prompt --application/set_environment
set define off verify off feedback off
whenever sqlerror exit sql.sqlcode rollback
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_220100 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2022.04.12'
,p_release=>'22.1.11'
,p_default_workspace_id=>2400405578329584
,p_default_application_id=>100
,p_default_id_offset=>0
,p_default_owner=>'FLOWS4APEX'
);
end;
/
 
prompt APPLICATION 100 - Flows for APEX
--
-- Application Export:
--   Application:     100
--   Name:            Flows for APEX
--   Date and Time:   18:52 Wednesday October 9, 2024
--   Exported By:     DENNIS.AMTHOR@HYAND.COM
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                     32
--       Items:                  195
--       Computations:            48
--       Validations:             15
--       Processes:               49
--       Regions:                146
--       Buttons:                 76
--       Dynamic Actions:         66
--     Shared Components:
--       Logic:
--         Items:                  4
--         Processes:              5
--         Computations:           1
--         Build Options:          1
--       Navigation:
--         Lists:                 16
--         Breadcrumbs:            1
--           Entries:             20
--       Security:
--         Authentication:         2
--         Authorization:          1
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                10
--           Region:              19
--           Label:                7
--           List:                13
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               3
--           Report:              12
--         LOVs:                  15
--         Shortcuts:              1
--         Plug-ins:               6
--       Globalization:
--         Messages:             830
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--       Install scripts:         17
--   Version:         22.1.11
--   Instance ID:     204275825414274
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_imp.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'FLOWS4APEX')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Flows for APEX')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'FLOWS4APEX')
,p_page_view_logging=>'YES'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt=>'15B753D68F7A5467E3DD14853F094D31FD5E3C9E459C8DD99A84BD40F714D421'
,p_bookmark_checksum_function=>'SH512'
,p_accept_old_checksums=>false
,p_compatibility_mode=>'21.2'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'dd.mm.yyyy'
,p_date_time_format=>'dd.mm.yyyy hh24:mi:ss'
,p_timestamp_format=>'dd.mm.yyyy hh24:mi:ss'
,p_timestamp_tz_format=>'dd.mm.yyyy hh24:mi:ss'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Application created from create application wizard 2020.01.31.'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_imp.id(12495636783173880401)
,p_application_tab_set=>1
,p_logo_type=>'IT'
,p_logo=>'#APP_IMAGES#app-100-logo.png'
,p_logo_text=>'Flows for APEX'
,p_app_builder_icon_name=>'flows-apex.svg'
,p_favicons=>'<link rel="icon" sizes="32x32" href="#APP_IMAGES#favicon.png">'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'24.1'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_referrer_policy=>'strict-origin-when-cross-origin'
,p_authorize_batch_job=>'N'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'Y'
,p_error_handling_function=>'flow_engine_app_api.apex_error_handling'
,p_tokenize_row_search=>'N'
,p_substitution_string_01=>'APP_NAME'
,p_substitution_value_01=>'Workflow'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241009185143'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>1124
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/p8_subflow_row_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2407587958394790)
,p_name=>'P8_SUBFLOW_ROW_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2407770381394791)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Complete'
,p_list_item_icon=>'fa-sign-out'
,p_list_text_01=>'complete-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2408186437394796)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Re-start'
,p_list_item_icon=>'fa-redo-arrow'
,p_list_text_01=>'restart-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2408507152394796)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2408929523394796)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Reserve'
,p_list_item_icon=>'fa-lock'
,p_list_text_01=>'reserve-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2409356015394796)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Release'
,p_list_item_icon=>'fa-unlock'
,p_list_text_01=>'release-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(73474529421861842)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(73474805704863264)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Reschedule'
,p_list_item_icon=>'fa-clock-o'
,p_list_text_01=>'reschedule-timer'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p10_instance_header_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2431522092873048)
,p_name=>'P10_INSTANCE_HEADER_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2432103661873123)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Start'
,p_list_item_icon=>'fa-play'
,p_list_text_01=>'bulk-start-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2432511726873124)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Reset'
,p_list_item_icon=>'fa-undo'
,p_list_text_01=>'bulk-reset-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2432979512873125)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Terminate'
,p_list_item_icon=>'fa-stop'
,p_list_text_01=>'bulk-terminate-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2433306262873126)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Delete'
,p_list_item_icon=>'fa-trash-o'
,p_list_text_01=>'bulk-delete-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p9_configuration_pages
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3291351989268379)
,p_name=>'P9_CONFIGURATION_PAGES'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3291576005268381)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Logging'
,p_list_item_link_target=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-indent'
,p_list_text_01=>'Language, level, user information, retention time, bpmn location, message flows'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3291958597268382)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Archiving'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-archive'
,p_list_text_01=>'Enable archiving, instance archive location'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3343699244810836)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Statistics'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:37:::'
,p_list_item_icon=>'fa-bar-chart'
,p_list_text_01=>'Summaries retention time'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3292372844268382)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Engine App'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-window'
,p_list_text_01=>'App Mode'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3292700268268382)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Engine'
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-hardware'
,p_list_text_01=>'Step key usage, default values'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3293122238268383)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Timers'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-clock-o'
,p_list_text_01=>'Enable timers, scheduler, max cycles'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3293918632269809)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'REST'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-gear'
,p_list_text_01=>'REST clients'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11497553424163179)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'License'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-file-signature'
,p_list_text_01=>'Edition, license information'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p8_subflow_header_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4409050172512221)
,p_name=>'P8_SUBFLOW_HEADER_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4409268569512242)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Complete'
,p_list_item_icon=>'fa-sign-out'
,p_list_text_01=>'bulk-complete-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4409653667512250)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Re-start'
,p_list_item_icon=>'fa-redo-arrow'
,p_list_text_01=>'bulk-restart-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4410048087512250)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4410440520512250)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Reserve'
,p_list_item_icon=>'fa-lock'
,p_list_text_01=>'bulk-reserve-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4410861620512250)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Release'
,p_list_item_icon=>'fa-unlock'
,p_list_text_01=>'bulk-release-step'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(73510569356145167)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(73510888958146465)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Reschedule'
,p_list_item_icon=>'fa-clock-o'
,p_list_text_01=>'bulk-reschedule-timer'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p8_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6338940478461643)
,p_name=>'P8_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46777067725540092)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Start'
,p_list_item_icon=>'fa-play'
,p_list_text_01=>'start-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46778310373540093)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Reset'
,p_list_item_icon=>'fa-undo'
,p_list_text_01=>'reset-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46779088416540093)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Terminate'
,p_list_item_icon=>'fa-stop'
,p_list_text_01=>'terminate-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46779754471540095)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Delete'
,p_list_item_icon=>'fa-trash-o'
,p_list_text_01=>'delete-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12017441161816637)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12016899984810068)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Show History'
,p_list_item_icon=>'fa-info-circle-o'
,p_list_text_01=>'flow-instance-audit'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2128118443982532)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Show Instance Timeline'
,p_list_item_link_target=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::P20_PRCS_ID,P20_PRCS_NAME:&P10_PRCS_ID.,&P10_PRCS_NAME.:'
,p_list_item_icon=>'fa-sequence'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3528025546791202)
,p_list_item_display_sequence=>67
,p_list_item_link_text=>'Instance Summary'
,p_list_item_link_target=>'javascript:apex.page.submit(''INSTANCE_SUMMARY'');'
,p_list_item_icon=>'fa-download'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12015017232750300)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Download (SVG)'
,p_list_item_icon=>'fa-image'
,p_list_text_01=>'download-as-svg'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12668784852437164)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12017214847815037)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Show Model Details'
,p_list_item_icon=>'fa-search'
,p_list_text_01=>'edit-flow-diagram'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6351240010504867)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14295838249027758)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Refresh'
,p_list_item_link_target=>'javascript:apex.region(''subflows'').refresh();apex.region(''flow-monitor'').refresh();apex.region(''flow-instance-detail'').refresh();apex.region(''process-variables'').refresh();apex.region(''message-subscriptions'').refresh();apex.region(''task-list'').refresh();'
,p_list_item_icon=>'fa-refresh'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3597012048710221)
,p_list_item_display_sequence=>115
,p_list_item_link_text=>'Step Timers'
,p_list_item_link_target=>'javascript:apex.page.submit(''STEP_TIMERS'');'
,p_list_item_icon=>'fa-clock-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12694916872990920)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46154425883410953)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Display Setting'
,p_list_item_icon=>'fa-gear'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46154708390415036)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'below report|side-by-side|new window'
,p_parent_list_item_id=>wwv_flow_imp.id(46154425883410953)
,p_list_text_01=>'choose-setting'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p8_variable_row_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7074608790273038)
,p_name=>'P8_VARIABLE_ROW_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7074803452273042)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit'
,p_list_item_icon=>'fa-pencil'
,p_list_text_01=>'update-process-variable'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7075252422273053)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Delete'
,p_list_item_icon=>'fa-trash-o'
,p_list_text_01=>'delete-process-variable'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p8_variable_header_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7390393853616382)
,p_name=>'P8_VARIABLE_HEADER_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7390805893616409)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete'
,p_list_item_icon=>'fa-trash-o'
,p_list_text_01=>'bulk-delete-process-variable'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p2_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7927640106409064)
,p_name=>'P2_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7928205045409069)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.:IMPORT_FLOW:&DEBUG.:6:P6_FORCE_OVERWRITE:N:'
,p_list_item_icon=>'fa-upload'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7928603491409069)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Refresh'
,p_list_item_link_target=>'javascript:apex.region(''parsed_drgm'').refresh();'
,p_list_item_icon=>'fa-refresh'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p7_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7935522414465879)
,p_name=>'P7_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7935795315465880)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:5:P5_DGRM_ID,P5_MULTI:&P7_DGRM_ID.,N:'
,p_list_item_icon=>'fa-download'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7936149892465882)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Delete'
,p_list_item_icon=>'fa-trash-o'
,p_list_text_01=>'delete-flow-diagram'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p10_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7946860874526805)
,p_name=>'P10_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7947003406526806)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Refresh'
,p_list_item_link_target=>'javascript:apex.region(''flow-instances'').refresh();apex.region(''flow-monitor'').refresh();'
,p_list_item_icon=>'fa-refresh'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6346082030489968)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(39805591040910001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Display Setting'
,p_list_item_icon=>'fa-gear'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(39805873547914084)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'below report|side-by-side|new window'
,p_parent_list_item_id=>wwv_flow_imp.id(39805591040910001)
,p_list_text_01=>'choose-setting'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p4_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7959288629726086)
,p_name=>'P4_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7959427446726087)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'View Source'
,p_list_item_link_target=>'javascript:apex.region( ''modeler'' ).getDiagram().then( ( xml ) => { apex.item( ''P4_DIAGRAM_XML'' ).setValue( xml );apex.theme.openRegion(''diagram_xml_region''); } );'
,p_list_item_icon=>'fa-cloud-download'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7959824792726090)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Download (SVG)'
,p_list_item_link_target=>'javascript:apex.region( ''modeler'' ).getSVG().then( ( svg ) => {'||wwv_flow.LF||
'     var svgBlob = new Blob([svg], {'||wwv_flow.LF||
'        type: ''image/svg+xml'''||wwv_flow.LF||
'    });'||wwv_flow.LF||
'    var fileName = $v(''P4_REGION_TITLE'');'||wwv_flow.LF||
''||wwv_flow.LF||
'    var downloadLink = document.createElement(''a'');'||wwv_flow.LF||
'    downloadLink.download = fileName;'||wwv_flow.LF||
'    downloadLink.href = window.URL.createObjectURL(svgBlob);'||wwv_flow.LF||
'    downloadLink.click();'||wwv_flow.LF||
'} );'
,p_list_item_icon=>'fa-image'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p2_row_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(39902352324857428)
,p_name=>'P2_ROW_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(39902501487857435)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Show Details'
,p_list_item_icon=>'fa-search'
,p_list_text_01=>'edit-flow-diagram'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(39902920078857437)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Add New Version'
,p_list_item_icon=>'fa-plus'
,p_list_text_01=>'new-flow-version'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(39903360633857437)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Copy'
,p_list_item_icon=>'fa-clone'
,p_list_text_01=>'copy-flow'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p2_header_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(40402255178815218)
,p_name=>'P2_HEADER_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40402870460815221)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Add New Version'
,p_list_item_icon=>'fa-plus'
,p_list_text_01=>'bulk-new-flow-version'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40403252293815221)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy'
,p_list_item_icon=>'fa-clone'
,p_list_text_01=>'bulk-copy-flow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40416697084414268)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40410074688263331)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'javascript:apex.submit(''EXPORT_FLOW'');'
,p_list_item_icon=>'fa-download'
,p_list_text_01=>'export-flow'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p10_instance_row_action_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(40423692118997018)
,p_name=>'P10_INSTANCE_ROW_ACTION_MENU'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40423835706997032)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'View'
,p_list_item_icon=>'fa-eye'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'view-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6315881052890668)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Show Details'
,p_list_item_icon=>'fa-search'
,p_list_text_01=>'open-flow-instance-details'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5664262065267010)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Show History'
,p_list_item_icon=>'fa-info-circle-o'
,p_list_text_01=>'flow-instance-audit'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5662379313207242)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Download (SVG)'
,p_list_item_icon=>'fa-image'
,p_list_text_01=>'download-as-svg'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6316146932894106)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40424429805997034)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Start'
,p_list_item_icon=>'fa-play'
,p_list_text_01=>'start-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40425672453997035)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Reset'
,p_list_item_icon=>'fa-undo'
,p_list_text_01=>'reset-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40426450496997035)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Terminate'
,p_list_item_icon=>'fa-stop'
,p_list_text_01=>'terminate-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40427116551997037)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Delete'
,p_list_item_icon=>'fa-trash-o'
,p_list_text_01=>'delete-flow-instance'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5664803242273579)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5664576928271979)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Show Model Details'
,p_list_item_icon=>'fa-search'
,p_list_text_01=>'edit-flow-diagram'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/desktop_navigation_bar
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12495499558192880054)
,p_name=>'Desktop Navigation Bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34597614443542059)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Getting started'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-info-square-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11904067894914484)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Configuration'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:9:::'
,p_list_item_icon=>'fa-gear'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5589254850825963)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'Theme'
,p_list_item_icon=>'fa-paint-brush'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6211519620415215)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Automatic'
,p_list_item_link_target=>'javascript:apex.submit((window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''RESET_DARK'' : ''RESET_LIGHT'');'
,p_list_item_icon=>'fa-adjust'
,p_parent_list_item_id=>wwv_flow_imp.id(5589254850825963)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5591024903839479)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Light Mode'
,p_list_item_link_target=>'javascript:apex.submit(''LIGHT_MODE'');'
,p_list_item_icon=>'fa-sun-o'
,p_parent_list_item_id=>wwv_flow_imp.id(5589254850825963)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5591767688841799)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dark Mode'
,p_list_item_link_target=>'javascript:apex.submit(''DARK_MODE'');'
,p_list_item_icon=>'fa-moon-o'
,p_parent_list_item_id=>wwv_flow_imp.id(5589254850825963)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12495487956468879842)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'&APP_USER.'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_text_02=>'has-username'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12495487403732879842)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(12495487956468879842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12495487001695879840)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Sign Out'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_item_icon=>'fa-sign-out'
,p_parent_list_item_id=>wwv_flow_imp.id(12495487956468879842)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/desktop_navigation_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12495635966008880385)
,p_name=>'Desktop Navigation Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34586567175532090)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-pie-chart'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9900462312126995)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Flow Management'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-sitemap-horizontal'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2,4,7'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12493524976121117621)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Flow Monitor'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:RP,RIR:::'
,p_list_item_icon=>'fa-sequence'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'10,8'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5597875143964021)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Simple Form Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-forms'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'50,51'
);
end;
/
prompt --application/shared_components/files/css_flows4apex_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20636F6C6F7220636C6173736573202A2F0D0A2E6666612D636F6C6F722D2D63726561746564207B0D0A20206261636B67726F756E642D636F6C6F723A202364396231336221696D706F7274616E743B0D0A2020636F6C6F723A2023343633343030';
wwv_flow_imp.g_varchar2_table(2) := '21696D706F7274616E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D636F6D706C65746564207B0D0A20206261636B67726F756E642D636F6C6F723A202338633965623021696D706F7274616E743B0D0A2020636F6C6F723A202332383361346421';
wwv_flow_imp.g_varchar2_table(3) := '696D706F7274616E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D72756E6E696E67207B0D0A20206261636B67726F756E642D636F6C6F723A202336616164343221696D706F7274616E743B0D0A2020636F6C6F723A20776869746521696D706F72';
wwv_flow_imp.g_varchar2_table(4) := '74616E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D7465726D696E61746564207B0D0A20206261636B67726F756E642D636F6C6F723A202364373661323721696D706F7274616E743B0D0A2020636F6C6F723A20776869746521696D706F727461';
wwv_flow_imp.g_varchar2_table(5) := '6E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D6572726F72207B0D0A20206261636B67726F756E642D636F6C6F723A202364323432336221696D706F7274616E743B0D0A2020636F6C6F723A20776869746521696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(6) := '0A0D0A2F2A20686561646572202A2F0D0A2E617065782D6C6F676F2D696D677B0D0A20206D61782D6865696768743A3235707821696D706F7274616E743B0D0A20206D617267696E2D72696768743A3570783B0D0A7D0D0A0D0A2F2A2070616765203220';
wwv_flow_imp.g_varchar2_table(7) := '2A2F0D0A0D0A746823616374696F6E5F636F6C2C2074645B686561646572732A3D22616374696F6E5F636F6C225D2C0D0A746823636865636B626F785F636F6C2C2074645B686561646572732A3D22636865636B626F785F636F6C225D7B0D0A20202077';
wwv_flow_imp.g_varchar2_table(8) := '696474683A20313070782021696D706F7274616E743B0D0A7D0D0A0D0A2E612D4952522D686561646572207B0D0A2020766572746963616C2D616C69676E3A20696E68657269743B0D0A7D0D0A0D0A2E612D4952522D6865616465724C696E6B7B0D0A20';
wwv_flow_imp.g_varchar2_table(9) := '2020636F6C6F723A20696E68657269742021696D706F7274616E743B0D0A7D0D0A0D0A2E6666612D6467726D2D62616467657B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206A7573';
wwv_flow_imp.g_varchar2_table(10) := '746966792D636F6E74656E743A2063656E7465723B0D0A7D0D0A0D0A2E7374617475735F69636F6E207B0D0A202070616464696E672D72696768743A203870783B0D0A7D0D0A0D0A2E6666612D6467726D2D6261646765202E66612C202E6666612D6467';
wwv_flow_imp.g_varchar2_table(11) := '726D2D62616467652D746578747B0D0A202070616464696E673A203470783B0D0A7D0D0A0D0A2F2A20706167652033202A2F0D0A0D0A23666C6F772D696E7374616E6365732D7065722D73746174757320617B0D0A2020636F6C6F723A20696E68657269';
wwv_flow_imp.g_varchar2_table(12) := '743B0D0A7D0D0A0D0A2F2A20706167652037202A2F0D0A0D0A236465707265636174655F62746E2C202372656C656173655F62746E2C2023617263686976655F62746E2C20236E65775F76657273696F6E5F62746E7B0D0A20206865696768743A203530';
wwv_flow_imp.g_varchar2_table(13) := '70783B0D0A7D0D0A0D0A2E696E7374616E63652D636F756E7465722D6C696E6B7B0D0A20202020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A74645B686561646572733D224E425F494E5354414E434553225D7B0D0A202020207061646469';
wwv_flow_imp.g_varchar2_table(14) := '6E672D6C6566743A203070783B0D0A7D0D0A0D0A2F2A2070616765203130202A2F0D0A0D0A2E666C6F772D72756E6E696E677B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C302C302C2E3035293B0D0A7D0D0A0D0A74682369';
wwv_flow_imp.g_varchar2_table(15) := '6E7374616E63655F616374696F6E5F636F6C2C2074645B686561646572732A3D22696E7374616E63655F616374696F6E5F636F6C225D2C0D0A746823696E7374616E63655F636865636B626F785F636F6C2C2074645B686561646572732A3D22696E7374';
wwv_flow_imp.g_varchar2_table(16) := '616E63655F636865636B626F785F636F6C225D2C0D0A746823737562666C6F775F616374696F6E5F636F6C2C2074645B686561646572732A3D22737562666C6F775F616374696F6E5F636F6C225D2C0D0A746823737562666C6F775F636865636B626F78';
wwv_flow_imp.g_varchar2_table(17) := '5F636F6C2C2074645B686561646572732A3D22737562666C6F775F636865636B626F785F636F6C225D2C0D0A746823766965772D70726F636573732C2074645B686561646572732A3D22766965772D70726F63657373225D7B0D0A202020207769647468';
wwv_flow_imp.g_varchar2_table(18) := '3A20313070782021696D706F7274616E743B0D0A7D0D0A0D0A2F2A20706167652031332A2F0D0A2E742D4156504C6973742D6C6162656C2E6666612D686967686C696768742D6C6162656C207B0D0A0970616464696E672D746F703A20333070783B0D0A';
wwv_flow_imp.g_varchar2_table(19) := '7D0D0A0D0A64697623617474726962757465732D6972207468234A534F4E207B0D0A09646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2F2A20626164676573202A2F0D0A0D0A2E707263735F7374617475735F62616467652C202E707263735F6576';
wwv_flow_imp.g_varchar2_table(20) := '656E745F62616467652C202E7362666C5F7374617475735F6261646765207B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020616C69676E2D6974656D733A2063656E746572';
wwv_flow_imp.g_varchar2_table(21) := '3B0D0A7D0D0A0D0A2F2A20726567696F6E20646973706C61792073656C6563746F7220666978202A2F0D0A0D0A2E612D546162732D70616E656C7B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2F2A2066697820666F7220696E6C696E';
wwv_flow_imp.g_varchar2_table(22) := '65206469616C6F6720696E2032312E31202A2F0D0A0D0A23696E7374616E63655F616374696F6E5F6469616C6F67206469762E742D466F726D2D6C6162656C436F6E7461696E65722E636F6C2D6E756C6C207B0D0A20206865696768743A20303B0D0A20';
wwv_flow_imp.g_varchar2_table(23) := '2070616464696E673A20303B0D0A7D0D0A0D0A2F2A20706167652038202A2F0D0A2E752D636F6C6F722D34342D616C6572742D746578747B0D0A2020636F6C6F723A202338633965623021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33';
wwv_flow_imp.g_varchar2_table(24) := '372D616C6572742D74657874207B0D0A2020636F6C6F723A202364396231336221696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D616C6572742D746578747B0D0A2020636F6C6F723A202336616164343221696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(25) := '0D0A7D0D0A2E752D636F6C6F722D33382D616C6572742D746578747B0D0A2020636F6C6F723A202364373661323721696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D616C6572742D746578747B0D0A2020636F6C6F723A2023643234';
wwv_flow_imp.g_varchar2_table(26) := '32336221696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34342D616C6572742D62677B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283134302C203135382C203137362C20302E31352921696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(27) := '7D0D0A2E752D636F6C6F722D33372D616C6572742D6267207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235322C203138362C20332C20302E31352921696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D616C';
wwv_flow_imp.g_varchar2_table(28) := '6572742D62677B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283130362C203137332C2036362C20302E31352921696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33382D616C6572742D62677B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(29) := '6F756E642D636F6C6F723A2072676261283231352C203130362C2033392C20302E31352921696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D616C6572742D62677B0D0A20206261636B67726F756E642D636F6C6F723A207267626128';
wwv_flow_imp.g_varchar2_table(30) := '3231302C2036372C2035392C20302E31352921696D706F7274616E743B0D0A7D0D0A0D0A2F2A2049522048656164657220776974682068656164657220616374696F6E2A2F0D0A23696E7374616E63655F616374696F6E5F636F6C202E612D4952522D68';
wwv_flow_imp.g_varchar2_table(31) := '65616465724C6162656C2C200D0A23616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C2C0D0A23737562666C6F775F616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C2C0D0A237661726961626C655F6163';
wwv_flow_imp.g_varchar2_table(32) := '74696F6E5F636F6C202E612D4952522D6865616465724C6162656C207B0D0A0970616464696E672D746F703A203870783B0D0A0970616464696E672D626F74746F6D3A203870783B0D0A7D0D0A0D0A2F2A2053796E74617820686967686C696768742066';
wwv_flow_imp.g_varchar2_table(33) := '697820666F72204952202A2F0D0A2E612D4952522D7461626C65207072655B636C6173732A3D226C616E67756167652D225D207B0D0A0970616464696E673A2031656D20302031656D20302021696D706F7274616E743B0D0A7D0D0A0D0A2F2A496E7374';
wwv_flow_imp.g_varchar2_table(34) := '616E63652074696D656C696E652A2F0D0A23696E7374616E63652D74696D656C696E652D6372202E742D54696D656C696E652D6974656D207B0D0A2020626F782D736861646F773A203020313070782031357078202D337078207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(35) := '20302C20302E31292C20302034707820367078202D347078207267626128302C20302C20302C20302E31293B0D0A20206D617267696E2D626F74746F6D3A203272656D3B0D0A2020626F726465723A2023646664666466346420302E35707820736F6C69';
wwv_flow_imp.g_varchar2_table(36) := '643B0D0A7D0D0A0D0A23696E7374616E63652D74696D656C696E652D6372202E742D54696D656C696E652D2D636F6D70616374202E742D54696D656C696E652D75736572207B0D0A2020766572746963616C2D616C69676E3A206D6964646C653B0D0A7D';
wwv_flow_imp.g_varchar2_table(37) := '0D0A';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(4505418457856239)
,p_file_name=>'css/flows4apex.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/js_flows4apex_js
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '66756E6374696F6E20696E69744170702829207B0D0A2020617065782E6A5175657279282077696E646F7720292E6F6E2820227468656D6534327265616479222C2066756E6374696F6E202829207B0D0A20202020617065782E7468656D6534322E7574';
wwv_flow_imp.g_varchar2_table(2) := '696C2E636F6E666967415045584D73677328207B0D0A2020202020206175746F4469736D6973733A20747275652C0D0A2020202020206475726174696F6E3A20353030302C0D0A202020207D20293B0D0A20207D20293B0D0A7D0D0A0D0A66756E637469';
wwv_flow_imp.g_varchar2_table(3) := '6F6E20616464436C6173736573546F506172656E7473287053656C6563746F722C2070506172656E7453656C6563746F722C2070436C617373657329207B0D0A2020617065780D0A202020202E6A517565727928207053656C6563746F7220290D0A2020';
wwv_flow_imp.g_varchar2_table(4) := '20202E706172656E7473282070506172656E7453656C6563746F7220290D0A202020202E616464436C617373282070436C617373657320293B0D0A7D0D0A0D0A66756E6374696F6E206368696C6472656E417474726962757465546F417272617928636F';
wwv_flow_imp.g_varchar2_table(5) := '6E7461696E65722C206368696C6472656E2C20617474726962757465297B0D0A202072657475726E20617065780D0A20202020202020202020202E6A517565727928636F6E7461696E6572290D0A20202020202020202020202E66696E64286368696C64';
wwv_flow_imp.g_varchar2_table(6) := '72656E290D0A20202020202020202020202E6D6170282066756E6374696F6E2028206974656D2029207B0D0A2020202020202020202020202072657475726E20617065782E6A517565727928207468697320292E61747472282061747472696275746520';
wwv_flow_imp.g_varchar2_table(7) := '293B0D0A20202020202020202020207D290D0A20202020202020202020202E746F417272617928293B0D0A7D0D0A0D0A66756E6374696F6E20676574666C6F77496E7374616E63654461746128616374696F6E2C20656C656D656E74297B0D0A20206C65';
wwv_flow_imp.g_varchar2_table(8) := '7420656C203D20656C656D656E743B0D0A20206966202820656C2E74797065203D3D3D20756E646566696E6564207C7C20656C2E7479706520213D3D2022627574746F6E2229207B0D0A20202020656C203D20617065782E6A517565727928656C656D65';
wwv_flow_imp.g_varchar2_table(9) := '6E74292E636C6F736573742822627574746F6E22293B0D0A20207D0D0A202072657475726E207B0D0A2020202022783031223A20616374696F6E2C0D0A2020202022783032223A20617065782E6A51756572792820656C20292E61747472282264617461';
wwv_flow_imp.g_varchar2_table(10) := '2D7072637322290D0A20207D3B0D0A7D0D0A0D0A66756E6374696F6E2067657442756C6B466C6F77496E7374616E63654461746128616374696F6E297B0D0A202072657475726E207B0D0A2020202022783031223A20616374696F6E2C0D0A2020202022';
wwv_flow_imp.g_varchar2_table(11) := '663031223A206368696C6472656E417474726962757465546F417272617928202223666C6F772D696E7374616E636573202E612D4952522D7461626C65436F6E7461696E6572222C2027696E7075745B6E616D653D22663031225D3A636865636B656427';
wwv_flow_imp.g_varchar2_table(12) := '2C2022646174612D707263732220290D0A20207D3B0D0A7D0D0A0D0A66756E6374696F6E206765744D6573736167654461746128616374696F6E2C20656C656D656E74297B0D0A20206C657420656C203D20656C656D656E743B0D0A2020696620282065';
wwv_flow_imp.g_varchar2_table(13) := '6C2E74797065203D3D3D20756E646566696E6564207C7C20656C2E7479706520213D3D2022627574746F6E2229207B0D0A20202020656C203D20617065782E6A517565727928656C656D656E74292E636C6F736573742822627574746F6E22293B0D0A20';
wwv_flow_imp.g_varchar2_table(14) := '207D0D0A202072657475726E207B0D0A2020202022783031223A20616374696F6E2C0D0A2020202022783032223A20617065782E6A51756572792820656C20292E617474722822646174612D6D65737361676522292C0D0A2020202022783033223A2061';
wwv_flow_imp.g_varchar2_table(15) := '7065782E6A51756572792820656C20292E617474722822646174612D6B657922292C0D0A2020202022783034223A20617065782E6A51756572792820656C20292E617474722822646174612D76616C756522290D0A20207D3B0D0A7D0D0A0D0A66756E63';
wwv_flow_imp.g_varchar2_table(16) := '74696F6E20676574537562666C6F774461746128616374696F6E2C20656C656D656E74297B0D0A20206C657420656C203D20656C656D656E743B0D0A20206966202820656C2E74797065203D3D3D20756E646566696E6564207C7C20656C2E7479706520';
wwv_flow_imp.g_varchar2_table(17) := '213D3D2022627574746F6E2229207B0D0A20202020656C203D20617065782E6A517565727928656C656D656E74292E636C6F736573742822627574746F6E22293B0D0A20207D0D0A202072657475726E207B0D0A2020202022783031223A20616374696F';
wwv_flow_imp.g_varchar2_table(18) := '6E2C0D0A2020202022783032223A20617065782E6A51756572792820656C20292E617474722822646174612D7072637322292C0D0A2020202022783033223A20617065782E6A51756572792820656C20292E617474722822646174612D7362666C22292C';
wwv_flow_imp.g_varchar2_table(19) := '0D0A2020202022783034223A20617065782E6A51756572792820656C20292E617474722822646174612D6B657922290D0A20207D3B0D0A7D0D0A0D0A66756E6374696F6E2067657442756C6B537562666C6F774461746128616374696F6E297B0D0A2020';
wwv_flow_imp.g_varchar2_table(20) := '72657475726E207B0D0A2020202022783031223A20616374696F6E2C0D0A2020202022663031223A206368696C6472656E417474726962757465546F417272617928202223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E657222';
wwv_flow_imp.g_varchar2_table(21) := '2C2027696E7075745B6E616D653D22663032225D3A636865636B6564272C2022646174612D707263732220292C0D0A2020202022663032223A206368696C6472656E417474726962757465546F417272617928202223737562666C6F7773202E612D4952';
wwv_flow_imp.g_varchar2_table(22) := '522D7461626C65436F6E7461696E6572222C2027696E7075745B6E616D653D22663032225D3A636865636B6564272C202276616C75652220292C0D0A2020202022663033223A206368696C6472656E417474726962757465546F41727261792820222373';
wwv_flow_imp.g_varchar2_table(23) := '7562666C6F7773202E612D4952522D7461626C65436F6E7461696E6572222C2027696E7075745B6E616D653D22663032225D3A636865636B6564272C2022646174612D6B65792220290D0A20207D3B0D0A7D0D0A0D0A66756E6374696F6E206F70656E4D';
wwv_flow_imp.g_varchar2_table(24) := '6F64616C436F6E6669726D57697468436F6D6D656E742820616374696F6E2C20656C656D656E742C20636F6E6669726D4D6573736167654B65792C207469746C654B657920297B0D0A20206C657420656C203D20656C656D656E743B0D0A202069662028';
wwv_flow_imp.g_varchar2_table(25) := '20656C2E74797065203D3D3D20756E646566696E6564207C7C20656C2E7479706520213D3D2022627574746F6E2229207B0D0A20202020656C203D20617065782E6A517565727928656C656D656E74292E636C6F736573742822627574746F6E22293B0D';
wwv_flow_imp.g_varchar2_table(26) := '0A20207D0D0A202076617220706167654964203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293B0D0A2020617065782E6974656D2820225022202B20706167654964202B20225F434F4D4D454E542220292E';
wwv_flow_imp.g_varchar2_table(27) := '73657456616C75652820222220293B0D0A2020617065782E6974656D2820225022202B20706167654964202B20225F434F4E4649524D5F544558542220292E73657456616C75652820617065782E6C616E672E6765744D6573736167652820636F6E6669';
wwv_flow_imp.g_varchar2_table(28) := '726D4D6573736167654B6579202920293B0D0A2020617065782E6A517565727928202223636F6E6669726D2D62746E2220292E61747472282022646174612D616374696F6E222C20616374696F6E20293B0D0A2020617065780D0A202020202E6A517565';
wwv_flow_imp.g_varchar2_table(29) := '727928202223636F6E6669726D2D62746E2220290D0A202020202E61747472282022646174612D70726373222C20617065782E6A51756572792820656C20292E61747472282022646174612D7072637322202920293B0D0A2020617065780D0A20202020';
wwv_flow_imp.g_varchar2_table(30) := '2E6A517565727928202223636F6E6669726D2D62746E2220290D0A202020202E61747472282022646174612D7362666C222C20617065782E6A51756572792820656C20292E61747472282022646174612D7362666C22202920293B0D0A2020617065780D';
wwv_flow_imp.g_varchar2_table(31) := '0A202020202E6A517565727928202223636F6E6669726D2D62746E2220290D0A202020202E61747472282022646174612D6B6579222C20617065782E6A51756572792820656C20292E61747472282022646174612D6B657922202920293B0D0A20206170';
wwv_flow_imp.g_varchar2_table(32) := '65780D0A202020202E6A517565727928202223636F6E6669726D2D62746E2220290D0A202020202E61747472282022646174612D6E616D65222C20617065782E6A51756572792820656C20292E61747472282022646174612D6E616D6522202920293B0D';
wwv_flow_imp.g_varchar2_table(33) := '0A2020617065782E7468656D652E6F70656E526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A2020617065782E7574696C2E676574546F704170657828292E6A517565727928222E6634612D64796E616D6963';
wwv_flow_imp.g_varchar2_table(34) := '2D7469746C6522292E636C6F7365737428222E75692D6469616C6F672D636F6E74656E7422292E6469616C6F6728276F7074696F6E272C20277469746C65272C20617065782E6C616E672E6765744D65737361676528207469746C654B65792029293B0D';
wwv_flow_imp.g_varchar2_table(35) := '0A7D0D0A0D0A66756E6374696F6E20676574436F6E6669726D436F6D6D656E7428297B0D0A202076617220706167654964203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293B0D0A202072657475726E2061';
wwv_flow_imp.g_varchar2_table(36) := '7065782E6974656D2820225022202B20706167654964202B20225F434F4D4D454E542220292E67657456616C756528293B0D0A7D0D0A0D0A66756E6374696F6E2073656E64546F5365727665722864617461546F53656E642C206F7074696F6E73203D20';
wwv_flow_imp.g_varchar2_table(37) := '7B7D297B0D0A202076617220726573756C74203D20617065782E7365727665722E70726F63657373282022414A41585F48414E444C4552222C2064617461546F53656E64293B0D0A2020726573756C740D0A202020202E646F6E65282066756E6374696F';
wwv_flow_imp.g_varchar2_table(38) := '6E202820646174612029207B0D0A202020202020696620282021646174612E737563636573732029207B0D0A202020202020202069662028646174612E6D65737361676520213D3D20756E646566696E656420262620646174612E6D6573736167652021';
wwv_flow_imp.g_varchar2_table(39) := '3D3D206E756C6C29207B0D0A20202020202020202020617065782E6D6573736167652E636C6561724572726F727328293B0D0A0D0A20202020202020202020617065782E6D6573736167652E73686F774572726F7273285B0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(40) := '202020207B0D0A202020202020202020202020202020202020747970653A20202020202020226572726F72222C0D0A2020202020202020202020202020202020206C6F636174696F6E3A2020202270616765222C0D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(41) := '202020206D6573736167653A20202020646174612E6D6573736167652C0D0A202020202020202020202020202020202020756E736166653A202020202066616C73650D0A20202020202020202020202020207D0D0A202020202020202020205D293B0D0A';
wwv_flow_imp.g_varchar2_table(42) := '20202020202020207D20656C7365207B0D0A20202020202020202020617065782E64656275672E6572726F72282022536F6D657468696E672077656E742077726F6E672E2E2E2220293B0D0A20202020202020207D0D0A2020202020207D20656C736520';
wwv_flow_imp.g_varchar2_table(43) := '7B0D0A202020202020202069662028206F7074696F6E732E6D6573736167654B657920213D3D20756E646566696E656420297B0D0A20202020202020202020617065782E6D6573736167652E73686F7750616765537563636573732820617065782E6C61';
wwv_flow_imp.g_varchar2_table(44) := '6E672E6765744D65737361676528206F7074696F6E732E6D6573736167654B6579202920293B0D0A20202020202020207D0D0A2020202020202020696620286F7074696F6E732E4974656D73546F53657420213D3D20756E646566696E65642026262061';
wwv_flow_imp.g_varchar2_table(45) := '7065782E6A51756572792E6973456D7074794F626A656374286F7074696F6E732E4974656D73546F53657429203D3D3D2066616C736520297B0D0A202020202020202020204F626A6563742E6B657973286F7074696F6E732E4974656D73546F53657429';
wwv_flow_imp.g_varchar2_table(46) := '2E666F72456163682866756E6374696F6E286974656D4E616D6529207B0D0A202020202020202020202020617065782E6974656D286974656D4E616D65292E73657456616C7565286F7074696F6E732E4974656D73546F5365745B6974656D4E616D655D';
wwv_flow_imp.g_varchar2_table(47) := '293B0D0A202020202020202020207D293B0D0A20202020202020207D0D0A202020202020202069662028206F7074696F6E732E72656672657368526567696F6E20213D3D20756E646566696E6564202626206F7074696F6E732E72656672657368526567';
wwv_flow_imp.g_varchar2_table(48) := '696F6E2E6C656E677468203E20302029207B0D0A202020202020202020206F7074696F6E732E72656672657368526567696F6E2E666F72456163682866756E6374696F6E286E616D6529207B0D0A20202020202020202020202069662028617065782E72';
wwv_flow_imp.g_varchar2_table(49) := '6567696F6E286E616D65292E74797065203D3D3D2022496E7465726163746976655265706F72742229207B0D0A20202020202020202020202020207661722063757272656E74526F777350657250616765203D20617065782E6A51756572792822232220';
wwv_flow_imp.g_varchar2_table(50) := '2B206E616D65202B20225F697222292E6461746128292E61706578496E7465726163746976655265706F72742E6F7074696F6E732E63757272656E74526F7773506572506167653B0D0A20202020202020202020202020207661722063757272656E7450';
wwv_flow_imp.g_varchar2_table(51) := '616765203D20617065782E6A517565727928222322202B206E616D65202B22202E612D4952522D706167696E6174696F6E2D6C6162656C22292E7465787428292E73706C697428272D27295B305D2E7472696D28293B0D0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(52) := '2020617065782E6A517565727928222322202B206E616D65202B20225F697222292E6461746128292E61706578496E7465726163746976655265706F72742E5F706167696E61746528227067525F6D696E5F726F773D22202B2063757272656E74506167';
wwv_flow_imp.g_varchar2_table(53) := '65202B20226D61785F726F77733D22202B2063757272656E74526F777350657250616765202B2022726F77735F666574636865643D22202B2063757272656E74526F77735065725061676520293B0D0A2020202020202020202020207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(54) := '0D0A2020202020202020202020202020617065782E726567696F6E286E616D65292E7265667265736828293B0D0A2020202020202020202020207D0D0A202020202020202020207D290D0A20202020202020207D0D0A2020202020202020696620282064';
wwv_flow_imp.g_varchar2_table(55) := '6174612E75726C20213D3D20756E646566696E6564202626206F7074696F6E732E726564697265637420213D3D2066616C736520297B0D0A20202020202020202020617065782E6E617669676174696F6E2E72656469726563742820646174612E75726C';
wwv_flow_imp.g_varchar2_table(56) := '20293B0D0A20202020202020207D0D0A2020202020202020696620282028206F7074696F6E732E72656C6F61645061676520213D3D20756E646566696E6564202626206F7074696F6E732E72656C6F6164506167652029207C7C202820646174612E7265';
wwv_flow_imp.g_varchar2_table(57) := '6C6F61645061676520213D3D20756E646566696E656420262620646174612E72656C6F61645061676520292029207B0D0A2020202020202020202077696E646F772E6C6F636174696F6E2E72656C6F616428293B0D0A20202020202020207D0D0A202020';
wwv_flow_imp.g_varchar2_table(58) := '2020207D0D0A202020207D290D0A202020202E6661696C282066756E6374696F6E2028206A715848522C20746578745374617475732C206572726F725468726F776E2029207B0D0A202020202020617065782E64656275672E6572726F72282022546F74';
wwv_flow_imp.g_varchar2_table(59) := '616C206661696C2E2E2E222C206A715848522C20746578745374617475732C206572726F725468726F776E20293B0D0A202020207D20293B200D0A7D0D0A0D0A66756E6374696F6E20646F776E6C6F61644173535647286576656E74297B0D0A20207661';
wwv_flow_imp.g_varchar2_table(60) := '7220726567696F6E4964203D2024286576656E742E746172676574292E706172656E747328272E742D526567696F6E27292E617474722827696427293B0D0A2020617065780D0A202020202E726567696F6E2820726567696F6E496420290D0A20202020';
wwv_flow_imp.g_varchar2_table(61) := '2E67657453564728290D0A202020202E7468656E282028207376672029203D3E207B0D0A20202020202076617220737667426C6F62203D206E657720426C6F6228205B7376675D2C207B0D0A2020202020202020747970653A2022696D6167652F737667';
wwv_flow_imp.g_varchar2_table(62) := '2B786D6C222C0D0A2020202020207D20293B0D0A2020202020207661722066696C654E616D65203D20446174652E6E6F7728293B0D0A0D0A20202020202076617220646F776E6C6F61644C696E6B203D20646F63756D656E742E637265617465456C656D';
wwv_flow_imp.g_varchar2_table(63) := '656E74282022612220293B0D0A202020202020646F776E6C6F61644C696E6B2E646F776E6C6F6164203D2066696C654E616D653B0D0A202020202020646F776E6C6F61644C696E6B2E68726566203D2077696E646F772E55524C2E6372656174654F626A';
wwv_flow_imp.g_varchar2_table(64) := '65637455524C2820737667426C6F6220293B0D0A202020202020646F776E6C6F61644C696E6B2E636C69636B28293B0D0A202020207D20293B0D0A7D0D0A0D0A66756E6374696F6E207374617274466C6F77496E7374616E63652820616374696F6E2C20';
wwv_flow_imp.g_varchar2_table(65) := '656C656D656E742029207B0D0A20207661722064617461203D20676574666C6F77496E7374616E63654461746128616374696F6E2C20656C656D656E74293B0D0A2020766172206F7074696F6E73203D207B7D3B0D0A20206F7074696F6E732E6D657373';
wwv_flow_imp.g_varchar2_table(66) := '6167654B6579203D20224150505F494E5354414E43455F53544152544544223B0D0A20206F7074696F6E732E72656C6F616450616765203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822';
wwv_flow_imp.g_varchar2_table(67) := '203F2074727565203A2066616C73653B0D0A20206F7074696F6E732E72656672657368526567696F6E203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F205B5D203A205B22666C6F';
wwv_flow_imp.g_varchar2_table(68) := '772D696E7374616E636573222C2022666C6F772D6D6F6E69746F72225D3B0D0A20206F7074696F6E732E4974656D73546F536574203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F';
wwv_flow_imp.g_varchar2_table(69) := '207B7D203A207B225031305F505243535F4944223A20646174612E7830322C20225031305F505243535F4E414D45223A20617065782E6A51756572792820656C656D656E7420292E617474722822646174612D6E616D652229207D3B0D0A202073656E64';
wwv_flow_imp.g_varchar2_table(70) := '546F53657276657228646174612C206F7074696F6E73293B0D0A7D0D0A0D0A66756E6374696F6E2062756C6B5374617274466C6F77496E7374616E63652820616374696F6E2029207B0D0A20207661722064617461203D2067657442756C6B466C6F7749';
wwv_flow_imp.g_varchar2_table(71) := '6E7374616E63654461746128616374696F6E293B0D0A2020766172206F7074696F6E73203D207B7D3B0D0A20206F7074696F6E732E6D6573736167654B6579203D20224150505F494E5354414E43455F53544152544544223B0D0A20206F7074696F6E73';
wwv_flow_imp.g_varchar2_table(72) := '2E72656672657368526567696F6E203D205B22666C6F772D696E7374616E636573222C2022666C6F772D6D6F6E69746F72225D3B0D0A202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A7D0D0A0D0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(73) := '7265736574466C6F77496E7374616E636528616374696F6E2C20656C656D656E74297B0D0A20206966202820617065782E6A517565727928202223696E7374616E63655F616374696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E';
wwv_flow_imp.g_varchar2_table(74) := '2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A202020207661722064617461203D20676574666C6F77496E7374616E636544617461';
wwv_flow_imp.g_varchar2_table(75) := '28616374696F6E2C20656C656D656E74293B0D0A20202020646174612E783033203D20676574436F6E6669726D436F6D6D656E7428293B0D0A0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E6D6573736167';
wwv_flow_imp.g_varchar2_table(76) := '654B6579203D20224150505F494E5354414E43455F5245534554223B0D0A202020206F7074696F6E732E72656C6F616450616765203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F';
wwv_flow_imp.g_varchar2_table(77) := '2074727565203A2066616C73653B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F205B5D203A205B22666C6F';
wwv_flow_imp.g_varchar2_table(78) := '772D696E7374616E636573222C2022666C6F772D6D6F6E69746F72225D3B0D0A202020206F7074696F6E732E4974656D73546F536574203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822';
wwv_flow_imp.g_varchar2_table(79) := '203F207B7D203A207B225031305F505243535F4944223A20646174612E7830322C20225031305F505243535F4E414D45223A20617065782E6A51756572792820656C656D656E7420292E617474722822646174612D6E616D652229207D3B0D0A20202020';
wwv_flow_imp.g_varchar2_table(80) := '73656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E742820616374696F6E2C20656C656D656E742C20224150505F434F4E';
wwv_flow_imp.g_varchar2_table(81) := '4649524D5F52455345545F494E5354414E4345222C20224150505F52455345545F494E5354414E43452220293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2062756C6B5265736574466C6F77496E7374616E636528616374696F6E2C20656C656D';
wwv_flow_imp.g_varchar2_table(82) := '656E74297B0D0A20206966202820617065782E6A517565727928202223696E7374616E63655F616374696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F736552';
wwv_flow_imp.g_varchar2_table(83) := '6567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A202020207661722064617461203D2067657442756C6B466C6F77496E7374616E63654461746128616374696F6E293B0D0A20202020646174612E783032203D20';
wwv_flow_imp.g_varchar2_table(84) := '676574436F6E6669726D436F6D6D656E7428293B0D0A0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E6D6573736167654B6579203D20224150505F494E5354414E43455F5245534554223B0D0A202020206F';
wwv_flow_imp.g_varchar2_table(85) := '7074696F6E732E72656672657368526567696F6E203D205B22666C6F772D696E7374616E636573222C2022666C6F772D6D6F6E69746F72225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C';
wwv_flow_imp.g_varchar2_table(86) := '7365207B0D0A202020206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E742820616374696F6E2C20656C656D656E742C20224150505F434F4E4649524D5F52455345545F494E5354414E4345222C20224150505F52455345545F494E53';
wwv_flow_imp.g_varchar2_table(87) := '54414E43452220293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E207465726D696E617465466C6F77496E7374616E636528616374696F6E2C20656C656D656E7429207B0D0A20206966202820617065782E6A517565727928202223696E7374616E';
wwv_flow_imp.g_varchar2_table(88) := '63655F616374696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D';
wwv_flow_imp.g_varchar2_table(89) := '0A202020207661722064617461203D20676574666C6F77496E7374616E63654461746128616374696F6E2C20656C656D656E74293B0D0A20202020646174612E783033203D20676574436F6E6669726D436F6D6D656E7428293B0D0A0D0A202020207661';
wwv_flow_imp.g_varchar2_table(90) := '72206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E6D6573736167654B6579203D20224150505F494E5354414E43455F5445524D494E41544544223B0D0A202020206F7074696F6E732E72656C6F616450616765203D20617065782E';
wwv_flow_imp.g_varchar2_table(91) := '6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F2074727565203A2066616C73653B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D20617065782E6974656D282270466C6F77';
wwv_flow_imp.g_varchar2_table(92) := '53746570496422292E67657456616C75652829203D3D3D20223822203F205B5D203A205B22666C6F772D696E7374616E636573222C2022666C6F772D6D6F6E69746F72225D3B0D0A202020206F7074696F6E732E4974656D73546F536574203D20617065';
wwv_flow_imp.g_varchar2_table(93) := '782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F207B7D203A207B225031305F505243535F4944223A20646174612E7830322C20225031305F505243535F4E414D45223A20617065782E6A517565';
wwv_flow_imp.g_varchar2_table(94) := '72792820656C656D656E7420292E617474722822646174612D6E616D652229207D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E4D6F64616C436F6E6669';
wwv_flow_imp.g_varchar2_table(95) := '726D57697468436F6D6D656E742820616374696F6E2C20656C656D656E742C20224150505F434F4E4649524D5F5445524D494E4154455F494E5354414E4345222C20224150505F5445524D494E4154455F494E5354414E43452220293B0D0A20207D0D0A';
wwv_flow_imp.g_varchar2_table(96) := '7D0D0A0D0A66756E6374696F6E2062756C6B5465726D696E617465466C6F77496E7374616E636528616374696F6E2C20656C656D656E7429207B0D0A20206966202820617065782E6A517565727928202223696E7374616E63655F616374696F6E5F6469';
wwv_flow_imp.g_varchar2_table(97) := '616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A2020202076617220646174';
wwv_flow_imp.g_varchar2_table(98) := '61203D2067657442756C6B466C6F77496E7374616E63654461746128616374696F6E293B0D0A20202020646174612E783032203D20676574436F6E6669726D436F6D6D656E7428293B0D0A0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A';
wwv_flow_imp.g_varchar2_table(99) := '202020206F7074696F6E732E6D6573736167654B6579203D20224150505F494E5354414E43455F5445524D494E41544544223B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D205B22666C6F772D696E7374616E636573222C20';
wwv_flow_imp.g_varchar2_table(100) := '22666C6F772D6D6F6E69746F72225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E742820616374';
wwv_flow_imp.g_varchar2_table(101) := '696F6E2C20656C656D656E742C20224150505F434F4E4649524D5F5445524D494E4154455F494E5354414E4345222C20224150505F5445524D494E4154455F494E5354414E43452220293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2064656C65';
wwv_flow_imp.g_varchar2_table(102) := '7465466C6F77496E7374616E63652820616374696F6E2C20656C656D656E7420297B200D0A20206966202820617065782E6A517565727928202223696E7374616E63655F616374696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E';
wwv_flow_imp.g_varchar2_table(103) := '2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A202020207661722064617461203D20676574666C6F77496E7374616E636544617461';
wwv_flow_imp.g_varchar2_table(104) := '28616374696F6E2C20656C656D656E74293B0D0A20202020646174612E783033203D20676574436F6E6669726D436F6D6D656E7428293B0D0A0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E6D6573736167';
wwv_flow_imp.g_varchar2_table(105) := '654B6579203D20224150505F494E5354414E43455F44454C45544544223B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20';
wwv_flow_imp.g_varchar2_table(106) := '22313022203F205B22666C6F772D696E7374616E636573222C2022666C6F772D6D6F6E69746F72225D203A205B5D3B0D0A202020206F7074696F6E732E4974656D73546F536574203D20617065782E6974656D282270466C6F7753746570496422292E67';
wwv_flow_imp.g_varchar2_table(107) := '657456616C75652829203D3D3D20223822203F207B7D203A207B225031305F505243535F4944223A2022222C20225031305F505243535F4E414D45223A2022227D3B0D0A202020206F7074696F6E732E7265646972656374203D20617065782E6974656D';
wwv_flow_imp.g_varchar2_table(108) := '282270466C6F7753746570496422292E67657456616C75652829203D3D3D2022313022203F2066616C7365203A20747275653B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A20';
wwv_flow_imp.g_varchar2_table(109) := '2020206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E742820616374696F6E2C20656C656D656E742C20224150505F434F4E4649524D5F44454C4554455F494E5354414E4345222C20224150505F44454C4554455F494E5354414E4345';
wwv_flow_imp.g_varchar2_table(110) := '2220293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2062756C6B44656C657465466C6F77496E7374616E63652820616374696F6E2C20656C656D656E7420297B200D0A20206966202820617065782E6A517565727928202223696E7374616E6365';
wwv_flow_imp.g_varchar2_table(111) := '5F616374696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A20';
wwv_flow_imp.g_varchar2_table(112) := '2020207661722064617461203D2067657442756C6B466C6F77496E7374616E63654461746128616374696F6E293B0D0A20202020646174612E783032203D20676574436F6E6669726D436F6D6D656E7428293B0D0A0D0A20202020766172206F7074696F';
wwv_flow_imp.g_varchar2_table(113) := '6E73203D207B7D3B0D0A202020206F7074696F6E732E6D6573736167654B6579203D20224150505F494E5354414E43455F44454C45544544223B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D205B22666C6F772D696E737461';
wwv_flow_imp.g_varchar2_table(114) := '6E636573222C2022666C6F772D6D6F6E69746F72225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E4D6F64616C436F6E6669726D57697468436F6D6D65';
wwv_flow_imp.g_varchar2_table(115) := '6E742820616374696F6E2C20656C656D656E742C20224150505F434F4E4649524D5F44454C4554455F494E5354414E4345222C20224150505F44454C4554455F494E5354414E43452220293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E20726564';
wwv_flow_imp.g_varchar2_table(116) := '6972656374546F466C6F77496E7374616E636541756469742820616374696F6E2C20656C656D656E7420297B0D0A20207661722064617461203D20676574666C6F77496E7374616E63654461746128616374696F6E2C20656C656D656E74293B0D0A2020';
wwv_flow_imp.g_varchar2_table(117) := '646174612E783033203D20617065782E6A51756572792820656C656D656E7420292E617474722822646174612D6E616D6522293B0D0A20206966202820617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D';
wwv_flow_imp.g_varchar2_table(118) := '20223130222029207B0D0A20202020617065782E6974656D28225031305F505243535F494422292E73657456616C756528646174612E783032293B0D0A20202020617065782E6974656D28225031305F505243535F4E414D4522292E73657456616C7565';
wwv_flow_imp.g_varchar2_table(119) := '2820646174612E78303320293B0D0A20202020646174612E706167654974656D73203D205B225031305F505243535F4944222C20225031305F505243535F4E414D45225D3B0D0A20207D0D0A2020766172206F7074696F6E73203D207B7D3B0D0A20206F';
wwv_flow_imp.g_varchar2_table(120) := '7074696F6E732E72656672657368526567696F6E203D20617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829203D3D3D20223822203F205B5D203A205B22666C6F772D696E7374616E636573222C2022666C6F772D6D';
wwv_flow_imp.g_varchar2_table(121) := '6F6E69746F72225D3B0D0A202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A7D0D0A0D0A66756E6374696F6E207265646972656374546F466C6F77496E7374616E636544657461696C2820616374696F6E2C20656C656D65';
wwv_flow_imp.g_varchar2_table(122) := '6E7420297B0D0A20207661722064617461203D20676574666C6F77496E7374616E63654461746128616374696F6E2C20656C656D656E74293B0D0A2020617065782E6974656D28225031305F505243535F494422292E73657456616C756528646174612E';
wwv_flow_imp.g_varchar2_table(123) := '783032293B0D0A2020617065782E6974656D28225031305F505243535F4E414D4522292E73657456616C75652820617065782E6A51756572792820656C656D656E7420292E617474722822646174612D6E616D65222920293B0D0A2020646174612E7061';
wwv_flow_imp.g_varchar2_table(124) := '67654974656D73203D205B225031305F505243535F4944222C20225031305F505243535F4E414D45225D3B0D0A202073656E64546F5365727665722864617461293B0D0A7D0D0A0D0A66756E6374696F6E207265646972656374546F466C6F7744696167';
wwv_flow_imp.g_varchar2_table(125) := '72616D2820616374696F6E2C20656C656D656E7420297B0D0A20207661722064617461203D20676574666C6F77496E7374616E63654461746128616374696F6E2C20656C656D656E74293B0D0A2020646174612E783032203D20617065782E6A51756572';
wwv_flow_imp.g_varchar2_table(126) := '792820656C656D656E7420292E617474722822646174612D6467726D22293B0D0A202073656E64546F5365727665722864617461293B0D0A7D0D0A0D0A66756E6374696F6E20696E697456696577657228207072637349642C20707263734E616D652C20';
wwv_flow_imp.g_varchar2_table(127) := '646973706C617953657474696E672029207B0D0A202069662028707263734E616D6520213D3D202222290D0A202020202020617065782E6A517565727928202223666C6F772D6D6F6E69746F725F68656164696E672220292E746578742820617065782E';
wwv_flow_imp.g_varchar2_table(128) := '6C616E672E666F726D61744D65737361676528224150505F5649455745525F5449544C455F50524F434553535F53454C4543544544222C20707263734E616D652920293B0D0A20202020656C73650D0A20202020202020617065782E6A51756572792820';
wwv_flow_imp.g_varchar2_table(129) := '2223666C6F772D6D6F6E69746F725F68656164696E672220292E746578742820617065782E6C616E672E6765744D65737361676528224150505F5649455745525F5449544C455F4E4F5F50524F43455353222920293B0D0A0D0A20206966202820707263';
wwv_flow_imp.g_varchar2_table(130) := '73496420213D3D20222220262620646973706C617953657474696E67203D3D3D202277696E646F772229207B0D0A202020207265646972656374546F4D6F6E69746F7228707263734964293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E20726564';
wwv_flow_imp.g_varchar2_table(131) := '6972656374546F4D6F6E69746F722870726373496429207B0D0A20207661722064617461203D207B7D3B0D0A2020646174612E783031203D2022766965772D666C6F772D696E7374616E6365223B0D0A2020646174612E783032203D207072637349643B';
wwv_flow_imp.g_varchar2_table(132) := '0D0A202073656E64546F5365727665722864617461293B0D0A7D0D0A0D0A66756E6374696F6E206765745661726961626C654572726F727328297B0D0A2020766172206572726F7273203D205B5D3B0D0A0D0A20206966202820617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(133) := '2250385F50524F565F5641525F4E414D4522292E6973456D70747928292029207B0D0A202020206572726F72732E70757368280D0A2020202020207B0D0A2020202020202020747970653A20202020202020226572726F72222C0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(134) := '6C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A2020202020202020706167654974656D3A2020202250385F50524F565F5641525F4E414D45222C0D0A20202020202020206D6573736167653A20202020617065782E6C616E672E6765';
wwv_flow_imp.g_varchar2_table(135) := '744D6573736167652820224150505F4552525F50524F565F5641525F4E414D455F454D5054592220292C0D0A2020202020202020756E736166653A202020202066616C73650D0A2020202020207D0D0A20202020293B0D0A20207D0D0A0D0A2020696620';
wwv_flow_imp.g_varchar2_table(136) := '2820617065782E6974656D282250385F50524F565F5641525F5459504522292E6973456D70747928292029207B0D0A202020206572726F72732E70757368280D0A2020202020207B0D0A2020202020202020747970653A20202020202020226572726F72';
wwv_flow_imp.g_varchar2_table(137) := '222C0D0A20202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A2020202020202020706167654974656D3A2020202250385F50524F565F5641525F54595045222C0D0A20202020202020206D6573736167653A20202020';
wwv_flow_imp.g_varchar2_table(138) := '617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F545950455F454D5054592220292C0D0A2020202020202020756E736166653A202020202066616C73650D0A2020202020207D0D0A20202020293B0D0A';
wwv_flow_imp.g_varchar2_table(139) := '20207D20656C7365207B0D0A202020207661722076617254797065203D20617065782E6974656D282250385F50524F565F5641525F5459504522292E67657456616C756528293B0D0A20202020696620282076617254797065203D3D3D20225641524348';
wwv_flow_imp.g_varchar2_table(140) := '415232222029207B0D0A2020202020206966202820617065782E6974656D282250385F50524F565F5641525F56433222292E6973456D70747928292029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A';
wwv_flow_imp.g_varchar2_table(141) := '202020202020202020202020747970653A20202020202020226572726F72222C0D0A2020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A202020225038';
wwv_flow_imp.g_varchar2_table(142) := '5F50524F565F5641525F564332222C0D0A2020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F56414C55455F454D5054592220292C0D0A2020';
wwv_flow_imp.g_varchar2_table(143) := '20202020202020202020756E736166653A202020202066616C73650D0A202020202020202020207D0D0A2020202020202020293B0D0A2020202020207D200D0A202020207D20656C736520696620282076617254797065203D3D3D20224E554D42455222';
wwv_flow_imp.g_varchar2_table(144) := '2029207B0D0A2020202020206966202820617065782E6974656D282250385F50524F565F5641525F4E554D22292E6973456D70747928292029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(145) := '2020202020202020747970653A20202020202020226572726F72222C0D0A2020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A2020202250385F50524F';
wwv_flow_imp.g_varchar2_table(146) := '565F5641525F4E554D222C0D0A2020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F56414C55455F454D5054592220292C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(147) := '202020202020756E736166653A202020202066616C73650D0A202020202020202020207D0D0A2020202020202020293B0D0A2020202020207D20656C7365207B0D0A20202020202020206966202820617065782E6974656D282250385F50524F565F5641';
wwv_flow_imp.g_varchar2_table(148) := '525F4E554D5F56414C494422292E67657456616C75652829203D3D3D20224E222029207B0D0A202020202020202020206572726F72732E70757368280D0A2020202020202020202020207B0D0A2020202020202020202020202020747970653A20202020';
wwv_flow_imp.g_varchar2_table(149) := '202020226572726F72222C0D0A20202020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A2020202020202020202020202020706167654974656D3A2020202250385F50524F565F5641525F4E554D222C0D0A';
wwv_flow_imp.g_varchar2_table(150) := '20202020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F4E554D5F4E4F545F4E554D4245522220292C0D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(151) := '756E736166653A202020202066616C73650D0A2020202020202020202020207D0D0A20202020202020202020293B0D0A20202020202020207D0D0A2020202020207D0D0A202020207D20656C736520696620282076617254797065203D3D3D2022444154';
wwv_flow_imp.g_varchar2_table(152) := '45222029207B0D0A2020202020206966202820617065782E6974656D282250385F50524F565F5641525F4441544522292E6973456D70747928292029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A20';
wwv_flow_imp.g_varchar2_table(153) := '2020202020202020202020747970653A20202020202020226572726F72222C0D0A2020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A2020202250385F';
wwv_flow_imp.g_varchar2_table(154) := '50524F565F5641525F44415445222C0D0A2020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F56414C55455F454D5054592220292C0D0A2020';
wwv_flow_imp.g_varchar2_table(155) := '20202020202020202020756E736166653A202020202066616C73650D0A202020202020202020207D0D0A2020202020202020293B0D0A2020202020207D20656C7365206966202820617065782E6974656D282250385F50524F565F5641525F444154455F';
wwv_flow_imp.g_varchar2_table(156) := '56414C494422292E67657456616C75652829203D3D3D20224E222029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A202020202020202020202020747970653A20202020202020226572726F72222C0D';
wwv_flow_imp.g_varchar2_table(157) := '0A2020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A2020202250385F50524F565F5641525F44415445222C0D0A2020202020202020202020206D6573';
wwv_flow_imp.g_varchar2_table(158) := '736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F444154455F4E4F545F444154452220292C0D0A202020202020202020202020756E736166653A202020202066616C73650D0A20';
wwv_flow_imp.g_varchar2_table(159) := '2020202020202020207D0D0A2020202020202020293B0D0A2020202020207D200D0A202020207D20656C736520696620282076617254797065203D3D3D202254494D455354414D5020574954482054494D45205A4F4E45222029207B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(160) := '6966202820617065782E6974656D282250385F50524F565F5641525F5453545A22292E6973456D70747928292029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A202020202020202020202020747970';
wwv_flow_imp.g_varchar2_table(161) := '653A20202020202020226572726F72222C0D0A2020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A2020202250385F50524F565F5641525F5453545A22';
wwv_flow_imp.g_varchar2_table(162) := '2C0D0A2020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F56414C55455F454D5054592220292C0D0A202020202020202020202020756E7361';
wwv_flow_imp.g_varchar2_table(163) := '66653A202020202066616C73650D0A202020202020202020207D0D0A2020202020202020293B0D0A2020202020207D20656C7365206966202820617065782E6974656D282250385F50524F565F5641525F5453545A5F56414C494422292E67657456616C';
wwv_flow_imp.g_varchar2_table(164) := '75652829203D3D3D20224E222029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A202020202020202020202020747970653A20202020202020226572726F72222C0D0A2020202020202020202020206C';
wwv_flow_imp.g_varchar2_table(165) := '6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A2020202250385F50524F565F5641525F5453545A222C0D0A2020202020202020202020206D6573736167653A20202020617065782E';
wwv_flow_imp.g_varchar2_table(166) := '6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F5453545A5F4E4F545F5453545A2220292C0D0A202020202020202020202020756E736166653A202020202066616C73650D0A202020202020202020207D0D0A2020';
wwv_flow_imp.g_varchar2_table(167) := '202020202020293B0D0A2020202020207D200D0A202020207D20656C736520696620282076617254797065203D3D3D2022434C4F4222207C7C2076617254797065203D3D3D20224A534F4E222029207B0D0A2020202020206966202820617065782E6974';
wwv_flow_imp.g_varchar2_table(168) := '656D282250385F50524F565F5641525F434C4F4222292E6973456D70747928292029207B0D0A20202020202020206572726F72732E70757368280D0A202020202020202020207B0D0A202020202020202020202020747970653A20202020202020226572';
wwv_flow_imp.g_varchar2_table(169) := '726F72222C0D0A2020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020706167654974656D3A2020202250385F50524F565F5641525F434C4F42222C0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(170) := '2020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F5641525F56414C55455F454D5054592220292C0D0A202020202020202020202020756E736166653A202020202066616C73';
wwv_flow_imp.g_varchar2_table(171) := '650D0A202020202020202020207D0D0A2020202020202020293B0D0A2020202020207D200D0A2020202020206966202876617254797065203D3D3D20224A534F4E2229207B0D0A2020202020202020747279207B0D0A202020202020202020204A534F4E';
wwv_flow_imp.g_varchar2_table(172) := '2E706172736528617065782E6974656D282250385F50524F565F5641525F434C4F4222292E67657456616C75652829293B0D0A20202020202020207D20636174636820286529207B0D0A202020202020202020206572726F72732E70757368280D0A2020';
wwv_flow_imp.g_varchar2_table(173) := '202020202020202020207B0D0A2020202020202020202020202020747970653A20202020202020226572726F72222C0D0A20202020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(174) := '20202020706167654974656D3A2020202250385F50524F565F5641525F434C4F42222C0D0A20202020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F50524F565F56';
wwv_flow_imp.g_varchar2_table(175) := '41525F494E56414C49445F4A534F4E2220292C0D0A2020202020202020202020202020756E736166653A202020202066616C73650D0A2020202020202020202020207D0D0A20202020202020202020293B0D0A20202020202020207D0D0A202020202020';
wwv_flow_imp.g_varchar2_table(176) := '7D0D0A202020207D200D0A20207D0D0A202072657475726E206572726F72733B0D0A7D0D0A0D0A66756E6374696F6E20676574476174657761794572726F727328297B0D0A2020766172206572726F7273203D205B5D3B0D0A0D0A202069662028617065';
wwv_flow_imp.g_varchar2_table(177) := '782E6974656D282250385F53454C4543545F4F5054494F4E22292E67657456616C75652829203D3D3D202273696E676C652220262620617065782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528292E6C656E677468203E';
wwv_flow_imp.g_varchar2_table(178) := '203129207B0D0A2020202020206572726F7273203D205B0D0A202020202020202020207B0D0A2020202020202020202020202020747970653A20202020202020226572726F72222C0D0A20202020202020202020202020206C6F636174696F6E3A202020';
wwv_flow_imp.g_varchar2_table(179) := '5B2022696E6C696E6522205D2C0D0A2020202020202020202020202020706167654974656D3A2020202250385F434F4E4E454354494F4E222C0D0A20202020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D65';
wwv_flow_imp.g_varchar2_table(180) := '73736167652820224150505F4552525F474154455741595F4F4E4C595F4F4E455F434F4E4E454354494F4E2220292C0D0A2020202020202020202020202020756E736166653A202020202066616C73650D0A202020202020202020207D0D0A2020202020';
wwv_flow_imp.g_varchar2_table(181) := '205D3B0D0A20207D0D0A202069662028617065782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528292E6C656E677468203D3D3D203029207B0D0A2020202020206572726F7273203D205B0D0A202020202020202020207B';
wwv_flow_imp.g_varchar2_table(182) := '0D0A2020202020202020202020202020747970653A20202020202020226572726F72222C0D0A20202020202020202020202020206C6F636174696F6E3A2020205B2022696E6C696E6522205D2C0D0A202020202020202020202020202070616765497465';
wwv_flow_imp.g_varchar2_table(183) := '6D3A2020202250385F434F4E4E454354494F4E222C0D0A20202020202020202020202020206D6573736167653A20202020617065782E6C616E672E6765744D6573736167652820224150505F4552525F474154455741595F434F4E4E454354494F4E5F45';
wwv_flow_imp.g_varchar2_table(184) := '4D5054592220292C0D0A2020202020202020202020202020756E736166653A202020202066616C73650D0A202020202020202020207D0D0A2020202020205D3B0D0A20207D0D0A202072657475726E206572726F72733B0D0A7D0D0A0D0A66756E637469';
wwv_flow_imp.g_varchar2_table(185) := '6F6E2061646450726F636573735661726961626C6528616374696F6E2C20666F637573456C656D656E74297B200D0A202076617220656C203D20666F637573456C656D656E743B0D0A20206966202820656C2E74797065203D3D3D20756E646566696E65';
wwv_flow_imp.g_varchar2_table(186) := '64207C7C20656C2E7479706520213D3D2022627574746F6E2229207B0D0A20202020656C203D20617065782E6A517565727928666F637573456C656D656E74292E636C6F736573742822627574746F6E22293B0D0A20207D0D0A20207661722067617465';
wwv_flow_imp.g_varchar2_table(187) := '776179526F757465203D20617065782E6A517565727928656C292E617474722822646174612D676174657761792D726F7574652229203D3D3D20227472756522203F2074727565203A2066616C73653B0D0A2020766172206469616C6F674964203D2067';
wwv_flow_imp.g_varchar2_table(188) := '617465776179526F757465203F2022676174657761795F73656C6563746F7222203A20227661726961626C655F6469616C6F6722203B0D0A0D0A20206966202820617065782E6A51756572792820222322202B206469616C6F67496420292E6469616C6F';
wwv_flow_imp.g_varchar2_table(189) := '6728202269734F70656E2220292029207B0D0A20202020766172206572726F7273203D2067617465776179526F757465203F20676574476174657761794572726F72732829203A206765745661726961626C654572726F727328293B0D0A202020206966';
wwv_flow_imp.g_varchar2_table(190) := '2028206572726F72732E6C656E677468203D3D3D20302029207B0D0A202020202020617065782E7468656D652E636C6F7365526567696F6E28206469616C6F67496420293B0D0A0D0A2020202020207661722064617461203D207B7D2C206F7074696F6E';
wwv_flow_imp.g_varchar2_table(191) := '73203D207B7D3B0D0A202020202020646174612E783031203D20616374696F6E3B0D0A202020202020646174612E783032203D20617065782E6974656D282250385F505243535F494422292E67657456616C756528293B0D0A202020202020646174612E';
wwv_flow_imp.g_varchar2_table(192) := '783036203D20617065782E6974656D282250385F50524F565F53434F504522292E67657456616C756528293B0D0A202020202020696620282067617465776179526F7574652029207B0D0A2020202020202020646174612E783033203D20617065782E69';
wwv_flow_imp.g_varchar2_table(193) := '74656D282250385F4741544557415922292E67657456616C75652829202B20223A726F757465223B0D0A2020202020202020646174612E783034203D20275641524348415232273B0D0A20202020202020207661722073656C6563744F7074696F6E203D';
wwv_flow_imp.g_varchar2_table(194) := '20617065782E6974656D282250385F53454C4543545F4F5054494F4E22292E67657456616C756528293B0D0A202020202020202076617220726F757465203D2073656C6563744F7074696F6E203D3D3D202273696E676C6522203F20617065782E697465';
wwv_flow_imp.g_varchar2_table(195) := '6D282250385F434F4E4E454354494F4E22292E67657456616C75652829203A20617065782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528292E6A6F696E28223A22293B0D0A2020202020202020646174612E783035203D';
wwv_flow_imp.g_varchar2_table(196) := '2073656C6563744F7074696F6E203D20726F7574653B0D0A2020202020207D20656C7365207B0D0A2020202020202020646174612E783033203D20617065782E6974656D282250385F50524F565F5641525F4E414D4522292E67657456616C756528293B';
wwv_flow_imp.g_varchar2_table(197) := '0D0A2020202020202020646174612E783034203D20617065782E6974656D282250385F50524F565F5641525F5459504522292E67657456616C756528293B0D0A20202020202020206966202820646174612E783034203D3D3D2022564152434841523222';
wwv_flow_imp.g_varchar2_table(198) := '2029207B0D0A20202020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F56433222292E67657456616C756528293B0D0A20202020202020207D20656C7365206966202820646174612E783034203D3D';
wwv_flow_imp.g_varchar2_table(199) := '3D20224E554D424552222029207B0D0A20202020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F4E554D22292E67657456616C756528293B0D0A20202020202020207D20656C736520696620282064';
wwv_flow_imp.g_varchar2_table(200) := '6174612E783034203D3D3D202244415445222029207B0D0A20202020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F4441544522292E67657456616C756528293B0D0A20202020202020207D20656C';
wwv_flow_imp.g_varchar2_table(201) := '7365206966202820646174612E783034203D3D3D202254494D455354414D5020574954482054494D45205A4F4E45222029207B0D0A20202020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F545354';
wwv_flow_imp.g_varchar2_table(202) := '5A22292E67657456616C756528293B0D0A20202020202020207D20656C7365206966202820646174612E783034203D3D3D2022434C4F4222207C7C20646174612E783034203D3D3D20224A534F4E2229207B0D0A20202020202020202020766172206368';
wwv_flow_imp.g_varchar2_table(203) := '756E6B6564436C6F62203D20617065782E7365727665722E6368756E6B28617065782E6974656D282250385F50524F565F5641525F434C4F4222292E67657456616C75652829293B0D0A2020202020202020202069662028202141727261792E69734172';
wwv_flow_imp.g_varchar2_table(204) := '72617928206368756E6B6564436C6F6220292029207B0D0A2020202020202020202020206368756E6B6564436C6F62203D205B6368756E6B6564436C6F625D3B0D0A202020202020202020207D0D0A20202020202020202020646174612E663031203D20';
wwv_flow_imp.g_varchar2_table(205) := '6368756E6B6564436C6F623B0D0A20202020202020207D200D0A0D0A2020202020207D0D0A2020202020200D0A2020202020206F7074696F6E732E6D6573736167654B6579203D20224150505F50524F434553535F5641524941424C455F414444454422';
wwv_flow_imp.g_varchar2_table(206) := '3B0D0A2020202020206F7074696F6E732E72656672657368526567696F6E203D205B2270726F636573732D7661726961626C6573225D3B0D0A0D0A20202020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A202020207D';
wwv_flow_imp.g_varchar2_table(207) := '20656C7365207B0D0A202020202020617065782E6D6573736167652E636C6561724572726F727328293B0D0A202020202020617065782E6D6573736167652E73686F774572726F727328206572726F727320293B0D0A202020207D0D0A20207D20656C73';
wwv_flow_imp.g_varchar2_table(208) := '65207B0D0A202020206966202867617465776179526F75746529207B0D0A202020202020617065782E6974656D28202250385F474154455741592220292E73657456616C75652820222220293B0D0A202020202020617065782E6974656D282250385F47';
wwv_flow_imp.g_varchar2_table(209) := '41544557415922292E656E61626C6528293B0D0A202020202020617065782E6974656D28202250385F434F4E4E454354494F4E2220292E73657456616C75652820222220293B0D0A202020202020617065782E6A517565727928202223756E73656C6563';
wwv_flow_imp.g_varchar2_table(210) := '745F62746E2220292E6869646528293B0D0A202020202020617065782E6A51756572792820222373656C6563745F62746E2220292E6869646528293B0D0A202020202020617065782E6A5175657279282022236164642D70726F762D7661722D726F7574';
wwv_flow_imp.g_varchar2_table(211) := '652D62746E2220292E73686F7728293B0D0A202020202020617065782E6A517565727928202223736176652D70726F762D7661722D726F7574652D62746E2220292E6869646528293B0D0A202020207D20656C7365207B0D0A202020202020617065782E';
wwv_flow_imp.g_varchar2_table(212) := '6974656D28202250385F50524F565F5641525F564332222020292E73657456616C756528293B0D0A202020202020617065782E6974656D28202250385F50524F565F5641525F4E554D222020292E73657456616C756528293B0D0A202020202020617065';
wwv_flow_imp.g_varchar2_table(213) := '782E6974656D28202250385F50524F565F5641525F444154452220292E73657456616C756528293B0D0A202020202020617065782E6974656D28202250385F50524F565F5641525F434C4F422220292E73657456616C756528293B0D0A20202020202061';
wwv_flow_imp.g_varchar2_table(214) := '7065782E6974656D28202250385F50524F565F5641525F4E414D452220292E73657456616C756528293B0D0A202020202020617065782E6974656D28202250385F50524F565F5641525F4E414D452220292E656E61626C6528293B0D0A20202020202061';
wwv_flow_imp.g_varchar2_table(215) := '7065782E6974656D28202250385F50524F565F5641525F545950452220292E73657456616C75652822564152434841523222293B0D0A202020202020617065782E6974656D28202250385F50524F565F5641525F545950452220292E656E61626C652829';
wwv_flow_imp.g_varchar2_table(216) := '3B0D0A202020202020617065782E6974656D28202250385F50524F565F53434F50452220202020292E73657456616C756528617065782E6974656D732E50385F4449414752414D5F4C4556454C2E6973456D7074792829203F20223022203A2061706578';
wwv_flow_imp.g_varchar2_table(217) := '2E6974656D732E50385F4449414752414D5F4C4556454C2E76616C756520293B0D0A202020202020617065782E6974656D28202250385F50524F565F53434F50452220202020292E656E61626C6528293B0D0A202020202020617065782E6A5175657279';
wwv_flow_imp.g_varchar2_table(218) := '282022236164642D70726F762D7661722D62746E2220292E73686F7728293B0D0A202020202020617065782E6A517565727928202223736176652D70726F762D7661722D62746E2220292E6869646528293B0D0A202020207D0D0A20202020617065782E';
wwv_flow_imp.g_varchar2_table(219) := '6D6573736167652E636C6561724572726F727328293B0D0A20202020617065782E7468656D652E6F70656E526567696F6E28206469616C6F67496420293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2075706461746550726F6365737356617269';
wwv_flow_imp.g_varchar2_table(220) := '61626C6528616374696F6E2C20666F637573456C656D656E74297B0D0A202076617220656C203D20666F637573456C656D656E743B0D0A20206966202820656C2E74797065203D3D3D20756E646566696E6564207C7C20656C2E7479706520213D3D2022';
wwv_flow_imp.g_varchar2_table(221) := '627574746F6E2229207B0D0A20202020656C203D20617065782E6A517565727928666F637573456C656D656E74292E636C6F736573742822627574746F6E22293B0D0A20207D0D0A20207661722067617465776179526F757465203D20617065782E6A51';
wwv_flow_imp.g_varchar2_table(222) := '7565727928656C292E617474722822646174612D676174657761792D726F7574652229203D3D3D20227472756522203F2074727565203A2066616C73653B0D0A2020766172206469616C6F674964203D2067617465776179526F757465203F2022676174';
wwv_flow_imp.g_varchar2_table(223) := '657761795F73656C6563746F7222203A20227661726961626C655F6469616C6F6722203B0D0A0D0A20206966202820617065782E6A51756572792820222322202B206469616C6F67496420292E6469616C6F6728202269734F70656E2220292029207B0D';
wwv_flow_imp.g_varchar2_table(224) := '0A20202020766172206572726F7273203D2067617465776179526F757465203F20676574476174657761794572726F72732829203A206765745661726961626C654572726F727328293B0D0A2020202069662028206572726F72732E6C656E677468203D';
wwv_flow_imp.g_varchar2_table(225) := '3D3D20302029207B0D0A202020202020617065782E7468656D652E636C6F7365526567696F6E28206469616C6F67496420293B0D0A0D0A2020202020207661722064617461203D207B7D2C206F7074696F6E73203D207B7D3B0D0A202020202020646174';
wwv_flow_imp.g_varchar2_table(226) := '612E783031203D20616374696F6E3B0D0A202020202020646174612E783032203D20617065782E6974656D282250385F505243535F494422292E67657456616C756528293B0D0A202020202020646174612E783036203D20617065782E6974656D282250';
wwv_flow_imp.g_varchar2_table(227) := '385F50524F565F53434F504522292E67657456616C756528293B0D0A202020202020696620282067617465776179526F7574652029207B0D0A2020202020202020646174612E783033203D20617065782E6974656D282250385F4741544557415922292E';
wwv_flow_imp.g_varchar2_table(228) := '67657456616C75652829202B20223A726F757465223B0D0A2020202020202020646174612E783034203D20275641524348415232273B0D0A20202020202020207661722073656C6563744F7074696F6E203D20617065782E6974656D282250385F53454C';
wwv_flow_imp.g_varchar2_table(229) := '4543545F4F5054494F4E22292E67657456616C756528293B0D0A202020202020202076617220726F757465203D2073656C6563744F7074696F6E203D3D3D202273696E676C6522203F20617065782E6974656D282250385F434F4E4E454354494F4E2229';
wwv_flow_imp.g_varchar2_table(230) := '2E67657456616C75652829203A20617065782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528292E6A6F696E28223A22293B0D0A2020202020202020646174612E783035203D2073656C6563744F7074696F6E203D20726F';
wwv_flow_imp.g_varchar2_table(231) := '7574653B0D0A2020202020207D20656C7365207B0D0A2020202020202020646174612E783033203D20617065782E6974656D282250385F50524F565F5641525F4E414D4522292E67657456616C756528293B0D0A2020202020202020646174612E783034';
wwv_flow_imp.g_varchar2_table(232) := '203D20617065782E6974656D282250385F50524F565F5641525F5459504522292E67657456616C756528293B0D0A20202020202020206966202820646174612E783034203D3D3D20225641524348415232222029207B0D0A202020202020202020206461';
wwv_flow_imp.g_varchar2_table(233) := '74612E783035203D20617065782E6974656D282250385F50524F565F5641525F56433222292E67657456616C756528293B0D0A20202020202020207D20656C7365206966202820646174612E783034203D3D3D20224E554D424552222029207B0D0A2020';
wwv_flow_imp.g_varchar2_table(234) := '2020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F4E554D22292E67657456616C756528293B0D0A20202020202020207D20656C7365206966202820646174612E783034203D3D3D20224441544522';
wwv_flow_imp.g_varchar2_table(235) := '2029207B0D0A20202020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F4441544522292E67657456616C756528293B0D0A20202020202020207D20656C7365206966202820646174612E783034203D';
wwv_flow_imp.g_varchar2_table(236) := '3D3D202254494D455354414D5020574954482054494D45205A4F4E45222029207B0D0A20202020202020202020646174612E783035203D20617065782E6974656D282250385F50524F565F5641525F5453545A22292E67657456616C756528293B0D0A20';
wwv_flow_imp.g_varchar2_table(237) := '202020202020207D20656C7365206966202820646174612E783034203D3D3D2022434C4F4222207C7C20646174612E783034203D3D3D20224A534F4E2229207B0D0A20202020202020202020766172206368756E6B6564436C6F62203D20617065782E73';
wwv_flow_imp.g_varchar2_table(238) := '65727665722E6368756E6B28617065782E6974656D282250385F50524F565F5641525F434C4F4222292E67657456616C75652829293B0D0A2020202020202020202069662028202141727261792E6973417272617928206368756E6B6564436C6F622029';
wwv_flow_imp.g_varchar2_table(239) := '2029207B0D0A2020202020202020202020206368756E6B6564436C6F62203D205B6368756E6B6564436C6F625D3B0D0A202020202020202020207D0D0A20202020202020202020646174612E663031203D206368756E6B6564436C6F623B0D0A20202020';
wwv_flow_imp.g_varchar2_table(240) := '202020207D200D0A2020202020207D0D0A2020202020200D0A2020202020206F7074696F6E732E6D6573736167654B6579203D20224150505F50524F434553535F5641524941424C455F5341564544223B0D0A2020202020206F7074696F6E732E726566';
wwv_flow_imp.g_varchar2_table(241) := '72657368526567696F6E203D205B2270726F636573732D7661726961626C6573225D3B0D0A0D0A20202020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A202020207D20656C7365207B0D0A202020202020617065782E';
wwv_flow_imp.g_varchar2_table(242) := '6D6573736167652E73686F774572726F727328206572726F727320293B0D0A202020207D0D0A20207D20656C7365207B0D0A20202020766172207661724E616D65203D20617065782E6A517565727928666F637573456C656D656E74292E617474722822';
wwv_flow_imp.g_varchar2_table(243) := '646174612D6E616D6522293B0D0A202020207661722076617254797065203D20617065782E6A517565727928666F637573456C656D656E74292E617474722822646174612D7479706522293B0D0A202020207661722076617253636F7065203D20617065';
wwv_flow_imp.g_varchar2_table(244) := '782E6A517565727928666F637573456C656D656E74292E617474722822646174612D73636F706522293B0D0A20202020617065782E7365727665722E70726F6365737328200D0A202020202020224745545F5641524941424C45222C200D0A2020202020';
wwv_flow_imp.g_varchar2_table(245) := '207B0D0A20202020202020207830313A20617065782E6974656D282250385F505243535F494422292E67657456616C756528292C0D0A20202020202020207830323A207661724E616D652C0D0A20202020202020207830333A20766172547970652C0D0A';
wwv_flow_imp.g_varchar2_table(246) := '20202020202020207830343A2076617253636F70650D0A2020202020207D2C200D0A2020202020207B0D0A2020202020202020737563636573733A2066756E6374696F6E282064617461202920207B0D0A2020202020202020202069662028646174612E';
wwv_flow_imp.g_varchar2_table(247) := '73756363657373297B0D0A2020202020202020202020206966202867617465776179526F75746529207B0D0A2020202020202020202020202020617065782E6D6573736167652E636C6561724572726F727328293B0D0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(248) := '20617065782E7468656D652E6F70656E526567696F6E2822676174657761795F73656C6563746F7222293B0D0A2020202020202020202020202020617065782E6A5175657279282223756E73656C6563745F62746E22292E6869646528293B0D0A202020';
wwv_flow_imp.g_varchar2_table(249) := '2020202020202020202020617065782E6A517565727928222373656C6563745F62746E22292E6869646528293B0D0A2020202020202020202020202020617065782E6A51756572792822236164642D70726F762D7661722D726F7574652D62746E22292E';
wwv_flow_imp.g_varchar2_table(250) := '6869646528293B0D0A2020202020202020202020202020617065782E6A5175657279282223736176652D70726F762D7661722D726F7574652D62746E22292E73686F7728293B0D0A2020202020202020202020202020617065782E6974656D282250385F';
wwv_flow_imp.g_varchar2_table(251) := '4741544557415922292E73657456616C7565287661724E616D652E73706C697428223A22295B305D293B0D0A202020202020202020202020202073657454696D656F75742866756E6374696F6E28297B200D0A2020202020202020202020202020202061';
wwv_flow_imp.g_varchar2_table(252) := '7065782E6974656D282250385F434F4E4E454354494F4E22292E73657456616C756528646174612E7663325F76616C7565293B200D0A20202020202020202020202020202020617065782E6974656D282250385F4741544557415922292E64697361626C';
wwv_flow_imp.g_varchar2_table(253) := '6528293B0D0A20202020202020202020202020207D2C20333030293B0D0A2020202020202020202020207D20656C7365207B0D0A2020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E414D4522292E73657456';
wwv_flow_imp.g_varchar2_table(254) := '616C7565287661724E616D65293B0D0A2020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E414D4522292E64697361626C6528293B0D0A2020202020202020202020202020617065782E6974656D282250385F';
wwv_flow_imp.g_varchar2_table(255) := '50524F565F5641525F5459504522292E73657456616C75652876617254797065293B0D0A2020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5459504522292E64697361626C6528293B0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(256) := '202020202020617065782E6974656D282250385F50524F565F53434F504522292E73657456616C75652876617253636F7065293B0D0A2020202020202020202020202020617065782E6974656D282250385F50524F565F53434F504522292E6469736162';
wwv_flow_imp.g_varchar2_table(257) := '6C6528293B0D0A2020202020202020202020202020617065782E7468656D652E6F70656E526567696F6E28227661726961626C655F6469616C6F6722293B0D0A2020202020202020202020202020696620282076617254797065203D3D3D202256415243';
wwv_flow_imp.g_varchar2_table(258) := '484152322229207B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C756528646174612E7663325F76616C7565293B0D0A202020202020202020202020202020206170';
wwv_flow_imp.g_varchar2_table(259) := '65782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C756528222229';
wwv_flow_imp.g_varchar2_table(260) := '3B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F56';
wwv_flow_imp.g_varchar2_table(261) := '41525F434C4F4222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F56433222292E736574466F63757328293B0D0A20202020202020202020202020207D2065';
wwv_flow_imp.g_varchar2_table(262) := '6C736520696620282076617254797065203D3D3D20224E554D4245522229207B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C756528646174612E6E756D5F76616C';
wwv_flow_imp.g_varchar2_table(263) := '7565293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F56';
wwv_flow_imp.g_varchar2_table(264) := '5F5641525F4441544522292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C7565282222293B0D0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(265) := '20202020617065782E6974656D282250385F50524F565F5641525F434C4F4222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E554D22292E736574466F63';
wwv_flow_imp.g_varchar2_table(266) := '757328293B0D0A20202020202020202020202020207D20656C736520696620282076617254797065203D3D3D2022444154452229207B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4441544522';
wwv_flow_imp.g_varchar2_table(267) := '292E73657456616C756528646174612E646174655F76616C7565293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C7565282222293B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(268) := '20202020202020617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E554D22292E73657456';
wwv_flow_imp.g_varchar2_table(269) := '616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F434C4F4222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250';
wwv_flow_imp.g_varchar2_table(270) := '385F50524F565F5641525F4441544522292E736574466F63757328293B0D0A20202020202020202020202020207D20656C736520696620282076617254797065203D3D3D202254494D455354414D5020574954482054494D45205A4F4E452229207B0D0A';
wwv_flow_imp.g_varchar2_table(271) := '20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C756528646174612E7473747A5F76616C7565293B0D0A20202020202020202020202020202020617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(272) := '2250385F50524F565F5641525F56433222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C7565282222293B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(273) := '20202020202020202020617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F434C4F422229';
wwv_flow_imp.g_varchar2_table(274) := '2E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5453545A22292E736574466F63757328293B0D0A20202020202020202020202020207D20656C73652069662028';
wwv_flow_imp.g_varchar2_table(275) := '2076617254797065203D3D3D2022434C4F4222207C7C2076617254797065203D3D3D20224A534F4E2229207B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F434C4F4222292E73657456616C7565';
wwv_flow_imp.g_varchar2_table(276) := '2876617254797065203D3D3D2022434C4F4222203F20646174612E636C6F625F76616C7565203A20646174612E6A736F6E5F76616C7565293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5643';
wwv_flow_imp.g_varchar2_table(277) := '3222292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E';
wwv_flow_imp.g_varchar2_table(278) := '6974656D282250385F50524F565F5641525F4441544522292E73657456616C7565282222293B0D0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C7565282222293B0D';
wwv_flow_imp.g_varchar2_table(279) := '0A20202020202020202020202020202020617065782E6974656D282250385F50524F565F5641525F434C4F4222292E736574466F63757328293B0D0A20202020202020202020202020207D200D0A2020202020202020202020202020617065782E6A5175';
wwv_flow_imp.g_varchar2_table(280) := '6572792822236164642D70726F762D7661722D62746E22292E6869646528293B0D0A2020202020202020202020202020617065782E6A5175657279282223736176652D70726F762D7661722D62746E22292E73686F7728293B200D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(281) := '202020207D0D0A202020202020202020202020617065782E7468656D652E6F70656E526567696F6E28206469616C6F67496420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020206572726F723A2066756E6374';
wwv_flow_imp.g_varchar2_table(282) := '696F6E28206A715848522C20746578745374617475732C206572726F725468726F776E2029207B0D0A20202020202020202020636F6E736F6C652E6C6F67286A71584852293B0D0A20202020202020207D0D0A2020202020207D200D0A20202020293B0D';
wwv_flow_imp.g_varchar2_table(283) := '0A20207D0D0A7D0D0A0D0A66756E6374696F6E2064656C65746550726F636573735661726961626C6528616374696F6E2C20666F637573456C656D656E74297B0D0A2020617065782E6D6573736167652E636F6E6669726D2820617065782E6C616E672E';
wwv_flow_imp.g_varchar2_table(284) := '6765744D65737361676528224150505F434F4E4649524D5F44454C4554455F50524F434553535F5641524941424C4522292C2066756E6374696F6E28206F6B507265737365642029207B0D0A20202020696628206F6B507265737365642029207B0D0A20';
wwv_flow_imp.g_varchar2_table(285) := '20202020207661722064617461203D207B7D2C206F7074696F6E73203D207B7D3B0D0A202020202020646174612E783031203D20616374696F6E3B0D0A202020202020646174612E783032203D20617065782E6A517565727928666F637573456C656D65';
wwv_flow_imp.g_varchar2_table(286) := '6E74292E617474722822646174612D7072637322293B0D0A202020202020646174612E783033203D20617065782E6A517565727928666F637573456C656D656E74292E617474722822646174612D6E616D6522293B0D0A202020202020646174612E7830';
wwv_flow_imp.g_varchar2_table(287) := '34203D20617065782E6A517565727928666F637573456C656D656E74292E617474722822646174612D73636F706522293B0D0A2020202020200D0A2020202020206F7074696F6E732E6D6573736167654B6579203D20224150505F50524F434553535F56';
wwv_flow_imp.g_varchar2_table(288) := '41524941424C455F44454C45544544223B0D0A2020202020206F7074696F6E732E72656672657368526567696F6E203D205B2270726F636573732D7661726961626C6573225D3B0D0A20202020202073656E64546F53657276657228646174612C206F70';
wwv_flow_imp.g_varchar2_table(289) := '74696F6E73293B0D0A202020207D0D0A20207D293B0D0A7D0D0A0D0A66756E6374696F6E2062756C6B44656C65746550726F636573735661726961626C6528616374696F6E297B0D0A2020617065782E6D6573736167652E636F6E6669726D2820617065';
wwv_flow_imp.g_varchar2_table(290) := '782E6C616E672E6765744D65737361676528224150505F434F4E4649524D5F44454C4554455F50524F434553535F5641524941424C4522292C2066756E6374696F6E28206F6B507265737365642029207B0D0A20202020696628206F6B50726573736564';
wwv_flow_imp.g_varchar2_table(291) := '2029207B0D0A2020202020207661722064617461203D207B7D2C206F7074696F6E73203D207B7D3B0D0A202020202020646174612E783031203D20616374696F6E3B0D0A202020202020646174612E663031203D206368696C6472656E41747472696275';
wwv_flow_imp.g_varchar2_table(292) := '7465546F417272617928222370726F636573732D7661726961626C6573202E612D4952522D7461626C65436F6E7461696E6572222C2027696E7075745B6E616D653D22663033225D3A636865636B6564272C2022646174612D7072637322293B0D0A2020';
wwv_flow_imp.g_varchar2_table(293) := '20202020646174612E663032203D206368696C6472656E417474726962757465546F417272617928222370726F636573732D7661726961626C6573202E612D4952522D7461626C65436F6E7461696E6572222C2027696E7075745B6E616D653D22663033';
wwv_flow_imp.g_varchar2_table(294) := '225D3A636865636B6564272C202276616C756522293B0D0A202020202020646174612E663033203D206368696C6472656E417474726962757465546F417272617928222370726F636573732D7661726961626C6573202E612D4952522D7461626C65436F';
wwv_flow_imp.g_varchar2_table(295) := '6E7461696E6572222C2027696E7075745B6E616D653D22663033225D3A636865636B6564272C2022646174612D73636F706522293B0D0A2020202020200D0A2020202020206F7074696F6E732E6D6573736167654B6579203D20224150505F50524F4345';
wwv_flow_imp.g_varchar2_table(296) := '53535F5641524941424C455F44454C45544544223B0D0A2020202020206F7074696F6E732E72656672657368526567696F6E203D205B2270726F636573732D7661726961626C6573225D3B0D0A20202020202073656E64546F5365727665722864617461';
wwv_flow_imp.g_varchar2_table(297) := '2C206F7074696F6E73293B0D0A202020207D0D0A20207D293B0D0A7D0D0A0D0A66756E6374696F6E20636F6D706C657465537465702820616374696F6E2C20656C656D656E7420297B0D0A20207661722064617461203D20676574537562666C6F774461';
wwv_flow_imp.g_varchar2_table(298) := '746128616374696F6E2C20656C656D656E74293B0D0A2020766172206F7074696F6E73203D207B7D3B0D0A20206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270';
wwv_flow_imp.g_varchar2_table(299) := '726F636573732D7661726961626C6573222C2022666C6F772D696E7374616E63652D6576656E7473222C20226D6573736167652D737562736372697074696F6E73222C20227461736B2D6C697374225D3B0D0A202073656E64546F536572766572286461';
wwv_flow_imp.g_varchar2_table(300) := '74612C206F7074696F6E73293B0D0A7D0D0A0D0A66756E6374696F6E2062756C6B436F6D706C657465537465702820616374696F6E20297B0D0A20207661722064617461203D2067657442756C6B537562666C6F77446174612820616374696F6E20293B';
wwv_flow_imp.g_varchar2_table(301) := '0D0A2020766172206F7074696F6E73203D207B7D3B0D0A20206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270726F636573732D7661726961626C6573222C2022';
wwv_flow_imp.g_varchar2_table(302) := '666C6F772D696E7374616E63652D6576656E7473222C20226D6573736167652D737562736372697074696F6E73222C20227461736B2D6C697374225D3B0D0A202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A7D0D0A0D0A';
wwv_flow_imp.g_varchar2_table(303) := '66756E6374696F6E2072657374617274537465702820616374696F6E2C20656C656D656E74297B0D0A20206966202820617065782E6A517565727928202223696E7374616E63655F616374696F6E5F6469616C6F672220292E6469616C6F672820226973';
wwv_flow_imp.g_varchar2_table(304) := '4F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A202020207661722064617461203D20676574537562666C6F774461746128';
wwv_flow_imp.g_varchar2_table(305) := '616374696F6E2C20656C656D656E74293B0D0A20202020646174612E783035203D20676574436F6E6669726D436F6D6D656E7428293B0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E6D6573736167654B65';
wwv_flow_imp.g_varchar2_table(306) := '79203D20224150505F5355424C464F575F524553544152544544223B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270726F636573732D76617269';
wwv_flow_imp.g_varchar2_table(307) := '61626C6573222C2022666C6F772D696E7374616E63652D6576656E7473222C20227461736B2D6C697374225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F7065';
wwv_flow_imp.g_varchar2_table(308) := '6E4D6F64616C436F6E6669726D57697468436F6D6D656E742820616374696F6E2C20656C656D656E742C20224150505F434F4E4649524D5F524553544152545F53544550222C20224150505F5449544C455F524553544152545F535445502220293B0D0A';
wwv_flow_imp.g_varchar2_table(309) := '20207D0D0A7D0D0A0D0A66756E6374696F6E2062756C6B52657374617274537465702820616374696F6E2C20656C656D656E7420297B0D0A20206966202820617065782E6A517565727928202223696E7374616E63655F616374696F6E5F6469616C6F67';
wwv_flow_imp.g_varchar2_table(310) := '2220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022696E7374616E63655F616374696F6E5F6469616C6F672220293B0D0A202020207661722064617461203D20';
wwv_flow_imp.g_varchar2_table(311) := '67657442756C6B537562666C6F77446174612820616374696F6E20293B0D0A20202020646174612E783032203D20676574436F6E6669726D436F6D6D656E7428293B0D0A202020200D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020';
wwv_flow_imp.g_varchar2_table(312) := '206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270726F636573732D7661726961626C6573222C2022666C6F772D696E7374616E63652D6576656E7473222C2022';
wwv_flow_imp.g_varchar2_table(313) := '7461736B2D6C697374225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E742820616374696F6E2C';
wwv_flow_imp.g_varchar2_table(314) := '20656C656D656E742C20224150505F434F4E4649524D5F524553544152545F53544550222C20224150505F5449544C455F524553544152545F535445502220293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E206F70656E5265736572766174696F';
wwv_flow_imp.g_varchar2_table(315) := '6E4469616C6F6728616374696F6E2C20656C656D656E74297B0D0A2020617065782E6974656D28202250385F5245534552564154494F4E2220292E73657456616C75652820222220293B0D0A2020617065782E6A51756572792820222372657365727665';
wwv_flow_imp.g_varchar2_table(316) := '2D737465702D62746E2220292E61747472282022646174612D616374696F6E222C20616374696F6E20293B0D0A2020617065780D0A202020202E6A517565727928202223726573657276652D737465702D62746E2220290D0A202020202E617474722820';
wwv_flow_imp.g_varchar2_table(317) := '22646174612D70726373222C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D7072637322202920293B0D0A2020617065780D0A202020202E6A517565727928202223726573657276652D737465702D62746E22';
wwv_flow_imp.g_varchar2_table(318) := '20290D0A202020202E61747472282022646174612D7362666C222C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D7362666C22202920293B0D0A2020617065780D0A202020202E6A5175657279282022237265';
wwv_flow_imp.g_varchar2_table(319) := '73657276652D737465702D62746E2220290D0A202020202E61747472282022646174612D6B6579222C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D6B657922202920293B0D0A2020617065782E7468656D65';
wwv_flow_imp.g_varchar2_table(320) := '2E6F70656E526567696F6E2820227265736572766174696F6E5F6469616C6F672220293B0D0A7D0D0A0D0A66756E6374696F6E2072657365727665537465702820616374696F6E2C20656C656D656E7420297B0D0A20206966202820617065782E6A5175';
wwv_flow_imp.g_varchar2_table(321) := '657279282022237265736572766174696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E2820227265736572766174696F6E5F6469616C6F67';
wwv_flow_imp.g_varchar2_table(322) := '2220293B0D0A202020207661722064617461203D20676574537562666C6F774461746128616374696F6E2C20656C656D656E74293B0D0A20202020646174612E783035203D20617065782E6974656D282250385F5245534552564154494F4E22292E6765';
wwv_flow_imp.g_varchar2_table(323) := '7456616C756528293B0D0A0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C20227461736B2D6C697374225D3B0D0A2020202073656E64';
wwv_flow_imp.g_varchar2_table(324) := '546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E5265736572766174696F6E4469616C6F672820616374696F6E2C20656C656D656E7420293B0D0A20207D0D0A7D0D0A0D0A66756E6374';
wwv_flow_imp.g_varchar2_table(325) := '696F6E2062756C6B52657365727665537465702820616374696F6E20297B0D0A20206966202820617065782E6A5175657279282022237265736572766174696F6E5F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A';
wwv_flow_imp.g_varchar2_table(326) := '20202020617065782E7468656D652E636C6F7365526567696F6E2820227265736572766174696F6E5F6469616C6F672220293B0D0A202020207661722064617461203D2067657442756C6B537562666C6F77446174612820616374696F6E20293B0D0A20';
wwv_flow_imp.g_varchar2_table(327) := '202020646174612E783032203D20617065782E6974656D282250385F5245534552564154494F4E22292E67657456616C756528293B0D0A202020200D0A20202020766172206F7074696F6E73203D207B7D3B0D0A202020206F7074696F6E732E72656672';
wwv_flow_imp.g_varchar2_table(328) := '657368526567696F6E203D205B22737562666C6F7773222C20227461736B2D6C697374225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020206F70656E526573657276';
wwv_flow_imp.g_varchar2_table(329) := '6174696F6E4469616C6F672820616374696F6E2C206E756C6C20293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2072656C65617365537465702820616374696F6E2C20656C656D656E7420297B0D0A2020617065782E6D6573736167652E636F6E';
wwv_flow_imp.g_varchar2_table(330) := '6669726D2820617065782E6C616E672E6765744D65737361676528224150505F434F4E4649524D5F52454C454153455F5354455022292C2066756E6374696F6E28206F6B507265737365642029207B0D0A20202020696628206F6B507265737365642029';
wwv_flow_imp.g_varchar2_table(331) := '207B0D0A2020202020207661722064617461203D20676574537562666C6F774461746128616374696F6E2C20656C656D656E74293B0D0A2020202020200D0A202020202020766172206F7074696F6E73203D207B7D3B0D0A2020202020206F7074696F6E';
wwv_flow_imp.g_varchar2_table(332) := '732E72656672657368526567696F6E203D205B22737562666C6F7773222C20227461736B2D6C697374225D3B0D0A20202020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A202020207D0D0A20207D293B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(333) := '0A66756E6374696F6E2062756C6B52656C65617365537465702820616374696F6E20297B0D0A2020617065782E6D6573736167652E636F6E6669726D2820617065782E6C616E672E6765744D65737361676528224150505F434F4E4649524D5F52454C45';
wwv_flow_imp.g_varchar2_table(334) := '4153455F5354455022292C2066756E6374696F6E28206F6B507265737365642029207B0D0A20202020696628206F6B507265737365642029207B0D0A2020202020207661722064617461203D2067657442756C6B537562666C6F77446174612861637469';
wwv_flow_imp.g_varchar2_table(335) := '6F6E293B0D0A2020202020200D0A202020202020766172206F7074696F6E73203D207B7D3B0D0A2020202020206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C20227461736B2D6C697374225D3B0D0A202020';
wwv_flow_imp.g_varchar2_table(336) := '20202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A202020207D0D0A20207D293B0D0A7D0D0A0D0A66756E6374696F6E2072657363686564756C6554696D6572202820616374696F6E2C20656C656D656E7420297B0D0A20';
wwv_flow_imp.g_varchar2_table(337) := '206966202820617065782E6A51756572792820222372657363686564756C655F74696D65725F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E2820';
wwv_flow_imp.g_varchar2_table(338) := '2272657363686564756C655F74696D65725F6469616C6F672220293B0D0A202020207661722064617461203D20676574537562666C6F774461746128616374696F6E2C20656C656D656E74293B0D0A20202020646174612E783035203D20617065782E69';
wwv_flow_imp.g_varchar2_table(339) := '74656D282250385F52455343484544554C455F54494D45525F4E4F5722292E67657456616C756528293B0D0A20202020646174612E783036203D20617065782E6974656D28202250385F52455343484544554C455F54494D45525F41542220292E676574';
wwv_flow_imp.g_varchar2_table(340) := '56616C756528293B0D0A20202020646174612E783037203D20617065782E6974656D282250385F52455343484544554C455F54494D45525F434F4D4D454E5422292E67657456616C756528293B0D0A202020202020200D0A20202020766172206F707469';
wwv_flow_imp.g_varchar2_table(341) := '6F6E73203D207B7D3B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270726F636573732D7661726961626C6573222C2022666C6F772D696E737461';
wwv_flow_imp.g_varchar2_table(342) := '6E63652D6576656E7473222C20226D6573736167652D737562736372697074696F6E73222C20227461736B2D6C697374225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A20';
wwv_flow_imp.g_varchar2_table(343) := '2020206F70656E52657363686564756C6554696D65724469616C6F672820616374696F6E2C20656C656D656E7420293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2062756C6B52657363686564756C6554696D6572202820616374696F6E20297B';
wwv_flow_imp.g_varchar2_table(344) := '0D0A20206966202820617065782E6A51756572792820222372657363686564756C655F74696D65725F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A20202020617065782E7468656D652E636C6F7365526567696F';
wwv_flow_imp.g_varchar2_table(345) := '6E28202272657363686564756C655F74696D65725F6469616C6F672220293B0D0A202020207661722064617461203D2067657442756C6B537562666C6F774461746128616374696F6E293B0D0A20202020646174612E783032203D20617065782E697465';
wwv_flow_imp.g_varchar2_table(346) := '6D282250385F52455343484544554C455F54494D45525F4E4F5722292E67657456616C756528293B0D0A20202020646174612E783033203D20617065782E6974656D28202250385F52455343484544554C455F54494D45525F41542220292E6765745661';
wwv_flow_imp.g_varchar2_table(347) := '6C756528293B0D0A20202020646174612E783034203D20617065782E6974656D282250385F52455343484544554C455F54494D45525F434F4D4D454E5422292E67657456616C756528293B0D0A202020202020200D0A20202020766172206F7074696F6E';
wwv_flow_imp.g_varchar2_table(348) := '73203D207B7D3B0D0A202020206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270726F636573732D7661726961626C6573222C2022666C6F772D696E7374616E63';
wwv_flow_imp.g_varchar2_table(349) := '652D6576656E7473222C20226D6573736167652D737562736372697074696F6E73222C20227461736B2D6C697374225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D20656C7365207B0D0A202020';
wwv_flow_imp.g_varchar2_table(350) := '206F70656E52657363686564756C6554696D65724469616C6F672820616374696F6E2C206E756C6C20293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E20726563656976654D6573736167652820616374696F6E2C20656C656D656E742029207B0D';
wwv_flow_imp.g_varchar2_table(351) := '0A20206966202820617065782E6A517565727928202223726563656976655F6D6573736167655F6469616C6F672220292E6469616C6F6728202269734F70656E2220292029207B0D0A202020207661722064617461203D206765744D6573736167654461';
wwv_flow_imp.g_varchar2_table(352) := '74612820616374696F6E2C20656C656D656E7420293B0D0A20202020766172206368756E6B6564436C6F62203D20617065782E7365727665722E6368756E6B28617065782E6974656D282250385F5041594C4F414422292E67657456616C75652829293B';
wwv_flow_imp.g_varchar2_table(353) := '0D0A2020202069662028202141727261792E6973417272617928206368756E6B6564436C6F6220292029207B0D0A2020202020206368756E6B6564436C6F62203D205B6368756E6B6564436C6F625D3B0D0A202020207D0D0A20202020646174612E6630';
wwv_flow_imp.g_varchar2_table(354) := '31203D206368756E6B6564436C6F623B0D0A20202020617065782E7468656D652E636C6F7365526567696F6E282022726563656976655F6D6573736167655F6469616C6F672220293B0D0A20202020766172206F7074696F6E73203D207B7D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(355) := '20206F7074696F6E732E72656672657368526567696F6E203D205B22737562666C6F7773222C2022666C6F772D6D6F6E69746F72222C202270726F636573732D7661726961626C6573222C2022666C6F772D696E7374616E63652D6576656E7473222C20';
wwv_flow_imp.g_varchar2_table(356) := '226D6573736167652D737562736372697074696F6E73222C20227461736B2D6C697374225D3B0D0A2020202073656E64546F53657276657228646174612C206F7074696F6E73293B0D0A20207D200D0A2020656C7365207B0D0A202020206F70656E5265';
wwv_flow_imp.g_varchar2_table(357) := '63656976654D6573736167654469616C6F672820616374696F6E2C20656C656D656E7420293B0D0A20207D0D0A20200D0A7D3B0D0A0D0A66756E6374696F6E206F70656E526563656976654D6573736167654469616C6F6728616374696F6E2C20656C65';
wwv_flow_imp.g_varchar2_table(358) := '6D656E74297B0D0A2020617065780D0A202020202E6A517565727928202223726563656976652D6D6573736167652D62746E2220290D0A202020202E61747472282022646174612D6D657373616765222C20617065782E6A51756572792820656C656D65';
wwv_flow_imp.g_varchar2_table(359) := '6E7420292E61747472282022646174612D6D65737361676522202920293B0D0A2020617065780D0A202020202E6A517565727928202223726563656976652D6D6573736167652D62746E2220290D0A202020202E61747472282022646174612D6B657922';
wwv_flow_imp.g_varchar2_table(360) := '2C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D6B657922202920293B0D0A2020617065780D0A202020202E6A517565727928202223726563656976652D6D6573736167652D62746E2220290D0A202020202E';
wwv_flow_imp.g_varchar2_table(361) := '61747472282022646174612D76616C7565222C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D76616C756522202920293B0D0A2020617065782E7468656D652E6F70656E526567696F6E282022726563656976';
wwv_flow_imp.g_varchar2_table(362) := '655F6D6573736167655F6469616C6F672220293B0D0A7D0D0A0D0A66756E6374696F6E206F70656E52657363686564756C6554696D65724469616C6F6728616374696F6E2C20656C656D656E74297B0D0A2020617065782E6974656D28202250385F5245';
wwv_flow_imp.g_varchar2_table(363) := '5343484544554C455F54494D45525F4E4F572220292E73657456616C7565282022592220293B0D0A2020617065782E6974656D28202250385F52455343484544554C455F54494D45525F41542220292E73657456616C75652820222220293B0D0A202061';
wwv_flow_imp.g_varchar2_table(364) := '7065782E6974656D282250385F52455343484544554C455F54494D45525F434F4D4D454E5422292E73657456616C7565282222293B0D0A2020617065782E6A51756572792820222372657363686564756C652D74696D65722D62746E2220292E61747472';
wwv_flow_imp.g_varchar2_table(365) := '282022646174612D616374696F6E222C20616374696F6E20293B0D0A2020617065780D0A202020202E6A51756572792820222372657363686564756C652D74696D65722D62746E2220290D0A202020202E61747472282022646174612D70726373222C20';
wwv_flow_imp.g_varchar2_table(366) := '617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D7072637322202920293B0D0A2020617065780D0A202020202E6A51756572792820222372657363686564756C652D74696D65722D62746E2220290D0A202020202E';
wwv_flow_imp.g_varchar2_table(367) := '61747472282022646174612D7362666C222C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D7362666C22202920293B0D0A2020617065780D0A202020202E6A51756572792820222372657363686564756C652D';
wwv_flow_imp.g_varchar2_table(368) := '74696D65722D62746E2220290D0A202020202E61747472282022646174612D6B6579222C20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D6B657922202920293B0D0A2020617065782E7468656D652E6F70656E';
wwv_flow_imp.g_varchar2_table(369) := '526567696F6E28202272657363686564756C655F74696D65725F6469616C6F672220293B0D0A7D0D0A0D0A66756E6374696F6E206D61726B417343757272656E7428707263734964297B0D0A20207661722070726F63657373526F7773203D2061706578';
wwv_flow_imp.g_varchar2_table(370) := '2E6A517565727928202223666C6F772D696E7374616E6365732074642220293B0D0A20207661722073656C656374656450726F63657373203D207072637349643B0D0A20207661722063757272656E7453656C6563746F72203D0D0A2020202022627574';
wwv_flow_imp.g_varchar2_table(371) := '746F6E2E666C6F772D696E7374616E63652D616374696F6E732D62746E5B646174612D707263733D22202B0D0A2020202073656C656374656450726F63657373202B0D0A20202020225D223B0D0A20207661722063757272656E74526F77203D2070726F';
wwv_flow_imp.g_varchar2_table(372) := '63657373526F77732E686173282063757272656E7453656C6563746F7220293B0D0A202070726F63657373526F77732E72656D6F7665436C61737328202263757272656E742D70726F636573732220293B0D0A202063757272656E74526F772E70617265';
wwv_flow_imp.g_varchar2_table(373) := '6E7428292E6368696C6472656E28292E616464436C61737328202263757272656E742D70726F636573732220293B0D0A7D0D0A0D0A66756E6374696F6E207265667265736856696577657228707263734964297B0D0A20206966202820617065782E6974';
wwv_flow_imp.g_varchar2_table(374) := '656D28225031305F444953504C41595F53455454494E4722292E67657456616C75652829203D3D3D202277696E646F77222029207B0D0A202020207265646972656374546F4D6F6E69746F7228707263734964293B0D0A20207D20656C7365207B0D0A20';
wwv_flow_imp.g_varchar2_table(375) := '202020617065782E726567696F6E2822666C6F772D6D6F6E69746F7222292E7265667265736828293B0D0A20207D0D0A7D0D0A0D0A66756E6374696F6E2076696577466C6F77496E7374616E63652820616374696F6E2C20656C656D656E7420297B0D0A';
wwv_flow_imp.g_varchar2_table(376) := '20207661722073656C656374656450726F63657373203D20617065782E6A51756572792820656C656D656E7420292E61747472282022646174612D707263732220293B0D0A20207661722063757272656E744E616D65203D20617065782E6A5175657279';
wwv_flow_imp.g_varchar2_table(377) := '2820656C656D656E7420292E61747472282022646174612D6E616D652220293B0D0A2020617065782E6974656D28225031305F505243535F494422292E73657456616C75652873656C656374656450726F63657373293B0D0A2020617065782E6974656D';
wwv_flow_imp.g_varchar2_table(378) := '28225031305F505243535F4E414D4522292E73657456616C75652863757272656E744E616D65293B0D0A20206D61726B417343757272656E742873656C656374656450726F63657373293B0D0A2020726566726573685669657765722873656C65637465';
wwv_flow_imp.g_varchar2_table(379) := '6450726F63657373293B0D0A7D0D0A0D0A66756E6374696F6E20696E6974416374696F6E7328297B0D0A20202F2F446566696E6520616374696F6E730D0A202024282066756E6374696F6E202829207B0D0A2020202076617220706167654964203D2061';
wwv_flow_imp.g_varchar2_table(380) := '7065782E6974656D282270466C6F7753746570496422292E67657456616C756528293B0D0A2020202069662028706167654964203D3D3D2022322229207B0D0A202020202020617065782E616374696F6E732E61646428205B0D0A20202020202020207B';
wwv_flow_imp.g_varchar2_table(381) := '0D0A202020202020202020206E616D653A20226E65772D666C6F772D76657273696F6E222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020';
wwv_flow_imp.g_varchar2_table(382) := '2020202020766172206467726D4964203D20617065782E6A51756572792820666F637573456C656D656E7420292E61747472282022646174612D6467726D2220293B0D0A202020202020202020202020617065782E6974656D28202250325F4447524D5F';
wwv_flow_imp.g_varchar2_table(383) := '49442220292E73657456616C756528206467726D496420293B0D0A202020202020202020202020617065782E6974656D28202250325F42554C4B5F414354494F4E2220292E73657456616C75652820224E2220293B0D0A20202020202020202020202061';
wwv_flow_imp.g_varchar2_table(384) := '7065782E7468656D652E6F70656E526567696F6E2820226E65775F76657273696F6E5F7265672220293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A20226275';
wwv_flow_imp.g_varchar2_table(385) := '6C6B2D6E65772D666C6F772D76657273696F6E222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020766172206467726D496420';
wwv_flow_imp.g_varchar2_table(386) := '3D20617065780D0A20202020202020202020202020202E6A5175657279282022696E7075745B6E616D653D6630315D3A636865636B65642220290D0A20202020202020202020202020202E6D6170282066756E6374696F6E202829207B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(387) := '202020202020202020202072657475726E20617065782E6A517565727928207468697320292E6174747228202276616C75652220293B0D0A20202020202020202020202020207D20290D0A20202020202020202020202020202E67657428290D0A202020';
wwv_flow_imp.g_varchar2_table(388) := '20202020202020202020202E6A6F696E2820223A2220293B0D0A202020202020202020202020617065782E6974656D28202250325F4447524D5F49442220292E73657456616C756528206467726D496420293B0D0A202020202020202020202020617065';
wwv_flow_imp.g_varchar2_table(389) := '782E6974656D28202250325F42554C4B5F414354494F4E2220292E73657456616C7565282022592220293B0D0A202020202020202020202020617065782E7468656D652E6F70656E526567696F6E2820226E65775F76657273696F6E5F7265672220293B';
wwv_flow_imp.g_varchar2_table(390) := '0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202262756C6B2D636F70792D666C6F77222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(391) := '2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020766172206467726D4964203D20617065780D0A20202020202020202020202020202E6A5175657279282022696E7075745B6E616D653D6630315D3A63';
wwv_flow_imp.g_varchar2_table(392) := '6865636B65642220290D0A20202020202020202020202020202E6D6170282066756E6374696F6E202829207B0D0A2020202020202020202020202020202072657475726E20617065782E6A517565727928207468697320292E6174747228202276616C75';
wwv_flow_imp.g_varchar2_table(393) := '652220293B0D0A20202020202020202020202020207D20290D0A20202020202020202020202020202E67657428290D0A20202020202020202020202020202E6A6F696E2820223A2220293B0D0A202020202020202020202020617065782E6974656D2820';
wwv_flow_imp.g_varchar2_table(394) := '2250325F4447524D5F49442220292E73657456616C756528206467726D496420293B0D0A202020202020202020202020617065782E6974656D28202250325F42554C4B5F414354494F4E2220292E73657456616C7565282022592220293B0D0A20202020';
wwv_flow_imp.g_varchar2_table(395) := '2020202020202020617065782E7468656D652E6F70656E526567696F6E282022636F70795F666C6F775F7265672220293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E61';
wwv_flow_imp.g_varchar2_table(396) := '6D653A2022636F70792D666C6F77222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020766172206467726D4964203D20617065';
wwv_flow_imp.g_varchar2_table(397) := '782E6A51756572792820666F637573456C656D656E7420292E61747472282022646174612D6467726D2220293B0D0A202020202020202020202020617065782E6974656D28202250325F4447524D5F49442220292E73657456616C756528206467726D49';
wwv_flow_imp.g_varchar2_table(398) := '6420293B0D0A202020202020202020202020617065782E6974656D28202250325F42554C4B5F414354494F4E2220292E73657456616C75652820224E2220293B0D0A202020202020202020202020617065782E7468656D652E6F70656E526567696F6E28';
wwv_flow_imp.g_varchar2_table(399) := '2022636F70795F666C6F775F7265672220293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A2020202020205D20293B0D0A202020207D0D0A0D0A202020206966202820706167654964203D3D3D2022372229207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(400) := '2020617065782E616374696F6E732E61646428205B0D0A20202020202020207B0D0A202020202020202020206E616D653A202264656C6574652D666C6F772D6469616772616D222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(401) := '2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020617065782E7468656D652E6F70656E526567696F6E282264656C6574655F72656722293B0D0A202020202020202020207D2C0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(402) := '7D0D0A2020202020205D20293B0D0A202020207D0D0A0D0A202020206966202820706167654964203D3D3D2022382229207B0D0A202020202020617065782E616374696F6E732E61646428205B0D0A20202020202020207B0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(403) := '6E616D653A2022636F6D706C6574652D73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020636F6D706C6574655374';
wwv_flow_imp.g_varchar2_table(404) := '65702820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202262756C6B2D636F6D706C6574652D';
wwv_flow_imp.g_varchar2_table(405) := '73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202062756C6B436F6D706C657465537465702820746869732E6E616D';
wwv_flow_imp.g_varchar2_table(406) := '6520293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A2022726573746172742D73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F';
wwv_flow_imp.g_varchar2_table(407) := '6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202072657374617274537465702820746869732E6E616D652C20666F637573456C656D656E74293B0D0A202020202020202020207D0D0A202020202020';
wwv_flow_imp.g_varchar2_table(408) := '20207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202262756C6B2D726573746172742D73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D';
wwv_flow_imp.g_varchar2_table(409) := '656E742029207B0D0A20202020202020202020202062756C6B52657374617274537465702820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B';
wwv_flow_imp.g_varchar2_table(410) := '0D0A202020202020202020206E616D653A2022726573657276652D73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(411) := '2072657365727665537465702820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202262756C6B2D';
wwv_flow_imp.g_varchar2_table(412) := '726573657276652D73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202062756C6B5265736572766553746570282074';
wwv_flow_imp.g_varchar2_table(413) := '6869732E6E616D6520293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202272656C656173652D73746570222C0D0A20202020202020202020616374696F6E3A20';
wwv_flow_imp.g_varchar2_table(414) := '66756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202072656C65617365537465702820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D';
wwv_flow_imp.g_varchar2_table(415) := '0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202262756C6B2D72656C656173652D73746570222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C2066';
wwv_flow_imp.g_varchar2_table(416) := '6F637573456C656D656E742029207B0D0A20202020202020202020202062756C6B52656C65617365537465702820746869732E6E616D6520293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(417) := '2020202020206E616D653A20226164642D70726F636573732D7661726961626C65222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(418) := '20202061646450726F636573735661726961626C6528202770726F636573732D7661726961626C65272C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(419) := '2020202020206E616D653A20227570646174652D70726F636573732D7661726961626C65222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(420) := '20202020202075706461746550726F636573735661726961626C6528202770726F636573732D7661726961626C65272C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B';
wwv_flow_imp.g_varchar2_table(421) := '0D0A202020202020202020206E616D653A202264656C6574652D70726F636573732D7661726961626C65222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A';
wwv_flow_imp.g_varchar2_table(422) := '20202020202020202020202064656C65746550726F636573735661726961626C652820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A20';
wwv_flow_imp.g_varchar2_table(423) := '2020202020202020206E616D653A202262756C6B2D64656C6574652D70726F636573732D7661726961626C65222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B';
wwv_flow_imp.g_varchar2_table(424) := '0D0A20202020202020202020202062756C6B44656C65746550726F636573735661726961626C652820746869732E6E616D6520293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(425) := '206E616D653A202272657363686564756C652D74696D6572222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E28206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202072657363686564';
wwv_flow_imp.g_varchar2_table(426) := '756C6554696D65722820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202262756C6B2D72657363';
wwv_flow_imp.g_varchar2_table(427) := '686564756C652D74696D6572222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E28206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202062756C6B52657363686564756C6554696D6572';
wwv_flow_imp.g_varchar2_table(428) := '2820746869732E6E616D65293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A2022726563656976652D6D657373616765222C0D0A20202020202020202020616374';
wwv_flow_imp.g_varchar2_table(429) := '696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020726563656976654D6573736167652820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020';
wwv_flow_imp.g_varchar2_table(430) := '202020202020207D2C0D0A20202020202020207D0D0A2020202020205D20293B0D0A202020207D0D0A0D0A2020202069662028706167654964203D3D3D202231302229207B0D0A202020202020617065782E616374696F6E732E61646428200D0A202020';
wwv_flow_imp.g_varchar2_table(431) := '20202020205B200D0A202020202020202020207B0D0A2020202020202020202020206E616D653A2022766965772D666C6F772D696E7374616E6365222C0D0A202020202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C';
wwv_flow_imp.g_varchar2_table(432) := '20666F637573456C656D656E742029207B0D0A202020202020202020202020202076696577466C6F77496E7374616E63652820746869732E6E616D652C20666F637573456C656D656E74293B0D0A2020202020202020202020207D2C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(433) := '202020207D2C0D0A202020202020202020207B0D0A2020202020202020202020206E616D653A202262756C6B2D73746172742D666C6F772D696E7374616E6365222C0D0A202020202020202020202020616374696F6E3A2066756E6374696F6E20282065';
wwv_flow_imp.g_varchar2_table(434) := '76656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020202062756C6B5374617274466C6F77496E7374616E63652820746869732E6E616D6520293B0D0A2020202020202020202020207D2C0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(435) := '207D2C0D0A202020202020202020207B0D0A2020202020202020202020206E616D653A202262756C6B2D72657365742D666C6F772D696E7374616E6365222C0D0A202020202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E';
wwv_flow_imp.g_varchar2_table(436) := '742C20666F637573456C656D656E742029207B0D0A202020202020202020202020202062756C6B5265736574466C6F77496E7374616E63652820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A2020202020202020202020207D2C';
wwv_flow_imp.g_varchar2_table(437) := '0D0A202020202020202020207D2C0D0A202020202020202020207B0D0A2020202020202020202020206E616D653A202262756C6B2D7465726D696E6174652D666C6F772D696E7374616E6365222C0D0A202020202020202020202020616374696F6E3A20';
wwv_flow_imp.g_varchar2_table(438) := '66756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020202062756C6B5465726D696E617465466C6F77496E7374616E63652820746869732E6E616D652C20666F637573456C656D656E74';
wwv_flow_imp.g_varchar2_table(439) := '20293B0D0A2020202020202020202020207D2C0D0A202020202020202020207D2C0D0A202020202020202020207B0D0A2020202020202020202020206E616D653A202262756C6B2D64656C6574652D666C6F772D696E7374616E6365222C0D0A20202020';
wwv_flow_imp.g_varchar2_table(440) := '2020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020202062756C6B44656C657465466C6F77496E7374616E63652820746869732E6E616D652C';
wwv_flow_imp.g_varchar2_table(441) := '20666F637573456C656D656E74293B0D0A2020202020202020202020207D2C0D0A202020202020202020207D2C0D0A202020202020202020207B0D0A2020202020202020202020206E616D653A20226F70656E2D666C6F772D696E7374616E63652D6465';
wwv_flow_imp.g_varchar2_table(442) := '7461696C73222C0D0A202020202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202020207265646972656374546F466C6F77496E7374616E63';
wwv_flow_imp.g_varchar2_table(443) := '6544657461696C2820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A20202020202020205D0D0A202020202020293B0D0A202020207D0D0A0D0A2020202069';
wwv_flow_imp.g_varchar2_table(444) := '662028706167654964203D3D3D20223822207C7C20706167654964203D3D3D202231302229207B0D0A202020202020617065782E616374696F6E732E616464285B0D0A20202020202020207B0D0A202020202020202020206E616D653A202263686F6F73';
wwv_flow_imp.g_varchar2_table(445) := '652D73657474696E67222C0D0A202020202020202020206765743A2066756E6374696F6E202829207B0D0A20202020202020202020202072657475726E20617065782E6974656D2820225022202B20706167654964202B20225F444953504C41595F5345';
wwv_flow_imp.g_varchar2_table(446) := '5454494E472220292E67657456616C756528293B0D0A202020202020202020207D2C0D0A202020202020202020207365743A2066756E6374696F6E20282076616C75652029207B0D0A202020202020202020202020617065782E6974656D282022502220';
wwv_flow_imp.g_varchar2_table(447) := '2B20706167654964202B20225F444953504C41595F53455454494E472220292E73657456616C7565282076616C756520293B0D0A20202020202020202020202076617220707263734964203D20617065782E6974656D2820225022202B20706167654964';
wwv_flow_imp.g_varchar2_table(448) := '202B20225F505243535F49442220292E67657456616C756528293B0D0A20200D0A20202020202020202020202073776974636820282076616C75652029207B0D0A2020202020202020202020202020636173652022726F77223A0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(449) := '2020202020202020617065782E6A517565727928202223636F6C312220292E616464436C61737328205B2022636F6C2D3132222C2022636F6C2D7374617274222C2022636F6C2D656E6422205D20292E72656D6F7665436C617373282022636F6C2D3622';
wwv_flow_imp.g_varchar2_table(450) := '20293B0D0A20202020202020202020202020202020617065782E6A517565727928202223636F6C322220292E616464436C61737328205B2022636F6C2D3132222C2022636F6C2D7374617274222C2022636F6C2D656E6422205D20292E72656D6F766543';
wwv_flow_imp.g_varchar2_table(451) := '6C617373282022636F6C2D362220293B0D0A20200D0A20202020202020202020202020202020617065782E6A517565727928202223666C6F772D6D6F6E69746F722220292E73686F7728293B0D0A20202020202020202020202020202020617065782E72';
wwv_flow_imp.g_varchar2_table(452) := '6567696F6E282022666C6F772D6D6F6E69746F722220292E7265667265736828293B0D0A2020202020202020202020202020200D0A20202020202020202020202020202020627265616B3B0D0A2020202020202020202020202020636173652022636F6C';
wwv_flow_imp.g_varchar2_table(453) := '756D6E223A0D0A20202020202020202020202020202020617065782E6A517565727928202223636F6C312220292E616464436C617373282022636F6C2D362220292E72656D6F7665436C61737328205B2022636F6C2D3132222C2022636F6C2D656E6422';
wwv_flow_imp.g_varchar2_table(454) := '205D20293B0D0A20202020202020202020202020202020617065782E6A517565727928202223636F6C322220292E616464436C617373282022636F6C2D362220292E72656D6F7665436C61737328205B2022636F6C2D3132222C2022636F6C2D73746172';
wwv_flow_imp.g_varchar2_table(455) := '7422205D20293B0D0A20202020202020202020202020202020617065782E6A517565727928202223636F6C322220292E617070656E64546F2820617065782E6A517565727928202223636F6C312220292E706172656E74282920293B0D0A20200D0A2020';
wwv_flow_imp.g_varchar2_table(456) := '2020202020202020202020202020617065782E6A517565727928202223666C6F772D6D6F6E69746F722220292E73686F7728293B0D0A20202020202020202020202020202020617065782E726567696F6E282022666C6F772D6D6F6E69746F722220292E';
wwv_flow_imp.g_varchar2_table(457) := '7265667265736828293B0D0A202020202020202020202020202020200D0A20202020202020202020202020202020627265616B3B0D0A202020202020202020202020202063617365202277696E646F77223A0D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(458) := '617065782E6A517565727928202223666C6F772D6D6F6E69746F722220292E6869646528293B0D0A20202020202020202020202020202020617065782E6A517565727928202223636F6C312220292E616464436C61737328205B2022636F6C2D3132222C';
wwv_flow_imp.g_varchar2_table(459) := '2022636F6C2D7374617274222C2022636F6C2D656E6422205D20292E72656D6F7665436C617373282022636F6C2D362220293B0D0A20202020202020202020202020202020617065782E6A517565727928202223636F6C322220292E616464436C617373';
wwv_flow_imp.g_varchar2_table(460) := '28205B2022636F6C2D3132222C2022636F6C2D7374617274222C2022636F6C2D656E6422205D20292E72656D6F7665436C617373282022636F6C2D362220293B0D0A0D0A20202020202020202020202020202020696620282070726373496420213D3D20';
wwv_flow_imp.g_varchar2_table(461) := '22222029207B0D0A2020202020202020202020202020202020207265646972656374546F4D6F6E69746F72282070726373496420293B0D0A202020202020202020202020202020207D0D0A20202020202020202020202020202020627265616B3B0D0A20';
wwv_flow_imp.g_varchar2_table(462) := '20202020202020202020207D0D0A202020202020202020207D2C0D0A2020202020202020202063686F696365733A205B5D2C0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202273746172742D666C';
wwv_flow_imp.g_varchar2_table(463) := '6F772D696E7374616E6365222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A2020202020202020202020207374617274466C6F77496E7374616E63652820';
wwv_flow_imp.g_varchar2_table(464) := '746869732E6E616D652C20666F637573456C656D656E74293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202272657365742D666C6F772D696E7374616E636522';
wwv_flow_imp.g_varchar2_table(465) := '2C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A2020202020202020202020207265736574466C6F77496E7374616E63652820746869732E6E616D652C2066';
wwv_flow_imp.g_varchar2_table(466) := '6F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A20227465726D696E6174652D666C6F772D696E7374616E6365222C0D0A20202020';
wwv_flow_imp.g_varchar2_table(467) := '202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A2020202020202020202020207465726D696E617465466C6F77496E7374616E63652820746869732E6E616D652C20666F6375';
wwv_flow_imp.g_varchar2_table(468) := '73456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A202264656C6574652D666C6F772D696E7374616E6365222C0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(469) := '616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020202064656C657465466C6F77496E7374616E63652820746869732E6E616D652C20666F637573456C656D656E7420';
wwv_flow_imp.g_varchar2_table(470) := '293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A202020202020202020206E616D653A2022646F776E6C6F61642D61732D737667222C0D0A20202020202020202020616374696F6E3A2066756E637469';
wwv_flow_imp.g_varchar2_table(471) := '6F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020202020646F776E6C6F6164417353564728293B0D0A202020202020202020207D0D0A20202020202020207D2C0D0A20202020202020207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(472) := '2020202020206E616D653A2022666C6F772D696E7374616E63652D6175646974222C0D0A20202020202020202020616374696F6E3A2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(473) := '20207265646972656374546F466C6F77496E7374616E636541756469742820746869732E6E616D652C20666F637573456C656D656E7420293B0D0A202020202020202020207D0D0A20202020202020207D0D0A2020202020205D293B0D0A0D0A20202020';
wwv_flow_imp.g_varchar2_table(474) := '2020617065782E616374696F6E732E736574280D0A20202020202020202263686F6F73652D73657474696E67222C0D0A2020202020202020617065782E6974656D2820225022202B20706167654964202B20225F444953504C41595F53455454494E4722';
wwv_flow_imp.g_varchar2_table(475) := '20292E67657456616C756528290D0A202020202020293B0D0A20200D0A20202020202073657454696D656F7574282066756E6374696F6E202829207B0D0A202020202020202076617220616374696F6E2C206C6162656C3B0D0A20202020202020206163';
wwv_flow_imp.g_varchar2_table(476) := '74696F6E203D20617065782E616374696F6E732E6C6F6F6B757028202263686F6F73652D73657474696E672220293B0D0A2020202020202020616374696F6E2E63686F69636573203D20616374696F6E2E6C6162656C2E73706C69742820227C2220292E';
wwv_flow_imp.g_varchar2_table(477) := '6D6170282066756E6374696F6E202820632C20692029207B0D0A2020202020202020202072657475726E207B206C6162656C3A20632C2076616C75653A205B22726F77222C2022636F6C756D6E222C202277696E646F77225D5B695D207D3B0D0A202020';
wwv_flow_imp.g_varchar2_table(478) := '20202020207D20293B0D0A202020202020202064656C65746520616374696F6E2E6C6162656C3B0D0A2020202020202020617065782E616374696F6E732E75706461746528202263686F6F73652D73657474696E672220293B0D0A2020202020207D2C20';
wwv_flow_imp.g_varchar2_table(479) := '3120293B0D0A202020207D0D0A0D0A20202020617065782E616374696F6E732E61646428205B0D0A2020202020207B0D0A20202020202020206E616D653A2022656469742D666C6F772D6469616772616D222C0D0A2020202020202020616374696F6E3A';
wwv_flow_imp.g_varchar2_table(480) := '2066756E6374696F6E2028206576656E742C20666F637573456C656D656E742029207B0D0A202020202020202020207265646972656374546F466C6F774469616772616D2820746869732E6E616D652C20666F637573456C656D656E74293B0D0A202020';
wwv_flow_imp.g_varchar2_table(481) := '20202020207D0D0A2020202020207D0D0A202020205D200D0A20202020293B0D0A20207D20293B0D0A7D0D0A0D0A66756E6374696F6E20696E697450616765322829207B0D0A2020696E697441707028293B0D0A2020696E6974416374696F6E7328293B';
wwv_flow_imp.g_varchar2_table(482) := '0D0A0D0A2020617065782E6A5175657279282077696E646F7720292E6F6E2820227468656D6534327265616479222C2066756E6374696F6E202829207B0D0A2020202024282022237061727365645F6472676D207461626C652074682E612D4952522D68';
wwv_flow_imp.g_varchar2_table(483) := '65616465722D2D67726F75702220290D0A2020202020202E61747472282022636F6C7370616E222C2022362220290D0A2020202020202E6166746572280D0A2020202020202020273C746820636F6C7370616E3D22352220636C6173733D22612D495252';
wwv_flow_imp.g_varchar2_table(484) := '2D68656164657220612D4952522D6865616465722D2D67726F7570222069643D22696E7374616E6365735F636F6C756D6E5F67726F75705F68656164696E6722207374796C653D22746578742D616C69676E3A2063656E7465723B223E496E7374616E63';
wwv_flow_imp.g_varchar2_table(485) := '65733C2F74683E270D0A202020202020293B0D0A0D0A20202020242820222E612D4952522D6865616465724C6162656C2C202E612D4952522D6865616465724C696E6B2220292E65616368282066756E6374696F6E202829207B0D0A2020202020207661';
wwv_flow_imp.g_varchar2_table(486) := '7220737461747573203D202428207468697320292E6368696C6472656E28226922292E64617461282273746174757322293B0D0A2020202020206966202820737461747573203D3D202263726561746564222029207B0D0A202020202020202024282074';
wwv_flow_imp.g_varchar2_table(487) := '68697320292E706172656E7428292E616464436C6173732820226666612D636F6C6F722D2D637265617465642220293B0D0A2020202020207D20656C7365206966202820737461747573203D3D2022636F6D706C65746564222029207B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(488) := '2020202428207468697320292E706172656E7428292E616464436C6173732820226666612D636F6C6F722D2D636F6D706C657465642220293B0D0A2020202020207D20656C7365206966202820737461747573203D3D202272756E6E696E67222029207B';
wwv_flow_imp.g_varchar2_table(489) := '0D0A20202020202020202428207468697320292E706172656E7428292E616464436C6173732820226666612D636F6C6F722D2D72756E6E696E672220293B0D0A2020202020207D20656C7365206966202820737461747573203D3D20227465726D696E61';
wwv_flow_imp.g_varchar2_table(490) := '746564222029207B0D0A20202020202020202428207468697320292E706172656E7428292E616464436C6173732820226666612D636F6C6F722D2D7465726D696E617465642220293B0D0A2020202020207D20656C736520696620282073746174757320';
wwv_flow_imp.g_varchar2_table(491) := '3D3D20226572726F72222029207B0D0A20202020202020202428207468697320292E706172656E7428292E616464436C6173732820226666612D636F6C6F722D2D6572726F722220293B0D0A2020202020207D0D0A202020207D20293B0D0A0D0A202020';
wwv_flow_imp.g_varchar2_table(492) := '206966202824282274682E612D4952522D6865616465722D2D67726F757022292E6C656E677468203E203029207B0D0A202020202020242822746822292E656163682866756E6374696F6E2869297B0D0A20202020202020202020696620282061706578';
wwv_flow_imp.g_varchar2_table(493) := '2E6A51756572792874686973292E61747472282269642229203D3D3D20756E646566696E656429207B0D0A2020202020202020202020202020617065782E6A51756572792874686973292E66696E642827696E7075745B747970653D22636865636B626F';
wwv_flow_imp.g_varchar2_table(494) := '78225D27292E6869646528293B0D0A2020202020202020202020202020617065782E6A51756572792874686973292E66696E642827627574746F6E236865616465722D616374696F6E27292E6869646528293B0D0A202020202020202020207D20656C73';
wwv_flow_imp.g_varchar2_table(495) := '65207B0D0A2020202020202020202020202020617065782E6A51756572792874686973292E616464436C6173732822752D616C69676E4D6964646C6522293B0D0A202020202020202020207D0D0A2020202020207D293B0D0A202020207D0D0A0D0A2020';
wwv_flow_imp.g_varchar2_table(496) := '202024282022236865616465725F616374696F6E735F6D656E752220292E6F6E2820226D656E756265666F72656F70656E222C2066756E6374696F6E2028206576656E742C2075692029207B0D0A202020202020766172206D656E754974656D73203D20';
wwv_flow_imp.g_varchar2_table(497) := '75692E6D656E752E6974656D733B0D0A202020202020696620280D0A2020202020202020617065780D0A202020202020202020202E6A5175657279282022237061727365645F6472676D5F6972202E612D4952522D7461626C65436F6E7461696E657222';
wwv_flow_imp.g_varchar2_table(498) := '20290D0A202020202020202020202E66696E64282027696E7075745B747970653D22636865636B626F78225D3A636865636B65642720292E6C656E677468203D3D3D20300D0A20202020202029207B0D0A20202020202020206D656E754974656D73203D';
wwv_flow_imp.g_varchar2_table(499) := '206D656E754974656D732E6D6170282066756E6374696F6E2028206974656D2029207B0D0A2020202020202020202069662028206974656D2E616374696F6E20213D3D202272656672657368222029207B0D0A2020202020202020202020206974656D2E';
wwv_flow_imp.g_varchar2_table(500) := '64697361626C6564203D20747275653B0D0A202020202020202020207D0D0A2020202020202020202072657475726E206974656D3B0D0A20202020202020207D20293B0D0A2020202020207D20656C7365207B0D0A20202020202020206D656E75497465';
wwv_flow_imp.g_varchar2_table(501) := '6D73203D206D656E754974656D732E6D6170282066756E6374696F6E2028206974656D2029207B0D0A2020202020202020202069662028206974656D2E616374696F6E20213D3D202272656672657368222029207B0D0A20202020202020202020202069';
wwv_flow_imp.g_varchar2_table(502) := '74656D2E64697361626C6564203D2066616C73653B0D0A202020202020202020207D0D0A2020202020202020202072657475726E206974656D3B0D0A20202020202020207D20293B0D0A0D0A2020202020202020617065780D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(503) := '2E6A5175657279282022237061727365645F6472676D5F6972202E612D4952522D7461626C65436F6E7461696E65722220290D0A202020202020202020202E66696E64282027696E7075745B747970653D22636865636B626F78225D3A636865636B6564';
wwv_flow_imp.g_varchar2_table(504) := '2720290D0A202020202020202020202E65616368282066756E6374696F6E202829207B0D0A202020202020202020202020766172206E616D65203D202428207468697320292E646174612820226E616D652220293B0D0A0D0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(505) := '20696620280D0A2020202020202020202020202020617065780D0A202020202020202020202020202020202E6A5175657279282022237061727365645F6472676D5F6972202E612D4952522D7461626C65436F6E7461696E65722220290D0A2020202020';
wwv_flow_imp.g_varchar2_table(506) := '20202020202020202020202E66696E64280D0A20202020202020202020202020202020202027696E7075745B747970653D22636865636B626F78225D5B646174612D6E616D653D2227202B206E616D65202B2027225D3A636865636B6564270D0A202020';
wwv_flow_imp.g_varchar2_table(507) := '20202020202020202020202020292E6C656E677468203E20310D0A20202020202020202020202029207B0D0A20202020202020202020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E6374696F6E2028206974656D';
wwv_flow_imp.g_varchar2_table(508) := '2029207B0D0A20202020202020202020202020202020696620280D0A2020202020202020202020202020202020206974656D2E616374696F6E203D3D3D202262756C6B2D6E65772D666C6F772D76657273696F6E22207C7C0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(509) := '20202020202020206974656D2E616374696F6E203D3D3D202262756C6B2D636F70792D666C6F77220D0A2020202020202020202020202020202029207B0D0A2020202020202020202020202020202020206974656D2E64697361626C6564203D20747275';
wwv_flow_imp.g_varchar2_table(510) := '653B0D0A202020202020202020202020202020207D0D0A2020202020202020202020202020202072657475726E206974656D3B0D0A20202020202020202020202020207D20293B0D0A202020202020202020202020202072657475726E2066616C73653B';
wwv_flow_imp.g_varchar2_table(511) := '0D0A2020202020202020202020207D0D0A202020202020202020207D20293B0D0A2020202020207D0D0A20202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A202020207D20293B0D0A20207D20293B0D0A7D0D0A0D0A66';
wwv_flow_imp.g_varchar2_table(512) := '756E6374696F6E20696E697450616765332829207B0D0A2020696E697441707028293B0D0A2020617065782E6A5175657279282077696E646F7720292E6F6E2820227468656D6534327265616479222C2066756E6374696F6E202829207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(513) := '616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D2263726561746564225D2720202C20227370616E2E742D42616467654C6973742D77726170222C20226666612D636F6C6F722D2D6372656174656422293B';
wwv_flow_imp.g_varchar2_table(514) := '0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D2272756E6E696E67225D2720202C20227370616E2E742D42616467654C6973742D77726170222C20226666612D636F6C6F722D2D72756E6E';
wwv_flow_imp.g_varchar2_table(515) := '696E6722293B0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D22636F6D706C65746564225D272C20227370616E2E742D42616467654C6973742D77726170222C20226666612D636F6C6F72';
wwv_flow_imp.g_varchar2_table(516) := '2D2D636F6D706C6574656422293B0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D227465726D696E61746564225D272C20227370616E2E742D42616467654C6973742D77726170222C2022';
wwv_flow_imp.g_varchar2_table(517) := '6666612D636F6C6F722D2D7465726D696E6174656422293B0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D226572726F72225D2720202020202C20227370616E2E742D42616467654C6973';
wwv_flow_imp.g_varchar2_table(518) := '742D77726170222C20226666612D636F6C6F722D2D6572726F7222293B0D0A20207D20293B0D0A7D0D0A0D0A66756E6374696F6E20696E697450616765342829207B0D0A2020696E697441707028293B0D0A2020242877696E646F77292E62696E642827';
wwv_flow_imp.g_varchar2_table(519) := '6B6579646F776E272C2066756E6374696F6E286576656E7429207B0D0A20202020696620286576656E742E6374726C4B6579207C7C206576656E742E6D6574614B657929207B0D0A202020202020202069662028537472696E672E66726F6D4368617243';
wwv_flow_imp.g_varchar2_table(520) := '6F6465286576656E742E7768696368292E746F4C6F776572436173652829203D3D3D2027732729207B0D0A2020202020202020202020206576656E742E70726576656E7444656661756C7428293B0D0A202020202020202020202020617065782E726567';
wwv_flow_imp.g_varchar2_table(521) := '696F6E28276D6F64656C657227292E7361766528293B0D0A20202020202020207D0D0A202020207D0D0A20207D293B0D0A7D0D0A0D0A66756E6374696F6E20696E697450616765372829207B0D0A2020696E6974416374696F6E7328293B0D0A20206170';
wwv_flow_imp.g_varchar2_table(522) := '65782E6A5175657279282077696E646F7720292E6F6E2820227468656D6534327265616479222C2066756E6374696F6E202829207B0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D226372';
wwv_flow_imp.g_varchar2_table(523) := '6561746564225D272020202C20227370616E2E742D42616467654C6973742D76616C7565222C205B226666612D636F6C6F722D2D63726561746564222C2022696E7374616E63652D636F756E7465722D6C696E6B225D293B0D0A20202020616464436C61';
wwv_flow_imp.g_varchar2_table(524) := '73736573546F506172656E747328277370616E5B646174612D7374617475733D2272756E6E696E67225D272020202C20227370616E2E742D42616467654C6973742D76616C7565222C205B226666612D636F6C6F722D2D72756E6E696E67222C2022696E';
wwv_flow_imp.g_varchar2_table(525) := '7374616E63652D636F756E7465722D6C696E6B225D293B0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D22636F6D706C65746564225D27202C20227370616E2E742D42616467654C697374';
wwv_flow_imp.g_varchar2_table(526) := '2D76616C7565222C205B226666612D636F6C6F722D2D636F6D706C65746564222C2022696E7374616E63652D636F756E7465722D6C696E6B225D293B0D0A20202020616464436C6173736573546F506172656E747328277370616E5B646174612D737461';
wwv_flow_imp.g_varchar2_table(527) := '7475733D227465726D696E61746564225D272C20227370616E2E742D42616467654C6973742D76616C7565222C205B226666612D636F6C6F722D2D7465726D696E61746564222C2022696E7374616E63652D636F756E7465722D6C696E6B225D293B0D0A';
wwv_flow_imp.g_varchar2_table(528) := '20202020616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D226572726F72225D2720202020202C20227370616E2E742D42616467654C6973742D76616C7565222C205B226666612D636F6C6F722D2D657272';
wwv_flow_imp.g_varchar2_table(529) := '6F72222C2022696E7374616E63652D636F756E7465722D6C696E6B225D293B0D0A0D0A202020202428202223616374696F6E735F6D656E752220292E6F6E2820226D656E756265666F72656F70656E222C2066756E6374696F6E2028206576656E742C20';
wwv_flow_imp.g_varchar2_table(530) := '75692029207B0D0A202020202020766172206D656E754974656D73203D2075692E6D656E752E6974656D733B0D0A202020202020766172206467726D537461747573203D20617065782E6974656D282250375F4447524D5F53544154555322292E676574';
wwv_flow_imp.g_varchar2_table(531) := '56616C756528293B0D0A20202020202076617220656E67696E654170704D6F6465203D20617065782E6974656D282250375F454E47494E455F4150505F4D4F444522292E67657456616C756528293B0D0A2020202020206D656E754974656D73203D206D';
wwv_flow_imp.g_varchar2_table(532) := '656E754974656D732E6D6170282066756E6374696F6E2028206974656D2029207B0D0A202020202020202069662028206974656D2E616374696F6E203D3D3D202264656C6574652D666C6F772D6469616772616D222029207B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(533) := '206974656D2E64697361626C6564203D206467726D537461747573203D3D3D2022647261667422207C7C206467726D537461747573203D3D3D2022617263686976656422207C7C20656E67696E654170704D6F6465203D3D3D2022646576656C6F706D65';
wwv_flow_imp.g_varchar2_table(534) := '6E7422203F2066616C7365203A20747275653B0D0A20202020202020207D0D0A202020202020202072657475726E206974656D3B0D0A2020202020207D20293B0D0A20202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A';
wwv_flow_imp.g_varchar2_table(535) := '202020207D20293B0D0A20207D20293B0D0A7D0D0A0D0A66756E6374696F6E20696E697450616765382829207B0D0A2020696E697441707028293B0D0A2020696E6974416374696F6E7328293B0D0A0D0A2020617065782E6A5175657279282077696E64';
wwv_flow_imp.g_varchar2_table(536) := '6F7720292E6F6E2820227468656D6534327265616479222C2066756E6374696F6E202829207B0D0A202020202428202274682E612D4952522D6865616465722220292E65616368282066756E6374696F6E202820692029207B0D0A202020202020696620';
wwv_flow_imp.g_varchar2_table(537) := '2820617065782E6A517565727928207468697320292E617474722820226964222029203D3D3D20756E646566696E65642029207B0D0A2020202020202020617065782E6A517565727928207468697320292E66696E64282027696E7075745B747970653D';
wwv_flow_imp.g_varchar2_table(538) := '22636865636B626F78225D2720292E6869646528293B0D0A2020202020202020617065782E6A517565727928207468697320292E66696E64282022627574746F6E23737562666C6F772D6865616465722D616374696F6E2220292E6869646528293B0D0A';
wwv_flow_imp.g_varchar2_table(539) := '2020202020207D20656C7365207B0D0A2020202020202020617065782E6A517565727928207468697320292E616464436C617373282022752D616C69676E4D6964646C652220293B0D0A2020202020207D0D0A202020207D20293B0D0A202020200D0A20';
wwv_flow_imp.g_varchar2_table(540) := '2020207661722070726373537461747573203D20617065782E6974656D282250385F505243535F53544154555322292E67657456616C756528293B0D0A2020202020200D0A20202020696620282070726373537461747573203D3D3D2022637265617465';
wwv_flow_imp.g_varchar2_table(541) := '64222029207B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D33372D616C657274';
wwv_flow_imp.g_varchar2_table(542) := '2D74657874222C20226661222C202266612D706C75732D636972636C652D6F225D293B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D';
wwv_flow_imp.g_varchar2_table(543) := '69636F6E22292E616464436C6173732822752D636F6C6F722D33372D616C6572742D626722293B0D0A202020207D20656C736520696620282070726373537461747573203D3D3D202272756E6E696E67222029207B0D0A2020202020202020617065782E';
wwv_flow_imp.g_varchar2_table(544) := '6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D33352D616C6572742D74657874222C20226661222C202266612D706C61';
wwv_flow_imp.g_varchar2_table(545) := '792D636972636C652D6F225D293B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F';
wwv_flow_imp.g_varchar2_table(546) := '6C6F722D33352D616C6572742D626722293B0D0A202020207D20656C736520696620282070726373537461747573203D3D3D2022636F6D706C65746564222029207B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E737461';
wwv_flow_imp.g_varchar2_table(547) := '6E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D34342D616C6572742D74657874222C20226661222C202266612D636865636B2D636972636C652D6F225D293B0D0A2020';
wwv_flow_imp.g_varchar2_table(548) := '202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F722D34342D616C6572742D626722293B';
wwv_flow_imp.g_varchar2_table(549) := '0D0A202020207D20656C736520696620282070726373537461747573203D3D3D20227465726D696E61746564222029207B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E64';
wwv_flow_imp.g_varchar2_table(550) := '28227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D33382D616C6572742D74657874222C20226661222C202266612D73746F702D636972636C652D6F225D293B0D0A2020202020202020617065782E6A517565727928';
wwv_flow_imp.g_varchar2_table(551) := '2223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F722D33382D616C6572742D626722293B0D0A202020207D20656C7365206966202820';
wwv_flow_imp.g_varchar2_table(552) := '70726373537461747573203D3D3D20226572726F72222029207B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C6173';
wwv_flow_imp.g_varchar2_table(553) := '73285B22752D636F6C6F722D33392D616C6572742D74657874222C20226661222C202266612D6578636C616D6174696F6E2D636972636C652D6F225D293B0D0A2020202020202020617065782E6A5175657279282223666C6F772D696E7374616E63652D';
wwv_flow_imp.g_varchar2_table(554) := '64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F722D33392D616C6572742D626722293B0D0A202020207D200D0A0D0A0D0A202020202428202223616374696F6E735F6D656E';
wwv_flow_imp.g_varchar2_table(555) := '752220292E6F6E2820226D656E756265666F72656F70656E222C2066756E6374696F6E2028206576656E742C2075692029207B0D0A202020202020766172206D656E754974656D73203D2075692E6D656E752E6974656D733B0D0A202020202020766172';
wwv_flow_imp.g_varchar2_table(556) := '2070726373537461747573203D20617065782E6974656D282250385F505243535F53544154555322292E67657456616C756528293B0D0A2020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E6374696F6E20282069';
wwv_flow_imp.g_varchar2_table(557) := '74656D2029207B0D0A202020202020202069662028206974656D2E616374696F6E203D3D3D202273746172742D666C6F772D696E7374616E6365222029207B0D0A202020202020202020206974656D2E64697361626C6564203D20707263735374617475';
wwv_flow_imp.g_varchar2_table(558) := '7320213D3D20226372656174656422203F2074727565203A2066616C73653B0D0A20202020202020207D0D0A202020202020202069662028206974656D2E616374696F6E203D3D3D202272657365742D666C6F772D696E7374616E6365222029207B0D0A';
wwv_flow_imp.g_varchar2_table(559) := '202020202020202020206974656D2E64697361626C6564203D207072637353746174757320213D3D20226372656174656422203F2066616C7365203A20747275653B0D0A20202020202020207D0D0A202020202020202069662028206974656D2E616374';
wwv_flow_imp.g_varchar2_table(560) := '696F6E203D3D3D20227465726D696E6174652D666C6F772D696E7374616E6365222029207B0D0A202020202020202020206974656D2E64697361626C6564203D0D0A20202020202020202020202070726373537461747573203D3D3D202272756E6E696E';
wwv_flow_imp.g_varchar2_table(561) := '6722207C7C2070726373537461747573203D3D3D20226572726F7222203F2066616C7365203A20747275653B0D0A20202020202020207D0D0A202020202020202072657475726E206974656D3B0D0A2020202020207D20293B0D0A0D0A20202020202075';
wwv_flow_imp.g_varchar2_table(562) := '692E6D656E752E6974656D73203D206D656E754974656D733B0D0A202020207D20293B0D0A0D0A202020202428202223737562666C6F775F6865616465725F616374696F6E5F6D656E752220292E6F6E2820226D656E756265666F72656F70656E222C20';
wwv_flow_imp.g_varchar2_table(563) := '66756E6374696F6E2028206576656E742C2075692029207B0D0A202020202020766172206D656E754974656D73203D2075692E6D656E752E6974656D733B0D0A2020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E';
wwv_flow_imp.g_varchar2_table(564) := '6374696F6E2028206974656D2029207B0D0A20202020202020206966202820617065782E6A5175657279282027696E7075745B6E616D653D22663032225D3A636865636B65642720292E6C656E677468203D3D3D20302029207B0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(565) := '20206974656D2E64697361626C6564203D20747275653B0D0A20202020202020207D20656C7365207B0D0A202020202020202020206974656D2E64697361626C6564203D2066616C73653B0D0A2020202020202020202069662028206974656D2E616374';
wwv_flow_imp.g_varchar2_table(566) := '696F6E203D3D3D202262756C6B2D636F6D706C6574652D73746570222029207B0D0A202020202020202020202020696620280D0A2020202020202020202020202020617065780D0A202020202020202020202020202020202E6A51756572792820222373';
wwv_flow_imp.g_varchar2_table(567) := '7562666C6F7773202E612D4952522D7461626C65436F6E7461696E65722220290D0A202020202020202020202020202020202E66696E64282027696E7075745B6E616D653D22663032225D5B646174612D737461747573213D2272756E6E696E67225D3A';
wwv_flow_imp.g_varchar2_table(568) := '636865636B65642720290D0A202020202020202020202020202020202E6C656E677468203E20300D0A20202020202020202020202029207B0D0A20202020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(569) := '202020202020207D0D0A202020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D202262756C6B2D726573746172742D73746570222029207B0D0A202020202020202020202020696620280D0A202020';
wwv_flow_imp.g_varchar2_table(570) := '2020202020202020202020617065780D0A202020202020202020202020202020202E6A517565727928202223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E65722220290D0A202020202020202020202020202020202E66696E64';
wwv_flow_imp.g_varchar2_table(571) := '282027696E7075745B6E616D653D22663032225D5B646174612D737461747573213D226572726F72225D3A636865636B65642720290D0A202020202020202020202020202020202E6C656E677468203E20300D0A20202020202020202020202029207B0D';
wwv_flow_imp.g_varchar2_table(572) := '0A20202020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D20226275';
wwv_flow_imp.g_varchar2_table(573) := '6C6B2D726573657276652D73746570222029207B0D0A202020202020202020202020696620280D0A2020202020202020202020202020617065780D0A202020202020202020202020202020202E6A517565727928202223737562666C6F7773202E612D49';
wwv_flow_imp.g_varchar2_table(574) := '52522D7461626C65436F6E7461696E65722220290D0A202020202020202020202020202020202E66696E64282027696E7075745B6E616D653D22663032225D5B646174612D7265736572766174696F6E213D22225D3A636865636B65642720290D0A2020';
wwv_flow_imp.g_varchar2_table(575) := '20202020202020202020202020202E6C656E677468203E20300D0A20202020202020202020202020207C7C20617065780D0A20202020202020202020202020202E6A517565727928202223737562666C6F7773202E612D4952522D7461626C65436F6E74';
wwv_flow_imp.g_varchar2_table(576) := '61696E65722220290D0A20202020202020202020202020202E66696E64282027696E7075745B6E616D653D22663032225D5B646174612D737461747573213D2272756E6E696E67225D3A636865636B65642720290D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(577) := '2E6C656E677468203E20300D0A20202020202020202020202029207B0D0A20202020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A2020202020';
wwv_flow_imp.g_varchar2_table(578) := '202020202069662028206974656D2E616374696F6E203D3D3D202262756C6B2D72656C656173652D73746570222029207B0D0A202020202020202020202020696620280D0A2020202020202020202020202020617065780D0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(579) := '20202020202E6A517565727928202223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E65722220290D0A202020202020202020202020202020202E66696E64282027696E7075745B6E616D653D22663032225D5B646174612D7265';
wwv_flow_imp.g_varchar2_table(580) := '736572766174696F6E3D22225D3A636865636B65642720290D0A202020202020202020202020202020202E6C656E677468203E20300D0A20202020202020202020202029207B0D0A20202020202020202020202020206974656D2E64697361626C656420';
wwv_flow_imp.g_varchar2_table(581) := '3D20747275653B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D202262756C6B2D72657363686564756C652D74696D6572222029207B0D0A202020';
wwv_flow_imp.g_varchar2_table(582) := '202020202020202020696620280D0A2020202020202020202020202020617065780D0A202020202020202020202020202020202E6A517565727928202223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E65722220290D0A202020';
wwv_flow_imp.g_varchar2_table(583) := '202020202020202020202020202E66696E64282027696E7075745B6E616D653D22663032225D5B646174612D737461747573213D2277616974696E6720666F722074696D6572225D3A636865636B65642720290D0A202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(584) := '202E6C656E677468203E20300D0A20202020202020202020202029207B0D0A20202020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A20202020';
wwv_flow_imp.g_varchar2_table(585) := '202020207D0D0A202020202020202072657475726E206974656D3B0D0A2020202020207D20293B0D0A20202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A202020207D20293B0D0A0D0A20202020617065780D0A202020';
wwv_flow_imp.g_varchar2_table(586) := '2020202E6A517565727928202223737562666C6F775F726F775F616374696F6E5F6D656E752220290D0A2020202020202E6F6E2820226D656E756265666F72656F70656E222C2066756E6374696F6E2028206576656E742C2075692029207B0D0A202020';
wwv_flow_imp.g_varchar2_table(587) := '202020202076617220726F7742746E203D20617065782E6A51756572792820222E737562666C6F772D616374696F6E732D62746E2E69732D6163746976652220293B0D0A2020202020202020766172206D656E754974656D73203D2075692E6D656E752E';
wwv_flow_imp.g_varchar2_table(588) := '6974656D733B0D0A2020202020202020766172207362666C537461747573203D20726F7742746E2E646174612820227374617475732220293B0D0A202020202020202076617220737562666C5265736572766174696F6E203D20726F7742746E2E646174';
wwv_flow_imp.g_varchar2_table(589) := '612820227265736572766174696F6E2220293B0D0A20202020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E6374696F6E2028206974656D2029207B0D0A2020202020202020202069662028206974656D2E616374';
wwv_flow_imp.g_varchar2_table(590) := '696F6E203D3D3D2022636F6D706C6574652D73746570222029207B0D0A2020202020202020202020206974656D2E64697361626C6564203D207362666C537461747573203D3D3D202272756E6E696E6722203F2066616C7365203A20747275653B0D0A20';
wwv_flow_imp.g_varchar2_table(591) := '2020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D2022726573746172742D73746570222029207B0D0A2020202020202020202020206974656D2E64697361626C6564203D207362666C5374617475';
wwv_flow_imp.g_varchar2_table(592) := '73203D3D3D20226572726F7222203F2066616C7365203A20747275653B0D0A202020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D2022726573657276652D73746570222029207B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(593) := '202020202020206974656D2E64697361626C6564203D0D0A2020202020202020202020202020737562666C5265736572766174696F6E203D3D3D202222202626207362666C537461747573203D3D3D202272756E6E696E67220D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(594) := '202020202020203F2066616C73650D0A202020202020202020202020202020203A20747275653B0D0A202020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D202272656C656173652D737465702220';
wwv_flow_imp.g_varchar2_table(595) := '29207B0D0A2020202020202020202020206974656D2E64697361626C6564203D0D0A2020202020202020202020202020737562666C5265736572766174696F6E20213D3D202222202626207362666C537461747573203D3D3D202272756E6E696E67220D';
wwv_flow_imp.g_varchar2_table(596) := '0A202020202020202020202020202020203F2066616C73650D0A202020202020202020202020202020203A20747275653B0D0A202020202020202020207D0D0A2020202020202020202069662028206974656D2E616374696F6E203D3D3D202272657363';
wwv_flow_imp.g_varchar2_table(597) := '686564756C652D74696D6572222029207B0D0A2020202020202020202020206974656D2E64697361626C6564203D207362666C537461747573203D3D3D202277616974696E6720666F722074696D657222203F2066616C7365203A20747275653B0D0A20';
wwv_flow_imp.g_varchar2_table(598) := '2020202020202020207D0D0A2020202020202020202072657475726E206974656D3B0D0A20202020202020207D20293B0D0A202020202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A2020202020207D20293B0D0A0D0A';
wwv_flow_imp.g_varchar2_table(599) := '20202020617065780D0A2020202020202E6A5175657279282022237661726961626C655F6865616465725F616374696F6E5F6D656E752220290D0A2020202020202E6F6E2820226D656E756265666F72656F70656E222C2066756E6374696F6E20282065';
wwv_flow_imp.g_varchar2_table(600) := '76656E742C2075692029207B0D0A2020202020202020766172206D656E754974656D73203D2075692E6D656E752E6974656D733B0D0A20202020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E6374696F6E202820';
wwv_flow_imp.g_varchar2_table(601) := '6974656D2029207B0D0A202020202020202020206966202820617065782E6A5175657279282027696E7075745B6E616D653D22663033225D3A636865636B65642720292E6C656E677468203D3D3D20302029207B0D0A2020202020202020202020206974';
wwv_flow_imp.g_varchar2_table(602) := '656D2E64697361626C6564203D20747275653B0D0A202020202020202020207D20656C7365207B0D0A2020202020202020202020206974656D2E64697361626C6564203D2066616C73653B0D0A202020202020202020207D0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(603) := '72657475726E206974656D3B0D0A20202020202020207D20293B0D0A202020202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A2020202020207D20293B0D0A0D0A20207D20293B0D0A7D0D0A0D0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(604) := '696E69745061676531302829207B0D0A2020696E697441707028293B0D0A2020696E6974416374696F6E7328293B0D0A0D0A2020617065782E6A5175657279282077696E646F7720292E6F6E2820227468656D6534327265616479222C2066756E637469';
wwv_flow_imp.g_varchar2_table(605) := '6F6E202829207B0D0A202020206966202824282274682E612D4952522D6865616465722D2D67726F757022292E6C656E677468203E203029207B0D0A2020202020202428202274682E612D4952522D6865616465722220292E65616368282066756E6374';
wwv_flow_imp.g_varchar2_table(606) := '696F6E202820692029207B0D0A20202020202020206966202820617065782E6A517565727928207468697320292E617474722820226964222029203D3D3D20756E646566696E65642029207B0D0A20202020202020202020617065782E6A517565727928';
wwv_flow_imp.g_varchar2_table(607) := '207468697320292E66696E64282027696E7075745B747970653D22636865636B626F78225D2720292E6869646528293B0D0A20202020202020202020617065782E6A517565727928207468697320292E66696E64282022627574746F6E23696E7374616E';
wwv_flow_imp.g_varchar2_table(608) := '63652D6865616465722D616374696F6E2220292E6869646528293B0D0A20202020202020207D20656C7365207B0D0A20202020202020202020617065782E6A517565727928207468697320292E616464436C617373282022752D616C69676E4D6964646C';
wwv_flow_imp.g_varchar2_table(609) := '652220293B0D0A20202020202020207D0D0A2020202020207D20293B0D0A202020207D0D0A0D0A202020202F2A44697361626C6520646F776E6C6F616420696D616765207768656E206E6F20696E7374616E6365732073656C65637465642A2F0D0A2020';
wwv_flow_imp.g_varchar2_table(610) := '20202428202223616374696F6E735F6D656E752220292E6F6E2820226D656E756265666F72656F70656E222C2066756E6374696F6E2028206576656E742C2075692029207B0D0A202020202020766172206D656E754974656D73203D2075692E6D656E75';
wwv_flow_imp.g_varchar2_table(611) := '2E6974656D733B0D0A2020202020206D656E754974656D735B315D2E64697361626C6564203D0D0A2020202020202020617065782E6974656D2820225031305F505243535F49442220292E67657456616C75652829203D3D3D202222203F207472756520';
wwv_flow_imp.g_varchar2_table(612) := '3A2066616C73653B0D0A20202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A202020207D20293B0D0A0D0A202020202428202223696E7374616E63655F6865616465725F616374696F6E5F6D656E752220292E6F6E280D';
wwv_flow_imp.g_varchar2_table(613) := '0A202020202020226D656E756265666F72656F70656E222C0D0A20202020202066756E6374696F6E2028206576656E742C2075692029207B0D0A2020202020202020766172206D656E754974656D73203D2075692E6D656E752E6974656D733B0D0A2020';
wwv_flow_imp.g_varchar2_table(614) := '2020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E6374696F6E2028206974656D2029207B0D0A202020202020202020206966202820617065782E6A5175657279282027696E7075745B6E616D653D22663031225D';
wwv_flow_imp.g_varchar2_table(615) := '3A636865636B65642720292E6C656E677468203D3D3D20302029207B0D0A2020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A202020202020202020207D20656C7365207B0D0A202020202020202020202020697465';
wwv_flow_imp.g_varchar2_table(616) := '6D2E64697361626C6564203D2066616C73653B0D0A20202020202020202020202069662028206974656D2E616374696F6E203D3D3D202262756C6B2D73746172742D666C6F772D696E7374616E6365222029207B0D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(617) := '696620280D0A20202020202020202020202020202020617065780D0A2020202020202020202020202020202020202E6A517565727928202223666C6F772D696E7374616E636573202E612D4952522D7461626C65436F6E7461696E65722220290D0A2020';
wwv_flow_imp.g_varchar2_table(618) := '202020202020202020202020202020202E66696E64282027696E7075745B6E616D653D22663031225D5B646174612D737461747573213D2263726561746564225D3A636865636B65642720290D0A2020202020202020202020202020202020202E6C656E';
wwv_flow_imp.g_varchar2_table(619) := '677468203E20300D0A202020202020202020202020202029207B0D0A202020202020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A20202020202020202020202020207D0D0A2020202020202020202020207D0D0A20';
wwv_flow_imp.g_varchar2_table(620) := '202020202020202020202069662028206974656D2E616374696F6E203D3D3D202262756C6B2D72657365742D666C6F772D696E7374616E6365222029207B0D0A2020202020202020202020202020696620280D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(621) := '617065780D0A2020202020202020202020202020202020202E6A517565727928202223666C6F772D696E7374616E636573202E612D4952522D7461626C65436F6E7461696E65722220290D0A2020202020202020202020202020202020202E66696E6428';
wwv_flow_imp.g_varchar2_table(622) := '2027696E7075745B6E616D653D22663031225D5B646174612D7374617475733D2263726561746564225D3A636865636B65642720290D0A2020202020202020202020202020202020202E6C656E677468203E20300D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(623) := '29207B0D0A202020202020202020202020202020206974656D2E64697361626C6564203D20747275653B0D0A20202020202020202020202020207D0D0A2020202020202020202020207D0D0A20202020202020202020202069662028206974656D2E6163';
wwv_flow_imp.g_varchar2_table(624) := '74696F6E203D3D3D202262756C6B2D7465726D696E6174652D666C6F772D696E7374616E6365222029207B0D0A2020202020202020202020202020696620280D0A20202020202020202020202020202020617065780D0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(625) := '20202020202E6A517565727928202223666C6F772D696E7374616E636573202E612D4952522D7461626C65436F6E7461696E65722220290D0A2020202020202020202020202020202020202E66696E64280D0A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(626) := '20202027696E7075745B6E616D653D22663031225D5B646174612D737461747573213D2272756E6E696E67225D3A636865636B6564272C0D0A202020202020202020202020202020202020202027696E7075745B6E616D653D22663031225D5B64617461';
wwv_flow_imp.g_varchar2_table(627) := '2D737461747573213D226572726F72225D3A636865636B6564270D0A202020202020202020202020202020202020292E6C656E677468203E20300D0A202020202020202020202020202029207B0D0A202020202020202020202020202020206974656D2E';
wwv_flow_imp.g_varchar2_table(628) := '64697361626C6564203D20747275653B0D0A20202020202020202020202020207D0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A2020202020202020202072657475726E206974656D3B0D0A20202020202020207D20293B0D';
wwv_flow_imp.g_varchar2_table(629) := '0A202020202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A2020202020207D0D0A20202020293B0D0A0D0A202020202428202223696E7374616E63655F726F775F616374696F6E5F6D656E752220292E6F6E2820226D65';
wwv_flow_imp.g_varchar2_table(630) := '6E756265666F72656F70656E222C2066756E6374696F6E2028206576656E742C2075692029207B0D0A20202020202076617220726F7742746E203D20617065782E6A51756572792820222E666C6F772D696E7374616E63652D616374696F6E732D62746E';
wwv_flow_imp.g_varchar2_table(631) := '2E69732D6163746976652220293B0D0A202020202020766172206D656E754974656D73203D2075692E6D656E752E6974656D733B0D0A2020202020207661722070726373537461747573203D20726F7742746E2E64617461282022737461747573222029';
wwv_flow_imp.g_varchar2_table(632) := '3B0D0A20202020202076617220707263734964203D20726F7742746E2E61747472282022646174612D707263732220293B0D0A2020202020206D656E754974656D73203D206D656E754974656D732E6D6170282066756E6374696F6E2028206974656D20';
wwv_flow_imp.g_varchar2_table(633) := '29207B0D0A202020202020202069662028206974656D2E616374696F6E203D3D3D202273746172742D666C6F772D696E7374616E6365222029207B0D0A202020202020202020206974656D2E64697361626C6564203D207072637353746174757320213D';
wwv_flow_imp.g_varchar2_table(634) := '3D20226372656174656422203F2074727565203A2066616C73653B0D0A20202020202020207D0D0A202020202020202069662028206974656D2E616374696F6E203D3D3D202272657365742D666C6F772D696E7374616E6365222029207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(635) := '2020202020206974656D2E64697361626C6564203D207072637353746174757320213D3D20226372656174656422203F2066616C7365203A20747275653B0D0A20202020202020207D0D0A202020202020202069662028206974656D2E616374696F6E20';
wwv_flow_imp.g_varchar2_table(636) := '3D3D3D20227465726D696E6174652D666C6F772D696E7374616E6365222029207B0D0A202020202020202020206974656D2E64697361626C6564203D0D0A20202020202020202020202070726373537461747573203D3D3D202272756E6E696E6722207C';
wwv_flow_imp.g_varchar2_table(637) := '7C2070726373537461747573203D3D3D20226572726F7222203F2066616C7365203A20747275653B0D0A20202020202020207D0D0A202020202020202069662028206974656D2E616374696F6E203D3D3D2022646F776E6C6F61642D61732D7376672220';
wwv_flow_imp.g_varchar2_table(638) := '29207B0D0A202020202020202020206974656D2E64697361626C6564203D200D0A2020202020202020202070726373496420213D3D20617065782E6974656D28225031305F505243535F494422292E67657456616C75652829203F2074727565203A2066';
wwv_flow_imp.g_varchar2_table(639) := '616C73653B0D0A20202020202020207D0D0A202020202020202072657475726E206974656D3B0D0A2020202020207D20293B0D0A0D0A20202020202075692E6D656E752E6974656D73203D206D656E754974656D733B0D0A202020207D20293B0D0A0D0A';
wwv_flow_imp.g_varchar2_table(640) := '20207D20293B0D0A7D0D0A0D0A2F2A205574696C6974792066756E6374696F6E7320666F722076696577657220706C7567696E2064796E616D69632028636C69636B2920616374696F6E73202A2F0D0A0D0A66756E6374696F6E206368616E6765437572';
wwv_flow_imp.g_varchar2_table(641) := '736F72286F626A6563744C6973744974656D29207B0D0A20202F2F20676574206F626A656374206964732066726F6D2070616765206974656D0D0A2020766172206F626A65637473203D206F626A6563744C6973744974656D2E73706C697428273A2729';
wwv_flow_imp.g_varchar2_table(642) := '3B0D0A20202F2F206368616E676520637572736F7220746F20706F696E7465720D0A2020242E65616368286F626A656374732C2066756E6374696F6E2820696E6465782C2076616C75652029207B0D0A20202020242820225B646174612D656C656D656E';
wwv_flow_imp.g_varchar2_table(643) := '742D69643D2722202B2076616C7565202B2022275D22292E637373282022637572736F72222C2022706F696E7465722220293B0D0A20207D293B0D0A7D0D0A0D0A66756E6374696F6E20636C69636B436F6E646974696F6E286F626A6563744C69737449';
wwv_flow_imp.g_varchar2_table(644) := '74656D2C206576656E744461746129207B0D0A20202F2F206966206F626A6563742065786973747320696E206C6973740D0A2020696620286F626A6563744C6973744974656D2E73706C697428273A27292E696E636C75646573286576656E7444617461';
wwv_flow_imp.g_varchar2_table(645) := '2E656C656D656E742E6964292026260D0A2020202020202F2F2066696C746572206F75742063616C6C206163746976697479206472696C6C646F776E0D0A202020202020286576656E74446174612E656C656D656E742E7479706520213D202762706D6E';
wwv_flow_imp.g_varchar2_table(646) := '3A43616C6C416374697669747927207C7C0D0A2020202020202020286576656E74446174612E6F726967696E616C4576656E742E7461726765742E7461674E616D6520213D2027706174682720262620216576656E74446174612E6F726967696E616C45';
wwv_flow_imp.g_varchar2_table(647) := '76656E742E7461726765742E67657441747472696275746528277472616E73666F726D2729290D0A202020202020290D0A20202020292072657475726E20747275653B0D0A202072657475726E2066616C73653B0D0A7D0D0A0D0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(648) := '6F70656E4F626A6563744469616C6F67286F626A65637442706D6E49642C206F626A6563744E616D652C2063757272656E745061676529207B0D0A20202F2F20736574207469746C650D0A2020766172207469746C65203D206F626A65637442706D6E49';
wwv_flow_imp.g_varchar2_table(649) := '64202B20286F626A6563744E616D652E6C656E677468203E2030203F2027202D2027202B206F626A6563744E616D65203A202727293B0D0A20202F2F206F70656E20706167650D0A2020617065782E7365727665722E70726F63657373280D0A20202020';
wwv_flow_imp.g_varchar2_table(650) := '2020274745545F55524C272C2020202020202020202020202020202020202020202020202020200D0A2020202020207B0D0A202020202020202020207830313A206F626A65637442706D6E49642C0D0A202020202020202020207830323A207469746C65';
wwv_flow_imp.g_varchar2_table(651) := '2C0D0A20202020202020202020706167654974656D733A205B6050247B63757272656E74506167657D5F4C4F414445445F4449414752414D605D0D0A2020202020207D2C200D0A2020202020207B0D0A20202020202020202020737563636573733A2066';
wwv_flow_imp.g_varchar2_table(652) := '756E6374696F6E20287044617461290D0A202020202020202020207B20202020202020202020200D0A2020202020202020202020202020617065782E6E617669676174696F6E2E7265646972656374287044617461293B0D0A202020202020202020207D';
wwv_flow_imp.g_varchar2_table(653) := '2C0D0A2020202020202020202064617461547970653A202274657874222020202020202020202020202020202020202020200D0A2020202020207D0D0A2020293B0D0A7D0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(4701136124111997)
,p_file_name=>'js/flows4apex.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/js_flows4apex_js_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E6A73225D2C226E616D6573223A5B22696E6974417070222C2261706578222C226A5175657279222C2277696E646F77222C226F6E222C227468656D653432222C';
wwv_flow_imp.g_varchar2_table(2) := '227574696C222C22636F6E666967415045584D736773222C226175746F4469736D697373222C226475726174696F6E222C22616464436C6173736573546F506172656E7473222C227053656C6563746F72222C2270506172656E7453656C6563746F7222';
wwv_flow_imp.g_varchar2_table(3) := '2C2270436C6173736573222C22706172656E7473222C22616464436C617373222C226368696C6472656E417474726962757465546F4172726179222C22636F6E7461696E6572222C226368696C6472656E222C22617474726962757465222C2266696E64';
wwv_flow_imp.g_varchar2_table(4) := '222C226D6170222C226974656D222C2274686973222C2261747472222C22746F4172726179222C22676574666C6F77496E7374616E636544617461222C22616374696F6E222C22656C656D656E74222C22656C222C22756E646566696E6564222C227479';
wwv_flow_imp.g_varchar2_table(5) := '7065222C22636C6F73657374222C22783031222C22783032222C2267657442756C6B466C6F77496E7374616E636544617461222C22663031222C226765744D65737361676544617461222C22783033222C22783034222C22676574537562666C6F774461';
wwv_flow_imp.g_varchar2_table(6) := '7461222C2267657442756C6B537562666C6F7744617461222C22663032222C22663033222C226F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E74222C22636F6E6669726D4D6573736167654B6579222C227469746C654B6579222C2270';
wwv_flow_imp.g_varchar2_table(7) := '6167654964222C2267657456616C7565222C2273657456616C7565222C226C616E67222C226765744D657373616765222C227468656D65222C226F70656E526567696F6E222C22676574546F7041706578222C226469616C6F67222C22676574436F6E66';
wwv_flow_imp.g_varchar2_table(8) := '69726D436F6D6D656E74222C2273656E64546F536572766572222C2264617461546F53656E64222C226F7074696F6E73222C22736572766572222C2270726F63657373222C22646F6E65222C2264617461222C2273756363657373222C226D6573736167';
wwv_flow_imp.g_varchar2_table(9) := '654B6579222C226D657373616765222C2273686F775061676553756363657373222C224974656D73546F536574222C226973456D7074794F626A656374222C224F626A656374222C226B657973222C22666F7245616368222C226974656D4E616D65222C';
wwv_flow_imp.g_varchar2_table(10) := '2272656672657368526567696F6E222C226C656E677468222C226E616D65222C22726567696F6E222C2263757272656E74526F777350657250616765222C2261706578496E7465726163746976655265706F7274222C2263757272656E7450616765222C';
wwv_flow_imp.g_varchar2_table(11) := '2274657874222C2273706C6974222C227472696D222C225F706167696E617465222C2272656672657368222C2275726C222C227265646972656374222C226E617669676174696F6E222C2272656C6F616450616765222C226C6F636174696F6E222C2272';
wwv_flow_imp.g_varchar2_table(12) := '656C6F6164222C22636C6561724572726F7273222C2273686F774572726F7273222C22756E73616665222C226465627567222C226572726F72222C226661696C222C226A71584852222C2274657874537461747573222C226572726F725468726F776E22';
wwv_flow_imp.g_varchar2_table(13) := '2C22646F776E6C6F61644173535647222C226576656E74222C22726567696F6E4964222C2224222C22746172676574222C22676574535647222C227468656E222C22737667222C22737667426C6F62222C22426C6F62222C2266696C654E616D65222C22';
wwv_flow_imp.g_varchar2_table(14) := '44617465222C226E6F77222C22646F776E6C6F61644C696E6B222C22646F63756D656E74222C22637265617465456C656D656E74222C22646F776E6C6F6164222C2268726566222C2255524C222C226372656174654F626A65637455524C222C22636C69';
wwv_flow_imp.g_varchar2_table(15) := '636B222C227374617274466C6F77496E7374616E6365222C225031305F505243535F4944222C225031305F505243535F4E414D45222C2262756C6B5374617274466C6F77496E7374616E6365222C227265736574466C6F77496E7374616E6365222C2263';
wwv_flow_imp.g_varchar2_table(16) := '6C6F7365526567696F6E222C2262756C6B5265736574466C6F77496E7374616E6365222C227465726D696E617465466C6F77496E7374616E6365222C2262756C6B5465726D696E617465466C6F77496E7374616E6365222C2264656C657465466C6F7749';
wwv_flow_imp.g_varchar2_table(17) := '6E7374616E6365222C2262756C6B44656C657465466C6F77496E7374616E6365222C227265646972656374546F466C6F77496E7374616E63654175646974222C22706167654974656D73222C227265646972656374546F466C6F77496E7374616E636544';
wwv_flow_imp.g_varchar2_table(18) := '657461696C222C227265646972656374546F466C6F774469616772616D222C22696E6974566965776572222C22707263734964222C22707263734E616D65222C22646973706C617953657474696E67222C22666F726D61744D657373616765222C227265';
wwv_flow_imp.g_varchar2_table(19) := '646972656374546F4D6F6E69746F72222C226765745661726961626C654572726F7273222C226572726F7273222C226973456D707479222C2270757368222C22706167654974656D222C2276617254797065222C22676574476174657761794572726F72';
wwv_flow_imp.g_varchar2_table(20) := '73222C2261646450726F636573735661726961626C65222C22666F637573456C656D656E74222C2267617465776179526F757465222C226469616C6F674964222C22783036222C2273656C6563744F7074696F6E222C22726F757465222C226A6F696E22';
wwv_flow_imp.g_varchar2_table(21) := '2C22783035222C226368756E6B6564436C6F62222C226368756E6B222C224172726179222C2269734172726179222C22656E61626C65222C2268696465222C2273686F77222C2275706461746550726F636573735661726961626C65222C227661724E61';
wwv_flow_imp.g_varchar2_table(22) := '6D65222C2276617253636F7065222C2273657454696D656F7574222C227663325F76616C7565222C2264697361626C65222C22736574466F637573222C226E756D5F76616C7565222C22646174655F76616C7565222C227473747A5F76616C7565222C22';
wwv_flow_imp.g_varchar2_table(23) := '636C6F625F76616C7565222C22636F6E736F6C65222C226C6F67222C2264656C65746550726F636573735661726961626C65222C22636F6E6669726D222C226F6B50726573736564222C2262756C6B44656C65746550726F636573735661726961626C65';
wwv_flow_imp.g_varchar2_table(24) := '222C22636F6D706C65746553746570222C2262756C6B436F6D706C65746553746570222C227265737461727453746570222C2262756C6B5265737461727453746570222C226F70656E5265736572766174696F6E4469616C6F67222C2272657365727665';
wwv_flow_imp.g_varchar2_table(25) := '53746570222C2262756C6B5265736572766553746570222C2272656C6561736553746570222C2262756C6B52656C6561736553746570222C2272657363686564756C6554696D6572222C22783037222C226F70656E52657363686564756C6554696D6572';
wwv_flow_imp.g_varchar2_table(26) := '4469616C6F67222C2262756C6B52657363686564756C6554696D6572222C22726563656976654D657373616765222C226F70656E526563656976654D6573736167654469616C6F67222C226D61726B417343757272656E74222C2270726F63657373526F';
wwv_flow_imp.g_varchar2_table(27) := '7773222C2263757272656E7453656C6563746F72222C2263757272656E74526F77222C22686173222C2272656D6F7665436C617373222C22706172656E74222C2272656672657368566965776572222C2276696577466C6F77496E7374616E6365222C22';
wwv_flow_imp.g_varchar2_table(28) := '73656C656374656450726F63657373222C2263757272656E744E616D65222C22696E6974416374696F6E73222C22616374696F6E73222C22616464222C226467726D4964222C22676574222C22736574222C2276616C7565222C22617070656E64546F22';
wwv_flow_imp.g_varchar2_table(29) := '2C2263686F69636573222C226C6F6F6B7570222C226C6162656C222C2263222C2269222C22757064617465222C22696E69745061676532222C226166746572222C2265616368222C227569222C226D656E754974656D73222C226D656E75222C22697465';
wwv_flow_imp.g_varchar2_table(30) := '6D73222C2264697361626C6564222C22696E69745061676533222C22696E69745061676534222C2262696E64222C226374726C4B6579222C226D6574614B6579222C22537472696E67222C2266726F6D43686172436F6465222C227768696368222C2274';
wwv_flow_imp.g_varchar2_table(31) := '6F4C6F77657243617365222C2270726576656E7444656661756C74222C2273617665222C22696E69745061676537222C226467726D537461747573222C22656E67696E654170704D6F6465222C22696E69745061676538222C2270726373537461747573';
wwv_flow_imp.g_varchar2_table(32) := '222C22726F7742746E222C227362666C537461747573222C22737562666C5265736572766174696F6E222C22696E6974506167653130222C226368616E6765437572736F72222C226F626A6563744C6973744974656D222C226F626A65637473222C2269';
wwv_flow_imp.g_varchar2_table(33) := '6E646578222C22637373222C22636C69636B436F6E646974696F6E222C226576656E7444617461222C22696E636C75646573222C226964222C226F726967696E616C4576656E74222C227461674E616D65222C22676574417474726962757465222C226F';
wwv_flow_imp.g_varchar2_table(34) := '70656E4F626A6563744469616C6F67222C226F626A65637442706D6E4964222C226F626A6563744E616D65222C227469746C65222C227044617461222C226461746154797065225D2C226D617070696E6773223A22414141412C53414153412C55414350';
wwv_flow_imp.g_varchar2_table(35) := '432C4B41414B432C4F414151432C51414153432C474141492C6742414167422C5741437843482C4B41414B492C51414151432C4B41414B432C65414167422C4341436843432C614141612C45414362432C534141552C53414B68422C53414153432C6F42';
wwv_flow_imp.g_varchar2_table(36) := '41416F42432C45414157432C4541416942432C47414376445A2C4B414347432C4F414151532C47414352472C51414153462C47414354472C53414155462C474147662C53414153472C794241417942432C45414157432C45414155432C47414372442C4F';
wwv_flow_imp.g_varchar2_table(37) := '41414F6C422C4B414347432C4F41414F652C47414350472C4B41414B462C4741434C472C4B41414B2C53414157432C474143662C4F41414F72422C4B41414B432C4F41415171422C4D41414F432C4B41414D4C2C4D41456C434D2C5541475A2C53414153';
wwv_flow_imp.g_varchar2_table(38) := '432C6F4241416F42432C45414151432C4741436E432C49414149432C4541414B442C454149542C5941486942452C4941415A442C45414147452C4D41416B432C5741415A462C45414147452C4F41432F42462C4541414B35422C4B41414B432C4F41414F';
wwv_flow_imp.g_varchar2_table(39) := '30422C47414153492C514141512C57414537422C4341434C432C4941414F4E2C454143504F2C4941414F6A432C4B41414B432C4F41415132422C4741414B4C2C4B41414B2C6341496C432C53414153572C774241417742522C4741432F422C4D41414F2C';
wwv_flow_imp.g_varchar2_table(40) := '4341434C4D2C4941414F4E2C45414350532C4941414F70422C7942414130422C7743414179432C3442414136422C63414933472C5341415371422C65414165562C45414151432C47414339422C49414149432C4541414B442C454149542C594148694245';
wwv_flow_imp.g_varchar2_table(41) := '2C4941415A442C45414147452C4D41416B432C5741415A462C45414147452C4F41432F42462C4541414B35422C4B41414B432C4F41414F30422C47414153492C514141512C57414537422C4341434C432C4941414F4E2C454143504F2C4941414F6A432C';
wwv_flow_imp.g_varchar2_table(42) := '4B41414B432C4F41415132422C4741414B4C2C4B41414B2C674241433942632C4941414F72432C4B41414B432C4F41415132422C4741414B4C2C4B41414B2C5941433942652C4941414F74432C4B41414B432C4F41415132422C4741414B4C2C4B41414B';
wwv_flow_imp.g_varchar2_table(43) := '2C6541496C432C5341415367422C65414165622C45414151432C47414339422C49414149432C4541414B442C454149542C5941486942452C4941415A442C45414147452C4D41416B432C5741415A462C45414147452C4F41432F42462C4541414B35422C';
wwv_flow_imp.g_varchar2_table(44) := '4B41414B432C4F41414F30422C47414153492C514141512C57414537422C4341434C432C4941414F4E2C454143504F2C4941414F6A432C4B41414B432C4F41415132422C4741414B4C2C4B41414B2C6141433942632C4941414F72432C4B41414B432C4F';
wwv_flow_imp.g_varchar2_table(45) := '41415132422C4741414B4C2C4B41414B2C6141433942652C4941414F74432C4B41414B432C4F41415132422C4741414B4C2C4B41414B2C6141496C432C5341415369422C6D4241416D42642C47414331422C4D41414F2C4341434C4D2C4941414F4E2C45';
wwv_flow_imp.g_varchar2_table(46) := '414350532C4941414F70422C7942414130422C6B4341416D432C3442414136422C6141436A4730422C4941414F31422C7942414130422C6B4341416D432C3442414136422C5341436A4732422C4941414F33422C7942414130422C6B4341416D432C3442';
wwv_flow_imp.g_varchar2_table(47) := '414136422C61414972472C5341415334422C3442414136426A422C45414151432C4541415369422C4541416D42432C47414378452C494141496A422C4541414B442C4F414351452C4941415A442C45414147452C4D41416B432C5741415A462C45414147';
wwv_flow_imp.g_varchar2_table(48) := '452C4F41432F42462C4541414B35422C4B41414B432C4F41414F30422C47414153492C514141512C57414570432C49414149652C4541415339432C4B41414B71422C4B41414B2C6541416530422C57414374432F432C4B41414B71422C4B41414D2C4941';
wwv_flow_imp.g_varchar2_table(49) := '414D79422C454141532C59414161452C534141552C4941436A4468442C4B41414B71422C4B41414D2C4941414D79422C454141532C694241416B42452C5341415568442C4B41414B69442C4B41414B432C574141594E2C494143354535432C4B41414B43';
wwv_flow_imp.g_varchar2_table(50) := '2C4F4141512C67424141694273422C4B41414D2C63414165472C4741436E4431422C4B414347432C4F4141512C674241435273422C4B41414D2C5941416176422C4B41414B432C4F41415132422C4741414B4C2C4B41414D2C634143394376422C4B4143';
wwv_flow_imp.g_varchar2_table(51) := '47432C4F4141512C674241435273422C4B41414D2C5941416176422C4B41414B432C4F41415132422C4741414B4C2C4B41414D2C634143394376422C4B414347432C4F4141512C674241435273422C4B41414D2C5741415976422C4B41414B432C4F4141';
wwv_flow_imp.g_varchar2_table(52) := '5132422C4741414B4C2C4B41414D2C614143374376422C4B414347432C4F4141512C674241435273422C4B41414D2C5941416176422C4B41414B432C4F41415132422C4741414B4C2C4B41414D2C634143394376422C4B41414B6D442C4D41414D432C57';
wwv_flow_imp.g_varchar2_table(53) := '4141592C30424143764270442C4B41414B4B2C4B41414B67442C6141416170442C4F41414F2C73424141734238422C514141512C73424141734275422C4F41414F2C534141552C5141415374442C4B41414B69442C4B41414B432C574141594C2C494147';
wwv_flow_imp.g_varchar2_table(54) := '70492C53414153552C6F424143502C49414149542C4541415339432C4B41414B71422C4B41414B2C6541416530422C57414374432C4F41414F2F432C4B41414B71422C4B41414D2C4941414D79422C454141532C59414161432C57414768442C53414153';
wwv_flow_imp.g_varchar2_table(55) := '532C61414161432C45414159432C454141552C494143374231442C4B41414B32442C4F41414F432C514141532C6541416742482C4741452F43492C4D41414D2C53414157432C47414356412C4541414B432C634167426D426C432C494141764236422C45';
wwv_flow_imp.g_varchar2_table(56) := '4141514D2C5941435868452C4B41414B69452C51414151432C6742414169426C452C4B41414B69442C4B41414B432C57414159512C454141514D2C6B4241456E436E432C494141764236422C45414151532C61414138452C4941416C446E452C4B41414B';
wwv_flow_imp.g_varchar2_table(57) := '432C4F41414F6D452C63414163562C45414151532C6141437845452C4F41414F432C4B41414B5A2C45414151532C59414159492C534141512C53414153432C4741432F4378452C4B41414B71422C4B41414B6D442C4741415578422C53414153552C4541';
wwv_flow_imp.g_varchar2_table(58) := '4151532C574141574B2C594147724233432C494141314236422C45414151652C6541412B42662C45414151652C63414163432C4F4141532C4741437A4568422C45414151652C63414163462C534141512C53414153492C47414372432C4741412B422C73';
wwv_flow_imp.g_varchar2_table(59) := '424141334233452C4B41414B34452C4F41414F442C4741414D37432C4B414138422C4341436C442C494141492B432C454141714237452C4B41414B432C4F41414F2C4941414D30452C4541414F2C4F41414F622C4F41414F67422C73424141734270422C';
wwv_flow_imp.g_varchar2_table(60) := '514141516D422C6D4241433146452C454141632F452C4B41414B432C4F41414F2C4941414D30452C4541414D2C3442414134424B2C4F41414F432C4D41414D2C4B41414B2C47414147432C4F414333466C462C4B41414B432C4F41414F2C4941414D3045';
wwv_flow_imp.g_varchar2_table(61) := '2C4541414F2C4F41414F622C4F41414F67422C7342414173424B2C554141552C65414169424A2C454141632C59414163462C45414171422C674241416B42412C514145334A37452C4B41414B34452C4F41414F442C4741414D532C6B4241494E76442C49';
wwv_flow_imp.g_varchar2_table(62) := '41416269432C4541414B75422C4D414130432C494141724233422C4541415134422C554143724374462C4B41414B75462C57414157442C5341415578422C4541414B75422C5741454878442C494141764236422C4541415138422C594141344239422C45';
wwv_flow_imp.g_varchar2_table(63) := '41415138422C69424141734333442C494141704269432C4541414B30422C594141344231422C4541414B30422C6141437A4774462C4F41414F75462C53414153432C654174434737442C4941416A4269432C4541414B472C53414130432C4F41416A4248';
wwv_flow_imp.g_varchar2_table(64) := '2C4541414B472C53414372436A452C4B41414B69452C5141415130422C6341456233462C4B41414B69452C5141415132422C574141572C43414370422C4341434939442C4B4141592C5141435A32442C534141592C4F41435A78422C51414159482C4541';
wwv_flow_imp.g_varchar2_table(65) := '414B472C5141436A4234422C514141592C4D4149704237462C4B41414B38462C4D41414D432C4D41414F2C38424138427642432C4D41414D2C53414157432C4541414F432C45414159432C4741436E436E472C4B41414B38462C4D41414D432C4D41414F';
wwv_flow_imp.g_varchar2_table(66) := '2C674241416942452C4541414F432C45414159432C4D414935442C53414153432C63414163432C47414372422C49414149432C45414157432C45414145462C4541414D472C5141415133462C514141512C61414161552C4B41414B2C4D41437A4476422C';
wwv_flow_imp.g_varchar2_table(67) := '4B41434734452C4F41415130422C47414352472C53414341432C4D414151432C494143502C49414149432C454141552C49414149432C4B41414D2C43414143462C4741414D2C434143374237452C4B41414D2C6B4241454A67462C45414157432C4B4141';
wwv_flow_imp.g_varchar2_table(68) := '4B432C4D41456842432C45414165432C53414153432C634141652C4B41433343462C45414161472C534141574E2C4541437842472C45414161492C4B41414F6E482C4F41414F6F482C49414149432C674241416942582C47414368444B2C454141614F2C';
wwv_flow_imp.g_varchar2_table(69) := '5741496E422C53414153432C6B4241416D422F462C45414151432C4741436C432C494141496D432C4541414F72432C6F4241416F42432C45414151432C4741436E432B422C454141552C43414364412C57414171422C774241437242412C454141513842';
wwv_flow_imp.g_varchar2_table(70) := '2C57414171442C4D4141784378462C4B41414B71422C4B41414B2C6541416530422C5741433943572C45414151652C63414177442C4D414178437A452C4B41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C434141432C69424141';
wwv_flow_imp.g_varchar2_table(71) := '6B422C674241433946572C45414151532C57414171442C4D414178436E452C4B41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C4341414332452C5941416535442C4541414B37422C4941414B30462C634141694233482C4B4141';
wwv_flow_imp.g_varchar2_table(72) := '4B432C4F41415130422C474141554A2C4B41414B2C6341432F4969432C614141614D2C4541414D4A2C47414772422C534141536B452C7342414175426C472C47414339422C4941434967432C454141552C43414364412C57414171422C75424143724241';
wwv_flow_imp.g_varchar2_table(73) := '2C63414177422C434141432C694241416B422C694241433343462C61414A5774422C774241417742522C474149684267432C47414772422C534141536D452C6B4241416B426E472C45414151432C4741436A432C4741414B33422C4B41414B432C4F4141';
wwv_flow_imp.g_varchar2_table(74) := '512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414968452C4541414F72432C6F4241416F42432C45414151432C47414376436D432C4541414B7A422C4941';
wwv_flow_imp.g_varchar2_table(75) := '414D6B422C6F424145582C49414149472C454141552C43414364412C57414171422C734241437242412C4541415138422C57414171442C4D4141784378462C4B41414B71422C4B41414B2C6541416530422C5741433943572C45414151652C6341417744';
wwv_flow_imp.g_varchar2_table(76) := '2C4D414178437A452C4B41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C434141432C694241416B422C674241433946572C45414151532C57414171442C4D414178436E452C4B41414B71422C4B41414B2C6541416530422C5741';
wwv_flow_imp.g_varchar2_table(77) := '4171422C4741414B2C4341414332452C5941416535442C4541414B37422C4941414B30462C634141694233482C4B41414B432C4F41415130422C474141554A2C4B41414B2C6341432F4969432C614141614D2C4541414D4A2C5141456E42662C34424141';
wwv_flow_imp.g_varchar2_table(78) := '36426A422C45414151432C454141532C3642414138422C7342414968462C534141536F472C73424141734272472C45414151432C47414372432C4741414B33422C4B41414B432C4F4141512C32424141344271442C4F4141512C554141612C4341436A45';
wwv_flow_imp.g_varchar2_table(79) := '74442C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414968452C4541414F35422C774241417742522C4741436E436F432C4541414B37422C4941414D73422C6F424145582C49414149472C454141552C43414364412C57414171';
wwv_flow_imp.g_varchar2_table(80) := '422C714241437242412C63414177422C434141432C694241416B422C694241433343462C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C45414151432C454141532C3642414138422C7342414968462C5341415371472C73424141';
wwv_flow_imp.g_varchar2_table(81) := '734274472C45414151432C47414372432C4741414B33422C4B41414B432C4F4141512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414968452C4541414F72';
wwv_flow_imp.g_varchar2_table(82) := '432C6F4241416F42432C45414151432C47414376436D432C4541414B7A422C4941414D6B422C6F424145582C49414149472C454141552C43414364412C57414171422C324241437242412C4541415138422C57414171442C4D4141784378462C4B41414B';
wwv_flow_imp.g_varchar2_table(83) := '71422C4B41414B2C6541416530422C5741433943572C45414151652C63414177442C4D414178437A452C4B41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C434141432C694241416B422C674241433946572C45414151532C5741';
wwv_flow_imp.g_varchar2_table(84) := '4171442C4D414178436E452C4B41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C4341414332452C5941416535442C4541414B37422C4941414B30462C634141694233482C4B41414B432C4F41415130422C474141554A2C4B4141';
wwv_flow_imp.g_varchar2_table(85) := '4B2C6341432F4969432C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C45414151432C454141532C694341416B432C3042414970462C5341415373472C30424141304276472C45414151432C4741437A432C4741414B33422C4B41';
wwv_flow_imp.g_varchar2_table(86) := '414B432C4F4141512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414968452C4541414F35422C774241417742522C4741436E436F432C4541414B37422C49';
wwv_flow_imp.g_varchar2_table(87) := '41414D73422C6F424145582C49414149472C454141552C43414364412C57414171422C304241437242412C63414177422C434141432C694241416B422C694241433343462C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C454141';
wwv_flow_imp.g_varchar2_table(88) := '51432C454141532C694341416B432C3042414970462C5341415375472C6D4241416F4278472C45414151432C4741436E432C4741414B33422C4B41414B432C4F4141512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D';
wwv_flow_imp.g_varchar2_table(89) := '442C4D41414D32452C594141612C3042414378422C4941414968452C4541414F72432C6F4241416F42432C45414151432C47414376436D432C4541414B7A422C4941414D6B422C6F424145582C49414149472C454141552C43414364412C57414171422C';
wwv_flow_imp.g_varchar2_table(90) := '774241437242412C45414151652C63414177442C4F414178437A452C4B41414B71422C4B41414B2C6541416530422C57414173422C434141432C694241416B422C674241416B422C4741433547572C45414151532C57414171442C4D414178436E452C4B';
wwv_flow_imp.g_varchar2_table(91) := '41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C4341414332452C594141652C47414149432C63414169422C49414337476A452C4541415134422C5341416D442C4F4141784374462C4B41414B71422C4B41414B2C654141653042';
wwv_flow_imp.g_varchar2_table(92) := '2C5741433543532C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C45414151432C454141532C384241412B422C754241496A462C5341415377472C7542414177427A472C45414151432C47414376432C4741414B33422C4B41414B';
wwv_flow_imp.g_varchar2_table(93) := '432C4F4141512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414968452C4541414F35422C774241417742522C4741436E436F432C4541414B37422C494141';
wwv_flow_imp.g_varchar2_table(94) := '4D73422C6F424145582C49414149472C454141552C43414364412C57414171422C754241437242412C63414177422C434141432C694241416B422C694241433343462C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C4541415143';
wwv_flow_imp.g_varchar2_table(95) := '2C454141532C384241412B422C754241496A462C5341415379472C34424141364231472C45414151432C47414335432C494141496D432C4541414F72432C6F4241416F42432C45414151432C47414376436D432C4541414B7A422C4941414D72432C4B41';
wwv_flow_imp.g_varchar2_table(96) := '414B432C4F41415130422C474141554A2C4B41414B2C6141434D2C4F4141784376422C4B41414B71422C4B41414B2C6541416530422C61414335422F432C4B41414B71422C4B41414B2C6541416532422C53414153632C4541414B37422C4B414376436A';
wwv_flow_imp.g_varchar2_table(97) := '432C4B41414B71422C4B41414B2C69424141694232422C53414155632C4541414B7A422C4B4143314379422C4541414B75452C554141592C434141432C634141652C6B4241456E432C4941414933452C454141552C47414364412C45414151652C634141';
wwv_flow_imp.g_varchar2_table(98) := '77442C4D414178437A452C4B41414B71422C4B41414B2C6541416530422C57414171422C4741414B2C434141432C694241416B422C674241433946532C614141614D2C4541414D4A2C47414772422C5341415334452C36424141384235472C4541415143';
wwv_flow_imp.g_varchar2_table(99) := '2C47414337432C494141496D432C4541414F72432C6F4241416F42432C45414151432C474143764333422C4B41414B71422C4B41414B2C6541416532422C53414153632C4541414B37422C4B414376436A432C4B41414B71422C4B41414B2C6942414169';
wwv_flow_imp.g_varchar2_table(100) := '4232422C5341415568442C4B41414B432C4F41415130422C474141554A2C4B41414B2C6341436A4575432C4541414B75452C554141592C434141432C634141652C694241436A4337452C614141614D2C474147662C5341415379452C7342414175423747';
wwv_flow_imp.g_varchar2_table(101) := '2C45414151432C47414374432C494141496D432C4541414F72432C6F4241416F42432C45414151432C47414376436D432C4541414B37422C4941414D6A432C4B41414B432C4F41415130422C474141554A2C4B41414B2C614143764369432C614141614D';
wwv_flow_imp.g_varchar2_table(102) := '2C474147662C5341415330452C57414159432C45414151432C45414155432C47414370422C4B414162442C4541434131492C4B41414B432C4F4141512C7942414130422B452C4B41414D68462C4B41414B69442C4B41414B32462C634141632C6F434141';
wwv_flow_imp.g_varchar2_table(103) := '7143462C4941457A4731492C4B41414B432C4F4141512C7942414130422B452C4B41414D68462C4B41414B69442C4B41414B432C574141572C6743414576442C4B41415875462C4741416F432C5741416E42452C4741437042452C6B4241416B424A2C47';
wwv_flow_imp.g_varchar2_table(104) := '414974422C53414153492C6B4241416B424A2C4741437A422C4941414933452C4541414F2C43414358412C494141572C7342414358412C4541414B37422C4941414D77472C454143586A462C614141614D2C474147662C5341415367462C6F424143502C';
wwv_flow_imp.g_varchar2_table(105) := '49414149432C454141532C474163622C47415A4B2F492C4B41414B71422C4B41414B2C6F4241416F4232482C5741436A43442C4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C5341';
wwv_flow_imp.g_varchar2_table(106) := '41592C6D4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C2B4241436C4332432C514141592C49414B6237462C4B41414B71422C4B41414B2C6F4241416F4232482C5541436A43442C4541414F452C4B41434C2C43414345';
wwv_flow_imp.g_varchar2_table(107) := '6E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C6D4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C2B4241436C4332432C514141592C514147582C4341434C2C494141497344';
wwv_flow_imp.g_varchar2_table(108) := '2C454141556E4A2C4B41414B71422C4B41414B2C6F4241416F4230422C57414333422C6141415A6F472C454143456E4A2C4B41414B71422C4B41414B2C6D4241416D4232482C5741436843442C4541414F452C4B41434C2C434143456E482C4B4141592C';
wwv_flow_imp.g_varchar2_table(109) := '5141435A32442C534141592C434141452C5541436479442C534141592C6B4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C674341436C4332432C514141592C494149492C5741415A73442C4541434C6E4A2C4B41414B71';
wwv_flow_imp.g_varchar2_table(110) := '422C4B41414B2C6D4241416D4232482C5541436843442C4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C6B4241435A6A462C514141596A452C4B41414B69442C4B4141';
wwv_flow_imp.g_varchar2_table(111) := '4B432C574141592C674341436C4332432C514141592C49414975432C4D41416C4437462C4B41414B71422C4B41414B2C79424141794230422C594143744367472C4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C';
wwv_flow_imp.g_varchar2_table(112) := '434141452C5541436479442C534141592C6B4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C6D4341436C4332432C514141592C49414B452C5341415A73442C4541434C6E4A2C4B41414B71422C4B41414B2C6F4241416F';
wwv_flow_imp.g_varchar2_table(113) := '4232482C5541436A43442C4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C6D4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C67434143';
wwv_flow_imp.g_varchar2_table(114) := '6C4332432C514141592C49414736432C4D41416E4437462C4B41414B71422C4B41414B2C30424141304230422C594143394367472C4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C';
wwv_flow_imp.g_varchar2_table(115) := '534141592C6D4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C6B4341436C4332432C514141592C494149492C364241415A73442C4541434C6E4A2C4B41414B71422C4B41414B2C6F4241416F4232482C5541436A43442C';
wwv_flow_imp.g_varchar2_table(116) := '4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C6D4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C674341436C4332432C514141592C49';
wwv_flow_imp.g_varchar2_table(117) := '414736432C4D41416E4437462C4B41414B71422C4B41414B2C30424141304230422C594143394367472C4541414F452C4B41434C2C434143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C6D4241435A6A';
wwv_flow_imp.g_varchar2_table(118) := '462C514141596A452C4B41414B69442C4B41414B432C574141592C6B4341436C4332432C514141592C494149492C5341415A73442C4741434C6E4A2C4B41414B71422C4B41414B2C6F4241416F4232482C5741436A43442C4541414F452C4B41434C2C43';
wwv_flow_imp.g_varchar2_table(119) := '4143456E482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C6D4241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C674341436C4332432C514141592C49414D74422C4F41414F6B442C';
wwv_flow_imp.g_varchar2_table(120) := '454147542C534141534B2C6D424143502C494141494C2C454141532C47417742622C4D41744269442C57414137432F492C4B41414B71422C4B41414B2C6F4241416F4230422C59414132422F432C4B41414B71422C4B41414B2C69424141694230422C57';
wwv_flow_imp.g_varchar2_table(121) := '41415732422C4F4141532C494143784771452C454141532C4341434C2C434143496A482C4B4141592C5141435A32442C534141592C434141452C5541436479442C534141592C674241435A6A462C514141596A452C4B41414B69442C4B41414B432C5741';
wwv_flow_imp.g_varchar2_table(122) := '41592C754341436C4332432C514141592C4B414936422C4941416A4437462C4B41414B71422C4B41414B2C69424141694230422C5741415732422C534143744371452C454141532C4341434C2C434143496A482C4B4141592C5141435A32442C53414159';
wwv_flow_imp.g_varchar2_table(123) := '2C434141452C5541436479442C534141592C674241435A6A462C514141596A452C4B41414B69442C4B41414B432C574141592C6F4341436C4332432C514141592C4B41496A426B442C454147542C534141534D2C6D4241416D4233482C4541415134482C';
wwv_flow_imp.g_varchar2_table(124) := '4741436C432C4941414931482C4541414B30482C4F4143517A482C4941415A442C45414147452C4D41416B432C5741415A462C45414147452C4F41432F42462C4541414B35422C4B41414B432C4F41414F714A2C4741416376482C514141512C5741457A';
wwv_flow_imp.g_varchar2_table(125) := '432C4941414977482C45414138442C5341412F43764A2C4B41414B432C4F41414F32422C474141494C2C4B41414B2C73424143704369492C45414157442C454141652C6D42414171422C6B4241456E442C4741414B764A2C4B41414B432C4F4141512C49';
wwv_flow_imp.g_varchar2_table(126) := '41414D754A2C474141576C472C4F4141512C554141612C43414374442C4941414979462C45414153512C45414165482C6D42414171424E2C6F4241436A442C47414175422C4941416C42432C4541414F72452C4F4141652C4341437A4231452C4B41414B';
wwv_flow_imp.g_varchar2_table(127) := '6D442C4D41414D32452C5941416130422C47414578422C4941414931462C4541414F2C474141494A2C454141552C4741497A422C47414841492C4541414B39422C4941414D4E2C454143586F432C4541414B37422C4941414D6A432C4B41414B71422C4B';
wwv_flow_imp.g_varchar2_table(128) := '41414B2C6341416330422C5741436E43652C4541414B32462C4941414D7A4A2C4B41414B71422C4B41414B2C69424141694230422C5741436A4377472C454141652C4341436C427A462C4541414B7A422C4941414D72432C4B41414B71422C4B41414B2C';
wwv_flow_imp.g_varchar2_table(129) := '6341416330422C574141612C5341436844652C4541414B78422C4941414D2C574143582C494141496F482C45414165314A2C4B41414B71422C4B41414B2C6F4241416F4230422C574143374334472C45414179422C5741416A42442C4541413442314A2C';
wwv_flow_imp.g_varchar2_table(130) := '4B41414B71422C4B41414B2C69424141694230422C574141612F432C4B41414B71422C4B41414B2C69424141694230422C5741415736472C4B41414B2C4B4143334839462C4541414B2B462C4941414D482C45414165432C4F414931422C474146413746';
wwv_flow_imp.g_varchar2_table(131) := '2C4541414B7A422C4941414D72432C4B41414B71422C4B41414B2C6F4241416F4230422C5741437A43652C4541414B78422C4941414D74432C4B41414B71422C4B41414B2C6F4241416F4230422C57414376422C61414162652C4541414B78422C494143';
wwv_flow_imp.g_varchar2_table(132) := '5277422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6D4241416D4230422C674241436E432C4741416B422C57414162652C4541414B78422C4941436677422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6D42';
wwv_flow_imp.g_varchar2_table(133) := '41416D4230422C674241436E432C4741416B422C53414162652C4541414B78422C4941436677422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6F4241416F4230422C6742414370432C4741416B422C3642414162652C4541414B78';
wwv_flow_imp.g_varchar2_table(134) := '422C4941436677422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6F4241416F4230422C6742414370432C4741416B422C53414162652C4541414B78422C49414169422C43414368432C4941414977482C45414163394A2C4B41414B';
wwv_flow_imp.g_varchar2_table(135) := '32442C4F41414F6F472C4D41414D2F4A2C4B41414B71422C4B41414B2C6F4241416F4230422C594143354469482C4D41414D432C51414153482C4B41436E42412C454141632C43414143412C4941456A4268472C4541414B33422C4941414D32482C4541';
wwv_flow_imp.g_varchar2_table(136) := '4B6670472C454141514D2C574141612C3642414372424E2C45414151652C63414167422C434141432C714241457A426A422C614141614D2C4541414D4A2C5141456E4231442C4B41414B69452C5141415130422C6341436233462C4B41414B69452C5141';
wwv_flow_imp.g_varchar2_table(137) := '415132422C574141596D442C5141477642512C47414346764A2C4B41414B71422C4B41414D2C6341416532422C534141552C494143704368442C4B41414B71422C4B41414B2C6341416336492C53414378426C4B2C4B41414B71422C4B41414D2C694241';
wwv_flow_imp.g_varchar2_table(138) := '416B4232422C534141552C494143764368442C4B41414B432C4F4141512C694241416B426B4B2C4F41432F426E4B2C4B41414B432C4F4141512C65414167426B4B2C4F414337426E4B2C4B41414B432C4F4141512C3242414134426D4B2C4F41437A4370';
wwv_flow_imp.g_varchar2_table(139) := '4B2C4B41414B432C4F4141512C3442414136426B4B2C53414531436E4B2C4B41414B71422C4B41414D2C6D424141714232422C574143684368442C4B41414B71422C4B41414D2C6D424141714232422C574143684368442C4B41414B71422C4B41414D2C';
wwv_flow_imp.g_varchar2_table(140) := '6F424141714232422C574143684368442C4B41414B71422C4B41414D2C6F424141714232422C574143684368442C4B41414B71422C4B41414D2C6F424141714232422C574143684368442C4B41414B71422C4B41414D2C6F424141714236492C53414368';
wwv_flow_imp.g_varchar2_table(141) := '436C4B2C4B41414B71422C4B41414D2C6F424141714232422C534141532C5941437A4368442C4B41414B71422C4B41414D2C6F424141714236492C53414368436C4B2C4B41414B71422C4B41414D2C69424141714232422C534141532C4B41437A436844';
wwv_flow_imp.g_varchar2_table(142) := '2C4B41414B71422C4B41414D2C69424141714236492C53414368436C4B2C4B41414B432C4F4141512C7142414173426D4B2C4F41436E43704B2C4B41414B432C4F4141512C7342414175426B4B2C51414574436E4B2C4B41414B69452C5141415130422C';
wwv_flow_imp.g_varchar2_table(143) := '6341436233462C4B41414B6D442C4D41414D432C574141596F472C47414933422C53414153612C73424141734233492C4541415134482C47414372432C4941414931482C4541414B30482C4F4143517A482C4941415A442C45414147452C4D41416B432C';
wwv_flow_imp.g_varchar2_table(144) := '5741415A462C45414147452C4F41432F42462C4541414B35422C4B41414B432C4F41414F714A2C4741416376482C514141512C5741457A432C4941414977482C45414138442C5341412F43764A2C4B41414B432C4F41414F32422C474141494C2C4B4141';
wwv_flow_imp.g_varchar2_table(145) := '4B2C73424143704369492C45414157442C454141652C6D42414171422C6B4241456E442C4741414B764A2C4B41414B432C4F4141512C4941414D754A2C474141576C472C4F4141512C554141612C43414374442C4941414979462C45414153512C454141';
wwv_flow_imp.g_varchar2_table(146) := '65482C6D42414171424E2C6F4241436A442C47414175422C4941416C42432C4541414F72452C4F4141652C4341437A4231452C4B41414B6D442C4D41414D32452C5941416130422C47414578422C4941414931462C4541414F2C474141494A2C45414155';
wwv_flow_imp.g_varchar2_table(147) := '2C4741497A422C47414841492C4541414B39422C4941414D4E2C454143586F432C4541414B37422C4941414D6A432C4B41414B71422C4B41414B2C6341416330422C5741436E43652C4541414B32462C4941414D7A4A2C4B41414B71422C4B41414B2C69';
wwv_flow_imp.g_varchar2_table(148) := '424141694230422C5741436A4377472C454141652C4341436C427A462C4541414B7A422C4941414D72432C4B41414B71422C4B41414B2C6341416330422C574141612C5341436844652C4541414B78422C4941414D2C574143582C494141496F482C4541';
wwv_flow_imp.g_varchar2_table(149) := '4165314A2C4B41414B71422C4B41414B2C6F4241416F4230422C574143374334472C45414179422C5741416A42442C4541413442314A2C4B41414B71422C4B41414B2C69424141694230422C574141612F432C4B41414B71422C4B41414B2C6942414169';
wwv_flow_imp.g_varchar2_table(150) := '4230422C5741415736472C4B41414B2C4B4143334839462C4541414B2B462C4941414D482C45414165432C4F414931422C4741464137462C4541414B7A422C4941414D72432C4B41414B71422C4B41414B2C6F4241416F4230422C5741437A43652C4541';
wwv_flow_imp.g_varchar2_table(151) := '414B78422C4941414D74432C4B41414B71422C4B41414B2C6F4241416F4230422C57414376422C61414162652C4541414B78422C4941435277422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6D4241416D4230422C674241436E43';
wwv_flow_imp.g_varchar2_table(152) := '2C4741416B422C57414162652C4541414B78422C4941436677422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6D4241416D4230422C674241436E432C4741416B422C53414162652C4541414B78422C4941436677422C4541414B2B';
wwv_flow_imp.g_varchar2_table(153) := '462C4941414D374A2C4B41414B71422C4B41414B2C6F4241416F4230422C6742414370432C4741416B422C3642414162652C4541414B78422C4941436677422C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6F4241416F4230422C67';
wwv_flow_imp.g_varchar2_table(154) := '42414370432C4741416B422C53414162652C4541414B78422C49414169422C43414368432C4941414977482C45414163394A2C4B41414B32442C4F41414F6F472C4D41414D2F4A2C4B41414B71422C4B41414B2C6F4241416F4230422C59414335446948';
wwv_flow_imp.g_varchar2_table(155) := '2C4D41414D432C51414153482C4B41436E42412C454141632C43414143412C4941456A4268472C4541414B33422C4941414D32482C4541496670472C454141514D2C574141612C3642414372424E2C45414151652C63414167422C434141432C71424145';
wwv_flow_imp.g_varchar2_table(156) := '7A426A422C614141614D2C4541414D4A2C5141456E4231442C4B41414B69452C5141415132422C574141596D442C4F414574422C4341434C2C4941414975422C45414155744B2C4B41414B432C4F41414F714A2C474141632F482C4B41414B2C6141437A';
wwv_flow_imp.g_varchar2_table(157) := '4334482C454141556E4A2C4B41414B432C4F41414F714A2C474141632F482C4B41414B2C6141437A43674A2C45414157764B2C4B41414B432C4F41414F714A2C474141632F482C4B41414B2C634143394376422C4B41414B32442C4F41414F432C514143';
wwv_flow_imp.g_varchar2_table(158) := '562C654143412C4341434535422C4941414B68432C4B41414B71422C4B41414B2C6341416330422C5741433742642C4941414B71492C4541434C6A492C4941414B38472C4541434C37472C4941414B69492C474145502C4341434578472C514141532C53';
wwv_flow_imp.g_varchar2_table(159) := '414155442C47414362412C4541414B432C5541434877462C47414346764A2C4B41414B69452C5141415130422C6341436233462C4B41414B6D442C4D41414D432C574141572C6F424143744270442C4B41414B432C4F41414F2C6942414169426B4B2C4F';
wwv_flow_imp.g_varchar2_table(160) := '414337426E4B2C4B41414B432C4F41414F2C654141656B4B2C4F414333426E4B2C4B41414B432C4F41414F2C3242414132426B4B2C4F414376436E4B2C4B41414B432C4F41414F2C3442414134426D4B2C4F41437843704B2C4B41414B71422C4B41414B';
wwv_flow_imp.g_varchar2_table(161) := '2C6341416332422C5341415373482C4541415172462C4D41414D2C4B41414B2C494143704475462C594141572C57414354784B2C4B41414B71422C4B41414B2C69424141694232422C53414153632C4541414B32472C5741437A437A4B2C4B41414B7142';
wwv_flow_imp.g_varchar2_table(162) := '2C4B41414B2C63414163714A2C59414376422C4F414548314B2C4B41414B71422C4B41414B2C6F4241416F4232422C5341415373482C4741437643744B2C4B41414B71422C4B41414B2C6F4241416F42714A2C5541433942314B2C4B41414B71422C4B41';
wwv_flow_imp.g_varchar2_table(163) := '414B2C6F4241416F4232422C534141536D472C47414376436E4A2C4B41414B71422C4B41414B2C6F4241416F42714A2C5541433942314B2C4B41414B71422C4B41414B2C69424141694232422C5341415375482C4741437043764B2C4B41414B71422C4B';
wwv_flow_imp.g_varchar2_table(164) := '41414B2C694241416942714A2C5541433342314B2C4B41414B6D442C4D41414D432C574141572C6D4241434C2C6141415A2B462C474143486E4A2C4B41414B71422C4B41414B2C6D4241416D4232422C53414153632C4541414B32472C57414333437A4B';
wwv_flow_imp.g_varchar2_table(165) := '2C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C494143744368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C4941437643';
wwv_flow_imp.g_varchar2_table(166) := '68442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6D4241416D42734A2C594143502C5741415A78422C474143566E4A2C4B41414B71422C4B41414B2C6D4241416D4232422C5341';
wwv_flow_imp.g_varchar2_table(167) := '4153632C4541414B38472C5741433343354B2C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C494143744368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6F';
wwv_flow_imp.g_varchar2_table(168) := '4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6D4241416D42734A2C594143502C5341415A78422C474143566E4A2C4B41414B71';
wwv_flow_imp.g_varchar2_table(169) := '422C4B41414B2C6F4241416F4232422C53414153632C4541414B2B472C5941433543374B2C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C494143';
wwv_flow_imp.g_varchar2_table(170) := '744368442C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C494143744368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6F4241416F42734A2C594143522C36';
wwv_flow_imp.g_varchar2_table(171) := '4241415A78422C474143566E4A2C4B41414B71422C4B41414B2C6F4241416F4232422C53414153632C4541414B67482C5941433543394B2C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C494143744368442C4B41414B71422C4B4141';
wwv_flow_imp.g_varchar2_table(172) := '4B2C6D4241416D4232422C534141532C494143744368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B';
wwv_flow_imp.g_varchar2_table(173) := '41414B2C6F4241416F42734A2C594143522C5341415A78422C494143566E4A2C4B41414B71422C4B41414B2C6F4241416F4232422C53414153632C4541414B69482C59414335432F4B2C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C';
wwv_flow_imp.g_varchar2_table(174) := '494143744368442C4B41414B71422C4B41414B2C6D4241416D4232422C534141532C494143744368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141532C494143764368442C4B41414B71422C4B41414B2C6F4241416F4232422C534141';
wwv_flow_imp.g_varchar2_table(175) := '532C494143764368442C4B41414B71422C4B41414B2C6F4241416F42734A2C5941456843334B2C4B41414B432C4F41414F2C7142414171426B4B2C4F41436A436E4B2C4B41414B432C4F41414F2C7342414173426D4B2C5141457043704B2C4B41414B6D';
wwv_flow_imp.g_varchar2_table(176) := '442C4D41414D432C574141596F472C4B414733427A442C4D41414F2C53414155452C4541414F432C45414159432C4741436C4336452C51414151432C4941414968462C4F414F74422C5341415369462C734241417342784A2C4541415134482C47414372';
wwv_flow_imp.g_varchar2_table(177) := '43744A2C4B41414B69452C514141516B482C514141536E4C2C4B41414B69442C4B41414B432C574141572C7743414177432C534141556B492C47414333462C47414149412C454141592C434143642C4941414974482C4541414F2C474141494A2C454141';
wwv_flow_imp.g_varchar2_table(178) := '552C4741437A42492C4541414B39422C4941414D4E2C454143586F432C4541414B37422C4941414D6A432C4B41414B432C4F41414F714A2C474141632F482C4B41414B2C614143314375432C4541414B7A422C4941414D72432C4B41414B432C4F41414F';
wwv_flow_imp.g_varchar2_table(179) := '714A2C474141632F482C4B41414B2C614143314375432C4541414B78422C4941414D74432C4B41414B432C4F41414F714A2C474141632F482C4B41414B2C63414531436D432C454141514D2C574141612C2B42414372424E2C45414151652C6341416742';
wwv_flow_imp.g_varchar2_table(180) := '2C434141432C714241437A426A422C614141614D2C4541414D4A2C4F414B7A422C5341415332482C304241413042334A2C4741436A4331422C4B41414B69452C514141516B482C514141536E4C2C4B41414B69442C4B41414B432C574141572C77434141';
wwv_flow_imp.g_varchar2_table(181) := '77432C534141556B492C47414333462C47414149412C454141592C434143642C4941414974482C4541414F2C474141494A2C454141552C4741437A42492C4541414B39422C4941414D4E2C454143586F432C4541414B33422C4941414D70422C79424141';
wwv_flow_imp.g_varchar2_table(182) := '79422C3243414134432C3442414136422C61414337472B432C4541414B72422C4941414D31422C7942414179422C3243414134432C3442414136422C53414337472B432C4541414B70422C4941414D33422C7942414179422C3243414134432C34424141';
wwv_flow_imp.g_varchar2_table(183) := '36422C634145374732432C454141514D2C574141612C2B42414372424E2C45414151652C63414167422C434141432C714241437A426A422C614141614D2C4541414D4A2C4F414B7A422C5341415334482C61414163354A2C45414151432C47414337422C';
wwv_flow_imp.g_varchar2_table(184) := '494143492B422C454141552C43414364412C63414177422C434141432C574141592C65414167422C6F42414171422C7542414177422C7742414179422C6341433348462C614148576A422C65414165622C45414151432C474147662B422C47414772422C';
wwv_flow_imp.g_varchar2_table(185) := '5341415336482C694241416B42374A2C4741437A422C4941434967432C454141552C43414364412C63414177422C434141432C574141592C65414167422C6F42414171422C7542414177422C7742414179422C6341433348462C6141485768422C6D4241';
wwv_flow_imp.g_varchar2_table(186) := '416F42642C4741475A67432C47414772422C5341415338482C59414161394A2C45414151432C47414335422C4741414B33422C4B41414B432C4F4141512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D442C4D41414D';
wwv_flow_imp.g_varchar2_table(187) := '32452C594141612C3042414378422C4941414968452C4541414F76422C65414165622C45414151432C4741436C436D432C4541414B2B462C4941414D74472C6F424143582C49414149472C454141552C43414364412C57414171422C774241437242412C';
wwv_flow_imp.g_varchar2_table(188) := '63414177422C434141432C574141592C65414167422C6F42414171422C7542414177422C6341436C47462C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C45414151432C454141532C3242414134422C3042414939452C53414153';
wwv_flow_imp.g_varchar2_table(189) := '384A2C6742414169422F4A2C45414151432C47414368432C4741414B33422C4B41414B432C4F4141512C32424141344271442C4F4141512C554141612C4341436A4574442C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414968';
wwv_flow_imp.g_varchar2_table(190) := '452C4541414F74422C6D4241416F42642C4741432F426F432C4541414B37422C4941414D73422C6F424145582C49414149472C454141552C43414364412C63414177422C434141432C574141592C65414167422C6F42414171422C7542414177422C6341';
wwv_flow_imp.g_varchar2_table(191) := '436C47462C614141614D2C4541414D4A2C5141456E42662C3442414136426A422C45414151432C454141532C3242414134422C3042414939452C534141532B4A2C734241417342684B2C45414151432C474143724333422C4B41414B71422C4B41414D2C';
wwv_flow_imp.g_varchar2_table(192) := '6B4241416D4232422C534141552C494143784368442C4B41414B432C4F4141512C71424141734273422C4B41414D2C63414165472C474143784431422C4B414347432C4F4141512C714241435273422C4B41414D2C5941416176422C4B41414B432C4F41';
wwv_flow_imp.g_varchar2_table(193) := '415130422C474141554A2C4B41414D2C6341436E4476422C4B414347432C4F4141512C714241435273422C4B41414D2C5941416176422C4B41414B432C4F41415130422C474141554A2C4B41414D2C6341436E4476422C4B414347432C4F4141512C7142';
wwv_flow_imp.g_varchar2_table(194) := '41435273422C4B41414D2C5741415976422C4B41414B432C4F41415130422C474141554A2C4B41414D2C6141436C4476422C4B41414B6D442C4D41414D432C574141592C734241477A422C5341415375492C594141616A4B2C45414151432C4741433542';
wwv_flow_imp.g_varchar2_table(195) := '2C4741414B33422C4B41414B432C4F4141512C75424141774271442C4F4141512C554141612C434143374474442C4B41414B6D442C4D41414D32452C594141612C7342414378422C4941414968452C4541414F76422C65414165622C45414151432C4741';
wwv_flow_imp.g_varchar2_table(196) := '436C436D432C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C6B4241416B4230422C57414576432C49414149572C454141552C43414364412C63414177422C434141432C574141592C6341437243462C614141614D2C4541414D4A2C51';
wwv_flow_imp.g_varchar2_table(197) := '41456E4267492C734241417542684B2C45414151432C4741496E432C53414153694B2C6742414169426C4B2C47414378422C4741414B31422C4B41414B432C4F4141512C75424141774271442C4F4141512C554141612C434143374474442C4B41414B6D';
wwv_flow_imp.g_varchar2_table(198) := '442C4D41414D32452C594141612C7342414378422C4941414968452C4541414F74422C6D4241416F42642C4741432F426F432C4541414B37422C4941414D6A432C4B41414B71422C4B41414B2C6B4241416B4230422C57414576432C49414149572C4541';
wwv_flow_imp.g_varchar2_table(199) := '41552C43414364412C63414177422C434141432C574141592C6341437243462C614141614D2C4541414D4A2C5141456E4267492C734241417542684B2C454141512C4D41496E432C534141536D4B2C594141616E4B2C45414151432C474143354233422C';
wwv_flow_imp.g_varchar2_table(200) := '4B41414B69452C514141516B482C514141536E4C2C4B41414B69442C4B41414B432C574141572C3642414136422C534141556B492C47414368462C47414149412C454141592C434143642C4941454931482C454141552C43414364412C63414177422C43';
wwv_flow_imp.g_varchar2_table(201) := '4141432C574141592C6341437243462C61414A576A422C65414165622C45414151432C474149662B422C4F414B7A422C534141536F492C674241416942704B2C474143784231422C4B41414B69452C514141516B482C514141536E4C2C4B41414B69442C';
wwv_flow_imp.g_varchar2_table(202) := '4B41414B432C574141572C3642414136422C534141556B492C47414368462C47414149412C454141592C434143642C4941454931482C454141552C43414364412C63414177422C434141432C574141592C6341437243462C61414A5768422C6D4241416D';
wwv_flow_imp.g_varchar2_table(203) := '42642C4741495867432C4F414B7A422C5341415371492C674241416B42724B2C45414151432C4741436A432C4741414B33422C4B41414B432C4F4141512C34424141364271442C4F4141512C554141612C4341436C4574442C4B41414B6D442C4D41414D';
wwv_flow_imp.g_varchar2_table(204) := '32452C594141612C3242414378422C4941414968452C4541414F76422C65414165622C45414151432C4741436C436D432C4541414B2B462C4941414D374A2C4B41414B71422C4B41414B2C32424141324230422C5741436844652C4541414B32462C4941';
wwv_flow_imp.g_varchar2_table(205) := '414D7A4A2C4B41414B71422C4B41414D2C30424141324230422C5741436A44652C4541414B6B492C4941414D684D2C4B41414B71422C4B41414B2C2B4241412B4230422C57414570442C49414149572C454141552C43414364412C63414177422C434141';
wwv_flow_imp.g_varchar2_table(206) := '432C574141592C65414167422C6F42414171422C7542414177422C7742414179422C6341433348462C614141614D2C4541414D4A2C5141456E4275492C304241413242764B2C45414151432C47414976432C53414153754B2C6F4241417342784B2C4741';
wwv_flow_imp.g_varchar2_table(207) := '4337422C4741414B31422C4B41414B432C4F4141512C34424141364271442C4F4141512C554141612C4341436C4574442C4B41414B6D442C4D41414D32452C594141612C3242414378422C4941414968452C4541414F74422C6D4241416D42642C474143';
wwv_flow_imp.g_varchar2_table(208) := '39426F432C4541414B37422C4941414D6A432C4B41414B71422C4B41414B2C32424141324230422C5741436844652C4541414B7A422C4941414D72432C4B41414B71422C4B41414D2C30424141324230422C5741436A44652C4541414B78422C4941414D';
wwv_flow_imp.g_varchar2_table(209) := '74432C4B41414B71422C4B41414B2C2B4241412B4230422C57414570442C49414149572C454141552C43414364412C63414177422C434141432C574141592C65414167422C6F42414171422C7542414177422C7742414179422C6341433348462C614141';
wwv_flow_imp.g_varchar2_table(210) := '614D2C4541414D4A2C5141456E4275492C304241413242764B2C454141512C4D414976432C53414153794B2C65414167427A4B2C45414151432C4741432F422C4741414B33422C4B41414B432C4F4141512C32424141344271442C4F4141512C55414161';
wwv_flow_imp.g_varchar2_table(211) := '2C4341436A452C49414149512C4541414F31422C6541416742562C45414151432C4741432F426D492C45414163394A2C4B41414B32442C4F41414F6F472C4D41414D2F4A2C4B41414B71422C4B41414B2C6341416330422C594143744469482C4D41414D';
wwv_flow_imp.g_varchar2_table(212) := '432C51414153482C4B41436E42412C454141632C43414143412C4941456A4268472C4541414B33422C4941414D32482C45414358394A2C4B41414B6D442C4D41414D32452C594141612C3042414378422C4941414970452C454141552C43414364412C63';
wwv_flow_imp.g_varchar2_table(213) := '414177422C434141432C574141592C65414167422C6F42414171422C7542414177422C7742414179422C6341433348462C614141614D2C4541414D4A2C5141476E4230492C794241413042314B2C45414151432C47414B74432C53414153794B2C794241';
wwv_flow_imp.g_varchar2_table(214) := '417942314B2C45414151432C474143784333422C4B414347432C4F4141512C774241435273422C4B41414D2C654141674276422C4B41414B432C4F41415130422C474141554A2C4B41414D2C69424143744476422C4B414347432C4F4141512C77424143';
wwv_flow_imp.g_varchar2_table(215) := '5273422C4B41414D2C5741415976422C4B41414B432C4F41415130422C474141554A2C4B41414D2C6141436C4476422C4B414347432C4F4141512C774241435273422C4B41414D2C6141416376422C4B41414B432C4F41415130422C474141554A2C4B41';
wwv_flow_imp.g_varchar2_table(216) := '414D2C654143704476422C4B41414B6D442C4D41414D432C574141592C304241477A422C5341415336492C304241413042764B2C45414151432C4741437A4333422C4B41414B71422C4B41414D2C32424141344232422C534141552C4B41436A4468442C';
wwv_flow_imp.g_varchar2_table(217) := '4B41414B71422C4B41414D2C30424141324232422C534141552C494143684468442C4B41414B71422C4B41414B2C2B4241412B4232422C534141532C4941436C4468442C4B41414B432C4F4141512C79424141304273422C4B41414D2C63414165472C47';
wwv_flow_imp.g_varchar2_table(218) := '4143354431422C4B414347432C4F4141512C794241435273422C4B41414D2C5941416176422C4B41414B432C4F41415130422C474141554A2C4B41414D2C6341436E4476422C4B414347432C4F4141512C794241435273422C4B41414D2C594141617642';
wwv_flow_imp.g_varchar2_table(219) := '2C4B41414B432C4F41415130422C474141554A2C4B41414D2C6341436E4476422C4B414347432C4F4141512C794241435273422C4B41414D2C5741415976422C4B41414B432C4F41415130422C474141554A2C4B41414D2C6141436C4476422C4B41414B';
wwv_flow_imp.g_varchar2_table(220) := '6D442C4D41414D432C574141592C324241477A422C53414153694A2C6341416335442C47414372422C4941414936442C45414163744D2C4B41414B432C4F4141512C734241453342734D2C454143462C384341466F4239442C45414970422C494143452B';
wwv_flow_imp.g_varchar2_table(221) := '442C45414161462C45414159472C4941414B462C4741436C43442C45414159492C594141612C6D4241437A42462C45414157472C53414153314C2C57414157482C534141552C6D42414733432C53414153384C2C634141636E452C47414367432C574141';
wwv_flow_imp.g_varchar2_table(222) := '68447A492C4B41414B71422C4B41414B2C75424141754230422C574143704338462C6B4241416B424A2C4741456C427A492C4B41414B34452C4F41414F2C674241416742512C55414968432C5341415379482C694241416B426E4C2C45414151432C4741';
wwv_flow_imp.g_varchar2_table(223) := '436A432C494141496D4C2C4541416B42394D2C4B41414B432C4F41415130422C474141554A2C4B41414D2C6141432F43774C2C454141632F4D2C4B41414B432C4F41415130422C474141554A2C4B41414D2C6141432F4376422C4B41414B71422C4B4141';
wwv_flow_imp.g_varchar2_table(224) := '4B2C6541416532422C53414153384A2C4741436C43394D2C4B41414B71422C4B41414B2C69424141694232422C534141532B4A2C4741437043562C63414163532C47414364462C63414163452C47414768422C53414153452C634145507A472C47414147';
wwv_flow_imp.g_varchar2_table(225) := '2C574143442C494141497A442C4541415339432C4B41414B71422C4B41414B2C6541416530422C57414376422C4D414158442C4741434639432C4B41414B694E2C51414151432C4941414B2C43414368422C4341434576492C4B41414D2C6D4241434E6A';
wwv_flow_imp.g_varchar2_table(226) := '442C4F4141512C5341415732452C4541414F69442C47414378422C4941414936442C454141536E4E2C4B41414B432C4F414151714A2C474141652F482C4B41414D2C6141432F4376422C4B41414B71422C4B41414D2C6341416532422C534141556D4B2C';
wwv_flow_imp.g_varchar2_table(227) := '47414370436E4E2C4B41414B71422C4B41414D2C6B4241416D4232422C534141552C4B4143784368442C4B41414B6D442C4D41414D432C574141592C7142414733422C4341434575422C4B41414D2C774241434E6A442C4F4141512C5341415732452C45';
wwv_flow_imp.g_varchar2_table(228) := '41414F69442C47414378422C4941414936442C454141536E4E2C4B414356432C4F4141512C32424143526D422C4B41414B2C5741434A2C4F41414F70422C4B41414B432C4F41415171422C4D41414F432C4B41414D2C5941456C43364C2C4D4143417844';
wwv_flow_imp.g_varchar2_table(229) := '2C4B41414D2C4B414354354A2C4B41414B71422C4B41414D2C6341416532422C534141556D4B2C47414370436E4E2C4B41414B71422C4B41414D2C6B4241416D4232422C534141552C4B4143784368442C4B41414B6D442C4D41414D432C574141592C71';
wwv_flow_imp.g_varchar2_table(230) := '42414733422C4341434575422C4B41414D2C694241434E6A442C4F4141512C5341415732452C4541414F69442C47414378422C4941414936442C454141536E4E2C4B414356432C4F4141512C32424143526D422C4B41414B2C5741434A2C4F41414F7042';
wwv_flow_imp.g_varchar2_table(231) := '2C4B41414B432C4F41415171422C4D41414F432C4B41414D2C5941456C43364C2C4D41434178442C4B41414D2C4B414354354A2C4B41414B71422C4B41414D2C6341416532422C534141556D4B2C47414370436E4E2C4B41414B71422C4B41414D2C6B42';
wwv_flow_imp.g_varchar2_table(232) := '41416D4232422C534141552C4B4143784368442C4B41414B6D442C4D41414D432C574141592C6D42414733422C4341434575422C4B41414D2C5941434E6A442C4F4141512C5341415732452C4541414F69442C47414378422C4941414936442C45414153';
wwv_flow_imp.g_varchar2_table(233) := '6E4E2C4B41414B432C4F414151714A2C474141652F482C4B41414D2C6141432F4376422C4B41414B71422C4B41414D2C6341416532422C534141556D4B2C47414370436E4E2C4B41414B71422C4B41414D2C6B4241416D4232422C534141552C4B414378';
wwv_flow_imp.g_varchar2_table(234) := '4368442C4B41414B6D442C4D41414D432C574141592C7142414D662C4D4141584E2C4741434839432C4B41414B694E2C51414151432C4941414B2C43414368422C4341434576492C4B41414D2C734241434E6A442C4F4141512C5341415732452C454141';
wwv_flow_imp.g_varchar2_table(235) := '4F69442C4741437842744A2C4B41414B6D442C4D41414D432C574141572C6B42414D642C4D4141584E2C4741434839432C4B41414B694E2C51414151432C4941414B2C43414368422C4341434576492C4B41414D2C674241434E6A442C4F4141512C5341';
wwv_flow_imp.g_varchar2_table(236) := '415732452C4541414F69442C474143784267432C61414163684B2C4B41414B71442C4B41414D32452C4B414737422C4341434533452C4B41414D2C714241434E6A442C4F4141512C5341415732452C4541414F69442C474143784269432C694241416B42';
wwv_flow_imp.g_varchar2_table(237) := '6A4B2C4B41414B71442C51414733422C43414345412C4B41414D2C6541434E6A442C4F4141512C5341415732452C4541414F69442C47414378426B432C594141616C4B2C4B41414B71442C4B41414D32452C4B414735422C4341434533452C4B41414D2C';
wwv_flow_imp.g_varchar2_table(238) := '6F4241434E6A442C4F4141512C5341415732452C4541414F69442C47414378426D432C6742414169426E4B2C4B41414B71442C4B41414D32452C4B414768432C4341434533452C4B41414D2C6541434E6A442C4F4141512C5341415732452C4541414F69';
wwv_flow_imp.g_varchar2_table(239) := '442C474143784271432C59414161724B2C4B41414B71442C4B41414D32452C4B414735422C4341434533452C4B41414D2C6F4241434E6A442C4F4141512C5341415732452C4541414F69442C474143784273432C674241416942744B2C4B41414B71442C';
wwv_flow_imp.g_varchar2_table(240) := '51414731422C43414345412C4B41414D2C6541434E6A442C4F4141512C5341415732452C4541414F69442C474143784275432C59414161764B2C4B41414B71442C4B41414D32452C4B414735422C4341434533452C4B41414D2C6F4241434E6A442C4F41';
wwv_flow_imp.g_varchar2_table(241) := '41512C5341415732452C4541414F69442C474143784277432C674241416942784B2C4B41414B71442C51414731422C43414345412C4B41414D2C754241434E6A442C4F4141512C5341415732452C4541414F69442C4741437842442C6D4241416F422C6D';
wwv_flow_imp.g_varchar2_table(242) := '4241416F42432C4B414735432C4341434533452C4B41414D2C304241434E6A442C4F4141512C5341415732452C4541414F69442C4741437842652C7342414175422C6D4241416F42662C4B41472F432C4341434533452C4B41414D2C304241434E6A442C';
wwv_flow_imp.g_varchar2_table(243) := '4F4141512C5341415732452C4541414F69442C474143784234422C734241417542354A2C4B41414B71442C4B41414D32452C4B414774432C4341434533452C4B41414D2C2B4241434E6A442C4F4141512C5341415732452C4541414F69442C4741437842';
wwv_flow_imp.g_varchar2_table(244) := '2B422C3042414132422F4A2C4B41414B71442C51414770432C43414345412C4B41414D2C6D4241434E6A442C4F4141512C5341415532452C4541414F69442C474143764279432C6742414169427A4B2C4B41414B71442C4B41414D32452C4B414768432C';
wwv_flow_imp.g_varchar2_table(245) := '4341434533452C4B41414D2C774241434E6A442C4F4141512C5341415532452C4541414F69442C474143764234432C6F4241417142354B2C4B41414B71442C51414739422C43414345412C4B41414D2C6B4241434E6A442C4F4141512C5341415732452C';
wwv_flow_imp.g_varchar2_table(246) := '4541414F69442C474143784236432C6541416742374B2C4B41414B71442C4B41414D32452C4F414D70422C4F41415878472C4741434639432C4B41414B694E2C51414151432C494143582C434143452C4341434576492C4B41414D2C714241434E6A442C';
wwv_flow_imp.g_varchar2_table(247) := '4F4141512C5341415732452C4541414F69442C474143784275442C694241416B42764C2C4B41414B71442C4B41414D32452C4B41476A432C4341434533452C4B41414D2C324241434E6A442C4F4141512C5341415732452C4541414F69442C4741437842';
wwv_flow_imp.g_varchar2_table(248) := '31422C73424141754274472C4B41414B71442C51414768432C43414345412C4B41414D2C324241434E6A442C4F4141512C5341415732452C4541414F69442C474143784276422C7342414175427A472C4B41414B71442C4B41414D32452C4B414774432C';
wwv_flow_imp.g_varchar2_table(249) := '4341434533452C4B41414D2C2B4241434E6A442C4F4141512C5341415732452C4541414F69442C474143784272422C30424141324233472C4B41414B71442C4B41414D32452C4B414731432C4341434533452C4B41414D2C344241434E6A442C4F414151';
wwv_flow_imp.g_varchar2_table(250) := '2C5341415732452C4541414F69442C47414378426E422C75424141774237472C4B41414B71442C4B41414D32452C4B414776432C4341434533452C4B41414D2C364241434E6A442C4F4141512C5341415732452C4541414F69442C474143784268422C36';
wwv_flow_imp.g_varchar2_table(251) := '424141384268482C4B41414B71442C4B41414D32452C4F414F70432C4D41415878472C47414136422C4F414158412C494143704239432C4B41414B694E2C51414151432C494141492C434143662C4341434576492C4B41414D2C694241434E79492C4941';
wwv_flow_imp.g_varchar2_table(252) := '414B2C574143482C4F41414F704E2C4B41414B71422C4B41414D2C4941414D79422C454141532C6F4241417142432C5941457844734B2C4941414B2C53414157432C47414364744E2C4B41414B71422C4B41414D2C4941414D79422C454141532C6F4241';
wwv_flow_imp.g_varchar2_table(253) := '417142452C53414155734B2C4741437A442C4941414937452C454141537A492C4B41414B71422C4B41414D2C4941414D79422C454141532C59414161432C57414570442C4F414153754B2C474143502C4941414B2C4D414348744E2C4B41414B432C4F41';
wwv_flow_imp.g_varchar2_table(254) := '41512C53414155612C534141552C434141452C534141552C594141612C59414163344C2C594141612C5341437246314D2C4B41414B432C4F4141512C53414155612C534141552C434141452C534141552C594141612C59414163344C2C594141612C5341';
wwv_flow_imp.g_varchar2_table(255) := '457246314D2C4B41414B432C4F4141512C694241416B426D4B2C4F41432F42704B2C4B41414B34452C4F4141512C674241416942512C55414539422C4D4143462C4941414B2C5341434870462C4B41414B432C4F4141512C53414155612C534141552C53';
wwv_flow_imp.g_varchar2_table(256) := '414155344C2C594141612C434141452C534141552C5941437045314D2C4B41414B432C4F4141512C53414155612C534141552C53414155344C2C594141612C434141452C534141552C6341437045314D2C4B41414B432C4F4141512C53414155734E2C53';
wwv_flow_imp.g_varchar2_table(257) := '414155764E2C4B41414B432C4F4141512C53414155304D2C5541457844334D2C4B41414B432C4F4141512C694241416B426D4B2C4F41432F42704B2C4B41414B34452C4F4141512C674241416942512C55414539422C4D4143462C4941414B2C53414348';
wwv_flow_imp.g_varchar2_table(258) := '70462C4B41414B432C4F4141512C694241416B426B4B2C4F41432F426E4B2C4B41414B432C4F4141512C53414155612C534141552C434141452C534141552C594141612C59414163344C2C594141612C5341437246314D2C4B41414B432C4F4141512C53';
wwv_flow_imp.g_varchar2_table(259) := '414155612C534141552C434141452C534141552C594141612C59414163344C2C594141612C53414572452C4B4141586A452C47414348492C6B4241416D424A2C4B414B33422B452C514141532C494145582C4341434537492C4B41414D2C734241434E6A';
wwv_flow_imp.g_varchar2_table(260) := '442C4F4141512C5341415732452C4541414F69442C474143784237422C6B4241416D426E472C4B41414B71442C4B41414D32452C4B41476C432C4341434533452C4B41414D2C734241434E6A442C4F4141512C5341415732452C4541414F69442C474143';
wwv_flow_imp.g_varchar2_table(261) := '78427A422C6B4241416D4276472C4B41414B71442C4B41414D32452C4B41476C432C4341434533452C4B41414D2C304241434E6A442C4F4141512C5341415732452C4541414F69442C474143784274422C73424141754231472C4B41414B71442C4B4141';
wwv_flow_imp.g_varchar2_table(262) := '4D32452C4B414774432C4341434533452C4B41414D2C754241434E6A442C4F4141512C5341415732452C4541414F69442C474143784270422C6D4241416F4235472C4B41414B71442C4B41414D32452C4B41476E432C4341434533452C4B41414D2C6B42';
wwv_flow_imp.g_varchar2_table(263) := '41434E6A442C4F4141512C5341415732452C4541414F69442C47414378426C442C6B4241474A2C434143457A422C4B41414D2C734241434E6A442C4F4141512C5341415732452C4541414F69442C47414378426C422C34424141364239472C4B41414B71';
wwv_flow_imp.g_varchar2_table(264) := '442C4B41414D32452C4F414B3943744A2C4B41414B694E2C51414151492C494143582C6942414341724E2C4B41414B71422C4B41414D2C4941414D79422C454141532C6F4241417142432C5941476A4479482C594141592C574143562C4941414939492C';
wwv_flow_imp.g_varchar2_table(265) := '4741434A412C4541415331422C4B41414B694E2C51414151512C4F4141512C6D4241437642442C51414155394C2C4541414F674D2C4D41414D7A492C4D41414F2C4B41414D37442C4B41414B2C53414157754D2C45414147432C47414335442C4D41414F';
wwv_flow_imp.g_varchar2_table(266) := '2C43414145462C4D41414F432C454141474C2C4D41414F2C434141432C4D41414F2C534141552C554141554D2C6341456A446C4D2C4541414F674D2C4D414364314E2C4B41414B694E2C51414151592C4F4141512C6F42414370422C4941474C374E2C4B';
wwv_flow_imp.g_varchar2_table(267) := '41414B694E2C51414151432C4941414B2C43414368422C4341434576492C4B41414D2C6F4241434E6A442C4F4141512C5341415732452C4541414F69442C4741437842662C7342414175426A482C4B41414B71442C4B41414D32452C55415135432C5341';
wwv_flow_imp.g_varchar2_table(268) := '415377452C594143502F4E2C55414341694E2C63414541684E2C4B41414B432C4F414151432C51414153432C474141492C6742414167422C57414378436F472C454141472C364341434168462C4B41414D2C554141572C4B41436A42774D2C4D4143432C';
wwv_flow_imp.g_varchar2_table(269) := '324941474A78482C454141472C79434141304379482C4D41414D2C5741436A442C49414149684A2C4541414F75422C454141476A462C4D41414F30442C4F4143522C57414152412C4541434875422C454141476A462C4D41414F714C2C53414153374C2C';
wwv_flow_imp.g_varchar2_table(270) := '534141552C73424143582C614141526B452C4541435675422C454141476A462C4D41414F714C2C53414153374C2C534141552C77424143582C574141526B452C4541435675422C454141476A462C4D41414F714C2C53414153374C2C534141552C734241';
wwv_flow_imp.g_varchar2_table(271) := '43582C634141526B452C4541435675422C454141476A462C4D41414F714C2C53414153374C2C534141552C79424143582C534141526B452C4741435675422C454141476A462C4D41414F714C2C53414153374C2C534141552C75424149374279462C4541';
wwv_flow_imp.g_varchar2_table(272) := '41452C30424141304237422C4F4141532C474143764336422C454141452C4D41414D79482C4D41414B2C534141534A2C5141436F422F4C2C4941416A4337422C4B41414B432C4F41414F71422C4D41414D432C4B41414B2C4F4143784276422C4B41414B';
wwv_flow_imp.g_varchar2_table(273) := '432C4F41414F71422C4D41414D482C4B41414B2C304241413042674A2C4F41436A446E4B2C4B41414B432C4F41414F71422C4D41414D482C4B41414B2C774241417742674A2C5141452F436E4B2C4B41414B432C4F41414F71422C4D41414D522C534141';
wwv_flow_imp.g_varchar2_table(274) := '532C6F42414B724379462C454141472C77424141794270472C474141492C6B4241416B422C534141576B472C4541414F34482C4741436C452C49414149432C45414159442C45414147452C4B41414B432C4D414969432C4941467644704F2C4B41434743';
wwv_flow_imp.g_varchar2_table(275) := '2C4F4141512C79434143526B422C4B41414D2C6B4341416D4375442C4F41453543774A2C45414159412C45414155394D2C4B41414B2C53414157432C47414970432C4D414871422C5941416842412C4541414B4B2C534143524C2C4541414B674E2C5541';
wwv_flow_imp.g_varchar2_table(276) := '41572C47414558684E2C4D414754364D2C45414159412C45414155394D2C4B41414B2C53414157432C47414970432C4D414871422C5941416842412C4541414B4B2C534143524C2C4541414B674E2C554141572C47414558684E2C4B41475472422C4B41';
wwv_flow_imp.g_varchar2_table(277) := '4347432C4F4141512C79434143526B422C4B41414D2C6B4341434E364D2C4D41414D2C5741434C2C49414149724A2C4541414F34422C454141476A462C4D41414F77432C4B41414D2C51414533422C4741434539442C4B414347432C4F4141512C794341';
wwv_flow_imp.g_varchar2_table(278) := '43526B422C4B4143432C71434141754377442C4541414F2C6341433943442C4F4141532C454157622C4F415441774A2C45414159412C45414155394D2C4B41414B2C53414157432C47414F70432C4D414C6B422C304241416842412C4541414B4B2C5141';
wwv_flow_imp.g_varchar2_table(279) := '43572C6D42414168424C2C4541414B4B2C5341454C4C2C4541414B674E2C554141572C47414558684E2C4D4145462C4D414966344D2C45414147452C4B41414B432C4D414151462C51414B74422C53414153492C59414350764F2C55414341432C4B4141';
wwv_flow_imp.g_varchar2_table(280) := '4B432C4F414151432C51414153432C474141492C6742414167422C57414378434D2C6F4241416F422C3842414169432C7742414179422C734241433945412C6F4241416F422C3842414169432C7742414179422C734241433945412C6F4241416F422C67';
wwv_flow_imp.g_varchar2_table(281) := '43414169432C7742414179422C774241433945412C6F4241416F422C694341416B432C7742414179422C794241432F45412C6F4241416F422C344241416B432C7742414179422C754241496E462C53414153384E2C59414350784F2C5541434177472C45';
wwv_flow_imp.g_varchar2_table(282) := '41414572472C51414151734F2C4B41414B2C574141572C534141536E492C4941433742412C4541414D6F492C5341415770492C4541414D71492C55414367432C4D41416E44432C4F41414F432C6141416176492C4541414D77492C4F41414F432C674241';
wwv_flow_imp.g_varchar2_table(283) := '436A437A492C4541414D30492C694241434E2F4F2C4B41414B34452C4F41414F2C574141576F4B2C57414D6E432C53414153432C594143506A432C63414341684E2C4B41414B432C4F414151432C51414153432C474141492C6742414167422C57414378';
wwv_flow_imp.g_varchar2_table(284) := '434D2C6F4241416F422C384241416B432C7942414130422C434141432C7142414173422C304241437647412C6F4241416F422C384241416B432C7942414130422C434141432C7142414173422C304241437647412C6F4241416F422C674341416B432C79';
wwv_flow_imp.g_varchar2_table(285) := '42414130422C434141432C7542414177422C304241437A47412C6F4241416F422C694341416B432C7942414130422C434141432C7742414179422C304241433147412C6F4241416F422C344241416B432C7942414130422C434141432C6D4241416F422C';
wwv_flow_imp.g_varchar2_table(286) := '30424145724738462C454141472C694241416B4270472C474141492C6B4241416B422C534141576B472C4541414F34482C47414333442C49414149432C45414159442C45414147452C4B41414B432C4D41437042632C454141616C502C4B41414B71422C';
wwv_flow_imp.g_varchar2_table(287) := '4B41414B2C6B4241416B4230422C5741437A436F4D2C45414167426E502C4B41414B71422C4B41414B2C73424141734230422C57414370446D4C2C45414159412C45414155394D2C4B41414B2C53414157432C47414970432C4D414871422C7742414168';
wwv_flow_imp.g_varchar2_table(288) := '42412C4541414B4B2C534143524C2C4541414B674E2C53414130422C55414166612C47414179432C61414166412C4741412B432C674241416C42432C4741456C45394E2C4B414554344D2C45414147452C4B41414B432C4D414151462C51414B74422C53';
wwv_flow_imp.g_varchar2_table(289) := '4141536B422C5941435072502C55414341694E2C63414541684E2C4B41414B432C4F414151432C51414153432C474141492C6742414167422C57414378436F472C454141472C6D4241416F4279482C4D41414D2C534141574A2C514143492F4C2C494141';
wwv_flow_imp.g_varchar2_table(290) := '724337422C4B41414B432C4F41415171422C4D41414F432C4B41414D2C4F4143374276422C4B41414B432C4F41415171422C4D41414F482C4B41414D2C304241413242674A2C4F414372446E4B2C4B41414B432C4F41415171422C4D41414F482C4B4141';
wwv_flow_imp.g_varchar2_table(291) := '4D2C674341416943674A2C51414533446E4B2C4B41414B432C4F41415171422C4D41414F522C534141552C6F4241496C432C49414149754F2C4541416172502C4B41414B71422C4B41414B2C6B4241416B4230422C5741457A422C59414166734D2C4741';
wwv_flow_imp.g_varchar2_table(292) := '434472502C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C654141654C2C534141532C434141432C7742414179422C4B41414D2C714241436C47642C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C6F4241416F424C2C53';
wwv_flow_imp.g_varchar2_table(293) := '4141532C7742414368442C59414166754F2C4741435272502C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C654141654C2C534141532C434141432C7742414179422C4B41414D2C714241436C47642C4B41414B432C4F41414F2C794241';
wwv_flow_imp.g_varchar2_table(294) := '4179426B422C4B41414B2C6F4241416F424C2C534141532C7742414368442C63414166754F2C4741435272502C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C654141654C2C534141532C434141432C7742414179422C4B41414D2C7342';
wwv_flow_imp.g_varchar2_table(295) := '41436C47642C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C6F4241416F424C2C534141532C7742414368442C65414166754F2C4741435272502C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C654141654C2C53414153';
wwv_flow_imp.g_varchar2_table(296) := '2C434141432C7742414179422C4B41414D2C714241436C47642C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C6F4241416F424C2C534141532C7742414368442C55414166754F2C4941435272502C4B41414B432C4F41414F2C79424141';
wwv_flow_imp.g_varchar2_table(297) := '79426B422C4B41414B2C654141654C2C534141532C434141432C7742414179422C4B41414D2C344241436C47642C4B41414B432C4F41414F2C7942414179426B422C4B41414B2C6F4241416F424C2C534141532C77424149334579462C454141472C6942';
wwv_flow_imp.g_varchar2_table(298) := '41416B4270472C474141492C6B4241416B422C534141576B472C4541414F34482C47414333442C49414149432C45414159442C45414147452C4B41414B432C4D4143704269422C4541416172502C4B41414B71422C4B41414B2C6B4241416B4230422C57';
wwv_flow_imp.g_varchar2_table(299) := '414337436D4C2C45414159412C45414155394D2C4B41414B2C53414157432C47415770432C4D415671422C774241416842412C4541414B4B2C534143524C2C4541414B674E2C53414130422C5941416667422C474145472C774241416842684F2C454141';
wwv_flow_imp.g_varchar2_table(300) := '4B4B2C534143524C2C4541414B674E2C53414130422C5941416667422C474145472C344241416842684F2C4541414B4B2C534143524C2C4541414B674E2C534143592C5941416667422C47414132432C55414166412C4741457A42684F2C4B414754344D';
wwv_flow_imp.g_varchar2_table(301) := '2C45414147452C4B41414B432C4D414151462C4B41476C4233482C454141472C2B424141674370472C474141492C6B4241416B422C534141576B472C4541414F34482C4741437A452C49414149432C45414159442C45414147452C4B41414B432C4D4143';
wwv_flow_imp.g_varchar2_table(302) := '7842462C45414159412C45414155394D2C4B41414B2C53414157432C4741344470432C4F41334432442C494141744472422C4B41414B432C4F4141512C36424141384279452C4F4143394372442C4541414B674E2C554141572C4741456842684E2C4541';
wwv_flow_imp.g_varchar2_table(303) := '414B674E2C554141572C4541434B2C754241416842684E2C4541414B4B2C5141454E31422C4B414347432C4F4141512C6D434143526B422C4B41414D2C714441434E75442C4F4141532C4941455A72442C4541414B674E2C554141572C474147432C7342';
wwv_flow_imp.g_varchar2_table(304) := '41416842684E2C4541414B4B2C5141454E31422C4B414347432C4F4141512C6D434143526B422C4B41414D2C6D4441434E75442C4F4141532C4941455A72442C4541414B674E2C554141572C474147432C734241416842684E2C4541414B4B2C5341454E';
wwv_flow_imp.g_varchar2_table(305) := '31422C4B414347432C4F4141512C6D434143526B422C4B41414D2C6D4441434E75442C4F4141532C4741435431452C4B414346432C4F4141512C6D434143526B422C4B41414D2C714441434E75442C4F4141532C4B41455672442C4541414B674E2C5541';
wwv_flow_imp.g_varchar2_table(306) := '41572C474147432C734241416842684E2C4541414B4B2C5141454E31422C4B414347432C4F4141512C6D434143526B422C4B41414D2C6B4441434E75442C4F4141532C4941455A72442C4541414B674E2C554141572C474147432C304241416842684E2C';
wwv_flow_imp.g_varchar2_table(307) := '4541414B4B2C5141454E31422C4B414347432C4F4141512C6D434143526B422C4B41414D2C2B4441434E75442C4F4141532C4941455A72442C4541414B674E2C554141572C49414966684E2C4B414554344D2C45414147452C4B41414B432C4D41415146';
wwv_flow_imp.g_varchar2_table(308) := '2C4B41476C426C4F2C4B414347432C4F4141512C3442414352452C474141492C6B4241416B422C534141576B472C4541414F34482C47414376432C4941414971422C4541415374502C4B41414B432C4F4141512C6B4341437442694F2C45414159442C45';
wwv_flow_imp.g_varchar2_table(309) := '414147452C4B41414B432C4D414370426D422C45414161442C4541414F784C2C4B41414D2C5541433142304C2C4541416D42462C4541414F784C2C4B41414D2C65414370436F4B2C45414159412C45414155394D2C4B41414B2C53414157432C47417342';
wwv_flow_imp.g_varchar2_table(310) := '70432C4D41724271422C6B4241416842412C4541414B4B2C534143524C2C4541414B674E2C53414130422C594141666B422C474145472C6942414168426C4F2C4541414B4B2C534143524C2C4541414B674E2C53414130422C554141666B422C47414547';
wwv_flow_imp.g_varchar2_table(311) := '2C6942414168426C4F2C4541414B4B2C534143524C2C4541414B674E2C5341436B422C4B414172426D422C47414130432C59414166442C474149562C6942414168426C4F2C4541414B4B2C534143524C2C4541414B674E2C5341436B422C4B414172426D';
wwv_flow_imp.g_varchar2_table(312) := '422C47414130432C59414166442C474149562C7142414168426C4F2C4541414B4B2C534143524C2C4541414B674E2C53414130422C73424141666B422C474145586C4F2C4B414554344D2C45414147452C4B41414B432C4D414151462C4B414770426C4F';
wwv_flow_imp.g_varchar2_table(313) := '2C4B414347432C4F4141512C6743414352452C474141492C6B4241416B422C534141576B472C4541414F34482C47414376432C49414149432C45414159442C45414147452C4B41414B432C4D41437842462C45414159412C45414155394D2C4B41414B2C';
wwv_flow_imp.g_varchar2_table(314) := '53414157432C47414D70432C4F414C32442C494141744472422C4B41414B432C4F4141512C36424141384279452C4F4143394372442C4541414B674E2C554141572C4541456842684E2C4541414B674E2C554141572C45414558684E2C4B414554344D2C';
wwv_flow_imp.g_varchar2_table(315) := '45414147452C4B41414B432C4D414151462C51414D78422C5341415375422C6141435031502C55414341694E2C63414541684E2C4B41414B432C4F414151432C51414153432C474141492C6742414167422C57414370436F472C454141452C3042414130';
wwv_flow_imp.g_varchar2_table(316) := '4237422C4F4141532C474143764336422C454141472C6D4241416F4279482C4D41414D2C534141574A2C514143492F4C2C494141724337422C4B41414B432C4F41415171422C4D41414F432C4B41414D2C4F4143374276422C4B41414B432C4F41415171';
wwv_flow_imp.g_varchar2_table(317) := '422C4D41414F482C4B41414D2C304241413242674A2C4F414372446E4B2C4B41414B432C4F41415171422C4D41414F482C4B41414D2C694341416B43674A2C51414535446E4B2C4B41414B432C4F41415171422C4D41414F522C534141552C6F42414D70';
wwv_flow_imp.g_varchar2_table(318) := '4379462C454141472C694241416B4270472C474141492C6B4241416B422C534141576B472C4541414F34482C47414333442C49414149432C45414159442C45414147452C4B41414B432C4D41437842462C454141552C47414147472C5341432B422C4B41';
wwv_flow_imp.g_varchar2_table(319) := '413143724F2C4B41414B71422C4B41414D2C654141674230422C57414337426B4C2C45414147452C4B41414B432C4D414151462C4B41476C4233482C454141472C67434141694370472C4741436C432C6B424143412C534141576B472C4541414F34482C';
wwv_flow_imp.g_varchar2_table(320) := '47414368422C49414149432C45414159442C45414147452C4B41414B432C4D41437842462C45414159412C45414155394D2C4B41414B2C53414157432C4741734370432C4F41724332442C494141744472422C4B41414B432C4F4141512C364241413842';
wwv_flow_imp.g_varchar2_table(321) := '79452C4F4143394372442C4541414B674E2C554141572C4741456842684E2C4541414B674E2C554141572C4541434B2C364241416842684E2C4541414B4B2C5141454E31422C4B414347432C4F4141512C79434143526B422C4B41414D2C714441434E75';
wwv_flow_imp.g_varchar2_table(322) := '442C4F4141532C4941455A72442C4541414B674E2C554141572C474147432C364241416842684E2C4541414B4B2C5141454E31422C4B414347432C4F4141512C79434143526B422C4B41414D2C6F4441434E75442C4F4141532C4941455A72442C454141';
wwv_flow_imp.g_varchar2_table(323) := '4B674E2C554141572C474147432C694341416842684E2C4541414B4B2C5141454E31422C4B414347432C4F4141512C79434143526B422C4B4143432C6F444143412C6D4441434175442C4F4141532C4941456272442C4541414B674E2C554141572C4941';
wwv_flow_imp.g_varchar2_table(324) := '4966684E2C4B414554344D2C45414147452C4B41414B432C4D414151462C4B4149704233482C454141472C36424141384270472C474141492C6B4241416B422C534141576B472C4541414F34482C47414376452C4941414971422C4541415374502C4B41';
wwv_flow_imp.g_varchar2_table(325) := '414B432C4F4141512C774341437442694F2C45414159442C45414147452C4B41414B432C4D4143704269422C45414161432C4541414F784C2C4B41414D2C554143314232452C4541415336472C4541414F2F4E2C4B41414D2C6141433142324D2C454141';
wwv_flow_imp.g_varchar2_table(326) := '59412C45414155394D2C4B41414B2C53414157432C47416570432C4D416471422C774241416842412C4541414B4B2C534143524C2C4541414B674E2C53414130422C5941416667422C474145472C774241416842684F2C4541414B4B2C534143524C2C45';
wwv_flow_imp.g_varchar2_table(327) := '41414B674E2C53414130422C5941416667422C474145472C344241416842684F2C4541414B4B2C534143524C2C4541414B674E2C534143592C5941416667422C47414132432C55414166412C474145582C6F4241416842684F2C4541414B4B2C53414352';
wwv_flow_imp.g_varchar2_table(328) := '4C2C4541414B674E2C5341434C35462C494141577A492C4B41414B71422C4B41414B2C6541416530422C5941452F4231422C4B414754344D2C45414147452C4B41414B432C4D414151462C51415174422C5341415377422C61414161432C47414570422C';
wwv_flow_imp.g_varchar2_table(329) := '49414149432C45414155442C45414165314B2C4D41414D2C4B41456E4373422C4541414579482C4B41414B34422C474141532C53414155432C4541414F76432C4741432F422F472C454141472C7142414175422B472C454141512C4D41414D77432C4941';
wwv_flow_imp.g_varchar2_table(330) := '414B2C534141552C63414933442C53414153432C654141654A2C45414167424B2C47414574432C534141494C2C45414165314B2C4D41414D2C4B41414B674C2C53414153442C45414155724F2C51414151754F2C4B414531422C714241413142462C4541';
wwv_flow_imp.g_varchar2_table(331) := '4155724F2C51414151472C4F414330422C51414131436B4F2C45414155472C63414163334A2C4F41414F344A2C53414173424A2C45414155472C63414163334A2C4F41414F364A2C614141612C65414D31472C53414153432C694241416942432C454141';
wwv_flow_imp.g_varchar2_table(332) := '63432C454141597A4C2C4741456C442C49414149304C2C45414151462C4741416742432C45414157394C2C4F4141532C454141492C4D414151384C2C454141612C4941457A4578512C4B41414B32442C4F41414F432C514143522C554143412C43414349';
wwv_flow_imp.g_varchar2_table(333) := '35422C4941414B754F2C4541434C744F2C4941414B774F2C4541434C70492C554141572C434141432C4941414974442C7142414570422C4341434968422C514141532C53414155324D2C4741456631512C4B41414B75462C57414157442C534141536F4C';
wwv_flow_imp.g_varchar2_table(334) := '2C4941453742432C53414155222C2266696C65223A22666C6F777334617065782E6A73227D';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(4704600929146008)
,p_file_name=>'js/flows4apex.js.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/css_flows4apex_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D637265617465647B6261636B67726F756E642D636F6C6F723A2364396231336221696D706F7274616E743B636F6C6F723A2334363334303021696D706F7274616E747D2E6666612D636F6C6F722D2D636F6D706C65746564';
wwv_flow_imp.g_varchar2_table(2) := '7B6261636B67726F756E642D636F6C6F723A2338633965623021696D706F7274616E743B636F6C6F723A2332383361346421696D706F7274616E747D2E6666612D636F6C6F722D2D72756E6E696E677B6261636B67726F756E642D636F6C6F723A233661';
wwv_flow_imp.g_varchar2_table(3) := '6164343221696D706F7274616E743B636F6C6F723A2366666621696D706F7274616E747D2E6666612D636F6C6F722D2D6572726F722C2E6666612D636F6C6F722D2D7465726D696E617465647B6261636B67726F756E642D636F6C6F723A236437366132';
wwv_flow_imp.g_varchar2_table(4) := '3721696D706F7274616E743B636F6C6F723A2366666621696D706F7274616E747D2E6666612D636F6C6F722D2D6572726F727B6261636B67726F756E642D636F6C6F723A2364323432336221696D706F7274616E747D2E617065782D6C6F676F2D696D67';
wwv_flow_imp.g_varchar2_table(5) := '7B6D61782D6865696768743A3235707821696D706F7274616E743B6D617267696E2D72696768743A3570787D74645B686561646572732A3D616374696F6E5F636F6C5D2C74645B686561646572732A3D636865636B626F785F636F6C5D2C746823616374';
wwv_flow_imp.g_varchar2_table(6) := '696F6E5F636F6C2C746823636865636B626F785F636F6C7B77696474683A3130707821696D706F7274616E747D2E612D4952522D6865616465727B766572746963616C2D616C69676E3A696E68657269747D2E612D4952522D6865616465724C696E6B7B';
wwv_flow_imp.g_varchar2_table(7) := '636F6C6F723A696E686572697421696D706F7274616E747D2E6666612D6467726D2D62616467657B646973706C61793A666C65783B616C69676E2D6974656D733A63656E7465723B6A7573746966792D636F6E74656E743A63656E7465727D2E73746174';
wwv_flow_imp.g_varchar2_table(8) := '75735F69636F6E7B70616464696E672D72696768743A3870787D2E6666612D6467726D2D6261646765202E66612C2E6666612D6467726D2D62616467652D746578747B70616464696E673A3470787D23666C6F772D696E7374616E6365732D7065722D73';
wwv_flow_imp.g_varchar2_table(9) := '746174757320617B636F6C6F723A696E68657269747D23617263686976655F62746E2C236465707265636174655F62746E2C236E65775F76657273696F6E5F62746E2C2372656C656173655F62746E7B6865696768743A353070787D2E696E7374616E63';
wwv_flow_imp.g_varchar2_table(10) := '652D636F756E7465722D6C696E6B7B637572736F723A706F696E7465727D74645B686561646572733D4E425F494E5354414E4345535D7B70616464696E672D6C6566743A307D2E666C6F772D72756E6E696E677B6261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(11) := '3A7267626128302C302C302C2E3035297D74645B686561646572732A3D696E7374616E63655F616374696F6E5F636F6C5D2C74645B686561646572732A3D696E7374616E63655F636865636B626F785F636F6C5D2C74645B686561646572732A3D737562';
wwv_flow_imp.g_varchar2_table(12) := '666C6F775F616374696F6E5F636F6C5D2C74645B686561646572732A3D737562666C6F775F636865636B626F785F636F6C5D2C74645B686561646572732A3D766965772D70726F636573735D2C746823696E7374616E63655F616374696F6E5F636F6C2C';
wwv_flow_imp.g_varchar2_table(13) := '746823696E7374616E63655F636865636B626F785F636F6C2C746823737562666C6F775F616374696F6E5F636F6C2C746823737562666C6F775F636865636B626F785F636F6C2C746823766965772D70726F636573737B77696474683A3130707821696D';
wwv_flow_imp.g_varchar2_table(14) := '706F7274616E747D2E742D4156504C6973742D6C6162656C2E6666612D686967686C696768742D6C6162656C7B70616464696E672D746F703A333070787D2E707263735F6576656E745F62616467652C2E707263735F7374617475735F62616467652C2E';
wwv_flow_imp.g_varchar2_table(15) := '7362666C5F7374617475735F62616467657B646973706C61793A666C65783B6A7573746966792D636F6E74656E743A63656E7465723B616C69676E2D6974656D733A63656E7465727D2E612D546162732D70616E656C2C64697623617474726962757465';
wwv_flow_imp.g_varchar2_table(16) := '732D6972207468234A534F4E7B646973706C61793A6E6F6E657D23696E7374616E63655F616374696F6E5F6469616C6F67206469762E742D466F726D2D6C6162656C436F6E7461696E65722E636F6C2D6E756C6C7B6865696768743A303B70616464696E';
wwv_flow_imp.g_varchar2_table(17) := '673A307D2E752D636F6C6F722D34342D616C6572742D746578747B636F6C6F723A2338633965623021696D706F7274616E747D2E752D636F6C6F722D33372D616C6572742D746578747B636F6C6F723A2364396231336221696D706F7274616E747D2E75';
wwv_flow_imp.g_varchar2_table(18) := '2D636F6C6F722D33352D616C6572742D746578747B636F6C6F723A2336616164343221696D706F7274616E747D2E752D636F6C6F722D33382D616C6572742D746578747B636F6C6F723A2364373661323721696D706F7274616E747D2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(19) := '2D33392D616C6572742D746578747B636F6C6F723A2364323432336221696D706F7274616E747D2E752D636F6C6F722D34342D616C6572742D62677B6261636B67726F756E642D636F6C6F723A72676261283134302C3135382C3137362C2E3135292169';
wwv_flow_imp.g_varchar2_table(20) := '6D706F7274616E747D2E752D636F6C6F722D33372D616C6572742D62677B6261636B67726F756E642D636F6C6F723A72676261283235322C3138362C332C2E31352921696D706F7274616E747D2E752D636F6C6F722D33352D616C6572742D62677B6261';
wwv_flow_imp.g_varchar2_table(21) := '636B67726F756E642D636F6C6F723A72676261283130362C3137332C36362C2E31352921696D706F7274616E747D2E752D636F6C6F722D33382D616C6572742D62677B6261636B67726F756E642D636F6C6F723A72676261283231352C3130362C33392C';
wwv_flow_imp.g_varchar2_table(22) := '2E31352921696D706F7274616E747D2E752D636F6C6F722D33392D616C6572742D62677B6261636B67726F756E642D636F6C6F723A72676261283231302C36372C35392C2E31352921696D706F7274616E747D23616374696F6E5F636F6C202E612D4952';
wwv_flow_imp.g_varchar2_table(23) := '522D6865616465724C6162656C2C23696E7374616E63655F616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C2C23737562666C6F775F616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C2C23766172696162';
wwv_flow_imp.g_varchar2_table(24) := '6C655F616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C7B70616464696E672D746F703A3870783B70616464696E672D626F74746F6D3A3870787D2E612D4952522D7461626C65207072655B636C6173732A3D6C616E6775616765';
wwv_flow_imp.g_varchar2_table(25) := '2D5D7B70616464696E673A31656D203021696D706F7274616E747D0A2F2A2320736F757263654D617070696E6755524C3D666C6F777334617065782E6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(6501580077493881)
,p_file_name=>'css/flows4apex.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414143412C6D422C434143452C6B432C434143412C75422C434147462C71422C434143';
wwv_flow_imp.g_varchar2_table(2) := '452C6B432C434143412C75422C434147462C6D422C434143452C6B432C434143412C6F422C434151462C69422C43414C412C73422C434143452C6B432C434143412C6F422C434147462C69422C434143452C6B432C43414B462C632C434143452C79422C';
wwv_flow_imp.g_varchar2_table(3) := '434143412C67422C43414B612C75422C434143452C79422C4341446A422C612C434143412C652C434143472C6F422C434147482C612C434143452C73422C434147462C69422C434143472C75422C434147482C652C434143452C592C434143412C6B422C';
wwv_flow_imp.g_varchar2_table(4) := '434143412C73422C434147462C592C434143452C69422C434147462C6D422C43414171422C6F422C4341436E422C572C43414B462C34422C434143452C612C43414B34422C592C43414139422C632C43414134432C67422C43414135422C592C43414364';
wwv_flow_imp.g_varchar2_table(5) := '2C572C434147462C73422C434143492C632C4341474A2C77422C434143492C632C43414B4A2C612C434143452C67432C43414773422C67432C434143452C6B432C434143482C2B422C434143452C69432C434143522C79422C43414A6A422C73422C4341';
wwv_flow_imp.g_varchar2_table(6) := '43412C77422C434143412C71422C434143412C75422C434143412C652C434143492C6F422C4341494A2C6F432C434143432C67422C4341536D422C69422C43414170422C6B422C43414175432C6B422C43414372432C592C434143412C73422C43414341';
wwv_flow_imp.g_varchar2_table(7) := '2C6B422C43414B462C612C434164412C79422C434165452C592C43414B462C30442C434143452C512C434143412C532C434149462C73422C434143452C75422C434145462C73422C434143452C75422C434145462C73422C434143452C75422C43414546';
wwv_flow_imp.g_varchar2_table(8) := '2C73422C434143452C75422C434145462C73422C434143452C75422C434145462C6F422C434143452C67442C434145462C6F422C434143452C38432C434145462C6F422C434143452C2B432C434145462C6F422C434143452C2B432C434145462C6F422C';
wwv_flow_imp.g_varchar2_table(9) := '434143452C38432C43414B462C38422C434144412C75432C434145412C73432C434143412C75432C434143432C652C434143412C6B422C434149442C6B432C434143432C7542222C2266696C65223A22666C6F777334617065782E637373222C22736F75';
wwv_flow_imp.g_varchar2_table(10) := '72636573436F6E74656E74223A5B222F2A20636F6C6F7220636C6173736573202A2F5C6E2E6666612D636F6C6F722D2D63726561746564207B5C6E20206261636B67726F756E642D636F6C6F723A202364396231336221696D706F7274616E743B5C6E20';
wwv_flow_imp.g_varchar2_table(11) := '20636F6C6F723A202334363334303021696D706F7274616E743B5C6E7D5C6E5C6E2E6666612D636F6C6F722D2D636F6D706C65746564207B5C6E20206261636B67726F756E642D636F6C6F723A202338633965623021696D706F7274616E743B5C6E2020';
wwv_flow_imp.g_varchar2_table(12) := '636F6C6F723A202332383361346421696D706F7274616E743B5C6E7D5C6E5C6E2E6666612D636F6C6F722D2D72756E6E696E67207B5C6E20206261636B67726F756E642D636F6C6F723A202336616164343221696D706F7274616E743B5C6E2020636F6C';
wwv_flow_imp.g_varchar2_table(13) := '6F723A20776869746521696D706F7274616E743B5C6E7D5C6E5C6E2E6666612D636F6C6F722D2D7465726D696E61746564207B5C6E20206261636B67726F756E642D636F6C6F723A202364373661323721696D706F7274616E743B5C6E2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(14) := '3A20776869746521696D706F7274616E743B5C6E7D5C6E5C6E2E6666612D636F6C6F722D2D6572726F72207B5C6E20206261636B67726F756E642D636F6C6F723A202364323432336221696D706F7274616E743B5C6E2020636F6C6F723A207768697465';
wwv_flow_imp.g_varchar2_table(15) := '21696D706F7274616E743B5C6E7D5C6E5C6E2F2A20686561646572202A2F5C6E2E617065782D6C6F676F2D696D677B5C6E20206D61782D6865696768743A3235707821696D706F7274616E743B5C6E20206D617267696E2D72696768743A3570783B5C6E';
wwv_flow_imp.g_varchar2_table(16) := '7D5C6E5C6E2F2A20706167652032202A2F5C6E5C6E746823616374696F6E5F636F6C2C2074645B686561646572732A3D5C22616374696F6E5F636F6C5C225D2C5C6E746823636865636B626F785F636F6C2C2074645B686561646572732A3D5C22636865';
wwv_flow_imp.g_varchar2_table(17) := '636B626F785F636F6C5C225D7B5C6E20202077696474683A20313070782021696D706F7274616E743B5C6E7D5C6E5C6E2E612D4952522D686561646572207B5C6E2020766572746963616C2D616C69676E3A20696E68657269743B5C6E7D5C6E5C6E2E61';
wwv_flow_imp.g_varchar2_table(18) := '2D4952522D6865616465724C696E6B7B5C6E202020636F6C6F723A20696E68657269742021696D706F7274616E743B5C6E7D5C6E5C6E2E6666612D6467726D2D62616467657B5C6E2020646973706C61793A20666C65783B5C6E2020616C69676E2D6974';
wwv_flow_imp.g_varchar2_table(19) := '656D733A2063656E7465723B5C6E20206A7573746966792D636F6E74656E743A2063656E7465723B5C6E7D5C6E5C6E2E7374617475735F69636F6E207B5C6E202070616464696E672D72696768743A203870783B5C6E7D5C6E5C6E2E6666612D6467726D';
wwv_flow_imp.g_varchar2_table(20) := '2D6261646765202E66612C202E6666612D6467726D2D62616467652D746578747B5C6E202070616464696E673A203470783B5C6E7D5C6E5C6E2F2A20706167652033202A2F5C6E5C6E23666C6F772D696E7374616E6365732D7065722D73746174757320';
wwv_flow_imp.g_varchar2_table(21) := '617B5C6E2020636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2F2A20706167652037202A2F5C6E5C6E236465707265636174655F62746E2C202372656C656173655F62746E2C2023617263686976655F62746E2C20236E65775F76657273696F6E';
wwv_flow_imp.g_varchar2_table(22) := '5F62746E7B5C6E20206865696768743A20353070783B5C6E7D5C6E5C6E2E696E7374616E63652D636F756E7465722D6C696E6B7B5C6E20202020637572736F723A20706F696E7465723B5C6E7D5C6E5C6E74645B686561646572733D5C224E425F494E53';
wwv_flow_imp.g_varchar2_table(23) := '54414E4345535C225D7B5C6E2020202070616464696E672D6C6566743A203070783B5C6E7D5C6E5C6E2F2A2070616765203130202A2F5C6E5C6E2E666C6F772D72756E6E696E677B5C6E20206261636B67726F756E642D636F6C6F723A20726762612830';
wwv_flow_imp.g_varchar2_table(24) := '2C302C302C2E3035293B5C6E7D5C6E5C6E746823696E7374616E63655F616374696F6E5F636F6C2C2074645B686561646572732A3D5C22696E7374616E63655F616374696F6E5F636F6C5C225D2C5C6E746823696E7374616E63655F636865636B626F78';
wwv_flow_imp.g_varchar2_table(25) := '5F636F6C2C2074645B686561646572732A3D5C22696E7374616E63655F636865636B626F785F636F6C5C225D2C5C6E746823737562666C6F775F616374696F6E5F636F6C2C2074645B686561646572732A3D5C22737562666C6F775F616374696F6E5F63';
wwv_flow_imp.g_varchar2_table(26) := '6F6C5C225D2C5C6E746823737562666C6F775F636865636B626F785F636F6C2C2074645B686561646572732A3D5C22737562666C6F775F636865636B626F785F636F6C5C225D2C5C6E746823766965772D70726F636573732C2074645B68656164657273';
wwv_flow_imp.g_varchar2_table(27) := '2A3D5C22766965772D70726F636573735C225D7B5C6E2020202077696474683A20313070782021696D706F7274616E743B5C6E7D5C6E5C6E2F2A20706167652031332A2F5C6E2E742D4156504C6973742D6C6162656C2E6666612D686967686C69676874';
wwv_flow_imp.g_varchar2_table(28) := '2D6C6162656C207B5C6E5C7470616464696E672D746F703A20333070783B5C6E7D5C6E5C6E64697623617474726962757465732D6972207468234A534F4E207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2F2A20626164676573202A';
wwv_flow_imp.g_varchar2_table(29) := '2F5C6E5C6E2E707263735F7374617475735F62616467652C202E707263735F6576656E745F62616467652C202E7362666C5F7374617475735F6261646765207B5C6E2020646973706C61793A20666C65783B5C6E20206A7573746966792D636F6E74656E';
wwv_flow_imp.g_varchar2_table(30) := '743A2063656E7465723B5C6E2020616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2F2A20726567696F6E20646973706C61792073656C6563746F7220666978202A2F5C6E5C6E2E612D546162732D70616E656C7B5C6E202064697370';
wwv_flow_imp.g_varchar2_table(31) := '6C61793A206E6F6E653B5C6E7D5C6E5C6E2F2A2066697820666F7220696E6C696E65206469616C6F6720696E2032312E31202A2F5C6E5C6E23696E7374616E63655F616374696F6E5F6469616C6F67206469762E742D466F726D2D6C6162656C436F6E74';
wwv_flow_imp.g_varchar2_table(32) := '61696E65722E636F6C2D6E756C6C207B5C6E20206865696768743A20303B5C6E202070616464696E673A20303B5C6E7D5C6E5C6E2F2A20706167652038202A2F5C6E2E752D636F6C6F722D34342D616C6572742D746578747B5C6E2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(33) := '2338633965623021696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D33372D616C6572742D74657874207B5C6E2020636F6C6F723A202364396231336221696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D33352D616C6572742D74';
wwv_flow_imp.g_varchar2_table(34) := '6578747B5C6E2020636F6C6F723A202336616164343221696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D33382D616C6572742D746578747B5C6E2020636F6C6F723A202364373661323721696D706F7274616E743B5C6E7D5C6E2E752D636F';
wwv_flow_imp.g_varchar2_table(35) := '6C6F722D33392D616C6572742D746578747B5C6E2020636F6C6F723A202364323432336221696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D34342D616C6572742D62677B5C6E20206261636B67726F756E642D636F6C6F723A207267626128';
wwv_flow_imp.g_varchar2_table(36) := '3134302C203135382C203137362C20302E31352921696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D33372D616C6572742D6267207B5C6E20206261636B67726F756E642D636F6C6F723A2072676261283235322C203138362C20332C20302E';
wwv_flow_imp.g_varchar2_table(37) := '31352921696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D33352D616C6572742D62677B5C6E20206261636B67726F756E642D636F6C6F723A2072676261283130362C203137332C2036362C20302E31352921696D706F7274616E743B5C6E7D';
wwv_flow_imp.g_varchar2_table(38) := '5C6E2E752D636F6C6F722D33382D616C6572742D62677B5C6E20206261636B67726F756E642D636F6C6F723A2072676261283231352C203130362C2033392C20302E31352921696D706F7274616E743B5C6E7D5C6E2E752D636F6C6F722D33392D616C65';
wwv_flow_imp.g_varchar2_table(39) := '72742D62677B5C6E20206261636B67726F756E642D636F6C6F723A2072676261283231302C2036372C2035392C20302E31352921696D706F7274616E743B5C6E7D5C6E5C6E2F2A2049522048656164657220776974682068656164657220616374696F6E';
wwv_flow_imp.g_varchar2_table(40) := '2A2F5C6E23696E7374616E63655F616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C2C205C6E23616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C2C5C6E23737562666C6F775F616374696F6E5F636F6C20';
wwv_flow_imp.g_varchar2_table(41) := '2E612D4952522D6865616465724C6162656C2C5C6E237661726961626C655F616374696F6E5F636F6C202E612D4952522D6865616465724C6162656C207B5C6E5C7470616464696E672D746F703A203870783B5C6E5C7470616464696E672D626F74746F';
wwv_flow_imp.g_varchar2_table(42) := '6D3A203870783B5C6E7D5C6E5C6E2F2A2053796E74617820686967686C696768742066697820666F72204952202A2F5C6E2E612D4952522D7461626C65207072655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C7470616464696E67';
wwv_flow_imp.g_varchar2_table(43) := '3A2031656D20302031656D20302021696D706F7274616E743B5C6E7D225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(6501813752493881)
,p_file_name=>'css/flows4apex.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_20_1_flows4apex_dark_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A427574746F6E20696E20466C6F7720456469742070616765206E65787420746F2076657273696F6E20616E6420737461747573206669656C732A2F0D0A0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F';
wwv_flow_imp.g_varchar2_table(2) := '74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E6729207B0D';
wwv_flow_imp.g_varchar2_table(3) := '0A20206261636B67726F756E642D636F6C6F723A20233463346535302021696D706F7274616E743B0D0A2020636F6C6F723A202366666621696D706F7274616E743B0D0A7D0D0A0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D4275';
wwv_flow_imp.g_varchar2_table(4) := '74746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D776172';
wwv_flow_imp.g_varchar2_table(5) := '6E696E67292E69732D6163746976652C202E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279';
wwv_flow_imp.g_varchar2_table(6) := '293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A666F6375732C202E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E';
wwv_flow_imp.g_varchar2_table(7) := '742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A686F766572207B0D0A20';
wwv_flow_imp.g_varchar2_table(8) := '206261636B67726F756E642D636F6C6F723A20233635363836612021696D706F7274616E743B0D0A7D0D0A0D0A2F2A44697361626C6564206D656E752A2F0D0A0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C6564202E';
wwv_flow_imp.g_varchar2_table(9) := '612D4D656E752D616363656C2C0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C6564202E612D4D656E752D6C6162656C207B0D0A2020636F6C6F723A726762283134342C203134362C20313437292021696D706F727461';
wwv_flow_imp.g_varchar2_table(10) := '6E743B0D0A7D0D0A0D0A2F2A495220636F6E74726F6C73207768656E20657870616E6465642A2F0D0A2E612D49472D636F6E74726F6C734C6162656C2C0D0A2E612D4952522D636F6E74726F6C734C6162656C207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(11) := '636F6C6F723A233232323632392021696D706F7274616E743B0D0A7D0D0A0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564207B0D0A2020636F6C6F723A2072676261283235342C203235';
wwv_flow_imp.g_varchar2_table(12) := '342C203235342C20302E35293B0D0A20206261636B67726F756E642D636F6C6F723A202336633663366337353B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564203E202E612D4D';
wwv_flow_imp.g_varchar2_table(13) := '656E752D696E6E6572202E612D4D656E752D737461747573436F6C2C0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564203E202E612D4D656E752D696E6E6572202E612D4D656E752D6163';
wwv_flow_imp.g_varchar2_table(14) := '63656C207B0D0A2020636F6C6F723A20726762283134342C203134362C20313437293B0D0A20206F7061636974793A20313B0D0A7D0D0A0D0A2F2A44617465207069636B65722A2F0D0A0D0A2375692D74696D657069636B65722D646976686F75722C20';
wwv_flow_imp.g_varchar2_table(15) := '2375692D74696D657069636B65722D6469766D696E757465207B0D0A20206261636B67726F756E643A20233366343234343B0D0A2020626F726465722D636F6C6F723A20233634363436343B0D0A2020626F726465722D7261646975733A203870783B0D';
wwv_flow_imp.g_varchar2_table(16) := '0A7D0D0A2375692D74696D657069636B65722D646976686F75723A686F7665722C202375692D74696D657069636B65722D6469766D696E7574653A686F766572207B0D0A20206261636B67726F756E643A20233634363436343B0D0A7D0D0A0D0A2E7569';
wwv_flow_imp.g_varchar2_table(17) := '2D646174657069636B65722D6D6F6E74682C202E75692D646174657069636B65722D79656172207B0D0A20206261636B67726F756E642D636F6C6F723A20696E68657269743B0D0A7D0D0A0D0A2F2A436F6E6669726D206469616C6F67207469746C6520';
wwv_flow_imp.g_varchar2_table(18) := '6261636B67726F756E642A2F0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D7469746C65626172207B0D0A20206261636B67726F756E642D636F6C6F723A202332323236323921696D706F7274616E743B0D0A7D0D0A0D0A2F2A';
wwv_flow_imp.g_varchar2_table(19) := '495220526F772073656C6563746F72206C6162656C2A2F0D0A2E612D4952522D726F7753656C6563746F72206C6162656C207B0D0A20636F6C6F723A236666666666662021696D706F7274616E743B0D0A7D0D0A';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(8134369338179677)
,p_file_name=>'css/20.1/flows4apex.dark.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_20_1_flows4apex_dark_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(2) := '73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67297B6261636B67726F756E642D636F6C6F723A2334633465353021696D706F7274616E743B636F6C6F723A2366666621696D706F7274616E747D2E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(3) := '73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F';
wwv_flow_imp.g_varchar2_table(4) := '74282E742D427574746F6E2D2D7761726E696E67292E69732D6163746976652C2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(5) := '427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A666F6375732C2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D42757474';
wwv_flow_imp.g_varchar2_table(6) := '6F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E69';
wwv_flow_imp.g_varchar2_table(7) := '6E67293A686F7665727B6261636B67726F756E642D636F6C6F723A2336353638366121696D706F7274616E747D2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C6564202E612D4D656E752D616363656C2C2E612D4D656E7520';
wwv_flow_imp.g_varchar2_table(8) := '2E612D4D656E752D6974656D2E69732D64697361626C6564202E612D4D656E752D6C6162656C7B636F6C6F723A2339303932393321696D706F7274616E747D2E612D49472D636F6E74726F6C734C6162656C2C2E612D4952522D636F6E74726F6C734C61';
wwv_flow_imp.g_varchar2_table(9) := '62656C2C626F6479202E75692D6469616C6F67202E75692D6469616C6F672D7469746C656261727B6261636B67726F756E642D636F6C6F723A2332323236323921696D706F7274616E747D2E612D4D656E75202E612D4D656E752D6974656D2E69732D64';
wwv_flow_imp.g_varchar2_table(10) := '697361626C65642E69732D666F63757365647B636F6C6F723A72676261283235342C3235342C3235342C2E35293B6261636B67726F756E642D636F6C6F723A2336633663366337357D2E612D4D656E75202E612D4D656E752D6974656D2E69732D646973';
wwv_flow_imp.g_varchar2_table(11) := '61626C65642E69732D666F63757365643E2E612D4D656E752D696E6E6572202E612D4D656E752D616363656C2C2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F63757365643E2E612D4D656E752D696E6E';
wwv_flow_imp.g_varchar2_table(12) := '6572202E612D4D656E752D737461747573436F6C7B636F6C6F723A233930393239333B6F7061636974793A317D2375692D74696D657069636B65722D646976686F75722C2375692D74696D657069636B65722D6469766D696E7574657B6261636B67726F';
wwv_flow_imp.g_varchar2_table(13) := '756E643A233366343234343B626F726465722D636F6C6F723A233634363436343B626F726465722D7261646975733A3870787D2375692D74696D657069636B65722D646976686F75723A686F7665722C2375692D74696D657069636B65722D6469766D69';
wwv_flow_imp.g_varchar2_table(14) := '6E7574653A686F7665727B6261636B67726F756E643A233634363436347D2E75692D646174657069636B65722D6D6F6E74682C2E75692D646174657069636B65722D796561727B6261636B67726F756E642D636F6C6F723A696E68657269747D2E612D49';
wwv_flow_imp.g_varchar2_table(15) := '52522D726F7753656C6563746F72206C6162656C7B636F6C6F723A2366666621696D706F7274616E747D0A2F2A2320736F757263654D617070696E6755524C3D666C6F777334617065782E6461726B2E6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(8134925047181290)
,p_file_name=>'css/20.1/flows4apex.dark.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_20_1_flows4apex_dark_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E6461726B2E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414145412C412C7342414173422C632C4D41416F422C69422C4D41417542';
wwv_flow_imp.g_varchar2_table(2) := '2C6B422C4D414177422C6B422C4D414177422C6D422C4341432F472C6B432C434143412C6F422C434147462C7342414173422C632C4D41416F422C69422C4D414175422C6B422C4D414177422C6B422C4D414177422C36422C4341412B422C7342414173';
wwv_flow_imp.g_varchar2_table(3) := '422C632C4D41416F422C69422C4D414175422C6B422C4D414177422C6B422C4D414177422C79422C43414132422C7342414173422C632C4D41416F422C69422C4D414175422C6B422C4D414177422C6B422C4D414177422C79422C43414333592C6B432C';
wwv_flow_imp.g_varchar2_table(4) := '43414B462C38432C434143412C38432C434143452C75422C434149462C6D422C434143412C6F422C43413842412C6D432C43413742452C6B432C434147462C32432C434143452C30422C434143412C30422C434147462C75452C434144412C32452C4341';
wwv_flow_imp.g_varchar2_table(5) := '45452C612C434143412C532C43414B462C73422C43414177422C77422C43414374422C6B422C434143412C6F422C434143412C69422C434145462C34422C43414138422C38422C43414335422C6B422C434147462C6F422C43414173422C6D422C434143';
wwv_flow_imp.g_varchar2_table(6) := '70422C77422C434153462C77422C434143432C6F42222C2266696C65223A22666C6F777334617065782E6461726B2E637373222C22736F7572636573436F6E74656E74223A5B222F2A427574746F6E20696E20466C6F7720456469742070616765206E65';
wwv_flow_imp.g_varchar2_table(7) := '787420746F2076657273696F6E20616E6420737461747573206669656C732A2F5C725C6E5C725C6E2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E67657229';
wwv_flow_imp.g_varchar2_table(8) := '3A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E6729207B5C725C6E20206261636B67726F756E642D636F6C6F723A202334';
wwv_flow_imp.g_varchar2_table(9) := '63346535302021696D706F7274616E743B5C725C6E2020636F6C6F723A202366666621696D706F7274616E743B5C725C6E7D5C725C6E5C725C6E2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F7428';
wwv_flow_imp.g_varchar2_table(10) := '2E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67292E69732D616374697665';
wwv_flow_imp.g_varchar2_table(11) := '2C202E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(12) := '2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A666F6375732C202E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E6765';
wwv_flow_imp.g_varchar2_table(13) := '72293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A686F766572207B5C725C6E20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(14) := '6F6C6F723A20233635363836612021696D706F7274616E743B5C725C6E7D5C725C6E5C725C6E2F2A44697361626C6564206D656E752A2F5C725C6E5C725C6E2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C6564202E612D4D';
wwv_flow_imp.g_varchar2_table(15) := '656E752D616363656C2C5C725C6E2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C6564202E612D4D656E752D6C6162656C207B5C725C6E2020636F6C6F723A726762283134342C203134362C20313437292021696D706F7274';
wwv_flow_imp.g_varchar2_table(16) := '616E743B5C725C6E7D5C725C6E5C725C6E2F2A495220636F6E74726F6C73207768656E20657870616E6465642A2F5C725C6E2E612D49472D636F6E74726F6C734C6162656C2C5C725C6E2E612D4952522D636F6E74726F6C734C6162656C207B5C725C6E';
wwv_flow_imp.g_varchar2_table(17) := '20206261636B67726F756E642D636F6C6F723A233232323632392021696D706F7274616E743B5C725C6E7D5C725C6E5C725C6E2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564207B5C725C6E';
wwv_flow_imp.g_varchar2_table(18) := '2020636F6C6F723A2072676261283235342C203235342C203235342C20302E35293B5C725C6E20206261636B67726F756E642D636F6C6F723A202336633663366337353B5C725C6E7D5C725C6E2E612D4D656E75202E612D4D656E752D6974656D2E6973';
wwv_flow_imp.g_varchar2_table(19) := '2D64697361626C65642E69732D666F6375736564203E202E612D4D656E752D696E6E6572202E612D4D656E752D737461747573436F6C2C5C725C6E2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F637573';
wwv_flow_imp.g_varchar2_table(20) := '6564203E202E612D4D656E752D696E6E6572202E612D4D656E752D616363656C207B5C725C6E2020636F6C6F723A20726762283134342C203134362C20313437293B5C725C6E20206F7061636974793A20313B5C725C6E7D5C725C6E5C725C6E2F2A4461';
wwv_flow_imp.g_varchar2_table(21) := '7465207069636B65722A2F5C725C6E5C725C6E2375692D74696D657069636B65722D646976686F75722C202375692D74696D657069636B65722D6469766D696E757465207B5C725C6E20206261636B67726F756E643A20233366343234343B5C725C6E20';
wwv_flow_imp.g_varchar2_table(22) := '20626F726465722D636F6C6F723A20233634363436343B5C725C6E2020626F726465722D7261646975733A203870783B5C725C6E7D5C725C6E2375692D74696D657069636B65722D646976686F75723A686F7665722C202375692D74696D657069636B65';
wwv_flow_imp.g_varchar2_table(23) := '722D6469766D696E7574653A686F766572207B5C725C6E20206261636B67726F756E643A20233634363436343B5C725C6E7D5C725C6E5C725C6E2E75692D646174657069636B65722D6D6F6E74682C202E75692D646174657069636B65722D7965617220';
wwv_flow_imp.g_varchar2_table(24) := '7B5C725C6E20206261636B67726F756E642D636F6C6F723A20696E68657269743B5C725C6E7D5C725C6E5C725C6E2F2A436F6E6669726D206469616C6F67207469746C65206261636B67726F756E642A2F5C725C6E626F6479202E75692D6469616C6F67';
wwv_flow_imp.g_varchar2_table(25) := '202E75692D6469616C6F672D7469746C65626172207B5C725C6E20206261636B67726F756E642D636F6C6F723A202332323236323921696D706F7274616E743B5C725C6E7D5C725C6E5C725C6E2F2A495220526F772073656C6563746F72206C6162656C';
wwv_flow_imp.g_varchar2_table(26) := '2A2F5C725C6E2E612D4952522D726F7753656C6563746F72206C6162656C207B5C725C6E20636F6C6F723A236666666666662021696D706F7274616E743B5C725C6E7D5C725C6E225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(8135246488181290)
,p_file_name=>'css/20.1/flows4apex.dark.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_css_prism_dark_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20507269736D4A5320312E32382E300A68747470733A2F2F707269736D6A732E636F6D2F646F776E6C6F61642E68746D6C237468656D65733D707269736D2D6F6B6169646961266C616E6775616765733D6A736F6E2B6C6F672B706C73716C2B7371';
wwv_flow_imp.g_varchar2_table(2) := '6C26706C7567696E733D6C696E652D6E756D626572732B746F6F6C6261722B636F70792D746F2D636C6970626F617264202A2F0A2F2A2A0A202A206F6B6169646961207468656D6520666F72204A6176615363726970742C2043535320616E642048544D';
wwv_flow_imp.g_varchar2_table(3) := '4C0A202A204C6F6F73656C79206261736564206F6E204D6F6E6F6B616920746578746D617465207468656D6520627920687474703A2F2F7777772E6D6F6E6F6B61692E6E6C2F0A202A2040617574686F72206F636F6469610A202A2F0A0A636F64655B63';
wwv_flow_imp.g_varchar2_table(4) := '6C6173732A3D226C616E67756167652D225D2C0A7072655B636C6173732A3D226C616E67756167652D225D207B0A09636F6C6F723A20236638663866323B0A096261636B67726F756E643A206E6F6E653B0A09746578742D736861646F773A2030203170';
wwv_flow_imp.g_varchar2_table(5) := '78207267626128302C20302C20302C20302E33293B0A09666F6E742D66616D696C793A20436F6E736F6C61732C204D6F6E61636F2C2027416E64616C65204D6F6E6F272C20275562756E7475204D6F6E6F272C206D6F6E6F73706163653B0A09666F6E74';
wwv_flow_imp.g_varchar2_table(6) := '2D73697A653A2031656D3B0A09746578742D616C69676E3A206C6566743B0A0977686974652D73706163653A207072653B0A09776F72642D73706163696E673A206E6F726D616C3B0A09776F72642D627265616B3A206E6F726D616C3B0A09776F72642D';
wwv_flow_imp.g_varchar2_table(7) := '777261703A206E6F726D616C3B0A096C696E652D6865696768743A20312E353B0A0A092D6D6F7A2D7461622D73697A653A20343B0A092D6F2D7461622D73697A653A20343B0A097461622D73697A653A20343B0A0A092D7765626B69742D68797068656E';
wwv_flow_imp.g_varchar2_table(8) := '733A206E6F6E653B0A092D6D6F7A2D68797068656E733A206E6F6E653B0A092D6D732D68797068656E733A206E6F6E653B0A0968797068656E733A206E6F6E653B0A7D0A0A2F2A20436F646520626C6F636B73202A2F0A7072655B636C6173732A3D226C';
wwv_flow_imp.g_varchar2_table(9) := '616E67756167652D225D207B0A0970616464696E673A2031656D3B0A096D617267696E3A202E35656D20303B0A096F766572666C6F773A206175746F3B0A09626F726465722D7261646975733A20302E33656D3B0A7D0A0A3A6E6F742870726529203E20';
wwv_flow_imp.g_varchar2_table(10) := '636F64655B636C6173732A3D226C616E67756167652D225D2C0A7072655B636C6173732A3D226C616E67756167652D225D207B0A096261636B67726F756E643A20233237323832323B0A7D0A0A2F2A20496E6C696E6520636F6465202A2F0A3A6E6F7428';
wwv_flow_imp.g_varchar2_table(11) := '70726529203E20636F64655B636C6173732A3D226C616E67756167652D225D207B0A0970616464696E673A202E31656D3B0A09626F726465722D7261646975733A202E33656D3B0A0977686974652D73706163653A206E6F726D616C3B0A7D0A0A2E746F';
wwv_flow_imp.g_varchar2_table(12) := '6B656E2E636F6D6D656E742C0A2E746F6B656E2E70726F6C6F672C0A2E746F6B656E2E646F63747970652C0A2E746F6B656E2E6364617461207B0A09636F6C6F723A20233832393261323B0A7D0A0A2E746F6B656E2E70756E6374756174696F6E207B0A';
wwv_flow_imp.g_varchar2_table(13) := '09636F6C6F723A20236638663866323B0A7D0A0A2E746F6B656E2E6E616D657370616365207B0A096F7061636974793A202E373B0A7D0A0A2E746F6B656E2E70726F70657274792C0A2E746F6B656E2E7461672C0A2E746F6B656E2E636F6E7374616E74';
wwv_flow_imp.g_varchar2_table(14) := '2C0A2E746F6B656E2E73796D626F6C2C0A2E746F6B656E2E64656C65746564207B0A09636F6C6F723A20236639323637323B0A7D0A0A2E746F6B656E2E626F6F6C65616E2C0A2E746F6B656E2E6E756D626572207B0A09636F6C6F723A20236165383166';
wwv_flow_imp.g_varchar2_table(15) := '663B0A7D0A0A2E746F6B656E2E73656C6563746F722C0A2E746F6B656E2E617474722D6E616D652C0A2E746F6B656E2E737472696E672C0A2E746F6B656E2E636861722C0A2E746F6B656E2E6275696C74696E2C0A2E746F6B656E2E696E736572746564';
wwv_flow_imp.g_varchar2_table(16) := '207B0A09636F6C6F723A20236136653232653B0A7D0A0A2E746F6B656E2E6F70657261746F722C0A2E746F6B656E2E656E746974792C0A2E746F6B656E2E75726C2C0A2E6C616E67756167652D637373202E746F6B656E2E737472696E672C0A2E737479';
wwv_flow_imp.g_varchar2_table(17) := '6C65202E746F6B656E2E737472696E672C0A2E746F6B656E2E7661726961626C65207B0A09636F6C6F723A20236638663866323B0A7D0A0A2E746F6B656E2E617472756C652C0A2E746F6B656E2E617474722D76616C75652C0A2E746F6B656E2E66756E';
wwv_flow_imp.g_varchar2_table(18) := '6374696F6E2C0A2E746F6B656E2E636C6173732D6E616D65207B0A09636F6C6F723A20236536646237343B0A7D0A0A2E746F6B656E2E6B6579776F7264207B0A09636F6C6F723A20233636643965663B0A7D0A0A2E746F6B656E2E72656765782C0A2E74';
wwv_flow_imp.g_varchar2_table(19) := '6F6B656E2E696D706F7274616E74207B0A09636F6C6F723A20236664393731663B0A7D0A0A2E746F6B656E2E696D706F7274616E742C0A2E746F6B656E2E626F6C64207B0A09666F6E742D7765696768743A20626F6C643B0A7D0A2E746F6B656E2E6974';
wwv_flow_imp.g_varchar2_table(20) := '616C6963207B0A09666F6E742D7374796C653A206974616C69633B0A7D0A0A2E746F6B656E2E656E74697479207B0A09637572736F723A2068656C703B0A7D0A0A7072655B636C6173732A3D226C616E67756167652D225D2E6C696E652D6E756D626572';
wwv_flow_imp.g_varchar2_table(21) := '73207B0A09706F736974696F6E3A2072656C61746976653B0A0970616464696E672D6C6566743A20332E38656D3B0A09636F756E7465722D72657365743A206C696E656E756D6265723B0A7D0A0A7072655B636C6173732A3D226C616E67756167652D22';
wwv_flow_imp.g_varchar2_table(22) := '5D2E6C696E652D6E756D62657273203E20636F6465207B0A09706F736974696F6E3A2072656C61746976653B0A0977686974652D73706163653A20696E68657269743B0A7D0A0A2E6C696E652D6E756D62657273202E6C696E652D6E756D626572732D72';
wwv_flow_imp.g_varchar2_table(23) := '6F7773207B0A09706F736974696F6E3A206162736F6C7574653B0A09706F696E7465722D6576656E74733A206E6F6E653B0A09746F703A20303B0A09666F6E742D73697A653A20313030253B0A096C6566743A202D332E38656D3B0A0977696474683A20';
wwv_flow_imp.g_varchar2_table(24) := '33656D3B202F2A20776F726B7320666F72206C696E652D6E756D626572732062656C6F772031303030206C696E6573202A2F0A096C65747465722D73706163696E673A202D3170783B0A09626F726465722D72696768743A2031707820736F6C69642023';
wwv_flow_imp.g_varchar2_table(25) := '3939393B0A0A092D7765626B69742D757365722D73656C6563743A206E6F6E653B0A092D6D6F7A2D757365722D73656C6563743A206E6F6E653B0A092D6D732D757365722D73656C6563743A206E6F6E653B0A09757365722D73656C6563743A206E6F6E';
wwv_flow_imp.g_varchar2_table(26) := '653B0A0A7D0A0A092E6C696E652D6E756D626572732D726F7773203E207370616E207B0A0909646973706C61793A20626C6F636B3B0A0909636F756E7465722D696E6372656D656E743A206C696E656E756D6265723B0A097D0A0A09092E6C696E652D6E';
wwv_flow_imp.g_varchar2_table(27) := '756D626572732D726F7773203E207370616E3A6265666F7265207B0A090909636F6E74656E743A20636F756E746572286C696E656E756D626572293B0A090909636F6C6F723A20233939393B0A090909646973706C61793A20626C6F636B3B0A09090970';
wwv_flow_imp.g_varchar2_table(28) := '616464696E672D72696768743A20302E38656D3B0A090909746578742D616C69676E3A2072696768743B0A09097D0A0A6469762E636F64652D746F6F6C626172207B0A09706F736974696F6E3A2072656C61746976653B0A7D0A0A6469762E636F64652D';
wwv_flow_imp.g_varchar2_table(29) := '746F6F6C626172203E202E746F6F6C626172207B0A09706F736974696F6E3A206162736F6C7574653B0A097A2D696E6465783A2031303B0A09746F703A202E33656D3B0A0972696768743A202E32656D3B0A097472616E736974696F6E3A206F70616369';
wwv_flow_imp.g_varchar2_table(30) := '747920302E337320656173652D696E2D6F75743B0A096F7061636974793A20303B0A7D0A0A6469762E636F64652D746F6F6C6261723A686F766572203E202E746F6F6C626172207B0A096F7061636974793A20313B0A7D0A0A2F2A205365706172617465';
wwv_flow_imp.g_varchar2_table(31) := '206C696E6520622F632072756C657320617265207468726F776E206F75742069662073656C6563746F7220697320696E76616C69642E0A2020204945313120616E64206F6C6420456467652076657273696F6E7320646F6E277420737570706F7274203A';
wwv_flow_imp.g_varchar2_table(32) := '666F6375732D77697468696E2E202A2F0A6469762E636F64652D746F6F6C6261723A666F6375732D77697468696E203E202E746F6F6C626172207B0A096F7061636974793A20313B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C';
wwv_flow_imp.g_varchar2_table(33) := '626172203E202E746F6F6C6261722D6974656D207B0A09646973706C61793A20696E6C696E652D626C6F636B3B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E2061207B0A09';
wwv_flow_imp.g_varchar2_table(34) := '637572736F723A20706F696E7465723B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E207B0A096261636B67726F756E643A206E6F6E653B0A09626F726465';
wwv_flow_imp.g_varchar2_table(35) := '723A20303B0A09636F6C6F723A20696E68657269743B0A09666F6E743A20696E68657269743B0A096C696E652D6865696768743A206E6F726D616C3B0A096F766572666C6F773A2076697369626C653B0A0970616464696E673A20303B0A092D7765626B';
wwv_flow_imp.g_varchar2_table(36) := '69742D757365722D73656C6563743A206E6F6E653B202F2A20666F7220627574746F6E202A2F0A092D6D6F7A2D757365722D73656C6563743A206E6F6E653B0A092D6D732D757365722D73656C6563743A206E6F6E653B0A7D0A0A6469762E636F64652D';
wwv_flow_imp.g_varchar2_table(37) := '746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20612C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E2C0A6469762E636F';
wwv_flow_imp.g_varchar2_table(38) := '64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E207B0A09636F6C6F723A20236262623B0A09666F6E742D73697A653A202E38656D3B0A0970616464696E673A2030202E35656D3B0A096261';
wwv_flow_imp.g_varchar2_table(39) := '636B67726F756E643A20236635663266303B0A096261636B67726F756E643A2072676261283232342C203232342C203232342C20302E32293B0A09626F782D736861646F773A20302032707820302030207267626128302C302C302C302E32293B0A0962';
wwv_flow_imp.g_varchar2_table(40) := '6F726465722D7261646975733A202E35656D3B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A686F7665722C0A6469762E636F64652D746F6F6C626172203E202E746F';
wwv_flow_imp.g_varchar2_table(41) := '6F6C626172203E202E746F6F6C6261722D6974656D203E20613A666F6375732C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E3A686F7665722C0A6469762E636F64';
wwv_flow_imp.g_varchar2_table(42) := '652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E3A666F6375732C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E2073';
wwv_flow_imp.g_varchar2_table(43) := '70616E3A686F7665722C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E3A666F637573207B0A09636F6C6F723A20696E68657269743B0A09746578742D6465636F726174';
wwv_flow_imp.g_varchar2_table(44) := '696F6E3A206E6F6E653B0A7D0A0A';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12618555361993254)
,p_file_name=>'lib/prismjs/css/prism.dark.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_css_prism_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20507269736D4A5320312E32382E300A68747470733A2F2F707269736D6A732E636F6D2F646F776E6C6F61642E68746D6C237468656D65733D707269736D266C616E6775616765733D6A736F6E2B6C6F672B706C73716C2B73716C26706C7567696E';
wwv_flow_imp.g_varchar2_table(2) := '733D6C696E652D6E756D626572732B746F6F6C6261722B636F70792D746F2D636C6970626F617264202A2F0A2F2A2A0A202A20707269736D2E6A732064656661756C74207468656D6520666F72204A6176615363726970742C2043535320616E64204854';
wwv_flow_imp.g_varchar2_table(3) := '4D4C0A202A204261736564206F6E20646162626C65742028687474703A2F2F646162626C65742E636F6D290A202A2040617574686F72204C6561205665726F750A202A2F0A200A636F64655B636C6173732A3D226C616E67756167652D225D2C0A707265';
wwv_flow_imp.g_varchar2_table(4) := '5B636C6173732A3D226C616E67756167652D225D207B0A09636F6C6F723A20626C61636B3B0A096261636B67726F756E643A206E6F6E653B0A09746578742D736861646F773A2030203170782077686974653B0A09666F6E742D66616D696C793A20436F';
wwv_flow_imp.g_varchar2_table(5) := '6E736F6C61732C204D6F6E61636F2C2027416E64616C65204D6F6E6F272C20275562756E7475204D6F6E6F272C206D6F6E6F73706163653B0A09666F6E742D73697A653A2031656D3B0A09746578742D616C69676E3A206C6566743B0A0977686974652D';
wwv_flow_imp.g_varchar2_table(6) := '73706163653A207072653B0A09776F72642D73706163696E673A206E6F726D616C3B0A09776F72642D627265616B3A206E6F726D616C3B0A09776F72642D777261703A206E6F726D616C3B0A096C696E652D6865696768743A20312E353B0A0A092D6D6F';
wwv_flow_imp.g_varchar2_table(7) := '7A2D7461622D73697A653A20343B0A092D6F2D7461622D73697A653A20343B0A097461622D73697A653A20343B0A0A092D7765626B69742D68797068656E733A206E6F6E653B0A092D6D6F7A2D68797068656E733A206E6F6E653B0A092D6D732D687970';
wwv_flow_imp.g_varchar2_table(8) := '68656E733A206E6F6E653B0A0968797068656E733A206E6F6E653B0A7D0A0A7072655B636C6173732A3D226C616E67756167652D225D3A3A2D6D6F7A2D73656C656374696F6E2C207072655B636C6173732A3D226C616E67756167652D225D203A3A2D6D';
wwv_flow_imp.g_varchar2_table(9) := '6F7A2D73656C656374696F6E2C0A636F64655B636C6173732A3D226C616E67756167652D225D3A3A2D6D6F7A2D73656C656374696F6E2C20636F64655B636C6173732A3D226C616E67756167652D225D203A3A2D6D6F7A2D73656C656374696F6E207B0A';
wwv_flow_imp.g_varchar2_table(10) := '09746578742D736861646F773A206E6F6E653B0A096261636B67726F756E643A20236233643466633B0A7D0A0A7072655B636C6173732A3D226C616E67756167652D225D3A3A73656C656374696F6E2C207072655B636C6173732A3D226C616E67756167';
wwv_flow_imp.g_varchar2_table(11) := '652D225D203A3A73656C656374696F6E2C0A636F64655B636C6173732A3D226C616E67756167652D225D3A3A73656C656374696F6E2C20636F64655B636C6173732A3D226C616E67756167652D225D203A3A73656C656374696F6E207B0A09746578742D';
wwv_flow_imp.g_varchar2_table(12) := '736861646F773A206E6F6E653B0A096261636B67726F756E643A20236233643466633B0A7D0A0A406D65646961207072696E74207B0A09636F64655B636C6173732A3D226C616E67756167652D225D2C0A097072655B636C6173732A3D226C616E677561';
wwv_flow_imp.g_varchar2_table(13) := '67652D225D207B0A0909746578742D736861646F773A206E6F6E653B0A097D0A7D0A0A2F2A20436F646520626C6F636B73202A2F0A7072655B636C6173732A3D226C616E67756167652D225D207B0A0970616464696E673A2031656D3B0A096D61726769';
wwv_flow_imp.g_varchar2_table(14) := '6E3A202E35656D20303B0A096F766572666C6F773A206175746F3B0A7D0A0A3A6E6F742870726529203E20636F64655B636C6173732A3D226C616E67756167652D225D2C0A7072655B636C6173732A3D226C616E67756167652D225D207B0A096261636B';
wwv_flow_imp.g_varchar2_table(15) := '67726F756E643A20236635663266303B0A7D0A0A2F2A20496E6C696E6520636F6465202A2F0A3A6E6F742870726529203E20636F64655B636C6173732A3D226C616E67756167652D225D207B0A0970616464696E673A202E31656D3B0A09626F72646572';
wwv_flow_imp.g_varchar2_table(16) := '2D7261646975733A202E33656D3B0A0977686974652D73706163653A206E6F726D616C3B0A7D0A0A2E746F6B656E2E636F6D6D656E742C0A2E746F6B656E2E70726F6C6F672C0A2E746F6B656E2E646F63747970652C0A2E746F6B656E2E636461746120';
wwv_flow_imp.g_varchar2_table(17) := '7B0A09636F6C6F723A20736C617465677261793B0A7D0A0A2E746F6B656E2E70756E6374756174696F6E207B0A09636F6C6F723A20233939393B0A7D0A0A2E746F6B656E2E6E616D657370616365207B0A096F7061636974793A202E373B0A7D0A0A2E74';
wwv_flow_imp.g_varchar2_table(18) := '6F6B656E2E70726F70657274792C0A2E746F6B656E2E7461672C0A2E746F6B656E2E626F6F6C65616E2C0A2E746F6B656E2E6E756D6265722C0A2E746F6B656E2E636F6E7374616E742C0A2E746F6B656E2E73796D626F6C2C0A2E746F6B656E2E64656C';
wwv_flow_imp.g_varchar2_table(19) := '65746564207B0A09636F6C6F723A20233930353B0A7D0A0A2E746F6B656E2E73656C6563746F722C0A2E746F6B656E2E617474722D6E616D652C0A2E746F6B656E2E737472696E672C0A2E746F6B656E2E636861722C0A2E746F6B656E2E6275696C7469';
wwv_flow_imp.g_varchar2_table(20) := '6E2C0A2E746F6B656E2E696E736572746564207B0A09636F6C6F723A20233639303B0A7D0A0A2E746F6B656E2E6F70657261746F722C0A2E746F6B656E2E656E746974792C0A2E746F6B656E2E75726C2C0A2E6C616E67756167652D637373202E746F6B';
wwv_flow_imp.g_varchar2_table(21) := '656E2E737472696E672C0A2E7374796C65202E746F6B656E2E737472696E67207B0A09636F6C6F723A20233961366533613B0A092F2A2054686973206261636B67726F756E6420636F6C6F722077617320696E74656E6465642062792074686520617574';
wwv_flow_imp.g_varchar2_table(22) := '686F72206F662074686973207468656D652E202A2F0A096261636B67726F756E643A2068736C6128302C2030252C20313030252C202E35293B0A7D0A0A2E746F6B656E2E617472756C652C0A2E746F6B656E2E617474722D76616C75652C0A2E746F6B65';
wwv_flow_imp.g_varchar2_table(23) := '6E2E6B6579776F7264207B0A09636F6C6F723A20233037613B0A7D0A0A2E746F6B656E2E66756E6374696F6E2C0A2E746F6B656E2E636C6173732D6E616D65207B0A09636F6C6F723A20234444344136383B0A7D0A0A2E746F6B656E2E72656765782C0A';
wwv_flow_imp.g_varchar2_table(24) := '2E746F6B656E2E696D706F7274616E742C0A2E746F6B656E2E7661726961626C65207B0A09636F6C6F723A20236539303B0A7D0A0A2E746F6B656E2E696D706F7274616E742C0A2E746F6B656E2E626F6C64207B0A09666F6E742D7765696768743A2062';
wwv_flow_imp.g_varchar2_table(25) := '6F6C643B0A7D0A2E746F6B656E2E6974616C6963207B0A09666F6E742D7374796C653A206974616C69633B0A7D0A0A2E746F6B656E2E656E74697479207B0A09637572736F723A2068656C703B0A7D0A0A7072655B636C6173732A3D226C616E67756167';
wwv_flow_imp.g_varchar2_table(26) := '652D225D2E6C696E652D6E756D62657273207B0A09706F736974696F6E3A2072656C61746976653B0A0970616464696E672D6C6566743A20332E38656D3B0A09636F756E7465722D72657365743A206C696E656E756D6265723B0A7D0A0A7072655B636C';
wwv_flow_imp.g_varchar2_table(27) := '6173732A3D226C616E67756167652D225D2E6C696E652D6E756D62657273203E20636F6465207B0A09706F736974696F6E3A2072656C61746976653B0A0977686974652D73706163653A20696E68657269743B0A7D0A0A2E6C696E652D6E756D62657273';
wwv_flow_imp.g_varchar2_table(28) := '202E6C696E652D6E756D626572732D726F7773207B0A09706F736974696F6E3A206162736F6C7574653B0A09706F696E7465722D6576656E74733A206E6F6E653B0A09746F703A20303B0A09666F6E742D73697A653A20313030253B0A096C6566743A20';
wwv_flow_imp.g_varchar2_table(29) := '2D332E38656D3B0A0977696474683A2033656D3B202F2A20776F726B7320666F72206C696E652D6E756D626572732062656C6F772031303030206C696E6573202A2F0A096C65747465722D73706163696E673A202D3170783B0A09626F726465722D7269';
wwv_flow_imp.g_varchar2_table(30) := '6768743A2031707820736F6C696420233939393B0A0A092D7765626B69742D757365722D73656C6563743A206E6F6E653B0A092D6D6F7A2D757365722D73656C6563743A206E6F6E653B0A092D6D732D757365722D73656C6563743A206E6F6E653B0A09';
wwv_flow_imp.g_varchar2_table(31) := '757365722D73656C6563743A206E6F6E653B0A0A7D0A0A092E6C696E652D6E756D626572732D726F7773203E207370616E207B0A0909646973706C61793A20626C6F636B3B0A0909636F756E7465722D696E6372656D656E743A206C696E656E756D6265';
wwv_flow_imp.g_varchar2_table(32) := '723B0A097D0A0A09092E6C696E652D6E756D626572732D726F7773203E207370616E3A6265666F7265207B0A090909636F6E74656E743A20636F756E746572286C696E656E756D626572293B0A090909636F6C6F723A20233939393B0A09090964697370';
wwv_flow_imp.g_varchar2_table(33) := '6C61793A20626C6F636B3B0A09090970616464696E672D72696768743A20302E38656D3B0A090909746578742D616C69676E3A2072696768743B0A09097D0A0A6469762E636F64652D746F6F6C626172207B0A09706F736974696F6E3A2072656C617469';
wwv_flow_imp.g_varchar2_table(34) := '76653B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172207B0A09706F736974696F6E3A206162736F6C7574653B0A097A2D696E6465783A2031303B0A09746F703A202E33656D3B0A0972696768743A202E32656D3B0A0974';
wwv_flow_imp.g_varchar2_table(35) := '72616E736974696F6E3A206F70616369747920302E337320656173652D696E2D6F75743B0A096F7061636974793A20303B0A7D0A0A6469762E636F64652D746F6F6C6261723A686F766572203E202E746F6F6C626172207B0A096F7061636974793A2031';
wwv_flow_imp.g_varchar2_table(36) := '3B0A7D0A0A2F2A205365706172617465206C696E6520622F632072756C657320617265207468726F776E206F75742069662073656C6563746F7220697320696E76616C69642E0A2020204945313120616E64206F6C6420456467652076657273696F6E73';
wwv_flow_imp.g_varchar2_table(37) := '20646F6E277420737570706F7274203A666F6375732D77697468696E2E202A2F0A6469762E636F64652D746F6F6C6261723A666F6375732D77697468696E203E202E746F6F6C626172207B0A096F7061636974793A20313B0A7D0A0A6469762E636F6465';
wwv_flow_imp.g_varchar2_table(38) := '2D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D207B0A09646973706C61793A20696E6C696E652D626C6F636B3B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C';
wwv_flow_imp.g_varchar2_table(39) := '6261722D6974656D203E2061207B0A09637572736F723A20706F696E7465723B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E207B0A096261636B67726F75';
wwv_flow_imp.g_varchar2_table(40) := '6E643A206E6F6E653B0A09626F726465723A20303B0A09636F6C6F723A20696E68657269743B0A09666F6E743A20696E68657269743B0A096C696E652D6865696768743A206E6F726D616C3B0A096F766572666C6F773A2076697369626C653B0A097061';
wwv_flow_imp.g_varchar2_table(41) := '6464696E673A20303B0A092D7765626B69742D757365722D73656C6563743A206E6F6E653B202F2A20666F7220627574746F6E202A2F0A092D6D6F7A2D757365722D73656C6563743A206E6F6E653B0A092D6D732D757365722D73656C6563743A206E6F';
wwv_flow_imp.g_varchar2_table(42) := '6E653B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20612C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D20';
wwv_flow_imp.g_varchar2_table(43) := '3E20627574746F6E2C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E207B0A09636F6C6F723A20236262623B0A09666F6E742D73697A653A202E38656D3B0A0970616464';
wwv_flow_imp.g_varchar2_table(44) := '696E673A2030202E35656D3B0A096261636B67726F756E643A20236635663266303B0A096261636B67726F756E643A2072676261283232342C203232342C203232342C20302E32293B0A09626F782D736861646F773A2030203270782030203020726762';
wwv_flow_imp.g_varchar2_table(45) := '6128302C302C302C302E32293B0A09626F726465722D7261646975733A202E35656D3B0A7D0A0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A686F7665722C0A6469762E636F';
wwv_flow_imp.g_varchar2_table(46) := '64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A666F6375732C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F';
wwv_flow_imp.g_varchar2_table(47) := '6E3A686F7665722C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E3A666F6375732C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E';
wwv_flow_imp.g_varchar2_table(48) := '746F6F6C6261722D6974656D203E207370616E3A686F7665722C0A6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E3A666F637573207B0A09636F6C6F723A20696E68657269';
wwv_flow_imp.g_varchar2_table(49) := '743B0A09746578742D6465636F726174696F6E3A206E6F6E653B0A7D0A0A';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12618784715993271)
,p_file_name=>'lib/prismjs/css/prism.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_js_prism_js
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20507269736D4A5320312E32382E300A68747470733A2F2F707269736D6A732E636F6D2F646F776E6C6F61642E68746D6C237468656D65733D707269736D266C616E6775616765733D6A736F6E2B6C6F672B706C73716C2B73716C26706C7567696E';
wwv_flow_imp.g_varchar2_table(2) := '733D6C696E652D6E756D626572732B746F6F6C6261722B636F70792D746F2D636C6970626F617264202A2F0A2F2F2F203C7265666572656E6365206C69623D22576562576F726B6572222F3E0A0A766172205F73656C66203D2028747970656F66207769';
wwv_flow_imp.g_varchar2_table(3) := '6E646F7720213D3D2027756E646566696E656427290A093F2077696E646F772020202F2F20696620696E2062726F777365720A093A20280A090928747970656F6620576F726B6572476C6F62616C53636F706520213D3D2027756E646566696E65642720';
wwv_flow_imp.g_varchar2_table(4) := '26262073656C6620696E7374616E63656F6620576F726B6572476C6F62616C53636F7065290A0909093F2073656C66202F2F20696620696E20776F726B65720A0909093A207B7D2020202F2F20696620696E206E6F6465206A730A09293B0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(5) := '202A20507269736D3A204C696768747765696768742C20726F627573742C20656C6567616E742073796E74617820686967686C69676874696E670A202A0A202A20406C6963656E7365204D4954203C68747470733A2F2F6F70656E736F757263652E6F72';
wwv_flow_imp.g_varchar2_table(6) := '672F6C6963656E7365732F4D49543E0A202A2040617574686F72204C6561205665726F75203C68747470733A2F2F6C65612E7665726F752E6D653E0A202A20406E616D6573706163650A202A20407075626C69630A202A2F0A76617220507269736D203D';
wwv_flow_imp.g_varchar2_table(7) := '202866756E6374696F6E20285F73656C6629207B0A0A092F2F20507269766174652068656C70657220766172730A09766172206C616E67203D202F283F3A5E7C5C73296C616E67283F3A75616765293F2D285B5C772D5D2B29283F3D5C737C24292F693B';
wwv_flow_imp.g_varchar2_table(8) := '0A0976617220756E697175654964203D20303B0A0A092F2F20546865206772616D6D6172206F626A65637420666F7220706C61696E746578740A0976617220706C61696E546578744772616D6D6172203D207B7D3B0A0A0A09766172205F203D207B0A09';
wwv_flow_imp.g_varchar2_table(9) := '092F2A2A0A0909202A2042792064656661756C742C20507269736D2077696C6C20617474656D707420746F20686967686C6967687420616C6C20636F646520656C656D656E7473202862792063616C6C696E67207B406C696E6B20507269736D2E686967';
wwv_flow_imp.g_varchar2_table(10) := '686C69676874416C6C7D29206F6E207468650A0909202A2063757272656E7420706167652061667465722074686520706167652066696E6973686564206C6F6164696E672E2054686973206D6967687420626520612070726F626C656D20696620652E67';
wwv_flow_imp.g_varchar2_table(11) := '2E20796F752077616E74656420746F206173796E6368726F6E6F75736C79206C6F61640A0909202A206164646974696F6E616C206C616E677561676573206F7220706C7567696E7320796F757273656C662E0A0909202A0A0909202A2042792073657474';
wwv_flow_imp.g_varchar2_table(12) := '696E6720746869732076616C756520746F206074727565602C20507269736D2077696C6C206E6F74206175746F6D61746963616C6C7920686967686C6967687420616C6C20636F646520656C656D656E7473206F6E2074686520706167652E0A0909202A';
wwv_flow_imp.g_varchar2_table(13) := '0A0909202A20596F75206F6276696F75736C79206861766520746F206368616E676520746869732076616C7565206265666F726520746865206175746F6D6174696320686967686C69676874696E6720737461727465642E20546F20646F20746869732C';
wwv_flow_imp.g_varchar2_table(14) := '20796F752063616E2061646420616E0A0909202A20656D70747920507269736D206F626A65637420696E746F2074686520676C6F62616C2073636F7065206265666F7265206C6F6164696E672074686520507269736D20736372697074206C696B652074';
wwv_flow_imp.g_varchar2_table(15) := '6869733A0A0909202A0A0909202A206060606A730A0909202A2077696E646F772E507269736D203D2077696E646F772E507269736D207C7C207B7D3B0A0909202A20507269736D2E6D616E75616C203D20747275653B0A0909202A202F2F206164642061';
wwv_flow_imp.g_varchar2_table(16) := '206E6577203C7363726970743E20746F206C6F616420507269736D2773207363726970740A0909202A206060600A0909202A0A0909202A204064656661756C742066616C73650A0909202A204074797065207B626F6F6C65616E7D0A0909202A20406D65';
wwv_flow_imp.g_varchar2_table(17) := '6D6265726F6620507269736D0A0909202A20407075626C69630A0909202A2F0A09096D616E75616C3A205F73656C662E507269736D202626205F73656C662E507269736D2E6D616E75616C2C0A09092F2A2A0A0909202A2042792064656661756C742C20';
wwv_flow_imp.g_varchar2_table(18) := '696620507269736D20697320696E20612077656220776F726B65722C20697420617373756D6573207468617420697420697320696E206120776F726B6572206974206372656174656420697473656C662C20736F20697420757365730A0909202A206061';
wwv_flow_imp.g_varchar2_table(19) := '64644576656E744C697374656E65726020746F20636F6D6D756E696361746520776974682069747320706172656E7420696E7374616E63652E20486F77657665722C20696620796F75277265207573696E6720507269736D206D616E75616C6C7920696E';
wwv_flow_imp.g_varchar2_table(20) := '20796F75720A0909202A206F776E20776F726B65722C20796F7520646F6E27742077616E7420697420746F20646F20746869732E0A0909202A0A0909202A2042792073657474696E6720746869732076616C756520746F206074727565602C2050726973';
wwv_flow_imp.g_varchar2_table(21) := '6D2077696C6C206E6F742061646420697473206F776E206C697374656E65727320746F2074686520776F726B65722E0A0909202A0A0909202A20596F75206F6276696F75736C79206861766520746F206368616E676520746869732076616C7565206265';
wwv_flow_imp.g_varchar2_table(22) := '666F726520507269736D2065786563757465732E20546F20646F20746869732C20796F752063616E2061646420616E0A0909202A20656D70747920507269736D206F626A65637420696E746F2074686520676C6F62616C2073636F7065206265666F7265';
wwv_flow_imp.g_varchar2_table(23) := '206C6F6164696E672074686520507269736D20736372697074206C696B6520746869733A0A0909202A0A0909202A206060606A730A0909202A2077696E646F772E507269736D203D2077696E646F772E507269736D207C7C207B7D3B0A0909202A205072';
wwv_flow_imp.g_varchar2_table(24) := '69736D2E64697361626C65576F726B65724D65737361676548616E646C6572203D20747275653B0A0909202A202F2F204C6F616420507269736D2773207363726970740A0909202A206060600A0909202A0A0909202A204064656661756C742066616C73';
wwv_flow_imp.g_varchar2_table(25) := '650A0909202A204074797065207B626F6F6C65616E7D0A0909202A20406D656D6265726F6620507269736D0A0909202A20407075626C69630A0909202A2F0A090964697361626C65576F726B65724D65737361676548616E646C65723A205F73656C662E';
wwv_flow_imp.g_varchar2_table(26) := '507269736D202626205F73656C662E507269736D2E64697361626C65576F726B65724D65737361676548616E646C65722C0A0A09092F2A2A0A0909202A2041206E616D65737061636520666F72207574696C697479206D6574686F64732E0A0909202A0A';
wwv_flow_imp.g_varchar2_table(27) := '0909202A20416C6C2066756E6374696F6E20696E2074686973206E616D657370616365207468617420617265206E6F74206578706C696369746C79206D61726B6564206173205F7075626C69635F2061726520666F72205F5F696E7465726E616C207573';
wwv_flow_imp.g_varchar2_table(28) := '65206F6E6C795F5F20616E64206D61790A0909202A206368616E6765206F722064697361707065617220617420616E792074696D652E0A0909202A0A0909202A20406E616D6573706163650A0909202A20406D656D6265726F6620507269736D0A090920';
wwv_flow_imp.g_varchar2_table(29) := '2A2F0A09097574696C3A207B0A090909656E636F64653A2066756E6374696F6E20656E636F646528746F6B656E7329207B0A0909090969662028746F6B656E7320696E7374616E63656F6620546F6B656E29207B0A090909090972657475726E206E6577';
wwv_flow_imp.g_varchar2_table(30) := '20546F6B656E28746F6B656E732E747970652C20656E636F646528746F6B656E732E636F6E74656E74292C20746F6B656E732E616C696173293B0A090909097D20656C7365206966202841727261792E6973417272617928746F6B656E732929207B0A09';
wwv_flow_imp.g_varchar2_table(31) := '0909090972657475726E20746F6B656E732E6D617028656E636F6465293B0A090909097D20656C7365207B0A090909090972657475726E20746F6B656E732E7265706C616365282F262F672C202726616D703B27292E7265706C616365282F3C2F672C20';
wwv_flow_imp.g_varchar2_table(32) := '27266C743B27292E7265706C616365282F5C75303061302F672C20272027293B0A090909097D0A0909097D2C0A0A0909092F2A2A0A090909202A2052657475726E7320746865206E616D65206F66207468652074797065206F662074686520676976656E';
wwv_flow_imp.g_varchar2_table(33) := '2076616C75652E0A090909202A0A090909202A2040706172616D207B616E797D206F0A090909202A204072657475726E73207B737472696E677D0A090909202A20406578616D706C650A090909202A2074797065286E756C6C292020202020203D3D3D20';
wwv_flow_imp.g_varchar2_table(34) := '274E756C6C270A090909202A207479706528756E646566696E656429203D3D3D2027556E646566696E6564270A090909202A20747970652831323329202020202020203D3D3D20274E756D626572270A090909202A20747970652827666F6F2729202020';
wwv_flow_imp.g_varchar2_table(35) := '20203D3D3D2027537472696E67270A090909202A20747970652874727565292020202020203D3D3D2027426F6F6C65616E270A090909202A2074797065285B312C20325D29202020203D3D3D20274172726179270A090909202A2074797065287B7D2920';
wwv_flow_imp.g_varchar2_table(36) := '202020202020203D3D3D20274F626A656374270A090909202A207479706528537472696E6729202020203D3D3D202746756E6374696F6E270A090909202A2074797065282F6162632B2F29202020203D3D3D2027526567457870270A090909202A2F0A09';
wwv_flow_imp.g_varchar2_table(37) := '0909747970653A2066756E6374696F6E20286F29207B0A0909090972657475726E204F626A6563742E70726F746F747970652E746F537472696E672E63616C6C286F292E736C69636528382C202D31293B0A0909097D2C0A0A0909092F2A2A0A09090920';
wwv_flow_imp.g_varchar2_table(38) := '2A2052657475726E73206120756E69717565206E756D62657220666F722074686520676976656E206F626A6563742E204C617465722063616C6C732077696C6C207374696C6C2072657475726E207468652073616D65206E756D6265722E0A090909202A';
wwv_flow_imp.g_varchar2_table(39) := '0A090909202A2040706172616D207B4F626A6563747D206F626A0A090909202A204072657475726E73207B6E756D6265727D0A090909202A2F0A0909096F626A49643A2066756E6374696F6E20286F626A29207B0A0909090969662028216F626A5B275F';
wwv_flow_imp.g_varchar2_table(40) := '5F6964275D29207B0A09090909094F626A6563742E646566696E6550726F7065727479286F626A2C20275F5F6964272C207B2076616C75653A202B2B756E697175654964207D293B0A090909097D0A0909090972657475726E206F626A5B275F5F696427';
wwv_flow_imp.g_varchar2_table(41) := '5D3B0A0909097D2C0A0A0909092F2A2A0A090909202A20437265617465732061206465657020636C6F6E65206F662074686520676976656E206F626A6563742E0A090909202A0A090909202A20546865206D61696E20696E74656E64656420757365206F';
wwv_flow_imp.g_varchar2_table(42) := '6620746869732066756E6374696F6E20697320746F20636C6F6E65206C616E677561676520646566696E6974696F6E732E0A090909202A0A090909202A2040706172616D207B547D206F0A090909202A2040706172616D207B5265636F72643C6E756D62';
wwv_flow_imp.g_varchar2_table(43) := '65722C20616E793E7D205B766973697465645D0A090909202A204072657475726E73207B547D0A090909202A204074656D706C61746520540A090909202A2F0A090909636C6F6E653A2066756E6374696F6E2064656570436C6F6E65286F2C2076697369';
wwv_flow_imp.g_varchar2_table(44) := '74656429207B0A0909090976697369746564203D2076697369746564207C7C207B7D3B0A0A0909090976617220636C6F6E653B207661722069643B0A0909090973776974636820285F2E7574696C2E74797065286F2929207B0A09090909096361736520';
wwv_flow_imp.g_varchar2_table(45) := '274F626A656374273A0A0909090909096964203D205F2E7574696C2E6F626A4964286F293B0A09090909090969662028766973697465645B69645D29207B0A0909090909090972657475726E20766973697465645B69645D3B0A0909090909097D0A0909';
wwv_flow_imp.g_varchar2_table(46) := '09090909636C6F6E65203D202F2A2A204074797065207B5265636F72643C737472696E672C20616E793E7D202A2F20287B7D293B0A090909090909766973697465645B69645D203D20636C6F6E653B0A0A090909090909666F722028766172206B657920';
wwv_flow_imp.g_varchar2_table(47) := '696E206F29207B0A09090909090909696620286F2E6861734F776E50726F7065727479286B65792929207B0A0909090909090909636C6F6E655B6B65795D203D2064656570436C6F6E65286F5B6B65795D2C2076697369746564293B0A09090909090909';
wwv_flow_imp.g_varchar2_table(48) := '7D0A0909090909097D0A0A09090909090972657475726E202F2A2A204074797065207B616E797D202A2F2028636C6F6E65293B0A0A09090909096361736520274172726179273A0A0909090909096964203D205F2E7574696C2E6F626A4964286F293B0A';
wwv_flow_imp.g_varchar2_table(49) := '09090909090969662028766973697465645B69645D29207B0A0909090909090972657475726E20766973697465645B69645D3B0A0909090909097D0A090909090909636C6F6E65203D205B5D3B0A090909090909766973697465645B69645D203D20636C';
wwv_flow_imp.g_varchar2_table(50) := '6F6E653B0A0A090909090909282F2A2A204074797065207B41727261797D202A2F282F2A2A204074797065207B616E797D202A2F286F2929292E666F72456163682866756E6374696F6E2028762C206929207B0A09090909090909636C6F6E655B695D20';
wwv_flow_imp.g_varchar2_table(51) := '3D2064656570436C6F6E6528762C2076697369746564293B0A0909090909097D293B0A0A09090909090972657475726E202F2A2A204074797065207B616E797D202A2F2028636C6F6E65293B0A0A090909090964656661756C743A0A0909090909097265';
wwv_flow_imp.g_varchar2_table(52) := '7475726E206F3B0A090909097D0A0909097D2C0A0A0909092F2A2A0A090909202A2052657475726E732074686520507269736D206C616E6775616765206F662074686520676976656E20656C656D656E7420736574206279206120606C616E6775616765';
wwv_flow_imp.g_varchar2_table(53) := '2D7878787860206F7220606C616E672D787878786020636C6173732E0A090909202A0A090909202A204966206E6F206C616E67756167652069732073657420666F722074686520656C656D656E74206F722074686520656C656D656E7420697320606E75';
wwv_flow_imp.g_varchar2_table(54) := '6C6C60206F722060756E646566696E6564602C20606E6F6E65602077696C6C2062652072657475726E65642E0A090909202A0A090909202A2040706172616D207B456C656D656E747D20656C656D656E740A090909202A204072657475726E73207B7374';
wwv_flow_imp.g_varchar2_table(55) := '72696E677D0A090909202A2F0A0909096765744C616E67756167653A2066756E6374696F6E2028656C656D656E7429207B0A090909097768696C652028656C656D656E7429207B0A0909090909766172206D203D206C616E672E6578656328656C656D65';
wwv_flow_imp.g_varchar2_table(56) := '6E742E636C6173734E616D65293B0A0909090909696620286D29207B0A09090909090972657475726E206D5B315D2E746F4C6F7765724361736528293B0A09090909097D0A0909090909656C656D656E74203D20656C656D656E742E706172656E74456C';
wwv_flow_imp.g_varchar2_table(57) := '656D656E743B0A090909097D0A0909090972657475726E20276E6F6E65273B0A0909097D2C0A0A0909092F2A2A0A090909202A20536574732074686520507269736D20606C616E67756167652D787878786020636C617373206F66207468652067697665';
wwv_flow_imp.g_varchar2_table(58) := '6E20656C656D656E742E0A090909202A0A090909202A2040706172616D207B456C656D656E747D20656C656D656E740A090909202A2040706172616D207B737472696E677D206C616E67756167650A090909202A204072657475726E73207B766F69647D';
wwv_flow_imp.g_varchar2_table(59) := '0A090909202A2F0A0909097365744C616E67756167653A2066756E6374696F6E2028656C656D656E742C206C616E677561676529207B0A090909092F2F2072656D6F766520616C6C20606C616E67756167652D787878786020636C61737365730A090909';
wwv_flow_imp.g_varchar2_table(60) := '092F2F202874686973206D69676874206C6561766520626568696E642061206C656164696E67207370616365290A09090909656C656D656E742E636C6173734E616D65203D20656C656D656E742E636C6173734E616D652E7265706C6163652852656745';
wwv_flow_imp.g_varchar2_table(61) := '7870286C616E672C2027676927292C202727293B0A0A090909092F2F2061646420746865206E657720606C616E67756167652D787878786020636C6173730A090909092F2F20287573696E672060636C6173734C697374602077696C6C206175746F6D61';
wwv_flow_imp.g_varchar2_table(62) := '746963616C6C7920636C65616E2075702073706163657320666F72207573290A09090909656C656D656E742E636C6173734C6973742E61646428276C616E67756167652D27202B206C616E6775616765293B0A0909097D2C0A0A0909092F2A2A0A090909';
wwv_flow_imp.g_varchar2_table(63) := '202A2052657475726E73207468652073637269707420656C656D656E7420746861742069732063757272656E746C7920657865637574696E672E0A090909202A0A090909202A205468697320646F6573205F5F6E6F745F5F20776F726B20666F72206C69';
wwv_flow_imp.g_varchar2_table(64) := '6E652073637269707420656C656D656E742E0A090909202A0A090909202A204072657475726E73207B48544D4C536372697074456C656D656E74207C206E756C6C7D0A090909202A2F0A09090963757272656E745363726970743A2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(65) := '202829207B0A0909090969662028747970656F6620646F63756D656E74203D3D3D2027756E646566696E65642729207B0A090909090972657475726E206E756C6C3B0A090909097D0A09090909696620282763757272656E745363726970742720696E20';
wwv_flow_imp.g_varchar2_table(66) := '646F63756D656E742026262031203C2032202F2A206861636B20746F20747269702054532720666C6F7720616E616C79736973202A2F29207B0A090909090972657475726E202F2A2A204074797065207B616E797D202A2F2028646F63756D656E742E63';
wwv_flow_imp.g_varchar2_table(67) := '757272656E74536372697074293B0A090909097D0A0A090909092F2F204945313120776F726B61726F756E640A090909092F2F207765276C6C206765742074686520737263206F66207468652063757272656E7420736372697074206279207061727369';
wwv_flow_imp.g_varchar2_table(68) := '6E6720494531312773206572726F7220737461636B2074726163650A090909092F2F20746869732077696C6C206E6F7420776F726B20666F7220696E6C696E6520736372697074730A0A09090909747279207B0A09090909097468726F77206E65772045';
wwv_flow_imp.g_varchar2_table(69) := '72726F7228293B0A090909097D206361746368202865727229207B0A09090909092F2F204765742066696C65207372632075726C2066726F6D20737461636B2E205370656369666963616C6C7920776F726B7320776974682074686520666F726D617420';
wwv_flow_imp.g_varchar2_table(70) := '6F6620737461636B2074726163657320696E2049452E0A09090909092F2F204120737461636B2077696C6C206C6F6F6B206C696B6520746869733A0A09090909092F2F0A09090909092F2F204572726F720A09090909092F2F202020206174205F2E7574';
wwv_flow_imp.g_varchar2_table(71) := '696C2E63757272656E745363726970742028687474703A2F2F6C6F63616C686F73742F636F6D706F6E656E74732F707269736D2D636F72652E6A733A3131393A35290A09090909092F2F20202020617420476C6F62616C20636F64652028687474703A2F';
wwv_flow_imp.g_varchar2_table(72) := '2F6C6F63616C686F73742F636F6D706F6E656E74732F707269736D2D636F72652E6A733A3630363A31290A0A090909090976617220737263203D20282F6174205B5E285C725C6E5D2A5C28282E2A293A5B5E3A5D2B3A5B5E3A5D2B5C29242F692E657865';
wwv_flow_imp.g_varchar2_table(73) := '63286572722E737461636B29207C7C205B5D295B315D3B0A09090909096966202873726329207B0A0909090909097661722073637269707473203D20646F63756D656E742E676574456C656D656E747342795461674E616D65282773637269707427293B';
wwv_flow_imp.g_varchar2_table(74) := '0A090909090909666F722028766172206920696E207363726970747329207B0A0909090909090969662028736372697074735B695D2E737263203D3D2073726329207B0A090909090909090972657475726E20736372697074735B695D3B0A0909090909';
wwv_flow_imp.g_varchar2_table(75) := '09097D0A0909090909097D0A09090909097D0A090909090972657475726E206E756C6C3B0A090909097D0A0909097D2C0A0A0909092F2A2A0A090909202A2052657475726E732077686574686572206120676976656E20636C6173732069732061637469';
wwv_flow_imp.g_varchar2_table(76) := '766520666F722060656C656D656E74602E0A090909202A0A090909202A2054686520636C6173732063616E206265206163746976617465642069662060656C656D656E7460206F72206F6E65206F662069747320616E636573746F727320686173207468';
wwv_flow_imp.g_varchar2_table(77) := '6520676976656E20636C61737320616E642069742063616E2062652064656163746976617465640A090909202A2069662060656C656D656E7460206F72206F6E65206F662069747320616E636573746F72732068617320746865206E6567617465642076';
wwv_flow_imp.g_varchar2_table(78) := '657273696F6E206F662074686520676976656E20636C6173732E20546865205F6E6567617465642076657273696F6E5F206F66207468650A090909202A20676976656E20636C617373206973206A7573742074686520676976656E20636C617373207769';
wwv_flow_imp.g_varchar2_table(79) := '7468206120606E6F2D60207072656669782E0A090909202A0A090909202A20576865746865722074686520636C617373206973206163746976652069732064657465726D696E65642062792074686520636C6F7365737420616E636573746F72206F6620';
wwv_flow_imp.g_varchar2_table(80) := '60656C656D656E7460202877686572652060656C656D656E746020697473656C662069730A090909202A20636C6F7365737420616E636573746F72292074686174206861732074686520676976656E20636C617373206F7220746865206E656761746564';
wwv_flow_imp.g_varchar2_table(81) := '2076657273696F6E206F662069742E204966206E6569746865722060656C656D656E7460206E6F7220616E79206F66206974730A090909202A20616E636573746F727320686176652074686520676976656E20636C617373206F7220746865206E656761';
wwv_flow_imp.g_varchar2_table(82) := '7465642076657273696F6E206F662069742C207468656E207468652064656661756C742061637469766174696F6E2077696C6C2062652072657475726E65642E0A090909202A0A090909202A20496E207468652070617261646F786963616C2073697475';
wwv_flow_imp.g_varchar2_table(83) := '6174696F6E2077686572652074686520636C6F7365737420616E636573746F7220636F6E7461696E73205F5F626F74685F5F2074686520676976656E20636C61737320616E6420746865206E6567617465640A090909202A2076657273696F6E206F6620';
wwv_flow_imp.g_varchar2_table(84) := '69742C2074686520636C61737320697320636F6E73696465726564206163746976652E0A090909202A0A090909202A2040706172616D207B456C656D656E747D20656C656D656E740A090909202A2040706172616D207B737472696E677D20636C617373';
wwv_flow_imp.g_varchar2_table(85) := '4E616D650A090909202A2040706172616D207B626F6F6C65616E7D205B64656661756C7441637469766174696F6E3D66616C73655D0A090909202A204072657475726E73207B626F6F6C65616E7D0A090909202A2F0A09090969734163746976653A2066';
wwv_flow_imp.g_varchar2_table(86) := '756E6374696F6E2028656C656D656E742C20636C6173734E616D652C2064656661756C7441637469766174696F6E29207B0A09090909766172206E6F203D20276E6F2D27202B20636C6173734E616D653B0A0A090909097768696C652028656C656D656E';
wwv_flow_imp.g_varchar2_table(87) := '7429207B0A090909090976617220636C6173734C697374203D20656C656D656E742E636C6173734C6973743B0A090909090969662028636C6173734C6973742E636F6E7461696E7328636C6173734E616D652929207B0A09090909090972657475726E20';
wwv_flow_imp.g_varchar2_table(88) := '747275653B0A09090909097D0A090909090969662028636C6173734C6973742E636F6E7461696E73286E6F2929207B0A09090909090972657475726E2066616C73653B0A09090909097D0A0909090909656C656D656E74203D20656C656D656E742E7061';
wwv_flow_imp.g_varchar2_table(89) := '72656E74456C656D656E743B0A090909097D0A0909090972657475726E20212164656661756C7441637469766174696F6E3B0A0909097D0A09097D2C0A0A09092F2A2A0A0909202A2054686973206E616D65737061636520636F6E7461696E7320616C6C';
wwv_flow_imp.g_varchar2_table(90) := '2063757272656E746C79206C6F61646564206C616E67756167657320616E642074686520736F6D652068656C7065722066756E6374696F6E7320746F2063726561746520616E64206D6F64696679206C616E6775616765732E0A0909202A0A0909202A20';
wwv_flow_imp.g_varchar2_table(91) := '406E616D6573706163650A0909202A20406D656D6265726F6620507269736D0A0909202A20407075626C69630A0909202A2F0A09096C616E6775616765733A207B0A0909092F2A2A0A090909202A20546865206772616D6D617220666F7220706C61696E';
wwv_flow_imp.g_varchar2_table(92) := '2C20756E666F726D617474656420746578742E0A090909202A2F0A090909706C61696E3A20706C61696E546578744772616D6D61722C0A090909706C61696E746578743A20706C61696E546578744772616D6D61722C0A090909746578743A20706C6169';
wwv_flow_imp.g_varchar2_table(93) := '6E546578744772616D6D61722C0A0909097478743A20706C61696E546578744772616D6D61722C0A0A0909092F2A2A0A090909202A20437265617465732061206465657020636F7079206F6620746865206C616E67756167652077697468207468652067';
wwv_flow_imp.g_varchar2_table(94) := '6976656E20696420616E6420617070656E64732074686520676976656E20746F6B656E732E0A090909202A0A090909202A204966206120746F6B656E20696E206072656465666020616C736F206170706561727320696E2074686520636F70696564206C';
wwv_flow_imp.g_varchar2_table(95) := '616E67756167652C207468656E20746865206578697374696E6720746F6B656E20696E2074686520636F70696564206C616E67756167650A090909202A2077696C6C206265206F7665727772697474656E20617420697473206F726967696E616C20706F';
wwv_flow_imp.g_varchar2_table(96) := '736974696F6E2E0A090909202A0A090909202A2023232042657374207072616374696365730A090909202A0A090909202A2053696E63652074686520706F736974696F6E206F66206F76657277726974696E6720746F6B656E732028746F6B656E20696E';
wwv_flow_imp.g_varchar2_table(97) := '20607265646566602074686174206F766572777269746520746F6B656E7320696E2074686520636F70696564206C616E6775616765290A090909202A20646F65736E2774206D61747465722C20746865792063616E20746563686E6963616C6C79206265';
wwv_flow_imp.g_varchar2_table(98) := '20696E20616E79206F726465722E20486F77657665722C20746869732063616E20626520636F6E667573696E6720746F206F7468657273207468617420747279696E6720746F0A090909202A20756E6465727374616E6420746865206C616E6775616765';
wwv_flow_imp.g_varchar2_table(99) := '20646566696E6974696F6E20626563617573652C206E6F726D616C6C792C20746865206F72646572206F6620746F6B656E73206D61747465727320696E20507269736D206772616D6D6172732E0A090909202A0A090909202A205468657265666F72652C';
wwv_flow_imp.g_varchar2_table(100) := '20697420697320656E636F75726167656420746F206F72646572206F76657277726974696E6720746F6B656E73206163636F7264696E6720746F2074686520706F736974696F6E73206F6620746865206F7665727772697474656E20746F6B656E732E0A';
wwv_flow_imp.g_varchar2_table(101) := '090909202A20467572746865726D6F72652C20616C6C206E6F6E2D6F76657277726974696E6720746F6B656E732073686F756C6420626520706C6163656420616674657220746865206F76657277726974696E67206F6E65732E0A090909202A0A090909';
wwv_flow_imp.g_varchar2_table(102) := '202A2040706172616D207B737472696E677D20696420546865206964206F6620746865206C616E677561676520746F20657874656E642E20546869732068617320746F2062652061206B657920696E2060507269736D2E6C616E677561676573602E0A09';
wwv_flow_imp.g_varchar2_table(103) := '0909202A2040706172616D207B4772616D6D61727D20726564656620546865206E657720746F6B656E7320746F20617070656E642E0A090909202A204072657475726E73207B4772616D6D61727D20546865206E6577206C616E67756167652063726561';
wwv_flow_imp.g_varchar2_table(104) := '7465642E0A090909202A20407075626C69630A090909202A20406578616D706C650A090909202A20507269736D2E6C616E6775616765735B276373732D776974682D636F6C6F7273275D203D20507269736D2E6C616E6775616765732E657874656E6428';
wwv_flow_imp.g_varchar2_table(105) := '27637373272C207B0A090909202A20202020202F2F20507269736D2E6C616E6775616765732E63737320616C72656164792068617320612027636F6D6D656E742720746F6B656E2C20736F207468697320746F6B656E2077696C6C206F76657277726974';
wwv_flow_imp.g_varchar2_table(106) := '6520435353272027636F6D6D656E742720746F6B656E0A090909202A20202020202F2F20617420697473206F726967696E616C20706F736974696F6E0A090909202A202020202027636F6D6D656E74273A207B202E2E2E207D2C0A090909202A20202020';
wwv_flow_imp.g_varchar2_table(107) := '202F2F2043535320646F65736E2774206861766520612027636F6C6F722720746F6B656E2C20736F207468697320746F6B656E2077696C6C20626520617070656E6465640A090909202A202020202027636F6C6F72273A202F5C62283F3A7265647C6772';
wwv_flow_imp.g_varchar2_table(108) := '65656E7C626C7565295C622F0A090909202A207D293B0A090909202A2F0A090909657874656E643A2066756E6374696F6E202869642C20726564656629207B0A09090909766172206C616E67203D205F2E7574696C2E636C6F6E65285F2E6C616E677561';
wwv_flow_imp.g_varchar2_table(109) := '6765735B69645D293B0A0A09090909666F722028766172206B657920696E20726564656629207B0A09090909096C616E675B6B65795D203D2072656465665B6B65795D3B0A090909097D0A0A0909090972657475726E206C616E673B0A0909097D2C0A0A';
wwv_flow_imp.g_varchar2_table(110) := '0909092F2A2A0A090909202A20496E736572747320746F6B656E73205F6265666F72655F20616E6F7468657220746F6B656E20696E2061206C616E677561676520646566696E6974696F6E206F7220616E79206F74686572206772616D6D61722E0A0909';
wwv_flow_imp.g_varchar2_table(111) := '09202A0A090909202A2023232055736167650A090909202A0A090909202A20546869732068656C706572206D6574686F64206D616B6573206974206561737920746F206D6F64696679206578697374696E67206C616E6775616765732E20466F72206578';
wwv_flow_imp.g_varchar2_table(112) := '616D706C652C2074686520435353206C616E677561676520646566696E6974696F6E0A090909202A206E6F74206F6E6C7920646566696E65732043535320686967686C69676874696E6720666F722043535320646F63756D656E74732C2062757420616C';
wwv_flow_imp.g_varchar2_table(113) := '736F206E6565647320746F20646566696E6520686967686C69676874696E6720666F722043535320656D6265646465640A090909202A20696E2048544D4C207468726F75676820603C7374796C653E6020656C656D656E74732E20546F20646F20746869';
wwv_flow_imp.g_varchar2_table(114) := '732C206974206E6565647320746F206D6F646966792060507269736D2E6C616E6775616765732E6D61726B75706020616E6420616464207468650A090909202A20617070726F70726961746520746F6B656E732E20486F77657665722C2060507269736D';
wwv_flow_imp.g_varchar2_table(115) := '2E6C616E6775616765732E6D61726B757060206973206120726567756C6172204A617661536372697074206F626A656374206C69746572616C2C20736F20696620796F7520646F0A090909202A20746869733A0A090909202A0A090909202A206060606A';
wwv_flow_imp.g_varchar2_table(116) := '730A090909202A20507269736D2E6C616E6775616765732E6D61726B75702E7374796C65203D207B0A090909202A20202020202F2F20746F6B656E0A090909202A207D3B0A090909202A206060600A090909202A0A090909202A207468656E2074686520';
wwv_flow_imp.g_varchar2_table(117) := '607374796C656020746F6B656E2077696C6C2062652061646465642028616E642070726F636573736564292061742074686520656E642E2060696E736572744265666F72656020616C6C6F777320796F7520746F20696E7365727420746F6B656E730A09';
wwv_flow_imp.g_varchar2_table(118) := '0909202A206265666F7265206578697374696E6720746F6B656E732E20466F722074686520435353206578616D706C652061626F76652C20796F7520776F756C6420757365206974206C696B6520746869733A0A090909202A0A090909202A206060606A';
wwv_flow_imp.g_varchar2_table(119) := '730A090909202A20507269736D2E6C616E6775616765732E696E736572744265666F726528276D61726B7570272C20276364617461272C207B0A090909202A2020202020277374796C65273A207B0A090909202A2020202020202020202F2F20746F6B65';
wwv_flow_imp.g_varchar2_table(120) := '6E0A090909202A20202020207D0A090909202A207D293B0A090909202A206060600A090909202A0A090909202A202323205370656369616C2063617365730A090909202A0A090909202A20496620746865206772616D6D617273206F662060696E736964';
wwv_flow_imp.g_varchar2_table(121) := '656020616E642060696E7365727460206861766520746F6B656E732077697468207468652073616D65206E616D652C2074686520746F6B656E7320696E2060696E73696465602773206772616D6D61720A090909202A2077696C6C2062652069676E6F72';
wwv_flow_imp.g_varchar2_table(122) := '65642E0A090909202A0A090909202A2054686973206265686176696F722063616E206265207573656420746F20696E7365727420746F6B656E7320616674657220606265666F7265603A0A090909202A0A090909202A206060606A730A090909202A2050';
wwv_flow_imp.g_varchar2_table(123) := '7269736D2E6C616E6775616765732E696E736572744265666F726528276D61726B7570272C2027636F6D6D656E74272C207B0A090909202A202020202027636F6D6D656E74273A20507269736D2E6C616E6775616765732E6D61726B75702E636F6D6D65';
wwv_flow_imp.g_varchar2_table(124) := '6E742C0A090909202A20202020202F2F20746F6B656E732061667465722027636F6D6D656E74270A090909202A207D293B0A090909202A206060600A090909202A0A090909202A202323204C696D69746174696F6E730A090909202A0A090909202A2054';
wwv_flow_imp.g_varchar2_table(125) := '6865206D61696E2070726F626C656D2060696E736572744265666F7265602068617320746F20736F6C766520697320697465726174696F6E206F726465722E2053696E6365204553323031352C2074686520697465726174696F6E206F7264657220666F';
wwv_flow_imp.g_varchar2_table(126) := '72206F626A6563740A090909202A2070726F706572746965732069732067756172616E7465656420746F2062652074686520696E73657274696F6E206F72646572202865786365707420666F7220696E7465676572206B657973292062757420736F6D65';
wwv_flow_imp.g_varchar2_table(127) := '2062726F7773657273206265686176650A090909202A20646966666572656E746C79207768656E206B657973206172652064656C6574656420616E642072652D696E7365727465642E20536F2060696E736572744265666F7265602063616E2774206265';
wwv_flow_imp.g_varchar2_table(128) := '20696D706C656D656E7465642062792074656D706F726172696C790A090909202A2064656C6574696E672070726F70657274696573207768696368206973206E656365737361727920746F20696E736572742061742061726269747261727920706F7369';
wwv_flow_imp.g_varchar2_table(129) := '74696F6E732E0A090909202A0A090909202A20546F20736F6C766520746869732070726F626C656D2C2060696E736572744265666F72656020646F65736E27742061637475616C6C7920696E736572742074686520676976656E20746F6B656E7320696E';
wwv_flow_imp.g_varchar2_table(130) := '746F2074686520746172676574206F626A6563742E0A090909202A20496E73746561642C2069742077696C6C206372656174652061206E6577206F626A65637420616E64207265706C61636520616C6C207265666572656E63657320746F207468652074';
wwv_flow_imp.g_varchar2_table(131) := '6172676574206F626A656374207769746820746865206E6577206F6E652E20546869730A090909202A2063616E20626520646F6E6520776974686F75742074656D706F726172696C792064656C6574696E672070726F706572746965732C20736F207468';
wwv_flow_imp.g_varchar2_table(132) := '6520697465726174696F6E206F726465722069732077656C6C2D646566696E65642E0A090909202A0A090909202A20486F77657665722C206F6E6C79207265666572656E63657320746861742063616E20626520726561636865642066726F6D20605072';
wwv_flow_imp.g_varchar2_table(133) := '69736D2E6C616E67756167657360206F722060696E73657274602077696C6C206265207265706C616365642E20492E652E2069660A090909202A20796F7520686F6C642074686520746172676574206F626A65637420696E2061207661726961626C652C';
wwv_flow_imp.g_varchar2_table(134) := '207468656E207468652076616C7565206F6620746865207661726961626C652077696C6C206E6F74206368616E67652E0A090909202A0A090909202A206060606A730A090909202A20766172206F6C644D61726B7570203D20507269736D2E6C616E6775';
wwv_flow_imp.g_varchar2_table(135) := '616765732E6D61726B75703B0A090909202A20766172206E65774D61726B7570203D20507269736D2E6C616E6775616765732E696E736572744265666F726528276D61726B7570272C2027636F6D6D656E74272C207B202E2E2E207D293B0A090909202A';
wwv_flow_imp.g_varchar2_table(136) := '0A090909202A20617373657274286F6C644D61726B757020213D3D20507269736D2E6C616E6775616765732E6D61726B7570293B0A090909202A20617373657274286E65774D61726B7570203D3D3D20507269736D2E6C616E6775616765732E6D61726B';
wwv_flow_imp.g_varchar2_table(137) := '7570293B0A090909202A206060600A090909202A0A090909202A2040706172616D207B737472696E677D20696E73696465205468652070726F7065727479206F662060726F6F74602028652E672E2061206C616E677561676520696420696E2060507269';
wwv_flow_imp.g_varchar2_table(138) := '736D2E6C616E6775616765736029207468617420636F6E7461696E73207468650A090909202A206F626A65637420746F206265206D6F6469666965642E0A090909202A2040706172616D207B737472696E677D206265666F726520546865206B65792074';
wwv_flow_imp.g_varchar2_table(139) := '6F20696E73657274206265666F72652E0A090909202A2040706172616D207B4772616D6D61727D20696E7365727420416E206F626A65637420636F6E7461696E696E6720746865206B65792D76616C756520706169727320746F20626520696E73657274';
wwv_flow_imp.g_varchar2_table(140) := '65642E0A090909202A2040706172616D207B4F626A6563743C737472696E672C20616E793E7D205B726F6F745D20546865206F626A65637420636F6E7461696E696E672060696E73696465602C20692E652E20746865206F626A65637420746861742063';
wwv_flow_imp.g_varchar2_table(141) := '6F6E7461696E73207468650A090909202A206F626A65637420746F206265206D6F6469666965642E0A090909202A0A090909202A2044656661756C747320746F2060507269736D2E6C616E677561676573602E0A090909202A204072657475726E73207B';
wwv_flow_imp.g_varchar2_table(142) := '4772616D6D61727D20546865206E6577206772616D6D6172206F626A6563742E0A090909202A20407075626C69630A090909202A2F0A090909696E736572744265666F72653A2066756E6374696F6E2028696E736964652C206265666F72652C20696E73';
wwv_flow_imp.g_varchar2_table(143) := '6572742C20726F6F7429207B0A09090909726F6F74203D20726F6F74207C7C202F2A2A204074797065207B616E797D202A2F20285F2E6C616E677561676573293B0A09090909766172206772616D6D6172203D20726F6F745B696E736964655D3B0A0909';
wwv_flow_imp.g_varchar2_table(144) := '09092F2A2A204074797065207B4772616D6D61727D202A2F0A0909090976617220726574203D207B7D3B0A0A09090909666F72202876617220746F6B656E20696E206772616D6D617229207B0A0909090909696620286772616D6D61722E6861734F776E';
wwv_flow_imp.g_varchar2_table(145) := '50726F706572747928746F6B656E2929207B0A0A09090909090969662028746F6B656E203D3D206265666F726529207B0A09090909090909666F722028766172206E6577546F6B656E20696E20696E7365727429207B0A09090909090909096966202869';
wwv_flow_imp.g_varchar2_table(146) := '6E736572742E6861734F776E50726F7065727479286E6577546F6B656E2929207B0A0909090909090909097265745B6E6577546F6B656E5D203D20696E736572745B6E6577546F6B656E5D3B0A09090909090909097D0A090909090909097D0A09090909';
wwv_flow_imp.g_varchar2_table(147) := '09097D0A0A0909090909092F2F20446F206E6F7420696E7365727420746F6B656E20776869636820616C736F206F6363757220696E20696E736572742E205365652023313532350A0909090909096966202821696E736572742E6861734F776E50726F70';
wwv_flow_imp.g_varchar2_table(148) := '6572747928746F6B656E2929207B0A090909090909097265745B746F6B656E5D203D206772616D6D61725B746F6B656E5D3B0A0909090909097D0A09090909097D0A090909097D0A0A09090909766172206F6C64203D20726F6F745B696E736964655D3B';
wwv_flow_imp.g_varchar2_table(149) := '0A09090909726F6F745B696E736964655D203D207265743B0A0A090909092F2F20557064617465207265666572656E63657320696E206F74686572206C616E677561676520646566696E6974696F6E730A090909095F2E6C616E6775616765732E444653';
wwv_flow_imp.g_varchar2_table(150) := '285F2E6C616E6775616765732C2066756E6374696F6E20286B65792C2076616C756529207B0A09090909096966202876616C7565203D3D3D206F6C64202626206B657920213D20696E7369646529207B0A090909090909746869735B6B65795D203D2072';
wwv_flow_imp.g_varchar2_table(151) := '65743B0A09090909097D0A090909097D293B0A0A0909090972657475726E207265743B0A0909097D2C0A0A0909092F2F2054726176657273652061206C616E677561676520646566696E6974696F6E207769746820446570746820466972737420536561';
wwv_flow_imp.g_varchar2_table(152) := '7263680A0909094446533A2066756E6374696F6E20444653286F2C2063616C6C6261636B2C20747970652C207669736974656429207B0A0909090976697369746564203D2076697369746564207C7C207B7D3B0A0A09090909766172206F626A4964203D';
wwv_flow_imp.g_varchar2_table(153) := '205F2E7574696C2E6F626A49643B0A0A09090909666F722028766172206920696E206F29207B0A0909090909696620286F2E6861734F776E50726F706572747928692929207B0A09090909090963616C6C6261636B2E63616C6C286F2C20692C206F5B69';
wwv_flow_imp.g_varchar2_table(154) := '5D2C2074797065207C7C2069293B0A0A0909090909097661722070726F7065727479203D206F5B695D3B0A0909090909097661722070726F706572747954797065203D205F2E7574696C2E747970652870726F7065727479293B0A0A0909090909096966';
wwv_flow_imp.g_varchar2_table(155) := '202870726F706572747954797065203D3D3D20274F626A656374272026262021766973697465645B6F626A49642870726F7065727479295D29207B0A09090909090909766973697465645B6F626A49642870726F7065727479295D203D20747275653B0A';
wwv_flow_imp.g_varchar2_table(156) := '090909090909094446532870726F70657274792C2063616C6C6261636B2C206E756C6C2C2076697369746564293B0A0909090909097D20656C7365206966202870726F706572747954797065203D3D3D2027417272617927202626202176697369746564';
wwv_flow_imp.g_varchar2_table(157) := '5B6F626A49642870726F7065727479295D29207B0A09090909090909766973697465645B6F626A49642870726F7065727479295D203D20747275653B0A090909090909094446532870726F70657274792C2063616C6C6261636B2C20692C207669736974';
wwv_flow_imp.g_varchar2_table(158) := '6564293B0A0909090909097D0A09090909097D0A090909097D0A0909097D0A09097D2C0A0A0909706C7567696E733A207B7D2C0A0A09092F2A2A0A0909202A205468697320697320746865206D6F737420686967682D6C6576656C2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(159) := '20696E20507269736DE2809973204150492E0A0909202A204974206665746368657320616C6C2074686520656C656D656E747320746861742068617665206120602E6C616E67756167652D787878786020636C61737320616E64207468656E2063616C6C';
wwv_flow_imp.g_varchar2_table(160) := '73207B406C696E6B20507269736D2E686967686C69676874456C656D656E747D206F6E0A0909202A2065616368206F6E65206F66207468656D2E0A0909202A0A0909202A2054686973206973206571756976616C656E7420746F2060507269736D2E6869';
wwv_flow_imp.g_varchar2_table(161) := '67686C69676874416C6C556E64657228646F63756D656E742C206173796E632C2063616C6C6261636B29602E0A0909202A0A0909202A2040706172616D207B626F6F6C65616E7D205B6173796E633D66616C73655D2053616D6520617320696E207B406C';
wwv_flow_imp.g_varchar2_table(162) := '696E6B20507269736D2E686967686C69676874416C6C556E6465727D2E0A0909202A2040706172616D207B486967686C6967687443616C6C6261636B7D205B63616C6C6261636B5D2053616D6520617320696E207B406C696E6B20507269736D2E686967';
wwv_flow_imp.g_varchar2_table(163) := '686C69676874416C6C556E6465727D2E0A0909202A20406D656D6265726F6620507269736D0A0909202A20407075626C69630A0909202A2F0A0909686967686C69676874416C6C3A2066756E6374696F6E20286173796E632C2063616C6C6261636B2920';
wwv_flow_imp.g_varchar2_table(164) := '7B0A0909095F2E686967686C69676874416C6C556E64657228646F63756D656E742C206173796E632C2063616C6C6261636B293B0A09097D2C0A0A09092F2A2A0A0909202A204665746368657320616C6C207468652064657363656E64616E7473206F66';
wwv_flow_imp.g_varchar2_table(165) := '2060636F6E7461696E65726020746861742068617665206120602E6C616E67756167652D787878786020636C61737320616E64207468656E2063616C6C730A0909202A207B406C696E6B20507269736D2E686967686C69676874456C656D656E747D206F';
wwv_flow_imp.g_varchar2_table(166) := '6E2065616368206F6E65206F66207468656D2E0A0909202A0A0909202A2054686520666F6C6C6F77696E6720686F6F6B732077696C6C2062652072756E3A0A0909202A20312E20606265666F72652D686967686C69676874616C6C600A0909202A20322E';
wwv_flow_imp.g_varchar2_table(167) := '20606265666F72652D616C6C2D656C656D656E74732D686967686C69676874600A0909202A20332E20416C6C20686F6F6B73206F66207B406C696E6B20507269736D2E686967686C69676874456C656D656E747D20666F72206561636820656C656D656E';
wwv_flow_imp.g_varchar2_table(168) := '742E0A0909202A0A0909202A2040706172616D207B506172656E744E6F64657D20636F6E7461696E65722054686520726F6F7420656C656D656E742C2077686F73652064657363656E64616E747320746861742068617665206120602E6C616E67756167';
wwv_flow_imp.g_varchar2_table(169) := '652D787878786020636C6173732077696C6C20626520686967686C6967687465642E0A0909202A2040706172616D207B626F6F6C65616E7D205B6173796E633D66616C73655D2057686574686572206561636820656C656D656E7420697320746F206265';
wwv_flow_imp.g_varchar2_table(170) := '20686967686C696768746564206173796E6368726F6E6F75736C79207573696E672057656220576F726B6572732E0A0909202A2040706172616D207B486967686C6967687443616C6C6261636B7D205B63616C6C6261636B5D20416E206F7074696F6E61';
wwv_flow_imp.g_varchar2_table(171) := '6C2063616C6C6261636B20746F20626520696E766F6B6564206F6E206561636820656C656D656E742061667465722069747320686967686C69676874696E6720697320646F6E652E0A0909202A20406D656D6265726F6620507269736D0A0909202A2040';
wwv_flow_imp.g_varchar2_table(172) := '7075626C69630A0909202A2F0A0909686967686C69676874416C6C556E6465723A2066756E6374696F6E2028636F6E7461696E65722C206173796E632C2063616C6C6261636B29207B0A09090976617220656E76203D207B0A0909090963616C6C626163';
wwv_flow_imp.g_varchar2_table(173) := '6B3A2063616C6C6261636B2C0A09090909636F6E7461696E65723A20636F6E7461696E65722C0A0909090973656C6563746F723A2027636F64655B636C6173732A3D226C616E67756167652D225D2C205B636C6173732A3D226C616E67756167652D225D';
wwv_flow_imp.g_varchar2_table(174) := '20636F64652C20636F64655B636C6173732A3D226C616E672D225D2C205B636C6173732A3D226C616E672D225D20636F6465270A0909097D3B0A0A0909095F2E686F6F6B732E72756E28276265666F72652D686967686C69676874616C6C272C20656E76';
wwv_flow_imp.g_varchar2_table(175) := '293B0A0A090909656E762E656C656D656E7473203D2041727261792E70726F746F747970652E736C6963652E6170706C7928656E762E636F6E7461696E65722E717565727953656C6563746F72416C6C28656E762E73656C6563746F7229293B0A0A0909';
wwv_flow_imp.g_varchar2_table(176) := '095F2E686F6F6B732E72756E28276265666F72652D616C6C2D656C656D656E74732D686967686C69676874272C20656E76293B0A0A090909666F7220287661722069203D20302C20656C656D656E743B2028656C656D656E74203D20656E762E656C656D';
wwv_flow_imp.g_varchar2_table(177) := '656E74735B692B2B5D293B29207B0A090909095F2E686967686C69676874456C656D656E7428656C656D656E742C206173796E63203D3D3D20747275652C20656E762E63616C6C6261636B293B0A0909097D0A09097D2C0A0A09092F2A2A0A0909202A20';
wwv_flow_imp.g_varchar2_table(178) := '486967686C69676874732074686520636F646520696E7369646520612073696E676C6520656C656D656E742E0A0909202A0A0909202A2054686520666F6C6C6F77696E6720686F6F6B732077696C6C2062652072756E3A0A0909202A20312E2060626566';
wwv_flow_imp.g_varchar2_table(179) := '6F72652D73616E6974792D636865636B600A0909202A20322E20606265666F72652D686967686C69676874600A0909202A20332E20416C6C20686F6F6B73206F66207B406C696E6B20507269736D2E686967686C696768747D2E20546865736520686F6F';
wwv_flow_imp.g_varchar2_table(180) := '6B732077696C6C2062652072756E20627920616E206173796E6368726F6E6F757320776F726B657220696620606173796E6360206973206074727565602E0A0909202A20342E20606265666F72652D696E73657274600A0909202A20352E206061667465';
wwv_flow_imp.g_varchar2_table(181) := '722D686967686C69676874600A0909202A20362E2060636F6D706C657465600A0909202A0A0909202A20536F6D65207468652061626F766520686F6F6B732077696C6C20626520736B69707065642069662074686520656C656D656E7420646F65736E27';
wwv_flow_imp.g_varchar2_table(182) := '7420636F6E7461696E20616E792074657874206F72207468657265206973206E6F206772616D6D6172206C6F6164656420666F720A0909202A2074686520656C656D656E742773206C616E67756167652E0A0909202A0A0909202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(183) := '456C656D656E747D20656C656D656E742054686520656C656D656E7420636F6E7461696E696E672074686520636F64652E0A0909202A204974206D7573742068617665206120636C617373206F6620606C616E67756167652D787878786020746F206265';
wwv_flow_imp.g_varchar2_table(184) := '2070726F6365737365642C2077686572652060787878786020697320612076616C6964206C616E6775616765206964656E7469666965722E0A0909202A2040706172616D207B626F6F6C65616E7D205B6173796E633D66616C73655D2057686574686572';
wwv_flow_imp.g_varchar2_table(185) := '2074686520656C656D656E7420697320746F20626520686967686C696768746564206173796E6368726F6E6F75736C79207573696E672057656220576F726B6572730A0909202A20746F20696D70726F766520706572666F726D616E636520616E642061';
wwv_flow_imp.g_varchar2_table(186) := '766F696420626C6F636B696E6720746865205549207768656E20686967686C69676874696E672076657279206C61726765206368756E6B73206F6620636F64652E2054686973206F7074696F6E2069730A0909202A205B64697361626C65642062792064';
wwv_flow_imp.g_varchar2_table(187) := '656661756C745D2868747470733A2F2F707269736D6A732E636F6D2F6661712E68746D6C237768792D69732D6173796E6368726F6E6F75732D686967686C69676874696E672D64697361626C65642D62792D64656661756C74292E0A0909202A0A090920';
wwv_flow_imp.g_varchar2_table(188) := '2A204E6F74653A20416C6C206C616E677561676520646566696E6974696F6E7320726571756972656420746F20686967686C696768742074686520636F6465206D75737420626520696E636C7564656420696E20746865206D61696E2060707269736D2E';
wwv_flow_imp.g_varchar2_table(189) := '6A73602066696C6520666F720A0909202A206173796E6368726F6E6F757320686967686C69676874696E6720746F20776F726B2E20596F752063616E206275696C6420796F7572206F776E2062756E646C65206F6E207468650A0909202A205B446F776E';
wwv_flow_imp.g_varchar2_table(190) := '6C6F616420706167655D2868747470733A2F2F707269736D6A732E636F6D2F646F776E6C6F61642E68746D6C292E0A0909202A2040706172616D207B486967686C6967687443616C6C6261636B7D205B63616C6C6261636B5D20416E206F7074696F6E61';
wwv_flow_imp.g_varchar2_table(191) := '6C2063616C6C6261636B20746F20626520696E766F6B65642061667465722074686520686967686C69676874696E6720697320646F6E652E0A0909202A204D6F73746C792075736566756C207768656E20606173796E6360206973206074727565602C20';
wwv_flow_imp.g_varchar2_table(192) := '73696E636520696E207468617420636173652C2074686520686967686C69676874696E6720697320646F6E65206173796E6368726F6E6F75736C792E0A0909202A20406D656D6265726F6620507269736D0A0909202A20407075626C69630A0909202A2F';
wwv_flow_imp.g_varchar2_table(193) := '0A0909686967686C69676874456C656D656E743A2066756E6374696F6E2028656C656D656E742C206173796E632C2063616C6C6261636B29207B0A0909092F2F2046696E64206C616E67756167650A090909766172206C616E6775616765203D205F2E75';
wwv_flow_imp.g_varchar2_table(194) := '74696C2E6765744C616E677561676528656C656D656E74293B0A090909766172206772616D6D6172203D205F2E6C616E6775616765735B6C616E67756167655D3B0A0A0909092F2F20536574206C616E6775616765206F6E2074686520656C656D656E74';
wwv_flow_imp.g_varchar2_table(195) := '2C206966206E6F742070726573656E740A0909095F2E7574696C2E7365744C616E677561676528656C656D656E742C206C616E6775616765293B0A0A0909092F2F20536574206C616E6775616765206F6E2074686520706172656E742C20666F72207374';
wwv_flow_imp.g_varchar2_table(196) := '796C696E670A09090976617220706172656E74203D20656C656D656E742E706172656E74456C656D656E743B0A09090969662028706172656E7420262620706172656E742E6E6F64654E616D652E746F4C6F776572436173652829203D3D3D2027707265';
wwv_flow_imp.g_varchar2_table(197) := '2729207B0A090909095F2E7574696C2E7365744C616E677561676528706172656E742C206C616E6775616765293B0A0909097D0A0A09090976617220636F6465203D20656C656D656E742E74657874436F6E74656E743B0A0A09090976617220656E7620';
wwv_flow_imp.g_varchar2_table(198) := '3D207B0A09090909656C656D656E743A20656C656D656E742C0A090909096C616E67756167653A206C616E67756167652C0A090909096772616D6D61723A206772616D6D61722C0A09090909636F64653A20636F64650A0909097D3B0A0A09090966756E';
wwv_flow_imp.g_varchar2_table(199) := '6374696F6E20696E73657274486967686C696768746564436F646528686967686C696768746564436F646529207B0A09090909656E762E686967686C696768746564436F6465203D20686967686C696768746564436F64653B0A0A090909095F2E686F6F';
wwv_flow_imp.g_varchar2_table(200) := '6B732E72756E28276265666F72652D696E73657274272C20656E76293B0A0A09090909656E762E656C656D656E742E696E6E657248544D4C203D20656E762E686967686C696768746564436F64653B0A0A090909095F2E686F6F6B732E72756E28276166';
wwv_flow_imp.g_varchar2_table(201) := '7465722D686967686C69676874272C20656E76293B0A090909095F2E686F6F6B732E72756E2827636F6D706C657465272C20656E76293B0A0909090963616C6C6261636B2026262063616C6C6261636B2E63616C6C28656E762E656C656D656E74293B0A';
wwv_flow_imp.g_varchar2_table(202) := '0909097D0A0A0909095F2E686F6F6B732E72756E28276265666F72652D73616E6974792D636865636B272C20656E76293B0A0A0909092F2F20706C7567696E73206D6179206368616E67652F6164642074686520706172656E742F656C656D656E740A09';
wwv_flow_imp.g_varchar2_table(203) := '0909706172656E74203D20656E762E656C656D656E742E706172656E74456C656D656E743B0A09090969662028706172656E7420262620706172656E742E6E6F64654E616D652E746F4C6F776572436173652829203D3D3D202770726527202626202170';
wwv_flow_imp.g_varchar2_table(204) := '6172656E742E6861734174747269627574652827746162696E646578272929207B0A09090909706172656E742E7365744174747269627574652827746162696E646578272C20273027293B0A0909097D0A0A0909096966202821656E762E636F64652920';
wwv_flow_imp.g_varchar2_table(205) := '7B0A090909095F2E686F6F6B732E72756E2827636F6D706C657465272C20656E76293B0A0909090963616C6C6261636B2026262063616C6C6261636B2E63616C6C28656E762E656C656D656E74293B0A0909090972657475726E3B0A0909097D0A0A0909';
wwv_flow_imp.g_varchar2_table(206) := '095F2E686F6F6B732E72756E28276265666F72652D686967686C69676874272C20656E76293B0A0A0909096966202821656E762E6772616D6D617229207B0A09090909696E73657274486967686C696768746564436F6465285F2E7574696C2E656E636F';
wwv_flow_imp.g_varchar2_table(207) := '646528656E762E636F646529293B0A0909090972657475726E3B0A0909097D0A0A090909696620286173796E63202626205F73656C662E576F726B657229207B0A0909090976617220776F726B6572203D206E657720576F726B6572285F2E66696C656E';
wwv_flow_imp.g_varchar2_table(208) := '616D65293B0A0A09090909776F726B65722E6F6E6D657373616765203D2066756E6374696F6E202865767429207B0A0909090909696E73657274486967686C696768746564436F6465286576742E64617461293B0A090909097D3B0A0A09090909776F72';
wwv_flow_imp.g_varchar2_table(209) := '6B65722E706F73744D657373616765284A534F4E2E737472696E67696679287B0A09090909096C616E67756167653A20656E762E6C616E67756167652C0A0909090909636F64653A20656E762E636F64652C0A0909090909696D6D656469617465436C6F';
wwv_flow_imp.g_varchar2_table(210) := '73653A20747275650A090909097D29293B0A0909097D20656C7365207B0A09090909696E73657274486967686C696768746564436F6465285F2E686967686C6967687428656E762E636F64652C20656E762E6772616D6D61722C20656E762E6C616E6775';
wwv_flow_imp.g_varchar2_table(211) := '61676529293B0A0909097D0A09097D2C0A0A09092F2A2A0A0909202A204C6F772D6C6576656C2066756E6374696F6E2C206F6E6C792075736520696620796F75206B6E6F77207768617420796F75E28099726520646F696E672E20497420616363657074';
wwv_flow_imp.g_varchar2_table(212) := '73206120737472696E67206F66207465787420617320696E7075740A0909202A20616E6420746865206C616E677561676520646566696E6974696F6E7320746F207573652C20616E642072657475726E73206120737472696E6720776974682074686520';
wwv_flow_imp.g_varchar2_table(213) := '48544D4C2070726F64756365642E0A0909202A0A0909202A2054686520666F6C6C6F77696E6720686F6F6B732077696C6C2062652072756E3A0A0909202A20312E20606265666F72652D746F6B656E697A65600A0909202A20322E206061667465722D74';
wwv_flow_imp.g_varchar2_table(214) := '6F6B656E697A65600A0909202A20332E206077726170603A204F6E2065616368207B406C696E6B20546F6B656E7D2E0A0909202A0A0909202A2040706172616D207B737472696E677D2074657874204120737472696E6720776974682074686520636F64';
wwv_flow_imp.g_varchar2_table(215) := '6520746F20626520686967686C6967687465642E0A0909202A2040706172616D207B4772616D6D61727D206772616D6D617220416E206F626A65637420636F6E7461696E696E672074686520746F6B656E7320746F207573652E0A0909202A0A0909202A';
wwv_flow_imp.g_varchar2_table(216) := '20557375616C6C792061206C616E677561676520646566696E6974696F6E206C696B652060507269736D2E6C616E6775616765732E6D61726B7570602E0A0909202A2040706172616D207B737472696E677D206C616E677561676520546865206E616D65';
wwv_flow_imp.g_varchar2_table(217) := '206F6620746865206C616E677561676520646566696E6974696F6E2070617373656420746F20606772616D6D6172602E0A0909202A204072657475726E73207B737472696E677D2054686520686967686C6967687465642048544D4C2E0A0909202A2040';
wwv_flow_imp.g_varchar2_table(218) := '6D656D6265726F6620507269736D0A0909202A20407075626C69630A0909202A20406578616D706C650A0909202A20507269736D2E686967686C69676874282776617220666F6F203D20747275653B272C20507269736D2E6C616E6775616765732E6A61';
wwv_flow_imp.g_varchar2_table(219) := '76617363726970742C20276A61766173637269707427293B0A0909202A2F0A0909686967686C696768743A2066756E6374696F6E2028746578742C206772616D6D61722C206C616E677561676529207B0A09090976617220656E76203D207B0A09090909';
wwv_flow_imp.g_varchar2_table(220) := '636F64653A20746578742C0A090909096772616D6D61723A206772616D6D61722C0A090909096C616E67756167653A206C616E67756167650A0909097D3B0A0909095F2E686F6F6B732E72756E28276265666F72652D746F6B656E697A65272C20656E76';
wwv_flow_imp.g_varchar2_table(221) := '293B0A0909096966202821656E762E6772616D6D617229207B0A090909097468726F77206E6577204572726F722827546865206C616E6775616765202227202B20656E762E6C616E6775616765202B20272220686173206E6F206772616D6D61722E2729';
wwv_flow_imp.g_varchar2_table(222) := '3B0A0909097D0A090909656E762E746F6B656E73203D205F2E746F6B656E697A6528656E762E636F64652C20656E762E6772616D6D6172293B0A0909095F2E686F6F6B732E72756E282761667465722D746F6B656E697A65272C20656E76293B0A090909';
wwv_flow_imp.g_varchar2_table(223) := '72657475726E20546F6B656E2E737472696E67696679285F2E7574696C2E656E636F646528656E762E746F6B656E73292C20656E762E6C616E6775616765293B0A09097D2C0A0A09092F2A2A0A0909202A20546869732069732074686520686561727420';
wwv_flow_imp.g_varchar2_table(224) := '6F6620507269736D2C20616E6420746865206D6F7374206C6F772D6C6576656C2066756E6374696F6E20796F752063616E207573652E2049742061636365707473206120737472696E67206F66207465787420617320696E7075740A0909202A20616E64';
wwv_flow_imp.g_varchar2_table(225) := '20746865206C616E677561676520646566696E6974696F6E7320746F207573652C20616E642072657475726E7320616E20617272617920776974682074686520746F6B656E697A656420636F64652E0A0909202A0A0909202A205768656E20746865206C';
wwv_flow_imp.g_varchar2_table(226) := '616E677561676520646566696E6974696F6E20696E636C75646573206E657374656420746F6B656E732C207468652066756E6374696F6E2069732063616C6C6564207265637572736976656C79206F6E2065616368206F6620746865736520746F6B656E';
wwv_flow_imp.g_varchar2_table(227) := '732E0A0909202A0A0909202A2054686973206D6574686F6420636F756C642062652075736566756C20696E206F7468657220636F6E74657874732061732077656C6C2C20617320612076657279206372756465207061727365722E0A0909202A0A090920';
wwv_flow_imp.g_varchar2_table(228) := '2A2040706172616D207B737472696E677D2074657874204120737472696E6720776974682074686520636F646520746F20626520686967686C6967687465642E0A0909202A2040706172616D207B4772616D6D61727D206772616D6D617220416E206F62';
wwv_flow_imp.g_varchar2_table(229) := '6A65637420636F6E7461696E696E672074686520746F6B656E7320746F207573652E0A0909202A0A0909202A20557375616C6C792061206C616E677561676520646566696E6974696F6E206C696B652060507269736D2E6C616E6775616765732E6D6172';
wwv_flow_imp.g_varchar2_table(230) := '6B7570602E0A0909202A204072657475726E73207B546F6B656E53747265616D7D20416E206172726179206F6620737472696E677320616E6420746F6B656E732C206120746F6B656E2073747265616D2E0A0909202A20406D656D6265726F6620507269';
wwv_flow_imp.g_varchar2_table(231) := '736D0A0909202A20407075626C69630A0909202A20406578616D706C650A0909202A206C657420636F6465203D206076617220666F6F203D20303B603B0A0909202A206C657420746F6B656E73203D20507269736D2E746F6B656E697A6528636F64652C';
wwv_flow_imp.g_varchar2_table(232) := '20507269736D2E6C616E6775616765732E6A617661736372697074293B0A0909202A20746F6B656E732E666F724561636828746F6B656E203D3E207B0A0909202A202020202069662028746F6B656E20696E7374616E63656F6620507269736D2E546F6B';
wwv_flow_imp.g_varchar2_table(233) := '656E20262620746F6B656E2E74797065203D3D3D20276E756D6265722729207B0A0909202A202020202020202020636F6E736F6C652E6C6F672860466F756E64206E756D65726963206C69746572616C3A20247B746F6B656E2E636F6E74656E747D6029';
wwv_flow_imp.g_varchar2_table(234) := '3B0A0909202A20202020207D0A0909202A207D293B0A0909202A2F0A0909746F6B656E697A653A2066756E6374696F6E2028746578742C206772616D6D617229207B0A0909097661722072657374203D206772616D6D61722E726573743B0A0909096966';
wwv_flow_imp.g_varchar2_table(235) := '20287265737429207B0A09090909666F72202876617220746F6B656E20696E207265737429207B0A09090909096772616D6D61725B746F6B656E5D203D20726573745B746F6B656E5D3B0A090909097D0A0A0909090964656C657465206772616D6D6172';
wwv_flow_imp.g_varchar2_table(236) := '2E726573743B0A0909097D0A0A09090976617220746F6B656E4C697374203D206E6577204C696E6B65644C69737428293B0A090909616464416674657228746F6B656E4C6973742C20746F6B656E4C6973742E686561642C2074657874293B0A0A090909';
wwv_flow_imp.g_varchar2_table(237) := '6D617463684772616D6D617228746578742C20746F6B656E4C6973742C206772616D6D61722C20746F6B656E4C6973742E686561642C2030293B0A0A09090972657475726E20746F417272617928746F6B656E4C697374293B0A09097D2C0A0A09092F2A';
wwv_flow_imp.g_varchar2_table(238) := '2A0A0909202A20406E616D6573706163650A0909202A20406D656D6265726F6620507269736D0A0909202A20407075626C69630A0909202A2F0A0909686F6F6B733A207B0A090909616C6C3A207B7D2C0A0A0909092F2A2A0A090909202A204164647320';
wwv_flow_imp.g_varchar2_table(239) := '74686520676976656E2063616C6C6261636B20746F20746865206C697374206F662063616C6C6261636B7320666F722074686520676976656E20686F6F6B2E0A090909202A0A090909202A205468652063616C6C6261636B2077696C6C20626520696E76';
wwv_flow_imp.g_varchar2_table(240) := '6F6B6564207768656E2074686520686F6F6B206974206973207265676973746572656420666F722069732072756E2E0A090909202A20486F6F6B732061726520757375616C6C79206469726563746C792072756E206279206120686967686C6967687420';
wwv_flow_imp.g_varchar2_table(241) := '66756E6374696F6E2062757420796F752063616E20616C736F2072756E20686F6F6B7320796F757273656C662E0A090909202A0A090909202A204F6E652063616C6C6261636B2066756E6374696F6E2063616E206265207265676973746572656420746F';
wwv_flow_imp.g_varchar2_table(242) := '206D756C7469706C6520686F6F6B7320616E64207468652073616D6520686F6F6B206D756C7469706C652074696D65732E0A090909202A0A090909202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F66207468652068';
wwv_flow_imp.g_varchar2_table(243) := '6F6F6B2E0A090909202A2040706172616D207B486F6F6B43616C6C6261636B7D2063616C6C6261636B205468652063616C6C6261636B2066756E6374696F6E20776869636820697320676976656E20656E7669726F6E6D656E74207661726961626C6573';
wwv_flow_imp.g_varchar2_table(244) := '2E0A090909202A20407075626C69630A090909202A2F0A0909096164643A2066756E6374696F6E20286E616D652C2063616C6C6261636B29207B0A0909090976617220686F6F6B73203D205F2E686F6F6B732E616C6C3B0A0A09090909686F6F6B735B6E';
wwv_flow_imp.g_varchar2_table(245) := '616D655D203D20686F6F6B735B6E616D655D207C7C205B5D3B0A0A09090909686F6F6B735B6E616D655D2E707573682863616C6C6261636B293B0A0909097D2C0A0A0909092F2A2A0A090909202A2052756E73206120686F6F6B20696E766F6B696E6720';
wwv_flow_imp.g_varchar2_table(246) := '616C6C20726567697374657265642063616C6C6261636B7320776974682074686520676976656E20656E7669726F6E6D656E74207661726961626C65732E0A090909202A0A090909202A2043616C6C6261636B732077696C6C20626520696E766F6B6564';
wwv_flow_imp.g_varchar2_table(247) := '2073796E6368726F6E6F75736C7920616E6420696E20746865206F7264657220696E2077686963682074686579207765726520726567697374657265642E0A090909202A0A090909202A2040706172616D207B737472696E677D206E616D652054686520';
wwv_flow_imp.g_varchar2_table(248) := '6E616D65206F662074686520686F6F6B2E0A090909202A2040706172616D207B4F626A6563743C737472696E672C20616E793E7D20656E762054686520656E7669726F6E6D656E74207661726961626C6573206F662074686520686F6F6B207061737365';
wwv_flow_imp.g_varchar2_table(249) := '6420746F20616C6C2063616C6C6261636B7320726567697374657265642E0A090909202A20407075626C69630A090909202A2F0A09090972756E3A2066756E6374696F6E20286E616D652C20656E7629207B0A090909097661722063616C6C6261636B73';
wwv_flow_imp.g_varchar2_table(250) := '203D205F2E686F6F6B732E616C6C5B6E616D655D3B0A0A09090909696620282163616C6C6261636B73207C7C202163616C6C6261636B732E6C656E67746829207B0A090909090972657475726E3B0A090909097D0A0A09090909666F7220287661722069';
wwv_flow_imp.g_varchar2_table(251) := '203D20302C2063616C6C6261636B3B202863616C6C6261636B203D2063616C6C6261636B735B692B2B5D293B29207B0A090909090963616C6C6261636B28656E76293B0A090909097D0A0909097D0A09097D2C0A0A0909546F6B656E3A20546F6B656E0A';
wwv_flow_imp.g_varchar2_table(252) := '097D3B0A095F73656C662E507269736D203D205F3B0A0A0A092F2F2054797065736372697074206E6F74653A0A092F2F2054686520666F6C6C6F77696E672063616E206265207573656420746F20696D706F72742074686520546F6B656E207479706520';
wwv_flow_imp.g_varchar2_table(253) := '696E204A53446F633A0A092F2F0A092F2F2020204074797065646566207B496E7374616E6365547970653C696D706F727428222E2F707269736D2D636F726522295B22546F6B656E225D3E7D20546F6B656E0A0A092F2A2A0A09202A2043726561746573';
wwv_flow_imp.g_varchar2_table(254) := '2061206E657720746F6B656E2E0A09202A0A09202A2040706172616D207B737472696E677D207479706520536565207B406C696E6B20546F6B656E237479706520747970657D0A09202A2040706172616D207B737472696E67207C20546F6B656E537472';
wwv_flow_imp.g_varchar2_table(255) := '65616D7D20636F6E74656E7420536565207B406C696E6B20546F6B656E23636F6E74656E7420636F6E74656E747D0A09202A2040706172616D207B737472696E677C737472696E675B5D7D205B616C6961735D2054686520616C69617328657329206F66';
wwv_flow_imp.g_varchar2_table(256) := '2074686520746F6B656E2E0A09202A2040706172616D207B737472696E677D205B6D6174636865645374723D22225D204120636F7079206F66207468652066756C6C20737472696E67207468697320746F6B656E2077617320637265617465642066726F';
wwv_flow_imp.g_varchar2_table(257) := '6D2E0A09202A2040636C6173730A09202A2040676C6F62616C0A09202A20407075626C69630A09202A2F0A0966756E6374696F6E20546F6B656E28747970652C20636F6E74656E742C20616C6961732C206D61746368656453747229207B0A09092F2A2A';
wwv_flow_imp.g_varchar2_table(258) := '0A0909202A205468652074797065206F662074686520746F6B656E2E0A0909202A0A0909202A205468697320697320757375616C6C7920746865206B6579206F662061207061747465726E20696E2061207B406C696E6B204772616D6D61727D2E0A0909';
wwv_flow_imp.g_varchar2_table(259) := '202A0A0909202A204074797065207B737472696E677D0A0909202A2040736565204772616D6D6172546F6B656E0A0909202A20407075626C69630A0909202A2F0A0909746869732E74797065203D20747970653B0A09092F2A2A0A0909202A2054686520';
wwv_flow_imp.g_varchar2_table(260) := '737472696E6773206F7220746F6B656E7320636F6E7461696E6564206279207468697320746F6B656E2E0A0909202A0A0909202A20546869732077696C6C206265206120746F6B656E2073747265616D20696620746865207061747465726E206D617463';
wwv_flow_imp.g_varchar2_table(261) := '68656420616C736F20646566696E656420616E2060696E7369646560206772616D6D61722E0A0909202A0A0909202A204074797065207B737472696E67207C20546F6B656E53747265616D7D0A0909202A20407075626C69630A0909202A2F0A09097468';
wwv_flow_imp.g_varchar2_table(262) := '69732E636F6E74656E74203D20636F6E74656E743B0A09092F2A2A0A0909202A2054686520616C69617328657329206F662074686520746F6B656E2E0A0909202A0A0909202A204074797065207B737472696E677C737472696E675B5D7D0A0909202A20';
wwv_flow_imp.g_varchar2_table(263) := '40736565204772616D6D6172546F6B656E0A0909202A20407075626C69630A0909202A2F0A0909746869732E616C696173203D20616C6961733B0A09092F2F20436F7079206F66207468652066756C6C20737472696E67207468697320746F6B656E2077';
wwv_flow_imp.g_varchar2_table(264) := '617320637265617465642066726F6D0A0909746869732E6C656E677468203D20286D617463686564537472207C7C202727292E6C656E677468207C20303B0A097D0A0A092F2A2A0A09202A204120746F6B656E2073747265616D20697320616E20617272';
wwv_flow_imp.g_varchar2_table(265) := '6179206F6620737472696E677320616E64207B406C696E6B20546F6B656E20546F6B656E7D206F626A656374732E0A09202A0A09202A20546F6B656E2073747265616D73206861766520746F2066756C66696C6C2061206665772070726F706572746965';
wwv_flow_imp.g_varchar2_table(266) := '7320746861742061726520617373756D6564206279206D6F73742066756E6374696F6E7320286D6F73746C7920696E7465726E616C206F6E65732920746861742070726F636573730A09202A207468656D2E0A09202A0A09202A20312E204E6F2061646A';
wwv_flow_imp.g_varchar2_table(267) := '6163656E7420737472696E67732E0A09202A20322E204E6F20656D70747920737472696E67732E0A09202A0A09202A20202020546865206F6E6C7920657863657074696F6E20686572652069732074686520746F6B656E2073747265616D207468617420';
wwv_flow_imp.g_varchar2_table(268) := '6F6E6C7920636F6E7461696E732074686520656D70747920737472696E6720616E64206E6F7468696E6720656C73652E0A09202A0A09202A204074797065646566207B41727261793C737472696E67207C20546F6B656E3E7D20546F6B656E5374726561';
wwv_flow_imp.g_varchar2_table(269) := '6D0A09202A2040676C6F62616C0A09202A20407075626C69630A09202A2F0A0A092F2A2A0A09202A20436F6E76657274732074686520676976656E20746F6B656E206F7220746F6B656E2073747265616D20746F20616E2048544D4C2072657072657365';
wwv_flow_imp.g_varchar2_table(270) := '6E746174696F6E2E0A09202A0A09202A2054686520666F6C6C6F77696E6720686F6F6B732077696C6C2062652072756E3A0A09202A20312E206077726170603A204F6E2065616368207B406C696E6B20546F6B656E7D2E0A09202A0A09202A2040706172';
wwv_flow_imp.g_varchar2_table(271) := '616D207B737472696E67207C20546F6B656E207C20546F6B656E53747265616D7D206F2054686520746F6B656E206F7220746F6B656E2073747265616D20746F20626520636F6E7665727465642E0A09202A2040706172616D207B737472696E677D206C';
wwv_flow_imp.g_varchar2_table(272) := '616E677561676520546865206E616D65206F662063757272656E74206C616E67756167652E0A09202A204072657475726E73207B737472696E677D205468652048544D4C20726570726573656E746174696F6E206F662074686520746F6B656E206F7220';
wwv_flow_imp.g_varchar2_table(273) := '746F6B656E2073747265616D2E0A09202A20406D656D6265726F6620546F6B656E0A09202A20407374617469630A09202A2F0A09546F6B656E2E737472696E67696679203D2066756E6374696F6E20737472696E67696679286F2C206C616E6775616765';
wwv_flow_imp.g_varchar2_table(274) := '29207B0A090969662028747970656F66206F203D3D2027737472696E672729207B0A09090972657475726E206F3B0A09097D0A09096966202841727261792E69734172726179286F2929207B0A0909097661722073203D2027273B0A0909096F2E666F72';
wwv_flow_imp.g_varchar2_table(275) := '456163682866756E6374696F6E20286529207B0A0909090973202B3D20737472696E6769667928652C206C616E6775616765293B0A0909097D293B0A09090972657475726E20733B0A09097D0A0A090976617220656E76203D207B0A090909747970653A';
wwv_flow_imp.g_varchar2_table(276) := '206F2E747970652C0A090909636F6E74656E743A20737472696E67696679286F2E636F6E74656E742C206C616E6775616765292C0A0909097461673A20277370616E272C0A090909636C61737365733A205B27746F6B656E272C206F2E747970655D2C0A';
wwv_flow_imp.g_varchar2_table(277) := '090909617474726962757465733A207B7D2C0A0909096C616E67756167653A206C616E67756167650A09097D3B0A0A090976617220616C6961736573203D206F2E616C6961733B0A090969662028616C696173657329207B0A0909096966202841727261';
wwv_flow_imp.g_varchar2_table(278) := '792E6973417272617928616C69617365732929207B0A0909090941727261792E70726F746F747970652E707573682E6170706C7928656E762E636C61737365732C20616C6961736573293B0A0909097D20656C7365207B0A09090909656E762E636C6173';
wwv_flow_imp.g_varchar2_table(279) := '7365732E7075736828616C6961736573293B0A0909097D0A09097D0A0A09095F2E686F6F6B732E72756E282777726170272C20656E76293B0A0A09097661722061747472696275746573203D2027273B0A0909666F722028766172206E616D6520696E20';
wwv_flow_imp.g_varchar2_table(280) := '656E762E6174747269627574657329207B0A09090961747472696275746573202B3D20272027202B206E616D65202B20273D2227202B2028656E762E617474726962757465735B6E616D655D207C7C202727292E7265706C616365282F222F672C202726';
wwv_flow_imp.g_varchar2_table(281) := '71756F743B2729202B202722273B0A09097D0A0A090972657475726E20273C27202B20656E762E746167202B202720636C6173733D2227202B20656E762E636C61737365732E6A6F696E2827202729202B20272227202B2061747472696275746573202B';
wwv_flow_imp.g_varchar2_table(282) := '20273E27202B20656E762E636F6E74656E74202B20273C2F27202B20656E762E746167202B20273E273B0A097D3B0A0A092F2A2A0A09202A2040706172616D207B5265674578707D207061747465726E0A09202A2040706172616D207B6E756D6265727D';
wwv_flow_imp.g_varchar2_table(283) := '20706F730A09202A2040706172616D207B737472696E677D20746578740A09202A2040706172616D207B626F6F6C65616E7D206C6F6F6B626568696E640A09202A204072657475726E73207B526567457870457865634172726179207C206E756C6C7D0A';
wwv_flow_imp.g_varchar2_table(284) := '09202A2F0A0966756E6374696F6E206D617463685061747465726E287061747465726E2C20706F732C20746578742C206C6F6F6B626568696E6429207B0A09097061747465726E2E6C617374496E646578203D20706F733B0A0909766172206D61746368';
wwv_flow_imp.g_varchar2_table(285) := '203D207061747465726E2E657865632874657874293B0A0909696620286D61746368202626206C6F6F6B626568696E64202626206D617463685B315D29207B0A0909092F2F206368616E676520746865206D6174636820746F2072656D6F766520746865';
wwv_flow_imp.g_varchar2_table(286) := '2074657874206D6174636865642062792074686520507269736D206C6F6F6B626568696E642067726F75700A090909766172206C6F6F6B626568696E644C656E677468203D206D617463685B315D2E6C656E6774683B0A0909096D617463682E696E6465';
wwv_flow_imp.g_varchar2_table(287) := '78202B3D206C6F6F6B626568696E644C656E6774683B0A0909096D617463685B305D203D206D617463685B305D2E736C696365286C6F6F6B626568696E644C656E677468293B0A09097D0A090972657475726E206D617463683B0A097D0A0A092F2A2A0A';
wwv_flow_imp.g_varchar2_table(288) := '09202A2040706172616D207B737472696E677D20746578740A09202A2040706172616D207B4C696E6B65644C6973743C737472696E67207C20546F6B656E3E7D20746F6B656E4C6973740A09202A2040706172616D207B616E797D206772616D6D61720A';
wwv_flow_imp.g_varchar2_table(289) := '09202A2040706172616D207B4C696E6B65644C6973744E6F64653C737472696E67207C20546F6B656E3E7D2073746172744E6F64650A09202A2040706172616D207B6E756D6265727D207374617274506F730A09202A2040706172616D207B52656D6174';
wwv_flow_imp.g_varchar2_table(290) := '63684F7074696F6E737D205B72656D617463685D0A09202A204072657475726E73207B766F69647D0A09202A2040707269766174650A09202A0A09202A2040747970656465662052656D617463684F7074696F6E730A09202A204070726F706572747920';
wwv_flow_imp.g_varchar2_table(291) := '7B737472696E677D2063617573650A09202A204070726F7065727479207B6E756D6265727D2072656163680A09202A2F0A0966756E6374696F6E206D617463684772616D6D617228746578742C20746F6B656E4C6973742C206772616D6D61722C207374';
wwv_flow_imp.g_varchar2_table(292) := '6172744E6F64652C207374617274506F732C2072656D6174636829207B0A0909666F72202876617220746F6B656E20696E206772616D6D617229207B0A09090969662028216772616D6D61722E6861734F776E50726F706572747928746F6B656E29207C';
wwv_flow_imp.g_varchar2_table(293) := '7C20216772616D6D61725B746F6B656E5D29207B0A09090909636F6E74696E75653B0A0909097D0A0A090909766172207061747465726E73203D206772616D6D61725B746F6B656E5D3B0A0909097061747465726E73203D2041727261792E6973417272';
wwv_flow_imp.g_varchar2_table(294) := '6179287061747465726E7329203F207061747465726E73203A205B7061747465726E735D3B0A0A090909666F722028766172206A203D20303B206A203C207061747465726E732E6C656E6774683B202B2B6A29207B0A090909096966202872656D617463';
wwv_flow_imp.g_varchar2_table(295) := '682026262072656D617463682E6361757365203D3D20746F6B656E202B20272C27202B206A29207B0A090909090972657475726E3B0A090909097D0A0A09090909766172207061747465726E4F626A203D207061747465726E735B6A5D3B0A0909090976';
wwv_flow_imp.g_varchar2_table(296) := '617220696E73696465203D207061747465726E4F626A2E696E736964653B0A09090909766172206C6F6F6B626568696E64203D2021217061747465726E4F626A2E6C6F6F6B626568696E643B0A0909090976617220677265656479203D20212170617474';
wwv_flow_imp.g_varchar2_table(297) := '65726E4F626A2E6772656564793B0A0909090976617220616C696173203D207061747465726E4F626A2E616C6961733B0A0A090909096966202867726565647920262620217061747465726E4F626A2E7061747465726E2E676C6F62616C29207B0A0909';
wwv_flow_imp.g_varchar2_table(298) := '0909092F2F20576974686F75742074686520676C6F62616C20666C61672C206C617374496E64657820776F6E277420776F726B0A090909090976617220666C616773203D207061747465726E4F626A2E7061747465726E2E746F537472696E6728292E6D';
wwv_flow_imp.g_varchar2_table(299) := '61746368282F5B696D7375795D2A242F295B305D3B0A09090909097061747465726E4F626A2E7061747465726E203D20526567457870287061747465726E4F626A2E7061747465726E2E736F757263652C20666C616773202B20276727293B0A09090909';
wwv_flow_imp.g_varchar2_table(300) := '7D0A0A090909092F2A2A204074797065207B5265674578707D202A2F0A09090909766172207061747465726E203D207061747465726E4F626A2E7061747465726E207C7C207061747465726E4F626A3B0A0A09090909666F722028202F2F206974657261';
wwv_flow_imp.g_varchar2_table(301) := '74652074686520746F6B656E206C69737420616E64206B65657020747261636B206F66207468652063757272656E7420746F6B656E2F737472696E6720706F736974696F6E0A09090909097661722063757272656E744E6F6465203D2073746172744E6F';
wwv_flow_imp.g_varchar2_table(302) := '64652E6E6578742C20706F73203D207374617274506F733B0A090909090963757272656E744E6F646520213D3D20746F6B656E4C6973742E7461696C3B0A0909090909706F73202B3D2063757272656E744E6F64652E76616C75652E6C656E6774682C20';
wwv_flow_imp.g_varchar2_table(303) := '63757272656E744E6F6465203D2063757272656E744E6F64652E6E6578740A0909090929207B0A0A09090909096966202872656D6174636820262620706F73203E3D2072656D617463682E726561636829207B0A090909090909627265616B3B0A090909';
wwv_flow_imp.g_varchar2_table(304) := '09097D0A0A090909090976617220737472203D2063757272656E744E6F64652E76616C75653B0A0A090909090969662028746F6B656E4C6973742E6C656E677468203E20746578742E6C656E67746829207B0A0909090909092F2F20536F6D657468696E';
wwv_flow_imp.g_varchar2_table(305) := '672077656E74207465727269626C792077726F6E672C2041424F52542C2041424F5254210A09090909090972657475726E3B0A09090909097D0A0A09090909096966202873747220696E7374616E63656F6620546F6B656E29207B0A090909090909636F';
wwv_flow_imp.g_varchar2_table(306) := '6E74696E75653B0A09090909097D0A0A09090909097661722072656D6F7665436F756E74203D20313B202F2F20746869732069732074686520746F20706172616D65746572206F662072656D6F76654265747765656E0A0909090909766172206D617463';
wwv_flow_imp.g_varchar2_table(307) := '683B0A0A09090909096966202867726565647929207B0A0909090909096D61746368203D206D617463685061747465726E287061747465726E2C20706F732C20746578742C206C6F6F6B626568696E64293B0A09090909090969662028216D6174636820';
wwv_flow_imp.g_varchar2_table(308) := '7C7C206D617463682E696E646578203E3D20746578742E6C656E67746829207B0A09090909090909627265616B3B0A0909090909097D0A0A0909090909097661722066726F6D203D206D617463682E696E6465783B0A09090909090976617220746F203D';
wwv_flow_imp.g_varchar2_table(309) := '206D617463682E696E646578202B206D617463685B305D2E6C656E6774683B0A0909090909097661722070203D20706F733B0A0A0909090909092F2F2066696E6420746865206E6F6465207468617420636F6E7461696E7320746865206D617463680A09';
wwv_flow_imp.g_varchar2_table(310) := '090909090970202B3D2063757272656E744E6F64652E76616C75652E6C656E6774683B0A0909090909097768696C65202866726F6D203E3D207029207B0A0909090909090963757272656E744E6F6465203D2063757272656E744E6F64652E6E6578743B';
wwv_flow_imp.g_varchar2_table(311) := '0A0909090909090970202B3D2063757272656E744E6F64652E76616C75652E6C656E6774683B0A0909090909097D0A0909090909092F2F2061646A75737420706F732028616E642070290A09090909090970202D3D2063757272656E744E6F64652E7661';
wwv_flow_imp.g_varchar2_table(312) := '6C75652E6C656E6774683B0A090909090909706F73203D20703B0A0A0909090909092F2F207468652063757272656E74206E6F6465206973206120546F6B656E2C207468656E20746865206D617463682073746172747320696E7369646520616E6F7468';
wwv_flow_imp.g_varchar2_table(313) := '657220546F6B656E2C20776869636820697320696E76616C69640A0909090909096966202863757272656E744E6F64652E76616C756520696E7374616E63656F6620546F6B656E29207B0A09090909090909636F6E74696E75653B0A0909090909097D0A';
wwv_flow_imp.g_varchar2_table(314) := '0A0909090909092F2F2066696E6420746865206C617374206E6F64652077686963682069732061666665637465642062792074686973206D617463680A090909090909666F7220280A09090909090909766172206B203D2063757272656E744E6F64653B';
wwv_flow_imp.g_varchar2_table(315) := '0A090909090909096B20213D3D20746F6B656E4C6973742E7461696C202626202870203C20746F207C7C20747970656F66206B2E76616C7565203D3D3D2027737472696E6727293B0A090909090909096B203D206B2E6E6578740A09090909090929207B';
wwv_flow_imp.g_varchar2_table(316) := '0A0909090909090972656D6F7665436F756E742B2B3B0A0909090909090970202B3D206B2E76616C75652E6C656E6774683B0A0909090909097D0A09090909090972656D6F7665436F756E742D2D3B0A0A0909090909092F2F207265706C616365207769';
wwv_flow_imp.g_varchar2_table(317) := '746820746865206E6577206D617463680A090909090909737472203D20746578742E736C69636528706F732C2070293B0A0909090909096D617463682E696E646578202D3D20706F733B0A09090909097D20656C7365207B0A0909090909096D61746368';
wwv_flow_imp.g_varchar2_table(318) := '203D206D617463685061747465726E287061747465726E2C20302C207374722C206C6F6F6B626568696E64293B0A09090909090969662028216D6174636829207B0A09090909090909636F6E74696E75653B0A0909090909097D0A09090909097D0A0A09';
wwv_flow_imp.g_varchar2_table(319) := '090909092F2F2065736C696E742D64697361626C652D6E6578742D6C696E65206E6F2D72656465636C6172650A09090909097661722066726F6D203D206D617463682E696E6465783B0A0909090909766172206D61746368537472203D206D617463685B';
wwv_flow_imp.g_varchar2_table(320) := '305D3B0A0909090909766172206265666F7265203D207374722E736C69636528302C2066726F6D293B0A0909090909766172206166746572203D207374722E736C6963652866726F6D202B206D617463685374722E6C656E677468293B0A0A0909090909';
wwv_flow_imp.g_varchar2_table(321) := '766172207265616368203D20706F73202B207374722E6C656E6774683B0A09090909096966202872656D61746368202626207265616368203E2072656D617463682E726561636829207B0A09090909090972656D617463682E7265616368203D20726561';
wwv_flow_imp.g_varchar2_table(322) := '63683B0A09090909097D0A0A09090909097661722072656D6F766546726F6D203D2063757272656E744E6F64652E707265763B0A0A0909090909696620286265666F726529207B0A09090909090972656D6F766546726F6D203D20616464416674657228';
wwv_flow_imp.g_varchar2_table(323) := '746F6B656E4C6973742C2072656D6F766546726F6D2C206265666F7265293B0A090909090909706F73202B3D206265666F72652E6C656E6774683B0A09090909097D0A0A090909090972656D6F766552616E676528746F6B656E4C6973742C2072656D6F';
wwv_flow_imp.g_varchar2_table(324) := '766546726F6D2C2072656D6F7665436F756E74293B0A0A09090909097661722077726170706564203D206E657720546F6B656E28746F6B656E2C20696E73696465203F205F2E746F6B656E697A65286D617463685374722C20696E7369646529203A206D';
wwv_flow_imp.g_varchar2_table(325) := '617463685374722C20616C6961732C206D61746368537472293B0A090909090963757272656E744E6F6465203D20616464416674657228746F6B656E4C6973742C2072656D6F766546726F6D2C2077726170706564293B0A0A0909090909696620286166';
wwv_flow_imp.g_varchar2_table(326) := '74657229207B0A090909090909616464416674657228746F6B656E4C6973742C2063757272656E744E6F64652C206166746572293B0A09090909097D0A0A09090909096966202872656D6F7665436F756E74203E203129207B0A0909090909092F2F2061';
wwv_flow_imp.g_varchar2_table(327) := '74206C65617374206F6E6520546F6B656E206F626A656374207761732072656D6F7665642C20736F207765206861766520746F20646F20736F6D652072656D61746368696E670A0909090909092F2F20746869732063616E206F6E6C792068617070656E';
wwv_flow_imp.g_varchar2_table(328) := '206966207468652063757272656E74207061747465726E206973206772656564790A0A0909090909092F2A2A204074797065207B52656D617463684F7074696F6E737D202A2F0A090909090909766172206E657374656452656D61746368203D207B0A09';
wwv_flow_imp.g_varchar2_table(329) := '09090909090963617573653A20746F6B656E202B20272C27202B206A2C0A0909090909090972656163683A2072656163680A0909090909097D3B0A0909090909096D617463684772616D6D617228746578742C20746F6B656E4C6973742C206772616D6D';
wwv_flow_imp.g_varchar2_table(330) := '61722C2063757272656E744E6F64652E707265762C20706F732C206E657374656452656D61746368293B0A0A0909090909092F2F20746865207265616368206D696768742068617665206265656E20657874656E6465642062656361757365206F662074';
wwv_flow_imp.g_varchar2_table(331) := '68652072656D61746368696E670A0909090909096966202872656D61746368202626206E657374656452656D617463682E7265616368203E2072656D617463682E726561636829207B0A0909090909090972656D617463682E7265616368203D206E6573';
wwv_flow_imp.g_varchar2_table(332) := '74656452656D617463682E72656163683B0A0909090909097D0A09090909097D0A090909097D0A0909097D0A09097D0A097D0A0A092F2A2A0A09202A204074797065646566204C696E6B65644C6973744E6F64650A09202A204070726F7065727479207B';
wwv_flow_imp.g_varchar2_table(333) := '547D2076616C75650A09202A204070726F7065727479207B4C696E6B65644C6973744E6F64653C543E207C206E756C6C7D2070726576205468652070726576696F7573206E6F64652E0A09202A204070726F7065727479207B4C696E6B65644C6973744E';
wwv_flow_imp.g_varchar2_table(334) := '6F64653C543E207C206E756C6C7D206E65787420546865206E657874206E6F64652E0A09202A204074656D706C61746520540A09202A2040707269766174650A09202A2F0A0A092F2A2A0A09202A204074656D706C61746520540A09202A204070726976';
wwv_flow_imp.g_varchar2_table(335) := '6174650A09202A2F0A0966756E6374696F6E204C696E6B65644C6973742829207B0A09092F2A2A204074797065207B4C696E6B65644C6973744E6F64653C543E7D202A2F0A09097661722068656164203D207B2076616C75653A206E756C6C2C20707265';
wwv_flow_imp.g_varchar2_table(336) := '763A206E756C6C2C206E6578743A206E756C6C207D3B0A09092F2A2A204074797065207B4C696E6B65644C6973744E6F64653C543E7D202A2F0A0909766172207461696C203D207B2076616C75653A206E756C6C2C20707265763A20686561642C206E65';
wwv_flow_imp.g_varchar2_table(337) := '78743A206E756C6C207D3B0A0909686561642E6E657874203D207461696C3B0A0A09092F2A2A204074797065207B4C696E6B65644C6973744E6F64653C543E7D202A2F0A0909746869732E68656164203D20686561643B0A09092F2A2A20407479706520';
wwv_flow_imp.g_varchar2_table(338) := '7B4C696E6B65644C6973744E6F64653C543E7D202A2F0A0909746869732E7461696C203D207461696C3B0A0909746869732E6C656E677468203D20303B0A097D0A0A092F2A2A0A09202A20416464732061206E6577206E6F646520776974682074686520';
wwv_flow_imp.g_varchar2_table(339) := '676976656E2076616C756520746F20746865206C6973742E0A09202A0A09202A2040706172616D207B4C696E6B65644C6973743C543E7D206C6973740A09202A2040706172616D207B4C696E6B65644C6973744E6F64653C543E7D206E6F64650A09202A';
wwv_flow_imp.g_varchar2_table(340) := '2040706172616D207B547D2076616C75650A09202A204072657475726E73207B4C696E6B65644C6973744E6F64653C543E7D20546865206164646564206E6F64652E0A09202A204074656D706C61746520540A09202A2F0A0966756E6374696F6E206164';
wwv_flow_imp.g_varchar2_table(341) := '644166746572286C6973742C206E6F64652C2076616C756529207B0A09092F2F20617373756D65732074686174206E6F646520213D206C6973742E7461696C2026262076616C7565732E6C656E677468203E3D20300A0909766172206E657874203D206E';
wwv_flow_imp.g_varchar2_table(342) := '6F64652E6E6578743B0A0A0909766172206E65774E6F6465203D207B2076616C75653A2076616C75652C20707265763A206E6F64652C206E6578743A206E657874207D3B0A09096E6F64652E6E657874203D206E65774E6F64653B0A09096E6578742E70';
wwv_flow_imp.g_varchar2_table(343) := '726576203D206E65774E6F64653B0A09096C6973742E6C656E6774682B2B3B0A0A090972657475726E206E65774E6F64653B0A097D0A092F2A2A0A09202A2052656D6F7665732060636F756E7460206E6F6465732061667465722074686520676976656E';
wwv_flow_imp.g_varchar2_table(344) := '206E6F64652E2054686520676976656E206E6F64652077696C6C206E6F742062652072656D6F7665642E0A09202A0A09202A2040706172616D207B4C696E6B65644C6973743C543E7D206C6973740A09202A2040706172616D207B4C696E6B65644C6973';
wwv_flow_imp.g_varchar2_table(345) := '744E6F64653C543E7D206E6F64650A09202A2040706172616D207B6E756D6265727D20636F756E740A09202A204074656D706C61746520540A09202A2F0A0966756E6374696F6E2072656D6F766552616E6765286C6973742C206E6F64652C20636F756E';
wwv_flow_imp.g_varchar2_table(346) := '7429207B0A0909766172206E657874203D206E6F64652E6E6578743B0A0909666F7220287661722069203D20303B2069203C20636F756E74202626206E65787420213D3D206C6973742E7461696C3B20692B2B29207B0A0909096E657874203D206E6578';
wwv_flow_imp.g_varchar2_table(347) := '742E6E6578743B0A09097D0A09096E6F64652E6E657874203D206E6578743B0A09096E6578742E70726576203D206E6F64653B0A09096C6973742E6C656E677468202D3D20693B0A097D0A092F2A2A0A09202A2040706172616D207B4C696E6B65644C69';
wwv_flow_imp.g_varchar2_table(348) := '73743C543E7D206C6973740A09202A204072657475726E73207B545B5D7D0A09202A204074656D706C61746520540A09202A2F0A0966756E6374696F6E20746F4172726179286C69737429207B0A0909766172206172726179203D205B5D3B0A09097661';
wwv_flow_imp.g_varchar2_table(349) := '72206E6F6465203D206C6973742E686561642E6E6578743B0A09097768696C6520286E6F646520213D3D206C6973742E7461696C29207B0A09090961727261792E70757368286E6F64652E76616C7565293B0A0909096E6F6465203D206E6F64652E6E65';
wwv_flow_imp.g_varchar2_table(350) := '78743B0A09097D0A090972657475726E2061727261793B0A097D0A0A0A0969662028215F73656C662E646F63756D656E7429207B0A090969662028215F73656C662E6164644576656E744C697374656E657229207B0A0909092F2F20696E204E6F64652E';
wwv_flow_imp.g_varchar2_table(351) := '6A730A09090972657475726E205F3B0A09097D0A0A090969662028215F2E64697361626C65576F726B65724D65737361676548616E646C657229207B0A0909092F2F20496E20776F726B65720A0909095F73656C662E6164644576656E744C697374656E';
wwv_flow_imp.g_varchar2_table(352) := '657228276D657373616765272C2066756E6374696F6E202865767429207B0A09090909766172206D657373616765203D204A534F4E2E7061727365286576742E64617461293B0A09090909766172206C616E67203D206D6573736167652E6C616E677561';
wwv_flow_imp.g_varchar2_table(353) := '67653B0A0909090976617220636F6465203D206D6573736167652E636F64653B0A0909090976617220696D6D656469617465436C6F7365203D206D6573736167652E696D6D656469617465436C6F73653B0A0A090909095F73656C662E706F73744D6573';
wwv_flow_imp.g_varchar2_table(354) := '73616765285F2E686967686C6967687428636F64652C205F2E6C616E6775616765735B6C616E675D2C206C616E6729293B0A0909090969662028696D6D656469617465436C6F736529207B0A09090909095F73656C662E636C6F736528293B0A09090909';
wwv_flow_imp.g_varchar2_table(355) := '7D0A0909097D2C2066616C7365293B0A09097D0A0A090972657475726E205F3B0A097D0A0A092F2F204765742063757272656E742073637269707420616E6420686967686C696768740A0976617220736372697074203D205F2E7574696C2E6375727265';
wwv_flow_imp.g_varchar2_table(356) := '6E7453637269707428293B0A0A096966202873637269707429207B0A09095F2E66696C656E616D65203D207363726970742E7372633B0A0A0909696620287363726970742E6861734174747269627574652827646174612D6D616E75616C272929207B0A';
wwv_flow_imp.g_varchar2_table(357) := '0909095F2E6D616E75616C203D20747275653B0A09097D0A097D0A0A0966756E6374696F6E20686967686C696768744175746F6D61746963616C6C7943616C6C6261636B2829207B0A090969662028215F2E6D616E75616C29207B0A0909095F2E686967';
wwv_flow_imp.g_varchar2_table(358) := '686C69676874416C6C28293B0A09097D0A097D0A0A0969662028215F2E6D616E75616C29207B0A09092F2F2049662074686520646F63756D656E7420737461746520697320226C6F6164696E67222C207468656E207765276C6C2075736520444F4D436F';
wwv_flow_imp.g_varchar2_table(359) := '6E74656E744C6F616465642E0A09092F2F2049662074686520646F63756D656E742073746174652069732022696E7465726163746976652220616E642074686520707269736D2E6A73207363726970742069732064656665727265642C207468656E2077';
wwv_flow_imp.g_varchar2_table(360) := '65276C6C20616C736F20757365207468650A09092F2F20444F4D436F6E74656E744C6F61646564206576656E742062656361757365207468657265206D6967687420626520736F6D6520706C7567696E73206F72206C616E677561676573207768696368';
wwv_flow_imp.g_varchar2_table(361) := '206861766520616C736F206265656E20646566657272656420616E6420746865790A09092F2F206D696768742074616B65206C6F6E676572206F6E6520616E696D6174696F6E206672616D6520746F20657865637574652077686963682063616E206372';
wwv_flow_imp.g_varchar2_table(362) := '656174652061207261636520636F6E646974696F6E207768657265206F6E6C7920736F6D6520706C7567696E7320686176650A09092F2F206265656E206C6F61646564207768656E20507269736D2E686967686C69676874416C6C282920697320657865';
wwv_flow_imp.g_varchar2_table(363) := '63757465642C20646570656E64696E67206F6E20686F772066617374207265736F757263657320617265206C6F616465642E0A09092F2F205365652068747470733A2F2F6769746875622E636F6D2F507269736D4A532F707269736D2F6973737565732F';
wwv_flow_imp.g_varchar2_table(364) := '323130320A09097661722072656164795374617465203D20646F63756D656E742E726561647953746174653B0A09096966202872656164795374617465203D3D3D20276C6F6164696E6727207C7C2072656164795374617465203D3D3D2027696E746572';
wwv_flow_imp.g_varchar2_table(365) := '6163746976652720262620736372697074202626207363726970742E646566657229207B0A090909646F63756D656E742E6164644576656E744C697374656E65722827444F4D436F6E74656E744C6F61646564272C20686967686C696768744175746F6D';
wwv_flow_imp.g_varchar2_table(366) := '61746963616C6C7943616C6C6261636B293B0A09097D20656C7365207B0A0909096966202877696E646F772E72657175657374416E696D6174696F6E4672616D6529207B0A0909090977696E646F772E72657175657374416E696D6174696F6E4672616D';
wwv_flow_imp.g_varchar2_table(367) := '6528686967686C696768744175746F6D61746963616C6C7943616C6C6261636B293B0A0909097D20656C7365207B0A0909090977696E646F772E73657454696D656F757428686967686C696768744175746F6D61746963616C6C7943616C6C6261636B2C';
wwv_flow_imp.g_varchar2_table(368) := '203136293B0A0909097D0A09097D0A097D0A0A0972657475726E205F3B0A0A7D285F73656C6629293B0A0A69662028747970656F66206D6F64756C6520213D3D2027756E646566696E656427202626206D6F64756C652E6578706F72747329207B0A096D';
wwv_flow_imp.g_varchar2_table(369) := '6F64756C652E6578706F727473203D20507269736D3B0A7D0A0A2F2F206861636B20666F7220636F6D706F6E656E747320746F20776F726B20636F72726563746C7920696E206E6F64652E6A730A69662028747970656F6620676C6F62616C20213D3D20';
wwv_flow_imp.g_varchar2_table(370) := '27756E646566696E65642729207B0A09676C6F62616C2E507269736D203D20507269736D3B0A7D0A0A2F2F20736F6D65206164646974696F6E616C20646F63756D656E746174696F6E2F74797065730A0A2F2A2A0A202A2054686520657870616E73696F';
wwv_flow_imp.g_varchar2_table(371) := '6E206F6620612073696D706C65206052656745787060206C69746572616C20746F20737570706F7274206164646974696F6E616C2070726F706572746965732E0A202A0A202A204074797065646566204772616D6D6172546F6B656E0A202A204070726F';
wwv_flow_imp.g_varchar2_table(372) := '7065727479207B5265674578707D207061747465726E2054686520726567756C61722065787072657373696F6E206F662074686520746F6B656E2E0A202A204070726F7065727479207B626F6F6C65616E7D205B6C6F6F6B626568696E643D66616C7365';
wwv_flow_imp.g_varchar2_table(373) := '5D204966206074727565602C207468656E2074686520666972737420636170747572696E672067726F7570206F6620607061747465726E602077696C6C20286566666563746976656C79290A202A206265686176652061732061206C6F6F6B626568696E';
wwv_flow_imp.g_varchar2_table(374) := '642067726F7570206D65616E696E6720746861742074686520636170747572656420746578742077696C6C206E6F742062652070617274206F6620746865206D6174636865642074657874206F6620746865206E657720746F6B656E2E0A202A20407072';
wwv_flow_imp.g_varchar2_table(375) := '6F7065727479207B626F6F6C65616E7D205B6772656564793D66616C73655D20576865746865722074686520746F6B656E206973206772656564792E0A202A204070726F7065727479207B737472696E677C737472696E675B5D7D205B616C6961735D20';
wwv_flow_imp.g_varchar2_table(376) := '416E206F7074696F6E616C20616C696173206F72206C697374206F6620616C69617365732E0A202A204070726F7065727479207B4772616D6D61727D205B696E736964655D20546865206E6573746564206772616D6D6172206F66207468697320746F6B';
wwv_flow_imp.g_varchar2_table(377) := '656E2E0A202A0A202A205468652060696E7369646560206772616D6D61722077696C6C206265207573656420746F20746F6B656E697A652074686520746578742076616C7565206F66206561636820746F6B656E206F662074686973206B696E642E0A20';
wwv_flow_imp.g_varchar2_table(378) := '2A0A202A20546869732063616E206265207573656420746F206D616B65206E657374656420616E64206576656E20726563757273697665206C616E677561676520646566696E6974696F6E732E0A202A0A202A204E6F74653A20546869732063616E2063';
wwv_flow_imp.g_varchar2_table(379) := '6175736520696E66696E69746520726563757273696F6E2E204265206361726566756C207768656E20796F7520656D62656420646966666572656E74206C616E677561676573206F72206576656E207468652073616D65206C616E677561676520696E74';
wwv_flow_imp.g_varchar2_table(380) := '6F0A202A206561636820616E6F746865722E0A202A2040676C6F62616C0A202A20407075626C69630A202A2F0A0A2F2A2A0A202A204074797065646566204772616D6D61720A202A204074797065207B4F626A6563743C737472696E672C205265674578';
wwv_flow_imp.g_varchar2_table(381) := '70207C204772616D6D6172546F6B656E207C2041727261793C526567457870207C204772616D6D6172546F6B656E3E3E7D0A202A204070726F7065727479207B4772616D6D61727D205B726573745D20416E206F7074696F6E616C206772616D6D617220';
wwv_flow_imp.g_varchar2_table(382) := '6F626A65637420746861742077696C6C20626520617070656E64656420746F2074686973206772616D6D61722E0A202A2040676C6F62616C0A202A20407075626C69630A202A2F0A0A2F2A2A0A202A20412066756E6374696F6E2077686963682077696C';
wwv_flow_imp.g_varchar2_table(383) := '6C20696E766F6B656420616674657220616E20656C656D656E7420776173207375636365737366756C6C7920686967686C6967687465642E0A202A0A202A204063616C6C6261636B20486967686C6967687443616C6C6261636B0A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(384) := '207B456C656D656E747D20656C656D656E742054686520656C656D656E74207375636365737366756C6C7920686967686C6967687465642E0A202A204072657475726E73207B766F69647D0A202A2040676C6F62616C0A202A20407075626C69630A202A';
wwv_flow_imp.g_varchar2_table(385) := '2F0A0A2F2A2A0A202A204063616C6C6261636B20486F6F6B43616C6C6261636B0A202A2040706172616D207B4F626A6563743C737472696E672C20616E793E7D20656E762054686520656E7669726F6E6D656E74207661726961626C6573206F66207468';
wwv_flow_imp.g_varchar2_table(386) := '6520686F6F6B2E0A202A204072657475726E73207B766F69647D0A202A2040676C6F62616C0A202A20407075626C69630A202A2F0A3B0A2F2F2068747470733A2F2F7777772E6A736F6E2E6F72672F6A736F6E2D656E2E68746D6C0A507269736D2E6C61';
wwv_flow_imp.g_varchar2_table(387) := '6E6775616765732E6A736F6E203D207B0A092770726F7065727479273A207B0A09097061747465726E3A202F285E7C5B5E5C5C5D2922283F3A5C5C2E7C5B5E5C5C225C725C6E5D292A22283F3D5C732A3A292F2C0A09096C6F6F6B626568696E643A2074';
wwv_flow_imp.g_varchar2_table(388) := '7275652C0A09096772656564793A20747275650A097D2C0A0927737472696E67273A207B0A09097061747465726E3A202F285E7C5B5E5C5C5D2922283F3A5C5C2E7C5B5E5C5C225C725C6E5D292A22283F215C732A3A292F2C0A09096C6F6F6B62656869';
wwv_flow_imp.g_varchar2_table(389) := '6E643A20747275652C0A09096772656564793A20747275650A097D2C0A0927636F6D6D656E74273A207B0A09097061747465726E3A202F5C2F5C2F2E2A7C5C2F5C2A5B5C735C535D2A3F283F3A5C2A5C2F7C24292F2C0A09096772656564793A20747275';
wwv_flow_imp.g_varchar2_table(390) := '650A097D2C0A09276E756D626572273A202F2D3F5C625C642B283F3A5C2E5C642B293F283F3A655B2B2D5D3F5C642B293F5C622F692C0A092770756E6374756174696F6E273A202F5B7B7D5B5C5D2C5D2F2C0A09276F70657261746F72273A202F3A2F2C';
wwv_flow_imp.g_varchar2_table(391) := '0A0927626F6F6C65616E273A202F5C62283F3A66616C73657C74727565295C622F2C0A09276E756C6C273A207B0A09097061747465726E3A202F5C626E756C6C5C622F2C0A0909616C6961733A20276B6579776F7264270A097D0A7D3B0A0A507269736D';
wwv_flow_imp.g_varchar2_table(392) := '2E6C616E6775616765732E7765626D616E6966657374203D20507269736D2E6C616E6775616765732E6A736F6E3B0A0A2F2F20546869732069732061206C616E677561676520646566696E6974696F6E20666F722067656E65726963206C6F672066696C';
wwv_flow_imp.g_varchar2_table(393) := '65732E0A2F2F2053696E6365207468657265206973206E6F206F6E65206C6F6720666F726D61742C2074686973206C616E677561676520646566696E6974696F6E2068617320746F20737570706F727420616C6C20666F726D61747320746F20736F6D65';
wwv_flow_imp.g_varchar2_table(394) := '206465677265652E0A2F2F0A2F2F204261736564206F6E2068747470733A2F2F6769746875622E636F6D2F4D54444C392F76696D2D6C6F672D686967686C69676874696E670A0A507269736D2E6C616E6775616765732E6C6F67203D207B0A0927737472';
wwv_flow_imp.g_varchar2_table(395) := '696E67273A207B0A09092F2F2053696E676C652D71756F74656420737472696E6773206D757374206E6F7420626520636F6E6675736564207769746820706C61696E20746578742E20452E672E2043616E27742069736E277420537573616E2773204368';
wwv_flow_imp.g_varchar2_table(396) := '7269732720746F790A09097061747465726E3A202F22283F3A5B5E225C5C5C725C6E5D7C5C5C2E292A227C27283F215B73745D207C205C7729283F3A5B5E275C5C5C725C6E5D7C5C5C2E292A272F2C0A09096772656564793A20747275652C0A097D2C0A';
wwv_flow_imp.g_varchar2_table(397) := '0A0927657863657074696F6E273A207B0A09097061747465726E3A202F285E7C5B5E5C772E5D295B612D7A5D5B5C772E5D2A283F3A4572726F727C457863657074696F6E293A2E2A283F3A283F3A5C725C6E3F7C5C6E295B205C745D2A283F3A61745B20';
wwv_flow_imp.g_varchar2_table(398) := '5C745D2E2B7C5C2E7B337D2E2A7C4361757365642062793A2E2A29292B283F3A283F3A5C725C6E3F7C5C6E295B205C745D2A5C2E5C2E5C2E202E2A293F2F2C0A09096C6F6F6B626568696E643A20747275652C0A09096772656564793A20747275652C0A';
wwv_flow_imp.g_varchar2_table(399) := '0909616C6961733A205B276A617661737461636B7472616365272C20276C616E67756167652D6A617661737461636B7472616365275D2C0A0909696E736964653A20507269736D2E6C616E6775616765735B276A617661737461636B7472616365275D20';
wwv_flow_imp.g_varchar2_table(400) := '7C7C207B0A090909276B6579776F7264273A202F5C6261745C622F2C0A0909092766756E6374696F6E273A202F5B612D7A5F5D5B5C77245D2A283F3D5C28292F2C0A0909092770756E6374756174696F6E273A202F5B2E3A28295D2F0A09097D0A097D2C';
wwv_flow_imp.g_varchar2_table(401) := '0A0A09276C6576656C273A205B0A09097B0A0909097061747465726E3A202F5C62283F3A414C4552547C435249547C435249544943414C7C454D4552477C454D455247454E43597C4552527C4552524F527C4641494C5552457C464154414C7C53455645';
wwv_flow_imp.g_varchar2_table(402) := '5245295C622F2C0A090909616C6961733A205B276572726F72272C2027696D706F7274616E74275D0A09097D2C0A09097B0A0909097061747465726E3A202F5C62283F3A5741524E7C5741524E494E477C57524E295C622F2C0A090909616C6961733A20';
wwv_flow_imp.g_varchar2_table(403) := '5B277761726E696E67272C2027696D706F7274616E74275D0A09097D2C0A09097B0A0909097061747465726E3A202F5C62283F3A444953504C41597C494E467C494E464F7C4E4F544943457C535441545553295C622F2C0A090909616C6961733A205B27';
wwv_flow_imp.g_varchar2_table(404) := '696E666F272C20276B6579776F7264275D0A09097D2C0A09097B0A0909097061747465726E3A202F5C62283F3A4442477C44454255477C46494E45295C622F2C0A090909616C6961733A205B276465627567272C20276B6579776F7264275D0A09097D2C';
wwv_flow_imp.g_varchar2_table(405) := '0A09097B0A0909097061747465726E3A202F5C62283F3A46494E45527C46494E4553547C54524143457C5452437C564552424F53457C565242295C622F2C0A090909616C6961733A205B277472616365272C2027636F6D6D656E74275D0A09097D0A095D';
wwv_flow_imp.g_varchar2_table(406) := '2C0A0A092770726F7065727479273A207B0A09097061747465726E3A202F28283F3A5E7C5B5C5D7C5D295B205C745D2A295B612D7A5F5D283F3A5B5C772D5D7C5C625C2F5C62292A283F3A5B2E205D5C283F5C77283F3A5B5C772D5D7C5C625C2F5C6229';
wwv_flow_imp.g_varchar2_table(407) := '2A5C293F292A3A283F3D5C73292F696D2C0A09096C6F6F6B626568696E643A20747275650A097D2C0A0A0927736570617261746F72273A207B0A09097061747465726E3A202F285E7C5B5E2D2B5D292D7B332C7D7C3D7B332C7D7C5C2A7B332C7D7C2D20';
wwv_flow_imp.g_varchar2_table(408) := '2D202F6D2C0A09096C6F6F6B626568696E643A20747275652C0A0909616C6961733A2027636F6D6D656E74270A097D2C0A0A092775726C273A202F5C62283F3A66696C657C6674707C68747470733F293A5C2F5C2F5B5E5C737C2C3B27225D2A5B5E5C73';
wwv_flow_imp.g_varchar2_table(409) := '7C2C3B27223E2E5D2F2C0A0927656D61696C273A207B0A09097061747465726E3A202F285E7C5C73295B2D5C772B2E5D2B405B612D7A5D5B612D7A302D392D5D2A283F3A5C2E5B612D7A5D5B612D7A302D392D5D2A292B283F3D5C73292F2C0A09096C6F';
wwv_flow_imp.g_varchar2_table(410) := '6F6B626568696E643A20747275652C0A0909616C6961733A202775726C270A097D2C0A0A092769702D61646472657373273A207B0A09097061747465726E3A202F5C62283F3A5C647B312C337D283F3A5C2E5C647B312C337D297B337D295C622F2C0A09';
wwv_flow_imp.g_varchar2_table(411) := '09616C6961733A2027636F6E7374616E74270A097D2C0A09276D61632D61646472657373273A207B0A09097061747465726E3A202F5C625B612D66302D395D7B327D283F3A3A5B612D66302D395D7B327D297B357D5C622F692C0A0909616C6961733A20';
wwv_flow_imp.g_varchar2_table(412) := '27636F6E7374616E74270A097D2C0A0927646F6D61696E273A207B0A09097061747465726E3A202F285E7C5C73295B612D7A5D5B612D7A302D392D5D2A283F3A5C2E5B612D7A5D5B612D7A302D392D5D2A292A5C2E5B612D7A5D5B612D7A302D392D5D2B';
wwv_flow_imp.g_varchar2_table(413) := '283F3D5C73292F2C0A09096C6F6F6B626568696E643A20747275652C0A0909616C6961733A2027636F6E7374616E74270A097D2C0A0A092775756964273A207B0A09097061747465726E3A202F5C625B302D39612D665D7B387D2D5B302D39612D665D7B';
wwv_flow_imp.g_varchar2_table(414) := '347D2D5B302D39612D665D7B347D2D5B302D39612D665D7B347D2D5B302D39612D665D7B31327D5C622F692C0A0909616C6961733A2027636F6E7374616E74270A097D2C0A092768617368273A207B0A09097061747465726E3A202F5C62283F3A5B612D';
wwv_flow_imp.g_varchar2_table(415) := '66302D395D7B33327D297B312C327D5C622F692C0A0909616C6961733A2027636F6E7374616E74270A097D2C0A0A092766696C652D70617468273A207B0A09097061747465726E3A202F5C625B612D7A5D3A5B5C5C2F5D5B5E5C737C2C3B3A28297B7D5C';
wwv_flow_imp.g_varchar2_table(416) := '5B5C5D22275D2B7C285E7C5B5C733A5C5B5C5D283E7C5D295C2E7B302C327D5C2F5C775B5E5C737C2C3B3A28297B7D5C5B5C5D22275D2A2F692C0A09096C6F6F6B626568696E643A20747275652C0A09096772656564793A20747275652C0A0909616C69';
wwv_flow_imp.g_varchar2_table(417) := '61733A2027737472696E67270A097D2C0A0A092764617465273A207B0A09097061747465726E3A20526567457870280A0909092F5C625C647B347D5B2D2F5D5C647B327D5B2D2F5D5C647B327D283F3A54283F3D5C647B312C327D3A297C283F3D5C735C';
wwv_flow_imp.g_varchar2_table(418) := '647B312C327D3A29292F2E736F75726365202B0A090909277C27202B0A0909092F5C625C647B312C347D5B2D2F205D283F3A5C647B312C327D7C4170727C4175677C4465637C4665627C4A616E7C4A756C7C4A756E7C4D61727C4D61797C4E6F767C4F63';
wwv_flow_imp.g_varchar2_table(419) := '747C536570295B2D2F205D5C647B322C347D543F5C622F2E736F75726365202B0A090909277C27202B0A0909092F5C62283F3A283F3A4672697C4D6F6E7C5361747C53756E7C5468757C5475657C57656429283F3A5C737B312C327D283F3A4170727C41';
wwv_flow_imp.g_varchar2_table(420) := '75677C4465637C4665627C4A616E7C4A756C7C4A756E7C4D61727C4D61797C4E6F767C4F63747C53657029293F7C4170727C4175677C4465637C4665627C4A616E7C4A756C7C4A756E7C4D61727C4D61797C4E6F767C4F63747C536570295C737B312C32';
wwv_flow_imp.g_varchar2_table(421) := '7D5C647B312C327D5C622F2E736F757263652C0A0909092769270A0909292C0A0909616C6961733A20276E756D626572270A097D2C0A092774696D65273A207B0A09097061747465726E3A202F5C625C647B312C327D3A5C647B312C327D3A5C647B312C';
wwv_flow_imp.g_varchar2_table(422) := '327D283F3A5B2E2C3A5D5C642B293F283F3A5C733F5B2B2D5D5C647B327D3A3F5C647B327D7C5A293F5C622F2C0A0909616C6961733A20276E756D626572270A097D2C0A0A0927626F6F6C65616E273A202F5C62283F3A66616C73657C6E756C6C7C7472';
wwv_flow_imp.g_varchar2_table(423) := '7565295C622F692C0A09276E756D626572273A207B0A09097061747465726E3A202F285E7C5B5E2E5C775D29283F3A30785B612D66302D395D2B7C306F5B302D375D2B7C30625B30315D2B7C763F5C645B5C64612D665D2A283F3A5C2E5C642B292A283F';
wwv_flow_imp.g_varchar2_table(424) := '3A655B2B2D5D3F5C642B293F5B612D7A5D7B302C337D5C62295C62283F215C2E5C77292F692C0A09096C6F6F6B626568696E643A20747275650A097D2C0A0A09276F70657261746F72273A202F5B3B3A3F3C3D3E7E2F40212425262B5C2D7C5E28297B7D';
wwv_flow_imp.g_varchar2_table(425) := '2A235D2F2C0A092770756E6374756174696F6E273A202F5B5C5B5C5D2E2C5D2F0A7D3B0A0A507269736D2E6C616E6775616765732E73716C203D207B0A0927636F6D6D656E74273A207B0A09097061747465726E3A202F285E7C5B5E5C5C5D29283F3A5C';
wwv_flow_imp.g_varchar2_table(426) := '2F5C2A5B5C735C535D2A3F5C2A5C2F7C283F3A2D2D7C5C2F5C2F7C23292E2A292F2C0A09096C6F6F6B626568696E643A20747275650A097D2C0A09277661726961626C65273A205B0A09097B0A0909097061747465726E3A202F40285B2227605D29283F';
wwv_flow_imp.g_varchar2_table(427) := '3A5C5C5B5C735C535D7C283F215C31295B5E5C5C5D292B5C312F2C0A0909096772656564793A20747275650A09097D2C0A09092F405B5C772E245D2B2F0A095D2C0A0927737472696E67273A207B0A09097061747465726E3A202F285E7C5B5E405C5C5D';
wwv_flow_imp.g_varchar2_table(428) := '2928227C2729283F3A5C5C5B5C735C535D7C283F215C32295B5E5C5C5D7C5C325C32292A5C322F2C0A09096772656564793A20747275652C0A09096C6F6F6B626568696E643A20747275650A097D2C0A09276964656E746966696572273A207B0A090970';
wwv_flow_imp.g_varchar2_table(429) := '61747465726E3A202F285E7C5B5E405C5C5D2960283F3A5C5C5B5C735C535D7C5B5E605C5C5D7C6060292A602F2C0A09096772656564793A20747275652C0A09096C6F6F6B626568696E643A20747275652C0A0909696E736964653A207B0A0909092770';
wwv_flow_imp.g_varchar2_table(430) := '756E6374756174696F6E273A202F5E607C60242F0A09097D0A097D2C0A092766756E6374696F6E273A202F5C62283F3A4156477C434F554E547C46495253547C464F524D41547C4C4153547C4C434153457C4C454E7C4D41587C4D49447C4D494E7C4D4F';
wwv_flow_imp.g_varchar2_table(431) := '447C4E4F577C524F554E447C53554D7C554341534529283F3D5C732A5C28292F692C202F2F2053686F756C6420776520686967686C69676874207573657220646566696E65642066756E6374696F6E7320746F6F3F0A09276B6579776F7264273A202F5C';
wwv_flow_imp.g_varchar2_table(432) := '62283F3A414354494F4E7C4144447C41465445527C414C474F524954484D7C414C4C7C414C5445527C414E414C595A457C414E597C4150504C597C41537C4153437C415554484F52495A4154494F4E7C4155544F5F494E4352454D454E547C4241434B55';
wwv_flow_imp.g_varchar2_table(433) := '507C4244427C424547494E7C4245524B454C455944427C424947494E547C42494E4152597C4249547C424C4F427C424F4F4C7C424F4F4C45414E7C425245414B7C42524F5753457C42545245457C42554C4B7C42597C43414C4C7C43415343414445443F';
wwv_flow_imp.g_varchar2_table(434) := '7C434153457C434841494E7C43484152283F3A41435445527C534554293F7C434845434B283F3A504F494E54293F7C434C4F53457C434C555354455245447C434F414C455343457C434F4C4C4154457C434F4C554D4E533F7C434F4D4D454E547C434F4D';
wwv_flow_imp.g_varchar2_table(435) := '4D4954283F3A544544293F7C434F4D505554457C434F4E4E4543547C434F4E53495354454E547C434F4E53545241494E547C434F4E5441494E53283F3A5441424C45293F7C434F4E54494E55457C434F4E564552547C4352454154457C43524F53537C43';
wwv_flow_imp.g_varchar2_table(436) := '555252454E54283F3A5F444154457C5F54494D457C5F54494D455354414D507C5F55534552293F7C435552534F527C4359434C457C44415441283F3A42415345533F293F7C44415445283F3A54494D45293F7C4441597C444243437C4445414C4C4F4341';
wwv_flow_imp.g_varchar2_table(437) := '54457C4445437C444543494D414C7C4445434C4152457C44454641554C547C444546494E45527C44454C415945447C44454C4554457C44454C494D49544552533F7C44454E597C444553437C44455343524942457C44455445524D494E49535449437C44';
wwv_flow_imp.g_varchar2_table(438) := '495341424C457C444953434152447C4449534B7C44495354494E43547C44495354494E4354524F577C44495354524942555445447C444F7C444F55424C457C44524F507C44554D4D597C44554D50283F3A46494C45293F7C4455504C49434154457C454C';
wwv_flow_imp.g_varchar2_table(439) := '5345283F3A4946293F7C454E41424C457C454E434C4F5345447C454E447C454E47494E457C454E554D7C4552524C564C7C4552524F52537C455343415045443F7C4558434550547C45584543283F3A555445293F7C4558495354537C455849547C455850';
wwv_flow_imp.g_varchar2_table(440) := '4C41494E7C455854454E4445447C46455443487C4649454C44537C46494C457C46494C4C464143544F527C46495253547C46495845447C464C4F41547C464F4C4C4F57494E477C464F52283F3A204541434820524F57293F7C464F5243457C464F524549';
wwv_flow_imp.g_varchar2_table(441) := '474E7C4652454554455854283F3A5441424C45293F7C46524F4D7C46554C4C7C46554E4354494F4E7C47454F4D45545259283F3A434F4C4C454354494F4E293F7C474C4F42414C7C474F544F7C4752414E547C47524F55507C48414E444C45527C484153';
wwv_flow_imp.g_varchar2_table(442) := '487C484156494E477C484F4C444C4F434B7C484F55527C4944454E54495459283F3A434F4C7C5F494E53455254293F7C49467C49474E4F52457C494D504F52547C494E4445587C494E46494C457C494E4E45527C494E4E4F44427C494E4F55547C494E53';
wwv_flow_imp.g_varchar2_table(443) := '4552547C494E547C494E54454745527C494E544552534543547C494E54455256414C7C494E544F7C494E564F4B45527C49534F4C4154494F4E7C495445524154457C4A4F494E7C4B4559533F7C4B494C4C7C4C414E47554147457C4C4153547C4C454156';
wwv_flow_imp.g_varchar2_table(444) := '457C4C4546547C4C4556454C7C4C494D49547C4C494E454E4F7C4C494E45537C4C494E45535452494E477C4C4F41447C4C4F43414C7C4C4F434B7C4C4F4E47283F3A424C4F427C54455854297C4C4F4F507C4D41544348283F3A4544293F7C4D45444955';
wwv_flow_imp.g_varchar2_table(445) := '4D283F3A424C4F427C494E547C54455854297C4D455247457C4D4944444C45494E547C4D494E5554457C4D4F44457C4D4F4449464945537C4D4F444946597C4D4F4E54487C4D554C5449283F3A4C494E45535452494E477C504F494E547C504F4C59474F';
wwv_flow_imp.g_varchar2_table(446) := '4E297C4E4154494F4E414C7C4E41545552414C7C4E434841527C4E4558547C4E4F7C4E4F4E434C555354455245447C4E554C4C49467C4E554D455249437C4F46463F7C4F4646534554533F7C4F4E7C4F50454E283F3A44415441534F555243457C515545';
wwv_flow_imp.g_varchar2_table(447) := '52597C524F57534554293F7C4F5054494D495A457C4F5054494F4E283F3A414C4C59293F7C4F524445527C4F5554283F3A45527C46494C45293F7C4F5645527C5041525449414C7C504152544954494F4E7C50455243454E547C5049564F547C504C414E';
wwv_flow_imp.g_varchar2_table(448) := '7C504F494E547C504F4C59474F4E7C505245434544494E477C505245434953494F4E7C505245504152457C505245567C5052494D4152597C5052494E547C50524956494C454745537C50524F43283F3A4544555245293F7C5055424C49437C5055524745';
wwv_flow_imp.g_varchar2_table(449) := '7C515549434B7C524149534552524F527C52454144533F7C5245414C7C5245434F4E4649475552457C5245464552454E4345537C52454C454153457C52454E414D457C524550454154283F3A41424C45293F7C5245504C4143457C5245504C4943415449';
wwv_flow_imp.g_varchar2_table(450) := '4F4E7C524551554952457C52455349474E414C7C524553544F52457C52455354524943547C52455455524E283F3A494E477C53293F7C5245564F4B457C52494748547C524F4C4C4241434B7C524F5554494E457C524F57283F3A434F554E547C47554944';
wwv_flow_imp.g_varchar2_table(451) := '434F4C7C53293F7C52545245457C52554C457C53415645283F3A504F494E54293F7C534348454D417C5345434F4E447C53454C4543547C53455249414C283F3A495A41424C45293F7C53455353494F4E283F3A5F55534552293F7C534554283F3A555345';
wwv_flow_imp.g_varchar2_table(452) := '52293F7C53484152457C53484F577C53485554444F574E7C53494D504C457C534D414C4C494E547C534E415053484F547C534F4D457C534F4E414D457C53514C7C5354415254283F3A494E47293F7C535441544953544943537C5354415455537C535452';
wwv_flow_imp.g_varchar2_table(453) := '495045447C53595354454D5F555345527C5441424C45533F7C5441424C4553504143457C54454D50283F3A4F524152597C5441424C45293F7C5445524D494E415445447C54455854283F3A53495A45293F7C5448454E7C54494D45283F3A5354414D5029';
wwv_flow_imp.g_varchar2_table(454) := '3F7C54494E59283F3A424C4F427C494E547C54455854297C544F503F7C5452414E283F3A53414354494F4E533F293F7C545249474745527C5452554E434154457C5453455155414C7C54595045533F7C554E424F554E4445447C554E434F4D4D49545445';
wwv_flow_imp.g_varchar2_table(455) := '447C554E444546494E45447C554E494F4E7C554E495155457C554E4C4F434B7C554E5049564F547C554E5349474E45447C555044415445283F3A54455854293F7C55534147457C5553457C555345527C5553494E477C56414C5545533F7C564152283F3A';
wwv_flow_imp.g_varchar2_table(456) := '42494E4152597C434841527C4348415241435445527C59494E47297C564945577C57414954464F527C5741524E494E47537C5748454E7C57484552457C5748494C457C57495448283F3A20524F4C4C55507C494E293F7C574F524B7C5752495445283F3A';
wwv_flow_imp.g_varchar2_table(457) := '54455854293F7C59454152295C622F692C0A0927626F6F6C65616E273A202F5C62283F3A46414C53457C4E554C4C7C54525545295C622F692C0A09276E756D626572273A202F5C6230785B5C64612D665D2B5C627C5C625C642B283F3A5C2E5C642A293F';
wwv_flow_imp.g_varchar2_table(458) := '7C5C425C2E5C642B5C622F692C0A09276F70657261746F72273A202F5B2D2B2A5C2F3D255E7E5D7C26263F7C5C7C5C7C3F7C213D3F7C3C283F3A3D3E3F7C3C7C3E293F7C3E5B3E3D5D3F7C5C62283F3A414E447C4245545745454E7C4449567C494C494B';
wwv_flow_imp.g_varchar2_table(459) := '457C494E7C49537C4C494B457C4E4F547C4F527C5245474558507C524C494B457C534F554E4453204C494B457C584F52295C622F692C0A092770756E6374756174696F6E273A202F5B3B5B5C5D2829602C2E5D2F0A7D3B0A0A507269736D2E6C616E6775';
wwv_flow_imp.g_varchar2_table(460) := '616765732E706C73716C203D20507269736D2E6C616E6775616765732E657874656E64282773716C272C207B0A0927636F6D6D656E74273A207B0A09097061747465726E3A202F5C2F5C2A5B5C735C535D2A3F5C2A5C2F7C2D2D2E2A2F2C0A0909677265';
wwv_flow_imp.g_varchar2_table(461) := '6564793A20747275650A097D2C0A092F2F2068747470733A2F2F646F63732E6F7261636C652E636F6D2F656E2F64617461626173652F6F7261636C652F6F7261636C652D64617461626173652F32312F6C6E706C732F706C73716C2D7265736572766564';
wwv_flow_imp.g_varchar2_table(462) := '2D776F7264732D6B6579776F7264732E68746D6C0A09276B6579776F7264273A202F5C62283F3A417C41434345535349424C457C4144447C4147454E547C4147475245474154457C414C4C7C414C5445527C414E447C414E597C41525241597C41537C41';
wwv_flow_imp.g_varchar2_table(463) := '53437C41547C4154545249425554457C4155544849447C4156477C424547494E7C4245545745454E7C4246494C455F424153457C42494E4152597C424C4F425F424153457C424C4F434B7C424F44597C424F54487C424F554E447C42554C4B7C42597C42';
wwv_flow_imp.g_varchar2_table(464) := '5954457C437C43414C4C7C43414C4C494E477C434153434144457C434153457C434841527C4348415241435445527C434841525345547C43484152534554464F524D7C4348415253455449447C434841525F424153457C434845434B7C434C4F425F4241';
wwv_flow_imp.g_varchar2_table(465) := '53457C434C4F4E457C434C4F53457C434C55535445527C434C5553544552537C434F4C415554487C434F4C4C4543547C434F4C554D4E537C434F4D4D454E547C434F4D4D49547C434F4D4D49545445447C434F4D50494C45447C434F4D50524553537C43';
wwv_flow_imp.g_varchar2_table(466) := '4F4E4E4543547C434F4E5354414E547C434F4E5354525543544F527C434F4E544558547C434F4E54494E55457C434F4E564552547C434F554E547C43524153487C4352454154457C43524544454E5449414C7C43555252454E547C435552534F527C4355';
wwv_flow_imp.g_varchar2_table(467) := '53544F4D444154554D7C44414E474C494E477C444154417C444154457C444154455F424153457C4441597C4445434C4152457C44454641554C547C444546494E457C44454C4554457C444553437C44455445524D494E49535449437C4449524543544F52';
wwv_flow_imp.g_varchar2_table(468) := '597C44495354494E43547C444F55424C457C44524F507C4455524154494F4E7C454C454D454E547C454C53457C454C5349467C454D5054597C454E447C4553434150457C4558434550547C455843455054494F4E7C455843455054494F4E537C4558434C';
wwv_flow_imp.g_varchar2_table(469) := '55534956457C455845435554457C4558495354537C455849547C45585445524E414C7C46455443487C46494E414C7C46495253547C46495845447C464C4F41547C464F527C464F52414C4C7C464F5243457C46524F4D7C46554E4354494F4E7C47454E45';
wwv_flow_imp.g_varchar2_table(470) := '52414C7C474F544F7C4752414E547C47524F55507C484153487C484156494E477C484541507C48494444454E7C484F55527C4944454E5449464945447C49467C494D4D4544494154457C494D4D555441424C457C494E7C494E434C5544494E477C494E44';
wwv_flow_imp.g_varchar2_table(471) := '45587C494E44455845537C494E44494341544F527C494E44494345537C494E46494E4954457C494E534552547C494E5354414E544941424C457C494E547C494E544552464143457C494E544552534543547C494E54455256414C7C494E544F7C494E5641';
wwv_flow_imp.g_varchar2_table(472) := '4C49444154457C49537C49534F4C4154494F4E7C4A4156417C4C414E47554147457C4C415247457C4C454144494E477C4C454E4754487C4C4556454C7C4C4942524152597C4C494B457C4C494B45327C4C494B45347C4C494B45437C4C494D49547C4C49';
wwv_flow_imp.g_varchar2_table(473) := '4D495445447C4C4F43414C7C4C4F434B7C4C4F4E477C4C4F4F507C4D41507C4D41587C4D41584C454E7C4D454D4245527C4D455247457C4D494E7C4D494E55537C4D494E5554457C4D4F447C4D4F44457C4D4F444946597C4D4F4E54487C4D554C544953';
wwv_flow_imp.g_varchar2_table(474) := '45547C4D555441424C457C4E414D457C4E414E7C4E4154494F4E414C7C4E41544956457C4E434841527C4E45577C4E4F434F4D50524553537C4E4F434F50597C4E4F547C4E4F574149547C4E554C4C7C4E554D4245525F424153457C4F424A4543547C4F';
wwv_flow_imp.g_varchar2_table(475) := '4349434F4C4C7C4F4349444154457C4F43494441544554494D457C4F43494455524154494F4E7C4F4349494E54455256414C7C4F43494C4F424C4F4341544F527C4F43494E554D4245527C4F43495241577C4F43495245467C4F4349524546435552534F';
wwv_flow_imp.g_varchar2_table(476) := '527C4F4349524F5749447C4F4349535452494E477C4F4349545950457C4F467C4F4C447C4F4E7C4F4E4C597C4F50415155457C4F50454E7C4F50455241544F527C4F5054494F4E7C4F527C4F5241434C457C4F5241444154417C4F524445527C4F524741';
wwv_flow_imp.g_varchar2_table(477) := '4E495A4154494F4E7C4F524C414E597C4F524C564152597C4F54484552537C4F55547C4F5645524C4150537C4F564552524944494E477C5041434B4147457C504152414C4C454C5F454E41424C457C504152414D455445527C504152414D45544552537C';
wwv_flow_imp.g_varchar2_table(478) := '504152454E547C504152544954494F4E7C50415343414C7C5045525349535441424C457C504950457C504950454C494E45447C504C55474741424C457C504F4C594D4F52504849437C505241474D417C505245434953494F4E7C5052494F527C50524956';
wwv_flow_imp.g_varchar2_table(479) := '4154457C50524F4345445552457C5055424C49437C52414953457C52414E47457C5241577C524541447C5245434F52447C5245467C5245464552454E43457C52454C4945535F4F4E7C52454D7C52454D41494E4445527C52454E414D457C5245534F5552';
wwv_flow_imp.g_varchar2_table(480) := '43457C524553554C547C524553554C545F43414348457C52455455524E7C52455455524E494E477C524556455253457C5245564F4B457C524F4C4C4241434B7C524F577C53414D504C457C534156457C53415645504F494E547C5342317C5342327C5342';
wwv_flow_imp.g_varchar2_table(481) := '347C5345434F4E447C5345474D454E547C53454C4543547C53454C467C53455041524154457C53455155454E43457C53455249414C495A41424C457C5345547C53484152457C53484F52547C53495A457C53495A455F547C534F4D457C5350415253457C';
wwv_flow_imp.g_varchar2_table(482) := '53514C7C53514C434F44457C53514C444154417C53514C4E414D457C53514C53544154457C5354414E444152447C53544152547C5354415449437C5354444445567C53544F5245447C535452494E477C5354525543547C5354594C457C5355424D554C54';
wwv_flow_imp.g_varchar2_table(483) := '495345547C535542504152544954494F4E7C53554253544954555441424C457C535542545950457C53554D7C53594E4F4E594D7C544142415554487C5441424C457C54444F7C5448457C5448454E7C54494D457C54494D455354414D507C54494D455A4F';
wwv_flow_imp.g_varchar2_table(484) := '4E455F414242527C54494D455A4F4E455F484F55527C54494D455A4F4E455F4D494E5554457C54494D455A4F4E455F524547494F4E7C544F7C545241494C494E477C5452414E53414354494F4E7C5452414E53414354494F4E414C7C545255535445447C';
wwv_flow_imp.g_varchar2_table(485) := '545950457C5542317C5542327C5542347C554E4445527C554E494F4E7C554E495155457C554E504C55477C554E5349474E45447C554E545255535445447C5550444154457C5553457C5553494E477C56414C4953547C56414C55457C56414C5545537C56';
wwv_flow_imp.g_varchar2_table(486) := '41524941424C457C56415249414E43457C5641525241597C56415259494E477C564945577C56494557537C564F49447C5748454E7C57484552457C5748494C457C574954487C574F524B7C575241505045447C57524954457C594541527C5A4F4E45295C';
wwv_flow_imp.g_varchar2_table(487) := '622F692C0A092F2F2068747470733A2F2F646F63732E6F7261636C652E636F6D2F656E2F64617461626173652F6F7261636C652F6F7261636C652D64617461626173652F32312F6C6E706C732F706C73716C2D6C616E67756167652D66756E64616D656E';
wwv_flow_imp.g_varchar2_table(488) := '74616C732E68746D6C23475549442D39364134324637432D374137312D344239302D383235352D4341394338424439373232450A09276F70657261746F72273A202F3A3D3F7C3D3E7C5B3C3E5E7E215D3D7C5C2E5C2E7C5C7C5C7C7C5C2A5C2A7C5B2D2B';
wwv_flow_imp.g_varchar2_table(489) := '2A2F253C3E3D405D2F0A7D293B0A0A507269736D2E6C616E6775616765732E696E736572744265666F72652827706C73716C272C20276F70657261746F72272C207B0A09276C6162656C273A207B0A09097061747465726E3A202F3C3C5C732A5C772B5C';
wwv_flow_imp.g_varchar2_table(490) := '732A3E3E2F2C0A0909616C6961733A202773796D626F6C270A097D2C0A7D293B0A0A2866756E6374696F6E202829207B0A0A0969662028747970656F6620507269736D203D3D3D2027756E646566696E656427207C7C20747970656F6620646F63756D65';
wwv_flow_imp.g_varchar2_table(491) := '6E74203D3D3D2027756E646566696E65642729207B0A090972657475726E3B0A097D0A0A092F2A2A0A09202A20506C7567696E206E616D652077686963682069732075736564206173206120636C617373206E616D6520666F72203C7072653E20776869';
wwv_flow_imp.g_varchar2_table(492) := '63682069732061637469766174696E672074686520706C7567696E0A09202A0A09202A204074797065207B737472696E677D0A09202A2F0A0976617220504C5547494E5F4E414D45203D20276C696E652D6E756D62657273273B0A0A092F2A2A0A09202A';
wwv_flow_imp.g_varchar2_table(493) := '20526567756C61722065787072657373696F6E207573656420666F722064657465726D696E696E67206C696E6520627265616B730A09202A0A09202A204074797065207B5265674578707D0A09202A2F0A09766172204E45575F4C494E455F455850203D';
wwv_flow_imp.g_varchar2_table(494) := '202F5C6E283F2124292F673B0A0A0A092F2A2A0A09202A20476C6F62616C206578706F7274730A09202A2F0A0976617220636F6E666967203D20507269736D2E706C7567696E732E6C696E654E756D62657273203D207B0A09092F2A2A0A0909202A2047';
wwv_flow_imp.g_varchar2_table(495) := '6574206E6F646520666F722070726F7669646564206C696E65206E756D6265720A0909202A0A0909202A2040706172616D207B456C656D656E747D20656C656D656E742070726520656C656D656E740A0909202A2040706172616D207B6E756D6265727D';
wwv_flow_imp.g_varchar2_table(496) := '206E756D626572206C696E65206E756D6265720A0909202A204072657475726E73207B456C656D656E747C756E646566696E65647D0A0909202A2F0A09096765744C696E653A2066756E6374696F6E2028656C656D656E742C206E756D62657229207B0A';
wwv_flow_imp.g_varchar2_table(497) := '09090969662028656C656D656E742E7461674E616D6520213D3D202750524527207C7C2021656C656D656E742E636C6173734C6973742E636F6E7461696E7328504C5547494E5F4E414D452929207B0A0909090972657475726E3B0A0909097D0A0A0909';
wwv_flow_imp.g_varchar2_table(498) := '09766172206C696E654E756D626572526F7773203D20656C656D656E742E717565727953656C6563746F7228272E6C696E652D6E756D626572732D726F777327293B0A09090969662028216C696E654E756D626572526F777329207B0A09090909726574';
wwv_flow_imp.g_varchar2_table(499) := '75726E3B0A0909097D0A090909766172206C696E654E756D6265725374617274203D207061727365496E7428656C656D656E742E6765744174747269627574652827646174612D737461727427292C20313029207C7C20313B0A090909766172206C696E';
wwv_flow_imp.g_varchar2_table(500) := '654E756D626572456E64203D206C696E654E756D6265725374617274202B20286C696E654E756D626572526F77732E6368696C6472656E2E6C656E677468202D2031293B0A0A090909696620286E756D626572203C206C696E654E756D62657253746172';
wwv_flow_imp.g_varchar2_table(501) := '7429207B0A090909096E756D626572203D206C696E654E756D62657253746172743B0A0909097D0A090909696620286E756D626572203E206C696E654E756D626572456E6429207B0A090909096E756D626572203D206C696E654E756D626572456E643B';
wwv_flow_imp.g_varchar2_table(502) := '0A0909097D0A0A090909766172206C696E65496E646578203D206E756D626572202D206C696E654E756D62657253746172743B0A0A09090972657475726E206C696E654E756D626572526F77732E6368696C6472656E5B6C696E65496E6465785D3B0A09';
wwv_flow_imp.g_varchar2_table(503) := '097D2C0A0A09092F2A2A0A0909202A20526573697A657320746865206C696E65206E756D62657273206F662074686520676976656E20656C656D656E742E0A0909202A0A0909202A20546869732066756E6374696F6E2077696C6C206E6F742061646420';
wwv_flow_imp.g_varchar2_table(504) := '6C696E65206E756D626572732E2049742077696C6C206F6E6C7920726573697A65206578697374696E67206F6E65732E0A0909202A0A0909202A2040706172616D207B48544D4C456C656D656E747D20656C656D656E74204120603C7072653E6020656C';
wwv_flow_imp.g_varchar2_table(505) := '656D656E742077697468206C696E65206E756D626572732E0A0909202A204072657475726E73207B766F69647D0A0909202A2F0A0909726573697A653A2066756E6374696F6E2028656C656D656E7429207B0A090909726573697A65456C656D656E7473';
wwv_flow_imp.g_varchar2_table(506) := '285B656C656D656E745D293B0A09097D2C0A0A09092F2A2A0A0909202A20576865746865722074686520706C7567696E2063616E20617373756D6520746861742074686520756E69747320666F6E742073697A657320616E64206D617267696E73206172';
wwv_flow_imp.g_varchar2_table(507) := '65206E6F7420646570656E646564206F6E207468652073697A65206F660A0909202A207468652063757272656E742076696577706F72742E0A0909202A0A0909202A2053657474696E67207468697320746F206074727565602077696C6C20616C6C6F77';
wwv_flow_imp.g_varchar2_table(508) := '2074686520706C7567696E20746F20646F206365727461696E206F7074696D697A6174696F6E7320666F722062657474657220706572666F726D616E63652E0A0909202A0A0909202A20536574207468697320746F206066616C73656020696620796F75';
wwv_flow_imp.g_varchar2_table(509) := '2075736520616E79206F662074686520666F6C6C6F77696E672043535320756E6974733A20607668602C20607677602C2060766D696E602C2060766D6178602E0A0909202A0A0909202A204074797065207B626F6F6C65616E7D0A0909202A2F0A090961';
wwv_flow_imp.g_varchar2_table(510) := '7373756D6556696577706F7274496E646570656E64656E63653A20747275650A097D3B0A0A092F2A2A0A09202A20526573697A65732074686520676976656E20656C656D656E74732E0A09202A0A09202A2040706172616D207B48544D4C456C656D656E';
wwv_flow_imp.g_varchar2_table(511) := '745B5D7D20656C656D656E74730A09202A2F0A0966756E6374696F6E20726573697A65456C656D656E747328656C656D656E747329207B0A0909656C656D656E7473203D20656C656D656E74732E66696C7465722866756E6374696F6E20286529207B0A';
wwv_flow_imp.g_varchar2_table(512) := '09090976617220636F64655374796C6573203D206765745374796C65732865293B0A0909097661722077686974655370616365203D20636F64655374796C65735B2777686974652D7370616365275D3B0A09090972657475726E20776869746553706163';
wwv_flow_imp.g_varchar2_table(513) := '65203D3D3D20277072652D7772617027207C7C2077686974655370616365203D3D3D20277072652D6C696E65273B0A09097D293B0A0A090969662028656C656D656E74732E6C656E677468203D3D203029207B0A09090972657475726E3B0A09097D0A0A';
wwv_flow_imp.g_varchar2_table(514) := '090976617220696E666F73203D20656C656D656E74732E6D61702866756E6374696F6E2028656C656D656E7429207B0A09090976617220636F6465456C656D656E74203D20656C656D656E742E717565727953656C6563746F722827636F646527293B0A';
wwv_flow_imp.g_varchar2_table(515) := '090909766172206C696E654E756D6265727357726170706572203D20656C656D656E742E717565727953656C6563746F7228272E6C696E652D6E756D626572732D726F777327293B0A0909096966202821636F6465456C656D656E74207C7C20216C696E';
wwv_flow_imp.g_varchar2_table(516) := '654E756D626572735772617070657229207B0A0909090972657475726E20756E646566696E65643B0A0909097D0A0A0909092F2A2A204074797065207B48544D4C456C656D656E747D202A2F0A090909766172206C696E654E756D62657253697A657220';
wwv_flow_imp.g_varchar2_table(517) := '3D20656C656D656E742E717565727953656C6563746F7228272E6C696E652D6E756D626572732D73697A657227293B0A09090976617220636F64654C696E6573203D20636F6465456C656D656E742E74657874436F6E74656E742E73706C6974284E4557';
wwv_flow_imp.g_varchar2_table(518) := '5F4C494E455F455850293B0A0A09090969662028216C696E654E756D62657253697A657229207B0A090909096C696E654E756D62657253697A6572203D20646F63756D656E742E637265617465456C656D656E7428277370616E27293B0A090909096C69';
wwv_flow_imp.g_varchar2_table(519) := '6E654E756D62657253697A65722E636C6173734E616D65203D20276C696E652D6E756D626572732D73697A6572273B0A0A09090909636F6465456C656D656E742E617070656E644368696C64286C696E654E756D62657253697A6572293B0A0909097D0A';
wwv_flow_imp.g_varchar2_table(520) := '0A0909096C696E654E756D62657253697A65722E696E6E657248544D4C203D202730273B0A0909096C696E654E756D62657253697A65722E7374796C652E646973706C6179203D2027626C6F636B273B0A0A090909766172206F6E654C696E6572486569';
wwv_flow_imp.g_varchar2_table(521) := '676874203D206C696E654E756D62657253697A65722E676574426F756E64696E67436C69656E745265637428292E6865696768743B0A0909096C696E654E756D62657253697A65722E696E6E657248544D4C203D2027273B0A0A09090972657475726E20';
wwv_flow_imp.g_varchar2_table(522) := '7B0A09090909656C656D656E743A20656C656D656E742C0A090909096C696E65733A20636F64654C696E65732C0A090909096C696E65486569676874733A205B5D2C0A090909096F6E654C696E65724865696768743A206F6E654C696E65724865696768';
wwv_flow_imp.g_varchar2_table(523) := '742C0A0909090973697A65723A206C696E654E756D62657253697A65722C0A0909097D3B0A09097D292E66696C74657228426F6F6C65616E293B0A0A0909696E666F732E666F72456163682866756E6374696F6E2028696E666F29207B0A090909766172';
wwv_flow_imp.g_varchar2_table(524) := '206C696E654E756D62657253697A6572203D20696E666F2E73697A65723B0A090909766172206C696E6573203D20696E666F2E6C696E65733B0A090909766172206C696E6548656967687473203D20696E666F2E6C696E65486569676874733B0A090909';
wwv_flow_imp.g_varchar2_table(525) := '766172206F6E654C696E6572486569676874203D20696E666F2E6F6E654C696E65724865696768743B0A0A0909096C696E65486569676874735B6C696E65732E6C656E677468202D20315D203D20756E646566696E65643B0A0909096C696E65732E666F';
wwv_flow_imp.g_varchar2_table(526) := '72456163682866756E6374696F6E20286C696E652C20696E64657829207B0A09090909696620286C696E65202626206C696E652E6C656E677468203E203129207B0A09090909097661722065203D206C696E654E756D62657253697A65722E617070656E';
wwv_flow_imp.g_varchar2_table(527) := '644368696C6428646F63756D656E742E637265617465456C656D656E7428277370616E2729293B0A0909090909652E7374796C652E646973706C6179203D2027626C6F636B273B0A0909090909652E74657874436F6E74656E74203D206C696E653B0A09';
wwv_flow_imp.g_varchar2_table(528) := '0909097D20656C7365207B0A09090909096C696E65486569676874735B696E6465785D203D206F6E654C696E65724865696768743B0A090909097D0A0909097D293B0A09097D293B0A0A0909696E666F732E666F72456163682866756E6374696F6E2028';
wwv_flow_imp.g_varchar2_table(529) := '696E666F29207B0A090909766172206C696E654E756D62657253697A6572203D20696E666F2E73697A65723B0A090909766172206C696E6548656967687473203D20696E666F2E6C696E65486569676874733B0A0A090909766172206368696C64496E64';
wwv_flow_imp.g_varchar2_table(530) := '6578203D20303B0A090909666F7220287661722069203D20303B2069203C206C696E65486569676874732E6C656E6774683B20692B2B29207B0A09090909696620286C696E65486569676874735B695D203D3D3D20756E646566696E656429207B0A0909';
wwv_flow_imp.g_varchar2_table(531) := '0909096C696E65486569676874735B695D203D206C696E654E756D62657253697A65722E6368696C6472656E5B6368696C64496E6465782B2B5D2E676574426F756E64696E67436C69656E745265637428292E6865696768743B0A090909097D0A090909';
wwv_flow_imp.g_varchar2_table(532) := '7D0A09097D293B0A0A0909696E666F732E666F72456163682866756E6374696F6E2028696E666F29207B0A090909766172206C696E654E756D62657253697A6572203D20696E666F2E73697A65723B0A0909097661722077726170706572203D20696E66';
wwv_flow_imp.g_varchar2_table(533) := '6F2E656C656D656E742E717565727953656C6563746F7228272E6C696E652D6E756D626572732D726F777327293B0A0A0909096C696E654E756D62657253697A65722E7374796C652E646973706C6179203D20276E6F6E65273B0A0909096C696E654E75';
wwv_flow_imp.g_varchar2_table(534) := '6D62657253697A65722E696E6E657248544D4C203D2027273B0A0A090909696E666F2E6C696E65486569676874732E666F72456163682866756E6374696F6E20286865696768742C206C696E654E756D62657229207B0A09090909777261707065722E63';
wwv_flow_imp.g_varchar2_table(535) := '68696C6472656E5B6C696E654E756D6265725D2E7374796C652E686569676874203D20686569676874202B20277078273B0A0909097D293B0A09097D293B0A097D0A0A092F2A2A0A09202A2052657475726E73207374796C65206465636C61726174696F';
wwv_flow_imp.g_varchar2_table(536) := '6E7320666F722074686520656C656D656E740A09202A0A09202A2040706172616D207B456C656D656E747D20656C656D656E740A09202A2F0A0966756E6374696F6E206765745374796C657328656C656D656E7429207B0A09096966202821656C656D65';
wwv_flow_imp.g_varchar2_table(537) := '6E7429207B0A09090972657475726E206E756C6C3B0A09097D0A0A090972657475726E2077696E646F772E676574436F6D70757465645374796C65203F20676574436F6D70757465645374796C6528656C656D656E7429203A2028656C656D656E742E63';
wwv_flow_imp.g_varchar2_table(538) := '757272656E745374796C65207C7C206E756C6C293B0A097D0A0A09766172206C6173745769647468203D20756E646566696E65643B0A0977696E646F772E6164644576656E744C697374656E65722827726573697A65272C2066756E6374696F6E202829';
wwv_flow_imp.g_varchar2_table(539) := '207B0A090969662028636F6E6669672E617373756D6556696577706F7274496E646570656E64656E6365202626206C6173745769647468203D3D3D2077696E646F772E696E6E6572576964746829207B0A09090972657475726E3B0A09097D0A09096C61';
wwv_flow_imp.g_varchar2_table(540) := '73745769647468203D2077696E646F772E696E6E657257696474683B0A0A0909726573697A65456C656D656E74732841727261792E70726F746F747970652E736C6963652E63616C6C28646F63756D656E742E717565727953656C6563746F72416C6C28';
wwv_flow_imp.g_varchar2_table(541) := '277072652E27202B20504C5547494E5F4E414D452929293B0A097D293B0A0A09507269736D2E686F6F6B732E6164642827636F6D706C657465272C2066756E6374696F6E2028656E7629207B0A09096966202821656E762E636F646529207B0A09090972';
wwv_flow_imp.g_varchar2_table(542) := '657475726E3B0A09097D0A0A090976617220636F6465203D202F2A2A204074797065207B456C656D656E747D202A2F2028656E762E656C656D656E74293B0A090976617220707265203D202F2A2A204074797065207B48544D4C456C656D656E747D202A';
wwv_flow_imp.g_varchar2_table(543) := '2F2028636F64652E706172656E744E6F6465293B0A0A09092F2F20776F726B73206F6E6C7920666F72203C636F64653E207772617070656420696E73696465203C7072653E20286E6F7420696E6C696E65290A09096966202821707265207C7C20212F70';
wwv_flow_imp.g_varchar2_table(544) := '72652F692E74657374287072652E6E6F64654E616D652929207B0A09090972657475726E3B0A09097D0A0A09092F2F2041626F7274206966206C696E65206E756D6265727320616C7265616479206578697374730A090969662028636F64652E71756572';
wwv_flow_imp.g_varchar2_table(545) := '7953656C6563746F7228272E6C696E652D6E756D626572732D726F7773272929207B0A09090972657475726E3B0A09097D0A0A09092F2F206F6E6C7920616464206C696E65206E756D62657273206966203C636F64653E206F72206F6E65206F66206974';
wwv_flow_imp.g_varchar2_table(546) := '7320616E636573746F7273206861732074686520606C696E652D6E756D626572736020636C6173730A09096966202821507269736D2E7574696C2E697341637469766528636F64652C20504C5547494E5F4E414D452929207B0A09090972657475726E3B';
wwv_flow_imp.g_varchar2_table(547) := '0A09097D0A0A09092F2F2052656D6F76652074686520636C61737320276C696E652D6E756D62657273272066726F6D20746865203C636F64653E0A0909636F64652E636C6173734C6973742E72656D6F766528504C5547494E5F4E414D45293B0A09092F';
wwv_flow_imp.g_varchar2_table(548) := '2F204164642074686520636C61737320276C696E652D6E756D626572732720746F20746865203C7072653E0A09097072652E636C6173734C6973742E61646428504C5547494E5F4E414D45293B0A0A0909766172206D61746368203D20656E762E636F64';
wwv_flow_imp.g_varchar2_table(549) := '652E6D61746368284E45575F4C494E455F455850293B0A0909766172206C696E65734E756D203D206D61746368203F206D617463682E6C656E677468202B2031203A20313B0A0909766172206C696E654E756D62657273577261707065723B0A0A090976';
wwv_flow_imp.g_varchar2_table(550) := '6172206C696E6573203D206E6577204172726179286C696E65734E756D202B2031292E6A6F696E28273C7370616E3E3C2F7370616E3E27293B0A0A09096C696E654E756D6265727357726170706572203D20646F63756D656E742E637265617465456C65';
wwv_flow_imp.g_varchar2_table(551) := '6D656E7428277370616E27293B0A09096C696E654E756D62657273577261707065722E7365744174747269627574652827617269612D68696464656E272C20277472756527293B0A09096C696E654E756D62657273577261707065722E636C6173734E61';
wwv_flow_imp.g_varchar2_table(552) := '6D65203D20276C696E652D6E756D626572732D726F7773273B0A09096C696E654E756D62657273577261707065722E696E6E657248544D4C203D206C696E65733B0A0A0909696620287072652E6861734174747269627574652827646174612D73746172';
wwv_flow_imp.g_varchar2_table(553) := '74272929207B0A0909097072652E7374796C652E636F756E7465725265736574203D20276C696E656E756D6265722027202B20287061727365496E74287072652E6765744174747269627574652827646174612D737461727427292C20313029202D2031';
wwv_flow_imp.g_varchar2_table(554) := '293B0A09097D0A0A0909656E762E656C656D656E742E617070656E644368696C64286C696E654E756D6265727357726170706572293B0A0A0909726573697A65456C656D656E7473285B7072655D293B0A0A0909507269736D2E686F6F6B732E72756E28';
wwv_flow_imp.g_varchar2_table(555) := '276C696E652D6E756D62657273272C20656E76293B0A097D293B0A0A09507269736D2E686F6F6B732E61646428276C696E652D6E756D62657273272C2066756E6374696F6E2028656E7629207B0A0909656E762E706C7567696E73203D20656E762E706C';
wwv_flow_imp.g_varchar2_table(556) := '7567696E73207C7C207B7D3B0A0909656E762E706C7567696E732E6C696E654E756D62657273203D20747275653B0A097D293B0A0A7D2829293B0A0A2866756E6374696F6E202829207B0A0A0969662028747970656F6620507269736D203D3D3D202775';
wwv_flow_imp.g_varchar2_table(557) := '6E646566696E656427207C7C20747970656F6620646F63756D656E74203D3D3D2027756E646566696E65642729207B0A090972657475726E3B0A097D0A0A097661722063616C6C6261636B73203D205B5D3B0A09766172206D6170203D207B7D3B0A0976';
wwv_flow_imp.g_varchar2_table(558) := '6172206E6F6F70203D2066756E6374696F6E202829207B7D3B0A0A09507269736D2E706C7567696E732E746F6F6C626172203D207B7D3B0A0A092F2A2A0A09202A20407479706564656620427574746F6E4F7074696F6E730A09202A204070726F706572';
wwv_flow_imp.g_varchar2_table(559) := '7479207B737472696E677D207465787420546865207465787420646973706C617965642E0A09202A204070726F7065727479207B737472696E677D205B75726C5D205468652055524C206F6620746865206C696E6B2077686963682077696C6C20626520';
wwv_flow_imp.g_varchar2_table(560) := '637265617465642E0A09202A204070726F7065727479207B46756E6374696F6E7D205B6F6E436C69636B5D20546865206576656E74206C697374656E657220666F72207468652060636C69636B60206576656E74206F6620746865206372656174656420';
wwv_flow_imp.g_varchar2_table(561) := '627574746F6E2E0A09202A204070726F7065727479207B737472696E677D205B636C6173734E616D655D2054686520636C6173732061747472696275746520746F20696E636C756465207769746820656C656D656E742E0A09202A2F0A0A092F2A2A0A09';
wwv_flow_imp.g_varchar2_table(562) := '202A205265676973746572206120627574746F6E2063616C6C6261636B20776974682074686520746F6F6C6261722E0A09202A0A09202A2040706172616D207B737472696E677D206B65790A09202A2040706172616D207B427574746F6E4F7074696F6E';
wwv_flow_imp.g_varchar2_table(563) := '737C46756E6374696F6E7D206F7074730A09202A2F0A09766172207265676973746572427574746F6E203D20507269736D2E706C7567696E732E746F6F6C6261722E7265676973746572427574746F6E203D2066756E6374696F6E20286B65792C206F70';
wwv_flow_imp.g_varchar2_table(564) := '747329207B0A09097661722063616C6C6261636B3B0A0A090969662028747970656F66206F707473203D3D3D202766756E6374696F6E2729207B0A09090963616C6C6261636B203D206F7074733B0A09097D20656C7365207B0A09090963616C6C626163';
wwv_flow_imp.g_varchar2_table(565) := '6B203D2066756E6374696F6E2028656E7629207B0A0909090976617220656C656D656E743B0A0A0909090969662028747970656F66206F7074732E6F6E436C69636B203D3D3D202766756E6374696F6E2729207B0A0909090909656C656D656E74203D20';
wwv_flow_imp.g_varchar2_table(566) := '646F63756D656E742E637265617465456C656D656E742827627574746F6E27293B0A0909090909656C656D656E742E74797065203D2027627574746F6E273B0A0909090909656C656D656E742E6164644576656E744C697374656E65722827636C69636B';
wwv_flow_imp.g_varchar2_table(567) := '272C2066756E6374696F6E202829207B0A0909090909096F7074732E6F6E436C69636B2E63616C6C28746869732C20656E76293B0A09090909097D293B0A090909097D20656C73652069662028747970656F66206F7074732E75726C203D3D3D20277374';
wwv_flow_imp.g_varchar2_table(568) := '72696E672729207B0A0909090909656C656D656E74203D20646F63756D656E742E637265617465456C656D656E7428276127293B0A0909090909656C656D656E742E68726566203D206F7074732E75726C3B0A090909097D20656C7365207B0A09090909';
wwv_flow_imp.g_varchar2_table(569) := '09656C656D656E74203D20646F63756D656E742E637265617465456C656D656E7428277370616E27293B0A090909097D0A0A09090909696620286F7074732E636C6173734E616D6529207B0A0909090909656C656D656E742E636C6173734C6973742E61';
wwv_flow_imp.g_varchar2_table(570) := '6464286F7074732E636C6173734E616D65293B0A090909097D0A0A09090909656C656D656E742E74657874436F6E74656E74203D206F7074732E746578743B0A0A0909090972657475726E20656C656D656E743B0A0909097D3B0A09097D0A0A09096966';
wwv_flow_imp.g_varchar2_table(571) := '20286B657920696E206D617029207B0A090909636F6E736F6C652E7761726E28275468657265206973206120627574746F6E207769746820746865206B6579202227202B206B6579202B202722207265676973746572656420616C72656164792E27293B';
wwv_flow_imp.g_varchar2_table(572) := '0A09090972657475726E3B0A09097D0A0A090963616C6C6261636B732E70757368286D61705B6B65795D203D2063616C6C6261636B293B0A097D3B0A0A092F2A2A0A09202A2052657475726E73207468652063616C6C6261636B206F72646572206F6620';
wwv_flow_imp.g_varchar2_table(573) := '74686520676976656E20656C656D656E742E0A09202A0A09202A2040706172616D207B48544D4C456C656D656E747D20656C656D656E740A09202A204072657475726E73207B737472696E675B5D207C20756E646566696E65647D0A09202A2F0A096675';
wwv_flow_imp.g_varchar2_table(574) := '6E6374696F6E206765744F7264657228656C656D656E7429207B0A09097768696C652028656C656D656E7429207B0A090909766172206F72646572203D20656C656D656E742E6765744174747269627574652827646174612D746F6F6C6261722D6F7264';
wwv_flow_imp.g_varchar2_table(575) := '657227293B0A090909696620286F7264657220213D206E756C6C29207B0A090909096F72646572203D206F726465722E7472696D28293B0A09090909696620286F726465722E6C656E67746829207B0A090909090972657475726E206F726465722E7370';
wwv_flow_imp.g_varchar2_table(576) := '6C6974282F5C732A2C5C732A2F67293B0A090909097D20656C7365207B0A090909090972657475726E205B5D3B0A090909097D0A0909097D0A090909656C656D656E74203D20656C656D656E742E706172656E74456C656D656E743B0A09097D0A097D0A';
wwv_flow_imp.g_varchar2_table(577) := '0A092F2A2A0A09202A20506F73742D686967686C6967687420507269736D20686F6F6B2063616C6C6261636B2E0A09202A0A09202A2040706172616D20656E760A09202A2F0A0976617220686F6F6B203D20507269736D2E706C7567696E732E746F6F6C';
wwv_flow_imp.g_varchar2_table(578) := '6261722E686F6F6B203D2066756E6374696F6E2028656E7629207B0A09092F2F20436865636B20696620696E6C696E65206F722061637475616C20636F646520626C6F636B202863726564697420746F206C696E652D6E756D6265727320706C7567696E';
wwv_flow_imp.g_varchar2_table(579) := '290A090976617220707265203D20656E762E656C656D656E742E706172656E744E6F64653B0A09096966202821707265207C7C20212F7072652F692E74657374287072652E6E6F64654E616D652929207B0A09090972657475726E3B0A09097D0A0A0909';
wwv_flow_imp.g_varchar2_table(580) := '2F2F204175746F6C6F61646572207265686967686C69676874732C20736F206F6E6C7920646F2074686973206F6E63652E0A0909696620287072652E706172656E744E6F64652E636C6173734C6973742E636F6E7461696E732827636F64652D746F6F6C';
wwv_flow_imp.g_varchar2_table(581) := '626172272929207B0A09090972657475726E3B0A09097D0A0A09092F2F20437265617465207772617070657220666F72203C7072653E20746F2070726576656E74207363726F6C6C696E6720746F6F6C626172207769746820636F6E74656E740A090976';
wwv_flow_imp.g_varchar2_table(582) := '61722077726170706572203D20646F63756D656E742E637265617465456C656D656E74282764697627293B0A0909777261707065722E636C6173734C6973742E6164642827636F64652D746F6F6C62617227293B0A09097072652E706172656E744E6F64';
wwv_flow_imp.g_varchar2_table(583) := '652E696E736572744265666F726528777261707065722C20707265293B0A0909777261707065722E617070656E644368696C6428707265293B0A0A09092F2F2053657475702074686520746F6F6C6261720A090976617220746F6F6C626172203D20646F';
wwv_flow_imp.g_varchar2_table(584) := '63756D656E742E637265617465456C656D656E74282764697627293B0A0909746F6F6C6261722E636C6173734C6973742E6164642827746F6F6C62617227293B0A0A09092F2F206F726465722063616C6C6261636B730A090976617220656C656D656E74';
wwv_flow_imp.g_varchar2_table(585) := '43616C6C6261636B73203D2063616C6C6261636B733B0A0909766172206F72646572203D206765744F7264657228656E762E656C656D656E74293B0A0909696620286F7264657229207B0A090909656C656D656E7443616C6C6261636B73203D206F7264';
wwv_flow_imp.g_varchar2_table(586) := '65722E6D61702866756E6374696F6E20286B657929207B0A0909090972657475726E206D61705B6B65795D207C7C206E6F6F703B0A0909097D293B0A09097D0A0A0909656C656D656E7443616C6C6261636B732E666F72456163682866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(587) := '202863616C6C6261636B29207B0A09090976617220656C656D656E74203D2063616C6C6261636B28656E76293B0A0A0909096966202821656C656D656E7429207B0A0909090972657475726E3B0A0909097D0A0A090909766172206974656D203D20646F';
wwv_flow_imp.g_varchar2_table(588) := '63756D656E742E637265617465456C656D656E74282764697627293B0A0909096974656D2E636C6173734C6973742E6164642827746F6F6C6261722D6974656D27293B0A0A0909096974656D2E617070656E644368696C6428656C656D656E74293B0A09';
wwv_flow_imp.g_varchar2_table(589) := '0909746F6F6C6261722E617070656E644368696C64286974656D293B0A09097D293B0A0A09092F2F20416464206F757220746F6F6C62617220746F207468652063757272656E746C7920637265617465642077726170706572206F66203C7072653E2074';
wwv_flow_imp.g_varchar2_table(590) := '61670A0909777261707065722E617070656E644368696C6428746F6F6C626172293B0A097D3B0A0A097265676973746572427574746F6E28276C6162656C272C2066756E6374696F6E2028656E7629207B0A090976617220707265203D20656E762E656C';
wwv_flow_imp.g_varchar2_table(591) := '656D656E742E706172656E744E6F64653B0A09096966202821707265207C7C20212F7072652F692E74657374287072652E6E6F64654E616D652929207B0A09090972657475726E3B0A09097D0A0A090969662028217072652E6861734174747269627574';
wwv_flow_imp.g_varchar2_table(592) := '652827646174612D6C6162656C272929207B0A09090972657475726E3B0A09097D0A0A090976617220656C656D656E743B207661722074656D706C6174653B0A09097661722074657874203D207072652E6765744174747269627574652827646174612D';
wwv_flow_imp.g_varchar2_table(593) := '6C6162656C27293B0A0909747279207B0A0909092F2F20416E79206E6F726D616C20746578742077696C6C20626C6F7720757020746869732073656C6563746F722E0A09090974656D706C617465203D20646F63756D656E742E717565727953656C6563';
wwv_flow_imp.g_varchar2_table(594) := '746F72282774656D706C6174652327202B2074657874293B0A09097D20636174636820286529207B202F2A206E6F6F70202A2F207D0A0A09096966202874656D706C61746529207B0A090909656C656D656E74203D2074656D706C6174652E636F6E7465';
wwv_flow_imp.g_varchar2_table(595) := '6E743B0A09097D20656C7365207B0A090909696620287072652E6861734174747269627574652827646174612D75726C272929207B0A09090909656C656D656E74203D20646F63756D656E742E637265617465456C656D656E7428276127293B0A090909';
wwv_flow_imp.g_varchar2_table(596) := '09656C656D656E742E68726566203D207072652E6765744174747269627574652827646174612D75726C27293B0A0909097D20656C7365207B0A09090909656C656D656E74203D20646F63756D656E742E637265617465456C656D656E7428277370616E';
wwv_flow_imp.g_varchar2_table(597) := '27293B0A0909097D0A0A090909656C656D656E742E74657874436F6E74656E74203D20746578743B0A09097D0A0A090972657475726E20656C656D656E743B0A097D293B0A0A092F2A2A0A09202A2052656769737465722074686520746F6F6C62617220';
wwv_flow_imp.g_varchar2_table(598) := '7769746820507269736D2E0A09202A2F0A09507269736D2E686F6F6B732E6164642827636F6D706C657465272C20686F6F6B293B0A7D2829293B0A0A2866756E6374696F6E202829207B0A0A0969662028747970656F6620507269736D203D3D3D202775';
wwv_flow_imp.g_varchar2_table(599) := '6E646566696E656427207C7C20747970656F6620646F63756D656E74203D3D3D2027756E646566696E65642729207B0A090972657475726E3B0A097D0A0A096966202821507269736D2E706C7567696E732E746F6F6C62617229207B0A0909636F6E736F';
wwv_flow_imp.g_varchar2_table(600) := '6C652E7761726E2827436F707920746F20436C6970626F61726420706C7567696E206C6F61646564206265666F726520546F6F6C62617220706C7567696E2E27293B0A0A090972657475726E3B0A097D0A0A092F2A2A0A09202A205768656E2074686520';
wwv_flow_imp.g_varchar2_table(601) := '676976656E20656C656D656E747320697320636C69636B65642062792074686520757365722C2074686520676976656E20746578742077696C6C20626520636F7069656420746F20636C6970626F6172642E0A09202A0A09202A2040706172616D207B48';
wwv_flow_imp.g_varchar2_table(602) := '544D4C456C656D656E747D20656C656D656E740A09202A2040706172616D207B436F7079496E666F7D20636F7079496E666F0A09202A0A09202A20407479706564656620436F7079496E666F0A09202A204070726F7065727479207B2829203D3E207374';
wwv_flow_imp.g_varchar2_table(603) := '72696E677D20676574546578740A09202A204070726F7065727479207B2829203D3E20766F69647D20737563636573730A09202A204070726F7065727479207B28726561736F6E3A20756E6B6E6F776E29203D3E20766F69647D206572726F720A09202A';
wwv_flow_imp.g_varchar2_table(604) := '2F0A0966756E6374696F6E207265676973746572436C6970626F61726428656C656D656E742C20636F7079496E666F29207B0A0909656C656D656E742E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E202829207B';
wwv_flow_imp.g_varchar2_table(605) := '0A090909636F707954657874546F436C6970626F61726428636F7079496E666F293B0A09097D293B0A097D0A0A092F2F2068747470733A2F2F737461636B6F766572666C6F772E636F6D2F612F33303831303332322F373539353437320A0A092F2A2A20';
wwv_flow_imp.g_varchar2_table(606) := '40706172616D207B436F7079496E666F7D20636F7079496E666F202A2F0A0966756E6374696F6E2066616C6C6261636B436F707954657874546F436C6970626F61726428636F7079496E666F29207B0A0909766172207465787441726561203D20646F63';
wwv_flow_imp.g_varchar2_table(607) := '756D656E742E637265617465456C656D656E742827746578746172656127293B0A090974657874417265612E76616C7565203D20636F7079496E666F2E6765745465787428293B0A0A09092F2F2041766F6964207363726F6C6C696E6720746F20626F74';
wwv_flow_imp.g_varchar2_table(608) := '746F6D0A090974657874417265612E7374796C652E746F70203D202730273B0A090974657874417265612E7374796C652E6C656674203D202730273B0A090974657874417265612E7374796C652E706F736974696F6E203D20276669786564273B0A0A09';
wwv_flow_imp.g_varchar2_table(609) := '09646F63756D656E742E626F64792E617070656E644368696C64287465787441726561293B0A090974657874417265612E666F63757328293B0A090974657874417265612E73656C65637428293B0A0A0909747279207B0A090909766172207375636365';
wwv_flow_imp.g_varchar2_table(610) := '737366756C203D20646F63756D656E742E65786563436F6D6D616E642827636F707927293B0A09090973657454696D656F75742866756E6374696F6E202829207B0A09090909696620287375636365737366756C29207B0A0909090909636F7079496E66';
wwv_flow_imp.g_varchar2_table(611) := '6F2E7375636365737328293B0A090909097D20656C7365207B0A0909090909636F7079496E666F2E6572726F7228293B0A090909097D0A0909097D2C2031293B0A09097D206361746368202865727229207B0A09090973657454696D656F75742866756E';
wwv_flow_imp.g_varchar2_table(612) := '6374696F6E202829207B0A09090909636F7079496E666F2E6572726F7228657272293B0A0909097D2C2031293B0A09097D0A0A0909646F63756D656E742E626F64792E72656D6F76654368696C64287465787441726561293B0A097D0A092F2A2A204070';
wwv_flow_imp.g_varchar2_table(613) := '6172616D207B436F7079496E666F7D20636F7079496E666F202A2F0A0966756E6374696F6E20636F707954657874546F436C6970626F61726428636F7079496E666F29207B0A0909696620286E6176696761746F722E636C6970626F61726429207B0A09';
wwv_flow_imp.g_varchar2_table(614) := '09096E6176696761746F722E636C6970626F6172642E77726974655465787428636F7079496E666F2E676574546578742829292E7468656E28636F7079496E666F2E737563636573732C2066756E6374696F6E202829207B0A090909092F2F2074727920';
wwv_flow_imp.g_varchar2_table(615) := '7468652066616C6C6261636B20696E2063617365206077726974655465787460206469646E277420776F726B0A0909090966616C6C6261636B436F707954657874546F436C6970626F61726428636F7079496E666F293B0A0909097D293B0A09097D2065';
wwv_flow_imp.g_varchar2_table(616) := '6C7365207B0A09090966616C6C6261636B436F707954657874546F436C6970626F61726428636F7079496E666F293B0A09097D0A097D0A0A092F2A2A0A09202A2053656C6563747320746865207465787420636F6E74656E74206F662074686520676976';
wwv_flow_imp.g_varchar2_table(617) := '656E20656C656D656E742E0A09202A0A09202A2040706172616D207B456C656D656E747D20656C656D656E740A09202A2F0A0966756E6374696F6E2073656C656374456C656D656E745465787428656C656D656E7429207B0A09092F2F2068747470733A';
wwv_flow_imp.g_varchar2_table(618) := '2F2F737461636B6F766572666C6F772E636F6D2F612F32303037393931302F373539353437320A090977696E646F772E67657453656C656374696F6E28292E73656C656374416C6C4368696C6472656E28656C656D656E74293B0A097D0A0A092F2A2A0A';
wwv_flow_imp.g_varchar2_table(619) := '09202A205472617665727365732075702074686520444F4D207472656520746F2066696E64206461746120617474726962757465732074686174206F76657272696465207468652064656661756C7420706C7567696E2073657474696E67732E0A09202A';
wwv_flow_imp.g_varchar2_table(620) := '0A09202A2040706172616D207B456C656D656E747D207374617274456C656D656E7420416E20656C656D656E7420746F2073746172742066726F6D2E0A09202A204072657475726E73207B53657474696E67737D2054686520706C7567696E2073657474';
wwv_flow_imp.g_varchar2_table(621) := '696E67732E0A09202A204074797065646566207B5265636F72643C22636F707922207C2022636F70792D6572726F7222207C2022636F70792D7375636365737322207C2022636F70792D74696D656F7574222C20737472696E67207C206E756D6265723E';
wwv_flow_imp.g_varchar2_table(622) := '7D2053657474696E67730A09202A2F0A0966756E6374696F6E2067657453657474696E6773287374617274456C656D656E7429207B0A09092F2A2A204074797065207B53657474696E67737D202A2F0A09097661722073657474696E6773203D207B0A09';
wwv_flow_imp.g_varchar2_table(623) := '090927636F7079273A2027436F7079272C0A09090927636F70792D6572726F72273A20275072657373204374726C2B4320746F20636F7079272C0A09090927636F70792D73756363657373273A2027436F7069656421272C0A09090927636F70792D7469';
wwv_flow_imp.g_varchar2_table(624) := '6D656F7574273A20353030300A09097D3B0A0A090976617220707265666978203D2027646174612D707269736D6A732D273B0A0909666F722028766172206B657920696E2073657474696E677329207B0A0909097661722061747472203D207072656669';
wwv_flow_imp.g_varchar2_table(625) := '78202B206B65793B0A09090976617220656C656D656E74203D207374617274456C656D656E743B0A0909097768696C652028656C656D656E742026262021656C656D656E742E68617341747472696275746528617474722929207B0A09090909656C656D';
wwv_flow_imp.g_varchar2_table(626) := '656E74203D20656C656D656E742E706172656E74456C656D656E743B0A0909097D0A09090969662028656C656D656E7429207B0A0909090973657474696E67735B6B65795D203D20656C656D656E742E6765744174747269627574652861747472293B0A';
wwv_flow_imp.g_varchar2_table(627) := '0909097D0A09097D0A090972657475726E2073657474696E67733B0A097D0A0A09507269736D2E706C7567696E732E746F6F6C6261722E7265676973746572427574746F6E2827636F70792D746F2D636C6970626F617264272C2066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(628) := '28656E7629207B0A090976617220656C656D656E74203D20656E762E656C656D656E743B0A0A09097661722073657474696E6773203D2067657453657474696E677328656C656D656E74293B0A0A0909766172206C696E6B436F7079203D20646F63756D';
wwv_flow_imp.g_varchar2_table(629) := '656E742E637265617465456C656D656E742827627574746F6E27293B0A09096C696E6B436F70792E636C6173734E616D65203D2027636F70792D746F2D636C6970626F6172642D627574746F6E273B0A09096C696E6B436F70792E736574417474726962';
wwv_flow_imp.g_varchar2_table(630) := '757465282774797065272C2027627574746F6E27293B0A0909766172206C696E6B5370616E203D20646F63756D656E742E637265617465456C656D656E7428277370616E27293B0A09096C696E6B436F70792E617070656E644368696C64286C696E6B53';
wwv_flow_imp.g_varchar2_table(631) := '70616E293B0A0A090973657453746174652827636F707927293B0A0A09097265676973746572436C6970626F617264286C696E6B436F70792C207B0A090909676574546578743A2066756E6374696F6E202829207B0A0909090972657475726E20656C65';
wwv_flow_imp.g_varchar2_table(632) := '6D656E742E74657874436F6E74656E743B0A0909097D2C0A090909737563636573733A2066756E6374696F6E202829207B0A0909090973657453746174652827636F70792D7375636365737327293B0A0A0909090972657365745465787428293B0A0909';
wwv_flow_imp.g_varchar2_table(633) := '097D2C0A0909096572726F723A2066756E6374696F6E202829207B0A0909090973657453746174652827636F70792D6572726F7227293B0A0A0909090973657454696D656F75742866756E6374696F6E202829207B0A090909090973656C656374456C65';
wwv_flow_imp.g_varchar2_table(634) := '6D656E745465787428656C656D656E74293B0A090909097D2C2031293B0A0A0909090972657365745465787428293B0A0909097D0A09097D293B0A0A090972657475726E206C696E6B436F70793B0A0A090966756E6374696F6E20726573657454657874';
wwv_flow_imp.g_varchar2_table(635) := '2829207B0A09090973657454696D656F75742866756E6374696F6E202829207B2073657453746174652827636F707927293B207D2C2073657474696E67735B27636F70792D74696D656F7574275D293B0A09097D0A0A09092F2A2A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(636) := '22636F707922207C2022636F70792D6572726F7222207C2022636F70792D73756363657373227D207374617465202A2F0A090966756E6374696F6E20736574537461746528737461746529207B0A0909096C696E6B5370616E2E74657874436F6E74656E';
wwv_flow_imp.g_varchar2_table(637) := '74203D2073657474696E67735B73746174655D3B0A0909096C696E6B436F70792E7365744174747269627574652827646174612D636F70792D7374617465272C207374617465293B0A09097D0A097D293B0A7D2829293B0A0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12619103143994029)
,p_file_name=>'lib/prismjs/js/prism.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/lib_prismjs_css_prism_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '636F64655B636C6173732A3D6C616E67756167652D5D2C7072655B636C6173732A3D6C616E67756167652D5D7B636F6C6F723A233030303B6261636B67726F756E643A3020303B746578742D736861646F773A302031707820236666663B666F6E742D66';
wwv_flow_imp.g_varchar2_table(2) := '616D696C793A436F6E736F6C61732C4D6F6E61636F2C27416E64616C65204D6F6E6F272C275562756E7475204D6F6E6F272C6D6F6E6F73706163653B666F6E742D73697A653A31656D3B746578742D616C69676E3A6C6566743B77686974652D73706163';
wwv_flow_imp.g_varchar2_table(3) := '653A7072653B776F72642D73706163696E673A6E6F726D616C3B776F72642D627265616B3A6E6F726D616C3B776F72642D777261703A6E6F726D616C3B6C696E652D6865696768743A312E353B2D6D6F7A2D7461622D73697A653A343B2D6F2D7461622D';
wwv_flow_imp.g_varchar2_table(4) := '73697A653A343B7461622D73697A653A343B2D7765626B69742D68797068656E733A6E6F6E653B2D6D6F7A2D68797068656E733A6E6F6E653B2D6D732D68797068656E733A6E6F6E653B68797068656E733A6E6F6E657D636F64655B636C6173732A3D6C';
wwv_flow_imp.g_varchar2_table(5) := '616E67756167652D5D203A3A2D6D6F7A2D73656C656374696F6E2C636F64655B636C6173732A3D6C616E67756167652D5D3A3A2D6D6F7A2D73656C656374696F6E2C7072655B636C6173732A3D6C616E67756167652D5D203A3A2D6D6F7A2D73656C6563';
wwv_flow_imp.g_varchar2_table(6) := '74696F6E2C7072655B636C6173732A3D6C616E67756167652D5D3A3A2D6D6F7A2D73656C656374696F6E7B746578742D736861646F773A6E6F6E653B6261636B67726F756E643A236233643466637D636F64655B636C6173732A3D6C616E67756167652D';
wwv_flow_imp.g_varchar2_table(7) := '5D203A3A73656C656374696F6E2C636F64655B636C6173732A3D6C616E67756167652D5D3A3A73656C656374696F6E2C7072655B636C6173732A3D6C616E67756167652D5D203A3A73656C656374696F6E2C7072655B636C6173732A3D6C616E67756167';
wwv_flow_imp.g_varchar2_table(8) := '652D5D3A3A73656C656374696F6E7B746578742D736861646F773A6E6F6E653B6261636B67726F756E643A236233643466637D406D65646961207072696E747B636F64655B636C6173732A3D6C616E67756167652D5D2C7072655B636C6173732A3D6C61';
wwv_flow_imp.g_varchar2_table(9) := '6E67756167652D5D7B746578742D736861646F773A6E6F6E657D7D7072655B636C6173732A3D6C616E67756167652D5D7B70616464696E673A31656D3B6D617267696E3A2E35656D20303B6F766572666C6F773A6175746F7D3A6E6F7428707265293E63';
wwv_flow_imp.g_varchar2_table(10) := '6F64655B636C6173732A3D6C616E67756167652D5D2C7072655B636C6173732A3D6C616E67756167652D5D7B6261636B67726F756E643A236635663266307D3A6E6F7428707265293E636F64655B636C6173732A3D6C616E67756167652D5D7B70616464';
wwv_flow_imp.g_varchar2_table(11) := '696E673A2E31656D3B626F726465722D7261646975733A2E33656D3B77686974652D73706163653A6E6F726D616C7D2E746F6B656E2E63646174612C2E746F6B656E2E636F6D6D656E742C2E746F6B656E2E646F63747970652C2E746F6B656E2E70726F';
wwv_flow_imp.g_varchar2_table(12) := '6C6F677B636F6C6F723A233730383039307D2E746F6B656E2E70756E6374756174696F6E7B636F6C6F723A233939397D2E746F6B656E2E6E616D6573706163657B6F7061636974793A2E377D2E746F6B656E2E626F6F6C65616E2C2E746F6B656E2E636F';
wwv_flow_imp.g_varchar2_table(13) := '6E7374616E742C2E746F6B656E2E64656C657465642C2E746F6B656E2E6E756D6265722C2E746F6B656E2E70726F70657274792C2E746F6B656E2E73796D626F6C2C2E746F6B656E2E7461677B636F6C6F723A233930357D2E746F6B656E2E617474722D';
wwv_flow_imp.g_varchar2_table(14) := '6E616D652C2E746F6B656E2E6275696C74696E2C2E746F6B656E2E636861722C2E746F6B656E2E696E7365727465642C2E746F6B656E2E73656C6563746F722C2E746F6B656E2E737472696E677B636F6C6F723A233639307D2E6C616E67756167652D63';
wwv_flow_imp.g_varchar2_table(15) := '7373202E746F6B656E2E737472696E672C2E7374796C65202E746F6B656E2E737472696E672C2E746F6B656E2E656E746974792C2E746F6B656E2E6F70657261746F722C2E746F6B656E2E75726C7B636F6C6F723A233961366533613B6261636B67726F';
wwv_flow_imp.g_varchar2_table(16) := '756E643A72676261283235352C3235352C3235352C2E35297D2E746F6B656E2E617472756C652C2E746F6B656E2E617474722D76616C75652C2E746F6B656E2E6B6579776F72647B636F6C6F723A233037617D2E746F6B656E2E636C6173732D6E616D65';
wwv_flow_imp.g_varchar2_table(17) := '2C2E746F6B656E2E66756E6374696F6E7B636F6C6F723A236464346136387D2E746F6B656E2E696D706F7274616E742C2E746F6B656E2E72656765782C2E746F6B656E2E7661726961626C657B636F6C6F723A236539307D2E746F6B656E2E626F6C642C';
wwv_flow_imp.g_varchar2_table(18) := '2E746F6B656E2E696D706F7274616E747B666F6E742D7765696768743A3730307D2E746F6B656E2E6974616C69637B666F6E742D7374796C653A6974616C69637D2E746F6B656E2E656E746974797B637572736F723A68656C707D7072655B636C617373';
wwv_flow_imp.g_varchar2_table(19) := '2A3D6C616E67756167652D5D2E6C696E652D6E756D626572737B706F736974696F6E3A72656C61746976653B70616464696E672D6C6566743A332E38656D3B636F756E7465722D72657365743A6C696E656E756D6265727D7072655B636C6173732A3D6C';
wwv_flow_imp.g_varchar2_table(20) := '616E67756167652D5D2E6C696E652D6E756D626572733E636F64657B706F736974696F6E3A72656C61746976653B77686974652D73706163653A696E68657269747D2E6C696E652D6E756D62657273202E6C696E652D6E756D626572732D726F77737B70';
wwv_flow_imp.g_varchar2_table(21) := '6F736974696F6E3A6162736F6C7574653B706F696E7465722D6576656E74733A6E6F6E653B746F703A303B666F6E742D73697A653A313030253B6C6566743A2D332E38656D3B77696474683A33656D3B6C65747465722D73706163696E673A2D3170783B';
wwv_flow_imp.g_varchar2_table(22) := '626F726465722D72696768743A31707820736F6C696420233939393B2D7765626B69742D757365722D73656C6563743A6E6F6E653B2D6D6F7A2D757365722D73656C6563743A6E6F6E653B2D6D732D757365722D73656C6563743A6E6F6E653B75736572';
wwv_flow_imp.g_varchar2_table(23) := '2D73656C6563743A6E6F6E657D2E6C696E652D6E756D626572732D726F77733E7370616E7B646973706C61793A626C6F636B3B636F756E7465722D696E6372656D656E743A6C696E656E756D6265727D2E6C696E652D6E756D626572732D726F77733E73';
wwv_flow_imp.g_varchar2_table(24) := '70616E3A6265666F72657B636F6E74656E743A636F756E746572286C696E656E756D626572293B636F6C6F723A233939393B646973706C61793A626C6F636B3B70616464696E672D72696768743A2E38656D3B746578742D616C69676E3A72696768747D';
wwv_flow_imp.g_varchar2_table(25) := '6469762E636F64652D746F6F6C6261727B706F736974696F6E3A72656C61746976657D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261727B706F736974696F6E3A6162736F6C7574653B7A2D696E6465783A31303B746F703A2E33656D3B72';
wwv_flow_imp.g_varchar2_table(26) := '696768743A2E32656D3B7472616E736974696F6E3A6F706163697479202E337320656173652D696E2D6F75743B6F7061636974793A307D6469762E636F64652D746F6F6C6261723A686F7665723E2E746F6F6C6261727B6F7061636974793A317D646976';
wwv_flow_imp.g_varchar2_table(27) := '2E636F64652D746F6F6C6261723A666F6375732D77697468696E3E2E746F6F6C6261727B6F7061636974793A317D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D7B646973706C61793A696E6C696E65';
wwv_flow_imp.g_varchar2_table(28) := '2D626C6F636B7D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E617B637572736F723A706F696E7465727D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D69';
wwv_flow_imp.g_varchar2_table(29) := '74656D3E627574746F6E7B6261636B67726F756E643A3020303B626F726465723A303B666F6E743A696E68657269743B6C696E652D6865696768743A6E6F726D616C3B6F766572666C6F773A76697369626C653B2D7765626B69742D757365722D73656C';
wwv_flow_imp.g_varchar2_table(30) := '6563743A6E6F6E653B2D6D6F7A2D757365722D73656C6563743A6E6F6E653B2D6D732D757365722D73656C6563743A6E6F6E657D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E612C6469762E636F';
wwv_flow_imp.g_varchar2_table(31) := '64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E627574746F6E2C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E7370616E7B636F6C6F723A236262623B666F6E';
wwv_flow_imp.g_varchar2_table(32) := '742D73697A653A2E38656D3B70616464696E673A30202E35656D3B6261636B67726F756E643A236635663266303B6261636B67726F756E643A72676261283232342C3232342C3232342C2E32293B626F782D736861646F773A3020327078203020302072';
wwv_flow_imp.g_varchar2_table(33) := '67626128302C302C302C2E32293B626F726465722D7261646975733A2E35656D7D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E613A666F6375732C6469762E636F64652D746F6F6C6261723E2E74';
wwv_flow_imp.g_varchar2_table(34) := '6F6F6C6261723E2E746F6F6C6261722D6974656D3E613A686F7665722C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E627574746F6E3A666F6375732C6469762E636F64652D746F6F6C6261723E2E';
wwv_flow_imp.g_varchar2_table(35) := '746F6F6C6261723E2E746F6F6C6261722D6974656D3E627574746F6E3A686F7665722C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E7370616E3A666F6375732C6469762E636F64652D746F6F6C62';
wwv_flow_imp.g_varchar2_table(36) := '61723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E7370616E3A686F7665727B636F6C6F723A696E68657269743B746578742D6465636F726174696F6E3A6E6F6E657D0A2F2A2320736F757263654D617070696E6755524C3D707269736D2E';
wwv_flow_imp.g_varchar2_table(37) := '6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12641794840336847)
,p_file_name=>'lib/prismjs/css/prism.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_css_prism_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22707269736D2E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414151412C73422C434143412C71422C434143432C552C434143412C632C434143412C73422C4341';
wwv_flow_imp.g_varchar2_table(2) := '43412C69452C434143412C612C434143412C652C434143412C652C434143412C6D422C434143412C69422C434143412C67422C434143412C652C434145412C652C434143412C612C434143412C552C434145412C6F422C434143412C69422C434143412C';
wwv_flow_imp.g_varchar2_table(3) := '67422C434143412C592C43414979432C75432C43414131432C73432C43414479432C73432C4341417A432C71432C434145432C67422C434143412C6B422C4341496F432C6B432C43414172432C69432C4341446F432C69432C43414170432C67432C4341';
wwv_flow_imp.g_varchar2_table(4) := '45432C67422C434143412C6B422C434147442C614143432C73422C434143412C71422C434143432C6B42414B462C71422C434143432C572C434143412C612C434143412C612C434147442C4B41414B2C32422C4341434C2C71422C434143432C6B422C43';
wwv_flow_imp.g_varchar2_table(5) := '4149442C4B41414B2C32422C4341434A2C592C434143412C6B422C434143412C6B422C43414D442C592C434148412C632C434145412C632C434144412C612C434147432C612C434147442C6B422C434143432C552C434147442C67422C434143432C552C';
wwv_flow_imp.g_varchar2_table(6) := '43414B442C632C434145412C652C434145412C632C434148412C612C434148412C652C43414B412C612C43414A412C552C43414D432C552C434149442C67422C434147412C632C434144412C572C434145412C652C43414C412C652C434145412C612C43';
wwv_flow_imp.g_varchar2_table(7) := '4149432C552C43414D442C32422C434143412C6F422C434148412C612C434144412C652C434145412C552C434147432C612C434145412C2B422C434147442C612C434143412C69422C434143412C632C434143432C552C434149442C69422C434144412C';
wwv_flow_imp.g_varchar2_table(8) := '652C434145432C612C434149442C67422C434144412C592C434145412C652C434143432C552C434149442C572C434144412C67422C434145432C652C434145442C612C434143432C69422C434147442C612C434143432C572C434147442C6B432C434143';
wwv_flow_imp.g_varchar2_table(9) := '432C69422C434143412C6B422C434143412C77422C434147442C75432C434143432C69422C434143412C6D422C434147442C67432C434143432C69422C434143412C6D422C434143412C4B2C434143412C632C434143412C572C434143412C532C434143';
wwv_flow_imp.g_varchar2_table(10) := '412C6D422C434143412C32422C434145412C77422C434143412C71422C434143412C6F422C434143412C67422C434149412C75422C434143432C612C434143412C34422C434147412C38422C434143432C32422C434143412C552C434143412C612C4341';
wwv_flow_imp.g_varchar2_table(11) := '43412C6B422C434143412C67422C434147482C67422C434143432C69422C434147442C79422C434143432C69422C434143412C552C434143412C512C434143412C552C434143412C6B432C434143412C532C434147442C2B422C434143432C532C43414B';
wwv_flow_imp.g_varchar2_table(12) := '442C73432C434143432C532C434147442C75432C434143432C6F422C434147442C79432C434143432C632C434147442C38432C434143432C632C434143412C512C434145412C592C434143412C6B422C434143412C67422C434145412C77422C43414341';
wwv_flow_imp.g_varchar2_table(13) := '2C71422C434143412C6F422C434164442C79432C434149412C38432C434165412C34432C434143432C552C434143412C632C434143412C632C434143412C6B422C434143412C2B422C434143412C6D432C434143412C6B422C434149442C2B432C434144';
wwv_flow_imp.g_varchar2_table(14) := '412C2B432C434147412C6F442C434144412C6F442C434147412C6B442C434144412C6B442C434145432C612C434143412C6F42222C2266696C65223A22707269736D2E637373222C22736F7572636573436F6E74656E74223A5B222F2A20507269736D4A';
wwv_flow_imp.g_varchar2_table(15) := '5320312E32382E305C6E68747470733A2F2F707269736D6A732E636F6D2F646F776E6C6F61642E68746D6C237468656D65733D707269736D266C616E6775616765733D6A736F6E2B6C6F672B706C73716C2B73716C26706C7567696E733D6C696E652D6E';
wwv_flow_imp.g_varchar2_table(16) := '756D626572732B746F6F6C6261722B636F70792D746F2D636C6970626F617264202A2F5C6E2F2A2A5C6E202A20707269736D2E6A732064656661756C74207468656D6520666F72204A6176615363726970742C2043535320616E642048544D4C5C6E202A';
wwv_flow_imp.g_varchar2_table(17) := '204261736564206F6E20646162626C65742028687474703A2F2F646162626C65742E636F6D295C6E202A2040617574686F72204C6561205665726F755C6E202A2F5C6E205C6E636F64655B636C6173732A3D5C226C616E67756167652D5C225D2C5C6E70';
wwv_flow_imp.g_varchar2_table(18) := '72655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C74636F6C6F723A20626C61636B3B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E5C74746578742D736861646F773A2030203170782077686974653B5C6E5C74666F6E';
wwv_flow_imp.g_varchar2_table(19) := '742D66616D696C793A20436F6E736F6C61732C204D6F6E61636F2C2027416E64616C65204D6F6E6F272C20275562756E7475204D6F6E6F272C206D6F6E6F73706163653B5C6E5C74666F6E742D73697A653A2031656D3B5C6E5C74746578742D616C6967';
wwv_flow_imp.g_varchar2_table(20) := '6E3A206C6566743B5C6E5C7477686974652D73706163653A207072653B5C6E5C74776F72642D73706163696E673A206E6F726D616C3B5C6E5C74776F72642D627265616B3A206E6F726D616C3B5C6E5C74776F72642D777261703A206E6F726D616C3B5C';
wwv_flow_imp.g_varchar2_table(21) := '6E5C746C696E652D6865696768743A20312E353B5C6E5C6E5C742D6D6F7A2D7461622D73697A653A20343B5C6E5C742D6F2D7461622D73697A653A20343B5C6E5C747461622D73697A653A20343B5C6E5C6E5C742D7765626B69742D68797068656E733A';
wwv_flow_imp.g_varchar2_table(22) := '206E6F6E653B5C6E5C742D6D6F7A2D68797068656E733A206E6F6E653B5C6E5C742D6D732D68797068656E733A206E6F6E653B5C6E5C7468797068656E733A206E6F6E653B5C6E7D5C6E5C6E7072655B636C6173732A3D5C226C616E67756167652D5C22';
wwv_flow_imp.g_varchar2_table(23) := '5D3A3A2D6D6F7A2D73656C656374696F6E2C207072655B636C6173732A3D5C226C616E67756167652D5C225D203A3A2D6D6F7A2D73656C656374696F6E2C5C6E636F64655B636C6173732A3D5C226C616E67756167652D5C225D3A3A2D6D6F7A2D73656C';
wwv_flow_imp.g_varchar2_table(24) := '656374696F6E2C20636F64655B636C6173732A3D5C226C616E67756167652D5C225D203A3A2D6D6F7A2D73656C656374696F6E207B5C6E5C74746578742D736861646F773A206E6F6E653B5C6E5C746261636B67726F756E643A20236233643466633B5C';
wwv_flow_imp.g_varchar2_table(25) := '6E7D5C6E5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D3A3A73656C656374696F6E2C207072655B636C6173732A3D5C226C616E67756167652D5C225D203A3A73656C656374696F6E2C5C6E636F64655B636C6173732A3D5C226C61';
wwv_flow_imp.g_varchar2_table(26) := '6E67756167652D5C225D3A3A73656C656374696F6E2C20636F64655B636C6173732A3D5C226C616E67756167652D5C225D203A3A73656C656374696F6E207B5C6E5C74746578742D736861646F773A206E6F6E653B5C6E5C746261636B67726F756E643A';
wwv_flow_imp.g_varchar2_table(27) := '20236233643466633B5C6E7D5C6E5C6E406D65646961207072696E74207B5C6E5C74636F64655B636C6173732A3D5C226C616E67756167652D5C225D2C5C6E5C747072655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C745C747465';
wwv_flow_imp.g_varchar2_table(28) := '78742D736861646F773A206E6F6E653B5C6E5C747D5C6E7D5C6E5C6E2F2A20436F646520626C6F636B73202A2F5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C7470616464696E673A2031656D3B5C6E5C746D61726769';
wwv_flow_imp.g_varchar2_table(29) := '6E3A202E35656D20303B5C6E5C746F766572666C6F773A206175746F3B5C6E7D5C6E5C6E3A6E6F742870726529203E20636F64655B636C6173732A3D5C226C616E67756167652D5C225D2C5C6E7072655B636C6173732A3D5C226C616E67756167652D5C';
wwv_flow_imp.g_varchar2_table(30) := '225D207B5C6E5C746261636B67726F756E643A20236635663266303B5C6E7D5C6E5C6E2F2A20496E6C696E6520636F6465202A2F5C6E3A6E6F742870726529203E20636F64655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C747061';
wwv_flow_imp.g_varchar2_table(31) := '6464696E673A202E31656D3B5C6E5C74626F726465722D7261646975733A202E33656D3B5C6E5C7477686974652D73706163653A206E6F726D616C3B5C6E7D5C6E5C6E2E746F6B656E2E636F6D6D656E742C5C6E2E746F6B656E2E70726F6C6F672C5C6E';
wwv_flow_imp.g_varchar2_table(32) := '2E746F6B656E2E646F63747970652C5C6E2E746F6B656E2E6364617461207B5C6E5C74636F6C6F723A20736C617465677261793B5C6E7D5C6E5C6E2E746F6B656E2E70756E6374756174696F6E207B5C6E5C74636F6C6F723A20233939393B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(33) := '5C6E2E746F6B656E2E6E616D657370616365207B5C6E5C746F7061636974793A202E373B5C6E7D5C6E5C6E2E746F6B656E2E70726F70657274792C5C6E2E746F6B656E2E7461672C5C6E2E746F6B656E2E626F6F6C65616E2C5C6E2E746F6B656E2E6E75';
wwv_flow_imp.g_varchar2_table(34) := '6D6265722C5C6E2E746F6B656E2E636F6E7374616E742C5C6E2E746F6B656E2E73796D626F6C2C5C6E2E746F6B656E2E64656C65746564207B5C6E5C74636F6C6F723A20233930353B5C6E7D5C6E5C6E2E746F6B656E2E73656C6563746F722C5C6E2E74';
wwv_flow_imp.g_varchar2_table(35) := '6F6B656E2E617474722D6E616D652C5C6E2E746F6B656E2E737472696E672C5C6E2E746F6B656E2E636861722C5C6E2E746F6B656E2E6275696C74696E2C5C6E2E746F6B656E2E696E736572746564207B5C6E5C74636F6C6F723A20233639303B5C6E7D';
wwv_flow_imp.g_varchar2_table(36) := '5C6E5C6E2E746F6B656E2E6F70657261746F722C5C6E2E746F6B656E2E656E746974792C5C6E2E746F6B656E2E75726C2C5C6E2E6C616E67756167652D637373202E746F6B656E2E737472696E672C5C6E2E7374796C65202E746F6B656E2E737472696E';
wwv_flow_imp.g_varchar2_table(37) := '67207B5C6E5C74636F6C6F723A20233961366533613B5C6E5C742F2A2054686973206261636B67726F756E6420636F6C6F722077617320696E74656E6465642062792074686520617574686F72206F662074686973207468656D652E202A2F5C6E5C7462';
wwv_flow_imp.g_varchar2_table(38) := '61636B67726F756E643A2068736C6128302C2030252C20313030252C202E35293B5C6E7D5C6E5C6E2E746F6B656E2E617472756C652C5C6E2E746F6B656E2E617474722D76616C75652C5C6E2E746F6B656E2E6B6579776F7264207B5C6E5C74636F6C6F';
wwv_flow_imp.g_varchar2_table(39) := '723A20233037613B5C6E7D5C6E5C6E2E746F6B656E2E66756E6374696F6E2C5C6E2E746F6B656E2E636C6173732D6E616D65207B5C6E5C74636F6C6F723A20234444344136383B5C6E7D5C6E5C6E2E746F6B656E2E72656765782C5C6E2E746F6B656E2E';
wwv_flow_imp.g_varchar2_table(40) := '696D706F7274616E742C5C6E2E746F6B656E2E7661726961626C65207B5C6E5C74636F6C6F723A20236539303B5C6E7D5C6E5C6E2E746F6B656E2E696D706F7274616E742C5C6E2E746F6B656E2E626F6C64207B5C6E5C74666F6E742D7765696768743A';
wwv_flow_imp.g_varchar2_table(41) := '20626F6C643B5C6E7D5C6E2E746F6B656E2E6974616C6963207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E7D5C6E5C6E2E746F6B656E2E656E74697479207B5C6E5C74637572736F723A2068656C703B5C6E7D5C6E5C6E7072655B63';
wwv_flow_imp.g_varchar2_table(42) := '6C6173732A3D5C226C616E67756167652D5C225D2E6C696E652D6E756D62657273207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C7470616464696E672D6C6566743A20332E38656D3B5C6E5C74636F756E7465722D72657365743A';
wwv_flow_imp.g_varchar2_table(43) := '206C696E656E756D6265723B5C6E7D5C6E5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D2E6C696E652D6E756D62657273203E20636F6465207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C7477686974652D73';
wwv_flow_imp.g_varchar2_table(44) := '706163653A20696E68657269743B5C6E7D5C6E5C6E2E6C696E652D6E756D62657273202E6C696E652D6E756D626572732D726F7773207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74706F696E7465722D6576656E74733A206E6F';
wwv_flow_imp.g_varchar2_table(45) := '6E653B5C6E5C74746F703A20303B5C6E5C74666F6E742D73697A653A20313030253B5C6E5C746C6566743A202D332E38656D3B5C6E5C7477696474683A2033656D3B202F2A20776F726B7320666F72206C696E652D6E756D626572732062656C6F772031';
wwv_flow_imp.g_varchar2_table(46) := '303030206C696E6573202A2F5C6E5C746C65747465722D73706163696E673A202D3170783B5C6E5C74626F726465722D72696768743A2031707820736F6C696420233939393B5C6E5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E';
wwv_flow_imp.g_varchar2_table(47) := '653B5C6E5C742D6D6F7A2D757365722D73656C6563743A206E6F6E653B5C6E5C742D6D732D757365722D73656C6563743A206E6F6E653B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C6E7D5C6E5C6E5C742E6C696E652D6E756D626572';
wwv_flow_imp.g_varchar2_table(48) := '732D726F7773203E207370616E207B5C6E5C745C74646973706C61793A20626C6F636B3B5C6E5C745C74636F756E7465722D696E6372656D656E743A206C696E656E756D6265723B5C6E5C747D5C6E5C6E5C745C742E6C696E652D6E756D626572732D72';
wwv_flow_imp.g_varchar2_table(49) := '6F7773203E207370616E3A6265666F7265207B5C6E5C745C745C74636F6E74656E743A20636F756E746572286C696E656E756D626572293B5C6E5C745C745C74636F6C6F723A20233939393B5C6E5C745C745C74646973706C61793A20626C6F636B3B5C';
wwv_flow_imp.g_varchar2_table(50) := '6E5C745C745C7470616464696E672D72696768743A20302E38656D3B5C6E5C745C745C74746578742D616C69676E3A2072696768743B5C6E5C745C747D5C6E5C6E6469762E636F64652D746F6F6C626172207B5C6E5C74706F736974696F6E3A2072656C';
wwv_flow_imp.g_varchar2_table(51) := '61746976653B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747A2D696E6465783A2031303B5C6E5C74746F703A202E33656D3B5C6E5C7472';
wwv_flow_imp.g_varchar2_table(52) := '696768743A202E32656D3B5C6E5C747472616E736974696F6E3A206F70616369747920302E337320656173652D696E2D6F75743B5C6E5C746F7061636974793A20303B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C6261723A686F766572203E202E';
wwv_flow_imp.g_varchar2_table(53) := '746F6F6C626172207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2F2A205365706172617465206C696E6520622F632072756C657320617265207468726F776E206F75742069662073656C6563746F7220697320696E76616C69642E5C6E2020';
wwv_flow_imp.g_varchar2_table(54) := '204945313120616E64206F6C6420456467652076657273696F6E7320646F6E277420737570706F7274203A666F6375732D77697468696E2E202A2F5C6E6469762E636F64652D746F6F6C6261723A666F6375732D77697468696E203E202E746F6F6C6261';
wwv_flow_imp.g_varchar2_table(55) := '72207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(56) := '6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E2061207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E74';
wwv_flow_imp.g_varchar2_table(57) := '6F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E207B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E5C74626F726465723A20303B5C6E5C74636F6C6F723A20696E68657269743B5C6E5C74666F6E743A20696E68';
wwv_flow_imp.g_varchar2_table(58) := '657269743B5C6E5C746C696E652D6865696768743A206E6F726D616C3B5C6E5C746F766572666C6F773A2076697369626C653B5C6E5C7470616464696E673A20303B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B202F2A20';
wwv_flow_imp.g_varchar2_table(59) := '666F7220627574746F6E202A2F5C6E5C742D6D6F7A2D757365722D73656C6563743A206E6F6E653B5C6E5C742D6D732D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172';
wwv_flow_imp.g_varchar2_table(60) := '203E202E746F6F6C6261722D6974656D203E20612C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E2C5C6E6469762E636F64652D746F6F6C626172203E202E746F';
wwv_flow_imp.g_varchar2_table(61) := '6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E207B5C6E5C74636F6C6F723A20236262623B5C6E5C74666F6E742D73697A653A202E38656D3B5C6E5C7470616464696E673A2030202E35656D3B5C6E5C746261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(62) := '3A20236635663266303B5C6E5C746261636B67726F756E643A2072676261283232342C203232342C203232342C20302E32293B5C6E5C74626F782D736861646F773A20302032707820302030207267626128302C302C302C302E32293B5C6E5C74626F72';
wwv_flow_imp.g_varchar2_table(63) := '6465722D7261646975733A202E35656D3B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A686F7665722C5C6E6469762E636F64652D746F6F6C626172203E202E';
wwv_flow_imp.g_varchar2_table(64) := '746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A666F6375732C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E3A686F7665722C5C6E646976';
wwv_flow_imp.g_varchar2_table(65) := '2E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E3A666F6375732C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D697465';
wwv_flow_imp.g_varchar2_table(66) := '6D203E207370616E3A686F7665722C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E3A666F637573207B5C6E5C74636F6C6F723A20696E68657269743B5C6E5C747465';
wwv_flow_imp.g_varchar2_table(67) := '78742D6465636F726174696F6E3A206E6F6E653B5C6E7D5C6E5C6E225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12642011694336848)
,p_file_name=>'lib/prismjs/css/prism.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_css_prism_dark_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '636F64655B636C6173732A3D6C616E67756167652D5D2C7072655B636C6173732A3D6C616E67756167652D5D7B636F6C6F723A236638663866323B6261636B67726F756E643A3020303B746578742D736861646F773A3020317078207267626128302C30';
wwv_flow_imp.g_varchar2_table(2) := '2C302C2E33293B666F6E742D66616D696C793A436F6E736F6C61732C4D6F6E61636F2C27416E64616C65204D6F6E6F272C275562756E7475204D6F6E6F272C6D6F6E6F73706163653B666F6E742D73697A653A31656D3B746578742D616C69676E3A6C65';
wwv_flow_imp.g_varchar2_table(3) := '66743B77686974652D73706163653A7072653B776F72642D73706163696E673A6E6F726D616C3B776F72642D627265616B3A6E6F726D616C3B776F72642D777261703A6E6F726D616C3B6C696E652D6865696768743A312E353B2D6D6F7A2D7461622D73';
wwv_flow_imp.g_varchar2_table(4) := '697A653A343B2D6F2D7461622D73697A653A343B7461622D73697A653A343B2D7765626B69742D68797068656E733A6E6F6E653B2D6D6F7A2D68797068656E733A6E6F6E653B2D6D732D68797068656E733A6E6F6E653B68797068656E733A6E6F6E657D';
wwv_flow_imp.g_varchar2_table(5) := '7072655B636C6173732A3D6C616E67756167652D5D7B70616464696E673A31656D3B6D617267696E3A2E35656D20303B6F766572666C6F773A6175746F3B626F726465722D7261646975733A2E33656D7D3A6E6F7428707265293E636F64655B636C6173';
wwv_flow_imp.g_varchar2_table(6) := '732A3D6C616E67756167652D5D2C7072655B636C6173732A3D6C616E67756167652D5D7B6261636B67726F756E643A233237323832327D3A6E6F7428707265293E636F64655B636C6173732A3D6C616E67756167652D5D7B70616464696E673A2E31656D';
wwv_flow_imp.g_varchar2_table(7) := '3B626F726465722D7261646975733A2E33656D3B77686974652D73706163653A6E6F726D616C7D2E746F6B656E2E63646174612C2E746F6B656E2E636F6D6D656E742C2E746F6B656E2E646F63747970652C2E746F6B656E2E70726F6C6F677B636F6C6F';
wwv_flow_imp.g_varchar2_table(8) := '723A233832393261327D2E746F6B656E2E70756E6374756174696F6E7B636F6C6F723A236638663866327D2E746F6B656E2E6E616D6573706163657B6F7061636974793A2E377D2E746F6B656E2E636F6E7374616E742C2E746F6B656E2E64656C657465';
wwv_flow_imp.g_varchar2_table(9) := '642C2E746F6B656E2E70726F70657274792C2E746F6B656E2E73796D626F6C2C2E746F6B656E2E7461677B636F6C6F723A236639323637327D2E746F6B656E2E626F6F6C65616E2C2E746F6B656E2E6E756D6265727B636F6C6F723A236165383166667D';
wwv_flow_imp.g_varchar2_table(10) := '2E746F6B656E2E617474722D6E616D652C2E746F6B656E2E6275696C74696E2C2E746F6B656E2E636861722C2E746F6B656E2E696E7365727465642C2E746F6B656E2E73656C6563746F722C2E746F6B656E2E737472696E677B636F6C6F723A23613665';
wwv_flow_imp.g_varchar2_table(11) := '3232657D2E6C616E67756167652D637373202E746F6B656E2E737472696E672C2E7374796C65202E746F6B656E2E737472696E672C2E746F6B656E2E656E746974792C2E746F6B656E2E6F70657261746F722C2E746F6B656E2E75726C2C2E746F6B656E';
wwv_flow_imp.g_varchar2_table(12) := '2E7661726961626C657B636F6C6F723A236638663866327D2E746F6B656E2E617472756C652C2E746F6B656E2E617474722D76616C75652C2E746F6B656E2E636C6173732D6E616D652C2E746F6B656E2E66756E6374696F6E7B636F6C6F723A23653664';
wwv_flow_imp.g_varchar2_table(13) := '6237347D2E746F6B656E2E6B6579776F72647B636F6C6F723A233636643965667D2E746F6B656E2E696D706F7274616E742C2E746F6B656E2E72656765787B636F6C6F723A236664393731667D2E746F6B656E2E626F6C642C2E746F6B656E2E696D706F';
wwv_flow_imp.g_varchar2_table(14) := '7274616E747B666F6E742D7765696768743A3730307D2E746F6B656E2E6974616C69637B666F6E742D7374796C653A6974616C69637D2E746F6B656E2E656E746974797B637572736F723A68656C707D7072655B636C6173732A3D6C616E67756167652D';
wwv_flow_imp.g_varchar2_table(15) := '5D2E6C696E652D6E756D626572737B706F736974696F6E3A72656C61746976653B70616464696E672D6C6566743A332E38656D3B636F756E7465722D72657365743A6C696E656E756D6265727D7072655B636C6173732A3D6C616E67756167652D5D2E6C';
wwv_flow_imp.g_varchar2_table(16) := '696E652D6E756D626572733E636F64657B706F736974696F6E3A72656C61746976653B77686974652D73706163653A696E68657269747D2E6C696E652D6E756D62657273202E6C696E652D6E756D626572732D726F77737B706F736974696F6E3A616273';
wwv_flow_imp.g_varchar2_table(17) := '6F6C7574653B706F696E7465722D6576656E74733A6E6F6E653B746F703A303B666F6E742D73697A653A313030253B6C6566743A2D332E38656D3B77696474683A33656D3B6C65747465722D73706163696E673A2D3170783B626F726465722D72696768';
wwv_flow_imp.g_varchar2_table(18) := '743A31707820736F6C696420233939393B2D7765626B69742D757365722D73656C6563743A6E6F6E653B2D6D6F7A2D757365722D73656C6563743A6E6F6E653B2D6D732D757365722D73656C6563743A6E6F6E653B757365722D73656C6563743A6E6F6E';
wwv_flow_imp.g_varchar2_table(19) := '657D2E6C696E652D6E756D626572732D726F77733E7370616E7B646973706C61793A626C6F636B3B636F756E7465722D696E6372656D656E743A6C696E656E756D6265727D2E6C696E652D6E756D626572732D726F77733E7370616E3A6265666F72657B';
wwv_flow_imp.g_varchar2_table(20) := '636F6E74656E743A636F756E746572286C696E656E756D626572293B636F6C6F723A233939393B646973706C61793A626C6F636B3B70616464696E672D72696768743A2E38656D3B746578742D616C69676E3A72696768747D6469762E636F64652D746F';
wwv_flow_imp.g_varchar2_table(21) := '6F6C6261727B706F736974696F6E3A72656C61746976657D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261727B706F736974696F6E3A6162736F6C7574653B7A2D696E6465783A31303B746F703A2E33656D3B72696768743A2E32656D3B74';
wwv_flow_imp.g_varchar2_table(22) := '72616E736974696F6E3A6F706163697479202E337320656173652D696E2D6F75743B6F7061636974793A307D6469762E636F64652D746F6F6C6261723A686F7665723E2E746F6F6C6261727B6F7061636974793A317D6469762E636F64652D746F6F6C62';
wwv_flow_imp.g_varchar2_table(23) := '61723A666F6375732D77697468696E3E2E746F6F6C6261727B6F7061636974793A317D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D7B646973706C61793A696E6C696E652D626C6F636B7D6469762E';
wwv_flow_imp.g_varchar2_table(24) := '636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E617B637572736F723A706F696E7465727D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E627574746F6E7B';
wwv_flow_imp.g_varchar2_table(25) := '6261636B67726F756E643A3020303B626F726465723A303B666F6E743A696E68657269743B6C696E652D6865696768743A6E6F726D616C3B6F766572666C6F773A76697369626C653B2D7765626B69742D757365722D73656C6563743A6E6F6E653B2D6D';
wwv_flow_imp.g_varchar2_table(26) := '6F7A2D757365722D73656C6563743A6E6F6E653B2D6D732D757365722D73656C6563743A6E6F6E657D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E612C6469762E636F64652D746F6F6C6261723E';
wwv_flow_imp.g_varchar2_table(27) := '2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E627574746F6E2C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E7370616E7B636F6C6F723A236262623B666F6E742D73697A653A2E38656D';
wwv_flow_imp.g_varchar2_table(28) := '3B70616464696E673A30202E35656D3B6261636B67726F756E643A236635663266303B6261636B67726F756E643A72676261283232342C3232342C3232342C2E32293B626F782D736861646F773A302032707820302030207267626128302C302C302C2E';
wwv_flow_imp.g_varchar2_table(29) := '32293B626F726465722D7261646975733A2E35656D7D6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E613A666F6375732C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F';
wwv_flow_imp.g_varchar2_table(30) := '6C6261722D6974656D3E613A686F7665722C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E627574746F6E3A666F6375732C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F';
wwv_flow_imp.g_varchar2_table(31) := '6F6C6261722D6974656D3E627574746F6E3A686F7665722C6469762E636F64652D746F6F6C6261723E2E746F6F6C6261723E2E746F6F6C6261722D6974656D3E7370616E3A666F6375732C6469762E636F64652D746F6F6C6261723E2E746F6F6C626172';
wwv_flow_imp.g_varchar2_table(32) := '3E2E746F6F6C6261722D6974656D3E7370616E3A686F7665727B636F6C6F723A696E68657269743B746578742D6465636F726174696F6E3A6E6F6E657D0A2F2A2320736F757263654D617070696E6755524C3D707269736D2E6461726B2E6373732E6D61';
wwv_flow_imp.g_varchar2_table(33) := '702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12643522207338745)
,p_file_name=>'lib/prismjs/css/prism.dark.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_css_prism_dark_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22707269736D2E6461726B2E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414151412C73422C434143412C71422C434143432C612C434143412C632C434143412C';
wwv_flow_imp.g_varchar2_table(2) := '67432C434143412C69452C434143412C612C434143412C652C434143412C652C434143412C6D422C434143412C69422C434143412C67422C434143412C652C434145412C652C434143412C612C434143412C552C434145412C6F422C434143412C69422C';
wwv_flow_imp.g_varchar2_table(3) := '434143412C67422C434143412C592C434149442C71422C434143432C572C434143412C612C434143412C612C434143412C6B422C434147442C4B41414B2C32422C4341434C2C71422C434143432C6B422C434149442C4B41414B2C32422C4341434A2C59';
wwv_flow_imp.g_varchar2_table(4) := '2C434143412C6B422C434143412C6B422C43414D442C592C434148412C632C434145412C632C434144412C612C434147432C612C434147442C6B422C434143432C612C434147442C67422C434143432C552C43414B442C652C434145412C632C43414A41';
wwv_flow_imp.g_varchar2_table(5) := '2C652C434147412C612C434146412C552C434149432C612C434147442C632C434143412C612C434143432C612C434149442C67422C434147412C632C434144412C572C434145412C652C43414C412C652C434145412C612C434149432C612C43414D442C';
wwv_flow_imp.g_varchar2_table(6) := '32422C434143412C6F422C434148412C612C434144412C652C434145412C552C434147412C652C434143432C612C434147442C612C434143412C69422C434145412C69422C434144412C652C434145432C612C434147442C632C434143432C612C434149';
wwv_flow_imp.g_varchar2_table(7) := '442C67422C434144412C592C434145432C612C434149442C572C434144412C67422C434145432C652C434145442C612C434143432C69422C434147442C612C434143432C572C434147442C6B432C434143432C69422C434143412C6B422C434143412C77';
wwv_flow_imp.g_varchar2_table(8) := '422C434147442C75432C434143432C69422C434143412C6D422C434147442C67432C434143432C69422C434143412C6D422C434143412C4B2C434143412C632C434143412C572C434143412C532C434143412C6D422C434143412C32422C434145412C77';
wwv_flow_imp.g_varchar2_table(9) := '422C434143412C71422C434143412C6F422C434143412C67422C434149412C75422C434143432C612C434143412C34422C434147412C38422C434143432C32422C434143412C552C434143412C612C434143412C6B422C434143412C67422C434147482C';
wwv_flow_imp.g_varchar2_table(10) := '67422C434143432C69422C434147442C79422C434143432C69422C434143412C552C434143412C512C434143412C552C434143412C6B432C434143412C532C434147442C2B422C434143432C532C43414B442C73432C434143432C532C434147442C7543';
wwv_flow_imp.g_varchar2_table(11) := '2C434143432C6F422C434147442C79432C434143432C632C434147442C38432C434143432C632C434143412C512C434145412C592C434143412C6B422C434143412C67422C434145412C77422C434143412C71422C434143412C6F422C434164442C7943';
wwv_flow_imp.g_varchar2_table(12) := '2C434149412C38432C434165412C34432C434143432C552C434143412C632C434143412C632C434143412C6B422C434143412C2B422C434143412C6D432C434143412C6B422C434149442C2B432C434144412C2B432C434147412C6F442C434144412C6F';
wwv_flow_imp.g_varchar2_table(13) := '442C434147412C6B442C434144412C6B442C434145432C612C434143412C6F42222C2266696C65223A22707269736D2E6461726B2E637373222C22736F7572636573436F6E74656E74223A5B222F2A20507269736D4A5320312E32382E305C6E68747470';
wwv_flow_imp.g_varchar2_table(14) := '733A2F2F707269736D6A732E636F6D2F646F776E6C6F61642E68746D6C237468656D65733D707269736D2D6F6B6169646961266C616E6775616765733D6A736F6E2B6C6F672B706C73716C2B73716C26706C7567696E733D6C696E652D6E756D62657273';
wwv_flow_imp.g_varchar2_table(15) := '2B746F6F6C6261722B636F70792D746F2D636C6970626F617264202A2F5C6E2F2A2A5C6E202A206F6B6169646961207468656D6520666F72204A6176615363726970742C2043535320616E642048544D4C5C6E202A204C6F6F73656C7920626173656420';
wwv_flow_imp.g_varchar2_table(16) := '6F6E204D6F6E6F6B616920746578746D617465207468656D6520627920687474703A2F2F7777772E6D6F6E6F6B61692E6E6C2F5C6E202A2040617574686F72206F636F6469615C6E202A2F5C6E5C6E636F64655B636C6173732A3D5C226C616E67756167';
wwv_flow_imp.g_varchar2_table(17) := '652D5C225D2C5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C74636F6C6F723A20236638663866323B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E5C74746578742D736861646F773A203020317078207267';
wwv_flow_imp.g_varchar2_table(18) := '626128302C20302C20302C20302E33293B5C6E5C74666F6E742D66616D696C793A20436F6E736F6C61732C204D6F6E61636F2C2027416E64616C65204D6F6E6F272C20275562756E7475204D6F6E6F272C206D6F6E6F73706163653B5C6E5C74666F6E74';
wwv_flow_imp.g_varchar2_table(19) := '2D73697A653A2031656D3B5C6E5C74746578742D616C69676E3A206C6566743B5C6E5C7477686974652D73706163653A207072653B5C6E5C74776F72642D73706163696E673A206E6F726D616C3B5C6E5C74776F72642D627265616B3A206E6F726D616C';
wwv_flow_imp.g_varchar2_table(20) := '3B5C6E5C74776F72642D777261703A206E6F726D616C3B5C6E5C746C696E652D6865696768743A20312E353B5C6E5C6E5C742D6D6F7A2D7461622D73697A653A20343B5C6E5C742D6F2D7461622D73697A653A20343B5C6E5C747461622D73697A653A20';
wwv_flow_imp.g_varchar2_table(21) := '343B5C6E5C6E5C742D7765626B69742D68797068656E733A206E6F6E653B5C6E5C742D6D6F7A2D68797068656E733A206E6F6E653B5C6E5C742D6D732D68797068656E733A206E6F6E653B5C6E5C7468797068656E733A206E6F6E653B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(22) := '2F2A20436F646520626C6F636B73202A2F5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C7470616464696E673A2031656D3B5C6E5C746D617267696E3A202E35656D20303B5C6E5C746F766572666C6F773A206175746F';
wwv_flow_imp.g_varchar2_table(23) := '3B5C6E5C74626F726465722D7261646975733A20302E33656D3B5C6E7D5C6E5C6E3A6E6F742870726529203E20636F64655B636C6173732A3D5C226C616E67756167652D5C225D2C5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D20';
wwv_flow_imp.g_varchar2_table(24) := '7B5C6E5C746261636B67726F756E643A20233237323832323B5C6E7D5C6E5C6E2F2A20496E6C696E6520636F6465202A2F5C6E3A6E6F742870726529203E20636F64655B636C6173732A3D5C226C616E67756167652D5C225D207B5C6E5C747061646469';
wwv_flow_imp.g_varchar2_table(25) := '6E673A202E31656D3B5C6E5C74626F726465722D7261646975733A202E33656D3B5C6E5C7477686974652D73706163653A206E6F726D616C3B5C6E7D5C6E5C6E2E746F6B656E2E636F6D6D656E742C5C6E2E746F6B656E2E70726F6C6F672C5C6E2E746F';
wwv_flow_imp.g_varchar2_table(26) := '6B656E2E646F63747970652C5C6E2E746F6B656E2E6364617461207B5C6E5C74636F6C6F723A20233832393261323B5C6E7D5C6E5C6E2E746F6B656E2E70756E6374756174696F6E207B5C6E5C74636F6C6F723A20236638663866323B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(27) := '2E746F6B656E2E6E616D657370616365207B5C6E5C746F7061636974793A202E373B5C6E7D5C6E5C6E2E746F6B656E2E70726F70657274792C5C6E2E746F6B656E2E7461672C5C6E2E746F6B656E2E636F6E7374616E742C5C6E2E746F6B656E2E73796D';
wwv_flow_imp.g_varchar2_table(28) := '626F6C2C5C6E2E746F6B656E2E64656C65746564207B5C6E5C74636F6C6F723A20236639323637323B5C6E7D5C6E5C6E2E746F6B656E2E626F6F6C65616E2C5C6E2E746F6B656E2E6E756D626572207B5C6E5C74636F6C6F723A20236165383166663B5C';
wwv_flow_imp.g_varchar2_table(29) := '6E7D5C6E5C6E2E746F6B656E2E73656C6563746F722C5C6E2E746F6B656E2E617474722D6E616D652C5C6E2E746F6B656E2E737472696E672C5C6E2E746F6B656E2E636861722C5C6E2E746F6B656E2E6275696C74696E2C5C6E2E746F6B656E2E696E73';
wwv_flow_imp.g_varchar2_table(30) := '6572746564207B5C6E5C74636F6C6F723A20236136653232653B5C6E7D5C6E5C6E2E746F6B656E2E6F70657261746F722C5C6E2E746F6B656E2E656E746974792C5C6E2E746F6B656E2E75726C2C5C6E2E6C616E67756167652D637373202E746F6B656E';
wwv_flow_imp.g_varchar2_table(31) := '2E737472696E672C5C6E2E7374796C65202E746F6B656E2E737472696E672C5C6E2E746F6B656E2E7661726961626C65207B5C6E5C74636F6C6F723A20236638663866323B5C6E7D5C6E5C6E2E746F6B656E2E617472756C652C5C6E2E746F6B656E2E61';
wwv_flow_imp.g_varchar2_table(32) := '7474722D76616C75652C5C6E2E746F6B656E2E66756E6374696F6E2C5C6E2E746F6B656E2E636C6173732D6E616D65207B5C6E5C74636F6C6F723A20236536646237343B5C6E7D5C6E5C6E2E746F6B656E2E6B6579776F7264207B5C6E5C74636F6C6F72';
wwv_flow_imp.g_varchar2_table(33) := '3A20233636643965663B5C6E7D5C6E5C6E2E746F6B656E2E72656765782C5C6E2E746F6B656E2E696D706F7274616E74207B5C6E5C74636F6C6F723A20236664393731663B5C6E7D5C6E5C6E2E746F6B656E2E696D706F7274616E742C5C6E2E746F6B65';
wwv_flow_imp.g_varchar2_table(34) := '6E2E626F6C64207B5C6E5C74666F6E742D7765696768743A20626F6C643B5C6E7D5C6E2E746F6B656E2E6974616C6963207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E7D5C6E5C6E2E746F6B656E2E656E74697479207B5C6E5C7463';
wwv_flow_imp.g_varchar2_table(35) := '7572736F723A2068656C703B5C6E7D5C6E5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D2E6C696E652D6E756D62657273207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C7470616464696E672D6C6566743A20';
wwv_flow_imp.g_varchar2_table(36) := '332E38656D3B5C6E5C74636F756E7465722D72657365743A206C696E656E756D6265723B5C6E7D5C6E5C6E7072655B636C6173732A3D5C226C616E67756167652D5C225D2E6C696E652D6E756D62657273203E20636F6465207B5C6E5C74706F73697469';
wwv_flow_imp.g_varchar2_table(37) := '6F6E3A2072656C61746976653B5C6E5C7477686974652D73706163653A20696E68657269743B5C6E7D5C6E5C6E2E6C696E652D6E756D62657273202E6C696E652D6E756D626572732D726F7773207B5C6E5C74706F736974696F6E3A206162736F6C7574';
wwv_flow_imp.g_varchar2_table(38) := '653B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E5C74746F703A20303B5C6E5C74666F6E742D73697A653A20313030253B5C6E5C746C6566743A202D332E38656D3B5C6E5C7477696474683A2033656D3B202F2A20776F726B7320';
wwv_flow_imp.g_varchar2_table(39) := '666F72206C696E652D6E756D626572732062656C6F772031303030206C696E6573202A2F5C6E5C746C65747465722D73706163696E673A202D3170783B5C6E5C74626F726465722D72696768743A2031707820736F6C696420233939393B5C6E5C6E5C74';
wwv_flow_imp.g_varchar2_table(40) := '2D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E5C742D6D6F7A2D757365722D73656C6563743A206E6F6E653B5C6E5C742D6D732D757365722D73656C6563743A206E6F6E653B5C6E5C74757365722D73656C6563743A206E6F6E65';
wwv_flow_imp.g_varchar2_table(41) := '3B5C6E5C6E7D5C6E5C6E5C742E6C696E652D6E756D626572732D726F7773203E207370616E207B5C6E5C745C74646973706C61793A20626C6F636B3B5C6E5C745C74636F756E7465722D696E6372656D656E743A206C696E656E756D6265723B5C6E5C74';
wwv_flow_imp.g_varchar2_table(42) := '7D5C6E5C6E5C745C742E6C696E652D6E756D626572732D726F7773203E207370616E3A6265666F7265207B5C6E5C745C745C74636F6E74656E743A20636F756E746572286C696E656E756D626572293B5C6E5C745C745C74636F6C6F723A20233939393B';
wwv_flow_imp.g_varchar2_table(43) := '5C6E5C745C745C74646973706C61793A20626C6F636B3B5C6E5C745C745C7470616464696E672D72696768743A20302E38656D3B5C6E5C745C745C74746578742D616C69676E3A2072696768743B5C6E5C745C747D5C6E5C6E6469762E636F64652D746F';
wwv_flow_imp.g_varchar2_table(44) := '6F6C626172207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747A2D696E646578';
wwv_flow_imp.g_varchar2_table(45) := '3A2031303B5C6E5C74746F703A202E33656D3B5C6E5C7472696768743A202E32656D3B5C6E5C747472616E736974696F6E3A206F70616369747920302E337320656173652D696E2D6F75743B5C6E5C746F7061636974793A20303B5C6E7D5C6E5C6E6469';
wwv_flow_imp.g_varchar2_table(46) := '762E636F64652D746F6F6C6261723A686F766572203E202E746F6F6C626172207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2F2A205365706172617465206C696E6520622F632072756C657320617265207468726F776E206F757420696620';
wwv_flow_imp.g_varchar2_table(47) := '73656C6563746F7220697320696E76616C69642E5C6E2020204945313120616E64206F6C6420456467652076657273696F6E7320646F6E277420737570706F7274203A666F6375732D77697468696E2E202A2F5C6E6469762E636F64652D746F6F6C6261';
wwv_flow_imp.g_varchar2_table(48) := '723A666F6375732D77697468696E203E202E746F6F6C626172207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D207B5C6E5C746469';
wwv_flow_imp.g_varchar2_table(49) := '73706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E2061207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(50) := '6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E207B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E5C74626F726465723A20303B5C6E5C74636F6C6F';
wwv_flow_imp.g_varchar2_table(51) := '723A20696E68657269743B5C6E5C74666F6E743A20696E68657269743B5C6E5C746C696E652D6865696768743A206E6F726D616C3B5C6E5C746F766572666C6F773A2076697369626C653B5C6E5C7470616464696E673A20303B5C6E5C742D7765626B69';
wwv_flow_imp.g_varchar2_table(52) := '742D757365722D73656C6563743A206E6F6E653B202F2A20666F7220627574746F6E202A2F5C6E5C742D6D6F7A2D757365722D73656C6563743A206E6F6E653B5C6E5C742D6D732D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E646976';
wwv_flow_imp.g_varchar2_table(53) := '2E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20612C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E2C';
wwv_flow_imp.g_varchar2_table(54) := '5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E207B5C6E5C74636F6C6F723A20236262623B5C6E5C74666F6E742D73697A653A202E38656D3B5C6E5C7470616464696E';
wwv_flow_imp.g_varchar2_table(55) := '673A2030202E35656D3B5C6E5C746261636B67726F756E643A20236635663266303B5C6E5C746261636B67726F756E643A2072676261283232342C203232342C203232342C20302E32293B5C6E5C74626F782D736861646F773A20302032707820302030';
wwv_flow_imp.g_varchar2_table(56) := '207267626128302C302C302C302E32293B5C6E5C74626F726465722D7261646975733A202E35656D3B5C6E7D5C6E5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A686F7665';
wwv_flow_imp.g_varchar2_table(57) := '722C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20613A666F6375732C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D69';
wwv_flow_imp.g_varchar2_table(58) := '74656D203E20627574746F6E3A686F7665722C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E20627574746F6E3A666F6375732C5C6E6469762E636F64652D746F6F6C626172203E';
wwv_flow_imp.g_varchar2_table(59) := '202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E3A686F7665722C5C6E6469762E636F64652D746F6F6C626172203E202E746F6F6C626172203E202E746F6F6C6261722D6974656D203E207370616E3A666F637573207B5C';
wwv_flow_imp.g_varchar2_table(60) := '6E5C74636F6C6F723A20696E68657269743B5C6E5C74746578742D6465636F726174696F6E3A206E6F6E653B5C6E7D5C6E5C6E225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(12643889679338746)
,p_file_name=>'lib/prismjs/css/prism.dark.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/js_flows4apex_min_js
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '66756E6374696F6E20696E697441707028297B617065782E6A51756572792877696E646F77292E6F6E28227468656D6534327265616479222C2866756E6374696F6E28297B617065782E7468656D6534322E7574696C2E636F6E666967415045584D7367';
wwv_flow_imp.g_varchar2_table(2) := '73287B6175746F4469736D6973733A21302C6475726174696F6E3A3565337D297D29297D66756E6374696F6E20616464436C6173736573546F506172656E747328652C612C74297B617065782E6A51756572792865292E706172656E74732861292E6164';
wwv_flow_imp.g_varchar2_table(3) := '64436C6173732874297D66756E6374696F6E206368696C6472656E417474726962757465546F417272617928652C612C74297B72657475726E20617065782E6A51756572792865292E66696E642861292E6D6170282866756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(4) := '7475726E20617065782E6A51756572792874686973292E617474722874297D29292E746F417272617928297D66756E6374696F6E20676574666C6F77496E7374616E63654461746128652C61297B6C657420743D613B72657475726E20766F6964203021';
wwv_flow_imp.g_varchar2_table(5) := '3D3D742E74797065262622627574746F6E223D3D3D742E747970657C7C28743D617065782E6A51756572792861292E636C6F736573742822627574746F6E2229292C7B7830313A652C7830323A617065782E6A51756572792874292E6174747228226461';
wwv_flow_imp.g_varchar2_table(6) := '74612D7072637322297D7D66756E6374696F6E2067657442756C6B466C6F77496E7374616E6365446174612865297B72657475726E7B7830313A652C6630313A6368696C6472656E417474726962757465546F4172726179282223666C6F772D696E7374';
wwv_flow_imp.g_varchar2_table(7) := '616E636573202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663031225D3A636865636B6564272C22646174612D7072637322297D7D66756E6374696F6E206765744D6573736167654461746128652C61297B';
wwv_flow_imp.g_varchar2_table(8) := '6C657420743D613B72657475726E20766F69642030213D3D742E74797065262622627574746F6E223D3D3D742E747970657C7C28743D617065782E6A51756572792861292E636C6F736573742822627574746F6E2229292C7B7830313A652C7830323A61';
wwv_flow_imp.g_varchar2_table(9) := '7065782E6A51756572792874292E617474722822646174612D6D65737361676522292C7830333A617065782E6A51756572792874292E617474722822646174612D6B657922292C7830343A617065782E6A51756572792874292E61747472282264617461';
wwv_flow_imp.g_varchar2_table(10) := '2D76616C756522297D7D66756E6374696F6E20676574537562666C6F774461746128652C61297B6C657420743D613B72657475726E20766F69642030213D3D742E74797065262622627574746F6E223D3D3D742E747970657C7C28743D617065782E6A51';
wwv_flow_imp.g_varchar2_table(11) := '756572792861292E636C6F736573742822627574746F6E2229292C7B7830313A652C7830323A617065782E6A51756572792874292E617474722822646174612D7072637322292C7830333A617065782E6A51756572792874292E61747472282264617461';
wwv_flow_imp.g_varchar2_table(12) := '2D7362666C22292C7830343A617065782E6A51756572792874292E617474722822646174612D6B657922297D7D66756E6374696F6E2067657442756C6B537562666C6F77446174612865297B72657475726E7B7830313A652C6630313A6368696C647265';
wwv_flow_imp.g_varchar2_table(13) := '6E417474726962757465546F4172726179282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663032225D3A636865636B6564272C22646174612D7072637322292C6630323A636869';
wwv_flow_imp.g_varchar2_table(14) := '6C6472656E417474726962757465546F4172726179282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663032225D3A636865636B6564272C2276616C756522292C6630333A636869';
wwv_flow_imp.g_varchar2_table(15) := '6C6472656E417474726962757465546F4172726179282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663032225D3A636865636B6564272C22646174612D6B657922297D7D66756E';
wwv_flow_imp.g_varchar2_table(16) := '6374696F6E206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C742C6E297B6C657420693D613B766F69642030213D3D692E74797065262622627574746F6E223D3D3D692E747970657C7C28693D617065782E6A51756572';
wwv_flow_imp.g_varchar2_table(17) := '792861292E636C6F736573742822627574746F6E2229293B76617220733D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293B617065782E6974656D282250222B732B225F434F4D4D454E5422292E73657456616C';
wwv_flow_imp.g_varchar2_table(18) := '7565282222292C617065782E6974656D282250222B732B225F434F4E4649524D5F5445585422292E73657456616C756528617065782E6C616E672E6765744D657373616765287429292C617065782E6A5175657279282223636F6E6669726D2D62746E22';
wwv_flow_imp.g_varchar2_table(19) := '292E617474722822646174612D616374696F6E222C65292C617065782E6A5175657279282223636F6E6669726D2D62746E22292E617474722822646174612D70726373222C617065782E6A51756572792869292E617474722822646174612D7072637322';
wwv_flow_imp.g_varchar2_table(20) := '29292C617065782E6A5175657279282223636F6E6669726D2D62746E22292E617474722822646174612D7362666C222C617065782E6A51756572792869292E617474722822646174612D7362666C2229292C617065782E6A5175657279282223636F6E66';
wwv_flow_imp.g_varchar2_table(21) := '69726D2D62746E22292E617474722822646174612D6B6579222C617065782E6A51756572792869292E617474722822646174612D6B65792229292C617065782E6A5175657279282223636F6E6669726D2D62746E22292E617474722822646174612D6E61';
wwv_flow_imp.g_varchar2_table(22) := '6D65222C617065782E6A51756572792869292E617474722822646174612D6E616D652229292C617065782E7468656D652E6F70656E526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722292C617065782E7574696C2E67657454';
wwv_flow_imp.g_varchar2_table(23) := '6F704170657828292E6A517565727928222E6634612D64796E616D69632D7469746C6522292E636C6F7365737428222E75692D6469616C6F672D636F6E74656E7422292E6469616C6F6728226F7074696F6E222C227469746C65222C617065782E6C616E';
wwv_flow_imp.g_varchar2_table(24) := '672E6765744D657373616765286E29297D66756E6374696F6E20676574436F6E6669726D436F6D6D656E7428297B76617220653D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293B72657475726E20617065782E';
wwv_flow_imp.g_varchar2_table(25) := '6974656D282250222B652B225F434F4D4D454E5422292E67657456616C756528297D66756E6374696F6E2073656E64546F53657276657228652C613D7B7D297B617065782E7365727665722E70726F636573732822414A41585F48414E444C4552222C65';
wwv_flow_imp.g_varchar2_table(26) := '292E646F6E65282866756E6374696F6E2865297B652E737563636573733F28766F69642030213D3D612E6D6573736167654B65792626617065782E6D6573736167652E73686F77506167655375636365737328617065782E6C616E672E6765744D657373';
wwv_flow_imp.g_varchar2_table(27) := '61676528612E6D6573736167654B657929292C766F69642030213D3D612E4974656D73546F536574262621313D3D3D617065782E6A51756572792E6973456D7074794F626A65637428612E4974656D73546F5365742926264F626A6563742E6B65797328';
wwv_flow_imp.g_varchar2_table(28) := '612E4974656D73546F536574292E666F7245616368282866756E6374696F6E2865297B617065782E6974656D2865292E73657456616C756528612E4974656D73546F5365745B655D297D29292C766F69642030213D3D612E72656672657368526567696F';
wwv_flow_imp.g_varchar2_table(29) := '6E2626612E72656672657368526567696F6E2E6C656E6774683E302626612E72656672657368526567696F6E2E666F7245616368282866756E6374696F6E2865297B69662822496E7465726163746976655265706F7274223D3D3D617065782E72656769';
wwv_flow_imp.g_varchar2_table(30) := '6F6E2865292E74797065297B76617220613D617065782E6A5175657279282223222B652B225F697222292E6461746128292E61706578496E7465726163746976655265706F72742E6F7074696F6E732E63757272656E74526F7773506572506167652C74';
wwv_flow_imp.g_varchar2_table(31) := '3D617065782E6A5175657279282223222B652B22202E612D4952522D706167696E6174696F6E2D6C6162656C22292E7465787428292E73706C697428222D22295B305D2E7472696D28293B617065782E6A5175657279282223222B652B225F697222292E';
wwv_flow_imp.g_varchar2_table(32) := '6461746128292E61706578496E7465726163746976655265706F72742E5F706167696E61746528227067525F6D696E5F726F773D222B742B226D61785F726F77733D222B612B22726F77735F666574636865643D222B61297D656C736520617065782E72';
wwv_flow_imp.g_varchar2_table(33) := '6567696F6E2865292E7265667265736828297D29292C766F69642030213D3D652E75726C26262131213D3D612E72656469726563742626617065782E6E617669676174696F6E2E726564697265637428652E75726C292C28766F69642030213D3D612E72';
wwv_flow_imp.g_varchar2_table(34) := '656C6F6164506167652626612E72656C6F6164506167657C7C766F69642030213D3D652E72656C6F6164506167652626652E72656C6F61645061676529262677696E646F772E6C6F636174696F6E2E72656C6F61642829293A766F69642030213D3D652E';
wwv_flow_imp.g_varchar2_table(35) := '6D65737361676526266E756C6C213D3D652E6D6573736167653F28617065782E6D6573736167652E636C6561724572726F727328292C617065782E6D6573736167652E73686F774572726F7273285B7B747970653A226572726F72222C6C6F636174696F';
wwv_flow_imp.g_varchar2_table(36) := '6E3A2270616765222C6D6573736167653A652E6D6573736167652C756E736166653A21317D5D29293A617065782E64656275672E6572726F722822536F6D657468696E672077656E742077726F6E672E2E2E22297D29292E6661696C282866756E637469';
wwv_flow_imp.g_varchar2_table(37) := '6F6E28652C612C74297B617065782E64656275672E6572726F722822546F74616C206661696C2E2E2E222C652C612C74297D29297D66756E6374696F6E20646F776E6C6F616441735356472865297B76617220613D2428652E746172676574292E706172';
wwv_flow_imp.g_varchar2_table(38) := '656E747328222E742D526567696F6E22292E617474722822696422293B617065782E726567696F6E2861292E67657453564728292E7468656E2828653D3E7B76617220613D6E657720426C6F62285B655D2C7B747970653A22696D6167652F7376672B78';
wwv_flow_imp.g_varchar2_table(39) := '6D6C227D292C743D446174652E6E6F7728292C6E3D646F63756D656E742E637265617465456C656D656E7428226122293B6E2E646F776E6C6F61643D742C6E2E687265663D77696E646F772E55524C2E6372656174654F626A65637455524C2861292C6E';
wwv_flow_imp.g_varchar2_table(40) := '2E636C69636B28297D29297D66756E6374696F6E207374617274466C6F77496E7374616E636528652C61297B76617220743D676574666C6F77496E7374616E63654461746128652C61292C6E3D7B6D6573736167654B65793A224150505F494E5354414E';
wwv_flow_imp.g_varchar2_table(41) := '43455F53544152544544227D3B6E2E72656C6F6164506167653D2238223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528292C6E2E72656672657368526567696F6E3D2238223D3D3D617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(42) := '2270466C6F7753746570496422292E67657456616C756528293F5B5D3A5B22666C6F772D696E7374616E636573222C22666C6F772D6D6F6E69746F72225D2C6E2E4974656D73546F5365743D2238223D3D3D617065782E6974656D282270466C6F775374';
wwv_flow_imp.g_varchar2_table(43) := '6570496422292E67657456616C756528293F7B7D3A7B5031305F505243535F49443A742E7830322C5031305F505243535F4E414D453A617065782E6A51756572792861292E617474722822646174612D6E616D6522297D2C73656E64546F536572766572';
wwv_flow_imp.g_varchar2_table(44) := '28742C6E297D66756E6374696F6E2062756C6B5374617274466C6F77496E7374616E63652865297B76617220613D7B6D6573736167654B65793A224150505F494E5354414E43455F53544152544544222C72656672657368526567696F6E3A5B22666C6F';
wwv_flow_imp.g_varchar2_table(45) := '772D696E7374616E636573222C22666C6F772D6D6F6E69746F72225D7D3B73656E64546F5365727665722867657442756C6B466C6F77496E7374616E6365446174612865292C61297D66756E6374696F6E207265736574466C6F77496E7374616E636528';
wwv_flow_imp.g_varchar2_table(46) := '652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E2822696E7374616E63655F6163';
wwv_flow_imp.g_varchar2_table(47) := '74696F6E5F6469616C6F6722293B76617220743D676574666C6F77496E7374616E63654461746128652C61293B742E7830333D676574436F6E6669726D436F6D6D656E7428293B766172206E3D7B6D6573736167654B65793A224150505F494E5354414E';
wwv_flow_imp.g_varchar2_table(48) := '43455F5245534554227D3B6E2E72656C6F6164506167653D2238223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528292C6E2E72656672657368526567696F6E3D2238223D3D3D617065782E6974656D282270';
wwv_flow_imp.g_varchar2_table(49) := '466C6F7753746570496422292E67657456616C756528293F5B5D3A5B22666C6F772D696E7374616E636573222C22666C6F772D6D6F6E69746F72225D2C6E2E4974656D73546F5365743D2238223D3D3D617065782E6974656D282270466C6F7753746570';
wwv_flow_imp.g_varchar2_table(50) := '496422292E67657456616C756528293F7B7D3A7B5031305F505243535F49443A742E7830322C5031305F505243535F4E414D453A617065782E6A51756572792861292E617474722822646174612D6E616D6522297D2C73656E64546F5365727665722874';
wwv_flow_imp.g_varchar2_table(51) := '2C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F52455345545F494E5354414E4345222C224150505F52455345545F494E5354414E434522297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(52) := '2062756C6B5265736574466C6F77496E7374616E636528652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E63';
wwv_flow_imp.g_varchar2_table(53) := '6C6F7365526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D67657442756C6B466C6F77496E7374616E6365446174612865293B742E7830323D676574436F6E6669726D436F6D6D656E7428293B76617220';
wwv_flow_imp.g_varchar2_table(54) := '6E3D7B6D6573736167654B65793A224150505F494E5354414E43455F5245534554222C72656672657368526567696F6E3A5B22666C6F772D696E7374616E636573222C22666C6F772D6D6F6E69746F72225D7D3B73656E64546F53657276657228742C6E';
wwv_flow_imp.g_varchar2_table(55) := '297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F52455345545F494E5354414E4345222C224150505F52455345545F494E5354414E434522297D66756E6374696F6E2074';
wwv_flow_imp.g_varchar2_table(56) := '65726D696E617465466C6F77496E7374616E636528652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F';
wwv_flow_imp.g_varchar2_table(57) := '7365526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D676574666C6F77496E7374616E63654461746128652C61293B742E7830333D676574436F6E6669726D436F6D6D656E7428293B766172206E3D7B6D';
wwv_flow_imp.g_varchar2_table(58) := '6573736167654B65793A224150505F494E5354414E43455F5445524D494E41544544227D3B6E2E72656C6F6164506167653D2238223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528292C6E2E726566726573';
wwv_flow_imp.g_varchar2_table(59) := '68526567696F6E3D2238223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293F5B5D3A5B22666C6F772D696E7374616E636573222C22666C6F772D6D6F6E69746F72225D2C6E2E4974656D73546F5365743D';
wwv_flow_imp.g_varchar2_table(60) := '2238223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293F7B7D3A7B5031305F505243535F49443A742E7830322C5031305F505243535F4E414D453A617065782E6A51756572792861292E61747472282264';
wwv_flow_imp.g_varchar2_table(61) := '6174612D6E616D6522297D2C73656E64546F53657276657228742C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F5445524D494E4154455F494E5354414E4345222C';
wwv_flow_imp.g_varchar2_table(62) := '224150505F5445524D494E4154455F494E5354414E434522297D66756E6374696F6E2062756C6B5465726D696E617465466C6F77496E7374616E636528652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F6E5F64';
wwv_flow_imp.g_varchar2_table(63) := '69616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D67657442756C6B466C6F77496E7374616E6365';
wwv_flow_imp.g_varchar2_table(64) := '446174612865293B742E7830323D676574436F6E6669726D436F6D6D656E7428293B766172206E3D7B6D6573736167654B65793A224150505F494E5354414E43455F5445524D494E41544544222C72656672657368526567696F6E3A5B22666C6F772D69';
wwv_flow_imp.g_varchar2_table(65) := '6E7374616E636573222C22666C6F772D6D6F6E69746F72225D7D3B73656E64546F53657276657228742C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F5445524D49';
wwv_flow_imp.g_varchar2_table(66) := '4E4154455F494E5354414E4345222C224150505F5445524D494E4154455F494E5354414E434522297D66756E6374696F6E2064656C657465466C6F77496E7374616E636528652C61297B696628617065782E6A5175657279282223696E7374616E63655F';
wwv_flow_imp.g_varchar2_table(67) := '616374696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D676574666C6F77496E7374';
wwv_flow_imp.g_varchar2_table(68) := '616E63654461746128652C61293B742E7830333D676574436F6E6669726D436F6D6D656E7428293B766172206E3D7B6D6573736167654B65793A224150505F494E5354414E43455F44454C45544544227D3B6E2E72656672657368526567696F6E3D2231';
wwv_flow_imp.g_varchar2_table(69) := '30223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293F5B22666C6F772D696E7374616E636573222C22666C6F772D6D6F6E69746F72225D3A5B5D2C6E2E4974656D73546F5365743D2238223D3D3D617065';
wwv_flow_imp.g_varchar2_table(70) := '782E6974656D282270466C6F7753746570496422292E67657456616C756528293F7B7D3A7B5031305F505243535F49443A22222C5031305F505243535F4E414D453A22227D2C6E2E72656469726563743D22313022213D3D617065782E6974656D282270';
wwv_flow_imp.g_varchar2_table(71) := '466C6F7753746570496422292E67657456616C756528292C73656E64546F53657276657228742C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F44454C4554455F49';
wwv_flow_imp.g_varchar2_table(72) := '4E5354414E4345222C224150505F44454C4554455F494E5354414E434522297D66756E6374696F6E2062756C6B44656C657465466C6F77496E7374616E636528652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F';
wwv_flow_imp.g_varchar2_table(73) := '6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D67657442756C6B466C6F77496E737461';
wwv_flow_imp.g_varchar2_table(74) := '6E6365446174612865293B742E7830323D676574436F6E6669726D436F6D6D656E7428293B766172206E3D7B6D6573736167654B65793A224150505F494E5354414E43455F44454C45544544222C72656672657368526567696F6E3A5B22666C6F772D69';
wwv_flow_imp.g_varchar2_table(75) := '6E7374616E636573222C22666C6F772D6D6F6E69746F72225D7D3B73656E64546F53657276657228742C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F44454C4554';
wwv_flow_imp.g_varchar2_table(76) := '455F494E5354414E4345222C224150505F44454C4554455F494E5354414E434522297D66756E6374696F6E207265646972656374546F466C6F77496E7374616E6365417564697428652C61297B76617220743D676574666C6F77496E7374616E63654461';
wwv_flow_imp.g_varchar2_table(77) := '746128652C61293B742E7830333D617065782E6A51756572792861292E617474722822646174612D6E616D6522292C223130223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C75652829262628617065782E697465';
wwv_flow_imp.g_varchar2_table(78) := '6D28225031305F505243535F494422292E73657456616C756528742E783032292C617065782E6974656D28225031305F505243535F4E414D4522292E73657456616C756528742E783033292C742E706167654974656D733D5B225031305F505243535F49';
wwv_flow_imp.g_varchar2_table(79) := '44222C225031305F505243535F4E414D45225D293B766172206E3D7B7D3B6E2E72656672657368526567696F6E3D2238223D3D3D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528293F5B5D3A5B22666C6F772D696E';
wwv_flow_imp.g_varchar2_table(80) := '7374616E636573222C22666C6F772D6D6F6E69746F72225D2C73656E64546F53657276657228742C6E297D66756E6374696F6E207265646972656374546F466C6F77496E7374616E636544657461696C28652C61297B76617220743D676574666C6F7749';
wwv_flow_imp.g_varchar2_table(81) := '6E7374616E63654461746128652C61293B617065782E6974656D28225031305F505243535F494422292E73657456616C756528742E783032292C617065782E6974656D28225031305F505243535F4E414D4522292E73657456616C756528617065782E6A';
wwv_flow_imp.g_varchar2_table(82) := '51756572792861292E617474722822646174612D6E616D652229292C742E706167654974656D733D5B225031305F505243535F4944222C225031305F505243535F4E414D45225D2C73656E64546F5365727665722874297D66756E6374696F6E20726564';
wwv_flow_imp.g_varchar2_table(83) := '6972656374546F466C6F774469616772616D28652C61297B76617220743D676574666C6F77496E7374616E63654461746128652C61293B742E7830323D617065782E6A51756572792861292E617474722822646174612D6467726D22292C73656E64546F';
wwv_flow_imp.g_varchar2_table(84) := '5365727665722874297D66756E6374696F6E20696E697456696577657228652C612C74297B2222213D3D613F617065782E6A5175657279282223666C6F772D6D6F6E69746F725F68656164696E6722292E7465787428617065782E6C616E672E666F726D';
wwv_flow_imp.g_varchar2_table(85) := '61744D65737361676528224150505F5649455745525F5449544C455F50524F434553535F53454C4543544544222C6129293A617065782E6A5175657279282223666C6F772D6D6F6E69746F725F68656164696E6722292E7465787428617065782E6C616E';
wwv_flow_imp.g_varchar2_table(86) := '672E6765744D65737361676528224150505F5649455745525F5449544C455F4E4F5F50524F434553532229292C2222213D3D6526262277696E646F77223D3D3D7426267265646972656374546F4D6F6E69746F722865297D66756E6374696F6E20726564';
wwv_flow_imp.g_varchar2_table(87) := '6972656374546F4D6F6E69746F722865297B76617220613D7B7830313A22766965772D666C6F772D696E7374616E6365227D3B612E7830323D652C73656E64546F5365727665722861297D66756E6374696F6E206765745661726961626C654572726F72';
wwv_flow_imp.g_varchar2_table(88) := '7328297B76617220653D5B5D3B696628617065782E6974656D282250385F50524F565F5641525F4E414D4522292E6973456D70747928292626652E70757368287B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C7061';
wwv_flow_imp.g_varchar2_table(89) := '67654974656D3A2250385F50524F565F5641525F4E414D45222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F5641525F4E414D455F454D50545922292C756E736166653A21317D292C6170';
wwv_flow_imp.g_varchar2_table(90) := '65782E6974656D282250385F50524F565F5641525F5459504522292E6973456D707479282929652E70757368287B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F564152';
wwv_flow_imp.g_varchar2_table(91) := '5F54595045222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F5641525F545950455F454D50545922292C756E736166653A21317D293B656C73657B76617220613D617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(92) := '2250385F50524F565F5641525F5459504522292E67657456616C756528293B696628225641524348415232223D3D3D6129617065782E6974656D282250385F50524F565F5641525F56433222292E6973456D70747928292626652E70757368287B747970';
wwv_flow_imp.g_varchar2_table(93) := '653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F564332222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F';
wwv_flow_imp.g_varchar2_table(94) := '5641525F56414C55455F454D50545922292C756E736166653A21317D293B656C736520696628224E554D424552223D3D3D6129617065782E6974656D282250385F50524F565F5641525F4E554D22292E6973456D70747928293F652E70757368287B7479';
wwv_flow_imp.g_varchar2_table(95) := '70653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F4E554D222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F56';
wwv_flow_imp.g_varchar2_table(96) := '5F5641525F56414C55455F454D50545922292C756E736166653A21317D293A224E223D3D3D617065782E6974656D282250385F50524F565F5641525F4E554D5F56414C494422292E67657456616C756528292626652E70757368287B747970653A226572';
wwv_flow_imp.g_varchar2_table(97) := '726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F4E554D222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F5641525F4E';
wwv_flow_imp.g_varchar2_table(98) := '554D5F4E4F545F4E554D42455222292C756E736166653A21317D293B656C7365206966282244415445223D3D3D6129617065782E6974656D282250385F50524F565F5641525F4441544522292E6973456D70747928293F652E70757368287B747970653A';
wwv_flow_imp.g_varchar2_table(99) := '226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F44415445222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F56';
wwv_flow_imp.g_varchar2_table(100) := '41525F56414C55455F454D50545922292C756E736166653A21317D293A224E223D3D3D617065782E6974656D282250385F50524F565F5641525F444154455F56414C494422292E67657456616C756528292626652E70757368287B747970653A22657272';
wwv_flow_imp.g_varchar2_table(101) := '6F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F44415445222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F5641525F44';
wwv_flow_imp.g_varchar2_table(102) := '4154455F4E4F545F4441544522292C756E736166653A21317D293B656C7365206966282254494D455354414D5020574954482054494D45205A4F4E45223D3D3D6129617065782E6974656D282250385F50524F565F5641525F5453545A22292E6973456D';
wwv_flow_imp.g_varchar2_table(103) := '70747928293F652E70757368287B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F5453545A222C6D6573736167653A617065782E6C616E672E6765744D657373';
wwv_flow_imp.g_varchar2_table(104) := '61676528224150505F4552525F50524F565F5641525F56414C55455F454D50545922292C756E736166653A21317D293A224E223D3D3D617065782E6974656D282250385F50524F565F5641525F5453545A5F56414C494422292E67657456616C75652829';
wwv_flow_imp.g_varchar2_table(105) := '2626652E70757368287B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F5453545A222C6D6573736167653A617065782E6C616E672E6765744D65737361676528';
wwv_flow_imp.g_varchar2_table(106) := '224150505F4552525F50524F565F5641525F5453545A5F4E4F545F5453545A22292C756E736166653A21317D293B656C7365206966282822434C4F42223D3D3D617C7C224A534F4E223D3D3D6129262628617065782E6974656D282250385F50524F565F';
wwv_flow_imp.g_varchar2_table(107) := '5641525F434C4F4222292E6973456D70747928292626652E70757368287B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F565F5641525F434C4F42222C6D6573736167653A61';
wwv_flow_imp.g_varchar2_table(108) := '7065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F5641525F56414C55455F454D50545922292C756E736166653A21317D292C224A534F4E223D3D3D6129297472797B4A534F4E2E706172736528617065782E6974656D';
wwv_flow_imp.g_varchar2_table(109) := '282250385F50524F565F5641525F434C4F4222292E67657456616C75652829297D63617463682861297B652E70757368287B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F50524F56';
wwv_flow_imp.g_varchar2_table(110) := '5F5641525F434C4F42222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F50524F565F5641525F494E56414C49445F4A534F4E22292C756E736166653A21317D297D7D72657475726E20657D66756E6374';
wwv_flow_imp.g_varchar2_table(111) := '696F6E20676574476174657761794572726F727328297B76617220653D5B5D3B72657475726E2273696E676C65223D3D3D617065782E6974656D282250385F53454C4543545F4F5054494F4E22292E67657456616C756528292626617065782E6974656D';
wwv_flow_imp.g_varchar2_table(112) := '282250385F434F4E4E454354494F4E22292E67657456616C756528292E6C656E6774683E31262628653D5B7B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F434F4E4E454354494F4E';
wwv_flow_imp.g_varchar2_table(113) := '222C6D6573736167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F474154455741595F4F4E4C595F4F4E455F434F4E4E454354494F4E22292C756E736166653A21317D5D292C303D3D3D617065782E6974656D28225038';
wwv_flow_imp.g_varchar2_table(114) := '5F434F4E4E454354494F4E22292E67657456616C756528292E6C656E677468262628653D5B7B747970653A226572726F72222C6C6F636174696F6E3A5B22696E6C696E65225D2C706167654974656D3A2250385F434F4E4E454354494F4E222C6D657373';
wwv_flow_imp.g_varchar2_table(115) := '6167653A617065782E6C616E672E6765744D65737361676528224150505F4552525F474154455741595F434F4E4E454354494F4E5F454D50545922292C756E736166653A21317D5D292C657D66756E6374696F6E2061646450726F636573735661726961';
wwv_flow_imp.g_varchar2_table(116) := '626C6528652C61297B76617220743D613B766F69642030213D3D742E74797065262622627574746F6E223D3D3D742E747970657C7C28743D617065782E6A51756572792861292E636C6F736573742822627574746F6E2229293B766172206E3D22747275';
wwv_flow_imp.g_varchar2_table(117) := '65223D3D3D617065782E6A51756572792874292E617474722822646174612D676174657761792D726F75746522292C693D6E3F22676174657761795F73656C6563746F72223A227661726961626C655F6469616C6F67223B696628617065782E6A517565';
wwv_flow_imp.g_varchar2_table(118) := '7279282223222B69292E6469616C6F67282269734F70656E2229297B76617220733D6E3F676574476174657761794572726F727328293A6765745661726961626C654572726F727328293B696628303D3D3D732E6C656E677468297B617065782E746865';
wwv_flow_imp.g_varchar2_table(119) := '6D652E636C6F7365526567696F6E2869293B76617220723D7B7D2C6F3D7B7D3B696628722E7830313D652C722E7830323D617065782E6974656D282250385F505243535F494422292E67657456616C756528292C722E7830363D617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(120) := '2250385F50524F565F53434F504522292E67657456616C756528292C6E297B722E7830333D617065782E6974656D282250385F4741544557415922292E67657456616C756528292B223A726F757465222C722E7830343D225641524348415232223B7661';
wwv_flow_imp.g_varchar2_table(121) := '72206C3D617065782E6974656D282250385F53454C4543545F4F5054494F4E22292E67657456616C756528292C753D2273696E676C65223D3D3D6C3F617065782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528293A6170';
wwv_flow_imp.g_varchar2_table(122) := '65782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528292E6A6F696E28223A22293B722E7830353D6C3D757D656C736520696628722E7830333D617065782E6974656D282250385F50524F565F5641525F4E414D4522292E';
wwv_flow_imp.g_varchar2_table(123) := '67657456616C756528292C722E7830343D617065782E6974656D282250385F50524F565F5641525F5459504522292E67657456616C756528292C225641524348415232223D3D3D722E78303429722E7830353D617065782E6974656D282250385F50524F';
wwv_flow_imp.g_varchar2_table(124) := '565F5641525F56433222292E67657456616C756528293B656C736520696628224E554D424552223D3D3D722E78303429722E7830353D617065782E6974656D282250385F50524F565F5641525F4E554D22292E67657456616C756528293B656C73652069';
wwv_flow_imp.g_varchar2_table(125) := '66282244415445223D3D3D722E78303429722E7830353D617065782E6974656D282250385F50524F565F5641525F4441544522292E67657456616C756528293B656C7365206966282254494D455354414D5020574954482054494D45205A4F4E45223D3D';
wwv_flow_imp.g_varchar2_table(126) := '3D722E78303429722E7830353D617065782E6974656D282250385F50524F565F5641525F5453545A22292E67657456616C756528293B656C73652069662822434C4F42223D3D3D722E7830347C7C224A534F4E223D3D3D722E783034297B76617220703D';
wwv_flow_imp.g_varchar2_table(127) := '617065782E7365727665722E6368756E6B28617065782E6974656D282250385F50524F565F5641525F434C4F4222292E67657456616C75652829293B41727261792E697341727261792870297C7C28703D5B705D292C722E6630313D707D6F2E6D657373';
wwv_flow_imp.g_varchar2_table(128) := '6167654B65793D224150505F50524F434553535F5641524941424C455F4144444544222C6F2E72656672657368526567696F6E3D5B2270726F636573732D7661726961626C6573225D2C73656E64546F53657276657228722C6F297D656C736520617065';
wwv_flow_imp.g_varchar2_table(129) := '782E6D6573736167652E636C6561724572726F727328292C617065782E6D6573736167652E73686F774572726F72732873297D656C7365206E3F28617065782E6974656D282250385F4741544557415922292E73657456616C7565282222292C61706578';
wwv_flow_imp.g_varchar2_table(130) := '2E6974656D282250385F4741544557415922292E656E61626C6528292C617065782E6974656D282250385F434F4E4E454354494F4E22292E73657456616C7565282222292C617065782E6A5175657279282223756E73656C6563745F62746E22292E6869';
wwv_flow_imp.g_varchar2_table(131) := '646528292C617065782E6A517565727928222373656C6563745F62746E22292E6869646528292C617065782E6A51756572792822236164642D70726F762D7661722D726F7574652D62746E22292E73686F7728292C617065782E6A517565727928222373';
wwv_flow_imp.g_varchar2_table(132) := '6176652D70726F762D7661722D726F7574652D62746E22292E686964652829293A28617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C756528292C617065782E6974656D282250385F50524F565F5641525F4E554D';
wwv_flow_imp.g_varchar2_table(133) := '22292E73657456616C756528292C617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C756528292C617065782E6974656D282250385F50524F565F5641525F434C4F4222292E73657456616C756528292C61706578';
wwv_flow_imp.g_varchar2_table(134) := '2E6974656D282250385F50524F565F5641525F4E414D4522292E73657456616C756528292C617065782E6974656D282250385F50524F565F5641525F4E414D4522292E656E61626C6528292C617065782E6974656D282250385F50524F565F5641525F54';
wwv_flow_imp.g_varchar2_table(135) := '59504522292E73657456616C75652822564152434841523222292C617065782E6974656D282250385F50524F565F5641525F5459504522292E656E61626C6528292C617065782E6974656D282250385F50524F565F53434F504522292E73657456616C75';
wwv_flow_imp.g_varchar2_table(136) := '6528617065782E6974656D732E50385F4449414752414D5F4C4556454C2E6973456D70747928293F2230223A617065782E6974656D732E50385F4449414752414D5F4C4556454C2E76616C7565292C617065782E6974656D282250385F50524F565F5343';
wwv_flow_imp.g_varchar2_table(137) := '4F504522292E656E61626C6528292C617065782E6A51756572792822236164642D70726F762D7661722D62746E22292E73686F7728292C617065782E6A5175657279282223736176652D70726F762D7661722D62746E22292E686964652829292C617065';
wwv_flow_imp.g_varchar2_table(138) := '782E6D6573736167652E636C6561724572726F727328292C617065782E7468656D652E6F70656E526567696F6E2869297D66756E6374696F6E2075706461746550726F636573735661726961626C6528652C61297B76617220743D613B766F6964203021';
wwv_flow_imp.g_varchar2_table(139) := '3D3D742E74797065262622627574746F6E223D3D3D742E747970657C7C28743D617065782E6A51756572792861292E636C6F736573742822627574746F6E2229293B766172206E3D2274727565223D3D3D617065782E6A51756572792874292E61747472';
wwv_flow_imp.g_varchar2_table(140) := '2822646174612D676174657761792D726F75746522292C693D6E3F22676174657761795F73656C6563746F72223A227661726961626C655F6469616C6F67223B696628617065782E6A5175657279282223222B69292E6469616C6F67282269734F70656E';
wwv_flow_imp.g_varchar2_table(141) := '2229297B76617220733D6E3F676574476174657761794572726F727328293A6765745661726961626C654572726F727328293B696628303D3D3D732E6C656E677468297B617065782E7468656D652E636C6F7365526567696F6E2869293B76617220723D';
wwv_flow_imp.g_varchar2_table(142) := '7B7D2C6F3D7B7D3B696628722E7830313D652C722E7830323D617065782E6974656D282250385F505243535F494422292E67657456616C756528292C722E7830363D617065782E6974656D282250385F50524F565F53434F504522292E67657456616C75';
wwv_flow_imp.g_varchar2_table(143) := '6528292C6E297B722E7830333D617065782E6974656D282250385F4741544557415922292E67657456616C756528292B223A726F757465222C722E7830343D225641524348415232223B766172206C3D617065782E6974656D282250385F53454C454354';
wwv_flow_imp.g_varchar2_table(144) := '5F4F5054494F4E22292E67657456616C756528292C753D2273696E676C65223D3D3D6C3F617065782E6974656D282250385F434F4E4E454354494F4E22292E67657456616C756528293A617065782E6974656D282250385F434F4E4E454354494F4E2229';
wwv_flow_imp.g_varchar2_table(145) := '2E67657456616C756528292E6A6F696E28223A22293B722E7830353D6C3D757D656C736520696628722E7830333D617065782E6974656D282250385F50524F565F5641525F4E414D4522292E67657456616C756528292C722E7830343D617065782E6974';
wwv_flow_imp.g_varchar2_table(146) := '656D282250385F50524F565F5641525F5459504522292E67657456616C756528292C225641524348415232223D3D3D722E78303429722E7830353D617065782E6974656D282250385F50524F565F5641525F56433222292E67657456616C756528293B65';
wwv_flow_imp.g_varchar2_table(147) := '6C736520696628224E554D424552223D3D3D722E78303429722E7830353D617065782E6974656D282250385F50524F565F5641525F4E554D22292E67657456616C756528293B656C7365206966282244415445223D3D3D722E78303429722E7830353D61';
wwv_flow_imp.g_varchar2_table(148) := '7065782E6974656D282250385F50524F565F5641525F4441544522292E67657456616C756528293B656C7365206966282254494D455354414D5020574954482054494D45205A4F4E45223D3D3D722E78303429722E7830353D617065782E6974656D2822';
wwv_flow_imp.g_varchar2_table(149) := '50385F50524F565F5641525F5453545A22292E67657456616C756528293B656C73652069662822434C4F42223D3D3D722E7830347C7C224A534F4E223D3D3D722E783034297B76617220703D617065782E7365727665722E6368756E6B28617065782E69';
wwv_flow_imp.g_varchar2_table(150) := '74656D282250385F50524F565F5641525F434C4F4222292E67657456616C75652829293B41727261792E697341727261792870297C7C28703D5B705D292C722E6630313D707D6F2E6D6573736167654B65793D224150505F50524F434553535F56415249';
wwv_flow_imp.g_varchar2_table(151) := '41424C455F5341564544222C6F2E72656672657368526567696F6E3D5B2270726F636573732D7661726961626C6573225D2C73656E64546F53657276657228722C6F297D656C736520617065782E6D6573736167652E73686F774572726F72732873297D';
wwv_flow_imp.g_varchar2_table(152) := '656C73657B76617220633D617065782E6A51756572792861292E617474722822646174612D6E616D6522292C5F3D617065782E6A51756572792861292E617474722822646174612D7479706522292C643D617065782E6A51756572792861292E61747472';
wwv_flow_imp.g_varchar2_table(153) := '2822646174612D73636F706522293B617065782E7365727665722E70726F6365737328224745545F5641524941424C45222C7B7830313A617065782E6974656D282250385F505243535F494422292E67657456616C756528292C7830323A632C7830333A';
wwv_flow_imp.g_varchar2_table(154) := '5F2C7830343A647D2C7B737563636573733A66756E6374696F6E2865297B652E737563636573732626286E3F28617065782E6D6573736167652E636C6561724572726F727328292C617065782E7468656D652E6F70656E526567696F6E28226761746577';
wwv_flow_imp.g_varchar2_table(155) := '61795F73656C6563746F7222292C617065782E6A5175657279282223756E73656C6563745F62746E22292E6869646528292C617065782E6A517565727928222373656C6563745F62746E22292E6869646528292C617065782E6A51756572792822236164';
wwv_flow_imp.g_varchar2_table(156) := '642D70726F762D7661722D726F7574652D62746E22292E6869646528292C617065782E6A5175657279282223736176652D70726F762D7661722D726F7574652D62746E22292E73686F7728292C617065782E6974656D282250385F474154455741592229';
wwv_flow_imp.g_varchar2_table(157) := '2E73657456616C756528632E73706C697428223A22295B305D292C73657454696D656F7574282866756E6374696F6E28297B617065782E6974656D282250385F434F4E4E454354494F4E22292E73657456616C756528652E7663325F76616C7565292C61';
wwv_flow_imp.g_varchar2_table(158) := '7065782E6974656D282250385F4741544557415922292E64697361626C6528297D292C33303029293A28617065782E6974656D282250385F50524F565F5641525F4E414D4522292E73657456616C75652863292C617065782E6974656D282250385F5052';
wwv_flow_imp.g_varchar2_table(159) := '4F565F5641525F4E414D4522292E64697361626C6528292C617065782E6974656D282250385F50524F565F5641525F5459504522292E73657456616C7565285F292C617065782E6974656D282250385F50524F565F5641525F5459504522292E64697361';
wwv_flow_imp.g_varchar2_table(160) := '626C6528292C617065782E6974656D282250385F50524F565F53434F504522292E73657456616C75652864292C617065782E6974656D282250385F50524F565F53434F504522292E64697361626C6528292C617065782E7468656D652E6F70656E526567';
wwv_flow_imp.g_varchar2_table(161) := '696F6E28227661726961626C655F6469616C6F6722292C225641524348415232223D3D3D5F3F28617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C756528652E7663325F76616C7565292C617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(162) := '2250385F50524F565F5641525F4E554D22292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F5453';
wwv_flow_imp.g_varchar2_table(163) := '545A22292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F434C4F4222292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F56433222292E736574466F6375732829';
wwv_flow_imp.g_varchar2_table(164) := '293A224E554D424552223D3D3D5F3F28617065782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C756528652E6E756D5F76616C7565292C617065782E6974656D282250385F50524F565F5641525F56433222292E73657456';
wwv_flow_imp.g_varchar2_table(165) := '616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C7565282222292C617065782E';
wwv_flow_imp.g_varchar2_table(166) := '6974656D282250385F50524F565F5641525F434C4F4222292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4E554D22292E736574466F6375732829293A2244415445223D3D3D5F3F28617065782E6974656D';
wwv_flow_imp.g_varchar2_table(167) := '282250385F50524F565F5641525F4441544522292E73657456616C756528652E646174655F76616C7565292C617065782E6974656D282250385F50524F565F5641525F5453545A22292E73657456616C7565282222292C617065782E6974656D28225038';
wwv_flow_imp.g_varchar2_table(168) := '5F50524F565F5641525F56433222292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F434C4F422229';
wwv_flow_imp.g_varchar2_table(169) := '2E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4441544522292E736574466F6375732829293A2254494D455354414D5020574954482054494D45205A4F4E45223D3D3D5F3F28617065782E6974656D282250';
wwv_flow_imp.g_varchar2_table(170) := '385F50524F565F5641525F5453545A22292E73657456616C756528652E7473747A5F76616C7565292C617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C7565282222292C617065782E6974656D282250385F50524F';
wwv_flow_imp.g_varchar2_table(171) := '565F5641525F4E554D22292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F434C4F4222292E7365';
wwv_flow_imp.g_varchar2_table(172) := '7456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F5453545A22292E736574466F6375732829293A22434C4F4222213D3D5F2626224A534F4E22213D3D5F7C7C28617065782E6974656D282250385F50524F565F564152';
wwv_flow_imp.g_varchar2_table(173) := '5F434C4F4222292E73657456616C75652822434C4F42223D3D3D5F3F652E636C6F625F76616C75653A652E6A736F6E5F76616C7565292C617065782E6974656D282250385F50524F565F5641525F56433222292E73657456616C7565282222292C617065';
wwv_flow_imp.g_varchar2_table(174) := '782E6974656D282250385F50524F565F5641525F4E554D22292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F4441544522292E73657456616C7565282222292C617065782E6974656D282250385F50524F56';
wwv_flow_imp.g_varchar2_table(175) := '5F5641525F5453545A22292E73657456616C7565282222292C617065782E6974656D282250385F50524F565F5641525F434C4F4222292E736574466F6375732829292C617065782E6A51756572792822236164642D70726F762D7661722D62746E22292E';
wwv_flow_imp.g_varchar2_table(176) := '6869646528292C617065782E6A5175657279282223736176652D70726F762D7661722D62746E22292E73686F772829292C617065782E7468656D652E6F70656E526567696F6E286929297D2C6572726F723A66756E6374696F6E28652C612C74297B636F';
wwv_flow_imp.g_varchar2_table(177) := '6E736F6C652E6C6F672865297D7D297D7D66756E6374696F6E2064656C65746550726F636573735661726961626C6528652C61297B617065782E6D6573736167652E636F6E6669726D28617065782E6C616E672E6765744D65737361676528224150505F';
wwv_flow_imp.g_varchar2_table(178) := '434F4E4649524D5F44454C4554455F50524F434553535F5641524941424C4522292C2866756E6374696F6E2874297B69662874297B766172206E3D7B7D2C693D7B7D3B6E2E7830313D652C6E2E7830323D617065782E6A51756572792861292E61747472';
wwv_flow_imp.g_varchar2_table(179) := '2822646174612D7072637322292C6E2E7830333D617065782E6A51756572792861292E617474722822646174612D6E616D6522292C6E2E7830343D617065782E6A51756572792861292E617474722822646174612D73636F706522292C692E6D65737361';
wwv_flow_imp.g_varchar2_table(180) := '67654B65793D224150505F50524F434553535F5641524941424C455F44454C45544544222C692E72656672657368526567696F6E3D5B2270726F636573732D7661726961626C6573225D2C73656E64546F536572766572286E2C69297D7D29297D66756E';
wwv_flow_imp.g_varchar2_table(181) := '6374696F6E2062756C6B44656C65746550726F636573735661726961626C652865297B617065782E6D6573736167652E636F6E6669726D28617065782E6C616E672E6765744D65737361676528224150505F434F4E4649524D5F44454C4554455F50524F';
wwv_flow_imp.g_varchar2_table(182) := '434553535F5641524941424C4522292C2866756E6374696F6E2861297B69662861297B76617220743D7B7D2C6E3D7B7D3B742E7830313D652C742E6630313D6368696C6472656E417474726962757465546F417272617928222370726F636573732D7661';
wwv_flow_imp.g_varchar2_table(183) := '726961626C6573202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663033225D3A636865636B6564272C22646174612D7072637322292C742E6630323D6368696C6472656E417474726962757465546F417272';
wwv_flow_imp.g_varchar2_table(184) := '617928222370726F636573732D7661726961626C6573202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663033225D3A636865636B6564272C2276616C756522292C742E6630333D6368696C6472656E417474';
wwv_flow_imp.g_varchar2_table(185) := '726962757465546F417272617928222370726F636573732D7661726961626C6573202E612D4952522D7461626C65436F6E7461696E6572222C27696E7075745B6E616D653D22663033225D3A636865636B6564272C22646174612D73636F706522292C6E';
wwv_flow_imp.g_varchar2_table(186) := '2E6D6573736167654B65793D224150505F50524F434553535F5641524941424C455F44454C45544544222C6E2E72656672657368526567696F6E3D5B2270726F636573732D7661726961626C6573225D2C73656E64546F53657276657228742C6E297D7D';
wwv_flow_imp.g_varchar2_table(187) := '29297D66756E6374696F6E20636F6D706C6574655374657028652C61297B76617220743D7B72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72222C2270726F636573732D7661726961626C6573222C2266';
wwv_flow_imp.g_varchar2_table(188) := '6C6F772D696E7374616E63652D6576656E7473222C226D6573736167652D737562736372697074696F6E73222C227461736B2D6C697374225D7D3B73656E64546F53657276657228676574537562666C6F774461746128652C61292C74297D66756E6374';
wwv_flow_imp.g_varchar2_table(189) := '696F6E2062756C6B436F6D706C657465537465702865297B76617220613D7B72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72222C2270726F636573732D7661726961626C6573222C22666C6F772D696E';
wwv_flow_imp.g_varchar2_table(190) := '7374616E63652D6576656E7473222C226D6573736167652D737562736372697074696F6E73222C227461736B2D6C697374225D7D3B73656E64546F5365727665722867657442756C6B537562666C6F77446174612865292C61297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(191) := '726573746172745374657028652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E28';
wwv_flow_imp.g_varchar2_table(192) := '22696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D676574537562666C6F774461746128652C61293B742E7830353D676574436F6E6669726D436F6D6D656E7428293B766172206E3D7B6D6573736167654B65793A22415050';
wwv_flow_imp.g_varchar2_table(193) := '5F5355424C464F575F524553544152544544222C72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72222C2270726F636573732D7661726961626C6573222C22666C6F772D696E7374616E63652D6576656E';
wwv_flow_imp.g_varchar2_table(194) := '7473222C227461736B2D6C697374225D7D3B73656E64546F53657276657228742C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F524553544152545F53544550222C';
wwv_flow_imp.g_varchar2_table(195) := '224150505F5449544C455F524553544152545F5354455022297D66756E6374696F6E2062756C6B526573746172745374657028652C61297B696628617065782E6A5175657279282223696E7374616E63655F616374696F6E5F6469616C6F6722292E6469';
wwv_flow_imp.g_varchar2_table(196) := '616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E2822696E7374616E63655F616374696F6E5F6469616C6F6722293B76617220743D67657442756C6B537562666C6F77446174612865293B742E7830323D67';
wwv_flow_imp.g_varchar2_table(197) := '6574436F6E6669726D436F6D6D656E7428293B766172206E3D7B72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72222C2270726F636573732D7661726961626C6573222C22666C6F772D696E7374616E63';
wwv_flow_imp.g_varchar2_table(198) := '652D6576656E7473222C227461736B2D6C697374225D7D3B73656E64546F53657276657228742C6E297D656C7365206F70656E4D6F64616C436F6E6669726D57697468436F6D6D656E7428652C612C224150505F434F4E4649524D5F524553544152545F';
wwv_flow_imp.g_varchar2_table(199) := '53544550222C224150505F5449544C455F524553544152545F5354455022297D66756E6374696F6E206F70656E5265736572766174696F6E4469616C6F6728652C61297B617065782E6974656D282250385F5245534552564154494F4E22292E73657456';
wwv_flow_imp.g_varchar2_table(200) := '616C7565282222292C617065782E6A5175657279282223726573657276652D737465702D62746E22292E617474722822646174612D616374696F6E222C65292C617065782E6A5175657279282223726573657276652D737465702D62746E22292E617474';
wwv_flow_imp.g_varchar2_table(201) := '722822646174612D70726373222C617065782E6A51756572792861292E617474722822646174612D707263732229292C617065782E6A5175657279282223726573657276652D737465702D62746E22292E617474722822646174612D7362666C222C6170';
wwv_flow_imp.g_varchar2_table(202) := '65782E6A51756572792861292E617474722822646174612D7362666C2229292C617065782E6A5175657279282223726573657276652D737465702D62746E22292E617474722822646174612D6B6579222C617065782E6A51756572792861292E61747472';
wwv_flow_imp.g_varchar2_table(203) := '2822646174612D6B65792229292C617065782E7468656D652E6F70656E526567696F6E28227265736572766174696F6E5F6469616C6F6722297D66756E6374696F6E20726573657276655374657028652C61297B696628617065782E6A51756572792822';
wwv_flow_imp.g_varchar2_table(204) := '237265736572766174696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E28227265736572766174696F6E5F6469616C6F6722293B76617220743D676574537562666C6F';
wwv_flow_imp.g_varchar2_table(205) := '774461746128652C61293B742E7830353D617065782E6974656D282250385F5245534552564154494F4E22292E67657456616C756528293B766172206E3D7B72656672657368526567696F6E3A5B22737562666C6F7773222C227461736B2D6C69737422';
wwv_flow_imp.g_varchar2_table(206) := '5D7D3B73656E64546F53657276657228742C6E297D656C7365206F70656E5265736572766174696F6E4469616C6F6728652C61297D66756E6374696F6E2062756C6B52657365727665537465702865297B696628617065782E6A51756572792822237265';
wwv_flow_imp.g_varchar2_table(207) := '736572766174696F6E5F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E28227265736572766174696F6E5F6469616C6F6722293B76617220613D67657442756C6B537562666C';
wwv_flow_imp.g_varchar2_table(208) := '6F77446174612865293B612E7830323D617065782E6974656D282250385F5245534552564154494F4E22292E67657456616C756528293B76617220743D7B72656672657368526567696F6E3A5B22737562666C6F7773222C227461736B2D6C697374225D';
wwv_flow_imp.g_varchar2_table(209) := '7D3B73656E64546F53657276657228612C74297D656C7365206F70656E5265736572766174696F6E4469616C6F6728652C6E756C6C297D66756E6374696F6E2072656C656173655374657028652C61297B617065782E6D6573736167652E636F6E666972';
wwv_flow_imp.g_varchar2_table(210) := '6D28617065782E6C616E672E6765744D65737361676528224150505F434F4E4649524D5F52454C454153455F5354455022292C2866756E6374696F6E2874297B69662874297B766172206E3D7B72656672657368526567696F6E3A5B22737562666C6F77';
wwv_flow_imp.g_varchar2_table(211) := '73222C227461736B2D6C697374225D7D3B73656E64546F53657276657228676574537562666C6F774461746128652C61292C6E297D7D29297D66756E6374696F6E2062756C6B52656C65617365537465702865297B617065782E6D6573736167652E636F';
wwv_flow_imp.g_varchar2_table(212) := '6E6669726D28617065782E6C616E672E6765744D65737361676528224150505F434F4E4649524D5F52454C454153455F5354455022292C2866756E6374696F6E2861297B69662861297B76617220743D7B72656672657368526567696F6E3A5B22737562';
wwv_flow_imp.g_varchar2_table(213) := '666C6F7773222C227461736B2D6C697374225D7D3B73656E64546F5365727665722867657442756C6B537562666C6F77446174612865292C74297D7D29297D66756E6374696F6E2072657363686564756C6554696D657228652C61297B69662861706578';
wwv_flow_imp.g_varchar2_table(214) := '2E6A517565727928222372657363686564756C655F74696D65725F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E282272657363686564756C655F74696D65725F6469616C6F';
wwv_flow_imp.g_varchar2_table(215) := '6722293B76617220743D676574537562666C6F774461746128652C61293B742E7830353D617065782E6974656D282250385F52455343484544554C455F54494D45525F4E4F5722292E67657456616C756528292C742E7830363D617065782E6974656D28';
wwv_flow_imp.g_varchar2_table(216) := '2250385F52455343484544554C455F54494D45525F415422292E67657456616C756528292C742E7830373D617065782E6974656D282250385F52455343484544554C455F54494D45525F434F4D4D454E5422292E67657456616C756528293B766172206E';
wwv_flow_imp.g_varchar2_table(217) := '3D7B72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72222C2270726F636573732D7661726961626C6573222C22666C6F772D696E7374616E63652D6576656E7473222C226D6573736167652D7375627363';
wwv_flow_imp.g_varchar2_table(218) := '72697074696F6E73222C227461736B2D6C697374225D7D3B73656E64546F53657276657228742C6E297D656C7365206F70656E52657363686564756C6554696D65724469616C6F6728652C61297D66756E6374696F6E2062756C6B52657363686564756C';
wwv_flow_imp.g_varchar2_table(219) := '6554696D65722865297B696628617065782E6A517565727928222372657363686564756C655F74696D65725F6469616C6F6722292E6469616C6F67282269734F70656E2229297B617065782E7468656D652E636C6F7365526567696F6E28227265736368';
wwv_flow_imp.g_varchar2_table(220) := '6564756C655F74696D65725F6469616C6F6722293B76617220613D67657442756C6B537562666C6F77446174612865293B612E7830323D617065782E6974656D282250385F52455343484544554C455F54494D45525F4E4F5722292E67657456616C7565';
wwv_flow_imp.g_varchar2_table(221) := '28292C612E7830333D617065782E6974656D282250385F52455343484544554C455F54494D45525F415422292E67657456616C756528292C612E7830343D617065782E6974656D282250385F52455343484544554C455F54494D45525F434F4D4D454E54';
wwv_flow_imp.g_varchar2_table(222) := '22292E67657456616C756528293B76617220743D7B72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72222C2270726F636573732D7661726961626C6573222C22666C6F772D696E7374616E63652D657665';
wwv_flow_imp.g_varchar2_table(223) := '6E7473222C226D6573736167652D737562736372697074696F6E73222C227461736B2D6C697374225D7D3B73656E64546F53657276657228612C74297D656C7365206F70656E52657363686564756C6554696D65724469616C6F6728652C6E756C6C297D';
wwv_flow_imp.g_varchar2_table(224) := '66756E6374696F6E20726563656976654D65737361676528652C61297B696628617065782E6A5175657279282223726563656976655F6D6573736167655F6469616C6F6722292E6469616C6F67282269734F70656E2229297B76617220743D6765744D65';
wwv_flow_imp.g_varchar2_table(225) := '73736167654461746128652C61292C6E3D617065782E7365727665722E6368756E6B28617065782E6974656D282250385F5041594C4F414422292E67657456616C75652829293B41727261792E69734172726179286E297C7C286E3D5B6E5D292C742E66';
wwv_flow_imp.g_varchar2_table(226) := '30313D6E2C617065782E7468656D652E636C6F7365526567696F6E2822726563656976655F6D6573736167655F6469616C6F6722293B76617220693D7B72656672657368526567696F6E3A5B22737562666C6F7773222C22666C6F772D6D6F6E69746F72';
wwv_flow_imp.g_varchar2_table(227) := '222C2270726F636573732D7661726961626C6573222C22666C6F772D696E7374616E63652D6576656E7473222C226D6573736167652D737562736372697074696F6E73222C227461736B2D6C697374225D7D3B73656E64546F53657276657228742C6929';
wwv_flow_imp.g_varchar2_table(228) := '7D656C7365206F70656E526563656976654D6573736167654469616C6F6728652C61297D66756E6374696F6E206F70656E526563656976654D6573736167654469616C6F6728652C61297B617065782E6A5175657279282223726563656976652D6D6573';
wwv_flow_imp.g_varchar2_table(229) := '736167652D62746E22292E617474722822646174612D6D657373616765222C617065782E6A51756572792861292E617474722822646174612D6D6573736167652229292C617065782E6A5175657279282223726563656976652D6D6573736167652D6274';
wwv_flow_imp.g_varchar2_table(230) := '6E22292E617474722822646174612D6B6579222C617065782E6A51756572792861292E617474722822646174612D6B65792229292C617065782E6A5175657279282223726563656976652D6D6573736167652D62746E22292E617474722822646174612D';
wwv_flow_imp.g_varchar2_table(231) := '76616C7565222C617065782E6A51756572792861292E617474722822646174612D76616C75652229292C617065782E7468656D652E6F70656E526567696F6E2822726563656976655F6D6573736167655F6469616C6F6722297D66756E6374696F6E206F';
wwv_flow_imp.g_varchar2_table(232) := '70656E52657363686564756C6554696D65724469616C6F6728652C61297B617065782E6974656D282250385F52455343484544554C455F54494D45525F4E4F5722292E73657456616C756528225922292C617065782E6974656D282250385F5245534348';
wwv_flow_imp.g_varchar2_table(233) := '4544554C455F54494D45525F415422292E73657456616C7565282222292C617065782E6974656D282250385F52455343484544554C455F54494D45525F434F4D4D454E5422292E73657456616C7565282222292C617065782E6A51756572792822237265';
wwv_flow_imp.g_varchar2_table(234) := '7363686564756C652D74696D65722D62746E22292E617474722822646174612D616374696F6E222C65292C617065782E6A517565727928222372657363686564756C652D74696D65722D62746E22292E617474722822646174612D70726373222C617065';
wwv_flow_imp.g_varchar2_table(235) := '782E6A51756572792861292E617474722822646174612D707263732229292C617065782E6A517565727928222372657363686564756C652D74696D65722D62746E22292E617474722822646174612D7362666C222C617065782E6A51756572792861292E';
wwv_flow_imp.g_varchar2_table(236) := '617474722822646174612D7362666C2229292C617065782E6A517565727928222372657363686564756C652D74696D65722D62746E22292E617474722822646174612D6B6579222C617065782E6A51756572792861292E617474722822646174612D6B65';
wwv_flow_imp.g_varchar2_table(237) := '792229292C617065782E7468656D652E6F70656E526567696F6E282272657363686564756C655F74696D65725F6469616C6F6722297D66756E6374696F6E206D61726B417343757272656E742865297B76617220613D617065782E6A5175657279282223';
wwv_flow_imp.g_varchar2_table(238) := '666C6F772D696E7374616E63657320746422292C743D22627574746F6E2E666C6F772D696E7374616E63652D616374696F6E732D62746E5B646174612D707263733D222B652B225D222C6E3D612E6861732874293B612E72656D6F7665436C6173732822';
wwv_flow_imp.g_varchar2_table(239) := '63757272656E742D70726F6365737322292C6E2E706172656E7428292E6368696C6472656E28292E616464436C617373282263757272656E742D70726F6365737322297D66756E6374696F6E20726566726573685669657765722865297B2277696E646F';
wwv_flow_imp.g_varchar2_table(240) := '77223D3D3D617065782E6974656D28225031305F444953504C41595F53455454494E4722292E67657456616C756528293F7265646972656374546F4D6F6E69746F722865293A617065782E726567696F6E2822666C6F772D6D6F6E69746F7222292E7265';
wwv_flow_imp.g_varchar2_table(241) := '667265736828297D66756E6374696F6E2076696577466C6F77496E7374616E636528652C61297B76617220743D617065782E6A51756572792861292E617474722822646174612D7072637322292C6E3D617065782E6A51756572792861292E6174747228';
wwv_flow_imp.g_varchar2_table(242) := '22646174612D6E616D6522293B617065782E6974656D28225031305F505243535F494422292E73657456616C75652874292C617065782E6974656D28225031305F505243535F4E414D4522292E73657456616C7565286E292C6D61726B41734375727265';
wwv_flow_imp.g_varchar2_table(243) := '6E742874292C726566726573685669657765722874297D66756E6374696F6E20696E6974416374696F6E7328297B24282866756E6374696F6E28297B76617220653D617065782E6974656D282270466C6F7753746570496422292E67657456616C756528';
wwv_flow_imp.g_varchar2_table(244) := '293B2232223D3D3D652626617065782E616374696F6E732E616464285B7B6E616D653A226E65772D666C6F772D76657273696F6E222C616374696F6E3A66756E6374696F6E28652C61297B76617220743D617065782E6A51756572792861292E61747472';
wwv_flow_imp.g_varchar2_table(245) := '2822646174612D6467726D22293B617065782E6974656D282250325F4447524D5F494422292E73657456616C75652874292C617065782E6974656D282250325F42554C4B5F414354494F4E22292E73657456616C756528224E22292C617065782E746865';
wwv_flow_imp.g_varchar2_table(246) := '6D652E6F70656E526567696F6E28226E65775F76657273696F6E5F72656722297D7D2C7B6E616D653A2262756C6B2D6E65772D666C6F772D76657273696F6E222C616374696F6E3A66756E6374696F6E28652C61297B76617220743D617065782E6A5175';
wwv_flow_imp.g_varchar2_table(247) := '6572792822696E7075745B6E616D653D6630315D3A636865636B656422292E6D6170282866756E6374696F6E28297B72657475726E20617065782E6A51756572792874686973292E61747472282276616C756522297D29292E67657428292E6A6F696E28';
wwv_flow_imp.g_varchar2_table(248) := '223A22293B617065782E6974656D282250325F4447524D5F494422292E73657456616C75652874292C617065782E6974656D282250325F42554C4B5F414354494F4E22292E73657456616C756528225922292C617065782E7468656D652E6F70656E5265';
wwv_flow_imp.g_varchar2_table(249) := '67696F6E28226E65775F76657273696F6E5F72656722297D7D2C7B6E616D653A2262756C6B2D636F70792D666C6F77222C616374696F6E3A66756E6374696F6E28652C61297B76617220743D617065782E6A51756572792822696E7075745B6E616D653D';
wwv_flow_imp.g_varchar2_table(250) := '6630315D3A636865636B656422292E6D6170282866756E6374696F6E28297B72657475726E20617065782E6A51756572792874686973292E61747472282276616C756522297D29292E67657428292E6A6F696E28223A22293B617065782E6974656D2822';
wwv_flow_imp.g_varchar2_table(251) := '50325F4447524D5F494422292E73657456616C75652874292C617065782E6974656D282250325F42554C4B5F414354494F4E22292E73657456616C756528225922292C617065782E7468656D652E6F70656E526567696F6E2822636F70795F666C6F775F';
wwv_flow_imp.g_varchar2_table(252) := '72656722297D7D2C7B6E616D653A22636F70792D666C6F77222C616374696F6E3A66756E6374696F6E28652C61297B76617220743D617065782E6A51756572792861292E617474722822646174612D6467726D22293B617065782E6974656D282250325F';
wwv_flow_imp.g_varchar2_table(253) := '4447524D5F494422292E73657456616C75652874292C617065782E6974656D282250325F42554C4B5F414354494F4E22292E73657456616C756528224E22292C617065782E7468656D652E6F70656E526567696F6E2822636F70795F666C6F775F726567';
wwv_flow_imp.g_varchar2_table(254) := '22297D7D5D292C2237223D3D3D652626617065782E616374696F6E732E616464285B7B6E616D653A2264656C6574652D666C6F772D6469616772616D222C616374696F6E3A66756E6374696F6E28652C61297B617065782E7468656D652E6F70656E5265';
wwv_flow_imp.g_varchar2_table(255) := '67696F6E282264656C6574655F72656722297D7D5D292C2238223D3D3D652626617065782E616374696F6E732E616464285B7B6E616D653A22636F6D706C6574652D73746570222C616374696F6E3A66756E6374696F6E28652C61297B636F6D706C6574';
wwv_flow_imp.g_varchar2_table(256) := '655374657028746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D636F6D706C6574652D73746570222C616374696F6E3A66756E6374696F6E28652C61297B62756C6B436F6D706C6574655374657028746869732E6E616D65297D7D2C7B';
wwv_flow_imp.g_varchar2_table(257) := '6E616D653A22726573746172742D73746570222C616374696F6E3A66756E6374696F6E28652C61297B726573746172745374657028746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D726573746172742D73746570222C616374696F6E';
wwv_flow_imp.g_varchar2_table(258) := '3A66756E6374696F6E28652C61297B62756C6B526573746172745374657028746869732E6E616D652C61297D7D2C7B6E616D653A22726573657276652D73746570222C616374696F6E3A66756E6374696F6E28652C61297B726573657276655374657028';
wwv_flow_imp.g_varchar2_table(259) := '746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D726573657276652D73746570222C616374696F6E3A66756E6374696F6E28652C61297B62756C6B526573657276655374657028746869732E6E616D65297D7D2C7B6E616D653A227265';
wwv_flow_imp.g_varchar2_table(260) := '6C656173652D73746570222C616374696F6E3A66756E6374696F6E28652C61297B72656C656173655374657028746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D72656C656173652D73746570222C616374696F6E3A66756E6374696F';
wwv_flow_imp.g_varchar2_table(261) := '6E28652C61297B62756C6B52656C656173655374657028746869732E6E616D65297D7D2C7B6E616D653A226164642D70726F636573732D7661726961626C65222C616374696F6E3A66756E6374696F6E28652C61297B61646450726F6365737356617269';
wwv_flow_imp.g_varchar2_table(262) := '61626C65282270726F636573732D7661726961626C65222C61297D7D2C7B6E616D653A227570646174652D70726F636573732D7661726961626C65222C616374696F6E3A66756E6374696F6E28652C61297B75706461746550726F636573735661726961';
wwv_flow_imp.g_varchar2_table(263) := '626C65282270726F636573732D7661726961626C65222C61297D7D2C7B6E616D653A2264656C6574652D70726F636573732D7661726961626C65222C616374696F6E3A66756E6374696F6E28652C61297B64656C65746550726F63657373566172696162';
wwv_flow_imp.g_varchar2_table(264) := '6C6528746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D64656C6574652D70726F636573732D7661726961626C65222C616374696F6E3A66756E6374696F6E28652C61297B62756C6B44656C65746550726F636573735661726961626C';
wwv_flow_imp.g_varchar2_table(265) := '6528746869732E6E616D65297D7D2C7B6E616D653A2272657363686564756C652D74696D6572222C616374696F6E3A66756E6374696F6E28652C61297B72657363686564756C6554696D657228746869732E6E616D652C61297D7D2C7B6E616D653A2262';
wwv_flow_imp.g_varchar2_table(266) := '756C6B2D72657363686564756C652D74696D6572222C616374696F6E3A66756E6374696F6E28652C61297B62756C6B52657363686564756C6554696D657228746869732E6E616D65297D7D2C7B6E616D653A22726563656976652D6D657373616765222C';
wwv_flow_imp.g_varchar2_table(267) := '616374696F6E3A66756E6374696F6E28652C61297B726563656976654D65737361676528746869732E6E616D652C61297D7D5D292C223130223D3D3D652626617065782E616374696F6E732E616464285B7B6E616D653A22766965772D666C6F772D696E';
wwv_flow_imp.g_varchar2_table(268) := '7374616E6365222C616374696F6E3A66756E6374696F6E28652C61297B76696577466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D73746172742D666C6F772D696E7374616E6365222C616374696F6E';
wwv_flow_imp.g_varchar2_table(269) := '3A66756E6374696F6E28652C61297B62756C6B5374617274466C6F77496E7374616E636528746869732E6E616D65297D7D2C7B6E616D653A2262756C6B2D72657365742D666C6F772D696E7374616E6365222C616374696F6E3A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(270) := '2C61297B62756C6B5265736574466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D7465726D696E6174652D666C6F772D696E7374616E6365222C616374696F6E3A66756E6374696F6E28652C61297B62';
wwv_flow_imp.g_varchar2_table(271) := '756C6B5465726D696E617465466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A2262756C6B2D64656C6574652D666C6F772D696E7374616E6365222C616374696F6E3A66756E6374696F6E28652C61297B62756C6B44';
wwv_flow_imp.g_varchar2_table(272) := '656C657465466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A226F70656E2D666C6F772D696E7374616E63652D64657461696C73222C616374696F6E3A66756E6374696F6E28652C61297B7265646972656374546F46';
wwv_flow_imp.g_varchar2_table(273) := '6C6F77496E7374616E636544657461696C28746869732E6E616D652C61297D7D5D292C223822213D3D65262622313022213D3D657C7C28617065782E616374696F6E732E616464285B7B6E616D653A2263686F6F73652D73657474696E67222C6765743A';
wwv_flow_imp.g_varchar2_table(274) := '66756E6374696F6E28297B72657475726E20617065782E6974656D282250222B652B225F444953504C41595F53455454494E4722292E67657456616C756528297D2C7365743A66756E6374696F6E2861297B617065782E6974656D282250222B652B225F';
wwv_flow_imp.g_varchar2_table(275) := '444953504C41595F53455454494E4722292E73657456616C75652861293B76617220743D617065782E6974656D282250222B652B225F505243535F494422292E67657456616C756528293B7377697463682861297B6361736522726F77223A617065782E';
wwv_flow_imp.g_varchar2_table(276) := '6A5175657279282223636F6C3122292E616464436C617373285B22636F6C2D3132222C22636F6C2D7374617274222C22636F6C2D656E64225D292E72656D6F7665436C6173732822636F6C2D3622292C617065782E6A5175657279282223636F6C322229';
wwv_flow_imp.g_varchar2_table(277) := '2E616464436C617373285B22636F6C2D3132222C22636F6C2D7374617274222C22636F6C2D656E64225D292E72656D6F7665436C6173732822636F6C2D3622292C617065782E6A5175657279282223666C6F772D6D6F6E69746F7222292E73686F772829';
wwv_flow_imp.g_varchar2_table(278) := '2C617065782E726567696F6E2822666C6F772D6D6F6E69746F7222292E7265667265736828293B627265616B3B6361736522636F6C756D6E223A617065782E6A5175657279282223636F6C3122292E616464436C6173732822636F6C2D3622292E72656D';
wwv_flow_imp.g_varchar2_table(279) := '6F7665436C617373285B22636F6C2D3132222C22636F6C2D656E64225D292C617065782E6A5175657279282223636F6C3222292E616464436C6173732822636F6C2D3622292E72656D6F7665436C617373285B22636F6C2D3132222C22636F6C2D737461';
wwv_flow_imp.g_varchar2_table(280) := '7274225D292C617065782E6A5175657279282223636F6C3222292E617070656E64546F28617065782E6A5175657279282223636F6C3122292E706172656E742829292C617065782E6A5175657279282223666C6F772D6D6F6E69746F7222292E73686F77';
wwv_flow_imp.g_varchar2_table(281) := '28292C617065782E726567696F6E2822666C6F772D6D6F6E69746F7222292E7265667265736828293B627265616B3B636173652277696E646F77223A617065782E6A5175657279282223666C6F772D6D6F6E69746F7222292E6869646528292C61706578';
wwv_flow_imp.g_varchar2_table(282) := '2E6A5175657279282223636F6C3122292E616464436C617373285B22636F6C2D3132222C22636F6C2D7374617274222C22636F6C2D656E64225D292E72656D6F7665436C6173732822636F6C2D3622292C617065782E6A5175657279282223636F6C3222';
wwv_flow_imp.g_varchar2_table(283) := '292E616464436C617373285B22636F6C2D3132222C22636F6C2D7374617274222C22636F6C2D656E64225D292E72656D6F7665436C6173732822636F6C2D3622292C2222213D3D7426267265646972656374546F4D6F6E69746F722874297D7D2C63686F';
wwv_flow_imp.g_varchar2_table(284) := '696365733A5B5D7D2C7B6E616D653A2273746172742D666C6F772D696E7374616E6365222C616374696F6E3A66756E6374696F6E28652C61297B7374617274466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A227265';
wwv_flow_imp.g_varchar2_table(285) := '7365742D666C6F772D696E7374616E6365222C616374696F6E3A66756E6374696F6E28652C61297B7265736574466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A227465726D696E6174652D666C6F772D696E737461';
wwv_flow_imp.g_varchar2_table(286) := '6E6365222C616374696F6E3A66756E6374696F6E28652C61297B7465726D696E617465466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A2264656C6574652D666C6F772D696E7374616E6365222C616374696F6E3A66';
wwv_flow_imp.g_varchar2_table(287) := '756E6374696F6E28652C61297B64656C657465466C6F77496E7374616E636528746869732E6E616D652C61297D7D2C7B6E616D653A22646F776E6C6F61642D61732D737667222C616374696F6E3A66756E6374696F6E28652C61297B646F776E6C6F6164';
wwv_flow_imp.g_varchar2_table(288) := '417353564728297D7D2C7B6E616D653A22666C6F772D696E7374616E63652D6175646974222C616374696F6E3A66756E6374696F6E28652C61297B7265646972656374546F466C6F77496E7374616E6365417564697428746869732E6E616D652C61297D';
wwv_flow_imp.g_varchar2_table(289) := '7D5D292C617065782E616374696F6E732E736574282263686F6F73652D73657474696E67222C617065782E6974656D282250222B652B225F444953504C41595F53455454494E4722292E67657456616C75652829292C73657454696D656F757428286675';
wwv_flow_imp.g_varchar2_table(290) := '6E6374696F6E28297B76617220653B28653D617065782E616374696F6E732E6C6F6F6B7570282263686F6F73652D73657474696E672229292E63686F696365733D652E6C6162656C2E73706C697428227C22292E6D6170282866756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(291) := '61297B72657475726E7B6C6162656C3A652C76616C75653A5B22726F77222C22636F6C756D6E222C2277696E646F77225D5B615D7D7D29292C64656C65746520652E6C6162656C2C617065782E616374696F6E732E757064617465282263686F6F73652D';
wwv_flow_imp.g_varchar2_table(292) := '73657474696E6722297D292C3129292C617065782E616374696F6E732E616464285B7B6E616D653A22656469742D666C6F772D6469616772616D222C616374696F6E3A66756E6374696F6E28652C61297B7265646972656374546F466C6F774469616772';
wwv_flow_imp.g_varchar2_table(293) := '616D28746869732E6E616D652C61297D7D5D297D29297D66756E6374696F6E20696E6974506167653228297B696E697441707028292C696E6974416374696F6E7328292C617065782E6A51756572792877696E646F77292E6F6E28227468656D65343272';
wwv_flow_imp.g_varchar2_table(294) := '65616479222C2866756E6374696F6E28297B242822237061727365645F6472676D207461626C652074682E612D4952522D6865616465722D2D67726F757022292E617474722822636F6C7370616E222C223622292E616674657228273C746820636F6C73';
wwv_flow_imp.g_varchar2_table(295) := '70616E3D22352220636C6173733D22612D4952522D68656164657220612D4952522D6865616465722D2D67726F7570222069643D22696E7374616E6365735F636F6C756D6E5F67726F75705F68656164696E6722207374796C653D22746578742D616C69';
wwv_flow_imp.g_varchar2_table(296) := '676E3A2063656E7465723B223E496E7374616E6365733C2F74683E27292C2428222E612D4952522D6865616465724C6162656C2C202E612D4952522D6865616465724C696E6B22292E65616368282866756E6374696F6E28297B76617220653D24287468';
wwv_flow_imp.g_varchar2_table(297) := '6973292E6368696C6472656E28226922292E64617461282273746174757322293B2263726561746564223D3D653F242874686973292E706172656E7428292E616464436C61737328226666612D636F6C6F722D2D6372656174656422293A22636F6D706C';
wwv_flow_imp.g_varchar2_table(298) := '65746564223D3D653F242874686973292E706172656E7428292E616464436C61737328226666612D636F6C6F722D2D636F6D706C6574656422293A2272756E6E696E67223D3D653F242874686973292E706172656E7428292E616464436C617373282266';
wwv_flow_imp.g_varchar2_table(299) := '66612D636F6C6F722D2D72756E6E696E6722293A227465726D696E61746564223D3D653F242874686973292E706172656E7428292E616464436C61737328226666612D636F6C6F722D2D7465726D696E6174656422293A226572726F72223D3D65262624';
wwv_flow_imp.g_varchar2_table(300) := '2874686973292E706172656E7428292E616464436C61737328226666612D636F6C6F722D2D6572726F7222297D29292C24282274682E612D4952522D6865616465722D2D67726F757022292E6C656E6774683E302626242822746822292E656163682828';
wwv_flow_imp.g_varchar2_table(301) := '66756E6374696F6E2865297B766F696420303D3D3D617065782E6A51756572792874686973292E617474722822696422293F28617065782E6A51756572792874686973292E66696E642827696E7075745B747970653D22636865636B626F78225D27292E';
wwv_flow_imp.g_varchar2_table(302) := '6869646528292C617065782E6A51756572792874686973292E66696E642822627574746F6E236865616465722D616374696F6E22292E686964652829293A617065782E6A51756572792874686973292E616464436C6173732822752D616C69676E4D6964';
wwv_flow_imp.g_varchar2_table(303) := '646C6522297D29292C242822236865616465725F616374696F6E735F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D612E6D656E752E6974656D733B303D3D3D617065782E6A51';
wwv_flow_imp.g_varchar2_table(304) := '756572792822237061727365645F6472676D5F6972202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B747970653D22636865636B626F78225D3A636865636B656427292E6C656E6774683F743D742E6D617028';
wwv_flow_imp.g_varchar2_table(305) := '2866756E6374696F6E2865297B72657475726E227265667265736822213D3D652E616374696F6E262628652E64697361626C65643D2130292C657D29293A28743D742E6D6170282866756E6374696F6E2865297B72657475726E22726566726573682221';
wwv_flow_imp.g_varchar2_table(306) := '3D3D652E616374696F6E262628652E64697361626C65643D2131292C657D29292C617065782E6A51756572792822237061727365645F6472676D5F6972202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B7479';
wwv_flow_imp.g_varchar2_table(307) := '70653D22636865636B626F78225D3A636865636B656427292E65616368282866756E6374696F6E28297B76617220653D242874686973292E6461746128226E616D6522293B696628617065782E6A51756572792822237061727365645F6472676D5F6972';
wwv_flow_imp.g_varchar2_table(308) := '202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B747970653D22636865636B626F78225D5B646174612D6E616D653D22272B652B27225D3A636865636B656427292E6C656E6774683E312972657475726E2074';
wwv_flow_imp.g_varchar2_table(309) := '3D742E6D6170282866756E6374696F6E2865297B72657475726E2262756C6B2D6E65772D666C6F772D76657273696F6E22213D3D652E616374696F6E26262262756C6B2D636F70792D666C6F7722213D3D652E616374696F6E7C7C28652E64697361626C';
wwv_flow_imp.g_varchar2_table(310) := '65643D2130292C657D29292C21317D2929292C612E6D656E752E6974656D733D747D29297D29297D66756E6374696F6E20696E6974506167653328297B696E697441707028292C617065782E6A51756572792877696E646F77292E6F6E28227468656D65';
wwv_flow_imp.g_varchar2_table(311) := '34327265616479222C2866756E6374696F6E28297B616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D2263726561746564225D272C227370616E2E742D42616467654C6973742D77726170222C226666612D';
wwv_flow_imp.g_varchar2_table(312) := '636F6C6F722D2D6372656174656422292C616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D2272756E6E696E67225D272C227370616E2E742D42616467654C6973742D77726170222C226666612D636F6C6F';
wwv_flow_imp.g_varchar2_table(313) := '722D2D72756E6E696E6722292C616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D22636F6D706C65746564225D272C227370616E2E742D42616467654C6973742D77726170222C226666612D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(314) := '2D636F6D706C6574656422292C616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D227465726D696E61746564225D272C227370616E2E742D42616467654C6973742D77726170222C226666612D636F6C6F72';
wwv_flow_imp.g_varchar2_table(315) := '2D2D7465726D696E6174656422292C616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D226572726F72225D272C227370616E2E742D42616467654C6973742D77726170222C226666612D636F6C6F722D2D65';
wwv_flow_imp.g_varchar2_table(316) := '72726F7222297D29297D66756E6374696F6E20696E6974506167653428297B696E697441707028292C242877696E646F77292E62696E6428226B6579646F776E222C2866756E6374696F6E2865297B28652E6374726C4B65797C7C652E6D6574614B6579';
wwv_flow_imp.g_varchar2_table(317) := '2926262273223D3D3D537472696E672E66726F6D43686172436F646528652E7768696368292E746F4C6F776572436173652829262628652E70726576656E7444656661756C7428292C617065782E726567696F6E28226D6F64656C657222292E73617665';
wwv_flow_imp.g_varchar2_table(318) := '2829297D29297D66756E6374696F6E20696E6974506167653728297B696E6974416374696F6E7328292C617065782E6A51756572792877696E646F77292E6F6E28227468656D6534327265616479222C2866756E6374696F6E28297B616464436C617373';
wwv_flow_imp.g_varchar2_table(319) := '6573546F506172656E747328277370616E5B646174612D7374617475733D2263726561746564225D272C227370616E2E742D42616467654C6973742D76616C7565222C5B226666612D636F6C6F722D2D63726561746564222C22696E7374616E63652D63';
wwv_flow_imp.g_varchar2_table(320) := '6F756E7465722D6C696E6B225D292C616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D2272756E6E696E67225D272C227370616E2E742D42616467654C6973742D76616C7565222C5B226666612D636F6C6F';
wwv_flow_imp.g_varchar2_table(321) := '722D2D72756E6E696E67222C22696E7374616E63652D636F756E7465722D6C696E6B225D292C616464436C6173736573546F506172656E747328277370616E5B646174612D7374617475733D22636F6D706C65746564225D272C227370616E2E742D4261';
wwv_flow_imp.g_varchar2_table(322) := '6467654C6973742D76616C7565222C5B226666612D636F6C6F722D2D636F6D706C65746564222C22696E7374616E63652D636F756E7465722D6C696E6B225D292C616464436C6173736573546F506172656E747328277370616E5B646174612D73746174';
wwv_flow_imp.g_varchar2_table(323) := '75733D227465726D696E61746564225D272C227370616E2E742D42616467654C6973742D76616C7565222C5B226666612D636F6C6F722D2D7465726D696E61746564222C22696E7374616E63652D636F756E7465722D6C696E6B225D292C616464436C61';
wwv_flow_imp.g_varchar2_table(324) := '73736573546F506172656E747328277370616E5B646174612D7374617475733D226572726F72225D272C227370616E2E742D42616467654C6973742D76616C7565222C5B226666612D636F6C6F722D2D6572726F72222C22696E7374616E63652D636F75';
wwv_flow_imp.g_varchar2_table(325) := '6E7465722D6C696E6B225D292C24282223616374696F6E735F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D612E6D656E752E6974656D732C6E3D617065782E6974656D282250';
wwv_flow_imp.g_varchar2_table(326) := '375F4447524D5F53544154555322292E67657456616C756528292C693D617065782E6974656D282250375F454E47494E455F4150505F4D4F444522292E67657456616C756528293B743D742E6D6170282866756E6374696F6E2865297B72657475726E22';
wwv_flow_imp.g_varchar2_table(327) := '64656C6574652D666C6F772D6469616772616D223D3D3D652E616374696F6E262628652E64697361626C65643D22647261667422213D3D6E262622617263686976656422213D3D6E262622646576656C6F706D656E7422213D3D69292C657D29292C612E';
wwv_flow_imp.g_varchar2_table(328) := '6D656E752E6974656D733D747D29297D29297D66756E6374696F6E20696E6974506167653828297B696E697441707028292C696E6974416374696F6E7328292C617065782E6A51756572792877696E646F77292E6F6E28227468656D6534327265616479';
wwv_flow_imp.g_varchar2_table(329) := '222C2866756E6374696F6E28297B24282274682E612D4952522D68656164657222292E65616368282866756E6374696F6E2865297B766F696420303D3D3D617065782E6A51756572792874686973292E617474722822696422293F28617065782E6A5175';
wwv_flow_imp.g_varchar2_table(330) := '6572792874686973292E66696E642827696E7075745B747970653D22636865636B626F78225D27292E6869646528292C617065782E6A51756572792874686973292E66696E642822627574746F6E23737562666C6F772D6865616465722D616374696F6E';
wwv_flow_imp.g_varchar2_table(331) := '22292E686964652829293A617065782E6A51756572792874686973292E616464436C6173732822752D616C69676E4D6964646C6522297D29293B76617220653D617065782E6974656D282250385F505243535F53544154555322292E67657456616C7565';
wwv_flow_imp.g_varchar2_table(332) := '28293B2263726561746564223D3D3D653F28617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D33372D616C65';
wwv_flow_imp.g_varchar2_table(333) := '72742D74657874222C226661222C2266612D706C75732D636972636C652D6F225D292C617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464';
wwv_flow_imp.g_varchar2_table(334) := '436C6173732822752D636F6C6F722D33372D616C6572742D62672229293A2272756E6E696E67223D3D3D653F28617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22';
wwv_flow_imp.g_varchar2_table(335) := '292E616464436C617373285B22752D636F6C6F722D33352D616C6572742D74657874222C226661222C2266612D706C61792D636972636C652D6F225D292C617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66';
wwv_flow_imp.g_varchar2_table(336) := '696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F722D33352D616C6572742D62672229293A22636F6D706C65746564223D3D3D653F28617065782E6A5175657279282223666C6F772D696E7374616E63';
wwv_flow_imp.g_varchar2_table(337) := '652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D34342D616C6572742D74657874222C226661222C2266612D636865636B2D636972636C652D6F225D292C617065782E6A5175';
wwv_flow_imp.g_varchar2_table(338) := '657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F722D34342D616C6572742D62672229293A227465726D696E61746564223D';
wwv_flow_imp.g_varchar2_table(339) := '3D3D653F28617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B22752D636F6C6F722D33382D616C6572742D74657874222C22666122';
wwv_flow_imp.g_varchar2_table(340) := '2C2266612D73746F702D636972636C652D6F225D292C617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F';
wwv_flow_imp.g_varchar2_table(341) := '722D33382D616C6572742D62672229293A226572726F72223D3D3D65262628617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428227370616E2E742D49636F6E22292E616464436C617373285B2275';
wwv_flow_imp.g_varchar2_table(342) := '2D636F6C6F722D33392D616C6572742D74657874222C226661222C2266612D6578636C616D6174696F6E2D636972636C652D6F225D292C617065782E6A5175657279282223666C6F772D696E7374616E63652D64657461696C22292E66696E6428226469';
wwv_flow_imp.g_varchar2_table(343) := '762E742D416C6572742D69636F6E22292E616464436C6173732822752D636F6C6F722D33392D616C6572742D62672229292C24282223616374696F6E735F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(344) := '2C61297B76617220743D612E6D656E752E6974656D732C6E3D617065782E6974656D282250385F505243535F53544154555322292E67657456616C756528293B743D742E6D6170282866756E6374696F6E2865297B72657475726E2273746172742D666C';
wwv_flow_imp.g_varchar2_table(345) := '6F772D696E7374616E6365223D3D3D652E616374696F6E262628652E64697361626C65643D226372656174656422213D3D6E292C2272657365742D666C6F772D696E7374616E6365223D3D3D652E616374696F6E262628652E64697361626C65643D2263';
wwv_flow_imp.g_varchar2_table(346) := '726561746564223D3D3D6E292C227465726D696E6174652D666C6F772D696E7374616E6365223D3D3D652E616374696F6E262628652E64697361626C65643D2272756E6E696E6722213D3D6E2626226572726F7222213D3D6E292C657D29292C612E6D65';
wwv_flow_imp.g_varchar2_table(347) := '6E752E6974656D733D747D29292C24282223737562666C6F775F6865616465725F616374696F6E5F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D612E6D656E752E6974656D73';
wwv_flow_imp.g_varchar2_table(348) := '3B743D742E6D6170282866756E6374696F6E2865297B72657475726E20303D3D3D617065782E6A51756572792827696E7075745B6E616D653D22663032225D3A636865636B656427292E6C656E6774683F652E64697361626C65643D21303A28652E6469';
wwv_flow_imp.g_varchar2_table(349) := '7361626C65643D21312C2262756C6B2D636F6D706C6574652D73746570223D3D3D652E616374696F6E2626617065782E6A5175657279282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075';
wwv_flow_imp.g_varchar2_table(350) := '745B6E616D653D22663032225D5B646174612D737461747573213D2272756E6E696E67225D3A636865636B656427292E6C656E6774683E30262628652E64697361626C65643D2130292C2262756C6B2D726573746172742D73746570223D3D3D652E6163';
wwv_flow_imp.g_varchar2_table(351) := '74696F6E2626617065782E6A5175657279282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B6E616D653D22663032225D5B646174612D737461747573213D226572726F72225D3A63';
wwv_flow_imp.g_varchar2_table(352) := '6865636B656427292E6C656E6774683E30262628652E64697361626C65643D2130292C2262756C6B2D726573657276652D73746570223D3D3D652E616374696F6E262628617065782E6A5175657279282223737562666C6F7773202E612D4952522D7461';
wwv_flow_imp.g_varchar2_table(353) := '626C65436F6E7461696E657222292E66696E642827696E7075745B6E616D653D22663032225D5B646174612D7265736572766174696F6E213D22225D3A636865636B656427292E6C656E6774683E307C7C617065782E6A5175657279282223737562666C';
wwv_flow_imp.g_varchar2_table(354) := '6F7773202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B6E616D653D22663032225D5B646174612D737461747573213D2272756E6E696E67225D3A636865636B656427292E6C656E6774683E3029262628652E';
wwv_flow_imp.g_varchar2_table(355) := '64697361626C65643D2130292C2262756C6B2D72656C656173652D73746570223D3D3D652E616374696F6E2626617065782E6A5175657279282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E';
wwv_flow_imp.g_varchar2_table(356) := '7075745B6E616D653D22663032225D5B646174612D7265736572766174696F6E3D22225D3A636865636B656427292E6C656E6774683E30262628652E64697361626C65643D2130292C2262756C6B2D72657363686564756C652D74696D6572223D3D3D65';
wwv_flow_imp.g_varchar2_table(357) := '2E616374696F6E2626617065782E6A5175657279282223737562666C6F7773202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B6E616D653D22663032225D5B646174612D737461747573213D2277616974696E';
wwv_flow_imp.g_varchar2_table(358) := '6720666F722074696D6572225D3A636865636B656427292E6C656E6774683E30262628652E64697361626C65643D213029292C657D29292C612E6D656E752E6974656D733D747D29292C617065782E6A5175657279282223737562666C6F775F726F775F';
wwv_flow_imp.g_varchar2_table(359) := '616374696F6E5F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D617065782E6A517565727928222E737562666C6F772D616374696F6E732D62746E2E69732D6163746976652229';
wwv_flow_imp.g_varchar2_table(360) := '2C6E3D612E6D656E752E6974656D732C693D742E64617461282273746174757322292C733D742E6461746128227265736572766174696F6E22293B6E3D6E2E6D6170282866756E6374696F6E2865297B72657475726E22636F6D706C6574652D73746570';
wwv_flow_imp.g_varchar2_table(361) := '223D3D3D652E616374696F6E262628652E64697361626C65643D2272756E6E696E6722213D3D69292C22726573746172742D73746570223D3D3D652E616374696F6E262628652E64697361626C65643D226572726F7222213D3D69292C22726573657276';
wwv_flow_imp.g_varchar2_table(362) := '652D73746570223D3D3D652E616374696F6E262628652E64697361626C65643D2222213D3D737C7C2272756E6E696E6722213D3D69292C2272656C656173652D73746570223D3D3D652E616374696F6E262628652E64697361626C65643D22223D3D3D73';
wwv_flow_imp.g_varchar2_table(363) := '7C7C2272756E6E696E6722213D3D69292C2272657363686564756C652D74696D6572223D3D3D652E616374696F6E262628652E64697361626C65643D2277616974696E6720666F722074696D657222213D3D69292C657D29292C612E6D656E752E697465';
wwv_flow_imp.g_varchar2_table(364) := '6D733D6E7D29292C617065782E6A51756572792822237661726961626C655F6865616465725F616374696F6E5F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D612E6D656E752E';
wwv_flow_imp.g_varchar2_table(365) := '6974656D733B743D742E6D6170282866756E6374696F6E2865297B72657475726E20303D3D3D617065782E6A51756572792827696E7075745B6E616D653D22663033225D3A636865636B656427292E6C656E6774683F652E64697361626C65643D21303A';
wwv_flow_imp.g_varchar2_table(366) := '652E64697361626C65643D21312C657D29292C612E6D656E752E6974656D733D747D29297D29297D66756E6374696F6E20696E697450616765313028297B696E697441707028292C696E6974416374696F6E7328292C617065782E6A5175657279287769';
wwv_flow_imp.g_varchar2_table(367) := '6E646F77292E6F6E28227468656D6534327265616479222C2866756E6374696F6E28297B24282274682E612D4952522D6865616465722D2D67726F757022292E6C656E6774683E30262624282274682E612D4952522D68656164657222292E6561636828';
wwv_flow_imp.g_varchar2_table(368) := '2866756E6374696F6E2865297B766F696420303D3D3D617065782E6A51756572792874686973292E617474722822696422293F28617065782E6A51756572792874686973292E66696E642827696E7075745B747970653D22636865636B626F78225D2729';
wwv_flow_imp.g_varchar2_table(369) := '2E6869646528292C617065782E6A51756572792874686973292E66696E642822627574746F6E23696E7374616E63652D6865616465722D616374696F6E22292E686964652829293A617065782E6A51756572792874686973292E616464436C6173732822';
wwv_flow_imp.g_varchar2_table(370) := '752D616C69676E4D6964646C6522297D29292C24282223616374696F6E735F6D656E7522292E6F6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D612E6D656E752E6974656D733B745B315D2E646973';
wwv_flow_imp.g_varchar2_table(371) := '61626C65643D22223D3D3D617065782E6974656D28225031305F505243535F494422292E67657456616C756528292C612E6D656E752E6974656D733D747D29292C24282223696E7374616E63655F6865616465725F616374696F6E5F6D656E7522292E6F';
wwv_flow_imp.g_varchar2_table(372) := '6E28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D612E6D656E752E6974656D733B743D742E6D6170282866756E6374696F6E2865297B72657475726E20303D3D3D617065782E6A51756572792827696E';
wwv_flow_imp.g_varchar2_table(373) := '7075745B6E616D653D22663031225D3A636865636B656427292E6C656E6774683F652E64697361626C65643D21303A28652E64697361626C65643D21312C2262756C6B2D73746172742D666C6F772D696E7374616E6365223D3D3D652E616374696F6E26';
wwv_flow_imp.g_varchar2_table(374) := '26617065782E6A5175657279282223666C6F772D696E7374616E636573202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B6E616D653D22663031225D5B646174612D737461747573213D226372656174656422';
wwv_flow_imp.g_varchar2_table(375) := '5D3A636865636B656427292E6C656E6774683E30262628652E64697361626C65643D2130292C2262756C6B2D72657365742D666C6F772D696E7374616E6365223D3D3D652E616374696F6E2626617065782E6A5175657279282223666C6F772D696E7374';
wwv_flow_imp.g_varchar2_table(376) := '616E636573202E612D4952522D7461626C65436F6E7461696E657222292E66696E642827696E7075745B6E616D653D22663031225D5B646174612D7374617475733D2263726561746564225D3A636865636B656427292E6C656E6774683E30262628652E';
wwv_flow_imp.g_varchar2_table(377) := '64697361626C65643D2130292C2262756C6B2D7465726D696E6174652D666C6F772D696E7374616E6365223D3D3D652E616374696F6E2626617065782E6A5175657279282223666C6F772D696E7374616E636573202E612D4952522D7461626C65436F6E';
wwv_flow_imp.g_varchar2_table(378) := '7461696E657222292E66696E642827696E7075745B6E616D653D22663031225D5B646174612D737461747573213D2272756E6E696E67225D3A636865636B6564272C27696E7075745B6E616D653D22663031225D5B646174612D737461747573213D2265';
wwv_flow_imp.g_varchar2_table(379) := '72726F72225D3A636865636B656427292E6C656E6774683E30262628652E64697361626C65643D213029292C657D29292C612E6D656E752E6974656D733D747D29292C24282223696E7374616E63655F726F775F616374696F6E5F6D656E7522292E6F6E';
wwv_flow_imp.g_varchar2_table(380) := '28226D656E756265666F72656F70656E222C2866756E6374696F6E28652C61297B76617220743D617065782E6A517565727928222E666C6F772D696E7374616E63652D616374696F6E732D62746E2E69732D61637469766522292C6E3D612E6D656E752E';
wwv_flow_imp.g_varchar2_table(381) := '6974656D732C693D742E64617461282273746174757322292C733D742E617474722822646174612D7072637322293B6E3D6E2E6D6170282866756E6374696F6E2865297B72657475726E2273746172742D666C6F772D696E7374616E6365223D3D3D652E';
wwv_flow_imp.g_varchar2_table(382) := '616374696F6E262628652E64697361626C65643D226372656174656422213D3D69292C2272657365742D666C6F772D696E7374616E6365223D3D3D652E616374696F6E262628652E64697361626C65643D2263726561746564223D3D3D69292C22746572';
wwv_flow_imp.g_varchar2_table(383) := '6D696E6174652D666C6F772D696E7374616E6365223D3D3D652E616374696F6E262628652E64697361626C65643D2272756E6E696E6722213D3D692626226572726F7222213D3D69292C22646F776E6C6F61642D61732D737667223D3D3D652E61637469';
wwv_flow_imp.g_varchar2_table(384) := '6F6E262628652E64697361626C65643D73213D3D617065782E6974656D28225031305F505243535F494422292E67657456616C75652829292C657D29292C612E6D656E752E6974656D733D6E7D29297D29297D66756E6374696F6E206368616E67654375';
wwv_flow_imp.g_varchar2_table(385) := '72736F722865297B76617220613D652E73706C697428223A22293B242E6561636828612C2866756E6374696F6E28652C61297B2428225B646174612D656C656D656E742D69643D27222B612B22275D22292E6373732822637572736F72222C22706F696E';
wwv_flow_imp.g_varchar2_table(386) := '74657222297D29297D66756E6374696F6E20636C69636B436F6E646974696F6E28652C61297B72657475726E212821652E73706C697428223A22292E696E636C7564657328612E656C656D656E742E6964297C7C2262706D6E3A43616C6C416374697669';
wwv_flow_imp.g_varchar2_table(387) := '7479223D3D612E656C656D656E742E747970652626282270617468223D3D612E6F726967696E616C4576656E742E7461726765742E7461674E616D657C7C612E6F726967696E616C4576656E742E7461726765742E676574417474726962757465282274';
wwv_flow_imp.g_varchar2_table(388) := '72616E73666F726D222929297D66756E6374696F6E206F70656E4F626A6563744469616C6F6728652C612C74297B766172206E3D652B28612E6C656E6774683E303F22202D20222B613A2222293B617065782E7365727665722E70726F63657373282247';
wwv_flow_imp.g_varchar2_table(389) := '45545F55524C222C7B7830313A652C7830323A6E2C706167654974656D733A5B6050247B747D5F4C4F414445445F4449414752414D605D7D2C7B737563636573733A66756E6374696F6E2865297B617065782E6E617669676174696F6E2E726564697265';
wwv_flow_imp.g_varchar2_table(390) := '63742865297D2C64617461547970653A2274657874227D297D';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(15834189710706142)
,p_file_name=>'js/flows4apex.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/app_100_logo_png
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000300000003008060000005702F987000000097048597300002137000021370133589F7A0000014D494441546881ED9AEB0DC22014854F8DFF75948ED051D84C47E9088E8213601AA5A90D52B85C5EC24930';
wwv_flow_imp.g_varchar2_table(2) := 'D6C7E57CC005A40E4A2944D60860067061A8E6096002F0D02FA400904CE6B51688ABBE480110A382413F394708EE543141C68638A5721E4B3E3D306EC75E6D0002C02DB217925C93982B11B972608DD3540E68F9B662D479BAFA1EE800B9D5048038B8CE';
wwv_flow_imp.g_varchar2_table(3) := 'AB651DB014A1CC1207DFDB96185AE353CC6BB942486600E90260327F27428C8C10F213CF0A60322F1CDECB527CCCFB7C2659A11A2B0622C4501110A146B2432C0F73A0813DC49C12A0FAADC45F0C21AA9162929862A8B869D4C758B10B998BC1E2B71236';
wwv_flow_imp.g_varchar2_table(4) := '886A367336084ACB67D94E1F4154F183E61784EF9837564C28C63894A3C59083AD7EB4B85707C82DCAE1EE54124033F7079E011547952BC0542A44EAFBC47D1DD8ABC9693444ECE335450F7027FF57BC14009C3398FEBBCD5B005EB84A5E5D09CFBB1C00';
wwv_flow_imp.g_varchar2_table(5) := '00000049454E44AE426082';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(16924045360692548)
,p_file_name=>'app-100-logo.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/favicon_png
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '89504E470D0A1A0A0000000D494844520000002D0000003008060000008552F3DF000000097048597300002C4A00002C4A01777A744D0000001974455874536F667477617265007777772E696E6B73636170652E6F72679BEE3C1A000002464944415468';
wwv_flow_imp.g_varchar2_table(2) := '81ED994D6ED3401840DF0C7FDB2AB0C71107681BC4091A1027E896032021216439270057A97A112E8048720224D20B509B3D44DDB048161E16B1B14D6A676CCD4C9CAA6F954C3CE3A7F137DF8CBF086C338A3EA2F8003C3430DA0AD4B93030503D41B4C4';
wwv_flow_imp.g_varchar2_table(3) := '8C70C6521A1CAC0A93C2008FEE1B1EB09EB37EFB271B442AFBE862A68DB397D27AE1114417C03BE09E551B4D7467FA2D1D11067DE907562D1AD23C7B9C791284DA7E614A61D59B622F17E29DB42B6EA9B41F0F807CFBF57F1E5BF4D1A2FE2CE0474748A6';
wwv_flow_imp.g_varchar2_table(4) := 'C0E342EB35227945F8EC9BD61D9C660F3F1E20995116063840C92FE913D061D556AE828AA3A91F0F906A02F4D29605A837C0EFF47B0FA9267AE2EA1C73E22BC44D2F019B21918743707508720AEAC9C66F0E294BD709677440BC901534843382AB431033';
wwv_flow_imp.g_varchar2_table(5) := 'AD6B2D201A0B67B4E96308C1283E46A929C5459788978CBDEF5B7BDFD4578821A137B7E40B8044A9CFB4110608BD39420C8145DAD24BC7B34AB363A616A6C7DB442238A53853DAF9978AF0E0D482670949E8CD4938A1BC71CC18FD7851DBD38F8E50A50D';
wwv_flow_imp.g_varchar2_table(6) := 'E81A91BCB61DCFD036E5ED3073409BCD65C7C2F0FF8169DCBF246108E257DA7280925FFF854A0784A1EA68BA5E601372B905A8F7202E4A6D3AE9D169D57453BC887E3E775A350DBD39A89342A864ACB384EE0664A16ABABD8AB98EE33C8D25E27903E1F2';
wwv_flow_imp.g_varchar2_table(7) := '9B8BB3AAE9B87F09E4371E3FB59E87B7714BDFC63BC89DB42B9A574D833881C8828A3EBA33BDB46AD1105DE94FC01F9B224D70F1E7E70E36970EB297D26EC3C3102E66DA51D5D428E6ABA67F012AB6087585D15BAF0000000049454E44AE426082';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(16925863151714032)
,p_file_name=>'favicon.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_dark_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D22696E7374616E63655F7374617475735F636F6C225D29207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E';
wwv_flow_imp.g_varchar2_table(2) := '3134292021696D706F7274616E743B0D0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(17904413161090630)
,p_file_name=>'css/flows4apex.dark.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_dark_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D696E7374616E63655F7374617475735F636F6C5D297B6261636B67726F756E642D636F6C6F723A72676261283235352C3235352C3235352C2E31342921696D706F7274616E';
wwv_flow_imp.g_varchar2_table(2) := '747D0A2F2A2320736F757263654D617070696E6755524C3D666C6F777334617065782E6461726B2E6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(17905049977092217)
,p_file_name=>'css/flows4apex.dark.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_dark_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E6461726B2E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414141412C412C7142414171422C2B422C4341436E422C6744222C226669';
wwv_flow_imp.g_varchar2_table(2) := '6C65223A22666C6F777334617065782E6461726B2E637373222C22736F7572636573436F6E74656E74223A5B222E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D5C22696E7374616E63655F7374617475735F636F6C5C225D';
wwv_flow_imp.g_varchar2_table(3) := '29207B5C725C6E20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3134292021696D706F7274616E743B5C725C6E7D225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(17905378289092218)
,p_file_name=>'css/flows4apex.dark.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_light_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D696E7374616E63655F7374617475735F636F6C5D297B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C302C302C2E312921696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(2) := '0D0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(17905784119093999)
,p_file_name=>'css/flows4apex.light.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_light_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D696E7374616E63655F7374617475735F636F6C5D297B6261636B67726F756E642D636F6C6F723A7267626128302C302C302C2E312921696D706F7274616E747D0A2F2A2320';
wwv_flow_imp.g_varchar2_table(2) := '736F757263654D617070696E6755524C3D666C6F777334617065782E6C696768742E6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(17906322031094625)
,p_file_name=>'css/flows4apex.light.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_flows4apex_light_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E6C696768742E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414141412C412C7142414171422C2B422C4341436E422C7943222C2266';
wwv_flow_imp.g_varchar2_table(2) := '696C65223A22666C6F777334617065782E6C696768742E637373222C22736F7572636573436F6E74656E74223A5B222E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D696E7374616E63655F7374617475735F636F6C5D297B';
wwv_flow_imp.g_varchar2_table(3) := '5C725C6E20206261636B67726F756E642D636F6C6F723A207267626128302C302C302C2E312921696D706F7274616E743B5C725C6E7D225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(17906637125094626)
,p_file_name=>'css/flows4apex.light.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_1_flows4apex_dark_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D63726561746564202E742D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A202334363334303021696D706F7274616E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D636F6D706C65746564202E74';
wwv_flow_imp.g_varchar2_table(2) := '2D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A202332383361346421696D706F7274616E743B0D0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18105510024371205)
,p_file_name=>'css/21.1/flows4apex.dark.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_1_flows4apex_dark_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D63726561746564202E742D42616467654C6973742D6C6162656C7B636F6C6F723A2334363334303021696D706F7274616E747D2E6666612D636F6C6F722D2D636F6D706C65746564202E742D42616467654C6973742D6C61';
wwv_flow_imp.g_varchar2_table(2) := '62656C7B636F6C6F723A2332383361346421696D706F7274616E747D0A2F2A2320736F757263654D617070696E6755524C3D666C6F777334617065782E6461726B2E6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18106106010373782)
,p_file_name=>'css/21.1/flows4apex.dark.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_1_flows4apex_dark_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E6461726B2E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414141412C73432C434143452C75422C434147462C77432C434143452C75';
wwv_flow_imp.g_varchar2_table(2) := '42222C2266696C65223A22666C6F777334617065782E6461726B2E637373222C22736F7572636573436F6E74656E74223A5B222E6666612D636F6C6F722D2D63726561746564202E742D42616467654C6973742D6C6162656C207B5C725C6E2020636F6C';
wwv_flow_imp.g_varchar2_table(3) := '6F723A202334363334303021696D706F7274616E743B5C725C6E7D5C725C6E5C725C6E2E6666612D636F6C6F722D2D636F6D706C65746564202E742D42616467654C6973742D6C6162656C207B5C725C6E2020636F6C6F723A202332383361346421696D';
wwv_flow_imp.g_varchar2_table(4) := '706F7274616E743B5C725C6E7D225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18106414269373783)
,p_file_name=>'css/21.1/flows4apex.dark.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_1_flows4apex_light_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D72756E6E696E67202E742D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20776869746521696D706F7274616E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D7465726D696E61746564202E742D';
wwv_flow_imp.g_varchar2_table(2) := '42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20776869746521696D706F7274616E743B0D0A7D0D0A0D0A2E6666612D636F6C6F722D2D6572726F72202E742D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(3) := '776869746521696D706F7274616E743B0D0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18106877801374789)
,p_file_name=>'css/21.1/flows4apex.light.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_1_flows4apex_light_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D6572726F72202E742D42616467654C6973742D6C6162656C2C2E6666612D636F6C6F722D2D72756E6E696E67202E742D42616467654C6973742D6C6162656C2C2E6666612D636F6C6F722D2D7465726D696E61746564202E';
wwv_flow_imp.g_varchar2_table(2) := '742D42616467654C6973742D6C6162656C7B636F6C6F723A2366666621696D706F7274616E747D0A2F2A2320736F757263654D617070696E6755524C3D666C6F777334617065782E6C696768742E6373732E6D61702A2F';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18107437347376260)
,p_file_name=>'css/21.1/flows4apex.light.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_1_flows4apex_light_css_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22666C6F777334617065782E6C696768742E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414151412C6F432C434152412C73432C434149412C79432C434148452C';
wwv_flow_imp.g_varchar2_table(2) := '6F42222C2266696C65223A22666C6F777334617065782E6C696768742E637373222C22736F7572636573436F6E74656E74223A5B222E6666612D636F6C6F722D2D72756E6E696E67202E742D42616467654C6973742D6C6162656C207B5C725C6E202063';
wwv_flow_imp.g_varchar2_table(3) := '6F6C6F723A20776869746521696D706F7274616E743B5C725C6E7D5C725C6E5C725C6E2E6666612D636F6C6F722D2D7465726D696E61746564202E742D42616467654C6973742D6C6162656C207B5C725C6E2020636F6C6F723A20776869746521696D70';
wwv_flow_imp.g_varchar2_table(4) := '6F7274616E743B5C725C6E7D5C725C6E5C725C6E2E6666612D636F6C6F722D2D6572726F72202E742D42616467654C6973742D6C6162656C207B5C725C6E2020636F6C6F723A20776869746521696D706F7274616E743B5C725C6E7D225D7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18107777094376261)
,p_file_name=>'css/21.1/flows4apex.light.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_20_2_flows4apex_dark_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A427574746F6E20696E20466C6F7720456469742070616765206E65787420746F2076657273696F6E20616E6420737461747573206669656C732A2F0D0A0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F';
wwv_flow_imp.g_varchar2_table(2) := '74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E6729207B0D';
wwv_flow_imp.g_varchar2_table(3) := '0A20206261636B67726F756E642D636F6C6F723A20233463346535302021696D706F7274616E743B0D0A2020636F6C6F723A202366666621696D706F7274616E743B0D0A7D0D0A0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D4275';
wwv_flow_imp.g_varchar2_table(4) := '74746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D776172';
wwv_flow_imp.g_varchar2_table(5) := '6E696E67292E69732D6163746976652C202E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279';
wwv_flow_imp.g_varchar2_table(6) := '293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A666F6375732C202E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E';
wwv_flow_imp.g_varchar2_table(7) := '742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A686F766572207B0D0A20';
wwv_flow_imp.g_varchar2_table(8) := '206261636B67726F756E642D636F6C6F723A20233635363836612021696D706F7274616E743B0D0A7D0D0A0D0A2F2A2044697361626C6564206D656E75206974656D732A2F0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D6469736162';
wwv_flow_imp.g_varchar2_table(9) := '6C65642E69732D666F6375736564207B0D0A2020636F6C6F723A2072676261283235342C203235342C203235342C20302E35293B0D0A20206261636B67726F756E642D636F6C6F723A202336633663366337353B0D0A7D0D0A2E612D4D656E75202E612D';
wwv_flow_imp.g_varchar2_table(10) := '4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564203E202E612D4D656E752D696E6E6572202E612D4D656E752D737461747573436F6C2C0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65';
wwv_flow_imp.g_varchar2_table(11) := '642E69732D666F6375736564203E202E612D4D656E752D696E6E6572202E612D4D656E752D616363656C207B0D0A2020636F6C6F723A20726762283134342C203134362C20313437293B0D0A20206F7061636974793A20313B0D0A7D0D0A0D0A2F2A4952';
wwv_flow_imp.g_varchar2_table(12) := '20526F772073656C6563746F72206C6162656C2A2F0D0A2E612D4952522D726F7753656C6563746F72206C6162656C207B0D0A20636F6C6F723A236666666666662021696D706F7274616E743B0D0A7D0D0A';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(18118519760185449)
,p_file_name=>'css/20.2/flows4apex.dark.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/workflow_black_svg
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '3C7376672069643D224C617965725F312220646174612D6E616D653D224C6179657220312220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22313622206865696768743D223136222076696577';
wwv_flow_imp.g_varchar2_table(2) := '426F783D22302030203136203136223E3C7061746820643D224D382E352C366836612E352E352C302C302C302C2E352D2E35562E35612E352E352C302C302C302D2E352D2E35682D36412E352E352C302C302C302C382C2E3556312E393948332E35612E';
wwv_flow_imp.g_varchar2_table(3) := '352E352C302C302C302D2E352E3576322E334C2E3134362C372E363436612E352E352C302C302C302C302C2E3730384C332C31312E3230375631332E3439612E352E352C302C302C302C2E352E3548385631352E35612E352E352C302C302C302C2E352E';
wwv_flow_imp.g_varchar2_table(4) := '356836612E352E352C302C302C302C2E352D2E35762D35612E352E352C302C302C302D2E352D2E35682D36612E352E352C302C302C302D2E352E3576322E343948345631312E3230374C362E3835342C382E333534612E352E352C302C302C302C302D2E';
wwv_flow_imp.g_varchar2_table(5) := '3730384C342C342E37393356322E3939483856352E35412E352E352C302C302C302C382E352C365A4D392C31316835763448395A6D2D352E352D2E3730374C312E3230372C382C332E352C352E3730372C352E3739332C385A4D392C316835563548395A';
wwv_flow_imp.g_varchar2_table(6) := '222F3E3C2F7376673E';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(26991323914877414)
,p_file_name=>'workflow_black.svg'
,p_mime_type=>'image/svg+xml'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/app_100_logo_svg
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '3C7376672069643D224C617965725F312220646174612D6E616D653D224C6179657220312220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22313622206865696768743D223136222076696577';
wwv_flow_imp.g_varchar2_table(2) := '426F783D22302030203136203136223E3C7061746820643D224D382E352C366836612E352E352C302C302C302C2E352D2E35562E35612E352E352C302C302C302D2E352D2E35682D36412E352E352C302C302C302C382C2E3556312E393948332E35612E';
wwv_flow_imp.g_varchar2_table(3) := '352E352C302C302C302D2E352E3576322E334C2E3134362C372E363436612E352E352C302C302C302C302C2E3730384C332C31312E3230375631332E3439612E352E352C302C302C302C2E352E3548385631352E35612E352E352C302C302C302C2E352E';
wwv_flow_imp.g_varchar2_table(4) := '356836612E352E352C302C302C302C2E352D2E35762D35612E352E352C302C302C302D2E352D2E35682D36612E352E352C302C302C302D2E352E3576322E343948345631312E3230374C362E3835342C382E333534612E352E352C302C302C302C302D2E';
wwv_flow_imp.g_varchar2_table(5) := '3730384C342C342E37393356322E3939483856352E35412E352E352C302C302C302C382E352C365A4D392C31316835763448395A6D2D352E352D2E3730374C312E3230372C382C332E352C352E3730372C352E3739332C385A4D392C316835563548395A';
wwv_flow_imp.g_varchar2_table(6) := '222066696C6C3D2223666666222F3E3C2F7376673E';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(26994221198953312)
,p_file_name=>'app-100-logo.svg'
,p_mime_type=>'image/svg+xml'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/workflow_white_svg
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '3C7376672069643D224C617965725F312220646174612D6E616D653D224C6179657220312220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22313622206865696768743D223136222076696577';
wwv_flow_imp.g_varchar2_table(2) := '426F783D22302030203136203136223E3C7061746820643D224D382E352C366836612E352E352C302C302C302C2E352D2E35562E35612E352E352C302C302C302D2E352D2E35682D36412E352E352C302C302C302C382C2E3556312E393948332E35612E';
wwv_flow_imp.g_varchar2_table(3) := '352E352C302C302C302D2E352E3576322E334C2E3134362C372E363436612E352E352C302C302C302C302C2E3730384C332C31312E3230375631332E3439612E352E352C302C302C302C2E352E3548385631352E35612E352E352C302C302C302C2E352E';
wwv_flow_imp.g_varchar2_table(4) := '356836612E352E352C302C302C302C2E352D2E35762D35612E352E352C302C302C302D2E352D2E35682D36612E352E352C302C302C302D2E352E3576322E343948345631312E3230374C362E3835342C382E333534612E352E352C302C302C302C302D2E';
wwv_flow_imp.g_varchar2_table(5) := '3730384C342C342E37393356322E3939483856352E35412E352E352C302C302C302C382E352C365A4D392C31316835763448395A6D2D352E352D2E3730374C312E3230372C382C332E352C352E3730372C352E3739332C385A4D392C316835563548395A';
wwv_flow_imp.g_varchar2_table(6) := '222066696C6C3D2223666666222F3E3C2F7376673E';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(26999326863976501)
,p_file_name=>'workflow_white.svg'
,p_mime_type=>'image/svg+xml'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_2_flows4apex_dark_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D63726561746564202E742D42616467654C6973742D6C6162656C207B0A2020636F6C6F723A202334363334303021696D706F7274616E743B0A7D0A0A2E6666612D636F6C6F722D2D636F6D706C65746564202E742D426164';
wwv_flow_imp.g_varchar2_table(2) := '67654C6973742D6C6162656C207B0A2020636F6C6F723A202332383361346421696D706F7274616E743B0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(32200728748850876)
,p_file_name=>'css/21.2/flows4apex.dark.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/css_21_2_flows4apex_light_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6666612D636F6C6F722D2D72756E6E696E67202E742D42616467654C6973742D6C6162656C207B0A2020636F6C6F723A20776869746521696D706F7274616E743B0A7D0A0A2E6666612D636F6C6F722D2D7465726D696E61746564202E742D42616467';
wwv_flow_imp.g_varchar2_table(2) := '654C6973742D6C6162656C207B0A2020636F6C6F723A20776869746521696D706F7274616E743B0A7D0A0A2E6666612D636F6C6F722D2D6572726F72202E742D42616467654C6973742D6C6162656C207B0A2020636F6C6F723A20776869746521696D70';
wwv_flow_imp.g_varchar2_table(3) := '6F7274616E743B0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(32200948477850895)
,p_file_name=>'css/21.2/flows4apex.light.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/flows_apex_svg
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22363422206865696768743D223634222076696577426F783D22302030203634203634223E0A20203C67207374796C653D2269736F6C';
wwv_flow_imp.g_varchar2_table(2) := '6174696F6E3A2069736F6C617465223E0A202020203C672069643D224C617965725F312220646174612D6E616D653D224C617965722031223E0A2020202020203C726563742077696474683D22363422206865696768743D223634222066696C6C3D2223';
wwv_flow_imp.g_varchar2_table(3) := '303037376466222F3E0A2020202020203C7061746820643D224D33322E352C3237683133612E352E352C302C302C302C2E352D2E35762D3130612E352E352C302C302C302D2E352D2E35682D3133612E352E352C302C302C302D2E352E35563231483231';
wwv_flow_imp.g_varchar2_table(4) := '2E35612E352E352C302C302C302D2E352E3576332E3239336C2D362E3835342C362E383533612E352E352C302C302C302C302C2E3730384C32312C33392E3230375634322E35612E352E352C302C302C302C2E352E3548333276342E35612E352E352C30';
wwv_flow_imp.g_varchar2_table(5) := '2C302C302C2E352E35683133612E352E352C302C302C302C2E352D2E35762D3130612E352E352C302C302C302D2E352D2E35682D3133612E352E352C302C302C302D2E352E355634324832325633392E3230376C362E3835342D362E383533612E352E35';
wwv_flow_imp.g_varchar2_table(6) := '2C302C302C302C302D2E3730384C32322C32342E37393356323248333276342E35412E352E352C302C302C302C33322E352C32375A4D33332C333848343576394833335A6D2D31312E352E3239334C31352E3230372C33322C32312E352C32352E373037';
wwv_flow_imp.g_varchar2_table(7) := '2C32372E3739332C33325A4D33332C313748343576394833335A22206F7061636974793D22302E3422207374796C653D226D69782D626C656E642D6D6F64653A206D756C7469706C793B69736F6C6174696F6E3A2069736F6C617465222F3E0A20202020';
wwv_flow_imp.g_varchar2_table(8) := '20203C7265637420783D2233332220793D223338222077696474683D22313222206865696768743D2239222066696C6C3D222366636662666122206F7061636974793D22302E3622207374796C653D2269736F6C6174696F6E3A2069736F6C617465222F';
wwv_flow_imp.g_varchar2_table(9) := '3E0A2020202020203C7265637420783D2233332220793D223137222077696474683D22313222206865696768743D2239222066696C6C3D222366636662666122206F7061636974793D22302E3622207374796C653D2269736F6C6174696F6E3A2069736F';
wwv_flow_imp.g_varchar2_table(10) := '6C617465222F3E0A2020202020203C7265637420783D2231372E30352220793D2232372E3535222077696474683D22382E3922206865696768743D22382E3922207472616E73666F726D3D227472616E736C617465282D31362E33332032342E35373529';
wwv_flow_imp.g_varchar2_table(11) := '20726F74617465282D343529222066696C6C3D222366636662666122206F7061636974793D22302E3922207374796C653D2269736F6C6174696F6E3A2069736F6C617465222F3E0A202020203C2F673E0A20203C2F673E0A3C2F7376673E0A';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(57100485715285864)
,p_file_name=>'flows-apex.svg'
,p_mime_type=>'image/svg+xml'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/lib_prismjs_js_prism_min_js
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '766172205F73656C663D22756E646566696E656422213D747970656F662077696E646F773F77696E646F773A22756E646566696E656422213D747970656F6620576F726B6572476C6F62616C53636F7065262673656C6620696E7374616E63656F662057';
wwv_flow_imp.g_varchar2_table(2) := '6F726B6572476C6F62616C53636F70653F73656C663A7B7D2C507269736D3D66756E6374696F6E2865297B76617220743D2F283F3A5E7C5C73296C616E67283F3A75616765293F2D285B5C772D5D2B29283F3D5C737C24292F692C6E3D302C723D7B7D2C';
wwv_flow_imp.g_varchar2_table(3) := '613D7B6D616E75616C3A652E507269736D2626652E507269736D2E6D616E75616C2C64697361626C65576F726B65724D65737361676548616E646C65723A652E507269736D2626652E507269736D2E64697361626C65576F726B65724D65737361676548';
wwv_flow_imp.g_varchar2_table(4) := '616E646C65722C7574696C3A7B656E636F64653A66756E6374696F6E20652874297B72657475726E207420696E7374616E63656F6620453F6E6577204528742E747970652C6528742E636F6E74656E74292C742E616C696173293A41727261792E697341';
wwv_flow_imp.g_varchar2_table(5) := '727261792874293F742E6D61702865293A742E7265706C616365282F262F672C2226616D703B22292E7265706C616365282F3C2F672C22266C743B22292E7265706C616365282F5C75303061302F672C222022297D2C747970653A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(6) := '65297B72657475726E204F626A6563742E70726F746F747970652E746F537472696E672E63616C6C2865292E736C69636528382C2D31297D2C6F626A49643A66756E6374696F6E2865297B72657475726E20652E5F5F69647C7C4F626A6563742E646566';
wwv_flow_imp.g_varchar2_table(7) := '696E6550726F706572747928652C225F5F6964222C7B76616C75653A2B2B6E7D292C652E5F5F69647D2C636C6F6E653A66756E6374696F6E206528742C6E297B76617220722C453B737769746368286E3D6E7C7C7B7D2C612E7574696C2E747970652874';
wwv_flow_imp.g_varchar2_table(8) := '29297B63617365224F626A656374223A696628453D612E7574696C2E6F626A49642874292C6E5B455D2972657475726E206E5B455D3B666F7228766172206920696E20723D7B7D2C6E5B455D3D722C7429742E6861734F776E50726F7065727479286929';
wwv_flow_imp.g_varchar2_table(9) := '262628725B695D3D6528745B695D2C6E29293B72657475726E20723B63617365224172726179223A72657475726E20453D612E7574696C2E6F626A49642874292C6E5B455D3F6E5B455D3A28723D5B5D2C6E5B455D3D722C742E666F7245616368282866';
wwv_flow_imp.g_varchar2_table(10) := '756E6374696F6E28742C61297B725B615D3D6528742C6E297D29292C72293B64656661756C743A72657475726E20747D7D2C6765744C616E67756167653A66756E6374696F6E2865297B666F72283B653B297B766172206E3D742E6578656328652E636C';
wwv_flow_imp.g_varchar2_table(11) := '6173734E616D65293B6966286E2972657475726E206E5B315D2E746F4C6F7765724361736528293B653D652E706172656E74456C656D656E747D72657475726E226E6F6E65227D2C7365744C616E67756167653A66756E6374696F6E28652C6E297B652E';
wwv_flow_imp.g_varchar2_table(12) := '636C6173734E616D653D652E636C6173734E616D652E7265706C6163652852656745787028742C22676922292C2222292C652E636C6173734C6973742E61646428226C616E67756167652D222B6E297D2C63757272656E745363726970743A66756E6374';
wwv_flow_imp.g_varchar2_table(13) := '696F6E28297B69662822756E646566696E6564223D3D747970656F6620646F63756D656E742972657475726E206E756C6C3B6966282263757272656E7453637269707422696E20646F63756D656E742972657475726E20646F63756D656E742E63757272';
wwv_flow_imp.g_varchar2_table(14) := '656E745363726970743B7472797B7468726F77206E6577204572726F727D63617463682872297B76617220653D282F6174205B5E285C725C6E5D2A5C28282E2A293A5B5E3A5D2B3A5B5E3A5D2B5C29242F692E6578656328722E737461636B297C7C5B5D';
wwv_flow_imp.g_varchar2_table(15) := '295B315D3B69662865297B76617220743D646F63756D656E742E676574456C656D656E747342795461674E616D65282273637269707422293B666F7228766172206E20696E207429696628745B6E5D2E7372633D3D652972657475726E20745B6E5D7D72';
wwv_flow_imp.g_varchar2_table(16) := '657475726E206E756C6C7D7D2C69734163746976653A66756E6374696F6E28652C742C6E297B666F722876617220723D226E6F2D222B743B653B297B76617220613D652E636C6173734C6973743B696628612E636F6E7461696E73287429297265747572';
wwv_flow_imp.g_varchar2_table(17) := '6E21303B696628612E636F6E7461696E732872292972657475726E21313B653D652E706172656E74456C656D656E747D72657475726E21216E7D7D2C6C616E6775616765733A7B706C61696E3A722C706C61696E746578743A722C746578743A722C7478';
wwv_flow_imp.g_varchar2_table(18) := '743A722C657874656E643A66756E6374696F6E28652C74297B766172206E3D612E7574696C2E636C6F6E6528612E6C616E6775616765735B655D293B666F7228766172207220696E2074296E5B725D3D745B725D3B72657475726E206E7D2C696E736572';
wwv_flow_imp.g_varchar2_table(19) := '744265666F72653A66756E6374696F6E28652C742C6E2C72297B76617220453D28723D727C7C612E6C616E677561676573295B655D2C693D7B7D3B666F7228766172206F20696E204529696628452E6861734F776E50726F7065727479286F29297B6966';
wwv_flow_imp.g_varchar2_table(20) := '286F3D3D7429666F7228766172206C20696E206E296E2E6861734F776E50726F7065727479286C29262628695B6C5D3D6E5B6C5D293B6E2E6861734F776E50726F7065727479286F297C7C28695B6F5D3D455B6F5D297D76617220733D725B655D3B7265';
wwv_flow_imp.g_varchar2_table(21) := '7475726E20725B655D3D692C612E6C616E6775616765732E44465328612E6C616E6775616765732C2866756E6374696F6E28742C6E297B6E3D3D3D73262674213D65262628746869735B745D3D69297D29292C697D2C4446533A66756E6374696F6E2065';
wwv_flow_imp.g_varchar2_table(22) := '28742C6E2C722C45297B453D457C7C7B7D3B76617220693D612E7574696C2E6F626A49643B666F7228766172206F20696E207429696628742E6861734F776E50726F7065727479286F29297B6E2E63616C6C28742C6F2C745B6F5D2C727C7C6F293B7661';
wwv_flow_imp.g_varchar2_table(23) := '72206C3D745B6F5D2C733D612E7574696C2E74797065286C293B224F626A65637422213D3D737C7C455B69286C295D3F22417272617922213D3D737C7C455B69286C295D7C7C28455B69286C295D3D21302C65286C2C6E2C6F2C4529293A28455B69286C';
wwv_flow_imp.g_varchar2_table(24) := '295D3D21302C65286C2C6E2C6E756C6C2C4529297D7D7D2C706C7567696E733A7B7D2C686967686C69676874416C6C3A66756E6374696F6E28652C74297B612E686967686C69676874416C6C556E64657228646F63756D656E742C652C74297D2C686967';
wwv_flow_imp.g_varchar2_table(25) := '686C69676874416C6C556E6465723A66756E6374696F6E28652C742C6E297B76617220723D7B63616C6C6261636B3A6E2C636F6E7461696E65723A652C73656C6563746F723A27636F64655B636C6173732A3D226C616E67756167652D225D2C205B636C';
wwv_flow_imp.g_varchar2_table(26) := '6173732A3D226C616E67756167652D225D20636F64652C20636F64655B636C6173732A3D226C616E672D225D2C205B636C6173732A3D226C616E672D225D20636F6465277D3B612E686F6F6B732E72756E28226265666F72652D686967686C6967687461';
wwv_flow_imp.g_varchar2_table(27) := '6C6C222C72292C722E656C656D656E74733D41727261792E70726F746F747970652E736C6963652E6170706C7928722E636F6E7461696E65722E717565727953656C6563746F72416C6C28722E73656C6563746F7229292C612E686F6F6B732E72756E28';
wwv_flow_imp.g_varchar2_table(28) := '226265666F72652D616C6C2D656C656D656E74732D686967686C69676874222C72293B666F722876617220452C693D303B453D722E656C656D656E74735B692B2B5D3B29612E686967686C69676874456C656D656E7428452C21303D3D3D742C722E6361';
wwv_flow_imp.g_varchar2_table(29) := '6C6C6261636B297D2C686967686C69676874456C656D656E743A66756E6374696F6E28742C6E2C72297B76617220453D612E7574696C2E6765744C616E67756167652874292C693D612E6C616E6775616765735B455D3B612E7574696C2E7365744C616E';
wwv_flow_imp.g_varchar2_table(30) := '677561676528742C45293B766172206F3D742E706172656E74456C656D656E743B6F262622707265223D3D3D6F2E6E6F64654E616D652E746F4C6F7765724361736528292626612E7574696C2E7365744C616E6775616765286F2C45293B766172206C3D';
wwv_flow_imp.g_varchar2_table(31) := '7B656C656D656E743A742C6C616E67756167653A452C6772616D6D61723A692C636F64653A742E74657874436F6E74656E747D3B66756E6374696F6E20732865297B6C2E686967686C696768746564436F64653D652C612E686F6F6B732E72756E282262';
wwv_flow_imp.g_varchar2_table(32) := '65666F72652D696E73657274222C6C292C6C2E656C656D656E742E696E6E657248544D4C3D6C2E686967686C696768746564436F64652C612E686F6F6B732E72756E282261667465722D686967686C69676874222C6C292C612E686F6F6B732E72756E28';
wwv_flow_imp.g_varchar2_table(33) := '22636F6D706C657465222C6C292C722626722E63616C6C286C2E656C656D656E74297D696628612E686F6F6B732E72756E28226265666F72652D73616E6974792D636865636B222C6C292C286F3D6C2E656C656D656E742E706172656E74456C656D656E';
wwv_flow_imp.g_varchar2_table(34) := '7429262622707265223D3D3D6F2E6E6F64654E616D652E746F4C6F7765724361736528292626216F2E6861734174747269627574652822746162696E646578222926266F2E7365744174747269627574652822746162696E646578222C223022292C216C';
wwv_flow_imp.g_varchar2_table(35) := '2E636F64652972657475726E20612E686F6F6B732E72756E2822636F6D706C657465222C6C292C766F696428722626722E63616C6C286C2E656C656D656E7429293B696628612E686F6F6B732E72756E28226265666F72652D686967686C69676874222C';
wwv_flow_imp.g_varchar2_table(36) := '6C292C6C2E6772616D6D6172296966286E2626652E576F726B6572297B76617220753D6E657720576F726B657228612E66696C656E616D65293B752E6F6E6D6573736167653D66756E6374696F6E2865297B7328652E64617461297D2C752E706F73744D';
wwv_flow_imp.g_varchar2_table(37) := '657373616765284A534F4E2E737472696E67696679287B6C616E67756167653A6C2E6C616E67756167652C636F64653A6C2E636F64652C696D6D656469617465436C6F73653A21307D29297D656C7365207328612E686967686C69676874286C2E636F64';
wwv_flow_imp.g_varchar2_table(38) := '652C6C2E6772616D6D61722C6C2E6C616E677561676529293B656C7365207328612E7574696C2E656E636F6465286C2E636F646529297D2C686967686C696768743A66756E6374696F6E28652C742C6E297B76617220723D7B636F64653A652C6772616D';
wwv_flow_imp.g_varchar2_table(39) := '6D61723A742C6C616E67756167653A6E7D3B696628612E686F6F6B732E72756E28226265666F72652D746F6B656E697A65222C72292C21722E6772616D6D6172297468726F77206E6577204572726F722827546865206C616E67756167652022272B722E';
wwv_flow_imp.g_varchar2_table(40) := '6C616E67756167652B272220686173206E6F206772616D6D61722E27293B72657475726E20722E746F6B656E733D612E746F6B656E697A6528722E636F64652C722E6772616D6D6172292C612E686F6F6B732E72756E282261667465722D746F6B656E69';
wwv_flow_imp.g_varchar2_table(41) := '7A65222C72292C452E737472696E6769667928612E7574696C2E656E636F646528722E746F6B656E73292C722E6C616E6775616765297D2C746F6B656E697A653A66756E6374696F6E28652C74297B766172206E3D742E726573743B6966286E297B666F';
wwv_flow_imp.g_varchar2_table(42) := '7228766172207220696E206E29745B725D3D6E5B725D3B64656C65746520742E726573747D76617220613D6E6577206C3B72657475726E207328612C612E686561642C65292C6F28652C612C742C612E686561642C30292C66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(43) := '76617220743D5B5D2C6E3D652E686561642E6E6578743B666F72283B6E213D3D652E7461696C3B29742E70757368286E2E76616C7565292C6E3D6E2E6E6578743B72657475726E20747D2861297D2C686F6F6B733A7B616C6C3A7B7D2C6164643A66756E';
wwv_flow_imp.g_varchar2_table(44) := '6374696F6E28652C74297B766172206E3D612E686F6F6B732E616C6C3B6E5B655D3D6E5B655D7C7C5B5D2C6E5B655D2E707573682874297D2C72756E3A66756E6374696F6E28652C74297B766172206E3D612E686F6F6B732E616C6C5B655D3B6966286E';
wwv_flow_imp.g_varchar2_table(45) := '26266E2E6C656E67746829666F722876617220722C453D303B723D6E5B452B2B5D3B29722874297D7D2C546F6B656E3A457D3B66756E6374696F6E204528652C742C6E2C72297B746869732E747970653D652C746869732E636F6E74656E743D742C7468';
wwv_flow_imp.g_varchar2_table(46) := '69732E616C6961733D6E2C746869732E6C656E6774683D307C28727C7C2222292E6C656E6774687D66756E6374696F6E206928652C742C6E2C72297B652E6C617374496E6465783D743B76617220613D652E65786563286E293B69662861262672262661';
wwv_flow_imp.g_varchar2_table(47) := '5B315D297B76617220453D615B315D2E6C656E6774683B612E696E6465782B3D452C615B305D3D615B305D2E736C6963652845297D72657475726E20617D66756E6374696F6E206F28652C742C6E2C722C6C2C54297B666F7228766172206320696E206E';
wwv_flow_imp.g_varchar2_table(48) := '296966286E2E6861734F776E50726F706572747928632926266E5B635D297B76617220413D6E5B635D3B413D41727261792E697341727261792841293F413A5B415D3B666F722876617220493D303B493C412E6C656E6774683B2B2B49297B6966285426';
wwv_flow_imp.g_varchar2_table(49) := '26542E63617573653D3D632B222C222B492972657475726E3B766172204E3D415B495D2C523D4E2E696E736964652C643D21214E2E6C6F6F6B626568696E642C4F3D21214E2E6772656564792C4C3D4E2E616C6961733B6966284F2626214E2E70617474';
wwv_flow_imp.g_varchar2_table(50) := '65726E2E676C6F62616C297B76617220533D4E2E7061747465726E2E746F537472696E6728292E6D61746368282F5B696D7375795D2A242F295B305D3B4E2E7061747465726E3D526567457870284E2E7061747465726E2E736F757263652C532B226722';
wwv_flow_imp.g_varchar2_table(51) := '297D666F722876617220433D4E2E7061747465726E7C7C4E2C703D722E6E6578742C673D6C3B70213D3D742E7461696C26262128542626673E3D542E7265616368293B672B3D702E76616C75652E6C656E6774682C703D702E6E657874297B7661722066';
wwv_flow_imp.g_varchar2_table(52) := '3D702E76616C75653B696628742E6C656E6774683E652E6C656E6774682972657475726E3B69662821286620696E7374616E63656F66204529297B766172206D2C683D313B6966284F297B69662821286D3D6928432C672C652C6429297C7C6D2E696E64';
wwv_flow_imp.g_varchar2_table(53) := '65783E3D652E6C656E67746829627265616B3B76617220623D6D2E696E6465782C443D6D2E696E6465782B6D5B305D2E6C656E6774682C553D673B666F7228552B3D702E76616C75652E6C656E6774683B623E3D553B29552B3D28703D702E6E65787429';
wwv_flow_imp.g_varchar2_table(54) := '2E76616C75652E6C656E6774683B696628673D552D3D702E76616C75652E6C656E6774682C702E76616C756520696E7374616E63656F66204529636F6E74696E75653B666F722876617220503D703B50213D3D742E7461696C262628553C447C7C227374';
wwv_flow_imp.g_varchar2_table(55) := '72696E67223D3D747970656F6620502E76616C7565293B503D502E6E65787429682B2B2C552B3D502E76616C75652E6C656E6774683B682D2D2C663D652E736C69636528672C55292C6D2E696E6465782D3D677D656C73652069662821286D3D6928432C';
wwv_flow_imp.g_varchar2_table(56) := '302C662C64292929636F6E74696E75653B623D6D2E696E6465783B76617220763D6D5B305D2C4D3D662E736C69636528302C62292C793D662E736C69636528622B762E6C656E677468292C423D672B662E6C656E6774683B542626423E542E7265616368';
wwv_flow_imp.g_varchar2_table(57) := '262628542E72656163683D42293B76617220473D702E707265763B6966284D262628473D7328742C472C4D292C672B3D4D2E6C656E677468292C7528742C472C68292C703D7328742C472C6E6577204528632C523F612E746F6B656E697A6528762C5229';
wwv_flow_imp.g_varchar2_table(58) := '3A762C4C2C7629292C7926267328742C702C79292C683E31297B76617220463D7B63617573653A632B222C222B492C72656163683A427D3B6F28652C742C6E2C702E707265762C672C46292C542626462E72656163683E542E7265616368262628542E72';
wwv_flow_imp.g_varchar2_table(59) := '656163683D462E7265616368297D7D7D7D7D7D66756E6374696F6E206C28297B76617220653D7B76616C75653A6E756C6C2C707265763A6E756C6C2C6E6578743A6E756C6C7D2C743D7B76616C75653A6E756C6C2C707265763A652C6E6578743A6E756C';
wwv_flow_imp.g_varchar2_table(60) := '6C7D3B652E6E6578743D742C746869732E686561643D652C746869732E7461696C3D742C746869732E6C656E6774683D307D66756E6374696F6E207328652C742C6E297B76617220723D742E6E6578742C613D7B76616C75653A6E2C707265763A742C6E';
wwv_flow_imp.g_varchar2_table(61) := '6578743A727D3B72657475726E20742E6E6578743D612C722E707265763D612C652E6C656E6774682B2B2C617D66756E6374696F6E207528652C742C6E297B666F722876617220723D742E6E6578742C613D303B613C6E262672213D3D652E7461696C3B';
wwv_flow_imp.g_varchar2_table(62) := '612B2B29723D722E6E6578743B742E6E6578743D722C722E707265763D742C652E6C656E6774682D3D617D696628652E507269736D3D612C452E737472696E676966793D66756E6374696F6E206528742C6E297B69662822737472696E67223D3D747970';
wwv_flow_imp.g_varchar2_table(63) := '656F6620742972657475726E20743B69662841727261792E69734172726179287429297B76617220723D22223B72657475726E20742E666F7245616368282866756E6374696F6E2874297B722B3D6528742C6E297D29292C727D76617220453D7B747970';
wwv_flow_imp.g_varchar2_table(64) := '653A742E747970652C636F6E74656E743A6528742E636F6E74656E742C6E292C7461673A227370616E222C636C61737365733A5B22746F6B656E222C742E747970655D2C617474726962757465733A7B7D2C6C616E67756167653A6E7D2C693D742E616C';
wwv_flow_imp.g_varchar2_table(65) := '6961733B6926262841727261792E697341727261792869293F41727261792E70726F746F747970652E707573682E6170706C7928452E636C61737365732C69293A452E636C61737365732E70757368286929292C612E686F6F6B732E72756E2822777261';
wwv_flow_imp.g_varchar2_table(66) := '70222C45293B766172206F3D22223B666F7228766172206C20696E20452E61747472696275746573296F2B3D2220222B6C2B273D22272B28452E617474726962757465735B6C5D7C7C2222292E7265706C616365282F222F672C222671756F743B22292B';
wwv_flow_imp.g_varchar2_table(67) := '2722273B72657475726E223C222B452E7461672B2720636C6173733D22272B452E636C61737365732E6A6F696E28222022292B2722272B6F2B223E222B452E636F6E74656E742B223C2F222B452E7461672B223E227D2C21652E646F63756D656E742972';
wwv_flow_imp.g_varchar2_table(68) := '657475726E20652E6164644576656E744C697374656E65723F28612E64697361626C65576F726B65724D65737361676548616E646C65727C7C652E6164644576656E744C697374656E657228226D657373616765222C2866756E6374696F6E2874297B76';
wwv_flow_imp.g_varchar2_table(69) := '6172206E3D4A534F4E2E706172736528742E64617461292C723D6E2E6C616E67756167652C453D6E2E636F64652C693D6E2E696D6D656469617465436C6F73653B652E706F73744D65737361676528612E686967686C6967687428452C612E6C616E6775';
wwv_flow_imp.g_varchar2_table(70) := '616765735B725D2C7229292C692626652E636C6F736528297D292C2131292C61293A613B76617220543D612E7574696C2E63757272656E7453637269707428293B66756E6374696F6E206328297B612E6D616E75616C7C7C612E686967686C6967687441';
wwv_flow_imp.g_varchar2_table(71) := '6C6C28297D69662854262628612E66696C656E616D653D542E7372632C542E6861734174747269627574652822646174612D6D616E75616C2229262628612E6D616E75616C3D213029292C21612E6D616E75616C297B76617220413D646F63756D656E74';
wwv_flow_imp.g_varchar2_table(72) := '2E726561647953746174653B226C6F6164696E67223D3D3D417C7C22696E746572616374697665223D3D3D412626542626542E64656665723F646F63756D656E742E6164644576656E744C697374656E65722822444F4D436F6E74656E744C6F61646564';
wwv_flow_imp.g_varchar2_table(73) := '222C63293A77696E646F772E72657175657374416E696D6174696F6E4672616D653F77696E646F772E72657175657374416E696D6174696F6E4672616D652863293A77696E646F772E73657454696D656F757428632C3136297D72657475726E20617D28';
wwv_flow_imp.g_varchar2_table(74) := '5F73656C66293B0A2F2A2A0A202A20507269736D3A204C696768747765696768742C20726F627573742C20656C6567616E742073796E74617820686967686C69676874696E670A202A0A202A20406C6963656E7365204D4954203C68747470733A2F2F6F';
wwv_flow_imp.g_varchar2_table(75) := '70656E736F757263652E6F72672F6C6963656E7365732F4D49543E0A202A2040617574686F72204C6561205665726F75203C68747470733A2F2F6C65612E7665726F752E6D653E0A202A20406E616D6573706163650A202A20407075626C69630A202A2F';
wwv_flow_imp.g_varchar2_table(76) := '22756E646566696E656422213D747970656F66206D6F64756C6526266D6F64756C652E6578706F7274732626286D6F64756C652E6578706F7274733D507269736D292C22756E646566696E656422213D747970656F6620676C6F62616C262628676C6F62';
wwv_flow_imp.g_varchar2_table(77) := '616C2E507269736D3D507269736D292C507269736D2E6C616E6775616765732E6A736F6E3D7B70726F70657274793A7B7061747465726E3A2F285E7C5B5E5C5C5D2922283F3A5C5C2E7C5B5E5C5C225C725C6E5D292A22283F3D5C732A3A292F2C6C6F6F';
wwv_flow_imp.g_varchar2_table(78) := '6B626568696E643A21302C6772656564793A21307D2C737472696E673A7B7061747465726E3A2F285E7C5B5E5C5C5D2922283F3A5C5C2E7C5B5E5C5C225C725C6E5D292A22283F215C732A3A292F2C6C6F6F6B626568696E643A21302C6772656564793A';
wwv_flow_imp.g_varchar2_table(79) := '21307D2C636F6D6D656E743A7B7061747465726E3A2F5C2F5C2F2E2A7C5C2F5C2A5B5C735C535D2A3F283F3A5C2A5C2F7C24292F2C6772656564793A21307D2C6E756D6265723A2F2D3F5C625C642B283F3A5C2E5C642B293F283F3A655B2B2D5D3F5C64';
wwv_flow_imp.g_varchar2_table(80) := '2B293F5C622F692C70756E6374756174696F6E3A2F5B7B7D5B5C5D2C5D2F2C6F70657261746F723A2F3A2F2C626F6F6C65616E3A2F5C62283F3A66616C73657C74727565295C622F2C6E756C6C3A7B7061747465726E3A2F5C626E756C6C5C622F2C616C';
wwv_flow_imp.g_varchar2_table(81) := '6961733A226B6579776F7264227D7D2C507269736D2E6C616E6775616765732E7765626D616E69666573743D507269736D2E6C616E6775616765732E6A736F6E2C507269736D2E6C616E6775616765732E6C6F673D7B737472696E673A7B706174746572';
wwv_flow_imp.g_varchar2_table(82) := '6E3A2F22283F3A5B5E225C5C5C725C6E5D7C5C5C2E292A227C27283F215B73745D207C205C7729283F3A5B5E275C5C5C725C6E5D7C5C5C2E292A272F2C6772656564793A21307D2C657863657074696F6E3A7B7061747465726E3A2F285E7C5B5E5C772E';
wwv_flow_imp.g_varchar2_table(83) := '5D295B612D7A5D5B5C772E5D2A283F3A4572726F727C457863657074696F6E293A2E2A283F3A283F3A5C725C6E3F7C5C6E295B205C745D2A283F3A61745B205C745D2E2B7C5C2E7B337D2E2A7C4361757365642062793A2E2A29292B283F3A283F3A5C72';
wwv_flow_imp.g_varchar2_table(84) := '5C6E3F7C5C6E295B205C745D2A5C2E5C2E5C2E202E2A293F2F2C6C6F6F6B626568696E643A21302C6772656564793A21302C616C6961733A5B226A617661737461636B7472616365222C226C616E67756167652D6A617661737461636B7472616365225D';
wwv_flow_imp.g_varchar2_table(85) := '2C696E736964653A507269736D2E6C616E6775616765732E6A617661737461636B74726163657C7C7B6B6579776F72643A2F5C6261745C622F2C66756E6374696F6E3A2F5B612D7A5F5D5B5C77245D2A283F3D5C28292F2C70756E6374756174696F6E3A';
wwv_flow_imp.g_varchar2_table(86) := '2F5B2E3A28295D2F7D7D2C6C6576656C3A5B7B7061747465726E3A2F5C62283F3A414C4552547C435249547C435249544943414C7C454D4552477C454D455247454E43597C4552527C4552524F527C4641494C5552457C464154414C7C53455645524529';
wwv_flow_imp.g_varchar2_table(87) := '5C622F2C616C6961733A5B226572726F72222C22696D706F7274616E74225D7D2C7B7061747465726E3A2F5C62283F3A5741524E7C5741524E494E477C57524E295C622F2C616C6961733A5B227761726E696E67222C22696D706F7274616E74225D7D2C';
wwv_flow_imp.g_varchar2_table(88) := '7B7061747465726E3A2F5C62283F3A444953504C41597C494E467C494E464F7C4E4F544943457C535441545553295C622F2C616C6961733A5B22696E666F222C226B6579776F7264225D7D2C7B7061747465726E3A2F5C62283F3A4442477C4445425547';
wwv_flow_imp.g_varchar2_table(89) := '7C46494E45295C622F2C616C6961733A5B226465627567222C226B6579776F7264225D7D2C7B7061747465726E3A2F5C62283F3A46494E45527C46494E4553547C54524143457C5452437C564552424F53457C565242295C622F2C616C6961733A5B2274';
wwv_flow_imp.g_varchar2_table(90) := '72616365222C22636F6D6D656E74225D7D5D2C70726F70657274793A7B7061747465726E3A2F28283F3A5E7C5B5C5D7C5D295B205C745D2A295B612D7A5F5D283F3A5B5C772D5D7C5C625C2F5C62292A283F3A5B2E205D5C283F5C77283F3A5B5C772D5D';
wwv_flow_imp.g_varchar2_table(91) := '7C5C625C2F5C62292A5C293F292A3A283F3D5C73292F696D2C6C6F6F6B626568696E643A21307D2C736570617261746F723A7B7061747465726E3A2F285E7C5B5E2D2B5D292D7B332C7D7C3D7B332C7D7C5C2A7B332C7D7C2D202D202F6D2C6C6F6F6B62';
wwv_flow_imp.g_varchar2_table(92) := '6568696E643A21302C616C6961733A22636F6D6D656E74227D2C75726C3A2F5C62283F3A66696C657C6674707C68747470733F293A5C2F5C2F5B5E5C737C2C3B27225D2A5B5E5C737C2C3B27223E2E5D2F2C656D61696C3A7B7061747465726E3A2F285E';
wwv_flow_imp.g_varchar2_table(93) := '7C5C73295B2D5C772B2E5D2B405B612D7A5D5B612D7A302D392D5D2A283F3A5C2E5B612D7A5D5B612D7A302D392D5D2A292B283F3D5C73292F2C6C6F6F6B626568696E643A21302C616C6961733A2275726C227D2C2269702D61646472657373223A7B70';
wwv_flow_imp.g_varchar2_table(94) := '61747465726E3A2F5C62283F3A5C647B312C337D283F3A5C2E5C647B312C337D297B337D295C622F2C616C6961733A22636F6E7374616E74227D2C226D61632D61646472657373223A7B7061747465726E3A2F5C625B612D66302D395D7B327D283F3A3A';
wwv_flow_imp.g_varchar2_table(95) := '5B612D66302D395D7B327D297B357D5C622F692C616C6961733A22636F6E7374616E74227D2C646F6D61696E3A7B7061747465726E3A2F285E7C5C73295B612D7A5D5B612D7A302D392D5D2A283F3A5C2E5B612D7A5D5B612D7A302D392D5D2A292A5C2E';
wwv_flow_imp.g_varchar2_table(96) := '5B612D7A5D5B612D7A302D392D5D2B283F3D5C73292F2C6C6F6F6B626568696E643A21302C616C6961733A22636F6E7374616E74227D2C757569643A7B7061747465726E3A2F5C625B302D39612D665D7B387D2D5B302D39612D665D7B347D2D5B302D39';
wwv_flow_imp.g_varchar2_table(97) := '612D665D7B347D2D5B302D39612D665D7B347D2D5B302D39612D665D7B31327D5C622F692C616C6961733A22636F6E7374616E74227D2C686173683A7B7061747465726E3A2F5C62283F3A5B612D66302D395D7B33327D297B312C327D5C622F692C616C';
wwv_flow_imp.g_varchar2_table(98) := '6961733A22636F6E7374616E74227D2C2266696C652D70617468223A7B7061747465726E3A2F5C625B612D7A5D3A5B5C5C2F5D5B5E5C737C2C3B3A28297B7D5C5B5C5D22275D2B7C285E7C5B5C733A5C5B5C5D283E7C5D295C2E7B302C327D5C2F5C775B';
wwv_flow_imp.g_varchar2_table(99) := '5E5C737C2C3B3A28297B7D5C5B5C5D22275D2A2F692C6C6F6F6B626568696E643A21302C6772656564793A21302C616C6961733A22737472696E67227D2C646174653A7B7061747465726E3A526567457870282F5C625C647B347D5B2D2F5D5C647B327D';
wwv_flow_imp.g_varchar2_table(100) := '5B2D2F5D5C647B327D283F3A54283F3D5C647B312C327D3A297C283F3D5C735C647B312C327D3A29292F2E736F757263652B227C222B2F5C625C647B312C347D5B2D2F205D283F3A5C647B312C327D7C4170727C4175677C4465637C4665627C4A616E7C';
wwv_flow_imp.g_varchar2_table(101) := '4A756C7C4A756E7C4D61727C4D61797C4E6F767C4F63747C536570295B2D2F205D5C647B322C347D543F5C622F2E736F757263652B227C222B2F5C62283F3A283F3A4672697C4D6F6E7C5361747C53756E7C5468757C5475657C57656429283F3A5C737B';
wwv_flow_imp.g_varchar2_table(102) := '312C327D283F3A4170727C4175677C4465637C4665627C4A616E7C4A756C7C4A756E7C4D61727C4D61797C4E6F767C4F63747C53657029293F7C4170727C4175677C4465637C4665627C4A616E7C4A756C7C4A756E7C4D61727C4D61797C4E6F767C4F63';
wwv_flow_imp.g_varchar2_table(103) := '747C536570295C737B312C327D5C647B312C327D5C622F2E736F757263652C226922292C616C6961733A226E756D626572227D2C74696D653A7B7061747465726E3A2F5C625C647B312C327D3A5C647B312C327D3A5C647B312C327D283F3A5B2E2C3A5D';
wwv_flow_imp.g_varchar2_table(104) := '5C642B293F283F3A5C733F5B2B2D5D5C647B327D3A3F5C647B327D7C5A293F5C622F2C616C6961733A226E756D626572227D2C626F6F6C65616E3A2F5C62283F3A66616C73657C6E756C6C7C74727565295C622F692C6E756D6265723A7B706174746572';
wwv_flow_imp.g_varchar2_table(105) := '6E3A2F285E7C5B5E2E5C775D29283F3A30785B612D66302D395D2B7C306F5B302D375D2B7C30625B30315D2B7C763F5C645B5C64612D665D2A283F3A5C2E5C642B292A283F3A655B2B2D5D3F5C642B293F5B612D7A5D7B302C337D5C62295C62283F215C';
wwv_flow_imp.g_varchar2_table(106) := '2E5C77292F692C6C6F6F6B626568696E643A21307D2C6F70657261746F723A2F5B3B3A3F3C3D3E7E2F40212425262B5C2D7C5E28297B7D2A235D2F2C70756E6374756174696F6E3A2F5B5C5B5C5D2E2C5D2F7D2C507269736D2E6C616E6775616765732E';
wwv_flow_imp.g_varchar2_table(107) := '73716C3D7B636F6D6D656E743A7B7061747465726E3A2F285E7C5B5E5C5C5D29283F3A5C2F5C2A5B5C735C535D2A3F5C2A5C2F7C283F3A2D2D7C5C2F5C2F7C23292E2A292F2C6C6F6F6B626568696E643A21307D2C7661726961626C653A5B7B70617474';
wwv_flow_imp.g_varchar2_table(108) := '65726E3A2F40285B2227605D29283F3A5C5C5B5C735C535D7C283F215C31295B5E5C5C5D292B5C312F2C6772656564793A21307D2C2F405B5C772E245D2B2F5D2C737472696E673A7B7061747465726E3A2F285E7C5B5E405C5C5D2928227C2729283F3A';
wwv_flow_imp.g_varchar2_table(109) := '5C5C5B5C735C535D7C283F215C32295B5E5C5C5D7C5C325C32292A5C322F2C6772656564793A21302C6C6F6F6B626568696E643A21307D2C6964656E7469666965723A7B7061747465726E3A2F285E7C5B5E405C5C5D2960283F3A5C5C5B5C735C535D7C';
wwv_flow_imp.g_varchar2_table(110) := '5B5E605C5C5D7C6060292A602F2C6772656564793A21302C6C6F6F6B626568696E643A21302C696E736964653A7B70756E6374756174696F6E3A2F5E607C60242F7D7D2C66756E6374696F6E3A2F5C62283F3A4156477C434F554E547C46495253547C46';
wwv_flow_imp.g_varchar2_table(111) := '4F524D41547C4C4153547C4C434153457C4C454E7C4D41587C4D49447C4D494E7C4D4F447C4E4F577C524F554E447C53554D7C554341534529283F3D5C732A5C28292F692C6B6579776F72643A2F5C62283F3A414354494F4E7C4144447C41465445527C';
wwv_flow_imp.g_varchar2_table(112) := '414C474F524954484D7C414C4C7C414C5445527C414E414C595A457C414E597C4150504C597C41537C4153437C415554484F52495A4154494F4E7C4155544F5F494E4352454D454E547C4241434B55507C4244427C424547494E7C4245524B454C455944';
wwv_flow_imp.g_varchar2_table(113) := '427C424947494E547C42494E4152597C4249547C424C4F427C424F4F4C7C424F4F4C45414E7C425245414B7C42524F5753457C42545245457C42554C4B7C42597C43414C4C7C43415343414445443F7C434153457C434841494E7C43484152283F3A4143';
wwv_flow_imp.g_varchar2_table(114) := '5445527C534554293F7C434845434B283F3A504F494E54293F7C434C4F53457C434C555354455245447C434F414C455343457C434F4C4C4154457C434F4C554D4E533F7C434F4D4D454E547C434F4D4D4954283F3A544544293F7C434F4D505554457C43';
wwv_flow_imp.g_varchar2_table(115) := '4F4E4E4543547C434F4E53495354454E547C434F4E53545241494E547C434F4E5441494E53283F3A5441424C45293F7C434F4E54494E55457C434F4E564552547C4352454154457C43524F53537C43555252454E54283F3A5F444154457C5F54494D457C';
wwv_flow_imp.g_varchar2_table(116) := '5F54494D455354414D507C5F55534552293F7C435552534F527C4359434C457C44415441283F3A42415345533F293F7C44415445283F3A54494D45293F7C4441597C444243437C4445414C4C4F434154457C4445437C444543494D414C7C4445434C4152';
wwv_flow_imp.g_varchar2_table(117) := '457C44454641554C547C444546494E45527C44454C415945447C44454C4554457C44454C494D49544552533F7C44454E597C444553437C44455343524942457C44455445524D494E49535449437C44495341424C457C444953434152447C4449534B7C44';
wwv_flow_imp.g_varchar2_table(118) := '495354494E43547C44495354494E4354524F577C44495354524942555445447C444F7C444F55424C457C44524F507C44554D4D597C44554D50283F3A46494C45293F7C4455504C49434154457C454C5345283F3A4946293F7C454E41424C457C454E434C';
wwv_flow_imp.g_varchar2_table(119) := '4F5345447C454E447C454E47494E457C454E554D7C4552524C564C7C4552524F52537C455343415045443F7C4558434550547C45584543283F3A555445293F7C4558495354537C455849547C4558504C41494E7C455854454E4445447C46455443487C46';
wwv_flow_imp.g_varchar2_table(120) := '49454C44537C46494C457C46494C4C464143544F527C46495253547C46495845447C464C4F41547C464F4C4C4F57494E477C464F52283F3A204541434820524F57293F7C464F5243457C464F524549474E7C4652454554455854283F3A5441424C45293F';
wwv_flow_imp.g_varchar2_table(121) := '7C46524F4D7C46554C4C7C46554E4354494F4E7C47454F4D45545259283F3A434F4C4C454354494F4E293F7C474C4F42414C7C474F544F7C4752414E547C47524F55507C48414E444C45527C484153487C484156494E477C484F4C444C4F434B7C484F55';
wwv_flow_imp.g_varchar2_table(122) := '527C4944454E54495459283F3A434F4C7C5F494E53455254293F7C49467C49474E4F52457C494D504F52547C494E4445587C494E46494C457C494E4E45527C494E4E4F44427C494E4F55547C494E534552547C494E547C494E54454745527C494E544552';
wwv_flow_imp.g_varchar2_table(123) := '534543547C494E54455256414C7C494E544F7C494E564F4B45527C49534F4C4154494F4E7C495445524154457C4A4F494E7C4B4559533F7C4B494C4C7C4C414E47554147457C4C4153547C4C454156457C4C4546547C4C4556454C7C4C494D49547C4C49';
wwv_flow_imp.g_varchar2_table(124) := '4E454E4F7C4C494E45537C4C494E45535452494E477C4C4F41447C4C4F43414C7C4C4F434B7C4C4F4E47283F3A424C4F427C54455854297C4C4F4F507C4D41544348283F3A4544293F7C4D454449554D283F3A424C4F427C494E547C54455854297C4D45';
wwv_flow_imp.g_varchar2_table(125) := '5247457C4D4944444C45494E547C4D494E5554457C4D4F44457C4D4F4449464945537C4D4F444946597C4D4F4E54487C4D554C5449283F3A4C494E45535452494E477C504F494E547C504F4C59474F4E297C4E4154494F4E414C7C4E41545552414C7C4E';
wwv_flow_imp.g_varchar2_table(126) := '434841527C4E4558547C4E4F7C4E4F4E434C555354455245447C4E554C4C49467C4E554D455249437C4F46463F7C4F4646534554533F7C4F4E7C4F50454E283F3A44415441534F555243457C51554552597C524F57534554293F7C4F5054494D495A457C';
wwv_flow_imp.g_varchar2_table(127) := '4F5054494F4E283F3A414C4C59293F7C4F524445527C4F5554283F3A45527C46494C45293F7C4F5645527C5041525449414C7C504152544954494F4E7C50455243454E547C5049564F547C504C414E7C504F494E547C504F4C59474F4E7C505245434544';
wwv_flow_imp.g_varchar2_table(128) := '494E477C505245434953494F4E7C505245504152457C505245567C5052494D4152597C5052494E547C50524956494C454745537C50524F43283F3A4544555245293F7C5055424C49437C50555247457C515549434B7C524149534552524F527C52454144';
wwv_flow_imp.g_varchar2_table(129) := '533F7C5245414C7C5245434F4E4649475552457C5245464552454E4345537C52454C454153457C52454E414D457C524550454154283F3A41424C45293F7C5245504C4143457C5245504C49434154494F4E7C524551554952457C52455349474E414C7C52';
wwv_flow_imp.g_varchar2_table(130) := '4553544F52457C52455354524943547C52455455524E283F3A494E477C53293F7C5245564F4B457C52494748547C524F4C4C4241434B7C524F5554494E457C524F57283F3A434F554E547C47554944434F4C7C53293F7C52545245457C52554C457C5341';
wwv_flow_imp.g_varchar2_table(131) := '5645283F3A504F494E54293F7C534348454D417C5345434F4E447C53454C4543547C53455249414C283F3A495A41424C45293F7C53455353494F4E283F3A5F55534552293F7C534554283F3A55534552293F7C53484152457C53484F577C53485554444F';
wwv_flow_imp.g_varchar2_table(132) := '574E7C53494D504C457C534D414C4C494E547C534E415053484F547C534F4D457C534F4E414D457C53514C7C5354415254283F3A494E47293F7C535441544953544943537C5354415455537C535452495045447C53595354454D5F555345527C5441424C';
wwv_flow_imp.g_varchar2_table(133) := '45533F7C5441424C4553504143457C54454D50283F3A4F524152597C5441424C45293F7C5445524D494E415445447C54455854283F3A53495A45293F7C5448454E7C54494D45283F3A5354414D50293F7C54494E59283F3A424C4F427C494E547C544558';
wwv_flow_imp.g_varchar2_table(134) := '54297C544F503F7C5452414E283F3A53414354494F4E533F293F7C545249474745527C5452554E434154457C5453455155414C7C54595045533F7C554E424F554E4445447C554E434F4D4D49545445447C554E444546494E45447C554E494F4E7C554E49';
wwv_flow_imp.g_varchar2_table(135) := '5155457C554E4C4F434B7C554E5049564F547C554E5349474E45447C555044415445283F3A54455854293F7C55534147457C5553457C555345527C5553494E477C56414C5545533F7C564152283F3A42494E4152597C434841527C434841524143544552';
wwv_flow_imp.g_varchar2_table(136) := '7C59494E47297C564945577C57414954464F527C5741524E494E47537C5748454E7C57484552457C5748494C457C57495448283F3A20524F4C4C55507C494E293F7C574F524B7C5752495445283F3A54455854293F7C59454152295C622F692C626F6F6C';
wwv_flow_imp.g_varchar2_table(137) := '65616E3A2F5C62283F3A46414C53457C4E554C4C7C54525545295C622F692C6E756D6265723A2F5C6230785B5C64612D665D2B5C627C5C625C642B283F3A5C2E5C642A293F7C5C425C2E5C642B5C622F692C6F70657261746F723A2F5B2D2B2A5C2F3D25';
wwv_flow_imp.g_varchar2_table(138) := '5E7E5D7C26263F7C5C7C5C7C3F7C213D3F7C3C283F3A3D3E3F7C3C7C3E293F7C3E5B3E3D5D3F7C5C62283F3A414E447C4245545745454E7C4449567C494C494B457C494E7C49537C4C494B457C4E4F547C4F527C5245474558507C524C494B457C534F55';
wwv_flow_imp.g_varchar2_table(139) := '4E4453204C494B457C584F52295C622F692C70756E6374756174696F6E3A2F5B3B5B5C5D2829602C2E5D2F7D2C507269736D2E6C616E6775616765732E706C73716C3D507269736D2E6C616E6775616765732E657874656E64282273716C222C7B636F6D';
wwv_flow_imp.g_varchar2_table(140) := '6D656E743A7B7061747465726E3A2F5C2F5C2A5B5C735C535D2A3F5C2A5C2F7C2D2D2E2A2F2C6772656564793A21307D2C6B6579776F72643A2F5C62283F3A417C41434345535349424C457C4144447C4147454E547C4147475245474154457C414C4C7C';
wwv_flow_imp.g_varchar2_table(141) := '414C5445527C414E447C414E597C41525241597C41537C4153437C41547C4154545249425554457C4155544849447C4156477C424547494E7C4245545745454E7C4246494C455F424153457C42494E4152597C424C4F425F424153457C424C4F434B7C42';
wwv_flow_imp.g_varchar2_table(142) := '4F44597C424F54487C424F554E447C42554C4B7C42597C425954457C437C43414C4C7C43414C4C494E477C434153434144457C434153457C434841527C4348415241435445527C434841525345547C43484152534554464F524D7C434841525345544944';
wwv_flow_imp.g_varchar2_table(143) := '7C434841525F424153457C434845434B7C434C4F425F424153457C434C4F4E457C434C4F53457C434C55535445527C434C5553544552537C434F4C415554487C434F4C4C4543547C434F4C554D4E537C434F4D4D454E547C434F4D4D49547C434F4D4D49';
wwv_flow_imp.g_varchar2_table(144) := '545445447C434F4D50494C45447C434F4D50524553537C434F4E4E4543547C434F4E5354414E547C434F4E5354525543544F527C434F4E544558547C434F4E54494E55457C434F4E564552547C434F554E547C43524153487C4352454154457C43524544';
wwv_flow_imp.g_varchar2_table(145) := '454E5449414C7C43555252454E547C435552534F527C435553544F4D444154554D7C44414E474C494E477C444154417C444154457C444154455F424153457C4441597C4445434C4152457C44454641554C547C444546494E457C44454C4554457C444553';
wwv_flow_imp.g_varchar2_table(146) := '437C44455445524D494E49535449437C4449524543544F52597C44495354494E43547C444F55424C457C44524F507C4455524154494F4E7C454C454D454E547C454C53457C454C5349467C454D5054597C454E447C4553434150457C4558434550547C45';
wwv_flow_imp.g_varchar2_table(147) := '5843455054494F4E7C455843455054494F4E537C4558434C55534956457C455845435554457C4558495354537C455849547C45585445524E414C7C46455443487C46494E414C7C46495253547C46495845447C464C4F41547C464F527C464F52414C4C7C';
wwv_flow_imp.g_varchar2_table(148) := '464F5243457C46524F4D7C46554E4354494F4E7C47454E4552414C7C474F544F7C4752414E547C47524F55507C484153487C484156494E477C484541507C48494444454E7C484F55527C4944454E5449464945447C49467C494D4D4544494154457C494D';
wwv_flow_imp.g_varchar2_table(149) := '4D555441424C457C494E7C494E434C5544494E477C494E4445587C494E44455845537C494E44494341544F527C494E44494345537C494E46494E4954457C494E534552547C494E5354414E544941424C457C494E547C494E544552464143457C494E5445';
wwv_flow_imp.g_varchar2_table(150) := '52534543547C494E54455256414C7C494E544F7C494E56414C49444154457C49537C49534F4C4154494F4E7C4A4156417C4C414E47554147457C4C415247457C4C454144494E477C4C454E4754487C4C4556454C7C4C4942524152597C4C494B457C4C49';
wwv_flow_imp.g_varchar2_table(151) := '4B45327C4C494B45347C4C494B45437C4C494D49547C4C494D495445447C4C4F43414C7C4C4F434B7C4C4F4E477C4C4F4F507C4D41507C4D41587C4D41584C454E7C4D454D4245527C4D455247457C4D494E7C4D494E55537C4D494E5554457C4D4F447C';
wwv_flow_imp.g_varchar2_table(152) := '4D4F44457C4D4F444946597C4D4F4E54487C4D554C54495345547C4D555441424C457C4E414D457C4E414E7C4E4154494F4E414C7C4E41544956457C4E434841527C4E45577C4E4F434F4D50524553537C4E4F434F50597C4E4F547C4E4F574149547C4E';
wwv_flow_imp.g_varchar2_table(153) := '554C4C7C4E554D4245525F424153457C4F424A4543547C4F4349434F4C4C7C4F4349444154457C4F43494441544554494D457C4F43494455524154494F4E7C4F4349494E54455256414C7C4F43494C4F424C4F4341544F527C4F43494E554D4245527C4F';
wwv_flow_imp.g_varchar2_table(154) := '43495241577C4F43495245467C4F4349524546435552534F527C4F4349524F5749447C4F4349535452494E477C4F4349545950457C4F467C4F4C447C4F4E7C4F4E4C597C4F50415155457C4F50454E7C4F50455241544F527C4F5054494F4E7C4F527C4F';
wwv_flow_imp.g_varchar2_table(155) := '5241434C457C4F5241444154417C4F524445527C4F5247414E495A4154494F4E7C4F524C414E597C4F524C564152597C4F54484552537C4F55547C4F5645524C4150537C4F564552524944494E477C5041434B4147457C504152414C4C454C5F454E4142';
wwv_flow_imp.g_varchar2_table(156) := '4C457C504152414D455445527C504152414D45544552537C504152454E547C504152544954494F4E7C50415343414C7C5045525349535441424C457C504950457C504950454C494E45447C504C55474741424C457C504F4C594D4F52504849437C505241';
wwv_flow_imp.g_varchar2_table(157) := '474D417C505245434953494F4E7C5052494F527C505249564154457C50524F4345445552457C5055424C49437C52414953457C52414E47457C5241577C524541447C5245434F52447C5245467C5245464552454E43457C52454C4945535F4F4E7C52454D';
wwv_flow_imp.g_varchar2_table(158) := '7C52454D41494E4445527C52454E414D457C5245534F555243457C524553554C547C524553554C545F43414348457C52455455524E7C52455455524E494E477C524556455253457C5245564F4B457C524F4C4C4241434B7C524F577C53414D504C457C53';
wwv_flow_imp.g_varchar2_table(159) := '4156457C53415645504F494E547C5342317C5342327C5342347C5345434F4E447C5345474D454E547C53454C4543547C53454C467C53455041524154457C53455155454E43457C53455249414C495A41424C457C5345547C53484152457C53484F52547C';
wwv_flow_imp.g_varchar2_table(160) := '53495A457C53495A455F547C534F4D457C5350415253457C53514C7C53514C434F44457C53514C444154417C53514C4E414D457C53514C53544154457C5354414E444152447C53544152547C5354415449437C5354444445567C53544F5245447C535452';
wwv_flow_imp.g_varchar2_table(161) := '494E477C5354525543547C5354594C457C5355424D554C54495345547C535542504152544954494F4E7C53554253544954555441424C457C535542545950457C53554D7C53594E4F4E594D7C544142415554487C5441424C457C54444F7C5448457C5448';
wwv_flow_imp.g_varchar2_table(162) := '454E7C54494D457C54494D455354414D507C54494D455A4F4E455F414242527C54494D455A4F4E455F484F55527C54494D455A4F4E455F4D494E5554457C54494D455A4F4E455F524547494F4E7C544F7C545241494C494E477C5452414E53414354494F';
wwv_flow_imp.g_varchar2_table(163) := '4E7C5452414E53414354494F4E414C7C545255535445447C545950457C5542317C5542327C5542347C554E4445527C554E494F4E7C554E495155457C554E504C55477C554E5349474E45447C554E545255535445447C5550444154457C5553457C555349';
wwv_flow_imp.g_varchar2_table(164) := '4E477C56414C4953547C56414C55457C56414C5545537C5641524941424C457C56415249414E43457C5641525241597C56415259494E477C564945577C56494557537C564F49447C5748454E7C57484552457C5748494C457C574954487C574F524B7C57';
wwv_flow_imp.g_varchar2_table(165) := '5241505045447C57524954457C594541527C5A4F4E45295C622F692C6F70657261746F723A2F3A3D3F7C3D3E7C5B3C3E5E7E215D3D7C5C2E5C2E7C5C7C5C7C7C5C2A5C2A7C5B2D2B2A2F253C3E3D405D2F7D292C507269736D2E6C616E6775616765732E';
wwv_flow_imp.g_varchar2_table(166) := '696E736572744265666F72652822706C73716C222C226F70657261746F72222C7B6C6162656C3A7B7061747465726E3A2F3C3C5C732A5C772B5C732A3E3E2F2C616C6961733A2273796D626F6C227D7D292C66756E6374696F6E28297B696628766F6964';
wwv_flow_imp.g_varchar2_table(167) := '2030213D3D507269736D262622756E646566696E656422213D747970656F6620646F63756D656E74297B76617220653D226C696E652D6E756D62657273222C743D2F5C6E283F2124292F672C6E3D507269736D2E706C7567696E732E6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(168) := '6572733D7B6765744C696E653A66756E6374696F6E28742C6E297B69662822505245223D3D3D742E7461674E616D652626742E636C6173734C6973742E636F6E7461696E73286529297B76617220723D742E717565727953656C6563746F7228222E6C69';
wwv_flow_imp.g_varchar2_table(169) := '6E652D6E756D626572732D726F777322293B69662872297B76617220613D7061727365496E7428742E6765744174747269627574652822646174612D737461727422292C3130297C7C312C453D612B28722E6368696C6472656E2E6C656E6774682D3129';
wwv_flow_imp.g_varchar2_table(170) := '3B6E3C612626286E3D61292C6E3E452626286E3D45293B76617220693D6E2D613B72657475726E20722E6368696C6472656E5B695D7D7D7D2C726573697A653A66756E6374696F6E2865297B61285B655D297D2C617373756D6556696577706F7274496E';
wwv_flow_imp.g_varchar2_table(171) := '646570656E64656E63653A21307D2C723D766F696420303B77696E646F772E6164644576656E744C697374656E65722822726573697A65222C2866756E6374696F6E28297B6E2E617373756D6556696577706F7274496E646570656E64656E6365262672';
wwv_flow_imp.g_varchar2_table(172) := '3D3D3D77696E646F772E696E6E657257696474687C7C28723D77696E646F772E696E6E657257696474682C612841727261792E70726F746F747970652E736C6963652E63616C6C28646F63756D656E742E717565727953656C6563746F72416C6C282270';
wwv_flow_imp.g_varchar2_table(173) := '72652E6C696E652D6E756D6265727322292929297D29292C507269736D2E686F6F6B732E6164642822636F6D706C657465222C2866756E6374696F6E286E297B6966286E2E636F6465297B76617220723D6E2E656C656D656E742C453D722E706172656E';
wwv_flow_imp.g_varchar2_table(174) := '744E6F64653B6966284526262F7072652F692E7465737428452E6E6F64654E616D6529262621722E717565727953656C6563746F7228222E6C696E652D6E756D626572732D726F777322292626507269736D2E7574696C2E697341637469766528722C65';
wwv_flow_imp.g_varchar2_table(175) := '29297B722E636C6173734C6973742E72656D6F76652865292C452E636C6173734C6973742E6164642865293B76617220692C6F3D6E2E636F64652E6D617463682874292C6C3D6F3F6F2E6C656E6774682B313A312C733D6E6577204172726179286C2B31';
wwv_flow_imp.g_varchar2_table(176) := '292E6A6F696E28223C7370616E3E3C2F7370616E3E22293B28693D646F63756D656E742E637265617465456C656D656E7428227370616E2229292E7365744174747269627574652822617269612D68696464656E222C227472756522292C692E636C6173';
wwv_flow_imp.g_varchar2_table(177) := '734E616D653D226C696E652D6E756D626572732D726F7773222C692E696E6E657248544D4C3D732C452E6861734174747269627574652822646174612D73746172742229262628452E7374796C652E636F756E74657252657365743D226C696E656E756D';
wwv_flow_imp.g_varchar2_table(178) := '62657220222B287061727365496E7428452E6765744174747269627574652822646174612D737461727422292C3130292D3129292C6E2E656C656D656E742E617070656E644368696C642869292C61285B455D292C507269736D2E686F6F6B732E72756E';
wwv_flow_imp.g_varchar2_table(179) := '28226C696E652D6E756D62657273222C6E297D7D7D29292C507269736D2E686F6F6B732E61646428226C696E652D6E756D62657273222C2866756E6374696F6E2865297B652E706C7567696E733D652E706C7567696E737C7C7B7D2C652E706C7567696E';
wwv_flow_imp.g_varchar2_table(180) := '732E6C696E654E756D626572733D21307D29297D66756E6374696F6E20612865297B69662830213D28653D652E66696C746572282866756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B69662821652972657475726E206E756C6C';
wwv_flow_imp.g_varchar2_table(181) := '3B72657475726E2077696E646F772E676574436F6D70757465645374796C653F676574436F6D70757465645374796C652865293A652E63757272656E745374796C657C7C6E756C6C7D2865295B2277686974652D7370616365225D3B72657475726E2270';
wwv_flow_imp.g_varchar2_table(182) := '72652D77726170223D3D3D747C7C227072652D6C696E65223D3D3D747D2929292E6C656E677468297B766172206E3D652E6D6170282866756E6374696F6E2865297B766172206E3D652E717565727953656C6563746F722822636F646522292C723D652E';
wwv_flow_imp.g_varchar2_table(183) := '717565727953656C6563746F7228222E6C696E652D6E756D626572732D726F777322293B6966286E262672297B76617220613D652E717565727953656C6563746F7228222E6C696E652D6E756D626572732D73697A657222292C453D6E2E74657874436F';
wwv_flow_imp.g_varchar2_table(184) := '6E74656E742E73706C69742874293B617C7C2828613D646F63756D656E742E637265617465456C656D656E7428227370616E2229292E636C6173734E616D653D226C696E652D6E756D626572732D73697A6572222C6E2E617070656E644368696C642861';
wwv_flow_imp.g_varchar2_table(185) := '29292C612E696E6E657248544D4C3D2230222C612E7374796C652E646973706C61793D22626C6F636B223B76617220693D612E676574426F756E64696E67436C69656E745265637428292E6865696768743B72657475726E20612E696E6E657248544D4C';
wwv_flow_imp.g_varchar2_table(186) := '3D22222C7B656C656D656E743A652C6C696E65733A452C6C696E65486569676874733A5B5D2C6F6E654C696E65724865696768743A692C73697A65723A617D7D7D29292E66696C74657228426F6F6C65616E293B6E2E666F7245616368282866756E6374';
wwv_flow_imp.g_varchar2_table(187) := '696F6E2865297B76617220743D652E73697A65722C6E3D652E6C696E65732C723D652E6C696E65486569676874732C613D652E6F6E654C696E65724865696768743B725B6E2E6C656E6774682D315D3D766F696420302C6E2E666F724561636828286675';
wwv_flow_imp.g_varchar2_table(188) := '6E6374696F6E28652C6E297B696628652626652E6C656E6774683E31297B76617220453D742E617070656E644368696C6428646F63756D656E742E637265617465456C656D656E7428227370616E2229293B452E7374796C652E646973706C61793D2262';
wwv_flow_imp.g_varchar2_table(189) := '6C6F636B222C452E74657874436F6E74656E743D657D656C736520725B6E5D3D617D29297D29292C6E2E666F7245616368282866756E6374696F6E2865297B666F722876617220743D652E73697A65722C6E3D652E6C696E65486569676874732C723D30';
wwv_flow_imp.g_varchar2_table(190) := '2C613D303B613C6E2E6C656E6774683B612B2B29766F696420303D3D3D6E5B615D2626286E5B615D3D742E6368696C6472656E5B722B2B5D2E676574426F756E64696E67436C69656E745265637428292E686569676874297D29292C6E2E666F72456163';
wwv_flow_imp.g_varchar2_table(191) := '68282866756E6374696F6E2865297B76617220743D652E73697A65722C6E3D652E656C656D656E742E717565727953656C6563746F7228222E6C696E652D6E756D626572732D726F777322293B742E7374796C652E646973706C61793D226E6F6E65222C';
wwv_flow_imp.g_varchar2_table(192) := '742E696E6E657248544D4C3D22222C652E6C696E65486569676874732E666F7245616368282866756E6374696F6E28652C74297B6E2E6368696C6472656E5B745D2E7374796C652E6865696768743D652B227078227D29297D29297D7D7D28292C66756E';
wwv_flow_imp.g_varchar2_table(193) := '6374696F6E28297B696628766F69642030213D3D507269736D262622756E646566696E656422213D747970656F6620646F63756D656E74297B76617220653D5B5D2C743D7B7D2C6E3D66756E6374696F6E28297B7D3B507269736D2E706C7567696E732E';
wwv_flow_imp.g_varchar2_table(194) := '746F6F6C6261723D7B7D3B76617220723D507269736D2E706C7567696E732E746F6F6C6261722E7265676973746572427574746F6E3D66756E6374696F6E286E2C72297B76617220613B613D2266756E6374696F6E223D3D747970656F6620723F723A66';
wwv_flow_imp.g_varchar2_table(195) := '756E6374696F6E2865297B76617220743B72657475726E2266756E6374696F6E223D3D747970656F6620722E6F6E436C69636B3F2828743D646F63756D656E742E637265617465456C656D656E742822627574746F6E2229292E747970653D2262757474';
wwv_flow_imp.g_varchar2_table(196) := '6F6E222C742E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B722E6F6E436C69636B2E63616C6C28746869732C65297D2929293A22737472696E67223D3D747970656F6620722E75726C3F28743D646F6375';
wwv_flow_imp.g_varchar2_table(197) := '6D656E742E637265617465456C656D656E742822612229292E687265663D722E75726C3A743D646F63756D656E742E637265617465456C656D656E7428227370616E22292C722E636C6173734E616D652626742E636C6173734C6973742E61646428722E';
wwv_flow_imp.g_varchar2_table(198) := '636C6173734E616D65292C742E74657874436F6E74656E743D722E746578742C747D2C6E20696E20743F636F6E736F6C652E7761726E28275468657265206973206120627574746F6E207769746820746865206B65792022272B6E2B2722207265676973';
wwv_flow_imp.g_varchar2_table(199) := '746572656420616C72656164792E27293A652E7075736828745B6E5D3D61297D2C613D507269736D2E706C7567696E732E746F6F6C6261722E686F6F6B3D66756E6374696F6E2872297B76617220613D722E656C656D656E742E706172656E744E6F6465';
wwv_flow_imp.g_varchar2_table(200) := '3B6966286126262F7072652F692E7465737428612E6E6F64654E616D6529262621612E706172656E744E6F64652E636C6173734C6973742E636F6E7461696E732822636F64652D746F6F6C6261722229297B76617220453D646F63756D656E742E637265';
wwv_flow_imp.g_varchar2_table(201) := '617465456C656D656E74282264697622293B452E636C6173734C6973742E6164642822636F64652D746F6F6C62617222292C612E706172656E744E6F64652E696E736572744265666F726528452C61292C452E617070656E644368696C642861293B7661';
wwv_flow_imp.g_varchar2_table(202) := '7220693D646F63756D656E742E637265617465456C656D656E74282264697622293B692E636C6173734C6973742E6164642822746F6F6C62617222293B766172206F3D652C6C3D66756E6374696F6E2865297B666F72283B653B297B76617220743D652E';
wwv_flow_imp.g_varchar2_table(203) := '6765744174747269627574652822646174612D746F6F6C6261722D6F7264657222293B6966286E756C6C213D742972657475726E28743D742E7472696D2829292E6C656E6774683F742E73706C6974282F5C732A2C5C732A2F67293A5B5D3B653D652E70';
wwv_flow_imp.g_varchar2_table(204) := '6172656E74456C656D656E747D7D28722E656C656D656E74293B6C2626286F3D6C2E6D6170282866756E6374696F6E2865297B72657475726E20745B655D7C7C6E7D2929292C6F2E666F7245616368282866756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(205) := '2872293B69662874297B766172206E3D646F63756D656E742E637265617465456C656D656E74282264697622293B6E2E636C6173734C6973742E6164642822746F6F6C6261722D6974656D22292C6E2E617070656E644368696C642874292C692E617070';
wwv_flow_imp.g_varchar2_table(206) := '656E644368696C64286E297D7D29292C452E617070656E644368696C642869297D7D3B7228226C6162656C222C2866756E6374696F6E2865297B76617220743D652E656C656D656E742E706172656E744E6F64653B6966287426262F7072652F692E7465';
wwv_flow_imp.g_varchar2_table(207) := '737428742E6E6F64654E616D65292626742E6861734174747269627574652822646174612D6C6162656C2229297B766172206E2C722C613D742E6765744174747269627574652822646174612D6C6162656C22293B7472797B723D646F63756D656E742E';
wwv_flow_imp.g_varchar2_table(208) := '717565727953656C6563746F72282274656D706C61746523222B61297D63617463682865297B7D72657475726E20723F6E3D722E636F6E74656E743A28742E6861734174747269627574652822646174612D75726C22293F286E3D646F63756D656E742E';
wwv_flow_imp.g_varchar2_table(209) := '637265617465456C656D656E742822612229292E687265663D742E6765744174747269627574652822646174612D75726C22293A6E3D646F63756D656E742E637265617465456C656D656E7428227370616E22292C6E2E74657874436F6E74656E743D61';
wwv_flow_imp.g_varchar2_table(210) := '292C6E7D7D29292C507269736D2E686F6F6B732E6164642822636F6D706C657465222C61297D7D28292C66756E6374696F6E28297B66756E6374696F6E206528652C6E297B652E6164644576656E744C697374656E65722822636C69636B222C2866756E';
wwv_flow_imp.g_varchar2_table(211) := '6374696F6E28297B2166756E6374696F6E2865297B6E6176696761746F722E636C6970626F6172643F6E6176696761746F722E636C6970626F6172642E77726974655465787428652E676574546578742829292E7468656E28652E737563636573732C28';
wwv_flow_imp.g_varchar2_table(212) := '66756E6374696F6E28297B742865297D29293A742865297D286E297D29297D66756E6374696F6E20742865297B76617220743D646F63756D656E742E637265617465456C656D656E742822746578746172656122293B742E76616C75653D652E67657454';
wwv_flow_imp.g_varchar2_table(213) := '65787428292C742E7374796C652E746F703D2230222C742E7374796C652E6C6566743D2230222C742E7374796C652E706F736974696F6E3D226669786564222C646F63756D656E742E626F64792E617070656E644368696C642874292C742E666F637573';
wwv_flow_imp.g_varchar2_table(214) := '28292C742E73656C65637428293B7472797B766172206E3D646F63756D656E742E65786563436F6D6D616E642822636F707922293B73657454696D656F7574282866756E6374696F6E28297B6E3F652E7375636365737328293A652E6572726F7228297D';
wwv_flow_imp.g_varchar2_table(215) := '292C31297D63617463682874297B73657454696D656F7574282866756E6374696F6E28297B652E6572726F722874297D292C31297D646F63756D656E742E626F64792E72656D6F76654368696C642874297D766F69642030213D3D507269736D26262275';
wwv_flow_imp.g_varchar2_table(216) := '6E646566696E656422213D747970656F6620646F63756D656E74262628507269736D2E706C7567696E732E746F6F6C6261723F507269736D2E706C7567696E732E746F6F6C6261722E7265676973746572427574746F6E2822636F70792D746F2D636C69';
wwv_flow_imp.g_varchar2_table(217) := '70626F617264222C2866756E6374696F6E2874297B766172206E3D742E656C656D656E742C723D66756E6374696F6E2865297B76617220743D7B636F70793A22436F7079222C22636F70792D6572726F72223A225072657373204374726C2B4320746F20';
wwv_flow_imp.g_varchar2_table(218) := '636F7079222C22636F70792D73756363657373223A22436F7069656421222C22636F70792D74696D656F7574223A3565337D3B666F7228766172206E20696E2074297B666F722876617220723D22646174612D707269736D6A732D222B6E2C613D653B61';
wwv_flow_imp.g_varchar2_table(219) := '262621612E6861734174747269627574652872293B29613D612E706172656E74456C656D656E743B61262628745B6E5D3D612E676574417474726962757465287229297D72657475726E20747D286E292C613D646F63756D656E742E637265617465456C';
wwv_flow_imp.g_varchar2_table(220) := '656D656E742822627574746F6E22293B612E636C6173734E616D653D22636F70792D746F2D636C6970626F6172642D627574746F6E222C612E736574417474726962757465282274797065222C22627574746F6E22293B76617220453D646F63756D656E';
wwv_flow_imp.g_varchar2_table(221) := '742E637265617465456C656D656E7428227370616E22293B72657475726E20612E617070656E644368696C642845292C6F2822636F707922292C6528612C7B676574546578743A66756E6374696F6E28297B72657475726E206E2E74657874436F6E7465';
wwv_flow_imp.g_varchar2_table(222) := '6E747D2C737563636573733A66756E6374696F6E28297B6F2822636F70792D7375636365737322292C6928297D2C6572726F723A66756E6374696F6E28297B6F2822636F70792D6572726F7222292C73657454696D656F7574282866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(223) := '297B2166756E6374696F6E2865297B77696E646F772E67657453656C656374696F6E28292E73656C656374416C6C4368696C6472656E2865297D286E297D292C31292C6928297D7D292C613B66756E6374696F6E206928297B73657454696D656F757428';
wwv_flow_imp.g_varchar2_table(224) := '2866756E6374696F6E28297B6F2822636F707922297D292C725B22636F70792D74696D656F7574225D297D66756E6374696F6E206F2865297B452E74657874436F6E74656E743D725B655D2C612E7365744174747269627574652822646174612D636F70';
wwv_flow_imp.g_varchar2_table(225) := '792D7374617465222C65297D7D29293A636F6E736F6C652E7761726E2822436F707920746F20436C6970626F61726420706C7567696E206C6F61646564206265666F726520546F6F6C62617220706C7567696E2E2229297D28293B0A2F2F2320736F7572';
wwv_flow_imp.g_varchar2_table(226) := '63654D617070696E6755524C3D707269736D2E6A732E6D6170';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(57432074669854671)
,p_file_name=>'lib/prismjs/js/prism.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/lib_prismjs_js_prism_js_map
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22707269736D2E6A73225D2C226E616D6573223A5B225F73656C66222C2277696E646F77222C22576F726B6572476C6F62616C53636F7065222C2273656C66222C22507269736D222C226C61';
wwv_flow_imp.g_varchar2_table(2) := '6E67222C22756E697175654964222C22706C61696E546578744772616D6D6172222C225F222C226D616E75616C222C2264697361626C65576F726B65724D65737361676548616E646C6572222C227574696C222C22656E636F6465222C22746F6B656E73';
wwv_flow_imp.g_varchar2_table(3) := '222C22546F6B656E222C2274797065222C22636F6E74656E74222C22616C696173222C224172726179222C2269734172726179222C226D6170222C227265706C616365222C226F222C224F626A656374222C2270726F746F74797065222C22746F537472';
wwv_flow_imp.g_varchar2_table(4) := '696E67222C2263616C6C222C22736C696365222C226F626A4964222C226F626A222C22646566696E6550726F7065727479222C2276616C7565222C22636C6F6E65222C2264656570436C6F6E65222C2276697369746564222C226964222C226B6579222C';
wwv_flow_imp.g_varchar2_table(5) := '226861734F776E50726F7065727479222C22666F7245616368222C2276222C2269222C226765744C616E6775616765222C22656C656D656E74222C226D222C2265786563222C22636C6173734E616D65222C22746F4C6F77657243617365222C22706172';
wwv_flow_imp.g_varchar2_table(6) := '656E74456C656D656E74222C227365744C616E6775616765222C226C616E6775616765222C22526567457870222C22636C6173734C697374222C22616464222C2263757272656E74536372697074222C22646F63756D656E74222C224572726F72222C22';
wwv_flow_imp.g_varchar2_table(7) := '657272222C22737263222C22737461636B222C2273637269707473222C22676574456C656D656E747342795461674E616D65222C226973416374697665222C2264656661756C7441637469766174696F6E222C226E6F222C22636F6E7461696E73222C22';
wwv_flow_imp.g_varchar2_table(8) := '6C616E677561676573222C22706C61696E222C22706C61696E74657874222C2274657874222C22747874222C22657874656E64222C227265646566222C22696E736572744265666F7265222C22696E73696465222C226265666F7265222C22696E736572';
wwv_flow_imp.g_varchar2_table(9) := '74222C22726F6F74222C226772616D6D6172222C22726574222C22746F6B656E222C226E6577546F6B656E222C226F6C64222C22444653222C2274686973222C2263616C6C6261636B222C2270726F7065727479222C2270726F70657274795479706522';
wwv_flow_imp.g_varchar2_table(10) := '2C22706C7567696E73222C22686967686C69676874416C6C222C226173796E63222C22686967686C69676874416C6C556E646572222C22636F6E7461696E6572222C22656E76222C2273656C6563746F72222C22686F6F6B73222C2272756E222C22656C';
wwv_flow_imp.g_varchar2_table(11) := '656D656E7473222C226170706C79222C22717565727953656C6563746F72416C6C222C22686967686C69676874456C656D656E74222C22706172656E74222C226E6F64654E616D65222C22636F6465222C2274657874436F6E74656E74222C22696E7365';
wwv_flow_imp.g_varchar2_table(12) := '7274486967686C696768746564436F6465222C22686967686C696768746564436F6465222C22696E6E657248544D4C222C22686173417474726962757465222C22736574417474726962757465222C22576F726B6572222C22776F726B6572222C226669';
wwv_flow_imp.g_varchar2_table(13) := '6C656E616D65222C226F6E6D657373616765222C22657674222C2264617461222C22706F73744D657373616765222C224A534F4E222C22737472696E67696679222C22696D6D656469617465436C6F7365222C22686967686C69676874222C22746F6B65';
wwv_flow_imp.g_varchar2_table(14) := '6E697A65222C2272657374222C22746F6B656E4C697374222C224C696E6B65644C697374222C226164644166746572222C2268656164222C226D617463684772616D6D6172222C226C697374222C226172726179222C226E6F6465222C226E657874222C';
wwv_flow_imp.g_varchar2_table(15) := '227461696C222C2270757368222C22746F4172726179222C22616C6C222C226E616D65222C2263616C6C6261636B73222C226C656E677468222C226D617463686564537472222C226D617463685061747465726E222C227061747465726E222C22706F73';
wwv_flow_imp.g_varchar2_table(16) := '222C226C6F6F6B626568696E64222C226C617374496E646578222C226D61746368222C226C6F6F6B626568696E644C656E677468222C22696E646578222C2273746172744E6F6465222C227374617274506F73222C2272656D61746368222C2270617474';
wwv_flow_imp.g_varchar2_table(17) := '65726E73222C226A222C226361757365222C227061747465726E4F626A222C22677265656479222C22676C6F62616C222C22666C616773222C22736F75726365222C2263757272656E744E6F6465222C227265616368222C22737472222C2272656D6F76';
wwv_flow_imp.g_varchar2_table(18) := '65436F756E74222C2266726F6D222C22746F222C2270222C226B222C226D61746368537472222C226166746572222C2272656D6F766546726F6D222C2270726576222C2272656D6F766552616E6765222C226E657374656452656D61746368222C226E65';
wwv_flow_imp.g_varchar2_table(19) := '774E6F6465222C22636F756E74222C2273222C2265222C22746167222C22636C6173736573222C2261747472696275746573222C22616C6961736573222C226A6F696E222C226164644576656E744C697374656E6572222C226D657373616765222C2270';
wwv_flow_imp.g_varchar2_table(20) := '61727365222C22636C6F7365222C22736372697074222C22686967686C696768744175746F6D61746963616C6C7943616C6C6261636B222C2272656164795374617465222C226465666572222C2272657175657374416E696D6174696F6E4672616D6522';
wwv_flow_imp.g_varchar2_table(21) := '2C2273657454696D656F7574222C226D6F64756C65222C226578706F727473222C226A736F6E222C22737472696E67222C22636F6D6D656E74222C226E756D626572222C2270756E6374756174696F6E222C226F70657261746F72222C22626F6F6C6561';
wwv_flow_imp.g_varchar2_table(22) := '6E222C226E756C6C222C227765626D616E6966657374222C226C6F67222C22657863657074696F6E222C226B6579776F7264222C2266756E6374696F6E222C226C6576656C222C22736570617261746F72222C2275726C222C22656D61696C222C22646F';
wwv_flow_imp.g_varchar2_table(23) := '6D61696E222C2275756964222C2268617368222C2264617465222C2274696D65222C2273716C222C227661726961626C65222C226964656E746966696572222C22706C73716C222C226C6162656C222C22504C5547494E5F4E414D45222C224E45575F4C';
wwv_flow_imp.g_varchar2_table(24) := '494E455F455850222C22636F6E666967222C226C696E654E756D62657273222C226765744C696E65222C227461674E616D65222C226C696E654E756D626572526F7773222C22717565727953656C6563746F72222C226C696E654E756D62657253746172';
wwv_flow_imp.g_varchar2_table(25) := '74222C227061727365496E74222C22676574417474726962757465222C226C696E654E756D626572456E64222C226368696C6472656E222C226C696E65496E646578222C22726573697A65222C22726573697A65456C656D656E7473222C22617373756D';
wwv_flow_imp.g_varchar2_table(26) := '6556696577706F7274496E646570656E64656E6365222C226C6173745769647468222C22756E646566696E6564222C22696E6E65725769647468222C22707265222C2274657374222C2272656D6F7665222C226C696E654E756D62657273577261707065';
wwv_flow_imp.g_varchar2_table(27) := '72222C226C696E65734E756D222C226C696E6573222C22637265617465456C656D656E74222C227374796C65222C22636F756E7465725265736574222C22617070656E644368696C64222C2266696C746572222C2277686974655370616365222C226765';
wwv_flow_imp.g_varchar2_table(28) := '74436F6D70757465645374796C65222C2263757272656E745374796C65222C226765745374796C6573222C22696E666F73222C22636F6465456C656D656E74222C226C696E654E756D62657253697A6572222C22636F64654C696E6573222C2273706C69';
wwv_flow_imp.g_varchar2_table(29) := '74222C22646973706C6179222C226F6E654C696E6572486569676874222C22676574426F756E64696E67436C69656E7452656374222C22686569676874222C226C696E6548656967687473222C2273697A6572222C22426F6F6C65616E222C22696E666F';
wwv_flow_imp.g_varchar2_table(30) := '222C226C696E65222C226368696C64496E646578222C2277726170706572222C226C696E654E756D626572222C226E6F6F70222C22746F6F6C626172222C227265676973746572427574746F6E222C226F707473222C226F6E436C69636B222C22687265';
wwv_flow_imp.g_varchar2_table(31) := '66222C22636F6E736F6C65222C227761726E222C22686F6F6B222C22706172656E744E6F6465222C22656C656D656E7443616C6C6261636B73222C226F72646572222C227472696D222C226765744F72646572222C226974656D222C2274656D706C6174';
wwv_flow_imp.g_varchar2_table(32) := '65222C227265676973746572436C6970626F617264222C22636F7079496E666F222C226E6176696761746F72222C22636C6970626F617264222C22777269746554657874222C2267657454657874222C227468656E222C2273756363657373222C226661';
wwv_flow_imp.g_varchar2_table(33) := '6C6C6261636B436F707954657874546F436C6970626F617264222C22636F707954657874546F436C6970626F617264222C227465787441726561222C22746F70222C226C656674222C22706F736974696F6E222C22626F6479222C22666F637573222C22';
wwv_flow_imp.g_varchar2_table(34) := '73656C656374222C227375636365737366756C222C2265786563436F6D6D616E64222C226572726F72222C2272656D6F76654368696C64222C2273657474696E6773222C227374617274456C656D656E74222C22636F7079222C2261747472222C226765';
wwv_flow_imp.g_varchar2_table(35) := '7453657474696E6773222C226C696E6B436F7079222C226C696E6B5370616E222C227365745374617465222C22726573657454657874222C2267657453656C656374696F6E222C2273656C656374416C6C4368696C6472656E222C2273656C656374456C';
wwv_flow_imp.g_varchar2_table(36) := '656D656E7454657874222C227374617465225D2C226D617070696E6773223A22414149412C49414149412C4D414132422C6F42414158432C4F41436A42412C4F414536422C6F4241417442432C6D4241417143432C674241416742442C6B424143314443';
wwv_flow_imp.g_varchar2_table(37) := '2C4B4143412C47415744432C4D4141532C534141554A2C47414774422C494141494B2C4541414F2C3043414350432C454141572C45414758432C4541416D422C4741476E42432C454141492C4341734250432C4F414151542C4541414D492C4F4141534A';
wwv_flow_imp.g_varchar2_table(38) := '2C4541414D492C4D41414D4B2C4F4173426E43432C344241413642562C4541414D492C4F4141534A2C4541414D492C4D41414D4D2C344241577844432C4B41414D2C4341434C432C4F4141512C53414153412C4541414F432C47414376422C4F41414941';
wwv_flow_imp.g_varchar2_table(39) := '2C6141416B42432C454143642C49414149412C4541414D442C4541414F452C4B41414D482C4541414F432C4541414F472C53414155482C4541414F492C4F41436E44432C4D41414D432C514141514E2C4741436A42412C4541414F4F2C49414149522C47';
wwv_flow_imp.g_varchar2_table(40) := '414558432C4541414F512C514141512C4B41414D2C53414153412C514141512C4B41414D2C51414151412C514141512C554141572C4D416F4268464E2C4B41414D2C534141554F2C474143662C4F41414F432C4F41414F432C55414155432C5341415343';
wwv_flow_imp.g_varchar2_table(41) := '2C4B41414B4A2C474141474B2C4D41414D2C474141492C4941537044432C4D41414F2C53414155432C47414968422C4F41484B412C454141552C4D4143644E2C4F41414F4F2C65414165442C4541414B2C4F4141512C43414145452C514141537A422C49';
wwv_flow_imp.g_varchar2_table(42) := '4145784375422C454141552C4D41616C42472C4D41414F2C53414153432C45414155582C45414147592C47414735422C49414149462C45414157472C454143662C4F414841442C45414155412C474141572C4741476231422C45414145472C4B41414B49';
wwv_flow_imp.g_varchar2_table(43) := '2C4B41414B4F2C4941436E422C4941414B2C5341454A2C47414441612C4541414B33422C45414145472C4B41414B69422C4D41414D4E2C47414364592C45414151432C474143582C4F41414F442C45414151432C47414B68422C4941414B2C4941414943';
wwv_flow_imp.g_varchar2_table(44) := '2C4B4148544A2C45414132432C4741433343452C45414151432C4741414D482C45414545562C45414358412C45414145652C65414165442C4B414370424A2C4541414D492C4741414F482C45414155582C45414145632C4741414D462C4941496A432C4F';
wwv_flow_imp.g_varchar2_table(45) := '414130422C45414533422C4941414B2C5141454A2C4F414441432C4541414B33422C45414145472C4B41414B69422C4D41414D4E2C47414364592C45414151432C4741434A442C45414151432C4941456842482C454141512C47414352452C4541415143';
wwv_flow_imp.g_varchar2_table(46) := '2C4741414D482C454145642C45414138434D2C534141512C53414155432C45414147432C4741436C45522C4541414D512C4741414B502C454141554D2C454141474C2C4D4147432C47414533422C514143432C4F41414F5A2C494159566D422C59414161';
wwv_flow_imp.g_varchar2_table(47) := '2C53414155432C47414374422C4B41414F412C474141532C434143662C49414149432C4541414974432C4541414B75432C4B41414B462C45414151472C57414331422C47414149462C454143482C4F41414F412C454141452C47414147472C634145624A';
wwv_flow_imp.g_varchar2_table(48) := '2C45414155412C454141514B2C6341456E422C4D41414F2C51415552432C594141612C534141554E2C454141534F2C4741472F42502C45414151472C55414159482C45414151472C5541415578422C5141415136422C4F41414F37432C4541414D2C4D41';
wwv_flow_imp.g_varchar2_table(49) := '414F2C4941496C4571432C45414151532C55414155432C494141492C59414163482C4941557243492C634141652C574143642C47414177422C6F42414162432C534143562C4F41414F2C4B4145522C474141492C6B4241416D42412C53414374422C4F41';
wwv_flow_imp.g_varchar2_table(50) := '413242412C53414173422C63414F6C442C494143432C4D41414D2C49414149432C4D4143542C4D41414F432C474151522C49414149432C4741414F2C714341417143622C4B41414B592C45414149452C514141552C494141492C47414376452C47414149';
wwv_flow_imp.g_varchar2_table(51) := '442C4541414B2C434143522C49414149452C454141554C2C534141534D2C7142414171422C55414335432C4941414B2C4941414970422C4B41414B6D422C454143622C47414149412C454141516E422C4741414769422C4B41414F412C45414372422C4F';
wwv_flow_imp.g_varchar2_table(52) := '41414F452C454141516E422C4741496C422C4F41414F2C4F4175425471422C534141552C534141556E422C45414153472C4541415769422C47414776432C494146412C49414149432C4541414B2C4D4141516C422C45414556482C474141532C43414366';
wwv_flow_imp.g_varchar2_table(53) := '2C49414149532C45414159542C45414151532C55414378422C47414149412C45414155612C534141536E422C47414374422C4F41414F2C454145522C474141494D2C45414155612C53414153442C47414374422C4F41414F2C4541455272422C45414155';
wwv_flow_imp.g_varchar2_table(54) := '412C454141514B2C6341456E422C51414153652C49415758472C554141572C43414956432C4D41414F33442C4541435034442C5541415735442C4541435836442C4B41414D37442C4541434E38442C4941414B39442C454138424C2B442C4F4141512C53';
wwv_flow_imp.g_varchar2_table(55) := '4141556E432C454141496F432C47414372422C494141496C452C4541414F472C45414145472C4B41414B71422C4D41414D78422C4541414579442C5541415539422C49414570432C4941414B2C49414149432C4B41414F6D432C454143666C452C454141';
wwv_flow_imp.g_varchar2_table(56) := '4B2B422C4741414F6D432C4541414D6E432C4741476E422C4F41414F2F422C47413845526D452C614141632C53414155432C45414151432C45414151432C45414151432C4741452F432C49414149432C4741444A442C4541414F412C474141344270452C';
wwv_flow_imp.g_varchar2_table(57) := '454141572C574143334269452C474145664B2C4541414D2C474145562C4941414B2C49414149432C4B414153462C4541436A422C47414149412C4541415178432C6541416530432C474141512C4341456C432C47414149412C474141534C2C4541435A2C';
wwv_flow_imp.g_varchar2_table(58) := '4941414B2C494141494D2C4B4141594C2C4541436842412C4541414F74432C6541416532432C4B41437A42462C45414149452C474141594C2C4541414F4B2C49414D72424C2C4541414F74432C6541416530432C4B41433142442C45414149432C474141';
wwv_flow_imp.g_varchar2_table(59) := '53462C45414151452C49414B78422C49414149452C4541414D4C2C4541414B482C474155662C4F415441472C4541414B482C474141554B2C4541476674452C4541414579442C5541415569422C4941414931452C4541414579442C574141572C53414155';
wwv_flow_imp.g_varchar2_table(60) := '37422C4541414B4C2C4741437643412C494141556B442C4741414F37432C4741414F71432C4941433342552C4B41414B2F432C4741414F30432C4D414950412C47414952492C4941414B2C53414153412C4541414935442C4541414738442C4541415572';
wwv_flow_imp.g_varchar2_table(61) := '452C4541414D6D422C4741437043412C45414155412C474141572C47414572422C494141494E2C4541415170422C45414145472C4B41414B69422C4D41456E422C4941414B2C49414149592C4B41414B6C422C454143622C47414149412C45414145652C';
wwv_flow_imp.g_varchar2_table(62) := '65414165472C474141492C434143784234432C4541415331442C4B41414B4A2C454141476B422C454141476C422C454141456B422C474141497A422C4741415179422C4741456C432C4941414936432C454141572F442C454141456B422C474143623843';
wwv_flow_imp.g_varchar2_table(63) := '2C4541416539452C45414145472C4B41414B492C4B41414B73452C474145562C5741416A42432C474141384270442C454141514E2C4541414D79442C49414770422C5541416A42432C474141364270442C454141514E2C4541414D79442C4D414372446E';
wwv_flow_imp.g_varchar2_table(64) := '442C454141514E2C4541414D79442C4B4141612C4541433342482C45414149472C45414155442C4541415535432C454141474E2C4B414A3342412C454141514E2C4541414D79442C4B4141612C4541433342482C45414149472C45414155442C45414155';
wwv_flow_imp.g_varchar2_table(65) := '2C4B41414D6C442C4F41556E4371442C514141532C47416354432C614141632C53414155432C4541414F4C2C474143394235452C454141456B462C6B4241416B4270432C534141556D432C4541414F4C2C49416B4274434D2C6B4241416D422C53414155';
wwv_flow_imp.g_varchar2_table(66) := '432C45414157462C4541414F4C2C47414339432C49414149512C4541414D2C43414354522C53414155412C454143564F2C55414157412C45414358452C534141552C6F4741475872462C4541414573462C4D41414D432C494141492C734241417542482C';
wwv_flow_imp.g_varchar2_table(67) := '4741456E43412C45414149492C5341415739452C4D41414D4D2C55414155472C4D41414D73452C4D41414D4C2C45414149442C554141554F2C6942414169424E2C45414149432C574145394572462C4541414573462C4D41414D432C494141492C674341';
wwv_flow_imp.g_varchar2_table(68) := '416943482C47414537432C4941414B2C494141576C442C45414150462C454141492C45414161452C454141556B442C45414149492C5341415378442C4D4143684468432C4541414532462C6942414169427A442C4741416D422C494141562B432C454141';
wwv_flow_imp.g_varchar2_table(69) := '6742472C45414149522C574167436C44652C694241416B422C534141557A442C454141532B432C4541414F4C2C47414533432C494141496E432C454141577A432C45414145472C4B41414B38422C59414159432C47414339426D432C4541415572452C45';
wwv_flow_imp.g_varchar2_table(70) := '41414579442C5541415568422C47414731427A432C45414145472C4B41414B71432C594141594E2C454141534F2C47414735422C494141496D442C4541415331442C454141514B2C6341436A4271442C47414134432C5141416C43412C4541414F432C53';
wwv_flow_imp.g_varchar2_table(71) := '41415376442C654143374274432C45414145472C4B41414B71432C594141596F442C454141516E442C47414735422C4941454932432C4541414D2C434143546C442C51414153412C454143544F2C53414155412C4541435634422C51414153412C454143';
wwv_flow_imp.g_varchar2_table(72) := '5479422C4B414E5535442C4541415136442C6141536E422C53414153432C4541417342432C4741433942622C45414149612C674241416B42412C45414574426A472C4541414573462C4D41414D432C494141492C674241416942482C4741453742412C45';
wwv_flow_imp.g_varchar2_table(73) := '4141496C442C5141415167452C55414159642C45414149612C6742414535426A472C4541414573462C4D41414D432C494141492C6B4241416D42482C4741432F4270462C4541414573462C4D41414D432C494141492C57414159482C4741437842522C47';
wwv_flow_imp.g_varchar2_table(74) := '414159412C4541415331442C4B41414B6B452C454141496C442C5341572F422C474152416C432C4541414573462C4D41414D432C494141492C734241417542482C4941476E43512C45414153522C454141496C442C514141514B2C6742414332422C5141';
wwv_flow_imp.g_varchar2_table(75) := '416C4371442C4541414F432C5341415376442C67424141344273442C4541414F4F2C614141612C6141433745502C4541414F512C614141612C574141592C4D4147354268422C45414149552C4B4147522C4F41464139462C4541414573462C4D41414D43';
wwv_flow_imp.g_varchar2_table(76) := '2C494141492C57414159482C5141437842522C47414159412C4541415331442C4B41414B6B452C454141496C442C55414D2F422C474146416C432C4541414573462C4D41414D432C494141492C6D4241416F42482C4741453342412C45414149662C5141';
wwv_flow_imp.g_varchar2_table(77) := '4B542C47414149592C474141537A462C4541414D36472C4F4141512C43414331422C49414149432C454141532C49414149442C4F41414F72472C4541414575472C5541453142442C4541414F452C554141592C53414155432C4741433542542C45414173';
wwv_flow_imp.g_varchar2_table(78) := '42532C45414149432C4F414733424A2C4541414F4B2C59414159432C4B41414B432C554141552C4341436A4370452C5341415532432C4541414933432C5341436471442C4B41414D562C45414149552C4B41435667422C6742414167422C5541476A4264';
wwv_flow_imp.g_varchar2_table(79) := '2C454141734268472C454141452B472C5541415533422C45414149552C4B41414D562C45414149662C51414153652C4541414933432C6742416A42374475442C454141734268472C45414145472C4B41414B432C4F41414F67462C45414149552C514179';
wwv_flow_imp.g_varchar2_table(80) := '43314369422C554141572C534141556E442C4541414D532C4541415335422C4741436E432C4941414932432C4541414D2C43414354552C4B41414D6C432C4541434E532C51414153412C4541435435422C53414155412C474147582C474144417A432C45';
wwv_flow_imp.g_varchar2_table(81) := '41414573462C4D41414D432C494141492C6B4241416D42482C4941433142412C45414149662C514143522C4D41414D2C4941414974422C4D41414D2C694241416D4271432C4541414933432C534141572C714241496E442C4F41464132432C454141492F';
wwv_flow_imp.g_varchar2_table(82) := '452C4F4141534C2C4541414567482C5341415335422C45414149552C4B41414D562C45414149662C534143744372452C4541414573462C4D41414D432C494141492C694241416B42482C474143764239452C4541414D75472C5541415537472C45414145';
wwv_flow_imp.g_varchar2_table(83) := '472C4B41414B432C4F41414F67462C454141492F452C514141532B452C4541414933432C57413242764475452C534141552C5341415570442C4541414D532C4741437A422C4941414934432C4541414F35432C4541415134432C4B41436E422C47414149';
wwv_flow_imp.g_varchar2_table(84) := '412C4541414D2C434143542C4941414B2C4941414931432C4B41415330432C4541436A4235432C45414151452C4741415330432C4541414B31432C5541476842462C4541415134432C4B414768422C49414149432C454141592C49414149432C45414B70';
wwv_flow_imp.g_varchar2_table(85) := '422C4F414A41432C45414153462C45414157412C45414155472C4B41414D7A442C474145704330442C4541416131442C4541414D73442C4541415737432C4541415336432C45414155472C4B41414D2C474179617A442C5341416942452C47414368422C';
wwv_flow_imp.g_varchar2_table(86) := '49414149432C454141512C47414352432C4541414F462C4541414B462C4B41414B4B2C4B414372422C4B41414F442C49414153462C4541414B492C4D41437042482C4541414D492C4B41414B482C4541414B6C472C4F414368426B472C4541414F412C45';
wwv_flow_imp.g_varchar2_table(87) := '41414B432C4B4145622C4F41414F462C45413961434B2C43414151582C494151684235422C4D41414F2C4341434E77432C4941414B2C4741634C6C462C4941414B2C534141556D462C4541414D6E442C47414370422C49414149552C4541415174462C45';
wwv_flow_imp.g_varchar2_table(88) := '41414573462C4D41414D77432C494145704278432C4541414D79432C474141517A432C4541414D79432C494141532C47414537427A432C4541414D79432C4741414D482C4B41414B68442C4941596C42572C4941414B2C5341415577432C4541414D3343';
wwv_flow_imp.g_varchar2_table(89) := '2C47414370422C4941414934432C4541415968492C4541414573462C4D41414D77432C49414149432C47414535422C4741414B432C47414163412C45414155432C4F414937422C4941414B2C4941415772442C4541415035432C454141492C4541416334';
wwv_flow_imp.g_varchar2_table(90) := '432C454141576F442C4541415568472C4D41432F4334432C45414153512C4B414B5A39452C4D41414F412C47417142522C53414153412C4541414D432C4541414D432C45414153432C4541414F79482C474155704376442C4B41414B70452C4B41414F41';
wwv_flow_imp.g_varchar2_table(91) := '2C4541535A6F452C4B41414B6E452C51414155412C454151666D452C4B41414B6C452C4D414151412C454145626B452C4B41414B73442C4F414171432C4741413342432C474141632C49414149442C4F4138456C432C53414153452C45414161432C4541';
wwv_flow_imp.g_varchar2_table(92) := '4153432C4541414B7A452C4541414D30452C4741437A43462C45414151472C55414159462C45414370422C49414149472C454141514A2C4541415168472C4B41414B77422C4741437A422C4741414934452C47414153462C47414163452C4541414D2C47';
wwv_flow_imp.g_varchar2_table(93) := '4141492C43414570432C49414149432C4541416D42442C4541414D2C47414147502C4F414368434F2C4541414D452C4F414153442C45414366442C4541414D2C4741414B412C4541414D2C4741414772482C4D41414D73482C47414533422C4F41414F44';
wwv_flow_imp.g_varchar2_table(94) := '2C45416942522C534141536C422C4541416131442C4541414D73442C4541415737432C4541415373452C45414157432C45414155432C47414370452C4941414B2C4941414974452C4B414153462C4541436A422C4741414B412C4541415178432C654141';
wwv_flow_imp.g_varchar2_table(95) := '6530432C49414157462C45414151452C4741412F432C434149412C4941414975452C454141577A452C45414151452C474143764275452C4541415770492C4D41414D432C514141516D492C47414159412C454141572C43414143412C4741456A442C4941';
wwv_flow_imp.g_varchar2_table(96) := '414B2C49414149432C454141492C45414147412C45414149442C45414153622C53414155632C454141472C4341437A432C47414149462C47414157412C45414151472C4F4141537A452C454141512C4941414D77452C45414337432C4F4147442C494141';
wwv_flow_imp.g_varchar2_table(97) := '49452C45414161482C45414153432C474143744239452C4541415367462C4541415768462C4F4143704271452C49414165572C45414157582C5741433142592C49414157442C45414157432C4F414374427A492C4541415177492C4541415778492C4D41';
wwv_flow_imp.g_varchar2_table(98) := '4576422C4741414979492C49414157442C45414157622C51414151652C4F4141512C4341457A432C49414149432C45414151482C45414157622C514141516E482C5741415775482C4D41414D2C614141612C4741433744532C45414157622C5141415531';
wwv_flow_imp.g_varchar2_table(99) := '462C4F41414F75472C45414157622C5141415169422C4F414151442C454141512C4B414D68452C494146412C4941414968422C45414155612C45414157622C53414157612C4541472F424B2C45414163582C454141556A422C4B41414D572C4541414D4F';
wwv_flow_imp.g_varchar2_table(100) := '2C4541437843552C494141674270432C45414155532C51414974426B422C47414157522C4741414F512C45414151552C4F414839426C422C4741414F69422C454141592F482C4D41414D30472C4F41415171422C45414163412C4541415935422C4B4143';
wwv_flow_imp.g_varchar2_table(101) := '31442C43414D442C4941414938422C4541414D462C454141592F482C4D414574422C4741414932462C45414155652C4F41415372452C4541414B71452C4F414533422C4F4147442C4B41414975422C614141656C4A2C4741416E422C434149412C494143';
wwv_flow_imp.g_varchar2_table(102) := '496B492C4541444169422C454141632C4541476C422C47414149502C454141512C434145582C4B414441562C454141514C2C45414161432C45414153432C4541414B7A452C4541414D30452C4B41433342452C4541414D452C4F41415339452C4541414B';
wwv_flow_imp.g_varchar2_table(103) := '71452C4F41436A432C4D4147442C4941414979422C4541414F6C422C4541414D452C4D41436269422C4541414B6E422C4541414D452C4D414151462C4541414D2C47414147502C4F4143354232422C4541414976422C454149522C4941444175422C4741';
wwv_flow_imp.g_varchar2_table(104) := '414B4E2C454141592F482C4D41414D30472C4F4143684279422C47414151452C47414564412C494144414E2C45414163412C4541415935422C4D4143546E472C4D41414D30472C4F414F78422C47414841492C4541444175422C4741414B4E2C45414159';
wwv_flow_imp.g_varchar2_table(105) := '2F482C4D41414D30472C4F41496E4271422C454141592F482C6942414169426A422C45414368432C534149442C494143432C49414149754A2C45414149502C454143524F2C4941414D33432C45414155532C4F41415369432C45414149442C4741417942';
wwv_flow_imp.g_varchar2_table(106) := '2C694241415A452C4541414574492C4F4143354373492C45414149412C454141456E432C4B41454E2B422C49414341472C4741414B432C4541414574492C4D41414D30472C4F41456477422C49414741442C4541414D35462C4541414B7A432C4D41414D';
wwv_flow_imp.g_varchar2_table(107) := '6B482C4541414B75422C474143744270422C4541414D452C4F4141534C2C4F4147662C4B414441472C454141514C2C45414161432C454141532C454141476F422C4541414B6C422C49414572432C53414B456F422C4541414F6C422C4541414D452C4D41';
wwv_flow_imp.g_varchar2_table(108) := '416A422C494143496F422C4541415774422C4541414D2C4741436A4274452C4541415373462C4541414972492C4D41414D2C4541414775492C47414374424B2C45414151502C4541414972492C4D41414D75492C4541414F492C4541415337422C514145';
wwv_flow_imp.g_varchar2_table(109) := '6C4373422C454141516C422C4541414D6D422C4541414976422C4F41436C42592C47414157552C45414151562C45414151552C5141433942562C45414151552C4D414151412C4741476A422C49414149532C45414161562C45414159572C4B4167423742';
wwv_flow_imp.g_varchar2_table(110) := '2C474164492F462C4941434838462C4541416135432C45414153462C4541415738432C4541415939462C47414337436D452C4741414F6E452C4541414F2B442C5141476669432C4541415968442C4541415738432C45414159502C4741476E43482C4541';
wwv_flow_imp.g_varchar2_table(111) := '41636C432C45414153462C4541415738432C45414470422C49414149314A2C4541414D69452C4541414F4E2C454141536A452C4541414567482C5341415338432C4541415537462C4741415536462C45414155724A2C4541414F714A2C4941477046432C';
wwv_flow_imp.g_varchar2_table(112) := '4741434833432C45414153462C454141576F432C45414161532C47414739424E2C454141632C454141472C43414B70422C49414149552C45414167422C4341436E426E422C4D41414F7A452C454141512C4941414D77452C4541437242512C4D41414F41';
wwv_flow_imp.g_varchar2_table(113) := '2C474145526A432C4541416131442C4541414D73442C4541415737432C4541415369462C45414159572C4B41414D35422C4541414B38422C474147314474422C4741415773422C454141635A2C4D414151562C45414151552C5141433543562C45414151';
wwv_flow_imp.g_varchar2_table(114) := '552C4D414151592C454141635A2C5941714270432C5341415370432C494145522C49414149452C4541414F2C4341414539462C4D41414F2C4B41414D30492C4B41414D2C4B41414D76432C4B41414D2C4D41457843432C4541414F2C4341414570472C4D';
wwv_flow_imp.g_varchar2_table(115) := '41414F2C4B41414D30492C4B41414D35432C4541414D4B2C4B41414D2C4D414335434C2C4541414B4B2C4B41414F432C4541475A68442C4B41414B30432C4B41414F412C4541455A31432C4B41414B67442C4B41414F412C4541435A68442C4B41414B73';
wwv_flow_imp.g_varchar2_table(116) := '442C4F4141532C454159662C53414153622C45414153472C4541414D452C4541414D6C472C47414537422C494141496D472C4541414F442C4541414B432C4B41455A30432C454141552C4341414537492C4D41414F412C4541414F30492C4B41414D7843';
wwv_flow_imp.g_varchar2_table(117) := '2C4541414D432C4B41414D412C47414B68442C4F414A41442C4541414B432C4B41414F30432C4541435A31432C4541414B75432C4B41414F472C4541435A37432C4541414B552C534145456D432C454155522C53414153462C4541415933432C4541414D';
wwv_flow_imp.g_varchar2_table(118) := '452C4541414D34432C47414568432C494144412C4941414933432C4541414F442C4541414B432C4B41435031462C454141492C45414147412C4541414971492C4741415333432C49414153482C4541414B492C4B41414D33462C494143684430462C4541';
wwv_flow_imp.g_varchar2_table(119) := '414F412C4541414B412C4B414562442C4541414B432C4B41414F412C4541435A412C4541414B75432C4B41414F78432C4541435A462C4541414B552C514141556A472C45416B4268422C474133584178432C4541414D492C4D414151492C45412B45644D';
wwv_flow_imp.g_varchar2_table(120) := '2C4541414D75472C554141592C53414153412C454141552F462C4541414732422C47414376432C47414167422C694241414C33422C454143562C4F41414F412C454145522C474141494A2C4D41414D432C51414151472C474141492C43414372422C4941';
wwv_flow_imp.g_varchar2_table(121) := '4149774A2C454141492C474149522C4F414841784A2C4541414567422C534141512C5341415579492C4741436E42442C4741414B7A442C4541415530442C4541414739482C4D41455A36482C454147522C494141496C462C4541414D2C4341435437452C';
wwv_flow_imp.g_varchar2_table(122) := '4B41414D4F2C45414145502C4B414352432C5141415371472C454141552F462C454141454E2C5141415369432C47414339422B482C4941414B2C4F41434C432C514141532C434141432C51414153334A2C45414145502C4D414372426D4B2C574141592C';
wwv_flow_imp.g_varchar2_table(123) := '4741435A6A492C53414155412C474147506B492C45414155374A2C454141454C2C4D41435A6B4B2C494143436A4B2C4D41414D432C51414151674B2C4741436A426A4B2C4D41414D4D2C5541415534472C4B41414B6E432C4D41414D4C2C454141497146';
wwv_flow_imp.g_varchar2_table(124) := '2C51414153452C474145784376462C4541414971462C5141415137432C4B41414B2B432C4941496E42334B2C4541414573462C4D41414D432C494141492C4F414151482C47414570422C4941414973462C454141612C4741436A422C4941414B2C494141';
wwv_flow_imp.g_varchar2_table(125) := '4933432C4B41415133432C4541414973462C5741437042412C474141632C4941414D33432C4541414F2C4D41415133432C4541414973462C5741415733432C494141532C494141496C482C514141512C4B41414D2C554141592C49414731462C4D41414F';
wwv_flow_imp.g_varchar2_table(126) := '2C4941414D75452C454141496F462C4941414D2C5741416170462C4541414971462C51414151472C4B41414B2C4B41414F2C4941414D462C454141612C4941414D74462C4541414935452C514141552C4B41414F34452C454141496F462C4941414D2C4D';
wwv_flow_imp.g_varchar2_table(127) := '4175516848684C2C4541414D73442C534143562C4F41414B74442C4541414D714C2C6B42414B4E374B2C45414145452C364241454E562C4541414D714C2C6942414169422C574141572C5341415570452C47414333432C4941414971452C454141556C45';
wwv_flow_imp.g_varchar2_table(128) := '2C4B41414B6D452C4D41414D74452C45414149432C4D41437A4237472C4541414F694C2C4541415172492C5341436671442C4541414F67462C4541415168462C4B41436667422C454141694267452C4541415168452C654145374274482C4541414D6D48';
wwv_flow_imp.g_varchar2_table(129) := '2C5941415933472C454141452B472C554141556A422C4541414D39462C4541414579442C5541415535442C4741414F412C4941436E4469482C4741434874482C4541414D774C2C5741454C2C47414747684C2C47416C4243412C45417342542C49414149';
wwv_flow_imp.g_varchar2_table(130) := '694C2C454141536A4C2C45414145472C4B41414B30432C6742415570422C5341415371492C494143486C4C2C45414145432C5141434E442C4541414567462C6541494A2C4741644969472C494143486A4C2C4541414575472C5341415730452C4541414F';
wwv_flow_imp.g_varchar2_table(131) := '68492C494145684267492C4541414F39452C614141612C6942414376426E472C45414145432C514141532C4B415552442C45414145432C4F4141512C43414F642C494141496B4C2C4541416172492C5341415371492C574143502C59414166412C474141';
wwv_flow_imp.g_varchar2_table(132) := '32432C6742414166412C4741416743462C47414155412C4541414F472C4D4143684674492C534141532B482C6942414169422C6D4241416F424B2C47414531437A4C2C4F41414F344C2C7342414356354C2C4F41414F344C2C734241417342482C474145';
wwv_flow_imp.g_varchar2_table(133) := '37427A4C2C4F41414F364C2C574141574A2C45414167432C49414B72442C4F41414F6C4C2C4541687143492C43416B714356523B3B3B3B3B3B3B3B4741456F422C6F424141582B4C2C5141413042412C4F41414F432C5541433343442C4F41414F432C51';
wwv_flow_imp.g_varchar2_table(134) := '414155354C2C4F4149492C6F42414158754A2C53414356412C4F41414F764A2C4D414151412C4F4171446842412C4D41414D36442C5541415567492C4B41414F2C434143744235472C534141592C4341435875442C514141532C7943414354452C594141';
wwv_flow_imp.g_varchar2_table(135) := '592C4541435A592C514141512C4741455477432C4F4141552C4341435474442C514141532C7943414354452C594141592C4541435A592C514141512C4741455479432C514141572C4341435676442C514141532C6743414354632C514141512C47414554';
wwv_flow_imp.g_varchar2_table(136) := '30432C4F4141552C7143414356432C594141652C57414366432C534141592C4941435A432C514141572C7142414358432C4B4141512C4341435035442C514141532C5741435433482C4D41414F2C59414954622C4D41414D36442C5541415577492C5941';
wwv_flow_imp.g_varchar2_table(137) := '4163724D2C4D41414D36442C5541415567492C4B414F3943374C2C4D41414D36442C5541415579492C4941414D2C4341437242522C4F4141552C4341455474442C514141532C3244414354632C514141512C4741475469442C554141612C4341435A2F44';
wwv_flow_imp.g_varchar2_table(138) := '2C514141532C7549414354452C594141592C4541435A592C514141512C454143527A492C4D41414F2C434141432C694241416B422C32424143314277442C4F41415172452C4D41414D36442C55414130422C674241414B2C434143354332492C51414157';
wwv_flow_imp.g_varchar2_table(139) := '2C53414358432C534141592C714241435A522C594141652C5741496A42532C4D4141532C434143522C434143436C452C514141532C364541435433482C4D41414F2C434141432C514141532C6341456C422C4341434332482C514141532C324241435433';
wwv_flow_imp.g_varchar2_table(140) := '482C4D41414F2C434141432C554141572C63414570422C4341434332482C514141532C794341435433482C4D41414F2C434141432C4F4141512C5941456A422C4341434332482C514141532C794241435433482C4D41414F2C434141432C514141532C59';
wwv_flow_imp.g_varchar2_table(141) := '41456C422C4341434332482C514141532C364341435433482C4D41414F2C434141432C514141532C6141496E426F452C534141592C4341435875442C514141532C7746414354452C594141592C4741476269452C554141612C4341435A6E452C51414153';
wwv_flow_imp.g_varchar2_table(142) := '2C6F43414354452C594141592C4541435A37482C4D41414F2C574147522B4C2C4941414F2C6F44414350432C4D4141532C4341435272452C514141532C3644414354452C594141592C4541435A37482C4D41414F2C4F4147522C614141632C4341436232';
wwv_flow_imp.g_varchar2_table(143) := '482C514141532C6B4341435433482C4D41414F2C594145522C634141652C4341436432482C514141532C734341435433482C4D41414F2C59414552694D2C4F4141552C4341435474452C514141532C7145414354452C594141592C4541435A37482C4D41';
wwv_flow_imp.g_varchar2_table(144) := '414F2C594147526B4D2C4B4141512C4341435076452C514141532C6F4541435433482C4D41414F2C594145526D4D2C4B4141512C4341435078452C514141532C364241435433482C4D41414F2C594147522C594141612C4341435A32482C514141532C71';
wwv_flow_imp.g_varchar2_table(145) := '46414354452C594141592C4541435A592C514141512C454143527A492C4D41414F2C554147526F4D2C4B4141512C434143507A452C5141415331462C4F4143522C34444141344432472C4F414335442C494143412C344641413446412C4F414335462C49';
wwv_flow_imp.g_varchar2_table(146) := '4143412C754B4141754B412C4F4143764B2C4B41454435492C4D41414F2C55414552714D2C4B4141512C4341435031452C514141532C714541435433482C4D41414F2C55414752734C2C514141572C3242414358482C4F4141552C4341435478442C5141';
wwv_flow_imp.g_varchar2_table(147) := '41532C7947414354452C594141592C4741476277442C534141592C364241435A442C594141652C59414768426A4D2C4D41414D36442C55414155734A2C4941414D2C434143724270422C514141572C4341435676442C514141532C6744414354452C5941';
wwv_flow_imp.g_varchar2_table(148) := '41592C4741456230452C534141592C434143582C4341434335452C514141532C7343414354632C514141512C474145542C5941454477432C4F4141552C4341435474442C514141532C6B44414354632C514141512C454143525A2C594141592C47414562';
wwv_flow_imp.g_varchar2_table(149) := '32452C574141632C4341436237452C514141532C7343414354632C514141512C454143525A2C594141592C4541435A72452C4F4141512C4341435034482C594141652C5541476A42512C534141592C344641435A442C514141572C7539454143584C2C51';
wwv_flow_imp.g_varchar2_table(150) := '4141572C3242414358482C4F4141552C3443414356452C534141592C2B4841435A442C594141652C65414768426A4D2C4D41414D36442C55414155794A2C4D414151744E2C4D41414D36442C554141554B2C4F41414F2C4D41414F2C434143724436482C';
wwv_flow_imp.g_varchar2_table(151) := '514141572C4341435676442C514141532C7742414354632C514141512C474147546B442C514141572C7536454145584E2C534141592C2B434147626C4D2C4D41414D36442C554141554F2C614141612C514141532C574141592C4341436A446D4A2C4D41';
wwv_flow_imp.g_varchar2_table(152) := '41532C434143522F452C514141532C674241435433482C4D41414F2C594149522C574145412C51414171422C49414156622C4F414136432C6F424141626B442C53414133432C434153412C49414149734B2C454141632C65414F64432C454141652C5741';
wwv_flow_imp.g_varchar2_table(153) := '4D66432C45414153314E2C4D41414D6D462C5141415177492C594141632C4341517843432C514141532C53414155744C2C45414153304A2C47414333422C47414177422C5141417042314A2C45414151754C2C5341417342764C2C45414151532C554141';
wwv_flow_imp.g_varchar2_table(154) := '55612C53414153344A2C47414137442C434149412C494141494D2C4541416942784C2C45414151794C2C634141632C7342414333432C4741414B442C4541414C2C434147412C49414149452C4541416B42432C53414153334C2C45414151344C2C614141';
wwv_flow_imp.g_varchar2_table(155) := '612C634141652C4B41414F2C4541437445432C4541416742482C4741416D42462C454141654D2C534141532F462C4F4141532C474145704532442C4541415367432C4941435A68432C4541415367432C4741454E68432C454141536D432C4941435A6E43';
wwv_flow_imp.g_varchar2_table(156) := '2C454141536D432C474147562C49414149452C4541415972432C4541415367432C4541457A422C4F41414F462C454141654D2C53414153432C4D41576843432C4F4141512C53414155684D2C4741436A42694D2C454141652C434141436A4D2C4B41616A';
wwv_flow_imp.g_varchar2_table(157) := '426B4D2C3442414134422C474134477A42432C4F414159432C4541436842374F2C4F41414F6F4C2C6942414169422C554141552C574143374279432C4541414F632C344241413842432C49414163354F2C4F41414F384F2C6141473944462C4541415935';
wwv_flow_imp.g_varchar2_table(158) := '4F2C4F41414F384F2C5741456E424A2C454141657A4E2C4D41414D4D2C55414155472C4D41414D442C4B41414B34422C5341415334432C6942414169422C30424147724539462C4D41414D30462C4D41414D31432C494141492C594141592C5341415577';
wwv_flow_imp.g_varchar2_table(159) := '432C47414372432C4741414B412C45414149552C4B4141542C434149412C49414149412C4541412B42562C454141572C51414331436F4A2C4541416B4331492C454141652C57414772442C4741414B30492C474141512C4F41414F432C4B41414B442C45';
wwv_flow_imp.g_varchar2_table(160) := '41414933492C59414B7A42432C4541414B36482C634141632C7542414B6C422F4E2C4D41414D4F2C4B41414B6B442C5341415379432C4541414D73482C4741412F422C43414B4174482C4541414B6E442C554141552B4C2C4F41414F74422C4741457442';
wwv_flow_imp.g_varchar2_table(161) := '6F422C45414149374C2C55414155432C49414149774B2C4741456C422C4941454975422C454146416E472C4541415170442C45414149552C4B41414B30432C4D41414D36452C474143764275422C4541415770472C45414151412C4541414D502C4F4141';
wwv_flow_imp.g_varchar2_table(162) := '532C454141492C454147744334472C454141512C494141496E4F2C4D41414D6B4F2C454141572C4741414768452C4B41414B2C6B4241457A432B442C4541417142374C2C53414153674D2C634141632C5341437A4231492C614141612C634141652C5141';
wwv_flow_imp.g_varchar2_table(163) := '432F4375492C4541416D42744D2C554141592C6F4241432F42734D2C4541416D427A492C5541415932492C45414533424C2C4541414972492C614141612C67424143704271492C454141494F2C4D41414D432C614141652C65414169426E422C53414153';
wwv_flow_imp.g_varchar2_table(164) := '572C45414149562C614141612C634141652C4941414D2C494147314631492C454141496C442C514141512B4D2C594141594E2C4741457842522C454141652C434141434B2C4941456842354F2C4D41414D30462C4D41414D432C494141492C6541416742';
wwv_flow_imp.g_varchar2_table(165) := '482C5141476A4378462C4D41414D30462C4D41414D31432C494141492C6742414167422C5341415577432C4741437A43412C454141494C2C514141554B2C454141494C2C534141572C47414337424B2C454141494C2C5141415177492C614141632C4B41';
wwv_flow_imp.g_varchar2_table(166) := '6C4B33422C53414153592C4541416533492C47414F76422C47414175422C49414E7642412C45414157412C45414153304A2C5141414F2C5341415533452C47414370432C4941434934452C454179464E2C5341416D426A4E2C4741436C422C4941414B41';
wwv_flow_imp.g_varchar2_table(167) := '2C4541434A2C4F41414F2C4B4147522C4F41414F7A432C4F41414F32502C694241416D42412C6942414169426C4E2C47414159412C454141516D4E2C63414167422C4B412F467045432C434141552F452C474143432C65414335422C4D414173422C6141';
wwv_flow_imp.g_varchar2_table(168) := '416634452C47414134432C61414166412C4D414778426C482C4F4141622C434149412C4941414973482C454141512F4A2C4541415335452C4B4141492C5341415573422C4741436C432C49414149734E2C45414163744E2C45414151794C2C634141632C';
wwv_flow_imp.g_varchar2_table(169) := '514143704367422C45414171427A4D2C45414151794C2C634141632C734241432F432C4741414B36422C4741416742622C45414172422C43414B412C49414149632C4541416B42764E2C45414151794C2C634141632C7542414378432B422C4541415946';
wwv_flow_imp.g_varchar2_table(170) := '2C454141597A4A2C59414159344A2C4D41414D74432C4741457A436F432C4B41434A412C4541416B42334D2C53414153674D2C634141632C5341437A427A4D2C554141592C7142414535426D4E2C45414159502C59414159512C4941477A42412C454141';
wwv_flow_imp.g_varchar2_table(171) := '6742764A2C554141592C4941433542754A2C4541416742562C4D41414D612C514141552C51414568432C49414149432C45414169424A2C45414167424B2C774241417742432C4F414737442C4F4146414E2C4541416742764A2C554141592C4741457242';
wwv_flow_imp.g_varchar2_table(172) := '2C4341434E68452C51414153412C45414354324D2C4D41414F612C454143504D2C594141612C47414362482C6541416742412C4541436842492C4D41414F522C4F41454E502C4F41414F67422C53414556582C4541414D7A4E2C534141512C5341415571';
wwv_flow_imp.g_varchar2_table(173) := '4F2C47414376422C49414149562C4541416B42552C4541414B462C4D4143764270422C4541415173422C4541414B74422C4D4143626D422C45414163472C4541414B482C5941436E42482C45414169424D2C4541414B4E2C6541453142472C454141596E';
wwv_flow_imp.g_varchar2_table(174) := '422C4541414D35472C4F4141532C5141414B71472C45414368434F2C4541414D2F4D2C534141512C53414155734F2C4541414D31482C47414337422C4741414930482C47414151412C4541414B6E492C4F4141532C454141472C43414335422C49414149';
wwv_flow_imp.g_varchar2_table(175) := '73432C454141496B462C4541416742522C594141596E4D2C53414153674D2C634141632C534143334476452C4541414577452C4D41414D612C514141552C5141436C4272462C4541414578452C59414163714B2C4F414568424A2C4541415974482C4741';
wwv_flow_imp.g_varchar2_table(176) := '41536D482C51414B78424E2C4541414D7A4E2C534141512C53414155714F2C47414B76422C49414A412C49414149562C4541416B42552C4541414B462C4D41437642442C45414163472C4541414B482C5941456E424B2C454141612C45414352724F2C45';
wwv_flow_imp.g_varchar2_table(177) := '4141492C45414147412C45414149674F2C454141592F482C4F4141516A472C5341436842734D2C4941416E4230422C45414159684F2C4B414366674F2C45414159684F2C4741414B794E2C45414167427A422C5341415371432C4B414163502C77424141';
wwv_flow_imp.g_varchar2_table(178) := '7742432C57414B6E46522C4541414D7A4E2C534141512C53414155714F2C47414376422C49414149562C4541416B42552C4541414B462C4D414376424B2C45414155482C4541414B6A4F2C51414151794C2C634141632C734241457A4338422C45414167';
wwv_flow_imp.g_varchar2_table(179) := '42562C4D41414D612C514141552C4F41436843482C4541416742764A2C554141592C4741453542694B2C4541414B482C594141596C4F2C534141512C53414155694F2C45414151512C4741433143442C4541415174432C5341415375432C474141597842';
wwv_flow_imp.g_varchar2_table(180) := '2C4D41414D67422C4F414153412C454141532C6141784B7A442C47413650432C574145412C51414171422C494141566E512C4F414136432C6F424141626B442C53414133432C434149412C494141496B462C454141592C4741435A70482C4541414D2C47';
wwv_flow_imp.g_varchar2_table(181) := '41434E34502C4541414F2C6141455835512C4D41414D6D462C51414151304C2C514141552C4741674278422C49414149432C454141694239512C4D41414D6D462C51414151304C2C51414151432C65414169422C53414155394F2C4541414B2B4F2C4741';
wwv_flow_imp.g_varchar2_table(182) := '4331452C494141492F4C2C45414748412C4541446D422C6D424141542B4C2C45414343412C454145412C53414155764C2C47414370422C494141496C442C454171424A2C4D416E4234422C6D4241416A42794F2C4541414B432C55414366314F2C454141';
wwv_flow_imp.g_varchar2_table(183) := '55592C53414153674D2C634141632C5741437A42764F2C4B41414F2C5341436632422C4541415132492C6942414169422C534141532C5741436A4338462C4541414B432C5141415131502C4B41414B79442C4B41414D532C4F41454B2C6942414162754C';
wwv_flow_imp.g_varchar2_table(184) := '2C4541414B6E452C4B41437442744B2C45414155592C53414153674D2C634141632C4D41437A422B422C4B41414F462C4541414B6E452C4941457042744B2C45414155592C53414153674D2C634141632C514147394236422C4541414B744F2C57414352';
wwv_flow_imp.g_varchar2_table(185) := '482C45414151532C55414155432C494141492B4E2C4541414B744F2C5741473542482C4541415136442C59414163344B2C4541414B2F4D2C4B4145704231422C4741494C4E2C4B41414F68422C454143566B512C51414151432C4B41414B2C6D43414171';
wwv_flow_imp.g_varchar2_table(186) := '436E502C4541414D2C794241497A446F472C454141554A2C4B41414B68482C4541414967422C4741414F67442C4941364276426F4D2C4541414F70522C4D41414D6D462C51414151304C2C514141514F2C4B41414F2C53414155354C2C4741456A442C49';
wwv_flow_imp.g_varchar2_table(187) := '4141496F4A2C4541414D704A2C454141496C442C514141512B4F2C57414374422C4741414B7A432C474141512C4F41414F432C4B41414B442C4541414933492C59414B7A4232492C4541414979432C57414157744F2C55414155612C534141532C674241';
wwv_flow_imp.g_varchar2_table(188) := '4174432C43414B412C49414149384D2C45414155784E2C53414153674D2C634141632C4F4143724377422C45414151334E2C55414155432C494141492C674241437442344C2C4541414979432C574141576A4E2C61414161734D2C4541415339422C4741';
wwv_flow_imp.g_varchar2_table(189) := '43724338422C4541415172422C59414159542C47414770422C4941414969432C45414155334E2C53414153674D2C634141632C4F4143724332422C45414151394E2C55414155432C494141492C57414774422C49414149734F2C4541416D426C4A2C4541';
wwv_flow_imp.g_varchar2_table(190) := '436E426D4A2C454135434C2C5341416B426A502C4741436A422C4B41414F412C474141532C434143662C4941414969502C454141516A502C45414151344C2C614141612C734241436A432C474141612C4D41415471442C454145482C4F414441412C4541';
wwv_flow_imp.g_varchar2_table(191) := '4151412C4541414D432C5141434A6E4A2C4F4143466B4A2C4541414D78422C4D41414D2C5941455A2C474147547A4E2C45414155412C454141514B2C6541694350384F2C434141536A4D2C454141496C442C534143724269502C49414348442C4541416D';
wwv_flow_imp.g_varchar2_table(192) := '42432C4541414D76512C4B4141492C5341415567422C47414374432C4F41414F68422C4541414967422C49414151344F2C4D41497242552C454141694270502C534141512C5341415538432C4741436C432C4941414931432C4541415530432C45414153';
wwv_flow_imp.g_varchar2_table(193) := '512C47414576422C4741414B6C442C4541414C2C434149412C494141496F502C4541414F784F2C53414153674D2C634141632C4F41436C4377432C4541414B334F2C55414155432C494141492C674241456E42304F2C4541414B72432C594141592F4D2C';
wwv_flow_imp.g_varchar2_table(194) := '4741436A42754F2C4541415178422C5941415971432C4F4149724268422C4541415172422C5941415977422C4B41477242432C454141652C534141532C53414155744C2C4741436A432C494141496F4A2C4541414D704A2C454141496C442C514141512B';
wwv_flow_imp.g_varchar2_table(195) := '4F2C57414374422C4741414B7A432C474141512C4F41414F432C4B41414B442C4541414933492C574149784232492C4541414972492C614141612C63414174422C434149412C494141496A452C4541416171502C45414362334E2C4541414F344B2C4541';
wwv_flow_imp.g_varchar2_table(196) := '4149562C614141612C63414335422C4941454379442C454141577A4F2C53414153364B2C634141632C594141632F4A2C4741432F432C4D41414F32472C494165542C4F41624967482C4541434872502C4541415571502C454141532F512C53414566674F';
wwv_flow_imp.g_varchar2_table(197) := '2C4541414972492C614141612C61414370426A452C45414155592C53414153674D2C634141632C4D41437A422B422C4B41414F72432C45414149562C614141612C5941456843354C2C45414155592C53414153674D2C634141632C5141476C43354D2C45';
wwv_flow_imp.g_varchar2_table(198) := '41415136442C594141636E432C474147684231422C4D414D5274432C4D41414D30462C4D41414D31432C494141492C574141596F4F2C49416A4C37422C47416F4C432C57417542412C53414153512C4541416B4274502C4541415375502C4741436E4376';
wwv_flow_imp.g_varchar2_table(199) := '502C4541415132492C6942414169422C534141532C594175436E432C534141364234472C4741437842432C55414155432C55414362442C55414155432C55414155432C55414155482C45414153492C57414157432C4B41414B4C2C454141534D2C534141';
wwv_flow_imp.g_varchar2_table(200) := '532C5741457845432C4541413442502C4D414737424F2C4541413442502C474137433542512C4341416F42522C4D414F74422C534141534F2C4541413442502C47414370432C49414149532C4541415770502C53414153674D2C634141632C5941437443';
wwv_flow_imp.g_varchar2_table(201) := '6F442C4541415333512C4D4141516B512C45414153492C55414731424B2C454141536E442C4D41414D6F442C4941414D2C4941437242442C454141536E442C4D41414D71442C4B41414F2C4941437442462C454141536E442C4D41414D73442C53414157';
wwv_flow_imp.g_varchar2_table(202) := '2C514145314276502C5341415377502C4B41414B72442C5941415969442C4741433142412C454141534B2C514143544C2C454141534D2C534145542C494143432C49414149432C4541416133502C5341415334502C594141592C514143744370482C5941';
wwv_flow_imp.g_varchar2_table(203) := '41572C5741434E6D482C4541434868422C454141534D2C554145544E2C454141536B422C554145522C474143462C4D41414F33502C4741435273492C594141572C574143566D472C454141536B422C4D41414D33502C4B4143622C4741474A462C534141';
wwv_flow_imp.g_varchar2_table(204) := '5377502C4B41414B4D2C59414159562C514131444E2C4941415674532C4F414136432C6F424141626B442C57414974436C442C4D41414D6D462C51414151304C2C514134476E4237512C4D41414D6D462C51414151304C2C51414151432C654141652C71';
wwv_flow_imp.g_varchar2_table(205) := '42414171422C53414155744C2C4741436E452C494141496C442C454141556B442C454141496C442C5141456432512C454131424C2C5341417142432C47414570422C49414149442C454141572C43414364452C4B4141512C4F4143522C614141632C7542';
wwv_flow_imp.g_varchar2_table(206) := '4143642C65414167422C55414368422C65414167422C4B41496A422C4941414B2C494141496E522C4B41414F69522C454141552C4341477A422C494146412C49414149472C454146512C674241455170522C45414368424D2C4541415534512C45414350';
wwv_flow_imp.g_varchar2_table(207) := '35512C49414159412C4541415169452C61414161364D2C494143764339512C45414155412C454141514B2C634145664C2C4941434832512C454141536A522C4741414F4D2C45414151344C2C614141616B462C49414776432C4F41414F482C45414D5149';
wwv_flow_imp.g_varchar2_table(208) := '2C434141592F512C474145764267522C4541415770512C53414153674D2C634141632C55414374436F452C4541415337512C554141592C32424143724236512C45414153394D2C614141612C4F4141512C55414339422C494141492B4D2C454141577251';
wwv_flow_imp.g_varchar2_table(209) := '2C53414153674D2C634141632C5141794274432C4F417842416F452C454141536A452C594141596B452C4741457242432C454141532C5141455435422C4541416B4230422C454141552C434143334272422C514141532C574143522C4F41414F33502C45';
wwv_flow_imp.g_varchar2_table(210) := '41415136442C6141456842674D2C514141532C5741435271422C454141532C6742414554432C4B414544562C4D41414F2C5741434E532C454141532C6341455439482C594141572C59413544642C5341413242704A2C47414531427A432C4F41414F3654';
wwv_flow_imp.g_varchar2_table(211) := '2C65414165432C6B4241416B4272522C47413244724373522C4341416B4274522C4B414368422C474145486D522C4F41494B482C454145502C53414153472C494143522F482C594141572C5741416338482C454141532C55414159502C454141532C6942';
wwv_flow_imp.g_varchar2_table(212) := '414978442C534141534F2C454141534B2C4741436A424E2C45414153704E2C59414163384D2C45414153592C4741436843502C45414153394D2C614141612C6B4241416D42714E2C4F41724A314333432C51414151432C4B41414B2C3244415066222C22';
wwv_flow_imp.g_varchar2_table(213) := '66696C65223A22707269736D2E6A73227D';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(57432329230854672)
,p_file_name=>'lib/prismjs/js/prism.js.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1182306920811988)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(4174066140699943)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(4174166300699943)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(33700780045345979)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'PLUGIN_COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495637049419880410)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495637316813880410)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495637696260880410)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495637972733880410)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495638240314880412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495638591473880412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(12495638754943880417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/shared_components/security/authorizations/administration_rights
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12495496796563879971)
,p_name=>'Administration Rights'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return true;'
,p_error_message=>'Insufficient privileges, user is not an Administrator'
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_processes/set_init_theme_mode
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(29402085585388580)
,p_process_sequence=>1
,p_process_point=>'AFTER_LOGIN'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SET_INIT_THEME_MODE'
,p_process_sql_clob=>'flow_theme_api.set_init_theme_mode;'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_processes/switch_theme_mode
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(5593447532877397)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SWITCH_THEME_MODE'
,p_process_sql_clob=>'flow_theme_api.switch_theme_mode(:REQUEST);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'LIGHT_MODE DARK_MODE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/shared_components/logic/application_processes/reset_theme_mode
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(6213103405434761)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'RESET_THEME_MODE'
,p_process_sql_clob=>'flow_theme_api.reset_theme_mode(:REQUEST);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':request in (''RESET_DARK'', ''RESET_LIGHT'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_processes/css_tricks
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(8120377472916762)
,p_process_sequence=>1
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CSS_TRICKS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_version varchar2(4);',
'    l_user_style_id number := apex_theme.get_user_style(:APP_ID, :APP_USER, 42);',
'    l_user_style varchar2(100);',
'    l_debug boolean := apex_application.g_debug;',
'    l_file_exists number;',
'    l_directory varchar2(100);',
'    l_filename varchar2(100);',
'begin',
'    /* retrieve user theme setting */',
'    ',
'    if (l_user_style_id is not null ) then',
'        begin',
'            select name',
'            into l_user_style',
'            from apex_application_theme_styles',
'            where theme_style_id = l_user_style_id;',
'        exception',
'            when no_data_found',
'            then l_user_style := case :THEME_PLUGIN_CLASS when ''FLOWS'' then ''Vita'' else ''Vita - Dark'' end;',
'        end;',
'         ',
'    else',
'        l_user_style := case :THEME_PLUGIN_CLASS when ''FLOWS'' then ''Vita'' else ''Vita - Dark'' end;',
'    end if;',
'',
'    /* load theme specific file */',
'    ',
'    l_directory := ''css/'';',
'    l_filename := ''flows4apex.''||case l_user_style when ''Vita'' then ''light'' else ''dark'' end ||''.css'';',
'',
'    select count(*)',
'    into l_file_exists',
'    from apex_application_static_files',
'    where file_name = l_directory || l_filename',
'    and application_id = :app_id;',
'',
'    if (l_file_exists > 0) then',
'    l_filename := ''flows4apex.''||case l_user_style when ''Vita'' then ''light'' else ''dark'' end ||''#MIN#'';',
'        ',
'        APEX_CSS.ADD_FILE(',
'            p_name => l_filename',
'            , p_directory => ''#APP_IMAGES#''||l_directory',
'        );',
'    end if;',
'    ',
'    /* load version specific file */',
'',
'    select substr(version_no, 1, 4)',
'    into l_version',
'    from apex_release;',
'    ',
'    l_directory := ''css/'' || l_version || ''/'';',
'    l_filename := ''flows4apex.''||case l_user_style when ''Vita'' then ''light'' else ''dark'' end ||''.css'';',
'',
'    select count(*)',
'    into l_file_exists',
'    from apex_application_static_files',
'    where file_name = l_directory || l_filename',
'    and application_id = :app_id;',
'',
'    if (l_file_exists > 0) then',
'    l_filename := ''flows4apex.''||case l_user_style when ''Vita'' then ''light'' else ''dark'' end ||''#MIN#'';',
'        ',
'        APEX_CSS.ADD_FILE(',
'            p_name => l_filename',
'            , p_directory => ''#APP_IMAGES#''||l_directory',
'        );',
'    end if;',
'    ',
'    /* load prisma file */',
'    ',
'     APEX_CSS.ADD_FILE(',
'            p_name => ''prism'' || case l_user_style when ''Vita - Dark'' then ''.dark'' end ||''#MIN#''',
'            , p_directory => ''#APP_IMAGES#lib/prismjs/css/''',
'        ); ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_processes/ajax_handler
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(7625964662736152)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'AJAX_HANDLER'
,p_process_sql_clob=>'flow_engine_app_api.handle_ajax;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_items/app_name_title
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(34570520101106514)
,p_name=>'APP_NAME_TITLE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/flow_page_title
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(34551546825917526)
,p_name=>'FLOW_PAGE_TITLE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_language_preference
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(9614743728201348)
,p_name=>'FSP_LANGUAGE_PREFERENCE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/theme_plugin_class
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(6189993961233425)
,p_name=>'THEME_PLUGIN_CLASS'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_computations/app_name_title
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(34570910330109834)
,p_computation_sequence=>10
,p_computation_item=>'APP_NAME_TITLE'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'Flows for APEX'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/diagrams_instanciated_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(66615520889086574)
,p_lov_name=>'DIAGRAMS_INSTANCIATED_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_DIAGRAMS_INSTANCIATED_LOV'
,p_return_column_name=>'DGRM_ID'
,p_display_column_name=>'DGRM_NAME'
,p_group_column_name=>'DGRM_CATEGORY'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DGRM_NAME'
,p_default_sort_direction=>'ASC'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(66619493214096628)
,p_query_column_name=>'DGRM_ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(66619733681096628)
,p_query_column_name=>'DGRM_NAME'
,p_heading=>'Name'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(66620198364096628)
,p_query_column_name=>'DGRM_CATEGORY'
,p_heading=>'Category'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(66620549721096629)
,p_query_column_name=>'DGRM_VERSION'
,p_heading=>'Version'
,p_display_sequence=>40
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(66620978691096630)
,p_query_column_name=>'DGRM_STATUS'
,p_heading=>'Status'
,p_display_sequence=>50
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/diagrams_parsed_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(599957119101802)
,p_lov_name=>'DIAGRAMS_PARSED_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_DIAGRAMS_PARSED_LOV'
,p_return_column_name=>'DGRM_ID'
,p_display_column_name=>'DGRM_NAME'
,p_group_column_name=>'DGRM_CATEGORY'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DGRM_NAME'
,p_default_sort_direction=>'ASC'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(9100877958535115)
,p_query_column_name=>'DGRM_NAME'
,p_heading=>'Name'
,p_display_sequence=>10
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(9604120679701834)
,p_query_column_name=>'DGRM_ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(9101106304535117)
,p_query_column_name=>'DGRM_CATEGORY'
,p_heading=>'Category'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(9101564040535117)
,p_query_column_name=>'DGRM_STATUS'
,p_heading=>'Status'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(9101910594535117)
,p_query_column_name=>'DGRM_VERSION'
,p_heading=>'Version'
,p_display_sequence=>40
,p_data_type=>'NUMBER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/diagram_categories_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25503316579708357)
,p_lov_name=>'DIAGRAM_CATEGORIES_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_DIAGRAM_CATEGORIES_LOV'
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_default_sort_column_name=>'D'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_instance_diagrams_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60714624308437115)
,p_lov_name=>'FLOW_INSTANCE_DIAGRAMS_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_INSTANCE_DIAGRAMS_LOV'
,p_query_where=>'prdg_prcs_id = :P8_PRCS_ID'
,p_return_column_name=>'PRDG_ID'
,p_display_column_name=>'CALLING_DIAGRAM'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'CALLING_DIAGRAM'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_rest_roles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2384141954898413)
,p_lov_name=>'FLOW_REST_ROLES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select role_name',
'     , role_id',
'  from table(flow_rest_auth.get_rest_roles)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ROLE_ID'
,p_display_column_name=>'ROLE_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_simple_form_templates_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10362301203290988)
,p_lov_name=>'FLOW_SIMPLE_FORM_TEMPLATES_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_SIMPLE_FORM_TEMPLATES'
,p_return_column_name=>'SFTE_ID'
,p_display_column_name=>'SFTE_NAME'
,p_default_sort_column_name=>'SFTE_NAME'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_remember_username
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(12495494129921879909)
,p_lov_name=>'LOGIN_REMEMBER_USERNAME'
,p_lov_query=>'.'||wwv_flow_imp.id(12495494129921879909)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12495493775569879902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Remember username'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p13_object_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15330862223656536)
,p_lov_name=>'P13_OBJECT_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(15330862223656536)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15331535176656556)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Clear Cache'
,p_lov_return_value=>'apex:cache'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15331901949656556)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Item Values'
,p_lov_return_value=>'apex:itemValue'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15332307999656557)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Request'
,p_lov_return_value=>'apex:request'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15332751649656557)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Page Items'
,p_lov_return_value=>'apex:itemName'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15333170482656557)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'PL/SQL Code'
,p_lov_return_value=>'apex:plsqlCode'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15333581483656557)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Bind Page Item Values'
,p_lov_return_value=>'apex:autoBinds'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15333933530656557)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Engine'
,p_lov_return_value=>'apex:engine'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15334375925656558)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'apex:pageId'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15373450429468526)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Process status after termination'
,p_lov_return_value=>'processStatus'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15373733235468542)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Timer Definition Type'
,p_lov_return_value=>'timerType'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15374151920468542)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Timer Definition'
,p_lov_return_value=>'timerDefinition'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35700662160505107)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Task Type'
,p_lov_return_value=>'taskType'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35700949683505137)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'From'
,p_lov_return_value=>'apex:emailFrom'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35701367611505137)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'To'
,p_lov_return_value=>'apex:emailTo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35701702285505137)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'CC'
,p_lov_return_value=>'apex:emailCC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35702112103505146)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'BCC'
,p_lov_return_value=>'apex:emailBCC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35702525554505146)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Reply To'
,p_lov_return_value=>'apex:emailReplyTo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35702928038505146)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Use Template'
,p_lov_return_value=>'apex:useTemplate'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35703352692505146)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Application ID'
,p_lov_return_value=>'apex:applicationId'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35703713806505147)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Template ID'
,p_lov_return_value=>'apex:templateId'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35704108915505147)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Placeholder'
,p_lov_return_value=>'apex:placeholder'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35704517220505147)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Subject'
,p_lov_return_value=>'apex:subject'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35704978438505147)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Body'
,p_lov_return_value=>'apex:bodyText'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35705311456505147)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'HTML Body'
,p_lov_return_value=>'apex:bodyHTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35705730321505148)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Attachment'
,p_lov_return_value=>'apex:attachment'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35706161989505149)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'Send Immediatly'
,p_lov_return_value=>'apex:immediately'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35707717059505149)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Date'
,p_lov_return_value=>'apex:date'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35708141249505150)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Format Mask'
,p_lov_return_value=>'apex:formatMask'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35708515702505150)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>'Interval Year to Month'
,p_lov_return_value=>'apex:intervalYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35708950682505150)
,p_lov_disp_sequence=>34
,p_lov_disp_value=>'Interval Day to Second'
,p_lov_return_value=>'apex:intervalDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35709380114505150)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Time until the timer fires first'
,p_lov_return_value=>'apex:startIntervalDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35709717522505150)
,p_lov_disp_sequence=>36
,p_lov_disp_value=>'Time until the timer fires again'
,p_lov_return_value=>'apex:repeatIntervalDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35710159164505151)
,p_lov_disp_sequence=>37
,p_lov_disp_value=>'Max Runs'
,p_lov_return_value=>'apex:maxRuns'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p13_var_exp_set_on
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15901843917364053)
,p_lov_name=>'P13_VAR_EXP_SET_ON'
,p_lov_query=>'.'||wwv_flow_imp.id(15901843917364053)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15902102975364060)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Before Task'
,p_lov_return_value=>'beforeTask'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15902510563364061)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'After Task'
,p_lov_return_value=>'afterTask'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15902907108364061)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Before Event'
,p_lov_return_value=>'beforeEvent'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15903304316364061)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'On Event'
,p_lov_return_value=>'onEvent'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15903750919364061)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Before Split'
,p_lov_return_value=>'beforeSplit'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15904152776364061)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'After Merge'
,p_lov_return_value=>'afterMerge'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62212194512228414)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'In Variables'
,p_lov_return_value=>'inVariables'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62212467011228444)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Out Variables'
,p_lov_return_value=>'outVariables'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p13_var_exp_typ
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15214828485777501)
,p_lov_name=>'P13_VAR_EXP_TYP'
,p_lov_query=>'.'||wwv_flow_imp.id(15214828485777501)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15215132143777515)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static Value'
,p_lov_return_value=>'static'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15216223137803713)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Process Variable'
,p_lov_return_value=>'processVariable'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15216699385803714)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'item'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15217004677803714)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'sqlQuerySingle'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15217473228803715)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'SQL Query (return colon separated value)'
,p_lov_return_value=>'sqlQueryList'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15217803205803716)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'PL/SQL Function Body'
,p_lov_return_value=>'plsqlFunctionBody'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15218228624803716)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'PL/SQL Expression'
,p_lov_return_value=>'plsqlExpression'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p5_download_as
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11258952541008552)
,p_lov_name=>'P5_DOWNLOAD_AS'
,p_lov_query=>'.'||wwv_flow_imp.id(11258952541008552)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11259254401008560)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'BPMN File'
,p_lov_return_value=>'BPMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11259507519008561)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Script'
,p_lov_return_value=>'SQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p6_import_from
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11250367144948655)
,p_lov_name=>'P6_IMPORT_FROM'
,p_lov_query=>'.'||wwv_flow_imp.id(11250367144948655)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11250625753948668)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'File'
,p_lov_return_value=>'file'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11251072818948672)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'text'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p6_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13102745982982601)
,p_lov_name=>'P6_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(13102745982982601)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13103030553982630)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_lov_return_value=>'single'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13103422381982643)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_lov_return_value=>'multiple'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p8_instance_connections_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3000126357622364)
,p_lov_name=>'P8_INSTANCE_CONNECTIONS_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_INSTANCE_CONNECTIONS_LOV'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'src_objt_bpmn_id = :p8_gateway',
'and prdg_id = :p8_prdg_id'))
,p_return_column_name=>'CONN_BPMN_ID'
,p_display_column_name=>'CONN_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'CONN_NAME'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p8_instance_gateways_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2800147004522946)
,p_lov_name=>'P8_INSTANCE_GATEWAYS_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'FLOW_INSTANCE_GATEWAYS_LOV'
,p_query_where=>'prdg_id = :P8_PRDG_ID'
,p_return_column_name=>'OBJT_BPMN_ID'
,p_display_column_name=>'OBJT_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'OBJT_NAME'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(12495496131529879959)
,p_group_name=>'Administration'
);
end;
/
prompt --application/comments
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(12495636486941880396)
,p_name=>'Breadcrumb'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2116968797571265)
,p_parent_id=>wwv_flow_imp.id(6043758234733358)
,p_short_name=>'Instance Timeline - &P20_PRCS_NAME.'
,p_link=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_page_id=>20
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2407759203411191)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'REST Service'
,p_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP,30::'
,p_page_id=>30
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2541995976137178)
,p_short_name=>'Daily Statistics'
,p_link=>'f?p=&APP_ID.:15:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>15
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2550001583373355)
,p_short_name=>'Process Statistics'
,p_link=>'f?p=&APP_ID.:16:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2561724817878606)
,p_short_name=>'Task Statistics'
,p_link=>'f?p=&APP_ID.:17:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3308151438310190)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Logging'
,p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:32::'
,p_page_id=>32
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3308475687313586)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Archiving'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33::'
,p_page_id=>33
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3308685056315428)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Engine App'
,p_link=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:34::'
,p_page_id=>34
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3308819433316729)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Engine'
,p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:35::'
,p_page_id=>35
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3309054147318793)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Timers'
,p_link=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:36::'
,p_page_id=>36
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3337454003771697)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Statistics'
,p_link=>'f?p=&APP_ID.:37:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>37
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5601978818964023)
,p_short_name=>'Simple Form Templates'
,p_link=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_page_id=>50
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6043758234733358)
,p_parent_id=>wwv_flow_imp.id(34554383018964598)
,p_short_name=>'&P8_PRCS_NAME.'
,p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.::P8_PRCS_ID:&P20_PRCS_ID.'
,p_page_id=>8
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11482636344804668)
,p_parent_id=>wwv_flow_imp.id(11904723133918726)
,p_short_name=>'Configuration - Licence'
,p_link=>'f?p=&APP_ID.:39:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>39
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11904723133918726)
,p_parent_id=>0
,p_short_name=>'Configuration'
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:9::'
,p_page_id=>9
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34530380979770009)
,p_parent_id=>0
,p_short_name=>'Flow Management'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2::'
,p_page_id=>2
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34530584751775010)
,p_parent_id=>wwv_flow_imp.id(34530380979770009)
,p_short_name=>'&FLOW_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::'
,p_page_id=>7
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34550076822906956)
,p_parent_id=>wwv_flow_imp.id(34530584751775010)
,p_short_name=>'Flow Modeler'
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34554383018964598)
,p_parent_id=>0
,p_short_name=>'Flow Monitor'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34709672555312450)
,p_parent_id=>0
,p_short_name=>'Dashboard'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/drawer
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(9977787507536054)
,p_theme_id=>42
,p_name=>'Drawer'
,p_internal_name=>'DRAWER'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Drawer-page t-PageTemplate--drawer #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Drawer" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Drawer-header">#REGION_POSITION_01#</div>',
'  <div class="t-Drawer-bodyWrapperOut">',
'    <div class="t-Drawer-bodyWrapperIn">',
'      <div class="t-Drawer-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Drawer-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>11
,p_preset_template_options=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Drawer-page--standard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#)'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>1659739787629394056
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9978222589536055)
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9978745708536055)
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9979267045536055)
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/minimal_no_navigation
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495616037696880296)
,p_theme_id=>42
,p_name=>'Minimal (No Navigation)'
,p_internal_name=>'MINIMAL_NO_NAVIGATION'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#  ',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim #PAGE_CSS_CLASSES# t-PageBody--noNav t-PageTemplate--minimal" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="#EXPAND_COLLAPSE_NAV_LABEL#" title="#EXPAND_COLLAPSE_NAV_LABEL#" id="t_Button_navControl" type="button"><span class="t-Icon fa fa-bars" aria-hidden="true"'
||'></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'</header>',
'    '))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2977628563533209425
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9964172158536050)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9964608916536050)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9965167066536050)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9965622286536050)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9966124946536050)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9966668390536051)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9967112628536051)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9967685564536051)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9968166923536051)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9968620747536051)
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/page/standard
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495618547053880299)
,p_theme_id=>42
,p_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim t-PageTemplate--standard #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>4070909157481059304
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9972546633536052)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9973075735536052)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9973528985536052)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9974060553536052)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9974588249536052)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9975064869536052)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9975565018536053)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9976049205536053)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9976522474536053)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9977079270536053)
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/page/wizard_modal_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495620021366880299)
,p_theme_id=>42
,p_name=>'Wizard Modal Dialog'
,p_internal_name=>'WIZARD_MODAL_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.wizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Dialog-page t-Dialog-page--wizard t-PageTemplate--wizard #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-header">#REGION_POSITION_01#</div>',
'  <div class="t-Dialog-bodyWrapperOut">',
'    <div class="t-Dialog-bodyWrapperIn">',
'      <div class="t-Dialog-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Dialog-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,h:#DIALOG_HEIGHT#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Dialog-page--wizard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#'
||')'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2120348229686426515
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9930138642536042)
,p_page_template_id=>wwv_flow_imp.id(12495620021366880299)
,p_name=>'Wizard Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9930697653536043)
,p_page_template_id=>wwv_flow_imp.id(12495620021366880299)
,p_name=>'Wizard Progress Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9931197702536043)
,p_page_template_id=>wwv_flow_imp.id(12495620021366880299)
,p_name=>'Wizard Buttons'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/right_side_column
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495622898900880302)
,p_theme_id=>42
,p_name=>'Right Side Column'
,p_internal_name=>'RIGHT_SIDE_COLUMN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.rightSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8"> ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft no-anim t-PageTemplate--rightSideCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" aria-label="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button'
||'>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525200116240651575
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9945091204536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9945598838536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9946042499536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9946517272536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9947009570536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9947529163536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9948098726536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9948501231536046)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9949006081536047)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9949521176536047)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9950079112536047)
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/modal_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495624331342880306)
,p_theme_id=>42
,p_name=>'Modal Dialog'
,p_internal_name=>'MODAL_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Dialog-page t-Dialog-page--standard t-PageTemplate--dialog #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-header">#REGION_POSITION_01#</div>',
'  <div class="t-Dialog-bodyWrapperOut">',
'    <div class="t-Dialog-bodyWrapperIn">',
'      <div class="t-Dialog-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Dialog-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,h:#DIALOG_HEIGHT#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Dialog-page--standard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMEN'
||'T#)'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2098960803539086924
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9920603484536040)
,p_page_template_id=>wwv_flow_imp.id(12495624331342880306)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9921144757536040)
,p_page_template_id=>wwv_flow_imp.id(12495624331342880306)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9921626162536040)
,p_page_template_id=>wwv_flow_imp.id(12495624331342880306)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/master_detail
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495627437383880309)
,p_theme_id=>42
,p_name=>'Marquee'
,p_internal_name=>'MASTER_DETAIL'
,p_is_popup=>false
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.stickyTableHeader#MIN#.js?v=#APEX_VERSION#',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'))
,p_javascript_code_onload=>'apex.theme42.initializePage.masterDetail();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--masterDetail t-PageBody--hideLeft no-anim t-PageTemplate--marquee #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-info" id="t_Body_info">#REGION_POSITION_02#</div>',
'        <div class="t-Body-contentInner" role="main">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>1996914646461572319
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9912862289536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9913347092536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9913806964536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9914301127536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9914864075536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9915361899536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Master Detail'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9915815964536036)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Right Side Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9916373154536037)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9916835435536037)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9917371941536037)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9917864446536037)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9918349197536037)
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/login
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495629732925880320)
,p_theme_id=>42
,p_name=>'Login'
,p_internal_name=>'LOGIN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.appLogin();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody--login t-PageTemplate--login no-anim #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#',
'<div class="t-Login-bg">',
'  #BACKGROUND_IMAGE#',
'  <div class="t-Login-bgImg"></div>',
'</div>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Login-container">',
'  <header class="t-Login-containerHeader">#REGION_POSITION_01#</header>',
'  <main class="t-Login-containerBody" id="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</main>',
'  <footer class="t-Login-containerFooter">#REGION_POSITION_02#</footer>',
'</div>',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>6
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2099711150063350616
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9924271629536041)
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_name=>'Background Image'
,p_placeholder=>'BACKGROUND_IMAGE'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9924708943536041)
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9925217172536041)
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_name=>'Body Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9925766033536041)
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_name=>'Body Footer'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/left_and_right_side_columns
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495632827206880321)
,p_theme_id=>42
,p_name=>'Left and Right Side Columns'
,p_internal_name=>'LEFT_AND_RIGHT_SIDE_COLUMNS'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.bothSideCols();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0"/>',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft no-anim t-PageTemplate--leftRightCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-side" id="t_Body_side">#REGION_POSITION_02#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525203692562657055
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9954773218536048)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9955296177536048)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9955747776536048)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9956221713536048)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9956728881536048)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9957211579536048)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>3
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9957725854536049)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>3
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9958296709536049)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9958715579536049)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9959210428536049)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9959717214536049)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9960246631536049)
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>6
);
end;
/
prompt --application/shared_components/user_interface/templates/page/left_side_column
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(12495635610083880376)
,p_theme_id=>42
,p_name=>'Left Side Column'
,p_internal_name=>'LEFT_SIDE_COLUMN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.leftSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft t-PageBody--hideActions no-anim t-PageTemplate--leftCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-side" id="t_Body_side">#REGION_POSITION_02#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main class="t-Body-mainContent" id="main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525196570560608698
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9935748514536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9936271638536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9936756398536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9937254353536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9937737475536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9938287676536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9938708407536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9939278311536044)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9939702817536045)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9940253509536045)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9940779853536045)
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/button/text_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(12495521691135880126)
,p_template_name=>'Text with Icon'
,p_internal_name=>'TEXT_WITH_ICON'
,p_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-label">#LABEL#'
||'</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-'
||'label">#LABEL#</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>2081382742158699622
,p_translate_this_template=>'N'
,p_theme_class_id=>4
,p_preset_template_options=>'t-Button--iconLeft'
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/button/text
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(12495521767510880126)
,p_template_name=>'Text'
,p_internal_name=>'TEXT'
,p_template=>'<button onclick="#JAVASCRIPT#" class="t-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="t-Button t-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_reference_id=>4070916158035059322
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/button/icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(12495522463331880131)
,p_template_name=>'Icon'
,p_internal_name=>'ICON'
,p_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidde'
||'n="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#"><span class="t-Icon #ICON_CSS_CLASSE'
||'S#" aria-hidden="true"></span></button>'
,p_reference_id=>2347660919680321258
,p_translate_this_template=>'N'
,p_theme_class_id=>5
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/region/cards_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1792064716043263)
,p_layout=>'TABLE'
,p_template=>'<div role="region" aria-label="#TITLE!ATTR#" class="t-CardsRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#ORDER_BY_ITEM##BODY##SUB_REGIONS#</div>'
,p_page_plug_template_name=>'Cards Container'
,p_internal_name=>'CARDS_CONTAINER'
,p_theme_id=>42
,p_theme_class_id=>21
,p_default_template_options=>'u-colors'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2071277712695139743
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10013664886536066)
,p_plug_template_id=>wwv_flow_imp.id(1792064716043263)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10014103553536066)
,p_plug_template_id=>wwv_flow_imp.id(1792064716043263)
,p_name=>'Sort Order'
,p_placeholder=>'ORDER_BY_ITEM'
,p_has_grid_support=>true
,p_has_region_support=>false
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10014682249536066)
,p_plug_template_id=>wwv_flow_imp.id(1792064716043263)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_drawer
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(10202937558536114)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'  <div id="#REGION_STATIC_ID#" class="t-DrawerRegion js-dialog-class-ui-dialog--drawer #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'    <div class="t-DrawerRegion-wrap">',
'      <div class="t-DrawerRegion-bodyWrapperOut">',
'        <div class="t-DrawerRegion-bodyWrapperIn">',
'          <div class="t-DrawerRegion-body">#BODY##SUB_REGIONS#</div>',
'        </div>',
'      </div>',
'      <div class="t-DrawerRegion-buttons">',
'        <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'          <div class="t-ButtonRegion-wrap">',
'            <div class="t-ButtonRegion-col t-ButtonRegion-col--left">',
'              <div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div>',
'            </div>',
'            <div class="t-ButtonRegion-col t-ButtonRegion-col--right">',
'              <div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div>',
'            </div>',
'          </div>',
'        </div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Inline Drawer'
,p_internal_name=>'INLINE_DRAWER'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal'
,p_preset_template_options=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1659526333647509386
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10203419275536115)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10203906231536115)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10204434026536115)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10204906898536115)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10205461225536115)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10205996765536116)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10206461860536116)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10206946708536116)
,p_plug_template_id=>wwv_flow_imp.id(10202937558536114)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/image
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(10210934346536117)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-ImageRegion #REGION_CSS_CLASSES#"><img src="#REGION_IMAGE_URL#" alt="#REGION_IMAGE_ALT_TEXT#" #REGION_IMAGE_ATTRIBUTES# /></div>'
,p_page_plug_template_name=>'Image'
,p_internal_name=>'IMAGE'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-ImageRegion--noFilter:t-ImageRegion--auto:t-ImageRegion--cover:t-ImageRegion--square'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1673953645642781634
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10211434407536117)
,p_plug_template_id=>wwv_flow_imp.id(10210934346536117)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10211903228536117)
,p_plug_template_id=>wwv_flow_imp.id(10210934346536117)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495572013166880213)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Wizard #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Wizard-header">',
'    <h1 class="t-Wizard-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'    <div class="u-Table t-Wizard-controls">',
'      <div class="u-Table-fit t-Wizard-buttons">#PREVIOUS##CLOSE#</div>',
'      <div class="u-Table-fill t-Wizard-steps">#BODY#</div>',
'      <div class="u-Table-fit t-Wizard-buttons">#NEXT#</div>',
'    </div>',
'  </div>',
'  <div class="t-Wizard-body">#SUB_REGIONS#</div>',
'</div>'))
,p_page_plug_template_name=>'Wizard Container'
,p_internal_name=>'WIZARD_CONTAINER'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Wizard--hideStepsXSmall'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2117602213152591491
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10024527726536069)
,p_plug_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10025020937536069)
,p_plug_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10025567370536069)
,p_plug_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10026092432536069)
,p_plug_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10026528854536069)
,p_plug_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_name=>'Wizard Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
);
end;
/
prompt --application/shared_components/user_interface/templates/region/title_bar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495573047450880221)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<nav aria-label="#TITLE!ATTR#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-BreadcrumbRegion #REGION_CSS_CLASSES#">',
'  <div class="t-BreadcrumbRegion-top">',
'    <div class="t-BreadcrumbRegion-body">',
'      <div class="t-BreadcrumbRegion-breadcrumb">#BODY#</div>',
'        <div class="t-BreadcrumbRegion-title">',
'        <h1 id="#REGION_STATIC_ID#_heading" class="t-BreadcrumbRegion-titleText" data-apex-heading>#TITLE#</h1>',
'      </div>',
'    </div>',
'    <div class="t-BreadcrumbRegion-buttons">#PREVIOUS##CLOSE##DELETE##HELP##CHANGE##EDIT##COPY##CREATE##NEXT#</div>',
'  </div>',
'  <div class="t-BreadcrumbRegion-bottom">#SMART_FILTERS#</div>',
'</nav>',
''))
,p_page_plug_template_name=>'Title Bar'
,p_internal_name=>'TITLE_BAR'
,p_theme_id=>42
,p_theme_class_id=>6
,p_default_template_options=>'t-BreadcrumbRegion--showBreadcrumb'
,p_preset_template_options=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2530016523834132090
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10054934153536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10055451253536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10055953989536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10056490559536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10056929549536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10057461132536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10057943352536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10058455452536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10058947623536076)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10059486601536077)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10059905216536077)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Smart Filters'
,p_placeholder=>'SMART_FILTERS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10060421923536077)
,p_plug_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/tabs_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495575615770880223)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-TabsRegion #REGION_CSS_CLASSES# apex-tabs-region" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  <div class="t-TabsRegion-items">#SUB_REGIONS#</div>',
'</div>'))
,p_sub_plug_template=>'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">#SUB_REGION#</div>'
,p_page_plug_template_name=>'Tabs Container'
,p_internal_name=>'TABS_CONTAINER'
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'
,p_theme_id=>42
,p_theme_class_id=>5
,p_preset_template_options=>'t-TabsRegion-mod--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>3221725015618492759
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10149625615536100)
,p_plug_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10150125351536100)
,p_plug_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_name=>'Tabs'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/standard
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495582446800880234)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Region #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <span class="t-Region-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'    <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #ORDER_BY_ITEM#',
'     #BODY#',
'     #SUB_REGIONS#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'    <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'   </div>',
' </div>',
'</div>',
''))
,p_page_plug_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>4070912133526059312
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10162516810536103)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10163075607536103)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10163511270536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10164042580536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10164536026536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10165016111536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10165532529536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10166019094536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10166557334536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10167040770536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Sort Order'
,p_placeholder=>'ORDER_BY_ITEM'
,p_has_grid_support=>true
,p_has_region_support=>false
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10167558759536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10168026121536104)
,p_plug_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/login
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495583796584880235)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Login-region t-Form--stretchInputs t-Form--labelsAbove #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Login-header">',
'    #REGION_IMAGE#',
'    <span class="t-Login-logo #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <h1 class="t-Login-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'  </div>',
'  <div class="t-Login-body">#BODY#</div>',
'  <div class="t-Login-buttons">#NEXT#</div>',
'  <div class="t-Login-links">#EDIT##CREATE#</div>',
'  <div class="t-Login-subRegions">#SUB_REGIONS#</div>',
'</div>'))
,p_page_plug_template_name=>'Login'
,p_internal_name=>'LOGIN'
,p_image_template=>'<img class="t-Login-logo" src="#REGION_IMAGE_URL#" alt="" data-app-icon />'
,p_theme_id=>42
,p_theme_class_id=>23
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2672711194551076376
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10119309347536092)
,p_plug_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10119836515536093)
,p_plug_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10120373985536093)
,p_plug_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10120820303536093)
,p_plug_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10121315016536093)
,p_plug_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/interactive_report
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495584334308880235)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-IRR-region #REGION_CSS_CLASSES#">#PREVIOUS##ORDER_BY_ITEM##BODY##SUB_REGIONS##NEXT#</div>',
''))
,p_page_plug_template_name=>'Interactive Report'
,p_internal_name=>'INTERACTIVE_REPORT'
,p_theme_id=>42
,p_theme_class_id=>9
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2099079838218790610
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10019105438536067)
,p_plug_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10019610184536067)
,p_plug_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10020156132536068)
,p_plug_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_name=>'Sort Order'
,p_placeholder=>'ORDER_BY_ITEM'
,p_has_grid_support=>true
,p_has_region_support=>false
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10020661781536068)
,p_plug_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10021148714536068)
,p_plug_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_popup
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495587659835880238)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#" class="t-DialogRegion #REGION_CSS_CLASSES# js-regionPopup" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'  <div class="t-DialogRegion-wrap">',
'    <div class="t-DialogRegion-bodyWrapperOut"><div class="t-DialogRegion-bodyWrapperIn"><div class="t-DialogRegion-body">#BODY##SUB_REGIONS#</div></div></div>',
'    <div class="t-DialogRegion-buttons">',
'       <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'         <div class="t-ButtonRegion-wrap">',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'         </div>',
'       </div>',
'    </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Popup'
,p_internal_name=>'INLINE_POPUP'
,p_theme_id=>42
,p_theme_class_id=>24
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1483922538999385230
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9986033357536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9986578238536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9987081811536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9987556502536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9988095025536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9988559615536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9989089695536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9989533090536058)
,p_plug_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/hero
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495589722092880240)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-HeroRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-HeroRegion-top">',
'    <div class="t-HeroRegion-wrap">',
'      <div class="t-HeroRegion-col t-HeroRegion-col--left">#REGION_IMAGE#<span class="t-HeroRegion-icon t-Icon #ICON_CSS_CLASSES#"></span></div>',
'      <div class="t-HeroRegion-col t-HeroRegion-col--content">',
'        <h1 class="t-HeroRegion-title" data-apex-heading>#TITLE#</h1>',
'        #BODY#',
'      </div>',
'      <div class="t-HeroRegion-col t-HeroRegion-col--right"><div class="t-HeroRegion-form">#SUB_REGIONS#</div><div class="t-HeroRegion-buttons">#NEXT#</div></div>',
'    </div>',
'  </div>',
'  <div class="t-HeroRegion-bottom">#SMART_FILTERS#</div>',
'</div>',
''))
,p_page_plug_template_name=>'Hero'
,p_internal_name=>'HERO'
,p_image_template=>'<img class="t-HeroRegion-icon" src="#REGION_IMAGE_URL#" alt="" />'
,p_theme_id=>42
,p_theme_class_id=>22
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2672571031438297268
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10110463709536090)
,p_plug_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10110926152536090)
,p_plug_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10111486841536090)
,p_plug_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_name=>'Smart Filters'
,p_placeholder=>'SMART_FILTERS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10111972774536090)
,p_plug_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/carousel_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495596329535880246)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Region t-Region--carousel #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Region-header">',
'    <div class="t-Region-headerItems t-Region-headerItems--title">',
'      <span class="t-Region-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'      <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'    </div>',
'    <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
'  </div>',
'  <div role="region" aria-label="#TITLE#" class="t-Region-bodyWrap">',
'    <div class="t-Region-buttons t-Region-buttons--top">',
'      <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'      <div class="t-Region-buttons-right">#NEXT#</div>',
'    </div>',
'    <div class="t-Region-body">',
'      #BODY#',
'      <div class="t-Region-carouselRegions">#SUB_REGIONS#</div>',
'    </div>',
'    <div class="t-Region-buttons t-Region-buttons--bottom">',
'      <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'      <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'    </div>',
'  </div>',
'</div>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">',
'  #SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'Carousel Container'
,p_internal_name=>'CAROUSEL_CONTAINER'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#',
'#APEX_FILES#plugins/com.oracle.apex.carousel/1.1/com.oracle.apex.carousel#MIN#.js?v=#APEX_VERSION#'))
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-Region--showCarouselControls'
,p_preset_template_options=>'t-Region--hiddenOverflow'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2865840475322558786
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10128955663536095)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10129427687536095)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10129991926536095)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10130418695536095)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10130939820536095)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10131403777536095)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10131984544536096)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10132404387536096)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10132954661536096)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10133487550536096)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10133952434536096)
,p_plug_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_name=>'Slides'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/content_block
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495598315850880248)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-ContentBlock #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-ContentBlock-header">',
'    <div class="t-ContentBlock-headerItems t-ContentBlock-headerItems--title">',
'      <span class="t-ContentBlock-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'      <h1 class="t-ContentBlock-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'      #EDIT#',
'    </div>',
'    <div class="t-ContentBlock-headerItems t-ContentBlock-headerItems--buttons">#CHANGE#</div>',
'  </div>',
'  <div class="t-ContentBlock-body">#BODY##SUB_REGIONS#</div>',
'  <div class="t-ContentBlock-buttons">#PREVIOUS##NEXT#</div>',
'</div>',
''))
,p_page_plug_template_name=>'Content Block'
,p_internal_name=>'CONTENT_BLOCK'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-ContentBlock--h1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2320668864738842174
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10042376535536073)
,p_plug_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10042831372536073)
,p_plug_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10043340027536073)
,p_plug_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10043805458536073)
,p_plug_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10044358468536073)
,p_plug_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10044844716536073)
,p_plug_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/collapsible
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495604368136880259)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!HTML#" class="t-Region t-Region--hideShow #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--controls"><span class="t-Button t-Button--icon t-Button--hideShow"><span class="a-Icon _a-Collapsible-icon" aria-hidden="true"></span></span></div>',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <h2 class="t-Region-title" data-apex-heading><button class="t-Region-titleButton" type="button">#TITLE#</button></h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#EDIT#</div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#CLOSE#</div>',
'    <div class="t-Region-buttons-right">#CREATE#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #COPY#',
'     #BODY#',
'     #SUB_REGIONS#',
'     #CHANGE#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
' </div>',
'</div>'))
,p_page_plug_template_name=>'Collapsible'
,p_internal_name=>'COLLAPSIBLE'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>1
,p_preset_template_options=>'is-expanded:t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2662888092628347716
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10067902048536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10068488051536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10068953006536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10069441694536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10069996260536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10070456052536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10070963775536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10071480100536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10071943277536079)
,p_plug_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/buttons_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495606500823880260)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-ButtonRegion t-Form--floatLeft #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-ButtonRegion-wrap">',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##CLOSE##DELETE#</div></div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--content">',
'      #BODY#',
'      <div class="t-ButtonRegion-buttons">#CHANGE#</div>',
'      #SUB_REGIONS#',
'    </div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Buttons Container'
,p_internal_name=>'BUTTONS_CONTAINER'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>17
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2124982336649579661
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10032489542536070)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10032996014536070)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10033445551536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10033941771536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10034451501536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10034957922536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10035449072536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10035952954536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10036484967536071)
,p_plug_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495608896288880263)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#" class="t-DialogRegion #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'  <div class="t-DialogRegion-wrap">',
'    <div class="t-DialogRegion-bodyWrapperOut"><div class="t-DialogRegion-bodyWrapperIn"><div class="t-DialogRegion-body">#BODY##SUB_REGIONS#</div></div></div>',
'    <div class="t-DialogRegion-buttons">',
'       <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'         <div class="t-ButtonRegion-wrap">',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'         </div>',
'       </div>',
'    </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Dialog'
,p_internal_name=>'INLINE_DIALOG'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal:js-draggable:js-resizable'
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2671226943886536762
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10100311469536087)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10100835674536087)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10101301558536087)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10101884129536087)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10102356356536087)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10102813372536088)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10103355020536088)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10103875269536088)
,p_plug_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_with_attributes_no_grid
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495609667684880263)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>'
,p_page_plug_template_name=>'Blank with Attributes (No Grid)'
,p_internal_name=>'BLANK_WITH_ATTRIBUTES_NO_GRID'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>3369790999010910123
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10155844085536102)
,p_plug_template_id=>wwv_flow_imp.id(12495609667684880263)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10156390994536102)
,p_plug_template_id=>wwv_flow_imp.id(12495609667684880263)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10156844339536102)
,p_plug_template_id=>wwv_flow_imp.id(12495609667684880263)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10157323417536102)
,p_plug_template_id=>wwv_flow_imp.id(12495609667684880263)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_with_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495609856182880263)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>'
,p_page_plug_template_name=>'Blank with Attributes'
,p_internal_name=>'BLANK_WITH_ATTRIBUTES'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>4499993862448380551
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10201097800536114)
,p_plug_template_id=>wwv_flow_imp.id(12495609856182880263)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10201573761536114)
,p_plug_template_id=>wwv_flow_imp.id(12495609856182880263)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10202008556536114)
,p_plug_template_id=>wwv_flow_imp.id(12495609856182880263)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10202567516536114)
,p_plug_template_id=>wwv_flow_imp.id(12495609856182880263)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12495613507239880288)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">#BODY##SUB_REGIONS#</div>',
'    </div>',
'    <div class="t-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Alert'
,p_internal_name=>'ALERT'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--warning'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2039236646100190748
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9999346432536061)
,p_plug_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(9999818600536062)
,p_plug_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10000383154536062)
,p_plug_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10000807341536062)
,p_plug_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10001351234536062)
,p_plug_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(10001843810536062)
,p_plug_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_mega_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(88546529882008878)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--noSub is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--noSub #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_list_template_name=>'Top Navigation Mega Menu'
,p_internal_name=>'TOP_NAVIGATION_MEGA_MENU'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-MegaMenu #COMPONENT_CSS_CLASSES#" id="t_MenuNav" style="display:none;">',
'  <div class="a-Menu-content t-MegaMenu-container">',
'    <div class="t-MegaMenu-body">',
'    <ul class="t-MegaMenu-list t-MegaMenu-list--top">'))
,p_list_template_after_rows=>' </ul></div></div></div>'
,p_before_sub_list=>'<ul class="t-MegaMenu-list t-MegaMenu-list--sub">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--hasSub is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--hasSub #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Description'
,p_a04_label=>'List Item Class'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_a07_label=>'Badge Class'
,p_a08_label=>'Menu Item Class'
,p_reference_id=>1665447133514362075
);
end;
/
prompt --application/shared_components/user_interface/templates/list/tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495524735818880142)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Tabs-item is-active #A03#" aria-current="page" id="#A01#">',
'  <a href="#LINK#" class="t-Tabs-link #A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-Tabs-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Tabs-item #A03#" id="#A01#">',
'  <a href="#LINK#" class="t-Tabs-link #A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-Tabs-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Tabs'
,p_internal_name=>'TABS'
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Tabs--simple'
,p_list_template_before_rows=>'<ul class="t-Tabs #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'List Item ID'
,p_a03_label=>'List Item Class'
,p_a04_label=>'Link Class'
,p_reference_id=>3288206686691809997
);
end;
/
prompt --application/shared_components/user_interface/templates/list/menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495525309455880143)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'Menu Popup'
,p_internal_name=>'MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({ iconType: ''fa'', callout: e.hasClass("js-menu-callout")});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut'
,p_a06_label=>'Link Target'
,p_reference_id=>3492264004432431646
);
end;
/
prompt --application/shared_components/user_interface/templates/list/wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495526785023880145)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-WizardSteps-step is-active" aria-current="step" id="#LIST_ITEM_ID#">',
'  <div class="t-WizardSteps-wrap" data-link="#LINK#">',
'    <span class="t-WizardSteps-marker" aria-hidden="true"></span>',
'    <span class="t-WizardSteps-label">#TEXT# <span aria-hidden="true" class="t-WizardSteps-labelState"></span></span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-WizardSteps-step" id="#LIST_ITEM_ID#">',
'  <div class="t-WizardSteps-wrap" data-link="#LINK#">',
'    <span class="t-WizardSteps-marker" aria-hidden="true"></span>',
'    <span class="t-WizardSteps-label">#TEXT# <span aria-hidden="true" class="t-WizardSteps-labelState"></span></span>',
'  </div>',
'</li>'))
,p_list_template_name=>'Wizard Progress'
,p_internal_name=>'WIZARD_PROGRESS'
,p_javascript_code_onload=>'apex.theme.initWizardProgressBar();'
,p_theme_id=>42
,p_theme_class_id=>17
,p_preset_template_options=>'t-WizardSteps--displayLabels'
,p_list_template_before_rows=>'<ul aria-label="#CURRENT_PROGRESS#" class="t-WizardSteps #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>2008702338707394488
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495528385085880146)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavTabs-item #A03# is-active" aria-current="page" id="#A01#">',
'  <a href="#LINK#" class="t-NavTabs-link #A04# " title="#TEXT_ESC_SC#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-NavTabs-label">#TEXT_ESC_SC#</span>',
'    <span class="t-NavTabs-badge #A05#">#A02#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavTabs-item #A03#" id="#A01#">',
'  <a href="#LINK#" class="t-NavTabs-link #A04# " title="#TEXT_ESC_SC#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-NavTabs-label">#TEXT_ESC_SC#</span>',
'    <span class="t-NavTabs-badge #A05#">#A02#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Top Navigation Tabs'
,p_internal_name=>'TOP_NAVIGATION_TABS'
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-NavTabs--inlineLabels-lg:t-NavTabs--displayLabels-sm'
,p_list_template_before_rows=>'<ul class="t-NavTabs #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_navtabs">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'List Item ID'
,p_a02_label=>'Badge Value'
,p_a03_label=>'List Item Class'
,p_a04_label=>'Link Class'
,p_a05_label=>'Badge Class'
,p_reference_id=>1453011561172885578
);
end;
/
prompt --application/shared_components/user_interface/templates/list/menu_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495529517389880148)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Menu Bar'
,p_internal_name=>'MENU_BAR'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  iconType: ''fa'',',
'  menubar: true,',
'  menubarOverflow: true,',
'  callout: e.hasClass("js-menu-callout")',
'});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-showSubMenuIcons'
,p_list_template_before_rows=>'<div class="t-MenuBar #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_menubar"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut'
,p_a06_label=>'Link Target'
,p_reference_id=>2008709236185638887
);
end;
/
prompt --application/shared_components/user_interface/templates/list/links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495531199768880148)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Links List'
,p_internal_name=>'LINKS_LIST'
,p_theme_id=>42
,p_theme_class_id=>18
,p_list_template_before_rows=>'<ul class="t-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul class="t-LinksList-list">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_a01_label=>'Badge Value'
,p_a02_label=>'Link Attributes'
,p_a03_label=>'List Item CSS Classes'
,p_reference_id=>4070914341144059318
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495532306266880151)
,p_list_template_current=>'<li class="a-MenuBar-item a-Menu--current" data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ES'
||'C_SC#</a></li>'
,p_list_template_noncurrent=>'<li class="a-MenuBar-item" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Top Navigation Menu'
,p_internal_name=>'TOP_NAVIGATION_MENU'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("#t_MenuNav", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  menubar: true,',
'  menubarOverflow: true,',
'  callout: e.hasClass("js-menu-callout")',
'});',
''))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-tabLike'
,p_list_template_before_rows=>'<div class="t-Header-nav-list #COMPONENT_CSS_CLASSES#" id="t_MenuNav"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul style="display: none">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li class="a-MenuBar-item a-Menu--current" data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ES'
||'C_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li class="a-MenuBar-item" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_reference_id=>2525307901300239072
);
end;
/
prompt --application/shared_components/user_interface/templates/list/side_navigation_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495533999726880152)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row is-selected is-current--top"></div>',
'    <div role="none" class="a-TreeView-content is-selected is-current--top">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="false" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row"></div>',
'    <div role="none" class="a-TreeView-content">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
'</li>'))
,p_list_template_name=>'Side Navigation Menu'
,p_internal_name=>'SIDE_NAVIGATION_MENU'
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js?v=#APEX_VERSION#'
,p_javascript_code_onload=>'apex.jQuery(''body'').addClass(''t-PageBody--leftNav'');'
,p_theme_id=>42
,p_theme_class_id=>19
,p_default_template_options=>'js-defaultCollapsed'
,p_preset_template_options=>'js-navCollapsed--hidden:t-TreeNav--styleA'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-nav" id="t_Body_nav" role="navigation" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL".">',
'  <div class="a-TreeView t-TreeNav #COMPONENT_CSS_CLASSES#" id="t_TreeNav" data-id="#PARENT_STATIC_ID#_tree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL".">',
'    <ul>',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </ul>',
'  </div>',
'</div>',
'<script>(sessionStorage.getItem("nav.&APP_ID..preferenceForExpanded") === "true" && window.matchMedia("(min-width: " + getComputedStyle(document.documentElement).getPropertyValue("--js-mq-lg") + ")").matches) && document.getElementById(''t_PageBody'').'
||'classList.add(''js-navExpanded'');</script>',
'<script>',
'    const labels = document.querySelectorAll(".a-TreeView .a-TreeView-label");',
'    for (const label of labels) {',
'        label.textContent = label.textContent.replaceAll(/\[(.*?)\]/ig, '''');',
'    }',
'</script>'))
,p_before_sub_list=>'<ul style="display:none">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row is-selected is-current--top"></div>',
'    <div role="none" class="a-TreeView-content is-selected is-current--top">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="false" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row"></div>',
'    <div role="none" class="a-TreeView-content">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
''))
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Disabled (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_reference_id=>2466292414354694776
);
end;
/
prompt --application/shared_components/user_interface/templates/list/navigation_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495534382344880154)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#" aria-current="page">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" title="#A04#" target="#A06#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" title="#A04#" target="#A06#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Navigation Bar'
,p_internal_name=>'NAVIGATION_BAR'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<ul class="t-NavigationBar #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<div class="t-NavigationBar-menu" style="display: none" id="menu_#PARENT_LIST_ITEM_ID#"><ul>'
,p_after_sub_list=>'</ul></div></li>'
,p_sub_list_item_current=>'<li class="#A02#" data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li class="#A02#" data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#" aria-current="page">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#" title="#A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow" aria-hidden="true"></span>',
'  </button>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#" title="#A04#">',
'      <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow" aria-hidden="true"></span>',
'  </button>'))
,p_sub_templ_curr_w_child=>'<li class="#A02#" data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="#A02#" data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_a01_label=>'Badge Value'
,p_a02_label=>'List  Item CSS Classes'
,p_a04_label=>'Title Attribute'
,p_a06_label=>'Link Target'
,p_reference_id=>2846096252961119197
);
end;
/
prompt --application/shared_components/user_interface/templates/list/media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495537187789880157)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item is-active #A04#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #A05#" #A03#>',
'    <div class="t-MediaList-iconWrap" aria-hidden="true">',
'      <span class="t-MediaList-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title" aria-current="page">#TEXT#</h3>',
'      <p class="t-MediaList-desc">#A01#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#A02#</span>',
'    </div>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item  #A04#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #A05#" #A03#>',
'    <div class="t-MediaList-iconWrap" aria-hidden="true">',
'      <span class="t-MediaList-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#TEXT#</h3>',
'      <p class="t-MediaList-desc">#A01#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#A02#</span>',
'    </div>',
'  </a>',
'</li>'))
,p_list_template_name=>'Media List'
,p_internal_name=>'MEDIA_LIST'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-MediaList--showIcons:t-MediaList--showDesc'
,p_list_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'List Item CSS Classes'
,p_a05_label=>'Link Class'
,p_a06_label=>'Icon Color Class'
,p_reference_id=>2066548068783481421
);
end;
/
prompt --application/shared_components/user_interface/templates/list/cards
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495542773533880165)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item is-active #A04#" aria-current="page">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap" #A05#>',
'      <div class="t-Card-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap">',
'        <h3 class="t-Card-title">#TEXT#</h3>',
'        <h4 class="t-Card-subtitle">#A07#</h4>',
'      </div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #A06#" aria-hidden="true"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #A04#">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap" #A05#>',
'      <div class="t-Card-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap">',
'        <h3 class="t-Card-title">#TEXT#</h3>',
'        <h4 class="t-Card-subtitle">#A07#</h4>',
'      </div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #A06#" aria-hidden="true"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_name=>'Cards'
,p_internal_name=>'CARDS'
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Cards--animColorFill:t-Cards--3cols:t-Cards--basic'
,p_list_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Secondary Information'
,p_a03_label=>'Initials'
,p_a04_label=>'List Item CSS Classes'
,p_a05_label=>'Link Attributes'
,p_a06_label=>'Card Color Class'
,p_a07_label=>'Subtitle'
,p_reference_id=>2885322685880632508
);
end;
/
prompt --application/shared_components/user_interface/templates/list/badge_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(12495546789751880176)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02# is-current" aria-current="page">',
'  <a class="t-BadgeList-wrap u-color #A04#" href="#LINK#" #A03#>',
'    <span class="t-BadgeList-label">#TEXT#</span>',
'    <span class="t-BadgeList-value">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02#">',
'  <a class="t-BadgeList-wrap u-color #A04#" href="#LINK#" #A03#>',
'    <span class="t-BadgeList-label">#TEXT#</span>',
'    <span class="t-BadgeList-value">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'Badge List'
,p_internal_name=>'BADGE_LIST'
,p_theme_id=>42
,p_theme_class_id=>3
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--cols t-BadgeList--3cols:t-BadgeList--circular'
,p_list_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Value'
,p_a02_label=>'List item CSS Classes'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'Link Classes'
,p_reference_id=>2062482847268086664
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A01: Large Number',
'A02: List Item Classes',
'A03: Link Attributes'))
);
end;
/
prompt --application/shared_components/user_interface/templates/report/contextual_info
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(10330268006536153)
,p_row_template_name=>'Contextual Info'
,p_internal_name=>'CONTEXTUAL_INFO'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ContextualInfo-item">',
'  <span class="t-ContextualInfo-label">#COLUMN_HEADER#</span>',
'  <span class="t-ContextualInfo-value">#COLUMN_VALUE#</span>',
'</div>'))
,p_row_template_before_rows=>' <div class="t-ContextualInfo #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_reference_id=>2114325881116323585
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/value_attribute_pairs_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495548550946880181)
,p_row_template_name=>'Value Attribute Pairs - Column'
,p_internal_name=>'VALUE_ATTRIBUTE_PAIRS_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #COLUMN_HEADER#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #COLUMN_VALUE#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-AVPList--leftAligned'
,p_reference_id=>2099068636272681754
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/media_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495551502649880184)
,p_row_template_name=>'Media List'
,p_internal_name=>'MEDIA_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item #LIST_CLASS#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #LINK_CLASS#" #LINK_ATTR#>',
'    <div class="t-MediaList-iconWrap" aria-hidden"true">',
'      <span class="t-MediaList-icon u-color #ICON_COLOR_CLASS#"><span class="t-Icon #ICON_CLASS#"></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#LIST_TITLE#</h3>',
'      <p class="t-MediaList-desc">#LIST_TEXT#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#LIST_BADGE#</span>',
'    </div>',
'  </a>',
'</li>',
''))
,p_row_template_condition1=>':LINK is not null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item #LIST_CLASS#">',
'  <div class="t-MediaList-itemWrap #LINK_CLASS#" #LINK_ATTR#>',
'    <div class="t-MediaList-iconWrap" aria-hidden"true">',
'      <span class="t-MediaList-icon u-color #ICON_COLOR_CLASS#"><span class="t-Icon #ICON_CLASS#"></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#LIST_TITLE#</h3>',
'      <p class="t-MediaList-desc">#LIST_TEXT#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#LIST_BADGE#</span>',
'    </div>',
'  </div>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_default_template_options=>'t-MediaList--showDesc:t-MediaList--showIcons'
,p_preset_template_options=>'t-MediaList--stack'
,p_reference_id=>2092157460408299055
,p_translate_this_template=>'N'
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/timeline
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495551963420880184)
,p_row_template_name=>'Timeline'
,p_internal_name=>'TIMELINE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <div class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#" role="presentation">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':EVENT_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <a href="#EVENT_LINK#" class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#" role="presentation">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </a>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-Timeline #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_timeline" data-region-id="#REGION_STATIC_ID#">',
''))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_reference_id=>1513373588340069864
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/content_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495555143782880187)
,p_row_template_name=>'Content Row'
,p_internal_name=>'CONTENT_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-ContentRow-item #ITEM_CLASSES#">',
'  <div class="t-ContentRow-wrap">',
'    <div class="t-ContentRow-selection">#SELECTION#</div>',
'    <div class="t-ContentRow-iconWrap">',
'      <span class="t-ContentRow-icon #ICON_CLASS#">#ICON_HTML#</span>',
'    </div>',
'    <div class="t-ContentRow-body">',
'      <div class="t-ContentRow-content">',
'        <h3 class="t-ContentRow-title">#TITLE#</h3>',
'        <div class="t-ContentRow-description">#DESCRIPTION#</div>',
'      </div>',
'      <div class="t-ContentRow-misc">#MISC#</div>',
'      <div class="t-ContentRow-actions">#ACTIONS#</div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-ContentRow #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>1797843454948280151
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/value_attribute_pairs_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495557168323880188)
,p_row_template_name=>'Value Attribute Pairs - Row'
,p_internal_name=>'VALUE_ATTRIBUTE_PAIRS_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #1#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #2#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-AVPList--leftAligned'
,p_reference_id=>2099068321678681753
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495559701953880190)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td class="t-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS#>#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">',
'  <div class="t-Report-wrap">',
'    <table class="t-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="t-Report-tableWrap">',
'    <table class="t-Report-report" id="report_table_#REGION_STATIC_ID#" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="t-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="t-Report-pagination t-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="t-Report-colHead" #ARIA_SORT# #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</thead>',
'<tbody>'))
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
,p_reference_id=>2537207537838287671
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/search_results
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495559979944880192)
,p_row_template_name=>'Search Results'
,p_internal_name=>'SEARCH_RESULTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition1=>':LABEL_02 is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition2=>':LABEL_03 is null'
,p_row_template3=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition3=>':LABEL_04 is null'
,p_row_template4=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'      <span class="t-SearchResults-misc">#LABEL_04#: #VALUE_04#</span>',
'    </div>',
'  </li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-SearchResults #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">',
'<ul class="t-SearchResults-list">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>',
'</div>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070913431524059316
,p_translate_this_template=>'N'
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/comments
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495561145534880193)
,p_row_template_name=>'Comments'
,p_internal_name=>'COMMENTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Comments-item #COMMENT_MODIFIERS#">',
'  <div class="t-Comments-icon">',
'    <div class="t-Comments-userIcon #ICON_MODIFIER#" aria-hidden="true">#USER_ICON#</div>',
'  </div>',
'  <div class="t-Comments-body">',
'    <div class="t-Comments-info">',
'      #USER_NAME# <span class="t-Comments-date">#COMMENT_DATE#</span> <span class="t-Comments-actions">#ACTIONS#</span>',
'    </div>',
'    <div class="t-Comments-comment">',
'      #COMMENT_TEXT##ATTRIBUTE_1##ATTRIBUTE_2##ATTRIBUTE_3##ATTRIBUTE_4#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Comments #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>',
''))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Comments--chat'
,p_reference_id=>2611722012730764232
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/cards
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495566507385880202)
,p_row_template_name=>'Cards'
,p_internal_name=>'CARDS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <a href="#CARD_LINK#" class="t-Card-wrap">',
'      <div class="t-Card-icon u-color #CARD_COLOR#"><span class="t-Icon fa #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3><h4 class="t-Card-subtitle">#CARD_SUBTITLE#</h4></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #CARD_COLOR#"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is not null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <div class="t-Card-wrap">',
'      <div class="t-Card-icon u-color #CARD_COLOR#"><span class="t-Icon fa #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3><h4 class="t-Card-subtitle">#CARD_SUBTITLE#</h4></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #CARD_COLOR#"></span>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_cards" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Cards--animColorFill:t-Cards--3cols:t-Cards--basic'
,p_reference_id=>2973535649510699732
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/badge_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495570578125880206)
,p_row_template_name=>'Badge List'
,p_internal_name=>'BADGE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-wrap u-color">',
'    <span class="t-BadgeList-label">#COLUMN_HEADER#</span>',
'    <span class="t-BadgeList-value">#COLUMN_VALUE#</span>',
'  </span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--fixed:t-BadgeList--circular'
,p_reference_id=>2103197159775914759
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/alerts
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(12495570774422880210)
,p_row_template_name=>'Alerts'
,p_internal_name=>'ALERTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--horizontal t-Alert--colorBG t-Alert--defaultIcons t-Alert--#ALERT_TYPE#" role="alert">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon" aria-hidden="true"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title">#ALERT_TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">',
'        #ALERT_DESC#',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      #ALERT_ACTION#',
'    </div>',
'  </div>',
'</div>'))
,p_row_template_before_rows=>'<div class="t-Alerts #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_alerts" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>14
,p_reference_id=>2881456138952347027
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required_floating
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495522548744880132)
,p_template_name=>'Required - Floating'
,p_internal_name=>'REQUIRED_FLOATING'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--floatingLabel is-required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer">',
'  <div class="t-Form-itemRequired-marker" aria-hidden="true"></div>',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>1607675344320152883
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495522609431880132)
,p_template_name=>'Required - Above'
,p_internal_name=>'REQUIRED_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label> #HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked is-required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer">',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>3030115129444970113
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495522780887880132)
,p_template_name=>'Required'
,p_internal_name=>'REQUIRED'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer is-required rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#">',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>2525313812251712801
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_floating
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495522847445880132)
,p_template_name=>'Optional - Floating'
,p_internal_name=>'OPTIONAL_FLOATING'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--floatingLabel #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>1607675164727151865
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495522916395880132)
,p_template_name=>'Optional - Above'
,p_internal_name=>'OPTIONAL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>3030114864004968404
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495523037429880132)
,p_template_name=>'Optional'
,p_internal_name=>'OPTIONAL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>',
''))
,p_before_item=>'<div class="t-Form-fieldContainer rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>2317154212072806530
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12495523145758880138)
,p_template_name=>'Hidden'
,p_internal_name=>'HIDDEN'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer t-Form-labelContainer--hiddenLabel col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label u-VisuallyHidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--hiddenLabel rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>13
,p_reference_id=>2039339104148359505
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(12495520300515880126)
,p_name=>'Breadcrumb'
,p_internal_name=>'BREADCRUMB'
,p_before_first=>'<ul class="t-Breadcrumb #COMPONENT_CSS_CLASSES#">'
,p_current_page_option=>'<li class="t-Breadcrumb-item is-active" aria-current="page"><h1 class="t-Breadcrumb-label">#NAME#</h1></li>'
,p_non_current_page_option=>'<li class="t-Breadcrumb-item"><a href="#LINK#" class="t-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070916542570059325
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(12495520149009880113)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#THEME_STYLE_CSS#',
'#FAVICONS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="t-Page t-Page--popupLOV"'
,p_before_field_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="apex-item-text"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="t-Button t-Button--hot t-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="t-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_result_row_x_of_y=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>100
,p_before_result_set=>'<div class="t-PopupLOV-links">'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>2885398517835871876
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(12495520204691880120)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" aria-label="#IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>',
''))
,p_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--weekly">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_weekly_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" aria-label="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_weekly_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_weekly_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_day_close_format=>'</div></td>'
,p_weekly_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_close_format=>'</div></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_weekly_time_close_format=>'</th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" id="#DY#" class="t-ClassicCalendar-dayColumn">#IDAY#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--daily">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #DD#, #YYYY#</h1>'))
,p_daily_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" aria-label="#CALENDAR_TITLE# #START_DL#" class="t-ClassicCalendar-calendar">'
,p_daily_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_daily_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_day_close_format=>'</div></td>'
,p_daily_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol" id="#TIME#">'
,p_daily_time_close_format=>'</th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_cust_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_cust_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_cust_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" aria-label="#IMONTH# #YYYY#">'
,p_cust_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_cust_week_open_format=>'<tr>'
,p_cust_week_close_format=>'</tr> '
,p_cust_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">'
,p_cust_day_close_format=>'</td>'
,p_cust_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">'
,p_cust_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_cust_nonday_close_format=>'</td>'
,p_cust_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">'
,p_cust_weekend_close_format=>'</td>'
,p_cust_hour_open_format=>'<tr>'
,p_cust_hour_close_format=>'</tr>'
,p_cust_time_title_format=>'#TIME#'
,p_cust_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_cust_time_close_format=>'</th>'
,p_cust_wk_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_cust_wk_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_cust_wk_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_cust_wk_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_cust_wk_week_open_format=>'<tr>'
,p_cust_wk_week_close_format=>'</tr> '
,p_cust_wk_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_cust_wk_day_close_format=>'</div></td>'
,p_cust_wk_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_cust_wk_weekend_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">'
,p_cust_wk_weekend_close_format=>'</td>'
,p_agenda_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--list">',
'  <div class="t-ClassicCalendar-title">#IMONTH# #YYYY#</div>',
'  <ul class="t-ClassicCalendar-list">',
'    #DAYS#',
'  </ul>',
'</div>'))
,p_agenda_past_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-past">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_today_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-today">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_future_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-future">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_past_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-past">#DATA#</li>'
,p_agenda_today_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-today">#DATA#</li>'
,p_agenda_future_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-future">#DATA#</li>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'<span class="t-ClassicCalendar-event">#DATA#</span>'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070916747979059326
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(12495518953135880092)
,p_theme_id=>42
,p_theme_name=>'Universal Theme'
,p_theme_internal_name=>'UNIVERSAL_THEME'
,p_ui_type_name=>'DESKTOP'
,p_navigation_type=>'L'
,p_nav_bar_type=>'LIST'
,p_reference_id=>4070917134413059350
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(12495618547053880299)
,p_default_dialog_template=>wwv_flow_imp.id(12495624331342880306)
,p_error_template=>wwv_flow_imp.id(12495629732925880320)
,p_printer_friendly_template=>wwv_flow_imp.id(12495618547053880299)
,p_breadcrumb_display_point=>'REGION_POSITION_01'
,p_sidebar_display_point=>'REGION_POSITION_02'
,p_login_template=>wwv_flow_imp.id(12495629732925880320)
,p_default_button_template=>wwv_flow_imp.id(12495521767510880126)
,p_default_region_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_chart_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_form_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_reportr_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_tabform_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_wizard_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_menur_template=>wwv_flow_imp.id(12495573047450880221)
,p_default_listr_template=>wwv_flow_imp.id(12495582446800880234)
,p_default_irr_template=>wwv_flow_imp.id(12495584334308880235)
,p_default_report_template=>wwv_flow_imp.id(12495559701953880190)
,p_default_label_template=>wwv_flow_imp.id(12495522847445880132)
,p_default_menu_template=>wwv_flow_imp.id(12495520300515880126)
,p_default_calendar_template=>wwv_flow_imp.id(12495520204691880120)
,p_default_list_template=>wwv_flow_imp.id(12495531199768880148)
,p_default_nav_list_template=>wwv_flow_imp.id(12495532306266880151)
,p_default_top_nav_list_temp=>wwv_flow_imp.id(12495532306266880151)
,p_default_side_nav_list_temp=>wwv_flow_imp.id(12495533999726880152)
,p_default_nav_list_position=>'SIDE'
,p_default_dialogbtnr_template=>wwv_flow_imp.id(12495606500823880260)
,p_default_dialogr_template=>wwv_flow_imp.id(12495609856182880263)
,p_default_option_label=>wwv_flow_imp.id(12495522847445880132)
,p_default_required_label=>wwv_flow_imp.id(12495522548744880132)
,p_default_page_transition=>'NONE'
,p_default_popup_transition=>'NONE'
,p_default_navbar_list_template=>wwv_flow_imp.id(12495534382344880154)
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(42),'#APEX_FILES#themes/theme_42/22.1/')
,p_files_version=>64
,p_icon_library=>'FONTAPEX'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
'#THEME_FILES#js/theme42#MIN#.js?v=#APEX_VERSION#'))
,p_css_file_urls=>'#THEME_FILES#css/Core#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(9342850631535906)
,p_theme_id=>42
,p_name=>'Redwood Light'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#',
'#THEME_FILES#css/Redwood#MIN#.css?v=#APEX_VERSION#'))
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Redwood-Theme.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Redwood-Theme#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>2596426436825065489
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(9343252703535906)
,p_theme_id=>42
,p_name=>'Vita'
,p_is_current=>true
,p_is_public=>true
,p_is_accessible=>true
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>2719875314571594493
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(9343693327535906)
,p_theme_id=>42
,p_name=>'Vita - Dark'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita-Dark.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita-Dark#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>3543348412015319650
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(9344068638535906)
,p_theme_id=>42
,p_name=>'Vita - Red'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita-Red.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita-Red#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>1938457712423918173
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(9344480134535906)
,p_theme_id=>42
,p_name=>'Vita - Slate'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita-Slate.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita-Slate#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>3291983347983194966
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A200D0A202A20464C4F57532D4441524B0D0A202A20202020284F7261636C65204170706C69636174696F6E2045787072657373205468656D65205374796C65290D0A202A200D0A202A2054686973204353532066696C65207761732067656E657261';
wwv_flow_imp.g_varchar2_table(2) := '746564207573696E6720746865204F7261636C65204170706C69636174696F6E204578707265737320352E30205468656D6520526F6C6C65722E200D0A202A200D0A202A2F2E742D426F6479207B0D0A20200D0A7D0D0A2E742D426F6479202E612D4D69';
wwv_flow_imp.g_varchar2_table(3) := '6E6943616C207B0D0A2020626F726465723A2031707820736F6C696420233432346135313B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033353B0D0A7D0D0A2E742D426F';
wwv_flow_imp.g_varchar2_table(4) := '6479202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20236166616661663B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(5) := '742D426F6479202E612D4D696E6943616C2D646179207B0D0A2020626F726465722D636F6C6F723A20233331333633633B0D0A2020636F6C6F723A20236566656665663B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D6461792E69732D74';
wwv_flow_imp.g_varchar2_table(6) := '6F646179202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D6461792E69';
wwv_flow_imp.g_varchar2_table(7) := '732D616374697665202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D64';
wwv_flow_imp.g_varchar2_table(8) := '61792E69732D7765656B656E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233330333533613B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(9) := '6F723A20233334336134303B0D0A7D0D0A2E742D526567696F6E207B0D0A20200D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420233339336634353B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(10) := '7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(11) := '742D526567696F6E202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20236135613561353B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D646179207B0D0A2020626F726465722D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(12) := '3238326333303B0D0A2020636F6C6F723A20236535653565353B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(13) := '6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D616374697665202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(14) := '6E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D7765656B656E64207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(15) := '20233236326232663B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033353B0D0A7D0D0A2E742D426F64792D616374696F6E73207B';
wwv_flow_imp.g_varchar2_table(16) := '0D0A20200D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420233435346535353B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(17) := '6F756E642D636F6C6F723A20233265333433393B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D616374696F6E73202E';
wwv_flow_imp.g_varchar2_table(18) := '612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20236233623362333B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D646179207B0D0A2020626F726465722D636F6C6F723A202333343361';
wwv_flow_imp.g_varchar2_table(19) := '34303B0D0A2020636F6C6F723A20236633663366333B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(20) := '6F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D616374697665202E612D4D696E6943616C2D64617465207B0D0A2020';
wwv_flow_imp.g_varchar2_table(21) := '6261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D7765656B656E64207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(22) := '6B67726F756E642D636F6C6F723A20233333333933653B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233338336534343B0D0A';
wwv_flow_imp.g_varchar2_table(23) := '7D0D0A2E742D426F64792D696E666F207B0D0A20200D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420233439353135393B0D0A2020626F726465722D7261646975733A20';
wwv_flow_imp.g_varchar2_table(24) := '3270783B0D0A20206261636B67726F756E642D636F6C6F723A20233332333833643B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64';
wwv_flow_imp.g_varchar2_table(25) := '792D696E666F202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20236237623762373B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D646179207B0D0A2020626F726465722D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(26) := '233338336534343B0D0A2020636F6C6F723A20236637663766373B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(27) := '2D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D616374697665202E612D4D696E6943616C2D64617465207B0D0A202062';
wwv_flow_imp.g_varchar2_table(28) := '61636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D7765656B656E64207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(29) := '756E642D636F6C6F723A20233336336434333B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233362343234383B0D0A7D0D0A2E742D41';
wwv_flow_imp.g_varchar2_table(30) := '56504C6973742D6974656D207B0D0A2020626F782D736861646F773A2030202D302E3172656D20302072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E742D4156504C6973742D6C6162656C2C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(31) := '4156504C6973742D76616C7565207B0D0A2020626F782D736861646F773A203020302E3172656D2072676261283235352C203235352C203235352C20302E3037352920696E7365743B0D0A7D0D0A2E742D4156504C6973742D76616C7565207B0D0A2020';
wwv_flow_imp.g_varchar2_table(32) := '636F6C6F723A20236439643964393B0D0A7D0D0A2E742D426F64792D696E666F202E742D4156504C6973742D76616C7565207B0D0A2020636F6C6F723A20236439643964393B0D0A7D0D0A2E742D526567696F6E202E742D4156504C6973742D76616C75';
wwv_flow_imp.g_varchar2_table(33) := '65207B0D0A2020636F6C6F723A20236438643864383B0D0A7D0D0A2E742D4156504C6973742D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D696E666F202E742D4156504C6973742D6C6162656C207B';
wwv_flow_imp.g_varchar2_table(34) := '0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E742D4156504C6973742D6C6162656C207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D4156504C697374202B202E742D5265706F72742D70';
wwv_flow_imp.g_varchar2_table(35) := '6167696E6174696F6E207B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D416C6572742D2D77697A6172642C0D0A2E742D416C6572742D2D686F72697A6F6E';
wwv_flow_imp.g_varchar2_table(36) := '74616C207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D416C6572742D2D77697A617264202E742D416C6572';
wwv_flow_imp.g_varchar2_table(37) := '742D69636F6E2C0D0A2E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A2020626F726465722D626F74746F6D2D6C6566742D';
wwv_flow_imp.g_varchar2_table(38) := '7261646975733A203270783B0D0A7D0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D7761726E696E672C0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D79656C6C6F77207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(39) := '756E642D636F6C6F723A20233362326330313B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D73756363657373207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(40) := '20233134333930663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D64616E6765722C0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D72656420';
wwv_flow_imp.g_varchar2_table(41) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233332303630333B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D696E666F207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(42) := '6E642D636F6C6F723A20233032326134643B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D416C6572742D2D7761726E';
wwv_flow_imp.g_varchar2_table(43) := '696E67202E742D416C6572742D69636F6E202E742D49636F6E2C0D0A2E742D416C6572742D2D79656C6C6F77202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E742D416C657274';
wwv_flow_imp.g_varchar2_table(44) := '2D2D7761726E696E672E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E2C0D0A2E742D416C6572742D2D79656C6C6F772E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A';
wwv_flow_imp.g_varchar2_table(45) := '20206261636B67726F756E642D636F6C6F723A2072676261283235312C203230362C2037342C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D73756363657373202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(46) := '3A20233342414132433B0D0A7D0D0A2E742D416C6572742D2D737563636573732E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835392C2031';
wwv_flow_imp.g_varchar2_table(47) := '37302C2034342C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D696E666F202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20233361613266613B0D0A7D0D0A2E742D416C6572742D2D696E666F2E742D416C';
wwv_flow_imp.g_varchar2_table(48) := '6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835382C203136322C203235302C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D64616E67657220';
wwv_flow_imp.g_varchar2_table(49) := '2E742D416C6572742D69636F6E202E742D49636F6E2C0D0A2E742D416C6572742D2D726564202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20236634343333363B0D0A7D0D0A2E742D416C6572742D2D64616E6765';
wwv_flow_imp.g_varchar2_table(50) := '722E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E2C0D0A2E742D416C6572742D2D7265642E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(51) := '642D636F6C6F723A2072676261283234342C2036372C2035342C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D77697A617264202E742D416C6572742D696E736574207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(52) := '742D416C6572742D2D686F72697A6F6E74616C2C0D0A2E742D416C6572742D2D77697A617264207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D416C65';
wwv_flow_imp.g_varchar2_table(53) := '72742D2D70616765207B0D0A2020626F782D736861646F773A20302030203020302E3172656D2072676261283235352C203235352C203235352C20302E312920696E7365742C20302033707820397078202D327078207267626128302C20302C20302C20';
wwv_flow_imp.g_varchar2_table(54) := '302E31293B0D0A7D0D0A2E742D416C6572742D2D70616765202E612D4E6F74696669636174696F6E2D6974656D3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3529';
wwv_flow_imp.g_varchar2_table(55) := '3B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835392C203137302C2034342C20302E39293B0D0A2020636F6C6F723A20234646463B';
wwv_flow_imp.g_varchar2_table(56) := '0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20234646';
wwv_flow_imp.g_varchar2_table(57) := '463B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D416C6572742D2D70616765';
wwv_flow_imp.g_varchar2_table(58) := '2E742D416C6572742D2D73756363657373202E742D427574746F6E2D2D636C6F7365416C657274207B0D0A2020636F6C6F723A20234646462021696D706F7274616E743B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D776172';
wwv_flow_imp.g_varchar2_table(59) := '6E696E67207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D7761726E696E67202E742D416C657274';
wwv_flow_imp.g_varchar2_table(60) := '2D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D7761726E696E672061207B0D0A2020636F6C6F723A20696E68657269743B0D0A2020746578';
wwv_flow_imp.g_varchar2_table(61) := '742D6465636F726174696F6E3A20756E6465726C696E653B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D7761726E696E67202E612D4E6F74696669636174696F6E2D6974656D3A6265666F7265207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(62) := '6F756E642D636F6C6F723A2063757272656E74436F6C6F723B0D0A7D0D0A2E742D4C6F67696E2D636F6E7461696E6572426F6479202E742D426F64792D616C657274207B0D0A202077696474683A2034363070783B0D0A7D0D0A2E742D42616467652D2D';
wwv_flow_imp.g_varchar2_table(63) := '6261736963207B0D0A2020626F782D736861646F773A20302030203020302E3172656D207267626128302C20302C20302C20302E3032352920696E7365743B0D0A7D0D0A2E742D42616467652D2D6F72623A6265666F7265207B0D0A2020626F782D7368';
wwv_flow_imp.g_varchar2_table(64) := '61646F773A20302030203020302E3172656D207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D42616467652D2D6F72622E69732D6E756C6C3A6265666F7265207B0D0A2020636F6C6F723A20233730373037303B0D';
wwv_flow_imp.g_varchar2_table(65) := '0A7D0D0A2E742D42616467652D2D62617369632E69732D6E756C6C207B0D0A2020636F6C6F723A20233730373037303B0D0A7D0D0A2E742D42616467654C6973742C0D0A2E742D42616467654C6973743A6E6F74282E752D636F6C6F7273292061202E74';
wwv_flow_imp.g_varchar2_table(66) := '2D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D76616C7565207B0D0A2020626F782D736861646F773A';
wwv_flow_imp.g_varchar2_table(67) := '203020302030203170782072676261283235342C203235342C203235342C20302E312920696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E742D42616467654C6973742D2D63697263756C617220';
wwv_flow_imp.g_varchar2_table(68) := '612E742D42616467654C6973742D777261703A686F766572202E742D42616467654C6973742D76616C7565207B0D0A2020626F782D736861646F773A20302030203020347078202330303736646620696E7365743B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(69) := '636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742D2D6461736820612E742D42616467654C6973742D777261703A666F6375732C0D0A2E742D42616467654C6973742D2D64';
wwv_flow_imp.g_varchar2_table(70) := '617368202E742D42616467654C6973742D777261703A666F6375732D77697468696E2C0D0A2E742D42616467654C6973742D2D63697263756C617220612E742D42616467654C6973742D777261703A666F637573202E742D42616467654C6973742D7661';
wwv_flow_imp.g_varchar2_table(71) := '6C75652C0D0A2E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D76616C756520613A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C203020';
wwv_flow_imp.g_varchar2_table(72) := '30203020327078202332323236323920696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742D2D64617368202E742D4261';
wwv_flow_imp.g_varchar2_table(73) := '6467654C6973742D777261703A666F6375732D77697468696E2C0D0A2E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D76616C756520613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(74) := '20233030373664662021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D42616467654C6973742D2D64617368202E742D42616467654C6973742D76616C756520613A666F637573';
wwv_flow_imp.g_varchar2_table(75) := '2C0D0A2E742D42616467654C6973742D2D6461736820612E742D42616467654C6973742D777261703A666F6375732D77697468696E202E742D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(76) := '2D42616467654C6973742D6974656D3A61667465722C0D0A2E742D42616467654C6973742D6974656D3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A';
wwv_flow_imp.g_varchar2_table(77) := '7D0D0A2E742D42616467654C6973742D2D6461736820612E742D42616467654C6973742D777261703A686F7665723A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E31';
wwv_flow_imp.g_varchar2_table(78) := '293B0D0A7D0D0A2E742D42616467654C6973742E752D636F6C6F72732E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D777261703A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(79) := '3232323632393B0D0A7D0D0A2E742D42616467654C6973742E752D636F6C6F72732E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(80) := '2E742D42616467654C6973742E752D636F6C6F7273202E742D42616467654C6973742D76616C75652061207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4261724368617274202E612D42617243686172742D6974656D207B0D0A';
wwv_flow_imp.g_varchar2_table(81) := '2020626F782D736861646F773A2030202D302E3172656D20302072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E612D4261724368617274202E612D42617243686172742D6974656D3A686F766572207B0D';
wwv_flow_imp.g_varchar2_table(82) := '0A20206261636B67726F756E642D636F6C6F723A20233264333333373B0D0A7D0D0A2E742D426F6479202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C7565207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(83) := '20236166616661663B0D0A7D0D0A2E742D426F64792D7469746C65202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C7565207B0D0A2020636F6C6F723A20236237623762373B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(84) := '2E742D426F64792D696E666F202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C7565207B0D0A2020636F6C6F723A20236237623762373B0D0A7D0D0A2E742D526567696F6E202E612D4261';
wwv_flow_imp.g_varchar2_table(85) := '724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C75652C0D0A2E742D427574746F6E526567696F6E202E612D4261724368617274202E612D42617243686172742D6974656D202E612D4261724368617274';
wwv_flow_imp.g_varchar2_table(86) := '2D76616C7565207B0D0A2020636F6C6F723A20236135613561353B0D0A7D0D0A2E612D4261724368617274202E612D42617243686172742D6974656D20696D67207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E612D426172';
wwv_flow_imp.g_varchar2_table(87) := '4368617274202E612D42617243686172742D626172207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A7D0D0A2E612D42617243686172742D2D636C6173736963202E61';
wwv_flow_imp.g_varchar2_table(88) := '2D42617243686172742D6C6162656C2C0D0A2E612D42617243686172742D2D636C6173736963202E612D42617243686172742D6261724C696E6B2C0D0A2E612D42617243686172742D2D636C6173736963202E612D42617243686172742D76616C756520';
wwv_flow_imp.g_varchar2_table(89) := '7B0D0A2020626F782D736861646F773A2030202D302E3172656D20302072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E612D42617243686172742D2D636C6173736963202E612D42617243686172742D62';
wwv_flow_imp.g_varchar2_table(90) := '61722C0D0A2E612D42617243686172742D2D636C6173736963202E612D42617243686172742D66696C6C6564207B0D0A2020626F726465722D7261646975733A203170783B0D0A7D0D0A2E612D42617243686172742D2D636C6173736963202E612D4261';
wwv_flow_imp.g_varchar2_table(91) := '7243686172742D6974656D3A686F766572202E612D42617243686172742D626172207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E612D42617243686172742D';
wwv_flow_imp.g_varchar2_table(92) := '2D6D6F6465726E202E612D42617243686172742D6261722C0D0A2E612D42617243686172742D2D6D6F6465726E202E612D42617243686172742D66696C6C6564207B0D0A2020626F726465722D7261646975733A203170783B0D0A7D0D0A2E612D426172';
wwv_flow_imp.g_varchar2_table(93) := '43686172742D2D6D6F6465726E202E612D42617243686172742D6974656D3A686F766572202E612D42617243686172742D626172207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035';
wwv_flow_imp.g_varchar2_table(94) := '293B0D0A7D0D0A2E612D42617243686172742D66696C6C6564207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E617065785F776169745F6F7665726C6179207B0D0A20206261636B67726F756E643A207267';
wwv_flow_imp.g_varchar2_table(95) := '626128302C20302C20302C20302E35293B0D0A7D0D0A626F6479207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033353B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E677269642D64656275672D6F';
wwv_flow_imp.g_varchar2_table(96) := '6E202E636F6E7461696E6572207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A61207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(97) := '6F64792D616374696F6E73207B0D0A20206261636B67726F756E642D636F6C6F723A20233265333433393B0D0A2020626F726465722D6C6566743A2031707820736F6C69642072676261283235352C203235352C203235352C20302E303735293B0D0A7D';
wwv_flow_imp.g_varchar2_table(98) := '0D0A2E752D52544C202E742D426F64792D616374696F6E73207B0D0A2020626F726465722D6C6566743A20303B0D0A2020626F726465722D72696768743A2031707820736F6C69642072676261283235352C203235352C203235352C20302E303735293B';
wwv_flow_imp.g_varchar2_table(99) := '0D0A7D0D0A2E742D426F64792D7469746C65207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835302C2035362C2036312C20302E39293B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F726465722D626F74746F6D';
wwv_flow_imp.g_varchar2_table(100) := '3A2031707820736F6C696420233162316532313B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C';
wwv_flow_imp.g_varchar2_table(101) := '2023745F426F64795F636F6E74656E745F6F6666736574207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835302C2035362C2036312C20302E39293B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C20';
wwv_flow_imp.g_varchar2_table(102) := '2E742D426F64792D7469746C652E6861732D736861646F77207B0D0A2020626F782D736861646F773A2030203170782030207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D50616765426F64792D2D6D61737465724465746169';
wwv_flow_imp.g_varchar2_table(103) := '6C202E742D426F64792D7469746C652E6861732D736861646F773A6166746572207B0D0A20206261636B67726F756E642D696D6167653A206C696E6561722D6772616469656E74287267626128302C20302C20302C20302E3035292C207267626128302C';
wwv_flow_imp.g_varchar2_table(104) := '20302C20302C203029293B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C202E617065782D7264732D636F6E7461696E6572207B0D0A2020626F782D736861646F773A2030202D31707820302072676261283235352C203235';
wwv_flow_imp.g_varchar2_table(105) := '352C203235352C20302E312920696E7365743B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C202E617065782D7264732D636F6E7461696E65722E69732D737475636B3A6166746572207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(106) := '2D696D6167653A206C696E6561722D6772616469656E74287267626128302C20302C20302C20302E3035292C207267626128302C20302C20302C203029293B0D0A7D0D0A2E75692D7769646765742D636F6E74656E74207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(107) := '6E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E742D426F6479202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20236566656665663B0D0A7D0D0A2E742D426F64792D7469746C65202E75692D7769646765742D';
wwv_flow_imp.g_varchar2_table(108) := '636F6E74656E74207B0D0A2020636F6C6F723A20236637663766373B0D0A7D0D0A2E742D426F64792D696E666F202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20236637663766373B0D0A7D0D0A2E742D526567696F6E20';
wwv_flow_imp.g_varchar2_table(109) := '2E75692D7769646765742D636F6E74656E742C0D0A2E742D427574746F6E526567696F6E202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20236535653565353B0D0A7D0D0A2E742D426F64792D73696465207B0D0A202062';
wwv_flow_imp.g_varchar2_table(110) := '61636B67726F756E642D636F6C6F723A20233336336434333B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E742D42';
wwv_flow_imp.g_varchar2_table(111) := '6F64792D73696465207B0D0A20202020626F782D736861646F773A20317078203020302072676261283235352C203235352C203235352C20302E31293B0D0A20207D0D0A20202E752D52544C202E742D426F64792D73696465207B0D0A20202020626F78';
wwv_flow_imp.g_varchar2_table(112) := '2D736861646F773A202D317078203020302072676261283235352C203235352C203235352C20302E31293B0D0A20207D0D0A7D0D0A2E617065782D7264732D636F6E7461696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E';
wwv_flow_imp.g_varchar2_table(113) := '73706172656E743B0D0A7D0D0A2E742D426F64792D696E666F202E617065782D7264732D636F6E7461696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233332333833643B0D0A7D0D0A2E742D426F64792D696E666F202E61706578';
wwv_flow_imp.g_varchar2_table(114) := '2D7264732D636F6E7461696E65722E69732D737475636B207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835302C2035362C2036312C20302E3935293B0D0A20206261636B64726F702D66696C7465723A20626C75722834707829';
wwv_flow_imp.g_varchar2_table(115) := '3B0D0A7D0D0A2E742D426F64792D696E666F207B0D0A20206261636B67726F756E642D636F6C6F723A20233332333833643B0D0A7D0D0A2E742D426F64792D7469746C652E6A732D6869646542726561646372756D6273207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(116) := '756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A7D0D0A2E742D426F64792D746F70427574746F6E207B0D0A2020626F726465722D7261646975733A20313030253B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(117) := '636F6C6F723A20233432346135313B0D0A2020636F6C6F723A20233539363336643B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D426F64792D746F';
wwv_flow_imp.g_varchar2_table(118) := '70427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C20302031707820327078207267626128302C20302C20302C20302E3135293B0D0A7D0D0A2E742D426F64792D74';
wwv_flow_imp.g_varchar2_table(119) := '6F70427574746F6E3A686F7665722C0D0A2E742D426F64792D746F70427574746F6E3A666F637573207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D426F64792D746F70427574746F6E3A686F7665722C0D0A2E742D426F64792D';
wwv_flow_imp.g_varchar2_table(120) := '746F70427574746F6E3A616374697665207B0D0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31352920696E7365743B0D0A7D0D0A2E742D426F64792D746F70427574746F6E3A61637469766520';
wwv_flow_imp.g_varchar2_table(121) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233464353735663B0D0A2020636F6C6F723A20233634373037623B0D0A7D0D0A2E742D4865616465722D6272616E64696E67207B0D0A20206865696768743A20343870783B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(122) := '4865616465722D6C6F676F2D6C696E6B20696D67207B0D0A20206D61782D6865696768743A20343070783B0D0A7D0D0A2E742D426F64792D636F6E74656E74207B0D0A20206D696E2D6865696768743A2063616C63283130307668202D20203438707829';
wwv_flow_imp.g_varchar2_table(123) := '3B0D0A7D0D0A2E617065782D736964652D6E6176202E742D426F64792D6E61762C0D0A2E617065782D736964652D6E6176202E742D426F64792D616374696F6E732C0D0A2E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A';
wwv_flow_imp.g_varchar2_table(124) := '2020746F703A20343870783B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D';
wwv_flow_imp.g_varchar2_table(125) := '7469746C65207B0D0A202020206C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A2020202072696768743A2032343070783B0D0A20207D0D0A20203A';
wwv_flow_imp.g_varchar2_table(126) := '6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D7469746C';
wwv_flow_imp.g_varchar2_table(127) := '65207B0D0A202020206C6566743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61';
wwv_flow_imp.g_varchar2_table(128) := '76202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D636F6E74656E74207B0D0A202020206D61';
wwv_flow_imp.g_varchar2_table(129) := '7267696E2D72696768743A2032343070783B0D0A20207D0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D6D61696E207B0D0A20206D617267696E2D6C6566743A20303B0D0A7D0D0A2E752D52544C';
wwv_flow_imp.g_varchar2_table(130) := '202E617065782D736964652D6E6176202E742D426F64792D6D61696E207B0D0A20206D617267696E2D72696768743A20303B0D0A7D0D0A2E617065782D746F702D6E6176202E742D426F64792D616374696F6E73207B0D0A2020746F703A20383870783B';
wwv_flow_imp.g_varchar2_table(131) := '0D0A7D0D0A2E617065782D746F702D6E6176202E742D426F64792D7469746C65207B0D0A2020746F703A20383870783B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A2020';
wwv_flow_imp.g_varchar2_table(132) := '2E617065782D746F702D6E61762E6A732D6D656E754E6176436F6C6C6170736564202E742D4865616465722D6E6176207B0D0A202020207472616E73666F726D3A207472616E736C61746559282D31303025293B0D0A20207D0D0A7D0D0A2E742D426F64';
wwv_flow_imp.g_varchar2_table(133) := '792D6E6176207B0D0A202077696474683A2032343070783B0D0A7D0D0A2E742D426F64792D616374696F6E73207B0D0A202077696474683A2032303070783B0D0A7D0D0A3A6E6F74282E752D52544C29202E742D426F64792D616374696F6E73202E742D';
wwv_flow_imp.g_varchar2_table(134) := '427574746F6E2D2D686561646572207B0D0A20207472616E73666F726D3A207472616E736C6174653364282D343070782C20302C2030293B0D0A7D0D0A2E752D52544C202E742D426F64792D616374696F6E73202E742D427574746F6E2D2D6865616465';
wwv_flow_imp.g_varchar2_table(135) := '72207B0D0A20207472616E73666F726D3A207472616E736C617465336428343070782C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E742D426F64';
wwv_flow_imp.g_varchar2_table(136) := '792D73696465207B0D0A2020202077696474683A2032343070783B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E6170';
wwv_flow_imp.g_varchar2_table(137) := '65782D736964652D6E6176202E742D426F64792D73696465207B0D0A202020206C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D73696465207B0D0A2020202072696768743A';
wwv_flow_imp.g_varchar2_table(138) := '20343870783B0D0A20207D0D0A7D0D0A2E6E6F2D616E696D202E742D426F64792D6E61762C0D0A2E6E6F2D616E696D202E742D547265654E6176207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F72';
wwv_flow_imp.g_varchar2_table(139) := '74616E743B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64';
wwv_flow_imp.g_varchar2_table(140) := '792D6D61696E207B0D0A20206D617267696E2D6C6566743A20343870783B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D726967';
wwv_flow_imp.g_varchar2_table(141) := '68743A20343870783B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20207472616E73666F726D3A207472616E736C6174653364283139';
wwv_flow_imp.g_varchar2_table(142) := '3270782C20302C2030293B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20207472616E73666F726D3A207472616E736C6174653364282D3139327078';
wwv_flow_imp.g_varchar2_table(143) := '2C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20343830707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E64';
wwv_flow_imp.g_varchar2_table(144) := '6564202E742D426F64792D7469746C652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E617065782D';
wwv_flow_imp.g_varchar2_table(145) := '736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E617645';
wwv_flow_imp.g_varchar2_table(146) := '7870616E646564202E742D426F64792D7469746C652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D736964652C0D0A20202E752D52544C202E617065782D736964652D6E61';
wwv_flow_imp.g_varchar2_table(147) := '762E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E617645';
wwv_flow_imp.g_varchar2_table(148) := '7870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D6169';
wwv_flow_imp.g_varchar2_table(149) := '6E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20202020747261';
wwv_flow_imp.g_varchar2_table(150) := '6E73666F726D3A207472616E736C61746533642832343070782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A2020202074';
wwv_flow_imp.g_varchar2_table(151) := '72616E73666F726D3A207472616E736C6174653364282D32343070782C20302C2030293B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E617065782D73';
wwv_flow_imp.g_varchar2_table(152) := '6964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C652C0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F';
wwv_flow_imp.g_varchar2_table(153) := '64792D2D686964654C656674202E742D426F64792D636F6E74656E742C0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A';
wwv_flow_imp.g_varchar2_table(154) := '202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F6479';
wwv_flow_imp.g_varchar2_table(155) := '2D7469746C65207B0D0A202020206C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F6479';
wwv_flow_imp.g_varchar2_table(156) := '2D7469746C65207B0D0A2020202072696768743A2032343070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C65667420';
wwv_flow_imp.g_varchar2_table(157) := '2E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D';
wwv_flow_imp.g_varchar2_table(158) := '426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E';
wwv_flow_imp.g_varchar2_table(159) := '742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2031393270783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D68';
wwv_flow_imp.g_varchar2_table(160) := '6964654C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2031393270783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E64';
wwv_flow_imp.g_varchar2_table(161) := '65642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E617645';
wwv_flow_imp.g_varchar2_table(162) := '7870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20343870783B0D0A20207D0D0A20202E617065782D736964652D6E61762E6A732D6E61764578';
wwv_flow_imp.g_varchar2_table(163) := '70616E646564202E742D426F64792D73696465207B0D0A202020207472616E73666F726D3A207472616E736C61746533642832343070782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176';
wwv_flow_imp.g_varchar2_table(164) := '457870616E646564202E742D426F64792D73696465207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D32343070782C20302C2030293B0D0A20207D0D0A20202E617065782D736964652D6E61762E6A732D6E617645787061';
wwv_flow_imp.g_varchar2_table(165) := '6E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A';
wwv_flow_imp.g_varchar2_table(166) := '732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176';
wwv_flow_imp.g_varchar2_table(167) := '2E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E61706578';
wwv_flow_imp.g_varchar2_table(168) := '2D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D73696465';
wwv_flow_imp.g_varchar2_table(169) := '2D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D7369';
wwv_flow_imp.g_varchar2_table(170) := '64652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032383870783B0D0A20207D0D0A20202E752D52544C';
wwv_flow_imp.g_varchar2_table(171) := '202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032383870783B0D0A20207D';
wwv_flow_imp.g_varchar2_table(172) := '0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D';
wwv_flow_imp.g_varchar2_table(173) := '3A207472616E736C61746533642831393270782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64';
wwv_flow_imp.g_varchar2_table(174) := '792D636F6E74656E74207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D31393270782C20302C2030293B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870';
wwv_flow_imp.g_varchar2_table(175) := '616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465';
wwv_flow_imp.g_varchar2_table(176) := '642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E617645787061';
wwv_flow_imp.g_varchar2_table(177) := '6E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020207472616E73666F726D3A207472616E736C61746533642832343070782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E';
wwv_flow_imp.g_varchar2_table(178) := '617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D3234307078';
wwv_flow_imp.g_varchar2_table(179) := '2C20302C2030293B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20393933707829207B0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D506167';
wwv_flow_imp.g_varchar2_table(180) := '65426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E';
wwv_flow_imp.g_varchar2_table(181) := '6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870';
wwv_flow_imp.g_varchar2_table(182) := '616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465';
wwv_flow_imp.g_varchar2_table(183) := '642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020207472616E73666F726D3A206E6F6E652021696D706F7274616E743B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D73';
wwv_flow_imp.g_varchar2_table(184) := '6964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C20';
wwv_flow_imp.g_varchar2_table(185) := '2E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A20';
wwv_flow_imp.g_varchar2_table(186) := '203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A';
wwv_flow_imp.g_varchar2_table(187) := '2034383070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D6172';
wwv_flow_imp.g_varchar2_table(188) := '67696E2D72696768743A2034383070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F';
wwv_flow_imp.g_varchar2_table(189) := '6E74656E742C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D';
wwv_flow_imp.g_varchar2_table(190) := '3A206E6F6E653B0D0A20207D0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E61762C0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F6479';
wwv_flow_imp.g_varchar2_table(191) := '2D6E6176202E742D547265654E6176207B0D0A202077696474683A20343870783B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D636F6E74656E742C0D0A';
wwv_flow_imp.g_varchar2_table(192) := '3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652C0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170';
wwv_flow_imp.g_varchar2_table(193) := '736564202E742D426F64792D73696465207B0D0A20206D617267696E2D6C6566743A20343870783B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D636F6E74656E742C0D';
wwv_flow_imp.g_varchar2_table(194) := '0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652C0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F6479';
wwv_flow_imp.g_varchar2_table(195) := '2D73696465207B0D0A20206D617267696E2D72696768743A20343870783B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652E69732D73747563';
wwv_flow_imp.g_varchar2_table(196) := '6B207B0D0A20206C6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652E69732D737475636B207B0D0A202072696768743A20303B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(197) := '406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20343830707829207B0D0A20202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176207B0D0A20202020747261';
wwv_flow_imp.g_varchar2_table(198) := '6E73666F726D3A207472616E736C61746558282D34387078293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176207B0D0A202020207472616E73666F72';
wwv_flow_imp.g_varchar2_table(199) := '6D3A207472616E736C617465582834387078293B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652C0D0A20203A6E6F74282E752D52';
wwv_flow_imp.g_varchar2_table(200) := '544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D42';
wwv_flow_imp.g_varchar2_table(201) := '6F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652C0D0A20202E';
wwv_flow_imp.g_varchar2_table(202) := '752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D736964652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D';
wwv_flow_imp.g_varchar2_table(203) := '636F6E74656E74207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20203A6E6F74282E752D52544C29';
wwv_flow_imp.g_varchar2_table(204) := '202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D';
wwv_flow_imp.g_varchar2_table(205) := '0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D726967';
wwv_flow_imp.g_varchar2_table(206) := '68743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C';
wwv_flow_imp.g_varchar2_table(207) := '6C6170736564202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469';
wwv_flow_imp.g_varchar2_table(208) := '746C65207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A202020';
wwv_flow_imp.g_varchar2_table(209) := '206C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A2020202072696768743A20343870783B0D0A20207D0D0A20';
wwv_flow_imp.g_varchar2_table(210) := '203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A2030';
wwv_flow_imp.g_varchar2_table(211) := '3B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D72696768';
wwv_flow_imp.g_varchar2_table(212) := '743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A2020';
wwv_flow_imp.g_varchar2_table(213) := '20206D617267696E2D6C6566743A2032383870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E';
wwv_flow_imp.g_varchar2_table(214) := '74656E74207B0D0A202020206D617267696E2D72696768743A2032383870783B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20393933707829207B0D0A20203A6E6F74282E752D52544C';
wwv_flow_imp.g_varchar2_table(215) := '29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D73696465207B0D0A202020206C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E61';
wwv_flow_imp.g_varchar2_table(216) := '76436F6C6C6170736564202E742D426F64792D73696465207B0D0A2020202072696768743A20343870783B0D0A20207D0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E6A732D6E6176436F';
wwv_flow_imp.g_varchar2_table(217) := '6C6C6170736564202E742D426F64792D6E6176207B0D0A202077696474683A20303B0D0A20207669736962696C6974793A2068696464656E3B0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E';
wwv_flow_imp.g_varchar2_table(218) := '2E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176202E612D54726565566965772D6261646765207B0D0A20207669736962696C6974793A2068696464656E2021696D706F7274616E743B0D0A7D0D0A2E617065782D736964652D6E61';
wwv_flow_imp.g_varchar2_table(219) := '762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E61762C0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E6176202E742D547265654E61';
wwv_flow_imp.g_varchar2_table(220) := '76207B0D0A202077696474683A2032343070783B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D636F6E74656E742C0D0A3A6E6F7428';
wwv_flow_imp.g_varchar2_table(221) := '2E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652C0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C';
wwv_flow_imp.g_varchar2_table(222) := '6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A20206D617267696E2D6C6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E';
wwv_flow_imp.g_varchar2_table(223) := '742D426F64792D636F6E74656E742C0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652C0D0A2E752D52544C202E617065782D736964652D6E6176';
wwv_flow_imp.g_varchar2_table(224) := '2E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A20206D617267696E2D72696768743A20303B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F';
wwv_flow_imp.g_varchar2_table(225) := '6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652E69732D737475636B207B0D0A20206C6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464';
wwv_flow_imp.g_varchar2_table(226) := '656E202E742D426F64792D7469746C652E69732D737475636B207B0D0A202072696768743A20303B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20343830707829207B0D0A20202E617065782D7369';
wwv_flow_imp.g_varchar2_table(227) := '64652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E6176207B0D0A202020207472616E73666F726D3A207472616E736C617465582830293B0D0A20207D0D0A20202E752D52544C202E617065782D736964';
wwv_flow_imp.g_varchar2_table(228) := '652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E6176207B0D0A202020207472616E73666F726D3A207472616E736C617465582830293B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065';
wwv_flow_imp.g_varchar2_table(229) := '782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D6869';
wwv_flow_imp.g_varchar2_table(230) := '6464656E202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D636F6E74656E74207B0D0A202020206D6172';
wwv_flow_imp.g_varchar2_table(231) := '67696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652C0D0A20202E752D52544C202E617065782D7369';
wwv_flow_imp.g_varchar2_table(232) := '64652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D736964652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64';
wwv_flow_imp.g_varchar2_table(233) := '792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20203A6E6F74282E752D5254';
wwv_flow_imp.g_varchar2_table(234) := '4C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566';
wwv_flow_imp.g_varchar2_table(235) := '743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E';
wwv_flow_imp.g_varchar2_table(236) := '207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D';
wwv_flow_imp.g_varchar2_table(237) := '736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E';
wwv_flow_imp.g_varchar2_table(238) := '6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A73';
wwv_flow_imp.g_varchar2_table(239) := '2D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68';
wwv_flow_imp.g_varchar2_table(240) := '696464656E202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50';
wwv_flow_imp.g_varchar2_table(241) := '616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E';
wwv_flow_imp.g_varchar2_table(242) := '2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170';
wwv_flow_imp.g_varchar2_table(243) := '7365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964';
wwv_flow_imp.g_varchar2_table(244) := '652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D';
wwv_flow_imp.g_varchar2_table(245) := '0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20393933707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464';
wwv_flow_imp.g_varchar2_table(246) := '656E202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F6479';
wwv_flow_imp.g_varchar2_table(247) := '2D73696465207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7369';
wwv_flow_imp.g_varchar2_table(248) := '6465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A2020202072696768743A20';
wwv_flow_imp.g_varchar2_table(249) := '303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A';
wwv_flow_imp.g_varchar2_table(250) := '202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465';
wwv_flow_imp.g_varchar2_table(251) := '207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E';
wwv_flow_imp.g_varchar2_table(252) := '742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D5061';
wwv_flow_imp.g_varchar2_table(253) := '6765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D';
wwv_flow_imp.g_varchar2_table(254) := '6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C6566742E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2034383070783B0D';
wwv_flow_imp.g_varchar2_table(255) := '0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C6566742E6A732D6E6176457870616E646564202E742D426F64792D636F';
wwv_flow_imp.g_varchar2_table(256) := '6E74656E74207B0D0A202020206D617267696E2D72696768743A2034383070783B0D0A20207D0D0A7D0D0A2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D726967';
wwv_flow_imp.g_varchar2_table(257) := '68743A20303B0D0A7D0D0A3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E2C0D0A3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D72696768';
wwv_flow_imp.g_varchar2_table(258) := '74457870616E646564202E742D426F64792D6E6176207B0D0A20207472616E73666F726D3A207472616E736C6174653364282D32303070782C20302C2030293B0D0A7D0D0A2E752D52544C202E742D50616765426F64792E6A732D726967687445787061';
wwv_flow_imp.g_varchar2_table(259) := '6E646564202E742D426F64792D6D61696E2C0D0A2E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6E6176207B0D0A20207472616E73666F726D3A207472616E736C61746533642832303070';
wwv_flow_imp.g_varchar2_table(260) := '782C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F6479';
wwv_flow_imp.g_varchar2_table(261) := '2D2D686964654C656674202E742D426F64792D6D61696E2C0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6E6176207B0D0A20202020747261';
wwv_flow_imp.g_varchar2_table(262) := '6E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D';
wwv_flow_imp.g_varchar2_table(263) := '0A202020206D617267696E2D72696768743A2032303070783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D';
wwv_flow_imp.g_varchar2_table(264) := '61696E207B0D0A202020206D617267696E2D6C6566743A2032303070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C6566';
wwv_flow_imp.g_varchar2_table(265) := '74202E742D426F64792D7469746C65207B0D0A2020202072696768743A2032303070783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C6566';
wwv_flow_imp.g_varchar2_table(266) := '74202E742D426F64792D7469746C65207B0D0A202020206C6566743A2032303070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D7368';
wwv_flow_imp.g_varchar2_table(267) := '6F774C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C65';
wwv_flow_imp.g_varchar2_table(268) := '6674202E742D426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E74';
wwv_flow_imp.g_varchar2_table(269) := '2D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E';
wwv_flow_imp.g_varchar2_table(270) := '6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D5061';
wwv_flow_imp.g_varchar2_table(271) := '6765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E75';
wwv_flow_imp.g_varchar2_table(272) := '2D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A2020202072696768743A20303B';
wwv_flow_imp.g_varchar2_table(273) := '0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20393933707829207B0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E74';
wwv_flow_imp.g_varchar2_table(274) := '2D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A2032303070783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D726967687445787061';
wwv_flow_imp.g_varchar2_table(275) := '6E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A2032303070783B0D0A20207D0D0A20202E742D50616765426F64792E6A732D7269676874457870616E64';
wwv_flow_imp.g_varchar2_table(276) := '65642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E2C0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6E';
wwv_flow_imp.g_varchar2_table(277) := '6176207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E74';
wwv_flow_imp.g_varchar2_table(278) := '2D426F64792D7469746C65207B0D0A2020202072696768743A2032303070783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E74';
wwv_flow_imp.g_varchar2_table(279) := '2D426F64792D7469746C65207B0D0A202020206C6566743A2032303070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D';
wwv_flow_imp.g_varchar2_table(280) := '50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E61';
wwv_flow_imp.g_varchar2_table(281) := '76436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A2020202072696768743A20343870783B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61';
wwv_flow_imp.g_varchar2_table(282) := '782D77696474683A20393932707829207B0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D';
wwv_flow_imp.g_varchar2_table(283) := '3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C652C0D0A20203A6E6F';
wwv_flow_imp.g_varchar2_table(284) := '74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64';
wwv_flow_imp.g_varchar2_table(285) := '792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D32303070782C20302C2030293B';
wwv_flow_imp.g_varchar2_table(286) := '0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C652C0D0A20202E752D52544C202E742D50616765426F';
wwv_flow_imp.g_varchar2_table(287) := '64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D736964652C0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765';
wwv_flow_imp.g_varchar2_table(288) := '426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D3A207472616E736C61746533642832303070782C20302C2030293B0D0A20207D0D0A20202E742D50616765426F64792E6A732D7269';
wwv_flow_imp.g_varchar2_table(289) := '676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20343870782021696D706F7274616E743B0D0A20207D0D0A20202E752D52544C202E74';
wwv_flow_imp.g_varchar2_table(290) := '2D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20302021696D706F7274616E743B0D0A20202020';
wwv_flow_imp.g_varchar2_table(291) := '72696768743A20343870782021696D706F7274616E743B0D0A20207D0D0A7D0D0A2E742D50616765426F64792E6A732D7269676874436F6C6C6170736564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D72696768743A203070783B0D';
wwv_flow_imp.g_varchar2_table(292) := '0A7D0D0A2E742D50616765426F64792E6A732D7269676874436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A202072696768743A203070783B0D0A7D0D0A3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D726967';
wwv_flow_imp.g_varchar2_table(293) := '6874436F6C6C6170736564202E742D426F64792D616374696F6E73207B0D0A20207472616E73666F726D3A207472616E736C61746533642832303070782C20302C2030293B0D0A7D0D0A2E752D52544C202E742D50616765426F64792E6A732D72696768';
wwv_flow_imp.g_varchar2_table(294) := '74436F6C6C6170736564202E742D426F64792D616374696F6E73207B0D0A20207472616E73666F726D3A207472616E736C6174653364282D32303070782C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D69';
wwv_flow_imp.g_varchar2_table(295) := '6E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A';
wwv_flow_imp.g_varchar2_table(296) := '20207D0D0A20202E752D52544C202E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A7D0D0A2E742D426F64792D636F6E';
wwv_flow_imp.g_varchar2_table(297) := '74656E74496E6E6572207B0D0A20206D617267696E3A2030206175746F3B0D0A20206D61782D77696474683A20313030253B0D0A7D0D0A23745F426F64795F736B6970546F436F6E74656E74207B0D0A2020636F6C6F723A20233030373664663B0D0A20';
wwv_flow_imp.g_varchar2_table(298) := '206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D6567614D656E752D2D66756C6C57696474683A6E6F74282E6A732D6D656E752D63616C6C6F757429207B0D0A202070616464696E672D746F703A203870783B0D';
wwv_flow_imp.g_varchar2_table(299) := '0A7D0D0A2E742D4D6567614D656E752D2D6C61796F757432436F6C73202E742D4D6567614D656E752D6974656D2D2D746F702C0D0A2E742D4D6567614D656E752D2D6C61796F757433436F6C73202E742D4D6567614D656E752D6974656D2D2D746F702C';
wwv_flow_imp.g_varchar2_table(300) := '0D0A2E742D4D6567614D656E752D2D6C61796F757434436F6C73202E742D4D6567614D656E752D6974656D2D2D746F702C0D0A2E742D4D6567614D656E752D2D6C61796F757435436F6C73202E742D4D6567614D656E752D6974656D2D2D746F70207B0D';
wwv_flow_imp.g_varchar2_table(301) := '0A20206D61782D77696474683A2032343070783B0D0A7D0D0A2E742D42726561646372756D622D6974656D3A6166746572207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E742D42726561';
wwv_flow_imp.g_varchar2_table(302) := '646372756D622D6974656D2C0D0A2E742D42726561646372756D622D6974656D2061207B0D0A2020636F6C6F723A20236436643664363B0D0A7D0D0A2E742D42726561646372756D622D6974656D20613A686F7665722C0D0A2E742D4272656164637275';
wwv_flow_imp.g_varchar2_table(303) := '6D622D6974656D20613A666F637573207B0D0A2020636F6C6F723A20233431613566663B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A2E742D426F64792D7469';
wwv_flow_imp.g_varchar2_table(304) := '746C652D736872696E6B202E742D42726561646372756D62526567696F6E2D2D75736542726561646372756D625469746C65202E742D42726561646372756D622D6974656D2E69732D6163746976652C0D0A2E742D426F64792D7469746C652D73687269';
wwv_flow_imp.g_varchar2_table(305) := '6E6B202E742D42726561646372756D62526567696F6E2D2D757365526567696F6E5469746C65202E742D42726561646372756D62526567696F6E2D7469746C6554657874207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A406D65646961';
wwv_flow_imp.g_varchar2_table(306) := '206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20202E742D42726561646372756D62526567696F6E2D2D757365526567696F6E5469746C65202E742D42726561646372756D62526567696F6E2D746974';
wwv_flow_imp.g_varchar2_table(307) := '6C6554657874207B0D0A20202020636F6C6F723A20236666666666663B0D0A20207D0D0A7D0D0A2E742D42726561646372756D622D6974656D202E742D49636F6E3A686F766572207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(308) := '42726561646372756D62526567696F6E2D2D75736542726561646372756D625469746C65202E742D42726561646372756D622D6974656D2E69732D6163746976652C0D0A2E742D42726561646372756D62526567696F6E2D7469746C6554657874207B0D';
wwv_flow_imp.g_varchar2_table(309) := '0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D7469746C65202E742D42726561646372756D622D6974656D3A6166746572207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B';
wwv_flow_imp.g_varchar2_table(310) := '0D0A7D0D0A2E742D426F64792D7469746C65202E742D42726561646372756D622D6974656D2C0D0A2E742D426F64792D7469746C65202E742D42726561646372756D622D6974656D20612C0D0A2E742D426F64792D7469746C65202E742D427265616463';
wwv_flow_imp.g_varchar2_table(311) := '72756D62526567696F6E2D2D75736542726561646372756D625469746C65202E742D42726561646372756D622D6974656D2E69732D6163746976652C0D0A2E742D426F64792D7469746C65202E742D42726561646372756D62526567696F6E2D7469746C';
wwv_flow_imp.g_varchar2_table(312) := '6554657874207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2C0D0A2E612D427574746F6E2C0D0A2E75692D627574746F6E207B0D0A2020626F726465723A206E6F6E653B0D0A2020746578742D736861646F773A';
wwv_flow_imp.g_varchar2_table(313) := '206E6F6E653B0D0A2020626F726465722D7261646975733A203270783B0D0A20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E327320656173652C20626F782D736861646F7720302E327320656173652C20636F6C6F72';
wwv_flow_imp.g_varchar2_table(314) := '20302E327320656173653B0D0A7D0D0A2E742D427574746F6E202E742D49636F6E2C0D0A2E612D427574746F6E202E742D49636F6E2C0D0A2E75692D627574746F6E202E742D49636F6E207B0D0A20207472616E736974696F6E3A20696E68657269743B';
wwv_flow_imp.g_varchar2_table(315) := '0D0A7D0D0A2E742D427574746F6E3A686F7665722C0D0A2E612D427574746F6E3A686F7665722C0D0A2E75692D627574746F6E3A686F7665722C0D0A2E742D427574746F6E3A666F6375732C0D0A2E612D427574746F6E3A666F6375732C0D0A2E75692D';
wwv_flow_imp.g_varchar2_table(316) := '627574746F6E3A666F637573207B0D0A20207A2D696E6465783A203130303B0D0A20206F75746C696E653A206E6F6E652021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E3A666F6375733A6265666F72652C0D0A2E612D427574746F6E3A';
wwv_flow_imp.g_varchar2_table(317) := '666F6375733A6265666F72652C0D0A2E75692D627574746F6E3A666F6375733A6265666F72652C0D0A2E742D427574746F6E2E69732D6163746976653A666F6375733A6265666F72652C0D0A2E612D427574746F6E2E69732D6163746976653A666F6375';
wwv_flow_imp.g_varchar2_table(318) := '733A6265666F72652C0D0A2E75692D627574746F6E2E69732D6163746976653A666F6375733A6265666F7265207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742021696D706F7274616E743B0D0A20';
wwv_flow_imp.g_varchar2_table(319) := '206F7061636974793A20313B0D0A7D0D0A2E742D427574746F6E3A666F6375733A6163746976653A6265666F72652C0D0A2E612D427574746F6E3A666F6375733A6163746976653A6265666F72652C0D0A2E75692D627574746F6E3A666F6375733A6163';
wwv_flow_imp.g_varchar2_table(320) := '746976653A6265666F72652C0D0A2E742D427574746F6E2E69732D6163746976653A666F6375733A6163746976653A6265666F72652C0D0A2E612D427574746F6E2E69732D6163746976653A666F6375733A6163746976653A6265666F72652C0D0A2E75';
wwv_flow_imp.g_varchar2_table(321) := '692D627574746F6E2E69732D6163746976653A666F6375733A6163746976653A6265666F7265207B0D0A20206F7061636974793A20303B0D0A7D0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D6C696E6B293A6E6F74282E742D4275';
wwv_flow_imp.g_varchar2_table(322) := '74746F6E2D2D686561646572293A6163746976652C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D6C696E6B293A6E6F74282E742D427574746F6E2D2D686561646572292E69732D616374697665207B0D0A2020626F782D73686164';
wwv_flow_imp.g_varchar2_table(323) := '6F773A203020302030203170782072676261283235352C203235352C203235352C20302E31352920696E7365742C20302032707820327078207267626128302C20302C20302C20302E31352920696E7365742021696D706F7274616E743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(324) := '612D427574746F6E3A6265666F72652C0D0A2E742D427574746F6E3A6265666F72652C0D0A2E75692D627574746F6E3A6265666F72652C0D0A2E612D427574746F6E3A61667465722C0D0A2E742D427574746F6E3A61667465722C0D0A2E75692D627574';
wwv_flow_imp.g_varchar2_table(325) := '746F6E3A6166746572207B0D0A2020636F6E74656E743A2027273B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A20303B0D0A20206C6566743A20303B0D0A202077696474683A20313030253B0D0A20206865696768743A';
wwv_flow_imp.g_varchar2_table(326) := '20313030253B0D0A2020626F726465722D7261646975733A20696E68657269743B0D0A20206F7061636974793A20303B0D0A20207472616E736974696F6E3A20302E327320656173653B0D0A7D0D0A2E612D427574746F6E3A6265666F72652C0D0A2E74';
wwv_flow_imp.g_varchar2_table(327) := '2D427574746F6E3A6265666F72652C0D0A2E75692D627574746F6E3A6265666F7265207B0D0A20207A2D696E6465783A20313B0D0A7D0D0A2E612D427574746F6E3A61667465722C0D0A2E742D427574746F6E3A61667465722C0D0A2E75692D62757474';
wwv_flow_imp.g_varchar2_table(328) := '6F6E3A6166746572207B0D0A20207A2D696E6465783A202D313B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20302E303735293B0D0A20207472616E73666F726D3A207472616E736C61746559282D';
wwv_flow_imp.g_varchar2_table(329) := '327078293B0D0A7D0D0A2E612D427574746F6E3A666F6375733A61667465722C0D0A2E742D427574746F6E3A666F6375733A61667465722C0D0A2E75692D627574746F6E3A666F6375733A61667465722C0D0A2E612D427574746F6E3A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(330) := '427574746F6E2D2D6C696E6B293A686F7665723A61667465722C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D6C696E6B293A686F7665723A61667465722C0D0A2E75692D627574746F6E3A6E6F74282E742D427574746F6E2D2D6C';
wwv_flow_imp.g_varchar2_table(331) := '696E6B293A686F7665723A6166746572207B0D0A20206F7061636974793A20313B0D0A20207472616E73666F726D3A207472616E736C617465592830293B0D0A7D0D0A2E612D427574746F6E3A666F6375733A6163746976653A61667465722C0D0A2E74';
wwv_flow_imp.g_varchar2_table(332) := '2D427574746F6E3A666F6375733A6163746976653A61667465722C0D0A2E75692D627574746F6E3A666F6375733A6163746976653A6166746572207B0D0A20206F7061636974793A20303B0D0A20207472616E73666F726D3A207472616E736C61746559';
wwv_flow_imp.g_varchar2_table(333) := '282D327078293B0D0A7D0D0A2E612D427574746F6E3A666F6375733A61667465722C0D0A2E742D427574746F6E3A666F6375733A61667465722C0D0A2E75692D627574746F6E3A666F6375733A6166746572207B0D0A20207472616E73666F726D3A2074';
wwv_flow_imp.g_varchar2_table(334) := '72616E736C617465592830293B0D0A2020626F782D736861646F773A203020302031707820317078207267626128302C203131382C203232332C20302E3235293B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F42';
wwv_flow_imp.g_varchar2_table(335) := '7574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C2C0D0A2E742D427574746F6E3A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(336) := '427574746F6E2D2D73696D706C65292C0D0A2E75692D627574746F6E2C0D0A2E612D427574746F6E2C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F562C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(337) := '636F6E74726F6C73207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233463346535303B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C20';
wwv_flow_imp.g_varchar2_table(338) := '3235352C20302E3132352920696E7365743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A68';
wwv_flow_imp.g_varchar2_table(339) := '6F7665722C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C3A686F7665722C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D73696D706C65293A686F7665722C0D0A2E75692D627574746F6E3A';
wwv_flow_imp.g_varchar2_table(340) := '686F7665722C0D0A2E612D427574746F6E3A686F7665722C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F563A686F7665722C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C733A686F';
wwv_flow_imp.g_varchar2_table(341) := '766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233635363836613B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E31352920696E7365743B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(342) := '2D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A666F6375732C0D0A2E617065782D627574746F6E2D67726F7570';
wwv_flow_imp.g_varchar2_table(343) := '20696E707574202B206C6162656C3A666F6375732C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D73696D706C65293A666F6375732C0D0A2E75692D627574746F6E3A666F6375732C0D0A2E612D427574746F6E3A666F6375732C0D';
wwv_flow_imp.g_varchar2_table(344) := '0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F563A666F6375732C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C733A666F637573207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(345) := '3A20233732373537373B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C2E69732D616374697665';
wwv_flow_imp.g_varchar2_table(346) := '2C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C2E69732D6163746976652C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D73696D706C65292E69732D6163746976652C0D0A2E75692D627574';
wwv_flow_imp.g_varchar2_table(347) := '746F6E2E69732D6163746976652C0D0A2E612D427574746F6E2E69732D6163746976652C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F562E69732D6163746976652C0D0A2E612D49472D627574746F6E2E612D49472D627574';
wwv_flow_imp.g_varchar2_table(348) := '746F6E2D2D636F6E74726F6C732E69732D6163746976652C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C616265';
wwv_flow_imp.g_varchar2_table(349) := '6C3A6163746976652C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C3A6163746976652C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D73696D706C65293A6163746976652C0D0A2E75692D62';
wwv_flow_imp.g_varchar2_table(350) := '7574746F6E3A6163746976652C0D0A2E612D427574746F6E3A6163746976652C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F563A6163746976652C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F';
wwv_flow_imp.g_varchar2_table(351) := '6E74726F6C733A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233334333533363B0D0A7D0D0A2E75692D627574746F6E3A686F766572207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D466F726D2D';
wwv_flow_imp.g_varchar2_table(352) := '6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964207B0D0A20206261636B67726F756E642D636F6C6F723A20233264326533303B0D0A2020626F726465722D7261646975733A2032';
wwv_flow_imp.g_varchar2_table(353) := '70783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A616374697665202B206C6162656C2C0D0A2E742D466F726D';
wwv_flow_imp.g_varchar2_table(354) := '2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A666F6375733A6E6F74283A636865636B656429202B206C6162656C2C0D0A2E617065782D627574';
wwv_flow_imp.g_varchar2_table(355) := '746F6E2D67726F757020696E7075743A616374697665202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A666F6375733A6E6F74283A636865636B656429202B206C6162656C207B0D0A2020626F782D736861646F';
wwv_flow_imp.g_varchar2_table(356) := '773A20302030203020317078202330303736646620696E7365742C20302030203020327078202332383263333020696E7365742021696D706F7274616E743B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F726465722D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(357) := '3030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A636865636B65643A666F637573202B206C616265';
wwv_flow_imp.g_varchar2_table(358) := '6C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B65643A666F637573202B206C6162656C207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C2030203020302032';
wwv_flow_imp.g_varchar2_table(359) := '7078202332383263333020696E7365742021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574';
wwv_flow_imp.g_varchar2_table(360) := '3A636865636B6564202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B6564202B206C6162656C207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(361) := '642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D427574746F6E2D2D686F742C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E74';
wwv_flow_imp.g_varchar2_table(362) := '2D427574746F6E2D2D73696D706C65292C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F742C0D0A626F6479202E75692D73746174652D64656661756C742E75692D7072696F726974792D7072696D617279207B0D0A2020';
wwv_flow_imp.g_varchar2_table(363) := '6261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D427574746F6E2D2D686F743A686F7665722C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D427574746F';
wwv_flow_imp.g_varchar2_table(364) := '6E2D2D73696D706C65293A686F7665722C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F743A686F7665722C0D0A626F6479202E75692D73746174652D64656661756C742E75692D7072696F726974792D7072696D617279';
wwv_flow_imp.g_varchar2_table(365) := '3A686F7665722C0D0A2E612D427574746F6E2D2D686F743A6E6F74283A616374697665293A666F6375732C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74283A616374697665293A666F6375';
wwv_flow_imp.g_varchar2_table(366) := '732C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F743A6E6F74283A616374697665293A666F6375732C0D0A626F6479202E75692D73746174652D64656661756C742E75692D7072696F726974792D7072696D6172793A6E';
wwv_flow_imp.g_varchar2_table(367) := '6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233030383366393B0D0A7D0D0A2E612D427574746F6E2D2D686F743A6163746976652C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(368) := '427574746F6E2D2D73696D706C65293A6163746976652C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F743A6163746976652C0D0A626F6479202E75692D73746174652D64656661756C742E75692D7072696F726974792D';
wwv_flow_imp.g_varchar2_table(369) := '7072696D6172793A6163746976652C0D0A2E612D427574746F6E2D2D686F742E69732D6163746976652C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D427574746F6E2D2D73696D706C65292E69732D6163746976652C0D0A626F6479202E';
wwv_flow_imp.g_varchar2_table(370) := '75692D627574746F6E2E75692D627574746F6E2D2D686F742E69732D6163746976652C0D0A626F6479202E75692D73746174652D64656661756C742E75692D7072696F726974792D7072696D6172792E69732D616374697665207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(371) := '726F756E642D636F6C6F723A20233030363963363B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F74207B0D0A2020666F6E742D7765696768743A20626F6C643B0D0A7D0D0A2E742D427574746F6E2D2D7761726E';
wwv_flow_imp.g_varchar2_table(372) := '696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D4275';
wwv_flow_imp.g_varchar2_table(373) := '74746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D68';
wwv_flow_imp.g_varchar2_table(374) := '6F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236663646337633B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C6529';
wwv_flow_imp.g_varchar2_table(375) := '3A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574';
wwv_flow_imp.g_varchar2_table(376) := '746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A7D';
wwv_flow_imp.g_varchar2_table(377) := '0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(378) := '737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C6529';
wwv_flow_imp.g_varchar2_table(379) := '3A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233432626533313B0D0A7D0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E';
wwv_flow_imp.g_varchar2_table(380) := '742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74';
wwv_flow_imp.g_varchar2_table(381) := '293A6163746976652C0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(382) := '6F6C6F723A20233342414132433B0D0A7D0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020636F6C6F723A20236666666666663B';
wwv_flow_imp.g_varchar2_table(383) := '0D0A7D0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D42';
wwv_flow_imp.g_varchar2_table(384) := '7574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236635356134653B0D0A7D0D0A2E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(385) := '2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E74';
wwv_flow_imp.g_varchar2_table(386) := '2D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A202062';
wwv_flow_imp.g_varchar2_table(387) := '61636B67726F756E642D636F6C6F723A20236634343333363B0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(388) := '6F723A20233030313832643B0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D7072';
wwv_flow_imp.g_varchar2_table(389) := '696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236336653466663B0D';
wwv_flow_imp.g_varchar2_table(390) := '0A7D0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(391) := '2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429';
wwv_flow_imp.g_varchar2_table(392) := '2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236163643866663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(393) := '64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E6729207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(394) := '723A20234646464646463B0D0A2020636F6C6F723A20233430343034303B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E3132352920696E7365743B0D0A7D0D0A2E742D427574';
wwv_flow_imp.g_varchar2_table(395) := '746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D737563636573';
wwv_flow_imp.g_varchar2_table(396) := '73293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F7428';
wwv_flow_imp.g_varchar2_table(397) := '2E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E74';
wwv_flow_imp.g_varchar2_table(398) := '2D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(399) := '7761726E696E67292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F74207B0D0A2020626F782D73686164';
wwv_flow_imp.g_varchar2_table(400) := '6F773A20302030203020317078202330303736646620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F742C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(401) := '427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F74202E742D49636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A686F7665722C';
wwv_flow_imp.g_varchar2_table(402) := '0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F742E69732D616374697665207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(403) := '636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D7369';
wwv_flow_imp.g_varchar2_table(404) := '6D706C652E742D427574746F6E2D2D686F743A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F742E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20236666';
wwv_flow_imp.g_varchar2_table(405) := '666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020626F782D736861646F773A203020302030203170782023616364386666';
wwv_flow_imp.g_varchar2_table(406) := '20696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74292C0D0A';
wwv_flow_imp.g_varchar2_table(407) := '2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A2020636F6C6F723A20233264396366663B0D0A7D0D0A2E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(408) := '73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D42757474';
wwv_flow_imp.g_varchar2_table(409) := '6F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(410) := '6F6C6F723A20236163643866663B0D0A2020636F6C6F723A20233030313832643B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74293A686F76657220';
wwv_flow_imp.g_varchar2_table(411) := '2E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74293A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E';
wwv_flow_imp.g_varchar2_table(412) := '742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20233030313832643B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E74';
wwv_flow_imp.g_varchar2_table(413) := '2D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020626F782D736861646F773A20302030203020317078202346424345344120696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(414) := '234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D77';
wwv_flow_imp.g_varchar2_table(415) := '61726E696E673A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A2020636F6C6F723A20236331393130343B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F7428';
wwv_flow_imp.g_varchar2_table(416) := '2E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73';
wwv_flow_imp.g_varchar2_table(417) := '696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A2023343433';
wwv_flow_imp.g_varchar2_table(418) := '3330323B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74293A686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E74';
wwv_flow_imp.g_varchar2_table(419) := '2D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74293A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D42757474';
wwv_flow_imp.g_varchar2_table(420) := '6F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(421) := '2D2D686F7429207B0D0A2020626F782D736861646F773A20302030203020317078202366343433333620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C65';
wwv_flow_imp.g_varchar2_table(422) := '2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F7429202E742D4963';
wwv_flow_imp.g_varchar2_table(423) := '6F6E207B0D0A2020636F6C6F723A20236634343333363B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(424) := '2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D42757474';
wwv_flow_imp.g_varchar2_table(425) := '6F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(426) := '2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A';
wwv_flow_imp.g_varchar2_table(427) := '666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(428) := '20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020626F782D736861646F773A2030203020302031707820233342';
wwv_flow_imp.g_varchar2_table(429) := '4141324320696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74';
wwv_flow_imp.g_varchar2_table(430) := '292C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A2020636F6C6F723A20233362616132633B0D0A7D0D0A2E742D42757474';
wwv_flow_imp.g_varchar2_table(431) := '6F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(432) := '427574746F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(433) := '6E642D636F6C6F723A20233342414132433B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74293A686F';
wwv_flow_imp.g_varchar2_table(434) := '766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74293A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D';
wwv_flow_imp.g_varchar2_table(435) := '706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D6E6F5549';
wwv_flow_imp.g_varchar2_table(436) := '207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55493A6E6F74283A686F766572293A6E6F74283A666F637573293A6E6F74282E69732D';
wwv_flow_imp.g_varchar2_table(437) := '61637469766529207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55493A686F7665722C0D0A2E742D427574746F6E2D2D6E6F55493A666F6375732C0D0A2E742D427574746F6E2D2D6E6F55492E69';
wwv_flow_imp.g_varchar2_table(438) := '732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55493A666F6375733A686F766572207B0D0A2020626F782D736861646F773A2030203020302031707820';
wwv_flow_imp.g_varchar2_table(439) := '72676261283235352C203235352C203235352C20302E3132352920696E7365743B0D0A7D0D0A2E742D427574746F6E2D2D6C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(440) := '0D0A2020626F782D736861646F773A206E6F6E652021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6C696E6B3A686F766572207B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A7D0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(441) := '7574746F6E2D2D6C696E6B2E742D427574746F6E2C0D0A2E742D427574746F6E2D2D6C696E6B202E742D49636F6E207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D686F';
wwv_flow_imp.g_varchar2_table(442) := '742C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D686F74202E742D49636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D7072696D617279';
wwv_flow_imp.g_varchar2_table(443) := '2C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D7072696D6172792C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D7072696D617279202E742D49636F6E2C0D0A2E742D427574746F6E2D2D6C696E6B2E74';
wwv_flow_imp.g_varchar2_table(444) := '2D427574746F6E2D2D7072696D617279202E742D49636F6E207B0D0A2020636F6C6F723A20233264396366662021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D7761726E696E672C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(445) := '427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D7761726E696E672C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D7761726E696E67202E742D49636F6E2C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F';
wwv_flow_imp.g_varchar2_table(446) := '6E2D2D7761726E696E67202E742D49636F6E207B0D0A2020636F6C6F723A20236331393130342021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D64616E6765722C0D0A2E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(447) := '2D6C696E6B2E742D427574746F6E2D2D64616E6765722C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D64616E676572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D64616E676572';
wwv_flow_imp.g_varchar2_table(448) := '202E742D49636F6E207B0D0A2020636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D737563636573732C0D0A2E742D427574746F6E2D2D6C696E6B2E742D42';
wwv_flow_imp.g_varchar2_table(449) := '7574746F6E2D2D737563636573732C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D73756363657373202E742D49636F6E2C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D73756363657373202E742D4963';
wwv_flow_imp.g_varchar2_table(450) := '6F6E207B0D0A2020636F6C6F723A20233362616132632021696D706F7274616E743B0D0A7D0D0A2E742D4865616465722D6272616E64696E67202E742D427574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E7370617265';
wwv_flow_imp.g_varchar2_table(451) := '6E743B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D686561646572207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E2E742D427574';
wwv_flow_imp.g_varchar2_table(452) := '746F6E2D2D6865616465723A666F6375733A6265666F72652C0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A6163746976653A666F6375733A6265666F7265207B0D0A2020626F782D736861646F773A20302030203020317078';
wwv_flow_imp.g_varchar2_table(453) := '202332643963666620696E7365742021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A686F7665722C0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A666F6375732C0D';
wwv_flow_imp.g_varchar2_table(454) := '0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465';
wwv_flow_imp.g_varchar2_table(455) := '723A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A6163746976652C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(456) := '427574746F6E2E742D427574746F6E2D2D6865616465723A666F6375733A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E34293B0D0A7D0D0A2E742D427574746F6E2E';
wwv_flow_imp.g_varchar2_table(457) := '742D427574746F6E2D2D6865616465722E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3235293B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D';
wwv_flow_imp.g_varchar2_table(458) := '0D0A2E742D427574746F6E2E742D427574746F6E2D2D686561646572547265653A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202332643963666620696E7365743B0D0A7D0D0A406D65646961206F6E6C7920736372';
wwv_flow_imp.g_varchar2_table(459) := '65656E20616E6420286D61782D77696474683A20343830707829207B0D0A20202E742D427574746F6E2E742D427574746F6E2D2D68656164657254726565207B0D0A202020206261636B67726F756E642D636F6C6F723A2072676261283235352C203235';
wwv_flow_imp.g_varchar2_table(460) := '352C203235352C20302E3235293B0D0A20207D0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465725269676874207B0D0A20206261636B67726F756E642D636F6C6F723A20233265333433393B0D0A2020626F726465723A2031';
wwv_flow_imp.g_varchar2_table(461) := '707820736F6C696420233435346535353B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D68656164657252696768743A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233435346535353B0D0A7D0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(462) := '7574746F6E2E742D427574746F6E2D2D68656164657252696768743A6163746976652C0D0A2E742D427574746F6E2E742D427574746F6E2D2D68656164657252696768742E69732D616374697665207B0D0A2020636F6C6F723A20236666666666663B0D';
wwv_flow_imp.g_varchar2_table(463) := '0A7D0D0A2E742D427574746F6E2D2D6E6176426172202E742D427574746F6E2D6261646765207B0D0A2020626F726465722D7261646975733A20313670783B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C20';
wwv_flow_imp.g_varchar2_table(464) := '3235352C20302E3335293B0D0A7D0D0A2E742D427574746F6E2D2D68656C70427574746F6E202E612D49636F6E207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E742D4865616465722D6E6176426172202E742D427574746F6E2D2D686561';
wwv_flow_imp.g_varchar2_table(465) := '6465722E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233030346539333B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6E6F5549202E66613A6166';
wwv_flow_imp.g_varchar2_table(466) := '7465722C0D0A2E742D427574746F6E2E742D427574746F6E2D2D6C696E6B202E66613A61667465722C0D0A2E742D427574746F6E2E742D427574746F6E2D2D73696D706C65202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(467) := '723A20234646463B0D0A7D0D0A2E742D427574746F6E2D2D64616E676572202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A686F766572202E66613A6166746572207B0D0A202062';
wwv_flow_imp.g_varchar2_table(468) := '61636B67726F756E642D636F6C6F723A20236634343333363B0D0A7D0D0A2E742D427574746F6E2D2D73756363657373202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A686F76';
wwv_flow_imp.g_varchar2_table(469) := '6572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A7D0D0A2E742D427574746F6E2D2D7072696D617279202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D';
wwv_flow_imp.g_varchar2_table(470) := '427574746F6E2D2D7072696D6172793A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20236163643866663B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E67202E66613A61667465722C0D0A2E';
wwv_flow_imp.g_varchar2_table(471) := '742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A7D0D0A2E742D427574746F6E2D2D686F';
wwv_flow_imp.g_varchar2_table(472) := '74202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(473) := '2D426F64792D616374696F6E73546F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A20233265333433393B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E303735293B0D0A2020';
wwv_flow_imp.g_varchar2_table(474) := '626F726465722D72696768742D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20696E697469616C3B0D0A7D0D0A2E752D52544C202E742D426F64792D616374696F6E73546F67676C65207B0D0A2020626F726465722D636F6C';
wwv_flow_imp.g_varchar2_table(475) := '6F723A2072676261283235352C203235352C203235352C20302E303735293B0D0A2020626F726465722D6C6566742D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D616374696F6E73546F67676C653A61637469766520';
wwv_flow_imp.g_varchar2_table(476) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233435346535353B0D0A7D0D0A2E742D426F64792D616374696F6E73546F67676C653A666F6375732C0D0A2E742D426F64792D616374696F6E73546F67676C653A616374697665207B0D0A2020';
wwv_flow_imp.g_varchar2_table(477) := '626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D427574746F6E526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236665666566653B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(478) := '6465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E303735293B0D0A2020626F782D736861646F773A20302032707820327078207267626128302C20302C20302C';
wwv_flow_imp.g_varchar2_table(479) := '20302E3035293B0D0A7D0D0A2E742D427574746F6E526567696F6E2D2D6E6F5549207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D4275';
wwv_flow_imp.g_varchar2_table(480) := '74746F6E526567696F6E2D2D77697A6172642C0D0A2E742D427574746F6E526567696F6E2D2D6469616C6F67526567696F6E207B0D0A2020626F726465722D7261646975733A2030203020327078203270783B0D0A7D0D0A2E742D427574746F6E526567';
wwv_flow_imp.g_varchar2_table(481) := '696F6E2D2D6469616C6F67526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F6479202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D42757474';
wwv_flow_imp.g_varchar2_table(482) := '6F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20236566656665663B0D0A7D0D0A2E742D426F64792D7469746C65202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D746974';
wwv_flow_imp.g_varchar2_table(483) := '6C65207B0D0A2020636F6C6F723A20236637663766373B0D0A7D0D0A2E742D426F64792D696E666F202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(484) := '3A20236637663766373B0D0A7D0D0A2E742D526567696F6E202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C652C0D0A2E742D427574746F6E526567696F6E202E742D427574746F';
wwv_flow_imp.g_varchar2_table(485) := '6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20236535653565353B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D427574746F6E526567696F6E207B0D';
wwv_flow_imp.g_varchar2_table(486) := '0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F726465722D7261646975733A20303B0D0A7D0D0A2E742D4469616C6F672D666F6F746572202E742D427574746F6E526567696F6E207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(487) := '6465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E66632E75692D776964676574207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(488) := '722D7261646975733A203270783B0D0A7D0D0A2E66632D746F6F6C626172207B0D0A2020626F726465722D636F6C6F723A20233334336134303B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020626F726465722D72';
wwv_flow_imp.g_varchar2_table(489) := '61646975733A2032707820327078203020303B0D0A7D0D0A2E66632D746F6F6C6261722068322C0D0A2E6663202E66632D62617369632D766965772074642E66632D6461792D6E756D6265722C0D0A2E6663202E66632D6461792D6E756D626572207B0D';
wwv_flow_imp.g_varchar2_table(490) := '0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E66632D6461792D6865616465722E75692D7769646765742D6865616465722C0D0A2E66632D76696577202E75692D7769646765742D686561646572207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(491) := '636F6C6F723A20233234323832633B0D0A2020636F6C6F723A20236634663466343B0D0A2020626F726465722D636F6C6F723A20233330333533613B0D0A7D0D0A6469762E66632D6167656E64614C697374207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(492) := '6F6C6F723A20233232323632393B0D0A2020626F726465722D636F6C6F723A20233334336134303B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D646179486561646572207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(493) := '636B67726F756E642D636F6C6F723A20233362343234383B0D0A2020636F6C6F723A20236634663466343B0D0A2020626F726465722D636F6C6F723A20233236326232663B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D646179207B0D0A';
wwv_flow_imp.g_varchar2_table(494) := '2020636F6C6F723A20236634663466343B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D64617465207B0D0A2020636F6C6F723A20236365636563653B0D0A7D0D0A2E6663202E66632D6167656E64614C697374202E66632D6576656E742D';
wwv_flow_imp.g_varchar2_table(495) := '73746172742D74696D652C0D0A2E6663202E66632D6167656E64614C697374202E66632D6576656E742D616C6C2D646179207B0D0A2020636F6C6F723A20236438643864383B0D0A7D0D0A626F6479202E66632074642E66632D746F6461792C0D0A626F';
wwv_flow_imp.g_varchar2_table(496) := '6479202E6663202E75692D7769646765742D636F6E74656E74207B0D0A2020626F726465722D636F6C6F723A20233339336634353B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A626F6479202E75692D7769646765742D636F6E74656E74';
wwv_flow_imp.g_varchar2_table(497) := '2E66632D746F6461792E75692D73746174652D686967686C69676874207B0D0A20206261636B67726F756E642D636F6C6F723A20233264333333373B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D6974656D207B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(498) := '2D636F6C6F723A20233236326232663B0D0A7D0D0A2E6663202E75692D627574746F6E3A6163746976652C0D0A2E6663202E75692D627574746F6E3A666F6375732C0D0A2E66632D766965773A6163746976652C0D0A2E66632D766965773A666F637573';
wwv_flow_imp.g_varchar2_table(499) := '207B0D0A20206F75746C696E653A2031707820736F6C696420233030373664663B0D0A7D0D0A2E66632D766965772D636F6E7461696E6572203E202E66632D766965773A6163746976652C0D0A2E66632D766965772D636F6E7461696E6572203E202E66';
wwv_flow_imp.g_varchar2_table(500) := '632D766965773A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A2E742D43617264207B0D0A2020626F782D736861646F773A20302032707820347078202D327078207267626128302C20302C20302C20302E303735293B0D0A';
wwv_flow_imp.g_varchar2_table(501) := '7D0D0A2E742D436172642D77726170207B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235';
wwv_flow_imp.g_varchar2_table(502) := '352C203235352C20302E303735293B0D0A7D0D0A2E742D436172642D777261703A666F637573207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D436172642D69636F6E207B0D0A2020636F6C6F723A2023323232';
wwv_flow_imp.g_varchar2_table(503) := '3632393B0D0A7D0D0A2E742D436172642D64657363207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D436172642D696E666F2C0D0A2E742D436172642D7375627469746C65207B0D0A2020636F6C6F723A20236266626662663B0D';
wwv_flow_imp.g_varchar2_table(504) := '0A7D0D0A2E742D436172642D7469746C65207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D436172642D636F6C6F7246696C6C2C0D0A2E742D436172642D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(505) := '3030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D43617264732D2D6665617475726564202E742D436172642D626F6479207B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C';
wwv_flow_imp.g_varchar2_table(506) := '203235352C20302E303735293B0D0A7D0D0A2E742D43617264732D2D6261736963202E742D436172642D7469746C6557726170207B0D0A2020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E';
wwv_flow_imp.g_varchar2_table(507) := '30352920696E7365743B0D0A7D0D0A2E742D43617264732D2D636F6D70616374202E742D436172642D7469746C6557726170207B0D0A2020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E30';
wwv_flow_imp.g_varchar2_table(508) := '352920696E7365743B0D0A7D0D0A2E742D43617264732D2D6665617475726564202E742D436172642D626F6479207B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E303735293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(509) := '0A2E742D43617264732D2D626C6F636B202E742D49636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A2020746578742D736861646F773A2030203170782031707820';
wwv_flow_imp.g_varchar2_table(510) := '7267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D43617264732D2D616E696D526169736543617264202E742D436172643A686F766572207B0D0A2020626F782D736861646F773A2030203130707820347078202D347078207267626128';
wwv_flow_imp.g_varchar2_table(511) := '302C20302C20302C20302E3035293B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572207B0D0A20206D617267696E2D746F703A20333270783B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572';
wwv_flow_imp.g_varchar2_table(512) := '202E742D43617264207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D43617264732D6974656D207B0D0A2020646973706C61793A20626C6F636B3B0D0A20';
wwv_flow_imp.g_varchar2_table(513) := '20666C65782D67726F773A20313B0D0A202077696474683A203235253B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20343830707829207B0D0A20202E742D43617264732D2D73616D706C65417070';
wwv_flow_imp.g_varchar2_table(514) := '73466F6F746572202E742D43617264732D6974656D207B0D0A2020202077696474683A203530253B0D0A20207D0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D436172642D777261702C0D0A2E742D4361726473';
wwv_flow_imp.g_varchar2_table(515) := '2D2D73616D706C6541707073466F6F746572202E742D436172642D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(516) := '0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D436172642D69636F6E207B0D0A20207472616E736974696F6E3A20302E327320656173653B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572';
wwv_flow_imp.g_varchar2_table(517) := '202E742D49636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233030303030303B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E312920696E7365743B0D0A7D';
wwv_flow_imp.g_varchar2_table(518) := '0D0A2E742D436C617373696343616C656E6461722D6D6F6E74685469746C65207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D436C617373696343616C656E6461722D646179436F6C756D6E207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(519) := '642D636F6C6F723A20233236326232663B0D0A2020766572746963616C2D616C69676E3A20746F703B0D0A2020626F726465722D636F6C6F723A20233264333333373B0D0A2020636F6C6F723A20236438643864383B0D0A7D0D0A2E742D436C61737369';
wwv_flow_imp.g_varchar2_table(520) := '6343616C656E6461722D646179207B0D0A2020626F726465722D636F6C6F723A20233264333333373B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6461792E69732D696E616374697665202E742D436C617373696343616C656E6461722D';
wwv_flow_imp.g_varchar2_table(521) := '64617465207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6461792E69732D7765656B656E642C0D0A2E742D436C617373696343616C656E6461722D6461792E69732D696E616374697665207B';
wwv_flow_imp.g_varchar2_table(522) := '0D0A20206261636B67726F756E642D636F6C6F723A20233234323832633B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6461792E69732D746F646179202E742D436C617373696343616C656E6461722D64617465207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(523) := '67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D64617465207B0D0A2020636F6C6F723A20236266626662663B0D0A7D0D0A2E742D436C';
wwv_flow_imp.g_varchar2_table(524) := '617373696343616C656E6461722D6576656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20233264333333373B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6576656E74207B0D0A2020636F6C6F723A2023666566656665';
wwv_flow_imp.g_varchar2_table(525) := '3B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6576656E742061207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436C61737369634361';
wwv_flow_imp.g_varchar2_table(526) := '6C656E6461722D2D7765656B6C79202E742D436C617373696343616C656E6461722D74696D65436F6C2C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E6461722D74696D65436F6C207B0D0A';
wwv_flow_imp.g_varchar2_table(527) := '20206261636B67726F756E642D636F6C6F723A20233236326232663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D2D7765656B6C79202E742D436C617373696343616C656E6461722D6461794576656E74732C0D0A2E742D436C61737369';
wwv_flow_imp.g_varchar2_table(528) := '6343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E6461722D6461794576656E7473207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D436C617373696343616C656E6461722D2D7765656B6C79202E74';
wwv_flow_imp.g_varchar2_table(529) := '2D436C617373696343616C656E6461722D6461794576656E747320612C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E6461722D6461794576656E74732061207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(530) := '756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D2D7765656B6C79202E742D436C617373696343616C656E6461722D6461792E69732D746F6461';
wwv_flow_imp.g_varchar2_table(531) := '792C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E6461722D6461792E69732D746F646179207B0D0A20206261636B67726F756E642D636F6C6F723A20236466663066663B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(532) := '2D436C617373696343616C656E6461722D6C697374207B0D0A2020626F726465722D636F6C6F723A20233264333333373B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6C6973745469746C652C0D0A2E742D436C617373696343616C656E';
wwv_flow_imp.g_varchar2_table(533) := '6461722D6C6973744576656E74207B0D0A2020626F726465722D636F6C6F723A20233264333333373B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6C6973745469746C65207B0D0A20206261636B67726F756E642D636F6C6F723A202332';
wwv_flow_imp.g_varchar2_table(534) := '36326232663B0D0A2020636F6C6F723A20236438643864383B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6C6973744576656E74207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D436F6D6D656E74732D2D636861';
wwv_flow_imp.g_varchar2_table(535) := '74202E742D436F6D6D656E74732D636F6D6D656E74207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A2020636F6C6F723A20236666663B0D0A7D0D0A2E742D436F6D6D65';
wwv_flow_imp.g_varchar2_table(536) := '6E74732D2D63686174202E742D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C2030293B0D0A2020626F726465722D72696768742D636F6C6F72';
wwv_flow_imp.g_varchar2_table(537) := '3A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E752D52544C202E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F726465722D72696768';
wwv_flow_imp.g_varchar2_table(538) := '742D636F6C6F723A2072676261283235352C203235352C203235352C2030293B0D0A2020626F726465722D6C6566742D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D436F6D6D656E74732D2D63';
wwv_flow_imp.g_varchar2_table(539) := '686174202E742D436F6D6D656E74732D6974656D2E69732D616374697665202E742D436F6D6D656E74732D636F6D6D656E74207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D';
wwv_flow_imp.g_varchar2_table(540) := '0A2020636F6C6F723A20236666663B0D0A7D0D0A2E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D6974656D2E69732D616374697665202E742D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(541) := '65722D72696768742D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E752D52544C202E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D6974656D2E69732D616374697665202E74';
wwv_flow_imp.g_varchar2_table(542) := '2D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F726465722D72696768742D636F6C6F723A2072676261283235352C203235352C203235352C2030293B0D0A2020626F726465722D6C6566742D636F6C6F723A207267626128';
wwv_flow_imp.g_varchar2_table(543) := '3235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D436F6D6D656E74732D2D6261736963202E742D436F6D6D656E74732D6974656D2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233235326132';
wwv_flow_imp.g_varchar2_table(544) := '653B0D0A7D0D0A2E742D436F6D6D656E74732D6974656D2E69732D73797374656D4D657373616765207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283234322C203234322C203234322C20302E3035293B0D0A7D0D0A2E742D436F';
wwv_flow_imp.g_varchar2_table(545) := '6D6D656E74732D696E666F207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3635293B0D0A7D0D0A2E742D436F6D6D656E74732D636F6D6D656E74207B0D0A2020636F6C6F723A20236666663B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(546) := '436F6D706C6574656E657373207B0D0A20206261636B67726F756E642D636F6C6F723A20233030303030303B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E312920696E736574';
wwv_flow_imp.g_varchar2_table(547) := '3B0D0A7D0D0A612E742D436F6D706C6574656E6573733A686F766572202E742D436F6D706C6574656E6573732D6C6162656C57726170207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E';
wwv_flow_imp.g_varchar2_table(548) := '3235293B0D0A7D0D0A612E742D436F6D706C6574656E6573733A686F766572202E742D436F6D706C6574656E6573732D6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20233030303030303B0D0A7D0D0A2E742D436F6D706C6574';
wwv_flow_imp.g_varchar2_table(549) := '656E6573732D66696C6C207B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E31352920696E7365743B0D0A7D0D0A2E742D436F6D706C6574656E6573732D6C6162656C207B0D0A';
wwv_flow_imp.g_varchar2_table(550) := '20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E742D436F6E66696750616E656C207B0D0A';
wwv_flow_imp.g_varchar2_table(551) := '2020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E312920696E7365743B0D0A7D0D0A2E742D436F6E66696750616E656C2D61626F7574207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(552) := '723A20236666663765303B0D0A2020636F6C6F723A20233536353635363B0D0A2020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E312920696E7365743B0D0A7D0D0A2E742D436F6E666967';
wwv_flow_imp.g_varchar2_table(553) := '50616E656C2D6D61696E207B0D0A2020626F782D736861646F773A202D317078203020302072676261283235352C203235352C203235352C20302E312920696E7365743B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D6178';
wwv_flow_imp.g_varchar2_table(554) := '2D77696474683A20363430707829207B0D0A20202E742D436F6E66696750616E656C2D6D61696E207B0D0A20202020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E312920696E7365743B0D';
wwv_flow_imp.g_varchar2_table(555) := '0A20207D0D0A7D0D0A2E742D436F6E66696750616E656C2D69636F6E207B0D0A2020626F726465722D7261646975733A20313030253B0D0A20206261636B67726F756E642D636F6C6F723A20234130413041303B0D0A2020636F6C6F723A20234646463B';
wwv_flow_imp.g_varchar2_table(556) := '0D0A7D0D0A2E742D436F6E66696750616E656C2D69636F6E2E69732D656E61626C6564207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A7D0D0A2E742D436F6E66696750616E656C2D69636F6E2E69732D6469736162';
wwv_flow_imp.g_varchar2_table(557) := '6C6564207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A7D0D0A2E742D436F6E66696750616E656C2D73657474696E672C0D0A2E742D436F6E66696750616E656C2D737461747573207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(558) := '6232623262323B0D0A7D0D0A2E742D436F6E66696750616E656C2D737461747573207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D436F6E66696750616E656C2D617474724C696E6B207B0D0A2020636F6C6F723A202362326232';
wwv_flow_imp.g_varchar2_table(559) := '62323B0D0A2020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E742D436F6E66696750616E656C2D617474724C696E6B3A686F766572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(560) := '6261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A2020626F782D736861646F773A20302031707820302072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(561) := '742D436F6E66696750616E656C2D6174747256616C7565207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E742D436F6E74656E74426C6F636B2D2D736861646F774247202E742D436F6E74656E74426C6F636B2D626F6479207B0D0A20';
wwv_flow_imp.g_varchar2_table(562) := '206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D436F6E74';
wwv_flow_imp.g_varchar2_table(563) := '656E74426C6F636B2D2D6C696768744247202E742D436F6E74656E74426C6F636B2D626F6479207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D436F6E74656E74526F';
wwv_flow_imp.g_varchar2_table(564) := '772D6974656D207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E303735293B0D0A7D0D0A2E742D436F6E74656E74526F772D69636F6E577261702C0D0A2E742D436F6E74656E74';
wwv_flow_imp.g_varchar2_table(565) := '526F772D6465736372697074696F6E2C0D0A2E742D436F6E74656E74526F772D6D697363207B0D0A2020636F6C6F723A20236232623262323B0D0A7D0D0A2E742D4469616C6F67207B0D0A20206261636B67726F756E642D636F6C6F723A202332323236';
wwv_flow_imp.g_varchar2_table(566) := '32393B0D0A7D0D0A2E742D4469616C6F67203A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A20206261636B67726F756E642D636F6C6F723A20233562363636663B0D0A7D0D0A2E742D4469616C6F67203A3A2D7765626B69742D';
wwv_flow_imp.g_varchar2_table(567) := '7363726F6C6C6261722D7468756D623A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233637373337643B0D0A7D0D0A2E742D4469616C6F673A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(568) := '636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E742D4469616C6F67526567696F6E2D627574746F6E73207B0D0A2020626F782D736861646F773A20696E73657420302031707820302072676261283235352C203235352C2032';
wwv_flow_imp.g_varchar2_table(569) := '35352C20302E3035293B0D0A7D0D0A2E612D46532D636F6E74726F6C202B202E612D46532D636F6E74726F6C207B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E61';
wwv_flow_imp.g_varchar2_table(570) := '2D46532D746F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E32293B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F726465722D7261646975733A20327078';
wwv_flow_imp.g_varchar2_table(571) := '3B0D0A7D0D0A2E612D46532D746F67676C653A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3235293B0D0A7D0D0A2E612D46532D746F67676C653A666F637573207B0D';
wwv_flow_imp.g_varchar2_table(572) := '0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F782D736861646F773A203020317078203170782030207267626128302C203131382C203232332C20302E3835293B0D0A7D0D0A2E612D46532D636C656172427574';
wwv_flow_imp.g_varchar2_table(573) := '746F6E2C0D0A2E612D46532D746F67676C654F766572666C6F77207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E612D46532D7365617263682073';
wwv_flow_imp.g_varchar2_table(574) := '70616E2E617065782D6974656D2D69636F6E2C0D0A2E612D46532D66696C746572207370616E2E617065782D6974656D2D69636F6E207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3635293B0D0A7D0D0A2E612D';
wwv_flow_imp.g_varchar2_table(575) := '46532D736561726368207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D466F6F746572207B0D0A2020626F726465722D746F703A2031707820736F6C';
wwv_flow_imp.g_varchar2_table(576) := '69642072676261283235352C203235352C203235352C20302E3035293B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A7D0D0A2E742D466F6F7465722D746F7042757474';
wwv_flow_imp.g_varchar2_table(577) := '6F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236363636363633B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C2030';
wwv_flow_imp.g_varchar2_table(578) := '2E312920696E7365743B0D0A7D0D0A2E742D466F6F7465722D746F70427574746F6E3A686F766572207B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E312920696E7365742C20';
wwv_flow_imp.g_varchar2_table(579) := '302032707820347078207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D466F6F7465722D746F70427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365';
wwv_flow_imp.g_varchar2_table(580) := '743B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E65723A6265666F7265207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D4952522D7365617263682D6669656C642C0D0A2E612D4947202E612D546F6F6C626172';
wwv_flow_imp.g_varchar2_table(581) := '2D696E707574546578742C0D0A2E612D4952522D73656C6563744C697374207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A2020626F726465722D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(582) := '3365343634633B0D0A7D0D0A2E612D4947202E612D546F6F6C6261722D696E70757454657874207B0D0A2020626F782D736861646F773A20302030203020317078202333653436346320696E7365743B0D0A7D0D0A2E617065782D6974656D2D74657874';
wwv_flow_imp.g_varchar2_table(583) := '617265612C0D0A2E617065782D6974656D2D746578742C0D0A2E617065782D6974656D2D73656C6563742C0D0A2E617065782D6974656D2D6D756C74692C0D0A73656C6563742E6C6973746D616E616765722C0D0A2E75692D646174657069636B65722D';
wwv_flow_imp.g_varchar2_table(584) := '6D6F6E74682C0D0A2E75692D646174657069636B65722D79656172207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A2020626F726465722D636F6C6F723A2023336534';
wwv_flow_imp.g_varchar2_table(585) := '3634633B0D0A7D0D0A2E617065782D6974656D2D74657874617265612E617065782D706167652D6974656D2D6572726F722C0D0A2E617065782D6974656D2D746578742E617065782D706167652D6974656D2D6572726F722C0D0A2E617065782D697465';
wwv_flow_imp.g_varchar2_table(586) := '6D2D73656C6563742E617065782D706167652D6974656D2D6572726F722C0D0A2E617065782D6974656D2D6D756C74692E617065782D706167652D6974656D2D6572726F722C0D0A73656C6563742E6C6973746D616E616765722E617065782D70616765';
wwv_flow_imp.g_varchar2_table(587) := '2D6974656D2D6572726F722C0D0A2E75692D646174657069636B65722D6D6F6E74682E617065782D706167652D6974656D2D6572726F722C0D0A2E75692D646174657069636B65722D796561722E617065782D706167652D6974656D2D6572726F72207B';
wwv_flow_imp.g_varchar2_table(588) := '0D0A2020626F726465722D636F6C6F723A20236637373036363B0D0A7D0D0A2E617065782D6974656D2D74657874617265612E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E617065782D6974656D2D';
wwv_flow_imp.g_varchar2_table(589) := '746578742E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E617065782D6974656D2D73656C6563742E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E';
wwv_flow_imp.g_varchar2_table(590) := '617065782D6974656D2D6D756C74692E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A73656C6563742E6C6973746D616E616765722E617065782D706167652D6974656D2D6572726F723A726571756972';
wwv_flow_imp.g_varchar2_table(591) := '65643A76616C69642C0D0A2E75692D646174657069636B65722D6D6F6E74682E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E75692D646174657069636B65722D796561722E617065782D706167652D';
wwv_flow_imp.g_varchar2_table(592) := '6974656D2D6572726F723A72657175697265643A76616C6964207B0D0A2020626F726465722D636F6C6F723A20233365343634633B0D0A7D0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E657220696E7075742C0D0A';
wwv_flow_imp.g_varchar2_table(593) := '2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722073656C6563742C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E6572207465787461726561207B0D0A2020636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(594) := '66666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A2020626F726465722D636F6C6F723A20233365343634633B0D0A7D0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(595) := '20696E7075743A686F7665722C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722073656C6563743A686F7665722C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E6572207465';
wwv_flow_imp.g_varchar2_table(596) := '7874617265613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233163316632323B0D0A7D0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E657220696E7075743A666F6375732C0D0A2E7569';
wwv_flow_imp.g_varchar2_table(597) := '2D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722073656C6563743A666F6375732C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722074657874617265613A666F637573207B0D0A2020';
wwv_flow_imp.g_varchar2_table(598) := '6261636B67726F756E642D636F6C6F723A20233131313331342021696D706F7274616E743B0D0A2020626F726465722D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(599) := '722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D74657874617265612E6A732D73686F772D6C6162656C202E742D466F726D2D6C6162656C3A6265666F72652C0D0A2E742D466F726D2D6669656C64436F6E7461';
wwv_flow_imp.g_varchar2_table(600) := '696E65722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D74657874617265612E69732D616374697665202E742D466F726D2D6C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(601) := '3A20233238326333303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D74657874617265613A666F6375732D77697468696E202E742D466F72';
wwv_flow_imp.g_varchar2_table(602) := '6D2D6C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233131313331342021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E';
wwv_flow_imp.g_varchar2_table(603) := '617065782D6974656D2D777261707065722D2D74657874617265613A686F766572202E742D466F726D2D6C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233163316632323B0D0A7D0D0A2E617065782D697465';
wwv_flow_imp.g_varchar2_table(604) := '6D2D746578742C0D0A2E617065782D6974656D2D73656C6563742C0D0A2E617065782D6974656D2D7465787461726561207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E617065782D6974656D2D6D756C7469202E61706578';
wwv_flow_imp.g_varchar2_table(605) := '2D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F76207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(606) := '0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E742D466F726D2D696E707574436F6E7461696E6572202E617065782D6974656D2D646973706C61792D6F6E6C79207B0D0A2020636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(607) := '66666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233163316632323B0D0A2020626F726465722D636F6C6F723A20233365343634633B0D0A2020626F726465722D7374796C653A206461736865643B0D0A7D0D0A2E617065782D6974';
wwv_flow_imp.g_varchar2_table(608) := '656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20233163316632323B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E37293B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(609) := '2D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E617065782D6974656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(610) := '0A2E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(611) := '2D52544C202E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E617065782D6974656D2D66696C653A686F766572202B202E617065';
wwv_flow_imp.g_varchar2_table(612) := '782D6974656D2D66696C652D64726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E617065782D6974656D2D66696C653A686F766572202B';
wwv_flow_imp.g_varchar2_table(613) := '202E617065782D6974656D2D66696C652D64726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233131313331343B0D0A2020636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(614) := '66666666663B0D0A7D0D0A2E617065782D6974656D2D66696C653A666F637573202B202E617065782D6974656D2D66696C652D64726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(615) := '65722D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E617065782D6974656D2D66696C653A666F637573202B202E617065782D6974656D2D66696C652D64726F707A6F6E65202E617065782D697465';
wwv_flow_imp.g_varchar2_table(616) := '6D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D';
wwv_flow_imp.g_varchar2_table(617) := '0D0A2E617065782D6974656D2D74657874617265613A666F6375732C0D0A2E617065782D6974656D2D746578743A666F6375732C0D0A2E617065782D6974656D2D73656C6563743A666F6375732C0D0A2E617065782D6974656D2D6D756C74693A666F63';
wwv_flow_imp.g_varchar2_table(618) := '75732C0D0A73656C6563742E6C6973746D616E616765723A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233131313331342021696D706F7274616E743B0D0A2020626F726465722D636F6C6F723A2023303037366466202169';
wwv_flow_imp.g_varchar2_table(619) := '6D706F7274616E743B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263683A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E612D506F7075';
wwv_flow_imp.g_varchar2_table(620) := '704C4F562D7365617263682E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F763A666F637573202B202E612D427574746F6E';
wwv_flow_imp.g_varchar2_table(621) := '2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C7469';
wwv_flow_imp.g_varchar2_table(622) := '3A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74692E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E61';
wwv_flow_imp.g_varchar2_table(623) := '2D506F7075704C4F562D7365617263683A666F637573202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263682E69';
wwv_flow_imp.g_varchar2_table(624) := '732D666F6375736564202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F763A666F637573202B202E617065';
wwv_flow_imp.g_varchar2_table(625) := '782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075';
wwv_flow_imp.g_varchar2_table(626) := '704C4F562C0D0A2E617065782D6974656D2D6D756C74693A666F637573202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74692E69732D666F637573656420';
wwv_flow_imp.g_varchar2_table(627) := '2B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F56207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E617065782D6974656D2D746578';
wwv_flow_imp.g_varchar2_table(628) := '74617265613A686F7665722C0D0A2E617065782D6974656D2D746578743A686F7665722C0D0A2E617065782D6974656D2D73656C6563743A686F7665722C0D0A2E617065782D6974656D2D6D756C74693A686F7665722C0D0A73656C6563742E6C697374';
wwv_flow_imp.g_varchar2_table(629) := '6D616E616765723A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233163316632323B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E7075743A3A2D7765626B69742D696E7075742D706C61636568';
wwv_flow_imp.g_varchar2_table(630) := '6F6C646572207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3632293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E7075743A3A2D6D6F7A2D70';
wwv_flow_imp.g_varchar2_table(631) := '6C616365686F6C646572207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3632293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E7075743A2D6D';
wwv_flow_imp.g_varchar2_table(632) := '732D696E7075742D706C616365686F6C646572207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3632293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D466F726D20696E7075742E66696C65207B0D0A';
wwv_flow_imp.g_varchar2_table(633) := '2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E6572207370616E2E646973706C61795F6F6E6C79207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20206261';
wwv_flow_imp.g_varchar2_table(634) := '636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D466F726D2D73656C6563742C0D0A2E742D466F726D2D696E707574436F6E7461696E65722073656C6563742E7965735F6E6F207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(635) := '6666666666663B0D0A2020626F726465722D636F6C6F723A20233365343634633B0D0A7D0D0A2E742D466F726D2D6669656C642D2D726561644F6E6C79207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(636) := '0D0A2E742D466F726D2D726164696F4C6162656C2C0D0A2E742D466F726D2D696E707574436F6E7461696E6572202E726164696F5F67726F7570206C6162656C2C0D0A2E742D466F726D2D636865636B626F784C6162656C2C0D0A2E742D466F726D2D69';
wwv_flow_imp.g_varchar2_table(637) := '6E707574436F6E7461696E6572202E636865636B626F785F67726F7570206C6162656C2C0D0A2E742D466F726D2D6C6162656C2C0D0A2E752D466F726D2D6C6162656C207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D466F726D';
wwv_flow_imp.g_varchar2_table(638) := '2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E742D466F726D2D6C6162656C207B0D0A2020636F6C6F723A20236362636263623B0D0A7D0D0A2E742D466F726D2D6572726F72207B0D0A2020636F6C6F723A2023663434';
wwv_flow_imp.g_varchar2_table(639) := '3333363B0D0A7D0D0A2E742D466F726D2D706F737454657874207B0D0A2020636F6C6F723A20233766376637663B0D0A7D0D0A2E742D466F726D2D2D73656172636820696E7075742E742D466F726D2D7365617263684669656C64207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(640) := '6B67726F756E642D636F6C6F723A20233238326333303B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D427574746F6E2E612D427574746F6E2D2D63616C656E6461722C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F';
wwv_flow_imp.g_varchar2_table(641) := '7075704C4F562C0D0A2E612D427574746F6E2E612D427574746F6E2D2D636F6C6F725069636B6572207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E752D52544C202E612D427574746F6E2E612D427574';
wwv_flow_imp.g_varchar2_table(642) := '746F6E2D2D63616C656E6461722C0D0A2E752D52544C202E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F562C0D0A2E752D52544C202E612D427574746F6E2E612D427574746F6E2D2D636F6C6F725069636B6572207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(643) := '726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E7075742E686173446174657069636B65722C0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E';
wwv_flow_imp.g_varchar2_table(644) := '7075742E706F7075705F6C6F76207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D696E707574436F6E7461696E657220696E7075742E686173446174657069636B6572';
wwv_flow_imp.g_varchar2_table(645) := '2C0D0A2E752D52544C202E742D466F726D2D696E707574436F6E7461696E657220696E7075742E706F7075705F6C6F76207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E75692D646174657069636B6572';
wwv_flow_imp.g_varchar2_table(646) := '207B0D0A2020626F726465722D636F6C6F723A20233365343634633B0D0A7D0D0A626F6479202E75692D646174657069636B65722E75692D646174657069636B65722D696E6C696E65207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(647) := '2D736861646F773A206E6F6E652021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D66';
wwv_flow_imp.g_varchar2_table(648) := '6C6F6174696E674C6162656C202E75692D646174657069636B65722D696E6C696E65207B0D0A2020626F782D736861646F773A206E6F6E652021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E';
wwv_flow_imp.g_varchar2_table(649) := '743B0D0A202070616464696E673A20303B0D0A2020626F726465723A206E6F6E653B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E75692D646174657069636B65722D696E6C696E65202E';
wwv_flow_imp.g_varchar2_table(650) := '75692D7769646765742D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E707574207B0D0A2020';
wwv_flow_imp.g_varchar2_table(651) := '0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861646F773A20696E7365742072676261283235352C203235352C203235352C20302E3135292030203020';
wwv_flow_imp.g_varchar2_table(652) := '30203170783B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A6166746572207B0D0A2020636F6C6F723A20236666666666';
wwv_flow_imp.g_varchar2_table(653) := '663B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E7075743A686F766572202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861646F773A20696E7365742072676261283235352C203235352C203235352C20302E';
wwv_flow_imp.g_varchar2_table(654) := '323529203020302030203170783B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E7075743A666F637573202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861646F773A20696E7365742023303037366466203020';
wwv_flow_imp.g_varchar2_table(655) := '302030203170782C20696E7365742023666666666666203020302030203270783B0D0A7D0D0A2E636865636B626F785F67726F757020696E7075742C0D0A2E726164696F5F67726F757020696E707574207B0D0A20200D0A7D0D0A2E636865636B626F78';
wwv_flow_imp.g_varchar2_table(656) := '5F67726F757020696E7075743A666F6375733A636865636B6564202B206C6162656C3A6265666F72652C0D0A2E726164696F5F67726F757020696E7075743A666F6375733A636865636B6564202B206C6162656C3A6265666F7265207B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(657) := '2D736861646F773A20696E7365742023303037366466203020302030203170782C20696E7365742023666666666666203020302030203270783B0D0A7D0D0A2E636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C';
wwv_flow_imp.g_varchar2_table(658) := '3A6265666F72652C0D0A2E726164696F5F67726F757020696E7075743A636865636B6564202B206C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F782D736861646F773A206E';
wwv_flow_imp.g_varchar2_table(659) := '6F6E653B0D0A7D0D0A2E636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A686F7665723A6265666F72652C0D0A2E726164696F5F67726F757020696E7075743A636865636B6564202B206C6162656C3A686F76';
wwv_flow_imp.g_varchar2_table(660) := '65723A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233030363963363B0D0A7D0D0A2E726164696F5F67726F757020696E707574202B206C6162656C3A6166746572207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(661) := '3A20236666666666663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E707574207B0D0A20200D0A7D0D0A2E742D466F726D2D6669656C';
wwv_flow_imp.g_varchar2_table(662) := '64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E707574202B206C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233136313931623B0D0A20';
wwv_flow_imp.g_varchar2_table(663) := '20626F726465722D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E7075743A666F637573';
wwv_flow_imp.g_varchar2_table(664) := '202B206C6162656C3A6265666F7265207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67';
wwv_flow_imp.g_varchar2_table(665) := '726F757020696E7075743A666F6375733A636865636B6564202B206C6162656C3A6265666F7265207B0D0A2020626F726465722D636F6C6F723A20233238326333303B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A20';
wwv_flow_imp.g_varchar2_table(666) := '20626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F75702069';
wwv_flow_imp.g_varchar2_table(667) := '6E7075743A666F6375733A636865636B6564202B206C6162656C3A6166746572207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E';
wwv_flow_imp.g_varchar2_table(668) := '636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A6265666F7265207B0D0A2020626F726465722D636F6C6F723A20233238326333303B0D0A20206261636B67726F756E642D636F6C6F723A2023323832633330';
wwv_flow_imp.g_varchar2_table(669) := '3B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A6166746572207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(670) := '723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D70726554657874426C6F636B202E742D466F726D2D6974656D546578742D2D7072652C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D';
wwv_flow_imp.g_varchar2_table(671) := '2D706F737454657874426C6F636B202E742D466F726D2D6974656D546578742D2D706F7374207B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A2020626F782D736861646F773A20302030203020302E3172656D202333';
wwv_flow_imp.g_varchar2_table(672) := '653436346320696E7365743B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D70726554657874426C6F636B202E742D466F726D2D6974656D546578742D2D707265207B';
wwv_flow_imp.g_varchar2_table(673) := '0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D70726554657874426C6F636B202E742D466F726D2D6974656D546578742D2D7072';
wwv_flow_imp.g_varchar2_table(674) := '65207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D706F737454657874426C6F636B202E742D466F726D2D6974656D546578742D2D706F737420';
wwv_flow_imp.g_varchar2_table(675) := '7B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D706F737454657874426C6F636B202E742D466F726D2D6974656D546578742D2D';
wwv_flow_imp.g_varchar2_table(676) := '706F7374207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E617065782D6974656D2D6861732D69636F6E3A666F637573202B202E617065782D6974656D2D69636F6E2C0D0A2E617065782D6974656D2D6D';
wwv_flow_imp.g_varchar2_table(677) := '756C74692E69732D666F6375736564202B202E617065782D6974656D2D69636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E6170';
wwv_flow_imp.g_varchar2_table(678) := '65782D6974656D2D69636F6E207B0D0A2020636F6C6F723A20236535653565353B0D0A2020626F782D736861646F773A202D302E3172656D20302030202333653436346320696E7365743B0D0A2020626F726465722D7261646975733A20327078203020';
wwv_flow_imp.g_varchar2_table(679) := '30203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E617065782D6974656D2D69636F6E207B0D0A2020626F782D736861646F773A20302E3172656D2030203020';
wwv_flow_imp.g_varchar2_table(680) := '2333653436346320696E7365743B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E69732D72657175697265643A';
wwv_flow_imp.g_varchar2_table(681) := '6265666F7265207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E69732D72657175697265';
wwv_flow_imp.g_varchar2_table(682) := '643A6265666F7265207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A20303B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(683) := '2D2D666C6F6174696E674C6162656C202E617065782D6974656D2D6861732D69636F6E3A666F637573202B202E617065782D6974656D2D69636F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C20';
wwv_flow_imp.g_varchar2_table(684) := '2E617065782D6974656D2D6D756C74692E69732D666F6375736564202B202E617065782D6974656D2D69636F6E207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A';
wwv_flow_imp.g_varchar2_table(685) := '2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D466F726D2D68656C70427574746F6E3A666F637573202E612D49636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E';
wwv_flow_imp.g_varchar2_table(686) := '65722D2D726164696F427574746F6E47726F7570202E742D466F726D2D6974656D57726170706572203E202E617065782D6974656D2D67726F7570203E202E617065782D6974656D2D6F7074696F6E3A66697273742D6F662D74797065206C6162656C20';
wwv_flow_imp.g_varchar2_table(687) := '7B0D0A2020626F726465722D7261646975733A2032707820327078203020303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E742D466F726D2D6974656D57726170706572203E20';
wwv_flow_imp.g_varchar2_table(688) := '2E617065782D6974656D2D67726F7570203E202E617065782D6974656D2D6F7074696F6E3A6C6173742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2030203020327078203270783B0D0A7D0D0A2E742D466F726D';
wwv_flow_imp.g_varchar2_table(689) := '2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A66';
wwv_flow_imp.g_varchar2_table(690) := '697273742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E6170';
wwv_flow_imp.g_varchar2_table(691) := '65782D6974656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A6C6173742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A';
wwv_flow_imp.g_varchar2_table(692) := '2030203270782032707820303B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964202E617065782D6974656D2D677269642D726F';
wwv_flow_imp.g_varchar2_table(693) := '773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A66697273742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E752D52544C202E742D466F';
wwv_flow_imp.g_varchar2_table(694) := '726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E';
wwv_flow_imp.g_varchar2_table(695) := '3A6C6173742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E612D5377697463682D746F67676C65207B0D0A2020626F782D736861646F773A20696E73657420726762';
wwv_flow_imp.g_varchar2_table(696) := '61283235352C203235352C203235352C20302E303529203020302030203170783B0D0A20206261636B67726F756E642D636F6C6F723A20233733373337333B0D0A7D0D0A2E612D5377697463682D746F67676C653A6265666F7265207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(697) := '6B67726F756E642D636F6C6F723A20233030303B0D0A7D0D0A2E612D5377697463683A686F766572202E612D5377697463682D746F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C';
wwv_flow_imp.g_varchar2_table(698) := '20302E3735293B0D0A7D0D0A2E612D53776974636820696E7075745B747970653D636865636B626F785D3A666F637573202B202E612D5377697463682D746F67676C65207B0D0A2020626F782D736861646F773A20696E73657420233030373664662030';
wwv_flow_imp.g_varchar2_table(699) := '20302030203170782C20696E7365742023303030203020302030203270783B0D0A7D0D0A2E612D53776974636820696E7075745B747970653D636865636B626F785D3A636865636B6564202B202E612D5377697463682D746F67676C65207B0D0A202062';
wwv_flow_imp.g_varchar2_table(700) := '61636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D5377697463683A686F76657220696E7075745B747970653D636865636B626F785D3A636865636B6564202B202E612D5377697463682D746F67676C65207B0D0A202062';
wwv_flow_imp.g_varchar2_table(701) := '61636B67726F756E642D636F6C6F723A20233030363963363B0D0A7D0D0A2E612D53776974636820696E7075745B747970653D636865636B626F785D3A696E64657465726D696E617465202B202E612D5377697463682D746F67676C653A6265666F7265';
wwv_flow_imp.g_varchar2_table(702) := '207B0D0A2020626F782D736861646F773A20696E7365742023303030203020302030203170783B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A7D0D0A2E742D4865616465722D6272616E64';
wwv_flow_imp.g_varchar2_table(703) := '696E67207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4865616465722D6C6F676F2C0D0A2E742D486561646572202E742D427574746F6E2D2D6865616465722E69732D6163746976652C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(704) := '486561646572202E742D427574746F6E2D2D686561646572207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6C6F676F3A686F7665722C0D0A2E742D486561646572202E742D427574746F6E2D2D686561646572';
wwv_flow_imp.g_varchar2_table(705) := '2E69732D6163746976653A686F7665722C0D0A2E742D486561646572202E742D427574746F6E2D2D6865616465723A686F766572207B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A2E742D4865616465722D6C6F676F2D';
wwv_flow_imp.g_varchar2_table(706) := '6C696E6B207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D4865616465722D6C6F676F2D6C696E6B3A666F6375732C0D0A2E742D4865616465722D6C6F676F2D6C696E6B3A6163746976653A666F637573207B0D0A20206F75746C';
wwv_flow_imp.g_varchar2_table(707) := '696E653A206E6F6E653B0D0A2020626F782D736861646F773A20302030203020317078202332643963666620696E7365743B0D0A7D0D0A2E742D4865726F526567696F6E2D69636F6E207B0D0A2020626F726465722D7261646975733A203470783B0D0A';
wwv_flow_imp.g_varchar2_table(708) := '20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865726F526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(709) := '4865726F526567696F6E2D636F6C2D2D636F6E74656E74207B0D0A2020636F6C6F723A20236263626362633B0D0A7D0D0A2E742D426F64792D7469746C65202E742D4865726F526567696F6E2D7469746C652C0D0A2E742D426F64792D7469746C65202E';
wwv_flow_imp.g_varchar2_table(710) := '742D4865726F526567696F6E2D636F6C2D2D636F6E74656E74207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D4947207B0D0A2020626F726465722D636F6C6F723A20233332333633393B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(711) := '6F6C6F723A20233030303B0D0A7D0D0A2E612D52562D746F6F6C626172207B0D0A2020626F726465722D636F6C6F723A20233265326532653B0D0A7D0D0A2E612D47562D6864722C0D0A2E612D49472D686561646572207B0D0A2020626F726465722D63';
wwv_flow_imp.g_varchar2_table(712) := '6F6C6F723A20233332333633393B0D0A20206261636B67726F756E642D636F6C6F723A20233139316331653B0D0A7D0D0A2E612D47562D772D66726F7A656E202E612D47562D7461626C652C0D0A2E612D47562D772D686472202E612D47562D7461626C';
wwv_flow_imp.g_varchar2_table(713) := '65207B0D0A2020626F726465722D636F6C6F723A20233166316631662021696D706F7274616E743B0D0A7D0D0A2E612D47562D626479207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E612D47562D686561';
wwv_flow_imp.g_varchar2_table(714) := '6465722C0D0A2E612D47562D68656164657247726F75702C0D0A2E612D546F6F6C6261722D67726F7570207B0D0A2020626F726465722D636F6C6F723A20233332333633393B0D0A7D0D0A2E612D47562D7461626C65202E612D47562D63656C6C207B0D';
wwv_flow_imp.g_varchar2_table(715) := '0A2020626F726465722D636F6C6F723A20233332333633393B0D0A7D0D0A2E612D47562D7461626C652074722E69732D73656C6563746564202E612D47562D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233030306331363B0D';
wwv_flow_imp.g_varchar2_table(716) := '0A7D0D0A2E612D47562D7461626C652074722E69732D64656C657465642E69732D73656C6563746564202E612D47562D63656C6C2E6861732D627574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C2031322C2032';
wwv_flow_imp.g_varchar2_table(717) := '322C20302E35293B0D0A7D0D0A2E612D4952522D706167696E6174696F6E577261702D2D626F74746F6D207B0D0A2020626F726465722D746F702D636F6C6F723A20233332333633393B0D0A7D0D0A2E612D49472D6772696456696577202E612D47562D';
wwv_flow_imp.g_varchar2_table(718) := '666F6F746572207B0D0A2020626F726465722D636F6C6F723A20233332333633393B0D0A7D0D0A2E612D47562D666F6F746572207B0D0A2020626F726465722D636F6C6F723A20233332333633393B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(719) := '20233235323932643B0D0A7D0D0A2E612D47562D7061676552616E6765207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3635293B0D0A7D0D0A2E612D47562D70616765427574746F6E207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(720) := '3A2072676261283235352C203235352C203235352C20302E3635293B0D0A7D0D0A2E612D47562D70616765427574746F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C2030';
wwv_flow_imp.g_varchar2_table(721) := '2E303735293B0D0A7D0D0A2E612D47562D7061676553656C6563746F722D6974656D2E69732D73656C6563746564202E612D47562D70616765427574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C20323535';
wwv_flow_imp.g_varchar2_table(722) := '2C203235352C20302E3135293B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A7D0D0A2E612D47562D7461626C652074682E612D47562D636F6E74726F6C427265616B486561646572207B0D0A202062';
wwv_flow_imp.g_varchar2_table(723) := '61636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A2020636F6C6F723A20726762';
wwv_flow_imp.g_varchar2_table(724) := '61283235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E612D47562D2D656469744D6F6465202E612D47562D726F772E69732D726561646F6E6C79202E612D47562D63656C6C2C0D0A2E612D47562D2D656469744D6F6465202E612D4756';
wwv_flow_imp.g_varchar2_table(725) := '2D63656C6C2E69732D726561646F6E6C79207B0D0A20206261636B67726F756E642D636F6C6F723A20233036303630363B0D0A2020636F6C6F723A20233866386638663B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669';
wwv_flow_imp.g_varchar2_table(726) := '656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E207B0D0A2020626F782D736861646F773A206E6F6E652021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A2074';
wwv_flow_imp.g_varchar2_table(727) := '72616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A6265';
wwv_flow_imp.g_varchar2_table(728) := '666F72652C0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A6166746572207B0D0A2020636F6E74656E743A206E6F';
wwv_flow_imp.g_varchar2_table(729) := '6E653B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A686F766572202E612D49636F6E207B0D0A20206F70';
wwv_flow_imp.g_varchar2_table(730) := '61636974793A20313B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A666F637573207B0D0A2020626F782D';
wwv_flow_imp.g_varchar2_table(731) := '736861646F773A20302030203020317078202330303736646620696E7365742021696D706F7274616E743B0D0A7D0D0A2E612D49472D6865616465722C0D0A2E612D49474469616C6F672D6865616465722C0D0A2E612D49474469616C6F672D666F6F74';
wwv_flow_imp.g_varchar2_table(732) := '65722C0D0A2E612D49474469616C6F672D73696465207B0D0A2020626F726465722D636F6C6F723A20233166316631663B0D0A20206261636B67726F756E642D636F6C6F723A20233036303630363B0D0A7D0D0A2E612D47562D636F6C756D6E436F6E74';
wwv_flow_imp.g_varchar2_table(733) := '726F6C73202E612D427574746F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233463346535303B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C';
wwv_flow_imp.g_varchar2_table(734) := '203235352C203235352C20302E3132352920696E7365743B0D0A7D0D0A2E612D47562D636F6C756D6E436F6E74726F6C73202E612D427574746F6E2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A2023333433353336';
wwv_flow_imp.g_varchar2_table(735) := '3B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E3032352920696E7365743B0D0A7D0D0A2E612D47562D666C6F6174696E674974656D2E69732D657870616E646564207B0D0A20';
wwv_flow_imp.g_varchar2_table(736) := '206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3935293B0D0A7D0D0A2E612D47562D636F6C756D6E48616E646C652C0D0A2E612D47562D63656C6C4D6F766548616E646C65207B0D0A20206F7061636974793A20';
wwv_flow_imp.g_varchar2_table(737) := '302E353B0D0A20206261636B67726F756E642D696D6167653A2075726C28646174613A696D6167652F7376672B786D6C3B6261736536342C50484E325A79423462577875637A30696148523063446F764C336433647935334D793576636D63764D6A4177';
wwv_flow_imp.g_varchar2_table(738) := '4D43397A646D6369494864705A48526F505349304969426F5A576C6E61485139496A516949485A705A58644362336739496A41674D43413049445169506A78775958526F49475A706247773949694D324E6A596949475139496B30774944426F4D6E5979';
wwv_flow_imp.g_varchar2_table(739) := '6143307965694976506A777663335A6E50673D3D293B0D0A7D0D0A2E612D47562D636F6C756D6E48616E646C653A686F7665722C0D0A2E612D47562D63656C6C4D6F766548616E646C653A686F766572207B0D0A20206F7061636974793A20302E37353B';
wwv_flow_imp.g_varchar2_table(740) := '0D0A7D0D0A2E612D495252207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(741) := '20233232323632393B0D0A7D0D0A2E612D495252202E612D4952522D706167696E6174696F6E2D6C6162656C207B0D0A2020636F6C6F723A20236232623262323B0D0A7D0D0A2E612D4952522D6469616C6F67526F772D2D686561646572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(742) := '636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4952522D6469616C6F674C6973742061207B0D0A2020636F6C6F723A20696E68657269742021696D706F7274616E743B0D0A7D0D0A2E612D4952522D7265706F727453756D6D6172792D76616C';
wwv_flow_imp.g_varchar2_table(743) := '75652C0D0A2E612D49472D7265706F727453756D6D6172792D76616C7565207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E612D4952522D636F6E74726F6C73436F6E7461696E6572207B0D0A2020626F726465722D746F702D636F6C';
wwv_flow_imp.g_varchar2_table(744) := '6F723A20233262333033353B0D0A20206261636B67726F756E642D636F6C6F723A20233236326232663B0D0A7D0D0A2E612D4952522D66756C6C56696577207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(745) := '612D4952522D627574746F6E2E612D4952522D627574746F6E2D2D636F6E74726F6C73207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E612D4952522D746F6F6C626172207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(746) := '67726F756E643A20233139316331653B0D0A2020626F726465722D636F6C6F723A20233330333533613B0D0A7D0D0A2E612D5265706F72742D70657263656E7443686172742D66696C6C207B0D0A20206261636B67726F756E642D636F6C6F723A202330';
wwv_flow_imp.g_varchar2_table(747) := '30373664663B0D0A7D0D0A2E612D5265706F72742D70657263656E744368617274207B0D0A20206261636B67726F756E642D636F6C6F723A20236466663066663B0D0A7D0D0A2E612D4952522D627574746F6E2D2D636F6C536561726368207B0D0A2020';
wwv_flow_imp.g_varchar2_table(748) := '626F726465722D746F702D72696768742D7261646975733A20302021696D706F7274616E743B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A20302021696D706F7274616E743B0D0A7D0D0A2E752D52544C202E612D4952';
wwv_flow_imp.g_varchar2_table(749) := '522D627574746F6E2D2D636F6C536561726368207B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270782021696D706F7274616E743B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A20327078';
wwv_flow_imp.g_varchar2_table(750) := '2021696D706F7274616E743B0D0A2020626F726465722D746F702D6C6566742D7261646975733A20302021696D706F7274616E743B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A20302021696D706F7274616E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(751) := '0D0A2E612D4952522D69636F6E566965775461626C652C0D0A2E612D4952522D6368617274566965772C0D0A2E612D4952522D7069766F74566965772C0D0A2E612D4952522D67726F75704279566965772C0D0A2E612D4952522D64657461696C566965';
wwv_flow_imp.g_varchar2_table(752) := '77207B0D0A2020626F726465722D746F702D636F6C6F723A20233262333033353B0D0A7D0D0A2E612D4952522D746F6F6C6261722D2D73696E676C65526F77207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A20233330333533613B0D0A';
wwv_flow_imp.g_varchar2_table(753) := '7D0D0A2E612D4952522D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233236326232663B0D0A2020626F726465722D746F703A2031707820736F6C696420233339336634353B0D0A2020626F782D736861646F773A20696E';
wwv_flow_imp.g_varchar2_table(754) := '7365742031707820302030203020233339336634353B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A7D0D0A2E612D4952522D6865616465723A686F766572207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(755) := '636F6C6F723A20233264333333373B0D0A7D0D0A2E612D4952522D6865616465722E69732D616374697665207B0D0A2020626F782D736861646F773A20302031707820317078207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D';
wwv_flow_imp.g_varchar2_table(756) := '0D0A2E612D4952522D6865616465722E69732D6163746976652061207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4952522D6865616465722E69732D616374697665202E612D4952522D686561646572536F7274207B0D0A2020';
wwv_flow_imp.g_varchar2_table(757) := '636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4952522D6865616465722E69732D6163746976652C0D0A2E612D47562D6865616465722E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233230323032303B';
wwv_flow_imp.g_varchar2_table(758) := '0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E612D4952522D6865616465722D2D67726F7570207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033353B0D0A7D0D0A2E742D4952522D726567696F6E207B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(759) := '2D736861646F773A20302031707820327078207267626128302C20302C20302C20302E3035292C20302032707820347078202D327078207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E612D4952522D7461626C65436F6E7461696E';
wwv_flow_imp.g_varchar2_table(760) := '6572202E6A732D737469636B795461626C654865616465722E69732D737475636B207B0D0A2020626F782D736861646F773A2030203170782072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A406D65646961206F6E6C792073';
wwv_flow_imp.g_varchar2_table(761) := '637265656E20616E6420286D61782D77696474683A20373638707829207B0D0A20202E612D4952522D627574746F6E733A6265666F7265207B0D0A202020206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C';
wwv_flow_imp.g_varchar2_table(762) := '20302E3035293B0D0A20207D0D0A7D0D0A2E612D4952522D7461626C65207472207464207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E612D4952522D7461';
wwv_flow_imp.g_varchar2_table(763) := '626C65207B0D0A2020626F726465722D636F6C6C617073653A2073657061726174653B0D0A7D0D0A2E612D4952522D7461626C652074723A686F766572207464207B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(764) := '0A2E742D4952522D726567696F6E2D2D6E6F426F7264657273202E612D495252207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E612D4952522D7461626C65207464207B0D0A2020626F726465722D6C6566743A2031707820';
wwv_flow_imp.g_varchar2_table(765) := '736F6C696420233264333133343B0D0A2020626F726465722D746F703A2031707820736F6C696420233264333133343B0D0A7D0D0A2E612D4952522D7461626C652074722074643A6C6173742D6368696C64207B0D0A2020626F726465722D7269676874';
wwv_flow_imp.g_varchar2_table(766) := '2D636F6C6F723A20233136313931623B0D0A7D0D0A2E612D4952522D6865616465724C696E6B3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D4952522D7365';
wwv_flow_imp.g_varchar2_table(767) := '617263682D6669656C643A666F637573207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A2020626F782D736861646F773A202D31707820302030202330303736646620696E7365742C2031707820302030202330303736646620';
wwv_flow_imp.g_varchar2_table(768) := '696E7365743B0D0A7D0D0A2E612D4952522D73696E676C65526F772D6E616D652C0D0A2E612D4952522D73696E676C65526F772D76616C7565207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A20233330333533613B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(769) := '723A20236532653565373B0D0A7D0D0A2E612D4952522D73696E676C65526F772D76616C7565207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E612D4952522D73696E676C65526F772D726F773A686F7665';
wwv_flow_imp.g_varchar2_table(770) := '72202E612D4952522D73696E676C65526F772D76616C7565207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433323B0D0A7D0D0A2E612D4952522D73696E676C65526F772D6E616D65207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(771) := '6F6C6F723A20233239326433323B0D0A7D0D0A2E612D4952522D73696E676C65526F772D726F773A686F766572202E612D4952522D73696E676C65526F772D6E616D65207B0D0A20206261636B67726F756E642D636F6C6F723A20233330333533613B0D';
wwv_flow_imp.g_varchar2_table(772) := '0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D627574746F6E2D2D706167696E6174696F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D4952522D7265706F72745375';
wwv_flow_imp.g_varchar2_table(773) := '6D6D6172792D6C6162656C2C0D0A2E612D49472D7265706F727453756D6D6172792D6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632392021696D706F7274616E743B0D0A2020636F6C6F723A2023666566656665';
wwv_flow_imp.g_varchar2_table(774) := '3B0D0A7D0D0A2E612D4952522D636F6E74726F6C734C6162656C2C0D0A2E612D49472D636F6E74726F6C734C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A406D65646961206F6E6C7920736372';
wwv_flow_imp.g_varchar2_table(775) := '65656E20616E6420286D696E2D77696474683A20373639707829207B0D0A20202E69732D6D6178696D697A65642E742D4952522D726567696F6E202E742D6668742D7468656164202E612D4952522D686561646572207B0D0A20202020626F726465722D';
wwv_flow_imp.g_varchar2_table(776) := '626F74746F6D3A2031707820736F6C696420233339336634353B0D0A20207D0D0A7D0D0A2E75692D7769646765742D636F6E74656E74202E612D4952522D69636F6E4C6973742D6C696E6B207B0D0A2020636F6C6F723A20236665666566653B0D0A2020';
wwv_flow_imp.g_varchar2_table(777) := '6261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E612D4952522D69636F6E4C6973742D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433323B0D0A7D0D0A2E612D495252';
wwv_flow_imp.g_varchar2_table(778) := '2D69636F6E4C6973742D6974656D202E612D4952522D69636F6E4C6973742D6C696E6B3A686F7665722C0D0A2E612D4952522D69636F6E4C6973742D6974656D202E612D4952522D69636F6E4C6973742D6C696E6B2E69732D6163746976652C0D0A2E61';
wwv_flow_imp.g_varchar2_table(779) := '2D4952522D726164696F49636F6E4C6973742D6974656D20696E7075745B747970653D726164696F5D3A636865636B6564202B206C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433322021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(780) := '0D0A7D0D0A2E612D4952522D627574746F6E3A666F6375732C0D0A2E612D4952522D627574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20696E68657269743B0D0A7D0D0A2E612D4952522D736F7274576964676574207B0D0A2020';
wwv_flow_imp.g_varchar2_table(781) := '6261636B67726F756E642D636F6C6F723A20726762612833322C2033322C2033322C20302E3935293B0D0A20202D7765626B69742D6261636B64726F702D66696C7465723A20626C757228347078293B0D0A2020636F6C6F723A20234646463B0D0A2020';
wwv_flow_imp.g_varchar2_table(782) := '626F726465722D77696474683A20303B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A203270783B0D0A2020626F782D736861646F';
wwv_flow_imp.g_varchar2_table(783) := '773A2030203870782031367078207267626128302C20302C20302C20302E3235292C203020302030203170782072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E612D4952522D736F7274576964676574203A3A2D7765626B';
wwv_flow_imp.g_varchar2_table(784) := '69742D7363726F6C6C626172207B0D0A202077696474683A203870783B0D0A20206865696768743A203870783B0D0A7D0D0A2E612D4952522D736F7274576964676574203A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A202062';
wwv_flow_imp.g_varchar2_table(785) := '61636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A7D0D0A2E612D4952522D736F7274576964676574203A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(786) := '2D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A7D0D0A2E612D4952522D736F72745769646765742D68656C70207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E612D49';
wwv_flow_imp.g_varchar2_table(787) := '52522D736F72745769646765742D616374696F6E73207B0D0A202070616464696E673A203870783B0D0A2020626F726465722D7261646975733A203270783B0D0A202077696474683A206175746F3B0D0A2020626F726465722D626F74746F6D2D776964';
wwv_flow_imp.g_varchar2_table(788) := '74683A20303B0D0A7D0D0A2E612D4952522D736F72745769646765742D616374696F6E732D6974656D207B0D0A2020626F726465722D72696768742D77696474683A20303B0D0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D736F72745769';
wwv_flow_imp.g_varchar2_table(789) := '646765742D627574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20234646463B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E612D4952522D6275';
wwv_flow_imp.g_varchar2_table(790) := '74746F6E2E612D4952522D736F72745769646765742D627574746F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E32293B0D0A7D0D0A2E612D4952522D627574746F';
wwv_flow_imp.g_varchar2_table(791) := '6E2E612D4952522D736F72745769646765742D627574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D736F';
wwv_flow_imp.g_varchar2_table(792) := '72745769646765742D627574746F6E2E69732D6163746976652C0D0A2E612D4952522D627574746F6E2E612D4952522D736F72745769646765742D627574746F6E3A6163746976653A666F637573207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(793) := '3A2072676261283235352C203235352C203235352C20302E35293B0D0A7D0D0A2E612D4952522D736F72745769646765742D7365617263684C6162656C207B0D0A20206865696768743A20343070783B0D0A202070616464696E673A2031327078203870';
wwv_flow_imp.g_varchar2_table(794) := '783B0D0A7D0D0A2E612D4952522D736F72745769646765742D7365617263684C6162656C3A6265666F7265207B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E612D4952522D736F72745769646765742D736561726368203E202E612D4952522D';
wwv_flow_imp.g_varchar2_table(795) := '736F72745769646765742D7365617263684669656C645B747970653D2274657874225D207B0D0A2020617070656172616E63653A206E6F6E653B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D';
wwv_flow_imp.g_varchar2_table(796) := '0A20206865696768743A20343070783B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E612D4952522D736F72745769646765742D736561726368203E202E612D4952522D736F72745769646765742D7365617263684669656C645B747970653D22';
wwv_flow_imp.g_varchar2_table(797) := '74657874225D3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F7773207B0D0A2020626F726465722D746F702D7769';
wwv_flow_imp.g_varchar2_table(798) := '6474683A20303B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F77207B0D0A2020636F6C6F723A20234646463B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F773A68';
wwv_flow_imp.g_varchar2_table(799) := '6F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F773A666F637573207B0D0A2020626F782D736861646F773A203020';
wwv_flow_imp.g_varchar2_table(800) := '30203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D4947202E612D4952522D736F72745769646765743A6265666F7265207B0D0A2020636F6C6F723A20726762612833322C2033322C2033322C20302E3935293B0D0A7D0D0A2E61';
wwv_flow_imp.g_varchar2_table(801) := '2D495252202E686F75722D6772617068207370616E2E686F75722E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233166316631662021696D706F7274616E743B0D0A7D0D0A2E612D495252202E686F75722D6772617068';
wwv_flow_imp.g_varchar2_table(802) := '207370616E2E686F7572207B0D0A20206261636B67726F756E642D636F6C6F723A20233138343431322021696D706F7274616E743B0D0A7D0D0A2E6F6A2D6476742D63617465676F727931207B0D0A2020636F6C6F723A20233330394644423B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(803) := '0A2E6F6A2D6476742D63617465676F727932207B0D0A2020636F6C6F723A20233343414638353B0D0A7D0D0A2E6F6A2D6476742D63617465676F727933207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E6F6A2D6476742D6361746567';
wwv_flow_imp.g_varchar2_table(804) := '6F727934207B0D0A2020636F6C6F723A20234539354235343B0D0A7D0D0A2E6F6A2D6476742D63617465676F727935207B0D0A2020636F6C6F723A20233835344539423B0D0A7D0D0A2E6F6A2D6476742D63617465676F727936207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(805) := '723A20233245424642433B0D0A7D0D0A2E6F6A2D6476742D63617465676F727937207B0D0A2020636F6C6F723A20234544383133453B0D0A7D0D0A2E6F6A2D6476742D63617465676F727938207B0D0A2020636F6C6F723A20234538354438383B0D0A7D';
wwv_flow_imp.g_varchar2_table(806) := '0D0A2E6F6A2D6476742D63617465676F727939207B0D0A2020636F6C6F723A20233133423643463B0D0A7D0D0A2E6F6A2D6476742D63617465676F72793130207B0D0A2020636F6C6F723A20233831424235463B0D0A7D0D0A2E6F6A2D6476742D636174';
wwv_flow_imp.g_varchar2_table(807) := '65676F72793131207B0D0A2020636F6C6F723A20234341353839443B0D0A7D0D0A2E6F6A2D6476742D63617465676F72793132207B0D0A2020636F6C6F723A20234444444535333B0D0A7D0D0A2E6F6A2D6C6567656E642C0D0A2E6F6A2D6C6567656E64';
wwv_flow_imp.g_varchar2_table(808) := '2D7469746C652C0D0A2E6F6A2D63686172742D7069652D63656E7465722D6C6162656C2C0D0A2E6F6A2D63686172742D78617869732D7469746C652C0D0A2E6F6A2D63686172742D79617869732D7469746C652C0D0A2E6F6A2D63686172742D79326178';
wwv_flow_imp.g_varchar2_table(809) := '69732D7469746C652C0D0A2E6F6A2D63686172742D78617869732D7469636B2D6C6162656C2C0D0A2E6F6A2D63686172742D79617869732D7469636B2D6C6162656C2C0D0A2E6F6A2D63686172742D7932617869732D7469636B2D6C6162656C2C0D0A2E';
wwv_flow_imp.g_varchar2_table(810) := '6F6A2D63686172742D646174612D6C6162656C2C0D0A2E6F6A2D6476742D6E6F2D646174612D6D657373616765207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4C696E6B734C6973742D6974656D2C0D0A2E742D4C696E6B734C';
wwv_flow_imp.g_varchar2_table(811) := '6973742D6C696E6B207B0D0A2020626F726465722D636F6C6F723A20233339336634353B0D0A7D0D0A2E742D4C696E6B734C6973742D69636F6E207B0D0A2020636F6C6F723A20233434346335333B0D0A7D0D0A2E742D4C696E6B734C6973742D6C696E';
wwv_flow_imp.g_varchar2_table(812) := '6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233264333333373B0D0A7D0D0A2E742D4C696E6B734C6973742D6C696E6B3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736';
wwv_flow_imp.g_varchar2_table(813) := '646620696E7365743B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6974656D2D2D736570617261746F72207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C';
wwv_flow_imp.g_varchar2_table(814) := '203235352C203235352C20302E3035293B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774172726F77202E742D4C696E6B734C6973742D6C696E6B3A6265666F7265207B0D0A2020636F6C6F723A20233434346335333B0D0A7D0D0A2E742D4C';
wwv_flow_imp.g_varchar2_table(815) := '696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033353B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D4C696E';
wwv_flow_imp.g_varchar2_table(816) := '6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233334336134303B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(817) := '4C696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564203E202E742D4C696E6B734C6973742D6C696E6B202E742D4C696E6B734C6973742D6261646765207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(818) := '726F756E642D636F6C6F723A20233562363636663B0D0A7D0D0A2E742D4C696E6B734C6973742D2D627269676874486F766572202E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564202E742D4C696E6B734C6973742D6C696E6B3A';
wwv_flow_imp.g_varchar2_table(819) := '686F7665723A6265666F7265207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A7D0D0A2E742D4C696E6B734C6973742D2D627269676874486F766572202E742D4C696E6B734C6973742D6C696E6B3A686F766572207B';
wwv_flow_imp.g_varchar2_table(820) := '0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4C696E6B734C6973742D2D627269676874486F766572202E742D4C696E6B734C6973742D6C696E6B3A686F';
wwv_flow_imp.g_varchar2_table(821) := '766572202E742D4C696E6B734C6973742D69636F6E207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A7D0D0A2E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(822) := '6F756E642D636F6C6F723A20234643464346433B0D0A20206261636B67726F756E643A206C696E6561722D6772616469656E74287267626128302C20302C20302C20302E303135292C207267626128302C20302C20302C203029292C206C696E6561722D';
wwv_flow_imp.g_varchar2_table(823) := '6772616469656E74287267626128302C20302C20302C2030292C207267626128302C20302C20302C20302E30313529293B0D0A7D0D0A2E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564202E742D4C696E6B734C6973742D6C696E';
wwv_flow_imp.g_varchar2_table(824) := '6B3A686F7665723A6265666F7265207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564202E742D4C696E6B734C6973742D6C696E6B3A6265666F7265207B0D0A2020';
wwv_flow_imp.g_varchar2_table(825) := '636F6C6F723A2072676261283235352C203235352C203235352C20302E3235293B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6261646765207B0D0A2020626F726465722D7261646975733A';
wwv_flow_imp.g_varchar2_table(826) := '203470783B0D0A7D0D0A2E742D4C696E6B734C6973742D2D69636F6E4F6E6C79202E742D4C696E6B734C6973742D69636F6E207B0D0A2020626F726465722D7261646975733A20313030253B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F';
wwv_flow_imp.g_varchar2_table(827) := '6E73202E742D4C696E6B734C6973742D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D69636F6E207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(828) := '6666666666663B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D69636F6E2C0D0A2E742D4C696E6B734C6973742D2D616374696F6E7320';
wwv_flow_imp.g_varchar2_table(829) := '2E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D6C6162656C2C0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C';
wwv_flow_imp.g_varchar2_table(830) := '6973742D6261646765207B0D0A2020636F6C6F723A20236564656666313B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D4C696E6B734C6973742D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A202333';
wwv_flow_imp.g_varchar2_table(831) := '61343134373B0D0A7D0D0A2E612D4C697374566965772D6974656D207B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C69642072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E612D4C69737456696577';
wwv_flow_imp.g_varchar2_table(832) := '2D6974656D202E75692D62746E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D4C697374566965772D6974656D202E75692D62746E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235';
wwv_flow_imp.g_varchar2_table(833) := '352C203235352C203235352C20302E3035293B0D0A7D0D0A2E612D4C697374566965772D6974656D202E6661207B0D0A2020636F6C6F723A20233434346335333B0D0A7D0D0A2E612D4C697374566965772D6974656D202E75692D6C692D636F756E7420';
wwv_flow_imp.g_varchar2_table(834) := '7B0D0A2020636F6C6F723A20236336636364303B0D0A20206261636B67726F756E642D636F6C6F723A20233339336634353B0D0A7D0D0A2E742D50616765426F64792D2D6C6F67696E207B0D0A20206261636B67726F756E642D636F6C6F723A20233166';
wwv_flow_imp.g_varchar2_table(835) := '316631663B0D0A7D0D0A2E742D4C6F67696E506167652D2D6267312C0D0A2E742D4C6F67696E506167652D2D6267322C0D0A2E742D4C6F67696E506167652D2D626733207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D';
wwv_flow_imp.g_varchar2_table(836) := '0A7D0D0A2E6170702D69636F6E207B0D0A20206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0D0A20206261636B67726F756E642D73697A653A20636F7665723B0D0A20206261636B67726F756E642D706F736974696F6E3A20';
wwv_flow_imp.g_varchar2_table(837) := '3530253B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4C6F67696E2D69636F6E56616C69646174696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(838) := '6C6F723A20233030303B0D0A7D0D0A2E742D4C6F67696E2D726567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3635293B0D0A2020626F782D736861646F773A2030203870782032347078';
wwv_flow_imp.g_varchar2_table(839) := '202D347078207267626128302C20302C20302C20302E32292C203020302030203170782072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D4C6F67696E506167652D2D73706C6974202E742D4C6F67696E2D636F6E7461';
wwv_flow_imp.g_varchar2_table(840) := '696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3635293B0D0A2020626F782D736861646F773A203020302032347078202D347078207267626128302C20302C20302C20302E32292C203020';
wwv_flow_imp.g_varchar2_table(841) := '302030203170782072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E612D4D44456469746F72202E612D546F6F6C626172207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20';
wwv_flow_imp.g_varchar2_table(842) := '302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A2020626F726465722D746F702D6C6566742D7261646975733A20302E3272656D3B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(843) := '722D746F702D72696768742D7261646975733A20302E3272656D3B0D0A7D0D0A2E612D4D44456469746F72202E612D546F6F6C626172202E612D427574746F6E3A6E6F74283A686F766572293A6E6F74283A616374697665293A6E6F74283A666F637573';
wwv_flow_imp.g_varchar2_table(844) := '293A6E6F74282E69732D61637469766529207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D4D44456469746F722D707265766965775061';
wwv_flow_imp.g_varchar2_table(845) := '6E656C2C0D0A2E612D4D44456469746F722074657874617265612E617065782D6974656D2D74657874617265612C0D0A2E612D4D44456469746F72202E436F64654D6972726F72207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C';
wwv_flow_imp.g_varchar2_table(846) := '203235352C203235352C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A20233030303B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A20302E327265';
wwv_flow_imp.g_varchar2_table(847) := '6D3B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A20302E3272656D3B0D0A7D0D0A2E612D4D44456469746F722D7072657669657750616E656C3A666F6375732C0D0A2E612D4D44456469746F722074657874617265612E';
wwv_flow_imp.g_varchar2_table(848) := '617065782D6974656D2D74657874617265613A666F6375732C0D0A2E612D4D44456469746F72202E436F64654D6972726F723A666F6375732C0D0A2E612D4D44456469746F722D7072657669657750616E656C2E436F64654D6972726F722D666F637573';
wwv_flow_imp.g_varchar2_table(849) := '65642C0D0A2E612D4D44456469746F722074657874617265612E617065782D6974656D2D74657874617265612E436F64654D6972726F722D666F63757365642C0D0A2E612D4D44456469746F72202E436F64654D6972726F722E436F64654D6972726F72';
wwv_flow_imp.g_varchar2_table(850) := '2D666F6375736564207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E436F64654D6972726F722D637572736F72207B0D0A2020626F726465722D6C6566742D636F6C6F723A20236666666666662021696D706F727461';
wwv_flow_imp.g_varchar2_table(851) := '6E743B0D0A7D0D0A2E69732D6D61726B646F776E69666965642068312C0D0A2E69732D6D61726B646F776E69666965642068322C0D0A2E69732D6D61726B646F776E69666965642068332C0D0A2E69732D6D61726B646F776E69666965642068342C0D0A';
wwv_flow_imp.g_varchar2_table(852) := '2E69732D6D61726B646F776E69666965642068352C0D0A2E69732D6D61726B646F776E6966696564206836207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E69732D6D61726B646F776E6966696564206872207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(853) := '726F756E643A206E6F6E653B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E32293B0D0A7D0D0A2E69732D6D61726B646F776E696669656420626C6F636B71756F7465207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(854) := '726465722D6C6566742D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E69732D6D61726B646F776E696669656420636F6465207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235';
wwv_flow_imp.g_varchar2_table(855) := '352C203235352C203235352C20302E3235293B0D0A2020626F782D736861646F773A20696E7365742072676261283235352C203235352C203235352C20302E303529203020302030203170783B0D0A7D0D0A2E69732D6D61726B646F776E696669656420';
wwv_flow_imp.g_varchar2_table(856) := '707265207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3235293B0D0A2020626F782D736861646F773A20696E7365742072676261283235352C203235352C203235352C20302E303529';
wwv_flow_imp.g_varchar2_table(857) := '203020302030203170783B0D0A7D0D0A2E69732D6D61726B646F776E69666965642070726520636F6465207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D';
wwv_flow_imp.g_varchar2_table(858) := '0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C65207B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D';
wwv_flow_imp.g_varchar2_table(859) := '0A2020626F782D736861646F773A20302032707820347078202D327078207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C65207468207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(860) := '6F6C6F723A2072676261283235352C203235352C203235352C20302E303135293B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C652074682C0D0A2E69732D6D61726B646F776E6966696564207461626C65207464207B0D0A202062';
wwv_flow_imp.g_varchar2_table(861) := '6F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C652074723A686F766572207464207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(862) := '6E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E30313235293B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C652074723A686F766572207468207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(863) := '3A2072676261283235352C203235352C203235352C20302E3235293B0D0A7D0D0A2E742D4D656469614C697374207B0D0A2020626F726465722D636F6C6F723A20233364343534623B0D0A20206261636B67726F756E642D636F6C6F723A202332323236';
wwv_flow_imp.g_varchar2_table(864) := '32393B0D0A7D0D0A2E742D4D656469614C6973742D6974656D207B0D0A2020626F726465722D636F6C6F723A20233364343534623B0D0A7D0D0A2E742D4D656469614C6973742D6974656D2E69732D616374697665207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(865) := '642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D4D656469614C6973742D2D686F72697A6F6E74616C202E742D4D656469614C6973742D6974656D207B0D0A2020626F726465722D7269676874';
wwv_flow_imp.g_varchar2_table(866) := '3A2031707820736F6C696420233364343534623B0D0A7D0D0A612E742D4D656469614C6973742D6974656D57726170207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A612E742D4D656469614C6973742D6974656D577261703A686F7665';
wwv_flow_imp.g_varchar2_table(867) := '72207B0D0A20206261636B67726F756E642D636F6C6F723A20233236326232663B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A612E742D4D656469614C6973742D6974656D577261703A666F637573207B0D0A2020626F782D736861646F';
wwv_flow_imp.g_varchar2_table(868) := '773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D4D656469614C6973742D6974656D57726170207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D4D656469614C6973742D6261646765207B0D';
wwv_flow_imp.g_varchar2_table(869) := '0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D4D656469614C6973742D62616467652C0D0A2E742D4D656469614C6973742D64657363207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(870) := '723A20236232623262323B0D0A7D0D0A2E742D4D656469614C6973742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656469614C6973';
wwv_flow_imp.g_varchar2_table(871) := '742D2D636F6C73207B0D0A2020626F782D736861646F773A202D317078202D31707820302030202333643435346220696E7365743B0D0A7D0D0A2E742D4D656469614C6973742D2D636F6C73202E742D4D656469614C6973742D6974656D3A6265666F72';
wwv_flow_imp.g_varchar2_table(872) := '652C0D0A2E742D4D656469614C6973742D2D636F6C73202E742D4D656469614C6973742D6974656D3A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233339336634353B0D0A7D0D0A2E612D4D656E752E742D4D6567614D656E';
wwv_flow_imp.g_varchar2_table(873) := '75202E612D4D656E752D6974656D2E69732D666F63757365642C0D0A2E612D4D656E752E742D4D6567614D656E75202E612D4D656E752D6974656D2E69732D657870616E646564207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73';
wwv_flow_imp.g_varchar2_table(874) := '706172656E743B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D4D6567614D656E752D6974656D426F64792E69732D666F6375736564202E742D4D6567614D656E752D6C6162656C2C0D0A2E742D4D6567614D656E752D6974656D42';
wwv_flow_imp.g_varchar2_table(875) := '6F64793A686F766572202E742D4D6567614D656E752D6C6162656C207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E742D4D6567614D656E752D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433';
wwv_flow_imp.g_varchar2_table(876) := '323B0D0A2020636F6C6F723A20236438643864383B0D0A7D0D0A2E742D4D6567614D656E752D2D6C61796F7574537461636B6564202E742D4D6567614D656E752D6974656D2D2D746F70202B202E742D4D6567614D656E752D6974656D2D2D746F70207B';
wwv_flow_imp.g_varchar2_table(877) := '0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E612D4D656E752D636F6E74656E74207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(878) := '6B67726F756E642D636F6C6F723A20233232323632393B0D0A2020626F726465722D77696474683A20303B0D0A2020626F782D736861646F773A2030203870782031367078207267626128302C20302C20302C20302E3235292C20302030203020317078';
wwv_flow_imp.g_varchar2_table(879) := '2072676261283235352C203235352C203235352C20302E31293B0D0A202070616464696E673A2038707820303B0D0A7D0D0A2E612D4D656E752D636F6E74656E74202E612D4D656E752D7363726F6C6C42746E2D2D646F776E2C0D0A2E612D4D656E752D';
wwv_flow_imp.g_varchar2_table(880) := '636F6E74656E74202E612D4D656E752D7363726F6C6C42746E2D2D7570207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433323B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E612D4D656E75207B0D0A20206D69';
wwv_flow_imp.g_varchar2_table(881) := '6E2D77696474683A2031363070783B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D207B0D0A20206C696E652D6865696768743A20333670783B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E612D4D656E75202E612D4D';
wwv_flow_imp.g_varchar2_table(882) := '656E752D6974656D203E202E612D4D656E752D696E6E6572202E612D4D656E752D616363656C2C0D0A2E612D4D656E75202E612D4D656E752D6974656D203E202E612D4D656E752D696E6E6572202E612D4D656E752D7375624D656E75436F6C207B0D0A';
wwv_flow_imp.g_varchar2_table(883) := '20206F7061636974793A20302E38353B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D666F63757365642C0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D657870616E646564207B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(884) := '236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564207B0D0A2020636F6C6F723A2072';
wwv_flow_imp.g_varchar2_table(885) := '676261283235342C203235342C203235342C20302E35293B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F637573';
wwv_flow_imp.g_varchar2_table(886) := '6564203E202E612D4D656E752D696E6E6572202E612D4D656E752D616363656C207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D202E612D4D656E752D7375624D656E75436F6C207B0D0A20';
wwv_flow_imp.g_varchar2_table(887) := '206865696768743A20333670783B0D0A202070616464696E673A203130707820347078203130707820303B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D202E612D4D656E752D737461747573436F6C207B0D0A202070616464696E673A';
wwv_flow_imp.g_varchar2_table(888) := '2031307078203870783B0D0A7D0D0A2E612D4D656E752D68536570617261746F72207B0D0A2020626F726465722D636F6C6F723A2072676261283235342C203235342C203235342C20302E31293B0D0A20206D617267696E2D746F703A203470783B0D0A';
wwv_flow_imp.g_varchar2_table(889) := '202070616464696E672D746F703A203270783B0D0A202070616464696E672D626F74746F6D3A203270783B0D0A7D0D0A2E752D63616C6C6F75743A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A20';
wwv_flow_imp.g_varchar2_table(890) := '20626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E612D4D656E754261722D6C6162656C207B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A20';
wwv_flow_imp.g_varchar2_table(891) := '20666F6E742D73697A653A20312E3472656D3B0D0A20206C696E652D6865696768743A20312E3672656D3B0D0A202070616464696E673A20313270783B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A2020666C65782D67726F77';
wwv_flow_imp.g_varchar2_table(892) := '3A20313B0D0A7D0D0A2E612D4D656E754261722D6C6162656C3A686F766572207B0D0A20206261636B67726F756E642D636C69703A2070616464696E672D626F783B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A2E612D';
wwv_flow_imp.g_varchar2_table(893) := '4D656E754261722D6C6162656C202B202E612D4D656E752D7375624D656E75436F6C207B0D0A2020666C65782D736872696E6B3A20303B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A20206C696E652D6865696768743A20313B0D0A7D';
wwv_flow_imp.g_varchar2_table(894) := '0D0A2E612D4D656E754261722D6974656D207B0D0A2020646973706C61793A20666C65783B0D0A2020666C6F61743A206C6566743B0D0A202070616464696E673A20303B0D0A2020626F726465722D77696474683A2030203170783B0D0A2020626F782D';
wwv_flow_imp.g_varchar2_table(895) := '736861646F773A206E6F6E653B0D0A20206D617267696E2D6C6566743A20303B0D0A20206261636B67726F756E642D636C69703A20636F6E74656E742D626F783B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D6974656D207B0D0A2020666C';
wwv_flow_imp.g_varchar2_table(896) := '6F61743A2072696768743B0D0A7D0D0A2E612D4D656E754261722D6974656D2E69732D657870616E646564207B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A2E612D4D656E754261722D6974656D3A686F766572207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(897) := '726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E612D4D656E754261722D6974656D3A66697273742D6368696C64207B0D0A2020626F726465722D6C6566742D77696474683A20303B0D0A7D0D0A2E752D52544C202E612D4D';
wwv_flow_imp.g_varchar2_table(898) := '656E754261722D6974656D3A66697273742D6368696C64207B0D0A2020626F726465722D72696768742D77696474683A20303B0D0A2020626F726465722D6C6566742D77696474683A203170783B0D0A7D0D0A2E612D4D656E754261722D6974656D2E69';
wwv_flow_imp.g_varchar2_table(899) := '732D666F6375736564207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74202E612D4D656E754261722D6C6162656C207B0D0A2020666F6E742D77656967';
wwv_flow_imp.g_varchar2_table(900) := '68743A20626F6C643B0D0A7D0D0A2E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C2C0D0A2E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75';
wwv_flow_imp.g_varchar2_table(901) := '436F6C207B0D0A2020626F726465722D77696474683A20303B0D0A202070616464696E673A20302031327078203020303B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C2C0D0A';
wwv_flow_imp.g_varchar2_table(902) := '2E752D52544C202E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C207B0D0A202070616464696E672D72696768743A20303B0D0A202070616464696E672D6C6566743A203132';
wwv_flow_imp.g_varchar2_table(903) := '70783B0D0A2020626F726465722D72696768743A20302021696D706F7274616E743B0D0A7D0D0A2E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020626F726465722D72616469';
wwv_flow_imp.g_varchar2_table(904) := '75733A2031322E35253B0D0A7D0D0A2E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E3A6265666F7265207B0D0A2020636F6E74656E743A20275C65306332273B0D0A7D0D0A2E612D4D656E';
wwv_flow_imp.g_varchar2_table(905) := '754261722D6974656D203E20627574746F6E202B202E612D4D656E752D7375624D656E75436F6C207B0D0A20206D617267696E2D6C6566743A202D3670783B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D6974656D203E20627574746F6E20';
wwv_flow_imp.g_varchar2_table(906) := '2B202E612D4D656E752D7375624D656E75436F6C207B0D0A20206D617267696E2D6C6566743A20303B0D0A20206D617267696E2D72696768743A202D3670783B0D0A7D0D0A2E742D4865616465722D6E61762D6C697374207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(907) := '756E642D636F6C6F723A20233333336434363B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6E6176202E742D4D656E';
wwv_flow_imp.g_varchar2_table(908) := '752D6261646765207B0D0A202070616464696E673A2030203670783B0D0A2020666F6E742D73697A653A20313170783B0D0A20206C696E652D6865696768743A20696E68657269743B0D0A2020666F6E742D7765696768743A203530303B0D0A20206261';
wwv_flow_imp.g_varchar2_table(909) := '636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A2020766572746963616C2D616C69676E3A20746F703B0D0A20206D6172';
wwv_flow_imp.g_varchar2_table(910) := '67696E2D6C6566743A203470783B0D0A2020626F726465722D7261646975733A20313670783B0D0A7D0D0A2E752D52544C202E742D4865616465722D6E6176202E742D4D656E752D6261646765207B0D0A20206D617267696E2D6C6566743A20303B0D0A';
wwv_flow_imp.g_varchar2_table(911) := '20206D617267696E2D72696768743A203470783B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D207B0D0A2020626F726465722D636F6C6F723A20233433346335333B0D0A7D0D0A2E742D4865616465722D6E6176';
wwv_flow_imp.g_varchar2_table(912) := '202E612D4D656E754261722D6974656D2E69732D666F6375736564207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D';
wwv_flow_imp.g_varchar2_table(913) := '0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D666F6375736564202E612D4D656E754261722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6E6176';
wwv_flow_imp.g_varchar2_table(914) := '202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F63757365642C0D0A2E742D486561';
wwv_flow_imp.g_varchar2_table(915) := '6465722D6E6176202E612D4D656E754261722D6974656D2E69732D657870616E6465642C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E646564207B0D0A20';
wwv_flow_imp.g_varchar2_table(916) := '206261636B67726F756E642D636F6C6F723A20233165323332383B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74202E612D4D656E754261722D6C6162656C2C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(917) := '4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F6375736564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974';
wwv_flow_imp.g_varchar2_table(918) := '656D2E69732D657870616E646564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E646564202E612D4D656E7542';
wwv_flow_imp.g_varchar2_table(919) := '61722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(920) := '6C6F723A2072676261283235352C203235352C203235352C20302E38293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C3A';
wwv_flow_imp.g_varchar2_table(921) := '686F766572202E612D49636F6E2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D666F6375736564203E20627574746F6E202B202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020';
wwv_flow_imp.g_varchar2_table(922) := '6261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E75';
wwv_flow_imp.g_varchar2_table(923) := '2D7375624D656E75436F6C202E612D49636F6E2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F6C3A686F766572202E612D49636F6E207B';
wwv_flow_imp.g_varchar2_table(924) := '0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656E75426172207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(925) := '67726F756E642D636F6C6F723A20233463346535303B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261';
wwv_flow_imp.g_varchar2_table(926) := '722D6974656D207B0D0A2020626F726465722D636F6C6F723A20233565363036323B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D666F6375736564207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(927) := '233534353635383B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74';
wwv_flow_imp.g_varchar2_table(928) := '2E69732D666F63757365642C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D657870616E6465642C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E6973';
wwv_flow_imp.g_varchar2_table(929) := '2D657870616E646564207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74202E612D4D656E754261722D';
wwv_flow_imp.g_varchar2_table(930) := '6C6162656C2C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F6375736564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4D656E75426172202E612D4D656E7542';
wwv_flow_imp.g_varchar2_table(931) := '61722D6974656D2E69732D657870616E646564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E646564202E612D4D656E';
wwv_flow_imp.g_varchar2_table(932) := '754261722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(933) := '6F723A2072676261283235352C203235352C203235352C20302E38293B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C3A686F7665';
wwv_flow_imp.g_varchar2_table(934) := '72202E612D49636F6E2C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D666F6375736564203E20627574746F6E202B202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(935) := '756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F';
wwv_flow_imp.g_varchar2_table(936) := '6C202E612D49636F6E2C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F6C3A686F766572202E612D49636F6E207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(937) := '642D636F6C6F723A20236666666666663B0D0A2020626F726465722D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4E617654616273207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(938) := '20233333336434363B0D0A7D0D0A2E742D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A2020626F782D736861646F773A20696E73';
wwv_flow_imp.g_varchar2_table(939) := '65742031707820302030203020233333336434363B0D0A7D0D0A2E742D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D7468756D623A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233365346135343B0D';
wwv_flow_imp.g_varchar2_table(940) := '0A7D0D0A2E742D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261636B67726F756E643A20233333336434363B0D0A7D0D0A2E742D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D';
wwv_flow_imp.g_varchar2_table(941) := '747261636B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233534363437323B0D0A7D0D0A2E742D4E6176546162732D6974656D207B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F726465722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(942) := '3A20233365346135343B0D0A7D0D0A2E742D4E6176546162732D6974656D3A686F7665722C0D0A2E742D4E6176546162732D6974656D2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233165323332383B0D0A2020';
wwv_flow_imp.g_varchar2_table(943) := '636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4E6176546162732D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233165323332383B0D0A7D0D0A2E742D506F707570';
wwv_flow_imp.g_varchar2_table(944) := '4C4F562D6C696E6B7320613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233431613566663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D506F7075704C4F562D726573756C74735365742074723A68';
wwv_flow_imp.g_varchar2_table(945) := '6F766572207464207B0D0A20206261636B67726F756E642D636F6C6F723A20234543463246422021696D706F7274616E743B0D0A7D0D0A2E742D506F7075704C4F562D726573756C74735365742074723A6E74682D6368696C6428326E29207464207B0D';
wwv_flow_imp.g_varchar2_table(946) := '0A20206261636B67726F756E642D636F6C6F723A20234641464146413B0D0A7D0D0A2E742D506F7075704C4F562D726573756C74735365742D6C696E6B2C0D0A2E75692D7769646765742D636F6E74656E7420612E742D506F7075704C4F562D72657375';
wwv_flow_imp.g_varchar2_table(947) := '6C74735365742D6C696E6B207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E742D506167652D2D706F7075704C4F56207B0D0A20206261636B67726F756E642D636F6C6F723A20234646463B0D0A7D0D0A2E742D506F7075704C4F562D';
wwv_flow_imp.g_varchar2_table(948) := '616374696F6E73207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033353B0D0A2020626F782D736861646F773A2030202D31707820302072676261283235352C203235352C203235352C20302E31352920696E7365743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(949) := '0A2E742D426F6479202E742D506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20236566656665663B0D0A7D0D0A2E742D426F64792D7469746C65202E742D506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(950) := '236637663766373B0D0A7D0D0A2E742D426F64792D696E666F202E742D506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20236637663766373B0D0A7D0D0A2E742D526567696F6E202E742D506F7075704C4F562D6C696E6B732061';
wwv_flow_imp.g_varchar2_table(951) := '2C0D0A2E742D427574746F6E526567696F6E202E742D506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20236535653565353B0D0A7D0D0A2E742D506F7075704C4F562D6C696E6B7320613A686F766572207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(952) := '726F756E642D636F6C6F723A20233734626566663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F6479202E742D506F7075704C4F562D706167696E6174696F6E207B0D0A2020636F6C6F723A20236166616661663B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(953) := '0A2E742D426F64792D7469746C65202E742D506F7075704C4F562D706167696E6174696F6E207B0D0A2020636F6C6F723A20236237623762373B0D0A7D0D0A2E742D426F64792D696E666F202E742D506F7075704C4F562D706167696E6174696F6E207B';
wwv_flow_imp.g_varchar2_table(954) := '0D0A2020636F6C6F723A20236237623762373B0D0A7D0D0A2E742D526567696F6E202E742D506F7075704C4F562D706167696E6174696F6E2C0D0A2E742D427574746F6E526567696F6E202E742D506F7075704C4F562D706167696E6174696F6E207B0D';
wwv_flow_imp.g_varchar2_table(955) := '0A2020636F6C6F723A20236135613561353B0D0A7D0D0A2E612D506F7075704C4F562D736561726368426172207B0D0A202070616464696E673A203870783B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D49636F6E4C6973742D';
wwv_flow_imp.g_varchar2_table(956) := '6974656D207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D49636F6E4C6973742D6974656D3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2023303037';
wwv_flow_imp.g_varchar2_table(957) := '3664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A20302030203020317078202330303639633620696E7365743B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D49636F6E4C6973742D';
wwv_flow_imp.g_varchar2_table(958) := '6974656D3A686F7665722061207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D47562D6C6F61644D6F7265207B0D0A2020626F726465722D746F702D636F6C6F723A2072676261';
wwv_flow_imp.g_varchar2_table(959) := '283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233463346535303B0D0A';
wwv_flow_imp.g_varchar2_table(960) := '2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E3132352920696E7365743B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A686F766572207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(961) := '6F756E642D636F6C6F723A20233635363836613B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E31352920696E7365743B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574';
wwv_flow_imp.g_varchar2_table(962) := '746F6E3A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233732373537373B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233334';
wwv_flow_imp.g_varchar2_table(963) := '333533363B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A6163746976653A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C203020302031707820302072676261';
wwv_flow_imp.g_varchar2_table(964) := '28352C203131342C203230362C20302E3235293B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D6974656D203E207370616E207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(965) := '6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D6974656D2E69732D616374697665203E207370';
wwv_flow_imp.g_varchar2_table(966) := '616E207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D72656D6F7665';
wwv_flow_imp.g_varchar2_table(967) := '207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D72656D6F76653A686F766572207B';
wwv_flow_imp.g_varchar2_table(968) := '0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263682C0D0A2E617065782D6974656D2D';
wwv_flow_imp.g_varchar2_table(969) := '746578742E617065782D6974656D2D706F7075702D6C6F762C0D0A2E617065782D6974656D2D6D756C7469207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233238326333303B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(970) := '726465722D636F6C6F723A20233365343634633B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263683A666F6375732C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C';
wwv_flow_imp.g_varchar2_table(971) := '6F763A666F6375732C0D0A2E617065782D6974656D2D6D756C74693A666F6375732C0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263682E69732D666F63757365642C0D0A2E617065782D6974656D2D746578742E61';
wwv_flow_imp.g_varchar2_table(972) := '7065782D6974656D2D706F7075702D6C6F762E69732D666F63757365642C0D0A2E617065782D6974656D2D6D756C74692E69732D666F6375736564207B0D0A2020636F6C6F723A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(973) := '3A20233131313331342021696D706F7274616E743B0D0A2020626F726465722D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263683A666F63';
wwv_flow_imp.g_varchar2_table(974) := '7573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F763A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D69';
wwv_flow_imp.g_varchar2_table(975) := '74656D2D6D756C74693A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263682E69732D666F6375736564202B202E612D427574746F6E2D2D706F';
wwv_flow_imp.g_varchar2_table(976) := '7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74692E69732D';
wwv_flow_imp.g_varchar2_table(977) := '666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F56207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E75692D6469616C6F67202E75692D6469616C6F672D636F';
wwv_flow_imp.g_varchar2_table(978) := '6E74656E742E612D506F7075704C4F562D6469616C6F67207B0D0A20206261636B67726F756E642D636F6C6F723A20233030303B0D0A7D0D0A2E612D506F7075704C4F562D646F5365617263683A666F637573207B0D0A2020626F782D736861646F773A';
wwv_flow_imp.g_varchar2_table(979) := '20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D506F7075704C4F562D7365617263684261722C0D0A2E612D506F7075704C4F562D636C656172207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267';
wwv_flow_imp.g_varchar2_table(980) := '6261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E612D506F7075704C4F562D636C656172427574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20696E';
wwv_flow_imp.g_varchar2_table(981) := '68657269743B0D0A7D0D0A2E612D506F7075704C4F562D636C656172427574746F6E3A686F766572207B0D0A2020636F6C6F723A20233030303B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D506F7075';
wwv_flow_imp.g_varchar2_table(982) := '704C4F562D636C656172427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D526567696F6E207B0D0A2020626F726465722D636F6C6F723A207267';
wwv_flow_imp.g_varchar2_table(983) := '6261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D526567696F6E2C0D0A2E742D436F6E74656E74426C6F636B2D2D6C696768744247202E742D436F6E74656E74426C6F636B2D626F6479207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(984) := '642D636F6C6F723A20233232323632393B0D0A7D0D0A2E742D426F6479202E6669656C64646174612062207B0D0A2020636F6C6F723A20236566656665663B0D0A7D0D0A2E742D426F64792D7469746C65202E6669656C64646174612062207B0D0A2020';
wwv_flow_imp.g_varchar2_table(985) := '636F6C6F723A20236637663766373B0D0A7D0D0A2E742D426F64792D696E666F202E6669656C64646174612062207B0D0A2020636F6C6F723A20236637663766373B0D0A7D0D0A2E742D526567696F6E202E6669656C646461746120622C0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(986) := '7574746F6E526567696F6E202E6669656C64646174612062207B0D0A2020636F6C6F723A20236535653565353B0D0A7D0D0A2E742D526567696F6E2D686561646572207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235';
wwv_flow_imp.g_varchar2_table(987) := '352C203235352C203235352C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A20233139316331653B0D0A2020636F6C6F723A20236634663466343B0D0A7D0D0A2E742D526567696F6E2D686561646572202E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(988) := '2D2D6E6F55492C0D0A2E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236634663466343B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D526567696F6E2D68656164657220';
wwv_flow_imp.g_varchar2_table(989) := '7B0D0A20206261636B67726F756E643A207472616E73706172656E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D737461636B6564207B0D0A2020626F726465722D7261646975733A20302021696D706F72';
wwv_flow_imp.g_varchar2_table(990) := '74616E743B0D0A7D0D0A2E742D526567696F6E2D2D6E6F426F72646572203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236665666566653B0D';
wwv_flow_imp.g_varchar2_table(991) := '0A7D0D0A2E742D526567696F6E2D2D6E6F426F72646572203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D6E6F426F72646572203E202E742D526567696F6E2D68656164657220';
wwv_flow_imp.g_varchar2_table(992) := '2E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(993) := '3A20233330394644423B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(994) := '2D616363656E7431203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74312E742D526567696F6E2D2D7465';
wwv_flow_imp.g_varchar2_table(995) := '7874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233330394644423B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7432203E202E742D526567696F6E2D686561646572207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(996) := '6B67726F756E642D636F6C6F723A20233133423643463B0D0A2020636F6C6F723A20236534663966643B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7432203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F5549';
wwv_flow_imp.g_varchar2_table(997) := '2C0D0A2E742D526567696F6E2D2D616363656E7432203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236534663966643B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7432';
wwv_flow_imp.g_varchar2_table(998) := '2E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233133423643463B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7433203E202E742D526567696F6E2D6865';
wwv_flow_imp.g_varchar2_table(999) := '61646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642433B0D0A2020636F6C6F723A20236630666366623B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7433203E202E742D526567696F6E2D686561646572202E74';
wwv_flow_imp.g_varchar2_table(1000) := '2D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7433203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236630666366623B0D0A7D0D0A2E742D5265';
wwv_flow_imp.g_varchar2_table(1001) := '67696F6E2D2D616363656E74332E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233245424642433B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7434203E';
wwv_flow_imp.g_varchar2_table(1002) := '202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638353B0D0A2020636F6C6F723A20236630666166363B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7434203E202E742D526567';
wwv_flow_imp.g_varchar2_table(1003) := '696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7434203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A202366306661';
wwv_flow_imp.g_varchar2_table(1004) := '66363B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74342E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233343414638353B0D0A7D0D0A2E742D52656769';
wwv_flow_imp.g_varchar2_table(1005) := '6F6E2D2D616363656E7435203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233831424235463B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363';
wwv_flow_imp.g_varchar2_table(1006) := '656E7435203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7435203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A20';
wwv_flow_imp.g_varchar2_table(1007) := '20636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74352E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A2023383142423546';
wwv_flow_imp.g_varchar2_table(1008) := '3B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7436203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234444444535333B0D0A2020636F6C6F723A20233261326130383B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1009) := '742D526567696F6E2D2D616363656E7436203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7436203E202E742D526567696F6E2D686561646572202E742D42757474';
wwv_flow_imp.g_varchar2_table(1010) := '6F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233261326130383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74362E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A202063';
wwv_flow_imp.g_varchar2_table(1011) := '6F6C6F723A20234444444535333B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7437203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1012) := '3434333330323B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7437203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7437203E202E742D526567696F6E2D68';
wwv_flow_imp.g_varchar2_table(1013) := '6561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74372E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(1014) := '686561646572207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7438203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A2023454438313345';
wwv_flow_imp.g_varchar2_table(1015) := '3B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7438203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743820';
wwv_flow_imp.g_varchar2_table(1016) := '3E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74382E742D526567696F6E2D2D74657874436F6E74656E74';
wwv_flow_imp.g_varchar2_table(1017) := '203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234544383133453B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7439203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1018) := '6F6C6F723A20234539354235343B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7439203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567';
wwv_flow_imp.g_varchar2_table(1019) := '696F6E2D2D616363656E7439203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74392E742D526567696F6E';
wwv_flow_imp.g_varchar2_table(1020) := '2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234539354235343B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743130203E202E742D526567696F6E2D686561646572207B0D0A';
wwv_flow_imp.g_varchar2_table(1021) := '20206261636B67726F756E642D636F6C6F723A20234538354438383B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743130203E202E742D526567696F6E2D686561646572202E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(1022) := '2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743130203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D';
wwv_flow_imp.g_varchar2_table(1023) := '616363656E7431302E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234538354438383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743131203E202E742D';
wwv_flow_imp.g_varchar2_table(1024) := '526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743131203E202E742D526567696F6E';
wwv_flow_imp.g_varchar2_table(1025) := '2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743131203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A2023666666666666';
wwv_flow_imp.g_varchar2_table(1026) := '3B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431312E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234341353839443B0D0A7D0D0A2E742D526567696F';
wwv_flow_imp.g_varchar2_table(1027) := '6E2D2D616363656E743132203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539423B0D0A2020636F6C6F723A20236636663066383B0D0A7D0D0A2E742D526567696F6E2D2D616363';
wwv_flow_imp.g_varchar2_table(1028) := '656E743132203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743132203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D';
wwv_flow_imp.g_varchar2_table(1029) := '0A2020636F6C6F723A20236636663066383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431322E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A2023383534';
wwv_flow_imp.g_varchar2_table(1030) := '4539423B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743133203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233541363841443B0D0A2020636F6C6F723A20236666666666663B0D0A';
wwv_flow_imp.g_varchar2_table(1031) := '7D0D0A2E742D526567696F6E2D2D616363656E743133203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743133203E202E742D526567696F6E2D686561646572202E';
wwv_flow_imp.g_varchar2_table(1032) := '742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431332E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572';
wwv_flow_imp.g_varchar2_table(1033) := '207B0D0A2020636F6C6F723A20233541363841443B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743134203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234146424143353B0D0A2020';
wwv_flow_imp.g_varchar2_table(1034) := '636F6C6F723A20233331336134343B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743134203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743134203E202E';
wwv_flow_imp.g_varchar2_table(1035) := '742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233331336134343B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431342E742D526567696F6E2D2D74657874436F6E74656E74203E';
wwv_flow_imp.g_varchar2_table(1036) := '202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234146424143353B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743135203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(1037) := '6C6F723A20233645383539383B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743135203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567';
wwv_flow_imp.g_varchar2_table(1038) := '696F6E2D2D616363656E743135203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431352E742D52656769';
wwv_flow_imp.g_varchar2_table(1039) := '6F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233645383539383B0D0A7D0D0A2E742D526567696F6E2D626F6479207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1040) := '2E742D526567696F6E2D2D6869646553686F772E69732D636F6C6C6170736564207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D526567696F';
wwv_flow_imp.g_varchar2_table(1041) := '6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A207472';
wwv_flow_imp.g_varchar2_table(1042) := '616E73706172656E743B0D0A7D0D0A2E742D426F64792D73696465202E742D526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D526567696F6E2C0D0A2E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(1043) := '686561646572207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E742D526567696F6E2D2D6E6F4247207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D';
wwv_flow_imp.g_varchar2_table(1044) := '616374696F6E73202E742D526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D627574746F6E207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1045) := '726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E34293B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A2030203020302031';
wwv_flow_imp.g_varchar2_table(1046) := '7078207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D627574746F6E3A686F766572207B0D0A2020626F782D736861646F773A20302030203020317078';
wwv_flow_imp.g_varchar2_table(1047) := '207267626128302C20302C20302C20302E312920696E7365742C20302031707820317078207267626128302C20302C20302C20302E3035293B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A';
wwv_flow_imp.g_varchar2_table(1048) := '7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D627574746F6E3A6163746976652C0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D627574746F6E3A6163746976653A666F637573207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1049) := '6F7061636974793A20313B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365742C20302031707820317078207267626128302C20302C20302C20302E30352920696E7365743B0D';
wwv_flow_imp.g_varchar2_table(1050) := '0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D6E6578742D726567696F6E207B0D0A2020626F726465722D7261';
wwv_flow_imp.g_varchar2_table(1051) := '646975733A2032707820302030203270783B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D70726576696F75732D726567696F6E207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D';
wwv_flow_imp.g_varchar2_table(1052) := '0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D526567696F6E2D6361726F7573656C4E61764974656D2E612D546162732D73656C6563746564202E612D526567696F6E2D6361726F7573656C4C696E6B207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1053) := '6F756E642D636F6C6F723A207267626128302C20302C20302C20302E34293B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D526567696F6E2D6361726F7573656C4E61764974656D2E612D546162732D73656C6563746564202E61';
wwv_flow_imp.g_varchar2_table(1054) := '2D526567696F6E2D6361726F7573656C4C696E6B3A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D526567696F6E2D6361726F757365';
wwv_flow_imp.g_varchar2_table(1055) := '6C4C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A2020626F726465722D7261646975733A20313030253B0D0A2020626F782D736861646F773A203020302030203170782072';
wwv_flow_imp.g_varchar2_table(1056) := '67626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D5265706F72742D63656C6C2C0D0A2E742D5265706F72742D636F6C48656164207B0D0A2020626F726465723A2031707820736F6C696420233339336634353B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1057) := '2E742D5265706F72742D7265706F7274207472202E742D5265706F72742D63656C6C3A6C6173742D6368696C642C0D0A2E742D5265706F72742D7265706F7274207472202E742D5265706F72742D636F6C486561643A6C6173742D6368696C64207B0D0A';
wwv_flow_imp.g_varchar2_table(1058) := '2020626F726465722D72696768743A2031707820736F6C696420233339336634353B0D0A7D0D0A2E752D52544C202E742D5265706F72742D7265706F7274207472202E742D5265706F72742D63656C6C3A6C6173742D6368696C642C0D0A2E752D52544C';
wwv_flow_imp.g_varchar2_table(1059) := '202E742D5265706F72742D7265706F7274207472202E742D5265706F72742D636F6C486561643A6C6173742D6368696C64207B0D0A2020626F726465722D6C6566743A2031707820736F6C696420233339336634353B0D0A7D0D0A2E742D5265706F7274';
wwv_flow_imp.g_varchar2_table(1060) := '2D7265706F72742074723A6C6173742D6368696C64202E742D5265706F72742D63656C6C207B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C696420233339336634353B0D0A7D0D0A2E742D5265706F7274202E69732D737475636B20';
wwv_flow_imp.g_varchar2_table(1061) := '2E742D5265706F72742D636F6C48656164207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612833342C2033382C2034312C20302E3935293B0D0A20202D7765626B69742D6261636B64726F702D66696C7465723A20626C7572283470';
wwv_flow_imp.g_varchar2_table(1062) := '78293B0D0A7D0D0A2E742D526567696F6E2D2D6E6F50616464696E67202E742D5265706F72742D2D686F72697A6F6E74616C426F7264657273202E69732D737475636B202E742D5265706F72742D636F6C486561642C0D0A2E742D5265706F72742D2D69';
wwv_flow_imp.g_varchar2_table(1063) := '6E6C696E65202E69732D737475636B202E742D5265706F72742D636F6C48656164207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3935293B0D0A2020626F726465722D626F74746F6D2D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1064) := '3A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D5265706F72742D2D726F77486967686C69676874202E742D5265706F72742D7265706F72742074723A686F766572202E742D5265706F72742D63656C6C2C0D0A';
wwv_flow_imp.g_varchar2_table(1065) := '2E742D5265706F72742D2D726F77486967686C69676874202E742D5265706F72742D7265706F72742074723A6E74682D6368696C64286F6464293A686F766572202E742D5265706F72742D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1066) := '723A20233236326232662021696D706F7274616E743B0D0A7D0D0A2E742D5265706F72742D2D737461746963526F77436F6C6F7273202E742D5265706F72742D7265706F72742074723A6E74682D6368696C64286F646429202E742D5265706F72742D63';
wwv_flow_imp.g_varchar2_table(1067) := '656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D5265706F72742D2D616C74526F777344656661756C74202E742D5265706F72742D7265706F72742074723A6E74682D6368696C6428';
wwv_flow_imp.g_varchar2_table(1068) := '6F646429202E742D5265706F72742D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D5265706F72742D706167696E6174696F6E546578742062';
wwv_flow_imp.g_varchar2_table(1069) := '2C0D0A2E742D5265706F72742D706167696E6174696F6E5465787420613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D5265706F7274';
wwv_flow_imp.g_varchar2_table(1070) := '2D6C696E6B73207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235';
wwv_flow_imp.g_varchar2_table(1071) := '293B0D0A7D0D0A2E742D536561726368526573756C74732D64657363207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D536561726368526573756C74732D64617465207B0D0A2020636F6C6F723A20236263626362633B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1072) := '0A2E742D536561726368526573756C74732D6D697363207B0D0A2020636F6C6F723A20236263626362633B0D0A7D0D0A2E742D526567696F6E202E742D536561726368526573756C74732D64657363207B0D0A2020636F6C6F723A20236665666566653B';
wwv_flow_imp.g_varchar2_table(1073) := '0D0A7D0D0A2E742D526567696F6E202E742D536561726368526573756C74732D64617465207B0D0A2020636F6C6F723A20236232623262323B0D0A7D0D0A2E742D526567696F6E202E742D536561726368526573756C74732D6D697363207B0D0A202063';
wwv_flow_imp.g_varchar2_table(1074) := '6F6C6F723A20236232623262323B0D0A7D0D0A2E612D53746172526174696E672D7374617273207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E612D53746172526174696E672D73746172';
wwv_flow_imp.g_varchar2_table(1075) := '732E69732D666F6375736564207B0D0A2020626F782D736861646F773A203020302030203170782063757272656E74436F6C6F7220696E7365743B0D0A7D0D0A2E612D53746172526174696E672D73746172732E69732D666F6375736564202E612D5374';
wwv_flow_imp.g_varchar2_table(1076) := '6172526174696E672D73746172732D6667202E612D53746172526174696E672D73746172207B0D0A2020746578742D736861646F773A20302030203270782063757272656E74436F6C6F723B0D0A7D0D0A2E612D47562D63656C6C2E69732D6163746976';
wwv_flow_imp.g_varchar2_table(1077) := '65202E612D53746172526174696E672D73746172732E69732D666F6375736564207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D53746172526174696E672D73746172732D6667207B0D0A2020636F6C6F723A202330303736';
wwv_flow_imp.g_varchar2_table(1078) := '64663B0D0A7D0D0A2E612D53746172526174696E672D76616C7565207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D53746172526174696E672D636C6561723A666F637573207B0D0A2020626F782D736861646F773A20696E7365';
wwv_flow_imp.g_varchar2_table(1079) := '742023303037366466203020302030203170783B0D0A7D0D0A2E612D53746172526174696E672D2D64697361626C6564202E612D53746172526174696E672D73746172732D6667207B0D0A2020636F6C6F723A20696E697469616C3B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(1080) := '5374617475734C6973742D626C6F636B486561646572207B0D0A2020636F6C6F723A20236665666566653B0D0A20206261636B67726F756E642D636F6C6F723A20233139316331653B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267';
wwv_flow_imp.g_varchar2_table(1081) := '6261283235352C203235352C203235352C20302E3035293B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E742D5374617475734C6973742D686561646572546578';
wwv_flow_imp.g_varchar2_table(1082) := '74416C742C0D0A2E742D5374617475734C6973742D617474722C0D0A2E742D5374617475734C6973742D7465787444657363207B0D0A2020636F6C6F723A20236232623262323B0D0A7D0D0A2E742D5374617475734C6973742D6974656D5469746C6520';
wwv_flow_imp.g_varchar2_table(1083) := '7B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D5374617475734C6973742D2D6461746573202E742D5374617475734C6973742D6D61726B6572207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C2030';
wwv_flow_imp.g_varchar2_table(1084) := '2E35293B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20233030303030303B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235';
wwv_flow_imp.g_varchar2_table(1085) := '352C20302E312920696E7365743B0D0A7D0D0A2E742D5374617475734C6973742D2D6461746573202E742D5374617475734C6973742D6D61726B65723A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C20';
wwv_flow_imp.g_varchar2_table(1086) := '3235352C203235352C20302E32293B0D0A2020626F726465722D7261646975733A2032707820327078203020303B0D0A7D0D0A2E742D5374617475734C6973742D2D6461746573202E742D5374617475734C6973742D6974656D2E69732D6E756C6C202E';
wwv_flow_imp.g_varchar2_table(1087) := '742D5374617475734C6973742D6D61726B6572207B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E742D5374617475734C6973742D2D62';
wwv_flow_imp.g_varchar2_table(1088) := '756C6C657473202E742D5374617475734C6973742D6D61726B6572207B0D0A2020626F726465722D7261646975733A20323470783B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B0D0A2020636F6C6F723A20233430343034303B0D';
wwv_flow_imp.g_varchar2_table(1089) := '0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D636F6D706C6574';
wwv_flow_imp.g_varchar2_table(1090) := '65202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233730373037303B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D';
wwv_flow_imp.g_varchar2_table(1091) := '2E69732D64616E676572202E742D5374617475734C6973742D6D61726B65722C0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D6572726F72202E742D5374617475734C6973742D6D';
wwv_flow_imp.g_varchar2_table(1092) := '61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666336233303B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D6F70656E202E742D5374617475';
wwv_flow_imp.g_varchar2_table(1093) := '734C6973742D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233463643936343B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D7761726E696E';
wwv_flow_imp.g_varchar2_table(1094) := '67202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666636330303B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D';
wwv_flow_imp.g_varchar2_table(1095) := '2E69732D6E756C6C202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A2020636F6C6F723A207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(1096) := '20302C20302E3735293B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E742D5374617475734C6973742D6974656D49636F6E207B0D0A20';
wwv_flow_imp.g_varchar2_table(1097) := '20636F6C6F723A2072676261283235352C203235352C203235352C20302E34293B0D0A2020626F782D736861646F773A2030203020302072676261283235352C203235352C203235352C20302E322920696E7365743B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1098) := '2D636F6C6F723A20233030303030303B0D0A7D0D0A2E612D5461626C652E752D5265706F72742074642C0D0A2E612D5461626C652E752D5265706F7274207468207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1099) := '0A2E612D5461626C652E752D5265706F72742E7461626C652D7374726F6B652074642C0D0A2E612D5461626C652E752D5265706F72742E7461626C652D7374726F6B65207468207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C20';
wwv_flow_imp.g_varchar2_table(1100) := '3235352C203235352C20302E31293B0D0A7D0D0A2E612D5461626C652E752D5265706F72742074723A6E74682D6368696C64286576656E292074642C0D0A2E612D5461626C652E752D5265706F72742074723A6E74682D6368696C64286576656E292074';
wwv_flow_imp.g_varchar2_table(1101) := '685B73636F70653D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A20233030303B0D0A7D0D0A2E612D5461626C652E752D5265706F72742E7461626C652D7374726970652074723A6E74682D6368696C64286576656E29207464';
wwv_flow_imp.g_varchar2_table(1102) := '2C0D0A2E612D5461626C652E752D5265706F72742E7461626C652D7374726970652074723A6E74682D6368696C64286576656E292074685B73636F70653D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128323535';
wwv_flow_imp.g_varchar2_table(1103) := '2C203235352C203235352C20302E303235293B0D0A7D0D0A406D6564696120286D61782D77696474683A20353630707829207B0D0A20202E612D5461626C652D2D7265666C6F772E75692D726573706F6E736976652074642C0D0A20202E612D5461626C';
wwv_flow_imp.g_varchar2_table(1104) := '652D2D7265666C6F772E75692D726573706F6E73697665207468207B0D0A20202020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A20207D0D0A7D0D0A2E752D5265706F7274';
wwv_flow_imp.g_varchar2_table(1105) := '202E752D5265706F72742D6865616465722C0D0A2E752D5265706F7274207468207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A2020636F6C6F723A20236666663B0D';
wwv_flow_imp.g_varchar2_table(1106) := '0A7D0D0A2E752D5265706F72742074685B73636F70653D22726F7767726F7570225D207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A2E752D5265706F72742074';
wwv_flow_imp.g_varchar2_table(1107) := '685B73636F70653D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A20233030303B0D0A7D0D0A2E752D5265706F7274207464207B0D0A2020636F6C6F723A20236666663B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1108) := '233030303B0D0A7D0D0A2E752D5265706F72742074723A6E74682D6368696C64286576656E292074642C0D0A2E752D5265706F72742074723A6E74682D6368696C64286576656E292074685B73636F70653D22726F77225D207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1109) := '6F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A7D0D0A2E752D5265706F72742074642C0D0A2E752D5265706F7274207468207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C';
wwv_flow_imp.g_varchar2_table(1110) := '203235352C203235352C20302E31293B0D0A7D0D0A2E752D5265706F72742D2D73746174696342472074723A6E74682D6368696C64286576656E292074642C0D0A2E752D5265706F72742D2D73746174696342472074723A6E74682D6368696C64286576';
wwv_flow_imp.g_varchar2_table(1111) := '656E292074685B73636F70653D22726F77225D207B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6974656D2E';
wwv_flow_imp.g_varchar2_table(1112) := '69732D616374697665202E742D546162732D6C696E6B207B0D0A2020626F782D736861646F773A2030202D3270782030202330303736646620696E7365743B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6C696E6B3A666F63';
wwv_flow_imp.g_varchar2_table(1113) := '7573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D546162732D2D70696C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233163316632323B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1114) := '726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20';
wwv_flow_imp.g_varchar2_table(1115) := '302E3035293B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D49636F6E207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20236665';
wwv_flow_imp.g_varchar2_table(1116) := '666566653B0D0A2020626F726465722D6C6566742D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E752D52544C202E742D546162732D2D70696C6C202E742D546162732D6C696E6B207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(1117) := '6465722D72696768742D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1118) := '723A20233232323632393B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6C696E6B3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D5461';
wwv_flow_imp.g_varchar2_table(1119) := '62732D2D70696C6C202E742D546162732D6C696E6B3A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20';
wwv_flow_imp.g_varchar2_table(1120) := '302E30352920696E7365743B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6974656D3A66697273742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D7261646975733A203270782030203020327078';
wwv_flow_imp.g_varchar2_table(1121) := '3B0D0A7D0D0A2E752D52544C202E742D546162732D2D70696C6C202E742D546162732D6974656D3A66697273742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D';
wwv_flow_imp.g_varchar2_table(1122) := '0D0A2E742D546162732D2D70696C6C202E742D546162732D6974656D3A6C6173742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D72696768742D636F6C6F723A2072676261283235352C203235352C203235352C20302E';
wwv_flow_imp.g_varchar2_table(1123) := '31293B0D0A7D0D0A2E752D52544C202E742D546162732D2D70696C6C202E742D546162732D6974656D3A6C6173742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D6C6566742D636F6C6F723A2072676261283235352C20';
wwv_flow_imp.g_varchar2_table(1124) := '3235352C203235352C20302E31293B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6974656D2E69732D616374697665202E742D546162732D6C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A2023323232363239';
wwv_flow_imp.g_varchar2_table(1125) := '3B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D49636F6E207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(1126) := '6666663B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E303235293B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1127) := '742D546162732D2D73696D706C65202E742D546162732D6C696E6B3A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E742D426F6479202E742D';
wwv_flow_imp.g_varchar2_table(1128) := '546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D7469746C65202E742D546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A202063';
wwv_flow_imp.g_varchar2_table(1129) := '6F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E742D546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E617065782D726473202E617065782D72';
wwv_flow_imp.g_varchar2_table(1130) := '64732D73656C6563746564207370616E207B0D0A2020626F782D736861646F773A2030202D3270782030202330303736646620696E7365743B0D0A7D0D0A2E617065782D72647320613A666F637573207B0D0A2020626F782D736861646F773A20302030';
wwv_flow_imp.g_varchar2_table(1131) := '203020317078202330303736646620696E7365743B0D0A7D0D0A2E617065782D7264732061207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D7469746C65202E617065782D72647320612C0D0A2E742D426F64792D69';
wwv_flow_imp.g_varchar2_table(1132) := '6E666F202E617065782D7264732061207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E617065782D7264732061207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E617065782D72647320613A';
wwv_flow_imp.g_varchar2_table(1133) := '686F766572207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E617065782D726473202E617065782D7264732D73656C65637465642061207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A2E617065782D7264732D686F76';
wwv_flow_imp.g_varchar2_table(1134) := '65722E6C6566742061207B0D0A20206261636B67726F756E643A202D7765626B69742D6C696E6561722D6772616469656E74286C6566742C2023333233383364203530252C2072676261283235352C203235352C203235352C2030292031303025293B0D';
wwv_flow_imp.g_varchar2_table(1135) := '0A20206261636B67726F756E643A206C696E6561722D6772616469656E7428746F2072696768742C2023333233383364203530252C2072676261283235352C203235352C203235352C2030292031303025293B0D0A7D0D0A2E617065782D7264732D686F';
wwv_flow_imp.g_varchar2_table(1136) := '7665722E72696768742061207B0D0A20206261636B67726F756E643A202D7765626B69742D6C696E6561722D6772616469656E74286C6566742C20233332333833642030252C2072676261283235352C203235352C203235352C2030292031252C202333';
wwv_flow_imp.g_varchar2_table(1137) := '323338336420353025293B0D0A20206261636B67726F756E643A206C696E6561722D6772616469656E7428746F2072696768742C20233332333833642030252C2072676261283235352C203235352C203235352C2030292031252C202333323338336420';
wwv_flow_imp.g_varchar2_table(1138) := '353025293B0D0A7D0D0A2E617065782D7264732D6974656D2D2D68696E742061207370616E207B0D0A2020626F782D736861646F773A2030202D32707820302072676261283235352C203235352C203235352C20302E322920696E7365743B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1139) := '2E766572746963616C2D726473202E617065782D726473202E617065782D7264732D73656C6563746564207370616E2C0D0A2E742D426F64792D73696465202E617065782D726473202E617065782D7264732D73656C6563746564207370616E207B0D0A';
wwv_flow_imp.g_varchar2_table(1140) := '2020626F782D736861646F773A2034707820302030202330303736646620696E7365743B0D0A7D0D0A2E752D52544C202E766572746963616C2D726473202E617065782D726473202E617065782D7264732D73656C6563746564207370616E2C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1141) := '2D52544C202E742D426F64792D73696465202E617065782D726473202E617065782D7264732D73656C6563746564207370616E207B0D0A2020626F782D736861646F773A202D34707820302030202330303736646620696E7365743B0D0A7D0D0A2E612D';
wwv_flow_imp.g_varchar2_table(1142) := '546167436C6F75642D6C696E6B207B0D0A2020626F726465722D636F6C6F723A20233264333333373B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E643A20233236326232663B0D0A20207472616E73697469';
wwv_flow_imp.g_varchar2_table(1143) := '6F6E3A206261636B67726F756E642D636F6C6F7220302E32732C20626F726465722D636F6C6F7220302E32732C20626F782D736861646F7720302E32732C20636F6C6F7220302E32733B0D0A2020636F6C6F723A20233363613366663B0D0A7D0D0A2E61';
wwv_flow_imp.g_varchar2_table(1144) := '2D546167436C6F75642D6C696E6B207370616E207B0D0A20207472616E736974696F6E3A20636F6C6F7220302E32733B0D0A7D0D0A2E612D546167436C6F75642D6C696E6B3A686F766572207B0D0A2020746578742D6465636F726174696F6E3A206E6F';
wwv_flow_imp.g_varchar2_table(1145) := '6E653B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A20302030203020';
wwv_flow_imp.g_varchar2_table(1146) := '327078202330303736646620696E7365743B0D0A7D0D0A2E612D546167436C6F75642D6C696E6B3A686F766572207370616E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D546167436C6F75642D636F756E74207B0D0A202063';
wwv_flow_imp.g_varchar2_table(1147) := '6F6C6F723A20236266626662663B0D0A2020666F6E742D7765696768743A203530303B0D0A7D0D0A2E742D54696D656C696E65207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D54696D656C696E652D6974656D207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1148) := '6F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D54696D656C696E652D757365726E616D652C0D0A2E742D54696D656C696E652D646174652C0D0A2E742D54696D656C';
wwv_flow_imp.g_varchar2_table(1149) := '696E652D64657363207B0D0A2020636F6C6F723A20236232623262323B0D0A7D0D0A2E742D54696D656C696E652D617661746172207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A202366666666';
wwv_flow_imp.g_varchar2_table(1150) := '66663B0D0A7D0D0A2E742D54696D656C696E652D77726170207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A612E742D54696D656C696E652D777261703A686F7665722C0D0A612E742D54696D656C696E652D777261703A666F63757320';
wwv_flow_imp.g_varchar2_table(1151) := '7B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3035293B0D0A2020626F782D736861646F773A20302038707820387078202D347078207267626128302C20302C20302C20302E3035292C';
wwv_flow_imp.g_varchar2_table(1152) := '20302032707820387078202D327078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D54696D656C696E652D74797065207B0D0A20206261636B67726F756E642D636F6C6F723A20233066313131333B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1153) := '6634663466343B0D0A7D0D0A2E742D54696D656C696E652D747970652E69732D6E6577207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D54696D656C696E652D';
wwv_flow_imp.g_varchar2_table(1154) := '747970652E69732D75706461746564207B0D0A20206261636B67726F756E642D636F6C6F723A20233361613266613B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D54696D656C696E652D747970652E69732D72656D6F766564207B0D0A20';
wwv_flow_imp.g_varchar2_table(1155) := '206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D54696D656C696E652D777261703A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F782D7368';
wwv_flow_imp.g_varchar2_table(1156) := '61646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D54696D656C696E65202B202E742D5265706F72742D706167696E6174696F6E207B0D0A2020626F726465722D746F702D636F6C6F723A2072676261283235';
wwv_flow_imp.g_varchar2_table(1157) := '352C203235352C203235352C20302E31293B0D0A7D0D0A406D6564696120286D696E2D77696474683A20373639707829207B0D0A20202E742D426F64792D6E6176207B0D0A202020206261636B67726F756E642D636F6C6F723A20233333336434363B0D';
wwv_flow_imp.g_varchar2_table(1158) := '0A20207D0D0A7D0D0A2E742D547265654E6176207B0D0A20206261636B67726F756E642D636F6C6F723A20233333336434363B0D0A7D0D0A2E742D50616765426F64792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363';
wwv_flow_imp.g_varchar2_table(1159) := '726F6C6C6261722D7468756D62207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A2020626F782D736861646F773A20696E7365742031707820302030203020233333336434363B0D0A7D0D0A2E742D50616765426F64';
wwv_flow_imp.g_varchar2_table(1160) := '792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D7468756D623A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233365346135343B0D0A7D0D0A2E742D50616765426F64';
wwv_flow_imp.g_varchar2_table(1161) := '792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261636B67726F756E643A20233333336434363B0D0A7D0D0A2E742D50616765426F64792D2D6C6566744E6176202E';
wwv_flow_imp.g_varchar2_table(1162) := '742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D747261636B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233534363437323B0D0A7D0D0A2E742D526567696F6E207B0D0A20200D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(1163) := '2D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E73';
wwv_flow_imp.g_varchar2_table(1164) := '65743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D6375';
wwv_flow_imp.g_varchar2_table(1165) := '7272656E742C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D73656C65637465642C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64';
wwv_flow_imp.g_varchar2_table(1166) := '652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433323B0D0A7D0D0A2E742D526567696F';
wwv_flow_imp.g_varchar2_table(1167) := '6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E';
wwv_flow_imp.g_varchar2_table(1168) := '69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A202332';
wwv_flow_imp.g_varchar2_table(1169) := '32323632393B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2023333033';
wwv_flow_imp.g_varchar2_table(1170) := '3533612021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E612D54726565566965772D746F6767';
wwv_flow_imp.g_varchar2_table(1171) := '6C652C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D746F67676C65207B0D0A2020636F6C6F723A2072676261283235342C203235';
wwv_flow_imp.g_varchar2_table(1172) := '342C203235342C20302E3735293B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E612D54726565566965772D746F67676C';
wwv_flow_imp.g_varchar2_table(1173) := '653A686F7665722C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D746F67676C653A686F766572207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1174) := '6665666566652021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1175) := '20236665666566652021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74207B0D0A2020636F6C6F723A20236665666566';
wwv_flow_imp.g_varchar2_table(1176) := '653B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66612C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F';
wwv_flow_imp.g_varchar2_table(1177) := '704C6576656C202E612D54726565566965772D636F6E74656E74202E612D49636F6E207B0D0A2020636F6C6F723A2072676261283235342C203235342C203235342C20302E3935293B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(1178) := '6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66613A6265666F72652C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E';
wwv_flow_imp.g_varchar2_table(1179) := '74656E74202E612D49636F6E3A6265666F7265207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E';
wwv_flow_imp.g_varchar2_table(1180) := '742E69732D686F766572202E66612C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E66612C0D0A2E742D52';
wwv_flow_imp.g_varchar2_table(1181) := '6567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572202E612D49636F6E2C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D';
wwv_flow_imp.g_varchar2_table(1182) := '746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E612D49636F6E207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(1183) := '6E6F64652D2D746F704C6576656C202E612D54726565566965772D6C6162656C207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D5472';
wwv_flow_imp.g_varchar2_table(1184) := '6565566965772D636F6E74656E742E69732D63757272656E742C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D73656C65637465642C0D0A2E';
wwv_flow_imp.g_varchar2_table(1185) := '742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(1186) := '526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C65207B0D0A2020636F6C6F723A2072676261283235342C203235342C203235342C20302E3735293B0D0A7D0D0A2E742D52';
wwv_flow_imp.g_varchar2_table(1187) := '6567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C653A686F766572207B0D0A2020636F6C6F723A20236665666566652021696D706F7274616E743B0D0A7D0D0A2E742D526567';
wwv_flow_imp.g_varchar2_table(1188) := '696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772E69732D73656C65637465642C0D0A2E742D526567696F6E202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(1189) := '6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A20206261636B67726F756E642D636F6C6F723A20233239326433323B0D0A7D0D0A2E742D5472';
wwv_flow_imp.g_varchar2_table(1190) := '65654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E736574';
wwv_flow_imp.g_varchar2_table(1191) := '3B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D637572';
wwv_flow_imp.g_varchar2_table(1192) := '72656E742C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D73656C65637465642C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F';
wwv_flow_imp.g_varchar2_table(1193) := '64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A7D0D0A2E742D54726565';
wwv_flow_imp.g_varchar2_table(1194) := '4E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576';
wwv_flow_imp.g_varchar2_table(1195) := '656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1196) := '3A20233165323332383B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1197) := '20233262333333612021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E612D54726565566965';
wwv_flow_imp.g_varchar2_table(1198) := '772D746F67676C652C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D746F67676C65207B0D0A2020636F6C6F723A207267626128';
wwv_flow_imp.g_varchar2_table(1199) := '3235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E612D547265655669';
wwv_flow_imp.g_varchar2_table(1200) := '65772D746F67676C653A686F7665722C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D746F67676C653A686F766572207B0D0A20';
wwv_flow_imp.g_varchar2_table(1201) := '20636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572207B';
wwv_flow_imp.g_varchar2_table(1202) := '0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74207B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(1203) := '6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66612C0D0A2E742D547265654E6176202E612D54726565';
wwv_flow_imp.g_varchar2_table(1204) := '566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E612D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F6465';
wwv_flow_imp.g_varchar2_table(1205) := '2D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66613A6265666F72652C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E';
wwv_flow_imp.g_varchar2_table(1206) := '74202E612D49636F6E3A6265666F7265207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E';
wwv_flow_imp.g_varchar2_table(1207) := '69732D686F766572202E66612C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E66612C0D0A2E742D5472';
wwv_flow_imp.g_varchar2_table(1208) := '65654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572202E612D49636F6E2C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D';
wwv_flow_imp.g_varchar2_table(1209) := '2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E612D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965';
wwv_flow_imp.g_varchar2_table(1210) := '772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D6C6162656C207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E61';
wwv_flow_imp.g_varchar2_table(1211) := '2D54726565566965772D636F6E74656E742E69732D63757272656E742C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D73656C6563746564';
wwv_flow_imp.g_varchar2_table(1212) := '2C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70207B0D0A2020636F6C6F723A20236666666666663B0D0A7D';
wwv_flow_imp.g_varchar2_table(1213) := '0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C65207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A7D';
wwv_flow_imp.g_varchar2_table(1214) := '0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C653A686F766572207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1215) := '0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D636F6E74656E74202E66612C0D0A2E742D547265654E6176202E612D547265655669';
wwv_flow_imp.g_varchar2_table(1216) := '65772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D636F6E74656E74202E612D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D';
wwv_flow_imp.g_varchar2_table(1217) := '54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D636F6E74656E74207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E6A732D6E6176436F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(1218) := '202E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C203E202E612D54726565566965772D636F6E74656E74202E612D54726565566965772D6C6162656C202E612D54726565566965772D6261646765207B0D0A';
wwv_flow_imp.g_varchar2_table(1219) := '20206261636B67726F756E643A20233133313631613B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6261646765207B0D0A2020626F782D736861646F773A203020302030203170';
wwv_flow_imp.g_varchar2_table(1220) := '782072676261283235352C203235352C203235352C20302E31293B0D0A2020666F6E742D7765696768743A203430303B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D636F6E74656E742E69732D63757272656E74202E612D5472';
wwv_flow_imp.g_varchar2_table(1221) := '6565566965772D6C6162656C2C0D0A2E742D547265654E6176202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E612D54726565566965772D6C6162656C207B0D0A2020666F6E742D7765696768743A203530';
wwv_flow_imp.g_varchar2_table(1222) := '303B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C207B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C69642072676261283235352C203235352C203235';
wwv_flow_imp.g_varchar2_table(1223) := '352C20302E303735293B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D5472';
wwv_flow_imp.g_varchar2_table(1224) := '65654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F77207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1225) := '6F782D736861646F773A20696E736574202330303736646620347078203020303B0D0A7D0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D547265655669';
wwv_flow_imp.g_varchar2_table(1226) := '65772D726F772E69732D63757272656E742D2D746F702C0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D637572';
wwv_flow_imp.g_varchar2_table(1227) := '72656E742D2D746F70207E20756C202E612D54726565566965772D726F77207B0D0A2020626F782D736861646F773A20696E7365742023303037366466202D347078203020303B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D5472';
wwv_flow_imp.g_varchar2_table(1228) := '6565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D666F63757365642C0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F';
wwv_flow_imp.g_varchar2_table(1229) := '64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F773A20696E73657420';
wwv_flow_imp.g_varchar2_table(1230) := '2330303736646620347078203020302C20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E';
wwv_flow_imp.g_varchar2_table(1231) := '612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D666F63757365642C0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D';
wwv_flow_imp.g_varchar2_table(1232) := '54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F773A20696E7365742023303037366466202D34707820302030';
wwv_flow_imp.g_varchar2_table(1233) := '2C20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D';
wwv_flow_imp.g_varchar2_table(1234) := '0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E6A732D6E6176436F6C6C6170736564202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C203E202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(1235) := '636F6E74656E74202E612D54726565566965772D6C6162656C202E612D54726565566965772D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1236) := '782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172';
wwv_flow_imp.g_varchar2_table(1237) := '656E743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E61762D';
wwv_flow_imp.g_varchar2_table(1238) := '2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1239) := '3A20233030373664663B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C65';
wwv_flow_imp.g_varchar2_table(1240) := '63746564202B202E612D54726565566965772D746F67676C652C0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D637572';
wwv_flow_imp.g_varchar2_table(1241) := '72656E742D2D746F70207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74';
wwv_flow_imp.g_varchar2_table(1242) := '2E69732D63757272656E742D2D746F702E69732D686F766572207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D74';
wwv_flow_imp.g_varchar2_table(1243) := '6F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373965342021696D706F7274616E743B0D0A7D0D0A2E742D54';
wwv_flow_imp.g_varchar2_table(1244) := '7265654E61762D2D7374796C6542202E612D54726565566965772D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A206E';
wwv_flow_imp.g_varchar2_table(1245) := '6F6E653B0D0A7D0D0A2E742D56616C69646174696F6E2D64617465207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D56616C69646174696F6E2D75736572207B0D0A2020636F6C6F723A20236535653565353B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(1246) := '426F64792D616374696F6E73202E742D56616C69646174696F6E2D64617465207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D56616C69646174696F6E2D75736572207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(1247) := '6F723A20236536653665363B0D0A7D0D0A2E742D4469616C6F672D706167652D2D77697A617264207B0D0A2020626F726465723A20233339336634353B0D0A7D0D0A2E742D57697A617264207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1248) := '3232323632393B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A20233339336634353B0D0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E3035';
wwv_flow_imp.g_varchar2_table(1249) := '293B0D0A7D0D0A2E742D57697A617264202E742D57697A6172642D7469746C65207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D57697A617264202E742D57697A6172642D686561646572207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1250) := '2D636F6C6F723A20233236326232663B0D0A2020626F726465722D636F6C6F723A20233332333833643B0D0A7D0D0A2E742D57697A61726453746570732D777261703A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A2023333933';
wwv_flow_imp.g_varchar2_table(1251) := '6634353B0D0A7D0D0A2E742D57697A61726453746570732D73746570202E742D57697A61726453746570732D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233530353936313B0D0A7D0D0A2E742D57697A61726453746570';
wwv_flow_imp.g_varchar2_table(1252) := '732D737465702E69732D636F6D706C657465202E742D57697A61726453746570732D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D57697A61';
wwv_flow_imp.g_varchar2_table(1253) := '726453746570732D737465702E69732D616374697665202E742D57697A61726453746570732D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D57697A61726453746570732D6C616265';
wwv_flow_imp.g_varchar2_table(1254) := '6C207B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A612E742D57697A61726453746570732D777261705B687265665D3A686F766572202E742D57697A61726453746570732D6C6162656C2C0D0A612E742D57697A61726453746570732D77';
wwv_flow_imp.g_varchar2_table(1255) := '7261705B687265665D3A666F637573202E742D57697A61726453746570732D6C6162656C207B0D0A2020636F6C6F723A20233431613566663B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A7D0D0A612E742D57697A';
wwv_flow_imp.g_varchar2_table(1256) := '61726453746570732D777261705B687265665D3A666F637573202E742D57697A61726453746570732D6D61726B6572207B0D0A2020626F782D736861646F773A2030203020302031707820233232323632392C2030203020302032707820233030373664';
wwv_flow_imp.g_varchar2_table(1257) := '662C203020302031707820327078207267626128302C203131382C203232332C20302E3235293B0D0A7D0D0A626F6479202E75692D7769646765742D6F7665726C6179207B0D0A20206261636B67726F756E643A206E6F6E65207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(1258) := '20302C20302E35293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E75692D776964676574207B0D0A2020666F6E742D66616D696C793A202748656C766574696361204E657565272C20275365676F65205549272C2048656C7665746963612C2041';
wwv_flow_imp.g_varchar2_table(1259) := '7269616C2C2073616E732D73657269663B0D0A2020666F6E742D73697A653A20313270783B0D0A7D0D0A2E75692D776964676574202E75692D776964676574207B0D0A2020666F6E742D73697A653A20313270783B0D0A7D0D0A626F6479202E75692D77';
wwv_flow_imp.g_varchar2_table(1260) := '69646765742D636F6E74656E742C0D0A626F6479202E75692D7769646765742E75692D7769646765742D636F6E74656E74207B0D0A2020626F726465722D636F6C6F723A20233334336134303B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1261) := '3232323632393B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A626F6479202E75692D7769646765742D636F6E74656E742061207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A626F6479202E75692D7769646765742D6865';
wwv_flow_imp.g_varchar2_table(1262) := '61646572207B0D0A2020626F726465722D636F6C6F723A20233334336134303B0D0A20206261636B67726F756E642D636F6C6F723A20233139316331653B0D0A2020636F6C6F723A20236634663466343B0D0A7D0D0A626F6479202E75692D7769646765';
wwv_flow_imp.g_varchar2_table(1263) := '742D6865616465722061207B0D0A2020636F6C6F723A20236634663466343B0D0A7D0D0A626F6479202E75692D73746174652D64656661756C742C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6465666175';
wwv_flow_imp.g_varchar2_table(1264) := '6C742C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D64656661756C74207B0D0A20206261636B67726F756E642D636F6C6F723A20233463346535303B0D0A2020636F6C6F723A20236666666666663B0D0A2020';
wwv_flow_imp.g_varchar2_table(1265) := '626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E303132352920696E7365743B0D0A7D0D0A626F6479202E75692D73746174652D64656661756C7420612C0D0A626F6479202E75692D737461';
wwv_flow_imp.g_varchar2_table(1266) := '74652D64656661756C7420613A6C696E6B2C0D0A626F6479202E75692D73746174652D64656661756C7420613A766973697465642C0D0A626F6479202E75692D73746174652D61637469766520612C0D0A626F6479202E75692D73746174652D61637469';
wwv_flow_imp.g_varchar2_table(1267) := '766520613A6C696E6B2C0D0A626F6479202E75692D73746174652D61637469766520613A76697369746564207B0D0A2020636F6C6F723A20233431613566663B0D0A7D0D0A626F6479202E75692D73746174652D6163746976652C0D0A626F6479202E75';
wwv_flow_imp.g_varchar2_table(1268) := '692D7769646765742D636F6E74656E74202E75692D73746174652D6163746976652C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D616374697665207B0D0A2020626F782D736861646F773A2030203020302031';
wwv_flow_imp.g_varchar2_table(1269) := '70782072676261283235352C203235352C203235352C20302E322920696E7365742C20302031707820327078207267626128302C20302C20302C20302E32352920696E7365743B0D0A7D0D0A626F6479202E75692D73746174652D686F7665722C0D0A62';
wwv_flow_imp.g_varchar2_table(1270) := '6F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D686F7665722C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D686F766572207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1271) := '723A20233635363836613B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20302E3035292C203020302030203170782072676261283235352C20323535';
wwv_flow_imp.g_varchar2_table(1272) := '2C203235352C20302E303132352920696E7365743B0D0A7D0D0A626F6479202E75692D73746174652D666F6375732C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D666F6375732C0D0A626F6479202E75692D';
wwv_flow_imp.g_varchar2_table(1273) := '7769646765742D686561646572202E75692D73746174652D666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C203020302031707820327078207267626128302C203131382C20323233';
wwv_flow_imp.g_varchar2_table(1274) := '2C20302E3235292021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A20233635363836613B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D646174657069636B6572202E75692D646174';
wwv_flow_imp.g_varchar2_table(1275) := '657069636B65722D627574746F6E70616E6520627574746F6E3A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C203020302031707820';
wwv_flow_imp.g_varchar2_table(1276) := '327078207267626128302C203131382C203232332C20302E3235292021696D706F7274616E743B0D0A7D0D0A626F6479202E75692D73746174652D686F76657220612C0D0A626F6479202E75692D73746174652D686F76657220613A686F7665722C0D0A';
wwv_flow_imp.g_varchar2_table(1277) := '626F6479202E75692D73746174652D686F76657220613A6C696E6B2C0D0A626F6479202E75692D73746174652D686F76657220613A766973697465642C0D0A626F6479202E75692D73746174652D666F63757320612C0D0A626F6479202E75692D737461';
wwv_flow_imp.g_varchar2_table(1278) := '74652D666F63757320613A686F7665722C0D0A626F6479202E75692D73746174652D666F63757320613A6C696E6B2C0D0A626F6479202E75692D73746174652D666F63757320613A76697369746564207B0D0A2020636F6C6F723A20233431613566663B';
wwv_flow_imp.g_varchar2_table(1279) := '0D0A7D0D0A626F6479202E75692D73746174652D6163746976652C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6163746976652C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73';
wwv_flow_imp.g_varchar2_table(1280) := '746174652D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233334333533363B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D73746174652D686967686C696768742C0D0A626F6479202E';
wwv_flow_imp.g_varchar2_table(1281) := '75692D7769646765742D636F6E74656E74202E75692D73746174652D686967686C696768742C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D686967686C69676874207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1282) := '6F6C6F723A20236466663066663B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D73746174652D686967686C6967687420612C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D7374617465';
wwv_flow_imp.g_varchar2_table(1283) := '2D686967686C6967687420612C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D686967686C696768742061207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D73746174652D';
wwv_flow_imp.g_varchar2_table(1284) := '6572726F722C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6572726F722C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D6572726F72207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1285) := '6F756E642D636F6C6F723A20236634343333363B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D73746174652D6572726F7220612C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D737461';
wwv_flow_imp.g_varchar2_table(1286) := '74652D6572726F7220612C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D6572726F722061207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D73746174652D6572726F722D';
wwv_flow_imp.g_varchar2_table(1287) := '746578742C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6572726F722D746578742C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D6572726F722D74657874207B0D';
wwv_flow_imp.g_varchar2_table(1288) := '0A2020636F6C6F723A20236634343333363B0D0A7D0D0A626F6479202E75692D646174657069636B6572207B0D0A2020626F782D736861646F773A20302032707820367078207267626128302C20302C20302C20302E3035293B0D0A7D0D0A626F647920';
wwv_flow_imp.g_varchar2_table(1289) := '2E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C74207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1290) := '636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742E75692D73746174652D616374';
wwv_flow_imp.g_varchar2_table(1291) := '6976652C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A202063';
wwv_flow_imp.g_varchar2_table(1292) := '6F6C6F723A20236666666666663B0D0A2020666F6E742D7765696768743A20626F6C643B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742E75692D73746174652D6163746976';
wwv_flow_imp.g_varchar2_table(1293) := '652E75692D73746174652D686F7665722C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D6163746976652E75692D73746174652D686F766572207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(1294) := '6B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D6465666175';
wwv_flow_imp.g_varchar2_table(1295) := '6C742E75692D73746174652D686F7665722C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1296) := '233264333333372021696D706F7274616E743B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C743A666F6375732C0D0A626F6479202E75692D646174657069636B657220746420';
wwv_flow_imp.g_varchar2_table(1297) := '612E75692D73746174652D64656661756C743A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C20302030203170782032707820726762';
wwv_flow_imp.g_varchar2_table(1298) := '6128302C203131382C203232332C20302E3235292021696D706F7274616E743B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742E75692D73746174652D686967686C69676874';
wwv_flow_imp.g_varchar2_table(1299) := '2C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D686967686C69676874207B0D0A20206261636B67726F756E642D636F6C6F723A20233334336134303B0D0A202063';
wwv_flow_imp.g_varchar2_table(1300) := '6F6C6F723A20236665666566653B0D0A7D0D0A626F6479202E75692D646174657069636B6572207468207B0D0A2020636F6C6F723A20236266626662663B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261283235352C20323535';
wwv_flow_imp.g_varchar2_table(1301) := '2C203235352C20302E31293B0D0A7D0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D6865616465722C0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D62757474';
wwv_flow_imp.g_varchar2_table(1302) := '6F6E70616E6520627574746F6E2C0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D6E6578742C0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D70726576207B0D';
wwv_flow_imp.g_varchar2_table(1303) := '0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D707265763A6163746976652C0D0A626F6479202E75692D646174657069636B6572202E75692D';
wwv_flow_imp.g_varchar2_table(1304) := '646174657069636B65722D6E6578743A616374697665207B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20302E30352920696E7365742C203020302030203170782072676261283235352C20323535';
wwv_flow_imp.g_varchar2_table(1305) := '2C203235352C20302E303132352920696E7365743B0D0A7D0D0A2E75692D6469616C6F67207B0D0A2020626F782D736861646F773A2030203470782031367078202D347078207267626128302C20302C20302C20302E32292C2030203870782032347078';
wwv_flow_imp.g_varchar2_table(1306) := '2030207267626128302C20302C20302C20302E3135292C203020302030203170782072676261283235352C203235352C203235352C20302E32293B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D7469746C6562617220';
wwv_flow_imp.g_varchar2_table(1307) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233139316331653B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C69642072676261283235352C203235352C203235352C20302E3035293B0D0A7D0D0A626F6479202E75692D';
wwv_flow_imp.g_varchar2_table(1308) := '6469616C6F672E742D4469616C6F672D706167652D2D77697A617264202E75692D6469616C6F672D7469746C65626172207B0D0A20206261636B67726F756E642D636F6C6F723A20233232323632393B0D0A7D0D0A626F6479202E75692D6469616C6F67';
wwv_flow_imp.g_varchar2_table(1309) := '202E75692D6469616C6F672D7469746C65207B0D0A2020636F6C6F723A20236634663466343B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D636F6E74656E742C0D0A2E742D4469616C6F672D70616765207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1310) := '6261636B67726F756E642D636F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D4469616C6F672D2D77697A6172642E75692D6469616C6F672C0D0A2E742D4469616C6F672D2D77697A6172642E7569';
wwv_flow_imp.g_varchar2_table(1311) := '2D6469616C6F67202E75692D6469616C6F672D7469746C656261722C0D0A2E742D4469616C6F672D2D77697A61726420626F6479202E75692D6469616C6F67202E75692D6469616C6F672D636F6E74656E74207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1312) := '6F6C6F723A20233232323632393B0D0A2020636F6C6F723A20236665666566653B0D0A7D0D0A2E742D4469616C6F672D2D77697A6172642E75692D6469616C6F67202E75692D6469616C6F672D7469746C65207B0D0A2020636F6C6F723A202366656665';
wwv_flow_imp.g_varchar2_table(1313) := '66653B0D0A7D0D0A626F6479202E75692D636F726E65722D616C6C207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D746F702C0D0A626F6479202E75692D636F726E65722D6C6566742C';
wwv_flow_imp.g_varchar2_table(1314) := '0D0A626F6479202E75692D636F726E65722D746C207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D746F702C0D0A626F6479202E75692D636F726E65722D726967';
wwv_flow_imp.g_varchar2_table(1315) := '68742C0D0A626F6479202E75692D636F726E65722D7472207B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D636F72';
wwv_flow_imp.g_varchar2_table(1316) := '6E65722D6C6566742C0D0A626F6479202E75692D636F726E65722D626C207B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D626F74746F6D2C0D0A626F6479';
wwv_flow_imp.g_varchar2_table(1317) := '202E75692D636F726E65722D72696768742C0D0A626F6479202E75692D636F726E65722D6272207B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D';
wwv_flow_imp.g_varchar2_table(1318) := '636F726E65722D616C6C207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D746F702C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D6C65';
wwv_flow_imp.g_varchar2_table(1319) := '66742C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D746C207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D746F';
wwv_flow_imp.g_varchar2_table(1320) := '702C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D72696768742C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D7472207B0D0A2020626F726465722D746F702D72696768742D7261646975733A20327078';
wwv_flow_imp.g_varchar2_table(1321) := '3B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D6C6566742C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D';
wwv_flow_imp.g_varchar2_table(1322) := '626C207B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D627574746F6E2E75692D636F';
wwv_flow_imp.g_varchar2_table(1323) := '726E65722D72696768742C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D6272207B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D6469616C6F6720';
wwv_flow_imp.g_varchar2_table(1324) := '2E75692D6469616C6F672D7469746C656261722D636C6F7365207B0D0A2020626F726465722D7261646975733A20313030253B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D627574746F6E70616E65207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1325) := '6F726465722D746F702D636F6C6F723A20233334336134303B0D0A7D0D0A2E752D7761726E696E67207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A2020636F6C6F723A20233434333330';
wwv_flow_imp.g_varchar2_table(1326) := '323B0D0A7D0D0A2E752D7761726E696E672D74657874207B0D0A2020636F6C6F723A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D7761726E696E672D6267207B0D0A20206261636B67726F756E642D636F6C6F723A2023464243';
wwv_flow_imp.g_varchar2_table(1327) := '4534412021696D706F7274616E743B0D0A7D0D0A2E752D7761726E696E672D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D73756363657373207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(1328) := '6B67726F756E642D636F6C6F723A20233342414132432021696D706F7274616E743B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E752D737563636573732D74657874207B0D0A2020636F6C6F723A20233342414132432021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1329) := '743B0D0A7D0D0A2E752D737563636573732D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132432021696D706F7274616E743B0D0A7D0D0A2E752D737563636573732D626F72646572207B0D0A2020626F726465722D636F';
wwv_flow_imp.g_varchar2_table(1330) := '6C6F723A20233342414132432021696D706F7274616E743B0D0A7D0D0A2E752D64616E676572207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333362021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B';
wwv_flow_imp.g_varchar2_table(1331) := '0D0A7D0D0A2E752D64616E6765722D74657874207B0D0A2020636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D0A2E752D64616E6765722D6267207B0D0A20206261636B67726F756E642D636F6C6F723A202366343433333620';
wwv_flow_imp.g_varchar2_table(1332) := '21696D706F7274616E743B0D0A7D0D0A2E752D64616E6765722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D0A2E752D696E666F207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1333) := '636F6C6F723A20233361613266612021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D696E666F2D74657874207B0D0A2020636F6C6F723A20233361613266612021696D706F7274616E743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1334) := '752D696E666F2D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20233361613266612021696D706F7274616E743B0D0A7D0D0A2E752D696E666F2D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233361613266612021';
wwv_flow_imp.g_varchar2_table(1335) := '696D706F7274616E743B0D0A7D0D0A2E752D686F74207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D686F742D7465787420';
wwv_flow_imp.g_varchar2_table(1336) := '7B0D0A2020636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D686F742D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D686F742D';
wwv_flow_imp.g_varchar2_table(1337) := '626F72646572207B0D0A2020626F726465722D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D6E6F726D616C207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333033352021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1338) := '743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D6E6F726D616C2D74657874207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D6E6F726D616C2D6267207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(1339) := '726F756E642D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D6E6F726D616C2D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1340) := '636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644423B0D0A202066696C6C3A20233330394644423B0D0A2020636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(1341) := '66666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D6261';
wwv_flow_imp.g_varchar2_table(1342) := '636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1343) := '73203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233330394644423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F';
wwv_flow_imp.g_varchar2_table(1344) := '6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233330394644423B0D0A20207374726F6B653A2023333039';
wwv_flow_imp.g_varchar2_table(1345) := '4644423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643463B0D0A202066696C6C3A20233133423643463B0D';
wwv_flow_imp.g_varchar2_table(1346) := '0A2020636F6C6F723A20236534663966643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229';
wwv_flow_imp.g_varchar2_table(1347) := '202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D7478';
wwv_flow_imp.g_varchar2_table(1348) := '742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233133423643463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1349) := '6E202B203229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233133423643463B0D0A2020';
wwv_flow_imp.g_varchar2_table(1350) := '7374726F6B653A20233133423643463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642433B0D0A202066696C';
wwv_flow_imp.g_varchar2_table(1351) := '6C3A20233245424642433B0D0A2020636F6C6F723A20236630666366623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1352) := '696C642834356E202B203329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642433B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329';
wwv_flow_imp.g_varchar2_table(1353) := '202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233245424642433B0D0A7D0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1354) := '6E74682D6368696C642834356E202B203329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1355) := '233245424642433B0D0A20207374726F6B653A20233245424642433B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233343';
wwv_flow_imp.g_varchar2_table(1356) := '414638353B0D0A202066696C6C3A20233343414638353B0D0A2020636F6C6F723A20236630666166363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1357) := '7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1358) := '696C642834356E202B203429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233343414638353B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1359) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D626F72646572207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1360) := '726465722D636F6C6F723A20233343414638353B0D0A20207374726F6B653A20233343414638353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F72207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1361) := '642D636F6C6F723A20233831424235463B0D0A202066696C6C3A20233831424235463B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1362) := '62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233831424235463B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1363) := '7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A202338';
wwv_flow_imp.g_varchar2_table(1364) := '31424235463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D626F';
wwv_flow_imp.g_varchar2_table(1365) := '72646572207B0D0A2020626F726465722D636F6C6F723A20233831424235463B0D0A20207374726F6B653A20233831424235463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F72207B0D';
wwv_flow_imp.g_varchar2_table(1366) := '0A20206261636B67726F756E642D636F6C6F723A20234444444535333B0D0A202066696C6C3A20234444444535333B0D0A2020636F6C6F723A20233261326130383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1367) := '3629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234444444535333B';
wwv_flow_imp.g_varchar2_table(1368) := '0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D74657874207B0D';
wwv_flow_imp.g_varchar2_table(1369) := '0A2020636F6C6F723A20234444444535333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629';
wwv_flow_imp.g_varchar2_table(1370) := '202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234444444535333B0D0A20207374726F6B653A20234444444535333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729';
wwv_flow_imp.g_varchar2_table(1371) := '202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A202066696C6C3A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1372) := '6368696C642834356E202B203729202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(1373) := '6F723A20234642434534413B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D63';
wwv_flow_imp.g_varchar2_table(1374) := '6F6C6F722D74657874207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1375) := '696C642834356E202B203729202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234642434534413B0D0A20207374726F6B653A20234642434534413B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1376) := '696C642834356E202B203829202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133453B0D0A202066696C6C3A20234544383133453B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1377) := '6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1378) := '636B67726F756E642D636F6C6F723A20234544383133453B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1379) := '356E202B203829202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234544383133453B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1380) := '7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234544383133453B0D0A20207374726F6B653A20234544383133453B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1381) := '7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235343B0D0A202066696C6C3A20234539354235343B0D0A2020636F6C6F723A20236666666666';
wwv_flow_imp.g_varchar2_table(1382) := '663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D6261636B6772';
wwv_flow_imp.g_varchar2_table(1383) := '6F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1384) := '3A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234539354235343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1385) := '62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234539354235343B0D0A20207374726F6B653A20234539354235343B';
wwv_flow_imp.g_varchar2_table(1386) := '0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438383B0D0A202066696C6C3A20234538354438383B0D0A2020';
wwv_flow_imp.g_varchar2_table(1387) := '636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2031302920';
wwv_flow_imp.g_varchar2_table(1388) := '2E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D7478';
wwv_flow_imp.g_varchar2_table(1389) := '742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234538354438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1390) := '356E202B20313029202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234538354438383B0D';
wwv_flow_imp.g_varchar2_table(1391) := '0A20207374726F6B653A20234538354438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839443B0D0A20';
wwv_flow_imp.g_varchar2_table(1392) := '2066696C6C3A20234341353839443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E';
wwv_flow_imp.g_varchar2_table(1393) := '74682D6368696C642834356E202B20313129202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1394) := '6E202B20313129202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234341353839443B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1395) := '6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D626F72646572207B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(1396) := '65722D636F6C6F723A20234341353839443B0D0A20207374726F6B653A20234341353839443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F72207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1397) := '2D636F6C6F723A20233835344539423B0D0A202066696C6C3A20233835344539423B0D0A2020636F6C6F723A20236636663066383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1398) := '62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539423B0D0A7D0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1399) := '6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1400) := '20233835344539423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C';
wwv_flow_imp.g_varchar2_table(1401) := '6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233835344539423B0D0A20207374726F6B653A20233835344539423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F';
wwv_flow_imp.g_varchar2_table(1402) := '6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233541363841443B0D0A202066696C6C3A20233541363841443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C6428';
wwv_flow_imp.g_varchar2_table(1403) := '34356E202B20313329202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1404) := '233541363841443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C';
wwv_flow_imp.g_varchar2_table(1405) := '6F722D74657874207B0D0A2020636F6C6F723A20233541363841443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D636869';
wwv_flow_imp.g_varchar2_table(1406) := '6C642834356E202B20313329202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233541363841443B0D0A20207374726F6B653A20233541363841443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1407) := '696C642834356E202B20313429202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234146424143353B0D0A202066696C6C3A20234146424143353B0D0A2020636F6C6F723A20233331336134343B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1408) := '6F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20';
wwv_flow_imp.g_varchar2_table(1409) := '206261636B67726F756E642D636F6C6F723A20234146424143353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D636869';
wwv_flow_imp.g_varchar2_table(1410) := '6C642834356E202B20313429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234146424143353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D62642C0D0A2E';
wwv_flow_imp.g_varchar2_table(1411) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234146424143353B0D0A20207374726F6B653A20234146424143353B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1412) := '2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539383B0D0A202066696C6C3A20233645383539383B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1413) := '3A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F';
wwv_flow_imp.g_varchar2_table(1414) := '6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D7478742C0D0A2E';
wwv_flow_imp.g_varchar2_table(1415) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233645383539383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1416) := '313529202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233645383539383B0D0A20207374';
wwv_flow_imp.g_varchar2_table(1417) := '726F6B653A20233645383539383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233539623265323B0D0A202066696C6C';
wwv_flow_imp.g_varchar2_table(1418) := '3A20233539623265323B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1419) := '696C642834356E202B20313629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233539623265323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2031';
wwv_flow_imp.g_varchar2_table(1420) := '3629202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233539623265323B0D0A7D0D0A2E752D636F6C6F727320';
wwv_flow_imp.g_varchar2_table(1421) := '3E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F';
wwv_flow_imp.g_varchar2_table(1422) := '6C6F723A20233539623265323B0D0A20207374726F6B653A20233539623265323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1423) := '723A20233432633564393B0D0A202066696C6C3A20233432633564393B0D0A2020636F6C6F723A20233035313531373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D62672C0D0A';
wwv_flow_imp.g_varchar2_table(1424) := '2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233432633564393B0D0A7D0D0A2E752D636F6C6F7273203E';
wwv_flow_imp.g_varchar2_table(1425) := '203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A2023343263';
wwv_flow_imp.g_varchar2_table(1426) := '3564393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D626F';
wwv_flow_imp.g_varchar2_table(1427) := '72646572207B0D0A2020626F726465722D636F6C6F723A20233432633564393B0D0A20207374726F6B653A20233432633564393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F72207B';
wwv_flow_imp.g_varchar2_table(1428) := '0D0A20206261636B67726F756E642D636F6C6F723A20233538636363393B0D0A202066696C6C3A20233538636363393B0D0A2020636F6C6F723A20233039316331633B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B';
wwv_flow_imp.g_varchar2_table(1429) := '20313829202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A202335386363';
wwv_flow_imp.g_varchar2_table(1430) := '63393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D7465';
wwv_flow_imp.g_varchar2_table(1431) := '7874207B0D0A2020636F6C6F723A20233538636363393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1432) := '6E202B20313829202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233538636363393B0D0A20207374726F6B653A20233538636363393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1433) := '356E202B20313929202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639643B0D0A202066696C6C3A20233633626639643B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273';
wwv_flow_imp.g_varchar2_table(1434) := '203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1435) := '67726F756E642D636F6C6F723A20233633626639643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1436) := '6E202B20313929202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233633626639643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D62642C0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1437) := '6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233633626639643B0D0A20207374726F6B653A20233633626639643B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1438) := '6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233961633937663B0D0A202066696C6C3A20233961633937663B0D0A2020636F6C6F723A20233230';
wwv_flow_imp.g_varchar2_table(1439) := '333331363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D62';
wwv_flow_imp.g_varchar2_table(1440) := '61636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233961633937663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D7478742C0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1441) := '6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233961633937663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E';
wwv_flow_imp.g_varchar2_table(1442) := '752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233961633937663B0D0A20207374726F6B653A';
wwv_flow_imp.g_varchar2_table(1443) := '20233961633937663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236534653537353B0D0A202066696C6C3A20236534';
wwv_flow_imp.g_varchar2_table(1444) := '653537353B0D0A2020636F6C6F723A20233463346330663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1445) := '356E202B20323129202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236534653537353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E75';
wwv_flow_imp.g_varchar2_table(1446) := '2D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236534653537353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74';
wwv_flow_imp.g_varchar2_table(1447) := '682D6368696C642834356E202B20323129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1448) := '236534653537353B0D0A20207374726F6B653A20236534653537353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(1449) := '63643836653B0D0A202066696C6C3A20236663643836653B0D0A2020636F6C6F723A20233639346630323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D62672C0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1450) := '6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236663643836653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E7468';
wwv_flow_imp.g_varchar2_table(1451) := '2D6368696C642834356E202B20323229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236663643836653B0D';
wwv_flow_imp.g_varchar2_table(1452) := '0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D626F7264657220';
wwv_flow_imp.g_varchar2_table(1453) := '7B0D0A2020626F726465722D636F6C6F723A20236663643836653B0D0A20207374726F6B653A20236663643836653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F72207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1454) := '61636B67726F756E642D636F6C6F723A20236631396136353B0D0A202066696C6C3A20236631396136353B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2032332920';
wwv_flow_imp.g_varchar2_table(1455) := '2E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236631396136353B0D0A';
wwv_flow_imp.g_varchar2_table(1456) := '7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D74657874207B0D';
wwv_flow_imp.g_varchar2_table(1457) := '0A2020636F6C6F723A20236631396136353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2032';
wwv_flow_imp.g_varchar2_table(1458) := '3329202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236631396136353B0D0A20207374726F6B653A20236631396136353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1459) := '323429202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376337363B0D0A202066696C6C3A20236564376337363B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E';
wwv_flow_imp.g_varchar2_table(1460) := '74682D6368696C642834356E202B20323429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1461) := '642D636F6C6F723A20236564376337363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2032';
wwv_flow_imp.g_varchar2_table(1462) := '3429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236564376337363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E';
wwv_flow_imp.g_varchar2_table(1463) := '203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376337363B0D0A20207374726F6B653A20236564376337363B0D0A7D0D0A2E752D636F6C6F727320';
wwv_flow_imp.g_varchar2_table(1464) := '3E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461303B0D0A202066696C6C3A20236564376461303B0D0A2020636F6C6F723A20236666666666663B';
wwv_flow_imp.g_varchar2_table(1465) := '0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D6261636B6772';
wwv_flow_imp.g_varchar2_table(1466) := '6F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E';
wwv_flow_imp.g_varchar2_table(1467) := '203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236564376461303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C';
wwv_flow_imp.g_varchar2_table(1468) := '6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376461303B0D0A20207374726F6B653A2023656437';
wwv_flow_imp.g_varchar2_table(1469) := '6461303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962313B0D0A202066696C6C3A20236435373962313B';
wwv_flow_imp.g_varchar2_table(1470) := '0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1471) := '323629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1472) := '722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236435373962313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D636869';
wwv_flow_imp.g_varchar2_table(1473) := '6C642834356E202B20323629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A202364353739';
wwv_flow_imp.g_varchar2_table(1474) := '62313B0D0A20207374726F6B653A20236435373962313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A2023396437316166';
wwv_flow_imp.g_varchar2_table(1475) := '3B0D0A202066696C6C3A20233964373161663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D62672C0D0A2E752D636F6C6F727320';
wwv_flow_imp.g_varchar2_table(1476) := '3E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233964373161663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C';
wwv_flow_imp.g_varchar2_table(1477) := '642834356E202B20323729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233964373161663B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1478) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D626F72646572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1479) := '626F726465722D636F6C6F723A20233964373161663B0D0A20207374726F6B653A20233964373161663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F72207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1480) := '6F756E642D636F6C6F723A20233762383662643B0D0A202066696C6C3A20233762383662643B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F';
wwv_flow_imp.g_varchar2_table(1481) := '6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233762383662643B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(1482) := '2D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D74657874207B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(1483) := '6C6F723A20233762383662643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E75';
wwv_flow_imp.g_varchar2_table(1484) := '2D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233762383662643B0D0A20207374726F6B653A20233762383662643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E';
wwv_flow_imp.g_varchar2_table(1485) := '752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236266633864313B0D0A202066696C6C3A20236266633864313B0D0A2020636F6C6F723A20233364343835343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1486) := '696C642834356E202B20323929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(1487) := '6F723A20236266633864313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E75';
wwv_flow_imp.g_varchar2_table(1488) := '2D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236266633864313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E7468';
wwv_flow_imp.g_varchar2_table(1489) := '2D6368696C642834356E202B20323929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236266633864313B0D0A20207374726F6B653A20236266633864313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74';
wwv_flow_imp.g_varchar2_table(1490) := '682D6368696C642834356E202B20333029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233862396461643B0D0A202066696C6C3A20233862396461643B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1491) := '2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D6261636B67726F756E6420';
wwv_flow_imp.g_varchar2_table(1492) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233862396461643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E7468';
wwv_flow_imp.g_varchar2_table(1493) := '2D6368696C642834356E202B20333029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233862396461643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D6264';
wwv_flow_imp.g_varchar2_table(1494) := '2C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233862396461643B0D0A20207374726F6B653A20233862396461643B0D';
wwv_flow_imp.g_varchar2_table(1495) := '0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363613B0D0A202066696C6C3A20233139386363613B0D0A202063';
wwv_flow_imp.g_varchar2_table(1496) := '6F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E';
wwv_flow_imp.g_varchar2_table(1497) := '752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363613B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D747874';
wwv_flow_imp.g_varchar2_table(1498) := '2C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233139386363613B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1499) := '6E202B20333129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233139386363613B0D0A';
wwv_flow_imp.g_varchar2_table(1500) := '20207374726F6B653A20233139386363613B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562653B0D0A2020';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '66696C6C3A20233032613562653B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74';
wwv_flow_imp.g_varchar2_table(1502) := '682D6368696C642834356E202B20333229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E';
wwv_flow_imp.g_varchar2_table(1503) := '202B20333229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233032613562653B0D0A7D0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1504) := '6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D626F72646572207B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(1505) := '722D636F6C6F723A20233032613562653B0D0A20207374726F6B653A20233032613562653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F72207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1506) := '636F6C6F723A20233138623161653B0D0A202066696C6C3A20233138623161653B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D62';
wwv_flow_imp.g_varchar2_table(1507) := '672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233138623161653B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1508) := '7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1509) := '233138623161653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1510) := '722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233138623161653B0D0A20207374726F6B653A20233138623161653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C';
wwv_flow_imp.g_varchar2_table(1511) := '6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233234613437353B0D0A202066696C6C3A20233234613437353B0D0A2020636F6C6F723A20236566666266373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1512) := '356E202B20333429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1513) := '3234613437353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1514) := '722D74657874207B0D0A2020636F6C6F723A20233234613437353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C';
wwv_flow_imp.g_varchar2_table(1515) := '642834356E202B20333429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233234613437353B0D0A20207374726F6B653A20233234613437353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D636869';
wwv_flow_imp.g_varchar2_table(1516) := '6C642834356E202B20333529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233661616434323B0D0A202066696C6C3A20233661616434323B0D0A2020636F6C6F723A20233063313530363B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1517) := '6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D6261636B67726F756E64207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1518) := '6261636B67726F756E642D636F6C6F723A20233661616434323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C';
wwv_flow_imp.g_varchar2_table(1519) := '642834356E202B20333529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233661616434323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D62642C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1520) := '2D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233661616434323B0D0A20207374726F6B653A20233661616434323B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1521) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133393B0D0A202066696C6C3A20236339636133393B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1522) := '20233264326530343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C';
wwv_flow_imp.g_varchar2_table(1523) := '6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D7478742C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1524) := '2D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236339636133393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2033';
wwv_flow_imp.g_varchar2_table(1525) := '3629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236339636133393B0D0A2020737472';
wwv_flow_imp.g_varchar2_table(1526) := '6F6B653A20236339636133393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236439623133623B0D0A202066696C6C3A';
wwv_flow_imp.g_varchar2_table(1527) := '20236439623133623B0D0A2020636F6C6F723A20233436333430303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D636869';
wwv_flow_imp.g_varchar2_table(1528) := '6C642834356E202B20333729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236439623133623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203337';
wwv_flow_imp.g_varchar2_table(1529) := '29202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236439623133623B0D0A7D0D0A2E752D636F6C6F7273203E';
wwv_flow_imp.g_varchar2_table(1530) := '203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C';
wwv_flow_imp.g_varchar2_table(1531) := '6F723A20236439623133623B0D0A20207374726F6B653A20236439623133623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1532) := '3A20236437366132373B0D0A202066696C6C3A20236437366132373B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D62672C0D0A2E';
wwv_flow_imp.g_varchar2_table(1533) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236437366132373B0D0A7D0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1534) := '3A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A202364373661';
wwv_flow_imp.g_varchar2_table(1535) := '32373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D626F72';
wwv_flow_imp.g_varchar2_table(1536) := '646572207B0D0A2020626F726465722D636F6C6F723A20236437366132373B0D0A20207374726F6B653A20236437366132373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F72207B0D';
wwv_flow_imp.g_varchar2_table(1537) := '0A20206261636B67726F756E642D636F6C6F723A20236432343233623B0D0A202066696C6C3A20236432343233623B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1538) := '333929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236432343233';
wwv_flow_imp.g_varchar2_table(1539) := '623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D746578';
wwv_flow_imp.g_varchar2_table(1540) := '74207B0D0A2020636F6C6F723A20236432343233623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E';
wwv_flow_imp.g_varchar2_table(1541) := '202B20333929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236432343233623B0D0A20207374726F6B653A20236432343233623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1542) := '6E202B20343029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236431343336663B0D0A202066696C6C3A20236431343336663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F727320';
wwv_flow_imp.g_varchar2_table(1543) := '3E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(1544) := '726F756E642D636F6C6F723A20236431343336663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E';
wwv_flow_imp.g_varchar2_table(1545) := '202B20343029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236431343336663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D62642C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1546) := '7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236431343336663B0D0A20207374726F6B653A20236431343336663B0D0A7D0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1547) := '6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236261336438383B0D0A202066696C6C3A20236261336438383B0D0A2020636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(1548) := '6666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D6261';
wwv_flow_imp.g_varchar2_table(1549) := '636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236261336438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1550) := '7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236261336438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E75';
wwv_flow_imp.g_varchar2_table(1551) := '2D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236261336438383B0D0A20207374726F6B653A20';
wwv_flow_imp.g_varchar2_table(1552) := '236261336438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339333B0D0A202066696C6C3A2023373733';
wwv_flow_imp.g_varchar2_table(1553) := '3339333B0D0A2020636F6C6F723A20236636656666393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1554) := '6E202B20343229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D';
wwv_flow_imp.g_varchar2_table(1555) := '636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233737333339333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E7468';
wwv_flow_imp.g_varchar2_table(1556) := '2D6368696C642834356E202B20343229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1557) := '3737333339333B0D0A20207374726F6B653A20233737333339333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233364';
wwv_flow_imp.g_varchar2_table(1558) := '346561333B0D0A202066696C6C3A20233364346561333B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D62672C0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1559) := '6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233364346561333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1560) := '6368696C642834356E202B20343329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233364346561333B0D0A';
wwv_flow_imp.g_varchar2_table(1561) := '7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D626F72646572207B';
wwv_flow_imp.g_varchar2_table(1562) := '0D0A2020626F726465722D636F6C6F723A20233364346561333B0D0A20207374726F6B653A20233364346561333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F72207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1563) := '636B67726F756E642D636F6C6F723A20233863396562303B0D0A202066696C6C3A20233863396562303B0D0A2020636F6C6F723A20233238336134643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E';
wwv_flow_imp.g_varchar2_table(1564) := '752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233863396562303B0D0A7D';
wwv_flow_imp.g_varchar2_table(1565) := '0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D74657874207B0D0A';
wwv_flow_imp.g_varchar2_table(1566) := '2020636F6C6F723A20233863396562303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203434';
wwv_flow_imp.g_varchar2_table(1567) := '29202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233863396562303B0D0A20207374726F6B653A20233863396562303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2034';
wwv_flow_imp.g_varchar2_table(1568) := '3529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233465373339313B0D0A202066696C6C3A20233465373339313B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74';
wwv_flow_imp.g_varchar2_table(1569) := '682D6368696C642834356E202B20343529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1570) := '2D636F6C6F723A20233465373339313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203435';
wwv_flow_imp.g_varchar2_table(1571) := '29202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233465373339313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1572) := '3A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233465373339313B0D0A20207374726F6B653A20233465373339313B0D0A7D0D0A2E752D636F6C6F722D3120';
wwv_flow_imp.g_varchar2_table(1573) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644422021696D706F7274616E743B0D0A202066696C6C3A20233330394644422021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1574) := '3B0D0A7D0D0A2E752D636F6C6F722D312D62672C0D0A2E752D636F6C6F722D312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644422021696D706F7274616E743B0D0A202066696C6C3A2023333039';
wwv_flow_imp.g_varchar2_table(1575) := '4644422021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D312D7478742C0D0A2E752D636F6C6F722D312D74657874207B0D0A2020636F6C6F723A20233330394644422021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D312D';
wwv_flow_imp.g_varchar2_table(1576) := '62642C0D0A2E752D636F6C6F722D312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233330394644422021696D706F7274616E743B0D0A20207374726F6B653A20233330394644422021696D706F7274616E743B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1577) := '636F6C6F722D32207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643462021696D706F7274616E743B0D0A202066696C6C3A20233133423643462021696D706F7274616E743B0D0A2020636F6C6F723A2023653466396664202169';
wwv_flow_imp.g_varchar2_table(1578) := '6D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D322D62672C0D0A2E752D636F6C6F722D322D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643462021696D706F7274616E743B0D0A20206669';
wwv_flow_imp.g_varchar2_table(1579) := '6C6C3A20233133423643462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D322D7478742C0D0A2E752D636F6C6F722D322D74657874207B0D0A2020636F6C6F723A20233133423643462021696D706F7274616E743B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1580) := '636F6C6F722D322D62642C0D0A2E752D636F6C6F722D322D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233133423643462021696D706F7274616E743B0D0A20207374726F6B653A20233133423643462021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1581) := '0D0A7D0D0A2E752D636F6C6F722D33207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642432021696D706F7274616E743B0D0A202066696C6C3A20233245424642432021696D706F7274616E743B0D0A2020636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(1582) := '30666366622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D332D62672C0D0A2E752D636F6C6F722D332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642432021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1583) := '743B0D0A202066696C6C3A20233245424642432021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D332D7478742C0D0A2E752D636F6C6F722D332D74657874207B0D0A2020636F6C6F723A20233245424642432021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1584) := '0D0A7D0D0A2E752D636F6C6F722D332D62642C0D0A2E752D636F6C6F722D332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233245424642432021696D706F7274616E743B0D0A20207374726F6B653A20233245424642432021696D';
wwv_flow_imp.g_varchar2_table(1585) := '706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638352021696D706F7274616E743B0D0A202066696C6C3A20233343414638352021696D706F7274616E743B0D0A202063';
wwv_flow_imp.g_varchar2_table(1586) := '6F6C6F723A20236630666166362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D342D62672C0D0A2E752D636F6C6F722D342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638352021';
wwv_flow_imp.g_varchar2_table(1587) := '696D706F7274616E743B0D0A202066696C6C3A20233343414638352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D342D7478742C0D0A2E752D636F6C6F722D342D74657874207B0D0A2020636F6C6F723A20233343414638352021696D';
wwv_flow_imp.g_varchar2_table(1588) := '706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D342D62642C0D0A2E752D636F6C6F722D342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233343414638352021696D706F7274616E743B0D0A20207374726F6B653A20233343';
wwv_flow_imp.g_varchar2_table(1589) := '414638352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D35207B0D0A20206261636B67726F756E642D636F6C6F723A20233831424235462021696D706F7274616E743B0D0A202066696C6C3A20233831424235462021696D706F727461';
wwv_flow_imp.g_varchar2_table(1590) := '6E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D352D62672C0D0A2E752D636F6C6F722D352D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1591) := '3831424235462021696D706F7274616E743B0D0A202066696C6C3A20233831424235462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D352D7478742C0D0A2E752D636F6C6F722D352D74657874207B0D0A2020636F6C6F723A20233831';
wwv_flow_imp.g_varchar2_table(1592) := '424235462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D352D62642C0D0A2E752D636F6C6F722D352D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233831424235462021696D706F7274616E743B0D0A2020737472';
wwv_flow_imp.g_varchar2_table(1593) := '6F6B653A20233831424235462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D36207B0D0A20206261636B67726F756E642D636F6C6F723A20234444444535332021696D706F7274616E743B0D0A202066696C6C3A202344444445353320';
wwv_flow_imp.g_varchar2_table(1594) := '21696D706F7274616E743B0D0A2020636F6C6F723A20233261326130382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D362D62672C0D0A2E752D636F6C6F722D362D6261636B67726F756E64207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1595) := '636F6C6F723A20234444444535332021696D706F7274616E743B0D0A202066696C6C3A20234444444535332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D362D7478742C0D0A2E752D636F6C6F722D362D74657874207B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(1596) := '6C6F723A20234444444535332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D362D62642C0D0A2E752D636F6C6F722D362D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234444444535332021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1597) := '3B0D0A20207374726F6B653A20234444444535332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D37207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(1598) := '234642434534412021696D706F7274616E743B0D0A2020636F6C6F723A20233434333330322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D372D62672C0D0A2E752D636F6C6F722D372D6261636B67726F756E64207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(1599) := '6B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A202066696C6C3A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D372D7478742C0D0A2E752D636F6C6F722D372D74657874';
wwv_flow_imp.g_varchar2_table(1600) := '207B0D0A2020636F6C6F723A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D372D62642C0D0A2E752D636F6C6F722D372D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023464243453441202169';
wwv_flow_imp.g_varchar2_table(1601) := '6D706F7274616E743B0D0A20207374726F6B653A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D38207B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133452021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1602) := '202066696C6C3A20234544383133452021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D382D62672C0D0A2E752D636F6C6F722D382D6261636B67726F756E6420';
wwv_flow_imp.g_varchar2_table(1603) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133452021696D706F7274616E743B0D0A202066696C6C3A20234544383133452021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D382D7478742C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1604) := '722D382D74657874207B0D0A2020636F6C6F723A20234544383133452021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D382D62642C0D0A2E752D636F6C6F722D382D626F72646572207B0D0A2020626F726465722D636F6C6F723A202345';
wwv_flow_imp.g_varchar2_table(1605) := '44383133452021696D706F7274616E743B0D0A20207374726F6B653A20234544383133452021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D39207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235342021696D706F';
wwv_flow_imp.g_varchar2_table(1606) := '7274616E743B0D0A202066696C6C3A20234539354235342021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D392D62672C0D0A2E752D636F6C6F722D392D626163';
wwv_flow_imp.g_varchar2_table(1607) := '6B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235342021696D706F7274616E743B0D0A202066696C6C3A20234539354235342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D392D7478742C0D';
wwv_flow_imp.g_varchar2_table(1608) := '0A2E752D636F6C6F722D392D74657874207B0D0A2020636F6C6F723A20234539354235342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D392D62642C0D0A2E752D636F6C6F722D392D626F72646572207B0D0A2020626F726465722D63';
wwv_flow_imp.g_varchar2_table(1609) := '6F6C6F723A20234539354235342021696D706F7274616E743B0D0A20207374726F6B653A20234539354235342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3130207B0D0A20206261636B67726F756E642D636F6C6F723A2023453835';
wwv_flow_imp.g_varchar2_table(1610) := '4438382021696D706F7274616E743B0D0A202066696C6C3A20234538354438382021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31302D62672C0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1611) := '6F6C6F722D31302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438382021696D706F7274616E743B0D0A202066696C6C3A20234538354438382021696D706F7274616E743B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1612) := '6C6F722D31302D7478742C0D0A2E752D636F6C6F722D31302D74657874207B0D0A2020636F6C6F723A20234538354438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31302D62642C0D0A2E752D636F6C6F722D31302D626F726465';
wwv_flow_imp.g_varchar2_table(1613) := '72207B0D0A2020626F726465722D636F6C6F723A20234538354438382021696D706F7274616E743B0D0A20207374726F6B653A20234538354438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3131207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(1614) := '756E642D636F6C6F723A20234341353839442021696D706F7274616E743B0D0A202066696C6C3A20234341353839442021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1615) := '6F722D31312D62672C0D0A2E752D636F6C6F722D31312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839442021696D706F7274616E743B0D0A202066696C6C3A20234341353839442021696D706F72';
wwv_flow_imp.g_varchar2_table(1616) := '74616E743B0D0A7D0D0A2E752D636F6C6F722D31312D7478742C0D0A2E752D636F6C6F722D31312D74657874207B0D0A2020636F6C6F723A20234341353839442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31312D62642C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1617) := '2D636F6C6F722D31312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234341353839442021696D706F7274616E743B0D0A20207374726F6B653A20234341353839442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1618) := '3132207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539422021696D706F7274616E743B0D0A202066696C6C3A20233835344539422021696D706F7274616E743B0D0A2020636F6C6F723A20236636663066382021696D706F7274';
wwv_flow_imp.g_varchar2_table(1619) := '616E743B0D0A7D0D0A2E752D636F6C6F722D31322D62672C0D0A2E752D636F6C6F722D31322D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539422021696D706F7274616E743B0D0A202066696C6C3A';
wwv_flow_imp.g_varchar2_table(1620) := '20233835344539422021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31322D7478742C0D0A2E752D636F6C6F722D31322D74657874207B0D0A2020636F6C6F723A20233835344539422021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1621) := '6F6C6F722D31322D62642C0D0A2E752D636F6C6F722D31322D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233835344539422021696D706F7274616E743B0D0A20207374726F6B653A20233835344539422021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1622) := '3B0D0A7D0D0A2E752D636F6C6F722D3133207B0D0A20206261636B67726F756E642D636F6C6F723A20233541363841442021696D706F7274616E743B0D0A202066696C6C3A20233541363841442021696D706F7274616E743B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1623) := '236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31332D62672C0D0A2E752D636F6C6F722D31332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233541363841442021696D706F';
wwv_flow_imp.g_varchar2_table(1624) := '7274616E743B0D0A202066696C6C3A20233541363841442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31332D7478742C0D0A2E752D636F6C6F722D31332D74657874207B0D0A2020636F6C6F723A20233541363841442021696D706F';
wwv_flow_imp.g_varchar2_table(1625) := '7274616E743B0D0A7D0D0A2E752D636F6C6F722D31332D62642C0D0A2E752D636F6C6F722D31332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233541363841442021696D706F7274616E743B0D0A20207374726F6B653A20233541';
wwv_flow_imp.g_varchar2_table(1626) := '363841442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3134207B0D0A20206261636B67726F756E642D636F6C6F723A20234146424143352021696D706F7274616E743B0D0A202066696C6C3A20234146424143352021696D706F7274';
wwv_flow_imp.g_varchar2_table(1627) := '616E743B0D0A2020636F6C6F723A20233331336134342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31342D62672C0D0A2E752D636F6C6F722D31342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1628) := '3A20234146424143352021696D706F7274616E743B0D0A202066696C6C3A20234146424143352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31342D7478742C0D0A2E752D636F6C6F722D31342D74657874207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1629) := '3A20234146424143352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31342D62642C0D0A2E752D636F6C6F722D31342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234146424143352021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1630) := '0D0A20207374726F6B653A20234146424143352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3135207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539382021696D706F7274616E743B0D0A202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(1631) := '233645383539382021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31352D62672C0D0A2E752D636F6C6F722D31352D6261636B67726F756E64207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1632) := '61636B67726F756E642D636F6C6F723A20233645383539382021696D706F7274616E743B0D0A202066696C6C3A20233645383539382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31352D7478742C0D0A2E752D636F6C6F722D31352D';
wwv_flow_imp.g_varchar2_table(1633) := '74657874207B0D0A2020636F6C6F723A20233645383539382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31352D62642C0D0A2E752D636F6C6F722D31352D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023364538';
wwv_flow_imp.g_varchar2_table(1634) := '3539382021696D706F7274616E743B0D0A20207374726F6B653A20233645383539382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3136207B0D0A20206261636B67726F756E642D636F6C6F723A20233539623265322021696D706F72';
wwv_flow_imp.g_varchar2_table(1635) := '74616E743B0D0A202066696C6C3A20233539623265322021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31362D62672C0D0A2E752D636F6C6F722D31362D6261';
wwv_flow_imp.g_varchar2_table(1636) := '636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233539623265322021696D706F7274616E743B0D0A202066696C6C3A20233539623265322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31362D747874';
wwv_flow_imp.g_varchar2_table(1637) := '2C0D0A2E752D636F6C6F722D31362D74657874207B0D0A2020636F6C6F723A20233539623265322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31362D62642C0D0A2E752D636F6C6F722D31362D626F72646572207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(1638) := '6465722D636F6C6F723A20233539623265322021696D706F7274616E743B0D0A20207374726F6B653A20233539623265322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3137207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1639) := '20233432633564392021696D706F7274616E743B0D0A202066696C6C3A20233432633564392021696D706F7274616E743B0D0A2020636F6C6F723A20233035313531372021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31372D62672C0D';
wwv_flow_imp.g_varchar2_table(1640) := '0A2E752D636F6C6F722D31372D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233432633564392021696D706F7274616E743B0D0A202066696C6C3A20233432633564392021696D706F7274616E743B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1641) := '2E752D636F6C6F722D31372D7478742C0D0A2E752D636F6C6F722D31372D74657874207B0D0A2020636F6C6F723A20233432633564392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31372D62642C0D0A2E752D636F6C6F722D31372D';
wwv_flow_imp.g_varchar2_table(1642) := '626F72646572207B0D0A2020626F726465722D636F6C6F723A20233432633564392021696D706F7274616E743B0D0A20207374726F6B653A20233432633564392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3138207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1643) := '636B67726F756E642D636F6C6F723A20233538636363392021696D706F7274616E743B0D0A202066696C6C3A20233538636363392021696D706F7274616E743B0D0A2020636F6C6F723A20233039316331632021696D706F7274616E743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1644) := '752D636F6C6F722D31382D62672C0D0A2E752D636F6C6F722D31382D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233538636363392021696D706F7274616E743B0D0A202066696C6C3A20233538636363392021';
wwv_flow_imp.g_varchar2_table(1645) := '696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31382D7478742C0D0A2E752D636F6C6F722D31382D74657874207B0D0A2020636F6C6F723A20233538636363392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31382D6264';
wwv_flow_imp.g_varchar2_table(1646) := '2C0D0A2E752D636F6C6F722D31382D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233538636363392021696D706F7274616E743B0D0A20207374726F6B653A20233538636363392021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1647) := '6F6C6F722D3139207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639642021696D706F7274616E743B0D0A202066696C6C3A20233633626639642021696D706F7274616E743B0D0A2020636F6C6F723A2023666666666666202169';
wwv_flow_imp.g_varchar2_table(1648) := '6D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31392D62672C0D0A2E752D636F6C6F722D31392D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639642021696D706F7274616E743B0D0A2020';
wwv_flow_imp.g_varchar2_table(1649) := '66696C6C3A20233633626639642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31392D7478742C0D0A2E752D636F6C6F722D31392D74657874207B0D0A2020636F6C6F723A20233633626639642021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1650) := '0A2E752D636F6C6F722D31392D62642C0D0A2E752D636F6C6F722D31392D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233633626639642021696D706F7274616E743B0D0A20207374726F6B653A20233633626639642021696D706F';
wwv_flow_imp.g_varchar2_table(1651) := '7274616E743B0D0A7D0D0A2E752D636F6C6F722D3230207B0D0A20206261636B67726F756E642D636F6C6F723A20233961633937662021696D706F7274616E743B0D0A202066696C6C3A20233961633937662021696D706F7274616E743B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(1652) := '6C6F723A20233230333331362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32302D62672C0D0A2E752D636F6C6F722D32302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A202339616339376620';
wwv_flow_imp.g_varchar2_table(1653) := '21696D706F7274616E743B0D0A202066696C6C3A20233961633937662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32302D7478742C0D0A2E752D636F6C6F722D32302D74657874207B0D0A2020636F6C6F723A202339616339376620';
wwv_flow_imp.g_varchar2_table(1654) := '21696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32302D62642C0D0A2E752D636F6C6F722D32302D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233961633937662021696D706F7274616E743B0D0A20207374726F6B65';
wwv_flow_imp.g_varchar2_table(1655) := '3A20233961633937662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3231207B0D0A20206261636B67726F756E642D636F6C6F723A20236534653537352021696D706F7274616E743B0D0A202066696C6C3A2023653465353735202169';
wwv_flow_imp.g_varchar2_table(1656) := '6D706F7274616E743B0D0A2020636F6C6F723A20233463346330662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32312D62672C0D0A2E752D636F6C6F722D32312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1657) := '636F6C6F723A20236534653537352021696D706F7274616E743B0D0A202066696C6C3A20236534653537352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32312D7478742C0D0A2E752D636F6C6F722D32312D74657874207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1658) := '636F6C6F723A20236534653537352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32312D62642C0D0A2E752D636F6C6F722D32312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236534653537352021696D706F72';
wwv_flow_imp.g_varchar2_table(1659) := '74616E743B0D0A20207374726F6B653A20236534653537352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3232207B0D0A20206261636B67726F756E642D636F6C6F723A20236663643836652021696D706F7274616E743B0D0A202066';
wwv_flow_imp.g_varchar2_table(1660) := '696C6C3A20236663643836652021696D706F7274616E743B0D0A2020636F6C6F723A20233639346630322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32322D62672C0D0A2E752D636F6C6F722D32322D6261636B67726F756E64207B';
wwv_flow_imp.g_varchar2_table(1661) := '0D0A20206261636B67726F756E642D636F6C6F723A20236663643836652021696D706F7274616E743B0D0A202066696C6C3A20236663643836652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32322D7478742C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1662) := '722D32322D74657874207B0D0A2020636F6C6F723A20236663643836652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32322D62642C0D0A2E752D636F6C6F722D32322D626F72646572207B0D0A2020626F726465722D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1663) := '20236663643836652021696D706F7274616E743B0D0A20207374726F6B653A20236663643836652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3233207B0D0A20206261636B67726F756E642D636F6C6F723A20236631396136352021';
wwv_flow_imp.g_varchar2_table(1664) := '696D706F7274616E743B0D0A202066696C6C3A20236631396136352021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32332D62672C0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1665) := '32332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236631396136352021696D706F7274616E743B0D0A202066696C6C3A20236631396136352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32';
wwv_flow_imp.g_varchar2_table(1666) := '332D7478742C0D0A2E752D636F6C6F722D32332D74657874207B0D0A2020636F6C6F723A20236631396136352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32332D62642C0D0A2E752D636F6C6F722D32332D626F72646572207B0D0A';
wwv_flow_imp.g_varchar2_table(1667) := '2020626F726465722D636F6C6F723A20236631396136352021696D706F7274616E743B0D0A20207374726F6B653A20236631396136352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3234207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1668) := '6F6C6F723A20236564376337362021696D706F7274616E743B0D0A202066696C6C3A20236564376337362021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3234';
wwv_flow_imp.g_varchar2_table(1669) := '2D62672C0D0A2E752D636F6C6F722D32342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376337362021696D706F7274616E743B0D0A202066696C6C3A20236564376337362021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1670) := '0D0A7D0D0A2E752D636F6C6F722D32342D7478742C0D0A2E752D636F6C6F722D32342D74657874207B0D0A2020636F6C6F723A20236564376337362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32342D62642C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1671) := '722D32342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376337362021696D706F7274616E743B0D0A20207374726F6B653A20236564376337362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3235207B0D';
wwv_flow_imp.g_varchar2_table(1672) := '0A20206261636B67726F756E642D636F6C6F723A20236564376461302021696D706F7274616E743B0D0A202066696C6C3A20236564376461302021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(1673) := '0A7D0D0A2E752D636F6C6F722D32352D62672C0D0A2E752D636F6C6F722D32352D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461302021696D706F7274616E743B0D0A202066696C6C3A2023656437';
wwv_flow_imp.g_varchar2_table(1674) := '6461302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32352D7478742C0D0A2E752D636F6C6F722D32352D74657874207B0D0A2020636F6C6F723A20236564376461302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1675) := '32352D62642C0D0A2E752D636F6C6F722D32352D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376461302021696D706F7274616E743B0D0A20207374726F6B653A20236564376461302021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1676) := '0A2E752D636F6C6F722D3236207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962312021696D706F7274616E743B0D0A202066696C6C3A20236435373962312021696D706F7274616E743B0D0A2020636F6C6F723A202366666666';
wwv_flow_imp.g_varchar2_table(1677) := '66662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32362D62672C0D0A2E752D636F6C6F722D32362D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962312021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1678) := '3B0D0A202066696C6C3A20236435373962312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32362D7478742C0D0A2E752D636F6C6F722D32362D74657874207B0D0A2020636F6C6F723A20236435373962312021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1679) := '3B0D0A7D0D0A2E752D636F6C6F722D32362D62642C0D0A2E752D636F6C6F722D32362D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236435373962312021696D706F7274616E743B0D0A20207374726F6B653A202364353739623120';
wwv_flow_imp.g_varchar2_table(1680) := '21696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3237207B0D0A20206261636B67726F756E642D636F6C6F723A20233964373161662021696D706F7274616E743B0D0A202066696C6C3A20233964373161662021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(1681) := '0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32372D62672C0D0A2E752D636F6C6F722D32372D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233964';
wwv_flow_imp.g_varchar2_table(1682) := '373161662021696D706F7274616E743B0D0A202066696C6C3A20233964373161662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32372D7478742C0D0A2E752D636F6C6F722D32372D74657874207B0D0A2020636F6C6F723A20233964';
wwv_flow_imp.g_varchar2_table(1683) := '373161662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32372D62642C0D0A2E752D636F6C6F722D32372D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233964373161662021696D706F7274616E743B0D0A202073';
wwv_flow_imp.g_varchar2_table(1684) := '74726F6B653A20233964373161662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3238207B0D0A20206261636B67726F756E642D636F6C6F723A20233762383662642021696D706F7274616E743B0D0A202066696C6C3A202337623836';
wwv_flow_imp.g_varchar2_table(1685) := '62642021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32382D62672C0D0A2E752D636F6C6F722D32382D6261636B67726F756E64207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1686) := '6F756E642D636F6C6F723A20233762383662642021696D706F7274616E743B0D0A202066696C6C3A20233762383662642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32382D7478742C0D0A2E752D636F6C6F722D32382D7465787420';
wwv_flow_imp.g_varchar2_table(1687) := '7B0D0A2020636F6C6F723A20233762383662642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32382D62642C0D0A2E752D636F6C6F722D32382D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233762383662642021';
wwv_flow_imp.g_varchar2_table(1688) := '696D706F7274616E743B0D0A20207374726F6B653A20233762383662642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3239207B0D0A20206261636B67726F756E642D636F6C6F723A20236266633864312021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1689) := '0D0A202066696C6C3A20236266633864312021696D706F7274616E743B0D0A2020636F6C6F723A20233364343835342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32392D62672C0D0A2E752D636F6C6F722D32392D6261636B67726F';
wwv_flow_imp.g_varchar2_table(1690) := '756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236266633864312021696D706F7274616E743B0D0A202066696C6C3A20236266633864312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32392D7478742C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1691) := '2D636F6C6F722D32392D74657874207B0D0A2020636F6C6F723A20236266633864312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32392D62642C0D0A2E752D636F6C6F722D32392D626F72646572207B0D0A2020626F726465722D63';
wwv_flow_imp.g_varchar2_table(1692) := '6F6C6F723A20236266633864312021696D706F7274616E743B0D0A20207374726F6B653A20236266633864312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3330207B0D0A20206261636B67726F756E642D636F6C6F723A2023386239';
wwv_flow_imp.g_varchar2_table(1693) := '6461642021696D706F7274616E743B0D0A202066696C6C3A20233862396461642021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33302D62672C0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1694) := '6F6C6F722D33302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233862396461642021696D706F7274616E743B0D0A202066696C6C3A20233862396461642021696D706F7274616E743B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1695) := '6C6F722D33302D7478742C0D0A2E752D636F6C6F722D33302D74657874207B0D0A2020636F6C6F723A20233862396461642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33302D62642C0D0A2E752D636F6C6F722D33302D626F726465';
wwv_flow_imp.g_varchar2_table(1696) := '72207B0D0A2020626F726465722D636F6C6F723A20233862396461642021696D706F7274616E743B0D0A20207374726F6B653A20233862396461642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3331207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(1697) := '756E642D636F6C6F723A20233139386363612021696D706F7274616E743B0D0A202066696C6C3A20233139386363612021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1698) := '6F722D33312D62672C0D0A2E752D636F6C6F722D33312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363612021696D706F7274616E743B0D0A202066696C6C3A20233139386363612021696D706F72';
wwv_flow_imp.g_varchar2_table(1699) := '74616E743B0D0A7D0D0A2E752D636F6C6F722D33312D7478742C0D0A2E752D636F6C6F722D33312D74657874207B0D0A2020636F6C6F723A20233139386363612021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33312D62642C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1700) := '2D636F6C6F722D33312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233139386363612021696D706F7274616E743B0D0A20207374726F6B653A20233139386363612021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1701) := '3332207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562652021696D706F7274616E743B0D0A202066696C6C3A20233032613562652021696D706F7274616E743B0D0A2020636F6C6F723A20233030303030302021696D706F7274';
wwv_flow_imp.g_varchar2_table(1702) := '616E743B0D0A7D0D0A2E752D636F6C6F722D33322D62672C0D0A2E752D636F6C6F722D33322D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562652021696D706F7274616E743B0D0A202066696C6C3A';
wwv_flow_imp.g_varchar2_table(1703) := '20233032613562652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33322D7478742C0D0A2E752D636F6C6F722D33322D74657874207B0D0A2020636F6C6F723A20233032613562652021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1704) := '6F6C6F722D33322D62642C0D0A2E752D636F6C6F722D33322D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233032613562652021696D706F7274616E743B0D0A20207374726F6B653A20233032613562652021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1705) := '3B0D0A7D0D0A2E752D636F6C6F722D3333207B0D0A20206261636B67726F756E642D636F6C6F723A20233138623161652021696D706F7274616E743B0D0A202066696C6C3A20233138623161652021696D706F7274616E743B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1706) := '233030303030302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33332D62672C0D0A2E752D636F6C6F722D33332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233138623161652021696D706F';
wwv_flow_imp.g_varchar2_table(1707) := '7274616E743B0D0A202066696C6C3A20233138623161652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33332D7478742C0D0A2E752D636F6C6F722D33332D74657874207B0D0A2020636F6C6F723A20233138623161652021696D706F';
wwv_flow_imp.g_varchar2_table(1708) := '7274616E743B0D0A7D0D0A2E752D636F6C6F722D33332D62642C0D0A2E752D636F6C6F722D33332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233138623161652021696D706F7274616E743B0D0A20207374726F6B653A20233138';
wwv_flow_imp.g_varchar2_table(1709) := '623161652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3334207B0D0A20206261636B67726F756E642D636F6C6F723A20233234613437352021696D706F7274616E743B0D0A202066696C6C3A20233234613437352021696D706F7274';
wwv_flow_imp.g_varchar2_table(1710) := '616E743B0D0A2020636F6C6F723A20236566666266372021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33342D62672C0D0A2E752D636F6C6F722D33342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1711) := '3A20233234613437352021696D706F7274616E743B0D0A202066696C6C3A20233234613437352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33342D7478742C0D0A2E752D636F6C6F722D33342D74657874207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1712) := '3A20233234613437352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33342D62642C0D0A2E752D636F6C6F722D33342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233234613437352021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1713) := '0D0A20207374726F6B653A20233234613437352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3335207B0D0A20206261636B67726F756E642D636F6C6F723A20233661616434322021696D706F7274616E743B0D0A202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(1714) := '233661616434322021696D706F7274616E743B0D0A2020636F6C6F723A20233063313530362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D62672C0D0A2E752D636F6C6F722D33352D6261636B67726F756E64207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1715) := '61636B67726F756E642D636F6C6F723A20233661616434322021696D706F7274616E743B0D0A202066696C6C3A20233661616434322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D7478742C0D0A2E752D636F6C6F722D33352D';
wwv_flow_imp.g_varchar2_table(1716) := '74657874207B0D0A2020636F6C6F723A20233661616434322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D62642C0D0A2E752D636F6C6F722D33352D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023366161';
wwv_flow_imp.g_varchar2_table(1717) := '6434322021696D706F7274616E743B0D0A20207374726F6B653A20233661616434322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3336207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133392021696D706F72';
wwv_flow_imp.g_varchar2_table(1718) := '74616E743B0D0A202066696C6C3A20236339636133392021696D706F7274616E743B0D0A2020636F6C6F723A20233264326530342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33362D62672C0D0A2E752D636F6C6F722D33362D6261';
wwv_flow_imp.g_varchar2_table(1719) := '636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133392021696D706F7274616E743B0D0A202066696C6C3A20236339636133392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33362D747874';
wwv_flow_imp.g_varchar2_table(1720) := '2C0D0A2E752D636F6C6F722D33362D74657874207B0D0A2020636F6C6F723A20236339636133392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33362D62642C0D0A2E752D636F6C6F722D33362D626F72646572207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(1721) := '6465722D636F6C6F723A20236339636133392021696D706F7274616E743B0D0A20207374726F6B653A20236339636133392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3337207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1722) := '20236439623133622021696D706F7274616E743B0D0A202066696C6C3A20236439623133622021696D706F7274616E743B0D0A2020636F6C6F723A20233436333430302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33372D62672C0D';
wwv_flow_imp.g_varchar2_table(1723) := '0A2E752D636F6C6F722D33372D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236439623133622021696D706F7274616E743B0D0A202066696C6C3A20236439623133622021696D706F7274616E743B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1724) := '2E752D636F6C6F722D33372D7478742C0D0A2E752D636F6C6F722D33372D74657874207B0D0A2020636F6C6F723A20236439623133622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33372D62642C0D0A2E752D636F6C6F722D33372D';
wwv_flow_imp.g_varchar2_table(1725) := '626F72646572207B0D0A2020626F726465722D636F6C6F723A20236439623133622021696D706F7274616E743B0D0A20207374726F6B653A20236439623133622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3338207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1726) := '636B67726F756E642D636F6C6F723A20236437366132372021696D706F7274616E743B0D0A202066696C6C3A20236437366132372021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1727) := '752D636F6C6F722D33382D62672C0D0A2E752D636F6C6F722D33382D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236437366132372021696D706F7274616E743B0D0A202066696C6C3A20236437366132372021';
wwv_flow_imp.g_varchar2_table(1728) := '696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33382D7478742C0D0A2E752D636F6C6F722D33382D74657874207B0D0A2020636F6C6F723A20236437366132372021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33382D6264';
wwv_flow_imp.g_varchar2_table(1729) := '2C0D0A2E752D636F6C6F722D33382D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236437366132372021696D706F7274616E743B0D0A20207374726F6B653A20236437366132372021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1730) := '6F6C6F722D3339207B0D0A20206261636B67726F756E642D636F6C6F723A20236432343233622021696D706F7274616E743B0D0A202066696C6C3A20236432343233622021696D706F7274616E743B0D0A2020636F6C6F723A2023666666666666202169';
wwv_flow_imp.g_varchar2_table(1731) := '6D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D62672C0D0A2E752D636F6C6F722D33392D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236432343233622021696D706F7274616E743B0D0A2020';
wwv_flow_imp.g_varchar2_table(1732) := '66696C6C3A20236432343233622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D7478742C0D0A2E752D636F6C6F722D33392D74657874207B0D0A2020636F6C6F723A20236432343233622021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1733) := '0A2E752D636F6C6F722D33392D62642C0D0A2E752D636F6C6F722D33392D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236432343233622021696D706F7274616E743B0D0A20207374726F6B653A20236432343233622021696D706F';
wwv_flow_imp.g_varchar2_table(1734) := '7274616E743B0D0A7D0D0A2E752D636F6C6F722D3430207B0D0A20206261636B67726F756E642D636F6C6F723A20236431343336662021696D706F7274616E743B0D0A202066696C6C3A20236431343336662021696D706F7274616E743B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(1735) := '6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34302D62672C0D0A2E752D636F6C6F722D34302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A202364313433366620';
wwv_flow_imp.g_varchar2_table(1736) := '21696D706F7274616E743B0D0A202066696C6C3A20236431343336662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34302D7478742C0D0A2E752D636F6C6F722D34302D74657874207B0D0A2020636F6C6F723A202364313433366620';
wwv_flow_imp.g_varchar2_table(1737) := '21696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34302D62642C0D0A2E752D636F6C6F722D34302D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236431343336662021696D706F7274616E743B0D0A20207374726F6B65';
wwv_flow_imp.g_varchar2_table(1738) := '3A20236431343336662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3431207B0D0A20206261636B67726F756E642D636F6C6F723A20236261336438382021696D706F7274616E743B0D0A202066696C6C3A2023626133643838202169';
wwv_flow_imp.g_varchar2_table(1739) := '6D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34312D62672C0D0A2E752D636F6C6F722D34312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1740) := '636F6C6F723A20236261336438382021696D706F7274616E743B0D0A202066696C6C3A20236261336438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34312D7478742C0D0A2E752D636F6C6F722D34312D74657874207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1741) := '636F6C6F723A20236261336438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34312D62642C0D0A2E752D636F6C6F722D34312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236261336438382021696D706F72';
wwv_flow_imp.g_varchar2_table(1742) := '74616E743B0D0A20207374726F6B653A20236261336438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3432207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339332021696D706F7274616E743B0D0A202066';
wwv_flow_imp.g_varchar2_table(1743) := '696C6C3A20233737333339332021696D706F7274616E743B0D0A2020636F6C6F723A20236636656666392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34322D62672C0D0A2E752D636F6C6F722D34322D6261636B67726F756E64207B';
wwv_flow_imp.g_varchar2_table(1744) := '0D0A20206261636B67726F756E642D636F6C6F723A20233737333339332021696D706F7274616E743B0D0A202066696C6C3A20233737333339332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34322D7478742C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1745) := '722D34322D74657874207B0D0A2020636F6C6F723A20233737333339332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34322D62642C0D0A2E752D636F6C6F722D34322D626F72646572207B0D0A2020626F726465722D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1746) := '20233737333339332021696D706F7274616E743B0D0A20207374726F6B653A20233737333339332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3433207B0D0A20206261636B67726F756E642D636F6C6F723A20233364346561332021';
wwv_flow_imp.g_varchar2_table(1747) := '696D706F7274616E743B0D0A202066696C6C3A20233364346561332021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34332D62672C0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1748) := '34332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233364346561332021696D706F7274616E743B0D0A202066696C6C3A20233364346561332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34';
wwv_flow_imp.g_varchar2_table(1749) := '332D7478742C0D0A2E752D636F6C6F722D34332D74657874207B0D0A2020636F6C6F723A20233364346561332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34332D62642C0D0A2E752D636F6C6F722D34332D626F72646572207B0D0A';
wwv_flow_imp.g_varchar2_table(1750) := '2020626F726465722D636F6C6F723A20233364346561332021696D706F7274616E743B0D0A20207374726F6B653A20233364346561332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3434207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1751) := '6F6C6F723A20233863396562302021696D706F7274616E743B0D0A202066696C6C3A20233863396562302021696D706F7274616E743B0D0A2020636F6C6F723A20233238336134642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3434';
wwv_flow_imp.g_varchar2_table(1752) := '2D62672C0D0A2E752D636F6C6F722D34342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233863396562302021696D706F7274616E743B0D0A202066696C6C3A20233863396562302021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1753) := '0D0A7D0D0A2E752D636F6C6F722D34342D7478742C0D0A2E752D636F6C6F722D34342D74657874207B0D0A2020636F6C6F723A20233863396562302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34342D62642C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1754) := '722D34342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233863396562302021696D706F7274616E743B0D0A20207374726F6B653A20233863396562302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3435207B0D';
wwv_flow_imp.g_varchar2_table(1755) := '0A20206261636B67726F756E642D636F6C6F723A20233465373339312021696D706F7274616E743B0D0A202066696C6C3A20233465373339312021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(1756) := '0A7D0D0A2E752D636F6C6F722D34352D62672C0D0A2E752D636F6C6F722D34352D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233465373339312021696D706F7274616E743B0D0A202066696C6C3A2023346537';
wwv_flow_imp.g_varchar2_table(1757) := '3339312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34352D7478742C0D0A2E752D636F6C6F722D34352D74657874207B0D0A2020636F6C6F723A20233465373339312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1758) := '34352D62642C0D0A2E752D636F6C6F722D34352D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233465373339312021696D706F7274616E743B0D0A20207374726F6B653A20233465373339312021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1759) := '0A2E752D636F6C6F722D7472616E73706172656E74207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A2020636F6C6F723A207472616E73706172656E742021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1760) := '743B0D0A7D0D0A2E752D636F6C6F722D7472616E73706172656E742D6267207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D7472616E7370617265';
wwv_flow_imp.g_varchar2_table(1761) := '6E742D7478742C0D0A2E752D636F6C6F722D7472616E73706172656E742D74657874207B0D0A2020636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D7472616E73706172656E742D62642C0D';
wwv_flow_imp.g_varchar2_table(1762) := '0A2E752D636F6C6F722D7472616E73706172656E742D626F72646572207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_theme_file(
 p_id=>wwv_flow_imp.id(5634392093827563)
,p_theme_id=>42
,p_file_name=>'5633999520827555.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A200D0A202A20464C4F57530D0A202A20202020284F7261636C65204170706C69636174696F6E2045787072657373205468656D65205374796C65290D0A202A200D0A202A2054686973204353532066696C65207761732067656E6572617465642075';
wwv_flow_imp.g_varchar2_table(2) := '73696E6720746865204F7261636C65204170706C69636174696F6E204578707265737320352E30205468656D6520526F6C6C65722E200D0A202A200D0A202A2F2E742D4156504C6973742D6974656D207B0D0A2020626F782D736861646F773A2030202D';
wwv_flow_imp.g_varchar2_table(3) := '302E3172656D2030207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D4156504C6973742D6C6162656C2C0D0A2E742D4156504C6973742D76616C7565207B0D0A2020626F782D736861646F773A203020302E317265';
wwv_flow_imp.g_varchar2_table(4) := '6D207267626128302C20302C20302C20302E3037352920696E7365743B0D0A7D0D0A2E742D4156504C6973742D76616C7565207B0D0A2020636F6C6F723A20233462346234623B0D0A7D0D0A2E742D426F64792D696E666F202E742D4156504C6973742D';
wwv_flow_imp.g_varchar2_table(5) := '76616C7565207B0D0A2020636F6C6F723A20233464346434643B0D0A7D0D0A2E742D526567696F6E202E742D4156504C6973742D76616C7565207B0D0A2020636F6C6F723A20233464346434643B0D0A7D0D0A2E742D4156504C6973742D6C6162656C20';
wwv_flow_imp.g_varchar2_table(6) := '7B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E742D426F64792D696E666F202E742D4156504C6973742D6C6162656C207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E202E742D4156504C697374';
wwv_flow_imp.g_varchar2_table(7) := '2D6C6162656C207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D4156504C697374202B202E742D5265706F72742D706167696E6174696F6E207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20';
wwv_flow_imp.g_varchar2_table(8) := '302C20302E3035293B0D0A7D0D0A2E742D416C6572742D2D77697A6172642C0D0A2E742D416C6572742D2D686F72697A6F6E74616C207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A2072676261';
wwv_flow_imp.g_varchar2_table(9) := '28302C20302C20302C20302E31293B0D0A7D0D0A2E742D416C6572742D2D77697A617264202E742D416C6572742D69636F6E2C0D0A2E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(10) := '746F702D6C6566742D7261646975733A203270783B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A7D0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D7761726E696E672C0D0A2E74';
wwv_flow_imp.g_varchar2_table(11) := '2D416C6572742D2D636F6C6F7242472E742D416C6572742D2D79656C6C6F77207B0D0A20206261636B67726F756E642D636F6C6F723A20236665663765303B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E742D416C6572742D2D636F6C';
wwv_flow_imp.g_varchar2_table(12) := '6F7242472E742D416C6572742D2D73756363657373207B0D0A20206261636B67726F756E642D636F6C6F723A20236634666366333B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C65';
wwv_flow_imp.g_varchar2_table(13) := '72742D2D64616E6765722C0D0A2E742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D726564207B0D0A20206261636B67726F756E642D636F6C6F723A20236666663866373B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(14) := '742D416C6572742D2D636F6C6F7242472E742D416C6572742D2D696E666F207B0D0A20206261636B67726F756E642D636F6C6F723A20236639666366663B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E742D416C6572742D69636F6E20';
wwv_flow_imp.g_varchar2_table(15) := '2E742D49636F6E207B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D416C6572742D2D7761726E696E67202E742D416C6572742D69636F6E202E742D49636F6E2C0D0A2E742D416C6572742D2D79656C6C6F77202E742D416C6572742D6963';
wwv_flow_imp.g_varchar2_table(16) := '6F6E202E742D49636F6E207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E742D416C6572742D2D7761726E696E672E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E2C0D0A2E742D416C6572742D2D';
wwv_flow_imp.g_varchar2_table(17) := '79656C6C6F772E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235312C203230362C2037342C20302E3135293B0D0A7D0D0A2E742D416C65';
wwv_flow_imp.g_varchar2_table(18) := '72742D2D73756363657373202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20233342414132433B0D0A7D0D0A2E742D416C6572742D2D737563636573732E742D416C6572742D2D686F72697A6F6E74616C202E742D';
wwv_flow_imp.g_varchar2_table(19) := '416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835392C203137302C2034342C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D696E666F202E742D416C6572742D69636F6E202E742D49636F6E20';
wwv_flow_imp.g_varchar2_table(20) := '7B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D416C6572742D2D696E666F2E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20726762';
wwv_flow_imp.g_varchar2_table(21) := '6128302C203131382C203232332C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D64616E676572202E742D416C6572742D69636F6E202E742D49636F6E2C0D0A2E742D416C6572742D2D726564202E742D416C6572742D69636F6E202E742D4963';
wwv_flow_imp.g_varchar2_table(22) := '6F6E207B0D0A2020636F6C6F723A20236634343333363B0D0A7D0D0A2E742D416C6572742D2D64616E6765722E742D416C6572742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E2C0D0A2E742D416C6572742D2D7265642E742D416C65';
wwv_flow_imp.g_varchar2_table(23) := '72742D2D686F72697A6F6E74616C202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283234342C2036372C2035342C20302E3135293B0D0A7D0D0A2E742D416C6572742D2D77697A617264202E74';
wwv_flow_imp.g_varchar2_table(24) := '2D416C6572742D696E736574207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E742D416C6572742D2D686F72697A6F6E74616C2C0D0A2E742D416C6572742D2D77697A617264207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(25) := '6C6F723A20236666666666663B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D416C6572742D2D70616765207B0D0A2020626F782D736861646F773A20302030203020302E3172656D207267626128302C20302C20302C20302E3129';
wwv_flow_imp.g_varchar2_table(26) := '20696E7365742C20302033707820397078202D327078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D416C6572742D2D70616765202E612D4E6F74696669636174696F6E2D6974656D3A6265666F7265207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(27) := '726F756E642D636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612835392C';
wwv_flow_imp.g_varchar2_table(28) := '203137302C2034342C20302E39293B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373202E742D416C6572742D69636F6E207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(29) := '6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(30) := '6F723A20696E68657269743B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D73756363657373202E742D427574746F6E2D2D636C6F7365416C657274207B0D0A2020636F6C6F723A20234646462021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(31) := '0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D7761726E696E67207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D416C6572742D';
wwv_flow_imp.g_varchar2_table(32) := '2D706167652E742D416C6572742D2D7761726E696E67202E742D416C6572742D69636F6E202E742D49636F6E207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D7761726E696E';
wwv_flow_imp.g_varchar2_table(33) := '672061207B0D0A2020636F6C6F723A20696E68657269743B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A7D0D0A2E742D416C6572742D2D706167652E742D416C6572742D2D7761726E696E67202E612D4E6F746966';
wwv_flow_imp.g_varchar2_table(34) := '69636174696F6E2D6974656D3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A2063757272656E74436F6C6F723B0D0A7D0D0A2E742D4C6F67696E2D636F6E7461696E6572426F6479202E742D426F64792D616C657274207B0D';
wwv_flow_imp.g_varchar2_table(35) := '0A202077696474683A2034363070783B0D0A7D0D0A2E742D42616467652D2D6261736963207B0D0A2020626F782D736861646F773A20302030203020302E3172656D2072676261283235352C203235352C203235352C20302E3032352920696E7365743B';
wwv_flow_imp.g_varchar2_table(36) := '0D0A7D0D0A2E742D42616467652D2D6F72623A6265666F7265207B0D0A2020626F782D736861646F773A20302030203020302E3172656D2072676261283235352C203235352C203235352C20302E30352920696E7365743B0D0A7D0D0A2E742D42616467';
wwv_flow_imp.g_varchar2_table(37) := '652D2D6F72622E69732D6E756C6C3A6265666F7265207B0D0A2020636F6C6F723A20233730373037303B0D0A7D0D0A2E742D42616467652D2D62617369632E69732D6E756C6C207B0D0A2020636F6C6F723A20233730373037303B0D0A7D0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(38) := '616467654C6973742C0D0A2E742D42616467654C6973743A6E6F74282E752D636F6C6F7273292061202E742D42616467654C6973742D6C6162656C207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D42616467654C6973742D2D63';
wwv_flow_imp.g_varchar2_table(39) := '697263756C6172202E742D42616467654C6973742D76616C7565207B0D0A2020626F782D736861646F773A2030203020302031707820726762612833382C2033382C2033382C20302E312920696E7365743B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(40) := '6F723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742D2D63697263756C617220612E742D42616467654C6973742D777261703A686F766572202E742D42616467654C6973742D76616C7565207B0D0A2020626F782D736861646F773A';
wwv_flow_imp.g_varchar2_table(41) := '20302030203020347078202330303736646620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742D2D6461736820612E';
wwv_flow_imp.g_varchar2_table(42) := '742D42616467654C6973742D777261703A666F6375732C0D0A2E742D42616467654C6973742D2D64617368202E742D42616467654C6973742D777261703A666F6375732D77697468696E2C0D0A2E742D42616467654C6973742D2D63697263756C617220';
wwv_flow_imp.g_varchar2_table(43) := '612E742D42616467654C6973742D777261703A666F637573202E742D42616467654C6973742D76616C75652C0D0A2E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D76616C756520613A666F637573207B0D0A20';
wwv_flow_imp.g_varchar2_table(44) := '20626F782D736861646F773A20302030203020317078202330303736646620696E7365742C20302030203020327078202366666666666620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(45) := '723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742D2D64617368202E742D42616467654C6973742D777261703A666F6375732D77697468696E2C0D0A2E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C';
wwv_flow_imp.g_varchar2_table(46) := '6973742D76616C756520613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D4261';
wwv_flow_imp.g_varchar2_table(47) := '6467654C6973742D2D64617368202E742D42616467654C6973742D76616C756520613A666F6375732C0D0A2E742D42616467654C6973742D2D6461736820612E742D42616467654C6973742D777261703A666F6375732D77697468696E202E742D426164';
wwv_flow_imp.g_varchar2_table(48) := '67654C6973742D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742D6974656D3A61667465722C0D0A2E742D42616467654C6973742D6974656D3A6265666F7265207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(49) := '6F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D42616467654C6973742D2D6461736820612E742D42616467654C6973742D777261703A686F7665723A6265666F7265207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(50) := '756E642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D42616467654C6973742E752D636F6C6F72732E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D777261703A626566';
wwv_flow_imp.g_varchar2_table(51) := '6F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D42616467654C6973742E752D636F6C6F72732E742D42616467654C6973742D2D63697263756C6172202E742D42616467654C6973742D6C6162';
wwv_flow_imp.g_varchar2_table(52) := '656C207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D42616467654C6973742E752D636F6C6F7273202E742D42616467654C6973742D76616C75652061207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D42';
wwv_flow_imp.g_varchar2_table(53) := '61724368617274202E612D42617243686172742D6974656D207B0D0A2020626F782D736861646F773A2030202D302E3172656D2030207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E612D4261724368617274202E612D';
wwv_flow_imp.g_varchar2_table(54) := '42617243686172742D6974656D3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236632663266323B0D0A7D0D0A2E742D426F6479202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243';
wwv_flow_imp.g_varchar2_table(55) := '686172742D76616C7565207B0D0A2020636F6C6F723A20233765376537653B0D0A7D0D0A2E742D426F64792D7469746C65202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C7565207B0D0A';
wwv_flow_imp.g_varchar2_table(56) := '2020636F6C6F723A20233830383038303B0D0A7D0D0A2E742D426F64792D696E666F202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C7565207B0D0A2020636F6C6F723A20233830383038';
wwv_flow_imp.g_varchar2_table(57) := '303B0D0A7D0D0A2E742D526567696F6E202E612D4261724368617274202E612D42617243686172742D6974656D202E612D42617243686172742D76616C75652C0D0A2E742D427574746F6E526567696F6E202E612D4261724368617274202E612D426172';
wwv_flow_imp.g_varchar2_table(58) := '43686172742D6974656D202E612D42617243686172742D76616C7565207B0D0A2020636F6C6F723A20233830383038303B0D0A7D0D0A2E612D4261724368617274202E612D42617243686172742D6974656D20696D67207B0D0A2020626F726465722D72';
wwv_flow_imp.g_varchar2_table(59) := '61646975733A203270783B0D0A7D0D0A2E612D4261724368617274202E612D42617243686172742D626172207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A7D0D0A2E612D42617243';
wwv_flow_imp.g_varchar2_table(60) := '686172742D2D636C6173736963202E612D42617243686172742D6C6162656C2C0D0A2E612D42617243686172742D2D636C6173736963202E612D42617243686172742D6261724C696E6B2C0D0A2E612D42617243686172742D2D636C6173736963202E61';
wwv_flow_imp.g_varchar2_table(61) := '2D42617243686172742D76616C7565207B0D0A2020626F782D736861646F773A2030202D302E3172656D2030207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E612D42617243686172742D2D636C6173736963202E612D';
wwv_flow_imp.g_varchar2_table(62) := '42617243686172742D6261722C0D0A2E612D42617243686172742D2D636C6173736963202E612D42617243686172742D66696C6C6564207B0D0A2020626F726465722D7261646975733A203170783B0D0A7D0D0A2E612D42617243686172742D2D636C61';
wwv_flow_imp.g_varchar2_table(63) := '73736963202E612D42617243686172742D6974656D3A686F766572202E612D42617243686172742D626172207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E612D4261724368';
wwv_flow_imp.g_varchar2_table(64) := '6172742D2D6D6F6465726E202E612D42617243686172742D6261722C0D0A2E612D42617243686172742D2D6D6F6465726E202E612D42617243686172742D66696C6C6564207B0D0A2020626F726465722D7261646975733A203170783B0D0A7D0D0A2E61';
wwv_flow_imp.g_varchar2_table(65) := '2D42617243686172742D2D6D6F6465726E202E612D42617243686172742D6974656D3A686F766572202E612D42617243686172742D626172207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B';
wwv_flow_imp.g_varchar2_table(66) := '0D0A7D0D0A2E612D42617243686172742D66696C6C6564207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E617065785F776169745F6F7665726C6179207B0D0A20206261636B67726F756E643A2072676261';
wwv_flow_imp.g_varchar2_table(67) := '283235352C203235352C203235352C20302E35293B0D0A7D0D0A626F6479207B0D0A20206261636B67726F756E642D636F6C6F723A20234644464446443B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A626F6479202E677269642D646562';
wwv_flow_imp.g_varchar2_table(68) := '75672D6F6E202E636F6E7461696E6572207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A61207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A2E742D426F64';
wwv_flow_imp.g_varchar2_table(69) := '792D616374696F6E73207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F726465722D6C6566743A2031707820736F6C6964207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E752D52544C';
wwv_flow_imp.g_varchar2_table(70) := '202E742D426F64792D616374696F6E73207B0D0A2020626F726465722D6C6566743A20303B0D0A2020626F726465722D72696768743A2031707820736F6C6964207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D426F64792D74';
wwv_flow_imp.g_varchar2_table(71) := '69746C65207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E39293B0D0A2020636F6C6F723A20233236323632363B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C6964';
wwv_flow_imp.g_varchar2_table(72) := '20236536653665363B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C2023745F426F64795F636F6E74656E745F';
wwv_flow_imp.g_varchar2_table(73) := '6F6666736574207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E39293B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C202E742D426F64792D7469746C652E';
wwv_flow_imp.g_varchar2_table(74) := '6861732D736861646F77207B0D0A2020626F782D736861646F773A2030203170782030207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C202E742D426F64792D7469746C';
wwv_flow_imp.g_varchar2_table(75) := '652E6861732D736861646F773A6166746572207B0D0A20206261636B67726F756E642D696D6167653A206C696E6561722D6772616469656E74287267626128302C20302C20302C20302E3035292C207267626128302C20302C20302C203029293B0D0A7D';
wwv_flow_imp.g_varchar2_table(76) := '0D0A2E742D50616765426F64792D2D6D617374657244657461696C202E617065782D7264732D636F6E7461696E6572207B0D0A2020626F782D736861646F773A2030202D3170782030207267626128302C20302C20302C20302E312920696E7365743B0D';
wwv_flow_imp.g_varchar2_table(77) := '0A7D0D0A2E742D50616765426F64792D2D6D617374657244657461696C202E617065782D7264732D636F6E7461696E65722E69732D737475636B3A6166746572207B0D0A20206261636B67726F756E642D696D6167653A206C696E6561722D6772616469';
wwv_flow_imp.g_varchar2_table(78) := '656E74287267626128302C20302C20302C20302E3035292C207267626128302C20302C20302C203029293B0D0A7D0D0A2E75692D7769646765742D636F6E74656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A';
wwv_flow_imp.g_varchar2_table(79) := '7D0D0A2E742D426F6479202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20233365336533653B0D0A7D0D0A2E742D426F64792D7469746C65202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(80) := '233430343034303B0D0A7D0D0A2E742D426F64792D696E666F202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D526567696F6E202E75692D7769646765742D636F6E74656E742C0D';
wwv_flow_imp.g_varchar2_table(81) := '0A2E742D427574746F6E526567696F6E202E75692D7769646765742D636F6E74656E74207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D426F64792D73696465207B0D0A20206261636B67726F756E642D636F6C6F723A20236666';
wwv_flow_imp.g_varchar2_table(82) := '666666663B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E742D426F64792D73696465207B0D0A20202020626F782D';
wwv_flow_imp.g_varchar2_table(83) := '736861646F773A2031707820302030207267626128302C20302C20302C20302E31293B0D0A20207D0D0A20202E752D52544C202E742D426F64792D73696465207B0D0A20202020626F782D736861646F773A202D31707820302030207267626128302C20';
wwv_flow_imp.g_varchar2_table(84) := '302C20302C20302E31293B0D0A20207D0D0A7D0D0A2E617065782D7264732D636F6E7461696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D696E666F202E617065782D';
wwv_flow_imp.g_varchar2_table(85) := '7264732D636F6E7461696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D696E666F202E617065782D7264732D636F6E7461696E65722E69732D737475636B207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(86) := '6B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A20206261636B64726F702D66696C7465723A20626C757228347078293B0D0A7D0D0A2E742D426F64792D696E666F207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(87) := '726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D7469746C652E6A732D6869646542726561646372756D6273207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3935';
wwv_flow_imp.g_varchar2_table(88) := '293B0D0A7D0D0A2E742D426F64792D746F70427574746F6E207B0D0A2020626F726465722D7261646975733A20313030253B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20236536653665363B0D';
wwv_flow_imp.g_varchar2_table(89) := '0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D426F64792D746F70427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A2030203020302031707820';
wwv_flow_imp.g_varchar2_table(90) := '2330303736646620696E7365742C20302031707820327078207267626128302C20302C20302C20302E3135293B0D0A7D0D0A2E742D426F64792D746F70427574746F6E3A686F7665722C0D0A2E742D426F64792D746F70427574746F6E3A666F63757320';
wwv_flow_imp.g_varchar2_table(91) := '7B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D426F64792D746F70427574746F6E3A686F7665722C0D0A2E742D426F64792D746F70427574746F6E3A616374697665207B0D0A2020626F782D736861646F773A2030203170782032';
wwv_flow_imp.g_varchar2_table(92) := '7078207267626128302C20302C20302C20302E31352920696E7365743B0D0A7D0D0A2E742D426F64792D746F70427574746F6E3A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(93) := '20236536653665363B0D0A7D0D0A2E742D4865616465722D6272616E64696E67207B0D0A20206865696768743A20343870783B0D0A7D0D0A2E742D4865616465722D6C6F676F2D6C696E6B20696D67207B0D0A20206D61782D6865696768743A20343070';
wwv_flow_imp.g_varchar2_table(94) := '783B0D0A7D0D0A2E742D426F64792D636F6E74656E74207B0D0A20206D696E2D6865696768743A2063616C63283130307668202D202034387078293B0D0A7D0D0A2E617065782D736964652D6E6176202E742D426F64792D6E61762C0D0A2E617065782D';
wwv_flow_imp.g_varchar2_table(95) := '736964652D6E6176202E742D426F64792D616374696F6E732C0D0A2E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A2020746F703A20343870783B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E642028';
wwv_flow_imp.g_varchar2_table(96) := '6D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A202020206C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C20';
wwv_flow_imp.g_varchar2_table(97) := '2E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A2020202072696768743A2032343070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D7469746C6520';
wwv_flow_imp.g_varchar2_table(98) := '7B0D0A2020202072696768743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C79207363';
wwv_flow_imp.g_varchar2_table(99) := '7265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A20323430';
wwv_flow_imp.g_varchar2_table(100) := '70783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A7D0D0A3A6E6F74282E752D52544C2920';
wwv_flow_imp.g_varchar2_table(101) := '2E617065782D736964652D6E6176202E742D426F64792D6D61696E207B0D0A20206D617267696E2D6C6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E6176202E742D426F64792D6D61696E207B0D0A20206D617267696E2D';
wwv_flow_imp.g_varchar2_table(102) := '72696768743A20303B0D0A7D0D0A2E617065782D746F702D6E6176202E742D426F64792D616374696F6E73207B0D0A2020746F703A20383870783B0D0A7D0D0A2E617065782D746F702D6E6176202E742D426F64792D7469746C65207B0D0A2020746F70';
wwv_flow_imp.g_varchar2_table(103) := '3A20383870783B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20202E617065782D746F702D6E61762E6A732D6D656E754E6176436F6C6C6170736564202E742D48656164';
wwv_flow_imp.g_varchar2_table(104) := '65722D6E6176207B0D0A202020207472616E73666F726D3A207472616E736C61746559282D31303025293B0D0A20207D0D0A7D0D0A2E742D426F64792D6E6176207B0D0A202077696474683A2032343070783B0D0A7D0D0A2E742D426F64792D61637469';
wwv_flow_imp.g_varchar2_table(105) := '6F6E73207B0D0A202077696474683A2032303070783B0D0A7D0D0A3A6E6F74282E752D52544C29202E742D426F64792D616374696F6E73202E742D427574746F6E2D2D686561646572207B0D0A20207472616E73666F726D3A207472616E736C61746533';
wwv_flow_imp.g_varchar2_table(106) := '64282D343070782C20302C2030293B0D0A7D0D0A2E752D52544C202E742D426F64792D616374696F6E73202E742D427574746F6E2D2D686561646572207B0D0A20207472616E73666F726D3A207472616E736C617465336428343070782C20302C203029';
wwv_flow_imp.g_varchar2_table(107) := '3B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E742D426F64792D73696465207B0D0A2020202077696474683A2032343070783B0D0A20207D0D0A7D0D0A406D6564';
wwv_flow_imp.g_varchar2_table(108) := '6961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E6176202E742D426F64792D73696465207B0D0A202020206C6566743A20343870';
wwv_flow_imp.g_varchar2_table(109) := '783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E6176202E742D426F64792D73696465207B0D0A2020202072696768743A20343870783B0D0A20207D0D0A7D0D0A2E6E6F2D616E696D202E742D426F64792D6E61762C0D0A2E6E';
wwv_flow_imp.g_varchar2_table(110) := '6F2D616E696D202E742D547265654E6176207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E742021696D706F72';
wwv_flow_imp.g_varchar2_table(111) := '74616E743B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D6C6566743A20343870783B0D0A7D0D0A2E752D52544C';
wwv_flow_imp.g_varchar2_table(112) := '202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D72696768743A20343870783B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E6176';
wwv_flow_imp.g_varchar2_table(113) := '2E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20207472616E73666F726D3A207472616E736C61746533642831393270782C20302C2030293B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D';
wwv_flow_imp.g_varchar2_table(114) := '6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A20207472616E73666F726D3A207472616E736C6174653364282D31393270782C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D';
wwv_flow_imp.g_varchar2_table(115) := '77696474683A20343830707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D7469746C652C0D0A20203A6E6F74282E752D52544C29202E617065782D73';
wwv_flow_imp.g_varchar2_table(116) := '6964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B';
wwv_flow_imp.g_varchar2_table(117) := '0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D7469746C652C0D0A20202E752D52544C202E617065782D7369';
wwv_flow_imp.g_varchar2_table(118) := '64652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D736964652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B0D0A202020206D';
wwv_flow_imp.g_varchar2_table(119) := '617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20';
wwv_flow_imp.g_varchar2_table(120) := '303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E75';
wwv_flow_imp.g_varchar2_table(121) := '2D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D3A207472616E736C61746533642832343070782C20302C2030293B0D0A20207D0D0A20';
wwv_flow_imp.g_varchar2_table(122) := '202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D32343070782C20302C2030293B0D0A20207D';
wwv_flow_imp.g_varchar2_table(123) := '0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C65';
wwv_flow_imp.g_varchar2_table(124) := '6674202E742D426F64792D7469746C652C0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D636F6E74656E742C0D0A20202E617065782D7369';
wwv_flow_imp.g_varchar2_table(125) := '64652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29';
wwv_flow_imp.g_varchar2_table(126) := '202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C65207B0D0A202020206C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C';
wwv_flow_imp.g_varchar2_table(127) := '202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A2032343070783B0D0A20207D0D0A20203A6E6F7428';
wwv_flow_imp.g_varchar2_table(128) := '2E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D0D0A20202E75';
wwv_flow_imp.g_varchar2_table(129) := '2D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A20203A6E6F74282E';
wwv_flow_imp.g_varchar2_table(130) := '752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2031393270783B';
wwv_flow_imp.g_varchar2_table(131) := '0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D726967';
wwv_flow_imp.g_varchar2_table(132) := '68743A2031393270783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A20';
wwv_flow_imp.g_varchar2_table(133) := '2020206D617267696E2D6C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E';
wwv_flow_imp.g_varchar2_table(134) := '207B0D0A202020206D617267696E2D72696768743A20343870783B0D0A20207D0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D73696465207B0D0A202020207472616E73666F726D3A20747261';
wwv_flow_imp.g_varchar2_table(135) := '6E736C61746533642832343070782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E646564202E742D426F64792D73696465207B0D0A202020207472616E73666F726D3A2074';
wwv_flow_imp.g_varchar2_table(136) := '72616E736C6174653364282D32343070782C20302C2030293B0D0A20207D0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D';
wwv_flow_imp.g_varchar2_table(137) := '0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64';
wwv_flow_imp.g_varchar2_table(138) := '792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D42';
wwv_flow_imp.g_varchar2_table(139) := '6F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F77';
wwv_flow_imp.g_varchar2_table(140) := '4C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C65667420';
wwv_flow_imp.g_varchar2_table(141) := '2E742D426F64792D73696465207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C6566';
wwv_flow_imp.g_varchar2_table(142) := '74202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032383870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F6479';
wwv_flow_imp.g_varchar2_table(143) := '2D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032383870783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870';
wwv_flow_imp.g_varchar2_table(144) := '616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D3A207472616E736C61746533642831393270782C20302C2030293B0D0A20207D0D0A20202E752D5254';
wwv_flow_imp.g_varchar2_table(145) := '4C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D';
wwv_flow_imp.g_varchar2_table(146) := '31393270782C20302C2030293B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C6520';
wwv_flow_imp.g_varchar2_table(147) := '7B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A20';
wwv_flow_imp.g_varchar2_table(148) := '20202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B';
wwv_flow_imp.g_varchar2_table(149) := '0D0A202020207472616E73666F726D3A207472616E736C61746533642832343070782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D';
wwv_flow_imp.g_varchar2_table(150) := '73686F774C656674202E742D426F64792D7469746C65207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D32343070782C20302C2030293B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420';
wwv_flow_imp.g_varchar2_table(151) := '286D696E2D77696474683A20393933707829207B0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020207472616E73';
wwv_flow_imp.g_varchar2_table(152) := '666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A';
wwv_flow_imp.g_varchar2_table(153) := '202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B';
wwv_flow_imp.g_varchar2_table(154) := '0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A20';
wwv_flow_imp.g_varchar2_table(155) := '2020207472616E73666F726D3A206E6F6E652021696D706F7274616E743B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C65';
wwv_flow_imp.g_varchar2_table(156) := '6674202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D';
wwv_flow_imp.g_varchar2_table(157) := '2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176457870616E64';
wwv_flow_imp.g_varchar2_table(158) := '65642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2034383070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D';
wwv_flow_imp.g_varchar2_table(159) := '6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2034383070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E61';
wwv_flow_imp.g_varchar2_table(160) := '7065782D736964652D6E61762E6A732D6E6176457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E742C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176457870';
wwv_flow_imp.g_varchar2_table(161) := '616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C';
wwv_flow_imp.g_varchar2_table(162) := '6C6170736564202E742D426F64792D6E61762C0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176202E742D547265654E6176207B0D0A202077696474683A20343870783B0D0A7D0D0A3A6E6F';
wwv_flow_imp.g_varchar2_table(163) := '74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D636F6E74656E742C0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C617073';
wwv_flow_imp.g_varchar2_table(164) := '6564202E742D426F64792D7469746C652C0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D73696465207B0D0A20206D617267696E2D6C6566743A20343870783B0D';
wwv_flow_imp.g_varchar2_table(165) := '0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D636F6E74656E742C0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E74';
wwv_flow_imp.g_varchar2_table(166) := '2D426F64792D7469746C652C0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D73696465207B0D0A20206D617267696E2D72696768743A20343870783B0D0A7D0D0A3A6E6F74282E';
wwv_flow_imp.g_varchar2_table(167) := '752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652E69732D737475636B207B0D0A20206C6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E6176';
wwv_flow_imp.g_varchar2_table(168) := '2E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652E69732D737475636B207B0D0A202072696768743A20303B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20343830707829';
wwv_flow_imp.g_varchar2_table(169) := '207B0D0A20202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176207B0D0A202020207472616E73666F726D3A207472616E736C61746558282D34387078293B0D0A20207D0D0A20202E752D52544C';
wwv_flow_imp.g_varchar2_table(170) := '202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176207B0D0A202020207472616E73666F726D3A207472616E736C617465582834387078293B0D0A20207D0D0A20203A6E6F74282E752D52544C29';
wwv_flow_imp.g_varchar2_table(171) := '202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64';
wwv_flow_imp.g_varchar2_table(172) := '792D736964652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A';
wwv_flow_imp.g_varchar2_table(173) := '20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D42';
wwv_flow_imp.g_varchar2_table(174) := '6F64792D736964652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(175) := '406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64';
wwv_flow_imp.g_varchar2_table(176) := '792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(177) := '2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D';
wwv_flow_imp.g_varchar2_table(178) := '696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D6C6566743A20';
wwv_flow_imp.g_varchar2_table(179) := '303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F7428';
wwv_flow_imp.g_varchar2_table(180) := '2E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A202020206C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61';
wwv_flow_imp.g_varchar2_table(181) := '762E6A732D6E6176436F6C6C6170736564202E742D426F64792D7469746C65207B0D0A2020202072696768743A20343870783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170';
wwv_flow_imp.g_varchar2_table(182) := '7365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C';
wwv_flow_imp.g_varchar2_table(183) := '6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E6176';
wwv_flow_imp.g_varchar2_table(184) := '2E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032383870783B0D0A20207D0D0A20202E752D52544C202E617065';
wwv_flow_imp.g_varchar2_table(185) := '782D736964652D6E61762E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032383870783B0D0A20207D0D0A7D0D';
wwv_flow_imp.g_varchar2_table(186) := '0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20393933707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D';
wwv_flow_imp.g_varchar2_table(187) := '73696465207B0D0A202020206C6566743A20343870783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C6170736564202E742D426F64792D73696465207B0D0A2020202072696768743A20343870';
wwv_flow_imp.g_varchar2_table(188) := '783B0D0A20207D0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176207B0D0A202077696474683A20303B0D0A2020766973';
wwv_flow_imp.g_varchar2_table(189) := '6962696C6974793A2068696464656E3B0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E6A732D6E6176436F6C6C6170736564202E742D426F64792D6E6176202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(190) := '6261646765207B0D0A20207669736962696C6974793A2068696464656E2021696D706F7274616E743B0D0A7D0D0A2E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E61762C0D0A2E';
wwv_flow_imp.g_varchar2_table(191) := '617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E6176202E742D547265654E6176207B0D0A202077696474683A2032343070783B0D0A7D0D0A3A6E6F74282E752D52544C29202E6170';
wwv_flow_imp.g_varchar2_table(192) := '65782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D636F6E74656E742C0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68';
wwv_flow_imp.g_varchar2_table(193) := '696464656E202E742D426F64792D7469746C652C0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A20206D617267696E2D6C';
wwv_flow_imp.g_varchar2_table(194) := '6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D636F6E74656E742C0D0A2E752D52544C202E617065782D736964652D6E61762E6A73';
wwv_flow_imp.g_varchar2_table(195) := '2D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652C0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A';
wwv_flow_imp.g_varchar2_table(196) := '20206D617267696E2D72696768743A20303B0D0A7D0D0A3A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652E69732D737475636B207B0D';
wwv_flow_imp.g_varchar2_table(197) := '0A20206C6566743A20303B0D0A7D0D0A2E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652E69732D737475636B207B0D0A202072696768743A20303B0D';
wwv_flow_imp.g_varchar2_table(198) := '0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20343830707829207B0D0A20202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E61';
wwv_flow_imp.g_varchar2_table(199) := '76207B0D0A202020207472616E73666F726D3A207472616E736C617465582830293B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D6E6176';
wwv_flow_imp.g_varchar2_table(200) := '207B0D0A202020207472616E73666F726D3A207472616E736C617465582830293B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64';
wwv_flow_imp.g_varchar2_table(201) := '792D7469746C652C0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E617065782D';
wwv_flow_imp.g_varchar2_table(202) := '736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61';
wwv_flow_imp.g_varchar2_table(203) := '762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7369';
wwv_flow_imp.g_varchar2_table(204) := '64652C0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D';
wwv_flow_imp.g_varchar2_table(205) := '0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E';
wwv_flow_imp.g_varchar2_table(206) := '2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E61';
wwv_flow_imp.g_varchar2_table(207) := '76436F6C6C61707365642D2D68696464656E2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A7D0D0A406D6564696120';
wwv_flow_imp.g_varchar2_table(208) := '6F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D';
wwv_flow_imp.g_varchar2_table(209) := '7469746C65207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C65207B0D0A';
wwv_flow_imp.g_varchar2_table(210) := '202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C65207B0D0A2020';
wwv_flow_imp.g_varchar2_table(211) := '20206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A20207D';
wwv_flow_imp.g_varchar2_table(212) := '0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566';
wwv_flow_imp.g_varchar2_table(213) := '743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020';
wwv_flow_imp.g_varchar2_table(214) := '2072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D';
wwv_flow_imp.g_varchar2_table(215) := '636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D';
wwv_flow_imp.g_varchar2_table(216) := '2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203939';
wwv_flow_imp.g_varchar2_table(217) := '33707829207B0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20303B0D0A20';
wwv_flow_imp.g_varchar2_table(218) := '207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F';
wwv_flow_imp.g_varchar2_table(219) := '74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D73';
wwv_flow_imp.g_varchar2_table(220) := '6964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E202E742D426F64792D73696465207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A73';
wwv_flow_imp.g_varchar2_table(221) := '2D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61';
wwv_flow_imp.g_varchar2_table(222) := '762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A2020202072696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E61';
wwv_flow_imp.g_varchar2_table(223) := '7065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B';
wwv_flow_imp.g_varchar2_table(224) := '0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D';
wwv_flow_imp.g_varchar2_table(225) := '617267696E2D72696768743A2032343070783B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C656674';
wwv_flow_imp.g_varchar2_table(226) := '2E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2034383070783B0D0A20207D0D0A20202E752D52544C202E617065782D736964652D6E61762E6A732D6E6176436F6C6C61';
wwv_flow_imp.g_varchar2_table(227) := '707365642D2D68696464656E2E742D50616765426F64792D2D73686F774C6566742E6A732D6E6176457870616E646564202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2034383070783B0D0A20207D0D0A7D';
wwv_flow_imp.g_varchar2_table(228) := '0D0A2E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D72696768743A20303B0D0A7D0D0A3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269';
wwv_flow_imp.g_varchar2_table(229) := '676874457870616E646564202E742D426F64792D6D61696E2C0D0A3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6E6176207B0D0A20207472616E73666F726D3A20747261';
wwv_flow_imp.g_varchar2_table(230) := '6E736C6174653364282D32303070782C20302C2030293B0D0A7D0D0A2E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E646564202E742D426F64792D6D61696E2C0D0A2E752D52544C202E742D50616765426F64792E6A73';
wwv_flow_imp.g_varchar2_table(231) := '2D7269676874457870616E646564202E742D426F64792D6E6176207B0D0A20207472616E73666F726D3A207472616E736C61746533642832303070782C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E';
wwv_flow_imp.g_varchar2_table(232) := '2D77696474683A20363431707829207B0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E2C0D0A20202E742D50616765426F64792E6A';
wwv_flow_imp.g_varchar2_table(233) := '732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6E6176207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D506167';
wwv_flow_imp.g_varchar2_table(234) := '65426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D72696768743A2032303070783B0D0A20207D0D0A20202E752D52544C20';
wwv_flow_imp.g_varchar2_table(235) := '2E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D6D61696E207B0D0A202020206D617267696E2D6C6566743A2032303070783B0D0A20207D0D0A20203A6E';
wwv_flow_imp.g_varchar2_table(236) := '6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A2032303070783B0D0A20207D';
wwv_flow_imp.g_varchar2_table(237) := '0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D686964654C656674202E742D426F64792D7469746C65207B0D0A202020206C6566743A2032303070783B0D0A20207D0D';
wwv_flow_imp.g_varchar2_table(238) := '0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A20303B0D0A2020';
wwv_flow_imp.g_varchar2_table(239) := '7D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020206C6566743A20303B0D0A20207D0D0A2020';
wwv_flow_imp.g_varchar2_table(240) := '3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206D';
wwv_flow_imp.g_varchar2_table(241) := '617267696E2D6C6566743A20303B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D42';
wwv_flow_imp.g_varchar2_table(242) := '6F64792D73696465207B0D0A202020206D617267696E2D72696768743A20303B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E74';
wwv_flow_imp.g_varchar2_table(243) := '2D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C6566743A20303B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E617643';
wwv_flow_imp.g_varchar2_table(244) := '6F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A2020202072696768743A20303B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D776964';
wwv_flow_imp.g_varchar2_table(245) := '74683A20393933707829207B0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020206D';
wwv_flow_imp.g_varchar2_table(246) := '617267696E2D72696768743A2032303070783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D';
wwv_flow_imp.g_varchar2_table(247) := '0A202020206D617267696E2D6C6566743A2032303070783B0D0A20207D0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E2C0D0A2020';
wwv_flow_imp.g_varchar2_table(248) := '2E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6E6176207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E';
wwv_flow_imp.g_varchar2_table(249) := '752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A2020202072696768743A2032303070783B0D0A20207D0D0A2020';
wwv_flow_imp.g_varchar2_table(250) := '2E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C65207B0D0A202020206C6566743A2032303070783B0D0A20207D0D0A20203A';
wwv_flow_imp.g_varchar2_table(251) := '6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73696465207B0D0A202020206C65';
wwv_flow_imp.g_varchar2_table(252) := '66743A20343870783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E6A732D6E6176436F6C6C61707365642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D73';
wwv_flow_imp.g_varchar2_table(253) := '696465207B0D0A2020202072696768743A20343870783B0D0A20207D0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20393932707829207B0D0A20202E742D50616765426F64792E6A732D7269676874';
wwv_flow_imp.g_varchar2_table(254) := '457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D6D61696E207B0D0A202020207472616E73666F726D3A206E6F6E653B0D0A20207D0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E';
wwv_flow_imp.g_varchar2_table(255) := '6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C652C0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D';
wwv_flow_imp.g_varchar2_table(256) := '50616765426F64792D2D73686F774C656674202E742D426F64792D736964652C0D0A20203A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E';
wwv_flow_imp.g_varchar2_table(257) := '742D426F64792D636F6E74656E74207B0D0A202020207472616E73666F726D3A207472616E736C6174653364282D32303070782C20302C2030293B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E';
wwv_flow_imp.g_varchar2_table(258) := '6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D7469746C652C0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C65667420';
wwv_flow_imp.g_varchar2_table(259) := '2E742D426F64792D736964652C0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A20202020747261';
wwv_flow_imp.g_varchar2_table(260) := '6E73666F726D3A207472616E736C61746533642832303070782C20302C2030293B0D0A20207D0D0A20202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D73686F774C656674202E742D426F64792D';
wwv_flow_imp.g_varchar2_table(261) := '73696465207B0D0A202020206D617267696E2D6C6566743A20343870782021696D706F7274616E743B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792E6A732D7269676874457870616E6465642E742D50616765426F64792D2D7368';
wwv_flow_imp.g_varchar2_table(262) := '6F774C656674202E742D426F64792D73696465207B0D0A202020206D617267696E2D6C6566743A20302021696D706F7274616E743B0D0A2020202072696768743A20343870782021696D706F7274616E743B0D0A20207D0D0A7D0D0A2E742D5061676542';
wwv_flow_imp.g_varchar2_table(263) := '6F64792E6A732D7269676874436F6C6C6170736564202E742D426F64792D6D61696E207B0D0A20206D617267696E2D72696768743A203070783B0D0A7D0D0A2E742D50616765426F64792E6A732D7269676874436F6C6C6170736564202E742D426F6479';
wwv_flow_imp.g_varchar2_table(264) := '2D7469746C65207B0D0A202072696768743A203070783B0D0A7D0D0A3A6E6F74282E752D52544C29202E742D50616765426F64792E6A732D7269676874436F6C6C6170736564202E742D426F64792D616374696F6E73207B0D0A20207472616E73666F72';
wwv_flow_imp.g_varchar2_table(265) := '6D3A207472616E736C61746533642832303070782C20302C2030293B0D0A7D0D0A2E752D52544C202E742D50616765426F64792E6A732D7269676874436F6C6C6170736564202E742D426F64792D616374696F6E73207B0D0A20207472616E73666F726D';
wwv_flow_imp.g_varchar2_table(266) := '3A207472616E736C6174653364282D32303070782C20302C2030293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20363431707829207B0D0A20203A6E6F74282E752D52544C29202E742D50616765';
wwv_flow_imp.g_varchar2_table(267) := '426F64792D2D73686F774C656674202E742D426F64792D636F6E74656E74207B0D0A202020206D617267696E2D6C6566743A2032343070783B0D0A20207D0D0A20202E752D52544C202E742D50616765426F64792D2D73686F774C656674202E742D426F';
wwv_flow_imp.g_varchar2_table(268) := '64792D636F6E74656E74207B0D0A202020206D617267696E2D72696768743A2032343070783B0D0A20207D0D0A7D0D0A2E742D426F64792D636F6E74656E74496E6E6572207B0D0A20206D617267696E3A2030206175746F3B0D0A20206D61782D776964';
wwv_flow_imp.g_varchar2_table(269) := '74683A20313030253B0D0A7D0D0A23745F426F64795F736B6970546F436F6E74656E74207B0D0A2020636F6C6F723A20233030373664663B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D6567614D65';
wwv_flow_imp.g_varchar2_table(270) := '6E752D2D66756C6C57696474683A6E6F74282E6A732D6D656E752D63616C6C6F757429207B0D0A202070616464696E672D746F703A203870783B0D0A7D0D0A2E742D4D6567614D656E752D2D6C61796F757432436F6C73202E742D4D6567614D656E752D';
wwv_flow_imp.g_varchar2_table(271) := '6974656D2D2D746F702C0D0A2E742D4D6567614D656E752D2D6C61796F757433436F6C73202E742D4D6567614D656E752D6974656D2D2D746F702C0D0A2E742D4D6567614D656E752D2D6C61796F757434436F6C73202E742D4D6567614D656E752D6974';
wwv_flow_imp.g_varchar2_table(272) := '656D2D2D746F702C0D0A2E742D4D6567614D656E752D2D6C61796F757435436F6C73202E742D4D6567614D656E752D6974656D2D2D746F70207B0D0A20206D61782D77696474683A2032343070783B0D0A7D0D0A2E742D42726561646372756D622D6974';
wwv_flow_imp.g_varchar2_table(273) := '656D3A6166746572207B0D0A2020636F6C6F723A20726762612833362C2033362C2033362C20302E3735293B0D0A7D0D0A2E742D42726561646372756D622D6974656D2C0D0A2E742D42726561646372756D622D6974656D2061207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(274) := '723A20233537353735373B0D0A7D0D0A2E742D42726561646372756D622D6974656D20613A686F7665722C0D0A2E742D42726561646372756D622D6974656D20613A666F637573207B0D0A2020636F6C6F723A20233030366564303B0D0A202074657874';
wwv_flow_imp.g_varchar2_table(275) := '2D6465636F726174696F6E3A20756E6465726C696E653B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A2E742D426F64792D7469746C652D736872696E6B202E742D42726561646372756D62526567696F6E2D2D75736542726561646372756D';
wwv_flow_imp.g_varchar2_table(276) := '625469746C65202E742D42726561646372756D622D6974656D2E69732D6163746976652C0D0A2E742D426F64792D7469746C652D736872696E6B202E742D42726561646372756D62526567696F6E2D2D757365526567696F6E5469746C65202E742D4272';
wwv_flow_imp.g_varchar2_table(277) := '6561646372756D62526567696F6E2D7469746C6554657874207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20202E742D';
wwv_flow_imp.g_varchar2_table(278) := '42726561646372756D62526567696F6E2D2D757365526567696F6E5469746C65202E742D42726561646372756D62526567696F6E2D7469746C6554657874207B0D0A20202020636F6C6F723A20233234323432343B0D0A20207D0D0A7D0D0A2E742D4272';
wwv_flow_imp.g_varchar2_table(279) := '6561646372756D622D6974656D202E742D49636F6E3A686F766572207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D42726561646372756D62526567696F6E2D2D75736542726561646372756D625469746C65202E742D42726561';
wwv_flow_imp.g_varchar2_table(280) := '646372756D622D6974656D2E69732D6163746976652C0D0A2E742D42726561646372756D62526567696F6E2D7469746C6554657874207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D426F64792D7469746C65202E742D42726561';
wwv_flow_imp.g_varchar2_table(281) := '646372756D622D6974656D3A6166746572207B0D0A2020636F6C6F723A20726762612833382C2033382C2033382C20302E3735293B0D0A7D0D0A2E742D426F64792D7469746C65202E742D42726561646372756D622D6974656D2C0D0A2E742D426F6479';
wwv_flow_imp.g_varchar2_table(282) := '2D7469746C65202E742D42726561646372756D622D6974656D20612C0D0A2E742D426F64792D7469746C65202E742D42726561646372756D62526567696F6E2D2D75736542726561646372756D625469746C65202E742D42726561646372756D622D6974';
wwv_flow_imp.g_varchar2_table(283) := '656D2E69732D6163746976652C0D0A2E742D426F64792D7469746C65202E742D42726561646372756D62526567696F6E2D7469746C6554657874207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D427574746F6E2C0D0A2E612D42';
wwv_flow_imp.g_varchar2_table(284) := '7574746F6E2C0D0A2E75692D627574746F6E207B0D0A2020626F726465723A206E6F6E653B0D0A2020746578742D736861646F773A206E6F6E653B0D0A2020626F726465722D7261646975733A203270783B0D0A20207472616E736974696F6E3A206261';
wwv_flow_imp.g_varchar2_table(285) := '636B67726F756E642D636F6C6F7220302E327320656173652C20626F782D736861646F7720302E327320656173652C20636F6C6F7220302E327320656173653B0D0A7D0D0A2E742D427574746F6E202E742D49636F6E2C0D0A2E612D427574746F6E202E';
wwv_flow_imp.g_varchar2_table(286) := '742D49636F6E2C0D0A2E75692D627574746F6E202E742D49636F6E207B0D0A20207472616E736974696F6E3A20696E68657269743B0D0A7D0D0A2E742D427574746F6E3A686F7665722C0D0A2E612D427574746F6E3A686F7665722C0D0A2E75692D6275';
wwv_flow_imp.g_varchar2_table(287) := '74746F6E3A686F7665722C0D0A2E742D427574746F6E3A666F6375732C0D0A2E612D427574746F6E3A666F6375732C0D0A2E75692D627574746F6E3A666F637573207B0D0A20207A2D696E6465783A203130303B0D0A20206F75746C696E653A206E6F6E';
wwv_flow_imp.g_varchar2_table(288) := '652021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E3A666F6375733A6265666F72652C0D0A2E612D427574746F6E3A666F6375733A6265666F72652C0D0A2E75692D627574746F6E3A666F6375733A6265666F72652C0D0A2E742D427574';
wwv_flow_imp.g_varchar2_table(289) := '746F6E2E69732D6163746976653A666F6375733A6265666F72652C0D0A2E612D427574746F6E2E69732D6163746976653A666F6375733A6265666F72652C0D0A2E75692D627574746F6E2E69732D6163746976653A666F6375733A6265666F7265207B0D';
wwv_flow_imp.g_varchar2_table(290) := '0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742021696D706F7274616E743B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D427574746F6E3A666F6375733A6163746976653A6265666F72652C';
wwv_flow_imp.g_varchar2_table(291) := '0D0A2E612D427574746F6E3A666F6375733A6163746976653A6265666F72652C0D0A2E75692D627574746F6E3A666F6375733A6163746976653A6265666F72652C0D0A2E742D427574746F6E2E69732D6163746976653A666F6375733A6163746976653A';
wwv_flow_imp.g_varchar2_table(292) := '6265666F72652C0D0A2E612D427574746F6E2E69732D6163746976653A666F6375733A6163746976653A6265666F72652C0D0A2E75692D627574746F6E2E69732D6163746976653A666F6375733A6163746976653A6265666F7265207B0D0A20206F7061';
wwv_flow_imp.g_varchar2_table(293) := '636974793A20303B0D0A7D0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D6C696E6B293A6E6F74282E742D427574746F6E2D2D686561646572293A6163746976652C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(294) := '2D6C696E6B293A6E6F74282E742D427574746F6E2D2D686561646572292E69732D616374697665207B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E31352920696E7365742C20302032707820';
wwv_flow_imp.g_varchar2_table(295) := '327078207267626128302C20302C20302C20302E31352920696E7365742021696D706F7274616E743B0D0A7D0D0A2E612D427574746F6E3A6265666F72652C0D0A2E742D427574746F6E3A6265666F72652C0D0A2E75692D627574746F6E3A6265666F72';
wwv_flow_imp.g_varchar2_table(296) := '652C0D0A2E612D427574746F6E3A61667465722C0D0A2E742D427574746F6E3A61667465722C0D0A2E75692D627574746F6E3A6166746572207B0D0A2020636F6E74656E743A2027273B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20';
wwv_flow_imp.g_varchar2_table(297) := '20746F703A20303B0D0A20206C6566743A20303B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A2020626F726465722D7261646975733A20696E68657269743B0D0A20206F7061636974793A20303B0D0A202074';
wwv_flow_imp.g_varchar2_table(298) := '72616E736974696F6E3A20302E327320656173653B0D0A7D0D0A2E612D427574746F6E3A6265666F72652C0D0A2E742D427574746F6E3A6265666F72652C0D0A2E75692D627574746F6E3A6265666F7265207B0D0A20207A2D696E6465783A20313B0D0A';
wwv_flow_imp.g_varchar2_table(299) := '7D0D0A2E612D427574746F6E3A61667465722C0D0A2E742D427574746F6E3A61667465722C0D0A2E75692D627574746F6E3A6166746572207B0D0A20207A2D696E6465783A202D313B0D0A2020626F782D736861646F773A203020327078203170782072';
wwv_flow_imp.g_varchar2_table(300) := '67626128302C20302C20302C20302E303735293B0D0A20207472616E73666F726D3A207472616E736C61746559282D327078293B0D0A7D0D0A2E612D427574746F6E3A666F6375733A61667465722C0D0A2E742D427574746F6E3A666F6375733A616674';
wwv_flow_imp.g_varchar2_table(301) := '65722C0D0A2E75692D627574746F6E3A666F6375733A61667465722C0D0A2E612D427574746F6E3A6E6F74282E742D427574746F6E2D2D6C696E6B293A686F7665723A61667465722C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(302) := '6C696E6B293A686F7665723A61667465722C0D0A2E75692D627574746F6E3A6E6F74282E742D427574746F6E2D2D6C696E6B293A686F7665723A6166746572207B0D0A20206F7061636974793A20313B0D0A20207472616E73666F726D3A207472616E73';
wwv_flow_imp.g_varchar2_table(303) := '6C617465592830293B0D0A7D0D0A2E612D427574746F6E3A666F6375733A6163746976653A61667465722C0D0A2E742D427574746F6E3A666F6375733A6163746976653A61667465722C0D0A2E75692D627574746F6E3A666F6375733A6163746976653A';
wwv_flow_imp.g_varchar2_table(304) := '6166746572207B0D0A20206F7061636974793A20303B0D0A20207472616E73666F726D3A207472616E736C61746559282D327078293B0D0A7D0D0A2E612D427574746F6E3A666F6375733A61667465722C0D0A2E742D427574746F6E3A666F6375733A61';
wwv_flow_imp.g_varchar2_table(305) := '667465722C0D0A2E75692D627574746F6E3A666F6375733A6166746572207B0D0A20207472616E73666F726D3A207472616E736C617465592830293B0D0A2020626F782D736861646F773A203020302031707820317078207267626128302C203131382C';
wwv_flow_imp.g_varchar2_table(306) := '203232332C20302E3235293B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C2C0D0A2E61706578';
wwv_flow_imp.g_varchar2_table(307) := '2D627574746F6E2D67726F757020696E707574202B206C6162656C2C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D73696D706C65292C0D0A2E75692D627574746F6E2C0D0A2E612D427574746F6E2C0D0A2E612D427574746F6E2E';
wwv_flow_imp.g_varchar2_table(308) := '612D427574746F6E2D2D706F7075704C4F562C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C73207B0D0A2020636F6C6F723A20233338333833383B0D0A20206261636B67726F756E642D636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(309) := '38663866383B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E3132352920696E7365743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47';
wwv_flow_imp.g_varchar2_table(310) := '726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A686F7665722C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C3A686F7665722C0D0A2E742D427574746F6E3A6E';
wwv_flow_imp.g_varchar2_table(311) := '6F74282E742D427574746F6E2D2D73696D706C65293A686F7665722C0D0A2E75692D627574746F6E3A686F7665722C0D0A2E612D427574746F6E3A686F7665722C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F563A686F7665';
wwv_flow_imp.g_varchar2_table(312) := '722C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C733A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A203020302030203170';
wwv_flow_imp.g_varchar2_table(313) := '78207267626128302C20302C20302C20302E31352920696E7365743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E707574';
wwv_flow_imp.g_varchar2_table(314) := '202B206C6162656C3A666F6375732C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C3A666F6375732C0D0A2E742D427574746F6E3A6E6F74282E742D427574746F6E2D2D73696D706C65293A666F6375732C0D0A2E';
wwv_flow_imp.g_varchar2_table(315) := '75692D627574746F6E3A666F6375732C0D0A2E612D427574746F6E3A666F6375732C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F563A666F6375732C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D63';
wwv_flow_imp.g_varchar2_table(316) := '6F6E74726F6C733A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D697465';
wwv_flow_imp.g_varchar2_table(317) := '6D2D67726F75702D2D726320696E707574202B206C6162656C2E69732D6163746976652C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C2E69732D6163746976652C0D0A2E742D427574746F6E3A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(318) := '427574746F6E2D2D73696D706C65292E69732D6163746976652C0D0A2E75692D627574746F6E2E69732D6163746976652C0D0A2E612D427574746F6E2E69732D6163746976652C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F';
wwv_flow_imp.g_varchar2_table(319) := '562E69732D6163746976652C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C732E69732D6163746976652C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F75';
wwv_flow_imp.g_varchar2_table(320) := '70202E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A6163746976652C0D0A2E617065782D627574746F6E2D67726F757020696E707574202B206C6162656C3A6163746976652C0D0A2E742D427574746F6E3A6E6F';
wwv_flow_imp.g_varchar2_table(321) := '74282E742D427574746F6E2D2D73696D706C65293A6163746976652C0D0A2E75692D627574746F6E3A6163746976652C0D0A2E612D427574746F6E3A6163746976652C0D0A2E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F563A6163';
wwv_flow_imp.g_varchar2_table(322) := '746976652C0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C733A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236465646564653B0D0A7D0D0A2E75692D627574746F6E3A686F7665';
wwv_flow_imp.g_varchar2_table(323) := '72207B0D0A2020636F6C6F723A20233338333833383B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(324) := '636F6C6F723A20236438643864383B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F7570';
wwv_flow_imp.g_varchar2_table(325) := '2D2D726320696E7075743A616374697665202B206C6162656C2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A666F6375';
wwv_flow_imp.g_varchar2_table(326) := '733A6E6F74283A636865636B656429202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A616374697665202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A666F6375733A6E';
wwv_flow_imp.g_varchar2_table(327) := '6F74283A636865636B656429202B206C6162656C207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C20302030203020327078202366396639663920696E7365742021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(328) := '20206F75746C696E653A206E6F6E653B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67';
wwv_flow_imp.g_varchar2_table(329) := '726F75702D2D726320696E7075743A636865636B65643A666F637573202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B65643A666F637573202B206C6162656C207B0D0A2020626F782D736861646F';
wwv_flow_imp.g_varchar2_table(330) := '773A20302030203020317078202330303736646620696E7365742C20302030203020327078202366396639663920696E7365742021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574';
wwv_flow_imp.g_varchar2_table(331) := '746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A636865636B6564202B206C6162656C2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B6564202B206C6162656C207B0D0A2020';
wwv_flow_imp.g_varchar2_table(332) := '626F726465722D636F6C6F723A20233030373664663B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D';
wwv_flow_imp.g_varchar2_table(333) := '427574746F6E2D2D686F742C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D427574746F6E2D2D73696D706C65292C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F742C0D0A626F6479202E75692D73746174';
wwv_flow_imp.g_varchar2_table(334) := '652D64656661756C742E75692D7072696F726974792D7072696D617279207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D427574746F6E2D2D686F743A';
wwv_flow_imp.g_varchar2_table(335) := '686F7665722C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D427574746F6E2D2D73696D706C65293A686F7665722C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F743A686F7665722C0D0A626F6479202E75';
wwv_flow_imp.g_varchar2_table(336) := '692D73746174652D64656661756C742E75692D7072696F726974792D7072696D6172793A686F7665722C0D0A2E612D427574746F6E2D2D686F743A6E6F74283A616374697665293A666F6375732C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E';
wwv_flow_imp.g_varchar2_table(337) := '742D427574746F6E2D2D73696D706C65293A6E6F74283A616374697665293A666F6375732C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F743A6E6F74283A616374697665293A666F6375732C0D0A626F6479202E75692D';
wwv_flow_imp.g_varchar2_table(338) := '73746174652D64656661756C742E75692D7072696F726974792D7072696D6172793A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233030383366393B0D0A7D0D0A2E612D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(339) := '686F743A6163746976652C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E742D427574746F6E2D2D73696D706C65293A6163746976652C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F743A6163746976652C0D0A';
wwv_flow_imp.g_varchar2_table(340) := '626F6479202E75692D73746174652D64656661756C742E75692D7072696F726974792D7072696D6172793A6163746976652C0D0A2E612D427574746F6E2D2D686F742E69732D6163746976652C0D0A2E742D427574746F6E2D2D686F743A6E6F74282E74';
wwv_flow_imp.g_varchar2_table(341) := '2D427574746F6E2D2D73696D706C65292E69732D6163746976652C0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F742E69732D6163746976652C0D0A626F6479202E75692D73746174652D64656661756C742E75692D7072';
wwv_flow_imp.g_varchar2_table(342) := '696F726974792D7072696D6172792E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233030363963363B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D627574746F6E2D2D686F74207B0D0A2020666F6E';
wwv_flow_imp.g_varchar2_table(343) := '742D7765696768743A20626F6C643B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020636F6C6F723A20233434333330';
wwv_flow_imp.g_varchar2_table(344) := '323B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F7428';
wwv_flow_imp.g_varchar2_table(345) := '2E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236663646337633B0D0A7D0D0A2E742D427574';
wwv_flow_imp.g_varchar2_table(346) := '746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A';
wwv_flow_imp.g_varchar2_table(347) := '6E6F74282E742D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665';
wwv_flow_imp.g_varchar2_table(348) := '207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A7D0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B';
wwv_flow_imp.g_varchar2_table(349) := '0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574';
wwv_flow_imp.g_varchar2_table(350) := '746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A202334';
wwv_flow_imp.g_varchar2_table(351) := '32626533313B0D0A7D0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E74';
wwv_flow_imp.g_varchar2_table(352) := '2D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F';
wwv_flow_imp.g_varchar2_table(353) := '6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A7D0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E';
wwv_flow_imp.g_varchar2_table(354) := '742D427574746F6E2D2D686F7429207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429';
wwv_flow_imp.g_varchar2_table(355) := '3A686F7665722C0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F637573207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(356) := '6F756E642D636F6C6F723A20236635356134653B0D0A7D0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D64';
wwv_flow_imp.g_varchar2_table(357) := '616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E';
wwv_flow_imp.g_varchar2_table(358) := '6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73';
wwv_flow_imp.g_varchar2_table(359) := '696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020636F6C6F723A20233030313832643B0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E74';
wwv_flow_imp.g_varchar2_table(360) := '2D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74283A616374697665293A666F63';
wwv_flow_imp.g_varchar2_table(361) := '7573207B0D0A20206261636B67726F756E642D636F6C6F723A20236336653466663B0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F7429';
wwv_flow_imp.g_varchar2_table(362) := '2C0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74293A6163746976652C0D0A2E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D';
wwv_flow_imp.g_varchar2_table(363) := '427574746F6E2D2D73696D706C65293A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236163643866663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C653A';
wwv_flow_imp.g_varchar2_table(364) := '6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D4275';
wwv_flow_imp.g_varchar2_table(365) := '74746F6E2D2D7761726E696E6729207B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A2020636F6C6F723A20233430343034303B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C2030';
wwv_flow_imp.g_varchar2_table(366) := '2C20302C20302E3132352920696E7365743B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D70';
wwv_flow_imp.g_varchar2_table(367) := '72696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74';
wwv_flow_imp.g_varchar2_table(368) := '293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67293A666F63';
wwv_flow_imp.g_varchar2_table(369) := '75732C0D0A2E742D427574746F6E2D2D73696D706C653A6E6F74282E742D427574746F6E2D2D686F74293A6E6F74282E742D427574746F6E2D2D64616E676572293A6E6F74282E742D427574746F6E2D2D7072696D617279293A6E6F74282E742D427574';
wwv_flow_imp.g_varchar2_table(370) := '746F6E2D2D73756363657373293A6E6F74282E742D427574746F6E2D2D7761726E696E67292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C';
wwv_flow_imp.g_varchar2_table(371) := '652E742D427574746F6E2D2D686F74207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F';
wwv_flow_imp.g_varchar2_table(372) := '6E2D2D73696D706C652E742D427574746F6E2D2D686F742C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F74202E742D49636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(373) := '2D2D73696D706C652E742D427574746F6E2D2D686F743A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D68';
wwv_flow_imp.g_varchar2_table(374) := '6F742E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A';
wwv_flow_imp.g_varchar2_table(375) := '686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F742E69732D61';
wwv_flow_imp.g_varchar2_table(376) := '6374697665202E742D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020';
wwv_flow_imp.g_varchar2_table(377) := '626F782D736861646F773A20302030203020317078202361636438666620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D70';
wwv_flow_imp.g_varchar2_table(378) := '72696D6172793A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(379) := '6C6F723A20233264396366663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E';
wwv_flow_imp.g_varchar2_table(380) := '742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74';
wwv_flow_imp.g_varchar2_table(381) := '292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236163643866663B0D0A2020636F6C6F723A20233030313832643B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D61';
wwv_flow_imp.g_varchar2_table(382) := '72793A6E6F74282E742D427574746F6E2D2D686F74293A686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74293A666F637573';
wwv_flow_imp.g_varchar2_table(383) := '202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20233030';
wwv_flow_imp.g_varchar2_table(384) := '313832643B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020626F782D736861646F773A203020302030203170782023464243453441';
wwv_flow_imp.g_varchar2_table(385) := '20696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74292C0D0A';
wwv_flow_imp.g_varchar2_table(386) := '2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A2020636F6C6F723A20236331393130343B0D0A7D0D0A2E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(387) := '73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D42757474';
wwv_flow_imp.g_varchar2_table(388) := '6F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(389) := '6F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74293A686F76657220';
wwv_flow_imp.g_varchar2_table(390) := '2E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74293A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E';
wwv_flow_imp.g_varchar2_table(391) := '742D427574746F6E2D2D7761726E696E673A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E74';
wwv_flow_imp.g_varchar2_table(392) := '2D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F7429207B0D0A2020626F782D736861646F773A20302030203020317078202366343433333620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(393) := '4646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E';
wwv_flow_imp.g_varchar2_table(394) := '6765723A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A2020636F6C6F723A20236634343333363B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D42';
wwv_flow_imp.g_varchar2_table(395) := '7574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C65';
wwv_flow_imp.g_varchar2_table(396) := '2E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A2020636F6C6F723A20236666666666663B0D0A';
wwv_flow_imp.g_varchar2_table(397) := '7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(398) := '2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74293A666F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A6E6F74282E742D427574746F6E2D2D686F74292E';
wwv_flow_imp.g_varchar2_table(399) := '69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F7429207B';
wwv_flow_imp.g_varchar2_table(400) := '0D0A2020626F782D736861646F773A20302030203020317078202333424141324320696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F';
wwv_flow_imp.g_varchar2_table(401) := '6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74292C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F7429202E742D49636F6E207B0D0A';
wwv_flow_imp.g_varchar2_table(402) := '2020636F6C6F723A20233362616132633B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74293A686F7665722C0D0A2E742D427574746F6E2D2D73696D';
wwv_flow_imp.g_varchar2_table(403) := '706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74293A666F6375732C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(404) := '2D686F74292E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D73';
wwv_flow_imp.g_varchar2_table(405) := '7563636573733A6E6F74282E742D427574746F6E2D2D686F74293A686F766572202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74293A66';
wwv_flow_imp.g_varchar2_table(406) := '6F637573202E742D49636F6E2C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A6E6F74282E742D427574746F6E2D2D686F74292E69732D616374697665202E742D49636F6E207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(407) := '20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D6E6F5549207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55493A6E6F74';
wwv_flow_imp.g_varchar2_table(408) := '283A686F766572293A6E6F74283A666F637573293A6E6F74282E69732D61637469766529207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55493A686F7665722C0D0A2E742D427574746F6E2D2D6E';
wwv_flow_imp.g_varchar2_table(409) := '6F55493A666F6375732C0D0A2E742D427574746F6E2D2D6E6F55492E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55493A666F6375733A686F7665';
wwv_flow_imp.g_varchar2_table(410) := '72207B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E3132352920696E7365743B0D0A7D0D0A2E742D427574746F6E2D2D6C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(411) := '7472616E73706172656E742021696D706F7274616E743B0D0A2020626F782D736861646F773A206E6F6E652021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6C696E6B3A686F766572207B0D0A2020746578742D6465636F72617469';
wwv_flow_imp.g_varchar2_table(412) := '6F6E3A20756E6465726C696E653B0D0A7D0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2C0D0A2E742D427574746F6E2D2D6C696E6B202E742D49636F6E207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A2E742D4275';
wwv_flow_imp.g_varchar2_table(413) := '74746F6E2D2D6E6F55492E742D427574746F6E2D2D686F742C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D686F74202E742D49636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(414) := '2D6E6F55492E742D427574746F6E2D2D7072696D6172792C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D7072696D6172792C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D7072696D617279202E742D49';
wwv_flow_imp.g_varchar2_table(415) := '636F6E2C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D7072696D617279202E742D49636F6E207B0D0A2020636F6C6F723A20233264396366662021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E';
wwv_flow_imp.g_varchar2_table(416) := '742D427574746F6E2D2D7761726E696E672C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D7761726E696E672C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D7761726E696E67202E742D49636F6E2C0D0A';
wwv_flow_imp.g_varchar2_table(417) := '2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D7761726E696E67202E742D49636F6E207B0D0A2020636F6C6F723A20236331393130342021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D42757474';
wwv_flow_imp.g_varchar2_table(418) := '6F6E2D2D64616E6765722C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D64616E6765722C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D64616E676572202E742D49636F6E2C0D0A2E742D427574746F6E';
wwv_flow_imp.g_varchar2_table(419) := '2D2D6C696E6B2E742D427574746F6E2D2D64616E676572202E742D49636F6E207B0D0A2020636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D737563636573';
wwv_flow_imp.g_varchar2_table(420) := '732C0D0A2E742D427574746F6E2D2D6C696E6B2E742D427574746F6E2D2D737563636573732C0D0A2E742D427574746F6E2D2D6E6F55492E742D427574746F6E2D2D73756363657373202E742D49636F6E2C0D0A2E742D427574746F6E2D2D6C696E6B2E';
wwv_flow_imp.g_varchar2_table(421) := '742D427574746F6E2D2D73756363657373202E742D49636F6E207B0D0A2020636F6C6F723A20233362616132632021696D706F7274616E743B0D0A7D0D0A2E742D4865616465722D6272616E64696E67202E742D427574746F6E207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(422) := '67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D686561646572207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F782D736861646F773A206E6F';
wwv_flow_imp.g_varchar2_table(423) := '6E653B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A666F6375733A6265666F72652C0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A6163746976653A666F6375733A6265666F7265207B0D0A';
wwv_flow_imp.g_varchar2_table(424) := '2020626F782D736861646F773A20302030203020317078202332643963666620696E7365742021696D706F7274616E743B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A686F7665722C0D0A2E742D427574746F6E2E74';
wwv_flow_imp.g_varchar2_table(425) := '2D427574746F6E2D2D6865616465723A666F6375732C0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(426) := '2D427574746F6E2E742D427574746F6E2D2D6865616465723A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865';
wwv_flow_imp.g_varchar2_table(427) := '616465723A6163746976652C0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465723A666F6375733A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E34293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(428) := '0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465722E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A2020626F782D736861646F773A206E6F6E';
wwv_flow_imp.g_varchar2_table(429) := '653B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D686561646572547265653A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202332643963666620696E7365743B0D0A7D0D0A406D65646961206F6E6C';
wwv_flow_imp.g_varchar2_table(430) := '792073637265656E20616E6420286D61782D77696474683A20343830707829207B0D0A20202E742D427574746F6E2E742D427574746F6E2D2D68656164657254726565207B0D0A202020206261636B67726F756E642D636F6C6F723A207267626128302C';
wwv_flow_imp.g_varchar2_table(431) := '20302C20302C20302E3235293B0D0A20207D0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6865616465725269676874207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F726465723A203170';
wwv_flow_imp.g_varchar2_table(432) := '7820736F6C696420236530653065303B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D68656164657252696768743A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236530653065303B0D0A7D0D0A2E742D4275';
wwv_flow_imp.g_varchar2_table(433) := '74746F6E2E742D427574746F6E2D2D68656164657252696768743A6163746976652C0D0A2E742D427574746F6E2E742D427574746F6E2D2D68656164657252696768742E69732D616374697665207B0D0A2020636F6C6F723A20233230323032303B0D0A';
wwv_flow_imp.g_varchar2_table(434) := '7D0D0A2E742D427574746F6E2D2D6E6176426172202E742D427574746F6E2D6261646765207B0D0A2020626F726465722D7261646975733A20313670783B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E';
wwv_flow_imp.g_varchar2_table(435) := '3335293B0D0A7D0D0A2E742D427574746F6E2D2D68656C70427574746F6E202E612D49636F6E207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E742D4865616465722D6E6176426172202E742D427574746F6E2D2D6865616465722E69732D';
wwv_flow_imp.g_varchar2_table(436) := '616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233030346539333B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6E6F5549202E66613A61667465722C0D0A2E';
wwv_flow_imp.g_varchar2_table(437) := '742D427574746F6E2E742D427574746F6E2D2D6C696E6B202E66613A61667465722C0D0A2E742D427574746F6E2E742D427574746F6E2D2D73696D706C65202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A2023464646';
wwv_flow_imp.g_varchar2_table(438) := '3B0D0A7D0D0A2E742D427574746F6E2D2D64616E676572202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A686F766572202E66613A6166746572207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(439) := '6E642D636F6C6F723A20236634343333363B0D0A7D0D0A2E742D427574746F6E2D2D73756363657373202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D737563636573733A686F766572202E66613A';
wwv_flow_imp.g_varchar2_table(440) := '6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A7D0D0A2E742D427574746F6E2D2D7072696D617279202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(441) := '2D7072696D6172793A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20236163643866663B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E67202E66613A61667465722C0D0A2E742D427574746F';
wwv_flow_imp.g_varchar2_table(442) := '6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A7D0D0A2E742D427574746F6E2D2D686F74202E66613A61';
wwv_flow_imp.g_varchar2_table(443) := '667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D426F64792D61';
wwv_flow_imp.g_varchar2_table(444) := '6374696F6E73546F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A2020626F726465722D72696768742D';
wwv_flow_imp.g_varchar2_table(445) := '636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20696E697469616C3B0D0A7D0D0A2E752D52544C202E742D426F64792D616374696F6E73546F67676C65207B0D0A2020626F726465722D636F6C6F723A207267626128302C2030';
wwv_flow_imp.g_varchar2_table(446) := '2C20302C20302E303735293B0D0A2020626F726465722D6C6566742D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D616374696F6E73546F67676C653A616374697665207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(447) := '6F723A20236530653065303B0D0A7D0D0A2E742D426F64792D616374696F6E73546F67676C653A666F6375732C0D0A2E742D426F64792D616374696F6E73546F67676C653A616374697665207B0D0A2020626F726465722D636F6C6F723A202330303736';
wwv_flow_imp.g_varchar2_table(448) := '64663B0D0A7D0D0A2E742D427574746F6E526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233236323632363B0D0A2020626F726465722D7261646975733A203270783B0D0A20';
wwv_flow_imp.g_varchar2_table(449) := '20626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A2020626F782D736861646F773A20302032707820327078207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D427574746F6E52656769';
wwv_flow_imp.g_varchar2_table(450) := '6F6E2D2D6E6F5549207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E526567696F6E2D2D77697A6172642C0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(451) := '7574746F6E526567696F6E2D2D6469616C6F67526567696F6E207B0D0A2020626F726465722D7261646975733A2030203020327078203270783B0D0A7D0D0A2E742D427574746F6E526567696F6E2D2D6469616C6F67526567696F6E207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(452) := '636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F6479202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(453) := '3A20233365336533653B0D0A7D0D0A2E742D426F64792D7469746C65202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20233430343034303B0D0A';
wwv_flow_imp.g_varchar2_table(454) := '7D0D0A2E742D426F64792D696E666F202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D526567696F6E20';
wwv_flow_imp.g_varchar2_table(455) := '2E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574746F6E526567696F6E2D7469746C652C0D0A2E742D427574746F6E526567696F6E202E742D427574746F6E526567696F6E2D2D73686F775469746C65202E742D427574';
wwv_flow_imp.g_varchar2_table(456) := '746F6E526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D427574746F6E526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E';
wwv_flow_imp.g_varchar2_table(457) := '73706172656E743B0D0A2020626F726465722D7261646975733A20303B0D0A7D0D0A2E742D4469616C6F672D666F6F746572202E742D427574746F6E526567696F6E207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(458) := '20302C20302E3035293B0D0A7D0D0A2E66632E75692D776964676574207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E66632D746F6F6C62617220';
wwv_flow_imp.g_varchar2_table(459) := '7B0D0A2020626F726465722D636F6C6F723A20236562656265623B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D7261646975733A2032707820327078203020303B0D0A7D0D0A2E66632D746F6F';
wwv_flow_imp.g_varchar2_table(460) := '6C6261722068322C0D0A2E6663202E66632D62617369632D766965772074642E66632D6461792D6E756D6265722C0D0A2E6663202E66632D6461792D6E756D626572207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E66632D6461792D';
wwv_flow_imp.g_varchar2_table(461) := '6865616465722E75692D7769646765742D6865616465722C0D0A2E66632D76696577202E75692D7769646765742D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20236632663266323B0D0A2020636F6C6F723A202332363236';
wwv_flow_imp.g_varchar2_table(462) := '32363B0D0A2020626F726465722D636F6C6F723A20236536653665363B0D0A7D0D0A6469762E66632D6167656E64614C697374207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(463) := '20236562656265623B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D646179486561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20236439643964393B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(464) := '6F723A20233236323632363B0D0A2020626F726465722D636F6C6F723A20236661666166613B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D646179207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E6663202E66632D61';
wwv_flow_imp.g_varchar2_table(465) := '67656E64614C6973742D64617465207B0D0A2020636F6C6F723A20233464346434643B0D0A7D0D0A2E6663202E66632D6167656E64614C697374202E66632D6576656E742D73746172742D74696D652C0D0A2E6663202E66632D6167656E64614C697374';
wwv_flow_imp.g_varchar2_table(466) := '202E66632D6576656E742D616C6C2D646179207B0D0A2020636F6C6F723A20233464346434643B0D0A7D0D0A626F6479202E66632074642E66632D746F6461792C0D0A626F6479202E6663202E75692D7769646765742D636F6E74656E74207B0D0A2020';
wwv_flow_imp.g_varchar2_table(467) := '626F726465722D636F6C6F723A20236536653665363B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D7769646765742D636F6E74656E742E66632D746F6461792E75692D73746174652D686967686C69676874207B0D';
wwv_flow_imp.g_varchar2_table(468) := '0A20206261636B67726F756E642D636F6C6F723A20236632663266323B0D0A7D0D0A2E6663202E66632D6167656E64614C6973742D6974656D207B0D0A2020626F726465722D636F6C6F723A20236661666166613B0D0A7D0D0A2E6663202E75692D6275';
wwv_flow_imp.g_varchar2_table(469) := '74746F6E3A6163746976652C0D0A2E6663202E75692D627574746F6E3A666F6375732C0D0A2E66632D766965773A6163746976652C0D0A2E66632D766965773A666F637573207B0D0A20206F75746C696E653A2031707820736F6C696420233030373664';
wwv_flow_imp.g_varchar2_table(470) := '663B0D0A7D0D0A2E66632D766965772D636F6E7461696E6572203E202E66632D766965773A6163746976652C0D0A2E66632D766965772D636F6E7461696E6572203E202E66632D766965773A666F637573207B0D0A20206F75746C696E653A206E6F6E65';
wwv_flow_imp.g_varchar2_table(471) := '3B0D0A7D0D0A2E742D43617264207B0D0A2020626F782D736861646F773A20302032707820347078202D327078207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D436172642D77726170207B0D0A2020626F726465722D726164';
wwv_flow_imp.g_varchar2_table(472) := '6975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D436172642D777261703A666F6375';
wwv_flow_imp.g_varchar2_table(473) := '73207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D436172642D69636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436172642D64657363207B0D0A2020636F6C6F723A20233236';
wwv_flow_imp.g_varchar2_table(474) := '323632363B0D0A7D0D0A2E742D436172642D696E666F2C0D0A2E742D436172642D7375627469746C65207B0D0A2020636F6C6F723A20233636363636363B0D0A7D0D0A2E742D436172642D7469746C65207B0D0A2020636F6C6F723A2023323632363236';
wwv_flow_imp.g_varchar2_table(475) := '3B0D0A7D0D0A2E742D436172642D636F6C6F7246696C6C2C0D0A2E742D436172642D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436172';
wwv_flow_imp.g_varchar2_table(476) := '64732D2D6665617475726564202E742D436172642D626F6479207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D43617264732D2D6261736963202E742D436172642D74';
wwv_flow_imp.g_varchar2_table(477) := '69746C6557726170207B0D0A2020626F782D736861646F773A2030202D3170782030207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D43617264732D2D636F6D70616374202E742D436172642D7469746C65577261';
wwv_flow_imp.g_varchar2_table(478) := '70207B0D0A2020626F782D736861646F773A2030202D3170782030207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D43617264732D2D6665617475726564202E742D436172642D626F6479207B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(479) := '65722D746F702D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D43617264732D2D626C6F636B202E742D49636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C';
wwv_flow_imp.g_varchar2_table(480) := '20302E31293B0D0A2020746578742D736861646F773A20302031707820317078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D43617264732D2D616E696D526169736543617264202E742D436172643A686F766572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(481) := '626F782D736861646F773A2030203130707820347078202D347078207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572207B0D0A20206D617267696E2D746F703A20333270';
wwv_flow_imp.g_varchar2_table(482) := '783B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D43617264207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D43';
wwv_flow_imp.g_varchar2_table(483) := '617264732D6974656D207B0D0A2020646973706C61793A20626C6F636B3B0D0A2020666C65782D67726F773A20313B0D0A202077696474683A203235253B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D7769647468';
wwv_flow_imp.g_varchar2_table(484) := '3A20343830707829207B0D0A20202E742D43617264732D2D73616D706C6541707073466F6F746572202E742D43617264732D6974656D207B0D0A2020202077696474683A203530253B0D0A20207D0D0A7D0D0A2E742D43617264732D2D73616D706C6541';
wwv_flow_imp.g_varchar2_table(485) := '707073466F6F746572202E742D436172642D777261702C0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D436172642D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B';
wwv_flow_imp.g_varchar2_table(486) := '0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D436172642D69636F6E207B0D0A20207472616E736974696F6E3A20302E327320656173';
wwv_flow_imp.g_varchar2_table(487) := '653B0D0A7D0D0A2E742D43617264732D2D73616D706C6541707073466F6F746572202E742D49636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A203020302030203170782072';
wwv_flow_imp.g_varchar2_table(488) := '67626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6D6F6E74685469746C65207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D436C617373696343616C656E64';
wwv_flow_imp.g_varchar2_table(489) := '61722D646179436F6C756D6E207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A2020766572746963616C2D616C69676E3A20746F703B0D0A2020626F726465722D636F6C6F723A20236632663266323B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(490) := '6C6F723A20233464346434643B0D0A7D0D0A2E742D436C617373696343616C656E6461722D646179207B0D0A2020626F726465722D636F6C6F723A20236632663266323B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6461792E69732D69';
wwv_flow_imp.g_varchar2_table(491) := '6E616374697665202E742D436C617373696343616C656E6461722D64617465207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6461792E69732D7765656B656E642C0D0A2E742D436C61737369';
wwv_flow_imp.g_varchar2_table(492) := '6343616C656E6461722D6461792E69732D696E616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236663666366633B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6461792E69732D746F646179202E742D436C61';
wwv_flow_imp.g_varchar2_table(493) := '7373696343616C656E6461722D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D64617465207B0D0A';
wwv_flow_imp.g_varchar2_table(494) := '2020636F6C6F723A20233636363636363B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6576656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20236632663266323B0D0A7D0D0A2E742D436C617373696343616C656E6461';
wwv_flow_imp.g_varchar2_table(495) := '722D6576656E74207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6576656E742061207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(496) := '3A20236666666666663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D2D7765656B6C79202E742D436C617373696343616C656E6461722D74696D65436F6C2C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D';
wwv_flow_imp.g_varchar2_table(497) := '436C617373696343616C656E6461722D74696D65436F6C207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A7D0D0A2E742D436C617373696343616C656E6461722D2D7765656B6C79202E742D436C617373696343616C';
wwv_flow_imp.g_varchar2_table(498) := '656E6461722D6461794576656E74732C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E6461722D6461794576656E7473207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(499) := '2D436C617373696343616C656E6461722D2D7765656B6C79202E742D436C617373696343616C656E6461722D6461794576656E747320612C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E64';
wwv_flow_imp.g_varchar2_table(500) := '61722D6461794576656E74732061207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D2D7765656B6C79202E742D';
wwv_flow_imp.g_varchar2_table(501) := '436C617373696343616C656E6461722D6461792E69732D746F6461792C0D0A2E742D436C617373696343616C656E6461722D2D6461696C79202E742D436C617373696343616C656E6461722D6461792E69732D746F646179207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(502) := '6F756E642D636F6C6F723A20236466663066663B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6C697374207B0D0A2020626F726465722D636F6C6F723A20236632663266323B0D0A7D0D0A2E742D436C617373696343616C656E6461722D';
wwv_flow_imp.g_varchar2_table(503) := '6C6973745469746C652C0D0A2E742D436C617373696343616C656E6461722D6C6973744576656E74207B0D0A2020626F726465722D636F6C6F723A20236632663266323B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6C6973745469746C';
wwv_flow_imp.g_varchar2_table(504) := '65207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A2020636F6C6F723A20233464346434643B0D0A7D0D0A2E742D436C617373696343616C656E6461722D6C6973744576656E74207B0D0A2020636F6C6F723A202332';
wwv_flow_imp.g_varchar2_table(505) := '36323632363B0D0A7D0D0A2E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D636F6D6D656E74207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(506) := '723A20233030303B0D0A7D0D0A2E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C2030293B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(507) := '6465722D72696768742D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E752D52544C202E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(508) := '726465722D72696768742D636F6C6F723A207267626128302C20302C20302C2030293B0D0A2020626F726465722D6C6566742D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D436F6D6D656E74732D2D63686174';
wwv_flow_imp.g_varchar2_table(509) := '202E742D436F6D6D656E74732D6974656D2E69732D616374697665202E742D436F6D6D656E74732D636F6D6D656E74207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(510) := '20233030303B0D0A7D0D0A2E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D6974656D2E69732D616374697665202E742D436F6D6D656E74732D636F6D6D656E743A6166746572207B0D0A2020626F726465722D72696768742D';
wwv_flow_imp.g_varchar2_table(511) := '636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E752D52544C202E742D436F6D6D656E74732D2D63686174202E742D436F6D6D656E74732D6974656D2E69732D616374697665202E742D436F6D6D656E74732D636F6D6D65';
wwv_flow_imp.g_varchar2_table(512) := '6E743A6166746572207B0D0A2020626F726465722D72696768742D636F6C6F723A207267626128302C20302C20302C2030293B0D0A2020626F726465722D6C6566742D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(513) := '2D436F6D6D656E74732D2D6261736963202E742D436F6D6D656E74732D6974656D2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236662666266623B0D0A7D0D0A2E742D436F6D6D656E74732D6974656D2E69732D';
wwv_flow_imp.g_varchar2_table(514) := '73797374656D4D657373616765207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612831332C2031332C2031332C20302E3035293B0D0A7D0D0A2E742D436F6D6D656E74732D696E666F207B0D0A2020636F6C6F723A20726762612830';
wwv_flow_imp.g_varchar2_table(515) := '2C20302C20302C20302E3635293B0D0A7D0D0A2E742D436F6D6D656E74732D636F6D6D656E74207B0D0A2020636F6C6F723A20233030303B0D0A7D0D0A2E742D436F6D706C6574656E657373207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(516) := '236666666666663B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A612E742D436F6D706C6574656E6573733A686F766572202E742D436F6D706C6574656E65';
wwv_flow_imp.g_varchar2_table(517) := '73732D6C6162656C57726170207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A7D0D0A612E742D436F6D706C6574656E6573733A686F766572202E742D436F6D706C6574656E6573732D';
wwv_flow_imp.g_varchar2_table(518) := '6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D436F6D706C6574656E6573732D66696C6C207B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(519) := '20302C20302E31352920696E7365743B0D0A7D0D0A2E742D436F6D706C6574656E6573732D6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(520) := '723A207267626128302C20302C20302C20302E3735293B0D0A7D0D0A2E742D436F6E66696750616E656C207B0D0A2020626F782D736861646F773A2030202D3170782030207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(521) := '742D436F6E66696750616E656C2D61626F7574207B0D0A20206261636B67726F756E642D636F6C6F723A20236666663765303B0D0A2020636F6C6F723A20233536353635363B0D0A2020626F782D736861646F773A2030202D3170782030207267626128';
wwv_flow_imp.g_varchar2_table(522) := '302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D436F6E66696750616E656C2D6D61696E207B0D0A2020626F782D736861646F773A202D31707820302030207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(523) := '0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20363430707829207B0D0A20202E742D436F6E66696750616E656C2D6D61696E207B0D0A20202020626F782D736861646F773A2030202D31707820302072676261';
wwv_flow_imp.g_varchar2_table(524) := '28302C20302C20302C20302E312920696E7365743B0D0A20207D0D0A7D0D0A2E742D436F6E66696750616E656C2D69636F6E207B0D0A2020626F726465722D7261646975733A20313030253B0D0A20206261636B67726F756E642D636F6C6F723A202341';
wwv_flow_imp.g_varchar2_table(525) := '30413041303B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D436F6E66696750616E656C2D69636F6E2E69732D656E61626C6564207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A7D0D0A2E742D436F6E';
wwv_flow_imp.g_varchar2_table(526) := '66696750616E656C2D69636F6E2E69732D64697361626C6564207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A7D0D0A2E742D436F6E66696750616E656C2D73657474696E672C0D0A2E742D436F6E66696750616E65';
wwv_flow_imp.g_varchar2_table(527) := '6C2D737461747573207B0D0A2020636F6C6F723A20233636363636363B0D0A7D0D0A2E742D436F6E66696750616E656C2D737461747573207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D436F6E66696750616E656C2D61747472';
wwv_flow_imp.g_varchar2_table(528) := '4C696E6B207B0D0A2020636F6C6F723A20233636363636363B0D0A2020626F782D736861646F773A2030202D3170782030207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D436F6E66696750616E656C2D61747472';
wwv_flow_imp.g_varchar2_table(529) := '4C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A2020626F782D736861646F773A2030203170782030207267626128302C20302C20302C20302E3035293B0D0A';
wwv_flow_imp.g_varchar2_table(530) := '7D0D0A2E742D436F6E66696750616E656C2D6174747256616C7565207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A2E742D436F6E74656E74426C6F636B2D2D736861646F774247202E742D436F6E74656E74426C6F636B2D626F647920';
wwv_flow_imp.g_varchar2_table(531) := '7B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D436F6E74656E74426C6F636B';
wwv_flow_imp.g_varchar2_table(532) := '2D2D6C696768744247202E742D436F6E74656E74426C6F636B2D626F6479207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D436F6E74656E74526F772D6974656D207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(533) := '726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E742D436F6E74656E74526F772D69636F6E577261702C0D0A2E742D436F6E74656E74526F772D6465736372697074696F6E2C0D0A2E74';
wwv_flow_imp.g_varchar2_table(534) := '2D436F6E74656E74526F772D6D697363207B0D0A2020636F6C6F723A20233636363636363B0D0A7D0D0A2E742D4469616C6F67207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4469616C6F67203A3A';
wwv_flow_imp.g_varchar2_table(535) := '2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A20206261636B67726F756E642D636F6C6F723A20236266626662663B0D0A7D0D0A2E742D4469616C6F67203A3A2D7765626B69742D7363726F6C6C6261722D7468756D623A686F7665';
wwv_flow_imp.g_varchar2_table(536) := '72207B0D0A20206261636B67726F756E642D636F6C6F723A20236233623362333B0D0A7D0D0A2E742D4469616C6F673A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261636B67726F756E642D636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(537) := '6666663B0D0A7D0D0A2E742D4469616C6F67526567696F6E2D627574746F6E73207B0D0A2020626F782D736861646F773A20696E7365742030203170782030207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E612D46532D636F6E7472';
wwv_flow_imp.g_varchar2_table(538) := '6F6C202B202E612D46532D636F6E74726F6C207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E612D46532D746F67676C65207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(539) := '3A207267626128302C20302C20302C20302E32293B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E612D46532D746F67676C653A686F766572207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(540) := '6E642D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A7D0D0A2E612D46532D746F67676C653A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F782D736861646F773A';
wwv_flow_imp.g_varchar2_table(541) := '203020317078203170782030207267626128302C203131382C203232332C20302E3835293B0D0A7D0D0A2E612D46532D636C656172427574746F6E2C0D0A2E612D46532D746F67676C654F766572666C6F77207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(542) := '6F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E612D46532D736561726368207370616E2E617065782D6974656D2D69636F6E2C0D0A2E612D46532D66696C746572207370616E2E617065782D';
wwv_flow_imp.g_varchar2_table(543) := '6974656D2D69636F6E207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3635293B0D0A7D0D0A2E612D46532D736561726368207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20';
wwv_flow_imp.g_varchar2_table(544) := '302E31293B0D0A7D0D0A2E742D466F6F746572207B0D0A2020626F726465722D746F703A2031707820736F6C6964207267626128302C20302C20302C20302E3035293B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20';
wwv_flow_imp.g_varchar2_table(545) := '302C20302E303235293B0D0A7D0D0A2E742D466F6F7465722D746F70427574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233537353735373B0D0A2020626F782D736861646F773A';
wwv_flow_imp.g_varchar2_table(546) := '20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D466F6F7465722D746F70427574746F6E3A686F766572207B0D0A2020626F782D736861646F773A2030203020302031707820726762612830';
wwv_flow_imp.g_varchar2_table(547) := '2C20302C20302C20302E312920696E7365742C20302032707820347078207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D466F6F7465722D746F70427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A203020';
wwv_flow_imp.g_varchar2_table(548) := '30203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E65723A6265666F7265207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E612D4952522D7365617263682D6669656C';
wwv_flow_imp.g_varchar2_table(549) := '642C0D0A2E612D4947202E612D546F6F6C6261722D696E707574546578742C0D0A2E612D4952522D73656C6563744C697374207B0D0A2020636F6C6F723A20233230323032303B0D0A20206261636B67726F756E642D636F6C6F723A2023663966396639';
wwv_flow_imp.g_varchar2_table(550) := '3B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A2E612D4947202E612D546F6F6C6261722D696E70757454657874207B0D0A2020626F782D736861646F773A20302030203020317078202364666466646620696E7365743B';
wwv_flow_imp.g_varchar2_table(551) := '0D0A7D0D0A2E617065782D6974656D2D74657874617265612C0D0A2E617065782D6974656D2D746578742C0D0A2E617065782D6974656D2D73656C6563742C0D0A2E617065782D6974656D2D6D756C74692C0D0A73656C6563742E6C6973746D616E6167';
wwv_flow_imp.g_varchar2_table(552) := '65722C0D0A2E75692D646174657069636B65722D6D6F6E74682C0D0A2E75692D646174657069636B65722D79656172207B0D0A2020636F6C6F723A20233230323032303B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A';
wwv_flow_imp.g_varchar2_table(553) := '2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A2E617065782D6974656D2D74657874617265612E617065782D706167652D6974656D2D6572726F722C0D0A2E617065782D6974656D2D746578742E617065782D706167652D6974';
wwv_flow_imp.g_varchar2_table(554) := '656D2D6572726F722C0D0A2E617065782D6974656D2D73656C6563742E617065782D706167652D6974656D2D6572726F722C0D0A2E617065782D6974656D2D6D756C74692E617065782D706167652D6974656D2D6572726F722C0D0A73656C6563742E6C';
wwv_flow_imp.g_varchar2_table(555) := '6973746D616E616765722E617065782D706167652D6974656D2D6572726F722C0D0A2E75692D646174657069636B65722D6D6F6E74682E617065782D706167652D6974656D2D6572726F722C0D0A2E75692D646174657069636B65722D796561722E6170';
wwv_flow_imp.g_varchar2_table(556) := '65782D706167652D6974656D2D6572726F72207B0D0A2020626F726465722D636F6C6F723A20236637373036363B0D0A7D0D0A2E617065782D6974656D2D74657874617265612E617065782D706167652D6974656D2D6572726F723A7265717569726564';
wwv_flow_imp.g_varchar2_table(557) := '3A76616C69642C0D0A2E617065782D6974656D2D746578742E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E617065782D6974656D2D73656C6563742E617065782D706167652D6974656D2D6572726F';
wwv_flow_imp.g_varchar2_table(558) := '723A72657175697265643A76616C69642C0D0A2E617065782D6974656D2D6D756C74692E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A73656C6563742E6C6973746D616E616765722E617065782D7061';
wwv_flow_imp.g_varchar2_table(559) := '67652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E75692D646174657069636B65722D6D6F6E74682E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C69642C0D0A2E75692D646174657069';
wwv_flow_imp.g_varchar2_table(560) := '636B65722D796561722E617065782D706167652D6974656D2D6572726F723A72657175697265643A76616C6964207B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A2E75692D6469616C6F67202E752D466F726D2D696E70';
wwv_flow_imp.g_varchar2_table(561) := '7574436F6E7461696E657220696E7075742C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722073656C6563742C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E657220746578';
wwv_flow_imp.g_varchar2_table(562) := '7461726561207B0D0A2020636F6C6F723A20233230323032303B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A2E75692D6469616C6F67202E75';
wwv_flow_imp.g_varchar2_table(563) := '2D466F726D2D696E707574436F6E7461696E657220696E7075743A686F7665722C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722073656C6563743A686F7665722C0D0A2E75692D6469616C6F67202E752D466F';
wwv_flow_imp.g_varchar2_table(564) := '726D2D696E707574436F6E7461696E65722074657874617265613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E';
wwv_flow_imp.g_varchar2_table(565) := '657220696E7075743A666F6375732C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E65722073656C6563743A666F6375732C0D0A2E75692D6469616C6F67202E752D466F726D2D696E707574436F6E7461696E657220';
wwv_flow_imp.g_varchar2_table(566) := '74657874617265613A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A2020626F726465722D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(567) := '742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D74657874617265612E6A732D73686F772D6C6162656C202E742D466F726D2D6C6162656C3A6265666F72652C';
wwv_flow_imp.g_varchar2_table(568) := '0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D74657874617265612E69732D616374697665202E742D466F726D2D6C6162656C3A6265666F7265207B';
wwv_flow_imp.g_varchar2_table(569) := '0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D7465787461726561';
wwv_flow_imp.g_varchar2_table(570) := '3A666F6375732D77697468696E202E742D466F726D2D6C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461';
wwv_flow_imp.g_varchar2_table(571) := '696E65722D2D666C6F6174696E674C6162656C2E617065782D6974656D2D777261707065722D2D74657874617265613A686F766572202E742D466F726D2D6C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(572) := '66666666663B0D0A7D0D0A2E617065782D6974656D2D746578742C0D0A2E617065782D6974656D2D73656C6563742C0D0A2E617065782D6974656D2D7465787461726561207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E61';
wwv_flow_imp.g_varchar2_table(573) := '7065782D6974656D2D6D756C7469202E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F76207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F726465722D636F6C';
wwv_flow_imp.g_varchar2_table(574) := '6F723A207472616E73706172656E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E742D466F726D2D696E707574436F6E7461696E6572202E617065782D6974656D2D646973706C6179';
wwv_flow_imp.g_varchar2_table(575) := '2D6F6E6C79207B0D0A2020636F6C6F723A20233230323032303B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A2020626F726465722D7374796C653A20';
wwv_flow_imp.g_varchar2_table(576) := '6461736865643B0D0A7D0D0A2E617065782D6974656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20726762612833322C2033322C203332';
wwv_flow_imp.g_varchar2_table(577) := '2C20302E37293B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E617065782D6974656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A2020626F726465722D7261646975733A';
wwv_flow_imp.g_varchar2_table(578) := '2030203270782032707820303B0D0A7D0D0A2E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F726465722D7261646975733A203020';
wwv_flow_imp.g_varchar2_table(579) := '3270782032707820303B0D0A7D0D0A2E752D52544C202E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E617065782D6974656D2D';
wwv_flow_imp.g_varchar2_table(580) := '66696C653A686F766572202B202E617065782D6974656D2D66696C652D64726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E652D6C6162656C207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E617065782D';
wwv_flow_imp.g_varchar2_table(581) := '6974656D2D66696C653A686F766572202B202E617065782D6974656D2D66696C652D64726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(582) := '6666663B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E617065782D6974656D2D66696C653A666F637573202B202E617065782D6974656D2D66696C652D64726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E';
wwv_flow_imp.g_varchar2_table(583) := '652D6C6162656C207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E617065782D6974656D2D66696C653A666F637573202B202E617065782D6974656D2D66696C652D64';
wwv_flow_imp.g_varchar2_table(584) := '726F707A6F6E65202E617065782D6974656D2D66696C652D64726F707A6F6E652D69636F6E207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A202063';
wwv_flow_imp.g_varchar2_table(585) := '6F6C6F723A20236666666666663B0D0A7D0D0A2E617065782D6974656D2D74657874617265613A666F6375732C0D0A2E617065782D6974656D2D746578743A666F6375732C0D0A2E617065782D6974656D2D73656C6563743A666F6375732C0D0A2E6170';
wwv_flow_imp.g_varchar2_table(586) := '65782D6974656D2D6D756C74693A666F6375732C0D0A73656C6563742E6C6973746D616E616765723A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(587) := '636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263683A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E61706578';
wwv_flow_imp.g_varchar2_table(588) := '2D6974656D2D746578742E612D506F7075704C4F562D7365617263682E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F763A';
wwv_flow_imp.g_varchar2_table(589) := '666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D';
wwv_flow_imp.g_varchar2_table(590) := '0A2E617065782D6974656D2D6D756C74693A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74692E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A';
wwv_flow_imp.g_varchar2_table(591) := '2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263683A666F637573202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E612D';
wwv_flow_imp.g_varchar2_table(592) := '506F7075704C4F562D7365617263682E69732D666F6375736564202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F707570';
wwv_flow_imp.g_varchar2_table(593) := '2D6C6F763A666F637573202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F637573656420';
wwv_flow_imp.g_varchar2_table(594) := '2B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74693A666F637573202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D';
wwv_flow_imp.g_varchar2_table(595) := '6D756C74692E69732D666F6375736564202B202E617065782D6974656D2D69636F6E202B202E612D427574746F6E2D2D706F7075704C4F56207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A';
wwv_flow_imp.g_varchar2_table(596) := '7D0D0A2E617065782D6974656D2D74657874617265613A686F7665722C0D0A2E617065782D6974656D2D746578743A686F7665722C0D0A2E617065782D6974656D2D73656C6563743A686F7665722C0D0A2E617065782D6974656D2D6D756C74693A686F';
wwv_flow_imp.g_varchar2_table(597) := '7665722C0D0A73656C6563742E6C6973746D616E616765723A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E7075743A3A2D7765';
wwv_flow_imp.g_varchar2_table(598) := '626B69742D696E7075742D706C616365686F6C646572207B0D0A2020636F6C6F723A20726762612833322C2033322C2033322C20302E3632293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(599) := '20696E7075743A3A2D6D6F7A2D706C616365686F6C646572207B0D0A2020636F6C6F723A20726762612833322C2033322C2033322C20302E3632293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E';
wwv_flow_imp.g_varchar2_table(600) := '657220696E7075743A2D6D732D696E7075742D706C616365686F6C646572207B0D0A2020636F6C6F723A20726762612833322C2033322C2033322C20302E3632293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E742D466F726D20696E7075742E';
wwv_flow_imp.g_varchar2_table(601) := '66696C65207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E6572207370616E2E646973706C61795F6F6E6C79207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E';
wwv_flow_imp.g_varchar2_table(602) := '743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D466F726D2D73656C6563742C0D0A2E742D466F726D2D696E707574436F6E7461696E65722073656C6563742E7965735F6E6F207B0D0A2020';
wwv_flow_imp.g_varchar2_table(603) := '636F6C6F723A20233230323032303B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A2E742D466F726D2D6669656C642D2D726561644F6E6C79207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E737061';
wwv_flow_imp.g_varchar2_table(604) := '72656E743B0D0A7D0D0A2E742D466F726D2D726164696F4C6162656C2C0D0A2E742D466F726D2D696E707574436F6E7461696E6572202E726164696F5F67726F7570206C6162656C2C0D0A2E742D466F726D2D636865636B626F784C6162656C2C0D0A2E';
wwv_flow_imp.g_varchar2_table(605) := '742D466F726D2D696E707574436F6E7461696E6572202E636865636B626F785F67726F7570206C6162656C2C0D0A2E742D466F726D2D6C6162656C2C0D0A2E752D466F726D2D6C6162656C207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(606) := '0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E742D466F726D2D6C6162656C207B0D0A2020636F6C6F723A20233539353935393B0D0A7D0D0A2E742D466F726D2D6572726F72207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(607) := '6F723A20236634343333363B0D0A7D0D0A2E742D466F726D2D706F737454657874207B0D0A2020636F6C6F723A20236136613661363B0D0A7D0D0A2E742D466F726D2D2D73656172636820696E7075742E742D466F726D2D7365617263684669656C6420';
wwv_flow_imp.g_varchar2_table(608) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E612D427574746F6E2E612D427574746F6E2D2D63616C656E6461722C0D0A2E612D427574746F6E2E612D4275';
wwv_flow_imp.g_varchar2_table(609) := '74746F6E2D2D706F7075704C4F562C0D0A2E612D427574746F6E2E612D427574746F6E2D2D636F6C6F725069636B6572207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E752D52544C202E612D42757474';
wwv_flow_imp.g_varchar2_table(610) := '6F6E2E612D427574746F6E2D2D63616C656E6461722C0D0A2E752D52544C202E612D427574746F6E2E612D427574746F6E2D2D706F7075704C4F562C0D0A2E752D52544C202E612D427574746F6E2E612D427574746F6E2D2D636F6C6F725069636B6572';
wwv_flow_imp.g_varchar2_table(611) := '207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E742D466F726D2D696E707574436F6E7461696E657220696E7075742E686173446174657069636B65722C0D0A2E742D466F726D2D696E707574436F6E74';
wwv_flow_imp.g_varchar2_table(612) := '61696E657220696E7075742E706F7075705F6C6F76207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D696E707574436F6E7461696E657220696E7075742E6861734461';
wwv_flow_imp.g_varchar2_table(613) := '74657069636B65722C0D0A2E752D52544C202E742D466F726D2D696E707574436F6E7461696E657220696E7075742E706F7075705F6C6F76207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E75692D6461';
wwv_flow_imp.g_varchar2_table(614) := '74657069636B6572207B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A626F6479202E75692D646174657069636B65722E75692D646174657069636B65722D696E6C696E65207B0D0A20206F75746C696E653A206E6F6E65';
wwv_flow_imp.g_varchar2_table(615) := '3B0D0A2020626F782D736861646F773A206E6F6E652021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E74';
wwv_flow_imp.g_varchar2_table(616) := '61696E65722D2D666C6F6174696E674C6162656C202E75692D646174657069636B65722D696E6C696E65207B0D0A2020626F782D736861646F773A206E6F6E652021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A207472';
wwv_flow_imp.g_varchar2_table(617) := '616E73706172656E743B0D0A202070616464696E673A20303B0D0A2020626F726465723A206E6F6E653B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E75692D646174657069636B65722D';
wwv_flow_imp.g_varchar2_table(618) := '696E6C696E65202E75692D7769646765742D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E70';
wwv_flow_imp.g_varchar2_table(619) := '7574207B0D0A20200D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861646F773A20696E736574207267626128302C20302C20302C20302E313529203020';
wwv_flow_imp.g_varchar2_table(620) := '302030203170783B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E707574202B206C6162656C3A6166746572207B0D0A2020636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(621) := '6666663B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E7075743A686F766572202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861646F773A20696E736574207267626128302C20302C20302C20302E32352920';
wwv_flow_imp.g_varchar2_table(622) := '3020302030203170783B0D0A7D0D0A2E617065782D6974656D2D67726F75702D2D726320696E7075743A666F637573202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861646F773A20696E736574202330303736646620302030203020';
wwv_flow_imp.g_varchar2_table(623) := '3170782C20696E7365742023666666666666203020302030203270783B0D0A7D0D0A2E636865636B626F785F67726F757020696E7075742C0D0A2E726164696F5F67726F757020696E707574207B0D0A20200D0A7D0D0A2E636865636B626F785F67726F';
wwv_flow_imp.g_varchar2_table(624) := '757020696E7075743A666F6375733A636865636B6564202B206C6162656C3A6265666F72652C0D0A2E726164696F5F67726F757020696E7075743A666F6375733A636865636B6564202B206C6162656C3A6265666F7265207B0D0A2020626F782D736861';
wwv_flow_imp.g_varchar2_table(625) := '646F773A20696E7365742023303037366466203020302030203170782C20696E7365742023666666666666203020302030203270783B0D0A7D0D0A2E636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A626566';
wwv_flow_imp.g_varchar2_table(626) := '6F72652C0D0A2E726164696F5F67726F757020696E7075743A636865636B6564202B206C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F782D736861646F773A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(627) := '0D0A7D0D0A2E636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A686F7665723A6265666F72652C0D0A2E726164696F5F67726F757020696E7075743A636865636B6564202B206C6162656C3A686F7665723A62';
wwv_flow_imp.g_varchar2_table(628) := '65666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20233030363963363B0D0A7D0D0A2E726164696F5F67726F757020696E707574202B206C6162656C3A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A202366';
wwv_flow_imp.g_varchar2_table(629) := '66666666663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E707574207B0D0A20200D0A7D0D0A2E742D466F726D2D6669656C64436F6E';
wwv_flow_imp.g_varchar2_table(630) := '7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E707574202B206C6162656C3A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(631) := '6465722D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E7075743A666F637573202B206C';
wwv_flow_imp.g_varchar2_table(632) := '6162656C3A6265666F7265207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F7570';
wwv_flow_imp.g_varchar2_table(633) := '20696E7075743A666F6375733A636865636B6564202B206C6162656C3A6265666F7265207B0D0A2020626F726465722D636F6C6F723A20236639663966393B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(634) := '2D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E707574';
wwv_flow_imp.g_varchar2_table(635) := '3A666F6375733A636865636B6564202B206C6162656C3A6166746572207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E63686563';
wwv_flow_imp.g_varchar2_table(636) := '6B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A6265666F7265207B0D0A2020626F726465722D636F6C6F723A20236639663966393B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A7D';
wwv_flow_imp.g_varchar2_table(637) := '0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E636865636B626F785F67726F757020696E7075743A636865636B6564202B206C6162656C3A6166746572207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(638) := '3030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D70726554657874426C6F636B202E742D466F726D2D6974656D546578742D2D7072652C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D706F73';
wwv_flow_imp.g_varchar2_table(639) := '7454657874426C6F636B202E742D466F726D2D6974656D546578742D2D706F7374207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F782D736861646F773A20302030203020302E3172656D20236466646664';
wwv_flow_imp.g_varchar2_table(640) := '6620696E7365743B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D70726554657874426C6F636B202E742D466F726D2D6974656D546578742D2D707265207B0D0A2020';
wwv_flow_imp.g_varchar2_table(641) := '626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D70726554657874426C6F636B202E742D466F726D2D6974656D546578742D2D707265207B0D';
wwv_flow_imp.g_varchar2_table(642) := '0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D706F737454657874426C6F636B202E742D466F726D2D6974656D546578742D2D706F7374207B0D0A20';
wwv_flow_imp.g_varchar2_table(643) := '20626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D706F737454657874426C6F636B202E742D466F726D2D6974656D546578742D2D706F7374';
wwv_flow_imp.g_varchar2_table(644) := '207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E617065782D6974656D2D6861732D69636F6E3A666F637573202B202E617065782D6974656D2D69636F6E2C0D0A2E617065782D6974656D2D6D756C7469';
wwv_flow_imp.g_varchar2_table(645) := '2E69732D666F6375736564202B202E617065782D6974656D2D69636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E617065782D69';
wwv_flow_imp.g_varchar2_table(646) := '74656D2D69636F6E207B0D0A2020636F6C6F723A20233430343034303B0D0A2020626F782D736861646F773A202D302E3172656D20302030202364666466646620696E7365743B0D0A2020626F726465722D7261646975733A2032707820302030203270';
wwv_flow_imp.g_varchar2_table(647) := '783B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E617065782D6974656D2D69636F6E207B0D0A2020626F782D736861646F773A20302E3172656D203020302023646664';
wwv_flow_imp.g_varchar2_table(648) := '66646620696E7365743B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E69732D72657175697265643A6265666F';
wwv_flow_imp.g_varchar2_table(649) := '7265207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E69732D72657175697265643A6265';
wwv_flow_imp.g_varchar2_table(650) := '666F7265207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A20303B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C';
wwv_flow_imp.g_varchar2_table(651) := '6F6174696E674C6162656C202E617065782D6974656D2D6861732D69636F6E3A666F637573202B202E617065782D6974656D2D69636F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C202E617065';
wwv_flow_imp.g_varchar2_table(652) := '782D6974656D2D6D756C74692E69732D666F6375736564202B202E617065782D6974656D2D69636F6E207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(653) := '6C6F723A20236666666666663B0D0A7D0D0A2E742D466F726D2D68656C70427574746F6E3A666F637573202E612D49636F6E207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D';
wwv_flow_imp.g_varchar2_table(654) := '726164696F427574746F6E47726F7570202E742D466F726D2D6974656D57726170706572203E202E617065782D6974656D2D67726F7570203E202E617065782D6974656D2D6F7074696F6E3A66697273742D6F662D74797065206C6162656C207B0D0A20';
wwv_flow_imp.g_varchar2_table(655) := '20626F726465722D7261646975733A2032707820327078203020303B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E742D466F726D2D6974656D57726170706572203E202E617065';
wwv_flow_imp.g_varchar2_table(656) := '782D6974656D2D67726F7570203E202E617065782D6974656D2D6F7074696F6E3A6C6173742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2030203020327078203270783B0D0A7D0D0A2E742D466F726D2D666965';
wwv_flow_imp.g_varchar2_table(657) := '6C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A6669727374';
wwv_flow_imp.g_varchar2_table(658) := '2D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D69';
wwv_flow_imp.g_varchar2_table(659) := '74656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A6C6173742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A20302032';
wwv_flow_imp.g_varchar2_table(660) := '70782032707820303B0D0A7D0D0A2E752D52544C202E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E';
wwv_flow_imp.g_varchar2_table(661) := '6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A66697273742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E752D52544C202E742D466F726D2D66';
wwv_flow_imp.g_varchar2_table(662) := '69656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726964202E617065782D6974656D2D677269642D726F773A6F6E6C792D6368696C64202E617065782D6974656D2D6F7074696F6E3A6C6173';
wwv_flow_imp.g_varchar2_table(663) := '742D6F662D74797065206C6162656C207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E612D5377697463682D746F67676C65207B0D0A2020626F782D736861646F773A20696E736574207267626128302C';
wwv_flow_imp.g_varchar2_table(664) := '20302C20302C20302E303529203020302030203170783B0D0A20206261636B67726F756E642D636F6C6F723A20233863386338633B0D0A7D0D0A2E612D5377697463682D746F67676C653A6265666F7265207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(665) := '6C6F723A20236666663B0D0A7D0D0A2E612D5377697463683A686F766572202E612D5377697463682D746F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A7D0D0A2E612D53';
wwv_flow_imp.g_varchar2_table(666) := '776974636820696E7075745B747970653D636865636B626F785D3A666F637573202B202E612D5377697463682D746F67676C65207B0D0A2020626F782D736861646F773A20696E7365742023303037366466203020302030203170782C20696E73657420';
wwv_flow_imp.g_varchar2_table(667) := '23666666203020302030203270783B0D0A7D0D0A2E612D53776974636820696E7075745B747970653D636865636B626F785D3A636865636B6564202B202E612D5377697463682D746F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(668) := '20233030373664663B0D0A7D0D0A2E612D5377697463683A686F76657220696E7075745B747970653D636865636B626F785D3A636865636B6564202B202E612D5377697463682D746F67676C65207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(669) := '20233030363963363B0D0A7D0D0A2E612D53776974636820696E7075745B747970653D636865636B626F785D3A696E64657465726D696E617465202B202E612D5377697463682D746F67676C653A6265666F7265207B0D0A2020626F782D736861646F77';
wwv_flow_imp.g_varchar2_table(670) := '3A20696E7365742023666666203020302030203170783B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E35293B0D0A7D0D0A2E742D4865616465722D6272616E64696E67207B0D0A202062';
wwv_flow_imp.g_varchar2_table(671) := '61636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4865616465722D6C6F676F2C0D0A2E742D486561646572202E742D427574746F6E2D2D6865616465722E69732D6163746976652C0D0A2E742D486561646572202E742D';
wwv_flow_imp.g_varchar2_table(672) := '427574746F6E2D2D686561646572207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6C6F676F3A686F7665722C0D0A2E742D486561646572202E742D427574746F6E2D2D6865616465722E69732D616374697665';
wwv_flow_imp.g_varchar2_table(673) := '3A686F7665722C0D0A2E742D486561646572202E742D427574746F6E2D2D6865616465723A686F766572207B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A2E742D4865616465722D6C6F676F2D6C696E6B207B0D0A2020';
wwv_flow_imp.g_varchar2_table(674) := '636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D4865616465722D6C6F676F2D6C696E6B3A666F6375732C0D0A2E742D4865616465722D6C6F676F2D6C696E6B3A6163746976653A666F637573207B0D0A20206F75746C696E653A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(675) := '0D0A2020626F782D736861646F773A20302030203020317078202332643963666620696E7365743B0D0A7D0D0A2E742D4865726F526567696F6E2D69636F6E207B0D0A2020626F726465722D7261646975733A203470783B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(676) := '6E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865726F526567696F6E2D7469746C65207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E742D4865726F526567696F6E';
wwv_flow_imp.g_varchar2_table(677) := '2D636F6C2D2D636F6E74656E74207B0D0A2020636F6C6F723A20233731373137313B0D0A7D0D0A2E742D426F64792D7469746C65202E742D4865726F526567696F6E2D7469746C652C0D0A2E742D426F64792D7469746C65202E742D4865726F52656769';
wwv_flow_imp.g_varchar2_table(678) := '6F6E2D636F6C2D2D636F6E74656E74207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E612D4947207B0D0A2020626F726465722D636F6C6F723A20236563656365633B0D0A20206261636B67726F756E642D636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(679) := '3B0D0A7D0D0A2E612D52562D746F6F6C626172207B0D0A2020626F726465722D636F6C6F723A20236431643164313B0D0A7D0D0A2E612D47562D6864722C0D0A2E612D49472D686561646572207B0D0A2020626F726465722D636F6C6F723A2023656365';
wwv_flow_imp.g_varchar2_table(680) := '6365633B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D47562D772D66726F7A656E202E612D47562D7461626C652C0D0A2E612D47562D772D686472202E612D47562D7461626C65207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(681) := '6465722D636F6C6F723A20236530653065302021696D706F7274616E743B0D0A7D0D0A2E612D47562D626479207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D47562D6865616465722C0D0A2E612D47';
wwv_flow_imp.g_varchar2_table(682) := '562D68656164657247726F75702C0D0A2E612D546F6F6C6261722D67726F7570207B0D0A2020626F726465722D636F6C6F723A20236563656365633B0D0A7D0D0A2E612D47562D7461626C65202E612D47562D63656C6C207B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(683) := '636F6C6F723A20236563656365633B0D0A7D0D0A2E612D47562D7461626C652074722E69732D73656C6563746564202E612D47562D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20236536663166633B0D0A7D0D0A2E612D47562D';
wwv_flow_imp.g_varchar2_table(684) := '7461626C652074722E69732D64656C657465642E69732D73656C6563746564202E612D47562D63656C6C2E6861732D627574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283233302C203234312C203235322C20302E35';
wwv_flow_imp.g_varchar2_table(685) := '293B0D0A7D0D0A2E612D4952522D706167696E6174696F6E577261702D2D626F74746F6D207B0D0A2020626F726465722D746F702D636F6C6F723A20236563656365633B0D0A7D0D0A2E612D49472D6772696456696577202E612D47562D666F6F746572';
wwv_flow_imp.g_varchar2_table(686) := '207B0D0A2020626F726465722D636F6C6F723A20236563656365633B0D0A7D0D0A2E612D47562D666F6F746572207B0D0A2020626F726465722D636F6C6F723A20236563656365633B0D0A20206261636B67726F756E642D636F6C6F723A202366626662';
wwv_flow_imp.g_varchar2_table(687) := '66623B0D0A7D0D0A2E612D47562D7061676552616E6765207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3635293B0D0A7D0D0A2E612D47562D70616765427574746F6E207B0D0A2020636F6C6F723A207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(688) := '20302C20302E3635293B0D0A7D0D0A2E612D47562D70616765427574746F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A7D0D0A2E612D47562D7061676553656C';
wwv_flow_imp.g_varchar2_table(689) := '6563746F722D6974656D2E69732D73656C6563746564202E612D47562D70616765427574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A2020636F6C6F723A20726762612830';
wwv_flow_imp.g_varchar2_table(690) := '2C20302C20302C20302E3935293B0D0A7D0D0A2E612D47562D7461626C652074682E612D47562D636F6E74726F6C427265616B486561646572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303529';
wwv_flow_imp.g_varchar2_table(691) := '3B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A7D0D0A2E612D47562D2D656469744D6F6465202E612D47562D726F772E';
wwv_flow_imp.g_varchar2_table(692) := '69732D726561646F6E6C79202E612D47562D63656C6C2C0D0A2E612D47562D2D656469744D6F6465202E612D47562D63656C6C2E69732D726561646F6E6C79207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A202063';
wwv_flow_imp.g_varchar2_table(693) := '6F6C6F723A20233730373037303B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E207B0D0A2020626F782D73';
wwv_flow_imp.g_varchar2_table(694) := '6861646F773A206E6F6E652021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669';
wwv_flow_imp.g_varchar2_table(695) := '656C64436F6E7461696E6572202E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A6265666F72652C0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D42757474';
wwv_flow_imp.g_varchar2_table(696) := '6F6E2E742D427574746F6E2D2D68656C70427574746F6E3A6166746572207B0D0A2020636F6E74656E743A206E6F6E653B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E6572202E742D427574';
wwv_flow_imp.g_varchar2_table(697) := '746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A686F766572202E612D49636F6E207B0D0A20206F7061636974793A20313B0D0A7D0D0A2E612D49472D7265636F726456696577202E752D466F726D2D6669656C64436F6E7461696E657220';
wwv_flow_imp.g_varchar2_table(698) := '2E742D427574746F6E2E742D427574746F6E2D2D68656C70427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742021696D706F7274616E743B0D0A7D0D0A2E612D49472D';
wwv_flow_imp.g_varchar2_table(699) := '6865616465722C0D0A2E612D49474469616C6F672D6865616465722C0D0A2E612D49474469616C6F672D666F6F7465722C0D0A2E612D49474469616C6F672D73696465207B0D0A2020626F726465722D636F6C6F723A20236530653065303B0D0A202062';
wwv_flow_imp.g_varchar2_table(700) := '61636B67726F756E642D636F6C6F723A20236639663966393B0D0A7D0D0A2E612D47562D636F6C756D6E436F6E74726F6C73202E612D427574746F6E207B0D0A2020636F6C6F723A20233338333833383B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(701) := '723A20236638663866383B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E3132352920696E7365743B0D0A7D0D0A2E612D47562D636F6C756D6E436F6E74726F6C73202E612D427574746F6E2E';
wwv_flow_imp.g_varchar2_table(702) := '69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236465646564653B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E3032352920696E7365743B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(703) := '612D47562D666C6F6174696E674974656D2E69732D657870616E646564207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A7D0D0A2E612D47562D636F6C756D6E48616E64';
wwv_flow_imp.g_varchar2_table(704) := '6C652C0D0A2E612D47562D63656C6C4D6F766548616E646C65207B0D0A20206F7061636974793A20302E353B0D0A20206261636B67726F756E642D696D6167653A2075726C28646174613A696D6167652F7376672B786D6C3B6261736536342C50484E32';
wwv_flow_imp.g_varchar2_table(705) := '5A79423462577875637A30696148523063446F764C336433647935334D793576636D63764D6A41774D43397A646D6369494864705A48526F505349304969426F5A576C6E61485139496A516949485A705A58644362336739496A41674D43413049445169';
wwv_flow_imp.g_varchar2_table(706) := '506A78775958526F49475A706247773949694D324E6A596949475139496B30774944426F4D6E59796143307965694976506A777663335A6E50673D3D293B0D0A7D0D0A2E612D47562D636F6C756D6E48616E646C653A686F7665722C0D0A2E612D47562D';
wwv_flow_imp.g_varchar2_table(707) := '63656C6C4D6F766548616E646C653A686F766572207B0D0A20206F7061636974793A20302E37353B0D0A7D0D0A2E612D495252207B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A20726762612830';
wwv_flow_imp.g_varchar2_table(708) := '2C20302C20302C20302E31293B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D495252202E612D4952522D706167696E6174696F6E2D6C6162656C207B0D0A2020636F6C6F723A20233733373337333B0D';
wwv_flow_imp.g_varchar2_table(709) := '0A7D0D0A2E612D4952522D6469616C6F67526F772D2D686561646572207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4952522D6469616C6F674C6973742061207B0D0A2020636F6C6F723A20696E68657269742021696D706F72';
wwv_flow_imp.g_varchar2_table(710) := '74616E743B0D0A7D0D0A2E612D4952522D7265706F727453756D6D6172792D76616C75652C0D0A2E612D49472D7265706F727453756D6D6172792D76616C7565207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E612D4952522D636F6E';
wwv_flow_imp.g_varchar2_table(711) := '74726F6C73436F6E7461696E6572207B0D0A2020626F726465722D746F702D636F6C6F723A20236635663566353B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A7D0D0A2E612D4952522D66756C6C56696577207B0D0A';
wwv_flow_imp.g_varchar2_table(712) := '20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D627574746F6E2D2D636F6E74726F6C73207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E737061';
wwv_flow_imp.g_varchar2_table(713) := '72656E743B0D0A7D0D0A2E612D4952522D746F6F6C626172207B0D0A20206261636B67726F756E643A20236666666666663B0D0A2020626F726465722D636F6C6F723A20236536653665363B0D0A7D0D0A2E612D5265706F72742D70657263656E744368';
wwv_flow_imp.g_varchar2_table(714) := '6172742D66696C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D5265706F72742D70657263656E744368617274207B0D0A20206261636B67726F756E642D636F6C6F723A20236466663066663B0D';
wwv_flow_imp.g_varchar2_table(715) := '0A7D0D0A2E612D4952522D627574746F6E2D2D636F6C536561726368207B0D0A2020626F726465722D746F702D72696768742D7261646975733A20302021696D706F7274616E743B0D0A2020626F726465722D626F74746F6D2D72696768742D72616469';
wwv_flow_imp.g_varchar2_table(716) := '75733A20302021696D706F7274616E743B0D0A7D0D0A2E752D52544C202E612D4952522D627574746F6E2D2D636F6C536561726368207B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270782021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(717) := '0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A203270782021696D706F7274616E743B0D0A2020626F726465722D746F702D6C6566742D7261646975733A20302021696D706F7274616E743B0D0A2020626F726465722D626F';
wwv_flow_imp.g_varchar2_table(718) := '74746F6D2D6C6566742D7261646975733A20302021696D706F7274616E743B0D0A7D0D0A2E612D4952522D69636F6E566965775461626C652C0D0A2E612D4952522D6368617274566965772C0D0A2E612D4952522D7069766F74566965772C0D0A2E612D';
wwv_flow_imp.g_varchar2_table(719) := '4952522D67726F75704279566965772C0D0A2E612D4952522D64657461696C56696577207B0D0A2020626F726465722D746F702D636F6C6F723A20236635663566353B0D0A7D0D0A2E612D4952522D746F6F6C6261722D2D73696E676C65526F77207B0D';
wwv_flow_imp.g_varchar2_table(720) := '0A2020626F726465722D626F74746F6D2D636F6C6F723A20236630663066303B0D0A7D0D0A2E612D4952522D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A2020626F726465722D746F703A203170';
wwv_flow_imp.g_varchar2_table(721) := '7820736F6C696420236536653665363B0D0A2020626F782D736861646F773A20696E7365742031707820302030203020236536653665363B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3935293B0D0A7D0D0A2E612D4952522D68';
wwv_flow_imp.g_varchar2_table(722) := '65616465723A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236632663266323B0D0A7D0D0A2E612D4952522D6865616465722E69732D616374697665207B0D0A2020626F782D736861646F773A203020317078203170782072';
wwv_flow_imp.g_varchar2_table(723) := '67626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E612D4952522D6865616465722E69732D6163746976652061207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4952522D6865616465722E69732D6163';
wwv_flow_imp.g_varchar2_table(724) := '74697665202E612D4952522D686561646572536F7274207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D4952522D6865616465722E69732D6163746976652C0D0A2E612D47562D6865616465722E69732D616374697665207B0D0A';
wwv_flow_imp.g_varchar2_table(725) := '20206261636B67726F756E642D636F6C6F723A20233230323032303B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E612D4952522D6865616465722D2D67726F7570207B0D0A20206261636B67726F756E642D636F6C6F723A2023663566356635';
wwv_flow_imp.g_varchar2_table(726) := '3B0D0A7D0D0A2E742D4952522D726567696F6E207B0D0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E3035292C20302032707820347078202D327078207267626128302C20302C20302C20302E30';
wwv_flow_imp.g_varchar2_table(727) := '3735293B0D0A7D0D0A2E612D4952522D7461626C65436F6E7461696E6572202E6A732D737469636B795461626C654865616465722E69732D737475636B207B0D0A2020626F782D736861646F773A203020317078207267626128302C20302C20302C2030';
wwv_flow_imp.g_varchar2_table(728) := '2E31293B0D0A7D0D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A20373638707829207B0D0A20202E612D4952522D627574746F6E733A6265666F7265207B0D0A202020206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(729) := '723A207267626128302C20302C20302C20302E3035293B0D0A20207D0D0A7D0D0A2E612D4952522D7461626C65207472207464207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233236323632';
wwv_flow_imp.g_varchar2_table(730) := '363B0D0A7D0D0A2E612D4952522D7461626C65207B0D0A2020626F726465722D636F6C6C617073653A2073657061726174653B0D0A7D0D0A2E612D4952522D7461626C652074723A686F766572207464207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(731) := '6F723A20236639663966393B0D0A7D0D0A2E742D4952522D726567696F6E2D2D6E6F426F7264657273202E612D495252207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E612D4952522D7461626C65207464207B0D0A202062';
wwv_flow_imp.g_varchar2_table(732) := '6F726465722D6C6566743A2031707820736F6C696420236632663266323B0D0A2020626F726465722D746F703A2031707820736F6C696420236632663266323B0D0A7D0D0A2E612D4952522D7461626C652074722074643A6C6173742D6368696C64207B';
wwv_flow_imp.g_varchar2_table(733) := '0D0A2020626F726465722D72696768742D636F6C6F723A20236632663266323B0D0A7D0D0A2E612D4952522D6865616465724C696E6B3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365';
wwv_flow_imp.g_varchar2_table(734) := '743B0D0A7D0D0A2E612D4952522D7365617263682D6669656C643A666F637573207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A2020626F782D736861646F773A202D31707820302030202330303736646620696E7365742C20';
wwv_flow_imp.g_varchar2_table(735) := '31707820302030202330303736646620696E7365743B0D0A7D0D0A2E612D4952522D73696E676C65526F772D6E616D652C0D0A2E612D4952522D73696E676C65526F772D76616C7565207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(736) := '236630663066303B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E612D4952522D73696E676C65526F772D76616C7565207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D4952522D7369';
wwv_flow_imp.g_varchar2_table(737) := '6E676C65526F772D726F773A686F766572202E612D4952522D73696E676C65526F772D76616C7565207B0D0A20206261636B67726F756E642D636F6C6F723A20236637663766373B0D0A7D0D0A2E612D4952522D73696E676C65526F772D6E616D65207B';
wwv_flow_imp.g_varchar2_table(738) := '0D0A20206261636B67726F756E642D636F6C6F723A20236637663766373B0D0A7D0D0A2E612D4952522D73696E676C65526F772D726F773A686F766572202E612D4952522D73696E676C65526F772D6E616D65207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(739) := '636F6C6F723A20236630663066303B0D0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D627574746F6E2D2D706167696E6174696F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(740) := '0A2E612D4952522D7265706F727453756D6D6172792D6C6162656C2C0D0A2E612D49472D7265706F727453756D6D6172792D6C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(741) := '2020636F6C6F723A20233236323632363B0D0A7D0D0A2E612D4952522D636F6E74726F6C734C6162656C2C0D0A2E612D49472D636F6E74726F6C734C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(742) := '0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A20373639707829207B0D0A20202E69732D6D6178696D697A65642E742D4952522D726567696F6E202E742D6668742D7468656164202E612D4952522D6865616465';
wwv_flow_imp.g_varchar2_table(743) := '72207B0D0A20202020626F726465722D626F74746F6D3A2031707820736F6C696420236536653665363B0D0A20207D0D0A7D0D0A2E75692D7769646765742D636F6E74656E74202E612D4952522D69636F6E4C6973742D6C696E6B207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(744) := '6F723A20233236323632363B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D4952522D69636F6E4C6973742D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236637';
wwv_flow_imp.g_varchar2_table(745) := '663766373B0D0A7D0D0A2E612D4952522D69636F6E4C6973742D6974656D202E612D4952522D69636F6E4C6973742D6C696E6B3A686F7665722C0D0A2E612D4952522D69636F6E4C6973742D6974656D202E612D4952522D69636F6E4C6973742D6C696E';
wwv_flow_imp.g_varchar2_table(746) := '6B2E69732D6163746976652C0D0A2E612D4952522D726164696F49636F6E4C6973742D6974656D20696E7075745B747970653D726164696F5D3A636865636B6564202B206C6162656C207B0D0A20206261636B67726F756E642D636F6C6F723A20236637';
wwv_flow_imp.g_varchar2_table(747) := '663766372021696D706F7274616E743B0D0A7D0D0A2E612D4952522D627574746F6E3A666F6375732C0D0A2E612D4952522D627574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20696E68657269743B0D0A7D0D0A2E612D4952522D';
wwv_flow_imp.g_varchar2_table(748) := '736F7274576964676574207B0D0A20206261636B67726F756E642D636F6C6F723A20726762612833322C2033322C2033322C20302E3935293B0D0A20202D7765626B69742D6261636B64726F702D66696C7465723A20626C757228347078293B0D0A2020';
wwv_flow_imp.g_varchar2_table(749) := '636F6C6F723A20234646463B0D0A2020626F726465722D77696474683A20303B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A2032';
wwv_flow_imp.g_varchar2_table(750) := '70783B0D0A2020626F782D736861646F773A2030203870782031367078207267626128302C20302C20302C20302E3235292C20302030203020317078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E612D4952522D736F727457696467';
wwv_flow_imp.g_varchar2_table(751) := '6574203A3A2D7765626B69742D7363726F6C6C626172207B0D0A202077696474683A203870783B0D0A20206865696768743A203870783B0D0A7D0D0A2E612D4952522D736F7274576964676574203A3A2D7765626B69742D7363726F6C6C6261722D7468';
wwv_flow_imp.g_varchar2_table(752) := '756D62207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E35293B0D0A7D0D0A2E612D4952522D736F7274576964676574203A3A2D7765626B69742D7363726F6C6C6261722D747261636B';
wwv_flow_imp.g_varchar2_table(753) := '207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3235293B0D0A7D0D0A2E612D4952522D736F72745769646765742D68656C70207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(754) := '207472616E73706172656E743B0D0A7D0D0A2E612D4952522D736F72745769646765742D616374696F6E73207B0D0A202070616464696E673A203870783B0D0A2020626F726465722D7261646975733A203270783B0D0A202077696474683A206175746F';
wwv_flow_imp.g_varchar2_table(755) := '3B0D0A2020626F726465722D626F74746F6D2D77696474683A20303B0D0A7D0D0A2E612D4952522D736F72745769646765742D616374696F6E732D6974656D207B0D0A2020626F726465722D72696768742D77696474683A20303B0D0A7D0D0A2E612D49';
wwv_flow_imp.g_varchar2_table(756) := '52522D627574746F6E2E612D4952522D736F72745769646765742D627574746F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20234646463B0D0A2020626F726465722D72616469';
wwv_flow_imp.g_varchar2_table(757) := '75733A203270783B0D0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D736F72745769646765742D627574746F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E32293B0D';
wwv_flow_imp.g_varchar2_table(758) := '0A7D0D0A2E612D4952522D627574746F6E2E612D4952522D736F72745769646765742D627574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D495252';
wwv_flow_imp.g_varchar2_table(759) := '2D627574746F6E2E612D4952522D736F72745769646765742D627574746F6E2E69732D6163746976652C0D0A2E612D4952522D627574746F6E2E612D4952522D736F72745769646765742D627574746F6E3A6163746976653A666F637573207B0D0A2020';
wwv_flow_imp.g_varchar2_table(760) := '6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A7D0D0A2E612D4952522D736F72745769646765742D7365617263684C6162656C207B0D0A20206865696768743A20343070783B0D0A202070616464696E';
wwv_flow_imp.g_varchar2_table(761) := '673A2031327078203870783B0D0A7D0D0A2E612D4952522D736F72745769646765742D7365617263684C6162656C3A6265666F7265207B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E612D4952522D736F72745769646765742D736561726368';
wwv_flow_imp.g_varchar2_table(762) := '203E202E612D4952522D736F72745769646765742D7365617263684669656C645B747970653D2274657874225D207B0D0A2020617070656172616E63653A206E6F6E653B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C20';
wwv_flow_imp.g_varchar2_table(763) := '3235352C203235352C20302E31293B0D0A20206865696768743A20343070783B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E612D4952522D736F72745769646765742D736561726368203E202E612D4952522D736F72745769646765742D7365';
wwv_flow_imp.g_varchar2_table(764) := '617263684669656C645B747970653D2274657874225D3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F7773207B0D';
wwv_flow_imp.g_varchar2_table(765) := '0A2020626F726465722D746F702D77696474683A20303B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F77207B0D0A2020636F6C6F723A20234646463B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D4952522D';
wwv_flow_imp.g_varchar2_table(766) := '736F72745769646765742D726F773A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E612D4952522D736F72745769646765742D726F773A666F63';
wwv_flow_imp.g_varchar2_table(767) := '7573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D4947202E612D4952522D736F72745769646765743A6265666F7265207B0D0A2020636F6C6F723A20726762612833322C';
wwv_flow_imp.g_varchar2_table(768) := '2033322C2033322C20302E3935293B0D0A7D0D0A2E612D495252202E686F75722D6772617068207370616E2E686F75722E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20236530653065302021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(769) := '0A7D0D0A2E612D495252202E686F75722D6772617068207370616E2E686F7572207B0D0A20206261636B67726F756E642D636F6C6F723A20236231646461622021696D706F7274616E743B0D0A7D0D0A2E6F6A2D6476742D63617465676F727931207B0D';
wwv_flow_imp.g_varchar2_table(770) := '0A2020636F6C6F723A20233330394644423B0D0A7D0D0A2E6F6A2D6476742D63617465676F727932207B0D0A2020636F6C6F723A20233343414638353B0D0A7D0D0A2E6F6A2D6476742D63617465676F727933207B0D0A2020636F6C6F723A2023464243';
wwv_flow_imp.g_varchar2_table(771) := '4534413B0D0A7D0D0A2E6F6A2D6476742D63617465676F727934207B0D0A2020636F6C6F723A20234539354235343B0D0A7D0D0A2E6F6A2D6476742D63617465676F727935207B0D0A2020636F6C6F723A20233835344539423B0D0A7D0D0A2E6F6A2D64';
wwv_flow_imp.g_varchar2_table(772) := '76742D63617465676F727936207B0D0A2020636F6C6F723A20233245424642433B0D0A7D0D0A2E6F6A2D6476742D63617465676F727937207B0D0A2020636F6C6F723A20234544383133453B0D0A7D0D0A2E6F6A2D6476742D63617465676F727938207B';
wwv_flow_imp.g_varchar2_table(773) := '0D0A2020636F6C6F723A20234538354438383B0D0A7D0D0A2E6F6A2D6476742D63617465676F727939207B0D0A2020636F6C6F723A20233133423643463B0D0A7D0D0A2E6F6A2D6476742D63617465676F72793130207B0D0A2020636F6C6F723A202338';
wwv_flow_imp.g_varchar2_table(774) := '31424235463B0D0A7D0D0A2E6F6A2D6476742D63617465676F72793131207B0D0A2020636F6C6F723A20234341353839443B0D0A7D0D0A2E6F6A2D6476742D63617465676F72793132207B0D0A2020636F6C6F723A20234444444535333B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(775) := '6F6A2D6C6567656E642C0D0A2E6F6A2D6C6567656E642D7469746C652C0D0A2E6F6A2D63686172742D7069652D63656E7465722D6C6162656C2C0D0A2E6F6A2D63686172742D78617869732D7469746C652C0D0A2E6F6A2D63686172742D79617869732D';
wwv_flow_imp.g_varchar2_table(776) := '7469746C652C0D0A2E6F6A2D63686172742D7932617869732D7469746C652C0D0A2E6F6A2D63686172742D78617869732D7469636B2D6C6162656C2C0D0A2E6F6A2D63686172742D79617869732D7469636B2D6C6162656C2C0D0A2E6F6A2D6368617274';
wwv_flow_imp.g_varchar2_table(777) := '2D7932617869732D7469636B2D6C6162656C2C0D0A2E6F6A2D63686172742D646174612D6C6162656C2C0D0A2E6F6A2D6476742D6E6F2D646174612D6D657373616765207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E742D4C696E6B';
wwv_flow_imp.g_varchar2_table(778) := '734C6973742D6974656D2C0D0A2E742D4C696E6B734C6973742D6C696E6B207B0D0A2020626F726465722D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D4C696E6B734C6973742D69636F6E207B0D0A2020636F6C6F723A2023643964396439';
wwv_flow_imp.g_varchar2_table(779) := '3B0D0A7D0D0A2E742D4C696E6B734C6973742D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236632663266323B0D0A7D0D0A2E742D4C696E6B734C6973742D6C696E6B3A666F637573207B0D0A2020626F782D73';
wwv_flow_imp.g_varchar2_table(780) := '6861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6974656D2D2D736570617261746F72207B0D0A2020626F726465722D62';
wwv_flow_imp.g_varchar2_table(781) := '6F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774172726F77202E742D4C696E6B734C6973742D6C696E6B3A6265666F7265207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(782) := '6439643964393B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20236635663566353B0D0A2020636F6C6F723A20233236';
wwv_flow_imp.g_varchar2_table(783) := '323632363B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(784) := '236562656265623B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564203E202E742D4C696E6B734C6973742D6C696E6B202E742D4C696E6B734C6973742D';
wwv_flow_imp.g_varchar2_table(785) := '6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20236266626662663B0D0A7D0D0A2E742D4C696E6B734C6973742D2D627269676874486F766572202E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564202E74';
wwv_flow_imp.g_varchar2_table(786) := '2D4C696E6B734C6973742D6C696E6B3A686F7665723A6265666F7265207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E35293B0D0A7D0D0A2E742D4C696E6B734C6973742D2D627269676874486F766572202E742D';
wwv_flow_imp.g_varchar2_table(787) := '4C696E6B734C6973742D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4C696E6B734C6973742D2D627269676874486F7665';
wwv_flow_imp.g_varchar2_table(788) := '72202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D69636F6E207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E742D4C696E6B734C6973742D';
wwv_flow_imp.g_varchar2_table(789) := '6974656D2E69732D657870616E646564207B0D0A20206261636B67726F756E642D636F6C6F723A20234643464346433B0D0A20206261636B67726F756E643A206C696E6561722D6772616469656E74287267626128302C20302C20302C20302E30313529';
wwv_flow_imp.g_varchar2_table(790) := '2C207267626128302C20302C20302C203029292C206C696E6561722D6772616469656E74287267626128302C20302C20302C2030292C207267626128302C20302C20302C20302E30313529293B0D0A7D0D0A2E742D4C696E6B734C6973742D6974656D2E';
wwv_flow_imp.g_varchar2_table(791) := '69732D657870616E646564202E742D4C696E6B734C6973742D6C696E6B3A686F7665723A6265666F7265207B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4C696E6B734C6973742D6974656D2E69732D657870616E646564202E74';
wwv_flow_imp.g_varchar2_table(792) := '2D4C696E6B734C6973742D6C696E6B3A6265666F7265207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A7D0D0A2E742D4C696E6B734C6973742D2D73686F774261646765202E742D4C696E6B734C6973742D626164';
wwv_flow_imp.g_varchar2_table(793) := '6765207B0D0A2020626F726465722D7261646975733A203470783B0D0A7D0D0A2E742D4C696E6B734C6973742D2D69636F6E4F6E6C79202E742D4C696E6B734C6973742D69636F6E207B0D0A2020626F726465722D7261646975733A20313030253B0D0A';
wwv_flow_imp.g_varchar2_table(794) := '7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6C6162656C207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C';
wwv_flow_imp.g_varchar2_table(795) := '6973742D69636F6E207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D69636F6E2C0D0A';
wwv_flow_imp.g_varchar2_table(796) := '2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D6C6162656C2C0D0A2E742D4C696E6B734C6973742D2D616374696F6E73202E742D4C696E6B734C6973';
wwv_flow_imp.g_varchar2_table(797) := '742D6C696E6B3A686F766572202E742D4C696E6B734C6973742D6261646765207B0D0A2020636F6C6F723A20233365336533653B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D4C696E6B734C6973742D6C696E6B3A686F766572207B0D0A';
wwv_flow_imp.g_varchar2_table(798) := '20206261636B67726F756E642D636F6C6F723A20236563656365633B0D0A7D0D0A2E612D4C697374566965772D6974656D207B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C6964207267626128302C20302C20302C20302E3035293B';
wwv_flow_imp.g_varchar2_table(799) := '0D0A7D0D0A2E612D4C697374566965772D6974656D202E75692D62746E207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E612D4C697374566965772D6974656D202E75692D62746E3A686F766572207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(800) := '642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E612D4C697374566965772D6974656D202E6661207B0D0A2020636F6C6F723A20236439643964393B0D0A7D0D0A2E612D4C697374566965772D6974656D202E7569';
wwv_flow_imp.g_varchar2_table(801) := '2D6C692D636F756E74207B0D0A2020636F6C6F723A20233539353935393B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D50616765426F64792D2D6C6F67696E207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(802) := '636F6C6F723A20236530653065303B0D0A7D0D0A2E742D4C6F67696E506167652D2D6267312C0D0A2E742D4C6F67696E506167652D2D6267322C0D0A2E742D4C6F67696E506167652D2D626733207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(803) := '20233030373664663B0D0A7D0D0A2E6170702D69636F6E207B0D0A20206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0D0A20206261636B67726F756E642D73697A653A20636F7665723B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(804) := '706F736974696F6E3A203530253B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4C6F67696E2D69636F6E56616C69646174696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2023334241';
wwv_flow_imp.g_varchar2_table(805) := '4132433B0D0A2020636F6C6F723A20236666663B0D0A7D0D0A2E742D4C6F67696E2D726567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3635293B0D0A2020626F782D7368';
wwv_flow_imp.g_varchar2_table(806) := '61646F773A2030203870782032347078202D347078207267626128302C20302C20302C20302E32292C20302030203020317078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D4C6F67696E506167652D2D73706C6974202E742D4C';
wwv_flow_imp.g_varchar2_table(807) := '6F67696E2D636F6E7461696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3635293B0D0A2020626F782D736861646F773A203020302032347078202D34707820726762612830';
wwv_flow_imp.g_varchar2_table(808) := '2C20302C20302C20302E32292C20302030203020317078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E612D4D44456469746F72202E612D546F6F6C626172207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(809) := '20302C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A2020626F726465722D746F702D6C6566742D7261646975733A20302E3272656D3B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(810) := '746F702D72696768742D7261646975733A20302E3272656D3B0D0A7D0D0A2E612D4D44456469746F72202E612D546F6F6C626172202E612D427574746F6E3A6E6F74283A686F766572293A6E6F74283A616374697665293A6E6F74283A666F637573293A';
wwv_flow_imp.g_varchar2_table(811) := '6E6F74282E69732D61637469766529207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D4D44456469746F722D7072657669657750616E65';
wwv_flow_imp.g_varchar2_table(812) := '6C2C0D0A2E612D4D44456469746F722074657874617265612E617065782D6974656D2D74657874617265612C0D0A2E612D4D44456469746F72202E436F64654D6972726F72207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20';
wwv_flow_imp.g_varchar2_table(813) := '302C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B0D0A2020636F6C6F723A20233230323032303B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A20302E3272656D3B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(814) := '726465722D626F74746F6D2D72696768742D7261646975733A20302E3272656D3B0D0A7D0D0A2E612D4D44456469746F722D7072657669657750616E656C3A666F6375732C0D0A2E612D4D44456469746F722074657874617265612E617065782D697465';
wwv_flow_imp.g_varchar2_table(815) := '6D2D74657874617265613A666F6375732C0D0A2E612D4D44456469746F72202E436F64654D6972726F723A666F6375732C0D0A2E612D4D44456469746F722D7072657669657750616E656C2E436F64654D6972726F722D666F63757365642C0D0A2E612D';
wwv_flow_imp.g_varchar2_table(816) := '4D44456469746F722074657874617265612E617065782D6974656D2D74657874617265612E436F64654D6972726F722D666F63757365642C0D0A2E612D4D44456469746F72202E436F64654D6972726F722E436F64654D6972726F722D666F6375736564';
wwv_flow_imp.g_varchar2_table(817) := '207B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A7D0D0A2E436F64654D6972726F722D637572736F72207B0D0A2020626F726465722D6C6566742D636F6C6F723A20233230323032302021696D706F7274616E743B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(818) := '2E69732D6D61726B646F776E69666965642068312C0D0A2E69732D6D61726B646F776E69666965642068322C0D0A2E69732D6D61726B646F776E69666965642068332C0D0A2E69732D6D61726B646F776E69666965642068342C0D0A2E69732D6D61726B';
wwv_flow_imp.g_varchar2_table(819) := '646F776E69666965642068352C0D0A2E69732D6D61726B646F776E6966696564206836207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E69732D6D61726B646F776E6966696564206872207B0D0A20206261636B67726F756E643A206E';
wwv_flow_imp.g_varchar2_table(820) := '6F6E653B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E32293B0D0A7D0D0A2E69732D6D61726B646F776E696669656420626C6F636B71756F7465207B0D0A2020626F726465722D6C6566742D636F6C6F';
wwv_flow_imp.g_varchar2_table(821) := '723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E69732D6D61726B646F776E696669656420636F6465207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(822) := '2D736861646F773A20696E736574207267626128302C20302C20302C20302E303529203020302030203170783B0D0A7D0D0A2E69732D6D61726B646F776E696669656420707265207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128';
wwv_flow_imp.g_varchar2_table(823) := '302C20302C20302C20302E3235293B0D0A2020626F782D736861646F773A20696E736574207267626128302C20302C20302C20302E303529203020302030203170783B0D0A7D0D0A2E69732D6D61726B646F776E69666965642070726520636F6465207B';
wwv_flow_imp.g_varchar2_table(824) := '0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C65207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(825) := '636F6C6F723A20236666663B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A2020626F782D736861646F773A20302032707820347078202D327078207267626128302C20302C20302C20302E30373529';
wwv_flow_imp.g_varchar2_table(826) := '3B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C65207468207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303135293B0D0A7D0D0A2E69732D6D61726B646F776E696669656420';
wwv_flow_imp.g_varchar2_table(827) := '7461626C652074682C0D0A2E69732D6D61726B646F776E6966696564207461626C65207464207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E69732D6D61726B646F77';
wwv_flow_imp.g_varchar2_table(828) := '6E6966696564207461626C652074723A686F766572207464207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E30313235293B0D0A7D0D0A2E69732D6D61726B646F776E6966696564207461626C652074';
wwv_flow_imp.g_varchar2_table(829) := '723A686F766572207468207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A7D0D0A2E742D4D656469614C697374207B0D0A2020626F726465722D636F6C6F723A20236530653065303B0D';
wwv_flow_imp.g_varchar2_table(830) := '0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656469614C6973742D6974656D207B0D0A2020626F726465722D636F6C6F723A20236530653065303B0D0A7D0D0A2E742D4D656469614C6973742D697465';
wwv_flow_imp.g_varchar2_table(831) := '6D2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D4D656469614C6973742D2D686F72697A6F6E74616C202E742D4D656469614C6973742D6974';
wwv_flow_imp.g_varchar2_table(832) := '656D207B0D0A2020626F726465722D72696768743A2031707820736F6C696420236530653065303B0D0A7D0D0A612E742D4D656469614C6973742D6974656D57726170207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A612E742D4D6564';
wwv_flow_imp.g_varchar2_table(833) := '69614C6973742D6974656D577261703A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A612E742D4D656469614C6973742D6974656D577261703A';
wwv_flow_imp.g_varchar2_table(834) := '666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D4D656469614C6973742D6974656D57726170207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(835) := '742D4D656469614C6973742D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D4D656469614C6973742D62616467652C0D0A2E742D4D656469614C6973742D';
wwv_flow_imp.g_varchar2_table(836) := '64657363207B0D0A2020636F6C6F723A20233636363636363B0D0A7D0D0A2E742D4D656469614C6973742D69636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A';
wwv_flow_imp.g_varchar2_table(837) := '7D0D0A2E742D4D656469614C6973742D2D636F6C73207B0D0A2020626F782D736861646F773A202D317078202D31707820302030202365306530653020696E7365743B0D0A7D0D0A2E742D4D656469614C6973742D2D636F6C73202E742D4D656469614C';
wwv_flow_imp.g_varchar2_table(838) := '6973742D6974656D3A6265666F72652C0D0A2E742D4D656469614C6973742D2D636F6C73202E742D4D656469614C6973742D6974656D3A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E612D';
wwv_flow_imp.g_varchar2_table(839) := '4D656E752E742D4D6567614D656E75202E612D4D656E752D6974656D2E69732D666F63757365642C0D0A2E612D4D656E752E742D4D6567614D656E75202E612D4D656E752D6974656D2E69732D657870616E646564207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(840) := '642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D4D6567614D656E752D6974656D426F64792E69732D666F6375736564202E742D4D6567614D656E752D6C6162656C2C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(841) := '4D6567614D656E752D6974656D426F64793A686F766572202E742D4D6567614D656E752D6C6162656C207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A2E742D4D6567614D656E752D6261646765207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(842) := '2D636F6C6F723A20236637663766373B0D0A2020636F6C6F723A20233464346434643B0D0A7D0D0A2E742D4D6567614D656E752D2D6C61796F7574537461636B6564202E742D4D6567614D656E752D6974656D2D2D746F70202B202E742D4D6567614D65';
wwv_flow_imp.g_varchar2_table(843) := '6E752D6974656D2D2D746F70207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E612D4D656E752D636F6E74656E74207B0D0A2020626F726465722D7261646975733A20327078';
wwv_flow_imp.g_varchar2_table(844) := '3B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A2020626F726465722D77696474683A20303B0D0A2020626F782D736861646F773A2030203870782031367078207267626128302C20302C20302C20302E3235292C2030';
wwv_flow_imp.g_varchar2_table(845) := '2030203020317078207267626128302C20302C20302C20302E31293B0D0A202070616464696E673A2038707820303B0D0A7D0D0A2E612D4D656E752D636F6E74656E74202E612D4D656E752D7363726F6C6C42746E2D2D646F776E2C0D0A2E612D4D656E';
wwv_flow_imp.g_varchar2_table(846) := '752D636F6E74656E74202E612D4D656E752D7363726F6C6C42746E2D2D7570207B0D0A20206261636B67726F756E642D636F6C6F723A20236637663766373B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E612D4D656E75207B0D0A2020';
wwv_flow_imp.g_varchar2_table(847) := '6D696E2D77696474683A2031363070783B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D207B0D0A20206C696E652D6865696768743A20333670783B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E612D4D656E75202E61';
wwv_flow_imp.g_varchar2_table(848) := '2D4D656E752D6974656D203E202E612D4D656E752D696E6E6572202E612D4D656E752D616363656C2C0D0A2E612D4D656E75202E612D4D656E752D6974656D203E202E612D4D656E752D696E6E6572202E612D4D656E752D7375624D656E75436F6C207B';
wwv_flow_imp.g_varchar2_table(849) := '0D0A20206F7061636974793A20302E38353B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D666F63757365642C0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D657870616E646564207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(850) := '3A20236666666666663B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F6375736564207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(851) := '20726762612833382C2033382C2033382C20302E35293B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D2E69732D64697361626C65642E69732D666F63757365';
wwv_flow_imp.g_varchar2_table(852) := '64203E202E612D4D656E752D696E6E6572202E612D4D656E752D616363656C207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D202E612D4D656E752D7375624D656E75436F6C207B0D0A2020';
wwv_flow_imp.g_varchar2_table(853) := '6865696768743A20333670783B0D0A202070616464696E673A203130707820347078203130707820303B0D0A7D0D0A2E612D4D656E75202E612D4D656E752D6974656D202E612D4D656E752D737461747573436F6C207B0D0A202070616464696E673A20';
wwv_flow_imp.g_varchar2_table(854) := '31307078203870783B0D0A7D0D0A2E612D4D656E752D68536570617261746F72207B0D0A2020626F726465722D636F6C6F723A20726762612833382C2033382C2033382C20302E31293B0D0A20206D617267696E2D746F703A203470783B0D0A20207061';
wwv_flow_imp.g_varchar2_table(855) := '6464696E672D746F703A203270783B0D0A202070616464696E672D626F74746F6D3A203270783B0D0A7D0D0A2E752D63616C6C6F75743A6265666F7265207B0D0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(856) := '2D736861646F773A20302030203020317078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E612D4D656E754261722D6C6162656C207B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A2020666F6E742D73697A65';
wwv_flow_imp.g_varchar2_table(857) := '3A20312E3472656D3B0D0A20206C696E652D6865696768743A20312E3672656D3B0D0A202070616464696E673A20313270783B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A2020666C65782D67726F773A20313B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(858) := '612D4D656E754261722D6C6162656C3A686F766572207B0D0A20206261636B67726F756E642D636C69703A2070616464696E672D626F783B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A2E612D4D656E754261722D6C61';
wwv_flow_imp.g_varchar2_table(859) := '62656C202B202E612D4D656E752D7375624D656E75436F6C207B0D0A2020666C65782D736872696E6B3A20303B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A20206C696E652D6865696768743A20313B0D0A7D0D0A2E612D4D656E7542';
wwv_flow_imp.g_varchar2_table(860) := '61722D6974656D207B0D0A2020646973706C61793A20666C65783B0D0A2020666C6F61743A206C6566743B0D0A202070616464696E673A20303B0D0A2020626F726465722D77696474683A2030203170783B0D0A2020626F782D736861646F773A206E6F';
wwv_flow_imp.g_varchar2_table(861) := '6E653B0D0A20206D617267696E2D6C6566743A20303B0D0A20206261636B67726F756E642D636C69703A20636F6E74656E742D626F783B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D6974656D207B0D0A2020666C6F61743A207269676874';
wwv_flow_imp.g_varchar2_table(862) := '3B0D0A7D0D0A2E612D4D656E754261722D6974656D2E69732D657870616E646564207B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A2E612D4D656E754261722D6974656D3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(863) := '723A207472616E73706172656E743B0D0A7D0D0A2E612D4D656E754261722D6974656D3A66697273742D6368696C64207B0D0A2020626F726465722D6C6566742D77696474683A20303B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D697465';
wwv_flow_imp.g_varchar2_table(864) := '6D3A66697273742D6368696C64207B0D0A2020626F726465722D72696768742D77696474683A20303B0D0A2020626F726465722D6C6566742D77696474683A203170783B0D0A7D0D0A2E612D4D656E754261722D6974656D2E69732D666F637573656420';
wwv_flow_imp.g_varchar2_table(865) := '7B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74202E612D4D656E754261722D6C6162656C207B0D0A2020666F6E742D7765696768743A20626F6C643B0D';
wwv_flow_imp.g_varchar2_table(866) := '0A7D0D0A2E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C2C0D0A2E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C207B0D0A202062';
wwv_flow_imp.g_varchar2_table(867) := '6F726465722D77696474683A20303B0D0A202070616464696E673A20302031327078203020303B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C2C0D0A2E752D52544C202E612D';
wwv_flow_imp.g_varchar2_table(868) := '4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C207B0D0A202070616464696E672D72696768743A20303B0D0A202070616464696E672D6C6566743A20313270783B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(869) := '6465722D72696768743A20302021696D706F7274616E743B0D0A7D0D0A2E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020626F726465722D7261646975733A2031322E35253B';
wwv_flow_imp.g_varchar2_table(870) := '0D0A7D0D0A2E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E3A6265666F7265207B0D0A2020636F6E74656E743A20275C65306332273B0D0A7D0D0A2E612D4D656E754261722D6974656D20';
wwv_flow_imp.g_varchar2_table(871) := '3E20627574746F6E202B202E612D4D656E752D7375624D656E75436F6C207B0D0A20206D617267696E2D6C6566743A202D3670783B0D0A7D0D0A2E752D52544C202E612D4D656E754261722D6974656D203E20627574746F6E202B202E612D4D656E752D';
wwv_flow_imp.g_varchar2_table(872) := '7375624D656E75436F6C207B0D0A20206D617267696E2D6C6566743A20303B0D0A20206D617267696E2D72696768743A202D3670783B0D0A7D0D0A2E742D4865616465722D6E61762D6C697374207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(873) := '20233333336434363B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6E6176202E742D4D656E752D6261646765207B0D';
wwv_flow_imp.g_varchar2_table(874) := '0A202070616464696E673A2030203670783B0D0A2020666F6E742D73697A653A20313170783B0D0A20206C696E652D6865696768743A20696E68657269743B0D0A2020666F6E742D7765696768743A203530303B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(875) := '6F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A2020766572746963616C2D616C69676E3A20746F703B0D0A20206D617267696E2D6C6566743A20';
wwv_flow_imp.g_varchar2_table(876) := '3470783B0D0A2020626F726465722D7261646975733A20313670783B0D0A7D0D0A2E752D52544C202E742D4865616465722D6E6176202E742D4D656E752D6261646765207B0D0A20206D617267696E2D6C6566743A20303B0D0A20206D617267696E2D72';
wwv_flow_imp.g_varchar2_table(877) := '696768743A203470783B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D207B0D0A2020626F726465722D636F6C6F723A20233433346335333B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261';
wwv_flow_imp.g_varchar2_table(878) := '722D6974656D2E69732D666F6375736564207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D486561';
wwv_flow_imp.g_varchar2_table(879) := '6465722D6E6176202E612D4D656E754261722D6974656D2E69732D666F6375736564202E612D4D656E754261722D6C6162656C207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261';
wwv_flow_imp.g_varchar2_table(880) := '722D6974656D2E612D4D656E752D2D63757272656E742C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F63757365642C0D0A2E742D4865616465722D6E6176202E61';
wwv_flow_imp.g_varchar2_table(881) := '2D4D656E754261722D6974656D2E69732D657870616E6465642C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E646564207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(882) := '642D636F6C6F723A20233165323332383B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74202E612D4D656E754261722D6C6162656C2C0D0A2E742D4865616465722D6E6176';
wwv_flow_imp.g_varchar2_table(883) := '202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F6375736564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D65787061';
wwv_flow_imp.g_varchar2_table(884) := '6E646564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E646564202E612D4D656E754261722D6C6162656C207B';
wwv_flow_imp.g_varchar2_table(885) := '0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020636F6C6F723A207267626128';
wwv_flow_imp.g_varchar2_table(886) := '3235352C203235352C203235352C20302E38293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C3A686F766572202E612D49';
wwv_flow_imp.g_varchar2_table(887) := '636F6E2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D666F6375736564203E20627574746F6E202B202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(888) := '2D636F6C6F723A2072676261283235352C203235352C203235352C20302E3135293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F';
wwv_flow_imp.g_varchar2_table(889) := '6C202E612D49636F6E2C0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F6C3A686F766572202E612D49636F6E207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(890) := '6F756E642D636F6C6F723A20233030373664663B0D0A2020626F726465722D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656E75426172207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(891) := '6F723A20236638663866383B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6C6162656C207B0D0A2020636F6C6F723A20233338333833383B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D207B0D0A';
wwv_flow_imp.g_varchar2_table(892) := '2020626F726465722D636F6C6F723A20236534653465343B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D666F6375736564207B0D0A20206261636B67726F756E642D636F6C6F723A20236630663066303B0D0A';
wwv_flow_imp.g_varchar2_table(893) := '7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F63757365';
wwv_flow_imp.g_varchar2_table(894) := '642C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D657870616E6465642C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E64656420';
wwv_flow_imp.g_varchar2_table(895) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E74202E612D4D656E754261722D6C6162656C2C0D0A2E74';
wwv_flow_imp.g_varchar2_table(896) := '2D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D666F6375736564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E6973';
wwv_flow_imp.g_varchar2_table(897) := '2D657870616E646564202E612D4D656E754261722D6C6162656C2C0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D63757272656E742E69732D657870616E646564202E612D4D656E754261722D6C6162656C';
wwv_flow_imp.g_varchar2_table(898) := '207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A2020636F6C6F723A20726762612835';
wwv_flow_imp.g_varchar2_table(899) := '362C2035362C2035362C20302E38293B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E612D4D656E752D2D73706C6974203E202E612D4D656E752D7375624D656E75436F6C3A686F766572202E612D49636F6E2C0D0A2E';
wwv_flow_imp.g_varchar2_table(900) := '742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D666F6375736564203E20627574746F6E202B202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207267';
wwv_flow_imp.g_varchar2_table(901) := '62612835362C2035362C2035362C20302E3135293B0D0A7D0D0A2E742D4D656E75426172202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F6C202E612D49636F6E2C0D0A2E742D4D';
wwv_flow_imp.g_varchar2_table(902) := '656E75426172202E612D4D656E754261722D6974656D2E69732D657870616E646564203E202E612D4D656E752D7375624D656E75436F6C3A686F766572202E612D49636F6E207B0D0A20206261636B67726F756E642D636F6C6F723A2023666666666666';
wwv_flow_imp.g_varchar2_table(903) := '3B0D0A2020626F726465722D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233030373664663B0D0A7D0D0A2E742D4E617654616273207B0D0A20206261636B67726F756E642D636F6C6F723A20233333336434363B0D0A7D0D0A2E74';
wwv_flow_imp.g_varchar2_table(904) := '2D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A2020626F782D736861646F773A20696E7365742031707820302030203020233333';
wwv_flow_imp.g_varchar2_table(905) := '336434363B0D0A7D0D0A2E742D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D7468756D623A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233365346135343B0D0A7D0D0A2E742D4E6176546162733A3A';
wwv_flow_imp.g_varchar2_table(906) := '2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261636B67726F756E643A20233333336434363B0D0A7D0D0A2E742D4E6176546162733A3A2D7765626B69742D7363726F6C6C6261722D747261636B3A686F766572207B0D0A20';
wwv_flow_imp.g_varchar2_table(907) := '206261636B67726F756E642D636F6C6F723A20233534363437323B0D0A7D0D0A2E742D4E6176546162732D6974656D207B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F726465722D636F6C6F723A20233365346135343B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(908) := '742D4E6176546162732D6974656D3A686F7665722C0D0A2E742D4E6176546162732D6974656D2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20233165323332383B0D0A2020636F6C6F723A20236666666666663B0D';
wwv_flow_imp.g_varchar2_table(909) := '0A7D0D0A2E742D4E6176546162732D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233165323332383B0D0A7D0D0A2E742D506F7075704C4F562D6C696E6B7320613A686F7665';
wwv_flow_imp.g_varchar2_table(910) := '72207B0D0A20206261636B67726F756E642D636F6C6F723A20233030366564303B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D506F7075704C4F562D726573756C74735365742074723A686F766572207464207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(911) := '6B67726F756E642D636F6C6F723A20234543463246422021696D706F7274616E743B0D0A7D0D0A2E742D506F7075704C4F562D726573756C74735365742074723A6E74682D6368696C6428326E29207464207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(912) := '6C6F723A20234641464146413B0D0A7D0D0A2E742D506F7075704C4F562D726573756C74735365742D6C696E6B2C0D0A2E75692D7769646765742D636F6E74656E7420612E742D506F7075704C4F562D726573756C74735365742D6C696E6B207B0D0A20';
wwv_flow_imp.g_varchar2_table(913) := '20636F6C6F723A20233030366564303B0D0A7D0D0A2E742D506167652D2D706F7075704C4F56207B0D0A20206261636B67726F756E642D636F6C6F723A20234646463B0D0A7D0D0A2E742D506F7075704C4F562D616374696F6E73207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(914) := '6B67726F756E642D636F6C6F723A20234644464446443B0D0A2020626F782D736861646F773A2030202D3170782030207267626128302C20302C20302C20302E31352920696E7365743B0D0A7D0D0A2E742D426F6479202E742D506F7075704C4F562D6C';
wwv_flow_imp.g_varchar2_table(915) := '696E6B732061207B0D0A2020636F6C6F723A20233365336533653B0D0A7D0D0A2E742D426F64792D7469746C65202E742D506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D426F64792D69';
wwv_flow_imp.g_varchar2_table(916) := '6E666F202E742D506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D526567696F6E202E742D506F7075704C4F562D6C696E6B7320612C0D0A2E742D427574746F6E526567696F6E202E742D';
wwv_flow_imp.g_varchar2_table(917) := '506F7075704C4F562D6C696E6B732061207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D506F7075704C4F562D6C696E6B7320613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233034383966663B0D';
wwv_flow_imp.g_varchar2_table(918) := '0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F6479202E742D506F7075704C4F562D706167696E6174696F6E207B0D0A2020636F6C6F723A20233765376537653B0D0A7D0D0A2E742D426F64792D7469746C65202E742D506F7075';
wwv_flow_imp.g_varchar2_table(919) := '704C4F562D706167696E6174696F6E207B0D0A2020636F6C6F723A20233830383038303B0D0A7D0D0A2E742D426F64792D696E666F202E742D506F7075704C4F562D706167696E6174696F6E207B0D0A2020636F6C6F723A20233830383038303B0D0A7D';
wwv_flow_imp.g_varchar2_table(920) := '0D0A2E742D526567696F6E202E742D506F7075704C4F562D706167696E6174696F6E2C0D0A2E742D427574746F6E526567696F6E202E742D506F7075704C4F562D706167696E6174696F6E207B0D0A2020636F6C6F723A20233830383038303B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(921) := '0A2E612D506F7075704C4F562D736561726368426172207B0D0A202070616464696E673A203870783B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D49636F6E4C6973742D6974656D207B0D0A2020636F6C6F723A20696E686572';
wwv_flow_imp.g_varchar2_table(922) := '69743B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D49636F6E4C6973742D6974656D3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A2023666666666666';
wwv_flow_imp.g_varchar2_table(923) := '3B0D0A2020626F782D736861646F773A20302030203020317078202330303639633620696E7365743B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D49636F6E4C6973742D6974656D3A686F7665722061207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(924) := '723A20696E68657269743B0D0A7D0D0A2E612D506F7075704C4F562D726573756C7473202E612D47562D6C6F61644D6F7265207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(925) := '612D47562D6C6F61644D6F7265427574746F6E207B0D0A2020636F6C6F723A20233338333833383B0D0A20206261636B67726F756E642D636F6C6F723A20236638663866383B0D0A2020626F782D736861646F773A203020302030203170782072676261';
wwv_flow_imp.g_varchar2_table(926) := '28302C20302C20302C20302E3132352920696E7365743B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F782D736861646F77';
wwv_flow_imp.g_varchar2_table(927) := '3A20302030203020317078207267626128302C20302C20302C20302E31352920696E7365743B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A2023666666666666';
wwv_flow_imp.g_varchar2_table(928) := '3B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236465646564653B0D0A7D0D0A2E612D47562D6C6F61644D6F7265427574746F6E3A6163746976653A666F';
wwv_flow_imp.g_varchar2_table(929) := '637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C20302030203170782030207267626128352C203131342C203230362C20302E3235293B0D0A7D0D0A2E617065782D6974656D2D67726F75';
wwv_flow_imp.g_varchar2_table(930) := '702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D6974656D203E207370616E207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E617065782D6974656D';
wwv_flow_imp.g_varchar2_table(931) := '2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D6974656D2E69732D616374697665203E207370616E207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A';
wwv_flow_imp.g_varchar2_table(932) := '7D0D0A2E617065782D6974656D2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D72656D6F7665207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E61706578';
wwv_flow_imp.g_varchar2_table(933) := '2D6974656D2D67726F75702D2D706F7075702D6C6F76202E617065782D6974656D2D6D756C74692D72656D6F76653A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(934) := '0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263682C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762C0D0A2E617065782D6974656D2D6D756C7469207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(935) := '6F723A20233230323032303B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A2020626F726465722D636F6C6F723A20236466646664663B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D';
wwv_flow_imp.g_varchar2_table(936) := '7365617263683A666F6375732C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F763A666F6375732C0D0A2E617065782D6974656D2D6D756C74693A666F6375732C0D0A2E617065782D6974656D2D746578742E';
wwv_flow_imp.g_varchar2_table(937) := '612D506F7075704C4F562D7365617263682E69732D666F63757365642C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F63757365642C0D0A2E617065782D6974656D2D6D756C74692E69732D';
wwv_flow_imp.g_varchar2_table(938) := '666F6375736564207B0D0A2020636F6C6F723A20233230323032303B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666662021696D706F7274616E743B0D0A2020626F726465722D636F6C6F723A20233030373664662021696D706F';
wwv_flow_imp.g_varchar2_table(939) := '7274616E743B0D0A7D0D0A2E617065782D6974656D2D746578742E612D506F7075704C4F562D7365617263683A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D';
wwv_flow_imp.g_varchar2_table(940) := '2D706F7075702D6C6F763A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74693A666F637573202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D74';
wwv_flow_imp.g_varchar2_table(941) := '6578742E612D506F7075704C4F562D7365617263682E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D746578742E617065782D6974656D2D706F7075702D6C6F762E69732D666F6375';
wwv_flow_imp.g_varchar2_table(942) := '736564202B202E612D427574746F6E2D2D706F7075704C4F562C0D0A2E617065782D6974656D2D6D756C74692E69732D666F6375736564202B202E612D427574746F6E2D2D706F7075704C4F56207B0D0A2020626F782D736861646F773A203020302030';
wwv_flow_imp.g_varchar2_table(943) := '20317078202330303736646620696E7365743B0D0A7D0D0A2E75692D6469616C6F67202E75692D6469616C6F672D636F6E74656E742E612D506F7075704C4F562D6469616C6F67207B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B';
wwv_flow_imp.g_varchar2_table(944) := '0D0A7D0D0A2E612D506F7075704C4F562D646F5365617263683A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E612D506F7075704C4F562D7365617263684261722C';
wwv_flow_imp.g_varchar2_table(945) := '0D0A2E612D506F7075704C4F562D636C656172207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E612D506F7075704C4F562D636C656172427574746F6E207B0D0A202062';
wwv_flow_imp.g_varchar2_table(946) := '61636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E612D506F7075704C4F562D636C656172427574746F6E3A686F766572207B0D0A2020636F6C6F723A20236666663B';
wwv_flow_imp.g_varchar2_table(947) := '0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E612D506F7075704C4F562D636C656172427574746F6E3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620';
wwv_flow_imp.g_varchar2_table(948) := '696E7365743B0D0A7D0D0A2E742D526567696F6E207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D526567696F6E2C0D0A2E742D436F6E74656E74426C6F636B2D2D6C696768744247';
wwv_flow_imp.g_varchar2_table(949) := '202E742D436F6E74656E74426C6F636B2D626F6479207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F6479202E6669656C64646174612062207B0D0A2020636F6C6F723A20233365336533653B0D';
wwv_flow_imp.g_varchar2_table(950) := '0A7D0D0A2E742D426F64792D7469746C65202E6669656C64646174612062207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D426F64792D696E666F202E6669656C64646174612062207B0D0A2020636F6C6F723A20233430343034';
wwv_flow_imp.g_varchar2_table(951) := '303B0D0A7D0D0A2E742D526567696F6E202E6669656C646461746120622C0D0A2E742D427574746F6E526567696F6E202E6669656C64646174612062207B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D526567696F6E2D68656164';
wwv_flow_imp.g_varchar2_table(952) := '6572207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233236323632363B0D';
wwv_flow_imp.g_varchar2_table(953) := '0A7D0D0A2E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(954) := '426F64792D616374696F6E73202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E643A207472616E73706172656E743B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E742D526567696F6E2D2D737461636B65';
wwv_flow_imp.g_varchar2_table(955) := '64207B0D0A2020626F726465722D7261646975733A20302021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E2D2D6E6F426F72646572203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(956) := '3A20236666666666663B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E2D2D6E6F426F72646572203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E';
wwv_flow_imp.g_varchar2_table(957) := '2D2D6E6F426F72646572203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431203E202E742D526567696F';
wwv_flow_imp.g_varchar2_table(958) := '6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644423B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431203E202E742D526567696F6E2D6865616465';
wwv_flow_imp.g_varchar2_table(959) := '72202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7431203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(960) := '742D526567696F6E2D2D616363656E74312E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233330394644423B0D0A7D0D0A2E742D526567696F6E2D2D616363656E';
wwv_flow_imp.g_varchar2_table(961) := '7432203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643463B0D0A2020636F6C6F723A20236534663966643B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7432203E202E74';
wwv_flow_imp.g_varchar2_table(962) := '2D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7432203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(963) := '6534663966643B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74322E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233133423643463B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(964) := '526567696F6E2D2D616363656E7433203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642433B0D0A2020636F6C6F723A20236630666366623B0D0A7D0D0A2E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(965) := '2D616363656E7433203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7433203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B20';
wwv_flow_imp.g_varchar2_table(966) := '7B0D0A2020636F6C6F723A20236630666366623B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74332E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233245';
wwv_flow_imp.g_varchar2_table(967) := '424642433B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7434203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638353B0D0A2020636F6C6F723A20236630666166363B0D0A';
wwv_flow_imp.g_varchar2_table(968) := '7D0D0A2E742D526567696F6E2D2D616363656E7434203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7434203E202E742D526567696F6E2D686561646572202E742D';
wwv_flow_imp.g_varchar2_table(969) := '427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236630666166363B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74342E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D';
wwv_flow_imp.g_varchar2_table(970) := '0A2020636F6C6F723A20233343414638353B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7435203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233831424235463B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(971) := '723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7435203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7435203E202E742D52656769';
wwv_flow_imp.g_varchar2_table(972) := '6F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74352E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567';
wwv_flow_imp.g_varchar2_table(973) := '696F6E2D686561646572207B0D0A2020636F6C6F723A20233831424235463B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7436203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234444';
wwv_flow_imp.g_varchar2_table(974) := '444535333B0D0A2020636F6C6F723A20233261326130383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7436203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D61636365';
wwv_flow_imp.g_varchar2_table(975) := '6E7436203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233261326130383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74362E742D526567696F6E2D2D74657874436F6E';
wwv_flow_imp.g_varchar2_table(976) := '74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234444444535333B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7437203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(977) := '6E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7437203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E74';
wwv_flow_imp.g_varchar2_table(978) := '2D526567696F6E2D2D616363656E7437203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D526567696F6E2D2D616363656E74372E742D5265';
wwv_flow_imp.g_varchar2_table(979) := '67696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7438203E202E742D526567696F6E2D68656164657220';
wwv_flow_imp.g_varchar2_table(980) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133453B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7438203E202E742D526567696F6E2D686561646572202E742D42757474';
wwv_flow_imp.g_varchar2_table(981) := '6F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7438203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(982) := '2D616363656E74382E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234544383133453B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7439203E202E742D52';
wwv_flow_imp.g_varchar2_table(983) := '6567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235343B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7439203E202E742D526567696F6E2D68';
wwv_flow_imp.g_varchar2_table(984) := '6561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E7439203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A';
wwv_flow_imp.g_varchar2_table(985) := '7D0D0A2E742D526567696F6E2D2D616363656E74392E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234539354235343B0D0A7D0D0A2E742D526567696F6E2D2D61';
wwv_flow_imp.g_varchar2_table(986) := '6363656E743130203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438383B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431';
wwv_flow_imp.g_varchar2_table(987) := '30203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743130203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A202063';
wwv_flow_imp.g_varchar2_table(988) := '6F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431302E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234538354438383B';
wwv_flow_imp.g_varchar2_table(989) := '0D0A7D0D0A2E742D526567696F6E2D2D616363656E743131203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(990) := '742D526567696F6E2D2D616363656E743131203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743131203E202E742D526567696F6E2D686561646572202E742D4275';
wwv_flow_imp.g_varchar2_table(991) := '74746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431312E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A';
wwv_flow_imp.g_varchar2_table(992) := '2020636F6C6F723A20234341353839443B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743132203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539423B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(993) := '723A20236636663066383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743132203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743132203E202E742D5265';
wwv_flow_imp.g_varchar2_table(994) := '67696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236636663066383B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431322E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D';
wwv_flow_imp.g_varchar2_table(995) := '526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233835344539423B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743133203E202E742D526567696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(996) := '20233541363841443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743133203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(997) := '2D616363656E743133203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E7431332E742D526567696F6E2D2D';
wwv_flow_imp.g_varchar2_table(998) := '74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233541363841443B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743134203E202E742D526567696F6E2D686561646572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(999) := '6261636B67726F756E642D636F6C6F723A20234146424143353B0D0A2020636F6C6F723A20233331336134343B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743134203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D';
wwv_flow_imp.g_varchar2_table(1000) := '6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743134203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20233331336134343B0D0A7D0D0A2E742D526567696F6E2D2D6163';
wwv_flow_imp.g_varchar2_table(1001) := '63656E7431342E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20234146424143353B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743135203E202E742D5265';
wwv_flow_imp.g_varchar2_table(1002) := '67696F6E2D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539383B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E2D2D616363656E743135203E202E742D526567696F6E2D68';
wwv_flow_imp.g_varchar2_table(1003) := '6561646572202E742D427574746F6E2D2D6E6F55492C0D0A2E742D526567696F6E2D2D616363656E743135203E202E742D526567696F6E2D686561646572202E742D427574746F6E2D2D6C696E6B207B0D0A2020636F6C6F723A20236666666666663B0D';
wwv_flow_imp.g_varchar2_table(1004) := '0A7D0D0A2E742D526567696F6E2D2D616363656E7431352E742D526567696F6E2D2D74657874436F6E74656E74203E202E742D526567696F6E2D686561646572207B0D0A2020636F6C6F723A20233645383539383B0D0A7D0D0A2E742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(1005) := '626F6479207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E2D2D6869646553686F772E69732D636F6C6C6170736564207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207472616E73706172656E74';
wwv_flow_imp.g_varchar2_table(1006) := '3B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D526567696F6E2D6865';
wwv_flow_imp.g_varchar2_table(1007) := '61646572207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D73696465202E742D526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E7370617265';
wwv_flow_imp.g_varchar2_table(1008) := '6E743B0D0A7D0D0A2E742D526567696F6E2C0D0A2E742D526567696F6E2D686561646572207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A2E742D526567696F6E2D2D6E6F4247207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(1009) := '6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D526567696F6E207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D526567696F6E2D2D63';
wwv_flow_imp.g_varchar2_table(1010) := '61726F7573656C202E612D546162732D627574746F6E207B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E34293B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1011) := '6666666666663B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D627574746F6E3A686F';
wwv_flow_imp.g_varchar2_table(1012) := '766572207B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365742C20302031707820317078207267626128302C20302C20302C20302E3035293B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1013) := '642D636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D627574746F6E3A6163746976652C0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D';
wwv_flow_imp.g_varchar2_table(1014) := '546162732D627574746F6E3A6163746976653A666F637573207B0D0A20206F7061636974793A20313B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365742C2030203170782031';
wwv_flow_imp.g_varchar2_table(1015) := '7078207267626128302C20302C20302C20302E30352920696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D54';
wwv_flow_imp.g_varchar2_table(1016) := '6162732D6E6578742D726567696F6E207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D546162732D70726576696F75732D726567696F6E207B0D0A';
wwv_flow_imp.g_varchar2_table(1017) := '2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D526567696F6E2D6361726F7573656C4E61764974656D2E612D546162732D73656C6563746564202E612D52';
wwv_flow_imp.g_varchar2_table(1018) := '6567696F6E2D6361726F7573656C4C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E34293B0D0A7D0D0A2E742D526567696F6E2D2D6361726F7573656C202E612D526567696F6E2D6361726F';
wwv_flow_imp.g_varchar2_table(1019) := '7573656C4E61764974656D2E612D546162732D73656C6563746564202E612D526567696F6E2D6361726F7573656C4C696E6B3A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D52656769';
wwv_flow_imp.g_varchar2_table(1020) := '6F6E2D2D6361726F7573656C202E612D526567696F6E2D6361726F7573656C4C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A2020626F726465722D7261646975733A203130';
wwv_flow_imp.g_varchar2_table(1021) := '30253B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0D0A7D0D0A2E742D5265706F72742D63656C6C2C0D0A2E742D5265706F72742D636F6C48656164207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1022) := '6F726465723A2031707820736F6C696420236536653665363B0D0A7D0D0A2E742D5265706F72742D7265706F7274207472202E742D5265706F72742D63656C6C3A6C6173742D6368696C642C0D0A2E742D5265706F72742D7265706F7274207472202E74';
wwv_flow_imp.g_varchar2_table(1023) := '2D5265706F72742D636F6C486561643A6C6173742D6368696C64207B0D0A2020626F726465722D72696768743A2031707820736F6C696420236536653665363B0D0A7D0D0A2E752D52544C202E742D5265706F72742D7265706F7274207472202E742D52';
wwv_flow_imp.g_varchar2_table(1024) := '65706F72742D63656C6C3A6C6173742D6368696C642C0D0A2E752D52544C202E742D5265706F72742D7265706F7274207472202E742D5265706F72742D636F6C486561643A6C6173742D6368696C64207B0D0A2020626F726465722D6C6566743A203170';
wwv_flow_imp.g_varchar2_table(1025) := '7820736F6C696420236536653665363B0D0A7D0D0A2E742D5265706F72742D7265706F72742074723A6C6173742D6368696C64202E742D5265706F72742D63656C6C207B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C696420236536';
wwv_flow_imp.g_varchar2_table(1026) := '653665363B0D0A7D0D0A2E742D5265706F7274202E69732D737475636B202E742D5265706F72742D636F6C48656164207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3935293B0D0A20';
wwv_flow_imp.g_varchar2_table(1027) := '202D7765626B69742D6261636B64726F702D66696C7465723A20626C757228347078293B0D0A7D0D0A2E742D526567696F6E2D2D6E6F50616464696E67202E742D5265706F72742D2D686F72697A6F6E74616C426F7264657273202E69732D737475636B';
wwv_flow_imp.g_varchar2_table(1028) := '202E742D5265706F72742D636F6C486561642C0D0A2E742D5265706F72742D2D696E6C696E65202E69732D737475636B202E742D5265706F72742D636F6C48656164207B0D0A20206261636B67726F756E642D636F6C6F723A2072676261283235352C20';
wwv_flow_imp.g_varchar2_table(1029) := '3235352C203235352C20302E3935293B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D5265706F72742D2D726F77486967686C69676874202E742D5265706F72742D';
wwv_flow_imp.g_varchar2_table(1030) := '7265706F72742074723A686F766572202E742D5265706F72742D63656C6C2C0D0A2E742D5265706F72742D2D726F77486967686C69676874202E742D5265706F72742D7265706F72742074723A6E74682D6368696C64286F6464293A686F766572202E74';
wwv_flow_imp.g_varchar2_table(1031) := '2D5265706F72742D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166612021696D706F7274616E743B0D0A7D0D0A2E742D5265706F72742D2D737461746963526F77436F6C6F7273202E742D5265706F72742D726570';
wwv_flow_imp.g_varchar2_table(1032) := '6F72742074723A6E74682D6368696C64286F646429202E742D5265706F72742D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D5265706F72742D2D616C74526F77734465666175';
wwv_flow_imp.g_varchar2_table(1033) := '6C74202E742D5265706F72742D7265706F72742074723A6E74682D6368696C64286F646429202E742D5265706F72742D63656C6C207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1034) := '0A2E742D5265706F72742D706167696E6174696F6E5465787420622C0D0A2E742D5265706F72742D706167696E6174696F6E5465787420613A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(1035) := '6C6F723A20236666666666663B0D0A7D0D0A2E742D5265706F72742D6C696E6B73207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A20206261636B67726F756E642D636F6C6F723A2072676261';
wwv_flow_imp.g_varchar2_table(1036) := '28302C20302C20302C20302E303235293B0D0A7D0D0A2E742D536561726368526573756C74732D64657363207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E742D536561726368526573756C74732D64617465207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(1037) := '723A20233731373137313B0D0A7D0D0A2E742D536561726368526573756C74732D6D697363207B0D0A2020636F6C6F723A20233731373137313B0D0A7D0D0A2E742D526567696F6E202E742D536561726368526573756C74732D64657363207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1038) := '636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E202E742D536561726368526573756C74732D64617465207B0D0A2020636F6C6F723A20233733373337333B0D0A7D0D0A2E742D526567696F6E202E742D53656172636852657375';
wwv_flow_imp.g_varchar2_table(1039) := '6C74732D6D697363207B0D0A2020636F6C6F723A20233733373337333B0D0A7D0D0A2E612D53746172526174696E672D7374617273207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A7D0D0A2E612D537461725261';
wwv_flow_imp.g_varchar2_table(1040) := '74696E672D73746172732E69732D666F6375736564207B0D0A2020626F782D736861646F773A203020302030203170782063757272656E74436F6C6F7220696E7365743B0D0A7D0D0A2E612D53746172526174696E672D73746172732E69732D666F6375';
wwv_flow_imp.g_varchar2_table(1041) := '736564202E612D53746172526174696E672D73746172732D6667202E612D53746172526174696E672D73746172207B0D0A2020746578742D736861646F773A20302030203270782063757272656E74436F6C6F723B0D0A7D0D0A2E612D47562D63656C6C';
wwv_flow_imp.g_varchar2_table(1042) := '2E69732D616374697665202E612D53746172526174696E672D73746172732E69732D666F6375736564207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E612D53746172526174696E672D73746172732D6667207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(1043) := '6F723A20233030373664663B0D0A7D0D0A2E612D53746172526174696E672D76616C7565207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E612D53746172526174696E672D636C6561723A666F637573207B0D0A2020626F782D736861';
wwv_flow_imp.g_varchar2_table(1044) := '646F773A20696E7365742023303037366466203020302030203170783B0D0A7D0D0A2E612D53746172526174696E672D2D64697361626C6564202E612D53746172526174696E672D73746172732D6667207B0D0A2020636F6C6F723A20696E697469616C';
wwv_flow_imp.g_varchar2_table(1045) := '3B0D0A7D0D0A2E742D5374617475734C6973742D626C6F636B486561646572207B0D0A2020636F6C6F723A20233236323632363B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D626F74746F6D2D';
wwv_flow_imp.g_varchar2_table(1046) := '636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D5374617475734C6973742D68656164657254657874416C';
wwv_flow_imp.g_varchar2_table(1047) := '742C0D0A2E742D5374617475734C6973742D617474722C0D0A2E742D5374617475734C6973742D7465787444657363207B0D0A2020636F6C6F723A20233733373337333B0D0A7D0D0A2E742D5374617475734C6973742D6974656D5469746C65207B0D0A';
wwv_flow_imp.g_varchar2_table(1048) := '2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D5374617475734C6973742D2D6461746573202E742D5374617475734C6973742D6D61726B6572207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E35293B0D0A202062';
wwv_flow_imp.g_varchar2_table(1049) := '6F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0D';
wwv_flow_imp.g_varchar2_table(1050) := '0A7D0D0A2E742D5374617475734C6973742D2D6461746573202E742D5374617475734C6973742D6D61726B65723A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E32293B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1051) := '726465722D7261646975733A2032707820327078203020303B0D0A7D0D0A2E742D5374617475734C6973742D2D6461746573202E742D5374617475734C6973742D6974656D2E69732D6E756C6C202E742D5374617475734C6973742D6D61726B6572207B';
wwv_flow_imp.g_varchar2_table(1052) := '0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6D61726B6572';
wwv_flow_imp.g_varchar2_table(1053) := '207B0D0A2020626F726465722D7261646975733A20323470783B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B0D0A2020636F6C6F723A20233430343034303B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(1054) := '20302C20302E3135293B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D636F6D706C657465202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(1055) := '726F756E642D636F6C6F723A20233730373037303B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D64616E676572202E742D5374617475734C6973742D6D61726B65722C0D';
wwv_flow_imp.g_varchar2_table(1056) := '0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D6572726F72202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A2023666633';
wwv_flow_imp.g_varchar2_table(1057) := '6233303B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D6F70656E202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1058) := '723A20233463643936343B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D7761726E696E67202E742D5374617475734C6973742D6D61726B6572207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(1059) := '726F756E642D636F6C6F723A20236666636330303B0D0A7D0D0A2E742D5374617475734C6973742D2D62756C6C657473202E742D5374617475734C6973742D6974656D2E69732D6E756C6C202E742D5374617475734C6973742D6D61726B6572207B0D0A';
wwv_flow_imp.g_varchar2_table(1060) := '20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3935293B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A2020626F782D736861646F773A2030203020302031';
wwv_flow_imp.g_varchar2_table(1061) := '7078207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A2E742D5374617475734C6973742D6974656D49636F6E207B0D0A2020636F6C6F723A207267626128302C20302C20302C20302E34293B0D0A2020626F782D73686164';
wwv_flow_imp.g_varchar2_table(1062) := '6F773A203020302030207267626128302C20302C20302C20302E322920696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E612D5461626C652E752D5265706F72742074642C0D0A2E612D5461626C';
wwv_flow_imp.g_varchar2_table(1063) := '652E752D5265706F7274207468207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E612D5461626C652E752D5265706F72742E7461626C652D7374726F6B652074642C0D0A2E612D5461626C652E752D526570';
wwv_flow_imp.g_varchar2_table(1064) := '6F72742E7461626C652D7374726F6B65207468207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E612D5461626C652E752D5265706F72742074723A6E74682D6368696C64286576656E2920';
wwv_flow_imp.g_varchar2_table(1065) := '74642C0D0A2E612D5461626C652E752D5265706F72742074723A6E74682D6368696C64286576656E292074685B73636F70653D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B0D0A7D0D0A2E612D5461626C652E';
wwv_flow_imp.g_varchar2_table(1066) := '752D5265706F72742E7461626C652D7374726970652074723A6E74682D6368696C64286576656E292074642C0D0A2E612D5461626C652E752D5265706F72742E7461626C652D7374726970652074723A6E74682D6368696C64286576656E292074685B73';
wwv_flow_imp.g_varchar2_table(1067) := '636F70653D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A7D0D0A406D6564696120286D61782D77696474683A20353630707829207B0D0A20202E612D5461626C65';
wwv_flow_imp.g_varchar2_table(1068) := '2D2D7265666C6F772E75692D726573706F6E736976652074642C0D0A20202E612D5461626C652D2D7265666C6F772E75692D726573706F6E73697665207468207B0D0A20202020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20';
wwv_flow_imp.g_varchar2_table(1069) := '302C20302C20302E3035293B0D0A20207D0D0A7D0D0A2E752D5265706F7274202E752D5265706F72742D6865616465722C0D0A2E752D5265706F7274207468207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C';
wwv_flow_imp.g_varchar2_table(1070) := '20302E303235293B0D0A2020636F6C6F723A20233030303B0D0A7D0D0A2E752D5265706F72742074685B73636F70653D22726F7767726F7570225D207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E30';
wwv_flow_imp.g_varchar2_table(1071) := '35293B0D0A7D0D0A2E752D5265706F72742074685B73636F70653D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A20236666663B0D0A7D0D0A2E752D5265706F7274207464207B0D0A2020636F6C6F723A20233030303B0D0A20';
wwv_flow_imp.g_varchar2_table(1072) := '206261636B67726F756E642D636F6C6F723A20236666663B0D0A7D0D0A2E752D5265706F72742074723A6E74682D6368696C64286576656E292074642C0D0A2E752D5265706F72742074723A6E74682D6368696C64286576656E292074685B73636F7065';
wwv_flow_imp.g_varchar2_table(1073) := '3D22726F77225D207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A7D0D0A2E752D5265706F72742074642C0D0A2E752D5265706F7274207468207B0D0A2020626F726465722D636F6C';
wwv_flow_imp.g_varchar2_table(1074) := '6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E752D5265706F72742D2D73746174696342472074723A6E74682D6368696C64286576656E292074642C0D0A2E752D5265706F72742D2D73746174696342472074723A6E74682D63';
wwv_flow_imp.g_varchar2_table(1075) := '68696C64286576656E292074685B73636F70653D22726F77225D207B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6974656D';
wwv_flow_imp.g_varchar2_table(1076) := '2E69732D616374697665202E742D546162732D6C696E6B207B0D0A2020626F782D736861646F773A2030202D3270782030202330303736646620696E7365743B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6C696E6B3A666F';
wwv_flow_imp.g_varchar2_table(1077) := '637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D546162732D2D70696C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A202062';
wwv_flow_imp.g_varchar2_table(1078) := '6F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E303529';
wwv_flow_imp.g_varchar2_table(1079) := '3B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D49636F6E207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20233236323632363B';
wwv_flow_imp.g_varchar2_table(1080) := '0D0A2020626F726465722D6C6566742D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E752D52544C202E742D546162732D2D70696C6C202E742D546162732D6C696E6B207B0D0A2020626F726465722D72696768742D63';
wwv_flow_imp.g_varchar2_table(1081) := '6F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1082) := '742D546162732D2D70696C6C202E742D546162732D6C696E6B3A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D546162732D2D70696C6C202E742D546162732D';
wwv_flow_imp.g_varchar2_table(1083) := '6C696E6B3A616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20302E30352920696E7365743B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1084) := '2E742D546162732D2D70696C6C202E742D546162732D6974656D3A66697273742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A7D0D0A2E752D52544C202E742D54';
wwv_flow_imp.g_varchar2_table(1085) := '6162732D2D70696C6C202E742D546162732D6974656D3A66697273742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D7261646975733A2030203270782032707820303B0D0A7D0D0A2E742D546162732D2D70696C6C202E';
wwv_flow_imp.g_varchar2_table(1086) := '742D546162732D6974656D3A6C6173742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D72696768742D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E752D52544C202E742D546162732D';
wwv_flow_imp.g_varchar2_table(1087) := '2D70696C6C202E742D546162732D6974656D3A6C6173742D6368696C64202E742D546162732D6C696E6B207B0D0A2020626F726465722D6C6566742D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D546162732D2D';
wwv_flow_imp.g_varchar2_table(1088) := '70696C6C202E742D546162732D6974656D2E69732D616374697665202E742D546162732D6C696E6B207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D49636F6E';
wwv_flow_imp.g_varchar2_table(1089) := '207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D54';
wwv_flow_imp.g_varchar2_table(1090) := '6162732D6C696E6B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A7D0D0A2E742D546162732D2D73696D706C65202E742D546162732D6C696E6B3A61637469766520';
wwv_flow_imp.g_varchar2_table(1091) := '7B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A7D0D0A2E742D426F6479202E742D546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20233234';
wwv_flow_imp.g_varchar2_table(1092) := '323432343B0D0A7D0D0A2E742D426F64792D7469746C65202E742D546162732D2D73696D706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E202E742D546162732D2D73696D';
wwv_flow_imp.g_varchar2_table(1093) := '706C65202E742D546162732D6C696E6B207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E617065782D726473202E617065782D7264732D73656C6563746564207370616E207B0D0A2020626F782D736861646F773A2030202D32707820';
wwv_flow_imp.g_varchar2_table(1094) := '30202330303736646620696E7365743B0D0A7D0D0A2E617065782D72647320613A666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E617065782D7264732061207B0D0A';
wwv_flow_imp.g_varchar2_table(1095) := '2020636F6C6F723A20233234323432343B0D0A7D0D0A2E742D426F64792D7469746C65202E617065782D72647320612C0D0A2E742D426F64792D696E666F202E617065782D7264732061207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1096) := '2E742D526567696F6E202E617065782D7264732061207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E617065782D72647320613A686F766572207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A2E617065782D72647320';
wwv_flow_imp.g_varchar2_table(1097) := '2E617065782D7264732D73656C65637465642061207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A2E617065782D7264732D686F7665722E6C6566742061207B0D0A20206261636B67726F756E643A202D7765626B69742D6C696E656172';
wwv_flow_imp.g_varchar2_table(1098) := '2D6772616469656E74286C6566742C2023666666666666203530252C2072676261283235352C203235352C203235352C2030292031303025293B0D0A20206261636B67726F756E643A206C696E6561722D6772616469656E7428746F2072696768742C20';
wwv_flow_imp.g_varchar2_table(1099) := '23666666666666203530252C2072676261283235352C203235352C203235352C2030292031303025293B0D0A7D0D0A2E617065782D7264732D686F7665722E72696768742061207B0D0A20206261636B67726F756E643A202D7765626B69742D6C696E65';
wwv_flow_imp.g_varchar2_table(1100) := '61722D6772616469656E74286C6566742C20236666666666662030252C2072676261283235352C203235352C203235352C2030292031252C202366666666666620353025293B0D0A20206261636B67726F756E643A206C696E6561722D6772616469656E';
wwv_flow_imp.g_varchar2_table(1101) := '7428746F2072696768742C20236666666666662030252C2072676261283235352C203235352C203235352C2030292031252C202366666666666620353025293B0D0A7D0D0A2E617065782D7264732D6974656D2D2D68696E742061207370616E207B0D0A';
wwv_flow_imp.g_varchar2_table(1102) := '2020626F782D736861646F773A2030202D3270782030207267626128302C20302C20302C20302E322920696E7365743B0D0A7D0D0A2E766572746963616C2D726473202E617065782D726473202E617065782D7264732D73656C6563746564207370616E';
wwv_flow_imp.g_varchar2_table(1103) := '2C0D0A2E742D426F64792D73696465202E617065782D726473202E617065782D7264732D73656C6563746564207370616E207B0D0A2020626F782D736861646F773A2034707820302030202330303736646620696E7365743B0D0A7D0D0A2E752D52544C';
wwv_flow_imp.g_varchar2_table(1104) := '202E766572746963616C2D726473202E617065782D726473202E617065782D7264732D73656C6563746564207370616E2C0D0A2E752D52544C202E742D426F64792D73696465202E617065782D726473202E617065782D7264732D73656C656374656420';
wwv_flow_imp.g_varchar2_table(1105) := '7370616E207B0D0A2020626F782D736861646F773A202D34707820302030202330303736646620696E7365743B0D0A7D0D0A2E612D546167436C6F75642D6C696E6B207B0D0A2020626F726465722D636F6C6F723A20236632663266323B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1106) := '726465722D7261646975733A203270783B0D0A20206261636B67726F756E643A20236661666166613B0D0A20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E32732C20626F726465722D636F6C6F7220302E32732C2062';
wwv_flow_imp.g_varchar2_table(1107) := '6F782D736861646F7720302E32732C20636F6C6F7220302E32733B0D0A2020636F6C6F723A20233030366263623B0D0A7D0D0A2E612D546167436C6F75642D6C696E6B207370616E207B0D0A20207472616E736974696F6E3A20636F6C6F7220302E3273';
wwv_flow_imp.g_varchar2_table(1108) := '3B0D0A7D0D0A2E612D546167436C6F75642D6C696E6B3A686F766572207B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020626F726465722D636F6C';
wwv_flow_imp.g_varchar2_table(1109) := '6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A20302030203020327078202330303736646620696E7365743B0D0A7D0D0A2E612D546167436C6F75642D6C696E6B3A686F7665722073';
wwv_flow_imp.g_varchar2_table(1110) := '70616E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E612D546167436C6F75642D636F756E74207B0D0A2020636F6C6F723A20233636363636363B0D0A2020666F6E742D7765696768743A203530303B0D0A7D0D0A2E742D54696D65';
wwv_flow_imp.g_varchar2_table(1111) := '6C696E65207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D54696D656C696E652D6974656D207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(1112) := '54696D656C696E652D757365726E616D652C0D0A2E742D54696D656C696E652D646174652C0D0A2E742D54696D656C696E652D64657363207B0D0A2020636F6C6F723A20233636363636363B0D0A7D0D0A2E742D54696D656C696E652D61766174617220';
wwv_flow_imp.g_varchar2_table(1113) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D54696D656C696E652D77726170207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A612E74';
wwv_flow_imp.g_varchar2_table(1114) := '2D54696D656C696E652D777261703A686F7665722C0D0A612E742D54696D656C696E652D777261703A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A2020626F782D7368';
wwv_flow_imp.g_varchar2_table(1115) := '61646F773A20302038707820387078202D347078207267626128302C20302C20302C20302E3035292C20302032707820387078202D327078207267626128302C20302C20302C20302E31293B0D0A7D0D0A2E742D54696D656C696E652D74797065207B0D';
wwv_flow_imp.g_varchar2_table(1116) := '0A20206261636B67726F756E642D636F6C6F723A20236635663566353B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D54696D656C696E652D747970652E69732D6E6577207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1117) := '233342414132433B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D54696D656C696E652D747970652E69732D75706461746564207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1118) := '4646463B0D0A7D0D0A2E742D54696D656C696E652D747970652E69732D72656D6F766564207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E742D54696D656C696E65';
wwv_flow_imp.g_varchar2_table(1119) := '2D777261703A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D54696D656C696E65202B202E742D5265706F72742D';
wwv_flow_imp.g_varchar2_table(1120) := '706167696E6174696F6E207B0D0A2020626F726465722D746F702D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A7D0D0A406D6564696120286D696E2D77696474683A20373639707829207B0D0A20202E742D426F64792D6E6176';
wwv_flow_imp.g_varchar2_table(1121) := '207B0D0A202020206261636B67726F756E642D636F6C6F723A20233333336434363B0D0A20207D0D0A7D0D0A2E742D547265654E6176207B0D0A20206261636B67726F756E642D636F6C6F723A20233333336434363B0D0A7D0D0A2E742D50616765426F';
wwv_flow_imp.g_varchar2_table(1122) := '64792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A20206261636B67726F756E642D636F6C6F723A20233234326233313B0D0A2020626F782D736861646F773A20696E7365';
wwv_flow_imp.g_varchar2_table(1123) := '742031707820302030203020233333336434363B0D0A7D0D0A2E742D50616765426F64792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D7468756D623A686F766572207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1124) := '6F756E642D636F6C6F723A20233365346135343B0D0A7D0D0A2E742D50616765426F64792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A20206261636B67726F756E643A20';
wwv_flow_imp.g_varchar2_table(1125) := '233333336434363B0D0A7D0D0A2E742D50616765426F64792D2D6C6566744E6176202E742D426F64792D6E61763A3A2D7765626B69742D7363726F6C6C6261722D747261636B3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1126) := '233534363437323B0D0A7D0D0A2E742D526567696F6E207B0D0A20200D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A';
wwv_flow_imp.g_varchar2_table(1127) := '2020626F782D736861646F773A20302030203020317078202330303736646620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E';
wwv_flow_imp.g_varchar2_table(1128) := '6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D73';
wwv_flow_imp.g_varchar2_table(1129) := '656C65637465642C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1130) := '67726F756E642D636F6C6F723A20236637663766373B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E74';
wwv_flow_imp.g_varchar2_table(1131) := '2D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F';
wwv_flow_imp.g_varchar2_table(1132) := '704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69';
wwv_flow_imp.g_varchar2_table(1133) := '732D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236630663066302021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D5472656556';
wwv_flow_imp.g_varchar2_table(1134) := '6965772D726F772E69732D686F766572202B202E612D54726565566965772D746F67676C652C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D5472656556';
wwv_flow_imp.g_varchar2_table(1135) := '6965772D746F67676C65207B0D0A2020636F6C6F723A20726762612833382C2033382C2033382C20302E3735293B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(1136) := '726F772E69732D686F766572202B202E612D54726565566965772D746F67676C653A686F7665722C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D547265';
wwv_flow_imp.g_varchar2_table(1137) := '65566965772D746F67676C653A686F766572207B0D0A2020636F6C6F723A20233236323632362021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D5472656556';
wwv_flow_imp.g_varchar2_table(1138) := '6965772D636F6E74656E742E69732D686F766572207B0D0A2020636F6C6F723A20233236323632362021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D547265';
wwv_flow_imp.g_varchar2_table(1139) := '65566965772D636F6E74656E74207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66612C';
wwv_flow_imp.g_varchar2_table(1140) := '0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E612D49636F6E207B0D0A2020636F6C6F723A20726762612833382C2033382C2033382C20302E3935';
wwv_flow_imp.g_varchar2_table(1141) := '293B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66613A6265666F72652C0D0A2E742D526567696F6E202E612D54726565566965772D6E';
wwv_flow_imp.g_varchar2_table(1142) := '6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E612D49636F6E3A6265666F7265207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F6465';
wwv_flow_imp.g_varchar2_table(1143) := '2D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572202E66612C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E7465';
wwv_flow_imp.g_varchar2_table(1144) := '6E742E69732D63757272656E742D2D746F70202E66612C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572202E612D49636F6E2C0D';
wwv_flow_imp.g_varchar2_table(1145) := '0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E612D49636F6E207B0D0A2020636F6C6F723A20233236323632';
wwv_flow_imp.g_varchar2_table(1146) := '363B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D6C6162656C207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D526567696F6E202E612D';
wwv_flow_imp.g_varchar2_table(1147) := '54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D547265';
wwv_flow_imp.g_varchar2_table(1148) := '65566965772D636F6E74656E742E69732D73656C65637465642C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70';
wwv_flow_imp.g_varchar2_table(1149) := '207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C65207B0D0A2020636F6C6F723A20726762612833';
wwv_flow_imp.g_varchar2_table(1150) := '382C2033382C2033382C20302E3735293B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C653A686F766572207B0D0A2020636F6C6F723A2023323632';
wwv_flow_imp.g_varchar2_table(1151) := '3632362021696D706F7274616E743B0D0A7D0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772E69732D73656C65637465';
wwv_flow_imp.g_varchar2_table(1152) := '642C0D0A2E742D526567696F6E202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1153) := '2D636F6C6F723A20236637663766373B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F';
wwv_flow_imp.g_varchar2_table(1154) := '773A20302030203020317078202330303736646620696E7365743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C65';
wwv_flow_imp.g_varchar2_table(1155) := '76656C202E612D54726565566965772D726F772E69732D63757272656E742C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D73656C65637465642C0D';
wwv_flow_imp.g_varchar2_table(1156) := '0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1157) := '6F6C6F723A20233234326233313B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E61';
wwv_flow_imp.g_varchar2_table(1158) := '76202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65203E202E612D54726565566965772D726F772C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C657665';
wwv_flow_imp.g_varchar2_table(1159) := '6C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A20233165323332383B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F';
wwv_flow_imp.g_varchar2_table(1160) := '766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233262333333612021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D5472656556696577';
wwv_flow_imp.g_varchar2_table(1161) := '2D726F772E69732D686F766572202B202E612D54726565566965772D746F67676C652C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965';
wwv_flow_imp.g_varchar2_table(1162) := '772D746F67676C65207B0D0A2020636F6C6F723A2072676261283235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965';
wwv_flow_imp.g_varchar2_table(1163) := '772D726F772E69732D686F766572202B202E612D54726565566965772D746F67676C653A686F7665722C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D';
wwv_flow_imp.g_varchar2_table(1164) := '54726565566965772D746F67676C653A686F766572207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54';
wwv_flow_imp.g_varchar2_table(1165) := '726565566965772D636F6E74656E742E69732D686F766572207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E';
wwv_flow_imp.g_varchar2_table(1166) := '612D54726565566965772D636F6E74656E74207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E';
wwv_flow_imp.g_varchar2_table(1167) := '74202E66612C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E612D49636F6E207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1168) := '742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74202E66613A6265666F72652C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D74';
wwv_flow_imp.g_varchar2_table(1169) := '6F704C6576656C202E612D54726565566965772D636F6E74656E74202E612D49636F6E3A6265666F7265207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F70';
wwv_flow_imp.g_varchar2_table(1170) := '4C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572202E66612C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69';
wwv_flow_imp.g_varchar2_table(1171) := '732D63757272656E742D2D746F70202E66612C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D686F766572202E612D49636F6E2C0D0A2E74';
wwv_flow_imp.g_varchar2_table(1172) := '2D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E612D49636F6E207B0D0A2020636F6C6F723A20236666666666663B';
wwv_flow_imp.g_varchar2_table(1173) := '0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D6C6162656C207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A2E742D547265654E6176202E612D';
wwv_flow_imp.g_varchar2_table(1174) := '54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D5472';
wwv_flow_imp.g_varchar2_table(1175) := '6565566965772D636F6E74656E742E69732D73656C65637465642C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D74';
wwv_flow_imp.g_varchar2_table(1176) := '6F70207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C65207B0D0A2020636F6C6F723A20726762';
wwv_flow_imp.g_varchar2_table(1177) := '61283235352C203235352C203235352C20302E3735293B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D746F67676C653A686F766572207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(1178) := '723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D636F6E74656E7420';
wwv_flow_imp.g_varchar2_table(1179) := '2E66612C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D636F6E74656E74202E612D49636F6E207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1180) := '6666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65202E612D54726565566965772D636F6E74656E74207B0D0A2020636F6C6F723A20236666';
wwv_flow_imp.g_varchar2_table(1181) := '666666663B0D0A7D0D0A2E6A732D6E6176436F6C6C6170736564202E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C203E202E612D54726565566965772D636F6E74656E74202E612D54726565566965772D6C';
wwv_flow_imp.g_varchar2_table(1182) := '6162656C202E612D54726565566965772D6261646765207B0D0A20206261636B67726F756E643A20233133313631613B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6261646765';
wwv_flow_imp.g_varchar2_table(1183) := '207B0D0A2020626F782D736861646F773A203020302030203170782072676261283235352C203235352C203235352C20302E31293B0D0A2020666F6E742D7765696768743A203430303B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965';
wwv_flow_imp.g_varchar2_table(1184) := '772D636F6E74656E742E69732D63757272656E74202E612D54726565566965772D6C6162656C2C0D0A2E742D547265654E6176202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(1185) := '6C6162656C207B0D0A2020666F6E742D7765696768743A203530303B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C207B0D0A2020626F726465722D626F74746F6D3A2031';
wwv_flow_imp.g_varchar2_table(1186) := '707820736F6C69642072676261283235352C203235352C203235352C20302E303735293B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D72';
wwv_flow_imp.g_varchar2_table(1187) := '6F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E';
wwv_flow_imp.g_varchar2_table(1188) := '20756C202E612D54726565566965772D726F77207B0D0A2020626F782D736861646F773A20696E736574202330303736646620347078203020303B0D0A7D0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965';
wwv_flow_imp.g_varchar2_table(1189) := '772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C65';
wwv_flow_imp.g_varchar2_table(1190) := '76656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F77207B0D0A2020626F782D736861646F773A20696E7365742023303037366466202D347078203020303B0D0A7D';
wwv_flow_imp.g_varchar2_table(1191) := '0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D666F63757365642C0D0A2E742D54726565';
wwv_flow_imp.g_varchar2_table(1192) := '4E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F772E69732D666F637573';
wwv_flow_imp.g_varchar2_table(1193) := '6564207B0D0A2020626F782D736861646F773A20696E736574202330303736646620347078203020302C20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E61';
wwv_flow_imp.g_varchar2_table(1194) := '2D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D666F63757365642C0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54';
wwv_flow_imp.g_varchar2_table(1195) := '726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D73686164';
wwv_flow_imp.g_varchar2_table(1196) := '6F773A20696E7365742023303037366466202D347078203020302C20302030203020317078202330303736646620696E7365743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6261646765207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1197) := '61636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E6A732D6E6176436F6C6C6170736564202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64';
wwv_flow_imp.g_varchar2_table(1198) := '652D2D746F704C6576656C203E202E612D54726565566965772D636F6E74656E74202E612D54726565566965772D6C6162656C202E612D54726565566965772D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A2023303037366466';
wwv_flow_imp.g_varchar2_table(1199) := '3B0D0A2020636F6C6F723A20236666666666663B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1200) := '6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D';
wwv_flow_imp.g_varchar2_table(1201) := '63757272656E742D2D746F702C0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C65';
wwv_flow_imp.g_varchar2_table(1202) := '63746564207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D72';
wwv_flow_imp.g_varchar2_table(1203) := '6F772E69732D63757272656E742D2D746F702E69732D73656C6563746564202B202E612D54726565566965772D746F67676C652C0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C20';
wwv_flow_imp.g_varchar2_table(1204) := '2E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F70207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F';
wwv_flow_imp.g_varchar2_table(1205) := '704C6576656C202E612D54726565566965772D636F6E74656E742E69732D63757272656E742D2D746F702E69732D686F766572207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E61762D2D';
wwv_flow_imp.g_varchar2_table(1206) := '7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A202330';
wwv_flow_imp.g_varchar2_table(1207) := '30373965342021696D706F7274616E743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6261646765207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1208) := '20236666666666663B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D56616C69646174696F6E2D64617465207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D56616C69646174696F6E2D75736572207B0D';
wwv_flow_imp.g_varchar2_table(1209) := '0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D426F64792D616374696F6E73202E742D56616C69646174696F6E2D64617465207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E742D426F64792D616374696F6E73202E';
wwv_flow_imp.g_varchar2_table(1210) := '742D56616C69646174696F6E2D75736572207B0D0A2020636F6C6F723A20233361336133613B0D0A7D0D0A2E742D4469616C6F672D706167652D2D77697A617264207B0D0A2020626F726465723A20236536653665363B0D0A7D0D0A2E742D57697A6172';
wwv_flow_imp.g_varchar2_table(1211) := '64207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465722D636F6C6F723A20236536653665363B0D0A2020626F782D736861646F773A203020';
wwv_flow_imp.g_varchar2_table(1212) := '31707820327078207267626128302C20302C20302C20302E3035293B0D0A7D0D0A2E742D57697A617264202E742D57697A6172642D7469746C65207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D57697A617264202E742D57697A';
wwv_flow_imp.g_varchar2_table(1213) := '6172642D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A2020626F726465722D636F6C6F723A20236564656465643B0D0A7D0D0A2E742D57697A61726453746570732D777261703A6166746572207B';
wwv_flow_imp.g_varchar2_table(1214) := '0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E742D57697A61726453746570732D73746570202E742D57697A61726453746570732D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1215) := '236363636363633B0D0A7D0D0A2E742D57697A61726453746570732D737465702E69732D636F6D706C657465202E742D57697A61726453746570732D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132433B0D0A';
wwv_flow_imp.g_varchar2_table(1216) := '2020636F6C6F723A20234646463B0D0A7D0D0A2E742D57697A61726453746570732D737465702E69732D616374697665202E742D57697A61726453746570732D6D61726B6572207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664';
wwv_flow_imp.g_varchar2_table(1217) := '663B0D0A7D0D0A2E742D57697A61726453746570732D6C6162656C207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A612E742D57697A61726453746570732D777261705B687265665D3A686F766572202E742D57697A6172645374657073';
wwv_flow_imp.g_varchar2_table(1218) := '2D6C6162656C2C0D0A612E742D57697A61726453746570732D777261705B687265665D3A666F637573202E742D57697A61726453746570732D6C6162656C207B0D0A2020636F6C6F723A20233030366564303B0D0A2020746578742D6465636F72617469';
wwv_flow_imp.g_varchar2_table(1219) := '6F6E3A20756E6465726C696E653B0D0A7D0D0A612E742D57697A61726453746570732D777261705B687265665D3A666F637573202E742D57697A61726453746570732D6D61726B6572207B0D0A2020626F782D736861646F773A20302030203020317078';
wwv_flow_imp.g_varchar2_table(1220) := '20236666666666662C2030203020302032707820233030373664662C203020302031707820327078207267626128302C203131382C203232332C20302E3235293B0D0A7D0D0A626F6479202E75692D7769646765742D6F7665726C6179207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1221) := '61636B67726F756E643A206E6F6E65207267626128302C20302C20302C20302E3235293B0D0A20206F7061636974793A20313B0D0A7D0D0A2E75692D776964676574207B0D0A2020666F6E742D66616D696C793A202748656C766574696361204E657565';
wwv_flow_imp.g_varchar2_table(1222) := '272C20275365676F65205549272C2048656C7665746963612C20417269616C2C2073616E732D73657269663B0D0A2020666F6E742D73697A653A20313270783B0D0A7D0D0A2E75692D776964676574202E75692D776964676574207B0D0A2020666F6E74';
wwv_flow_imp.g_varchar2_table(1223) := '2D73697A653A20313270783B0D0A7D0D0A626F6479202E75692D7769646765742D636F6E74656E742C0D0A626F6479202E75692D7769646765742E75692D7769646765742D636F6E74656E74207B0D0A2020626F726465722D636F6C6F723A2023656265';
wwv_flow_imp.g_varchar2_table(1224) := '6265623B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D7769646765742D636F6E74656E742061207B0D0A2020636F6C6F723A2023303036';
wwv_flow_imp.g_varchar2_table(1225) := '6564303B0D0A7D0D0A626F6479202E75692D7769646765742D686561646572207B0D0A2020626F726465722D636F6C6F723A20236562656265623B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1226) := '233236323632363B0D0A7D0D0A626F6479202E75692D7769646765742D6865616465722061207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D73746174652D64656661756C742C0D0A626F6479202E75692D776964';
wwv_flow_imp.g_varchar2_table(1227) := '6765742D636F6E74656E74202E75692D73746174652D64656661756C742C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D64656661756C74207B0D0A20206261636B67726F756E642D636F6C6F723A2023663866';
wwv_flow_imp.g_varchar2_table(1228) := '3866383B0D0A2020636F6C6F723A20233338333833383B0D0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E303132352920696E7365743B0D0A7D0D0A626F6479202E75692D73746174652D646566';
wwv_flow_imp.g_varchar2_table(1229) := '61756C7420612C0D0A626F6479202E75692D73746174652D64656661756C7420613A6C696E6B2C0D0A626F6479202E75692D73746174652D64656661756C7420613A766973697465642C0D0A626F6479202E75692D73746174652D61637469766520612C';
wwv_flow_imp.g_varchar2_table(1230) := '0D0A626F6479202E75692D73746174652D61637469766520613A6C696E6B2C0D0A626F6479202E75692D73746174652D61637469766520613A76697369746564207B0D0A2020636F6C6F723A20233030366564303B0D0A7D0D0A626F6479202E75692D73';
wwv_flow_imp.g_varchar2_table(1231) := '746174652D6163746976652C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6163746976652C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D616374697665207B0D0A';
wwv_flow_imp.g_varchar2_table(1232) := '2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E322920696E7365742C20302031707820327078207267626128302C20302C20302C20302E32352920696E7365743B0D0A7D0D0A626F6479202E75692D';
wwv_flow_imp.g_varchar2_table(1233) := '73746174652D686F7665722C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D686F7665722C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D686F766572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1234) := '6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233338333833383B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20302E3035292C203020302030203170';
wwv_flow_imp.g_varchar2_table(1235) := '78207267626128302C20302C20302C20302E303132352920696E7365743B0D0A7D0D0A626F6479202E75692D73746174652D666F6375732C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D666F6375732C0D0A';
wwv_flow_imp.g_varchar2_table(1236) := '626F6479202E75692D7769646765742D686561646572202E75692D73746174652D666F637573207B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C203020302031707820327078207267626128302C';
wwv_flow_imp.g_varchar2_table(1237) := '203131382C203232332C20302E3235292021696D706F7274616E743B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A2020636F6C6F723A20233338333833383B0D0A7D0D0A626F6479202E75692D646174657069636B65';
wwv_flow_imp.g_varchar2_table(1238) := '72202E75692D646174657069636B65722D627574746F6E70616E6520627574746F6E3A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C';
wwv_flow_imp.g_varchar2_table(1239) := '203020302031707820327078207267626128302C203131382C203232332C20302E3235292021696D706F7274616E743B0D0A7D0D0A626F6479202E75692D73746174652D686F76657220612C0D0A626F6479202E75692D73746174652D686F7665722061';
wwv_flow_imp.g_varchar2_table(1240) := '3A686F7665722C0D0A626F6479202E75692D73746174652D686F76657220613A6C696E6B2C0D0A626F6479202E75692D73746174652D686F76657220613A766973697465642C0D0A626F6479202E75692D73746174652D666F63757320612C0D0A626F64';
wwv_flow_imp.g_varchar2_table(1241) := '79202E75692D73746174652D666F63757320613A686F7665722C0D0A626F6479202E75692D73746174652D666F63757320613A6C696E6B2C0D0A626F6479202E75692D73746174652D666F63757320613A76697369746564207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1242) := '20233030366564303B0D0A7D0D0A626F6479202E75692D73746174652D6163746976652C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6163746976652C0D0A626F6479202E75692D7769646765742D686561';
wwv_flow_imp.g_varchar2_table(1243) := '646572202E75692D73746174652D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236465646564653B0D0A2020636F6C6F723A20233338333833383B0D0A7D0D0A626F6479202E75692D73746174652D686967686C69676874';
wwv_flow_imp.g_varchar2_table(1244) := '2C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D686967686C696768742C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D686967686C69676874207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(1245) := '6B67726F756E642D636F6C6F723A20236466663066663B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D73746174652D686967686C6967687420612C0D0A626F6479202E75692D7769646765742D636F6E74656E7420';
wwv_flow_imp.g_varchar2_table(1246) := '2E75692D73746174652D686967686C6967687420612C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D686967686C696768742061207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E';
wwv_flow_imp.g_varchar2_table(1247) := '75692D73746174652D6572726F722C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6572726F722C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D6572726F72207B0D';
wwv_flow_imp.g_varchar2_table(1248) := '0A20206261636B67726F756E642D636F6C6F723A20236634343333363B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D73746174652D6572726F7220612C0D0A626F6479202E75692D7769646765742D636F6E74656E';
wwv_flow_imp.g_varchar2_table(1249) := '74202E75692D73746174652D6572726F7220612C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D6572726F722061207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D737461';
wwv_flow_imp.g_varchar2_table(1250) := '74652D6572726F722D746578742C0D0A626F6479202E75692D7769646765742D636F6E74656E74202E75692D73746174652D6572726F722D746578742C0D0A626F6479202E75692D7769646765742D686561646572202E75692D73746174652D6572726F';
wwv_flow_imp.g_varchar2_table(1251) := '722D74657874207B0D0A2020636F6C6F723A20236634343333363B0D0A7D0D0A626F6479202E75692D646174657069636B6572207B0D0A2020626F782D736861646F773A20302032707820367078207267626128302C20302C20302C20302E3035293B0D';
wwv_flow_imp.g_varchar2_table(1252) := '0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C74207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1253) := '636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742E75692D';
wwv_flow_imp.g_varchar2_table(1254) := '73746174652D6163746976652C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A2023303037';
wwv_flow_imp.g_varchar2_table(1255) := '3664663B0D0A2020636F6C6F723A20236666666666663B0D0A2020666F6E742D7765696768743A20626F6C643B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742E75692D7374';
wwv_flow_imp.g_varchar2_table(1256) := '6174652D6163746976652E75692D73746174652D686F7665722C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D6163746976652E75692D73746174652D686F766572';
wwv_flow_imp.g_varchar2_table(1257) := '207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D7374';
wwv_flow_imp.g_varchar2_table(1258) := '6174652D64656661756C742E75692D73746174652D686F7665722C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D686F766572207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1259) := '642D636F6C6F723A20236632663266322021696D706F7274616E743B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C743A666F6375732C0D0A626F6479202E75692D6461746570';
wwv_flow_imp.g_varchar2_table(1260) := '69636B657220746420612E75692D73746174652D64656661756C743A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F782D736861646F773A20302030203020317078202330303736646620696E7365742C20302030203170';
wwv_flow_imp.g_varchar2_table(1261) := '7820327078207267626128302C203131382C203232332C20302E3235292021696D706F7274616E743B0D0A7D0D0A626F6479202E75692D646174657069636B6572207464207370616E2E75692D73746174652D64656661756C742E75692D73746174652D';
wwv_flow_imp.g_varchar2_table(1262) := '686967686C696768742C0D0A626F6479202E75692D646174657069636B657220746420612E75692D73746174652D64656661756C742E75692D73746174652D686967686C69676874207B0D0A20206261636B67726F756E642D636F6C6F723A2023656265';
wwv_flow_imp.g_varchar2_table(1263) := '6265623B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D646174657069636B6572207468207B0D0A2020636F6C6F723A20233636363636363B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A2072676261';
wwv_flow_imp.g_varchar2_table(1264) := '28302C20302C20302C20302E31293B0D0A7D0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D6865616465722C0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D62';
wwv_flow_imp.g_varchar2_table(1265) := '7574746F6E70616E6520627574746F6E2C0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D6E6578742C0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D70726576';
wwv_flow_imp.g_varchar2_table(1266) := '207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D646174657069636B6572202E75692D646174657069636B65722D707265763A6163746976652C0D0A626F6479202E75692D646174657069636B6572202E';
wwv_flow_imp.g_varchar2_table(1267) := '75692D646174657069636B65722D6E6578743A616374697665207B0D0A2020626F782D736861646F773A20302032707820317078207267626128302C20302C20302C20302E30352920696E7365742C20302030203020317078207267626128302C20302C';
wwv_flow_imp.g_varchar2_table(1268) := '20302C20302E303132352920696E7365743B0D0A7D0D0A2E75692D6469616C6F67207B0D0A2020626F782D736861646F773A2030203470782031367078202D347078207267626128302C20302C20302C20302E32292C2030203870782032347078203020';
wwv_flow_imp.g_varchar2_table(1269) := '7267626128302C20302C20302C20302E3135292C20302030203020317078207267626128302C20302C20302C20302E32293B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D7469746C65626172207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1270) := '67726F756E642D636F6C6F723A20236666666666663B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C6964207267626128302C20302C20302C20302E3035293B0D0A7D0D0A626F6479202E75692D6469616C6F672E742D4469616C6F67';
wwv_flow_imp.g_varchar2_table(1271) := '2D706167652D2D77697A617264202E75692D6469616C6F672D7469746C65626172207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D746974';
wwv_flow_imp.g_varchar2_table(1272) := '6C65207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D636F6E74656E742C0D0A2E742D4469616C6F672D70616765207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1273) := '723A20236666666666663B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D4469616C6F672D2D77697A6172642E75692D6469616C6F672C0D0A2E742D4469616C6F672D2D77697A6172642E75692D6469616C6F67202E75692D646961';
wwv_flow_imp.g_varchar2_table(1274) := '6C6F672D7469746C656261722C0D0A2E742D4469616C6F672D2D77697A61726420626F6479202E75692D6469616C6F67202E75692D6469616C6F672D636F6E74656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D';
wwv_flow_imp.g_varchar2_table(1275) := '0A2020636F6C6F723A20233236323632363B0D0A7D0D0A2E742D4469616C6F672D2D77697A6172642E75692D6469616C6F67202E75692D6469616C6F672D7469746C65207B0D0A2020636F6C6F723A20233236323632363B0D0A7D0D0A626F6479202E75';
wwv_flow_imp.g_varchar2_table(1276) := '692D636F726E65722D616C6C207B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D746F702C0D0A626F6479202E75692D636F726E65722D6C6566742C0D0A626F6479202E75692D636F726E';
wwv_flow_imp.g_varchar2_table(1277) := '65722D746C207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D746F702C0D0A626F6479202E75692D636F726E65722D72696768742C0D0A626F6479202E75692D63';
wwv_flow_imp.g_varchar2_table(1278) := '6F726E65722D7472207B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D636F726E65722D6C6566742C0D0A626F6479';
wwv_flow_imp.g_varchar2_table(1279) := '202E75692D636F726E65722D626C207B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D636F726E65722D726967';
wwv_flow_imp.g_varchar2_table(1280) := '68742C0D0A626F6479202E75692D636F726E65722D6272207B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D616C6C207B0D0A20';
wwv_flow_imp.g_varchar2_table(1281) := '20626F726465722D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D746F702C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D6C6566742C0D0A626F6479202E75692D62';
wwv_flow_imp.g_varchar2_table(1282) := '7574746F6E2E75692D636F726E65722D746C207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D746F702C0D0A626F6479202E75692D6275';
wwv_flow_imp.g_varchar2_table(1283) := '74746F6E2E75692D636F726E65722D72696768742C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D7472207B0D0A2020626F726465722D746F702D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D';
wwv_flow_imp.g_varchar2_table(1284) := '627574746F6E2E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D6C6566742C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D626C207B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(1285) := '626F74746F6D2D6C6566742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D626F74746F6D2C0D0A626F6479202E75692D627574746F6E2E75692D636F726E65722D72696768742C0D0A626F';
wwv_flow_imp.g_varchar2_table(1286) := '6479202E75692D627574746F6E2E75692D636F726E65722D6272207B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A203270783B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D7469746C';
wwv_flow_imp.g_varchar2_table(1287) := '656261722D636C6F7365207B0D0A2020626F726465722D7261646975733A20313030253B0D0A7D0D0A626F6479202E75692D6469616C6F67202E75692D6469616C6F672D627574746F6E70616E65207B0D0A2020626F726465722D746F702D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1288) := '3A20236562656265623B0D0A7D0D0A2E752D7761726E696E67207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E752D7761726E69';
wwv_flow_imp.g_varchar2_table(1289) := '6E672D74657874207B0D0A2020636F6C6F723A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D7761726E696E672D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(1290) := '0D0A7D0D0A2E752D7761726E696E672D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D73756363657373207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1291) := '233342414132432021696D706F7274616E743B0D0A2020636F6C6F723A20234646463B0D0A7D0D0A2E752D737563636573732D74657874207B0D0A2020636F6C6F723A20233342414132432021696D706F7274616E743B0D0A7D0D0A2E752D7375636365';
wwv_flow_imp.g_varchar2_table(1292) := '73732D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20233342414132432021696D706F7274616E743B0D0A7D0D0A2E752D737563636573732D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023334241413243202169';
wwv_flow_imp.g_varchar2_table(1293) := '6D706F7274616E743B0D0A7D0D0A2E752D64616E676572207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333362021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D64616E6765722D';
wwv_flow_imp.g_varchar2_table(1294) := '74657874207B0D0A2020636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D0A2E752D64616E6765722D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1295) := '0A2E752D64616E6765722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236634343333362021696D706F7274616E743B0D0A7D0D0A2E752D696E666F207B0D0A20206261636B67726F756E642D636F6C6F723A202330303736646620';
wwv_flow_imp.g_varchar2_table(1296) := '21696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D696E666F2D74657874207B0D0A2020636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D696E666F2D6267207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1297) := '6261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D696E666F2D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1298) := '2E752D686F74207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D686F742D74657874207B0D0A2020636F6C6F723A20233030';
wwv_flow_imp.g_varchar2_table(1299) := '373664662021696D706F7274616E743B0D0A7D0D0A2E752D686F742D6267207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D686F742D626F72646572207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(1300) := '6465722D636F6C6F723A20233030373664662021696D706F7274616E743B0D0A7D0D0A2E752D6E6F726D616C207B0D0A20206261636B67726F756E642D636F6C6F723A20234644464446442021696D706F7274616E743B0D0A2020636F6C6F723A202332';
wwv_flow_imp.g_varchar2_table(1301) := '34323432343B0D0A7D0D0A2E752D6E6F726D616C2D74657874207B0D0A2020636F6C6F723A20233234323432342021696D706F7274616E743B0D0A7D0D0A2E752D6E6F726D616C2D6267207B0D0A20206261636B67726F756E642D636F6C6F723A202332';
wwv_flow_imp.g_varchar2_table(1302) := '34323432342021696D706F7274616E743B0D0A7D0D0A2E752D6E6F726D616C2D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233234323432342021696D706F7274616E743B0D0A7D0D0A2E742D426F6479207B0D0A20200D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1303) := '2E742D426F6479202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420236534653465343B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A202346444644';
wwv_flow_imp.g_varchar2_table(1304) := '46443B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20233234323432343B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1305) := '3765376537653B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D646179207B0D0A2020626F726465722D636F6C6F723A20236637663766373B0D0A2020636F6C6F723A20233365336533653B0D0A7D0D0A2E742D426F6479202E612D4D696E';
wwv_flow_imp.g_varchar2_table(1306) := '6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F6479202E612D';
wwv_flow_imp.g_varchar2_table(1307) := '4D696E6943616C2D6461792E69732D616374697665202E612D4D696E6943616C2D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D426F6479';
wwv_flow_imp.g_varchar2_table(1308) := '202E612D4D696E6943616C2D6461792E69732D7765656B656E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236638663866383B0D0A7D0D0A2E742D426F6479202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1309) := '61636B67726F756E642D636F6C6F723A20236633663366333B0D0A7D0D0A2E742D526567696F6E207B0D0A20200D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420236536653665';
wwv_flow_imp.g_varchar2_table(1310) := '363B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1311) := '3236323632363B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20233830383038303B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D646179207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1312) := '726465722D636F6C6F723A20236639663966393B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1313) := '61636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D616374697665202E612D4D696E6943616C2D6461746520';
wwv_flow_imp.g_varchar2_table(1314) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D7765656B656E64207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1315) := '67726F756E642D636F6C6F723A20236661666166613B0D0A7D0D0A2E742D526567696F6E202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A20236635663566353B0D0A7D0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(1316) := '6F64792D616374696F6E73207B0D0A20200D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420236530653065303B0D0A2020626F726465722D7261646975733A2032';
wwv_flow_imp.g_varchar2_table(1317) := '70783B0D0A20206261636B67726F756E642D636F6C6F723A20236639663966393B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20233230323032303B0D0A7D0D0A2E742D42';
wwv_flow_imp.g_varchar2_table(1318) := '6F64792D616374696F6E73202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20233761376137613B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D646179207B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(1319) := '2D636F6C6F723A20236633663366333B0D0A2020636F6C6F723A20233361336133613B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D0A20';
wwv_flow_imp.g_varchar2_table(1320) := '206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D616374697665202E612D4D696E6943';
wwv_flow_imp.g_varchar2_table(1321) := '616C2D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D776565';
wwv_flow_imp.g_varchar2_table(1322) := '6B656E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236634663466343B0D0A7D0D0A2E742D426F64792D616374696F6E73202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1323) := '723A20236566656665663B0D0A7D0D0A2E742D426F64792D696E666F207B0D0A20200D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C207B0D0A2020626F726465723A2031707820736F6C696420236536653665363B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1324) := '726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D7469746C65207B0D0A2020636F6C6F723A20233236323632';
wwv_flow_imp.g_varchar2_table(1325) := '363B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461794F665765656B207B0D0A2020636F6C6F723A20233830383038303B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D646179207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1326) := '6F726465722D636F6C6F723A20236639663966393B0D0A2020636F6C6F723A20233430343034303B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D746F646179202E612D4D696E6943616C2D64617465207B0D';
wwv_flow_imp.g_varchar2_table(1327) := '0A20206261636B67726F756E642D636F6C6F723A20233030373664663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D616374697665202E612D4D696E694361';
wwv_flow_imp.g_varchar2_table(1328) := '6C2D64617465207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D7765656B656E64';
wwv_flow_imp.g_varchar2_table(1329) := '207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A7D0D0A2E742D426F64792D696E666F202E612D4D696E6943616C2D6461792E69732D6E756C6C207B0D0A20206261636B67726F756E642D636F6C6F723A2023663566';
wwv_flow_imp.g_varchar2_table(1330) := '3566353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644423B0D0A202066696C6C3A20233330394644423B0D';
wwv_flow_imp.g_varchar2_table(1331) := '0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129';
wwv_flow_imp.g_varchar2_table(1332) := '202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D7478';
wwv_flow_imp.g_varchar2_table(1333) := '742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233330394644423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64283435';
wwv_flow_imp.g_varchar2_table(1334) := '6E202B203129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233330394644423B0D0A2020';
wwv_flow_imp.g_varchar2_table(1335) := '7374726F6B653A20233330394644423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643463B0D0A202066696C';
wwv_flow_imp.g_varchar2_table(1336) := '6C3A20233133423643463B0D0A2020636F6C6F723A20236534663966643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1337) := '696C642834356E202B203229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229';
wwv_flow_imp.g_varchar2_table(1338) := '202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233133423643463B0D0A7D0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1339) := '6E74682D6368696C642834356E202B203229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203229202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1340) := '233133423643463B0D0A20207374726F6B653A20233133423643463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233245';
wwv_flow_imp.g_varchar2_table(1341) := '424642433B0D0A202066696C6C3A20233245424642433B0D0A2020636F6C6F723A20236630666366623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D62672C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1342) := '7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642433B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1343) := '696C642834356E202B203329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233245424642433B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(1344) := '752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203329202E752D636F6C6F722D626F72646572207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1345) := '726465722D636F6C6F723A20233245424642433B0D0A20207374726F6B653A20233245424642433B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F72207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1346) := '642D636F6C6F723A20233343414638353B0D0A202066696C6C3A20233343414638353B0D0A2020636F6C6F723A20236630666166363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1347) := '62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638353B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1348) := '7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A202333';
wwv_flow_imp.g_varchar2_table(1349) := '43414638353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203429202E752D636F6C6F722D626F';
wwv_flow_imp.g_varchar2_table(1350) := '72646572207B0D0A2020626F726465722D636F6C6F723A20233343414638353B0D0A20207374726F6B653A20233343414638353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F72207B0D';
wwv_flow_imp.g_varchar2_table(1351) := '0A20206261636B67726F756E642D636F6C6F723A20233831424235463B0D0A202066696C6C3A20233831424235463B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1352) := '3529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233831424235463B';
wwv_flow_imp.g_varchar2_table(1353) := '0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D74657874207B0D';
wwv_flow_imp.g_varchar2_table(1354) := '0A2020636F6C6F723A20233831424235463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203529';
wwv_flow_imp.g_varchar2_table(1355) := '202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233831424235463B0D0A20207374726F6B653A20233831424235463B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629';
wwv_flow_imp.g_varchar2_table(1356) := '202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234444444535333B0D0A202066696C6C3A20234444444535333B0D0A2020636F6C6F723A20233261326130383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1357) := '6368696C642834356E202B203629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(1358) := '6F723A20234444444535333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D63';
wwv_flow_imp.g_varchar2_table(1359) := '6F6C6F722D74657874207B0D0A2020636F6C6F723A20234444444535333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1360) := '696C642834356E202B203629202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234444444535333B0D0A20207374726F6B653A20234444444535333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1361) := '696C642834356E202B203729202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534413B0D0A202066696C6C3A20234642434534413B0D0A2020636F6C6F723A20233434333330323B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1362) := '6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1363) := '636B67726F756E642D636F6C6F723A20234642434534413B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1364) := '356E202B203729202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234642434534413B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1365) := '7273203E203A6E74682D6368696C642834356E202B203729202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234642434534413B0D0A20207374726F6B653A20234642434534413B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1366) := '7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133453B0D0A202066696C6C3A20234544383133453B0D0A2020636F6C6F723A20236666666666';
wwv_flow_imp.g_varchar2_table(1367) := '663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D6261636B6772';
wwv_flow_imp.g_varchar2_table(1368) := '6F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133453B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1369) := '3A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234544383133453B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1370) := '62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203829202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234544383133453B0D0A20207374726F6B653A20234544383133453B';
wwv_flow_imp.g_varchar2_table(1371) := '0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235343B0D0A202066696C6C3A20234539354235343B0D0A202063';
wwv_flow_imp.g_varchar2_table(1372) := '6F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D';
wwv_flow_imp.g_varchar2_table(1373) := '636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D7478742C0D0A';
wwv_flow_imp.g_varchar2_table(1374) := '2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234539354235343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20';
wwv_flow_imp.g_varchar2_table(1375) := '3929202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234539354235343B0D0A20207374726F';
wwv_flow_imp.g_varchar2_table(1376) := '6B653A20234539354235343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438383B0D0A202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(1377) := '234538354438383B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C';
wwv_flow_imp.g_varchar2_table(1378) := '642834356E202B20313029202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029';
wwv_flow_imp.g_varchar2_table(1379) := '202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234538354438383B0D0A7D0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1380) := '3A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(1381) := '723A20234538354438383B0D0A20207374726F6B653A20234538354438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1382) := '20234341353839443B0D0A202066696C6C3A20234341353839443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D62672C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1383) := '2D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839443B0D0A7D0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1384) := '6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234341353839';
wwv_flow_imp.g_varchar2_table(1385) := '443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313129202E752D636F6C6F722D626F7264';
wwv_flow_imp.g_varchar2_table(1386) := '6572207B0D0A2020626F726465722D636F6C6F723A20234341353839443B0D0A20207374726F6B653A20234341353839443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F72207B0D0A';
wwv_flow_imp.g_varchar2_table(1387) := '20206261636B67726F756E642D636F6C6F723A20233835344539423B0D0A202066696C6C3A20233835344539423B0D0A2020636F6C6F723A20236636663066383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2031';
wwv_flow_imp.g_varchar2_table(1388) := '3229202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A2023383534453942';
wwv_flow_imp.g_varchar2_table(1389) := '3B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D74657874';
wwv_flow_imp.g_varchar2_table(1390) := '207B0D0A2020636F6C6F723A20233835344539423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E20';
wwv_flow_imp.g_varchar2_table(1391) := '2B20313229202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233835344539423B0D0A20207374726F6B653A20233835344539423B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E';
wwv_flow_imp.g_varchar2_table(1392) := '202B20313329202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233541363841443B0D0A202066696C6C3A20233541363841443B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E';
wwv_flow_imp.g_varchar2_table(1393) := '203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(1394) := '6F756E642D636F6C6F723A20233541363841443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E20';
wwv_flow_imp.g_varchar2_table(1395) := '2B20313329202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233541363841443B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1396) := '73203E203A6E74682D6368696C642834356E202B20313329202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233541363841443B0D0A20207374726F6B653A20233541363841443B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1397) := '7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20234146424143353B0D0A202066696C6C3A20234146424143353B0D0A2020636F6C6F723A202333313361';
wwv_flow_imp.g_varchar2_table(1398) := '34343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D626163';
wwv_flow_imp.g_varchar2_table(1399) := '6B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234146424143353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1400) := '73203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20234146424143353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D';
wwv_flow_imp.g_varchar2_table(1401) := '636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234146424143353B0D0A20207374726F6B653A2023';
wwv_flow_imp.g_varchar2_table(1402) := '4146424143353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539383B0D0A202066696C6C3A202336453835';
wwv_flow_imp.g_varchar2_table(1403) := '39383B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E';
wwv_flow_imp.g_varchar2_table(1404) := '202B20313529202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D63';
wwv_flow_imp.g_varchar2_table(1405) := '6F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233645383539383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1406) := '6368696C642834356E202B20313529202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A202336';
wwv_flow_imp.g_varchar2_table(1407) := '45383539383B0D0A20207374726F6B653A20233645383539383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A2023353962';
wwv_flow_imp.g_varchar2_table(1408) := '3265323B0D0A202066696C6C3A20233539623265323B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1409) := '7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233539623265323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(1410) := '68696C642834356E202B20313629202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233539623265323B0D0A7D';
wwv_flow_imp.g_varchar2_table(1411) := '0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313629202E752D636F6C6F722D626F72646572207B0D';
wwv_flow_imp.g_varchar2_table(1412) := '0A2020626F726465722D636F6C6F723A20233539623265323B0D0A20207374726F6B653A20233539623265323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F72207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(1413) := '6B67726F756E642D636F6C6F723A20233432633564393B0D0A202066696C6C3A20233432633564393B0D0A2020636F6C6F723A20233035313531373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E75';
wwv_flow_imp.g_varchar2_table(1414) := '2D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233432633564393B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1415) := '0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D74657874207B0D0A20';
wwv_flow_imp.g_varchar2_table(1416) := '20636F6C6F723A20233432633564393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313729';
wwv_flow_imp.g_varchar2_table(1417) := '202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233432633564393B0D0A20207374726F6B653A20233432633564393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203138';
wwv_flow_imp.g_varchar2_table(1418) := '29202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233538636363393B0D0A202066696C6C3A20233538636363393B0D0A2020636F6C6F723A20233039316331633B0D0A7D0D0A2E752D636F6C6F7273203E203A6E7468';
wwv_flow_imp.g_varchar2_table(1419) := '2D6368696C642834356E202B20313829202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1420) := '636F6C6F723A20233538636363393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829';
wwv_flow_imp.g_varchar2_table(1421) := '202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233538636363393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1422) := '6E74682D6368696C642834356E202B20313829202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233538636363393B0D0A20207374726F6B653A20233538636363393B0D0A7D0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1423) := '3A6E74682D6368696C642834356E202B20313929202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639643B0D0A202066696C6C3A20233633626639643B0D0A2020636F6C6F723A20236666666666663B0D0A';
wwv_flow_imp.g_varchar2_table(1424) := '7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(1425) := '6E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1426) := '6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233633626639643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1427) := '2D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20313929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233633626639643B0D0A20207374726F6B653A20233633626639';
wwv_flow_imp.g_varchar2_table(1428) := '643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233961633937663B0D0A202066696C6C3A20233961633937663B0D0A';
wwv_flow_imp.g_varchar2_table(1429) := '2020636F6C6F723A20233230333331363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203230';
wwv_flow_imp.g_varchar2_table(1430) := '29202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233961633937663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1431) := '7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233961633937663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64';
wwv_flow_imp.g_varchar2_table(1432) := '2834356E202B20323029202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023396163393766';
wwv_flow_imp.g_varchar2_table(1433) := '3B0D0A20207374726F6B653A20233961633937663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236534653537353B0D';
wwv_flow_imp.g_varchar2_table(1434) := '0A202066696C6C3A20236534653537353B0D0A2020636F6C6F723A20233463346330663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1435) := '3A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236534653537353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C6428';
wwv_flow_imp.g_varchar2_table(1436) := '34356E202B20323129202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236534653537353B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1437) := '636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323129202E752D636F6C6F722D626F72646572207B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(1438) := '726465722D636F6C6F723A20236534653537353B0D0A20207374726F6B653A20236534653537353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F72207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(1439) := '6E642D636F6C6F723A20236663643836653B0D0A202066696C6C3A20236663643836653B0D0A2020636F6C6F723A20233639346630323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1440) := '722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236663643836653B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1441) := '6F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(1442) := '723A20236663643836653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323229202E752D63';
wwv_flow_imp.g_varchar2_table(1443) := '6F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236663643836653B0D0A20207374726F6B653A20236663643836653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D';
wwv_flow_imp.g_varchar2_table(1444) := '636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236631396136353B0D0A202066696C6C3A20236631396136353B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C';
wwv_flow_imp.g_varchar2_table(1445) := '642834356E202B20323329202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1446) := '3A20236631396136353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D63';
wwv_flow_imp.g_varchar2_table(1447) := '6F6C6F722D74657874207B0D0A2020636F6C6F723A20236631396136353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(1448) := '68696C642834356E202B20323329202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236631396136353B0D0A20207374726F6B653A20236631396136353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1449) := '6368696C642834356E202B20323429202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376337363B0D0A202066696C6C3A20236564376337363B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(1450) := '2D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D6261636B67726F756E64207B0D';
wwv_flow_imp.g_varchar2_table(1451) := '0A20206261636B67726F756E642D636F6C6F723A20236564376337363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(1452) := '68696C642834356E202B20323429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236564376337363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D62642C0D';
wwv_flow_imp.g_varchar2_table(1453) := '0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376337363B0D0A20207374726F6B653A20236564376337363B0D0A7D';
wwv_flow_imp.g_varchar2_table(1454) := '0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461303B0D0A202066696C6C3A20236564376461303B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(1455) := '6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D';
wwv_flow_imp.g_varchar2_table(1456) := '636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D7478742C0D';
wwv_flow_imp.g_varchar2_table(1457) := '0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236564376461303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E20';
wwv_flow_imp.g_varchar2_table(1458) := '2B20323529202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376461303B0D0A2020';
wwv_flow_imp.g_varchar2_table(1459) := '7374726F6B653A20236564376461303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962313B0D0A20206669';
wwv_flow_imp.g_varchar2_table(1460) := '6C6C3A20236435373962313B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1461) := '6368696C642834356E202B20323629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B';
wwv_flow_imp.g_varchar2_table(1462) := '20323629202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236435373962313B0D0A7D0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1463) := '73203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323629202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(1464) := '636F6C6F723A20236435373962313B0D0A20207374726F6B653A20236435373962313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(1465) := '6C6F723A20233964373161663B0D0A202066696C6C3A20233964373161663B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D62672C';
wwv_flow_imp.g_varchar2_table(1466) := '0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233964373161663B0D0A7D0D0A2E752D636F6C6F7273';
wwv_flow_imp.g_varchar2_table(1467) := '203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A202339';
wwv_flow_imp.g_varchar2_table(1468) := '64373161663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323729202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1469) := '626F72646572207B0D0A2020626F726465722D636F6C6F723A20233964373161663B0D0A20207374726F6B653A20233964373161663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1470) := '207B0D0A20206261636B67726F756E642D636F6C6F723A20233762383662643B0D0A202066696C6C3A20233762383662643B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E';
wwv_flow_imp.g_varchar2_table(1471) := '202B20323829202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233762';
wwv_flow_imp.g_varchar2_table(1472) := '383662643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1473) := '74657874207B0D0A2020636F6C6F723A20233762383662643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C6428';
wwv_flow_imp.g_varchar2_table(1474) := '34356E202B20323829202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233762383662643B0D0A20207374726F6B653A20233762383662643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64';
wwv_flow_imp.g_varchar2_table(1475) := '2834356E202B20323929202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236266633864313B0D0A202066696C6C3A20236266633864313B0D0A2020636F6C6F723A20233364343835343B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1476) := '7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(1477) := '636B67726F756E642D636F6C6F723A20236266633864313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C6428';
wwv_flow_imp.g_varchar2_table(1478) := '34356E202B20323929202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236266633864313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D62642C0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1479) := '6F6C6F7273203E203A6E74682D6368696C642834356E202B20323929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236266633864313B0D0A20207374726F6B653A20236266633864313B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1480) := '636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233862396461643B0D0A202066696C6C3A20233862396461643B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1481) := '6666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1482) := '2D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233862396461643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D7478742C0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1483) := '6F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233862396461643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029';
wwv_flow_imp.g_varchar2_table(1484) := '202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233862396461643B0D0A20207374726F6B';
wwv_flow_imp.g_varchar2_table(1485) := '653A20233862396461643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363613B0D0A202066696C6C3A2023';
wwv_flow_imp.g_varchar2_table(1486) := '3139386363613B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64';
wwv_flow_imp.g_varchar2_table(1487) := '2834356E202B20333129202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363613B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2033312920';
wwv_flow_imp.g_varchar2_table(1488) := '2E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233139386363613B0D0A7D0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1489) := '6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1490) := '3A20233139386363613B0D0A20207374726F6B653A20233139386363613B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1491) := '233032613562653B0D0A202066696C6C3A20233032613562653B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D62672C0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1492) := '636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E';
wwv_flow_imp.g_varchar2_table(1493) := '74682D6368696C642834356E202B20333229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A2023303261356265';
wwv_flow_imp.g_varchar2_table(1494) := '3B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333229202E752D636F6C6F722D626F726465';
wwv_flow_imp.g_varchar2_table(1495) := '72207B0D0A2020626F726465722D636F6C6F723A20233032613562653B0D0A20207374726F6B653A20233032613562653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F72207B0D0A20';
wwv_flow_imp.g_varchar2_table(1496) := '206261636B67726F756E642D636F6C6F723A20233138623161653B0D0A202066696C6C3A20233138623161653B0D0A2020636F6C6F723A20233030303030303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B203333';
wwv_flow_imp.g_varchar2_table(1497) := '29202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233138623161653B';
wwv_flow_imp.g_varchar2_table(1498) := '0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D7465787420';
wwv_flow_imp.g_varchar2_table(1499) := '7B0D0A2020636F6C6F723A20233138623161653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B';
wwv_flow_imp.g_varchar2_table(1500) := '20333329202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233138623161653B0D0A20207374726F6B653A20233138623161653B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E20';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '2B20333429202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233234613437353B0D0A202066696C6C3A20233234613437353B0D0A2020636F6C6F723A20236566666266373B0D0A7D0D0A2E752D636F6C6F7273203E20';
wwv_flow_imp.g_varchar2_table(1502) := '3A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(1503) := '756E642D636F6C6F723A20233234613437353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B';
wwv_flow_imp.g_varchar2_table(1504) := '20333429202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233234613437353B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273';
wwv_flow_imp.g_varchar2_table(1505) := '203E203A6E74682D6368696C642834356E202B20333429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233234613437353B0D0A20207374726F6B653A20233234613437353B0D0A7D0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1506) := '73203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233661616434323B0D0A202066696C6C3A20233661616434323B0D0A2020636F6C6F723A20233063313530';
wwv_flow_imp.g_varchar2_table(1507) := '363B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D6261636B';
wwv_flow_imp.g_varchar2_table(1508) := '67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233661616434323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273';
wwv_flow_imp.g_varchar2_table(1509) := '203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233661616434323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D63';
wwv_flow_imp.g_varchar2_table(1510) := '6F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233661616434323B0D0A20207374726F6B653A202336';
wwv_flow_imp.g_varchar2_table(1511) := '61616434323B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133393B0D0A202066696C6C3A20236339636133';
wwv_flow_imp.g_varchar2_table(1512) := '393B0D0A2020636F6C6F723A20233264326530343B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E20';
wwv_flow_imp.g_varchar2_table(1513) := '2B20333629202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F';
wwv_flow_imp.g_varchar2_table(1514) := '6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236339636133393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(1515) := '68696C642834356E202B20333629202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333629202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236339';
wwv_flow_imp.g_varchar2_table(1516) := '636133393B0D0A20207374726F6B653A20236339636133393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A202364396231';
wwv_flow_imp.g_varchar2_table(1517) := '33623B0D0A202066696C6C3A20236439623133623B0D0A2020636F6C6F723A20233436333430303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D62672C0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1518) := '73203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236439623133623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1519) := '696C642834356E202B20333729202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236439623133623B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1520) := '0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333729202E752D636F6C6F722D626F72646572207B0D0A';
wwv_flow_imp.g_varchar2_table(1521) := '2020626F726465722D636F6C6F723A20236439623133623B0D0A20207374726F6B653A20236439623133623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F72207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1522) := '67726F756E642D636F6C6F723A20236437366132373B0D0A202066696C6C3A20236437366132373B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D';
wwv_flow_imp.g_varchar2_table(1523) := '636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236437366132373B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(1524) := '2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D74657874207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1525) := '636F6C6F723A20236437366132373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333829202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2033382920';
wwv_flow_imp.g_varchar2_table(1526) := '2E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236437366132373B0D0A20207374726F6B653A20236437366132373B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929';
wwv_flow_imp.g_varchar2_table(1527) := '202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236432343233623B0D0A202066696C6C3A20236432343233623B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D';
wwv_flow_imp.g_varchar2_table(1528) := '6368696C642834356E202B20333929202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1529) := '6F6C6F723A20236432343233623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B2033392920';
wwv_flow_imp.g_varchar2_table(1530) := '2E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236432343233623B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20333929202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E';
wwv_flow_imp.g_varchar2_table(1531) := '74682D6368696C642834356E202B20333929202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236432343233623B0D0A20207374726F6B653A20236432343233623B0D0A7D0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1532) := '6E74682D6368696C642834356E202B20343029202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236431343336663B0D0A202066696C6C3A20236431343336663B0D0A2020636F6C6F723A20236666666666663B0D0A7D';
wwv_flow_imp.g_varchar2_table(1533) := '0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1534) := '64207B0D0A20206261636B67726F756E642D636F6C6F723A20236431343336663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E';
wwv_flow_imp.g_varchar2_table(1535) := '74682D6368696C642834356E202B20343029202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236431343336663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1536) := '62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343029202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236431343336663B0D0A20207374726F6B653A2023643134333666';
wwv_flow_imp.g_varchar2_table(1537) := '3B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20236261336438383B0D0A202066696C6C3A20236261336438383B0D0A20';
wwv_flow_imp.g_varchar2_table(1538) := '20636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129';
wwv_flow_imp.g_varchar2_table(1539) := '202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236261336438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D74';
wwv_flow_imp.g_varchar2_table(1540) := '78742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20236261336438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C6428';
wwv_flow_imp.g_varchar2_table(1541) := '34356E202B20343129202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343129202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236261336438383B';
wwv_flow_imp.g_varchar2_table(1542) := '0D0A20207374726F6B653A20236261336438383B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339333B0D0A';
wwv_flow_imp.g_varchar2_table(1543) := '202066696C6C3A20233737333339333B0D0A2020636F6C6F723A20236636656666393B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A';
wwv_flow_imp.g_varchar2_table(1544) := '6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834';
wwv_flow_imp.g_varchar2_table(1545) := '356E202B20343229202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233737333339333B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1546) := '6F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343229202E752D636F6C6F722D626F72646572207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(1547) := '6465722D636F6C6F723A20233737333339333B0D0A20207374726F6B653A20233737333339333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F72207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1548) := '642D636F6C6F723A20233364346561333B0D0A202066696C6C3A20233364346561333B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1549) := '2D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233364346561333B0D0A7D0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1550) := '6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D74657874207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1551) := '3A20233364346561333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343329202E752D636F';
wwv_flow_imp.g_varchar2_table(1552) := '6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233364346561333B0D0A20207374726F6B653A20233364346561333B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D63';
wwv_flow_imp.g_varchar2_table(1553) := '6F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233863396562303B0D0A202066696C6C3A20233863396562303B0D0A2020636F6C6F723A20233238336134643B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C64';
wwv_flow_imp.g_varchar2_table(1554) := '2834356E202B20343429202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1555) := '20233863396562303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F';
wwv_flow_imp.g_varchar2_table(1556) := '6C6F722D74657874207B0D0A2020636F6C6F723A20233863396562303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343429202E752D636F6C6F722D62642C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1557) := '696C642834356E202B20343429202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233863396562303B0D0A20207374726F6B653A20233863396562303B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(1558) := '68696C642834356E202B20343529202E752D636F6C6F72207B0D0A20206261636B67726F756E642D636F6C6F723A20233465373339313B0D0A202066696C6C3A20233465373339313B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1559) := '636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D62672C0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D6261636B67726F756E64207B0D0A';
wwv_flow_imp.g_varchar2_table(1560) := '20206261636B67726F756E642D636F6C6F723A20233465373339313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D7478742C0D0A2E752D636F6C6F7273203E203A6E74682D6368';
wwv_flow_imp.g_varchar2_table(1561) := '696C642834356E202B20343529202E752D636F6C6F722D74657874207B0D0A2020636F6C6F723A20233465373339313B0D0A7D0D0A2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D62642C0D0A';
wwv_flow_imp.g_varchar2_table(1562) := '2E752D636F6C6F7273203E203A6E74682D6368696C642834356E202B20343529202E752D636F6C6F722D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233465373339313B0D0A20207374726F6B653A20233465373339313B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1563) := '0A2E752D636F6C6F722D31207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644422021696D706F7274616E743B0D0A202066696C6C3A20233330394644422021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666';
wwv_flow_imp.g_varchar2_table(1564) := '662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D312D62672C0D0A2E752D636F6C6F722D312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233330394644422021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1565) := '202066696C6C3A20233330394644422021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D312D7478742C0D0A2E752D636F6C6F722D312D74657874207B0D0A2020636F6C6F723A20233330394644422021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1566) := '0A2E752D636F6C6F722D312D62642C0D0A2E752D636F6C6F722D312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233330394644422021696D706F7274616E743B0D0A20207374726F6B653A20233330394644422021696D706F7274';
wwv_flow_imp.g_varchar2_table(1567) := '616E743B0D0A7D0D0A2E752D636F6C6F722D32207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643462021696D706F7274616E743B0D0A202066696C6C3A20233133423643462021696D706F7274616E743B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1568) := '3A20236534663966642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D322D62672C0D0A2E752D636F6C6F722D322D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233133423643462021696D706F';
wwv_flow_imp.g_varchar2_table(1569) := '7274616E743B0D0A202066696C6C3A20233133423643462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D322D7478742C0D0A2E752D636F6C6F722D322D74657874207B0D0A2020636F6C6F723A20233133423643462021696D706F7274';
wwv_flow_imp.g_varchar2_table(1570) := '616E743B0D0A7D0D0A2E752D636F6C6F722D322D62642C0D0A2E752D636F6C6F722D322D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233133423643462021696D706F7274616E743B0D0A20207374726F6B653A2023313342364346';
wwv_flow_imp.g_varchar2_table(1571) := '2021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33207B0D0A20206261636B67726F756E642D636F6C6F723A20233245424642432021696D706F7274616E743B0D0A202066696C6C3A20233245424642432021696D706F7274616E743B0D';
wwv_flow_imp.g_varchar2_table(1572) := '0A2020636F6C6F723A20236630666366622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D332D62672C0D0A2E752D636F6C6F722D332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A202332454246';
wwv_flow_imp.g_varchar2_table(1573) := '42432021696D706F7274616E743B0D0A202066696C6C3A20233245424642432021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D332D7478742C0D0A2E752D636F6C6F722D332D74657874207B0D0A2020636F6C6F723A2023324542464243';
wwv_flow_imp.g_varchar2_table(1574) := '2021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D332D62642C0D0A2E752D636F6C6F722D332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233245424642432021696D706F7274616E743B0D0A20207374726F6B653A';
wwv_flow_imp.g_varchar2_table(1575) := '20233245424642432021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34207B0D0A20206261636B67726F756E642D636F6C6F723A20233343414638352021696D706F7274616E743B0D0A202066696C6C3A20233343414638352021696D70';
wwv_flow_imp.g_varchar2_table(1576) := '6F7274616E743B0D0A2020636F6C6F723A20236630666166362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D342D62672C0D0A2E752D636F6C6F722D342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1577) := '723A20233343414638352021696D706F7274616E743B0D0A202066696C6C3A20233343414638352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D342D7478742C0D0A2E752D636F6C6F722D342D74657874207B0D0A2020636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1578) := '20233343414638352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D342D62642C0D0A2E752D636F6C6F722D342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233343414638352021696D706F7274616E743B0D0A20';
wwv_flow_imp.g_varchar2_table(1579) := '207374726F6B653A20233343414638352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D35207B0D0A20206261636B67726F756E642D636F6C6F723A20233831424235462021696D706F7274616E743B0D0A202066696C6C3A2023383142';
wwv_flow_imp.g_varchar2_table(1580) := '4235462021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D352D62672C0D0A2E752D636F6C6F722D352D6261636B67726F756E64207B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(1581) := '756E642D636F6C6F723A20233831424235462021696D706F7274616E743B0D0A202066696C6C3A20233831424235462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D352D7478742C0D0A2E752D636F6C6F722D352D74657874207B0D0A';
wwv_flow_imp.g_varchar2_table(1582) := '2020636F6C6F723A20233831424235462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D352D62642C0D0A2E752D636F6C6F722D352D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233831424235462021696D706F72';
wwv_flow_imp.g_varchar2_table(1583) := '74616E743B0D0A20207374726F6B653A20233831424235462021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D36207B0D0A20206261636B67726F756E642D636F6C6F723A20234444444535332021696D706F7274616E743B0D0A20206669';
wwv_flow_imp.g_varchar2_table(1584) := '6C6C3A20234444444535332021696D706F7274616E743B0D0A2020636F6C6F723A20233261326130382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D362D62672C0D0A2E752D636F6C6F722D362D6261636B67726F756E64207B0D0A20';
wwv_flow_imp.g_varchar2_table(1585) := '206261636B67726F756E642D636F6C6F723A20234444444535332021696D706F7274616E743B0D0A202066696C6C3A20234444444535332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D362D7478742C0D0A2E752D636F6C6F722D362D';
wwv_flow_imp.g_varchar2_table(1586) := '74657874207B0D0A2020636F6C6F723A20234444444535332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D362D62642C0D0A2E752D636F6C6F722D362D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234444444535';
wwv_flow_imp.g_varchar2_table(1587) := '332021696D706F7274616E743B0D0A20207374726F6B653A20234444444535332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D37207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1588) := '743B0D0A202066696C6C3A20234642434534412021696D706F7274616E743B0D0A2020636F6C6F723A20233434333330322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D372D62672C0D0A2E752D636F6C6F722D372D6261636B67726F';
wwv_flow_imp.g_varchar2_table(1589) := '756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234642434534412021696D706F7274616E743B0D0A202066696C6C3A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D372D7478742C0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1590) := '636F6C6F722D372D74657874207B0D0A2020636F6C6F723A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D372D62642C0D0A2E752D636F6C6F722D372D626F72646572207B0D0A2020626F726465722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1591) := '3A20234642434534412021696D706F7274616E743B0D0A20207374726F6B653A20234642434534412021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D38207B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133452021';
wwv_flow_imp.g_varchar2_table(1592) := '696D706F7274616E743B0D0A202066696C6C3A20234544383133452021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D382D62672C0D0A2E752D636F6C6F722D38';
wwv_flow_imp.g_varchar2_table(1593) := '2D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234544383133452021696D706F7274616E743B0D0A202066696C6C3A20234544383133452021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D382D74';
wwv_flow_imp.g_varchar2_table(1594) := '78742C0D0A2E752D636F6C6F722D382D74657874207B0D0A2020636F6C6F723A20234544383133452021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D382D62642C0D0A2E752D636F6C6F722D382D626F72646572207B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(1595) := '65722D636F6C6F723A20234544383133452021696D706F7274616E743B0D0A20207374726F6B653A20234544383133452021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D39207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1596) := '4539354235342021696D706F7274616E743B0D0A202066696C6C3A20234539354235342021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D392D62672C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1597) := '2D636F6C6F722D392D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234539354235342021696D706F7274616E743B0D0A202066696C6C3A20234539354235342021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1598) := '6F6C6F722D392D7478742C0D0A2E752D636F6C6F722D392D74657874207B0D0A2020636F6C6F723A20234539354235342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D392D62642C0D0A2E752D636F6C6F722D392D626F72646572207B';
wwv_flow_imp.g_varchar2_table(1599) := '0D0A2020626F726465722D636F6C6F723A20234539354235342021696D706F7274616E743B0D0A20207374726F6B653A20234539354235342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3130207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1600) := '2D636F6C6F723A20234538354438382021696D706F7274616E743B0D0A202066696C6C3A20234538354438382021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1601) := '31302D62672C0D0A2E752D636F6C6F722D31302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234538354438382021696D706F7274616E743B0D0A202066696C6C3A20234538354438382021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1602) := '743B0D0A7D0D0A2E752D636F6C6F722D31302D7478742C0D0A2E752D636F6C6F722D31302D74657874207B0D0A2020636F6C6F723A20234538354438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31302D62642C0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1603) := '6C6F722D31302D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234538354438382021696D706F7274616E743B0D0A20207374726F6B653A20234538354438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D313120';
wwv_flow_imp.g_varchar2_table(1604) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839442021696D706F7274616E743B0D0A202066696C6C3A20234341353839442021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1605) := '3B0D0A7D0D0A2E752D636F6C6F722D31312D62672C0D0A2E752D636F6C6F722D31312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20234341353839442021696D706F7274616E743B0D0A202066696C6C3A202343';
wwv_flow_imp.g_varchar2_table(1606) := '41353839442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31312D7478742C0D0A2E752D636F6C6F722D31312D74657874207B0D0A2020636F6C6F723A20234341353839442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1607) := '722D31312D62642C0D0A2E752D636F6C6F722D31312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20234341353839442021696D706F7274616E743B0D0A20207374726F6B653A20234341353839442021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1608) := '7D0D0A2E752D636F6C6F722D3132207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539422021696D706F7274616E743B0D0A202066696C6C3A20233835344539422021696D706F7274616E743B0D0A2020636F6C6F723A20236636';
wwv_flow_imp.g_varchar2_table(1609) := '663066382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31322D62672C0D0A2E752D636F6C6F722D31322D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233835344539422021696D706F727461';
wwv_flow_imp.g_varchar2_table(1610) := '6E743B0D0A202066696C6C3A20233835344539422021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31322D7478742C0D0A2E752D636F6C6F722D31322D74657874207B0D0A2020636F6C6F723A20233835344539422021696D706F727461';
wwv_flow_imp.g_varchar2_table(1611) := '6E743B0D0A7D0D0A2E752D636F6C6F722D31322D62642C0D0A2E752D636F6C6F722D31322D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233835344539422021696D706F7274616E743B0D0A20207374726F6B653A20233835344539';
wwv_flow_imp.g_varchar2_table(1612) := '422021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3133207B0D0A20206261636B67726F756E642D636F6C6F723A20233541363841442021696D706F7274616E743B0D0A202066696C6C3A20233541363841442021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1613) := '3B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31332D62672C0D0A2E752D636F6C6F722D31332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1614) := '3541363841442021696D706F7274616E743B0D0A202066696C6C3A20233541363841442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31332D7478742C0D0A2E752D636F6C6F722D31332D74657874207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1615) := '3541363841442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31332D62642C0D0A2E752D636F6C6F722D31332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233541363841442021696D706F7274616E743B0D0A20';
wwv_flow_imp.g_varchar2_table(1616) := '207374726F6B653A20233541363841442021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3134207B0D0A20206261636B67726F756E642D636F6C6F723A20234146424143352021696D706F7274616E743B0D0A202066696C6C3A20234146';
wwv_flow_imp.g_varchar2_table(1617) := '424143352021696D706F7274616E743B0D0A2020636F6C6F723A20233331336134342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31342D62672C0D0A2E752D636F6C6F722D31342D6261636B67726F756E64207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1618) := '67726F756E642D636F6C6F723A20234146424143352021696D706F7274616E743B0D0A202066696C6C3A20234146424143352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31342D7478742C0D0A2E752D636F6C6F722D31342D746578';
wwv_flow_imp.g_varchar2_table(1619) := '74207B0D0A2020636F6C6F723A20234146424143352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31342D62642C0D0A2E752D636F6C6F722D31342D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023414642414335';
wwv_flow_imp.g_varchar2_table(1620) := '2021696D706F7274616E743B0D0A20207374726F6B653A20234146424143352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3135207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539382021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1621) := '743B0D0A202066696C6C3A20233645383539382021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31352D62672C0D0A2E752D636F6C6F722D31352D6261636B67';
wwv_flow_imp.g_varchar2_table(1622) := '726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233645383539382021696D706F7274616E743B0D0A202066696C6C3A20233645383539382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31352D7478742C0D0A';
wwv_flow_imp.g_varchar2_table(1623) := '2E752D636F6C6F722D31352D74657874207B0D0A2020636F6C6F723A20233645383539382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31352D62642C0D0A2E752D636F6C6F722D31352D626F72646572207B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(1624) := '2D636F6C6F723A20233645383539382021696D706F7274616E743B0D0A20207374726F6B653A20233645383539382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3136207B0D0A20206261636B67726F756E642D636F6C6F723A202335';
wwv_flow_imp.g_varchar2_table(1625) := '39623265322021696D706F7274616E743B0D0A202066696C6C3A20233539623265322021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31362D62672C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1626) := '2D636F6C6F722D31362D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233539623265322021696D706F7274616E743B0D0A202066696C6C3A20233539623265322021696D706F7274616E743B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1627) := '636F6C6F722D31362D7478742C0D0A2E752D636F6C6F722D31362D74657874207B0D0A2020636F6C6F723A20233539623265322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31362D62642C0D0A2E752D636F6C6F722D31362D626F72';
wwv_flow_imp.g_varchar2_table(1628) := '646572207B0D0A2020626F726465722D636F6C6F723A20233539623265322021696D706F7274616E743B0D0A20207374726F6B653A20233539623265322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3137207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(1629) := '726F756E642D636F6C6F723A20233432633564392021696D706F7274616E743B0D0A202066696C6C3A20233432633564392021696D706F7274616E743B0D0A2020636F6C6F723A20233035313531372021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1630) := '6F6C6F722D31372D62672C0D0A2E752D636F6C6F722D31372D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233432633564392021696D706F7274616E743B0D0A202066696C6C3A20233432633564392021696D70';
wwv_flow_imp.g_varchar2_table(1631) := '6F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31372D7478742C0D0A2E752D636F6C6F722D31372D74657874207B0D0A2020636F6C6F723A20233432633564392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31372D62642C0D0A';
wwv_flow_imp.g_varchar2_table(1632) := '2E752D636F6C6F722D31372D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233432633564392021696D706F7274616E743B0D0A20207374726F6B653A20233432633564392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1633) := '722D3138207B0D0A20206261636B67726F756E642D636F6C6F723A20233538636363392021696D706F7274616E743B0D0A202066696C6C3A20233538636363392021696D706F7274616E743B0D0A2020636F6C6F723A20233039316331632021696D706F';
wwv_flow_imp.g_varchar2_table(1634) := '7274616E743B0D0A7D0D0A2E752D636F6C6F722D31382D62672C0D0A2E752D636F6C6F722D31382D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233538636363392021696D706F7274616E743B0D0A202066696C';
wwv_flow_imp.g_varchar2_table(1635) := '6C3A20233538636363392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31382D7478742C0D0A2E752D636F6C6F722D31382D74657874207B0D0A2020636F6C6F723A20233538636363392021696D706F7274616E743B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(1636) := '2D636F6C6F722D31382D62642C0D0A2E752D636F6C6F722D31382D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233538636363392021696D706F7274616E743B0D0A20207374726F6B653A20233538636363392021696D706F727461';
wwv_flow_imp.g_varchar2_table(1637) := '6E743B0D0A7D0D0A2E752D636F6C6F722D3139207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639642021696D706F7274616E743B0D0A202066696C6C3A20233633626639642021696D706F7274616E743B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1638) := '3A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31392D62672C0D0A2E752D636F6C6F722D31392D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233633626639642021696D';
wwv_flow_imp.g_varchar2_table(1639) := '706F7274616E743B0D0A202066696C6C3A20233633626639642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31392D7478742C0D0A2E752D636F6C6F722D31392D74657874207B0D0A2020636F6C6F723A20233633626639642021696D';
wwv_flow_imp.g_varchar2_table(1640) := '706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D31392D62642C0D0A2E752D636F6C6F722D31392D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233633626639642021696D706F7274616E743B0D0A20207374726F6B653A2023';
wwv_flow_imp.g_varchar2_table(1641) := '3633626639642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3230207B0D0A20206261636B67726F756E642D636F6C6F723A20233961633937662021696D706F7274616E743B0D0A202066696C6C3A20233961633937662021696D706F';
wwv_flow_imp.g_varchar2_table(1642) := '7274616E743B0D0A2020636F6C6F723A20233230333331362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32302D62672C0D0A2E752D636F6C6F722D32302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(1643) := '6F723A20233961633937662021696D706F7274616E743B0D0A202066696C6C3A20233961633937662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32302D7478742C0D0A2E752D636F6C6F722D32302D74657874207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(1644) := '6F723A20233961633937662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32302D62642C0D0A2E752D636F6C6F722D32302D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233961633937662021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1645) := '743B0D0A20207374726F6B653A20233961633937662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3231207B0D0A20206261636B67726F756E642D636F6C6F723A20236534653537352021696D706F7274616E743B0D0A202066696C6C';
wwv_flow_imp.g_varchar2_table(1646) := '3A20236534653537352021696D706F7274616E743B0D0A2020636F6C6F723A20233463346330662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32312D62672C0D0A2E752D636F6C6F722D32312D6261636B67726F756E64207B0D0A20';
wwv_flow_imp.g_varchar2_table(1647) := '206261636B67726F756E642D636F6C6F723A20236534653537352021696D706F7274616E743B0D0A202066696C6C3A20236534653537352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32312D7478742C0D0A2E752D636F6C6F722D32';
wwv_flow_imp.g_varchar2_table(1648) := '312D74657874207B0D0A2020636F6C6F723A20236534653537352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32312D62642C0D0A2E752D636F6C6F722D32312D626F72646572207B0D0A2020626F726465722D636F6C6F723A202365';
wwv_flow_imp.g_varchar2_table(1649) := '34653537352021696D706F7274616E743B0D0A20207374726F6B653A20236534653537352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3232207B0D0A20206261636B67726F756E642D636F6C6F723A20236663643836652021696D70';
wwv_flow_imp.g_varchar2_table(1650) := '6F7274616E743B0D0A202066696C6C3A20236663643836652021696D706F7274616E743B0D0A2020636F6C6F723A20233639346630322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32322D62672C0D0A2E752D636F6C6F722D32322D';
wwv_flow_imp.g_varchar2_table(1651) := '6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236663643836652021696D706F7274616E743B0D0A202066696C6C3A20236663643836652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32322D74';
wwv_flow_imp.g_varchar2_table(1652) := '78742C0D0A2E752D636F6C6F722D32322D74657874207B0D0A2020636F6C6F723A20236663643836652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32322D62642C0D0A2E752D636F6C6F722D32322D626F72646572207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1653) := '6F726465722D636F6C6F723A20236663643836652021696D706F7274616E743B0D0A20207374726F6B653A20236663643836652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3233207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1654) := '723A20236631396136352021696D706F7274616E743B0D0A202066696C6C3A20236631396136352021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32332D6267';
wwv_flow_imp.g_varchar2_table(1655) := '2C0D0A2E752D636F6C6F722D32332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236631396136352021696D706F7274616E743B0D0A202066696C6C3A20236631396136352021696D706F7274616E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(1656) := '0D0A2E752D636F6C6F722D32332D7478742C0D0A2E752D636F6C6F722D32332D74657874207B0D0A2020636F6C6F723A20236631396136352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32332D62642C0D0A2E752D636F6C6F722D32';
wwv_flow_imp.g_varchar2_table(1657) := '332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236631396136352021696D706F7274616E743B0D0A20207374726F6B653A20236631396136352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3234207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1658) := '6261636B67726F756E642D636F6C6F723A20236564376337362021696D706F7274616E743B0D0A202066696C6C3A20236564376337362021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1659) := '0A2E752D636F6C6F722D32342D62672C0D0A2E752D636F6C6F722D32342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376337362021696D706F7274616E743B0D0A202066696C6C3A2023656437633736';
wwv_flow_imp.g_varchar2_table(1660) := '2021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32342D7478742C0D0A2E752D636F6C6F722D32342D74657874207B0D0A2020636F6C6F723A20236564376337362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32342D';
wwv_flow_imp.g_varchar2_table(1661) := '62642C0D0A2E752D636F6C6F722D32342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376337362021696D706F7274616E743B0D0A20207374726F6B653A20236564376337362021696D706F7274616E743B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(1662) := '2D636F6C6F722D3235207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461302021696D706F7274616E743B0D0A202066696C6C3A20236564376461302021696D706F7274616E743B0D0A2020636F6C6F723A202366666666666620';
wwv_flow_imp.g_varchar2_table(1663) := '21696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32352D62672C0D0A2E752D636F6C6F722D32352D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236564376461302021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1664) := '202066696C6C3A20236564376461302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32352D7478742C0D0A2E752D636F6C6F722D32352D74657874207B0D0A2020636F6C6F723A20236564376461302021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1665) := '7D0D0A2E752D636F6C6F722D32352D62642C0D0A2E752D636F6C6F722D32352D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236564376461302021696D706F7274616E743B0D0A20207374726F6B653A20236564376461302021696D';
wwv_flow_imp.g_varchar2_table(1666) := '706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3236207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962312021696D706F7274616E743B0D0A202066696C6C3A20236435373962312021696D706F7274616E743B0D0A2020';
wwv_flow_imp.g_varchar2_table(1667) := '636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32362D62672C0D0A2E752D636F6C6F722D32362D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236435373962';
wwv_flow_imp.g_varchar2_table(1668) := '312021696D706F7274616E743B0D0A202066696C6C3A20236435373962312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32362D7478742C0D0A2E752D636F6C6F722D32362D74657874207B0D0A2020636F6C6F723A20236435373962';
wwv_flow_imp.g_varchar2_table(1669) := '312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32362D62642C0D0A2E752D636F6C6F722D32362D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236435373962312021696D706F7274616E743B0D0A20207374726F';
wwv_flow_imp.g_varchar2_table(1670) := '6B653A20236435373962312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3237207B0D0A20206261636B67726F756E642D636F6C6F723A20233964373161662021696D706F7274616E743B0D0A202066696C6C3A202339643731616620';
wwv_flow_imp.g_varchar2_table(1671) := '21696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32372D62672C0D0A2E752D636F6C6F722D32372D6261636B67726F756E64207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(1672) := '642D636F6C6F723A20233964373161662021696D706F7274616E743B0D0A202066696C6C3A20233964373161662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32372D7478742C0D0A2E752D636F6C6F722D32372D74657874207B0D0A';
wwv_flow_imp.g_varchar2_table(1673) := '2020636F6C6F723A20233964373161662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32372D62642C0D0A2E752D636F6C6F722D32372D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233964373161662021696D70';
wwv_flow_imp.g_varchar2_table(1674) := '6F7274616E743B0D0A20207374726F6B653A20233964373161662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3238207B0D0A20206261636B67726F756E642D636F6C6F723A20233762383662642021696D706F7274616E743B0D0A20';
wwv_flow_imp.g_varchar2_table(1675) := '2066696C6C3A20233762383662642021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32382D62672C0D0A2E752D636F6C6F722D32382D6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1676) := '207B0D0A20206261636B67726F756E642D636F6C6F723A20233762383662642021696D706F7274616E743B0D0A202066696C6C3A20233762383662642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32382D7478742C0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1677) := '6C6F722D32382D74657874207B0D0A2020636F6C6F723A20233762383662642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32382D62642C0D0A2E752D636F6C6F722D32382D626F72646572207B0D0A2020626F726465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(1678) := '723A20233762383662642021696D706F7274616E743B0D0A20207374726F6B653A20233762383662642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3239207B0D0A20206261636B67726F756E642D636F6C6F723A2023626663386431';
wwv_flow_imp.g_varchar2_table(1679) := '2021696D706F7274616E743B0D0A202066696C6C3A20236266633864312021696D706F7274616E743B0D0A2020636F6C6F723A20233364343835342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32392D62672C0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1680) := '722D32392D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236266633864312021696D706F7274616E743B0D0A202066696C6C3A20236266633864312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1681) := '2D32392D7478742C0D0A2E752D636F6C6F722D32392D74657874207B0D0A2020636F6C6F723A20236266633864312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D32392D62642C0D0A2E752D636F6C6F722D32392D626F72646572207B';
wwv_flow_imp.g_varchar2_table(1682) := '0D0A2020626F726465722D636F6C6F723A20236266633864312021696D706F7274616E743B0D0A20207374726F6B653A20236266633864312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3330207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1683) := '2D636F6C6F723A20233862396461642021696D706F7274616E743B0D0A202066696C6C3A20233862396461642021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(1684) := '33302D62672C0D0A2E752D636F6C6F722D33302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233862396461642021696D706F7274616E743B0D0A202066696C6C3A20233862396461642021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1685) := '743B0D0A7D0D0A2E752D636F6C6F722D33302D7478742C0D0A2E752D636F6C6F722D33302D74657874207B0D0A2020636F6C6F723A20233862396461642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33302D62642C0D0A2E752D636F';
wwv_flow_imp.g_varchar2_table(1686) := '6C6F722D33302D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233862396461642021696D706F7274616E743B0D0A20207374726F6B653A20233862396461642021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D333120';
wwv_flow_imp.g_varchar2_table(1687) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363612021696D706F7274616E743B0D0A202066696C6C3A20233139386363612021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1688) := '3B0D0A7D0D0A2E752D636F6C6F722D33312D62672C0D0A2E752D636F6C6F722D33312D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233139386363612021696D706F7274616E743B0D0A202066696C6C3A202331';
wwv_flow_imp.g_varchar2_table(1689) := '39386363612021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33312D7478742C0D0A2E752D636F6C6F722D33312D74657874207B0D0A2020636F6C6F723A20233139386363612021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1690) := '722D33312D62642C0D0A2E752D636F6C6F722D33312D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233139386363612021696D706F7274616E743B0D0A20207374726F6B653A20233139386363612021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1691) := '7D0D0A2E752D636F6C6F722D3332207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562652021696D706F7274616E743B0D0A202066696C6C3A20233032613562652021696D706F7274616E743B0D0A2020636F6C6F723A20233030';
wwv_flow_imp.g_varchar2_table(1692) := '303030302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33322D62672C0D0A2E752D636F6C6F722D33322D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233032613562652021696D706F727461';
wwv_flow_imp.g_varchar2_table(1693) := '6E743B0D0A202066696C6C3A20233032613562652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33322D7478742C0D0A2E752D636F6C6F722D33322D74657874207B0D0A2020636F6C6F723A20233032613562652021696D706F727461';
wwv_flow_imp.g_varchar2_table(1694) := '6E743B0D0A7D0D0A2E752D636F6C6F722D33322D62642C0D0A2E752D636F6C6F722D33322D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233032613562652021696D706F7274616E743B0D0A20207374726F6B653A20233032613562';
wwv_flow_imp.g_varchar2_table(1695) := '652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3333207B0D0A20206261636B67726F756E642D636F6C6F723A20233138623161652021696D706F7274616E743B0D0A202066696C6C3A20233138623161652021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(1696) := '3B0D0A2020636F6C6F723A20233030303030302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33332D62672C0D0A2E752D636F6C6F722D33332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1697) := '3138623161652021696D706F7274616E743B0D0A202066696C6C3A20233138623161652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33332D7478742C0D0A2E752D636F6C6F722D33332D74657874207B0D0A2020636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(1698) := '3138623161652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33332D62642C0D0A2E752D636F6C6F722D33332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233138623161652021696D706F7274616E743B0D0A20';
wwv_flow_imp.g_varchar2_table(1699) := '207374726F6B653A20233138623161652021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3334207B0D0A20206261636B67726F756E642D636F6C6F723A20233234613437352021696D706F7274616E743B0D0A202066696C6C3A20233234';
wwv_flow_imp.g_varchar2_table(1700) := '613437352021696D706F7274616E743B0D0A2020636F6C6F723A20236566666266372021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33342D62672C0D0A2E752D636F6C6F722D33342D6261636B67726F756E64207B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(1701) := '67726F756E642D636F6C6F723A20233234613437352021696D706F7274616E743B0D0A202066696C6C3A20233234613437352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33342D7478742C0D0A2E752D636F6C6F722D33342D746578';
wwv_flow_imp.g_varchar2_table(1702) := '74207B0D0A2020636F6C6F723A20233234613437352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33342D62642C0D0A2E752D636F6C6F722D33342D626F72646572207B0D0A2020626F726465722D636F6C6F723A2023323461343735';
wwv_flow_imp.g_varchar2_table(1703) := '2021696D706F7274616E743B0D0A20207374726F6B653A20233234613437352021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3335207B0D0A20206261636B67726F756E642D636F6C6F723A20233661616434322021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1704) := '743B0D0A202066696C6C3A20233661616434322021696D706F7274616E743B0D0A2020636F6C6F723A20233063313530362021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D62672C0D0A2E752D636F6C6F722D33352D6261636B67';
wwv_flow_imp.g_varchar2_table(1705) := '726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233661616434322021696D706F7274616E743B0D0A202066696C6C3A20233661616434322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D7478742C0D0A';
wwv_flow_imp.g_varchar2_table(1706) := '2E752D636F6C6F722D33352D74657874207B0D0A2020636F6C6F723A20233661616434322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33352D62642C0D0A2E752D636F6C6F722D33352D626F72646572207B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(1707) := '2D636F6C6F723A20233661616434322021696D706F7274616E743B0D0A20207374726F6B653A20233661616434322021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3336207B0D0A20206261636B67726F756E642D636F6C6F723A202363';
wwv_flow_imp.g_varchar2_table(1708) := '39636133392021696D706F7274616E743B0D0A202066696C6C3A20236339636133392021696D706F7274616E743B0D0A2020636F6C6F723A20233264326530342021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33362D62672C0D0A2E75';
wwv_flow_imp.g_varchar2_table(1709) := '2D636F6C6F722D33362D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236339636133392021696D706F7274616E743B0D0A202066696C6C3A20236339636133392021696D706F7274616E743B0D0A7D0D0A2E752D';
wwv_flow_imp.g_varchar2_table(1710) := '636F6C6F722D33362D7478742C0D0A2E752D636F6C6F722D33362D74657874207B0D0A2020636F6C6F723A20236339636133392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33362D62642C0D0A2E752D636F6C6F722D33362D626F72';
wwv_flow_imp.g_varchar2_table(1711) := '646572207B0D0A2020626F726465722D636F6C6F723A20236339636133392021696D706F7274616E743B0D0A20207374726F6B653A20236339636133392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3337207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(1712) := '726F756E642D636F6C6F723A20236439623133622021696D706F7274616E743B0D0A202066696C6C3A20236439623133622021696D706F7274616E743B0D0A2020636F6C6F723A20233436333430302021696D706F7274616E743B0D0A7D0D0A2E752D63';
wwv_flow_imp.g_varchar2_table(1713) := '6F6C6F722D33372D62672C0D0A2E752D636F6C6F722D33372D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236439623133622021696D706F7274616E743B0D0A202066696C6C3A20236439623133622021696D70';
wwv_flow_imp.g_varchar2_table(1714) := '6F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33372D7478742C0D0A2E752D636F6C6F722D33372D74657874207B0D0A2020636F6C6F723A20236439623133622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33372D62642C0D0A';
wwv_flow_imp.g_varchar2_table(1715) := '2E752D636F6C6F722D33372D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236439623133622021696D706F7274616E743B0D0A20207374726F6B653A20236439623133622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F';
wwv_flow_imp.g_varchar2_table(1716) := '722D3338207B0D0A20206261636B67726F756E642D636F6C6F723A20236437366132372021696D706F7274616E743B0D0A202066696C6C3A20236437366132372021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F';
wwv_flow_imp.g_varchar2_table(1717) := '7274616E743B0D0A7D0D0A2E752D636F6C6F722D33382D62672C0D0A2E752D636F6C6F722D33382D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236437366132372021696D706F7274616E743B0D0A202066696C';
wwv_flow_imp.g_varchar2_table(1718) := '6C3A20236437366132372021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33382D7478742C0D0A2E752D636F6C6F722D33382D74657874207B0D0A2020636F6C6F723A20236437366132372021696D706F7274616E743B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(1719) := '2D636F6C6F722D33382D62642C0D0A2E752D636F6C6F722D33382D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236437366132372021696D706F7274616E743B0D0A20207374726F6B653A20236437366132372021696D706F727461';
wwv_flow_imp.g_varchar2_table(1720) := '6E743B0D0A7D0D0A2E752D636F6C6F722D3339207B0D0A20206261636B67726F756E642D636F6C6F723A20236432343233622021696D706F7274616E743B0D0A202066696C6C3A20236432343233622021696D706F7274616E743B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(1721) := '3A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D62672C0D0A2E752D636F6C6F722D33392D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20236432343233622021696D';
wwv_flow_imp.g_varchar2_table(1722) := '706F7274616E743B0D0A202066696C6C3A20236432343233622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D7478742C0D0A2E752D636F6C6F722D33392D74657874207B0D0A2020636F6C6F723A20236432343233622021696D';
wwv_flow_imp.g_varchar2_table(1723) := '706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D33392D62642C0D0A2E752D636F6C6F722D33392D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236432343233622021696D706F7274616E743B0D0A20207374726F6B653A2023';
wwv_flow_imp.g_varchar2_table(1724) := '6432343233622021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3430207B0D0A20206261636B67726F756E642D636F6C6F723A20236431343336662021696D706F7274616E743B0D0A202066696C6C3A20236431343336662021696D706F';
wwv_flow_imp.g_varchar2_table(1725) := '7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34302D62672C0D0A2E752D636F6C6F722D34302D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(1726) := '6F723A20236431343336662021696D706F7274616E743B0D0A202066696C6C3A20236431343336662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34302D7478742C0D0A2E752D636F6C6F722D34302D74657874207B0D0A2020636F6C';
wwv_flow_imp.g_varchar2_table(1727) := '6F723A20236431343336662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34302D62642C0D0A2E752D636F6C6F722D34302D626F72646572207B0D0A2020626F726465722D636F6C6F723A20236431343336662021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(1728) := '743B0D0A20207374726F6B653A20236431343336662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3431207B0D0A20206261636B67726F756E642D636F6C6F723A20236261336438382021696D706F7274616E743B0D0A202066696C6C';
wwv_flow_imp.g_varchar2_table(1729) := '3A20236261336438382021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34312D62672C0D0A2E752D636F6C6F722D34312D6261636B67726F756E64207B0D0A20';
wwv_flow_imp.g_varchar2_table(1730) := '206261636B67726F756E642D636F6C6F723A20236261336438382021696D706F7274616E743B0D0A202066696C6C3A20236261336438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34312D7478742C0D0A2E752D636F6C6F722D34';
wwv_flow_imp.g_varchar2_table(1731) := '312D74657874207B0D0A2020636F6C6F723A20236261336438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34312D62642C0D0A2E752D636F6C6F722D34312D626F72646572207B0D0A2020626F726465722D636F6C6F723A202362';
wwv_flow_imp.g_varchar2_table(1732) := '61336438382021696D706F7274616E743B0D0A20207374726F6B653A20236261336438382021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3432207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339332021696D70';
wwv_flow_imp.g_varchar2_table(1733) := '6F7274616E743B0D0A202066696C6C3A20233737333339332021696D706F7274616E743B0D0A2020636F6C6F723A20236636656666392021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34322D62672C0D0A2E752D636F6C6F722D34322D';
wwv_flow_imp.g_varchar2_table(1734) := '6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233737333339332021696D706F7274616E743B0D0A202066696C6C3A20233737333339332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34322D74';
wwv_flow_imp.g_varchar2_table(1735) := '78742C0D0A2E752D636F6C6F722D34322D74657874207B0D0A2020636F6C6F723A20233737333339332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34322D62642C0D0A2E752D636F6C6F722D34322D626F72646572207B0D0A202062';
wwv_flow_imp.g_varchar2_table(1736) := '6F726465722D636F6C6F723A20233737333339332021696D706F7274616E743B0D0A20207374726F6B653A20233737333339332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3433207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(1737) := '723A20233364346561332021696D706F7274616E743B0D0A202066696C6C3A20233364346561332021696D706F7274616E743B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34332D6267';
wwv_flow_imp.g_varchar2_table(1738) := '2C0D0A2E752D636F6C6F722D34332D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233364346561332021696D706F7274616E743B0D0A202066696C6C3A20233364346561332021696D706F7274616E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(1739) := '0D0A2E752D636F6C6F722D34332D7478742C0D0A2E752D636F6C6F722D34332D74657874207B0D0A2020636F6C6F723A20233364346561332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34332D62642C0D0A2E752D636F6C6F722D34';
wwv_flow_imp.g_varchar2_table(1740) := '332D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233364346561332021696D706F7274616E743B0D0A20207374726F6B653A20233364346561332021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D3434207B0D0A2020';
wwv_flow_imp.g_varchar2_table(1741) := '6261636B67726F756E642D636F6C6F723A20233863396562302021696D706F7274616E743B0D0A202066696C6C3A20233863396562302021696D706F7274616E743B0D0A2020636F6C6F723A20233238336134642021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(1742) := '0A2E752D636F6C6F722D34342D62672C0D0A2E752D636F6C6F722D34342D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233863396562302021696D706F7274616E743B0D0A202066696C6C3A2023386339656230';
wwv_flow_imp.g_varchar2_table(1743) := '2021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34342D7478742C0D0A2E752D636F6C6F722D34342D74657874207B0D0A2020636F6C6F723A20233863396562302021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34342D';
wwv_flow_imp.g_varchar2_table(1744) := '62642C0D0A2E752D636F6C6F722D34342D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233863396562302021696D706F7274616E743B0D0A20207374726F6B653A20233863396562302021696D706F7274616E743B0D0A7D0D0A2E75';
wwv_flow_imp.g_varchar2_table(1745) := '2D636F6C6F722D3435207B0D0A20206261636B67726F756E642D636F6C6F723A20233465373339312021696D706F7274616E743B0D0A202066696C6C3A20233465373339312021696D706F7274616E743B0D0A2020636F6C6F723A202366666666666620';
wwv_flow_imp.g_varchar2_table(1746) := '21696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34352D62672C0D0A2E752D636F6C6F722D34352D6261636B67726F756E64207B0D0A20206261636B67726F756E642D636F6C6F723A20233465373339312021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1747) := '202066696C6C3A20233465373339312021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D34352D7478742C0D0A2E752D636F6C6F722D34352D74657874207B0D0A2020636F6C6F723A20233465373339312021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(1748) := '7D0D0A2E752D636F6C6F722D34352D62642C0D0A2E752D636F6C6F722D34352D626F72646572207B0D0A2020626F726465722D636F6C6F723A20233465373339312021696D706F7274616E743B0D0A20207374726F6B653A20233465373339312021696D';
wwv_flow_imp.g_varchar2_table(1749) := '706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D7472616E73706172656E74207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A2020636F6C6F723A207472616E7370617265';
wwv_flow_imp.g_varchar2_table(1750) := '6E742021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D7472616E73706172656E742D6267207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E752D636F6C';
wwv_flow_imp.g_varchar2_table(1751) := '6F722D7472616E73706172656E742D7478742C0D0A2E752D636F6C6F722D7472616E73706172656E742D74657874207B0D0A2020636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A2E752D636F6C6F722D7472616E';
wwv_flow_imp.g_varchar2_table(1752) := '73706172656E742D62642C0D0A2E752D636F6C6F722D7472616E73706172656E742D626F72646572207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B0D0A7D0D0A0D0A2F2A200D0A202A204F72';
wwv_flow_imp.g_varchar2_table(1753) := '61636C65204170706C69636174696F6E204578707265737320352E30205468656D6520526F6C6C657220437573746F6D20435353200D0A202A0D0A202A2F0D0A0D0A2E63757272656E742D70726F636573733A6E6F74285B686561646572732A3D696E73';
wwv_flow_imp.g_varchar2_table(1754) := '74616E63655F7374617475735F636F6C5D297B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C302C302C2E312921696D706F7274616E743B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_theme_file(
 p_id=>wwv_flow_imp.id(26992721367947345)
,p_theme_id=>42
,p_file_name=>'26992397294947328.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9791758988536006)
,p_theme_id=>42
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>40
,p_template_types=>'BUTTON'
,p_help_text=>'Enables you to group many buttons together into a pill. You can use this option to specify where the button is within this set. Set the option to Default if this button is not part of a button set.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9792128696536006)
,p_theme_id=>42
,p_name=>'ICON_HOVER_ANIMATION'
,p_display_name=>'Icon Hover Animation'
,p_display_sequence=>55
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9792530262536006)
,p_theme_id=>42
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>50
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the position of the icon relative to the label.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9792945716536006)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the size of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9793307033536006)
,p_theme_id=>42
,p_name=>'SPACING_BOTTOM'
,p_display_name=>'Spacing Bottom'
,p_display_sequence=>100
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the bottom of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9793755471536006)
,p_theme_id=>42
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing Left'
,p_display_sequence=>70
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the left of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9794166768536006)
,p_theme_id=>42
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>80
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the right of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9794535838536006)
,p_theme_id=>42
,p_name=>'SPACING_TOP'
,p_display_name=>'Spacing Top'
,p_display_sequence=>90
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the top of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9794924591536006)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>30
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the style of the button. Use the "Simple" option for secondary actions or sets of buttons. Use the "Remove UI Decoration" option to make the button appear as text.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9795357560536007)
,p_theme_id=>42
,p_name=>'TYPE'
,p_display_name=>'Type'
,p_display_sequence=>20
,p_template_types=>'BUTTON'
,p_null_text=>'Normal'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9795720589536007)
,p_theme_id=>42
,p_name=>'WIDTH'
,p_display_name=>'Width'
,p_display_sequence=>60
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the width of the button.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9796193590536007)
,p_theme_id=>42
,p_name=>'BOTTOM_MARGIN'
,p_display_name=>'Bottom Margin'
,p_display_sequence=>220
,p_template_types=>'FIELD'
,p_help_text=>'Set the bottom margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9796538047536007)
,p_theme_id=>42
,p_name=>'ITEM_POST_TEXT'
,p_display_name=>'Item Post Text'
,p_display_sequence=>30
,p_template_types=>'FIELD'
,p_help_text=>'Adjust the display of the Item Post Text'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9796973853536007)
,p_theme_id=>42
,p_name=>'ITEM_PRE_TEXT'
,p_display_name=>'Item Pre Text'
,p_display_sequence=>20
,p_template_types=>'FIELD'
,p_help_text=>'Adjust the display of the Item Pre Text'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9797382654536007)
,p_theme_id=>42
,p_name=>'LEFT_MARGIN'
,p_display_name=>'Left Margin'
,p_display_sequence=>220
,p_template_types=>'FIELD'
,p_help_text=>'Set the left margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9797709051536007)
,p_theme_id=>42
,p_name=>'PRESERVE_LABEL_SPACING'
,p_display_name=>'Preserve Label Spacing'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_help_text=>'Preserves the label space and enables use of the Label Column Span property.'
,p_null_text=>'Yes'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9798164219536007)
,p_theme_id=>42
,p_name=>'RADIO_GROUP_DISPLAY'
,p_display_name=>'Item Group Display'
,p_display_sequence=>300
,p_template_types=>'FIELD'
,p_help_text=>'Determines the display style for radio and check box items.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9798553014536007)
,p_theme_id=>42
,p_name=>'REQUIRED_INDICATOR'
,p_display_name=>'Required Indicator'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9798959190536007)
,p_theme_id=>42
,p_name=>'RIGHT_MARGIN'
,p_display_name=>'Right Margin'
,p_display_sequence=>230
,p_template_types=>'FIELD'
,p_help_text=>'Set the right margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9799341038536007)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9799701651536007)
,p_theme_id=>42
,p_name=>'TOP_MARGIN'
,p_display_name=>'Top Margin'
,p_display_sequence=>200
,p_template_types=>'FIELD'
,p_help_text=>'Set the top margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9800143751536007)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>80
,p_template_types=>'LIST'
,p_help_text=>'Sets the hover and focus animation.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9800561547536008)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>70
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9800955155536008)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'LIST'
,p_help_text=>'Determines the height of the card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9801300905536008)
,p_theme_id=>42
,p_name=>'COLLAPSE_STYLE'
,p_display_name=>'Collapse Mode'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9801722971536008)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9802100522536008)
,p_theme_id=>42
,p_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_sequence=>90
,p_template_types=>'LIST'
,p_help_text=>'Determines the display for a desktop-sized screen'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9802536647536008)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9802957888536008)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9803310229536008)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'LIST'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Circle'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9803791849536008)
,p_theme_id=>42
,p_name=>'ICON_STYLE'
,p_display_name=>'Icon Style'
,p_display_sequence=>35
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9804174690536008)
,p_theme_id=>42
,p_name=>'LABEL_DISPLAY'
,p_display_name=>'Label Display'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9804567021536008)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9804934402536008)
,p_theme_id=>42
,p_name=>'MOBILE'
,p_display_name=>'Mobile'
,p_display_sequence=>100
,p_template_types=>'LIST'
,p_help_text=>'Determines the display for a mobile-sized screen'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9805349260536008)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9805776572536008)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9806190304536009)
,p_theme_id=>42
,p_name=>'CONTENT_PADDING'
,p_display_name=>'Content Padding'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_help_text=>'Sets the Content Body padding for the page.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9806567855536009)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9806942999536009)
,p_theme_id=>42
,p_name=>'DISPLAY_MODE'
,p_display_name=>'Display Mode'
,p_display_sequence=>30
,p_template_types=>'PAGE'
,p_help_text=>'Determines the default display appearance and positioning of the dialog. The default opens a floating dialog position at the center of the screen.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9807388278536009)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND'
,p_display_name=>'Page Background'
,p_display_sequence=>20
,p_template_types=>'PAGE'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9807715570536009)
,p_theme_id=>42
,p_name=>'PAGE_LAYOUT'
,p_display_name=>'Page Layout'
,p_display_sequence=>10
,p_template_types=>'PAGE'
,p_null_text=>'Floating (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9808142671536009)
,p_theme_id=>42
,p_name=>'PAGE_POSITION'
,p_display_name=>'Position'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_help_text=>'Sets the position of the page.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9808594480536009)
,p_theme_id=>42
,p_name=>'ACCENT'
,p_display_name=>'Accent'
,p_display_sequence=>30
,p_template_types=>'REGION'
,p_help_text=>'Set the Region''s accent. This accent corresponds to a Theme-Rollable color and sets the background of the Region''s Header.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9808960275536009)
,p_theme_id=>42
,p_name=>'ALERT_DISPLAY'
,p_display_name=>'Alert Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the layout of the Alert Region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9809363190536009)
,p_theme_id=>42
,p_name=>'ALERT_ICONS'
,p_display_name=>'Alert Icons'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets how icons are handled for the Alert Region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9809758623536009)
,p_theme_id=>42
,p_name=>'ALERT_TITLE'
,p_display_name=>'Alert Title'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the title of the alert is displayed.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9810125402536009)
,p_theme_id=>42
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>3
,p_template_types=>'REGION'
,p_help_text=>'Sets the type of alert which can be used to determine the icon, icon color, and the background color.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9810502001536009)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the animation when navigating within the Carousel Region.'
,p_null_text=>'Fade'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9810956252536009)
,p_theme_id=>42
,p_name=>'BODY_HEIGHT'
,p_display_name=>'Body Height'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body height. You can also specify a custom height by modifying the Region''s CSS Classes and using the height helper classes "i-hXXX" where XXX is any increment of 10 from 100 to 800.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9811324869536009)
,p_theme_id=>42
,p_name=>'BODY_OVERFLOW'
,p_display_name=>'Body Overflow'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Determines the scroll behavior when the region contents are larger than their container.'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9811727359536010)
,p_theme_id=>42
,p_name=>'BODY_PADDING'
,p_display_name=>'Body Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body padding for the region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9812128850536010)
,p_theme_id=>42
,p_name=>'BODY_STYLE'
,p_display_name=>'Body Style'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Controls the display of the region''s body container.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9812522421536010)
,p_theme_id=>42
,p_name=>'CALLOUT_POSITION'
,p_display_name=>'Callout Position'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Determines where the callout for the popup will be positioned relative to its parent.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9812912792536010)
,p_theme_id=>42
,p_name=>'COLLAPSIBLE_BUTTON_ICONS'
,p_display_name=>'Collapsible Button Icons'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines which arrows to use to represent the icons for the collapse and expand button.'
,p_null_text=>'Arrows'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9813366672536010)
,p_theme_id=>42
,p_name=>'COLLAPSIBLE_ICON_POSITION'
,p_display_name=>'Collapsible Icon Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the position of the expand and collapse toggle for the region.'
,p_null_text=>'Start'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9813755212536010)
,p_theme_id=>42
,p_name=>'DEFAULT_STATE'
,p_display_name=>'Default State'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the default state of the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9814102179536010)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9814507929536010)
,p_theme_id=>42
,p_name=>'DISPLAY_ICON'
,p_display_name=>'Display Icon'
,p_display_sequence=>50
,p_template_types=>'REGION'
,p_help_text=>'Display the Hero Region icon.'
,p_null_text=>'Yes (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9814959320536010)
,p_theme_id=>42
,p_name=>'DISPLAY_MODE'
,p_display_name=>'Display Mode'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the default display appearance and positioning of the dialog. The default opens a floating dialog position at the center of the screen.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9815315975536010)
,p_theme_id=>42
,p_name=>'HEADER'
,p_display_name=>'Header'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Determines the display of the Region Header which also contains the Region Title.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9815794812536010)
,p_theme_id=>42
,p_name=>'HEADING_FONT'
,p_display_name=>'Heading Font'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the font-family of the heading for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9816144582536010)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL'
,p_display_name=>'Heading Level'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9816501219536010)
,p_theme_id=>42
,p_name=>'HIDE_STEPS_FOR'
,p_display_name=>'Hide Steps For'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9816921552536011)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'REGION'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Rounded Corners'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9817388461536011)
,p_theme_id=>42
,p_name=>'IMAGE_FILTER'
,p_display_name=>'Filter'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9817744559536011)
,p_theme_id=>42
,p_name=>'IMAGE_RATIO'
,p_display_name=>'Ratio'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9818137669536011)
,p_theme_id=>42
,p_name=>'IMAGE_SCALE'
,p_display_name=>'Scale'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9818585284536011)
,p_theme_id=>42
,p_name=>'IMAGE_SHAPE'
,p_display_name=>'Shape'
,p_display_sequence=>30
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9818954016536011)
,p_theme_id=>42
,p_name=>'ITEM_PADDING'
,p_display_name=>'Item Spacing'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the padding around items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9819388862536011)
,p_theme_id=>42
,p_name=>'ITEM_SIZE'
,p_display_name=>'Item Size'
,p_display_sequence=>110
,p_template_types=>'REGION'
,p_help_text=>'Sets the size of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9819778708536011)
,p_theme_id=>42
,p_name=>'ITEM_WIDTH'
,p_display_name=>'Item Width'
,p_display_sequence=>120
,p_template_types=>'REGION'
,p_help_text=>'Sets the width of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9820115227536011)
,p_theme_id=>42
,p_name=>'LABEL_ALIGNMENT'
,p_display_name=>'Label Alignment'
,p_display_sequence=>130
,p_template_types=>'REGION'
,p_help_text=>'Set the label text alignment for items within this region.'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9820550314536011)
,p_theme_id=>42
,p_name=>'LABEL_POSITION'
,p_display_name=>'Label Position'
,p_display_sequence=>140
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the label relative to the form item.'
,p_null_text=>'Inline - Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9820952812536011)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9821307237536011)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER'
,p_display_name=>'Login Header'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Controls the display of the Login region header.'
,p_null_text=>'Icon and Title (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9821723425536011)
,p_theme_id=>42
,p_name=>'REGION_BOTTOM_MARGIN'
,p_display_name=>'Bottom Margin'
,p_display_sequence=>210
,p_template_types=>'REGION'
,p_help_text=>'Set the bottom margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9822195675536011)
,p_theme_id=>42
,p_name=>'REGION_LEFT_MARGIN'
,p_display_name=>'Left Margin'
,p_display_sequence=>220
,p_template_types=>'REGION'
,p_help_text=>'Set the left margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9822533187536012)
,p_theme_id=>42
,p_name=>'REGION_POSITION'
,p_display_name=>'Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9822973935536012)
,p_theme_id=>42
,p_name=>'REGION_RIGHT_MARGIN'
,p_display_name=>'Right Margin'
,p_display_sequence=>230
,p_template_types=>'REGION'
,p_help_text=>'Set the right margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9823311984536012)
,p_theme_id=>42
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the source of the Title Bar region''s title.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9823708753536012)
,p_theme_id=>42
,p_name=>'REGION_TOP_MARGIN'
,p_display_name=>'Top Margin'
,p_display_sequence=>200
,p_template_types=>'REGION'
,p_help_text=>'Set the top margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9824116708536012)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the region is styled. Use the "Remove Borders" template option to remove the region''s borders and shadows.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9824545847536012)
,p_theme_id=>42
,p_name=>'TABS_SIZE'
,p_display_name=>'Tabs Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9824953271536012)
,p_theme_id=>42
,p_name=>'TAB_STYLE'
,p_display_name=>'Tab Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9825351092536012)
,p_theme_id=>42
,p_name=>'TIMER'
,p_display_name=>'Timer'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets the timer for when to automatically navigate to the next region within the Carousel Region.'
,p_null_text=>'No Timer'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9825723263536012)
,p_theme_id=>42
,p_name=>'ALTERNATING_ROWS'
,p_display_name=>'Alternating Rows'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Shades alternate rows in the report with slightly different background colors.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9826106602536012)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>70
,p_template_types=>'REPORT'
,p_help_text=>'Sets the hover and focus animation.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9826559969536012)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9826911596536012)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'REPORT'
,p_help_text=>'Determines the height of the card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9827372112536012)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9827762035536012)
,p_theme_id=>42
,p_name=>'COL_ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>150
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9828174990536012)
,p_theme_id=>42
,p_name=>'COL_CONTENT_DESCRIPTION'
,p_display_name=>'Description'
,p_display_sequence=>130
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9828512836536013)
,p_theme_id=>42
,p_name=>'COL_CONTENT_TITLE'
,p_display_name=>'Title'
,p_display_sequence=>120
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9828922746536013)
,p_theme_id=>42
,p_name=>'COL_ICON'
,p_display_name=>'Icon'
,p_display_sequence=>110
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9829366703536013)
,p_theme_id=>42
,p_name=>'COL_MISC'
,p_display_name=>'Misc'
,p_display_sequence=>140
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9829786231536013)
,p_theme_id=>42
,p_name=>'COL_SELECTION'
,p_display_name=>'Selection'
,p_display_sequence=>100
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9830134773536013)
,p_theme_id=>42
,p_name=>'COMMENTS_STYLE'
,p_display_name=>'Comments Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the style in which comments are displayed.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9830535197536013)
,p_theme_id=>42
,p_name=>'CONTENT_ALIGNMENT'
,p_display_name=>'Content Alignment'
,p_display_sequence=>90
,p_template_types=>'REPORT'
,p_null_text=>'Center (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9830918564536013)
,p_theme_id=>42
,p_name=>'DISPLAY_ITEMS'
,p_display_name=>'Display Items'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_null_text=>'Inline (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9831311102536013)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS'
,p_display_name=>'Display Labels'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_null_text=>'Inline (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9831714164536013)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Controls how to handle icons in the report.'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9832143653536013)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'REPORT'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Circle'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9832513543536013)
,p_theme_id=>42
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9832956204536013)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Determines the layout of Cards in the report.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9833377756536013)
,p_theme_id=>42
,p_name=>'PAGINATION_DISPLAY'
,p_display_name=>'Pagination Display'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of pagination for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9833739543536013)
,p_theme_id=>42
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of the Report''s borders.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9834174173536014)
,p_theme_id=>42
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Determines whether you want the row to be highlighted on hover.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9834559519536014)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>35
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(9834947869536014)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the overall style for the component.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1792535287043264)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1792064716043263)
,p_css_classes=>'u-colors'
,p_template_types=>'REGION'
,p_help_text=>'Applies the colors from the theme''s color palette to the icons or initials within cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1792910802043264)
,p_theme_id=>42
,p_name=>'STYLE_A'
,p_display_name=>'Style A'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(1792064716043263)
,p_css_classes=>'t-CardsRegion--styleA'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1793386681043265)
,p_theme_id=>42
,p_name=>'STYLE_B'
,p_display_name=>'Style B'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(1792064716043263)
,p_css_classes=>'t-CardsRegion--styleB'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1793775126043265)
,p_theme_id=>42
,p_name=>'STYLE_C'
,p_display_name=>'Style C'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(1792064716043263)
,p_css_classes=>'t-CardsRegion--styleC'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1794428795043267)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1817034024043276)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9856037125536020)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H1'
,p_display_name=>'H1'
,p_display_sequence=>10
,p_css_classes=>'js-headingLevel-1'
,p_group_id=>wwv_flow_imp.id(9816144582536010)
,p_template_types=>'REGION'
,p_help_text=>'H1'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9856748088536020)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H2'
,p_display_name=>'H2'
,p_display_sequence=>20
,p_css_classes=>'js-headingLevel-2'
,p_group_id=>wwv_flow_imp.id(9816144582536010)
,p_template_types=>'REGION'
,p_help_text=>'H2'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9857420995536020)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H3'
,p_display_name=>'H3'
,p_display_sequence=>30
,p_css_classes=>'js-headingLevel-3'
,p_group_id=>wwv_flow_imp.id(9816144582536010)
,p_template_types=>'REGION'
,p_help_text=>'H3'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9858158660536020)
,p_theme_id=>42
,p_name=>'H4'
,p_display_name=>'H4'
,p_display_sequence=>40
,p_css_classes=>'js-headingLevel-4'
,p_group_id=>wwv_flow_imp.id(9816144582536010)
,p_template_types=>'REGION'
,p_help_text=>'H4'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9858832618536020)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H5'
,p_display_name=>'H5'
,p_display_sequence=>50
,p_css_classes=>'js-headingLevel-5'
,p_group_id=>wwv_flow_imp.id(9816144582536010)
,p_template_types=>'REGION'
,p_help_text=>'H5'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9859504757536020)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H6'
,p_display_name=>'H6'
,p_display_sequence=>60
,p_css_classes=>'js-headingLevel-6'
,p_group_id=>wwv_flow_imp.id(9816144582536010)
,p_template_types=>'REGION'
,p_help_text=>'H6'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9860263473536021)
,p_theme_id=>42
,p_name=>'FBM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-bottom-lg'
,p_group_id=>wwv_flow_imp.id(9796193590536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9860999897536021)
,p_theme_id=>42
,p_name=>'RBM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-bottom-lg'
,p_group_id=>wwv_flow_imp.id(9821723425536011)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large bottom margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9861677043536021)
,p_theme_id=>42
,p_name=>'FBM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-bottom-md'
,p_group_id=>wwv_flow_imp.id(9796193590536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9862377475536021)
,p_theme_id=>42
,p_name=>'RBM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-bottom-md'
,p_group_id=>wwv_flow_imp.id(9821723425536011)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium bottom margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9863049428536022)
,p_theme_id=>42
,p_name=>'FBM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-bottom-none'
,p_group_id=>wwv_flow_imp.id(9796193590536007)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9863710149536022)
,p_theme_id=>42
,p_name=>'RBM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-bottom-none'
,p_group_id=>wwv_flow_imp.id(9821723425536011)
,p_template_types=>'REGION'
,p_help_text=>'Removes the bottom margin for this region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9864483983536022)
,p_theme_id=>42
,p_name=>'FBM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-bottom-sm'
,p_group_id=>wwv_flow_imp.id(9796193590536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9865113762536022)
,p_theme_id=>42
,p_name=>'RBM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-bottom-sm'
,p_group_id=>wwv_flow_imp.id(9821723425536011)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small bottom margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9865819406536022)
,p_theme_id=>42
,p_name=>'FLM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-left-lg'
,p_group_id=>wwv_flow_imp.id(9797382654536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9866583634536023)
,p_theme_id=>42
,p_name=>'RLM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-left-lg'
,p_group_id=>wwv_flow_imp.id(9822195675536011)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9867260441536023)
,p_theme_id=>42
,p_name=>'FLM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-left-md'
,p_group_id=>wwv_flow_imp.id(9797382654536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9867948002536023)
,p_theme_id=>42
,p_name=>'RLM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-left-md'
,p_group_id=>wwv_flow_imp.id(9822195675536011)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9868669672536023)
,p_theme_id=>42
,p_name=>'FLM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-left-none'
,p_group_id=>wwv_flow_imp.id(9797382654536007)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9869387299536023)
,p_theme_id=>42
,p_name=>'RLM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-left-none'
,p_group_id=>wwv_flow_imp.id(9822195675536011)
,p_template_types=>'REGION'
,p_help_text=>'Removes the left margin from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9870010228536023)
,p_theme_id=>42
,p_name=>'FLM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-left-sm'
,p_group_id=>wwv_flow_imp.id(9797382654536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9870759552536023)
,p_theme_id=>42
,p_name=>'RLM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-left-sm'
,p_group_id=>wwv_flow_imp.id(9822195675536011)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small left margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9871456673536024)
,p_theme_id=>42
,p_name=>'FRM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-right-lg'
,p_group_id=>wwv_flow_imp.id(9798959190536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9872139932536024)
,p_theme_id=>42
,p_name=>'RRM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-right-lg'
,p_group_id=>wwv_flow_imp.id(9822973935536012)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9872800850536024)
,p_theme_id=>42
,p_name=>'FRM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-right-md'
,p_group_id=>wwv_flow_imp.id(9798959190536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9873540978536024)
,p_theme_id=>42
,p_name=>'RRM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-right-md'
,p_group_id=>wwv_flow_imp.id(9822973935536012)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9874269083536024)
,p_theme_id=>42
,p_name=>'FRM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-right-none'
,p_group_id=>wwv_flow_imp.id(9798959190536007)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9874929763536024)
,p_theme_id=>42
,p_name=>'RRM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-right-none'
,p_group_id=>wwv_flow_imp.id(9822973935536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes the right margin from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9875699768536025)
,p_theme_id=>42
,p_name=>'FRM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-right-sm'
,p_group_id=>wwv_flow_imp.id(9798959190536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9876321265536025)
,p_theme_id=>42
,p_name=>'RRM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-right-sm'
,p_group_id=>wwv_flow_imp.id(9822973935536012)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9877074742536025)
,p_theme_id=>42
,p_name=>'FTM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-top-lg'
,p_group_id=>wwv_flow_imp.id(9799701651536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9877734312536025)
,p_theme_id=>42
,p_name=>'RTM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-top-lg'
,p_group_id=>wwv_flow_imp.id(9823708753536012)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large top margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9878455005536025)
,p_theme_id=>42
,p_name=>'FTM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-top-md'
,p_group_id=>wwv_flow_imp.id(9799701651536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9879171723536025)
,p_theme_id=>42
,p_name=>'RTM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-top-md'
,p_group_id=>wwv_flow_imp.id(9823708753536012)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium top margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9879896937536026)
,p_theme_id=>42
,p_name=>'FTM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-top-none'
,p_group_id=>wwv_flow_imp.id(9799701651536007)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9880560405536026)
,p_theme_id=>42
,p_name=>'RTM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-top-none'
,p_group_id=>wwv_flow_imp.id(9823708753536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes the top margin for this region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9881261635536026)
,p_theme_id=>42
,p_name=>'FTM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-top-sm'
,p_group_id=>wwv_flow_imp.id(9799701651536007)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9881914237536026)
,p_theme_id=>42
,p_name=>'RTM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-top-sm'
,p_group_id=>wwv_flow_imp.id(9823708753536012)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small top margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9882524216536026)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>30
,p_css_classes=>'t-Button--danger'
,p_group_id=>wwv_flow_imp.id(9795357560536007)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9883248984536027)
,p_theme_id=>42
,p_name=>'LARGEBOTTOMMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapBottom'
,p_group_id=>wwv_flow_imp.id(9793307033536006)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9883975561536027)
,p_theme_id=>42
,p_name=>'LARGELEFTMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(9793755471536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9884625398536027)
,p_theme_id=>42
,p_name=>'LARGERIGHTMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(9794166768536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9885311850536027)
,p_theme_id=>42
,p_name=>'LARGETOPMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapTop'
,p_group_id=>wwv_flow_imp.id(9794535838536006)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9886057992536027)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_css_classes=>'t-Button--large'
,p_group_id=>wwv_flow_imp.id(9792945716536006)
,p_template_types=>'BUTTON'
,p_help_text=>'A large button.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9886763199536028)
,p_theme_id=>42
,p_name=>'DISPLAY_AS_LINK'
,p_display_name=>'Display as Link'
,p_display_sequence=>30
,p_css_classes=>'t-Button--link'
,p_group_id=>wwv_flow_imp.id(9794924591536006)
,p_template_types=>'BUTTON'
,p_help_text=>'This option makes the button appear as a text link.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9887406535536028)
,p_theme_id=>42
,p_name=>'NOUI'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>20
,p_css_classes=>'t-Button--noUI'
,p_group_id=>wwv_flow_imp.id(9794924591536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9888170885536028)
,p_theme_id=>42
,p_name=>'SMALLBOTTOMMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padBottom'
,p_group_id=>wwv_flow_imp.id(9793307033536006)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9888807132536028)
,p_theme_id=>42
,p_name=>'SMALLLEFTMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(9793755471536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9889544429536029)
,p_theme_id=>42
,p_name=>'SMALLRIGHTMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padRight'
,p_group_id=>wwv_flow_imp.id(9794166768536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9890246942536029)
,p_theme_id=>42
,p_name=>'SMALLTOPMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padTop'
,p_group_id=>wwv_flow_imp.id(9794535838536006)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9890940215536029)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Inner Button'
,p_display_sequence=>20
,p_css_classes=>'t-Button--pill'
,p_group_id=>wwv_flow_imp.id(9791758988536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9891646160536029)
,p_theme_id=>42
,p_name=>'PILLEND'
,p_display_name=>'Last Button'
,p_display_sequence=>30
,p_css_classes=>'t-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(9791758988536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9892365383536029)
,p_theme_id=>42
,p_name=>'PILLSTART'
,p_display_name=>'First Button'
,p_display_sequence=>10
,p_css_classes=>'t-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(9791758988536006)
,p_template_types=>'BUTTON'
,p_help_text=>'Use this for the start of a pill button.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9893098218536029)
,p_theme_id=>42
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>10
,p_css_classes=>'t-Button--primary'
,p_group_id=>wwv_flow_imp.id(9795357560536007)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9893781326536029)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_css_classes=>'t-Button--simple'
,p_group_id=>wwv_flow_imp.id(9794924591536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9894426098536030)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'t-Button--small'
,p_group_id=>wwv_flow_imp.id(9792945716536006)
,p_template_types=>'BUTTON'
,p_help_text=>'A small button.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9895166344536030)
,p_theme_id=>42
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>10
,p_css_classes=>'t-Button--stretch'
,p_group_id=>wwv_flow_imp.id(9795720589536007)
,p_template_types=>'BUTTON'
,p_help_text=>'Stretches button to fill container'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9895873573536030)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_css_classes=>'t-Button--success'
,p_group_id=>wwv_flow_imp.id(9795357560536007)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9896503397536030)
,p_theme_id=>42
,p_name=>'TINY'
,p_display_name=>'Tiny'
,p_display_sequence=>10
,p_css_classes=>'t-Button--tiny'
,p_group_id=>wwv_flow_imp.id(9792945716536006)
,p_template_types=>'BUTTON'
,p_help_text=>'A very small button.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9897232372536030)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>20
,p_css_classes=>'t-Button--warning'
,p_group_id=>wwv_flow_imp.id(9795357560536007)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9897685772536030)
,p_theme_id=>42
,p_name=>'DEFERRED_PAGE_RENDERING'
,p_display_name=>'Deferred Page Rendering'
,p_display_sequence=>1
,p_css_classes=>'t-DeferredRendering'
,p_template_types=>'PAGE'
,p_help_text=>'Defer page rendering until all page components have finished loading.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9898396359536030)
,p_theme_id=>42
,p_name=>'SHOWFORMLABELSABOVE'
,p_display_name=>'Show Form Labels Above'
,p_display_sequence=>10
,p_css_classes=>'t-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(9820550314536011)
,p_template_types=>'REGION'
,p_help_text=>'Show form labels above input fields.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9899052494536031)
,p_theme_id=>42
,p_name=>'FORMSIZELARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form--large'
,p_group_id=>wwv_flow_imp.id(9819388862536011)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9899750308536031)
,p_theme_id=>42
,p_name=>'FORMLEFTLABELS'
,p_display_name=>'Left'
,p_display_sequence=>20
,p_css_classes=>'t-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(9820115227536011)
,p_template_types=>'REGION'
,p_help_text=>'Align form labels to left.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9900472130536031)
,p_theme_id=>42
,p_name=>'FORMREMOVEPADDING'
,p_display_name=>'None'
,p_display_sequence=>20
,p_css_classes=>'t-Form--noPadding'
,p_group_id=>wwv_flow_imp.id(9818954016536011)
,p_template_types=>'REGION'
,p_help_text=>'Removes spacing between items.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9901156253536031)
,p_theme_id=>42
,p_name=>'FORMSLIMPADDING'
,p_display_name=>'Slim'
,p_display_sequence=>10
,p_css_classes=>'t-Form--slimPadding'
,p_group_id=>wwv_flow_imp.id(9818954016536011)
,p_template_types=>'REGION'
,p_help_text=>'Reduces form item spacing.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9901818549536031)
,p_theme_id=>42
,p_name=>'FORMSTANDARDPADDING'
,p_display_name=>'Standard'
,p_display_sequence=>5
,p_css_classes=>'t-Form--standardPadding'
,p_group_id=>wwv_flow_imp.id(9818954016536011)
,p_template_types=>'REGION'
,p_help_text=>'Uses the standard spacing between items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9902551378536031)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_FIELDS'
,p_display_name=>'Stretch Form Fields'
,p_display_sequence=>10
,p_css_classes=>'t-Form--stretchInputs'
,p_group_id=>wwv_flow_imp.id(9819778708536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9903287033536032)
,p_theme_id=>42
,p_name=>'FORMSIZEXLARGE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form--xlarge'
,p_group_id=>wwv_flow_imp.id(9819388862536011)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9903986476536032)
,p_theme_id=>42
,p_name=>'LARGE_FIELD'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--large'
,p_group_id=>wwv_flow_imp.id(9799341038536007)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9904671219536032)
,p_theme_id=>42
,p_name=>'POST_TEXT_BLOCK'
,p_display_name=>'Display as Block'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--postTextBlock'
,p_group_id=>wwv_flow_imp.id(9796538047536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the Item Post Text in a block style immediately after the item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9905329692536032)
,p_theme_id=>42
,p_name=>'PRE_TEXT_BLOCK'
,p_display_name=>'Display as Block'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--preTextBlock'
,p_group_id=>wwv_flow_imp.id(9796973853536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the Item Pre Text in a block style immediately before the item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9906084281536032)
,p_theme_id=>42
,p_name=>'DISPLAY_AS_PILL_BUTTON'
,p_display_name=>'Display as Pill Button'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--radioButtonGroup'
,p_group_id=>wwv_flow_imp.id(9798164219536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the radio buttons to look like a button set / pill button.  Note that the the radio buttons must all be in the same row for this option to work.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9906455474536032)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_ITEM'
,p_display_name=>'Stretch Form Item'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--stretchInputs'
,p_template_types=>'FIELD'
,p_help_text=>'Stretches the form item to fill its container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9907157458536033)
,p_theme_id=>42
,p_name=>'X_LARGE_SIZE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form-fieldContainer--xlarge'
,p_group_id=>wwv_flow_imp.id(9799341038536007)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9907828404536033)
,p_theme_id=>42
,p_name=>'REMOVE_PADDING'
,p_display_name=>'Remove Padding'
,p_display_sequence=>1
,p_css_classes=>'t-PageBody--noContentPadding'
,p_group_id=>wwv_flow_imp.id(9806190304536009)
,p_template_types=>'PAGE'
,p_help_text=>'Removes padding from the content region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9908547461536033)
,p_theme_id=>42
,p_name=>'HIDE_WHEN_ALL_ROWS_DISPLAYED'
,p_display_name=>'Hide when all rows displayed'
,p_display_sequence=>10
,p_css_classes=>'t-Report--hideNoPagination'
,p_group_id=>wwv_flow_imp.id(9833377756536013)
,p_template_types=>'REPORT'
,p_help_text=>'This option will hide the pagination when all rows are displayed.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9979762198536055)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_EXTRA_LARGE'
,p_display_name=>'Extra Large'
,p_display_sequence=>40
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'js-dialog-class-t-Drawer--xl'
,p_group_id=>wwv_flow_imp.id(9806567855536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9980124876536055)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'js-dialog-class-t-Drawer--lg'
,p_group_id=>wwv_flow_imp.id(9806567855536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9980570168536055)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'js-dialog-class-t-Drawer--md'
,p_group_id=>wwv_flow_imp.id(9806567855536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9980935486536055)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'js-dialog-class-t-Drawer--sm'
,p_group_id=>wwv_flow_imp.id(9806567855536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9981364087536056)
,p_theme_id=>42
,p_name=>'POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_group_id=>wwv_flow_imp.id(9808142671536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9981752061536056)
,p_theme_id=>42
,p_name=>'POSITION_START'
,p_display_name=>'Start'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutStart'
,p_group_id=>wwv_flow_imp.id(9808142671536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(9982196298536056)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(9977787507536054)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10045623395536073)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--headingFontAlt'
,p_group_id=>wwv_flow_imp.id(9815794812536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10061266717536077)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_css_classes=>'t-BreadcrumbRegion--headingFontAlt'
,p_group_id=>wwv_flow_imp.id(9815794812536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10072790936536080)
,p_theme_id=>42
,p_name=>'ACCENT_12'
,p_display_name=>'Accent 12'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent12'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10073415524536080)
,p_theme_id=>42
,p_name=>'ACCENT_14'
,p_display_name=>'Accent 14'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent14'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10074116572536080)
,p_theme_id=>42
,p_name=>'ACCENT_8'
,p_display_name=>'Accent 8'
,p_display_sequence=>80
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent8'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10074871703536080)
,p_theme_id=>42
,p_name=>'ACCENT_15'
,p_display_name=>'Accent 15'
,p_display_sequence=>150
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent15'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10075555367536080)
,p_theme_id=>42
,p_name=>'ACCENT_9'
,p_display_name=>'Accent 9'
,p_display_sequence=>90
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent9'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10076278548536080)
,p_theme_id=>42
,p_name=>'ACCENT_7'
,p_display_name=>'Accent 7'
,p_display_sequence=>70
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent7'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10076964359536081)
,p_theme_id=>42
,p_name=>'ACCENT_13'
,p_display_name=>'Accent 13'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent13'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10077662592536081)
,p_theme_id=>42
,p_name=>'ACCENT_10'
,p_display_name=>'Accent 10'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent10'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10078349737536081)
,p_theme_id=>42
,p_name=>'ACCENT_6'
,p_display_name=>'Accent 6'
,p_display_sequence=>60
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent6'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10079057979536081)
,p_theme_id=>42
,p_name=>'ACCENT_11'
,p_display_name=>'Accent 11'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent11'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10104638117536088)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10112779684536091)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--headingFontAlt'
,p_group_id=>wwv_flow_imp.id(9815794812536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10207434056536116)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_EXTRA_LARGE'
,p_display_name=>'Extra Large'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-class-t-Drawer--xl'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10207895139536116)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-class-t-Drawer--lg'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10208286944536116)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-class-t-Drawer--md'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10208656424536116)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-class-t-Drawer--sm'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10209082876536116)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10209439814536116)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None (Auto)'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10209807394536116)
,p_theme_id=>42
,p_name=>'POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_group_id=>wwv_flow_imp.id(9822533187536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10210234959536116)
,p_theme_id=>42
,p_name=>'POSITION_START'
,p_display_name=>'Start'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutStart'
,p_group_id=>wwv_flow_imp.id(9822533187536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10210644673536116)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(10202937558536114)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10212482186536117)
,p_theme_id=>42
,p_name=>'FILTER_BLUR'
,p_display_name=>'Blur'
,p_display_sequence=>430
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--blur'
,p_group_id=>wwv_flow_imp.id(9817388461536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10212827903536117)
,p_theme_id=>42
,p_name=>'FILTER_GRAYSCALE'
,p_display_name=>'Grayscale'
,p_display_sequence=>410
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--grayscale'
,p_group_id=>wwv_flow_imp.id(9817388461536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10213202959536117)
,p_theme_id=>42
,p_name=>'FILTER_INVERT'
,p_display_name=>'Invert'
,p_display_sequence=>440
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--invert'
,p_group_id=>wwv_flow_imp.id(9817388461536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10213684923536117)
,p_theme_id=>42
,p_name=>'FILTER_NONE'
,p_display_name=>'None'
,p_display_sequence=>400
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--noFilter'
,p_group_id=>wwv_flow_imp.id(9817388461536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10214093803536117)
,p_theme_id=>42
,p_name=>'FILTER_SATURATE'
,p_display_name=>'Saturate'
,p_display_sequence=>450
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--saturate'
,p_group_id=>wwv_flow_imp.id(9817388461536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10214407690536117)
,p_theme_id=>42
,p_name=>'FILTER_SEPIA'
,p_display_name=>'Sepia'
,p_display_sequence=>420
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--sepia'
,p_group_id=>wwv_flow_imp.id(9817388461536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10214801667536117)
,p_theme_id=>42
,p_name=>'IMAGE_STRETCH'
,p_display_name=>'Image Stretch'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--stretch'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10215294073536117)
,p_theme_id=>42
,p_name=>'RATIO_16_9'
,p_display_name=>'16:9 (Widescreen)'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--16x9'
,p_group_id=>wwv_flow_imp.id(9817744559536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10215674415536118)
,p_theme_id=>42
,p_name=>'RATIO_1_1'
,p_display_name=>'1:1 (Square)'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--1x1'
,p_group_id=>wwv_flow_imp.id(9817744559536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10216023307536118)
,p_theme_id=>42
,p_name=>'RATIO_2_1'
,p_display_name=>'2:1 (Univisium)'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--2x1'
,p_group_id=>wwv_flow_imp.id(9817744559536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10216443715536118)
,p_theme_id=>42
,p_name=>'RATIO_4_3'
,p_display_name=>'4:3 (Standard)'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--4x3'
,p_group_id=>wwv_flow_imp.id(9817744559536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10216838275536118)
,p_theme_id=>42
,p_name=>'RATIO_AUTO'
,p_display_name=>'Auto'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--auto'
,p_group_id=>wwv_flow_imp.id(9817744559536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10217252183536118)
,p_theme_id=>42
,p_name=>'SCALE_CONTAIN'
,p_display_name=>'Contain'
,p_display_sequence=>200
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--contain'
,p_group_id=>wwv_flow_imp.id(9818137669536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10217686933536118)
,p_theme_id=>42
,p_name=>'SCALE_COVER'
,p_display_name=>'Cover'
,p_display_sequence=>210
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--cover'
,p_group_id=>wwv_flow_imp.id(9818137669536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10218013514536118)
,p_theme_id=>42
,p_name=>'SCALE_DOWN'
,p_display_name=>'Scale Down'
,p_display_sequence=>230
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--scale-down'
,p_group_id=>wwv_flow_imp.id(9818137669536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10218484154536118)
,p_theme_id=>42
,p_name=>'SCALE_FILL'
,p_display_name=>'Fill'
,p_display_sequence=>220
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--fill'
,p_group_id=>wwv_flow_imp.id(9818137669536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10218813296536118)
,p_theme_id=>42
,p_name=>'SHAPE_CIRCLE'
,p_display_name=>'Circle'
,p_display_sequence=>320
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--circle'
,p_group_id=>wwv_flow_imp.id(9818585284536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10219234198536118)
,p_theme_id=>42
,p_name=>'SHAPE_ROUNDED'
,p_display_name=>'Rounded'
,p_display_sequence=>310
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--rounded'
,p_group_id=>wwv_flow_imp.id(9818585284536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10219660779536118)
,p_theme_id=>42
,p_name=>'SHAPE_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>300
,p_region_template_id=>wwv_flow_imp.id(10210934346536117)
,p_css_classes=>'t-ImageRegion--square'
,p_group_id=>wwv_flow_imp.id(9818585284536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10330705793536153)
,p_theme_id=>42
,p_name=>'DISPLAY_ITEMS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(10330268006536153)
,p_css_classes=>'t-ContextualInfo-item--stacked'
,p_group_id=>wwv_flow_imp.id(9830918564536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10331123224536154)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(10330268006536153)
,p_css_classes=>'t-ContextualInfo-label--stacked'
,p_group_id=>wwv_flow_imp.id(9831311102536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10332867801536155)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_imp.id(12495522780887880132)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_imp.id(9798553014536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10333506226536155)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_imp.id(12495522780887880132)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_imp.id(9798553014536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10335626281536156)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_imp.id(12495522609431880132)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_imp.id(9798553014536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10336347117536156)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_imp.id(12495522609431880132)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_imp.id(9798553014536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10338423946536157)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_imp.id(12495522548744880132)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_imp.id(9798553014536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10339170659536157)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_imp.id(12495522548744880132)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_imp.id(9798553014536007)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(10342937947536160)
,p_theme_id=>42
,p_name=>'HIDE_ICON_ON_DESKTOP'
,p_display_name=>'Hide Icon on Desktop'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_css_classes=>'t-Button--desktopHideIcon'
,p_template_types=>'BUTTON'
,p_help_text=>'This template options hides the button icon on large screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88547031223008883)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--layout2Cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88547363961008883)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--layout3Cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88547845021008883)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--layout4Cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88548160965008884)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--layout5Cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88548630470008884)
,p_theme_id=>42
,p_name=>'CUSTOM'
,p_display_name=>'Custom'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--layoutCustom'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88549005800008884)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Displays a callout arrow that points to where the menu was activated from.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88549413713008884)
,p_theme_id=>42
,p_name=>'FULL_WIDTH'
,p_display_name=>'Full Width'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--fullWidth'
,p_template_types=>'LIST'
,p_help_text=>'Stretches the menu to fill the width of the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(88549765769008884)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(88546529882008878)
,p_css_classes=>'t-MegaMenu--layoutStacked'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495520470130880126)
,p_theme_id=>42
,p_name=>'HIDE_LABEL_ON_MOBILE'
,p_display_name=>'Hide Label on Mobile'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_css_classes=>'t-Button--mobileHideLabel'
,p_template_types=>'BUTTON'
,p_help_text=>'This template options hides the button label on small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495520688868880126)
,p_theme_id=>42
,p_name=>'RIGHTICON'
,p_display_name=>'Right'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_css_classes=>'t-Button--iconRight'
,p_group_id=>wwv_flow_imp.id(9792530262536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495520853724880126)
,p_theme_id=>42
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_css_classes=>'t-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(9792530262536006)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495521242564880126)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_css_classes=>'t-Button--hoverIconSpin'
,p_group_id=>wwv_flow_imp.id(9792128696536006)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will spin on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495521414255880126)
,p_theme_id=>42
,p_name=>'PUSH'
,p_display_name=>'Push'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_css_classes=>'t-Button--hoverIconPush'
,p_group_id=>wwv_flow_imp.id(9792128696536006)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will animate to the right or left on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495521877519880126)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_css_classes=>'t-Button--hoverIconSpin'
,p_group_id=>wwv_flow_imp.id(9792128696536006)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will spin on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495522011421880127)
,p_theme_id=>42
,p_name=>'PUSH'
,p_display_name=>'Push'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_css_classes=>'t-Button--hoverIconPush'
,p_group_id=>wwv_flow_imp.id(9792128696536006)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will animate to the right or left on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495523249552880140)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--small'
,p_group_id=>wwv_flow_imp.id(9805349260536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495523430849880140)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--simple'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'A very simplistic tab UI.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495523644208880140)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--pill'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'Displays tabs in a pill container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495523859248880140)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--large'
,p_group_id=>wwv_flow_imp.id(9805349260536008)
,p_template_types=>'LIST'
,p_help_text=>'Increases font size and white space around tab items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495524049575880140)
,p_theme_id=>42
,p_name=>'INLINE_WITH_LABEL'
,p_display_name=>'Inline with Label'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--inlineIcons'
,p_group_id=>wwv_flow_imp.id(9802957888536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495524251143880140)
,p_theme_id=>42
,p_name=>'ABOVE_LABEL'
,p_display_name=>'Above Label'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--iconsAbove'
,p_group_id=>wwv_flow_imp.id(9802957888536008)
,p_template_types=>'LIST'
,p_help_text=>'Places icons above tab label.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495524461988880140)
,p_theme_id=>42
,p_name=>'FILL_LABELS'
,p_display_name=>'Fill Labels'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(12495524735818880142)
,p_css_classes=>'t-Tabs--fillLabels'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Stretch tabs to fill to the width of the tabs container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495524862618880143)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu. Note that callout will only be displayed if the data-parent-element custom attribute is defined.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495525068278880143)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Enables you to define a keyboard shortcut to activate the menu item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495525495554880143)
,p_theme_id=>42
,p_name=>'VERTICAL_LIST'
,p_display_name=>'Vertical Orientation'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495526785023880145)
,p_css_classes=>'t-WizardSteps--vertical'
,p_template_types=>'LIST'
,p_help_text=>'Displays the wizard progress list in a vertical orientation and is suitable for displaying within a side column of a page.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495525642905880143)
,p_theme_id=>42
,p_name=>'HIDELABELS'
,p_display_name=>'Hide Labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495526785023880145)
,p_css_classes=>'t-WizardSteps--hideLabels'
,p_group_id=>wwv_flow_imp.id(9804174690536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495525829841880143)
,p_theme_id=>42
,p_name=>'ALLSTEPS'
,p_display_name=>'All Steps'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495526785023880145)
,p_css_classes=>'t-WizardSteps--displayLabels'
,p_group_id=>wwv_flow_imp.id(9804174690536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495526055652880143)
,p_theme_id=>42
,p_name=>'CURRENTSTEPONLY'
,p_display_name=>'Current Step Only'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495526785023880145)
,p_css_classes=>'t-WizardSteps--displayCurrentLabelOnly'
,p_group_id=>wwv_flow_imp.id(9804174690536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495526423626880143)
,p_theme_id=>42
,p_name=>'WIZARD_PROGRESS_LINKS'
,p_display_name=>'Make Wizard Steps Clickable'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495526785023880145)
,p_css_classes=>'js-wizardProgressLinks'
,p_template_types=>'LIST'
,p_help_text=>'This option will make the wizard steps clickable links.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495526839144880145)
,p_theme_id=>42
,p_name=>'LABEL_ABOVE_LG'
,p_display_name=>'Display labels above'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495528385085880146)
,p_css_classes=>'t-NavTabs--stacked'
,p_group_id=>wwv_flow_imp.id(9802100522536008)
,p_template_types=>'LIST'
,p_help_text=>'Display the label stacked above the icon and badge'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495527024406880145)
,p_theme_id=>42
,p_name=>'LABEL_INLINE_LG'
,p_display_name=>'Display labels inline'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495528385085880146)
,p_css_classes=>'t-NavTabs--inlineLabels-lg'
,p_group_id=>wwv_flow_imp.id(9802100522536008)
,p_template_types=>'LIST'
,p_help_text=>'Display the label inline with the icon and badge'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495527255570880145)
,p_theme_id=>42
,p_name=>'HIDE_LABELS_SM'
,p_display_name=>'Do not display labels'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495528385085880146)
,p_css_classes=>'t-NavTabs--hiddenLabels-sm'
,p_group_id=>wwv_flow_imp.id(9804934402536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495527402028880145)
,p_theme_id=>42
,p_name=>'NO_LABEL_LG'
,p_display_name=>'Do not display labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495528385085880146)
,p_css_classes=>'t-NavTabs--hiddenLabels-lg'
,p_group_id=>wwv_flow_imp.id(9802100522536008)
,p_template_types=>'LIST'
,p_help_text=>'Hides the label for the list item'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495527863440880145)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS_SM'
,p_display_name=>'Display labels'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495528385085880146)
,p_css_classes=>'t-NavTabs--displayLabels-sm'
,p_group_id=>wwv_flow_imp.id(9804934402536008)
,p_template_types=>'LIST'
,p_help_text=>'Displays the label for the list items below the icon'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495528443868880146)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495529517389880148)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495528844306880146)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495529517389880148)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495529023501880146)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495529517389880148)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495529254324880146)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495529517389880148)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495529607350880148)
,p_theme_id=>42
,p_name=>'SHOWTOPICONS'
,p_display_name=>'For Top Level Items Only'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495531199768880148)
,p_css_classes=>'t-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(9802536647536008)
,p_template_types=>'LIST'
,p_help_text=>'This will show icons for top level items of the list only. It will not show icons for sub lists.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495529811979880148)
,p_theme_id=>42
,p_name=>'SHOWICONS'
,p_display_name=>'For All Items'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495531199768880148)
,p_css_classes=>'t-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(9802536647536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495530224839880148)
,p_theme_id=>42
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495531199768880148)
,p_css_classes=>'t-LinksList--showBadge'
,p_template_types=>'LIST'
,p_help_text=>'Show badge to right of link (requires Attribute 1 to be populated)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495530420299880148)
,p_theme_id=>42
,p_name=>'SHOWGOTOARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495531199768880148)
,p_css_classes=>'t-LinksList--showArrow'
,p_template_types=>'LIST'
,p_help_text=>'Show arrow to the right of link'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495530611793880148)
,p_theme_id=>42
,p_name=>'DISABLETEXTWRAPPING'
,p_display_name=>'Disable Text Wrapping'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495531199768880148)
,p_css_classes=>'t-LinksList--nowrap'
,p_template_types=>'LIST'
,p_help_text=>'Do not allow link text to wrap to new lines. Truncate with ellipsis.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495530876602880148)
,p_theme_id=>42
,p_name=>'ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495531199768880148)
,p_css_classes=>'t-LinksList--actions'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'Render as actions to be placed on the right side column.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495531210901880149)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(12495532306266880151)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495531659842880149)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(12495532306266880151)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495531809266880149)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495532306266880151)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495532058926880149)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(12495532306266880151)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495532499920880151)
,p_theme_id=>42
,p_name=>'STYLE_B'
,p_display_name=>'Style B'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'t-TreeNav--styleB'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'Style Variation B'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495532636217880151)
,p_theme_id=>42
,p_name=>'STYLE_A'
,p_display_name=>'Style A'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'t-TreeNav--styleA'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'Style Variation A'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495532875262880152)
,p_theme_id=>42
,p_name=>'STYLE_C'
,p_display_name=>'Classic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'t-TreeNav--classic'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'Classic Style'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495533001635880152)
,p_theme_id=>42
,p_name=>'COLLAPSE_STYLE_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'js-navCollapsed--hidden'
,p_group_id=>wwv_flow_imp.id(9801300905536008)
,p_template_types=>'LIST'
,p_help_text=>'Completely hide the navigation menu when it is collapsed.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495533260166880152)
,p_theme_id=>42
,p_name=>'ICON_DEFAULT'
,p_display_name=>'Icon'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'js-navCollapsed--default'
,p_group_id=>wwv_flow_imp.id(9801300905536008)
,p_template_types=>'LIST'
,p_help_text=>'Display icons when the navigation menu is collapsed for large screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495533672614880152)
,p_theme_id=>42
,p_name=>'COLLAPSED_DEFAULT'
,p_display_name=>'Collapsed by Default'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_css_classes=>'js-defaultCollapsed'
,p_template_types=>'LIST'
,p_help_text=>'This option will load the side navigation menu in a collapsed state by default.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495534019905880152)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495534382344880154)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495534440938880156)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
,p_help_text=>'Applies colors from the Theme''s color palette to icons in the list.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495534609191880156)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'LIST'
,p_help_text=>'Display an icon next to the list item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495534848193880156)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'LIST'
,p_help_text=>'Shows the description (Attribute 1) for each list item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495535049264880156)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'LIST'
,p_help_text=>'Show a badge (Attribute 2) to the right of the list item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495535208776880156)
,p_theme_id=>42
,p_name=>'LIST_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--large force-fa-lg'
,p_group_id=>wwv_flow_imp.id(9805349260536008)
,p_template_types=>'LIST'
,p_help_text=>'Increases the size of the text and icons in the list.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495535691639880156)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--iconsSquare'
,p_group_id=>wwv_flow_imp.id(9803310229536008)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495535851622880156)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--iconsRounded'
,p_group_id=>wwv_flow_imp.id(9803310229536008)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495536075167880156)
,p_theme_id=>42
,p_name=>'SPANHORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Show all list items in one horizontal row.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495536205681880156)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495536469962880156)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495536648855880156)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495536879435880157)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495537298467880157)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
,p_help_text=>'Applies the colors from the theme''s color palette to the icons or initials within cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495537412177880157)
,p_theme_id=>42
,p_name=>'CARDS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--stacked'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Stacks the cards on top of each other.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495537692510880157)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495537887100880157)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--iconsSquare'
,p_group_id=>wwv_flow_imp.id(9803310229536008)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495538057178880157)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--iconsRounded'
,p_group_id=>wwv_flow_imp.id(9803310229536008)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495538480427880159)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_imp.id(9800955155536008)
,p_template_types=>'LIST'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495538681630880159)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495538839944880159)
,p_theme_id=>42
,p_name=>'BLOCK'
,p_display_name=>'Block'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--featured t-Cards--block force-fa-lg'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495539092326880159)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--featured force-fa-lg'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495539246488880159)
,p_theme_id=>42
,p_name=>'DISPLAY_SUBTITLE'
,p_display_name=>'Display Subtitle'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--displaySubtitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495539485418880159)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_imp.id(9802957888536008)
,p_template_types=>'LIST'
,p_help_text=>'Initials come from List Attribute 3'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495539660270880159)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_imp.id(9802957888536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495540092530880159)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_imp.id(9800955155536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495540295899880160)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_imp.id(9800955155536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495540474923880160)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_imp.id(9800955155536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495540805281880160)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495541087730880160)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495541264314880162)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495541455298880162)
,p_theme_id=>42
,p_name=>'RAISE_CARD'
,p_display_name=>'Raise Card'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--animRaiseCard'
,p_group_id=>wwv_flow_imp.id(9800143751536007)
,p_template_types=>'LIST'
,p_help_text=>'Raises the card so it pops up.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495541633607880162)
,p_theme_id=>42
,p_name=>'COLOR_FILL'
,p_display_name=>'Color Fill'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--animColorFill'
,p_group_id=>wwv_flow_imp.id(9800143751536007)
,p_template_types=>'LIST'
,p_help_text=>'Fills the card background with the color of the icon or default link style.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495542092200880165)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495542291041880165)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495542424759880165)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495542773533880165)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495542869236880165)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495543063075880165)
,p_theme_id=>42
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(9800561547536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495543217773880167)
,p_theme_id=>42
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(9800561547536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495543432138880167)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Stack badges on top of each other'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495543642357880167)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(9800561547536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495543815075880167)
,p_theme_id=>42
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(9800561547536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495544084965880167)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(9800561547536008)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495544415469880167)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Float badges to left'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495544679195880167)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Use flexbox to arrange items'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495544842685880167)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Span badges horizontally'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495545083611880168)
,p_theme_id=>42
,p_name=>'GRID'
,p_display_name=>'Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--dash'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495545224789880168)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 5 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495545457700880168)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in 4 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495545659348880168)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495545855921880168)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(9804567021536008)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495546228455880170)
,p_theme_id=>42
,p_name=>'CIRCULAR'
,p_display_name=>'Circular'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(12495546789751880176)
,p_css_classes=>'t-BadgeList--circular'
,p_group_id=>wwv_flow_imp.id(9805776572536008)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495546805795880177)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495547078982880177)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495547291189880177)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495547450629880177)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495547619235880177)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495547810758880177)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495548064828880179)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495548253342880179)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495548550946880181)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495548643163880181)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495548813608880181)
,p_theme_id=>42
,p_name=>'STACK'
,p_display_name=>'Stack'
,p_display_sequence=>5
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--stack'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495549082909880182)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495549202810880182)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495549401073880182)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495549638385880182)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--large force-fa-lg'
,p_group_id=>wwv_flow_imp.id(9834559519536014)
,p_template_types=>'REPORT'
,p_help_text=>'Increases the size of the text and icons in the list.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495550050952880182)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--iconsSquare'
,p_group_id=>wwv_flow_imp.id(9832143653536013)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495550295458880184)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--iconsRounded'
,p_group_id=>wwv_flow_imp.id(9832143653536013)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495550474540880184)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495550606866880184)
,p_theme_id=>42
,p_name=>'5_COLUMN_GRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495550824129880184)
,p_theme_id=>42
,p_name=>'4_COLUMN_GRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495551080312880184)
,p_theme_id=>42
,p_name=>'3_COLUMN_GRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495551282235880184)
,p_theme_id=>42
,p_name=>'2_COLUMN_GRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495551502649880184)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495551602804880184)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(12495551963420880184)
,p_css_classes=>'t-Timeline--compact'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
,p_help_text=>'Displays a compact version of timeline with smaller text and fewer columns.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495552079578880184)
,p_theme_id=>42
,p_name=>'STYLE_COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--styleCompact'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
,p_help_text=>'This option reduces the padding and font sizes to present a compact display of the same information.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495552209678880184)
,p_theme_id=>42
,p_name=>'TITLE_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--hideTitle'
,p_group_id=>wwv_flow_imp.id(9828512836536013)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Title from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495552617879880184)
,p_theme_id=>42
,p_name=>'SELECTION_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--hideSelection'
,p_group_id=>wwv_flow_imp.id(9829786231536013)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Selection column from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495553009304880184)
,p_theme_id=>42
,p_name=>'MISC_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--hideMisc'
,p_group_id=>wwv_flow_imp.id(9829366703536013)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Misc column from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495553414079880185)
,p_theme_id=>42
,p_name=>'ICON_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--hideIcon'
,p_group_id=>wwv_flow_imp.id(9828922746536013)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Icon from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495553881941880185)
,p_theme_id=>42
,p_name=>'DESCRIPTION_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--hideDescription'
,p_group_id=>wwv_flow_imp.id(9828174990536012)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Description from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495554229884880185)
,p_theme_id=>42
,p_name=>'ACTIONS_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--hideActions'
,p_group_id=>wwv_flow_imp.id(9827762035536012)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Actions column from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495554636875880185)
,p_theme_id=>42
,p_name=>'ALIGNMENT_TOP'
,p_display_name=>'Top'
,p_display_sequence=>100
,p_report_template_id=>wwv_flow_imp.id(12495555143782880187)
,p_css_classes=>'t-ContentRow--alignTop'
,p_group_id=>wwv_flow_imp.id(9830535197536013)
,p_template_types=>'REPORT'
,p_help_text=>'Aligns the content to the top of the row. This is useful when you expect that yours rows will vary in height (e.g. some rows will have longer descriptions than others).'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495555228129880187)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495555496496880187)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495555611131880187)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495555816095880187)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495556005155880187)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495556214683880187)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495556449860880187)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495556655999880187)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495557168323880188)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_imp.id(9832513543536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495557231685880188)
,p_theme_id=>42
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(9833739543536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495557458025880188)
,p_theme_id=>42
,p_name=>'STRETCHREPORT'
,p_display_name=>'Stretch Report'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--stretch'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495557699371880188)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(9825723263536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495557860589880188)
,p_theme_id=>42
,p_name=>'ROWHIGHLIGHTDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--rowHighlightOff'
,p_group_id=>wwv_flow_imp.id(9834174173536014)
,p_template_types=>'REPORT'
,p_help_text=>'Disable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495558081907880188)
,p_theme_id=>42
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(9834174173536014)
,p_template_types=>'REPORT'
,p_help_text=>'Enable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495558478229880188)
,p_theme_id=>42
,p_name=>'REMOVEALLBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(9833739543536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495558619467880190)
,p_theme_id=>42
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'No Outer Borders'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--inline'
,p_group_id=>wwv_flow_imp.id(9833739543536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495558807878880190)
,p_theme_id=>42
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(9833739543536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495559298261880190)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495559701953880190)
,p_css_classes=>'t-Report--altRowsDefault'
,p_group_id=>wwv_flow_imp.id(9825723263536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495560094146880192)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495561145534880193)
,p_css_classes=>'t-Comments--iconsSquare'
,p_group_id=>wwv_flow_imp.id(9832143653536013)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495560283734880192)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495561145534880193)
,p_css_classes=>'t-Comments--iconsRounded'
,p_group_id=>wwv_flow_imp.id(9832143653536013)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495560498971880192)
,p_theme_id=>42
,p_name=>'SPEECH_BUBBLES'
,p_display_name=>'Speech Bubbles'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495561145534880193)
,p_css_classes=>'t-Comments--chat'
,p_group_id=>wwv_flow_imp.id(9830134773536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495560650598880192)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495561145534880193)
,p_css_classes=>'t-Comments--basic'
,p_group_id=>wwv_flow_imp.id(9830134773536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495561206143880193)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495561439726880193)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495561697325880193)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--iconsSquare'
,p_group_id=>wwv_flow_imp.id(9832143653536013)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495561825119880193)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--iconsRounded'
,p_group_id=>wwv_flow_imp.id(9832143653536013)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495562203691880193)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_imp.id(9826911596536012)
,p_template_types=>'REPORT'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495562438492880193)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495562621910880193)
,p_theme_id=>42
,p_name=>'BLOCK'
,p_display_name=>'Block'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--featured t-Cards--block force-fa-lg'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495562862622880193)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--featured force-fa-lg'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495563097453880193)
,p_theme_id=>42
,p_name=>'DISPLAY_SUBTITLE'
,p_display_name=>'Display Subtitle'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--displaySubtitle'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495563252910880193)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_imp.id(9831714164536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495563404221880193)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_imp.id(9831714164536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495563865852880198)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_imp.id(9826911596536012)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495564063832880198)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_imp.id(9826911596536012)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495564226052880198)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_imp.id(9826911596536012)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495564645096880198)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495564841403880198)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>15
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495565030673880199)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495565255452880199)
,p_theme_id=>42
,p_name=>'CARD_RAISE_CARD'
,p_display_name=>'Raise Card'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--animRaiseCard'
,p_group_id=>wwv_flow_imp.id(9826106602536012)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495565419981880201)
,p_theme_id=>42
,p_name=>'CARDS_COLOR_FILL'
,p_display_name=>'Color Fill'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--animColorFill'
,p_group_id=>wwv_flow_imp.id(9826106602536012)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495565867405880201)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495566092868880201)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495566224806880201)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495566507385880202)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495566611054880202)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495566844954880202)
,p_theme_id=>42
,p_name=>'128PX'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(9826559969536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495567097788880202)
,p_theme_id=>42
,p_name=>'96PX'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(9826559969536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495567254741880202)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495567477733880202)
,p_theme_id=>42
,p_name=>'32PX'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(9826559969536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495567657760880202)
,p_theme_id=>42
,p_name=>'48PX'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(9826559969536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495567871477880204)
,p_theme_id=>42
,p_name=>'64PX'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(9826559969536012)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495568299015880204)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495568492129880204)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495568617845880204)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495568891525880204)
,p_theme_id=>42
,p_name=>'GRID'
,p_display_name=>'Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--dash'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495569022701880204)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495569282312880204)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495569490227880204)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495569638054880204)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(9832956204536013)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495570041442880206)
,p_theme_id=>42
,p_name=>'CIRCULAR'
,p_display_name=>'Circular'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(12495570578125880206)
,p_css_classes=>'t-BadgeList--circular'
,p_group_id=>wwv_flow_imp.id(9834947869536014)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495570856484880213)
,p_theme_id=>42
,p_name=>'SHOW_TITLE'
,p_display_name=>'Show Title'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_css_classes=>'t-Wizard--showTitle'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495571036749880213)
,p_theme_id=>42
,p_name=>'HIDEXSMALLSCREENS'
,p_display_name=>'X Small Screens (Mobile)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_css_classes=>'t-Wizard--hideStepsXSmall'
,p_group_id=>wwv_flow_imp.id(9816501219536010)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495571238093880213)
,p_theme_id=>42
,p_name=>'HIDESMALLSCREENS'
,p_display_name=>'Small Screens (Tablet)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495572013166880213)
,p_css_classes=>'t-Wizard--hideStepsSmall'
,p_group_id=>wwv_flow_imp.id(9816501219536010)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495572105966880218)
,p_theme_id=>42
,p_name=>'REGION_HEADER_VISIBLE'
,p_display_name=>'Use Region Title'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_css_classes=>'t-BreadcrumbRegion--useRegionTitle'
,p_group_id=>wwv_flow_imp.id(9823311984536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495572339255880218)
,p_theme_id=>42
,p_name=>'GET_TITLE_FROM_BREADCRUMB'
,p_display_name=>'Use Current Breadcrumb Entry'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_css_classes=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_group_id=>wwv_flow_imp.id(9823311984536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495572592954880218)
,p_theme_id=>42
,p_name=>'HIDE_BREADCRUMB'
,p_display_name=>'Show Breadcrumbs'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_css_classes=>'t-BreadcrumbRegion--showBreadcrumb'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495572740683880218)
,p_theme_id=>42
,p_name=>'USE_COMPACT_STYLE'
,p_display_name=>'Use Compact Style'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495573047450880221)
,p_css_classes=>'t-BreadcrumbRegion--compactTitle'
,p_template_types=>'REGION'
,p_help_text=>'Uses a compact style for the breadcrumbs.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495573199090880221)
,p_theme_id=>42
,p_name=>'TABS_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_css_classes=>'t-TabsRegion-mod--small'
,p_group_id=>wwv_flow_imp.id(9824545847536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495573394794880221)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_css_classes=>'t-TabsRegion-mod--simple'
,p_group_id=>wwv_flow_imp.id(9824953271536012)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495573516866880223)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_css_classes=>'t-TabsRegion-mod--pill'
,p_group_id=>wwv_flow_imp.id(9824953271536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495573968526880223)
,p_theme_id=>42
,p_name=>'TABSLARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_css_classes=>'t-TabsRegion-mod--large'
,p_group_id=>wwv_flow_imp.id(9824545847536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495574354715880223)
,p_theme_id=>42
,p_name=>'FILL_TAB_LABELS'
,p_display_name=>'Fill Tab Labels'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_css_classes=>'t-TabsRegion-mod--fillLabels'
,p_group_id=>wwv_flow_imp.id(9820952812536011)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495574742904880223)
,p_theme_id=>42
,p_name=>'REMEMBER_ACTIVE_TAB'
,p_display_name=>'Remember Active Tab'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495575615770880223)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495575725402880223)
,p_theme_id=>42
,p_name=>'TEXT_CONTENT'
,p_display_name=>'Text Content'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--textContent'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Useful for displaying primarily text-based content, such as FAQs and more.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495575977296880223)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495576186628880224)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495576355854880224)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_imp.id(9811324869536009)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495576597046880224)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--removeHeader js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(9815315975536010)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495576768921880227)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495576991918880227)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495577170820880227)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495577347312880227)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(9815315975536010)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495577502198880229)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_imp.id(9811324869536009)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495577776616880229)
,p_theme_id=>42
,p_name=>'ACCENT_9'
,p_display_name=>'Accent 9'
,p_display_sequence=>90
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent9'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495577921451880229)
,p_theme_id=>42
,p_name=>'ACCENT_8'
,p_display_name=>'Accent 8'
,p_display_sequence=>80
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent8'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495578113952880229)
,p_theme_id=>42
,p_name=>'ACCENT_7'
,p_display_name=>'Accent 7'
,p_display_sequence=>70
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent7'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495578398557880229)
,p_theme_id=>42
,p_name=>'ACCENT_6'
,p_display_name=>'Accent 6'
,p_display_sequence=>60
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent6'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495578544998880229)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495578754356880229)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495578954875880229)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495579129499880229)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495579307653880232)
,p_theme_id=>42
,p_name=>'ACCENT_15'
,p_display_name=>'Accent 15'
,p_display_sequence=>150
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent15'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495579573857880232)
,p_theme_id=>42
,p_name=>'ACCENT_14'
,p_display_name=>'Accent 14'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent14'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495579715347880232)
,p_theme_id=>42
,p_name=>'ACCENT_13'
,p_display_name=>'Accent 13'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent13'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495579929707880232)
,p_theme_id=>42
,p_name=>'ACCENT_12'
,p_display_name=>'Accent 12'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent12'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495580137758880232)
,p_theme_id=>42
,p_name=>'ACCENT_11'
,p_display_name=>'Accent 11'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent11'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495580348451880232)
,p_theme_id=>42
,p_name=>'ACCENT_10'
,p_display_name=>'Accent 10'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent10'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495580551726880232)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495580728391880232)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495580993132880232)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495581167369880232)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495581302495880232)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495581521331880232)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495582446800880234)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495582533658880234)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER_TITLE'
,p_display_name=>'Title'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_css_classes=>'t-Login-region--headerTitle js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(9821307237536011)
,p_template_types=>'REGION'
,p_help_text=>'Displays only the Region Title in the Login region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495582752894880234)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER_ICON'
,p_display_name=>'Icon'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_css_classes=>'t-Login-region--headerIcon'
,p_group_id=>wwv_flow_imp.id(9821307237536011)
,p_template_types=>'REGION'
,p_help_text=>'Displays only the Region Icon in the Login region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495582942876880235)
,p_theme_id=>42
,p_name=>'LOGO_HEADER_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495583796584880235)
,p_css_classes=>'t-Login-region--headerHidden js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(9821307237536011)
,p_template_types=>'REGION'
,p_help_text=>'Hides both the Region Icon and Title from the Login region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495583800483880235)
,p_theme_id=>42
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_css_classes=>'t-IRR-region--noBorders'
,p_template_types=>'REGION'
,p_help_text=>'Removes borders around the Interactive Report'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495584057238880235)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495584334308880235)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Interactive Reports toolbar to maximize the report. Clicking this button will toggle the maximize state and stretch the report to fill the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495584485392880235)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495584616124880235)
,p_theme_id=>42
,p_name=>'INSIDE'
,p_display_name=>'Inside'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-pos-inside'
,p_group_id=>wwv_flow_imp.id(9812522421536010)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout inside of the parent. This is useful when the parent is sufficiently large, such as a report or large region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495584857677880235)
,p_theme_id=>42
,p_name=>'BELOW'
,p_display_name=>'Below'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-pos-below'
,p_group_id=>wwv_flow_imp.id(9812522421536010)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout below or typically to the bottom of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495585053174880235)
,p_theme_id=>42
,p_name=>'BEFORE'
,p_display_name=>'Before'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-pos-before'
,p_group_id=>wwv_flow_imp.id(9812522421536010)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout before or typically to the left of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495585269207880237)
,p_theme_id=>42
,p_name=>'AFTER'
,p_display_name=>'After'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-pos-after'
,p_group_id=>wwv_flow_imp.id(9812522421536010)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout after or typically to the right of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495585485182880237)
,p_theme_id=>42
,p_name=>'ABOVE'
,p_display_name=>'Above'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-pos-above'
,p_group_id=>wwv_flow_imp.id(9812522421536010)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout above or typically on top of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495585866516880237)
,p_theme_id=>42
,p_name=>'REMOVE_PAGE_OVERLAY'
,p_display_name=>'Remove Page Overlay'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-noOverlay'
,p_template_types=>'REGION'
,p_help_text=>'This option will display the inline dialog without an overlay on the background.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495586067630880237)
,p_theme_id=>42
,p_name=>'DISPLAY_POPUP_CALLOUT'
,p_display_name=>'Display Popup Callout'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-popup-callout'
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add display a callout for the popup. Note that callout will only be displayed if the data-parent-element custom attribute is defined.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495586216074880237)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495586421524880237)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495586693891880237)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495586831251880238)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495587038684880238)
,p_theme_id=>42
,p_name=>'AUTO_HEIGHT_INLINE_DIALOG'
,p_display_name=>'Auto Height'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495587659835880238)
,p_css_classes=>'js-dialog-autoheight'
,p_template_types=>'REGION'
,p_help_text=>'This option will set the height of the dialog to fit its contents.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495587746569880238)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the hero region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495587930547880238)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--iconsSquare'
,p_group_id=>wwv_flow_imp.id(9816921552536011)
,p_template_types=>'REGION'
,p_help_text=>'The icons are displayed within a square.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495588149653880238)
,p_theme_id=>42
,p_name=>'ICONS_CIRCULAR'
,p_display_name=>'Circle'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--iconsCircle'
,p_group_id=>wwv_flow_imp.id(9816921552536011)
,p_template_types=>'REGION'
,p_help_text=>'The icons are displayed within a circle.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495588544046880238)
,p_theme_id=>42
,p_name=>'DISPLAY_ICON_NO'
,p_display_name=>'No'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--hideIcon'
,p_group_id=>wwv_flow_imp.id(9814507929536010)
,p_template_types=>'REGION'
,p_help_text=>'Hide the Hero Region icon.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495588912806880238)
,p_theme_id=>42
,p_name=>'STACKED_FEATURED'
,p_display_name=>'Stacked Featured'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--featured t-HeroRegion--centered'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495589129431880238)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495589722092880240)
,p_css_classes=>'t-HeroRegion--featured'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495589837707880240)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495590016112880242)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495590250587880242)
,p_theme_id=>42
,p_name=>'SHOW_NEXT_AND_PREVIOUS_BUTTONS'
,p_display_name=>'Show Next and Previous Buttons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--showCarouselControls'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495590497429880242)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_imp.id(9811324869536009)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495590648586880242)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--removeHeader'
,p_group_id=>wwv_flow_imp.id(9815315975536010)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495590877434880242)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495591043524880243)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495591219314880243)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(9815315975536010)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495591631366880243)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_imp.id(9811324869536009)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495591890082880243)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--carouselSpin'
,p_group_id=>wwv_flow_imp.id(9810502001536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495592067407880243)
,p_theme_id=>42
,p_name=>'SLIDE'
,p_display_name=>'Slide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--carouselSlide'
,p_group_id=>wwv_flow_imp.id(9810502001536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495592443791880243)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495592668696880243)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495592834823880243)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495593039880880243)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495593267359880243)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495593431587880243)
,p_theme_id=>42
,p_name=>'REMEMBER_CAROUSEL_SLIDE'
,p_display_name=>'Remember Carousel Slide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495593613282880243)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495593829090880243)
,p_theme_id=>42
,p_name=>'5_SECONDS'
,p_display_name=>'5 Seconds'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'js-cycle5s'
,p_group_id=>wwv_flow_imp.id(9825351092536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495594095497880243)
,p_theme_id=>42
,p_name=>'20_SECONDS'
,p_display_name=>'20 Seconds'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'js-cycle20s'
,p_group_id=>wwv_flow_imp.id(9825351092536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495594285476880243)
,p_theme_id=>42
,p_name=>'15_SECONDS'
,p_display_name=>'15 Seconds'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'js-cycle15s'
,p_group_id=>wwv_flow_imp.id(9825351092536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495594466484880245)
,p_theme_id=>42
,p_name=>'10_SECONDS'
,p_display_name=>'10 Seconds'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'js-cycle10s'
,p_group_id=>wwv_flow_imp.id(9825351092536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495594805504880245)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495595094074880245)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495595287841880245)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495595452102880245)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495596329535880246)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495596416603880246)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495596673454880246)
,p_theme_id=>42
,p_name=>'SHADOW_BACKGROUND'
,p_display_name=>'Shadow Background'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--shadowBG'
,p_group_id=>wwv_flow_imp.id(9812128850536010)
,p_template_types=>'REGION'
,p_help_text=>'Gives the region body a slightly darker background.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495596860070880246)
,p_theme_id=>42
,p_name=>'ADD_BODY_PADDING'
,p_display_name=>'Add Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--padded'
,p_template_types=>'REGION'
,p_help_text=>'Adds padding to the region''s body container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495597072713880246)
,p_theme_id=>42
,p_name=>'LIGHT_BACKGROUND'
,p_display_name=>'Light Background'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--lightBG'
,p_group_id=>wwv_flow_imp.id(9812128850536010)
,p_template_types=>'REGION'
,p_help_text=>'Gives the region body a slightly lighter background.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495597488495880246)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H3'
,p_display_name=>'Small'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--h3'
,p_group_id=>wwv_flow_imp.id(9823311984536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495597661960880246)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H2'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--h2'
,p_group_id=>wwv_flow_imp.id(9823311984536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495597823652880248)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H1'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495598315850880248)
,p_css_classes=>'t-ContentBlock--h1'
,p_group_id=>wwv_flow_imp.id(9823311984536012)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495598458885880248)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495598655818880248)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_imp.id(9811324869536009)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495598807938880251)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495599019151880251)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495599221282880256)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495599460439880256)
,p_theme_id=>42
,p_name=>'ICONS_PLUS_OR_MINUS'
,p_display_name=>'Plus or Minus'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--hideShowIconsMath'
,p_group_id=>wwv_flow_imp.id(9812912792536010)
,p_template_types=>'REGION'
,p_help_text=>'Use the plus and minus icons for the expand and collapse button.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495599896207880256)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_imp.id(9811324869536009)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495600257183880256)
,p_theme_id=>42
,p_name=>'CONRTOLS_POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--controlsPosEnd'
,p_group_id=>wwv_flow_imp.id(9813366672536010)
,p_template_types=>'REGION'
,p_help_text=>'Position the expand / collapse button to the end of the region header.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495600653844880256)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495600845620880256)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495601099083880256)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495601297358880256)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495601469175880257)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_imp.id(9808594480536009)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495601865143880257)
,p_theme_id=>42
,p_name=>'REMEMBER_COLLAPSIBLE_STATE'
,p_display_name=>'Remember Collapsible State'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
,p_help_text=>'This option saves the current state of the collapsible region for the duration of the session.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495602012675880257)
,p_theme_id=>42
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(9813755212536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495602261238880257)
,p_theme_id=>42
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(9813755212536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495602646850880257)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 640px.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495602889079880257)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 480px.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495603000093880257)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495603220585880257)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495604368136880259)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_imp.id(9810956252536009)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495604444412880259)
,p_theme_id=>42
,p_name=>'STICK_TO_BOTTOM'
,p_display_name=>'Stick to Bottom for Mobile'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_css_classes=>'t-ButtonRegion--stickToBottom'
,p_template_types=>'REGION'
,p_help_text=>'This will position the button container region to the bottom of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495604689788880259)
,p_theme_id=>42
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_css_classes=>'t-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(9811727359536010)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495604824313880259)
,p_theme_id=>42
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>4
,p_region_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_css_classes=>'t-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495605059156880259)
,p_theme_id=>42
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_css_classes=>'t-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(9811727359536010)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495605468649880260)
,p_theme_id=>42
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495606500823880260)
,p_css_classes=>'t-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(9824116708536012)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495606658903880260)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495606813623880260)
,p_theme_id=>42
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495607098214880260)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495607234997880262)
,p_theme_id=>42
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495607450254880262)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495607646016880262)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495607815474880262)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(9814102179536010)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495608262473880262)
,p_theme_id=>42
,p_name=>'AUTO_HEIGHT_INLINE_DIALOG'
,p_display_name=>'Auto Height'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495608896288880263)
,p_css_classes=>'js-dialog-autoheight'
,p_template_types=>'REGION'
,p_help_text=>'This option will set the height of the dialog to fit its contents.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495609999660880263)
,p_theme_id=>42
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(9808960275536009)
,p_template_types=>'REGION'
,p_help_text=>'Show the alert in a wizard style region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495610108226880268)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--warning'
,p_group_id=>wwv_flow_imp.id(9810125402536009)
,p_template_types=>'REGION'
,p_help_text=>'Show a warning alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495610303047880268)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--success'
,p_group_id=>wwv_flow_imp.id(9810125402536009)
,p_template_types=>'REGION'
,p_help_text=>'Show success alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495610521728880268)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--removeHeading js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(9809758623536009)
,p_template_types=>'REGION'
,p_help_text=>'Hides the Alert Title from being displayed.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495610721345880268)
,p_theme_id=>42
,p_name=>'HIDE_ICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--noIcon'
,p_group_id=>wwv_flow_imp.id(9809363190536009)
,p_template_types=>'REGION'
,p_help_text=>'Hides alert icons'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495610967418880268)
,p_theme_id=>42
,p_name=>'INFORMATION'
,p_display_name=>'Information'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--info'
,p_group_id=>wwv_flow_imp.id(9810125402536009)
,p_template_types=>'REGION'
,p_help_text=>'Show informational alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495611165937880268)
,p_theme_id=>42
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(9808960275536009)
,p_template_types=>'REGION'
,p_help_text=>'Show horizontal alert with buttons to the right.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495611577386880271)
,p_theme_id=>42
,p_name=>'USEDEFAULTICONS'
,p_display_name=>'Show Default Icons'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--defaultIcons'
,p_group_id=>wwv_flow_imp.id(9809363190536009)
,p_template_types=>'REGION'
,p_help_text=>'Uses default icons for alert types.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495611707140880271)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--danger'
,p_group_id=>wwv_flow_imp.id(9810125402536009)
,p_template_types=>'REGION'
,p_help_text=>'Show an error or danger alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495612123859880271)
,p_theme_id=>42
,p_name=>'SHOW_CUSTOM_ICONS'
,p_display_name=>'Show Custom Icons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--customIcons'
,p_group_id=>wwv_flow_imp.id(9809363190536009)
,p_template_types=>'REGION'
,p_help_text=>'Set custom icons by modifying the Alert Region''s Icon CSS Classes property.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495612589926880273)
,p_theme_id=>42
,p_name=>'COLOREDBACKGROUND'
,p_display_name=>'Highlight Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--colorBG'
,p_template_types=>'REGION'
,p_help_text=>'Set alert background color to that of the alert type (warning, success, etc.)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495612726392880274)
,p_theme_id=>42
,p_name=>'HIDDENHEADER'
,p_display_name=>'Hidden but Accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(12495613507239880288)
,p_css_classes=>'t-Alert--accessibleHeading'
,p_group_id=>wwv_flow_imp.id(9809758623536009)
,p_template_types=>'REGION'
,p_help_text=>'Visually hides the alert title, but assistive technologies can still read it.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495613643163880290)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(12495616037696880296)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495616119590880296)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(12495618547053880299)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495618656086880299)
,p_theme_id=>42
,p_name=>'STRETCH_TO_FIT_WINDOW'
,p_display_name=>'Stretch to Fit Window'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(12495620021366880299)
,p_css_classes=>'ui-dialog--stretch'
,p_template_types=>'PAGE'
,p_help_text=>'Stretch the dialog to fit the browser window.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495618865060880299)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(12495620021366880299)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495620104205880299)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(12495622898900880302)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495622952146880302)
,p_theme_id=>42
,p_name=>'STRETCH_TO_FIT_WINDOW'
,p_display_name=>'Stretch to Fit Window'
,p_display_sequence=>1
,p_page_template_id=>wwv_flow_imp.id(12495624331342880306)
,p_css_classes=>'ui-dialog--stretch'
,p_template_types=>'PAGE'
,p_help_text=>'Stretch the dialog to fit the browser window.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495623136658880304)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(12495624331342880306)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495624497392880306)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(12495627437383880309)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495627533213880309)
,p_theme_id=>42
,p_name=>'PAGE_LAYOUT_SPLIT'
,p_display_name=>'Split'
,p_display_sequence=>1
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_css_classes=>'t-LoginPage--split'
,p_group_id=>wwv_flow_imp.id(9807715570536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495627901544880309)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_3'
,p_display_name=>'Background 3'
,p_display_sequence=>30
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_css_classes=>'t-LoginPage--bg3'
,p_group_id=>wwv_flow_imp.id(9807388278536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495628133484880309)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_2'
,p_display_name=>'Background 2'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_css_classes=>'t-LoginPage--bg2'
,p_group_id=>wwv_flow_imp.id(9807388278536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495628369896880310)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_1'
,p_display_name=>'Background 1'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(12495629732925880320)
,p_css_classes=>'t-LoginPage--bg1'
,p_group_id=>wwv_flow_imp.id(9807388278536009)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495629830445880320)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(12495632827206880321)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(12495632933480880329)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(12495635610083880376)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(2717958559026966)
,p_translation_flow_id=>100006
,p_translation_flow_language_cd=>'it'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(5648198079050972)
,p_translation_flow_id=>100007
,p_translation_flow_language_cd=>'ko'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(5672514122653306)
,p_translation_flow_id=>100008
,p_translation_flow_language_cd=>'zh-tw'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(5672660075655263)
,p_translation_flow_id=>100009
,p_translation_flow_language_cd=>'zh-cn'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(9033928420999483)
,p_translation_flow_id=>100001
,p_translation_flow_language_cd=>'fr'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(53002706255554766)
,p_translation_flow_id=>100002
,p_translation_flow_language_cd=>'pt-br'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(53002824512556233)
,p_translation_flow_id=>100003
,p_translation_flow_language_cd=>'ja'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(53913409405549240)
,p_translation_flow_id=>100004
,p_translation_flow_language_cd=>'de'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(65314222214861109)
,p_translation_flow_id=>100005
,p_translation_flow_language_cd=>'es'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/globalization/translations
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11530051096415053)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>6.100009
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11530144398415054)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>50.100009
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11530374565415054)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>14.100009
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\5FD7')
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11530526077415054)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>51.100009
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7F16\8F91\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11530749869415054)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>1.100009
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5165\95E8')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11530991960415054)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>7.100009
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B')
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11531155961415054)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>15.100009
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\7EDF\8BA1')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11531361072415055)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>31.100009
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - REST - \5BA2\6237\7AEF')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11531569247415055)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>36.100009
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BA1\65F6\5668')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11531723644415055)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>34.100009
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5F15\64CE\5E94\7528\7A0B\5E8F')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11531929722415055)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>11.100009
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11532173398415055)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>30.100009
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11532346254415055)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>2.100009
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11532516852415055)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>8.100009
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5B9E\4F8B\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11532782114415055)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>12.100009
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\67E5\770B\8005')
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11532930075415055)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>17.100009
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52A1\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11533101032415055)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>37.100009
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11533341336415055)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>4.100009
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5EFA\6A21\5668')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11533546620415056)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>5.100009
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11533775874415056)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>10.100009
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76D1\89C6\5668')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11533998538415056)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>35.100009
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5F15\64CE')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11534106439415056)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>33.100009
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5F52\6863')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11534325719415056)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>3.100009
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EEA\8868\76D8')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11534576567415056)
,p_page_id=>9
,p_translated_flow_id=>100009
,p_translate_to_id=>9.100009
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11534701506415056)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>20.100009
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\65F6\95F4\8868 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11534910410415056)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>38.100009
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5730\70B9')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11535114401415056)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>13.100009
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\8C61\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11535350407415056)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>39.100009
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BB8\53EF\8BC1')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11535578286415056)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>16.100009
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FDB\7A0B\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11535777397415056)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>32.100009
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BB0\5F55')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11535944794415056)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>100.100009
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E [OLD\FF0CBACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11536136094415057)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>9999.100009
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\5F55\9875\9762')
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11536322419415058)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>6.100009
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11536509073415059)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>50.100009
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11536745001415059)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>51.100009
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7F16\8F91\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11536955455415059)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>1.100009
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5165\95E8 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11537123607415059)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>7.100009
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11537351229415059)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>15.100009
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\7EDF\8BA1')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11537572710415059)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>31.100009
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - REST - \5BA2\6237\7AEF')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11537737200415059)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>36.100009
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BA1\65F6\5668')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11537911010415059)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>34.100009
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5F15\64CE\5E94\7528\7A0B\5E8F')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11538163369415059)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>11.100009
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\6D41\7A0B\5B9E\4F8B - &APP_NAME_TITLE.')
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11538341308415059)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>30.100009
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11538521566415059)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>2.100009
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11538757625415059)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>8.100009
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5B9E\4F8B\8BE6\7EC6\8D44\6599 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11538928852415059)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>12.100009
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76D1\63A7\7A0B\5E8F - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11539172354415059)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>17.100009
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52A1\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11539336141415059)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>37.100009
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11539505558415059)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>4.100009
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5EFA\6A21\5668 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11539762338415059)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>5.100009
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\51FA - &APP_NAME_TITLE.')
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11539981904415059)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>10.100009
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76D1\63A7\7A0B\5E8F - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11540109208415060)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>35.100009
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5F15\64CE')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11540392022415060)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>33.100009
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5F52\6863')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11540548556415060)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>3.100009
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EEA\8868\76D8 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11540775058415060)
,p_page_id=>9
,p_translated_flow_id=>100009
,p_translate_to_id=>9.100009
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11540958036415060)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>20.100009
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\65F6\95F4\8868 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11541104969415060)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>38.100009
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \5730\70B9')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11541356742415060)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>39.100009
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BB8\53EF\8BC1')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11541556270415060)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>16.100009
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FDB\7A0B\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11541775007415060)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>32.100009
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BB0\5F55')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11541970612415060)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>100.100009
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E [OLD\FF0CBACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11542123341415060)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>9999.100009
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11542355720415067)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100009)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5168\9009')
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11542536874415067)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100009)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BBE\7F6E\7F51\5173\8DEF\7531')
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11542707308415068)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100009)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11542956238415068)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100009)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11543179338415068)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11543305337415068)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100009)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88\5168\9009')
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11543579557415068)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\52A0')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11543744068415068)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100009)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BBE\7F6E\6D41\7A0B\53D8\91CF')
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11543901743415068)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100009)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11544135807415068)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100009)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \914D\7F6E')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11544338783415068)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11544504612415068)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100009)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165\5E76\7F16\8F91')
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11544739005415068)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100009)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA')
,p_translate_from_text=>'Create'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11544971042415068)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100009)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11545106403415069)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11545376682415069)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100009)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11545531694415069)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11545730275415069)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63A5\6536\6D88\606F')
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11545938760415069)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100009)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11546146200415069)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100009)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11546320653415069)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11546545845415069)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100009)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11546785371415069)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100009)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11546911318415069)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100009)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\6A21\578B')
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11547174674415069)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100009)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11547383626415069)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100009)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\5B58')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11547598305415070)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100009)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11547729186415070)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100009)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165\5E76\5BFC\5165\53E6\4E00\4E2A')
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11547950075415070)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100009)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11548169574415070)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\590D\5236\6A21\578B')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11548356002415070)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100009)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11548568638415070)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100009)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11548707876415070)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\5F55')
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11548901283415070)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100009)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11549115927415070)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100009)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \914D\7F6E')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11549316344415070)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D1\5E03')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11549583847415070)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\6A21\677F')
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11549760691415070)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100009)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FEE\6539\56FE\8868')
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11549984115415070)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100009)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11550132291415070)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100009)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\52A0\7248\672C')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11550376705415071)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11550576247415071)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11550709210415071)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100009)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11550999083415071)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B58\6863')
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11551127549415071)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11551300674415071)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100009)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11551560472415071)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100009)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11551721331415071)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100009)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11551976496415071)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11552146677415071)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100009)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11552301584415071)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100009)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11552555515415071)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\5B9E\4F8B')
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11552711298415071)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100009)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11552938764415071)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100009)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11553128103415071)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100009)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11553353386415071)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100009)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11553578786415071)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100009)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11553737847415071)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F03\7528')
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11553964029415071)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11554133058415072)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100009)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\52A0\7248\672C')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11554378720415072)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100009)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11554545925415072)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7F16\8F91\914D\7F6E')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11554795754415072)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100009)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11554967400415072)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\66F4\6539')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11555183671415072)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\8BA1\5212\8BA1\65F6\5668')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11555367720415072)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11555554153415072)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100009)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11555790738415072)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100009)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\786E\8BA4')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11555949239415072)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100009)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7F16\8F91\914D\7F6E')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11556157060415072)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100009)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\52A0')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11556399608415072)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100009)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11556533392415072)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100009)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11556729761415072)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\786E\8BA4')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11556929094415072)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100009)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11557123133415072)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100009)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11557362649415072)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100009)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\5B58')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11557558504415074)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100009)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11557707432415076)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9690\85CF\7528\6237 ID')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11557963378415076)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID \5217')
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11558107132415076)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB8\53EF\8BC1\5BC6\94A5')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11558326500415076)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233\5217')
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11558567965415076)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57FA\672C URL')
,p_translate_from_text=>'Base URL'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11558790022415076)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100009)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11558998367415076)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6709\6548\8D1F\8F7D')
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11559116122415076)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100009)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FDE\63A5')
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11559314471415076)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11559545774415076)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11559705262415076)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\56FE\8868')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11559962654415076)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11560157115415077)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\7528\6237\540D')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11560363813415077)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11560573958415077)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11560728974415077)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\91CD\590D\95F4\9694')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11560930646415077)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\4EF6\540D')
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11561124422415077)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11561358758415077)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B58\50A8\6876\540D\79F0')
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11561598468415077)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100009)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB8\53EF\8BC1\7248\672C')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11561713566415077)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100009)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165\81EA')
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11561912982415077)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11562193439415077)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11562373460415077)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11562532292415077)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\6863\524D\7F00')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11562768695415077)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\671F')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11562904248415077)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\5EFA')
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11563180449415077)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100009)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F3A\5236\6539\5199')
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11563376423415077)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9884\8BA2')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11563567108415077)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\6700\5927\5468\671F\6570')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11563736665415078)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\522B')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11563909006415078)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11564164707415078)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6267\884C\8005')
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11564360920415078)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\540D')
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11564548297415078)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\62EC\4E0A\6B21\66F4\6539\65E5\671F')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11564750290415078)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\578B')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11564911496415078)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100009)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7F51\5173')
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11565162883415078)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\6BCF\6708\6C47\603B\FF08\6708\FF09')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11565331378415078)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D88\606F\6D41\65E5\5FD7\4FDD\7559\671F\FF08\5929\FF09\FF08\5C1A\672A\5B9E\65BD\FF09')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11565513857415078)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100009)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EA7\8054')
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11565767293415078)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100009)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11565937867415078)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7EA7\522B')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11566197220415078)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11566357959415078)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\7801')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11566519635415078)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\65E5\5FD7\FF08\5929\6570\FF09')
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11566778947415078)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11566959659415078)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\56FE\8868 XML')
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11567115242415078)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\62EC\7248\672C')
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11567319329415078)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\4EF6')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11567590364415079)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\8BA1\5212\8BA1\65F6\5668\4E8E')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11567714537415079)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\5F52\6863\4F4D\7F6E')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11567938838415079)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11568145256415079)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F7D\4E3A')
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11568372644415079)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11568512803415079)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\53D8\91CF')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11568739052415079)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BA2\6237\7AEF\5BC6\94A5')
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11568930867415079)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\590D\6B65\9AA4\9884\9632')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11569128245415079)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\540D\79F0/\540E\7F00')
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11569379733415079)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX \8EAB\4EFD\8BC1\660E\9759\6001 ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11569524626415079)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BED\8A00')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11569771988415079)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9759\6001 ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11569957204415079)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100009)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6240\6709\8005')
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11570102815415079)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB8\53EF\5BF9\8C61')
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11570331326415079)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\590D\6B65\9AA4\9884\9632')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11570546925415079)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EA7\522B')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11570704840415079)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\5E94\7528\7A0B\5E8F ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11570919441415079)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\9875\9762 ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11571167943415079)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\540D')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11571353581415079)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8303\56F4')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11571523859415080)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E1A\52A1\53C2\8003\FF08\6D41\7A0B\53D8\91CF\FF09')
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11571742281415080)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\62EC\7C7B\522B')
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11571957138415080)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\5F55\5165\7AD9 MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11572128761415080)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100009)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\6700\5927\5468\671F\6570')
,p_translate_from_text=>'Timer Max Cycles'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11572372145415080)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\6807\7C7B\578B')
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11572583403415080)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B4C\66F2')
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11572766627415080)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\5F0F')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11572949602415080)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C98\8D34 BPMN \6587\4EF6\5185\5BB9\FF08\6700\591A 30 000 \4E2A\5B57\7B26\FF09\3002')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11573132250415080)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\5DE5\4F5C\533A')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11573332458415080)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\6BCF\65E5\6C47\603B\FF08\5929\FF09')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11573529049415080)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9690\85CF\7528\6237 ID')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11573713356415080)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\5F55\5165\7AD9 MessageFlow\FF08\5C1A\672A\5B9E\65BD\FF09')
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11573958160415080)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\65E5\5FD7\FF08\6D41\7A0B\5B9E\4F8B\5B8C\6210\540E\7684\5929\6570\FF09')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11574144834415080)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\7528\6237\540D')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11574319217415080)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX \8EAB\4EFD\8BC1\660E\9759\6001 ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11574515979415080)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\542F\7528\8BA1\65F6\5668')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11574729648415080)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Blob \5217')
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11574940126415080)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100009)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB8\53EF\8BC1\5230\671F\65E5\671F')
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11575120242415080)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11575369903415081)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\5F55\4F20\5165\7684 Rest \8C03\7528')
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11575525148415081)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\5B9A\5411 URI')
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11575728417415081)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9884\6388\6743 URL')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11575916443415081)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100009)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\5F0F')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11576166722415081)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\65E5\5FD7\FF08\6D41\7A0B\5B9E\4F8B\5B8C\6210\540E\7684\5929\6570\FF09')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11576357344415081)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\652F\6301 URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11576573562415081)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\62EC\72B6\6001')
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11576749892415081)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11576953490415081)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100009)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BED\8A00')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11577131658415081)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\6863\524D\7F00')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11577392763415081)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\542F\7528\5B9E\4F8B\6982\8981\5F52\6863')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11577542683415081)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11577736274415081)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\5E94\7528\7A0B\5E8F ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11577908534415081)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11578129524415081)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100009)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\5F0F')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11578303576415081)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\4F4F\7528\6237\540D')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11578578630415081)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\578B\53F7')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11578772646415081)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\5DE5\4F5C\533A')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11578907827415081)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7ACB\5373\91CD\65B0\5B89\6392\8BA1\65F6\5668')
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11579129829415081)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D88\606F\6D41\65E5\5FD7\4FDD\7559\671F\FF08\5929\FF09')
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11579379768415081)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\578B\53F7')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11579590643415082)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF4\660E')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11579726884415082)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EA7\522B')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11579923512415082)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11580104305415082)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\5B63\5EA6\6C47\603B\FF08\6708\FF09')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11580335334415082)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D8\91CF\540D\79F0')
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11580563564415082)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BA2\6237\7AEF ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11580722186415082)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\9875\9762 ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11580915784415082)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100009)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57FA\672C URL')
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11581177195415082)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\652F\6301\90AE\7BB1')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11581362280415082)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\542F\7528\8BA1\65F6\5668')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11581545533415082)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11581764685415082)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100009)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11581944080415082)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\522B')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11582144159415082)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\641C\7D22')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11582330771415082)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100009)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11582560021415082)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\542F\7528\5B9E\4F8B\6982\8981\5F52\6863')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11582741032415082)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9ED8\8BA4\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11582980518415085)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100009)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('JSON \683C\5F0F\65E0\6548')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11583155313415085)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100009)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11583310575415085)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100009)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF7\68C0\67E5\63D0\4F9B\7684\6D41\7A0B\3002')
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11583501531415085)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\987B\5177\6709\4E00\4E9B\503C\3002')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11583716732415085)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100009)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11583931469415085)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\987B\5177\6709\4E00\4E9B\503C\3002')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11584122727415085)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E0\6CD5\5F52\6863\4E0E\6B63\5728\8FD0\884C\7684\5B9E\4F8B\5173\8054\7684\6A21\578B\3002')
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11584334549415085)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100009)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF7\7C98\8D34 BPMN \6587\4EF6\5185\5BB9')
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11584530410415085)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100009)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF7\9009\62E9 #LABEL#\3002')
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11584773038415087)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\5DF2\5B58\5728\3002\4F7F\7528\5F3A\5236\8986\76D6\3002')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11584954633415087)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\5DF2\5B58\5728\3002\4F7F\7528\5F3A\5236\8986\76D6\3002')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11585147380415088)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5BFC\5165\6A21\578B\3002')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11585312587415088)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100009)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11585530226415088)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100009)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11585725385415088)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100009)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11585908119415088)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100009)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11586158986415089)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100009)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11586378577415089)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100009)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rest \914D\7F6E\5DF2\4FDD\5B58\FF01')
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11586581117415089)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11586723478415089)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100009)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11586963653415089)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100009)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11587145241415089)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100009)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11587355503415089)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100009)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C\5DF2\5904\7406\3002')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11587533297415089)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100009)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11587721778415089)
,p_page_id=>9
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100009)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11587932586415089)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5BFC\5165\6A21\578B\3002')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11588174838415092)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100009)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B9E\4F8B\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11588332238415092)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100009)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11588532299415092)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100009)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B9E\4F8B\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11588701855415092)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100009)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B9E\4F8B\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11588948414415092)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100009)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('OAUTH \5BA2\6237\673A')
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11589195925415092)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100009)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11589360006415092)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100009)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11589548273415092)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100009)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11589787546415092)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100009)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\914D\7F6E - REST - \5BA2\6237\7AEF')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11589933984415092)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100009)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11590155241415092)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\7EE9\6548\FF08\671F\95F4\6C47\603B\FF09')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11590391627415093)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100009)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F53\524D\5B50\6D41\7A0B')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11590539063415093)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100009)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\94AE\680F')
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11590743933415093)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100009)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\53D8\91CF\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11590997329415093)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100009)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON \914D\7F6E')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11591156763415093)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100009)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8BA1\65F6\5668')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11591376904415093)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6B65\9AA4\4E8B\4EF6')
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11591543328415093)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11591726697415093)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100009)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11591956104415093)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6BCF\4E2A\72B6\6001\7684\6D41\7A0B\5B9E\4F8B\6570')
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11592140814415093)
,p_page_id=>9
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100009)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\90E8\5206')
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11592374359415093)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100009)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\6B65\9AA4')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11592504714415093)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\641C\7D22')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11592790352415093)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\56FE\8868\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11592911962415093)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D88\606F\8BA2\9605')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11593118465415093)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100009)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8C03\7528\7684\56FE\8868')
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11593340614415093)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100009)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11593571366415093)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100009)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11593751981415093)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100009)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5165\95E8')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11593954790415094)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11594182349415094)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\521B\5EFA\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11594310526415094)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100009)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7248\672C\4E0D\5339\914D')
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11594567396415094)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100009)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5BFC\5165\6D41\7A0B')
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11594724137415094)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100009)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11594966475415094)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7F3A\5C11\5148\51B3\6761\4EF6')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11595194414415094)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100009)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\94AE')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11595365612415094)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100009)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11595509802415094)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100009)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\641C\7D22\7ED3\679C')
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11595707868415094)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100009)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE\5E94\7528\7A0B\5E8F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11595922941415094)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100009)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11596115217415094)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100009)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE\5E94\7528\7A0B\5E8F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11596352247415094)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8FC7\53BB 14 \5929\5185\7684\5B9E\4F8B\9519\8BEF')
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11596591610415094)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100009)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON \914D\7F6E')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11596773605415094)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100009)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11596934566415094)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\67E5\770B\5668')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11597190686415094)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100009)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11597333690415094)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5730\70B9')
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11597558384415094)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100009)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9009\9879')
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11597753003415094)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100009)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6DFB\52A0\7F51\5173\8DEF\7531')
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11597969103415094)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100009)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8C03\7528\7684\56FE\8868')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11598127483415095)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100009)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11598357525415095)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100009)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\94FE\63A5')
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11598568036415095)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11598706813415095)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11598995375415095)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11599104945415095)
,p_page_id=>9
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100009)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11599301779415095)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7F3A\5C11\6A21\5757')
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11599594655415095)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11599720191415095)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11599947560415095)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100009)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11600162118415095)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\94AE\5BB9\5668')
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11600359978415095)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100009)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11600568590415095)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\590D\5236\6A21\578B')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11600762843415095)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4E0A\6B21\9519\8BEF')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11600909608415095)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100009)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME. \7684\5386\53F2\6B65\9AA4\7B49\5F85\65F6\95F4\3002(&P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11601196976415095)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100009)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11601302122415095)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100009)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\5B50\6D41')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11601594727415095)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100009)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F53\524D\6B65\9AA4')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11601775947415095)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\67E5\770B\5668')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11601908001415095)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100009)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8BB0\5F55')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11602189676415096)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100009)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F52\6863')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11602375243415096)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100009)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11602592517415096)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100009)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11602792338415096)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100009)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11602979731415096)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100009)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11603111430415096)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100009)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11603397089415096)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8C03\7528\56FE')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11603554711415096)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100009)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8BB8\53EF\8BC1')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11603798523415096)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11603905258415096)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100009)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11604199141415096)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100009)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11604384907415096)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\672A\542F\7528 REST')
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11604538746415096)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6807\7B7E')
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11604710563415096)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100009)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME. \7684\5386\53F2\6B65\9AA4\6027\80FD\3002( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11604990382415096)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\89D2\8272')
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11605159466415096)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100009)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5BFC\5165\8B66\544A')
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11605315535415096)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B9E\4F8B\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11605545924415096)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100009)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11605745378415096)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11605927880415097)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B9E\4F8B\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11606155291415097)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100009)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\53D8\91CF\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11606395069415097)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\914D\7F6E')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11606505544415097)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100009)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8BA1\65F6\5668')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11606756390415097)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100009)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F53\524D\903E\671F\6D41\5B9E\4F8B')
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11606915368415097)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100009)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11607151398415097)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4FE1\606F')
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11607323589415097)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100009)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11607552456415097)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11607760420415097)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100009)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11607913940415097)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100009)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\5F00\59CB\4E8E &P15_DATE\3002')
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11608161780415097)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100009)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9644\52A0\5B89\88C5\6B65\9AA4\672A\5B8C\6210')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11608368918415097)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100009)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7F16\8F91\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11608550323415097)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100009)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11608761849415097)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100009)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B9E\4F8B\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11608918620415097)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100009)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11609178671415097)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100009)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4EFB\52A1\6B65\9AA4\6027\80FD\FF08\672C\6708\FF09- &P16_DGRM_NAME_VERSION.\FF08dgrm_id\FF1A&P16_DGRM_ID.\FF09')
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11609370225415098)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6B65\9AA4\9519\8BEF')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11609550373415098)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0BXML')
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11609761334415098)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100009)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F20\5165/\8F93\51FA\53D8\91CF')
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11609960308415098)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\586B\5199\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11610110505415098)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100009)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11610363390415098)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100009)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\53D8\91CF')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11610531318415098)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100009)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11610727438415098)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100009)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11610927976415098)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100009)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6BCF\4E2A\72B6\6001\7684\5904\7406\5B9E\4F8B\6570')
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11611131855415098)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100009)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5220\9664\6A21\578B')
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11611393711415098)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100009)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11611536543415098)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9009\62E9\6D3B\52A8\76EE\6807')
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11611707226415098)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100009)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6BCF\4E2A\6A21\578B\7684\6D41\7A0B\5B9E\4F8B - \524D 10 \4E2A')
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11611989423415098)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100009)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4FDD\7559\6B65\9AA4')
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11612179077415098)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100009)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6DFB\52A0/\7F16\8F91\6D41\7A0B\53D8\91CF')
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11612369989415098)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11612587562415098)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9762\5305\5C51\5BFC\822A')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11612701713415098)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100009)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8FC7\53BB 7 \5929\5185\521B\5EFA\7684\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11612907980415098)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11613114548415098)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100009)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11613332470415099)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5DF2\7981\7528\8BA1\65F6\5668')
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11613540420415099)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100009)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11613706477415099)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\91CD\65B0\8BA1\5212\8BA1\65F6\5668')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11613963002415099)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\68C0\6D4B\5230 APEX \5347\7EA7')
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11614140603415099)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11614347842415099)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5165\95E8')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11614538317415099)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11614724860415099)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100009)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5173\8054\7684\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11614987510415099)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11615105405415099)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100009)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11615342411415099)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\76D1\89C6\5668 (&P12_PRCS_NAME)')
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11615511955415099)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8BED\8A00\9009\62E9\5668')
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11615790467415099)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100009)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\94AE')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11615906041415099)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100009)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8BB0\5F55')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11616134664415099)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\67E5\770B\5668')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11616316673415099)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11616598610415100)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\63A5\6536\6D88\606F')
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11616713551415100)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\64CD\4F5C\83DC\5355')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11616925486415100)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9519\8BEF')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11617193854415100)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5185\5BB9')
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11617395883415102)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100009)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11617531796415102)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11617779799415103)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11617958132415103)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100009)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11618106098415103)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100009)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11618379610415103)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11618588669415103)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11618705043415103)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100009)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11618980755415103)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100009)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E3A\4E86\4FBF\4E8E\4EE5\58F0\660E\65B9\5F0F\6784\5EFA\60A8\81EA\5DF1\7684\8868\5355\5B9A\4E49\FF0C\60A8\53EF\4EE5\4F7F\7528<a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">\7B80\5355\8868\5355\6784\5EFA\5668</span></a>\751F\6210\6240\9700\7684 JSON\3002')
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11619176995415103)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100009)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11619300306415103)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11619522443415103)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100009)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11619739180415104)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>REST \6A21\5757\672A\5B89\88C5\3002\8BF7\6309\7167\4EE5\4E0B\4F4D\7F6E\7684\5B89\88C5\6307\5357\FF1A<a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11619926901415104)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11620131977415104)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100009)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11620333015415104)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100009)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6211\4EEC\5EFA\8BAE\60A8\5BFC\5165\4F7F\7528 Flows for APEX \6784\5EFA\7684\6A21\578B\FF0C\4EE5\786E\4FDD\8FD9\4E9B\6A21\578B\53EF\7531\5F15\64CE\8FD0\884C\3002')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11620574498415104)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>\65B9\6848\672A\542F\7528 REST</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11620790312415104)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5728\6B64\9875\9762\4E0A\FF0C\60A8\53EF\4EE5\7BA1\7406\7B80\5355\8868\5355\6A21\677F\7684 JSON \5B9A\4E49\3002\53EF\4EE5\901A\8FC7\4E24\79CD\65B9\5F0F\4F7F\7528\60A8\7684\6A21\677F\FF1A<ul>'),
unistr('    <li>\5728\6D41\6A21\578B\4E2D\7C7B\578B\4E3A\201C\7B80\5355\8868\5355\201D\7684\7528\6237\4EFB\52A1\4E0A\9009\62E9\5B83\4EEC</li>'),
unistr('    <li>\901A\8FC7\586B\5199\8868\5355\FF0C\5728\6D41\5206\914D\4E2D\7684<strong>\7B80\5355\6D41\7A0B\542F\52A8\7A0B\5E8F\5E94\7528\7A0B\5E8F</strong>\4E2D\5229\7528\5B83\4EEC\6765\542F\52A8\6D41\7A0B\5B9E\4F8B</ul>')))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11620929593415104)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100009)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11621107094415104)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100009)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11621342856415104)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100009)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8981\4F7F\7528 Flows for APEX \7684\8BA1\65F6\5668\529F\80FD\FF0C\60A8\5FC5\987B\5B8C\6210\53EF\5728 <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank"> \6B64\5904 </a> \627E\5230\7684\5176\4ED6\5B89\88C5\6B65\9AA4\3002')
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11621553521415104)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100009)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11621764645415104)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100009)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11621957159415104)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\542B\4E00\4E2A\6216\591A\4E2A\8BA1\65F6\5668\7684\6A21\578B\65E0\6CD5\5728\6B64\7CFB\7EDF\4E0A\6B63\5E38\5DE5\4F5C\FF0C\56E0\4E3A\5B83\4EEC\5DF2\88AB\7981\7528\3002<br> \60A8\53EF\4EE5\5728\201C\914D\7F6E\201D\9875\4E2D\542F\7528\5B83\3002')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11622144159415104)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11622340232415105)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100009)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11622567768415105)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100009)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11622726845415105)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>APEX \7684\4F4E\4EE3\7801\3001\57FA\4E8E BPMN \7684\6D41\7A0B\6D41\7CFB\7EDF\3002</h3>'),
unistr('<h4> \529F\80FD</h4>'),
'<ul>',
unistr('<li>Flows for APEX \652F\6301 APEX \5F00\53D1\4EBA\5458\7ED3\5408\4F7F\7528\53EF\89C6\5316\6D41\7A0B\8BBE\8BA1\548C\4F4E\4EE3\7801\6280\672F\5728 APEX \4E2D\5EFA\6A21\548C\8FD0\884C\6D41\7A0B\6D41\3002</li>'),
unistr('<li>Flows for APEX \4E3B\8981\662F\4E3A APEX \5F00\53D1\4EBA\5458\8BBE\8BA1\7684\FF0C\5B83\4F7F\7528\60A8\5DF2\7ECF\719F\6089\7684\6280\672F\FF08APEX\3001PL/SQL \548C SQL\FF09\5728 APEX \73AF\5883\4E2D\521B\5EFA\5F3A\5927\800C\7075\6D3B\7684\6D41\7A0B\6D41\3002</li>'),
unistr('<li>\7528\4E8E\521B\5EFA\548C\6267\884C APEX \9875\9762\3001PL/SQL \811A\672C\7684\5904\7406\6D41\FF0C\53D1\9001\7535\5B50\90AE\4EF6\3002</li>'),
unistr('<li> \6B64\5916\FF0C\4E1A\52A1\7528\6237\8FD8\53EF\4EE5\7406\89E3\548C\7F16\8F91\4F4E\4EE3\7801\56FE\5F62\5316\6D41\7A0B\5B9A\4E49\FF0C\4EE5\63D0\9AD8\4E1A\52A1\7075\6D3B\6027\3002\6D41\4F7F\7528\4E1A\52A1\6D41\7A0B\5EFA\6A21\8868\793A\6CD5 (BPMN) V2 \6837\5F0F</li>'),
unistr('<li>\4F5C\4E3A APEX \793E\533A\9879\76EE\6784\5EFA\FF0C\5E76\4EE5\5F00\6E90 MIT \8BB8\53EF\8BC1\53D1\5E03\3002</li>'),
'</ul>',
'<p>',
unistr('<h4>\4E0B\8F7D</h4>'),
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a> <p>',
unistr('<h4>\6587\6863</h4>'),
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">\5728\7EBF\6700\65B0\6587\6863</a> <p>'),
unistr('<h4>BPMN \6559\7A0B</h4>'),
unistr('\8981\5F00\59CB\4F7F\7528\5EFA\6A21\6D41\FF0C\8BF7\5C1D\8BD5\9884\5B89\88C5\7684\6559\7A0B\6D41\3002\6709\5173\6559\7A0B\7684\8BE6\7EC6\4FE1\606F\FF0C\8BF7\8BBF\95EE<a href="https://flowsforapex.org/latest/tutorials/" target="_blank">\6B64\5904</a>\3002<p>'),
unistr('<h4>\6F14\793A\5E94\7528</h4>'),
'<p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11622934823415105)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100009)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11623128467415105)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11623311909415111)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100009)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \5730\70B9')
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11623563561415111)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11623737968415111)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100009)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F52\6863\4F4D\7F6E')
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11623972674415112)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11624152789415113)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100009)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11624319415415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100009)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11624586521415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100009)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11624717924415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100009)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11624970886415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100009)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5237\65B0')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11625158942415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100009)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11625382809415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100009)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\590D\5236')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11625558646415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100009)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EC8\6B62')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11625722463415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100009)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11625925877415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100009)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EC8\6B62')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11626167181415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100009)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E3B\9898')
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11626311425415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100009)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB8\53EF\8BC1')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11626519545415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100009)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EC8\6B62')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11626761309415114)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100009)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76D1\89C6\5668')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11626909610415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11627121806415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100009)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5237\65B0')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11627378398415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100009)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11627511626415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100009)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11627791199415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100009)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\52A0\65B0\7248\672C')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11627909191415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100009)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11628100468415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100009)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F7D (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11628332518415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11628538720415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100009)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\6982\8981')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11628760954415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100009)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7F16\8F91')
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11628904107415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100009)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11629186016415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100009)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11629305389415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\5B9E\4F8B\65F6\95F4\8868')
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11629529362415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100009)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11629773049415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100009)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11629921941415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100009)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5237\65B0')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11630132239415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100009)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\6A21\578B\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11630337338415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100009)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11630538887415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100009)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11630711919415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100009)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\52A0\65B0\7248\672C')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11630966122415115)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100009)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\81EA\52A8')
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11631138232415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11631366239415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100009)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE\5E94\7528\7A0B\5E8F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11631527819415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100009)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F00\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11631744508415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100009)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EEA\8868\76D8')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11631989297415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100009)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11632105162415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100009)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F52\6863')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11632397406415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100009)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11632535366415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100009)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F7D (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11632789260415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100009)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4\8BA1\65F6\5668')
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11632949102415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100009)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EE5\4E0B\62A5\544A|\5E76\6392|\65B0\7A97\53E3')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11633194146415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100009)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11633363272415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9000\51FA')
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11633554133415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100009)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11633796081415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100009)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F00\59CB\4F7F\7528')
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11633962521415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100009)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\8BA1\5212')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11634149587415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100009)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F00\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11634345948415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100009)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\8BBE\7F6E')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11634559248415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11634722016415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100009)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\5165')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11634905035415116)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100009)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11635154252415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100009)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11635382663415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100009)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\590D\5236')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11635578681415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DF1\8272\6A21\5F0F')
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11635751668415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100009)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11635961206415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100009)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11636171844415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100009)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\6A21\578B\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11636360777415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100009)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11636568183415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11636735407415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D1\5E03')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11636979989415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100009)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\8BBE\7F6E')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11637182512415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100009)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\67E5\770B\6765\6E90')
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11637386784415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100009)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\8BE6\7EC6\4FE1\606F')
,p_translate_from_text=>'Show Details'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11637593880415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100009)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11637765535415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\542F\52A8')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11637968836415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11638186647415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100009)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11638377359415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100009)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\5F55')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11638526802415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D1\5E03')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11638763593415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100009)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11638994809415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100009)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11639153442415117)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100009)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F7D (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11639348848415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100009)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BFC\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11639504675415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100009)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\67E5\770B')
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11639799391415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100009)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F00\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11639996717415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D45\6A21\5F0F')
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11640139685415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100009)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\8BA1\5212')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11640383764415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100009)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11640546881415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100009)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EE5\4E0B\62A5\544A|\5E76\6392|\65B0\7A97\53E3')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11640760901415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100009)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\663E\793A\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11640971613415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11641130549415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\542F\52A8')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11641368872415118)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100009)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11641537319415127)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\9009\62E9\8FDB\7A0B')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11641638097415127)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\9009\62E9\8FDB\7A0B')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11641894887415127)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100009)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\5C5E\6027\3002')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11642024205415127)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11642210997415127)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100009)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\8F93\5165/\8F93\51FA\53D8\91CF\3002')
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11642457461415159)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\641C\7D22\5BF9\8BDD\6846')
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11642644635415163)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11642862347415165)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11643035458415169)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11643268039415170)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11643412526415171)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\641C\7D22')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11643667385415173)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5173\95ED')
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11643831736415174)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\4E00\6B65 >')
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11644088221415175)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('< \4E0A\4E00\4E2A')
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11644242429415180)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\662F\5426\8981\6267\884C\6B64\5220\9664\64CD\4F5C\FF1F')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11644443443415181)
,p_translated_flow_id=>100009
,p_translate_to_id=>100.100009
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\6D41')
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11644673250415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100009)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FDB\7A0B\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11644840436415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100009)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11645013776415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100009)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \670D\52A1')
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11645296056415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11645496578415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100009)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F52\6863')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11645694820415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100009)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76D1\89C6\5668')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11645817921415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100009)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\65F6\95F4\8868 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11646077341415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100009)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11646211125415204)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100009)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11646477479415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100009)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EEA\8868\76D8')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11646611097415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100009)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52A1\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11646888667415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100009)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EDF\8BA1\4FE1\606F')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11647071040415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100009)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE\5E94\7528\7A0B\5E8F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11647218364415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100009)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\7EDF\8BA1')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11647471598415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100009)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11647645852415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100009)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\914D\7F6E - \8BB8\53EF\8BC1')
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11647818988415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100009)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5EFA\6A21\5668')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11648004876415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100009)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\5F55')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11648298297415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100009)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11648499899415205)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100009)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11648674399415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100009)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\4EF6')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11648877167415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100009)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52A1\4E4B\540E')
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11649030945415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100009)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\5272\4E4B\524D')
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11649253868415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100009)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EC8\6B62\540E\5904\7406\72B6\6001')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11649411687415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100009)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5360\4F4D\7B26')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11649607368415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100009)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11649883156415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100009)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\4EF6\6284\9001')
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11650007648415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100009)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\671F')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11650271390415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100009)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E74\81F3\6708\95F4\9694')
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11650493425415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100009)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F20\5165\53D8\91CF')
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11650665976415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100009)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\672C')
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11650892750415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100009)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \811A\672C')
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11651084245415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100009)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF7\6C42')
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11651206408415209)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100009)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9875\9762\9879\76EE')
,p_translate_from_text=>'Page Items'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11651486600415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100009)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\518D\6B21\89E6\53D1\4E4B\524D\7684\65F6\95F4')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11651676188415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100009)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\5927\8FD0\884C\6B21\6570')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11651803398415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100009)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8F93\51FA\53D8\91CF')
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11652009641415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100009)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \51FD\6570\4E3B\4F53')
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11652298757415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100009)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9875\9762')
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11652433973415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100009)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\683C\5F0F\63A9\7801')
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11652659963415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100009)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\95F4\9694\65E5\5230\79D2')
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11652838671415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100009)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\9996\6B21\89E6\53D1\4E4B\524D\7684\65F6\95F4')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11653015240415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100009)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11653268364415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100009)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\5B9A\4E49\7C7B\578B')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11653450905415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100009)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\5B9A\4E49')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11653611815415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100009)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\56DE\590D\5730\5740')
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11653813829415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BB0\4F4F\7528\6237\540D')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11654083478415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100009)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \6587\4EF6')
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11654267037415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100009)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52A1\4E4B\524D')
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11654479379415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100009)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6536\4EF6\4EBA')
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11654646423415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100009)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6284\9001')
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11654845203415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100009)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7ACB\5373\53D1\9001')
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11655005923415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100009)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D3B\52A8\524D')
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11655239317415210)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100009)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\7A0B\5E8F ID')
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11655462471415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100009)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('HTML \6B63\6587')
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11655634505415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100009)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5408\5E76\4E4B\540E')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11655807930415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100009)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\81EA')
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11656048557415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100009)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9759\6001\503C')
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11656205416415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100009)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E3B\9898')
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11656440828415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100009)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Item'
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11656673858415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100009)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \67E5\8BE2\FF08\8FD4\56DE\5192\53F7\5206\9694\503C\FF09')
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11656830425415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100009)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \8868\8FBE\5F0F')
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11657077570415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100009)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \4EE3\7801')
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11657216690415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100009)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\53D8\91CF')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11657439936415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100009)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D3B\52A8\4E2D')
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11657616378415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100009)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9644\4EF6')
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11657821815415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100009)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \67E5\8BE2\FF08\8FD4\56DE\5355\4E2A\503C\FF09')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11658084426415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100009)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6E05\9664\7F13\5B58')
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11658223260415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100009)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Item\503C')
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11658434311415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100009)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B63\6587')
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11658636565415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100009)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52A1\7C7B\578B')
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11658825154415211)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100009)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\6A21\677F')
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11659072946415212)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100009)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\677F ID')
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11659282221415212)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100009)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11659456438415212)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100009)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7ED1\5B9A\9875\9879\503C')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11659619963415215)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\8BB0\5F55\5B50\6D41')
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11659838943415215)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\8BB0\5F55\8FDB\7A0B\7EA7\522B')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11660002887415215)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('	- \9009\62E9 -')
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11660293661415215)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E0\7C7B\522B')
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11660486054415216)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100009)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B9\5411')
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11660677724415216)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100009)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11660833501415216)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100009)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11661035312415216)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100009)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9519\8BEF\5806\6808')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11661288939415216)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100009)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\72B6\6001')
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11661416001415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100009)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11661620000415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100009)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11661877583415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11662040903415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100009)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11662225430415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100009)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\65E5\671F')
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11662448751415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11662657947415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100009)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53EF\8C03\7528')
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11662854488415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100009)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521D\59CB\5316\65E5\671F')
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11663002941415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100009)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11663276163415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11663453237415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100009)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9875\9762 ID')
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11663659405415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100009)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11663837099415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100009)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\540D')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11664037469415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100009)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11664204949415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100009)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11664435934415217)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100009)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\65E5\671F')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11664617702415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100009)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\6807\9898')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11664823402415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100009)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\56FE\6807')
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11665065276415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100009)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11665200298415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11665418595415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100009)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\8BF4\660E')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11665654084415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100009)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11665870499415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11666073477415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100009)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\578B\53F7')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11666245553415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100009)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11666495545415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100009)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\7528\7A0B\5E8F ID')
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11666660691415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100009)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\989C\8272')
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11666847823415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100009)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6570\636E\7C7B\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11667027012415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100009)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF4\660E')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11667210313415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100009)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11667436098415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F18\5148\7EA7')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11667692182415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100009)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11667859504415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100009)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\7C7B\578B')
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11668083893415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100009)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11668271310415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100009)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11668494025415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5230\671F\65E5')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11668610129415218)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100009)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\540D')
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11668846538415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100009)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11669081314415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100009)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11669261793415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100009)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11669469219415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11669698350415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11669876823415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100009)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11670085628415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100009)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11670254292415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100009)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11670418508415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11670621085415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100009)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11670828692415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11671096767415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100009)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11671218783415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100009)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11671400047415222)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100009)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11671615665415227)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li> \4E00\4E2A\6A21\578B\FF1A\901A\8FC7\63D0\4F9B\6240\6709\5C5E\6027\6765\5BFC\5165\5355\4E2A\6A21\578B </li>'),
unistr('    <li> \591A\4E2A\6A21\578B\FF1A\901A\8FC7\63D0\4F9B zip \6587\4EF6 *</li>'),
'</ul>',
unistr('<p> \5BFC\5165\591A\4E2A\6A21\578B* zip \6587\4EF6\5FC5\987B\5305\542B\FF1A '),
'    <ul>',
unistr('        <li> \8981\5BFC\5165\7684 bpmn \6587\4EF6 </li>'),
unistr('        <li> \4E00\4E2A import.json \6587\4EF6\FF0C\5B83\662F\5305\542B\4EE5\4E0B\5C5E\6027\7684\5BF9\8C61\6570\7EC4\FF08\8BF7\53C2\89C1\4E0B\9762\7684\793A\4F8B\FF09\FF1A '),
'            <ul>',
unistr('                <li>dgrm_name\FF1A\6A21\578B\7684\540D\79F0 </li>'),
unistr('                <li>dgrm_version\FF1A\6A21\578B\7684\7248\672C </li>'),
unistr('                <li>dgrm_category\FF1A\6A21\578B\7684\7C7B\522B </li>'),
unistr('                <li>file\FF1A\5F52\6863\6587\4EF6\4E2D bpmn \6587\4EF6\7684\540D\79F0 </li>'),
'            </ul>',
'        </li>',
'    </ul>',
unistr(' \5177\6709\4E24\4E2A\6A21\578B\7684 import.json \6587\4EF6\793A\4F8B <br>'),
unistr('<pre><code>\FF3B'),
unistr('\FF5B '),
unistr('    "dgrm_name"\FF1A\201C\6BD4\8428\534F\4F5C\201D\FF0C '),
unistr('    "dgrm_version"\FF1A"0"\FF0C '),
unistr('    "dgrm_status"\FF1A"draft"\FF0C '),
unistr('    "dgrm_category"\FF1Anull\FF0C'),
unistr('    \201C\6587\4EF6\201D\FF1A"The Pizza Collaboration_0.bpmn"'),
unistr('   \FF5D\FF0C '),
unistr('  \FF5B '),
unistr('    "dgrm_name"\FF1A\201C\8282\5047\65E5\201D\FF0C '),
unistr('    "dgrm_version"\FF1A"0"\FF0C '),
unistr('    "dgrm_status"\FF1A"draft"\FF0C '),
unistr('    "dgrm_category"\FF1Anull\FF0C'),
unistr('    \201C\6587\4EF6\201D\FF1A"Holidays_0.bpmn"'),
unistr('  \FF5D'),
unistr('\FF3D '),
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11671789597415227)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr(' \5982\679C\9009\6B64\590D\9009\6846\FF0C\5E94\7528\7A0B\5E8F\4F1A\5C06\60A8\7684\7528\6237\540D\4FDD\5B58\5728\540D\4E3A "LOGIN_USERNAME_COOKIE" \7684\6301\4E45\6027\6D4F\89C8\5668 cookie \4E2D\3002\4E0B\6B21\8F6C\81F3\767B\5F55\9875\9762\65F6\FF0C'),
unistr('\7528\6237\540D\5B57\6BB5\5C06\81EA\52A8\586B\5145\6B64\503C\3002 '),
'</p><p>',
unistr(' \5982\679C\53D6\6D88\9009\6B64\590D\9009\6846\5E76\4E14\60A8\7684\7528\6237\540D\5DF2\4FDD\5B58\5728 Cookie \4E2D\FF0C'),
unistr('\5E94\7528\7A0B\5E8F\5C06\4F7F\7528\7A7A\503C\8986\76D6\5B83\3002\60A8\4E5F\53EF\4EE5\4F7F\7528\6D4F\89C8\5668\7684\5F00\53D1\8005\5DE5\5177\5F7B\5E95\5220\9664 Cookie\3002 '),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11671946622415228)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11672132707415250)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100009)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11672304049415250)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100009)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D\5B50\6D41\7A0B')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11672557456415250)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100009)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11672740040415250)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B80\5355\8868\5355\6A21\677F')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11672978694415250)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100009)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D8\91CF\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11673170702415251)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100009)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11673305827415251)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100009)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ORDS \5BA2\6237\62A5\8868')
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11673533162415251)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100009)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\7684\6A21\578B')
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11673747843415251)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D88\606F\8BA2\9605')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11673926503415251)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100009)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\6B65\9AA4')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11674145418415251)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100009)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11674343402415251)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100009)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\7684\56FE\8868')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11674596569415251)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100009)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11674704787415251)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\56FE')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11674986842415251)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100009)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11675191920415251)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100009)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\5B50\6D41')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11675370756415251)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100009)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D\6B65\9AA4')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11675558817415251)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100009)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D8\91CF\5386\53F2\8BB0\5F55')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11675778113415251)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100009)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D8\91CF')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11675994853415251)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4\9519\8BEF')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11676169196415251)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100009)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11676359590415256)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100009)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B64\62A5\544A\7684\6700\5927\884C\6570\4E3A #MAX_ROW_COUNT# \884C\3002\8BF7\5E94\7528\7B5B\9009\5668\4EE5\51CF\5C11\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11676586200415256)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B64\62A5\544A\7684\6700\5927\884C\6570\4E3A #MAX_ROW_COUNT# \884C\3002\8BF7\5E94\7528\7B5B\9009\5668\4EE5\51CF\5C11\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11676732765415257)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D8\91CF\5386\53F2\8BB0\5F55\4E3A\7A7A\3002')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11676924740415258)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4\9519\8BEF\5386\53F2\8BB0\5F55\4E3A\7A7A\3002')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11677151449415258)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\5F53\524D\5B50\6D41\7A0B\3002')
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11677328354415258)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\53D8\91CF\8868\8FBE\5F0F\3002')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11677523743415258)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\8C03\7528\56FE\3002')
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11677753941415258)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\5DF2\5B8C\6210\7684\5B50\6D41\7A0B\3002')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11677991880415258)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\4E8B\4EF6\5386\53F2\8BB0\5F55\4E3A\7A7A\3002')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11678120349415258)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100009)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\6570\636E\3002')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11678320653415258)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\5C5E\6027\3002')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11678527550415258)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\8C03\7528\56FE\8868\3002')
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11678760984415258)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100009)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D8\91CF\5386\53F2\8BB0\5F55\4E3A\7A7A\3002')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11678916294415258)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100009)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\6570\636E\3002')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11679189379415258)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\5DF2\5B8C\6210\7684\6B65\9AA4\3002')
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11679348944415258)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\627E\5230\5F53\524D\6B65\9AA4\3002')
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11679548563415262)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11679734637415262)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11679961818415262)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11680102573415262)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11680308250415262)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11680543751415262)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11680714133415263)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11680970879415263)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11681157959415263)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11681393068415263)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11681598618415263)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11681784757415263)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11681967145415263)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11682157663415263)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11682321957415263)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11682527402415263)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11682750948415263)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11682976857415263)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11683194834415263)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11683364907415263)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100009)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11683587822415263)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100009)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11683767017415263)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11683962287415263)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11684167152415263)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11684397881415264)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100009)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11684575819415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11684745335415264)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11684945447415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11685184084415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100009)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11685382359415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100009)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11685599155415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11685771406415264)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11685946195415264)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11686167414415264)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11686388778415264)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11686597153415264)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11686712546415264)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11686963048415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11687109895415264)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11687380986415264)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11687563284415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100009)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11687727106415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11687998135415264)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11688136729415265)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11688343169415265)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11688543368415265)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100009)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11688747918415265)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100009)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11688973605415265)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11689157532415265)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11689384824415265)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11689506504415265)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11689754512415265)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100009)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11689985763415265)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11690122518415265)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11690369732415265)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11690528785415265)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100009)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11690793702415265)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11690928794415265)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11691146947415265)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11691343757415265)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11691508063415265)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100009)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11691757881415265)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11691961880415265)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11692155219415266)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11692391786415266)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100009)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11692591328415266)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11692726105415266)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100009)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11692953223415266)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11693105664415266)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11693336232415266)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11693589055415266)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11693786331415266)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11693915504415266)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11694160626415266)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11694310431415266)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11694525408415266)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11694749556415266)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11694920554415266)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11695134751415266)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11695343906415266)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11695561611415266)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11695707997415266)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100009)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11695955043415266)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11696190497415267)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100009)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11696350413415267)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11696519571415267)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11696732612415267)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11696967993415267)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11697100295415267)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100009)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11697323380415267)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100009)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11697583964415267)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100009)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11697786442415267)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11697944732415267)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11698124095415267)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11698382397415267)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100009)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11698550745415267)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11698789502415267)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11698911633415267)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11699103916415267)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11699340755415267)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11699551315415267)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11699730452415267)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11699969623415268)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11700194976415268)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11700368351415268)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11700556323415268)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11700748903415268)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11700918131415268)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11701189612415268)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11701374182415268)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11701588958415268)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11701767446415268)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11701990362415268)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11702183842415268)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11702344268415268)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11702519087415268)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11702710912415268)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11702918929415268)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11703120101415268)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11703398494415268)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11703527812415268)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100009)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11703723616415268)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11703958290415268)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11704199002415269)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100009)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11704394607415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11704597799415269)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11704710046415269)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11704972682415269)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100009)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11705155813415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11705399522415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11705569463415269)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11705781010415269)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100009)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11705968408415269)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11706130409415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11706354788415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11706513775415269)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11706739720415269)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100009)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11706992584415269)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11707139211415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11707319562415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100009)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11707544372415269)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11707738805415269)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100009)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11707934496415269)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11708198594415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11708361099415270)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11708584077415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11708751928415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11708910367415270)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11709192981415270)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100009)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11709347087415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11709500065415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11709744178415270)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11709964787415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11710156751415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11710372068415270)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11710539108415270)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100009)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11710762536415270)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11710953993415270)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11711103329415270)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11711379730415270)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11711561049415270)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11711767168415270)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11711975872415270)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11712116414415270)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11712397331415271)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100009)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11712541208415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11712756447415271)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11712931591415271)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11713158236415271)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11713327076415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11713591297415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100009)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11713765045415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11713926746415271)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11714144630415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11714396709415271)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100009)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11714548552415271)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11714775367415271)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100009)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11714903469415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11715142039415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11715348824415271)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11715554444415271)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11715784703415271)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11715990008415271)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11716108689415271)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100009)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11716394814415272)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11716572165415272)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11716724095415272)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11716992186415272)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11717185837415272)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11717354260415272)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11717550663415272)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100009)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11717711952415272)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11717968516415272)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11718123053415272)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11718355171415272)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100009)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11718513382415272)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11718735680415272)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11718991851415272)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100009)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11719177848415272)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11719348779415272)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100009)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11719531302415272)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100009)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11719732729415272)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11719908973415273)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11720147010415273)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11720353354415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11720556035415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100009)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11720703905415273)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11720969751415273)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11721193220415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11721339253415273)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11721510949415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11721705840415273)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100009)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11721927426415273)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11722128774415273)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11722314145415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11722579324415273)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11722797827415273)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11722974230415273)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11723195821415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11723312026415273)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11723527653415273)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11723717723415273)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11723911545415273)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11724116782415274)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100009)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11724310273415274)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11724574566415274)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100009)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11724769813415274)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11724936159415277)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BA1\65F6\5668\5F00\59CB\65F6\95F4')
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11725149675415277)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11725338093415277)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D\8303\56F4')
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11725593363415277)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\8C61')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11725769277415277)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('JSON \5C5E\6027')
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11725975678415277)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11726141526415277)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11726367700415277)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\8C61')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11726516895415277)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11726729405415277)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11726924065415277)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11727149335415278)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\65E5\671F')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11727306451415278)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11727569215415278)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\7684\56FE\8868\7248\672C\9009\62E9')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11727784795415278)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11727959645415278)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11728127727415278)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11728311061415278)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11728564189415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8D77\59CB\5BF9\8C61')
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11728768249415278)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100009)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\652F\6301\90AE\7BB1')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11728958701415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100009)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11729184791415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D\7EA7\522B')
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11729346711415278)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\7248\672C')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11729570949415278)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11729775063415278)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100009)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210\65F6\7684\72B6\6001')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11729950467415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5173\952E\5B57\503C')
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11730167927415278)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11730398905415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FD0\8F93\8DEF\7EBF')
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11730525989415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100009)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\5BF9\8C61')
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11730788803415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100009)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11730902354415278)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\94A5\540D\79F0')
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11731153498415278)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11731312959415279)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11731593431415279)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11731705698415279)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5177\6709\9012\5F52\56FE\6807')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11731988218415279)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11732102750415279)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11732377540415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FEB\901F\64CD\4F5C')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11732576316415279)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\540D\79F0')
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11732703829415279)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11732964344415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100009)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11733188206415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11733374624415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5230\671F\65E5')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11733552146415279)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11733737136415279)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11733942082415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100009)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11734178490415279)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100009)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FEB\901F\64CD\4F5C')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11734388147415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\521B\5EFA')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11734520571415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11734752994415279)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6267\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11734980200415279)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\65E5\671F')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11735185611415279)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100009)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11735334150415280)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\7BA1\7406\5668')
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11735529083415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11735767757415280)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D\7C7B\522B')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11735999015415280)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100009)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11736117304415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8303\56F4')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11736366568415280)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9759\6001 ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11736530366415280)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11736711733415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\4E3A\5F53\524D')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11736984965415280)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100009)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11737122548415280)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11737357444415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\8FBE\5F0F')
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11737502512415280)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6267\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11737754306415280)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100009)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11737991187415280)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11738132889415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100009)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11738398414415280)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11738519564415280)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100009)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\8C61')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11738765180415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11738943952415280)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11739125094415280)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11739381972415281)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6392\9664\7684\7528\6237')
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11739503345415281)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11739782576415281)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9884\8BA2')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11739920175415281)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\56FE\8868')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11740178282415281)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11740383601415281)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\5DF2\5F00\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11740581707415281)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6709\6548\8D1F\8F7D\53D8\91CF')
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11740771686415281)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11740941036415281)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\522B')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11741175588415281)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100009)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\89E3\6790\7684\6D41\7A0B')
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11741301965415281)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11741538575415281)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100009)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9884\8BA2')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11741742612415281)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11741904301415281)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7EA7\522B')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11742195738415281)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\5DF2\5F00\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11742394437415281)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11742551511415281)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100009)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11742757024415281)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100009)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11742986100415281)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100009)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11743177159415281)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11743327594415282)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11743582452415282)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11743767518415282)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100009)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\65E5\671F')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11743927174415282)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6839 Dgrm')
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11744129468415282)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9884\8BA2')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11744337833415282)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11744560163415282)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11744702484415282)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\5BF9\8C61')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11744968126415282)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\578B')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11745180148415282)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11745314820415282)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11745503702415282)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11745775703415282)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11745905691415282)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11746147821415282)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11746364908415282)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\7684\56FE\8868')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11746533775415282)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11746716591415282)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EA7\522B')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11746951330415282)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11747108178415282)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11747381883415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100009)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11747501145415283)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B4C\66F2')
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11747765476415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11747958007415283)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11748145325415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11748368818415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11748506357415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D88\606F\540D\79F0')
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11748795773415283)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\65E5\671F')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11748941802415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100009)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11749190892415283)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7EA7\522B')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11749301354415283)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11749564402415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100009)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\5BF9\8C61')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11749717124415283)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11749927731415283)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11750122437415283)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\5BF9\8C61')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11750391481415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100009)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8303\56F4')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11750587379415283)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11750768862415283)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11750979968415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F18\5148\7EA7')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11751169276415283)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100009)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11751311647415284)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9884\8BA2')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11751586750415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9519\8BEF\5806\6808')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11751733312415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11751988681415284)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11752125564415284)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100009)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11752307284415284)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11752558678415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6267\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11752723402415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100009)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4\5173\952E\5B57')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11752952382415284)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11753149575415284)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100009)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4\5173\952E\5B57')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11753381324415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11753517317415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \6807\8BC6')
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11753765793415284)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\4E3A\5F53\524D')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11753971408415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6570\636E\7C7B\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11754166905415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11754387155415284)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11754517078415284)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100009)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11754779273415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11754999668415284)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11755145067415285)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\7684\56FE\8868\7248\672C')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11755350599415285)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11755527267415285)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\65E5\671F')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11755745155415285)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11755920259415285)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100009)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4\5173\952E\5B57')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11756137932415285)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11756389780415285)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11756568519415285)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7EA7\522B')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11756712114415285)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9519\8BEF\5806\6808')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11756973697415285)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11757178921415285)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11757301666415285)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\5DF2\5F00\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11757505005415285)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11757789930415285)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100009)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11757911492415285)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D\7C7B\522B')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11758160706415285)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\56FE\8868')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11758364242415285)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\5DF2\5F00\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11758561202415285)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6570\636E\7C7B\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11758719696415285)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\5BF9\8C61')
,p_translate_from_text=>'Calling Object'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11758913758415285)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100009)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9519\8BEF\5806\6808')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11759171987415286)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11759363112415286)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7EA7\522B')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11759548551415286)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100009)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub ID'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11759758968415286)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100009)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11759915735415286)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100009)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5907\6CE8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11760192309415286)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100009)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8BF4\660E')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11760393908415286)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11760545937415286)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7EA7\522B')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11760766012415286)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\72B6\6001')
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11760918818415286)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\7C7B\522B')
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11761152527415286)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100009)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11761300996415286)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11761500734415286)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100009)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FED\4EE3\8DEF\5F84')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11761780006415286)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\56FE')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11761952351415286)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6570\636E\7C7B\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11762172027415286)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F53\524D')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11762314271415286)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65F6\95F4\6233')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11762536918415286)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11762743383415286)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8C03\7528\56FE\8868 ID')
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11762928432415287)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100009)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\652F\6301 URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11763122529415287)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11763388877415287)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11763557647415287)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100009)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11763777242415287)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100009)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11763976995415287)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11764143730415287)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5177\6709\9012\5F52')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11764366150415287)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100009)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B ID')
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11764525839415287)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6F5C\5728\7528\6237')
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11764796611415287)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100009)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11764952859415287)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100009)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11765196262415287)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100009)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11765350950415287)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\540D\79F0')
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11765530055415287)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11765774551415287)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\8FBE\5F0F\7C7B\578B')
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11765948585415287)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100009)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11766190604415287)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11766311718415287)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11766561469415287)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11766712577415287)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6F5C\5728\7EC4')
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11766993685415287)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\56FE')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11767192225415288)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100009)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BA2\6237\7AEF ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11767342563415288)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11767533543415288)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11767704986415288)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\90E8\95E8\6807\8BC6')
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11767956206415288)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9AA4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11768191234415288)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100009)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\4E3A\5F53\524D')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11768385892415288)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11768526045415288)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100009)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11768709107415288)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100009)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\4E3A\5F53\524D')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11768913422415288)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100009)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11769117246415288)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100009)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11769334867415288)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100009)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11769583701415288)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100009)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210\65F6\7684\72B6\6001')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11769711646415288)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FEB\901F\64CD\4F5C')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11769991707415288)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100009)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11770184427415288)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11770388985415292)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11770577536415292)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11770787511415292)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11770987564415292)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100009)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11771157526415292)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100009)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11771342162415292)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11771591623415292)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100009)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11771791416415292)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11771926580415293)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100009)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11772189823415293)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11772333825415293)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100009)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11772594410415293)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11772727049415293)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11772921661415293)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100009)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11773115839415293)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11773305178415293)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100009)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11773542223415293)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100009)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11773762230415293)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100009)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11773939235415293)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11774161164415293)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100009)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11774344668415293)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11774559175415293)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100009)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11774736670415293)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11774986104415293)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11775121235415294)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100009)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11775353707415294)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100009)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11775505538415296)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100009)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11775708516415296)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100009)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11775969077415399)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100009)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \67E5\770B\5668')
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11776040803415399)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100009)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \5EFA\6A21\5668')
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11776209093415399)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100009)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11776425427415399)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100009)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11776685542415399)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100009)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11776892601415401)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100009)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11777087284415401)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100009)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11777258429415401)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100009)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11777402588415403)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6743\9650\4E0D\8DB3\FF0C\7528\6237\4E0D\662F\7BA1\7406\5458')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11777655560415404)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\5C0F\65F6')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11777829037415405)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\5C0F\65F6')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11778022921415405)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11778201422415405)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11778479764415405)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11778635396415405)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('I \5E74')
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11778865567415405)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 \5E74')
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11779068549415406)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \5206\949F')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11779227583415406)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \5206\949F')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11779478486415406)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \4E2A\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11779613177415406)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \4E2A\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11779850217415406)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \4E2A\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11780083228415406)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \4E2A\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11780212835415406)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('4 \5E74')
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11780445537415408)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 \5206\949F')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11780630790415408)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 \5206\949F')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11780810242415408)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \4E2A\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11781024279415408)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \4E2A\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11781241580415408)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \4E2A\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11781417413415408)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \4E2A\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11781685842415408)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \5E74')
,p_translate_from_text=>'3 Years'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11781850572415409)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5206\949F')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11782075698415409)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5206\949F')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11782207697415410)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \4E2A\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11782414920415410)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \4E2A\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11782655423415410)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \4E2A\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11782846710415410)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \4E2A\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11783021445415410)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('2 \5E74')
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11783276935415412)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \79D2\FF08\751F\4EA7\4F7F\7528 - \4E0D\9002\7528\4E8E apex.oracle.com\FF09')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11783424712415412)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \79D2\FF08\751F\4EA7\4F7F\7528 - \4E0D\9002\7528\4E8E apex.oracle.com\FF09')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11783606708415412)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 \5929')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11783833892415412)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 \5929')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11784028004415412)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 \5929')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11784287471415412)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11784446098415414)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 \5929')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11784670262415414)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 \5929')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11784868316415414)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 \5929')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11785091150415421)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11785248861415421)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11785489478415421)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11785600298415421)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11785899747415421)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11786046424415421)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100009)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11786220575415421)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11786426577415421)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100009)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11786651159415421)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11786865963415421)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11787019938415421)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11787294190415421)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11787480558415421)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100009)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11787686662415421)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11787866833415421)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11788019043415421)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11788235591415422)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11788464002415422)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11788611458415422)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100009)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11788878337415422)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100009)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11789051849415422)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11789238945415422)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100009)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11789457696415422)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11789606130415422)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100009)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11789860519415422)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100009)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11790015387415422)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11790284130415422)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100009)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11790444200415422)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100009)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11790691717415422)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11790801441415422)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100009)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11791037824415422)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100009)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11791205758415422)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11791472262415422)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100009)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11791632630415422)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100009)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11791879854415422)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11792047257415422)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11792254850415422)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11792447492415422)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11792623839415423)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11792843205415423)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11793012687415423)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11793262795415423)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100009)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11793490770415423)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100009)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11793608670415423)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11793869194415423)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11794077998415423)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11794284119415423)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11794480702415423)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11794624625415423)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11794820020415423)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100009)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11795056524415423)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11795298556415423)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100009)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11795416535415423)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11795679947415423)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100009)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11795864118415423)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11796045540415423)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11796273614415423)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100009)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11796469258415423)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100009)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11796661993415424)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100009)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11796874065415424)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11797070498415424)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11797262393415424)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11797483111415424)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100009)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11797673268415424)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11797890999415424)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100009)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11798060493415424)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11798212972415424)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11798493556415424)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11798675761415424)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11798863739415424)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11799095522415424)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11799298871415424)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11799478667415424)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11799679842415424)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11799830903415424)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100009)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11800076129415424)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11800211343415425)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11800417723415425)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11800646790415425)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100009)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11800896296415425)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11801067690415425)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11801220176415425)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100009)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11801447840415425)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11801671963415425)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11801805152415425)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100009)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11802042264415425)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11802290127415425)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11802494841415425)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11802640220415425)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11802842490415425)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11803020253415425)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11803244544415425)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11803443960415425)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11803611934415425)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11803813814415425)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11804000718415425)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11804247946415425)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11804426441415425)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11804696480415426)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11804844281415426)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11805012471415426)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100009)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11805282814415426)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100009)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11805441201415426)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11805673110415426)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11805889196415426)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100009)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11806083813415426)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100009)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11806256571415426)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11806432850415426)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11806547483415426)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11806702356415426)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11806979288415426)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11807145061415426)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11807378897415426)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11807530342415426)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11807727263415426)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11807986539415426)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100009)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11808193611415426)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100009)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11808395789415426)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100009)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11808560233415427)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100009)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11808763132415427)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11808973140415427)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11809122309415427)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11809359486415427)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100009)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11809520232415427)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11809751590415427)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11809978512415427)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100009)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11810129220415427)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11810371603415427)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11810525904415427)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100009)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11810710767415427)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11810976962415427)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11811163817415427)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100009)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11811378072415427)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11811542292415427)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11811730683415427)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11811916911415427)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100009)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11812161956415427)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100009)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11812382289415427)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11812591078415428)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100009)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11812707609415428)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11812992337415428)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11813194696415428)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100009)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11813399806415428)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11813551545415428)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11813738573415428)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11813985481415428)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100009)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11814145882415428)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11814356403415428)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11814581395415428)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11814702801415428)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11814937702415428)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11815148373415428)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11815329292415428)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11815597903415428)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11815730264415428)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11815974084415428)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11816121219415428)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11816314776415428)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100009)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11816593177415428)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11816771275415429)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11816934604415429)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11817118960415429)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11817399455415429)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100009)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11817596276415429)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11817784782415429)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11817973912415429)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11818180062415429)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11818358089415429)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100009)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11818554693415429)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11818741838415429)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11818980011415429)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11819142940415429)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11819305646415429)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100009)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11819581355415429)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100009)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11819794373415429)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11819999942415429)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100009)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11820197575415429)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11820327883415429)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100009)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11820556418415430)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11820747889415430)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11820907215415430)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11821158476415433)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11821301807415433)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11821560268415433)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11821749469415433)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11821910401415433)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11822102109415433)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100009)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11822369119415433)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11822536519415433)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11822767779415433)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11822979129415433)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11823152968415433)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11823301269415433)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11823568555415434)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11823704679415434)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11823992836415434)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11824129303415434)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11824378505415434)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11824532474415434)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11824761061415434)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100009)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11824997373415434)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100009)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11825189118415434)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11825362167415434)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11825525719415434)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11825764189415434)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100009)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11825933803415434)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11826159454415434)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11826358672415434)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11826571482415434)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11826718420415434)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11826928548415434)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11827193125415434)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100009)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11827328889415435)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11827547083415435)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11827772454415435)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11827969307415435)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11828122774415435)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11828345417415435)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11828530313415435)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11828757417415435)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11828970955415435)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11829178037415435)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11829331705415435)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11829533072415435)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11829702935415435)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11829971603415435)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100009)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11830108294415435)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11830312893415435)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11830535773415435)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11830781012415435)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11830948288415435)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11831129768415435)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11831357841415436)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11831589777415436)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11831788342415436)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11831930077415436)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11832131514415436)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11832395644415436)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11832576774415436)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11832745011415436)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100009)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11832910958415436)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11833121282415436)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11833397118415436)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11833590932415436)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11833701397415436)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11833958417415436)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11834132333415436)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11834374980415436)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100009)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11834589160415436)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11834798574415436)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11834920586415436)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100009)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11835198227415436)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100009)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11835335791415436)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11835512079415437)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11835736413415437)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100009)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11835910015415437)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100009)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11836133786415437)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11836370284415437)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11836594373415437)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11836704515415437)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11836930095415437)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11837147005415437)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11837377585415437)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11837590278415437)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11837741330415437)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11837981250415437)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11838119751415437)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11838349571415437)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11838529794415437)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100009)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11838726193415437)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11838966665415437)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100009)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11839112215415437)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11839332369415438)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11839507420415438)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11839732383415438)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11839926778415438)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11840158777415438)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100009)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11840326787415438)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11840563037415438)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11840720603415438)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11840938696415440)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11841111673415440)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11841378865415440)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11841579070415440)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11841728824415440)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11841998166415441)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100009)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11842167447415441)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11842372699415441)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11842549773415441)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11842797356415441)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11842938948415441)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100009)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11843139604415441)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11843350226415441)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11843519181415441)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11843704735415441)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11843907975415441)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11844158538415441)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11844303278415441)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11844564318415441)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11844740655415441)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11844999627415441)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11845108988415441)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11845343906415441)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11845506086415441)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11845700871415442)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11845992722415442)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11846192073415443)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11846368631415443)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11846527123415443)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11846737282415443)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100009)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11846940998415443)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11847192852415443)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11847317543415444)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11847502216415444)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11847756349415444)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11847970702415444)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11848103343415444)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11848360371415444)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11848507438415444)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11848719980415444)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11848900525415444)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11849120363415444)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100009)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11849324969415444)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11849598339415444)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11849793098415444)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11849924100415444)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11850125229415444)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11850305152415444)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11850563648415444)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11850727463415444)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100009)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11850954788415444)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11851160338415445)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11851342077415445)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11851526583415445)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11851773355415445)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11851989324415445)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11852127048415445)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11852315230415445)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11852529059415445)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11852715296415445)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11852902195415445)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100009)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11853194309415445)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11853307500415445)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11853528650415445)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11853785294415445)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11853989829415445)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11854111090415445)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11854358255415445)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11854597511415446)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11854702261415446)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11854986264415446)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11855117681415446)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11855381575415446)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11855572695415446)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11855716414415446)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11855929308415446)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11856112370415446)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11856328458415446)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11856526626415446)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100009)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11856788492415446)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11856982610415446)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11857199244415446)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11857300869415446)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11857562466415446)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11857721158415446)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11857984761415446)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11858106193415446)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11858304365415446)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11858580038415447)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11858747969415447)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11858966389415447)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11859185350415447)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11859384018415447)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100009)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11859579452415447)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11859737211415447)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100009)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11859963092415447)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11860101830415447)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11860328539415447)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11860549588415447)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11860744675415447)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100009)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11860938651415447)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11861105495415447)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11861312976415447)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11861507462415450)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100009)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11861745899415450)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11861972171415450)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11862152141415450)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11862336096415450)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11862590412415450)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11862728164415450)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11862936766415450)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11863110339415450)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100009)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11863359698415450)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100009)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11863500416415450)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11863773680415450)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11863977071415450)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100009)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11864157141415450)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100009)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11864393536415450)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11864597597415451)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11864744114415451)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11864917803415451)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11865177973415451)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11865301377415451)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11865501933415451)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11865730190415451)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11865945111415451)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11866176539415451)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11866314120415451)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11866596567415451)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11866744409415451)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11866909506415451)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11867121601415451)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11867314477415451)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100009)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11867558065415451)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100009)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11867764761415451)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100009)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11867988808415451)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11868197435415452)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11868363724415452)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11868532825415452)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11868733147415452)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11868912178415452)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11869113644415452)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100009)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11869374426415452)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100009)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11869519763415452)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11869702268415452)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11869992093415452)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11870104215415452)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100009)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11870315915415452)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100009)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11870521476415452)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100009)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11870710136415452)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11870939525415452)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100009)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11871159726415452)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11871356472415452)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11871535038415452)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100009)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11871720733415452)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100009)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11871998248415452)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11872196703415453)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100009)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11872313500415453)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11872550145415453)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100009)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11872732729415453)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100009)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11872935632415453)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11873193406415453)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100009)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11873306238415453)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11873513679415453)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100009)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11873795772415453)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100009)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11873914588415453)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100009)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11874139372415453)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100009)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11874384976415453)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100009)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11874527816415453)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100009)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11874713916415453)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100009)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11874946997415453)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11875138468415457)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11875329663415457)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100009)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11875595079415459)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11875721042415461)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11875983033415462)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100009)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11876145709415462)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11876341610415462)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100009)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11876514751415463)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11876723343415463)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100009)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11876927967415463)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100009)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11877154865415468)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11877364865415470)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11877546209415473)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100009)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11877729909415477)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100009)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11877978165415477)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100009)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11878179991415477)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11878383197415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100009)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11878526017415477)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100009)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11878778346415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100009)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11878934873415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100009)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11879124643415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11879339071415477)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100009)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11879551849415477)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11879764323415477)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11879986356415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100009)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11880173789415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11880342058415477)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11880587788415477)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11880726616415477)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100009)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11880961101415477)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100009)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11881160065415478)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100009)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11881397918415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11881515529415478)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11881766454415478)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100009)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11881912646415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11882193825415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100009)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11882312251415478)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11882559818415478)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11882722467415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11882993859415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100009)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11883118515415478)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11883397115415478)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11883509797415478)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11883708902415478)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100009)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11883919539415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100009)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11884194896415478)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11884379041415478)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11884547073415478)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100009)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11884788453415478)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100009)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11884938790415479)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100009)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11885101156415479)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100009)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11885316427415479)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100009)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11885514371415479)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100009)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11885721872415479)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11885900806415479)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100009)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11886146759415479)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100009)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11886301826415479)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11886599359415479)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100009)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11886798727415479)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100009)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11886985349415479)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11887119973415479)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100009)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11887344163415479)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100009)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11887515088415479)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11887707862415479)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100009)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11887906455415479)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100009)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11888122281415479)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100009)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11888355262415479)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11888513074415479)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100009)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11888709372415480)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11888920694415480)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11889141279415480)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11889391613415480)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100009)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11889531376415480)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100009)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11889722797415480)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11889978594415480)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11890124605415480)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100009)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11890347263415480)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100009)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11890568427415480)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11890791388415480)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100009)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11890958027415480)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11891134886415480)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11891328596415480)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100009)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11891554508415480)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11891765835415480)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100009)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11891995251415480)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11892170321415480)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100009)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11892300047415480)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100009)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11892551996415481)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11892740094415481)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100009)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11892945829415481)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100009)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11893117097415481)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100009)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11893388777415483)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11893569272415483)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11893756313415483)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11893922168415483)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11894159431415483)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100009)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11894393684415483)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100009)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11894537267415483)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100009)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11894715284415483)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11894982942415483)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100009)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11895109437415485)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11895373465415486)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11895538061415486)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11895725379415486)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100009)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11895959005415486)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100009)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11896181133415487)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100009)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11896305615415488)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100009)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11896545848415488)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100009)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11896757474415488)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11896902094415488)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11897124269415488)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11897350662415488)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100009)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11897569238415488)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11897716673415489)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11897903733415489)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100009)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11898140033415489)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11898352965415489)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100009)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11898552086415489)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11898775010415489)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11898987314415489)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100009)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11899108343415490)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11899381561415490)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11899532684415491)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11899706224415491)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100009)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11899918885415491)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11900110822415491)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100009)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11900312809415491)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100009)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11900578590415491)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100009)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11900770750415491)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11900921507415492)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11901191452415493)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11901368829415493)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11901540157415493)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100009)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11901772809415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11901938890415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11902141742415493)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100009)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11902396494415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11902564685415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100009)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11902744597415493)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100009)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11902965801415493)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100009)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11903159965415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11903342088415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11903566293415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100009)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11903766581415493)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100009)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11903920692415495)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11904147212415495)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11904303863415495)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11904589170415495)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100009)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11904727606415495)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11904983799415495)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11905133500415495)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100009)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11905356294415495)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11905551959415495)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100009)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11905727129415495)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100009)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11905914886415495)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100009)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11906115578415495)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11906395643415495)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11906513198415496)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100009)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11906727455415496)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100009)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11906918987415497)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100009)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11907137912415497)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100009)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11907361462415497)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100009)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11907589954415497)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11907731984415498)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11907925309415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11908142554415498)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11908356999415498)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100009)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11908558900415498)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100009)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11908797635415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11908978686415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100009)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11909121959415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100009)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11909324761415498)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100009)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11909574416415498)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11909710708415498)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100009)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11909925319415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11910154992415498)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100009)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11910301737415498)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100009)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11910565498415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100009)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11910763114415498)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100009)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11910900810415498)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100009)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11911144145415498)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100009)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11911323924415498)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11911577188415499)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100009)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11911775058415499)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11911988494415499)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100009)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11912129533415499)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100009)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11912316572415499)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100009)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11912556866415499)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100009)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11912710420415499)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100009)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11912999210415501)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11913100291415501)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11913396599415501)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100009)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11913593963415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11913700781415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11913972587415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11914104619415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11914377345415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11914582277415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11914767220415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11914933260415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100009)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11915162866415503)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11915316285415505)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11915550154415505)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11915718115415505)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11915961138415505)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100009)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11916187811415506)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11916385896415506)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11916504319415507)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11916759586415508)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11916988639415508)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11917114250415508)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11917361625415509)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11917576368415511)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100009)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11917795380415517)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11917984029415517)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100009)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11918150117415517)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100009)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11918360208415518)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100009)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11918597174415518)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100009)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11918794923415518)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11918914683415518)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100009)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11919112470415518)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11919393985415518)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11919577098415518)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100009)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11919733519415518)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100009)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11919939542415518)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100009)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11920177606415518)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100009)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11920372677415518)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11920552327415518)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11920731669415518)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100009)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11920911752415518)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100009)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11921188914415518)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100009)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11921313880415518)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100009)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11921547673415518)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11921760901415518)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100009)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11921934127415518)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100009)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11922125477415519)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100009)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11922335511415519)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11922599291415519)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11922735911415519)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11922991744415519)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100009)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11923130641415519)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100009)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11923319914415519)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11923577586415519)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100009)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11923711073415519)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100009)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11923918285415519)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11924118415415519)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11924325755415519)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11924538071415519)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11924714507415519)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11924990665415519)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11925198489415519)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100009)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11925355926415519)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100009)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11925523760415519)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11925788289415519)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100009)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11925964915415520)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11926197282415520)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100009)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11926325022415520)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100009)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11926577105415520)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11926743744415520)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100009)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11926976217415520)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100009)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11927180811415520)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100009)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11927307985415520)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11927511999415520)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11927751503415520)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11927961608415520)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100009)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11928139977415520)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100009)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11928357358415520)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11928504295415520)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11928722213415520)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11928901469415520)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11929125566415520)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11929373139415521)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11929533484415521)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11929778743415521)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11929937633415521)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11930132692415521)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100009)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11930388362415521)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100009)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11930565161415523)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100009)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11930792493415523)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100009)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11930986225415523)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100009)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11931161872415523)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100009)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11931308962415523)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100009)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11931544754415523)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11931789248415523)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100009)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11931976911415523)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100009)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11932149585415523)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100009)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11932351505415523)
,p_page_id=>5
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100009)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11932538658415524)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100009)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11932719220415524)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100009)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11932967898415524)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11933124297415524)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11933344108415524)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100009)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11933521955415524)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100009)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11933760802415524)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100009)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11933935274415524)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100009)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11934190779415524)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11934321355415524)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100009)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11934589192415524)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100009)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11934709005415524)
,p_page_id=>37
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100009)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11934904020415524)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11935173885415524)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11935371681415524)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11935575950415524)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100009)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11935710439415524)
,p_page_id=>33
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100009)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11935908480415524)
,p_page_id=>11
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11936119427415524)
,p_page_id=>39
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100009)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11936357861415524)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100009)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11936516312415524)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100009)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11936719225415525)
,p_page_id=>50
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100009)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11936968850415525)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100009)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11937146169415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100009)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11937318965415525)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100009)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11937543512415525)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11937735954415525)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100009)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11937913479415525)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100009)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11938127135415525)
,p_page_id=>4
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100009)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11938376887415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100009)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11938548016415525)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11938775719415525)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100009)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11938962906415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100009)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11939175723415525)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11939372872415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100009)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11939507526415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100009)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11939721540415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100009)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11939944426415525)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100009)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11940109674415526)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100009)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11940352145415526)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11940533055415526)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100009)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11940752268415526)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100009)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11940929071415526)
,p_page_id=>13
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100009)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11941184363415526)
,p_page_id=>38
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11941391349415526)
,p_page_id=>1
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100009)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11941564388415526)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100009)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11941795581415526)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11941985729415526)
,p_page_id=>14
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100009)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11942121813415526)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100009)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11942298410415526)
,p_page_id=>30
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100009)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11942437171415526)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100009)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11942631313415526)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100009)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11942811224415528)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11943083450415528)
,p_page_id=>51
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100009)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11943234173415529)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11943405906415529)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11943623536415529)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11943821161415529)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11944011164415529)
,p_page_id=>31
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100009)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11944273742415530)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11944406453415531)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11944612220415531)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11944895658415532)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11945095960415532)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11945277608415532)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11945424605415534)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11945647461415534)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11945822690415534)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11946050317415534)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11946277532415536)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11946431912415536)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11946686782415536)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11946872048415537)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11947071372415538)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11947277954415538)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11947435711415538)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11947695816415539)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11947807799415539)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11948006464415539)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11948293065415539)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11948414939415539)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11948641994415546)
,p_page_id=>6
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100009)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11948857175415571)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11949060014415571)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11949254214415571)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11949477536415571)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11949624932415573)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11949845570415573)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11950086222415573)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11950281204415573)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11950495525415575)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11950621624415575)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11950887545415575)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11951030387415575)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11951293323415576)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11951426344415576)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11951609828415576)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11951810879415576)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11952086062415578)
,p_page_id=>20
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100009)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11952249792415578)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11952475365415578)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11952666316415578)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11952847370415578)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11953095245415580)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11953231468415626)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100009)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11953328760415626)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100009)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11953523604415626)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100009)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11953761229415626)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100009)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11953972843415626)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100009)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11954125569415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100009)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11954346991415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100009)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11954598392415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100009)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11954726642415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100009)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11954942813415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100009)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C\3001\8BB8\53EF\8BC1\4FE1\606F')
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11955145731415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100009)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11955372009415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100009)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11955555203415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100009)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11955721820415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100009)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11955991149415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11956131952415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100009)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11956357905415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100009)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11956515671415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100009)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11956783684415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100009)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11956921972415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100009)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11957175853415627)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100009)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11957343256415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100009)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11957537663415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100009)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11957752538415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100009)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11957986111415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100009)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11958105247415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100009)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11958352033415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100009)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11958538222415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100009)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11958708156415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100009)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11958922018415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100009)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11959140423415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100009)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11959308324415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100009)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11959599873415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100009)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11959745688415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100009)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11959932081415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11960103619415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100009)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11960311099415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100009)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11960540744415628)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11960723736415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100009)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11960972651415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11961158700415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100009)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11961303301415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100009)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11961555882415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100009)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11961712933415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100009)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11961928299415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100009)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11962175191415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100009)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11962394466415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100009)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11962575577415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100009)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11962750939415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100009)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11962946122415629)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100009)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11963148549415632)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11963393341415657)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\6237\540D')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11963565071415657)
,p_page_id=>9999
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100009)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\7801')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11963754998415667)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11963927092415667)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11964180869415667)
,p_page_id=>12
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100009)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11964337885415667)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100009)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11964592741415730)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \4E0D\6355\83B7\6709\5173\6B65\9AA4\7684\7528\6237\4FE1\606F 	</li>'),
unistr('     <li><strong>disabled</strong>\FF08\9ED8\8BA4\503C\FF09- \6355\83B7\6D41\5F15\64CE\5DF2\77E5\8FDB\7A0B\6B65\9AA4\7684\7528\6237 ID	 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11964625048415730)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\8BBE\7F6E\4E3A\60A8\7684\9ED8\8BA4\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA\FF0C\4EE5\9632\51FA\7AD9\90AE\4EF6 serviceTasks \672A\5B9A\4E49\53D1\4EF6\4EBA\3002')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11964832195415730)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5728 APEX \4F1A\8BDD\4E2D\4F5C\4E3A\7528\6237\7684\7528\6237\540D\FF0C\7528\4E8E\5728\672A\63D0\4F9B\5176\4ED6\7528\6237\540D\7684\60C5\51B5\4E0B\521B\5EFA\4F1A\8BDD')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11965002973415730)
,p_page_id=>7
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100009)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5220\9664\5173\8054\7684\6D41\7A0B\5B9E\4F8B')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11965270827415730)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100009)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5982\679C\7559\7A7A\FF0C\5C06\4FDD\7559\5F53\524D\7528\6237 (app_user) \7684\4EFB\52A1\3002')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11965482273415730)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\4E8E\5468\671F\8BA1\65F6\5668\FF0C\8FD9\5C06\5B9A\4E49\6700\5927\6267\884C\6570\3002')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11965651362415730)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100009)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6240\9700\683C\5F0F\FF1AYYYY-MM-DD HH24\FF1AMI:SS TZR')
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11965859772415730)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('     <li><strong>legacy</strong> - \4F7F\7528\6B64\9009\9879\4EC5\652F\6301\4F7F\7528 Flows for APEX 21.1 \53CA\66F4\4F4E\7248\672C\5F00\53D1\7684\5E94\7528\7A0B\5E8F\FF0C\65E0\9700\989D\5916\5F00\53D1\3002\5F15\64CE\4E0D\4F7F\7528\6B65\9AA4\952E\963B\6B62\5728\5355\4E2A\6B65\9AA4\4E0A\6267\884C\91CD\590D\64CD\4F5C\3002</li>'),
unistr('     <li><strong>strict</strong>\FF08\63A8\8350\FF09- \5C06\6B64\9009\9879\7528\4E8E\65B0\5F00\53D1\548C/\6216\5B8C\5168\8FC1\79FB\7684\5E94\7528\7A0B\5E8F\3002\5F15\64CE\4F7F\7528\6B65\9AA4\952E\907F\514D\5728\5355\4E2A\6B65\9AA4\4E0A\6267\884C\91CD\590D\64CD\4F5C\3002</li>'),
' </ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11966044812415730)
,p_page_id=>2
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100009)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\4E8E\5355\4E2A\6A21\578B\526F\672C\FF0C\65B0\6A21\578B\5C06\5177\6709\8F93\5165\7684\540D\79F0\FF0C\4F46\5982\679C\60A8\9009\62E9\4E86\591A\884C\FF0C\5219\8F93\5165\7684\503C\5C06\7528\4F5C\540E\7F00\3002')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11966230167415730)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\4E8E\663E\793A\9519\8BEF\6D88\606F\548C\65E5\5FD7\4E8B\4EF6\7684\8BED\8A00\3002')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11966483630415730)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('     <li><strong>legacy</strong> - \4F7F\7528\6B64\9009\9879\4EC5\652F\6301\4F7F\7528 Flows for APEX 21.1 \53CA\66F4\4F4E\7248\672C\5F00\53D1\7684\5E94\7528\7A0B\5E8F\FF0C\65E0\9700\989D\5916\5F00\53D1\3002\5F15\64CE\4E0D\4F7F\7528\6B65\9AA4\952E\963B\6B62\5728\5355\4E2A\6B65\9AA4\4E0A\6267\884C\91CD\590D\64CD\4F5C\3002</li>'),
unistr('     <li><strong>strict</strong>\FF08\63A8\8350\FF09- \5C06\6B64\9009\9879\7528\4E8E\65B0\5F00\53D1\548C/\6216\5B8C\5168\8FC1\79FB\7684\5E94\7528\7A0B\5E8F\3002\5F15\64CE\4F7F\7528\6B65\9AA4\952E\907F\514D\5728\5355\4E2A\6B65\9AA4\4E0A\6267\884C\91CD\590D\64CD\4F5C\3002</li>'),
' </ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11966673192415731)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100009)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \5DF2\7981\7528\65E5\5FD7\8BB0\5F55 	</li>'),
unistr('     <li><strong>standard</strong>\FF08\9ED8\8BA4\FF09- \8BB0\5F55\5B9E\4F8B\4E8B\4EF6 </li>'),
unistr('     <li><strong>secure</strong> - \8BB0\5F55\6A21\578B\4E8B\4EF6\548C\5B9E\4F8B\4E8B\4EF6 	</li>'),
unistr('     <li><strong>full</strong> - \8BB0\5F55\6A21\578B\3001\5B9E\4F8B\548C\8FDB\7A0B\53D8\91CF\4E8B\4EF6 		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11966809801415731)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C06\63D0\4F9B\7684\7528\4E8E\521B\5EFA\4F1A\8BDD\7684 APEX \5E94\7528\7A0B\5E8F\4E4B\4E00\7684\5E94\7528\7A0B\5E8F ID')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11967071390415731)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\4F1A\8BDD\65F6\5C06\63D0\4F9B\7684\5E94\7528\7A0B\5E8F\7684\9875\9762 ID')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11967244270415731)
,p_page_id=>36
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100009)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BF9\4E8E\5468\671F\8BA1\65F6\5668\FF0C\8FD9\5C06\5B9A\4E49\6700\5927\6267\884C\6570\3002')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11967458376415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\8BBE\7F6E\4E3A\7528\4E8E APEXFlows for APEX \7684 Flows \7684\9ED8\8BA4 APEX \5DE5\4F5C\533A\3002\8FD9\5728\521B\5EFA APEX \4F1A\8BDD\6216\67E5\627E\90AE\4EF6\6A21\677F\65F6\7528\4F5C scriptTasks \548C serviceTasks \7684\6700\540E\6392\5E8F')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11967648245415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \4E0D\6355\83B7\6709\5173\6B65\9AA4\7684\7528\6237\4FE1\606F 	</li>'),
unistr('     <li><strong>disabled</strong>\FF08\9ED8\8BA4\503C\FF09- \6355\83B7\6D41\5F15\64CE\5DF2\77E5\8FDB\7A0B\6B65\9AA4\7684\7528\6237 ID	 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11967804486415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5728 APEX \4F1A\8BDD\4E2D\4F5C\4E3A\7528\6237\4EE5\5728\672A\63D0\4F9B\5176\4ED6\7528\6237\540D\7684\60C5\51B5\4E0B\521B\5EFA\4F1A\8BDD\7684\7528\6237\540D')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11968022138415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100009)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong>\FF08\9ED8\8BA4\8BBE\7F6E\FF09- \963B\6B62\7F16\8F91\5DF2\53D1\5E03\6A21\578B\7684\56FE\8868 </li>'),
unistr('     <li><strong>development </strong> - \5141\8BB8\7F16\8F91\5DF2\53D1\5E03\6A21\578B\7684\56FE\8868 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11968236977415731)
,p_page_id=>32
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100009)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\4E8E\663E\793A\9519\8BEF\6D88\606F\548C\65E5\5FD7\4E8B\4EF6\7684\8BED\8A00\3002')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11968469584415731)
,p_page_id=>34
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100009)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong>\FF08\9ED8\8BA4\8BBE\7F6E\FF09- \963B\6B62\7F16\8F91\5DF2\53D1\5E03\6A21\578B\7684\56FE\8868 </li>'),
unistr('     <li><strong>development</strong> - \5141\8BB8\7F16\8F91\5DF2\53D1\5E03\6A21\578B\7684\56FE\8868 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11968689028415731)
,p_page_id=>35
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100009)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\8BBE\7F6E\4E3A\7528\4E8E APEXFlows for APEX \7684 Flows \7684\9ED8\8BA4 APEX \5DE5\4F5C\533A\3002\8FD9\5728\521B\5EFA APEX \4F1A\8BDD\6216\67E5\627E\90AE\4EF6\6A21\677F\65F6\7528\4F5C scriptTasks \548C serviceTasks \7684\6700\540E\6392\5E8F\3002')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11968855627415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C06\63D0\4F9B\7528\4E8E\521B\5EFA\4F1A\8BDD\7684 APEX \5E94\7528\7A0B\5E8F\4E4B\4E00\7684\5E94\7528\7A0B\5E8F ID')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11969039313415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100009)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \5DF2\7981\7528\65E5\5FD7\8BB0\5F55 	</li>'),
unistr('     <li><strong>standard</strong>\FF08\9ED8\8BA4\FF09- \8BB0\5F55\5B9E\4F8B\4E8B\4EF6 </li>'),
unistr('     <li><strong>secure</strong> - \8BB0\5F55\6A21\578B\4E8B\4EF6\548C\5B9E\4F8B\4E8B\4EF6 	</li>'),
unistr('     <li><strong>full</strong> - \8BB0\5F55\6A21\578B\3001\5B9E\4F8B\548C\8FDB\7A0B\53D8\91CF\4E8B\4EF6 		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11969222172415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100009)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521B\5EFA\4F1A\8BDD\65F6\5C06\63D0\4F9B\7684\5E94\7528\7A0B\5E8F\7684\9875\9762 ID')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11969484165415731)
,p_page_id=>100
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100009)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5E94\8BBE\7F6E\4E3A\60A8\7684\9ED8\8BA4\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA\FF0C\4EE5\9632\51FA\7AD9\90AE\4EF6 serviceTasks \672A\5B9A\4E49\53D1\4EF6\4EBA\3002')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11969693771415737)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100009)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11969816960415741)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11970028969415741)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\79D2\949F')
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11970238671415742)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100009)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11970486356415742)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9E\4F8B\9519\8BEF')
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11970647338415742)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9519\8BEF')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11970867758415742)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\5927\503C')
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11971064726415742)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100009)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - \6700\5927\503C')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11971258647415743)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9519\8BEF')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11971499210415743)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\542F\52A8\5B9E\4F8B')
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11971669397415743)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6301\7EED\65F6\95F4 - 90pc')
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11971836670415743)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6301\7EED\65F6\95F4 - 10pc')
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11972087964415743)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100009)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11972244175415743)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\7EC8\6B62\7684\5B9E\4F8B')
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11972475529415743)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90pc \6301\7EED\65F6\95F4')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11972665778415743)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100009)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \767E\5206\4F4D')
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11972840253415743)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('50 \767E\5206\4F4D')
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11973093230415743)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100009)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 90pc')
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11973277890415743)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100009)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7CFB\5217 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11973494607415743)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100009)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\521B\5EFA')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11973608214415743)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100009)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11973838348415743)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 10pc')
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11974022441415743)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100009)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\542F\52A8')
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11974262156415743)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100009)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7CFB\5217 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11974429873415743)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90 \767E\5206\4F4D')
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11974664903415743)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6301\7EED\65F6\95F4 - 50pc')
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11974812119415743)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100009)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B63\5728\8FD0\884C')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11975053399415743)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100009)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11975241131415743)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11975416454415744)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\7EC8\6B62')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11975646827415744)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\5B9E\4F8B\6570')
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11975870861415744)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 10pc')
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11976014587415744)
,p_page_id=>16
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100009)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E2D\503C\6301\7EED\65F6\95F4')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11976273942415744)
,p_page_id=>3
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100009)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11976421234415744)
,p_page_id=>15
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100009)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\7F6E')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11976698250415744)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100009)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 50pc')
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11976846608415744)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 50pc')
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11977005966415744)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100009)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6301\7EED\65F6\95F4 - \6700\5927\503C')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11977227666415744)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - \6700\5927\503C')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11977404751415744)
,p_page_id=>17
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100009)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 90pc')
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11977695310415753)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100009)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11977851047415753)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100009)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11978008345415753)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100009)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\522B')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11978297760415753)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100009)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11978485463415753)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100009)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72B6\6001')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11978632728415754)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100009)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\79F0')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11978822590415754)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100009)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C7B\522B')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11979026289415754)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100009)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11979235216415755)
,p_translated_flow_id=>100009
,p_translate_to_id=>100.100009
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11979426088415802)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100009)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\5B9E\4F8B\6C47\603B\5B58\6863\6D41\7A0B\9519\8BEF')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11979623267415802)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100009)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error purging Flows for APEX Statistics summaries'
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11979864637415802)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100009)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \6E05\9664\65E5\5FD7\8868\65F6\51FA\9519\3002')
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11980020245415802)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100009)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error gathering daily Flows for APEX Stats'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11980282244415809)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11980481691415814)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11980633647415814)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100009)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11980857314415855)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>6.100008
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11980949637415855)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>50.100008
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11981123883415855)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>14.100008
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\8A8C')
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11981392065415855)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>51.100008
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7DE8\8F2F\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11981525758415855)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>1.100008
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5165\9580')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11981782851415855)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>7.100008
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B')
,p_translate_from_text=>'Flow'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11981973447415855)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>15.100008
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\7D71\8A08')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11982107926415855)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>31.100008
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - REST - \5F9E\5C6C\7AEF')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11982312488415855)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>36.100008
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \8A08\6642\5668')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11982532910415855)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>34.100008
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5F15\64CE App')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11982709599415855)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>11.100008
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\6D41\7A0B\5BE6\4F8B')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11982927860415855)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>30.100008
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11983135034415855)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>2.100008
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11983340741415855)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>8.100008
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5BE6\4F8B\660E\7D30')
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11983573840415855)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>12.100008
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6AA2\8996\5668')
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11983765387415855)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>17.100008
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52D9\7D71\8A08')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11983994572415855)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>37.100008
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \7D71\8A08\8CC7\6599')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11984185649415856)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>4.100008
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5EFA\6A21\5DE5\5177')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11984328157415856)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>5.100008
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11984523712415856)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>10.100008
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76E3\8996\5668')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11984783633415856)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>35.100008
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5F15\64CE')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11984911359415856)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>33.100008
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5C01\5B58\4E2D')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11985160770415856)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>3.100008
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5100\8868\677F')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11985398095415856)
,p_page_id=>9
,p_translated_flow_id=>100008
,p_translate_to_id=>9.100008
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11985540031415856)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>20.100008
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\74B0\5883\6642\9593\8EF8 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11985765784415856)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>38.100008
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5730\9EDE')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11985934159415856)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>13.100008
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7269\4EF6\660E\7D30')
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11986182236415856)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>39.100008
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \6388\6B0A')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11986353813415856)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>16.100008
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\4F5C\696D\7D71\8A08\8CC7\6599')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11986500472415856)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>32.100008
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \8A18\9304\65E5\8A8C')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11986720350415856)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>100.100008
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B [OLD\FF0CBACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11986966651415856)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>9999.100008
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\5165\9801\9762')
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11987167234415857)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>6.100008
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11987378950415857)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>50.100008
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11987546147415857)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>51.100008
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7DE8\8F2F\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11987741847415857)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>1.100008
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5165\9580 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11987949316415857)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>7.100008
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11988163436415857)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>15.100008
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\7D71\8A08')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11988397546415857)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>31.100008
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - REST - \5F9E\5C6C\7AEF')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11988550582415857)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>36.100008
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \8A08\6642\5668')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11988726845415857)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>34.100008
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5F15\64CE App')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11988918532415857)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>11.100008
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\6D41\7A0B\57F7\884C\74B0\5883 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11989170283415857)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>30.100008
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11989325859415858)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>2.100008
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11989530095415858)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>8.100008
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5BE6\4F8B\660E\7D30 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11989779413415858)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>12.100008
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76E3\8996\5668 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11989909669415858)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>17.100008
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52D9\7D71\8A08')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11990163128415858)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>37.100008
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \7D71\8A08\8CC7\6599')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11990392283415858)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>4.100008
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\6A21\578B\7A0B\5F0F - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11990594132415858)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>5.100008
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\51FA - &APP_NAME_TITLE.')
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11990792957415858)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>10.100008
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76E3\8996\5668 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11990929030415858)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>35.100008
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5F15\64CE')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11991193766415858)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>33.100008
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5C01\5B58\4E2D')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11991301913415858)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>3.100008
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5100\8868\677F - &APP_NAME_TITLE.')
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11991595924415858)
,p_page_id=>9
,p_translated_flow_id=>100008
,p_translate_to_id=>9.100008
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11991727800415858)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>20.100008
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\74B0\5883\6642\9593\8EF8 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11991980739415858)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>38.100008
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \5730\9EDE')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11992194861415858)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>39.100008
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \6388\6B0A')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11992308834415858)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>16.100008
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\4F5C\696D\7D71\8A08\8CC7\6599')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11992520363415858)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>32.100008
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \8A18\9304\65E5\8A8C')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11992733854415858)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>100.100008
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B [OLD\FF0CBACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11992958183415858)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>9999.100008
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11993187241415859)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100008)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5168\9078')
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11993323984415859)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100008)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A2D\5B9A\9598\9053\8DEF\7531')
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11993565601415859)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100008)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11993733928415859)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100008)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11993999728415859)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11994164496415860)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100008)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88\5168\9078')
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11994306186415860)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\589E')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11994525261415860)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100008)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A2D\5B9A\8655\7406\8B8A\6578')
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11994792905415860)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100008)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11994933504415860)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100008)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \7D44\614B')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11995127684415860)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11995320197415860)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100008)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165\8207\7DE8\8F2F')
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11995517733415860)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100008)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11995792611415860)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100008)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11995944860415860)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11996116386415860)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100008)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11996312518415860)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11996559961415860)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63A5\6536\8A0A\606F')
,p_translate_from_text=>'Receive Message'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11996773717415860)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100008)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11996954182415860)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100008)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11997134582415860)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11997317176415860)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100008)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11997552190415861)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100008)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11997778889415861)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100008)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\6A21\578B')
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11997912074415861)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100008)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11998103060415861)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100008)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5132\5B58')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11998304851415861)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100008)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11998502273415861)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100008)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165\8207\532F\5165\5176\4ED6')
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11998772315415861)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100008)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11998963808415861)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8907\88FD\6A21\578B')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11999148407415861)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100008)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11999358543415861)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100008)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11999518559415861)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\5165')
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11999734015415861)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100008)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(11999900438415861)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100008)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \7D44\614B')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12000134245415861)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12000300021415861)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\7BC4\672C')
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12000527055415861)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100008)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5716\8868')
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12000740374415861)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100008)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12000937064415861)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100008)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\589E\7248\672C')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12001166501415861)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12001308275415862)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12001591701415862)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100008)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12001703370415862)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B58\6A94')
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12001993852415862)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12002132656415862)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100008)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12002344759415862)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100008)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12002510810415862)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100008)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12002788628415862)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12002935898415862)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100008)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\6B77\53F2\8CC7\8A0A')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12003183254415862)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100008)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12003307011415862)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\57F7\884C\8655\7406')
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12003568294415862)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100008)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12003712560415862)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100008)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12003967549415862)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100008)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12004199639415862)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100008)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12004395080415862)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100008)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12004537869415862)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0D\518D\4F7F\7528')
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12004705298415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12004949222415863)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100008)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\589E\7248\672C')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12005180714415863)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100008)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12005330425415863)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7DE8\8F2F\7D44\614B')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12005560463415863)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100008)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12005764827415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5957\7528\8B8A\66F4')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12005977535415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6392\5B9A\8A08\6642\5668')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12006188577415863)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12006378084415863)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100008)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12006540582415863)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100008)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\78BA\8A8D')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12006716860415863)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100008)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7DE8\8F2F\7D44\614B')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12006960421415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100008)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\589E')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12007117238415863)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100008)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12007395166415863)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100008)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12007596602415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\78BA\8A8D')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12007766410415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100008)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12007962825415863)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100008)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12008136029415863)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100008)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5132\5B58')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12008307965415865)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100008)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12008501105415865)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\96B1\85CF\4F7F\7528\8005 ID')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12008735392415865)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID \8CC7\6599\6B04')
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12008962526415865)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6388\6B0A\91D1\9470')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12009106364415865)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\6233\8CC7\6599\6B04')
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12009351614415865)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57FA\790E URL')
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12009525089415865)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100008)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12009762782415865)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6709\6548\8CA0\8F09')
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12009948224415865)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100008)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9023\7DDA')
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12010198525415865)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12010368435415865)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12010508216415865)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\5716')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12010712690415865)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12010920573415866)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12011108009415866)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12011331954415866)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12011545230415866)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\91CD\8907\9593\9694')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12011700635415866)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A94\6848\540D\7A31')
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12011969251415866)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12012123665415866)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\6BB5\540D\7A31')
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12012303395415866)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100008)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6388\6B0A\7248\672C')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12012511424415866)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100008)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165\4F86\6E90')
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12012793933415866)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\696D')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12012902118415866)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12013143966415866)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12013378432415866)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\4EF6\5B57\9996')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12013527103415866)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\671F')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12013707083415866)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\5EFA')
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12013910184415866)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100008)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F37\5236\8986\5BEB')
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12014110827415866)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A02')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12014390607415866)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\9031\671F\4E0A\9650')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12014538107415866)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\985E')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12014726231415866)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12014964429415867)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8005')
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12015177235415867)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\683C\540D\7A31')
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12015362074415867)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\542B\6700\5F8C\8B8A\66F4\65E5\671F')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12015581520415867)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\985E\578B')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12015777713415867)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100008)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9598\9053')
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12015925117415867)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\6BCF\6708\6458\8981 (\6708)')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12016121315415867)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A0A\606F\6D41\7A0B\65E5\8A8C\4FDD\7559 (\5929) ')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12016327001415867)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100008)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\758A\986F\793A')
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12016526124415867)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100008)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12016702697415867)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\5C64\6B21')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12016906153415867)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12017188107415867)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\78BC')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12017364548415867)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\65E5\8A8C (\5929)')
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12017584224415867)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12017782529415867)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5716\8868 Xml')
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12017957204415867)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\542B\7248\672C')
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12018157998415867)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A94\6848')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12018315832415867)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6392\7A0B\8A08\6642\5668\65BC')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12018597920415867)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\5B58\6A94\4F4D\7F6E')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12018752813415867)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12018946080415868)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F09\70BA')
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12019125596415868)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12019383694415868)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\8B8A\6578')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12019538510415868)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F9E\5C6C\7AEF\5BC6\78BC')
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12019761437415868)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\9632\91CD\8907\6B65\9A5F')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12019987978415868)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\540D\7A31 / \5B57\5C3E')
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12020110813415868)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX \8B49\660E\8CC7\6599\975C\614B ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12020306535415868)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A9E\8A00')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12020512188415868)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\975C\614B ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12020709156415868)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100008)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64C1\6709\8005')
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12020907947415868)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6388\6B0A\5C0D\8C61')
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12021119334415868)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\9632\91CD\8907\6B65\9A5F')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12021378377415868)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C64\6B21')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12021504925415868)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\61C9\7528\7A0B\5F0F ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12021719698415868)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\9801\9762 ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12021936290415868)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12022167119415868)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7BC4\570D')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12022345171415868)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\696D\52D9\53C3\8003 (\8655\7406\8B8A\6578)')
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12022551181415868)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\542B\985E\76EE')
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12022774889415868)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\5165\5167\9001 MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12022960523415869)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100008)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\9031\671F\4E0A\9650')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12023188152415869)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\7684\5730\985E\578B')
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12023383728415869)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12023588823415869)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\5F0F')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12023797815415869)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8CBC\4E0A BPMN \6A94\6848\5167\5BB9 (\6700\591A 30 \500B 000 \500B\5B57\5143)')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12023979050415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\5DE5\4F5C\5340')
,p_translate_from_text=>'Default Workspace'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12024176836415869)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\6BCF\65E5\5F59\7E3D (\5929\6578)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12024389992415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\96B1\85CF\4F7F\7528\8005 ID')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12024544963415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\5165\5167\9001 MessageFlow ')
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12024719939415869)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\65E5\8A8C (\8655\7406\4F5C\696D\57F7\884C\8655\7406\5B8C\6210\5F8C\7684\5929\6578)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12024969218415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12025152153415869)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX \8B49\660E\8CC7\6599\975C\614B ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12025389409415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\555F\7528\8A08\6642\5668')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12025553348415869)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Blob \8CC7\6599\6B04')
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12025738584415869)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100008)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\7167\5230\671F\65E5')
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12025934097415869)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12026188577415869)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A18\9304\50B3\5165\7684 Rest \547C\53EB')
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12026349904415869)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\5C0E\5411 URI')
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12026514435415869)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\5148\6388\6B0A URL')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12026788062415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100008)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\5F0F')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12026943112415869)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\65E5\8A8C (\8655\7406\4F5C\696D\57F7\884C\8655\7406\5B8C\6210\5F8C\7684\5929\6578)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12027117665415870)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\652F\63F4 URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12027328845415870)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\542B\72C0\614B')
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12027551471415870)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12027792416415870)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100008)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A9E\8A00')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12027974778415870)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\4EF6\5B57\9996')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12028118632415870)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\555F\7528\57F7\884C\8655\7406\6458\8981\5B58\6A94\529F\80FD')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12028373799415870)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12028535048415870)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\61C9\7528\7A0B\5F0F ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12028706849415870)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12028953096415870)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100008)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\5F0F')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12029150171415870)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A18\4F4F\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12029397924415870)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12029514966415870)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\5DE5\4F5C\5340')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12029701193415870)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7ACB\5373\91CD\65B0\6392\5B9A\8A08\6642\5668')
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12029902333415870)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A0A\606F\6D41\7A0B\65E5\8A8C\4FDD\7559 (\5929) ')
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12030108522415870)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12030326802415870)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63CF\8FF0')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12030593705415870)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C64\6B21')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12030792178415870)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12030912238415871)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\6BCF\5B63\6458\8981 (\6708)')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12031100540415871)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\6578\540D\7A31')
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12031339318415871)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F9E\5C6C\7AEF ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12031542019415871)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\9801\9762 ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12031778909415871)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100008)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57FA\672C URL')
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12031933548415871)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6280\8853\652F\63F4\4FE1\7BB1')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12032191586415871)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\555F\7528\8A08\6642\5668')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12032308289415871)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12032563034415871)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100008)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12032788290415871)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\985E')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12032936540415871)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\641C\5C0B')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12033125542415871)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100008)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12033356678415871)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\555F\7528\57F7\884C\8655\7406\6458\8981\5B58\6A94\529F\80FD')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12033542005415871)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A2D\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12033704749415873)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100008)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7121\6548\7684 JSON \683C\5F0F')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12033904583415873)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100008)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\9808\6709\503C\3002')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12034102583415873)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100008)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8ACB\6AA2\67E5\63D0\4F9B\7684\6D41\7A0B\3002')
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12034358309415873)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\9808\6709\503C\3002')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12034547952415874)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100008)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\9808\6709\503C\3002')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12034783785415874)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# \5FC5\9808\6709\503C\3002')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12034980420415874)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\60A8\7121\6CD5\5C01\5B58\8207\57F7\884C\4E2D\5BE6\4F8B\76F8\95DC\806F\7684\6A21\578B\3002')
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12035105478415874)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100008)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8ACB\8CBC\4E0A BPMN \6A94\6848\5167\5BB9')
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12035337539415874)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100008)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8ACB\9078\53D6 #LABEL#\3002')
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12035538270415874)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\5DF2\5B58\5728\3002\4F7F\7528\5F37\5236\8986\5BEB \3002')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12035757955415874)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\5DF2\5B58\5728\3002\4F7F\7528\5F37\5236\8986\5BEB \3002')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12035998970415874)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\532F\5165\6A21\578B\3002')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12036163893415874)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100008)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12036369363415874)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100008)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12036510525415874)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100008)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12036714641415875)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100008)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12036927602415875)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100008)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12037165707415875)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100008)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5132\5B58 Rest \7D44\614B\FF01')
,p_translate_from_text=>'Rest Configuration saved!'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12037347725415875)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12037531447415875)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100008)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12037725360415875)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100008)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12037997332415875)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100008)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12038156089415875)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100008)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\8655\7406\52D5\4F5C\3002')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12038396991415875)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100008)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12038579045415875)
,p_page_id=>9
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100008)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\66F4\5DF2\5132\5B58\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12038721868415875)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\532F\5165\6A21\578B\3002')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12038913518415876)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100008)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12039163373415876)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100008)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12039325651415876)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100008)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\8A73\7D30\8CC7\8A0A')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12039569475415876)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100008)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12039799747415876)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100008)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('OAUTH \5F9E\5C6C\7AEF')
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12039954735415876)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100008)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12040199034415876)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100008)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12040306338415876)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100008)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12040599055415876)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100008)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7D44\614B - REST - \5F9E\5C6C\7AEF')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12040728622415876)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100008)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12040915131415876)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8655\7406\7E3E\6548 (\671F\9593\5F59\7E3D)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12041123577415876)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100008)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\76EE\524D\7684\5B50\6D41\7A0B')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12041398219415876)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100008)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\9215\5217')
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12041554660415876)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100008)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8B8A\6578\6B77\53F2\8A18\9304')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12041706658415876)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100008)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON \7D44\614B')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12041944476415876)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100008)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A08\6642')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12042169614415877)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6B65\9A5F\4E8B\4EF6')
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12042374212415877)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12042574704415877)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100008)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12042733191415877)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6BCF\4E00\72C0\614B\7684\6D41\7A0B\57F7\884C\8655\7406\6578')
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12042985750415877)
,p_page_id=>9
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100008)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5340\6BB5')
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12043112596415877)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100008)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B8C\6210\7684\6B65\9A5F')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12043333118415877)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\641C\5C0B')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12043536597415877)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5716\8868\660E\7D30')
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12043765281415877)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A0A\606F\8A02\95B1')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12043950111415877)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100008)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\88AB\53EB\5716\8868')
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12044172925415877)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100008)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12044325281415877)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100008)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12044557576415877)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100008)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5165\9580')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12044775632415877)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\5BE6\4F8B')
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12044930757415877)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5EFA\7ACB\6D41\7A0B\5BE6\4F8B')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12045135926415877)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100008)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7248\672C\4E0D\76F8\7B26')
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12045337704415877)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100008)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\532F\5165\6D41\7A0B')
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12045555771415877)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100008)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12045707980415877)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\907A\6F0F\5148\6C7A\689D\4EF6')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12045917718415877)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100008)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\9215')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12046122112415877)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100008)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12046329066415878)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100008)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\641C\5C0B\7D50\679C')
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12046579339415878)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100008)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE\61C9\7528\7A0B\5F0F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12046779019415878)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100008)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7D71\8A08')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12046919141415878)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100008)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE\61C9\7528\7A0B\5F0F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12047134044415878)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\904E\53BB 14 \5929\7684\57F7\884C\8655\7406\932F\8AA4')
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12047382686415878)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100008)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON \7D44\614B')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12047521563415878)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100008)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12047753292415878)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\6AA2\8996\5668')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12047956707415878)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100008)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C6C\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12048154492415878)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5730\9EDE')
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12048359156415878)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100008)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9078\9805')
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12048582142415878)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100008)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\589E\9598\9053\8DEF\7531')
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12048726911415878)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100008)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\88AB\53EB\5716')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12048942107415878)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100008)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12049163231415878)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100008)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9023\7D50')
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12049350065415878)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12049504304415878)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12049703562415878)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12049987677415878)
,p_page_id=>9
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100008)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12050152047415878)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\907A\6F0F\6A21\7D44')
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12050340995415878)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12050587804415878)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12050787114415879)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100008)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\5BE6\4F8B')
,p_translate_from_text=>'Flow Instances'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12050905412415879)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\9215\5340')
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12051153929415879)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100008)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12051364637415879)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8907\88FD\6A21\578B')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12051529255415879)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4E0A\4E00\500B\932F\8AA4')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12051715033415879)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100008)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME. \7684\6B77\53F2\6B65\9A5F\7B49\5F85\6642\9593\3002(&P17_OBJT_BPMN_ID.)')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12051936533415879)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100008)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C6C\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12052107621415879)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100008)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\5B50\6D41\7A0B')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12052346366415879)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100008)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\76EE\524D\6B65\9A5F')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12052562486415879)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\6AA2\8996\5668')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12052727483415879)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100008)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A18\9304')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12052912365415879)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100008)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6B78\6A94\4E2D')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12053130621415879)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100008)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12053390265415879)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100008)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12053527522415879)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100008)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12053743238415879)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100008)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12053957790415879)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100008)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C0E\89BD\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12054183374415879)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\547C\53EB\5716\8868')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12054386746415879)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100008)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6388\6B0A')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12054527771415879)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12054774971415879)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100008)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12054954145415880)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100008)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12055154811415880)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\672A\555F\7528 REST')
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12055339324415880)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9801\7C64')
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12055585898415880)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100008)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME. \7684\6B77\53F2\6B65\9A5F\7E3E\6548\3002(&P17_OBJT_BPMN_ID.)')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12055707001415880)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\89D2\8272')
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12055941898415880)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100008)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\532F\5165\8B66\544A')
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12056126538415880)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\8A73\7D30\8CC7\8A0A')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12056399708415880)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100008)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12056568428415880)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12056707405415880)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\8A73\7D30\8CC7\8A0A')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12056977513415880)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100008)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8B8A\6578\6B77\53F2\8A18\9304')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12057112921415880)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7D44\614B')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12057390844415880)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100008)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A08\6642')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12057507309415880)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100008)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\76EE\524D\903E\671F\6D41\7A0B\5BE6\4F8B')
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12057763200415880)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100008)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12057930182415880)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8CC7\8A0A')
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12058139261415880)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100008)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12058322585415880)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12058566426415880)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100008)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12058797167415880)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100008)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\958B\59CB\65BC &P15_DATE. \7684\8655\7406\3002')
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12058995510415881)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100008)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5176\4ED6\5B89\88DD\6B65\9A5F\672A\5B8C\6210')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12059191521415881)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100008)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7DE8\8F2F\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12059330263415881)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100008)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12059596407415881)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100008)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12059790822415881)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100008)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12059944197415881)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100008)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F5C\696D\6B65\9A5F\7E3E\6548 (\672C\6708) - &P16_DGRM_NAME_VERSION. (dgrm_id \FF1A&P16_DGRM_ID.)')
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12060127809415881)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6B65\9A5F\932F\8AA4')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12060391200415881)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B XML')
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12060593181415881)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100008)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8F38\5165 / \8F38\51FA\8B8A\6578')
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12060795697415881)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\586B\5BEB\8A73\7D30\8CC7\8A0A')
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12060910590415881)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100008)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\7248\672C')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12061130519415881)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100008)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8B8A\6578')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12061383852415881)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100008)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12061599982415881)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100008)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C0E\89BD\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12061747329415881)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100008)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6BCF\500B\72C0\614B\7684\8655\7406\4F5C\696D\57F7\884C\8655\7406')
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12061922767415881)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100008)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\522A\9664\6A21\578B')
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12062100183415881)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100008)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12062357296415881)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\9078\64C7\4F5C\7528\4E2D\76EE\7684\5730')
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12062541347415881)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100008)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6BCF\4E00\6A21\578B\7684\6D41\7A0B\57F7\884C\8655\7406 - \524D 10 \540D')
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12062732625415881)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100008)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4FDD\7559\6B65\9A5F')
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12062902558415881)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100008)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\589E / \7DE8\8F2F\8655\7406\8B8A\6578')
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12063164731415882)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12063319973415882)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4F86\6E90\8DEF\5F91')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12063509297415882)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100008)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\904E\53BB 7 \5929\5167\5EFA\7ACB\7684\6D41\7A0B\57F7\884C\8655\7406')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12063754677415882)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12063985843415882)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100008)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12064123182415882)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5DF2\505C\7528\8A08\6642\5668')
,p_translate_from_text=>'Timers disabled'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12064349370415882)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100008)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12064542326415882)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\91CD\65B0\6392\5B9A\8A08\6642\5668')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12064798133415882)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5075\6E2C\5230 APEX \5347\7D1A')
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12064919548415882)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12065158532415882)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5165\9580')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12065318992415882)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C6C\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12065537533415882)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100008)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\95DC\806F\7684\8655\7406\4F5C\696D\57F7\884C\8655\7406')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12065760620415882)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12065920762415882)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100008)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12066174808415882)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\76E3\8996\5668 (&P12_PRCS_NAME.)')
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12066339703415882)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A9E\8A00\9078\64C7\5668')
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12066529094415882)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100008)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6309\9215')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12066739750415882)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100008)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A18\9304')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12066986816415882)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\6D41\7A0B\6AA2\8996\5668')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12067125055415883)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12067367392415883)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\63A5\6536\8A0A\606F')
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12067573367415883)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12067787915415883)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\932F\8AA4')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12067900733415883)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5167\5BB9')
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12068172332415885)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100008)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12068373329415885)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12068511824415885)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12068755797415885)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100008)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12068919067415886)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100008)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12069102974415886)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12069382769415886)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12069513502415886)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100008)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12069776807415886)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100008)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\82E5\8981\4EE5\5BA3\544A\65B9\5F0F\5EFA\7ACB\81EA\5DF1\7684\8868\55AE\5B9A\7FA9\FF0C\60A8\53EF\4EE5\4F7F\7528<a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">\7C21\6613\8868\55AE\88FD\4F5C\5668</span></a>\4F86\7522\751F\5FC5\8981\7684 JSON\3002')
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12069921732415886)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100008)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12070181845415886)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12070333694415886)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100008)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12070577368415886)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li> \672A\5B89\88DD REST \6A21\7D44\3002\8ACB\4F9D\7167\4E0B\5217\5B89\88DD\6307\5357\64CD\4F5C\FF1A<a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12070768478415886)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12070985558415886)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100008)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12071170417415886)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100008)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6211\5011\5EFA\8B70\60A8\532F\5165\4F7F\7528 Flows for APEX \5EFA\7ACB\7684\6A21\578B\FF0C\4EE5\78BA\4FDD\5F15\64CE\53EF\4EE5\57F7\884C\9019\4E9B\6A21\578B\3002')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12071393388415887)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>\7DB1\8981\672A\555F\7528 REST</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12071529847415887)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\5728\6B64\9801\9762\4E2D\7BA1\7406\300C\7C21\6613\8868\55AE\300D\6A23\677F\7684 JSON \5B9A\7FA9\3002\60A8\7684\7BC4\672C\6709\5169\7A2E\4F7F\7528\65B9\5F0F\FF1A<ul>'),
unistr('    <li>\5728\6D41\7A0B\6A21\578B\4E2D\300C\7C21\55AE\8868\55AE\300D\985E\578B\7684\300C\4F7F\7528\8005\5DE5\4F5C\300D\4E0A\9078\53D6\5B83\5011</li>'),
unistr('    <li>\586B\5BEB\8868\55AE\FF0C\5373\53EF\5728\300C\6D41\7A0B\300D\5206\9001\7684<strong>\7C21\55AE\6D41\7A0B\5165\9580 App</strong> \4E2D\4F7F\7528\9019\4E9B App \4F86\958B\59CB\8655\7406\57F7\884C\8655\7406</ul>')))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12071704258415887)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100008)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12071938381415887)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100008)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12072164960415887)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100008)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\82E5\8981\4F7F\7528 Flows for APEX \7684 Timers \529F\80FD\FF0C\60A8\5FC5\9808\5B8C\6210\5176\4ED6\5B89\88DD\6B65\9A5F\FF0C\60A8\53EF\4EE5\5728 <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank"> \9019\88E1\627E\5230 </a>\3002')
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12072318840415887)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100008)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12072551050415887)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100008)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12072744813415887)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5305\542B\4E00\6216\591A\500B\8A08\6642\5668\7684\6A21\578B\5728\6B64\7CFB\7D71\4E0A\7121\6CD5\6B63\5E38\904B\4F5C\FF0C\56E0\70BA\5B83\5011\5DF2\505C\7528\3002<br> \60A8\53EF\4EE5\5728\300C\7D44\614B\300D\9801\9762\4E2D\555F\7528\3002')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12072996770415887)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12073145822415887)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100008)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12073347455415887)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100008)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12073556596415887)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>APEX \7684\4F4E\7A0B\5F0F\78BC\3001BPMN \578B\8655\7406\6D41\7A0B\7CFB\7D71\3002</h3>'),
unistr('<h4> \529F\80FD</h4>'),
'<ul>',
unistr('<li>Flows for APEX \53EF\8B93 APEX \958B\767C\4EBA\54E1\4F7F\7528\8996\89BA\5316\8655\7406\8A2D\8A08\548C\4F4E\7A0B\5F0F\78BC\6280\8853\7D44\5408\FF0C\5728 APEX \4E2D\5EFA\7ACB\548C\57F7\884C\8655\7406\6D41\7A0B\7684\6A21\578B\3002</li>'),
unistr('<li>Flows for APEX \4E3B\8981\662F\91DD\5C0D APEX \958B\767C\4EBA\54E1\6240\8A2D\8A08\FF0C\4F7F\7528\60A8\719F\6089\7684\6280\8853 - APEX\3001PL/SQL \548C SQL - \5728\60A8\7684 APEX \74B0\5883\4E2D\5EFA\7ACB\529F\80FD\5F37\5927\4E14\5F48\6027\7684\8655\7406\6D41\7A0B\3002</li>'),
unistr('<li>\7528\4F86\5EFA\7ACB\548C\57F7\884C APEX \9801\9762\3001PL/SQL \6307\4EE4\78BC\3001\50B3\9001\96FB\5B50\90F5\4EF6\7684\8655\7406\6D41\7A0B\3002</li>'),
unistr('<li> \696D\52D9\4F7F\7528\8005\4E5F\53EF\4EE5\77AD\89E3\4E26\7DE8\8F2F\4F4E\7A0B\5F0F\78BC\5716\8868\8655\7406\5B9A\7FA9\FF0C\4EE5\63D0\5347\696D\52D9\5F48\6027\3002\6D41\7A0B\4F7F\7528 Business Process Modeling Notation (BPMN) V2 \6A23\5F0F</li>'),
unistr('<li>\5EFA\7F6E\70BA APEX \793E\7FA4\5C08\6848\FF0C\4E26\5728\958B\6E90 MIT \6388\6B0A\4E0A\767C\884C\3002</li>'),
'</ul>',
'<p>',
unistr('<h4>\4E0B\8F09</h4>'),
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a> <p>',
unistr('<h4>\6587\4EF6</h4>'),
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">\6700\65B0\7684\7DDA\4E0A\6587\4EF6</a> <p>'),
unistr('<h4>BPMN \6559\5B78\8AB2\7A0B</h4>'),
unistr('\82E5\8981\958B\59CB\4F7F\7528\6A21\578B\6D41\7A0B\FF0C\8ACB\5617\8A66\9810\5148\5B89\88DD\7684\6559\5B78\8AB2\7A0B\6D41\7A0B\3002\5982\9700\6559\5B78\8AB2\7A0B\7684\9032\4E00\6B65\8CC7\8A0A\FF0C\8ACB\53C3\95B1<a href="https://flowsforapex.org/latest/tutorials/" target="_blank">\9019\500B\7DB2\9801</a>\3002<p>'),
unistr('<h4>\793A\7BC4\61C9\7528\7A0B\5F0F</h4>'),
'<p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12073748324415887)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100008)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12073953099415888)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12074135864415889)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100008)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \4F4D\7F6E')
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12074397559415889)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12074519228415889)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100008)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B58\6A94\4F4D\7F6E')
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12074712174415889)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EBA\624D\62DB\8058')
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12074982041415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100008)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12075132105415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100008)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12075341049415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100008)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12075517868415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100008)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12075764894415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100008)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6574\7406')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12075958899415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100008)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12076197243415889)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100008)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8907\88FD')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12076316919415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100008)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\6B62')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12076573573415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100008)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12076752509415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100008)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\6B62')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12076989349415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100008)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E3B\984C')
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12077196097415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100008)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6388\6B0A')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12077357263415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100008)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\6B62')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12077537079415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100008)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76E3\8996\5668')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12077750276415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12077961114415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100008)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6574\7406')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12078168121415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100008)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12078396681415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100008)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\660E\7D30')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12078504382415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100008)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\589E\7248\672C')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12078789258415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100008)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12078993926415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100008)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F09 (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12079162204415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12079333284415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100008)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\6458\8981')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12079509864415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100008)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7DE8\8F2F')
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12079715148415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100008)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12079977564415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100008)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12080192165415890)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\57F7\884C\8655\7406\6642\9593\8EF8')
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12080307609415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100008)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12080575896415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100008)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12080707756415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100008)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6574\7406')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12080912004415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100008)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\6A21\578B\660E\7D30')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12081104509415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100008)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12081336124415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100008)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12081509273415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100008)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\589E\7248\672C')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12081711584415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100008)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\81EA\52D5')
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12081918743415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12082180495415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100008)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE\61C9\7528\7A0B\5F0F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12082354089415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100008)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12082554986415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100008)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5100\8868\677F')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12082716671415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100008)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\6B77\53F2\8CC7\8A0A')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12082974828415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100008)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B78\6A94\4E2D')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12083127671415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100008)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D71\8A08')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12083325647415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100008)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F09 (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12083599568415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100008)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F\8A08\6642\5668')
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12083723740415891)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100008)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\65B9\5831\8868 | \4E26\6392 | \65B0\8996\7A97')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12083952077415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100008)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12084184428415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\767B\51FA')
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12084391624415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100008)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12084521427415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100008)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB\4F7F\7528')
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12084719807415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100008)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6392\5B9A')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12084977048415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100008)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12085175033415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100008)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\8A2D\5B9A')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12085305311415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12085516210415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100008)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\5165')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12085723124415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100008)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12085913572415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100008)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12086185220415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100008)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8907\88FD')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12086399013415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6697\8272\6A21\5F0F')
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12086577132415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100008)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12086701450415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100008)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12086962483415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100008)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\6A21\578B\660E\7D30')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12087104304415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100008)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12087367981415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12087533999415892)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12087788403415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100008)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\8A2D\5B9A')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12087931001415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100008)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6AA2\8996\539F\59CB\78BC')
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12088175202415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100008)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\660E\7D30')
,p_translate_from_text=>'Show Details'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12088325229415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100008)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12088564095415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\555F\52D5')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12088757906415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12088974088415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100008)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12089184432415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100008)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A18\9304')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12089303756415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12089538179415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100008)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12089738836415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100008)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12089993140415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100008)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\8F09 (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12090171723415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100008)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\532F\51FA')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12090376597415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100008)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6AA2\8996')
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12090583014415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100008)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12090755257415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EAE\8272\6A21\5F0F')
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12090910209415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100008)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\6392\5B9A')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12091182923415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100008)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12091396374415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100008)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\65B9\5831\8868 | \4E26\6392 | \65B0\8996\7A97')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12091597395415893)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100008)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\986F\793A\6B77\53F2\8CC7\8A0A')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12091731484415894)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12091957253415894)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\65B0\555F\52D5')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12092124122415894)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100008)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12092353371415895)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\9078\53D6\8655\7406')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12092526449415896)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\9078\53D6\8655\7406')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12092713688415896)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100008)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\5C6C\6027\3002')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12092971942415896)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12093100140415896)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100008)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230 In/Out \8B8A\6578\3002')
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12093300656415897)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\641C\5C0B\5C0D\8A71\6846')
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12093505004415897)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12093765628415897)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12093962929415897)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12094110494415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12094314557415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\641C\5C0B')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12094558589415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\95DC\9589')
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12094785210415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0B\4E00\6B65 >')
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12094956205415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('< \4E0A\4E00\500B')
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12095159463415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\60A8\662F\5426\8981\57F7\884C\6B64\522A\9664\52D5\4F5C\FF1F')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12095321434415898)
,p_translated_flow_id=>100008
,p_translate_to_id=>100.100008
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\6D41\7A0B')
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12095525608415899)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100008)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\4F5C\696D\7D71\8A08\8CC7\6599')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12095720420415899)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100008)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12095926839415899)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100008)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \670D\52D9')
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12096152912415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12096330338415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100008)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B78\6A94\4E2D')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12096580024415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100008)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\76E3\8996\5668')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12096739001415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100008)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\74B0\5883\6642\9593\8EF8 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12096911686415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100008)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12097140895415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100008)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12097391976415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100008)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5100\8868\677F')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12097519682415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100008)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52D9\7D71\8A08')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12097765721415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100008)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D71\8A08')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12097985159415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100008)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE\61C9\7528\7A0B\5F0F')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12098139840415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100008)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\65E5\7D71\8A08')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12098376396415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100008)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12098522263415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100008)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D44\614B - \6388\6B0A')
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12098726622415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100008)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5EFA\6A21\5DE5\5177')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12098976352415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100008)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A18\9304')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12099155388415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100008)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12099356362415900)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100008)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12099508350415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100008)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A94\6848')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12099713291415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100008)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\696D\4E4B\5F8C')
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12099940650415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100008)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\5272\524D')
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12100179777415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100008)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\6B62\5F8C\7684\8655\7406\72C0\614B')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12100323211415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100008)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\7559\4F4D\7F6E')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12100509515415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100008)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12100792473415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100008)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\4EF6\526F\672C')
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12100931381415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100008)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\671F')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12101189668415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100008)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9593\9694\5E74\7D2F\8A08\81F3\6708')
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12101377644415901)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100008)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5728\8B8A\6578\4E2D')
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12101589095415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100008)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6587\5B57')
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12101738985415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100008)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \547D\4EE4\6A94')
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12101933308415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100008)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8981\6C42')
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12102184788415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100008)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9801\9762\9805\76EE')
,p_translate_from_text=>'Page Items'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12102388503415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100008)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\518D\5EA6\555F\52D5\7684\6642\9593')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12102584725415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100008)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\6B21\6578\4E0A\9650')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12102740711415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100008)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8F38\51FA\8B8A\6578')
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12102923129415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100008)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12103144177415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100008)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9801\9762')
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12103373432415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100008)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\683C\5F0F\906E\7F69')
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12103531208415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100008)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9593\9694\65E5\7D2F\8A08\5230\79D2')
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12103722953415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100008)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\7B2C\4E00\6B21\89F8\767C\7684\6642\9593')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12103984357415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100008)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F15\64CE')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12104172531415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100008)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\5B9A\7FA9\985E\578B')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12104357003415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100008)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\5B9A\7FA9')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12104519638415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100008)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\56DE\8986\5C0D\8C61')
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12104728459415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A18\4F4F\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12104997598415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100008)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \6A94\6848')
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12105130992415902)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100008)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5728\4EFB\52D9\4E4B\524D')
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12105377959415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100008)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\6B62')
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12105586506415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100008)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\526F\672C')
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12105755643415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100008)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7ACB\5373\50B3\9001')
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12105943766415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100008)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\4E4B\524D')
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12106151450415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100008)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\61C9\7528\7A0B\5F0F ID')
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12106311139415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100008)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('HTML \5167\6587')
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12106518841415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100008)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5408\4F75\5F8C')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12106770593415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100008)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8D77\59CB')
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12106901214415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100008)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\975C\614B\503C')
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12107118743415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100008)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E3B\65E8')
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12107358002415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100008)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9805\76EE')
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12107542762415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100008)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\5192\865F\5340\9694\503C)')
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12107702800415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100008)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \8868\793A\5F0F')
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12107968916415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100008)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12108180332415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100008)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\8B8A\6578')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12108341847415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100008)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\767C\751F\6642')
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12108571238415903)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100008)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9644\4EF6')
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12108796752415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100008)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\55AE\4E00\503C)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12108908976415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100008)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6E05\9664\7F13\5B58')
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12109124010415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100008)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9805\76EE\503C')
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12109367373415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100008)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5167\6587')
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12109574792415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100008)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EFB\52D9\985E\578B')
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12109767925415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100008)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\7BC4\672C')
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12109952410415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100008)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7BC4\672C ID')
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12110108395415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100008)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12110353864415904)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100008)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9023\7D50\9801\9762\9805\76EE\503C')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12110578267415905)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\8A18\9304\5B50\6D41\7A0B')
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12110737827415905)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672A\8A18\9304\8655\7406\5C64\6B21')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12110903939415906)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('	- \9078\53D6 -')
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12111149646415906)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6C92\6709\985E\5225')
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12111326164415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100008)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B9\5411')
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12111505699415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100008)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12111794620415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100008)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\4E2D')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12111915196415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100008)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4\5806\758A')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12112186341415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100008)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\72C0\614B')
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12112306180415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100008)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12112559315415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100008)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12112778607415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12112969725415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100008)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12113170665415906)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100008)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\65E5\671F')
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12113333341415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12113562598415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100008)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53EF\547C\53EB')
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12113735360415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100008)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521D\59CB\5316\65E5\671F')
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12113966228415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100008)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12114110610415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\4E2D')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12114313002415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100008)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9801\9762 ID')
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12114594551415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100008)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12114777357415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100008)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12114996040415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100008)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12115147439415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100008)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12115323330415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100008)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\65E5\671F')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12115551097415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100008)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\6A19\984C')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12115712176415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100008)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\5716\793A')
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12115977702415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100008)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\7D42\6B62')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12116100235415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\7D42\6B62')
,p_translate_from_text=>'Terminated'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12116339799415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100008)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\63CF\8FF0')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12116598795415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100008)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12116771467415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12116948295415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100008)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12117123661415907)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100008)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12117345557415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100008)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\61C9\7528\7A0B\5F0F ID')
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12117551888415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100008)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005\984F\8272')
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12117746636415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100008)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8CC7\6599\985E\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12117979443415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100008)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63CF\8FF0')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12118159550415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100008)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12118358294415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\512A\5148\9806\5E8F')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12118538377415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100008)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\9593\6233\8A18')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12118733578415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100008)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6\985E\578B')
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12118921755415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100008)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12119183610415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100008)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12119353974415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5230\671F\65E5')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12119544063415908)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100008)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12119708155415909)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100008)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12119918443415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100008)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12120114167415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100008)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12120309810415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12120585669415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12120739402415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100008)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12120949960415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100008)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12121185744415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100008)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12121321393415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12121573820415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100008)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12121737483415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12121932051415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100008)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12122164465415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100008)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12122346225415910)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100008)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12122570113415911)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('\3000<li> \4E00\500B\6A21\578B\FF1A\4EE5\532F\5165\55AE\4E00\6A21\578B\FF0C\63D0\4F9B\6240\6709\5C6C\6027 </li> '),
unistr('\3000<li> \591A\91CD\6A21\578B\FF1A\4EE5\532F\5165\6578\500B\6A21\578B\FF0C\63D0\4F9B\58D3\7E2E\6A94 *</li>'),
'</ul>',
unistr('<p>* \58D3\7E2E\6A94\5FC5\9808\5305\542B\FF1A* \58D3\7E2E\6A94\5FC5\9808\5305\542B\FF1A '),
'    <ul>',
unistr('        <li> \8981\532F\5165\7684 bpmn \6A94\6848 </li>'),
unistr('        <li> \542B\6709\4E0B\5217\5C6C\6027\7684 import.json \6A94\6848 (\8ACB\53C3\95B1\4E0B\65B9\7BC4\4F8B)\FF1A '),
'            <ul>',
unistr('                <li>dgrm_name\FF1A\6A21\578B\7684\540D\7A31 </li>'),
unistr('                <li>dgrm_version\FF1A\6A21\578B\7684\7248\672C </li>'),
unistr('                <li>dgrm_category\FF1A\6A21\578B\7684\985E\5225 </li>'),
unistr('                <li> \6A94\6848\FF1A\5B58\6A94\4E2D\7684 bpmn \6A94\6848\540D\7A31 </li>'),
'            </ul>',
'        </li>',
'    </ul>',
unistr(' \5177\6709\5169\500B\6A21\578B\7684 import.json \6A94\6848\7BC4\4F8B <br>'),
'<pre><code>[',
'{',
unistr('    "dgrm_name"\FF1A\300C\62AB\85A9\5408\4F5C\300D\FF0C '),
unistr('    "dgrm_version"\FF1A"0"\FF0C '),
unistr('    "dgrm_status"\FF1A\300C\8349\7A3F\300D\FF0C '),
unistr('    "dgrm_category"\FF1Anull\FF0C '),
unistr('    "file"\FF1A"The Pizza Collaboration_0.bpmn"'),
unistr('  }\FF0C '),
'  {',
unistr('    "dgrm_name"\FF1A\300C\5047\65E5\300D\FF0C '),
unistr('    "dgrm_version"\FF1A"0"\FF0C '),
unistr('    "dgrm_status"\FF1A\300C\8349\7A3F\300D\FF0C '),
unistr('    "dgrm_category"\FF1Anull\FF0C '),
unistr('    "file"\FF1A"Holidays_0.bpmn"'),
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12122769642415911)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr(' \5982\679C\60A8\9078\53D6\6B64\6838\53D6\65B9\584A\FF0C\61C9\7528\7A0B\5F0F\6703\5C07\60A8\7684\4F7F\7528\8005\540D\7A31\5132\5B58\5728\540D\70BA "LOGIN_USERNAME_COOKIE" \7684\6C38\4E45\700F\89BD\5668 Cookie \4E2D\3002\7576\60A8\4E0B\6B21\9032\5165\767B\5165\9801\9762\6642\FF0C'),
unistr('\4F7F\7528\8005\540D\7A31\6B04\4F4D\6703\81EA\52D5\586B\5165\6B64\503C\3002 '),
'</p><p>',
unistr(' \5982\679C\60A8\53D6\6D88\9078\53D6\6B64\6838\53D6\65B9\584A\FF0C\4E14\60A8\7684\4F7F\7528\8005\540D\7A31\5DF2\7D93\5132\5B58\5728 Cookie \4E2D\FF0C'),
unistr('\61C9\7528\7A0B\5F0F\5C07\6703\4EE5\7A7A\767D\503C\8986\5BEB\3002\60A8\4E5F\53EF\4EE5\4F7F\7528\700F\89BD\5668\7684\958B\767C\4EBA\54E1\5DE5\5177\4F86\5B8C\5168\79FB\9664 Cookie\3002 '),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12122995447415911)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12123162966415912)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100008)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12123353715415912)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100008)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D\7684\5B50\6D41\7A0B')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12123593426415912)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100008)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12123717833415912)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\8868\55AE\7BC4\672C')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12123968478415912)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100008)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\6578\6B77\53F2\8A18\9304')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12124160191415912)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100008)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\4E8B\4EF6')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12124330978415912)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100008)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ORDS \5F9E\5C6C\7AEF\5831\8868')
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12124586643415912)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100008)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\7684\6A21\578B')
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12124773713415912)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A0A\606F\8A02\95B1')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12124979018415912)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100008)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210\7684\6B65\9A5F')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12125186118415913)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100008)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C6C\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12125397725415913)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100008)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\88AB\53EB\5716')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12125542563415913)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100008)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12125780577415913)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\5716\8868')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12125933396415913)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100008)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6D41\7A0B\5BE6\4F8B')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12126191429415913)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100008)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210\7684\5B50\6D41\7A0B')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12126332842415913)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100008)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D\6B65\9A5F')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12126571140415913)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100008)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\6578\6B77\53F2\8A18\9304')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12126791513415913)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100008)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\6578')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12126906516415913)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F\932F\8AA4')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12127179987415913)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100008)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12127381003415914)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100008)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B64\5831\8868\7684\8CC7\6599\5217\8A08\6578\4E0A\9650\70BA #MAX_ROW_COUNT# \500B\8CC7\6599\5217\3002\8ACB\5957\7528\7BE9\9078\4EE5\6E1B\5C11\67E5\8A62\4E2D\7684\8A18\9304\6578\3002')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12127540269415914)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B64\5831\8868\7684\8CC7\6599\5217\8A08\6578\4E0A\9650\70BA #MAX_ROW_COUNT# \500B\8CC7\6599\5217\3002\8ACB\5957\7528\7BE9\9078\689D\4EF6\4EE5\6E1B\5C11\67E5\8A62\4E2D\7684\8A18\9304\6578\3002')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12127737316415914)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\6578\6B77\53F2\8A18\9304\7A7A\767D\3002')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12127938328415914)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F\932F\8AA4\6B77\53F2\8A18\9304\7A7A\767D\3002')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12128146483415914)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\76EE\524D\7684\5B50\6D41\7A0B\3002')
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12128384626415914)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\8B8A\6578\904B\7B97\5F0F\3002')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12128519044415914)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\547C\53EB\5716\8868 \3002')
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12128776055415914)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\5DF2\5B8C\6210\7684\5B50\6D41\7A0B\3002')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12128912056415914)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\4E8B\4EF6\6B77\53F2\8A18\9304\7A7A\767D\3002')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12129174727415914)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100008)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\8CC7\6599\3002')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12129386408415914)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\5C6C\6027\3002')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12129500626415914)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\547C\53EB\7684\5716\8868\3002')
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12129712505415914)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100008)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8B8A\6578\6B77\53F2\8A18\9304\7A7A\767D\3002')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12129945708415915)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100008)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\8CC7\6599\3002')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12130194409415915)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\5DF2\5B8C\6210\7684\6B65\9A5F\3002')
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12130350579415915)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627E\4E0D\5230\76EE\524D\7684\6B65\9A5F\3002')
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12130537534415915)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12130700716415915)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12130958557415915)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12131126156415915)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12131337794415915)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12131538686415915)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12131755183415916)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12131974143415916)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12132184944415916)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12132372124415916)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12132593622415916)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12132713454415916)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12132939788415916)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12133189491415916)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12133331632415916)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12133565339415916)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12133795763415916)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12133980809415916)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12134172604415916)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12134355870415916)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100008)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12134594038415916)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100008)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12134727321415916)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12134956278415916)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12135118850415916)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12135322107415916)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100008)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12135536022415916)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12135784785415916)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12135978688415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12136192532415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100008)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12136351515415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100008)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12136581937415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12136799304415917)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12136926219415917)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12137158303415917)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12137391073415917)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12137590625415917)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12137799972415917)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12137957049415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12138129663415917)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12138308639415917)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12138506900415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100008)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12138726560415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12138909931415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12139113652415917)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12139363709415917)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12139581476415917)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100008)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12139760178415918)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100008)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12139909778415918)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12140166515415918)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12140306870415918)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12140539919415918)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12140720873415918)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100008)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12140926377415918)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12141176432415918)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12141324175415918)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12141505509415918)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100008)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12141777513415918)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12141972049415918)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12142147826415918)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12142301340415918)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12142507964415918)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100008)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12142725459415918)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12142978954415918)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12143131039415918)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12143340748415918)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100008)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12143576453415919)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12143793446415919)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100008)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12143973630415919)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12144175345415919)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12144389724415919)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12144533708415919)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12144713201415919)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12144997460415919)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12145148295415919)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12145310294415919)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12145511865415919)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12145795801415919)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12145937036415919)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12146192991415919)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12146368966415919)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12146529235415919)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12146748822415919)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100008)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12146927022415919)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12147163690415919)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100008)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12147358036415920)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12147508298415920)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12147763113415920)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12147915120415920)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12148141182415920)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100008)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12148391791415920)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100008)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12148575947415920)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100008)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12148792548415920)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12148956739415920)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12149184417415920)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12149301364415920)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100008)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12149555739415920)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12149781274415920)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12149953580415920)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12150112278415920)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12150308009415920)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12150502562415920)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12150740000415920)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12150902366415921)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12151168352415921)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12151341969415921)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12151567647415921)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12151785168415921)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12151999426415921)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12152153084415921)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12152330432415921)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12152524292415921)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12152706761415921)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12152904522415921)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12153100819415921)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12153344996415921)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12153546609415921)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12153759094415921)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12153972065415921)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12154159957415921)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12154381998415921)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12154570862415921)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100008)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12154718723415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12154918010415922)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12155125611415922)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100008)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12155300329415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12155590525415922)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12155739455415922)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12155929082415922)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100008)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12156146787415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12156377565415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12156594644415922)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12156722442415922)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100008)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12156976711415922)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12157105314415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12157314647415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12157557320415922)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12157712834415922)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100008)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12157933914415922)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12158196554415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12158369864415922)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100008)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12158575155415923)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12158777514415923)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100008)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12158910618415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12159169633415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12159330510415923)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12159538496415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12159768183415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12159961346415923)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12160128467415923)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100008)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12160375632415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12160578804415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12160729327415923)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12160986210415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12161135972415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12161306909415923)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12161543369415923)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100008)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12161736256415923)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12161926925415923)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12162156302415923)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12162323245415924)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12162586525415924)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12162701737415924)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12162931939415924)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12163130097415924)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12163311868415924)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100008)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12163538004415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12163745398415924)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12163947021415924)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12164181971415924)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12164360907415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12164506373415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100008)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12164784195415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12164970803415924)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12165182900415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12165300874415924)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100008)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12165503250415924)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12165717572415924)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100008)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12165924794415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12166104971415924)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12166379098415925)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12166569565415925)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12166757214415925)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12166956554415925)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12167176615415925)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100008)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12167341943415925)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12167529134415925)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12167753947415925)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12167940752415925)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12168138834415925)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12168392918415925)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12168543050415925)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100008)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12168711471415925)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12168988013415925)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12169147550415925)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12169361647415925)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100008)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12169549261415925)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12169720852415925)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12169905464415925)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100008)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12170135363415926)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12170380370415926)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100008)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12170548237415926)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100008)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12170775350415926)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12170982493415926)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12171171068415926)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12171396974415926)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12171577238415926)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100008)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12171729783415926)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12171995758415926)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12172158180415926)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12172375052415926)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12172506608415926)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12172709799415926)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100008)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12172928987415926)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12173191140415926)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12173334889415926)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12173597656415926)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12173792941415926)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12173913944415926)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12174159883415927)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12174355615415927)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12174599314415927)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12174721669415927)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12174956769415927)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12175170484415927)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100008)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12175325198415927)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12175501258415927)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100008)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12175750759415927)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12175965907415931)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A08\6642\5668\958B\59CB\65E5\671F')
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12176103677415931)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12176369325415931)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D\7BC4\570D')
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12176516503415931)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7269\4EF6')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12176768382415931)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Json \5C6C\6027')
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12176939857415931)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12177185720415931)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12177336730415932)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7269\4EF6')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12177580785415932)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12177724664415932)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12177997273415932)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12178123358415932)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12178350705415932)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12178547835415932)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9078\64C7\547C\53EB\7684\5716\8868\7248\672C')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12178713032415932)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12178948175415932)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12179118429415932)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12179381552415932)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12179531910415932)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB\7269\4EF6')
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12179711369415932)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100008)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6280\8853\652F\63F4\4FE1\7BB1')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12179998026415932)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100008)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12180183022415932)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D\5C64\6B21')
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12180371251415932)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\7248\672C')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12180596164415932)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\9593\6233\8A18')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12180757411415932)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100008)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210\6642\7684\72C0\614B')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12180948631415932)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91D1\9470\503C')
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12181105534415932)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12181399738415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8DEF\7DDA')
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12181511149415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100008)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\7559\5C0D\8C61')
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12181740116415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100008)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12181908307415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91D1\9470\540D\7A31')
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12182187134415933)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12182393804415933)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12182589294415933)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12182769057415933)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6709\905E\8FF4\5716\793A')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12182994138415933)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12183182782415933)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12183339104415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FEB\901F\64CD\4F5C')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12183528368415933)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\540D\7A31')
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12183752065415933)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12183967515415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100008)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12184119842415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12184368117415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5230\671F\65E5')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12184519328415933)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12184796614415933)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12184966324415933)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100008)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12185108303415934)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100008)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FEB\901F\64CD\4F5C')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12185333492415934)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12185536941415934)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12185741611415934)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12185969854415934)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\6642\9593')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12186131184415934)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100008)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12186363202415934)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB Dgrm')
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12186545630415934)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12186713876415934)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D\985E\5225')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12186915939415934)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100008)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12187172404415934)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7BC4\570D')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12187350504415934)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\975C\614B ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12187525864415934)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12187789194415934)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\70BA\76EE\524D\7684\5E33\865F')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12187992915415934)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100008)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12188129805415934)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12188370139415934)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\793A\5F0F')
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12188536001415934)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12188762589415935)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100008)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12188938455415935)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12189110123415935)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100008)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12189362647415935)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12189565840415935)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100008)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7269\4EF6')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12189731423415935)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12189959765415935)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12190184690415935)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12190327935415935)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6392\9664\7684\4F7F\7528\8005')
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12190509834415935)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12190773102415935)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A02')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12190942820415935)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\5716')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12191193128415935)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12191329314415935)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\958B\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12191559387415935)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6709\6548\8CA0\8F09\8B8A\6578')
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12191779209415935)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12191994063415935)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\985E')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12192175576415935)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100008)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5256\6790\7684\6D41\7A0B')
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12192345940415935)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12192524449415935)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100008)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A02')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12192775091415936)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12192939522415936)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\5C64\6B21')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12193127289415936)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\958B\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12193375697415936)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12193536402415936)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100008)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12193754504415936)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100008)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12193966164415936)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100008)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12194128409415936)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12194313564415936)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12194540511415936)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12194707607415936)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100008)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\6642\9593')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12194999000415936)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6839\76EE\9304\7BA1\7406\54E1')
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12195177032415936)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A02')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12195356449415936)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\9593\6233\8A18')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12195576609415936)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12195737363415936)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\7269\4EF6')
,p_translate_from_text=>'Calling Object'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12195963104415937)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\985E\578B')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12196185347415937)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12196338296415937)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12196584517415937)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12196782755415937)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12196901039415937)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12197135232415937)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12197347936415937)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\88AB\53EB\5716')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12197525670415937)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12197751724415937)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C64\6B21')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12197970474415937)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12198199635415937)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12198375984415937)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100008)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12198574317415938)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12198793152415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12198943183415938)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12199169244415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12199367331415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\9593\6233\8A18')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12199524924415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A0A\606F\540D\7A31')
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12199784422415938)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\6642\9593')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12199995846415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100008)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12200162630415938)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\5C64\6B21')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12200337612415938)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12200567048415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100008)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\7269\4EF6')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12200722007415938)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12200949583415938)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12201182123415938)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\7269\4EF6')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12201346131415938)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100008)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7BC4\570D')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12201593536415938)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\9593\6233\8A18')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12201729914415938)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\4EF6')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12201947326415939)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\512A\5148\9806\5E8F')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12202142076415939)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100008)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12202309698415939)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9810\8A02')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12202516270415939)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4\5806\758A')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12202744860415939)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12202922791415939)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12203140885415939)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100008)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12203318549415939)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12203532273415939)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12203778332415939)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100008)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F\9375\503C')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12203977621415939)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12204183196415939)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100008)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F\9375\503C')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12204305800415939)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12204592702415939)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \8B58\5225\78BC')
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12204738093415939)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\70BA\76EE\524D\7684\5E33\865F')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12204968962415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8CC7\6599\985E\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12205124314415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12205338813415940)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12205581369415940)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100008)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12205784079415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12205974425415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12206137216415940)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\7684\5716\8868\7248\672C')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12206303126415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12206515289415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\6B21\5B8C\6210\6642\9593')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12206723435415940)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12206946828415940)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100008)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F\9375\503C')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12207148058415940)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12207398707415940)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12207500366415940)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\5C64\6B21')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12207723789415940)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4\5806\758A')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12207995732415941)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12208107608415941)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12208373338415941)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\958B\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12208546026415941)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12208775343415941)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100008)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12208953568415941)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D\985E\5225')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12209128905415941)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\5716')
,p_translate_from_text=>'Calling Diagram'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12209371129415941)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DE5\4F5C\958B\59CB')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12209582322415941)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8CC7\6599\985E\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12209749383415941)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\7269\4EF6')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12209986199415941)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100008)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4\5806\758A')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12210101748415941)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12210388113415941)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8655\7406\5C64\6B21')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12210524182415941)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100008)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub ID'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12210714953415941)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100008)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12210923366415942)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100008)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A3B\89E3')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12211168691415942)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100008)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63CF\8FF0')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12211387244415942)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12211538536415942)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C64\6B21')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12211761956415942)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\72C0\614B')
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12211975389415942)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\5206\985E')
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12212181394415942)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100008)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12212363292415942)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12212501392415942)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100008)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8907\8DEF\5F91')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12212784624415942)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5716\8868')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12212941552415942)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8CC7\6599\985E\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12213134963415942)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\76EE\524D')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12213355747415942)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6642\9593\6233\8A18')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12213565930415942)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12213705595415942)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\53EB\5716\8868 ID')
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12213939109415942)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100008)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\652F\63F4 URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12214126046415942)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12214323245415942)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\503C')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12214592994415942)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100008)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12214795599415943)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100008)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12214954558415943)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12215115416415943)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6709\905E\8FF4')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12215321654415943)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100008)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B ID')
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12215597862415943)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6F5B\5728\4F7F\7528\8005')
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12215799198415943)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100008)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12215995059415943)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100008)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12216105757415943)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100008)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12216328856415943)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A21\578B\540D\7A31')
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12216555693415943)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12216782378415943)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\793A\5F0F\985E\578B')
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12216944601415943)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100008)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12217189165415943)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B50\6D41\7A0B')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12217354032415943)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12217573693415943)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12217798572415943)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6F5B\5728\7FA4\7D44')
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12217927422415943)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5716\8868')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12218133206415943)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100008)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F9E\5C6C\7AEF ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12218338470415943)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12218534437415944)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12218753778415944)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm ID'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12218980307415944)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B65\9A5F')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12219180279415944)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100008)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\70BA\76EE\524D\7684\5E33\865F')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12219382124415944)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12219558075415944)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100008)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12219792096415944)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100008)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6210\70BA\76EE\524D\7684\5E33\865F')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12219965972415944)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100008)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12220175794415944)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100008)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12220346647415944)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100008)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12220557275415944)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100008)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210\6642\7684\72C0\614B')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12220750886415944)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FEB\901F\64CD\4F5C')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12220912125415944)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100008)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12221134358415944)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12221389921415948)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12221562180415948)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12221765933415948)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12221909270415948)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100008)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12222102399415948)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100008)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12222317099415948)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12222548051415948)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100008)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12222787208415948)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12222931355415948)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100008)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12223167286415949)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12223332838415949)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100008)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12223506855415949)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12223763223415949)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12223977246415949)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100008)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12224154256415949)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12224339041415949)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100008)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12224520957415949)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100008)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12224784033415949)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100008)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12224939153415949)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12225165434415949)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100008)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12225300606415949)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12225555905415949)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100008)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12225729601415949)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12225920787415949)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12226118766415949)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100008)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12226334134415950)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100008)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12226507211415950)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100008)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12226750777415950)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100008)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12226970598415953)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100008)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Viewer'
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12227132573415953)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100008)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \6A21\578B\88FD\4F5C\5668')
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12227300159415953)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100008)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12227521983415953)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100008)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12227779678415953)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100008)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12227952692415954)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100008)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12228105042415954)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100008)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12228317177415954)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100008)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12228580209415954)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B0A\9650\4E0D\8DB3\FF0C\4F7F\7528\8005\4E0D\662F\7BA1\7406\54E1')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12228784220415954)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\5C0F\6642')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12228961579415954)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCF\5C0F\6642')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12229140934415954)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12229390211415954)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12229517822415954)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12229726578415954)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('I \5E74')
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12229904259415954)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 \5E74')
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12230145395415955)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \5206\9418')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12230388721415955)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \5206\9418')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12230573204415955)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \500B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12230799996415955)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \500B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12230935129415955)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \500B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12231148011415955)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9 \500B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12231316567415955)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('4 \5E74')
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12231555191415955)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 \5206\9418')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12231750310415955)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 \5206\9418')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12231933257415955)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \500B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12232102756415955)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \500B\6708')
,p_translate_from_text=>'6 Months'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12232373468415955)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \500B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12232549073415955)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6 \500B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12232708569415955)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \5E74')
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12232986871415956)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5206\9418')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12233191328415956)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5206\9418')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12233365021415956)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \500B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12233526937415956)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \500B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12233719375415956)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \500B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12233998708415956)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 \500B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12234184648415956)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('2 \5E74')
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12234348755415956)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \79D2 (\751F\7522\4F7F\7528 - \4E0D\9069\7528\65BC apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12234576355415956)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \79D2 (\751F\7522\4F7F\7528 - \4E0D\9069\7528\65BC apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12234718588415956)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 \5929')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12234907826415957)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 \5929')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12235197221415957)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 \5929')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12235365437415957)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 \5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12235528571415957)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 \5929')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12235714295415957)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 \5929')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12235921703415957)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 \5929')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12236101009415957)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12236390243415957)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12236510389415957)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12236738597415958)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12236906765415958)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12237102142415958)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100008)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12237387928415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12237531341415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100008)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12237750185415958)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12237920319415958)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12238185404415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12238304001415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12238529950415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100008)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12238718292415958)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12238979047415958)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12239138229415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12239353067415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12239561376415958)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12239709472415958)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100008)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12239901510415958)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100008)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12240107020415958)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12240313526415958)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100008)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12240523334415959)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12240723528415959)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100008)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12240960011415959)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100008)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12241153511415959)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12241341624415959)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100008)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12241565299415959)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100008)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12241771978415959)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12241969437415959)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100008)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12242146219415959)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100008)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12242338881415959)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12242590242415959)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100008)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12242721312415959)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100008)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12242934811415959)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12243105982415959)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12243361274415959)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12243559692415959)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12243717011415959)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12243994619415959)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12244179712415959)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12244357649415959)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100008)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12244576468415959)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100008)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12244761606415959)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12244928201415960)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12245138352415960)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12245331317415960)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12245558146415960)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12245724347415960)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12245924679415960)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100008)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12246106524415960)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12246342147415960)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100008)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12246521265415960)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12246766711415960)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100008)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12246910818415960)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12247128003415960)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12247386893415960)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100008)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12247534039415960)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100008)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12247783110415960)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100008)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12247956465415960)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12248183369415960)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12248306312415960)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12248505054415960)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100008)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12248746651415960)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12248923475415961)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100008)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12249167714415961)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12249343666415961)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12249521726415961)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12249787921415961)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12249979437415961)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12250112108415961)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12250377811415961)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12250563310415961)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12250714003415961)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12250921381415961)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100008)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12251156394415961)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12251354158415961)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12251513504415961)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12251755891415961)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100008)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12251965188415961)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12252171233415961)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12252325823415961)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100008)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12252530044415961)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12252765278415961)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12252993089415962)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100008)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12253169347415962)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12253319330415962)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12253589856415962)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12253705277415962)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12253960587415962)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12254104875415962)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12254307369415962)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12254562203415962)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12254731711415962)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12254977490415962)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12255143953415962)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12255346412415962)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12255586973415962)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12255731837415962)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12255991255415962)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12256173013415962)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100008)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12256364355415962)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100008)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12256510185415962)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12256754653415962)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12256915233415962)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100008)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12257143026415963)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100008)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12257361262415963)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12257556843415963)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12257710579415963)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12257988223415963)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12258179144415963)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12258309342415963)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12258534226415963)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12258700448415963)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12258900752415963)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12259174032415963)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100008)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12259388813415963)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100008)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12259573638415963)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100008)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12259744236415963)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100008)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12259983602415963)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12260149713415963)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12260349162415963)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12260525515415963)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100008)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12260776012415963)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12260986439415963)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12261186104415963)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100008)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12261392566415964)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12261573159415964)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12261725448415964)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100008)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12261919256415964)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12262191542415964)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12262358149415964)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100008)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12262540308415964)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12262720303415964)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12262994722415964)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12263166232415964)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100008)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12263384777415964)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100008)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12263572910415964)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12263732313415964)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100008)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12263919612415964)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12264175710415964)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12264371722415964)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100008)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12264574957415964)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12264776521415965)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12264982287415965)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12265159786415965)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100008)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12265344130415965)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12265592235415965)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12265797637415965)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12265941922415965)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12266152150415965)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12266312306415965)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12266507821415965)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12266738727415965)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12266905572415965)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12267190946415965)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12267317169415965)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12267516934415965)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100008)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12267785113415965)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12267952142415965)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12268170190415965)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12268364777415965)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12268568186415965)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100008)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12268793234415965)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12268930267415966)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12269124615415966)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12269370238415966)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12269566602415966)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100008)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12269715314415966)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12269940466415966)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12270145701415966)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12270337341415966)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12270505397415966)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100008)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12270782986415966)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100008)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12270922371415966)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12271105219415966)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100008)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12271382061415966)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12271593068415966)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100008)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12271723573415966)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12271915634415966)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12272140631415966)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12272390065415969)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12272516710415969)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12272775954415969)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12272968916415969)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12273161910415970)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12273396757415970)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100008)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12273540031415970)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12273751792415970)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12273930512415970)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12274180026415970)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12274373170415970)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12274563045415970)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12274746121415970)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12274947545415970)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12275137884415970)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12275354910415970)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12275581082415970)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12275759357415970)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12275950486415970)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100008)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12276198319415970)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100008)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12276369676415970)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12276547017415970)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12276726133415970)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12276942821415971)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100008)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12277107723415971)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12277334351415971)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12277525497415971)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12277780735415971)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12277926752415971)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12278188288415971)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12278320164415971)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100008)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12278561432415971)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12278704474415971)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12278991461415971)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12279115387415971)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12279343482415971)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12279559669415971)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12279719573415971)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12279901422415971)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12280103136415971)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12280354184415971)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12280542462415971)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12280712050415971)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12280990437415971)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12281166653415972)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100008)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12281360169415972)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12281512797415972)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12281704612415972)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12281953033415972)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12282150820415972)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12282396439415972)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12282570783415972)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12282727850415972)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12282927756415972)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12283170534415972)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12283309209415972)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12283524963415972)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12283740639415972)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12283928635415972)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100008)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12284198687415972)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12284398438415972)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12284543730415972)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12284773046415972)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12284923950415972)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12285104675415973)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12285301400415973)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12285511459415973)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100008)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12285732994415973)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12285981836415973)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12286191929415973)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100008)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12286317200415973)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100008)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12286528243415973)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12286791532415973)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12286920147415973)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100008)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12287123319415973)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100008)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12287375883415973)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12287563939415973)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12287738898415973)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12287952359415973)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12288125673415973)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12288355224415973)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12288563348415973)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12288750349415973)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12288933634415973)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12289182842415974)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12289330412415974)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12289560033415974)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12289770395415974)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100008)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12289973288415974)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12290168697415974)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100008)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12290343271415974)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12290577313415974)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12290793597415974)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12290912447415974)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12291179805415974)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12291397944415974)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100008)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12291592030415974)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12291776480415974)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12291945103415974)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12292134184415976)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12292342842415976)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12292566037415976)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12292749914415976)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12292943774415976)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12293111611415976)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100008)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12293362638415976)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12293599044415976)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12293734818415976)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12293989767415976)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12294172667415976)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100008)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12294344507415976)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12294565744415977)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12294722214415977)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12294918269415977)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12295124016415977)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12295317789415977)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12295508949415977)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12295719278415977)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12295901665415977)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12296180334415977)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12296370860415977)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12296507403415977)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12296719004415977)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12296992382415977)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12297106044415977)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12297318577415978)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12297518672415978)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12297711083415978)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12297974141415978)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100008)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12298128839415978)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12298399946415978)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12298596801415978)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12298765552415978)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12298967249415978)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12299186174415978)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12299359050415978)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12299507710415978)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12299750785415978)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12299938520415978)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12300139474415978)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12300383502415979)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100008)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12300570618415979)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12300721187415979)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12300919821415979)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12301145179415979)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12301381337415979)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12301548167415979)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12301750441415979)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12301987872415979)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100008)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12302139081415979)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12302325156415979)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12302524330415979)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12302742820415979)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12302921994415979)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12303148803415979)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12303372046415979)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12303590889415979)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12303771217415979)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12303921445415979)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12304131213415979)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100008)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12304383889415979)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12304543266415980)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12304730336415980)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12304993837415980)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12305160236415980)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12305317725415980)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12305556108415980)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12305742808415980)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12305978855415980)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12306161363415980)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12306353435415980)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12306525383415980)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12306733674415980)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12306942282415980)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12307112033415980)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12307366862415980)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12307537718415980)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12307714233415980)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100008)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12307953444415980)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12308114713415980)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12308351913415981)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12308549259415981)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12308710012415981)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12308976926415981)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12309121101415981)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12309396672415981)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12309502266415981)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12309780912415981)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12309930794415981)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12310155123415981)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12310365485415981)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12310510589415981)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100008)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12310716842415981)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12310922914415981)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100008)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12311128877415981)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12311378841415981)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12311585093415981)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12311758423415981)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12311913685415982)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100008)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12312186009415982)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12312378927415982)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12312508209415982)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12312767649415983)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100008)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12312968619415983)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12313182066415983)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12313392464415983)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12313500033415983)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12313796049415983)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12313941276415983)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12314154110415983)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12314349884415983)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100008)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12314553616415983)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100008)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12314720965415984)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12314983047415984)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12315199251415984)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100008)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12315310445415984)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100008)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12315501396415984)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12315768655415984)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12315990903415984)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12316197483415984)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12316324308415984)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12316516391415984)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12316706142415984)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12316924426415984)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12317186148415984)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12317356514415984)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12317567874415984)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12317788447415984)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12317902201415984)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12318102793415984)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12318375929415984)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12318542662415984)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100008)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12318765077415984)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100008)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12318946766415985)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100008)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12319127581415985)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12319357550415985)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12319501854415985)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12319728195415985)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12319909321415985)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12320139202415985)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12320355749415985)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100008)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12320500570415985)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100008)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12320722527415985)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12320995326415985)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12321121274415985)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12321377980415985)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100008)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12321575520415985)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100008)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12321738589415985)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100008)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12321923363415985)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12322189162415985)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100008)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12322311563415985)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12322539118415985)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12322778158415986)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100008)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12322953308415986)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100008)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12323142410415986)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12323311020415986)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100008)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12323597703415986)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12323716210415986)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100008)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12323986547415986)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100008)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12324157614415986)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12324386636415986)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100008)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12324560585415986)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12324757669415986)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100008)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12324981508415986)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100008)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12325120225415986)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100008)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12325344393415986)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100008)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12325574357415986)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100008)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12325749810415986)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100008)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12325970341415986)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100008)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12326121152415986)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12326358935415988)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12326510893415988)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100008)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12326759462415988)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12326977022415988)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12327145583415988)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100008)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12327375209415988)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12327544318415988)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100008)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12327702129415988)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12327941376415988)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100008)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12328111281415988)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100008)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12328388108415989)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12328584311415989)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12328704160415989)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100008)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12328994268415989)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100008)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12329112504415989)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100008)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12329334655415989)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12329565488415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100008)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12329784599415990)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100008)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12329968567415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100008)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12330189047415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100008)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12330322526415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12330555804415990)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100008)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12330749043415990)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12330956180415990)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12331106463415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100008)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12331317406415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12331568441415990)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12331735887415990)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12331904070415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100008)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12332196997415990)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100008)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12332334596415990)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100008)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12332564043415990)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12332766363415990)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12332957908415991)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100008)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12333102251415991)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12333340025415991)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100008)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12333576304415991)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12333760583415991)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12333971976415991)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12334147420415991)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100008)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12334358587415991)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12334505096415991)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12334783524415991)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12334998121415991)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100008)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12335106523415991)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100008)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12335339097415991)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12335570996415991)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12335723672415991)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100008)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12335940181415991)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100008)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12336196752415991)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100008)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12336340834415991)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100008)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12336583960415991)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100008)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12336783192415992)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100008)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12336996884415992)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12337161369415992)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100008)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12337301391415992)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100008)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12337535794415992)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12337714452415992)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100008)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12337992833415992)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100008)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12338194037415992)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12338367494415992)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100008)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12338570257415992)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100008)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12338713599415992)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12338923257415992)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100008)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12339105592415992)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100008)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12339336805415992)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100008)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12339533031415992)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12339775203415992)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100008)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12339927746415992)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12340164528415992)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12340329450415992)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12340521175415992)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100008)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12340719924415992)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100008)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12340984245415993)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12341131556415993)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12341370385415993)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100008)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12341542521415993)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100008)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12341771823415993)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12341940066415993)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100008)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12342153113415993)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12342398086415993)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12342581403415993)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100008)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12342775441415993)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12342993705415993)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100008)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12343116458415993)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12343347797415993)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100008)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12343542836415993)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100008)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12343722261415993)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12343955490415993)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100008)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12344159987415993)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100008)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12344367545415993)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100008)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12344528973415995)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12344734052415995)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12344956138415995)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12345190292415995)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12345360472415995)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100008)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12345549498415995)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100008)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12345727797415995)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100008)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12345943689415995)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12346103236415995)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100008)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12346373271415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12346527256415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12346709303415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12346990446415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100008)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12347172141415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100008)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12347337547415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100008)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12347580282415996)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100008)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12347792521415996)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100008)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12347968718415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12348189237415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12348339015415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12348575636415996)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100008)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12348768881415996)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12348988342415996)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12349150432415997)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100008)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12349389899415997)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12349532801415997)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100008)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12349729011415997)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12349916428415997)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12350172209415997)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100008)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12350361384415997)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12350576065415997)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12350797350415997)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12350922225415997)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100008)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12351190715415997)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12351352449415997)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100008)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12351539137415997)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100008)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12351739515415998)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100008)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12351926531415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12352158776415998)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12352334062415998)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12352551939415998)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12352764598415998)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100008)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12352921372415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12353177401415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12353370464415998)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100008)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12353589012415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12353792440415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100008)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12353904480415998)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100008)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12354147021415998)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100008)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12354365223415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12354507503415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12354766303415998)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100008)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12354912194415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100008)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12355186060415999)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12355355661415999)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12355532828415999)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12355799138415999)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100008)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12355964218415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12356118290415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12356337270415999)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100008)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12356524848415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12356739680415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100008)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12356914522415999)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100008)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12357120056415999)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100008)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12357370835415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12357518800415999)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12357768966416000)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100008)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12357934809416000)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100008)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12358181268416000)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100008)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12358330639416000)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100008)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12358522273416000)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100008)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12358704493416000)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12358960714416000)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12359152711416000)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12359325702416000)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12359577904416000)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100008)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12359785662416001)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100008)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12359960649416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12360195834416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100008)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12360358998416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100008)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12360549560416001)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100008)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12360734818416001)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12360980807416001)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100008)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12361192385416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12361342449416001)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100008)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12361560563416001)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100008)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12361759024416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100008)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12361960600416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100008)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12362118656416001)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100008)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12362364391416001)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100008)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12362567316416001)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12362725973416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100008)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12362941946416001)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12363144388416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100008)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12363383861416001)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100008)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12363551060416001)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100008)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12363706695416002)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100008)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12363982133416002)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100008)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12364144532416002)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12364385837416002)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12364529900416002)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100008)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12364759256416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12364908063416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12365101573416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12365375880416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12365510846416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12365717977416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12365993927416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12366107774416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100008)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12366305309416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12366532443416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12366724899416003)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12366943564416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12367192304416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100008)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12367390745416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12367583268416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12367764894416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12367936001416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12368160993416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12368364403416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12368504905416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12368741962416004)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100008)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12368946548416005)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12369120268416005)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100008)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12369384438416005)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100008)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12369527100416005)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100008)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12369725029416005)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100008)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12369996926416005)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12370140954416005)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100008)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12370336141416005)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12370505483416005)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12370746084416005)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100008)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12370975005416005)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100008)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12371124615416005)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100008)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12371341004416005)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100008)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12371543993416005)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12371767547416006)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12371910879416006)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100008)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12372109937416006)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100008)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12372388974416006)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100008)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12372584878416006)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100008)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12372770411416006)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12372914368416006)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100008)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12373191552416006)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100008)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12373322688416006)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100008)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12373505113416006)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12373796170416006)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12373901087416006)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12374124960416006)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100008)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12374366811416006)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100008)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12374561978416006)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12374779125416006)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100008)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12374959509416006)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100008)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12375155581416006)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12375331066416006)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12375502114416006)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12375776412416006)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12375903025416006)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12376198722416007)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12376377014416007)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100008)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12376573884416007)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100008)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12376731649416007)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12376969137416007)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100008)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12377148180416007)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12377378366416007)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100008)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12377514422416007)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100008)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12377747011416007)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12377925698416007)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100008)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12378178157416007)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100008)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12378341091416007)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100008)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12378535954416007)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12378746073416007)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12378990332416007)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12379174505416007)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100008)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12379375706416007)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100008)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12379587683416007)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12379784938416007)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12379926862416007)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12380106482416008)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12380377027416008)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12380539476416008)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12380792116416008)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12380930776416008)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12381169154416008)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12381364762416008)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100008)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12381589025416008)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100008)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12381759312416009)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100008)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12381989599416009)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100008)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12382196021416009)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100008)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12382344992416009)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100008)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12382522924416009)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100008)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12382736657416009)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12382904207416009)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100008)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12383139640416009)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100008)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12383310617416009)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100008)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12383566816416010)
,p_page_id=>5
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100008)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12383719412416010)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100008)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12383973284416010)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100008)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12384128883416010)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12384355961416010)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12384596927416010)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100008)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12384737637416010)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100008)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12384962884416010)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100008)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12385127987416010)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100008)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12385351572416010)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12385526684416010)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100008)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12385769247416010)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100008)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12385910327416010)
,p_page_id=>37
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100008)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12386185237416010)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12386329585416010)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12386512512416010)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12386770316416010)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100008)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12386954946416010)
,p_page_id=>33
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100008)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12387124559416010)
,p_page_id=>11
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12387350282416010)
,p_page_id=>39
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100008)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12387508515416010)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100008)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12387748235416010)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100008)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12387913432416011)
,p_page_id=>50
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100008)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12388191937416011)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100008)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12388323817416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100008)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12388517963416011)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100008)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12388766720416011)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12388996671416011)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100008)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12389101651416011)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100008)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12389386112416011)
,p_page_id=>4
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100008)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12389535068416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100008)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12389766096416011)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12389993204416011)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100008)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12390155049416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100008)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12390313484416011)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12390520854416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100008)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12390788377416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100008)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12390906634416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100008)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12391168958416011)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100008)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12391385042416011)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100008)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12391526504416011)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12391751353416011)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100008)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12391917306416012)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100008)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12392137990416012)
,p_page_id=>13
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100008)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12392366793416012)
,p_page_id=>38
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12392518488416012)
,p_page_id=>1
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100008)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12392715588416012)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100008)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12392918781416012)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12393142915416012)
,p_page_id=>14
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100008)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12393349298416012)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100008)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12393537767416012)
,p_page_id=>30
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100008)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12393774861416012)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100008)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12393911638416012)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100008)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12394174841416013)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12394336508416013)
,p_page_id=>51
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100008)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12394532496416013)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12394717660416013)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12394943847416013)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12395113685416013)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12395365744416013)
,p_page_id=>31
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100008)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12395513794416014)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12395716580416014)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12395901596416014)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12396157767416014)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12396371778416014)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12396522092416014)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12396713460416014)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12396938218416014)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12397181616416014)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12397396958416014)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12397506436416015)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12397757367416015)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12397902060416015)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12398184836416015)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12398350210416015)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12398595423416015)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12398774040416015)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12398976184416015)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12399119423416015)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12399329798416016)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12399593576416016)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12399752318416016)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12399993694416016)
,p_page_id=>6
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100008)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12400169062416017)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12400302736416017)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12400519553416017)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12400793529416017)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12400917722416017)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12401152949416017)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12401307751416017)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12401560491416018)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12401796608416018)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12401956073416018)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12402194610416018)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12402330683416018)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12402553084416018)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12402709361416018)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12402972226416018)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12403184784416018)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12403361352416018)
,p_page_id=>20
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100008)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12403559838416019)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12403773662416019)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12403948998416019)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12404178620416019)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12404326207416019)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12404596982416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100008)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12404749759416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100008)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12404918267416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100008)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12405173952416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100008)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12405337207416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100008)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12405512786416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100008)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12405795054416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100008)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12405941292416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100008)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12406162336416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100008)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12406379841416020)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100008)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C\FF0C\6388\6B0A\8CC7\8A0A')
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12406526680416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100008)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12406795897416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100008)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12406908145416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100008)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12407112179416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100008)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12407364621416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12407536060416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100008)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12407757088416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100008)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12407906768416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100008)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12408168850416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100008)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12408347401416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100008)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12408507130416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100008)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12408772925416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100008)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12408965297416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100008)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12409171589416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100008)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12409327429416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100008)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12409523513416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100008)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12409769414416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100008)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12409972435416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100008)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12410107322416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100008)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12410343159416021)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100008)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12410505646416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100008)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12410783166416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100008)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12410911289416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100008)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12411182286416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100008)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12411371325416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12411504410416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100008)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12411727150416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100008)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12411942563416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12412160530416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100008)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12412339962416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12412533004416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100008)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12412738438416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100008)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12412960822416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100008)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12413118679416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100008)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12413348729416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100008)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12413528979416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100008)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12413789604416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100008)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12413963146416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100008)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12414133004416022)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100008)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12414348824416023)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100008)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12414512040416023)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12414777270416024)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12414953412416024)
,p_page_id=>9999
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100008)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5BC6\78BC')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12415189549416025)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12415393110416025)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12415534745416025)
,p_page_id=>12
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100008)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12415765065416025)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100008)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12415907184416027)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \4E0D\6703\64F7\53D6\6B65\9A5F\7684\4F7F\7528\8005\8CC7\8A0A 	</li>'),
unistr('     <li><strong>disabled</strong> (\9810\8A2D) - \64F7\53D6\6D41\7A0B\5F15\64CE\5DF2\77E5\4E4B\8655\7406\4F5C\696D\6B65\9A5F\7684\4F7F\7528\8005 ID	 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12416060532416027)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5982\679C\5916\9001\90F5\4EF6 serviceTasks \672A\5B9A\7FA9\5BC4\4EF6\8005\FF0C\5247\61C9\8A2D\70BA\60A8\7684\9810\8A2D\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005\3002')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12416212886416027)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\82E5\672A\63D0\4F9B\5176\4ED6\4F7F\7528\8005\540D\7A31\FF0C\8981\5728 APEX \968E\6BB5\4F5C\696D\5EFA\7ACB\968E\6BB5\4F5C\696D\7684\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12416499441416027)
,p_page_id=>7
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100008)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\522A\9664\95DC\806F\7684\8655\7406\4F5C\696D\57F7\884C\8655\7406')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12416664562416027)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100008)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5982\679C\4FDD\7559\7A7A\767D\FF0C\5C07\4FDD\7559\76EE\524D\4F7F\7528\8005\7684\5DE5\4F5C (app_user)\3002')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12416824259416027)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C0D\9031\671F\8A08\6642\5668\800C\8A00\FF0C\9019\6703\5B9A\7FA9\6700\5927\57F7\884C\6578\3002')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12417004065416027)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100008)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FC5\8981\683C\5F0F\FF1AYYYY-MM-DD HH24\FF1AMI:SS TZR')
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12417273987416027)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development.\5F15\64CE\4E0D\6703\4F7F\7528\6B65\9A5F\7D22\5F15\9375\4F86\9632\6B62\55AE\4E00\6B65\9A5F\767C\751F\91CD\8907\52D5\4F5C\3002</li>'),
unistr('     <li><strong>strict</strong> (\5EFA\8B70) - \5C07\6B64\9078\9805\7528\65BC\65B0\7684\958B\767C\548C (\6216) \5B8C\5168\79FB\8F49\7684\61C9\7528\7A0B\5F0F\3002\5F15\64CE\4F7F\7528\6B65\9A5F\9375\4EE5\907F\514D\55AE\4E00\6B65\9A5F\767C\751F\91CD\8907\52D5\4F5C\3002</li>'),
' </ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12417497337416027)
,p_page_id=>2
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100008)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5728\55AE\4E00\6A21\578B\8907\88FD\7684\60C5\6CC1\4E0B\FF0C\65B0\6A21\578B\6703\6709\8F38\5165\7684\540D\7A31\FF0C\4F46\5982\679C\60A8\9078\53D6\4E00\500B\4EE5\4E0A\7684\8CC7\6599\5217\FF0C\5247\8F38\5165\7684\503C\5C07\6703\4F5C\70BA\5B57\5C3E\3002')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12417672934416027)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\4F86\986F\793A\932F\8AA4\8A0A\606F\8207\65E5\8A8C\4E8B\4EF6\7684\8A9E\8A00\3002')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12417819678416027)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development.\5F15\64CE\4E0D\6703\4F7F\7528\6B65\9A5F\7D22\5F15\9375\4F86\9632\6B62\55AE\4E00\6B65\9A5F\767C\751F\91CD\8907\52D5\4F5C\3002</li>'),
unistr('     <li><strong>strict</strong> (\5EFA\8B70) - \5C07\6B64\9078\9805\7528\65BC\65B0\7684\958B\767C\548C (\6216) \5B8C\5168\79FB\8F49\7684\61C9\7528\7A0B\5F0F\3002\5F15\64CE\4F7F\7528\6B65\9A5F\9375\4EE5\907F\514D\55AE\4E00\6B65\9A5F\767C\751F\91CD\8907\52D5\4F5C\3002</li>'),
' </ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12418054175416027)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100008)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \8A18\9304\529F\80FD\505C\7528 	</li>'),
unistr('     <li><strong>standard</strong> (\9810\8A2D) - \8A18\9304\57F7\884C\8655\7406\4E8B\4EF6 </li>'),
unistr('     <li><strong>secure</strong> - \8A18\9304\6A21\578B\4E8B\4EF6\548C\57F7\884C\8655\7406\4E8B\4EF6 	</li>'),
unistr('     <li><strong>full</strong> - \65E5\8A8C\6A21\578B\3001\57F7\884C\8655\7406\53CA\8655\7406\8B8A\6578\4E8B\4EF6 		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12418294843416027)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C07\63D0\4F9B\7528\4F86\5EFA\7ACB\968E\6BB5\4F5C\696D\4E4B\5176\4E2D\4E00\500B APEX App \7684\61C9\7528\7A0B\5F0F ID')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12418469081416027)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C07\63D0\4F9B\7528\4F86\5EFA\7ACB\968E\6BB5\4F5C\696D\4E4B\5176\4E2D\4E00\500B App \7684\9801\9762 ID')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12418630374416027)
,p_page_id=>36
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100008)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C0D\9031\671F\8A08\6642\5668\800C\8A00\FF0C\9019\6703\5B9A\7FA9\6700\5927\57F7\884C\6578\3002')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12418871034416027)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Should be set to your default APEX workspace used for Flows for APEX.\9019\662F\5728\5EFA\7ACB APEX \968E\6BB5\4F5C\696D\6216\5C0B\627E\90F5\4EF6\6A23\677F\6642\FF0C\505A\70BA scriptTasks \548C serviceTasks \7684\6700\5F8C\91CD\65B0\6392\5E8F')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12419061913416027)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \4E0D\6703\64F7\53D6\6B65\9A5F\7684\4F7F\7528\8005\8CC7\8A0A 	</li>'),
unistr('     <li><strong>disabled</strong> (\9810\8A2D) - \64F7\53D6\6D41\7A0B\5F15\64CE\5DF2\77E5\4E4B\8655\7406\4F5C\696D\6B65\9A5F\7684\4F7F\7528\8005 ID	 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12419287068416028)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\82E5\672A\63D0\4F9B\5176\4ED6\4F7F\7528\8005\540D\7A31\FF0C\8981\5728 APEX \968E\6BB5\4F5C\696D\5EFA\7ACB\968E\6BB5\4F5C\696D\7684\4F7F\7528\8005\540D\7A31')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12419429893416028)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100008)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (\9810\8A2D) - \9632\6B62\7DE8\8F2F\5DF2\767C\884C\6A21\578B\7684\5716\8868 </li>'),
unistr('     <li><strong>development</strong> - \5141\8A31\7DE8\8F2F\5DF2\767C\884C\6A21\578B\7684\5716\8868 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12419626664416028)
,p_page_id=>32
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100008)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7528\4F86\986F\793A\932F\8AA4\8A0A\606F\8207\65E5\8A8C\4E8B\4EF6\7684\8A9E\8A00\3002')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12419852483416028)
,p_page_id=>34
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100008)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (\9810\8A2D) - \9632\6B62\7DE8\8F2F\5DF2\767C\884C\6A21\578B\7684\5716\8868 </li>'),
unistr('     <li><strong>development</strong> - \5141\8A31\7DE8\8F2F\5DF2\767C\884C\6A21\578B\7684\5716\8868 </li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12420018756416028)
,p_page_id=>35
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100008)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Should be set to your default APEX workspace used for Flows for APEX.\9019\662F\5728\5EFA\7ACB APEX \968E\6BB5\4F5C\696D\6216\5C0B\627E\90F5\4EF6\6A23\677F\6642\FF0C\7528\4F86\4F5C\70BA scriptTasks \548C serviceTasks \7684\6700\5F8C\91CD\65B0\6392\5E8F\3002')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12420206831416028)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C07\63D0\4F9B\7528\4F86\5EFA\7ACB\968E\6BB5\4F5C\696D\4E4B\5176\4E2D\4E00\500B APEX App \7684\61C9\7528\7A0B\5F0F ID')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12420439684416028)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100008)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \8A18\9304\529F\80FD\505C\7528 	</li>'),
unistr('     <li><strong>standard</strong> (\9810\8A2D) - \8A18\9304\57F7\884C\8655\7406\4E8B\4EF6 </li>'),
unistr('     <li><strong>secure</strong> - \8A18\9304\6A21\578B\4E8B\4EF6\548C\57F7\884C\8655\7406\4E8B\4EF6 	</li>'),
unistr('     <li><strong>full</strong> - \65E5\8A8C\6A21\578B\3001\57F7\884C\8655\7406\53CA\8655\7406\8B8A\6578\4E8B\4EF6 		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12420625235416028)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100008)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C07\63D0\4F9B\7528\4F86\5EFA\7ACB\968E\6BB5\4F5C\696D\4E4B\5176\4E2D\4E00\500B App \7684\9801\9762 ID')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12420812618416028)
,p_page_id=>100
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100008)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5982\679C\5916\9001\90F5\4EF6 serviceTasks \672A\5B9A\7FA9\5BC4\4EF6\8005\FF0C\5247\61C9\8A2D\70BA\60A8\7684\9810\8A2D\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005\3002')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12421043056416029)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100008)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12421227981416029)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12421416168416029)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\79D2 second')
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12421655939416029)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100008)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12421845047416029)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\8655\7406\932F\8AA4')
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12422023686416029)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12422246608416029)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\5927\503C')
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12422457128416029)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100008)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85\4E2D - \4E0A\9650')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12422643566416029)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\932F\8AA4')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12422879801416029)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\555F\52D5\7684\57F7\884C\8655\7406')
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12423089912416029)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593 - 90pc')
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12423264964416029)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593 - 10pc')
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12423487237416030)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100008)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\7D42\6B62')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12423608107416030)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\6B62\7684\57F7\884C\8655\7406')
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12423865150416030)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90pc \6301\7E8C\6642\9593')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12424067968416030)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100008)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \767E\5206\4F4D\6578')
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12424247564416030)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('50 \767E\5206\4F4D\6578')
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12424438998416030)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100008)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85\4E2D - 90pc')
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12424682335416030)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100008)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7CFB\5217 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12424823206416030)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100008)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12425052697416030)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100008)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12425275495416030)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85\4E2D - 10pc')
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12425460322416030)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100008)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\958B\59CB')
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12425604011416030)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100008)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7CFB\5217 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12425857105416030)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90 \767E\5206\4F4D\6578')
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12426050809416030)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593 - 50pc')
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12426264362416030)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100008)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\4E2D')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12426499953416030)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100008)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\57F7\884C\4E2D')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12426695856416030)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\5B8C\6210')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12426829222416030)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DF2\7D42\6B62')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12427089406416030)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\6210\7684\57F7\884C\8655\7406')
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12427251601416030)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85\4E2D - 10pc')
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12427496105416031)
,p_page_id=>16
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100008)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6301\7E8C\6642\9593\4E2D\4F4D\6578')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12427665345416031)
,p_page_id=>3
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100008)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12427825136416031)
,p_page_id=>15
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100008)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\91CD\8A2D')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12428067620416031)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100008)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 50pc')
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12428260561416031)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85 - 50pc')
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12428474856416031)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100008)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6301\7E8C\6642\9593 - \4E0A\9650')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12428669120416031)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85\4E2D - \4E0A\9650')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12428883687416031)
,p_page_id=>17
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100008)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7B49\5F85\4E2D - 90pc')
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12429047432416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100008)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12429251856416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100008)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12429482615416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100008)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\985E')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12429649404416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100008)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12429845291416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100008)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72C0\614B')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12430076986416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100008)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\7A31')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12430262528416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100008)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\985E')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12430489979416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100008)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7248\672C')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12430650851416032)
,p_translated_flow_id=>100008
,p_translate_to_id=>100.100008
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12430872425416034)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100008)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\300C\6BCF\65E5\57F7\884C\74B0\5883\5F59\7E3D\5B58\6A94\300D\8655\7406\932F\8AA4')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12431085801416034)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100008)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error purging Flows for APEX Statistics summaries'
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12431288376416034)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100008)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \6C38\4E45\6E05\9664\65E5\8A8C\8868\683C\6642\767C\751F\932F\8AA4\3002')
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12431402123416034)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100008)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error gathering daily Flows for APEX Stats'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12431631262416034)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12431830423416034)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12432029504416034)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100008)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12432259847416036)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>6.100001
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Import'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12432471453416036)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>50.100001
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8les de formulaire simples')
,p_translate_from_text=>'Simple Form Templates'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12432668202416036)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>14.100001
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Journaux'
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12432855333416036)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>51.100001
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifier le mod\00E8le de formulaire simple')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12433063492416036)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>1.100001
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bien d\00E9marrer')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12433260484416036)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>7.100001
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flux'
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12433454119416036)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>15.100001
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques quotidiennes'
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12433619507416036)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>31.100001
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12433868219416036)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>36.100001
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Compteurs'
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12434009342416037)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>34.100001
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Application de moteur'
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12434292827416037)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>11.100001
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er une instance de flux')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12434415513416037)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>30.100001
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - REST'
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12434625510416037)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>2.100001
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gestion des mod\00E8les')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12434887926416037)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>8.100001
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9tails de l''instance de flux')
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12435062515416037)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>12.100001
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visionneuse'
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12435203241416037)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>17.100001
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statistiques de t\00E2che')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12435437153416037)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>37.100001
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Statistiques'
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12435636689416037)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>4.100001
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9diteur de flux')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12435890308416037)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>5.100001
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Export'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12436025587416037)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>10.100001
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Surveillance des instances'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12436227099416037)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>35.100001
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Moteur'
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12436407189416037)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>33.100001
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Archivage'
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12436681433416037)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>3.100001
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tableau de bord'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12436836603416037)
,p_page_id=>9
,p_translated_flow_id=>100001
,p_translate_to_id=>9.100001
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12437009218416037)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>20.100001
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chronologie d''instance - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12437222764416037)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>38.100001
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Lieu'
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12437449056416037)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>13.100001
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9tails de l''objet')
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12437667184416037)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>39.100001
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Licence'
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12437855435416037)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>16.100001
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques de processus'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12438046998416038)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>32.100001
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Journalisation'
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12438246893416038)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>100.100001
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration [OLD, BACKUP]'
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12438497639416038)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>9999.100001
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Page de connexion'
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12438637253416039)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>6.100001
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Import - &APP_NAME_TITLE.'
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12438832816416039)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>50.100001
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8les de formulaire simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12439011431416039)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>51.100001
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifier le mod\00E8le de formulaire simple')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12439273067416039)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>1.100001
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bien d\00E9marrer - &APP_NAME_TITLE.')
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12439445642416039)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>7.100001
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flux  - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12439644570416039)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>15.100001
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques quotidiennes'
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12439858143416039)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>31.100001
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12440089235416039)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>36.100001
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Compteurs'
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12440236765416039)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>34.100001
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Application de moteur'
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12440490755416039)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>11.100001
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er une instance de flux - &APP_NAME_TITLE.')
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12440668614416039)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>30.100001
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - REST'
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12440867055416039)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>2.100001
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestion des flux - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12441010734416039)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>8.100001
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9tails de l''instance de flux - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12441229428416039)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>12.100001
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Surveillance des instances - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12441425380416039)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>17.100001
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statistiques de t\00E2che')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12441693664416039)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>37.100001
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Statistiques'
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12441827981416039)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>4.100001
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9diteur de flux - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12442007884416039)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>5.100001
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Export - &APP_NAME_TITLE.'
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12442282805416039)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>10.100001
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Surveillance des instances - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12442458903416039)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>35.100001
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Moteur'
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12442603543416040)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>33.100001
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Archivage'
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12442865854416040)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>3.100001
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tableau de bord - &APP_NAME_TITLE.'
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12443002096416040)
,p_page_id=>9
,p_translated_flow_id=>100001
,p_translate_to_id=>9.100001
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12443260360416040)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>20.100001
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chronologie d''instance - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12443464125416040)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>38.100001
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Lieu'
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12443694331416040)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>39.100001
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Licence'
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12443816286416040)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>16.100001
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques de processus'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12444053746416040)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>32.100001
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Journalisation'
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12444241356416040)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>100.100001
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration [OLD, BACKUP]'
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12444465737416040)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>9999.100001
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12444661598416041)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100001)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('S\00E9lectionner tout')
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12444816364416041)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100001)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9finir la route de la passerelle')
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12445033349416041)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100001)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12445240268416041)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100001)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12445410573416041)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12445619823416041)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100001)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9s\00E9lectionner tout')
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12445802592416041)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12446088276416041)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100001)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter une variable de processus'
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12446239927416041)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100001)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12446446949416041)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100001)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration REST'
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12446689240416041)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12446893124416042)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100001)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importer et modifier'
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12447032818416042)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100001)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12447282600416042)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100001)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12447430714416042)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nouvelle version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12447657350416042)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100001)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12447885199416042)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12448009825416042)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Recevoir le message'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12448242020416042)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100001)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12448437455416042)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100001)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12448636379416042)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12448899418416042)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100001)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12449018047416042)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100001)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12449282555416042)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100001)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er un mod\00E8le')
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12449488749416042)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100001)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12449651292416042)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100001)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enregistrer'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12449861303416042)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100001)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12450062849416043)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100001)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importer et importer de nouveau'
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12450285538416043)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100001)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12450478745416043)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Copier le mod\00E8le')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12450687413416043)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100001)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12450891789416043)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100001)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12451028487416043)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se connecter'
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12451225838416043)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100001)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12451486016416043)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100001)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration REST'
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12451681057416043)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Publier'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12451809860416043)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er un mod\00E8le')
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12452019324416043)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100001)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifier le diagramme'
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12452206564416043)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100001)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12452472998416043)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100001)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter une version'
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12452649559416043)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importer'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12452827735416043)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12453009667416043)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100001)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12453215880416043)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archiver'
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12453479540416043)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12453633359416043)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100001)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12453870154416043)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100001)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12454027176416044)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100001)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12454258649416044)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exporter'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12454469842416044)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100001)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Voir l''historique'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12454698372416044)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100001)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12454816387416044)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er une instance')
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12455034339416044)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100001)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12455245986416044)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100001)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12455404323416044)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100001)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12455604714416044)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100001)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12455898709416044)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100001)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12456039368416044)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9pr\00E9cier')
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12456272880416044)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9server')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12456430124416044)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100001)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter une version'
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12456628066416044)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100001)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12456841558416044)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifier la configuration'
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12457022493416044)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100001)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12457252728416044)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Appliquer les modifications'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12457474987416044)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogrammation minuteur'
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12457621092416044)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12457874179416044)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100001)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12458029743416044)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100001)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Confirmer'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12458219817416045)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100001)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifier la configuration'
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12458461480416045)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100001)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12458644843416045)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100001)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9er')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12458898699416045)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100001)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annuler'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12459017269416045)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Confirmer'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12459245470416045)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100001)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12459456250416045)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100001)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12459600481416045)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100001)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enregistrer'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12459868280416047)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100001)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12460072402416047)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Masquer l''ID utilisateur'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12460225678416047)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colonne d''ID'
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12460475392416047)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cl\00E9 de licence')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12460683898416047)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colonne d''horodatage'
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12460805822416047)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL de base'
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12461089309416047)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100001)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nouvelle version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12461252342416047)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Charge utile'
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12461496055416047)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100001)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Connexion'
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12461600575416047)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Exp\00E9diteur de courriel par d\00E9faut')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12461899415416047)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12462090248416047)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramme d''appel'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12462232515416048)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12462403463416048)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nom d''utilisateur par d\00E9faut')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12462623579416048)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12462834409416048)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12463096049416048)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Intervalle de r\00E9p\00E9tition de l''horloge')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12463288265416048)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom du fichier'
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12463493501416048)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Etape'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12463696941416048)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom du bucket'
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12463814822416048)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100001)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9dition de la licence')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12464044221416048)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100001)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Importer \00E0 partir de')
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12464245862416048)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Op\00E9ration')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12464487291416048)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12464679412416048)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12464816527416048)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pr\00E9fixe du document')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12465095747416048)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Date'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12465235544416048)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nouveau'
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12465407520416048)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100001)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Forcer le remplacement'
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12465634027416048)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9servation')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12465863726416048)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre maximal de cycles de temporisation'
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12466052008416048)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cat\00E9gorie')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12466214949416048)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12466401347416049)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ex\00E9cut\00E9 par')
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12466683122416049)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom de la table'
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12466883232416049)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inclure la date de derni\00E8re modification')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12467063569416049)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12467204686416049)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100001)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passerelle'
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12467409514416049)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conserver les synth\00E8ses mensuelles (mois)')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12467625809416049)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conservation du journal de flux de messages (jours) (non encore impl\00E9ment\00E9e)')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12467814823416049)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100001)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'En cascade'
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12468048047416049)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100001)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12468233916416049)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau de processus'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12468429076416049)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12468680082416049)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mot de passe'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12468813521416049)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conserver les journaux (jours)'
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12469001637416049)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12469231661416049)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramme XML'
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12469443303416049)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inclure la version'
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12469630604416049)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fichier'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12469842095416049)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reprogrammer le minuteur \00E0')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12470061475416049)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Emplacement de l''archive d''instance'
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12470219372416049)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12470453700416050)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E9l\00E9charger en tant que')
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12470642995416050)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12470861965416050)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variable de processus'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12471077521416050)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cl\00E9 secr\00E8te du client')
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12471276351416050)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pr\00E9vention des \00E9tapes en double')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12471414939416050)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nouveau nom/Suffixe'
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12471634437416050)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statique des informations d''identification APEX'
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12471895623416050)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Langue'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12472087680416050)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statique'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12472207107416050)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100001)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Propri\00E9taire')
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12472476027416050)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Licence attribu\00E9e \00E0')
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12472652162416050)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pr\00E9vention des \00E9tapes en double')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12472855058416050)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12473097998416050)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID application par d\00E9faut')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12473223574416050)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de page par d\00E9faut')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12473460814416050)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom d''utilisateur'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12473653500416050)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Port\00E9e')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12473852978416050)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference (Variable de processus)'
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12474015891416050)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inclure la cat\00E9gorie')
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12474266012416050)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Journaliser les entr\00E9es MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12474412366416050)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100001)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre maximal de cycles de temporisation'
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12474676264416050)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type de destination'
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12474892090416051)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12475033467416051)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mode'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12475295856416051)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coller le contenu du fichier BPMN (30 000 caract\00E8res max.)')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12475498841416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Espace de travail par d\00E9faut')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12475628008416051)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conserver les synth\00E8ses quotidiennes (jours)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12475878998416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Masquer l''ID utilisateur'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12476059835416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Journaliser les entr\00E9es MessageFlow (pas encore impl\00E9ment\00E9es)')
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12476230159416051)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conserver les journaux (jours apr\00E8s la fin de l''instance de processus)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12476400976416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nom d''utilisateur par d\00E9faut')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12476684880416051)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statique des informations d''identification APEX'
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12476865711416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Compteurs activ\00E9s')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12477057364416051)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colonne BLOB'
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12477205541416051)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100001)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Date d''expiration de la licence'
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12477410945416051)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12477667704416051)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Consigner les appels restants entrants'
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12477847043416051)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI de redirection'
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12478017908416051)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('URL de pr\00E9-authentification')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12478290136416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100001)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mode'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12478470396416051)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conserver les journaux (jours apr\00E8s la fin de l''instance de processus)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12478655525416051)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI de support'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12478837352416052)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inclure le statut'
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12479081931416052)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12479250463416052)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100001)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Langue'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12479445556416052)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pr\00E9fixe du document')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12479646117416052)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Activer l''archivage r\00E9capitulatif des instances')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12479802540416052)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12480014212416052)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID application par d\00E9faut')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12480211284416052)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12480414212416052)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100001)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mode'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12480631571416052)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se souvenir du nom d''utilisateur'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12480874758416052)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8le')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12481073450416052)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Espace de travail par d\00E9faut')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12481224317416052)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogrammer le minuteur maintenant'
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12481493079416052)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conservation du journal de flux de messages (jours)'
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12481614146416052)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8le')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12481871129416052)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12482038486416052)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12482268619416052)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12482492290416052)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conserver les synth\00E8ses trimestrielles (mois)')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12482697728416052)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom de variable'
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12482885370416053)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID client'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12483092902416053)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de page par d\00E9faut')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12483266776416053)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100001)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL de base'
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12483476359416053)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Courriel d''assistance'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12483667683416053)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Compteurs activ\00E9s')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12483894909416053)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12484057878416053)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100001)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nouvelle version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12484257069416053)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cat\00E9gorie')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12484412026416053)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rechercher'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12484604611416053)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100001)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12484873919416053)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Activer l''archivage r\00E9capitulatif des instances')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12485014848416053)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Exp\00E9diteur de courriel par d\00E9faut')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12485230572416056)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100001)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Format JSON non valide'
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12485439999416056)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100001)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le champ #LABEL# ne peut \00EAtre vide.')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12485691977416056)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100001)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Veuillez v\00E9rifier le flux fourni.')
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12485898569416056)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le champ #LABEL# ne peut \00EAtre vide.')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12486030144416056)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100001)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le champ #LABEL# ne peut \00EAtre vide.')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12486205731416056)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le champ #LABEL# ne peut \00EAtre vide.')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12486468290416057)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vous ne pouvez pas archiver un mod\00E8le qui est associ\00E9 \00E0 des instances en cours d''ex\00E9cution.')
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12486691506416057)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100001)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Veuillez coller le contenu du fichier BMPN'
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12486848292416057)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100001)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Veuillez s\00E9lectionner un #LABEL#.')
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12487056752416057)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le mod\00E8le existe d\00E9j\00E0. Utilisez le remplacement forc\00E9.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12487207826416057)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le flux existe d\00E9j\00E0. Activez l''option de remplacement forc\00E9.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12487436554416057)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8le import\00E9.')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12487670927416057)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100001)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12487812818416057)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100001)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12488047455416057)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100001)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12488213160416057)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100001)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12488499794416057)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100001)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12488694065416057)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100001)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuration restante enregistr\00E9e.')
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12488898104416058)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12489050168416058)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100001)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12489236830416058)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100001)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12489470090416058)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100001)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modifications enregistr\00E9es.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12489621295416058)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100001)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Action effectu\00E9e.')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12489807470416058)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100001)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12490047500416058)
,p_page_id=>9
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100001)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Changements enregistr\00E9s.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12490262716416058)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8le import\00E9.')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12490497073416058)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100001)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00C9v\00E9nements de l''instance')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12490657620416059)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100001)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Moteur'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12490854774416059)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100001)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('D\00E9tails de l''instance')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12491024652416059)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100001)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00C9v\00E9nements de l''instance')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12491219474416059)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100001)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Clients OAUTH'
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12491430466416059)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100001)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12491686260416059)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100001)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12491829722416059)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100001)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12492039092416059)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100001)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configuration - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12492249296416059)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100001)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12492419763416059)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Performances du processus (synth\00E8ses de p\00E9riode)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12492626475416059)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100001)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Sous-flux courant'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12492833156416059)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100001)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Barre de boutons'
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12493072984416059)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100001)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Historique des variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12493221225416059)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100001)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configuration JSON'
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12493478509416059)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100001)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Minuteurs'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12493605792416059)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00C9v\00E8nements de l''\00E9tape')
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12493844618416059)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Mod\00E8les de formulaire simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12494054039416059)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100001)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12494282967416059)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances de flux par statut'
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12494425961416059)
,p_page_id=>9
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100001)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Sections'
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12494669274416059)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100001)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00C9tapes termin\00E9es')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12494829325416060)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Rechercher'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12495072486416060)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('D\00E9tails du diagramme')
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12495238450416060)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Abonnements aux messages'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12495459958416060)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100001)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Diagrammes appel\00E9s')
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12495616627416060)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100001)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12495869552416060)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100001)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12496057002416060)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100001)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Bien d\00E9marrer')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12496212187416060)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance de flux'
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12496441406416060)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Cr\00E9er une instance de flux')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12496661420416060)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100001)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Non-concordance de versions'
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12496805911416060)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100001)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Import'
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12497001043416060)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100001)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12497217413416060)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Pr\00E9requis manquants')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12497402065416060)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100001)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Boutons'
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12497660802416060)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100001)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Nouvelle version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12497871428416060)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100001)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('R\00E9sultats de la recherche')
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12498061354416060)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100001)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Application de moteur'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12498223263416061)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100001)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Statistiques'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12498406471416061)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100001)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Application de moteur'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12498604093416061)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Erreurs d''instance au cours des 14 derniers jours'
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12498866864416061)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100001)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configuration JSON'
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12499035997416061)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100001)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12499215247416061)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visionneuse de flux'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12499452873416061)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100001)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attributs'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12499691747416061)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Lieu'
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12499829503416061)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100001)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Options'
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12500044800416061)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100001)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ajouter une route de passerelle'
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12500265114416061)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100001)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Diagramme appel\00E9')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12500455503416061)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100001)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Moteur'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12500650836416061)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100001)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Liens'
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12500838983416061)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12501051205416061)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12501269923416061)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12501446007416061)
,p_page_id=>9
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100001)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12501660940416061)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Module manquant'
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12501897179416061)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Liste de t\00E2ches')
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12502045209416062)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12502220125416062)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100001)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances de flux'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12502468858416062)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Conteneur de boutons'
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12502667488416062)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100001)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12502865420416062)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Copie du mod\00E8le')
,p_translate_from_text=>'Copy Model'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12503075313416062)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Derni\00E8re erreur')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12503291401416062)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100001)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Temps d''attente d''\00E9tape historique pour &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12503402272416062)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100001)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attributs'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12503612949416062)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100001)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Sous-flux termin\00E9s')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12503882521416062)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100001)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00C9tapes courantes')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12504080375416062)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visionneuse de flux'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12504235744416062)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100001)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Journalisation'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12504443510416062)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100001)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Archivage'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12504684237416062)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100001)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Gestion des mod\00E8les')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12504811691416062)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100001)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12505056738416062)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100001)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12505232637416062)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100001)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12505466061416062)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100001)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Fil d''Ariane'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12505652860416063)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagrammes appelants'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12505899751416063)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100001)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Licence'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12506085642416063)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12506234230416063)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100001)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12506470456416063)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100001)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12506681139416063)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Non compatible REST'
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12506841375416063)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Onglet'
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12507028250416063)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100001)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Performances historiques des \00E9tapes pour &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12507236498416063)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('R\00F4les')
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12507411488416063)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100001)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Avertissement concernant l''import'
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12507666028416063)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('D\00E9tails de l''instance')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12507871738416063)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100001)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12508052981416063)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12508286030416063)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('D\00E9tails de l''instance')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12508455238416063)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100001)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Historique des variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12508633451416063)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configuration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12508838732416063)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100001)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Minuteurs'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12509076383416063)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100001)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances de flux de retard en cours'
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12509269301416064)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100001)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12509423881416064)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Informations'
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12509657625416064)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100001)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12509829337416064)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12510001475416064)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100001)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chemin de navigation'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12510299070416064)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100001)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Processus d\00E9marr\00E9s le &P15_DATE.')
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12510403334416064)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100001)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Etape d''installation suppl\00E9mentaire non termin\00E9e')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12510609454416064)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100001)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Modifier le mod\00E8le de formulaire simple')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12510838514416064)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100001)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12511099806416064)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100001)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00C9v\00E9nements de l''instance')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12511270842416064)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100001)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12511402704416064)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100001)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Performances de l''\00E9tape de t\00E2che (mois en cours) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )')
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12511676576416064)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Erreurs de l''\00E9tape')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12511807726416064)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flux (XML)'
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12512010189416064)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100001)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables entrantes/sortantes'
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12512238969416064)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Remplissez les d\00E9tails')
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12512431592416064)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100001)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Nouvelle version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12512628549416064)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100001)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12512842463416064)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100001)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12513011466416064)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100001)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Fil d''Ariane'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12513231659416065)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100001)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances de processus par statut'
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12513495801416065)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100001)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Suppression du mod\00E8le')
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12513610478416065)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100001)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12513842874416065)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Choisir la destination active'
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12514076523416065)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100001)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Instances de flux en cours par mod\00E8le - 10 principales')
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12514279146416065)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100001)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('R\00E9server l''\00E9tape')
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12514450342416065)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100001)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ajouter/modifier une variable de processus'
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12514646259416065)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12514882606416065)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb - fr'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12515069829416065)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100001)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Instances de flux d\00E9marr\00E9es au cours des 14 derniers jours')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12515279530416065)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12515485258416065)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100001)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12515695679416065)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Compteurs d\00E9sactiv\00E9s')
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12515816738416065)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100001)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12516051854416065)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Reprogrammation minuteur'
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12516275330416065)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Mise \00E0 niveau d''APEX d\00E9tect\00E9e')
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12516415178416065)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12516621942416066)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Bien d\00E9marrer')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12516831827416066)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attributs'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12517071382416066)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100001)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Instances de processus associ\00E9es')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12517274181416066)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12517418655416066)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100001)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12517661141416066)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Surveillance des instances (&P12_FLOW_NAME.)'
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12517883439416066)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('S\00E9lecteur de langue')
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12518024646416066)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100001)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Boutons'
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12518273955416066)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100001)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Journalisation'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12518470468416066)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visionneuse de flux'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12518621279416066)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12518822716416066)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Recevoir le message'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12519037033416066)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu d''action'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12519269140416066)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Erreurs'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12519446992416066)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Contenu'
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12519608968416070)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100001)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12519801012416070)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12520066907416070)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12520262808416070)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100001)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12520452990416070)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100001)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12520661845416070)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12520848021416070)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12521068930416070)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100001)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12521208957416071)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100001)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pour cr\00E9er facilement vos propres d\00E9finitions de formulaire de mani\00E8re d\00E9clarative, vous pouvez utiliser le <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">g\00E9n\00E9rateur de')
||unistr(' formulaire simple</span></a> pour g\00E9n\00E9rer le JSON requis.')
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12521452872416071)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100001)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12521638310416071)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12521829517416071)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100001)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12522015162416071)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Module <li>REST non install\00E9. Suivez le guide d''installation \00E0 l''adresse suivante : <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12522221579416071)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12522436821416071)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100001)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12522659559416071)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100001)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nous vous encourageons \00E0 importer des mod\00E8les qui ont \00E9t\00E9 cr\00E9\00E9s \00E0 l''aide de Flows for APEX afin de vous assurer qu''ils puissent \00EAtre ex\00E9cut\00E9s par le moteur.')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12522826499416071)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>Le sch\00E9ma n''est pas compatible REST</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12523054659416071)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dans cette page, vous pouvez g\00E9rer les d\00E9finitions JSON de vos mod\00E8les de formulaire simple. Vos mod\00E8les peuvent \00EAtre utilis\00E9s de deux mani\00E8res :'),
'<ul>',
unistr('    <li>S\00E9lectionnez-les dans les t\00E2ches utilisateur de type "Formulaires simples" dans vos mod\00E8les de flux</li>'),
unistr('    <li>Utilisez-les dans l''<strong>application D\00E9marrage de processus simple</strong> de la distribution de Flows pour d\00E9marrer des instances de processus en remplissant un formulaire'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12523298494416071)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100001)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12523478935416071)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100001)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12523631202416072)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100001)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pour utiliser la fonctionnalit\00E9 Timers de Flows for APEX, vous devez effectuer une \00E9tape d''installation suppl\00E9mentaire qui peut \00EAtre trouv\00E9e <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers')
||'" target="_blank">ici</a>.'
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12523877593416072)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100001)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12524043483416072)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100001)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12524286084416072)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Les mod\00E8les contenant un ou plusieurs temporisateurs n''ont pas pu fonctionner correctement sur ce syst\00E8me car ils sont d\00E9sactiv\00E9s.<br>Vous pouvez l''activer dans la page Configuration.')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12524434750416072)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12524676762416072)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100001)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12524821462416072)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100001)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12525047797416072)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>Un syst\00E8me de flux de processus low code pour APEX bas\00E9 sur BPMN.</h3>'),
unistr('<h4> Fonctionnalit\00E9s</h4>'),
'<ul>',
unistr('<li>Flows for APEX permet aux d\00E9veloppeurs APEX de mod\00E9liser et d''ex\00E9cuter des flux de processus dans des applications APEX en utilisant une combinaison de conception visuelle de processus et de techniques low code.</li>'),
unistr('<li>Con\00E7u principalement pour les d\00E9veloppeurs APEX, Flows for APEX utilise des technologies qui vous sont famili\00E8res - APEX, PL/SQL et SQL - pour cr\00E9er des flux de processus puissants et flexibles dans votre environnement APEX.</li>'),
unistr('<li>Utilis\00E9 pour cr\00E9er et ex\00E9cuter un flux de processus de pages APEX, de scripts PL/SQL, d''envoi d\2019e-mail.</li>'),
unistr('<li> La d\00E9finition sch\00E9matique du processus peut \00E9galement \00EAtre comprise et modifi\00E9e par les utilisateurs m\00E9tiers afin d''accroitre la flexibilit\00E9 de l''entreprise. Flows for APEX utilise le format BPMN (Business Process Modeling Notation) V2.</li>'),
unistr('<li>D\00E9velopp\00E9 pour la communaut\00E9 APEX et publi\00E9 sous licence libre (MIT).</li>'),
'</ul>',
'<p>',
unistr('<h4>T\00E9l\00E9charger</h4>'),
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Derni\00E8re documentation en ligne</a>'),
'<p>',
'<h4>Tutoriels BPMN</h4>',
unistr('Pour bien d\00E9marrer avec la mod\00E9lisation des flux, essayez les tutoriels pr\00E9install\00E9s. Pour plus d''informations sur les tutoriels, cliquez <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">ici</a>.'),
'<p>',
unistr('<h4>Application de d\00E9monstration</h4>'),
unistr('<p>Consultez notre <a href="https://flowsforapex.org" target="_blank">site</a> pour voir comment l''int\00E9gration d''un flux de processus peut \00EAtre effectu\00E9e.</p>')))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12525215447416072)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100001)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12525469526416072)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12525607599416074)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100001)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Emplacement BPMN'
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12525837442416074)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12526096101416074)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100001)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Emplacement de l''archive'
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12526261901416075)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12526499410416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100001)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Minuteurs'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12526647766416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100001)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12526881968416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100001)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12527026360416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100001)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12527273301416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100001)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rafra\00EEchir')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12527492396416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100001)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12527607651416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100001)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copier'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12527866548416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100001)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminer'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12528006598416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100001)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12528244819416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100001)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminer'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12528493220416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100001)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Th\00E8me')
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12528658438416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100001)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Licence'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12528889102416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100001)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminer'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12529056347416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100001)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Surveillance des instances'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12529223938416075)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9server')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12529428811416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100001)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rafra\00EEchir')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12529687153416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100001)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12529834744416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100001)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Afficher les d\00E9tails')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12530082993416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100001)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter nouvelle version'
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12530266084416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100001)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12530415096416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100001)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E9l\00E9charger (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12530652074416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12530873318416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100001)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9capitulatif de l''instance')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12531062926416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100001)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9diter')
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12531215267416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100001)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12531428259416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100001)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Moteur'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12531673556416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Afficher la chronologie d''instance'
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12531875717416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100001)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12532053418416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100001)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12532223574416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100001)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rafra\00EEchir')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12532495796416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100001)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Afficher les d\00E9tails du mod\00E8le')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12532612231416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100001)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Compl\00E9ter')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12532817609416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100001)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Supprimer'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12533096032416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100001)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ajouter nouvelle version'
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12533245547416076)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100001)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Automatique'
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12533472716416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8les de formulaire simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12533639870416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100001)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Application de moteur'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12533815092416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100001)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9marrer')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12534005808416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100001)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tableau de bord'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12534297995416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100001)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Voir l''historique'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12534434712416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100001)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivage'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12534691953416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100001)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12534835503416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100001)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E9l\00E9charger (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12535002228416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100001)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Minuteurs d''\00E9tape')
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12535239325416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100001)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('en dessous|c\00F4te \00E0 c\00F4te|nouvelle fen\00EAtre')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12535422086416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100001)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12535652298416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se d\00E9connecter')
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12535890345416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100001)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12536094964416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100001)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bien d\00E9marrer')
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12536201336416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100001)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogrammer'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12536469957416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100001)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9marrer')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12536658775416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100001)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Param\00E8tres d''affichage')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12536853301416077)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12537012970416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100001)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importer'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12537257427416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100001)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12537475560416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100001)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exporter'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12537681070416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100001)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copier'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12537871662416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mode sombre'
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12538003367416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100001)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12538267680416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100001)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12538402863416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100001)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Afficher les d\00E9tails du mod\00E8le')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12538609618416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100001)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Compl\00E9ter')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12538813753416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12539056849416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lib\00E9rer')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12539299057416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100001)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Param\00E8tres d''affichage')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12539493942416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100001)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Afficher la source'
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12539656681416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100001)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Afficher les d\00E9tails')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12539887784416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100001)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12540004069416078)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Red\00E9marrer')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12540206205416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9server')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12540436674416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100001)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12540687313416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100001)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Journalisation'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12540865692416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lib\00E9rer')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12541088240416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100001)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12541229882416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100001)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12541470596416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100001)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E9l\00E9charger (SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12541636933416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100001)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exporter'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12541818226416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100001)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Voir'
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12542006264416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100001)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9marrer')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12542276120416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mode clair'
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12542427144416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100001)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogrammer'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12542695983416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100001)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12542876395416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100001)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('en dessous|c\00F4te \00E0 c\00F4te|nouvelle fen\00EAtre')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12543059422416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100001)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Voir l''historique'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12543211772416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12543460814416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Red\00E9marrer')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12543623360416079)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100001)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gestion des mod\00E8les')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12543867039416082)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun processus s\00E9lectionn\00E9')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12544097227416082)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun processus s\00E9lectionn\00E9')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12544232372416082)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100001)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun attribut trouv\00E9.')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12544424669416082)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune T\00E2che')
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12544623062416082)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100001)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune variable entrante/sortante trouv\00E9e.')
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12544829113416083)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dialogue de recherche'
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12545027982416083)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12545287168416083)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12545494905416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12545606575416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12545892974416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rechercher'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12546036750416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fermer'
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12546259706416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suivant &gt;'
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12546498304416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('&lt; Pr\00E9c\00E9dent')
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12546632234416084)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Voulez-vous effectuer cette action de suppression ?'
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12546832879416085)
,p_translated_flow_id=>100001
,p_translate_to_id=>100.100001
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flux de processus'
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12547088169416085)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100001)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques de processus'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12547232164416085)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100001)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gestion des mod\00E8les')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12547458278416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100001)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Service REST'
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12547638477416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Moteur'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12547807185416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100001)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivage'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12548071364416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100001)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Surveillance des instances'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12548251075416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100001)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chronologie d''instance - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12548403952416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100001)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12548619912416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100001)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12548827309416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100001)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tableau de bord'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12549001056416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100001)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statistiques de t\00E2che')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12549220979416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100001)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12549485326416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100001)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Application de moteur'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12549675404416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100001)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiques quotidiennes'
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12549840009416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100001)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8les de formulaire simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12550029088416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100001)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configuration - Licence'
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12550221086416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100001)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9diteur de flux')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12550484495416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100001)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Journalisation'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12550621790416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100001)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Minuteurs'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12550868509416086)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100001)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12551095028416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100001)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fichier'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12551289734416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100001)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Apr\00E8s la t\00E2che')
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12551472728416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100001)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Avant la division'
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12551612887416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100001)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statut du processus apr\00E8s l''arr\00EAt')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12551877856416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100001)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Espace r\00E9serv\00E9')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12552083244416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100001)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12552294678416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100001)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BCC'
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12552434936416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100001)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Date'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12552652024416087)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100001)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Intervalle ann\00E9e/mois')
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12552879825416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100001)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Variables d''entr\00E9e')
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12553056189416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100001)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Texte'
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12553215772416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100001)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Script SQL'
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12553414121416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100001)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Requ\00EAte')
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12553647556416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100001)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El\00E9ments de page')
,p_translate_from_text=>'Page Items'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12553807837416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100001)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Temps jusqu''aux d\00E9clenchements suivants')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12554029334416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100001)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nombre maximal d''ex\00E9cution')
,p_translate_from_text=>'Max Runs'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12554278541416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100001)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variables de sortie'
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12554455894416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100001)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corps de function PL/SQL'
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12554690565416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100001)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Page'
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12554855688416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100001)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Masque de format'
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12555090662416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100001)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Intervalle jour/seconde'
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12555273845416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100001)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Temps jusqu''au premier d\00E9clenchement du minuteur')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12555491562416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100001)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Moteur'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12555665358416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100001)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type de d\00E9finition de minuteur')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12555827882416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100001)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9finition du minuteur')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12556032248416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100001)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9pondre \00E0')
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12556252043416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se souvenir du nom d''utilisateur'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12556491477416088)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100001)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fichier BPMN'
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12556671170416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100001)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Avant la t\00E2che')
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12556804754416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100001)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'A'
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12557035401416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100001)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CC'
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12557294812416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100001)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Envoyer le courriel imm\00E9diatement')
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12557462638416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100001)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Avant l''\00E9v\00E8nement')
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12557626808416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100001)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de l''application'
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12557812047416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100001)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML du corps'
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12558026106416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100001)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Apr\00E8s la r\00E9union')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12558251139416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100001)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'De'
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12558475620416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100001)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur statique'
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12558610990416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100001)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sujet'
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12558893056416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100001)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El\00E9ment')
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12559095276416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100001)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur s\00E9par\00E9e par deux-points)')
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12559254875416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100001)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression PL/SQL'
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12559405145416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100001)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Code PL/SQL'
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12559606079416089)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100001)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variable de processus'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12559852291416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100001)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pendant l''\00E9v\00E8nement')
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12560012213416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100001)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pi\00E8ce jointe')
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12560246274416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100001)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur unique)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12560478945416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100001)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vider le cache'
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12560638495416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100001)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valeurs de l''\00E9l\00E9ment')
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12560871488416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100001)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corps'
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12561081848416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100001)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type de t\00E2che')
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12561228464416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100001)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Utiliser un mod\00E8le')
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12561488669416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100001)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID du mod\00E8le')
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12561678263416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100001)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12561836694416090)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100001)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lier les valeurs des \00E9l\00E9ments de la page')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12562073746416091)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun sous-flux consign\00E9')
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12562204041416092)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun niveau de processus consign\00E9')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12562433805416092)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('- S\00E9lectionnez -')
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12562624465416092)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune cat\00E9gorie')
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12562895791416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100001)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Direction'
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12563085280416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100001)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12563221048416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100001)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12563439141416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100001)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pile d''erreur'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12563657849416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100001)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statut de l''\00E9v\00E9nement')
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12563813334416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100001)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12564058773416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100001)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateur'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12564231458416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12564490952416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100001)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12564600958416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100001)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Date de l''\00E9v\00E9nement')
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12564813825416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12565057241416092)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100001)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Est appelable'
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12565222214416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100001)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Initialis\00E9 le')
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12565438144416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100001)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12565657444416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12565855255416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100001)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id de la page'
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12566087983416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100001)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12566230782416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100001)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom d''utilisateur'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12566497432416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100001)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12566662840416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100001)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12566880596416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100001)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Derni\00E8re mise \00E0 jour le')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12567095237416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100001)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Titre de l''\00E9v\00E9nement')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12567237231416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100001)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ic\00F4ne d''\00E9v\00E9nement')
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12567488537416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100001)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12567615365416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12567843486416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100001)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Description de l''\00E9v\00E9nement')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12568034301416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100001)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12568232465416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12568433709416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100001)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8le')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12568669327416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100001)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12568892017416093)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100001)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id de l''application'
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12569032130416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100001)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Couleur utilisateur'
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12569243328416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100001)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type de donn\00E9es')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12569457390416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100001)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12569691924416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100001)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12569890514416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Priorit\00E9')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12570041982416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100001)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horodatage'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12570263478416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100001)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type d''\00E9v\00E9nement')
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12570413311416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100001)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12570621690416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100001)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12570878983416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ech\00E9ance le')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12571023599416094)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100001)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom utilisateur'
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12571254498416095)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100001)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12571431405416095)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100001)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12571625020416095)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100001)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12571892220416095)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12572072825416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12572256838416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100001)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12572468506416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100001)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12572686398416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100001)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12572804680416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12573034531416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100001)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12573277772416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12573469575416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100001)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12573668744416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100001)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12573836717416096)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100001)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12574078978416097)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li>Un mod\00E8le: Import d''un seul mod\00E8le en fournissant tous les attributs</li>'),
unistr('    <li>Plusieurs mod\00E8les: Import de plusieurs mod\00E8les en utilisant un fichier zip*</li>'),
'</ul>',
'<p>',
'    * Le fichier zip doit contenir:',
'    <ul>',
unistr('        <li>Les fichiers bpmn \00E0 importer</li>'),
'        <li>Un fichier import.json qui est un tableau d''objets (voir exemple ci dessous) dont les attributs sont les suivants :',
'            <ul>',
unistr('                <li>dgrm_name: le nom du mod\00E8le</li>'),
unistr('                <li>dgrm_version: la version du mod\00E8le</li>'),
unistr('                <li>dgrm_category: la cat\00E9gorie du mod\00E8le</li>'),
'                <li>file: le nom du fichier bpmn dans l''archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
unistr('Exemple d''un fichier import.json contenant deux mod\00E8les<br>'),
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12574239873416097)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si vous cochez cette case, l''application enregistrera votre nom d''utilisateur dans un cookie de navigateur persistant nomm\00E9 "LOGIN_USERNAME_COOKIE".'),
'Lorsque vous vous rendrez sur la page de connexion la fois suivante,',
'le champ du nom d''utilisateur sera automatiquement rempli avec cette valeur.',
'</p>',
'<p>',
unistr('Si vous d\00E9s\00E9lectionnez cette case et que votre nom d''utilisateur est d\00E9j\00E0 enregistr\00E9 dans le cookie,'),
unistr('l''application l''\00E9crasera avec une valeur vide.'),
unistr('Vous pouvez \00E9galement utiliser les outils de d\00E9veloppement de votre navigateur pour supprimer compl\00E8tement le cookie.'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12574480467416097)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12574620739416098)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100001)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9v\00E9nements de l''instance')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12574877350416098)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100001)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux courant'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12575064710416098)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100001)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12575216241416098)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8les de formulaire simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12575417681416098)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100001)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historique des variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12575637321416098)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100001)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9v\00E9nements de l''instance')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12575851143416098)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100001)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rapport client ORDS'
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12576043982416098)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100001)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mod\00E8les appel\00E9s')
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12576283225416098)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abonnements aux messages'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12576453040416098)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100001)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9tapes termin\00E9es')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12576653058416098)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100001)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Attributs'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12576843340416098)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100001)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Diagramme appel\00E9')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12577041440416098)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100001)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gestion des mod\00E8les')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12577268835416098)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrammes appelants'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12577415037416098)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100001)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances de flux'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12577674934416098)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100001)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Sous-flux termin\00E9s')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12577854453416098)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100001)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9tapes courantes')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12578001142416099)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100001)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historique des variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12578231220416099)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100001)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variables'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12578428871416099)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Erreurs de l''\00E9tape')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12578679776416099)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100001)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12578866535416099)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100001)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le nombre maximal de lignes pour ce rapport est de #MAX_ROW_COUNT# lignes. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements dans votre requ\00EAte.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12579035085416100)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Le nombre maximum de lignes pour ce rapport est de #MAX_ROW_COUNT# lignes.  Appliquez un filtre pour r\00E9duire le nombre d''enregistrements dans votre requ\00EAte.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12579299366416100)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'L''historique des variables est vide.'
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12579486825416100)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L''historique des erreurs d''\00E9tape est vide.')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12579639405416100)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun sous-flux courant trouv\00E9.')
,p_translate_from_text=>'No current subflows found.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12579857387416100)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune expression de variable trouv\00E9e.')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12580082667416100)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun diagramme appelant trouv\00E9.')
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12580253977416100)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun sous-flux termin\00E9s trouv\00E9.')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12580451425416100)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L''historique des \00E9v\00E9nements de l''instance est vide.')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12580616780416100)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100001)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune donn\00E9e trouv\00E9e.')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12580884050416100)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun attribut trouv\00E9.')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12581029753416100)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucun diagramme appel\00E9 trouv\00E9.')
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12581244574416100)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100001)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'L''historique des variables est vide.'
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12581418453416101)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100001)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune donn\00E9e trouv\00E9e.')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12581613981416101)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune \00E9tape termin\00E9e trouv\00E9e.')
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12581832544416101)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aucune \00E9tape en cours trouv\00E9e.')
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12582088411416101)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12582256913416102)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12582412470416102)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12582628803416102)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12582882108416102)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12583052287416102)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12583240788416102)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12583440535416102)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12583605228416102)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12583894077416102)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12584063832416102)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12584264590416102)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12584475896416102)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12584647919416102)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12584823076416102)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12585089012416102)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12585270951416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12585453799416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12585600948416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12585836483416103)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100001)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12586032394416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100001)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12586252017416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12586456901416103)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12586647481416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12586821966416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100001)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12587077830416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12587203538416103)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12587496886416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12587659873416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100001)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12587839511416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100001)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12588086364416103)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12588292029416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12588489512416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12588630094416103)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12588870750416103)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12589010193416104)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12589224671416104)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12589454797416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12589631806416104)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12589891426416104)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12590005745416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100001)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12590220129416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12590431673416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12590656681416104)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12590879725416104)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12591075198416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100001)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12591229465416104)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100001)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12591447108416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12591683295416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12591804215416104)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12592098946416104)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12592251347416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100001)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12592484691416104)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12592636135416104)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12592824920416104)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12593095578416105)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100001)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12593205213416105)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12593447743416105)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12593618524416105)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12593874981416105)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12594079691416105)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100001)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12594285941416105)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12594414848416105)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12594649864416105)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12594833561416105)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100001)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12595039777416105)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12595293741416105)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100001)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12595446267416105)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12595605336416105)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12595829509416105)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12596066912416105)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12596242246416105)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12596453855416105)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12596671671416105)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12596878923416105)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12597064635416106)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12597218143416106)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12597435527416106)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12597610982416106)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12597883643416106)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12598060890416106)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12598217660416106)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100001)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12598436929416106)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12598600562416106)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100001)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12598896687416106)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12599025096416106)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12599295697416106)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12599425611416106)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12599697026416106)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100001)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12599825759416106)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100001)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12600037072416106)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100001)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12600215485416106)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12600441269416106)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12600610962416106)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12600866431416106)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100001)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12601048390416107)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12601216309416107)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12601408411416107)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12601646445416107)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12601851349416107)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12602098064416107)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12602242208416107)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12602453053416107)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12602647958416107)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12602882314416107)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12603065123416107)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12603207303416107)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12603418630416107)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12603630639416107)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12603853306416107)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12604011300416107)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12604236765416107)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12604455912416107)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12604618179416107)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12604801578416107)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12605070990416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12605268314416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12605408929416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12605612166416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12605803710416108)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12606018008416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100001)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12606280137416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12606465569416108)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12606603715416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100001)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12606875296416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12607062389416108)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12607270944416108)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12607423805416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100001)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12607681900416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12607831114416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12608037865416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12608239165416108)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100001)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12608447310416108)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12608661164416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12608893292416108)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12609019404416109)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12609206877416109)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100001)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12609470190416109)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12609627602416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12609806665416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100001)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12610091076416109)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12610218715416109)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100001)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12610426171416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12610643724416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12610858705416109)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12611062054416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12611249349416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12611493072416109)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12611659177416109)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100001)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12611839341416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12612022948416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12612272893416109)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12612441423416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12612634940416109)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12612820403416110)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12613009896416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100001)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12613272770416110)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12613443827416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12613645257416110)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12613857220416110)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12614004080416110)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12614239987416110)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12614476557416110)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12614600808416110)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12614848067416110)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100001)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12615006273416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12615258845416110)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12615490399416110)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12615660351416110)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12615835856416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12616015424416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100001)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12616237470416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12616418754416110)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12616696890416110)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12616897292416111)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100001)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12617048027416111)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12617295343416111)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100001)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12617425683416111)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12617693945416111)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12617894717416111)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12618029819416111)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12618237037416111)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12618442856416111)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12618600399416111)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100001)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12618865888416111)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12619054842416111)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12619279547416111)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12619467141416111)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12619649670416111)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12619812521416111)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12620065650416111)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100001)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12620282120416111)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12620465334416111)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12620678194416111)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12620842265416112)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100001)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12621077384416112)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12621258084416112)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12621417616416112)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100001)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12621629173416112)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12621894176416112)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100001)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12622090071416112)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100001)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12622249735416112)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12622497662416112)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12622673402416112)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12622889019416112)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12623034441416112)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100001)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12623272057416112)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12623446030416112)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12623693050416112)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12623872213416112)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12624001808416112)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12624245815416112)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100001)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12624481408416113)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12624622782416113)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12624885621416113)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12625097873416113)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12625286640416113)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12625495246416113)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12625665929416113)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12625833412416113)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12626065827416113)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12626214496416113)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12626405707416113)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12626683321416113)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100001)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12626816957416113)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12627007006416113)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100001)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12627239972416113)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12627482610416119)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Minuteur d\00E9marre \00E0')
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12627679587416119)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12627891414416119)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Port\00E9e actuelle')
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12628058663416120)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12628285677416120)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Attributs JSON'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12628432446416120)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12628611240416120)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Derni\00E8re mise \00E0 jour')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12628825675416120)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12629090272416120)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateur'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12629230275416120)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12629439048416120)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12629653394416120)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Date de cr\00E9ation')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12629877682416120)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9v\00E9nement')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12630022430416120)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('S\00E9lection de la version du diagramme appel\00E9')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12630244453416120)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12630485401416120)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12630641699416120)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateur'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12630829594416120)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Derni\00E8re mise \00E0 jour')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12631066449416120)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet d''origine'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12631229013416120)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100001)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Courriel d''assistance'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12631470566416120)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100001)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID du processus'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12631642671416120)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau actuel'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12631827452416120)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Version du mod\00E8le')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12632099921416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horodatage'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12632210468416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100001)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statut une fois termin\00E9')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12632403575416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valeur de cl\00E9')
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12632652590416121)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12632814221416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Couloir'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12633094719416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100001)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9serv\00E9 pour')
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12633216303416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100001)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12633492288416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nom de cl\00E9')
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12633624751416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12633826094416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12634022808416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12634260720416121)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A une ic\00F4ne de r\00E9cursivit\00E9')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12634420815416121)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12634627109416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12634890625416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Action rapide'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12635085207416121)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom de l''instance'
,p_translate_from_text=>'Instance Name'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12635291680416121)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12635412819416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100001)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12635687475416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9v\00E9nement')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12635825689416121)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ech\00E9ance le')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12636065946416122)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12636272585416122)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12636472807416122)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100001)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID du processus'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12636633536416122)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100001)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Action rapide'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12636873430416122)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9\00E9')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12637088812416122)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12637211534416122)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ex\00E9cution')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12637455978416122)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dernier termin\00E9')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12637652983416122)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100001)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12637896744416122)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12638077625416122)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12638257365416122)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Classe courante'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12638403887416122)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100001)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12638652438416122)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Port\00E9e')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12638866179416122)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statique'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12639005822416122)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12639210741416122)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Devenu courant'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12639401877416122)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100001)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12639617675416122)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12639886482416122)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12640069890416123)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ex\00E9cution')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12640261686416123)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100001)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12640481021416123)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12640660724416123)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100001)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID du processus'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12640827120416123)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12641079350416123)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100001)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12641244343416123)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12641477753416123)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9tape')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12641655758416123)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12641808136416123)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateurs exclus'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12642095783416123)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12642298458416123)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9servation')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12642480627416123)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramme d''appel'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12642646628416123)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12642853722416123)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Travail d\00E9marr\00E9')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12643080415416123)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variable de charge utile'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12643266641416123)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12643446864416123)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cat\00E9gorie')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12643627001416123)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100001)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flux analys\00E9')
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12643869804416123)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12644027129416124)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100001)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9servation')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12644283166416124)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12644410612416124)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau du processus'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12644628255416124)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Travail d\00E9marr\00E9')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12644875105416124)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12645034007416124)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100001)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12645203365416124)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100001)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12645489483416124)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100001)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12645699606416124)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID du processus'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12645841891416124)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12646008867416124)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateur'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12646280105416124)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100001)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dernier termin\00E9')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12646479931416124)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12646670532416124)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9servation')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12646818368416124)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horodatage'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12647018889416124)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Derni\00E8re mise \00E0 jour')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12647222034416124)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet appelant'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12647431272416124)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12647638271416124)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Derni\00E8re mise \00E0 jour')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12647826070416124)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12648043451416125)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12648202686416125)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12648445187416125)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12648662742416125)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateur'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12648883753416125)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Diagramme appel\00E9')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12649021157416125)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12649285301416125)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12649486256416125)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12649661397416125)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12649888108416125)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100001)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12650001065416125)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12650265939416125)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateur'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12650454151416125)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12650642909416125)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12650824963416125)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horodatage'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12651027924416125)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom du message'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12651219731416125)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dernier termin\00E9')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12651491285416125)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100001)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Courant'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12651688615416125)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau du processus'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12651828071416125)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12652026282416126)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100001)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet appelant'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12652252716416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12652494167416126)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12652626462416126)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet appelant'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12652889581416126)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100001)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Port\00E9e')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12653017512416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horodatage'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12653215429416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9v\00E9nement')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12653459778416126)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Priorit\00E9')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12653544431416126)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100001)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12653709472416126)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9servation')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12653969703416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pile d''erreur'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12654192021416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12654331097416126)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Derni\00E8re mise \00E0 jour')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12654552084416126)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100001)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12654728926416126)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12654902307416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ex\00E9cution')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12655104041416126)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100001)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cl\00E9 de l''\00E9tape')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12655393291416126)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12655548784416127)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100001)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cl\00E9 de l''\00E9tape')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12655719870416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12655901024416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12656136169416127)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Devenu courant'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12656351186416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type de donn\00E9es')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12656542164416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12656728310416127)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12656982528416127)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100001)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12657113923416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12657348651416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12657525597416127)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Version du diagramme appel\00E9')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12657779846416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12657976957416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dernier termin\00E9')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12658168875416127)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12658307365416127)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100001)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cl\00E9 de l''\00E9tape')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12658525609416127)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12658711751416127)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12658938506416127)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau du processus'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12659132554416127)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pile d''erreur'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12659349743416127)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9tape')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12659538646416128)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12659779310416128)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Travail d\00E9marr\00E9')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12659962941416128)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12660170535416128)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100001)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12660331666416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Classe courante'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12660516086416128)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramme d''appel'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12660711994416128)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Travail d\00E9marr\00E9')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12660922528416128)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type de donn\00E9es')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12661166495416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objet appelant'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12661380310416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100001)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pile d''erreur'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12661564892416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12661761665416128)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau du processus'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12661930212416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100001)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID message'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12662142389416128)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100001)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12662361619416128)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100001)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commentaire'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12662537131416128)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100001)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12662762356416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12662946229416128)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Niveau'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12663139481416128)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statut du mod\00E8le')
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12663322600416128)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cat\00E9gorie du mod\00E8le')
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12663504861416128)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100001)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12663790244416129)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12663937821416129)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100001)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Chemin d''it\00E9ration')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12664184878416129)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramme'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12664310163416129)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Type de donn\00E9es')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12664529505416129)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Courant'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12664761150416129)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horodatage'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12664951297416129)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12665155507416129)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID du diagramme appelant'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12665313637416129)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100001)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI de support'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12665513191416129)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12665783654416129)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valeur'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12665926732416129)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100001)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12666179151416129)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100001)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12666369807416129)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12666597275416129)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A une r\00E9cursivit\00E9')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12666728623416129)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100001)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID du sous-flux'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12666946077416129)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utilisateurs potentiels'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12667127957416129)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100001)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12667345680416129)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100001)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12667554168416129)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100001)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12667712156416130)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nom du mod\00E8le')
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12667917370416130)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12668107585416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type d''expression'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12668331291416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100001)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12668579538416130)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sous-flux'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12668739286416130)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12668908964416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12669102403416130)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Groupes potentiels'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12669304189416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramme'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12669552343416130)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100001)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID client'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12669730119416130)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12669922572416130)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12670140692416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12670336690416130)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9tape')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12670508374416130)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100001)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Devenu courant'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12670730113416130)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12670945448416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100001)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12671190020416130)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100001)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Devenu courant'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12671360206416130)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100001)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12671582625416131)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100001)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12671774206416131)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100001)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12671997895416131)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100001)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statut une fois termin\00E9')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12672129670416131)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Action rapide'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12672334120416131)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100001)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12672569988416131)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12672753995416137)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12672949361416137)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12673171697416137)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12673379686416137)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100001)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12673516776416137)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100001)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12673734282416137)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12673947063416137)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100001)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12674100565416137)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12674347305416137)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100001)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12674599121416138)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12674797802416138)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100001)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12674920135416138)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12675190211416138)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12675339260416138)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100001)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12675592310416138)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12675705214416138)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100001)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12675982142416138)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100001)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12676171124416138)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100001)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12676382258416138)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12676586591416138)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100001)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12676767832416138)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12676958357416138)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100001)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12677198766416139)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12677361373416139)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12677520592416139)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100001)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12677726756416139)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100001)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12677928345416140)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100001)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12678185060416140)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100001)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12678340304416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100001)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Visionneuse'
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12678554211416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100001)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - Mod\00E9lisateur')
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12678787318416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100001)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12678914619416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100001)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12679175673416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100001)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12679337472416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100001)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12679514948416142)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100001)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12679746173416143)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100001)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12679952415416143)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Privil\00E8ges insuffisants, l''utilisateur n''est pas un Administrateur')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12680170221416143)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horaire'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12680316682416143)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Horaire'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12680547758416143)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 an'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12680740077416143)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 an'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12680978907416143)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 an'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12681167623416143)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ann\00E9e I')
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12681375586416143)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 ans'
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12681550814416144)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 minutes'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12681799157416144)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 minutes'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12681941435416144)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mois'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12682134351416144)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mois'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12682368275416144)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mois'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12682582118416144)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mois'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12682705732416144)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4 ans'
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12682905902416144)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 minutes'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12683101847416144)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 minutes'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12683381963416144)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mois'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12683558065416144)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mois'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12683740500416145)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mois'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12683970992416145)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mois'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12684168847416145)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 ans'
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12684302337416145)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 minute'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12684532300416145)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 minute'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12684786674416145)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mois'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12684951615416145)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mois'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12685187277416145)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mois'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12685369496416145)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mois'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12685534354416145)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2 ans'
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12685721351416146)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 secondes (utilisation de production - pas pour apex.oracle.com)'
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12685936077416146)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 secondes (utilisation de production - pas pour apex.oracle.com)'
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12686136220416146)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 jours'
,p_translate_from_text=>'30 Days'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12686359163416146)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 jours'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12686521917416146)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 jours'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12686731022416146)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 an'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12686992343416146)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 jours'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12687159414416146)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 jours'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12687338258416146)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 jours'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12687522215416147)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12687708022416147)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12687937326416147)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12688176530416147)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12688366378416147)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12688527032416147)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100001)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12688754608416147)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12688960499416147)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100001)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12689115994416147)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12689366437416147)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12689525073416147)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12689779298416147)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12689911223416147)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100001)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12690140000416147)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12690367086416147)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12690519611416148)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12690755715416148)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12690940855416148)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12691185610416148)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100001)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12691320372416148)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100001)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12691559067416148)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12691767305416148)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100001)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12691936065416148)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12692133421416148)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100001)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12692341874416148)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100001)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12692503276416148)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12692705459416148)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100001)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12692976174416148)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100001)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12693146418416148)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12693356405416148)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100001)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12693514100416148)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100001)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12693729143416148)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12693981666416148)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100001)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12694153033416149)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100001)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12694359592416149)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12694539144416149)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12694722010416149)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12694976909416149)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12695114402416149)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12695373447416149)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12695541182416149)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12695714137416149)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100001)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12695904729416149)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100001)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12696130736416149)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12696385230416149)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12696597361416149)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12696776866416149)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12696955728416149)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12697149865416149)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12697304455416149)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100001)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12697526524416149)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12697708964416149)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100001)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12697959323416150)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12698190165416150)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100001)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12698397597416150)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12698568362416150)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12698769617416150)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100001)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12698900502416150)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100001)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12699127235416150)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100001)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12699346573416150)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12699516667416150)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12699755601416150)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12699970137416150)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100001)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12700111300416150)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12700348404416150)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100001)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12700512563416150)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12700791741416150)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12700925124416150)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12701188328416150)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12701303811416150)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12701571113416150)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12701784693416150)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12701960115416150)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12702117345416151)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12702336975416151)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100001)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12702537474416151)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12702772474416151)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12702950755416151)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12703199695416151)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100001)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12703348516416151)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12703549270416151)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12703719339416151)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100001)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12703950236416151)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12704187546416151)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12704304589416151)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100001)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12704584249416151)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12704711858416151)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12704937043416151)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12705156844416151)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12705367718416151)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12705564892416151)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12705751705416151)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12705902353416152)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12706147523416152)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12706324837416152)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12706575739416152)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12706759456416152)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12706966724416152)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12707135872416152)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12707338319416152)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12707503798416152)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100001)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12707705886416152)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100001)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12707923471416152)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12708165129416152)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12708369286416152)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100001)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12708576831416152)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100001)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12708763735416152)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12708927747416152)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12709166320416152)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12709343430416152)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12709540967416152)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12709759837416152)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12709906014416152)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12710123936416153)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12710347157416153)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12710522774416153)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100001)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12710789882416153)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100001)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12710925411416153)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100001)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12711166711416153)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100001)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12711347200416153)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12711518218416153)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12711742097416153)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12711919168416153)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100001)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12712185787416153)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12712356502416153)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12712577740416153)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100001)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12712769258416153)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12712983600416153)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12713142538416153)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100001)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12713353952416153)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12713595762416153)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12713787272416153)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100001)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12713994338416153)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12714133456416153)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12714315091416154)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12714597078416154)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100001)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12714731208416154)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100001)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12714989451416154)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12715105703416154)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100001)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12715338393416154)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12715596112416154)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12715753004416154)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100001)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12715986590416154)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12716168703416154)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12716313815416154)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12716574853416154)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100001)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12716735764416154)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12716977038416154)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12717105273416154)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12717331320416154)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12717510151416154)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12717749021416154)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12717984869416154)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12718124395416155)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12718342469416155)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12718590490416155)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12718776812416155)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12718919012416155)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100001)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12719184067416155)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12719312089416155)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12719528202416155)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12719734101416155)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12719962367416155)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100001)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12720197172416155)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12720340018416155)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12720562193416155)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12720778363416155)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12720952824416155)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100001)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12721178070416155)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12721346948416155)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12721579411416155)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12721700307416155)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12721947403416155)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100001)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12722127425416156)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100001)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12722395530416156)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12722535332416156)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100001)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12722707462416156)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12722939174416156)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100001)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12723154574416156)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12723312853416156)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12723578714416156)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12723717088416161)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12723909494416161)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12724135552416161)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12724337980416161)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12724531183416161)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12724732886416161)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100001)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12724944668416161)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12725192513416161)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12725366280416161)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12725531082416161)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12725726498416162)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12725969849416162)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12726181594416162)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12726375243416162)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12726572832416162)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12726796926416162)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12726981535416162)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12727159178416162)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12727390700416162)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100001)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12727571190416162)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100001)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12727738580416162)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12727948708416162)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12728166688416162)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12728396561416162)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100001)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12728501326416162)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12728726593416162)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12728997272416162)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12729154665416162)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12729377568416162)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12729507700416163)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12729733581416163)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100001)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12729997510416163)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12730189306416163)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12730361218416163)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12730530917416163)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12730718048416163)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12730915041416163)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12731182023416163)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12731365430416163)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12731516865416163)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12731742942416163)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12731928147416163)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12732155711416163)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12732331974416163)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12732584274416163)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100001)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12732707373416163)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12732928433416163)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12733174864416163)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12733353364416163)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12733555181416163)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12733705164416164)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12733954320416164)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12734178875416164)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12734395036416164)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12734532242416164)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12734765660416164)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12734982739416164)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12735181606416164)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12735336145416164)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100001)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12735549319416164)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12735750599416164)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12735989235416164)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12736174476416164)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12736310614416164)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12736598986416164)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12736714943416164)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12736923773416164)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100001)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12737196223416164)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12737339458416164)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12737519241416165)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100001)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12737754080416165)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100001)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12737910497416165)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12738152956416165)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12738334042416165)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100001)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12738587106416165)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100001)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12738714488416165)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12738949804416165)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12739155588416165)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12739339818416165)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12739525987416165)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12739722269416165)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12739903757416165)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12740146993416165)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12740307584416165)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12740599324416165)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12740707992416165)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12740982835416165)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12741169102416166)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100001)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12741367836416166)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12741559554416166)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100001)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12741724055416166)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12741976538416166)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12742124251416166)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12742346524416166)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12742527967416166)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12742744420416166)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100001)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12742972893416166)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12743164906416166)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12743324586416166)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12743507547416169)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12743737971416169)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12743955281416169)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12744183444416169)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12744349215416169)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12744528236416169)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100001)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12744727771416169)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12744963605416169)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12745134904416169)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12745348440416169)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12745505470416169)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100001)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12745758567416169)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12745939434416169)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12746160200416169)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12746384940416169)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12746535884416169)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12746766178416169)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12746980117416170)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12747199178416170)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12747366849416170)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12747582795416170)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12747711636416170)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12747966618416170)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12748105037416170)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12748351913416170)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12748592116416170)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12748769716416171)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12748991561416171)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12749194744416171)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12749308811416171)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100001)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12749502095416171)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12749737542416171)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12749946805416171)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12750196496416171)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12750392027416171)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12750536766416171)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12750752079416171)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12750993589416171)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12751167184416171)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12751310747416171)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12751554739416171)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12751782072416171)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100001)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12751981595416171)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12752165673416172)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12752360547416172)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12752559907416172)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12752745162416172)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12752926779416172)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12753187455416172)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12753349959416172)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100001)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12753536207416172)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12753782910416172)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12753910521416172)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12754134025416172)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12754340507416172)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12754551236416172)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12754797141416172)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12754942296416172)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12755105092416172)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12755363288416172)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12755585572416172)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100001)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12755728742416172)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12755910143416172)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12756157696416172)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12756316928416173)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12756524810416173)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12756752430416173)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12756993688416173)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12757179038416173)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12757371709416173)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12757562895416173)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12757715365416173)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12757960942416173)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12758182995416173)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12758381715416173)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12758563849416173)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12758701282416173)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12758906163416173)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12759165280416173)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100001)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12759374028416173)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12759554338416173)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12759722358416173)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12759915273416173)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12760167799416173)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12760394957416174)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12760594581416174)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12760742275416174)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12760998893416174)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12761166323416174)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12761325359416174)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12761538801416174)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12761702544416174)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12761944414416174)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100001)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12762124573416174)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12762302104416174)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100001)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12762512120416174)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12762780465416174)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12762907430416174)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12763109917416174)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12763347265416174)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100001)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12763592679416174)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12763775512416174)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12763996370416174)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12764110717416176)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100001)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12764389865416176)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12764548375416176)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12764747372416177)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12764940854416177)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12765127927416177)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12765395792416177)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12765561264416177)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12765733278416177)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100001)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12765931401416177)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100001)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12766162952416177)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12766332946416177)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12766522357416177)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100001)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12766766677416177)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100001)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12766965014416177)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12767109092416177)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12767386524416177)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12767507905416177)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12767710974416177)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12767907003416177)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12768166974416177)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12768390955416177)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12768585582416178)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12768768075416178)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12768994705416178)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12769198107416178)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12769346196416178)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12769569852416178)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12769793511416178)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12769922568416178)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100001)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12770132925416178)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100001)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12770340392416178)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100001)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12770597359416178)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12770750718416178)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12770951905416178)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12771146804416178)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12771311918416178)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12771540628416178)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12771774403416178)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100001)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12771951298416179)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100001)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12772156052416179)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12772306607416179)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12772502006416179)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12772739180416179)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100001)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12772909370416179)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100001)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12773152232416179)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100001)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12773345625416179)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12773598567416179)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100001)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12773756164416179)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12773966381416179)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12774161792416179)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100001)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12774338267416179)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100001)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12774573387416179)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12774711212416179)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100001)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12774995232416179)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12775193352416179)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100001)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12775345653416179)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100001)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12775510897416179)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12775785895416179)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100001)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12775962522416180)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12776128397416180)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100001)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12776389401416180)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100001)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12776520875416180)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100001)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12776773932416180)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100001)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12776936792416180)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100001)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12777181629416180)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100001)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12777335916416180)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100001)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12777578734416180)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12777743792416182)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12777913546416182)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100001)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12778154274416182)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12778336281416182)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12778554506416182)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100001)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12778749913416182)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12778934112416182)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100001)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12779105108416182)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12779361998416182)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100001)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12779567406416182)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100001)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12779724028416183)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12779927175416183)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12780174700416183)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100001)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12780318331416183)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100001)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12780545461416183)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100001)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12780750527416183)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12780981734416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100001)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12781135872416184)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100001)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12781374004416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100001)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12781556913416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100001)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12781769799416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12781961190416184)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100001)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12782150737416184)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12782389566416184)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12782520407416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100001)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12782795049416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12782919117416184)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12783157027416184)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12783342449416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100001)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12783510809416184)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100001)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12783795746416184)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100001)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12783947820416184)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12784171550416184)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12784362968416185)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100001)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12784576305416185)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12784774689416185)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100001)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12784933484416185)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12785168733416185)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12785338165416185)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12785502388416185)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100001)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12785770877416185)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12785916949416185)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12786115990416185)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12786345762416185)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100001)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12786506452416185)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100001)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12786702967416185)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12786942558416185)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12787166117416185)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100001)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12787309219416185)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100001)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12787578925416185)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100001)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12787728932416185)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100001)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12787903182416186)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100001)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12788191890416186)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100001)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12788383763416186)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12788592599416186)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100001)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12788730002416186)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100001)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12788984634416186)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12789123727416186)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100001)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12789386543416186)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100001)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12789518747416186)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12789794106416186)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100001)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12789948459416186)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100001)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12790115731416186)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12790332491416186)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100001)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12790599497416186)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100001)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12790715806416186)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100001)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12790933932416186)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12791168154416186)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100001)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12791342561416186)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12791519438416186)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12791735246416186)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12791968535416187)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100001)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12792170505416187)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100001)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12792383101416187)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12792578916416187)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12792743604416187)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100001)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12792947836416187)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100001)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12793127938416187)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12793390285416187)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100001)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12793589898416187)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12793756626416187)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12793911118416187)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100001)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12794141387416187)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12794327289416187)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100001)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12794575361416187)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12794720757416187)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100001)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12794929487416187)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100001)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12795132820416187)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12795397703416187)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100001)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12795557248416187)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100001)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12795774078416187)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100001)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12795980714416189)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12796106092416189)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12796359837416190)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12796517239416190)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12796723109416190)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100001)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12796973113416190)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100001)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12797155592416190)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100001)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12797347249416190)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12797538676416190)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100001)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12797766449416190)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12797999559416190)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12798102839416190)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12798308823416190)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100001)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12798506446416190)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100001)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12798727456416191)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100001)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12798991673416191)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100001)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12799198788416191)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100001)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12799337103416191)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12799552691416191)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12799750959416191)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12799919809416191)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100001)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12800160954416191)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12800371640416191)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12800556413416191)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100001)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12800725879416191)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12800915619416191)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100001)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12801182781416192)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12801332046416192)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12801551913416192)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100001)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12801796220416192)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12801903912416192)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12802163233416192)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12802306674416192)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100001)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12802545384416192)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12802703623416192)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100001)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12802998502416192)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100001)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12803136930416192)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100001)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12803362805416193)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12803566024416193)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12803715835416193)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12803970394416193)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12804143899416193)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100001)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12804347471416193)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12804588198416193)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12804751634416193)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100001)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12804998773416193)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12805134992416193)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100001)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12805336713416193)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100001)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12805566356416193)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100001)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12805797138416193)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12805932848416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12806140555416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100001)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12806316510416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100001)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12806510108416194)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12806745295416194)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12806964227416194)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12807153271416194)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100001)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12807339407416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12807526881416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12807744852416194)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100001)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12807906712416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12808168674416194)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100001)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12808308578416195)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100001)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12808554810416195)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100001)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12808721639416195)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12808938955416195)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12809186206416195)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100001)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12809354844416195)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100001)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12809555439416195)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100001)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12809709787416195)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100001)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12809912070416195)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100001)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12810112522416195)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12810346491416195)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12810596277416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12810744895416196)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12810934034416196)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100001)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12811130065416196)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100001)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12811342024416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12811578861416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100001)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12811739314416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100001)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12811948238416196)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100001)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12812117454416196)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12812314056416196)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100001)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12812599414416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12812756421416196)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100001)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12812937828416196)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100001)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12813193741416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100001)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12813352207416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100001)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12813546136416196)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100001)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12813728103416196)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100001)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12813912715416196)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12814111248416196)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100001)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12814388096416197)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12814526204416197)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100001)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12814708281416197)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100001)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12814988010416197)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100001)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12815146576416197)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100001)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12815302746416197)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100001)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12815552556416198)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12815787454416198)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12815936655416198)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100001)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12816108621416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12816370708416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12816569813416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12816763286416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12816916589416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12817125474416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12817372190416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12817581641416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100001)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12817773868416198)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12817960875416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12818149022416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12818315879416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12818544846416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100001)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12818764342416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12818966373416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12819133718416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12819372223416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12819519788416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12819795542416199)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12819963781416200)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12820177073416200)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100001)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12820327779416200)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12820554250416200)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100001)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12820772269416200)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100001)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12820913023416200)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100001)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12821159690416200)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100001)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12821382097416200)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12821599724416200)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100001)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12821701584416200)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12821940370416200)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12822163594416200)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100001)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12822313892416200)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100001)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12822543424416201)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100001)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12822700234416201)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100001)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12822916655416201)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12823127727416201)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12823328694416201)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100001)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12823545940416201)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100001)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12823754199416201)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100001)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12823921079416201)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100001)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12824166813416201)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12824391313416201)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100001)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12824545794416201)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100001)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12824703411416201)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100001)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12824945680416201)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12825103833416201)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12825351077416201)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12825537232416201)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100001)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12825774990416201)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100001)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12825932753416202)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12826138607416202)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100001)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12826334905416202)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100001)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12826573611416202)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12826775976416202)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12826936183416202)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12827110056416202)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12827348312416202)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12827576950416202)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12827748048416202)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100001)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12827923179416202)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100001)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12828137925416202)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12828364779416202)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100001)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12828581459416202)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12828799360416202)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100001)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12828950025416202)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100001)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12829198000416202)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12829355409416202)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100001)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12829583922416202)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100001)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12829713615416202)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100001)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12829928526416203)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12830172518416203)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12830376962416203)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12830523597416203)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100001)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12830793877416203)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100001)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12830962831416203)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12831136811416203)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12831317038416203)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12831574343416203)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12831748931416203)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12831901222416203)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12832157325416203)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12832352631416203)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12832505192416203)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12832757997416203)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100001)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12832932857416203)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100001)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12833126995416205)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100001)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12833301790416205)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100001)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12833581281416205)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100001)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12833757683416205)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100001)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12833993455416205)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100001)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12834182683416205)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12834393221416205)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100001)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12834512795416205)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100001)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12834736767416205)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100001)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12834955763416206)
,p_page_id=>5
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100001)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12835170401416206)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100001)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12835373705416206)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100001)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12835521251416206)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12835795351416206)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12835914290416206)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100001)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12836196863416206)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100001)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12836381605416206)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100001)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12836504298416206)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100001)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12836795733416206)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12836941961416206)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100001)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12837188435416206)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100001)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12837315037416206)
,p_page_id=>37
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100001)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12837508989416206)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12837791765416206)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12837961995416206)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12838164948416206)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100001)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12838368278416206)
,p_page_id=>33
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100001)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12838588169416206)
,p_page_id=>11
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12838794462416206)
,p_page_id=>39
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100001)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12838952579416206)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100001)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12839117783416206)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100001)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12839329581416207)
,p_page_id=>50
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100001)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12839537818416207)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100001)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12839753307416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100001)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12839906051416207)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100001)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12840168981416207)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12840385678416207)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100001)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12840545803416207)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100001)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12840767038416207)
,p_page_id=>4
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100001)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12840950783416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100001)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12841122847416207)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12841359982416207)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100001)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12841583750416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100001)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12841791101416207)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12841993366416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100001)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12842144483416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100001)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12842339089416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100001)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12842596669416207)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100001)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12842749993416207)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100001)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12842911522416207)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12843106405416208)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100001)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12843367343416208)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100001)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12843583462416208)
,p_page_id=>13
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100001)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12843782378416208)
,p_page_id=>38
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12843902286416208)
,p_page_id=>1
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100001)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12844145035416208)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100001)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12844312706416208)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12844543515416208)
,p_page_id=>14
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100001)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12844773531416208)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100001)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12844937498416208)
,p_page_id=>30
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100001)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12845196581416208)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100001)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12845335088416208)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100001)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12845501997416210)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12845728512416210)
,p_page_id=>51
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100001)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12845919974416210)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12846173456416210)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12846368447416210)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12846515828416210)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12846726806416210)
,p_page_id=>31
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100001)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12846919219416210)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12847127259416210)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12847301046416210)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12847546174416211)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12847793507416211)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12847967403416211)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12848122594416211)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12848308846416211)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12848513922416211)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12848748546416211)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12848911116416211)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12849135438416211)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12849358239416212)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12849573391416212)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12849790189416212)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12849923303416212)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12850191880416212)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12850388913416212)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12850549024416212)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12850705395416212)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12850930481416212)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12851198971416212)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12851339986416213)
,p_page_id=>6
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100001)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12851514569416213)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12851784001416213)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12851984375416213)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12852168187416214)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12852393638416214)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12852522261416214)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12852759868416214)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12852959983416214)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12853167081416214)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12853312976416214)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12853504493416214)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12853731492416214)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12853911516416215)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12854155918416215)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12854368420416215)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12854531737416215)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12854741626416215)
,p_page_id=>20
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100001)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12854933302416215)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12855106303416215)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12855337396416215)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12855566104416215)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12855783204416215)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12855951034416216)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100001)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12856102296416216)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100001)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12856391140416216)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100001)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12856509141416216)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100001)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12856794321416216)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100001)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12856996813416216)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100001)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12857124285416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100001)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12857361465416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100001)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12857543731416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100001)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12857780011416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100001)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edition, informations de licence'
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12857934564416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100001)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12858136747416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100001)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12858307492416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100001)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12858534862416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100001)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12858780543416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12858955408416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100001)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12859184437416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100001)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12859338781416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100001)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12859503690416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100001)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12859734667416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100001)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12859955718416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100001)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12860166217416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100001)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12860391770416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100001)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12860512372416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100001)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12860728158416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100001)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12860972180416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100001)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12861127739416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100001)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12861313581416217)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100001)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12861591520416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100001)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12861700170416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100001)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12861985046416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100001)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12862144770416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100001)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12862334649416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100001)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12862568804416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100001)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12862719317416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12862931261416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100001)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12863100775416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100001)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12863311828416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12863564187416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100001)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12863725507416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12863954182416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100001)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12864108417416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100001)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12864385371416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100001)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12864584335416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100001)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12864703020416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100001)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12864970920416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100001)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12865109370416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100001)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12865347345416218)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100001)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12865576784416219)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100001)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12865779086416219)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100001)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12865999980416220)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12866111505416221)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom d''utilisateur'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12866303867416221)
,p_page_id=>9999
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100001)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mot de passe'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12866584340416221)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12866720285416221)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12866997333416221)
,p_page_id=>12
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100001)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12867121793416221)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100001)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12867339370416223)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - ne capture pas les informations utilisateur sur l''\00E9tape	</li>'),
unistr('    <li><strong>disabled</strong> (valeur par d\00E9faut) - capture l''ID utilisateur de l''\00E9tape de processus tel que connu du moteur de flux	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12867523563416223)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Doit \00EAtre d\00E9fini sur votre exp\00E9diteur de courriel par d\00E9faut, si aucun exp\00E9diteur n''est d\00E9fini pour le courriel sortant serviceTasks.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12867786013416223)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nom utilisateur \00E0 utiliser dans la session APEX pour cr\00E9er une session si aucun autre nom utilisateur n''est fourni')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12867960580416223)
,p_page_id=>7
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100001)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Supprimer les instances de processus associ\00E9es')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12868138837416223)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100001)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Si vous laissez ce champ vide, la t\00E2che sera r\00E9serv\00E9 pour l''utilisateur courant (app_user).')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12868321232416223)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pour les temporisateurs de cycle, cela d\00E9finit le nombre maximal d''ex\00E9cutions.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12868545458416223)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100001)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Format requis : AAAA-MM-JJ HH24 :MI:SS TZR'
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12868766122416223)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Utilisez cette option uniquement pour prendre en charge les applications qui ont \00E9t\00E9 d\00E9velopp\00E9es avec Flows for APEX 21.1 et inf\00E9rieures sans d\00E9veloppement suppl\00E9mentaire. Le moteur n''utilise pas la cl\00E9 d''\00E9tape pour ')
||unistr('emp\00EAcher les actions en double sur une seule \00E9tape.</li>'),
unistr('    <li><strong>strict</strong> (recommand\00E9) : utilisez cette option pour le nouveau d\00E9veloppement et/ou l''application enti\00E8rement migr\00E9e. Le moteur utilise la cl\00E9 d''\00E9tape pour \00E9viter les actions en double en une seule \00E9tape.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12868979894416223)
,p_page_id=>2
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100001)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('En cas de copie d''un seul mod\00E8le, le nouveau mod\00E8le portera le nom saisi, mais si vous avez s\00E9lectionn\00E9 plus d''une ligne, la valeur saisie sera utilis\00E9e comme suffixe.')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12869142017416223)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Langue utilis\00E9e pour afficher les messages d''erreur et les \00E9v\00E9nements de journal.')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12869301684416223)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Utilisez cette option uniquement pour prendre en charge les applications qui ont \00E9t\00E9 d\00E9velopp\00E9es avec Flows for APEX 21.1 et inf\00E9rieures sans d\00E9veloppement suppl\00E9mentaire. Le moteur n''utilise pas la cl\00E9 d''\00E9tape pour ')
||unistr('emp\00EAcher les actions en double sur une seule \00E9tape.</li>'),
unistr('    <li><strong>strict</strong> (recommand\00E9) : utilisez cette option pour le nouveau d\00E9veloppement et/ou l''application enti\00E8rement migr\00E9e. Le moteur utilise la cl\00E9 d''\00E9tape pour \00E9viter les actions en double en une seule \00E9tape.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12869506242416223)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100001)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - la journalisation est d\00E9sactiv\00E9e	</li>'),
unistr('    <li><strong>standard</strong> (valeur par d\00E9faut) - consigne les \00E9v\00E9nements d''instance</li>'),
unistr('    <li><strong>secure</strong> - consigne les \00E9v\00E9nements de mod\00E8le et d''instance	</li>'),
unistr('    <li><strong>full</strong> - Journaux des \00E9v\00E9nements de mod\00E8le, d''instance et de variable de processus		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12869786853416223)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID d''application de l''une de vos applications APEX qui sera fourni pour cr\00E9er une session')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12869960363416223)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de page de l''une de vos applications qui sera fourni pour cr\00E9er une session')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12870114231416223)
,p_page_id=>36
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100001)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pour les temporisateurs de cycle, cela d\00E9finit le nombre maximal d''ex\00E9cutions.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12870363036416223)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Doit \00EAtre d\00E9fini sur votre espace de travail APEX par d\00E9faut utilis\00E9 pour les flux Flows for APEX. Elle est utilis\00E9e comme dernier tri pour scriptTasks et serviceTasks lors de la cr\00E9ation d''une session APEX ou de la recherche de mod\00E8les de courrier.')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12870516566416223)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - ne capture pas les informations utilisateur sur l''\00E9tape	</li>'),
unistr('    <li><strong>disabled</strong> (valeur par d\00E9faut) - capture l''ID utilisateur de l''\00E9tape de processus tel que connu du moteur de flux	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12870787852416224)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('nom utilisateur \00E0 utiliser dans la session APEX pour cr\00E9er une session si aucun autre nom utilisateur n''est fourni')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12870918176416224)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100001)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (valeur par d\00E9faut) - emp\00EAche la modification du diagramme pour les mod\00E8les publi\00E9s</li>'),
unistr('    <li><strong>development/strong> - permet de modifier le diagramme pour les mod\00E8les publi\00E9s</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12871107195416224)
,p_page_id=>32
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100001)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Langue utilis\00E9e pour afficher les messages d''erreur et les \00E9v\00E9nements de journal.')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12871348337416224)
,p_page_id=>34
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100001)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (valeur par d\00E9faut) - emp\00EAche la modification du diagramme pour les mod\00E8les publi\00E9s</li>'),
unistr('    <li><strong>development</strong> - permet de modifier le diagramme pour les mod\00E8les publi\00E9s</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12871526784416224)
,p_page_id=>35
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100001)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Doit \00EAtre d\00E9fini sur votre espace de travail APEX par d\00E9faut utilis\00E9 pour les flux Flows for APEX. Elle est utilis\00E9e en tant que dernier tri pour scriptTasks et serviceTasks lors de la cr\00E9ation d''une session APEX ou de la recherche de mod\00E8les de cour')
||'rier.'
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12871718635416224)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('l''ID d''application de l''une de vos applications APEX qui sera fourni pour cr\00E9er une session')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12871995252416224)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100001)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - la journalisation est d\00E9sactiv\00E9e	</li>'),
unistr('    <li><strong>standard</strong> (valeur par d\00E9faut) - consigne les \00E9v\00E9nements d''instance</li>'),
unistr('    <li><strong>secure</strong> - consigne les \00E9v\00E9nements de mod\00E8le et d''instance	</li>'),
unistr('    <li><strong>full</strong> - Journaux des \00E9v\00E9nements de mod\00E8le, d''instance et de variable de processus		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12872199581416224)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100001)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('l''ID de page de l''une de vos applications qui sera fourni pour cr\00E9er une session')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12872386560416224)
,p_page_id=>100
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100001)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Doit \00EAtre d\00E9fini sur votre exp\00E9diteur de courriel par d\00E9faut, si aucun exp\00E9diteur n''est d\00E9fini pour le courriel sortant serviceTasks.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12872586111416225)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100001)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12872793843416225)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12872967298416225)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'seconde'
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12873164072416225)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100001)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12873332620416225)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erreurs d''instances'
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12873571350416225)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erreur'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12873757713416225)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Max.'
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12873976816416225)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100001)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'En attente - Maximum'
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12874154847416225)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erreurs'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12874352525416225)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Instances d\00E9marr\00E9es')
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12874580183416225)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-90pc'
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12874794276416226)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-10pc'
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12874903221416226)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100001)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12875182435416226)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Instances termin\00E9es')
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12875339430416226)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dur\00E9e 90pc')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12875529272416226)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100001)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 centile'
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12875712030416226)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'50 centile'
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12875900352416226)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100001)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12876131425416226)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100001)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('S\00E9rie 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12876322634416226)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100001)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cr\00E9\00E9')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12876541185416226)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100001)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12876706907416226)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12876981574416226)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100001)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00E9marr\00E9')
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12877177730416226)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100001)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('S\00E9rie 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12877321618416226)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'90 centile'
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12877558003416226)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-50pc'
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12877776749416226)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100001)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'En cours'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12877950341416226)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100001)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12878112591416226)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Termin\00E9')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12878370914416227)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Termin\00E9')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12878548701416227)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Instances termin\00E9es')
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12878715984416227)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12878975633416227)
,p_page_id=>16
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100001)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dur\00E9e m\00E9diane')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12879188229416227)
,p_page_id=>3
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100001)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12879383829416227)
,p_page_id=>15
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100001)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('R\00E9initialiser')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12879549486416227)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100001)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12879738821416227)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12879987805416227)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100001)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dur\00E9e-Max')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12880189480416227)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'En attente - Maximum'
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12880380495416227)
,p_page_id=>17
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100001)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12880599215416228)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100001)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12880719361416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100001)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12880981076416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100001)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cat\00E9gorie')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12881148365416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100001)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12881315757416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100001)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statut'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12881512592416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100001)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nom'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12881752036416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100001)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cat\00E9gorie')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12881941976416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100001)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12882131735416229)
,p_translated_flow_id=>100001
,p_translate_to_id=>100.100001
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12882331433416230)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100001)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Erreur du traitement d''archivage de la synth\00E8se des instances quotidiennes')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12882586747416230)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100001)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Erreur lors de la purge des r\00E9capitulatifs des statistiques Flows for APEX')
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12882764895416230)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100001)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Erreur lors de la purge des tables de journalisation.'
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12882982531416230)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100001)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erreur lors de la collecte des Flows for APEX'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12883159124416231)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12883379782416231)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12883509405416231)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100001)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12883721467416233)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>6.100004
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importieren'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12883936872416233)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>50.100004
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlagen'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12884167114416233)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>14.100004
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logs'
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12884348827416233)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>51.100004
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlage bearbeiten'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12884500178416233)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>1.100004
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erste Schritte'
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12884752168416233)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>7.100004
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow'
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12884968857416233)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>15.100004
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E4gliche Statistiken')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12885140680416233)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>31.100004
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12885359045416233)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>36.100004
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Timer'
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12885557614416233)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>34.100004
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Engine-Anwendung'
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12885781531416233)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>11.100004
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Instanz erstellen'
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12885913023416233)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>30.100004
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - REST'
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12886107560416233)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>2.100004
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Management'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12886355881416233)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>8.100004
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Instanz Details'
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12886583031416233)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>12.100004
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Viewer'
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12886722261416233)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>17.100004
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgabenstatistik'
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12886916622416234)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>37.100004
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Statistiken'
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12887101491416234)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>4.100004
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Modellierer'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12887357618416234)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>5.100004
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportieren'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12887532538416234)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>10.100004
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Monitor'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12887728979416234)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>35.100004
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Engine'
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12887941110416234)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>33.100004
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Archivierung'
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12888123783416234)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>3.100004
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dashboard'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12888345194416234)
,p_page_id=>9
,p_translated_flow_id=>100004
,p_translate_to_id=>9.100004
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12888518371416234)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>20.100004
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzzeitleiste - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12888702804416234)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>38.100004
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Ziel'
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12888957431416234)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>13.100004
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objektdetails'
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12889144573416234)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>39.100004
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Lizenz'
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12889343123416234)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>16.100004
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessstatistiken'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12889527585416234)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>32.100004
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Logging'
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12889748229416234)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>100.100004
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration [OLD,BACKUP]'
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12889960695416234)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>9999.100004
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anmeldeseite'
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12890152836416235)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>6.100004
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importieren - &APP_NAME_TITLE.'
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12890373980416235)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>50.100004
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlagen'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12890518234416236)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>51.100004
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlage bearbeiten'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12890713896416236)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>1.100004
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erste Schritte - &APP_NAME_TITLE.'
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12890960348416236)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>7.100004
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow- &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12891128978416236)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>15.100004
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E4gliche Statistiken')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12891327075416236)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>31.100004
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12891599383416236)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>36.100004
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Timer'
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12891704421416236)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>34.100004
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Engine-Anwendung'
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12891954726416236)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>11.100004
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Instanz erstellen - &APP_NAME_TITLE.'
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12892198655416236)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>30.100004
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - REST'
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12892396785416236)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>2.100004
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Management - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12892559933416236)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>8.100004
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Instanz-Details  - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12892797525416236)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>12.100004
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Monitor - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12892940310416236)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>17.100004
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgabenstatistik'
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12893156310416236)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>37.100004
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Statistiken'
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12893360990416236)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>4.100004
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Modellierer - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12893508898416236)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>5.100004
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportieren - &APP_NAME_TITLE.'
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12893717862416236)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>10.100004
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Monitor - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12893944431416236)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>35.100004
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Engine'
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12894131717416236)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>33.100004
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Archivierung'
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12894366733416236)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>3.100004
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dashboard - &APP_NAME_TITLE.'
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12894598947416237)
,p_page_id=>9
,p_translated_flow_id=>100004
,p_translate_to_id=>9.100004
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12894713345416237)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>20.100004
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzzeitleiste - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12894911347416237)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>38.100004
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Standort'
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12895125789416237)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>39.100004
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Lizenz'
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12895398638416237)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>16.100004
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessstatistiken'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12895534571416237)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>32.100004
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Logging'
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12895725986416237)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>100.100004
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration [OLD,BACKUP]'
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12895998749416237)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>9999.100004
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12896194514416238)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100004)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Alle ausw\00E4hlen')
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12896365475416238)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100004)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gateway-Pfad setzen'
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12896548096416238)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100004)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12896764425416238)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100004)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12896978376416238)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12897168078416238)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100004)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Alle abw\00E4hlen')
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12897314844416238)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Hinzuf\00FCgen')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12897514264416239)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100004)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessvariable setzen'
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12897727705416239)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100004)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12897940296416239)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100004)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST-Konfiguration'
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12898118717416239)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12898386065416239)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100004)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importieren und editieren'
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12898559938416239)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100004)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellen'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12898761540416239)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100004)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12898911877416239)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neue Version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12899125809416239)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100004)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12899357186416239)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12899521686416239)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nachricht empfangen'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12899700126416239)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100004)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellen'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12899994472416239)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100004)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12900122119416239)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellen'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12900397639416239)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100004)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12900506479416239)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100004)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12900743032416239)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100004)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell erstellen'
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12900954932416239)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100004)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12901139858416239)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100004)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Speichern'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12901362751416239)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100004)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12901580604416240)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100004)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importieren und weiteres importieren'
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12901706685416240)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100004)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12901933693416240)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell kopieren'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12902111874416240)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100004)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12902354885416240)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100004)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12902527321416240)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anmelden'
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12902790381416240)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100004)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12902951637416240)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100004)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST-Konfiguration'
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12903168657416240)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Release'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12903335957416240)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vorlage erstellen'
,p_translate_from_text=>'Create Template'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12903554575416240)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100004)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Diagramm \00E4ndern')
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12903751150416240)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100004)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12903952039416240)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100004)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Version hinzuf\00FCgen')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12904121416416240)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importieren'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12904340590416240)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12904582711416240)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100004)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12904751662416240)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archiv'
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12904970839416240)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12905153790416240)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100004)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12905347660416240)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100004)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12905559308416240)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100004)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12905731498416240)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportieren'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12905933939416241)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100004)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historie anzeigen'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12906133195416241)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100004)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12906388017416241)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanz erstellen'
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12906503334416241)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100004)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12906792053416241)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100004)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12906926207416241)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100004)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12907133812416241)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100004)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12907305598416241)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100004)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12907596440416241)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Veraltet'
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12907745860416241)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservieren'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12907913703416241)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100004)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Version hinzuf\00FCgen')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12908107871416241)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100004)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellen'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12908395100416241)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration bearbeiten'
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12908557191416241)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100004)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12908748191416241)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen anwenden')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12908914193416241)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Timer neu-ausl\00F6sen')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12909162460416241)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12909395037416241)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100004)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12909565488416242)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100004)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Best\00E4tigen')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12909706541416242)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100004)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration bearbeiten'
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12909939966416242)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100004)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Hinzuf\00FCgen')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12910176816416242)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100004)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellen'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12910385660416242)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100004)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abbrechen'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12910585299416242)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Best\00E4tigen')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12910799867416242)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100004)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12910954162416242)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100004)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12911155741416242)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100004)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Speichern'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12911349743416244)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100004)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12911538252416245)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer-ID ausblenden'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12911735389416245)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID-Spalte'
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12911908657416245)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lizenzschl\00FCssel')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12912173226416245)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel-Spalte'
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12912366991416245)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Basis-URL'
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12912525509416245)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100004)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neue Version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12912712748416245)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload'
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12912935126416245)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100004)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Verbindung'
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12913114469416245)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standard E-Mail-Absender'
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12913393835416245)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12913518110416245)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12913720496416245)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12913993005416245)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standardbenutzername'
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12914120035416245)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sub-Prozess'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12914346055416245)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12914596764416246)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer-Wiederholungsintervall'
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12914783291416246)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dateiname'
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12914962687416246)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schritt'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12915127169416246)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bucket-Name'
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12915345285416246)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100004)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lizenzedition'
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12915531088416246)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100004)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importiere von'
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12915717733416246)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vorgang'
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12915918261416246)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12916154796416246)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12916312799416246)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dokumentpr\00E4fix')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12916584409416246)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datum'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12916710307416246)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neu'
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12916998019416246)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100004)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DCberschreiben erzwingen')
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12917123256416246)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservierung'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12917365232416246)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer - Max. Zyklen'
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12917569972416246)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kategorie'
,p_translate_from_text=>'Category'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12917796564416246)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12917961237416246)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ausgef\00FChrt von')
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12918190199416246)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tabellenname'
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12918364391416247)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Letztes \00C4nderungsdatum einbeziehen')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12918556221416247)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Typ'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12918744749416247)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100004)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gateway'
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12918998830416247)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Monatliche \00DCbersichten beibehalten (Monate)')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12919147426416247)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MessageFlow-Logaufbewahrung (Tage)'
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12919329068416247)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100004)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kaskade'
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12919532647416247)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100004)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12919779074416247)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessebene'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12919915576416247)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12920131693416247)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passwort'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12920329028416247)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logs (Tage) beibehalten'
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12920539739416247)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12920785205416247)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'XML Diagramm'
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12920967522416247)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version einbeziehen'
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12921154069416247)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datei'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12921317101416247)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Timer neu-ausl\00F6sen um')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12921566746416247)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Speicherort f\00FCr Instanzarchivierung')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12921702392416247)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12921992949416247)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Herunterladen als'
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12922106102416247)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12922386200416247)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessvariable'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12922572296416248)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Secret'
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12922766726416248)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Doppelte Schritte vermeiden'
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12922920210416248)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neuer Name/Suffix'
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12923109795416248)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statische ID f\00FCr APEX-Zugangsdaten')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12923356808416248)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sprache'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12923588823416248)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statische ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12923783485416248)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100004)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Besitzer'
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12923904380416248)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lizenziert an'
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12924161297416248)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Doppelte Schritte vermeiden'
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12924314971416248)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ebene'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12924597598416248)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standard Anwendungs-ID'
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12924799102416248)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standardseiten-ID'
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12924981990416248)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzername'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12925132599416248)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12925322497416248)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesch\00E4ftsreferenz (Prozessvariable)')
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12925519382416248)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kategorie einbeziehen'
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12925710210416248)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Log - eingehender MessageFlow'
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12925914972416248)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100004)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer - Max. Zyklen'
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12926160245416248)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zieltyp'
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12926339344416248)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12926512651416249)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modus'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12926728297416249)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Einf\00FCgen des Inhalts einer BPMN-Datei (max. 30 000 Zeichen)')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12926942456416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standard-Workspace'
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12927192350416249)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E4gliche \00DCbersichten beibehalten (Tage)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12927374466416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer-ID ausblenden'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12927512457416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Log - eingehende MessageFlow Nachrichten'
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12927719493416249)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logs beibehalten (Tage nach Abschluss der Prozessinstanz)'
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12927923861416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standardbenutzername'
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12928175449416249)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Statische ID f\00FCr APEX-Zugangsdaten')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12928370034416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer aktiviert'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12928541970416249)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BLOB-Spalte'
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12928713063416249)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100004)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lizenzablaufdatum'
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12928962899416249)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12929133565416249)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eingehende REST-Calls loggen'
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12929358096416249)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Redirect-URI'
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12929584261416249)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL vor Genehmigung'
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12929705752416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100004)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modus'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12929946374416249)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logs beibehalten (Tage nach Abschluss der Prozessinstanz)'
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12930146526416249)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support URI'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12930388005416249)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status einbeziehen'
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12930562231416250)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12930723490416250)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100004)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sprache'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12930908001416250)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dokumentpr\00E4fix')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12931153876416250)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Archivierung der Instanz\00FCbersicht aktivieren')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12931338260416250)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12931540578416250)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standardanwendungs-ID'
,p_translate_from_text=>'Default Application Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12931790627416250)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12931906956416250)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100004)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modus'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12932199839416250)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzername merken'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12932393452416250)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12932520473416250)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standard-Workspace'
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12932703149416250)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Timer jetzt neu-ausl\00F6sen')
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12932967761416250)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MessageFlow-Logaufbewahrung (Tage)'
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12933136010416250)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12933323695416250)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Beschreibung'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12933540033416250)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ebene'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12933783068416250)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12933987392416250)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Quartals\00FCbersichten beibehalten (Monate)')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12934196845416250)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variablenname'
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12934348845416250)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client-ID'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12934590511416251)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standardseiten-ID'
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12934748782416251)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100004)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Basis-URL'
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12934949638416251)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support E-Mail'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12935138114416251)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer aktiviert'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12935342113416251)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12935556235416251)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100004)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neue Version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12935746169416251)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kategorie'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12935926267416251)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suchen'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12936164571416251)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100004)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12936309468416251)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Archivierung der Instanz\00FCbersicht aktivieren')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12936514979416251)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Standard-E-Mail-Absender'
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12936741650416255)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100004)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ung\00FCltiges JSON-Format')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12936943111416255)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100004)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# muss einen Wert haben.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12937154353416255)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100004)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bitte \00FCberpr\00FCfen sie den angef\00FChrten Flow')
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12937342139416255)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# muss einen Wert haben.'
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12937510902416255)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100004)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# muss einen Wert haben.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12937760851416255)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# muss einen Wert haben.'
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12937913904416256)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ein Modell mit aktuell laufenden Instanzen kann nicht archiviert werden.'
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12938198997416256)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100004)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN Dateiinhalt bitte einf\00FCgen')
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12938330170416256)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100004)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bitte #LABEL# ausw\00E4hlen.')
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12938559508416256)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modell existiert bereits. Verwenden sie "\00DCberschreiben erzwingen"')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12938788682416256)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flow existiert bereits. Verwenden sie \00DCberschreiben erzwingen')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12938975761416256)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell importiert'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12939126277416256)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100004)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12939321650416256)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100004)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12939554841416256)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100004)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12939764997416257)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100004)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12939900593416257)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100004)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12940107767416257)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100004)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST-Konfiguration gespeichert.'
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12940328287416257)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12940577290416257)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100004)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12940747992416257)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100004)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12940976012416257)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100004)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12941128554416257)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100004)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktion durchgef\00FChrt.')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12941376797416257)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100004)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12941579983416257)
,p_page_id=>9
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100004)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C4nderungen gespeichert')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12941783397416257)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell importiert.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12941969250416258)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100004)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanz-Ereignisse'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12942148580416258)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100004)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Engine'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12942369136416258)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100004)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanzdetails'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12942577243416258)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100004)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanz-Ereignisse'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12942770877416258)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100004)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'OAUTH-Clients'
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12942914842416258)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100004)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12943143338416258)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100004)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12943349204416258)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100004)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12943544893416258)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100004)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Konfiguration - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12943732648416258)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100004)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12943979204416258)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Prozessleistung (Perioden\00FCbersichten)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12944147262416258)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100004)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktuelle Teil-Sequenzfl\00FCsse')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12944314512416258)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100004)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Button Bar'
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12944519190416258)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100004)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variablenhistorie'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12944771592416258)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100004)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'JSON-Konfiguration'
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12944991855416259)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100004)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12945191137416259)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Schritt-Ereignis'
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12945375114416259)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Einfache Formular-Vorlagen'
,p_translate_from_text=>'Simple Form Templates'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12945563438416259)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100004)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12945706907416259)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Instanzen pro Status'
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12945949494416259)
,p_page_id=>9
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100004)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Abschnitte'
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12946162898416259)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100004)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Abgeschlossene Schritte'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12946359169416259)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Suchen'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12946573432416259)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagrammdetails'
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12946750931416259)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Nachrichtenabonnements'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12946920388416259)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100004)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aufgerufenes Diagramm'
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12947161471416259)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100004)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12947383437416259)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100004)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12947588842416259)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100004)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Erste Schritte'
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12947764100416259)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Instanz'
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12947978232416259)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Instanz erstellen'
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12948113211416259)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100004)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Versionsunstimmigkeit'
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12948354447416259)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100004)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow importieren'
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12948549955416259)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100004)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12948744452416259)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Voraussetzungen nicht erf\00FCllt')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12948920748416259)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100004)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Schaltfl\00E4chen')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12949198875416260)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100004)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Neue Version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12949308124416260)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100004)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Suchergebnisse'
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12949590946416260)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100004)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Engine-Anwendung'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12949762368416260)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100004)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Statistiken'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12949907714416260)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100004)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Engine-Anwendung'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12950104437416260)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanzfehler in den letzten 14 Tagen'
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12950362432416260)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100004)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'JSON-Konfiguration'
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12950529945416260)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100004)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12950744616416260)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Viewer'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12950912574416260)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100004)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attribute'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12951102764416260)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Standort'
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12951381592416260)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100004)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Optionen'
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12951523929416260)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100004)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Gateway-Pfad hinzuf\00FCgen')
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12951737068416260)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100004)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aufgerufenes Diagramm'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12951981888416260)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100004)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Engine'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12952140593416260)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100004)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Links'
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12952344909416260)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12952564543416260)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12952703647416260)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12952988422416260)
,p_page_id=>9
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100004)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12953180624416261)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Modul fehlt'
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12953395101416261)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12953551071416261)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12953786694416261)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100004)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Instanzen'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12953950822416261)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Button Container'
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12954157841416261)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100004)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12954361033416261)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Modell kopieren'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12954534988416261)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Letzter Fehler'
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12954712457416261)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100004)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Historische Wartezeiten f\00FCr Schritt &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12954984238416261)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100004)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attribute'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12955103546416261)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100004)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Abgeschlossene Teil-Sequenzfl\00FCsse')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12955324871416261)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100004)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aktueller Schritt'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12955529331416261)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Viewer'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12955717159416261)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100004)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Logging'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12955979677416261)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100004)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Archivierung'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12956196761416261)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100004)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Management'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12956323985416261)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100004)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12956510263416261)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100004)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12956737559416262)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100004)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12956999604416262)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100004)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12957139756416262)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12957334389416262)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100004)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Lizenz'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12957534847416262)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12957794995416262)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100004)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12957991444416262)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100004)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12958127725416262)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'REST nicht aktiviert'
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12958364381416262)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab'
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12958547389416262)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100004)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Historische Schrittperformance f\00FCr &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12958732894416262)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Rollen'
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12958988349416262)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100004)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Import-Warnung'
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12959136007416262)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanzdetails'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12959313916416262)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100004)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12959508345416262)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12959716860416262)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanzdetails'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12959999309416262)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100004)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variablenhistorie'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12960112979416262)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Konfiguration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12960362680416262)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100004)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12960595519416262)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100004)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktuelle \00FCberf\00E4llige Ablaufinstanzen')
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12960739041416262)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100004)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12960948940416263)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Informationen'
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12961151986416263)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100004)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12961316727416263)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12961530462416263)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100004)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12961734912416263)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100004)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Prozesse gestartet am &P15_DATE.'
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12961994245416263)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100004)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Zus\00E4tzlicher Installationsschritt nicht abgeschlossen')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12962125684416263)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100004)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Einfache Formular-Vorlage bearbeiten'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12962367350416263)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100004)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12962585117416263)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100004)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instanz-Ereignisse'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12962756855416263)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100004)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12962941205416263)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100004)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aufgabenschrittperformance (aktueller Monat) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12963143302416263)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Schritt-Fehler'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12963353305416263)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-XML'
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12963585125416263)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100004)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'In/Out-Variablen'
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12963788495416263)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Geben Sie die Details ein'
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12963963890416263)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100004)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Neue Version'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12964112516416263)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100004)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variablen'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12964374338416263)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100004)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12964595973416263)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100004)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12964779087416263)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100004)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Prozess Instanzen pro Status'
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12964907936416264)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100004)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Modell l\00F6schen')
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12965177701416264)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100004)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12965391337416264)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktives Ziel ausw\00E4hlen')
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12965514773416264)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100004)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aktuelle Ablaufinstanzen pro Modell - Top 10'
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12965728098416264)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100004)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('R\00FCckschritt')
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12965937835416264)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100004)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Prozessvariable hinzuf\00FCgen/editieren')
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12966183839416264)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12966366273416264)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Navigationspfad'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12966542036416264)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100004)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ablaufinstanzen, die in den letzten 14 Tagen gestartet wurden'
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12966738993416264)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12966926093416264)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100004)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12967177119416264)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timer deaktiviert'
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12967369414416264)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100004)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12967555530416264)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Timer neu-ausl\00F6sen')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12967748175416264)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'APEX-Upgrade gefunden'
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12967929428416264)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12968187519416264)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Erste Schritte'
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12968364598416264)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attribute'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12968563155416264)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100004)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Zugeh\00F6rige Prozessinstanzen')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12968744521416264)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12968996161416265)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100004)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12969193635416265)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Monitor (&P12_PRCS_NAME.)'
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12969371539416265)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Sprachauswahl'
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12969536100416265)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100004)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Schaltfl\00E4chen')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12969715448416265)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100004)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Logging'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12969924504416265)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flow-Viewer'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12970199842416265)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12970368052416265)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Nachricht empfangen'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12970501207416265)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aktionsmen\00FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12970706574416265)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Fehler'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12970924954416265)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Inhalt'
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12971125056416270)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100004)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12971381430416270)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12971555169416270)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12971718808416270)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100004)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12971938836416270)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100004)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12972155476416270)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12972370910416270)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12972581905416270)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100004)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12972700786416270)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100004)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Um Ihre eigenen Formulardefinitionen deklarativ zu erstellen, k\00F6nnen Sie den <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Einfachen Formular-Builder</span></a> verwen')
||'den, um das erforderliche JSON zu generieren.'
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12972994366416270)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100004)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12973153287416271)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12973371228416271)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100004)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12973597502416271)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<li>REST-Modul nicht installiert. Befolgen Sie die Installationsanleitung unter: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12973723974416271)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12973915690416271)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100004)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12974136368416271)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100004)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Wir empfehlen Ihnen, Modelle zu importieren, die mit Flows for APEX erstellt wurden, um sicherzustellen, dass sie von der Engine ausgef\00FChrt werden k\00F6nnen.')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12974341264416271)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>REST ist f\00FCr dieses Schema nicht aktiviert</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12974531540416271)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Auf dieser Seite k\00F6nnen Sie die JSON-Definitionen Ihrer "Einfachen Formular-Vorlagen" verwalten. Die Vorlagen k\00F6nnen auf zwei Arten verwendet werden:'),
'<ul>',
unistr('    <li>W\00E4hlen Sie sie f\00FCr Benutzeraufgaben vom Typ "Einfache Formulare" in Ihren Ablaufmodellen aus</li>'),
unistr('    <li>Verwenden Sie sie in der <strong>Simple Process Starter-App</strong> aus der Flows-Distribution, um Prozessinstanzen zu starten, indem Sie ein Formular ausf\00FCllen'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12974770866416271)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100004)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12974912330416271)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100004)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12975188787416271)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100004)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Um die Timer-Funktion von Flows for APEX verwenden zu k\00F6nnen, m\00FCssen Sie einen zus\00E4tzlichen Installationsschritt abschlie\00DFen, der <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_')
||'blank">hier</a> zu finden ist.'
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12975325994416271)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100004)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12975599742416272)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100004)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12975769075416272)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modelle mit mindestens einem Timer k\00F6nnten auf diesem System nicht ordnungsgem\00E4\00DF funktionieren, da sie deaktiviert sind.<br>Sie k\00F6nnen diese in der Konfiguration aktivieren.')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12975961177416272)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12976101720416272)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100004)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12976371343416272)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100004)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12976581584416272)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>Ein BPMN-basiertes Low-Code-Prozessfluss-System f\00FCr APEX.</h3>'),
'<h4> Funktionen</h4>',
'<ul>',
unistr('<li>Mit Flows for APEX k\00F6nnen APEX-Entwickler Prozessfl\00FCsse in APEX mit einer Kombination aus visuellem Prozessdesign und Low-Code-Techniken modellieren und ausf\00FChren.</li>'),
unistr('<li>Flows for APEX wurde in erster Linie f\00FCr APEX-Entwickler entwickelt und verwendet die Technologien, mit denen Sie bereits vertraut sind - APEX, PL/SQL und SQL -, um leistungsstarke und flexible Prozessfl\00FCsse in Ihrer APEX-Umgebung zu erstellen.</')
||'li>',
unistr('<li>Wird zum Erstellen und Ausf\00FChren eines Prozessflusses von APEX-Seiten, PL/SQL-Skripten und zum Senden von E-Mails verwendet.</li>'),
unistr('<li> Die Low-Code-Diagrammprozessdefinition kann auch von Business-Anwendern verstanden und bearbeitet werden, um die Gesch\00E4ftsflexibilit\00E4t zu erh\00F6hen.  Abl\00E4ufe verwenden die BPMN-Notation (Business Process Modeling Notation) V2</li>'),
unistr('<li>Entwickelt als APEX-Community-Projekt und ver\00F6ffentlicht auf einer Open-Source-MIT-Lizenz.</li>'),
'</ul>',
'<p>',
'<h4>Herunterladen</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Dokumentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Aktuelle Dokumentation online</a>',
'<p>',
'<h4>BPMN-Tutorials</h4>',
unistr('Um mit dem Modellieren von Abl\00E4ufen zu beginnen, probieren Sie die vorinstallierten Tutorialabl\00E4ufe aus. Weitere Informationen zu den Tutorials finden Sie <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">hier</a>.'),
'<p>',
'<h4>Demo-App</h4>',
'<p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12976752359416272)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100004)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12976973994416272)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12977153404416274)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100004)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BPMN-Speicherort'
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12977345205416274)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12977588045416274)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100004)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archiv-Speicherort'
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12977781505416275)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12977934971416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100004)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12978159621416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100004)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12978307439416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100004)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12978587948416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100004)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12978787051416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100004)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktualisieren'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12978960927416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100004)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12979157847416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100004)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kopieren'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12979379386416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100004)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminieren'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12979588283416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100004)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12979785839416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100004)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminieren'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12979970565416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100004)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Theme'
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12980140813416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100004)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lizenz'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12980368005416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100004)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminieren'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12980523633416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100004)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Monitor'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12980754113416275)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservieren'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12980982046416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100004)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktualisieren'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12981180405416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100004)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12981315118416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100004)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Details anzeigen'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12981577922416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100004)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Neue Version hinzuf\00FCgen')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12981721289416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100004)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12981905060416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100004)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Herunterladen (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12982195775416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12982363736416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100004)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Instanz\00FCbersicht')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12982564013416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100004)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Editieren'
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12982717802416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100004)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12982970033416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100004)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Engine'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12983102643416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanz-Zeitleiste anzeigen'
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12983344144416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100004)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12983517674416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100004)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12983759673416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100004)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktualisieren'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12983962030416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100004)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modeldetails zeigen'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12984138451416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100004)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Abschlie\00DFen')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12984392250416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100004)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00F6schen')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12984568605416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100004)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Neue Version hinzuf\00FCgen')
,p_translate_from_text=>'Add New Version'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12984737982416276)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100004)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Automatisch'
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12984920895416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlagen'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12985155737416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100004)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Engine-Anwendung'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12985351239416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100004)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Start'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12985574887416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100004)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dashboard'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12985722066416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100004)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historie anzeigen'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12985935602416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100004)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivierung'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12986161412416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100004)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiken'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12986388483416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100004)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Herunterladen (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12986584695416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100004)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step-Timer'
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12986715648416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100004)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nach Report|Seite an Seite|Neues Fenster'
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12986993990416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100004)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12987197879416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abmelden'
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12987304371416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100004)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12987580700416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100004)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erste Schritte'
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12987760018416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100004)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Neu-ausl\00F6sen')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12987900500416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100004)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Start'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12988136136416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100004)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anzeigeeinstellungen'
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12988310063416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12988520435416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100004)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importieren'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12988740114416277)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100004)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12988970707416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100004)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportieren'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12989178442416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100004)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kopieren'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12989353601416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dunkler Modus'
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12989558462416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100004)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12989729066416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100004)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12989992436416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100004)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model-Details anzeigen'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12990177855416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100004)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Abschlie\00DFen')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12990382887416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12990583441416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Release'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12990766968416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100004)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anzeigeeinstellungen'
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12990977734416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100004)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quelle anzeigen'
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12991158338416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100004)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Details anzeigen'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12991319451416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100004)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12991566871416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neustart'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12991750963416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservieren'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12991973071416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100004)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12992143775416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100004)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logging'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12992346154416278)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Release'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12992531712416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100004)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12992776818416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100004)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12992940183416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100004)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Herunterladen (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12993178778416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100004)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportieren'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12993354334416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100004)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ansicht'
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12993550123416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100004)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Start'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12993737165416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Heller Modus'
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12993984198416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100004)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Neu-ausl\00F6sen')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12994115322416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100004)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12994384872416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100004)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nach Report|Seite an Seite|Neues Fenster'
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12994505636416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100004)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historie anzeigen'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12994710773416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12994936271416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Neustart'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12995189755416279)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100004)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Management'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12995380618416282)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Kein Prozess ausgew\00E4hlt')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12995536590416282)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Kein Prozess ausgew\00E4hlt')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12995717534416282)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100004)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine Attribute gefunden'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12995984853416282)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12996157009416282)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100004)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine In/Out-Variablen gefunden.'
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12996355975416284)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suchdialog'
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12996522108416284)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12996729358416284)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12996912318416284)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12997195013416284)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12997357762416284)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suche'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12997507864416285)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Schlie\00DFen')
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12997719691416285)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Weiter &gt;'
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12997994332416285)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('&lt; Zur\00FCck')
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12998139671416285)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00F6chen sie diese L\00F6sch-Aktion durchf\00FChren?')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12998353707416285)
,p_translated_flow_id=>100004
,p_translate_to_id=>100.100004
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ablauf'
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12998541619416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100004)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessstatistiken'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12998742361416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100004)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Management'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12998924882416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100004)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST-Service'
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12999145076416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Engine'
,p_translate_from_text=>'Engine'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12999306477416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100004)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivierung'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12999569321416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100004)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Monitor'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12999771085416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100004)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanz-Zeitleiste - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(12999943607416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100004)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13000113795416286)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100004)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13000303876416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100004)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dashboard'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13000540282416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100004)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgabenstatistik'
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13000787755416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100004)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiken'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13000923256416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100004)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Engine-Anwendung'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13001166552416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100004)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00E4gliche Statistik')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13001343951416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100004)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlagen'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13001528643416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100004)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Konfiguration - Lizenz'
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13001726412416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100004)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Modellierer'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13001904803416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100004)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logging'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13002142134416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100004)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13002312367416287)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100004)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13002553489416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100004)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datei'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13002752563416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100004)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nach Aufgabe'
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13002959238416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100004)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bevor Aufteilung'
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13003167467416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100004)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess-Status nach Terminierung'
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13003379089416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100004)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Platzhalter'
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13003508013416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100004)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13003731132416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100004)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BCC'
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13003998581416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100004)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datum'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13004168509416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100004)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Intervall Jahr zu Monat'
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13004338847416288)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100004)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'In Variable'
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13004544767416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100004)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Text'
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13004741305416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100004)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL Skript'
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13004955405416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100004)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anforderung'
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13005132475416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100004)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seitenelemente'
,p_translate_from_text=>'Page Items'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13005309918416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100004)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zeit bis zur n\00E4chsten Ausf\00FChrung des Timers')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13005523880416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100004)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Maximale Ausf\00FChrungen')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13005734967416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100004)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Out Variable'
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13005985457416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100004)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PL/SQL Funktionsbody'
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13006167782416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100004)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seite'
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13006379517416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100004)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Formatierungsmaske'
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13006533815416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100004)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Interval Tag zu Sekunde'
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13006797394416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100004)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zeit bis zur ersten Ausf\00FChrung des Timers')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13006958023416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100004)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Engine'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13007111316416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100004)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Definitionstyp'
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13007386524416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100004)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Definition'
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13007527309416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100004)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Antwort An'
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13007730546416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzername merken'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13007940846416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100004)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BPMN Datei'
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13008119247416289)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100004)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vor Aufgabe'
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13008372145416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100004)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'An'
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13008597624416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100004)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CC'
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13008785520416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100004)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sofort Senden'
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13008996681416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100004)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vor Ereignis'
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13009114186416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100004)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applikations-ID'
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13009340489416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100004)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML Body'
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13009559826416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100004)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nach Zusammenf\00FChrung')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13009725221416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100004)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Von'
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13009930198416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100004)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statischer Wert'
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13010135003416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100004)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Betreff'
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13010372854416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100004)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Element'
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13010559693416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100004)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL Abfrage (gibt Doppelpunkt getrennte Werte zur\00FCck)')
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13010726995416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100004)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PL/SQL Ausdruck'
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13010956310416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100004)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PL/SQL-Code'
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13011190896416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100004)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessvariable'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13011306184416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100004)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bei Ereignis'
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13011567954416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100004)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anhang'
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13011792836416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100004)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL Abfrage (gibt einzelnen Wert zur\00FCck)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13011990941416290)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100004)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cache leeren'
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13012165341416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100004)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elementwerte'
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13012307251416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100004)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Body'
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13012542675416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100004)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgabentyp'
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13012710077416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100004)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Verwende Template'
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13012924700416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100004)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Template-ID'
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13013110991416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100004)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13013303107416291)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100004)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seiten-Elementwerte verbinden'
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13013503331416293)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kein Sub-Prozess geloggt'
,p_translate_from_text=>'No Subflow Logged'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13013723438416293)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine Prozess-Ebene geloggt'
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13013950920416293)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('- Ausw\00E4hlen -')
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13014111688416293)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine Kategorie'
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13014367124416293)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100004)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Richtung'
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13014593146416293)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100004)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13014737177416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100004)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13014997409416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100004)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fehler-Stapel'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13015159708416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100004)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignisstatus'
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13015326624416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100004)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13015567734416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100004)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13015775694416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13015921139416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100004)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13016146481416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100004)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignisatum'
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13016386434416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13016588394416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100004)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ist aufrufbar'
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13016750129416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100004)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Initialisiert am'
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13016912010416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100004)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13017173897416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13017333400416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100004)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seiten-ID'
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13017533275416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100004)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13017735102416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100004)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzername'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13017963042416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100004)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13018171104416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100004)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13018384198416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100004)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Letztes Update am'
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13018507428416294)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100004)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignistitel'
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13018771922416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100004)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignissymbol'
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13018987145416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100004)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13019195517416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13019319637416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100004)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignisbeschreibung'
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13019539599416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100004)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13019741325416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13019986882416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100004)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13020194007416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100004)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13020333065416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100004)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applikations-ID'
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13020595499416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100004)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzerfarbe'
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13020709738416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100004)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datentyp'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13020904459416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100004)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Beschreibung'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13021181638416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100004)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13021386629416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Priorit\00E4t')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13021581781416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100004)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13021785788416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100004)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignistyp'
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13021925623416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100004)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13022152310416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100004)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13022380238416295)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('F\00E4llig am')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13022553145416296)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100004)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzername'
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13022796427416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100004)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13022908102416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100004)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13023103969416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100004)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13023304516416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13023534116416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13023730037416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100004)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13023967093416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100004)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13024191472416297)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100004)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13024304888416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13024526580416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100004)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13024730446416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13024990551416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100004)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13025169983416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100004)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13025369916416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100004)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13025558563416298)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>Ein Modell: Ein einzelnes Modell importieren, indem alle Attribute angegeben werden</li>',
'    <li>Mehrere Modelle: Importieren Sie mehrere Modelle, indem Sie eine ZIP-Datei angeben*</li>',
'</ul>',
'<p>',
'    * Die ZIP-Datei muss Folgendes enthalten:',
'    <ul>',
'        <li>Die zu importierenden BPMN-Dateien</li>',
'        <li>Eine import.json-Datei, bei der es sich um ein Array von Objekten (siehe Beispiel unten) mit den folgenden Attributen handelt:',
'            <ul>',
'                <li>dgrm_name: Der Name des Modells</li>',
'                <li>dgrm_version: Die Modellversion</li>',
'                <li>dgrm_category: Die Kategorie des Modells</li>',
'                <li>file: Der Name der bpmn-Datei im Archiv</li>',
'            </ul>',
'        </li>',
'    </ul>',
unistr('Beispiel f\00FCr eine import.json-Datei mit zwei Modellen<br>'),
'<pre><code>[',
'{',
'    "dgrm_name": "Die Pizza-Kollaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": Null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Feiertage",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": Null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13025751997416299)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen aktivieren, speichert die Anwendung Ihren Benutzernamen in einem persistenten Browsercookie namens "LOGIN_USERNAME_COOKIE".'),
unistr('Wenn Sie das n\00E4chste Mal zur Anmeldeseite gehen,'),
unistr('wird das Feld "Benutzername" automatisch mit diesem Wert aufgef\00FCllt.'),
'</p>',
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen deaktivieren und Ihr Benutzername bereits im Cookie gespeichert ist,'),
unistr('wird es von der Anwendung mit einem leeren Wert \00FCberschrieben.'),
unistr('Sie k\00F6nnen auch die Entwicklertools Ihres Browsers verwenden, um das Cookie vollst\00E4ndig zu entfernen.'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13025940706416299)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13026154585416300)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100004)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanz-Ereignisse'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13026359236416300)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100004)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aktuelle Teil-Sequenzfl\00FCsse')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13026561449416300)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100004)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13026799748416300)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Einfache Formular-Vorlagen'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13026929346416300)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100004)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variablenhistorie'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13027100482416300)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100004)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanz-Ereignisse'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13027381057416300)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100004)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ORDS-Client-Report'
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13027534240416300)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100004)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgerufenes Modell'
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13027792376416300)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nachrichtenabonnements'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13027911471416300)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100004)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abgeschlossene Schritte'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13028117467416300)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100004)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Attribute'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13028361786416300)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100004)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgerufenes Diagramm'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13028592488416300)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100004)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Management'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13028706297416300)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13028953271416300)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100004)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow-Instanzen'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13029135396416300)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100004)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Abgeschlossene Teil-Sequenzfl\00FCsse')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13029320047416300)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100004)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktueller Schritt'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13029576155416300)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100004)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variablenhistorie'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13029753734416300)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100004)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variablen'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13029964460416301)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schrittfehler'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13030100760416301)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100004)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflows'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13030385762416301)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100004)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Die maximale Zeilenanzahl f\00FCr diesen Bericht betr\00E4gt #MAX_ROW_COUNT# Zeilen.  Wenden Sie einen Filter an, um die Anzahl der Datens\00E4tze in Ihrer Abfrage zu reduzieren.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13030547165416302)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Die maximale Zeilenanzahl f\00FCr diesen Bericht betr\00E4gt #MAX_ROW_COUNT# Zeilen.  Wenden Sie einen Filter an, um die Anzahl der Datens\00E4tze in Ihrer Abfrage zu reduzieren.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13030748753416302)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Die Variablenhistorie ist leer.'
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13030921632416302)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Die Schritt-Fehler Historie ist leer.'
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13031144824416302)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Keine aktuellen Sequenzfl\00FCsse gefunden.')
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13031362779416302)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Keine Variablen-Ausdr\00FCcke gefunden.')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13031504629416302)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine aufgerufenen Diagramme gefunden'
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13031725367416302)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Keine abgeschlossenen Sequenzfl\00FCsse gefunden.')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13031964532416302)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Die Instanz-Ereignishistorie ist leer.'
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13032190520416302)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100004)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine Daten gefunden.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13032362910416302)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine Attribute gefunden'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13032535263416302)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine aufgerufenen Diagramme gefunden'
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13032700904416302)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100004)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Die Variablenhistorie ist leer.'
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13032963723416302)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100004)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine Daten gefunden.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13033166543416302)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine abgeschlossenen Schritte gefunden.'
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13033375153416303)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Keine aktuellen Schritte gefunden.'
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13033553251416303)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13033709842416303)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13033922093416303)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13034164760416303)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13034339046416303)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13034580993416303)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13034793412416304)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13034913785416304)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13035115635416304)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13035393642416304)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13035579521416304)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13035720717416304)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13035940221416304)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13036170427416304)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13036307309416304)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13036572499416304)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13036725374416304)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13036999899416304)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13037103987416304)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13037360759416304)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100004)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13037592475416304)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100004)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13037724111416304)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13037971750416304)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13038186765416304)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13038375030416304)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100004)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13038527908416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13038780037416305)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13038968511416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13039159418416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100004)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13039354363416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100004)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13039536387416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13039791495416305)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13039923561416305)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13040116979416305)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13040357080416305)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13040518531416305)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13040748968416305)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13040953324416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13041174105416305)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13041332120416305)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13041524789416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100004)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13041733095416305)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13041919303416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13042150463416306)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13042324447416306)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13042593253416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100004)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13042734433416306)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100004)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13042984790416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13043147889416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13043320087416306)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13043511824416306)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13043793228416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100004)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13043966220416306)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13044103086416306)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13044371640416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13044584625416306)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100004)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13044705410416306)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13044969032416306)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13045172047416306)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13045375915416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13045542032416307)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100004)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13045780934416307)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13045994879416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13046192892416307)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13046320060416307)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100004)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13046522731416307)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13046715877416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100004)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13046978419416307)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13047144720416307)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13047323289416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13047593995416307)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13047750074416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13047996647416307)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13048118938416307)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13048326679416307)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13048565624416307)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13048779457416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13048957583416307)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13049151399416307)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13049322263416307)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13049532771416307)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13049750773416308)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100004)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13049933666416308)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13050179319416308)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100004)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13050347127416308)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13050542299416308)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13050742654416308)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13050926246416308)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13051133618416308)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100004)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13051372086416308)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100004)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13051582177416308)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100004)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13051749675416308)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13051903209416308)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13052132135416308)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13052381576416308)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100004)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13052511818416308)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13052715122416308)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13052929556416308)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13053106047416308)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13053399969416308)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13053574988416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13053725201416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13053994025416309)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13054124967416309)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13054304446416309)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13054562831416309)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13054708712416309)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13054952300416309)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13055164637416309)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13055380321416309)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13055560391416309)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13055713363416309)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13055965968416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13056142352416309)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13056310830416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13056589113416309)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13056751633416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13056912942416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13057147545416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13057377979416309)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13057541994416309)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100004)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13057714339416310)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13057967855416310)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13058111639416310)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100004)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13058381460416310)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13058511412416310)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13058708901416310)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13058934388416310)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100004)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13059105566416310)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13059399790416310)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13059547457416310)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13059760255416310)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100004)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13059983230416310)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13060156521416310)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13060372586416310)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13060566024416310)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13060728058416310)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100004)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13060945509416310)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13061102038416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13061399176416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100004)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13061579792416311)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13061766981416311)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100004)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13061937907416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13062117691416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13062364326416311)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13062541527416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13062706154416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13062919386416311)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13063132339416311)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100004)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13063325705416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13063540953416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13063759655416311)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13063960357416311)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13064107254416312)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13064369722416312)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13064508548416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100004)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13064787357416312)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13064986181416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13065109471416312)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13065396072416312)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13065537093416312)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13065786127416312)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13065992014416312)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13066163707416312)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13066346648416312)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100004)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13066536142416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13066708531416312)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13066929807416312)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13067122052416312)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13067322981416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13067531214416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100004)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13067723494416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13067922514416312)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13068118240416312)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13068356897416313)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100004)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13068560322416313)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13068734031416313)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100004)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13068914442416313)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13069118801416313)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13069393431416313)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13069589846416313)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13069788211416313)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13069913772416313)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13070167309416313)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100004)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13070357607416313)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13070515220416313)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13070790538416313)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13070982130416313)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13071184505416313)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13071360220416313)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13071582640416313)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100004)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13071737357416313)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13071953671416313)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13072125515416313)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13072353921416314)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100004)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13072505926416314)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13072708403416314)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13072947442416314)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100004)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13073110048416314)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13073389754416314)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100004)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13073501609416314)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100004)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13073762945416314)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13073988197416314)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13074188874416314)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13074371775416314)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13074586681416314)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100004)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13074735888416314)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13074990458416314)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13075161885416314)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13075316038416314)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13075546537416314)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13075703481416314)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100004)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13075945261416314)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13076129931416314)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13076318242416315)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13076554044416315)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13076764227416315)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13076900462416315)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13077131506416315)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13077344127416315)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13077595686416315)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13077738893416315)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13077921195416315)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13078172714416315)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100004)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13078387190416315)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13078505827416315)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100004)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13078724659416315)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13078901901416323)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13079171525416323)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13079312717416323)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktueller Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13079565190416323)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objekt'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13079739772416323)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attribute'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13079978610416323)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13080172140416323)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Letzte Aktualisierung'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13080354025416323)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objekt'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13080531037416323)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13080771916416323)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13080945022416323)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13081125395416323)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellungsdatum'
,p_translate_from_text=>'Creation Date'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13081363765416323)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignis'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13081563876416324)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgerufenes Diagram - Versionsselektion'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13081702796416324)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13081999169416324)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13082172906416324)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13082379133416324)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Letztes Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13082532214416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Start Objekt'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13082705680416324)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100004)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support E-Mail-Adresse'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13082953877416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100004)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13083133065416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuelles Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13083385052416324)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modellversion'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13083565716416324)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13083712346416324)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100004)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status wenn abgeschlossen'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13083907869416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Schl\00FCsselwert')
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13084171521416324)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13084366350416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bahn'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13084508138416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100004)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reserviert f\00FCr')
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13084765021416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100004)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13084963137416324)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Schl\00FCsselname')
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13085108340416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13085390450416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13085578973416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13085891942416325)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Enth\00E4lt Rekursionsymbol')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13086078590416325)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte-ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13086273183416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13086426471416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schnellaktion'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13086607092416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzname'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13086864282416325)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13087041996416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100004)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13087225364416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13087457518416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('F\00E4llig am')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13087671657416325)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13087893943416325)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13088016378416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100004)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13088247426416325)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100004)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schnellaktion'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13088402290416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellt'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13088605048416325)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13088890869416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ausf\00FChrung')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13089053032416325)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zuletzt abgeschlossen'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13089201673416326)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100004)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13089446507416326)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13089611596416326)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13089885398416326)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuelle Klasse'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13090013729416326)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100004)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13090239666416326)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13090411324416326)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statische ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13090686875416326)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13090848594416326)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuell geworden'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13091065132416326)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100004)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13091136439416326)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13091373681416326)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ausdruck'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13091579790416326)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ausf\00FChrung')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13091761539416326)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100004)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13091982158416326)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13092197095416326)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100004)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess-ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13092302163416326)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13092571121416326)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100004)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objekt'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13092770224416326)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13092908468416326)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schritt'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13093169935416327)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13093379250416327)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ausgeschlossene Benutzer'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13093591590416327)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13093745932416327)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservierung'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13093931138416327)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13094190751416327)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13094375299416327)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arbeit gestartet'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13094588085416327)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload-Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13094759749416327)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13094965699416327)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kategorie'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13095165075416327)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100004)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow geparst'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13095360091416327)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13095555714416327)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100004)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservierung'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13095726258416327)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13095992460416327)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozessebene'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13096160334416327)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arbeit gestartet'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13096305147416327)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13096580384416327)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100004)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13096752868416327)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100004)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13096938059416327)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100004)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13097175029416328)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13097386007416328)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13097536454416328)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13097746402416328)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100004)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zuletzt abgeschlossen'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13097927065416328)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ausgangsdiagramm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13098130706416328)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservierung'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13098398170416328)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13098524416416328)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Letztes Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13098721861416328)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Objekt'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13098998558416328)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Typ'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13099192601416328)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Letzte Aktualisierung'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13099395062416328)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13099584219416328)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13099760228416328)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13099967798416328)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13100160650416328)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13100370523416328)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgerufenes Diagramm'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13100519650416328)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13100784862416328)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13100970520416329)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13101188020416329)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13101382498416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100004)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13101540982416329)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13101726427416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzer'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13101992442416329)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13102175312416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13102352764416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13102556783416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nachrichtenname'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13102797738416329)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zuletzt abgeschlossen'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13102927009416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100004)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuell'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13103146469416329)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess Ebene'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13103357988416329)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13103558823416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100004)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Objekt'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13103713756416329)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13103953732416329)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13104171308416329)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Objekt'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13104357670416329)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100004)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13104552183416329)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13104744279416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ereignis'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13104913368416330)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Priorit\00E4t')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13105104278416330)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100004)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13105319914416330)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservierung'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13105593161416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fehlerstapel'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13105764800416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13105966930416330)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Letzte Aktualisierung'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13106131937416330)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100004)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13106342768416330)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13106558625416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ausf\00FChrung')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13106719907416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100004)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Schritt-Schl\00FCssel')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13106929596416330)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13107141666416330)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100004)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Schritt-Schl\00FCssel')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13107301285416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13107533947416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesch\00E4ftsprozess-ID')
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13107702560416330)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuell geworden'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13107974425416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datentyp'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13108138046416330)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13108332844416330)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13108516339416330)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100004)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13108713121416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13108917855416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13109105322416331)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufgerufene Diagramversion'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13109309521416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13109530302416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zuletzt abgeschlossen'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13109733212416331)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13109997776416331)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100004)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Schritt-Schl\00FCssel')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13110142729416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13110377616416331)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13110579026416331)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess Ebene'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13110747835416331)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fehlerstapel'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13110913347416331)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schritt'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13111166310416331)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13111356977416331)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arbeit gestartet'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13111516786416331)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13111799972416331)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100004)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13111939070416331)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuelle Klasse'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13112147637416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13112337943416331)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arbeit gestartet'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13112562252416331)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datentyp'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13112737261416331)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufendes Diagramm'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13112962186416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100004)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fehlerstapel'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13113163952416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13113391946416332)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prozess Ebene'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13113525004416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100004)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub-ID'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13113729168416332)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100004)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13113918715416332)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100004)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kommentar'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13114176552416332)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100004)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Beschreibung'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13114372819416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13114571050416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13114719158416332)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13114992753416332)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modell Kategorie'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13115167897416332)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100004)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13115349222416332)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13115589521416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100004)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iterationspfad'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13115749755416332)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramm'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13115921792416332)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Datentyp'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13116191602416332)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuell'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13116308891416332)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Zeitstempel'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13116540983416332)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13116785531416332)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aufrufende Diagramm-ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13116962977416332)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100004)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support URI'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13117191321416333)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzen'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13117353928416333)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Wert'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13117580120416333)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100004)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13117753246416333)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100004)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13117934292416333)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13118179506416333)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Hat Rekursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13118393419416333)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100004)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow-ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13118510948416333)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potenzielle Benutzer'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13118777765416333)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100004)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13118973037416333)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100004)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13119163979416333)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100004)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13119326360416333)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modellname'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13119525667416333)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13119709159416333)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ausdruckstyp'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13119933565416333)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100004)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13120197973416333)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13120382152416333)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13120553981416333)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13120771325416333)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potenzielle Gruppen'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13120990971416334)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramm'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13121127503416334)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100004)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client-ID'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13121320137416334)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13121599352416334)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13121719308416334)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramm-ID'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13121926227416334)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schritt'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13122179680416334)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100004)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuell geworden'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13122380756416334)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13122564113416334)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100004)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13122779280416334)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100004)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aktuell geworden'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13122907908416334)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100004)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13123196369416334)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100004)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13123398580416334)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100004)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13123595008416334)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100004)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status wenn abgeschlossen'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13123714148416334)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Schnellaktion'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13123941808416334)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100004)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13124106656416334)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13124358682416343)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13124540249416343)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13124705486416343)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13124943339416343)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100004)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13125118570416343)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100004)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13125390717416343)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13125564973416343)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100004)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13125728988416343)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13125980029416343)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100004)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13126165906416343)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13126367981416343)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100004)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13126581107416343)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13126708788416343)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13126905045416343)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100004)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13127176411416343)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13127309275416343)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100004)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13127598213416344)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100004)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13127710093416344)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100004)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13127937760416344)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13128115009416344)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100004)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13128386948416344)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13128555938416344)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100004)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13128750160416344)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13128924627416344)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13129147987416344)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100004)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13129354337416344)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100004)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13129557643416345)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100004)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13129787651416345)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100004)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13129975471416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100004)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Viewer'
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13130140180416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100004)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Modeler'
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13130337899416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100004)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13130519780416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100004)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13130713857416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100004)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13130909818416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100004)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13131105373416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100004)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13131309674416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100004)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13131560009416348)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Unzureichende Berechtigungen, Benutzer ist kein Administrator'
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13131738377416349)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('St\00FCndlich')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13131968894416349)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('St\00FCndlich')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13132125675416349)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Jahr'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13132346554416349)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Jahr'
,p_translate_from_text=>'1 Year'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13132502234416349)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Jahr'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13132739210416349)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Jahr'
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13132992745416349)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 Jahre'
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13133176913416349)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 Min.'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13133392859416349)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 Min.'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13133500829416350)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Monate'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13133758189416350)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Monate'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13133982270416350)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Monate'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13134125476416350)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Monate'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13134323992416350)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4 Jahre'
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13134575366416350)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 Min.'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13134767422416350)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 Min.'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13134903626416350)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Monate'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13135143460416350)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Monate'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13135386379416350)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Monate'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13135527228416350)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Monate'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13135721842416350)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Jahre'
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13135947237416351)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Min.'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13136101000416351)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Min.'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13136381014416351)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Monate'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13136516472416351)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Monate'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13136733620416351)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Monate'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13136953400416351)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Monate'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13137141181416351)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2 Jahre'
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13137394520416352)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 Sekunden (Produktionsverwendung - nicht f\00FCr apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13137566836416352)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 Sekunden (Produktionsverwendung - nicht f\00FCr apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13137703499416352)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 Tage'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13137963599416352)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 Tage'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13138100501416352)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 Tage'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13138331249416352)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Jahr'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13138534916416352)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 Tage'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13138774515416352)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 Tage'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13138980978416352)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 Tage'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13139152949416353)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13139350319416353)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13139536484416353)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13139721159416353)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13139963524416353)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13140140283416353)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100004)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13140391900416353)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13140510428416353)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100004)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13140742067416353)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13140970502416353)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13141133887416353)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13141307455416353)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13141519847416354)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100004)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13141732719416354)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13141943309416354)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13142137314416354)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13142355088416354)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13142553786416354)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13142724897416354)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100004)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13142980567416354)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100004)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13143154105416354)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13143350772416354)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100004)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13143561607416354)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13143783062416354)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100004)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13143959236416354)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100004)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13144139942416354)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13144394207416354)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100004)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13144542566416354)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100004)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13144710722416354)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13144951002416354)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100004)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13145135265416354)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100004)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13145300357416354)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13145583523416354)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100004)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13145723609416355)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100004)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13145955094416355)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13146164651416355)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13146376382416355)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13146506324416355)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13146728684416355)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13146991577416355)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13147125935416355)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13147364823416355)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100004)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13147502283416355)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100004)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13147756631416355)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13147949935416355)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13148135047416355)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13148375950416355)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13148596611416355)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13148773916416355)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13148924577416355)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100004)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13149111739416355)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13149371670416355)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100004)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13149526766416355)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13149784812416356)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100004)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13149984936416356)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13150152642416356)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13150309009416356)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100004)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13150528678416356)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100004)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13150776289416356)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100004)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13150952975416356)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13151165142416356)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13151323134416356)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13151509177416356)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100004)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13151754478416356)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13151950406416356)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100004)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13152177822416356)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13152350208416356)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13152534004416356)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13152763698416356)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13152907933416356)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13153124629416356)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13153387184416356)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13153505312416357)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13153737596416357)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13153992858416357)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100004)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13154110220416357)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13154399108416357)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13154533029416357)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13154798081416357)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100004)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13154932167416357)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13155108144416357)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13155363065416357)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100004)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13155584641416357)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13155750951416357)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13155907211416357)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100004)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13156144765416357)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13156385549416357)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13156535794416357)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13156743732416357)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13156964129416357)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13157105546416357)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13157312811416357)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13157596110416357)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13157720544416358)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13157901558416358)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13158128857416358)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13158353207416358)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13158505453416358)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13158740096416358)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13158988113416358)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13159145190416358)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100004)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13159354636416358)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100004)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13159576361416358)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13159766313416358)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13159985277416358)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100004)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13160159328416358)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100004)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13160305113416358)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13160582894416358)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13160766996416358)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13160932708416358)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13161121635416358)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13161370234416358)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13161557478416358)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13161720092416359)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13161951255416359)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13162130928416359)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100004)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13162361367416359)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100004)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13162577064416359)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100004)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13162732220416359)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100004)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13162969635416359)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13163191484416359)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13163352739416359)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13163550271416359)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100004)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13163755269416359)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13163961284416359)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13164196891416359)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100004)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13164390849416359)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13164557313416359)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13164763931416359)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100004)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13164928383416359)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13165198535416359)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13165323480416359)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100004)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13165597897416359)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13165770459416359)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13165911021416359)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13166131589416360)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100004)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13166381901416360)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100004)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13166534416416360)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13166787259416360)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100004)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13166953443416360)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13167101482416360)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13167316121416360)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100004)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13167553053416360)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13167703231416360)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13167952704416360)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13168175961416360)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100004)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13168328911416360)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13168554293416360)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13168791790416360)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13168946783416360)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13169180751416360)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13169322603416360)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13169514618416360)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13169710795416360)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13169999555416360)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13170125131416360)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13170301878416361)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13170561786416361)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100004)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13170741446416361)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13170947825416361)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13171157077416361)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13171307818416361)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13171502803416361)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100004)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13171718431416361)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13171954484416361)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13172147045416361)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13172374311416361)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13172582224416361)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100004)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13172783698416361)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13172986881416361)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13173166538416361)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13173364878416361)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13173564657416361)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100004)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13173730307416361)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100004)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13173952205416361)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13174153136416362)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100004)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13174375175416362)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13174580819416362)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100004)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13174753350416362)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13174994455416362)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13175138100416362)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13175378108416375)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13175585837416375)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13175772082416375)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13175906914416375)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13176162571416375)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13176307300416375)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100004)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13176568292416376)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13176749766416376)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13176980845416376)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13177137787416376)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13177389993416376)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13177559809416376)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13177729649416376)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13177961117416376)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13178175437416376)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13178342511416376)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13178549450416376)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13178793494416376)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13178916783416376)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100004)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13179173497416376)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100004)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13179344085416376)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13179554296416376)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13179734260416376)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13179916939416376)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100004)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13180131521416376)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13180335595416376)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13180532576416377)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13180727024416377)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13180922757416377)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13181184557416377)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13181347878416377)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100004)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13181531064416377)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13181755495416377)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13181966944416377)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13182126073416377)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13182313586416377)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13182520605416377)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13182757104416377)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13182973486416377)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13183138496416377)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13183327827416377)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13183599064416377)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13183750106416377)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13183964550416377)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13184105725416377)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100004)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13184373144416377)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13184522128416377)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13184707950416378)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13184978453416378)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13185116585416378)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13185373087416378)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13185547026416378)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13185706594416378)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13185999640416378)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13186130970416378)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13186382414416378)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13186573603416378)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13186719171416378)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13186988690416378)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100004)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13187111063416378)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13187387337416378)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13187522728416378)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13187713100416378)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13187970896416379)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13188113658416379)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13188345260416379)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13188556046416379)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100004)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13188727839416379)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13188960426416379)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13189122321416379)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100004)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13189338674416379)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100004)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13189575747416379)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13189745590416379)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13189995287416379)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100004)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13190185977416379)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100004)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13190383333416379)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13190597421416379)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13190730516416379)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13190974905416379)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13191177326416379)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13191302201416379)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13191523435416379)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13191704021416379)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13191954786416379)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13192159253416380)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13192321867416380)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13192573776416380)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13192799074416380)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100004)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13192947262416380)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13193130826416380)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100004)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13193388995416380)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13193591576416380)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13193726754416380)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13193919848416380)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13194140793416380)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13194318303416380)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100004)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13194534609416380)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13194754951416380)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13194952076416380)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13195151351416384)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13195361407416384)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13195509813416384)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13195751637416384)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13195975745416384)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13196104534416384)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100004)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13196357423416384)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13196577347416384)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13196760781416384)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13196903122416384)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13197175311416384)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100004)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13197385182416384)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13197557748416384)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13197794239416384)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13197913997416384)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13198165487416384)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13198339185416385)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13198589948416385)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13198711619416385)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13198944348416385)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13199115573416385)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13199349344416385)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13199502089416385)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13199763284416385)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13199970988416385)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13200132247416385)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13200376653416386)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13200516256416386)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13200788637416386)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13200973230416386)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100004)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13201169533416386)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13201397386416386)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13201582419416386)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13201711010416386)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13201957426416386)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13202145516416387)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13202394370416387)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13202511798416387)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13202760756416387)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13202934196416387)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13203184267416387)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13203336694416387)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100004)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13203587171416387)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13203725768416387)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13203934254416387)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13204190533416387)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13204385639416387)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13204527866416387)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13204777078416387)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13204966237416387)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100004)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13205132022416387)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13205320794416387)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13205525431416387)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13205794713416387)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13205983047416387)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13206194578416388)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13206398716416388)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13206564786416388)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13206724987416388)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13206924009416388)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13207159783416388)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100004)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13207315789416388)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13207590467416388)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13207702918416388)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13207961436416388)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13208118399416388)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13208318605416388)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13208511206416388)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13208750364416388)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13208939003416388)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13209129101416388)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13209356368416388)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13209570338416388)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13209783136416388)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13209959370416388)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13210105993416389)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13210390350416389)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13210578623416389)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13210798672416389)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100004)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13210977644416389)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13211118644416389)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13211353557416389)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13211596565416389)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13211760369416389)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13211957096416389)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13212141165416389)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13212319285416389)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13212502040416389)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13212790306416389)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13212935464416389)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13213166514416389)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13213350274416389)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13213507998416389)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100004)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13213720660416389)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13213951921416389)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100004)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13214173450416389)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13214375848416389)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13214560298416390)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13214741420416390)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13214991539416390)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100004)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13215187961416390)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13215378584416390)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13215527825416390)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13215722885416392)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100004)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13215969160416393)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13216112106416393)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13216373265416393)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13216527526416393)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13216779566416393)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13216940740416393)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13217105314416393)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13217316186416393)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100004)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13217560116416393)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100004)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13217715139416393)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13217995781416393)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13218150056416393)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100004)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13218364581416393)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100004)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13218590059416393)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13218759897416393)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13218915244416393)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13219156897416393)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13219361155416393)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13219551628416393)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13219758409416393)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13219963009416394)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13220153175416394)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13220372527416394)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13220528203416394)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13220703049416394)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13220963252416394)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13221145866416394)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13221382330416394)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13221532475416394)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100004)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13221797206416394)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100004)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13221939118416394)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100004)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13222135226416394)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13222336307416394)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13222578599416394)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13222704302416394)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13222907047416394)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13223165432416394)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13223304931416394)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100004)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13223563450416394)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100004)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13223712781416394)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13223950440416394)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13224131317416395)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13224314531416395)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100004)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13224556034416395)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100004)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13224726026416395)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100004)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13224918151416395)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13225181062416395)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100004)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13225379377416395)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13225570371416395)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13225777900416395)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100004)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13225902224416395)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100004)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13226124847416395)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13226379266416395)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100004)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13226571382416395)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13226725825416395)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100004)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13226921267416395)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100004)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13227112710416395)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13227386387416395)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100004)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13227522014416395)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13227759400416395)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100004)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13227929623416395)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100004)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13228104956416396)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100004)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13228303005416396)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100004)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13228502719416396)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100004)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13228754023416396)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100004)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13228949551416396)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100004)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13229131527416396)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13229314031416398)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13229598055416398)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100004)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13229705908416398)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13229954873416398)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13230177428416399)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100004)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13230307622416399)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13230503976416399)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100004)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13230715899416399)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13230974631416399)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100004)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13231108328416399)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100004)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13231327094416399)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13231568315416400)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13231788255416400)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100004)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13231955100416400)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100004)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13232170571416400)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100004)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13232361701416400)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13232526320416400)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100004)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13232705790416400)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100004)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13232950000416400)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100004)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13233104912416400)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100004)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13233304777416400)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13233566200416401)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100004)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13233714145416401)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13233958850416401)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13234130981416401)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100004)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13234393312416401)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13234520540416401)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13234716042416401)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13234998063416401)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100004)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13235126004416401)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100004)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13235335246416401)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100004)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13235581741416401)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13235756406416401)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13235950528416401)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100004)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13236115338416401)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13236325704416401)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100004)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13236520432416402)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13236773467416402)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13236901591416402)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13237156423416402)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100004)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13237332927416402)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13237555159416402)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13237736532416402)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13237998059416402)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100004)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13238137409416402)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100004)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13238300171416402)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13238568964416402)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13238753984416402)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100004)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13238971348416402)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100004)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13239186821416402)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100004)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13239340438416402)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100004)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13239587218416402)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100004)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13239705248416402)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100004)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13239974560416403)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13240106565416403)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100004)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13240360578416403)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100004)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13240529404416403)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13240745894416403)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100004)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13240950407416403)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100004)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13241155205416403)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13241391483416403)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100004)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13241595044416403)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100004)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13241765515416403)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13241933475416403)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100004)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13242181270416403)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100004)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13242353633416403)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100004)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13242586203416403)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13242799435416403)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100004)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13242950932416403)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13243194574416403)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13243381892416403)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13243506366416403)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100004)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13243792416416403)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100004)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13243955798416404)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13244122554416404)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13244315109416404)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100004)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13244532703416404)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100004)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13244747329416404)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13244971502416404)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100004)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13245179047416404)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13245382305416404)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13245573891416404)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100004)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13245762404416404)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13245923147416404)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100004)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13246161694416404)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13246392779416404)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100004)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13246521907416404)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100004)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13246729765416404)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13246961488416404)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100004)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13247149666416404)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100004)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13247339847416404)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100004)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13247575792416407)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13247726451416407)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13247931862416407)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13248185790416407)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13248353468416407)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100004)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13248589639416407)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100004)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13248750522416407)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100004)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13248960979416407)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13249183891416408)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100004)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13249394481416408)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13249565513416408)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13249747265416408)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13249999676416408)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100004)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13250180021416408)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100004)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13250377755416408)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100004)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13250572885416409)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100004)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13250719665416409)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100004)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13250942595416409)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13251118881416409)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13251382929416409)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13251570394416409)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100004)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13251735772416409)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13251986846416409)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13252190944416409)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100004)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13252394090416409)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13252550613416409)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100004)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13252728051416409)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13252969730416409)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13253122915416409)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100004)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13253321097416410)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13253559692416410)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13253799542416410)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13253963574416410)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100004)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13254151961416410)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13254373800416410)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100004)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13254518105416410)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100004)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13254764697416410)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100004)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13254954077416411)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13255119886416411)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13255319147416411)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13255509359416411)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13255744911416411)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100004)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13255947929416411)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13256140529416411)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13256348463416411)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100004)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13256511048416411)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13256783056416411)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100004)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13256908905416412)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100004)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13257160390416412)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100004)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13257356359416412)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13257577943416412)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13257711442416412)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100004)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13257910858416412)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100004)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13258132706416413)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13258305654416413)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13258500206416413)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13258793917416413)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100004)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13258957493416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13259126193416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13259336411416413)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100004)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13259532486416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13259778028416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100004)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13259929095416413)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100004)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13260115771416413)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100004)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13260348660416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13260572365416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13260760492416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100004)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13260938309416413)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100004)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13261183848416414)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100004)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13261315167416414)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100004)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13261538295416414)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100004)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13261700659416414)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13261946858416414)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13262176806416414)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13262371878416414)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13262515873416414)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100004)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13262764462416414)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100004)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13262935391416414)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13263185517416414)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100004)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13263365825416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100004)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13263538687416415)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100004)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13263728680416415)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13263933868416415)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100004)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13264110756416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13264321408416415)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100004)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13264561914416415)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100004)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13264716604416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100004)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13264932354416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100004)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13265119984416415)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100004)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13265337007416415)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100004)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13265515517416415)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13265717992416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100004)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13265942946416415)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13266113558416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100004)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13266392017416415)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100004)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13266533433416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100004)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13266728595416415)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100004)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13266955109416415)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100004)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13267158564416417)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13267334491416417)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13267596971416417)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100004)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13267790310416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13267933384416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13268173734416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13268351670416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13268585770416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13268754615416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13268927943416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13269111304416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100004)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13269371972416417)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13269570145416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13269725592416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13269973042416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13270127867416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100004)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13270355062416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13270554048416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13270754571416418)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13270984325416419)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13271145461416419)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13271356102416419)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13271551121416419)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13271728196416419)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100004)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13271981692416419)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13272105836416420)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100004)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13272348672416420)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100004)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13272529392416420)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100004)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13272725437416420)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100004)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13272971535416420)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13273169663416420)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100004)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13273321976416420)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13273510925416420)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13273794343416420)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100004)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13273979006416420)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100004)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13274133925416420)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100004)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13274329464416420)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100004)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13274535450416420)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13274709787416420)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13274971912416420)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100004)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13275182667416420)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100004)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13275393652416420)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100004)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13275561143416420)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100004)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13275707655416420)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13275905374416421)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100004)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13276173321416421)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100004)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13276378006416421)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100004)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13276556093416421)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13276745453416421)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13276949118416421)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13277151811416421)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100004)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13277350308416421)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100004)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13277553384416421)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13277742450416421)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100004)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13277928114416421)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100004)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13278142127416421)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13278393796416421)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13278503409416421)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13278764431416421)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13278914059416421)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13279191510416421)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13279375412416421)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100004)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13279523203416421)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100004)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13279771647416422)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13279972870416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100004)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13280105667416422)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13280338643416422)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100004)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13280529174416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100004)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13280719922416422)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13280948958416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100004)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13281138119416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100004)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13281394103416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100004)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13281541348416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13281790146416422)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13281913802416422)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13282137125416422)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100004)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13282355297416422)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100004)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13282539935416422)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13282710823416422)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13282985510416422)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13283148141416422)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13283363420416423)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13283525969416423)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13283763301416423)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13283941544416423)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13284102731416423)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13284372013416423)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100004)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13284549656416423)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100004)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13284781193416425)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100004)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13284912475416425)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100004)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13285178924416425)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100004)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13285310263416425)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100004)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13285525707416425)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100004)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13285794152416425)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13285939988416425)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100004)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13286123971416425)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100004)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13286357036416426)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100004)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13286552434416426)
,p_page_id=>5
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100004)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13286755229416426)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100004)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13286959653416426)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100004)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13287191041416426)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13287312393416426)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13287556997416426)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100004)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13287730702416426)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100004)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13287900249416426)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100004)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13288186178416426)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100004)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13288350950416426)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13288574676416426)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100004)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13288607621416426)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100004)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13288899645416426)
,p_page_id=>37
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100004)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13289028762416426)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13289247383416426)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13289421393416426)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13289633514416426)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100004)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13289851961416426)
,p_page_id=>33
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100004)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13290001408416426)
,p_page_id=>11
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13290258668416426)
,p_page_id=>39
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100004)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13290418980416426)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100004)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13290682996416427)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100004)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13290806754416427)
,p_page_id=>50
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100004)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13291034914416427)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100004)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13291242582416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100004)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13291499035416427)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100004)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13291631841416427)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13291807923416427)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100004)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13292001964416427)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100004)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13292203753416427)
,p_page_id=>4
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100004)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13292448126416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100004)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13292658797416427)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13292805977416427)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100004)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13293009583416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100004)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13293284522416427)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13293461415416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100004)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13293661764416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100004)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13293876643416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100004)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13294055820416427)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100004)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13294233670416427)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100004)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13294402306416427)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13294664730416428)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100004)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13294801059416428)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100004)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13295030592416428)
,p_page_id=>13
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100004)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13295252431416428)
,p_page_id=>38
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13295425113416428)
,p_page_id=>1
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100004)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13295691722416428)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100004)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13295887992416428)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13296001941416428)
,p_page_id=>14
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100004)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13296242253416428)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100004)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13296404565416428)
,p_page_id=>30
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100004)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13296662112416428)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100004)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13296880283416428)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100004)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13297004801416430)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13297235176416430)
,p_page_id=>51
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100004)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13297497429416430)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13297624130416431)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13297807050416431)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13298012355416431)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13298217266416431)
,p_page_id=>31
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100004)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13298478594416431)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13298698383416431)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13298854202416431)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13299026862416431)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13299212381416431)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13299402309416432)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13299603430416432)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13299894671416432)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13300026515416432)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13300228580416432)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13300440402416432)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13300616866416432)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13300813383416432)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13301057588416433)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13301261435416433)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13301427974416433)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13301644176416433)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13301868810416433)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13302033982416433)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13302215950416433)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13302407506416433)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13302695126416433)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13302813101416434)
,p_page_id=>6
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100004)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13303012377416434)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13303261963416435)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13303449328416435)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13303689039416435)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13303840664416435)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13304048224416435)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13304262219416435)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13304449241416435)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13304616587416436)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13304886294416436)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13305062263416436)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13305211335416436)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13305471000416436)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13305693230416436)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13305867926416436)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13306001643416436)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13306221334416437)
,p_page_id=>20
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100004)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13306468445416437)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13306658051416437)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13306819250416437)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13307025366416437)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13307211578416437)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13307456131416438)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100004)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13307690896416438)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100004)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13307824955416438)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100004)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13308056618416438)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100004)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13308254951416438)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100004)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13308486275416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100004)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13308606887416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100004)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13308802300416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100004)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13309026121416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100004)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13309203353416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100004)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edition, Lizenzinformationen'
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13309402583416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100004)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13309696127416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100004)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13309858300416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100004)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13310047013416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100004)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13310251104416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13310424783416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100004)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13310675301416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100004)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13310889591416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100004)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13311091942416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100004)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13311254587416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100004)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13311414141416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100004)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13311628419416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100004)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13311887457416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100004)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13312027385416439)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100004)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13312216100416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100004)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13312429122416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100004)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13312669482416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100004)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13312877648416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100004)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13313084259416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100004)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13313243499416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100004)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13313413133416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100004)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13313635504416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100004)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13313802544416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100004)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13314050793416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100004)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13314205621416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13314484836416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100004)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13314688547416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100004)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13314841079416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13315045042416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100004)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13315248104416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13315439670416440)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100004)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13315634633416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100004)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13315877975416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100004)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13316035337416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100004)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13316262030416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100004)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13316449363416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100004)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13316640776416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100004)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13316856534416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100004)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13317033992416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100004)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13317205429416441)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100004)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13317488156416443)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13317681461416443)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Benutzername'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13317837361416444)
,p_page_id=>9999
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100004)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passwort'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13318094510416444)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13318273490416444)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13318489030416444)
,p_page_id=>12
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100004)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13318652883416444)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100004)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13318889217416446)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - Erfasst keine Benutzerinformationen zu dem Schritt	</li>',
'    <li><strong>disabled</strong> (Standard) - Erfasst die Benutzer-ID des Prozessschritts, so diese der Ablauf-Engine bekannt ist	</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13319048020416446)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Muss auf Ihren Standard E-Mail-Absender gesetzt werden, falls f\00FCr ausgehende E-Mails kein Absender definiert ist.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13319274802416446)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Der Benutzername, der in der APEX-Session als Benutzer verwendet werden soll, um eine Session zu erstellen, wenn kein anderer Benutzername angegeben wird'
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13319482968416446)
,p_page_id=>7
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100004)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zugeh\00F6rige Prozess-Instanzen l\00F6schen')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13319673990416446)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100004)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bei leerem Eintrag wird die Aufgabe f\00FCr den aktuellen Benutzer (app_user) reserviert.')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13319835866416446)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bei Zyklus-Timern wird dadurch die maximale Anzahl der Ausf\00FChrungen definiert.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13320017677416446)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100004)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erforderliches Format: YYYY-MM-DD HH24:MI:SS TZR'
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13320220704416446)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Verwenden Sie diese Option nur, um Anwendungen zu unterst\00FCtzen, die mit Flows for APEX 21.1 und niedriger entwickelt wurden, ohne dass zus\00E4tzliche Entwicklung erforderlich ist. Die Engine verwendet die Step-Keys nich')
||'t, um doppelte Aktionen in einem einzelnen Schritt zu verhindern.</li>',
unistr('    <li><strong>strict</strong> (empfohlen) - Verwenden Sie diese Option f\00FCr neue Entwicklungs- und/oder vollst\00E4ndig migrierte Anwendungen. Die Engine verwendet den Step-Key, um doppelte Aktionen in einem einzelnen Schritt zu vermeiden.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13320480349416446)
,p_page_id=>2
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100004)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Im Falle einer Kopie eines einzelnen Modells, erh\00E4lt das Modell den angegebenen Namen. Bei Auswahl mehrerer Zeilen erhalten die Kopien den angegeben Namen als Suffix.')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13320690451416446)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Sprache f\00FCr die Anzeige von Fehlermeldungen und Logereignissen.')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13320861255416446)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Verwenden Sie diese Option nur, um Anwendungen zu unterst\00FCtzen, die mit Flows for APEX 21.1 und niedriger entwickelt wurden, ohne dass zus\00E4tzliche Entwicklung erforderlich ist. Die Engine verwendet die Step-Keys nich')
||'t, um doppelte Aktionen in einem einzelnen Schritt zu verhindern.</li>',
unistr('    <li><strong>strict</strong> (empfohlen) - Verwenden Sie diese Option f\00FCr neue Entwicklungs- und/oder vollst\00E4ndig migrierte Anwendungen. Die Engine verwendet den Step-Key, um doppelte Aktionen in einem einzelnen Schritt zu vermeiden.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13321049204416446)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100004)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - Logging ist deaktiviert	</li>',
'    <li><strong>standard</strong> (default) - Instanzereignisse protokollieren</li>',
'    <li><strong>secure</strong> - Loggt Modellereignisse und Instanzereignisse	</li>',
'    <li><strong>full</strong> - Loggt Modell-, Instanz- und Prozessvariablenereignisse		</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13321291019416446)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Die Anwendungs-ID einer Ihrer APEX-Anwendungen, die zum Erstellen einer Session bereitgestellt wird'
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13321478420416446)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Die Seiten-ID einer Ihrer Apps, die zum Erstellen einer Session bereitgestellt werden'
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13321637677416447)
,p_page_id=>36
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100004)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Bei Zyklus-Timern wird dadurch die maximale Anzahl der Ausf\00FChrungen definiert.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13321838237416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Muss auf Ihren Standard-APEX-Workspace f\00FCr Flows for APEX festgelegt werden. Wird als letztes Resort f\00FCr scriptTasks und serviceTasks beim Erstellen einer APEX-Session oder beim Suchen nach E-Mail-Vorlagen verwendet')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13322001847416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - Erfasst keine Benutzerinformationen zu dem Schritt	</li>',
'    <li><strong>disabled</strong> (Standard) - Erfasst die Benutzer-ID des Prozessschritts, so diese der Ablauf-Engine bekannt ist	</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13322283597416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Der Benutzername, der in der APEX-Session als Benutzer verwendet werden soll, um eine Session zu erstellen, wenn kein anderer Benutzername angegeben wird'
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13322453501416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100004)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (default) - verhindert die Bearbeitung des Diagramms f\00FCr ver\00F6ffentlichte Modelle</li>'),
unistr('    <li><strong>development</strong> - erm\00F6glicht die Bearbeitung des Diagramms f\00FCr ver\00F6ffentlichte Modelle</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13322622572416447)
,p_page_id=>32
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100004)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Sprache f\00FCr die Anzeige von Fehlermeldungen und Logereignissen.')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13322801039416447)
,p_page_id=>34
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100004)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (default) - verhindert die Bearbeitung des Diagramms f\00FCr ver\00F6ffentlichte Modelle</li>'),
unistr('    <li><strong>development</strong> - erm\00F6glicht die Bearbeitung des Diagramms f\00FCr ver\00F6ffentlichte Modelle</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13323020872416447)
,p_page_id=>35
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100004)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Muss auf Ihren Standard-APEX-Workspace f\00FCr Flows for APEX festgelegt werden. Wird als letztes Resort f\00FCr scriptTasks und serviceTasks beim Erstellen einer APEX-Session oder bei der Suche nach Mailvorlagen verwendet.')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13323265166416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anwendungs-ID einer Ihrer APEX-Apps, die zum Erstellen einer Session bereitgestellt wird'
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13323450031416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100004)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - Logging ist deaktiviert	</li>',
'    <li><strong>standard</strong> (default) - Instanzereignisse protokollieren</li>',
'    <li><strong>secure</strong> - Protokolliert Modellereignisse und Instanzereignisse	</li>',
'    <li><strong>full</strong> - Loggt Modell-, Instanz- und Prozessvariablenereignisse		</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13323610947416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100004)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'die Seiten-ID einer Ihrer Apps, die zum Erstellen einer Session bereitgestellt werden'
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13323852431416447)
,p_page_id=>100
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100004)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Muss auf Ihren Standard-E-Mail-Absender gesetzt werden, falls f\00FCr ausgehende E-Mails kein Absender definiert ist.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13324084214416448)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100004)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzen'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13324294842416448)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzen'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13324404096416448)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sek'
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13324652401416449)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100004)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13324806730416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzfehler'
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13325012448416449)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fehler'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13325231326416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Max.'
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13325409257416449)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100004)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-Max'
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13325607066416449)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fehler'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13325843850416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzen gestartet'
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13326000062416449)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-90pc'
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13326221480416449)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-10pc'
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13326411923416449)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100004)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13326618635416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instanzen beendet'
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13326851100416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dauer 90 Prozent'
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13327040199416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100004)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 Perzentil'
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13327210550416449)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'50-Perzentil'
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13327476852416449)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100004)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13327684123416449)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100004)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reihe 1'
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13327866148416450)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100004)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erstellt'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13328024030416450)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100004)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13328293373416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13328442898416450)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100004)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestartet'
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13328689115416450)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100004)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Serie 1'
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13328826113416450)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'90-Perzentil'
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13329091946416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-50pc'
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13329287521416450)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100004)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Wird ausgef\00FChrt')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13329427861416450)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100004)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13329613358416450)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abgeschlossen'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13329887694416450)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Beendet'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13330064182416450)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abgeschlossene Instanzen'
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13330296044416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13330418079416450)
,p_page_id=>16
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100004)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mediandauer'
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13330697222416450)
,p_page_id=>3
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100004)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13330890284416450)
,p_page_id=>15
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100004)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Zur\00FCcksetzen')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13331046355416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100004)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13331281516416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13331481891416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100004)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dauer - Max.'
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13331607079416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-Max'
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13331894642416450)
,p_page_id=>17
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100004)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13332063046416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100004)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13332276888416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100004)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13332432224416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100004)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kategorie'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13332630065416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100004)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13332826766416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100004)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13333096157416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100004)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13333227073416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100004)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Kategorie'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13333497894416452)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100004)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13333605591416453)
,p_translated_flow_id=>100004
,p_translate_to_id=>100.100004
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13333815377416454)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100004)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Fehler beim Archivieren der t\00E4glichen Instanz\00FCbersicht')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13334070638416454)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100004)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Fehler beim L\00F6schen von Flows for APEX-Statistik\00FCbersichten')
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13334285787416454)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100004)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - Fehler beim L\00F6schen von Logtabellen.')
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13334464322416454)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100004)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Fehler beim Erfassen der t\00E4glichen Flows for APEX-Statistiken')
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13334639631416454)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Aufgaben Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiiert von &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
unistr('            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">F\00E4llig &DUE_IN.</strong>'),
'        {when NEXT_HOUR/}',
unistr('            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">F\00E4llig &DUE_IN.</strong>'),
'        {when NEXT_24_HOURS/}',
unistr('            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">F\00E4llig &DUE_IN.</span>'),
'        {otherwise/}',
unistr('            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>F\00E4llig &DUE_IN.</span>{endif/}'),
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Dringend</strong>',
'        {when 2/}',
unistr('            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Hohe Priorit\00E4t</span>'),
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13334858186416455)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Genehmigen'
,p_translate_from_text=>'Approve'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13335004347416455)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100004)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13335292068416456)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>6.100006
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13335420911416456)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>50.100006
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelli form semplici'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13335694957416456)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>14.100006
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Log'
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13335811998416456)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>51.100006
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifica modello form semplice'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13336008076416456)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>1.100006
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Introduzione'
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13336275198416457)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>7.100006
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso'
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13336479213416457)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>15.100006
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche giornaliere'
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13336601098416457)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>31.100006
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13336879344416457)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>36.100006
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Timer'
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13337076816416457)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>34.100006
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Applicazione motore'
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13337214033416457)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>11.100006
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea istanza flusso'
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13337465321416457)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>30.100006
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - REST'
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13337609308416457)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>2.100006
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestione del flusso'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13337810858416457)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>8.100006
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dettagli istanza flusso'
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13338099986416457)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>12.100006
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visualizzatore'
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13338240725416457)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>17.100006
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche task'
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13338443625416457)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>37.100006
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Statistiche'
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13338662467416457)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>4.100006
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modeler di flusso'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13338879364416457)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>5.100006
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esporta'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13339008565416457)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>10.100006
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Controllo flusso'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13339232077416457)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>35.100006
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Motore'
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13339444026416457)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>33.100006
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Archiviazione'
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13339686658416457)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>3.100006
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pannello'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13339832392416457)
,p_page_id=>9
,p_translated_flow_id=>100006
,p_translate_to_id=>9.100006
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13340007889416457)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>20.100006
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sequenza temporale istanza - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13340215959416458)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>38.100006
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Ubicazione'
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13340432781416458)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>13.100006
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dettagli oggetto'
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13340686471416458)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>39.100006
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Licenza'
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13340882997416458)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>16.100006
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche processo'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13341087336416458)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>32.100006
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Registrazione'
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13341268566416458)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>100.100006
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione [OLD,BACKUP]'
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13341460664416458)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>9999.100006
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pagina di login'
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13341690220416459)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>6.100006
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa - &APP_NAME_TITLE.'
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13341850459416459)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>50.100006
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelli form semplici'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13342080561416459)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>51.100006
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifica modello form semplice'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13342263233416459)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>1.100006
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Guida introduttiva - &APP_NAME_TITLE.'
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13342434526416459)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>7.100006
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13342667754416460)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>15.100006
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche giornaliere'
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13342848302416460)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>31.100006
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13343049063416460)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>36.100006
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Timer'
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13343232215416460)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>34.100006
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Applicazione motore'
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13343462314416460)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>11.100006
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea istanza flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13343661703416460)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>30.100006
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - REST'
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13343837805416460)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>2.100006
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestione flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13344010148416460)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>8.100006
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dettagli istanza flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13344246057416460)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>12.100006
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13344484496416460)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>17.100006
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche task'
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13344698790416460)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>37.100006
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Statistiche'
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13344820623416460)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>4.100006
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modeler flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13345017873416460)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>5.100006
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esporta - &APP_NAME_TITLE.'
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13345255801416460)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>10.100006
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor flusso - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13345495748416460)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>35.100006
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Motore'
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13345602986416460)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>33.100006
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Archiviazione'
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13345810378416460)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>3.100006
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dashboard - &APP_NAME_TITLE.'
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13346023660416460)
,p_page_id=>9
,p_translated_flow_id=>100006
,p_translate_to_id=>9.100006
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13346279695416460)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>20.100006
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sequenza temporale istanza - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13346400955416461)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>38.100006
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Ubicazione'
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13346697283416461)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>39.100006
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Licenza'
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13346837350416461)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>16.100006
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche processo'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13347051693416461)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>32.100006
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Registrazione'
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13347257547416461)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>100.100006
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione [OLD,BACKUP]'
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13347450178416461)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>9999.100006
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13347607453416462)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100006)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seleziona tutto'
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13347895104416462)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100006)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Imposta instradamento gateway'
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13348092070416462)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100006)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13348222389416462)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100006)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13348431831416462)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13348679279416463)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100006)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Deseleziona tutto'
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13348825825416463)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiungi'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13349060671416463)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100006)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Imposta variabile processo'
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13349268764416463)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100006)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13349406040416463)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100006)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione REST'
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13349689864416463)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13349831147416463)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100006)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa e modifica'
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13350003350416463)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100006)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13350292196416463)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100006)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13350419359416463)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuova versione'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13350645495416463)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100006)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13350886837416463)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13351099231416463)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ricevi messaggio'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13351230775416463)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100006)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13351489768416463)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100006)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13351675433416463)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13351894011416463)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100006)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13352027482416463)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100006)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13352209089416463)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100006)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea modello'
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13352430116416463)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100006)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13352668604416464)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100006)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Salva'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13352847173416464)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100006)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13353098048416464)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100006)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa e importa un altro'
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13353271887416464)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100006)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13353451610416464)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copia modello'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13353622997416464)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100006)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13353886204416464)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100006)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13354068835416464)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Accedi'
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13354280783416464)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100006)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13354451142416464)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100006)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione REST'
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13354673622416464)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rilascio'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13354841184416464)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea modello'
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13355081605416464)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100006)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifica diagramma'
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13355237161416464)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100006)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13355478687416464)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100006)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiungi versione'
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13355695430416464)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13355825077416464)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13356073310416464)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100006)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13356217313416465)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivio'
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13356482489416465)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13356673108416465)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100006)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13356872636416465)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100006)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13357010694416465)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100006)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13357276146416465)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esporta'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13357414680416465)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100006)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra cronologia'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13357620980416465)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100006)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13357851170416465)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea istanza'
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13358041535416465)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100006)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13358260576416465)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100006)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13358482960416465)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100006)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13358669806416465)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100006)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13358840181416465)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100006)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13359020040416465)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rendi non pi\00F9 valido')
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13359200902416465)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenota'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13359415472416465)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100006)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiungi versione'
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13359623477416465)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100006)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13359830123416466)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifica configurazione'
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13360013680416466)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100006)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13360221503416466)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applica modifiche'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13360415126416466)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rischedula timer'
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13360642733416466)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13360818316416466)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100006)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13361015866416466)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100006)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conferma'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13361267716416466)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100006)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifica configurazione'
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13361468869416466)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100006)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiungi'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13361641420416466)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100006)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crea'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13361864216416466)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100006)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Annulla'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13362062489416466)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conferma'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13362229418416466)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100006)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13362435490416466)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100006)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13362651214416466)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100006)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Salva'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13362860661416469)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100006)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13363024452416470)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nascondi ID utente'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13363254889416470)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colonna ID'
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13363473824416470)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chiave licenza'
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13363613333416470)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colonna indicatore orario'
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13363860690416470)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL di base'
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13364071333416470)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100006)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuova versione'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13364211789416470)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload'
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13364462292416470)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100006)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Connessione'
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13364638041416470)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mittente e-mail predefinito'
,p_translate_from_text=>'Default Email Sender'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13364841382416470)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13365077557416470)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma chiamante'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13365253787416470)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13365425873416470)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome utente predefinito'
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13365644136416470)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso secondario'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13365839363416470)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13366049241416470)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Intervallo ripetizione timer'
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13366250475416470)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome file'
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13366441576416470)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passo'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13366678876416470)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome bucket'
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13366896006416471)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100006)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edizione licenza'
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13367008351416471)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100006)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa da'
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13367272737416471)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Operazione'
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13367452138416471)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13367602782416471)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13367891158416471)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prefisso documento'
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13368005740416471)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13368200158416471)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuovo'
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13368414336416471)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100006)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Forza sovrascrittura'
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13368686736416471)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenotazione'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13368868454416471)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Numero massimo cicli timer'
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13369075209416471)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13369209891416471)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13369477220416471)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eseguito da'
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13369615101416471)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome tabella'
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13369895070416471)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Includi data ultima modifica'
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13370019440416471)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13370234906416471)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100006)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gateway'
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13370417379416471)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mantieni sintetici mensili (mesi)'
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13370680652416471)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conservazione del log del flusso di messaggi (giorni)'
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13370840561416472)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100006)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'A cascata'
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13371094771416472)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100006)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13371247604416472)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello processo'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13371428423416472)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13371683297416472)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Password'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13371834501416472)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conserva log (giorni)'
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13372084619416472)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13372282260416472)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma XML'
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13372428955416472)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Includi versione'
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13372602935416472)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'File'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13372872772416472)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rischedula timer alle'
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13373042117416472)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posizione archivio istanze'
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13373255198416472)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13373431308416472)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scarica come'
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13373601218416472)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13373875155416472)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabile processo'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13374039592416472)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Segreto client'
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13374235505416473)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prevenzione passi duplicati'
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13374462078416473)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuovo nome/suffisso'
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13374615123416473)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statico delle credenziali APEX'
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13374879968416473)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lingua'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13375001548416473)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statico'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13375208511416473)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100006)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Proprietario'
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13375444171416473)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Con licenza - A'
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13375606959416473)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prevenzione passi duplicati'
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13375865383416473)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13376097440416473)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID applicazione predefinito'
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13376255246416473)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID pagina predefinito'
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13376411027416473)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome utente'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13376679781416473)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ambito'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13376859266416473)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Riferimento aziendale (variabile processo)'
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13377066707416473)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Includi categoria'
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13377262136416473)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registra in entrata MessageFlow'
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13377435379416473)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100006)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Numero massimo cicli timer'
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13377651464416473)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di destinazione'
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13377807579416473)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13378048861416473)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modalit\00E0')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13378293722416473)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Incolla contenuto file BPMN (massimo 30.000 caratteri)'
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13378421768416473)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Area di lavoro predefinita'
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13378652477416474)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mantieni sintetici giornalieri (giorni)'
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13378847348416474)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nascondi ID utente'
,p_translate_from_text=>'Hide User ID'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13379028259416474)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registra in entrata MessageFlow (non ancora implementato)'
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13379236951416474)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mantieni log (giorni dopo completamento istanza processo)'
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13379467955416474)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome utente predefinito'
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13379624422416474)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statico delle credenziali APEX'
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13379807996416474)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer abilitati'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13380054872416474)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colonna BLOB'
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13380235585416474)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100006)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data scadenza licenza'
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13380400838416474)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13380602965416474)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Effettua chiamate Rest in entrata'
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13380841806416474)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI di reindirizzamento'
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13381010189416474)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL pre-autenticazione'
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13381204968416474)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100006)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modalit\00E0')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13381410037416474)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mantieni log (giorni dopo completamento istanza processo)'
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13381653485416474)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI supporto'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13381875266416474)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Includi stato'
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13382020873416474)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13382214834416474)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100006)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lingua'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13382414395416475)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prefisso documento'
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13382693434416475)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abilita archiviazione sintetico istanze'
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13382828739416475)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13383099302416475)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID applicazione predefinito'
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13383276977416475)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13383489059416475)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100006)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modalit\00E0')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13383617135416475)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Memorizza nome utente'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13383808050416475)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modello'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13384032259416475)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Area di lavoro predefinita'
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13384242459416475)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rischedula ora il timer'
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13384411547416475)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Conservazione del log del flusso di messaggi (giorni)'
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13384645890416475)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modello'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13384886674416475)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descrizione'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13385054463416475)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13385299901416475)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13385440715416475)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mantieni sintetici trimestrali (mesi)'
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13385690344416475)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabile Nome'
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13385815115416475)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID client'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13386031124416475)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID pagina predefinito'
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13386282439416475)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100006)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL di base'
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13386413067416476)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Email per il supporto'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13386695949416476)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer abilitati'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13386860826416476)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13387028770416476)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100006)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuova versione'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13387295879416476)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13387442772416476)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cerca'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13387678416416476)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100006)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13387817427416476)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Abilita archiviazione sintetico istanze'
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13388068445416476)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mittente e-mail predefinito'
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13388261866416481)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100006)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Formato JSON non valido'
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13388413568416481)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100006)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve avere un valore.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13388662397416482)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100006)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Controllare il flusso fornito.'
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13388819438416482)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve avere un valore.'
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13389086429416482)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100006)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve avere un valore.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13389275544416482)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve avere un valore.'
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13389465402416482)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Impossibile archiviare un modello associato a istanze in esecuzione.'
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13389678453416482)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100006)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Incollare il contenuto del file BPMN'
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13389839225416482)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100006)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Selezionare un numero #LABEL.'
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13390060961416482)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Il modello esiste gi\00E0. Usa sovrascrittura forzata.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13390226903416483)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Il modello esiste gi\00E0. Usa sovrascrittura forzata.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13390446857416483)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modello importato.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13390689195416483)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100006)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13390802723416483)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100006)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13391047337416483)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100006)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13391250191416483)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100006)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13391421852416483)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100006)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13391616733416483)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100006)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione Rest salvata.'
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13391869897416483)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13392084823416483)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100006)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13392229657416483)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100006)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13392426319416483)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100006)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13392684927416483)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100006)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Azione elaborata.'
,p_translate_from_text=>'Action processed.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13392848535416483)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100006)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13393024733416483)
,p_page_id=>9
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100006)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifiche salvate.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13393224240416484)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modello importato.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13393489675416484)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100006)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventi istanza'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13393680009416485)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100006)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Motore'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13393875115416485)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100006)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Dettagli istanza'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13394010447416485)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100006)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventi istanza'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13394243027416485)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100006)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Client OAUTH'
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13394456988416485)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100006)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13394694786416485)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100006)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13394855662416485)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100006)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13395032346416485)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100006)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configurazione - REST - Client'
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13395292066416485)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100006)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13395406069416485)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Prestazioni processo (sintetici periodo)'
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13395695764416485)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100006)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flussi secondari correnti'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13395887368416485)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100006)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Barra dei pulsanti'
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13396064072416485)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100006)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variabile Cronologia'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13396208030416485)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100006)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configurazione JSON'
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13396438949416485)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100006)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13396605636416485)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventi passo'
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13396875138416485)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Modelli form semplici'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13397068369416485)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100006)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13397299345416485)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze flusso per stato'
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13397438647416485)
,p_page_id=>9
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100006)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Sezioni'
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13397682589416486)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100006)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Passi completati'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13397855353416486)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Cerca'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13398080066416486)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Dettagli diagramma'
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13398291754416486)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Sottoscrizioni ai messaggi'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13398494599416486)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100006)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagrammi chiamati'
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13398638364416486)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100006)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13398884189416486)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100006)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13399084789416486)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100006)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Introduzione'
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13399290249416486)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanza flusso'
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13399440481416486)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Crea istanza flusso'
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13399694364416486)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100006)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'La versione non corrisponde'
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13399824891416486)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100006)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Importa flusso'
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13400084127416486)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100006)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13400234599416486)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Prerequisiti mancanti'
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13400482971416486)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100006)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Pulsanti'
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13400668777416486)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100006)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Nuova versione'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13400804614416486)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100006)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Risultati ricerca'
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13401074253416486)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100006)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Applicazione motore'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13401249613416487)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100006)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Statistiche'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13401400294416487)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100006)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Applicazione motore'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13401632796416487)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Errori istanza negli ultimi 14 giorni'
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13401872258416487)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100006)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configurazione JSON'
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13402064987416487)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100006)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13402246263416487)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visualizzatore flusso'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13402432372416487)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100006)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attributi'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13402622564416487)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ubicazione'
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13402823992416487)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100006)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Opzioni'
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13403074872416487)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100006)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aggiungi instradamento gateway'
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13403273759416487)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100006)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagramma chiamato'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13403427776416487)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100006)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Motore'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13403616545416487)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100006)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Collegamenti'
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13403821444416487)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13404067275416487)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13404297630416487)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13404403875416487)
,p_page_id=>9
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100006)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13404612844416487)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Modulo mancante'
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13404897949416487)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13405034020416487)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13405212717416488)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100006)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze flusso'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13405424169416488)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Contenitore pulsanti'
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13405671292416488)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100006)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13405807079416488)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Copia modello'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13406041153416488)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ultimo errore'
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13406217550416488)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100006)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tempi di attesa passo storico per &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13406400377416488)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100006)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attributi'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13406616741416488)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100006)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flussi secondari completati'
,p_translate_from_text=>'Completed Subflows'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13406807006416488)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100006)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Passi correnti'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13407062528416488)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visualizzatore flusso'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13407244292416488)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100006)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Registrazione'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13407407553416488)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100006)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Archiviazione'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13407659582416488)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100006)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Gestione del flusso'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13407833820416488)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100006)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13408019431416488)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100006)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13408217086416488)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100006)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13408401429416488)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100006)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13408656044416488)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagrammi Chiamanti'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13408838075416488)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100006)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Licenza'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13409059049416488)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13409233342416489)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100006)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13409450385416489)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100006)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13409681878416489)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Non abilitato per REST'
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13409885626416489)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Scheda'
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13410034456416489)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100006)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Prestazioni passo storico per &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13410272152416489)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ruoli'
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13410421423416489)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100006)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Avvertenza importazione'
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13410609006416489)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Dettagli istanza'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13410868091416489)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100006)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13411086433416489)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13411269939416489)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Dettagli istanza'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13411492548416489)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100006)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variabile Cronologia'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13411612703416489)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Configurazione'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13411802812416489)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100006)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13412046272416489)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100006)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze flusso scaduto corrente'
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13412216563416489)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100006)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13412497248416489)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Informazioni'
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13412682244416489)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100006)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13412893592416489)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13413095603416489)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100006)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13413233300416490)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100006)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Processi avviati il &P15_DATE.'
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13413422421416490)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100006)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Passo di installazione aggiuntivo non completato'
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13413616683416490)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100006)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Modifica modello form semplice'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13413899441416490)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100006)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13414076937416490)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100006)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventi istanza'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13414215973416490)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100006)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13414433464416490)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100006)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Prestazioni passo task (mese corrente) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13414636014416490)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Errori passo'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13414854619416490)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flusso XML'
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13415085757416490)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100006)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variabili di entrata/uscita'
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13415287233416490)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Compila i dettagli'
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13415411925416490)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100006)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Nuova versione'
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13415633483416490)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100006)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variabili'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13415835008416490)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100006)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13416048217416490)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100006)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13416234466416490)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100006)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze processo per stato'
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13416407819416490)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100006)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Elimina modello'
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13416680222416490)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100006)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13416822949416490)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Scegliere la destinazione attiva'
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13417022149416490)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100006)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze flusso per modello - Prime 10'
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13417259473416490)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100006)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Passo Prenotazione'
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13417445714416491)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100006)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aggiungi/Modifica variabile processo'
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13417607010416491)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13417814588416491)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Indicatore di percorso'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13418083265416491)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100006)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze di flusso create negli ultimi 7 giorni'
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13418264581416491)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13418490986416491)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100006)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flussi secondari'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13418654264416491)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timer disabilitati'
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13418848309416491)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100006)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13419074834416491)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Rischedula timer'
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13419205653416491)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Rilevato upgrade APEX'
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13419470033416491)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13419678151416491)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Introduzione'
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13419876362416491)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Attributi'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13420049383416491)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100006)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Istanze di processo associate'
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13420230623416491)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13420411908416491)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100006)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13420626483416491)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Monitor flusso (&P12_PRCS_NAME)'
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13420806223416492)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Selettore lingua'
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13421074616416492)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100006)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Pulsanti'
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13421217683416492)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100006)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Registrazione'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13421419161416492)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visualizzatore flusso'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13421643314416492)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13421852215416492)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Ricevi messaggio'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13422048900416492)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Menu Azione'
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13422260363416492)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Errori'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13422422887416492)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Contenuto'
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13422693585416498)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100006)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13422810550416498)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13423068726416498)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13423266553416499)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100006)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13423440725416499)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100006)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13423621701416499)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13423804321416499)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13424036260416499)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100006)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13424297172416499)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100006)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13424445730416499)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100006)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13424616169416499)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13424886357416499)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100006)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13425006184416499)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<li>Modulo REST non installato. Seguire la guida di installazione all''indirizzo: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13425249410416499)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13425434340416499)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100006)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13425629785416499)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100006)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C8 consigliabile importare modelli creati utilizzando Flows for APEX per assicurarsi che possano essere eseguiti dal motore.')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13425821058416499)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<li>Schema non abilitato per REST</li>'
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13426028531416500)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13426261453416500)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100006)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13426473722416500)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100006)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13426681589416500)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100006)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Per utilizzare la funzione Timers di Flows for APEX, \00E8 necessario completare un passo di installazione aggiuntivo che pu\00F2 essere trovato <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" ta')
||'rget="_blank">qui</a>.'
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13426827629416500)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100006)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13427073804416500)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100006)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13427238785416500)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('I modelli contenenti uno o pi\00F9 timer non possono funzionare correttamente su questo sistema perch\00E9 sono disabilitati.<br>\00C8 possibile abilitarlo nella pagina Configurazione.')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13427466516416500)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13427633982416500)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100006)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13427827350416500)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100006)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13428050469416500)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>Un sistema di flusso di processo basato su BPMN a basso codice per APEX.</h3> <h4> Funzioni</h4>',
'<ul>',
'<li>Flows for APEX consente agli sviluppatori APEX di modellare ed eseguire flussi di processo in APEX utilizzando una combinazione di progettazione visiva dei processi e tecniche low-code.</li> <li>Progettato principalmente per gli sviluppatori APEX'
||unistr(', Flows for APEX utilizza le tecnologie gi\00E0 note - APEX, PL/SQL e SQL - per creare flussi di processi potenti e flessibili nell''ambiente APEX.</li> <li>Utilizzato per creare ed eseguire un flusso di processo di pagine APEX, script PL/SQL, inviare e-m')
||unistr('ail.</li> <li> La definizione del processo low-code diagrammamatico pu\00F2 essere compresa e modificata anche dagli utenti aziendali per aumentare la flessibilit\00E0 aziendale. I flussi utilizzano lo stile BPMN (Business Process Modeling Notation) V2</li>'),
'<li>Creato come progetto della community APEX e rilasciato su una licenza MIT open source.</li>',
'</ul> <p>',
'<h4>Scarica</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentazione</h4>',
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Documentazione pi\00F9 recente online</a>'),
'<p>',
'<h4>Esercitazioni BPMN</h4>',
'Per iniziare a utilizzare i flussi di modellazione, provare i flussi di esercitazione preinstallati. Per ulteriori informazioni sulle esercitazioni, consultare <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">qui</a>. <p>',
'<h4>Applicazione demo</h4>',
unistr('<p>Date un''occhiata al nostro <a href="https://flowsforapex.org" target="_blank">sito web</a> per vedere come si pu\00F2 integrare un flusso.</p>')))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13428225101416500)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100006)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13428456599416500)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13428656102416503)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100006)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ubicazione BPMN'
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13428884819416503)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13429061171416503)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100006)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posizione archivio'
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13429293878416503)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13429485943416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100006)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13429628497416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100006)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13429806971416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100006)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13430005659416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100006)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13430213168416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100006)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiorna'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13430469623416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100006)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13430688390416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100006)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copia'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13430820035416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100006)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Termina'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13431004614416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100006)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13431274397416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100006)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Termina'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13431422074416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100006)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tema'
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13431656913416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100006)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Licenza'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13431816707416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100006)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Termina'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13432062829416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100006)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Controllo flusso'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13432275803416504)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenota'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13432443952416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100006)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiorna'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13432669548416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100006)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13432881277416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100006)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra dettagli'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13433077654416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100006)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiungi nuova versione'
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13433299034416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100006)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13433470545416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100006)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scarica (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13433686479416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13433860894416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100006)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Riepilogo istanza'
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13434079420416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100006)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modifica'
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13434284792416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100006)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13434485987416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100006)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motore'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13434676565416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra sequenza temporale istanza'
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13434803866416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100006)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13435051057416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100006)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13435252882416505)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100006)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiorna'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13435492060416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100006)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra dettagli modello'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13435687793416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100006)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completato'
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13435897256416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100006)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13436087071416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100006)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aggiungi nuova versione'
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13436210101416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100006)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Automatico'
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13436466130416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelli form semplici'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13436640170416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100006)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applicazione motore'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13436814690416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100006)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inizio'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13437017691416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100006)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pannello'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13437213101416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100006)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra cronologia'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13437487710416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100006)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archiviazione'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13437626095416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100006)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13437800879416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100006)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scarica (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13438088517416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100006)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer passi'
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13438285471416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100006)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'sotto il rapporto|side by side|nuova finestra'
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13438404368416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100006)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13438668265416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esci'
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13438811262416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100006)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13439031855416506)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100006)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Per iniziare'
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13439256564416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100006)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rischedula'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13439489040416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100006)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inizio'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13439643511416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100006)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Impostazione visualizzazione'
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13439809774416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13440071781416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100006)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importa'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13440217378416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100006)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13440492856416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100006)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esporta'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13440638114416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100006)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copia'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13440890934416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modalit\00E0 scura')
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13441074565416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100006)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13441266533416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100006)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13441418279416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100006)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra dettagli modello'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13441643482416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100006)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completato'
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13441867987416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13442050645416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rilascio'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13442261177416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100006)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Impostazione visualizzazione'
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13442402255416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100006)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visualizza origine'
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13442635514416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100006)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra dettagli'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13442840768416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100006)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13443088474416507)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Riavvia'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13443255216416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenota'
,p_translate_from_text=>'Reserve'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13443472693416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100006)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13443644392416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100006)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registrazione'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13443850900416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rilascio'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13444040294416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100006)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13444286687416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100006)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13444423343416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100006)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scarica (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13444642216416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100006)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esporta'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13444894731416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100006)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visualizza'
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13445098651416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100006)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inizio'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13445230454416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modalit\00E0 chiara')
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13445487476416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100006)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rischedula'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13445662766416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100006)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13445872386416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100006)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'sotto il report|side by side|nuova finestra'
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13446077453416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100006)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostra cronologia'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13446261253416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13446444803416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Riavvia'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13446672439416508)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100006)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestione del flusso'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13446825148416512)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun processo selezionato'
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13447015193416512)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun processo selezionato'
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13447211859416512)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100006)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun attributo trovato.'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13447445365416512)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13447680647416512)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100006)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessuna variabile di entrata/uscita trovata.'
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13447847403416514)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Finestra di dialogo Cerca'
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13448056734416514)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13448255549416514)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13448463471416514)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13448686738416514)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13448823501416515)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cerca'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13449007600416515)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chiudi'
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13449226863416515)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Successivo >'
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13449449050416515)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'< Precedente'
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13449660794416515)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eseguire questa azione di eliminazione?'
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13449895170416515)
,p_translated_flow_id=>100006
,p_translate_to_id=>100.100006
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso di lavoro'
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13450021476416516)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100006)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche processo'
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13450297745416516)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100006)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestione del flusso'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13450451921416516)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100006)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Servizio REST'
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13450633787416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motore'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13450869488416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100006)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archiviazione'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13451027685416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100006)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Controllo flusso'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13451229983416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100006)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sequenza temporale istanza - &P20_PRCS_NAME.'
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13451471623416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100006)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione'
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13451683963416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100006)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13451846039416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100006)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pannello'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13452003570416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100006)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche task'
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13452207386416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100006)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche'
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13452426300416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100006)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Applicazione motore'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13452651884416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100006)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Statistiche giornaliere'
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13452850112416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100006)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelli form semplici'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13453012620416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100006)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Configurazione - Licenza'
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13453258620416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100006)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modeler di flusso'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13453437982416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100006)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registrazione'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13453634606416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100006)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13453888256416517)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100006)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13454032398416518)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100006)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'File'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13454245308416518)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100006)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dopo il task'
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13454413759416518)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100006)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prima del frazionamento'
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13454651423416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100006)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato processo dopo cessazione'
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13454860766416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100006)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Segnaposto'
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13455063261416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100006)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13455295490416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100006)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ccn'
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13455450201416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100006)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13455613441416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100006)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Intervallo da Anno a Mese'
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13455835830416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100006)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nelle variabili'
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13456047858416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100006)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Testo'
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13456204290416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100006)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Script SQL'
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13456491918416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100006)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Richiesta'
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13456677722416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100006)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elementi pagina'
,p_translate_from_text=>'Page Items'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13456890178416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100006)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tempo di riattivazione del timer'
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13457044139416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100006)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Numero massimo di esecuzioni'
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13457212516416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100006)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabili di output'
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13457488964416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100006)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corpo funzione PL/SQL'
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13457662843416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100006)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pagina'
,p_translate_from_text=>'Page'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13457815086416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100006)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Maschera formato'
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13458084230416519)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100006)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Intervallo da Giorno a Secondo'
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13458255503416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100006)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tempo fino al primo avvio del timer'
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13458461528416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100006)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motore'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13458653579416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100006)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo definizione timer'
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13458835514416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100006)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Definizione timer'
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13459064589416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100006)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Rispondi a'
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13459212566416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Memorizza nome utente'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13459475130416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100006)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'File BPMN'
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13459640178416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100006)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prima del task'
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13459854475416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100006)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'A'
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13460071209416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100006)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CC'
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13460269248416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100006)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Invia Immediatamente'
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13460493251416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100006)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prima dell''evento'
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13460694895416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100006)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID applicazione'
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13460809160416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100006)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corpo HTML'
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13461024468416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100006)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dopo l''unione'
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13461229173416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100006)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Da'
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13461436108416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100006)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore statico'
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13461660360416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100006)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto'
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13461810509416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100006)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elemento'
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13462092435416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100006)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Query SQL (restituisce un valore separato da due punti)'
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13462299404416520)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100006)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Espressione PL/SQL'
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13462438950416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100006)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Codice PL/SQL'
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13462669255416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100006)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabile processo'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13462829133416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100006)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nell''evento'
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13463027520416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100006)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Allegato'
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13463251625416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100006)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Query SQL (ritorno di un valore singolo)'
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13463423875416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100006)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancella cache'
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13463621770416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100006)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valori Elemento'
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13463868961416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100006)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corpo'
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13464094407416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100006)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di task'
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13464287532416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100006)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usa modello'
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13464415228416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100006)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID modello'
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13464611838416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100006)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13464894164416521)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100006)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Associa valori elemento pagina'
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13465016624416523)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun flusso secondario registrato'
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13465210717416523)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun livello di processo registrato'
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13465409782416524)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'	- Seleziona -'
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13465671363416524)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessuna categoria'
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13465826349416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100006)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Direzione'
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13466078527416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100006)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13466281274416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100006)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13466430046416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100006)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13466685204416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100006)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato evento'
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13466861893416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100006)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13467066306416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100006)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utente'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13467288839416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13467475833416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100006)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13467622530416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100006)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data evento'
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13467874279416524)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13468074118416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100006)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C8 chiamabile')
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13468249707416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100006)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data avvio'
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13468437284416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100006)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13468601902416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13468859392416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100006)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID pagina'
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13469040946416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100006)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13469213283416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100006)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome utente'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13469432978416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100006)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13469615779416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100006)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13469810939416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100006)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data ultimo aggiornamento'
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13470022626416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100006)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Titolo evento'
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13470228210416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100006)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Icona evento'
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13470497504416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100006)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13470665219416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13470884802416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100006)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descrizione evento'
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13471095317416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100006)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13471281482416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13471499043416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100006)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modello'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13471615359416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100006)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13471824042416525)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100006)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID applicazione'
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13472093270416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100006)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Colore utente'
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13472230807416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100006)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di dati'
,p_translate_from_text=>'Data Type'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13472456867416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100006)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descrizione'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13472605032416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100006)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13472860652416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Priorit\00E0')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13473030020416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100006)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Indicatore orario'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13473262792416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100006)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di evento'
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13473412660416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100006)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13473567018416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100006)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13473795878416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data scadenza'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13473936861416526)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100006)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome utente'
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13474122643416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100006)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13474351012416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100006)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13474592599416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100006)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13474745999416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13474907165416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13475187928416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100006)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13475346914416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100006)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13475506981416528)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100006)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13475786642416529)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13475947562416529)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100006)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13476133903416529)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13476303709416529)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100006)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13476565756416529)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100006)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13476752603416529)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100006)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13476935213416530)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>Un modello: importare un singolo modello fornendo tutti gli attributi</li>',
unistr('    <li>Pi\00F9 modelli: importare diversi modelli fornendo un file zip*</li>'),
'</ul>',
'<p> * Il file zip deve contenere:',
'    <ul>',
'        <li>I file bpmn da importare</li>',
unistr('        <li>Un file import.json che \00E8 un array di oggetti (vedere l''esempio riportato di seguito) con i seguenti attributi:'),
'            <ul>',
'                <li>dgrm_name: il nome del modello</li>',
'                <li>dgrm_version: la versione del modello</li>',
'                <li>dgrm_category: la categoria del modello</li>',
'                <li>file: il nome del file bpmn nell''archivio</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Esempio di file import.json con due modelli<br>',
'<pre><code>[',
'{',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "bozza",',
'    "dgrm_category": nullo,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
unistr('    "dgrm_name": "Festivit\00E0",'),
'    "dgrm_version": "0",',
'    "dgrm_status": "bozza",',
'    "dgrm_category": nullo,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13477173147416530)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se si seleziona questa casella di controllo, l''applicazione salver\00E0 il nome utente in un cookie del browser persistente denominato "LOGIN_USERNAME_COOKIE". Al successivo accesso alla pagina di login,'),
unistr('il campo del nome utente verr\00E0 popolato automaticamente con questo valore.'),
'</p> <p>',
unistr('Se si deseleziona questa casella di controllo e il nome utente \00E8 gi\00E0 stato salvato nel cookie,'),
unistr('l''applicazione lo sovrascriver\00E0 con un valore vuoto. \00C8 inoltre possibile utilizzare gli strumenti di sviluppo del browser per rimuovere completamente il cookie.'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13477311470416530)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13477527954416531)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100006)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eventi istanza'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13477712857416531)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100006)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flussi secondari correnti'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13477944174416531)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100006)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13478149342416531)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelli form semplici'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13478306587416531)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100006)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabile Cronologia'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13478507721416531)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100006)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eventi istanza'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13478700277416531)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100006)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Report client ORDS'
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13478901335416531)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100006)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelli chiamati'
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13479187835416531)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sottoscrizioni ai messaggi'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13479353719416531)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100006)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passi completati'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13479576997416531)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100006)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Attributi'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13479777229416531)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100006)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma chiamato'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13479912664416531)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100006)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gestione del flusso'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13480103946416531)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrammi chiamanti'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13480334072416532)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100006)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze flusso'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13480590653416532)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100006)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flussi secondari completati'
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13480742105416532)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100006)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passi correnti'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13480947489416532)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100006)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabile Cronologia'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13481144080416532)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100006)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabili'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13481307184416532)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errori passo'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13481576376416532)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100006)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flussi secondari'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13481785741416533)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100006)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Il conteggio massimo di righe per questo report \00E8 #MAX_ROW_COUNT# righe.  Applicare un filtro per ridurre il numero di record nella query.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13481908676416533)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Il conteggio massimo di righe per questo report \00E8 #MAX_ROW_COUNT# righe.  Applicare un filtro per ridurre il numero di record nella query.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13482113988416533)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('La cronologia delle variabili \00E8 vuota.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13482339256416533)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('La cronologia degli errori del passo \00E8 vuota.')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13482513684416533)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun flusso secondario corrente trovato.'
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13482729439416533)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessuna espressione variabile trovata.'
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13482980884416533)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun diagramma chiamante trovato.'
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13483112762416534)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun flusso secondario completato trovato.'
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13483357863416534)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('La cronologia degli eventi dell''istanza \00E8 vuota.')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13483516786416534)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100006)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun dato trovato.'
,p_translate_from_text=>'No data found.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13483748284416534)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun attributo trovato.'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13483995616416534)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun diagramma chiamato trovato.'
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13484105818416534)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100006)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('La cronologia delle variabili \00E8 vuota.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13484324763416534)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100006)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun dato trovato.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13484536490416534)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun passo completato trovato.'
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13484757510416534)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nessun passo corrente trovato.'
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13484905038416535)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13485172195416535)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13485312201416535)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13485511142416535)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13485725393416535)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13485918371416535)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13486111756416535)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13486381536416535)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13486587078416535)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13486773095416535)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13486933668416535)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13487125388416535)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13487354221416535)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13487508408416535)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13487784157416536)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13487944116416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13488115750416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13488302092416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13488506598416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13488754494416536)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100006)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13488960651416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100006)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13489165308416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13489338867416536)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13489590672416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13489745250416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100006)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13489905148416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13490180284416536)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13490309069416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13490514155416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100006)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13490798255416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100006)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13490904604416536)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13491145971416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13491384140416536)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13491548976416537)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13491733074416537)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13491929269416537)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13492121241416537)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13492310310416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13492554413416537)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13492755409416537)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13492945892416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100006)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13493141543416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13493334482416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13493505923416537)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13493738064416537)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13493970638416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100006)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13494137458416537)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100006)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13494378679416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13494563485416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13494705791416537)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13494944179416537)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13495158211416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100006)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13495349688416537)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13495567146416537)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13495780488416537)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13495921968416538)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100006)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13496149452416538)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13496305654416538)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13496521506416538)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13496728711416538)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13496973517416538)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100006)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13497172542416538)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13497356394416538)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13497535902416538)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13497729516416538)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100006)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13497915303416538)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13498192022416538)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100006)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13498346575416538)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13498528627416538)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13498734381416538)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13498964086416538)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13499144430416538)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13499366605416538)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13499571860416538)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13499701332416538)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13499990018416539)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13500140842416539)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13500386816416539)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13500530327416539)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13500775840416539)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13500909540416539)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13501106243416539)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100006)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13501306603416539)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13501550031416539)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100006)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13501770847416539)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13501915096416539)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13502149225416539)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13502397281416539)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13502540360416539)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100006)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13502799121416539)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100006)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13502968978416539)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100006)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13503161011416539)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13503345490416539)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13503581897416539)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13503727693416540)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100006)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13503968688416540)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13504124774416540)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13504363822416540)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13504527746416540)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13504727379416540)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13504960671416540)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13505184779416540)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13505307109416540)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13505570547416540)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13505735677416540)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13505974567416540)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13506188324416540)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13506339987416540)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13506544050416540)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13506777100416540)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13506933447416540)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13507195559416541)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13507364271416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13507530447416541)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13507741242416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13507945038416541)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13508132245416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13508392205416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13508571351416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13508792749416541)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13508994533416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100006)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13509122300416541)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13509351071416541)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13509509884416541)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100006)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13509732249416542)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13509920828416542)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13510171980416542)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13510361209416542)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100006)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13510569840416542)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13510740988416542)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13510967877416542)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13511125760416542)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100006)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13511392329416542)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13511552953416542)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13511735089416542)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13511959797416542)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13512145024416542)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100006)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13512344312416542)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13512546512416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13512794510416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100006)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13512973539416543)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13513143696416543)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100006)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13513374201416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13513570987416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13513741095416543)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13513954385416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13514127742416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13514345721416543)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13514563491416543)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100006)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13514755065416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13514973744416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13515131295416543)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13515311725416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13515574486416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13515783268416543)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13515980827416543)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100006)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13516135209416543)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13516362893416544)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13516565154416544)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13516761881416544)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13516913216416544)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13517175245416544)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13517346904416544)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13517574981416544)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13517744452416544)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100006)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13517900589416544)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13518127741416544)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13518372287416544)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13518552566416544)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13518778172416544)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13518920860416544)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100006)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13519102365416544)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13519335763416544)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13519574635416544)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13519771086416544)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100006)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13519904294416544)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13520152133416544)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100006)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13520391238416545)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13520534781416545)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13520746993416545)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13520988143416545)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13521153229416545)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13521310367416545)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13521559540416545)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100006)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13521700651416545)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13521907755416545)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13522112332416545)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13522393865416545)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13522596997416545)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13522788476416545)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13522929992416545)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100006)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13523198572416545)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13523382617416545)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13523511260416545)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13523780279416545)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100006)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13523952036416545)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13524152213416545)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13524312123416546)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100006)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13524560470416546)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13524718270416546)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100006)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13524997021416546)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100006)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13525130418416546)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13525369556416546)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13525521887416546)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13525778252416546)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13525994850416546)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100006)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13526121410416546)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13526344520416546)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13526578167416546)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13526770973416546)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13526932870416546)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13527114209416546)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100006)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13527351655416546)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13527593290416546)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13527749624416546)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13527939619416546)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13528121812416546)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13528306165416547)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13528533544416547)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13528714826416547)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13528915371416547)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13529173651416547)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13529342618416547)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13529594725416547)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100006)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13529788543416547)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13529945378416547)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100006)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13530113594416547)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13530338868416556)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data inizio timer'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13530529822416556)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13530780312416557)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ambito corrente'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13530904641416557)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13531182729416557)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Attributi JSON'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13531331579416557)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13531539046416557)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo aggiornamento'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13531736546416557)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13531936279416557)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utente'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13532192225416557)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13532349901416557)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13532598959416557)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data creazione'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13532705098416557)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13532906456416557)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Selezione versione diagramma chiamata'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13533171048416557)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13533301872416557)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13533502690416557)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utente'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13533702084416557)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo aggiornamento'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13533973208416557)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto iniziale'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13534174681416558)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100006)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Email per il supporto'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13534319467416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100006)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13534544173416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello corrente'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13534723374416558)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione modello'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13534990908416558)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Indicatore orario'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13535161050416558)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100006)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato al completamento'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13535342389416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore chiave'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13535578275416558)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13535738815416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corsia'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13535995825416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100006)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenotato per'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13536124792416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100006)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13536393914416558)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome chiave'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13536529783416558)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13536761247416558)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13536984318416558)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13537185543416558)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Con icona ricorsione'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13537341364416558)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13537584448416558)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13537711310416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Azione rapida'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13537991795416559)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome istanza'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13538114671416559)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13538347813416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100006)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13538529173416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13538719208416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data scadenza'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13538957868416559)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13539170223416559)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13539367861416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100006)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID processo'
,p_translate_from_text=>'Process ID'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13539522707416559)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100006)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Azione rapida'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13539796494416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creato'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13539965678416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13540154557416559)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esecuzione'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13540382940416559)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo completamento'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13540598602416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100006)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13540752959416559)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm chiamante'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13540990190416559)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13541175962416559)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Classe corrente'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13541358225416559)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100006)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13541561985416559)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ambito'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13541767230416559)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID statico'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13541928784416560)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13542112908416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diventa corrente'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13542332231416560)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100006)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13542597747416560)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13542786357416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Espressione'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13542979485416560)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esecuzione'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13543195275416560)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100006)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13543354518416560)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13543515697416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100006)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13543764082416560)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13543953918416560)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100006)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13544184174416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13544330205416560)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passo'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13544533159416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13544700308416560)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utenti esclusi'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13544914416416560)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13545137088416560)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenotazione'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13545337418416560)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma chiamante'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13545538208416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13545763624416560)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lavoro iniziato'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13545978296416560)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variabile payload'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13546162332416561)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13546354931416561)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13546504634416561)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100006)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso analizzato'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13546775193416561)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13546979747416561)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100006)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenotazione'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13547182375416561)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13547346665416561)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello processo'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13547575500416561)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lavoro iniziato'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13547769442416561)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13547991236416561)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100006)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13548125483416561)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100006)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13548328735416561)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100006)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13548534769416561)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13548703614416561)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13548963438416561)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utente'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13549142059416561)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100006)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo completamento'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13549394952416561)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm radice'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13549528912416562)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenotazione'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13549799303416562)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Indicatore orario'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13549987512416562)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo aggiornamento'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13550195916416562)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto chiamante'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13550306121416562)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13550571669416562)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo aggiornamento'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13550754736416562)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13550996837416562)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13551118170416562)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13551332232416562)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13551547077416562)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utente'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13551788029416562)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma chiamato'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13551967609416562)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13552170062416562)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13552302787416562)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13552516748416562)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13552754851416562)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100006)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13552911456416562)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13553116286416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utente'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13553366523416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13553529808416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13553748903416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Indicatore orario'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13553999619416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome messaggio'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13554133425416563)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo completamento'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13554362218416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100006)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corrente'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13554573950416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello processo'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13554748542416563)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13554916452416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100006)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto chiamante'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13555197378416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13555366271416563)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso secondario'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13555582665416563)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto chiamante'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13555794920416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100006)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ambito'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13555997865416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Indicatore orario'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13556109839416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13556331178416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Priorit\00E0')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13556527509416563)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100006)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13556733012416563)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prenotazione'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13556911578416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13557131417416563)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso secondario'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13557336516416564)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo aggiornamento'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13557587800416564)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100006)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13557777033416564)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13557960930416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Esecuzione'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13558185106416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100006)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chiave passo'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13558369755416564)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13558525651416564)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100006)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chiave passo'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13558700382416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13558957786416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID Bpmn'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13559158033416564)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diventa corrente'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13559310535416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di dati'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13559535692416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13559729329416564)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13559944160416564)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100006)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13560175862416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13560358552416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13560555007416564)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione diagramma chiamata'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13560747160416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso secondario'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13560943505416564)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ultimo completamento'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13561135198416564)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13561364277416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100006)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chiave passo'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13561521905416565)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13561790736416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13561982763416565)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello processo'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13562109625416565)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13562327372416565)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passo'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13562582650416565)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13562773554416565)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lavoro iniziato'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13562931011416565)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13563130240416565)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100006)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13563390863416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Classe corrente'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13563540956416565)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma chiamante'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13563784430416565)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lavoro iniziato'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13563961624416565)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di dati'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13564198923416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Oggetto chiamante'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13564304978416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100006)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13564573305416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13564707323416565)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello processo'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13564976297416565)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100006)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID secondario'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13565107317416565)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100006)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13565326915416566)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100006)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Commento'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13565594228416566)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100006)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descrizione'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13565757696416566)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13565992328416566)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Livello'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13566124134416566)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato modello'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13566304405416566)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria modello'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13566534220416566)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100006)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso secondario'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13566744472416566)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13566989830416566)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100006)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Percorso iterazione'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13567140330416566)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13567393430416566)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo di dati'
,p_translate_from_text=>'Data Type'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13567589804416566)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corrente'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13567723864416566)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Indicatore orario'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13567904373416566)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13568154062416566)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID Diagramma chiamante'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13568363847416566)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100006)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI supporto'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13568538696416566)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13568726199416566)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valore'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13568973865416566)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100006)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13569133570416567)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100006)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13569348058416567)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13569503478416567)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Con ricorsione'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13569723156416567)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100006)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID flusso secondario'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13569966834416567)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Utenti potenziali'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13570111936416567)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100006)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13570330594416567)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100006)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13570540620416567)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100006)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13570718192416567)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome modello'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13570972789416567)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13571177152416567)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo espressione'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13571372024416567)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100006)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13571594944416567)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flusso secondario'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13571736020416567)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13571950842416567)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13572133606416567)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gruppi potenziali'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13572390123416567)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagramma'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13572585934416567)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100006)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID client'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13572771730416567)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13572989507416567)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13573104943416568)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID responsabile'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13573324989416568)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passo'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13573531708416568)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100006)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diventa corrente'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13573708260416568)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13573907608416568)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100006)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13574100858416568)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100006)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diventa corrente'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13574336900416568)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100006)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13574576195416568)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100006)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13574702549416568)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100006)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13574925670416568)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100006)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato al completamento'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13575102208416568)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Azione rapida'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13575351503416568)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100006)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13575553332416568)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13575760846416577)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13575947107416577)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13576192762416578)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13576315977416578)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100006)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13576566571416578)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100006)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13576704026416578)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13576982473416578)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100006)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13577117743416578)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13577316490416578)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100006)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13577576815416578)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13577721240416578)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100006)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13577930520416578)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13578127496416578)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13578373069416578)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100006)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13578528067416578)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13578750672416578)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100006)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13578992712416578)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100006)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13579196987416578)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100006)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13579338524416579)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13579559968416579)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100006)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13579755234416579)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13579948091416579)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100006)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13580154809416579)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13580303323416579)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13580503836416579)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100006)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13580761405416579)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100006)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13580961138416580)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100006)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13581113718416580)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100006)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13581334226416582)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100006)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Visualizzatore'
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13581532881416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100006)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Modeler'
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13581752879416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100006)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13581916056416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100006)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13582190475416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100006)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13582342975416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100006)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13582519302416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100006)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13582719454416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100006)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13582964251416583)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Privilegi insufficienti: l''utente non \00E8 un amministratore')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13583135970416584)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ogni ora'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13583391969416584)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ogni ora'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13583525242416584)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 anno'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13583763528416584)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 anno'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13583940034416584)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 anno'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13584120562416584)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anno I'
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13584381797416584)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 anni'
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13584540302416584)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 min'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13584725269416584)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 min'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13584979658416584)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mesi'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13585190306416585)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mesi'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13585302534416585)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mesi'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13585558100416585)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 mesi'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13585726804416585)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4 anni'
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13585949866416585)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 min'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13586140836416585)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 min'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13586354541416585)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mesi'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13586524905416585)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mesi'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13586782629416585)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mesi'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13586948266416585)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 mesi'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13587199034416585)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 anni'
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13587383580416586)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 min'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13587552098416586)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 min'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13587763456416586)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mesi'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13587980941416586)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mesi'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13588105249416586)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mesi'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13588365132416586)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 mesi'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13588544014416586)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2 anni'
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13588749467416587)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 secondi (uso produzione - non per apex.oracle.com)'
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13588940448416587)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 secondi (uso produzione - non per apex.oracle.com)'
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13589106558416587)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 giorni'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13589309584416587)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 giorni'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13589586836416587)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 giorni'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13589756920416587)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 anno'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13589900477416587)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 giorni'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13590194482416587)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 giorni'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13590306359416587)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 giorni'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13590560034416588)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13590756638416588)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13590981160416588)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13591113415416588)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13591341100416588)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13591589207416588)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100006)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13591781312416588)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13591974907416588)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100006)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13592118855416588)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13592320005416588)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13592563583416588)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13592747168416588)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13592982979416589)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100006)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13593179102416589)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13593338216416589)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13593550344416589)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13593770538416589)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13593920761416589)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13594109346416589)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100006)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13594322943416589)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100006)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13594534350416589)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13594789590416589)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100006)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13594975314416589)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13595197393416589)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100006)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13595389566416589)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100006)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13595589516416589)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13595794224416590)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100006)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13595934141416590)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100006)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13596198464416590)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13596343356416590)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100006)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13596588541416590)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100006)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13596718860416590)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13596905834416590)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100006)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13597116891416590)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100006)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13597314985416590)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13597509949416590)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13597762516416590)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13597929621416590)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13598128468416590)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13598398220416590)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13598567084416590)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13598730260416590)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100006)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13598914745416590)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100006)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13599131850416590)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13599385246416591)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13599525667416591)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13599730298416591)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13599925926416591)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13600194681416591)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13600385697416591)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100006)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13600555227416591)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13600787232416591)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100006)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13600978067416591)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13601106691416591)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100006)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13601355674416591)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13601539553416591)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13601785010416591)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100006)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13601901035416591)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100006)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13602161582416591)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100006)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13602395199416592)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13602558251416592)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13602713683416592)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13602925031416592)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100006)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13603106923416592)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13603319578416592)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100006)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13603551288416592)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13603714764416592)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13603985386416592)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13604168555416592)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13604384027416592)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13604567704416592)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13604755531416592)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13604975799416593)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13605181800416593)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13605369725416593)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100006)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13605531778416593)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13605792360416593)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13605945997416593)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13606182772416593)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100006)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13606374689416593)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13606516327416593)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13606714808416593)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100006)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13606979737416593)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13607156061416593)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13607380239416593)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100006)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13607539929416593)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13607714720416594)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13607901276416594)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13608125783416594)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13608367730416594)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13608554940416594)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13608787748416594)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13608973051416594)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13609195395416594)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13609321206416594)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13609567060416594)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13609708857416594)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13609911548416594)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13610150082416594)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13610307679416594)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13610571615416594)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100006)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13610748557416595)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100006)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13610919303416595)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13611131832416595)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13611349663416595)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100006)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13611513550416595)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100006)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13611790713416595)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13611951871416595)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13612109915416595)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13612330730416595)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13612587606416595)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13612726759416595)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13612994430416595)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13613166151416595)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13613398584416595)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13613546225416596)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100006)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13613728884416596)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100006)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13613933573416596)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100006)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13614101971416596)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100006)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13614345110416596)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13614561959416596)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13614776222416596)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13614929596416596)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100006)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13615168203416596)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13615314738416596)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13615555843416596)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100006)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13615715406416596)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13615901055416596)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13616184220416596)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100006)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13616399698416596)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13616549931416596)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13616719400416597)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100006)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13616949109416597)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13617108297416597)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13617350021416597)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13617533952416597)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100006)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13617776935416597)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100006)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13617939706416597)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13618194881416597)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100006)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13618349131416597)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13618576165416597)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13618798979416597)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100006)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13618995603416597)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13619126973416597)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13619311642416597)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13619558672416598)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100006)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13619787658416598)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13619921038416598)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13620155822416598)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13620342082416598)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13620581579416598)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13620722313416598)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13620960677416598)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13621118975416598)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13621387818416598)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13621550681416598)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13621702806416598)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13621964881416598)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100006)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13622112761416598)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13622308660416598)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13622511924416599)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13622788106416599)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13622951147416599)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100006)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13623131488416599)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13623324732416599)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13623596726416599)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13623725918416599)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13623943772416599)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100006)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13624184632416599)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13624380803416599)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13624505760416599)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13624775136416599)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13624968984416599)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100006)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13625183911416599)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100006)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13625333230416599)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13625573878416599)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100006)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13625775543416599)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13625919510416599)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100006)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13626160589416599)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13626306786416600)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13626598644416600)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13626703649416617)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13626997511416617)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13627112726416617)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13627394872416617)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13627528259416617)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13627796613416617)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100006)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13627914470416617)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13628197113416618)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13628351542416618)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13628535166416618)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13628795052416618)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13628979120416618)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13629114923416618)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13629380317416618)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13629562296416618)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13629723365416618)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13629991745416618)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13630149943416618)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13630330584416618)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100006)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13630581779416618)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100006)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13630779572416618)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13630900442416618)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13631165673416618)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13631368234416618)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100006)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13631500205416618)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13631790000416619)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13631963458416619)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13632134485416619)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13632392129416619)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13632507111416619)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13632779122416619)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100006)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13632954781416619)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13633140752416619)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13633301030416619)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13633517337416619)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13633746120416619)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13633914218416619)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13634125188416619)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13634345333416619)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13634567747416619)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13634762838416619)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13634939738416619)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13635129279416619)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13635349901416619)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13635545788416619)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100006)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13635789954416619)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13635925352416620)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13636152096416620)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13636335065416620)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13636584553416620)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13636769080416620)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13636980221416620)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13637134713416620)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13637388081416620)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13637599005416620)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13637717524416620)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13637913216416620)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13638130534416620)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13638374615416620)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100006)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13638559465416620)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13638733258416620)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13638920477416620)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13639183351416620)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13639375433416620)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13639554955416620)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13639720040416620)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13639975198416620)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100006)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13640179312416621)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13640351604416621)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13640570600416621)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100006)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13640732825416621)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100006)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13640915261416621)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13641171236416621)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13641369085416621)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100006)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13641529248416621)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100006)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13641783999416621)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13641975036416621)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13642160694416621)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13642372329416621)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13642560221416621)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13642718584416621)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13642968057416621)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13643119689416621)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13643391116416621)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13643535893416621)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13643795081416621)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13643986052416621)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13644185959416621)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100006)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13644333576416622)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13644578111416622)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100006)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13644743333416622)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13644963296416622)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13645182437416622)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13645385025416622)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13645536379416622)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13645748086416622)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100006)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13645907073416622)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13646125151416622)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13646376008416622)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13646531309416626)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13646792943416626)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13646921988416626)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13647146613416626)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13647336460416626)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13647505924416626)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100006)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13647723159416626)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13647992451416626)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13648183449416626)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13648362535416626)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13648537344416626)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100006)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13648749953416627)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13648980198416627)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13649168426416627)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13649357627416627)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13649543458416627)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13649779801416627)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13649932721416627)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13650111184416627)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13650330792416627)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13650596312416627)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13650744315416627)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13650975299416627)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13651146789416627)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13651318497416627)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13651587607416627)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13651713039416628)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13651905015416628)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13652161067416629)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13652381086416629)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100006)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13652520541416629)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13652764006416629)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13652908134416629)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13653147624416629)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13653346009416629)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13653525637416629)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13653754647416629)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13653949379416629)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13654115741416629)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13654305795416629)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13654512758416629)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13654716565416629)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100006)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13654997204416629)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13655184103416629)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13655342693416629)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13655547667416629)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13655721246416629)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13655940297416629)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13656120120416630)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13656397886416630)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100006)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13656571184416630)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13656738806416630)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13656992012416630)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13657128255416630)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13657373898416630)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13657534493416630)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13657725806416630)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13657922261416630)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13658161282416630)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13658365856416630)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13658574159416630)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100006)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13658769897416630)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13658937024416630)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13659136034416630)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13659371384416630)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13659574833416630)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13659735287416630)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13659971610416630)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13660142946416630)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13660395384416630)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13660512219416631)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13660783537416631)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13660968898416631)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13661197251416631)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13661302033416631)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13661597583416631)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13661765068416631)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13661957861416631)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13662152666416631)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100006)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13662325445416631)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13662540149416631)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13662731975416631)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13662957234416631)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13663109826416631)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13663311374416631)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13663521700416631)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13663726386416631)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13663982235416631)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13664149556416631)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13664312822416631)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13664575806416631)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13664737334416632)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13664953107416632)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100006)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13665137307416632)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13665371690416632)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100006)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13665529274416632)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13665724665416632)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13665904846416632)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13666182439416632)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13666370832416632)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100006)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13666530687416632)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13666723662416632)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13666992400416632)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13667181480416636)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100006)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13667313866416636)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13667580155416636)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13667778572416636)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13667969653416636)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13668193300416636)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13668318441416636)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13668564134416636)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13668731799416636)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100006)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13668995692416636)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100006)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13669198501416636)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13669323386416636)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13669532596416636)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100006)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13669769392416636)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100006)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13669957815416636)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13670175440416637)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13670306318416637)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13670528089416637)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13670716847416637)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13670923928416637)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13671141783416637)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13671367244416637)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13671560734416637)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13671749431416637)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13671935497416637)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13672110257416637)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13672311271416637)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13672533503416637)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13672755941416637)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13672901708416637)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100006)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13673123418416637)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100006)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13673347902416637)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100006)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13673536200416638)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13673767232416638)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13673980579416638)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13674157982416638)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13674353891416638)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13674589624416638)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13674776353416638)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100006)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13674992956416638)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100006)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13675120736416638)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13675382133416638)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13675517990416638)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13675760859416638)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100006)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13675916012416638)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100006)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13676192703416638)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100006)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13676396661416638)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13676584696416638)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100006)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13676716080416638)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13676928415416638)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13677152687416638)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100006)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13677352726416638)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100006)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13677583133416638)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13677723194416639)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100006)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13677995949416639)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13678116814416639)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100006)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13678365430416639)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100006)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13678512901416639)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13678724439416639)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100006)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13678992432416639)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13679176701416639)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100006)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13679317451416639)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100006)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13679582329416639)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100006)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13679754470416639)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100006)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13679972409416639)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100006)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13680149861416639)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100006)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13680362880416639)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100006)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13680546189416639)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13680728684416642)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13680940025416642)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100006)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13681134010416642)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13681348255416643)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13681578045416643)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100006)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13681768987416643)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13681905231416643)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100006)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13682166042416643)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13682366609416643)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100006)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13682548578416643)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100006)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13682748092416644)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13682973493416644)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13683193324416644)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100006)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13683320056416644)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100006)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13683502882416644)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100006)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13683733449416644)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13683932334416644)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100006)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13684112058416644)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100006)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13684385142416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100006)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13684516240416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100006)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13684769651416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13684960140416645)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100006)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13685189773416645)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13685384324416645)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13685529401416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100006)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13685744675416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13685990745416645)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13686197388416645)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13686356324416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100006)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13686517976416645)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100006)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13686772008416645)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100006)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13686928976416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13687147800416645)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13687383765416645)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100006)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13687508015416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13687781196416645)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100006)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13687951079416646)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13688155991416646)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13688355942416646)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13688514388416646)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100006)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13688756011416646)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13688970894416646)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13689104809416646)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13689319376416646)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100006)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13689528870416646)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100006)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13689784500416646)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13689944352416646)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13690103982416646)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100006)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13690367056416646)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100006)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13690556364416646)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100006)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13690772062416646)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100006)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13690939685416646)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100006)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13691141723416646)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100006)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13691310478416646)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13691539639416646)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100006)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13691774552416647)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100006)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13691999848416647)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13692121246416647)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100006)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13692358077416647)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100006)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13692551145416647)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13692714210416647)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100006)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13692908440416647)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100006)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13693111367416647)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13693334360416647)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100006)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13693575935416647)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100006)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13693707385416647)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100006)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13693939007416647)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13694127705416647)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100006)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13694390393416647)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13694515156416647)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13694788327416647)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13694935974416647)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100006)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13695162529416647)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100006)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13695305554416647)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13695569229416647)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13695735583416648)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100006)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13695905542416648)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100006)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13696140415416648)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13696323721416648)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100006)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13696558496416648)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13696782122416648)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13696939209416648)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100006)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13697132780416648)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13697313422416648)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100006)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13697580956416648)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13697778321416648)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100006)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13697978789416648)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100006)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13698162490416648)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13698365985416648)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100006)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13698530363416648)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100006)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13698748106416648)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100006)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13698981373416652)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13699178965416652)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13699332625416652)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13699587601416652)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13699769707416652)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100006)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13699966080416652)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100006)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13700189457416652)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100006)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13700342641416652)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13700560423416652)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100006)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13700771504416653)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13700953652416653)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13701185346416653)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13701323812416653)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100006)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13701575773416653)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100006)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13701752325416653)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100006)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13701955077416653)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100006)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13702117196416653)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100006)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13702348144416654)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13702517683416654)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13702706855416654)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13702971178416654)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100006)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13703108346416654)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13703350577416654)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13703585701416654)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100006)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13703764305416654)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13703976598416654)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100006)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13704156611416654)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13704302814416654)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13704531438416654)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100006)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13704788248416655)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13704909280416655)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13705103715416655)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13705397970416655)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100006)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13705548610416655)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13705774291416655)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100006)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13705940527416655)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100006)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13706163888416655)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100006)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13706390981416655)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13706593307416656)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13706746122416656)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13706991828416656)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13707143610416656)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100006)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13707310323416656)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13707525404416656)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13707764500416656)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100006)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13707964011416656)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13708120921416656)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100006)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13708301437416657)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100006)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13708529981416657)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100006)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13708751926416657)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13708958758416657)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13709128495416657)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100006)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13709361217416657)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100006)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13709537048416658)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13709793336416658)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13709911157416658)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13710163273416658)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100006)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13710353179416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13710570211416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13710796051416658)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100006)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13710992038416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13711109425416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100006)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13711350256416658)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100006)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13711532299416658)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100006)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13711773917416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13711900277416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13712152720416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100006)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13712382479416658)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100006)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13712502931416659)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100006)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13712768725416659)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100006)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13712906794416659)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100006)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13713157156416659)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13713307850416659)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13713597613416659)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13713751739416659)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13713962577416660)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100006)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13714193313416660)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100006)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13714323440416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13714568347416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100006)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13714749659416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100006)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13714952361416660)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100006)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13715142195416660)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13715312508416660)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100006)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13715558375416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13715790686416660)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100006)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13715909159416660)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100006)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13716143886416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100006)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13716320796416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100006)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13716562426416660)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100006)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13716769380416660)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100006)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13716969680416660)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13717173554416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100006)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13717368629416660)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13717551670416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100006)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13717753390416660)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100006)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13717918391416660)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100006)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13718199358416661)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100006)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13718374603416661)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100006)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13718534138416662)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13718726733416662)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13718977338416662)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100006)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13719160132416662)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13719346102416662)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13719590616416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13719727793416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13719935922416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13720103144416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13720372775416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13720586580416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100006)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13720700099416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13720987757416663)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13721147398416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13721326550416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13721568440416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100006)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13721754627416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13721977367416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13722197486416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13722386161416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13722536949416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13722797010416664)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13722982527416665)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13723154224416665)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100006)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13723308412416665)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13723535235416665)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100006)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13723764065416665)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100006)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13723974067416665)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100006)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13724169393416665)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100006)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13724302930416665)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13724547360416665)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100006)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13724779833416665)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13724909088416665)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13725159685416666)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100006)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13725365510416666)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100006)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13725539543416666)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100006)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13725710202416666)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100006)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13725938581416666)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13726190993416666)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13726313553416666)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100006)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13726524914416666)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100006)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13726763383416666)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100006)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13726939719416666)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100006)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13727160868416666)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13727398897416666)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100006)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13727588027416666)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100006)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13727744155416666)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100006)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13727905545416666)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13728126769416666)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13728362358416666)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13728552235416667)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100006)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13728718211416667)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100006)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13728943103416667)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13729161593416667)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100006)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13729391779416667)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100006)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13729529994416667)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13729713205416667)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13729938799416667)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13730130579416667)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13730332275416667)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13730522501416667)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13730791613416667)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100006)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13730906404416667)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100006)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13731127811416667)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13731384300416667)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100006)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13731501975416667)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13731766127416667)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100006)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13731970328416667)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100006)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13732187174416667)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13732346004416667)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100006)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13732512346416668)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100006)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13732732402416668)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100006)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13732946488416668)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13733113089416668)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13733303483416668)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13733588669416668)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100006)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13733757148416668)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100006)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13733949057416668)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13734160720416668)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13734329412416668)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13734523951416668)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13734775867416668)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13734956343416668)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13735117357416668)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13735358692416668)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13735565980416668)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13735780105416668)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100006)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13735937098416668)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100006)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13736188871416671)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100006)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13736323008416671)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100006)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13736511099416671)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100006)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13736730308416671)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100006)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13736962306416671)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100006)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13737147986416671)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13737326564416671)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100006)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13737508469416672)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100006)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13737782642416672)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100006)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13737973294416672)
,p_page_id=>5
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100006)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13738150509416672)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100006)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13738305834416672)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100006)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13738535764416672)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13738777968416672)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13738964863416672)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100006)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13739111953416672)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100006)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13739312717416672)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100006)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13739509184416672)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100006)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13739776777416672)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13739912623416672)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100006)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13740140386416672)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100006)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13740333826416672)
,p_page_id=>37
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100006)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13740574491416672)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13740779172416672)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13740991039416672)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13741165893416672)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100006)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13741390175416672)
,p_page_id=>33
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100006)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13741515309416673)
,p_page_id=>11
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13741795417416673)
,p_page_id=>39
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100006)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13741919965416673)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100006)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13742172474416673)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100006)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13742389168416673)
,p_page_id=>50
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100006)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13742538890416673)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100006)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13742704211416673)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100006)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13742967859416673)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100006)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13743178742416673)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13743369372416673)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100006)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13743538145416673)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100006)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13743736049416673)
,p_page_id=>4
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100006)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13743904727416673)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100006)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13744133408416673)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13744385572416673)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100006)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13744513837416673)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100006)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13744712793416673)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13744971750416673)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100006)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13745121028416673)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100006)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13745313348416673)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100006)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13745539819416674)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100006)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13745770524416674)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100006)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13745907496416674)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13746107815416674)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100006)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13746327877416674)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100006)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13746524916416674)
,p_page_id=>13
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100006)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13746749015416674)
,p_page_id=>38
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13746927218416674)
,p_page_id=>1
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100006)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13747149347416674)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100006)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13747357241416674)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13747565376416674)
,p_page_id=>14
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100006)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13747730886416674)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100006)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13747937990416674)
,p_page_id=>30
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100006)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13748119136416674)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100006)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13748377769416674)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100006)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13748555855416677)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13748749170416677)
,p_page_id=>51
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100006)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13748990685416677)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13749148059416677)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13749378362416677)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13749517213416677)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13749737604416678)
,p_page_id=>31
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100006)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13749942803416678)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13750151435416678)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13750321517416678)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13750536494416678)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13750733610416678)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13750939741416678)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13751115166416679)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13751351070416679)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13751565340416679)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13751791089416679)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13751964837416679)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13752178951416679)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13752380443416679)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13752599461416680)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13752706591416680)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13752941121416680)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13753186826416680)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13753305865416680)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13753520560416680)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13753765248416680)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13753900143416680)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13754191851416680)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13754335284416681)
,p_page_id=>6
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100006)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13754502184416682)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13754796819416682)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13754954339416682)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13755124848416682)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13755323046416682)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13755553909416682)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13755722900416682)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13755954499416682)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13756122023416683)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13756323601416683)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13756580831416683)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13756741998416683)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13756992019416683)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13757184885416683)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13757322059416684)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13757536171416684)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13757768435416684)
,p_page_id=>20
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100006)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13757923964416684)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13758171577416684)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13758363506416684)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13758513212416684)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13758778339416684)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13758939770416685)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100006)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13759194233416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100006)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13759305014416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100006)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13759565395416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100006)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13759708688416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100006)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13759975219416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100006)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13760199344416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100006)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13760359060416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100006)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13760571665416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100006)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13760774946416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100006)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edizione, informazioni sulla licenza'
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13760934368416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100006)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13761126404416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100006)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13761300649416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100006)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13761539995416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100006)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13761794179416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13761963442416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100006)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13762187971416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100006)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13762368631416686)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100006)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13762557449416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100006)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13762779069416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100006)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13762913349416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100006)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13763113712416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100006)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13763375509416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100006)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13763521356416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100006)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13763741777416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100006)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13763919734416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100006)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13764108249416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100006)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13764329413416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100006)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13764566778416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100006)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13764772959416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100006)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13764906689416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100006)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13765167403416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100006)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13765385553416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100006)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13765501010416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100006)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13765781067416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13765931099416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100006)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13766149588416687)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100006)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13766326222416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13766584148416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100006)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13766717433416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13766929851416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100006)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13767181549416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100006)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13767338211416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100006)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13767550909416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100006)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13767715903416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100006)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13767977661416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100006)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13768124895416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100006)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13768330733416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100006)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13768581520416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100006)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13768763649416688)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100006)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13768945887416690)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13769197832416691)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome utente'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13769343469416691)
,p_page_id=>9999
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100006)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Password'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13769592223416692)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13769723198416692)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13769989115416692)
,p_page_id=>12
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100006)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13770164857416692)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100006)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13770311746416693)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong>: non acquisisce le informazioni utente sul passo	</li>',
'    <li><strong>disabled</strong> (impostazione predefinita): acquisisce l''ID utente del passo del processo, noto al motore di flusso	</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13770572881416693)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Deve essere impostato sul mittente e-mail predefinito, nel caso in cui non sia stato definito un mittente per la posta in uscita serviceTasks.'
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13770709588416693)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Il nome utente da utilizzare nella sessione APEX per creare una sessione se non viene fornito alcun altro nome utente'
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13770929780416693)
,p_page_id=>7
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100006)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Elimina istanze di processo associate'
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13771140643416693)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100006)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se lasciato vuoto, il task verr\00E0 riservato all''utente corrente (app_user).')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13771355912416693)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Per i timer dei cicli, verr\00E0 definito il numero massimo di esecuzioni.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13771587484416694)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100006)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Formato richiesto: AAAA-MM-GG HH24:MI:SS TZR'
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13771723460416694)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong>: utilizza questa opzione solo per supportare applicazioni che sono state sviluppate con Flows for APEX 21.1 e versioni successive senza ulteriore sviluppo. Il motore non utilizza la chiave passo per impedire azioni dup'
||'licate su un singolo passo.</li>',
'    <li><strong>strict</strong> (consigliato): utilizzare questa opzione per creare una nuova applicazione di sviluppo e/o migrata completamente. Il motore utilizza il tasto passo per evitare azioni duplicate su un singolo passo.</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13771921973416694)
,p_page_id=>2
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100006)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('In caso di copia di un singolo modello, il nuovo modello avr\00E0 il nome immesso, ma se sono state selezionate pi\00F9 righe, il valore immesso verr\00E0 utilizzato come suffisso.')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13772146652416694)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lingua utilizzata per visualizzare i messaggi di errore e registrare gli eventi.'
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13772356053416694)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong>: utilizza questa opzione solo per supportare applicazioni che sono state sviluppate con Flows for APEX 21.1 e versioni successive senza ulteriore sviluppo. Il motore non utilizza la chiave passo per impedire azioni dup'
||'licate su un singolo passo.</li>',
'    <li><strong>strict</strong> (consigliato): utilizzare questa opzione per creare una nuova applicazione di sviluppo e/o migrata completamente. Il motore utilizza il tasto passo per evitare azioni duplicate su un singolo passo.</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13772571405416694)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100006)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - la registrazione \00E8 disabilitata	</li>'),
'    <li><strong>standard</strong> (impostazione predefinita) - registra gli eventi delle istanze</li>',
'    <li><strong>secure</strong> - registra eventi del modello e eventi dell''istanza	</li>',
'    <li><strong>full</strong>: registra gli eventi di modello, istanza e variabile di processo		</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13772777788416694)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L''ID applicazione di una delle applicazioni APEX che verr\00E0 fornito per creare una sessione')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13772962576416694)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L''ID pagina di una delle applicazioni che verr\00E0 fornito per creare una sessione')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13773195340416694)
,p_page_id=>36
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100006)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Per i timer dei cicli, verr\00E0 definito il numero massimo di esecuzioni.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13773396411416694)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Deve essere impostata sull''area di lavoro APEX predefinita utilizzata per Flows for APEX. Utilizzato come ultima operazione di importazione per scriptTasks e serviceTasks durante la creazione di una sessione APEX o la ricerca di modelli di posta'
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13773579129416694)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong>: non acquisisce le informazioni utente sul passo	</li>',
'    <li><strong>disabled</strong> (impostazione predefinita): acquisisce l''ID utente del passo del processo, noto al motore di flusso	</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13773748560416694)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'il nome utente da utilizzare nella sessione APEX per creare una sessione se non viene fornito alcun altro nome utente'
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13773904226416694)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100006)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (impostazione predefinita): impedisce la modifica del diagramma per i modelli rilasciati</li>',
'    <li><strong>development</strong> - consente la modifica del diagramma per i modelli rilasciati</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13774156673416694)
,p_page_id=>32
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100006)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lingua utilizzata per visualizzare i messaggi di errore e registrare gli eventi.'
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13774314198416694)
,p_page_id=>34
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100006)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (impostazione predefinita): impedisce la modifica del diagramma per i modelli rilasciati</li>',
'    <li><strong>development</strong> - consente la modifica del diagramma per i modelli rilasciati</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13774533246416694)
,p_page_id=>35
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100006)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Deve essere impostata sull''area di lavoro APEX predefinita utilizzata per Flows for APEX. Viene utilizzata come ultima risorsa per scriptTasks e serviceTasks durante la creazione di una sessione APEX o la ricerca di modelli di posta.'
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13774743979416695)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('l''ID applicazione di una delle applicazioni APEX che verr\00E0 fornita per creare una sessione')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13774968934416695)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100006)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - la registrazione \00E8 disabilitata	</li>'),
'    <li><strong>standard</strong> (impostazione predefinita) - registra gli eventi delle istanze</li>',
'    <li><strong>secure</strong> - registra eventi del modello e eventi dell''istanza	</li>',
'    <li><strong>full</strong>: registra gli eventi di modello, istanza e variabile di processo		</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13775189567416695)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100006)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('l''ID pagina di una delle applicazioni che verr\00E0 fornita per creare una sessione')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13775358494416695)
,p_page_id=>100
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100006)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Deve essere impostato sul mittente e-mail predefinito, nel caso in cui non sia stato definito un mittente per la posta in uscita serviceTasks.'
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13775555616416696)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100006)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13775708737416696)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13775902976416696)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'sec.'
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13776173529416696)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100006)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13776325260416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errori istanze'
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13776590124416697)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13776725184416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Massimo'
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13776914432416697)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100006)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'In attesa - Max'
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13777179922416697)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errori'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13777325243416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze avviate'
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13777538156416697)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-90pc'
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13777732715416697)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-10pc'
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13777976111416697)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100006)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13778126470416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze terminate'
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13778308370416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Durata 90pc'
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13778517378416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100006)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 percentile'
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13778786742416697)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'50 percentile'
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13778946025416697)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100006)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13779125927416697)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100006)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Serie 1'
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13779360550416697)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100006)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creato'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13779529420416697)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100006)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13779792188416697)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13779931984416697)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100006)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Avviato'
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13780131442416697)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100006)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Serie 1'
,p_translate_from_text=>'Series 1'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13780374338416698)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'90 percentile'
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13780581672416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-50pc'
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13780765952416698)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100006)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'In esecuzione'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13780916080416698)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100006)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13781196119416698)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completato'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13781336055416698)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminato'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13781527922416698)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Istanze completate'
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13781717772416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13781972963416698)
,p_page_id=>16
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100006)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Durata mediana'
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13782116675416698)
,p_page_id=>3
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100006)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13782304208416698)
,p_page_id=>15
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100006)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reimposta'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13782576553416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100006)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13782764977416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13782995015416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100006)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Durata - max'
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13783166775416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'In attesa - Max'
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13783396405416698)
,p_page_id=>17
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100006)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13783587308416700)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100006)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13783762232416700)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100006)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13783991992416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100006)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13784185533416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100006)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13784349608416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100006)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Stato'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13784584371416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100006)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13784713035416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100006)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13784975108416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100006)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Versione'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13785141709416701)
,p_translated_flow_id=>100006
,p_translate_to_id=>100.100006
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13785351832416702)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100006)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore del processo di archiviazione del sintetico istanza giornaliera'
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13785582795416703)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100006)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore durante la rimozione dei Flows for APEX'
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13785702784416703)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100006)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX: errore durante la rimozione delle tabelle di log.'
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13785959406416703)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100006)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errore durante la raccolta dei Flows for APEX'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13786150497416703)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13786308763416703)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13786502128416703)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100006)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13786737790416705)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>6.100003
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13786918229416705)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>50.100003
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13787178813416705)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>14.100003
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0')
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13787325421416705)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>51.100003
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\7DE8\96C6')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13787510876416705)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>1.100003
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\59CB\3081\306B')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13787724856416705)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>7.100003
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC')
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13787931221416705)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>15.100003
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\6B21\7D71\8A08')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13788177985416705)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>31.100003
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- REST - \30AF\30E9\30A4\30A2\30F3\30C8')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13788391135416705)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>36.100003
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13788505211416705)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>34.100003
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30A8\30F3\30B8\30F3\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13788792473416705)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>11.100003
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\4F5C\6210')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13788923099416706)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>30.100003
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13789188784416706)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>2.100003
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13789313898416706)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>8.100003
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\8A73\7D30')
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13789515769416706)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>12.100003
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\793A')
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13789780993416706)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>17.100003
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\7D71\8A08')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13789966493416706)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>37.100003
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \7D71\8A08')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13790158316416706)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>4.100003
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30E2\30C7\30E9\30FC')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13790321787416706)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>5.100003
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13790564191416706)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>10.100003
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30CB\30BF\30FC')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13790754165416706)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>35.100003
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13790971554416706)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>33.100003
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30A2\30FC\30AB\30A4\30D6')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13791158005416706)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>3.100003
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13791346181416706)
,p_page_id=>9
,p_translated_flow_id=>100003
,p_translate_to_id=>9.100003
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13791534900416706)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>20.100003
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30BF\30A4\30E0\30E9\30A4\30F3- &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13791760442416706)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>38.100003
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \5834\6240')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13791938867416706)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>13.100003
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\8A73\7D30')
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13792175877416706)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>39.100003
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30E9\30A4\30BB\30F3\30B9')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13792397693416706)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>16.100003
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\7D71\8A08')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13792537250416706)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>32.100003
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30ED\30AE\30F3\30B0')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13792701128416706)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>100.100003
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210[OLD\3001BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13792961786416707)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>9999.100003
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13793172095416708)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>6.100003
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8- &APP_NAME_TITLE.')
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13793332604416708)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>50.100003
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13793504955416708)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>51.100003
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\7DE8\96C6')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13793740088416708)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>1.100003
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB- &APP_NAME_TITLE.')
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13793965860416708)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>7.100003
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC- &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13794195550416709)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>15.100003
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\6B21\7D71\8A08')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13794395069416709)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>31.100003
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- REST - \30AF\30E9\30A4\30A2\30F3\30C8')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13794599743416709)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>36.100003
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13794756421416709)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>34.100003
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30A8\30F3\30B8\30F3\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13794952644416709)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>11.100003
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\4F5C\6210- &APP_NAME_TITLE.')
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13795180561416709)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>30.100003
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13795391750416709)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>2.100003
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\7BA1\7406- &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13795589829416709)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>8.100003
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\8A73\7D30- &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13795728893416709)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>12.100003
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30CB\30BF\30FC- &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13795980028416709)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>17.100003
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\7D71\8A08')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13796111578416709)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>37.100003
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \7D71\8A08')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13796353490416709)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>4.100003
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30C7\30E9\30FC- &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13796567429416709)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>5.100003
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8- &APP_NAME_TITLE.')
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13796710321416709)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>10.100003
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30CB\30BF\30FC- &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13796962361416709)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>35.100003
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13797175857416709)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>33.100003
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30A2\30FC\30AB\30A4\30D6')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13797367712416709)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>3.100003
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9- &APP_NAME_TITLE.')
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13797529474416710)
,p_page_id=>9
,p_translated_flow_id=>100003
,p_translate_to_id=>9.100003
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13797768504416710)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>20.100003
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30BF\30A4\30E0\30E9\30A4\30F3- &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13797904185416710)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>38.100003
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \5834\6240')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13798117176416710)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>39.100003
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30E9\30A4\30BB\30F3\30B9')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13798349304416710)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>16.100003
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\7D71\8A08')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13798537350416710)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>32.100003
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30ED\30AE\30F3\30B0')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13798748536416710)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>100.100003
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210[OLD\3001BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13798928336416710)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>9999.100003
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13799110972416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100003)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\3059\3079\3066\9078\629E')
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13799386518416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100003)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B2\30FC\30C8\30A6\30A7\30A4\30FB\30EB\30FC\30C8\306E\8A2D\5B9A')
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13799537122416712)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100003)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13799719880416712)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100003)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13799984109416712)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13800110445416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100003)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\3059\3079\3066\9078\629E\89E3\9664')
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13800325493416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FFD\52A0')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13800510883416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100003)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570\306E\8A2D\5B9A')
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13800719630416712)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100003)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13800999671416712)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100003)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST\69CB\6210')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13801129586416712)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13801375132416712)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100003)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8\3068\7DE8\96C6')
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13801581286416712)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100003)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13801799463416712)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100003)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13801970228416712)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13802169702416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100003)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13802313389416712)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13802584453416712)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\306E\53D7\4FE1')
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13802716198416712)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100003)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13802933739416712)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100003)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13803157704416713)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13803332168416713)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100003)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13803558586416713)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100003)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13803718839416713)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100003)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\306E\4F5C\6210')
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13803965428416713)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100003)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13804166503416713)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100003)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\5B58')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13804323471416713)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100003)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13804598241416713)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100003)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8\3068\8FFD\52A0\30A4\30F3\30DD\30FC\30C8')
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13804713134416713)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100003)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13804941708416713)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\306E\30B3\30D4\30FC')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13805189201416713)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100003)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13805312228416713)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100003)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13805521500416713)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30A4\30F3\30FB\30A4\30F3')
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13805703479416713)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100003)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13805988447416713)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100003)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST\69CB\6210')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13806107398416713)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30EA\30FC\30B9')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13806380018416713)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210')
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13806500498416713)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100003)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A4\30A2\30B0\30E9\30E0\5909\66F4')
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13806747279416713)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100003)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13806955124416714)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100003)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3\3092\8FFD\52A0')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13807175294416714)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13807329402416714)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13807584058416714)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100003)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13807770984416714)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30FC\30AB\30A4\30D6')
,p_translate_from_text=>'Archive'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13807926063416714)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13808104981416714)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100003)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13808369496416714)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100003)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13808559901416714)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100003)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13808735481416714)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13808914541416714)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100003)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C65\6B74\3092\8868\793A')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13809164929416714)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100003)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13809373515416714)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E\4F5C\6210')
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13809508555416714)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100003)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13809768735416714)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100003)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13809992385416714)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100003)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13810129175416714)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100003)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13810362184416714)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100003)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13810578973416714)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\975E\63A8\5968')
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13810703779416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13810927234416715)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100003)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3\3092\8FFD\52A0')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13811106111416715)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100003)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13811327779416715)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210\306E\7DE8\96C6')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13811570162416715)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100003)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13811793487416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\306E\9069\7528')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13811942465416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\306E\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13812132162416715)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13812388466416715)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100003)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13812559491416715)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100003)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\78BA\8A8D')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13812700317416715)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100003)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210\306E\7DE8\96C6')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13812900375416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100003)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FFD\52A0')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13813182431416715)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100003)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13813331924416715)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100003)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53D6\6D88')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13813521184416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\78BA\8A8D')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13813739286416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100003)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13813981715416715)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100003)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13814171309416715)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100003)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4FDD\5B58')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13814368527416719)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100003)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13814576895416719)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FCID\306E\975E\8868\793A')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13814729162416719)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID\5217')
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13814913491416719)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E9\30A4\30BB\30F3\30B9\30FB\30AD\30FC')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13815170811416719)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7\5217')
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13815372293416719)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D9\30FC\30B9URL')
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13815547701416719)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100003)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13815772693416719)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30DA\30A4\30ED\30FC\30C9')
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13815970872416720)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100003)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63A5\7D9A')
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13816182847416720)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\96FB\5B50\30E1\30FC\30EB\9001\4FE1\8005')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13816301753416720)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13816524103416720)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13816731689416720)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13816936799416720)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13817156410416720)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13817357229416720)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13817502223416720)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\7E70\8FD4\3057\9593\9694')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13817772800416720)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30A1\30A4\30EB\540D')
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13817904965416720)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13818121887416720)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30B1\30C3\30C8\540D')
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13818352144416720)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100003)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E9\30A4\30BB\30F3\30B9\30FB\30A8\30C7\30A3\30B7\30E7\30F3')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13818503787416720)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100003)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8\5143')
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13818741109416720)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\64CD\4F5C')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13818959178416720)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13819148756416720)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13819388563416720)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\63A5\982D\8F9E')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13819519541416720)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\4ED8')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13819791091416720)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\898F')
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13819973761416720)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100003)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E0A\66F8\304D\306E\5F37\5236')
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13820142392416720)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13820325057416721)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\6700\5927\30B5\30A4\30AF\30EB')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13820548085416721)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\30FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13820796735416721)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13820905589416721)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9F\884C\8005')
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13821143526416721)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\540D')
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13821343476416721)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\7D42\5909\66F4\65E5\3092\542B\3080')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13821560586416721)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30D7')
,p_translate_from_text=>'Type'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13821710607416721)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100003)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B2\30FC\30C8\30A6\30A7\30A4')
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13821967177416721)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6708\6B21\8981\7D04\306E\4FDD\6301(\6708\6570)')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13822165390416721)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\30FB\30D5\30ED\30FC\30FB\30ED\30B0\4FDD\6301(\65E5\6570)')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13822358465416721)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100003)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30B9\30B1\30FC\30C9')
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13822521436416721)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100003)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13822765927416721)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30EC\30D9\30EB')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13822970798416721)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13823180715416721)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13823324362416721)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\306E\4FDD\6301(\65E5\6570)')
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13823586168416721)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13823764886416721)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A4\30A2\30B0\30E9\30E0XML')
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13823932845416721)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3\3092\542B\3080')
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13824147212416722)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30A1\30A4\30EB')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13824313890416722)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\306E\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13824517983416722)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A2\30FC\30AB\30A4\30D6\306E\5834\6240')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13824769031416722)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13824906051416722)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\540D\306B\3066\30C0\30A6\30F3\30ED\30FC\30C9')
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13825158682416722)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13825314415416722)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13825557895416722)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30B7\30FC\30AF\30EC\30C3\30C8')
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13825784985416722)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\306E\91CD\8907\9632\6B62')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13825906778416722)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\3057\3044\540D\524D/\63A5\5C3E\8A9E')
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13826105917416722)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX\8CC7\683C\8A3C\660E\9759\7684ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13826391059416722)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A00\8A9E')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13826560393416722)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9759\7684ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13826797997416722)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100003)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6240\6709\8005')
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13826984034416722)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E9\30A4\30BB\30F3\30B9\5148')
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13827192440416722)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\306E\91CD\8907\9632\6B62')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13827304053416722)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30D9\30EB')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13827590563416722)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13827739939416722)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13827948471416722)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13828115834416722)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30B3\30FC\30D7')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13828308623416723)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D3\30B8\30CD\30B9\53C2\7167(\30D7\30ED\30BB\30B9\5909\6570)')
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13828580521416723)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\3092\542B\3081\308B')
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13828718757416723)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\30FB\30A4\30F3\30D0\30A6\30F3\30C9MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13828930457416723)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100003)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\6700\5927\30B5\30A4\30AF\30EB')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13829144580416723)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9B\5148\30BF\30A4\30D7')
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13829386407416723)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13829545629416723)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30FC\30C9')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13829797759416723)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN\30D5\30A1\30A4\30EB\30FB\30B3\30F3\30C6\30F3\30C4\3092\8CBC\308A\4ED8\3051\307E\3059(\6700\592730 000\6587\5B57)\3002')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13829976386416723)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13830193472416723)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\6B21\8981\7D04\306E\4FDD\6301(\65E5\6570)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13830319632416723)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FCID\306E\975E\8868\793A')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13830563531416723)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\30FB\30A4\30F3\30D0\30A6\30F3\30C9MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13830791759416723)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\306E\4FDD\6301(\30D7\30ED\30BB\30B9 \30A4\30F3\30B9\30BF\30F3\30B9\5B8C\4E86\5F8C\306E\65E5\6570)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13830995327416723)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13831120667416723)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX\8CC7\683C\8A3C\660E\9759\7684ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13831373068416723)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\4F7F\7528\53EF\80FD')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13831536143416723)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BLOB\5217')
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13831713661416723)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100003)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E9\30A4\30BB\30F3\30B9\6709\52B9\671F\9650')
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13831906563416723)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13832126420416723)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7740\4FE1\5F85\6A5F\30B3\30FC\30EB\306E\30ED\30B0')
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13832383101416723)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30C0\30A4\30EC\30AF\30C8URI')
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13832502872416724)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A8D\8A3C\524DURL')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13832776474416724)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100003)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30FC\30C9')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13832909855416724)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\306E\4FDD\6301(\30D7\30ED\30BB\30B9 \30A4\30F3\30B9\30BF\30F3\30B9\5B8C\4E86\5F8C\306E\65E5\6570)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13833168194416724)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30DD\30FC\30C8URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13833399562416724)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9\3092\542B\3080')
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13833551676416724)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13833779332416724)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100003)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A00\8A9E')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13833994084416724)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\63A5\982D\8F9E')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13834156762416724)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30B5\30DE\30EA\30FC\30FB\30A2\30FC\30AB\30A4\30D6\306E\6709\52B9\5316')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13834301454416724)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13834500174416724)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13834748984416724)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13834956119416724)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100003)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30FC\30C9')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13835102429416724)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\540D\3092\4FDD\5B58')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13835349445416724)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13835524573416724)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13835791880416724)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\3092\4ECA\3059\3050\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13835988080416724)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\30FB\30D5\30ED\30FC\30FB\30ED\30B0\4FDD\6301')
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13836128492416724)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13836300961416724)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8AAC\660E')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13836553594416725)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30D9\30EB')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13836773700416725)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13836947603416725)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\56DB\534A\671F\8981\7D04\306E\4FDD\6301(\6708)')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13837100424416725)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\540D')
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13837310177416725)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13837545006416725)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13837764119416725)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100003)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D9\30FC\30B9URL')
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13837934853416725)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30DD\30FC\30C8\30E1\30FC\30EB\30A2\30C9\30EC\30B9')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13838102088416725)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\4F7F\7528\53EF\80FD')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13838313872416725)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13838526550416725)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100003)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13838761176416725)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\30FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13838956349416725)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\691C\7D22')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13839149752416725)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100003)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13839387418416725)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30B5\30DE\30EA\30FC\30FB\30A2\30FC\30AB\30A4\30D6\306E\6709\52B9\5316')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13839551515416725)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\96FB\5B50\30E1\30FC\30EB\9001\4FE1\8005')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13839747115416741)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100003)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('JSON\5F62\5F0F\304C\7121\52B9\3067\3059')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13839810205416741)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100003)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\306B\306F\5024\304C\5FC5\8981\3067\3059\3002')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13840037262416741)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100003)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\63D0\4F9B\3055\308C\305F\30D5\30ED\30FC\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13840236660416741)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\306B\306F\5024\304C\5FC5\8981\3067\3059\3002')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13840417083416741)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100003)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\306B\306F\5024\304C\5FC5\8981\3067\3059\3002')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13840644961416741)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\306B\306F\5024\304C\5FC5\8981\3067\3059\3002')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13840837543416741)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'You cannot archived a model which is associated with running instances.'
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13841090136416741)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100003)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN\30D5\30A1\30A4\30EB\30FB\30B3\30F3\30C6\30F3\30C4\3092\8CBC\308A\4ED8\3051\3066\304F\3060\3055\3044')
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13841224393416741)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100003)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13841493502416742)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\4E0A\66F8\304D\306E\5F37\5236\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13841680514416742)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\4E0A\66F8\304D\306E\5F37\5236\3092\4F7F\7528\3057\307E\3059\3002')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13841863433416742)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\304C\30A4\30F3\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13842055167416742)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100003)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13842201808416742)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100003)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13842409327416742)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100003)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13842610158416742)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100003)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13842807841416742)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100003)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13843012717416742)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100003)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rest\69CB\6210\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13843224880416742)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13843441590416742)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100003)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13843624538416742)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100003)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13843843149416742)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100003)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13844054285416743)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100003)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\51E6\7406\6E08\3002')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13844294950416743)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100003)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13844426346416743)
,p_page_id=>9
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100003)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13844637651416743)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\304C\30A4\30F3\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13844833273416744)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100003)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13845093181416744)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100003)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13845209528416744)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100003)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E\8A73\7D30')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13845472877416744)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100003)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13845669604416744)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100003)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('OAUTH\30AF\30E9\30A4\30A2\30F3\30C8')
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13845843427416744)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100003)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13846077491416744)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100003)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13846212069416744)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100003)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13846451477416744)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100003)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\69CB\6210- REST - \30AF\30E9\30A4\30A2\30F3\30C8')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13846647456416744)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100003)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13846824460416744)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9(\671F\9593\8981\7D04)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13847081115416744)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100003)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\73FE\5728\306E\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13847206442416744)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100003)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30DC\30BF\30F3\30FB\30D0\30FC')
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13847426445416744)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100003)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5909\6570\5C65\6B74')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13847666838416744)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100003)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON\69CB\6210')
,p_translate_from_text=>'JSON Configuration'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13847802457416744)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100003)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13848052873416744)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13848208330416744)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13848498549416745)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100003)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13848640975416745)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9\3054\3068\306E\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13848837089416745)
,p_page_id=>9
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100003)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BB\30AF\30B7\30E7\30F3')
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13849091054416745)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100003)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B8C\4E86\6E08\307F\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13849240876416745)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\691C\7D22')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13849402289416745)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30C0\30A4\30A2\30B0\30E9\30E0\306E\8A73\7D30')
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13849672680416745)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\306E\8CFC\8AAD')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13849875557416745)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100003)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13850081680416745)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100003)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13850256135416745)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100003)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13850442925416745)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100003)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\59CB\3081\306B')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13850661218416745)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13850802686416745)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\4F5C\6210')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13851063962416745)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100003)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3\306E\4E0D\4E00\81F4')
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13851228990416745)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100003)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8\30FB\30D5\30ED\30FC')
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13851405058416745)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100003)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13851675426416745)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\524D\63D0\6761\4EF6\304C\3042\308A\307E\305B\3093')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13851813332416745)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100003)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30DC\30BF\30F3')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13852040491416745)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100003)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13852256117416745)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100003)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\691C\7D22\7D50\679C')
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13852418362416745)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100003)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3\30A2\30D7\30EA')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13852643527416746)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100003)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7D71\8A08')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13852861697416746)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100003)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3\30A2\30D7\30EA')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13853081783416746)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\904E\53BB14\65E5\9593\306E\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A8\30E9\30FC')
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13853290204416746)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100003)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON\69CB\6210')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13853469089416746)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100003)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13853602157416746)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30D3\30E5\30FC\30A2\30FC')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13853846926416746)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100003)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13854006393416746)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5834\6240')
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13854205745416746)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100003)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30AA\30D7\30B7\30E7\30F3')
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13854461499416746)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100003)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B2\30FC\30C8\30A6\30A7\30A4\30FB\30EB\30FC\30C8\306E\8FFD\52A0')
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13854670089416746)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100003)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13854847785416746)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100003)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13855065776416746)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100003)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30EA\30F3\30AF')
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13855234150416746)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13855456608416746)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13855675187416746)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13855810475416746)
,p_page_id=>9
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100003)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13856054865416746)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E2\30B8\30E5\30FC\30EB\304C\3042\308A\307E\305B\3093')
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13856205994416746)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\30EA\30B9\30C8')
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13856413425416746)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13856604259416746)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100003)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13856878166416747)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30DC\30BF\30F3\30FB\30B3\30F3\30C6\30CA')
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13857072302416747)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100003)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13857269908416747)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\306E\30B3\30D4\30FC')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13857422257416747)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\4E8B\524D\30BF\30B9\30AF\30A8\30E9\30FC')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13857651016416747)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100003)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME.\306E\5C65\6B74\30B9\30C6\30C3\30D7\5F85\6A5F\6642\9593( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13857862300416747)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100003)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13858030234416747)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100003)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5B8C\4E86\6E08\307F\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13858206920416747)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100003)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\73FE\5728\306E\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13858469023416747)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30D3\30E5\30FC\30A2\30FC')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13858653639416747)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100003)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30ED\30AE\30F3\30B0')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13858868800416747)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100003)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30FC\30AB\30A4\30D6')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13859014046416747)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100003)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13859260872416747)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100003)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13859430827416747)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100003)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13859669918416747)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100003)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13859898357416747)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100003)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13860020972416747)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13860264057416747)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100003)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E9\30A4\30BB\30F3\30B9')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13860422562416747)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13860675509416747)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100003)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13860804379416748)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100003)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13861015621416748)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('REST\5BFE\5FDC\3067\306F\306A\3044')
,p_translate_from_text=>'Not REST Enabled'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13861230765416748)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30D6')
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13861456146416748)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100003)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME.\306E\5C65\6B74\30B9\30C6\30C3\30D7\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13861622115416748)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30ED\30FC\30EB')
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13861848077416748)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100003)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8\8B66\544A')
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13862036553416748)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E\8A73\7D30')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13862227900416748)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100003)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13862420980416748)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13862696903416748)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E\8A73\7D30')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13862881802416748)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100003)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5909\6570\5C65\6B74')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13863041263416748)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\69CB\6210')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13863265121416748)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100003)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13863429092416748)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100003)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\73FE\5728\306E\671F\9650\8D85\904E\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13863629635416748)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100003)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13863828985416748)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\60C5\5831')
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13864051180416748)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100003)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13864241607416748)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13864405594416748)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100003)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13864624743416749)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100003)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\304C&P15_DATE.\306B\958B\59CB\3055\308C\307E\3057\305F\3002')
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13864803336416749)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100003)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8FFD\52A0\306E\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30C6\30C3\30D7\304C\5B8C\4E86\3057\3066\3044\307E\305B\3093')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13865051387416749)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100003)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\7DE8\96C6')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13865295246416749)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100003)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13865443766416749)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100003)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13865601725416749)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100003)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13865873601416749)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100003)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\30FB\30B9\30C6\30C3\30D7\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9(\4ECA\6708) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )')
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13866036742416749)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30A8\30E9\30FC')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13866256822416749)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FCXML')
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13866494715416749)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100003)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5165\51FA\529B\5909\6570')
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13866696595416749)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A73\7D30\3092\5165\529B')
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13866824279416749)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100003)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13867055636416749)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100003)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5909\6570')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13867232493416749)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100003)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13867439384416749)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100003)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13867686794416749)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100003)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9\5F53\305F\308A\306E\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13867826967416749)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100003)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\306E\524A\9664')
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13868024863416749)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100003)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13868216902416749)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30AF\30C6\30A3\30D6\306A\5B9B\5148\3092\9078\629E\3057\307E\3059')
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13868406999416749)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100003)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\5F53\305F\308A\306E\73FE\5728\306E\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9- \4E0A\4F4D10\4EF6')
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13868637365416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100003)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\306E\4E88\7D04')
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13868897523416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100003)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570\306E\8FFD\52A0/\7DE8\96C6')
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13869045418416750)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13869276215416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13869484400416750)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100003)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\904E\53BB14\65E5\9593\306B\958B\59CB\3055\308C\305F\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13869616838416750)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13869826358416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100003)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13870042418416750)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\304C\7121\52B9')
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13870268184416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100003)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13870446669416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\306E\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13870628408416750)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('APEX\30A2\30C3\30D7\30B0\30EC\30FC\30C9\304C\691C\51FA\3055\308C\307E\3057\305F')
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13870822230416750)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13871044111416750)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\59CB\3081\306B')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13871227278416750)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13871411221416750)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100003)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13871660651416750)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13871816669416750)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100003)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13872060935416750)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30CB\30BF\30FC(&P12_PRCS_NAME.)')
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13872277421416750)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\8A00\8A9E\9078\629E')
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13872475261416751)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100003)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30DC\30BF\30F3')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13872692946416751)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100003)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30ED\30AE\30F3\30B0')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13872839412416751)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30D3\30E5\30FC\30A2\30FC')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13873049850416751)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13873286079416751)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\306E\53D7\4FE1')
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13873471754416751)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13873698315416751)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30A8\30E9\30FC')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13873892279416751)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\30B3\30F3\30C6\30F3\30C4')
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13874039599416765)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100003)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13874207255416765)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13874413703416766)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13874621461416766)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100003)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13874803184416766)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100003)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13875039873416766)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13875231035416766)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13875493867416766)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100003)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13875614561416766)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100003)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\72EC\81EA\306E\30D5\30A9\30FC\30E0\5B9A\7FA9\3092\5BA3\8A00\7684\306B\7C21\5358\306B\69CB\7BC9\3059\308B\306B\306F\3001<a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">\7C21\6613\30D5\30A9\30FC\30E0\30FB\30D3\30EB\30C0\30FC</span></a>\3092\4F7F\7528\3057\3066\3001\5FC5\8981\306AJSON\3092\751F\6210\3067\304D\307E\3059\3002')
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13875881384416766)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100003)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13876079759416766)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13876204670416766)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100003)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13876469952416767)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>REST\30E2\30B8\30E5\30FC\30EB\304C\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\307E\305B\3093\3002\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30AC\30A4\30C9(<a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>)\306B\5F93\3063\3066\304F\3060\3055\3044\3002')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13876643490416767)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13876813584416767)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100003)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13877067749416767)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100003)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\52D5\4F5C\3092\4FDD\8A3C\3059\308B\305F\3081\3001Flows for APEX \3092\4F7F\7528\3057\3066\4F5C\6210\3057\305F\30E2\30C7\30EB\3092\30A4\30F3\30DD\30FC\30C8\3059\308B\3053\3068\3092\304A\52E7\3081\3057\307E\3059\3002')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13877278251416767)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>\30B9\30AD\30FC\30DE\306FREST\5BFE\5FDC\3067\306F\3042\308A\307E\305B\3093</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13877467174416767)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\3067\306F\3001\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306EJSON\5B9A\7FA9\3092\7BA1\7406\3067\304D\307E\3059\3002\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\6B21\306E2\3064\306E\65B9\6CD5\3067\4F7F\7528\3067\304D\307E\3059\3002<ul>'),
unistr('    <li>\30D5\30ED\30FC\30FB\30E2\30C7\30EB\306E\300C\7C21\6613\30D5\30A9\30FC\30E0\300D\30BF\30A4\30D7\306E\30E6\30FC\30B6\30FC\30FB\30BF\30B9\30AF\3067\305D\308C\3089\3092\9078\629E\3057\307E\3059</li>'),
unistr('    <li>Flows\30C7\30A3\30B9\30C8\30EA\30D3\30E5\30FC\30B7\30E7\30F3\306E<strong>Simple Process Starter App</strong>\3067\3053\308C\3089\3092\5229\7528\3057\3066\3001\30D5\30A9\30FC\30E0\306B\5165\529B\3059\308B\3053\3068\3067\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9\3092\958B\59CB\3057\307E\3059</ul>')))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13877656287416767)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100003)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13877882408416767)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100003)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13878044801416767)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100003)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX\306E\30BF\30A4\30DE\30FC\6A5F\80FD\3092\4F7F\7528\3059\308B\306B\306F\3001<a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">\3053\3053</a>\306B\3042\308B\8FFD\52A0\306E\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30C6\30C3\30D7\3092\5B8C\4E86\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13878221274416767)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100003)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13878492555416767)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100003)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13878651526416767)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\3064\4EE5\4E0A\306E\30BF\30A4\30DE\30FC\304C\542B\307E\308C\3066\3044\308B\30E2\30C7\30EB\304C\7121\52B9\306B\306A\3063\3066\3044\308B\305F\3081\3001\3053\306E\30B7\30B9\30C6\30E0\3067\6B63\3057\304F\52D5\4F5C\3067\304D\307E\305B\3093\3067\3057\305F\3002<br>\300C\69CB\6210\300D\30DA\30FC\30B8\3067\6709\52B9\306B\3067\304D\307E\3059\3002')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13878886779416767)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13879054532416767)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100003)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13879242248416768)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100003)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13879486877416768)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>APEX\7528\306E\30ED\30FC\30FB\30B3\30FC\30C9BPMN\30D9\30FC\30B9\306E\30D7\30ED\30BB\30B9\30FB\30D5\30ED\30FC\30FB\30B7\30B9\30C6\30E0\3002</h3>'),
unistr('<h4> \6A5F\80FD</h4>'),
'<ul>',
unistr('<li>Flows for APEX\3092\4F7F\7528\3059\308B\3068\3001APEX\958B\767A\8005\306F\3001\30D3\30B8\30E5\30A2\30EB\30FB\30D7\30ED\30BB\30B9\8A2D\8A08\3068\30ED\30FC\30B3\30FC\30C9\6280\8853\3092\7D44\307F\5408\305B\3066\3001APEX\3067\30D7\30ED\30BB\30B9\30FB\30D5\30ED\30FC\3092\30E2\30C7\30EB\5316\304A\3088\3073\5B9F\884C\3067\304D\307E\3059\3002</li>'),
unistr('<li>\4E3B\306BAPEX\958B\767A\8005\5411\3051\306B\8A2D\8A08\3055\308C\305FFlows for APEX\306F\3001APEX\3001PL/SQL\3001SQL\306A\3069\3001\4F7F\3044\6163\308C\305F\30C6\30AF\30CE\30ED\30B8\3092\4F7F\7528\3057\3066\3001APEX\74B0\5883\3067\5F37\529B\3067\67D4\8EDF\306A\30D7\30ED\30BB\30B9\30FB\30D5\30ED\30FC\3092\4F5C\6210\3057\307E\3059\3002</li>'),
unistr('<li>APEX\30DA\30FC\30B8\3001PL/SQL\30B9\30AF\30EA\30D7\30C8\3001\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\306E\30D7\30ED\30BB\30B9\30FB\30D5\30ED\30FC\3092\4F5C\6210\304A\3088\3073\5B9F\884C\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002</li>'),
unistr('<li> \30ED\30FC\30B3\30FC\30C9\306E\56F3\5F0F\30D7\30ED\30BB\30B9\5B9A\7FA9\306F\3001\30D3\30B8\30CD\30B9\30FB\30E6\30FC\30B6\30FC\304C\7406\89E3\304A\3088\3073\7DE8\96C6\3057\3066\3001\30D3\30B8\30CD\30B9\306E\67D4\8EDF\6027\3092\9AD8\3081\308B\3053\3068\3082\3067\304D\307E\3059\3002\30D5\30ED\30FC\3067\306F\3001\30D3\30B8\30CD\30B9\30FB\30D7\30ED\30BB\30B9\30FB\30E2\30C7\30EA\30F3\30B0\8868\8A18\6CD5(BPMN)\306EV2\30B9\30BF\30A4\30EB\304C\4F7F\7528\3055\308C\307E\3059</li>'),
unistr('<li>APEX\30B3\30DF\30E5\30CB\30C6\30A3\30FB\30D7\30ED\30B8\30A7\30AF\30C8\3068\3057\3066\69CB\7BC9\3055\308C\3001\30AA\30FC\30D7\30F3\30FB\30BD\30FC\30B9\306EMIT\30E9\30A4\30BB\30F3\30B9\3067\30EA\30EA\30FC\30B9\3055\308C\307E\3057\305F\3002</li>'),
'</ul>',
'<p>',
unistr('<h4>\30C0\30A6\30F3\30ED\30FC\30C9</h4>'),
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a> <p>',
unistr('<h4>\30C9\30AD\30E5\30E1\30F3\30C8</h4>'),
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">\6700\65B0\306E\30AA\30F3\30E9\30A4\30F3\30FB\30C9\30AD\30E5\30E1\30F3\30C8</a> <p>'),
unistr('<h4>BPMN\30C1\30E5\30FC\30C8\30EA\30A2\30EB</h4>'),
unistr('\30E2\30C7\30EA\30F3\30B0 \30D5\30ED\30FC\3092\958B\59CB\3059\308B\306B\306F\3001\30D7\30EA\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\308B\30C1\30E5\30FC\30C8\30EA\30A2\30EB \30D5\30ED\30FC\3092\8A66\3057\3066\304F\3060\3055\3044\3002\30C1\30E5\30FC\30C8\30EA\30A2\30EB\306E\8A73\7D30\306F\3001<a href="https://flowsforapex.org/latest/tutorials/" target="_blank">\3053\3053</a>\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002<p>'),
unistr('<h4>\30C7\30E2\30A2\30D7\30EA</h4>'),
'<p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13879614183416768)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100003)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13879811279416768)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13880085369416771)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100003)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN\306E\5834\6240')
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13880288868416771)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13880424037416771)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100003)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30FC\30AB\30A4\30D6\306E\5834\6240')
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13880648867416771)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13880886243416771)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100003)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13881030181416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100003)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13881202835416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100003)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13881448563416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100003)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13881656235416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100003)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13881806316416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100003)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13882063305416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100003)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30D4\30FC')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13882222457416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100003)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\4E86')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13882477087416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100003)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13882676908416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100003)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\4E86')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13882866096416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100003)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C6\30FC\30DE')
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13883010208416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100003)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E9\30A4\30BB\30F3\30B9')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13883261728416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100003)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\4E86')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13883415095416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100003)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30CB\30BF\30FC')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13883678091416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13883852095416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100003)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13884071995416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100003)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13884202737416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100003)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A73\7D30\306E\8868\793A')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13884417892416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100003)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3\3092\8FFD\52A0')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13884689881416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100003)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13884869062416772)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100003)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9(SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13885003988416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13885227160416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100003)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30B5\30DE\30EA\30FC')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13885484578416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100003)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7DE8\96C6')
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13885692387416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100003)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13885884309416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100003)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13886079015416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30BF\30A4\30E0\30E9\30A4\30F3\306E\8868\793A')
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13886288535416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100003)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13886489330416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100003)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13886636154416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100003)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13886896573416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100003)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\8A73\7D30\306E\8868\793A')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13887016733416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100003)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13887238677416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100003)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\524A\9664')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13887430530416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100003)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B0\30D0\30FC\30B8\30E7\30F3\3092\8FFD\52A0')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13887627134416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100003)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\81EA\52D5')
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13887820137416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13888054116416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100003)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3\30A2\30D7\30EA')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13888207783416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100003)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13888425885416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100003)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13888657508416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100003)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C65\6B74\3092\8868\793A')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13888819429416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100003)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30FC\30AB\30A4\30D6')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13889083770416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100003)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D71\8A08')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13889281374416773)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100003)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9(SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13889446771416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100003)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13889634432416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100003)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30DD\30FC\30C8\306E\4E0B|\4E26\5217|\65B0\898F\30A6\30A3\30F3\30C9\30A6')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13889828081416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100003)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13890025707416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30B0\30A2\30A6\30C8')
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13890219087416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100003)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13890491918416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100003)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\59CB\3081\306B')
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13890677226416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100003)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13890875420416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100003)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13891030216416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100003)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\793A\8A2D\5B9A')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13891214622416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13891468456416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100003)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30DD\30FC\30C8')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13891650031416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100003)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13891863375416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100003)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13892046501416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100003)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30D4\30FC')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13892211778416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30FC\30AF\30E2\30FC\30C9')
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13892409810416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100003)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13892681323416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100003)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13892831786416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100003)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\8A73\7D30\306E\8868\793A')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13893038725416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100003)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13893273305416774)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13893420810416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30EA\30FC\30B9')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13893660194416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100003)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\793A\8A2D\5B9A')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13893886876416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100003)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BD\30FC\30B9\3092\8868\793A')
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13894014304416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100003)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8A73\7D30\306E\8868\793A')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13894241689416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100003)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13894473457416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\518D\8D77\52D5')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13894614394416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13894843363416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100003)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13895019989416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100003)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30AE\30F3\30B0')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13895259361416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30EA\30FC\30B9')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13895445616416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100003)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13895617836416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100003)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13895878184416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100003)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9(SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13896072276416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100003)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13896263601416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100003)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8868\793A')
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13896405335416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100003)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13896665263416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E9\30A4\30C8\30E2\30FC\30C9')
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13896821683416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100003)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13897035700416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100003)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13897287955416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100003)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30DD\30FC\30C8\306E\4E0B|\4E26\5217|\65B0\898F\30A6\30A3\30F3\30C9\30A6')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13897462867416775)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100003)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C65\6B74\3092\8868\793A')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13897603945416776)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13897854991416776)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\518D\8D77\52D5')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13898010303416776)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100003)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13898274136416780)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13898449720416780)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13898652984416780)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100003)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C5E\6027\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13898822490416780)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\304C\3042\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13899090059416780)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100003)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\51FA\5165\529B\5909\6570\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13899240529416781)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\691C\7D22\30C0\30A4\30A2\30ED\30B0')
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13899416889416781)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13899627927416782)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13899853282416782)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13900080855416782)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13900224846416782)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\691C\7D22')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13900467623416782)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9589\3058\308B')
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13900658334416783)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6B21\306E>')
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13900841449416783)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<\524D\3078')
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13901090426416783)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\3053\306E\524A\9664\51E6\7406\3092\5B9F\884C\3057\307E\3059\304B?')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13901247420416783)
,p_translated_flow_id=>100003
,p_translate_to_id=>100.100003
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EF\30FC\30AF\30D5\30ED\30FC')
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13901450193416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100003)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\7D71\8A08')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13901698668416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100003)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13901886013416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100003)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST\30B5\30FC\30D3\30B9')
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13902014873416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13902221647416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100003)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30FC\30AB\30A4\30D6')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13902449218416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100003)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30CB\30BF\30FC')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13902659039416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100003)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30BF\30A4\30E0\30E9\30A4\30F3- &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13902825295416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100003)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13903034935416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100003)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13903293841416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100003)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13903430949416784)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100003)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\7D71\8A08')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13903649952416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100003)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D71\8A08')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13903811640416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100003)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3\30A2\30D7\30EA')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13904035566416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100003)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\6B21\7D71\8A08')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13904238429416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100003)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13904481754416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100003)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\69CB\6210- \30E9\30A4\30BB\30F3\30B9')
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13904616064416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100003)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30E2\30C7\30E9\30FC')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13904841672416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100003)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30ED\30AE\30F3\30B0')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13905015489416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100003)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13905227202416785)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100003)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13905460363416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100003)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30A1\30A4\30EB')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13905649578416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100003)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\306E\5F8C')
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13905827616416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100003)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5206\5272\524D')
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13906099516416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100003)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\4E86\5F8C\306E\30D7\30ED\30BB\30B9\30FB\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13906277130416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100003)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13906438039416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100003)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13906671130416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100003)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BCC'
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13906842722416786)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100003)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\4ED8')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13907068236416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100003)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Interval Year to Month'
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13907228946416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100003)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\5185')
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13907465263416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100003)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C6\30AD\30B9\30C8')
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13907641912416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100003)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL\30B9\30AF\30EA\30D7\30C8')
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13907899200416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100003)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30AF\30A8\30B9\30C8')
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13908003460416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100003)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30DA\30FC\30B8\30A2\30A4\30C6\30E0')
,p_translate_from_text=>'Page Items'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13908249410416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100003)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\304C\518D\3073\8D77\52D5\3059\308B\307E\3067\306E\6642\9593')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13908429958416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100003)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\5927\5B9F\884C\6570')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13908699277416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100003)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\51FA\529B\5909\6570')
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13908895643416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100003)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13909090454416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100003)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30DA\30FC\30B8')
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13909247331416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100003)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
,p_translate_from_text=>'Format Mask'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13909439426416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100003)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Interval Day to Second'
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13909604772416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100003)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\304C\6700\521D\306B\8D77\52D5\3059\308B\307E\3067\306E\6642\9593')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13909861822416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100003)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30F3\30B8\30F3')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13910076437416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100003)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\5B9A\7FA9\30BF\30A4\30D7')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13910217181416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100003)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\5B9A\7FA9')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13910400395416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100003)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8FD4\4FE1\5148')
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13910691221416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\540D\3092\4FDD\5B58')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13910813463416787)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100003)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN\30D5\30A1\30A4\30EB')
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13911041966416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100003)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\524D')
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13911292025416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100003)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9B\5148')
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13911494197416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100003)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CC'
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13911600754416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100003)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5373\6642\9001\4FE1')
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13911800584416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100003)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\524D')
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13912085368416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100003)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13912296468416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100003)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('HTML\672C\6587')
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13912461976416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100003)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30DE\30FC\30B8\5F8C')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13912631088416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100003)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5DEE\51FA\4EBA')
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13912824513416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100003)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9759\7684\5024')
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13913050855416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100003)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4EF6\540D')
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13913257301416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100003)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30A4\30C6\30E0')
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13913470428416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100003)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL\554F\5408\305B(\30B3\30ED\30F3\533A\5207\308A\306E\5024\3092\623B\3059)')
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13913654928416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100003)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL\5F0F')
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13913875313416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100003)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL\30B3\30FC\30C9')
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13914085614416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100003)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13914237388416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100003)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\6642')
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13914496279416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100003)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6DFB\4ED8\30D5\30A1\30A4\30EB')
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13914643985416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100003)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL\554F\5408\305B(\5358\4E00\5024\3092\623B\3059)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13914829217416788)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100003)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3092\30AF\30EA\30A2')
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13915009279416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100003)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30A4\30C6\30E0\5024')
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13915212987416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100003)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\672C\6587')
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13915451164416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100003)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30B9\30AF\30FB\30BF\30A4\30D7')
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13915610229416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100003)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F7F\7528')
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13915878521416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100003)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8ID')
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13916099590416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100003)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13916279373416789)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100003)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30A4\30F3\30C9\30FB\30DA\30FC\30B8\30A2\30A4\30C6\30E0\5024')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13916418971416792)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC\304C\30ED\30B0\3055\308C\3066\3044\307E\305B\3093')
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13916626635416792)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30EC\30D9\30EB\304C\30ED\30B0\3055\308C\3066\3044\307E\305B\3093')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13916864374416792)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'- Select -'
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13917094598416792)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\306A\3057')
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13917281096416792)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100003)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65B9\5411')
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13917467509416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100003)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13917696327416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100003)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13917873636416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100003)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC\30FB\30B9\30BF\30C3\30AF')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13918046505416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100003)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13918232359416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100003)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13918421467416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100003)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13918608982416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13918846551416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100003)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13919039317416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100003)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\65E5')
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13919294385416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13919407681416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100003)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30FC\30EB\53EF\80FD')
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13919677385416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100003)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\521D\671F\5316')
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13919862186416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100003)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13920006723416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13920208627416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100003)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30DA\30FC\30B8ID')
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13920436243416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100003)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13920609284416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100003)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13920821809416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100003)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13921089091416793)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100003)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13921245910416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100003)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\7D42\66F4\65B0\65E5')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13921451055416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100003)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30BF\30A4\30C8\30EB')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13921684057416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100003)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30A2\30A4\30B3\30F3')
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13921820004416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100003)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13922042385416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13922290558416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100003)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\6458\8981')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13922419539416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100003)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13922658484416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13922877404416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100003)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13923038883416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100003)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13923229242416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100003)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
,p_translate_from_text=>'Application Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13923461067416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100003)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\8272')
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13923634386416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100003)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30FC\30BF\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13923842870416794)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100003)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8AAC\660E')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13924012300416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100003)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13924228130416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\512A\5148\5EA6')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13924425320416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100003)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13924690644416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100003)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30BF\30A4\30D7')
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13924880377416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100003)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13925027556416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100003)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13925267680416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\65E5')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13925432548416795)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100003)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13925656821416797)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100003)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13925860553416797)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100003)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13926017279416797)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100003)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13926228539416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13926471729416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13926649572416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100003)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13926837707416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100003)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13927000350416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100003)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13927266856416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13927415106416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100003)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13927667766416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13927885738416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100003)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13928032869416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100003)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13928276932416798)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100003)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13928490012416799)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li>One Model: \3059\3079\3066\306E\5C5E\6027\3092\6307\5B9A\3057\3066\5358\4E00\306E\30E2\30C7\30EB\3092\30A4\30F3\30DD\30FC\30C8\3057\307E\3059</li>'),
unistr('    <li>\8907\6570\306E\30E2\30C7\30EB: zip\30D5\30A1\30A4\30EB\3092\63D0\4F9B\3059\308B\3053\3068\306B\3088\308B\8907\6570\306E\30E2\30C7\30EB\306E\30A4\30F3\30DD\30FC\30C8*</li>'),
'</ul>',
unistr('<p>* zip\30D5\30A1\30A4\30EB\306B\306F\6B21\306E\3082\306E\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
'    <ul>',
unistr('        <li>\30A4\30F3\30DD\30FC\30C8\3059\308Bbpmn\30D5\30A1\30A4\30EB</li>'),
unistr('        <li>\6B21\306E\5C5E\6027\3092\6301\3064\30AA\30D6\30B8\30A7\30AF\30C8\306E\914D\5217\3067\3042\308Bimport.json\30D5\30A1\30A4\30EB(\6B21\306E\4F8B\3092\53C2\7167)\3002'),
'            <ul>',
unistr('                <li>dgrm_name: \30E2\30C7\30EB\306E\540D\524D</li>'),
unistr('                <li>dgrm_version: \30E2\30C7\30EB\306E\30D0\30FC\30B8\30E7\30F3</li>'),
unistr('                <li>dgrm_category: \30E2\30C7\30EB\306E\30AB\30C6\30B4\30EA</li>'),
unistr('                <li>file: \30A2\30FC\30AB\30A4\30D6\5185\306Ebpmn\30D5\30A1\30A4\30EB\306E\540D\524D</li>'),
'            </ul>',
'        </li>',
'    </ul>',
unistr('2\3064\306E\30E2\30C7\30EB\3092\4F7F\7528\3057\305Fimport.json\30D5\30A1\30A4\30EB\306E\4F8B<br>'),
'<pre><code>[',
'{',
unistr('    }"dgrm_name": "\30D4\30B6\306E\30B3\30E9\30DC\30EC\30FC\30B7\30E7\30F3"\3001'),
unistr('    "dgrm_version": "0"\3001'),
unistr('    "dgrm_status": "\30C9\30E9\30D5\30C8"\3001'),
unistr('    "dgrm_category": null\3001'),
unistr('    "file": "\30D4\30B6 Collaboration_0.bpmn"'),
unistr('  }\3001'),
'  {',
unistr('    "dgrm_name": "\4F11\65E5"\3001'),
unistr('    "dgrm_version": "0"\3001'),
unistr('    "dgrm_status": "\30C9\30E9\30D5\30C8"\3001'),
unistr('    "dgrm_category": null\3001'),
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13928698512416799)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\300CLOGIN_USERNAME_COOKIE\300D\3068\3044\3046\540D\524D\306E\6C38\7D9A\30D6\30E9\30A6\30B6Cookie\306B\30E6\30FC\30B6\30FC\540D\3092\4FDD\5B58\3057\307E\3059\3002\6B21\56DE\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306B\79FB\52D5\3059\308B\3068\3001'),
unistr('\30E6\30FC\30B6\30FC\540D\30D5\30A3\30FC\30EB\30C9\306B\3053\306E\5024\304C\81EA\52D5\7684\306B\5165\529B\3055\308C\307E\3059\3002'),
'</p>',
'<p>',
unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\9078\629E\3092\89E3\9664\3059\308B\3068\3001\30E6\30FC\30B6\30FC\540D\304C\3059\3067\306BCookie\306B\4FDD\5B58\3055\308C\3066\3044\308B\5834\5408\3001'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\7A7A\306E\5024\3067\4E0A\66F8\304D\3057\307E\3059\3002\30D6\30E9\30A6\30B6\306E\958B\767A\8005\30C4\30FC\30EB\3092\4F7F\7528\3057\3066\3001Cookie\3092\5B8C\5168\306B\524A\9664\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13928821306416800)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13929065651416801)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100003)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13929220264416801)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100003)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13929484045416801)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100003)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13929661303416801)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7C21\6613\30D5\30A9\30FC\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13929861605416801)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100003)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\5C65\6B74')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13930071617416801)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100003)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13930204194416801)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100003)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ORDS\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30EC\30DD\30FC\30C8')
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13930430034416801)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100003)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30FC\30EB\30FB\30E2\30C7\30EB')
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13930636696416801)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\306E\8CFC\8AAD')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13930827118416801)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100003)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\3057\305F\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13931046661416801)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100003)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C5E\6027')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13931266327416801)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100003)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13931451985416801)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100003)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\7BA1\7406')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13931638132416802)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13931829451416802)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100003)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13932050498416802)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100003)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13932216909416802)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100003)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13932435693416802)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100003)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\5C65\6B74')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13932692321416802)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100003)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13932812779416802)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30A8\30E9\30FC')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13933019145416802)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100003)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13933257204416803)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100003)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\6700\5927\884C\6570\306F\3001#MAX_ROW_COUNT#\884C\3067\3059\3002\30D5\30A3\30EB\30BF\30FC\3092\9069\7528\3057\3066\3001\30AF\30A8\30EA\30FC\306E\30EC\30B3\30FC\30C9\6570\3092\6E1B\3089\3057\3066\304F\3060\3055\3044\3002')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13933419723416803)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\6700\5927\884C\6570\306F\3001#MAX_ROW_COUNT#\884C\3067\3059\3002\30D5\30A3\30EB\30BF\30FC\3092\9069\7528\3057\3066\3001\30AF\30A8\30EA\30FC\5185\306E\30EC\30B3\30FC\30C9\6570\3092\6E1B\3089\3057\3066\304F\3060\3055\3044\3002')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13933679475416804)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\5C65\6B74\304C\7A7A\3067\3059\3002')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13933876636416804)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30A8\30E9\30FC\5C65\6B74\304C\7A7A\3067\3059\3002')
,p_translate_from_text=>'The step error history is empty.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13934068503416804)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30B5\30D6\30D5\30ED\30FC\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13934251385416804)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\5F0F\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13934482316416804)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13934612867416804)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\3057\305F\30B5\30D6\30D5\30ED\30FC\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13934830780416804)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8\5C65\6B74\304C\7A7A\3067\3059\3002')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13935060453416804)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100003)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13935230589416804)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5C5E\6027\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13935427089416805)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13935674924416805)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100003)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5909\6570\5C65\6B74\304C\7A7A\3067\3059\3002')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13935873612416805)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100003)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13936018780416805)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\3057\305F\30B9\30C6\30C3\30D7\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13936250445416805)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30B9\30C6\30C3\30D7\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13936445734416806)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13936623720416806)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13936881099416806)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13937026192416806)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13937290048416806)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13937476942416806)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13937638122416806)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13937899023416806)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13938067321416806)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13938201222416806)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13938480230416806)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13938694104416806)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13938837489416806)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13939095962416807)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13939255441416807)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13939432691416807)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13939635838416807)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13939858027416807)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13940000036416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13940262405416807)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100003)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13940400143416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100003)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13940603806416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13940827910416807)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13941020003416807)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13941263431416807)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100003)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13941411986416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13941601255416807)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13941813320416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13942066424416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100003)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13942292290416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100003)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13942412060416807)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13942676851416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13942879416416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13943046609416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13943267322416808)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13943489728416808)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13943661543416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13943864702416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13944075764416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13944206219416808)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13944462439416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100003)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13944612383416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13944831705416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13945096947416808)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13945251044416808)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13945400322416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100003)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13945614507416808)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100003)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13945886944416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13946066887416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13946239948416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13946415134416808)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13946640509416808)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100003)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13946831922416809)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13947011434416809)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13947265833416809)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13947456553416809)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100003)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13947686930416809)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13947814202416809)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13948014982416809)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13948278003416809)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13948456321416809)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100003)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13948602661416809)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13948800738416809)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13949054172416809)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13949218460416809)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100003)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13949484865416809)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13949649863416809)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100003)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13949897607416809)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13950094368416809)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13950293311416809)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13950454345416809)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13950626789416810)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13950813878416810)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13951083609416810)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13951213192416810)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13951475923416810)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13951602079416810)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13951813198416810)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13952037582416810)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13952280297416810)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13952481750416810)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13952674022416810)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100003)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13952818393416810)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13953007928416810)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100003)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13953280194416810)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13953491253416810)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13953665736416810)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13953831002416810)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13954089759416810)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100003)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13954280173416810)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100003)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13954452971416810)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100003)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13954630558416811)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13954849304416811)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13955050861416811)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13955229258416811)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100003)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13955446907416811)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13955695588416811)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13955840999416811)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13956037637416811)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13956283442416811)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13956481473416811)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13956639524416811)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13956823737416811)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13957049068416811)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13957280449416811)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13957451233416811)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13957629884416811)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13957815525416811)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13958026203416811)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13958288590416811)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13958414974416811)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13958665421416812)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13958860298416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13959022054416812)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13959201547416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13959444228416812)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13959604254416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13959820456416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13960066541416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13960265584416812)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13960401458416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100003)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13960683457416812)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13960841876416812)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13961084095416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100003)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13961299520416812)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13961443373416812)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13961670323416812)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13961854391416812)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100003)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13962053165416812)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13962258453416812)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13962456516416813)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13962640255416813)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100003)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13962858747416813)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13963014355416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13963273447416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13963436111416813)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13963622291416813)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100003)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13963849965416813)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13964038454416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13964224151416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100003)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13964428256416813)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13964601192416813)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100003)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13964849331416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13965068413416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13965225816416813)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13965489850416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13965610621416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13965826758416813)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13966091256416813)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100003)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13966233101416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13966497340416813)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13966688856416814)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13966891226416814)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13967028194416814)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13967285507416814)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13967473054416814)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100003)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13967643278416814)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13967836730416814)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13968092922416814)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13968254836416814)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13968476128416814)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13968692071416814)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13968815776416814)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13969021109416814)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13969224442416814)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100003)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13969423015416814)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13969645195416814)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13969802089416814)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13970088690416814)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13970277858416814)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13970470689416814)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100003)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13970627851416815)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13970804791416815)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13971064355416815)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13971207570416815)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100003)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13971414116416815)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13971601854416815)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100003)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13971818803416815)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13972083138416815)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13972208099416815)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13972467833416815)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13972628232416815)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13972894706416815)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13973051764416815)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100003)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13973269166416815)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13973456174416815)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13973631112416815)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13973846545416815)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13974012104416815)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13974216830416815)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13974439735416815)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100003)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13974668205416815)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13974845508416816)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13975003347416816)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13975208298416816)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100003)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13975409987416816)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13975692769416816)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13975852977416816)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100003)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13976036995416816)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13976282121416816)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100003)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13976482192416816)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100003)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13976603435416816)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13976856546416816)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13977006458416816)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13977250425416816)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13977455126416816)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100003)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13977679865416816)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13977896097416816)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13978092632416816)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13978245892416816)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13978437010416816)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13978690461416816)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100003)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13978800298416817)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13979003694416817)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13979220580416817)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13979409848416817)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13979608733416817)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13979832262416817)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13980028108416817)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13980221595416817)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13980421828416817)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13980688944416817)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13980890320416817)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13981086142416817)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100003)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13981216708416817)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13981422573416817)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100003)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13981651296416817)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13981869418416828)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30DE\30FC\958B\59CB\65E5')
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13981996341416829)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13982118192416829)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\7BC4\56F2')
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13982300737416829)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13982569422416829)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('JSON\5C5E\6027')
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13982716177416829)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13982931677416829)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\7D42\66F4\65B0\65E5')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13983104534416829)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13983374234416829)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13983521594416829)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13983718475416829)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13983953208416829)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210\65E5')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13984179873416829)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13984368794416829)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0\30FB\30D0\30FC\30B8\30E7\30F3\9078\629E')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13984591138416829)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13984752003416829)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13984980715416829)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13985181218416829)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\7D42\66F4\65B0\65E5')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13985392511416829)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13985570194416829)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100003)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30DD\30FC\30C8\30E1\30FC\30EB\30A2\30C9\30EC\30B9')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13985774675416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100003)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13985906143416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30EC\30D9\30EB')
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13986119801416830)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\30FB\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13986325396416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13986501806416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100003)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\6642\306E\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13986749637416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AD\30FC\5024')
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13986989552416830)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13987105170416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30FC\30F3')
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13987349430416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100003)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04\5BFE\8C61')
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13987514669416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100003)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13987767474416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AD\30FC\540D')
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13987979160416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13988136628416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13988388067416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13988591704416830)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\300C\518D\5E30\3042\308A\300D\30A2\30A4\30B3\30F3')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13988753799416830)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13988965965416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13989145901416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AF\30A4\30C3\30AF\30A2\30AF\30B7\30E7\30F3')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13989335956416830)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\540D')
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13989505489416830)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13989728073416830)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100003)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13989923598416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13990179850416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\65E5')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13990334408416831)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13990501103416831)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13990776376416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100003)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13990916304416831)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100003)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AF\30A4\30C3\30AF\30A2\30AF\30B7\30E7\30F3')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13991134969416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210\65E5')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13991332895416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13991524059416831)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9F\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13991743961416831)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\524D\30BF\30B9\30AF\306E\5B8C\4E86')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13991990618416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100003)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13992118254416831)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13992303089416831)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13992582248416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30AF\30E9\30B9')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13992743468416831)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100003)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13992931798416831)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30B3\30FC\30D7')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13993122375416831)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9759\7684ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13993358193416831)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13993520201416831)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\884C')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13993796014416832)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100003)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13993973345416832)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13994191718416832)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F0F')
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13994384110416832)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9F\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13994513165416832)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100003)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13994771921416832)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13994908907416832)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100003)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13995111356416832)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13995388102416832)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100003)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13995546430416832)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13995717595416832)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13995983983416832)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13996101488416832)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\9664\5916\3055\308C\305F\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13996305261416832)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13996559613416832)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13996792570416832)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13996982190416832)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13997126993416832)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\696D\958B\59CB\6E08')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13997328362416832)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30DA\30A4\30ED\30FC\30C9\5909\6570')
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13997566984416832)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13997773659416832)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\30FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13997905602416833)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100003)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\89E3\6790\6E08\30D5\30ED\30FC')
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13998121860416833)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13998368472416833)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100003)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13998506002416833)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13998772891416833)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30EC\30D9\30EB')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13998985918416833)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\696D\958B\59CB\6E08')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13999183531416833)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13999301300416833)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100003)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13999537673416833)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100003)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13999783290416833)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100003)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(13999926900416833)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14000114786416833)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14000372877416833)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14000586472416833)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100003)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\524D\30BF\30B9\30AF\306E\5B8C\4E86')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14000723572416833)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EB\30FC\30C8\30FB\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14000999090416833)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14001160442416833)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14001378157416833)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\7D42\66F4\65B0\65E5')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14001587719416833)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14001735809416833)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30D7')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14001972284416834)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\7D42\66F4\65B0\65E5')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14002148841416834)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14002307882416834)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14002521273416834)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14002755161416834)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14002974795416834)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14003166674416834)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14003374474416834)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14003525382416834)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30D9\30EB')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14003724721416834)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14003944753416834)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14004109434416834)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100003)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14004307896416834)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14004531562416834)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14004768771416834)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14004930839416834)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14005166651416834)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14005352668416834)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E1\30C3\30BB\30FC\30B8\540D')
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14005584925416834)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\524D\30BF\30B9\30AF\306E\5B8C\4E86')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14005713815416835)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100003)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14005976729416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30EC\30D9\30EB')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14006193066416835)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14006347148416835)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100003)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14006551093416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14006733182416835)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14006922152416835)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14007167697416835)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100003)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30B3\30FC\30D7')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14007340957416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14007515488416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30D9\30F3\30C8')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14007770230416835)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\512A\5148\5EA6')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14007986052416835)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100003)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14008185476416835)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E88\7D04')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14008346513416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC\30FB\30B9\30BF\30C3\30AF')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14008544286416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14008711257416835)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\65B0\66F4\65B0\65E5')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14008966545416835)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100003)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14009112105416835)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14009300549416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9F\884C')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14009572699416835)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100003)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30AD\30FC')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14009713862416836)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14009983491416836)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100003)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30AD\30FC')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14010158296416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14010320201416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BPMN ID'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14010578339416836)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\884C')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14010761742416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30FC\30BF\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14010916097416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14011166811416836)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14011326122416836)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100003)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14011560005416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14011783392416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14011900667416836)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5148\30C0\30A4\30A2\30B0\30E9\30E0\30FB\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14012168627416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14012391298416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E8B\524D\30BF\30B9\30AF\306E\5B8C\4E86')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14012526188416836)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14012760471416836)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100003)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7\30FB\30AD\30FC')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14012908019416836)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14013143011416836)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14013367336416836)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30EC\30D9\30EB')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14013574323416836)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC\30FB\30B9\30BF\30C3\30AF')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14013730067416837)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14013979082416837)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14014102331416837)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\696D\958B\59CB\6E08')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14014314694416837)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14014525612416837)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100003)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14014719425416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728\306E\30AF\30E9\30B9')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14014902181416837)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14015146218416837)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\696D\958B\59CB\6E08')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14015356489416837)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30FC\30BF\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14015514987416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30AA\30D6\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14015711674416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100003)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC\30FB\30B9\30BF\30C3\30AF')
,p_translate_from_text=>'Error Stack'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14015961858416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14016109460416837)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30EC\30D9\30EB')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14016367230416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100003)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6ID')
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14016530098416837)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100003)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14016761967416837)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100003)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B3\30E1\30F3\30C8')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14016988800416837)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100003)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\8AAC\660E')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14017165842416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14017341465416837)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EC\30D9\30EB')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14017598411416838)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\30FB\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14017789532416838)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\30FB\30AB\30C6\30B4\30EA\30FC')
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14017980652416838)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100003)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14018195191416838)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14018318606416838)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100003)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\53CD\5FA9\30D1\30B9')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14018510215416838)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14018731408416838)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C7\30FC\30BF\578B')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14018971016416838)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\5728')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14019150514416838)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14019337879416838)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14019579949416838)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\547C\51FA\3057\5143\30C0\30A4\30A2\30B0\30E9\30E0ID')
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14019786700416838)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100003)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30DD\30FC\30C8URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14019973263416838)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14020138133416838)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5024')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14020332014416838)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100003)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14020565496416838)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100003)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14020701282416838)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14020983191416838)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\518D\5E30\3042\308A')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14021112371416839)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100003)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FCID')
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14021376610416839)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6F5C\5728\30E6\30FC\30B6\30FC')
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14021509617416839)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100003)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14021786317416839)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100003)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14021908546416839)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100003)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14022135331416839)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E2\30C7\30EB\540D')
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14022325166416839)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14022568281416839)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F0F\30BF\30A4\30D7')
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14022755152416839)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100003)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14022931559416839)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30D6\30D5\30ED\30FC')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14023176119416839)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14023356684416839)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14023535069416839)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6F5C\5728\7684\30B0\30EB\30FC\30D7')
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14023708354416839)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A4\30A2\30B0\30E9\30E0')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14023995493416839)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100003)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14024189787416839)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14024312492416839)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14024546794416839)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30C0\30A4\30A2\30B0\30E9\30E0ID')
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14024768086416839)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30C3\30D7')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14024900280416839)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100003)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\884C')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14025184811416840)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14025375720416840)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100003)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14025516525416840)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100003)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\73FE\884C')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14025747250416840)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100003)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14025956199416840)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100003)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14026179285416840)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100003)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14026314805416840)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100003)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\6642\306E\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14026554791416840)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AF\30A4\30C3\30AF\30A2\30AF\30B7\30E7\30F3')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14026727009416840)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100003)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14026906863416840)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14027134011416851)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14027373507416851)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14027582911416851)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14027797499416851)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100003)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14027958533416852)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100003)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14028104407416852)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14028350880416852)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100003)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14028509005416852)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14028779201416852)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100003)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14028976739416852)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14029173753416852)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100003)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14029364746416852)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14029529164416852)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14029762954416852)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100003)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14029963541416852)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14030133232416852)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100003)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14030358064416852)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100003)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14030580312416852)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100003)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14030785008416852)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14030956669416852)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100003)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14031161723416852)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14031332481416853)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100003)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14031538686416853)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14031755840416853)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14031906746416853)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100003)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14032166449416853)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100003)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14032360755416854)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100003)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14032561234416854)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100003)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14032709322416857)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100003)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX \30FC\8868\793A')
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14032914436416857)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100003)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX\30FC\30E2\30C7\30E9\30FC')
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14033165452416857)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100003)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14033381069416857)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100003)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14033544266416857)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100003)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14033771933416858)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100003)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14033937593416858)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100003)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14034168126416858)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100003)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14034362535416858)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6A29\9650\304C\4E0D\5341\5206\3067\3059\3002\30E6\30FC\30B6\30FC\306F\7BA1\7406\8005\3067\306F\3042\308A\307E\305B\3093')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14034567371416858)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCE\6642')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14034760204416858)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6BCE\6642')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14034936738416858)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14035134208416858)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14035331752416858)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14035577452416859)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('I\5E74\5EA6')
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14035793556416859)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5\5E74\9593')
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14035977675416859)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\5206')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14036173241416859)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\5206')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14036377573416859)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\304B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14036543850416859)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\304B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14036721036416859)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\304B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14036946625416859)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\304B\6708')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14037190015416859)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('4\5E74\9593')
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14037313582416860)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5\5206')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14037571704416860)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5\5206')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14037724038416860)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\304B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14037977831416860)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\304B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14038109950416860)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\304B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14038382722416860)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\304B\6708')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14038535166416860)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\5E74\9593')
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14038735757416861)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\5206')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14038962165416861)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\5206')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14039139117416861)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\304B\6708')
,p_translate_from_text=>'3 Months'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14039338582416861)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\304B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14039533669416861)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\304B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14039794127416861)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\304B\6708')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14039998340416861)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('2\5E74\9593')
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14040110630416862)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\79D2(\672C\756A\4F7F\7528- apex.oracle.com\7528\3067\306F\306A\3044)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14040365768416862)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\79D2(\672C\756A\4F7F\7528- apex.oracle.com\7528\3067\306F\306A\3044)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14040557719416862)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30\65E5\9593')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14040720494416862)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30\65E5\9593')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14040955871416862)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30\65E5\9593')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14041120659416862)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\5E74')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14041390887416862)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14\65E5\9593')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14041500620416862)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14\65E5\9593')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14041729519416863)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14\65E5\9593')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14041981799416863)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14042123070416863)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14042355179416863)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14042583823416863)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14042790978416863)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14042975100416863)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100003)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14043113908416863)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14043358717416863)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100003)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14043539866416863)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14043799373416863)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14043969720416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14044124668416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14044334917416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100003)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14044585212416864)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14044760800416864)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14044927066416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14045187026416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14045323005416864)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14045542595416864)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100003)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14045742480416864)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100003)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14045954888416864)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14046120690416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100003)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14046376685416864)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14046505251416864)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100003)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14046716321416864)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100003)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14046941022416864)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14047100361416864)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100003)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14047374490416864)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100003)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14047509094416864)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14047799245416864)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100003)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14047978107416865)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100003)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14048146884416865)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14048385086416865)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100003)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14048590138416865)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100003)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14048765280416865)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14048995491416865)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14049112442416865)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14049393605416865)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14049596278416865)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14049778093416865)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14049988254416865)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14050126033416865)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100003)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14050336657416865)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100003)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14050538581416865)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14050720861416865)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14050990442416865)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14051147795416865)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14051342756416865)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14051536299416865)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14051798856416865)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100003)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14051932017416866)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14052161118416866)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100003)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14052361413416866)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14052515760416866)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100003)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14052708573416866)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14052958882416866)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14053104759416866)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100003)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14053305431416866)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100003)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14053545166416866)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100003)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14053769719416866)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14053986582416866)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14054199501416866)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14054352500416866)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100003)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14054581518416866)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14054799426416866)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100003)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14054980405416866)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14055164950416866)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14055311188416866)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14055531065416866)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14055722999416866)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14055965705416866)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14056193287416866)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14056373583416867)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14056586679416867)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14056713898416867)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100003)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14056930072416867)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14057183051416867)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14057384265416867)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14057543377416867)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100003)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14057743018416867)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14057962205416867)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14058184237416867)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100003)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14058384496416867)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14058572384416867)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14058733197416867)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100003)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14058901053416867)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14059172119416867)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14059343761416867)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14059546349416867)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14059712515416867)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14059990616416867)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14060104036416868)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14060309450416868)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14060500232416868)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14060723017416868)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14060967855416868)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14061179249416868)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14061379673416868)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14061576062416868)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14061782060416868)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14061986856416868)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100003)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14062117236416868)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100003)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14062301693416868)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14062571270416868)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14062756951416868)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100003)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14062965610416868)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100003)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14063176601416868)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14063318260416868)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14063542635416868)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14063778865416868)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14063976313416868)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14064160189416868)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14064348280416869)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14064582454416869)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14064787844416869)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14064915504416869)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100003)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14065127652416869)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100003)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14065346868416869)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100003)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14065503109416869)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100003)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14065743445416869)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14065922274416869)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14066160777416869)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14066321076416869)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100003)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14066547623416869)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14066703997416869)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14066985574416869)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100003)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14067104127416869)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14067329287416869)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14067570196416869)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100003)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14067737085416869)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14067903068416869)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14068129597416869)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100003)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14068390175416869)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14068533351416870)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14068712325416870)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14068955623416870)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100003)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14069112101416870)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100003)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14069399221416870)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14069570635416870)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100003)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14069718852416870)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14069904829416870)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14070153543416870)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100003)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14070375892416870)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14070528955416870)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14070769114416870)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14070928936416870)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100003)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14071101789416870)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14071327176416870)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14071503748416870)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14071715444416870)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14071953927416870)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14072136937416870)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14072303328416870)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14072518740416871)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14072732099416871)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14072917800416871)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14073111016416871)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14073361242416871)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100003)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14073506747416871)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14073710380416871)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14073938574416871)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14074118523416871)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14074323680416871)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100003)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14074593705416871)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14074799398416871)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14074959445416871)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14075177027416871)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14075389730416871)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100003)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14075508665416871)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14075730102416871)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14075929046416871)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14076181322416871)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14076332189416872)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100003)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14076548359416872)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100003)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14076778750416872)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14076982026416872)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100003)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14077195443416872)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14077302048416872)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100003)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14077503490416872)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14077762287416872)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14077929828416872)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14078164885416891)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14078360638416891)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14078581741416891)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14078762228416891)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14078922911416891)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14079139988416891)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100003)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14079399498416891)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14079531608416891)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14079732978416891)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14079973156416891)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14080114506416891)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14080348943416892)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14080590008416892)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14080706612416892)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14080934841416892)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14081154634416892)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14081349311416892)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14081532346416892)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14081764050416892)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100003)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14081936315416892)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100003)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14082148233416892)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14082374382416892)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14082524067416892)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14082790455416892)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100003)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14082904214416892)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14083122886416892)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14083308290416892)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14083573492416892)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14083700054416892)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14083930629416892)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14084154468416893)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100003)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14084344060416893)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14084506148416893)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14084705474416893)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14084960176416893)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14085171111416893)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14085368249416893)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14085512222416893)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14085721428416893)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14085994221416893)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14086120966416893)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14086387841416893)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14086571575416893)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14086721640416893)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14086967943416893)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100003)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14087109447416893)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14087343912416893)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14087592130416893)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14087787720416893)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14087906439416893)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14088148511416894)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14088324262416894)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14088549912416894)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14088732295416894)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14088945227416894)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14089106149416894)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14089324200416894)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14089590909416894)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14089710355416894)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100003)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14089928280416894)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14090166719416894)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14090307319416894)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14090536815416894)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14090767141416894)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14090950664416894)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14091184044416894)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14091319338416894)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100003)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14091598184416894)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14091702715416894)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14091971894416894)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100003)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14092189730416894)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100003)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14092321447416895)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14092515691416895)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14092767150416895)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100003)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14092934233416895)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100003)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14093172591416895)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14093373884416895)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14093533222416895)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14093775373416895)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14093937612416895)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14094173984416895)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14094391044416895)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14094525600416895)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14094711916416895)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14094923099416895)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14095133869416895)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14095312646416895)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14095581870416895)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100003)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14095747746416896)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14095953316416896)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100003)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14096175920416896)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14096331533416896)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14096532722416896)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14096741679416896)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14096939809416896)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14097189110416896)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100003)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14097356949416896)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14097548116416896)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14097736831416896)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14097905041416901)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14098119901416902)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14098381440416902)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14098525948416902)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14098747762416902)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14098939343416902)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100003)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14099165008416902)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14099361608416902)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14099577803416902)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14099754930416902)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14099993930416902)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100003)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14100181792416902)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14100373309416902)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14100511348416902)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14100714763416902)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14100990353416902)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14101123337416902)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14101322879416902)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14101509414416902)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14101730485416903)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14101903162416903)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14102145867416903)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14102312349416903)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14102593683416903)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14102741144416903)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14102999645416903)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14103146476416904)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14103300016416904)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14103512234416905)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14103718414416905)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100003)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14103990228416905)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14104128492416905)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14104303068416905)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14104526013416905)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14104724770416905)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14104932764416905)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14105170839416905)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14105352401416905)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14105591352416905)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14105792548416905)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14105954266416905)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14106194841416905)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100003)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14106322752416905)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14106574141416905)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14106767083416905)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14106945731416905)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14107100413416906)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14107370260416906)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14107589508416906)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14107746187416906)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100003)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14107923405416906)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14108129481416906)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14108332476416906)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14108534274416906)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14108775896416906)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14108911761416906)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14109106637416906)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14109366489416906)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14109590453416906)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14109761956416906)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14109903366416906)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100003)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14110134391416906)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14110350683416906)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14110543352416906)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14110730428416906)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14110992667416907)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14111147245416907)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14111374546416907)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14111559512416907)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14111709675416907)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14111931878416907)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14112184070416907)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14112387095416907)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14112565610416907)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14112757082416907)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14112978554416907)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14113166339416907)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14113308879416907)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14113540751416907)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100003)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14113790487416908)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14113984808416908)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14114190388416908)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14114333459416908)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14114556302416908)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14114737266416908)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14114977731416908)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14115127573416908)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14115358193416908)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14115571171416908)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14115710281416908)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14115924565416908)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14116154113416908)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14116321332416908)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100003)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14116528954416908)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14116716548416908)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100003)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14116902930416908)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14117181116416908)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14117325822416908)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14117560628416908)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14117751672416909)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100003)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14117937885416909)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14118101894416909)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14118348353416909)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14118529936416913)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100003)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14118792918416913)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14118990051416913)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14119110680416913)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14119310560416913)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14119559727416913)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14119746417416913)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14119990591416913)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14120100003416913)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100003)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14120308514416913)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100003)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14120577079416913)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14120770529416913)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14120958419416913)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100003)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14121129187416913)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100003)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14121374247416913)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14121583600416913)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14121763019416913)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14121970729416913)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14122193237416914)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14122305153416914)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14122587123416914)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14122736841416914)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14122958932416914)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14123164029416914)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14123358292416914)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14123560329416914)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14123728667416914)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14123958924416914)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14124133338416914)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14124335179416914)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100003)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14124504430416914)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100003)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14124754042416914)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100003)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14124916754416914)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14125182330416914)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14125354796416914)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14125592273416914)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14125766621416914)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14125988134416915)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14126183645416915)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100003)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14126330193416915)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100003)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14126519357416915)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14126739537416915)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14126992769416915)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14127181573416915)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100003)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14127300592416915)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100003)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14127588064416915)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100003)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14127786707416915)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14127904194416915)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100003)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14128168475416915)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14128375538416915)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14128541858416915)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100003)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14128799526416915)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100003)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14128994643416915)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14129189472416915)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100003)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14129323823416915)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14129527119416915)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100003)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14129758871416915)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100003)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14129903606416916)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14130197488416916)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100003)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14130339243416916)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14130514398416916)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100003)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14130779910416916)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100003)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14130975845416916)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100003)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14131184272416916)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100003)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14131300475416916)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100003)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14131552033416916)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100003)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14131750251416916)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100003)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14131922067416916)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14132130847416919)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14132351402416919)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100003)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14132558705416920)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14132770032416920)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14132956534416920)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100003)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14133115828416920)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14133384837416920)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100003)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14133576979416920)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14133786717416920)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100003)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14133986350416920)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100003)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14134125030416921)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14134352159416921)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14134562033416921)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100003)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14134754900416922)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100003)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14134922171416922)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100003)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14135174072416922)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14135352178416922)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100003)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14135591618416922)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100003)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14135721250416922)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100003)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14135927938416922)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100003)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14136106553416922)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14136354027416922)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100003)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14136515278416922)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14136740188416922)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14136982508416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100003)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14137182683416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14137344037416923)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14137519215416923)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14137790657416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100003)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14137911812416923)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100003)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14138100132416923)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100003)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14138360304416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14138574167416923)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14138744231416923)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100003)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14138976491416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14139109144416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100003)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14139332627416923)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14139509311416923)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14139745398416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14139959088416923)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100003)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14140147648416923)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14140330596416924)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14140568059416924)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14140712052416924)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100003)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14140978803416924)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100003)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14141118929416924)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14141360731416924)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14141586856416924)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100003)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14141719479416924)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100003)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14141989556416924)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100003)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14142146234416924)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100003)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14142327001416924)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100003)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14142537209416924)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100003)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14142740924416924)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14142980742416924)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100003)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14143127006416924)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100003)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14143399556416924)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14143516719416924)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100003)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14143758362416924)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100003)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14143972259416924)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14144109253416925)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100003)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14144397105416925)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100003)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14144556943416925)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14144746080416925)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100003)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14144987495416925)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100003)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14145138535416925)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100003)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14145314882416925)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14145521851416925)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100003)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14145722957416925)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14145924295416925)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14146127318416925)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14146362809416925)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100003)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14146599395416925)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100003)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14146754951416925)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14146914122416925)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14147159466416925)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100003)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14147320353416925)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100003)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14147511676416926)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14147725231416926)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100003)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14147931015416926)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14148152305416926)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14148389798416926)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100003)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14148580083416926)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14148726874416926)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100003)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14148959444416926)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14149190502416926)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100003)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14149333202416926)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100003)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14149471680416926)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14149619466416926)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100003)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14149852068416926)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100003)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14150021195416926)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100003)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14150282076416930)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14150417040416930)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14150660179416930)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14150895624416930)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14151095886416930)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100003)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14151290882416930)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100003)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14151435670416930)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100003)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14151660324416930)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14151858888416931)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100003)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14152078391416931)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14152243642416931)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14152471889416931)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14152650587416931)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100003)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14152877047416931)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100003)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14153005058416931)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100003)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14153291985416932)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100003)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14153439362416932)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100003)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14153641429416932)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14153855810416932)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14154093586416932)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14154225771416932)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100003)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14154454180416932)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14154695145416932)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14154839525416932)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100003)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14155081951416932)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14155224433416932)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100003)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14155458462416933)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14155622158416933)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14155840306416933)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100003)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14156038751416934)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14156276217416934)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14156485724416934)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14156697192416934)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100003)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14156821898416934)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14157067254416934)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100003)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14157254357416934)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100003)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14157425751416934)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100003)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14157695285416934)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14157837092416935)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14158007381416935)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14158260176416935)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14158462389416935)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100003)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14158642076416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14158866344416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14159079757416935)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100003)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14159238380416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14159442895416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100003)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14159690590416935)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100003)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14159869613416935)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100003)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14160043189416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14160279037416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14160421874416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100003)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14160617581416935)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100003)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14160876438416936)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14161097061416937)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14161243996416937)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14161472882416937)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100003)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14161693030416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14161819502416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14162012992416937)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100003)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14162245973416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14162488256416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100003)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14162640882416937)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100003)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14162823571416937)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100003)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14163002863416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14163256450416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14163477984416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100003)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14163654863416937)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100003)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14163812519416938)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100003)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14164054987416938)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100003)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14164240428416938)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100003)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14164474001416938)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14164651014416938)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14164830895416938)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14165050732416938)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14165247146416939)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100003)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14165419180416939)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100003)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14165660038416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14165819978416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100003)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14166055095416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100003)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14166206306416939)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100003)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14166450908416939)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14166658910416939)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100003)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14166861915416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14167092676416939)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100003)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14167296511416939)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100003)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14167404355416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100003)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14167606894416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100003)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14167853644416939)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100003)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14168014468416939)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100003)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14168228762416939)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14168439041416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100003)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14168605398416939)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14168804398416939)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100003)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14169066121416940)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100003)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14169262977416940)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100003)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14169436562416940)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100003)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14169684322416940)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100003)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14169844263416941)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14170088414416941)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14170296693416941)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100003)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14170430490416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14170623584416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14170895720416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14171058501416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14171220803416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14171447364416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14171690406416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14171870204416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100003)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14172011272416942)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14172289951416943)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14172425325416943)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14172648358416943)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14172841117416943)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100003)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14173058916416944)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14173209230416944)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14173484075416944)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14173663126416944)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14173843642416944)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14174073684416944)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14174215482416945)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14174497749416945)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100003)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14174696453416946)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14174859898416946)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100003)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14175042944416946)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100003)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14175286973416946)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100003)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14175495114416946)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100003)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14175622683416946)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14175862845416946)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100003)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14176005274416946)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14176241356416946)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14176406238416946)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100003)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14176660552416946)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100003)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14176844188416946)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100003)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14177052845416946)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100003)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14177231881416946)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14177493771416946)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14177618152416946)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100003)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14177881460416946)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100003)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14178051481416947)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100003)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14178262737416947)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100003)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14178482910416947)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14178653301416947)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100003)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14178857883416947)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100003)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14179016050416947)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100003)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14179210331416947)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14179481307416947)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14179613181416947)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14179873679416947)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100003)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14180038195416947)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100003)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14180222740416947)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14180486797416947)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100003)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14180669426416947)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100003)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14180862229416947)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14181031302416947)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14181243280416947)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14181458709416947)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14181657836416947)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14181887024416947)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14182091811416947)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100003)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14182202602416948)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100003)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14182442703416948)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14182696143416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100003)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14182892906416948)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14183076014416948)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100003)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14183216574416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100003)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14183478148416948)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14183667593416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100003)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14183823021416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100003)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14184039129416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100003)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14184248139416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14184439353416948)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14184699966416948)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14184838514416948)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100003)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14185013855416948)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100003)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14185248893416948)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14185482423416948)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14185608806416948)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14185844605416948)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14186027104416948)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14186258733416949)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14186452338416949)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14186666661416949)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14186862446416949)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14187082780416949)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100003)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14187278730416949)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100003)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14187407802416952)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100003)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14187655332416952)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100003)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14187800658416952)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100003)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14188025533416952)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100003)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14188276335416952)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100003)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14188486476416952)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14188607845416952)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100003)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14188807412416952)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100003)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14189007393416953)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100003)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14189275952416953)
,p_page_id=>5
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100003)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14189411221416953)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100003)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14189696909416953)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100003)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14189849533416953)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14190058169416953)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14190290035416953)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100003)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14190497146416953)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100003)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14190670834416953)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100003)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14190876449416953)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100003)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14191013130416953)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14191257042416953)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100003)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14191401704416953)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100003)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14191601776416953)
,p_page_id=>37
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100003)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14191864345416953)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14192081801416953)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14192258245416953)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14192442695416953)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100003)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14192672324416953)
,p_page_id=>33
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100003)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14192826298416953)
,p_page_id=>11
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14193060768416953)
,p_page_id=>39
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100003)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14193298721416954)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100003)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14193467692416954)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100003)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14193677469416954)
,p_page_id=>50
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100003)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14193862432416954)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100003)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14194022904416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100003)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14194259727416954)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100003)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14194429259416954)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14194632947416954)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100003)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14194840086416954)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100003)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14195081069416954)
,p_page_id=>4
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100003)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14195226015416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100003)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14195441068416954)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14195693470416954)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100003)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14195822557416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100003)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14196067352416954)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14196228211416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100003)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14196483642416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100003)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14196614613416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100003)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14196858185416954)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100003)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14197016132416955)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100003)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14197278651416955)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14197486716416955)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100003)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14197643481416955)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100003)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14197892990416955)
,p_page_id=>13
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100003)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14198097949416955)
,p_page_id=>38
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14198218936416955)
,p_page_id=>1
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100003)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14198404413416955)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100003)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14198646089416955)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14198870869416955)
,p_page_id=>14
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100003)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14199091572416955)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100003)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14199205294416955)
,p_page_id=>30
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100003)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14199413707416955)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100003)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14199652695416955)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100003)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14199873282416958)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14200092894416958)
,p_page_id=>51
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100003)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14200254420416959)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14200479974416959)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14200673074416959)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14200855673416959)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14201064817416959)
,p_page_id=>31
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100003)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14201251759416959)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14201450217416959)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14201680503416959)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14201886015416960)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14202060053416960)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14202269160416960)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14202459048416960)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14202657917416960)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14202841232416960)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14203040773416960)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14203297053416961)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14203433774416961)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14203672943416961)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14203870093416961)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14204063153416962)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14204276449416962)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14204415759416962)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14204640398416962)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14204866976416962)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14205028956416962)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14205292681416962)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14205475973416962)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14205661580416963)
,p_page_id=>6
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100003)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14205891205416964)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14206046563416964)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14206221209416964)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14206488917416964)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14206620238416964)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14206848909416964)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14207028515416964)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14207274592416964)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14207479301416965)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14207688295416965)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14207822868416965)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14208067000416965)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14208206919416965)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14208490814416965)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14208603278416966)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14208885547416966)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14209002168416966)
,p_page_id=>20
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100003)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14209227803416966)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14209453329416966)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14209656508416966)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14209809627416966)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14210079152416967)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14210247283416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100003)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14210463119416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100003)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14210660660416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100003)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14210835611416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100003)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14211077686416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100003)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14211285080416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100003)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14211454438416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100003)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14211612619416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100003)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14211860754416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100003)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14212044147416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100003)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30C7\30A3\30B7\30E7\30F3\3001\30E9\30A4\30BB\30F3\30B9\60C5\5831')
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14212213490416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100003)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14212488251416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100003)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14212633010416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100003)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14212802648416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100003)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14213073603416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14213221338416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100003)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14213423185416968)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100003)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14213659017416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100003)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14213867732416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100003)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14214058323416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100003)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14214275884416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100003)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14214473036416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100003)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14214661740416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100003)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14214862646416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100003)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14215005698416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100003)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14215216582416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100003)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14215482629416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100003)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14215691426416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100003)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14215867942416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100003)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14216030385416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100003)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14216218475416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100003)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14216479500416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100003)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14216637121416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100003)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14216864003416969)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100003)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14217080453416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14217216076416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100003)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14217452496416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100003)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14217687511416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14217832496416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100003)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14218050820416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14218222806416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100003)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14218460130416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100003)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14218675643416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100003)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14218815715416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100003)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14219066218416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100003)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14219273862416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100003)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14219489273416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100003)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14219692960416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100003)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14219840505416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100003)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14220061590416970)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100003)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14220206112416973)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14220455355416974)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14220632346416974)
,p_page_id=>9999
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100003)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14220840270416974)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14221069787416974)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14221251478416974)
,p_page_id=>12
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100003)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14221419733416974)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100003)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14221689133416976)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \30B9\30C6\30C3\30D7\306B\95A2\3059\308B\30E6\30FC\30B6\30FC\60C5\5831\306F\53D6\5F97\3057\307E\305B\3093	</li>'),
unistr('    <li><strong>disabled</strong> (\30C7\30D5\30A9\30EB\30C8) - \30D7\30ED\30BB\30B9\30FB\30B9\30C6\30C3\30D7\306E\30E6\30FC\30B6\30FCID\3092\30D5\30ED\30FC\30FB\30A8\30F3\30B8\30F3\306B\8A8D\8B58\3057\3066\53D6\5F97\3057\307E\3059\3002	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14221879523416976)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30A6\30C8\30D0\30A6\30F3\30C9\30FB\30E1\30FC\30EBserviceTasks\306B\9001\4FE1\8005\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\306EE\30E1\30FC\30EB\9001\4FE1\8005\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14222001818416976)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4ED6\306E\30E6\30FC\30B6\30FC\540D\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\306B\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306BAPEX\30BB\30C3\30B7\30E7\30F3\3067\30E6\30FC\30B6\30FC\306B\306A\308B\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14222238124416976)
,p_page_id=>7
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100003)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\95A2\9023\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\524A\9664')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14222409898416976)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100003)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7A7A\767D\306E\307E\307E\306B\3057\305F\5834\5408\3001\30BF\30B9\30AF\306F\73FE\5728\306E\30E6\30FC\30B6\30FC(app_user)\7528\306B\4E88\7D04\3055\308C\307E\3059\3002')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14222642306416976)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30A4\30AF\30EB\30BF\30A4\30DE\30FC\306E\5834\5408\3001\3053\308C\306F\6700\5927\5B9F\884C\56DE\6570\3092\5B9A\7FA9\3057\307E\3059\3002')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14222899592416976)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100003)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5FC5\9808\306E\5F62\5F0F: YYYY-MM-DD HH24:MI:SS TZR')
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14223058170416976)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - \3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\8FFD\52A0\306E\958B\767A\3092\884C\308F\305A\306BFlows for APEX 21.1\4EE5\4E0B\3067\958B\767A\3057\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30B5\30DD\30FC\30C8\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3057\307E\3059\3002\30A8\30F3\30B8\30F3\306F\30B9\30C6\30C3\30D7\30FB\30AD\30FC\3092\4F7F\7528\3057\3066\3001\5358\4E00\30B9\30C6\30C3\30D7\3067\306E\91CD\8907\30A2\30AF\30B7\30E7\30F3\3092\9632\6B62\3057\307E\305B\3093\3002</li>'),
unistr('    <li><strong>strict</strong> (\63A8\5968) - \3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\65B0\3057\3044\958B\767A\307E\305F\306F\5B8C\5168\306B\79FB\884C\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\4F7F\7528\3057\307E\3059\3002\30A8\30F3\30B8\30F3\306F\3001\30B9\30C6\30C3\30D7\30FB\30AD\30FC\3092\4F7F\7528\3057\3066\3001\5358\4E00\30B9\30C6\30C3\30D7\3067\306E\91CD\8907\30A2\30AF\30B7\30E7\30F3\3092\56DE\907F\3057\307E\3059\3002</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14223227255416977)
,p_page_id=>2
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100003)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5358\4E00\30E2\30C7\30EB\30FB\30B3\30D4\30FC\306E\5834\5408\3001\65B0\898F\30E2\30C7\30EB\306B\306F\5165\529B\3055\308C\305F\540D\524D\304C\4ED8\304D\307E\3059\304C\3001\8907\6570\306E\884C\3092\9078\629E\3057\305F\5834\5408\3001\5165\529B\3057\305F\5024\304C\63A5\5C3E\8F9E\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14223452841416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304A\3088\3073\30ED\30B0\30FB\30A4\30D9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3002')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14223654480416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - \3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\8FFD\52A0\306E\958B\767A\3092\884C\308F\305A\306BFlows for APEX 21.1\4EE5\4E0B\3067\958B\767A\3057\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30B5\30DD\30FC\30C8\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3057\307E\3059\3002\30A8\30F3\30B8\30F3\306F\30B9\30C6\30C3\30D7\30FB\30AD\30FC\3092\4F7F\7528\3057\3066\3001\5358\4E00\30B9\30C6\30C3\30D7\3067\306E\91CD\8907\30A2\30AF\30B7\30E7\30F3\3092\9632\6B62\3057\307E\305B\3093\3002</li>'),
unistr('    <li><strong>strict</strong> (\63A8\5968) - \3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\65B0\3057\3044\958B\767A\307E\305F\306F\5B8C\5168\306B\79FB\884C\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\4F7F\7528\3057\307E\3059\3002\30A8\30F3\30B8\30F3\306F\3001\30B9\30C6\30C3\30D7\30FB\30AD\30FC\3092\4F7F\7528\3057\3066\3001\5358\4E00\30B9\30C6\30C3\30D7\3067\306E\91CD\8907\30A2\30AF\30B7\30E7\30F3\3092\56DE\907F\3057\307E\3059\3002</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14223876848416977)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100003)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \30ED\30AE\30F3\30B0\306F\7121\52B9\3067\3059	</li>'),
unistr('    <li><strong>standard</strong>(\30C7\30D5\30A9\30EB\30C8) - \30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8\3092\30ED\30B0\306B\8A18\9332\3057\307E\3059</li>'),
unistr('    <li><strong>secure</strong> - \30E2\30C7\30EB\30FB\30A4\30D9\30F3\30C8\3068\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8\3092\30ED\30B0\306B\8A18\9332\3057\307E\3059\3002	</li>'),
unistr('    <li><strong>full</strong> - \30E2\30C7\30EB\3001\30A4\30F3\30B9\30BF\30F3\30B9\304A\3088\3073\30D7\30ED\30BB\30B9\5909\6570\30A4\30D9\30F3\30C8\306E\30ED\30B0\8A18\9332		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14224083668416977)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306B\63D0\4F9B\3055\308C\308BAPEX\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E1\3064\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14224284792416977)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306B\63D0\4F9B\3055\308C\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E1\3064\306E\30DA\30FC\30B8ID')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14224468612416977)
,p_page_id=>36
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100003)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B5\30A4\30AF\30EB\30BF\30A4\30DE\30FC\306E\5834\5408\3001\3053\308C\306F\6700\5927\5B9F\884C\56DE\6570\3092\5B9A\7FA9\3057\307E\3059\3002')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14224693859416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX\306EFlows for APEX\306B\4F7F\7528\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\306EAPEX\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\308C\306F\3001APEX\30BB\30C3\30B7\30E7\30F3\306E\4F5C\6210\6642\307E\305F\306F\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\691C\7D22\6642\306B\3001scriptTasks\304A\3088\3073serviceTasks\306E\6700\7D42\30BD\30FC\30C8\3068\3057\3066\4F7F\7528\3055\308C\307E\3059')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14224813679416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \30B9\30C6\30C3\30D7\306B\95A2\3059\308B\30E6\30FC\30B6\30FC\60C5\5831\306F\53D6\5F97\3057\307E\305B\3093	</li>'),
unistr('    <li><strong>disabled</strong> (\30C7\30D5\30A9\30EB\30C8) - \30D7\30ED\30BB\30B9\30FB\30B9\30C6\30C3\30D7\306E\30E6\30FC\30B6\30FCID\3092\30D5\30ED\30FC\30FB\30A8\30F3\30B8\30F3\306B\8A8D\8B58\3057\3066\53D6\5F97\3057\307E\3059\3002	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14225070017416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4ED6\306E\30E6\30FC\30B6\30FC\540D\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306EAPEX\30BB\30C3\30B7\30E7\30F3\4E0A\306E\30E6\30FC\30B6\30FC\306B\306A\308B\30E6\30FC\30B6\30FC\540D')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14225295807416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100003)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong>(\30C7\30D5\30A9\30EB\30C8) - \30EA\30EA\30FC\30B9\3055\308C\305F\30E2\30C7\30EB\306E\30C0\30A4\30A2\30B0\30E9\30E0\306E\7DE8\96C6\3092\9632\6B62</li>'),
unistr('    <li><strong>development</strong> - \30EA\30EA\30FC\30B9\3055\308C\305F\30E2\30C7\30EB\306E\30C0\30A4\30A2\30B0\30E9\30E0\306E\7DE8\96C6\3092\8A31\53EF</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14225406508416977)
,p_page_id=>32
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100003)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304A\3088\3073\30ED\30B0\30FB\30A4\30D9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3002')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14225663648416977)
,p_page_id=>34
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100003)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong>(\30C7\30D5\30A9\30EB\30C8) - \30EA\30EA\30FC\30B9\3055\308C\305F\30E2\30C7\30EB\306E\30C0\30A4\30A2\30B0\30E9\30E0\306E\7DE8\96C6\3092\9632\6B62</li>'),
unistr('    <li><strong>development</strong> - \30EA\30EA\30FC\30B9\3055\308C\305F\30E2\30C7\30EB\306E\30C0\30A4\30A2\30B0\30E9\30E0\306E\7DE8\96C6\3092\8A31\53EF</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14225878808416977)
,p_page_id=>35
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100003)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX\306EFlows for APEX\306B\4F7F\7528\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\306EAPEX\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\308C\306F\3001APEX\30BB\30C3\30B7\30E7\30F3\306E\4F5C\6210\6642\307E\305F\306F\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\691C\7D22\6642\306B\3001scriptTasks\304A\3088\3073serviceTasks\306E\6700\7D42\30BD\30FC\30C8\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14226064072416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306B\63D0\4F9B\3055\308C\308BAPEX\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E1\3064\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14226214636416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100003)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \30ED\30AE\30F3\30B0\306F\7121\52B9\3067\3059	</li>'),
unistr('    <li><strong>standard</strong>(\30C7\30D5\30A9\30EB\30C8) - \30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8\3092\30ED\30B0\306B\8A18\9332\3057\307E\3059</li>'),
unistr('    <li><strong>secure</strong> - \30E2\30C7\30EB\30FB\30A4\30D9\30F3\30C8\3068\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A4\30D9\30F3\30C8\3092\30ED\30B0\306B\8A18\9332\3057\307E\3059\3002	</li>'),
unistr('    <li><strong>full</strong> - \30E2\30C7\30EB\3001\30A4\30F3\30B9\30BF\30F3\30B9\304A\3088\3073\30D7\30ED\30BB\30B9\5909\6570\30A4\30D9\30F3\30C8\306E\30ED\30B0\8A18\9332		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14226435070416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100003)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306B\63D0\4F9B\3055\308C\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E1\3064\306E\30DA\30FC\30B8ID')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14226655483416977)
,p_page_id=>100
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100003)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A2\30A6\30C8\30D0\30A6\30F3\30C9\30FB\30E1\30FC\30EBserviceTasks\306B\9001\4FE1\8005\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\306EE\30E1\30FC\30EB\9001\4FE1\8005\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14226880066416979)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100003)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14227060464416979)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14227205389416979)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\79D2')
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14227467070416979)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100003)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14227616984416979)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30A8\30E9\30FC')
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14227820693416980)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14228095110416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\6700\5927')
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14228203179416980)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100003)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-\6700\5927')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14228437748416980)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30A8\30E9\30FC')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14228617045416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB\3055\308C\305F\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14228807280416980)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593-90pc')
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14229070900416980)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593-10pc')
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14229222958416980)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100003)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14229464699416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\4E86\3057\305F\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14229639774416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90pc\671F\9593')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14229817907416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100003)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\30D1\30FC\30BB\30F3\30BF\30A4\30EB')
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14230080789416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('50\30D1\30FC\30BB\30F3\30BF\30A4\30EB')
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14230212327416980)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100003)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-90pc')
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14230432326416980)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100003)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B7\30EA\30FC\30BA1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14230678173416980)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100003)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4F5C\6210\65E5')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14230865646416980)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100003)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14231033710416980)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-10pc')
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14231284978416980)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100003)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\958B\59CB\6E08')
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14231419904416980)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100003)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B7\30EA\30FC\30BA1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14231696273416980)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90\30D1\30FC\30BB\30F3\30BF\30A4\30EB')
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14231873771416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593-50pc')
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14232016703416981)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100003)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B9F\884C\4E2D')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14232271188416981)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100003)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14232429472416981)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14232674890416981)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\7D42\4E86\6E08')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14232898391416981)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5B8C\4E86\3057\305F\30A4\30F3\30B9\30BF\30F3\30B9')
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14233091996416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-10pc')
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14233226316416981)
,p_page_id=>16
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100003)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\4E2D\592E\5024\671F\9593')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14233492838416981)
,p_page_id=>3
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100003)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14233625791416981)
,p_page_id=>15
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100003)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30BB\30C3\30C8')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14233828618416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100003)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-50pc')
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14234012468416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-50pc')
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14234256239416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100003)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\671F\9593- \6700\5927')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14234485922416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-\6700\5927')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14234684442416981)
,p_page_id=>17
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100003)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\5F85\6A5F-90pc')
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14234844248416983)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100003)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14235002377416983)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100003)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14235268487416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100003)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\30FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14235466281416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100003)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14235661309416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100003)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14235838537416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100003)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\540D\524D')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14236081471416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100003)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30AB\30C6\30B4\30EA\30FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14236255675416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100003)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14236477720416984)
,p_translated_flow_id=>100003
,p_translate_to_id=>100.100003
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14236632545416985)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100003)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\65E5\6B21\30A4\30F3\30B9\30BF\30F3\30B9\8981\7D04\30A2\30FC\30AB\30A4\30D6\30FB\30D7\30ED\30BB\30B9\30FB\30A8\30E9\30FC')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14236881394416985)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100003)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX\7D71\8A08\30B5\30DE\30EA\30FC\306E\30D1\30FC\30B8\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14237027233416985)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100003)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \30ED\30B0\8868\306E\30D1\30FC\30B8\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14237203260416986)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100003)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX\306E\65E5\6B21\7D71\8A08\306E\53D6\5F97\306B\5931\6557\3057\307E\3057\305F\3002')
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14237448437416986)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14237602006416986)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\627F\8A8D')
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14237822471416986)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100003)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\30EA\30B8\30A7\30AF\30C8')
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14238006227416988)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>6.100007
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14238292308416988)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>50.100007
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14238422814416988)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>14.100007
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8')
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14238648457416988)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>51.100007
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8 \D3B8\C9D1')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14238810077416988)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>1.100007
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791\D558\AE30')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14239000857416988)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>7.100007
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0')
,p_translate_from_text=>'Flow'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14239200484416988)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>15.100007
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\BCC4 \D1B5\ACC4')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14239492663416988)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>31.100007
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - REST - \D074\B77C\C774\C5B8\D2B8')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14239675173416988)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>36.100007
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \D0C0\C774\BA38')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14239885005416988)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>34.100007
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C5D4\C9C4 \C571')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14240091335416988)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>11.100007
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C0DD\C131')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14240247286416988)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>30.100007
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14240477663416988)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>2.100007
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD00\B9AC')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14240683258416988)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>8.100007
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C138\BD80\C815\BCF4')
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14240811150416989)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>12.100007
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BDF0\C5B4')
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14241015851416989)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>17.100007
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0DC\C2A4\D06C \D1B5\ACC4')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14241227427416989)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>37.100007
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \D1B5\ACC4')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14241426159416989)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>4.100007
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B378\B7EC')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14241665855416989)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>5.100007
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C775\C2A4\D3EC\D2B8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14241896251416989)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>10.100007
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B2C8\D130')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14242052927416989)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>35.100007
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C5D4\C9C4')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14242296143416989)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>33.100007
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C544\CE74\C774\BE0C')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14242475856416989)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>3.100007
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\C2DC\BCF4\B4DC')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14242647794416989)
,p_page_id=>9
,p_translated_flow_id=>100007
,p_translate_to_id=>9.100007
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14242824915416989)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>20.100007
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \D0C0\C784\B77C\C778 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14243008011416989)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>38.100007
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C704\CE58')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14243294487416989)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>13.100007
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC1D\CCB4 \C138\BD80\C815\BCF4')
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14243407598416989)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>39.100007
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \B77C\C774\C13C\C2A4')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14243611580416989)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>16.100007
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \D1B5\ACC4')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14243879071416989)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>32.100007
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \B85C\AE45')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14244048452416989)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>100.100007
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 [OLD,BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14244248186416989)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>9999.100007
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8\C778 \D398\C774\C9C0')
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14244459951416991)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>6.100007
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14244693446416991)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>50.100007
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14244866042416991)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>51.100007
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8 \D3B8\C9D1')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14245006395416991)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>1.100007
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791\D558\AE30 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14245239276416992)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>7.100007
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14245435963416992)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>15.100007
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\BCC4 \D1B5\ACC4')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14245696850416992)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>31.100007
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - REST - \D074\B77C\C774\C5B8\D2B8')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14245815822416992)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>36.100007
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \D0C0\C774\BA38')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14246039442416992)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>34.100007
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C5D4\C9C4 \C571')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14246266826416992)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>11.100007
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C0DD\C131 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14246481494416992)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>30.100007
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14246613727416992)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>2.100007
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD00\B9AC - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14246830342416992)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>8.100007
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C0C1\C138\B0B4\C5ED - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14247030582416992)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>12.100007
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B2C8\D130 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14247290407416992)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>17.100007
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0DC\C2A4\D06C \D1B5\ACC4')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14247428441416992)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>37.100007
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \D1B5\ACC4')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14247633557416992)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>4.100007
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B378\B7EC - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14247809054416992)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>5.100007
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C775\C2A4\D3EC\D2B8 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14248062417416992)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>10.100007
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B2C8\D130 - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14248236279416992)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>35.100007
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C5D4\C9C4')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14248445233416992)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>33.100007
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C544\CE74\C774\BE0C')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14248692409416992)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>3.100007
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\C2DC\BCF4\B4DC - &APP_NAME_TITLE.')
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14248853716416992)
,p_page_id=>9
,p_translated_flow_id=>100007
,p_translate_to_id=>9.100007
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14249053670416993)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>20.100007
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \D0C0\C784\B77C\C778 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14249251729416993)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>38.100007
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \C704\CE58')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14249416366416993)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>39.100007
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \B77C\C774\C13C\C2A4')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14249673527416993)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>16.100007
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \D1B5\ACC4')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14249823925416993)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>32.100007
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \B85C\AE45')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14250075122416993)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>100.100007
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 [OLD,BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14250264229416993)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>9999.100007
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14250436237416995)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100007)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B450 \C120\D0DD')
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14250623732416995)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100007)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC8C\C774\D2B8\C6E8\C774 \ACBD\B85C \C124\C815')
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14250864656416995)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100007)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14251083083416995)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100007)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14251291378416995)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14251483734416995)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100007)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B450 \C120\D0DD \CDE8\C18C')
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14251630206416995)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD94\AC00')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14251844921416995)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100007)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218 \C124\C815')
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14252075519416995)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100007)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14252234375416995)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100007)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \AD6C\C131')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14252451724416995)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14252647236416995)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100007)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8 \BC0F \D3B8\C9D1')
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14252841960416995)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100007)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14253057784416995)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100007)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14253291055416996)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14253408766416996)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100007)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14253696942416996)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14253865179416996)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \C218\C2E0')
,p_translate_from_text=>'Receive Message'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14254082794416996)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100007)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14254254071416996)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100007)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14254493825416996)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14254620606416996)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100007)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14254808969416996)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100007)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14255048022416996)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100007)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \C0DD\C131')
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14255230080416996)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100007)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14255456339416996)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100007)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C800\C7A5')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14255690454416996)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100007)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14255854226416996)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100007)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\B978 \C784\D3EC\D2B8 \BC0F \C784\D3EC\D2B8')
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14256065963416996)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100007)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14256226132416996)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \BCF5\C0AC')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14256459389416996)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100007)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14256663524416996)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100007)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14256836882416997)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8\C778')
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14257019511416997)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100007)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14257243925416997)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100007)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \AD6C\C131')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14257415789416997)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B9B4\B9AC\C2A4')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14257684566416997)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D15C\D50C\B9AC\D2B8 \C0DD\C131')
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14257828315416997)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100007)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8 \C218\C815')
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14258084185416997)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100007)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14258279730416997)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100007)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804 \CD94\AC00')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14258409772416997)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14258628642416997)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14258867013416997)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100007)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14259059101416997)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\CE74\C774\BE0C')
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14259280054416997)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14259450808416997)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100007)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14259686371416997)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100007)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14259846725416997)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100007)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14260099593416997)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C775\C2A4\D3EC\D2B8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14260260853416997)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100007)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\B85D \BCF4\AE30')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14260443487416997)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100007)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14260616816416997)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C0DD\C131')
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14260855946416997)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100007)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14261071182416998)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100007)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14261247373416998)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100007)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14261412459416998)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100007)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14261689240416998)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100007)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14261815679416998)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D3D0\AE30')
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14262030763416998)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14262216210416998)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100007)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804 \CD94\AC00')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14262457556416998)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100007)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14262601086416998)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 \D3B8\C9D1')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14262883586416998)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100007)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14263017106416998)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD\C0AC\D56D \C801\C6A9')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14263220893416998)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2A4\CF00\C904 \C870\C815 \D0C0\C774\BA38')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14263490329416998)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14263645338416998)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100007)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14263851382416998)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100007)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D655\C778')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14264042148416998)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100007)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 \D3B8\C9D1')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14264246121416998)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100007)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD94\AC00')
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14264414691416998)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100007)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131')
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14264679352416998)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100007)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CDE8\C18C')
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14264871400416998)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D655\C778')
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14265011530416999)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100007)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14265298933416999)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100007)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14265442277416999)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100007)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C800\C7A5')
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14265643660417003)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100007)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14265845399417003)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 ID \C228\AE30\AE30')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14266042699417003)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID \C5F4')
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14266294631417004)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B77C\C774\C13C\C2A4 \D0A4')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14266471120417004)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D \C5F4')
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14266617109417004)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 URL')
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14266832021417004)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100007)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14267086061417004)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D398\C774\B85C\B4DC')
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14267207231417004)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100007)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5F0\ACB0')
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14267434722417004)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C804\C790\BA54\C77C \BC1C\C2E0\C790')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14267673540417004)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14267819893417004)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14268093107417004)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14268263112417004)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C0AC\C6A9\C790 \C774\B984')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14268482923417004)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14268664113417004)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14268868926417004)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \BC18\BCF5 \AC04\ACA9')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14269067558417004)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D30C\C77C \C774\B984')
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14269223269417004)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14269425414417004)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\CF13 \C774\B984')
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14269659753417004)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100007)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B77C\C774\C13C\C2A4 \BC84\C804')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14269826219417004)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100007)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8 \CD9C\CC98')
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14270068480417004)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14270221429417005)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14270431458417005)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14270674062417005)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BB38\C11C \C811\B450\C5B4')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14270842086417005)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\C790')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14271013154417005)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2E0\ADDC')
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14271209640417005)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100007)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC15\C81C \B36E\C5B4\C4F0\AE30')
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14271416769417005)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14271670532417005)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \CD5C\B300 \C8FC\AE30')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14271850089417005)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14272008665417005)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14272271470417005)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C218\D589\C790')
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14272415581417005)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D14C\C774\BE14 \C774\B984')
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14272617502417005)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \BCC0\ACBD \C77C\C790 \D3EC\D568')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14272898421417005)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C720\D615')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14273054720417005)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100007)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC8C\C774\D2B8\C6E8\C774')
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14273284551417005)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C6D4\BCC4 \C694\C57D \C720\C9C0(\C6D4)')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14273467851417005)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \D50C\B85C\C6B0 \B85C\ADF8 \BCF4\C874')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14273623116417005)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100007)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CE90\C2A4\CF00\C774\B4DC')
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14273836506417005)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100007)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14274055619417005)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \B808\BCA8')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14274257588417006)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14274426453417006)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE44\BC00\BC88\D638')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14274648715417006)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8 \C720\C9C0(\C77C)')
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14274856053417006)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14275075943417006)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8 Xml')
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14275281946417006)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804 \D3EC\D568')
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14275461901417006)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D30C\C77C')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14275651668417006)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2A4\CF00\C904 \C870\C815 \D0C0\C774\BA38 \C2DC\AC04')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14275811369417006)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C544\CE74\C774\BE0C \C704\CE58')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14276014614417006)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14276295905417006)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\B978 \C774\B984\C73C\B85C \B2E4\C6B4\B85C\B4DC')
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14276441650417006)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14276663059417006)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14276809083417006)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D074\B77C\C774\C5B8\D2B8 \C554\D638')
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14277084454417006)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C911\BCF5 \B2E8\ACC4 \BC29\C9C0')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14277279150417006)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8 \C774\B984/\C811\BBF8\C5B4')
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14277498906417006)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX \C778\C99D\C11C \C815\C801 ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14277672503417006)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5B8\C5B4')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14277876084417006)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C815\C801 ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14278039115417006)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100007)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C18C\C720\C790')
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14278246753417006)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B77C\C774\C13C\C2A4 \B300\C0C1')
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14278417046417007)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C911\BCF5 \B2E8\ACC4 \BC29\C9C0')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14278625153417007)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B808\BCA8')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14278806637417007)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158 ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14279019196417007)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \D398\C774\C9C0 ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14279299257417007)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14279427045417007)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C704')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14279670811417007)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE44\C988\B2C8\C2A4 \CC38\C870(\D504\B85C\C138\C2A4 \BCC0\C218)')
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14279899074417007)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC \D3EC\D568')
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14280084187417007)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8\C778 \C778\BC14\C6B4\B4DC MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14280219557417007)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100007)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \CD5C\B300 \C8FC\AE30')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14280498050417007)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\C0C1 \C720\D615')
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14280649782417007)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14280865911417007)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B4DC')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14281093087417007)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \D30C\C77C \B0B4\C6A9 \BD99\C5EC\B123\AE30(\CD5C\B300 30,000\C790)')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14281277801417007)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C791\C5C5\C601\C5ED')
,p_translate_from_text=>'Default Workspace'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14281406833417007)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\BCC4 \C694\C57D \C720\C9C0(\C77C)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14281620660417007)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 ID \C228\AE30\AE30')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14281813874417007)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8\C778 \C778\BC14\C6B4\B4DC MessageFlow')
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14282002105417007)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8 \C720\C9C0(\D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4 \C644\B8CC \D6C4 \C77C\C218)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14282293886417007)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C0AC\C6A9\C790 \C774\B984')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14282425740417008)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX \C778\C99D\C11C \C815\C801 ID')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14282651440417008)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \C0AC\C6A9')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14282876033417008)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BLOB \C5F4')
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14283087463417008)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100007)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BA74\D5C8 \B9CC\B8CC\C77C')
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14283264439417008)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14283454466417008)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C218\C2E0 Rest \D1B5\D654 \AE30\B85D')
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14283641981417008)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C9C0\C815 URI')
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14283870711417008)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C804 \C778\C99D URL')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14284000896417008)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100007)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B4DC')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14284288154417008)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8 \C720\C9C0(\D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4 \C644\B8CC \D6C4 \C77C\C218)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14284457642417008)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C9C0\C6D0 URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14284665545417008)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC \D3EC\D568')
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14284849346417008)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14285045571417008)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100007)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5B8\C5B4')
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14285233611417008)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BB38\C11C \C811\B450\C5B4')
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14285480177417008)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C694\C57D \C544\CE74\C774\BE0C \C0AC\C6A9')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14285623283417008)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14285872299417008)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C560\D50C\B9AC\CF00\C774\C158 ID')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14286049349417008)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14286232151417008)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100007)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B4DC')
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14286421692417008)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \C800\C7A5')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14286621991417009)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14286812884417009)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C791\C5C5\C601\C5ED')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14287062095417009)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C9C0\AE08 \D0C0\C774\BA38 \C2A4\CF00\C904 \C870\C815')
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14287261759417009)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \D50C\B85C\C6B0 \B85C\ADF8 \BCF4\C874(\C77C)')
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14287478351417009)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14287670478417009)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14287832248417009)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B808\BCA8')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14288099025417009)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14288246476417009)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BD84\AE30\BCC4 \C694\C57D \C720\C9C0(\C6D4)')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14288451991417009)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218 \C774\B984')
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14288658139417009)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D074\B77C\C774\C5B8\D2B8 ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14288871125417009)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \D398\C774\C9C0 ID')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14289022163417009)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100007)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 URL')
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14289232091417009)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C9C0\C6D0 \C774\BA54\C77C')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14289466464417009)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \C0AC\C6A9')
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14289617490417009)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14289815726417009)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100007)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14290075760417009)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14290274848417009)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC80\C0C9')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14290465709417009)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100007)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14290698596417010)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C694\C57D \C544\CE74\C774\BE0C \C0AC\C6A9')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14290816911417010)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\BCF8 \C804\C790\BA54\C77C \BC1C\C2E0\C790')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14291081551417028)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100007)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BD80\C801\D569\D55C JSON \D615\C2DD')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14291159758417028)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100007)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\C5D0 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14291385818417028)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100007)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C81C\ACF5\B41C \D50C\B85C\C6B0\B97C \D655\C778\D558\C2ED\C2DC\C624.')
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14291546587417028)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\C5D0 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14291716806417028)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100007)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\C5D0 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14291921911417028)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\C5D0 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14292185033417028)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2E4\D589 \C911\C778 \C778\C2A4\D134\C2A4\C640 \C5F0\AD00\B41C \BAA8\B378\C740 \C544\CE74\C774\BE0C\D560 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14292346741417029)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100007)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \D30C\C77C \CF58\D150\CE20\B97C \BD99\C5EC\B123\C73C\C2ED\C2DC\C624.')
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14292506270417029)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100007)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL#\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14292747518417029)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378\C774 \C774\BBF8 \C788\C2B5\B2C8\B2E4. \AC15\C81C\B85C \B36E\C5B4\C4F0\AE30 \D569\B2C8\B2E4.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14292980493417029)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378\C774 \C774\BBF8 \C788\C2B5\B2C8\B2E4. \AC15\C81C\B85C \B36E\C5B4\C4F0\AE30 \D569\B2C8\B2E4.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14293111094417030)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378\C744 \C784\D3EC\D2B8\D588\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14293390481417030)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100007)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14293559174417030)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100007)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14293775414417030)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100007)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14293902122417030)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100007)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14294164917417030)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100007)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14294305790417030)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100007)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Rest \AD6C\C131\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Rest Configuration saved!'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14294513313417030)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14294794769417030)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100007)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14294917489417030)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100007)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14295150401417030)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100007)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14295357346417030)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100007)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5\C774 \CC98\B9AC\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14295554033417030)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100007)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14295790155417030)
,p_page_id=>9
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100007)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14295910647417031)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378\C744 \C784\D3EC\D2B8\D588\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14296158732417032)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100007)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\BCA4\D2B8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14296350210417032)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100007)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5D4\C9C4')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14296531436417032)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100007)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C138\BD80\C815\BCF4')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14296715046417032)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100007)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\BCA4\D2B8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14296911286417032)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100007)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('OAUTH \D074\B77C\C774\C5B8\D2B8')
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14297172979417032)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100007)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14297314898417032)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100007)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14297521563417032)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100007)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14297776378417032)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100007)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\AD6C\C131 - REST - \D074\B77C\C774\C5B8\D2B8')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14297962896417032)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100007)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14298160478417032)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \C131\ACFC(\AE30\AC04 \C694\C57D)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14298385253417032)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100007)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D604\C7AC \D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14298587026417032)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100007)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BC84\D2BC \BC14')
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14298733336417032)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100007)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BCC0\C218 \B0B4\C5ED')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14298909517417032)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100007)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON \AD6C\C131')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14299198063417032)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100007)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D0C0\C774\BA38')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14299316021417032)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B2E8\ACC4 \C774\BCA4\D2B8')
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14299533578417032)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14299754529417033)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100007)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14299904779417033)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C0C1\D0DC\B2F9 \D50C\B85C\C6B0 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14300105765417033)
,p_page_id=>9
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100007)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C139\C158')
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14300387870417033)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100007)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \B2E8\ACC4')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14300520269417033)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\AC80\C0C9')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14300761194417033)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8 \C138\BD80\C815\BCF4')
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14300901446417033)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \AD6C\B3C5')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14301182088417033)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100007)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14301360617417033)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100007)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14301563275417033)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100007)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14301760673417033)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100007)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C2DC\C791\D558\AE30')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14301918490417033)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14302101041417033)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C0DD\C131')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14302359277417033)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100007)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BC84\C804 \BD88\C77C\CE58')
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14302587321417033)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100007)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C784\D3EC\D2B8')
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14302766231417033)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100007)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14302960016417033)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C120\D589 \C870\AC74 \B204\B77D')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14303116192417033)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100007)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BC84\D2BC')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14303316261417033)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100007)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14303580570417034)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100007)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\AC80\C0C9 \ACB0\ACFC')
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14303761489417034)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100007)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5D4\C9C4 \C571')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14303988876417034)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100007)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D1B5\ACC4')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14304105718417034)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100007)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5D4\C9C4 \C571')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14304331521417034)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\CD5C\ADFC 14\C77C \B3D9\C548 \C778\C2A4\D134\C2A4 \C624\B958')
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14304511426417034)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100007)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('JSON \AD6C\C131')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14304740823417034)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100007)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14304995928417034)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BDF0\C5B4')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14305187941417034)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100007)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C18D\C131')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14305302681417034)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C704\CE58')
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14305591729417034)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100007)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C635\C158')
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14305754064417034)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100007)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\AC8C\C774\D2B8\C6E8\C774 \ACBD\B85C \CD94\AC00')
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14305932796417034)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100007)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14306127910417034)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100007)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5D4\C9C4')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14306349065417034)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100007)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B9C1\D06C')
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14306560783417034)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14306741491417034)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14306904037417034)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14307174231417034)
,p_page_id=>9
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100007)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14307371469417034)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BAA8\B4C8 \B204\B77D')
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14307516576417035)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14307737720417035)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14307926075417035)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100007)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Flow Instances'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14308104237417035)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BC84\D2BC \CEE8\D14C\C774\B108')
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14308393129417035)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100007)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14308511444417035)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BAA8\B378 \BCF5\C0AC')
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14308757378417035)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B9C8\C9C0\B9C9 \C624\B958')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14308976845417035)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100007)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME. \C5D0 \B300\D55C \C5ED\C0AC\C801 \B2E8\ACC4 \B300\AE30 \C2DC\AC04( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14309167059417035)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100007)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C18D\C131')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14309337541417035)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100007)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14309530897417035)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100007)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D604\C7AC \B2E8\ACC4')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14309776348417035)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BDF0\C5B4')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14309950061417035)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100007)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B85C\AE45')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14310198816417035)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100007)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C544\CE74\C774\BE0C')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14310335647417035)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100007)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD00\B9AC')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14310593677417035)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100007)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14310771565417035)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100007)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14310997556417035)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100007)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14311141842417036)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100007)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14311308618417036)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8 \D638\CD9C')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14311526176417036)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100007)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B77C\C774\C13C\C2A4')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14311764985417036)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14311969291417036)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100007)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14312107311417036)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100007)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14312371112417036)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('REST \C0AC\C6A9 \C548\D568')
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14312523654417036)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D0ED')
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14312777894417036)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100007)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('&P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )\C5D0 \B300\D55C \C5ED\C0AC\C801 \B2E8\ACC4 \C131\ACFC')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14312982638417036)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5ED\D560')
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14313144899417036)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100007)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8 \ACBD\ACE0')
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14313321478417036)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C138\BD80\C815\BCF4')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14313561976417036)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100007)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14313751223417036)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14313949831417036)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C138\BD80\C815\BCF4')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14314118015417036)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100007)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BCC0\C218 \B0B4\C5ED')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14314308842417036)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\AD6C\C131')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14314541286417036)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100007)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D0C0\C774\BA38')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14314756408417036)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100007)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D604\C7AC \AE30\D55C \ACBD\ACFC \D50C\B85C\C6B0 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14314982735417036)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100007)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14315149290417036)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C815\BCF4')
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14315341008417037)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100007)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14315595318417037)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14315728284417037)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100007)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14315912126417037)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100007)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4\AC00 P15_DATE\C5D0 \C2DC\C791\B418\C5C8\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14316165335417037)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100007)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\CD94\AC00 \C124\CE58 \B2E8\ACC4\AC00 \C644\B8CC\B418\C9C0 \C54A\C74C')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14316380960417037)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100007)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8 \D3B8\C9D1')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14316577165417037)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100007)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14316732477417037)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100007)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\BCA4\D2B8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14316961662417037)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100007)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14317145785417037)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100007)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D0DC\C2A4\D06C \B2E8\ACC4 \C131\ACFC(\D604\C7AC \C6D4) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )')
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14317386597417037)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B2E8\ACC4 \C624\B958')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14317520067417037)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 XML')
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14317770055417037)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100007)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C785\B825/\CD9C\B825 \BCC0\C218')
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14317998127417037)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C0C1\C138 \B0B4\C6A9\C744 \C785\B825\D558\C138\C694')
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14318112430417037)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100007)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14318395902417037)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100007)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BCC0\C218')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14318518447417037)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100007)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14318731544417037)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100007)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14318997344417037)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100007)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C0C1\D0DC\B2F9 \C778\C2A4\D134\C2A4 \CC98\B9AC')
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14319187996417037)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100007)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BAA8\B378 \C0AD\C81C')
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14319333988417038)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100007)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14319563342417038)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D65C\C131 \B300\C0C1 \C120\D0DD')
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14319786100417038)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100007)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BAA8\B378\B2F9 \D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 - \C0C1\C704 10\AC1C')
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14319992453417038)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100007)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C608\C57D \B2E8\ACC4')
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14320109937417038)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100007)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218 \CD94\AC00/\D3B8\C9D1')
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14320379929417038)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14320597090417038)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C774\B3D9 \ACBD\B85C')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14320768557417038)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100007)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\CD5C\ADFC 7\C77C\AC04 \C0DD\C131\B41C \D50C\B85C\C6B0 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14320904670417038)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14321111084417038)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100007)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14321347607417038)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \C0AC\C6A9 \C548\D568')
,p_translate_from_text=>'Timers disabled'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14321522237417038)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100007)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14321710492417038)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C2A4\CF00\C904 \C870\C815 \D0C0\C774\BA38')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14321964145417038)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('APEX \C5C5\ADF8\B808\C774\B4DC\AC00 \AC10\C9C0\B428')
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14322186570417038)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14322372020417038)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C2DC\C791\D558\AE30')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14322508425417038)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C18D\C131')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14322754174417038)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100007)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5F0\AD00\B41C \D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14322955328417038)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14323147647417039)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100007)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14323384958417039)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B2C8\D130(&P12_PRCS_NAME)')
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14323590860417039)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C5B8\C5B4 \C120\D0DD\AE30')
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14323738936417039)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100007)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BC84\D2BC')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14323959849417039)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100007)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\B85C\AE45')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14324193090417039)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BDF0\C5B4')
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14324384625417039)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14324567898417039)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \C218\C2E0')
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14324774116417039)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C791\C5C5 \BA54\B274')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14324938398417039)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\C624\B958')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14325102010417039)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\CF58\D150\CE20')
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14325304413417056)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100007)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14325585071417056)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14325705556417056)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14325925063417056)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100007)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14326147458417056)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100007)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14326359477417057)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14326561708417057)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14326795572417057)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100007)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14326913615417057)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100007)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C120\C5B8\C801\C73C\B85C \ACE0\C720\D55C \D3FC \C815\C758\B97C \C27D\AC8C \BE4C\B4DC\D560 \C218 \C788\B3C4\B85D <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">\B2E8\C21C \D3FC \C791\C131\AE30</span></a>\B97C \C0AC\C6A9\D558\C5EC \D544\C694\D55C JSON\C744 \C0DD\C131\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14327111347417057)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100007)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14327346826417057)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14327561081417057)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100007)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14327728283417057)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>REST \BAA8\B4C8\C774 \C124\CE58\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>\C758 \C124\CE58 \AC00\C774\B4DC\B97C \B530\B974\C2ED\C2DC\C624.')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14327969497417057)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14328127516417057)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100007)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14328306465417057)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100007)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEX\C758 Flows\B97C \C0AC\C6A9\D558\C5EC \AD6C\CD95\B41C \BAA8\B378\C744 \C784\D3EC\D2B8\D558\C5EC \C5D4\C9C4\C5D0\C11C \C2E4\D589\D560 \C218 \C788\B3C4\B85D \D558\B294 \AC83\C774 \C88B\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14328533127417057)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>\C2A4\D0A4\B9C8\AC00 REST \C0AC\C6A9\C73C\B85C \C124\C815\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14328751263417057)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C774 \D398\C774\C9C0\C5D0\C11C\B294 \B2E8\C21C \D3FC \D15C\D50C\B9AC\D2B8\C758 JSON \C815\C758\B97C \AD00\B9AC\D560 \C218 \C788\C2B5\B2C8\B2E4. \D15C\D50C\B9AC\D2B8\B294 \B2E4\C74C \B450 \AC00\C9C0 \BC29\BC95\C73C\B85C \C0AC\C6A9\D560 \C218 \C788\C2B5\B2C8\B2E4. <ul>'),
unistr('    <li>\D50C\B85C\C6B0 \BAA8\B378\C5D0\C11C "\B2E8\C21C \C591\C2DD" \C720\D615\C758 \C0AC\C6A9\C790 \D0DC\C2A4\D06C\C5D0\C11C \C120\D0DD\D569\B2C8\B2E4.</li>'),
unistr('    <li>\D3FC\C744 \C791\C131\D558\C5EC \D50C\B85C\C6B0 \BD84\BC30\C758 <strong>\B2E8\C21C \D504\B85C\C138\C2A4 \C2A4\D0C0\D130 \C571</strong>\C5D0\C11C \C774 \C571\C744 \D65C\C6A9\D558\C5EC \D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4\B97C \C2DC\C791\D569\B2C8\B2E4. </ul>')))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14328945444417057)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100007)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14329116827417058)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100007)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14329399590417058)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100007)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX\C758 \D0C0\C774\BA38 \AE30\B2A5\C744 \C0AC\C6A9\D558\B824\BA74 <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">\C5EC\AE30</a>\C5D0\C11C \CC3E\C744 \C218 \C788\B294 \CD94\AC00 \C124\CE58 \B2E8\ACC4\B97C \C644\B8CC\D574\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14329570139417058)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100007)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14329779985417058)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100007)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14329957238417058)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\B098 \C774\C0C1\C758 \D0C0\C774\BA38\AC00 \D3EC\D568\B41C \BAA8\B378\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B418\C5C8\C73C\BBC0\B85C \C774 \C2DC\C2A4\D15C\C5D0\C11C \C81C\B300\B85C \C791\B3D9\D558\C9C0 \BABB\D588\C2B5\B2C8\B2E4.<br>\AD6C\C131 \D398\C774\C9C0\C5D0\C11C \C0AC\C6A9\C73C\B85C \C124\C815\D560 \C218 \C788\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14330122428417058)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14330373157417058)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100007)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14330505005417058)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100007)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14330702638417058)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>APEX\C6A9 \B85C\C6B0 \CF54\B4DC BPMN \AE30\BC18 \D504\B85C\C138\C2A4 \D50C\B85C\C6B0 \C2DC\C2A4\D15C\C785\B2C8\B2E4.</h3>'),
unistr('<h4> \AE30\B2A5</h4>'),
'<ul>',
unistr('<li>Flows for APEX APEX \AC1C\BC1C\C790\B294 \C2DC\AC01\C801 \D504\B85C\C138\C2A4 \C124\ACC4\C640 \B85C\C6B0 \CF54\B4DC \AE30\BC95\C744 \ACB0\D569\D558\C5EC APEX\C5D0\C11C \D504\B85C\C138\C2A4 \D750\B984\C744 \BAA8\B378\B9C1\D558\ACE0 \C2E4\D589\D560 \C218 \C788\C2B5\B2C8\B2E4.</li>'),
unistr('<li>APEX \AC1C\BC1C\C790\B97C \C704\D574 \C8FC\B85C \C124\ACC4\B41C Flows for APEX\B294 APEX, PL/SQL, SQL \B4F1 \C774\BBF8 \C775\C219\D55C \AE30\C220\C744 \C0AC\C6A9\D558\C5EC APEX \D658\ACBD\C5D0\C11C \AC15\B825\D558\ACE0 \C720\C5F0\D55C \D504\B85C\C138\C2A4 \D50C\B85C\C6B0\B97C \C0DD\C131\D569\B2C8\B2E4.</li>'),
unistr('<li>APEX \D398\C774\C9C0, PL/SQL \C2A4\D06C\B9BD\D2B8, \C804\C790\BA54\C77C \C804\C1A1\C758 \D504\B85C\C138\C2A4 \D50C\B85C\C6B0\B97C \C0DD\C131 \BC0F \C2E4\D589\D558\B294 \B370 \C0AC\C6A9\B429\B2C8\B2E4.</li>'),
unistr('<li> \B85C\C6B0 \CF54\B4DC \B3C4\D45C \BC29\C2DD\C758 \D504\B85C\C138\C2A4 \C815\C758\B97C \BE44\C988\B2C8\C2A4 \C0AC\C6A9\C790\AC00 \C774\D574\D558\ACE0 \D3B8\C9D1\D558\C5EC \BE44\C988\B2C8\C2A4 \C720\C5F0\C131\C744 \B192\C77C \C218\B3C4 \C788\C2B5\B2C8\B2E4. \D50C\B85C\C6B0\B294 BPMN(Business Process Modeling Notation) V2 \C2A4\D0C0\C77C\C744 \C0AC\C6A9\D569\B2C8\B2E4.</li>'),
unistr('<li>APEX \CEE4\BBA4\B2C8\D2F0 \D504\B85C\C81D\D2B8\B85C \AD6C\CD95\B418\ACE0, \C624\D508 \C18C\C2A4 MIT \B77C\C774\C120\C2A4\C5D0 \BC30\D3EC\B429\B2C8\B2E4.</li>'),
'</ul>',
'<p>',
unistr('<h4>\B2E4\C6B4\B85C\B4DC</h4>'),
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a> <p>',
unistr('<h4>\C124\BA85\C11C</h4>'),
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">\C628\B77C\C778 \CD5C\C2E0 \C124\BA85\C11C</a> <p>'),
unistr('<h4>BPMN \C790\C2B5\C11C</h4>'),
unistr('\BAA8\B378\B9C1 \D50C\B85C\C6B0\B97C \C2DC\C791\D558\B824\BA74 \C0AC\C804 \C124\CE58\B41C \D29C\D1A0\B9AC\C5BC \D50C\B85C\C6B0\B97C \C0AC\C6A9\D574 \BCF4\C2ED\C2DC\C624. \D29C\D1A0\B9AC\C5BC\C5D0 \B300\D55C \C790\C138\D55C \B0B4\C6A9\C740 <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">\C5EC\AE30</a>\B97C \CC38\C870\D558\C2ED\C2DC\C624. <p>'),
unistr('<h4>\B370\BAA8 \C571</h4>'),
'<p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14330947069417058)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100007)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14331169960417058)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14331317079417062)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100007)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \C704\CE58')
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14331528497417062)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14331705868417062)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100007)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\CE74\C774\BE0C \C704\CE58')
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14331913180417062)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14332129517417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100007)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14332372908417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100007)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14332589207417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100007)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14332715524417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100007)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14332973938417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100007)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8\B85C\ACE0\CE68')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14333177369417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100007)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14333312283417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100007)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCF5\C0AC')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14333514353417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100007)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C885\B8CC')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14333717573417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100007)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14333995644417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100007)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C885\B8CC')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14334183828417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100007)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D14C\B9C8')
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14334344458417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100007)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B77C\C774\C13C\C2A4')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14334578117417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100007)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C885\B8CC')
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14334701244417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100007)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B2C8\D130')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14334935209417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14335178400417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100007)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8\B85C\ACE0\CE68')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14335320896417063)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100007)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14335503468417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100007)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C138\BD80\C815\BCF4 \D45C\C2DC')
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14335763417417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100007)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804 \CD94\AC00\D558\AE30')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14335979103417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100007)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14336128911417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100007)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C6B4\B85C\B4DC(SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14336338105417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14336536354417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100007)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C694\C57D')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14336747434417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100007)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D3B8\C9D1')
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14336933109417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100007)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14337194056417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100007)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5D4\C9C4')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14337319916417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \D0C0\C784\B77C\C778 \D45C\C2DC')
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14337567738417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100007)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14337779656417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100007)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14337941502417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100007)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8\B85C\ACE0\CE68')
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14338178967417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100007)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \C138\BD80\C815\BCF4 \D45C\C2DC')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14338366635417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100007)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14338592977417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100007)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AD\C81C')
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14338771803417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100007)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C8 \BC84\C804 \CD94\AC00\D558\AE30')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14338959153417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100007)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C790\B3D9')
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14339161512417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14339328199417064)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100007)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5D4\C9C4 \C571')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14339522546417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100007)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14339753093417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100007)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\C2DC\BCF4\B4DC')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14339924164417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100007)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\B85D \BCF4\AE30')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14340143974417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100007)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\CE74\C774\BE0C')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14340360978417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100007)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D1B5\ACC4')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14340529701417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100007)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C6B4\B85C\B4DC(SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14340777752417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100007)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4 \D0C0\C774\BA38')
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14340902241417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100007)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\B798 \BCF4\ACE0\C11C|\CE21\BA74|\C0C8 \CC3D')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14341108265417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100007)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14341328122417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\ADF8\C544\C6C3')
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14341566833417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100007)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14341726957417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100007)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791\D558\AE30')
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14341922095417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100007)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2A4\CF00\C904 \C870\C815')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14342161634417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100007)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14342370031417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100007)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D45C\C2DC \C124\C815')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14342574435417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14342723113417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100007)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C784\D3EC\D2B8')
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14342936591417065)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100007)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14343178487417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100007)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C775\C2A4\D3EC\D2B8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14343304872417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100007)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCF5\C0AC')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14343553608417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5B4\B450\C6B4 \BAA8\B4DC')
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14343768615417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100007)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14343939514417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100007)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14344124515417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100007)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \C138\BD80\C815\BCF4 \D45C\C2DC')
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14344351760417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100007)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC')
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14344572665417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14344798845417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B9B4\B9AC\C2A4')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14344958682417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100007)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D45C\C2DC \C124\C815')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14345114684417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100007)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C18C\C2A4 \BCF4\AE30')
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14345348410417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100007)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C138\BD80\C815\BCF4 \D45C\C2DC')
,p_translate_from_text=>'Show Details'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14345534791417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100007)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14345741204417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C2DC\C791')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14345908874417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14346159688417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100007)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14346321160417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100007)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\AE45')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14346584943417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B9B4\B9AC\C2A4')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14346778973417066)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100007)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14346988867417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100007)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14347162961417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100007)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C6B4\B85C\B4DC(SVG)')
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14347301593417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100007)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C775\C2A4\D3EC\D2B8')
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14347567425417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100007)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCF4\AE30')
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14347797146417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100007)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14347907051417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B77C\C774\D2B8 \BAA8\B4DC')
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14348188566417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100007)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2A4\CF00\C904 \C870\C815')
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14348309322417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100007)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14348519915417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100007)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\B798 \BCF4\ACE0\C11C|\CE21\BA74|\C0C8 \CC3D')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14348770315417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100007)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\B85D \BCF4\AE30')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14348929177417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14349163258417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C2DC\C791')
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14349366810417067)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100007)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD00\B9AC')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14349568714417073)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C120\D0DD\B41C \D504\B85C\C138\C2A4 \C5C6\C74C')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14349717086417073)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C120\D0DD\B41C \D504\B85C\C138\C2A4 \C5C6\C74C')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14349900514417073)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100007)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C18D\C131\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14350120759417073)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14350379381417073)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100007)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C785\B825/\CD9C\B825 \BCC0\C218\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14350588760417074)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC80\C0C9 \B300\D654\C0C1\C790')
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14350702727417074)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14350985458417075)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14351197352417075)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14351366276417075)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14351515277417075)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC80\C0C9')
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14351732398417075)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2EB\AE30')
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14351901978417076)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C74C  &gt;')
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14352188017417076)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('< \C774\C804')
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14352333680417076)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774 \C0AD\C81C \C791\C5C5\C744 \C218\D589\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14352599188417076)
,p_translated_flow_id=>100007
,p_translate_to_id=>100.100007
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C6CC\D06C\D50C\B85C\C6B0')
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14352785788417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100007)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \D1B5\ACC4')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14352970006417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100007)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD00\B9AC')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14353168786417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100007)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('REST \C11C\BE44\C2A4')
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14353301947417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5D4\C9C4')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14353593072417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100007)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\CE74\C774\BE0C')
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14353718069417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100007)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B2C8\D130')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14353946436417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100007)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \D0C0\C784\B77C\C778 - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14354136605417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100007)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14354358438417077)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100007)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14354595464417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100007)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\C2DC\BCF4\B4DC')
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14354766306417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100007)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0DC\C2A4\D06C \D1B5\ACC4')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14354919323417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100007)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D1B5\ACC4')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14355139061417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100007)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5D4\C9C4 \C571')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14355393696417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100007)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\BCC4 \D1B5\ACC4')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14355544012417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100007)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14355713748417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100007)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD6C\C131 - \B77C\C774\C13C\C2A4')
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14355932975417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100007)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \BAA8\B378\B7EC')
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14356136434417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100007)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B85C\AE45')
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14356396072417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100007)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38')
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14356563364417078)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100007)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14356725600417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100007)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D30C\C77C')
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14356937459417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100007)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\D6C4 \D0DC\C2A4\D06C')
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14357150339417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100007)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BD84\D560 \C804')
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14357333833417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100007)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D1F4\C9C1 \D6C4 \D504\B85C\C138\C2A4 \C0C1\D0DC')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14357544596417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100007)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C704\CE58 \D45C\C2DC\C790')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14357765305417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100007)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14357949601417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100007)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C228\C740 \CC38\C870')
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14358112530417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100007)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\C790')
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14358352483417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100007)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC04\ACA9 \B144-\C6D4')
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14358595380417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100007)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218')
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14358717216417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100007)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D14D\C2A4\D2B8')
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14358995260417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100007)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \C2A4\D06C\B9BD\D2B8')
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14359139322417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100007)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C694\CCAD')
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14359368478417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100007)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D398\C774\C9C0 \D56D\BAA9')
,p_translate_from_text=>'Page Items'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14359574457417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100007)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38\AC00 \B2E4\C2DC \C2E4\D589\B420 \B54C\AE4C\C9C0\C758 \C2DC\AC04')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14359763431417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100007)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\B300 \C2E4\D589')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14359981297417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100007)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD9C\B825 \BCC0\C218')
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14360145291417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100007)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \D568\C218 \BCF8\BB38')
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14360399985417080)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100007)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D398\C774\C9C0')
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14360561534417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100007)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D615\C2DD \B9C8\C2A4\D06C')
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14360779654417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100007)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC04\ACA9 \C77C-\CD08')
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14360919682417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100007)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38\AC00 \BA3C\C800 \C2E4\D589\B420 \B54C\AE4C\C9C0\C758 \C2DC\AC04')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14361197470417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100007)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5D4\C9C4')
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14361377427417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100007)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \C815\C758 \C720\D615')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14361567657417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100007)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \C815\C758')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14361753488417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100007)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D68C\C2E0 \B300\C0C1')
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14361948032417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C774\B984 \C800\C7A5')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14362199330417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100007)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('BPMN \D30C\C77C')
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14362373486417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100007)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0DC\C2A4\D06C \C804')
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14362504870417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100007)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC1B\B294 \C0AC\B78C')
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14362704906417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100007)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CC38\C870')
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14362969756417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100007)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C989\C2DC \C804\C1A1')
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14363144365417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100007)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C804')
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14363335465417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100007)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID')
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14363551747417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100007)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('HTML \BCF8\BB38')
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14363732456417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100007)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCD1\D569 \D6C4')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14363955763417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100007)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791\C77C')
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14364144499417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100007)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C815\C801 \AC12')
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14364301455417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100007)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C81C\BAA9')
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14364586065417081)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100007)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D488\BAA9')
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14364715273417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100007)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \C9C8\C758(\CF5C\B860\C73C\B85C \AD6C\BD84\B41C \AC12 \BC18\D658)')
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14364900221417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100007)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \D45C\D604\C2DD')
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14365134982417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100007)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('PL/SQL \CF54\B4DC')
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14365333954417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100007)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14365520475417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100007)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C2DC')
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14365750444417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100007)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CCA8\BD80')
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14365940257417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100007)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL \C9C8\C758(\B2E8\C77C \AC12 \BC18\D658)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14366168991417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100007)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CE90\C2DC \C9C0\C6B0\AE30')
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14366373451417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100007)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D488\BAA9 \AC12')
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14366517950417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100007)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCF8\BB38')
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14366725546417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100007)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0DC\C2A4\D06C \C720\D615')
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14366941206417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100007)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D15C\D50C\B9AC\D2B8 \C0AC\C6A9')
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14367180781417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100007)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D15C\D50C\B9AC\D2B8 ID')
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14367387208417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100007)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14367536639417082)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100007)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D398\C774\C9C0 \D56D\BAA9 \AC12 \BC14\C778\B4DC')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14367729314417086)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\B85D\B41C \D558\C704 \D50C\B85C\C6B0 \C5C6\C74C')
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14367971700417086)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\B85D\B41C \D504\B85C\C138\C2A4 \B808\BCA8 \C5C6\C74C')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14368128383417086)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('	- \C120\D0DD -')
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14368333731417086)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC \C5C6\C74C')
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14368539725417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100007)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC29\D5A5')
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14368726985417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100007)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14368957483417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100007)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14369143863417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100007)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958 \C2A4\D0DD')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14369307930417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100007)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C0C1\D0DC')
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14369599906417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100007)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14369709725417086)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100007)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14369911469417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14370116208417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100007)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14370355586417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100007)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C77C\C790')
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14370583167417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14370773597417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100007)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \AC00\B2A5')
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14370919056417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100007)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD08\AE30\D654 \C77C\C790')
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14371199349417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100007)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14371306838417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14371501643417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100007)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D398\C774\C9C0 ID')
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14371752420417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100007)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14371989237417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100007)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14372100459417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100007)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14372311353417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100007)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14372516761417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100007)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8 \C77C\C790')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14372736871417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100007)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C81C\BAA9')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14372916310417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100007)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C544\C774\CF58')
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14373173043417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100007)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14373372207417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14373518715417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100007)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C124\BA85')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14373783535417087)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100007)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14373953767417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14374130744417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100007)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378')
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14374320767417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100007)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14374537817417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100007)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C560\D50C\B9AC\CF00\C774\C158 ID')
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14374770710417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100007)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C0C9\C0C1')
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14374909020417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100007)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B370\C774\D130 \C720\D615')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14375125185417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100007)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14375367875417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100007)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14375527516417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C6B0\C120\C21C\C704')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14375720048417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100007)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14375996459417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100007)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8 \C720\D615')
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14376185467417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100007)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14376374937417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100007)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14376529798417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B9CC\AE30 \C77C\C790')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14376771898417088)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100007)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14376977356417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100007)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14377194318417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100007)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14377368618417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100007)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14377532937417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14377766014417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14377943128417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100007)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14378122679417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100007)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14378300716417091)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100007)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14378516041417092)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14378755385417092)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100007)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14378969049417092)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14379119803417092)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100007)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14379303406417092)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100007)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14379595279417092)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100007)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14379729212417093)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li>One Model: \BAA8\B4E0 \C18D\C131\C774 \D3EC\D568\B41C \B2E8\C77C \BAA8\B378 \C784\D3EC\D2B8</li>'),
unistr('    <li>\B2E4\C911 \BAA8\B378: zip \D30C\C77C\B85C \C5EC\B7EC \BAA8\B378 \C784\D3EC\D2B8*</li>'),
'</ul>',
'<p>',
unistr('   * zip \D30C\C77C\C5D0\B294 \B2E4\C74C\C774 \D3EC\D568\B418\C5B4\C57C \D569\B2C8\B2E4.'),
'    <ul>',
unistr('        <li>\C784\D3EC\D2B8\D560  bpmn \D30C\C77C\B4E4</li>'),
unistr('        <li>\B2E4\C74C \C18D\C131\C744 \AC00\C9C4 \AC1D\CCB4 \BC30\C5F4(\C544\B798 \C608 \CC38\C870)\C778 import.json \D30C\C77C.'),
'            <ul>',
unistr('                <li>dgrm_name: \BAA8\B378\C758 \C774\B984</li>'),
unistr('                <li>dgrm_version: \BAA8\B378\C758 \BC84\C804</li>'),
unistr('                <li>dgrm_category: \BAA8\B378\C758 \BC94\C8FC</li>'),
unistr('                <li>file: \C544\CE74\C774\BE0C\C5D0 \C788\B294 bpmn \D30C\C77C\C758 \C774\B984</li>'),
'            </ul>',
'        </li>',
'    </ul>',
unistr('\B450 \AC1C\C758 \BAA8\B378\C774 \C788\B294 import.json \D30C\C77C\C758 \C608<br>'),
'<pre><code>[',
'{',
unistr('     "dgrm_name": "\D53C\C790 \D611\B825",'),
'    "dgrm_version": "0",',
unistr('    "dgrm_status": "\CD08\C548",'),
'    "dgrm_category": null,',
unistr('    "file": "\D53C\C790 Collaboration_0.bpmn"'),
'  },',
'  {',
unistr('    "dgrm_name": "\D734\C77C",'),
'    "dgrm_version": "0",',
unistr('    "dgrm_status": "\CD08\C548",'),
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14379916812417093)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\C774 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD\D558\BA74 \C560\D50C\B9AC\CF00\C774\C158\C774 \C0AC\C6A9\C790 \C774\B984\C744 \C601\AD6C \BE0C\B77C\C6B0\C800 \CFE0\D0A4 "LOGIN_USERNAME_COOKIE"\C5D0 \C800\C7A5\D569\B2C8\B2E4. \B2E4\C74C\C5D0 \B85C\ADF8\C778 \D398\C774\C9C0\B85C \C774\B3D9\D558\BA74 '),
unistr('\C0AC\C6A9\C790 \C774\B984 \D544\B4DC\AC00 \C790\B3D9\C73C\B85C \C774 \AC12\C73C\B85C \CC44\C6CC\C9D1\B2C8\B2E4.'),
'</p> <p>',
unistr('\C774 \CCB4\D06C\BC15\C2A4\B97C \C120\D0DD \D574\C81C\D558\ACE0 \C0AC\C6A9\C790 \C774\B984\C774 \CFE0\D0A4\C5D0 \C774\BBF8 \C800\C7A5\B41C \ACBD\C6B0'),
unistr('\C560\D50C\B9AC\CF00\C774\C158\C774 \BE48 \AC12\C73C\B85C \ACB9\CCD0\C501\B2C8\B2E4. \BE0C\B77C\C6B0\C800\C758 \AC1C\BC1C\C790 \D234\C744 \C0AC\C6A9\D558\C5EC \CFE0\D0A4\B97C \C644\C804\D788 \C81C\AC70\D560 \C218\B3C4 \C788\C2B5\B2C8\B2E4.'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14380152591417093)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14380333302417094)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100007)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\BCA4\D2B8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14380590530417094)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100007)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14380740249417094)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100007)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14380973934417094)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C21C \C591\C2DD \D15C\D50C\B9AC\D2B8')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14381116800417094)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100007)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218 \B0B4\C5ED')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14381385772417094)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100007)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\BCA4\D2B8')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14381583544417094)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100007)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ORDS \D074\B77C\C774\C5B8\D2B8 \BCF4\ACE0\C11C')
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14381774012417094)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100007)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \BAA8\B378')
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14381978379417094)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \AD6C\B3C5')
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14382176817417094)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100007)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \B2E8\ACC4')
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14382318216417094)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100007)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C18D\C131')
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14382567514417094)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100007)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14382781636417095)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100007)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD00\B9AC')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14382917606417095)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8 \D638\CD9C')
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14383176727417095)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100007)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14383315865417095)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100007)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14383525453417095)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100007)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \B2E8\ACC4')
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14383719622417095)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100007)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218 \B0B4\C5ED')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14383954304417095)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100007)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14384138951417095)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4 \C624\B958')
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14384300466417095)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100007)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14384529723417096)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100007)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774 \BCF4\ACE0\C11C\C758 \CD5C\B300 \D589 \C218\B294 #MAX_ROW_COUNT#\AC1C \D589\C785\B2C8\B2E4. \CFFC\B9AC\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14384781895417096)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774 \BCF4\ACE0\C11C\C758 \CD5C\B300 \D589 \C218\B294 #MAX_ROW_COUNT#\AC1C\C785\B2C8\B2E4. \C870\D68C\C758 \B808\CF54\B4DC \C218\B97C \C904\C774\B824\BA74 \D544\D130\B97C \C801\C6A9\D558\C2ED\C2DC\C624.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14384900982417097)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218 \B0B4\C5ED\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14385179767417097)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4 \C624\B958 \AE30\B85D\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14385374834417097)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \D558\C704 \D50C\B85C\C6B0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14385566797417097)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218 \D45C\D604\C2DD\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14385735491417097)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \B2E4\C774\C5B4\ADF8\B7A8\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14385997088417097)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \D558\C704 \D50C\B85C\C6B0\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14386141529417097)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\BCA4\D2B8 \B0B4\C5ED\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14386313407417097)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100007)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14386597386417097)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C18D\C131\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14386772873417097)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14386902085417097)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100007)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BCC0\C218 \B0B4\C5ED\C774 \BE44\C5B4 \C788\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14387108264417097)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100007)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B370\C774\D130\AC00 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14387351886417097)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \B2E8\ACC4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14387507249417098)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \B2E8\ACC4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14387724381417099)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14387919158417099)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14388120570417099)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14388367701417099)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14388511917417099)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14388785985417099)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14388968667417099)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14389169822417099)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14389354461417099)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14389585820417099)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14389786405417099)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14389975370417099)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14390159878417099)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14390372943417099)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14390524492417099)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14390796408417099)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14390944632417099)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14391178146417099)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14391361623417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14391599858417100)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100007)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14391757947417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100007)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14391925550417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14392127062417100)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14392373814417100)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14392566599417100)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100007)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14392796319417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14392967239417100)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14393161728417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14393367403417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100007)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14393555677417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100007)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14393702605417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14393951527417100)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14394117750417100)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14394367999417100)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14394501749417100)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14394762702417100)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14394995129417100)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14395155062417100)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14395396251417101)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14395526319417101)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14395745004417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100007)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14395999526417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14396135526417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14396318961417101)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14396502205417101)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14396769634417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100007)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14396921615417101)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100007)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14397123893417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14397399270417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14397590646417101)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14397797042417101)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14397968472417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100007)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14398150084417101)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14398357423417101)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14398540637417101)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14398727800417101)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100007)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14398992403417101)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14399196049417102)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14399355028417102)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14399541087417102)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14399747366417102)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100007)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14399940644417102)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14400119799417102)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14400327643417102)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14400512357417102)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100007)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14400754213417102)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14400995285417102)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100007)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14401187252417102)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14401305467417102)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14401586911417102)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14401776216417102)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14401977538417102)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14402183675417102)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14402367512417102)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14402581599417102)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14402776526417102)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14402945944417103)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14403180542417103)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14403353952417103)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14403581712417103)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14403775018417103)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14403929534417103)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100007)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14404181975417103)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14404370692417103)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100007)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14404591828417103)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14404717899417103)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14404981498417103)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14405101758417103)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14405371913417103)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100007)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14405507654417103)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100007)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14405714922417103)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100007)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14405984942417103)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14406110746417103)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14406349255417103)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14406543917417103)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100007)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14406740121417104)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14406985193417104)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14407172529417104)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14407354683417104)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14407580038417104)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14407799550417104)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14407941843417104)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14408148695417104)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14408302535417104)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14408510609417104)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14408742662417104)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14408990657417104)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14409187479417104)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14409350759417104)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14409506525417104)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14409752005417104)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14409963995417104)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14410185468417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14410310985417105)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14410537983417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14410740373417105)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14410981094417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14411194845417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14411339680417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14411529608417105)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14411772783417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100007)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14411907172417105)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14412177066417105)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14412381081417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100007)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14412527837417105)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14412719612417105)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14412915109417105)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14413159823417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100007)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14413355920417105)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14413562533417105)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14413751701417105)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14413978760417106)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100007)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14414137843417106)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14414342121417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14414541641417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14414732261417106)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14414977438417106)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100007)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14415133076417106)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14415336453417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14415534619417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100007)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14415703851417106)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14415915968417106)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100007)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14416104173417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14416357991417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14416597630417106)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14416770618417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14416909615417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14417125432417106)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14417318692417106)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100007)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14417565629417106)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14417791877417107)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14417911366417107)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14418120212417107)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14418389870417107)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14418589347417107)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14418711042417107)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100007)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14418949682417107)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14419168177417107)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14419384352417107)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14419554204417107)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14419717890417107)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14419971334417107)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14420102646417107)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14420375825417107)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14420522430417107)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100007)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14420718770417107)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14420990428417107)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14421135628417107)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14421391975417107)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14421554297417107)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14421762611417108)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100007)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14421946014417108)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14422164999417108)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14422328139417108)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14422528571417108)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100007)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14422760599417108)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14422923094417108)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100007)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14423190644417108)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14423323158417108)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14423550604417108)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14423712292417108)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14423950194417108)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14424182534417108)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14424373606417108)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100007)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14424588374417108)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14424764947417108)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14424970651417108)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14425160464417108)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14425393153417108)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14425539223417109)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14425783830417109)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100007)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14425968527417109)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14426154114417109)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14426383467417109)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14426524772417109)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100007)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14426715495417109)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14426913010417109)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14427157568417109)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100007)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14427389843417109)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14427593026417109)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100007)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14427702401417109)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100007)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14427942309417109)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14428192161417109)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14428373081417109)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14428510156417109)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14428752011417109)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100007)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14428957658417109)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14429199736417109)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14429378987417110)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14429573878417110)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14429766459417110)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14429919719417110)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100007)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14430150250417110)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14430323140417110)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14430546416417110)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14430767114417110)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14430997271417110)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14431178023417110)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14431311590417110)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14431512406417110)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14431724996417110)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14431936808417110)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14432157902417110)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14432315779417110)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100007)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14432534620417110)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14432743895417110)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100007)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14432942503417110)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14433130672417124)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0C0\C774\BA38 \C2DC\C791 \C77C\C790')
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14433306794417124)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14433517275417124)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \BC94\C704')
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14433726368417124)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC1D\CCB4')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14433986984417124)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Json \C18D\C131')
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14434130285417124)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14434372391417124)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14434588786417124)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC1D\CCB4')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14434797794417124)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14434999801417124)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14435145978417124)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14435330774417124)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131 \C77C\C790')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14435549204417124)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14435712957417124)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8 \BC84\C804 \C120\D0DD')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14435998546417124)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14436107371417124)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14436388155417124)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14436580177417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14436750009417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791 \AC1D\CCB4')
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14436934496417125)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100007)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C9C0\C6D0 \C774\BA54\C77C')
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14437130922417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100007)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14437301610417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \C218\C900')
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14437531949417125)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \BC84\C804')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14437766215417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14437911705417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100007)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC \C2DC \C0C1\D0DC')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14438182120417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0A4 \AC12')
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14438334520417125)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14438530222417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B808\C778')
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14438746120417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100007)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D \B300\C0C1')
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14438942651417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100007)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14439139558417125)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D0A4 \C774\B984')
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14439320674417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14439599756417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14439764333417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14439975382417125)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC18\BCF5 \C544\C774\CF58 \C788\C74C')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14440126502417125)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SFTE ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14440302512417125)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14440582692417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE60\B978 \C791\C5C5')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14440773974417126)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C774\B984')
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14440950158417126)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14441173604417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100007)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14441352460417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14441537928417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B9CC\AE30 \C77C\C790')
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14441750093417126)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14441993888417126)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14442189837417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100007)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14442315204417126)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100007)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE60\B978 \C791\C5C5')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14442570177417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131\B428')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14442617435417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14442893994417126)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2E4\D589')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14443070126417126)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C644\B8CC')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14443241380417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100007)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14443425629417126)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14443699594417126)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14443865811417126)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \D074\B798\C2A4')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14444062597417126)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100007)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14444269397417127)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C704')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14444456839417127)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C815\C801 ID')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14444676650417127)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14444847587417127)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC\B85C \C124\C815')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14445043189417127)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100007)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14445236237417127)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14445489384417127)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D45C\D604\C2DD')
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14445666759417127)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2E4\D589')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14445832574417127)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100007)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14446090925417127)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14446250840417127)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100007)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14446428561417127)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14446655849417127)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100007)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC1D\CCB4')
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14446864872417127)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14447083303417127)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14447276426417127)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14447456317417127)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C81C\C678\B41C \C0AC\C6A9\C790')
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14447677905417127)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14447870727417127)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14448053354417128)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14448281896417128)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14448454830417128)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \C2DC\C791\B428')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14448661131417128)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D398\C774\B85C\B4DC \BCC0\C218')
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14448883110417128)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14449033950417128)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14449264053417128)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100007)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D50C\B85C\C6B0 \AD6C\BB38 \BD84\C11D\B428')
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14449442619417128)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14449616815417128)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100007)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14449800462417128)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14450019843417128)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \B808\BCA8')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14450208362417128)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \C2DC\C791\B428')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14450433215417128)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14450609668417128)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100007)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14450885758417128)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100007)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14451025247417128)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100007)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14451207502417128)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 ID')
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14451467895417128)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14451698127417128)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14451897857417129)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100007)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C644\B8CC')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14452051306417129)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B8E8\D2B8 \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14452289402417129)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14452487272417129)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14452663148417129)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14452886868417129)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \AC1D\CCB4')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14453079286417129)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C720\D615')
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14453244065417129)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8')
,p_translate_from_text=>'Last Update'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14453489551417129)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14453635770417129)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14453807646417129)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14454014699417129)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14454277386417129)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14454413160417129)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14454683515417129)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14454840540417129)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B808\BCA8')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14455062119417129)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14455290757417129)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14455478777417129)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100007)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14455603166417129)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14455816736417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14456055175417130)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14456289523417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14456474878417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14456608943417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BA54\C2DC\C9C0 \C774\B984')
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14456897059417130)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C644\B8CC')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14457061117417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100007)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14457268007417130)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \B808\BCA8')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14457485927417130)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14457626715417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100007)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \AC1D\CCB4')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14457825776417130)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14458018647417130)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14458266803417130)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \AC1D\CCB4')
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14458480858417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100007)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C704')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14458664318417130)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14458821432417130)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\BCA4\D2B8')
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14459076672417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C6B0\C120\C21C\C704')
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14459254306417130)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100007)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14459423962417130)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C608\C57D')
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14459648903417130)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958 \C2A4\D0DD')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14459821305417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14460081974417131)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C5C5\B370\C774\D2B8')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14460294587417131)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100007)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14460404813417131)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14460631130417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2E4\D589')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14460843527417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100007)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4 \D0A4')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14461078347417131)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14461266152417131)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100007)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4 \D0A4')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14461419089417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14461667375417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BPMN ID'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14461890347417131)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC\B85C \C124\C815')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14462094057417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B370\C774\D130 \C720\D615')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14462211473417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14462468725417131)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14462655848417131)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100007)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14462812367417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14463096011417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14463254775417131)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C\B41C \B2E4\C774\C5B4\ADF8\B7A8 \BC84\C804')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14463413861417131)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14463680980417132)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\C885 \C644\B8CC')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14463802699417132)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14464061635417132)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100007)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4 \D0A4')
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14464234608417132)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14464492292417132)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14464671218417132)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \B808\BCA8')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14464841881417132)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958 \C2A4\D0DD')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14465051819417132)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14465208853417132)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14465414910417132)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \C2DC\C791\B428')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14465681387417132)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14465827100417132)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100007)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14466058524417132)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC \D074\B798\C2A4')
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14466212963417132)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14466444631417132)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C791\C5C5 \C2DC\C791\B428')
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14466645759417132)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B370\C774\D130 \C720\D615')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14466881820417132)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \AC1D\CCB4')
,p_translate_from_text=>'Calling Object'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14467096309417132)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100007)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958 \C2A4\D0DD')
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14467237614417132)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14467404527417132)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D504\B85C\C138\C2A4 \B808\BCA8')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14467688012417133)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100007)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub ID'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14467859456417133)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100007)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14468057822417133)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100007)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14468287473417133)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100007)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C124\BA85')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14468418435417133)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14468651286417133)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B808\BCA8')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14468810670417133)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \C0C1\D0DC')
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14469022244417133)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \BC94\C8FC')
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14469244092417133)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100007)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14469483053417133)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14469623820417133)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100007)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC18\BCF5 \ACBD\B85C')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14469891924417133)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14470098122417133)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B370\C774\D130 \C720\D615')
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14470261852417133)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC')
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14470475970417133)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\AE30\B85D')
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14470603779417133)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14470833340417133)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D638\CD9C \B2E4\C774\C5B4\ADF8\B7A8 ID')
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14471063814417133)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100007)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C9C0\C6D0 URI')
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14471217790417133)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14471485061417133)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AC12')
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14471647608417133)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100007)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14471834282417134)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100007)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14472028824417134)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14472297552417134)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC18\BCF5 \C788\C74C')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14472415319417134)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100007)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0 ID')
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14472681824417134)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7A0\C7AC \C0AC\C6A9\C790')
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14472849583417134)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100007)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14473031639417134)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100007)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14473208950417134)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100007)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14473403079417134)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BAA8\B378 \C774\B984')
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14473667279417134)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14473829739417134)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D45C\D604\C2DD \C720\D615')
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14474082788417134)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100007)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14474228133417134)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D558\C704 \D50C\B85C\C6B0')
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14474455135417134)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14474662564417134)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14474810603417134)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7A0\C7AC\C801 \ADF8\B8F9')
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14475026094417134)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\C774\C5B4\ADF8\B7A8')
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14475212314417134)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100007)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D074\B77C\C774\C5B8\D2B8 ID')
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14475480010417134)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14475696677417135)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14475849903417135)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm ID'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14476067327417135)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\ACC4')
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14476233833417135)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100007)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC\B85C \C124\C815')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14476420986417135)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14476697987417135)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100007)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14476868001417135)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100007)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D604\C7AC\B85C \C124\C815')
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14477090693417135)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100007)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14477242747417135)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100007)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14477440589417135)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100007)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14477675868417135)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100007)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC \C2DC \C0C1\D0DC')
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14477802536417135)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE60\B978 \C791\C5C5')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14478063708417135)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100007)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14478293155417135)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14478421596417148)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14478691562417148)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14478859154417149)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14479040535417149)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100007)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14479294652417149)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100007)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14479434335417149)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14479616132417149)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100007)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14479889021417149)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14480035694417149)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100007)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14480277066417149)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14480462775417149)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100007)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14480651236417149)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14480874125417149)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14481032617417149)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100007)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14481204675417149)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14481462135417149)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100007)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14481613683417149)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100007)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14481894564417149)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100007)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14482060408417150)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14482257059417150)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100007)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14482403095417150)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14482651078417150)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100007)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14482809707417150)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14483034894417150)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14483238684417150)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100007)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14483405844417150)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100007)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14483638182417152)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100007)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14483825948417152)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100007)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14484025874417154)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100007)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \BDF0\C5B4')
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14484245803417154)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100007)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \BAA8\B378\B7EC')
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14484492698417154)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100007)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14484608788417154)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100007)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14484807227417154)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100007)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14485040867417155)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100007)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14485269953417155)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100007)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14485461083417155)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100007)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14485669941417155)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AD8C\D55C\C774 \BD80\C871\D569\B2C8\B2E4. \C0AC\C6A9\C790\AC00 \AD00\B9AC\C790\AC00 \C544\B2D9\B2C8\B2E4.')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14485894423417156)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\C81C')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14486039476417156)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\AC04\C81C')
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14486205931417156)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\B144')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14486418046417156)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\B144')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14486667275417156)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\B144')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14486807679417156)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('I\B144')
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14487065443417156)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5\B144')
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14487230978417157)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\BD84')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14487434346417157)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\BD84')
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14487683286417157)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\AC1C\C6D4')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14487896870417157)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\AC1C\C6D4')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14488041300417157)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\AC1C\C6D4')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14488292770417157)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('9\AC1C\C6D4')
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14488488424417157)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('4\B144')
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14488636718417158)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5\BD84')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14488879599417158)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5\BD84')
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14489074832417158)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\AC1C\C6D4')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14489264086417158)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\AC1C\C6D4')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14489446539417158)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\AC1C\C6D4')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14489669083417158)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('6\AC1C\C6D4')
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14489830458417158)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\B144')
,p_translate_from_text=>'3 Years'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14490097782417159)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\BD84')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14490278305417159)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\BD84')
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14490456477417159)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\AC1C\C6D4')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14490649961417159)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\AC1C\C6D4')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14490814589417159)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\AC1C\C6D4')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14491078773417159)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3\AC1C\C6D4')
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14491290153417159)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('2\B144')
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14491411145417160)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\CD08(\C0DD\C0B0 \C0AC\C6A9 - apex.oracle.com\C6A9\C774 \C544\B2D8)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14491611643417160)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10\CD08(\C0DD\C0B0 \C0AC\C6A9 - apex.oracle.com\C6A9\C774 \C544\B2D8)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14491837362417160)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30\C77C')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14492040099417160)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30\C77C')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14492280666417160)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30\C77C')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14492428533417160)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1\B144')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14492669224417160)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14\C77C')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14492873282417160)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14\C77C')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14493094285417160)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14\C77C')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14493203346417161)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14493441415417161)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14493660354417161)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14493865902417161)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14494080792417161)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14494257617417161)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100007)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14494429379417161)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14494688207417161)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100007)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14494862365417161)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14495025290417162)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14495262659417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14495419431417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14495674263417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100007)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14495829116417162)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14496076946417162)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14496290191417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14496476508417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14496671739417162)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14496883858417162)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100007)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14497051168417162)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100007)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14497264153417162)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14497469446417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100007)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14497683675417162)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14497852116417162)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100007)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14498041164417162)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100007)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14498239500417162)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14498406518417162)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100007)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14498648581417163)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100007)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14498802372417163)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14499001824417163)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100007)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14499293082417163)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100007)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14499441350417163)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14499692405417163)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100007)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14499859483417163)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100007)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14500089145417163)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14500215188417163)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14500455503417163)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14500665305417163)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14500892582417163)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14501090940417163)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14501239433417163)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14501476555417163)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100007)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14501612013417163)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100007)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14501821044417163)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14502055650417163)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14502289714417163)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14502445441417163)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14502652692417163)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14502858360417164)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14503006566417164)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100007)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14503246992417164)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14503461994417164)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100007)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14503612214417164)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14503814207417164)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100007)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14504041013417164)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14504216968417164)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14504492034417164)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100007)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14504614936417164)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100007)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14504893002417164)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100007)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14505067105417164)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14505212862417164)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14505492096417164)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14505609743417164)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100007)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14505811251417164)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14506023269417164)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100007)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14506254751417165)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14506480977417165)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14506605288417165)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14506874939417165)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14507087511417165)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14507298422417165)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14507426665417165)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14507644251417165)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14507893443417165)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14508077268417165)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100007)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14508275476417165)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14508412205417165)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14508623705417165)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14508886253417165)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100007)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14509033729417165)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14509291819417165)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14509463340417165)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100007)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14509683788417165)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14509809297417166)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14510006421417166)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100007)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14510294146417166)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14510495265417166)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14510665993417166)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14510889743417166)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14511028125417166)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14511272032417166)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14511420326417166)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14511607374417166)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14511893877417166)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14512088199417166)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14512202921417166)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14512496206417166)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14512638644417166)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14512867764417166)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14513076892417166)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14513280831417166)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100007)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14513442953417166)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100007)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14513607255417166)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14513829275417166)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14514069880417167)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100007)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14514223536417167)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100007)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14514487157417167)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14514669137417167)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14514862498417167)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14515065771417167)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14515284912417167)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14515407351417167)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14515628069417167)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14515801625417167)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14516014795417167)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14516249320417167)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100007)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14516449990417167)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100007)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14516657172417167)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100007)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14516821586417167)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100007)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14517084850417167)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14517257710417167)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14517496827417167)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14517604027417167)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100007)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14517850541417167)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14518081055417168)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14518254010417168)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100007)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14518427353417168)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14518669366417168)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14518837467417168)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100007)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14519039122417168)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14519287028417168)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14519469733417168)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100007)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14519619012417168)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14519898570417168)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14520027762417168)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14520259983417168)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100007)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14520486138417168)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100007)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14520661036417168)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14520896039417168)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100007)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14521048792417168)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14521218134417168)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14521450405417168)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100007)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14521642762417169)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14521843110417169)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14522027665417169)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14522220380417169)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100007)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14522414160417169)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14522632213417169)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14522851862417169)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14523012695417169)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14523216833417169)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14523452498417169)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14523617507417169)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14523889274417169)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14524049563417169)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14524217412417169)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14524468949417169)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14524630729417169)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100007)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14524896602417169)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14525074314417169)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14525297070417169)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14525474524417169)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14525640587417169)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100007)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14525857604417170)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14526060939417170)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14526214969417170)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14526446977417170)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14526689218417170)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100007)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14526829590417170)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14527034529417170)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14527289662417170)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14527478097417170)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14527649088417170)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100007)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14527841699417170)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100007)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14528003589417170)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14528214406417170)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100007)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14528409594417170)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14528671639417170)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100007)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14528845727417170)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14529008041417170)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14529231176417170)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14529459037417192)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14529627956417193)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14529868247417193)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14530054871417193)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14530238814417193)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14530451963417193)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100007)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14530673218417193)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14530864850417193)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14531024078417193)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14531246760417193)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14531406996417193)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14531677378417193)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14531806927417193)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14532007925417193)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14532223814417193)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14532411461417193)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14532623648417193)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14532889720417193)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14533045742417193)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100007)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14533242782417193)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100007)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14533416630417193)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14533626480417194)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14533822272417194)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14534034965417194)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100007)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14534294012417194)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14534431692417194)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14534649693417194)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14534818881417194)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14535054371417194)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14535219839417194)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14535445164417194)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100007)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14535680005417194)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14535829953417194)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14536088817417194)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14536205130417194)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14536468399417194)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14536686196417194)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14536813704417195)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14537070034417195)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14537295241417195)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14537466312417195)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14537632448417195)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14537816054417195)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14538008676417195)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14538230448417195)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100007)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14538435518417195)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14538690693417195)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14538851901417195)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14539099223417195)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14539204872417195)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14539453154417195)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14539668758417195)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14539886781417195)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14540075939417195)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14540271891417195)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14540460750417195)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14540601177417195)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14540897130417196)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14541082620417196)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100007)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14541242113417196)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14541477324417196)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14541664200417196)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14541822008417196)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14542077189417196)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14542287791417196)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14542462158417196)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14542608395417196)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100007)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14542870186417196)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14543042361417196)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14543265589417196)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100007)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14543403848417196)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100007)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14543602636417196)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14543873041417196)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14544036181417196)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100007)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14544221672417196)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100007)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14544445388417196)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14544699428417196)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14544850945417196)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14545066239417197)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14545234874417197)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14545405711417197)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14545621995417197)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14545825284417197)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14546084146417197)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14546221069417197)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14546417329417197)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14546658143417197)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14546888184417197)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100007)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14547013768417197)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14547255957417197)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100007)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14547468788417197)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14547624099417197)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14547826857417197)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14548042820417197)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14548205040417197)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14548419048417197)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100007)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14548686464417197)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14548801803417197)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14549051268417198)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14549278476417204)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14549434226417204)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14549680589417204)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14549881008417204)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14550093737417204)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14550293941417204)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100007)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14550407910417204)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14550691254417204)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14550822048417204)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14551094733417204)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14551284802417204)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100007)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14551461848417204)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14551677316417204)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14551817786417204)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14552065962417204)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14552251961417205)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14552498391417205)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14552673105417205)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14552879309417205)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14553006822417205)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14553253076417205)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14553415389417205)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14553643103417205)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14553879069417205)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14554074199417205)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14554263613417205)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14554426570417207)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14554652704417207)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14554879789417207)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14555091328417207)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100007)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14555223056417207)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14555481823417207)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14555613435417207)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14555840593417207)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14556073858417207)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14556202237417207)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14556472181417207)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14556607205417207)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14556820185417207)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14557087571417207)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14557234252417207)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14557401257417207)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100007)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14557692378417207)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14557804476417208)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14558003115417208)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14558289556417208)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14558412357417208)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14558692882417208)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14558898449417208)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14559027168417208)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100007)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14559205118417208)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14559441517417208)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14559662330417208)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14559872761417208)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14560009138417208)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14560208697417208)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14560435653417208)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14560622219417208)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14560835361417208)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14561018322417208)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14561253429417208)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100007)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14561486661417208)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14561606489417208)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14561831565417208)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14562003896417209)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14562244887417209)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14562441781417209)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14562665489417209)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14562833613417209)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14563058287417209)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14563232704417209)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14563414716417209)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14563692863417209)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14563836854417209)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14564070283417209)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14564273382417209)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14564497388417209)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14564616145417209)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14564820406417209)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100007)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14565070755417209)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14565243370417209)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14565447374417209)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14565641603417209)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14565835923417210)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14566000514417210)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14566203869417210)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14566442807417210)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14566607618417210)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14566890974417210)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14567042106417210)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14567222667417210)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14567448836417210)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14567695589417210)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100007)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14567886193417210)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14568040925417210)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100007)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14568219214417210)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14568462200417210)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14568626896417210)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14568888807417210)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14569072015417210)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100007)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14569258179417210)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14569421435417210)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14569677138417210)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14569871640417215)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100007)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14570086134417215)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14570284145417215)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14570423487417215)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14570698868417215)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14570818088417215)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14571062820417215)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14571250515417215)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14571470991417215)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100007)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14571632992417215)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100007)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14571831303417216)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14572067750417216)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14572281474417216)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100007)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14572439741417216)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100007)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14572671231417216)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14572850742417216)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14573062784417216)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14573257000417216)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14573483119417216)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14573643538417216)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14573835758417216)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14574092084417216)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14574226148417216)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14574492202417216)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14574641940417216)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14574871248417216)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14575091854417216)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14575219018417216)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14575419084417217)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14575660482417217)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100007)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14575846942417217)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100007)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14576034557417217)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100007)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14576267349417217)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14576432671417217)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14576625267417217)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14576868866417217)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14577000620417217)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14577234194417217)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14577462096417217)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100007)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14577662689417217)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100007)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14577892348417217)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14578083432417217)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14578274092417217)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14578461805417217)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100007)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14578683253417217)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100007)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14578877845417217)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100007)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14579072121417217)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14579220035417217)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100007)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14579444302417217)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14579657899417217)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14579811722417218)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100007)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14580063031417218)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100007)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14580270323417218)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14580461900417218)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100007)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14580624461417218)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14580811674417218)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100007)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14581003151417218)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100007)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14581232509417218)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14581424287417218)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100007)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14581609801417218)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14581820822417218)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100007)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14582096987417218)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100007)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14582257697417218)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100007)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14582447832417218)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100007)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14582666357417218)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100007)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14582880798417218)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100007)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14583056463417218)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100007)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14583244533417218)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14583418267417222)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14583613911417222)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100007)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14583887715417223)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14584062670417223)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14584228272417223)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100007)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14584414889417223)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14584643260417223)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100007)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14584897937417223)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14585067965417223)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100007)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14585277371417223)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100007)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14585499491417224)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14585640774417224)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14585896248417225)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100007)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14586055369417225)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100007)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14586281117417225)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100007)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14586437801417225)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14586688230417225)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100007)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14586887913417225)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100007)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14587054996417225)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100007)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14587230846417225)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100007)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14587455947417225)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14587679320417225)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100007)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14587828762417226)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14588017056417226)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14588203902417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100007)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14588428754417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14588619964417226)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14588893316417226)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14589061631417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100007)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14589283088417226)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100007)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14589472940417226)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100007)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14589548445417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14589733216417226)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14589984600417226)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100007)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14590156405417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14590361996417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100007)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14590528672417226)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14590709472417226)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14590947697417226)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14591177668417227)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100007)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14591398692417227)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14591563795417227)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14591711213417227)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14591926647417227)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100007)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14592146593417227)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100007)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14592320670417227)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14592582900417227)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14592713249417227)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100007)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14592952404417227)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100007)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14593144637417227)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100007)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14593300221417227)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100007)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14593562451417227)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100007)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14593747632417227)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100007)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14593927415417227)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14594120532417227)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100007)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14594337189417227)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100007)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14594566902417227)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14594788224417228)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100007)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14594906053417228)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100007)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14595114745417228)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14595387162417228)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100007)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14595551492417228)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100007)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14595737510417228)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14595974390417228)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100007)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14596186296417228)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100007)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14596363093417228)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100007)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14596524546417228)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14596716722417228)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100007)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14596985782417228)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14597131830417228)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14597385620417228)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14597591693417228)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100007)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14597763271417228)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100007)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14597950794417228)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14598148688417228)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14598355953417229)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100007)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14598558466417229)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100007)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14598711584417229)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14598923841417229)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100007)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14599148818417229)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14599382733417229)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14599557982417229)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100007)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14599705201417229)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14599998894417229)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100007)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14600128276417229)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14600312097417229)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100007)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14600548801417229)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100007)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14600707652417229)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14600957124417229)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100007)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14601130513417229)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100007)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14601303076417229)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100007)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14601564724417234)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14601760244417234)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14601965092417234)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14602105342417234)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14602338389417234)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100007)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14602574696417234)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100007)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14602779596417234)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100007)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14602926209417234)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14603142946417234)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100007)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14603381065417235)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14603564701417235)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14603731071417235)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14603918566417235)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100007)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14604101206417235)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100007)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14604367589417235)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100007)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14604560326417236)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100007)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14604788644417236)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100007)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14604942952417236)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14605158517417236)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14605399362417236)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14605572166417236)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100007)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14605771604417236)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14605917768417236)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14606191286417236)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100007)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14606375305417236)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14606539074417236)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100007)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14606766804417236)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14606995678417237)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14607183317417237)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100007)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14607381735417238)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14607503105417238)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14607726998417238)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14607991021417238)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100007)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14608181588417238)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14608381020417238)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100007)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14608533968417238)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100007)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14608747775417238)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100007)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14608987737417238)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14609183180417239)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14609315077417239)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14609587047417239)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14609761827417239)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100007)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14609932033417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14610120736417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14610387256417239)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100007)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14610513717417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14610774584417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100007)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14610906068417239)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100007)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14611139234417239)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100007)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14611398157417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14611561030417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14611718931417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100007)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14611929956417239)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100007)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14612137737417240)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14612303209417240)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14612535642417240)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14612787265417241)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100007)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14612994592417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14613125140417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14613350909417241)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100007)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14613595549417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14613748864417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100007)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14613909243417241)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100007)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14614134488417241)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100007)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14614301058417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14614534771417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14614748432417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100007)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14614988124417241)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100007)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14615154211417242)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100007)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14615305628417242)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100007)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14615593928417242)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100007)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14615734927417242)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14615987280417243)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14616125147417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14616365682417243)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14616524642417243)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100007)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14616702240417243)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100007)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14616924479417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14617135643417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100007)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14617389920417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100007)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14617595688417243)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100007)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14617709057417243)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14617956226417243)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100007)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14618196847417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14618350385417243)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100007)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14618524778417243)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100007)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14618760261417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100007)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14618942015417243)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100007)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14619125986417243)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100007)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14619314284417243)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100007)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14619504016417243)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14619724565417244)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100007)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14619976415417244)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14620197939417244)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100007)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14620302960417244)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100007)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14620541412417244)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100007)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14620702255417244)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100007)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14620944707417244)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100007)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14621166345417246)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14621334602417246)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14621584886417246)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100007)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14621710243417246)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14621947103417246)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14622194374417246)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14622399644417246)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14622500996417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14622734190417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14622991730417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14623112230417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100007)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14623346075417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14623517714417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14623745252417247)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14623932029417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14624171922417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100007)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14624329537417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14624558310417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14624772259417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14624958607417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14625110633417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14625362267417248)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14625581816417249)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14625738286417249)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100007)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14625976223417249)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14626177298417249)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100007)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14626325906417249)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100007)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14626551089417249)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100007)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14626716400417249)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100007)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14626940356417249)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14627184517417250)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100007)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14627334206417250)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14627588072417250)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14627730620417250)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100007)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14627922755417250)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100007)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14628126225417250)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100007)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14628397608417250)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100007)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14628596707417250)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14628730420417250)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14628943685417250)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100007)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14629148078417250)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100007)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14629359381417250)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100007)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14629582081417250)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100007)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14629729703417250)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14629914502417250)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100007)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14630113173417250)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100007)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14630348637417250)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100007)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14630544153417250)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14630711232417250)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14630914577417250)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14631138247417251)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100007)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14631369831417251)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100007)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14631566872417251)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14631777202417251)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100007)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14631962759417251)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100007)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14632114048417251)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14632389768417251)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14632502768417251)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14632729246417251)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14632938707417251)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14633131061417251)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14633304196417251)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100007)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14633558593417251)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100007)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14633731621417251)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14633987646417251)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100007)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14634153370417251)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14634336518417251)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100007)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14634559816417251)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100007)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14634748345417251)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14634945686417252)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100007)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14635152656417252)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100007)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14635361203417252)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100007)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14635579047417252)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14635712740417252)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14635976140417252)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14636166434417252)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100007)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14636307175417252)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100007)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14636516490417252)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14636766847417252)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14636968840417252)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14637118481417252)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14637390423417252)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14637564721417252)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14637741276417252)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14637930859417252)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14638139808417252)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14638312442417252)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100007)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14638536450417252)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100007)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14638775915417256)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100007)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14638943321417256)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100007)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14639151601417256)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100007)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14639347813417256)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100007)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14639529272417256)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100007)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14639713333417256)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14639973287417256)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100007)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14640154505417257)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100007)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14640387044417257)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100007)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14640551844417257)
,p_page_id=>5
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100007)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14640703853417257)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100007)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14640982062417257)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100007)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14641168403417257)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14641345179417257)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14641530036417257)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100007)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14641740671417257)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100007)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14641986139417257)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100007)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14642196878417257)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100007)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14642398171417257)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14642572637417257)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100007)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14642751092417257)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100007)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14642906910417257)
,p_page_id=>37
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100007)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14643117210417257)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14643382197417257)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14643571283417257)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14643735426417257)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100007)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14643935364417257)
,p_page_id=>33
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100007)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14644122848417258)
,p_page_id=>11
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14644326709417258)
,p_page_id=>39
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100007)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14644537003417258)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100007)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14644757737417258)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100007)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14644923451417258)
,p_page_id=>50
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100007)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14645140523417258)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100007)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14645378209417258)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100007)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14645584309417258)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100007)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14645760361417258)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14645987462417258)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100007)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14646100160417258)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100007)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14646384044417258)
,p_page_id=>4
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100007)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14646506599417258)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100007)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14646789203417258)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14646976541417258)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100007)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14647142872417258)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100007)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14647328478417258)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14647547703417258)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100007)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14647721290417258)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100007)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14647943111417259)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100007)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14648159908417259)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100007)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14648331245417259)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100007)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14648570167417259)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14648749160417259)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100007)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14648929507417259)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100007)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14649177235417259)
,p_page_id=>13
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100007)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14649396513417259)
,p_page_id=>38
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14649512500417259)
,p_page_id=>1
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100007)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14649713000417259)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100007)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14649901576417259)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14650187431417259)
,p_page_id=>14
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100007)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14650375342417259)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100007)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14650507765417259)
,p_page_id=>30
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100007)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14650747155417259)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100007)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14650986728417259)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100007)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14651159139417263)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14651382432417263)
,p_page_id=>51
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100007)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14651566075417263)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14651760665417263)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14651918755417263)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14652110307417263)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14652342633417263)
,p_page_id=>31
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100007)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14652573429417264)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14652744344417264)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14652996325417264)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14653194238417264)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14653312295417264)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14653529922417264)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14653790632417265)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14653990459417265)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14654182025417265)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14654362062417265)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14654577297417265)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14654788510417265)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14654963154417266)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14655174622417266)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14655336618417266)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14655545829417266)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14655747838417266)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14655949802417266)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14656179883417266)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14656354630417267)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14656510461417267)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14656732046417267)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14656982908417267)
,p_page_id=>6
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100007)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14657145525417268)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14657322101417268)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14657568949417268)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14657723808417269)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14657986106417269)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14658100577417269)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14658367559417269)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14658540803417269)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14658772446417270)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14658938396417270)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14659153180417270)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14659343763417270)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14659502181417270)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14659779818417270)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14659960663417270)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14660140425417270)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14660330848417271)
,p_page_id=>20
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100007)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14660598754417271)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14660723982417271)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14660933011417271)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14661191465417271)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14661397364417272)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14661519148417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100007)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14661705141417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100007)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14661915247417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100007)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14662191171417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100007)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14662324405417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100007)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14662511111417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100007)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14662799433417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100007)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14662958976417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100007)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14663146413417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100007)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14663365657417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100007)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5D0\B514\C158, \B77C\C774\C13C\C2A4 \C815\BCF4')
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14663589859417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100007)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14663706420417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100007)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14663999314417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100007)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14664175863417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100007)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14664359288417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14664525053417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100007)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14664764769417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100007)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14664909662417273)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100007)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14665125300417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100007)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14665387156417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100007)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14665530883417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100007)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14665775332417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100007)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14665936181417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100007)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14666174478417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100007)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14666349714417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100007)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14666571143417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100007)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14666719559417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100007)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14666961808417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100007)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14667196656417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100007)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14667379275417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100007)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14667524859417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100007)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14667722150417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100007)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14667929773417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100007)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14668149631417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100007)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14668351941417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14668542607417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100007)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14668753756417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100007)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14668976645417274)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14669139853417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100007)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14669354207417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14669512246417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100007)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14669771658417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100007)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14669983281417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100007)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14670192456417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100007)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14670328400417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100007)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14670506055417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100007)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14670723908417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100007)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14670961211417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100007)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14671180799417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100007)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14671348418417275)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100007)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14671599740417278)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14671745895417279)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0AC\C6A9\C790 \C774\B984')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14671913032417279)
,p_page_id=>9999
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100007)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE44\BC00\BC88\D638')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14672100706417279)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14672323163417279)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14672581891417279)
,p_page_id=>12
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100007)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14672741760417279)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100007)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14672987543417281)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \B2E8\ACC4\C5D0 \B300\D55C \C0AC\C6A9\C790 \C815\BCF4\B97C \CEA1\CC98\D558\C9C0 \C54A\C2B5\B2C8\B2E4.	</li>'),
unistr('    <li><strong>disabled</strong>(\AE30\BCF8\AC12) - \D50C\B85C\C6B0 \C5D4\C9C4\C5D0 \C54C\B824\C9C4 \D504\B85C\C138\C2A4 \B2E8\ACC4\C758 userid\B97C \CEA1\CC98\D569\B2C8\B2E4.	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14673181709417281)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\C6C3\BC14\C6B4\B4DC \BA54\C77C serviceTasks\C5D0 \C815\C758\B41C \BC1C\C2E0\C790\AC00 \C5C6\B294 \ACBD\C6B0 \AE30\BCF8 \C804\C790\BA54\C77C \BC1C\C2E0\C790\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14673394600417281)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\B978 \C0AC\C6A9\C790 \C774\B984\C774 \C81C\ACF5\B418\C9C0 \C54A\C740 \ACBD\C6B0 \C138\C158\C744 \C0DD\C131\D558\AE30 \C704\D574 APEX \C138\C158\C5D0\C11C \C0AC\C6A9\C790\AC00 \B420 \C0AC\C6A9\C790 \C774\B984\C785\B2C8\B2E4.')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14673558891417281)
,p_page_id=>7
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100007)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C5F0\AD00\B41C \D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4 \C0AD\C81C')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14673778403417281)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100007)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BE44\C6CC \B458 \ACBD\C6B0 \D604\C7AC \C0AC\C6A9\C790(app_user)\C5D0 \B300\D574 \D0DC\C2A4\D06C\AC00 \C608\C57D\B429\B2C8\B2E4.')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14673995809417281)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C8FC\AE30 \D0C0\C774\BA38\C5D0 \B300\D574 \CD5C\B300 \C2E4\D589 \C218\B97C \C815\C758\D569\B2C8\B2E4.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14674150682417281)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100007)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\D544\C218 \D615\C2DD: YYYY-MM-DD HH24:MI:SS TZR')
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14674390594417281)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - \CD94\AC00 \AC1C\BC1C \C5C6\C774 Flows for APEX 21.1 \C774\D558\B85C \D45C\C2DC\B41C \C751\C6A9 \D504\B85C\ADF8\B7A8\C744 \C9C0\C6D0\D558\B294 \ACBD\C6B0\C5D0\B9CC \C774 \C635\C158\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C5D4\C9C4\C740 \B2E8\ACC4 \D0A4\B97C \C0AC\C6A9\D558\C5EC \B2E8\C77C \B2E8\ACC4\C5D0\C11C \C911\BCF5 \C791\C5C5\C744 \BC29\C9C0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('    <li><strong>strict</strong>(\AD8C\C7A5) - \C0C8 \AC1C\BC1C \BC0F/\B610\B294 \C644\C804\D788 \B9C8\C774\ADF8\B808\C774\C158\B41C \C751\C6A9 \D504\B85C\ADF8\B7A8\C5D0 \C774 \C635\C158\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C5D4\C9C4\C740 \B2E8\ACC4 \D0A4\B97C \C0AC\C6A9\D558\C5EC \B2E8\C77C \B2E8\ACC4\C5D0\C11C \C911\BCF5 \C791\C5C5\C744 \BC29\C9C0\D569\B2C8\B2E4.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14674501934417281)
,p_page_id=>2
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100007)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E8\C77C \BAA8\B378 \BCF5\C0AC\BCF8\C758 \ACBD\C6B0 \C0C8 \BAA8\B378\C5D0 \C785\B825\B41C \C774\B984\C774 \C788\C9C0\B9CC \B458 \C774\C0C1\C758 \D589\C744 \C120\D0DD\D55C \ACBD\C6B0 \C785\B825\D55C \AC12\C774 \C811\BBF8\C5B4\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14674718009417281)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958 \BA54\C2DC\C9C0 \BC0F \B85C\ADF8 \C774\BCA4\D2B8\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\C785\B2C8\B2E4.')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14674923092417281)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - \CD94\AC00 \AC1C\BC1C \C5C6\C774 Flows for APEX 21.1 \C774\D558\B85C \D45C\C2DC\B41C \C751\C6A9 \D504\B85C\ADF8\B7A8\C744 \C9C0\C6D0\D558\B294 \ACBD\C6B0\C5D0\B9CC \C774 \C635\C158\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C5D4\C9C4\C740 \B2E8\ACC4 \D0A4\B97C \C0AC\C6A9\D558\C5EC \B2E8\C77C \B2E8\ACC4\C5D0\C11C \C911\BCF5 \C791\C5C5\C744 \BC29\C9C0\D558\C9C0 \C54A\C2B5\B2C8\B2E4.</li>'),
unistr('    <li><strong>strict</strong>(\AD8C\C7A5) - \C0C8 \AC1C\BC1C \BC0F/\B610\B294 \C644\C804\D788 \B9C8\C774\ADF8\B808\C774\C158\B41C \C751\C6A9 \D504\B85C\ADF8\B7A8\C5D0 \C774 \C635\C158\C744 \C0AC\C6A9\D569\B2C8\B2E4. \C5D4\C9C4\C740 \B2E8\ACC4 \D0A4\B97C \C0AC\C6A9\D558\C5EC \B2E8\C77C \B2E8\ACC4\C5D0\C11C \C911\BCF5 \C791\C5C5\C744 \BC29\C9C0\D569\B2C8\B2E4.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14675178330417281)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100007)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \B85C\AE45\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428	</li>'),
unistr('    <li><strong>standard</strong>(\AE30\BCF8\AC12) - \C778\C2A4\D134\C2A4 \C774\BCA4\D2B8 \AE30\B85D</li>'),
unistr('    <li><strong>secure</strong> - \BAA8\B378 \C774\BCA4\D2B8 \BC0F \C778\C2A4\D134\C2A4 \C774\BCA4\D2B8 \AE30\B85D	</li>'),
unistr('    <li><strong>full</strong> - \BAA8\B378, \C778\C2A4\D134\C2A4 \BC0F \D504\B85C\C138\C2A4 \BCC0\C218 \C774\BCA4\D2B8\B97C \AE30\B85D\D569\B2C8\B2E4.		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14675326787417282)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C138\C158 \C0DD\C131\C744 \C704\D574 \C81C\ACF5\B420 APEX \C571 \C911 \D558\B098\C758 \C560\D50C\B9AC\CF00\C774\C158 ID\C785\B2C8\B2E4.')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14675504749417282)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C138\C158 \C0DD\C131\C744 \C704\D574 \C81C\ACF5\B420 \C571 \C911 \D558\B098\C758 \D398\C774\C9C0 ID')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14675775247417282)
,p_page_id=>36
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100007)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C8FC\AE30 \D0C0\C774\BA38\C5D0 \B300\D574 \CD5C\B300 \C2E4\D589 \C218\B97C \C815\C758\D569\B2C8\B2E4.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14675938422417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEXFlows for APEX\C6A9 Flows\C5D0 \C0AC\C6A9\B418\B294 \AE30\BCF8 APEX \C791\C5C5\C601\C5ED\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4. APEX \C138\C158\C744 \C0DD\C131\D558\AC70\B098 \BA54\C77C \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \B54C scriptTasks \BC0F serviceTasks\C5D0 \B300\D55C \B9C8\C9C0\B9C9 \C815\B82C\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14676180983417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - \B2E8\ACC4\C5D0 \B300\D55C \C0AC\C6A9\C790 \C815\BCF4\B97C \CEA1\CC98\D558\C9C0 \C54A\C2B5\B2C8\B2E4.	</li>'),
unistr('    <li><strong>disabled</strong>(\AE30\BCF8\AC12) - \D50C\B85C\C6B0 \C5D4\C9C4\C5D0 \C54C\B824\C9C4 \D504\B85C\C138\C2A4 \B2E8\ACC4\C758 userid\B97C \CEA1\CC98\D569\B2C8\B2E4.	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14676384725417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B2E4\B978 \C0AC\C6A9\C790 \C774\B984\C774 \C81C\ACF5\B418\C9C0 \C54A\C740 \ACBD\C6B0 \C138\C158\C744 \C0DD\C131\D558\AE30 \C704\D574 APEX \C138\C158\C5D0\C11C \C0AC\C6A9\C790\AC00 \B420 \C0AC\C6A9\C790 \C774\B984\C785\B2C8\B2E4.')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14676500041417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100007)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong>(\AE30\BCF8\AC12) - \B9B4\B9AC\C2A4\B41C \BAA8\B378\C5D0 \B300\D55C \B2E4\C774\C5B4\ADF8\B7A8 \D3B8\C9D1\C744 \BC29\C9C0\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>development</strong> - \B9B4\B9AC\C2A4\B41C \BAA8\B378\C5D0 \B300\D55C \B2E4\C774\C5B4\ADF8\B7A8 \D3B8\C9D1 \D5C8\C6A9</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14676727499417282)
,p_page_id=>32
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100007)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958 \BA54\C2DC\C9C0 \BC0F \B85C\ADF8 \C774\BCA4\D2B8\B97C \D45C\C2DC\D558\B294 \B370 \C0AC\C6A9\B418\B294 \C5B8\C5B4\C785\B2C8\B2E4.')
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14676907197417282)
,p_page_id=>34
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100007)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong>(\AE30\BCF8\AC12) - \B9B4\B9AC\C2A4\B41C \BAA8\B378\C5D0 \B300\D55C \B2E4\C774\C5B4\ADF8\B7A8 \D3B8\C9D1\C744 \BC29\C9C0\D569\B2C8\B2E4.</li>'),
unistr('    <li><strong>development</strong> - \B9B4\B9AC\C2A4\B41C \BAA8\B378\C5D0 \B300\D55C \B2E4\C774\C5B4\ADF8\B7A8 \D3B8\C9D1 \D5C8\C6A9</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14677130456417282)
,p_page_id=>35
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100007)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('APEXFlows for APEX\C6A9 Flows\C5D0 \C0AC\C6A9\B418\B294 \AE30\BCF8 APEX \C791\C5C5\C601\C5ED\C73C\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4. APEX \C138\C158\C744 \C0DD\C131\D558\AC70\B098 \BA54\C77C \D15C\D50C\B9AC\D2B8\B97C \CC3E\C744 \B54C scriptTasks \BC0F serviceTasks\C5D0 \B300\D55C \B9C8\C9C0\B9C9 \C815\B82C\B85C \C0AC\C6A9\B429\B2C8\B2E4.')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14677379761417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C138\C158\C744 \C0DD\C131\D558\AE30 \C704\D574 \C81C\ACF5\B418\B294 APEX \C571 \C911 \D558\B098\C758 \C560\D50C\B9AC\CF00\C774\C158 ID\C785\B2C8\B2E4.')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14677500071417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100007)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - \B85C\AE45\C774 \C0AC\C6A9 \C548\D568\C73C\B85C \C124\C815\B428	</li>'),
unistr('    <li><strong>standard</strong>(\AE30\BCF8\AC12) - \C778\C2A4\D134\C2A4 \C774\BCA4\D2B8 \AE30\B85D</li>'),
unistr('    <li><strong>secure</strong> - \BAA8\B378 \C774\BCA4\D2B8 \BC0F \C778\C2A4\D134\C2A4 \C774\BCA4\D2B8 \AE30\B85D	</li>'),
unistr('    <li><strong>full</strong> - \BAA8\B378, \C778\C2A4\D134\C2A4 \BC0F \D504\B85C\C138\C2A4 \BCC0\C218 \C774\BCA4\D2B8\B97C \AE30\B85D\D569\B2C8\B2E4.		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14677755381417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100007)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C138\C158 \C0DD\C131\C744 \C704\D574 \C81C\ACF5\B420 \C571 \C911 \D558\B098\C758 \D398\C774\C9C0 ID')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14677983764417282)
,p_page_id=>100
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100007)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C544\C6C3\BC14\C6B4\B4DC \BA54\C77C serviceTasks\C5D0 \C815\C758\B41C \BC1C\C2E0\C790\AC00 \C5C6\B294 \ACBD\C6B0 \AE30\BCF8 \C804\C790\BA54\C77C \BC1C\C2E0\C790\B85C \C124\C815\D574\C57C \D569\B2C8\B2E4.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14678197292417284)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100007)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14678390574417284)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14678506006417284)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD08')
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14678772530417284)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100007)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14678932510417284)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C778\C2A4\D134\C2A4 \C624\B958')
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14679153207417284)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958')
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14679327144417284)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\CD5C\B300')
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14679540382417285)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100007)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\AE30-\CD5C\B300')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14679729659417285)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C624\B958')
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14679935393417285)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791\B41C \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14680124638417285)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-90pc'
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14680351644417285)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-10pc'
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14680520669417285)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100007)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14680706037417285)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C885\B8CC\B41C \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14680951332417285)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90pc \AE30\AC04')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14681103192417285)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100007)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 \BC31\BD84\C704\C218')
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14681388572417285)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('50 \BC31\BD84\C704\C218')
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14681539466417285)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100007)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14681742878417285)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100007)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\B9AC\C988 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14681915761417285)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100007)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0DD\C131\B428')
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14682143881417285)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100007)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14682341693417285)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14682574960417285)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100007)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\C791\B428')
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14682765495417285)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100007)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2DC\B9AC\C988 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14682967265417285)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('90 \BC31\BD84\C704\C218')
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14683117914417285)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-50pc'
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14683302884417286)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100007)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C2E4\D589 \C911')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14683524489417286)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100007)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14683785499417286)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC\B428')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14683938044417286)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C885\B8CC\B428')
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14684165901417286)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C644\B8CC\B41C \C778\C2A4\D134\C2A4')
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14684315229417286)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14684587227417286)
,p_page_id=>16
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100007)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C911\AC04 \AE30\AC04')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14684721536417286)
,p_page_id=>3
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100007)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14684930443417286)
,p_page_id=>15
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100007)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C7AC\C124\C815')
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14685153307417286)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100007)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14685355215417286)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14685550995417286)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100007)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\AE30\AC04-\CD5C\B300')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14685762283417286)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\B300\AE30-\CD5C\B300')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14685926177417286)
,p_page_id=>17
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100007)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14686141435417288)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100007)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14686345259417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100007)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14686589908417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100007)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14686711372417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100007)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14686939241417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100007)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C0C1\D0DC')
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14687106651417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100007)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C774\B984')
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14687353966417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100007)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC94\C8FC')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14687509133417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100007)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\BC84\C804')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14687780345417289)
,p_translated_flow_id=>100007
,p_translate_to_id=>100.100007
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14687936123417290)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100007)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\C77C\BCC4 \C778\C2A4\D134\C2A4 \C694\C57D \C544\CE74\C774\BE0C \D504\B85C\C138\C2A4 \C624\B958')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14688108104417290)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100007)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error purging Flows for APEX Statistics summaries'
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14688374999417291)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100007)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Flows for APEX - \B85C\ADF8 \D14C\C774\BE14\C744 \BE44\C6B0\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.')
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14688523569417291)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100007)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error gathering daily Flows for APEX Stats'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14688745731417291)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14688961683417291)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14689162799417291)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100007)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14689389726417293)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>6.100002
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14689575814417293)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>50.100002
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modelos de Formul\00E1rio Simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14689796263417293)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>14.100002
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registros'
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14689955081417293)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>51.100002
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Editar Modelo de Formul\00E1rio Simples')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14690106233417293)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>1.100002
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Come\00E7ando')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14690323015417293)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>7.100002
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fluxo'
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14690591694417293)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>15.100002
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas Di\00E1rias')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14690722135417293)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>31.100002
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - REST - Cliente')
,p_translate_from_text=>'Configuration - REST - Client'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14690994966417293)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>36.100002
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Timers')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14691135423417293)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>34.100002
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Aplicativo do Mecanismo')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14691366412417293)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>11.100002
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Criar Inst\00E2ncia de fluxo')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14691560249417293)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>30.100002
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14691712229417293)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>2.100002
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gerenciamento do Fluxo'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14691984276417293)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>8.100002
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Detalhes da Inst\00E2ncia de Fluxo')
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14692197022417294)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>12.100002
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visualizador'
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14692324544417294)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>17.100002
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas da Tarefa')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14692518777417294)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>37.100002
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Estat\00EDsticas')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14692761493417294)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>4.100002
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelador de Fluxo'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14692949281417294)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>5.100002
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14693134583417294)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>10.100002
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor de fluxo'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14693323487417294)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>35.100002
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Mecanismo')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14693566089417294)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>33.100002
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Arquivamento')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14693753475417294)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>3.100002
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Painel de controle'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14693962487417294)
,p_page_id=>9
,p_translated_flow_id=>100002
,p_translate_to_id=>9.100002
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14694143766417294)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>20.100002
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Linha do Tempo da Inst\00E2ncia - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14694349535417294)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>38.100002
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Local')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14694584296417294)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>13.100002
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Detalhes do objeto'
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14694739647417294)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>39.100002
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Licen\00E7a')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14694981549417294)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>16.100002
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas do Processo')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14695187561417294)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>32.100002
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Log')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14695391183417294)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>100.100002
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o [OLD,BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14695526437417294)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>9999.100002
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('P\00E1gina de Acesso')
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14695739813417297)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>6.100002
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Importa\00E7\00E3o - &APP_NAME_TITLE.')
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14695919575417297)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>50.100002
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modelos de Formul\00E1rio Simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14696102191417297)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>51.100002
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Editar Modelo de Formul\00E1rio Simples')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14696392661417297)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>1.100002
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Primeiros passos - &APP_NAME_TITLE.'
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14696550053417297)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>7.100002
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fluxo - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14696710677417297)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>15.100002
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas Di\00E1rias')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14696981506417297)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>31.100002
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - REST - Cliente')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14697188270417297)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>36.100002
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Timers')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14697306564417297)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>34.100002
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Aplicativo do Mecanismo')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14697557802417297)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>11.100002
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Criar Inst\00E2ncia de Fluxo - &APP_NAME_TITLE.')
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14697797790417297)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>30.100002
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14697946830417297)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>2.100002
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gerenciamento do fluxo - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14698117355417297)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>8.100002
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Detalhes da Inst\00E2ncia de Fluxo - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14698344095417297)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>12.100002
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor de Fluxo - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14698566811417297)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>17.100002
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas da Tarefa')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14698733673417297)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>37.100002
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Estat\00EDsticas')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14698963628417297)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>4.100002
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Modeler - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14699190014417297)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>5.100002
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Exporta\00E7\00E3o - &APP_NAME_TITLE.')
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14699356870417297)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>10.100002
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor de Fluxo - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14699599406417298)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>35.100002
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Mecanismo')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14699707297417298)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>33.100002
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Arquivamento')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14699971558417298)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>3.100002
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Painel de controle - &APP_NAME_TITLE.'
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14700187666417298)
,p_page_id=>9
,p_translated_flow_id=>100002
,p_translate_to_id=>9.100002
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14700358751417298)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>20.100002
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Linha do Tempo da Inst\00E2ncia - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14700549634417298)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>38.100002
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Local')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14700779405417298)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>39.100002
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Licen\00E7a')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14700974451417298)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>16.100002
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas do Processo')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14701192266417298)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>32.100002
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Log')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14701366694417298)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>100.100002
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o [OLD,BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14701549767417298)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>9999.100002
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14701790674417300)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100002)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Selecione todos'
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14701921553417300)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100002)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Definir Rota do Gateway'
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14702154668417300)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100002)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14702375400417300)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100002)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14702584908417300)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14702721846417300)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100002)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Desmarcar todos'
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14702946470417301)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Adicione'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14703119492417301)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100002)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Definir Vari\00E1vel do Processo')
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14703386363417301)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100002)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14703555455417301)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100002)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o REST')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14703768640417301)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14703920498417301)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100002)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar e editar'
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14704169791417301)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100002)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14704370579417301)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100002)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14704577830417301)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nova vers\00E3o')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14704780785417301)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100002)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancela'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14704974210417301)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancela'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14705180936417301)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Receber mensagem'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14705385880417301)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100002)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14705595998417301)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100002)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar mudan\00E7as')
,p_translate_from_text=>'Apply Changes'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14705799926417301)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14705968421417301)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100002)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14706176108417301)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100002)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14706322103417301)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100002)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar modelo'
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14706521737417301)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100002)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14706738618417301)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100002)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Salvar'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14706904632417301)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100002)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14707167418417302)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100002)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar e importar outro'
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14707304843417302)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100002)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14707526036417302)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copiar Modelo'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14707729508417302)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100002)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14707926840417302)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100002)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14708145706417302)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Entrar'
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14708358212417302)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100002)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14708511103417302)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100002)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o REST')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14708736120417302)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lan\00E7amento')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14708908836417302)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar Modelo'
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14709188713417302)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100002)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modificar o Diagrama'
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14709329224417302)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100002)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14709508094417302)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100002)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Adicionar Vers\00E3o')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14709706260417302)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14709903383417302)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14710163095417302)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100002)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14710372280417302)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arquivar'
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14710542732417302)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14710783157417302)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100002)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar mudan\00E7as')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14710924449417303)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100002)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancela'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14711169543417303)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100002)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14711390119417303)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14711581774417303)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100002)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mostrar Hist\00F3rico')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14711730934417303)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100002)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14711968504417303)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Criar inst\00E2ncia')
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14712131406417303)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100002)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14712342664417303)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100002)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14712524086417303)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100002)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14712798030417303)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100002)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14712954458417303)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100002)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar mudan\00E7as')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14713110139417303)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descontinuar'
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14713337954417303)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14713566555417303)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100002)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Adicionar Vers\00E3o')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14713757418417303)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100002)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14713943063417303)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Editar Configura\00E7\00E3o')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14714107108417303)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100002)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar Altera\00E7\00F5es')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14714339501417303)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicar mudan\00E7as')
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14714578512417303)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Redefini\00E7\00E3o do Timer')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14714746433417304)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14714948072417304)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100002)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14715165803417304)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100002)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Confirma'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14715390791417304)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100002)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Editar Configura\00E7\00E3o')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14715596592417304)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100002)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Adicione'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14715725022417304)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100002)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criar'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14715991171417304)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100002)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14716167878417304)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Confirma'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14716329165417304)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100002)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14716533516417304)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100002)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14716732537417304)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100002)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Salvar'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14716938075417309)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100002)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14717189427417309)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ocultar ID do Usu\00E1rio')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14717367889417309)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Coluna de ID'
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14717585638417309)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Chave de Licen\00E7a')
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14717763309417309)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Coluna de Timestamp'
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14717923869417309)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL Base'
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14718164811417309)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100002)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nova vers\00E3o')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14718365549417309)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Carga \00DAtil')
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14718520345417309)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100002)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conex\00E3o')
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14718789164417310)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Remetente de e-mail padr\00E3o')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14718950956417310)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14719129473417310)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama de Chamada'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14719315130417310)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14719591767417310)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome de Usu\00E1rio Padr\00E3o')
,p_translate_from_text=>'Default Username'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14719764166417310)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14719944537417310)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14720183656417310)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Intervalo de Repeti\00E7\00E3o do Timer')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14720374804417310)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome do arquivo'
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14720562374417310)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Etapa'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14720764831417310)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome do Per\00EDodo')
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14720996411417310)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100002)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Edi\00E7\00E3o de Licen\00E7a')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14721185860417310)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100002)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar de'
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14721344129417310)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Opera\00E7\00E3o')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14721540540417310)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14721704721417310)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14721949163417310)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prefixo do Documento'
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14722179566417310)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14722355891417310)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Novo'
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14722560693417310)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100002)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Sobrescrever For\00E7ado')
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14722780897417310)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservas'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14722977180417311)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1ximo de Ciclos do Timer')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14723151763417311)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14723389890417311)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14723533150417311)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Executado por'
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14723775797417311)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome da Tabela'
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14723927562417311)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Incluir a data da \00FAltima mudan\00E7a')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14724110729417311)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14724307140417311)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100002)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Porta de entrada'
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14724567413417311)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reter Resumos Mensais (Meses)'
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14724715994417311)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reten\00E7\00E3o de Log do Fluxo de Mensagens (Dias) (ainda n\00E3o implementado)')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14724990044417311)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100002)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Em Cascata'
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14725178677417311)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100002)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14725353717417311)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel do Processo')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14725593566417311)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14725776469417311)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Senha'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14725949609417311)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reter Logs (Dias)'
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14726190006417311)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14726369825417311)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama XML'
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14726583912417311)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Incluir Vers\00E3o')
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14726745928417311)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arquivo'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14726917650417311)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reprogramar o cron\00F4metro em')
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14727106484417312)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Localiza\00E7\00E3o do Arquivo Compactado da Inst\00E2ncia')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14727375032417312)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14727582579417312)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Baixar como'
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14727713034417312)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14727938910417312)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vari\00E1vel do Processo')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14728191878417312)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Segredo do Cliente'
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14728338793417312)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Preven\00E7\00E3o de Etapa Duplicada')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14728586684417312)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Novo Nome/Tratamento'
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14728715903417312)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID Est\00E1tico da Credencial do APEX')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14728965615417312)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14729122671417312)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID Est\00E1tico')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14729374351417312)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100002)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Propriet\00E1rio')
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14729548379417312)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Licenciado para'
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14729784808417312)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Preven\00E7\00E3o de Etapa Duplicada')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14729933829417312)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14730138751417312)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID do Aplicativo Padr\00E3o')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14730347618417312)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Id da P\00E1gina Padr\00E3o')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14730598615417312)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome de usu\00E1rio')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14730782310417312)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Escopo'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14730917274417312)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Refer\00EAncia de Neg\00F3cio (Vari\00E1vel de Processo)')
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14731117636417313)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Incluir Categoria'
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14731361626417313)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Log de Entrada MessageFlow'
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14731554354417313)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100002)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1ximo de Ciclos do Timer')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14731725501417313)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de Destino'
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14731995260417313)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14732149276417313)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14732371598417313)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Colar o conte\00FAdo do arquivo BPMN (30 000 caracteres no m\00E1ximo)')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14732586725417313)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Espa\00E7o de Trabalho Padr\00E3o')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14732727668417313)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reter Resumos Di\00E1rios (Dias)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14732958768417313)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ocultar ID do Usu\00E1rio')
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14733164311417313)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Log de Entrada MessageFlow (ainda n\00E3o implementado)')
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14733355983417313)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reter Logs (Dias ap\00F3s a Conclus\00E3o da Inst\00E2ncia do Processo)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14733501477417313)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome de Usu\00E1rio Padr\00E3o')
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14733786459417313)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID Est\00E1tico da Credencial do APEX')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14733962794417313)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timers Ativados'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14734140435417313)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Coluna Blob'
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14734355501417313)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100002)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Data de Expira\00E7\00E3o da Licen\00E7a')
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14734533650417313)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14734756589417313)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registrar Chamadas Rest Recebidas'
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14734931722417313)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Uri de Redirecionamento'
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14735184322417313)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('URL de Pr\00E9-autentica\00E7\00E3o')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14735395387417314)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100002)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14735509883417314)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reter Logs (Dias ap\00F3s a Conclus\00E3o da Inst\00E2ncia do Processo)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14735703893417314)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Uri de Suporte'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14735985453417314)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Incluir status'
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14736102244417314)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14736399568417314)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100002)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14736522297417314)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prefixo do Documento'
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14736732568417314)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ativar Arquivamento de Resumo da Inst\00E2ncia')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14736944280417314)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14737177099417314)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID do Aplicativo Padr\00E3o')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14737395781417314)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14737597272417314)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100002)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14737708466417314)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lembrar o nome de usu\00E1rio')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14737937121417314)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14738197961417314)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Espa\00E7o de Trabalho Padr\00E3o')
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14738354980417314)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Remarcar o cron\00F4metro agora')
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14738569989417314)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Reten\00E7\00E3o de Log do Fluxo de Mensagens (Dias)')
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14738704017417314)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14738979023417314)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descri\00E7\00E3o')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14739127311417314)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14739357008417315)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14739507142417315)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reter Resumos Trimestrais (Meses)'
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14739730373417315)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome da vari\00E1vel')
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14739981004417315)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id do Cliente'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14740146163417315)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Id da P\00E1gina Padr\00E3o')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14740314955417315)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100002)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL Base'
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14740549935417315)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'E-mail de Suporte'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14740794813417315)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timers Ativados'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14740920560417315)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14741173659417315)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100002)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nova vers\00E3o')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14741319249417315)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14741533662417315)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pesquisar'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14741730194417315)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100002)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14741948601417315)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ativar Arquivamento de Resumo da Inst\00E2ncia')
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14742160712417315)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Remetente de e-mail padr\00E3o')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14742355155417336)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100002)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Formato JSON inv\00E1lido')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14742433906417336)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100002)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve ter um valor.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14742613185417336)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100002)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Verifique, por favor, o fluxo fornecido.'
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14742855501417336)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve ter algum valor.'
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14743055108417336)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100002)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve ter um valor.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14743240863417336)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# deve ter algum valor.'
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14743466997417336)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00E3o \00E9 poss\00EDvel arquivar um modelo associado a inst\00E2ncias em execu\00E7\00E3o.')
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14743618396417337)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100002)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cole, por favor, o conte\00FAdo do arquivo BPMN')
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14743855086417337)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100002)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Favor selecionar um #LABEL#.'
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14744034627417337)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O modelo j\00E1 existe. Use a op\00E7\00E3o sobrescrever for\00E7ada.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14744270366417337)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O modelo j\00E1 existe. Use a op\00E7\00E3o sobrescrever for\00E7ada.')
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14744463504417338)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo importado.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14744679781417338)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100002)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14744803482417338)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100002)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14745049062417338)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100002)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14745233065417338)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100002)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14745422015417338)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100002)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14745694984417338)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100002)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o Rest salva!')
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14745835220417338)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14746048870417338)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100002)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14746234254417338)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100002)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14746412985417338)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100002)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Altera\00E7\00F5es salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14746626975417338)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100002)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o processada.')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14746833844417338)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100002)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14747077587417338)
,p_page_id=>9
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100002)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mudan\00E7as salvas.')
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14747273456417338)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo importado.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14747440215417340)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100002)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Eventos de inst\00E2ncia')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14747620593417340)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100002)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Mecanismo'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14747827611417340)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100002)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Detalhes da inst\00E2ncia')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14748058382417340)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100002)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Eventos de inst\00E2ncia')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14748230003417340)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100002)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Clientes OAUTH'
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14748422165417340)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100002)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14748635079417340)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100002)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14748863523417340)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100002)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14749084027417340)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100002)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - REST - Cliente')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14749241574417340)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100002)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14749424385417340)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Desempenho do Processo (Resumos do Per\00EDodo)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14749614198417340)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100002)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subfluxos atuais'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14749825026417340)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100002)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Barra de bot\00F5es')
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14750037598417340)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100002)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Hist\00F3rico de Vari\00E1vel')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14750271644417340)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100002)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configura\00E7\00E3o do JSON')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14750486151417340)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100002)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14750641026417340)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Etapas de eventos'
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14750879743417340)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Modelos de Formul\00E1rio Simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14751016104417340)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100002)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14751274128417340)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de fluxo por status')
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14751462485417341)
,p_page_id=>9
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100002)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Se\00E7\00F5es')
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14751660248417341)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100002)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Passos completados'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14751821737417341)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Pesquisar'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14752008546417341)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Detalhes do Diagrama'
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14752230920417341)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Assinaturas de Mensagens'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14752432924417341)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100002)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagramas Chamados'
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14752612365417341)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100002)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14752809863417341)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100002)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14753013024417341)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100002)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Come\00E7ando')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14753250159417341)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncia de Fluxo')
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14753410759417341)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Criar Inst\00E2ncia de fluxo')
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14753638239417341)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100002)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Vers\00E3o incompat\00EDvel')
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14753890934417341)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100002)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Importar Fluxo'
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14754025503417341)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100002)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14754220113417341)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Pr\00E9-requisitos ausentes')
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14754473731417341)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100002)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Bot\00F5es')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14754685062417341)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100002)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Nova vers\00E3o')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14754887770417341)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100002)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Resultados da Pesquisa'
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14755002172417341)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100002)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aplicativo do Mecanismo'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14755209588417341)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100002)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Estat\00EDsticas')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14755417508417342)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100002)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aplicativo do Mecanismo'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14755646777417342)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Erros de Inst\00E2ncia nos \00FAltimos 14 dias')
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14755855278417342)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100002)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configura\00E7\00E3o do JSON')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14756061908417342)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100002)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14756222894417342)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visualizador de fluxo'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14756483843417342)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100002)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14756684783417342)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Local'
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14756835200417342)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100002)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Op\00E7\00F5es')
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14757035990417342)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100002)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Adicionar Rota ao Gateway'
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14757243932417342)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100002)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagrama Chamado'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14757401949417342)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100002)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Mecanismo'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14757694907417342)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100002)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Links'
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14757868356417342)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14758073591417342)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14758281936417342)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14758468307417342)
,p_page_id=>9
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100002)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14758605227417342)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('M\00F3dulo ausente')
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14758898208417342)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14759064105417342)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14759243114417343)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100002)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de fluxo')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14759425523417343)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Cont\00EAiner de Bot\00F5es')
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14759607441417343)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100002)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14759889034417343)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Copiar Modelo'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14760008190417343)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00DAltimo erro')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14760275381417343)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100002)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Tempos de Espera da Etapa do Hist\00F3rico para &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14760418050417343)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100002)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14760645017417343)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100002)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subfluxos completados'
,p_translate_from_text=>'Completed Subflows'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14760853336417343)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100002)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Etapas atuais'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14761084208417343)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visualizador de fluxo'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14761225252417343)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100002)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Log'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14761487061417343)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100002)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Arquivamento'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14761654504417343)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100002)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Gerenciamento do Fluxo'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14761807862417343)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100002)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14762024615417343)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100002)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14762263899417343)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100002)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14762495829417343)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100002)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14762655169417343)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Chamando Diagramas'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14762830274417343)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100002)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Licen\00E7a')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14763089681417343)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14763299506417344)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100002)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14763436134417344)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100002)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14763643926417344)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('N\00E3o REST Ativado')
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14763800323417344)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Aba'
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14764075973417344)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100002)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Desempenho da Etapa do Hist\00F3rico para &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14764252449417344)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Fun\00E7\00F5es')
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14764492777417344)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100002)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Alertas de Importa\00E7\00E3o')
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14764621981417344)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Detalhes da inst\00E2ncia')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14764826646417344)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100002)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14765050639417344)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14765208185417344)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Detalhes da inst\00E2ncia')
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14765413568417344)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100002)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Hist\00F3rico de Vari\00E1vel')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14765638645417344)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configura\00E7\00E3o')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14765863136417344)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100002)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14766063770417344)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100002)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de Fluxo Vencidas Atuais')
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14766245288417344)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100002)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14766424148417344)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Informa\00E7\00F5es')
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14766632229417344)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100002)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14766883322417344)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14767019042417344)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100002)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14767246936417345)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100002)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Processos Iniciados em &P15_DATE.'
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14767432094417345)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100002)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Etapa de Instala\00E7\00E3o Adicional N\00E3o Conclu\00EDda')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14767654632417345)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100002)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Editar Modelo de Formul\00E1rio Simples')
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14767820316417345)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100002)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14768078737417345)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100002)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Eventos de inst\00E2ncia')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14768223924417345)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100002)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14768431162417345)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100002)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Desempenho da Etapa da Tarefa (m\00EAs atual) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )')
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14768672052417345)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Erros de etapa'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14768830108417345)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Fluxo XML'
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14769002906417345)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100002)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Vari\00E1veis de Entrada/Sa\00EDda')
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14769296643417345)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Preencha os detalhes'
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14769434815417345)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100002)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Nova vers\00E3o')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14769657851417345)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100002)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Vari\00E1veis')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14769854761417345)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100002)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14770047495417345)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100002)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Caminho detalhado'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14770283377417345)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100002)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de processo por status')
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14770445495417345)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100002)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Excluir modelo'
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14770616798417345)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100002)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14770809667417345)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Escolha o destino ativo'
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14771079851417345)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100002)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de Fluxo Atuais por Modelo - 10 Principais')
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14771289699417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100002)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Etapa de reserva'
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14771479339417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100002)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Adicionar/Editar Vari\00E1vel de Processo')
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14771631847417346)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14771888081417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Breadcrumb'
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14772050561417346)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100002)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de Fluxo iniciadas nos \00FAltimos 14 dias')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14772252910417346)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14772474340417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100002)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subfluxos'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14772689569417346)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Timers desativados'
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14772808662417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100002)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14773059738417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Redefini\00E7\00E3o do Timer')
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14773212953417346)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Upgrade do APEX detectado'
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14773495025417346)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14773626073417346)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Come\00E7ando')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14773883418417346)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14774006012417346)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100002)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Inst\00E2ncias de processo associadas')
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14774261658417346)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14774423550417346)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100002)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14774614752417346)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Monitor de fluxo (&P12_PRCS_NAME.)'
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14774802655417346)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Seletor de Idiomas'
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14775079290417346)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100002)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Bot\00F5es')
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14775236051417346)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100002)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Log'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14775417090417346)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visualizador de fluxo'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14775604105417346)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14775878750417347)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Receber mensagem'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14776094652417347)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('A\00E7\00E3o de Menu')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14776268107417347)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Erros'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14776402507417347)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Conte\00FAdo')
,p_translate_from_text=>'Content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14776699976417366)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100002)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14776807485417366)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14777036393417366)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14777279930417366)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100002)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14777451731417366)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100002)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14777677673417366)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14777862255417366)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14778042520417366)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100002)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14778205312417367)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100002)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para uma maneira f\00E1cil de criar suas pr\00F3prias defini\00E7\00F5es de formul\00E1rio de forma declarativa, voc\00EA pode usar o <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Construtor ')
||unistr('de Formul\00E1rio Simples</span></a> para gerar o JSON necess\00E1rio.')
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14778443825417367)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100002)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14778647652417367)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14778876270417367)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100002)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14779099776417367)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00F3dulo REST <li>n\00E3o instalado. Siga o guia de instala\00E7\00E3o em: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14779252617417367)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14779415047417367)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100002)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14779654558417367)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100002)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Encorajamos voc\00EA a importar modelos que foram constru\00EDdos usando Flows for APEX para garantir que eles possam ser executados pelo motor.')
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14779842390417367)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>O esquema n\00E3o est\00E1 Ativado para REST</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14780026615417367)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nesta p\00E1gina, voc\00EA pode gerenciar as defini\00E7\00F5es JSON de seus modelos de Formul\00E1rio Simples. Seus modelos podem ser usados de duas maneiras:'),
'<ul>',
unistr('    <li>Selecione-os em Tarefas do Usu\00E1rio do tipo "Formul\00E1rios Simples" em seus modelos de fluxo</li>'),
unistr('    <li>Utilize-os no <strong>Aplicativo Iniciante de Processo Simples</strong> da distribui\00E7\00E3o de Fluxos para iniciar inst\00E2ncias do processo preenchendo um formul\00E1rio'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14780230923417367)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100002)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14780417619417368)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100002)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14780644048417368)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100002)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para usar o recurso Timers do Flows for APEX, conclua a etapa de instala\00E7\00E3o adicional que pode ser encontrada <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">aqui</a>.')
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14780879008417368)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100002)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14781087424417368)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100002)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14781235612417368)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Os modelos que cont\00EAm um ou mais temporizadores n\00E3o puderam funcionar corretamente neste sistema porque est\00E3o desativados.<br>\00C9 poss\00EDvel ativ\00E1-lo na p\00E1gina Configura\00E7\00E3o.')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14781454966417368)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14781642691417368)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100002)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14781823402417368)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100002)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14782035619417368)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>Um sistema de Fluxo de Processo baseado em BPMN de Baixo C\00F3digo para APEX.</h3>'),
'<h4> Recursos</h4>',
'<ul>',
unistr('<li>O Flows for APEX permite que os desenvolvedores do APEX modelem e executem fluxos de processos no APEX usando uma combina\00E7\00E3o de design de processo visual e t\00E9cnicas com pouco c\00F3digo.</li>'),
unistr('<li>Projetado principalmente para desenvolvedores APEX, o Flows for APEX usa as tecnologias com as quais voc\00EA j\00E1 conhece - APEX, PL/SQL e SQL - para criar fluxos de processos poderosos e flex\00EDveis em seu ambiente APEX.</li>'),
unistr('<li>usado para criar e executar um fluxo de processos de p\00E1ginas do APEX, scripts PL/SQL e enviar e-mail.</li>'),
unistr('<li> A defini\00E7\00E3o do processo diagram\00E1tico com pouco c\00F3digo tamb\00E9m pode ser compreendida e editada pelos usu\00E1rios corporativos para aumentar a flexibilidade dos neg\00F3cios. Os fluxos usam o estilo Business Process Modeling Notation (BPMN) V2</li>'),
unistr('<li>Built como um projeto da comunidade APEX e lan\00E7ado em uma licen\00E7a MIT de c\00F3digo-fonte aberto.</li>'),
'</ul>',
'<p>',
unistr('<h4>Fa\00E7a o download</h4>'),
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
unistr('<h4>Documenta\00E7\00E3o</h4>'),
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Documenta\00E7\00E3o Mais Recente On-line</a>'),
'<p>',
'<h4>Tutoriais do BPMN</h4>',
unistr('Para come\00E7ar a modelar fluxos, experimente os fluxos de tutoriais pr\00E9-instalados. Para obter mais informa\00E7\00F5es sobre os tutoriais, veja <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">aqui</a>.'),
'<p>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14782229222417368)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100002)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14782474860417369)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14782628284417372)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100002)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Localiza\00E7\00E3o do BPMN')
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14782886797417372)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14783090628417373)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100002)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Localiza\00E7\00E3o do Arquivo')
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14783201302417373)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14783416350417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100002)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14783687937417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100002)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14783865568417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100002)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14784098365417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100002)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14784248241417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100002)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atualizar'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14784451680417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100002)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14784629265417373)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100002)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('C\00F3pia')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14784867932417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100002)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminar'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14785052289417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100002)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14785293174417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100002)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminar'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14785477772417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100002)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tema'
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14785682766417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100002)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Licen\00E7a')
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14785897644417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100002)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminar'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14786003866417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100002)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor de fluxo'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14786292345417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14786470214417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100002)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atualizar'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14786606344417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100002)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14786852889417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100002)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalhes'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14787015998417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100002)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Adicionar nova vers\00E3o')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14787298125417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100002)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14787429273417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100002)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Download (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14787631060417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14787879756417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100002)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Resumo da Inst\00E2ncia')
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14788041551417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100002)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Editar'
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14788298427417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100002)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14788470744417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100002)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mecanismo'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14788650493417374)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mostrar Linha do Tempo da Inst\00E2ncia')
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14788842176417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100002)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14789079080417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100002)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14789255955417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100002)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atualizar'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14789415761417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100002)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalhes do modelo'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14789659711417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100002)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completo'
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14789825961417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100002)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14790082510417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100002)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Adicionar nova vers\00E3o')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14790295437417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100002)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Autom\00E1tico')
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14790409360417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modelos de Formul\00E1rio Simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14790656342417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100002)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicativo do Mecanismo'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14790891790417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100002)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('In\00EDcio')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14791040529417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100002)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Painel de controle'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14791204215417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100002)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mostrar Hist\00F3rico')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14791494452417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100002)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arquivamento'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14791697132417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100002)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14791841057417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100002)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Download (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14792099506417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100002)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores da Etapa'
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14792269032417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100002)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('abaixo do relat\00F3rio|lado a lado|nova janela')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14792428036417375)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100002)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14792617150417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sair'
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14792822422417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100002)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14793003872417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100002)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Come\00E7ando')
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14793298291417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100002)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14793412909417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100002)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('In\00EDcio')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14793650761417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100002)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o da tela')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14793888854417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14794084524417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100002)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14794292655417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100002)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14794480258417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100002)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14794698486417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100002)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('C\00F3pia')
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14794855080417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo Escuro'
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14795096177417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100002)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14795299185417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100002)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14795457624417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100002)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalhes do modelo'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14795646071417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100002)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completo'
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14795810343417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14796081416417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lan\00E7amento')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14796271925417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100002)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o da tela')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14796474648417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100002)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ver Fonte'
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14796695212417376)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100002)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalhes'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14796827817417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100002)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14797097034417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Re-start'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14797215225417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14797496308417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100002)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14797627832417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100002)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Log'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14797895789417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lan\00E7amento')
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14798090437417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100002)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14798204567417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100002)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14798460161417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100002)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Download (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14798630346417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100002)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14798874697417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100002)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visualizar'
,p_translate_from_text=>'View'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14799091758417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100002)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('In\00EDcio')
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14799241067417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo leve'
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14799447839417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100002)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14799619790417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100002)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14799898761417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100002)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('abaixo do relat\00F3rio|lado a lado|nova janela')
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14800087504417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100002)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mostrar Hist\00F3rico')
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14800221972417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14800400158417377)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14800696492417378)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100002)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gerenciamento do Fluxo'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14800865539417389)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum processo selecionado'
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14801056464417390)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum processo selecionado'
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14801286046417390)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100002)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum atributo encontrado.'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14801437391417390)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14801634122417390)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100002)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nenhuma vari\00E1vel de Entrada/Sa\00EDda encontrada.')
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14801869028417391)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Campo de Pesquisa'
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14802059168417391)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14802229613417392)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14802423522417392)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14802687056417392)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14802899933417392)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Busca'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14803029263417392)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fechar'
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14803223109417392)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pr\00F3ximo \005Cu0026gt;')
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14803405755417393)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&lt; Anterior'
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14803602225417393)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Voc\00EA gostaria de realizar esta a\00E7\00E3o de exclus\00E3o?')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14803849977417393)
,p_translated_flow_id=>100002
,p_translate_to_id=>100.100002
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fluxo de trabalho'
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14804016826417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100002)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas do Processo')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14804242894417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100002)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gerenciamento do Fluxo'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14804495122417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100002)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Servi\00E7o REST')
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14804641561417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mecanismo'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14804859340417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100002)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arquivamento'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14805015927417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100002)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Monitor de fluxo'
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14805206682417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100002)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Linha do Tempo da Inst\00E2ncia - &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14805444303417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100002)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14805684685417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100002)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14805842346417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100002)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Painel de controle'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14806040689417394)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100002)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas da Tarefa')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14806233649417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100002)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14806427264417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100002)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicativo do Mecanismo'
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14806633920417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100002)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estat\00EDsticas Di\00E1rias')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14806882555417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100002)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modelos de Formul\00E1rio Simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14807046292417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100002)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configura\00E7\00E3o - Licen\00E7a')
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14807265210417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100002)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelador de Fluxo'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14807429548417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100002)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Log'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14807626286417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100002)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14807819690417395)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100002)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14808002833417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100002)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arquivo'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14808221842417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100002)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Depois da tarefa'
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14808449458417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100002)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Antes da divis\00E3o')
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14808683717417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100002)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Status do processo ap\00F3s o t\00E9rmino')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14808863568417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100002)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Localiza\00E7\00E3o')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14809063903417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100002)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14809273580417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100002)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BCC'
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14809419512417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100002)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14809628495417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100002)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Intervalo de Ano a M\00EAs')
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14809887655417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100002)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Em Vari\00E1veis')
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14810076475417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100002)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Texto'
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14810268065417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100002)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Script SQL'
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14810433875417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100002)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Requisi\00E7\00E3o')
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14810678820417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100002)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Itens da p\00E1gina')
,p_translate_from_text=>'Page Items'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14810800630417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100002)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tempo at\00E9 o temporizador disparar novamente')
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14811048630417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100002)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1ximo de Execu\00E7\00F5es')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14811274165417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100002)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vari\00E1veis Externas')
,p_translate_from_text=>'Out Variables'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14811475294417397)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100002)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Corpo da fun\00E7\00E3o PL/SQL')
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14811676217417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100002)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('P\00E1gina')
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14811885361417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100002)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Formato da m\00E1scara')
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14812031190417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100002)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Intervalo de Dia para Segundo'
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14812217145417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100002)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tempo at\00E9 o primeiro disparo do temporizador')
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14812468899417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100002)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motor'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14812617473417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100002)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tipo de defini\00E7\00E3o do temporizador')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14812889723417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100002)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Defini\00E7\00E3o do temporizador')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14813011419417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100002)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Responder a'
,p_translate_from_text=>'Reply To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14813244176417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Lembrar o nome de usu\00E1rio')
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14813439828417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100002)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Arquivo BPMN'
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14813614835417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100002)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Antes da tarefa'
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14813866665417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100002)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Para'
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14814019857417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100002)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CC'
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14814205949417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100002)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enviar Imediatamente'
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14814450739417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100002)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Antes do evento'
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14814633238417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100002)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID da Aplica\00E7\00E3o')
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14814831689417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100002)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corpo do HTML'
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14815009937417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100002)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ap\00F3s a fus\00E3o')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14815285538417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100002)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'De'
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14815477654417398)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100002)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valor est\00E1tico')
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14815624723417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100002)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Assunto'
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14815847859417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100002)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Item'
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14816076298417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100002)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL Query (retorna valores separados por dois pontos)'
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14816280121417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100002)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Express\00E3o PL/SQL')
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14816476591417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100002)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('C\00F3digo PL/SQL')
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14816644936417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100002)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vari\00E1vel de Processo')
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14816897696417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100002)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No evento'
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14817060884417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100002)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anexo'
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14817213515417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100002)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('SQL Query (retorna valor \00FAnico)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14817496785417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100002)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Limpar Cache'
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14817644531417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100002)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valores do Item'
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14817816287417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100002)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Corpo'
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14818022110417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100002)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de tarefa'
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14818209415417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100002)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Use o modelo'
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14818424783417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100002)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Modelo'
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14818689886417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100002)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14818893517417399)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100002)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valores de liga\00E7\00E3o dos itens da p\00E1gina')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14819012201417403)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum Subfluxo Registrado'
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14819218246417403)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nenhum N\00EDvel de Processo Registrado')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14819430397417403)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'- selecionar -'
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14819643912417403)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhuma categoria'
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14819860651417403)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100002)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dire\00E7\00E3o')
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14820048430417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100002)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14820285653417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100002)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14820414471417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100002)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pilha de erros'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14820622187417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100002)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status do Evento'
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14820803836417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100002)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14821045953417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100002)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rio')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14821228933417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14821455466417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100002)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14821623009417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100002)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data do Evento'
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14821840079417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14822004861417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100002)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C9 Cham\00E1vel')
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14822230038417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100002)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iniciado em'
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14822451588417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100002)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14822669872417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14822872788417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100002)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID da p\00E1gina')
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14823071013417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100002)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14823200603417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100002)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome de usu\00E1rio')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14823410654417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100002)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14823645597417404)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100002)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14823807489417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100002)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima atualiza\00E7\00E3o sobre')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14824099202417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100002)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00EDtulo do Evento')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14824294184417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100002)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00CDcone do Evento')
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14824476208417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100002)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14824645204417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14824842825417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100002)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descri\00E7\00E3o do Evento')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14825062574417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100002)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14825282273417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14825485741417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100002)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo'
,p_translate_from_text=>'Model'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14825612869417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100002)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14825876250417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100002)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Aplicativo'
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14826011100417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100002)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cor do Usu\00E1rio')
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14826284198417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100002)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de Dados'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14826415656417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100002)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descri\00E7\00E3o')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14826614252417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100002)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14826864083417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prioridade'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14827065201417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100002)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14827203990417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100002)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de Evento'
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14827453080417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100002)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14827657583417405)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100002)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14827808677417406)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vencimento em'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14828098327417406)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100002)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome do Usu\00E1rio')
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14828233229417408)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100002)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14828409470417408)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100002)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14828667806417408)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100002)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14828806290417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14829029210417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14829296157417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100002)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14829406901417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100002)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14829657792417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100002)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14829888012417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14830080810417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100002)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14830264910417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14830427507417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100002)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14830690284417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100002)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14830846103417409)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100002)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14831074033417410)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li>Um Modelo: Importe um \00FAnico modelo fornecendo todos os atributos</li>'),
unistr('    <li>V\00E1rios Modelos: Importe v\00E1rios modelos fornecendo um arquivo zip*</li>'),
'</ul>',
'<p> * O arquivo zip deve conter:',
'    <ul>',
'        <li>Os arquivos bpmn a serem importados</li>',
unistr('        <li>Um arquivo import.json que \00E9 um array de objetos (veja o exemplo abaixo) com os seguintes atributos:'),
'            <ul>',
'                <li>dgrm_name: O nome do modelo</li>',
unistr('                <li>dgrm_version: A vers\00E3o do modelo</li>'),
'                <li>dgrm_category: A categoria do modelo</li>',
'                <li>arquivo: O nome do arquivo bpmn no arquivo</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Exemplo de arquivo import.json com dois modelos<br>',
'<pre><code>[',
'{',
unistr('    "dgrm_name": "Colabora\00E7\00E3o de Pizza",'),
'    "dgrm_version": "0",',
'    "dgrm_status": "esquema",',
'    "dgrm_category": nulo,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Feriados",',
'    "dgrm_version": "0",',
'    "dgrm_status": "esquema",',
'    "dgrm_category": nulo,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14831205164417410)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se voc\00EA marcar esta caixa de sele\00E7\00E3o, o aplicativo salvar\00E1 seu nome de usu\00E1rio em um cookie persistente do navegador chamado "LOGIN_USERNAME_COOKIE". Quando voc\00EA acessar a p\00E1gina de login na pr\00F3xima vez,'),
unistr('o campo de nome de usu\00E1rio ser\00E1 preenchido automaticamente com esse valor.'),
'</p> <p>',
unistr('Se voc\00EA desmarcar essa caixa de sele\00E7\00E3o e seu nome de usu\00E1rio j\00E1 tiver sido salvo no cookie,'),
unistr('o aplicativo o substituir\00E1 por um valor vazio. Voc\00EA tamb\00E9m pode usar as ferramentas de desenvolvimento do seu navegador para remover completamente o cookie.'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14831477060417410)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14831616340417411)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100002)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Eventos de inst\00E2ncia')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14831817924417411)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100002)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxos atuais'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14832081976417411)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100002)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14832261250417411)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Modelos de Formul\00E1rio Simples')
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14832413252417412)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100002)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Hist\00F3rico de Vari\00E1vel')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14832622180417412)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100002)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Eventos de inst\00E2ncia')
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14832894724417412)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100002)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Relat\00F3rio do Cliente ORDS')
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14833079079417412)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100002)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelos Chamados'
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14833274007417412)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Assinaturas de Mensagens'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14833499125417412)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100002)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Passos completados'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14833661326417412)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100002)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14833877855417412)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100002)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama Chamado'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14834051441417412)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100002)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Gerenciamento do Fluxo'
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14834229482417412)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chamando Diagramas'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14834447314417412)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100002)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias de fluxo')
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14834657541417412)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100002)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxos completados'
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14834840370417412)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100002)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Etapas atuais'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14835015574417412)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100002)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Hist\00F3rico de Vari\00E1vel')
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14835267669417412)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100002)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vari\00E1veis')
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14835406383417412)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erros de etapa'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14835629591417412)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100002)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxos'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14835848301417414)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100002)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A contagem m\00E1xima de linhas para este relat\00F3rio \00E9 #MAX_ROW_COUNT# linhas.  Aplique um filtro para reduzir o n\00FAmero de registros em sua consulta.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14836015956417414)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A contagem m\00E1xima de linhas para este relat\00F3rio \00E9 #MAX_ROW_COUNT# linhas.  Aplique um filtro para reduzir o n\00FAmero de registros em sua consulta.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14836227486417414)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O hist\00F3rico da vari\00E1vel est\00E1 vazio.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14836491679417414)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O hist\00F3rico de erros de passos est\00E1 vazio.')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14836628287417414)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum subfluxo atual foi encontrado.'
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14836801146417414)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nenhuma express\00E3o vari\00E1vel encontrada.')
,p_translate_from_text=>'No variable expressions found.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14837067415417414)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum Diagrama de Chamada encontrado.'
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14837279969417414)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00E3o foram encontrados subfluxos completos.')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14837470941417415)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O hist\00F3rico de eventos de exemplo est\00E1 vazio.')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14837678519417415)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100002)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum dado encontrado.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14837887426417415)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum atributo encontrado.'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14838028733417415)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum Diagrama Chamado encontrado.'
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14838285192417415)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100002)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O hist\00F3rico da vari\00E1vel est\00E1 vazio.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14838411689417415)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100002)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhum dado encontrado.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14838663484417415)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nenhuma etapa conclu\00EDda foi encontrada.')
,p_translate_from_text=>'No completed steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14838815605417415)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nenhuma etapa atual foi encontrada.'
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14839094892417416)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14839262596417416)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14839423015417416)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14839637169417416)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14839895079417416)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14840093359417416)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14840266344417416)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14840490156417416)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14840653356417416)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14840810967417416)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14841050356417417)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14841282176417417)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14841439883417417)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14841642385417417)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14841843572417417)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14842076131417417)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14842296047417417)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14842453072417417)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14842697642417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14842849572417417)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100002)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14843077037417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100002)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14843221489417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14843492195417417)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14843617911417417)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14843842400417417)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100002)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14844055747417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14844216295417417)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14844469438417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14844684818417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100002)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14844881160417417)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100002)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14845089436417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14845255240417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14845460721417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14845674545417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14845822072417418)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14846097480417418)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14846241136417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14846439657417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14846677218417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14846839642417418)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14847062624417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100002)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14847249397417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14847468601417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14847633975417418)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14847836350417418)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14848037230417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100002)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14848218084417418)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100002)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14848482662417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14848685801417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14848868471417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14849014234417418)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14849250919417418)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100002)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14849483074417419)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14849662586417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14849878496417419)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14850047718417419)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100002)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14850225126417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14850477642417419)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14850607477417419)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14850812063417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14851037220417419)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100002)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14851275243417419)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14851432291417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14851672282417419)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14851879118417419)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100002)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14852050665417419)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14852207079417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100002)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14852427800417419)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14852623387417419)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14852874769417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14853024149417419)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14853235070417419)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14853429133417419)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14853671170417420)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14853861650417420)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14854044367417420)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14854265471417420)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14854463180417420)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14854611800417420)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14854844958417420)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14855086454417420)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14855236685417420)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100002)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14855428411417420)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14855648653417420)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100002)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14855849070417420)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14856060510417420)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14856211133417420)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14856410971417420)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14856683732417420)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100002)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14856836164417420)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100002)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14857013493417420)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100002)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14857239673417420)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14857478440417420)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14857614106417421)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14857836718417421)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100002)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14858081000417421)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14858268595417421)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14858400238417421)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14858686753417421)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14858808515417421)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14859024811417421)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14859267495417421)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14859420383417421)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14859630123417421)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14859841933417421)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14860024859417421)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14860282042417421)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14860450180417421)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14860645909417421)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14860816744417421)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14861093849417421)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14861280072417421)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14861431721417421)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14861676085417421)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14861838252417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14862078695417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14862231011417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14862433873417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14862645345417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14862826305417422)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14863009324417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100002)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14863247072417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14863400020417422)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14863619587417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100002)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14863805260417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14864076342417422)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14864240849417422)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14864428079417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100002)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14864645829417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14864886376417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14865095895417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14865259701417422)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100002)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14865427052417422)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14865641216417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14865816685417422)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14866019877417423)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14866210745417423)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100002)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14866478821417423)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14866659092417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14866868923417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100002)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14867079658417423)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14867258847417423)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100002)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14867458575417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14867664182417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14867890415417423)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14868073255417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14868214115417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14868423206417423)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14868613986417423)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100002)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14868870072417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14869067855417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14869252070417423)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14869411463417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14869689359417423)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14869816827417423)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14870073951417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100002)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14870219841417424)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14870448116417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14870648671417424)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14870829272417424)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14871092241417424)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14871205313417424)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14871421462417424)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14871631080417424)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14871899739417424)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100002)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14872040767417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14872229679417424)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14872461741417424)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14872687163417424)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14872871756417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14873091754417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100002)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14873249985417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14873480725417424)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14873622888417424)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14873838619417424)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100002)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14874005064417425)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14874278981417425)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100002)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14874461982417425)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14874666406417425)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14874834092417425)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14875038109417425)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14875222684417425)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14875488083417425)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14875607477417425)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100002)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14875822136417425)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14876052956417425)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14876215698417425)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14876493450417425)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14876650923417425)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14876873669417425)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14877069229417425)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100002)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14877266272417425)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14877422178417425)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14877693213417425)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14877804201417425)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100002)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14878017896417425)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14878236757417426)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14878497519417426)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100002)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14878661198417426)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14878861661417426)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100002)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14879009396417426)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100002)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14879218115417426)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14879453971417426)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14879622601417426)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14879883866417426)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14880038727417426)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100002)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14880297283417426)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14880447591417426)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14880693660417426)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14880893707417426)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14881077526417426)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14881218315417426)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100002)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14881424976417426)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14881611193417426)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14881843625417426)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14882052713417426)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14882289117417426)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14882405408417427)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14882660464417427)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14882816310417427)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14883040725417427)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14883298140417427)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14883413499417427)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14883635450417427)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100002)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14883833969417427)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14884080317417427)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100002)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14884250763417427)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14884412988417441)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Iniciar cron\00F4metro')
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14884613429417442)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14884861990417442)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Escopo Atual'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14885053274417442)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14885218379417442)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON Attributos'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14885423328417442)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14885646644417442)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima Atualiza\00E7\00E3o')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14885863747417442)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14886036153417442)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rio')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14886265775417442)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14886426915417442)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14886680438417442)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Data de cria\00E7\00E3o')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14886887829417442)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14887046835417442)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Sele\00E7\00E3o da Vers\00E3o do Diagrama Chamado')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14887237047417442)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14887434556417442)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14887643485417442)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rio')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14887857242417442)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima Atualiza\00E7\00E3o')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14888033016417442)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto inicial'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14888231868417442)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100002)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'E-mail de Suporte'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14888487100417442)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100002)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14888658168417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel atual')
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14888805410417443)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o do Modelo')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14889011364417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14889298784417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100002)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status Quando Completo'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14889497997417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor da Chave'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14889699679417443)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14889846454417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14890003105417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100002)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservado para'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14890283786417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100002)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14890425700417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome da Chave'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14890614574417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14890835354417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14891089701417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14891210663417443)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tem \00CDcone de Recurs\00E3o')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14891446624417443)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14891652339417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14891809951417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o r\00E1pida')
,p_translate_from_text=>'Quick Action'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14892051522417443)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome da inst\00E2ncia')
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14892212473417443)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14892455304417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100002)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14892673356417443)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14892819647417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vencimento em'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14893019244417444)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14893239959417444)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14893431067417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100002)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14893679946417444)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100002)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o r\00E1pida')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14893853840417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criado'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14894035430417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14894221177417444)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Execu\00E7\00E3o')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14894462961417444)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltimo Conclu\00EDdo')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14894605467417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100002)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14894873145417444)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chamando Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14895015445417444)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14895299313417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Classe atual'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14895447880417444)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100002)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14895654014417444)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Escopo'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14895896109417444)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID Est\00E1tico')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14896044774417444)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14896200611417444)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tornou-se atual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14896446165417444)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100002)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14896690780417445)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14896873451417445)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Express\00E3o')
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14897071783417445)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Execu\00E7\00E3o')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14897278029417445)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100002)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14897402518417445)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14897636062417445)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100002)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14897827775417445)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14898070376417445)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100002)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14898216761417445)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14898461266417445)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Etapa'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14898645271417445)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14898806384417445)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rios Exclu\00EDdos')
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14899078959417445)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14899219717417445)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservas'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14899459832417445)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama de Chamada'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14899698163417445)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14899871348417445)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabalho Iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14900097783417445)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vari\00E1vel de Carga \00DAtil')
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14900233600417445)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14900446596417446)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14900687883417446)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100002)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fluxo Analisado'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14900859755417446)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14901006153417446)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100002)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservas'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14901271673417446)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14901477718417446)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel de processo')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14901665022417446)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabalho Iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14901853791417446)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14902030804417446)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100002)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14902213812417446)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100002)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14902487629417446)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100002)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14902664317417446)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Processo'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14902894007417446)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14903071022417446)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rio')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14903296910417446)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100002)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltimo Conclu\00EDdo')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14903467388417446)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Raiz'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14903644503417446)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservas'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14903847665417446)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14904086191417446)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima Atualiza\00E7\00E3o')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14904257823417447)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de Chamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14904459208417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14904624017417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima Atualiza\00E7\00E3o')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14904827668417447)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14905036152417447)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14905293466417447)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14905446598417447)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14905653388417447)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rio')
,p_translate_from_text=>'User'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14905834712417447)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama Chamado'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14906022501417447)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14906255085417447)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14906481032417447)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14906636497417447)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14906891360417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100002)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14907035481417447)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14907284321417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rio')
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14907473002417447)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14907650499417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14907808780417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14908023162417447)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome da Mensagem'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14908289459417448)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltimo Conclu\00EDdo')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14908453770417448)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100002)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atual'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14908660911417448)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel de processo')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14908817762417448)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14909001012417448)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100002)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de Chamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14909226940417448)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14909477824417448)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14909669413417448)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de Chamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14909889829417448)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100002)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Escopo'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14910057381417448)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14910221565417448)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14910474441417448)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prioridade'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14910683344417448)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100002)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14910853100417448)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservas'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14911077153417448)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pilha de erros'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14911236789417448)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14911476423417448)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima Atualiza\00E7\00E3o')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14911631236417448)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100002)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14911836991417448)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14912099787417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Execu\00E7\00E3o')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14912288267417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100002)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chave do passo'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14912481124417449)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14912609296417449)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100002)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chave do passo'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14912866816417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14913022306417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID BPMN'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14913229321417449)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tornou-se atual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14913457555417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de dado'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14913684839417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14913878268417449)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14914023358417449)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100002)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14914205336417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14914404504417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14914690923417449)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o do Diagrama Chamado')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14914872798417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14915048990417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltimo Conclu\00EDdo')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14915259018417449)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14915458677417449)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100002)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Chave do passo'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14915676727417449)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14915833205417449)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14916057692417450)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel de processo')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14916251264417450)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pilha de erros'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14916478206417450)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Etapa'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14916670203417450)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14916823704417450)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabalho Iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14917084920417450)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14917245464417450)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100002)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14917483821417450)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Classe atual'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14917699399417450)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama de Chamada'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14917807326417450)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabalho Iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14918076908417450)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de dado'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14918292691417450)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de Chamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14918427363417450)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100002)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pilha de erros'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14918645265417450)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14918841273417450)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel de processo')
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14919035526417450)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100002)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID Msub'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14919235661417450)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100002)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14919404447417450)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100002)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Coment\00E1rio')
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14919692848417450)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100002)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descri\00E7\00E3o')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14919894634417450)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14920049752417451)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('N\00EDvel')
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14920289228417451)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status do modelo'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14920453730417451)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria do modelo'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14920618245417451)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100002)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14920887481417451)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14921088616417451)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100002)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Caminho da Itera\00E7\00E3o')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14921216454417451)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14921461123417451)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de dado'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14921691339417451)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atual'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14921834036417451)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14922092027417451)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14922210454417451)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do Diagrama de Chamada'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14922444542417451)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100002)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Uri de Suporte'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14922676117417451)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14922814724417451)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14923099526417451)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100002)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14923297225417451)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100002)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14923489850417451)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14923607351417451)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tem Recurs\00E3o')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14923862263417451)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100002)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID do subfluxo'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14924058810417452)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Usu\00E1rios Potenciais')
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14924213683417452)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100002)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14924444641417452)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100002)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14924640929417452)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100002)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14924861364417452)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome do modelo'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14925070361417452)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14925299698417452)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tipo de express\00E3o')
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14925430433417452)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100002)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14925644530417452)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subfluxo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14925870510417452)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14926073939417452)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14926266071417452)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Grupos Potenciais'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14926469183417452)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14926612240417452)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100002)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id do Cliente'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14926829315417452)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14927026254417452)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14927283504417452)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID Dgrm'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14927482114417452)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Etapa'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14927685930417452)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100002)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tornou-se atual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14927870896417452)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14928053220417453)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100002)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14928261393417453)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100002)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tornou-se atual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14928475438417453)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100002)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14928677094417453)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100002)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14928881180417453)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100002)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14929073758417453)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100002)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status Quando Completo'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14929273086417453)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00E7\00E3o r\00E1pida')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14929403710417453)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100002)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14929647950417453)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14929814368417467)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14930032850417467)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14930248476417467)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14930475993417467)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100002)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14930662368417467)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100002)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14930872419417467)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14931037438417467)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100002)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14931241903417467)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14931433941417467)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100002)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14931686418417467)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14931842773417468)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100002)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14932067057417468)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14932252630417468)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14932438565417468)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100002)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14932680683417468)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14932806955417468)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100002)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14933058502417468)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100002)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14933222338417468)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100002)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14933441084417468)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14933684296417468)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100002)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14933877310417468)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14934084506417468)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100002)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14934275699417468)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14934476256417468)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14934670269417468)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100002)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14934886634417468)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100002)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14935088017417470)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100002)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14935246224417470)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100002)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14935461310417473)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100002)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Visualizador'
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14935606605417473)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100002)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Modelador'
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14935870041417473)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100002)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14936061536417473)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100002)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14936210213417473)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100002)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14936478508417474)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100002)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14936689376417474)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100002)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14936843832417474)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100002)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14937003551417474)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Privil\00E9gios insuficientes, o usu\00E1rio n\00E3o \00E9 um Administrador')
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14937226650417474)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Por Hora'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14937454730417475)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Por Hora'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14937689286417475)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Ano'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14937872591417475)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Ano'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14938024866417475)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Ano'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14938265693417475)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ano I'
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14938418397417475)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 Anos'
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14938621658417476)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 Min.'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14938885118417476)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 Min.'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14939052296417476)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14939268129417476)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14939484592417476)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14939678853417476)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 Meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14939808873417476)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4 Anos'
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14940064888417477)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 Min.'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14940206224417477)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 Min.'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14940479658417477)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14940625755417477)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14940820392417477)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14941044551417477)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 Meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14941220512417477)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Anos'
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14941479805417478)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Min.'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14941640451417478)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Min.'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14941864723417478)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14942053006417478)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14942230244417478)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14942438526417478)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 Meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14942626186417478)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2 Anos'
,p_translate_from_text=>'2 Years'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14942832625417478)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 Sec (Uso de Produ\00E7\00E3o - n\00E3o para apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14943042602417479)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 Sec (Uso de Produ\00E7\00E3o - n\00E3o para apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14943260125417479)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 Dias'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14943482278417479)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 Dias'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14943607961417479)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'30 Dias'
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14943805494417479)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 Ano'
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14944088791417479)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 Dias'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14944244998417479)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 Dias'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14944494372417479)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'14 Dias'
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14944616560417480)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14944816132417480)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14945091638417480)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14945225736417480)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14945489056417480)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14945680288417480)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100002)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14945815505417480)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14946064962417480)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100002)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14946277471417480)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14946400482417480)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14946617597417480)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14946829332417481)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14947043653417481)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100002)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14947269492417481)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14947408039417481)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14947602600417481)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14947893372417481)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14948069315417481)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14948202624417481)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100002)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14948443340417481)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100002)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14948665183417481)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14948898555417481)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100002)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14949064086417481)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14949259384417481)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100002)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14949474488417481)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100002)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14949653814417481)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14949801096417481)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100002)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14950028261417481)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100002)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14950239997417481)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14950416642417481)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100002)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14950687771417481)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100002)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14950857809417482)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14951036139417482)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100002)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14951265752417482)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100002)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14951431507417482)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14951680887417482)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14951844933417482)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14952032600417482)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14952220503417482)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14952457043417482)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14952624622417482)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14952875067417482)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100002)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14953056761417482)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100002)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14953217773417482)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14953482403417482)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14953669611417482)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14953843433417482)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14954047325417482)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14954260632417482)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14954445733417482)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100002)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14954692137417482)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14954821168417482)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100002)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14955018173417482)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14955268479417483)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100002)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14955419684417483)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14955666580417483)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14955837947417483)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100002)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14956053612417483)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100002)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14956220821417483)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100002)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14956483686417483)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14956697859417483)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14956898626417483)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14957001077417483)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100002)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14957218917417483)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14957445554417483)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100002)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14957605750417483)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14957854386417483)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14958052009417483)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14958226301417483)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14958454264417483)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14958660331417483)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14958895253417483)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14959022261417483)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14959269677417483)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14959455737417484)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100002)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14959644077417484)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14959882272417484)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14960000706417484)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14960262433417484)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100002)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14960450167417484)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14960677132417484)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14960871797417484)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100002)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14961041332417484)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14961206102417484)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14961476418417484)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100002)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14961661310417484)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14961843108417484)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14962038556417484)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14962263600417484)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14962419313417484)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14962667487417484)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14962820058417484)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14963023156417484)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14963230275417484)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14963457229417484)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14963671309417484)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14963837546417485)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14964043381417485)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14964262568417485)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14964406170417485)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14964619516417485)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100002)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14964830241417485)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100002)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14965058714417485)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14965278933417485)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14965413008417485)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100002)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14965675018417485)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100002)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14965890677417485)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14966044637417485)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14966210175417485)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14966414990417485)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14966610448417485)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14966806526417485)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14967058715417485)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14967257341417485)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14967479460417485)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14967637485417485)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100002)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14967854246417485)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100002)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14968055017417486)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100002)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14968238992417486)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100002)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14968437562417486)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14968668880417486)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14968897701417486)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14969055218417486)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100002)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14969212989417486)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14969456144417486)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14969642463417486)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100002)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14969868710417486)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14970069856417486)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14970299330417486)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100002)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14970492276417486)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14970627192417486)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14970857460417486)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100002)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14971092199417486)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14971230104417486)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14971482426417486)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14971614997417486)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100002)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14971864526417486)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100002)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14972033470417486)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14972200453417487)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100002)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14972473354417487)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14972649763417487)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14972863482417487)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100002)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14973061394417487)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14973247538417487)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14973454247417487)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14973661392417487)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100002)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14973855917417487)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14974033020417487)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14974290965417487)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14974426966417487)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14974684967417487)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14974895642417487)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14975013832417487)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14975230924417487)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14975434188417487)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14975656308417487)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14975867879417487)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14976062178417487)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100002)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14976298189417487)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14976480725417488)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14976667544417488)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14976864738417488)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14977042654417488)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100002)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14977225427417488)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14977492886417488)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14977671613417488)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14977839684417488)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14978061052417488)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100002)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14978273690417488)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14978438684417488)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14978641318417488)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14978805178417488)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14979049054417488)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100002)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14979263580417488)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100002)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14979433619417488)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14979641845417488)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100002)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14979820137417488)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14980065441417488)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100002)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14980291974417489)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14980470123417489)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14980625090417489)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14980888177417501)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14981029337417501)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14981250311417501)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14981437476417501)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14981642779417501)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14981827831417501)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100002)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14982090247417501)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14982251309417501)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14982411048417501)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14982644043417501)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14982890693417501)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14983041040417501)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14983220541417501)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14983469899417501)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14983606401417501)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14983808905417501)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14984050119417501)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14984216688417501)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14984406427417502)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100002)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14984685091417502)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100002)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14984873397417502)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14985035986417502)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14985285488417502)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14985423779417502)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100002)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14985608314417502)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14985847334417502)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14986036854417502)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14986247412417502)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14986465886417502)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14986623002417502)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14986816344417502)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100002)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14987073622417502)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14987227327417502)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14987467174417502)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14987633202417502)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14987837804417502)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14988019910417502)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14988296579417502)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14988466720417503)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14988668015417503)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14988878307417503)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14989084782417503)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14989279875417503)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14989476525417503)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14989608826417503)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100002)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14989817850417503)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14990082902417503)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14990276016417503)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14990441104417503)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14990647613417503)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14990863671417503)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14991021933417503)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14991277939417503)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14991459361417503)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14991659206417503)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14991837415417503)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14992099639417503)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14992259265417503)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14992418492417504)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100002)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14992641675417504)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14992857198417504)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14993024843417504)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14993234416417504)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14993442627417504)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14993602863417504)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14993857439417504)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14994062496417504)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100002)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14994230546417504)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14994429616417504)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14994666344417504)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100002)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14994860363417504)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100002)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14995024291417504)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14995220503417504)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14995437968417504)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100002)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14995644620417504)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100002)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14995891143417504)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14996062911417504)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14996252517417505)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14996464726417505)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14996633731417505)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14996884430417505)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14997059375417505)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14997237815417505)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14997488749417505)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14997658061417505)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14997810824417505)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14998007673417505)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14998231623417505)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100002)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14998418590417505)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14998639817417505)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100002)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14998857708417505)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14999040702417505)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14999262195417505)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14999404601417505)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14999671359417505)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(14999893283417505)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100002)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15000039017417506)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15000282825417506)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15000416248417506)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15000628828417526)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15000870165417526)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15001036691417526)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15001290472417526)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15001441676417526)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15001611652417526)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100002)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15001854229417526)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15002024268417526)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15002215432417526)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15002467653417526)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15002654937417526)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100002)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15002822001417527)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15003002132417527)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15003244625417527)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15003430354417527)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15003645817417527)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15003830422417527)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15004020511417527)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15004241133417527)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15004462801417527)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15004699050417527)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15004809070417527)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15005025124417527)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15005282378417527)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15005452973417527)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15005687693417527)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15005852051417529)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15006007451417529)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15006235386417529)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15006440943417529)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100002)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15006663435417529)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15006874901417529)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15007053267417529)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15007232395417529)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15007404158417530)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15007683078417530)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15007808852417530)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15008042664417530)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15008271042417530)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15008497583417530)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15008651482417530)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15008885310417530)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100002)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15009019440417530)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15009218416417530)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15009416863417530)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15009686111417530)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15009875964417530)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15010021189417530)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15010276831417530)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15010470525417530)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100002)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15010627142417530)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15010862965417530)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15011043897417530)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15011244196417530)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15011447127417531)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15011652228417531)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15011874991417531)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15012020904417531)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15012218581417531)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15012474418417531)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15012613924417531)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100002)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15012872916417531)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15013000443417531)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15013238047417531)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15013487207417531)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15013636459417531)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15013828821417531)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15014090329417531)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15014203307417531)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15014445675417531)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15014609303417531)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15014848601417531)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15015022648417531)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15015235549417531)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15015410847417531)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15015647394417531)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15015889291417532)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15016066929417532)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15016231780417532)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100002)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15016429410417532)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15016623621417532)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15016882680417532)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15017002324417532)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15017252707417532)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15017481285417532)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15017661671417532)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15017860126417532)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15018064584417532)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15018257119417532)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15018488604417532)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15018663466417532)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15018835381417532)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15019069240417532)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100002)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15019225765417532)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15019429297417532)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100002)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15019600383417532)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15019806749417532)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15020033334417533)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15020227680417533)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15020410489417533)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100002)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15020621824417533)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15020841352417533)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15021099285417533)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15021252707417538)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100002)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15021454167417538)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15021636347417538)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15021839986417538)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15022060725417538)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15022271476417538)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15022498571417538)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15022674024417538)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15022887604417538)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100002)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15023067387417538)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100002)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15023237459417538)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15023414503417538)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15023679847417538)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100002)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15023841919417538)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100002)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15024005700417538)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15024265823417538)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15024442115417539)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15024670441417539)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15024879807417539)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15025057273417539)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15025237469417539)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15025491391417539)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15025622356417539)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15025825463417539)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15026035000417539)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15026292567417539)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15026403655417539)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15026649891417539)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15026843241417539)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15027072877417539)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100002)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15027286189417539)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100002)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15027494687417539)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100002)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15027610007417539)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15027809660417539)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15028032416417539)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15028225247417539)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15028458991417539)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15028625054417539)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15028883563417540)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100002)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15029095299417540)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100002)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15029221795417540)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15029498938417540)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15029643743417540)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15029869178417540)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100002)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15030054062417540)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100002)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15030200663417540)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100002)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15030492557417540)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15030688903417540)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100002)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15030828734417540)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15031008183417540)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15031264292417540)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100002)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15031447147417540)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100002)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15031665060417540)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15031890949417540)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100002)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15032051598417540)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15032283472417540)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100002)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15032438399417541)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100002)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15032647662417541)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15032848119417541)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100002)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15033096068417541)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15033224160417541)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100002)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15033468721417541)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100002)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15033614004417541)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100002)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15033879895417541)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100002)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15034083077417541)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100002)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15034299537417541)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100002)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15034486987417541)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100002)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15034613609417541)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15034899254417547)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15035023066417547)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100002)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15035259819417547)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15035411206417547)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15035610523417547)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100002)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15035853980417547)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15036077355417547)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100002)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15036249358417548)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15036422197417548)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100002)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15036658767417548)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100002)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15036894106417548)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15037084176417549)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15037218512417549)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100002)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15037426555417549)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100002)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15037638280417549)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100002)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15037804369417549)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15038003878417549)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100002)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15038225136417549)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100002)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15038467355417549)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100002)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15038601036417549)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100002)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15038812128417549)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15039033631417549)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100002)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15039226206417549)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15039484622417549)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15039661480417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100002)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15039886027417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15040023107417550)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15040235074417550)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15040446948417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100002)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15040632630417550)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100002)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15040896252417550)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100002)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15041020965417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15041281072417550)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15041476659417550)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100002)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15041615808417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15041897455417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100002)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15042056479417550)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15042255786417550)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15042400320417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15042671980417550)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100002)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15042888515417550)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15043096004417550)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15043287357417550)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15043423779417550)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100002)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15043606120417551)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100002)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15043871254417551)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15044057865417551)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15044233047417551)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100002)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15044412256417551)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100002)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15044626809417551)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100002)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15044880341417551)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100002)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15045047068417551)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100002)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15045263385417551)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100002)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15045496041417551)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15045627783417551)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100002)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15045858099417551)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100002)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15046068808417551)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15046208350417551)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100002)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15046460143417551)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100002)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15046672869417551)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15046877045417551)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100002)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15047015760417551)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100002)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15047277095417551)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15047446551417551)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100002)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15047652556417551)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100002)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15047855409417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100002)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15048028450417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15048229980417552)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100002)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15048481751417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15048675761417552)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15048838087417552)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15049071578417552)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100002)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15049203109417552)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100002)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15049433041417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15049680711417552)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15049867577417552)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100002)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15050075710417552)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100002)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15050242259417552)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15050492853417552)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100002)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15050697275417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15050871273417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15051029848417552)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100002)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15051279434417552)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15051430028417552)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100002)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15051618023417552)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15051813439417553)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100002)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15052034506417553)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100002)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15052284057417553)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15052460600417553)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100002)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15052672475417553)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100002)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15052864860417553)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100002)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15053074313417558)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15053256352417558)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15053442425417558)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15053626270417558)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15053888713417558)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100002)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15054023387417558)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100002)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15054204114417558)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100002)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15054468898417558)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15054636371417558)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100002)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15054815838417559)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15055020836417559)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15055221199417559)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15055430116417559)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100002)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15055618190417559)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100002)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15055877803417559)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100002)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15056063301417560)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100002)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15056282643417560)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100002)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15056454800417560)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15056655530417560)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15056896265417560)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15057018727417560)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100002)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15057213179417560)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15057477886417560)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15057606595417560)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100002)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15057803451417560)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15058053295417560)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100002)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15058288103417560)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15058480151417560)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15058673799417560)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100002)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15058895836417561)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15059091159417561)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15059278460417562)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15059478658417562)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100002)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15059614256417562)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15059849512417562)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100002)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15060048623417562)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100002)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15060214071417562)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100002)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15060464750417562)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15060608806417563)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15060892756417563)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15061017507417563)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15061267669417563)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100002)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15061445231417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15061644010417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15061869813417563)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100002)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15062099210417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15062228605417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100002)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15062425990417563)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100002)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15062687911417563)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100002)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15062847517417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15063093356417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15063225570417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100002)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15063422774417563)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100002)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15063683589417564)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15063871148417564)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15064057261417565)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15064255299417565)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100002)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15064426558417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15064691009417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15064836226417565)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100002)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15065013077417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15065276883417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100002)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15065439225417565)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100002)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15065660707417565)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100002)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15065883652417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15066093799417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15066250389417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100002)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15066454956417565)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100002)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15066673622417566)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100002)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15066820456417566)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100002)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15067072506417566)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100002)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15067225586417566)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15067443324417566)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15067625774417566)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15067874449417567)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15068067509417567)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100002)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15068230002417567)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100002)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15068468602417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15068691379417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100002)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15068851795417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100002)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15069093546417567)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100002)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15069207217417567)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15069435276417567)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100002)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15069607196417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15069877500417567)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100002)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15070048038417567)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100002)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15070227558417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100002)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15070443353417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100002)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15070641392417567)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100002)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15070802266417567)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100002)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15071031270417567)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15071221671417567)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100002)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15071445649417567)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15071633868417568)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100002)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15071818746417568)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100002)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15072097233417568)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100002)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15072289689417568)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100002)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15072425152417568)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100002)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15072672927417570)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15072863798417570)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15073004013417570)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100002)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15073234138417570)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15073448768417570)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15073681444417570)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15073800395417570)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15074067015417570)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15074207865417571)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15074482550417571)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15074645227417571)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100002)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15074886719417571)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15075057071417571)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15075201398417571)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15075439899417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15075654157417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100002)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15075848379417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15076047976417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15076248597417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15076484696417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15076690254417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15076836377417572)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15077068829417573)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15077280936417573)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100002)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15077428482417573)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15077662921417573)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100002)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15077829395417573)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100002)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15078037451417574)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100002)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15078203614417574)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100002)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15078454519417574)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15078627080417574)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100002)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15078835138417574)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15079027198417574)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15079230818417574)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100002)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15079463012417574)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100002)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15079615575417574)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100002)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15079818431417574)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100002)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15080032168417574)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15080245559417574)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15080426979417574)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100002)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15080656964417574)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100002)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15080870401417574)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100002)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15081047365417574)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100002)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15081291970417574)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15081468357417574)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100002)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15081612382417574)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100002)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15081834548417574)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100002)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15082094692417574)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15082225286417575)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15082468265417575)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15082686147417575)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100002)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15082812012417575)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100002)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15083044733417575)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15083226924417575)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100002)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15083422130417575)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100002)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15083640653417575)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15083842248417575)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15084028091417575)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15084288412417575)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15084418805417575)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15084650743417575)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15084823493417575)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100002)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15085061736417575)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100002)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15085226961417575)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15085420248417575)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100002)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15085657230417575)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15085813134417575)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100002)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15086037759417575)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100002)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15086283273417576)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15086423794417576)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100002)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15086621222417576)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100002)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15086851576417576)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100002)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15087024631417576)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15087290063417576)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15087459184417576)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15087619466417576)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100002)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15087851186417576)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100002)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15088080468417576)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15088236882417576)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15088424103417576)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15088612218417576)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15088853079417576)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15089016911417576)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15089201591417576)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15089498676417576)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15089686819417576)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15089817345417576)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100002)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15090056239417576)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100002)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15090223203417581)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100002)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15090480594417581)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100002)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15090600615417581)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100002)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15090888890417581)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100002)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15091042062417581)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100002)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15091227691417581)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15091498944417581)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100002)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15091680545417581)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100002)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15091801277417581)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100002)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15092038832417581)
,p_page_id=>5
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100002)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15092204092417581)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100002)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15092457337417581)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100002)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15092608599417581)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15092856420417581)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15093003677417582)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100002)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15093268615417582)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100002)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15093454988417582)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100002)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15093698239417582)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100002)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15093881893417582)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15094086590417582)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100002)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15094269308417582)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100002)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15094453005417582)
,p_page_id=>37
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100002)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15094627863417582)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15094883768417582)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15095038279417582)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15095230541417582)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100002)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15095412618417582)
,p_page_id=>33
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100002)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15095650587417582)
,p_page_id=>11
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15095846809417582)
,p_page_id=>39
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100002)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15096094208417582)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100002)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15096230135417582)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100002)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15096492219417582)
,p_page_id=>50
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100002)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15096627917417582)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100002)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15096802179417582)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100002)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15097040723417582)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100002)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15097255670417582)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15097421015417583)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100002)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15097605695417583)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100002)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15097854013417583)
,p_page_id=>4
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100002)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15098060612417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100002)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15098297936417583)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15098493902417583)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100002)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15098619014417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100002)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15098801293417583)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15099095871417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100002)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15099287463417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100002)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15099405996417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100002)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15099675298417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100002)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15099852796417583)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100002)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15100024804417583)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15100208463417583)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100002)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15100443613417583)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100002)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15100637280417583)
,p_page_id=>13
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100002)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15100833083417583)
,p_page_id=>38
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15101008689417583)
,p_page_id=>1
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100002)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15101210096417583)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100002)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15101478472417584)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15101617649417584)
,p_page_id=>14
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100002)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15101885846417584)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100002)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15102080225417584)
,p_page_id=>30
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100002)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15102299119417584)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100002)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15102485425417584)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100002)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15102666159417588)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15102805937417588)
,p_page_id=>51
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100002)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15103004729417588)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15103209077417588)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15103415181417589)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15103616832417589)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15103834774417589)
,p_page_id=>31
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100002)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15104077014417589)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15104288314417589)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15104401609417589)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15104601165417590)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15104819791417590)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15105079209417590)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15105215333417590)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15105445825417590)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15105610668417590)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15105803081417590)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15106048041417591)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15106274893417591)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15106408796417591)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15106634768417591)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15106838125417591)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15107072333417591)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15107264203417591)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15107406508417592)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15107672701417592)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15107859182417592)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15108073051417592)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15108231098417592)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15108490884417593)
,p_page_id=>6
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100002)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15108621761417594)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15108845249417594)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15109003425417594)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15109210456417594)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15109477404417594)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15109618579417594)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15109849815417594)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15110086317417594)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15110280142417595)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15110460658417595)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15110605256417595)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15110872348417595)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15111070861417595)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15111282827417595)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15111455255417595)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15111662004417596)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15111820946417596)
,p_page_id=>20
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100002)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15112071582417596)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15112258259417596)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15112423988417596)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15112630370417596)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15112800564417597)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15113048713417597)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100002)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15113222427417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100002)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15113432603417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100002)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15113607885417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100002)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15113898458417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100002)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15114015191417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100002)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15114288534417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100002)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15114416563417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100002)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15114692776417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100002)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15114813903417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100002)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Edi\00E7\00E3o, informa\00E7\00F5es de licen\00E7a')
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15115011537417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100002)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15115272052417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100002)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15115418241417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100002)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15115633915417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100002)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15115850925417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15116040296417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100002)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15116230825417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100002)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15116446945417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100002)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15116627990417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100002)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15116888656417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100002)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15117048472417598)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100002)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15117249959417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100002)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15117406220417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100002)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15117674200417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100002)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15117861010417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100002)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15118091600417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100002)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15118201516417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100002)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15118462627417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100002)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15118670780417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100002)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15118888202417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100002)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15119043492417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100002)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15119247816417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100002)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15119458158417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100002)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15119698769417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100002)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15119846088417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15120095549417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100002)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15120293408417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100002)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15120401842417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15120667162417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100002)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15120813204417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15121041870417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100002)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15121208709417599)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100002)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15121474398417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100002)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15121683844417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100002)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15121821544417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100002)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15122034698417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100002)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15122233961417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100002)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15122412577417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100002)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15122646592417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100002)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15122815429417600)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100002)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15123025219417603)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15123275440417604)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nome de usu\00E1rio')
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15123435258417604)
,p_page_id=>9999
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100002)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Senha'
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15123631607417605)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15123838434417605)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15124008376417605)
,p_page_id=>12
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100002)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15124282268417605)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100002)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15124464126417606)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - n\00E3o captura informa\00E7\00F5es do usu\00E1rio sobre a etapa	</li>'),
unistr('    <li><strong>disabled</strong> (padr\00E3o) - captura o id do usu\00E1rio da etapa do processo, conforme conhecido pelo Mecanismo de Fluxo	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15124674041417607)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Deve ser definido como o remetente de e-mail padr\00E3o, caso o e-mail de sa\00EDda serviceTasks n\00E3o tenha um remetente definido.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15124896451417607)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O nome de usu\00E1rio a ser usu\00E1rio na sess\00E3o do APEX para criar uma sess\00E3o se nenhum outro nome de usu\00E1rio for fornecido')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15125087537417607)
,p_page_id=>7
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100002)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Eliminar inst\00E2ncias de processo associadas')
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15125205399417607)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100002)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se deixada em branco, a tarefa ser\00E1 reservada para o usu\00E1rio atual (app_user).')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15125488508417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para temporizadores de ciclo, isso definir\00E1 o n\00FAmero m\00E1ximo de execu\00E7\00E3o.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15125684592417607)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100002)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Formato obrigat\00F3rio: AAAA-MM-DD HH24:MI:SS TZR')
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15125858720417607)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Use esta op\00E7\00E3o apenas para suportar aplicativos que foram desenvolvidos com Flows for APEX 21.1 e inferiores sem desenvolvimento adicional. O mecanismo n\00E3o usa a chave de etapa para evitar a\00E7\00E3o duplicada em uma \00FAnica')
||' etapa.</li>',
unistr('    <li><strong>strict</strong> (recomendado) - Use esta op\00E7\00E3o para novo desenvolvimento e/ou aplicativo totalmente migrado. O mecanismo usa a tecla de etapa para evitar a\00E7\00F5es duplicadas em uma \00FAnica etapa.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15126075477417607)
,p_page_id=>2
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100002)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No caso da c\00F3pia de um \00FAnico modelo, o novo modelo ter\00E1 o nome inserido mas, se voc\00EA tiver selecionado mais de uma linha, ent\00E3o o valor inserido ser\00E1 usado como sufixo.')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15126213703417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma usado para exibir mensagens de erro e eventos de log.'
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15126487885417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong> - Use esta op\00E7\00E3o apenas para suportar aplicativos que foram desenvolvidos com Flows for APEX 21.1 e inferiores sem desenvolvimento adicional. O mecanismo n\00E3o usa a chave de etapa para evitar a\00E7\00E3o duplicada em uma \00FAnica')
||' etapa.</li>',
unistr('    <li><strong>strict</strong> (recomendado) - Use esta op\00E7\00E3o para novo desenvolvimento e/ou aplicativo totalmente migrado. O mecanismo usa a tecla de etapa para evitar a\00E7\00F5es duplicadas em uma \00FAnica etapa.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15126606382417607)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100002)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - o log est\00E1 desativado	</li>'),
unistr('    <li><strong>padr\00E3o</strong> (padr\00E3o) - registra eventos da inst\00E2ncia</li>'),
unistr('    <li><strong>segura</strong> - registra eventos de modelo e eventos de inst\00E2ncia	</li>'),
unistr('    <li><strong>full</strong> - registra eventos vari\00E1veis de modelo, inst\00E2ncia e processo		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15126865552417607)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O ID de um dos seus aplicativos APEX que ser\00E1 fornecido para criar uma sess\00E3o')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15127020646417607)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('O ID da p\00E1gina de um dos seus aplicativos que ser\00E1 fornecido para criar uma sess\00E3o')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15127293539417607)
,p_page_id=>36
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100002)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para temporizadores de ciclo, isso definir\00E1 o n\00FAmero m\00E1ximo de execu\00E7\00E3o.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15127438454417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Deve ser definido como o espa\00E7o de trabalho padr\00E3o do APEX usado para Flows for APEX. Isso \00E9 usado como um \00FAltimo recurso para scriptTasks e serviceTasks ao criar uma sess\00E3o do APEX ou procurar modelos de e-mail')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15127669027417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong> - n\00E3o captura informa\00E7\00F5es do usu\00E1rio sobre a etapa	</li>'),
unistr('    <li><strong>disabled</strong> (padr\00E3o) - captura o id do usu\00E1rio da etapa do processo, conforme conhecido pelo Mecanismo de Fluxo	</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15127877491417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('o nome de usu\00E1rio que ser\00E1 usu\00E1rio na sess\00E3o do APEX para criar uma sess\00E3o se nenhum outro nome de usu\00E1rio for fornecido')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15128078651417607)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100002)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (padr\00E3o) - impede a edi\00E7\00E3o do diagrama para modelos lan\00E7ados</li>'),
unistr('    <li><strong>development</strong> - permite a edi\00E7\00E3o de diagrama para modelos lan\00E7ados</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15128203501417607)
,p_page_id=>32
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100002)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma usado para exibir mensagens de erro e eventos de log.'
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15128430112417608)
,p_page_id=>34
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100002)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (padr\00E3o) - impede a edi\00E7\00E3o do diagrama para modelos lan\00E7ados</li>'),
unistr('    <li><strong>development</strong> - permite a edi\00E7\00E3o de diagrama para modelos lan\00E7ados</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15128612146417608)
,p_page_id=>35
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100002)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Deve ser definido como o espa\00E7o de trabalho padr\00E3o do APEX usado para Flows for APEX. Ele \00E9 usado como um \00FAltimo recurso para scriptTasks e serviceTasks ao criar uma sess\00E3o do APEX ou procurar modelos de e-mail.')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15128845856417608)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('o ID de um dos seus aplicativos APEX que ser\00E1 fornecido para criar uma sess\00E3o')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15129030988417608)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100002)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong> - o log est\00E1 desativado	</li>'),
unistr('    <li><strong>standard</strong> (padr\00E3o) - registra eventos da inst\00E2ncia</li>'),
unistr('    <li><strong>secure</strong> - registra eventos de modelo e eventos de inst\00E2ncia	</li>'),
unistr('    <li><strong>full</strong> - registra eventos vari\00E1veis de modelo, inst\00E2ncia e processo		</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15129240701417608)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100002)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('o ID da p\00E1gina de um dos seus aplicativos que ser\00E1 fornecido para criar uma sess\00E3o')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15129417077417608)
,p_page_id=>100
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100002)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Deve ser definido como o remetente de e-mail padr\00E3o, caso o e-mail de sa\00EDda serviceTasks n\00E3o tenha um remetente definido.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15129610214417610)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100002)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15129850653417610)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias')
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15130074969417610)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'seg'
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15130219980417610)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100002)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15130491666417610)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Erros de Inst\00E2ncias')
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15130673828417610)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erro'
,p_translate_from_text=>'Error'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15130845706417610)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1ximo')
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15131092846417610)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100002)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aguardando-M\00E1x')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15131263330417611)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erros'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15131498922417611)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias Iniciadas')
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15131654664417611)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-90pc'
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15131856241417611)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-10pc'
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15132012670417611)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100002)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15132287532417611)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias Encerradas')
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15132434421417611)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dura\00E7\00E3o de 90pc')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15132628064417611)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100002)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 Percentil'
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15132808935417611)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Percentil 50'
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15133038788417611)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100002)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15133251461417611)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100002)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('S\00E9rie 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15133447199417611)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100002)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Criado'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15133669329417611)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100002)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15133819107417611)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15134039369417611)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100002)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iniciado'
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15134231803417611)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100002)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('S\00E9rie 1')
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15134484717417611)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Percentil 90'
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15134664752417611)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-50pc'
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15134874985417611)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100002)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Em Execu\00E7\00E3o')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15135059020417611)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100002)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15135287510417611)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conclu\00EDdo')
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15135445724417612)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Encerrado'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15135615899417612)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Inst\00E2ncias Conclu\00EDdas')
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15135851915417612)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15136070550417612)
,p_page_id=>16
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100002)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dura\00E7\00E3o da Mediana')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15136220548417612)
,p_page_id=>3
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100002)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15136447416417612)
,p_page_id=>15
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100002)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Redefinir'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15136688192417612)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100002)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15136837775417612)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15137037361417612)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100002)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dura\00E7\00E3o-M\00E1x.')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15137250962417612)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aguardando-M\00E1x')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15137467054417612)
,p_page_id=>17
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100002)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15137671658417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100002)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15137848205417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100002)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15138079308417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100002)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15138208414417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100002)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15138466439417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100002)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15138658863417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100002)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nome'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15138875446417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100002)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Categoria'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15139026199417615)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100002)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Vers\00E3o')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15139291742417616)
,p_translated_flow_id=>100002
,p_translate_to_id=>100.100002
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15139451497417617)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100002)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Erro no processo de Arquivamento de Resumo da Inst\00E2ncia Di\00E1ria')
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15139645920417617)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100002)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erro ao limpar Flows for APEX'
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15139855822417617)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100002)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Erro ao expurgar tabelas de log.'
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15140060975417617)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100002)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Erro ao coletar Flows for APEX'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15140290063417617)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15140421868417618)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15140666527417618)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100002)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15140824502417619)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>6.100005
,p_translate_from_id=>6
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15141047097417619)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>50.100005
,p_translate_from_id=>50
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Plantillas de formulario simple'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15141241506417619)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>14.100005
,p_translate_from_id=>14
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Logs'
,p_translate_from_text=>'Logs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15141409943417619)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>51.100005
,p_translate_from_id=>51
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Editar plantilla de formulario simple'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15141688485417619)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>1.100005
,p_translate_from_id=>1
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Introducci\00F3n')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15141826659417619)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>7.100005
,p_translate_from_id=>7
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flujo'
,p_translate_from_text=>'Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15142008709417620)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>15.100005
,p_translate_from_id=>15
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas diarias')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15142222945417620)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>31.100005
,p_translate_from_id=>31
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - REST - Cliente')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15142422901417620)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>36.100005
,p_translate_from_id=>36
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Temporizadores')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15142696175417620)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>34.100005
,p_translate_from_id=>34
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Aplicaci\00F3n de motor')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15142888301417620)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>11.100005
,p_translate_from_id=>11
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear instancia de flujo'
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15143060832417620)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>30.100005
,p_translate_from_id=>30
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15143213875417620)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>2.100005
,p_translate_from_id=>2
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesti\00F3n de flujo')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15143444119417620)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>8.100005
,p_translate_from_id=>8
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Detalles de instancia de flujo'
,p_translate_from_text=>'Flow Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15143662769417620)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>12.100005
,p_translate_from_id=>12
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Visor'
,p_translate_from_text=>'Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15143837419417620)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>17.100005
,p_translate_from_id=>17
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas de tarea')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15144010904417620)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>37.100005
,p_translate_from_id=>37
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Estad\00EDsticas')
,p_translate_from_text=>'Configuration - Statistics'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15144267909417620)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>4.100005
,p_translate_from_id=>4
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelador de flujo'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15144462930417620)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>5.100005
,p_translate_from_id=>5
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15144658906417620)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>10.100005
,p_translate_from_id=>10
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Supervisi\00F3n de flujo')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15144833814417620)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>35.100005
,p_translate_from_id=>35
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Motor')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15145047239417620)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>33.100005
,p_translate_from_id=>33
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Archivado')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15145250035417620)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>3.100005
,p_translate_from_id=>3
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Panel de control'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15145437709417620)
,p_page_id=>9
,p_translated_flow_id=>100005
,p_translate_to_id=>9.100005
,p_translate_from_id=>9
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15145677445417620)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>20.100005
,p_translate_from_id=>20
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cronolog\00EDa de instancia: &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15145840066417620)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>38.100005
,p_translate_from_id=>38
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Ubicaci\00F3n')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15146085144417620)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>13.100005
,p_translate_from_id=>13
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Detalles de objeto'
,p_translate_from_text=>'Object Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15146218821417620)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>39.100005
,p_translate_from_id=>39
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Licencia')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15146419081417621)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>16.100005
,p_translate_from_id=>16
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas de proceso')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15146608526417621)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>32.100005
,p_translate_from_id=>32
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Registro')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15146808505417621)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>100.100005
,p_translate_from_id=>100
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n [OLD,BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15147058927417621)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>9999.100005
,p_translate_from_id=>9999
,p_translate_column_id=>5
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('P\00E1gina de conexi\00F3n')
,p_translate_from_text=>'Login Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15147209595417623)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>6.100005
,p_translate_from_id=>6
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar: &APP_NAME_TITLE.'
,p_translate_from_text=>'Import - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15147478924417623)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>50.100005
,p_translate_from_id=>50
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Plantillas de formulario simple'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15147675560417623)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>51.100005
,p_translate_from_id=>51
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Editar plantilla de formulario simple'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15147803186417623)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>1.100005
,p_translate_from_id=>1
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Introducci\00F3n - &APP_NAME_TITLE.')
,p_translate_from_text=>'Getting Started - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15148068262417623)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>7.100005
,p_translate_from_id=>7
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flujo: &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15148205568417623)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>15.100005
,p_translate_from_id=>15
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas diarias')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15148484270417623)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>31.100005
,p_translate_from_id=>31
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - REST - Cliente')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15148622461417623)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>36.100005
,p_translate_from_id=>36
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Temporizadores')
,p_translate_from_text=>'Configuration - Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15148824044417623)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>34.100005
,p_translate_from_id=>34
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Aplicaci\00F3n de motor')
,p_translate_from_text=>'Configuration - Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15149063976417623)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>11.100005
,p_translate_from_id=>11
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear instancia de flujo: &APP_NAME_TITLE.'
,p_translate_from_text=>'Create Flow Instance - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15149283847417624)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>30.100005
,p_translate_from_id=>30
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - REST')
,p_translate_from_text=>'Configuration - REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15149484082417624)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>2.100005
,p_translate_from_id=>2
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesti\00F3n de flujos - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Management - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15149632947417624)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>8.100005
,p_translate_from_id=>8
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Detalles de instancia de flujo - &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Instance Details  - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15149838745417624)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>12.100005
,p_translate_from_id=>12
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Supervisi\00F3n de flujo - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15150050718417624)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>17.100005
,p_translate_from_id=>17
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas de tarea')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15150201665417624)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>37.100005
,p_translate_from_id=>37
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Estad\00EDsticas')
,p_translate_from_text=>'Configuration - Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15150451577417624)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>4.100005
,p_translate_from_id=>4
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelador de flujo: &APP_NAME_TITLE.'
,p_translate_from_text=>'Flow Modeler - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15150636682417624)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>5.100005
,p_translate_from_id=>5
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar: &APP_NAME_TITLE.'
,p_translate_from_text=>'Export - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15150828473417624)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>10.100005
,p_translate_from_id=>10
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Supervisi\00F3n de flujo - &APP_NAME_TITLE.')
,p_translate_from_text=>'Flow Monitor - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15151011287417624)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>35.100005
,p_translate_from_id=>35
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Motor')
,p_translate_from_text=>'Configuration - Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15151201993417624)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>33.100005
,p_translate_from_id=>33
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Archivado')
,p_translate_from_text=>'Configuration - Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15151424823417624)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>3.100005
,p_translate_from_id=>3
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Panel de control - &APP_NAME_TITLE.'
,p_translate_from_text=>'Dashboard - &APP_NAME_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15151689912417624)
,p_page_id=>9
,p_translated_flow_id=>100005
,p_translate_to_id=>9.100005
,p_translate_from_id=>9
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15151864284417624)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>20.100005
,p_translate_from_id=>20
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cronolog\00EDa de instancia: &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15152071941417624)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>38.100005
,p_translate_from_id=>38
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Ubicaci\00F3n')
,p_translate_from_text=>'Configuration - Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15152291769417624)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>39.100005
,p_translate_from_id=>39
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Licencia')
,p_translate_from_text=>'Configuration - License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15152474298417624)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>16.100005
,p_translate_from_id=>16
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas de proceso')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15152616383417624)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>32.100005
,p_translate_from_id=>32
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Registro')
,p_translate_from_text=>'Configuration - Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15152822760417624)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>100.100005
,p_translate_from_id=>100
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n [OLD,BACKUP]')
,p_translate_from_text=>'Configuration [OLD,BACKUP]'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15153083448417624)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>9999.100005
,p_translate_from_id=>9999
,p_translate_column_id=>6
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15153295927417627)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5955186680464411.100005)
,p_translate_from_id=>wwv_flow_imp.id(5955186680464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seleccionar todo'
,p_translate_from_text=>'Select all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15153372041417627)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5977760271464469.100005)
,p_translate_from_id=>wwv_flow_imp.id(5977760271464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Definir ruta de gateway'
,p_translate_from_text=>'Set Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15153565599417627)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2339755735104535.100005)
,p_translate_from_id=>wwv_flow_imp.id(2339755735104535)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15153715808417627)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3273384211238364.100005)
,p_translate_from_id=>wwv_flow_imp.id(3273384211238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15153926487417627)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938283749499705.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938283749499705)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15154140164417627)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5954728604464411.100005)
,p_translate_from_id=>wwv_flow_imp.id(5954728604464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Desmarcar todo'
,p_translate_from_text=>'Unselect all'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15154352282417627)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5982997862464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5982997862464473)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Agregar'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15154599326417627)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5976915633464468.100005)
,p_translate_from_id=>wwv_flow_imp.id(5976915633464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Definir variable de proceso'
,p_translate_from_text=>'Set Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15154746800417627)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3220853426231712.100005)
,p_translate_from_id=>wwv_flow_imp.id(3220853426231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15154924822417627)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3273786813238364.100005)
,p_translate_from_id=>wwv_flow_imp.id(3273786813238364)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n de REST')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15155133244417627)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522753745864948.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522753745864948)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15155311782417627)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19019773259332915.100005)
,p_translate_from_id=>wwv_flow_imp.id(19019773259332915)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar y editar'
,p_translate_from_text=>'Import and edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15155587363417627)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2342112923104539.100005)
,p_translate_from_id=>wwv_flow_imp.id(2342112923104539)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15155707310417627)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3307218597301243.100005)
,p_translate_from_id=>wwv_flow_imp.id(3307218597301243)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15155938813417627)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215404585956138.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215404585956138)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nueva versi\00F3n')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15156164737417628)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7067605023119721.100005)
,p_translate_from_id=>wwv_flow_imp.id(7067605023119721)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15156380770417628)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404258251171428.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404258251171428)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15156540457417628)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511050226851723.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511050226851723)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Recibir mensaje'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15156775961417628)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5596037362964020.100005)
,p_translate_from_id=>wwv_flow_imp.id(5596037362964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15156980723417628)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26009257493877978.100005)
,p_translate_from_id=>wwv_flow_imp.id(26009257493877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15157193969417628)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865858754262840.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865858754262840)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15157380729417628)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100005)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suprimir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15157546671417628)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5595617458964020.100005)
,p_translate_from_id=>wwv_flow_imp.id(5595617458964020)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15157776457417628)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24212654778956110.100005)
,p_translate_from_id=>wwv_flow_imp.id(24212654778956110)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear modelo'
,p_translate_from_text=>'Create Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15157920726417628)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4723087919681905.100005)
,p_translate_from_id=>wwv_flow_imp.id(4723087919681905)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15158160937417628)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3745589259530319.100005)
,p_translate_from_id=>wwv_flow_imp.id(3745589259530319)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Guardar'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15158333032417628)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7937992279499702.100005)
,p_translate_from_id=>wwv_flow_imp.id(7937992279499702)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15158580451417628)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19019657971332914.100005)
,p_translate_from_id=>wwv_flow_imp.id(19019657971332914)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar e importar otro'
,p_translate_from_text=>'Import and import another'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15158799894417628)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3337626931771697.100005)
,p_translate_from_id=>wwv_flow_imp.id(3337626931771697)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15158935507417628)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938939101499712.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938939101499712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copiar modelo'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15159151817417628)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3309455839322446.100005)
,p_translate_from_id=>wwv_flow_imp.id(3309455839322446)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15159379677417628)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3336931358771696.100005)
,p_translate_from_id=>wwv_flow_imp.id(3336931358771696)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15159544398417628)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495492448748879893.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495492448748879893)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Iniciar sesi\00F3n')
,p_translate_from_text=>'Sign In'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15159717572417628)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3138033307214457.100005)
,p_translate_from_id=>wwv_flow_imp.id(3138033307214457)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15159934306417628)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3221271791231712.100005)
,p_translate_from_id=>wwv_flow_imp.id(3221271791231712)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n de REST')
,p_translate_from_text=>'REST Config'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15160163559417628)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215581832956139.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215581832956139)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Liberar'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15160396832417629)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5600473513964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5600473513964022)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear plantilla'
,p_translate_from_text=>'Create Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15160528453417629)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26091600150304603.100005)
,p_translate_from_id=>wwv_flow_imp.id(26091600150304603)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modificar diagrama'
,p_translate_from_text=>'Modify Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15160762324417629)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3192334722229270.100005)
,p_translate_from_id=>wwv_flow_imp.id(3192334722229270)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15160901226417629)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26067817325227237.100005)
,p_translate_from_id=>wwv_flow_imp.id(26067817325227237)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Agregar versi\00F3n')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15161131126417629)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018929080332907.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018929080332907)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15161378532417629)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522981517864950.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522981517864950)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15161567707417629)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34569800907098125.100005)
,p_translate_from_id=>wwv_flow_imp.id(34569800907098125)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15161799668417629)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215790121956141.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215790121956141)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivo'
,p_translate_from_text=>'Archive'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15161946717417629)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511139234851724.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511139234851724)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15162196236417629)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15683484308738625.100005)
,p_translate_from_id=>wwv_flow_imp.id(15683484308738625)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15162370117417629)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6179972139209944.100005)
,p_translate_from_id=>wwv_flow_imp.id(6179972139209944)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15162573569417629)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3310158364323358.100005)
,p_translate_from_id=>wwv_flow_imp.id(3310158364323358)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15162765368417629)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601866805220616.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601866805220616)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15162926314417629)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6431406612417624.100005)
,p_translate_from_id=>wwv_flow_imp.id(6431406612417624)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar historial'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15163195525417629)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5978892614464469.100005)
,p_translate_from_id=>wwv_flow_imp.id(5978892614464469)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15163328090417629)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491866636991262848.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491866636991262848)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear instancia'
,p_translate_from_text=>'Create instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15163575211417629)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2341363963104538.100005)
,p_translate_from_id=>wwv_flow_imp.id(2341363963104538)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suprimir'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15163782200417629)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3164119045223081.100005)
,p_translate_from_id=>wwv_flow_imp.id(3164119045223081)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15163986772417629)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3311591865325268.100005)
,p_translate_from_id=>wwv_flow_imp.id(3311591865325268)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15164162314417629)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5593882060964019.100005)
,p_translate_from_id=>wwv_flow_imp.id(5593882060964019)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15164353705417629)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5954353112464407.100005)
,p_translate_from_id=>wwv_flow_imp.id(5954353112464407)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15164511659417629)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215607769956140.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215607769956140)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Declarar obsoleto'
,p_translate_from_text=>'Deprecate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15164700951417629)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981427830464471.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981427830464471)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservar'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15164975369417630)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26400953036736995.100005)
,p_translate_from_id=>wwv_flow_imp.id(26400953036736995)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Agregar versi\00F3n')
,p_translate_from_text=>'Add Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15165143916417630)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2353415432104550.100005)
,p_translate_from_id=>wwv_flow_imp.id(2353415432104550)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15165353552417630)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512936201851742.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512936201851742)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Editar configuraci\00F3n')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15165518476417630)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3310860026324035.100005)
,p_translate_from_id=>wwv_flow_imp.id(3310860026324035)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15165700339417630)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5982517441464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5982517441464472)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Aplicar cambios'
,p_translate_from_text=>'Apply Changes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15165925307417630)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707677337232546.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707677337232546)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar temporizador'
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15166105801417630)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403897960171424.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403897960171424)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15166377962417630)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26068946058228467.100005)
,p_translate_from_id=>wwv_flow_imp.id(26068946058228467)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15166549323417630)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6178284555209927.100005)
,p_translate_from_id=>wwv_flow_imp.id(6178284555209927)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Confirmar'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15166726339417630)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3791980243921403.100005)
,p_translate_from_id=>wwv_flow_imp.id(3791980243921403)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Editar configuraci\00F3n')
,p_translate_from_text=>'Edit Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15166923471417630)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5955586107464411.100005)
,p_translate_from_id=>wwv_flow_imp.id(5955586107464411)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Agregar'
,p_translate_from_text=>'Add'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15167150456417630)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26009611434877978.100005)
,p_translate_from_id=>wwv_flow_imp.id(26009611434877978)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Crear'
,p_translate_from_text=>'Create'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15167314777417630)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3745670019530320.100005)
,p_translate_from_id=>wwv_flow_imp.id(3745670019530320)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cancelar'
,p_translate_from_text=>'Cancel'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15167502493417630)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068041536119722.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068041536119722)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Confirmar'
,p_translate_from_text=>'Confirm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15167783431417630)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5963945833464455.100005)
,p_translate_from_id=>wwv_flow_imp.id(5963945833464455)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15167991992417630)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5977391209464468.100005)
,p_translate_from_id=>wwv_flow_imp.id(5977391209464468)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15168155518417630)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2361808004158404.100005)
,p_translate_from_id=>wwv_flow_imp.id(2361808004158404)
,p_translate_column_id=>13
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Guardar'
,p_translate_from_text=>'Save'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15168380813417636)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5595272506964020.100005)
,p_translate_from_id=>wwv_flow_imp.id(5595272506964020)
,p_translate_column_id=>13.1
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_translate_from_text=>'&APP_TEXT$DELETE_MSG!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15168564264417636)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ocultar ID de usuario'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15168795119417636)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Columna de ID'
,p_translate_from_text=>'Id Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15168901099417636)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Clave de licencia'
,p_translate_from_text=>'License Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15169197606417636)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Columna de registro de hora'
,p_translate_from_text=>'Timestamp Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15169394478417636)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL base'
,p_translate_from_text=>'Base URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15169549367417636)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100005)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nueva versi\00F3n')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15169728125417637)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Carga \00FAtil')
,p_translate_from_text=>'Payload'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15169946915417637)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100005)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Conexi\00F3n')
,p_translate_from_text=>'Connection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15170174019417637)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Remitente de correo electr\00F3nico predeterminado')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15170385719417637)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte Id'
,p_translate_from_text=>'Sfte Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15170548890417637)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama de llamada'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15170725708417637)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15170966130417637)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de usuario por defecto'
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15171107918417637)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15171330860417637)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15171501424417637)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Intervalo de repetici\00F3n de temporizador')
,p_translate_from_text=>'Timer Repeat Interval'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15171782687417637)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de archivo'
,p_translate_from_text=>'File Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15171997131417637)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035771457569036.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035771457569036)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Paso'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15172144025417637)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de cubo'
,p_translate_from_text=>'Bucket Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15172351000417637)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100005)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Edici\00F3n de licencia')
,p_translate_from_text=>'License Edition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15172562999417637)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100005)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar desde'
,p_translate_from_text=>'Import From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15172775849417637)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035670797569035.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035670797569035)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Operaci\00F3n')
,p_translate_from_text=>'Operation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15172987051417637)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15173113403417637)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15173373577417637)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prefijo de documento'
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15173571347417638)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fecha'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15173721404417638)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuevo'
,p_translate_from_text=>'New'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15173938749417638)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100005)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Forzar sobrescritura'
,p_translate_from_text=>'Force Overwrite'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15174198310417638)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15174331794417638)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ciclos m\00E1ximos de temporizador')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15174569240417638)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Categor\00EDa')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15174757589417638)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15174929015417638)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036173097569040.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036173097569040)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Realizado por'
,p_translate_from_text=>'Performed By'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15175179695417638)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de tabla'
,p_translate_from_text=>'Table Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15175311625417638)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Incluir fecha de \00FAltimo cambio')
,p_translate_from_text=>'Include Last Change Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15175567140417638)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15175783802417638)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100005)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Puerta de enlace'
,p_translate_from_text=>'Gateway'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15175922629417638)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retener res\00FAmenes mensuales (meses)')
,p_translate_from_text=>'Retain Monthly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15176158864417638)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retenci\00F3n de log de flujo de mensajes (d\00EDas)')
,p_translate_from_text=>'Message Flow Log Retention (Days) (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15176332819417638)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100005)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cascada'
,p_translate_from_text=>'Cascade'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15176533585417638)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100005)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15176785285417638)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel de proceso'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15176956819417638)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15177180840417638)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Contrase\00F1a')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15177387643417638)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retener logs (d\00EDas)')
,p_translate_from_text=>'Retain Logs (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15177560082417638)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15177718598417638)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Xml de diagrama'
,p_translate_from_text=>'Diagram Xml'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15177950350417638)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Incluir versi\00F3n')
,p_translate_from_text=>'Include Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15178113384417639)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivo'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15178340011417639)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar temporizador a las'
,p_translate_from_text=>'Reschedule timer at'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15178593795417639)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ubicaci\00F3n de archivo de instancia')
,p_translate_from_text=>'Instance Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15178730451417639)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15178987751417639)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descargar como'
,p_translate_from_text=>'Download As'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15179132023417639)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15179323547417639)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035831132569037.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035831132569037)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variable de proceso'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15179537386417639)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Secreto de cliente'
,p_translate_from_text=>'Client Secret'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15179790803417639)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Prevenci\00F3n de pasos duplicados')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15179917033417639)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nuevo nombre/sufijo'
,p_translate_from_text=>'New Name/Suffix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15180164812417639)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID est\00E1tico de credencial de APEX')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15180337632417639)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15180571046417639)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID est\00E1tico')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15180740130417639)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100005)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Propietario'
,p_translate_from_text=>'Owner'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15180973420417639)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Con licencia para'
,p_translate_from_text=>'Licensed To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15181177081417639)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Prevenci\00F3n de pasos duplicados')
,p_translate_from_text=>'Duplicate Step Prevention'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15181360312417639)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15181577197417639)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de aplicaci\00F3n por defecto')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15181701608417639)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de p\00E1gina por defecto')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15181984500417639)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de usuario'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15182186054417639)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C1mbito')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15182305768417640)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Referencia de negocio (variable de proceso)'
,p_translate_from_text=>'Business Reference (Process Variable)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15182520218417640)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Incluir categor\00EDa')
,p_translate_from_text=>'Include Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15182776481417640)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registrar entrada MessageFlow'
,p_translate_from_text=>'Log Inbound MessageFlow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15182962628417640)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100005)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ciclos m\00E1ximos de temporizador')
,p_translate_from_text=>'Timer Max Cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15183180930417640)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de destino'
,p_translate_from_text=>'Destination Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15183344423417640)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15183581537417640)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15183741790417640)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Pegar contenido de archivo BPMN (30 000 caracteres como m\00E1ximo)')
,p_translate_from_text=>'Paste  BPMN file content (30 000 characters max.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15183924853417640)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Espacio de trabajo por defecto'
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15184123688417640)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retener res\00FAmenes diarios (d\00EDas)')
,p_translate_from_text=>'Retain Daily Summaries (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15184346966417640)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ocultar ID de usuario'
,p_translate_from_text=>'Hide User ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15184505274417640)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registrar entrada MessageFlow'
,p_translate_from_text=>'Log Inbound MessageFlow (not yet implemented)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15184704852417640)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retener logs (d\00EDas tras finalizaci\00F3n de instancia de proceso)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15184917124417640)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de usuario por defecto'
,p_translate_from_text=>'Default Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15185105498417640)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID est\00E1tico de credencial de APEX')
,p_translate_from_text=>'APEX Credential Static Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15185361465417640)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores activados'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15185510891417640)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Columna Blob'
,p_translate_from_text=>'Blob Column'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15185722517417640)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100005)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fecha de caducidad de licencia'
,p_translate_from_text=>'License Expiry Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15185954189417640)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15186128935417640)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Registrar llamadas entrantes de restauraci\00F3n')
,p_translate_from_text=>'Log Incoming Rest Calls'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15186353034417640)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('URI de redirecci\00F3n')
,p_translate_from_text=>'Redirect Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15186577257417641)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('URL de autorizaci\00F3n previa')
,p_translate_from_text=>'Pre Auth URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15186721613417641)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100005)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo'
,p_translate_from_text=>'Mode'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15186971322417641)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retener logs (d\00EDas tras finalizaci\00F3n de instancia de proceso)')
,p_translate_from_text=>'Retain Logs (Days after Process Instance Completion)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15187178839417641)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI de soporte'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15187353528417641)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Incluir estado'
,p_translate_from_text=>'Include Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15187569800417641)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15187747010417641)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100005)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma'
,p_translate_from_text=>'Language'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15187964025417641)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prefijo de documento'
,p_translate_from_text=>'Document Prefix'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15188152491417641)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Activar archivado de resumen de instancias'
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15188361647417641)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15188577831417641)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de aplicaci\00F3n por defecto')
,p_translate_from_text=>'Default Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15188768779417641)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15188976027417641)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100005)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo'
,p_translate_from_text=>'Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15189125651417641)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Recordar nombre de usuario'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15189304434417641)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15189509573417641)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Espacio de trabajo por defecto'
,p_translate_from_text=>'Default Workspace'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15189777025417641)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar temporizador ahora'
,p_translate_from_text=>'Reschedule timer now'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15189955065417641)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retenci\00F3n de log de flujo de mensajes (d\00EDas)')
,p_translate_from_text=>'Message Flow Log Retention (Days)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15190118322417641)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15190345050417641)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descripci\00F3n')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15190531984417641)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15190779735417641)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15190970287417642)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Retener res\00FAmenes trimestrales (meses)')
,p_translate_from_text=>'Retain Quarterly Summaries (Months)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15191124750417642)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de variable'
,p_translate_from_text=>'Variable Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15191306944417642)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de cliente'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15191559973417642)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de p\00E1gina por defecto')
,p_translate_from_text=>'Default Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15191786859417642)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100005)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL base'
,p_translate_from_text=>'Base-URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15191926176417642)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Correo de ayuda'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15192174582417642)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores activados'
,p_translate_from_text=>'Timers Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15192300216417642)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15192500834417642)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100005)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nueva versi\00F3n')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15192777625417642)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Categor\00EDa')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15192958899417642)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Buscar'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15193175271417642)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100005)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15193394732417642)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Activar archivado de resumen de instancias'
,p_translate_from_text=>'Enable Instance Summary Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15193563024417642)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>14
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Remitente de correo electr\00F3nico predeterminado')
,p_translate_from_text=>'Default Email Sender'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15193768942417665)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5571393661899135.100005)
,p_translate_from_id=>wwv_flow_imp.id(5571393661899135)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Formato JSON no v\00E1lido')
,p_translate_from_text=>'Invalid JSON format'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15193966987417665)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15356707920942515.100005)
,p_translate_from_id=>wwv_flow_imp.id(15356707920942515)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# debe tener un valor.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15194184039417665)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19019544229332913.100005)
,p_translate_from_id=>wwv_flow_imp.id(19019544229332913)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Compruebe el flujo proporcionado.'
,p_translate_from_text=>'Please check the flow provided.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15194342849417665)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633648852575838.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633648852575838)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15194593500417665)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15356651838942514.100005)
,p_translate_from_id=>wwv_flow_imp.id(15356651838942514)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#LABEL# debe tener un valor.'
,p_translate_from_text=>'#LABEL# must have a value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15194710231417665)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633545177575837.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633545177575837)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_translate_from_text=>'#LABEL# must have some value.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15194995121417665)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516446869355429.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516446869355429)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No puede archivar un modelo asociado a instancias en ejecuci\00F3n.')
,p_translate_from_text=>'You cannot archived a model which is associated with running instances.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15195175582417665)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19023151364332949.100005)
,p_translate_from_id=>wwv_flow_imp.id(19023151364332949)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pegue el contenido del archivo BPMN'
,p_translate_from_text=>'Please paste BPMN file content'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15195387562417665)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19023037485332948.100005)
,p_translate_from_id=>wwv_flow_imp.id(19023037485332948)
,p_translate_column_id=>16
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Seleccione un #LABEL#.'
,p_translate_from_text=>'Please select a #LABEL#.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15195518747417666)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'El modelo ya existe. Usar sobrescritura forzada.'
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15195704974417666)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>17
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'El modelo ya existe. Usar sobrescritura forzada.'
,p_translate_from_text=>'Model already exists. Use force overwrite.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15195927647417667)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633718670575839.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633718670575839)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo importado.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15196153199417667)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3176434129223085.100005)
,p_translate_from_id=>wwv_flow_imp.id(3176434129223085)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15196366549417667)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3285684485238370.100005)
,p_translate_from_id=>wwv_flow_imp.id(3285684485238370)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15196561044417667)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3233135486231716.100005)
,p_translate_from_id=>wwv_flow_imp.id(3233135486231716)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15196782672417667)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3339267970771698.100005)
,p_translate_from_id=>wwv_flow_imp.id(3339267970771698)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15196972553417667)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7939199045499714.100005)
,p_translate_from_id=>wwv_flow_imp.id(7939199045499714)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_MODEL_COPIED.'
,p_translate_from_text=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15197102704417667)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4723167093681906.100005)
,p_translate_from_id=>wwv_flow_imp.id(4723167093681906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n de Rest guardada')
,p_translate_from_text=>'Rest Configuration saved!'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15197311017417667)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094153642304628.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094153642304628)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
,p_translate_from_text=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15197503752417667)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3150354905214473.100005)
,p_translate_from_id=>wwv_flow_imp.id(3150354905214473)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15197790137417667)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3204611384229276.100005)
,p_translate_from_id=>wwv_flow_imp.id(3204611384229276)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15197921625417667)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3257766356234742.100005)
,p_translate_from_id=>wwv_flow_imp.id(3257766356234742)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Se han guardado los cambios.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15198191064417667)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(22799930478488038.100005)
,p_translate_from_id=>wwv_flow_imp.id(22799930478488038)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Acci\00F3n procesada.')
,p_translate_from_text=>'Action processed.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15198358001417667)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100005)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
,p_translate_from_text=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15198591012417667)
,p_page_id=>9
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8026807639825637.100005)
,p_translate_from_id=>wwv_flow_imp.id(8026807639825637)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cambios guardados.'
,p_translate_from_text=>'Changes saved.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15198730291417667)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018865821332906.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018865821332906)
,p_translate_column_id=>18
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo importado.'
,p_translate_from_text=>'Model imported.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15198984979417669)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100005)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventos de instancia'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15199106769417669)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100005)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Motor'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15199389169417669)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100005)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Detalles de instancia'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15199557968417669)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100005)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventos de instancia'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15199771895417669)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100005)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Clientes OAUTH'
,p_translate_from_text=>'OAUTH Clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15199956859417669)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24202222744578370.100005)
,p_translate_from_id=>wwv_flow_imp.id(24202222744578370)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15200193405417669)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6432353612417633.100005)
,p_translate_from_id=>wwv_flow_imp.id(6432353612417633)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Row Actions'
,p_translate_from_text=>'Variables - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15200385886417669)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100005)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15200533135417669)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100005)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configuraci\00F3n - REST - Cliente')
,p_translate_from_text=>'Configuration - REST - Client'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15200780335417669)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40001574962317105.100005)
,p_translate_from_id=>wwv_flow_imp.id(40001574962317105)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Header Action Menu'
,p_translate_from_text=>'Header Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15200942192417669)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Rendimiento de proceso (res\00FAmenes de per\00EDodos)')
,p_translate_from_text=>'Process Performance (Period Summaries)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15201164089417669)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100005)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflujos actuales'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15201347031417669)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100005)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Barra de botones'
,p_translate_from_text=>'Button Bar'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15201556659417669)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100005)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Historial de variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15201755278417669)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100005)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configuraci\00F3n de JSON')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15201969034417669)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100005)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15202127531417669)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventos de paso'
,p_translate_from_text=>'Step Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15202344883417669)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Plantillas de formulario simple'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15202523259417669)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19992522503359785.100005)
,p_translate_from_id=>wwv_flow_imp.id(19992522503359785)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15202713761417669)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancias de flujo por estado'
,p_translate_from_text=>'Flow Instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15202933006417670)
,p_page_id=>9
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3286177375239502.100005)
,p_translate_from_id=>wwv_flow_imp.id(3286177375239502)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Secciones'
,p_translate_from_text=>'Sections'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15203162192417670)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100005)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Pasos finalizados'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15203375475417670)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Buscar'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15203583405417670)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Detalles de diagrama'
,p_translate_from_text=>'Diagram Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15203751947417670)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Suscripciones de mensajes'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15203969628417670)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100005)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagramas Llamados'
,p_translate_from_text=>'Called Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15204125943417670)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24201499202577457.100005)
,p_translate_from_id=>wwv_flow_imp.id(24201499202577457)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15204393800417670)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(27538437580351975.100005)
,p_translate_from_id=>wwv_flow_imp.id(27538437580351975)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15204586766417670)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100005)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Introducci\00F3n')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15204729312417670)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681250057037012.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681250057037012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancia de flujo'
,p_translate_from_text=>'Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15204903396417670)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Crear instancia de flujo'
,p_translate_from_text=>'Create Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15205194417417670)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100005)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Discrepancia de versiones'
,p_translate_from_text=>'Version mismatch'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15205353012417670)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100005)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Flujo de importaci\00F3n')
,p_translate_from_text=>'Import Flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15205544360417670)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2541571424137177.100005)
,p_translate_from_id=>wwv_flow_imp.id(2541571424137177)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15205770463417670)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Faltan requisitos previos'
,p_translate_from_text=>'Prerequisites missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15205903065417670)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100005)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Botones'
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15206154190417670)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100005)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Nueva versi\00F3n')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15206309833417670)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2033643917569015.100005)
,p_translate_from_id=>wwv_flow_imp.id(2033643917569015)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Resultados de la b\00FAsqueda')
,p_translate_from_text=>'Search Results'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15206579247417670)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100005)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aplicaci\00F3n de motor')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15206796934417670)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100005)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Estad\00EDsticas')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15206936442417670)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100005)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Aplicaci\00F3n de motor')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15207132299417670)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036577010569044.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036577010569044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Errores de instancia en los \00FAltimos 14 d\00EDas')
,p_translate_from_text=>'Instance Errors in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15207386658417671)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100005)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configuraci\00F3n de JSON')
,p_translate_from_text=>'JSON Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15207585749417671)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34634863225575850.100005)
,p_translate_from_id=>wwv_flow_imp.id(34634863225575850)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Row Action Menu'
,p_translate_from_text=>'Row Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15207724018417671)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visor de flujo'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15207936869417671)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100005)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15208136222417671)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512217433851735.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512217433851735)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ubicaci\00F3n')
,p_translate_from_text=>'Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15208332168417671)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100005)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Opciones'
,p_translate_from_text=>'Options'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15208552416417671)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100005)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Agregar ruta de gateway'
,p_translate_from_text=>'Add Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15208726288417671)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100005)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Diagrama llamado'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15208987075417671)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100005)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Motor'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15209140092417671)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100005)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Enlaces'
,p_translate_from_text=>'Links'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15209352154417671)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15209508571417671)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938399981499706.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938399981499706)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15209708356417671)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402779943171413.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402779943171413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15209919361417671)
,p_page_id=>9
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17585395174953770.100005)
,p_translate_from_id=>wwv_flow_imp.id(17585395174953770)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15210150128417671)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Falta el m\00F3dulo')
,p_translate_from_text=>'Module missing'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15210384531417671)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Task List Entries'
,p_translate_from_text=>'Task List Entries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15210512875417671)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433033616417640.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433033616417640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables - Header Actions'
,p_translate_from_text=>'Variables - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15210764552417671)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100005)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancias de flujo'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15210926098417671)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Contenedor de botones'
,p_translate_from_text=>'Buttons Container'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15211117522417671)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(20892351125255012.100005)
,p_translate_from_id=>wwv_flow_imp.id(20892351125255012)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15211360459417671)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Copiar modelo'
,p_translate_from_text=>'Copy Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15211542289417671)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('\00DAltimo error')
,p_translate_from_text=>'Last Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15211734748417672)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100005)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Tiempos de espera de paso hist\00F3rico para &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15211918059417672)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100005)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15212108608417672)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100005)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflujos completados'
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15212317584417672)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100005)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Pasos actuales'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15212544383417672)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visor de flujo'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15212709087417672)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100005)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Registro'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15212994391417672)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100005)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Archivado'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15213181455417672)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100005)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Gesti\00F3n de flujo')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15213385957417672)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7937843762499701.100005)
,p_translate_from_id=>wwv_flow_imp.id(7937843762499701)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15213527258417672)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(13891898475964091.100005)
,p_translate_from_id=>wwv_flow_imp.id(13891898475964091)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15213770538417672)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2116559170571265.100005)
,p_translate_from_id=>wwv_flow_imp.id(2116559170571265)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15213936974417672)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5602132190964023.100005)
,p_translate_from_id=>wwv_flow_imp.id(5602132190964023)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15214154450417672)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Llamada a diagramas'
,p_translate_from_text=>'Calling Diagrams'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15214344758417672)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100005)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Licencia'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15214565524417672)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402625223171412.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402625223171412)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15214794244417672)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(22800510543488044.100005)
,p_translate_from_id=>wwv_flow_imp.id(22800510543488044)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'&P4_REGION_TITLE.'
,p_translate_from_text=>'&P4_REGION_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15214951207417672)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8367243423910488.100005)
,p_translate_from_id=>wwv_flow_imp.id(8367243423910488)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Row Actions'
,p_translate_from_text=>'Subflows - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15215149082417672)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'No REST activado'
,p_translate_from_text=>'Not REST Enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15215322833417672)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Separador'
,p_translate_from_text=>'Tab'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15215536219417672)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100005)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Rendimiento de paso hist\00F3rico para &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )')
,p_translate_from_text=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15215729507417672)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Roles'
,p_translate_from_text=>'Roles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15215938301417673)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100005)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Advertencia de importaci\00F3n')
,p_translate_from_text=>'Import Warning'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15216197210417673)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5682136171037021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5682136171037021)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Detalles de instancia'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15216358348417673)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24202901353579047.100005)
,p_translate_from_id=>wwv_flow_imp.id(24202901353579047)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15216526408417673)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631684166575818.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631684166575818)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15216713413417673)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Detalles de instancia'
,p_translate_from_text=>'Instance Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15216920199417673)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100005)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Historial de variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15217133829417673)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Configuraci\00F3n')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15217337943417673)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100005)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15217561123417673)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2037037389569049.100005)
,p_translate_from_id=>wwv_flow_imp.id(2037037389569049)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancias de flujo vencidas actuales'
,p_translate_from_text=>'Current Overdue Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15217754664417673)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2549667804373355.100005)
,p_translate_from_id=>wwv_flow_imp.id(2549667804373355)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15217907028417673)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Informaci\00F3n')
,p_translate_from_text=>'Information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15218191610417673)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2561368308878606.100005)
,p_translate_from_id=>wwv_flow_imp.id(2561368308878606)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15218323198417673)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403200187171418.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403200187171418)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15218548781417673)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24203633870580280.100005)
,p_translate_from_id=>wwv_flow_imp.id(24203633870580280)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15218709702417673)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100005)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Procesos iniciados el &P15_DATE.'
,p_translate_from_text=>'Processes Started On &P15_DATE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15218935773417673)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100005)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Paso de instalaci\00F3n adicional no finalizado')
,p_translate_from_text=>'Additonal Installation Step Not Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15219109277417673)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5590953265964017.100005)
,p_translate_from_id=>wwv_flow_imp.id(5590953265964017)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Editar plantilla de formulario simple'
,p_translate_from_text=>'Edit Simple Form Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15219333666417673)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100005)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tab Holder'
,p_translate_from_text=>'Tab Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15219576832417673)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100005)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Eventos de instancia'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15219776808417674)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40001946826317109.100005)
,p_translate_from_id=>wwv_flow_imp.id(40001946826317109)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Row Actions'
,p_translate_from_text=>'Instances - Row Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15219922461417674)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100005)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Rendimiento de paso de tarea (mes actual): &P16_DGRM_NAME_VERSION. (dgrm_id: &P16_DGRM_ID. )'
,p_translate_from_text=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15220129436417674)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Errores de paso'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15220330035417674)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'XML de flujo'
,p_translate_from_text=>'Flow XML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15220514100417674)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100005)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables de Entrada/Salida'
,p_translate_from_text=>'In/Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15220789997417674)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Completa los detalles'
,p_translate_from_text=>'Fill in the details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15220977616417674)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100005)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Nueva versi\00F3n')
,p_translate_from_text=>'New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15221112353417674)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100005)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Variables'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15221359926417674)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2436340351881201.100005)
,p_translate_from_id=>wwv_flow_imp.id(2436340351881201)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instances - Header Actions'
,p_translate_from_text=>'Instances - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15221547331417674)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39018437829156626.100005)
,p_translate_from_id=>wwv_flow_imp.id(39018437829156626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15221716213417674)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100005)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancias de proceso por estado'
,p_translate_from_text=>'Process instances per status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15221923768417674)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100005)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Suprimir modelo'
,p_translate_from_text=>'Delete Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15222141475417674)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100005)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Form'
,p_translate_from_text=>'Form'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15222324559417674)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Seleccione el destino activo'
,p_translate_from_text=>'Choose the active destination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15222542690417674)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34405803831171444.100005)
,p_translate_from_id=>wwv_flow_imp.id(34405803831171444)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancias de flujo actual por modelo - 10 principales'
,p_translate_from_text=>'Current Flow Instances per Model - Top 10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15222712349417674)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100005)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Paso de reserva'
,p_translate_from_text=>'Reserve Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15222907927417674)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100005)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Agregar/editar variable de proceso'
,p_translate_from_text=>'Add/Edit Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15223109920417674)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403031827171416.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403031827171416)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15223386502417674)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681179787037011.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681179787037011)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Ruta de navegaci\00F3n')
,p_translate_from_text=>'Breadcrumb'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15223566375417674)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34586934772532100.100005)
,p_translate_from_id=>wwv_flow_imp.id(34586934772532100)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Instancias de flujo iniciadas en los \00FAltimos 14 d\00EDas')
,p_translate_from_text=>'Flow Instances started in the last 14 days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15223767324417674)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15223927145417674)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100005)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflujos'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15224102393417675)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Temporizadores desactivados'
,p_translate_from_text=>'Timers disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15224358787417675)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100005)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instance Action'
,p_translate_from_text=>'Instance Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15224572577417675)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Reprogramar temporizador'
,p_translate_from_text=>'Reschedule Timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15224737790417675)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Se ha detectado una actualizaci\00F3n de APEX')
,p_translate_from_text=>'APEX upgrade detected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15224983678417675)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15225198620417675)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Introducci\00F3n')
,p_translate_from_text=>'Getting Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15225394660417675)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003019626877931.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003019626877931)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15225527310417675)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100005)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Instancias de proceso asociadas'
,p_translate_from_text=>'Associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15225782425417675)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Tabs Holder'
,p_translate_from_text=>'Tabs Holder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15225990916417675)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8392021138345607.100005)
,p_translate_from_id=>wwv_flow_imp.id(8392021138345607)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Subflows - Header Actions'
,p_translate_from_text=>'Subflows - Header Actions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15226195533417675)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Supervisi\00F3n de flujo (&P12_PRCS_NAME.)')
,p_translate_from_text=>'Flow Monitor (&P12_PRCS_NAME.)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15226351583417675)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Selector de idioma'
,p_translate_from_text=>'Language Selector'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15226574986417675)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100005)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Botones'
,p_translate_from_text=>'Buttons'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15226758685417675)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100005)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Registro'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15226941469417675)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Visor de flujo'
,p_translate_from_text=>'Flow Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15227116555417675)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938158412499704.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938158412499704)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15227374269417675)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Recibir mensaje'
,p_translate_from_text=>'Receive Message'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15227572730417675)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522803511864949.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522803511864949)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>unistr('Men\00FA Acci\00F3n')
,p_translate_from_text=>'Action Menu'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15227782604417675)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Errores'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15227917750417675)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>20
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'Y'
,p_translate_to_text=>'Contenido'
,p_translate_from_text=>'Content'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15228106735417697)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2333314435104525.100005)
,p_translate_from_id=>wwv_flow_imp.id(2333314435104525)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15228352790417697)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15228524153417697)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143958569493923.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143958569493923)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15228733107417697)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100005)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15228929357417697)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100005)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15229151684417697)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404686490171432.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404686490171432)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15229354471417697)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15229511319417697)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100005)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_VERSION_MISMATCH!RAW.'
,p_translate_from_text=>'&P3_VERSION_MISMATCH!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15229723950417697)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100005)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para crear f\00E1cilmente sus propias definiciones de formulario de forma declarativa, puede utilizar el <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Creador de formulari')
||'os simple</span></a> para generar el JSON necesario.'
,p_translate_from_text=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15229935919417697)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100005)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15230158633417697)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635705433220643.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635705433220643)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15230330164417698)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2146022401493944.100005)
,p_translate_from_id=>wwv_flow_imp.id(2146022401493944)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15230596305417698)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>M\00F3dulo REST no instalado. Siga la gu\00EDa de instalaci\00F3n en: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>')
,p_translate_from_text=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15230723420417698)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15230961984417698)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100005)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15231170167417698)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100005)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Le recomendamos importar modelos creados con Flows for APEX para asegurarse de que el motor los puede ejecutar.'
,p_translate_from_text=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15231310717417698)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('<li>El esquema no est\00E1 activado para REST</li>')
,p_translate_from_text=>'<li>Schema is not REST Enabled</li>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15231535397417698)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('En esta p\00E1gina puede gestionar las definiciones JSON de las plantillas de formulario simple. Las plantillas se pueden utilizar de dos formas:'),
'<ul>',
unistr('    <li>Selecci\00F3nelas en Tareas de usuario de tipo "Formularios simples" en sus modelos de flujo</li>'),
unistr('    <li>Util\00EDcelos en la <strong>aplicaci\00F3n de inicio de proceso simple</strong> de la distribuci\00F3n Flujos para iniciar instancias de proceso rellenando un formulario'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15231772883417698)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2542117955137179.100005)
,p_translate_from_id=>wwv_flow_imp.id(2542117955137179)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15231929509417698)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2561999301878606.100005)
,p_translate_from_id=>wwv_flow_imp.id(2561999301878606)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15232109624417698)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100005)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para utilizar la funci\00F3n Temporizadores de Flows for APEX, debe completar el paso de instalaci\00F3n adicional que se puede encontrar <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_')
||unistr('blank">aqu\00ED</a>.')
,p_translate_from_text=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15232341230417698)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100005)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15232591535417698)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2550204271373356.100005)
,p_translate_from_id=>wwv_flow_imp.id(2550204271373356)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15232723349417698)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Los modelos que contienen uno o m\00E1s temporizadores no han podido funcionar correctamente en este sistema porque est\00E1n desactivados.<br>Puede activarlo en la p\00E1gina Configuration.')
,p_translate_from_text=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15232954828417698)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_translate_from_text=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15233111373417698)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(36450747308745933.100005)
,p_translate_from_id=>wwv_flow_imp.id(36450747308745933)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15233328929417698)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100005)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15233500760417698)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
unistr('<h3>Un sistema de flujo de procesos basado en BPMN con poco c\00F3digo para APEX.</h3>'),
unistr('<h4> Caracter\00EDsticas</h4>'),
'<ul>',
unistr('<li>Flows for APEX permite a los desarrolladores de APEX modelar y ejecutar flujos de procesos en APEX mediante una combinaci\00F3n de dise\00F1o de procesos visuales y t\00E9cnicas con poco c\00F3digo.</li>'),
unistr('<li>Dise\00F1ado principalmente para desarrolladores de APEX, Flows for APEX utiliza las tecnolog\00EDas con las que ya est\00E1 familiarizado - APEX, PL/SQL y SQL - para crear flujos de procesos potentes y flexibles en su entorno APEX.</li>'),
unistr('<li>Se utiliza para crear y ejecutar un flujo de proceso de p\00E1ginas APEX, scripts PL/SQL y env\00EDo de correo electr\00F3nico.</li>'),
unistr('<li> Los usuarios de negocio tambi\00E9n pueden comprender y editar la definici\00F3n de proceso esquem\00E1tico con poco c\00F3digo para aumentar la flexibilidad del negocio.  Los flujos utilizan el estilo de Notaci\00F3n de Modelado de Procesos de Negocio (BPMN) V2</l')
||'i>',
unistr('<li>Creado como un proyecto de comunidad APEX y publicado con una licencia de MIT de c\00F3digo abierto.</li>'),
'</ul>',
'<p>',
'<h4>Descargar</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
unistr('<h4>Documentaci\00F3n</h4>'),
unistr('<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">\00DAltima documentaci\00F3n en l\00EDnea</a>'),
'<p>',
'<h4>Tutoriales de BPMN</h4>',
unistr('Para empezar a modelar flujos, pruebe los flujos de tutoriales preinstalados. Para obtener m\00E1s informaci\00F3n sobre los tutoriales, consulte <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">aqu\00ED</a>.'),
'<p>',
unistr('<h4>Aplicaci\00F3n de demostraci\00F3n</h4>'),
'<p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15233734331417699)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45089418627561392.100005)
,p_translate_from_id=>wwv_flow_imp.id(45089418627561392)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15233953480417699)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495490587764879882.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495490587764879882)
,p_translate_column_id=>21
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex_lang.emit_language_selector_list;'
,p_translate_from_text=>'apex_lang.emit_language_selector_list;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15234152039417703)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7537546705451722.100005)
,p_translate_from_id=>wwv_flow_imp.id(7537546705451722)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ubicaci\00F3n de BPMN')
,p_translate_from_text=>'BPMN Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15234376611417703)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<ul>'
,p_translate_from_text=>'<ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15234504910417703)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3746146895530325.100005)
,p_translate_from_id=>wwv_flow_imp.id(3746146895530325)
,p_translate_column_id=>26
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ubicaci\00F3n de archivo')
,p_translate_from_text=>'Archive Location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15234777219417703)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>27
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</ul>'
,p_translate_from_text=>'</ul>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15234988292417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100005)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15235140164417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100005)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST'
,p_translate_from_text=>'REST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15235330976417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100005)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15235530553417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100005)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15235740518417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(14295838249027758.100005)
,p_translate_from_id=>wwv_flow_imp.id(14295838249027758)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Refrescar'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15235996266417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100005)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15236113871417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100005)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copiar'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15236313294417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100005)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminar'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15236573005417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100005)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15236741444417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100005)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminar'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15236990178417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5589254850825963.100005)
,p_translate_from_id=>wwv_flow_imp.id(5589254850825963)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tema'
,p_translate_from_text=>'Theme'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15237135657417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100005)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Licencia'
,p_translate_from_text=>'License'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15237393552417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100005)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminar'
,p_translate_from_text=>'Terminate'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15237504579417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12493524976121117621.100005)
,p_translate_from_id=>wwv_flow_imp.id(12493524976121117621)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Supervisi\00F3n de flujo')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15237736535417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservar'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15237955328417704)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7928603491409069.100005)
,p_translate_from_id=>wwv_flow_imp.id(7928603491409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Refrescar'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15238184279417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6346082030489968.100005)
,p_translate_from_id=>wwv_flow_imp.id(6346082030489968)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15238391413417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100005)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalles'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15238504685417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100005)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Agregar nueva versi\00F3n')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15238781898417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40416697084414268.100005)
,p_translate_from_id=>wwv_flow_imp.id(40416697084414268)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15238925336417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100005)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descargar (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15239157333417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2408507152394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2408507152394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15239394013417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3528025546791202.100005)
,p_translate_from_id=>wwv_flow_imp.id(3528025546791202)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Resumen de instancia'
,p_translate_from_text=>'Instance Summary'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15239513505417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100005)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Editar'
,p_translate_from_text=>'Edit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15239752117417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6316146932894106.100005)
,p_translate_from_id=>wwv_flow_imp.id(6316146932894106)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15239969645417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100005)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motor'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15240193507417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2128118443982532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2128118443982532)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Mostrar cronolog\00EDa de instancia')
,p_translate_from_text=>'Show Instance Timeline'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15240326238417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100005)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15240530821417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100005)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15240784705417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7947003406526806.100005)
,p_translate_from_id=>wwv_flow_imp.id(7947003406526806)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Refrescar'
,p_translate_from_text=>'Refresh'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15240950792417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100005)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalles de modelo'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15241133844417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100005)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completo'
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15241380378417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100005)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eliminar'
,p_translate_from_text=>'Delete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15241532513417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100005)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Agregar nueva versi\00F3n')
,p_translate_from_text=>'Add New Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15241704718417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6211519620415215.100005)
,p_translate_from_id=>wwv_flow_imp.id(6211519620415215)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Autom\00E1tico')
,p_translate_from_text=>'Automatic'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15241987136417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5597875143964021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5597875143964021)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Plantillas de formulario simple'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15242199200417705)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100005)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicaci\00F3n de motor')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15242390918417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100005)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inicio'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15242542600417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34586567175532090.100005)
,p_translate_from_id=>wwv_flow_imp.id(34586567175532090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Panel de control'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15242741369417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100005)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar historial'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15242902135417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100005)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivado'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15243114647417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100005)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15243385227417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100005)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descargar (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15243529605417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3597012048710221.100005)
,p_translate_from_id=>wwv_flow_imp.id(3597012048710221)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores de paso'
,p_translate_from_text=>'Step Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15243737772417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100005)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'debajo del informe|lado a lado|nueva ventana'
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15243910274417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11904067894914484.100005)
,p_translate_from_id=>wwv_flow_imp.id(11904067894914484)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15244126532417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495487001695879840.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495487001695879840)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cerrar sesi\00F3n')
,p_translate_from_text=>'Sign Out'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15244347847417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5664803242273579.100005)
,p_translate_from_id=>wwv_flow_imp.id(5664803242273579)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15244500751417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34597614443542059.100005)
,p_translate_from_id=>wwv_flow_imp.id(34597614443542059)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comenzar'
,p_translate_from_text=>'Getting started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15244718042417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100005)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15244922749417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100005)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inicio'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15245105388417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46154425883410953.100005)
,p_translate_from_id=>wwv_flow_imp.id(46154425883410953)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n de visualizaci\00F3n')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15245367721417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4410048087512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4410048087512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15245513407417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7928205045409069.100005)
,p_translate_from_id=>wwv_flow_imp.id(7928205045409069)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Importar'
,p_translate_from_text=>'Import'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15245782554417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12694916872990920.100005)
,p_translate_from_id=>wwv_flow_imp.id(12694916872990920)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15245999274417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7935795315465880.100005)
,p_translate_from_id=>wwv_flow_imp.id(7935795315465880)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15246191091417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100005)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Copiar'
,p_translate_from_text=>'Copy'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15246398298417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591767688841799.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591767688841799)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo oscuro'
,p_translate_from_text=>'Dark Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15246547162417706)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73510569356145167.100005)
,p_translate_from_id=>wwv_flow_imp.id(73510569356145167)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15246734627417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12668784852437164.100005)
,p_translate_from_id=>wwv_flow_imp.id(12668784852437164)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15246906148417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100005)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalles de modelo'
,p_translate_from_text=>'Show Model Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15247153163417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100005)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completo'
,p_translate_from_text=>'Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15247392890417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_USER.'
,p_translate_from_text=>'&APP_USER.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15247528928417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Liberar'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15247784492417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39805591040910001.100005)
,p_translate_from_id=>wwv_flow_imp.id(39805591040910001)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n de visualizaci\00F3n')
,p_translate_from_text=>'Display Setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15247951712417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7959427446726087.100005)
,p_translate_from_id=>wwv_flow_imp.id(7959427446726087)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ver fuente'
,p_translate_from_text=>'View Source'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15248196363417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100005)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar detalles'
,p_translate_from_text=>'Show Details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15248340327417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100005)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15248579607417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15248709858417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservar'
,p_translate_from_text=>'Reserve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15248926613417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12017441161816637.100005)
,p_translate_from_id=>wwv_flow_imp.id(12017441161816637)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15249111565417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100005)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15249336255417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Liberar'
,p_translate_from_text=>'Release'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15249540839417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6351240010504867.100005)
,p_translate_from_id=>wwv_flow_imp.id(6351240010504867)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15249710150417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100005)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15249975953417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7959824792726090.100005)
,p_translate_from_id=>wwv_flow_imp.id(7959824792726090)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Descargar (SVG)'
,p_translate_from_text=>'Download (SVG)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15250148607417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100005)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Exportar'
,p_translate_from_text=>'Export'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15250360860417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100005)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Ver'
,p_translate_from_text=>'View'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15250578220417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100005)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inicio'
,p_translate_from_text=>'Start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15250766855417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591024903839479.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591024903839479)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modo ligero'
,p_translate_from_text=>'Light Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15250962174417707)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100005)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reprogramar'
,p_translate_from_text=>'Reschedule'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15251130676417708)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73474529421861842.100005)
,p_translate_from_id=>wwv_flow_imp.id(73474529421861842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'-'
,p_translate_from_text=>'-'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15251366071417708)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100005)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'debajo del informe|lado a lado|nueva ventana'
,p_translate_from_text=>'below report|side-by-side|new window'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15251595006417708)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100005)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Mostrar historial'
,p_translate_from_text=>'Show History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15251736507417708)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495487403732879842.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495487403732879842)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'---'
,p_translate_from_text=>'---'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15251925129417708)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reiniciar'
,p_translate_from_text=>'Re-start'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15252168329417708)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9900462312126995.100005)
,p_translate_from_id=>wwv_flow_imp.id(9900462312126995)
,p_translate_column_id=>28
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesti\00F3n de flujo')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15252388042417721)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha seleccionado ning\00FAn proceso')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15252523912417721)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha seleccionado ning\00FAn proceso')
,p_translate_from_text=>'No process selected'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15252776887417721)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(117321296215490847.100005)
,p_translate_from_id=>wwv_flow_imp.id(117321296215490847)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No se encontraron atributos.'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15252981233417721)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570542357060505.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570542357060505)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No Tasks'
,p_translate_from_text=>'No Tasks'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15253107692417721)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73725012982147304.100005)
,p_translate_from_id=>wwv_flow_imp.id(73725012982147304)
,p_translate_column_id=>36
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No se han encontrado variables de entrada/salida.'
,p_translate_from_text=>'No In/Out variables found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15253358680417723)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>63
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cuadro de di\00E1logo de b\00FAsqueda')
,p_translate_from_text=>'Search Dialog'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15253560756417723)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>66
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_translate_from_text=>'<div class="t-PopupLOV-actions t-Form--large">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15253721476417723)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>67
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15253993233417723)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>70
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-links">'
,p_translate_from_text=>'<div class="t-PopupLOV-links">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15254145436417723)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>71
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'</div>'
,p_translate_from_text=>'</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15254310544417724)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>72
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Buscar'
,p_translate_from_text=>'Search'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15254548379417724)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>73
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cerrar'
,p_translate_from_text=>'Close'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15254776623417724)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>74
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Siguiente >'
,p_translate_from_text=>'Next &gt;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15254987681417724)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>75
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'< Anterior'
,p_translate_from_text=>'&lt; Previous'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15255174537417724)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495496302977879965.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495496302977879965)
,p_translate_column_id=>79
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00BFDesea realizar esta acci\00F3n de supresi\00F3n?')
,p_translate_from_text=>'Would you like to perform this delete action?'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15255309387417725)
,p_translated_flow_id=>100005
,p_translate_to_id=>100.100005
,p_translate_from_id=>100
,p_translate_column_id=>80
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flujo de trabajo'
,p_translate_from_text=>'Workflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15255565978417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2550001583373355.100005)
,p_translate_from_id=>wwv_flow_imp.id(2550001583373355)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas de proceso')
,p_translate_from_text=>'Process Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15255726890417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34530380979770009.100005)
,p_translate_from_id=>wwv_flow_imp.id(34530380979770009)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesti\00F3n de flujo')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15255989151417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2407759203411191.100005)
,p_translate_from_id=>wwv_flow_imp.id(2407759203411191)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Servicio REST'
,p_translate_from_text=>'REST Service'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15256153924417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3308819433316729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3308819433316729)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motor'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15256374790417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3308475687313586.100005)
,p_translate_from_id=>wwv_flow_imp.id(3308475687313586)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivado'
,p_translate_from_text=>'Archiving'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15256544466417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34554383018964598.100005)
,p_translate_from_id=>wwv_flow_imp.id(34554383018964598)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Supervisi\00F3n de flujo')
,p_translate_from_text=>'Flow Monitor'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15256774789417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2116968797571265.100005)
,p_translate_from_id=>wwv_flow_imp.id(2116968797571265)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cronolog\00EDa de instancia: &P20_PRCS_NAME.')
,p_translate_from_text=>'Instance Timeline - &P20_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15256918182417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11904723133918726.100005)
,p_translate_from_id=>wwv_flow_imp.id(11904723133918726)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n')
,p_translate_from_text=>'Configuration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15257093452417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34530584751775010.100005)
,p_translate_from_id=>wwv_flow_imp.id(34530584751775010)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&FLOW_PAGE_TITLE.'
,p_translate_from_text=>'&FLOW_PAGE_TITLE.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15257204942417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34709672555312450.100005)
,p_translate_from_id=>wwv_flow_imp.id(34709672555312450)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Panel de control'
,p_translate_from_text=>'Dashboard'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15257469537417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2561724817878606.100005)
,p_translate_from_id=>wwv_flow_imp.id(2561724817878606)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas de tarea')
,p_translate_from_text=>'Task Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15257617445417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3337454003771697.100005)
,p_translate_from_id=>wwv_flow_imp.id(3337454003771697)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas')
,p_translate_from_text=>'Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15257881373417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3308685056315428.100005)
,p_translate_from_id=>wwv_flow_imp.id(3308685056315428)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Aplicaci\00F3n de motor')
,p_translate_from_text=>'Engine App'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15258062962417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2541995976137178.100005)
,p_translate_from_id=>wwv_flow_imp.id(2541995976137178)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estad\00EDsticas diarias')
,p_translate_from_text=>'Daily Statistics'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15258296402417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5601978818964023.100005)
,p_translate_from_id=>wwv_flow_imp.id(5601978818964023)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Plantillas de formulario simple'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15258434221417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11482636344804668.100005)
,p_translate_from_id=>wwv_flow_imp.id(11482636344804668)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Configuraci\00F3n - Licencia')
,p_translate_from_text=>'Configuration - Licence'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15258639143417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34550076822906956.100005)
,p_translate_from_id=>wwv_flow_imp.id(34550076822906956)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelador de flujo'
,p_translate_from_text=>'Flow Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15258826129417726)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3308151438310190.100005)
,p_translate_from_id=>wwv_flow_imp.id(3308151438310190)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro'
,p_translate_from_text=>'Logging'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15259040114417727)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3309054147318793.100005)
,p_translate_from_id=>wwv_flow_imp.id(3309054147318793)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Temporizadores'
,p_translate_from_text=>'Timers'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15259203572417727)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6043758234733358.100005)
,p_translate_from_id=>wwv_flow_imp.id(6043758234733358)
,p_translate_column_id=>100
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P8_PRCS_NAME.'
,p_translate_from_text=>'&P8_PRCS_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15259497265417728)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11250625753948668.100005)
,p_translate_from_id=>wwv_flow_imp.id(11250625753948668)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivo'
,p_translate_from_text=>'File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15259615997417728)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15902510563364061.100005)
,p_translate_from_id=>wwv_flow_imp.id(15902510563364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Despu\00E9s de tarea')
,p_translate_from_text=>'After Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15259807614417728)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15903750919364061.100005)
,p_translate_from_id=>wwv_flow_imp.id(15903750919364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Antes de divisi\00F3n')
,p_translate_from_text=>'Before Split'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15260088917417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15373450429468526.100005)
,p_translate_from_id=>wwv_flow_imp.id(15373450429468526)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Estado de proceso despu\00E9s de cese')
,p_translate_from_text=>'Process status after termination'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15260217645417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35704108915505147.100005)
,p_translate_from_id=>wwv_flow_imp.id(35704108915505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Marcador de posici\00F3n')
,p_translate_from_text=>'Placeholder'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15260472019417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(13103422381982643.100005)
,p_translate_from_id=>wwv_flow_imp.id(13103422381982643)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-files-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_MULTIPLE_MODELS.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15260663630417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35702112103505146.100005)
,p_translate_from_id=>wwv_flow_imp.id(35702112103505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CCO'
,p_translate_from_text=>'BCC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15260875494417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35707717059505149.100005)
,p_translate_from_id=>wwv_flow_imp.id(35707717059505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fecha'
,p_translate_from_text=>'Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15261055999417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35708515702505150.100005)
,p_translate_from_id=>wwv_flow_imp.id(35708515702505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Intervalo de a\00F1o a mes')
,p_translate_from_text=>'Interval Year to Month'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15261280431417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62212194512228414.100005)
,p_translate_from_id=>wwv_flow_imp.id(62212194512228414)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'En variables'
,p_translate_from_text=>'In Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15261433303417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11251072818948672.100005)
,p_translate_from_id=>wwv_flow_imp.id(11251072818948672)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Texto'
,p_translate_from_text=>'Text'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15261604807417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11259507519008561.100005)
,p_translate_from_id=>wwv_flow_imp.id(11259507519008561)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Script SQL'
,p_translate_from_text=>'SQL Script'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15261845177417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15332307999656557.100005)
,p_translate_from_id=>wwv_flow_imp.id(15332307999656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Solicitud'
,p_translate_from_text=>'Request'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15262061844417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15332751649656557.100005)
,p_translate_from_id=>wwv_flow_imp.id(15332751649656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00CDtems de p\00E1gina')
,p_translate_from_text=>'Page Items'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15262293290417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35709717522505150.100005)
,p_translate_from_id=>wwv_flow_imp.id(35709717522505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tiempo hasta que el temporizador se vuelve a disparar'
,p_translate_from_text=>'Time until the timer fires again'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15262466196417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35710159164505151.100005)
,p_translate_from_id=>wwv_flow_imp.id(35710159164505151)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1ximo de ejecuciones')
,p_translate_from_text=>'Max Runs'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15262616476417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62212467011228444.100005)
,p_translate_from_id=>wwv_flow_imp.id(62212467011228444)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variables de Salida'
,p_translate_from_text=>'Out Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15262892254417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15217803205803716.100005)
,p_translate_from_id=>wwv_flow_imp.id(15217803205803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_translate_from_text=>'PL/SQL Function Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15263085348417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15334375925656558.100005)
,p_translate_from_id=>wwv_flow_imp.id(15334375925656558)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('P\00E1gina')
,p_translate_from_text=>'Page'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15263276988417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35708141249505150.100005)
,p_translate_from_id=>wwv_flow_imp.id(35708141249505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1scara de formato')
,p_translate_from_text=>'Format Mask'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15263455657417729)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35708950682505150.100005)
,p_translate_from_id=>wwv_flow_imp.id(35708950682505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('D\00EDa de intervalo a segundo')
,p_translate_from_text=>'Interval Day to Second'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15263687937417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35709380114505150.100005)
,p_translate_from_id=>wwv_flow_imp.id(35709380114505150)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tiempo hasta que el temporizador se dispara primero'
,p_translate_from_text=>'Time until the timer fires first'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15263816817417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15333933530656557.100005)
,p_translate_from_id=>wwv_flow_imp.id(15333933530656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Motor'
,p_translate_from_text=>'Engine'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15264051934417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15373733235468542.100005)
,p_translate_from_id=>wwv_flow_imp.id(15373733235468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tipo de definici\00F3n de temporizador')
,p_translate_from_text=>'Timer Definition Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15264258999417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15374151920468542.100005)
,p_translate_from_id=>wwv_flow_imp.id(15374151920468542)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Definici\00F3n de temporizador')
,p_translate_from_text=>'Timer Definition'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15264414809417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35702525554505146.100005)
,p_translate_from_id=>wwv_flow_imp.id(35702525554505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Responder a'
,p_translate_from_text=>'Reply To'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15264636646417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495493775569879902.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495493775569879902)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Recordar nombre de usuario'
,p_translate_from_text=>'Remember username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15264896493417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11259254401008560.100005)
,p_translate_from_id=>wwv_flow_imp.id(11259254401008560)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Archivo BPMN'
,p_translate_from_text=>'BPMN File'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15265001583417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15902102975364060.100005)
,p_translate_from_id=>wwv_flow_imp.id(15902102975364060)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Antes de tarea'
,p_translate_from_text=>'Before Task'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15265248049417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35701367611505137.100005)
,p_translate_from_id=>wwv_flow_imp.id(35701367611505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Hasta'
,p_translate_from_text=>'To'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15265455034417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35701702285505137.100005)
,p_translate_from_id=>wwv_flow_imp.id(35701702285505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CC'
,p_translate_from_text=>'CC'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15265672826417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35706161989505149.100005)
,p_translate_from_id=>wwv_flow_imp.id(35706161989505149)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enviar inmediatamente'
,p_translate_from_text=>'Send Immediatly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15265829832417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15902907108364061.100005)
,p_translate_from_id=>wwv_flow_imp.id(15902907108364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Antes del evento'
,p_translate_from_text=>'Before Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15266088786417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35703352692505146.100005)
,p_translate_from_id=>wwv_flow_imp.id(35703352692505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de aplicaci\00F3n')
,p_translate_from_text=>'Application ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15266207339417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35705311456505147.100005)
,p_translate_from_id=>wwv_flow_imp.id(35705311456505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cuerpo HTML'
,p_translate_from_text=>'HTML Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15266477679417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15904152776364061.100005)
,p_translate_from_id=>wwv_flow_imp.id(15904152776364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Despu\00E9s de fusi\00F3n')
,p_translate_from_text=>'After Merge'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15266677997417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35700949683505137.100005)
,p_translate_from_id=>wwv_flow_imp.id(35700949683505137)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Desde'
,p_translate_from_text=>'From'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15266851612417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15215132143777515.100005)
,p_translate_from_id=>wwv_flow_imp.id(15215132143777515)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valor est\00E1tico')
,p_translate_from_text=>'Static Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15267074237417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35704517220505147.100005)
,p_translate_from_id=>wwv_flow_imp.id(35704517220505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Asunto'
,p_translate_from_text=>'Subject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15267285433417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15216699385803714.100005)
,p_translate_from_id=>wwv_flow_imp.id(15216699385803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Art\00EDculo')
,p_translate_from_text=>'Item'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15267401594417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15217473228803715.100005)
,p_translate_from_id=>wwv_flow_imp.id(15217473228803715)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Consulta SQL (devolver valor separado por dos puntos)'
,p_translate_from_text=>'SQL Query (return colon separated value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15267673961417730)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15218228624803716.100005)
,p_translate_from_id=>wwv_flow_imp.id(15218228624803716)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Expresi\00F3n PL/SQL')
,p_translate_from_text=>'PL/SQL Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15267884063417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15333170482656557.100005)
,p_translate_from_id=>wwv_flow_imp.id(15333170482656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('C\00F3digo PL/SQL')
,p_translate_from_text=>'PL/SQL Code'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15268033128417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15216223137803713.100005)
,p_translate_from_id=>wwv_flow_imp.id(15216223137803713)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variable de proceso'
,p_translate_from_text=>'Process Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15268234556417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15903304316364061.100005)
,p_translate_from_id=>wwv_flow_imp.id(15903304316364061)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'En evento'
,p_translate_from_text=>'On Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15268481384417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35705730321505148.100005)
,p_translate_from_id=>wwv_flow_imp.id(35705730321505148)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Anexo'
,p_translate_from_text=>'Attachment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15268684343417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15217004677803714.100005)
,p_translate_from_id=>wwv_flow_imp.id(15217004677803714)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_translate_from_text=>'SQL Query (return single value)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15268826678417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15331535176656556.100005)
,p_translate_from_id=>wwv_flow_imp.id(15331535176656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Borrar cach\00E9')
,p_translate_from_text=>'Clear Cache'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15269027155417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15331901949656556.100005)
,p_translate_from_id=>wwv_flow_imp.id(15331901949656556)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valores de art\00EDculo')
,p_translate_from_text=>'Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15269251822417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35704978438505147.100005)
,p_translate_from_id=>wwv_flow_imp.id(35704978438505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Cuerpo'
,p_translate_from_text=>'Body'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15269478099417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35700662160505107.100005)
,p_translate_from_id=>wwv_flow_imp.id(35700662160505107)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de tarea'
,p_translate_from_text=>'Task Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15269602205417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35702928038505146.100005)
,p_translate_from_id=>wwv_flow_imp.id(35702928038505146)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usar plantilla'
,p_translate_from_text=>'Use Template'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15269847730417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(35703713806505147.100005)
,p_translate_from_id=>wwv_flow_imp.id(35703713806505147)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de plantilla'
,p_translate_from_text=>'Template ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15270012882417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(13103030553982630.100005)
,p_translate_from_id=>wwv_flow_imp.id(13103030553982630)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
,p_translate_from_text=>'<span><span aria-hidden="true" class="fa fa-file-o fa-lg"></span><span style="display: block;">&APP_TEXT$APP_LOV_ONE_MODEL.</span></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15270255850417731)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15333581483656557.100005)
,p_translate_from_id=>wwv_flow_imp.id(15333581483656557)
,p_translate_column_id=>103
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Valores de \00EDtem de p\00E1gina de enlace')
,p_translate_from_text=>'Bind Page Item Values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15270402472417735)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035945696569038.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035945696569038)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No hay subflujo registrado'
,p_translate_from_text=>'No Subflow Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15270633602417735)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036063537569039.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036063537569039)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No hay ning\00FAn nivel de proceso registrado')
,p_translate_from_text=>'No Process Level Logged'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15270888294417735)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'	- Seleccionar -'
,p_translate_from_text=>'- Select -'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15271058826417735)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>105
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Sin categor\00EDa')
,p_translate_from_text=>'No Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15271286057417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60864662910537244.100005)
,p_translate_from_id=>wwv_flow_imp.id(60864662910537244)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Direcci\00F3n')
,p_translate_from_text=>'Direction'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15271488085417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100005)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15271630888417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100005)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15271886627417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100005)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pila de errores'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15272062970417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2034206989569021.100005)
,p_translate_from_id=>wwv_flow_imp.id(2034206989569021)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado de evento'
,p_translate_from_text=>'Event Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15272204807417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8023653162825605.100005)
,p_translate_from_id=>wwv_flow_imp.id(8023653162825605)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15272405703417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15355370045942501.100005)
,p_translate_from_id=>wwv_flow_imp.id(15355370045942501)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuario'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15272638398417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15272800003417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5683966799037039.100005)
,p_translate_from_id=>wwv_flow_imp.id(5683966799037039)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15273066912417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2033826985569017.100005)
,p_translate_from_id=>wwv_flow_imp.id(2033826985569017)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Fecha de evento'
,p_translate_from_text=>'Event Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15273215159417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15273416142417736)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60864072957537238.100005)
,p_translate_from_id=>wwv_flow_imp.id(60864072957537238)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Permite llamada'
,p_translate_from_text=>'Is Callable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15273644081417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5684069475037040.100005)
,p_translate_from_id=>wwv_flow_imp.id(5684069475037040)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inicializado el'
,p_translate_from_text=>'Initialized On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15273853327417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100005)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15274072082417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15274242909417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60863889314537236.100005)
,p_translate_from_id=>wwv_flow_imp.id(60863889314537236)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de p\00E1gina')
,p_translate_from_text=>'Page Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15274487489417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5684296657037042.100005)
,p_translate_from_id=>wwv_flow_imp.id(5684296657037042)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15274698010417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60863981218537237.100005)
,p_translate_from_id=>wwv_flow_imp.id(60863981218537237)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de usuario'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15274811911417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60864798356537245.100005)
,p_translate_from_id=>wwv_flow_imp.id(60864798356537245)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15275001802417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8023758985825606.100005)
,p_translate_from_id=>wwv_flow_imp.id(8023758985825606)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15275236740417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5684163968037041.100005)
,p_translate_from_id=>wwv_flow_imp.id(5684163968037041)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima actualizaci\00F3n el')
,p_translate_from_text=>'Last Update On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15275445870417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2034066823569019.100005)
,p_translate_from_id=>wwv_flow_imp.id(2034066823569019)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('T\00EDtulo de evento')
,p_translate_from_text=>'Event Title'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15275639444417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2034561911569024.100005)
,p_translate_from_id=>wwv_flow_imp.id(2034561911569024)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Icono de evento'
,p_translate_from_text=>'Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15275839582417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100005)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15276035720417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15276223692417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2034344167569022.100005)
,p_translate_from_id=>wwv_flow_imp.id(2034344167569022)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descripci\00F3n de evento')
,p_translate_from_text=>'Event Desc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15276467074417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100005)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15276628080417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15276894532417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100005)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelo'
,p_translate_from_text=>'Model'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15277077165417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15355453502942502.100005)
,p_translate_from_id=>wwv_flow_imp.id(15355453502942502)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15277279559417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60863751015537235.100005)
,p_translate_from_id=>wwv_flow_imp.id(60863751015537235)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID de aplicaci\00F3n')
,p_translate_from_text=>'Application Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15277413317417737)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2034410284569023.100005)
,p_translate_from_id=>wwv_flow_imp.id(2034410284569023)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Color de usuario'
,p_translate_from_text=>'User Color'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15277689719417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60864809349537246.100005)
,p_translate_from_id=>wwv_flow_imp.id(60864809349537246)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de datos'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15277833749417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60864944171537247.100005)
,p_translate_from_id=>wwv_flow_imp.id(60864944171537247)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descripci\00F3n')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15278076298417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26069606115228470.100005)
,p_translate_from_id=>wwv_flow_imp.id(26069606115228470)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nb Instances'
,p_translate_from_text=>'Nb Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15278200086417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142146265493905.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142146265493905)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prioridad'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15278407501417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12636412647220650.100005)
,p_translate_from_id=>wwv_flow_imp.id(12636412647220650)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro de hora'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15278671281417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2034198035569020.100005)
,p_translate_from_id=>wwv_flow_imp.id(2034198035569020)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de evento'
,p_translate_from_text=>'Event Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15278838816417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100005)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15279053190417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100005)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'D'
,p_translate_from_text=>'D'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15279211607417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142255235493906.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142255235493906)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vencimiento'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15279464466417738)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2033971970569018.100005)
,p_translate_from_id=>wwv_flow_imp.id(2033971970569018)
,p_translate_column_id=>106
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de usuario'
,p_translate_from_text=>'User Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15279682651417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26021760516277918.100005)
,p_translate_from_id=>wwv_flow_imp.id(26021760516277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15279871891417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26022166035277918.100005)
,p_translate_from_id=>wwv_flow_imp.id(26022166035277918)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15280053235417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15355565536942503.100005)
,p_translate_from_id=>wwv_flow_imp.id(15355565536942503)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15280233161417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404982371171435.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404982371171435)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15280420849417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404729118171433.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404729118171433)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15280687359417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26022532889277920.100005)
,p_translate_from_id=>wwv_flow_imp.id(26022532889277920)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15280826589417741)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34404808882171434.100005)
,p_translate_from_id=>wwv_flow_imp.id(34404808882171434)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15281018506417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34405020184171436.100005)
,p_translate_from_id=>wwv_flow_imp.id(34405020184171436)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15281266632417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402829743171414.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402829743171414)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15281446391417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34405145511171437.100005)
,p_translate_from_id=>wwv_flow_imp.id(34405145511171437)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_translate_from_text=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15281644931417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402963356171415.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402963356171415)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_translate_from_text=>'<span data-status="error">#ERROR_INSTANCES#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15281822128417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15355984569942507.100005)
,p_translate_from_id=>wwv_flow_imp.id(15355984569942507)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_translate_from_text=>'#DGRM_NAME# - Version #DGRM_VERSION#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15282044194417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3791697231921401.100005)
,p_translate_from_id=>wwv_flow_imp.id(3791697231921401)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15282202688417742)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3746305351530327.100005)
,p_translate_from_id=>wwv_flow_imp.id(3746305351530327)
,p_translate_column_id=>108
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#D#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#D#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15282485402417743)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li>One Model: importe un \00FAnico modelo proporcionando todos los atributos</li>'),
'    <li>Varios modelos: importe varios modelos proporcionando un archivo zip*</li>',
'</ul>',
'<p> * El archivo zip debe contener:',
'    <ul>',
'        <li>Los archivos bpmn que se van a importar</li>',
'        <li>Un archivo import.json que es una matriz de objetos (consulte el ejemplo siguiente) con los siguientes atributos:',
'            <ul>',
'                <li>dgrm_name: nombre del modelo</li>',
unistr('                <li>dgrm_version: versi\00F3n del modelo</li>'),
unistr('                <li>dgrm_category: categor\00EDa del modelo</li>'),
'                <li>file: El nombre del archivo bpmn en el archivo</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Ejemplo de un archivo import.json con dos modelos<br>',
'<pre><code>[',
'{',
unistr('    "dgrm_name": "Colaboraci\00F3n Pizza",'),
'    "dgrm_version": "0",',
'    "dgrm_status": "borrador",',
'    "dgrm_category": nulo,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Festivos",',
'    "dgrm_version": "0",',
'    "dgrm_status": "borrador",',
'    "dgrm_category": nulo,',
'    "archivo": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15282647822417743)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>111
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si activa esta casilla de control, la aplicaci\00F3n guardar\00E1 el nombre de usuario en una cookie de explorador persistente denominada "LOGIN_USERNAME_COOKIE". Cuando vaya a la p\00E1gina de conexi\00F3n la pr\00F3xima vez,'),
unistr('el campo de nombre de usuario se rellenar\00E1 autom\00E1ticamente con este valor.'),
'</p> <p>',
unistr('Si anula la selecci\00F3n de esta casilla de verificaci\00F3n y su nombre de usuario ya est\00E1 guardado en la cookie,'),
unistr('la aplicaci\00F3n la sobrescribir\00E1 con un valor vac\00EDo. Tambi\00E9n puede utilizar las herramientas de desarrollador de su explorador para eliminar por completo la cookie.'),
'</p>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15282802800417743)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495520149009880113.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495520149009880113)
,p_translate_column_id=>112
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_translate_from_text=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15283041698417744)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(29001516138505995.100005)
,p_translate_from_id=>wwv_flow_imp.id(29001516138505995)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eventos de instancia'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15283249629417744)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(23845375832515291.100005)
,p_translate_from_id=>wwv_flow_imp.id(23845375832515291)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujos actuales'
,p_translate_from_text=>'Current Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15283449301417744)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11504924392020455.100005)
,p_translate_from_id=>wwv_flow_imp.id(11504924392020455)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&P13_VAR_TAB_NAME.'
,p_translate_from_text=>'&P13_VAR_TAB_NAME.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15283652156417744)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5598277955964021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5598277955964021)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Plantillas de formulario simple'
,p_translate_from_text=>'Simple Form Templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15283822455417744)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7332140854307003.100005)
,p_translate_from_id=>wwv_flow_imp.id(7332140854307003)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historial de variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15284036946417744)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(20683667255713697.100005)
,p_translate_from_id=>wwv_flow_imp.id(20683667255713697)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Eventos de instancia'
,p_translate_from_text=>'Instance Events'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15284240509417745)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2343931822104541.100005)
,p_translate_from_id=>wwv_flow_imp.id(2343931822104541)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Informe de cliente de ORDS'
,p_translate_from_text=>'ORDS Client Report'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15284498848417745)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63513911250355404.100005)
,p_translate_from_id=>wwv_flow_imp.id(63513911250355404)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Modelos llamados'
,p_translate_from_text=>'Called Models'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15284695397417745)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509332876851706.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509332876851706)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suscripciones de mensajes'
,p_translate_from_text=>'Message Subscriptions'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15284821054417745)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2447308339538228.100005)
,p_translate_from_id=>wwv_flow_imp.id(2447308339538228)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pasos finalizados'
,p_translate_from_text=>'Completed Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15285068433417745)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55105327231434717.100005)
,p_translate_from_id=>wwv_flow_imp.id(55105327231434717)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atributos'
,p_translate_from_text=>'Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15285290778417745)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16213590277416087.100005)
,p_translate_from_id=>wwv_flow_imp.id(16213590277416087)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama llamado'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15285475574417745)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24213241311956116.100005)
,p_translate_from_id=>wwv_flow_imp.id(24213241311956116)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Gesti\00F3n de flujo')
,p_translate_from_text=>'Flow Management'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15285682019417745)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514877350355413.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514877350355413)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Llamada a diagramas'
,p_translate_from_text=>'Calling Diagrams'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15285841086417745)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12493545854579486121.100005)
,p_translate_from_id=>wwv_flow_imp.id(12493545854579486121)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias de flujo'
,p_translate_from_text=>'Flow Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15286075785417745)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16212173591416073.100005)
,p_translate_from_id=>wwv_flow_imp.id(16212173591416073)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujos completados'
,p_translate_from_text=>'Completed Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15286206975417745)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16453181626752830.100005)
,p_translate_from_id=>wwv_flow_imp.id(16453181626752830)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pasos actuales'
,p_translate_from_text=>'Current Steps'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15286457261417745)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2444768214538202.100005)
,p_translate_from_id=>wwv_flow_imp.id(2444768214538202)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Historial de variables'
,p_translate_from_text=>'Variable History'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15286666275417745)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8392311025345610.100005)
,p_translate_from_id=>wwv_flow_imp.id(8392311025345610)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Variables'
,p_translate_from_text=>'Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15286892846417745)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632550341220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632550341220611)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errores de paso'
,p_translate_from_text=>'Step Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15287003681417745)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(166753193485966384.100005)
,p_translate_from_id=>wwv_flow_imp.id(166753193485966384)
,p_translate_column_id=>143
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujos'
,p_translate_from_text=>'Subflows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15287273194417747)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100005)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El recuento m\00E1ximo de filas para este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15287447174417747)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>146
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El recuento m\00E1ximo de filas para este informe es #MAX_ROW_COUNT# filas.  Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_translate_from_text=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15287649808417748)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519619992437209.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519619992437209)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El historial de variables est\00E1 vac\00EDo.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15287896118417748)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632654932220612.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632654932220612)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El historial de errores del paso est\00E1 vac\00EDo.')
,p_translate_from_text=>'The step error history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15288043621417748)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497368023177018.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497368023177018)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha encontrado ning\00FAn subflujo actual.')
,p_translate_from_text=>'No current subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15288295092417748)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967786479177907.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967786479177907)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha encontrado ninguna expresi\00F3n de variable.')
,p_translate_from_text=>'No variable expressions found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15288443699417748)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514930517355414.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514930517355414)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha encontrado ning\00FAn diagrama de llamada.')
,p_translate_from_text=>'No Calling Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15288622582417748)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497980793177024.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497980793177024)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha encontrado ning\00FAn subflujo finalizado.')
,p_translate_from_text=>'No completed subflows found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15288886320417748)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153691026389227.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153691026389227)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El historial de eventos de instancia est\00E1 vac\00EDo.')
,p_translate_from_text=>'The instance event history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15289081924417748)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2344349165104542.100005)
,p_translate_from_id=>wwv_flow_imp.id(2344349165104542)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No se han encontrado datos.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15289244972417748)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107181775434735.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107181775434735)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No se encontraron atributos.'
,p_translate_from_text=>'No attributes found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15289456594417748)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514135027355406.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514135027355406)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha encontrado ning\00FAn diagrama llamado.')
,p_translate_from_text=>'No Called Diagrams found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15289676162417748)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7332204855307004.100005)
,p_translate_from_id=>wwv_flow_imp.id(7332204855307004)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El historial de variables est\00E1 vac\00EDo.')
,p_translate_from_text=>'The variable history is empty.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15289828326417748)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5598315428964021.100005)
,p_translate_from_id=>wwv_flow_imp.id(5598315428964021)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No se encontraron datos.'
,p_translate_from_text=>'No data found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15290021534417748)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155579215389246.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155579215389246)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('No se ha encontrado ning\00FAn paso finalizado.')
,p_translate_from_text=>'No completed steps found.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15290206794417748)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154410837389235.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154410837389235)
,p_translate_column_id=>147
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No se han encontrado pasos actuales.'
,p_translate_from_text=>'No current steps found.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15290431460417749)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Start On'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15290659602417750)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15290841606417750)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Scope'
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15291036635417750)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15291200904417750)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Json Attributes'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15291445753417750)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15291601765417750)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15291848978417750)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15292045425417750)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15292207054417750)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15292488384417750)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15292607154417750)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creation Date'
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15292859659417750)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15293001129417750)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version Selection'
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15293212979417750)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15293484428417750)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15293638147417750)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15293877109417750)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15294069948417750)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Starting Object'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15294282722417750)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100005)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Email'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15294431799417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100005)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15294600807417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Level'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15294896495417751)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Version'
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15295029233417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15295242243417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100005)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15295449428417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Value'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15295668199417751)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15295851492417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lane'
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15296004243417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100005)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserved For'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15296286857417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100005)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15296484374417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Key Name'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15296639608417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15296897026417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15297071535417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15297283068417751)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion Icon'
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15297427629417751)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15297610399417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15297830343417751)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15298082791417751)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Name'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15298266832417752)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15298436933417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100005)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15298629296417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15298817334417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Due On'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15299019588417752)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15299227729417752)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15299411809417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100005)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15299616396417752)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100005)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15299892566417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15300039854417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15300270779417752)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15300407249417752)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15300635679417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100005)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15300870626417752)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15301056617417752)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15301223009417752)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15301471202417752)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100005)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15301652286417752)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15301833955417753)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Static ID'
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15302068368417753)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15302247501417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15302435122417753)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100005)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15302603831417753)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15302816938417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression'
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15303062681417753)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15303239817417753)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100005)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15303437254417753)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15303662827417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100005)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15303845426417753)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15304001419417753)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Object'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15304274955417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15304471698417753)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15304630303417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15304807582417753)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Excluded Users'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15305058798417753)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15305256161417753)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15305421879417753)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15305645801417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15305854172417753)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15306001355417754)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Payload Variable'
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15306278177417754)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15306493354417754)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Category'
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15306640825417754)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100005)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flow Parsed'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15306888273417754)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15307054130417754)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100005)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15307222879417754)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15307431107417754)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15307645542417754)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15307859136417754)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15308062522417754)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100005)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15308224734417754)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100005)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15308464952417754)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100005)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15308621357417754)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process ID'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15308850532417754)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15309036918417754)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15309235879417754)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100005)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15309429076417754)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Root Dgrm'
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15309645885417754)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15309806232417754)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15310045843417754)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15310257786417755)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15310412600417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Type'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15310600318417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15310845718417755)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15311000583417755)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15311254004417755)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15311423405417755)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15311666678417755)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15311824065417755)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15312013144417755)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15312247614417755)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15312402860417755)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15312626842417755)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15312819795417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15313031518417755)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15313261263417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'User'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15313463805417755)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15313638201417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15313888616417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15314028072417755)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Message Name'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15314295263417756)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15314424036417756)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100005)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15314642413417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15314815759417756)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15315060758417756)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100005)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15315294195417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15315466080417756)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15315682917417756)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15315805611417756)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100005)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Scope'
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15316099904417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15316263624417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Event'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15316443899417756)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Priority'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15316642998417756)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100005)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15316877191417756)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservation'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15317039998417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15317216468417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15317423441417756)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Update'
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15317607329417756)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100005)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15317855163417756)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Version'
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15318063495417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Execution'
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15318297168417756)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100005)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15318480432417756)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15318661820417757)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100005)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15318859340417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15319003493417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Bpmn Id'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15319261880417757)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15319439423417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15319667026417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15319809105417757)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15320064448417757)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100005)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15320279548417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15320472312417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15320602431417757)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Called Diagram Version'
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15320823832417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15321027470417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Last Completed'
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15321223570417757)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15321430041417757)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100005)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step Key'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15321696923417757)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15321896123417757)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15322029792417757)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15322290800417757)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15322499214417757)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15322650688417757)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15322897247417758)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15323075180417758)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15323240496417758)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100005)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15323417641417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current Class'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15323666259417758)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15323809557417758)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Work Started'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15324099549417758)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15324235494417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Object'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15324464083417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100005)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error Stack'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15324680484417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15324886214417758)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process Level'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15325017254417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Msub Id'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15325230036417758)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100005)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15325420128417758)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comment'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15325611899417758)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100005)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Description'
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15325840039417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15326017801417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Level'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15326295448417758)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Status'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15326446655417758)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Category'
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15326625505417758)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15326833759417758)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15327004077417758)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100005)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iteration Path'
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15327222429417759)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15327490042417759)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Data Type'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15327691265417759)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Current'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15327844553417759)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timestamp'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15328029459417759)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15328284196417759)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Calling Diagram ID'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15328429222417759)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100005)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Support Uri'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15328683606417759)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instances'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15328882322417759)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Value'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15329070022417759)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15329217584417759)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100005)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15329433697417759)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15329689862417759)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Has Recursion'
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15329838218417759)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100005)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow ID'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15330075455417759)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Users'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15330272796417759)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100005)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15330419281417759)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100005)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15330633016417759)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Name'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15330866593417759)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Model Name'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15331043366417759)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15331236032417759)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Expression Type'
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15331478319417760)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100005)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15331658816417760)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflow'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15331859646417760)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15332023420417760)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15332217274417760)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Potential Groups'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15332484922417760)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15332600168417760)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100005)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Client Id'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15332860895417760)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15333013976417760)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15333208992417760)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Id'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15333486484417760)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15333649824417760)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15333834828417760)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15334043604417760)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15334232204417760)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Became Current'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15334432239417760)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15334683886417760)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15334890476417760)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Id'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15335023457417760)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100005)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Status When Complete'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15335233793417760)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action'
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15335487284417760)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100005)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15335625185417761)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>148
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15335884672417777)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707325166232543.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707325166232543)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Inicio de temporizador el'
,p_translate_from_text=>'Timer Start On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15336068648417777)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334292029307024.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334292029307024)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15336239737417777)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108556668434749.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108556668434749)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C1mbito actual')
,p_translate_from_text=>'Current Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15336435786417777)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634089221220626.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634089221220626)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15336669179417777)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Atributos JSON'
,p_translate_from_text=>'Json Attributes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15336831516417777)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403481804171420.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403481804171420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Completed Link'
,p_translate_from_text=>'Instance Completed Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15337012716417777)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095177493304638.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095177493304638)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima actualizaci\00F3n')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15337279788417777)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632277733220608.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632277733220608)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15337471243417777)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519468528437207.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519468528437207)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuario'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15337652022417777)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333560161307017.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333560161307017)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15337839371417777)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515990329355424.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515990329355424)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15338033226417777)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095045075304637.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095045075304637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Fecha de creaci\00F3n')
,p_translate_from_text=>'Creation Date'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15338235910417777)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15338401588417777)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515621004355421.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515621004355421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Selecci\00F3n de versi\00F3n de diagrama llamada')
,p_translate_from_text=>'Called Diagram Version Selection'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15338686207417777)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15338838088417777)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862034420537218.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862034420537218)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Calling Objt'
,p_translate_from_text=>'Prdg Calling Objt'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15339076385417777)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498234451177027.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498234451177027)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuario'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15339245489417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497849830177023.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497849830177023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima actualizaci\00F3n')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15339483485417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959198304464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959198304464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto inicial'
,p_translate_from_text=>'Starting Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15339684555417778)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2348040743104547.100005)
,p_translate_from_id=>wwv_flow_imp.id(2348040743104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Correo de ayuda'
,p_translate_from_text=>'Support Email'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15339840415417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5958314416464441.100005)
,p_translate_from_id=>wwv_flow_imp.id(5958314416464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de proceso'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15340000328417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108363460434747.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108363460434747)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel actual'
,p_translate_from_text=>'Current Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15340271335417778)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094640100304633.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094640100304633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n de modelo')
,p_translate_from_text=>'Model Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15340422009417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634561735220631.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634561735220631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro de hora'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15340651533417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2500043890177045.100005)
,p_translate_from_id=>wwv_flow_imp.id(2500043890177045)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado al finalizar'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15340813923417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509835519851711.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509835519851711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor clave'
,p_translate_from_text=>'Key Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15341042950417778)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_translate_from_text=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15341254419417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5960359099464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5960359099464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('L\00EDnea')
,p_translate_from_text=>'Lane'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15341476175417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5960748117464443.100005)
,p_translate_from_id=>wwv_flow_imp.id(5960748117464443)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reservado para'
,p_translate_from_text=>'Reserved For'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15341664023417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12631588555220601.100005)
,p_translate_from_id=>wwv_flow_imp.id(12631588555220601)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15341895635417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509701785851710.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509701785851710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de clave'
,p_translate_from_text=>'Key Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15342012983417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519852365437211.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519852365437211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Objt Id'
,p_translate_from_text=>'Lgvr Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15342268401417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861339168537211.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861339168537211)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15342468694417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634921498220635.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634921498220635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15342608482417778)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516662153355431.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516662153355431)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tiene \00EDcono de recursi\00F3n')
,p_translate_from_text=>'Has Recursion Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15342825132417778)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5599113851964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5599113851964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sfte ID'
,p_translate_from_text=>'Sfte ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15343095163417778)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519982605437212.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519982605437212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15343257081417778)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Acci\00F3n r\00E1pida')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15343413254417779)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634112364220627.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634112364220627)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de instancia'
,p_translate_from_text=>'Instance Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15343615264417779)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154394973389234.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154394973389234)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15343859414417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8318543391792317.100005)
,p_translate_from_id=>wwv_flow_imp.id(8318543391792317)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15344063265417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15344254806417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142712189493911.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142712189493911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Vencimiento'
,p_translate_from_text=>'Due On'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15344440749417779)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519206569437205.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519206569437205)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15344672269417779)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402061088171406.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402061088171406)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Created Link'
,p_translate_from_text=>'Instance Created Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15344867803417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5974128075464466.100005)
,p_translate_from_id=>wwv_flow_imp.id(5974128075464466)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de proceso'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15345091319417779)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100005)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Acci\00F3n r\00E1pida')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15345284071417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510565399851718.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510565399851718)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creado'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15345444815417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5975357132464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5975357132464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15345600814417779)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520039666437213.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520039666437213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ejecuci\00F3n')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15345833742417779)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499246622177037.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499246622177037)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima finalizaci\00F3n')
,p_translate_from_text=>'Last Completed'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15346037072417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8318159619792316.100005)
,p_translate_from_id=>wwv_flow_imp.id(8318159619792316)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15346210345417779)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514302661355408.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514302661355408)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Llamada a Dgrm'
,p_translate_from_text=>'Calling Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15346419257417779)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968656354177916.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968656354177916)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15346613257417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108288395434746.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108288395434746)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Clase actual'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15346861436417779)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26093269879304619.100005)
,p_translate_from_id=>wwv_flow_imp.id(26093269879304619)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagram Parsed Icon'
,p_translate_from_text=>'Diagram Parsed Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15347030217417779)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861543233537213.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861543233537213)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C1mbito')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15347252663417779)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570545939899127.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570545939899127)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('ID est\00E1tico')
,p_translate_from_text=>'Static ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15347443838417779)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5974553661464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5974553661464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15347666559417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498307868177028.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498307868177028)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Convertir en actual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15347838292417780)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8027944385825648.100005)
,p_translate_from_id=>wwv_flow_imp.id(8027944385825648)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15348087833417780)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362185830158407.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362185830158407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15348248449417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Expresi\00F3n')
,p_translate_from_text=>'Expression'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15348419468417780)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333938342307021.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333938342307021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ejecuci\00F3n')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15348659300417780)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2496678063177011.100005)
,p_translate_from_id=>wwv_flow_imp.id(2496678063177011)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Dgrm Status Icon'
,p_translate_from_text=>'Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15348839715417780)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8320570260792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8320570260792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15349025068417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12633913021220625.100005)
,p_translate_from_id=>wwv_flow_imp.id(12633913021220625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de proceso'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15349263413417780)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403626861171422.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403626861171422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Terminated Link'
,p_translate_from_text=>'Instance Terminated Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15349428263417780)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12632064663220606.100005)
,p_translate_from_id=>wwv_flow_imp.id(12632064663220606)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto'
,p_translate_from_text=>'Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15349625258417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499725670177042.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499725670177042)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15349824670417780)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154978160389240.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154978160389240)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Paso'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15350088773417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519751631437210.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519751631437210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgvr Prcs Id'
,p_translate_from_text=>'Lgvr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15350208764417780)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142648848493910.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142648848493910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuarios excluidos'
,p_translate_from_text=>'Excluded Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15350452998417780)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631054458575812.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631054458575812)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15350616987417780)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155393549389244.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155393549389244)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15350886834417780)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515140710355416.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515140710355416)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama de llamada'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15351083311417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498574679177030.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498574679177030)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15351279551417780)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498470720177029.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498470720177029)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabajo iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15351494160417780)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510437164851717.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510437164851717)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Variable de carga \00FAtil')
,p_translate_from_text=>'Payload Variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15351673299417780)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214759985956131.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214759985956131)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15351810132417780)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214982358956133.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214982358956133)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Categor\00EDa')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15352010458417781)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100005)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flujo analizado'
,p_translate_from_text=>'Flow Parsed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15352289831417781)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403349213171419.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403349213171419)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Running Link'
,p_translate_from_text=>'Instance Running Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15352419426417781)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2500227841177047.100005)
,p_translate_from_id=>wwv_flow_imp.id(2500227841177047)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15352610409417781)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333803701307020.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333803701307020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15352818933417781)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498104800177026.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498104800177026)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel de proceso'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15353046286417781)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519121253437204.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519121253437204)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabajo iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15353250829417781)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938514653499708.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938514653499708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Id'
,p_translate_from_text=>'Prcs Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15353480755417781)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8320935355792320.100005)
,p_translate_from_id=>wwv_flow_imp.id(8320935355792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15353679742417781)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100005)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15353869949417781)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8028177005825650.100005)
,p_translate_from_id=>wwv_flow_imp.id(8028177005825650)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15354013691417781)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094328735304630.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094328735304630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de proceso'
,p_translate_from_text=>'Process ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15354270432417781)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176739527209912.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176739527209912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Status Icon'
,p_translate_from_text=>'Prcs Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15354405654417781)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634624072220632.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634624072220632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuario'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15354664853417781)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5518828206437201.100005)
,p_translate_from_id=>wwv_flow_imp.id(5518828206437201)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima finalizaci\00F3n')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15354849120417781)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514708342355412.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514708342355412)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Dgrm ra\00EDz')
,p_translate_from_text=>'Root Dgrm'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15355048629417781)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499658547177041.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499658547177041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15355244582417781)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154181074389232.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154181074389232)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro de hora'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15355426189417781)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215092633956134.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215092633956134)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima actualizaci\00F3n')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15355673799417781)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514438411355409.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514438411355409)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de llamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15355873854417781)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5974908646464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5974908646464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo'
,p_translate_from_text=>'Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15356079281417781)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959540044464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959540044464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima actualizaci\00F3n')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15356218008417782)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968036863177910.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968036863177910)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15356411392417782)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154601391389237.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154601391389237)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15356605442417782)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519571677437208.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519571677437208)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15356889190417782)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153860078389229.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153860078389229)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15357082875417782)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154237026389233.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154237026389233)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuario'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15357278113417782)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515879418355423.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515879418355423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama llamado'
,p_translate_from_text=>'Called Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15357451640417782)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_translate_from_text=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15357613176417782)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861128182537209.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861128182537209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15357858806417782)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861297901537210.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861297901537210)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15358079806417782)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631762547575819.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631762547575819)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Edit Link'
,p_translate_from_text=>'Edit Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15358247570417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5975755489464467.100005)
,p_translate_from_id=>wwv_flow_imp.id(5975755489464467)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-variables">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-variables">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15358438843417782)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5599982855964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5599982855964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JSON'
,p_translate_from_text=>'JSON'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15358607726417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8320162530792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8320162530792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuario'
,p_translate_from_text=>'User'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15358846236417782)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634221363220628.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634221363220628)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15359052729417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707438405232544.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707438405232544)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Timer Status Info'
,p_translate_from_text=>'Timer Status Info'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15359251438417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8319757479792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8319757479792319)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro de hora'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15359457048417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509620456851709.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509620456851709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de mensaje'
,p_translate_from_text=>'Message Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15359665811417782)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154803602389239.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154803602389239)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima finalizaci\00F3n')
,p_translate_from_text=>'Last Completed'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15359886533417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5958746107464441.100005)
,p_translate_from_id=>wwv_flow_imp.id(5958746107464441)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Actual'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15360026766417782)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497514462177020.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497514462177020)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel de proceso'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15360266595417782)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_translate_from_text=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15360477802417782)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55103850324434702.100005)
,p_translate_from_id=>wwv_flow_imp.id(55103850324434702)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de llamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15360617587417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634464623220630.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634464623220630)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15360891318417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154592436389236.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154592436389236)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15361069954417783)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515316439355418.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515316439355418)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de llamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15361296150417783)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55103738997434701.100005)
,p_translate_from_id=>wwv_flow_imp.id(55103738997434701)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00C1mbito')
,p_translate_from_text=>'Scope'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15361487217417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520162288437214.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520162288437214)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro de hora'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15361616858417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Evento'
,p_translate_from_text=>'Event'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15361881817417783)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142388218493907.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142388218493907)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prioridad'
,p_translate_from_text=>'Priority'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15362071720417783)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7335900830307041.100005)
,p_translate_from_id=>wwv_flow_imp.id(7335900830307041)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Status Icon'
,p_translate_from_text=>'Sbfl Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15362288129417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519340927437206.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519340927437206)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reserva'
,p_translate_from_text=>'Reservation'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15362406593417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pila de errores'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15362669911417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498769981177032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498769981177032)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15362824169417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155440068389245.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155440068389245)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima actualizaci\00F3n')
,p_translate_from_text=>'Last Update'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15363017158417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8028057953825649.100005)
,p_translate_from_id=>wwv_flow_imp.id(8028057953825649)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15363203318417783)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515215281355417.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515215281355417)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15363401561417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967924181177909.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967924181177909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ejecuci\00F3n')
,p_translate_from_text=>'Execution'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15363625826417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62703949642232509.100005)
,p_translate_from_id=>wwv_flow_imp.id(62703949642232509)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Clave de paso'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15363874009417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155010144389241.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155010144389241)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15364055552417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62704084243232510.100005)
,p_translate_from_id=>wwv_flow_imp.id(62704084243232510)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Clave de paso'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15364268198417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634757568220633.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634757568220633)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15364404968417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862209443537220.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862209443537220)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de BPMN'
,p_translate_from_text=>'Bpmn Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15364614712417783)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155119332389242.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155119332389242)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Convertir en actual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15364831596417783)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520261763437215.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520261763437215)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de datos'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15365053811417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861474746537212.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861474746537212)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15365221201417784)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214647255956130.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214647255956130)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15365420589417784)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100005)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15365667005417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968566434177915.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968566434177915)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pretag'
,p_translate_from_text=>'Pretag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15365831956417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635022832220636.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635022832220636)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Posttag'
,p_translate_from_text=>'Posttag'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15366074447417784)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515771897355422.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515771897355422)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n de diagrama llamada')
,p_translate_from_text=>'Called Diagram Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15366218797417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498080603177025.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498080603177025)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15366405082417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499950017177044.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499950017177044)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('\00DAltima finalizaci\00F3n')
,p_translate_from_text=>'Last Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15366627444417784)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403765313171423.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403765313171423)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instance Error Link'
,p_translate_from_text=>'Instance Error Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15366896212417784)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62703712227232507.100005)
,p_translate_from_id=>wwv_flow_imp.id(62703712227232507)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Clave de paso'
,p_translate_from_text=>'Step Key'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15367058177417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861857847537216.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861857847537216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prdg Id'
,p_translate_from_text=>'Prdg Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15367213651417784)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025669951825625.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025669951825625)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Label'
,p_translate_from_text=>'Quick Action Label'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15367474635417784)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155989994389250.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155989994389250)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel de proceso'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15367656108417784)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pila de errores'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15367836549417784)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333781214307019.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333781214307019)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Paso'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15368078420417784)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15368250338417784)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155200599389243.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155200599389243)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabajo iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15368498619417784)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632066723575822.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632066723575822)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all">'
,p_translate_from_text=>'<input type="checkbox" id="check-all">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15368646000417784)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2344837977104545.100005)
,p_translate_from_id=>wwv_flow_imp.id(2344837977104545)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15368894648417784)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108405946434748.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108405946434748)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Clase actual'
,p_translate_from_text=>'Current Class'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15369036767417784)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861933808537217.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861933808537217)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama de llamada'
,p_translate_from_text=>'Calling Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15369211781417785)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497713489177022.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497713489177022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Trabajo iniciado'
,p_translate_from_text=>'Work Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15369430364417785)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334155877307023.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334155877307023)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de datos'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15369621324417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104753757434711.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104753757434711)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Objeto de llamada'
,p_translate_from_text=>'Calling Object'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15369882347417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100005)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Pila de errores'
,p_translate_from_text=>'Error Stack'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15370090069417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15370201593417785)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154732961389238.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154732961389238)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel de proceso'
,p_translate_from_text=>'Process Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15370426566417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3509591891851708.100005)
,p_translate_from_id=>wwv_flow_imp.id(3509591891851708)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de Msub'
,p_translate_from_text=>'Msub Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15370662511417785)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40002069571317110.100005)
,p_translate_from_id=>wwv_flow_imp.id(40002069571317110)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-instances">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-instances">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15370897657417785)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2498623112177031.100005)
,p_translate_from_id=>wwv_flow_imp.id(2498623112177031)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Comentario'
,p_translate_from_text=>'Comment'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15371090591417785)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2345216929104546.100005)
,p_translate_from_id=>wwv_flow_imp.id(2345216929104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Descripci\00F3n')
,p_translate_from_text=>'Description'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15371277530417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025464938825623.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025464938825623)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Quick Action Icon'
,p_translate_from_text=>'Quick Action Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15371460032417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104683966434710.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104683966434710)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nivel'
,p_translate_from_text=>'Level'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15371633652417785)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado de modelo'
,p_translate_from_text=>'Model Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15371845838417785)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094816603304635.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094816603304635)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Categor\00EDa de modelo')
,p_translate_from_text=>'Model Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15372037099417785)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7333692011307018.100005)
,p_translate_from_id=>wwv_flow_imp.id(7333692011307018)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15372226825417785)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153710452389228.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153710452389228)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Id'
,p_translate_from_text=>'Lgpr Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15372440927417785)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9074998747505001.100005)
,p_translate_from_id=>wwv_flow_imp.id(9074998747505001)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Ruta de iteraci\00F3n')
,p_translate_from_text=>'Iteration Path'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15372645382417785)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515571460355420.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515571460355420)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15372895319417785)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968146627177911.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968146627177911)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Tipo de datos'
,p_translate_from_text=>'Data Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15373061544417785)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499312713177038.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499312713177038)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Actual'
,p_translate_from_text=>'Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15373269473417785)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334095231307022.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334095231307022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Registro de hora'
,p_translate_from_text=>'Timestamp'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15373486262417786)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15373613490417786)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104508785434709.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104508785434709)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de diagrama de llamada'
,p_translate_from_text=>'Calling Diagram ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15373818644417786)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2348409591104547.100005)
,p_translate_from_id=>wwv_flow_imp.id(2348409591104547)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URI de soporte'
,p_translate_from_text=>'Support Uri'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15374008334417786)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15374219538417786)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520341426437216.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520341426437216)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Valor'
,p_translate_from_text=>'Value'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15374475429417786)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63515059362355415.100005)
,p_translate_from_id=>wwv_flow_imp.id(63515059362355415)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15374601715417786)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5962397543464444.100005)
,p_translate_from_id=>wwv_flow_imp.id(5962397543464444)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<input type="checkbox" id="check-all-subflows">'
,p_translate_from_text=>'<input type="checkbox" id="check-all-subflows">'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15374832170417786)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631865848575820.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631865848575820)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Create Instance Link'
,p_translate_from_text=>'Create Instance Link'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15375089608417786)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tiene recursi\00F3n')
,p_translate_from_text=>'Has Recursion'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15375279354417786)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5958060753464437.100005)
,p_translate_from_id=>wwv_flow_imp.id(5958060753464437)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de subflujo'
,p_translate_from_text=>'Subflow ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15375420356417786)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142460053493908.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142460053493908)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Usuarios potenciales'
,p_translate_from_text=>'Potential Users'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15375651804417786)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8318997702792318.100005)
,p_translate_from_id=>wwv_flow_imp.id(8318997702792318)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15375871873417786)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15357984541942527.100005)
,p_translate_from_id=>wwv_flow_imp.id(15357984541942527)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prcs Dgrm Status Icon'
,p_translate_from_text=>'Prcs Dgrm Status Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15376082064417786)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5599594716964022.100005)
,p_translate_from_id=>wwv_flow_imp.id(5599594716964022)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15376278245417786)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094567431304632.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094567431304632)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de modelo'
,p_translate_from_text=>'Model Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15376400939417786)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15376696804417786)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968285150177912.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968285150177912)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Tipo de expresi\00F3n')
,p_translate_from_text=>'Expression Type'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15376861688417786)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5151886864389209.100005)
,p_translate_from_id=>wwv_flow_imp.id(5151886864389209)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Sbfl Prcs Id'
,p_translate_from_text=>'Sbfl Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15377080803417786)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155819906389249.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155819906389249)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Subflujo'
,p_translate_from_text=>'Subflow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15377246451417786)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_translate_from_text=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15377444112417786)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499485991177039.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499485991177039)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15377613204417787)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142511739493909.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142511739493909)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Grupos potenciales'
,p_translate_from_text=>'Potential Groups'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15377806458417787)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968441007177914.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968441007177914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Diagrama'
,p_translate_from_text=>'Diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15378068702417787)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2346812012104546.100005)
,p_translate_from_id=>wwv_flow_imp.id(2346812012104546)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de cliente'
,p_translate_from_text=>'Client Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15378266670417787)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_translate_from_text=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15378441248417787)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214554954956129.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214554954956129)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15378678924417787)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862183787537219.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862183787537219)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID de Dgrm'
,p_translate_from_text=>'Dgrm Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15378862914417787)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155719517389248.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155719517389248)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Paso'
,p_translate_from_text=>'Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15379089637417787)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5519010082437203.100005)
,p_translate_from_id=>wwv_flow_imp.id(5519010082437203)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Convertir en actual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15379251123417787)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15379488749417787)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2499855288177043.100005)
,p_translate_from_id=>wwv_flow_imp.id(2499855288177043)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Objt Id'
,p_translate_from_text=>'Lgsf Objt Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15379683774417787)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2497666535177021.100005)
,p_translate_from_id=>wwv_flow_imp.id(2497666535177021)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Convertir en actual'
,p_translate_from_text=>'Became Current'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15379814651417787)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5155663147389247.100005)
,p_translate_from_id=>wwv_flow_imp.id(5155663147389247)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgsf Prcs Id'
,p_translate_from_text=>'Lgsf Prcs Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15380098695417787)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5153901442389230.100005)
,p_translate_from_id=>wwv_flow_imp.id(5153901442389230)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Business Reference'
,p_translate_from_text=>'Business Reference'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15380260492417787)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63514228675355407.100005)
,p_translate_from_id=>wwv_flow_imp.id(63514228675355407)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ID'
,p_translate_from_text=>'Id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15380455341417787)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5518927623437202.100005)
,p_translate_from_id=>wwv_flow_imp.id(5518927623437202)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado al finalizar'
,p_translate_from_text=>'Status When Complete'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15380693451417787)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Acci\00F3n r\00E1pida')
,p_translate_from_text=>'Quick Action'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15380814535417787)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6432711704417637.100005)
,p_translate_from_id=>wwv_flow_imp.id(6432711704417637)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Is Gateway Route'
,p_translate_from_text=>'Is Gateway Route'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15381056306417787)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176982328209914.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176982328209914)
,p_translate_column_id=>149
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Lgpr Prcs Event Icon'
,p_translate_from_text=>'Lgpr Prcs Event Icon'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15381265531417803)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094928056304636.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094928056304636)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_translate_from_text=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15381411341417803)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401735853171403.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401735853171403)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15381632469417803)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107985121434743.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107985121434743)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_translate_from_text=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15381882939417803)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5154065346389231.100005)
,p_translate_from_id=>wwv_flow_imp.id(5154065346389231)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15382062623417803)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8319379673792319.100005)
,p_translate_from_id=>wwv_flow_imp.id(8319379673792319)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15382280592417803)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025569156825624.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025569156825624)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15382458508417804)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8024079343825609.100005)
,p_translate_from_id=>wwv_flow_imp.id(8024079343825609)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15382689748417804)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968337862177913.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968337862177913)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_translate_from_text=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15382878791417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26092727630304614.100005)
,p_translate_from_id=>wwv_flow_imp.id(26092727630304614)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_translate_from_text=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15383071088417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401973271171405.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401973271171405)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15383291669417804)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5976199322464468.100005)
,p_translate_from_id=>wwv_flow_imp.id(5976199322464468)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15383446655417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401808911171404.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401808911171404)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15383633325417804)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634312423220629.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634312423220629)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_translate_from_text=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15383862115417804)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12634874560220634.100005)
,p_translate_from_id=>wwv_flow_imp.id(12634874560220634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15384030686417804)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177795465209922.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177795465209922)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15384244320417804)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5961953081464444.100005)
,p_translate_from_id=>wwv_flow_imp.id(5961953081464444)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15384423807417804)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5959935453464442.100005)
,p_translate_from_id=>wwv_flow_imp.id(5959935453464442)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_translate_from_text=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15384658225417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34401608353171402.100005)
,p_translate_from_id=>wwv_flow_imp.id(34401608353171402)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15384840784417804)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516512604355430.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516512604355430)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_translate_from_text=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15385064938417804)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8321340756792320.100005)
,p_translate_from_id=>wwv_flow_imp.id(8321340756792320)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_translate_from_text=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15385236038417804)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094739199304634.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094739199304634)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15385470176417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24214844713956132.100005)
,p_translate_from_id=>wwv_flow_imp.id(24214844713956132)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15385644130417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215123061956135.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215123061956135)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15385815275417804)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510601685851719.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510601685851719)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15386084954417804)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34403520844171421.100005)
,p_translate_from_id=>wwv_flow_imp.id(34403520844171421)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_translate_from_text=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15386267736417805)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26095284298304639.100005)
,p_translate_from_id=>wwv_flow_imp.id(26095284298304639)
,p_translate_column_id=>150
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15386447572417807)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26094452210304631.100005)
,p_translate_from_id=>wwv_flow_imp.id(26094452210304631)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#PRCS_NAME#'
,p_translate_from_text=>'#PRCS_NAME#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15386649605417807)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24215292671956136.100005)
,p_translate_from_id=>wwv_flow_imp.id(24215292671956136)
,p_translate_column_id=>151
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#INSTANCES#'
,p_translate_from_text=>'#INSTANCES#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15386813919417809)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(52324545630147899359.100005)
,p_translate_from_id=>wwv_flow_imp.id(52324545630147899359)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flujos para APEX: Visor'
,p_translate_from_text=>'Flows for APEX - Viewer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15387059195417809)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(116648167005824213.100005)
,p_translate_from_id=>wwv_flow_imp.id(116648167005824213)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Modelador'
,p_translate_from_text=>'Flows for APEX - Modeler'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15387247409417809)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100005)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15387490437417809)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100005)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Variables'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Variables'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15387614470417810)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100005)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Manage Flow Instance Step'
,p_translate_from_text=>'Flows for APEX - Manage Flow Instance Step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15387858977417810)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(92418934266670712.100005)
,p_translate_from_id=>wwv_flow_imp.id(92418934266670712)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_translate_from_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15388014574417810)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(84719765847460987.100005)
,p_translate_from_id=>wwv_flow_imp.id(84719765847460987)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_translate_from_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15388239223417810)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(151286992364012459.100005)
,p_translate_from_id=>wwv_flow_imp.id(151286992364012459)
,p_translate_column_id=>238
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_translate_from_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15388484749417811)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>257
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Privilegios insuficientes; el usuario no es administrador'
,p_translate_from_text=>'Insufficient privileges, user is not an Administrator'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15388619854417811)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Por hora'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15388871810417811)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Por hora'
,p_translate_from_text=>'Hourly'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15389017436417811)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 a\00F1o')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15389238679417811)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 a\00F1o')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15389410898417811)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 a\00F1o')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15389683508417811)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('A\00F1o I')
,p_translate_from_text=>'I Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15389872870417811)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>258
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('5 a\00F1os')
,p_translate_from_text=>'5 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15390095829417812)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 min'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15390200344417812)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10 min'
,p_translate_from_text=>'10 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15390411258417812)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15390663950417812)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15390853155417812)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15391014504417812)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'9 meses'
,p_translate_from_text=>'9 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15391238183417812)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>259
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('4 a\00F1os')
,p_translate_from_text=>'4 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15391469763417813)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 min'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15391679059417813)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'5 min'
,p_translate_from_text=>'5 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15391849328417813)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15392007932417813)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15392235401417813)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15392454764417813)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6 meses'
,p_translate_from_text=>'6 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15392638035417813)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>260
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('3 a\00F1os')
,p_translate_from_text=>'3 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15392836215417814)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 minuto'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15393010014417814)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1 minuto'
,p_translate_from_text=>'1 Min'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15393290304417814)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15393461487417814)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15393646708417814)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15393849137417814)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3 meses'
,p_translate_from_text=>'3 Months'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15394037610417815)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>261
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('2 a\00F1os')
,p_translate_from_text=>'2 Years'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15394230724417815)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 segundos (uso de producci\00F3n - no para apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15394403125417815)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('10 segundos (uso de producci\00F3n - no para apex.oracle.com)')
,p_translate_from_text=>'10 Sec (Production Use - not for apex.oracle.com)'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15394626101417815)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 d\00EDas')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15394834855417815)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 d\00EDas')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15395028862417816)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('30 d\00EDas')
,p_translate_from_text=>'30 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15395245172417816)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>262
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('1 a\00F1o')
,p_translate_from_text=>'1 Year'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15395427108417816)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 d\00EDas')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15395680072417816)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 d\00EDas')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15395890951417816)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>263
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('14 d\00EDas')
,p_translate_from_text=>'14 Days'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15396094789417817)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15396229925417817)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15396425074417817)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15396642760417817)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15396895572417817)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15397031854417817)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100005)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15397240487417817)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15397458363417817)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5956770983464421.100005)
,p_translate_from_id=>wwv_flow_imp.id(5956770983464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15397609132417817)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15397898554417818)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591377686964017.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591377686964017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15398011652417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15398285482417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681628052037016.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681628052037016)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15398468676417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3748085871530344.100005)
,p_translate_from_id=>wwv_flow_imp.id(3748085871530344)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15398654954417818)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15398810979417818)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15399056710417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681551841037015.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681551841037015)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15399223387417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15399458040417818)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15399655296417818)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3508955560851702.100005)
,p_translate_from_id=>wwv_flow_imp.id(3508955560851702)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15399800229417818)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(22800638443488045.100005)
,p_translate_from_id=>wwv_flow_imp.id(22800638443488045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15400030532417818)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15400217021417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5979272276464470.100005)
,p_translate_from_id=>wwv_flow_imp.id(5979272276464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15400477343417818)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15400621613417818)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100005)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15400842821417818)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100005)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15401024225417818)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681710279037017.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681710279037017)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15401229342417818)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7335361967307035.100005)
,p_translate_from_id=>wwv_flow_imp.id(7335361967307035)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15401412993417818)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7104945910320975.100005)
,p_translate_from_id=>wwv_flow_imp.id(7104945910320975)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15401629273417818)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803255576176614.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803255576176614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15401841995417819)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7336470700307046.100005)
,p_translate_from_id=>wwv_flow_imp.id(7336470700307046)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15402044673417819)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34634208559575844.100005)
,p_translate_from_id=>wwv_flow_imp.id(34634208559575844)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15402216628417819)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491864731021262829.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491864731021262829)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15402432121417819)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33735715098406128.100005)
,p_translate_from_id=>wwv_flow_imp.id(33735715098406128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15402670103417819)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5152076251389211.100005)
,p_translate_from_id=>wwv_flow_imp.id(5152076251389211)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15402800007417819)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15403094336417819)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15403270905417819)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036250500569041.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036250500569041)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15403450795417819)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15403631292417819)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15403893036417819)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362364494158409.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362364494158409)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15404092507417819)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15404229597417819)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24211819068956102.100005)
,p_translate_from_id=>wwv_flow_imp.id(24211819068956102)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15404413120417819)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15356359428942511.100005)
,p_translate_from_id=>wwv_flow_imp.id(15356359428942511)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15404619261417819)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15404894486417819)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15405072080417819)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15405276797417819)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143450803493918.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143450803493918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15405488878417819)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15405609856417819)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601607926220614.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601607926220614)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15405852519417819)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5972826023464463.100005)
,p_translate_from_id=>wwv_flow_imp.id(5972826023464463)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15406089364417820)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'6'
,p_translate_from_text=>'6'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15406222076417820)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100005)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15406477398417820)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429631498417606.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429631498417606)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15406688981417820)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7335483836307036.100005)
,p_translate_from_id=>wwv_flow_imp.id(7335483836307036)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15406829839417820)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15407017418417820)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15407250555417820)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100005)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15407472012417820)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(42701880150211103.100005)
,p_translate_from_id=>wwv_flow_imp.id(42701880150211103)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15407613324417820)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100005)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15407897819417820)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15408007274417820)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15408274050417820)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737496021406145.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737496021406145)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15408479245417820)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7129192978323670.100005)
,p_translate_from_id=>wwv_flow_imp.id(7129192978323670)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15408622858417820)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803477939176616.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803477939176616)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15408881336417820)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55108658269434750.100005)
,p_translate_from_id=>wwv_flow_imp.id(55108658269434750)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15409051491417820)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15409258642417820)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15409441278417820)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601485306220612.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601485306220612)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15409682457417820)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'APEX_APPLICATION_TEMP_FILES'
,p_translate_from_text=>'APEX_APPLICATION_TEMP_FILES'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15409881799417820)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15410007474417821)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632201368575824.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632201368575824)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15410225079417821)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803138381176613.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803138381176613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15410445627417821)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15410622645417821)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15410854661417821)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5980365397464471.100005)
,p_translate_from_id=>wwv_flow_imp.id(5980365397464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15411026696417821)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15411284502417821)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15411477164417821)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15411619615417821)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2448762581538242.100005)
,p_translate_from_id=>wwv_flow_imp.id(2448762581538242)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15411864294417821)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15412099862417821)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15412274419417821)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5980714077464471.100005)
,p_translate_from_id=>wwv_flow_imp.id(5980714077464471)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15412451889417821)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15412680980417821)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145861612493942.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145861612493942)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15412862836417821)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100005)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15413070480417821)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15413255211417821)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15413494003417821)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522035116864941.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522035116864941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15413622266417821)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15413873684417821)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15414068333417821)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15414264292417822)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15414425904417822)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15414667454417822)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512743931851740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512743931851740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15414811724417822)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601505679220613.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601505679220613)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15415039114417822)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15415263135417822)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'3'
,p_translate_from_text=>'3'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15415470244417822)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15415674690417822)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15415827183417822)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15416093996417822)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60861623457537214.100005)
,p_translate_from_id=>wwv_flow_imp.id(60861623457537214)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15416253047417822)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7104565818320974.100005)
,p_translate_from_id=>wwv_flow_imp.id(7104565818320974)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15416469916417822)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429967240417609.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429967240417609)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15416601708417822)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15416864045417822)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7336335344307045.100005)
,p_translate_from_id=>wwv_flow_imp.id(7336335344307045)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15417099079417822)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15681777930738608.100005)
,p_translate_from_id=>wwv_flow_imp.id(15681777930738608)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15417252484417822)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15417413515417822)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15417624139417822)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271519975238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271519975238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15417863729417822)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15418021709417822)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15418225483417822)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003369119877940.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003369119877940)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15418407448417823)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681957862037019.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681957862037019)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15418631053417823)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15418833343417823)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15419068210417823)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17600676567220604.100005)
,p_translate_from_id=>wwv_flow_imp.id(17600676567220604)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15419250400417823)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8026927386825638.100005)
,p_translate_from_id=>wwv_flow_imp.id(8026927386825638)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15419455788417823)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24212748636956111.100005)
,p_translate_from_id=>wwv_flow_imp.id(24212748636956111)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15419635277417823)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5979971726464470.100005)
,p_translate_from_id=>wwv_flow_imp.id(5979971726464470)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15419884099417823)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176260695209907.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176260695209907)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15420008409417823)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036320570569042.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036320570569042)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15420217664417823)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15420416760417823)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100005)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15420682387417823)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15420891627417823)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722790490681902.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722790490681902)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15421097366417823)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7104199777320970.100005)
,p_translate_from_id=>wwv_flow_imp.id(7104199777320970)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15421203901417823)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15421446407417823)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15421695193417823)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100005)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15421881425417823)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15422010968417823)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681449489037014.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681449489037014)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15422211924417823)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55103924099434703.100005)
,p_translate_from_id=>wwv_flow_imp.id(55103924099434703)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15422453231417823)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15422618690417823)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602168797220619.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602168797220619)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15422848295417824)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145742635493941.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145742635493941)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15423069075417824)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7336178189307043.100005)
,p_translate_from_id=>wwv_flow_imp.id(7336178189307043)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15423221329417824)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5955943099464415.100005)
,p_translate_from_id=>wwv_flow_imp.id(5955943099464415)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15423425161417824)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967195584177901.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967195584177901)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15423622861417824)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100005)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'12'
,p_translate_from_text=>'12'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15423861347417824)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15424014589417824)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15424297375417824)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26093937239304626.100005)
,p_translate_from_id=>wwv_flow_imp.id(26093937239304626)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15424444388417824)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15424697199417824)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433507492417645.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433507492417645)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15424827185417824)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15425090555417824)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100005)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'2'
,p_translate_from_text=>'2'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15425238689417824)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495493384485879899.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495493384485879899)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'1'
,p_translate_from_text=>'1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15425441358417824)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15425643561417824)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143539142493919.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143539142493919)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15425884625417824)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15426073782417824)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5681806442037018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5681806442037018)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15426298392417824)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707796384232547.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707796384232547)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15426403845417824)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15426664116417824)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15426832245417824)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15427065269417825)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'4'
,p_translate_from_text=>'4'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15427259410417825)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15427461836417825)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100005)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15427674396417825)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161978411223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161978411223080)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15427834726417825)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15428083305417825)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511819715851731.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511819715851731)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15428259400417825)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15428434366417825)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2448870230538243.100005)
,p_translate_from_id=>wwv_flow_imp.id(2448870230538243)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15428633497417825)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145950517493943.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145950517493943)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15428852721417825)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15429073312417825)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15429285205417825)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334592520307027.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334592520307027)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15429442107417825)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100005)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15429608306417825)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15429802267417825)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15430045834417825)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15430290101417825)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15430468491417825)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100005)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15430641456417825)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19000655987190889.100005)
,p_translate_from_id=>wwv_flow_imp.id(19000655987190889)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15430883729417825)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15431008508417825)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7334819132307030.100005)
,p_translate_from_id=>wwv_flow_imp.id(7334819132307030)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15431240958417825)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ROW'
,p_translate_from_text=>'ROW'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15431423796417826)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2333737125104527.100005)
,p_translate_from_id=>wwv_flow_imp.id(2333737125104527)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15431664592417826)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270703706238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270703706238363)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15431868810417826)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512603514851739.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512603514851739)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15432072148417826)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>268
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15432234145417838)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15432326279417838)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513290888851745.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513290888851745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15432529166417838)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15432710910417838)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513352883851746.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513352883851746)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15432965644417839)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15433164124417839)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100005)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15433325323417839)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15433564735417839)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15433757296417839)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15433929547417839)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15434160774417839)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107680657434740.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107680657434740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15434396727417839)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15434577281417839)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15434700055417839)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15434976957417839)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15435132590417839)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15435317176417839)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15435579574417839)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15435722587417839)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100005)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15435955260417839)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10431588640468049.100005)
,p_translate_from_id=>wwv_flow_imp.id(10431588640468049)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15436145166417839)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15436316688417839)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15436581349417839)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15436742345417840)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5956326391464421.100005)
,p_translate_from_id=>wwv_flow_imp.id(5956326391464421)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15436910278417840)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15437167920417840)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15437396628417840)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15437505341417840)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15437768295417840)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513116353851744.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513116353851744)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15437997492417840)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983769209464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983769209464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15438192643417840)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100005)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15438351844417840)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15438506752417840)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601740723220615.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601740723220615)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15438756129417840)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15438963016417840)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15439121185417840)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15439389026417840)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15439586897417840)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744055656530304.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744055656530304)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15439732103417840)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15439916947417840)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15440169255417840)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15440312919417840)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'+0d'
,p_translate_from_text=>'+0d'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15440504296417840)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15440785481417840)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15440948073417841)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100005)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15441177075417841)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15441317120417841)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15441548207417841)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15441733019417841)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15441922232417841)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15442100466417841)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15442377706417841)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107419799434738.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107419799434738)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15442526859417841)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15442735819417841)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15442915012417841)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15443174846417841)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513035181851743.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513035181851743)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15443305823417841)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15443589693417841)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15443784087417841)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34632505849575827.100005)
,p_translate_from_id=>wwv_flow_imp.id(34632505849575827)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15443938822417841)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15444111203417841)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15444344849417841)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15444538354417841)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15444721739417841)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15444908082417841)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747603686530340.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747603686530340)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15445153141417842)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15445303514417842)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100005)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15445505705417842)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15445723903417842)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15445992055417842)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3513454878851747.100005)
,p_translate_from_id=>wwv_flow_imp.id(3513454878851747)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15446192410417842)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100005)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15446398292417842)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15446574866417842)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15446757849417842)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100005)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15446993102417842)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100005)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15447149761417842)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15447354204417842)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15447552398417842)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15447793231417842)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'true'
,p_translate_from_text=>'true'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15447938029417842)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15448123196417842)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15448303155417842)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15448532495417842)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15448706837417842)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15448977871417842)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15449195879417842)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15449310376417843)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15449578936417843)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100005)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VALUE'
,p_translate_from_text=>'VALUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15449776688417843)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15449908284417843)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100005)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15450181253417843)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FIRST_ROWSET'
,p_translate_from_text=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15450314506417843)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15450554865417843)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035540233569034.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035540233569034)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FACET'
,p_translate_from_text=>'FACET'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15450728864417843)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15450971270417843)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15451148858417843)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100005)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15451397353417843)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15451583252417843)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TRUE'
,p_translate_from_text=>'TRUE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15451708678417843)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>269
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15451991813417866)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15452179287417866)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15452375383417866)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15452526563417866)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15452732045417866)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15452927170417866)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100005)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15453117376417867)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15453333541417867)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722861639681903.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722861639681903)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15453570040417867)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15453707718417867)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15453965722417867)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100005)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'left'
,p_translate_from_text=>'left'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15454191701417867)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15454396413417867)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15454510987417867)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15454723813417867)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15454917267417867)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15455192194417867)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15455377316417867)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984552376464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984552376464474)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15455565525417867)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15455799032417867)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Yes'
,p_translate_from_text=>'Yes'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15455900089417867)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15456116410417867)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'right'
,p_translate_from_text=>'right'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15456394267417867)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15456562069417867)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15456753138417867)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15456949454417867)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>270
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'enabled'
,p_translate_from_text=>'enabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15457196742417870)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15457302711417870)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15457589739417870)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15457785143417870)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100005)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15457937344417870)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510991975851722.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510991975851722)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15458116785417870)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5985303463464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5985303463464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15458358895417870)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15458510133417870)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15458793751417870)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15458981582417870)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15459125402417870)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15459360250417870)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15459583763417870)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15459744036417870)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15459960236417870)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15460172018417870)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100005)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15460381701417870)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15460565805417871)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15460721357417871)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15460933996417871)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15461129449417871)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15461354383417871)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15461532693417871)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15461766464417871)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73479633336995802.100005)
,p_translate_from_id=>wwv_flow_imp.id(73479633336995802)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15461908275417871)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15462168692417871)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15462325625417871)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15462587120417871)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15462781452417871)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15462985649417871)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418616934878745.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418616934878745)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15463115725417871)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'both'
,p_translate_from_text=>'both'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15463398836417871)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15463532159417871)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15463731505417871)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'button'
,p_translate_from_text=>'button'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15463935051417871)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100005)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15464112684417871)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15464319777417871)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15464564106417871)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15464787234417872)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15464975193417872)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15465194135417872)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15465348655417872)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15465518677417872)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5592198462964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5592198462964018)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15465702756417872)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15465957727417872)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001433995190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001433995190900)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15466167845417872)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15466388936417872)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15466593560417872)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15466709825417872)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15466923644417872)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15467192619417872)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15467339143417872)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'URL'
,p_translate_from_text=>'URL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15467578361417872)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100005)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15467786769417872)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068819919119733.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068819919119733)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15467966507417872)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177972762209924.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177972762209924)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15468114568417872)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15468334083417872)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15468556894417872)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15468745134417873)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'false'
,p_translate_from_text=>'false'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15468914569417873)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15469130002417873)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15469384234417873)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15469513655417873)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15469763399417873)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334540817104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334540817104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15469942248417873)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15470131483417873)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15470318680417873)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100005)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15470503414417873)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15470732377417873)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100005)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15470996210417873)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15471146140417873)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15471303287417873)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15471507207417873)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15471791395417873)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100005)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15471953298417873)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15472109133417873)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FALSE'
,p_translate_from_text=>'FALSE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15472302673417873)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>271
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'EMAIL'
,p_translate_from_text=>'EMAIL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15472541886417880)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26068279548227242.100005)
,p_translate_from_id=>wwv_flow_imp.id(26068279548227242)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15472706947417880)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15472908276417880)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15473123863417880)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3250052219234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3250052219234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15473389281417880)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481033389804665.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481033389804665)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15473561370417880)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865492429262836.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865492429262836)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15473750815417880)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15473952971417880)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743758890530301.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743758890530301)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15474118589417880)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17601343709220611.100005)
,p_translate_from_id=>wwv_flow_imp.id(17601343709220611)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15474326465417880)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26003724086877950.100005)
,p_translate_from_id=>wwv_flow_imp.id(26003724086877950)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15474533191417880)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004547057877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004547057877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15474715043417880)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743862263530302.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743862263530302)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15474940220417880)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3743975741530303.100005)
,p_translate_from_id=>wwv_flow_imp.id(3743975741530303)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15475142967417880)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11480685064804664.100005)
,p_translate_from_id=>wwv_flow_imp.id(11480685064804664)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15475391365417880)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277996439238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277996439238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15475531992417880)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142839389493912.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142839389493912)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15475784422417880)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15475940467417880)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287364553239514.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287364553239514)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15476192362417880)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271952589238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271952589238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15476324833417880)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19002654728190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19002654728190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15476516605417881)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15476720333417881)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334144599104530.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334144599104530)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15476975037417881)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001891912190900.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001891912190900)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15477188116417881)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15477364929417881)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335329517104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335329517104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15477583674417881)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570664007899128.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570664007899128)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15477787430417881)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3271184455238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3271184455238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15477993523417881)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15478186099417881)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15478375469417881)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2361513976158401.100005)
,p_translate_from_id=>wwv_flow_imp.id(2361513976158401)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15478568314417881)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11481474672804666.100005)
,p_translate_from_id=>wwv_flow_imp.id(11481474672804666)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15478757675417881)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5591745755964018.100005)
,p_translate_from_id=>wwv_flow_imp.id(5591745755964018)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15478986716417881)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136262120214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136262120214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15479147153417881)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15479310262417881)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3341734890779729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3341734890779729)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15479522223417881)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15479743314417881)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15479900103417881)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15480151195417881)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34631117879575813.100005)
,p_translate_from_id=>wwv_flow_imp.id(34631117879575813)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15480340531417881)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3325454520527225.100005)
,p_translate_from_id=>wwv_flow_imp.id(3325454520527225)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15480504280417881)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15480783319417882)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2335706591104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2335706591104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15480902462417882)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336591473104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336591473104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15481143346417882)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3744138186530305.100005)
,p_translate_from_id=>wwv_flow_imp.id(3744138186530305)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15481308545417882)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11488208038948201.100005)
,p_translate_from_id=>wwv_flow_imp.id(11488208038948201)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15481518872417882)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3277540906238367.100005)
,p_translate_from_id=>wwv_flow_imp.id(3277540906238367)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15481723333417882)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3270397696238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3270397696238363)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15481901579417882)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3161511927223080.100005)
,p_translate_from_id=>wwv_flow_imp.id(3161511927223080)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'No'
,p_translate_from_text=>'No'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15482138383417882)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747558988530339.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747558988530339)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15482354996417882)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984111734464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984111734464474)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15482503670417882)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(63516095778355425.100005)
,p_translate_from_id=>wwv_flow_imp.id(63516095778355425)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15482776483417882)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3136630459214455.100005)
,p_translate_from_id=>wwv_flow_imp.id(3136630459214455)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15482965086417882)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15483136544417882)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26401222533737000.100005)
,p_translate_from_id=>wwv_flow_imp.id(26401222533737000)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15483358526417882)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004901378877959.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004901378877959)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15483563220417882)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5983384367464473.100005)
,p_translate_from_id=>wwv_flow_imp.id(5983384367464473)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15483722477417882)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7068442550119727.100005)
,p_translate_from_id=>wwv_flow_imp.id(7068442550119727)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15483937735417882)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491865909625262841.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491865909625262841)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15484155179417882)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2334919752104531.100005)
,p_translate_from_id=>wwv_flow_imp.id(2334919752104531)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15484315082417882)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15484500611417882)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19001062236190895.100005)
,p_translate_from_id=>wwv_flow_imp.id(19001062236190895)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15484743981417882)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26004107468877957.100005)
,p_translate_from_id=>wwv_flow_imp.id(26004107468877957)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15484913393417883)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6179426398209939.100005)
,p_translate_from_id=>wwv_flow_imp.id(6179426398209939)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLAIN'
,p_translate_from_text=>'PLAIN'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15485110102417883)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5655634694360001.100005)
,p_translate_from_id=>wwv_flow_imp.id(5655634694360001)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15485360941417883)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2336147036104532.100005)
,p_translate_from_id=>wwv_flow_imp.id(2336147036104532)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15485575854417883)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3249682912234740.100005)
,p_translate_from_id=>wwv_flow_imp.id(3249682912234740)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'disabled'
,p_translate_from_text=>'disabled'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15485771224417883)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3287449524239515.100005)
,p_translate_from_id=>wwv_flow_imp.id(3287449524239515)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15485970426417883)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>272
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BOTH'
,p_translate_from_text=>'BOTH'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15486138290417888)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707843061232548.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707843061232548)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15486360374417888)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5984956372464474.100005)
,p_translate_from_id=>wwv_flow_imp.id(5984956372464474)
,p_translate_column_id=>274
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'NONE'
,p_translate_from_text=>'NONE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15486581991417889)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>276
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REQUEST'
,p_translate_from_text=>'REQUEST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15486719688417889)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>277
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15486955898417889)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19008825550190910.100005)
,p_translate_from_id=>wwv_flow_imp.id(19008825550190910)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P6_DGRM_ID'
,p_translate_from_text=>'P6_DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15487195010417889)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REGION_SOURCE'
,p_translate_from_text=>'REGION_SOURCE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15487356666417889)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19019994508332917.100005)
,p_translate_from_id=>wwv_flow_imp.id(19019994508332917)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15487510566417889)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495490821799879882.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495490821799879882)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15487728080417889)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(160797930317501982.100005)
,p_translate_from_id=>wwv_flow_imp.id(160797930317501982)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_ID,P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15487935161417890)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(22800039236488039.100005)
,p_translate_from_id=>wwv_flow_imp.id(22800039236488039)
,p_translate_column_id=>278
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CLEAR_CACHE_CURRENT_PAGE'
,p_translate_from_text=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15488199938417890)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>282
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15488380952417891)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>283
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15488514790417891)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3512846601851741.100005)
,p_translate_from_id=>wwv_flow_imp.id(3512846601851741)
,p_translate_column_id=>285
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15488701731417891)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100005)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15488931508417891)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100005)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15489183704417891)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15489337572417891)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8324491461815477.100005)
,p_translate_from_id=>wwv_flow_imp.id(8324491461815477)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15489552548417891)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33736700260406138.100005)
,p_translate_from_id=>wwv_flow_imp.id(33736700260406138)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15489777064417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6012103981464528.100005)
,p_translate_from_id=>wwv_flow_imp.id(6012103981464528)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
,p_translate_from_text=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15489959358417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6027533621464536.100005)
,p_translate_from_id=>wwv_flow_imp.id(6027533621464536)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15490137313417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15490399718417892)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(29602959246125302.100005)
,p_translate_from_id=>wwv_flow_imp.id(29602959246125302)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15490528006417892)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15490748703417892)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15490937929417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5997186082464520.100005)
,p_translate_from_id=>wwv_flow_imp.id(5997186082464520)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15491187331417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15491315050417892)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15491510279417892)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15491763120417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6005023363464524.100005)
,p_translate_from_id=>wwv_flow_imp.id(6005023363464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
,p_translate_from_text=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15491924554417892)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5521906942864940.100005)
,p_translate_from_id=>wwv_flow_imp.id(5521906942864940)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15492105132417892)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16958768897050251.100005)
,p_translate_from_id=>wwv_flow_imp.id(16958768897050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
,p_translate_from_text=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15492382503417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15492548642417892)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15492702489417892)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100005)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15492915192417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15493155704417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100005)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15493319748417892)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15493539609417892)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15493725407417892)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15493904845417893)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5998953651464521.100005)
,p_translate_from_id=>wwv_flow_imp.id(5998953651464521)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15494176064417893)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'STATIC_ASSIGNMENT'
,p_translate_from_text=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15494378498417893)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELEASE'
,p_translate_from_text=>'RELEASE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15494599761417893)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DEPRECATE'
,p_translate_from_text=>'DEPRECATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15494714313417893)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100005)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15494985453417893)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6432965813417639.100005)
,p_translate_from_id=>wwv_flow_imp.id(6432965813417639)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15495175888417893)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737098416406141.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737098416406141)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15495362262417893)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747195167530335.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747195167530335)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15495547125417893)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6017642167464531.100005)
,p_translate_from_id=>wwv_flow_imp.id(6017642167464531)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15495796150417893)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24414806355878707.100005)
,p_translate_from_id=>wwv_flow_imp.id(24414806355878707)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15495966844417893)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100005)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_translate_from_text=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15496105819417893)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4300813188764310.100005)
,p_translate_from_id=>wwv_flow_imp.id(4300813188764310)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15496312334417893)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5520525401437218.100005)
,p_translate_from_id=>wwv_flow_imp.id(5520525401437218)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15496587425417893)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100005)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15496756950417893)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522263817864943.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522263817864943)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
,p_translate_from_text=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15496976632417893)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100005)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15497132600417893)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3796393337966657.100005)
,p_translate_from_id=>wwv_flow_imp.id(3796393337966657)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15497310351417893)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15497518015417893)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6000816148464522.100005)
,p_translate_from_id=>wwv_flow_imp.id(6000816148464522)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15497739949417893)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34719055685581256.100005)
,p_translate_from_id=>wwv_flow_imp.id(34719055685581256)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15497931515417894)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630828651575810.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630828651575810)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15498171629417894)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100005)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15498337578417894)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8051867682140677.100005)
,p_translate_from_id=>wwv_flow_imp.id(8051867682140677)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P12_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15498545655417894)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8053186121141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8053186121141984)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
,p_translate_from_text=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15498780471417894)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15357188013942519.100005)
,p_translate_from_id=>wwv_flow_imp.id(15357188013942519)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Prism.highlightAll();'
,p_translate_from_text=>'Prism.highlightAll();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15498937510417894)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(22801024059488049.100005)
,p_translate_from_id=>wwv_flow_imp.id(22801024059488049)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.region(''modeler'').save();'
,p_translate_from_text=>'apex.region(''modeler'').save();'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15499115277417894)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26096178250304648.100005)
,p_translate_from_id=>wwv_flow_imp.id(26096178250304648)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15499380946417894)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15499575401417894)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6180462025209949.100005)
,p_translate_from_id=>wwv_flow_imp.id(6180462025209949)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P8_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15499763007417894)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630565554575807.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630565554575807)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15499929296417894)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SQL_STATEMENT'
,p_translate_from_text=>'SQL_STATEMENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15500143132417894)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DIALOG_RETURN_ITEM'
,p_translate_from_text=>'DIALOG_RETURN_ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15500318461417894)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8023966198825608.100005)
,p_translate_from_id=>wwv_flow_imp.id(8023966198825608)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
,p_translate_from_text=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15500518641417894)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19023277699332950.100005)
,p_translate_from_id=>wwv_flow_imp.id(19023277699332950)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
,p_translate_from_text=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15500772198417894)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402409828171410.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402409828171410)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15500901109417894)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FUNCTION_BODY'
,p_translate_from_text=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15501194550417894)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26093894432304625.100005)
,p_translate_from_id=>wwv_flow_imp.id(26093894432304625)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15501380232417894)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100005)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15501539717417894)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522653812864947.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522653812864947)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P10_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15501701963417894)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40001401094317104.100005)
,p_translate_from_id=>wwv_flow_imp.id(40001401094317104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15501950773417894)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ARCHIVE'
,p_translate_from_text=>'ARCHIVE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15502182949417895)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025177637825620.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025177637825620)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
,p_translate_from_text=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15502392311417895)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16956960300047776.100005)
,p_translate_from_id=>wwv_flow_imp.id(16956960300047776)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'changeCursor($v(''P7_OBJT_LIST''));'
,p_translate_from_text=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15502537206417895)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15502722844417895)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6016777800464530.100005)
,p_translate_from_id=>wwv_flow_imp.id(6016777800464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15502912032417895)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15503149071417895)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(15209592603614397.100005)
,p_translate_from_id=>wwv_flow_imp.id(15209592603614397)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15503347032417895)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24212041561956104.100005)
,p_translate_from_id=>wwv_flow_imp.id(24212041561956104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15503572193417895)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MODIFY_DIAGRAM'
,p_translate_from_text=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15503745555417895)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100005)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15503970461417895)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100005)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL_EXPRESSION'
,p_translate_from_text=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15504146419417895)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100005)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>288
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'JAVASCRIPT_EXPRESSION'
,p_translate_from_text=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15504314860417901)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402353637171409.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402353637171409)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15504511097417901)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'file'
,p_translate_from_text=>'file'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15504718737417901)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630686363575808.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630686363575808)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15504934544417901)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630931054575811.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630931054575811)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15505155548417901)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100005)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_DISPLAY_SETTING'
,p_translate_from_text=>'P10_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15505347404417901)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8025291955825621.100005)
,p_translate_from_id=>wwv_flow_imp.id(8025291955825621)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15505585025417901)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100005)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_DISPLAY_SETTING'
,p_translate_from_text=>'P8_DISPLAY_SETTING'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15505764420417902)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P9999_THEME_MODE'
,p_translate_from_text=>'P9999_THEME_MODE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15505923431417902)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34402245490171408.100005)
,p_translate_from_id=>wwv_flow_imp.id(34402245490171408)
,p_translate_column_id=>289
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15506180121417902)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>290
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15506334700417903)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15506599026417903)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15506738215417903)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100005)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15506953966417903)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100005)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15507152189417903)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100005)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>291
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15507327679417904)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100005)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15507575787417904)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100005)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15507743708417904)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15507911724417904)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingObjectId'
,p_translate_from_text=>'this.data.callingObjectId'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15508123803417904)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.callingDiagramIdentifier'
,p_translate_from_text=>'this.data.callingDiagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15508358125417904)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100005)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15508565040417904)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.element.id'
,p_translate_from_text=>'this.data.element.id'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15508735342417904)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15508992215417904)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34634644617575848.100005)
,p_translate_from_id=>wwv_flow_imp.id(34634644617575848)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15509155473417904)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15509305113417904)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6008377992464526.100005)
,p_translate_from_id=>wwv_flow_imp.id(6008377992464526)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15509573944417904)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15509726591417904)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176556209209910.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176556209209910)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PLSQL'
,p_translate_from_text=>'PLSQL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15509979668417904)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100005)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>292
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'this.data.diagramIdentifier'
,p_translate_from_text=>'this.data.diagramIdentifier'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15510184070417906)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15510352878417906)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15510507736417906)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15510703547417906)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100005)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15510909577417906)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15511191230417906)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100005)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15511352366417906)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100005)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15511553855417906)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100005)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15511794829417906)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>293
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15511922935417907)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_translate_from_text=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15512137733417907)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15512303098417907)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15512521225417907)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100005)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15512779872417907)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15512918468417907)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15513197067417907)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100005)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_translate_from_text=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15513357382417907)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_DATE'
,p_translate_from_text=>'P8_PROV_VAR_DATE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15513574352417907)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100005)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_NUM'
,p_translate_from_text=>'P8_PROV_VAR_NUM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15513742872417907)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100005)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P12_LOADED_DIAGRAM'
,p_translate_from_text=>'P12_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15513965810417908)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100005)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_translate_from_text=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15514125594417908)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15514362972417908)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_translate_from_text=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15514545809417908)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100005)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_GATEWAY,P8_PRDG_ID'
,p_translate_from_text=>'P8_GATEWAY,P8_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15514745794417908)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100005)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>294
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P8_PROV_VAR_TSTZ'
,p_translate_from_text=>'P8_PROV_VAR_TSTZ'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15514987823417910)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15515134888417910)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15515367837417910)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15515587078417910)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100005)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15515770014417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15515939704417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15516135795417910)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100005)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15516395649417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15516561499417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100005)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15516704682417910)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100005)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15516970374417910)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100005)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15517149820417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15517383919417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15517569300417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100005)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15517725988417910)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100005)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>295
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15517992029417912)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17602048410220618.100005)
,p_translate_from_id=>wwv_flow_imp.id(17602048410220618)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15518177010417912)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16957799465050250.100005)
,p_translate_from_id=>wwv_flow_imp.id(16957799465050250)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15518369267417912)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2448959260538244.100005)
,p_translate_from_id=>wwv_flow_imp.id(2448959260538244)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15518531717417912)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803077743176612.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803077743176612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15518710810417912)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8054174771141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8054174771141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15518921218417912)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104339991434707.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104339991434707)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15519172225417912)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15519335850417912)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5522598629864946.100005)
,p_translate_from_id=>wwv_flow_imp.id(5522598629864946)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15519558267417912)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16955942968047775.100005)
,p_translate_from_id=>wwv_flow_imp.id(16955942968047775)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15519759627417912)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104290877434706.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104290877434706)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15519941562417912)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55107869454434742.100005)
,p_translate_from_id=>wwv_flow_imp.id(55107869454434742)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15520108437417912)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6005591668464524.100005)
,p_translate_from_id=>wwv_flow_imp.id(6005591668464524)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15520316299417912)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8053641230141984.100005)
,p_translate_from_id=>wwv_flow_imp.id(8053641230141984)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15520598183417913)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15520746035417913)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6176192014209906.100005)
,p_translate_from_id=>wwv_flow_imp.id(6176192014209906)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15520942356417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006917102464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006917102464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15521180708417913)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34633042798575832.100005)
,p_translate_from_id=>wwv_flow_imp.id(34633042798575832)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15521399328417913)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16958247692050251.100005)
,p_translate_from_id=>wwv_flow_imp.id(16958247692050251)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15521529526417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6429852264417608.100005)
,p_translate_from_id=>wwv_flow_imp.id(6429852264417608)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15521717965417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6430261684417612.100005)
,p_translate_from_id=>wwv_flow_imp.id(6430261684417612)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15521991480417913)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8051357622140676.100005)
,p_translate_from_id=>wwv_flow_imp.id(8051357622140676)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15522120406417913)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2449082180538245.100005)
,p_translate_from_id=>wwv_flow_imp.id(2449082180538245)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15522358730417913)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803522247176617.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803522247176617)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15522532339417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(55104408483434708.100005)
,p_translate_from_id=>wwv_flow_imp.id(55104408483434708)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15522738589417913)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15522958446417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6006044910464525.100005)
,p_translate_from_id=>wwv_flow_imp.id(6006044910464525)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15523173706417913)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(44803326871176615.100005)
,p_translate_from_id=>wwv_flow_imp.id(44803326871176615)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15523375687417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6014962408464530.100005)
,p_translate_from_id=>wwv_flow_imp.id(6014962408464530)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15523592684417913)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3748406279530348.100005)
,p_translate_from_id=>wwv_flow_imp.id(3748406279530348)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15523750656417913)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(42701983528211104.100005)
,p_translate_from_id=>wwv_flow_imp.id(42701983528211104)
,p_translate_column_id=>296
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15523985661417916)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737253943406143.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737253943406143)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15524102113417916)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433779174417647.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433779174417647)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_NAME'
,p_translate_from_text=>'P11_PRCS_NAME'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15524331968417916)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(33737390268406144.100005)
,p_translate_from_id=>wwv_flow_imp.id(33737390268406144)
,p_translate_column_id=>297
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'P11_PRCS_ID'
,p_translate_from_text=>'P11_PRCS_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15524560128417916)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'MONTH-PICKER:YEAR-PICKER'
,p_translate_from_text=>'MONTH-PICKER:YEAR-PICKER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15524714156417916)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'RELAX_HOUSE_NUMBER'
,p_translate_from_text=>'RELAX_HOUSE_NUMBER'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15524979772417916)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15525144044417916)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495637049419880410.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495637049419880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'IG'
,p_translate_from_text=>'IG'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15525365113417917)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'fa-star'
,p_translate_from_text=>'fa-star'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15525528130417917)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FULL'
,p_translate_from_text=>'FULL'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15525714709417917)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495637316813880410.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495637316813880410)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15525948188417917)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100005)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15526109172417917)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495638754943880417.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495638754943880417)
,p_translate_column_id=>298
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15526381770417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'VISIBLE'
,p_translate_from_text=>'VISIBLE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15526549671417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15526719201417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495638591473880412.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495638591473880412)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP'
,p_translate_from_text=>'POPUP'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15526997354417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(1182306920811988.100005)
,p_translate_from_id=>wwv_flow_imp.id(1182306920811988)
,p_translate_column_id=>299
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15527197952417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'15'
,p_translate_from_text=>'15'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15527335467417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'POPUP:ITEM'
,p_translate_from_text=>'POPUP:ITEM'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15527528973417918)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>300
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15527729483417919)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174166300699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174166300699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'FOCUS'
,p_translate_from_text=>'FOCUS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15527940363417919)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'default'
,p_translate_from_text=>'default'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15528163677417919)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495637696260880410.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495637696260880410)
,p_translate_column_id=>301
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'#VALUE#'
,p_translate_from_text=>'#VALUE#'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15528393975417919)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495638240314880412.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495638240314880412)
,p_translate_column_id=>302
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'SWITCH_CB'
,p_translate_from_text=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15528544287417919)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4174066140699943.100005)
,p_translate_from_id=>wwv_flow_imp.id(4174066140699943)
,p_translate_column_id=>303
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'LIST'
,p_translate_from_text=>'LIST'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15528719402417920)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15528906019417920)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100005)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15529133390417920)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100005)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15529383875417920)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100005)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15529563411417920)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100005)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15529783855417920)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15529981722417920)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100005)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15530118682417920)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15530340051417920)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15530520309417920)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100005)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15530797128417920)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100005)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15530904344417920)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100005)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15531149545417920)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100005)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15531336752417920)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15531576872417920)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15531716733417921)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100005)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15531982563417921)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100005)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15532104042417921)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100005)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15532332090417921)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100005)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15532557544417921)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15532778106417921)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100005)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15532973445417921)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100005)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15533181909417921)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100005)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15533360649417921)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15533572930417921)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15533778066417921)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15533942736417921)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100005)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15534146756417921)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100005)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15534316148417921)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15534557996417921)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100005)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15534722727417921)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100005)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15534976610417921)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15535117478417921)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15535349154417921)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15535561709417921)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15535745305417921)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15535956666417921)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15536105257417922)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100005)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15536320363417922)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100005)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15536508777417922)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15536715908417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100005)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15536955712417922)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15537178399417922)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100005)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15537389669417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100005)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15537573726417922)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15537790553417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100005)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15537992222417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100005)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15538141366417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100005)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15538349526417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15538586388417922)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15538787851417922)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15538900413417922)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100005)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15539196240417922)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100005)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15539346766417922)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15539586453417922)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15539739913417922)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15539941719417922)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15540144343417923)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15540311484417923)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15540599671417923)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15540744633417923)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_CONTENT'
,p_translate_from_text=>'DGRM_CONTENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15540942350417923)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15541166500417923)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100005)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15541387575417923)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100005)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>308
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15541537725417928)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16967621768177906.100005)
,p_translate_from_id=>wwv_flow_imp.id(16967621768177906)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15541688221417928)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3745995977530323.100005)
,p_translate_from_id=>wwv_flow_imp.id(3745995977530323)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15541869441417928)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(65972703397470872.100005)
,p_translate_from_id=>wwv_flow_imp.id(65972703397470872)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15542016066417928)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5684323221037043.100005)
,p_translate_from_id=>wwv_flow_imp.id(5684323221037043)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15542278168417928)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5273399411803742.100005)
,p_translate_from_id=>wwv_flow_imp.id(5273399411803742)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15542482308417928)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862347292537221.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862347292537221)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15542671346417928)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16518361588787101.100005)
,p_translate_from_id=>wwv_flow_imp.id(16518361588787101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15542818208417928)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12491866042341262842.100005)
,p_translate_from_id=>wwv_flow_imp.id(12491866042341262842)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15543015146417929)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3508800535851701.100005)
,p_translate_from_id=>wwv_flow_imp.id(3508800535851701)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15543282786417929)
,p_page_id=>5
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(17600327473220601.100005)
,p_translate_from_id=>wwv_flow_imp.id(17600327473220601)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15543415326417929)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19000369704190884.100005)
,p_translate_from_id=>wwv_flow_imp.id(19000369704190884)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15543660547417929)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8354985158946288.100005)
,p_translate_from_id=>wwv_flow_imp.id(8354985158946288)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15543837918417929)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15544094777417929)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363080166158416.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363080166158416)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15544289002417929)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(65920170325464220.100005)
,p_translate_from_id=>wwv_flow_imp.id(65920170325464220)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15544476474417929)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100005)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15544656101417929)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5571513551899137.100005)
,p_translate_from_id=>wwv_flow_imp.id(5571513551899137)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15544836374417929)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11295777694064002.100005)
,p_translate_from_id=>wwv_flow_imp.id(11295777694064002)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15545045346417929)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15545271148417929)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45087523137560136.100005)
,p_translate_from_id=>wwv_flow_imp.id(45087523137560136)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15545483052417929)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11214749648054909.100005)
,p_translate_from_id=>wwv_flow_imp.id(11214749648054909)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15545640969417929)
,p_page_id=>37
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8608203121575437.100005)
,p_translate_from_id=>wwv_flow_imp.id(8608203121575437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15545805784417929)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938769092499710.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938769092499710)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15546019352417929)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15546229441417929)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363247042158418.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363247042158418)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15546416884417929)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11160422865040074.100005)
,p_translate_from_id=>wwv_flow_imp.id(11160422865040074)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15546664998417930)
,p_page_id=>33
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11186537419048718.100005)
,p_translate_from_id=>wwv_flow_imp.id(11186537419048718)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15546849622417930)
,p_page_id=>11
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603847781745438.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603847781745438)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15547074968417930)
,p_page_id=>39
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(20088203370380088.100005)
,p_translate_from_id=>wwv_flow_imp.id(20088203370380088)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15547226962417930)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24211779219956101.100005)
,p_translate_from_id=>wwv_flow_imp.id(24211779219956101)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15547418873417930)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2363132666158417.100005)
,p_translate_from_id=>wwv_flow_imp.id(2363132666158417)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15547637810417930)
,p_page_id=>50
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5570494030899126.100005)
,p_translate_from_id=>wwv_flow_imp.id(5570494030899126)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15547825242417930)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(60862870630537226.100005)
,p_translate_from_id=>wwv_flow_imp.id(60862870630537226)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15548083110417930)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6433334615417643.100005)
,p_translate_from_id=>wwv_flow_imp.id(6433334615417643)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15548296868417930)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4722613539681901.100005)
,p_translate_from_id=>wwv_flow_imp.id(4722613539681901)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15548486005417930)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362292353158408.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362292353158408)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15548621611417930)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4548240290043011.100005)
,p_translate_from_id=>wwv_flow_imp.id(4548240290043011)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15548805087417930)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5301292362807367.100005)
,p_translate_from_id=>wwv_flow_imp.id(5301292362807367)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15549085611417930)
,p_page_id=>4
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(24418438259878743.100005)
,p_translate_from_id=>wwv_flow_imp.id(24418438259878743)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15549286933417930)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(30368937979343097.100005)
,p_translate_from_id=>wwv_flow_imp.id(30368937979343097)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15549485784417930)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747347338530337.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747347338530337)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15549666870417931)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(71488161436297107.100005)
,p_translate_from_id=>wwv_flow_imp.id(71488161436297107)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15549811085417931)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8024125104825610.100005)
,p_translate_from_id=>wwv_flow_imp.id(8024125104825610)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15550045221417931)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511545006851728.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511545006851728)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15550290881417931)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8391710661345604.100005)
,p_translate_from_id=>wwv_flow_imp.id(8391710661345604)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15550435021417931)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(8394514514345632.100005)
,p_translate_from_id=>wwv_flow_imp.id(8394514514345632)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15550686354417931)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(13245209048329626.100005)
,p_translate_from_id=>wwv_flow_imp.id(13245209048329626)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15550815910417931)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(62707563129232545.100005)
,p_translate_from_id=>wwv_flow_imp.id(62707563129232545)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15551060030417931)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6177850959209923.100005)
,p_translate_from_id=>wwv_flow_imp.id(6177850959209923)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15551299078417931)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511637925851729.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511637925851729)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15551467243417931)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45089270532561391.100005)
,p_translate_from_id=>wwv_flow_imp.id(45089270532561391)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15551678422417931)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(45090112965561399.100005)
,p_translate_from_id=>wwv_flow_imp.id(45090112965561399)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15551829697417931)
,p_page_id=>13
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12635446510220640.100005)
,p_translate_from_id=>wwv_flow_imp.id(12635446510220640)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15552066214417931)
,p_page_id=>38
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747249703530336.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747249703530336)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15552262055417931)
,p_page_id=>1
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(10603774502745437.100005)
,p_translate_from_id=>wwv_flow_imp.id(10603774502745437)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15552491785417931)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3510821361851721.100005)
,p_translate_from_id=>wwv_flow_imp.id(3510821361851721)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15552637517417931)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_CURRENT'
,p_translate_from_text=>'ALL_CURRENT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15552847267417932)
,p_page_id=>14
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(16968778051177917.100005)
,p_translate_from_id=>wwv_flow_imp.id(16968778051177917)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15553003278417932)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3511439830851727.100005)
,p_translate_from_id=>wwv_flow_imp.id(3511439830851727)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15553258046417932)
,p_page_id=>30
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2362908411158415.100005)
,p_translate_from_id=>wwv_flow_imp.id(2362908411158415)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15553400204417932)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100005)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'TEXT'
,p_translate_from_text=>'TEXT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15553627335417932)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11295717440064001.100005)
,p_translate_from_id=>wwv_flow_imp.id(11295717440064001)
,p_translate_column_id=>309
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'HTML'
,p_translate_from_text=>'HTML'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15553847588417939)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15554067380417939)
,p_page_id=>51
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5593476220964019.100005)
,p_translate_from_id=>wwv_flow_imp.id(5593476220964019)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15554267929417939)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495495236065879932.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495495236065879932)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15554425044417939)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15554656284417939)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_ID'
,p_translate_from_text=>'PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15554837957417939)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DGRM_ID'
,p_translate_from_text=>'DGRM_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15555085423417939)
,p_page_id=>31
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2339381920104534.100005)
,p_translate_from_id=>wwv_flow_imp.id(2339381920104534)
,p_translate_column_id=>310
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15555220373417939)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15555490861417940)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15555675197417940)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>311
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_COMPLETED'
,p_translate_from_text=>'ALL_COMPLETED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15555885162417940)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15556024912417940)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15556210309417940)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>312
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'PRDG_PRDG_ID'
,p_translate_from_text=>'PRDG_PRDG_ID'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15556497252417941)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15556601795417941)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15556899012417941)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15557091922417941)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>313
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ALL_ERRORS'
,p_translate_from_text=>'ALL_ERRORS'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15557296701417942)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15557441249417942)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15557636949417942)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>314
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'CALLING_OBJT'
,p_translate_from_text=>'CALLING_OBJT'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15557844370417942)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15558028315417942)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15558259105417942)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15558426574417942)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>315
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15558608483417943)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15558881254417943)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15559069816417943)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15559243392417943)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15559458704417943)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>316
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15559634057417944)
,p_page_id=>6
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(19018652597332904.100005)
,p_translate_from_id=>wwv_flow_imp.id(19018652597332904)
,p_translate_column_id=>319
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'INLINE'
,p_translate_from_text=>'INLINE'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15559869633417945)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15560088030417945)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15560248827417945)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15560492138417945)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>338
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15560660500417946)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10000'
,p_translate_from_text=>'10000'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15560830866417946)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15561023108417946)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15561232015417946)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>339
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'BREADCRUMB'
,p_translate_from_text=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15561419722417946)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15561690003417947)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15561843409417947)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15562004309417947)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>340
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'DRILLDOWN_ALLOWED'
,p_translate_from_text=>'DRILLDOWN_ALLOWED'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15562213164417947)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15562491945417948)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15562603962417948)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15562865254417948)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>341
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15563084794417948)
,p_page_id=>20
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2035348203569032.100005)
,p_translate_from_id=>wwv_flow_imp.id(2035348203569032)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'10'
,p_translate_from_text=>'10'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15563296232417948)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15563457283417948)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15563659494417949)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15563860240417949)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>342
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'N'
,p_translate_from_text=>'N'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15564014115417949)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495496796563879971.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495496796563879971)
,p_translate_column_id=>343
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'return true;'
,p_translate_from_text=>'return true;'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15564207716417950)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3293122238268383.100005)
,p_translate_from_id=>wwv_flow_imp.id(3293122238268383)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable timers, scheduler, max cycles'
,p_translate_from_text=>'Enable timers, scheduler, max cycles'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15564483712417950)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3293918632269809.100005)
,p_translate_from_id=>wwv_flow_imp.id(3293918632269809)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'REST clients'
,p_translate_from_text=>'REST clients'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15564675420417950)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40403252293815221.100005)
,p_translate_from_id=>wwv_flow_imp.id(40403252293815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-copy-flow'
,p_translate_from_text=>'bulk-copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15564859319417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40427116551997037.100005)
,p_translate_from_id=>wwv_flow_imp.id(40427116551997037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15565074398417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2432979512873125.100005)
,p_translate_from_id=>wwv_flow_imp.id(2432979512873125)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-terminate-flow-instance'
,p_translate_from_text=>'bulk-terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15565241212417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2433306262873126.100005)
,p_translate_from_id=>wwv_flow_imp.id(2433306262873126)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-flow-instance'
,p_translate_from_text=>'bulk-delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15565474960417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46779088416540093.100005)
,p_translate_from_id=>wwv_flow_imp.id(46779088416540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15565641678417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46779754471540095.100005)
,p_translate_from_id=>wwv_flow_imp.id(46779754471540095)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-instance'
,p_translate_from_text=>'delete-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15565803132417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40425672453997035.100005)
,p_translate_from_id=>wwv_flow_imp.id(40425672453997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15566066250417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(11497553424163179.100005)
,p_translate_from_id=>wwv_flow_imp.id(11497553424163179)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Edici\00F3n, informaci\00F3n de licencia')
,p_translate_from_text=>'Edition, license information'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15566289214417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39902501487857435.100005)
,p_translate_from_id=>wwv_flow_imp.id(39902501487857435)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15566444395417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40402870460815221.100005)
,p_translate_from_id=>wwv_flow_imp.id(40402870460815221)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-new-flow-version'
,p_translate_from_text=>'bulk-new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15566688259417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5662379313207242.100005)
,p_translate_from_id=>wwv_flow_imp.id(5662379313207242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15566892487417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40426450496997035.100005)
,p_translate_from_id=>wwv_flow_imp.id(40426450496997035)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'terminate-flow-instance'
,p_translate_from_text=>'terminate-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15567019136417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2408929523394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2408929523394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reserve-step'
,p_translate_from_text=>'reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15567279811417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7074803452273042.100005)
,p_translate_from_id=>wwv_flow_imp.id(7074803452273042)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'update-process-variable'
,p_translate_from_text=>'update-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15567462725417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2407770381394791.100005)
,p_translate_from_id=>wwv_flow_imp.id(2407770381394791)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'complete-step'
,p_translate_from_text=>'complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15567695610417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3292700268268382.100005)
,p_translate_from_id=>wwv_flow_imp.id(3292700268268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Step key usage, default values'
,p_translate_from_text=>'Step key usage, default values'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15567868434417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7936149892465882.100005)
,p_translate_from_id=>wwv_flow_imp.id(7936149892465882)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-flow-diagram'
,p_translate_from_text=>'delete-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15568048783417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39902920078857437.100005)
,p_translate_from_id=>wwv_flow_imp.id(39902920078857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'new-flow-version'
,p_translate_from_text=>'new-flow-version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15568253345417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3292372844268382.100005)
,p_translate_from_id=>wwv_flow_imp.id(3292372844268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'App Mode'
,p_translate_from_text=>'App Mode'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15568468868417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46777067725540092.100005)
,p_translate_from_id=>wwv_flow_imp.id(46777067725540092)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15568698718417951)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7075252422273053.100005)
,p_translate_from_id=>wwv_flow_imp.id(7075252422273053)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'delete-process-variable'
,p_translate_from_text=>'delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15568857801417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7390805893616409.100005)
,p_translate_from_id=>wwv_flow_imp.id(7390805893616409)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-delete-process-variable'
,p_translate_from_text=>'bulk-delete-process-variable'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15569027409417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5664576928271979.100005)
,p_translate_from_id=>wwv_flow_imp.id(5664576928271979)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15569268388417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12016899984810068.100005)
,p_translate_from_id=>wwv_flow_imp.id(12016899984810068)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15569464642417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3291958597268382.100005)
,p_translate_from_id=>wwv_flow_imp.id(3291958597268382)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Enable archiving, instance archive location'
,p_translate_from_text=>'Enable archiving, instance archive location'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15569621251417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3343699244810836.100005)
,p_translate_from_id=>wwv_flow_imp.id(3343699244810836)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Summaries retention time'
,p_translate_from_text=>'Summaries retention time'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15569815566417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12015017232750300.100005)
,p_translate_from_id=>wwv_flow_imp.id(12015017232750300)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'download-as-svg'
,p_translate_from_text=>'download-as-svg'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15570056311417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46154708390415036.100005)
,p_translate_from_id=>wwv_flow_imp.id(46154708390415036)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15570271684417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73474805704863264.100005)
,p_translate_from_id=>wwv_flow_imp.id(73474805704863264)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reschedule-timer'
,p_translate_from_text=>'reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15570471071417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2432103661873123.100005)
,p_translate_from_id=>wwv_flow_imp.id(2432103661873123)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-start-flow-instance'
,p_translate_from_text=>'bulk-start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15570664801417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4409268569512242.100005)
,p_translate_from_id=>wwv_flow_imp.id(4409268569512242)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-complete-step'
,p_translate_from_text=>'bulk-complete-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15570887255417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39903360633857437.100005)
,p_translate_from_id=>wwv_flow_imp.id(39903360633857437)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'copy-flow'
,p_translate_from_text=>'copy-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15571080773417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4410861620512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4410861620512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-release-step'
,p_translate_from_text=>'bulk-release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15571268400417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12017214847815037.100005)
,p_translate_from_id=>wwv_flow_imp.id(12017214847815037)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'edit-flow-diagram'
,p_translate_from_text=>'edit-flow-diagram'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15571460806417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6315881052890668.100005)
,p_translate_from_id=>wwv_flow_imp.id(6315881052890668)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'open-flow-instance-details'
,p_translate_from_text=>'open-flow-instance-details'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15571619706417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2409356015394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2409356015394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'release-step'
,p_translate_from_text=>'release-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15571834733417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2432511726873124.100005)
,p_translate_from_id=>wwv_flow_imp.id(2432511726873124)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reset-flow-instance'
,p_translate_from_text=>'bulk-reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15572076693417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4409653667512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4409653667512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-restart-step'
,p_translate_from_text=>'bulk-restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15572227247417952)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(4410440520512250.100005)
,p_translate_from_id=>wwv_flow_imp.id(4410440520512250)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reserve-step'
,p_translate_from_text=>'bulk-reserve-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15572413278417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3291576005268381.100005)
,p_translate_from_id=>wwv_flow_imp.id(3291576005268381)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Language, level, user information, retention time, bpmn location, message flows'
,p_translate_from_text=>'Language, level, user information, retention time, bpmn location, message flows'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15572660808417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(46778310373540093.100005)
,p_translate_from_id=>wwv_flow_imp.id(46778310373540093)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'reset-flow-instance'
,p_translate_from_text=>'reset-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15572859293417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40410074688263331.100005)
,p_translate_from_id=>wwv_flow_imp.id(40410074688263331)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'export-flow'
,p_translate_from_text=>'export-flow'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15573010054417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40423835706997032.100005)
,p_translate_from_id=>wwv_flow_imp.id(40423835706997032)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'view-flow-instance'
,p_translate_from_text=>'view-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15573275223417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(40424429805997034.100005)
,p_translate_from_id=>wwv_flow_imp.id(40424429805997034)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'start-flow-instance'
,p_translate_from_text=>'start-flow-instance'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15573455842417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(73510888958146465.100005)
,p_translate_from_id=>wwv_flow_imp.id(73510888958146465)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'bulk-reschedule-timer'
,p_translate_from_text=>'bulk-reschedule-timer'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15573663185417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2408186437394796.100005)
,p_translate_from_id=>wwv_flow_imp.id(2408186437394796)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'restart-step'
,p_translate_from_text=>'restart-step'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15573885878417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(39805873547914084.100005)
,p_translate_from_id=>wwv_flow_imp.id(39805873547914084)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'choose-setting'
,p_translate_from_text=>'choose-setting'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15574068421417953)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5664262065267010.100005)
,p_translate_from_id=>wwv_flow_imp.id(5664262065267010)
,p_translate_column_id=>376
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'flow-instance-audit'
,p_translate_from_text=>'flow-instance-audit'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15574239510417957)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495487956468879842.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495487956468879842)
,p_translate_column_id=>377
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'has-username'
,p_translate_from_text=>'has-username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15574458945417958)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494855941879918.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494855941879918)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre de usuario'
,p_translate_from_text=>'Username'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15574682254417958)
,p_page_id=>9999
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12495494409843879910.100005)
,p_translate_from_id=>wwv_flow_imp.id(12495494409843879910)
,p_translate_column_id=>396
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Contrase\00F1a')
,p_translate_from_text=>'Password'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15574805301417959)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15575019032417959)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15575219043417959)
,p_page_id=>12
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6161598858353963900.100005)
,p_translate_from_id=>wwv_flow_imp.id(6161598858353963900)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15575410885417959)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(28425138174759832.100005)
,p_translate_from_id=>wwv_flow_imp.id(28425138174759832)
,p_translate_column_id=>405
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Y'
,p_translate_from_text=>'Y'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15575642823417960)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134666000214454.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134666000214454)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong>: no captura informaci\00F3n del usuario sobre el paso	</li>'),
'    <li><strong>disabled</strong> (valor por defecto): captura el ID de usuario del paso del proceso conocido por el motor de flujo	</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15575851395417960)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222763777231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222763777231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se debe definir en el remitente de correo electr\00F3nico por defecto, en caso de que el correo saliente serviceTasks no tenga un remitente definido.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15576047353417961)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223946439231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223946439231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Nombre de usuario que se va a utilizar en la sesi\00F3n de APEX para crear una sesi\00F3n si no se proporciona ning\00FAn otro nombre de usuario')
,p_translate_from_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15576277457417961)
,p_page_id=>7
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(26070342430228478.100005)
,p_translate_from_id=>wwv_flow_imp.id(26070342430228478)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Suprimir instancias de proceso asociadas'
,p_translate_from_text=>'Delete associated process instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15576403441417961)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(5981800867464472.100005)
,p_translate_from_id=>wwv_flow_imp.id(5981800867464472)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Si se deja en blanco, la tarea se reservar\00E1 para el usuario actual (app_user).')
,p_translate_from_text=>'If left blank, the task will be reserved for the current user (app_user).'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15576696761417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276827580238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276827580238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para los temporizadores de ciclo, se definir\00E1 el n\00FAmero m\00E1ximo de ejecuci\00F3n.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15576845448417961)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3747988967530343.100005)
,p_translate_from_id=>wwv_flow_imp.id(3747988967530343)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Formato requerido: AAAA-MM-DD HH24:MI:SS TZR'
,p_translate_from_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15577065629417961)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3221987342231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3221987342231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong>: utilice esta opci\00F3n solo para admitir aplicaciones que se han desarrollado con Flows for APEX 21.1 y versiones anteriores sin desarrollo adicional. El motor no utiliza la tecla de paso para evitar acciones duplicadas ')
||'en un solo paso.</li>',
unistr('    <li><strong>strict</strong> (recomendado): utilice esta opci\00F3n para el desarrollo nuevo y/o la aplicaci\00F3n totalmente migrada. El motor utiliza la clave de paso para evitar acciones duplicadas en un solo paso.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15577246164417961)
,p_page_id=>2
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(7938841081499711.100005)
,p_translate_from_id=>wwv_flow_imp.id(7938841081499711)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('En caso de copia de modelo \00FAnico, el nuevo modelo tendr\00E1 el nombre introducido, pero si ha seleccionado m\00E1s de una fila, el valor introducido se utilizar\00E1 como sufijo.')
,p_translate_from_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15577497925417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269101148238362.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269101148238362)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma utilizado para mostrar mensajes de error y eventos de log.'
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15577634154417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274466716238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274466716238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>legacy</strong>: utilice esta opci\00F3n solo para admitir aplicaciones que se han desarrollado con Flows for APEX 21.1 y versiones anteriores sin desarrollo adicional. El motor no utiliza la tecla de paso para evitar acciones duplicadas ')
||'en un solo paso.</li>',
unistr('    <li><strong>strict</strong> (recomendado): utilice esta opci\00F3n para el desarrollo nuevo y/o la aplicaci\00F3n totalmente migrada. El motor utiliza la clave de paso para evitar acciones duplicadas en un solo paso.</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15577845828417961)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3134229968214453.100005)
,p_translate_from_id=>wwv_flow_imp.id(3134229968214453)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong>: el registro est\00E1 desactivado	</li>'),
'    <li><strong>standard</strong> (por defecto): registra eventos de instancia</li>',
'    <li><strong>secure</strong>: registra eventos de modelo y eventos de instancia	</li>',
'    <li><strong>full</strong>: registra los eventos de modelo, instancia y variable de proceso		</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15578020022417961)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223134552231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223134552231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El ID de aplicaci\00F3n de una de sus aplicaciones APEX que se proporcionar\00E1 para crear una sesi\00F3n')
,p_translate_from_text=>'The application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15578234071417961)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3223533554231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3223533554231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('El ID de p\00E1gina de una de sus aplicaciones que se proporcionar\00E1 para crear una sesi\00F3n')
,p_translate_from_text=>'The page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15578444231417961)
,p_page_id=>36
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3317563907227906.100005)
,p_translate_from_id=>wwv_flow_imp.id(3317563907227906)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Para los temporizadores de ciclo, se definir\00E1 el n\00FAmero m\00E1ximo de ejecuci\00F3n.')
,p_translate_from_text=>'For cycle timers, this will defined the maximum number of execution.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15578601266417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3274892542238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3274892542238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se debe definir en el espacio de trabajo de APEX por defecto que se utiliza para Flows for APEX. Se utiliza como \00FAltimo recurso para scriptTasks y serviceTasks al crear una sesi\00F3n de APEX o buscar plantillas de correo')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15578801392417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269996682238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269996682238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>enabled</strong>: no captura informaci\00F3n del usuario sobre el paso	</li>'),
'    <li><strong>disabled</strong> (valor por defecto): captura el ID de usuario del paso del proceso conocido por el motor de flujo	</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15579021822417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276448525238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276448525238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('nombre de usuario que se va a utilizar en la sesi\00F3n de APEX para crear una sesi\00F3n si no se proporciona ning\00FAn otro nombre de usuario')
,p_translate_from_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15579231073417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3272674870238364.100005)
,p_translate_from_id=>wwv_flow_imp.id(3272674870238364)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (por defecto): evita la edici\00F3n del diagrama para modelos publicados</li>'),
unistr('    <li><strong>development</strong>: permite la edici\00F3n del diagrama para modelos publicados</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15579485864417961)
,p_page_id=>32
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3133819152214452.100005)
,p_translate_from_id=>wwv_flow_imp.id(3133819152214452)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Idioma utilizado para mostrar mensajes de error y eventos de log.'
,p_translate_from_text=>'Language used to display error messages and log events.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15579639265417961)
,p_page_id=>34
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3191696373229270.100005)
,p_translate_from_id=>wwv_flow_imp.id(3191696373229270)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>production</strong> (por defecto): evita la edici\00F3n del diagrama para modelos publicados</li>'),
unistr('    <li><strong>development</strong>: permite la edici\00F3n del diagrama para modelos publicados</li>'),
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15579895321417961)
,p_page_id=>35
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3222333263231713.100005)
,p_translate_from_id=>wwv_flow_imp.id(3222333263231713)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se debe definir en el espacio de trabajo de APEX por defecto que se utiliza para Flows for APEX. Se utiliza como \00FAltimo recurso para scriptTasks y serviceTasks al crear una sesi\00F3n de APEX o buscar plantillas de correo.')
,p_translate_from_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15580085654417961)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275605822238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275605822238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('el ID de aplicaci\00F3n de una de sus aplicaciones APEX que se proporcionar\00E1 para crear una sesi\00F3n')
,p_translate_from_text=>'the application ID of one of your APEX apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15580264165417962)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3269559694238363.100005)
,p_translate_from_id=>wwv_flow_imp.id(3269559694238363)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('    <li><strong>off</strong>: el registro est\00E1 desactivado	</li>'),
'    <li><strong>standard</strong> (por defecto): registra eventos de instancia</li>',
'    <li><strong>secure</strong>: registra eventos de modelo y eventos de instancia	</li>',
'    <li><strong>full</strong>: registra los eventos de modelo, instancia y variable de proceso		</li>',
'</ul>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15580482850417962)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3276036417238366.100005)
,p_translate_from_id=>wwv_flow_imp.id(3276036417238366)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('el ID de p\00E1gina de una de sus aplicaciones que se proporcionar\00E1 para crear una sesi\00F3n')
,p_translate_from_text=>'the page ID of one of your apps that will be provided to create a session'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15580606537417962)
,p_page_id=>100
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(3275221261238365.100005)
,p_translate_from_id=>wwv_flow_imp.id(3275221261238365)
,p_translate_column_id=>458
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Se debe definir en el remitente de correo electr\00F3nico por defecto, en caso de que el correo saliente serviceTasks no tenga un remitente definido.')
,p_translate_from_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15580893113417964)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2542556204137179.100005)
,p_translate_from_id=>wwv_flow_imp.id(2542556204137179)
,p_translate_column_id=>462
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15581056134417964)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144335477493927.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144335477493927)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias'
,p_translate_from_text=>'Instances'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15581284008417964)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144842592493932.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144842592493932)
,p_translate_column_id=>465
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'seg'
,p_translate_from_text=>'sec'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15581432351417964)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34630038161575802.100005)
,p_translate_from_id=>wwv_flow_imp.id(34630038161575802)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15581670957417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144612523493930.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144612523493930)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errores de instancias'
,p_translate_from_text=>'Instances Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15581857257417965)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142032851493904.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142032851493904)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error'
,p_translate_from_text=>'Error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15582086078417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143869603493922.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143869603493922)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('M\00E1ximo')
,p_translate_from_text=>'Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15582292031417965)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2146229575493946.100005)
,p_translate_from_id=>wwv_flow_imp.id(2146229575493946)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('En espera - M\00E1ximo')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15582472428417965)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143009590493914.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143009590493914)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Errores'
,p_translate_from_text=>'Errors'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15582634571417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144120727493925.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144120727493925)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias iniciadas'
,p_translate_from_text=>'Instances Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15582801390417965)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145050239493934.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145050239493934)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-90pc'
,p_translate_from_text=>'Duration-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15583096177417965)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145180896493935.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145180896493935)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-10pc'
,p_translate_from_text=>'Duration-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15583219411417965)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34629958268575801.100005)
,p_translate_from_id=>wwv_flow_imp.id(34629958268575801)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminated'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15583409706417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144581361493929.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144581361493929)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias terminadas'
,p_translate_from_text=>'Instances Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15583696631417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144947294493933.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144947294493933)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Duraci\00F3n de 90 pc')
,p_translate_from_text=>'90pc Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15583823329417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2552379943373356.100005)
,p_translate_from_id=>wwv_flow_imp.id(2552379943373356)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Percentil 10'
,p_translate_from_text=>'10 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15584078931417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143658369493920.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143658369493920)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Percentil 50'
,p_translate_from_text=>'50 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15584233324417965)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2146557171493949.100005)
,p_translate_from_id=>wwv_flow_imp.id(2146557171493949)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15584410473417965)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34589026072532104.100005)
,p_translate_from_id=>wwv_flow_imp.id(34589026072532104)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Serie 1'
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15584646867417965)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2544212410137182.100005)
,p_translate_from_id=>wwv_flow_imp.id(2544212410137182)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Creado'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15584864417417965)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34406421411171450.100005)
,p_translate_from_id=>wwv_flow_imp.id(34406421411171450)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Completed'
,p_translate_from_text=>'Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15585075752417965)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570196315060501.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570196315060501)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15585212961417965)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2142905983493913.100005)
,p_translate_from_id=>wwv_flow_imp.id(2142905983493913)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Iniciado'
,p_translate_from_text=>'Started'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15585421248417965)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2036784998569046.100005)
,p_translate_from_id=>wwv_flow_imp.id(2036784998569046)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Serie 1'
,p_translate_from_text=>'Series 1'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15585648944417965)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143732834493921.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143732834493921)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Percentil 90'
,p_translate_from_text=>'90 Percentile'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15585861947417965)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145203533493936.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145203533493936)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Duration-50pc'
,p_translate_from_text=>'Duration-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15586083698417966)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2141783765493901.100005)
,p_translate_from_id=>wwv_flow_imp.id(2141783765493901)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('En ejecuci\00F3n')
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15586242491417966)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34406322852171449.100005)
,p_translate_from_id=>wwv_flow_imp.id(34406322852171449)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Running'
,p_translate_from_text=>'Running'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15586483588417966)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143160145493915.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143160145493915)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Finalizado'
,p_translate_from_text=>'Completed'
);
end;
/
begin
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15586685120417966)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143222807493916.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143222807493916)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Terminado'
,p_translate_from_text=>'Terminated'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15586823422417966)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144430910493928.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144430910493928)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Instancias completadas'
,p_translate_from_text=>'Instances Completed'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15587011860417966)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145684188493940.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145684188493940)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-10pc'
,p_translate_from_text=>'Waiting-10pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15587291629417966)
,p_page_id=>16
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2144795267493931.100005)
,p_translate_from_id=>wwv_flow_imp.id(2144795267493931)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Duraci\00F3n media')
,p_translate_from_text=>'Median Duration'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15587492817417966)
,p_page_id=>3
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(34406094116171446.100005)
,p_translate_from_id=>wwv_flow_imp.id(34406094116171446)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Created'
,p_translate_from_text=>'Created'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15587621912417966)
,p_page_id=>15
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2143393414493917.100005)
,p_translate_from_id=>wwv_flow_imp.id(2143393414493917)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Restablecer'
,p_translate_from_text=>'Reset'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15587840645417966)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2146692991493950.100005)
,p_translate_from_id=>wwv_flow_imp.id(2146692991493950)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15588000070417966)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145521870493939.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145521870493939)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-50pc'
,p_translate_from_text=>'Waiting-50pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15588287375417966)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2564030625878607.100005)
,p_translate_from_id=>wwv_flow_imp.id(2564030625878607)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Duraci\00F3n - M\00E1ximo')
,p_translate_from_text=>'Duration-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15588481210417966)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145388121493937.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145388121493937)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('En espera - M\00E1ximo')
,p_translate_from_text=>'Waiting-Max'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15588674818417966)
,p_page_id=>17
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2145474164493938.100005)
,p_translate_from_id=>wwv_flow_imp.id(2145474164493938)
,p_translate_column_id=>466
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Waiting-90pc'
,p_translate_from_text=>'Waiting-90pc'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15588873808417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(66619733681096628.100005)
,p_translate_from_id=>wwv_flow_imp.id(66619733681096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15589052391417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(66620549721096629.100005)
,p_translate_from_id=>wwv_flow_imp.id(66620549721096629)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15589200963417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(66620198364096628.100005)
,p_translate_from_id=>wwv_flow_imp.id(66620198364096628)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Categor\00EDa')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15589489969417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9101564040535117.100005)
,p_translate_from_id=>wwv_flow_imp.id(9101564040535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15589673385417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(66620978691096630.100005)
,p_translate_from_id=>wwv_flow_imp.id(66620978691096630)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Estado'
,p_translate_from_text=>'Status'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15589821596417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9100877958535115.100005)
,p_translate_from_id=>wwv_flow_imp.id(9100877958535115)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Nombre'
,p_translate_from_text=>'Name'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15590025864417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9101106304535117.100005)
,p_translate_from_id=>wwv_flow_imp.id(9101106304535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Categor\00EDa')
,p_translate_from_text=>'Category'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15590223237417969)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(9101910594535117.100005)
,p_translate_from_id=>wwv_flow_imp.id(9101910594535117)
,p_translate_column_id=>475
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Versi\00F3n')
,p_translate_from_text=>'Version'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15590449601417970)
,p_translated_flow_id=>100005
,p_translate_to_id=>100.100005
,p_translate_from_id=>100
,p_translate_column_id=>476
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX'
,p_translate_from_text=>'Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15590661432417971)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2131266656065931.100005)
,p_translate_from_id=>wwv_flow_imp.id(2131266656065931)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error de proceso de archivo de resumen de instancia diaria'
,p_translate_from_text=>'Daily Instance Summary Archive process error'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15590830194417971)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2132703073101244.100005)
,p_translate_from_id=>wwv_flow_imp.id(2132703073101244)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>unistr('Error al depurar los res\00FAmenes de estad\00EDsticas de Flows for APEX')
,p_translate_from_text=>'Error purging Flows for APEX Statistics summaries'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15591084754417971)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2134675479122562.100005)
,p_translate_from_id=>wwv_flow_imp.id(2134675479122562)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX: error al depurar las tablas de log.'
,p_translate_from_text=>'Flows for APEX - Error purging log tables.'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15591212472417972)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2133626467110885.100005)
,p_translate_from_id=>wwv_flow_imp.id(2133626467110885)
,p_translate_column_id=>511
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Error al recopilar flujos de Flows for APEX'
,p_translate_from_text=>'Error gathering daily Flows for APEX Stats'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15591490894417972)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570671262060506.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570671262060506)
,p_translate_column_id=>516
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_translate_from_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15591693943417972)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570853105060508.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570853105060508)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Approve'
,p_translate_from_text=>'Approve'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15591859378417972)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(2570994574060509.100005)
,p_translate_from_id=>wwv_flow_imp.id(2570994574060509)
,p_translate_column_id=>520
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Reject'
,p_translate_from_text=>'Reject'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15938984689130159)
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100009)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939044643130429)
,p_page_id=>8
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100009)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939171109130429)
,p_page_id=>10
,p_translated_flow_id=>100009
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100009)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'zh-cn'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939373266130708)
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100008)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939451177130780)
,p_page_id=>8
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100008)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939533225130780)
,p_page_id=>10
,p_translated_flow_id=>100008
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100008)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'zh-tw'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939766707130880)
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100001)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939824770130952)
,p_page_id=>8
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100001)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15939991362130952)
,p_page_id=>10
,p_translated_flow_id=>100001
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100001)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'fr'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15940120853131052)
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100004)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15940222748131125)
,p_page_id=>8
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100004)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15940464595131125)
,p_page_id=>10
,p_translated_flow_id=>100004
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100004)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'de'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15940684714131228)
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100006)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15940729113131302)
,p_page_id=>8
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100006)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15940915267131302)
,p_page_id=>10
,p_translated_flow_id=>100006
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100006)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'it'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941108048131404)
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100003)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941219169131475)
,p_page_id=>8
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100003)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941379217131475)
,p_page_id=>10
,p_translated_flow_id=>100003
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100003)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'ja'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941522747131577)
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100007)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941679952131648)
,p_page_id=>8
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100007)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941719990131648)
,p_page_id=>10
,p_translated_flow_id=>100007
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100007)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'ko'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15941904742131748)
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100002)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15942054978131819)
,p_page_id=>8
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100002)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15942282506131819)
,p_page_id=>10
,p_translated_flow_id=>100002
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100002)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'pt-br'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15942429940131921)
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(12315927534327459869.100005)
,p_translate_from_id=>wwv_flow_imp.id(12315927534327459869)
,p_translate_column_id=>237
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'Flows for APEX - Return to Flows for APEX'
,p_translate_from_text=>'Flows for APEX - Return to Flows for APEX'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15942524251131992)
,p_page_id=>8
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6133652177393567089.100005)
,p_translate_from_id=>wwv_flow_imp.id(6133652177393567089)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
wwv_flow_imp_shared.create_translation(
 p_id=>wwv_flow_imp.id(15942663147131992)
,p_page_id=>10
,p_translated_flow_id=>100005
,p_translate_to_id=>wwv_flow_imp.id(6127698437330102702.100005)
,p_translate_from_id=>wwv_flow_imp.id(6127698437330102702)
,p_translate_column_id=>406
,p_translate_to_lang_code=>'es'
,p_translation_specific_to_item=>'NO'
,p_template_translatable=>'N'
,p_translate_to_text=>'ITERATION_DATA'
,p_translate_from_text=>'ITERATION_DATA'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(88199069651756122)
,p_build_option_name=>'Exclude'
,p_build_option_status=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892704058116077)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'de'
,p_message_text=>'APEX Seite'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36508956348127995)
,p_name=>'APEX:APEXPAGE'
,p_message_text=>'APEX Page'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934600888119469)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina APEX')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884492179115499)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'fr'
,p_message_text=>'Page APEX'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901019476116916)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'it'
,p_message_text=>'Pagina APEX'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909300441117433)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('APEX\30DA\30FC\30B8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918093328118157)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('APEX \D398\C774\C9C0')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926387829118763)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina APEX')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867875615114212)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('APEX \9875')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876151243114901)
,p_name=>'APEX:APEXPAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('APEX \9801\9762')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892827208116077)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'de'
,p_message_text=>unistr('PL/SQL ausf\00FChren')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36509146907128987)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_text=>'Execute PL/SQL'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934762757119469)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'es'
,p_message_text=>'Ejecutar PL/SQL'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884562527115499)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter PL/SQL')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901101755116916)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'it'
,p_message_text=>'Esegui PL/SQL'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909407133117433)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\306E\5B9F\884C')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918143106118157)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'ko'
,p_message_text=>unistr('PL/SQL \C2E4\D589')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926450172118763)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'pt-br'
,p_message_text=>'Executar PL/SQL'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867998713114212)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C PL/SQL')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876213011114901)
,p_name=>'APEX:EXECUTEPLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C PL/SQL')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892914921116077)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'de'
,p_message_text=>'Zyklus (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36509328878129867)
,p_name=>'APEX:ORACLECYCLE'
,p_message_text=>'Cycle (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934827158119469)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'es'
,p_message_text=>'Ciclo (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884608402115499)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'fr'
,p_message_text=>'Cycle (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901228798116916)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'it'
,p_message_text=>'Ciclo (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909522629117433)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30AF\30EB(Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918258292118157)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\AE30(Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926535785118763)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ciclo (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868056033114212)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468\671F (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876314939114901)
,p_name=>'APEX:ORACLECYCLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031\671F (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893523269116077)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'de'
,p_message_text=>'Datum (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36510876716170222)
,p_name=>'APEX:ORACLEDATE'
,p_message_text=>'Date (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935482687119469)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'es'
,p_message_text=>'Fecha (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885212164115499)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'fr'
,p_message_text=>'Date (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901874079116916)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'it'
,p_message_text=>'Data (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15910110159117433)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8(Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918866721118158)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C790(Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927155965118764)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868613221114213)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876949610114902)
,p_name=>'APEX:ORACLEDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893183283116077)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'de'
,p_message_text=>'Dauer (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36509739553137614)
,p_name=>'APEX:ORACLEDURATION'
,p_message_text=>'Duration (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935048453119469)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884833812115499)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901444700116916)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'it'
,p_message_text=>'Durata (Oracle)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909739299117433)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9593(Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918412286118158)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\AC04(Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926753079118763)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868250337114212)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6301\7EED\65F6\95F4 (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876577721114901)
,p_name=>'APEX:ORACLEDURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6301\7E8C\6642\9593 (Oracle)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893034670116077)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'de'
,p_message_text=>'Email senden'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36509583287131032)
,p_name=>'APEX:SENDMAIL'
,p_message_text=>'Send Email'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934931614119469)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar correo electr\00F3nico')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884715907115499)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901381645116916)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'it'
,p_message_text=>'Invia e-mail'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909614597117433)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918317356118158)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C804\C790\BA54\C77C \C804\C1A1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926623241118763)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar e-mail'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868177047114212)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876406061114901)
,p_name=>'APEX:SENDMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885861164116075)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Es wurde ein APEX-Upgrade ermittelt:',
'<ul>',
unistr('<li>ausgef\00FChrte Version: %0.%1</li>'),
'<li>gespeicherte Version: %2.%3</li>',
'</ul>',
unistr('Sie m\00FCssen die Dokumentation <a href="#" >hier</a> befolgen, um dies aufzul\00F6sen.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3703354379634692)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An APEX upgrade have been detected:',
'<ul>',
'<li>running version: %0.%1</li>',
'<li>stored version: %2.%3</li>',
'</ul>',
'You must follow the documentation <a href="#" >here</a> to resolve it.'))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927748742119467)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se ha detectado una actualizaci\00F3n de APEX:'),
'<ul>',
'<li>running version: %0.%1</li>',
unistr('<li>versi\00F3n almacenada: %2.%3</li>'),
'</ul>',
unistr('Debe seguir la documentaci\00F3n <a href="#" >aqu\00ED</a> para resolverla.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877517907115497)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Une mise \00E0 niveau APEX a \00E9t\00E9 d\00E9tect\00E9e :'),
'<ul>',
unistr('<li>ex\00E9cution de la version : %0.%1</li>'),
unistr('<li>version stock\00E9e : %2.%3</li>'),
'</ul>',
unistr('Vous devez suivre la documentation <a href="#" >ici</a> pour la r\00E9soudre.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894160287116914)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C8 stato rilevato un aggiornamento APEX:'),
'<ul>',
'<li>versione di esecuzione: %0.%1</li>',
'<li>versione memorizzata: %2.%3</li>',
'</ul>',
unistr('Per risolvere il problema, \00E8 necessario seguire la documentazione <a href="#" >qui</a>.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902418009117431)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('APEX\30A2\30C3\30D7\30B0\30EC\30FC\30C9\304C\691C\51FA\3055\308C\307E\3057\305F:'),
'<ul>',
unistr('<li>\5B9F\884C\4E2D\30D0\30FC\30B8\30E7\30F3: %0.%1</li>'),
unistr('<li>\683C\7D0D\3055\308C\305F\30D0\30FC\30B8\30E7\30F3: %2.%3</li>'),
'</ul>',
unistr('\89E3\6C7A\3059\308B\306B\306F\3001\30C9\30AD\30E5\30E1\30F3\30C8<a href="#" >\3053\3053</a>\306B\5F93\3046\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911172118118156)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('APEX \C5C5\ADF8\B808\C774\B4DC\AC00 \AC10\C9C0\B418\C5C8\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C2E4\D589 \C911\C778 \BC84\C804: %0.%1</li>'),
unistr('<li>\C800\C7A5\B41C \BC84\C804: %2.%3</li>'),
'</ul>',
unistr('\D574\ACB0\D558\B824\BA74 \C124\BA85\C11C <a href="#" >\C5EC\AE30</a>\B97C \B530\B77C\C57C \D569\B2C8\B2E4.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919462003118761)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Um upgrade do APEX foi detectado:',
'<ul>',
unistr('<li>vers\00E3o em execu\00E7\00E3o: %0.%1</li>'),
unistr('<li>vers\00E3o armazenada: %2.%3</li>'),
'</ul>',
unistr('\00C9 necess\00E1rio seguir a documenta\00E7\00E3o <a href="#" >aqui</a> para resolv\00EA-la.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15860937540114210)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\68C0\6D4B\5230 APEX \5347\7EA7\FF1A '),
'<ul>',
unistr(' <li> \8FD0\884C\7248\672C\FF1A%0.%1</li>'),
unistr(' <li> \5B58\50A8\7684\7248\672C\FF1A%2.%3</li>'),
' </ul>',
unistr(' \60A8\5FC5\987B\9075\5FAA\6587\6863 <a href="#" > \6B64\5904 </a> \6765\89E3\51B3\6B64\95EE\9898\3002')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869262291114899)
,p_name=>'APP_APEX_UPGRADE_DETECTED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5075\6E2C\5230 APEX \5347\7D1A\FF1A '),
'<ul>',
unistr(' <li> \57F7\884C\4E2D\7248\672C\FF1A%0.%1</li>'),
unistr(' <li> \5132\5B58\7684\7248\672C\FF1A%2.%3</li>'),
' </ul>',
unistr(' \60A8\5FC5\9808\4F9D\7167 <a href="#" > \6B64\8655 </a> \52A0\4EE5\89E3\6C7A\3002')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892589212116077)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'de'
,p_message_text=>'Abgeschlossen'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34717207504480868)
,p_name=>'APP_COMPLETE_STEP'
,p_message_text=>'Complete'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934432561119469)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'es'
,p_message_text=>'Completo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884229900115499)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'fr'
,p_message_text=>unistr('Compl\00E9ter')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900808289116916)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'it'
,p_message_text=>'Completato'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909173464117433)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917851827118157)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926140727118763)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'pt-br'
,p_message_text=>'Completo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867696753114212)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875986674114901)
,p_name=>'APP_COMPLETE_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890238556116076)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind dabei dieses Modell zu archivieren. M\00F6chten sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11208996871917779)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_text=>'You are about to archive this model. Do you want to continue?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932111926119468)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'es'
,p_message_text=>unistr('Va a archivar este modelo. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881931978115498)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point d''archiver ce mod\00E8le. Voulez-vous continuer?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898582763116915)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'it'
,p_message_text=>'Si sta per archiviare questo modello. Continuare?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906815187117432)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E2\30C7\30EB\3092\30A2\30FC\30AB\30A4\30D6\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\7D9A\884C\3057\307E\3059\304B?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915559638118157)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA8\B378\C744 \C544\CE74\C774\BE0C\D558\B824\ACE0 \D569\B2C8\B2E4. \ACC4\C18D\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923863341118763)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a arquivar este modelo. Voc\00EA quer continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865389832114212)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5373\5C06\5B58\6863\6B64\6A21\578B\3002\662F\5426\8981\7EE7\7EED\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873680386114901)
,p_name=>'APP_CONFIRM_ARCHIVE_MODEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5C01\5B58\6B64\6A21\578B\3002\60A8\662F\5426\8981\7E7C\7E8C\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886244671116075)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz wird gel\00F6scht. Bitte f\00FCgen sie einen Kommentar hinzu (optional) und best\00E4tigen sie.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5024381545147791)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_text=>'This will delete the flow instance. Please add a comment (optional) and click confirm.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928131832119467)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta acci\00F3n suprimir\00E1 la instancia de flujo. Agregue un comentario (opcional) y haga clic en Confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877971913115497)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>'Ceci supprimera l''instance de flux. Veuillez ajouter un commentaire (facultatif) et cliquer sur confirmer.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894569025116914)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa operazione eliminer\00E0 l''istanza del flusso. Aggiungere un commento (facoltativo) e fare clic su Conferma.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902867704117431)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306B\3088\308A\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\524A\9664\3055\308C\307E\3059\3002\30B3\30E1\30F3\30C8(\4EFB\610F)\3092\8FFD\52A0\3057\3001\300C\78BA\8A8D\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911573128118156)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C0AD\C81C\B429\B2C8\B2E4. \C124\BA85\C744 \CD94\AC00\D558\ACE0(\C120\D0DD\C0AC\D56D) \D655\C778\C744 \B204\B974\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919878554118761)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Isto eliminar\00E1 a inst\00E2ncia de fluxo. Favor adicionar um coment\00E1rio (opcional) e clicar em confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861371619114210)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\5C06\5220\9664\6D41\7A0B\5B9E\4F8B\3002\8BF7\6DFB\52A0\5907\6CE8\FF08\53EF\9009\FF09\FF0C\7136\540E\5355\51FB\201C\786E\8BA4\201D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869622191114899)
,p_name=>'APP_CONFIRM_DELETE_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\6703\522A\9664\6D41\7A0B\5BE6\4F8B\3002\8ACB\65B0\589E\8A3B\89E3 (\9078\64C7\6027)\FF0C\7136\5F8C\6309\4E00\4E0B\78BA\8A8D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887466699116075)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'de'
,p_message_text=>unistr('Prozessvariable wird gel\00F6scht. Bitte f\00FCgen sie einen Kommentar hinzu (optional) und best\00E4tigen sie.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7370414939802683)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_text=>'This will delete the process variable. Please add a comment (optional) and click confirm.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929316746119468)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta acci\00F3n suprimir\00E1 la variable de proceso. Agregue un comentario (opcional) y haga clic en Confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879120254115497)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'fr'
,p_message_text=>'Ceci supprimera la variable de processus. Voulez-vous continuer?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895788494116915)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'it'
,p_message_text=>unistr('La variabile di processo verr\00E0 eliminata. Aggiungere un commento (facoltativo) e fare clic su Conferma.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904036402117431)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306B\3088\308A\3001\30D7\30ED\30BB\30B9\5909\6570\304C\524A\9664\3055\308C\307E\3059\3002\30B3\30E1\30F3\30C8(\4EFB\610F)\3092\8FFD\52A0\3057\3001\300C\78BA\8A8D\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912797066118156)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218\AC00 \C0AD\C81C\B429\B2C8\B2E4. \C124\BA85\C744 \CD94\AC00\D558\ACE0(\C120\D0DD\C0AC\D56D) \D655\C778\C744 \B204\B974\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921090047118762)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Isto eliminar\00E1 a vari\00E1vel de processo. Favor adicionar um coment\00E1rio (opcional) e clicar em confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862593895114211)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\5C06\5220\9664\8FDB\7A0B\53D8\91CF\3002\8BF7\6DFB\52A0\5907\6CE8\FF08\53EF\9009\FF09\FF0C\7136\540E\5355\51FB\201C\786E\8BA4\201D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870883651114900)
,p_name=>'APP_CONFIRM_DELETE_PROCESS_VARIABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\6703\522A\9664\8655\7406\8B8A\6578\3002\8ACB\65B0\589E\8A3B\89E3 (\9078\64C7\6027)\FF0C\7136\5F8C\6309\4E00\4E0B\78BA\8A8D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892057195116077)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind dabei dieses Modell als Veraltet zu markieren. M\00F6chten sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34705077390288729)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_text=>'You are about to mark as deprecated this model. Do you want to continue?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933998793119469)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 a punto de marcar este modelo como en desuso. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883783690115499)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de rendre obsol\00E8te ce mod\00E8le. Voulez-vous continuer ?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900365017116916)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'it'
,p_message_text=>unistr('Si sta per contrassegnare come non pi\00F9 valido questo modello. Continuare?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908693470117433)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E2\30C7\30EB\3092\975E\63A8\5968\3068\3057\3066\30DE\30FC\30AF\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\7D9A\884C\3057\307E\3059\304B?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917333631118157)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA8\B378\C744 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\B294 \AC83\C73C\B85C \D45C\C2DC\D558\B824\ACE0 \D569\B2C8\B2E4. \ACC4\C18D\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925652949118763)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a marcar este modelo como descontinuado. Voc\00EA quer continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867160086114212)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5373\5C06\6807\8BB0\4E3A\5DF2\5F03\7528\6B64\6A21\578B\3002\662F\5426\8981\7EE7\7EED\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875425652114901)
,p_name=>'APP_CONFIRM_DEPRECATE_MODEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5C07\6B64\6A21\578B\6A19\793A\70BA\5DF2\4E0D\518D\4F7F\7528\3002\60A8\662F\5426\8981\7E7C\7E8C\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891065303116076)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind dabei das Diagramm eines releasten Modells zu \00E4ndern. Dies kann zu Fehlern in der Ausf\00FChrung aktueller Instanzen dieses Modells f\00FChren. M\00F6chten sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14021007858509194)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_text=>'Your are about to modify a diagram of a released model. That could possibly breaks running instances of that model. Do you want to continue?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932926968119469)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'es'
,p_message_text=>unistr('Va a modificar un diagrama de un modelo liberado. Esto podr\00EDa interrumpir las instancias en ejecuci\00F3n de ese modelo. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882737214115498)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de modifier un diagramme d''un mod\00E8le au statut released. Cela pourrait \00E9ventuellement provoquer des erreurs sur les instances en cours d''ex\00E9cution pour ce mod\00E8le. Voulez-vous continuer ?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899347768116916)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'it'
,p_message_text=>unistr('Si sta per modificare un diagramma di un modello rilasciato. Ci\00F2 potrebbe interrompere l''esecuzione di istanze di quel modello. Continuare?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907641871117432)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9\3055\308C\305F\30E2\30C7\30EB\306E\56F3\3092\4FEE\6B63\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\3053\308C\306B\3088\308A\3001\305D\306E\30E2\30C7\30EB\306E\5B9F\884C\4E2D\306E\30A4\30F3\30B9\30BF\30F3\30B9\304C\58CA\308C\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\7D9A\884C\3057\307E\3059\304B?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916305398118157)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'ko'
,p_message_text=>unistr('\B9B4\B9AC\C988\B41C \BAA8\B378\C758 \B2E4\C774\C5B4\ADF8\B7A8\C744 \C218\C815\D558\B824\ACE0 \D569\B2C8\B2E4. \C774 \ACBD\C6B0 \D574\B2F9 \BAA8\B378\C758 \C2E4\D589 \C911\C778 \C778\C2A4\D134\C2A4\AC00 \C190\C0C1\B420 \C218 \C788\C2B5\B2C8\B2E4. \ACC4\C18D\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924696235118763)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a modificar um diagrama de um modelo lan\00E7ado. Isso poderia possivelmente quebrar inst\00E2ncias de execu\00E7\00E3o desse modelo. Voc\00EA quer continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866112468114212)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\4FEE\6539\5DF2\53D1\5E03\6A21\578B\7684\56FE\8868\3002\8FD9\53EF\80FD\4F1A\7834\574F\8BE5\6A21\578B\7684\8FD0\884C\5B9E\4F8B\3002\662F\5426\8981\7EE7\7EED\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874413724114901)
,p_name=>'APP_CONFIRM_EDIT_RELEASE_DIAGRAM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\4FEE\6539\5DF2\6838\767C\6A21\578B\7684\5716\8868\3002\9019\53EF\80FD\6703\7834\58DE\8A72\6A21\578B\7684\57F7\884C\5BE6\4F8B\3002\60A8\662F\5426\8981\7E7C\7E8C\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892197048116077)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind dabei dieses Model zu releasen. Die aktuelle Release-Version wird als Veraltet markiert. M\00F6chten sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34706651053300739)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_text=>'You are about to release this model, this will mark as deprecated the current released version. Do you want to continue?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934026756119469)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 a punto de lanzar este modelo. Esto marcar\00E1 como en desuso la versi\00F3n publicada actual. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883812085115499)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de publier ce mod\00E8le, ceci rendra obsol\00E8te la version courant publi\00E9e. Voulez-vous continuer?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900404124116916)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'it'
,p_message_text=>unistr('Si sta per rilasciare questo modello. Verr\00E0 contrassegnata come non pi\00F9 valida la versione rilasciata corrente. Continuare?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908734811117433)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E2\30C7\30EB\3092\30EA\30EA\30FC\30B9\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\73FE\5728\306E\30EA\30EA\30FC\30B9\6E08\30D0\30FC\30B8\30E7\30F3\304C\975E\63A8\5968\3068\3057\3066\30DE\30FC\30AF\3055\308C\307E\3059\3002\7D9A\884C\3057\307E\3059\304B?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917471796118157)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \BAA8\B378\C744 \B9B4\B9AC\C2A4\D558\B824\ACE0 \D569\B2C8\B2E4. \ADF8\B7EC\BA74 \D604\C7AC \B9B4\B9AC\C2A4\B41C \BC84\C804\C774 \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\B294 \AC83\C73C\B85C \D45C\C2DC\B429\B2C8\B2E4. \ACC4\C18D\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925735482118763)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a lan\00E7ar este modelo, isto marcar\00E1 a vers\00E3o atual lan\00E7ada como descontinuado. Voc\00EA quer continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867272544114212)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5373\5C06\53D1\5E03\6B64\6A21\578B\FF0C\8FD9\4F1A\5C06\5F53\524D\53D1\5E03\7684\7248\672C\6807\8BB0\4E3A\5DF2\8FC7\65F6\3002\662F\5426\8981\7EE7\7EED\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875581438114901)
,p_name=>'APP_CONFIRM_RELEASE_MODEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\767C\884C\6B64\6A21\578B\FF0C\9019\5C07\6703\6A19\793A\70BA\5DF2\68C4\7528\76EE\524D\7684\767C\884C\7248\672C\3002\60A8\662F\5426\8981\7E7C\7E8C\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890335061116076)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'de'
,p_message_text=>unistr('Sie sind dabei die Reservierung f\00FCr Schritte aufzuheben. M\00F6chten sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11225313312069738)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_text=>'You are about to release reservation on step(s). Do you want to continue?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932246859119469)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 a punto de liberar la reserva en los pasos. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882078798115498)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de lib\00E9rer la r\00E9servation de la ou des \00E9tapes(s). Voulez-vous continuer?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898667482116915)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'it'
,p_message_text=>'Si sta per rilasciare la prenotazione per i passi. Continuare?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906966915117432)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D7\3067\4E88\7D04\3092\30EA\30EA\30FC\30B9\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\7D9A\884C\3057\307E\3059\304B?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915667173118157)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4\C5D0\C11C \C608\C57D\C744 \B9B4\B9AC\C2A4\D558\B824\ACE0 \D569\B2C8\B2E4. \ACC4\C18D\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923957873118763)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a liberar a reserva na(s) etapa(s). Voc\00EA quer continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865497474114212)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\5728\6B65\9AA4\4E2D\91CA\653E\4FDD\7559\3002\662F\5426\8981\7EE7\7EED\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873754845114901)
,p_name=>'APP_CONFIRM_RELEASE_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\6838\767C\6B65\9A5F\7684\9810\7559\3002\60A8\662F\5426\8981\7E7C\7E8C\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886095207116075)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz wird zur\00FCckgesetzt. Bitte f\00FCgen sie einen Kommentar hinzu (optional) und best\00E4tigen sie.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5023975409141065)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_text=>'This will reset the flow instance. Please add a comment (optional) and click confirm.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927990450119467)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Esto restablecer\00E1 la instancia de flujo. Agregue un comentario (opcional) y haga clic en Confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877738888115497)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci r\00E9initialisera l''instance de flux. Veuillez ajouter un commentaire (facultatif) et cliquer sur confirmer.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894376609116914)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa operazione reimposter\00E0 l''istanza del flusso. Aggiungere un commento (facoltativo) e fare clic su Conferma.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902670243117431)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306B\3088\308A\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\30EA\30BB\30C3\30C8\3055\308C\307E\3059\3002\30B3\30E1\30F3\30C8(\4EFB\610F)\3092\8FFD\52A0\3057\3001\300C\78BA\8A8D\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911328901118156)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\ADF8\B7EC\BA74 \D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C7AC\C124\C815\B429\B2C8\B2E4. \C124\BA85\C744 \CD94\AC00\D558\ACE0(\C120\D0DD\C0AC\D56D) \D655\C778\C744 \B204\B974\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919619408118761)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Isto reiniciar\00E1 a inst\00E2ncia de fluxo. Favor adicionar um coment\00E1rio (opcional) e clicar em confirmar.')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861150159114210)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\5C06\91CD\7F6E\6D41\7A0B\5B9E\4F8B\3002\8BF7\6DFB\52A0\5907\6CE8\FF08\53EF\9009\FF09\FF0C\7136\540E\5355\51FB\201C\786E\8BA4\201D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869488631114899)
,p_name=>'APP_CONFIRM_RESET_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\6703\91CD\8A2D\6D41\7A0B\5BE6\4F8B\3002\8ACB\65B0\589E\8A3B\89E3 (\9078\64C7\6027)\FF0C\7136\5F8C\6309\4E00\4E0B\78BA\8A8D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887342765116075)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'de'
,p_message_text=>unistr('Subflow wird neu gestartet. Bitte f\00FCgen sie einen Kommentar hinzu (optional) und best\00E4tigen sie.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7072975164227666)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_text=>'This will restart the subflow. Please add a comment (optional) and click confirm.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929273825119468)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'es'
,p_message_text=>unistr('Esto reiniciar\00E1 el subflujo. Agregue un comentario (opcional) y haga clic en Confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879009760115497)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci red\00E9marrera le sous-flux. Veuillez ajouter un commentaire (facultatif) et cliquer sur confirmer.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895685718116915)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'it'
,p_message_text=>unistr('Il flusso secondario verr\00E0 riavviato. Aggiungere un commento (facoltativo) e fare clic su Conferma.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903951479117431)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306B\3088\308A\30B5\30D6\30D5\30ED\30FC\304C\518D\8D77\52D5\3055\308C\307E\3059\3002\30B3\30E1\30F3\30C8(\4EFB\610F\FF09\3092\8FFD\52A0\3057\3001\300C\78BA\8A8D\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912676377118156)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B807\AC8C \D558\BA74 \D558\C704 \D50C\B85C\C6B0\AC00 \B2E4\C2DC \C2DC\C791\B429\B2C8\B2E4. \C124\BA85\C744 \CD94\AC00\D558\ACE0(\C120\D0DD\C0AC\D56D) \D655\C778\C744 \B204\B974\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920930012118762)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Isto reiniciar\00E1 o subfluxo. Favor adicionar um coment\00E1rio (opcional) e clicar em confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862429605114211)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\5C06\91CD\65B0\542F\52A8\5B50\6D41\7A0B\3002\8BF7\6DFB\52A0\5907\6CE8\FF08\53EF\9009\FF09\FF0C\7136\540E\5355\51FB\201C\786E\8BA4\201D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870724371114900)
,p_name=>'APP_CONFIRM_RESTART_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\6703\91CD\65B0\555F\52D5\5B50\6D41\7A0B\3002\8ACB\65B0\589E\8A3B\89E3 (\9078\64C7\6027)\FF0C\7136\5F8C\6309\4E00\4E0B\78BA\8A8D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886142446116075)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz wird terminiert. Bitte f\00FCgen sie einen Kommentar hinzu (optional) und best\00E4tigen sie.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5024181840145883)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_text=>'This will terminate the flow instance. Please add a comment (optional) and click confirm.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928020572119467)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta acci\00F3n terminar\00E1 la instancia de flujo. Agregue un comentario (opcional) y haga clic en Confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877884810115497)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>'Ceci terminera l''instance de flux. Veuillez ajouter un commentaire (facultatif) et cliquer sur confirmer.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894414581116914)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'it'
,p_message_text=>unistr('Questa operazione interromper\00E0 l''istanza del flusso. Aggiungere un commento (facoltativo) e fare clic su Conferma.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902742245117431)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306B\3088\308A\3001\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\7D42\4E86\3057\307E\3059\3002\30B3\30E1\30F3\30C8(\4EFB\610F)\3092\8FFD\52A0\3057\3001\300C\78BA\8A8D\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911454629118156)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C885\B8CC\B429\B2C8\B2E4. \C124\BA85\C744 \CD94\AC00\D558\ACE0(\C120\D0DD\C0AC\D56D) \D655\C778\C744 \B204\B974\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919726638118761)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Isto encerrar\00E1 a inst\00E2ncia de fluxo. Favor adicionar um coment\00E1rio (opcional) e clicar em confirmar.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861294600114210)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\5C06\7EC8\6B62\6D41\7A0B\5B9E\4F8B\3002\8BF7\6DFB\52A0\5907\6CE8\FF08\53EF\9009\FF09\FF0C\7136\540E\5355\51FB\201C\786E\8BA4\201D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869554404114899)
,p_name=>'APP_CONFIRM_TERMINATE_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\6703\7D42\6B62\6D41\7A0B\5BE6\4F8B\3002\8ACB\65B0\589E\8A3B\89E3 (\9078\64C7\6027)\FF0C\7136\5F8C\6309\4E00\4E0B\78BA\8A8D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892463200116077)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34716303518466200)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_text=>'Delete Flow Instance'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934325767119469)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'es'
,p_message_text=>'Suprimir instancia de flujo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884197381115499)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer une instance de flux'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900761008116916)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'it'
,p_message_text=>'Elimina istanza flusso'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909058670117433)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917746878118157)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C0AD\C81C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926025625118763)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eliminar inst\00E2ncia de fluxo')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867573482114212)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\6D41\7A0B\5B9E\4F8B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875808240114901)
,p_name=>'APP_DELETE_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\6D41\7A0B\5BE6\4F8B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891917998116077)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'de'
,p_message_text=>unistr('Es existieren %0, diesem Flow, zugeh\00F6rige Prozesse')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34704307318272181)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_text=>'There are %0 process instances associated to this flow.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933870709119469)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'es'
,p_message_text=>'Hay %0 instancias de proceso asociadas a este flujo.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883673145115499)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'fr'
,p_message_text=>unistr('Il existe %0 instance(s) de processus associ\00E9e(s) \00E0 ce flux.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900293798116916)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'it'
,p_message_text=>'A questo flusso sono associate %0 istanze di processo.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908503651117432)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30ED\30FC\306B\95A2\9023\4ED8\3051\3089\308C\305F\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C%0\500B\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917238423118157)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D50C\B85C\C6B0\C640 \C5F0\AD00\B41C %0\AC1C\C758 \D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4\AC00 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925566630118763)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 %0 inst\00E2ncias de processo associadas a este fluxo.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867085406114212)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709 %0 \4E2A\8FDB\7A0B\5B9E\4F8B\4E0E\6B64\6D41\7A0B\5173\8054\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875372983114901)
,p_name=>'APP_DIAGRAM_INSTANCES_NB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709 %0 \500B\8655\7406\57F7\884C\8655\7406\8207\6B64\6D41\7A0B\95DC\806F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888251705116076)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'de'
,p_message_text=>unistr('Bitte Verbindung ausw\00E4hlen')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7385691008882345)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_text=>'Please select a connection'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930150292119468)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una conexi\00F3n')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879932947115498)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'fr'
,p_message_text=>unistr('Veuillez s\00E9lectionner une connexion')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896578741116915)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'it'
,p_message_text=>'Selezionare una connessione'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904807139117431)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A5\7D9A\3092\9078\629E\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913529537118156)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\C811\C18D\C744 \C120\D0DD\D558\C2ED\C2DC\C624.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921872706118762)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por favor, selecione uma conex\00E3o')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863332707114211)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\9009\62E9\8FDE\63A5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871646141114900)
,p_name=>'APP_ERR_GATEWAY_CONNECTION_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\9078\53D6\9023\7DDA')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888171653116075)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'de'
,p_message_text=>unistr('Bitte w\00E4hlen Sie nur eine Verbindung aus')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7385418133881112)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Please select only one connection',
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930032230119468)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione solo una conexi\00F3n'),
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879825719115498)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Veuillez ne s\00E9lectionner qu''une connexion'),
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896402959116915)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selezionare una sola connessione',
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904745994117431)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A5\7D9A\30921\3064\306E\307F\9078\629E\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913490600118156)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C5F0\ACB0\C744 \D558\B098\B9CC \C120\D0DD\D558\C2ED\C2DC\C624.'),
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921747388118762)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por favor, selecione apenas uma conex\00E3o\005Cn')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863206764114211)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8BF7\4EC5\9009\62E9\4E00\4E2A\8FDE\63A5'),
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871559753114900)
,p_name=>'APP_ERR_GATEWAY_ONLY_ONE_CONNECTION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\53EA\9078\53D6\4E00\500B\9023\7DDA'),
''))
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891249556116077)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'de'
,p_message_text=>'Modell "%0" Version %1 existiert bereits.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16953295749988159)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_text=>'Model "%0" Version %1 already exists.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933179747119469)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('El modelo "%0" versi\00F3n %1 ya existe.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882926343115499)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le "%0" - Version %1 existe d\00E9j\00E0.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899543319116916)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'it'
,p_message_text=>unistr('Il modello "%0" versione %1 esiste gi\00E0.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907832970117432)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30C7\30EB"%0"\30D0\30FC\30B8\30E7\30F3%1\306F\65E2\306B\5B58\5728\3057\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916588630118157)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B378 "%0" \BC84\C804 %1\C774(\AC00) \C774\BBF8 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924885180118763)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo "%0 A vers\00E3o j\00E1 existe.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866341579114212)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\578B "%0" \7248\672C %1 \5DF2\5B58\5728\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874695166114901)
,p_name=>'APP_ERR_MODEL_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\578B "%0" \7248\672C %1 \5DF2\7D93\5B58\5728\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891173646116076)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'de'
,p_message_text=>'Version existiert bereits.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14702944177906412)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_text=>'Version already exists.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933026418119469)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('Esta versi\00F3n ya existe.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882803006115499)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La version existe d\00E9j\00E0')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899479412116916)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'it'
,p_message_text=>unistr('Questa versione esiste gi\00E0.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907735187117432)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30B8\30E7\30F3\304C\65E2\306B\5B58\5728\3057\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916457129118157)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC84\C804\C774 \C774\BBF8 \C874\C7AC\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924799160118763)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vers\00E3o j\00E1 existe.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866236643114212)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7248\672C\5DF2\5B58\5728\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874557901114901)
,p_name=>'APP_ERR_MODEL_VERSION_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\672C\5DF2\5B58\5728\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893686293116077)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'de'
,p_message_text=>unistr('\00DCberschreiben nur bei Entw\00FCrfen m\00F6glich.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61364531151233202)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_text=>'Overwrite only possible for draft models.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935523945119469)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'es'
,p_message_text=>'Sobrescribir solo es posible para modelos provisionales.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885311831115499)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9crasement n''est possible que pour les mod\00E8les au statut draft.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901949354116916)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'it'
,p_message_text=>'Sovrascrivi possibile solo per i modelli bozza.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15910200135117433)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\66F8\304D\3067\304D\308B\306E\306F\30C9\30E9\30D5\30C8\30FB\30E2\30C7\30EB\306B\5BFE\3057\3066\306E\307F\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918905767118158)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'ko'
,p_message_text=>unistr('\CD08\C548 \BAA8\B378\C5D0 \B300\D574\C11C\B9CC \ACB9\CCD0\C501\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927202682118764)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substitua somente os modelos preliminares poss\00EDveis.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868772119114213)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\80FD\8986\76D6\8349\7A3F\6A21\578B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877017264114902)
,p_name=>'APP_ERR_ONLY_DRAFT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\80FD\8986\5BEB\8349\7A3F\6A21\578B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888012609116075)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'de'
,p_message_text=>'Wert muss ein Datum sein'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7385297806875971)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_text=>'Value must be a date'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929907392119468)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'es'
,p_message_text=>'El valor debe ser una fecha'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879785430115498)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre une date')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896331844116915)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere una data'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904603766117431)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913339647118156)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C77C\C790\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921639968118762)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'O valor deve ser uma data'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863136906114211)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871414817114900)
,p_name=>'APP_ERR_PROV_VAR_DATE_NOT_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886443640116075)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'de'
,p_message_text=>unistr('Wert muss g\00FCltiges JSON sein')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7002513534958128)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_text=>'Value must a valid JSON'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928357164119467)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'es'
,p_message_text=>unistr('El valor debe ser un JSON v\00E1lido')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878135318115497)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre un JSON valide')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894793669116914)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere un JSON valido'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903052393117431)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\6709\52B9\306AJSON\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911764505118156)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C720\D6A8\D55C JSON\C774\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920045077118761)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor deve ser um JSON v\00E1lido')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861559759114210)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\6709\6548\7684 JSON')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869824246114900)
,p_name=>'APP_ERR_PROV_VAR_INVALID_JSON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\6709\6548\7684 JSON')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887608694116075)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'de'
,p_message_text=>'Variablen-Name muss einen Wert haben'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7384469808866136)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_text=>'Variable Name must have a value'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929594075119468)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'es'
,p_message_text=>'El nombre de variable debe tener un valor'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879309672115497)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'fr'
,p_message_text=>'Le nom de la variable doit avoir une valeur'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895995938116915)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'it'
,p_message_text=>'Il nome della variabile deve avere un valore'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904282637117431)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\6570\540D\306B\306F\5024\304C\5FC5\8981\3067\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912939642118156)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\C218 \C774\B984\C5D0\B294 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921210417118762)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome da Vari\00E1vel deve ser informado')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862712031114211)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D8\91CF\540D\79F0\5FC5\987B\5177\6709\503C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871020344114900)
,p_name=>'APP_ERR_PROV_VAR_NAME_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\6578\540D\7A31\5FC5\9808\6709\503C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887988209116075)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'de'
,p_message_text=>'Wert muss eine Zahl sein'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7385007498873734)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_text=>'Value must be a number'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929846658119468)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('El valor debe ser un n\00FAmero')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879657491115498)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre un nombre')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896257352116915)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere un numero'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904518919117431)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\6570\5024\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913225095118156)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C22B\C790\C5EC\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921534370118762)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor deve ser um n\00FAmero')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863096444114211)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\6570\5B57')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871365571114900)
,p_name=>'APP_ERR_PROV_VAR_NUM_NOT_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\6578\5B57')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885926606116075)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'de'
,p_message_text=>'Wert muss ein Zeitstempel sein'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4774216918721288)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_text=>'Value must be a timestamp'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927838542119467)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'es'
,p_message_text=>'El valor debe ser un registro de hora'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877675443115497)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre un horodatage')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894279211116914)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'it'
,p_message_text=>'Il valore deve essere un indicatore orario'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902569200117431)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911214361118156)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C740 \C2DC\AC04\AE30\B85D\C774\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919503795118761)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'pt-br'
,p_message_text=>'O valor deve ser um timestamp'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861034698114210)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\65F6\95F4\6233')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869384269114899)
,p_name=>'APP_ERR_PROV_VAR_TSTZ_NOT_TSTZ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\6642\6233')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887709575116075)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'de'
,p_message_text=>'Variablen-Typ muss einen Wert haben'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7384642544868247)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_text=>'Variable Type must have a value'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929600215119468)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'es'
,p_message_text=>'El tipo de variable debe tener un valor'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879449344115497)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'fr'
,p_message_text=>'Le type de variable doit avoir une valeur'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896041876116915)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'it'
,p_message_text=>'Il tipo di variabile deve avere un valore'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904390490117431)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\6570\30BF\30A4\30D7\306B\306F\5024\304C\5FC5\8981\3067\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913006955118156)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\C218 \C720\D615\C5D0\B294 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921388174118762)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Tipo de Vari\00E1vel deve ser informado')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862885376114211)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D8\91CF\7C7B\578B\5FC5\987B\5177\6709\503C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871136062114900)
,p_name=>'APP_ERR_PROV_VAR_TYPE_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\6578\985E\578B\5FC5\9808\6709\503C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887850461116075)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'de'
,p_message_text=>'Wert muss einen Wert haben'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7384854796870876)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_text=>'Value must have a value'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929798246119468)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'es'
,p_message_text=>'El valor debe tener un valor'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879502966115497)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur ne peut \00EAtre vide')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896144860116915)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'it'
,p_message_text=>'Il valore deve avere un valore'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904478439117431)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306B\306F\5024\304C\5FC5\8981\3067\3059')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913115697118156)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'ko'
,p_message_text=>unistr('\AC12\C5D0\B294 \AC12\C774 \C788\C5B4\C57C \D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921451140118762)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>'O Valor deve ser informado'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862900906114211)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\5177\6709\503C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871296185114900)
,p_name=>'APP_ERR_PROV_VAR_VALUE_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\6709\503C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886363875116075)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'de'
,p_message_text=>'Vorlage "%0" ist bereits vorhanden.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6619558821512329)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_text=>'Template "%0" already exists.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928287421119467)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'es'
,p_message_text=>'La plantilla "%0" ya existe.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878003758115497)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le "%0" existe d\00E9j\00E0.')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894615943116914)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'it'
,p_message_text=>unistr('Il modello "%0" esiste gi\00E0.')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902945086117431)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8"%0"\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911680701118156)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'ko'
,p_message_text=>unistr('"%0" \D15C\D50C\B9AC\D2B8\AC00 \C874\C7AC\D569\B2C8\B2E4.')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919987201118761)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O modelo "%0" j\00E1 existe.')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861481701114210)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F "%0" \5DF2\5B58\5728\3002')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869709243114900)
,p_name=>'APP_ERR_TEMPLATE_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F "%0" \5DF2\7D93\5B58\5728\3002')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891817137116077)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'de'
,p_message_text=>'Instanz erstellt.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29609850900170775)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_text=>'Instance created.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933791531119469)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Instancia creada.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883573809115499)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Instance cr\00E9\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900115679116916)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'it'
,p_message_text=>'Istanza creata.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908441621117432)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917156062118157)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C778\C2A4\D134\C2A4\AC00 \C0DD\C131\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925420841118763)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inst\00E2ncia criada.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866974897114212)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\5B9E\4F8B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875268266114901)
,p_name=>'APP_INSTANCE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\57F7\884C\8655\7406\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886853956116075)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz gel\00F6scht')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7005845949232185)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_text=>'Flow instance deleted.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928702042119468)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'es'
,p_message_text=>'Instancia de flujo suprimida.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878533861115497)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Instance de flux supprim\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895117507116914)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Istanza flusso eliminata.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903441547117431)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\524A\9664\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912153891118156)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920451174118762)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inst\00E2ncia de fluxo eliminada.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861923553114210)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\6D41\7A0B\5B9E\4F8B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870200572114900)
,p_name=>'APP_INSTANCE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\6D41\7A0B\57F7\884C\8655\7406\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886621904116075)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz zur\00FCckgesetzt')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7005460531221619)
,p_name=>'APP_INSTANCE_RESET'
,p_message_text=>'Flow instance reset.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928511304119468)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecimiento de instancia de flujo.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878325710115497)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('Instance de flux r\00E9initialis\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894959782116914)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'it'
,p_message_text=>'Reimpostazione istanza flusso.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903299678117431)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\30EA\30BB\30C3\30C8\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911929756118156)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C7AC\C124\C815\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920289454118761)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reiniciar a inst\00E2ncia do fluxo.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861739587114210)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\7A0B\5B9E\4F8B\91CD\7F6E\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870008070114900)
,p_name=>'APP_INSTANCE_RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B\57F7\884C\8655\7406\5DF2\91CD\8A2D\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886518473116075)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'de'
,p_message_text=>'Flow-Instanz gestartet'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7005265750200100)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_text=>'Flow instance started.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928449166119468)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'es'
,p_message_text=>'Instancia de flujo iniciada.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878298532115497)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Instance de flux d\00E9marr\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894861397116914)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'it'
,p_message_text=>'Istanza flusso avviata.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903197458117431)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\8D77\52D5\3057\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911821132118156)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C2DC\C791\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920197537118761)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo de fluxo iniciado.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861627558114210)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\7A0B\5B9E\4F8B\5DF2\542F\52A8\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869912020114900)
,p_name=>'APP_INSTANCE_STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B\5BE6\4F8B\5DF2\555F\52D5\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886796838116075)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'de'
,p_message_text=>'Flow-Instanz terminiert'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7005690133229935)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_text=>'Flow instance terminated.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928636407119468)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'es'
,p_message_text=>'Instancia de flujo terminada.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878422059115497)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Instance de flux termin\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895031250116914)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'it'
,p_message_text=>'Istanza flusso terminata.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903372452117431)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\7D42\4E86\3057\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912062284118156)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4\AC00 \C885\B8CC\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920351564118762)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inst\00E2ncia de Fluxo encerrada.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15861834292114210)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\7A0B\5B9E\4F8B\5DF2\7EC8\6B62\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870190289114900)
,p_name=>'APP_INSTANCE_TERMINATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B\57F7\884C\8655\7406\5DF2\7D42\6B62\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889962135116076)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'de'
,p_message_text=>'Mehrere Modelle'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8423955865822272)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_text=>'Multiple Models'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931842893119468)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'es'
,p_message_text=>'Varios modelos'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881637646115498)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'fr'
,p_message_text=>unistr('Plusieurs Mod\00E8les')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898216930116915)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'it'
,p_message_text=>unistr('Pi\00F9 modelli')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906503875117432)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\306E\30E2\30C7\30EB')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915293838118157)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E4\C911 \BAA8\B378')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923538063118762)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos M\00FAltiplos')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865096568114211)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4E2A\6A21\578B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873366215114901)
,p_name=>'APP_LOV_MULTIPLE_MODELS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\91CD\6A21\578B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889815261116076)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'de'
,p_message_text=>'Ein Modell'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8423720117819875)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_text=>'One Model'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931738071119468)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'es'
,p_message_text=>'Un modelo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881525878115498)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Un mod\00E8le')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898131392116915)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'it'
,p_message_text=>'Un unico modello'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906491539117432)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\306E\30E2\30C7\30EB')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915177657118157)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\C77C \BAA8\B378')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923402977118762)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'pt-br'
,p_message_text=>'Um Modelo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864914656114211)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\4E2A\6A21\578B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873208039114900)
,p_name=>'APP_LOV_ONE_MODEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\4E2A\6A21\578B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888324959116076)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'de'
,p_message_text=>'Modell kopiert'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8225061315538358)
,p_name=>'APP_MODEL_COPIED'
,p_message_text=>'Model copied.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930280485119468)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'es'
,p_message_text=>'Modelo copiado.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880031736115498)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le copi\00E9.')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896654889116915)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'it'
,p_message_text=>'Modello copiato.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904966988117432)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30C7\30EB\304C\30B3\30D4\30FC\3055\308C\307E\3057\305F\3002')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913671755118156)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B378\C774 \BCF5\C0AC\B418\C5C8\C2B5\B2C8\B2E4.')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921992563118762)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo copiado.'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863469391114211)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\590D\5236\6A21\578B\3002')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871721292114900)
,p_name=>'APP_MODEL_COPIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8907\88FD\6A21\578B\3002')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891782710116077)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'de'
,p_message_text=>'Modell importiert.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28300791809214356)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_text=>'Model imported.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933626339119469)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'es'
,p_message_text=>'Modelo importado.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883411115115499)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le import\00E9.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900023990116916)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'it'
,p_message_text=>'Modello importato.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908353176117432)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30C7\30EB\304C\30A4\30F3\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917008924118157)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\BAA8\B378\C744 \C784\D3EC\D2B8\D588\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925332265118763)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo importado.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866858164114212)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5BFC\5165\6A21\578B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875198103114901)
,p_name=>'APP_MODEL_IMPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\532F\5165\6A21\578B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892660198116077)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('Neue Version hinzugef\00FCgt.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34723270983639953)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_text=>'New version added.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934542372119469)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva versi\00F3n agregada.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884353578115499)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle version ajout\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900962906116916)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'it'
,p_message_text=>'Nuova versione aggiunta.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909237283117433)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\30D0\30FC\30B8\30E7\30F3\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917900586118157)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BC84\C804\C774 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926261517118763)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova vers\00E3o adicionada.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867732517114212)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6DFB\52A0\65B0\7248\672C\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876003807114901)
,p_name=>'APP_NEW_VERSION_ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E\65B0\7248\672C\3002')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891679105116077)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'de'
,p_message_text=>unistr('Wenn aktuell laufende Instanzen zu diesem Modell existieren k\00F6nnen dadurch Fehler auftreten. M\00F6chten sie fortfahren?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28202305228139790)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_text=>'If there are running instances associated to the existing model, then these might cause errors. Are you sure to continue?'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933512396119469)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('Si hay instancias en ejecuci\00F3n asociadas al modelo existente, pueden provocar errores. \00BFSeguro que desea continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883384331115499)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'fr'
,p_message_text=>unistr('Si des instances en cours d''ex\00E9cution sont associ\00E9es au mod\00E8le existant, ceci peut provoquer des erreurs. Etes-vous s\00FBr de vouloir continuer ?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899952160116916)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'it'
,p_message_text=>unistr('Se esistono istanze in esecuzione associate al modello esistente, potrebbero verificarsi errori. Si \00E8 certi di voler continuare?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908216808117432)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30E2\30C7\30EB\306B\95A2\9023\4ED8\3051\3089\308C\305F\5B9F\884C\4E2D\306E\30A4\30F3\30B9\30BF\30F3\30B9\304C\3042\308B\5834\5408\3001\30A8\30E9\30FC\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\7D9A\884C\3057\307E\3059\304B?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916964082118157)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\C874 \BAA8\B378\C5D0 \C5F0\AD00\B41C \C2E4\D589 \C911\C778 \C778\C2A4\D134\C2A4\AC00 \C788\C744 \ACBD\C6B0 \C774\B85C \C778\D574 \C624\B958\AC00 \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4. \ACC4\C18D\D558\C2DC\ACA0\C2B5\B2C8\AE4C?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925284561118763)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se houver inst\00E2ncias em execu\00E7\00E3o associadas ao modelo existente, elas poder\00E3o causar erros. Voc\00EA tem certeza que quer continuar?')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866722407114212)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5B58\5728\4E0E\73B0\6709\6A21\578B\5173\8054\7684\6B63\5728\8FD0\884C\7684\5B9E\4F8B\FF0C\5219\8FD9\4E9B\5B9E\4F8B\53EF\80FD\4F1A\5BFC\81F4\9519\8BEF\3002\662F\5426\786E\5B9A\8981\7EE7\7EED\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875099305114901)
,p_name=>'APP_OVERWRITE_WARN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\6709\8207\73FE\6709\6A21\578B\76F8\95DC\806F\7684\57F7\884C\4E2D\4F8B\9805\FF0C\5247\9019\4E9B\4F8B\9805\53EF\80FD\6703\5C0E\81F4\932F\8AA4\3002\60A8\662F\5426\78BA\5B9A\8981\7E7C\7E8C\FF1F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890072670116076)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'de'
,p_message_text=>'Details'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8450436543003358)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_text=>'Details'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931974056119468)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'es'
,p_message_text=>'Detalles'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881708020115498)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898323952116915)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'it'
,p_message_text=>'Dettagli'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906634616117432)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915348142118157)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'ko'
,p_message_text=>unistr('\C138\BD80 \C815\BCF4')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923676203118762)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865100449114211)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\4FE1\606F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873494557114901)
,p_name=>'APP_P10_ACTION_DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\8CC7\8A0A')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889214429116076)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8418785854683856)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931138485119468)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880991179115498)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897585321116915)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905876172117432)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914561463118157)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922823666118762)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864310480114211)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872623905114900)
,p_name=>'APP_P10_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889124177116076)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8418577279682188)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931041950119468)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880863431115498)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897491935116915)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905784565117432)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914448185118156)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922725569118762)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864286143114211)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872532888114900)
,p_name=>'APP_P10_ROW_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888463985116076)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8414682025609410)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930337337119468)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880157934115498)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896727112116915)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905004931117432)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913746768118156)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922086528118762)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863577570114211)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871847312114900)
,p_name=>'APP_P2_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888553978116076)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8414828651610768)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930446709119468)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880204010115498)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896871444116915)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905114044117432)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913881243118156)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922168772118762)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863651724114211)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871907858114900)
,p_name=>'APP_P2_ROW_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889720133116076)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'de'
,p_message_text=>'Hat  Rekursion'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8422989500792727)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_text=>'Has recursion'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931643373119468)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'es'
,p_message_text=>unistr('Tiene recursi\00F3n')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881450402115498)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Comporte une r\00E9cursivit\00E9')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898021675116915)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'it'
,p_message_text=>'Ha una ricorsione'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906336171117432)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\5E30\3042\308A')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915050860118157)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'ko'
,p_message_text=>unistr('\BC18\BCF5 \C788\C74C')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923351716118762)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'pt-br'
,p_message_text=>'Tem recursion'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864839068114211)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5177\6709\9012\5F52')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873155778114900)
,p_name=>'APP_P7_HAS_RECURSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\6709\9012\5F52')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890168877116076)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'de'
,p_message_text=>'Nachricht empfangen'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8518889119121621)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_text=>'Receive Message'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932024461119468)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Recibir mensaje'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881829403115498)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Recevoir le message'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898483030116915)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'it'
,p_message_text=>'Ricevi messaggio'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906709740117432)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\306E\53D7\4FE1')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915455084118157)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'ko'
,p_message_text=>unistr('\BA54\C2DC\C9C0 \C218\C2E0')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923733819118763)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Receber mensagem'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865208250114212)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A5\6536\6D88\606F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873554271114901)
,p_name=>'APP_P8_RECEIVE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A5\6536\8A0A\606F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889491876116076)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8420928299709960)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931329700119468)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881180823115498)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897791239116915)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906074669117432)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914742692118157)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923093861118762)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864593890114211)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872800541114900)
,p_name=>'APP_P8_SBFL_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889390152116076)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8420723257708761)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931245963119468)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881034150115498)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897615922116915)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905970342117432)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914626264118157)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922988375118762)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864422931114211)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872709550114900)
,p_name=>'APP_P8_SBFL_ROW_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889688652116076)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8421639358719603)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931578126119468)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881359092115498)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897921452116915)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906258002117432)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914972214118157)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923225926118762)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864710519114211)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873008971114900)
,p_name=>'APP_P8_VAR_HEADER_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889563695116076)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'de'
,p_message_text=>'Aktionen'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8421400625718216)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15931453504119468)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3nes')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15881273171115498)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897873664116915)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'it'
,p_message_text=>'Azioni'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15906127579117432)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914821540118157)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C791\C5C5')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15923131555118762)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864654011114211)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872948029114900)
,p_name=>'APP_P8_VAR_ROW_BUTTON_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52A8')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887052739116075)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'de'
,p_message_text=>unistr('Prozessvariable hinzugef\00FCgt')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7049063211512400)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_text=>'Process variable added.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928961980119468)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'es'
,p_message_text=>'Variable de proceso agregada.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878716510115497)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Variable de processus ajout\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895346986116914)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'it'
,p_message_text=>'Variabile processo aggiunta.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903625327117431)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912386660118156)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218\AC00 \CD94\AC00\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920619731118762)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel de processo adicionada.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862143982114210)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6DFB\52A0\8FDB\7A0B\53D8\91CF\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870487606114900)
,p_name=>'APP_PROCESS_VARIABLE_ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E\8655\7406\8B8A\6578\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887505245116075)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'de'
,p_message_text=>unistr('Prozessvariable gel\00F6scht.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7371506201807240)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_text=>'Process variable deleted.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929478096119468)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'es'
,p_message_text=>'Variable de proceso suprimida.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15879233812115497)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Variable de processus supprim\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895806922116915)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'it'
,p_message_text=>'Variabile processo eliminata.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15904127028117431)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570\304C\524A\9664\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912805066118156)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218\AC00 \C0AD\C81C\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15921190777118762)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel de processo exclu\00EDda.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862628437114211)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\7A0B\53D8\91CF\5DF2\5220\9664\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870921892114900)
,p_name=>'APP_PROCESS_VARIABLE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\8655\7406\8B8A\6578\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887140100116075)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'de'
,p_message_text=>'Prozessvariable gespeichert'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7049459946516827)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_text=>'Process variable saved.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929019299119468)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'es'
,p_message_text=>'Variable de proceso guardada.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878875572115497)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Variable de processus enregistr\00E9e.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895439133116914)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'it'
,p_message_text=>'Variabile processo salvata.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903771372117431)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\5909\6570\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912475682118156)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D504\B85C\C138\C2A4 \BCC0\C218\AC00 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920704553118762)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel de processo salva.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862217749114210)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDB\7A0B\53D8\91CF\5DF2\4FDD\5B58\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870568847114900)
,p_name=>'APP_PROCESS_VARIABLE_SAVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5132\5B58\8655\7406\8B8A\6578\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893905604116077)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'de'
,p_message_text=>unistr('Neu-ausl\00F6sen')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73507335747013782)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_text=>'Reschedule'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935894622119470)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'es'
,p_message_text=>'Reprogramar'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885622264115499)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'fr'
,p_message_text=>'Reprogrammer'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902271933116917)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'it'
,p_message_text=>'Rischedula'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15910535007117433)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\30B9\30B1\30B8\30E5\30FC\30EB')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919225257118158)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2A4\CF00\C904 \C870\C815')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927563647118764)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'pt-br'
,p_message_text=>'Reprogramar'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869062046114213)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\8BA1\5212')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877357607114902)
,p_name=>'APP_RESCHEDULE_TIMER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6392\5B9A')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892281593116077)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'de'
,p_message_text=>unistr('Flow-Instanz zur\00FCcksetzen')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34715720510433885)
,p_name=>'APP_RESET_INSTANCE'
,p_message_text=>'Reset Flow Instance'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934131067119469)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'es'
,p_message_text=>'Restablecer instancia de flujo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883926841115499)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser l''instance de flux')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900581748116916)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'it'
,p_message_text=>'Reimposta istanza flusso'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908848377117433)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917593062118157)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C7AC\C124\C815')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925851361118763)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reiniciar a Inst\00E2ncia do Fluxo')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867320804114212)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\6D41\7A0B\5B9E\4F8B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875663909114901)
,p_name=>'APP_RESET_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\6D41\7A0B\5BE6\4F8B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15887202910116075)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'de'
,p_message_text=>'Neustart'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7072717610226144)
,p_name=>'APP_RESTART_STEP'
,p_message_text=>'Re-start'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15929124531119468)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'es'
,p_message_text=>'Reiniciar'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878939069115497)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'fr'
,p_message_text=>unistr('Red\00E9marrer')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895583601116915)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'it'
,p_message_text=>'Riavvia'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903836015117431)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\8D77\52D5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912567592118156)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\C7AC\C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920809937118762)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'pt-br'
,p_message_text=>'Reiniciar'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862313293114210)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\542F\52A8')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870611691114900)
,p_name=>'APP_RESTART_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\555F\52D5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888830731116076)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'de'
,p_message_text=>'Completed'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8415945888658027)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_text=>'Completed'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930751877119468)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'es'
,p_message_text=>'Completed'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880587802115498)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'fr'
,p_message_text=>'Completed'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897166484116915)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'it'
,p_message_text=>'Completed'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905484694117432)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914176255118156)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C644\B8CC\B428')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922456141118762)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'pt-br'
,p_message_text=>'Completed'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863966308114211)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872244957114900)
,p_name=>'APP_STATUS_COMPLETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888665635116076)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'de'
,p_message_text=>'Created'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8415542937649956)
,p_name=>'APP_STATUS_CREATED'
,p_message_text=>'Created'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930550925119468)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'es'
,p_message_text=>'Created'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880350575115498)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'fr'
,p_message_text=>'Created'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15896998349116915)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'it'
,p_message_text=>'Created'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905267142117432)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\65E5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15913954794118156)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0DD\C131\B428')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922270125118762)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Created'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863715899114211)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872079171114900)
,p_name=>'APP_STATUS_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15889021392116076)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'de'
,p_message_text=>'Error'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8416377349661914)
,p_name=>'APP_STATUS_ERROR'
,p_message_text=>'Error'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930931774119468)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880733479115498)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Error'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897378396116915)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'it'
,p_message_text=>'Error'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905655395117432)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914304078118156)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'ko'
,p_message_text=>unistr('\C624\B958')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922616295118762)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Error'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864134159114211)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872472425114900)
,p_name=>'APP_STATUS_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888774436116076)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'de'
,p_message_text=>'Running'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8415731193656398)
,p_name=>'APP_STATUS_RUNNING'
,p_message_text=>'Running'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930637635119468)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'es'
,p_message_text=>'Running'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880419432115498)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'fr'
,p_message_text=>'Running'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897048330116915)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'it'
,p_message_text=>'Running'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905325042117432)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\4E2D')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914063895118156)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C2E4\D589 \C911')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922316265118762)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'pt-br'
,p_message_text=>'Running'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15863849304114211)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FD0\884C')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872158540114900)
,p_name=>'APP_STATUS_RUNNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E2D')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15888999940116076)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'de'
,p_message_text=>'Terminated'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8416109886659986)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_text=>'Terminated'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15930878619119468)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'es'
,p_message_text=>'Terminated'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15880682337115498)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'fr'
,p_message_text=>'Terminated'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15897231707116915)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'it'
,p_message_text=>'Terminated'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15905577061117432)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\6E08')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15914274001118156)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'ko'
,p_message_text=>unistr('\C885\B8CC\B428')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15922539850118762)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'pt-br'
,p_message_text=>'Terminated'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15864000385114211)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7EC8\6B62')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872316484114900)
,p_name=>'APP_STATUS_TERMINATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D42\6B62')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15886981299116075)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'de'
,p_message_text=>'Subflow neu gestartet'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7020498147014290)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_text=>'Subflow restarted.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15928869409119468)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'es'
,p_message_text=>'Subflujo reiniciado.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15878605785115497)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-flux red\00E9marr\00E9.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15895287555116914)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'it'
,p_message_text=>'Flusso secondario riavviato.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15903569294117431)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30D5\30ED\30FC\304C\518D\8D77\52D5\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15912259672118156)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D558\C704 \D50C\B85C\C6B0\AC00 \C7AC\C2DC\C791\B418\C5C8\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15920567132118762)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'pt-br'
,p_message_text=>'Subfluxo reiniciado.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15862014796114210)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\6D41\7A0B\5DF2\91CD\65B0\542F\52A8\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15870306631114900)
,p_name=>'APP_SUBLFOW_RESTARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\6D41\7A0B\5DF2\91CD\65B0\555F\52D5\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893802010116077)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'de'
,p_message_text=>'In/Out Mapping'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61820488838157963)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_text=>'In/Out Mapping'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935779743119470)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de entrada/salida')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885544065115499)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'fr'
,p_message_text=>unistr('Mappage entr\00E9e/sortie')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902169784116916)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'it'
,p_message_text=>'Mapping in entrata/in uscita'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15910429673117433)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\51FA\529B\30DE\30C3\30D4\30F3\30B0')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919141663118158)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'ko'
,p_message_text=>unistr('\C785\B825/\CD9C\B825 \B9E4\D551')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927454089118764)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapeamento de Entrada/Sa\00EDda')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868908513114213)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F20\5165/\8F93\51FA\6620\5C04')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877284919114902)
,p_name=>'APP_TAB_IN_OUT_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 / \8F38\51FA\5C0D\61C9')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893786011116077)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'de'
,p_message_text=>unistr('Variablenausdr\00FCcke')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61820286299155230)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_text=>'Variable Expressions'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935694224119469)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'es'
,p_message_text=>'Expresiones de variables'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885497472115499)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'fr'
,p_message_text=>'Expressions de variables'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902054911116916)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'it'
,p_message_text=>'Variabile Espressioni'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15910371594117433)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\6570\5F0F')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919052117118158)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCC0\C218 \D45C\D604\C2DD')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927319376118764)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00F5es de Vari\00E1vel')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868863324114213)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D8\91CF\8868\8FBE\5F0F')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877144736114902)
,p_name=>'APP_TAB_VAR_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\6578\8868\793A\5F0F')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15892387783116077)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'de'
,p_message_text=>'Flow-Instanz terminieren'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34715995579436957)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_text=>'Terminate Flow Instance'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15934275814119469)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'es'
,p_message_text=>'Terminar instancia de flujo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884024992115499)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>'Terminer l''instance de flux'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15900602017116916)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'it'
,p_message_text=>'Arresta istanza flusso'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908987237117433)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30A4\30F3\30B9\30BF\30F3\30B9\306E\7D42\4E86')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15917661249118157)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 \C885\B8CC')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925972661118763)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Terminar a inst\00E2ncia de fluxo')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15867429793114212)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC8\6B62\6D41\7A0B\5B9E\4F8B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15875725944114901)
,p_name=>'APP_TERMINATE_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D42\6B62\6D41\7A0B\5BE6\4F8B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890837700116076)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'de'
,p_message_text=>'%0 - Version %1'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14002829627275379)
,p_name=>'APP_TITLE_MODEL'
,p_message_text=>'%0 - Version %1'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932781951119469)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 - Versi\00F3n %1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882545484115498)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'fr'
,p_message_text=>'%0 - Version %1'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899110294116916)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'it'
,p_message_text=>'%0 - Versione %1'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907499876117432)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 - \30D0\30FC\30B8\30E7\30F3%1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916125654118157)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'ko'
,p_message_text=>unistr('%0 - \BC84\C804 %1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924437292118763)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 - Vers\00E3o %1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865986388114212)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 - \7248\672C %1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874263998114901)
,p_name=>'APP_TITLE_MODEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - \7248\672C %1')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890703637116076)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'de'
,p_message_text=>'Neues Modell'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14002221742257151)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_text=>'New Model'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932607742119469)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'es'
,p_message_text=>'Nuevo modelo'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882442673115498)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouveau Mod\00E8le')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899066346116916)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'it'
,p_message_text=>'Nuovo modello'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907331278117432)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30E2\30C7\30EB')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916046066118157)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'ko'
,p_message_text=>unistr('\C0C8 \BAA8\B378')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924313948118763)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'pt-br'
,p_message_text=>'Novo modelo'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865851199114212)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\6A21\578B')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874165978114901)
,p_name=>'APP_TITLE_NEW_MODEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\6A21\578B')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890992300116076)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'de'
,p_message_text=>'Schritt neustarten'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14016328404425844)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_text=>'Re-start Step'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932811342119469)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'es'
,p_message_text=>'Volver a iniciar paso'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882642187115498)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'fr'
,p_message_text=>unistr('Red\00E9marrer l''\00E9tape')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899218903116916)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'it'
,p_message_text=>'Riavvia passo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907540980117432)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D7\306E\518D\8D77\52D5')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916250810118157)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'ko'
,p_message_text=>unistr('\B2E8\ACC4 \C7AC\C2DC\C791')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924564578118763)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'pt-br'
,p_message_text=>'Reiniciar Etapa'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866082413114212)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\542F\52A8\6B65\9AA4')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874302654114901)
,p_name=>'APP_TITLE_RESTART_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\555F\52D5\6B65\9A5F')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885714509116075)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'de'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Die Anwendungsversion, das Datenmodell und der Code stimmen nicht \00FCberein:'),
'<ul>',
'<li>Anwendungsversion: %0</li>',
'<li>Datenmodellversion: %1</li>',
'<li>Codeversion: %2</li>',
'</ul>',
'Wenden Sie sich an Ihren Administrator, um Probleme zu vermeiden.'))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3524783067400924)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'We have identified that the application version, data model and code do not match:',
'<ul>',
'<li>application version: %0</li>',
'<li>data model version: %1</li>',
'<li>code version : %2</li>',
'</ul>',
'Please contact your administrator to avoid any problems.'))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927645148119467)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Hemos identificado que la versi\00F3n de la aplicaci\00F3n, el modelo de datos y el c\00F3digo no coinciden:'),
'<ul>',
unistr('<li>versi\00F3n de la aplicaci\00F3n: %0</li>'),
unistr('<li>versi\00F3n de modelo de datos: %1</li>'),
unistr('<li>versi\00F3n de c\00F3digo: %2</li>'),
'</ul>',
unistr('P\00F3ngase en contacto con el administrador para evitar problemas.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15877441901115497)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nous avons identifi\00E9 que la version de l''application, le mod\00E8le de donn\00E9es et le code ne correspondent pas :'),
'<ul>',
'<li>version de l''application : %0</li>',
unistr('<li>version du mod\00E8le de donn\00E9es : %1</li>'),
'<li>version du code : %2</li>',
'</ul>',
unistr('Contactez votre administrateur pour \00E9viter tout probl\00E8me.')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15894008852116914)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'it'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C8 stato rilevato che la versione dell''applicazione, il modello dati e il codice non corrispondono:'),
'<ul>',
'<li>versione dell''applicazione: %0</li>',
'<li>versione modello dati: %1</li>',
'<li>versione codice: %2</li>',
'</ul>',
'Contattare l''amministratore per evitare problemi.'))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15902316014117431)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3\3001\30C7\30FC\30BF\30FB\30E2\30C7\30EB\304A\3088\3073\30B3\30FC\30C9\304C\4E00\81F4\3057\306A\3044\3053\3068\304C\78BA\8A8D\3055\308C\307E\3057\305F\3002'),
'<ul>',
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30B8\30E7\30F3: %0</li>'),
unistr('<li>\30C7\30FC\30BF\30FB\30E2\30C7\30EB\30FB\30D0\30FC\30B8\30E7\30F3: %1</li>'),
unistr('<li>\30B3\30FC\30C9\30FB\30D0\30FC\30B8\30E7\30F3: %2</li>'),
'</ul>',
unistr('\554F\984C\3092\56DE\907F\3059\308B\306B\306F\3001\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15911050623118155)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'ko'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\C560\D50C\B9AC\CF00\C774\C158 \BC84\C804, \B370\C774\D130 \BAA8\B378 \BC0F \CF54\B4DC\AC00 \C77C\CE58\D558\C9C0 \C54A\B294 \AC83\C73C\B85C \D655\C778\B418\C5C8\C2B5\B2C8\B2E4.'),
'<ul>',
unistr('<li>\C560\D50C\B9AC\CF00\C774\C158 \BC84\C804: %0</li>'),
unistr('<li>\B370\C774\D130 \BAA8\B378 \BC84\C804: %1</li>'),
unistr('<li>\CF54\B4DC \BC84\C804: %2</li>'),
'</ul>',
unistr('\BB38\C81C\B97C \BC29\C9C0\D558\B824\BA74 \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.')))
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15919395261118761)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identificamos que a vers\00E3o, o modelo e o c\00F3digo do aplicativo n\00E3o correspondem:'),
'<ul>',
unistr('<li>vers\00E3o do aplicativo: %0</li>'),
unistr('<li>vers\00E3o do modelo de dados: %1</li>'),
unistr('<li>vers\00E3o do c\00F3digo: %2</li>'),
'</ul>',
'Entre em contato com o administrador para evitar problemas.'))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15860815768114210)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6211\4EEC\5DF2\786E\5B9A\5E94\7528\7A0B\5E8F\7248\672C\3001\6570\636E\6A21\578B\548C\4EE3\7801\4E0D\5339\914D\FF1A '),
'<ul>',
unistr(' <li> \5E94\7528\7A0B\5E8F\7248\672C\FF1A%0</li>'),
unistr(' <li> \6570\636E\6A21\578B\7248\672C\FF1A%1</li>'),
unistr(' <li> \4EE3\7801\7248\672C\FF1A%2</li>'),
' </ul>',
unistr(' \8BF7\4E0E\7BA1\7406\5458\8054\7CFB\4EE5\907F\514D\51FA\73B0\4EFB\4F55\95EE\9898\3002')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15869195883114899)
,p_name=>'APP_VERSION_MISMATCH'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6211\5011\767C\73FE\61C9\7528\7A0B\5F0F\7248\672C\3001\8CC7\6599\6A21\578B\4EE5\53CA\7A0B\5F0F\78BC\4E0D\7B26\FF1A '),
'<ul>',
unistr(' <li> \61C9\7528\7A0B\5F0F\7248\672C\FF1A%0</li>'),
unistr(' <li> \8CC7\6599\6A21\578B\7248\672C\FF1A%1</li>'),
unistr(' <li> \7A0B\5F0F\78BC\7248\672C\FF1A%2</li>'),
' </ul>',
unistr(' \8ACB\806F\7D61\7BA1\7406\54E1\4EE5\907F\514D\4EFB\4F55\554F\984C\3002')))
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890608295116076)
,p_name=>'APP_VIEW'
,p_message_language=>'de'
,p_message_text=>'Ansicht'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13203402380103446)
,p_name=>'APP_VIEW'
,p_message_text=>'View'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932507321119469)
,p_name=>'APP_VIEW'
,p_message_language=>'es'
,p_message_text=>'Ver'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882373379115498)
,p_name=>'APP_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Voir'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898903616116915)
,p_name=>'APP_VIEW'
,p_message_language=>'it'
,p_message_text=>'Visualizza'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907222944117432)
,p_name=>'APP_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915942765118157)
,p_name=>'APP_VIEW'
,p_message_language=>'ko'
,p_message_text=>unistr('\BCF4\AE30')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924204935118763)
,p_name=>'APP_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865741093114212)
,p_name=>'APP_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874079985114901)
,p_name=>'APP_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890414094116076)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'de'
,p_message_text=>'Flow-Viewer'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11239873943364108)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_text=>'Flow Viewer'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932396026119469)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'es'
,p_message_text=>'Visor de flujo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882165454115498)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Visionneuse de flux'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898794961116915)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'it'
,p_message_text=>'Visualizzatore flusso'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907054998117432)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30FB\30D3\30E5\30FC\30A2\30FC')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915758177118157)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \BDF0\C5B4')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924062041118763)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizador de fluxo'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865571538114212)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\7A0B\67E5\770B\5668')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873858044114901)
,p_name=>'APP_VIEWER_TITLE_NO_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B\6AA2\8996\5668')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15890528786116076)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'de'
,p_message_text=>'Flow-Viewer (%0)'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11240035334366277)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_text=>'Flow Viewer (%0)'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15932499926119469)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'es'
,p_message_text=>'Visor de flujo (%0)'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15882202454115498)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'fr'
,p_message_text=>'Visionneuse de flux (%0)'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15898846190116915)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'it'
,p_message_text=>'Visualizzatore flusso (%0)'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907182593117432)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30D3\30E5\30FC\30A2(%0)')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15915871467118157)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'ko'
,p_message_text=>unistr('\D50C\B85C\C6B0 \BDF0\C5B4(%0)')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924113619118763)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizador de fluxo (%0)'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15865630694114212)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\7A0B\67E5\770B\5668 (%0)')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15873972551114901)
,p_name=>'APP_VIEWER_TITLE_PROCESS_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B\6AA2\8996\5668 (%0)')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893412741116077)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'de'
,p_message_text=>'Zyklus (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36510629773154405)
,p_name=>'BPMN:TIMECYCLE'
,p_message_text=>'Cycle (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935351458119469)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'es'
,p_message_text=>'Ciclo (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885190231115499)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'fr'
,p_message_text=>'Cycle (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901744412116916)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'it'
,p_message_text=>'Ciclo (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15910039453117433)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30AF\30EB(ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918795421118158)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C8FC\AE30(ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15927050083118763)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ciclo (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868565330114213)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468\671F (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876874344114901)
,p_name=>'BPMN:TIMECYCLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031\671F (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893203660116077)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'de'
,p_message_text=>'Datum (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36510235534150779)
,p_name=>'BPMN:TIMEDATE'
,p_message_text=>'Date (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935133620119469)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'es'
,p_message_text=>'Fecha (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15884945772115499)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'fr'
,p_message_text=>'Date (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901595387116916)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'it'
,p_message_text=>'Data (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909839312117433)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8(ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918510716118158)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'ko'
,p_message_text=>unistr('\C77C\C790(ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926817692118763)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868394431114212)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876670311114901)
,p_name=>'BPMN:TIMEDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15893380120116077)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'de'
,p_message_text=>'Dauer (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36510489900152295)
,p_name=>'BPMN:TIMEDURATION'
,p_message_text=>'Duration (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935223385119469)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15885036360115499)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15901620576116916)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'it'
,p_message_text=>'Durata (ISO 8601)'
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15909924034117433)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9593(ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15918659017118158)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'ko'
,p_message_text=>unistr('\AE30\AC04(ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15926938912118763)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15868471455114213)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6301\7EED\65F6\95F4 (ISO 8601)')
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15876758030114901)
,p_name=>'BPMN:TIMEDURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6301\7E8C\6642\9593 (ISO 8601)')
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891566970116077)
,p_name=>'DGRM_UK'
,p_message_language=>'de'
,p_message_text=>'Ein Flow mit dem selben Namen und Status existiert bereits.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26017638645989579)
,p_name=>'DGRM_UK'
,p_message_text=>'A flow already exists with the same name and status.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933442988119469)
,p_name=>'DGRM_UK'
,p_message_language=>'es'
,p_message_text=>'Ya existe un flujo con el mismo nombre y estado.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883290569115499)
,p_name=>'DGRM_UK'
,p_message_language=>'fr'
,p_message_text=>unistr('Un flux existe d\00E9j\00E0 avec le m\00EAme nom et le m\00EAme statut.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899845243116916)
,p_name=>'DGRM_UK'
,p_message_language=>'it'
,p_message_text=>unistr('Esiste gi\00E0 un flusso con lo stesso nome e lo stesso stato.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908128818117432)
,p_name=>'DGRM_UK'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\3058\540D\524D\304A\3088\3073\30B9\30C6\30FC\30BF\30B9\306E\30D5\30ED\30FC\304C\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916897497118157)
,p_name=>'DGRM_UK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774\B984 \BC0F \C0C1\D0DC\AC00 \B3D9\C77C\D55C \D50C\B85C\C6B0\AC00 \C774\BBF8 \C788\C2B5\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925149836118763)
,p_name=>'DGRM_UK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('J\00E1 existe um fluxo com o mesmo nome e status.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866687792114212)
,p_name=>'DGRM_UK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B58\5728\5177\6709\76F8\540C\540D\79F0\548C\72B6\6001\7684\6D41\7A0B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874942552114901)
,p_name=>'DGRM_UK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6709\76F8\540C\540D\7A31\8207\72C0\614B\7684\6D41\7A0B\5B58\5728\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891466005116077)
,p_name=>'DGRM_UK2'
,p_message_language=>'de'
,p_message_text=>unistr('Ein Flow mit diesen Namen und einem Released-Status existiert bereits. \00C4ndern sie den aktuellen Status zu Veraltet oder Archiviert und starten sie den Import erneut.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24219258023169431)
,p_name=>'DGRM_UK2'
,p_message_text=>'A flow with this name and having a status of ''released'' already exists. Change the existing flow status to deprecated or archived and re-import.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933301777119469)
,p_name=>'DGRM_UK2'
,p_message_language=>'es'
,p_message_text=>'Ya existe un flujo con este nombre y con el estado ''liberado''. Cambie el estado del flujo existente a en desuso o archivado y vuelva a importarlo.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883197809115499)
,p_name=>'DGRM_UK2'
,p_message_language=>'fr'
,p_message_text=>unistr('Un flux portant ce nom et ayant le statut "released" existe d\00E9j\00E0.  Changez le statut du flux existant en deprecated ou archived et r\00E9importez-le.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899788405116916)
,p_name=>'DGRM_UK2'
,p_message_language=>'it'
,p_message_text=>unistr('Esiste gi\00E0 un flusso con questo nome e con stato ''rilasciato''. Modificare lo stato del flusso esistente in Non pi\00F9 valido o Archiviato e reimportare.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15908070887117432)
,p_name=>'DGRM_UK2'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\540D\524D\3067\30B9\30C6\30FC\30BF\30B9\304C ''released''\300C\30EA\30EA\30FC\30B9\6E08\300D\306E\30D5\30ED\30FC\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\65E2\5B58\306E\30D5\30ED\30FC\30FB\30B9\30C6\30FC\30BF\30B9\3092\975E\63A8\5968\307E\305F\306F\30A2\30FC\30AB\30A4\30D6\6E08\306B\5909\66F4\3057\3001\518D\30A4\30F3\30DD\30FC\30C8\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916764791118157)
,p_name=>'DGRM_UK2'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \C774\B984\C774 \C788\ACE0 \C0C1\D0DC\AC00 ''\B9B4\B9AC\C988\B428''\C778 \D50C\B85C\C6B0\AC00 \C774\BBF8 \C788\C2B5\B2C8\B2E4. \AE30\C874 \D50C\B85C\C6B0 \C0C1\D0DC\B97C \B354 \C774\C0C1 \C0AC\C6A9\B418\C9C0 \C54A\AC70\B098 \C544\CE74\C774\BE0C\B41C \D6C4 \B2E4\C2DC \C784\D3EC\D2B8\B85C \BCC0\ACBD\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15925068195118763)
,p_name=>'DGRM_UK2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('J\00E1 existe um fluxo com este nome e com um status de ''lan\00E7ado''. Alterar o status do fluxo existente para descontinuado ou arquivado e reimportado.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866516370114212)
,p_name=>'DGRM_UK2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5177\6709\6B64\540D\79F0\4E14\72B6\6001\4E3A\201C\5DF2\53D1\653E\201D\7684\6D41\7A0B\5DF2\5B58\5728\3002\5C06\73B0\6709\6D41\7A0B\72B6\6001\66F4\6539\4E3A\5DF2\5F03\7528\6216\5DF2\5B58\6863\5E76\91CD\65B0\5BFC\5165\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874860635114901)
,p_name=>'DGRM_UK2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\540D\7A31\4E14\72C0\614B\70BA\300C\5DF2\6838\767C\300D\7684\6D41\7A0B\5DF2\5B58\5728\3002\5C07\73FE\6709\6D41\7A0B\72C0\614B\8B8A\66F4\70BA\5DF2\68C4\7528\6216\5DF2\5C01\5B58\4E26\91CD\65B0\532F\5165\3002')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15891337281116077)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCr diesen Flow existieren bestehende Prozess-Instanzen. Ben\00FCtzen sie die Kaskadierungs-Option um aktuelle Instanzen to entfernen.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24202863069473923)
,p_name=>'PRCS_DGRM_FK'
,p_message_text=>'Process instances using this flow exist. Use cascade option to remove flow and process instances.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15933290130119469)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'es'
,p_message_text=>unistr('Existen instancias de proceso que utilizan este flujo. Utilice la opci\00F3n en cascada para eliminar instancias de flujo y proceso.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15883081573115499)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'fr'
,p_message_text=>'Des instances de processus utilisant ce flux existent. Utilisez l''option cascade pour supprimer le flux et les instances de processus.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15899641816116916)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'it'
,p_message_text=>'Esistono istanze di processo che utilizzano questo flusso. Utilizzare l''opzione a cascata per rimuovere le istanze di flusso ed elaborazione.'
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907949907117432)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30ED\30FC\3092\4F7F\7528\3059\308B\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9\304C\5B58\5728\3057\307E\3059\3002\30D5\30ED\30FC\304A\3088\3073\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9\3092\524A\9664\3059\308B\306B\306F\30AB\30B9\30B1\30FC\30C9\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15916603918118157)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'ko'
,p_message_text=>unistr('\C774 \D50C\B85C\C6B0\B97C \C0AC\C6A9\D558\B294 \D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4\AC00 \C874\C7AC\D569\B2C8\B2E4. \ACC4\B2E8\C2DD \C635\C158\C744 \C0AC\C6A9\D558\C5EC \D50C\B85C\C6B0 \BC0F \D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4\B97C \C81C\AC70\D569\B2C8\B2E4.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15924970157118763)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Existem inst\00E2ncias de processo que utilizam este fluxo. Use a op\00E7\00E3o em cascata para remover inst\00E2ncias de fluxo e de processo.')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15866452638114212)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\4F7F\7528\6B64\6D41\7684\6D41\7A0B\5B9E\4F8B\3002\4F7F\7528\7EA7\8054\9009\9879\5220\9664\6D41\548C\6D41\7A0B\5B9E\4F8B\3002')
,p_is_js_message=>true
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15874748089114901)
,p_name=>'PRCS_DGRM_FK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6B64\6D41\7A0B\7684\8655\7406\5BE6\4F8B\5DF2\5B58\5728\3002\4F7F\7528\91CD\758A\986F\793A\9078\9805\4F86\79FB\9664\6D41\7A0B\8207\8655\7406\5BE6\4F8B\3002')
,p_is_js_message=>true
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(12495496302977879965)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/automations/flows_for_apex_daily_instance_archive
begin
wwv_flow_imp_shared.create_automation(
 p_id=>wwv_flow_imp.id(2130974654065929)
,p_name=>'Flows for APEX - Daily Instance Archive'
,p_static_id=>'flows-for-apex-daily-instance-archive'
,p_trigger_type=>'POLLING'
,p_polling_interval=>'FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=0'
,p_polling_status=>'DISABLED'
,p_result_type=>'ALWAYS'
,p_use_local_sync_table=>false
,p_include_rowid_column=>false
,p_commit_each_row=>false
,p_error_handling_type=>'IGNORE'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Flows for APEX Daily Instance Archive.',
'For each process instance that has reached ''completed'' or ''terminated'' status, this daily job creates a JSON summary of the instance execution, diagrams used, sub flows run, variables set, process events.',
'Archives are stored based on the F4A Configuration Parameter  ''logging_archive_location'', and can be set to a database table or to OCI Object Storage.'))
);
wwv_flow_imp_shared.create_automation_action(
 p_id=>wwv_flow_imp.id(2131266656065931)
,p_automation_id=>wwv_flow_imp.id(2130974654065929)
,p_name=>'Run Daily Instance Archive'
,p_execution_sequence=>10
,p_action_type=>'NATIVE_PLSQL'
,p_action_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_admin_api.archive_completed_instances;',
'end;'))
,p_action_clob_language=>'PLSQL'
,p_location=>'LOCAL'
,p_error_message=>'Daily Instance Summary Archive process error'
,p_stop_execution_on_error=>true
);
end;
/
prompt --application/shared_components/automations/flows_for_apex_purge_statistics
begin
wwv_flow_imp_shared.create_automation(
 p_id=>wwv_flow_imp.id(2132078093091545)
,p_name=>'Flows for APEX - Purge Statistics'
,p_static_id=>'flows-for-apex-purge-statistics'
,p_trigger_type=>'POLLING'
,p_polling_interval=>'FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=0'
,p_polling_status=>'DISABLED'
,p_result_type=>'ALWAYS'
,p_use_local_sync_table=>false
,p_include_rowid_column=>false
,p_commit_each_row=>false
,p_error_handling_type=>'IGNORE'
);
wwv_flow_imp_shared.create_automation_action(
 p_id=>wwv_flow_imp.id(2132703073101244)
,p_automation_id=>wwv_flow_imp.id(2132078093091545)
,p_name=>'Purge Old Statistics'
,p_execution_sequence=>10
,p_action_type=>'NATIVE_PLSQL'
,p_action_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_admin_api.purge_statistics;',
'end;'))
,p_action_clob_language=>'PLSQL'
,p_location=>'LOCAL'
,p_error_message=>'Error purging Flows for APEX Statistics summaries'
,p_stop_execution_on_error=>true
);
end;
/
prompt --application/shared_components/automations/flows_for_apex_gather_daily_statistics
begin
wwv_flow_imp_shared.create_automation(
 p_id=>wwv_flow_imp.id(2133342671110884)
,p_name=>'Flows for APEX - Gather Daily Statistics'
,p_static_id=>'flows-for-apex-gather-daily-statistics'
,p_trigger_type=>'POLLING'
,p_polling_interval=>'FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=12'
,p_polling_status=>'DISABLED'
,p_result_type=>'ALWAYS'
,p_use_local_sync_table=>false
,p_include_rowid_column=>false
,p_commit_each_row=>false
,p_error_handling_type=>'IGNORE'
);
wwv_flow_imp_shared.create_automation_action(
 p_id=>wwv_flow_imp.id(2133626467110885)
,p_automation_id=>wwv_flow_imp.id(2133342671110884)
,p_name=>'Gather Daily Stats'
,p_execution_sequence=>10
,p_action_type=>'NATIVE_PLSQL'
,p_action_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_admin_api.run_daily_stats;',
'end;'))
,p_action_clob_language=>'PLSQL'
,p_location=>'LOCAL'
,p_error_message=>'Error gathering daily Flows for APEX Stats'
,p_stop_execution_on_error=>true
);
end;
/
prompt --application/shared_components/automations/flows_for_apex_purge_logs
begin
wwv_flow_imp_shared.create_automation(
 p_id=>wwv_flow_imp.id(2134304189122562)
,p_name=>'Flows for APEX - Purge Logs'
,p_static_id=>'flows-for-apex-purge-logs'
,p_trigger_type=>'POLLING'
,p_polling_interval=>'FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=5'
,p_polling_status=>'DISABLED'
,p_result_type=>'ALWAYS'
,p_use_local_sync_table=>false
,p_include_rowid_column=>false
,p_commit_each_row=>false
,p_error_handling_type=>'IGNORE'
,p_comment=>'Flows for APEX Purge Instance Log Tables.   This purges records in the flow_instance_events, flow_step_events, and flow_variable_events tables to keep log table size under control.  If instance summary archiving is enabled, a json document containing'
||' a full summary / audit trail for each process instance should have been created and stored in archive storage (database table or OCI Object Storage) before the relevant records are purged.   See documentation.'
);
wwv_flow_imp_shared.create_automation_action(
 p_id=>wwv_flow_imp.id(2134675479122562)
,p_automation_id=>wwv_flow_imp.id(2134304189122562)
,p_name=>'Purge Log Tables'
,p_execution_sequence=>10
,p_action_type=>'NATIVE_PLSQL'
,p_action_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_admin_api.purge_instance_logs;',
'end;'))
,p_action_clob_language=>'PLSQL'
,p_location=>'LOCAL'
,p_error_message=>'Flows for APEX - Error purging log tables.'
,p_stop_execution_on_error=>true
);
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(36651913839128043)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/shared_components/security/authentications/application_express_authentication
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(12495636783173880401)
,p_name=>'Application Express Authentication'
,p_scheme_type=>'NATIVE_APEX_ACCOUNTS'
,p_invalid_session_type=>'LOGIN'
,p_cookie_name=>'&WORKSPACE_COOKIE.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_manage_ins_vars_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(84719765847460987)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.MANAGE_INS_VARS.PROCESS'
,p_display_name=>'Flows for APEX - Manage Flow Instance Variables'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.MANAGE_INS_VARS.PROCESS'),'')
,p_api_version=>2
,p_execution_function=>'flow_plugin_manage_instance_variables.execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process used to Manage <i>Flows for APEX</i> Flow Instance Variable(s). The plug-in allows you to get or set variable(s).'
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84720010618460990)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Flow Instance info'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'item'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When a <i>Flows for APEX</i> task is completed, the application needs to send a <i> flow_step_complete </i> call to move the Flow Instance onto its next task / next step.  The call needs to provide the current context to the engine, so that the fl'
||'ow engine knows which task you were completing.  The context is made up of the process_id and subflow_id of the current task.</p>',
'',
'<p>Typically a <i>Flows for APEX </i> userTask (a page in APEX) will download its context when the page loads.  This download is defined in the Flow Modeller, using the Flow Modeller Properties Panel -- once you have created your userTask on your dia'
||'gram, click on the APEX tab in the Properties Panel, define the Page Items to set, and set them to the Process ID and Subflow ID.  </p>',
'',
'<blockquote>For example, one way to do this is to define Application Level items in your application named PROCESS_ID and SUBFLOW_ID.  Then in the Flow Modeller Properties Panel for your userTask, specify that the page call sets variables PROCESS_ID,'
||' SUBFLOW_ID with values of &F4A$process_id.,&F4A$subflow_id.</blockquote>',
'',
'<p>Alternatively, you could retrieve the Flow context (process_id and subflow_id) by retrieving these in a SQL Query.</p>',
'',
'<p>Specify which method you will use to supply the Flow Instance context (process_id and subflow_id)?</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84720344241460990)
,p_plugin_attribute_id=>wwv_flow_imp.id(84720010618460990)
,p_display_sequence=>10
,p_display_value=>'In Page Items'
,p_return_value=>'item'
,p_help_text=>'Use this when the Flow Instance context (process_id and subflow_id) are stored in APEX Page Items.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84720839343460990)
,p_plugin_attribute_id=>wwv_flow_imp.id(84720010618460990)
,p_display_sequence=>20
,p_display_value=>'from SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this when the Flow Instance context (process_id and subflow_id) are to be returned by a SQL Query.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84721419455460990)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Process ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84720010618460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance process_id.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named PROCESS_ID.</li>',
'<li>A Global Page Item, for example P0_PROCESS_ID.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84721742466460990)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84720010618460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>SQL Query which returns one row with one or or two columns:</p>',
'<ul>',
'<li>First column needs to contain the Instance Id (prcs_id)</li>',
'<li>Second column may contain the Subflow Id (sbfl_id)</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84820717881541566)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>'Action'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'set'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This attributes allows you to define if you want to set or to get the process variables.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84820967609542287)
,p_plugin_attribute_id=>wwv_flow_imp.id(84820717881541566)
,p_display_sequence=>10
,p_display_value=>'Set'
,p_return_value=>'set'
,p_help_text=>'Use this when you want to set a process variable(s)'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84821401852542882)
,p_plugin_attribute_id=>wwv_flow_imp.id(84820717881541566)
,p_display_sequence=>20
,p_display_value=>'Get'
,p_return_value=>'get'
,p_help_text=>'Use this when you want to get a process variable(s)'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84722146745460990)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Manage Variable(s) using'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'item'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This attribute allows you to define the way to manage the variables.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84722577900460991)
,p_plugin_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_display_sequence=>10
,p_display_value=>'APEX item(s)'
,p_return_value=>'item'
,p_help_text=>'Use this when you want to manage a process variable(s) using APEX item(s)'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84723065598460991)
,p_plugin_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_display_sequence=>20
,p_display_value=>'JSON'
,p_return_value=>'json'
,p_help_text=>'Use this when you want to manage a process variable(s) using JSON.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(84723558763460991)
,p_plugin_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_display_sequence=>30
,p_display_value=>'SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this when you want to manage a process variable(s) using a SQL Query.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84724051277460991)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Process Variable(s) Name(s)'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Comma-separated list of process variable(s) name(s)</p>',
'',
'<p>Note that process variable name is case sensitive and the order will have an impact on which APEX item will manage that value.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84724525114460991)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'APEX item(s)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Items(s) that will be used to manage the process variable value.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item.</li>',
'<li>A Global Page Item.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84724858440460993)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'JSON'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'json'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>JSON when action is set</p>',
'<pre>',
'[',
'	{',
'		"name": "Example_vc2_var",',
'		"type": "varchar2",',
'		"value": "text"',
'	},',
'	{',
'		"name": "Example_num_var",',
'		"type": "number",',
'		"value": 200',
'	},',
'	{',
'		"name": "Example_date_var",',
'		"type": "date",',
'		"value": "2021-04-07T22:07:29.961Z"',
'	},',
'	{',
'		"name": "Example_timestamp_var",',
'		"type": "timestamp",',
'		"value": "2021-04-07T22:07:29.961Z"',
'	},',
'	{',
'		"name": "Example_clob_var",',
'		"type": "clob",',
'		"value": "long text"',
'	},',
'	{',
'		"name": "Example_json_var",',
'		"type": "json",',
'		"value": "{\"myAttribue\":\"myAttributeValue\"}"',
'	}',
']',
'</pre>',
'',
'<p>JSON when action is get</p>',
'<pre>',
'[',
'	{',
'		"name": "Example_vc2_var",',
'		"type": "varchar2",',
'		"item": "ITEM_NAME"',
'	},',
'	{',
'		"name": "Example_num_var",',
'		"type": "number",',
'		"item": "ITEM_NAME"',
'	},',
'	{',
'		"name": "Example_date_var",',
'		"type": "date",',
'		"item": "ITEM_NAME"',
'	},',
'	{',
'		"name": "Example_clob_var",',
'		"type": "clob",',
'		"item": "ITEM_NAME"',
'	},',
'        {',
'		"name": "Example_json_var",',
'		"type": "json",',
'		"item": "ITEM_NAME"',
'	}',
']',
'</pre>'))
,p_help_text=>'Enter a JSON array that contains one or more process variables, their types, and values (when action is set) or item (when action is get).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(84725241650460993)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84722146745460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>SQL Query when action is Set</p>',
'<pre>',
'select json_array(',
'    json_object(',
'          key ''name'' value ''example_vc2_var''',
'        , key ''type'' value ''varchar2''',
'        , key ''value'' value ''test_vc2''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_num_var''',
'        , key ''type'' value ''number''',
'        , key ''value'' value 200',
'        ),',
'    json_object(',
'          key ''name'' value ''example_date_var''',
'        , key ''type'' value ''date''',
'        , key ''value'' value ''2021-04-07T22:07:29.961Z''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_timestamp_var''',
'        , key ''type'' value ''timestamp''',
'        , key ''value'' value ''2021-04-07T22:07:29.961Z''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_clob_var''',
'        , key ''type'' value ''clob''',
'        , key ''value'' value to_clob(''this is a clob'')',
'        ),',
'    json_object(',
'          key ''name'' value ''example_json_var''',
'        , key ''type'' value ''json''',
'        , key ''value'' value ''{"myAttribue":"myAttributeValue"}''',
'    )',
'returning clob) as json',
'from dual;',
'</pre>',
'<p>SQL Query when action is Get</p>',
'<pre>',
'select json_array(',
'    json_object(',
'          key ''name'' value ''example_vc2_var''',
'        , key ''type'' value ''varchar2''',
'        , key ''item'' value ''ITEM_NAME''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_num_var''',
'        , key ''type'' value ''number''',
'       , key ''item'' value ''ITEM_NAME''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_date_var''',
'        , key ''type'' value ''date''',
'        , key ''item'' value ''ITEM_NAME''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_timestamp_var''',
'        , key ''type'' value ''timestamp''',
'        , key ''item'' value ''ITEM_NAME''',
'        ),',
'    json_object(',
'          key ''name'' value ''examnple_clob_var''',
'        , key ''type'' value ''clob''',
'        , key ''item'' value ''ITEM_NAME''',
'        ),',
'    json_object(',
'          key ''name'' value ''examnple_json_var''',
'        , key ''type'' value ''json''',
'        , key ''item'' value ''ITEM_NAME''',
'        )',
'returning clob) as json',
'from dual;',
'</pre>'))
,p_help_text=>'SQL query that returns the array containing the instance variables.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(100919570706200019)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Return Flow Instance ID into [deprecated]'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'This attribute is deprecated starting from Flows for APEX 22.2 and will probably be removed in a future release.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(62243875274673859)
,p_plugin_id=>wwv_flow_imp.id(84719765847460987)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>25
,p_prompt=>'Subflow ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(84720010618460990)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance subflow_id.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named SUBFLOW_ID.</li>',
'<li>A Global Page Item, for example P0_SUBFLOW_ID.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_manage_instance_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(92418934266670712)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'
,p_display_name=>'Flows for APEX - Manage Flow Instance'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'),'')
,p_api_version=>2
,p_execution_function=>'flow_plugin_manage_instance.execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92419102522670723)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Global Flow'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>150
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Set Flow using Name only:',
'<pre>Holiday</pre>',
'Set Flow using Name and Version:',
'<pre>Holiday,0</pre>',
'Set Flow using Id:',
'<pre>1</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Depends on the action selected, you can provide:',
'<ul>',
'<li> a Flow Diagram by Name (and optionally Flow Version) or Id.</li>',
'<li> a Flow Instance Id.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92439391298687226)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Action'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'create_and_start'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Use this attribute to define the action you want to process.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92439941567689015)
,p_plugin_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_display_sequence=>10
,p_display_value=>'Create and Start'
,p_return_value=>'create_and_start'
,p_is_quick_pick=>true
,p_help_text=>'Use this option to create and start a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92440326453690607)
,p_plugin_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_display_sequence=>20
,p_display_value=>'Create'
,p_return_value=>'create'
,p_is_quick_pick=>true
,p_help_text=>'Use this option to create a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92440713021691138)
,p_plugin_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_display_sequence=>30
,p_display_value=>'Start'
,p_return_value=>'start'
,p_help_text=>'Use this option to start a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92441248373692579)
,p_plugin_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_display_sequence=>40
,p_display_value=>'Delete'
,p_return_value=>'delete'
,p_help_text=>'Use this option to delete a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92441679565693620)
,p_plugin_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_display_sequence=>50
,p_display_value=>'Reset'
,p_return_value=>'reset'
,p_help_text=>'Use this option to reset a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(33701757288369435)
,p_plugin_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_display_sequence=>60
,p_display_value=>'Terminate'
,p_return_value=>'terminate'
,p_help_text=>'Use this option to terminate a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92431147515670727)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Flow Instance Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>150
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start'
,p_help_text=>'Define the new Flow Instance name to be created.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92419359722670723)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Select Flow using'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'static'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A <i>Flows for APEX</i> <b>Flow</b> is the business process diagram or business workflow diagram used to control how your business process proceeds. These are created using the Flow Modeller in the <i>Flows for APEX</i> application.  Once you have'
||' created your Flow diagram, you should specify the Flow name (diagram name) you want to use to control the flow instance to be started.</p>',
'',
'<p>Depends on the action selected, this attribute can be use to define how to retrieve the Flow (Diagram) or the Flow Instance.</p>',
'',
'<p> <b>On Versioning.</b> If you are using flow versioning, where you can have multiple versions of a diagram, note that if you specify just the diagram name, the version of the diagram which is currently in <b>released</b> status will be used. If no'
||' <b>released</b> status version exists, a <b>draft</b> status having version = ''0'' will be used. If that doesn''t exist, you will receive an error.  So in a production environment, where you want your app to run with the current <b>released</b> versio'
||'n, just specify the flow / diagram name - and let the system find the current released version for you.  If you want to test a <b>draft</b> diagram for testing, you will need to use a query to specify which flow / model to use.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92419805442670723)
,p_plugin_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_display_sequence=>10
,p_display_value=>'APEX item'
,p_return_value=>'item'
,p_help_text=>'Use this when the Flow (Diagram or Instance) is contained in APEX Item(s).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92521941235766123)
,p_plugin_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_display_sequence=>20
,p_display_value=>'SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this when you want to specify the Flow (Diagram or Instance) with a SQL Query.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92420836686670724)
,p_plugin_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_display_sequence=>30
,p_display_value=>'Static Text'
,p_return_value=>'static'
,p_help_text=>'Use this when you want to specify the Flow (Diagram or Instance) as text.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92421276180670724)
,p_plugin_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_display_sequence=>40
,p_display_value=>'Component Setting'
,p_return_value=>'component'
,p_help_text=>'Use this when you want to specify the Flow (Diagram or Instance) to be used as a global component setting.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92421809270670724)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'APEX item(s)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'APEX Item(s) containing:',
'<ul>',
'<li>the Flow Name (a dgrm_name) and optionally the Flow Version (a dgrm_version)</li> ',
'<li>the Flow Id (a dgrm_id)</li>',
'<li>the Flow Instance Id (a prcs_id)</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92422567628670724)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Static Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>150
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'static'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Set Flow DIagram  using Name only:',
'<pre>Holiday</pre>',
'Set Flow DIagram using Name and Version:',
'<pre>Holiday,0</pre>',
'Set Flow Diagram or Instance using Id:',
'<pre>1</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provide ',
'<ul>',
'<li>a Flow Diagram Name and optionally Flow Diagram Version, using a Comma (,) separator</li>',
'<li>a Flow Diagram Id</li>',
'<li>a Flow Instance Id</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92521210289764160)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92419359722670723)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SQL query to retrieve Flow Diagram by Name:',
'<pre>',
'select dgrm_name',
'from flow_diagrams',
'where dgrm_id = 1',
'</pre>',
'SQL query to retrieve Flow Diagram by Name and Version:',
'<pre>',
'select dgrm_name, dgrm_version',
'from flow_diagrams',
'where dgrm_id = 1',
'</pre>',
'SQL query to retrieve Flow Diagram by ID:',
'<pre>',
'select dgrm_id',
'from flow_diagrams',
'where dgrm_id = 1',
'</pre>',
'SQL query to retrieve Flow Instance by ID:',
'<pre>',
'select prcs_id',
'from flow_processes',
'where prcs_id = 1',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SQL Query returning depends on the Action (and the Flow (Diagram) Selection) choosen:</br>',
'<ul>',
'<li>The flow name to use. Returned value should be a valid Flow name, i.e., should be contained in the table FLOW_DIAGRAMS in column dgrm_name.</li>',
'<li>The flow name and the flow version to use. Returned values should be a valid Flow name and version, i.e., should be contained in the table FLOW_DIAGRAMS in columns dgrm_name and dgrm_version.</li>',
'<li>The flow id to use. Returned values should be a valid Flow ID, i.e., should be contained in the table FLOW_DIAGRAMS in columns dgrm_id</li>',
'<li>The flow instance id to use. Returned values should be a valid Flow ID, i.e., should be contained in the table FLOW_PROCESSES in columns prcs_id</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92425252700670724)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Flow (Diagram) selection based on'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'name'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>How are you going to specify which Flow Diagram to use to create the Flow Instance?</p>',
'',
'<p>If you are not using Flow versioning, you can specify the Flow (diagram) by its Name, its Name and Version, or by a Flow ID. If you are not using versioning, the Version will probably be "0".  ',
'',
'<p>If you are using Flow versioning, <i>Flows for APEX</i> will  run the current, <i>released</i> version of a Flow if you specify <b>Name</b> - which you would typically use in your production application.  If you want to test a specific version of '
||'the Flow that is not the current <i>released</i> Flow, you can specify the Flow using its <b>Name and Version</b>, or by using its <b>ID</b>. -- but note that the ID will change if the model is exported and imported into another system.</p>',
'',
'<p>Using Flow ID is only recommended during testing. Note that when a Flow (Diagram) is moved from one system to another, it could be allocated a different ID number, and so using the ID might not be the best solution.</p>',
'',
'<p>When a Flow (diagram) is specified by <b>Name</b> only, the rules for Flow selection are as follows:</p><ul>',
'<li>the engine will first look for a Flow with that Name and having Status of <i>released</i></li>',
'<li>if that doesn''t exist, it will look for a Flow with that Name having a Status of <i>draft</i> and a Version of <i>0</i></li>',
'<li>if that doesn''t exist, it will return an error.</li></ul>',
'',
'',
'<p>For more information on the versioning system and its rules, see the <i>Flows for APEX</i> documentation.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92425689402670724)
,p_plugin_attribute_id=>wwv_flow_imp.id(92425252700670724)
,p_display_sequence=>10
,p_display_value=>'Name'
,p_return_value=>'name'
,p_help_text=>'Use this when you want to specify the Flow (diagram) giving just the Flow Name, letting <i>Flow for APEX</i> select the version. (see explanation for rules on which version will be used).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92426167038670726)
,p_plugin_attribute_id=>wwv_flow_imp.id(92425252700670724)
,p_display_sequence=>20
,p_display_value=>'Name & Version'
,p_return_value=>'name_and_version'
,p_help_text=>'Use this when you want to specify a Flow (diagram) using the Flow Name and a specific Version of the Flow. (see explanation)'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92426687525670726)
,p_plugin_attribute_id=>wwv_flow_imp.id(92425252700670724)
,p_display_sequence=>30
,p_display_value=>'ID [deprecated]'
,p_return_value=>'id'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This option is deprecated starting from Flows for APEX 22.2 and will probably be removed in a future release.',
'Use this to specify the Flow (Diagram) to be used by giving a Flow (diagram) ID.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92428044285670726)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Set Business Reference'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Most Flow Instances will need a Process Variable that contains a reference to its related business object.  This enables your Flow to find its associated object.</p>',
'<p>By convention, we suggest that all Flows use a process variable named ''BUSINESS_REF'' to store a reference to the associated business object in the database.  Several database views and application pages assume that this process variable exists and'
||' is set once the process knows which business object it relates to.</p>',
'<ul>',
'<li>If you know the related business object at this point in your flow, you can have the plugin set it from the contents of an APEX item before the Flow Instance is started.</li>',
'<li>If you don''t know the business object reference at this point, you can set it later in your process.  For example, if a later task creates the business object and the database returns its reference, you should then copy this into the BUSINESS_REF'
||' process variable once you do know it.  This can be done by calling flow_process_vars.set_var.</li>',
'</ul>',
'<p>',
'<p>Select an APEX Page Item containing the business reference key that you want used to set the process variable PROCESS_REF.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92428838832670726)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Return Instance ID into'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Select an APEX Page Item to return the Flow Instance ID (process_id).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92423411268670724)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Set Process Variables?'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'no'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92439391298687226)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start,start'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p> The <i>Flows for APEX</i> system provides a <i>Process Variable</i> system to store process state for the duration of the Flow Instance.  A Flow Instance can often run over days or weeks, and might involve different users performing their tasks a'
||'s part of the flow -- and so the life of a Flow Instance can often be longer than the duration of an APEX session.  The <i>Flows for APEX</i> documentation provides more information on the process variable system. Process Variables can be set by the '
||'application, by scriptTasks, and as part of the process definition.</p>',
'<p> Some Page Variables should be set when a new Flow Instance is created, as part of Flow initiation.  These variables, their types, and values can be set up declaratively in the Process Plugin.</p>',
'',
'<p> To set any <i>Flows for APEX</i> process variables as part of the Flow initialization, set this switch to ''Using JSON'' or ''Using SQL Query'', depending upon how you want to specify the process variables and their content. </p>',
'<p> Process Variables set from this process plugin are set after the new Flow has been <b>created</b>, but before it is <b>started</b>. </p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92423755357670724)
,p_plugin_attribute_id=>wwv_flow_imp.id(92423411268670724)
,p_display_sequence=>10
,p_display_value=>'No Process Variables'
,p_return_value=>'no'
,p_help_text=>'Use this option to indicate that no other process variables should to be set.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92424321622670724)
,p_plugin_attribute_id=>wwv_flow_imp.id(92423411268670724)
,p_display_sequence=>20
,p_display_value=>'Using JSON'
,p_return_value=>'json'
,p_help_text=>'Use this option to use a JSON array to specify your Process Variable(s), their types and initial values.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(92424779905670724)
,p_plugin_attribute_id=>wwv_flow_imp.id(92423411268670724)
,p_display_sequence=>30
,p_display_value=>'SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this option to specify a SQL statement to return your process variable names, types, and initial values.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92427230081670726)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'JSON'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92423411268670724)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'json'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'	{',
'		"name": "Example_vc2_var",',
'		"type": "varchar2",',
'		"value": "text"',
'	},',
'	{',
'		"name": "Example_num_var",',
'		"type": "number",',
'		"value": 200',
'	},',
'	{',
'		"name": "Example_date_var",',
'		"type": "date",',
'		"value": "2021-04-07T22:07:29.961Z"',
'	},',
'	{',
'		"name": "Example_timestamp_var",',
'		"type": "timestamp",',
'		"value": "2021-04-07T22:07:29.961Z"',
'	},',
'	{',
'		"name": "Example_clob_var",',
'		"type": "clob",',
'		"value": "long text"',
'	},',
'	{',
'		"name": "Example_json_var",',
'		"type": "json",',
'		"value": "{\"myAttribue\":\"myAttributeValue\"}"',
'	}',
']',
'</pre>'))
,p_help_text=>'Enter a JSON array that contains one or more process variables, their types, and values.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(92427637823670726)
,p_plugin_id=>wwv_flow_imp.id(92418934266670712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(92423411268670724)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_array(',
'    json_object(',
'          key ''name'' value ''example_vc2_var''',
'        , key ''type'' value ''varchar2''',
'        , key ''value'' value ''test_vc2''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_num_var''',
'        , key ''type'' value ''number''',
'        , key ''value'' value 200',
'        ),',
'    json_object(',
'          key ''name'' value ''example_date_var''',
'        , key ''type'' value ''date''',
'        , key ''value'' value ''2021-04-07T22:07:29.961Z''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_timestamp_var''',
'        , key ''type'' value ''timestamp''',
'        , key ''value'' value ''2021-04-07T22:07:29.961Z''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_clob_var''',
'        , key ''type'' value ''clob''',
'        , key ''value'' value to_clob(''this is a clob'')',
'        ),',
'    json_object(',
'          key ''name'' value ''example_json_var''',
'        , key ''type'' value ''json''',
'        , key ''value'' value ''{"myAttribue":"myAttributeValue"}''',
'    )',
'returning clob)',
'from dual;'))
,p_help_text=>'SQL query that returns the array containing the instance variables.'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_flows4apex_modeler_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(116648167005824213)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.FLOWS4APEX.MODELER.REGION'
,p_display_name=>'Flows for APEX - Modeler'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.FLOWS4APEX.MODELER.REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#js/flows4apex.apex.modeler.js',
'#PLUGIN_FILES#js/flows4apex.modeler.min.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#css/bpmn-embedded.css',
'#PLUGIN_FILES#css/bpmn-js-bpmnlint.css',
'#PLUGIN_FILES#css/bpmn-js.css',
'#PLUGIN_FILES#css/color-picker.css',
'#PLUGIN_FILES#css/diagram-js.css',
'#PLUGIN_FILES#css/flows4apex.modeler.css',
'#PLUGIN_FILES#css/properties-panel.css'))
,p_api_version=>1
,p_render_function=>'flow_modeler.render'
,p_ajax_function=>'flow_modeler.ajax'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
,p_files_version=>808
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(116654779214824242)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_name=>'SOURCE_LOCATION'
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20676C6F62616C20617065782C2062706D6E4D6F64656C6572202A2F0D0A0D0A282066756E6374696F6E202820242C20726567696F6E2C2064656275672C207365727665722C206D6573736167652C20706167652029207B0D0A2020242E77696467';
wwv_flow_imp.g_varchar2_table(2) := '6574282022666C6F777334617065782E6D6F64656C6572222C207B0D0A202020206F7074696F6E733A207B0D0A202020202020616A61784964656E7469666965723A206E756C6C2C0D0A2020202020206974656D73546F5375626D69743A206E756C6C2C';
wwv_flow_imp.g_varchar2_table(3) := '0D0A20202020202073686F77437573746F6D457874656E73696F6E733A206E756C6C2C0D0A202020207D2C0D0A0D0A202020205F6372656174653A2066756E6374696F6E202829207B0D0A202020202020746869732E6368616E676564203D2066616C73';
wwv_flow_imp.g_varchar2_table(4) := '653B0D0A202020202020746869732E726567696F6E4964203D20746869732E656C656D656E745B305D2E69643B0D0A202020202020746869732E6D6F64656C657257726170203D20746869732E726567696F6E4964202B20225F6D6F64656C6572223B0D';
wwv_flow_imp.g_varchar2_table(5) := '0A202020202020746869732E63616E7661734964203D20746869732E726567696F6E4964202B20225F63616E766173223B0D0A202020202020746869732E70726F7065727469657350616E656C506172656E74203D20746869732E726567696F6E496420';
wwv_flow_imp.g_varchar2_table(6) := '2B20225F70726F70657274696573223B0D0A0D0A202020202020746869732E656E61626C65644D6F64756C6573203D205B0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E42706D6E50726F7065727469657350';
wwv_flow_imp.g_varchar2_table(7) := '616E656C4D6F64756C652C0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E42706D6E50726F7065727469657350726F76696465724D6F64756C652C20200D0A202020202020202062706D6E4D6F64656C65722E';
wwv_flow_imp.g_varchar2_table(8) := '637573746F6D4D6F64756C65732E70726F7065727469657350726F76696465724D6F64756C652C0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E4164644578706F727465722C0D0A202020202020202062706D';
wwv_flow_imp.g_varchar2_table(9) := '6E4D6F64656C65722E637573746F6D4D6F64756C65732E6C696E744D6F64756C652C0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E637573746F6D50616C6574746550726F76696465724D6F64756C652C0D0A';
wwv_flow_imp.g_varchar2_table(10) := '202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E7472616E736C6174696F6E4D6F64756C652C0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E786D6C4D6F64756C652C0D0A';
wwv_flow_imp.g_varchar2_table(11) := '202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E6472696C6C646F776E43656E746572696E672C0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E62706D6E44694F72646572';
wwv_flow_imp.g_varchar2_table(12) := '696E672C0D0A202020202020202062706D6E4D6F64656C65722E637573746F6D4D6F64756C65732E636F6C6F725069636B65724D6F64756C650D0A2020202020205D3B0D0A0D0A202020202020746869732E6578706F72746572203D207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(13) := '202020206E616D653A2027466C6F777320666F722041504558272C0D0A202020202020202076657273696F6E3A202732342E312E30272C0D0A2020202020207D3B0D0A0D0A202020202020746869732E6D6F64646C65457874656E73696F6E73203D207B';
wwv_flow_imp.g_varchar2_table(14) := '0D0A2020202020202020617065783A2062706D6E4D6F64656C65722E6D6F64646C65457874656E73696F6E732E617065784D6F64646C6544657363726970746F722C0D0A2020202020207D3B0D0A0D0A202020202020746869732E6C696E74696E67203D';
wwv_flow_imp.g_varchar2_table(15) := '207B0D0A202020202020202062706D6E6C696E743A2062706D6E4D6F64656C65722E6C696E74696E672E617065784C696E74696E672C0D0A2020202020207D3B0D0A0D0A202020202020746869732E62706D6E52656E6465726572203D207B0D0A202020';
wwv_flow_imp.g_varchar2_table(16) := '202020202064656661756C7446696C6C436F6C6F723A2022766172282D2D64656661756C742D66696C6C2D636F6C6F7229222C0D0A202020202020202064656661756C745374726F6B65436F6C6F723A2022766172282D2D64656661756C742D7374726F';
wwv_flow_imp.g_varchar2_table(17) := '6B652D636F6C6F7229222C0D0A202020202020202064656661756C744C6162656C436F6C6F723A2022766172282D2D64656661756C742D7374726F6B652D636F6C6F7229222C0D0A2020202020207D3B0D0A0D0A202020202020746869732E62706D6E4D';
wwv_flow_imp.g_varchar2_table(18) := '6F64656C657224203D206E65772062706D6E4D6F64656C65722E4D6F64656C657228207B0D0A2020202020202020636F6E7461696E65723A20222322202B20746869732E63616E76617349642C0D0A20202020202020206B6579626F6172643A207B2062';
wwv_flow_imp.g_varchar2_table(19) := '696E64546F3A20646F63756D656E74207D2C0D0A202020202020202070726F7065727469657350616E656C3A207B20706172656E743A20222322202B20746869732E70726F7065727469657350616E656C506172656E74207D2C0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(20) := '6164646974696F6E616C4D6F64756C65733A20746869732E656E61626C65644D6F64756C65732C0D0A20202020202020206D6F64646C65457874656E73696F6E733A20746869732E6D6F64646C65457874656E73696F6E732C0D0A20202020202020206C';
wwv_flow_imp.g_varchar2_table(21) := '696E74696E673A20746869732E6C696E74696E672C0D0A202020202020202062706D6E52656E64657265723A20746869732E62706D6E52656E64657265722C0D0A20202020202020206578706F727465723A20746869732E6578706F727465722C0D0A20';
wwv_flow_imp.g_varchar2_table(22) := '2020202020202073686F77437573746F6D457874656E73696F6E733A2028746869732E6F7074696F6E732E73686F77437573746F6D457874656E73696F6E73203D3D3D20277472756527290D0A2020202020207D20293B0D0A0D0A2020202020202F2F20';
wwv_flow_imp.g_varchar2_table(23) := '70726576656E7420636C69636B206576656E74732066726F6D20627562626C696E672075702074686520646F6D0D0A202020202020242820222322202B20746869732E6D6F64656C65725772617020292E6F6E282022636C69636B222C2028206576656E';
wwv_flow_imp.g_varchar2_table(24) := '742029203D3E207B0D0A20202020202020202020636F6E737420696E707574203D206576656E742E7461726765742E7461674E616D65203D3D2027494E50555427203F206576656E742E746172676574203A0D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(25) := '20202020202020206576656E742E7461726765742E7461674E616D65203D3D20274C4142454C27203F20646F63756D656E742E676574456C656D656E7442794964286576656E742E7461726765742E6765744174747269627574652827666F7227292920';
wwv_flow_imp.g_varchar2_table(26) := '3A0D0A2020202020202020202020202020202020202020202020206576656E742E7461726765742E7461674E616D65203D3D20275350414E27203F206576656E742E746172676574203A200D0A2020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(27) := '206E756C6C3B0D0A0D0A2020202020202020202069662028696E70757420262620696E7075742E74797065203D3D2027636865636B626F782729207B0D0A2020202020202020202020202F2F20616C6C6F7720636865636B626F780D0A20202020202020';
wwv_flow_imp.g_varchar2_table(28) := '2020207D0D0A20202020202020202020656C73652069662028696E70757420262620696E7075742E636C6173734C6973742E636F6E7461696E73282762696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F736C6964';
wwv_flow_imp.g_varchar2_table(29) := '6572272929207B0D0A2020202020202020202020202F2F20616C6C6F7720746F67676C65207377697463680D0A202020202020202020207D0D0A20202020202020202020656C736520696620286576656E742E7461726765742E7461674E616D65203D3D';
wwv_flow_imp.g_varchar2_table(30) := '2027412729207B0D0A2020202020202020202020202F2F20616C6C6F77206C696E6B730D0A202020202020202020207D0D0A20202020202020202020656C7365207B0D0A2020202020202020202020206576656E742E73746F7050726F7061676174696F';
wwv_flow_imp.g_varchar2_table(31) := '6E28293B0D0A20202020202020202020202072657475726E2066616C73653B0D0A202020202020202020207D0D0A2020202020207D20293B0D0A0D0A2020202020202F2F2070726576656E742070616765207375626D6974202B2072656C6F6164206166';
wwv_flow_imp.g_varchar2_table(32) := '74657220627574746F6E20636C69636B0D0A202020202020242820646F63756D656E7420292E6F6E282022617065786265666F7265706167657375626D6974222C2028206576656E742C20726571756573742029203D3E207B0D0A202020202020202069';
wwv_flow_imp.g_varchar2_table(33) := '66202821726571756573742920617065782E6576656E742E6743616E63656C466C6167203D20747275653B0D0A2020202020207D20293B0D0A0D0A2020202020202F2F20726567697374657220637573746F6D206368616E6765642068616E646C657220';
wwv_flow_imp.g_varchar2_table(34) := '7769746820415045580D0A202020202020706167652E7761726E4F6E556E73617665644368616E67657328206E756C6C2C202829203D3E207B0D0A202020202020202072657475726E20746869732E6368616E6765643B0D0A2020202020207D20293B0D';
wwv_flow_imp.g_varchar2_table(35) := '0A0D0A202020202020726567696F6E2E6372656174652820746869732E726567696F6E49642C207B0D0A20202020202020207769646765743A202829203D3E207B0D0A2020202020202020202072657475726E20746869732E656C656D656E743B0D0A20';
wwv_flow_imp.g_varchar2_table(36) := '202020202020207D2C0D0A2020202020202020726566726573683A202829203D3E207B0D0A20202020202020202020746869732E7265667265736828293B0D0A20202020202020207D2C0D0A20202020202020206C6F61644469616772616D3A20282920';
wwv_flow_imp.g_varchar2_table(37) := '3D3E207B0D0A20202020202020202020746869732E6C6F61644469616772616D28293B0D0A20202020202020207D2C0D0A20202020202020206765744D6F64656C6572496E7374616E63653A202829203D3E207B0D0A2020202020202020202072657475';
wwv_flow_imp.g_varchar2_table(38) := '726E20746869732E62706D6E4D6F64656C6572243B0D0A20202020202020207D2C0D0A20202020202020206765744576656E744275733A202829203D3E207B0D0A2020202020202020202072657475726E20746869732E62706D6E4D6F64656C6572242E';
wwv_flow_imp.g_varchar2_table(39) := '6765742820226576656E744275732220293B0D0A20202020202020207D2C0D0A2020202020202020736176653A202829203D3E207B0D0A20202020202020202020746869732E7361766528293B0D0A20202020202020207D2C0D0A202020202020202067';
wwv_flow_imp.g_varchar2_table(40) := '65744469616772616D3A202829203D3E20746869732E6765744469616772616D28292C0D0A20202020202020206765745356473A202829203D3E20746869732E67657453564728292C0D0A20202020202020207769646765744E616D653A202262706D6E';
wwv_flow_imp.g_varchar2_table(41) := '6D6F64656C6572222C0D0A2020202020202020747970653A2022666C6F777334617065782E6D6F64656C6572222C0D0A2020202020207D20293B0D0A0D0A202020202020746869732E7265667265736828293B0D0A202020207D2C0D0A202020206C6F61';
wwv_flow_imp.g_varchar2_table(42) := '644469616772616D3A206173796E632066756E6374696F6E202829207B0D0A2020202020207661722074686174203D20746869733B0D0A202020202020636F6E73742062706D6E4D6F64656C657224203D20746869732E62706D6E4D6F64656C6572243B';
wwv_flow_imp.g_varchar2_table(43) := '0D0A202020202020747279207B0D0A202020202020202076617220726573756C74203D2061776169742062706D6E4D6F64656C6572242E696D706F7274584D4C2820746869732E6469616772616D436F6E74656E7420293B0D0A0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(44) := '696620282162706D6E4D6F64656C6572242E5F646566696E6974696F6E732E6765742827786D6C6E733A61706578272929207B0D0A202020202020202020202F2F20637573746F6D206E616D657370616365206D757374206265206164646564206D616E';
wwv_flow_imp.g_varchar2_table(45) := '75616C6C7920666F7220776F726B696E672064656661756C742076616C756573200D0A20202020202020202020636F6E7374207265666163746F726564203D2062706D6E4D6F64656C6572242E6765742827786D6C4D6F64756C6527292E616464437573';
wwv_flow_imp.g_varchar2_table(46) := '746F6D4E616D65737061636528746869732E6469616772616D436F6E74656E74293B0D0A20202020202020202020726573756C74203D2061776169742062706D6E4D6F64656C6572242E696D706F7274584D4C287265666163746F726564293B0D0A2020';
wwv_flow_imp.g_varchar2_table(47) := '2020202020207D0D0A0D0A2020202020202020636F6E7374207B207761726E696E6773207D203D20726573756C743B0D0A0D0A202020202020202069662028207761726E696E67732E6C656E677468203E20302029207B0D0A2020202020202020202064';
wwv_flow_imp.g_varchar2_table(48) := '656275672E7761726E2820225761726E696E677320647572696E6720584D4C20496D706F7274222C207761726E696E677320293B0D0A20202020202020207D0D0A0D0A202020202020202062706D6E4D6F64656C6572242E6765742827786D6C4D6F6475';
wwv_flow_imp.g_varchar2_table(49) := '6C6527292E7265666163746F72456C656D656E747328293B0D0A0D0A2020202020202020746869732E7A6F6F6D2820226669742D76696577706F72742220293B0D0A2020202020202020746861742E6368616E676564203D2066616C73653B0D0A202020';
wwv_flow_imp.g_varchar2_table(50) := '202020202062706D6E4D6F64656C6572242E6765742820226576656E744275732220292E6F6E282022636F6D6D616E64537461636B2E6368616E676564222C2066756E6374696F6E202829207B0D0A20202020202020202020746861742E6368616E6765';
wwv_flow_imp.g_varchar2_table(51) := '64203D20747275653B0D0A20202020202020207D20293B0D0A2020202020207D2063617463682028206572722029207B0D0A202020202020202064656275672E6572726F722820224C6F6164696E67204469616772616D206661696C65642E222C206572';
wwv_flow_imp.g_varchar2_table(52) := '722C20746869732E6469616772616D20293B0D0A2020202020207D0D0A202020207D2C0D0A202020207A6F6F6D3A2066756E6374696F6E2028207A6F6F6D4F7074696F6E2029207B0D0A202020202020746869732E62706D6E4D6F64656C6572242E6765';
wwv_flow_imp.g_varchar2_table(53) := '7428202263616E7661732220292E7A6F6F6D28207A6F6F6D4F7074696F6E20293B0D0A202020207D2C0D0A20202020726566726573683A2066756E6374696F6E202829207B0D0A2020202020207661722074686174203D20746869733B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(54) := '2064656275672E696E666F282022456E7465722052656672657368222C20746869732E6F7074696F6E7320293B0D0A2020202020206966202820746869732E6368616E6765642029207B0D0A20202020202020206D6573736167652E636F6E6669726D28';
wwv_flow_imp.g_varchar2_table(55) := '0D0A20202020202020202020224D6F64656C20686173206368616E6765642E2044697363617264206368616E6765733F222C0D0A2020202020202020202066756E6374696F6E2028206F6B507265737365642029207B0D0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(56) := '69662028206F6B507265737365642029207B0D0A2020202020202020202020202020746861742E5F7265667265736843616C6C28293B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A2020202020202020293B0D0A20202020';
wwv_flow_imp.g_varchar2_table(57) := '20207D20656C7365207B0D0A2020202020202020746861742E5F7265667265736843616C6C28293B0D0A2020202020207D0D0A202020207D2C0D0A202020206765744469616772616D3A206173796E632066756E6374696F6E202829207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(58) := '20207661722074686174203D20746869733B0D0A202020202020636F6E73742062706D6E4D6F64656C657224203D20746861742E62706D6E4D6F64656C6572243B0D0A202020202020747279207B0D0A2020202020202020636F6E737420726573756C74';
wwv_flow_imp.g_varchar2_table(59) := '203D2061776169742062706D6E4D6F64656C6572242E73617665584D4C28207B20666F726D61743A2074727565207D20293B0D0A2020202020202020636F6E7374207B20786D6C207D203D20726573756C743B0D0A202020202020202072657475726E20';
wwv_flow_imp.g_varchar2_table(60) := '786D6C3B0D0A2020202020207D2063617463682028206572722029207B0D0A202020202020202064656275672E6572726F72282022476574204469616772616D206661696C65642E222C2065727220293B0D0A20202020202020207468726F7720657272';
wwv_flow_imp.g_varchar2_table(61) := '3B0D0A2020202020207D0D0A202020207D2C0D0A202020206765745356473A206173796E632066756E6374696F6E202829207B0D0A202020202020636F6E73742062706D6E4D6F64656C657224203D20746869732E62706D6E4D6F64656C6572243B0D0A';
wwv_flow_imp.g_varchar2_table(62) := '202020202020747279207B0D0A2020202020202020636F6E737420726573756C74203D2061776169742062706D6E4D6F64656C6572242E7361766553564728207B20666F726D61743A2074727565207D20293B0D0A2020202020202020636F6E7374207B';
wwv_flow_imp.g_varchar2_table(63) := '20737667207D203D20726573756C743B0D0A2020202020202020636F6E7374207374796C6564535647203D2062706D6E4D6F64656C6572242E6765742827786D6C4D6F64756C6527292E616464546F5356475374796C65287376672C272E646A732D6772';
wwv_flow_imp.g_varchar2_table(64) := '6F7570207B202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B207D27293B0D0A202020202020202072657475726E207374796C65645356473B0D0A20';
wwv_flow_imp.g_varchar2_table(65) := '20202020207D2063617463682028206572722029207B0D0A202020202020202064656275672E6572726F7228202247657420535647206661696C65642E222C2065727220293B0D0A20202020202020207468726F77206572723B0D0A2020202020207D0D';
wwv_flow_imp.g_varchar2_table(66) := '0A202020207D2C0D0A20202020736176653A206173796E632066756E6374696F6E202829207B0D0A202020202020746869732E5F7361766543616C6C2820617761697420746869732E6765744469616772616D282920293B0D0A202020207D2C0D0A2020';
wwv_flow_imp.g_varchar2_table(67) := '20205F7265667265736843616C6C3A2066756E6374696F6E202829207B0D0A2020202020207365727665720D0A20202020202020202E706C7567696E280D0A20202020202020202020746869732E6F7074696F6E732E616A61784964656E746966696572';
wwv_flow_imp.g_varchar2_table(68) := '2C0D0A202020202020202020207B0D0A202020202020202020202020706167654974656D733A20242820746869732E6F7074696F6E732E6974656D73546F5375626D69742C20617065782E6750616765436F6E746578742420292C0D0A20202020202020';
wwv_flow_imp.g_varchar2_table(69) := '20202020207830313A20224C4F4144222C0D0A202020202020202020207D2C0D0A202020202020202020207B0D0A202020202020202020202020726566726573684F626A6563743A20222322202B20746869732E63616E76617349642C0D0A2020202020';
wwv_flow_imp.g_varchar2_table(70) := '202020202020206C6F6164696E67496E64696361746F723A20222322202B20746869732E63616E76617349642C0D0A202020202020202020207D0D0A2020202020202020290D0A20202020202020202E7468656E2820282070446174612029203D3E207B';
wwv_flow_imp.g_varchar2_table(71) := '0D0A20202020202020202020746869732E6469616772616D436F6E74656E74203D2070446174612E646174612E636F6E74656E743B0D0A20202020202020202020746869732E6469616772616D4964203D2070446174612E646174612E69643B0D0A2020';
wwv_flow_imp.g_varchar2_table(72) := '2020202020202020746869732E6C6F61644469616772616D28293B0D0A20202020202020207D20293B0D0A202020207D2C0D0A202020205F7361766543616C6C3A2066756E6374696F6E202820786D6C2029207B0D0A2020202020207365727665720D0A';
wwv_flow_imp.g_varchar2_table(73) := '20202020202020202E706C7567696E2820746869732E6F7074696F6E732E616A61784964656E7469666965722C207B0D0A20202020202020202020726567696F6E733A205B0D0A2020202020202020202020207B0D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(74) := '69643A20746869732E726567696F6E49642C0D0A2020202020202020202020202020646174613A207B0D0A2020202020202020202020202020202069643A20746869732E6469616772616D49642C0D0A20202020202020202020202020202020636F6E74';
wwv_flow_imp.g_varchar2_table(75) := '656E743A20786D6C2C0D0A20202020202020202020202020207D2C0D0A2020202020202020202020207D2C0D0A202020202020202020205D2C0D0A202020202020202020207830313A202253415645222C0D0A20202020202020207D20290D0A20202020';
wwv_flow_imp.g_varchar2_table(76) := '202020202E7468656E2820282070446174612029203D3E207B0D0A20202020202020202020617065782E6D6573736167652E636C6561724572726F727328293B0D0A20202020202020202020696620282070446174612E737563636573732029207B0D0A';
wwv_flow_imp.g_varchar2_table(77) := '202020202020202020202020746869732E6368616E676564203D2066616C73653B0D0A2020202020202020202020206D6573736167652E73686F775061676553756363657373282070446174612E6D65737361676520293B0D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(78) := '7D20656C7365207B0D0A2020202020202020202020206D6573736167652E73686F774572726F727328205B0D0A20202020202020202020202020207B0D0A20202020202020202020202020202020747970653A20226572726F72222C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(79) := '202020202020202020206C6F636174696F6E3A205B2270616765225D2C0D0A202020202020202020202020202020206D6573736167653A2070446174612E6D6573736167652C0D0A20202020202020202020202020202020756E736166653A2066616C73';
wwv_flow_imp.g_varchar2_table(80) := '652C0D0A20202020202020202020202020207D2C0D0A2020202020202020202020205D20293B0D0A202020202020202020207D0D0A20202020202020207D20293B0D0A202020207D2C0D0A20207D20293B0D0A7D20292820617065782E6A51756572792C';
wwv_flow_imp.g_varchar2_table(81) := '20617065782E726567696F6E2C20617065782E64656275672C20617065782E7365727665722C20617065782E6D6573736167652C20617065782E7061676520293B0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5446191022531663)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/flows4apex.apex.modeler.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '00010000000B00800003003047535542208B257A00000138000000544F532F32374F4B470000018C00000060636D61703D316D1A0000092000001AD0676C796640DD0FCA0000278C0000F69C686561645897A053000000E00000003668686561025B02F8';
wwv_flow_imp.g_varchar2_table(2) := '000000BC00000024686D74781B15FFFA000001EC000007346C6F63619277CFB8000023F00000039C6D61787002EE018100000118000000206E616D6593F7B94B00011E28000001F8706F73747B78D561000120200000191B00010000012C00000000012C';
wwv_flow_imp.g_varchar2_table(3) := 'FFFFFFFE012E0001000000000000000000000000000001CD00010000000100007CB0A3765F0F3CF5000B012C000000007C25B080000000007C25B080FFFFFFFD012E012D0000000800020000000000000001000001CD017500170000000000020000000A';
wwv_flow_imp.g_varchar2_table(4) := '000A000000FF00000000000000010000000A0030003E000244464C54000E6C61746E001A00040000000000000001000000040000000000000001000000016C6967610008000000010000000100040004000000010008000100060000000100000004012B';
wwv_flow_imp.g_varchar2_table(5) := '01900005000000CB00D20000002A00CB00D200000090000E004D000002000503000000000000000000000000000000000000000000005066456400C0EA60F101012C0000001B0147000300000001000000000000000000000000000200000000012C0000';
wwv_flow_imp.g_varchar2_table(6) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(7) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(8) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(9) := '012C0000012C0000012C0000012C0000012CFFFF012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(10) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(11) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012CFFFF012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(12) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(13) := '012CFFFF012C0000012C0000012C0000012C0000012C0000012C0000012C0000012CFFFF012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(14) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(15) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(16) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(17) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(18) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(19) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(20) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(21) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(22) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012CFFFF012C0000012C0000012C0000012CFFFF012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(23) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000';
wwv_flow_imp.g_varchar2_table(24) := '012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C0000012C000000000005000000030000002C0000000400000524000100000000041E000300010000002C0003000A00000524000403F200000012001000030002EA88EA8CEAC7';
wwv_flow_imp.g_varchar2_table(25) := 'EAC9EB09EB4EEC33F101FFFF0000EA60EA8AEA8FEAC9EACCEB0BEB50F101FFFF00000000000000000000000000000000000100120062006600D600D6015001D6039C0000000300F00149014600B3013601940124016D010D0173004D01C2015F01690168';
wwv_flow_imp.g_varchar2_table(26) := '00900035012F008500CE00FD004001920078001601BD009A00870142011C0113011401A700C800A500BB019F017F008A019001780187018501790188018F018A018300BD017E018C000200040005000A000B000C000D000E000F00100012001A001C001D';
wwv_flow_imp.g_varchar2_table(27) := '001E005B005C005D005E00610062002100220023002400250028002A002B002C002D002E002F0031003200330034003B0038003C003D003E003F00410042004500470048004A005400550056005700660068006A006D0071007300740075007600770079';
wwv_flow_imp.g_varchar2_table(28) := '007A007B007C007D007E008000810083008400860088008B008E008F00920093009400950096009700980099009B009D009E009F00A000A100A200A400A700A800A9009300AA00AB00AD00B700B800BC00BF00C300C400C700C900CA00CB00CC00D200D3';
wwv_flow_imp.g_varchar2_table(29) := '00D400D500D600D700D800D900EE00F100F200F500F800F900FA00FB00FF0100010501060107010C010E010F0110011201160117011A011B011E011F0127012B012C012D012E013001310132013301340135013A013B013C013D013E013F014001410143';
wwv_flow_imp.g_varchar2_table(30) := '014501470148014A014B014D014E014F0150015101580159015A015B015C015E0163016401650167016A016C01700171017201740175017A017B017C017D018001810182018401860189018B018D0196019701A001A101A301A501A601A801A901AA01AB';
wwv_flow_imp.g_varchar2_table(31) := '01AC01B001B201B301B401B701B801B901BB01BC01C301C401C501C601C701CB01CC00F300F400F600F7005F0060006F003900700063018E006E0072006C005A002600270108008C009100C501B100010017006400ED011D01540191012900B901620161';
wwv_flow_imp.g_varchar2_table(32) := '01210176012A0138005901BA00430109008D00C000FE01190139002901280120003600370049019301B501AF01AD01AE00AF015201550118006B01C801CA01C90199019A019B019C019D019E0198001100520123009C01C1006900D000DC00DB00DA0050';
wwv_flow_imp.g_varchar2_table(33) := '004F004E001400D100AE00B000580067015700A30065001500C100C20126001F002000FC001301B6011500EC00DD00DE00E300E100E200E500E600E800EA00EB00E000DF019500CD01370089000600070008000900E900E400E7001B00C601040101003A';
wwv_flow_imp.g_varchar2_table(34) := '00190018004C00B100B2015D004B0160016F00CF010B01A201A40046016B00A601BE003001250111010A0144005100EF014C016E0082007F0177016600B600B400B501C001BF004401560153005300BA0103010200BE012200AC00000106000000000000';
wwv_flow_imp.g_varchar2_table(35) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_imp.g_varchar2_table(36) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000';
wwv_flow_imp.g_varchar2_table(37) := '00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000C0000000015AC00000000000001CD0000EA600000EA60000000030000EA610000EA61000000F00000EA620000EA62';
wwv_flow_imp.g_varchar2_table(38) := '000001490000EA630000EA63000001460000EA640000EA64000000B30000EA650000EA65000001360000EA660000EA66000001940000EA670000EA67000001240000EA680000EA680000016D0000EA690000EA690000010D0000EA6A0000EA6A00000173';
wwv_flow_imp.g_varchar2_table(39) := '0000EA6B0000EA6B0000004D0000EA6C0000EA6C000001C20000EA6D0000EA6D0000015F0000EA6E0000EA6E000001690000EA6F0000EA6F000001680000EA700000EA70000000900000EA710000EA71000000350000EA720000EA720000012F0000EA73';
wwv_flow_imp.g_varchar2_table(40) := '0000EA73000000850000EA740000EA74000000CE0000EA750000EA75000000FD0000EA760000EA76000000400000EA770000EA77000001920000EA780000EA78000000780000EA790000EA79000000160000EA7A0000EA7A000001BD0000EA7B0000EA7B';
wwv_flow_imp.g_varchar2_table(41) := '0000009A0000EA7C0000EA7C000000870000EA7D0000EA7D000001420000EA7E0000EA7E0000011C0000EA7F0000EA7F000001130000EA800000EA80000001140000EA810000EA81000001A70000EA820000EA82000000C80000EA830000EA83000000A5';
wwv_flow_imp.g_varchar2_table(42) := '0000EA840000EA84000000BB0000EA850000EA850000019F0000EA860000EA860000017F0000EA870000EA870000008A0000EA880000EA88000001900000EA8A0000EA8A000001780000EA8B0000EA8B000001870000EA8C0000EA8C000001850000EA8F';
wwv_flow_imp.g_varchar2_table(43) := '0000EA8F000001790000EA900000EA90000001880000EA910000EA910000018F0000EA920000EA920000018A0000EA930000EA93000001830000EA940000EA94000000BD0000EA950000EA950000017E0000EA960000EA960000018C0000EA970000EA97';
wwv_flow_imp.g_varchar2_table(44) := '000000020000EA980000EA98000000040000EA990000EA99000000050000EA9A0000EA9A0000000A0000EA9B0000EA9B0000000B0000EA9C0000EA9C0000000C0000EA9D0000EA9D0000000D0000EA9E0000EA9E0000000E0000EA9F0000EA9F0000000F';
wwv_flow_imp.g_varchar2_table(45) := '0000EAA00000EAA0000000100000EAA10000EAA1000000120000EAA20000EAA20000001A0000EAA30000EAA30000001C0000EAA40000EAA40000001D0000EAA50000EAA50000001E0000EAA60000EAA60000005B0000EAA70000EAA70000005C0000EAA8';
wwv_flow_imp.g_varchar2_table(46) := '0000EAA80000005D0000EAA90000EAA90000005E0000EAAA0000EAAA000000610000EAAB0000EAAB000000620000EAAC0000EAAC000000210000EAAD0000EAAD000000220000EAAE0000EAAE000000230000EAAF0000EAAF000000240000EAB00000EAB0';
wwv_flow_imp.g_varchar2_table(47) := '000000250000EAB10000EAB1000000280000EAB20000EAB20000002A0000EAB30000EAB30000002B0000EAB40000EAB40000002C0000EAB50000EAB50000002D0000EAB60000EAB60000002E0000EAB70000EAB70000002F0000EAB80000EAB800000031';
wwv_flow_imp.g_varchar2_table(48) := '0000EAB90000EAB9000000320000EABA0000EABA000000330000EABB0000EABB000000340000EABC0000EABC0000003B0000EABD0000EABD000000380000EABE0000EABE0000003C0000EABF0000EABF0000003D0000EAC00000EAC00000003E0000EAC1';
wwv_flow_imp.g_varchar2_table(49) := '0000EAC10000003F0000EAC20000EAC2000000410000EAC30000EAC3000000420000EAC40000EAC4000000450000EAC50000EAC5000000470000EAC60000EAC6000000480000EAC70000EAC70000004A0000EAC90000EAC9000000540000EACC0000EACC';
wwv_flow_imp.g_varchar2_table(50) := '000000550000EACD0000EACD000000560000EACE0000EACE000000570000EACF0000EACF000000660000EAD00000EAD0000000680000EAD10000EAD10000006A0000EAD20000EAD20000006D0000EAD30000EAD3000000710000EAD40000EAD400000073';
wwv_flow_imp.g_varchar2_table(51) := '0000EAD50000EAD5000000740000EAD60000EAD6000000750000EAD70000EAD7000000760000EAD80000EAD8000000770000EAD90000EAD9000000790000EADA0000EADA0000007A0000EADB0000EADB0000007B0000EADC0000EADC0000007C0000EADD';
wwv_flow_imp.g_varchar2_table(52) := '0000EADD0000007D0000EADE0000EADE0000007E0000EADF0000EADF000000800000EAE00000EAE0000000810000EAE10000EAE1000000830000EAE20000EAE2000000840000EAE30000EAE3000000860000EAE40000EAE4000000880000EAE50000EAE5';
wwv_flow_imp.g_varchar2_table(53) := '0000008B0000EAE60000EAE60000008E0000EAE70000EAE70000008F0000EAE80000EAE8000000920000EAE90000EAE9000000930000EAEA0000EAEA000000940000EAEB0000EAEB000000950000EAEC0000EAEC000000960000EAED0000EAED00000097';
wwv_flow_imp.g_varchar2_table(54) := '0000EAEE0000EAEE000000980000EAEF0000EAEF000000990000EAF00000EAF00000009B0000EAF10000EAF10000009D0000EAF20000EAF20000009E0000EAF30000EAF30000009F0000EAF40000EAF4000000A00000EAF50000EAF5000000A10000EAF6';
wwv_flow_imp.g_varchar2_table(55) := '0000EAF6000000A20000EAF70000EAF7000000A40000EAF80000EAF8000000A70000EAF90000EAF9000000A80000EAFA0000EAFA000000A90000EAFB0000EAFB000000930000EAFC0000EAFC000000AA0000EAFD0000EAFD000000AB0000EAFE0000EAFE';
wwv_flow_imp.g_varchar2_table(56) := '000000AD0000EAFF0000EAFF000000B70000EB000000EB00000000B80000EB010000EB01000000BC0000EB020000EB02000000BF0000EB030000EB03000000C30000EB040000EB04000000C40000EB050000EB05000000C70000EB060000EB06000000C9';
wwv_flow_imp.g_varchar2_table(57) := '0000EB070000EB07000000CA0000EB080000EB08000000CB0000EB090000EB09000000CC0000EB0B0000EB0B000000D20000EB0C0000EB0C000000D30000EB0D0000EB0D000000D40000EB0E0000EB0E000000D50000EB0F0000EB0F000000D60000EB10';
wwv_flow_imp.g_varchar2_table(58) := '0000EB10000000D70000EB110000EB11000000D80000EB120000EB12000000D90000EB130000EB13000000EE0000EB140000EB14000000F10000EB150000EB15000000F20000EB160000EB16000000F50000EB170000EB17000000F80000EB180000EB18';
wwv_flow_imp.g_varchar2_table(59) := '000000F90000EB190000EB19000000FA0000EB1A0000EB1A000000FB0000EB1B0000EB1B000000FF0000EB1C0000EB1C000001000000EB1D0000EB1D000001050000EB1E0000EB1E000001060000EB1F0000EB1F000001070000EB200000EB200000010C';
wwv_flow_imp.g_varchar2_table(60) := '0000EB210000EB210000010E0000EB220000EB220000010F0000EB230000EB23000001100000EB240000EB24000001120000EB250000EB25000001160000EB260000EB26000001170000EB270000EB270000011A0000EB280000EB280000011B0000EB29';
wwv_flow_imp.g_varchar2_table(61) := '0000EB290000011E0000EB2A0000EB2A0000011F0000EB2B0000EB2B000001270000EB2C0000EB2C0000012B0000EB2D0000EB2D0000012C0000EB2E0000EB2E0000012D0000EB2F0000EB2F0000012E0000EB300000EB30000001300000EB310000EB31';
wwv_flow_imp.g_varchar2_table(62) := '000001310000EB320000EB32000001320000EB330000EB33000001330000EB340000EB34000001340000EB350000EB35000001350000EB360000EB360000013A0000EB370000EB370000013B0000EB380000EB380000013C0000EB390000EB390000013D';
wwv_flow_imp.g_varchar2_table(63) := '0000EB3A0000EB3A0000013E0000EB3B0000EB3B0000013F0000EB3C0000EB3C000001400000EB3D0000EB3D000001410000EB3E0000EB3E000001430000EB3F0000EB3F000001450000EB400000EB40000001470000EB410000EB41000001480000EB42';
wwv_flow_imp.g_varchar2_table(64) := '0000EB420000014A0000EB430000EB430000014B0000EB440000EB440000014D0000EB450000EB450000014E0000EB460000EB460000014F0000EB470000EB47000001500000EB480000EB48000001510000EB490000EB49000001580000EB4A0000EB4A';
wwv_flow_imp.g_varchar2_table(65) := '000001590000EB4B0000EB4B0000015A0000EB4C0000EB4C0000015B0000EB4D0000EB4D0000015C0000EB4E0000EB4E0000015E0000EB500000EB50000001630000EB510000EB51000001640000EB520000EB52000001650000EB530000EB5300000167';
wwv_flow_imp.g_varchar2_table(66) := '0000EB540000EB540000016A0000EB550000EB550000016C0000EB560000EB56000001700000EB570000EB57000001710000EB580000EB58000001720000EB590000EB59000001740000EB5A0000EB5A000001750000EB5B0000EB5B0000017A0000EB5C';
wwv_flow_imp.g_varchar2_table(67) := '0000EB5C0000017B0000EB5D0000EB5D0000017C0000EB5E0000EB5E0000017D0000EB5F0000EB5F000001800000EB600000EB60000001810000EB610000EB61000001820000EB620000EB62000001840000EB630000EB63000001860000EB640000EB64';
wwv_flow_imp.g_varchar2_table(68) := '000001890000EB650000EB650000018B0000EB660000EB660000018D0000EB670000EB67000001960000EB680000EB68000001970000EB690000EB69000001A00000EB6A0000EB6A000001A10000EB6B0000EB6B000001A30000EB6C0000EB6C000001A5';
wwv_flow_imp.g_varchar2_table(69) := '0000EB6D0000EB6D000001A60000EB6E0000EB6E000001A80000EB6F0000EB6F000001A90000EB700000EB70000001AA0000EB710000EB71000001AB0000EB720000EB72000001AC0000EB730000EB73000001B00000EB740000EB74000001B20000EB75';
wwv_flow_imp.g_varchar2_table(70) := '0000EB75000001B30000EB760000EB76000001B40000EB770000EB77000001B70000EB780000EB78000001B80000EB790000EB79000001B90000EB7A0000EB7A000001BB0000EB7B0000EB7B000001BC0000EB7C0000EB7C000001C30000EB7D0000EB7D';
wwv_flow_imp.g_varchar2_table(71) := '000001C40000EB7E0000EB7E000001C50000EB7F0000EB7F000001C60000EB800000EB80000001C70000EB810000EB81000001CB0000EB820000EB82000001CC0000EB830000EB83000000F30000EB840000EB84000000F40000EB850000EB85000000F6';
wwv_flow_imp.g_varchar2_table(72) := '0000EB860000EB86000000F70000EB870000EB870000005F0000EB880000EB88000000600000EB890000EB890000006F0000EB8A0000EB8A000000390000EB8B0000EB8B000000700000EB8C0000EB8C000000630000EB8D0000EB8D0000018E0000EB8E';
wwv_flow_imp.g_varchar2_table(73) := '0000EB8E0000006E0000EB8F0000EB8F000000720000EB900000EB900000006C0000EB910000EB910000005A0000EB920000EB92000000260000EB930000EB93000000270000EB940000EB94000001080000EB950000EB950000008C0000EB960000EB96';
wwv_flow_imp.g_varchar2_table(74) := '000000910000EB970000EB97000000C50000EB980000EB98000001B10000EB990000EB99000000010000EB9A0000EB9A000000170000EB9B0000EB9B000000640000EB9C0000EB9C000000ED0000EB9D0000EB9D0000011D0000EB9E0000EB9E00000154';
wwv_flow_imp.g_varchar2_table(75) := '0000EB9F0000EB9F000001910000EBA00000EBA0000001290000EBA10000EBA1000000B90000EBA20000EBA2000001620000EBA30000EBA3000001610000EBA40000EBA4000001210000EBA50000EBA5000001760000EBA60000EBA60000012A0000EBA7';
wwv_flow_imp.g_varchar2_table(76) := '0000EBA7000001380000EBA80000EBA8000000590000EBA90000EBA9000001BA0000EBAA0000EBAA000000430000EBAB0000EBAB000001090000EBAC0000EBAC0000008D0000EBAD0000EBAD000000C00000EBAE0000EBAE000000FE0000EBAF0000EBAF';
wwv_flow_imp.g_varchar2_table(77) := '000001190000EBB00000EBB0000001390000EBB10000EBB1000000290000EBB20000EBB2000001280000EBB30000EBB3000001200000EBB40000EBB4000000360000EBB50000EBB5000000370000EBB60000EBB6000000490000EBB70000EBB700000193';
wwv_flow_imp.g_varchar2_table(78) := '0000EBB80000EBB8000001B50000EBB90000EBB9000001AF0000EBBA0000EBBA000001AD0000EBBB0000EBBB000001AE0000EBBC0000EBBC000000AF0000EBBD0000EBBD000001520000EBBE0000EBBE000001550000EBBF0000EBBF000001180000EBC0';
wwv_flow_imp.g_varchar2_table(79) := '0000EBC00000006B0000EBC10000EBC1000001C80000EBC20000EBC2000001CA0000EBC30000EBC3000001C90000EBC40000EBC4000001990000EBC50000EBC50000019A0000EBC60000EBC60000019B0000EBC70000EBC70000019C0000EBC80000EBC8';
wwv_flow_imp.g_varchar2_table(80) := '0000019D0000EBC90000EBC90000019E0000EBCA0000EBCA000001980000EBCB0000EBCB000000110000EBCC0000EBCC000000520000EBCD0000EBCD000001230000EBCE0000EBCE0000009C0000EBCF0000EBCF000001C10000EBD00000EBD000000069';
wwv_flow_imp.g_varchar2_table(81) := '0000EBD10000EBD1000000D00000EBD20000EBD2000000DC0000EBD30000EBD3000000DB0000EBD40000EBD4000000DA0000EBD50000EBD5000000500000EBD60000EBD60000004F0000EBD70000EBD70000004E0000EBD80000EBD8000000140000EBD9';
wwv_flow_imp.g_varchar2_table(82) := '0000EBD9000000D10000EBDA0000EBDA000000AE0000EBDB0000EBDB000000B00000EBDC0000EBDC000000580000EBDD0000EBDD000000670000EBDE0000EBDE000001570000EBDF0000EBDF000000A30000EBE00000EBE0000000650000EBE10000EBE1';
wwv_flow_imp.g_varchar2_table(83) := '000000150000EBE20000EBE2000000C10000EBE30000EBE3000000C20000EBE40000EBE4000001260000EBE50000EBE50000001F0000EBE60000EBE6000000200000EBE70000EBE7000000FC0000EBE80000EBE8000000130000EBE90000EBE9000001B6';
wwv_flow_imp.g_varchar2_table(84) := '0000EBEA0000EBEA000001150000EBEB0000EBEB000000EC0000EBEC0000EBEC000000DD0000EBED0000EBED000000DE0000EBEE0000EBEE000000E30000EBEF0000EBEF000000E10000EBF00000EBF0000000E20000EBF10000EBF1000000E50000EBF2';
wwv_flow_imp.g_varchar2_table(85) := '0000EBF2000000E60000EBF30000EBF3000000E80000EBF40000EBF4000000EA0000EBF50000EBF5000000EB0000EBF60000EBF6000000E00000EBF70000EBF7000000DF0000EBF80000EBF8000001950000EBF90000EBF9000000CD0000EBFA0000EBFA';
wwv_flow_imp.g_varchar2_table(86) := '000001370000EBFB0000EBFB000000890000EBFC0000EBFC000000060000EBFD0000EBFD000000070000EBFE0000EBFE000000080000EBFF0000EBFF000000090000EC000000EC00000000E90000EC010000EC01000000E40000EC020000EC02000000E7';
wwv_flow_imp.g_varchar2_table(87) := '0000EC030000EC030000001B0000EC040000EC04000000C60000EC050000EC05000001040000EC060000EC06000001010000EC070000EC070000003A0000EC080000EC08000000190000EC090000EC09000000180000EC0A0000EC0A0000004C0000EC0B';
wwv_flow_imp.g_varchar2_table(88) := '0000EC0B000000B10000EC0C0000EC0C000000B20000EC0D0000EC0D0000015D0000EC0E0000EC0E0000004B0000EC0F0000EC0F000001600000EC100000EC100000016F0000EC110000EC11000000CF0000EC120000EC120000010B0000EC130000EC13';
wwv_flow_imp.g_varchar2_table(89) := '000001A20000EC140000EC14000001A40000EC150000EC15000000460000EC160000EC160000016B0000EC170000EC17000000A60000EC180000EC18000001BE0000EC190000EC19000000300000EC1A0000EC1A000001250000EC1B0000EC1B00000111';
wwv_flow_imp.g_varchar2_table(90) := '0000EC1C0000EC1C0000010A0000EC1D0000EC1D000001440000EC1E0000EC1E000000510000EC1F0000EC1F000000EF0000EC200000EC200000014C0000EC210000EC210000016E0000EC220000EC22000000820000EC230000EC230000007F0000EC24';
wwv_flow_imp.g_varchar2_table(91) := '0000EC24000001770000EC250000EC25000001660000EC260000EC26000000B60000EC270000EC27000000B40000EC280000EC28000000B50000EC290000EC29000001C00000EC2A0000EC2A000001BF0000EC2B0000EC2B000000440000EC2C0000EC2C';
wwv_flow_imp.g_varchar2_table(92) := '000001560000EC2D0000EC2D000001530000EC2E0000EC2E000000530000EC2F0000EC2F000000BA0000EC300000EC30000001030000EC310000EC31000001020000EC320000EC32000000BE0000EC330000EC33000001220000F1010000F101000000AC';
wwv_flow_imp.g_varchar2_table(93) := '00000000009400D400E801140132016C01A601E0021A022E02420256026A027E029202A602C802DE02FC034E03A803D4042A049004E0052E052E055C05AE05CA066A071E075E07E80806086E08E009980A4C0A920ABA0ACC0B140B260B380B4A0B5C0BA4';
wwv_flow_imp.g_varchar2_table(94) := '0BBE0BD00BDC0BFA0C260C540CB80CEE0D020D2A0D520DC00DF20E400E7A0E940EEA0F440F8C0FC60FEA107610A210C81126116011B411EA120E127C12DA132413D813FC1452147C148814FA154E15B81618167A16B016D416EC16FC170C1718172C173A';
wwv_flow_imp.g_varchar2_table(95) := '175E17DC17F61810185E18CE18FA190C1946199019C019DA1A021A1E1A341A661A881AAC1AE01AF81B781BA81BCE1C1C1C3A1C601C801CA41CDE1CFA1D1C1D4C1D7E1DAA1DCC1DF41E201E481E801ED81F5A1F8C1FA61FDE203C207E20E2213E217621C8';
wwv_flow_imp.g_varchar2_table(96) := '2230227822BE22FE2364238623B423C623E22466248424A024BC250A2548257C25AA261C268E27062752277C27FC282228A8293C29B82A402A8A2ACE2B622BA22BD82C0E2C4C2CEE2D682D8C2E262EA82EE62F302F442F8A2FAE2FDA301A3040309E30CE';
wwv_flow_imp.g_varchar2_table(97) := '3130316C319A31E032403270328E32DC3310333433A233F83434346434B2356A359C3602366A36BE3700372E3746375E377C37A437C837EA380838263844385C387A389238B038C838E0391A395639A83A423A823AA63B083B203B3C3BD23BEA3C0A3C3C';
wwv_flow_imp.g_varchar2_table(98) := '3CA03CBE3D103D3C3D6A3DB03DD63DF63E0E3E283E543E803EA63ED63F363F503FA63FDC40284052408E40C64106413A418A41BC41EA42244242428642AE4334436E43E844324516454E458045E6460A4658469846FA4752478E47D4482848A048F44946';
wwv_flow_imp.g_varchar2_table(99) := '495C498C49D24A0A4A224A4A4A6A4ACA4AFE4B884BE64C484C7A4CCA4CF64D5C4D8C4DB24E0A4E264E344EEE4F544F784FF2506E50B45124515C519451EC521A524A52DA5334539053EA54125436545A54B254D254F6554A55A655E056205646567A56B4';
wwv_flow_imp.g_varchar2_table(100) := '56FE575C578E57AC57E8587458DE595859BE5A1E5A945ACC5B065B605BD45C1A5C865D0E5DD45DF25E105EFE5F305F465F6C5FB65FFC601C604E609261226144617E61BE61E2620E6230626662FC6330635C63A2645A64846504654065AA65D2660C6682';
wwv_flow_imp.g_varchar2_table(101) := '66BE67026744678067C66812686A688E68D8697069C86BC86D7E6DAA6DCE6E3A6E626E8E6EA66ED46F266F546FA67044707E708E709E70AE70BE711E715E719E71E8722E729E72C87316739C7438746874BA74EC7528757E75C0760C762C769E76E27724';
wwv_flow_imp.g_varchar2_table(102) := '777E779E77DC780878627880794479B47A567ACE7B127B4E00040000FFFF012C012C0011002200340064000025342E01220E011514161F0116323F013E01072227373E0433321E01171617062726343E02321E02140E010706272E0117303D012E012726';
wwv_flow_imp.g_varchar2_table(103) := '27363736373627362E02220E0215141E0117161706070E0107152E0135343E01321E01151406012C28455245281C190D265C260E181C96292201030A0E10150A0F1D15060302225804080D1216110E08080E091314080E8704110C090B050407050A0101';
wwv_flow_imp.g_varchar2_table(104) := '0B141A1D1A130B06080804050A090C11051214233C483C231396294528284529213C150A1A1A0A153C6218070A110E0A050B150E0809188B0914120D09080E1215110E040808040E5B01010E180907050304070810140E1A140A0A141A0E0A130E080404';
wwv_flow_imp.g_varchar2_table(105) := '040709180F0112301A243C23233C241A30000000000200000000011A011A001A0028000025160E010734273E01372E030E010726233E0233321E0207220E01141E01323E01342E01230119011422160319220101101D231E1302090A03182515111F180C';
wwv_flow_imp.g_varchar2_table(106) := 'B217271616272E2717172717C5162518020A0903251A111E12010F1C11031522140C181F1A17272E271616272E2716000001000000000107011A000B000025152315233523353335331501077113707013A9137070137070000400000000011A011A000D';
wwv_flow_imp.g_varchar2_table(107) := '00120016001A00000123071517331517333735333735072335331507353315272315330110F409090A09CE0A09091CD7E1CFBC267070011909380A9F09099F0A382F2626A996967113000000000100000000011200CC000F000037170727353717073327';
wwv_flow_imp.g_varchar2_table(108) := '37171507273738280D38380D28BC280D38380D2883280D380D390E28280E390D380D28000003000000000107010700090016002300003717353315371707232737342E01220E01141E01323E0127140E01222E01343E01321E01652813260E380D38B01F';
wwv_flow_imp.g_varchar2_table(109) := '333E331E1E333E331F13192C322C19192C322C1994286C6A260D37370F1F331F1F333E331E1E331F192C19192C322C19192C00000003000000000107010700090017002400003727333523372707151737321E01140E022E023E011715220E01141E0132';
wwv_flow_imp.g_varchar2_table(110) := '3E01342E0194286C6A260D37370F1F331F1F333E331E011F331F192C19192C322C19192C652813260E380D38B01F333E331E011F333E331F0112192C322C19192C322C190003000000000107010700090016002300003717231533071737352707062E02';
wwv_flow_imp.g_varchar2_table(111) := '3E01321E01140E0127323E01342E01220E01141E0198286C6A260D37370F1F331E011F333E331F1F331F192C19192C322C19192CC72813260E380D38AF011F333E331F1F333E331E12192C322C19192C322C190000030000000001070107000900160023';
wwv_flow_imp.g_varchar2_table(112) := '00003F01153335173727230717140E022E023E01321E0107342E01220E01141E01323E01652813260E380D38B01F333E331E011F333E331F13192C322C19192C322C1998286C6A260D37370F1F331E011F333E331F1F331F192C19192C322C19192C0000';
wwv_flow_imp.g_varchar2_table(113) := '0001000000000104010700090000371733372707352315273B5E0D5E0D4E134E835D5D0E4EC4C44E000100000000010700F30009000037071517372733352337835D5D0E4EC4C44EF25E0D5E0E4D134E000100000000010700F1000900003F0135270717';
wwv_flow_imp.g_varchar2_table(114) := '23153307A95E5E0E4EC3C34E285D0E5D0D4E124E00010000000000C900E10009000037072327371735331537C92F0D2F0D1F131F8A2F2F0D1E68681F00010000000000D100CF00090000372735371707331523177A2F2F0D1F69691F632F0D2F0D1F131E';
wwv_flow_imp.g_varchar2_table(115) := '00010000000000D100CF0009000037171507273723353327A22F2F0D1E68681ECE2F0D2F0E1E131F00010000000000C900E1000900003F0133170727152335075E2F0D2F0D1F131FB22F2F0D1F69691F000200000000011A011B00090013000037273537';
wwv_flow_imp.g_varchar2_table(116) := '1707331523173F0135270717231533074F3C3C0D2CE9E92C813C3C0D2CE9E92C123C0D3C0D2C132C763C0D3C0D2C132C00010000000001040107000900002527230717371533351701045E0D5E0D4E134DA95E5E0E4EC3C34E000000000200000000011A';
wwv_flow_imp.g_varchar2_table(117) := '011A0007000F000025150727152717351727150F01151735011941663AA8015E561A25E8A03525254B0D900139251A214B1161000003000000000122011A001B00270036000025272E01072322060F01061E023B0132363F0117163B01323E0207222F01';
wwv_flow_imp.g_varchar2_table(118) := '3337171C010E01233323362F01331E011517160E022301204B020A0758060A024C020205090537050A020C38050658040905026B02026C39142A020401574502024C4502044C01010202022CE10508010705E1050908030706212B03040709080150347D';
wwv_flow_imp.g_varchar2_table(119) := '010303010607E1010202E10103020200000400000000011A011A001D002C0035003D00003733262723373334372337353315173637273533352315331507061E02373633321E0215140E012E02361716173237270615143717363534262322385E0B084B';
wwv_flow_imp.g_varchar2_table(120) := '1D1B021324260109090113701249020105087212170F1C150B192A2D200912141117120F4F0A184E0B21181213080A390909484E4F030402014B13124B8E05090904890D0C151B0F17261109202C2A5910010B4E0E1218464F0F12172100000000030000';
wwv_flow_imp.g_varchar2_table(121) := '0000010A011A000F0016001A00002527353335231533150706163B01323627373533151723073733170104481270134A040B0ABC0A0B880226246E271D821D2E8D4B13124B8E0A111190044E4F474B3939000000000300000000011A011B002A0031003A';
wwv_flow_imp.g_varchar2_table(122) := '000037062315141F012337363D01343E02173336372627260E021D01140F0117331416323635333727263507323627231416373236342622061416F4090A0807B507090D171F0F030507060714261D10070B0842161F1642090B075E070C01250B531721';
wwv_flow_imp.g_varchar2_table(123) := '212E21219802041A191415191929101E150A0209070201020D1B2414291616210D0F16160F0D2116166D0B08080B84212E21212E21000000000600000000012A012600150027002E003300380041000013060722070E021D01140F0137363D01343E021F';
wwv_flow_imp.g_varchar2_table(124) := '010607161F012307331416323635333727260706222635331637262737170F01173726173236342622061416A20A07090A0F170D041C0607101D261455090A0206077A120C161F1642090B0652060F0B25017506070B0D82940D9507331721212E212101';
wwv_flow_imp.g_varchar2_table(125) := '18080A0305151E102911111D1316162914241B0D02910301131214130F16160F0D21114C060B0808DD07070A0D67950D950601212E21212E21000000000400000000012A012600150027002E00320000132627260E021D01140737363D01343E02171617';
wwv_flow_imp.g_varchar2_table(126) := '073327263D013715141F01072314062226271732362723141607011701CF151B14261D100719010D171F0F14103D6C070813070B0942161F150126070C01250B7B01090DFEF701051004020D1B241429161519090929101E150A02030CAC14191A161329';
wwv_flow_imp.g_varchar2_table(127) := '1616210D0F16150F120B08080B0901090DFEF7000003000000000106011B001A00210034000037263D01342E0227260E021D01140F01173314163236353337070622263533162737363D01343E021716171E011D01141F01FB070C181F1214261D10070B';
wwv_flow_imp.g_varchar2_table(128) := '0842161F16420963060F0B25016E07090D171F0F1E13090A08076615172612211B1102020D1B2414291715210D0F16160F0D1A060B08081B15181A29101E150A0204160B1B0E261A1914000000030000000000E100F4000E0016001E0000373533321615';
wwv_flow_imp.g_varchar2_table(129) := '1406071E011514062327153332363534232733323634262B015E3F1F20100D1012221E2A2A1214252B27101412132638BC1A180D1505041811191D584412102214101D0E000900000000011A010700100017001E00220026002A002E0032003600000123';
wwv_flow_imp.g_varchar2_table(130) := '0F012F012307151733173337333735072F012335331F01230F01353733072315331523153327331523372315330733152315331523011067070C0C0767090963100E1063098C04065D590E7A5E07020D5A9639393939393939BC38383838383838010703';
wwv_flow_imp.g_varchar2_table(131) := '0C0C030ABB0A10100ABBB80303A90E9B0302A10D26123912381338121313131200020000000000F4011A0008000E0000132307151737173735072723073533EAA80A114D4D1113440E4496011909F406565606F4DB4B4BD2000300000000011A01070047';
wwv_flow_imp.g_varchar2_table(132) := '0071007D0000373123220E021D01140E02071E031D01141E023B011523222E012731262735263735342731262735262731262B013533323E013731363D012637313637313E023B0117333523222731262735262731263D013627352627312E022B011533';
wwv_flow_imp.g_varchar2_table(133) := '321E021D01141E0217231607220E011E023E013534267102060A0704020407050507040204070A06020209100D0303010101020204030505060101060A07020201010103030D1009029402020605050304020201010103030D10090101060A0704020407';
wwv_flow_imp.g_varchar2_table(134) := '05010F17111C0D0618221F1321F404080A0619060C0B080404080B0C0619060A080412060D0808070108081006050503010302031205070505061008080808080D077A120302030103050506100808010708080D071304080A0619060C0B08040211131F';
wwv_flow_imp.g_varchar2_table(135) := '2218060D1C111721000400000000011A010700470071007E008A0000373123220E021D01140E02071E031D01141E023B011523222E012731262735263735342731262735262731262B013533323E013731363D012637313637313E023B01173335232227';
wwv_flow_imp.g_varchar2_table(136) := '31262735262731263D013627352627312E022B011533321E021D01141E02172316073633321615140E012E02361707270717071737173727377102060A0704020407050507040204070A06020209100D0303010101020204030505060101060A07020201';
wwv_flow_imp.g_varchar2_table(137) := '010103030D1009029402020605050304020201010103030D10090101060A070402040705010F360E111721131F2218060D4215150E16160E15150E1616F404080A0619060C0B080404080B0C0619060A080412060D080807010808100605050301030203';
wwv_flow_imp.g_varchar2_table(138) := '1205070505061008080808080D077A120302030103050506100808010708080D071304080A0619060C0B0804021A092117111C0D0618221F0216160E15150E16160E1515000500000000011A0107000D0011001B001F0029000025233527230715230715';
wwv_flow_imp.g_varchar2_table(139) := '1733373527331523171507352723071527351715233507351715173337353715011042095E09420909F409A84B4B964B0A38094B83265D4B09380A4BE11C0A0A1C09960A0A961C13130E2A090A0A092B0D3813134B602B060909062A5F00000000040000';
wwv_flow_imp.g_varchar2_table(140) := '00000107011A0022003F005B00640000133633321E01170E01073531363D013E0226272E010E021617151417152E02361706231514062B013023312E013D0122263D0134363B0132161D011407371407161D013E0226272E010E021617353437263E021E';
wwv_flow_imp.g_varchar2_table(141) := '0107231406222634363216581C221F331E0101292109111709070A11363928091A19091E28081B72020405041401040404050B0812080B03190906090B010B090D24231A090B0D060901141E1E13011E0B100B0B100B0106131E341E243A0C01090B0309';
wwv_flow_imp.g_varchar2_table(142) := '2026271019150C2B3A350E030C08010B31403AA7032F04050104042F050426080B0B082604025B0F0D090A0209191C19090E0A0A1A24230D020B090D1F1A090B1910080B0B100B0B000300000000011A011A0007000B000F000013331715072327351715';
wwv_flow_imp.g_varchar2_table(143) := '3335273335231CF40909F40913E1E1E1E1011909E10909E142969613260000000003000000000118011A00310039004900003735342622061D012327071707061D0123153B01161F01071737171E0132363F011737273536373133352335362F01372707';
wwv_flow_imp.g_varchar2_table(144) := '2335343632161D0117151615140E02222E0235343735CC202D20101F0B1E0109262801040D01250B23020C1F221F0C01240B250E052927010A011E0B1F6D1720171D090D161B1D1C160C08D80B162020160B1F0B1E011A1B0C101B1501250B23010E100F';
wwv_flow_imp.g_varchar2_table(145) := '0E01240B2601161B100C1B1A011E0B1F0B101717100B1001161917271C0F0F1C2717191601000000001100000000011A011A000F00130017001B001F00230027002B002F00330037003B003F00430047004B004F00000123352315233523152307151733';
wwv_flow_imp.g_varchar2_table(146) := '37350723353335233533072315330733152317231533373315231723153307331523372315331733152317231533073315233723153317331523172315332733152301101C1396131C0909F40912E1E1E1E1BC1313131313131313261212121212121212';
wwv_flow_imp.g_varchar2_table(147) := '1212122613131313131313131313132513131313131313130107121212120AE10909E1D7A813135E13121313135E131213131384131313121313138413131312135E1300000300000000011A011A003D007900820000372E010E010F0206262F0126272E';
wwv_flow_imp.g_varchar2_table(148) := '023F023E023534272E0323220F010E0215141E0633323E013F01363534262F01262F012607062722262726272E0335263E013F013633321F01161F0116140F010E0214161F0116333237363F013E01321F02161F011615140F010E013707331523353315';
wwv_flow_imp.g_varchar2_table(149) := '37EB050B0A07030605030802290B0B04060103040703060308050B0C0D080C080E0509030A11181C202221100A110D060E0803030704040F040D07080E1E0E1F1A0D161009010406050B03040204070A070603020B040504040545090C05050906060206';
wwv_flow_imp.g_varchar2_table(150) := '0504070905030603040A050A2F573E5E13577D02010505040604030103270B0C050805030506030709060C09050C0B08080E060D110A0F2221201C19110A0408050E080C050A040804040E045402010907121A0D1C1E1E0F070E09050A04030608090704';
wwv_flow_imp.g_varchar2_table(151) := '05030B03070A0B0A054509020407060304030608040508030204030B0407E357135E3E57000300000000011A011A00080044008000003F012335331523350717321F031E0115140F010E0223222E0635343E013F013633321E02171615140E010F020614';
wwv_flow_imp.g_varchar2_table(152) := '1617161F011E013F023E0207323E013F013627362F01262F022622060F010E0223222F012E01343E023F0136342F042623220F010E02071E031716171E01A2573D5D1258310C090F08070303080E050E110A102221201C18110A0308060E080C070E0D0A';
wwv_flow_imp.g_varchar2_table(153) := '050803060307040206040B0B29020803050603080906090C0A050A040101030603050907040506020603070A050C094505040405070305020306080907040204030B04070301010910160D1A1F0E1EAF58125D3D5723080E0808040A050C080E0508040A';
wwv_flow_imp.g_varchar2_table(154) := '12181C202121100B100D060E08080B0D04090C050908030605030508050C0B2703010304060405055A0306050B030402030805040806030403060405040945040B0C09070603050305040709080603040A040B0D070E1F1E1C0D1A110809000000040000';
wwv_flow_imp.g_varchar2_table(155) := '0000010200E10007000F0024002F000037232723072337331727262723060F01172335310623222635343F013423220735363332150F010E0115141633323635A6130F3D0F1237111016010101010117B6110B150F12221F15120F0F142411180C0C0B09';
wwv_flow_imp.g_varchar2_table(156) := '0C1051282890593E030606033E371013100E1D05041A0C100A260F0401080B070A110D00000400000000012500F40006000A000C00130000250723273717370737270F0117071707232737170125920E3A0E348B90520D50120A290B0F0E3A0E34E9AD53';
wwv_flow_imp.g_varchar2_table(157) := '0A49A46D620B5E160F150F11530A4900000100000000010F00FA0006000025072F01371737010F9F0F3F0F3897EEBC01590B4FB2000800000000011A01070006000A000E00120016001D0024002B00003723273717371F01331523153315231723153307';
wwv_flow_imp.g_varchar2_table(158) := '331523273337270727071723273717371707333727072707460D130D0D1A0E1B969696969696969696964A0D220E1A0D0D200D130D0D1A0E2F0D220E1A0D0DD8140D0D1B0E051325132612261368210D1A0D0E4C140D0D1B0D5A210D1A0D0D0000010000';
wwv_flow_imp.g_varchar2_table(159) := '000000F300C1000600003F01170723273796510C580B580C6F520C57570C000000010000000000C100F400060000371707273537176F520C57570C96510C580B580C000000010000000000CF00F30006000037273717150727BD520C57570C96510C580B';
wwv_flow_imp.g_varchar2_table(160) := '580C000000010000000000F400CF000600003707273733170796510C580B580CBD520C57570C00000002000000000107011A0037003B00001333153335331533353315331715331523153315231533152315072315233523152335231523352327352335';
wwv_flow_imp.g_varchar2_table(161) := '333523353335233533353733073335235E1312131313121326262626262613121313131213131325252525252513131383830119252525252513131213131312131325252525252513131213131312131396830000010000000000FD00FD000B00003707';
wwv_flow_imp.g_varchar2_table(162) := '17371737273727072707855511555511555511555511965511555511555511555511000000020000000000F400F4000300070000371533350723353338BC139696F4BCBCA99600000001000000000107009600030000251523350107CF96131300030000';
wwv_flow_imp.g_varchar2_table(163) := '0000010700F4000300070011000037153335072335332733353315231533352338A91383837013831326A9CEA8A8968412138313A900000000010000000000E200E2001900003732171E01171614070E01070622272E01272634363736373E01960A0A13';
wwv_flow_imp.g_varchar2_table(164) := '1C050303051C130A140A131C050305050A110913E103051C130A140A131C050303051C130A141309110A0505000100000000011A011A001A00001332171E01171614060706070E01222E0434363736373E0196121121310A040909111E0F2124211E1811';
wwv_flow_imp.g_varchar2_table(165) := '090909111E0F210119040A31211124210F1E1109090911181E2124210F1E110909000000000200000000011A011A002A00440000132622073106070607310E01161716171E023E01373136373637313626273126273126273126273126271706070E0122';
wwv_flow_imp.g_varchar2_table(166) := '2E0434363736373E0132171E0117161406B40F1E0F0E0D190F0808010308150B191D1F1C0D190F08030501040308070B0A0C0D0E53111E0F2124211E1811090909111E0F21241121310A04090102050503080F190D1D1F0E1C160A0F080107080F190D0E';
wwv_flow_imp.g_varchar2_table(167) := '0F1F0E0E0D0C0A0B070803AE1E1109090911181E2124210F1E110909040A312111242100000300000000011A011A000C0016001F000013321E01140E01222E01343E0107141617372E010E011533342627071E013E0196243C23233C483C23233C4C0D0D';
wwv_flow_imp.g_varchar2_table(168) := '9F19423B24E20E0D9F19423B240119233C483C23233C483C23831425109F15091C37211425109F15091C370000010000000000BC00BC000800003714062E0134363216BC1620151520169610160115201616000000020000000000BC00BC000A00170000';
wwv_flow_imp.g_varchar2_table(169) := '370E012E023E01321614173635342623220E011E0236A6040A0B080204090E0B0C0716100B1309041116158C050402080B0A070B0E0F0A0B10160D151611040900030000000000E100E2000C00150016000037323E01342E01220E01141E013714062226';
wwv_flow_imp.g_varchar2_table(170) := '34363216279614231414232823141423451D281D1D281D314B142328231414232823144B141D1D281D1D2000000500000000011A011A00070034003D0046004F00000123071517333735072335331E0133323634262206152315233533150E0115141632';
wwv_flow_imp.g_varchar2_table(171) := '36353314163236342623220607232E012335330734363216140622262732161406222634363332161406222634360110F40909F40912A92B04120A0F16161F16382525080B161F1626161F1616100A11053005110AA9710A110B0B110A38080B0B110A0A';
wwv_flow_imp.g_varchar2_table(172) := '79090A0A110A0A011909F40909F4EA25080B161F16160F38E12C041209101616101016161F160A09090A26A9080B0B110A0A790A110A0A110A0A110A0A110A00000500000000011A00F4000B000F00130018001C00003717371737273727072707172721';
wwv_flow_imp.g_varchar2_table(173) := '352115213521173523153315352315BC0D1E1E0F20200F1E1E0D1EC70106FEFA0106FEFA96969696400D1E1E0D1E1E0F20200F1E83134B1342091239131300000004000000000116011A00160022002C0036000037233533153335272335233426220615';
wwv_flow_imp.g_varchar2_table(174) := '23152307151733353E021E01140E012E021707352315270717333727331707271523350727833896130A1C12162015141B0A0A4101090B0A07050A0B0805861413140E250D247C0D250E1413140D26A8252F09130F16160F1309BC09E5050902040A0A0A';
wwv_flow_imp.g_varchar2_table(175) := '0501060AAC146464140D24245B240D146464140D00040000000001070107000B001900200024000037270727071707173717372F013733171507231507232735373B02171533352317231533A20E1A1B0D1B1B0D1B1A0E1B291383131326128412122613';
wwv_flow_imp.g_varchar2_table(176) := '4B1226834B8484940E1B1B0E1A1B0D1B1B0D1B7A131383132612128412124B833884000000010000000000E800E8000B000037173727372707270717071796440E45450E44440E45450E89450E44440E45450E44440E0000000200000000011A00F6002F';
wwv_flow_imp.g_varchar2_table(177) := '0039000037331E0114062335323634262723272E02060F0127262722070E011E013B0115232226272E013E013736173E011E0107173533153717072327E001172121170F15150F110202171F1B0606100505140D0A060B180E09090E1A090C070B1B110E';
wwv_flow_imp.g_varchar2_table(178) := '0E09262B1F5F1813180D280D28BC01202F2113161E1601100F1605100E0E0301010E0A1C1A10130B0B0D2322170303041416061F76186665170D2828000200000000011A00F60032003C000037331E0114062B013533323634262723272E02060F012726';
wwv_flow_imp.g_varchar2_table(179) := '2706070E011E013B0115232226272E01373E02173E011E011707271523350727373317E0011721211725250F15150F110202171F1B0606100505140D0A060B180E2F2F0E1A090F040B07171C0E09262B1F031F1912180D280D28BC01202F2113161E1601';
wwv_flow_imp.g_varchar2_table(180) := '100F1605100E0E030101010D0A1C1A10130B0B102B120C1105041416061F1648196665180E282800000200000000011A00F60015002E000037331E0114062B012226272E013E013736173E011E010733323634262B01272E02060F0127262722070E011E';
wwv_flow_imp.g_varchar2_table(181) := '0133E001172121178C0E1A090C070B1B110E0E09262B1F7F8310161610110202171F1B0606100505140D0A060B180EBC01202F210B0B0D2322170303041416061F73161F16100F1605100E0E0301010E0A1C1A10000700000000011A011A00030007000B';
wwv_flow_imp.g_varchar2_table(182) := '000F0013001700270000133315233733152317331523153315231533152307331523270715333533152335231517333735275E1313254B4B264B4B4B4B4B4B264B4B5D1313E1E11313E112120107CFBC131312131313121313CE125E5ECF71711212CF12';
wwv_flow_imp.g_varchar2_table(183) := '000300000000011400F40006000D001100003707170727353733071707173735071737275831310D3838910E32320E38B8115E11C331320D380D390E31320D380D6008BB09000000000600000000012C011A0015002B00410053005D0065000013151416';
wwv_flow_imp.g_varchar2_table(184) := '17331617161D01233534262F012627263D013315061617331617161D012335342627352627263D013315141617311617161D01233534262F012627263D01073733321614062B010E012B01222E013D011735231514163B01323637153316363426233807';
wwv_flow_imp.g_varchar2_table(185) := '08010A0408130708010A04084C010708010A04081306090A05074B06090A0507120708010A04087012C5141B1B140C06281A38152215BCA9211739172113090C10100C01190906080708050A0C0A0A0608060107060A0C090906080708050A0C0A0A0608';
wwv_flow_imp.g_varchar2_table(186) := '060107060A0C090906080708050A0C0A0A0608060107060A0C0970131C271B191F1422143938383818212150380111171100000000040000000001070107000300110018001C000037231533273733171507231507232735373B02171533352317231533';
wwv_flow_imp.g_varchar2_table(187) := 'A95E5E4B13831313261284121226134B1226834B8484831283131383132612128412124B83388400000200000000011A011A000C0014000013220E01141E01323E01342E010735321E01140E0196243C23233C483C23233C241F331F1F330119233C483C';
wwv_flow_imp.g_varchar2_table(188) := '23233C483C23F3E11F333E331E000000000A00000000012C011A0007000B00130017001F0023002B002F0033003D00001307151733373527073533150F011517333735270735331507373317150723273715333537071517333735270723353315233533';
wwv_flow_imp.g_varchar2_table(189) := '272315330717373527071C0909380A0A2E252F0909380A0A2E253809380A0A380913259F09093909090A252525256E3A3A130D22220D011909380A0A3809382626250A380909380A3926262F0A0A3809092F25258309710909710938265E251313120C22';
wwv_flow_imp.g_varchar2_table(190) := '0D220D00000300000000011A011A0012001E002700003F01150727352327353733171523352315331F02373533373527230715173723353315230715274B1316101C0909E10A13CE1C097623101C09099609094B42841D091658131B15072F0996090954';
wwv_flow_imp.g_varchar2_table(191) := '4B84094222061C0A5D0A0A5D0A134B4B090F1500000A00000000011A01070006000A000E0014001800230027002D003100380000012315331533352733152327331523171D013337350735231527230F0135272315173733373523150735231517333D01';
wwv_flow_imp.g_varchar2_table(192) := '23153715233537331501101C13127025254B2525A909093825260907280A091036058312E113090A131313091C010612131C09121212841213091C251313130328210A4207364B252538121C094B25255E131C0912000000000200000000011A01070017';
wwv_flow_imp.g_varchar2_table(193) := '002300001333171526273523153317153F013306152307273523273517220E011E023E013534261CF409080AE12E0A28070B020536102F09CE111C0D0618221F132101070A80090668960A212803090A36072F09A97A131F2218060D1C11172100020000';
wwv_flow_imp.g_varchar2_table(194) := '0000011A0107000B0014000001230715173315173733373507230F0135272335330110F409092F10367F09127A07280A2EE101070AA9092F073609A99F0328210A96000000050000FFFD012D011A002C003200360043004A00003706233523152E022733';
wwv_flow_imp.g_varchar2_table(195) := '35233E02371533351E02172315330716173635342E01220E01141E0133323726372F011F01062F021F013617321615140E012E023617372707270717AB0606121B2E1C021212021D2D1B121B2E1C02121201090803233C483C23233C240E0D040D37264C';
wwv_flow_imp.g_varchar2_table(196) := '1B060D122412470F111721131F2218070D2E220F1C100C1827011212021D2D1B131B2D1C021212021C2E1B120C02040D0E243C23233C483C2303084A1B4C2637040D241224260A012018111C0D061921203F2D0B250E0F13000400000000012C011A002C';
wwv_flow_imp.g_varchar2_table(197) := '00320036003F00003706233523152E02273335233E02371533351E02172315330716173635342E01220E01141E0133323726372F011F01062F021F011416323634262206AB0606121B2E1C021212021D2D1B121B2E1C02121201090803233C483C23233C';
wwv_flow_imp.g_varchar2_table(198) := '240E0D040D37264C1B060D1224122F202F21212F2027011212021D2D1B131B2D1C021212021C2E1B120C02040D0E243C23233C483C2303084A1B4C2637040D241224551721212F2121000000000400000000011A011A0003000700230030000037172F01';
wwv_flow_imp.g_varchar2_table(199) := '172F0117330E02073523152E02273335233E02371533351E0217231507323E01342E01220E01141E01A9264C265412241279021C2E1B121B2E1C021212021D2D1B121B2E1C02125E243C23233C483C23233CA94C264C542412241B2E1C021212021D2D1B';
wwv_flow_imp.g_varchar2_table(200) := '131B2D1C021212021C2E1B127A233C483C23233C483C23000006FFFF0000012C010B000C0018004E00670071007B00003732161D01140622263D01343617342622061D01141632363527161737361716171615140717331E011D0114070E010F01060706';
wwv_flow_imp.g_varchar2_table(201) := '070622272627262F012E0127263D013436373337263534373637360F0115171617163237363F013527062322272627060706232237260E011416323637363706171E013236342E01750608080C080856080C08080C0832020103112623100D0503010E0F';
wwv_flow_imp.g_varchar2_table(202) := '030207070B06070C0D2952290D0C07060B070702030F0E0103050D1023264901010A0C2446240C0A01010C142112060404061221143A08300F0C2A13020327070302132A0C0F307109061C060808061C06090F060909061C06080806B201020313050413';
wwv_flow_imp.g_varchar2_table(203) := '111E130C1007190E1805060309050805040705121205070405080509030605180E1907100C131E111304058202500106050F0F05060150020613060808061362080513280E14141608081614140E2813050000000003000000000107011A0007000C0013';
wwv_flow_imp.g_varchar2_table(204) := '00003F013317150723273727231533270715173533274B136544139613A9385E96BC12127913E113438B13138338BBF312BC13CF12000000000400000000010700F40006001B002800360000370F0127371737173E0135342E0123220726233633321E01';
wwv_flow_imp.g_varchar2_table(205) := '1406073607222E01343E021E020E0107323E01342E01220E01141E0117A72F0E1C0D152849090A121E120D0C0D0F171E17271719140565121E12121E241E1101121E1217271616272E27161627179038011C0E15302B09180D121E1205051317272E280B';
wwv_flow_imp.g_varchar2_table(206) := '0E2B121E241E1101121E241E121216272E271616272E271601000000000400000000011A00E2000300070017001B00002515233515331523372322061D0114163B0132363D013426073315230107E1E1E1E1E1080B0B08E1070B0B402626CE1212255E96';
wwv_flow_imp.g_varchar2_table(207) := '0B0883080B0B0883080B701300010000000000CF009600030000373315235E70709613000006000000000109011C000C001C00280030003A00480000133E011E020E022E0236171633323E0135342E020E021E01371707160E012E023E01170716363426';
wwv_flow_imp.g_varchar2_table(208) := '0E0116370716151407173E012F012623220E01141707263E0217491B413B24041D36413A25041C261A201C2F1C1625302E24130318820D28040511140F020C140A12050A07080401540F05090E0C030A340B0C121E12090D100326381A010512041D3641';
wwv_flow_imp.g_varchar2_table(209) := '3B24041C37413AA8121C2F1C192A1E090C202D2F2A8A0D2909140C020E151105042103040B050107072B0E0B0D120F0E132E141705121E240F0E18392B0C0D0000030000000000F4011A001300240035000037342E01220E0115172315171E0132363F01';
wwv_flow_imp.g_varchar2_table(210) := '35232732171E011406070622272E013436373617070E01070622272E012F013516371637F4192C322C19010101043548350401015D151310131310132A131013131013600101130F122A120F13010123282823EA0D160C0C160D02A6071117171107A61E';
wwv_flow_imp.g_varchar2_table(211) := '05040E0A0D040505040D0A0E0405C403050C040505040C05038C140101150000000500000000012801070025002C0035003F0046000037072E0122060727071707152315331516170717371E013236371737273637353335233527372732161523343617';
wwv_flow_imp.g_varchar2_table(212) := '0E01072E01273533270715333517071537350735372735171589110419201904110D160313130104180D150716181607150D180401131303164B0C1038103202150F0F15014B2A0F138E304747698FA583100F14140F100D16021313010909180D150A0B';
wwv_flow_imp.g_varchar2_table(213) := '0B0A150D18090A01121302160D100C0C104B0F150101150F1CB30856445F20172F106416465F176E10000000000400000000011601070025002C0035003F000037072E0122060727071707152315331516170717371E0132363717372736373533352335';
wwv_flow_imp.g_varchar2_table(214) := '273727321615233436170E01072E012735332737171507353727152389110419201904110D160313130104180D150716181607150D180401131303164B0C1038103202150F0F15014B130EA96C568E1383100F14140F100D16021313010909180D150A0B';
wwv_flow_imp.g_varchar2_table(215) := '0B0A150D18090A01121302160D100C0C104B0F150101150F1CAB0871104817395F4400000004000000000129012C0025002C00350040000037072E0122060727071707152315331516170717371E01323637173727363735333523352737273216152334';
wwv_flow_imp.g_varchar2_table(216) := '36170E01072E01273533371507353727152627353789110419201904110D160313130104180D150716181607150D180401131302154B0C1038103202150F0F15014BB8806AA2090A0E83100F14140F100D15031313010909180D150A0B0B0A150D19080A';
wwv_flow_imp.g_varchar2_table(217) := '01121303150D100C0C104B0F150101150F1C6010511643677606037E0800000000040000000000E300E3000C0018001C00200000373E011E020E022E0236171E013E022627260E011637231533152315336C1128241702122128241603121D0C1C190F02';
wwv_flow_imp.g_varchar2_table(218) := '0D0B122918084A38383838D40C02112228241702122128245E08020C171C19080B08232A3B13121300030000000000E100E2000C00100014000037220E01141E01323E01342E0117152335371523359614231414232823141423124B4B4BE11423282314';
wwv_flow_imp.g_varchar2_table(219) := '14232823145E12123913130000020000000000E600E10005000B0000372307173337072327373317BA562C2C562C3A3A1E1E3A1DE14B4B4B3333333300010000000000E600E100050000370723273733E52B562C2C56964B4B4B000000020000000000E1';
wwv_flow_imp.g_varchar2_table(220) := '00E10002000500003733270733274B964B2346235E836C3D00010000000000E100E100020000371723964B96E181000000020000000000F400F40003000700003F01170735372707395D5D5D343434965E5E5D293435350000010000000000F400F40003';
wwv_flow_imp.g_varchar2_table(221) := '000037170727965E5E5EF45E5E5E000000030000000000E300E3000C001000140000373E012E020E021E02362723153327353315D40C021122282417021122282427171717176C1128241702112228241702111613254B4B000500000000011C011C0015';
wwv_flow_imp.g_varchar2_table(222) := '001E0044004C005600001337331F02150F012B013534273335231526233D011707262F01372737170737170717153315231506071707270E0122262707273726273523353335372737173E013216072E010E011533340736373523151E0117365802B101';
wwv_flow_imp.g_varchar2_table(223) := '0F01010F015C0760AC090A86230202061C2D0A3457110D150213130104180D150716181607150D180401131303160D1104192019150611100938020A014A01150F0F011B01010F01B1020F020A07AC5B025C0167230303051C2E0A333B100D1503131201';
wwv_flow_imp.g_varchar2_table(224) := '0A09180D150A0B0B0A150D19080901131303150D100F1414070603060E090C540A0F1C1C0F150101000300000000010C010700030009000C0000132315333707151737350F01354B13133E0F0F8316690107E1D507BC075D10084C98000300000000010F';
wwv_flow_imp.g_varchar2_table(225) := '010700030009000C0000133315233707151737350F01352F1C1C5C161684215D0107E1D90BBC0B5E160B4284000300000000011601070009002E003800003F011715073537271523170E011D01140E022B01222E023D01342E0235343E04321E04151406';
wwv_flow_imp.g_varchar2_table(226) := '07231514163B013236355E0EA96C568E13150506020305031003050302060B070306080A0C0C0C0A080604071C160201100102FF0871104817395F4460050D0710030503020203050310070D0B100A060B0B0806030306080B0B060A1019160102020100';
wwv_flow_imp.g_varchar2_table(227) := '0004000000000111011A0011001F00370044000037262737270726272607060F01173736373607060F012737363736171E011716073727072737270727070E011416170717371E0132363F010706222E0235343F01170706FF0305190B1A070914140B08';
wwv_flow_imp.g_varchar2_table(228) := '1D511D090408170306123A1206071010070B0406611C0C1B231C0C1C0B1D09080506190B1A07121515081D3608100F0C060C123A1206E409071A0B190602070804091D511D080B140E0706123A1206030606040B07106E1D0C1D231D0C1D0B1D08151511';
wwv_flow_imp.g_varchar2_table(229) := '08190C19050609081D1A04070B0F08110C123A1205000000000600000000011A010000030007000B000F0015001800003735331527331523371523351D01333525371715072737153771A85D5D5D5DA8A8FEFA0E65650E134A7112124B134B1313A91313';
wwv_flow_imp.g_varchar2_table(230) := 'AD07430F440875633100000000020000000000D800F40003000700003733152337152335541D1D841CF4BCBCBCBC000000020000FFFD01160107001A0024000037140E012627071E013E022E010607352315173335233E011E0127371715073537271523';
wwv_flow_imp.g_varchar2_table(231) := '8619272308120A2D3223071A2F310F13092C180A232517280EA959438E134B141F0812120717190725322C130D1417320A13110E0A1EA10871103B162D5F4400000500000000011C00F400040009000E0012002D00003735330607373637231517262723';
wwv_flow_imp.g_varchar2_table(232) := '152515213517323E012E010607331523273533153E011E010E022627371E011361020117090B89690503610106FEFAC7121A0611212009142508100D2A2716061E2A25090F061771120909380A081271090A13BC1313BC16221E0C0C0F10082A13110B11';
wwv_flow_imp.g_varchar2_table(233) := '242B1E071514060D0F000000000100000000010C010D001D000037140E012627071E023E0235342E010607352315173335233E011E01EF263A350C1A0A28323329172A4445161C0E41230E353723961E2E0D1B1C0B18210D0A202F1A243B17151C224B0E';
wwv_flow_imp.g_varchar2_table(234) := '1C19160F2D00000000030000000000FE010700030009000C0000132315332717150727351F0135FD1C1C5C161684215D0107E1D90BBC0B5E160B42840003000000000110010700080012001700003714062E0134363216332F0123071517333F01072335';
wwv_flow_imp.g_varchar2_table(235) := '3317BC1620151520165450115F18185F1150615F5F4F9610160115201616590818B21708594AB259000200000000011001070009000E0000252F0123071517333F010723353317011050115F18185F1150615F5F4FA6590818B21708594AB25900020000';
wwv_flow_imp.g_varchar2_table(236) := '000000FC01000005000800003F011715072737153750169696161C6EF40B6417640CAD934A000000000200000000010C010C001700200000373533153E0133321E011F0123352E0222060733152327172226343632161406211C10301B1D342002011D02';
wwv_flow_imp.g_varchar2_table(237) := '18272E290B354E1275101515201616C04B2F13161B2E1C050414221416131C12901520161620150000020000000000EA011A000A00130000373337270735231527071F011406222634363216960A4914311C3114492F161F16161F167949143174743114';
wwv_flow_imp.g_varchar2_table(238) := '494110151520161600020000000000EA011A000A001300001323071737153335173727171406222634363216960A4914311C3114491B161F16161F1601194914317474311449E1101515201616000000000200000000010C010C00170021000025352315';
wwv_flow_imp.g_varchar2_table(239) := '2E0123220E010F0133353E0232161723153337073236342E0106141633010B1C10301B1D342002011D0218272E290B354E127510161620151510C04B2F13161B2E1C050414221416131C12901520150116201600000200000000010701070007000B0000';
wwv_flow_imp.g_varchar2_table(240) := '131715072327353717231533F41313BC1212B7B2B2010713BC1212BC1318B200000500000000012B012C0001000D004100490059000037351727371737170717072707273715333717071516150733152331060F01170727070E0122262F010727372726';
wwv_flow_imp.g_varchar2_table(241) := '272B013533353437352737173335343E01321E010715333534262206173523070615141E02323E0235342B5B260D28270D26260D28270D7410240D220C012C2E060F012B0D29010E2426240E01290C2A010F05012E2C0B230D2412101D221D116B591A25';
wwv_flow_imp.g_varchar2_table(242) := '1A7A9B01090E191F221F190F8B0109260C28280D26260D29280D900C240D22011E1F0E121F19012B0C29020F12121002280C2A01191E120E201C01230D240C111D11111D110C0C131A1A3201011A1C192D211111212D191D000200000000011A01070014';
wwv_flow_imp.g_varchar2_table(243) := '001E0000373532363736352327353733171527352315330717333727073523152707174B11110202550909F40912E16B092E282F0D1F131E0E2F1313050503050ABB0A0AAD1391A9092F2F0D1F79791F0D2F0000000300000000011A00E1000D00110015';
wwv_flow_imp.g_varchar2_table(244) := '000025073527230715173337351737350723353317273537010B3D09A90909A9093D0E5D96964B3939D3232809098409092623096B6D705D1F0A2200000500000000011A0107000D00170020002900320000373317150723273537333F01331707333523';
wwv_flow_imp.g_varchar2_table(245) := '2F01230F012317220614163E01342617321614062E013436372206141632363426C9470909F40909471007380793E1420710301007411C04060608050550101616201515101721212E2121F40AA80A0AA80A100303B99603101003130508060105080512';
wwv_flow_imp.g_varchar2_table(246) := '1620160115201612212E21212E21000000030000000000F4011A0007000B000F00001333171507232735173335231733152354960A0A96091383832F2525011909F40909F4EAE1BC130000000003000000000107011A0007000B00170000133317150723';
wwv_flow_imp.g_varchar2_table(247) := '2735173335231723152315331533353335231CE10A0AE10913CECE70133838133838011909E10909E1D8CF263813383813000000000300000000011A011A0007000B001100001333171507232735173335231733150723351CF40909F40913E1E1962570';
wwv_flow_imp.g_varchar2_table(248) := '26011909F40909F4EAE1262571260000000300000000011A011A0007000B001400001333171507232735171533350732363426220614161CF40909F40913E1711721212E2121011909F40909F409E1E1A9212E21212E2100000500000000011A011A0009';
wwv_flow_imp.g_varchar2_table(249) := '000E001A001E00250000131F0115072327353733073335272317231533153335333523352307331523371F0115072F01B6380613A913137171A938714B252513262613255E5E8B2B051201380114380EA81313E112F3A8394B13262613258313CE2B0DBB';
wwv_flow_imp.g_varchar2_table(250) := '13CE38000003000000000107011A0003000B000F000037152335273317150723273517333523BC5E42E10A0AE10913CECEA913137009E10909E1D8CF000300000000011A011A0007000B00120000133317150723273517333523173315372715231CF409';
wwv_flow_imp.g_varchar2_table(251) := '09F40913E1E125385E5E38011909F40909F4EAE184384B4B380000000004000000000107011A0009000E001A001E0000131F0115072327353733073335272317231533153335333523352307331523C9380512A913137070A939704B252513252513255D';
wwv_flow_imp.g_varchar2_table(252) := '5D0114380EA81313E112F3A8394B13262613258313000000000600000000011A00F40007000B000F0017001B001F00003F0133171507232737333523353335233733171507232735173335233533352326095E09095E09124B4B4B4B7A5E09095E09134B';
wwv_flow_imp.g_varchar2_table(253) := '4B4B4BEA0A0AA80A0A09711213130AA80A0AA89F26254B0000010000000000F7010A00190000131517333523373E011E02060F0117373E012E02060F013542094230120D2223190A0A0D610D62100C0C212C2C100E0107420912120D09091923230C620D';
wwv_flow_imp.g_varchar2_table(254) := '61112C2C210B0B110D270000000300000000011A011A0009000C0010000013230F02173F023507371737273717F81B9B032C1A4D059AEC1D1B1021962101199A054D1A2C039B1BCB381B0A2196210000000300000000011A011A000D0011001800002527';
wwv_flow_imp.g_varchar2_table(255) := '23352723071517331517333727353315172335333735330119098D095E09092F09BC09F34B96A91C0984B20A54090997085509096771715D4B081D00000300000000010700A900080011001A000037140622263436321617140622263436321617140622';
wwv_flow_imp.g_varchar2_table(256) := '26343632164B0B100A0A100B5E0B100B0B100B5E0B100B0B100B96080B0B100B0B08080B0B100B0B08080B0B100B0B00000200000000011A011A000B001C000037331523152335233533353307353315333523353335233533171507234B383813383813';
wwv_flow_imp.g_varchar2_table(257) := '3813E17171717A0909F4E11338381338FD675D831325130ACE09000000030000000000E200E1000B00180021000037270727372737173717071737140E01222E01343E01321E01073426220614163236AC16161116161116161116162414232823141423';
wwv_flow_imp.g_varchar2_table(258) := '28231413212E21212E216F16161116161116161116161614231414232823141423141721212E21210003000000000116011B0015002800340000131E0117161514070E010706272E033736373E01173637362734262726272606070E0116171E01273717';
wwv_flow_imp.g_varchar2_table(259) := '071707270727372737A1162910261E0F26163027141E1003070F26122B2126191902110F1D2613260F201721221026042D0D2D2D0D2D2D0D2D2D0D011901141029372B2712170409160B222A2E152E190C0CF4091F2225172A101D0301090B184E48130A';
wwv_flow_imp.g_varchar2_table(260) := '067C2F0D2F2F0D2F2F0D2F2F0D000000000400000000011D011A002F004300500054000013230727071707151707173717332627232F010727372F01353F012737173F01331F013717071F01151617352737270F0132161706072E010E02161706072E01';
wwv_flow_imp.g_varchar2_table(261) := '3E011F013E011E020E022E023617153335B0340A26261A2D2D1A26260A270A0806090E260F19062C2C06190F260E0916090E260F19062C0B082D1A2626240C13040908010B0E0A01080706030D0D04150E180E232117050D1C222016060C085E01192D1A';
wwv_flow_imp.g_varchar2_table(262) := '26260A340A26261A2D080B2C06190F260E0916090E260F19062C2C06190F260E0906080A270A26261A300E0B03060708010A0E0B01080905171B1201340C060C1C232116050C1B22211E131300050000000001070107000300070015001C002000003723';
wwv_flow_imp.g_varchar2_table(263) := '153307352315273733171507231507232735373B02171533352317231533A95E5E26121313831313261284121226134B1226834B84848312265E5EA9131383132612128412124B8338840000000200000000011A00E30008000C00003727371707273723';
wwv_flow_imp.g_varchar2_table(264) := '3527331523F52C0D43430D2CBD251313A92D0D44430D2D1338830000000600000000012C012C0007000B0017001B001F00230000133733171507232737153335053537331715331715072327373523151723153B023523A9135D13135D13135DFEE7135E';
wwv_flow_imp.g_varchar2_table(265) := '125E1313CE13715E5E5E5E125E5E011913135D13135D5D5DA87013135E125E1313705E5E125E5E0000040000000001140114002000260037003B00001306141F010E0107061E0136373E013717061416323717163236342F01312726221F010622263437';
wwv_flow_imp.g_varchar2_table(266) := '22071736333216171E013E01272E0207172E011C030233121A050104070701051711160E1D290F4A0308050280680308622C091A121F13110F0B0A25390901070704010723331A30011B0110020703330D2516040702040414200B170E291E0F4A030507';
wwv_flow_imp.g_varchar2_table(267) := '03806803742C091319510510032E2304040207041B2B182C2F131B00000300000000011100E8000800110028000037321614062226343617220614163236342627321E0117160E0126272E012206070E012E01373E0296151D1D2A1D1D150D12121A1212';
wwv_flow_imp.g_varchar2_table(268) := '0D1C332307010407070109394A39090107070401072333BB1D291E1E291D12131A12121A133E182B1B0407020404232D2D2304040207041B2B1800000003FFFF0000011A011A0015003B0044000013071537173533152307352317073315173733373527';
wwv_flow_imp.g_varchar2_table(269) := '073E01342E01220E011416170E0107060F013335343E023B01321E021D01332726272E012722263436321614065409090AA92118260101141022220909980E10121E231F11100D0D1607040101130A12180D010D18120A13010105061632131B1B271B1B';
wwv_flow_imp.g_varchar2_table(270) := '0119091D0101145E18180A091C0723097109B1091D231E12121E231D090616100B0C120A0D17130A0A13170D0A130B0B10160F1B271B1B271B0000000008000000000107011A0009000E0018001D00270031003B00400000131F01150723273537330715';
wwv_flow_imp.g_varchar2_table(271) := '3335270714333236353423220617343214221733352335071537152307233533350735371533371433323635342322061734321422C63E030ACE09099188BC3868190D0E190D0E1014143C2D0F1F100F1A2D0F10200E141A0D0D190D0E10141401173E07';
wwv_flow_imp.g_varchar2_table(272) := 'B60909F40912E1A8394C2514122514121A320B0C3D060D032D6A0C2D030D063D182413132514131A320000000005000000000107011A0009000C0013001A00210000131F0115072327353733073327231533352327350737270715173F021715072737C6';
wwv_flow_imp.g_varchar2_table(273) := '3E030ACE09099104383884BC42094A220D29290D240D29290D2201173E07B60909F4094B39E19609428E230D290D290D440E290D290D2200000700000000011A011A00110014001C00250029002D0036000013331517331533352F022307151733352337';
wwv_flow_imp.g_varchar2_table(274) := '172317230715173337350715272307272307351737172B013537173732363426220614162670094213033E069109094238833838679609099609121F0D16280D0D4F0F1D1E5D132F25040606080505010742091329073E0209F40913E139380971090971';
wwv_flow_imp.g_varchar2_table(275) := '0A4B1E16280C27500F1C1B132E410607060607060009000000000107011A000E00110019001E0028002E0037003F00490000252F012307153335331517331533350735170F01151733373527071523353307231523353332151406272315333234173627';
wwv_flow_imp.g_varchar2_table(276) := '34072315333227353336161406273723152335331523153301043E06910912710942134B38C50909CE0A0A09BCBC96060D14150D0A05050A4209011E14140D1406070B0A084D120D211412D93E0209675E42091329043939380971090971095E125D3813';
wwv_flow_imp.g_varchar2_table(277) := '3913080B1B111126090C1C01380B23010B0F0B010B16390B0E000000000400000000011A010700030021002B0032000037333523373537331F013317150723273523273537331F013317152335232F01231517272315333F013335230723153335230726';
wwv_flow_imp.g_varchar2_table(278) := '1212120A5308086B0909CE0A1C09095308086B0A13670808447108443B080871681341BC6B085E4B130909040E0A9609092F09A90A050E0A2E25050E380F0F390E0513384B5D0E00000400000000011A0107000A0012001C002C00003733171507232735';
wwv_flow_imp.g_varchar2_table(279) := '37331F013537230F012315373337232F01231533371727371715072737230E011723343637917F0909F409095E07850177100654667A017A071050501031190E292B0D1B1A0F1501131E17F40ABB0909CE0A03CC1D67100371961303103910491A0D2A0D';
wwv_flow_imp.g_varchar2_table(280) := '2A0E1901150E1620010000000005000000000107011A00110014001C0020002A0000131F0115072335333523273523152335373307332707230715173337350723353307152335072737233533C63E030A41384209711209910438381D830909830A1370';
wwv_flow_imp.g_varchar2_table(281) := '701312320D31213801173E07B609139609424B54094B395E0A8309098379701C3821310D32120000000B000000000107011A000A000E00230027002B002F00330037003B003F00490000133317150F011507232735172315331533352F01352315072315';
wwv_flow_imp.g_varchar2_table(282) := '233523273523153335333515333527152335373315233515233537331523351523353B01352317373523151F011533352FCE0A03100ABB094B13134B1003260909130A0913261312121313121213131212131312127310380F03130119095E06117F0909';
wwv_flow_imp.g_varchar2_table(283) := 'F40926BB761007542F0A12120A2FE1121313131313131313251212131326131313161051510F077A790000000003000000000107011A0009000F00120000252F01230715173337350723353315332735170101380D711313A91313A95E4B3838DC380512';
wwv_flow_imp.g_varchar2_table(284) := 'E11313A8A8E14B12393900000004000000000113012C000D00100017001D0000132307152307151733373533373527172307233533151733372335331533DB711239121297123B10381E1E269639124B4B965E38012C133813BC12123912971E1EE1BB71';
wwv_flow_imp.g_varchar2_table(285) := '1213BB38000100000000011A010700070000011507152335273501195D4B5E010720596868592000000200000000011A01070007000F00000115071523352735171533353735231501195D4B5E70265EE10107205968685920715E5E5905050000020000';
wwv_flow_imp.g_varchar2_table(286) := '000000FB011A002D0053000037273626272627060706171617072E02373536373637363F01363736373627371E0107363F0115161716070E0127170616171E01073E01373626270E012F013626270607060F01060706153106161726373637AB0A09030B';
wwv_flow_imp.g_varchar2_table(287) := '12040E020306030A0B141F1101010304090A100809070A0304060D1F1B090604110A060B0B09253B100109090D0A040C120505040806130A060C09140211090F0217090401100F0A05061C130E0B1C090F1613110E0D080E0E041825140709090D0D0F0E';
wwv_flow_imp.g_varchar2_table(288) := '080A0B0F0C110C0C164725070802011013251B141A7F070D1909091C0F04110B1123100909020D1B3B16161A0D0F0214170C0A121F0A17151C1F0000000200000000010B011A0006000D00000127072707173337270727071733010A0D70710D770D770D';
wwv_flow_imp.g_varchar2_table(289) := '70710D770D010C0D70700D77060E71710E770000000200000000010E011A0006000D00003717371737272307173717372723130D70710D760D780D70710D760DA10D71710D78E80D70700D7800020000000000EE01000006000D00003707270717333707';
wwv_flow_imp.g_varchar2_table(290) := '371737272307E04A4B0C510B51A34D4C0C530B52FF4A4A0B5151CE4C4C0B525200040000FFFF012E01070014001E002B0032000037331715262735230F01231533161723273537331F013337232F0123153337173E011E020E022E023617372707270717';
wwv_flow_imp.g_varchar2_table(291) := '917F09080B761006556002046F09095E070B7A017A071050501031112824170212212824160312382D0F27180C20F40A5407041B100371090909CE0A03361303103910420C0211222824170212212824523B0C34130E1A00000500000000011A01070012';
wwv_flow_imp.g_varchar2_table(292) := '001C0020002400280000373317152335230F012315331523273537331F013337232F012315333717331523373315233F011707917F0912771007545E6709095E070B7A017A071050501010131326121225122611F40A41131003711209CE0A0336130310';
wwv_flow_imp.g_varchar2_table(293) := '39103570707069076A06000000030000000001250107000D00190020000037333F0127233527232F0123071537331F013315230F01230F01172337333F01331CCE093209150A6C11065E091350100767550610470913BDBA1F4506106D2606840C2E0A10';
wwv_flow_imp.g_varchar2_table(294) := '030ACEC510032503100739315E031000000300000000011A0107000A0012001C000025232F012307151733373507152335333F013327230F012335331F013301107F10075E0909F40913E155061077017A0610505010077AF410030ACE0909BB951D7103';
wwv_flow_imp.g_varchar2_table(295) := '1012031039100300000500000000012C00F40013002300400049005300003733321E011D01140E012B01222E013D01343E011722061D0114163B0132363D013426230722061D0123220614163B0115141632363D0133323634262B013534261714062226';
wwv_flow_imp.g_varchar2_table(296) := '34361E0107140622263E013216154B96142314142314961423141423141721211796172121177A04051C040606041C0508061C040505041C06890B100B0B100B130B100B010A100BF4142314381522141422143914231413211738182121183817212506';
wwv_flow_imp.g_varchar2_table(297) := '041C0508061C040505041C0608051C040613080B0B100B010A40080B0B0F0B0B08000000000400000000011A011A001F00370040004900003727230F012707170F01151F010717371F01333F011737273F01352F01372707271737170717150717072707';
wwv_flow_imp.g_varchar2_table(298) := '232707273727353727371737171406222634363216073236342622061416AB0A160A0D251118032D2D05180F250F08160A0F250F18052C2D06180F25080A27261B2D2D1B26270A340A27251A2D2D1926270840171E16161E1726080B0B100B0BDA2D2D06';
wwv_flow_imp.g_varchar2_table(299) := '180F250D0A160A0F250F18052B2D05180F250F08160A0F250F18432D19262708340A27251A2D2D19262708340A27261B2D830F16161E1717220B100B0B100B000005000000000107011A002200260039004C00500000372336352627262F012622060706';
wwv_flow_imp.g_varchar2_table(300) := '072627262322070607060F0114172307151733373507233533352335263537363736373632171617161716153334373637363736321617161F01140715072317233533FD1E02040306080508090803110D0D110C0509080706030401021E0909E10A845D';
wwv_flow_imp.g_varchar2_table(301) := '5D38020102030207020F04090604010213020204050A030F08050101020202365E5E5EE1080F0B050903020301020514140503050309030B030E0809A90909A9A0961304050A030501040402020408050305050505030508040204060103050A050202A9';
wwv_flow_imp.g_varchar2_table(302) := '96000000000500000000011A011A0013001600260030003400003733151723273537331F0215262735232735231727151715331715072327353733353436321607061D013335342E010607153335384B0256090991063E03080B420971BC384113090971';
wwv_flow_imp.g_varchar2_table(303) := '090913161F16330525060A0C255E26120109F409023E07300B070809423939394B120A4B09094B0A1210161602060812120609050237383800020000000000E1012C000F001800001333151E011406071523352E013436371732363426220614168D121C';
wwv_flow_imp.g_varchar2_table(304) := '26261C121C26261C09141D1D281D1D012C4C032A3A2A034C4C032A3A2A037B1D281D1D281D00000000040000FFFE011C011A001F002A00490055000037273717150727372306263D012E023E01333217161716151406071514163327163E022E010E0216';
wwv_flow_imp.g_varchar2_table(305) := '1716171E01070E012E02363736373534262B01170727353717073332160F013E022E020E021E018B180C28280D1823131C0E14050B170F09091208031510100C3508140E020A10100D0307C80E0A0C0309081A1C14060B0C0809110B23180E28280E1823';
wwv_flow_imp.g_varchar2_table(306) := '131C0106070C07010910110C03071038180D280D280E18011C136803141C1A100308120909111A03670C119B05020E140F07030D10107B030A0C210E0C0B06141C1A080502680C10180D280D280D181B14B201080E0E0E06030C11100A00000000040000';
wwv_flow_imp.g_varchar2_table(307) := '0000010401070003000D00110015000013231533072737173533153717072733152317231533A91313105E0D4E134D0E5E101313131313010713CE5D0E4E1B1B4E0E5DA8122613000004000000000108012D0034003F004A00570000372E010706070607';
wwv_flow_imp.g_varchar2_table(308) := '2E012732373E0135342726272623220E011E01171506070E011E023E0135362E012735161716171E013E0134071E010E022E013E0227222E013E021E010E01170E012E023E021E0206F90C210E0C0601011E2A0304040D10040712090A0E170B05140E09';
wwv_flow_imp.g_varchar2_table(309) := '080B0B05141C1B0F0109120B0F161314041D2418A8080A020E140F07030D1003080E07030D10110A040F8D050E0E0B06040C110E0903049B0C0309080D0404032A1E0206170E0A09120704101A1C14035F0205081B1B14060B170F09140F022D150B0A01';
wwv_flow_imp.g_varchar2_table(310) := '1215031B2532040F140E020A10100D03820A0F110C030711140D7B050403090E110C03060B0D0E0000060000FFFE011A011A0021002D0039004A00550061000037060F011516171E0115140E0223222E013E0137352E023E0133321E021514072E01220E';
wwv_flow_imp.g_varchar2_table(311) := '011E023E022716323E012E020E02161716171615140E012E02363736373533173E012E010E021E013627071737173727372707270769080D0804040D10070D12090F170B05140E0E14050B170F09120D0716040D100E07030D101009012C07100D080109';
wwv_flow_imp.g_varchar2_table(312) := '10110C0307C80E0A0E101A1C14060B0C070A120B07020A10110C030610141D1F0D1F200D1F1F0D201F0DD00C06025E010205180E0A110E07101A1C14035F03141C1A10070D12090F9F07080A0F110C03060E0F9E05080E100D07040C10107B030A0E130E';
wwv_flow_imp.g_varchar2_table(313) := '180B06141C1A080502438507141006030C110F0B02D81F0E20200E1F200D1F1F0D000000000500000000012C011A001D002A0036004A0056000037060F01151617161514070E01222E013E0137352E023E013336160714072E01232206171E023E022716';
wwv_flow_imp.g_varchar2_table(314) := '323E012E020E021617233534262B011707273537170733321617160715233523353335331533152369080D08130A080306181D170B05140E0E14050B170F131D0116040D080D1103010D101009012C07100D08010910110C0307C812110B23180E28280E';
wwv_flow_imp.g_varchar2_table(315) := '18230E18050401133838133838D00C06025E04100C0E0A090D10101A1C14035F03141C1A10011C140F9F0708150D080C03060E0F9E05080E100D07040C10102F1C0C10180D280D280D18100D0909C53813383813000700000000011B011A0020002C0038';
wwv_flow_imp.g_varchar2_table(316) := '0041004A0053005C0000373E0135342E0223220E011E0117150E021E0133323E0235342627262735171E010E022E023E013227222E013E021E020E01171406222634363216073236342622061416271416323634262206351416323634262206540D1007';
wwv_flow_imp.g_varchar2_table(317) := '0D12090F170B05140E0E14050B170F09120D07100D0404050608010910100D03070E1008080E07030C11100901080DD01B271B1B271B2F0C1111171111070B0F0B0B0F0B0B0F0B0B0F0BBE06170F09120D07101A1C14035F03141C1A10070E110A0E1805';
wwv_flow_imp.g_varchar2_table(318) := '02015E75040E0F0E06030C110F0A830A10100C04070D100E089F141B1B271C1C2F10181010181088080B0B0F0B0B48070B0B0F0B0B0000000004FFFF00000107011A000F001B001F003500003715173337352F0223153317152335372335231523153315';
wwv_flow_imp.g_varchar2_table(319) := '333533073315233707273723220614163B011523222634363B012737173813A91205380E252539A9832513252513255D5D5D13280D18380C10100C0909141B1B1438180D28714B1313A80E38051239A84B4B25251326264B1399280D18101810131B271C';
wwv_flow_imp.g_varchar2_table(320) := '180D2800000400000000011A011A001100160022002E0000252F01230715173326272335331715161735072315333427333533153315231523352317220E011E023E013534260101380E7013136409065570390A086E27252525132525132570111C0D06';
wwv_flow_imp.g_varchar2_table(321) := '18221F1321DC380512E113080AE2393A03054270130A67252513262626131F2218060D1C1117210000050000FFFE011A011A001D002A003600570063000037060F01151617161514070E01222E013E0137352E023E013336160714072E01232206171E02';
wwv_flow_imp.g_varchar2_table(322) := '3E022716323E012E020E02161716171615140E012E02363736373534262B0117072735371707333216171607173E012E010E021E023669080D08130A080306181D170B05140E0E14050B170F131D0116040D080D1103010D101009012C07100D08010910';
wwv_flow_imp.g_varchar2_table(323) := '110C0307C80E0A0E101A1C14060B0C0809110B23180E28280E18230E180504010B07020A10110C03060B0D0ED00C06025E04100C0E0A090D10101A1C14035F03141C1A10011C140F9F0708150D080C03060E0F9E05080E100D07040C10107B030A0E130E';
wwv_flow_imp.g_varchar2_table(324) := '180B06141C1A080502680C10180D280D280D18100D0909AA07141006030C110E090304000005000000000107010E000900170021002500290000371533351737272307170F01151733373527230E012226271733152335331E0132362733152315331523';
wwv_flow_imp.g_varchar2_table(325) := '8313320D420D420E360909E10A0A42041A211A03692CCE2B082027203D13131313F02222320E41410E3B095E09095E0910151510124B4B1115155C13131300000003000000000107010E0009001700210000371533351737272307170F01151733373527';
wwv_flow_imp.g_varchar2_table(326) := '230E012226271733152335331E0132368313320D420D420E360909E10A0A42041A211A03692CCE2B08202720F06D6D320E41410E3B095E09095E0910151510124B4B1115150000000003000000000107011A000900170021000037353315371707232737';
wwv_flow_imp.g_varchar2_table(327) := '0F01151733373527230E012226271733152335331E0132368313320D420D420E360909E10A0A42041A211A03692CCE2B08202720AD6C6C310D42420D5B095E09095E0910151510124B4B111515000000000500000000011A011A000C0018001F00230027';
wwv_flow_imp.g_varchar2_table(328) := '0000373317232735373317152735231707333727233727230F011737330733073723272335330723353339300D460A0AE10913CE681B2A690D1F0F0F36112B112B3623426C1F330A363F1A252E711309A909095A2130A9416C201B1D0B5E1A70386D4838';
wwv_flow_imp.g_varchar2_table(329) := '1339130000010000000001180121006C000025161514070607161D01140622263D0136262737363736373635342F013627060F0126072726230617070E011514171617161F01061715160622263D0106272627262F012E01272E013E01171617161F0116';
wwv_flow_imp.g_varchar2_table(330) := '171637352637262726353437263F013617161736173637361F01160107111712200605070501050505160D11090B100207061113072929071A0B06070308090B08120D16050B0101060706110D0B09050801050703020302060307070307010A080D1502';
wwv_flow_imp.g_varchar2_table(331) := '0720111911050906040A1015292A14100B040609EA141B2D1811050A112E040505042E080D060E0306070F121D16110A1012040D020B0B021013100908150A1D110F0806030F0A0F2F040606041A04040308040B01060601010606040201050308020D04';
wwv_flow_imp.g_varchar2_table(332) := '0705040E0D0611182B1C141A15040201030D0A0A0D040202051900000001FFFF0000012D012C0054000013220E0115141E011732363D0106272627262F012E012F0126373633311E011F0116171637363726272635343731263733321716173633321736';
wwv_flow_imp.g_varchar2_table(333) := '37361731160F011615140706071E011D011416333E0235342E01962945281A2E1E05050E0B09070403030208030309040204060B0303090E0A0A01081E10161007090406080A0D0F171114120D070308050110160F1F040605051E2F192945012C284529';
wwv_flow_imp.g_varchar2_table(334) := '203A2A0A04041903030205040504080A0301060301010704040F0101040C08040D13271711131403040905050C030201131401111727120D04030E0A2904040A2B3A1F294528000000030000000001070107000B00130017000037333533352335231523';
wwv_flow_imp.g_varchar2_table(335) := '15332733171507232735173335237112717112393942CE0A0ACE0912BCBC3871123939125E0ACE0909CEC5BC000200000000012D012C000C006A000013220E01141E01323E01342E01032322263D013426273E023736353426273E013426272322060F02';
wwv_flow_imp.g_varchar2_table(336) := '26072F012E012B010E011416170E011514171E02170E01070E01262F022E01230706141F01161F011E013733371514062B012E023E02321E020E010796294528284552452828450102020404050D17100304070601010202020508040907202007090409';
wwv_flow_imp.g_varchar2_table(337) := '0403010201010607040310160D030401070F0B0404040306030501020802020603110A06070403011D2C130A24373E37240A132C1D012C28455245282845524528FEF0030323070D040109100B0D0E091207040709090502020504090904050202050909';
wwv_flow_imp.g_varchar2_table(338) := '07040712090E0D0B1009010309050301080704050103010102020602020B090A0101160303092C3A3E321C1C323E3A2C09000000000A00000000011A011A000C0012001E002A0031003700410048004D0053000013321E01140E01222E01343E01172E01';
wwv_flow_imp.g_varchar2_table(339) := '27161F0136352627231615140733362735363427230615141733362726272B0106072336370E010F0106141733263534372317231E0117262717363723163706073E01379F213821213842382121387D091E120C06320101032C01042F02410102480104';
wwv_flow_imp.g_varchar2_table(340) := '43020307100A09110614050D131D090804042F04012C342C0A261712092F120A370942091217250B0119213842382020384238214B121A06171B3805040F0D0A081313090A01091209090913130A411E1A1A1E1B18071A12120E1D0E1313080A4A161C05';
wwv_flow_imp.g_varchar2_table(341) := '191D31161B1B1C1E19051C16000300000000012C011A00160027002A00003F013527071723220614163B013523222E01363B010717372327331F02150723273517153335233715337126280D1838141B1B1409090C1001110C38180D5F3213580D390513';
wwv_flow_imp.g_varchar2_table(342) := 'A81313A84B1338BD270D280D181C271B13101810180D4B1205380EA813138C107C964B39000300000000010F011A0003001A0030000037071737271E01323E01342E012322071733321E01140E012226273707273723220614163B011523222634363B01';
wwv_flow_imp.g_varchar2_table(343) := '2737175A470E471D0D313A2F1C1C2F1C0C0C110717271616272D250B36280D18380C10100C0909141B1B1438180D286E450D4522191F1C2F38301B021116272E2716141161280D18101810131B271C180D280000000200000000011A00BC000300070000';
wwv_flow_imp.g_varchar2_table(344) := '25211521152115210119FEFA0106FEFA0106BC1326120000000700000000011A010F000900110015001D00210029002D00003717072735371707331507353733171507233735231537353733171507233735231537151733373527231715233528100B20';
wwv_flow_imp.g_varchar2_table(345) := '200B0FF0CE09260909261D133809260909261D133809260909261D13E1110B1F0C1F0C0F13C6AB0808AB081199991D85080885091175757D60080860081050500002000000000120012C0006001300002515232735331537072327072737331737331707';
wwv_flow_imp.g_varchar2_table(346) := '0119FD0913CE610D1F440E4B0E1F600D260D381209FDF4B8611F440D4B1F61260D000000000600000000011A012C0006000A000E00120016001A00002515232735331537331523373315230733152307331523373315230119FD09133825258326264B26';
wwv_flow_imp.g_varchar2_table(347) := '26382525832626381209FDF4CF2638252625262538250000000700000000011A012C0006000E0012001A001E0026002A0000373335233523153735373317150723373523153715173337352723171523350735373317150723373523151CFDF313250A25';
wwv_flow_imp.g_varchar2_table(348) := '0A0A251C13830A250A0A251C135E0A250A0A251C132612F4FD25960A0A9609138383B2BC0909BC0912A9A9B37109097109135E5E00060000000000CF00F400030007000B000F001300170000373315231533152315331523373315231533152315331523';
wwv_flow_imp.g_varchar2_table(349) := '5E2525252525254B252525252525F42625262526BC26252625260000000B000000000107011A000900110015001D00210029002D00350039003D004100001333152315331523273517232735373317152733352317232735373317152733352307232735';
wwv_flow_imp.g_varchar2_table(350) := '373317152733352317232735373317152733352B021533352315331C261C1C26097A26090926092512128C380909380A3926264126090926092512128C380909380A3926261226262626011912E11309F46709260909260A122509380A0A380A25960926';
wwv_flow_imp.g_varchar2_table(351) := '0909260A13390A380909380926137012000100000000011A0107001C0000252E01272E0122060F01272E012206070E02141E011F01373E023401170209070A1A1B190A0D0D0A191B1A0A0709040409076F6F070904D20911060A0A0A090D0D090A0A0A07';
wwv_flow_imp.g_varchar2_table(352) := '1012121210076E6E07101212000200000000011A0107001D003D0000252E01272E0122060F01272E01220607060706141E011F0137363736353407060F01272E02343E013736373617161F013736373617161716171615140701170209070A1A1B190A0D';
wwv_flow_imp.g_varchar2_table(353) := '0D0A191B1A0A0D05020409076F6F07040915030A6162050703030705070A131409071A19070A1314090705030701D20911060A0B0B090D0D090B0B0A0D1309121210066F6F0608101309150D0A6161050C0C0E0D0B050704080803081919070408080407';
wwv_flow_imp.g_varchar2_table(354) := '05060B0E07060000000200000000011D011B001E00250000373E0126272E010E0107352315173335233E011E010E022627071E023627372735231517FD120D0C12133C4138101309422913484A2E02314B4612100F38423E2B0E36130345173939171A1C';
wwv_flow_imp.g_varchar2_table(355) := '04211C2D420912221D153E4D3C122122091D26061B2C0D36474B0700000200000000011401130011001C000013170727150723273523150723273507273707153335373317153335279D770D130A38092609380A120E77442609380A254B01126C0E117A';
wwv_flow_imp.g_varchar2_table(356) := '0909424209097A110E6C5882420909428244000000040000000000F400E2000B0020002C003000003733352315233523153335331733273637363736342E01272627262B011533353337062B01353332161514070617231533790F0F311010316A111803';
wwv_flow_imp.g_varchar2_table(357) := '04080302030504060704032E0F1C0903022020060A010317BCBC717031317030303101030609050B0A0703050201702E1001240A08050307661300000005000000000107011A0024002E003B003F00430000373317153317150723150723072735232735';
wwv_flow_imp.g_varchar2_table(358) := '2327353733353733352E013534363216150607173523151733153F013327060731062627071E0132363727231533373315239F4B090A0A0A0A093A2F102F0A090909090A4B04060B100B010942962F09220735280B0E0D18090D0A191C19094C13133813';
wwv_flow_imp.g_varchar2_table(359) := '13E109260A1209390934072D0C3609120A280715030806070B0B070B0561386E022926032E0A030308090E090B0B093313131300000300000000011A011A00090013001D0000373337352F01230F0115372335331F01333F013327230F01232F01233733';
wwv_flow_imp.g_varchar2_table(360) := '1CF40934088D0934F4E12F0E0856080D310135090C4B0E0835317F2609549006068B590938170505171305171705840000010000000000F400CF00110000371514163B01273717150727372322263D014B0504811E0D30300D1E810B11CE2504051E0E30';
wwv_flow_imp.g_varchar2_table(361) := '0B2F0D1E100C25000004000000000119011B00130027002B002F0000131E01171E0106070E0126272E033E03173E01373E0126272E0106070E011E01171E01372733352317152335A116290F18120C1513373C1B141E11020D1A262B2012210C120B1014';
wwv_flow_imp.g_varchar2_table(362) := '12313315191A031F1A1126121F181818180119031310183E401A1819020E0B222A2D2C241A0BF304140F163735151211070E11353B320E0906049412254B4B00000500000000011A011A0007000B00130017001D00000117150723273537172315331517';
wwv_flow_imp.g_varchar2_table(363) := '15072327353717231533271707173727010712129613139696961212961313969696F41E1E0D2B2B0119124B13134B12124B39124B13134B12124B8E1E1E0D2B2B00000000030000000001270107000C0010001400003F01331715233523153315232705';
wwv_flow_imp.g_varchar2_table(364) := '271537073517231313E11212E15D5D1301147E33203D25F413137171961313207EB13306563E00000009000000000107011A0007000D0015001B0024002A0032003800410000371736342707161427372627071627372622071736320727060717360734';
wwv_flow_imp.g_varchar2_table(365) := '3717061617072617071617372617071E0137270622371736372706273236342622061416EF12060612050B101223091E2C05122712060F213F092312110F2D061206010512061E111223091E2D061227120510213F09231210104C070B0B0F0B0B7F0512';
wwv_flow_imp.g_varchar2_table(366) := '2712060F213F092312110F1512060612060C111223091E4D1412060F211005121B0923121010161205010612050B101223091E3A0B0F0B0B0F0B00000003000000000123011B001500300039000037072F0137173E031E0317232E020607371F0107270E';
wwv_flow_imp.g_varchar2_table(367) := '032E03273335141E033E0237072737271416323634262206633D0D19110F081B242829251C1001120432483E0C2CAD19110F081B242929241C1002130C181F24232017072B073D7F0B100B0B100BC219053C0724131F140806141E261424340927221243';
wwv_flow_imp.g_varchar2_table(368) := '3D0825131F140807141E26150912221C120606121C111212190A080B0B0F0B0B0003000000000107011A000D001B0024000013220E011E023E0127362E0207222E013E021E0115140E022714163236342622068D253E1C0E3548442A010113222D182034';
wwv_flow_imp.g_varchar2_table(369) := '180D2C3D3A23101D26270B0F0B0B0F0B0119294449340E1C3D25192C2312E1233A3D2C0D18342014261D1067070B0B0F0B0B000000010000000000E00107001C00003707233732373637363F013635342E0123373307260E010F0106141E01A9025C020E';
wwv_flow_imp.g_varchar2_table(370) := '0507030606260504090C0256020A0D0806260604092D06060203050814871009040702070701060C1587130906030000000200000000011A0107001B0031000037232735232F013F01171E011716171637363F031F010F01231527333537333727070607';
wwv_flow_imp.g_varchar2_table(371) := '0E01222627262F0107173317DF93091B090C06500C01050205060E0D060505040C50060C091B9380091D083F030303081415130704030340091C0A210A7D07320B1B060507020503050602050509061B0B32077D097D0923150405030808080803050415';
wwv_flow_imp.g_varchar2_table(372) := '23090000000200000000010701070046008D0000373523220E0107310607310617151407310607062B011533321715161715161731161D010617151617311E0217333523222E023D01342627262736373E013D013436373633171533323E013731363731';
wwv_flow_imp.g_varchar2_table(373) := '3627353437313637363B013523222735262735262731263D013627352627312E0207231533321E021D01141617161706070E011D011406070623710209110C030301010102040A050601010605050304020201010103030D10090202060A070402020509';
wwv_flow_imp.g_varchar2_table(374) := '09050202090705064D0109100D030301010102040A050602020605050304020201010103030D10090101060A0704020205090905020209070506F413070D08080808081006050A050212020102030103050506100808010708080D06011304080A061906';
wwv_flow_imp.g_varchar2_table(375) := '0C050B07070B050C0619090D0402BC12060D08070908081006050A050212020102030103050506100808010708080D07011204080A0619060C050B07070B050C0619090D0402000000030000000000AA0107000B0014001D0000371E013E022627260E01';
wwv_flow_imp.g_varchar2_table(376) := '163722263436321614062722263436321614068C040A0905010405060F080211080B0B100B0B08080B0B100B0B29030105080A090304030D0F560B100B0B100B5E0B100B0B100B00000300000000011C011C001C003900450000131E02070E012322270F';
wwv_flow_imp.g_varchar2_table(377) := '012315072315072327353F012635343E0217363731362E02070E011506170F0115333537333537333F01163332373E012E020607061E0136D517230C04062F1E0D0B0F0713091C0A3809025E04111D252C12050309182011161E0105025E25091D091711';
wwv_flow_imp.g_varchar2_table(378) := '0A0C0C1703030105080B090204030D0E011805202B161D260412031C0A1C09092B075D0D0E122317098A0E1711201809030524170D0C0A5F1E1D091C0913030442040A0906010504070F0803000600000000011A011A002F00360039003D004000470000';
wwv_flow_imp.g_varchar2_table(379) := '2527333523352315231533072315331E01323637333523273315230F011733372F01233533072315331E013236373335070622262733062723371F01233F0117231706222627330601121E135E135E131E070205181E190502081F3A25082507A9072508';
wwv_flow_imp.g_varchar2_table(380) := '253A1F080205181F180502B7060F0C042F040126137617831776132620060F0C042F04A94B131212134B130E12120E134B96042F0F0F2F04964B130E12120E131D03070606192D8B1C1C8A2D1C0408060600000000060000FFFD012D01180007000B0017';
wwv_flow_imp.g_varchar2_table(381) := '001F002C0033000013230715173337350737170F012733173733072322060F011707272317333726373617321615140E012E023617372707270717990A6F6F0A73D65E6161056D215154220F0719270813101551216D0A14042B0F111721131F2218070D';
wwv_flow_imp.g_varchar2_table(382) := '2E220F1C100C1801184C104A4A100841413F424A37370A1D160D0E0E374A0D093D0A012018111C0D061921203F2D0B250E0F1300000500000000012C01180007000B0017001F0028000013230715173337350737170F012733173733072322060F011707';
wwv_flow_imp.g_varchar2_table(383) := '272317333726371416323634262206990A6F6F0A73D65E6161056D215154220F0719270813101551216D0A140413202F21212F2001184C104A4A100841413F424A37370A1D160D0E0E374A0D090E1721212F2121000400000000010C01180007000B0012';
wwv_flow_imp.g_varchar2_table(384) := '0019000013331715072327353707173707173337230727172733173733078F0A73730A6F745E5E61D36D0A712254514C6D215154227101184C104A4A1039413F3F374A4A3737794A37374A00000200000000011A011A0007000B00001307151733373527';
wwv_flow_imp.g_varchar2_table(385) := '15233533261313E11212BCBC011912E11313E112F3E10000000200000000011A011A0007000B0000130715173337352707353315261313E11212E1BB011912E11313E112F3E1E100000300000000011A011A0007000B000F000013071517333735270735';
wwv_flow_imp.g_varchar2_table(386) := '331533353315261313E11212E14B4B4B011912E11313E112F3E1E1E1E1000000000500000000011A011A0007000B000F0013001700001337331715072327371533350733152337331523372315331313E11212E11313E1CF26263925255D252501061313';
wwv_flow_imp.g_varchar2_table(387) := 'E11212E1E1E1121313131313000400000000011A011A0007000B000F001300001307151733373527073533153735331537331523261313E11212E1251370132626011912E11313E112F3E1E14B969696E1000000000400000000011A011A0007000B000F';
wwv_flow_imp.g_varchar2_table(388) := '001300001307151733373527073533153335331533353315261313E11212E12513701326011912E11313E112A896969696969600000300000000011A011A0007000B000F0000133733171507232737153335331533351313E11212E11313961239010712';
wwv_flow_imp.g_varchar2_table(389) := '12E11313E19696E1E1000000000300000000011A011A0007000B000F000013071517333735270735331507331523261313E11212E1E1E1E1E1011913E11212E113A9969612390000000300000000011A011A0007000B000F000013373317150723273715';
wwv_flow_imp.g_varchar2_table(390) := '3335331533351313E11212E1131338139601071212E11313E1E1E19696000000000200000000011A011A0007000B0000130715173337352707353315261313E11212E1E1011912E11313E112A8969600000300000000011A011A0007000B000F00001307';
wwv_flow_imp.g_varchar2_table(391) := '1517333735270735331533353315261313E11212E14B1284011913E11212E113F4E1E1E1E1000000000200000000011A011A0007000B0000130715173337352715233533261313E112128484011912E11313E112F3E10000000300000000011A011A0007';
wwv_flow_imp.g_varchar2_table(392) := '000B000F000013071517333735270735331533353315261313E11212E183134B011913E11212E113F4E1E1E1E1000000000200000000011A011A0007000B0000130715173337352707353315261313E11212E183011912E11313E112F3E1E10000020000';
wwv_flow_imp.g_varchar2_table(393) := '0000011A011A0007000B0000130715173337352707353315261313E11212E1E1011913E11212E113E1CECE00000600000000011A01070007000B00130017001F002300001307151733373527073533153F01331715072327371533350737331715072327';
wwv_flow_imp.g_varchar2_table(394) := '371533353812124B13134B4B3912391212391212394B1239121239121239010713BC1212BC13CFBCBCBC131338131338383883121239121239393900000600000000012801070007000B00130017001F002300003F0133171507232737153335173F011F';
wwv_flow_imp.g_varchar2_table(395) := '010F012F0117372F0137331715072327371533355E09260909260913122906230C4605230C32401241BF0926090926091312FD0A0ACE0909C5BCBC070C0D05C20C0D05C0B006B00C0A0ACE0909C5BCBC000300000000011A011A00080012003700003722';
wwv_flow_imp.g_varchar2_table(396) := '0614163236342617270737273337173307270E0107231514163B0116172306263D013426272E013534373E0333321E0115140706E11721212E212102191809161B0A0A1C171F121D072303031A0305220A0F0A090C0E0C051013150C172717070483212E';
wwv_flow_imp.g_varchar2_table(397) := '21212E215D12121C101F1F10520318122902040A08010F0A1E0D18090B1F1117130A0F0B06162717120E0900000300000000011D011A003B0058006C0000373637363F0136373635342E04220E04071E01171E011D01141E023B01323E02352723262715';
wwv_flow_imp.g_varchar2_table(398) := '14062B0122263D01333E013337321736373637363330312726272627262706070607060F011716171617161736373632171617161407060706222726272634A80508060402020705060B1013151815130F0B0601010D0C0A0A030709051E050907040102';
wwv_flow_imp.g_varchar2_table(399) := '090703031E020425030B07020433060E0B0D07050708080B080A04050A080B0709070709070B080A1F0906020702060902020906020702060902780A0805060708050D0F0C15130F0B06060B0F13150C121D0C0A170D1E05090703030709050801060F02';
wwv_flow_imp.g_varchar2_table(400) := '0404022906080150180F0A0502010105060A0E13130E0A06050101010204060B0D0506090202090602060206090303090602060000020000000000F5011A0021002B0000370E011D0114060706272306263D013426272E013534373E0333321E01151406';
wwv_flow_imp.g_varchar2_table(401) := '07231514163B01323635DB090B080704051E0B0E0A090C0E0C050F13160C1727160D332903031E02038A09180D1E070D030201010F0A1E0D18090B1F1117130A0F0B06162717121E2E29020403030000000200000000011A011A000C0016000013331523';
wwv_flow_imp.g_varchar2_table(402) := '153335331507232735211523350727372335331C554BE11209F4090106127F0D7E637A011912E14B550909F47A637E0D7F120000000200000000011A00F40024004900003733321E011D01140E012B01353332363D0134262B0122061D011E0117152E01';
wwv_flow_imp.g_varchar2_table(403) := '3D01343E0117351E011D01140E012B01222E013D01343E013B01152322061D0114163B01323637352E015339121D11111D120909131A1A1339131B0115101820111DA01820111D113A121D11111D120909131A1A133A121A010115F4111E1104111D1213';
wwv_flow_imp.g_varchar2_table(404) := '1B1204131A1A13041019031303241804111E114C1303241804111E11111E1104111D11121B1204131A1A130410190000000300000000010700F400030007000B0000373533152733152337152335714B719696BCE14B13135E135E131300000000040000';
wwv_flow_imp.g_varchar2_table(405) := '0000010700F400030007000B000F00003733152315331523353315233533152326A8A89696E1E1CECE8312261384134B13000000000600000000011A01070006000A000E00120033006B000013373315233507373315231533152317231533273F013634';
wwv_flow_imp.g_varchar2_table(406) := '27262726220706070607153335343F0132331715160F021533352317321716151407060706222E012F0126273133151716333F022F012B013537333F012734260F01061D01233534373E02321E0214072B070D0D0733BBBBBBBBBBBBBBD3010103010207';
wwv_flow_imp.g_varchar2_table(407) := '050805060201011001010102010101021325110B020103010207050805040202010110010201010101010101040401010101030101010F030104060706060403010007392A06021338133813520101050804070202020207030301010102010201030303';
wwv_flow_imp.g_varchar2_table(408) := '150B0D3A020406030307020202030204030402020101020203020C01010302010101010102010106050203020203070904000000000300000000011A00F400030007000B000037353315272115213715233513A9A90106FEFACECE4B13135E135E131300';
wwv_flow_imp.g_varchar2_table(409) := '000500000000010700F400030007000B000F00130000373315231533152335331523273315233B0115234BA9A98383BCBC38CECE3813138312261384134B13A9000800000000011A00F400030007000B000F00130017001B001F00003723153315231533';
wwv_flow_imp.g_varchar2_table(410) := '073315231723153337331523172315330733152317231533261313131313131313131325CECECECECECECECECECECEF413251326122613BC132513261226130000040000000001230120001600270033003F000013371715072735232207060706072726';
wwv_flow_imp.g_varchar2_table(411) := '373E0317331715372715232606070607363736373633073E011E020607062E0136171E013E022627260E0116AC12646412081F0F16141517130104041928301A0D16474624182E111509141412160F1C420C1D1A10020D0C132B19091E07111009020807';
wwv_flow_imp.g_varchar2_table(412) := '0C1A0F0601170950114C092303040D0F1E060E0E192C2011014123363821011111161D130A0803024A09020D181D1B070C09242C3B0502080F1110040806161A0001000000000118011A000F0000252E02220E0107233E02321E01170105051F3036301F';
wwv_flow_imp.g_varchar2_table(413) := '051305253840382505A91A2B18182B1A20331D1D3320000000040000000000E201100010001E002700330000372E012331220E021F01333736273426273B011E0117140F012726353E0117260E011E013E0126273E011E020607062E0136CB0A1C0F1522';
wwv_flow_imp.g_varchar2_table(414) := '14010C3B0A3B0C010B41010216200109303009012022061008030D0F0903260815120B0109090C1E1105FA0A0C15222A12777712160F1B0E012117100D61610D1017212805030D0F09030D0F14060209111512050806191E00030000000000F401070007';
wwv_flow_imp.g_varchar2_table(415) := '000B001B00003F01331715072327371533352735342622061D013335343632161D0138139613139613139613212E21131520159613135E12125E5E5E132518212118252510161610250000000003000000000107011A00110019001D0000372335342E01';
wwv_flow_imp.g_varchar2_table(416) := '220E011D012307151733373527343E01161D012317233533F4131423282314131212BC13A9212E217096BCBCA92515221414221525137013137038182001211825837000000400000000011A01100016001A001E0030000013220E011D01173337353436';
wwv_flow_imp.g_varchar2_table(417) := '32161D0117333735342E01072335331723353327353426220607152335343E01321E011D0196243C23133813161E17123912233C5C3838A9393939202E2101381E343C341F0110233C245E13135E0F16160F5E13135E243C23E1383838131318201F1616';
wwv_flow_imp.g_varchar2_table(418) := '131E341E1E341E13000300000000011A010F0007000C00140000132307151733373527170723271723351F01333F019B0A7E09F409836A1AA018D9E11408A80815010F4B95090995383F1D1D85721A03031A0000000300000000011A00F40007000D0010';
wwv_flow_imp.g_varchar2_table(419) := '00003F013317150723273715333507233723171309F40909F40913E16B0C64BC5EEA0A0AA80A0A958C8C525C49000000000300000000010700F400030007000B000037153735173527151735371526414B384B42C58D298DB08D238D238D298D00030000';
wwv_flow_imp.g_varchar2_table(420) := '000000F4010700030007000B0000133307231723273317230733678D298DB08D238D238D298D0107424B384B4100000000040000000000FC01100003000700150019000037330723153317233F0127230F0115170717333F0135073307236C7723777723';
wwv_flow_imp.g_varchar2_table(421) := '77642C088D082F2C2C088D082F90772377FD38133842460E054B0946470E054B090E3800000400000000011000FC0003000700150019000037153735331517350F0127353F0133173717150F0123371537352F38133841470E054B0947460E054B090E38';
wwv_flow_imp.g_varchar2_table(422) := 'C0772377772377642C088D082F2C2C088D082F9077237700000200000000011A00CF00100017000037331523370723271415172335331716173735231523173777271B012117210119280F0E019C25243736CE7A636363072F2D7A2B2B04164242363600';
wwv_flow_imp.g_varchar2_table(423) := '000300000000011A00EE000F0017001B00003F01171507270E022E02372F0135170615141E0136372717350726E70C0C72030F15160F0603260840010B100E0258D7D7AD400AA10A1E0B0F060510150B0A0A243D0202090C0208082C398A3D0000020000';
wwv_flow_imp.g_varchar2_table(424) := '000000EE00F5003800420000370627062E0237343E02333217161514062322350E01232226343E0133361617373307061633323635342623220E0115061E0237163727143332363736232206C41A1F1121190C010E1D26142416191F171506110A0E110D';
wwv_flow_imp.g_varchar2_table(425) := '170D090F0304110F0303060E15251F1825150109141B0E1C194C110B100409190E12440F01010C19201214271D101315231E2712090913221D12010A080F3C0D0A1F161D201829180F1A140A01010D38171211241E000000000300000000012C00E10003';
wwv_flow_imp.g_varchar2_table(426) := '0007000B0000252135211521352135213521012CFED4012CFED4012CFED4012CCE13A9133813000000020000000000EB00FE0026003B00003727230717371531153115141F0116171E011F011E021D013335342E022F012E02372717073637262F01060F';
wwv_flow_imp.g_varchar2_table(427) := '010E031D013335343E0137C5280E280D1501020202040D070E070C071A050B0C070D060B0601011534030307040205060D070C0B051A070C07D528280D1413090605050B06060B11080F0711130D11110D181210070E0610140B1D145304030A0C050706';
wwv_flow_imp.g_varchar2_table(428) := '0E070F13180D11110D13110700030000000000FE0110000B000F0023000037343632161D0114062226351735331527062E013533141E013B01323E013533140E01235E212E21212E212F12121A2B19131422151215221413192B1AD8172121174B182121';
wwv_flow_imp.g_varchar2_table(429) := '188D262626011A2B19142314142314192B19000000040000000000FE011A000B001C0020003400003735343632161D011406222637220E011D01141E01323E013D01342E010335331527062E013533141E013B01323E013533140E0123671C261C1C261C';
wwv_flow_imp.g_varchar2_table(430) := '2F121E12121E241E12121E1B12121A2B19131422151215221413192B1A8D4B131C1C134B141B1BA0111F114B121E12121E124B111F11FEE7262626011A2B19142314142314192B19000300000000011A011A00110016001A000013231523071517331533';
wwv_flow_imp.g_varchar2_table(431) := '35333F01352F01231723353317273315239613670909671354072828075450C0C01FA75E5E0119250A4B09838302260E25034B381C091200000300000000011A011A000A001500250000131F011507270727353F011F013527152335071537313F011715';
wwv_flow_imp.g_varchar2_table(432) := '072737231707273537170733A174040E75750E0474156767136767230E2E2E0D1E711E0D2E2E0D1F7201194B07AC084B4B08AC074BAB42964236364296425A0D2F0D2E0D1E1E0D2E0D2F0D1F000300000000011A00F40013001E00220000252723071533';
wwv_flow_imp.g_varchar2_table(433) := '3517061D011F01333F013534273707150727353637173337162F0137170119800680132B0F054B0849060F3F424142010D3107300D41676767C23232775E11151A08072222080819151947011E1E011612131312112828280004000000000110011A0009';
wwv_flow_imp.g_varchar2_table(434) := '0013001D0027000037073523152707173337271737153335173727230F01331523170727353717332737171507273723C02112210D300E306E0D2112210D300E35214141210D31316541210D31310D214163204040200D3030930D204040200D30502013';
wwv_flow_imp.g_varchar2_table(435) := '200E310D302D200D300D310E20000000000500000000011A011A000C00100018001C0020000013373317150723353335231523371533350F01151733373527073533150733152371099609092F2684121284EB0909960A0A8C8383838301100909830A13';
wwv_flow_imp.g_varchar2_table(436) := '4B133913135E0A830909830A261313124B00000000050000000001070107000C00150027002B003400002523152623220614163E013D01073216140622263E01370F011526230E01141632363D0137153335071507350732161406222634360107130D0F';
wwv_flow_imp.g_varchar2_table(437) := '141B1B271B2E0B1111171101103196090D0F141B1B271B841313832F0B1111171010A92F091B271C011B1355381117111117119509098D0A011B271B1B14710812540A2509268D1117101017110000000003000000000119011700090011001D00003733';
wwv_flow_imp.g_varchar2_table(438) := '37171507272327351F01350F012315333717071707270727372737171C34491010493409483B3B072E2EB70D20200D21200D20200D20CE4806F40648095E583BC73B024B490D20210D20200D21200D20000300000000012C011A00100013001F0000131F';
wwv_flow_imp.g_varchar2_table(439) := '011523352335231533152327353733071533172335233533353315331523B24002134B5E4B5409097E0436151338381338380117410825134BCF1209E1091239CE38133838130000000300000000012C011A0012001C0028000001232F01230715173335';
wwv_flow_imp.g_varchar2_table(440) := '2335333F013307333507230F012335331F013307233523353335331533152301107F10075E0909675E550610770113137A0610505010077A1313383813383801070F0309CE0A1371021025541C0310381002F4381338381300010000000000F400C50011';
wwv_flow_imp.g_varchar2_table(441) := '0000371514062B01372707151737273332363D01E10504811E0D30300D1E810B11C52504061F0D300A300D1F100C2500000400000000011A00D20008000F00160028000037361E010E012E0136172E010E01161F011E013E012627371514062B01372707';
wwv_flow_imp.g_varchar2_table(442) := '151737273332363D012C132E1A09272E1A09460914120A01050D0914120A01059C06044D1E0D30300D1E4D0C10C50D09272E1A09272E0205010A1214090D05010A121409252504051E0E300B2F0D1E100C250000000500000000011A01070007000B000F';
wwv_flow_imp.g_varchar2_table(443) := '0013001700001333171507232735171533350733152317231533073315231CF40909F40913E1BC9696717171714B4B01070ABB0A0ABB09A9A926121313131200001700000000012C012C00030007000B000F00130017001B001F00230027002B002F0033';
wwv_flow_imp.g_varchar2_table(444) := '0037003B003F0043004B004F00530057005B005F000037233533152335331523353315233533152335331D0123351733152337331523032335331723353B0215233323353317233533172335331535331D012335332B0135331737331715072327371533';
wwv_flow_imp.g_varchar2_table(445) := '3517331523153315231533152327331523131313131313131313131313131313251313251313251212131313381212261313251212131313CE13134B138313138313138325131313131313965E5ECE133813391338133913251313131313130119131313';
wwv_flow_imp.g_varchar2_table(446) := '1313131313132512122613134B1212A91313A9A9A91326122613258313000000000700000000011A011A0007000B00130017001B001F002300001337331715072327371533350737331715072327371533351723153307331523172315332612A91313A9';
wwv_flow_imp.g_varchar2_table(447) := '1212A996135E12125E13135E5D121212121212121201071212E11313E1E1E12613131312121313131325132513260000000400000000011A00FA002500400049005200002536373627232607060706072622072627260731061716170615141716171632';
wwv_flow_imp.g_varchar2_table(448) := '37363736353407222726272635343736373217163237363316171615140706070627220614163236342633220614163236342601040301010704040608090C0E124212191209050701010315110F1F1A531B1F0F11832110180C0D11080F0A1611121215';
wwv_flow_imp.g_varchar2_table(449) := '0A0F08110D0C18104A080C0C100C0C4A080C0C100C0CC2080A121201020105050905051004020112120A0817202918150A08080A151829207803040B0C19130F08020101010102080F13180D0B040352111811111811111811111811000400000000012D';
wwv_flow_imp.g_varchar2_table(450) := '011A000C00100022002E00001333171526273523150723273517333523172207230E01170717371E013E022E0207062E013E021E020E0138CF12090A5D155C12125E5EC30C0A0111090B2C0D2C0917150F07040D15080A0F07040C10100901060C011912';
wwv_flow_imp.g_varchar2_table(451) := '6404025ECC1512CFCFCF71070A27112C0D2C060308101516120A4B010B0F110C03060D0F0E080000000A00000000011A011C000B00170024002D0048006200770092009E00A70000370E012E023637361E0106272E010E021617163E0126373616171E01';
wwv_flow_imp.g_varchar2_table(452) := '0E02262726361716323634262206140733152322263D0122263D0134363B0106072322061D013315141637262B0122061D011416331506171617333E013D0132363D013407231514062B0122263D01233526363B01321E01151723353332363D01333534';
wwv_flow_imp.g_varchar2_table(453) := '262B0126273332161D0114062315140627220E011E023E01353426072226343632161406AB0914120B020A080D1E120618040A0906010505060F08032B091407050403090E11060902140308050508059C2222090E070B130E22070318060913028B0A0E';
wwv_flow_imp.g_varchar2_table(454) := '2E0E130B080107050726080B070B121302021E0202120109062E0507033422220103130906180307220E130B070EAE090E06030C111009100C040505080505D5060209111412060806191F26030104090A090304040C0F04050207050D0E0B0603060A1A';
wwv_flow_imp.g_varchar2_table(455) := '16030508060608A5130D0A220C08290D14080B09052A3502027A0A140E3B080C2C09070501020C082C0C083C0D4A3F010202013F3D050905070276130202352A05090B08140D29080C220A0DD90A10110C03060F080C1126050806060805000000050000';
wwv_flow_imp.g_varchar2_table(456) := '00000107012C00150019001D0021002500001315171507232735373533153335331533353315333503333523173315231723153307331523F41313BC1212132612261325A9BCBC267070707070707070012C1312F41313F41213131313131313FEE7F426';
wwv_flow_imp.g_varchar2_table(457) := '1338133813000000000400000000011A00F4000A00100014001C0000371F01150F012F01353F0117071F013F01071735271715373507150735A16C0C077373060B6B044B0A403911B15E5E715E2613F41D097E092020097E091D131303110F05771A6C19';
wwv_flow_imp.g_varchar2_table(458) := '196C1A6B0A3005300003000000000112011A0023002D00420000252735273534272627262322061D010706141F0116171637363F0107141E02323E0227263E021E011D0107170E01262F0126343F011506141E013E01262735170111165C02040B06050C';
wwv_flow_imp.g_varchar2_table(459) := '103909094404050B0A05045D0D0106070A080602960101030406041213010506014403035205060A09040304484F3A015C1706050B0402100C3D38081709440402040402045D2A04090704040708B3020403010105041713AA0202020244020803513504';
wwv_flow_imp.g_varchar2_table(460) := '0B090305090A033549000000000200000000011A011A000C0013000037323E01342E01220E01141E013723273717371796243C23233C483C23233C110D2B0D244F0D13233C483C23233C483C234D2B0D244F0D000003000000000116011B0006001C002F';
wwv_flow_imp.g_varchar2_table(461) := '000037333727072707371E0117161514070E010706272E033736373E01173637362734262726272606070E0116171E01760D550D4F240D56162910261E0F26163027141E1003070F26122B2126191902110F1D2613260F20172122102660560D4F240D8E';
wwv_flow_imp.g_varchar2_table(462) := '01141029372B2712170409160B222A2E152E190C0CF4091F2225172A101D0301090B184E48130A06000500000000010700FE0003000C0015001E002700003F0117073722263436321614060732363426220614161722263E013216140607323634262206';
wwv_flow_imp.g_varchar2_table(463) := '141644960E96020B11111711110C141B1B271B1B970C1101101711110B131C1C271B1B3EBC0CBC80111710101711131C271B1B271C5D101711111710131B271C1C271B00000400000000011A011B000B0017002300450000372315231533153335333523';
wwv_flow_imp.g_varchar2_table(464) := '272E010E021617163E0126273E011E020607062E0136173332161D01233534262B0122061D01331514163B01152322263735222637353436F413252513252554040A0905010405060F0903260914120B020A080D1E11060A2E0E131209062E0609130202';
wwv_flow_imp.g_varchar2_table(465) := '0F0F090E01090B0113712613252513B8030105080A090304030D0F14060109111412050907191E45130E0E0E06080806333F0102130D092C0C08320E1300000000040000000000CF011A000800110029003D00001332161406222634363722061E013236';
wwv_flow_imp.g_varchar2_table(466) := '3426172322061D010616331506163B0132363D01323627353426073526363B0132160715231514062B0122263D0196080B0B100B0B0810160115201616072E0E13010B09010E091E0A0D080B01134A0109062E0609011202021E020201070B100B0B100B';
wwv_flow_imp.g_varchar2_table(467) := '12161F16161F1654130E32080C2C090D0D0A2B0C08320E13543306080806333F010202013F000000000100000000012C0107002D000013071533353315173337353315173337353315173337353315233523152335231523352315233523151721373527';
wwv_flow_imp.g_varchar2_table(468) := '131313250A120A250A120A250A120A2538132F122F13381313010613130107137171670A0A67670A0A67670A0A67BC3939393939394B4B1212BC1300000400000000011A011A0005000E001B002D000037332E012715371E011716152335320717330E01';
wwv_flow_imp.g_varchar2_table(469) := '23222E013534363717323E01373635233522070E0217141E01BC4906281C012333060170092F135C073322192C192B20131B3020040271090A1A2B19011E33BC1B2806495C0633230A09708313202B192C19223307CC182B1A0A0971020420301B1F331E';
wwv_flow_imp.g_varchar2_table(470) := '000200000000010700E1001C00370000251523222627230E032B01352327373335333216171617333E0133070607060F01232726272E0127153E0137363F013317161F0116170107060B130736040C0F120A093C13133C090A110810083607130B090303';
wwv_flow_imp.g_varchar2_table(471) := '0503044D020409040F06060F040904024D040102050204CE830A09090E0A054B0A094B05050A12090A140102030605060C0803070183010704080B070603020402010000000200000000012D0107003600500000133315140607151E0117060731262F01';
wwv_flow_imp.g_varchar2_table(472) := '3537363F013637231617161F01150706070E0107330607231507273523353436373637352E0135173E02171E01171614070E01070622272E01272636373637364B83090A090D040908090C060503020402015B0201040506070B080407015E05040A090A';
wwv_flow_imp.g_varchar2_table(473) := '4B06040A12090A8C070E0F080E1504020204150E080F070E1604020101050C040107060B130736040B0603050A04024D04010205030304020503044D020409040F0607083C13133C090A110810083607130B980403010303150F070F080E150402020415';
wwv_flow_imp.g_varchar2_table(474) := '0E080F07100B040000020000000000E10107001C00370000133315140607151E031D01231507273523353436373637352E0135171617161F01150706070E0107332E0127262F013537363F0136374B83090A090E0A054B090A4B06040A12090A14020104';
wwv_flow_imp.g_varchar2_table(475) := '0506070B0804070183010604080C060503020402010107060B130736040C0F120A093C13133C090A110810083607130B0904020503044D020409040F06060F040904024D04010205030300000004000000000116011B00150028002E00310000131E0117';
wwv_flow_imp.g_varchar2_table(476) := '161514070E010706272E033736373E01173637362734262726272606070E0116171E01273717150727371537A1162910261E0F26163027141E1003070F26122B2126191902110F1D2613260F201721221026270E54540E123A011901141029372B271217';
wwv_flow_imp.g_varchar2_table(477) := '0409160B222A2E152E190C0CF4091F2225172A101D0301090B184E48130A06AB08381038085F4E2700020000000000F00107000500080000130715173735073517470F0FA9A58F010708E108701067BE5F00000000020000000000E2011A0015001F0000';
wwv_flow_imp.g_varchar2_table(478) := '1323152307151416171533353E013D01272335231523170E012E013D0133151483121D09251D121D25091C13263B0C221F137001193809421C2B033939032B1C42093838730C060D1C11383817000000000500000000010D00EF0007000F001F0027002F';
wwv_flow_imp.g_varchar2_table(479) := '000037232723072337331727262731060F01173533321615140607151E011514062327153332363534230715333236353423A0130F3E0E133811101701010102166E2913160E0B0E121B1419110E101C13170F10235E282890593E030707033E3790120F';
wwv_flow_imp.g_varchar2_table(480) := '0C12040101130F1217812F0E0C153E340E0C1A00000800000000011A01070007000B000F00130017001B001F0023000013331715072327351733352317231533272335330733352317331523272315330733152326E11212E11313E1E1CEBCBC13969638';
wwv_flow_imp.g_varchar2_table(481) := '4B4B132525394B4B4B4B4B010713BC1212BCBCBC13381312834B13253813251300020000000000EB00EB0007000B00003F0133171507232737153335420996090996091284E109099609098D84840000000500000000011A011A0007000B000F00130017';
wwv_flow_imp.g_varchar2_table(482) := '00001333171507232735173335231733152337231533373315231CF40909F40913E1E1122626712626252626011909F40909F4EAE113BCBC71719600000100000000011A00F400120000372723072723072315333F011733371F013335DD211323161216';
wwv_flow_imp.g_varchar2_table(483) := '353C0A0D1613231B094383717D5D511207325F84580612000004000000000107011A000C0019003C0040000013220E01141E01323E01342E0107222E013E02321E01140E01372E01220E020733343E01321E0214060F010E011715333534363F013E0234';
wwv_flow_imp.g_varchar2_table(484) := '26073315238D21382121384238212138211C301C011B30382F1C1C2F01050F110F0A04011705070605040204030E03040116040307040604042E1515011921384238202038423821E11C2F38301C1C30382F1C9E0506060B0D0705070301030508090410';
wwv_flow_imp.g_varchar2_table(485) := '0409050C0904080408040A0B0D0C5E16000200000000010A010D001000220000370E011532333216140623222635343637170E011532333216140623222635343637178623200305131C1A151B1D2F2F9924200305131C1A151B1D302E16EA163324182B';
wwv_flow_imp.g_varchar2_table(486) := '1B2A26354E1B23163324182B1B2A26354E1B23000008000000000119011A000C0019002500310043004E00520056000037343637270E01141617372E0137141617372E01343637270E0117273E01342627371E01140637071E01140607173E0134260716';
wwv_flow_imp.g_varchar2_table(487) := '0F01170727230727372E013E021E01070E021E013236342E01172307331727230738100F0E111313110E0F10140D0C0D090A0A090D0C0D900E0A0A0A0A0E0B0D0D0E0D0E10100E0D1113134B01050540110E680F11400504070D0F0D091E020401020506';
wwv_flow_imp.g_varchar2_table(488) := '0604050205112619113610C315260E0D112C312C110D0E2614101F0C0D09181A18090E0C1F4D0E09181A18090D0C1F211F860D0E2629260E0D112C312C420A08049108212108910610100901060C01010405050305070402272438252500000000050000';
wwv_flow_imp.g_varchar2_table(489) := '0000011A010B0015001E002A0033003F000037140733362E010E021E013735062E013E021E01073236342622061416173237170E01222627371E01373236342622061416173315331523152335233533E1011303203B402E0C1C39201A2E18062333311E';
wwv_flow_imp.g_varchar2_table(490) := '7A080B0B100B0B2E140E0D09191B19090D07122F080B0B100B0B371325251325259F040520391C0C2E403B20031303182F34270D132B110B0F0B0B0F0B2F0E0D090B0B0A0D07082F0B0F0B0B0F0B382613252513000E00000000011A00F4000F00130017';
wwv_flow_imp.g_varchar2_table(491) := '001B001F00230027002B002F00330037003B003F00430000252322061D0114163B0132363D013426072335330723153307231533373315231723153327331523372315332733152315231533073315233533152337231533073315230107CF080A0A08CF';
wwv_flow_imp.g_varchar2_table(492) := '070B0B07CFCF391212121313251313131313835D5D8326265E131313134B13131313381212382626F40B0883080B0B0883080B96831312131338123912121238133812131313125D121212131300000000030000000000E200E100080015001E00003732';
wwv_flow_imp.g_varchar2_table(493) := '3634262206141637140E01222E01343E01321E0107342622061416323696080B0B100B0B531423282314142328231413212E21212E21830B100B0B100B1314231414232823141423141721212E2121000003000000000116011B0008001E003100003732';
wwv_flow_imp.g_varchar2_table(494) := '36342622061E01371E0117161514070E010706272E033736373E01173637362734262726272606070E0116171E0196101616201601151B162910261E0F26163027141E1003070F26122B2126191902110F1D2613260F20172122102671152016162015A8';
wwv_flow_imp.g_varchar2_table(495) := '01141029372B2712170409160B222A2E152E190C0CF4091F2225172A101D0301090B184E48130A0600010000000000EB010A00190000131507233533272E010E02161F0107272E013E02161F0135EA094230120D2223190A0A0D610D62100C0C212C2C11';
wwv_flow_imp.g_varchar2_table(496) := '0D0107420912120D09091923230C620D61112C2C210B0B110D270000000A00000000012A012C0015001D0021002E00320036003A003E0042004700003707273723220614163B0115232E0134363733273717132327353733171527333523373317150723';
wwv_flow_imp.g_varchar2_table(497) := '35333523152335172315330733152317231533373315231723153327313315238B2B0E1A3C0D11110D0B0B141C1C143C1A0E2B45780A0A780A78646446780A0A32286414143C3C3C3C3C3C3C3C143C3C3C14142A2A16F32B0E1A11191214011D281D011A';
wwv_flow_imp.g_varchar2_table(498) := '0E2BFEFF0AA00A0AA00A8C780AA00A148C3C46821414141414C8143C143C140000010000000001090107001D000037233533171523350E011E013E022627371E020E032E023E015832410A131A111A39402B05241F05192512041A2B33312512041AF413';
wwv_flow_imp.g_varchar2_table(499) := '0A4125133F3C1F0B3041350A12082330332C1D07102330332C0000000002000000000108010700110015000013331537170717072715233507273727371707331523BC1230093030093012300930300930964B4B01073B1D101D1E101D3A3A1D101E1D10';
wwv_flow_imp.g_varchar2_table(500) := '1D5B4B00000500000000012D01120012001F002C0032003800001333171526273523153314172335333523273517220E01141E01323E01342E0107222E01343E01321E01140E0137273717071727170717372711FE09090AEA61144E3A6B0AD715241515';
wwv_flow_imp.g_varchar2_table(501) := '242A2415152415101B10101B201B0F0F1B101A1A0913134B1212081B1B0111096C070556B0201A131409C46C15242A241515242A2415880F1B201B10101B201B0F271B1B091213111213081B1B00000000020000000000F2011A0006000D000037273727';
wwv_flow_imp.g_varchar2_table(502) := '07151727170717373527F24B4B0C5050AE4D4D0C5252794A4B0B500C50564D4C0C530B52000100000000011A00A900030000252135210119FEFA010696130000000B00000000011A011A000B00150026003A0044005800610073007B007F008600003736';
wwv_flow_imp.g_varchar2_table(503) := '3216140622270723353315141632363426220615072737173534363B01152322061D01371737333534232206071536320F010615141633323F01151406222635343F010723350623222635343F01342207353E0137321507350706151416323617323735';
wwv_flow_imp.g_varchar2_table(504) := '062226343632173526272206141627373317150723273715333527373317150735DA040E08090E03010B0B0407040307058C270C130F0B2C2C0405120C3B0D12040903070F010B0E070608040105060306072C0C040806070E0B0E07030904110C070603';
wwv_flow_imp.g_varchar2_table(505) := '0604370905050C07080B0403080C0E0D7D12A91313A91212A97012841212FA090E180F07064A340407080E0708054E280C131D0A101106031D120C0D201703020C0509010310070909120404070402070101AF0709090710030109050C020201170B0401';
wwv_flow_imp.g_varchar2_table(506) := '010702040612030E04080E09040E0201101A0F4B13135D13135D5D5D2613135E1371000000060000000000E2011A0010001D0027003A00420046000037173727073534363B01352322061D01271733163E0134262207272315333D013436321614062226';
wwv_flow_imp.g_varchar2_table(507) := '070623222635263633321715262206141632372707151733373527073315233C2B290D1306031D1C0C10146F0105150D0B1606011010060B06060B0610070E10130116110C0607110B0A11085E1313831313838383E62B2A0D131E040612100C1E142F09';
wwv_flow_imp.g_varchar2_table(508) := '01121E110B275C1B07070809110A099605141012150313050B130B055B1370131370131370000000000100000000010701040015000013071517372733321617161D013335342E022B0137764B4B0E3D242734101E1311263C29223B01044C0D4B0D3C10';
wwv_flow_imp.g_varchar2_table(509) := '101F470606273926133A0000000900000000011A011A0028002C00300034003B004B00530057005B0000372335333523220E021D01061617161733352322272627343D0134353637363B0115231533373523272315330733152315331523172335331523';
wwv_flow_imp.g_varchar2_table(510) := '273733171507231523352322263D0134361733352322061E013B01352327333523F4A94B50060D0904010B0A060605050302060202060203AE4B540A1383131313131313130505380517425409092F1312080B0B11090904060105202626133939719612';
wwv_flow_imp.g_varchar2_table(511) := '050A0C06B20A100402011301030503020A020305030126130A547113131213138338381CEA09710913130B085E070B701306080513123900000700000000011A012C000F001F002F003F0047005700600000373132161531140623312226353134361731';
wwv_flow_imp.g_varchar2_table(512) := '321615311406233122263531343637313216153114062331222635313436373132161531140623312226353134360733371707232737172315331E013236373335232E012206171406222E013E01169F0406060404050504040606040405050404060604';
wwv_flow_imp.g_varchar2_table(513) := '04050504040606040405050513440D540D550E0C383804253125033939032531256C1B271B011C271BE105040406060404052506040405050404064B060404050504040625050404060604040579450E54540EAD13182020181318202021141B1B271B01';
wwv_flow_imp.g_varchar2_table(514) := '1C000000000400000000011A011A000900130023002C0000371533351737272307173715333517372723071F012315331E013236373335232E012206171406222E013E01169613440D540D550E4413440D540D550E0C383804253125033939032531256C';
wwv_flow_imp.g_varchar2_table(515) := '1B271B011C271BFC1212440D54540D0C2E2E450E54540E3413182020181318202021141B1B271B011C00000000040000000001070108002F00380041004A000025342E010E01161715140F0127263D013E012E01220E0116171514161F01150E011E0132';
wwv_flow_imp.g_varchar2_table(516) := '3E01262735373E013D013E012734363216140622261714062226343632163722263436321614060107141E1704100E053434050E1004151C1504100E0807330E1004151D1503100D3208080C0FBB0B100A0A100B670B100B0B100B2F080B0B100B0BE10F';
wwv_flow_imp.g_varchar2_table(517) := '1503131C19031406031A1A03061403181C12121C180314080E031B1804171C13131C1704181A040E081403140D080B0B100B0BA1080A0A100B0B8E0B100B0B100B000000000300000000011A012C000F001800220000372315331E013236373335232E01';
wwv_flow_imp.g_varchar2_table(518) := '2206171406222E013E0116273533153717072327375E383804253125033939032531256C1B271B011C271B3813440D540D550E4B13182020181318202021141B1B271B011C5E7979450E54540E000000000300000000011A011A00090019002200003715';
wwv_flow_imp.g_varchar2_table(519) := '333517372723071F012315331E013236373335232E012206171406222E013E01169613440D540D550E0C383804253125033939032531256C1B271B011C271BFC6666440D54540D6D13182020181318202021141B1B271B011C0000000006000000000107';
wwv_flow_imp.g_varchar2_table(520) := '011A0026002A002E00320036003D0000253527232207060706071514171617163B01352322272627263D0134373637363B011523153337273533152733152315331523172315331707233533152301070AB706060D05020103050D060605050302060201';
wwv_flow_imp.g_varchar2_table(521) := '0102060203AE4B540ABCA996131313131313130917053805719F0902060D0606B206060D05021201030503020A0203050301261209429696831313121313671C38380000000400000000011A011A000B00140018001C0000133317150723072735232735';
wwv_flow_imp.g_varchar2_table(522) := '17333523153317153F01331523153335231CF409097F36102F097A7AE12E0A280712121212011909BC0936072F09BCB2A9A90A2128995E25120000000004000000000107011A0009000E001A001E0000131F011507232735373307333527231723153315';
wwv_flow_imp.g_varchar2_table(523) := '3335333523352307331523C9380512A913137070A939704B252513252513255D5D0114380EA81313E112F3A8394B13262613258313000000000700000000011A012C00080011001A00230030005600660000371406222634363216071416323634262206';
wwv_flow_imp.g_varchar2_table(524) := '171416323634262206171406222634363216073637170E01222627371E013F01140607153332161D011715071514062B0122263D012735373534363B01352E0135343632160722061D0114163B013E013D0134262396161F16161F16380B0F0B0B0F0B38';
wwv_flow_imp.g_varchar2_table(525) := '161F16161F16380B0F0B0B0F0B2E0E0B0D09191C190A0D09180D120A092F182013122118701820131320182F090A101810541016161070101616109610151520151510080B0B100B0B0810151520151510080B0B100B0B45030B0D0A0A0A0A0D090702B7';
wwv_flow_imp.g_varchar2_table(526) := '090F030121171313251313172121171313251313172101030F090C10103B160F711016011510710F16000000000600000000011A011A00110016001B0028002E0037000001220706072307151F0233373536373635073306072717273637152F01363736';
wwv_flow_imp.g_varchar2_table(527) := '373637060706070607352335231537362E010E011E013601102F2E25244E090370073809211317F3311713076A071B17404010152324302F031E172417482513B7060513170D05131701191713210938077102094E24252E2F54181B076A071317311540';
wwv_flow_imp.g_varchar2_table(528) := '181724171E032F30242315381325389009170D0513170D0500040000000001250107001E00280035003E0000373537331F0133171533170F0123363733372326273F013335232F012315061714062226343632161533140E01222E01343E01321E010732';
wwv_flow_imp.g_varchar2_table(529) := '3634262206141613095E06116C0A15093209460705332D6C0608030655670710500A5511171111171026121E231F11111F231E1242141B1B271B1BB7460A03100A2E0C8406080A71070603032503103105570C10101810100C121E11111E241E12121E41';
wwv_flow_imp.g_varchar2_table(530) := '1C271B1B271C0000000400000000011A0107001C00260033003C000037331715072336373337231526273F013337232F0123150607353733170714062226343632161533140E01222E01343E01321E01073236342622061416917F09096C070556017708';
wwv_flow_imp.g_varchar2_table(531) := '0907067A017A0710500A09095E071011171111171026121E231F11111F231E1242141B1B271B1BF40ABB09080A840106040603130310310507460A039D0C10101810100C121E11111E241E12121E411C271B1B271C00000000030000000000F400F40004';
wwv_flow_imp.g_varchar2_table(532) := '000E0018000037233532162715321E011533342E010715321E011533342E015E261016262E4E2D133356331A2B19131F33382616AC132D4E2E3356334B13192B1A1F331F000300000000011A00F40009000E0012000037173337352F01230F0117273733';
wwv_flow_imp.g_varchar2_table(533) := '1727331707137C0E7C3E077C073E836F3574356F322254A57C7C0E3E03033E766F353522225300000003000000000120011A000500080012000013071517373507351F01331707271523350727210E0EA9A48E300D2F0D1F131F0D011908E107701067BE';
wwv_flow_imp.g_varchar2_table(534) := '5F0B2F0D1F66661F0D000000000500000000011700F80006001000200032003900003F0135271517072737171507353727152317260E011E0136373136353427312E010736173116171E011531160E012E01373136170723273717379F779A86636A0E9F';
wwv_flow_imp.g_varchar2_table(535) := '432E86122118260E11292E100F1308152D0D13110D06080116231E0F06054A230D110C0C1D2F500E67155942AC076A0E2D151F59400E01192D2C17081314161B15080A180A01020D06130B101D08122012111323110D0C1D000300000000011601070005';
wwv_flow_imp.g_varchar2_table(536) := '0008000F000013071517373507351707373527151707340E0EA9A58F56A4A48E8E010708E108701067BE5F756D106E175F5F00000003000000000120011A000500080012000013071517373507351F01232737173533153717220F0FA9A58E3D0D2F0D1F';
wwv_flow_imp.g_varchar2_table(537) := '131F0D011908E107701067BE5F8E2F0D1F66661F0E000000000400000000011601070009001C002E003500003F011715073537271523072606070616171E0136373136353427352E010736173116171E011531160E012E01373136170723273717375E0E';
wwv_flow_imp.g_varchar2_table(538) := 'A96C568E1303192808040204092B311110140916300E14120E0708011824201006054F250E120D0C1FFF0871104817395F440F011A190C180C16190A1315171E1501080B190A01020D08140B111F08132113131525130D0C1F0000000004000000000116';
wwv_flow_imp.g_varchar2_table(539) := '01070009001C002E003A00003F011715073537271523072606070616171E0136373136353427352E010736173116171E011531160E012E013731361727071707173717372737275E0EA96C568E1303192808040204092B311110140916300E14120E0708';
wwv_flow_imp.g_varchar2_table(540) := '011824201006052C160C17170C16170C17170CFF0871104817395F440F011A190C180C16190A1315171E1501080B190A01020D08140B111F081321131317170C18170C17170C17180C000000000400000000011A011A000F0018001C00260000252F0123';
wwv_flow_imp.g_varchar2_table(541) := '071523071517333735333735072335331533353317073533151723352F022335331701161C06A0092F0909BC092F094BA812710F165D257126031C065E9217FA1C03092F09BC09092F09A0CEA83939160F25254B5E061C0326170000000500000000011A';
wwv_flow_imp.g_varchar2_table(542) := '0119001400180020002300270000131F01152307352723152335231533072327353733073335231F01150F01273F010F013F01173727CF1F060A091F067125380A2E13139C3F26267A1C72390C1C72670A13030F610F01131F0E06090F204B4BBC1212BC';
wwv_flow_imp.g_varchar2_table(543) := '134B39391C0D721C0D38728713091D0F610E0000000300000000011A011A0009001200160000131F011507232735373307153335272315233533153335FA1C0309F40909D8CEE11722834B2601171D06D80909F40912E1CA174B4B393900000000060000';
wwv_flow_imp.g_varchar2_table(544) := '0000011A010700030007000E0015001C0023000037333523173315232723353733152337152335233533073315072335332333152327353338BCBC2670703813094238F31239420912094239E1384209134B96254B4B410A130941381396420912120942';
wwv_flow_imp.g_varchar2_table(545) := '000600000000011A011A0006000D0014001B00230027000037233533353315373523151733350715333533352B01153315333527370723273537331707231533422F2513A913092F3813252FD72513099F098409098409254B4BE113252F0A252F0913B2';
wwv_flow_imp.g_varchar2_table(546) := '2F251313252F091C09095E09091C260000030000FFFF012C01100012001F002F000013220E01151416170717371633323E01342E0107343E01321E01140E01222E0117072327371737331737331715270723961727160C0B450D46151A17271616275912';
wwv_flow_imp.g_varchar2_table(547) := '1E241E12121E241E1255280E1C0D16280D29280D1F25290D0110172716111E0C450D460E17272D271754111E12121E231E12121E82281C0D152828281F1A2528000400000000011B011F001C00290032003A0000370E01171617061715270727372E013E';
wwv_flow_imp.g_varchar2_table(548) := '011E01151407262735342E0106173E011E020E022E023617163716372706151437173627362623226C13090B080F020109470E471705244142290108091D2F3227102924160312222824160211121117120F4F0A184E0B0101211812EE133518120C0909';
wwv_flow_imp.g_varchar2_table(549) := '0306450D4519453A1913372307080706021A2A140A640B03122128241702112228245B1101010B4E0E1218464F0F121721000000000200000000012C012D000F001D000013220E0116170717371E013E012E012315222E01343E01321E01140E0123BF1F';
wwv_flow_imp.g_varchar2_table(550) := '33190914640E641B43381614372117271717272E2617172617012C21383C16730C72150226404128BB16272E271616272E271700000200000000011A01100006000D000013371715072737170737271F0115130EF8F80E1D1418D1D11865010808701170';
wwv_flow_imp.g_varchar2_table(551) := '086F0957625F560212000000000600000000011C011A00030007000B001D0021002900003733152315331523153315231721373335343E023B01321E021D0133073335231727231523352307714B4B4B4B4B4BABFEF4182303050704700407050323A670';
wwv_flow_imp.g_varchar2_table(552) := '70A60E1596150EF4135E1213134B5EA90307050303050704A826CFF438252538000600000000011A0107000C0010002E00370055005E00001333171523352315331523273517333523173526270727372637273717363735331516173717071607170727';
wwv_flow_imp.g_varchar2_table(553) := '0607152714163236342622061735262707273726372737173637353315161737170716071707270607152714163236342622061CF40912E1838D0913E1E15D0504110A120101120A1105041305041209120101120912040517080B09090B096505041209';
wwv_flow_imp.g_varchar2_table(554) := '11010111091204051205041209110101110912040517080C08080C0801070A7A39841209CE2F26A91501030A110A05050A100A0401151501040A100A05050A110B0401152F0608080C08086D1402030A100B05050A100A0302151502030A100A05050B10';
wwv_flow_imp.g_varchar2_table(555) := '0A0302142F0609090B0909000006000000000107011A0007001B00230037003F0053000037273537331715072723152335231523352315233523153335231523072735373317150727231523352315333523152335231523352315231737352723071517';
wwv_flow_imp.g_varchar2_table(556) := '37353315333533153335331533353315333533152F0909CE0A0A4113131312131313BC26128D0909CE0A0A8C131313BC2612131313128C0A0ACE090909131313121313131226CE0A380909380A391313131313132626138309380A0A3809381313262613';
wwv_flow_imp.g_varchar2_table(557) := '131313138309380A0A380913251313131313131313250000000400000000012C012C001700370043004E00003717150717072707232707273727353727371737331737170737352F013727072F01230F012707170F01151F010717371F01333F0117372F';
wwv_flow_imp.g_varchar2_table(558) := '013633321615140E012E01361716333236342E010E0116F834341E2B2C0B3C0B2C2A1D34341D2A2C0B3C0B2C2B313232071C112B110A190A102B121D073232071D122B100A190A112B111C600B0D1219141E1B0B08190606090C090F0E0605BF0B3C0B2C';
wwv_flow_imp.g_varchar2_table(559) := '2A1D34341E2B2C0B3C0B2C2B1E34341E2B6C0A190B102B121D073232071D122B100B190A102B121D073232071D122B4B0719120F18060E1D1D2D030C110B03070E0F0000000400000000010700FE00190023003C0046000037321617333216140607230E';
wwv_flow_imp.g_varchar2_table(560) := '012226272322263E0137333E01331722061416323634262337321617333216140607230E01222627232226343637333E0117220614163236342623710C150368040605036A03151915031D04060104031F03150C01080B0B0F0B0B084C0C15031D040605';
wwv_flow_imp.g_varchar2_table(561) := '031F031519150368040504036A03150D080B0B0F0B0B087A100C060705010C10100C050805010C10130B0F0B0B0F0B96100C050805010C10100C060705010C10130B0F0B0B0F0B000005000000000119011A000C0025003D004000420000372307151733';
wwv_flow_imp.g_varchar2_table(562) := '37352315233533172335343637353436321F0115070622263D010607060F012337220E010F0133363736373633171416323F01272E01061507323023315E420909CE0A13BB3813132A210F1507454507150F150A040201134C142115010104050A0F1709';
wwv_flow_imp.g_varchar2_table(563) := '09010306024444020603390101E109BC0909382FA9702F213406180A0F08491949080F0A140511070A067A132013210F0B0F040128030302494802010403A200000300000000011A011C0024004500510000372E05373537323E02373637361716171617';
wwv_flow_imp.g_varchar2_table(564) := '1E03331715140E04072715141E031F0136373E043D01232627262F01262726070E0307173E012E01220E01161707339B0F1C1A16110A01090A10110F070B0C12130C0B0605080F11100A09091117191C0F6C080F15180D160C0B0D18150E090B090A1411';
wwv_flow_imp.g_varchar2_table(565) := '09080A0E0F091113130A68090A0410140F04090A082518091316191E23123C0902030605070405030106030305060302093C12231E19161309D133101D1B1715080F07080914171B1D10330102040B0504020204030B080401510412130D0D1312043100';
wwv_flow_imp.g_varchar2_table(566) := '000300000000011B0107001500190023000037351735272307151F013735333735071523352F01330727351F01331523170727353717CF1209A909065E0C420912390644834C4B4B3A5D5C1E0E2E2F0DE501132A0A0ACA09200913092A130E9C0818D419';
wwv_flow_imp.g_varchar2_table(567) := 'AD192E131E0D2E0D2F0D0000000300000000011B01070017001B00250000371537352723071531151F013735333735271523352F01330727351F01233533273717150727CF1209A909065E0C420912390644834C4B4B7B5E5D1E0D2E2E0DE51D13220A0A';
wwv_flow_imp.g_varchar2_table(568) := '09C1092009130922132C9C0818D419AD1940131E0D2E0E2E0D000000000500000000011D011D000C00190022002B00380000133E011E020E022E0236171E013E022E020E021637140622263436321617140622263436321607222627071E013E0137270E';
wwv_flow_imp.g_varchar2_table(569) := '014D1D473F2804203B453F28041E29193C3622041B333B3622041A3C0B100B0B100B5E0B100B0B100B42101A08100A252A230910071C010314051F3B464027041E3C453FB710051B323D3621041B323C355F080B0B100B0B08080B0B100B0B53100D0912';
wwv_flow_imp.g_varchar2_table(570) := '15011613080E1100000300000000011A011A00080031005800003714062226343632162722061514170723153315333537161733152322061522061E013B013E0134262334262335342E01230734363B0132161D01173332161D0133321614062B012226';
wwv_flow_imp.g_varchar2_table(571) := '34363B013534363B01373527232226960508060608052F131C0815221D12150C0E1C1210161016011510A90F16160F1610111F1142100C26131B0A09080B13080B0B08A9080B0B08130B081C0909260C10EA0405050806062B1B140E0B15131C21150701';
wwv_flow_imp.g_varchar2_table(572) := '25160F162016011520160F1642111F112F0C111C134B0A0B08120B100B0B100B13070B0A38091100000700000000011A0107000A000E0012001A001E0022002C000013071533353315371735270733152307231533270715173337352707353315272315';
wwv_flow_imp.g_varchar2_table(573) := '333723152707173337270783121284030F1271262638262638131383131383831325255E13160D260D260D1601071338382E030F3A13262539254B135E12125E13715E5E39269648160E26260E16000000040000FFFF0107012C002C0035003E00470000';
wwv_flow_imp.g_varchar2_table(574) := '25342E010E021E01170E012B012207353E012E01220E011617150E011E023E0126273E013B013236373E0127343632161406222617140622263436321637222634363216140601070E181A160904120D05120B2516101215031B241B0315121216031924';
wwv_flow_imp.g_varchar2_table(575) := '1C06121205120B25121D061118CE10181010181038101810101810670C1010171111C50D170C0210191A13040A0B0F5B031D241818241D0372041C24190216241E050A0B1511021B490C1010171111C20C10101711116E11171010171100000000020000';
wwv_flow_imp.g_varchar2_table(576) := '0000011A011A002C00570000371632363F013E013F013E022E012F012E012F012E020E010F010E010F010E021E011F011617161F0116171632363F013E013F013E022E012F012E012F012E020E010F010E010F010E0114161F011E011F011665050D0A02';
wwv_flow_imp.g_varchar2_table(577) := '08040E0A1A050603020607190A0F030902090909060208030F091A0506030206061A0C090403080278040A0801050107050E0505010305030F04070105020608060502040206050E050505050E0507010501610307061A0A0E040802060909090209030E';
wwv_flow_imp.g_varchar2_table(578) := '0A1A0606020307041A0A0E030901070909090208040B06071A064F0305050E05070105010707070501050107050E0505010305030E0507010501080A0801050107050E05000400000000011A011A002C0040006B007F0000371632363F013E013F013E02';
wwv_flow_imp.g_varchar2_table(579) := '2E012F012E012F012E020E010F010E010F010E021E011F011617161F01163F01171E011F01070E010F01272E012F01373E01171632363F013E013F013E022E012F012E012F012E020E010F010E010F010E0114161F011E011F01162F01373E013F01171E';
wwv_flow_imp.g_varchar2_table(580) := '011F01070E010F01272E0165050D0A0208040E0A1A050603020607190A0F030902090909060208030F091A0506030206061A0C0904030802070A0805150E1A1A0E1505090904150E1A1A0E1476040A0801050107050E0505010305030F04070105020608';
wwv_flow_imp.g_varchar2_table(581) := '060502040206050E050505050E05070105010D0303090D030101030D090303090D030101030D610307061A0A0E040802060909090209030E0A1A0606020307041A0A0E030901070909090208040B06071A06871A1A0E15040A0904150E1A1A0E15050909';
wwv_flow_imp.g_varchar2_table(582) := '0514C80305050E05070105010707070501050107050E0505010305030E0506020501080A0801050107050E05320101030D090303090D030101030D090303090D000300000000011A011A0007000B000F0000012307151733373507233533172335330107';
wwv_flow_imp.g_varchar2_table(583) := 'CF1212CF12835E5E715E5E011912CF1212CFCFCFCFCF0000000300000000011A011A0007000B000F0000012307151733373507233533352335330107CF1212CF1212CFCFCFCF011912CF1212CFCF5E135E000000000300000000011A0112004D009C00A6';
wwv_flow_imp.g_varchar2_table(584) := '00003726232E0123150E01071516171617323106070607061D0114163237330607230E011506163B01163E0227262F012E01363F0133321716171636373635342726272607060706072627353426271716070607062B0134363B01352636372706072322';
wwv_flow_imp.g_varchar2_table(585) := '0706263E013B0132363F010626273E01373332171617161F0133352636373E013736171E011715140E01262726070E010706161F011E0107262F01220614163E01342623680101020F0A161E040511080A01100A0804030B0F072705020611170104047D';
wwv_flow_imp.g_varchar2_table(586) := '101C160901010D02070503030203030306070A1205020D0C11181A120D0A0505070F0C640202030E08096E0A081801120E0C08033C03020505040A0713040501060F1C0A0421150208070A100806010301020104130E13100D1102050708040A0B070902';
wwv_flow_imp.g_varchar2_table(587) := '030708020A010601078304060607060604FA01090C19092317080A06040202070608060706070A03090A021B120405010B171D10161103080B09020101040201090906071116120B0D05030E0B0E0707030B1001B90F090E0803070B0A0D140111030201';
wwv_flow_imp.g_varchar2_table(588) := '02030B0805031802090A151C010305150B0A01010717060C13020409081B0C0207050202020603020A070B1708030C1E0D0D0C700508060105080500000500000000011A011A0009000D000F0011001B0000372707231707371727370733370F02372307';
wwv_flow_imp.g_varchar2_table(589) := '333717330717270737B41E1E65521F50501F52ED5218181018AA52522C0E0E2C240E24240EB7626240643E3E6440094F4F345084112D2D1C2D1C1C2D000100000000011A011A0009000037270723170737172737B41E1E65521F50501F52B7626240643E';
wwv_flow_imp.g_varchar2_table(590) := '3E644000000400000000011A011A0009000F0010001200003F0117330717270737271F0127372327351723781E1E65521F50501F5283240E242C0E6A52B7626240643E3E6440471C2D1C2D334F0000000003000000000116011B00030019002C00003733';
wwv_flow_imp.g_varchar2_table(591) := '1523371E0117161514070E010706272E033736373E01173637362734262726272606070E0116171E01714B4B30162910261E0F26163027141E1003070F26122B2126191902110F1D2613260F201721221026BC4BA801141029372B2712170409160B222A';
wwv_flow_imp.g_varchar2_table(592) := '2E152E190C0CF4091F2225172A101D0301090B184E48130A06000000000500000000011A00F400090013001C0025002E00003733352307151733352337231533152315333735073236342622061416371406222634363216173236342622061E0126121C';
wwv_flow_imp.g_varchar2_table(593) := '09091C12EA1C13131C09BB080B0B100B0B530B100B0B100B25080B0B100B010AE1130AA80A13A91396130AA8670B100B0B100B13080B0B100B0B1B0B100B0B100B000000000200000000011A010700090013000013071517333523353335173735272315';
wwv_flow_imp.g_varchar2_table(594) := '331523151C09092F2525C509092F262601070ACE0912BC13E109CE0A13BC1200000200000000011A00F40007001F00003F013317150723273723152337270715173727333533273717150727372315331309F40909F409F4714C270D38380D284D49270D';
wwv_flow_imp.g_varchar2_table(595) := '37370D274971EA0A0AA80A0A9F41270D370E370D2812280D370E370D274100000004000000000114011A002000240028002C0000373337352723072335373527230715173337151733151733373527230723353315371707271F01072F023717D50D3219';
wwv_flow_imp.g_varchar2_table(596) := '0D225E23260D4B250E150958180E32190D235E4F380C250C250C250C90183D1976320D192218220E254B0D26166D090A19320E19234B092A0B260C380C260C78193D1800000700000000011A011A00190035003E0047005000590062000013220E021D01';
wwv_flow_imp.g_varchar2_table(597) := '1E013E011E020E01161733323E01342E012307232E013526373634262207062722263D01343E01321E01140E012337140622263436321617140622263E0132162732362E012206141637140622263E013216171406222634363216961A30251401131A14';
wwv_flow_imp.g_varchar2_table(598) := '1C140114030E0F0B233D23233D23010A040502080F1F2C10070A02041F333D341E1E341E120B100B0B100B380B100B010A100B83080B010A100B0B8B0B100B010A100B130B100B0B100B01191425301A080E0D041301141B151C1501243C473C24F50104';
wwv_flow_imp.g_varchar2_table(599) := '040C08102B201008020403071F331F1F333D341EBC080B0B100B0B8B080B0B0F0B0B560B100B0B100B13080B0B100B0B40080B0B100B0B00000400000000011A00F400030007000F0013000037331523172315332737331715072327371533354B969696';
wwv_flow_imp.g_varchar2_table(600) := '9696CE13E11212E11313E1BC132612701313961313969696000600000000011A0107000C00150019001E0022002600003F013317150723353335231523173527230715173337271523353727353315273315230723153383137112124B4B711326137013';
wwv_flow_imp.g_varchar2_table(601) := '13701313708B084B4B4B4B264B4BF413135E13135E38391313135E12125E5E5E13080B1338135D13000700000000011A0107000C0011001A001E00220026002A000001230715333533152315333735073315232707230715173337352715233533073315';
wwv_flow_imp.g_varchar2_table(602) := '2315331523373315230107711313714B4B12704B4407265D131370131370705E4B4B4B4B714B4B01071338385E13135E38130707135E12125E13715E131213139613000000020000000000EF011A000B0012000013373317073317072737232717073723';
wwv_flow_imp.g_varchar2_table(603) := '3723078B113E0F29210E861E281711473685453E3E40010F0A1D40208916481B0963895E84000000000400000000011A0107000B000F0013001700002527230F01151F01333F0135072735173727371F01073537010F5E11830A0A5E11830AA054540957';
wwv_flow_imp.g_varchar2_table(604) := '7D57077A7AD82F421154112F421154912A462610273F2C573D4939000003000000000107011A0009000C00130000252F01230715173337350723350735331517331501043E06910909CE0A133884710942D93E0209F40909B60439E1E142099600020000';
wwv_flow_imp.g_varchar2_table(605) := '0000011B00E200170021000037220607232E010E01141E013637331E023E022E0207222634363216140623D81925033A04171D12121D17043A02151F221C0F02121D11141B1B271B1B13E120180D1003151D1504100E111B0E04131E231C11701B271B1B';
wwv_flow_imp.g_varchar2_table(606) := '271C0000000500000000011A00EB00120025003F004A0065000037163E0137362736272E0123220735231533353736173617161516070E012706263735263736270E010F0115373637321615070E01141633323F0115333536261714062322263437363F';
wwv_flow_imp.g_varchar2_table(607) := '01171637163F013507062226343617321F0135272622060706141716870A1412060D01010C061009100C13131005060B060701090309060B0F010108045009110702080B0F0709170E15130E0B0906110113010F0B060904080A139C080A0E0C03090917';
wwv_flow_imp.g_varchar2_table(608) := '10120D0A0808030A1613070F0E065F060108081116140F07070B348F064C030101090A0D0F0D04060101110B0B0C0A04160105050117070A010C080401121A120605093F1017390D11080C040501032F0401010801160607141C16010505160105080711';
wwv_flow_imp.g_varchar2_table(609) := '2A100700000800000000011A010700030007000B000F00130017001B001F0000252335330723153327231533172315332723153337231533271523351723153301195D5D1226264BA9A925CECE5E7070965D5D8383705D5DE1134B1313135E124B131313';
wwv_flow_imp.g_varchar2_table(610) := 'A9393913130000000004000000000107011A000B000F0013001700003727230F01151F01333F0135072735172737170717073537FD5D135E09095E135D0A7A5555505959595E5454E1383810711038381071A332612E413535314332652E000000050000';
wwv_flow_imp.g_varchar2_table(611) := '0000011C011A0008000C0010001D0029000013331516173523153717270733273F0117373E011E020E022E0236171E013E022627260E01164B960A09BC1328154B9676200B2B2A0F23201402101E221F14020F190A19170E020C0A1026160801074B0104';
wwv_flow_imp.g_varchar2_table(612) := '629F212A25831338134B780A020F1E23201302101D22205407020B151A16070B08202600000200000000010701070046008D0000373523220E0107310607310617151407310607062B011533321715161715161731161D010617151617311E0217333523';
wwv_flow_imp.g_varchar2_table(613) := '222E023D01342627262736373E013D013436373633171533323E0137313637313627353437313637363B013523222735262735262731263D013627352627312E0207231533321E021D01141617161706070E011D0114070E0123710209110C0303010101';
wwv_flow_imp.g_varchar2_table(614) := '02040A050601010605050304020201010103030D10090202060A07040202050909050202090705064D0109100D030301010102040A050602020605050304020201010103030C11090101060A0704020205090905020208030A06F413070D080808080810';
wwv_flow_imp.g_varchar2_table(615) := '06050A050212020102030103050506100808010708080D06011304080A0619060C050B07070B050C0619090D0402BC12060D08070908081006050A050212020102030103050506100808010708080D07011204080A0619060C050B07070B050C06190C08';
wwv_flow_imp.g_varchar2_table(616) := '04040000000200000000011A011A001B001F00001315331523153315231523352315233523353335233533353315333507153335CE4B4B4B4B124B134B4B4B4B134B4B4B01194B124B134B4B4B4B134B124B4B4B5D4B4B00000800000000011A011C000E';
wwv_flow_imp.g_varchar2_table(617) := '0019001D002900350042004F0053000013161716140E012322263534363736173637342E010E01141E0137071737173315331523152335233533271707170727072737273717372E01220E011E033E0207060706272E013E0216171637231533360A0402';
wwv_flow_imp.g_varchar2_table(618) := '060C080A0F08070A0406010506060405064C640D6353122F2F122F2F6C0D21210D21210D21210D213A030C100D0501070B0D0C0701110104060502020105060501058D4B4B01170409050C0B080F0B070D0304250307030602030507050222640C63872F';
wwv_flow_imp.g_varchar2_table(619) := '122F2F12250D21210D21210D21210D21700709090D0D0A0601070A0D08040103050105060501020205341300000300000000011900E1001B00220029000037233534262B011514163B011523353332363D01232206071523353317273717150727232737';
wwv_flow_imp.g_varchar2_table(620) := '27071517CE1206041305040A390A0405120405011270371C0E22210EA71C1B0E2122BC0904056704051313050467050409254C1C0D220E210E1B1B0D210E2200000200000000011A011B001F0043000037222E0137363726343736373E011F0107173717';
wwv_flow_imp.g_varchar2_table(621) := '1614060706070E012706070637220706070E011F01070607061E023237363F011716363736373E0135342707273726350E130208234005060A151129120C36173805060C0B060810251244200989121006050E0708030444230301070608031E4905050F';
wwv_flow_imp.g_varchar2_table(622) := '200E0605090901313030061313190A263E0E1E0E180D0B0408053817360C0F201E0B06050B0407451E08F50B03050E261206044225050B0702031B4B0402070309030509170D06063030310100020000000000F4011A0007001B00001307151733373527';
wwv_flow_imp.g_varchar2_table(623) := '07353315233533352335333523353335233533354B131396131396969626264B4B26264B011912E11313E1122513E1121326122613251300000800000000011A011A0009000D001100150019001D00210025000013071533353315333527033533153723';
wwv_flow_imp.g_varchar2_table(624) := '153337331523372315333733152333352315273315232F0912CF1209EA122613131312123813131312125D12261313011909D8CFCFD809FEFA131313131313131313131313131300000700000000011A01070007000B001F002900360040005200001307';
wwv_flow_imp.g_varchar2_table(625) := '15173337352707353315273335342322060715363215070615141633323F01151406222635343F011723152335331736321614062227151416323634262206173237350622263436321735260726061416261313E11212E1E1A30D12040903070F0C0E07';
wwv_flow_imp.g_varchar2_table(626) := '0608040105060306072B010B0B01040E08090E04040704030705450905050B07070C0404080B0E0D010713A91313A913BCA9A93A201703020C050901031007090912040407040207010114064A1F090E180F1C050407080E070821030E04080E09040E03';
wwv_flow_imp.g_varchar2_table(627) := '0101101A0F000000000600000000011A01070007000B001300180020002500001307151733373527073315230737331715072327372315333533373317150723273723153335261313E11212E1E1E1131338131338132512385E12391212391225133901';
wwv_flow_imp.g_varchar2_table(628) := '0713381313381313384B121239121239393912123912123939390000000600000000011A00E100090013001F00230027002B000037333523071517333523372315331523153337350717150F01232F01353F013307173527371737270737350726252F09';
wwv_flow_imp.g_varchar2_table(629) := '092F25EA2F26262F093C040654092E05065409501C1C0B1B3F1B1B4242CE1309960A13961383130A9627082F09251C082F0826571119110F101C10571D1A1D00000300000000012B0108001100230027000037273E011E0117371707232737172E02061F';
wwv_flow_imp.g_varchar2_table(630) := '01062E0227072737331707271E0327371707670F1A3D362001170E270F270F17011A2C31400F1A3A321E01170F270E280F160218272E920DDF0DE70D11031C331F160E27280E17182A1801B30D0E011D311D170E27280E1617271703BE0DD00E00020000';
wwv_flow_imp.g_varchar2_table(631) := '0000012B010D00110023000037072737331707271E023637170E012E0137270717333727072E020607173E011E0126170F270E280F1603293D390F0F13454930CD170F270F270E17012E4845140F103A3C2791170E27280E161F2F0D1A1C0B211E113A2F';
wwv_flow_imp.g_varchar2_table(632) := '170E28270E16253A131B200B1B181030000B00000000010701070007000B000F00130017001B001F00230027002B002F0000132307151733373507331523172335331D01233527331523153315231535331533353315332335333523353327353315FDE1';
wwv_flow_imp.g_varchar2_table(633) := '0909E10AE1CECE833838384B383838383813384B38383838383801070ACE0909CE091338253825253825132539262626262613251325250000030000000001270107001100230030000013230F011517333716323E013F01342627350726232206141633';
wwv_flow_imp.g_varchar2_table(634) := '32171507060F01273733171E011506150E03273F01F862067D610D2A122A251702011411130E0E040505040F0D4903022554735413090A0102111B1E0E45030107037D0D622A0A1422150A15250C2A210505080606284A0103265474390A170D05050F19';
wwv_flow_imp.g_varchar2_table(635) := '0F02064507000000000500000000011A011A00080015001E002B0038000037323634262206141637140E01222E01343E01321E0107323634262206141637140E01222E01343E01321E0107323E01342E01220E01141E0196080B0B100B0B531423282314';
wwv_flow_imp.g_varchar2_table(636) := '14232823144B1721212E21219A233C483C23233C483C23831F331F1F333E331E1E33830B100B0B100B13142314142328231414234C212E21212E2138243C23233C483C23233C941E333E331F1F333E331E000000000400000000011A011A0006000A000E';
wwv_flow_imp.g_varchar2_table(637) := '001200003F012707270717372337330733152317231533436B0D641C0E22E4992B6EA8A8A8A8A8A8AE5D0E56220C2A1F264B2625260000000005000000000106011A00130017001B0020002A0000131F010F012F01072F01072F013F01273F0127370717';
wwv_flow_imp.g_varchar2_table(638) := '372737173727371737270F01172327152335072337D30B27043E0B03430A03300B0E052F030443030567062A070A1538140A232B212E05391623132315200119045D0B1A04081C040714051F0B14080A1D080B62101110172E182D184D134D13735B384B';
wwv_flow_imp.g_varchar2_table(639) := '614E490000040000000001120123001700470051006E0000252726220F010E011D0114161F0116323F013E013D0134260715140F01063D01062722353734373316373634222635343735343F01321D013617320F01140731260615141633321437142307';
wwv_flow_imp.g_varchar2_table(640) := '2335343F013137070E011D01141723222F012E013D0134363F0136321F0116172E0107010059081208590809090859081208590809094D0105010505010201010504070D060A010501040402010201050A04040C24011601011610540909080507075906';
wwv_flow_imp.g_varchar2_table(641) := '08080659070F06590B02020906E9350505350510096A091005350505350510096A09109F080101030102080302010701010102030D04070D0808010103010802010206010101050702021A04010E0601010D7C34050C09670B030335040E076A070E0435';
wwv_flow_imp.g_varchar2_table(642) := '030335070D040203000700000000012C011A000300200024002800300034003800003717232707220E02141E02323717062306222E02343E02321617072E01173315231533152337210715172137350721352135213521CC260E2553080C0A0505090C12';
wwv_flow_imp.g_varchar2_table(643) := '090204050710100C07070C12120A0202040925131313138DFEE60909011A0913FEFA0106FEFA0106A95E5E0B05090F100D090503090202060C1114110C07020209020208131213BB09F40909F4EAA81326000000000FFFFF000000F2012D00040117011A';
wwv_flow_imp.g_varchar2_table(644) := '012D0135013B014A015001520157015E01630164016E0174000013222B013717363507363D01232E01272E01073E01270E010706070633373007230E0107143631072607060733060731061507061514170717231E0317262714161707161F012617161F';
wwv_flow_imp.g_varchar2_table(645) := '01370617331E013307161733161727171E02172326272E0237263734273536373531163F0136373336373637313637153637363F0106333707361731323307063116373136172717161732373136171516173227311E0117263115162316173526271423';
wwv_flow_imp.g_varchar2_table(646) := '31260617163731343117161F0122273126151E0115312215141637330706172714153116073634071607310615270616073635313437220F010E0127342726272637363736373E0216172E010E0117373235141E013715363F010706363F01363531263F';
wwv_flow_imp.g_varchar2_table(647) := '01073039011416171637062E012732173116172627161737222332162330271734220717140706073426363714073106143F0136072E01371637270F0217161727161F012726273707060736271530333132140F013536071407353437850403020E4803';
wwv_flow_imp.g_varchar2_table(648) := '020201011B100D2309010601070803060601010603050508050402080F0D0503020405010204010301020405050404020503020203010403020603020108050108030305020103060306050D0E050414071C321C02010101070702030303010201050407';
wwv_flow_imp.g_varchar2_table(649) := '0702070C070D0801010F0705040405050205050606010B0A0A02020405010801050F1A0503010104020606030201020101020101010101020103010201010203010301020102010504030401030101010507102614021206090302020305041216120509';
wwv_flow_imp.g_varchar2_table(650) := '1A180E010101151F0E0503090103050E03010102045406030B12091B1806010508040406090B030101060202043602010203020404010402020401031905060407051A012701030403050202010103018C01020607E00201010402060203012B01900806';
wwv_flow_imp.g_varchar2_table(651) := '0508100A1326070602040101010102020402010102010306010203010F0C09050709040C11080D05070709040105090104020905020302010206030804020509030704010203020405060502020102082D4021060C0F0202160E01020505070404060407';
wwv_flow_imp.g_varchar2_table(652) := '060203060703060301020401010101010201020304030501010201030405081E110404050B0A0114090201030502010104020605020301040601030503010409070803040506060903070A0803040705040201010205070D050701020E0B0F1701060B03';
wwv_flow_imp.g_varchar2_table(653) := '070C010A0708040B190E0102111B0B07010102080203010D0302020203032901040204010406100A050A0103080A05BB01017A060403010B0706010104050202040102010413010201010199019F040406031704020502060318020F0D0E570101030301';
wwv_flow_imp.g_varchar2_table(654) := '03150404020404000005000000000112012D005A00B100CF0119013E0000371E011F01161F011E01140E010F010E02070E0123222627262F02220F01220F010E01222627262F012E0234363527343637363F0327343E02373E0135273435343E0233321E';
wwv_flow_imp.g_varchar2_table(655) := '021D011617161F011E0215142732161F01150F01060F01061417161F011E013B01323F03342F022E012F013D01343E013332161406141733323635272E02232206071727260723223D012E02220E011507141F011632363523222F01263607323E03262F';
wwv_flow_imp.g_varchar2_table(656) := '022E02060F010E021517140614161F02161737323736373637353F01343E013735343F01363F012F01262F01263527262F0226220F010622262F0126221D01070607171417070E011D02321F01161F01161F011406071E0317323E0137363F02363D012F';
wwv_flow_imp.g_varchar2_table(657) := '022623220F010622262F01070607061507060F021416F90405010201030302030306040706090A06040704080B040201041D07060D01010403080B0A0509091903050303010707030205070101070A0C06080901050B120D0E120903010303040E070C08';
wwv_flow_imp.g_varchar2_table(658) := '7E02030101010401020602020301040106060106050E0B01010205030703010203020504020102030301010306040806010105020202020102040603030102010102020101010201041D040606030102020D0A02040506030A0308050102050410080305';
wwv_flow_imp.g_varchar2_table(659) := '430405090904040205030603010201020305020202070101020303030205051405090703050302080301010105060403030704040604010205030208080A4003070803080A0A0301050305030603020A0305050104020201020201030101095B02070506';
wwv_flow_imp.g_varchar2_table(660) := '0405040206070504010403070A04020306080201010101020205020402030402040103060808050D0707020102040902070A141312080A180E0B06060C120E070C13170C0D0A090406120914160D0A8F0201040402050101050203010204060305030808';
wwv_flow_imp.g_varchar2_table(661) := '0402010201010401010207020302070504020103030704080407080901010101060306050304030504030501020101050406E4020306070502121004060401020A030304040C0407070301030101030E010204020301081F040605020101020301010217';
wwv_flow_imp.g_varchar2_table(662) := '0604020A0202040707070503030D020504060302070D0708040202070813090A04020403040803040604050104060402150205040905050202020208050F0401060103020A03020205051108080505070A000000000400000000012B011A0007000B000F';
wwv_flow_imp.g_varchar2_table(663) := '00150000131F010F012F013707173727170717372F01071707172FF408220BF408220EE120E14D035E023D450D323D0901190309F209030AF1E803DF029D1202132F370F27270F000004000000000107011A0007000C0010001400001323071517333735';
wwv_flow_imp.g_varchar2_table(664) := '07152335331723353335233533FDE10909E10A845D5D715E5E5E5E011909F40909F47167CFCF5E135E0000000006FFFF0000011C011A00080011001E0027003400440000371406222634363216071406222634363216172E012706271E01171633263537';
wwv_flow_imp.g_varchar2_table(665) := '1406222634363216173637362627060716070607162722313E0117060F010E010726272623F6172117172117A61821171721183216220A11120D31200E0E0B61172118182117101306060A0F0610110803090ED20112442609020118290E080A0606F311';
wwv_flow_imp.g_varchar2_table(666) := '16162116166511161621161674041A1308041E2807020E120110161621161602171D19321611091F22100E0B7C2023030A0D08011513050201000000000400000000011A011A0007000B0012001600001337331715072327371533350F01170717373515';
wwv_flow_imp.g_varchar2_table(667) := '3315231313E11212E11313E1AF0D35350D3E4B4B01071212E11313E1E1E1390D35350D3D0A331300000400000000011A00E10007000A00120018000037073337331733270737173723073337331733273736371F013F2C19092B0A192C1B0F0E851E3D1E';
wwv_flow_imp.g_varchar2_table(668) := '0E3F0E1D641602010217A9711C1C714228287AA92B2B424306050B43000300000000010700F400030007000B00002523353315233533073335230107E1E1E1E1E1E1E1CE2671267126000000000100000000011A0107001B000037222E013F0123062E02';
wwv_flow_imp.g_varchar2_table(669) := '3736373E0137331E011D0114062B01070666080E05041234070C0701032308030D08A70B0F0F0B196E08230B11092901060B0E064A17070901010F0B420A0F6707000000000200000000011A0107001B0036000037222E013F0123062E023736373E0137';
wwv_flow_imp.g_varchar2_table(670) := '331E011D0114062B010706272207060706163733171507061E01323F023332363D0134262366080E05041234070C0701032308030D08A70B0F0F0B196E081805020B200204053E0914010104050272091903050503230B11092901060B0E064A17070901';
wwv_flow_imp.g_varchar2_table(671) := '010F0B420A0F6707D1051F430407010C092E0205030268030403420305000000000100000000011A0107001B0000131E020F0133361E020706070E012B012E013D0134363B013736C6080E05041234070C0701032308030D08A70B0F0F0B1A6D08010701';
wwv_flow_imp.g_varchar2_table(672) := '0A11092901070B0D064A17070A010F0B420A0F6706000000000200000000011A0107001B00360000131E020F0133361E020706070E012B012E013D0134363B013736173237363736260723273537362E01220F022322061715061633C6080E0504123407';
wwv_flow_imp.g_varchar2_table(673) := '0C0701032308030D08A70B0F0F0B1A6D081805020B210104053D0A1401010405027209190305010105030107010A11092901070B0D064A17070A010F0B420A0F6706D0051F430407010C092E0205030268030403420305000006000000000119011A0020';
wwv_flow_imp.g_varchar2_table(674) := '002F0041004D00520068000025270727372726220E02141706070616171E013332373637363716323E023407062B01222E023736371E01170637160622272E01373E023B0107151733370733173727372F010F021727171523271737171614070E012726';
wwv_flow_imp.g_varchar2_table(675) := '2F0137171E013E0234262701150F271727030D1B1A140B053A3906010804090509071524221A0D1C1A140BE201020202020302012A4603060449A901202C0F0C0606040F140A0522230D22CA1C0E0C0C0104360B0F02230A2B141C8A0D3A0808060F0805';
wwv_flow_imp.g_varchar2_table(676) := '033B0D3A02050502010101EB032717280F040B141B1D0D3A3B0815070405071325211B060B151A1CB701010406022C460407034B85171F0F0C200F0A1008230D2322270E0D0D1F0824020F0C36401D152C7D0D3C08160806030302043C0D3C0202020303';
wwv_flow_imp.g_varchar2_table(677) := '0403010000060000000000F4011A00130017001B001F0023002700003733152315072327352335333534363B013216152B01153307333523172315333733152337331523BC381313831312380B0838080B1338385E8383261313121313261313F413A912';
wwv_flow_imp.g_varchar2_table(678) := '12A91313070B0B0713BCA9138383838383000000000100000000010700CF000500003F01331707232607D2086A10C40A0A66000000010000000000CF010700050000131715072735C40A0A66010708D2086A100000010000000000CF0107000500003727';
wwv_flow_imp.g_varchar2_table(679) := '35371715680A0A662607D2086A100000000100000000010700CF00050000250723273733010708D2076910680A0A6600000100000000011A00FF003E0000250E0107171406070E0322262716363722262726271716372E01272635311633262726272637';
wwv_flow_imp.g_varchar2_table(680) := '36371617161716172735343736373632161736370607360119050E08010707091D242B2D2A12152A100C17070503050A090910060C0C0D0B070302030401040A0D191F1010010408150A1614081210061210E5080E0607101F0F1522180C0C0C020B0E0C';
wwv_flow_imp.g_varchar2_table(681) := '0A07080101030209080E1406070C06060E0D07060C0A1508040106060C0915080409080409130A010004000000000107011A001E00220026002A000037232733373527230715173307230715173337352723371723071517333735273533150715233517';
wwv_flow_imp.g_varchar2_table(682) := '233533FD203F140A0A4B0909143E210909380A0A013A39010909380A96385E25CE26265E5E094B09094B095E0A380909380A56560A380909387A393983252525250000000004000000000107011A001E00220026002A0000132307151733072733373527';
wwv_flow_imp.g_varchar2_table(683) := '23071517331723071517333735272337333735073533151715233537233533FD38090901393A010A0A380909213E1409094B0A0A143F200AE1255E38832626011909380A56560A380909380A5D0A4B09094B0A5D0A382F26268338388326000000050000';
wwv_flow_imp.g_varchar2_table(684) := '00000107011A00230027002B002F0033000037232735272335333735272307151733152307150723071517333735373317151733373527331523073315230723353317233533FD21200A1C090A0A250909091C092022090926092043200A250A84131312';
wwv_flow_imp.g_varchar2_table(685) := '3838391212BC13134B20470A25092609092609250A47200926090922202022090926C5134B384B12121200000003000000000107011A00090013002D00003735072737331707271507152707173337270735371707170723353327230733152327372737';
wwv_flow_imp.g_varchar2_table(686) := '33152317333723358D130D220E220D1312130D220E220D1362064545064E3838383A394F054545054F3938383A38B24B130E21220D134B384B130D22220D134B6713373913132D2D1313373913132D2D13000000000C00000000011A011A00090013001B';
wwv_flow_imp.g_varchar2_table(687) := '001F0027002B00330037003F00430047004B0000131707271523350727371735231527071733372737232735373317152733352317232735373317152733352307232735373317152733352317232735373317152733352B0215333523153336280F1712';
wwv_flow_imp.g_varchar2_table(688) := '170D270F12170D270D280D4E250909250A2613138D380A0A380938262642250909250A2613138D380A0A380938262613252525250119270D165254180D27E85252160D27270D6209260909260A122509380A0A380A259609260909260A13390A38090938';
wwv_flow_imp.g_varchar2_table(689) := '09261370120000000002000000000107011D0015001A00003735343E011617332E010E011D01230715173337352707331523355E1A29230714082E3826131212BC13132626BCA925151F0715131B20072A1D25137013137013137070000500000000011A';
wwv_flow_imp.g_varchar2_table(690) := '011A00090011001E0027002F0000373337171507272327351F01350F0123153337140607273E01273627371E0107140727363427371607140727362737161C34491010493409483B3B072E2EC50F0E0E0C0D0101190E0E0F25130D0D0D0D1326080E0707';
wwv_flow_imp.g_varchar2_table(691) := '0E08D14806F40648095E573BC63A034B25172A120D0F2413271F0D112B171F190D142F130D191F100D0E0F100D0D0000000400000000011501140017002F005B005F00003733373337353735273527232723072307150715171517333723352F013F0135';
wwv_flow_imp.g_varchar2_table(692) := '333F011F0133151F010F0115230F012737060F01233536373E0333321E02140E010F010E011D01233534363F013E013427312E01273126220617233533900D202D0A2020092E200D1F2F0A1F1F0A2F0329021D1C0329061C1D0628031D1D0328071C1C15';
wwv_flow_imp.g_varchar2_table(693) := '0201011101030204070905080B08030405030602041104030B0303010103020306060F101018200A2D200E202E0920200A2D200E202D0A1328071C1C0728031C1C0328071C1C0728031C1C710303060109070306040305080B0C09080407030603090A05';
wwv_flow_imp.g_varchar2_table(694) := '08030E0308070302040102045D100000000600000000012C011A0042004E005A00620066006A00003734361F011632363F02272E0222073537161F01373E03161514232226220607060717161F01163237363F01170E03222E012F0126270F010E022226';
wwv_flow_imp.g_varchar2_table(695) := '173E01342627331615140607232E01353437330E011514173721071517213735072135213521352165070405010305030B060701050607031B06030505030909090608030506060305040801010201040105030303010607080605030104010109060308';
wwv_flow_imp.g_varchar2_table(696) := '07080673070909070D1209099E0909120D080810CFFEE60909011A0913FEFA0106FEFA01065404050204010503100D1B0305030104050608100806090601040408030604060822040303010104050402030807060406031404030F0905060505050A181A';
wwv_flow_imp.g_varchar2_table(697) := '180A151A0E170A09190D1A150A190C1B14CE09F40909F4EAA8132600000200000000011501140017001E0000372327232735273537353733373317331715171507150723273337270727079D0D1F2F0A1F1F0A2F1F0D202E0920200A2D3F0E460D401A0D';
wwv_flow_imp.g_varchar2_table(698) := '18200A2D200E202D0A2020092E200E202D0A30460E411A0D000300000000011501140017002F003600003733373337353735273527232723072307150715171517333723352F013F0135333F011F0133151F010F0115230F012737333727072707900D20';
wwv_flow_imp.g_varchar2_table(699) := '2D0A2020092E200D1F2F0A1F1F0A2F0329021D1C0329061C1D0628031D1D0328071C1C040E460D401A0D18200A2D200E202E0920200A2D200E202D0A1328071C1C0728031C1C0328071C1C0728031C1C20460E411A0D0000000400000000011A00F40007';
wwv_flow_imp.g_varchar2_table(700) := '000B001600210000370715173337352715233533073533352307151733352327353335230715173335239613137112127171A9131D09091D1338121C09091C12F4139613139613A9965E4B1309840913382612095E09130000030000FFFF012E01070012';
wwv_flow_imp.g_varchar2_table(701) := '001F0026000013331715262735231533141723353335232735173E011E020E022E0236173727072707171CF409080BE05D134B386709A4112824170212212824160312382D0F27180C2001070A67070453A91F1913120ABB740C02112228241702122128';
wwv_flow_imp.g_varchar2_table(702) := '24523B0C34130E1A000500000000012C01070012001F002B0031003700001333171526273523153314172335333523273517220E01141E01323E01342E0107222E01343E0133321614062717372737270727371707271CF409080BE05D134B386709CE14';
wwv_flow_imp.g_varchar2_table(703) := '231414232823141423140F1A0F0F1A0F172121151B091313093012081B1B0801070A67070453A91F1913120ABB6714232823141423282314830F1A1E1A0F212E21431B081312082E12081A1B08000000000300000000012C01070012001F002B00001333';
wwv_flow_imp.g_varchar2_table(704) := '171526273523153314172335333523273517220E01141E01323E01342E0107222E01343E0133321614061CF409080BE05D134B386709CE14231414232823141423140F1A0F0F1A0F17212101070A67070453A91F1913120ABB6714232823141423282314';
wwv_flow_imp.g_varchar2_table(705) := '830F1A1E1A0F212E2100000000030000FFFE012E01070012002E003100001333171526273523153314172335333523273517321E02171E01070E02070E01272E02272E01373E0237361727151CF409080BE05D134B386709CE0A13110E05070404020A0E';
wwv_flow_imp.g_varchar2_table(706) := '080D1E0F09110E05070404020A0E08123A3901070A67070453A91F1913120ABB67050A0E080D1E0F09110E05070404020A0E080D1E0F09110E050A4B264B0000000200000000011A0107000F001300000123071517331523153335233533373507233533';
wwv_flow_imp.g_varchar2_table(707) := '0110F4090967389638670912E1E101070ABB0A121313120ABBB2A900000600000000012C00F4001900330037003B004700530000373332161D0114062B01222F0126220F01062B0122263D0134361722061D011E013B01323F0136321F01163B0132363D';
wwv_flow_imp.g_varchar2_table(708) := '01342623073315232533152327321614062B01222634363B01321614062B0122263436334B961721211707110F0F0A160A0F0F1107172121171016011510070C09100E220E10090C0710161610E11313011913139F040505042F0405050496040505042F';
wwv_flow_imp.g_varchar2_table(709) := '04050504F421174B18210A0A06060A0A21184B172113160F4B1016060B09090B0616104B0F163838383825050806060805050806060805000004000000000107011900050011001F00290000130717373534152726220F010E011F01363537161D011407';
wwv_flow_imp.g_varchar2_table(710) := '373E013D013626270737170706222F012634B74F282C8C0208030D030104A1050E0404340404010504E8161F1B0208030D030112481F213B069A6A02030C030903940506E10909CF090919020804A504080181151C1502030C0309000001000000000107';
wwv_flow_imp.g_varchar2_table(711) := '011A002A0000370627262F010706222F0126343F012726343F0136321F01373E011F011E011D0123350717353315140607CC06060303602A0208030D0303242403030D0308022A620408043204043C49493D05042703030102582002030C030903212203';
wwv_flow_imp.g_varchar2_table(712) := '09030C03022059030102190108045C4138372E4904080200000600000000011A011A000B0017002300300038004000003733353335233523152315331723152315331533353335233735231523153315333533350726220F01061416323F013634070622';
wwv_flow_imp.g_varchar2_table(713) := '26343F0117370727373632161452131313131313961312121313131F13131313124A0817098C081018088C08A202080603790E13060D06020806CE13131313135E1213131313961212131313132E08088D081711098C08179E03060703790D13060E0602';
wwv_flow_imp.g_varchar2_table(714) := '050800000004000000000119011A00050008000C00100000133317072327370733273523153D0133158E107B08F608836BD65F18180119E60D0DCEC9131313264B4B000000030000000000F4011A0006001A0027000037333523352315270E0114161715';
wwv_flow_imp.g_varchar2_table(715) := '173337353E013426273527230717140E01222E01343E01321E018D251C131C161919160A4B0916191916094B0A7A1423282314142328231483132F385A0C2C322C0C290909290C2C322C0C2909097A1423141423282314142300000000030000000000E1';
wwv_flow_imp.g_varchar2_table(716) := '011A00110019001D0000133523220E01141E013B01152315333523350723222634363B0117233533E167121E12121E121C135E13381C141B1B141C261313010712111F231E125E1212CF5E1B271CCFCF000500000000012C00F70007001C002700370043';
wwv_flow_imp.g_varchar2_table(717) := '00003533152135331521372335230623222635343F013423220735363332150F010E01151416333236351731152335331531363332161514062227151416333236353426220613010613FED48010010A151011221F16120F0F142410190C0B0A090D103F';
wwv_flow_imp.g_varchar2_table(718) := '11110C181416192A0B100D0F11101C115E262638381013110D1D05041A0C1109260F0401080B070A110E1B0F9843141B181A1F3B0E0D121715111314000300000000011A01070007000B000F0000012307151733373507233533352335330110F40909F4';
wwv_flow_imp.g_varchar2_table(719) := '0912E1E1E1E101070ACE0909CEC5841226000000000600000000011A011A001F002F0045005A007A008A00003726272607060F0115373E01321617070E0207061617163332371533353426071514070E01272E023D01343E0133372E0222070607352315';
wwv_flow_imp.g_varchar2_table(720) := '333516171633323E023407140E010706272E023D013E031736171E01073E0132161F013527260E03141E0232363F01350F0106272E02343637233533171507231707273537170733490405090B07060604040B0B0501120709060103060905050B071303';
wwv_flow_imp.g_varchar2_table(721) := '0F01020A050202010304036B01060B0E050302121203060204070B07041202040206050204020102030503060401025E0306080603070208120E0A0505090D0E0A0402060A060603050304DC4B5409097C270E36360E2672EB0502030201030314030305';
wwv_flow_imp.g_varchar2_table(722) := '060602010507040A120402090731070B1F050303060502010203020401030216060B070402032E7405050101060C101007070A06010302020406040A04080503010106020960030302020515010501060C0F110E0A0603020111020401020206080B094D';
wwv_flow_imp.g_varchar2_table(723) := '12097109270D360D370E25000003000000000125012D0024003F004C000013321E021716171617163315140E040F01272E053D01323E02373E01172E01272E012206070E010715141E04173E05352F010F012F010F011F023F0197080D0D0C070A0B1517';
wwv_flow_imp.g_varchar2_table(724) := '0C0B0B13191F2111040511221E1A130A0B1816150A0C1A8815291209161615091229160A11181A1E0F101D1B171209340808511C080802240409045B012C0204060406050802014A1626231E1B170A03030A171B1E2327144C01050906080838010C0C06';
wwv_flow_imp.g_varchar2_table(725) := '0606060C0C01391222201B1815090914191B2022121907016027020707330201026B00000004000000000125012D0024003F00690071000013321E021716171617321715140E040F01272E053D01163E02373E01172E01272E012206070E010715141E04';
wwv_flow_imp.g_varchar2_table(726) := '173E0535271E01140E010F010E011D0107232735343E013F013E013426272622070E0115072327343E0137361716073733171507232797080D0D0C070A0B15160D0B0B13191F2111050411221E1A130A0B1816150A0C1A8815291209161615091229160A';
wwv_flow_imp.g_varchar2_table(727) := '11181A1E0F101D1B17110A600506050604060303030D030506040603030302050F050203030D03060A060E0F061E030D03030D03012C0204060406050802014A1626231E1B170A03030A171B1E2327144C0102050906080838010C0C060606060C0C0139';
wwv_flow_imp.g_varchar2_table(728) := '1222201B1815090914191B20221219060C0E0B08030603060406030306070B070306040607060305050306040202080D0A020606036103030D0303000003000000000125012D0024003F0053000013321E021716171617321715140E040F01272E053D01';
wwv_flow_imp.g_varchar2_table(729) := '163E02373E01172E01272E012206070E010715141E04173E05352F0123072723071517071517333717333735273797080D0D0C070A0B15160D0B0B13191F2111050411221E1A130A0B1816150A0C1A8815291209161615091229160A11181A1E0F101D1B';
wwv_flow_imp.g_varchar2_table(730) := '17110A4707042525040825250804252504072525012C0204060406050802014A1626231E1B170A03030A171B1E2327144C0102050906080838010C0C060606060C0C01391222201B1815090914191B2022120B0826260804252504082626080425250000';
wwv_flow_imp.g_varchar2_table(731) := '000300000000011A011E000E001F002B0000371606071707270E012E013E011E0107323637073E0135342E01220E01141E01373523352315231533153335E2010D0C500E4F1C4839131C3F473064111F0C010C0E17272E26171726452513262613B91426';
wwv_flow_imp.g_varchar2_table(732) := '104F0E5017022B4542230C35800D0C010C1F1117271717272D27174B1325251325250000000300000000011A011E000E001F00230000371606071707270E012E013E011E0107323637073E0135342E01220E01141E0127331523E2010D0C500E4F1C4839';
wwv_flow_imp.g_varchar2_table(733) := '131C3F473064111F0C010C0E17272E26171726185D5DB91426104F0E5017022B4542230C35800D0C010C1F1117271717272D27175D1200000000001000C600010000000000010007000000010000000000020007000700010000000000030007000E0001';
wwv_flow_imp.g_varchar2_table(734) := '000000000004000700150001000000000005000C001C000100000000000600070028000100000000000A0024002F000100000000000B001300530003000104090001000E00660003000104090002000E00740003000104090003000E0082000300010409';
wwv_flow_imp.g_varchar2_table(735) := '0004000E009000030001040900050018009E0003000104090006000E00B6000300010409000A004800C4000300010409000B0026010C636F6469636F6E526567756C6172636F6469636F6E636F6469636F6E56657273696F6E20312E3131636F6469636F';
wwv_flow_imp.g_varchar2_table(736) := '6E5468652069636F6E20666F6E7420666F722056697375616C2053747564696F20436F6465687474703A2F2F666F6E74656C6C6F2E636F6D0063006F006400690063006F006E0052006500670075006C006100720063006F006400690063006F006E0063';
wwv_flow_imp.g_varchar2_table(737) := '006F006400690063006F006E00560065007200730069006F006E00200031002E003100310063006F006400690063006F006E005400680065002000690063006F006E00200066006F006E007400200066006F0072002000560069007300750061006C0020';
wwv_flow_imp.g_varchar2_table(738) := '00530074007500640069006F00200043006F006400650068007400740070003A002F002F0066006F006E00740065006C006C006F002E0063006F006D000200000000000000030000000000000000000000000000000000000000000001CD010201030104';
wwv_flow_imp.g_varchar2_table(739) := '01050106010701080109010A010B010C010D010E010F0110011101120113011401150116011701180119011A011B011C011D011E011F0120012101220123012401250126012701280129012A012B012C012D012E012F0130013101320133013401350136';
wwv_flow_imp.g_varchar2_table(740) := '013701380139013A013B013C013D013E013F0140014101420143014401450146014701480149014A014B014C014D014E014F0150015101520153015401550156015701580159015A015B015C015D015E015F016001610162016301640165016601670168';
wwv_flow_imp.g_varchar2_table(741) := '0169016A016B016C016D016E016F0170017101720173017401750176017701780179017A017B017C017D017E017F0180018101820183018401850186018701880189018A018B018C018D018E018F0190019101920193019401950196019701980199019A';
wwv_flow_imp.g_varchar2_table(742) := '019B019C019D019E019F01A001A101A201A301A401A501A601A701A801A901AA01AB01AC01AD01AE01AF01B001B101B201B301B401B501B601B701B801B901BA01BB01BC01BD01BE01BF01C001C101C201C301C401C501C601C701C801C901CA01CB01CC';
wwv_flow_imp.g_varchar2_table(743) := '01CD01CE01CF01D001D101D201D301D401D501D601D701D801D901DA01DB01DC01DD01DE01DF01E001E101E201E301E401E501E601E701E801E901EA01EB01EC01ED01EE01EF01F001F101F201F301F401F501F601F701F801F901FA01FB01FC01FD01FE';
wwv_flow_imp.g_varchar2_table(744) := '01FF0200020102020203020402050206020702080209020A020B020C020D020E020F0210021102120213021402150216021702180219021A021B021C021D021E021F0220022102220223022402250226022702280229022A022B022C022D022E022F0230';
wwv_flow_imp.g_varchar2_table(745) := '023102320233023402350236023702380239023A023B023C023D023E023F0240024102420243024402450246024702480249024A024B024C024D024E024F0250025102520253025402550256025702580259025A025B025C025D025E025F026002610262';
wwv_flow_imp.g_varchar2_table(746) := '0263026402650266026702680269026A026B026C026D026E026F0270027102720273027402750276027702780279027A027B027C027D027E027F0280028102820283028402850286028702880289028A028B028C028D028E028F02900291029202930294';
wwv_flow_imp.g_varchar2_table(747) := '02950296029702980299029A029B029C029D029E029F02A002A102A202A302A402A502A602A702A802A902AA02AB02AC02AD02AE02AF02B002B102B202B302B402B502B602B702B802B902BA02BB02BC02BD02BE02BF02C002C102C202C302C402C502C6';
wwv_flow_imp.g_varchar2_table(748) := '02C702C802C902CA02CB02CC02CD02CE00076163636F756E741461637469766174652D627265616B706F696E74730361646407617263686976650A6172726F772D626F7468116172726F772D636972636C652D646F776E116172726F772D636972636C65';
wwv_flow_imp.g_varchar2_table(749) := '2D6C656674126172726F772D636972636C652D72696768740F6172726F772D636972636C652D75700A6172726F772D646F776E0A6172726F772D6C6566740B6172726F772D7269676874106172726F772D736D616C6C2D646F776E106172726F772D736D';
wwv_flow_imp.g_varchar2_table(750) := '616C6C2D6C656674116172726F772D736D616C6C2D72696768740E6172726F772D736D616C6C2D75700A6172726F772D73776170086172726F772D75700C617A7572652D6465766F707305617A7572650B6265616B65722D73746F70066265616B657208';
wwv_flow_imp.g_varchar2_table(751) := '62656C6C2D646F740E62656C6C2D736C6173682D646F740A62656C6C2D736C6173680462656C6C05626C616E6B04626F6C6404626F6F6B08626F6F6B6D61726B0B627261636B65742D646F740D627261636B65742D6572726F7209627269656663617365';
wwv_flow_imp.g_varchar2_table(752) := '0962726F6164636173740762726F77736572036275670863616C656E6461720D63616C6C2D696E636F6D696E670D63616C6C2D6F7574676F696E670E636173652D73656E73697469766509636865636B2D616C6C05636865636B09636865636B6C697374';
wwv_flow_imp.g_varchar2_table(753) := '0C63686576726F6E2D646F776E0C63686576726F6E2D6C6566740D63686576726F6E2D72696768740A63686576726F6E2D757004636869700C6368726F6D652D636C6F73650F6368726F6D652D6D6178696D697A650F6368726F6D652D6D696E696D697A';
wwv_flow_imp.g_varchar2_table(754) := '650E6368726F6D652D726573746F72650D636972636C652D66696C6C656413636972636C652D6C617267652D66696C6C65640C636972636C652D6C617267650C636972636C652D736C61736813636972636C652D736D616C6C2D66696C6C65640C636972';
wwv_flow_imp.g_varchar2_table(755) := '636C652D736D616C6C06636972636C650D636972637569742D626F61726409636C6561722D616C6C06636C6970707909636C6F73652D616C6C05636C6F73650E636C6F75642D646F776E6C6F61640C636C6F75642D75706C6F616405636C6F756408636F';
wwv_flow_imp.g_varchar2_table(756) := '64652D6F737304636F646506636F666665650C636F6C6C617073652D616C6C0A636F6C6F722D6D6F646507636F6D62696E6512636F6D6D656E742D64697363757373696F6E0D636F6D6D656E742D647261667412636F6D6D656E742D756E7265736F6C76';
wwv_flow_imp.g_varchar2_table(757) := '656407636F6D6D656E740E636F6D706173732D6163746976650B636F6D706173732D646F7407636F6D7061737307636F70696C6F7404636F707908636F7665726167650B6372656469742D6361726404646173680964617368626F617264086461746162';
wwv_flow_imp.g_varchar2_table(758) := '6173650964656275672D616C6C0F64656275672D616C742D736D616C6C0964656275672D616C742764656275672D627265616B706F696E742D636F6E646974696F6E616C2D756E76657269666965641C64656275672D627265616B706F696E742D636F6E';
wwv_flow_imp.g_varchar2_table(759) := '646974696F6E616C2064656275672D627265616B706F696E742D646174612D756E76657269666965641564656275672D627265616B706F696E742D646174612464656275672D627265616B706F696E742D66756E6374696F6E2D756E7665726966696564';
wwv_flow_imp.g_varchar2_table(760) := '1964656275672D627265616B706F696E742D66756E6374696F6E1F64656275672D627265616B706F696E742D6C6F672D756E76657269666965641464656275672D627265616B706F696E742D6C6F671C64656275672D627265616B706F696E742D756E73';
wwv_flow_imp.g_varchar2_table(761) := '7570706F727465640D64656275672D636F6E736F6C651464656275672D636F6E74696E75652D736D616C6C0E64656275672D636F6E74696E75650E64656275672D636F7665726167651064656275672D646973636F6E6E6563741264656275672D6C696E';
wwv_flow_imp.g_varchar2_table(762) := '652D62792D6C696E650B64656275672D70617573650B64656275672D726572756E1364656275672D726573746172742D6672616D650D64656275672D726573746172741664656275672D726576657273652D636F6E74696E75651764656275672D737461';
wwv_flow_imp.g_varchar2_table(763) := '636B6672616D652D6163746976651064656275672D737461636B6672616D650B64656275672D73746172740F64656275672D737465702D6261636B0F64656275672D737465702D696E746F0E64656275672D737465702D6F75740F64656275672D737465';
wwv_flow_imp.g_varchar2_table(764) := '702D6F7665720A64656275672D73746F70056465627567106465736B746F702D646F776E6C6F6164136465766963652D63616D6572612D766964656F0D6465766963652D63616D6572610D6465766963652D6D6F62696C650A646966662D61646465640C';
wwv_flow_imp.g_varchar2_table(765) := '646966662D69676E6F7265640D646966662D6D6F6469666965640D646966662D6D756C7469706C650C646966662D72656D6F7665640C646966662D72656E616D65640B646966662D73696E676C650464696666076469736361726404656469740D656469';
wwv_flow_imp.g_varchar2_table(766) := '746F722D6C61796F757408656C6C69707369730C656D7074792D77696E646F770B6572726F722D736D616C6C056572726F72076578636C7564650A657870616E642D616C6C066578706F72740A657874656E73696F6E730A6579652D636C6F7365640365';
wwv_flow_imp.g_varchar2_table(767) := '796508666565646261636B0B66696C652D62696E6172790966696C652D636F64650A66696C652D6D656469610866696C652D7064660E66696C652D7375626D6F64756C651666696C652D73796D6C696E6B2D6469726563746F72791166696C652D73796D';
wwv_flow_imp.g_varchar2_table(768) := '6C696E6B2D66696C650866696C652D7A69700466696C650566696C65730D66696C7465722D66696C6C65640666696C74657205666C616D6509666F6C642D646F776E07666F6C642D757004666F6C640D666F6C6465722D6163746976650E666F6C646572';
wwv_flow_imp.g_varchar2_table(769) := '2D6C6962726172790D666F6C6465722D6F70656E656406666F6C6465720467616D65046765617204676966740B676973742D7365637265740A6769742D636F6D6D69740B6769742D636F6D70617265096769742D6665746368096769742D6D6572676517';
wwv_flow_imp.g_varchar2_table(770) := '6769742D70756C6C2D726571756573742D636C6F736564176769742D70756C6C2D726571756573742D637265617465166769742D70756C6C2D726571756573742D64726166741E6769742D70756C6C2D726571756573742D676F2D746F2D6368616E6765';
wwv_flow_imp.g_varchar2_table(771) := '731C6769742D70756C6C2D726571756573742D6E65772D6368616E676573106769742D70756C6C2D726571756573740F6769742D73746173682D6170706C790D6769742D73746173682D706F70096769742D73746173680D6769746875622D616374696F';
wwv_flow_imp.g_varchar2_table(772) := '6E0A6769746875622D616C740F6769746875622D696E7665727465640E6769746875622D70726F6A6563740667697468756205676C6F62650A676F2D746F2D66696C650C676F2D746F2D73656172636807677261626265720A67726170682D6C6566740A';
wwv_flow_imp.g_varchar2_table(773) := '67726170682D6C696E650D67726170682D7363617474657205677261706807677269707065721167726F75702D62792D7265662D747970650C68656172742D66696C6C656405686561727407686973746F727904686F6D650F686F72697A6F6E74616C2D';
wwv_flow_imp.g_varchar2_table(774) := '72756C65056875626F7405696E626F7806696E64656E7404696E666F06696E7365727407696E73706563740B69737375652D64726166740E69737375652D72656F70656E656406697373756573066974616C6963066A6572736579046A736F6E0E6B6562';
wwv_flow_imp.g_varchar2_table(775) := '61622D766572746963616C036B6579036C61770D6C61796572732D6163746976650A6C61796572732D646F74066C6179657273176C61796F75742D61637469766974796261722D6C656674186C61796F75742D61637469766974796261722D7269676874';
wwv_flow_imp.g_varchar2_table(776) := '0F6C61796F75742D63656E74657265640E6C61796F75742D6D656E75626172136C61796F75742D70616E656C2D63656E746572146C61796F75742D70616E656C2D6A757374696679116C61796F75742D70616E656C2D6C656674106C61796F75742D7061';
wwv_flow_imp.g_varchar2_table(777) := '6E656C2D6F6666126C61796F75742D70616E656C2D72696768740C6C61796F75742D70616E656C176C61796F75742D736964656261722D6C6566742D6F6666136C61796F75742D736964656261722D6C656674186C61796F75742D736964656261722D72';
wwv_flow_imp.g_varchar2_table(778) := '696768742D6F6666146C61796F75742D736964656261722D7269676874106C61796F75742D737461747573626172066C61796F7574076C696272617279116C6967687462756C622D6175746F666978116C6967687462756C622D737061726B6C65096C69';
wwv_flow_imp.g_varchar2_table(779) := '67687462756C620D6C696E6B2D65787465726E616C046C696E6B0B6C6973742D66696C746572096C6973742D666C61740C6C6973742D6F7264657265640E6C6973742D73656C656374696F6E096C6973742D747265650E6C6973742D756E6F7264657265';
wwv_flow_imp.g_varchar2_table(780) := '640A6C6976652D7368617265076C6F6164696E67086C6F636174696F6E0A6C6F636B2D736D616C6C046C6F636B066D61676E6574096D61696C2D72656164046D61696C0A6D61702D66696C6C6564136D61702D766572746963616C2D66696C6C65640C6D';
wwv_flow_imp.g_varchar2_table(781) := '61702D766572746963616C036D6170086D61726B646F776E096D65676170686F6E65076D656E74696F6E046D656E75056D657267650A6D69632D66696C6C6564036D6963096D696C6573746F6E65066D6972726F720C6D6F727461722D626F617264046D';
wwv_flow_imp.g_varchar2_table(782) := '6F7665106D756C7469706C652D77696E646F7773056D75736963046D757465086E65772D66696C650A6E65772D666F6C646572076E65776C696E650A6E6F2D6E65776C696E65046E6F7465116E6F7465626F6F6B2D74656D706C617465086E6F7465626F';
wwv_flow_imp.g_varchar2_table(783) := '6F6B086F63746F666163650C6F70656E2D707265766965770C6F7267616E697A6174696F6E066F7574707574077061636B616765087061696E7463616E0B706173732D66696C6C656404706173730A70657263656E746167650A706572736F6E2D616464';
wwv_flow_imp.g_varchar2_table(784) := '06706572736F6E057069616E6F097069652D63686172740370696E0C70696E6E65642D64697274790670696E6E65640B706C61792D636972636C6504706C617904706C75670D70726573657276652D636173650770726576696577107072696D69746976';
wwv_flow_imp.g_varchar2_table(785) := '652D7371756172650770726F6A6563740570756C7365087175657374696F6E0571756F74650B726164696F2D746F776572097265616374696F6E730B7265636F72642D6B6579730C7265636F72642D736D616C6C067265636F7264047265646F0A726566';
wwv_flow_imp.g_varchar2_table(786) := '6572656E63657307726566726573680572656765780F72656D6F74652D6578706C6F7265720672656D6F74650672656D6F76650B7265706C6163652D616C6C077265706C616365057265706C790A7265706F2D636C6F6E650A7265706F2D66657463680F';
wwv_flow_imp.g_varchar2_table(787) := '7265706F2D666F7263652D707573680B7265706F2D666F726B6564097265706F2D70756C6C097265706F2D70757368047265706F067265706F72740F726571756573742D6368616E67657305726F626F7406726F636B657412726F6F742D666F6C646572';
wwv_flow_imp.g_varchar2_table(788) := '2D6F70656E65640B726F6F742D666F6C6465720372737304727562790972756E2D61626F76651072756E2D616C6C2D636F7665726167650772756E2D616C6C0972756E2D62656C6F770C72756E2D636F7665726167650A72756E2D6572726F7273087361';
wwv_flow_imp.g_varchar2_table(789) := '76652D616C6C07736176652D617304736176650B73637265656E2D66756C6C0D73637265656E2D6E6F726D616C0C7365617263682D66757A7A790B7365617263682D73746F70067365617263680473656E64127365727665722D656E7669726F6E6D656E';
wwv_flow_imp.g_varchar2_table(790) := '740E7365727665722D70726F63657373067365727665720D73657474696E67732D676561720873657474696E677305736861726506736869656C64077369676E2D696E087369676E2D6F757406736D696C657905736E616B650F736F72742D7072656365';
wwv_flow_imp.g_varchar2_table(791) := '64656E63650E736F757263652D636F6E74726F6C0E737061726B6C652D66696C6C656407737061726B6C651073706C69742D686F72697A6F6E74616C0E73706C69742D766572746963616C08737175697272656C0A737461722D656D7074790973746172';
wwv_flow_imp.g_varchar2_table(792) := '2D66756C6C09737461722D68616C660B73746F702D636972636C650D737572726F756E642D776974680C73796D626F6C2D61727261790E73796D626F6C2D626F6F6C65616E0C73796D626F6C2D636C6173730C73796D626F6C2D636F6C6F720F73796D62';
wwv_flow_imp.g_varchar2_table(793) := '6F6C2D636F6E7374616E741273796D626F6C2D656E756D2D6D656D6265720B73796D626F6C2D656E756D0C73796D626F6C2D6576656E740C73796D626F6C2D6669656C640B73796D626F6C2D66696C651073796D626F6C2D696E746572666163650A7379';
wwv_flow_imp.g_varchar2_table(794) := '6D626F6C2D6B65790E73796D626F6C2D6B6579776F72640D73796D626F6C2D6D6574686F640B73796D626F6C2D6D6973631073796D626F6C2D6E616D6573706163650E73796D626F6C2D6E756D657269630F73796D626F6C2D6F70657261746F72107379';
wwv_flow_imp.g_varchar2_table(795) := '6D626F6C2D706172616D657465720F73796D626F6C2D70726F70657274790C73796D626F6C2D72756C65720E73796D626F6C2D736E69707065740D73796D626F6C2D737472696E671073796D626F6C2D7374727563747572650F73796D626F6C2D766172';
wwv_flow_imp.g_varchar2_table(796) := '6961626C650C73796E632D69676E6F7265640473796E63057461626C650374616706746172676574087461736B6C6973740974656C6573636F70650D7465726D696E616C2D626173680C7465726D696E616C2D636D640F7465726D696E616C2D64656269';
wwv_flow_imp.g_varchar2_table(797) := '616E0E7465726D696E616C2D6C696E7578137465726D696E616C2D706F7765727368656C6C0D7465726D696E616C2D746D75780F7465726D696E616C2D7562756E7475087465726D696E616C09746578742D73697A650A74687265652D62617273117468';
wwv_flow_imp.g_varchar2_table(798) := '756D6273646F776E2D66696C6C65640A7468756D6273646F776E0F7468756D627375702D66696C6C6564087468756D6273757005746F6F6C730574726173680D747269616E676C652D646F776E0D747269616E676C652D6C6566740E747269616E676C65';
wwv_flow_imp.g_varchar2_table(799) := '2D72696768740B747269616E676C652D7570077477697474657212747970652D6869657261726368792D73756214747970652D6869657261726368792D73757065720E747970652D68696572617263687906756E666F6C6413756E67726F75702D62792D';
wwv_flow_imp.g_varchar2_table(800) := '7265662D7479706506756E6C6F636B06756E6D7574650A756E76657269666965640E7661726961626C652D67726F75700F76657269666965642D66696C6C65640876657269666965640876657273696F6E7309766D2D6163746976650A766D2D636F6E6E';
wwv_flow_imp.g_varchar2_table(801) := '6563740A766D2D6F75746C696E650A766D2D72756E6E696E6702766D0276720F7673636F64652D696E736964657273067673636F64650477616E64077761726E696E670577617463680A776869746573706163650A77686F6C652D776F72640677696E64';
wwv_flow_imp.g_varchar2_table(802) := '6F7709776F72642D7772617011776F726B73706163652D7472757374656411776F726B73706163652D756E6B6E6F776E13776F726B73706163652D756E74727573746564077A6F6F6D2D696E087A6F6F6D2D6F7574000000';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5447625127531698)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/8f3abbcbc983396e1f13da87e63ec9af.ttf'
,p_mime_type=>'application/octet-stream'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C65617365207365652037372E6D696E2E6A732E4C4943454E53452E747874202A2F0A2275736520737472696374223B2873656C662E7765627061636B4368756E6B62706D6E4D';
wwv_flow_imp.g_varchar2_table(2) := '6F64656C65723D73656C662E7765627061636B4368756E6B62706D6E4D6F64656C65727C7C5B5D292E70757368285B5B37375D2C7B323037373A28652C742C6E293D3E7B6E2E722874292C6E2E6428742C7B436F6D706C6574696F6E416461707465723A';
wwv_flow_imp.g_varchar2_table(3) := '28293D3E67742C446566696E6974696F6E416461707465723A28293D3E79742C446961676E6F7374696373416461707465723A28293D3E63742C446F63756D656E74436F6C6F72416461707465723A28293D3E4D742C446F63756D656E74466F726D6174';
wwv_flow_imp.g_varchar2_table(4) := '74696E674564697450726F76696465723A28293D3E54742C446F63756D656E74486967686C69676874416461707465723A28293D3E6B742C446F63756D656E744C696E6B416461707465723A28293D3E52742C446F63756D656E7452616E6765466F726D';
wwv_flow_imp.g_varchar2_table(5) := '617474696E674564697450726F76696465723A28293D3E44742C446F63756D656E7453796D626F6C416461707465723A28293D3E49742C466F6C64696E6752616E6765416461707465723A28293D3E46742C486F766572416461707465723A28293D3E76';
wwv_flow_imp.g_varchar2_table(6) := '742C5265666572656E6365416461707465723A28293D3E43742C52656E616D65416461707465723A28293D3E78742C53656C656374696F6E52616E6765416461707465723A28293D3E4C742C576F726B65724D616E616765723A28293D3E6F652C66726F';
wwv_flow_imp.g_varchar2_table(7) := '6D506F736974696F6E3A28293D3E6C742C66726F6D52616E67653A28293D3E68742C73657475704D6F64653A28293D3E4E742C73657475704D6F6465313A28293D3E4F742C746F52616E67653A28293D3E66742C746F54657874456469743A28293D3E6D';
wwv_flow_imp.g_varchar2_table(8) := '747D293B76617220723D6E2839353230292C693D4F626A6563742E646566696E6550726F70657274792C6F3D4F626A6563742E6765744F776E50726F706572747944657363726970746F722C613D4F626A6563742E6765744F776E50726F70657274794E';
wwv_flow_imp.g_varchar2_table(9) := '616D65732C733D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C753D28652C742C6E2C72293D3E7B696628742626226F626A656374223D3D747970656F6620747C7C2266756E6374696F6E223D3D747970656F66207429';
wwv_flow_imp.g_varchar2_table(10) := '666F72286C65742075206F66206128742929732E63616C6C28652C75297C7C753D3D3D6E7C7C6928652C752C7B6765743A28293D3E745B755D2C656E756D657261626C653A2128723D6F28742C7529297C7C722E656E756D657261626C657D293B726574';
wwv_flow_imp.g_varchar2_table(11) := '75726E20657D2C633D7B7D3B7528632C722C2264656661756C7422293B76617220642C672C6C2C682C662C702C6D2C762C5F2C772C6B2C622C792C452C432C782C492C412C532C522C542C442C502C4D2C462C4C2C6A2C4F2C4E2C552C572C562C482C4B';
wwv_flow_imp.g_varchar2_table(12) := '2C7A2C582C422C242C712C512C472C4A2C592C5A2C65652C74652C6E652C72652C69652C6F653D636C6173737B636F6E7374727563746F722865297B746869732E5F64656661756C74733D652C746869732E5F776F726B65723D6E756C6C2C746869732E';
wwv_flow_imp.g_varchar2_table(13) := '5F636C69656E743D6E756C6C2C746869732E5F69646C65436865636B496E74657276616C3D77696E646F772E736574496E74657276616C282828293D3E746869732E5F636865636B496649646C652829292C336534292C746869732E5F6C617374557365';
wwv_flow_imp.g_varchar2_table(14) := '6454696D653D302C746869732E5F636F6E6669674368616E67654C697374656E65723D746869732E5F64656661756C74732E6F6E4469644368616E6765282828293D3E746869732E5F73746F70576F726B6572282929297D5F73746F70576F726B657228';
wwv_flow_imp.g_varchar2_table(15) := '297B746869732E5F776F726B6572262628746869732E5F776F726B65722E646973706F736528292C746869732E5F776F726B65723D6E756C6C292C746869732E5F636C69656E743D6E756C6C7D646973706F736528297B636C656172496E74657276616C';
wwv_flow_imp.g_varchar2_table(16) := '28746869732E5F69646C65436865636B496E74657276616C292C746869732E5F636F6E6669674368616E67654C697374656E65722E646973706F736528292C746869732E5F73746F70576F726B657228297D5F636865636B496649646C6528297B746869';
wwv_flow_imp.g_varchar2_table(17) := '732E5F776F726B65722626446174652E6E6F7728292D746869732E5F6C6173745573656454696D653E313265342626746869732E5F73746F70576F726B657228297D5F676574436C69656E7428297B72657475726E20746869732E5F6C61737455736564';
wwv_flow_imp.g_varchar2_table(18) := '54696D653D446174652E6E6F7728292C746869732E5F636C69656E747C7C28746869732E5F776F726B65723D632E656469746F722E637265617465576562576F726B6572287B6D6F64756C6549643A2276732F6C616E67756167652F68746D6C2F68746D';
wwv_flow_imp.g_varchar2_table(19) := '6C576F726B6572222C637265617465446174613A7B6C616E677561676553657474696E67733A746869732E5F64656661756C74732E6F7074696F6E732C6C616E677561676549643A746869732E5F64656661756C74732E6C616E677561676549647D2C6C';
wwv_flow_imp.g_varchar2_table(20) := '6162656C3A746869732E5F64656661756C74732E6C616E677561676549647D292C746869732E5F636C69656E743D746869732E5F776F726B65722E67657450726F78792829292C746869732E5F636C69656E747D6765744C616E67756167655365727669';
wwv_flow_imp.g_varchar2_table(21) := '6365576F726B6572282E2E2E65297B6C657420743B72657475726E20746869732E5F676574436C69656E7428292E7468656E2828653D3E7B743D657D29292E7468656E2828743D3E7B696628746869732E5F776F726B65722972657475726E2074686973';
wwv_flow_imp.g_varchar2_table(22) := '2E5F776F726B65722E7769746853796E6365645265736F75726365732865297D29292E7468656E2828653D3E7429297D7D3B28673D647C7C28643D7B7D29292E4D494E5F56414C55453D2D323134373438333634382C672E4D41585F56414C55453D3231';
wwv_flow_imp.g_varchar2_table(23) := '34373438333634372C28683D6C7C7C286C3D7B7D29292E4D494E5F56414C55453D302C682E4D41585F56414C55453D323134373438333634372C28703D667C7C28663D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(24) := '653D3D3D4E756D6265722E4D41585F56414C5545262628653D6C2E4D41585F56414C5545292C743D3D3D4E756D6265722E4D41585F56414C5545262628743D6C2E4D41585F56414C5545292C7B6C696E653A652C6368617261637465723A747D7D2C702E';
wwv_flow_imp.g_varchar2_table(25) := '69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E6F626A6563744C69746572616C28742926266F742E75696E746567657228742E6C696E652926266F742E75696E746567657228742E636861726163746572297D2C2876';
wwv_flow_imp.g_varchar2_table(26) := '3D6D7C7C286D3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B6966286F742E75696E746567657228652926266F742E75696E746567657228742926266F742E75696E7465676572286E2926266F742E75696E746567657228';
wwv_flow_imp.g_varchar2_table(27) := '72292972657475726E7B73746172743A662E63726561746528652C74292C656E643A662E637265617465286E2C72297D3B696628662E69732865292626662E69732874292972657475726E7B73746172743A652C656E643A747D3B7468726F77206E6577';
wwv_flow_imp.g_varchar2_table(28) := '204572726F72282252616E6765236372656174652063616C6C6564207769746820696E76616C696420617267756D656E74735B222B652B222C20222B742B222C20222B6E2B222C20222B722B225D22297D2C762E69733D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(29) := '617220743D653B72657475726E206F742E6F626A6563744C69746572616C2874292626662E697328742E7374617274292626662E697328742E656E64297D2C28773D5F7C7C285F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B7265';
wwv_flow_imp.g_varchar2_table(30) := '7475726E7B7572693A652C72616E67653A747D7D2C772E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E72616E6765292626286F742E737472696E6728742E75726929';
wwv_flow_imp.g_varchar2_table(31) := '7C7C6F742E756E646566696E656428742E75726929297D2C28623D6B7C7C286B3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E7B7461726765745572693A652C74617267657452616E67653A742C74617267';
wwv_flow_imp.g_varchar2_table(32) := '657453656C656374696F6E52616E67653A6E2C6F726967696E53656C656374696F6E52616E67653A727D7D2C622E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E7461';
wwv_flow_imp.g_varchar2_table(33) := '7267657452616E67652926266F742E737472696E6728742E746172676574557269292626286D2E697328742E74617267657453656C656374696F6E52616E6765297C7C6F742E756E646566696E656428742E74617267657453656C656374696F6E52616E';
wwv_flow_imp.g_varchar2_table(34) := '676529292626286D2E697328742E6F726967696E53656C656374696F6E52616E6765297C7C6F742E756E646566696E656428742E6F726967696E53656C656374696F6E52616E676529297D2C28453D797C7C28793D7B7D29292E6372656174653D66756E';
wwv_flow_imp.g_varchar2_table(35) := '6374696F6E28652C742C6E2C72297B72657475726E7B7265643A652C677265656E3A742C626C75653A6E2C616C7068613A727D7D2C452E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E6E756D62657252616E676528';
wwv_flow_imp.g_varchar2_table(36) := '742E7265642C302C312926266F742E6E756D62657252616E676528742E677265656E2C302C312926266F742E6E756D62657252616E676528742E626C75652C302C312926266F742E6E756D62657252616E676528742E616C7068612C302C31297D2C2878';
wwv_flow_imp.g_varchar2_table(37) := '3D437C7C28433D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C636F6C6F723A747D7D2C782E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206D2E697328742E72616E';
wwv_flow_imp.g_varchar2_table(38) := '6765292626792E697328742E636F6C6F72297D2C28413D497C7C28493D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B6C6162656C3A652C74657874456469743A742C6164646974696F6E616C54657874456469';
wwv_flow_imp.g_varchar2_table(39) := '74733A6E7D7D2C412E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E737472696E6728742E6C6162656C292626286F742E756E646566696E656428742E7465787445646974297C7C4B2E6973287429292626286F742E';
wwv_flow_imp.g_varchar2_table(40) := '756E646566696E656428742E6164646974696F6E616C546578744564697473297C7C6F742E7479706564417272617928742E6164646974696F6E616C5465787445646974732C4B2E697329297D2C28523D537C7C28533D7B7D29292E436F6D6D656E743D';
wwv_flow_imp.g_varchar2_table(41) := '22636F6D6D656E74222C522E496D706F7274733D22696D706F727473222C522E526567696F6E3D22726567696F6E222C28443D547C7C28543D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C69297B766172206F3D7B73746172';
wwv_flow_imp.g_varchar2_table(42) := '744C696E653A652C656E644C696E653A747D3B72657475726E206F742E646566696E6564286E292626286F2E73746172744368617261637465723D6E292C6F742E646566696E65642872292626286F2E656E644368617261637465723D72292C6F742E64';
wwv_flow_imp.g_varchar2_table(43) := '6566696E65642869292626286F2E6B696E643D69292C6F7D2C442E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E75696E746567657228742E73746172744C696E652926266F742E75696E746567657228742E737461';
wwv_flow_imp.g_varchar2_table(44) := '72744C696E65292626286F742E756E646566696E656428742E7374617274436861726163746572297C7C6F742E75696E746567657228742E737461727443686172616374657229292626286F742E756E646566696E656428742E656E6443686172616374';
wwv_flow_imp.g_varchar2_table(45) := '6572297C7C6F742E75696E746567657228742E656E6443686172616374657229292626286F742E756E646566696E656428742E6B696E64297C7C6F742E737472696E6728742E6B696E6429297D2C284D3D507C7C28503D7B7D29292E6372656174653D66';
wwv_flow_imp.g_varchar2_table(46) := '756E6374696F6E28652C74297B72657475726E7B6C6F636174696F6E3A652C6D6573736167653A747D7D2C4D2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926265F2E697328742E6C6F63';
wwv_flow_imp.g_varchar2_table(47) := '6174696F6E2926266F742E737472696E6728742E6D657373616765297D2C284C3D467C7C28463D7B7D29292E4572726F723D312C4C2E5761726E696E673D322C4C2E496E666F726D6174696F6E3D332C4C2E48696E743D342C284F3D6A7C7C286A3D7B7D';
wwv_flow_imp.g_varchar2_table(48) := '29292E556E6E65636573736172793D312C4F2E446570726563617465643D322C284E7C7C284E3D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206E756C6C213D7426266F742E737472696E6728742E6872656629';
wwv_flow_imp.g_varchar2_table(49) := '7D2C28573D557C7C28553D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C692C6F297B76617220613D7B72616E67653A652C6D6573736167653A747D3B72657475726E206F742E646566696E6564286E29262628612E73657665';
wwv_flow_imp.g_varchar2_table(50) := '726974793D6E292C6F742E646566696E6564287229262628612E636F64653D72292C6F742E646566696E6564286929262628612E736F757263653D69292C6F742E646566696E6564286F29262628612E72656C61746564496E666F726D6174696F6E3D6F';
wwv_flow_imp.g_varchar2_table(51) := '292C617D2C572E69733D66756E6374696F6E2865297B76617220742C6E3D653B72657475726E206F742E646566696E6564286E2926266D2E6973286E2E72616E67652926266F742E737472696E67286E2E6D657373616765292626286F742E6E756D6265';
wwv_flow_imp.g_varchar2_table(52) := '72286E2E7365766572697479297C7C6F742E756E646566696E6564286E2E736576657269747929292626286F742E696E7465676572286E2E636F6465297C7C6F742E737472696E67286E2E636F6465297C7C6F742E756E646566696E6564286E2E636F64';
wwv_flow_imp.g_varchar2_table(53) := '6529292626286F742E756E646566696E6564286E2E636F64654465736372697074696F6E297C7C6F742E737472696E67286E756C6C3D3D3D28743D6E2E636F64654465736372697074696F6E297C7C766F696420303D3D3D743F766F696420303A742E68';
wwv_flow_imp.g_varchar2_table(54) := '72656629292626286F742E737472696E67286E2E736F75726365297C7C6F742E756E646566696E6564286E2E736F7572636529292626286F742E756E646566696E6564286E2E72656C61746564496E666F726D6174696F6E297C7C6F742E747970656441';
wwv_flow_imp.g_varchar2_table(55) := '72726179286E2E72656C61746564496E666F726D6174696F6E2C502E697329297D2C28483D567C7C28563D7B7D29292E6372656174653D66756E6374696F6E28652C74297B666F7228766172206E3D5B5D2C723D323B723C617267756D656E74732E6C65';
wwv_flow_imp.g_varchar2_table(56) := '6E6774683B722B2B296E5B722D325D3D617267756D656E74735B725D3B76617220693D7B7469746C653A652C636F6D6D616E643A747D3B72657475726E206F742E646566696E6564286E2926266E2E6C656E6774683E30262628692E617267756D656E74';
wwv_flow_imp.g_varchar2_table(57) := '733D6E292C697D2C482E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E7469746C652926266F742E737472696E6728742E636F6D6D616E64297D2C287A3D';
wwv_flow_imp.g_varchar2_table(58) := '4B7C7C284B3D7B7D29292E7265706C6163653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A747D7D2C7A2E696E736572743D66756E6374696F6E28652C74297B72657475726E7B72616E67653A7B737461';
wwv_flow_imp.g_varchar2_table(59) := '72743A652C656E643A657D2C6E6577546578743A747D7D2C7A2E64656C3D66756E6374696F6E2865297B72657475726E7B72616E67653A652C6E6577546578743A22227D7D2C7A2E69733D66756E6374696F6E2865297B76617220743D653B7265747572';
wwv_flow_imp.g_varchar2_table(60) := '6E206F742E6F626A6563744C69746572616C28742926266F742E737472696E6728742E6E6577546578742926266D2E697328742E72616E6765297D2C28423D587C7C28583D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B766172';
wwv_flow_imp.g_varchar2_table(61) := '20723D7B6C6162656C3A657D3B72657475726E20766F69642030213D3D74262628722E6E65656473436F6E6669726D6174696F6E3D74292C766F69642030213D3D6E262628722E6465736372697074696F6E3D6E292C727D2C422E69733D66756E637469';
wwv_flow_imp.g_varchar2_table(62) := '6F6E2865297B76617220743D653B72657475726E20766F69642030213D3D7426266F742E6F626A6563744C69746572616C28742926266F742E737472696E6728742E6C6162656C292626286F742E626F6F6C65616E28742E6E65656473436F6E6669726D';
wwv_flow_imp.g_varchar2_table(63) := '6174696F6E297C7C766F696420303D3D3D742E6E65656473436F6E6669726D6174696F6E292626286F742E737472696E6728742E6465736372697074696F6E297C7C766F696420303D3D3D742E6465736372697074696F6E297D2C28247C7C28243D7B7D';
wwv_flow_imp.g_varchar2_table(64) := '29292E69733D66756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620657D2C28513D717C7C28713D7B7D29292E7265706C6163653D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A652C6E6577';
wwv_flow_imp.g_varchar2_table(65) := '546578743A742C616E6E6F746174696F6E49643A6E7D7D2C512E696E736572743D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A7B73746172743A652C656E643A657D2C6E6577546578743A742C616E6E6F746174696F6E4964';
wwv_flow_imp.g_varchar2_table(66) := '3A6E7D7D2C512E64656C3D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A22222C616E6E6F746174696F6E49643A747D7D2C512E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20';
wwv_flow_imp.g_varchar2_table(67) := '4B2E6973287429262628582E697328742E616E6E6F746174696F6E4964297C7C242E697328742E616E6E6F746174696F6E496429297D2C284A3D477C7C28473D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B746578';
wwv_flow_imp.g_varchar2_table(68) := '74446F63756D656E743A652C65646974733A747D7D2C4A2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E6564287429262664652E697328742E74657874446F63756D656E7429262641727261792E6973';
wwv_flow_imp.g_varchar2_table(69) := '417272617928742E6564697473297D2C285A3D597C7C28593D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220723D7B6B696E643A22637265617465222C7572693A657D3B72657475726E20766F696420303D3D3D747C7C';
wwv_flow_imp.g_varchar2_table(70) := '766F696420303D3D3D742E6F76657277726974652626766F696420303D3D3D742E69676E6F726549664578697374737C7C28722E6F7074696F6E733D74292C766F69642030213D3D6E262628722E616E6E6F746174696F6E49643D6E292C727D2C5A2E69';
wwv_flow_imp.g_varchar2_table(71) := '733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262622637265617465223D3D3D742E6B696E6426266F742E737472696E6728742E75726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(72) := '742E6F7074696F6E732E6F76657277726974657C7C6F742E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C6F742E626F6F6C6561';
wwv_flow_imp.g_varchar2_table(73) := '6E28742E6F7074696F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C242E697328742E616E6E6F746174696F6E496429297D2C2874653D65657C7C2865653D7B7D29292E637265';
wwv_flow_imp.g_varchar2_table(74) := '6174653D66756E6374696F6E28652C742C6E2C72297B76617220693D7B6B696E643A2272656E616D65222C6F6C645572693A652C6E65775572693A747D3B72657475726E20766F696420303D3D3D6E7C7C766F696420303D3D3D6E2E6F76657277726974';
wwv_flow_imp.g_varchar2_table(75) := '652626766F696420303D3D3D6E2E69676E6F726549664578697374737C7C28692E6F7074696F6E733D6E292C766F69642030213D3D72262628692E616E6E6F746174696F6E49643D72292C697D2C74652E69733D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(76) := '743D653B72657475726E207426262272656E616D65223D3D3D742E6B696E6426266F742E737472696E6728742E6F6C645572692926266F742E737472696E6728742E6E657755726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F69';
wwv_flow_imp.g_varchar2_table(77) := '6420303D3D3D742E6F7074696F6E732E6F76657277726974657C7C6F742E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C6F742E';
wwv_flow_imp.g_varchar2_table(78) := '626F6F6C65616E28742E6F7074696F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C242E697328742E616E6E6F746174696F6E496429297D2C2872653D6E657C7C286E653D7B7D';
wwv_flow_imp.g_varchar2_table(79) := '29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220723D7B6B696E643A2264656C657465222C7572693A657D3B72657475726E20766F696420303D3D3D747C7C766F696420303D3D3D742E7265637572736976652626766F696420';
wwv_flow_imp.g_varchar2_table(80) := '303D3D3D742E69676E6F726549664E6F744578697374737C7C28722E6F7074696F6E733D74292C766F69642030213D3D6E262628722E616E6E6F746174696F6E49643D6E292C727D2C72652E69733D66756E6374696F6E2865297B76617220743D653B72';
wwv_flow_imp.g_varchar2_table(81) := '657475726E207426262264656C657465223D3D3D742E6B696E6426266F742E737472696E6728742E75726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E7265637572736976657C7C6F74';
wwv_flow_imp.g_varchar2_table(82) := '2E626F6F6C65616E28742E6F7074696F6E732E7265637572736976652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664E6F744578697374737C7C6F742E626F6F6C65616E28742E6F7074696F6E732E69676E6F72654966';
wwv_flow_imp.g_varchar2_table(83) := '4E6F74457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C242E697328742E616E6E6F746174696F6E496429297D2C2869657C7C2869653D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B';
wwv_flow_imp.g_varchar2_table(84) := '72657475726E2074262628766F69642030213D3D742E6368616E6765737C7C766F69642030213D3D742E646F63756D656E744368616E67657329262628766F696420303D3D3D742E646F63756D656E744368616E6765737C7C742E646F63756D656E7443';
wwv_flow_imp.g_varchar2_table(85) := '68616E6765732E6576657279282866756E6374696F6E2865297B72657475726E206F742E737472696E6728652E6B696E64293F592E69732865297C7C65652E69732865297C7C6E652E69732865293A472E69732865297D2929297D3B7661722061652C73';
wwv_flow_imp.g_varchar2_table(86) := '652C75652C63652C64652C67652C6C652C68652C66652C70652C6D652C76652C5F652C77652C6B652C62652C79652C45652C43652C78652C49652C41652C53652C52652C54652C44652C50652C4D652C46652C4C652C6A652C4F652C4E652C55652C5765';
wwv_flow_imp.g_varchar2_table(87) := '2C56652C48652C4B652C7A652C58652C42652C24652C71652C51652C47652C4A652C59652C5A652C65742C74742C6E742C72743D66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E65646974733D652C746869732E636861';
wwv_flow_imp.g_varchar2_table(88) := '6E6765416E6E6F746174696F6E733D747D72657475726E20652E70726F746F747970652E696E736572743D66756E6374696F6E28652C742C6E297B76617220722C693B696628766F696420303D3D3D6E3F723D4B2E696E7365727428652C74293A242E69';
wwv_flow_imp.g_varchar2_table(89) := '73286E293F28693D6E2C723D712E696E7365727428652C742C6E29293A28746869732E6173736572744368616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C693D746869732E6368616E6765416E6E6F';
wwv_flow_imp.g_varchar2_table(90) := '746174696F6E732E6D616E616765286E292C723D712E696E7365727428652C742C6929292C746869732E65646974732E707573682872292C766F69642030213D3D692972657475726E20697D2C652E70726F746F747970652E7265706C6163653D66756E';
wwv_flow_imp.g_varchar2_table(91) := '6374696F6E28652C742C6E297B76617220722C693B696628766F696420303D3D3D6E3F723D4B2E7265706C61636528652C74293A242E6973286E293F28693D6E2C723D712E7265706C61636528652C742C6E29293A28746869732E617373657274436861';
wwv_flow_imp.g_varchar2_table(92) := '6E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C693D746869732E6368616E6765416E6E6F746174696F6E732E6D616E616765286E292C723D712E7265706C61636528652C742C6929292C746869732E65';
wwv_flow_imp.g_varchar2_table(93) := '646974732E707573682872292C766F69642030213D3D692972657475726E20697D2C652E70726F746F747970652E64656C6574653D66756E6374696F6E28652C74297B766172206E2C723B696628766F696420303D3D3D743F6E3D4B2E64656C2865293A';
wwv_flow_imp.g_varchar2_table(94) := '242E69732874293F28723D742C6E3D712E64656C28652C7429293A28746869732E6173736572744368616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C723D746869732E6368616E6765416E6E6F7461';
wwv_flow_imp.g_varchar2_table(95) := '74696F6E732E6D616E6167652874292C6E3D712E64656C28652C7229292C746869732E65646974732E70757368286E292C766F69642030213D3D722972657475726E20727D2C652E70726F746F747970652E6164643D66756E6374696F6E2865297B7468';
wwv_flow_imp.g_varchar2_table(96) := '69732E65646974732E707573682865297D2C652E70726F746F747970652E616C6C3D66756E6374696F6E28297B72657475726E20746869732E65646974737D2C652E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E6564';
wwv_flow_imp.g_varchar2_table(97) := '6974732E73706C69636528302C746869732E65646974732E6C656E677468297D2C652E70726F746F747970652E6173736572744368616E6765416E6E6F746174696F6E733D66756E6374696F6E2865297B696628766F696420303D3D3D65297468726F77';
wwv_flow_imp.g_varchar2_table(98) := '206E6577204572726F722822546578742065646974206368616E6765206973206E6F7420636F6E6669677572656420746F206D616E616765206368616E676520616E6E6F746174696F6E732E22297D2C657D28292C69743D66756E6374696F6E28297B66';
wwv_flow_imp.g_varchar2_table(99) := '756E6374696F6E20652865297B746869732E5F616E6E6F746174696F6E733D766F696420303D3D3D653F4F626A6563742E637265617465286E756C6C293A652C746869732E5F636F756E7465723D302C746869732E5F73697A653D307D72657475726E20';
wwv_flow_imp.g_varchar2_table(100) := '652E70726F746F747970652E616C6C3D66756E6374696F6E28297B72657475726E20746869732E5F616E6E6F746174696F6E737D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2273697A65222C7B6765743A66';
wwv_flow_imp.g_varchar2_table(101) := '756E6374696F6E28297B72657475726E20746869732E5F73697A657D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E6D616E6167653D66756E6374696F6E28652C74297B766172206E3B';
wwv_flow_imp.g_varchar2_table(102) := '696628242E69732865293F6E3D653A286E3D746869732E6E657874496428292C743D65292C766F69642030213D3D746869732E5F616E6E6F746174696F6E735B6E5D297468726F77206E6577204572726F722822496420222B6E2B2220697320616C7265';
wwv_flow_imp.g_varchar2_table(103) := '61647920696E207573652E22293B696628766F696420303D3D3D74297468726F77206E6577204572726F7228224E6F20616E6E6F746174696F6E2070726F766964656420666F7220696420222B6E293B72657475726E20746869732E5F616E6E6F746174';
wwv_flow_imp.g_varchar2_table(104) := '696F6E735B6E5D3D742C746869732E5F73697A652B2B2C6E7D2C652E70726F746F747970652E6E65787449643D66756E6374696F6E28297B72657475726E20746869732E5F636F756E7465722B2B2C746869732E5F636F756E7465722E746F537472696E';
wwv_flow_imp.g_varchar2_table(105) := '6728297D2C657D28293B2166756E6374696F6E28297B66756E6374696F6E20652865297B76617220743D746869733B746869732E5F74657874456469744368616E6765733D4F626A6563742E637265617465286E756C6C292C766F69642030213D3D653F';
wwv_flow_imp.g_varchar2_table(106) := '28746869732E5F776F726B7370616365456469743D652C652E646F63756D656E744368616E6765733F28746869732E5F6368616E6765416E6E6F746174696F6E733D6E657720697428652E6368616E6765416E6E6F746174696F6E73292C652E6368616E';
wwv_flow_imp.g_varchar2_table(107) := '6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C28292C652E646F63756D656E744368616E6765732E666F7245616368282866756E6374696F6E2865297B696628472E6973286529297B766172206E';
wwv_flow_imp.g_varchar2_table(108) := '3D6E657720727428652E65646974732C742E5F6368616E6765416E6E6F746174696F6E73293B742E5F74657874456469744368616E6765735B652E74657874446F63756D656E742E7572695D3D6E7D7D2929293A652E6368616E67657326264F626A6563';
wwv_flow_imp.g_varchar2_table(109) := '742E6B65797328652E6368616E676573292E666F7245616368282866756E6374696F6E286E297B76617220723D6E657720727428652E6368616E6765735B6E5D293B742E5F74657874456469744368616E6765735B6E5D3D727D2929293A746869732E5F';
wwv_flow_imp.g_varchar2_table(110) := '776F726B7370616365456469743D7B7D7D4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2265646974222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E696E6974446F63756D656E744368';
wwv_flow_imp.g_varchar2_table(111) := '616E67657328292C766F69642030213D3D746869732E5F6368616E6765416E6E6F746174696F6E73262628303D3D3D746869732E5F6368616E6765416E6E6F746174696F6E732E73697A653F746869732E5F776F726B7370616365456469742E6368616E';
wwv_flow_imp.g_varchar2_table(112) := '6765416E6E6F746174696F6E733D766F696420303A746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829292C746869732E5F776F726B';
wwv_flow_imp.g_varchar2_table(113) := '7370616365456469747D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E67657454657874456469744368616E67653D66756E6374696F6E2865297B69662864652E6973286529297B6966';
wwv_flow_imp.g_varchar2_table(114) := '28746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B737061636520';
wwv_flow_imp.g_varchar2_table(115) := '65646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220743D7B7572693A652E7572692C76657273696F6E3A652E76657273696F6E7D3B6966282128723D746869732E5F74657874';
wwv_flow_imp.g_varchar2_table(116) := '456469744368616E6765735B742E7572695D29297B766172206E3D7B74657874446F63756D656E743A742C65646974733A693D5B5D7D3B746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E70757368286E292C72';
wwv_flow_imp.g_varchar2_table(117) := '3D6E657720727428692C746869732E5F6368616E6765416E6E6F746174696F6E73292C746869732E5F74657874456469744368616E6765735B742E7572695D3D727D72657475726E20727D696628746869732E696E69744368616E67657328292C766F69';
wwv_flow_imp.g_varchar2_table(118) := '6420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F72206E6F726D616C207465787420';
wwv_flow_imp.g_varchar2_table(119) := '65646974206368616E6765732E22293B76617220723B6966282128723D746869732E5F74657874456469744368616E6765735B655D29297B76617220693D5B5D3B746869732E5F776F726B7370616365456469742E6368616E6765735B655D3D692C723D';
wwv_flow_imp.g_varchar2_table(120) := '6E65772072742869292C746869732E5F74657874456469744368616E6765735B655D3D727D72657475726E20727D2C652E70726F746F747970652E696E6974446F63756D656E744368616E6765733D66756E6374696F6E28297B766F696420303D3D3D74';
wwv_flow_imp.g_varchar2_table(121) := '6869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869732E5F6368616E6765416E6E6F746174696F6E733D6E';
wwv_flow_imp.g_varchar2_table(122) := '65772069742C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765733D5B5D2C746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F74';
wwv_flow_imp.g_varchar2_table(123) := '6174696F6E732E616C6C2829297D2C652E70726F746F747970652E696E69744368616E6765733D66756E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F6964';
wwv_flow_imp.g_varchar2_table(124) := '20303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869732E5F776F726B7370616365456469742E6368616E6765733D4F626A6563742E637265617465286E756C6C29297D2C652E70726F746F747970652E637265';
wwv_flow_imp.g_varchar2_table(125) := '61746546696C653D66756E6374696F6E28652C742C6E297B696628746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732974';
wwv_flow_imp.g_varchar2_table(126) := '68726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220722C692C6F3B696628582E69732874297C7C242E697328';
wwv_flow_imp.g_varchar2_table(127) := '74293F723D743A6E3D742C766F696420303D3D3D723F693D592E63726561746528652C6E293A286F3D242E69732872293F723A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C693D592E63726561746528652C6E2C';
wwv_flow_imp.g_varchar2_table(128) := '6F29292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E707573682869292C766F69642030213D3D6F2972657475726E206F7D2C652E70726F746F747970652E72656E616D6546696C653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(129) := '28652C742C6E2C72297B696628746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(130) := '2822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220692C6F2C613B696628582E6973286E297C7C242E6973286E293F693D6E3A723D6E2C766F69';
wwv_flow_imp.g_varchar2_table(131) := '6420303D3D3D693F6F3D65652E63726561746528652C742C72293A28613D242E69732869293F693A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652869292C6F3D65652E63726561746528652C742C722C6129292C74686973';
wwv_flow_imp.g_varchar2_table(132) := '2E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E70757368286F292C766F69642030213D3D612972657475726E20617D2C652E70726F746F747970652E64656C65746546696C653D66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(133) := '696628746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163';
wwv_flow_imp.g_varchar2_table(134) := '652065646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220722C692C6F3B696628582E69732874297C7C242E69732874293F723D743A6E3D742C766F696420303D3D3D723F693D';
wwv_flow_imp.g_varchar2_table(135) := '6E652E63726561746528652C6E293A286F3D242E69732872293F723A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C693D6E652E63726561746528652C6E2C6F29292C746869732E5F776F726B7370616365456469';
wwv_flow_imp.g_varchar2_table(136) := '742E646F63756D656E744368616E6765732E707573682869292C766F69642030213D3D6F2972657475726E206F7D7D28292C2873653D61657C7C2861653D7B7D29292E6372656174653D66756E6374696F6E2865297B72657475726E7B7572693A657D7D';
wwv_flow_imp.g_varchar2_table(137) := '2C73652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E757269297D2C2863653D75657C7C2875653D7B7D29292E6372656174653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(138) := '652C74297B72657475726E7B7572693A652C76657273696F6E3A747D7D2C63652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E7572692926266F742E69';
wwv_flow_imp.g_varchar2_table(139) := '6E746567657228742E76657273696F6E297D2C2867653D64657C7C2864653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C76657273696F6E3A747D7D2C67652E69733D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(140) := '76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E757269292626286E756C6C3D3D3D742E76657273696F6E7C7C6F742E696E746567657228742E76657273696F6E29297D2C2868653D6C657C7C28';
wwv_flow_imp.g_varchar2_table(141) := '6C653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E7B7572693A652C6C616E677561676549643A742C76657273696F6E3A6E2C746578743A727D7D2C68652E69733D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(142) := '743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E7572692926266F742E737472696E6728742E6C616E677561676549642926266F742E696E746567657228742E76657273696F6E2926266F742E737472696E';
wwv_flow_imp.g_varchar2_table(143) := '6728742E74657874297D2C2870653D66657C7C2866653D7B7D29292E506C61696E546578743D22706C61696E74657874222C70652E4D61726B646F776E3D226D61726B646F776E222C66756E6374696F6E2865297B652E69733D66756E6374696F6E2874';
wwv_flow_imp.g_varchar2_table(144) := '297B766172206E3D743B72657475726E206E3D3D3D652E506C61696E546578747C7C6E3D3D3D652E4D61726B646F776E7D7D2866657C7C2866653D7B7D29292C286D657C7C286D653D7B7D29292E69733D66756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(145) := '3B72657475726E206F742E6F626A6563744C69746572616C286529262666652E697328742E6B696E642926266F742E737472696E6728742E76616C7565297D2C285F653D76657C7C2876653D7B7D29292E546578743D312C5F652E4D6574686F643D322C';
wwv_flow_imp.g_varchar2_table(146) := '5F652E46756E6374696F6E3D332C5F652E436F6E7374727563746F723D342C5F652E4669656C643D352C5F652E5661726961626C653D362C5F652E436C6173733D372C5F652E496E746572666163653D382C5F652E4D6F64756C653D392C5F652E50726F';
wwv_flow_imp.g_varchar2_table(147) := '70657274793D31302C5F652E556E69743D31312C5F652E56616C75653D31322C5F652E456E756D3D31332C5F652E4B6579776F72643D31342C5F652E536E69707065743D31352C5F652E436F6C6F723D31362C5F652E46696C653D31372C5F652E526566';
wwv_flow_imp.g_varchar2_table(148) := '6572656E63653D31382C5F652E466F6C6465723D31392C5F652E456E756D4D656D6265723D32302C5F652E436F6E7374616E743D32312C5F652E5374727563743D32322C5F652E4576656E743D32332C5F652E4F70657261746F723D32342C5F652E5479';
wwv_flow_imp.g_varchar2_table(149) := '7065506172616D657465723D32352C286B653D77657C7C2877653D7B7D29292E506C61696E546578743D312C6B652E536E69707065743D322C2862657C7C2862653D7B7D29292E446570726563617465643D312C2845653D79657C7C2879653D7B7D2929';
wwv_flow_imp.g_varchar2_table(150) := '2E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B6E6577546578743A652C696E736572743A742C7265706C6163653A6E7D7D2C45652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426266F74';
wwv_flow_imp.g_varchar2_table(151) := '2E737472696E6728742E6E6577546578742926266D2E697328742E696E736572742926266D2E697328742E7265706C616365297D2C2878653D43657C7C2843653D7B7D29292E617349733D312C78652E61646A757374496E64656E746174696F6E3D322C';
wwv_flow_imp.g_varchar2_table(152) := '2849657C7C2849653D7B7D29292E6372656174653D66756E6374696F6E2865297B72657475726E7B6C6162656C3A657D7D2C2841657C7C2841653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B6974656D733A657C';
wwv_flow_imp.g_varchar2_table(153) := '7C5B5D2C6973496E636F6D706C6574653A2121747D7D2C2852653D53657C7C2853653D7B7D29292E66726F6D506C61696E546578743D66756E6374696F6E2865297B72657475726E20652E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C';
wwv_flow_imp.g_varchar2_table(154) := '2D2E215D2F672C225C5C242622297D2C52652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E737472696E672874297C7C6F742E6F626A6563744C69746572616C28742926266F742E737472696E6728742E6C616E67';
wwv_flow_imp.g_varchar2_table(155) := '756167652926266F742E737472696E6728742E76616C7565297D2C2854657C7C2854653D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E21217426266F742E6F626A6563744C69746572616C2874292626286D652E';
wwv_flow_imp.g_varchar2_table(156) := '697328742E636F6E74656E7473297C7C53652E697328742E636F6E74656E7473297C7C6F742E7479706564417272617928742E636F6E74656E74732C53652E69732929262628766F696420303D3D3D652E72616E67657C7C6D2E697328652E72616E6765';
wwv_flow_imp.g_varchar2_table(157) := '29297D2C2844657C7C2844653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E20743F7B6C6162656C3A652C646F63756D656E746174696F6E3A747D3A7B6C6162656C3A657D7D2C2850657C7C2850653D7B7D29292E63';
wwv_flow_imp.g_varchar2_table(158) := '72656174653D66756E6374696F6E28652C74297B666F7228766172206E3D5B5D2C723D323B723C617267756D656E74732E6C656E6774683B722B2B296E5B722D325D3D617267756D656E74735B725D3B76617220693D7B6C6162656C3A657D3B72657475';
wwv_flow_imp.g_varchar2_table(159) := '726E206F742E646566696E6564287429262628692E646F63756D656E746174696F6E3D74292C6F742E646566696E6564286E293F692E706172616D65746572733D6E3A692E706172616D65746572733D5B5D2C697D2C2846653D4D657C7C284D653D7B7D';
wwv_flow_imp.g_varchar2_table(160) := '29292E546578743D312C46652E526561643D322C46652E57726974653D332C284C657C7C284C653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475726E206F742E6E756D6265722874';
wwv_flow_imp.g_varchar2_table(161) := '292626286E2E6B696E643D74292C6E7D2C284F653D6A657C7C286A653D7B7D29292E46696C653D312C4F652E4D6F64756C653D322C4F652E4E616D6573706163653D332C4F652E5061636B6167653D342C4F652E436C6173733D352C4F652E4D6574686F';
wwv_flow_imp.g_varchar2_table(162) := '643D362C4F652E50726F70657274793D372C4F652E4669656C643D382C4F652E436F6E7374727563746F723D392C4F652E456E756D3D31302C4F652E496E746572666163653D31312C4F652E46756E6374696F6E3D31322C4F652E5661726961626C653D';
wwv_flow_imp.g_varchar2_table(163) := '31332C4F652E436F6E7374616E743D31342C4F652E537472696E673D31352C4F652E4E756D6265723D31362C4F652E426F6F6C65616E3D31372C4F652E41727261793D31382C4F652E4F626A6563743D31392C4F652E4B65793D32302C4F652E4E756C6C';
wwv_flow_imp.g_varchar2_table(164) := '3D32312C4F652E456E756D4D656D6265723D32322C4F652E5374727563743D32332C4F652E4576656E743D32342C4F652E4F70657261746F723D32352C4F652E54797065506172616D657465723D32362C284E657C7C284E653D7B7D29292E4465707265';
wwv_flow_imp.g_varchar2_table(165) := '63617465643D312C2855657C7C2855653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C69297B766172206F3D7B6E616D653A652C6B696E643A742C6C6F636174696F6E3A7B7572693A722C72616E67653A6E7D7D3B72657475';
wwv_flow_imp.g_varchar2_table(166) := '726E20692626286F2E636F6E7461696E65724E616D653D69292C6F7D2C2856653D57657C7C2857653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C692C6F297B76617220613D7B6E616D653A652C64657461696C3A742C6B69';
wwv_flow_imp.g_varchar2_table(167) := '6E643A6E2C72616E67653A722C73656C656374696F6E52616E67653A697D3B72657475726E20766F69642030213D3D6F262628612E6368696C6472656E3D6F292C617D2C56652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E';
wwv_flow_imp.g_varchar2_table(168) := '207426266F742E737472696E6728742E6E616D652926266F742E6E756D62657228742E6B696E642926266D2E697328742E72616E67652926266D2E697328742E73656C656374696F6E52616E676529262628766F696420303D3D3D742E64657461696C7C';
wwv_flow_imp.g_varchar2_table(169) := '7C6F742E737472696E6728742E64657461696C2929262628766F696420303D3D3D742E646570726563617465647C7C6F742E626F6F6C65616E28742E646570726563617465642929262628766F696420303D3D3D742E6368696C6472656E7C7C41727261';
wwv_flow_imp.g_varchar2_table(170) := '792E6973417272617928742E6368696C6472656E2929262628766F696420303D3D3D742E746167737C7C41727261792E6973417272617928742E7461677329297D2C284B653D48657C7C2848653D7B7D29292E456D7074793D22222C4B652E517569636B';
wwv_flow_imp.g_varchar2_table(171) := '4669783D22717569636B666978222C4B652E5265666163746F723D227265666163746F72222C4B652E5265666163746F72457874726163743D227265666163746F722E65787472616374222C4B652E5265666163746F72496E6C696E653D227265666163';
wwv_flow_imp.g_varchar2_table(172) := '746F722E696E6C696E65222C4B652E5265666163746F72526577726974653D227265666163746F722E72657772697465222C4B652E536F757263653D22736F75726365222C4B652E536F757263654F7267616E697A65496D706F7274733D22736F757263';
wwv_flow_imp.g_varchar2_table(173) := '652E6F7267616E697A65496D706F727473222C4B652E536F75726365466978416C6C3D22736F757263652E666978416C6C222C2858653D7A657C7C287A653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B64696167';
wwv_flow_imp.g_varchar2_table(174) := '6E6F73746963733A657D3B72657475726E206E756C6C213D742626286E2E6F6E6C793D74292C6E7D2C58652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E7479706564417272';
wwv_flow_imp.g_varchar2_table(175) := '617928742E646961676E6F73746963732C552E697329262628766F696420303D3D3D742E6F6E6C797C7C6F742E7479706564417272617928742E6F6E6C792C6F742E737472696E6729297D2C2824653D42657C7C2842653D7B7D29292E6372656174653D';
wwv_flow_imp.g_varchar2_table(176) := '66756E6374696F6E28652C742C6E297B76617220723D7B7469746C653A657D2C693D21303B72657475726E22737472696E67223D3D747970656F6620743F28693D21312C722E6B696E643D74293A562E69732874293F722E636F6D6D616E643D743A722E';
wwv_flow_imp.g_varchar2_table(177) := '656469743D742C692626766F69642030213D3D6E262628722E6B696E643D6E292C727D2C24652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426266F742E737472696E6728742E7469746C6529262628766F696420303D';
wwv_flow_imp.g_varchar2_table(178) := '3D3D742E646961676E6F73746963737C7C6F742E7479706564417272617928742E646961676E6F73746963732C552E69732929262628766F696420303D3D3D742E6B696E647C7C6F742E737472696E6728742E6B696E642929262628766F69642030213D';
wwv_flow_imp.g_varchar2_table(179) := '3D742E656469747C7C766F69642030213D3D742E636F6D6D616E6429262628766F696420303D3D3D742E636F6D6D616E647C7C562E697328742E636F6D6D616E642929262628766F696420303D3D3D742E69735072656665727265647C7C6F742E626F6F';
wwv_flow_imp.g_varchar2_table(180) := '6C65616E28742E69735072656665727265642929262628766F696420303D3D3D742E656469747C7C69652E697328742E6564697429297D2C2851653D71657C7C2871653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D';
wwv_flow_imp.g_varchar2_table(181) := '7B72616E67653A657D3B72657475726E206F742E646566696E65642874292626286E2E646174613D74292C6E7D2C51652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E69732874';
wwv_flow_imp.g_varchar2_table(182) := '2E72616E6765292626286F742E756E646566696E656428742E636F6D6D616E64297C7C562E697328742E636F6D6D616E6429297D2C284A653D47657C7C2847653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7461';
wwv_flow_imp.g_varchar2_table(183) := '6253697A653A652C696E736572745370616365733A747D7D2C4A652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E75696E746567657228742E74616253697A652926266F742E';
wwv_flow_imp.g_varchar2_table(184) := '626F6F6C65616E28742E696E73657274537061636573297D2C285A653D59657C7C2859653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A652C7461726765743A742C646174613A6E7D7D2C5A65';
wwv_flow_imp.g_varchar2_table(185) := '2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E72616E6765292626286F742E756E646566696E656428742E746172676574297C7C6F742E737472696E6728742E7461';
wwv_flow_imp.g_varchar2_table(186) := '7267657429297D2C2874743D65747C7C2865743D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C706172656E743A747D7D2C74742E69733D66756E6374696F6E2865297B76617220743D653B7265';
wwv_flow_imp.g_varchar2_table(187) := '7475726E20766F69642030213D3D7426266D2E697328742E72616E676529262628766F696420303D3D3D742E706172656E747C7C74742E697328742E706172656E7429297D2C66756E6374696F6E2865297B66756E6374696F6E207428652C6E297B6966';
wwv_flow_imp.g_varchar2_table(188) := '28652E6C656E6774683C3D312972657475726E20653B76617220723D652E6C656E6774682F327C302C693D652E736C69636528302C72292C6F3D652E736C6963652872293B7428692C6E292C74286F2C6E293B666F722876617220613D302C733D302C75';
wwv_flow_imp.g_varchar2_table(189) := '3D303B613C692E6C656E6774682626733C6F2E6C656E6774683B297B76617220633D6E28695B615D2C6F5B735D293B655B752B2B5D3D633C3D303F695B612B2B5D3A6F5B732B2B5D7D666F72283B613C692E6C656E6774683B29655B752B2B5D3D695B61';
wwv_flow_imp.g_varchar2_table(190) := '2B2B5D3B666F72283B733C6F2E6C656E6774683B29655B752B2B5D3D6F5B732B2B5D3B72657475726E20657D652E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E206E657720757428652C742C6E2C72297D2C652E69733D';
wwv_flow_imp.g_varchar2_table(191) := '66756E6374696F6E2865297B76617220743D653B72657475726E2121286F742E646566696E656428742926266F742E737472696E6728742E757269292626286F742E756E646566696E656428742E6C616E67756167654964297C7C6F742E737472696E67';
wwv_flow_imp.g_varchar2_table(192) := '28742E6C616E67756167654964292926266F742E75696E746567657228742E6C696E65436F756E742926266F742E66756E6328742E676574546578742926266F742E66756E6328742E706F736974696F6E41742926266F742E66756E6328742E6F666673';
wwv_flow_imp.g_varchar2_table(193) := '6574417429297D2C652E6170706C7945646974733D66756E6374696F6E28652C6E297B666F722876617220723D652E6765745465787428292C693D74286E2C2866756E6374696F6E28652C74297B766172206E3D652E72616E67652E73746172742E6C69';
wwv_flow_imp.g_varchar2_table(194) := '6E652D742E72616E67652E73746172742E6C696E653B72657475726E20303D3D3D6E3F652E72616E67652E73746172742E6368617261637465722D742E72616E67652E73746172742E6368617261637465723A6E7D29292C6F3D722E6C656E6774682C61';
wwv_flow_imp.g_varchar2_table(195) := '3D692E6C656E6774682D313B613E3D303B612D2D297B76617220733D695B615D2C753D652E6F6666736574417428732E72616E67652E7374617274292C633D652E6F6666736574417428732E72616E67652E656E64293B6966282128633C3D6F29297468';
wwv_flow_imp.g_varchar2_table(196) := '726F77206E6577204572726F7228224F7665726C617070696E67206564697422293B723D722E737562737472696E6728302C75292B732E6E6577546578742B722E737562737472696E6728632C722E6C656E677468292C6F3D757D72657475726E20727D';
wwv_flow_imp.g_varchar2_table(197) := '7D286E747C7C286E743D7B7D29293B766172206F742C61742C73742C75743D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C72297B746869732E5F7572693D652C746869732E5F6C616E677561676549643D742C746869732E5F76';
wwv_flow_imp.g_varchar2_table(198) := '657273696F6E3D6E2C746869732E5F636F6E74656E743D722C746869732E5F6C696E654F6666736574733D766F696420307D72657475726E204F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C22757269222C7B6765';
wwv_flow_imp.g_varchar2_table(199) := '743A66756E6374696F6E28297B72657475726E20746869732E5F7572697D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C61';
wwv_flow_imp.g_varchar2_table(200) := '6E67756167654964222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F6C616E677561676549647D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F70';
wwv_flow_imp.g_varchar2_table(201) := '6572747928652E70726F746F747970652C2276657273696F6E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F76657273696F6E7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70';
wwv_flow_imp.g_varchar2_table(202) := '726F746F747970652E676574546578743D66756E6374696F6E2865297B69662865297B76617220743D746869732E6F6666736574417428652E7374617274292C6E3D746869732E6F6666736574417428652E656E64293B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(203) := '636F6E74656E742E737562737472696E6728742C6E297D72657475726E20746869732E5F636F6E74656E747D2C652E70726F746F747970652E7570646174653D66756E6374696F6E28652C74297B746869732E5F636F6E74656E743D652E746578742C74';
wwv_flow_imp.g_varchar2_table(204) := '6869732E5F76657273696F6E3D742C746869732E5F6C696E654F6666736574733D766F696420307D2C652E70726F746F747970652E6765744C696E654F6666736574733D66756E6374696F6E28297B696628766F696420303D3D3D746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(205) := '654F666673657473297B666F722876617220653D5B5D2C743D746869732E5F636F6E74656E742C6E3D21302C723D303B723C742E6C656E6774683B722B2B297B6E262628652E707573682872292C6E3D2131293B76617220693D742E6368617241742872';
wwv_flow_imp.g_varchar2_table(206) := '293B6E3D225C72223D3D3D697C7C225C6E223D3D3D692C225C72223D3D3D692626722B313C742E6C656E6774682626225C6E223D3D3D742E63686172417428722B31292626722B2B7D6E2626742E6C656E6774683E302626652E7075736828742E6C656E';
wwv_flow_imp.g_varchar2_table(207) := '677468292C746869732E5F6C696E654F6666736574733D657D72657475726E20746869732E5F6C696E654F6666736574737D2C652E70726F746F747970652E706F736974696F6E41743D66756E6374696F6E2865297B653D4D6174682E6D6178284D6174';
wwv_flow_imp.g_varchar2_table(208) := '682E6D696E28652C746869732E5F636F6E74656E742E6C656E677468292C30293B76617220743D746869732E6765744C696E654F66667365747328292C6E3D302C723D742E6C656E6774683B696628303D3D3D722972657475726E20662E637265617465';
wwv_flow_imp.g_varchar2_table(209) := '28302C65293B666F72283B6E3C723B297B76617220693D4D6174682E666C6F6F7228286E2B72292F32293B745B695D3E653F723D693A6E3D692B317D766172206F3D6E2D313B72657475726E20662E637265617465286F2C652D745B6F5D297D2C652E70';
wwv_flow_imp.g_varchar2_table(210) := '726F746F747970652E6F666673657441743D66756E6374696F6E2865297B76617220743D746869732E6765744C696E654F66667365747328293B696628652E6C696E653E3D742E6C656E6774682972657475726E20746869732E5F636F6E74656E742E6C';
wwv_flow_imp.g_varchar2_table(211) := '656E6774683B696628652E6C696E653C302972657475726E20303B766172206E3D745B652E6C696E655D2C723D652E6C696E652B313C742E6C656E6774683F745B652E6C696E652B315D3A746869732E5F636F6E74656E742E6C656E6774683B72657475';
wwv_flow_imp.g_varchar2_table(212) := '726E204D6174682E6D6178284D6174682E6D696E286E2B652E6368617261637465722C72292C6E297D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C696E65436F756E74222C7B6765743A66756E6374696F';
wwv_flow_imp.g_varchar2_table(213) := '6E28297B72657475726E20746869732E6765744C696E654F66667365747328292E6C656E6774687D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C657D28293B61743D6F747C7C286F743D7B7D292C73743D4F626A65';
wwv_flow_imp.g_varchar2_table(214) := '63742E70726F746F747970652E746F537472696E672C61742E646566696E65643D66756E6374696F6E2865297B72657475726E20766F69642030213D3D657D2C61742E756E646566696E65643D66756E6374696F6E2865297B72657475726E20766F6964';
wwv_flow_imp.g_varchar2_table(215) := '20303D3D3D657D2C61742E626F6F6C65616E3D66756E6374696F6E2865297B72657475726E21303D3D3D657C7C21313D3D3D657D2C61742E737472696E673D66756E6374696F6E2865297B72657475726E225B6F626A65637420537472696E675D223D3D';
wwv_flow_imp.g_varchar2_table(216) := '3D73742E63616C6C2865297D2C61742E6E756D6265723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D73742E63616C6C2865297D2C61742E6E756D62657252616E67653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(217) := '2C6E297B72657475726E225B6F626A656374204E756D6265725D223D3D3D73742E63616C6C2865292626743C3D652626653C3D6E7D2C61742E696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D22';
wwv_flow_imp.g_varchar2_table(218) := '3D3D3D73742E63616C6C28652926262D323134373438333634383C3D652626653C3D323134373438333634377D2C61742E75696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D73742E63';
wwv_flow_imp.g_varchar2_table(219) := '616C6C2865292626303C3D652626653C3D323134373438333634377D2C61742E66756E633D66756E6374696F6E2865297B72657475726E225B6F626A6563742046756E6374696F6E5D223D3D3D73742E63616C6C2865297D2C61742E6F626A6563744C69';
wwv_flow_imp.g_varchar2_table(220) := '746572616C3D66756E6374696F6E2865297B72657475726E206E756C6C213D3D652626226F626A656374223D3D747970656F6620657D2C61742E747970656441727261793D66756E6374696F6E28652C74297B72657475726E2041727261792E69734172';
wwv_flow_imp.g_varchar2_table(221) := '7261792865292626652E65766572792874297D3B7661722063743D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F6C616E677561676549643D652C746869732E5F776F726B65723D742C746869732E5F646973706F736162';
wwv_flow_imp.g_varchar2_table(222) := '6C65733D5B5D2C746869732E5F6C697374656E65723D4F626A6563742E637265617465286E756C6C293B636F6E737420723D653D3E7B6C657420742C6E3D652E6765744C616E6775616765496428293B6E3D3D3D746869732E5F6C616E67756167654964';
wwv_flow_imp.g_varchar2_table(223) := '262628746869732E5F6C697374656E65725B652E7572692E746F537472696E6728295D3D652E6F6E4469644368616E6765436F6E74656E74282828293D3E7B77696E646F772E636C65617254696D656F75742874292C743D77696E646F772E7365745469';
wwv_flow_imp.g_varchar2_table(224) := '6D656F7574282828293D3E746869732E5F646F56616C696461746528652E7572692C6E29292C353030297D29292C746869732E5F646F56616C696461746528652E7572692C6E29297D2C693D653D3E7B632E656469746F722E7365744D6F64656C4D6172';
wwv_flow_imp.g_varchar2_table(225) := '6B65727328652C746869732E5F6C616E677561676549642C5B5D293B6C657420743D652E7572692E746F537472696E6728292C6E3D746869732E5F6C697374656E65725B745D3B6E2626286E2E646973706F736528292C64656C65746520746869732E5F';
wwv_flow_imp.g_varchar2_table(226) := '6C697374656E65725B745D297D3B746869732E5F646973706F7361626C65732E7075736828632E656469746F722E6F6E4469644372656174654D6F64656C287229292C746869732E5F646973706F7361626C65732E7075736828632E656469746F722E6F';
wwv_flow_imp.g_varchar2_table(227) := '6E57696C6C446973706F73654D6F64656C286929292C746869732E5F646973706F7361626C65732E7075736828632E656469746F722E6F6E4469644368616E67654D6F64656C4C616E67756167652828653D3E7B6928652E6D6F64656C292C7228652E6D';
wwv_flow_imp.g_varchar2_table(228) := '6F64656C297D2929292C746869732E5F646973706F7361626C65732E70757368286E2828653D3E7B632E656469746F722E6765744D6F64656C7328292E666F72456163682828653D3E7B652E6765744C616E6775616765496428293D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(229) := '6C616E67756167654964262628692865292C72286529297D29297D2929292C746869732E5F646973706F7361626C65732E70757368287B646973706F73653A28293D3E7B632E656469746F722E6765744D6F64656C7328292E666F72456163682869293B';
wwv_flow_imp.g_varchar2_table(230) := '666F72286C6574206520696E20746869732E5F6C697374656E657229746869732E5F6C697374656E65725B655D2E646973706F736528297D7D292C632E656469746F722E6765744D6F64656C7328292E666F72456163682872297D646973706F73652829';
wwv_flow_imp.g_varchar2_table(231) := '7B746869732E5F646973706F7361626C65732E666F72456163682828653D3E652626652E646973706F7365282929292C746869732E5F646973706F7361626C65732E6C656E6774683D307D5F646F56616C696461746528652C74297B746869732E5F776F';
wwv_flow_imp.g_varchar2_table(232) := '726B65722865292E7468656E2828743D3E742E646F56616C69646174696F6E28652E746F537472696E6728292929292E7468656E28286E3D3E7B636F6E737420723D6E2E6D61702828653D3E66756E6374696F6E28652C74297B6C6574206E3D226E756D';
wwv_flow_imp.g_varchar2_table(233) := '626572223D3D747970656F6620742E636F64653F537472696E6728742E636F6465293A742E636F64653B72657475726E7B73657665726974793A647428742E7365766572697479292C73746172744C696E654E756D6265723A742E72616E67652E737461';
wwv_flow_imp.g_varchar2_table(234) := '72742E6C696E652B312C7374617274436F6C756D6E3A742E72616E67652E73746172742E6368617261637465722B312C656E644C696E654E756D6265723A742E72616E67652E656E642E6C696E652B312C656E64436F6C756D6E3A742E72616E67652E65';
wwv_flow_imp.g_varchar2_table(235) := '6E642E6368617261637465722B312C6D6573736167653A742E6D6573736167652C636F64653A6E2C736F757263653A742E736F757263657D7D28302C652929293B6C657420693D632E656469746F722E6765744D6F64656C2865293B692626692E676574';
wwv_flow_imp.g_varchar2_table(236) := '4C616E6775616765496428293D3D3D742626632E656469746F722E7365744D6F64656C4D61726B65727328692C742C72297D29292E7468656E28766F696420302C28653D3E7B636F6E736F6C652E6572726F722865297D29297D7D3B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(237) := '2064742865297B7377697463682865297B6361736520462E4572726F723A72657475726E20632E4D61726B657253657665726974792E4572726F723B6361736520462E5761726E696E673A72657475726E20632E4D61726B657253657665726974792E57';
wwv_flow_imp.g_varchar2_table(238) := '61726E696E673B6361736520462E496E666F726D6174696F6E3A72657475726E20632E4D61726B657253657665726974792E496E666F3B6361736520462E48696E743A72657475726E20632E4D61726B657253657665726974792E48696E743B64656661';
wwv_flow_imp.g_varchar2_table(239) := '756C743A72657475726E20632E4D61726B657253657665726974792E496E666F7D7D7661722067743D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F776F726B65723D652C746869732E5F747269676765724368617261637465';
wwv_flow_imp.g_varchar2_table(240) := '72733D747D67657420747269676765724368617261637465727328297B72657475726E20746869732E5F74726967676572436861726163746572737D70726F76696465436F6D706C6574696F6E4974656D7328652C742C6E2C72297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(241) := '652E7572693B72657475726E20746869732E5F776F726B65722869292E7468656E2828653D3E652E646F436F6D706C65746528692E746F537472696E6728292C6C742874292929292E7468656E28286E3D3E7B696628216E2972657475726E3B636F6E73';
wwv_flow_imp.g_varchar2_table(242) := '7420723D652E676574576F7264556E74696C506F736974696F6E2874292C693D6E657720632E52616E676528742E6C696E654E756D6265722C722E7374617274436F6C756D6E2C742E6C696E654E756D6265722C722E656E64436F6C756D6E292C6F3D6E';
wwv_flow_imp.g_varchar2_table(243) := '2E6974656D732E6D61702828653D3E7B636F6E737420743D7B6C6162656C3A652E6C6162656C2C696E73657274546578743A652E696E73657274546578747C7C652E6C6162656C2C736F7274546578743A652E736F7274546578742C66696C7465725465';
wwv_flow_imp.g_varchar2_table(244) := '78743A652E66696C746572546578742C646F63756D656E746174696F6E3A652E646F63756D656E746174696F6E2C64657461696C3A652E64657461696C2C636F6D6D616E643A286E3D652E636F6D6D616E642C6E262622656469746F722E616374696F6E';
wwv_flow_imp.g_varchar2_table(245) := '2E7472696767657253756767657374223D3D3D6E2E636F6D6D616E643F7B69643A6E2E636F6D6D616E642C7469746C653A6E2E7469746C652C617267756D656E74733A6E2E617267756D656E74737D3A766F69642030292C72616E67653A692C6B696E64';
wwv_flow_imp.g_varchar2_table(246) := '3A707428652E6B696E64297D3B766172206E2C723B72657475726E20652E7465787445646974262628766F69642030213D3D28723D652E7465787445646974292E696E736572742626766F69642030213D3D722E7265706C6163653F742E72616E67653D';
wwv_flow_imp.g_varchar2_table(247) := '7B696E736572743A667428652E74657874456469742E696E73657274292C7265706C6163653A667428652E74657874456469742E7265706C616365297D3A742E72616E67653D667428652E74657874456469742E72616E6765292C742E696E7365727454';
wwv_flow_imp.g_varchar2_table(248) := '6578743D652E74657874456469742E6E657754657874292C652E6164646974696F6E616C546578744564697473262628742E6164646974696F6E616C5465787445646974733D652E6164646974696F6E616C5465787445646974732E6D6170286D742929';
wwv_flow_imp.g_varchar2_table(249) := '2C652E696E7365727454657874466F726D61743D3D3D77652E536E6970706574262628742E696E736572745465787452756C65733D632E6C616E6775616765732E436F6D706C6574696F6E4974656D496E736572745465787452756C652E496E73657274';
wwv_flow_imp.g_varchar2_table(250) := '4173536E6970706574292C747D29293B72657475726E7B6973496E636F6D706C6574653A6E2E6973496E636F6D706C6574652C73756767657374696F6E733A6F7D7D29297D7D3B66756E6374696F6E206C742865297B696628652972657475726E7B6368';
wwv_flow_imp.g_varchar2_table(251) := '617261637465723A652E636F6C756D6E2D312C6C696E653A652E6C696E654E756D6265722D317D7D66756E6374696F6E2068742865297B696628652972657475726E7B73746172743A7B6C696E653A652E73746172744C696E654E756D6265722D312C63';
wwv_flow_imp.g_varchar2_table(252) := '68617261637465723A652E7374617274436F6C756D6E2D317D2C656E643A7B6C696E653A652E656E644C696E654E756D6265722D312C6368617261637465723A652E656E64436F6C756D6E2D317D7D7D66756E6374696F6E2066742865297B6966286529';
wwv_flow_imp.g_varchar2_table(253) := '72657475726E206E657720632E52616E676528652E73746172742E6C696E652B312C652E73746172742E6368617261637465722B312C652E656E642E6C696E652B312C652E656E642E6368617261637465722B31297D66756E6374696F6E207074286529';
wwv_flow_imp.g_varchar2_table(254) := '7B636F6E737420743D632E6C616E6775616765732E436F6D706C6574696F6E4974656D4B696E643B7377697463682865297B636173652076652E546578743A72657475726E20742E546578743B636173652076652E4D6574686F643A72657475726E2074';
wwv_flow_imp.g_varchar2_table(255) := '2E4D6574686F643B636173652076652E46756E6374696F6E3A72657475726E20742E46756E6374696F6E3B636173652076652E436F6E7374727563746F723A72657475726E20742E436F6E7374727563746F723B636173652076652E4669656C643A7265';
wwv_flow_imp.g_varchar2_table(256) := '7475726E20742E4669656C643B636173652076652E5661726961626C653A72657475726E20742E5661726961626C653B636173652076652E436C6173733A72657475726E20742E436C6173733B636173652076652E496E746572666163653A7265747572';
wwv_flow_imp.g_varchar2_table(257) := '6E20742E496E746572666163653B636173652076652E4D6F64756C653A72657475726E20742E4D6F64756C653B636173652076652E50726F70657274793A72657475726E20742E50726F70657274793B636173652076652E556E69743A72657475726E20';
wwv_flow_imp.g_varchar2_table(258) := '742E556E69743B636173652076652E56616C75653A72657475726E20742E56616C75653B636173652076652E456E756D3A72657475726E20742E456E756D3B636173652076652E4B6579776F72643A72657475726E20742E4B6579776F72643B63617365';
wwv_flow_imp.g_varchar2_table(259) := '2076652E536E69707065743A72657475726E20742E536E69707065743B636173652076652E436F6C6F723A72657475726E20742E436F6C6F723B636173652076652E46696C653A72657475726E20742E46696C653B636173652076652E5265666572656E';
wwv_flow_imp.g_varchar2_table(260) := '63653A72657475726E20742E5265666572656E63657D72657475726E20742E50726F70657274797D66756E6374696F6E206D742865297B696628652972657475726E7B72616E67653A667428652E72616E6765292C746578743A652E6E6577546578747D';
wwv_flow_imp.g_varchar2_table(261) := '7D7661722076743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465486F76657228652C742C6E297B6C657420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E74';
wwv_flow_imp.g_varchar2_table(262) := '68656E2828653D3E652E646F486F76657228722E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B696628652972657475726E7B72616E67653A667428652E72616E6765292C636F6E74656E74733A777428652E636F6E74656E';
wwv_flow_imp.g_varchar2_table(263) := '7473297D7D29297D7D3B66756E6374696F6E205F742865297B72657475726E22737472696E67223D3D747970656F6620653F7B76616C75653A657D3A28743D65292626226F626A656374223D3D747970656F662074262622737472696E67223D3D747970';
wwv_flow_imp.g_varchar2_table(264) := '656F6620742E6B696E643F22706C61696E74657874223D3D3D652E6B696E643F7B76616C75653A652E76616C75652E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D2E215D2F672C225C5C242622297D3A7B76616C75653A652E76616C';
wwv_flow_imp.g_varchar2_table(265) := '75657D3A7B76616C75653A22606060222B652E6C616E67756167652B225C6E222B652E76616C75652B225C6E6060605C6E227D3B76617220747D66756E6374696F6E2077742865297B696628652972657475726E2041727261792E697341727261792865';
wwv_flow_imp.g_varchar2_table(266) := '293F652E6D6170285F74293A5B5F742865295D7D766172206B743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E74486967686C696768747328652C742C6E297B636F6E73';
wwv_flow_imp.g_varchar2_table(267) := '7420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E66696E64446F63756D656E74486967686C696768747328722E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B69';
wwv_flow_imp.g_varchar2_table(268) := '6628652972657475726E20652E6D61702828653D3E287B72616E67653A667428652E72616E6765292C6B696E643A627428652E6B696E64297D2929297D29297D7D3B66756E6374696F6E2062742865297B7377697463682865297B63617365204D652E52';
wwv_flow_imp.g_varchar2_table(269) := '6561643A72657475726E20632E6C616E6775616765732E446F63756D656E74486967686C696768744B696E642E526561643B63617365204D652E57726974653A72657475726E20632E6C616E6775616765732E446F63756D656E74486967686C69676874';
wwv_flow_imp.g_varchar2_table(270) := '4B696E642E57726974653B63617365204D652E546578743A72657475726E20632E6C616E6775616765732E446F63756D656E74486967686C696768744B696E642E546578747D72657475726E20632E6C616E6775616765732E446F63756D656E74486967';
wwv_flow_imp.g_varchar2_table(271) := '686C696768744B696E642E546578747D7661722079743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446566696E6974696F6E28652C742C6E297B636F6E737420723D652E7572693B7265';
wwv_flow_imp.g_varchar2_table(272) := '7475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E66696E64446566696E6974696F6E28722E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B696628652972657475726E5B45742865295D7D2929';
wwv_flow_imp.g_varchar2_table(273) := '7D7D3B66756E6374696F6E2045742865297B72657475726E7B7572693A632E5572692E706172736528652E757269292C72616E67653A667428652E72616E6765297D7D7661722043743D636C6173737B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(274) := '5F776F726B65723D657D70726F766964655265666572656E63657328652C742C6E2C72297B636F6E737420693D652E7572693B72657475726E20746869732E5F776F726B65722869292E7468656E2828653D3E652E66696E645265666572656E63657328';
wwv_flow_imp.g_varchar2_table(275) := '692E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B696628652972657475726E20652E6D6170284574297D29297D7D2C78743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D7072';
wwv_flow_imp.g_varchar2_table(276) := '6F7669646552656E616D65456469747328652C742C6E2C72297B636F6E737420693D652E7572693B72657475726E20746869732E5F776F726B65722869292E7468656E2828653D3E652E646F52656E616D6528692E746F537472696E6728292C6C742874';
wwv_flow_imp.g_varchar2_table(277) := '292C6E2929292E7468656E2828653D3E66756E6374696F6E2865297B69662821657C7C21652E6368616E6765732972657475726E3B6C657420743D5B5D3B666F72286C6574206E20696E20652E6368616E676573297B636F6E737420723D632E5572692E';
wwv_flow_imp.g_varchar2_table(278) := '7061727365286E293B666F72286C65742069206F6620652E6368616E6765735B6E5D29742E70757368287B7265736F757263653A722C76657273696F6E49643A766F696420302C74657874456469743A7B72616E67653A667428692E72616E6765292C74';
wwv_flow_imp.g_varchar2_table(279) := '6578743A692E6E6577546578747D7D297D72657475726E7B65646974733A747D7D28652929297D7D2C49743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E7453796D626F';
wwv_flow_imp.g_varchar2_table(280) := '6C7328652C74297B636F6E7374206E3D652E7572693B72657475726E20746869732E5F776F726B6572286E292E7468656E2828653D3E652E66696E64446F63756D656E7453796D626F6C73286E2E746F537472696E6728292929292E7468656E2828653D';
wwv_flow_imp.g_varchar2_table(281) := '3E7B696628652972657475726E20652E6D61702828653D3E226368696C6472656E22696E20653F41742865293A7B6E616D653A652E6E616D652C64657461696C3A22222C636F6E7461696E65724E616D653A652E636F6E7461696E65724E616D652C6B69';
wwv_flow_imp.g_varchar2_table(282) := '6E643A537428652E6B696E64292C72616E67653A667428652E6C6F636174696F6E2E72616E6765292C73656C656374696F6E52616E67653A667428652E6C6F636174696F6E2E72616E6765292C746167733A5B5D7D29297D29297D7D3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(283) := '6E2041742865297B72657475726E7B6E616D653A652E6E616D652C64657461696C3A652E64657461696C3F3F22222C6B696E643A537428652E6B696E64292C72616E67653A667428652E72616E6765292C73656C656374696F6E52616E67653A66742865';
wwv_flow_imp.g_varchar2_table(284) := '2E73656C656374696F6E52616E6765292C746167733A652E746167733F3F5B5D2C6368696C6472656E3A28652E6368696C6472656E3F3F5B5D292E6D61702828653D3E417428652929297D7D66756E6374696F6E2053742865297B6C657420743D632E6C';
wwv_flow_imp.g_varchar2_table(285) := '616E6775616765732E53796D626F6C4B696E643B7377697463682865297B63617365206A652E46696C653A72657475726E20742E46696C653B63617365206A652E4D6F64756C653A72657475726E20742E4D6F64756C653B63617365206A652E4E616D65';
wwv_flow_imp.g_varchar2_table(286) := '73706163653A72657475726E20742E4E616D6573706163653B63617365206A652E5061636B6167653A72657475726E20742E5061636B6167653B63617365206A652E436C6173733A72657475726E20742E436C6173733B63617365206A652E4D6574686F';
wwv_flow_imp.g_varchar2_table(287) := '643A72657475726E20742E4D6574686F643B63617365206A652E50726F70657274793A72657475726E20742E50726F70657274793B63617365206A652E4669656C643A72657475726E20742E4669656C643B63617365206A652E436F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(288) := '723A72657475726E20742E436F6E7374727563746F723B63617365206A652E456E756D3A72657475726E20742E456E756D3B63617365206A652E496E746572666163653A72657475726E20742E496E746572666163653B63617365206A652E46756E6374';
wwv_flow_imp.g_varchar2_table(289) := '696F6E3A72657475726E20742E46756E6374696F6E3B63617365206A652E5661726961626C653A72657475726E20742E5661726961626C653B63617365206A652E436F6E7374616E743A72657475726E20742E436F6E7374616E743B63617365206A652E';
wwv_flow_imp.g_varchar2_table(290) := '537472696E673A72657475726E20742E537472696E673B63617365206A652E4E756D6265723A72657475726E20742E4E756D6265723B63617365206A652E426F6F6C65616E3A72657475726E20742E426F6F6C65616E3B63617365206A652E4172726179';
wwv_flow_imp.g_varchar2_table(291) := '3A72657475726E20742E41727261797D72657475726E20742E46756E6374696F6E7D7661722052743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F766964654C696E6B7328652C74297B636F6E7374';
wwv_flow_imp.g_varchar2_table(292) := '206E3D652E7572693B72657475726E20746869732E5F776F726B6572286E292E7468656E2828653D3E652E66696E64446F63756D656E744C696E6B73286E2E746F537472696E6728292929292E7468656E2828653D3E7B696628652972657475726E7B6C';
wwv_flow_imp.g_varchar2_table(293) := '696E6B733A652E6D61702828653D3E287B72616E67653A667428652E72616E6765292C75726C3A652E7461726765747D2929297D7D29297D7D2C54743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F';
wwv_flow_imp.g_varchar2_table(294) := '76696465446F63756D656E74466F726D617474696E67456469747328652C742C6E297B636F6E737420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E666F726D617428722E746F537472696E67';
wwv_flow_imp.g_varchar2_table(295) := '28292C6E756C6C2C5074287429292E7468656E2828653D3E7B69662865262630213D3D652E6C656E6774682972657475726E20652E6D6170286D74297D292929297D7D2C44743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F';
wwv_flow_imp.g_varchar2_table(296) := '726B65723D652C746869732E63616E466F726D61744D756C7469706C6552616E6765733D21317D70726F76696465446F63756D656E7452616E6765466F726D617474696E67456469747328652C742C6E2C72297B636F6E737420693D652E7572693B7265';
wwv_flow_imp.g_varchar2_table(297) := '7475726E20746869732E5F776F726B65722869292E7468656E2828653D3E652E666F726D617428692E746F537472696E6728292C68742874292C5074286E29292E7468656E2828653D3E7B69662865262630213D3D652E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(298) := '20652E6D6170286D74297D292929297D7D3B66756E6374696F6E2050742865297B72657475726E7B74616253697A653A652E74616253697A652C696E736572745370616365733A652E696E736572745370616365737D7D766172204D743D636C6173737B';
wwv_flow_imp.g_varchar2_table(299) := '636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E74436F6C6F727328652C74297B636F6E7374206E3D652E7572693B72657475726E20746869732E5F776F726B6572286E292E7468656E2828';
wwv_flow_imp.g_varchar2_table(300) := '653D3E652E66696E64446F63756D656E74436F6C6F7273286E2E746F537472696E6728292929292E7468656E2828653D3E7B696628652972657475726E20652E6D61702828653D3E287B636F6C6F723A652E636F6C6F722C72616E67653A667428652E72';
wwv_flow_imp.g_varchar2_table(301) := '616E6765297D2929297D29297D70726F76696465436F6C6F7250726573656E746174696F6E7328652C742C6E297B636F6E737420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E676574436F6C';
wwv_flow_imp.g_varchar2_table(302) := '6F7250726573656E746174696F6E7328722E746F537472696E6728292C742E636F6C6F722C687428742E72616E6765292929292E7468656E2828653D3E7B696628652972657475726E20652E6D61702828653D3E7B6C657420743D7B6C6162656C3A652E';
wwv_flow_imp.g_varchar2_table(303) := '6C6162656C7D3B72657475726E20652E7465787445646974262628742E74657874456469743D6D7428652E746578744564697429292C652E6164646974696F6E616C546578744564697473262628742E6164646974696F6E616C5465787445646974733D';
wwv_flow_imp.g_varchar2_table(304) := '652E6164646974696F6E616C5465787445646974732E6D6170286D7429292C747D29297D29297D7D2C46743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465466F6C64696E6752616E676573';
wwv_flow_imp.g_varchar2_table(305) := '28652C742C6E297B636F6E737420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E676574466F6C64696E6752616E67657328722E746F537472696E6728292C742929292E7468656E2828653D3E';
wwv_flow_imp.g_varchar2_table(306) := '7B696628652972657475726E20652E6D61702828653D3E7B636F6E737420743D7B73746172743A652E73746172744C696E652B312C656E643A652E656E644C696E652B317D3B72657475726E20766F69642030213D3D652E6B696E64262628742E6B696E';
wwv_flow_imp.g_varchar2_table(307) := '643D66756E6374696F6E2865297B7377697463682865297B6361736520532E436F6D6D656E743A72657475726E20632E6C616E6775616765732E466F6C64696E6752616E67654B696E642E436F6D6D656E743B6361736520532E496D706F7274733A7265';
wwv_flow_imp.g_varchar2_table(308) := '7475726E20632E6C616E6775616765732E466F6C64696E6752616E67654B696E642E496D706F7274733B6361736520532E526567696F6E3A72657475726E20632E6C616E6775616765732E466F6C64696E6752616E67654B696E642E526567696F6E7D7D';
wwv_flow_imp.g_varchar2_table(309) := '28652E6B696E6429292C747D29297D29297D7D2C4C743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F7669646553656C656374696F6E52616E67657328652C742C6E297B636F6E737420723D652E75';
wwv_flow_imp.g_varchar2_table(310) := '72693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E67657453656C656374696F6E52616E67657328722E746F537472696E6728292C742E6D6170286C74292929292E7468656E2828653D3E7B6966286529726574';
wwv_flow_imp.g_varchar2_table(311) := '75726E20652E6D61702828653D3E7B636F6E737420743D5B5D3B666F72283B653B29742E70757368287B72616E67653A667428652E72616E6765297D292C653D652E706172656E743B72657475726E20747D29297D29297D7D2C6A743D636C6173732065';
wwv_flow_imp.g_varchar2_table(312) := '7874656E64732067747B636F6E7374727563746F722865297B737570657228652C5B222E222C223A222C223C222C2722272C223D222C222F225D297D7D3B66756E6374696F6E204F742865297B636F6E737420743D6E6577206F652865292C6E3D282E2E';
wwv_flow_imp.g_varchar2_table(313) := '2E65293D3E742E6765744C616E677561676553657276696365576F726B6572282E2E2E65293B6C657420723D652E6C616E677561676549643B632E6C616E6775616765732E7265676973746572436F6D706C6574696F6E4974656D50726F766964657228';
wwv_flow_imp.g_varchar2_table(314) := '722C6E6577206A74286E29292C632E6C616E6775616765732E7265676973746572486F76657250726F766964657228722C6E6577207674286E29292C632E6C616E6775616765732E7265676973746572446F63756D656E74486967686C6967687450726F';
wwv_flow_imp.g_varchar2_table(315) := '766964657228722C6E6577206B74286E29292C632E6C616E6775616765732E72656769737465724C696E6B50726F766964657228722C6E6577205274286E29292C632E6C616E6775616765732E7265676973746572466F6C64696E6752616E676550726F';
wwv_flow_imp.g_varchar2_table(316) := '766964657228722C6E6577204674286E29292C632E6C616E6775616765732E7265676973746572446F63756D656E7453796D626F6C50726F766964657228722C6E6577204974286E29292C632E6C616E6775616765732E726567697374657253656C6563';
wwv_flow_imp.g_varchar2_table(317) := '74696F6E52616E676550726F766964657228722C6E6577204C74286E29292C632E6C616E6775616765732E726567697374657252656E616D6550726F766964657228722C6E6577207874286E29292C2268746D6C223D3D3D72262628632E6C616E677561';
wwv_flow_imp.g_varchar2_table(318) := '6765732E7265676973746572446F63756D656E74466F726D617474696E674564697450726F766964657228722C6E6577205474286E29292C632E6C616E6775616765732E7265676973746572446F63756D656E7452616E6765466F726D617474696E6745';
wwv_flow_imp.g_varchar2_table(319) := '64697450726F766964657228722C6E6577204474286E2929297D66756E6374696F6E204E742865297B636F6E737420743D5B5D2C6E3D5B5D2C723D6E6577206F652865293B742E707573682872293B636F6E737420693D282E2E2E65293D3E722E676574';
wwv_flow_imp.g_varchar2_table(320) := '4C616E677561676553657276696365576F726B6572282E2E2E65293B72657475726E2066756E6374696F6E28297B636F6E73747B6C616E677561676549643A742C6D6F6465436F6E66696775726174696F6E3A727D3D653B5774286E292C722E636F6D70';
wwv_flow_imp.g_varchar2_table(321) := '6C6574696F6E4974656D7326266E2E7075736828632E6C616E6775616765732E7265676973746572436F6D706C6574696F6E4974656D50726F766964657228742C6E6577206A7428692929292C722E686F7665727326266E2E7075736828632E6C616E67';
wwv_flow_imp.g_varchar2_table(322) := '75616765732E7265676973746572486F76657250726F766964657228742C6E657720767428692929292C722E646F63756D656E74486967686C696768747326266E2E7075736828632E6C616E6775616765732E7265676973746572446F63756D656E7448';
wwv_flow_imp.g_varchar2_table(323) := '6967686C6967687450726F766964657228742C6E6577206B7428692929292C722E6C696E6B7326266E2E7075736828632E6C616E6775616765732E72656769737465724C696E6B50726F766964657228742C6E657720527428692929292C722E646F6375';
wwv_flow_imp.g_varchar2_table(324) := '6D656E7453796D626F6C7326266E2E7075736828632E6C616E6775616765732E7265676973746572446F63756D656E7453796D626F6C50726F766964657228742C6E657720497428692929292C722E72656E616D6526266E2E7075736828632E6C616E67';
wwv_flow_imp.g_varchar2_table(325) := '75616765732E726567697374657252656E616D6550726F766964657228742C6E657720787428692929292C722E666F6C64696E6752616E67657326266E2E7075736828632E6C616E6775616765732E7265676973746572466F6C64696E6752616E676550';
wwv_flow_imp.g_varchar2_table(326) := '726F766964657228742C6E657720467428692929292C722E73656C656374696F6E52616E67657326266E2E7075736828632E6C616E6775616765732E726567697374657253656C656374696F6E52616E676550726F766964657228742C6E6577204C7428';
wwv_flow_imp.g_varchar2_table(327) := '692929292C722E646F63756D656E74466F726D617474696E67456469747326266E2E7075736828632E6C616E6775616765732E7265676973746572446F63756D656E74466F726D617474696E674564697450726F766964657228742C6E65772054742869';
wwv_flow_imp.g_varchar2_table(328) := '2929292C722E646F63756D656E7452616E6765466F726D617474696E67456469747326266E2E7075736828632E6C616E6775616765732E7265676973746572446F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722874';
wwv_flow_imp.g_varchar2_table(329) := '2C6E657720447428692929297D28292C742E70757368285574286E29292C55742874297D66756E6374696F6E2055742865297B72657475726E7B646973706F73653A28293D3E57742865297D7D66756E6374696F6E2057742865297B666F72283B652E6C';
wwv_flow_imp.g_varchar2_table(330) := '656E6774683B29652E706F7028292E646973706F736528297D7D7D5D293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5448086297531698)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/77.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C6561736520736565203635382E6D696E2E6A732E4C4943454E53452E747874202A2F0A2275736520737472696374223B2873656C662E7765627061636B4368756E6B62706D6E';
wwv_flow_imp.g_varchar2_table(2) := '4D6F64656C65723D73656C662E7765627061636B4368756E6B62706D6E4D6F64656C65727C7C5B5D292E70757368285B5B3635385D2C7B323635383A28652C742C6E293D3E7B6E2E722874292C6E2E6428742C7B636F6E663A28293D3E6C2C6C616E6775';
wwv_flow_imp.g_varchar2_table(3) := '6167653A28293D3E637D293B76617220723D6E2839353230292C693D4F626A6563742E646566696E6550726F70657274792C6F3D4F626A6563742E6765744F776E50726F706572747944657363726970746F722C733D4F626A6563742E6765744F776E50';
wwv_flow_imp.g_varchar2_table(4) := '726F70657274794E616D65732C613D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C643D28652C742C6E2C72293D3E7B696628742626226F626A656374223D3D747970656F6620747C7C2266756E6374696F6E223D3D74';
wwv_flow_imp.g_varchar2_table(5) := '7970656F66207429666F72286C65742064206F66207328742929612E63616C6C28652C64297C7C643D3D3D6E7C7C6928652C642C7B6765743A28293D3E745B645D2C656E756D657261626C653A2128723D6F28742C6429297C7C722E656E756D65726162';
wwv_flow_imp.g_varchar2_table(6) := '6C657D293B72657475726E20657D2C703D7B7D3B6428702C722C2264656661756C7422293B766172206D3D5B2261726561222C2262617365222C226272222C22636F6C222C22656D626564222C226872222C22696D67222C22696E707574222C226B6579';
wwv_flow_imp.g_varchar2_table(7) := '67656E222C226C696E6B222C226D656E756974656D222C226D657461222C22706172616D222C22736F75726365222C22747261636B222C22776272225D2C6C3D7B776F72645061747465726E3A2F282D3F5C642A5C2E5C645C772A297C285B5E5C605C7E';
wwv_flow_imp.g_varchar2_table(8) := '5C215C405C245C5E5C265C2A5C285C295C3D5C2B5C5B5C7B5C5D5C7D5C5C5C7C5C3B5C3A5C275C225C2C5C2E5C3C5C3E5C2F5C735D2B292F672C636F6D6D656E74733A7B626C6F636B436F6D6D656E743A5B225C783363212D2D222C222D2D5C78336522';
wwv_flow_imp.g_varchar2_table(9) := '5D7D2C627261636B6574733A5B5B225C783363212D2D222C222D2D5C783365225D2C5B223C222C223E225D2C5B227B222C227D225D2C5B2228222C2229225D5D2C6175746F436C6F73696E6750616972733A5B7B6F70656E3A227B222C636C6F73653A22';
wwv_flow_imp.g_varchar2_table(10) := '7D227D2C7B6F70656E3A225B222C636C6F73653A225D227D2C7B6F70656E3A2228222C636C6F73653A2229227D2C7B6F70656E3A2722272C636C6F73653A2722277D2C7B6F70656E3A2227222C636C6F73653A2227227D5D2C737572726F756E64696E67';
wwv_flow_imp.g_varchar2_table(11) := '50616972733A5B7B6F70656E3A2722272C636C6F73653A2722277D2C7B6F70656E3A2227222C636C6F73653A2227227D2C7B6F70656E3A227B222C636C6F73653A227D227D2C7B6F70656E3A225B222C636C6F73653A225D227D2C7B6F70656E3A222822';
wwv_flow_imp.g_varchar2_table(12) := '2C636C6F73653A2229227D2C7B6F70656E3A223C222C636C6F73653A223E227D5D2C6F6E456E74657252756C65733A5B7B6265666F7265546578743A6E65772052656745787028603C283F21283F3A247B6D2E6A6F696E28227C22297D2929285B5F3A5C';
wwv_flow_imp.g_varchar2_table(13) := '5C775D5B5F3A5C5C772D2E5C5C645D2A29285B5E2F3E5D2A283F212F293E295B5E3C5D2A24602C226922292C6166746572546578743A2F5E3C5C2F285B5F3A5C775D5B5F3A5C772D2E5C645D2A295C732A3E242F692C616374696F6E3A7B696E64656E74';
wwv_flow_imp.g_varchar2_table(14) := '416374696F6E3A702E6C616E6775616765732E496E64656E74416374696F6E2E496E64656E744F757464656E747D7D2C7B6265666F7265546578743A6E65772052656745787028603C283F21283F3A247B6D2E6A6F696E28227C22297D2929285C5C775B';
wwv_flow_imp.g_varchar2_table(15) := '5C5C775C5C645D2A29285B5E2F3E5D2A283F212F293E295B5E3C5D2A24602C226922292C616374696F6E3A7B696E64656E74416374696F6E3A702E6C616E6775616765732E496E64656E74416374696F6E2E496E64656E747D7D5D2C666F6C64696E673A';
wwv_flow_imp.g_varchar2_table(16) := '7B6D61726B6572733A7B73746172743A6E65772052656745787028225E5C5C732A5C783363212D2D5C5C732A23726567696F6E5C5C622E2A2D2D5C78336522292C656E643A6E65772052656745787028225E5C5C732A5C783363212D2D5C5C732A23656E';
wwv_flow_imp.g_varchar2_table(17) := '64726567696F6E5C5C622E2A2D2D5C78336522297D7D7D2C633D7B64656661756C74546F6B656E3A22222C746F6B656E506F73746669783A222E68746D6C222C69676E6F7265436173653A21302C746F6B656E697A65723A7B726F6F743A5B5B2F3C2144';
wwv_flow_imp.g_varchar2_table(18) := '4F43545950452F2C226D657461746167222C2240646F6374797065225D2C5B2F3C212D2D2F2C22636F6D6D656E74222C2240636F6D6D656E74225D2C5B2F283C2928283F3A5B5C775C2D5D2B3A293F5B5C775C2D5D2B29285C732A29285C2F3E292F2C5B';
wwv_flow_imp.g_varchar2_table(19) := '2264656C696D69746572222C22746167222C22222C2264656C696D69746572225D5D2C5B2F283C2928736372697074292F2C5B2264656C696D69746572222C7B746F6B656E3A22746167222C6E6578743A2240736372697074227D5D5D2C5B2F283C2928';
wwv_flow_imp.g_varchar2_table(20) := '7374796C65292F2C5B2264656C696D69746572222C7B746F6B656E3A22746167222C6E6578743A22407374796C65227D5D5D2C5B2F283C2928283F3A5B5C775C2D5D2B3A293F5B5C775C2D5D2B292F2C5B2264656C696D69746572222C7B746F6B656E3A';
wwv_flow_imp.g_varchar2_table(21) := '22746167222C6E6578743A22406F74686572546167227D5D5D2C5B2F283C5C2F2928283F3A5B5C775C2D5D2B3A293F5B5C775C2D5D2B292F2C5B2264656C696D69746572222C7B746F6B656E3A22746167222C6E6578743A22406F74686572546167227D';
wwv_flow_imp.g_varchar2_table(22) := '5D5D2C5B2F3C2F2C2264656C696D69746572225D2C5B2F5B5E3C5D2B2F5D5D2C646F63747970653A5B5B2F5B5E3E5D2B2F2C226D6574617461672E636F6E74656E74225D2C5B2F3E2F2C226D657461746167222C2240706F70225D5D2C636F6D6D656E74';
wwv_flow_imp.g_varchar2_table(23) := '3A5B5B2F2D2D3E2F2C22636F6D6D656E74222C2240706F70225D2C5B2F5B5E2D5D2B2F2C22636F6D6D656E742E636F6E74656E74225D2C5B2F2E2F2C22636F6D6D656E742E636F6E74656E74225D5D2C6F746865725461673A5B5B2F5C2F3F3E2F2C2264';
wwv_flow_imp.g_varchar2_table(24) := '656C696D69746572222C2240706F70225D2C5B2F22285B5E225D2A29222F2C226174747269627574652E76616C7565225D2C5B2F27285B5E275D2A29272F2C226174747269627574652E76616C7565225D2C5B2F5B5C775C2D5D2B2F2C22617474726962';
wwv_flow_imp.g_varchar2_table(25) := '7574652E6E616D65225D2C5B2F3D2F2C2264656C696D69746572225D2C5B2F5B205C745C725C6E5D2B2F5D5D2C7363726970743A5B5B2F747970652F2C226174747269627574652E6E616D65222C2240736372697074416674657254797065225D2C5B2F';
wwv_flow_imp.g_varchar2_table(26) := '22285B5E225D2A29222F2C226174747269627574652E76616C7565225D2C5B2F27285B5E275D2A29272F2C226174747269627574652E76616C7565225D2C5B2F5B5C775C2D5D2B2F2C226174747269627574652E6E616D65225D2C5B2F3D2F2C2264656C';
wwv_flow_imp.g_varchar2_table(27) := '696D69746572225D2C5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A2240736372697074456D626564646564222C6E657874456D6265646465643A22746578742F6A617661736372697074227D5D2C5B2F5B205C745C725C6E5D';
wwv_flow_imp.g_varchar2_table(28) := '2B2F5D2C5B2F283C5C2F29287363726970745C732A29283E292F2C5B2264656C696D69746572222C22746167222C7B746F6B656E3A2264656C696D69746572222C6E6578743A2240706F70227D5D5D5D2C7363726970744166746572547970653A5B5B2F';
wwv_flow_imp.g_varchar2_table(29) := '3D2F2C2264656C696D69746572222C2240736372697074416674657254797065457175616C73225D2C5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A2240736372697074456D626564646564222C6E657874456D626564646564';
wwv_flow_imp.g_varchar2_table(30) := '3A22746578742F6A617661736372697074227D5D2C5B2F5B205C745C725C6E5D2B2F5D2C5B2F3C5C2F7363726970745C732A3E2F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70227D5D5D2C7363726970744166746572547970';
wwv_flow_imp.g_varchar2_table(31) := '65457175616C733A5B5B2F226D6F64756C65222F2C7B746F6B656E3A226174747269627574652E76616C7565222C737769746368546F3A224073637269707457697468437573746F6D547970652E746578742F6A617661736372697074227D5D2C5B2F27';
wwv_flow_imp.g_varchar2_table(32) := '6D6F64756C65272F2C7B746F6B656E3A226174747269627574652E76616C7565222C737769746368546F3A224073637269707457697468437573746F6D547970652E746578742F6A617661736372697074227D5D2C5B2F22285B5E225D2A29222F2C7B74';
wwv_flow_imp.g_varchar2_table(33) := '6F6B656E3A226174747269627574652E76616C7565222C737769746368546F3A224073637269707457697468437573746F6D547970652E2431227D5D2C5B2F27285B5E275D2A29272F2C7B746F6B656E3A226174747269627574652E76616C7565222C73';
wwv_flow_imp.g_varchar2_table(34) := '7769746368546F3A224073637269707457697468437573746F6D547970652E2431227D5D2C5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A2240736372697074456D626564646564222C6E657874456D6265646465643A227465';
wwv_flow_imp.g_varchar2_table(35) := '78742F6A617661736372697074227D5D2C5B2F5B205C745C725C6E5D2B2F5D2C5B2F3C5C2F7363726970745C732A3E2F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70227D5D5D2C73637269707457697468437573746F6D5479';
wwv_flow_imp.g_varchar2_table(36) := '70653A5B5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A2240736372697074456D6265646465642E245332222C6E657874456D6265646465643A22245332227D5D2C5B2F22285B5E225D2A29222F2C226174747269627574652E';
wwv_flow_imp.g_varchar2_table(37) := '76616C7565225D2C5B2F27285B5E275D2A29272F2C226174747269627574652E76616C7565225D2C5B2F5B5C775C2D5D2B2F2C226174747269627574652E6E616D65225D2C5B2F3D2F2C2264656C696D69746572225D2C5B2F5B205C745C725C6E5D2B2F';
wwv_flow_imp.g_varchar2_table(38) := '5D2C5B2F3C5C2F7363726970745C732A3E2F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70227D5D5D2C736372697074456D6265646465643A5B5B2F3C5C2F7363726970742F2C7B746F6B656E3A224072656D61746368222C6E';
wwv_flow_imp.g_varchar2_table(39) := '6578743A2240706F70222C6E657874456D6265646465643A2240706F70227D5D2C5B2F5B5E3C5D2B2F2C22225D5D2C7374796C653A5B5B2F747970652F2C226174747269627574652E6E616D65222C22407374796C65416674657254797065225D2C5B2F';
wwv_flow_imp.g_varchar2_table(40) := '22285B5E225D2A29222F2C226174747269627574652E76616C7565225D2C5B2F27285B5E275D2A29272F2C226174747269627574652E76616C7565225D2C5B2F5B5C775C2D5D2B2F2C226174747269627574652E6E616D65225D2C5B2F3D2F2C2264656C';
wwv_flow_imp.g_varchar2_table(41) := '696D69746572225D2C5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A22407374796C65456D626564646564222C6E657874456D6265646465643A22746578742F637373227D5D2C5B2F5B205C745C725C6E5D2B2F5D2C5B2F283C';
wwv_flow_imp.g_varchar2_table(42) := '5C2F29287374796C655C732A29283E292F2C5B2264656C696D69746572222C22746167222C7B746F6B656E3A2264656C696D69746572222C6E6578743A2240706F70227D5D5D5D2C7374796C654166746572547970653A5B5B2F3D2F2C2264656C696D69';
wwv_flow_imp.g_varchar2_table(43) := '746572222C22407374796C65416674657254797065457175616C73225D2C5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A22407374796C65456D626564646564222C6E657874456D6265646465643A22746578742F637373227D';
wwv_flow_imp.g_varchar2_table(44) := '5D2C5B2F5B205C745C725C6E5D2B2F5D2C5B2F3C5C2F7374796C655C732A3E2F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70227D5D5D2C7374796C65416674657254797065457175616C733A5B5B2F22285B5E225D2A29222F';
wwv_flow_imp.g_varchar2_table(45) := '2C7B746F6B656E3A226174747269627574652E76616C7565222C737769746368546F3A22407374796C6557697468437573746F6D547970652E2431227D5D2C5B2F27285B5E275D2A29272F2C7B746F6B656E3A226174747269627574652E76616C756522';
wwv_flow_imp.g_varchar2_table(46) := '2C737769746368546F3A22407374796C6557697468437573746F6D547970652E2431227D5D2C5B2F3E2F2C7B746F6B656E3A2264656C696D69746572222C6E6578743A22407374796C65456D626564646564222C6E657874456D6265646465643A227465';
wwv_flow_imp.g_varchar2_table(47) := '78742F637373227D5D2C5B2F5B205C745C725C6E5D2B2F5D2C5B2F3C5C2F7374796C655C732A3E2F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70227D5D5D2C7374796C6557697468437573746F6D547970653A5B5B2F3E2F2C';
wwv_flow_imp.g_varchar2_table(48) := '7B746F6B656E3A2264656C696D69746572222C6E6578743A22407374796C65456D6265646465642E245332222C6E657874456D6265646465643A22245332227D5D2C5B2F22285B5E225D2A29222F2C226174747269627574652E76616C7565225D2C5B2F';
wwv_flow_imp.g_varchar2_table(49) := '27285B5E275D2A29272F2C226174747269627574652E76616C7565225D2C5B2F5B5C775C2D5D2B2F2C226174747269627574652E6E616D65225D2C5B2F3D2F2C2264656C696D69746572225D2C5B2F5B205C745C725C6E5D2B2F5D2C5B2F3C5C2F737479';
wwv_flow_imp.g_varchar2_table(50) := '6C655C732A3E2F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70227D5D5D2C7374796C65456D6265646465643A5B5B2F3C5C2F7374796C652F2C7B746F6B656E3A224072656D61746368222C6E6578743A2240706F70222C6E65';
wwv_flow_imp.g_varchar2_table(51) := '7874456D6265646465643A2240706F70227D5D2C5B2F5B5E3C5D2B2F2C22225D5D7D7D7D7D5D293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5448422765531699)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/658.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C6561736520736565203833392E6D696E2E6A732E4C4943454E53452E747874202A2F0A2275736520737472696374223B2873656C662E7765627061636B4368756E6B62706D6E';
wwv_flow_imp.g_varchar2_table(2) := '4D6F64656C65723D73656C662E7765627061636B4368756E6B62706D6E4D6F64656C65727C7C5B5D292E70757368285B5B3833395D2C7B343833393A28652C742C6E293D3E7B6E2E722874292C6E2E6428742C7B436F6D706C6574696F6E416461707465';
wwv_flow_imp.g_varchar2_table(3) := '723A28293D3E67742C446566696E6974696F6E416461707465723A28293D3E43742C446961676E6F7374696373416461707465723A28293D3E75742C446F63756D656E74436F6C6F72416461707465723A28293D3E6A742C446F63756D656E74466F726D';
wwv_flow_imp.g_varchar2_table(4) := '617474696E674564697450726F76696465723A28293D3E52742C446F63756D656E74486967686C69676874416461707465723A28293D3E5F742C446F63756D656E744C696E6B416461707465723A28293D3E54742C446F63756D656E7452616E6765466F';
wwv_flow_imp.g_varchar2_table(5) := '726D617474696E674564697450726F76696465723A28293D3E44742C446F63756D656E7453796D626F6C416461707465723A28293D3E78742C466F6C64696E6752616E6765416461707465723A28293D3E4C742C486F766572416461707465723A28293D';
wwv_flow_imp.g_varchar2_table(6) := '3E76742C5265666572656E6365416461707465723A28293D3E45742C52656E616D65416461707465723A28293D3E41742C53656C656374696F6E52616E6765416461707465723A28293D3E46742C576F726B65724D616E616765723A28293D3E6F652C66';
wwv_flow_imp.g_varchar2_table(7) := '726F6D506F736974696F6E3A28293D3E6C742C66726F6D52616E67653A28293D3E68742C676574576F726B65723A28293D3E746E2C73657475704D6F64653A28293D3E726E2C746F52616E67653A28293D3E66742C746F54657874456469743A28293D3E';
wwv_flow_imp.g_varchar2_table(8) := '6D747D293B76617220723D6E2839353230292C693D4F626A6563742E646566696E6550726F70657274792C6F3D4F626A6563742E6765744F776E50726F706572747944657363726970746F722C613D4F626A6563742E6765744F776E50726F7065727479';
wwv_flow_imp.g_varchar2_table(9) := '4E616D65732C733D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C633D28652C742C6E2C72293D3E7B696628742626226F626A656374223D3D747970656F6620747C7C2266756E6374696F6E223D3D747970656F662074';
wwv_flow_imp.g_varchar2_table(10) := '29666F72286C65742063206F66206128742929732E63616C6C28652C63297C7C633D3D3D6E7C7C6928652C632C7B6765743A28293D3E745B635D2C656E756D657261626C653A2128723D6F28742C6329297C7C722E656E756D657261626C657D293B7265';
wwv_flow_imp.g_varchar2_table(11) := '7475726E20657D2C753D7B7D3B6328752C722C2264656661756C7422293B76617220642C672C6C2C682C662C702C6D2C762C6B2C622C5F2C772C432C792C452C412C782C492C532C542C522C442C4D2C502C6A2C4C2C462C4F2C4E2C572C552C562C482C';
wwv_flow_imp.g_varchar2_table(12) := '4B2C7A2C712C582C422C242C4A2C512C472C592C5A2C65652C74652C6E652C72652C69652C6F653D636C6173737B636F6E7374727563746F722865297B746869732E5F64656661756C74733D652C746869732E5F776F726B65723D6E756C6C2C74686973';
wwv_flow_imp.g_varchar2_table(13) := '2E5F636C69656E743D6E756C6C2C746869732E5F69646C65436865636B496E74657276616C3D77696E646F772E736574496E74657276616C282828293D3E746869732E5F636865636B496649646C652829292C336534292C746869732E5F6C6173745573';
wwv_flow_imp.g_varchar2_table(14) := '656454696D653D302C746869732E5F636F6E6669674368616E67654C697374656E65723D746869732E5F64656661756C74732E6F6E4469644368616E6765282828293D3E746869732E5F73746F70576F726B6572282929297D5F73746F70576F726B6572';
wwv_flow_imp.g_varchar2_table(15) := '28297B746869732E5F776F726B6572262628746869732E5F776F726B65722E646973706F736528292C746869732E5F776F726B65723D6E756C6C292C746869732E5F636C69656E743D6E756C6C7D646973706F736528297B636C656172496E7465727661';
wwv_flow_imp.g_varchar2_table(16) := '6C28746869732E5F69646C65436865636B496E74657276616C292C746869732E5F636F6E6669674368616E67654C697374656E65722E646973706F736528292C746869732E5F73746F70576F726B657228297D5F636865636B496649646C6528297B7468';
wwv_flow_imp.g_varchar2_table(17) := '69732E5F776F726B65722626446174652E6E6F7728292D746869732E5F6C6173745573656454696D653E313265342626746869732E5F73746F70576F726B657228297D5F676574436C69656E7428297B72657475726E20746869732E5F6C617374557365';
wwv_flow_imp.g_varchar2_table(18) := '6454696D653D446174652E6E6F7728292C746869732E5F636C69656E747C7C28746869732E5F776F726B65723D752E656469746F722E637265617465576562576F726B6572287B6D6F64756C6549643A2276732F6C616E67756167652F6A736F6E2F6A73';
wwv_flow_imp.g_varchar2_table(19) := '6F6E576F726B6572222C6C6162656C3A746869732E5F64656661756C74732E6C616E677561676549642C637265617465446174613A7B6C616E677561676553657474696E67733A746869732E5F64656661756C74732E646961676E6F73746963734F7074';
wwv_flow_imp.g_varchar2_table(20) := '696F6E732C6C616E677561676549643A746869732E5F64656661756C74732E6C616E677561676549642C656E61626C65536368656D61526571756573743A746869732E5F64656661756C74732E646961676E6F73746963734F7074696F6E732E656E6162';
wwv_flow_imp.g_varchar2_table(21) := '6C65536368656D61526571756573747D7D292C746869732E5F636C69656E743D746869732E5F776F726B65722E67657450726F78792829292C746869732E5F636C69656E747D6765744C616E677561676553657276696365576F726B6572282E2E2E6529';
wwv_flow_imp.g_varchar2_table(22) := '7B6C657420743B72657475726E20746869732E5F676574436C69656E7428292E7468656E2828653D3E7B743D657D29292E7468656E2828743D3E7B696628746869732E5F776F726B65722972657475726E20746869732E5F776F726B65722E7769746853';
wwv_flow_imp.g_varchar2_table(23) := '796E6365645265736F75726365732865297D29292E7468656E2828653D3E7429297D7D3B28673D647C7C28643D7B7D29292E4D494E5F56414C55453D2D323134373438333634382C672E4D41585F56414C55453D323134373438333634372C28683D6C7C';
wwv_flow_imp.g_varchar2_table(24) := '7C286C3D7B7D29292E4D494E5F56414C55453D302C682E4D41585F56414C55453D323134373438333634372C28703D667C7C28663D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E20653D3D3D4E756D6265722E4D4158';
wwv_flow_imp.g_varchar2_table(25) := '5F56414C5545262628653D6C2E4D41585F56414C5545292C743D3D3D4E756D6265722E4D41585F56414C5545262628743D6C2E4D41585F56414C5545292C7B6C696E653A652C6368617261637465723A747D7D2C702E69733D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(26) := '7B76617220743D653B72657475726E206F742E6F626A6563744C69746572616C28742926266F742E75696E746567657228742E6C696E652926266F742E75696E746567657228742E636861726163746572297D2C28763D6D7C7C286D3D7B7D29292E6372';
wwv_flow_imp.g_varchar2_table(27) := '656174653D66756E6374696F6E28652C742C6E2C72297B6966286F742E75696E746567657228652926266F742E75696E746567657228742926266F742E75696E7465676572286E2926266F742E75696E74656765722872292972657475726E7B73746172';
wwv_flow_imp.g_varchar2_table(28) := '743A662E63726561746528652C74292C656E643A662E637265617465286E2C72297D3B696628662E69732865292626662E69732874292972657475726E7B73746172743A652C656E643A747D3B7468726F77206E6577204572726F72282252616E676523';
wwv_flow_imp.g_varchar2_table(29) := '6372656174652063616C6C6564207769746820696E76616C696420617267756D656E74735B222B652B222C20222B742B222C20222B6E2B222C20222B722B225D22297D2C762E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20';
wwv_flow_imp.g_varchar2_table(30) := '6F742E6F626A6563744C69746572616C2874292626662E697328742E7374617274292626662E697328742E656E64297D2C28623D6B7C7C286B3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C72616E';
wwv_flow_imp.g_varchar2_table(31) := '67653A747D7D2C622E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E72616E6765292626286F742E737472696E6728742E757269297C7C6F742E756E646566696E6564';
wwv_flow_imp.g_varchar2_table(32) := '28742E75726929297D2C28773D5F7C7C285F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E7B7461726765745572693A652C74617267657452616E67653A742C74617267657453656C656374696F6E52616E';
wwv_flow_imp.g_varchar2_table(33) := '67653A6E2C6F726967696E53656C656374696F6E52616E67653A727D7D2C772E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E74617267657452616E67652926266F74';
wwv_flow_imp.g_varchar2_table(34) := '2E737472696E6728742E746172676574557269292626286D2E697328742E74617267657453656C656374696F6E52616E6765297C7C6F742E756E646566696E656428742E74617267657453656C656374696F6E52616E676529292626286D2E697328742E';
wwv_flow_imp.g_varchar2_table(35) := '6F726967696E53656C656374696F6E52616E6765297C7C6F742E756E646566696E656428742E6F726967696E53656C656374696F6E52616E676529297D2C28793D437C7C28433D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C7229';
wwv_flow_imp.g_varchar2_table(36) := '7B72657475726E7B7265643A652C677265656E3A742C626C75653A6E2C616C7068613A727D7D2C792E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E6E756D62657252616E676528742E7265642C302C312926266F74';
wwv_flow_imp.g_varchar2_table(37) := '2E6E756D62657252616E676528742E677265656E2C302C312926266F742E6E756D62657252616E676528742E626C75652C302C312926266F742E6E756D62657252616E676528742E616C7068612C302C31297D2C28413D457C7C28453D7B7D29292E6372';
wwv_flow_imp.g_varchar2_table(38) := '656174653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C636F6C6F723A747D7D2C412E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206D2E697328742E72616E6765292626432E697328742E636F';
wwv_flow_imp.g_varchar2_table(39) := '6C6F72297D2C28493D787C7C28783D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B6C6162656C3A652C74657874456469743A742C6164646974696F6E616C5465787445646974733A6E7D7D2C492E69733D6675';
wwv_flow_imp.g_varchar2_table(40) := '6E6374696F6E2865297B76617220743D653B72657475726E206F742E737472696E6728742E6C6162656C292626286F742E756E646566696E656428742E7465787445646974297C7C4B2E6973287429292626286F742E756E646566696E656428742E6164';
wwv_flow_imp.g_varchar2_table(41) := '646974696F6E616C546578744564697473297C7C6F742E7479706564417272617928742E6164646974696F6E616C5465787445646974732C4B2E697329297D2C28543D537C7C28533D7B7D29292E436F6D6D656E743D22636F6D6D656E74222C542E496D';
wwv_flow_imp.g_varchar2_table(42) := '706F7274733D22696D706F727473222C542E526567696F6E3D22726567696F6E222C28443D527C7C28523D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C69297B766172206F3D7B73746172744C696E653A652C656E644C696E';
wwv_flow_imp.g_varchar2_table(43) := '653A747D3B72657475726E206F742E646566696E6564286E292626286F2E73746172744368617261637465723D6E292C6F742E646566696E65642872292626286F2E656E644368617261637465723D72292C6F742E646566696E65642869292626286F2E';
wwv_flow_imp.g_varchar2_table(44) := '6B696E643D69292C6F7D2C442E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E75696E746567657228742E73746172744C696E652926266F742E75696E746567657228742E73746172744C696E65292626286F742E75';
wwv_flow_imp.g_varchar2_table(45) := '6E646566696E656428742E7374617274436861726163746572297C7C6F742E75696E746567657228742E737461727443686172616374657229292626286F742E756E646566696E656428742E656E64436861726163746572297C7C6F742E75696E746567';
wwv_flow_imp.g_varchar2_table(46) := '657228742E656E6443686172616374657229292626286F742E756E646566696E656428742E6B696E64297C7C6F742E737472696E6728742E6B696E6429297D2C28503D4D7C7C284D3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(47) := '657475726E7B6C6F636174696F6E3A652C6D6573736167653A747D7D2C502E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266B2E697328742E6C6F636174696F6E2926266F742E737472';
wwv_flow_imp.g_varchar2_table(48) := '696E6728742E6D657373616765297D2C284C3D6A7C7C286A3D7B7D29292E4572726F723D312C4C2E5761726E696E673D322C4C2E496E666F726D6174696F6E3D332C4C2E48696E743D342C284F3D467C7C28463D7B7D29292E556E6E6563657373617279';
wwv_flow_imp.g_varchar2_table(49) := '3D312C4F2E446570726563617465643D322C284E7C7C284E3D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206E756C6C213D7426266F742E737472696E6728742E68726566297D2C28553D577C7C28573D7B7D29';
wwv_flow_imp.g_varchar2_table(50) := '292E6372656174653D66756E6374696F6E28652C742C6E2C722C692C6F297B76617220613D7B72616E67653A652C6D6573736167653A747D3B72657475726E206F742E646566696E6564286E29262628612E73657665726974793D6E292C6F742E646566';
wwv_flow_imp.g_varchar2_table(51) := '696E6564287229262628612E636F64653D72292C6F742E646566696E6564286929262628612E736F757263653D69292C6F742E646566696E6564286F29262628612E72656C61746564496E666F726D6174696F6E3D6F292C617D2C552E69733D66756E63';
wwv_flow_imp.g_varchar2_table(52) := '74696F6E2865297B76617220742C6E3D653B72657475726E206F742E646566696E6564286E2926266D2E6973286E2E72616E67652926266F742E737472696E67286E2E6D657373616765292626286F742E6E756D626572286E2E7365766572697479297C';
wwv_flow_imp.g_varchar2_table(53) := '7C6F742E756E646566696E6564286E2E736576657269747929292626286F742E696E7465676572286E2E636F6465297C7C6F742E737472696E67286E2E636F6465297C7C6F742E756E646566696E6564286E2E636F646529292626286F742E756E646566';
wwv_flow_imp.g_varchar2_table(54) := '696E6564286E2E636F64654465736372697074696F6E297C7C6F742E737472696E67286E756C6C3D3D3D28743D6E2E636F64654465736372697074696F6E297C7C766F696420303D3D3D743F766F696420303A742E6872656629292626286F742E737472';
wwv_flow_imp.g_varchar2_table(55) := '696E67286E2E736F75726365297C7C6F742E756E646566696E6564286E2E736F7572636529292626286F742E756E646566696E6564286E2E72656C61746564496E666F726D6174696F6E297C7C6F742E74797065644172726179286E2E72656C61746564';
wwv_flow_imp.g_varchar2_table(56) := '496E666F726D6174696F6E2C4D2E697329297D2C28483D567C7C28563D7B7D29292E6372656174653D66756E6374696F6E28652C74297B666F7228766172206E3D5B5D2C723D323B723C617267756D656E74732E6C656E6774683B722B2B296E5B722D32';
wwv_flow_imp.g_varchar2_table(57) := '5D3D617267756D656E74735B725D3B76617220693D7B7469746C653A652C636F6D6D616E643A747D3B72657475726E206F742E646566696E6564286E2926266E2E6C656E6774683E30262628692E617267756D656E74733D6E292C697D2C482E69733D66';
wwv_flow_imp.g_varchar2_table(58) := '756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E7469746C652926266F742E737472696E6728742E636F6D6D616E64297D2C287A3D4B7C7C284B3D7B7D29292E726570';
wwv_flow_imp.g_varchar2_table(59) := '6C6163653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A747D7D2C7A2E696E736572743D66756E6374696F6E28652C74297B72657475726E7B72616E67653A7B73746172743A652C656E643A657D2C6E65';
wwv_flow_imp.g_varchar2_table(60) := '77546578743A747D7D2C7A2E64656C3D66756E6374696F6E2865297B72657475726E7B72616E67653A652C6E6577546578743A22227D7D2C7A2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E6F626A6563744C6974';
wwv_flow_imp.g_varchar2_table(61) := '6572616C28742926266F742E737472696E6728742E6E6577546578742926266D2E697328742E72616E6765297D2C28583D717C7C28713D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220723D7B6C6162656C3A657D3B72';
wwv_flow_imp.g_varchar2_table(62) := '657475726E20766F69642030213D3D74262628722E6E65656473436F6E6669726D6174696F6E3D74292C766F69642030213D3D6E262628722E6465736372697074696F6E3D6E292C727D2C582E69733D66756E6374696F6E2865297B76617220743D653B';
wwv_flow_imp.g_varchar2_table(63) := '72657475726E20766F69642030213D3D7426266F742E6F626A6563744C69746572616C28742926266F742E737472696E6728742E6C6162656C292626286F742E626F6F6C65616E28742E6E65656473436F6E6669726D6174696F6E297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(64) := '3D3D3D742E6E65656473436F6E6669726D6174696F6E292626286F742E737472696E6728742E6465736372697074696F6E297C7C766F696420303D3D3D742E6465736372697074696F6E297D2C28427C7C28423D7B7D29292E69733D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(65) := '2865297B72657475726E22737472696E67223D3D747970656F6620657D2C284A3D247C7C28243D7B7D29292E7265706C6163653D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A652C6E6577546578743A742C616E6E6F746174';
wwv_flow_imp.g_varchar2_table(66) := '696F6E49643A6E7D7D2C4A2E696E736572743D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A7B73746172743A652C656E643A657D2C6E6577546578743A742C616E6E6F746174696F6E49643A6E7D7D2C4A2E64656C3D66756E';
wwv_flow_imp.g_varchar2_table(67) := '6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A22222C616E6E6F746174696F6E49643A747D7D2C4A2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E204B2E6973287429262628712E6973';
wwv_flow_imp.g_varchar2_table(68) := '28742E616E6E6F746174696F6E4964297C7C422E697328742E616E6E6F746174696F6E496429297D2C28473D517C7C28513D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B74657874446F63756D656E743A652C6564';
wwv_flow_imp.g_varchar2_table(69) := '6974733A747D7D2C472E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E6564287429262664652E697328742E74657874446F63756D656E7429262641727261792E6973417272617928742E656469747329';
wwv_flow_imp.g_varchar2_table(70) := '7D2C285A3D597C7C28593D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220723D7B6B696E643A22637265617465222C7572693A657D3B72657475726E20766F696420303D3D3D747C7C766F696420303D3D3D742E6F7665';
wwv_flow_imp.g_varchar2_table(71) := '7277726974652626766F696420303D3D3D742E69676E6F726549664578697374737C7C28722E6F7074696F6E733D74292C766F69642030213D3D6E262628722E616E6E6F746174696F6E49643D6E292C727D2C5A2E69733D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(72) := '76617220743D653B72657475726E2074262622637265617465223D3D3D742E6B696E6426266F742E737472696E6728742E75726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E6F766572';
wwv_flow_imp.g_varchar2_table(73) := '77726974657C7C6F742E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C6F742E626F6F6C65616E28742E6F7074696F6E732E6967';
wwv_flow_imp.g_varchar2_table(74) := '6E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C422E697328742E616E6E6F746174696F6E496429297D2C2874653D65657C7C2865653D7B7D29292E6372656174653D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(75) := '2C742C6E2C72297B76617220693D7B6B696E643A2272656E616D65222C6F6C645572693A652C6E65775572693A747D3B72657475726E20766F696420303D3D3D6E7C7C766F696420303D3D3D6E2E6F76657277726974652626766F696420303D3D3D6E2E';
wwv_flow_imp.g_varchar2_table(76) := '69676E6F726549664578697374737C7C28692E6F7074696F6E733D6E292C766F69642030213D3D72262628692E616E6E6F746174696F6E49643D72292C697D2C74652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20742626';
wwv_flow_imp.g_varchar2_table(77) := '2272656E616D65223D3D3D742E6B696E6426266F742E737472696E6728742E6F6C645572692926266F742E737472696E6728742E6E657755726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(78) := '732E6F76657277726974657C7C6F742E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C6F742E626F6F6C65616E28742E6F707469';
wwv_flow_imp.g_varchar2_table(79) := '6F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C422E697328742E616E6E6F746174696F6E496429297D2C2872653D6E657C7C286E653D7B7D29292E6372656174653D66756E63';
wwv_flow_imp.g_varchar2_table(80) := '74696F6E28652C742C6E297B76617220723D7B6B696E643A2264656C657465222C7572693A657D3B72657475726E20766F696420303D3D3D747C7C766F696420303D3D3D742E7265637572736976652626766F696420303D3D3D742E69676E6F72654966';
wwv_flow_imp.g_varchar2_table(81) := '4E6F744578697374737C7C28722E6F7074696F6E733D74292C766F69642030213D3D6E262628722E616E6E6F746174696F6E49643D6E292C727D2C72652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426262264656C65';
wwv_flow_imp.g_varchar2_table(82) := '7465223D3D3D742E6B696E6426266F742E737472696E6728742E75726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E7265637572736976657C7C6F742E626F6F6C65616E28742E6F7074';
wwv_flow_imp.g_varchar2_table(83) := '696F6E732E7265637572736976652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664E6F744578697374737C7C6F742E626F6F6C65616E28742E6F7074696F6E732E69676E6F726549664E6F744578697374732929292626';
wwv_flow_imp.g_varchar2_table(84) := '28766F696420303D3D3D742E616E6E6F746174696F6E49647C7C422E697328742E616E6E6F746174696F6E496429297D2C2869657C7C2869653D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262628766F69';
wwv_flow_imp.g_varchar2_table(85) := '642030213D3D742E6368616E6765737C7C766F69642030213D3D742E646F63756D656E744368616E67657329262628766F696420303D3D3D742E646F63756D656E744368616E6765737C7C742E646F63756D656E744368616E6765732E65766572792828';
wwv_flow_imp.g_varchar2_table(86) := '66756E6374696F6E2865297B72657475726E206F742E737472696E6728652E6B696E64293F592E69732865297C7C65652E69732865297C7C6E652E69732865293A512E69732865297D2929297D3B7661722061652C73652C63652C75652C64652C67652C';
wwv_flow_imp.g_varchar2_table(87) := '6C652C68652C66652C70652C6D652C76652C6B652C62652C5F652C77652C43652C79652C45652C41652C78652C49652C53652C54652C52652C44652C4D652C50652C6A652C4C652C46652C4F652C4E652C57652C55652C56652C48652C4B652C7A652C71';
wwv_flow_imp.g_varchar2_table(88) := '652C58652C42652C24652C4A652C51652C47652C59652C5A652C65742C74742C6E742C72743D66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E65646974733D652C746869732E6368616E6765416E6E6F746174696F6E73';
wwv_flow_imp.g_varchar2_table(89) := '3D747D72657475726E20652E70726F746F747970652E696E736572743D66756E6374696F6E28652C742C6E297B76617220722C693B696628766F696420303D3D3D6E3F723D4B2E696E7365727428652C74293A422E6973286E293F28693D6E2C723D242E';
wwv_flow_imp.g_varchar2_table(90) := '696E7365727428652C742C6E29293A28746869732E6173736572744368616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C693D746869732E6368616E6765416E6E6F746174696F6E732E6D616E616765';
wwv_flow_imp.g_varchar2_table(91) := '286E292C723D242E696E7365727428652C742C6929292C746869732E65646974732E707573682872292C766F69642030213D3D692972657475726E20697D2C652E70726F746F747970652E7265706C6163653D66756E6374696F6E28652C742C6E297B76';
wwv_flow_imp.g_varchar2_table(92) := '617220722C693B696628766F696420303D3D3D6E3F723D4B2E7265706C61636528652C74293A422E6973286E293F28693D6E2C723D242E7265706C61636528652C742C6E29293A28746869732E6173736572744368616E6765416E6E6F746174696F6E73';
wwv_flow_imp.g_varchar2_table(93) := '28746869732E6368616E6765416E6E6F746174696F6E73292C693D746869732E6368616E6765416E6E6F746174696F6E732E6D616E616765286E292C723D242E7265706C61636528652C742C6929292C746869732E65646974732E707573682872292C76';
wwv_flow_imp.g_varchar2_table(94) := '6F69642030213D3D692972657475726E20697D2C652E70726F746F747970652E64656C6574653D66756E6374696F6E28652C74297B766172206E2C723B696628766F696420303D3D3D743F6E3D4B2E64656C2865293A422E69732874293F28723D742C6E';
wwv_flow_imp.g_varchar2_table(95) := '3D242E64656C28652C7429293A28746869732E6173736572744368616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C723D746869732E6368616E6765416E6E6F746174696F6E732E6D616E6167652874';
wwv_flow_imp.g_varchar2_table(96) := '292C6E3D242E64656C28652C7229292C746869732E65646974732E70757368286E292C766F69642030213D3D722972657475726E20727D2C652E70726F746F747970652E6164643D66756E6374696F6E2865297B746869732E65646974732E7075736828';
wwv_flow_imp.g_varchar2_table(97) := '65297D2C652E70726F746F747970652E616C6C3D66756E6374696F6E28297B72657475726E20746869732E65646974737D2C652E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E65646974732E73706C69636528302C74';
wwv_flow_imp.g_varchar2_table(98) := '6869732E65646974732E6C656E677468297D2C652E70726F746F747970652E6173736572744368616E6765416E6E6F746174696F6E733D66756E6374696F6E2865297B696628766F696420303D3D3D65297468726F77206E6577204572726F7228225465';
wwv_flow_imp.g_varchar2_table(99) := '78742065646974206368616E6765206973206E6F7420636F6E6669677572656420746F206D616E616765206368616E676520616E6E6F746174696F6E732E22297D2C657D28292C69743D66756E6374696F6E28297B66756E6374696F6E20652865297B74';
wwv_flow_imp.g_varchar2_table(100) := '6869732E5F616E6E6F746174696F6E733D766F696420303D3D3D653F4F626A6563742E637265617465286E756C6C293A652C746869732E5F636F756E7465723D302C746869732E5F73697A653D307D72657475726E20652E70726F746F747970652E616C';
wwv_flow_imp.g_varchar2_table(101) := '6C3D66756E6374696F6E28297B72657475726E20746869732E5F616E6E6F746174696F6E737D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2273697A65222C7B6765743A66756E6374696F6E28297B72657475';
wwv_flow_imp.g_varchar2_table(102) := '726E20746869732E5F73697A657D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E6D616E6167653D66756E6374696F6E28652C74297B766172206E3B696628422E69732865293F6E3D65';
wwv_flow_imp.g_varchar2_table(103) := '3A286E3D746869732E6E657874496428292C743D65292C766F69642030213D3D746869732E5F616E6E6F746174696F6E735B6E5D297468726F77206E6577204572726F722822496420222B6E2B2220697320616C726561647920696E207573652E22293B';
wwv_flow_imp.g_varchar2_table(104) := '696628766F696420303D3D3D74297468726F77206E6577204572726F7228224E6F20616E6E6F746174696F6E2070726F766964656420666F7220696420222B6E293B72657475726E20746869732E5F616E6E6F746174696F6E735B6E5D3D742C74686973';
wwv_flow_imp.g_varchar2_table(105) := '2E5F73697A652B2B2C6E7D2C652E70726F746F747970652E6E65787449643D66756E6374696F6E28297B72657475726E20746869732E5F636F756E7465722B2B2C746869732E5F636F756E7465722E746F537472696E6728297D2C657D28293B2166756E';
wwv_flow_imp.g_varchar2_table(106) := '6374696F6E28297B66756E6374696F6E20652865297B76617220743D746869733B746869732E5F74657874456469744368616E6765733D4F626A6563742E637265617465286E756C6C292C766F69642030213D3D653F28746869732E5F776F726B737061';
wwv_flow_imp.g_varchar2_table(107) := '6365456469743D652C652E646F63756D656E744368616E6765733F28746869732E5F6368616E6765416E6E6F746174696F6E733D6E657720697428652E6368616E6765416E6E6F746174696F6E73292C652E6368616E6765416E6E6F746174696F6E733D';
wwv_flow_imp.g_varchar2_table(108) := '746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C28292C652E646F63756D656E744368616E6765732E666F7245616368282866756E6374696F6E2865297B696628512E6973286529297B766172206E3D6E657720727428652E65646974';
wwv_flow_imp.g_varchar2_table(109) := '732C742E5F6368616E6765416E6E6F746174696F6E73293B742E5F74657874456469744368616E6765735B652E74657874446F63756D656E742E7572695D3D6E7D7D2929293A652E6368616E67657326264F626A6563742E6B65797328652E6368616E67';
wwv_flow_imp.g_varchar2_table(110) := '6573292E666F7245616368282866756E6374696F6E286E297B76617220723D6E657720727428652E6368616E6765735B6E5D293B742E5F74657874456469744368616E6765735B6E5D3D727D2929293A746869732E5F776F726B7370616365456469743D';
wwv_flow_imp.g_varchar2_table(111) := '7B7D7D4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2265646974222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E696E6974446F63756D656E744368616E67657328292C766F69642030';
wwv_flow_imp.g_varchar2_table(112) := '213D3D746869732E5F6368616E6765416E6E6F746174696F6E73262628303D3D3D746869732E5F6368616E6765416E6E6F746174696F6E732E73697A653F746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D';
wwv_flow_imp.g_varchar2_table(113) := '766F696420303A746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829292C746869732E5F776F726B7370616365456469747D2C656E75';
wwv_flow_imp.g_varchar2_table(114) := '6D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E67657454657874456469744368616E67653D66756E6374696F6E2865297B69662864652E6973286529297B696628746869732E696E6974446F6375';
wwv_flow_imp.g_varchar2_table(115) := '6D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F';
wwv_flow_imp.g_varchar2_table(116) := '6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220743D7B7572693A652E7572692C76657273696F6E3A652E76657273696F6E7D3B6966282128723D746869732E5F74657874456469744368616E6765735B742E';
wwv_flow_imp.g_varchar2_table(117) := '7572695D29297B766172206E3D7B74657874446F63756D656E743A742C65646974733A693D5B5D7D3B746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E70757368286E292C723D6E657720727428692C74686973';
wwv_flow_imp.g_varchar2_table(118) := '2E5F6368616E6765416E6E6F746174696F6E73292C746869732E5F74657874456469744368616E6765735B742E7572695D3D727D72657475726E20727D696628746869732E696E69744368616E67657328292C766F696420303D3D3D746869732E5F776F';
wwv_flow_imp.g_varchar2_table(119) := '726B7370616365456469742E6368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F72206E6F726D616C20746578742065646974206368616E6765732E22';
wwv_flow_imp.g_varchar2_table(120) := '293B76617220723B6966282128723D746869732E5F74657874456469744368616E6765735B655D29297B76617220693D5B5D3B746869732E5F776F726B7370616365456469742E6368616E6765735B655D3D692C723D6E65772072742869292C74686973';
wwv_flow_imp.g_varchar2_table(121) := '2E5F74657874456469744368616E6765735B655D3D727D72657475726E20727D2C652E70726F746F747970652E696E6974446F63756D656E744368616E6765733D66756E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365';
wwv_flow_imp.g_varchar2_table(122) := '456469742E646F63756D656E744368616E6765732626766F696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869732E5F6368616E6765416E6E6F746174696F6E733D6E65772069742C746869732E5F776F';
wwv_flow_imp.g_varchar2_table(123) := '726B7370616365456469742E646F63756D656E744368616E6765733D5B5D2C746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829297D';
wwv_flow_imp.g_varchar2_table(124) := '2C652E70726F746F747970652E696E69744368616E6765733D66756E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F696420303D3D3D746869732E5F776F72';
wwv_flow_imp.g_varchar2_table(125) := '6B7370616365456469742E6368616E676573262628746869732E5F776F726B7370616365456469742E6368616E6765733D4F626A6563742E637265617465286E756C6C29297D2C652E70726F746F747970652E63726561746546696C653D66756E637469';
wwv_flow_imp.g_varchar2_table(126) := '6F6E28652C742C6E297B696628746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(127) := '2822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220722C692C6F3B696628712E69732874297C7C422E69732874293F723D743A6E3D742C766F69';
wwv_flow_imp.g_varchar2_table(128) := '6420303D3D3D723F693D592E63726561746528652C6E293A286F3D422E69732872293F723A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C693D592E63726561746528652C6E2C6F29292C746869732E5F776F726B';
wwv_flow_imp.g_varchar2_table(129) := '7370616365456469742E646F63756D656E744368616E6765732E707573682869292C766F69642030213D3D6F2972657475726E206F7D2C652E70726F746F747970652E72656E616D6546696C653D66756E6374696F6E28652C742C6E2C72297B69662874';
wwv_flow_imp.g_varchar2_table(130) := '6869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B7370616365206564';
wwv_flow_imp.g_varchar2_table(131) := '6974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220692C6F2C613B696628712E6973286E297C7C422E6973286E293F693D6E3A723D6E2C766F696420303D3D3D693F6F3D65652E63';
wwv_flow_imp.g_varchar2_table(132) := '726561746528652C742C72293A28613D422E69732869293F693A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652869292C6F3D65652E63726561746528652C742C722C6129292C746869732E5F776F726B7370616365456469';
wwv_flow_imp.g_varchar2_table(133) := '742E646F63756D656E744368616E6765732E70757368286F292C766F69642030213D3D612972657475726E20617D2C652E70726F746F747970652E64656C65746546696C653D66756E6374696F6E28652C742C6E297B696628746869732E696E6974446F';
wwv_flow_imp.g_varchar2_table(134) := '63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420';
wwv_flow_imp.g_varchar2_table(135) := '636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220722C692C6F3B696628712E69732874297C7C422E69732874293F723D743A6E3D742C766F696420303D3D3D723F693D6E652E63726561746528652C6E29';
wwv_flow_imp.g_varchar2_table(136) := '3A286F3D422E69732872293F723A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C693D6E652E63726561746528652C6E2C6F29292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E';
wwv_flow_imp.g_varchar2_table(137) := '6765732E707573682869292C766F69642030213D3D6F2972657475726E206F7D7D28292C2873653D61657C7C2861653D7B7D29292E6372656174653D66756E6374696F6E2865297B72657475726E7B7572693A657D7D2C73652E69733D66756E6374696F';
wwv_flow_imp.g_varchar2_table(138) := '6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E757269297D2C2875653D63657C7C2863653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572';
wwv_flow_imp.g_varchar2_table(139) := '693A652C76657273696F6E3A747D7D2C75652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E737472696E6728742E7572692926266F742E696E746567657228742E7665727369';
wwv_flow_imp.g_varchar2_table(140) := '6F6E297D2C2867653D64657C7C2864653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C76657273696F6E3A747D7D2C67652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E';
wwv_flow_imp.g_varchar2_table(141) := '206F742E646566696E656428742926266F742E737472696E6728742E757269292626286E756C6C3D3D3D742E76657273696F6E7C7C6F742E696E746567657228742E76657273696F6E29297D2C2868653D6C657C7C286C653D7B7D29292E637265617465';
wwv_flow_imp.g_varchar2_table(142) := '3D66756E6374696F6E28652C742C6E2C72297B72657475726E7B7572693A652C6C616E677561676549643A742C76657273696F6E3A6E2C746578743A727D7D2C68652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E';
wwv_flow_imp.g_varchar2_table(143) := '646566696E656428742926266F742E737472696E6728742E7572692926266F742E737472696E6728742E6C616E677561676549642926266F742E696E746567657228742E76657273696F6E2926266F742E737472696E6728742E74657874297D2C287065';
wwv_flow_imp.g_varchar2_table(144) := '3D66657C7C2866653D7B7D29292E506C61696E546578743D22706C61696E74657874222C70652E4D61726B646F776E3D226D61726B646F776E222C66756E6374696F6E2865297B652E69733D66756E6374696F6E2874297B766172206E3D743B72657475';
wwv_flow_imp.g_varchar2_table(145) := '726E206E3D3D3D652E506C61696E546578747C7C6E3D3D3D652E4D61726B646F776E7D7D2866657C7C2866653D7B7D29292C286D657C7C286D653D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E6F626A';
wwv_flow_imp.g_varchar2_table(146) := '6563744C69746572616C286529262666652E697328742E6B696E642926266F742E737472696E6728742E76616C7565297D2C286B653D76657C7C2876653D7B7D29292E546578743D312C6B652E4D6574686F643D322C6B652E46756E6374696F6E3D332C';
wwv_flow_imp.g_varchar2_table(147) := '6B652E436F6E7374727563746F723D342C6B652E4669656C643D352C6B652E5661726961626C653D362C6B652E436C6173733D372C6B652E496E746572666163653D382C6B652E4D6F64756C653D392C6B652E50726F70657274793D31302C6B652E556E';
wwv_flow_imp.g_varchar2_table(148) := '69743D31312C6B652E56616C75653D31322C6B652E456E756D3D31332C6B652E4B6579776F72643D31342C6B652E536E69707065743D31352C6B652E436F6C6F723D31362C6B652E46696C653D31372C6B652E5265666572656E63653D31382C6B652E46';
wwv_flow_imp.g_varchar2_table(149) := '6F6C6465723D31392C6B652E456E756D4D656D6265723D32302C6B652E436F6E7374616E743D32312C6B652E5374727563743D32322C6B652E4576656E743D32332C6B652E4F70657261746F723D32342C6B652E54797065506172616D657465723D3235';
wwv_flow_imp.g_varchar2_table(150) := '2C285F653D62657C7C2862653D7B7D29292E506C61696E546578743D312C5F652E536E69707065743D322C2877657C7C2877653D7B7D29292E446570726563617465643D312C2879653D43657C7C2843653D7B7D29292E6372656174653D66756E637469';
wwv_flow_imp.g_varchar2_table(151) := '6F6E28652C742C6E297B72657475726E7B6E6577546578743A652C696E736572743A742C7265706C6163653A6E7D7D2C79652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426266F742E737472696E6728742E6E657754';
wwv_flow_imp.g_varchar2_table(152) := '6578742926266D2E697328742E696E736572742926266D2E697328742E7265706C616365297D2C2841653D45657C7C2845653D7B7D29292E617349733D312C41652E61646A757374496E64656E746174696F6E3D322C2878657C7C2878653D7B7D29292E';
wwv_flow_imp.g_varchar2_table(153) := '6372656174653D66756E6374696F6E2865297B72657475726E7B6C6162656C3A657D7D2C2849657C7C2849653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B6974656D733A657C7C5B5D2C6973496E636F6D706C65';
wwv_flow_imp.g_varchar2_table(154) := '74653A2121747D7D2C2854653D53657C7C2853653D7B7D29292E66726F6D506C61696E546578743D66756E6374696F6E2865297B72657475726E20652E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D2E215D2F672C225C5C24262229';
wwv_flow_imp.g_varchar2_table(155) := '7D2C54652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E737472696E672874297C7C6F742E6F626A6563744C69746572616C28742926266F742E737472696E6728742E6C616E67756167652926266F742E73747269';
wwv_flow_imp.g_varchar2_table(156) := '6E6728742E76616C7565297D2C2852657C7C2852653D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E21217426266F742E6F626A6563744C69746572616C2874292626286D652E697328742E636F6E74656E747329';
wwv_flow_imp.g_varchar2_table(157) := '7C7C53652E697328742E636F6E74656E7473297C7C6F742E7479706564417272617928742E636F6E74656E74732C53652E69732929262628766F696420303D3D3D652E72616E67657C7C6D2E697328652E72616E676529297D2C2844657C7C2844653D7B';
wwv_flow_imp.g_varchar2_table(158) := '7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E20743F7B6C6162656C3A652C646F63756D656E746174696F6E3A747D3A7B6C6162656C3A657D7D2C284D657C7C284D653D7B7D29292E6372656174653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(159) := '28652C74297B666F7228766172206E3D5B5D2C723D323B723C617267756D656E74732E6C656E6774683B722B2B296E5B722D325D3D617267756D656E74735B725D3B76617220693D7B6C6162656C3A657D3B72657475726E206F742E646566696E656428';
wwv_flow_imp.g_varchar2_table(160) := '7429262628692E646F63756D656E746174696F6E3D74292C6F742E646566696E6564286E293F692E706172616D65746572733D6E3A692E706172616D65746572733D5B5D2C697D2C286A653D50657C7C2850653D7B7D29292E546578743D312C6A652E52';
wwv_flow_imp.g_varchar2_table(161) := '6561643D322C6A652E57726974653D332C284C657C7C284C653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475726E206F742E6E756D6265722874292626286E2E6B696E643D74292C';
wwv_flow_imp.g_varchar2_table(162) := '6E7D2C284F653D46657C7C2846653D7B7D29292E46696C653D312C4F652E4D6F64756C653D322C4F652E4E616D6573706163653D332C4F652E5061636B6167653D342C4F652E436C6173733D352C4F652E4D6574686F643D362C4F652E50726F70657274';
wwv_flow_imp.g_varchar2_table(163) := '793D372C4F652E4669656C643D382C4F652E436F6E7374727563746F723D392C4F652E456E756D3D31302C4F652E496E746572666163653D31312C4F652E46756E6374696F6E3D31322C4F652E5661726961626C653D31332C4F652E436F6E7374616E74';
wwv_flow_imp.g_varchar2_table(164) := '3D31342C4F652E537472696E673D31352C4F652E4E756D6265723D31362C4F652E426F6F6C65616E3D31372C4F652E41727261793D31382C4F652E4F626A6563743D31392C4F652E4B65793D32302C4F652E4E756C6C3D32312C4F652E456E756D4D656D';
wwv_flow_imp.g_varchar2_table(165) := '6265723D32322C4F652E5374727563743D32332C4F652E4576656E743D32342C4F652E4F70657261746F723D32352C4F652E54797065506172616D657465723D32362C284E657C7C284E653D7B7D29292E446570726563617465643D312C2857657C7C28';
wwv_flow_imp.g_varchar2_table(166) := '57653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C69297B766172206F3D7B6E616D653A652C6B696E643A742C6C6F636174696F6E3A7B7572693A722C72616E67653A6E7D7D3B72657475726E20692626286F2E636F6E7461';
wwv_flow_imp.g_varchar2_table(167) := '696E65724E616D653D69292C6F7D2C2856653D55657C7C2855653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C692C6F297B76617220613D7B6E616D653A652C64657461696C3A742C6B696E643A6E2C72616E67653A722C73';
wwv_flow_imp.g_varchar2_table(168) := '656C656374696F6E52616E67653A697D3B72657475726E20766F69642030213D3D6F262628612E6368696C6472656E3D6F292C617D2C56652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426266F742E737472696E6728';
wwv_flow_imp.g_varchar2_table(169) := '742E6E616D652926266F742E6E756D62657228742E6B696E642926266D2E697328742E72616E67652926266D2E697328742E73656C656374696F6E52616E676529262628766F696420303D3D3D742E64657461696C7C7C6F742E737472696E6728742E64';
wwv_flow_imp.g_varchar2_table(170) := '657461696C2929262628766F696420303D3D3D742E646570726563617465647C7C6F742E626F6F6C65616E28742E646570726563617465642929262628766F696420303D3D3D742E6368696C6472656E7C7C41727261792E6973417272617928742E6368';
wwv_flow_imp.g_varchar2_table(171) := '696C6472656E2929262628766F696420303D3D3D742E746167737C7C41727261792E6973417272617928742E7461677329297D2C284B653D48657C7C2848653D7B7D29292E456D7074793D22222C4B652E517569636B4669783D22717569636B66697822';
wwv_flow_imp.g_varchar2_table(172) := '2C4B652E5265666163746F723D227265666163746F72222C4B652E5265666163746F72457874726163743D227265666163746F722E65787472616374222C4B652E5265666163746F72496E6C696E653D227265666163746F722E696E6C696E65222C4B65';
wwv_flow_imp.g_varchar2_table(173) := '2E5265666163746F72526577726974653D227265666163746F722E72657772697465222C4B652E536F757263653D22736F75726365222C4B652E536F757263654F7267616E697A65496D706F7274733D22736F757263652E6F7267616E697A65496D706F';
wwv_flow_imp.g_varchar2_table(174) := '727473222C4B652E536F75726365466978416C6C3D22736F757263652E666978416C6C222C2871653D7A657C7C287A653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B646961676E6F73746963733A657D3B726574';
wwv_flow_imp.g_varchar2_table(175) := '75726E206E756C6C213D742626286E2E6F6E6C793D74292C6E7D2C71652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E7479706564417272617928742E646961676E6F737469';
wwv_flow_imp.g_varchar2_table(176) := '63732C572E697329262628766F696420303D3D3D742E6F6E6C797C7C6F742E7479706564417272617928742E6F6E6C792C6F742E737472696E6729297D2C2842653D58657C7C2858653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(177) := '297B76617220723D7B7469746C653A657D2C693D21303B72657475726E22737472696E67223D3D747970656F6620743F28693D21312C722E6B696E643D74293A562E69732874293F722E636F6D6D616E643D743A722E656469743D742C692626766F6964';
wwv_flow_imp.g_varchar2_table(178) := '2030213D3D6E262628722E6B696E643D6E292C727D2C42652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426266F742E737472696E6728742E7469746C6529262628766F696420303D3D3D742E646961676E6F73746963';
wwv_flow_imp.g_varchar2_table(179) := '737C7C6F742E7479706564417272617928742E646961676E6F73746963732C572E69732929262628766F696420303D3D3D742E6B696E647C7C6F742E737472696E6728742E6B696E642929262628766F69642030213D3D742E656469747C7C766F696420';
wwv_flow_imp.g_varchar2_table(180) := '30213D3D742E636F6D6D616E6429262628766F696420303D3D3D742E636F6D6D616E647C7C562E697328742E636F6D6D616E642929262628766F696420303D3D3D742E69735072656665727265647C7C6F742E626F6F6C65616E28742E69735072656665';
wwv_flow_imp.g_varchar2_table(181) := '727265642929262628766F696420303D3D3D742E656469747C7C69652E697328742E6564697429297D2C284A653D24657C7C2824653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475';
wwv_flow_imp.g_varchar2_table(182) := '726E206F742E646566696E65642874292626286E2E646174613D74292C6E7D2C4A652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E72616E6765292626286F742E75';
wwv_flow_imp.g_varchar2_table(183) := '6E646566696E656428742E636F6D6D616E64297C7C562E697328742E636F6D6D616E6429297D2C2847653D51657C7C2851653D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B74616253697A653A652C696E73657274';
wwv_flow_imp.g_varchar2_table(184) := '5370616365733A747D7D2C47652E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206F742E646566696E656428742926266F742E75696E746567657228742E74616253697A652926266F742E626F6F6C65616E28742E696E7365';
wwv_flow_imp.g_varchar2_table(185) := '7274537061636573297D2C285A653D59657C7C2859653D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A652C7461726765743A742C646174613A6E7D7D2C5A652E69733D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(186) := '297B76617220743D653B72657475726E206F742E646566696E656428742926266D2E697328742E72616E6765292626286F742E756E646566696E656428742E746172676574297C7C6F742E737472696E6728742E74617267657429297D2C2874743D6574';
wwv_flow_imp.g_varchar2_table(187) := '7C7C2865743D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C706172656E743A747D7D2C74742E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(188) := '7426266D2E697328742E72616E676529262628766F696420303D3D3D742E706172656E747C7C74742E697328742E706172656E7429297D2C66756E6374696F6E2865297B66756E6374696F6E207428652C6E297B696628652E6C656E6774683C3D312972';
wwv_flow_imp.g_varchar2_table(189) := '657475726E20653B76617220723D652E6C656E6774682F327C302C693D652E736C69636528302C72292C6F3D652E736C6963652872293B7428692C6E292C74286F2C6E293B666F722876617220613D302C733D302C633D303B613C692E6C656E67746826';
wwv_flow_imp.g_varchar2_table(190) := '26733C6F2E6C656E6774683B297B76617220753D6E28695B615D2C6F5B735D293B655B632B2B5D3D753C3D303F695B612B2B5D3A6F5B732B2B5D7D666F72283B613C692E6C656E6774683B29655B632B2B5D3D695B612B2B5D3B666F72283B733C6F2E6C';
wwv_flow_imp.g_varchar2_table(191) := '656E6774683B29655B632B2B5D3D6F5B732B2B5D3B72657475726E20657D652E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E206E657720637428652C742C6E2C72297D2C652E69733D66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(192) := '7220743D653B72657475726E2121286F742E646566696E656428742926266F742E737472696E6728742E757269292626286F742E756E646566696E656428742E6C616E67756167654964297C7C6F742E737472696E6728742E6C616E6775616765496429';
wwv_flow_imp.g_varchar2_table(193) := '2926266F742E75696E746567657228742E6C696E65436F756E742926266F742E66756E6328742E676574546578742926266F742E66756E6328742E706F736974696F6E41742926266F742E66756E6328742E6F6666736574417429297D2C652E6170706C';
wwv_flow_imp.g_varchar2_table(194) := '7945646974733D66756E6374696F6E28652C6E297B666F722876617220723D652E6765745465787428292C693D74286E2C2866756E6374696F6E28652C74297B766172206E3D652E72616E67652E73746172742E6C696E652D742E72616E67652E737461';
wwv_flow_imp.g_varchar2_table(195) := '72742E6C696E653B72657475726E20303D3D3D6E3F652E72616E67652E73746172742E6368617261637465722D742E72616E67652E73746172742E6368617261637465723A6E7D29292C6F3D722E6C656E6774682C613D692E6C656E6774682D313B613E';
wwv_flow_imp.g_varchar2_table(196) := '3D303B612D2D297B76617220733D695B615D2C633D652E6F6666736574417428732E72616E67652E7374617274292C753D652E6F6666736574417428732E72616E67652E656E64293B6966282128753C3D6F29297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(197) := '224F7665726C617070696E67206564697422293B723D722E737562737472696E6728302C63292B732E6E6577546578742B722E737562737472696E6728752C722E6C656E677468292C6F3D637D72657475726E20727D7D286E747C7C286E743D7B7D2929';
wwv_flow_imp.g_varchar2_table(198) := '3B766172206F742C61742C73742C63743D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C72297B746869732E5F7572693D652C746869732E5F6C616E677561676549643D742C746869732E5F76657273696F6E3D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(199) := '5F636F6E74656E743D722C746869732E5F6C696E654F6666736574733D766F696420307D72657475726E204F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C22757269222C7B6765743A66756E6374696F6E28297B72';
wwv_flow_imp.g_varchar2_table(200) := '657475726E20746869732E5F7572697D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C616E67756167654964222C7B676574';
wwv_flow_imp.g_varchar2_table(201) := '3A66756E6374696F6E28297B72657475726E20746869732E5F6C616E677561676549647D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F7479';
wwv_flow_imp.g_varchar2_table(202) := '70652C2276657273696F6E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F76657273696F6E7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E6765745465';
wwv_flow_imp.g_varchar2_table(203) := '78743D66756E6374696F6E2865297B69662865297B76617220743D746869732E6F6666736574417428652E7374617274292C6E3D746869732E6F6666736574417428652E656E64293B72657475726E20746869732E5F636F6E74656E742E737562737472';
wwv_flow_imp.g_varchar2_table(204) := '696E6728742C6E297D72657475726E20746869732E5F636F6E74656E747D2C652E70726F746F747970652E7570646174653D66756E6374696F6E28652C74297B746869732E5F636F6E74656E743D652E746578742C746869732E5F76657273696F6E3D74';
wwv_flow_imp.g_varchar2_table(205) := '2C746869732E5F6C696E654F6666736574733D766F696420307D2C652E70726F746F747970652E6765744C696E654F6666736574733D66756E6374696F6E28297B696628766F696420303D3D3D746869732E5F6C696E654F666673657473297B666F7228';
wwv_flow_imp.g_varchar2_table(206) := '76617220653D5B5D2C743D746869732E5F636F6E74656E742C6E3D21302C723D303B723C742E6C656E6774683B722B2B297B6E262628652E707573682872292C6E3D2131293B76617220693D742E6368617241742872293B6E3D225C72223D3D3D697C7C';
wwv_flow_imp.g_varchar2_table(207) := '225C6E223D3D3D692C225C72223D3D3D692626722B313C742E6C656E6774682626225C6E223D3D3D742E63686172417428722B31292626722B2B7D6E2626742E6C656E6774683E302626652E7075736828742E6C656E677468292C746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(208) := '654F6666736574733D657D72657475726E20746869732E5F6C696E654F6666736574737D2C652E70726F746F747970652E706F736974696F6E41743D66756E6374696F6E2865297B653D4D6174682E6D6178284D6174682E6D696E28652C746869732E5F';
wwv_flow_imp.g_varchar2_table(209) := '636F6E74656E742E6C656E677468292C30293B76617220743D746869732E6765744C696E654F66667365747328292C6E3D302C723D742E6C656E6774683B696628303D3D3D722972657475726E20662E63726561746528302C65293B666F72283B6E3C72';
wwv_flow_imp.g_varchar2_table(210) := '3B297B76617220693D4D6174682E666C6F6F7228286E2B72292F32293B745B695D3E653F723D693A6E3D692B317D766172206F3D6E2D313B72657475726E20662E637265617465286F2C652D745B6F5D297D2C652E70726F746F747970652E6F66667365';
wwv_flow_imp.g_varchar2_table(211) := '7441743D66756E6374696F6E2865297B76617220743D746869732E6765744C696E654F66667365747328293B696628652E6C696E653E3D742E6C656E6774682972657475726E20746869732E5F636F6E74656E742E6C656E6774683B696628652E6C696E';
wwv_flow_imp.g_varchar2_table(212) := '653C302972657475726E20303B766172206E3D745B652E6C696E655D2C723D652E6C696E652B313C742E6C656E6774683F745B652E6C696E652B315D3A746869732E5F636F6E74656E742E6C656E6774683B72657475726E204D6174682E6D6178284D61';
wwv_flow_imp.g_varchar2_table(213) := '74682E6D696E286E2B652E6368617261637465722C72292C6E297D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C696E65436F756E74222C7B6765743A66756E6374696F6E28297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(214) := '732E6765744C696E654F66667365747328292E6C656E6774687D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C657D28293B61743D6F747C7C286F743D7B7D292C73743D4F626A6563742E70726F746F747970652E74';
wwv_flow_imp.g_varchar2_table(215) := '6F537472696E672C61742E646566696E65643D66756E6374696F6E2865297B72657475726E20766F69642030213D3D657D2C61742E756E646566696E65643D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D657D2C61742E626F6F';
wwv_flow_imp.g_varchar2_table(216) := '6C65616E3D66756E6374696F6E2865297B72657475726E21303D3D3D657C7C21313D3D3D657D2C61742E737472696E673D66756E6374696F6E2865297B72657475726E225B6F626A65637420537472696E675D223D3D3D73742E63616C6C2865297D2C61';
wwv_flow_imp.g_varchar2_table(217) := '742E6E756D6265723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D73742E63616C6C2865297D2C61742E6E756D62657252616E67653D66756E6374696F6E28652C742C6E297B72657475726E225B6F62';
wwv_flow_imp.g_varchar2_table(218) := '6A656374204E756D6265725D223D3D3D73742E63616C6C2865292626743C3D652626653C3D6E7D2C61742E696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D73742E63616C6C28652926';
wwv_flow_imp.g_varchar2_table(219) := '262D323134373438333634383C3D652626653C3D323134373438333634377D2C61742E75696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D73742E63616C6C2865292626303C3D652626';
wwv_flow_imp.g_varchar2_table(220) := '653C3D323134373438333634377D2C61742E66756E633D66756E6374696F6E2865297B72657475726E225B6F626A6563742046756E6374696F6E5D223D3D3D73742E63616C6C2865297D2C61742E6F626A6563744C69746572616C3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(221) := '2865297B72657475726E206E756C6C213D3D652626226F626A656374223D3D747970656F6620657D2C61742E747970656441727261793D66756E6374696F6E28652C74297B72657475726E2041727261792E697341727261792865292626652E65766572';
wwv_flow_imp.g_varchar2_table(222) := '792874297D3B7661722075743D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F6C616E677561676549643D652C746869732E5F776F726B65723D742C746869732E5F646973706F7361626C65733D5B5D2C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(223) := '697374656E65723D4F626A6563742E637265617465286E756C6C293B636F6E737420723D653D3E7B6C657420742C6E3D652E6765744C616E6775616765496428293B6E3D3D3D746869732E5F6C616E67756167654964262628746869732E5F6C69737465';
wwv_flow_imp.g_varchar2_table(224) := '6E65725B652E7572692E746F537472696E6728295D3D652E6F6E4469644368616E6765436F6E74656E74282828293D3E7B77696E646F772E636C65617254696D656F75742874292C743D77696E646F772E73657454696D656F7574282828293D3E746869';
wwv_flow_imp.g_varchar2_table(225) := '732E5F646F56616C696461746528652E7572692C6E29292C353030297D29292C746869732E5F646F56616C696461746528652E7572692C6E29297D2C693D653D3E7B752E656469746F722E7365744D6F64656C4D61726B65727328652C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(226) := '616E677561676549642C5B5D293B6C657420743D652E7572692E746F537472696E6728292C6E3D746869732E5F6C697374656E65725B745D3B6E2626286E2E646973706F736528292C64656C65746520746869732E5F6C697374656E65725B745D297D3B';
wwv_flow_imp.g_varchar2_table(227) := '746869732E5F646973706F7361626C65732E7075736828752E656469746F722E6F6E4469644372656174654D6F64656C287229292C746869732E5F646973706F7361626C65732E7075736828752E656469746F722E6F6E57696C6C446973706F73654D6F';
wwv_flow_imp.g_varchar2_table(228) := '64656C286929292C746869732E5F646973706F7361626C65732E7075736828752E656469746F722E6F6E4469644368616E67654D6F64656C4C616E67756167652828653D3E7B6928652E6D6F64656C292C7228652E6D6F64656C297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(229) := '2E5F646973706F7361626C65732E70757368286E2828653D3E7B752E656469746F722E6765744D6F64656C7328292E666F72456163682828653D3E7B652E6765744C616E6775616765496428293D3D3D746869732E5F6C616E6775616765496426262869';
wwv_flow_imp.g_varchar2_table(230) := '2865292C72286529297D29297D2929292C746869732E5F646973706F7361626C65732E70757368287B646973706F73653A28293D3E7B752E656469746F722E6765744D6F64656C7328292E666F72456163682869293B666F72286C6574206520696E2074';
wwv_flow_imp.g_varchar2_table(231) := '6869732E5F6C697374656E657229746869732E5F6C697374656E65725B655D2E646973706F736528297D7D292C752E656469746F722E6765744D6F64656C7328292E666F72456163682872297D646973706F736528297B746869732E5F646973706F7361';
wwv_flow_imp.g_varchar2_table(232) := '626C65732E666F72456163682828653D3E652626652E646973706F7365282929292C746869732E5F646973706F7361626C65732E6C656E6774683D307D5F646F56616C696461746528652C74297B746869732E5F776F726B65722865292E7468656E2828';
wwv_flow_imp.g_varchar2_table(233) := '743D3E742E646F56616C69646174696F6E28652E746F537472696E6728292929292E7468656E28286E3D3E7B636F6E737420723D6E2E6D61702828653D3E66756E6374696F6E28652C74297B6C6574206E3D226E756D626572223D3D747970656F662074';
wwv_flow_imp.g_varchar2_table(234) := '2E636F64653F537472696E6728742E636F6465293A742E636F64653B72657475726E7B73657665726974793A647428742E7365766572697479292C73746172744C696E654E756D6265723A742E72616E67652E73746172742E6C696E652B312C73746172';
wwv_flow_imp.g_varchar2_table(235) := '74436F6C756D6E3A742E72616E67652E73746172742E6368617261637465722B312C656E644C696E654E756D6265723A742E72616E67652E656E642E6C696E652B312C656E64436F6C756D6E3A742E72616E67652E656E642E6368617261637465722B31';
wwv_flow_imp.g_varchar2_table(236) := '2C6D6573736167653A742E6D6573736167652C636F64653A6E2C736F757263653A742E736F757263657D7D28302C652929293B6C657420693D752E656469746F722E6765744D6F64656C2865293B692626692E6765744C616E6775616765496428293D3D';
wwv_flow_imp.g_varchar2_table(237) := '3D742626752E656469746F722E7365744D6F64656C4D61726B65727328692C742C72297D29292E7468656E28766F696420302C28653D3E7B636F6E736F6C652E6572726F722865297D29297D7D3B66756E6374696F6E2064742865297B73776974636828';
wwv_flow_imp.g_varchar2_table(238) := '65297B63617365206A2E4572726F723A72657475726E20752E4D61726B657253657665726974792E4572726F723B63617365206A2E5761726E696E673A72657475726E20752E4D61726B657253657665726974792E5761726E696E673B63617365206A2E';
wwv_flow_imp.g_varchar2_table(239) := '496E666F726D6174696F6E3A72657475726E20752E4D61726B657253657665726974792E496E666F3B63617365206A2E48696E743A72657475726E20752E4D61726B657253657665726974792E48696E743B64656661756C743A72657475726E20752E4D';
wwv_flow_imp.g_varchar2_table(240) := '61726B657253657665726974792E496E666F7D7D7661722067743D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F776F726B65723D652C746869732E5F74726967676572436861726163746572733D747D676574207472696767';
wwv_flow_imp.g_varchar2_table(241) := '65724368617261637465727328297B72657475726E20746869732E5F74726967676572436861726163746572737D70726F76696465436F6D706C6574696F6E4974656D7328652C742C6E2C72297B636F6E737420693D652E7572693B72657475726E2074';
wwv_flow_imp.g_varchar2_table(242) := '6869732E5F776F726B65722869292E7468656E2828653D3E652E646F436F6D706C65746528692E746F537472696E6728292C6C742874292929292E7468656E28286E3D3E7B696628216E2972657475726E3B636F6E737420723D652E676574576F726455';
wwv_flow_imp.g_varchar2_table(243) := '6E74696C506F736974696F6E2874292C693D6E657720752E52616E676528742E6C696E654E756D6265722C722E7374617274436F6C756D6E2C742E6C696E654E756D6265722C722E656E64436F6C756D6E292C6F3D6E2E6974656D732E6D61702828653D';
wwv_flow_imp.g_varchar2_table(244) := '3E7B636F6E737420743D7B6C6162656C3A652E6C6162656C2C696E73657274546578743A652E696E73657274546578747C7C652E6C6162656C2C736F7274546578743A652E736F7274546578742C66696C746572546578743A652E66696C746572546578';
wwv_flow_imp.g_varchar2_table(245) := '742C646F63756D656E746174696F6E3A652E646F63756D656E746174696F6E2C64657461696C3A652E64657461696C2C636F6D6D616E643A286E3D652E636F6D6D616E642C6E262622656469746F722E616374696F6E2E74726967676572537567676573';
wwv_flow_imp.g_varchar2_table(246) := '74223D3D3D6E2E636F6D6D616E643F7B69643A6E2E636F6D6D616E642C7469746C653A6E2E7469746C652C617267756D656E74733A6E2E617267756D656E74737D3A766F69642030292C72616E67653A692C6B696E643A707428652E6B696E64297D3B76';
wwv_flow_imp.g_varchar2_table(247) := '6172206E2C723B72657475726E20652E7465787445646974262628766F69642030213D3D28723D652E7465787445646974292E696E736572742626766F69642030213D3D722E7265706C6163653F742E72616E67653D7B696E736572743A667428652E74';
wwv_flow_imp.g_varchar2_table(248) := '657874456469742E696E73657274292C7265706C6163653A667428652E74657874456469742E7265706C616365297D3A742E72616E67653D667428652E74657874456469742E72616E6765292C742E696E73657274546578743D652E7465787445646974';
wwv_flow_imp.g_varchar2_table(249) := '2E6E657754657874292C652E6164646974696F6E616C546578744564697473262628742E6164646974696F6E616C5465787445646974733D652E6164646974696F6E616C5465787445646974732E6D6170286D7429292C652E696E736572745465787446';
wwv_flow_imp.g_varchar2_table(250) := '6F726D61743D3D3D62652E536E6970706574262628742E696E736572745465787452756C65733D752E6C616E6775616765732E436F6D706C6574696F6E4974656D496E736572745465787452756C652E496E736572744173536E6970706574292C747D29';
wwv_flow_imp.g_varchar2_table(251) := '293B72657475726E7B6973496E636F6D706C6574653A6E2E6973496E636F6D706C6574652C73756767657374696F6E733A6F7D7D29297D7D3B66756E6374696F6E206C742865297B696628652972657475726E7B6368617261637465723A652E636F6C75';
wwv_flow_imp.g_varchar2_table(252) := '6D6E2D312C6C696E653A652E6C696E654E756D6265722D317D7D66756E6374696F6E2068742865297B696628652972657475726E7B73746172743A7B6C696E653A652E73746172744C696E654E756D6265722D312C6368617261637465723A652E737461';
wwv_flow_imp.g_varchar2_table(253) := '7274436F6C756D6E2D317D2C656E643A7B6C696E653A652E656E644C696E654E756D6265722D312C6368617261637465723A652E656E64436F6C756D6E2D317D7D7D66756E6374696F6E2066742865297B696628652972657475726E206E657720752E52';
wwv_flow_imp.g_varchar2_table(254) := '616E676528652E73746172742E6C696E652B312C652E73746172742E6368617261637465722B312C652E656E642E6C696E652B312C652E656E642E6368617261637465722B31297D66756E6374696F6E2070742865297B636F6E737420743D752E6C616E';
wwv_flow_imp.g_varchar2_table(255) := '6775616765732E436F6D706C6574696F6E4974656D4B696E643B7377697463682865297B636173652076652E546578743A72657475726E20742E546578743B636173652076652E4D6574686F643A72657475726E20742E4D6574686F643B636173652076';
wwv_flow_imp.g_varchar2_table(256) := '652E46756E6374696F6E3A72657475726E20742E46756E6374696F6E3B636173652076652E436F6E7374727563746F723A72657475726E20742E436F6E7374727563746F723B636173652076652E4669656C643A72657475726E20742E4669656C643B63';
wwv_flow_imp.g_varchar2_table(257) := '6173652076652E5661726961626C653A72657475726E20742E5661726961626C653B636173652076652E436C6173733A72657475726E20742E436C6173733B636173652076652E496E746572666163653A72657475726E20742E496E746572666163653B';
wwv_flow_imp.g_varchar2_table(258) := '636173652076652E4D6F64756C653A72657475726E20742E4D6F64756C653B636173652076652E50726F70657274793A72657475726E20742E50726F70657274793B636173652076652E556E69743A72657475726E20742E556E69743B63617365207665';
wwv_flow_imp.g_varchar2_table(259) := '2E56616C75653A72657475726E20742E56616C75653B636173652076652E456E756D3A72657475726E20742E456E756D3B636173652076652E4B6579776F72643A72657475726E20742E4B6579776F72643B636173652076652E536E69707065743A7265';
wwv_flow_imp.g_varchar2_table(260) := '7475726E20742E536E69707065743B636173652076652E436F6C6F723A72657475726E20742E436F6C6F723B636173652076652E46696C653A72657475726E20742E46696C653B636173652076652E5265666572656E63653A72657475726E20742E5265';
wwv_flow_imp.g_varchar2_table(261) := '666572656E63657D72657475726E20742E50726F70657274797D66756E6374696F6E206D742865297B696628652972657475726E7B72616E67653A667428652E72616E6765292C746578743A652E6E6577546578747D7D7661722076743D636C6173737B';
wwv_flow_imp.g_varchar2_table(262) := '636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465486F76657228652C742C6E297B6C657420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E646F486F';
wwv_flow_imp.g_varchar2_table(263) := '76657228722E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B696628652972657475726E7B72616E67653A667428652E72616E6765292C636F6E74656E74733A627428652E636F6E74656E7473297D7D29297D7D3B66756E63';
wwv_flow_imp.g_varchar2_table(264) := '74696F6E206B742865297B72657475726E22737472696E67223D3D747970656F6620653F7B76616C75653A657D3A28743D65292626226F626A656374223D3D747970656F662074262622737472696E67223D3D747970656F6620742E6B696E643F22706C';
wwv_flow_imp.g_varchar2_table(265) := '61696E74657874223D3D3D652E6B696E643F7B76616C75653A652E76616C75652E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D2E215D2F672C225C5C242622297D3A7B76616C75653A652E76616C75657D3A7B76616C75653A226060';
wwv_flow_imp.g_varchar2_table(266) := '60222B652E6C616E67756167652B225C6E222B652E76616C75652B225C6E6060605C6E227D3B76617220747D66756E6374696F6E2062742865297B696628652972657475726E2041727261792E697341727261792865293F652E6D6170286B74293A5B6B';
wwv_flow_imp.g_varchar2_table(267) := '742865295D7D766172205F743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E74486967686C696768747328652C742C6E297B636F6E737420723D652E7572693B72657475';
wwv_flow_imp.g_varchar2_table(268) := '726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E66696E64446F63756D656E74486967686C696768747328722E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B696628652972657475726E20652E6D';
wwv_flow_imp.g_varchar2_table(269) := '61702828653D3E287B72616E67653A667428652E72616E6765292C6B696E643A777428652E6B696E64297D2929297D29297D7D3B66756E6374696F6E2077742865297B7377697463682865297B636173652050652E526561643A72657475726E20752E6C';
wwv_flow_imp.g_varchar2_table(270) := '616E6775616765732E446F63756D656E74486967686C696768744B696E642E526561643B636173652050652E57726974653A72657475726E20752E6C616E6775616765732E446F63756D656E74486967686C696768744B696E642E57726974653B636173';
wwv_flow_imp.g_varchar2_table(271) := '652050652E546578743A72657475726E20752E6C616E6775616765732E446F63756D656E74486967686C696768744B696E642E546578747D72657475726E20752E6C616E6775616765732E446F63756D656E74486967686C696768744B696E642E546578';
wwv_flow_imp.g_varchar2_table(272) := '747D7661722043743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446566696E6974696F6E28652C742C6E297B636F6E737420723D652E7572693B72657475726E20746869732E5F776F72';
wwv_flow_imp.g_varchar2_table(273) := '6B65722872292E7468656E2828653D3E652E66696E64446566696E6974696F6E28722E746F537472696E6728292C6C742874292929292E7468656E2828653D3E7B696628652972657475726E5B79742865295D7D29297D7D3B66756E6374696F6E207974';
wwv_flow_imp.g_varchar2_table(274) := '2865297B72657475726E7B7572693A752E5572692E706172736528652E757269292C72616E67653A667428652E72616E6765297D7D7661722045743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76';
wwv_flow_imp.g_varchar2_table(275) := '6964655265666572656E63657328652C742C6E2C72297B636F6E737420693D652E7572693B72657475726E20746869732E5F776F726B65722869292E7468656E2828653D3E652E66696E645265666572656E63657328692E746F537472696E6728292C6C';
wwv_flow_imp.g_varchar2_table(276) := '742874292929292E7468656E2828653D3E7B696628652972657475726E20652E6D6170287974297D29297D7D2C41743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F7669646552656E616D65456469';
wwv_flow_imp.g_varchar2_table(277) := '747328652C742C6E2C72297B636F6E737420693D652E7572693B72657475726E20746869732E5F776F726B65722869292E7468656E2828653D3E652E646F52656E616D6528692E746F537472696E6728292C6C742874292C6E2929292E7468656E282865';
wwv_flow_imp.g_varchar2_table(278) := '3D3E66756E6374696F6E2865297B69662821657C7C21652E6368616E6765732972657475726E3B6C657420743D5B5D3B666F72286C6574206E20696E20652E6368616E676573297B636F6E737420723D752E5572692E7061727365286E293B666F72286C';
wwv_flow_imp.g_varchar2_table(279) := '65742069206F6620652E6368616E6765735B6E5D29742E70757368287B7265736F757263653A722C76657273696F6E49643A766F696420302C74657874456469743A7B72616E67653A667428692E72616E6765292C746578743A692E6E6577546578747D';
wwv_flow_imp.g_varchar2_table(280) := '7D297D72657475726E7B65646974733A747D7D28652929297D7D2C78743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E7453796D626F6C7328652C74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(281) := '6E3D652E7572693B72657475726E20746869732E5F776F726B6572286E292E7468656E2828653D3E652E66696E64446F63756D656E7453796D626F6C73286E2E746F537472696E6728292929292E7468656E2828653D3E7B696628652972657475726E20';
wwv_flow_imp.g_varchar2_table(282) := '652E6D61702828653D3E226368696C6472656E22696E20653F49742865293A7B6E616D653A652E6E616D652C64657461696C3A22222C636F6E7461696E65724E616D653A652E636F6E7461696E65724E616D652C6B696E643A537428652E6B696E64292C';
wwv_flow_imp.g_varchar2_table(283) := '72616E67653A667428652E6C6F636174696F6E2E72616E6765292C73656C656374696F6E52616E67653A667428652E6C6F636174696F6E2E72616E6765292C746167733A5B5D7D29297D29297D7D3B66756E6374696F6E2049742865297B72657475726E';
wwv_flow_imp.g_varchar2_table(284) := '7B6E616D653A652E6E616D652C64657461696C3A652E64657461696C3F3F22222C6B696E643A537428652E6B696E64292C72616E67653A667428652E72616E6765292C73656C656374696F6E52616E67653A667428652E73656C656374696F6E52616E67';
wwv_flow_imp.g_varchar2_table(285) := '65292C746167733A652E746167733F3F5B5D2C6368696C6472656E3A28652E6368696C6472656E3F3F5B5D292E6D61702828653D3E497428652929297D7D66756E6374696F6E2053742865297B6C657420743D752E6C616E6775616765732E53796D626F';
wwv_flow_imp.g_varchar2_table(286) := '6C4B696E643B7377697463682865297B636173652046652E46696C653A72657475726E20742E46696C653B636173652046652E4D6F64756C653A72657475726E20742E4D6F64756C653B636173652046652E4E616D6573706163653A72657475726E2074';
wwv_flow_imp.g_varchar2_table(287) := '2E4E616D6573706163653B636173652046652E5061636B6167653A72657475726E20742E5061636B6167653B636173652046652E436C6173733A72657475726E20742E436C6173733B636173652046652E4D6574686F643A72657475726E20742E4D6574';
wwv_flow_imp.g_varchar2_table(288) := '686F643B636173652046652E50726F70657274793A72657475726E20742E50726F70657274793B636173652046652E4669656C643A72657475726E20742E4669656C643B636173652046652E436F6E7374727563746F723A72657475726E20742E436F6E';
wwv_flow_imp.g_varchar2_table(289) := '7374727563746F723B636173652046652E456E756D3A72657475726E20742E456E756D3B636173652046652E496E746572666163653A72657475726E20742E496E746572666163653B636173652046652E46756E6374696F6E3A72657475726E20742E46';
wwv_flow_imp.g_varchar2_table(290) := '756E6374696F6E3B636173652046652E5661726961626C653A72657475726E20742E5661726961626C653B636173652046652E436F6E7374616E743A72657475726E20742E436F6E7374616E743B636173652046652E537472696E673A72657475726E20';
wwv_flow_imp.g_varchar2_table(291) := '742E537472696E673B636173652046652E4E756D6265723A72657475726E20742E4E756D6265723B636173652046652E426F6F6C65616E3A72657475726E20742E426F6F6C65616E3B636173652046652E41727261793A72657475726E20742E41727261';
wwv_flow_imp.g_varchar2_table(292) := '797D72657475726E20742E46756E6374696F6E7D7661722054743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F766964654C696E6B7328652C74297B636F6E7374206E3D652E7572693B7265747572';
wwv_flow_imp.g_varchar2_table(293) := '6E20746869732E5F776F726B6572286E292E7468656E2828653D3E652E66696E64446F63756D656E744C696E6B73286E2E746F537472696E6728292929292E7468656E2828653D3E7B696628652972657475726E7B6C696E6B733A652E6D61702828653D';
wwv_flow_imp.g_varchar2_table(294) := '3E287B72616E67653A667428652E72616E6765292C75726C3A652E7461726765747D2929297D7D29297D7D2C52743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E74466F';
wwv_flow_imp.g_varchar2_table(295) := '726D617474696E67456469747328652C742C6E297B636F6E737420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E666F726D617428722E746F537472696E6728292C6E756C6C2C4D7428742929';
wwv_flow_imp.g_varchar2_table(296) := '2E7468656E2828653D3E7B69662865262630213D3D652E6C656E6774682972657475726E20652E6D6170286D74297D292929297D7D2C44743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D652C746869732E6361';
wwv_flow_imp.g_varchar2_table(297) := '6E466F726D61744D756C7469706C6552616E6765733D21317D70726F76696465446F63756D656E7452616E6765466F726D617474696E67456469747328652C742C6E2C72297B636F6E737420693D652E7572693B72657475726E20746869732E5F776F72';
wwv_flow_imp.g_varchar2_table(298) := '6B65722869292E7468656E2828653D3E652E666F726D617428692E746F537472696E6728292C68742874292C4D74286E29292E7468656E2828653D3E7B69662865262630213D3D652E6C656E6774682972657475726E20652E6D6170286D74297D292929';
wwv_flow_imp.g_varchar2_table(299) := '297D7D3B66756E6374696F6E204D742865297B72657475726E7B74616253697A653A652E74616253697A652C696E736572745370616365733A652E696E736572745370616365737D7D7661722050742C6A743D636C6173737B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(300) := '2865297B746869732E5F776F726B65723D657D70726F76696465446F63756D656E74436F6C6F727328652C74297B636F6E7374206E3D652E7572693B72657475726E20746869732E5F776F726B6572286E292E7468656E2828653D3E652E66696E64446F';
wwv_flow_imp.g_varchar2_table(301) := '63756D656E74436F6C6F7273286E2E746F537472696E6728292929292E7468656E2828653D3E7B696628652972657475726E20652E6D61702828653D3E287B636F6C6F723A652E636F6C6F722C72616E67653A667428652E72616E6765297D2929297D29';
wwv_flow_imp.g_varchar2_table(302) := '297D70726F76696465436F6C6F7250726573656E746174696F6E7328652C742C6E297B636F6E737420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E676574436F6C6F7250726573656E746174';
wwv_flow_imp.g_varchar2_table(303) := '696F6E7328722E746F537472696E6728292C742E636F6C6F722C687428742E72616E6765292929292E7468656E2828653D3E7B696628652972657475726E20652E6D61702828653D3E7B6C657420743D7B6C6162656C3A652E6C6162656C7D3B72657475';
wwv_flow_imp.g_varchar2_table(304) := '726E20652E7465787445646974262628742E74657874456469743D6D7428652E746578744564697429292C652E6164646974696F6E616C546578744564697473262628742E6164646974696F6E616C5465787445646974733D652E6164646974696F6E61';
wwv_flow_imp.g_varchar2_table(305) := '6C5465787445646974732E6D6170286D7429292C747D29297D29297D7D2C4C743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F76696465466F6C64696E6752616E67657328652C742C6E297B636F6E';
wwv_flow_imp.g_varchar2_table(306) := '737420723D652E7572693B72657475726E20746869732E5F776F726B65722872292E7468656E2828653D3E652E676574466F6C64696E6752616E67657328722E746F537472696E6728292C742929292E7468656E2828653D3E7B69662865297265747572';
wwv_flow_imp.g_varchar2_table(307) := '6E20652E6D61702828653D3E7B636F6E737420743D7B73746172743A652E73746172744C696E652B312C656E643A652E656E644C696E652B317D3B72657475726E20766F69642030213D3D652E6B696E64262628742E6B696E643D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(308) := '65297B7377697463682865297B6361736520532E436F6D6D656E743A72657475726E20752E6C616E6775616765732E466F6C64696E6752616E67654B696E642E436F6D6D656E743B6361736520532E496D706F7274733A72657475726E20752E6C616E67';
wwv_flow_imp.g_varchar2_table(309) := '75616765732E466F6C64696E6752616E67654B696E642E496D706F7274733B6361736520532E526567696F6E3A72657475726E20752E6C616E6775616765732E466F6C64696E6752616E67654B696E642E526567696F6E7D7D28652E6B696E6429292C74';
wwv_flow_imp.g_varchar2_table(310) := '7D29297D29297D7D2C46743D636C6173737B636F6E7374727563746F722865297B746869732E5F776F726B65723D657D70726F7669646553656C656374696F6E52616E67657328652C742C6E297B636F6E737420723D652E7572693B72657475726E2074';
wwv_flow_imp.g_varchar2_table(311) := '6869732E5F776F726B65722872292E7468656E2828653D3E652E67657453656C656374696F6E52616E67657328722E746F537472696E6728292C742E6D6170286C74292929292E7468656E2828653D3E7B696628652972657475726E20652E6D61702828';
wwv_flow_imp.g_varchar2_table(312) := '653D3E7B636F6E737420743D5B5D3B666F72283B653B29742E70757368287B72616E67653A667428652E72616E6765297D292C653D652E706172656E743B72657475726E20747D29297D29297D7D3B66756E6374696F6E204F742865297B72657475726E';
wwv_flow_imp.g_varchar2_table(313) := '2033323D3D3D657C7C393D3D3D657C7C31313D3D3D657C7C31323D3D3D657C7C3136303D3D3D657C7C353736303D3D3D657C7C653E3D383139322626653C3D383230337C7C383233393D3D3D657C7C383238373D3D3D657C7C31323238383D3D3D657C7C';
wwv_flow_imp.g_varchar2_table(314) := '36353237393D3D3D657D66756E6374696F6E204E742865297B72657475726E2031303D3D3D657C7C31333D3D3D657C7C383233323D3D3D657C7C383233333D3D3D657D66756E6374696F6E2057742865297B72657475726E20653E3D34382626653C3D35';
wwv_flow_imp.g_varchar2_table(315) := '377D2850747C7C2850743D7B7D29292E44454641554C543D7B616C6C6F77547261696C696E67436F6D6D613A21317D3B7661722055743D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D2131293B766172206E3D652E6C656E67';
wwv_flow_imp.g_varchar2_table(316) := '74682C723D302C693D22222C6F3D302C613D31362C733D302C633D302C753D302C643D302C673D303B66756E6374696F6E206C28742C6E297B666F722876617220693D302C6F3D303B693C747C7C216E3B297B76617220613D652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(317) := '742872293B696628613E3D34382626613C3D3537296F3D31362A6F2B612D34383B656C736520696628613E3D36352626613C3D3730296F3D31362A6F2B612D36352B31303B656C73657B6966282128613E3D39372626613C3D3130322929627265616B3B';
wwv_flow_imp.g_varchar2_table(318) := '6F3D31362A6F2B612D39372B31307D722B2B2C692B2B7D72657475726E20693C742626286F3D2D31292C6F7D66756E6374696F6E206828297B696628693D22222C673D302C6F3D722C633D732C643D752C723E3D6E2972657475726E206F3D6E2C613D31';
wwv_flow_imp.g_varchar2_table(319) := '373B76617220743D652E63686172436F646541742872293B6966284F74287429297B646F7B722B2B2C692B3D537472696E672E66726F6D43686172436F64652874292C743D652E63686172436F646541742872297D7768696C65284F74287429293B7265';
wwv_flow_imp.g_varchar2_table(320) := '7475726E20613D31357D6966284E742874292972657475726E20722B2B2C692B3D537472696E672E66726F6D43686172436F64652874292C31333D3D3D74262631303D3D3D652E63686172436F64654174287229262628722B2B2C692B3D225C6E22292C';
wwv_flow_imp.g_varchar2_table(321) := '732B2B2C753D722C613D31343B7377697463682874297B63617365203132333A72657475726E20722B2B2C613D313B63617365203132353A72657475726E20722B2B2C613D323B636173652039313A72657475726E20722B2B2C613D333B636173652039';
wwv_flow_imp.g_varchar2_table(322) := '333A72657475726E20722B2B2C613D343B636173652035383A72657475726E20722B2B2C613D363B636173652034343A72657475726E20722B2B2C613D353B636173652033343A72657475726E20722B2B2C693D66756E6374696F6E28297B666F722876';
wwv_flow_imp.g_varchar2_table(323) := '617220743D22222C693D723B3B297B696628723E3D6E297B742B3D652E737562737472696E6728692C72292C673D323B627265616B7D766172206F3D652E63686172436F646541742872293B69662833343D3D3D6F297B742B3D652E737562737472696E';
wwv_flow_imp.g_varchar2_table(324) := '6728692C72292C722B2B3B627265616B7D6966283932213D3D6F297B6966286F3E3D3026266F3C3D3331297B6966284E74286F29297B742B3D652E737562737472696E6728692C72292C673D323B627265616B7D673D367D722B2B7D656C73657B696628';
wwv_flow_imp.g_varchar2_table(325) := '742B3D652E737562737472696E6728692C72292C2B2B723E3D6E297B673D323B627265616B7D73776974636828652E63686172436F6465417428722B2B29297B636173652033343A742B3D2722273B627265616B3B636173652039323A742B3D225C5C22';
wwv_flow_imp.g_varchar2_table(326) := '3B627265616B3B636173652034373A742B3D222F223B627265616B3B636173652039383A742B3D225C62223B627265616B3B63617365203130323A742B3D225C66223B627265616B3B63617365203131303A742B3D225C6E223B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(327) := '203131343A742B3D225C72223B627265616B3B63617365203131363A742B3D225C74223B627265616B3B63617365203131373A76617220613D6C28342C2130293B613E3D303F742B3D537472696E672E66726F6D43686172436F64652861293A673D343B';
wwv_flow_imp.g_varchar2_table(328) := '627265616B3B64656661756C743A673D357D693D727D7D72657475726E20747D28292C613D31303B636173652034373A76617220683D722D313B69662834373D3D3D652E63686172436F6465417428722B3129297B666F7228722B3D323B723C6E262621';
wwv_flow_imp.g_varchar2_table(329) := '4E7428652E63686172436F64654174287229293B29722B2B3B72657475726E20693D652E737562737472696E6728682C72292C613D31327D69662834323D3D3D652E63686172436F6465417428722B3129297B722B3D323B666F722876617220703D6E2D';
wwv_flow_imp.g_varchar2_table(330) := '312C6D3D21313B723C703B297B76617220763D652E63686172436F646541742872293B69662834323D3D3D76262634373D3D3D652E63686172436F6465417428722B3129297B722B3D322C6D3D21303B627265616B7D722B2B2C4E742876292626283133';
wwv_flow_imp.g_varchar2_table(331) := '3D3D3D76262631303D3D3D652E63686172436F646541742872292626722B2B2C732B2B2C753D72297D72657475726E206D7C7C28722B2B2C673D31292C693D652E737562737472696E6728682C72292C613D31337D72657475726E20692B3D537472696E';
wwv_flow_imp.g_varchar2_table(332) := '672E66726F6D43686172436F64652874292C722B2B2C613D31363B636173652034353A696628692B3D537472696E672E66726F6D43686172436F64652874292C2B2B723D3D3D6E7C7C21577428652E63686172436F64654174287229292972657475726E';
wwv_flow_imp.g_varchar2_table(333) := '20613D31363B636173652034383A636173652034393A636173652035303A636173652035313A636173652035323A636173652035333A636173652035343A636173652035353A636173652035363A636173652035373A72657475726E20692B3D66756E63';
wwv_flow_imp.g_varchar2_table(334) := '74696F6E28297B76617220743D723B69662834383D3D3D652E63686172436F6465417428722929722B2B3B656C736520666F7228722B2B3B723C652E6C656E6774682626577428652E63686172436F64654174287229293B29722B2B3B696628723C652E';
wwv_flow_imp.g_varchar2_table(335) := '6C656E677468262634363D3D3D652E63686172436F64654174287229297B69662821282B2B723C652E6C656E6774682626577428652E63686172436F6465417428722929292972657475726E20673D332C652E737562737472696E6728742C72293B666F';
wwv_flow_imp.g_varchar2_table(336) := '7228722B2B3B723C652E6C656E6774682626577428652E63686172436F64654174287229293B29722B2B7D766172206E3D723B696628723C652E6C656E67746826262836393D3D3D652E63686172436F646541742872297C7C3130313D3D3D652E636861';
wwv_flow_imp.g_varchar2_table(337) := '72436F646541742872292929696628282B2B723C652E6C656E677468262634333D3D3D652E63686172436F646541742872297C7C34353D3D3D652E63686172436F64654174287229292626722B2B2C723C652E6C656E6774682626577428652E63686172';
wwv_flow_imp.g_varchar2_table(338) := '436F6465417428722929297B666F7228722B2B3B723C652E6C656E6774682626577428652E63686172436F64654174287229293B29722B2B3B6E3D727D656C736520673D333B72657475726E20652E737562737472696E6728742C6E297D28292C613D31';
wwv_flow_imp.g_varchar2_table(339) := '313B64656661756C743A666F72283B723C6E2626662874293B29722B2B2C743D652E63686172436F646541742872293B6966286F213D3D72297B73776974636828693D652E737562737472696E67286F2C7229297B636173652274727565223A72657475';
wwv_flow_imp.g_varchar2_table(340) := '726E20613D383B636173652266616C7365223A72657475726E20613D393B63617365226E756C6C223A72657475726E20613D377D72657475726E20613D31367D72657475726E20692B3D537472696E672E66726F6D43686172436F64652874292C722B2B';
wwv_flow_imp.g_varchar2_table(341) := '2C613D31367D7D66756E6374696F6E20662865297B6966284F742865297C7C4E742865292972657475726E21313B7377697463682865297B63617365203132353A636173652039333A63617365203132333A636173652039313A636173652033343A6361';
wwv_flow_imp.g_varchar2_table(342) := '73652035383A636173652034343A636173652034373A72657475726E21317D72657475726E21307D72657475726E7B736574506F736974696F6E3A66756E6374696F6E2865297B723D652C693D22222C6F3D302C613D31362C673D307D2C676574506F73';
wwv_flow_imp.g_varchar2_table(343) := '6974696F6E3A66756E6374696F6E28297B72657475726E20727D2C7363616E3A743F66756E6374696F6E28297B76617220653B646F7B653D6828297D7768696C6528653E3D31322626653C3D3135293B72657475726E20657D3A682C676574546F6B656E';
wwv_flow_imp.g_varchar2_table(344) := '3A66756E6374696F6E28297B72657475726E20617D2C676574546F6B656E56616C75653A66756E6374696F6E28297B72657475726E20697D2C676574546F6B656E4F66667365743A66756E6374696F6E28297B72657475726E206F7D2C676574546F6B65';
wwv_flow_imp.g_varchar2_table(345) := '6E4C656E6774683A66756E6374696F6E28297B72657475726E20722D6F7D2C676574546F6B656E53746172744C696E653A66756E6374696F6E28297B72657475726E20637D2C676574546F6B656E53746172744368617261637465723A66756E6374696F';
wwv_flow_imp.g_varchar2_table(346) := '6E28297B72657475726E206F2D647D2C676574546F6B656E4572726F723A66756E6374696F6E28297B72657475726E20677D7D7D3B7661722056742C48743D2264656C696D697465722E627261636B65742E6A736F6E222C4B743D2264656C696D697465';
wwv_flow_imp.g_varchar2_table(347) := '722E61727261792E6A736F6E222C7A743D2264656C696D697465722E636F6C6F6E2E6A736F6E222C71743D2264656C696D697465722E636F6D6D612E6A736F6E222C58743D226B6579776F72642E6A736F6E222C42743D226B6579776F72642E6A736F6E';
wwv_flow_imp.g_varchar2_table(348) := '222C24743D22737472696E672E76616C75652E6A736F6E222C4A743D226E756D6265722E6A736F6E222C51743D22737472696E672E6B65792E6A736F6E222C47743D22636F6D6D656E742E626C6F636B2E6A736F6E222C59743D22636F6D6D656E742E6C';
wwv_flow_imp.g_varchar2_table(349) := '696E652E6A736F6E222C5A743D636C61737320657B636F6E7374727563746F7228652C74297B746869732E706172656E743D652C746869732E747970653D747D73746174696320706F702865297B72657475726E20653F652E706172656E743A6E756C6C';
wwv_flow_imp.g_varchar2_table(350) := '7D737461746963207075736828742C6E297B72657475726E206E6577206528742C6E297D73746174696320657175616C7328652C74297B6966282165262621742972657475726E21303B69662821657C7C21742972657475726E21313B666F72283B6526';
wwv_flow_imp.g_varchar2_table(351) := '26743B297B696628653D3D3D742972657475726E21303B696628652E74797065213D3D742E747970652972657475726E21313B653D652E706172656E742C743D742E706172656E747D72657475726E21307D7D2C656E3D636C61737320657B636F6E7374';
wwv_flow_imp.g_varchar2_table(352) := '727563746F7228652C742C6E2C72297B746869732E5F73746174653D652C746869732E7363616E4572726F723D742C746869732E6C617374576173436F6C6F6E3D6E2C746869732E706172656E74733D727D636C6F6E6528297B72657475726E206E6577';
wwv_flow_imp.g_varchar2_table(353) := '206528746869732E5F73746174652C746869732E7363616E4572726F722C746869732E6C617374576173436F6C6F6E2C746869732E706172656E7473297D657175616C732874297B72657475726E20743D3D3D746869737C7C2121287426267420696E73';
wwv_flow_imp.g_varchar2_table(354) := '74616E63656F662065292626746869732E7363616E4572726F723D3D3D742E7363616E4572726F722626746869732E6C617374576173436F6C6F6E3D3D3D742E6C617374576173436F6C6F6E26265A742E657175616C7328746869732E706172656E7473';
wwv_flow_imp.g_varchar2_table(355) := '2C742E706172656E7473297D67657453746174654461746128297B72657475726E20746869732E5F73746174657D7365745374617465446174612865297B746869732E5F73746174653D657D7D3B66756E6374696F6E20746E28297B72657475726E206E';
wwv_flow_imp.g_varchar2_table(356) := '65772050726F6D697365282828652C74293D3E7B6966282156742972657475726E207428224A534F4E206E6F7420726567697374657265642122293B65285674297D29297D766172206E6E3D636C61737320657874656E64732075747B636F6E73747275';
wwv_flow_imp.g_varchar2_table(357) := '63746F7228652C742C6E297B737570657228652C742C6E2E6F6E4469644368616E6765292C746869732E5F646973706F7361626C65732E7075736828752E656469746F722E6F6E57696C6C446973706F73654D6F64656C2828653D3E7B746869732E5F72';
wwv_flow_imp.g_varchar2_table(358) := '65736574536368656D6128652E757269297D2929292C746869732E5F646973706F7361626C65732E7075736828752E656469746F722E6F6E4469644368616E67654D6F64656C4C616E67756167652828653D3E7B746869732E5F7265736574536368656D';
wwv_flow_imp.g_varchar2_table(359) := '6128652E6D6F64656C2E757269297D2929297D5F7265736574536368656D612865297B746869732E5F776F726B657228292E7468656E2828743D3E7B742E7265736574536368656D6128652E746F537472696E672829297D29297D7D3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(360) := '6E20726E2865297B636F6E737420743D5B5D2C6E3D5B5D2C723D6E6577206F652865293B66756E6374696F6E206928297B636F6E73747B6C616E677561676549643A742C6D6F6465436F6E66696775726174696F6E3A727D3D653B76617220693B616E28';
wwv_flow_imp.g_varchar2_table(361) := '6E292C722E646F63756D656E74466F726D617474696E67456469747326266E2E7075736828752E6C616E6775616765732E7265676973746572446F63756D656E74466F726D617474696E674564697450726F766964657228742C6E657720527428567429';
wwv_flow_imp.g_varchar2_table(362) := '29292C722E646F63756D656E7452616E6765466F726D617474696E67456469747326266E2E7075736828752E6C616E6775616765732E7265676973746572446F63756D656E7452616E6765466F726D617474696E674564697450726F766964657228742C';
wwv_flow_imp.g_varchar2_table(363) := '6E65772044742856742929292C722E636F6D706C6574696F6E4974656D7326266E2E7075736828752E6C616E6775616765732E7265676973746572436F6D706C6574696F6E4974656D50726F766964657228742C6E65772067742856742C5B2220222C22';
wwv_flow_imp.g_varchar2_table(364) := '3A222C2722275D2929292C722E686F7665727326266E2E7075736828752E6C616E6775616765732E7265676973746572486F76657250726F766964657228742C6E65772076742856742929292C722E646F63756D656E7453796D626F6C7326266E2E7075';
wwv_flow_imp.g_varchar2_table(365) := '736828752E6C616E6775616765732E7265676973746572446F63756D656E7453796D626F6C50726F766964657228742C6E65772078742856742929292C722E746F6B656E7326266E2E7075736828752E6C616E6775616765732E736574546F6B656E7350';
wwv_flow_imp.g_varchar2_table(366) := '726F766964657228742C28693D21302C7B676574496E697469616C53746174653A28293D3E6E657720656E286E756C6C2C6E756C6C2C21312C6E756C6C292C746F6B656E697A653A28652C74293D3E66756E6374696F6E28652C742C6E2C723D30297B6C';
wwv_flow_imp.g_varchar2_table(367) := '657420693D302C6F3D21313B737769746368286E2E7363616E4572726F72297B6361736520323A743D2722272B742C693D313B627265616B3B6361736520313A743D222F2A222B742C693D327D636F6E737420613D55742874293B6C657420733D6E2E6C';
wwv_flow_imp.g_varchar2_table(368) := '617374576173436F6C6F6E2C633D6E2E706172656E74733B636F6E737420753D7B746F6B656E733A5B5D2C656E6453746174653A6E2E636C6F6E6528297D3B666F72283B3B297B6C657420643D722B612E676574506F736974696F6E28292C673D22223B';
wwv_flow_imp.g_varchar2_table(369) := '636F6E7374206C3D612E7363616E28293B69662831373D3D3D6C29627265616B3B696628643D3D3D722B612E676574506F736974696F6E2829297468726F77206E6577204572726F7228225363616E6E657220646964206E6F7420616476616E63652C20';
wwv_flow_imp.g_varchar2_table(370) := '6E65787420332063686172616374657273206172653A20222B742E73756273747228612E676574506F736974696F6E28292C3329293B737769746368286F262628642D3D69292C6F3D693E302C6C297B6361736520313A633D5A742E7075736828632C30';
wwv_flow_imp.g_varchar2_table(371) := '292C673D48742C733D21313B627265616B3B6361736520323A633D5A742E706F702863292C673D48742C733D21313B627265616B3B6361736520333A633D5A742E7075736828632C31292C673D4B742C733D21313B627265616B3B6361736520343A633D';
wwv_flow_imp.g_varchar2_table(372) := '5A742E706F702863292C673D4B742C733D21313B627265616B3B6361736520363A673D7A742C733D21303B627265616B3B6361736520353A673D71742C733D21313B627265616B3B6361736520383A6361736520393A673D58742C733D21313B62726561';
wwv_flow_imp.g_varchar2_table(373) := '6B3B6361736520373A673D42742C733D21313B627265616B3B636173652031303A636F6E737420653D633F632E747970653A303B673D737C7C313D3D3D653F24743A51742C733D21313B627265616B3B636173652031313A673D4A742C733D21317D6966';
wwv_flow_imp.g_varchar2_table(374) := '286529737769746368286C297B636173652031323A673D59743B627265616B3B636173652031333A673D47747D752E656E6453746174653D6E657720656E286E2E67657453746174654461746128292C612E676574546F6B656E4572726F7228292C732C';
wwv_flow_imp.g_varchar2_table(375) := '63292C752E746F6B656E732E70757368287B7374617274496E6465783A642C73636F7065733A677D297D72657475726E20757D28692C652C74297D2929292C722E636F6C6F727326266E2E7075736828752E6C616E6775616765732E7265676973746572';
wwv_flow_imp.g_varchar2_table(376) := '436F6C6F7250726F766964657228742C6E6577206A742856742929292C722E666F6C64696E6752616E67657326266E2E7075736828752E6C616E6775616765732E7265676973746572466F6C64696E6752616E676550726F766964657228742C6E657720';
wwv_flow_imp.g_varchar2_table(377) := '4C742856742929292C722E646961676E6F737469637326266E2E70757368286E6577206E6E28742C56742C6529292C722E73656C656374696F6E52616E67657326266E2E7075736828752E6C616E6775616765732E726567697374657253656C65637469';
wwv_flow_imp.g_varchar2_table(378) := '6F6E52616E676550726F766964657228742C6E65772046742856742929297D742E707573682872292C56743D282E2E2E65293D3E722E6765744C616E677561676553657276696365576F726B6572282E2E2E65292C6928292C742E7075736828752E6C61';
wwv_flow_imp.g_varchar2_table(379) := '6E6775616765732E7365744C616E6775616765436F6E66696775726174696F6E28652E6C616E677561676549642C736E29293B6C6574206F3D652E6D6F6465436F6E66696775726174696F6E3B72657475726E20652E6F6E4469644368616E6765282865';
wwv_flow_imp.g_varchar2_table(380) := '3D3E7B652E6D6F6465436F6E66696775726174696F6E213D3D6F2626286F3D652E6D6F6465436F6E66696775726174696F6E2C692829297D29292C742E70757368286F6E286E29292C6F6E2874297D66756E6374696F6E206F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(381) := '7B646973706F73653A28293D3E616E2865297D7D66756E6374696F6E20616E2865297B666F72283B652E6C656E6774683B29652E706F7028292E646973706F736528297D76617220736E3D7B776F72645061747465726E3A2F282D3F5C642A5C2E5C645C';
wwv_flow_imp.g_varchar2_table(382) := '772A297C285B5E5C5B5C7B5C5D5C7D5C3A5C225C2C5C735D2B292F672C636F6D6D656E74733A7B6C696E65436F6D6D656E743A222F2F222C626C6F636B436F6D6D656E743A5B222F2A222C222A2F225D7D2C627261636B6574733A5B5B227B222C227D22';
wwv_flow_imp.g_varchar2_table(383) := '5D2C5B225B222C225D225D5D2C6175746F436C6F73696E6750616972733A5B7B6F70656E3A227B222C636C6F73653A227D222C6E6F74496E3A5B22737472696E67225D7D2C7B6F70656E3A225B222C636C6F73653A225D222C6E6F74496E3A5B22737472';
wwv_flow_imp.g_varchar2_table(384) := '696E67225D7D2C7B6F70656E3A2722272C636C6F73653A2722272C6E6F74496E3A5B22737472696E67225D7D5D7D7D7D5D293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5448866774531699)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/839.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C6561736520736565203931342E6D696E2E6A732E4C4943454E53452E747874202A2F0A2275736520737472696374223B2873656C662E7765627061636B4368756E6B62706D6E';
wwv_flow_imp.g_varchar2_table(2) := '4D6F64656C65723D73656C662E7765627061636B4368756E6B62706D6E4D6F64656C65727C7C5B5D292E70757368285B5B3931345D2C7B313931343A28452C542C52293D3E7B522E722854292C522E6428542C7B636F6E663A28293D3E412C6C616E6775';
wwv_flow_imp.g_varchar2_table(3) := '6167653A28293D3E497D293B76617220413D7B636F6D6D656E74733A7B6C696E65436F6D6D656E743A222D2D222C626C6F636B436F6D6D656E743A5B222F2A222C222A2F225D7D2C627261636B6574733A5B5B227B222C227D225D2C5B225B222C225D22';
wwv_flow_imp.g_varchar2_table(4) := '5D2C5B2228222C2229225D5D2C6175746F436C6F73696E6750616972733A5B7B6F70656E3A227B222C636C6F73653A227D227D2C7B6F70656E3A225B222C636C6F73653A225D227D2C7B6F70656E3A2228222C636C6F73653A2229227D2C7B6F70656E3A';
wwv_flow_imp.g_varchar2_table(5) := '2722272C636C6F73653A2722277D2C7B6F70656E3A2227222C636C6F73653A2227227D5D2C737572726F756E64696E6750616972733A5B7B6F70656E3A227B222C636C6F73653A227D227D2C7B6F70656E3A225B222C636C6F73653A225D227D2C7B6F70';
wwv_flow_imp.g_varchar2_table(6) := '656E3A2228222C636C6F73653A2229227D2C7B6F70656E3A2722272C636C6F73653A2722277D2C7B6F70656E3A2227222C636C6F73653A2227227D5D7D2C493D7B64656661756C74546F6B656E3A22222C746F6B656E506F73746669783A222E73716C22';
wwv_flow_imp.g_varchar2_table(7) := '2C69676E6F7265436173653A21302C627261636B6574733A5B7B6F70656E3A225B222C636C6F73653A225D222C746F6B656E3A2264656C696D697465722E737175617265227D2C7B6F70656E3A2228222C636C6F73653A2229222C746F6B656E3A226465';
wwv_flow_imp.g_varchar2_table(8) := '6C696D697465722E706172656E746865736973227D5D2C6B6579776F7264733A5B2241424F5254222C224142534F4C555445222C22414354494F4E222C22414441222C22414444222C224146544552222C22414C4C222C22414C4C4F43415445222C2241';
wwv_flow_imp.g_varchar2_table(9) := '4C544552222C22414C57415953222C22414E414C595A45222C22414E44222C22414E59222C22415245222C224153222C22415343222C22415353455254494F4E222C224154222C22415454414348222C22415554484F52495A4154494F4E222C22415554';
wwv_flow_imp.g_varchar2_table(10) := '4F494E4352454D454E54222C22415647222C224241434B5550222C224245464F5245222C22424547494E222C224245545745454E222C22424954222C224249545F4C454E475448222C22424F5448222C22425245414B222C2242524F575345222C224255';
wwv_flow_imp.g_varchar2_table(11) := '4C4B222C224259222C2243415343414445222C224341534341444544222C2243415345222C2243415354222C22434154414C4F47222C2243484152222C22434841524143544552222C224348415241435445525F4C454E475448222C22434841525F4C45';
wwv_flow_imp.g_varchar2_table(12) := '4E475448222C22434845434B222C22434845434B504F494E54222C22434C4F5345222C22434C55535445524544222C22434F414C45534345222C22434F4C4C415445222C22434F4C4C4154494F4E222C22434F4C554D4E222C22434F4D4D4954222C2243';
wwv_flow_imp.g_varchar2_table(13) := '4F4D50555445222C22434F4E464C494354222C22434F4E4E454354222C22434F4E4E454354494F4E222C22434F4E53545241494E54222C22434F4E53545241494E5453222C22434F4E5441494E53222C22434F4E5441494E535441424C45222C22434F4E';
wwv_flow_imp.g_varchar2_table(14) := '54494E5545222C22434F4E56455254222C22434F52524553504F4E44494E47222C22434F554E54222C22435245415445222C2243524F5353222C2243555252454E54222C2243555252454E545F44415445222C2243555252454E545F54494D45222C2243';
wwv_flow_imp.g_varchar2_table(15) := '555252454E545F54494D455354414D50222C2243555252454E545F55534552222C22435552534F52222C224441544142415345222C2244415445222C22444159222C2244424343222C224445414C4C4F43415445222C22444543222C22444543494D414C';
wwv_flow_imp.g_varchar2_table(16) := '222C224445434C415245222C2244454641554C54222C2244454645525241424C45222C224445464552524544222C2244454C455445222C2244454E59222C2244455343222C224445534352494245222C2244455343524950544F52222C22444554414348';
wwv_flow_imp.g_varchar2_table(17) := '222C22444941474E4F5354494353222C22444953434F4E4E454354222C224449534B222C2244495354494E4354222C224449535452494255544544222C22444F222C22444F4D41494E222C22444F55424C45222C2244524F50222C2244554D50222C2245';
wwv_flow_imp.g_varchar2_table(18) := '414348222C22454C5345222C22454E44222C22454E442D45584543222C224552524C564C222C22455343415045222C22455843455054222C22455843455054494F4E222C224558434C554445222C224558434C5553495645222C2245584543222C224558';
wwv_flow_imp.g_varchar2_table(19) := '4543555445222C22455849535453222C2245584954222C224558504C41494E222C2245585445524E414C222C2245585452414354222C224641494C222C2246414C5345222C224645544348222C2246494C45222C2246494C4C464143544F52222C224649';
wwv_flow_imp.g_varchar2_table(20) := '4C544552222C224649525354222C22464C4F4154222C22464F4C4C4F57494E47222C22464F52222C22464F524549474E222C22464F525452414E222C22464F554E44222C224652454554455854222C2246524545544558545441424C45222C2246524F4D';
wwv_flow_imp.g_varchar2_table(21) := '222C2246554C4C222C2246554E4354494F4E222C2247454E455241544544222C22474554222C22474C4F42222C22474C4F42414C222C22474F222C22474F544F222C224752414E54222C2247524F5550222C2247524F555053222C22484156494E47222C';
wwv_flow_imp.g_varchar2_table(22) := '22484F4C444C4F434B222C22484F5552222C224944454E54495459222C224944454E54495459434F4C222C224944454E544954595F494E53455254222C224946222C2249474E4F5245222C22494D4D454449415445222C22494E222C22494E434C554445';
wwv_flow_imp.g_varchar2_table(23) := '222C22494E444558222C22494E4445584544222C22494E44494341544F52222C22494E495449414C4C59222C22494E4E4552222C22494E505554222C22494E53454E534954495645222C22494E53455254222C22494E5354454144222C22494E54222C22';
wwv_flow_imp.g_varchar2_table(24) := '494E5445474552222C22494E54455253454354222C22494E54455256414C222C22494E544F222C224953222C2249534E554C4C222C2249534F4C4154494F4E222C224A4F494E222C224B4559222C224B494C4C222C224C414E4755414745222C224C4153';
wwv_flow_imp.g_varchar2_table(25) := '54222C224C454144494E47222C224C454654222C224C4556454C222C224C494B45222C224C494D4954222C224C494E454E4F222C224C4F4144222C224C4F43414C222C224C4F574552222C224D41544348222C224D4154455249414C495A4544222C224D';
wwv_flow_imp.g_varchar2_table(26) := '4158222C224D45524745222C224D494E222C224D494E555445222C224D4F44554C45222C224D4F4E5448222C224E414D4553222C224E4154494F4E414C222C224E41545552414C222C224E43484152222C224E455854222C224E4F222C224E4F43484543';
wwv_flow_imp.g_varchar2_table(27) := '4B222C224E4F4E434C55535445524544222C224E4F4E45222C224E4F54222C224E4F5448494E47222C224E4F544E554C4C222C224E554C4C222C224E554C4C4946222C224E554C4C53222C224E554D45524943222C224F435445545F4C454E475448222C';
wwv_flow_imp.g_varchar2_table(28) := '224F46222C224F4646222C224F4646534554222C224F464653455453222C224F4E222C224F4E4C59222C224F50454E222C224F50454E44415441534F55524345222C224F50454E5155455259222C224F50454E524F57534554222C224F50454E584D4C22';
wwv_flow_imp.g_varchar2_table(29) := '2C224F5054494F4E222C224F52222C224F52444552222C224F5448455253222C224F55544552222C224F5554505554222C224F564552222C224F5645524C415053222C22504144222C225041525449414C222C22504152544954494F4E222C2250415343';
wwv_flow_imp.g_varchar2_table(30) := '414C222C2250455243454E54222C225049564F54222C22504C414E222C22504F534954494F4E222C22505241474D41222C22505245434544494E47222C22505245434953494F4E222C2250524550415245222C225052455345525645222C225052494D41';
wwv_flow_imp.g_varchar2_table(31) := '5259222C225052494E54222C225052494F52222C2250524956494C45474553222C2250524F43222C2250524F434544555245222C225055424C4943222C225155455259222C225241495345222C22524149534552524F52222C2252414E4745222C225245';
wwv_flow_imp.g_varchar2_table(32) := '4144222C225245414454455854222C225245414C222C225245434F4E464947555245222C22524543555253495645222C225245464552454E434553222C22524547455850222C225245494E444558222C2252454C4154495645222C2252454C4541534522';
wwv_flow_imp.g_varchar2_table(33) := '2C2252454E414D45222C225245504C414345222C225245504C49434154494F4E222C22524553544F5245222C225245535452494354222C2252455455524E222C2252455455524E494E47222C22524556455254222C225245564F4B45222C225249474854';
wwv_flow_imp.g_varchar2_table(34) := '222C22524F4C4C4241434B222C22524F57222C22524F57434F554E54222C22524F5747554944434F4C222C22524F5753222C2252554C45222C2253415645222C2253415645504F494E54222C22534348454D41222C225343524F4C4C222C225345434F4E';
wwv_flow_imp.g_varchar2_table(35) := '44222C2253454354494F4E222C2253454355524954594155444954222C2253454C454354222C2253454D414E5449434B45595048524153455441424C45222C2253454D414E54494353494D494C415249545944455441494C535441424C45222C2253454D';
wwv_flow_imp.g_varchar2_table(36) := '414E54494353494D494C41524954595441424C45222C2253455353494F4E222C2253455353494F4E5F55534552222C22534554222C2253455455534552222C2253485554444F574E222C2253495A45222C22534D414C4C494E54222C22534F4D45222C22';
wwv_flow_imp.g_varchar2_table(37) := '5350414345222C2253514C222C2253514C4341222C2253514C434F4445222C2253514C4552524F52222C2253514C5354415445222C2253514C5741524E494E47222C2253544154495354494353222C22535542535452494E47222C2253554D222C225359';
wwv_flow_imp.g_varchar2_table(38) := '5354454D5F55534552222C225441424C45222C225441424C4553414D504C45222C2254454D50222C2254454D504F52415259222C225445585453495A45222C225448454E222C2254494553222C2254494D45222C2254494D455354414D50222C2254494D';
wwv_flow_imp.g_varchar2_table(39) := '455A4F4E455F484F5552222C2254494D455A4F4E455F4D494E555445222C22544F222C22544F50222C22545241494C494E47222C225452414E222C225452414E53414354494F4E222C225452414E534C415445222C225452414E534C4154494F4E222C22';
wwv_flow_imp.g_varchar2_table(40) := '54524947474552222C225452494D222C2254525545222C225452554E43415445222C225452595F434F4E56455254222C225453455155414C222C22554E424F554E444544222C22554E494F4E222C22554E49515545222C22554E4B4E4F574E222C22554E';
wwv_flow_imp.g_varchar2_table(41) := '5049564F54222C22555044415445222C2255504441544554455854222C225550504552222C225553414745222C22555345222C2255534552222C225553494E47222C2256414355554D222C2256414C5545222C2256414C554553222C2256415243484152';
wwv_flow_imp.g_varchar2_table(42) := '222C2256415259494E47222C2256494557222C225649525455414C222C2257414954464F52222C225748454E222C225748454E45564552222C225748455245222C225748494C45222C2257494E444F57222C2257495448222C2257495448494E2047524F';
wwv_flow_imp.g_varchar2_table(43) := '5550222C22574954484F5554222C22574F524B222C225752495445222C22575249544554455854222C2259454152222C225A4F4E45225D2C6F70657261746F72733A5B22414C4C222C22414E44222C22414E59222C224245545745454E222C2245584953';
wwv_flow_imp.g_varchar2_table(44) := '5453222C22494E222C224C494B45222C224E4F54222C224F52222C22534F4D45222C22455843455054222C22494E54455253454354222C22554E494F4E222C224150504C59222C2243524F5353222C2246554C4C222C22494E4E4552222C224A4F494E22';
wwv_flow_imp.g_varchar2_table(45) := '2C224C454654222C224F55544552222C225249474854222C22434F4E5441494E53222C224652454554455854222C224953222C224E554C4C222C225049564F54222C22554E5049564F54222C224D415443484544225D2C6275696C74696E46756E637469';
wwv_flow_imp.g_varchar2_table(46) := '6F6E733A5B22415647222C22434845434B53554D5F414747222C22434F554E54222C22434F554E545F424947222C2247524F5550494E47222C2247524F5550494E475F4944222C224D4158222C224D494E222C2253554D222C225354444556222C225354';
wwv_flow_imp.g_varchar2_table(47) := '44455650222C22564152222C2256415250222C2243554D455F44495354222C2246495253545F56414C5545222C224C4147222C224C4153545F56414C5545222C224C454144222C2250455243454E54494C455F434F4E54222C2250455243454E54494C45';
wwv_flow_imp.g_varchar2_table(48) := '5F44495343222C2250455243454E545F52414E4B222C22434F4C4C415445222C22434F4C4C4154494F4E50524F5045525459222C2254455254494152595F57454947485453222C2246454445524154494F4E5F46494C544552494E475F56414C5545222C';
wwv_flow_imp.g_varchar2_table(49) := '2243415354222C22434F4E56455254222C225041525345222C225452595F43415354222C225452595F434F4E56455254222C225452595F5041525345222C224153594D4B45595F4944222C224153594D4B455950524F5045525459222C22434552545052';
wwv_flow_imp.g_varchar2_table(50) := '4F5045525459222C22434552545F4944222C2243525950545F47454E5F52414E444F4D222C224445435259505442594153594D4B4559222C2244454352595054425943455254222C224445435259505442594B4559222C224445435259505442594B4559';
wwv_flow_imp.g_varchar2_table(51) := '4155544F4153594D4B4559222C224445435259505442594B45594155544F43455254222C2244454352595054425950415353504852415345222C22454E435259505442594153594D4B4559222C22454E4352595054425943455254222C22454E43525950';
wwv_flow_imp.g_varchar2_table(52) := '5442594B4559222C22454E4352595054425950415353504852415345222C22484153484259544553222C2249535F4F424A4543545349474E4544222C224B45595F47554944222C224B45595F4944222C224B45595F4E414D45222C225349474E42594153';
wwv_flow_imp.g_varchar2_table(53) := '594D4B4559222C225349474E425943455254222C2253594D4B455950524F5045525459222C225645524946595349474E4544425943455254222C225645524946595349474E454442594153594D4B4559222C22435552534F525F535441545553222C2244';
wwv_flow_imp.g_varchar2_table(54) := '4154414C454E475448222C224944454E545F43555252454E54222C224944454E545F494E4352222C224944454E545F53454544222C224944454E54495459222C2253514C5F56415249414E545F50524F5045525459222C2243555252454E545F54494D45';
wwv_flow_imp.g_varchar2_table(55) := '5354414D50222C2244415445414444222C224441544544494646222C224441544546524F4D5041525453222C22444154454E414D45222C224441544550415254222C224441544554494D453246524F4D5041525453222C224441544554494D4546524F4D';
wwv_flow_imp.g_varchar2_table(56) := '5041525453222C224441544554494D454F464653455446524F4D5041525453222C22444159222C22454F4D4F4E5448222C2247455444415445222C2247455455544344415445222C22495344415445222C224D4F4E5448222C22534D414C4C4441544554';
wwv_flow_imp.g_varchar2_table(57) := '494D4546524F4D5041525453222C225357495443484F4646534554222C225359534441544554494D45222C225359534441544554494D454F4646534554222C225359535554434441544554494D45222C2254494D4546524F4D5041525453222C22544F44';
wwv_flow_imp.g_varchar2_table(58) := '41544554494D454F4646534554222C2259454152222C2243484F4F5345222C22434F414C45534345222C22494946222C224E554C4C4946222C22414253222C2241434F53222C224153494E222C224154414E222C2241544E32222C224345494C494E4722';
wwv_flow_imp.g_varchar2_table(59) := '2C22434F53222C22434F54222C2244454752454553222C22455850222C22464C4F4F52222C224C4F47222C224C4F473130222C225049222C22504F574552222C2252414449414E53222C2252414E44222C22524F554E44222C225349474E222C2253494E';
wwv_flow_imp.g_varchar2_table(60) := '222C2253515254222C22535155415245222C2254414E222C224150505F4E414D45222C224150504C4F434B5F4D4F4445222C224150504C4F434B5F54455354222C22415353454D424C5950524F5045525459222C22434F4C5F4C454E475448222C22434F';
wwv_flow_imp.g_varchar2_table(61) := '4C5F4E414D45222C22434F4C554D4E50524F5045525459222C2244415441424153455F5052494E434950414C5F4944222C22444154414241534550524F50455254594558222C2244425F4944222C2244425F4E414D45222C2246494C455F4944222C2246';
wwv_flow_imp.g_varchar2_table(62) := '494C455F49444558222C2246494C455F4E414D45222C2246494C4547524F55505F4944222C2246494C4547524F55505F4E414D45222C2246494C4547524F555050524F5045525459222C2246494C4550524F5045525459222C2246554C4C544558544341';
wwv_flow_imp.g_varchar2_table(63) := '54414C4F4750524F5045525459222C2246554C4C544558545345525649434550524F5045525459222C22494E4445585F434F4C222C22494E4445584B45595F50524F5045525459222C22494E44455850524F5045525459222C224F424A4543545F444546';
wwv_flow_imp.g_varchar2_table(64) := '494E4954494F4E222C224F424A4543545F4944222C224F424A4543545F4E414D45222C224F424A4543545F534348454D415F4E414D45222C224F424A45435450524F5045525459222C224F424A45435450524F50455254594558222C224F524947494E41';
wwv_flow_imp.g_varchar2_table(65) := '4C5F44425F4E414D45222C2250415253454E414D45222C22534348454D415F4944222C22534348454D415F4E414D45222C2253434F50455F4944454E54495459222C2253455256455250524F5045525459222C2253544154535F44415445222C22545950';
wwv_flow_imp.g_varchar2_table(66) := '455F4944222C22545950455F4E414D45222C225459504550524F5045525459222C2244454E53455F52414E4B222C224E54494C45222C2252414E4B222C22524F575F4E554D424552222C225055424C495348494E475345525645524E414D45222C224F50';
wwv_flow_imp.g_varchar2_table(67) := '454E44415441534F55524345222C224F50454E5155455259222C224F50454E524F57534554222C224F50454E584D4C222C2243455254454E434F444544222C2243455254505249564154454B4559222C2243555252454E545F55534552222C224841535F';
wwv_flow_imp.g_varchar2_table(68) := '4442414343455353222C224841535F5045524D535F42595F4E414D45222C2249535F4D454D424552222C2249535F524F4C454D454D424552222C2249535F535256524F4C454D454D424552222C224C4F47494E50524F5045525459222C224F524947494E';
wwv_flow_imp.g_varchar2_table(69) := '414C5F4C4F47494E222C225045524D495353494F4E53222C22505744454E4352595054222C22505744434F4D50415245222C2253455353494F4E5F55534552222C2253455353494F4E50524F5045525459222C2253555345525F4944222C225355534552';
wwv_flow_imp.g_varchar2_table(70) := '5F4E414D45222C2253555345525F534944222C2253555345525F534E414D45222C2253595354454D5F55534552222C2255534552222C22555345525F4944222C22555345525F4E414D45222C224153434949222C2243484152222C2243484152494E4445';
wwv_flow_imp.g_varchar2_table(71) := '58222C22434F4E434154222C22444946464552454E4345222C22464F524D4154222C224C454654222C224C454E222C224C4F574552222C224C5452494D222C224E43484152222C22504154494E444558222C2251554F54454E414D45222C225245504C41';
wwv_flow_imp.g_varchar2_table(72) := '4345222C225245504C4943415445222C2252455645525345222C225249474854222C22525452494D222C22534F554E444558222C225350414345222C22535452222C225354554646222C22535542535452494E47222C22554E49434F4445222C22555050';
wwv_flow_imp.g_varchar2_table(73) := '4552222C2242494E4152595F434845434B53554D222C22434845434B53554D222C22434F4E4E454354494F4E50524F5045525459222C22434F4E544558545F494E464F222C2243555252454E545F524551554553545F4944222C224552524F525F4C494E';
wwv_flow_imp.g_varchar2_table(74) := '45222C224552524F525F4E554D424552222C224552524F525F4D455353414745222C224552524F525F50524F434544555245222C224552524F525F5345564552495459222C224552524F525F5354415445222C22464F524D41544D455353414745222C22';
wwv_flow_imp.g_varchar2_table(75) := '474554414E53494E554C4C222C224745545F46494C4553545245414D5F5452414E53414354494F4E5F434F4E54455854222C22484F53545F4944222C22484F53545F4E414D45222C2249534E554C4C222C2249534E554D45524943222C224D494E5F4143';
wwv_flow_imp.g_varchar2_table(76) := '544956455F524F5756455253494F4E222C224E45574944222C224E455753455155454E5449414C4944222C22524F57434F554E545F424947222C22584143545F5354415445222C2254455854505452222C225445585456414C4944222C22434F4C554D4E';
wwv_flow_imp.g_varchar2_table(77) := '535F55504441544544222C224556454E5444415441222C22545249474745525F4E4553544C4556454C222C22555044415445222C224348414E47455441424C45222C224348414E47455F545241434B494E475F434F4E54455854222C224348414E47455F';
wwv_flow_imp.g_varchar2_table(78) := '545241434B494E475F43555252454E545F56455253494F4E222C224348414E47455F545241434B494E475F49535F434F4C554D4E5F494E5F4D41534B222C224348414E47455F545241434B494E475F4D494E5F56414C49445F56455253494F4E222C2243';
wwv_flow_imp.g_varchar2_table(79) := '4F4E5441494E535441424C45222C2246524545544558545441424C45222C2253454D414E5449434B45595048524153455441424C45222C2253454D414E54494353494D494C415249545944455441494C535441424C45222C2253454D414E54494353494D';
wwv_flow_imp.g_varchar2_table(80) := '494C41524954595441424C45222C2246494C455441424C45524F4F5450415448222C2247455446494C454E414D45535041434550415448222C22474554504154484C4F4341544F52222C22504154484E414D45222C224745545F5452414E534D49535349';
wwv_flow_imp.g_varchar2_table(81) := '4F4E5F535441545553225D2C6275696C74696E5661726961626C65733A5B224040444154454649525354222C22404044425453222C2240404C414E474944222C2240404C414E4755414745222C2240404C4F434B5F54494D454F5554222C2240404D4158';
wwv_flow_imp.g_varchar2_table(82) := '5F434F4E4E454354494F4E53222C2240404D41585F505245434953494F4E222C2240404E4553544C4556454C222C2240404F5054494F4E53222C22404052454D534552564552222C2240405345525645524E414D45222C224040534552564943454E414D';
wwv_flow_imp.g_varchar2_table(83) := '45222C22404053504944222C2240405445585453495A45222C22404056455253494F4E222C224040435552534F525F524F5753222C22404046455443485F535441545553222C224040444154454649525354222C22404050524F434944222C2240404552';
wwv_flow_imp.g_varchar2_table(84) := '524F52222C2240404944454E54495459222C224040524F57434F554E54222C2240405452414E434F554E54222C224040434F4E4E454354494F4E53222C2240404350555F42555359222C22404049444C45222C224040494F5F42555359222C2240405041';
wwv_flow_imp.g_varchar2_table(85) := '434B45545F4552524F5253222C2240405041434B5F5245434549564544222C2240405041434B5F53454E54222C22404054494D455449434B53222C224040544F54414C5F4552524F5253222C224040544F54414C5F52454144222C224040544F54414C5F';
wwv_flow_imp.g_varchar2_table(86) := '5752495445225D2C70736575646F436F6C756D6E733A5B2224414354494F4E222C22244944454E54495459222C2224524F5747554944222C2224504152544954494F4E225D2C746F6B656E697A65723A7B726F6F743A5B7B696E636C7564653A2240636F';
wwv_flow_imp.g_varchar2_table(87) := '6D6D656E7473227D2C7B696E636C7564653A224077686974657370616365227D2C7B696E636C7564653A224070736575646F436F6C756D6E73227D2C7B696E636C7564653A22406E756D62657273227D2C7B696E636C7564653A2240737472696E677322';
wwv_flow_imp.g_varchar2_table(88) := '7D2C7B696E636C7564653A2240636F6D706C65784964656E74696669657273227D2C7B696E636C7564653A224073636F706573227D2C5B2F5B3B2C2E5D2F2C2264656C696D69746572225D2C5B2F5B28295D2F2C2240627261636B657473225D2C5B2F5B';
wwv_flow_imp.g_varchar2_table(89) := '5C774023245D2B2F2C7B63617365733A7B22406F70657261746F7273223A226F70657261746F72222C22406275696C74696E5661726961626C6573223A22707265646566696E6564222C22406275696C74696E46756E6374696F6E73223A227072656465';
wwv_flow_imp.g_varchar2_table(90) := '66696E6564222C22406B6579776F726473223A226B6579776F7264222C224064656661756C74223A226964656E746966696572227D7D5D2C5B2F5B3C3E3D2125262B5C2D2A2F7C7E5E5D2F2C226F70657261746F72225D5D2C776869746573706163653A';
wwv_flow_imp.g_varchar2_table(91) := '5B5B2F5C732B2F2C227768697465225D5D2C636F6D6D656E74733A5B5B2F2D2D2B2E2A2F2C22636F6D6D656E74225D2C5B2F5C2F5C2A2F2C7B746F6B656E3A22636F6D6D656E742E71756F7465222C6E6578743A2240636F6D6D656E74227D5D5D2C636F';
wwv_flow_imp.g_varchar2_table(92) := '6D6D656E743A5B5B2F5B5E2A2F5D2B2F2C22636F6D6D656E74225D2C5B2F5C2A5C2F2F2C7B746F6B656E3A22636F6D6D656E742E71756F7465222C6E6578743A2240706F70227D5D2C5B2F2E2F2C22636F6D6D656E74225D5D2C70736575646F436F6C75';
wwv_flow_imp.g_varchar2_table(93) := '6D6E733A5B5B2F5B245D5B412D5A612D7A5F5D5B5C774023245D2A2F2C7B63617365733A7B224070736575646F436F6C756D6E73223A22707265646566696E6564222C224064656661756C74223A226964656E746966696572227D7D5D5D2C6E756D6265';
wwv_flow_imp.g_varchar2_table(94) := '72733A5B5B2F305B78585D5B302D39612D66412D465D2A2F2C226E756D626572225D2C5B2F5B245D5B2B2D5D2A5C642A285C2E5C642A293F2F2C226E756D626572225D2C5B2F28285C642B285C2E5C642A293F297C285C2E5C642B2929285B65455D5B5C';
wwv_flow_imp.g_varchar2_table(95) := '2D2B5D3F5C642B293F2F2C226E756D626572225D5D2C737472696E67733A5B5B2F4E272F2C7B746F6B656E3A22737472696E67222C6E6578743A2240737472696E67227D5D2C5B2F272F2C7B746F6B656E3A22737472696E67222C6E6578743A22407374';
wwv_flow_imp.g_varchar2_table(96) := '72696E67227D5D5D2C737472696E673A5B5B2F5B5E275D2B2F2C22737472696E67225D2C5B2F27272F2C22737472696E67225D2C5B2F272F2C7B746F6B656E3A22737472696E67222C6E6578743A2240706F70227D5D5D2C636F6D706C65784964656E74';
wwv_flow_imp.g_varchar2_table(97) := '6966696572733A5B5B2F5C5B2F2C7B746F6B656E3A226964656E7469666965722E71756F7465222C6E6578743A2240627261636B657465644964656E746966696572227D5D2C5B2F222F2C7B746F6B656E3A226964656E7469666965722E71756F746522';
wwv_flow_imp.g_varchar2_table(98) := '2C6E6578743A224071756F7465644964656E746966696572227D5D5D2C627261636B657465644964656E7469666965723A5B5B2F5B5E5C5D5D2B2F2C226964656E746966696572225D2C5B2F5D5D2F2C226964656E746966696572225D2C5B2F5D2F2C7B';
wwv_flow_imp.g_varchar2_table(99) := '746F6B656E3A226964656E7469666965722E71756F7465222C6E6578743A2240706F70227D5D5D2C71756F7465644964656E7469666965723A5B5B2F5B5E225D2B2F2C226964656E746966696572225D2C5B2F22222F2C226964656E746966696572225D';
wwv_flow_imp.g_varchar2_table(100) := '2C5B2F222F2C7B746F6B656E3A226964656E7469666965722E71756F7465222C6E6578743A2240706F70227D5D5D2C73636F7065733A5B5B2F424547494E5C732B2844495354524942555445445C732B293F5452414E2853414354494F4E293F5C622F69';
wwv_flow_imp.g_varchar2_table(101) := '2C226B6579776F7264225D2C5B2F424547494E5C732B5452595C622F692C7B746F6B656E3A226B6579776F72642E747279227D5D2C5B2F454E445C732B5452595C622F692C7B746F6B656E3A226B6579776F72642E747279227D5D2C5B2F424547494E5C';
wwv_flow_imp.g_varchar2_table(102) := '732B43415443485C622F692C7B746F6B656E3A226B6579776F72642E6361746368227D5D2C5B2F454E445C732B43415443485C622F692C7B746F6B656E3A226B6579776F72642E6361746368227D5D2C5B2F28424547494E7C43415345295C622F692C7B';
wwv_flow_imp.g_varchar2_table(103) := '746F6B656E3A226B6579776F72642E626C6F636B227D5D2C5B2F454E445C622F692C7B746F6B656E3A226B6579776F72642E626C6F636B227D5D2C5B2F5748454E5C622F692C7B746F6B656E3A226B6579776F72642E63686F696365227D5D2C5B2F5448';
wwv_flow_imp.g_varchar2_table(104) := '454E5C622F692C7B746F6B656E3A226B6579776F72642E63686F696365227D5D5D7D7D7D7D5D293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5449221657531700)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/914.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '6578706F72742064656661756C74205F5F7765627061636B5F7075626C69635F706174685F5F202B202238663361626263626339383333393665316631336461383765363365633961662E747466223B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5449669759531700)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/a5a5b09031edbc161f4f.ttf'
,p_mime_type=>'application/octet-stream'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2828293D3E7B2275736520737472696374223B636F6E737420653D6E657720636C6173737B636F6E7374727563746F7228297B746869732E6C697374656E6572733D5B5D2C746869732E756E65787065637465644572726F7248616E646C65723D66756E';
wwv_flow_imp.g_varchar2_table(2) := '6374696F6E2865297B73657454696D656F7574282828293D3E7B696628652E737461636B297B696628732E69734572726F724E6F54656C656D65747279286529297468726F77206E6577207328652E6D6573736167652B225C6E5C6E222B652E73746163';
wwv_flow_imp.g_varchar2_table(3) := '6B293B7468726F77206E6577204572726F7228652E6D6573736167652B225C6E5C6E222B652E737461636B297D7468726F7720657D292C30297D7D656D69742865297B746869732E6C697374656E6572732E666F72456163682828743D3E7B742865297D';
wwv_flow_imp.g_varchar2_table(4) := '29297D6F6E556E65787065637465644572726F722865297B746869732E756E65787065637465644572726F7248616E646C65722865292C746869732E656D69742865297D6F6E556E657870656374656445787465726E616C4572726F722865297B746869';
wwv_flow_imp.g_varchar2_table(5) := '732E756E65787065637465644572726F7248616E646C65722865297D7D3B66756E6374696F6E20742874297B766172206E3B286E3D7429696E7374616E63656F6620727C7C6E20696E7374616E63656F66204572726F7226266E2E6E616D653D3D3D6926';
wwv_flow_imp.g_varchar2_table(6) := '266E2E6D6573736167653D3D3D697C7C652E6F6E556E65787065637465644572726F722874297D66756E6374696F6E206E2865297B6966286520696E7374616E63656F66204572726F72297B636F6E73747B6E616D653A742C6D6573736167653A6E7D3D';
wwv_flow_imp.g_varchar2_table(7) := '653B72657475726E7B2469734572726F723A21302C6E616D653A742C6D6573736167653A6E2C737461636B3A652E737461636B74726163657C7C652E737461636B2C6E6F54656C656D657472793A732E69734572726F724E6F54656C656D657472792865';
wwv_flow_imp.g_varchar2_table(8) := '297D7D72657475726E20657D636F6E737420693D2243616E63656C6564223B636C617373207220657874656E6473204572726F727B636F6E7374727563746F7228297B73757065722869292C746869732E6E616D653D746869732E6D6573736167657D7D';
wwv_flow_imp.g_varchar2_table(9) := '4572726F723B636C617373207320657874656E6473204572726F727B636F6E7374727563746F722865297B73757065722865292C746869732E6E616D653D22436F646545787065637465644572726F72227D7374617469632066726F6D4572726F722865';
wwv_flow_imp.g_varchar2_table(10) := '297B6966286520696E7374616E63656F6620732972657475726E20653B636F6E737420743D6E657720733B72657475726E20742E6D6573736167653D652E6D6573736167652C742E737461636B3D652E737461636B2C747D737461746963206973457272';
wwv_flow_imp.g_varchar2_table(11) := '6F724E6F54656C656D657472792865297B72657475726E22436F646545787065637465644572726F72223D3D3D652E6E616D657D7D636C617373206F20657874656E6473204572726F727B636F6E7374727563746F722865297B737570657228657C7C22';
wwv_flow_imp.g_varchar2_table(12) := '416E20756E657870656374656420627567206F636375727265642E22292C4F626A6563742E73657450726F746F747970654F6628746869732C6F2E70726F746F74797065297D7D66756E6374696F6E206128652C74297B636F6E7374206E3D746869733B';
wwv_flow_imp.g_varchar2_table(13) := '6C657420692C723D21313B72657475726E2066756E6374696F6E28297B696628722972657475726E20693B696628723D21302C74297472797B693D652E6170706C79286E2C617267756D656E7473297D66696E616C6C797B7428297D656C736520693D65';
wwv_flow_imp.g_varchar2_table(14) := '2E6170706C79286E2C617267756D656E7473293B72657475726E20697D7D766172206C3B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E20652626226F626A656374223D3D747970656F66206526262266756E637469';
wwv_flow_imp.g_varchar2_table(15) := '6F6E223D3D747970656F6620655B53796D626F6C2E6974657261746F725D7D652E69733D743B636F6E7374206E3D4F626A6563742E667265657A65285B5D293B66756E6374696F6E2A692865297B7969656C6420657D652E656D7074793D66756E637469';
wwv_flow_imp.g_varchar2_table(16) := '6F6E28297B72657475726E206E7D2C652E73696E676C653D692C652E777261703D66756E6374696F6E2865297B72657475726E20742865293F653A692865297D2C652E66726F6D3D66756E6374696F6E2865297B72657475726E20657C7C6E7D2C652E72';
wwv_flow_imp.g_varchar2_table(17) := '6576657273653D66756E6374696F6E2A2865297B666F72286C657420743D652E6C656E6774682D313B743E3D303B742D2D297969656C6420655B745D7D2C652E6973456D7074793D66756E6374696F6E2865297B72657475726E21657C7C21303D3D3D65';
wwv_flow_imp.g_varchar2_table(18) := '5B53796D626F6C2E6974657261746F725D28292E6E65787428292E646F6E657D2C652E66697273743D66756E6374696F6E2865297B72657475726E20655B53796D626F6C2E6974657261746F725D28292E6E65787428292E76616C75657D2C652E736F6D';
wwv_flow_imp.g_varchar2_table(19) := '653D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F6620652969662874286E292972657475726E21303B72657475726E21317D2C652E66696E643D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F662065296966';
wwv_flow_imp.g_varchar2_table(20) := '2874286E292972657475726E206E7D2C652E66696C7465723D66756E6374696F6E2A28652C74297B666F7228636F6E7374206E206F6620652974286E292626287969656C64206E297D2C652E6D61703D66756E6374696F6E2A28652C74297B6C6574206E';
wwv_flow_imp.g_varchar2_table(21) := '3D303B666F7228636F6E73742069206F662065297969656C64207428692C6E2B2B297D2C652E636F6E6361743D66756E6374696F6E2A282E2E2E65297B666F7228636F6E73742074206F662065297969656C642A747D2C652E7265647563653D66756E63';
wwv_flow_imp.g_varchar2_table(22) := '74696F6E28652C742C6E297B6C657420693D6E3B666F7228636F6E7374206E206F66206529693D7428692C6E293B72657475726E20697D2C652E736C6963653D66756E6374696F6E2A28652C742C6E3D652E6C656E677468297B666F7228743C30262628';
wwv_flow_imp.g_varchar2_table(23) := '742B3D652E6C656E677468292C6E3C303F6E2B3D652E6C656E6774683A6E3E652E6C656E6774682626286E3D652E6C656E677468293B743C6E3B742B2B297969656C6420655B745D7D2C652E636F6E73756D653D66756E6374696F6E28742C6E3D4E756D';
wwv_flow_imp.g_varchar2_table(24) := '6265722E504F5349544956455F494E46494E495459297B636F6E737420693D5B5D3B696628303D3D3D6E2972657475726E5B692C745D3B636F6E737420723D745B53796D626F6C2E6974657261746F725D28293B666F72286C657420743D303B743C6E3B';
wwv_flow_imp.g_varchar2_table(25) := '742B2B297B636F6E737420743D722E6E65787428293B696628742E646F6E652972657475726E5B692C652E656D70747928295D3B692E7075736828742E76616C7565297D72657475726E5B692C7B5B53796D626F6C2E6974657261746F725D3A28293D3E';
wwv_flow_imp.g_varchar2_table(26) := '727D5D7D2C652E6173796E63546F41727261793D6173796E632066756E6374696F6E2865297B636F6E737420743D5B5D3B666F7220617761697428636F6E7374206E206F66206529742E70757368286E293B72657475726E2050726F6D6973652E726573';
wwv_flow_imp.g_varchar2_table(27) := '6F6C76652874297D7D286C7C7C286C3D7B7D29293B6C657420753D6E756C6C3B66756E6374696F6E20682865297B72657475726E206E756C6C3D3D757C7C752E747261636B446973706F7361626C652865292C657D66756E6374696F6E20632865297B6E';
wwv_flow_imp.g_varchar2_table(28) := '756C6C3D3D757C7C752E6D61726B4173446973706F7365642865297D66756E6374696F6E206428652C74297B6E756C6C3D3D757C7C752E736574506172656E7428652C74297D66756E6374696F6E206D2865297B6966286C2E6973286529297B636F6E73';
wwv_flow_imp.g_varchar2_table(29) := '7420743D5B5D3B666F7228636F6E7374206E206F662065296966286E297472797B6E2E646973706F736528297D63617463682865297B742E707573682865297D696628313D3D3D742E6C656E677468297468726F7720745B305D3B696628742E6C656E67';
wwv_flow_imp.g_varchar2_table(30) := '74683E31297468726F77206E6577204167677265676174654572726F7228742C22456E636F756E7465726564206572726F7273207768696C6520646973706F73696E67206F662073746F726522293B72657475726E2041727261792E6973417272617928';
wwv_flow_imp.g_varchar2_table(31) := '65293F5B5D3A657D696628652972657475726E20652E646973706F736528292C657D66756E6374696F6E20672865297B636F6E737420743D68287B646973706F73653A61282828293D3E7B632874292C6528297D29297D293B72657475726E20747D636C';
wwv_flow_imp.g_varchar2_table(32) := '61737320667B636F6E7374727563746F7228297B746869732E5F746F446973706F73653D6E6577205365742C746869732E5F6973446973706F7365643D21312C682874686973297D646973706F736528297B746869732E5F6973446973706F7365647C7C';
wwv_flow_imp.g_varchar2_table(33) := '28632874686973292C746869732E5F6973446973706F7365643D21302C746869732E636C6561722829297D676574206973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D636C65617228297B69662830213D3D74';
wwv_flow_imp.g_varchar2_table(34) := '6869732E5F746F446973706F73652E73697A65297472797B6D28746869732E5F746F446973706F7365297D66696E616C6C797B746869732E5F746F446973706F73652E636C65617228297D7D6164642865297B69662821652972657475726E20653B6966';
wwv_flow_imp.g_varchar2_table(35) := '28653D3D3D74686973297468726F77206E6577204572726F72282243616E6E6F74207265676973746572206120646973706F7361626C65206F6E20697473656C662122293B72657475726E206428652C74686973292C746869732E5F6973446973706F73';
wwv_flow_imp.g_varchar2_table(36) := '65643F662E44495341424C455F444953504F5345445F5741524E494E477C7C636F6E736F6C652E7761726E286E6577204572726F722822547279696E6720746F20616464206120646973706F7361626C6520746F206120446973706F7361626C6553746F';
wwv_flow_imp.g_varchar2_table(37) := '726520746861742068617320616C7265616479206265656E20646973706F736564206F662E20546865206164646564206F626A6563742077696C6C206265206C65616B65642122292E737461636B293A746869732E5F746F446973706F73652E61646428';
wwv_flow_imp.g_varchar2_table(38) := '65292C657D64656C657465416E644C65616B2865297B652626746869732E5F746F446973706F73652E686173286529262628746869732E5F746F446973706F73652E64656C6574652865292C6428652C6E756C6C29297D7D662E44495341424C455F4449';
wwv_flow_imp.g_varchar2_table(39) := '53504F5345445F5741524E494E473D21313B636C61737320707B636F6E7374727563746F7228297B746869732E5F73746F72653D6E657720662C682874686973292C6428746869732E5F73746F72652C74686973297D646973706F736528297B63287468';
wwv_flow_imp.g_varchar2_table(40) := '6973292C746869732E5F73746F72652E646973706F736528297D5F72656769737465722865297B696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E6F74207265676973746572206120646973706F7361626C65206F6E20';
wwv_flow_imp.g_varchar2_table(41) := '697473656C662122293B72657475726E20746869732E5F73746F72652E6164642865297D7D702E4E6F6E653D4F626A6563742E667265657A65287B646973706F736528297B7D7D292C53796D626F6C2E6974657261746F723B636C61737320627B636F6E';
wwv_flow_imp.g_varchar2_table(42) := '7374727563746F722865297B746869732E656C656D656E743D652C746869732E6E6578743D622E556E646566696E65642C746869732E707265763D622E556E646566696E65647D7D622E556E646566696E65643D6E6577206228766F69642030293B636C';
wwv_flow_imp.g_varchar2_table(43) := '617373205F7B636F6E7374727563746F7228297B746869732E5F66697273743D622E556E646566696E65642C746869732E5F6C6173743D622E556E646566696E65642C746869732E5F73697A653D307D6765742073697A6528297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(44) := '69732E5F73697A657D6973456D70747928297B72657475726E20746869732E5F66697273743D3D3D622E556E646566696E65647D636C65617228297B6C657420653D746869732E5F66697273743B666F72283B65213D3D622E556E646566696E65643B29';
wwv_flow_imp.g_varchar2_table(45) := '7B636F6E737420743D652E6E6578743B652E707265763D622E556E646566696E65642C652E6E6578743D622E556E646566696E65642C653D747D746869732E5F66697273743D622E556E646566696E65642C746869732E5F6C6173743D622E556E646566';
wwv_flow_imp.g_varchar2_table(46) := '696E65642C746869732E5F73697A653D307D756E73686966742865297B72657475726E20746869732E5F696E7365727428652C2131297D707573682865297B72657475726E20746869732E5F696E7365727428652C2130297D5F696E7365727428652C74';
wwv_flow_imp.g_varchar2_table(47) := '297B636F6E7374206E3D6E657720622865293B696628746869732E5F66697273743D3D3D622E556E646566696E656429746869732E5F66697273743D6E2C746869732E5F6C6173743D6E3B656C73652069662874297B636F6E737420653D746869732E5F';
wwv_flow_imp.g_varchar2_table(48) := '6C6173743B746869732E5F6C6173743D6E2C6E2E707265763D652C652E6E6578743D6E7D656C73657B636F6E737420653D746869732E5F66697273743B746869732E5F66697273743D6E2C6E2E6E6578743D652C652E707265763D6E7D746869732E5F73';
wwv_flow_imp.g_varchar2_table(49) := '697A652B3D313B6C657420693D21313B72657475726E28293D3E7B697C7C28693D21302C746869732E5F72656D6F7665286E29297D7D736869667428297B696628746869732E5F6669727374213D3D622E556E646566696E6564297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(50) := '746869732E5F66697273742E656C656D656E743B72657475726E20746869732E5F72656D6F766528746869732E5F6669727374292C657D7D706F7028297B696628746869732E5F6C617374213D3D622E556E646566696E6564297B636F6E737420653D74';
wwv_flow_imp.g_varchar2_table(51) := '6869732E5F6C6173742E656C656D656E743B72657475726E20746869732E5F72656D6F766528746869732E5F6C617374292C657D7D5F72656D6F76652865297B696628652E70726576213D3D622E556E646566696E65642626652E6E657874213D3D622E';
wwv_flow_imp.g_varchar2_table(52) := '556E646566696E6564297B636F6E737420743D652E707265763B742E6E6578743D652E6E6578742C652E6E6578742E707265763D747D656C736520652E707265763D3D3D622E556E646566696E65642626652E6E6578743D3D3D622E556E646566696E65';
wwv_flow_imp.g_varchar2_table(53) := '643F28746869732E5F66697273743D622E556E646566696E65642C746869732E5F6C6173743D622E556E646566696E6564293A652E6E6578743D3D3D622E556E646566696E65643F28746869732E5F6C6173743D746869732E5F6C6173742E707265762C';
wwv_flow_imp.g_varchar2_table(54) := '746869732E5F6C6173742E6E6578743D622E556E646566696E6564293A652E707265763D3D3D622E556E646566696E6564262628746869732E5F66697273743D746869732E5F66697273742E6E6578742C746869732E5F66697273742E707265763D622E';
wwv_flow_imp.g_varchar2_table(55) := '556E646566696E6564293B746869732E5F73697A652D3D317D2A5B53796D626F6C2E6974657261746F725D28297B6C657420653D746869732E5F66697273743B666F72283B65213D3D622E556E646566696E65643B297969656C6420652E656C656D656E';
wwv_flow_imp.g_varchar2_table(56) := '742C653D652E6E6578747D7D636F6E737420763D676C6F62616C546869732E706572666F726D616E636526262266756E6374696F6E223D3D747970656F6620676C6F62616C546869732E706572666F726D616E63652E6E6F773B636C61737320437B7374';
wwv_flow_imp.g_varchar2_table(57) := '61746963206372656174652865297B72657475726E206E657720432865297D636F6E7374727563746F722865297B746869732E5F6E6F773D76262621313D3D3D653F446174652E6E6F773A676C6F62616C546869732E706572666F726D616E63652E6E6F';
wwv_flow_imp.g_varchar2_table(58) := '772E62696E6428676C6F62616C546869732E706572666F726D616E6365292C746869732E5F737461727454696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D73746F7028297B746869732E5F73746F7054696D653D74';
wwv_flow_imp.g_varchar2_table(59) := '6869732E5F6E6F7728297D726573657428297B746869732E5F737461727454696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D656C617073656428297B72657475726E2D31213D3D746869732E5F73746F7054696D65';
wwv_flow_imp.g_varchar2_table(60) := '3F746869732E5F73746F7054696D652D746869732E5F737461727454696D653A746869732E5F6E6F7728292D746869732E5F737461727454696D657D7D76617220793B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E';
wwv_flow_imp.g_varchar2_table(61) := '28742C6E3D6E756C6C2C69293D3E7B6C657420722C733D21313B72657475726E20723D652828653D3E7B69662821732972657475726E20723F722E646973706F736528293A733D21302C742E63616C6C286E2C65297D292C6E756C6C2C69292C73262672';
wwv_flow_imp.g_varchar2_table(62) := '2E646973706F736528292C727D7D66756E6374696F6E206E28652C742C6E297B72657475726E20722828286E2C693D6E756C6C2C72293D3E652828653D3E6E2E63616C6C28692C7428652929292C6E756C6C2C7229292C6E297D66756E6374696F6E2069';
wwv_flow_imp.g_varchar2_table(63) := '28652C742C6E297B72657475726E20722828286E2C693D6E756C6C2C72293D3E652828653D3E7428652926266E2E63616C6C28692C6529292C6E756C6C2C7229292C6E297D66756E6374696F6E207228652C74297B6C6574206E3B636F6E737420693D6E';
wwv_flow_imp.g_varchar2_table(64) := '65772053287B6F6E57696C6C41646446697273744C697374656E657228297B6E3D6528692E666972652C69297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B6E756C6C3D3D6E7C7C6E2E646973706F736528297D7D293B72657475';
wwv_flow_imp.g_varchar2_table(65) := '726E206E756C6C3D3D747C7C742E6164642869292C692E6576656E747D66756E6374696F6E207328652C742C6E3D3130302C693D21312C723D21312C732C6F297B6C657420612C6C2C752C682C633D303B636F6E737420643D6E65772053287B6C65616B';
wwv_flow_imp.g_varchar2_table(66) := '5761726E696E675468726573686F6C643A732C6F6E57696C6C41646446697273744C697374656E657228297B613D652828653D3E7B632B2B2C6C3D74286C2C65292C6926262175262628642E66697265286C292C6C3D766F69642030292C683D28293D3E';
wwv_flow_imp.g_varchar2_table(67) := '7B636F6E737420653D6C3B6C3D766F696420302C753D766F696420302C2821697C7C633E31292626642E666972652865292C633D307D2C226E756D626572223D3D747970656F66206E3F28636C65617254696D656F75742875292C753D73657454696D65';
wwv_flow_imp.g_varchar2_table(68) := '6F757428682C6E29293A766F696420303D3D3D75262628753D302C71756575654D6963726F7461736B286829297D29297D2C6F6E57696C6C52656D6F76654C697374656E657228297B722626633E302626286E756C6C3D3D687C7C682829297D2C6F6E44';
wwv_flow_imp.g_varchar2_table(69) := '696452656D6F76654C6173744C697374656E657228297B683D766F696420302C612E646973706F736528297D7D293B72657475726E206E756C6C3D3D6F7C7C6F2E6164642864292C642E6576656E747D652E4E6F6E653D28293D3E702E4E6F6E652C652E';
wwv_flow_imp.g_varchar2_table(70) := '64656665723D66756E6374696F6E28652C74297B72657475726E207328652C2828293D3E7B7D292C302C766F696420302C21302C766F696420302C74297D2C652E6F6E63653D742C652E6D61703D6E2C652E666F72456163683D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(71) := '2C742C6E297B72657475726E20722828286E2C693D6E756C6C2C72293D3E652828653D3E7B742865292C6E2E63616C6C28692C65297D292C6E756C6C2C7229292C6E297D2C652E66696C7465723D692C652E7369676E616C3D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(72) := '7B72657475726E20657D2C652E616E793D66756E6374696F6E282E2E2E65297B72657475726E28742C6E3D6E756C6C2C69293D3E7B72657475726E20723D66756E6374696F6E282E2E2E65297B636F6E737420743D67282828293D3E6D28652929293B72';
wwv_flow_imp.g_varchar2_table(73) := '657475726E2066756E6374696F6E28652C74297B6966287529666F7228636F6E7374206E206F66206529752E736574506172656E74286E2C74297D28652C74292C747D282E2E2E652E6D61702828653D3E652828653D3E742E63616C6C286E2C65292929';
wwv_flow_imp.g_varchar2_table(74) := '2929292C28733D6929696E7374616E63656F662041727261793F732E707573682872293A732626732E6164642872292C723B76617220722C737D7D2C652E7265647563653D66756E6374696F6E28652C742C692C72297B6C657420733D693B7265747572';
wwv_flow_imp.g_varchar2_table(75) := '6E206E28652C28653D3E28733D7428732C65292C7329292C72297D2C652E6465626F756E63653D732C652E616363756D756C6174653D66756E6374696F6E28742C6E3D302C69297B72657475726E20652E6465626F756E636528742C2828652C74293D3E';
wwv_flow_imp.g_varchar2_table(76) := '653F28652E707573682874292C65293A5B745D292C6E2C766F696420302C21302C766F696420302C69297D2C652E6C617463683D66756E6374696F6E28652C743D28652C74293D3E653D3D3D742C6E297B6C657420722C733D21303B72657475726E2069';
wwv_flow_imp.g_varchar2_table(77) := '28652C28653D3E7B636F6E7374206E3D737C7C217428652C72293B72657475726E20733D21312C723D652C6E7D292C6E297D2C652E73706C69743D66756E6374696F6E28742C6E2C69297B72657475726E5B652E66696C74657228742C6E2C69292C652E';
wwv_flow_imp.g_varchar2_table(78) := '66696C74657228742C28653D3E216E286529292C69295D7D2C652E6275666665723D66756E6374696F6E28652C743D21312C6E3D5B5D2C69297B6C657420723D6E2E736C69636528292C733D652828653D3E7B723F722E707573682865293A612E666972';
wwv_flow_imp.g_varchar2_table(79) := '652865297D29293B692626692E6164642873293B636F6E7374206F3D28293D3E7B6E756C6C3D3D727C7C722E666F72456163682828653D3E612E6669726528652929292C723D6E756C6C7D2C613D6E65772053287B6F6E57696C6C41646446697273744C';
wwv_flow_imp.g_varchar2_table(80) := '697374656E657228297B737C7C28733D652828653D3E612E6669726528652929292C692626692E616464287329297D2C6F6E44696441646446697273744C697374656E657228297B72262628743F73657454696D656F7574286F293A6F2829297D2C6F6E';
wwv_flow_imp.g_varchar2_table(81) := '44696452656D6F76654C6173744C697374656E657228297B732626732E646973706F736528292C733D6E756C6C7D7D293B72657475726E20692626692E6164642861292C612E6576656E747D2C652E636861696E3D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(82) := '657475726E286E2C692C72293D3E7B636F6E737420733D74286E65772061293B72657475726E2065282866756E6374696F6E2865297B636F6E737420743D732E6576616C756174652865293B74213D3D6F26266E2E63616C6C28692C74297D292C766F69';
wwv_flow_imp.g_varchar2_table(83) := '6420302C72297D7D3B636F6E7374206F3D53796D626F6C282248616C74436861696E61626C6522293B636C61737320617B636F6E7374727563746F7228297B746869732E73746570733D5B5D7D6D61702865297B72657475726E20746869732E73746570';
wwv_flow_imp.g_varchar2_table(84) := '732E707573682865292C746869737D666F72456163682865297B72657475726E20746869732E73746570732E707573682828743D3E28652874292C742929292C746869737D66696C7465722865297B72657475726E20746869732E73746570732E707573';
wwv_flow_imp.g_varchar2_table(85) := '682828743D3E652874293F743A6F29292C746869737D72656475636528652C74297B6C6574206E3D743B72657475726E20746869732E73746570732E707573682828743D3E286E3D65286E2C74292C6E2929292C746869737D6C6174636828653D28652C';
wwv_flow_imp.g_varchar2_table(86) := '74293D3E653D3D3D74297B6C657420742C6E3D21303B72657475726E20746869732E73746570732E707573682828693D3E7B636F6E737420723D6E7C7C216528692C74293B72657475726E206E3D21312C743D692C723F693A6F7D29292C746869737D65';
wwv_flow_imp.g_varchar2_table(87) := '76616C756174652865297B666F7228636F6E73742074206F6620746869732E73746570732969662828653D74286529293D3D3D6F29627265616B3B72657475726E20657D7D652E66726F6D4E6F64654576656E74456D69747465723D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(88) := '28652C742C6E3D653D3E65297B636F6E737420693D282E2E2E65293D3E722E66697265286E282E2E2E6529292C723D6E65772053287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6F6E28742C69292C6F6E44696452656D6F';
wwv_flow_imp.g_varchar2_table(89) := '76654C6173744C697374656E65723A28293D3E652E72656D6F76654C697374656E657228742C69297D293B72657475726E20722E6576656E747D2C652E66726F6D444F4D4576656E74456D69747465723D66756E6374696F6E28652C742C6E3D653D3E65';
wwv_flow_imp.g_varchar2_table(90) := '297B636F6E737420693D282E2E2E65293D3E722E66697265286E282E2E2E6529292C723D6E65772053287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6164644576656E744C697374656E657228742C69292C6F6E44696452';
wwv_flow_imp.g_varchar2_table(91) := '656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F76654576656E744C697374656E657228742C69297D293B72657475726E20722E6576656E747D2C652E746F50726F6D6973653D66756E6374696F6E2865297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(92) := '772050726F6D69736528286E3D3E74286529286E2929297D2C652E66726F6D50726F6D6973653D66756E6374696F6E2865297B636F6E737420743D6E657720533B72657475726E20652E7468656E2828653D3E7B742E666972652865297D292C2828293D';
wwv_flow_imp.g_varchar2_table(93) := '3E7B742E6669726528766F69642030297D29292E66696E616C6C79282828293D3E7B742E646973706F736528297D29292C742E6576656E747D2C652E72756E416E645375627363726962653D66756E6374696F6E28652C742C6E297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(94) := '286E292C652828653D3E7428652929297D3B636C617373206C7B636F6E7374727563746F7228652C74297B746869732E5F6F627365727661626C653D652C746869732E5F636F756E7465723D302C746869732E5F6861734368616E6765643D21313B636F';
wwv_flow_imp.g_varchar2_table(95) := '6E7374206E3D7B6F6E57696C6C41646446697273744C697374656E65723A28293D3E7B652E6164644F627365727665722874686973297D2C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E7B652E72656D6F76654F627365727665';
wwv_flow_imp.g_varchar2_table(96) := '722874686973297D7D3B746869732E656D69747465723D6E65772053286E292C742626742E61646428746869732E656D6974746572297D626567696E5570646174652865297B746869732E5F636F756E7465722B2B7D68616E646C65506F737369626C65';
wwv_flow_imp.g_varchar2_table(97) := '4368616E67652865297B7D68616E646C654368616E676528652C74297B746869732E5F6861734368616E6765643D21307D656E645570646174652865297B746869732E5F636F756E7465722D2D2C303D3D3D746869732E5F636F756E7465722626287468';
wwv_flow_imp.g_varchar2_table(98) := '69732E5F6F627365727661626C652E7265706F72744368616E67657328292C746869732E5F6861734368616E676564262628746869732E5F6861734368616E6765643D21312C746869732E656D69747465722E6669726528746869732E5F6F6273657276';
wwv_flow_imp.g_varchar2_table(99) := '61626C652E67657428292929297D7D652E66726F6D4F627365727661626C653D66756E6374696F6E28652C74297B72657475726E206E6577206C28652C74292E656D69747465722E6576656E747D2C652E66726F6D4F627365727661626C654C69676874';
wwv_flow_imp.g_varchar2_table(100) := '3D66756E6374696F6E2865297B72657475726E28742C6E2C69293D3E7B6C657420723D302C733D21313B636F6E7374206F3D7B626567696E55706461746528297B722B2B7D2C656E6455706461746528297B722D2D2C303D3D3D72262628652E7265706F';
wwv_flow_imp.g_varchar2_table(101) := '72744368616E67657328292C73262628733D21312C742E63616C6C286E2929297D2C68616E646C65506F737369626C654368616E676528297B7D2C68616E646C654368616E676528297B733D21307D7D3B652E6164644F62736572766572286F292C652E';
wwv_flow_imp.g_varchar2_table(102) := '7265706F72744368616E67657328293B636F6E737420613D7B646973706F736528297B652E72656D6F76654F62736572766572286F297D7D3B72657475726E206920696E7374616E63656F6620663F692E6164642861293A41727261792E697341727261';
wwv_flow_imp.g_varchar2_table(103) := '792869292626692E707573682861292C617D7D7D28797C7C28793D7B7D29293B636C617373204C7B636F6E7374727563746F722865297B746869732E6C697374656E6572436F756E743D302C746869732E696E766F636174696F6E436F756E743D302C74';
wwv_flow_imp.g_varchar2_table(104) := '6869732E656C61707365644F766572616C6C3D302C746869732E6475726174696F6E733D5B5D2C746869732E6E616D653D60247B657D5F247B4C2E5F6964506F6F6C2B2B7D602C4C2E616C6C2E6164642874686973297D73746172742865297B74686973';
wwv_flow_imp.g_varchar2_table(105) := '2E5F73746F7057617463683D6E657720432C746869732E6C697374656E6572436F756E743D657D73746F7028297B696628746869732E5F73746F705761746368297B636F6E737420653D746869732E5F73746F7057617463682E656C617073656428293B';
wwv_flow_imp.g_varchar2_table(106) := '746869732E6475726174696F6E732E707573682865292C746869732E656C61707365644F766572616C6C2B3D652C746869732E696E766F636174696F6E436F756E742B3D312C746869732E5F73746F7057617463683D766F696420307D7D7D4C2E616C6C';
wwv_flow_imp.g_varchar2_table(107) := '3D6E6577205365742C4C2E5F6964506F6F6C3D303B636C61737320777B636F6E7374727563746F7228652C743D4D6174682E72616E646F6D28292E746F537472696E67283138292E736C69636528322C3529297B746869732E7468726573686F6C643D65';
wwv_flow_imp.g_varchar2_table(108) := '2C746869732E6E616D653D742C746869732E5F7761726E436F756E74646F776E3D307D646973706F736528297B76617220653B6E756C6C3D3D3D28653D746869732E5F737461636B73297C7C766F696420303D3D3D657C7C652E636C65617228297D6368';
wwv_flow_imp.g_varchar2_table(109) := '65636B28652C74297B636F6E7374206E3D746869732E7468726573686F6C643B6966286E3C3D307C7C743C6E2972657475726E3B746869732E5F737461636B737C7C28746869732E5F737461636B733D6E6577204D6170293B636F6E737420693D746869';
wwv_flow_imp.g_varchar2_table(110) := '732E5F737461636B732E67657428652E76616C7565297C7C303B696628746869732E5F737461636B732E73657428652E76616C75652C692B31292C746869732E5F7761726E436F756E74646F776E2D3D312C746869732E5F7761726E436F756E74646F77';
wwv_flow_imp.g_varchar2_table(111) := '6E3C3D30297B6C657420653B746869732E5F7761726E436F756E74646F776E3D2E352A6E3B6C657420693D303B666F7228636F6E73745B742C6E5D6F6620746869732E5F737461636B73292821657C7C693C6E29262628653D742C693D6E293B636F6E73';
wwv_flow_imp.g_varchar2_table(112) := '6F6C652E7761726E28605B247B746869732E6E616D657D5D20706F74656E7469616C206C697374656E6572204C45414B2064657465637465642C20686176696E6720247B747D206C697374656E65727320616C72656164792E204D4F5354206672657175';
wwv_flow_imp.g_varchar2_table(113) := '656E74206C697374656E65722028247B697D293A60292C636F6E736F6C652E7761726E2865297D72657475726E28293D3E7B636F6E737420743D746869732E5F737461636B732E67657428652E76616C7565297C7C303B746869732E5F737461636B732E';
wwv_flow_imp.g_varchar2_table(114) := '73657428652E76616C75652C742D31297D7D7D636C617373204E7B7374617469632063726561746528297B76617220653B72657475726E206E6577204E286E756C6C213D3D28653D286E6577204572726F72292E737461636B292626766F69642030213D';
wwv_flow_imp.g_varchar2_table(115) := '3D653F653A2222297D636F6E7374727563746F722865297B746869732E76616C75653D657D7072696E7428297B636F6E736F6C652E7761726E28746869732E76616C75652E73706C697428225C6E22292E736C6963652832292E6A6F696E28225C6E2229';
wwv_flow_imp.g_varchar2_table(116) := '297D7D636C61737320457B636F6E7374727563746F722865297B746869732E76616C75653D657D7D636C61737320537B636F6E7374727563746F722865297B76617220742C6E2C692C722C733B746869732E5F73697A653D302C746869732E5F6F707469';
wwv_flow_imp.g_varchar2_table(117) := '6F6E733D652C746869732E5F6C65616B6167654D6F6E3D286E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6C65616B5761726E696E675468726573686F6C64293F6E65772077286E75';
wwv_flow_imp.g_varchar2_table(118) := '6C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C65616B5761726E696E675468726573686F6C64292626766F69642030213D3D693F693A2D31293A766F69642030';
wwv_flow_imp.g_varchar2_table(119) := '2C746869732E5F706572664D6F6E3D286E756C6C3D3D3D28723D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E5F70726F664E616D65293F6E6577204C28746869732E5F6F7074696F6E732E5F70726F664E61';
wwv_flow_imp.g_varchar2_table(120) := '6D65293A766F696420302C746869732E5F64656C697665727951756575653D6E756C6C3D3D3D28733D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D733F766F696420303A732E64656C697665727951756575657D646973706F73652829';
wwv_flow_imp.g_varchar2_table(121) := '7B76617220652C742C6E2C693B746869732E5F646973706F7365647C7C28746869732E5F646973706F7365643D21302C286E756C6C3D3D3D28653D746869732E5F64656C69766572795175657565297C7C766F696420303D3D3D653F766F696420303A65';
wwv_flow_imp.g_varchar2_table(122) := '2E63757272656E74293D3D3D746869732626746869732E5F64656C697665727951756575652E726573657428292C746869732E5F6C697374656E657273262628746869732E5F6C697374656E6572733D766F696420302C746869732E5F73697A653D3029';
wwv_flow_imp.g_varchar2_table(123) := '2C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D6E7C7C6E2E63616C';
wwv_flow_imp.g_varchar2_table(124) := '6C2874292C6E756C6C3D3D3D28693D746869732E5F6C65616B6167654D6F6E297C7C766F696420303D3D3D697C7C692E646973706F73652829297D676574206576656E7428297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F';
wwv_flow_imp.g_varchar2_table(125) := '6576656E74292626766F69642030213D3D657C7C28746869732E5F6576656E743D28652C742C6E293D3E7B76617220692C722C732C6F2C613B696628746869732E5F6C65616B6167654D6F6E2626746869732E5F73697A653E332A746869732E5F6C6561';
wwv_flow_imp.g_varchar2_table(126) := '6B6167654D6F6E2E7468726573686F6C642972657475726E20636F6E736F6C652E7761726E28605B247B746869732E5F6C65616B6167654D6F6E2E6E616D657D5D205245465553455320746F20616363657074206E6577206C697374656E657273206265';
wwv_flow_imp.g_varchar2_table(127) := '636175736520697420657863656564656420697473207468726573686F6C642062792066617260292C702E4E6F6E653B696628746869732E5F646973706F7365642972657475726E20702E4E6F6E653B74262628653D652E62696E64287429293B636F6E';
wwv_flow_imp.g_varchar2_table(128) := '7374206C3D6E657720452865293B6C657420753B746869732E5F6C65616B6167654D6F6E2626746869732E5F73697A653E3D4D6174682E6365696C282E322A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C64292626286C2E737461636B';
wwv_flow_imp.g_varchar2_table(129) := '3D4E2E63726561746528292C753D746869732E5F6C65616B6167654D6F6E2E636865636B286C2E737461636B2C746869732E5F73697A652B3129292C746869732E5F6C697374656E6572733F746869732E5F6C697374656E65727320696E7374616E6365';
wwv_flow_imp.g_varchar2_table(130) := '6F6620453F286E756C6C213D3D28613D746869732E5F64656C69766572795175657565292626766F69642030213D3D617C7C28746869732E5F64656C697665727951756575653D6E65772052292C746869732E5F6C697374656E6572733D5B746869732E';
wwv_flow_imp.g_varchar2_table(131) := '5F6C697374656E6572732C6C5D293A746869732E5F6C697374656E6572732E70757368286C293A286E756C6C3D3D3D28723D6E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E5769';
wwv_flow_imp.g_varchar2_table(132) := '6C6C41646446697273744C697374656E6572297C7C766F696420303D3D3D727C7C722E63616C6C28692C74686973292C746869732E5F6C697374656E6572733D6C2C6E756C6C3D3D3D286F3D6E756C6C3D3D3D28733D746869732E5F6F7074696F6E7329';
wwv_flow_imp.g_varchar2_table(133) := '7C7C766F696420303D3D3D733F766F696420303A732E6F6E44696441646446697273744C697374656E6572297C7C766F696420303D3D3D6F7C7C6F2E63616C6C28732C7468697329292C746869732E5F73697A652B2B3B636F6E737420683D6728282829';
wwv_flow_imp.g_varchar2_table(134) := '3D3E7B6E756C6C3D3D757C7C7528292C746869732E5F72656D6F76654C697374656E6572286C297D29293B72657475726E206E20696E7374616E63656F6620663F6E2E6164642868293A41727261792E69734172726179286E2926266E2E707573682868';
wwv_flow_imp.g_varchar2_table(135) := '292C687D292C746869732E5F6576656E747D5F72656D6F76654C697374656E65722865297B76617220742C6E2C692C723B6966286E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F76';
wwv_flow_imp.g_varchar2_table(136) := '6F696420303A742E6F6E57696C6C52656D6F76654C697374656E6572297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C74686973292C21746869732E5F6C697374656E6572732972657475726E3B696628313D3D3D746869732E5F73697A6529';
wwv_flow_imp.g_varchar2_table(137) := '72657475726E20746869732E5F6C697374656E6572733D766F696420302C6E756C6C3D3D3D28723D6E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E44696452656D6F76654C6173';
wwv_flow_imp.g_varchar2_table(138) := '744C697374656E6572297C7C766F696420303D3D3D727C7C722E63616C6C28692C74686973292C766F696428746869732E5F73697A653D30293B636F6E737420733D746869732E5F6C697374656E6572732C6F3D732E696E6465784F662865293B696628';
wwv_flow_imp.g_varchar2_table(139) := '2D313D3D3D6F297468726F7720636F6E736F6C652E6C6F672822646973706F7365643F222C746869732E5F646973706F736564292C636F6E736F6C652E6C6F67282273697A653F222C746869732E5F73697A65292C636F6E736F6C652E6C6F6728226172';
wwv_flow_imp.g_varchar2_table(140) := '723F222C4A534F4E2E737472696E6769667928746869732E5F6C697374656E65727329292C6E6577204572726F722822417474656D7074656420746F20646973706F736520756E6B6E6F776E206C697374656E657222293B746869732E5F73697A652D2D';
wwv_flow_imp.g_varchar2_table(141) := '2C735B6F5D3D766F696420303B636F6E737420613D746869732E5F64656C697665727951756575652E63757272656E743D3D3D746869733B696628322A746869732E5F73697A653C3D732E6C656E677468297B6C657420653D303B666F72286C65742074';
wwv_flow_imp.g_varchar2_table(142) := '3D303B743C732E6C656E6774683B742B2B29735B745D3F735B652B2B5D3D735B745D3A61262628746869732E5F64656C697665727951756575652E656E642D2D2C653C746869732E5F64656C697665727951756575652E692626746869732E5F64656C69';
wwv_flow_imp.g_varchar2_table(143) := '7665727951756575652E692D2D293B732E6C656E6774683D657D7D5F64656C6976657228652C6E297B76617220693B69662821652972657475726E3B636F6E737420723D286E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420';
wwv_flow_imp.g_varchar2_table(144) := '303D3D3D693F766F696420303A692E6F6E4C697374656E65724572726F72297C7C743B69662872297472797B652E76616C7565286E297D63617463682865297B722865297D656C736520652E76616C7565286E297D5F64656C6976657251756575652865';
wwv_flow_imp.g_varchar2_table(145) := '297B636F6E737420743D652E63757272656E742E5F6C697374656E6572733B666F72283B652E693C652E656E643B29746869732E5F64656C6976657228745B652E692B2B5D2C652E76616C7565293B652E726573657428297D666972652865297B766172';
wwv_flow_imp.g_varchar2_table(146) := '20742C6E2C692C723B696628286E756C6C3D3D3D28743D746869732E5F64656C69766572795175657565297C7C766F696420303D3D3D743F766F696420303A742E63757272656E7429262628746869732E5F64656C69766572517565756528746869732E';
wwv_flow_imp.g_varchar2_table(147) := '5F64656C69766572795175657565292C6E756C6C3D3D3D286E3D746869732E5F706572664D6F6E297C7C766F696420303D3D3D6E7C7C6E2E73746F702829292C6E756C6C3D3D3D28693D746869732E5F706572664D6F6E297C7C766F696420303D3D3D69';
wwv_flow_imp.g_varchar2_table(148) := '7C7C692E737461727428746869732E5F73697A65292C746869732E5F6C697374656E65727329696628746869732E5F6C697374656E65727320696E7374616E63656F66204529746869732E5F64656C6976657228746869732E5F6C697374656E6572732C';
wwv_flow_imp.g_varchar2_table(149) := '65293B656C73657B636F6E737420743D746869732E5F64656C697665727951756575653B742E656E717565756528746869732C652C746869732E5F6C697374656E6572732E6C656E677468292C746869732E5F64656C6976657251756575652874297D6E';
wwv_flow_imp.g_varchar2_table(150) := '756C6C3D3D3D28723D746869732E5F706572664D6F6E297C7C766F696420303D3D3D727C7C722E73746F7028297D6861734C697374656E65727328297B72657475726E20746869732E5F73697A653E307D7D636C61737320527B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(151) := '7228297B746869732E693D2D312C746869732E656E643D307D656E717565756528652C742C6E297B746869732E693D302C746869732E656E643D6E2C746869732E63757272656E743D652C746869732E76616C75653D747D726573657428297B74686973';
wwv_flow_imp.g_varchar2_table(152) := '2E693D746869732E656E642C746869732E63757272656E743D766F696420302C746869732E76616C75653D766F696420307D7D66756E6374696F6E20412865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(153) := '65297B6C657420743D5B5D3B666F72283B4F626A6563742E70726F746F74797065213D3D653B29743D742E636F6E636174284F626A6563742E6765744F776E50726F70657274794E616D6573286529292C653D4F626A6563742E67657450726F746F7479';
wwv_flow_imp.g_varchar2_table(154) := '70654F662865293B72657475726E20747D286529292266756E6374696F6E223D3D747970656F6620655B6E5D2626742E70757368286E293B72657475726E20747D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B6C6574';
wwv_flow_imp.g_varchar2_table(155) := '20783D22756E646566696E656422213D747970656F6620646F63756D656E742626646F63756D656E742E6C6F636174696F6E2626646F63756D656E742E6C6F636174696F6E2E686173682E696E6465784F66282270736575646F3D7472756522293E3D30';
wwv_flow_imp.g_varchar2_table(156) := '3B66756E6374696F6E204D28652C742C2E2E2E6E297B72657475726E2066756E6374696F6E28652C74297B6C6574206E3B72657475726E206E3D303D3D3D742E6C656E6774683F653A652E7265706C616365282F5C7B285C642B295C7D2F672C2828652C';
wwv_flow_imp.g_varchar2_table(157) := '6E293D3E7B636F6E737420693D6E5B305D2C723D745B695D3B6C657420733D653B72657475726E22737472696E67223D3D747970656F6620723F733D723A226E756D62657222213D747970656F662072262622626F6F6C65616E22213D747970656F6620';
wwv_flow_imp.g_varchar2_table(158) := '7226266E756C6C213D727C7C28733D537472696E67287229292C737D29292C782626286E3D22EFBCBB222B6E2E7265706C616365282F5B616F7565695D2F672C222426242622292B22EFBCBD22292C6E7D28742C6E297D766172206B2C4F3B636F6E7374';
wwv_flow_imp.g_varchar2_table(159) := '20543D22656E223B6C657420492C502C443D21312C463D21312C4B3D21312C713D21312C563D21312C423D21312C553D21312C7A3D21312C483D21312C573D21312C243D6E756C6C2C6A3D6E756C6C2C473D6E756C6C3B636F6E737420513D676C6F6261';
wwv_flow_imp.g_varchar2_table(160) := '6C546869733B6C657420583B766F69642030213D3D512E7673636F64652626766F69642030213D3D512E7673636F64652E70726F636573733F583D512E7673636F64652E70726F636573733A22756E646566696E656422213D747970656F662070726F63';
wwv_flow_imp.g_varchar2_table(161) := '657373262622737472696E67223D3D747970656F66286E756C6C3D3D3D286B3D6E756C6C3D3D3D70726F636573737C7C766F696420303D3D3D70726F636573733F766F696420303A70726F636573732E76657273696F6E73297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(162) := '6B3F766F696420303A6B2E6E6F646529262628583D70726F63657373293B636F6E7374204A3D22737472696E67223D3D747970656F66286E756C6C3D3D3D284F3D6E756C6C3D3D583F766F696420303A582E76657273696F6E73297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(163) := '3D3D4F3F766F696420303A4F2E656C656374726F6E292C593D4A26262272656E6465726572223D3D3D286E756C6C3D3D583F766F696420303A582E74797065293B696628226F626A656374223D3D747970656F662058297B443D2277696E3332223D3D3D';
wwv_flow_imp.g_varchar2_table(164) := '582E706C6174666F726D2C463D2264617277696E223D3D3D582E706C6174666F726D2C4B3D226C696E7578223D3D3D582E706C6174666F726D2C713D4B26262121582E656E762E534E415026262121582E656E762E534E41505F5245564953494F4E2C55';
wwv_flow_imp.g_varchar2_table(165) := '3D4A2C483D2121582E656E762E43497C7C2121582E656E762E4255494C445F415254494641435453544147494E474449524543544F52592C493D542C243D543B636F6E737420653D582E656E762E5653434F44455F4E4C535F434F4E4649473B69662865';
wwv_flow_imp.g_varchar2_table(166) := '297472797B636F6E737420743D4A534F4E2E70617273652865292C6E3D742E617661696C61626C654C616E6775616765735B222A225D3B493D742E6C6F63616C652C6A3D742E6F734C6F63616C652C243D6E7C7C542C473D742E5F7472616E736C617469';
wwv_flow_imp.g_varchar2_table(167) := '6F6E73436F6E66696746696C657D63617463682865297B7D563D21307D656C7365226F626A65637422213D747970656F66206E6176696761746F727C7C593F636F6E736F6C652E6572726F722822556E61626C6520746F207265736F6C766520706C6174';
wwv_flow_imp.g_varchar2_table(168) := '666F726D2E22293A28503D6E6176696761746F722E757365724167656E742C443D502E696E6465784F66282257696E646F777322293E3D302C463D502E696E6465784F6628224D6163696E746F736822293E3D302C7A3D28502E696E6465784F6628224D';
wwv_flow_imp.g_varchar2_table(169) := '6163696E746F736822293E3D307C7C502E696E6465784F6628226950616422293E3D307C7C502E696E6465784F6628226950686F6E6522293E3D3029262621216E6176696761746F722E6D6178546F756368506F696E747326266E6176696761746F722E';
wwv_flow_imp.g_varchar2_table(170) := '6D6178546F756368506F696E74733E302C4B3D502E696E6465784F6628224C696E757822293E3D302C573D286E756C6C3D3D503F766F696420303A502E696E6465784F6628224D6F62692229293E3D302C423D21302C493D766F6964204D28302C225F22';
wwv_flow_imp.g_varchar2_table(171) := '297C7C542C243D492C6A3D6E6176696761746F722E6C616E6775616765293B6C6574205A3D303B463F5A3D313A443F5A3D333A4B2626285A3D32293B636F6E73742065653D442C74653D462C6E653D284226262266756E6374696F6E223D3D747970656F';
wwv_flow_imp.g_varchar2_table(172) := '6620512E696D706F7274536372697074732626512E6F726967696E2C50292C69653D2266756E6374696F6E223D3D747970656F6620512E706F73744D657373616765262621512E696D706F7274536372697074733B2828293D3E7B6966286965297B636F';
wwv_flow_imp.g_varchar2_table(173) := '6E737420653D5B5D3B512E6164644576656E744C697374656E657228226D657373616765222C28743D3E7B696628742E646174612626742E646174612E7673636F64655363686564756C654173796E63576F726B29666F72286C6574206E3D302C693D65';
wwv_flow_imp.g_varchar2_table(174) := '2E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B696628692E69643D3D3D742E646174612E7673636F64655363686564756C654173796E63576F726B2972657475726E20652E73706C696365286E2C31292C766F696420692E63';
wwv_flow_imp.g_varchar2_table(175) := '616C6C6261636B28297D7D29293B6C657420743D307D7D2928293B636F6E73742072653D2121286E6526266E652E696E6465784F6628224368726F6D6522293E3D30293B66756E6374696F6E2073652865297B72657475726E20657D6E6526266E652E69';
wwv_flow_imp.g_varchar2_table(176) := '6E6465784F66282246697265666F7822292C21726526266E6526266E652E696E6465784F66282253616661726922292C6E6526266E652E696E6465784F6628224564672F22292C6E6526266E652E696E6465784F662822416E64726F696422293B636C61';
wwv_flow_imp.g_varchar2_table(177) := '7373206F657B636F6E7374727563746F722865297B746869732E6578656375746F723D652C746869732E5F64696452756E3D21317D6765742076616C756528297B69662821746869732E5F64696452756E297472797B746869732E5F76616C75653D7468';
wwv_flow_imp.g_varchar2_table(178) := '69732E6578656375746F7228297D63617463682865297B746869732E5F6572726F723D657D66696E616C6C797B746869732E5F64696452756E3D21307D696628746869732E5F6572726F72297468726F7720746869732E5F6572726F723B72657475726E';
wwv_flow_imp.g_varchar2_table(179) := '20746869732E5F76616C75657D6765742072617756616C756528297B72657475726E20746869732E5F76616C75657D7D7661722061653B66756E6374696F6E206C652865297B72657475726E20653E3D36352626653C3D39307D66756E6374696F6E2075';
wwv_flow_imp.g_varchar2_table(180) := '652865297B72657475726E2035353239363C3D652626653C3D35363331397D66756E6374696F6E2068652865297B72657475726E2035363332303C3D652626653C3D35373334337D66756E6374696F6E20636528652C74297B72657475726E20742D3536';
wwv_flow_imp.g_varchar2_table(181) := '3332302B28652D35353239363C3C3130292B36353533367D66756E6374696F6E20646528652C742C6E297B636F6E737420693D652E63686172436F64654174286E293B696628756528692926266E2B313C74297B636F6E737420743D652E63686172436F';
wwv_flow_imp.g_varchar2_table(182) := '64654174286E2B31293B69662868652874292972657475726E20636528692C74297D72657475726E20697D636F6E7374206D653D2F5E5B5C745C6E5C725C7832302D5C7837455D2A242F3B537472696E672E66726F6D43686172436F6465283635323739';
wwv_flow_imp.g_varchar2_table(183) := '293B636C6173732067657B73746174696320676574496E7374616E636528297B72657475726E2067652E5F494E5354414E43457C7C2867652E5F494E5354414E43453D6E6577206765292C67652E5F494E5354414E43457D636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(184) := '297B746869732E5F646174613D4A534F4E2E706172736528225B302C302C302C35313232392C35313235352C31322C34343036312C34343038372C31322C3132373436322C3132373438372C362C373038332C373038352C352C34373634352C34373637';
wwv_flow_imp.g_varchar2_table(185) := '312C31322C35343831332C35343833392C31322C3132383637382C3132383637382C31342C333237302C333237302C352C393931392C393932332C31342C34353835332C34353837392C31322C34393433372C34393436332C31322C35333032312C3533';
wwv_flow_imp.g_varchar2_table(186) := '3034372C31322C37313231362C37313231382C372C3132383339382C3132383339392C31342C3132393336302C3132393337342C31342C323531392C323531392C352C343434382C343531392C392C393734322C393734322C31342C31323333362C3132';
wwv_flow_imp.g_varchar2_table(187) := '3333362C31342C34343935372C34343938332C31322C34363734392C34363737352C31322C34383534312C34383536372C31322C35303333332C35303335392C31322C35323132352C35323135312C31322C35333931372C35333934332C31322C363938';
wwv_flow_imp.g_varchar2_table(188) := '38382C36393839302C352C37333031382C37333031382C352C3132373939302C3132373939302C31342C3132383535382C3132383535392C31342C3132383735392C3132383736302C31342C3132393635332C3132393635352C31342C323032372C3230';
wwv_flow_imp.g_varchar2_table(189) := '33352C352C323839312C323839322C372C333736312C333736312C352C363638332C363638332C352C383239332C383239332C342C393832352C393832362C31342C393939392C393939392C31342C34333435322C34333435332C352C34343530392C34';
wwv_flow_imp.g_varchar2_table(190) := '343533352C31322C34353430352C34353433312C31322C34363330312C34363332372C31322C34373139372C34373232332C31322C34383039332C34383131392C31322C34383938392C34393031352C31322C34393838352C34393931312C31322C3530';
wwv_flow_imp.g_varchar2_table(191) := '3738312C35303830372C31322C35313637372C35313730332C31322C35323537332C35323539392C31322C35333436392C35333439352C31322C35343336352C35343339312C31322C36353237392C36353237392C342C37303437312C37303437322C37';
wwv_flow_imp.g_varchar2_table(192) := '2C37323134352C37323134372C372C3131393137332C3131393137392C352C3132373739392C3132373831382C31342C3132383234302C3132383234342C31342C3132383531322C3132383531322C31342C3132383635322C3132383635322C31342C31';
wwv_flow_imp.g_varchar2_table(193) := '32383732312C3132383732322C31342C3132393239322C3132393239322C31342C3132393434352C3132393435302C31342C3132393733342C3132393734332C31342C313437362C313437372C352C323336362C323336382C372C323735302C32373532';
wwv_flow_imp.g_varchar2_table(194) := '2C372C333037362C333037362C352C333431352C333431352C352C343134312C343134342C352C363130392C363130392C352C363936342C363936342C352C373339342C373430302C352C393139372C393139382C31342C393737302C393737302C3134';
wwv_flow_imp.g_varchar2_table(195) := '2C393837372C393837372C31342C393936382C393936392C31342C31303038342C31303038342C31342C34333035322C34333035322C352C34333731332C34333731332C352C34343238352C34343331312C31322C34343733332C34343735392C31322C';
wwv_flow_imp.g_varchar2_table(196) := '34353138312C34353230372C31322C34353632392C34353635352C31322C34363037372C34363130332C31322C34363532352C34363535312C31322C34363937332C34363939392C31322C34373432312C34373434372C31322C34373836392C34373839';
wwv_flow_imp.g_varchar2_table(197) := '352C31322C34383331372C34383334332C31322C34383736352C34383739312C31322C34393231332C34393233392C31322C34393636312C34393638372C31322C35303130392C35303133352C31322C35303535372C35303538332C31322C3531303035';
wwv_flow_imp.g_varchar2_table(198) := '2C35313033312C31322C35313435332C35313437392C31322C35313930312C35313932372C31322C35323334392C35323337352C31322C35323739372C35323832332C31322C35333234352C35333237312C31322C35333639332C35333731392C31322C';
wwv_flow_imp.g_varchar2_table(199) := '35343134312C35343136372C31322C35343538392C35343631352C31322C35353033372C35353036332C31322C36393530362C36393530392C352C37303139312C37303139332C352C37303834312C37303834312C372C37313436332C37313436372C35';
wwv_flow_imp.g_varchar2_table(200) := '2C37323333302C37323334322C352C39343033312C39343033312C352C3132333632382C3132333633312C352C3132373736332C3132373736352C31342C3132373934312C3132373934312C31342C3132383034332C3132383036322C31342C31323833';
wwv_flow_imp.g_varchar2_table(201) := '30322C3132383331372C31342C3132383436352C3132383436372C31342C3132383533392C3132383533392C31342C3132383634302C3132383634302C31342C3132383636322C3132383636322C31342C3132383730332C3132383730332C31342C3132';
wwv_flow_imp.g_varchar2_table(202) := '383734352C3132383734352C31342C3132393030342C3132393030372C31342C3132393332392C3132393333302C31342C3132393430322C3132393430322C31342C3132393438332C3132393438332C31342C3132393638362C3132393730342C31342C';
wwv_flow_imp.g_varchar2_table(203) := '3133303034382C3133313036392C31342C3137332C3137332C342C313735372C313735372C312C323230302C323230372C352C323433342C323433352C372C323633312C323633322C352C323831372C323831372C352C333030382C333030382C352C33';
wwv_flow_imp.g_varchar2_table(204) := '3230312C333230312C352C333338372C333338382C352C333534322C333534322C352C333930322C333930332C372C343139302C343139322C352C363030322C363030332C352C363433392C363434302C352C363736352C363737302C372C373031392C';
wwv_flow_imp.g_varchar2_table(205) := '373032372C352C373135342C373135352C372C383230352C383230352C31332C383530352C383530352C31342C393635342C393635342C31342C393735372C393735372C31342C393739322C393739322C31342C393835322C393835332C31342C393839';
wwv_flow_imp.g_varchar2_table(206) := '302C393839342C31342C393933372C393933372C31342C393938312C393938312C31342C31303033352C31303033362C31342C31313033352C31313033362C31342C34323635342C34323635352C352C34333334362C34333334372C372C34333538372C';
wwv_flow_imp.g_varchar2_table(207) := '34333538372C352C34343030362C34343030372C372C34343137332C34343139392C31322C34343339372C34343432332C31322C34343632312C34343634372C31322C34343834352C34343837312C31322C34353036392C34353039352C31322C343532';
wwv_flow_imp.g_varchar2_table(208) := '39332C34353331392C31322C34353531372C34353534332C31322C34353734312C34353736372C31322C34353936352C34353939312C31322C34363138392C34363231352C31322C34363431332C34363433392C31322C34363633372C34363636332C31';
wwv_flow_imp.g_varchar2_table(209) := '322C34363836312C34363838372C31322C34373038352C34373131312C31322C34373330392C34373333352C31322C34373533332C34373535392C31322C34373735372C34373738332C31322C34373938312C34383030372C31322C34383230352C3438';
wwv_flow_imp.g_varchar2_table(210) := '3233312C31322C34383432392C34383435352C31322C34383635332C34383637392C31322C34383837372C34383930332C31322C34393130312C34393132372C31322C34393332352C34393335312C31322C34393534392C34393537352C31322C343937';
wwv_flow_imp.g_varchar2_table(211) := '37332C34393739392C31322C34393939372C35303032332C31322C35303232312C35303234372C31322C35303434352C35303437312C31322C35303636392C35303639352C31322C35303839332C35303931392C31322C35313131372C35313134332C31';
wwv_flow_imp.g_varchar2_table(212) := '322C35313334312C35313336372C31322C35313536352C35313539312C31322C35313738392C35313831352C31322C35323031332C35323033392C31322C35323233372C35323236332C31322C35323436312C35323438372C31322C35323638352C3532';
wwv_flow_imp.g_varchar2_table(213) := '3731312C31322C35323930392C35323933352C31322C35333133332C35333135392C31322C35333335372C35333338332C31322C35333538312C35333630372C31322C35333830352C35333833312C31322C35343032392C35343035352C31322C353432';
wwv_flow_imp.g_varchar2_table(214) := '35332C35343237392C31322C35343437372C35343530332C31322C35343730312C35343732372C31322C35343932352C35343935312C31322C35353134392C35353137352C31322C36383130312C36383130322C352C36393736322C36393736322C372C';
wwv_flow_imp.g_varchar2_table(215) := '37303036372C37303036392C372C37303337312C37303337382C352C37303732302C37303732312C372C37313038372C37313038372C352C37313334312C37313334312C352C37313939352C37313939362C352C37323234392C37323234392C372C3732';
wwv_flow_imp.g_varchar2_table(216) := '3835302C37323837312C352C37333130392C37333130392C352C3131383537362C3131383539382C352C3132313530352C3132313531392C352C3132373234352C3132373234372C31342C3132373536382C3132373536392C31342C3132373737372C31';
wwv_flow_imp.g_varchar2_table(217) := '32373737372C31342C3132373837322C3132373839312C31342C3132373935362C3132373936372C31342C3132383031352C3132383031362C31342C3132383131302C3132383137322C31342C3132383235392C3132383235392C31342C313238333637';
wwv_flow_imp.g_varchar2_table(218) := '2C3132383336382C31342C3132383432342C3132383432342C31342C3132383438382C3132383438382C31342C3132383533302C3132383533322C31342C3132383535302C3132383535312C31342C3132383536362C3132383536362C31342C31323836';
wwv_flow_imp.g_varchar2_table(219) := '34372C3132383634372C31342C3132383635362C3132383635362C31342C3132383636372C3132383637332C31342C3132383639312C3132383639332C31342C3132383731352C3132383731352C31342C3132383732382C3132383733322C31342C3132';
wwv_flow_imp.g_varchar2_table(220) := '383735322C3132383735322C31342C3132383736352C3132383736372C31342C3132393039362C3132393130332C31342C3132393331312C3132393331312C31342C3132393334342C3132393334392C31342C3132393339342C3132393339342C31342C';
wwv_flow_imp.g_varchar2_table(221) := '3132393431332C3132393432352C31342C3132393436362C3132393437312C31342C3132393531312C3132393533352C31342C3132393636342C3132393636362C31342C3132393731392C3132393732322C31342C3132393736302C3132393736372C31';
wwv_flow_imp.g_varchar2_table(222) := '342C3931373533362C3931373633312C352C31332C31332C322C313136302C313136312C352C313536342C313536342C342C313830372C313830372C312C323038352C323038372C352C323330372C323330372C372C323338322C323338332C372C3234';
wwv_flow_imp.g_varchar2_table(223) := '39372C323530302C352C323536332C323536332C372C323637372C323637372C352C323736332C323736342C372C323837392C323837392C352C323931342C323931352C352C333032312C333032312C352C333134322C333134342C352C333236332C33';
wwv_flow_imp.g_varchar2_table(224) := '3236332C352C333238352C333238362C352C333339382C333430302C372C333533302C333533302C352C333633332C333633332C352C333836342C333836352C352C333937342C333937352C352C343135352C343135362C372C343232392C343233302C';
wwv_flow_imp.g_varchar2_table(225) := '352C353930392C353930392C372C363037382C363038352C372C363237372C363237382C352C363435312C363435362C372C363734342C363735302C352C363834362C363834362C352C363937322C363937322C352C373037342C373037372C352C3731';
wwv_flow_imp.g_varchar2_table(226) := '34362C373134382C372C373232322C373232332C352C373431362C373431372C352C383233342C383233382C342C383431372C383431372C352C393030302C393030302C31342C393230332C393230332C31342C393733302C393733312C31342C393734';
wwv_flow_imp.g_varchar2_table(227) := '382C393734392C31342C393736322C393736332C31342C393737362C393738332C31342C393830302C393831312C31342C393833312C393833312C31342C393837322C393837332C31342C393838322C393838322C31342C393930302C393930332C3134';
wwv_flow_imp.g_varchar2_table(228) := '2C393932392C393933332C31342C393934312C393936302C31342C393937342C393937342C31342C393938392C393938392C31342C31303030362C31303030362C31342C31303036322C31303036322C31342C31303136302C31303136302C31342C3131';
wwv_flow_imp.g_varchar2_table(229) := '3634372C31313634372C352C31323935332C31323935332C31342C34333031392C34333031392C352C34333233322C34333234392C352C34333434332C34333434332C352C34333536372C34333536382C372C34333639362C34333639362C352C343337';
wwv_flow_imp.g_varchar2_table(230) := '36352C34333736352C372C34343031332C34343031332C352C34343131372C34343134332C31322C34343232392C34343235352C31322C34343334312C34343336372C31322C34343435332C34343437392C31322C34343536352C34343539312C31322C';
wwv_flow_imp.g_varchar2_table(231) := '34343637372C34343730332C31322C34343738392C34343831352C31322C34343930312C34343932372C31322C34353031332C34353033392C31322C34353132352C34353135312C31322C34353233372C34353236332C31322C34353334392C34353337';
wwv_flow_imp.g_varchar2_table(232) := '352C31322C34353436312C34353438372C31322C34353537332C34353539392C31322C34353638352C34353731312C31322C34353739372C34353832332C31322C34353930392C34353933352C31322C34363032312C34363034372C31322C3436313333';
wwv_flow_imp.g_varchar2_table(233) := '2C34363135392C31322C34363234352C34363237312C31322C34363335372C34363338332C31322C34363436392C34363439352C31322C34363538312C34363630372C31322C34363639332C34363731392C31322C34363830352C34363833312C31322C';
wwv_flow_imp.g_varchar2_table(234) := '34363931372C34363934332C31322C34373032392C34373035352C31322C34373134312C34373136372C31322C34373235332C34373237392C31322C34373336352C34373339312C31322C34373437372C34373530332C31322C34373538392C34373631';
wwv_flow_imp.g_varchar2_table(235) := '352C31322C34373730312C34373732372C31322C34373831332C34373833392C31322C34373932352C34373935312C31322C34383033372C34383036332C31322C34383134392C34383137352C31322C34383236312C34383238372C31322C3438333733';
wwv_flow_imp.g_varchar2_table(236) := '2C34383339392C31322C34383438352C34383531312C31322C34383539372C34383632332C31322C34383730392C34383733352C31322C34383832312C34383834372C31322C34383933332C34383935392C31322C34393034352C34393037312C31322C';
wwv_flow_imp.g_varchar2_table(237) := '34393135372C34393138332C31322C34393236392C34393239352C31322C34393338312C34393430372C31322C34393439332C34393531392C31322C34393630352C34393633312C31322C34393731372C34393734332C31322C34393832392C34393835';
wwv_flow_imp.g_varchar2_table(238) := '352C31322C34393934312C34393936372C31322C35303035332C35303037392C31322C35303136352C35303139312C31322C35303237372C35303330332C31322C35303338392C35303431352C31322C35303530312C35303532372C31322C3530363133';
wwv_flow_imp.g_varchar2_table(239) := '2C35303633392C31322C35303732352C35303735312C31322C35303833372C35303836332C31322C35303934392C35303937352C31322C35313036312C35313038372C31322C35313137332C35313139392C31322C35313238352C35313331312C31322C';
wwv_flow_imp.g_varchar2_table(240) := '35313339372C35313432332C31322C35313530392C35313533352C31322C35313632312C35313634372C31322C35313733332C35313735392C31322C35313834352C35313837312C31322C35313935372C35313938332C31322C35323036392C35323039';
wwv_flow_imp.g_varchar2_table(241) := '352C31322C35323138312C35323230372C31322C35323239332C35323331392C31322C35323430352C35323433312C31322C35323531372C35323534332C31322C35323632392C35323635352C31322C35323734312C35323736372C31322C3532383533';
wwv_flow_imp.g_varchar2_table(242) := '2C35323837392C31322C35323936352C35323939312C31322C35333037372C35333130332C31322C35333138392C35333231352C31322C35333330312C35333332372C31322C35333431332C35333433392C31322C35333532352C35333535312C31322C';
wwv_flow_imp.g_varchar2_table(243) := '35333633372C35333636332C31322C35333734392C35333737352C31322C35333836312C35333838372C31322C35333937332C35333939392C31322C35343038352C35343131312C31322C35343139372C35343232332C31322C35343330392C35343333';
wwv_flow_imp.g_varchar2_table(244) := '352C31322C35343432312C35343434372C31322C35343533332C35343535392C31322C35343634352C35343637312C31322C35343735372C35343738332C31322C35343836392C35343839352C31322C35343938312C35353030372C31322C3535303933';
wwv_flow_imp.g_varchar2_table(245) := '2C35353131392C31322C35353234332C35353239312C31302C36363034352C36363034352C352C36383332352C36383332362C352C36393638382C36393730322C352C36393831372C36393831382C352C36393935372C36393935382C372C3730303839';
wwv_flow_imp.g_varchar2_table(246) := '2C37303039322C352C37303139382C37303139392C352C37303436322C37303436322C352C37303530322C37303530382C352C37303735302C37303735302C352C37303834362C37303834362C372C37313130302C37313130312C352C37313233302C37';
wwv_flow_imp.g_varchar2_table(247) := '313233302C372C37313335312C37313335312C352C37313733372C37313733382C352C37323030302C37323030302C372C37323136302C37323136302C352C37323237332C37323237382C352C37323735322C37323735382C352C37323838322C373238';
wwv_flow_imp.g_varchar2_table(248) := '38332C352C37333033312C37333033312C352C37333436312C37333436322C372C39343139322C39343139332C372C3131393134392C3131393134392C372C3132313430332C3132313435322C352C3132323931352C3132323931362C352C3132363938';
wwv_flow_imp.g_varchar2_table(249) := '302C3132363938302C31342C3132373335382C3132373335392C31342C3132373533352C3132373533352C31342C3132373735392C3132373735392C31342C3132373737312C3132373737312C31342C3132373739322C3132373739332C31342C313237';
wwv_flow_imp.g_varchar2_table(250) := '3832352C3132373836372C31342C3132373839372C3132373839392C31342C3132373934352C3132373934352C31342C3132373938352C3132373938362C31342C3132383030302C3132383030372C31342C3132383032312C3132383032312C31342C31';
wwv_flow_imp.g_varchar2_table(251) := '32383036362C3132383130302C31342C3132383138342C3132383233352C31342C3132383234392C3132383235322C31342C3132383236362C3132383237362C31342C3132383333352C3132383333352C31342C3132383337392C3132383339302C3134';
wwv_flow_imp.g_varchar2_table(252) := '2C3132383430372C3132383431392C31342C3132383434342C3132383434342C31342C3132383438312C3132383438312C31342C3132383439392C3132383439392C31342C3132383532362C3132383532362C31342C3132383533362C3132383533362C';
wwv_flow_imp.g_varchar2_table(253) := '31342C3132383534332C3132383534332C31342C3132383535362C3132383535362C31342C3132383536342C3132383536342C31342C3132383537372C3132383538302C31342C3132383634332C3132383634352C31342C3132383634392C3132383634';
wwv_flow_imp.g_varchar2_table(254) := '392C31342C3132383635342C3132383635342C31342C3132383636302C3132383636302C31342C3132383636342C3132383636342C31342C3132383637352C3132383637352C31342C3132383638362C3132383638392C31342C3132383639352C313238';
wwv_flow_imp.g_varchar2_table(255) := '3639362C31342C3132383730352C3132383730392C31342C3132383731372C3132383731392C31342C3132383732352C3132383732352C31342C3132383733362C3132383734312C31342C3132383734372C3132383734382C31342C3132383735352C31';
wwv_flow_imp.g_varchar2_table(256) := '32383735352C31342C3132383736322C3132383736322C31342C3132383938312C3132383939312C31342C3132393030392C3132393032332C31342C3132393136302C3132393136372C31342C3132393239362C3132393330342C31342C313239333230';
wwv_flow_imp.g_varchar2_table(257) := '2C3132393332372C31342C3132393334302C3132393334322C31342C3132393335362C3132393335362C31342C3132393338382C3132393339322C31342C3132393339392C3132393430302C31342C3132393430342C3132393430372C31342C31323934';
wwv_flow_imp.g_varchar2_table(258) := '33322C3132393434322C31342C3132393435342C3132393435352C31342C3132393437332C3132393437342C31342C3132393438352C3132393438372C31342C3132393634382C3132393635312C31342C3132393635392C3132393636302C31342C3132';
wwv_flow_imp.g_varchar2_table(259) := '393637312C3132393637392C31342C3132393730392C3132393731312C31342C3132393732382C3132393733302C31342C3132393735312C3132393735332C31342C3132393737362C3132393738322C31342C3931373530352C3931373530352C342C39';
wwv_flow_imp.g_varchar2_table(260) := '31373736302C3931373939392C352C31302C31302C332C3132372C3135392C342C3736382C3837392C352C313437312C313437312C352C313533362C313534312C312C313634382C313634382C352C313736372C313736382C352C313834302C31383636';
wwv_flow_imp.g_varchar2_table(261) := '2C352C323037302C323037332C352C323133372C323133392C352C323237342C323237342C312C323336332C323336332C372C323337372C323338302C372C323430322C323430332C352C323439342C323439342C352C323530372C323530382C372C32';
wwv_flow_imp.g_varchar2_table(262) := '3535382C323535382C352C323632322C323632342C372C323634312C323634312C352C323639312C323639312C372C323735392C323736302C352C323738362C323738372C352C323837362C323837362C352C323838312C323838342C352C323930312C';
wwv_flow_imp.g_varchar2_table(263) := '323930322C352C333030362C333030362C352C333031342C333031362C372C333037322C333037322C352C333133342C333133362C352C333135372C333135382C352C333236302C333236302C352C333236362C333236362C352C333237342C33323735';
wwv_flow_imp.g_varchar2_table(264) := '2C372C333332382C333332392C352C333339312C333339322C372C333430352C333430352C352C333435372C333435372C352C333533362C333533372C372C333535312C333535312C352C333633362C333634322C352C333736342C333737322C352C33';
wwv_flow_imp.g_varchar2_table(265) := '3839352C333839352C352C333936372C333936372C372C333939332C343032382C352C343134362C343135312C352C343138322C343138332C372C343232362C343232362C352C343235332C343235332C352C343935372C343935392C352C353934302C';
wwv_flow_imp.g_varchar2_table(266) := '353934302C372C363037302C363037302C372C363038372C363038382C372C363135382C363135382C342C363433322C363433342C352C363434382C363434392C372C363637392C363638302C352C363734322C363734322C352C363735342C36373534';
wwv_flow_imp.g_varchar2_table(267) := '2C352C363738332C363738332C352C363931322C363931352C352C363936362C363937302C352C363937382C363937382C352C373034322C373034322C372C373038302C373038312C352C373134332C373134332C372C373135302C373135302C372C37';
wwv_flow_imp.g_varchar2_table(268) := '3231322C373231392C352C373338302C373339322C352C373431322C373431322C352C383230332C383230332C342C383233322C383233322C342C383236352C383236352C31342C383430302C383431322C352C383432312C383433322C352C38363137';
wwv_flow_imp.g_varchar2_table(269) := '2C383631382C31342C393136372C393136372C31342C393230302C393230302C31342C393431302C393431302C31342C393732332C393732362C31342C393733332C393733332C31342C393734352C393734352C31342C393735322C393735322C31342C';
wwv_flow_imp.g_varchar2_table(270) := '393736302C393736302C31342C393736362C393736362C31342C393737342C393737342C31342C393738362C393738362C31342C393739342C393739342C31342C393832332C393832332C31342C393832382C393832382C31342C393833332C39383530';
wwv_flow_imp.g_varchar2_table(271) := '2C31342C393835352C393835352C31342C393837352C393837352C31342C393838302C393838302C31342C393838352C393838372C31342C393839362C393839372C31342C393930362C393931362C31342C393932362C393932372C31342C393933352C';
wwv_flow_imp.g_varchar2_table(272) := '393933352C31342C393933392C393933392C31342C393936322C393936322C31342C393937322C393937322C31342C393937382C393937382C31342C393938362C393938362C31342C393939372C393939372C31342C31303030322C31303030322C3134';
wwv_flow_imp.g_varchar2_table(273) := '2C31303031372C31303031372C31342C31303035352C31303035352C31342C31303037312C31303037312C31342C31303133332C31303133352C31342C31303534382C31303534392C31342C31313039332C31313039332C31342C31323333302C313233';
wwv_flow_imp.g_varchar2_table(274) := '33332C352C31323434312C31323434322C352C34323630382C34323631302C352C34333031302C34333031302C352C34333034352C34333034362C352C34333138382C34333230332C372C34333330322C34333330392C352C34333339322C3433333934';
wwv_flow_imp.g_varchar2_table(275) := '2C352C34333434362C34333434392C352C34333439332C34333439332C352C34333537312C34333537322C372C34333539372C34333539372C372C34333730332C34333730342C352C34333735362C34333735372C352C34343030332C34343030342C37';
wwv_flow_imp.g_varchar2_table(276) := '2C34343030392C34343031302C372C34343033332C34343035392C31322C34343038392C34343131352C31322C34343134352C34343137312C31322C34343230312C34343232372C31322C34343235372C34343238332C31322C34343331332C34343333';
wwv_flow_imp.g_varchar2_table(277) := '392C31322C34343336392C34343339352C31322C34343432352C34343435312C31322C34343438312C34343530372C31322C34343533372C34343536332C31322C34343539332C34343631392C31322C34343634392C34343637352C31322C3434373035';
wwv_flow_imp.g_varchar2_table(278) := '2C34343733312C31322C34343736312C34343738372C31322C34343831372C34343834332C31322C34343837332C34343839392C31322C34343932392C34343935352C31322C34343938352C34353031312C31322C34353034312C34353036372C31322C';
wwv_flow_imp.g_varchar2_table(279) := '34353039372C34353132332C31322C34353135332C34353137392C31322C34353230392C34353233352C31322C34353236352C34353239312C31322C34353332312C34353334372C31322C34353337372C34353430332C31322C34353433332C34353435';
wwv_flow_imp.g_varchar2_table(280) := '392C31322C34353438392C34353531352C31322C34353534352C34353537312C31322C34353630312C34353632372C31322C34353635372C34353638332C31322C34353731332C34353733392C31322C34353736392C34353739352C31322C3435383235';
wwv_flow_imp.g_varchar2_table(281) := '2C34353835312C31322C34353838312C34353930372C31322C34353933372C34353936332C31322C34353939332C34363031392C31322C34363034392C34363037352C31322C34363130352C34363133312C31322C34363136312C34363138372C31322C';
wwv_flow_imp.g_varchar2_table(282) := '34363231372C34363234332C31322C34363237332C34363239392C31322C34363332392C34363335352C31322C34363338352C34363431312C31322C34363434312C34363436372C31322C34363439372C34363532332C31322C34363535332C34363537';
wwv_flow_imp.g_varchar2_table(283) := '392C31322C34363630392C34363633352C31322C34363636352C34363639312C31322C34363732312C34363734372C31322C34363737372C34363830332C31322C34363833332C34363835392C31322C34363838392C34363931352C31322C3436393435';
wwv_flow_imp.g_varchar2_table(284) := '2C34363937312C31322C34373030312C34373032372C31322C34373035372C34373038332C31322C34373131332C34373133392C31322C34373136392C34373139352C31322C34373232352C34373235312C31322C34373238312C34373330372C31322C';
wwv_flow_imp.g_varchar2_table(285) := '34373333372C34373336332C31322C34373339332C34373431392C31322C34373434392C34373437352C31322C34373530352C34373533312C31322C34373536312C34373538372C31322C34373631372C34373634332C31322C34373637332C34373639';
wwv_flow_imp.g_varchar2_table(286) := '392C31322C34373732392C34373735352C31322C34373738352C34373831312C31322C34373834312C34373836372C31322C34373839372C34373932332C31322C34373935332C34373937392C31322C34383030392C34383033352C31322C3438303635';
wwv_flow_imp.g_varchar2_table(287) := '2C34383039312C31322C34383132312C34383134372C31322C34383137372C34383230332C31322C34383233332C34383235392C31322C34383238392C34383331352C31322C34383334352C34383337312C31322C34383430312C34383432372C31322C';
wwv_flow_imp.g_varchar2_table(288) := '34383435372C34383438332C31322C34383531332C34383533392C31322C34383536392C34383539352C31322C34383632352C34383635312C31322C34383638312C34383730372C31322C34383733372C34383736332C31322C34383739332C34383831';
wwv_flow_imp.g_varchar2_table(289) := '392C31322C34383834392C34383837352C31322C34383930352C34383933312C31322C34383936312C34383938372C31322C34393031372C34393034332C31322C34393037332C34393039392C31322C34393132392C34393135352C31322C3439313835';
wwv_flow_imp.g_varchar2_table(290) := '2C34393231312C31322C34393234312C34393236372C31322C34393239372C34393332332C31322C34393335332C34393337392C31322C34393430392C34393433352C31322C34393436352C34393439312C31322C34393532312C34393534372C31322C';
wwv_flow_imp.g_varchar2_table(291) := '34393537372C34393630332C31322C34393633332C34393635392C31322C34393638392C34393731352C31322C34393734352C34393737312C31322C34393830312C34393832372C31322C34393835372C34393838332C31322C34393931332C34393933';
wwv_flow_imp.g_varchar2_table(292) := '392C31322C34393936392C34393939352C31322C35303032352C35303035312C31322C35303038312C35303130372C31322C35303133372C35303136332C31322C35303139332C35303231392C31322C35303234392C35303237352C31322C3530333035';
wwv_flow_imp.g_varchar2_table(293) := '2C35303333312C31322C35303336312C35303338372C31322C35303431372C35303434332C31322C35303437332C35303439392C31322C35303532392C35303535352C31322C35303538352C35303631312C31322C35303634312C35303636372C31322C';
wwv_flow_imp.g_varchar2_table(294) := '35303639372C35303732332C31322C35303735332C35303737392C31322C35303830392C35303833352C31322C35303836352C35303839312C31322C35303932312C35303934372C31322C35303937372C35313030332C31322C35313033332C35313035';
wwv_flow_imp.g_varchar2_table(295) := '392C31322C35313038392C35313131352C31322C35313134352C35313137312C31322C35313230312C35313232372C31322C35313235372C35313238332C31322C35313331332C35313333392C31322C35313336392C35313339352C31322C3531343235';
wwv_flow_imp.g_varchar2_table(296) := '2C35313435312C31322C35313438312C35313530372C31322C35313533372C35313536332C31322C35313539332C35313631392C31322C35313634392C35313637352C31322C35313730352C35313733312C31322C35313736312C35313738372C31322C';
wwv_flow_imp.g_varchar2_table(297) := '35313831372C35313834332C31322C35313837332C35313839392C31322C35313932392C35313935352C31322C35313938352C35323031312C31322C35323034312C35323036372C31322C35323039372C35323132332C31322C35323135332C35323137';
wwv_flow_imp.g_varchar2_table(298) := '392C31322C35323230392C35323233352C31322C35323236352C35323239312C31322C35323332312C35323334372C31322C35323337372C35323430332C31322C35323433332C35323435392C31322C35323438392C35323531352C31322C3532353435';
wwv_flow_imp.g_varchar2_table(299) := '2C35323537312C31322C35323630312C35323632372C31322C35323635372C35323638332C31322C35323731332C35323733392C31322C35323736392C35323739352C31322C35323832352C35323835312C31322C35323838312C35323930372C31322C';
wwv_flow_imp.g_varchar2_table(300) := '35323933372C35323936332C31322C35323939332C35333031392C31322C35333034392C35333037352C31322C35333130352C35333133312C31322C35333136312C35333138372C31322C35333231372C35333234332C31322C35333237332C35333239';
wwv_flow_imp.g_varchar2_table(301) := '392C31322C35333332392C35333335352C31322C35333338352C35333431312C31322C35333434312C35333436372C31322C35333439372C35333532332C31322C35333535332C35333537392C31322C35333630392C35333633352C31322C3533363635';
wwv_flow_imp.g_varchar2_table(302) := '2C35333639312C31322C35333732312C35333734372C31322C35333737372C35333830332C31322C35333833332C35333835392C31322C35333838392C35333931352C31322C35333934352C35333937312C31322C35343030312C35343032372C31322C';
wwv_flow_imp.g_varchar2_table(303) := '35343035372C35343038332C31322C35343131332C35343133392C31322C35343136392C35343139352C31322C35343232352C35343235312C31322C35343238312C35343330372C31322C35343333372C35343336332C31322C35343339332C35343431';
wwv_flow_imp.g_varchar2_table(304) := '392C31322C35343434392C35343437352C31322C35343530352C35343533312C31322C35343536312C35343538372C31322C35343631372C35343634332C31322C35343637332C35343639392C31322C35343732392C35343735352C31322C3534373835';
wwv_flow_imp.g_varchar2_table(305) := '2C35343831312C31322C35343834312C35343836372C31322C35343839372C35343932332C31322C35343935332C35343937392C31322C35353030392C35353033352C31322C35353036352C35353039312C31322C35353132312C35353134372C31322C';
wwv_flow_imp.g_varchar2_table(306) := '35353137372C35353230332C31322C36353032342C36353033392C352C36353532302C36353532382C342C36363432322C36363432362C352C36383135322C36383135342C352C36393239312C36393239322C352C36393633332C36393633332C352C36';
wwv_flow_imp.g_varchar2_table(307) := '393734372C36393734382C352C36393831312C36393831342C352C36393832362C36393832362C352C36393933322C36393933322C372C37303031362C37303031372C352C37303037392C37303038302C372C37303039352C37303039352C352C373031';
wwv_flow_imp.g_varchar2_table(308) := '39362C37303139362C352C37303336372C37303336372C352C37303430322C37303430332C372C37303436342C37303436342C352C37303438372C37303438372C352C37303730392C37303731312C372C37303732352C37303732352C372C3730383333';
wwv_flow_imp.g_varchar2_table(309) := '2C37303833342C372C37303834332C37303834342C372C37303834392C37303834392C372C37313039302C37313039332C352C37313130332C37313130342C352C37313232372C37313232382C372C37313333392C37313333392C352C37313334342C37';
wwv_flow_imp.g_varchar2_table(310) := '313334392C352C37313435382C37313436312C352C37313732372C37313733352C352C37313938352C37313938392C372C37313939382C37313939382C352C37323030322C37323030322C372C37323135342C37323135352C352C37323139332C373232';
wwv_flow_imp.g_varchar2_table(311) := '30322C352C37323235312C37323235342C352C37323238312C37323238332C352C37323334342C37323334352C352C37323736362C37323736362C372C37323837342C37323838302C352C37323838352C37323838362C352C37333032332C3733303239';
wwv_flow_imp.g_varchar2_table(312) := '2C352C37333130342C37333130352C352C37333131312C37333131312C352C39323931322C39323931362C352C39343039352C39343039382C352C3131333832342C3131333832372C342C3131393134322C3131393134322C372C3131393135352C3131';
wwv_flow_imp.g_varchar2_table(313) := '393136322C342C3131393336322C3131393336342C352C3132313437362C3132313437362C352C3132323838382C3132323930342C352C3132333138342C3132333139302C352C3132353235322C3132353235382C352C3132373138332C313237313833';
wwv_flow_imp.g_varchar2_table(314) := '2C31342C3132373334302C3132373334332C31342C3132373337372C3132373338362C31342C3132373439312C3132373530332C31342C3132373534382C3132373535312C31342C3132373734342C3132373735362C31342C3132373736312C31323737';
wwv_flow_imp.g_varchar2_table(315) := '36312C31342C3132373736392C3132373736392C31342C3132373737332C3132373737342C31342C3132373738302C3132373738382C31342C3132373739362C3132373739372C31342C3132373832302C3132373832332C31342C3132373836392C3132';
wwv_flow_imp.g_varchar2_table(316) := '373836392C31342C3132373839342C3132373839352C31342C3132373930322C3132373930332C31342C3132373934332C3132373934332C31342C3132373934372C3132373935302C31342C3132373937322C3132373937322C31342C3132373938382C';
wwv_flow_imp.g_varchar2_table(317) := '3132373938382C31342C3132373939322C3132373939342C31342C3132383030392C3132383031312C31342C3132383031392C3132383031392C31342C3132383032332C3132383034312C31342C3132383036342C3132383036342C31342C3132383130';
wwv_flow_imp.g_varchar2_table(318) := '322C3132383130372C31342C3132383137342C3132383138312C31342C3132383233382C3132383233382C31342C3132383234362C3132383234372C31342C3132383235342C3132383235342C31342C3132383236342C3132383236342C31342C313238';
wwv_flow_imp.g_varchar2_table(319) := '3237382C3132383239392C31342C3132383332392C3132383333302C31342C3132383334382C3132383335392C31342C3132383337312C3132383337372C31342C3132383339322C3132383339332C31342C3132383430312C3132383430342C31342C31';
wwv_flow_imp.g_varchar2_table(320) := '32383432312C3132383432312C31342C3132383433332C3132383433342C31342C3132383435302C3132383435322C31342C3132383437362C3132383437382C31342C3132383438332C3132383438332C31342C3132383439352C3132383439352C3134';
wwv_flow_imp.g_varchar2_table(321) := '2C3132383530362C3132383530362C31342C3132383531392C3132383532302C31342C3132383532382C3132383532382C31342C3132383533342C3132383533342C31342C3132383533382C3132383533382C31342C3132383534302C3132383534322C';
wwv_flow_imp.g_varchar2_table(322) := '31342C3132383534342C3132383534392C31342C3132383535322C3132383535352C31342C3132383535372C3132383535372C31342C3132383536302C3132383536332C31342C3132383536352C3132383536352C31342C3132383536372C3132383537';
wwv_flow_imp.g_varchar2_table(323) := '362C31342C3132383538312C3132383539312C31342C3132383634312C3132383634322C31342C3132383634362C3132383634362C31342C3132383634382C3132383634382C31342C3132383635302C3132383635312C31342C3132383635332C313238';
wwv_flow_imp.g_varchar2_table(324) := '3635332C31342C3132383635352C3132383635352C31342C3132383635372C3132383635392C31342C3132383636312C3132383636312C31342C3132383636332C3132383636332C31342C3132383636352C3132383636362C31342C3132383637342C31';
wwv_flow_imp.g_varchar2_table(325) := '32383637342C31342C3132383637362C3132383637372C31342C3132383637392C3132383638352C31342C3132383639302C3132383639302C31342C3132383639342C3132383639342C31342C3132383639372C3132383730322C31342C313238373034';
wwv_flow_imp.g_varchar2_table(326) := '2C3132383730342C31342C3132383731302C3132383731342C31342C3132383731362C3132383731362C31342C3132383732302C3132383732302C31342C3132383732332C3132383732342C31342C3132383732362C3132383732372C31342C31323837';
wwv_flow_imp.g_varchar2_table(327) := '33332C3132383733352C31342C3132383734322C3132383734342C31342C3132383734362C3132383734362C31342C3132383734392C3132383735312C31342C3132383735332C3132383735342C31342C3132383735362C3132383735382C31342C3132';
wwv_flow_imp.g_varchar2_table(328) := '383736312C3132383736312C31342C3132383736332C3132383736342C31342C3132383838342C3132383839352C31342C3132383939322C3132393030332C31342C3132393030382C3132393030382C31342C3132393033362C3132393033392C31342C';
wwv_flow_imp.g_varchar2_table(329) := '3132393131342C3132393131392C31342C3132393139382C3132393237392C31342C3132393239332C3132393239352C31342C3132393330352C3132393331302C31342C3132393331322C3132393331392C31342C3132393332382C3132393332382C31';
wwv_flow_imp.g_varchar2_table(330) := '342C3132393333312C3132393333382C31342C3132393334332C3132393334332C31342C3132393335312C3132393335352C31342C3132393335372C3132393335392C31342C3132393337352C3132393338372C31342C3132393339332C313239333933';
wwv_flow_imp.g_varchar2_table(331) := '2C31342C3132393339352C3132393339382C31342C3132393430312C3132393430312C31342C3132393430332C3132393430332C31342C3132393430382C3132393431322C31342C3132393432362C3132393433312C31342C3132393434332C31323934';
wwv_flow_imp.g_varchar2_table(332) := '34342C31342C3132393435312C3132393435332C31342C3132393435362C3132393436352C31342C3132393437322C3132393437322C31342C3132393437352C3132393438322C31342C3132393438342C3132393438342C31342C3132393438382C3132';
wwv_flow_imp.g_varchar2_table(333) := '393531302C31342C3132393533362C3132393634372C31342C3132393635322C3132393635322C31342C3132393635362C3132393635382C31342C3132393636312C3132393636332C31342C3132393636372C3132393637302C31342C3132393638302C';
wwv_flow_imp.g_varchar2_table(334) := '3132393638352C31342C3132393730352C3132393730382C31342C3132393731322C3132393731382C31342C3132393732332C3132393732372C31342C3132393733312C3132393733332C31342C3132393734342C3132393735302C31342C3132393735';
wwv_flow_imp.g_varchar2_table(335) := '342C3132393735392C31342C3132393736382C3132393737352C31342C3132393738332C3132393739312C31342C3931373530342C3931373530342C342C3931373530362C3931373533352C342C3931373633322C3931373735392C342C393138303030';
wwv_flow_imp.g_varchar2_table(336) := '2C3932313539392C342C302C392C342C31312C31322C342C31342C33312C342C3136392C3136392C31342C3137342C3137342C31342C313135352C313135392C352C313432352C313436392C352C313437332C313437342C352C313437392C313437392C';
wwv_flow_imp.g_varchar2_table(337) := '352C313535322C313536322C352C313631312C313633312C352C313735302C313735362C352C313735392C313736342C352C313737302C313737332C352C313830392C313830392C352C313935382C313936382C352C323034352C323034352C352C3230';
wwv_flow_imp.g_varchar2_table(338) := '37352C323038332C352C323038392C323039332C352C323139322C323139332C312C323235302C323237332C352C323237352C323330362C352C323336322C323336322C352C323336342C323336342C352C323336392C323337362C352C323338312C32';
wwv_flow_imp.g_varchar2_table(339) := '3338312C352C323338352C323339312C352C323433332C323433332C352C323439322C323439322C352C323439352C323439362C372C323530332C323530342C372C323530392C323530392C352C323533302C323533312C352C323536312C323536322C';
wwv_flow_imp.g_varchar2_table(340) := '352C323632302C323632302C352C323632352C323632362C352C323633352C323633372C352C323637322C323637332C352C323638392C323639302C352C323734382C323734382C352C323735332C323735372C352C323736312C323736312C372C3237';
wwv_flow_imp.g_varchar2_table(341) := '36352C323736352C352C323831302C323831352C352C323831382C323831392C372C323837382C323837382C352C323838302C323838302C372C323838372C323838382C372C323839332C323839332C352C323930332C323930332C352C323934362C32';
wwv_flow_imp.g_varchar2_table(342) := '3934362C352C333030372C333030372C372C333030392C333031302C372C333031382C333032302C372C333033312C333033312C352C333037332C333037352C372C333133322C333133322C352C333133372C333134302C372C333134362C333134392C';
wwv_flow_imp.g_varchar2_table(343) := '352C333137302C333137312C352C333230322C333230332C372C333236322C333236322C372C333236342C333236352C372C333236372C333236382C372C333237312C333237322C372C333237362C333237372C352C333239382C333239392C352C3333';
wwv_flow_imp.g_varchar2_table(344) := '33302C333333312C372C333339302C333339302C352C333339332C333339362C352C333430322C333430342C372C333430362C333430362C312C333432362C333432372C352C333435382C333435392C372C333533352C333533352C352C333533382C33';
wwv_flow_imp.g_varchar2_table(345) := '3534302C352C333534342C333535302C372C333537302C333537312C372C333633352C333633352C372C333635352C333636322C352C333736332C333736332C372C333738342C333738392C352C333839332C333839332C352C333839372C333839372C';
wwv_flow_imp.g_varchar2_table(346) := '352C333935332C333936362C352C333936382C333937322C352C333938312C333939312C352C343033382C343033382C352C343134352C343134352C372C343135332C343135342C352C343135372C343135382C352C343138342C343138352C352C3432';
wwv_flow_imp.g_varchar2_table(347) := '30392C343231322C352C343232382C343232382C372C343233372C343233372C352C343335322C343434372C382C343532302C343630372C31302C353930362C353930382C352C353933382C353933392C352C353937302C353937312C352C363036382C';
wwv_flow_imp.g_varchar2_table(348) := '363036392C352C363037312C363037372C352C363038362C363038362C352C363038392C363039392C352C363135352C363135372C352C363135392C363135392C352C363331332C363331332C352C363433352C363433382C372C363434312C36343433';
wwv_flow_imp.g_varchar2_table(349) := '2C372C363435302C363435302C352C363435372C363435392C352C363638312C363638322C372C363734312C363734312C372C363734332C363734332C372C363735322C363735322C352C363735372C363736342C352C363737312C363738302C352C36';
wwv_flow_imp.g_varchar2_table(350) := '3833322C363834352C352C363834372C363836322C352C363931362C363931362C372C363936352C363936352C352C363937312C363937312C372C363937332C363937372C372C363937392C363938302C372C373034302C373034312C352C373037332C';
wwv_flow_imp.g_varchar2_table(351) := '373037332C372C373037382C373037392C372C373038322C373038322C372C373134322C373134322C352C373134342C373134352C352C373134392C373134392C352C373135312C373135332C352C373230342C373231312C372C373232302C37323231';
wwv_flow_imp.g_varchar2_table(352) := '2C372C373337362C373337382C352C373339332C373339332C372C373430352C373430352C352C373431352C373431352C372C373631362C373637392C352C383230342C383230342C352C383230362C383230372C342C383233332C383233332C342C38';
wwv_flow_imp.g_varchar2_table(353) := '3235322C383235322C31342C383238382C383239322C342C383239342C383330332C342C383431332C383431362C352C383431382C383432302C352C383438322C383438322C31342C383539362C383630312C31342C383938362C383938372C31342C39';
wwv_flow_imp.g_varchar2_table(354) := '3039362C393039362C31342C393139332C393139362C31342C393139392C393139392C31342C393230312C393230322C31342C393230382C393231302C31342C393634322C393634332C31342C393636342C393636342C31342C393732382C393732392C';
wwv_flow_imp.g_varchar2_table(355) := '31342C393733322C393733322C31342C393733352C393734312C31342C393734332C393734342C31342C393734362C393734362C31342C393735302C393735312C31342C393735332C393735362C31342C393735382C393735392C31342C393736312C39';
wwv_flow_imp.g_varchar2_table(356) := '3736312C31342C393736342C393736352C31342C393736372C393736392C31342C393737312C393737332C31342C393737352C393737352C31342C393738342C393738352C31342C393738372C393739312C31342C393739332C393739332C31342C3937';
wwv_flow_imp.g_varchar2_table(357) := '39352C393739392C31342C393831322C393832322C31342C393832342C393832342C31342C393832372C393832372C31342C393832392C393833302C31342C393833322C393833322C31342C393835312C393835312C31342C393835342C393835342C31';
wwv_flow_imp.g_varchar2_table(358) := '342C393835362C393836312C31342C393837342C393837342C31342C393837362C393837362C31342C393837382C393837392C31342C393838312C393838312C31342C393838332C393838342C31342C393838382C393838392C31342C393839352C3938';
wwv_flow_imp.g_varchar2_table(359) := '39352C31342C393839382C393839392C31342C393930342C393930352C31342C393931372C393931382C31342C393932342C393932352C31342C393932382C393932382C31342C393933342C393933342C31342C393933362C393933362C31342C393933';
wwv_flow_imp.g_varchar2_table(360) := '382C393933382C31342C393934302C393934302C31342C393936312C393936312C31342C393936332C393936372C31342C393937302C393937312C31342C393937332C393937332C31342C393937352C393937372C31342C393937392C393938302C3134';
wwv_flow_imp.g_varchar2_table(361) := '2C393938322C393938352C31342C393938372C393938382C31342C393939322C393939362C31342C393939382C393939382C31342C31303030302C31303030312C31342C31303030342C31303030342C31342C31303031332C31303031332C31342C3130';
wwv_flow_imp.g_varchar2_table(362) := '3032342C31303032342C31342C31303035322C31303035322C31342C31303036302C31303036302C31342C31303036372C31303036392C31342C31303038332C31303038332C31342C31303038352C31303038372C31342C31303134352C31303134352C';
wwv_flow_imp.g_varchar2_table(363) := '31342C31303137352C31303137352C31342C31313031332C31313031352C31342C31313038382C31313038382C31342C31313530332C31313530352C352C31313734342C31313737352C352C31323333342C31323333352C352C31323334392C31323334';
wwv_flow_imp.g_varchar2_table(364) := '392C31342C31323935312C31323935312C31342C34323630372C34323630372C352C34323631322C34323632312C352C34323733362C34323733372C352C34333031342C34333031342C352C34333034332C34333034342C372C34333034372C34333034';
wwv_flow_imp.g_varchar2_table(365) := '372C372C34333133362C34333133372C372C34333230342C34333230352C352C34333236332C34333236332C352C34333333352C34333334352C352C34333336302C34333338382C382C34333339352C34333339352C372C34333434342C34333434352C';
wwv_flow_imp.g_varchar2_table(366) := '372C34333435302C34333435312C372C34333435342C34333435362C372C34333536312C34333536362C352C34333536392C34333537302C352C34333537332C34333537342C352C34333539362C34333539362C352C34333634342C34333634342C352C';
wwv_flow_imp.g_varchar2_table(367) := '34333639382C34333730302C352C34333731302C34333731312C352C34333735352C34333735352C372C34333735382C34333735392C372C34333736362C34333736362C352C34343030352C34343030352C352C34343030382C34343030382C352C3434';
wwv_flow_imp.g_varchar2_table(368) := '3031322C34343031322C372C34343033322C34343033322C31312C34343036302C34343036302C31312C34343038382C34343038382C31312C34343131362C34343131362C31312C34343134342C34343134342C31312C34343137322C34343137322C31';
wwv_flow_imp.g_varchar2_table(369) := '312C34343230302C34343230302C31312C34343232382C34343232382C31312C34343235362C34343235362C31312C34343238342C34343238342C31312C34343331322C34343331322C31312C34343334302C34343334302C31312C34343336382C3434';
wwv_flow_imp.g_varchar2_table(370) := '3336382C31312C34343339362C34343339362C31312C34343432342C34343432342C31312C34343435322C34343435322C31312C34343438302C34343438302C31312C34343530382C34343530382C31312C34343533362C34343533362C31312C343435';
wwv_flow_imp.g_varchar2_table(371) := '36342C34343536342C31312C34343539322C34343539322C31312C34343632302C34343632302C31312C34343634382C34343634382C31312C34343637362C34343637362C31312C34343730342C34343730342C31312C34343733322C34343733322C31';
wwv_flow_imp.g_varchar2_table(372) := '312C34343736302C34343736302C31312C34343738382C34343738382C31312C34343831362C34343831362C31312C34343834342C34343834342C31312C34343837322C34343837322C31312C34343930302C34343930302C31312C34343932382C3434';
wwv_flow_imp.g_varchar2_table(373) := '3932382C31312C34343935362C34343935362C31312C34343938342C34343938342C31312C34353031322C34353031322C31312C34353034302C34353034302C31312C34353036382C34353036382C31312C34353039362C34353039362C31312C343531';
wwv_flow_imp.g_varchar2_table(374) := '32342C34353132342C31312C34353135322C34353135322C31312C34353138302C34353138302C31312C34353230382C34353230382C31312C34353233362C34353233362C31312C34353236342C34353236342C31312C34353239322C34353239322C31';
wwv_flow_imp.g_varchar2_table(375) := '312C34353332302C34353332302C31312C34353334382C34353334382C31312C34353337362C34353337362C31312C34353430342C34353430342C31312C34353433322C34353433322C31312C34353436302C34353436302C31312C34353438382C3435';
wwv_flow_imp.g_varchar2_table(376) := '3438382C31312C34353531362C34353531362C31312C34353534342C34353534342C31312C34353537322C34353537322C31312C34353630302C34353630302C31312C34353632382C34353632382C31312C34353635362C34353635362C31312C343536';
wwv_flow_imp.g_varchar2_table(377) := '38342C34353638342C31312C34353731322C34353731322C31312C34353734302C34353734302C31312C34353736382C34353736382C31312C34353739362C34353739362C31312C34353832342C34353832342C31312C34353835322C34353835322C31';
wwv_flow_imp.g_varchar2_table(378) := '312C34353838302C34353838302C31312C34353930382C34353930382C31312C34353933362C34353933362C31312C34353936342C34353936342C31312C34353939322C34353939322C31312C34363032302C34363032302C31312C34363034382C3436';
wwv_flow_imp.g_varchar2_table(379) := '3034382C31312C34363037362C34363037362C31312C34363130342C34363130342C31312C34363133322C34363133322C31312C34363136302C34363136302C31312C34363138382C34363138382C31312C34363231362C34363231362C31312C343632';
wwv_flow_imp.g_varchar2_table(380) := '34342C34363234342C31312C34363237322C34363237322C31312C34363330302C34363330302C31312C34363332382C34363332382C31312C34363335362C34363335362C31312C34363338342C34363338342C31312C34363431322C34363431322C31';
wwv_flow_imp.g_varchar2_table(381) := '312C34363434302C34363434302C31312C34363436382C34363436382C31312C34363439362C34363439362C31312C34363532342C34363532342C31312C34363535322C34363535322C31312C34363538302C34363538302C31312C34363630382C3436';
wwv_flow_imp.g_varchar2_table(382) := '3630382C31312C34363633362C34363633362C31312C34363636342C34363636342C31312C34363639322C34363639322C31312C34363732302C34363732302C31312C34363734382C34363734382C31312C34363737362C34363737362C31312C343638';
wwv_flow_imp.g_varchar2_table(383) := '30342C34363830342C31312C34363833322C34363833322C31312C34363836302C34363836302C31312C34363838382C34363838382C31312C34363931362C34363931362C31312C34363934342C34363934342C31312C34363937322C34363937322C31';
wwv_flow_imp.g_varchar2_table(384) := '312C34373030302C34373030302C31312C34373032382C34373032382C31312C34373035362C34373035362C31312C34373038342C34373038342C31312C34373131322C34373131322C31312C34373134302C34373134302C31312C34373136382C3437';
wwv_flow_imp.g_varchar2_table(385) := '3136382C31312C34373139362C34373139362C31312C34373232342C34373232342C31312C34373235322C34373235322C31312C34373238302C34373238302C31312C34373330382C34373330382C31312C34373333362C34373333362C31312C343733';
wwv_flow_imp.g_varchar2_table(386) := '36342C34373336342C31312C34373339322C34373339322C31312C34373432302C34373432302C31312C34373434382C34373434382C31312C34373437362C34373437362C31312C34373530342C34373530342C31312C34373533322C34373533322C31';
wwv_flow_imp.g_varchar2_table(387) := '312C34373536302C34373536302C31312C34373538382C34373538382C31312C34373631362C34373631362C31312C34373634342C34373634342C31312C34373637322C34373637322C31312C34373730302C34373730302C31312C34373732382C3437';
wwv_flow_imp.g_varchar2_table(388) := '3732382C31312C34373735362C34373735362C31312C34373738342C34373738342C31312C34373831322C34373831322C31312C34373834302C34373834302C31312C34373836382C34373836382C31312C34373839362C34373839362C31312C343739';
wwv_flow_imp.g_varchar2_table(389) := '32342C34373932342C31312C34373935322C34373935322C31312C34373938302C34373938302C31312C34383030382C34383030382C31312C34383033362C34383033362C31312C34383036342C34383036342C31312C34383039322C34383039322C31';
wwv_flow_imp.g_varchar2_table(390) := '312C34383132302C34383132302C31312C34383134382C34383134382C31312C34383137362C34383137362C31312C34383230342C34383230342C31312C34383233322C34383233322C31312C34383236302C34383236302C31312C34383238382C3438';
wwv_flow_imp.g_varchar2_table(391) := '3238382C31312C34383331362C34383331362C31312C34383334342C34383334342C31312C34383337322C34383337322C31312C34383430302C34383430302C31312C34383432382C34383432382C31312C34383435362C34383435362C31312C343834';
wwv_flow_imp.g_varchar2_table(392) := '38342C34383438342C31312C34383531322C34383531322C31312C34383534302C34383534302C31312C34383536382C34383536382C31312C34383539362C34383539362C31312C34383632342C34383632342C31312C34383635322C34383635322C31';
wwv_flow_imp.g_varchar2_table(393) := '312C34383638302C34383638302C31312C34383730382C34383730382C31312C34383733362C34383733362C31312C34383736342C34383736342C31312C34383739322C34383739322C31312C34383832302C34383832302C31312C34383834382C3438';
wwv_flow_imp.g_varchar2_table(394) := '3834382C31312C34383837362C34383837362C31312C34383930342C34383930342C31312C34383933322C34383933322C31312C34383936302C34383936302C31312C34383938382C34383938382C31312C34393031362C34393031362C31312C343930';
wwv_flow_imp.g_varchar2_table(395) := '34342C34393034342C31312C34393037322C34393037322C31312C34393130302C34393130302C31312C34393132382C34393132382C31312C34393135362C34393135362C31312C34393138342C34393138342C31312C34393231322C34393231322C31';
wwv_flow_imp.g_varchar2_table(396) := '312C34393234302C34393234302C31312C34393236382C34393236382C31312C34393239362C34393239362C31312C34393332342C34393332342C31312C34393335322C34393335322C31312C34393338302C34393338302C31312C34393430382C3439';
wwv_flow_imp.g_varchar2_table(397) := '3430382C31312C34393433362C34393433362C31312C34393436342C34393436342C31312C34393439322C34393439322C31312C34393532302C34393532302C31312C34393534382C34393534382C31312C34393537362C34393537362C31312C343936';
wwv_flow_imp.g_varchar2_table(398) := '30342C34393630342C31312C34393633322C34393633322C31312C34393636302C34393636302C31312C34393638382C34393638382C31312C34393731362C34393731362C31312C34393734342C34393734342C31312C34393737322C34393737322C31';
wwv_flow_imp.g_varchar2_table(399) := '312C34393830302C34393830302C31312C34393832382C34393832382C31312C34393835362C34393835362C31312C34393838342C34393838342C31312C34393931322C34393931322C31312C34393934302C34393934302C31312C34393936382C3439';
wwv_flow_imp.g_varchar2_table(400) := '3936382C31312C34393939362C34393939362C31312C35303032342C35303032342C31312C35303035322C35303035322C31312C35303038302C35303038302C31312C35303130382C35303130382C31312C35303133362C35303133362C31312C353031';
wwv_flow_imp.g_varchar2_table(401) := '36342C35303136342C31312C35303139322C35303139322C31312C35303232302C35303232302C31312C35303234382C35303234382C31312C35303237362C35303237362C31312C35303330342C35303330342C31312C35303333322C35303333322C31';
wwv_flow_imp.g_varchar2_table(402) := '312C35303336302C35303336302C31312C35303338382C35303338382C31312C35303431362C35303431362C31312C35303434342C35303434342C31312C35303437322C35303437322C31312C35303530302C35303530302C31312C35303532382C3530';
wwv_flow_imp.g_varchar2_table(403) := '3532382C31312C35303535362C35303535362C31312C35303538342C35303538342C31312C35303631322C35303631322C31312C35303634302C35303634302C31312C35303636382C35303636382C31312C35303639362C35303639362C31312C353037';
wwv_flow_imp.g_varchar2_table(404) := '32342C35303732342C31312C35303735322C35303735322C31312C35303738302C35303738302C31312C35303830382C35303830382C31312C35303833362C35303833362C31312C35303836342C35303836342C31312C35303839322C35303839322C31';
wwv_flow_imp.g_varchar2_table(405) := '312C35303932302C35303932302C31312C35303934382C35303934382C31312C35303937362C35303937362C31312C35313030342C35313030342C31312C35313033322C35313033322C31312C35313036302C35313036302C31312C35313038382C3531';
wwv_flow_imp.g_varchar2_table(406) := '3038382C31312C35313131362C35313131362C31312C35313134342C35313134342C31312C35313137322C35313137322C31312C35313230302C35313230302C31312C35313232382C35313232382C31312C35313235362C35313235362C31312C353132';
wwv_flow_imp.g_varchar2_table(407) := '38342C35313238342C31312C35313331322C35313331322C31312C35313334302C35313334302C31312C35313336382C35313336382C31312C35313339362C35313339362C31312C35313432342C35313432342C31312C35313435322C35313435322C31';
wwv_flow_imp.g_varchar2_table(408) := '312C35313438302C35313438302C31312C35313530382C35313530382C31312C35313533362C35313533362C31312C35313536342C35313536342C31312C35313539322C35313539322C31312C35313632302C35313632302C31312C35313634382C3531';
wwv_flow_imp.g_varchar2_table(409) := '3634382C31312C35313637362C35313637362C31312C35313730342C35313730342C31312C35313733322C35313733322C31312C35313736302C35313736302C31312C35313738382C35313738382C31312C35313831362C35313831362C31312C353138';
wwv_flow_imp.g_varchar2_table(410) := '34342C35313834342C31312C35313837322C35313837322C31312C35313930302C35313930302C31312C35313932382C35313932382C31312C35313935362C35313935362C31312C35313938342C35313938342C31312C35323031322C35323031322C31';
wwv_flow_imp.g_varchar2_table(411) := '312C35323034302C35323034302C31312C35323036382C35323036382C31312C35323039362C35323039362C31312C35323132342C35323132342C31312C35323135322C35323135322C31312C35323138302C35323138302C31312C35323230382C3532';
wwv_flow_imp.g_varchar2_table(412) := '3230382C31312C35323233362C35323233362C31312C35323236342C35323236342C31312C35323239322C35323239322C31312C35323332302C35323332302C31312C35323334382C35323334382C31312C35323337362C35323337362C31312C353234';
wwv_flow_imp.g_varchar2_table(413) := '30342C35323430342C31312C35323433322C35323433322C31312C35323436302C35323436302C31312C35323438382C35323438382C31312C35323531362C35323531362C31312C35323534342C35323534342C31312C35323537322C35323537322C31';
wwv_flow_imp.g_varchar2_table(414) := '312C35323630302C35323630302C31312C35323632382C35323632382C31312C35323635362C35323635362C31312C35323638342C35323638342C31312C35323731322C35323731322C31312C35323734302C35323734302C31312C35323736382C3532';
wwv_flow_imp.g_varchar2_table(415) := '3736382C31312C35323739362C35323739362C31312C35323832342C35323832342C31312C35323835322C35323835322C31312C35323838302C35323838302C31312C35323930382C35323930382C31312C35323933362C35323933362C31312C353239';
wwv_flow_imp.g_varchar2_table(416) := '36342C35323936342C31312C35323939322C35323939322C31312C35333032302C35333032302C31312C35333034382C35333034382C31312C35333037362C35333037362C31312C35333130342C35333130342C31312C35333133322C35333133322C31';
wwv_flow_imp.g_varchar2_table(417) := '312C35333136302C35333136302C31312C35333138382C35333138382C31312C35333231362C35333231362C31312C35333234342C35333234342C31312C35333237322C35333237322C31312C35333330302C35333330302C31312C35333332382C3533';
wwv_flow_imp.g_varchar2_table(418) := '3332382C31312C35333335362C35333335362C31312C35333338342C35333338342C31312C35333431322C35333431322C31312C35333434302C35333434302C31312C35333436382C35333436382C31312C35333439362C35333439362C31312C353335';
wwv_flow_imp.g_varchar2_table(419) := '32342C35333532342C31312C35333535322C35333535322C31312C35333538302C35333538302C31312C35333630382C35333630382C31312C35333633362C35333633362C31312C35333636342C35333636342C31312C35333639322C35333639322C31';
wwv_flow_imp.g_varchar2_table(420) := '312C35333732302C35333732302C31312C35333734382C35333734382C31312C35333737362C35333737362C31312C35333830342C35333830342C31312C35333833322C35333833322C31312C35333836302C35333836302C31312C35333838382C3533';
wwv_flow_imp.g_varchar2_table(421) := '3838382C31312C35333931362C35333931362C31312C35333934342C35333934342C31312C35333937322C35333937322C31312C35343030302C35343030302C31312C35343032382C35343032382C31312C35343035362C35343035362C31312C353430';
wwv_flow_imp.g_varchar2_table(422) := '38342C35343038342C31312C35343131322C35343131322C31312C35343134302C35343134302C31312C35343136382C35343136382C31312C35343139362C35343139362C31312C35343232342C35343232342C31312C35343235322C35343235322C31';
wwv_flow_imp.g_varchar2_table(423) := '312C35343238302C35343238302C31312C35343330382C35343330382C31312C35343333362C35343333362C31312C35343336342C35343336342C31312C35343339322C35343339322C31312C35343432302C35343432302C31312C35343434382C3534';
wwv_flow_imp.g_varchar2_table(424) := '3434382C31312C35343437362C35343437362C31312C35343530342C35343530342C31312C35343533322C35343533322C31312C35343536302C35343536302C31312C35343538382C35343538382C31312C35343631362C35343631362C31312C353436';
wwv_flow_imp.g_varchar2_table(425) := '34342C35343634342C31312C35343637322C35343637322C31312C35343730302C35343730302C31312C35343732382C35343732382C31312C35343735362C35343735362C31312C35343738342C35343738342C31312C35343831322C35343831322C31';
wwv_flow_imp.g_varchar2_table(426) := '312C35343834302C35343834302C31312C35343836382C35343836382C31312C35343839362C35343839362C31312C35343932342C35343932342C31312C35343935322C35343935322C31312C35343938302C35343938302C31312C35353030382C3535';
wwv_flow_imp.g_varchar2_table(427) := '3030382C31312C35353033362C35353033362C31312C35353036342C35353036342C31312C35353039322C35353039322C31312C35353132302C35353132302C31312C35353134382C35353134382C31312C35353137362C35353137362C31312C353532';
wwv_flow_imp.g_varchar2_table(428) := '31362C35353233382C392C36343238362C36343238362C352C36353035362C36353037312C352C36353433382C36353433392C352C36353532392C36353533312C342C36363237322C36363237322C352C36383039372C36383039392C352C3638313038';
wwv_flow_imp.g_varchar2_table(429) := '2C36383131312C352C36383135392C36383135392C352C36383930302C36383930332C352C36393434362C36393435362C352C36393633322C36393633322C372C36393633342C36393633342C372C36393734342C36393734342C352C36393735392C36';
wwv_flow_imp.g_varchar2_table(430) := '393736312C352C36393830382C36393831302C372C36393831352C36393831362C372C36393832312C36393832312C312C36393833372C36393833372C312C36393932372C36393933312C352C36393933332C36393934302C352C37303030332C373030';
wwv_flow_imp.g_varchar2_table(431) := '30332C352C37303031382C37303031382C372C37303037302C37303037382C352C37303038322C37303038332C312C37303039342C37303039342C372C37303138382C37303139302C372C37303139342C37303139352C372C37303139372C3730313937';
wwv_flow_imp.g_varchar2_table(432) := '2C372C37303230362C37303230362C352C37303336382C37303337302C372C37303430302C37303430312C352C37303435392C37303436302C352C37303436332C37303436332C372C37303436352C37303436382C372C37303437352C37303437372C37';
wwv_flow_imp.g_varchar2_table(433) := '2C37303439382C37303439392C372C37303531322C37303531362C352C37303731322C37303731392C352C37303732322C37303732342C352C37303732362C37303732362C352C37303833322C37303833322C352C37303833352C37303834302C352C37';
wwv_flow_imp.g_varchar2_table(434) := '303834322C37303834322C352C37303834352C37303834352C352C37303834372C37303834382C352C37303835302C37303835312C352C37313038382C37313038392C372C37313039362C37313039392C372C37313130322C37313130322C372C373131';
wwv_flow_imp.g_varchar2_table(435) := '33322C37313133332C352C37313231392C37313232362C352C37313232392C37313232392C352C37313233312C37313233322C352C37313334302C37313334302C372C37313334322C37313334332C372C37313335302C37313335302C372C3731343533';
wwv_flow_imp.g_varchar2_table(436) := '2C37313435352C352C37313436322C37313436322C372C37313732342C37313732362C372C37313733362C37313733362C372C37313938342C37313938342C352C37313939312C37313939322C372C37313939372C37313939372C372C37313939392C37';
wwv_flow_imp.g_varchar2_table(437) := '313939392C312C37323030312C37323030312C312C37323030332C37323030332C352C37323134382C37323135312C352C37323135362C37323135392C372C37323136342C37323136342C372C37323234332C37323234382C352C37323235302C373232';
wwv_flow_imp.g_varchar2_table(438) := '35302C312C37323236332C37323236332C352C37323237392C37323238302C372C37323332342C37323332392C312C37323334332C37323334332C372C37323735312C37323735312C372C37323736302C37323736352C352C37323736372C3732373637';
wwv_flow_imp.g_varchar2_table(439) := '2C352C37323837332C37323837332C372C37323838312C37323838312C372C37323838342C37323838342C372C37333030392C37333031342C352C37333032302C37333032312C352C37333033302C37333033302C312C37333039382C37333130322C37';
wwv_flow_imp.g_varchar2_table(440) := '2C37333130372C37333130382C372C37333131302C37333131302C372C37333435392C37333436302C352C37383839362C37383930342C342C39323937362C39323938322C352C39343033332C39343038372C372C39343138302C39343138302C352C31';
wwv_flow_imp.g_varchar2_table(441) := '31333832312C3131333832322C352C3131383532382C3131383537332C352C3131393134312C3131393134312C352C3131393134332C3131393134352C352C3131393135302C3131393135342C352C3131393136332C3131393137302C352C3131393231';
wwv_flow_imp.g_varchar2_table(442) := '302C3131393231332C352C3132313334342C3132313339382C352C3132313436312C3132313436312C352C3132313439392C3132313530332C352C3132323838302C3132323838362C352C3132323930372C3132323931332C352C3132323931382C3132';
wwv_flow_imp.g_varchar2_table(443) := '323932322C352C3132333536362C3132333536362C352C3132353133362C3132353134322C352C3132363937362C3132363937392C31342C3132363938312C3132373138322C31342C3132373138342C3132373233312C31342C3132373237392C313237';
wwv_flow_imp.g_varchar2_table(444) := '3237392C31342C3132373334342C3132373334352C31342C3132373337342C3132373337342C31342C3132373430352C3132373436312C31342C3132373438392C3132373439302C31342C3132373531342C3132373531342C31342C3132373533382C31';
wwv_flow_imp.g_varchar2_table(445) := '32373534362C31342C3132373536312C3132373536372C31342C3132373537302C3132373734332C31342C3132373735372C3132373735382C31342C3132373736302C3132373736302C31342C3132373736322C3132373736322C31342C313237373636';
wwv_flow_imp.g_varchar2_table(446) := '2C3132373736382C31342C3132373737302C3132373737302C31342C3132373737322C3132373737322C31342C3132373737352C3132373737362C31342C3132373737382C3132373737392C31342C3132373738392C3132373739312C31342C31323737';
wwv_flow_imp.g_varchar2_table(447) := '39342C3132373739352C31342C3132373739382C3132373739382C31342C3132373831392C3132373831392C31342C3132373832342C3132373832342C31342C3132373836382C3132373836382C31342C3132373837302C3132373837312C31342C3132';
wwv_flow_imp.g_varchar2_table(448) := '373839322C3132373839332C31342C3132373839362C3132373839362C31342C3132373930302C3132373930312C31342C3132373930342C3132373934302C31342C3132373934322C3132373934322C31342C3132373934342C3132373934342C31342C';
wwv_flow_imp.g_varchar2_table(449) := '3132373934362C3132373934362C31342C3132373935312C3132373935352C31342C3132373936382C3132373937312C31342C3132373937332C3132373938342C31342C3132373938372C3132373938372C31342C3132373938392C3132373938392C31';
wwv_flow_imp.g_varchar2_table(450) := '342C3132373939312C3132373939312C31342C3132373939352C3132373939392C352C3132383030382C3132383030382C31342C3132383031322C3132383031342C31342C3132383031372C3132383031382C31342C3132383032302C3132383032302C';
wwv_flow_imp.g_varchar2_table(451) := '31342C3132383032322C3132383032322C31342C3132383034322C3132383034322C31342C3132383036332C3132383036332C31342C3132383036352C3132383036352C31342C3132383130312C3132383130312C31342C3132383130382C3132383130';
wwv_flow_imp.g_varchar2_table(452) := '392C31342C3132383137332C3132383137332C31342C3132383138322C3132383138332C31342C3132383233362C3132383233372C31342C3132383233392C3132383233392C31342C3132383234352C3132383234352C31342C3132383234382C313238';
wwv_flow_imp.g_varchar2_table(453) := '3234382C31342C3132383235332C3132383235332C31342C3132383235352C3132383235382C31342C3132383236302C3132383236332C31342C3132383236352C3132383236352C31342C3132383237372C3132383237372C31342C3132383330302C31';
wwv_flow_imp.g_varchar2_table(454) := '32383330312C31342C3132383332362C3132383332382C31342C3132383333312C3132383333342C31342C3132383333362C3132383334372C31342C3132383336302C3132383336362C31342C3132383336392C3132383337302C31342C313238333738';
wwv_flow_imp.g_varchar2_table(455) := '2C3132383337382C31342C3132383339312C3132383339312C31342C3132383339342C3132383339372C31342C3132383430302C3132383430302C31342C3132383430352C3132383430362C31342C3132383432302C3132383432302C31342C31323834';
wwv_flow_imp.g_varchar2_table(456) := '32322C3132383432332C31342C3132383432352C3132383433322C31342C3132383433352C3132383434332C31342C3132383434352C3132383434392C31342C3132383435332C3132383436342C31342C3132383436382C3132383437352C31342C3132';
wwv_flow_imp.g_varchar2_table(457) := '383437392C3132383438302C31342C3132383438322C3132383438322C31342C3132383438342C3132383438372C31342C3132383438392C3132383439342C31342C3132383439362C3132383439382C31342C3132383530302C3132383530352C31342C';
wwv_flow_imp.g_varchar2_table(458) := '3132383530372C3132383531312C31342C3132383531332C3132383531382C31342C3132383532312C3132383532352C31342C3132383532372C3132383532372C31342C3132383532392C3132383532392C31342C3132383533332C3132383533332C31';
wwv_flow_imp.g_varchar2_table(459) := '342C3132383533352C3132383533352C31342C3132383533372C3132383533372C31345D22297D6765744772617068656D65427265616B547970652865297B696628653C33322972657475726E2031303D3D3D653F333A31333D3D3D653F323A343B6966';
wwv_flow_imp.g_varchar2_table(460) := '28653C3132372972657475726E20303B636F6E737420743D746869732E5F646174612C6E3D742E6C656E6774682F333B6C657420693D313B666F72283B693C3D6E3B29696628653C745B332A695D29692A3D323B656C73657B6966282128653E745B332A';
wwv_flow_imp.g_varchar2_table(461) := '692B315D292972657475726E20745B332A692B325D3B693D322A692B317D72657475726E20307D7D67652E5F494E5354414E43453D6E756C6C3B636C6173732066657B73746174696320676574496E7374616E63652865297B72657475726E2061652E63';
wwv_flow_imp.g_varchar2_table(462) := '616368652E6765742841727261792E66726F6D286529297D737461746963206765744C6F63616C657328297B72657475726E2061652E5F6C6F63616C65732E76616C75657D636F6E7374727563746F722865297B746869732E636F6E66757361626C6544';
wwv_flow_imp.g_varchar2_table(463) := '696374696F6E6172793D657D6973416D626967756F75732865297B72657475726E20746869732E636F6E66757361626C6544696374696F6E6172792E6861732865297D6765745072696D617279436F6E66757361626C652865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(464) := '69732E636F6E66757361626C6544696374696F6E6172792E6765742865297D676574436F6E66757361626C65436F6465506F696E747328297B72657475726E206E65772053657428746869732E636F6E66757361626C6544696374696F6E6172792E6B65';
wwv_flow_imp.g_varchar2_table(465) := '79732829297D7D61653D66652C66652E616D626967756F7573436861726163746572446174613D6E6577206F65282828293D3E4A534F4E2E706172736528277B225F636F6D6D6F6E223A5B383233322C33322C383233332C33322C353736302C33322C38';
wwv_flow_imp.g_varchar2_table(466) := '3139322C33322C383139332C33322C383139342C33322C383139352C33322C383139362C33322C383139372C33322C383139382C33322C383230302C33322C383230312C33322C383230322C33322C383238372C33322C383139392C33322C383233392C';
wwv_flow_imp.g_varchar2_table(467) := '33322C323034322C39352C36353130312C39352C36353130322C39352C36353130332C39352C383230382C34352C383230392C34352C383231302C34352C36353131322C34352C313734382C34352C383235392C34352C3732372C34352C383732322C34';
wwv_flow_imp.g_varchar2_table(468) := '352C31303133342C34352C31313435302C34352C313534392C34342C313634332C34342C383231382C34342C3138342C34342C34323233332C34342C3839342C35392C323330372C35382C323639312C35382C313431372C35382C313739352C35382C31';
wwv_flow_imp.g_varchar2_table(469) := '3739362C35382C353836382C35382C36353037322C35382C363134372C35382C363135332C35382C383238322C35382C313437352C35382C3736302C35382C34323838392C35382C383735382C35382C3732302C35382C34323233372C35382C3435312C';
wwv_flow_imp.g_varchar2_table(470) := '33332C31313630312C33332C3636302C36332C3537372C36332C323432392C36332C353033382C36332C34323733312C36332C3131393134392C34362C383232382C34362C313739332C34362C313739342C34362C34323531302C34362C36383137362C';
wwv_flow_imp.g_varchar2_table(471) := '34362C313633322C34362C313737362C34362C34323233322C34362C313337332C39362C36353238372C39362C383231392C39362C383234322C39362C313337302C39362C313532332C39362C383137352C39362C36353334342C39362C3930302C3936';
wwv_flow_imp.g_varchar2_table(472) := '2C383138392C39362C383132352C39362C383132372C39362C383139302C39362C3639372C39362C3838342C39362C3731322C39362C3731342C39362C3731352C39362C3735362C39362C3639392C39362C3730312C39362C3730302C39362C3730322C';
wwv_flow_imp.g_varchar2_table(473) := '39362C34323839322C39362C313439372C39362C323033362C39362C323033372C39362C353139342C39362C353833362C39362C39343033332C39362C39343033342C39362C36353333392C39312C31303038382C34302C31303039382C34302C313233';
wwv_flow_imp.g_varchar2_table(474) := '30382C34302C36343833302C34302C36353334312C39332C31303038392C34312C31303039392C34312C31323330392C34312C36343833312C34312C31303130302C3132332C3131393036302C3132332C31303130312C3132352C36353334322C39342C';
wwv_flow_imp.g_varchar2_table(475) := '383237302C34322C313634352C34322C383732372C34322C36363333352C34322C353934312C34372C383235372C34372C383732352C34372C383236302C34372C393538352C34372C31303138372C34372C31303734342C34372C3131393335342C3437';
wwv_flow_imp.g_varchar2_table(476) := '2C31323735352C34372C31323333392C34372C31313436322C34372C32303033312C34372C31323033352C34372C36353334302C39322C36353132382C39322C383732362C39322C31303138392C39322C31303734312C39322C31303734352C39322C31';
wwv_flow_imp.g_varchar2_table(477) := '31393331312C39322C3131393335352C39322C31323735362C39322C32303032322C39322C31323033342C39322C34323837322C33382C3730382C39342C3731302C39342C353836392C34332C31303133332C34332C36363230332C34332C383234392C';
wwv_flow_imp.g_varchar2_table(478) := '36302C31303039342C36302C3730362C36302C3131393335302C36302C353137362C36302C353831302C36302C353132302C36312C31313834302C36312C31323434382C36312C34323233392C36312C383235302C36322C31303039352C36322C373037';
wwv_flow_imp.g_varchar2_table(479) := '2C36322C3131393335312C36322C353137312C36322C39343031352C36322C383237352C3132362C3733322C3132362C383132382C3132362C383736342C3132362C36353337322C3132342C36353239332C34352C3132303738342C35302C3132303739';
wwv_flow_imp.g_varchar2_table(480) := '342C35302C3132303830342C35302C3132303831342C35302C3132303832342C35302C3133303033342C35302C34323834322C35302C3432332C35302C313030302C35302C34323536342C35302C353331312C35302C34323733352C35302C3131393330';
wwv_flow_imp.g_varchar2_table(481) := '322C35312C3132303738352C35312C3132303739352C35312C3132303830352C35312C3132303831352C35312C3132303832352C35312C3133303033352C35312C34323932332C35312C3534302C35312C3433392C35312C34323835382C35312C313134';
wwv_flow_imp.g_varchar2_table(482) := '36382C35312C313234382C35312C39343031312C35312C37313838322C35312C3132303738362C35322C3132303739362C35322C3132303830362C35322C3132303831362C35322C3132303832362C35322C3133303033362C35322C353037302C35322C';
wwv_flow_imp.g_varchar2_table(483) := '37313835352C35322C3132303738372C35332C3132303739372C35332C3132303830372C35332C3132303831372C35332C3132303832372C35332C3133303033372C35332C3434342C35332C37313836372C35332C3132303738382C35342C3132303739';
wwv_flow_imp.g_varchar2_table(484) := '382C35342C3132303830382C35342C3132303831382C35342C3132303832382C35342C3133303033382C35342C31313437342C35342C353130322C35342C37313839332C35342C3131393331342C35352C3132303738392C35352C3132303739392C3535';
wwv_flow_imp.g_varchar2_table(485) := '2C3132303830392C35352C3132303831392C35352C3132303832392C35352C3133303033392C35352C36363737302C35352C37313837382C35352C323831392C35362C323533382C35362C323636362C35362C3132353133312C35362C3132303739302C';
wwv_flow_imp.g_varchar2_table(486) := '35362C3132303830302C35362C3132303831302C35362C3132303832302C35362C3132303833302C35362C3133303034302C35362C3534372C35362C3534362C35362C36363333302C35362C323636332C35372C323932302C35372C323534312C35372C';
wwv_flow_imp.g_varchar2_table(487) := '333433372C35372C3132303739312C35372C3132303830312C35372C3132303831312C35372C3132303832312C35372C3132303833312C35372C3133303034312C35372C34323836322C35372C31313436362C35372C37313838342C35372C3731383532';
wwv_flow_imp.g_varchar2_table(488) := '2C35372C37313839342C35372C393038322C39372C36353334352C39372C3131393833342C39372C3131393838362C39372C3131393933382C39372C3131393939302C39372C3132303034322C39372C3132303039342C39372C3132303134362C39372C';
wwv_flow_imp.g_varchar2_table(489) := '3132303139382C39372C3132303235302C39372C3132303330322C39372C3132303335342C39372C3132303430362C39372C3132303435382C39372C3539332C39372C3934352C39372C3132303531342C39372C3132303537322C39372C313230363330';
wwv_flow_imp.g_varchar2_table(490) := '2C39372C3132303638382C39372C3132303734362C39372C36353331332C36352C3131393830382C36352C3131393836302C36352C3131393931322C36352C3131393936342C36352C3132303031362C36352C3132303036382C36352C3132303132302C';
wwv_flow_imp.g_varchar2_table(491) := '36352C3132303137322C36352C3132303232342C36352C3132303237362C36352C3132303332382C36352C3132303338302C36352C3132303433322C36352C3931332C36352C3132303438382C36352C3132303534362C36352C3132303630342C36352C';
wwv_flow_imp.g_varchar2_table(492) := '3132303636322C36352C3132303732302C36352C353033342C36352C353537332C36352C34323232322C36352C39343031362C36352C36363230382C36352C3131393833352C39382C3131393838372C39382C3131393933392C39382C3131393939312C';
wwv_flow_imp.g_varchar2_table(493) := '39382C3132303034332C39382C3132303039352C39382C3132303134372C39382C3132303139392C39382C3132303235312C39382C3132303330332C39382C3132303335352C39382C3132303430372C39382C3132303435392C39382C3338382C39382C';
wwv_flow_imp.g_varchar2_table(494) := '353037312C39382C353233342C39382C353535312C39382C36353331342C36362C383439322C36362C3131393830392C36362C3131393836312C36362C3131393931332C36362C3132303031372C36362C3132303036392C36362C3132303132312C3636';
wwv_flow_imp.g_varchar2_table(495) := '2C3132303137332C36362C3132303232352C36362C3132303237372C36362C3132303332392C36362C3132303338312C36362C3132303433332C36362C34323933322C36362C3931342C36362C3132303438392C36362C3132303534372C36362C313230';
wwv_flow_imp.g_varchar2_table(496) := '3630352C36362C3132303636332C36362C3132303732312C36362C353130382C36362C353632332C36362C34323139322C36362C36363137382C36362C36363230392C36362C36363330352C36362C36353334372C39392C383537332C39392C31313938';
wwv_flow_imp.g_varchar2_table(497) := '33362C39392C3131393838382C39392C3131393934302C39392C3131393939322C39392C3132303034342C39392C3132303039362C39392C3132303134382C39392C3132303230302C39392C3132303235322C39392C3132303330342C39392C31323033';
wwv_flow_imp.g_varchar2_table(498) := '35362C39392C3132303430382C39392C3132303436302C39392C373432382C39392C313031302C39392C31313432392C39392C34333935312C39392C36363632312C39392C3132383834342C36372C37313932322C36372C37313931332C36372C363533';
wwv_flow_imp.g_varchar2_table(499) := '31352C36372C383535372C36372C383435302C36372C383439332C36372C3131393831302C36372C3131393836322C36372C3131393931342C36372C3131393936362C36372C3132303031382C36372C3132303137342C36372C3132303232362C36372C';
wwv_flow_imp.g_varchar2_table(500) := '3132303237382C36372C3132303333302C36372C3132303338322C36372C3132303433342C36372C313031372C36372C31313432382C36372C353038372C36372C34323230322C36372C36363231302C36372C36363330362C36372C36363538312C3637';
wwv_flow_imp.g_varchar2_table(501) := '2C36363834342C36372C383537342C3130302C383531382C3130302C3131393833372C3130302C3131393838392C3130302C3131393934312C3130302C3131393939332C3130302C3132303034352C3130302C3132303039372C3130302C313230313439';
wwv_flow_imp.g_varchar2_table(502) := '2C3130302C3132303230312C3130302C3132303235332C3130302C3132303330352C3130302C3132303335372C3130302C3132303430392C3130302C3132303436312C3130302C313238312C3130302C353039352C3130302C353233312C3130302C3432';
wwv_flow_imp.g_varchar2_table(503) := '3139342C3130302C383535382C36382C383531372C36382C3131393831312C36382C3131393836332C36382C3131393931352C36382C3131393936372C36382C3132303031392C36382C3132303037312C36382C3132303132332C36382C313230313735';
wwv_flow_imp.g_varchar2_table(504) := '2C36382C3132303232372C36382C3132303237392C36382C3132303333312C36382C3132303338332C36382C3132303433352C36382C353032342C36382C353539382C36382C353631302C36382C34323139352C36382C383439342C3130312C36353334';
wwv_flow_imp.g_varchar2_table(505) := '392C3130312C383439352C3130312C383531392C3130312C3131393833382C3130312C3131393839302C3130312C3131393934322C3130312C3132303034362C3130312C3132303039382C3130312C3132303135302C3130312C3132303230322C313031';
wwv_flow_imp.g_varchar2_table(506) := '2C3132303235342C3130312C3132303330362C3130312C3132303335382C3130312C3132303431302C3130312C3132303436322C3130312C34333832362C3130312C313231332C3130312C383935392C36392C36353331372C36392C383439362C36392C';
wwv_flow_imp.g_varchar2_table(507) := '3131393831322C36392C3131393836342C36392C3131393931362C36392C3132303032302C36392C3132303037322C36392C3132303132342C36392C3132303137362C36392C3132303232382C36392C3132303238302C36392C3132303333322C36392C';
wwv_flow_imp.g_varchar2_table(508) := '3132303338342C36392C3132303433362C36392C3931372C36392C3132303439322C36392C3132303535302C36392C3132303630382C36392C3132303636362C36392C3132303732342C36392C31313537372C36392C353033362C36392C34323232342C';
wwv_flow_imp.g_varchar2_table(509) := '36392C37313834362C36392C37313835342C36392C36363138322C36392C3131393833392C3130322C3131393839312C3130322C3131393934332C3130322C3131393939352C3130322C3132303034372C3130322C3132303039392C3130322C31323031';
wwv_flow_imp.g_varchar2_table(510) := '35312C3130322C3132303230332C3130322C3132303235352C3130322C3132303330372C3130322C3132303335392C3130322C3132303431312C3130322C3132303436332C3130322C34333832392C3130322C34323930352C3130322C3338332C313032';
wwv_flow_imp.g_varchar2_table(511) := '2C373833372C3130322C313431322C3130322C3131393331352C37302C383439372C37302C3131393831332C37302C3131393836352C37302C3131393931372C37302C3132303032312C37302C3132303037332C37302C3132303132352C37302C313230';
wwv_flow_imp.g_varchar2_table(512) := '3137372C37302C3132303232392C37302C3132303238312C37302C3132303333332C37302C3132303338352C37302C3132303433372C37302C34323930342C37302C3938382C37302C3132303737382C37302C353535362C37302C34323230352C37302C';
wwv_flow_imp.g_varchar2_table(513) := '37313837342C37302C37313834322C37302C36363138332C37302C36363231332C37302C36363835332C37302C36353335312C3130332C383435382C3130332C3131393834302C3130332C3131393839322C3130332C3131393934342C3130332C313230';
wwv_flow_imp.g_varchar2_table(514) := '3034382C3130332C3132303130302C3130332C3132303135322C3130332C3132303230342C3130332C3132303235362C3130332C3132303330382C3130332C3132303336302C3130332C3132303431322C3130332C3132303436342C3130332C3630392C';
wwv_flow_imp.g_varchar2_table(515) := '3130332C373535352C3130332C3339372C3130332C313430392C3130332C3131393831342C37312C3131393836362C37312C3131393931382C37312C3131393937302C37312C3132303032322C37312C3132303037342C37312C3132303132362C37312C';
wwv_flow_imp.g_varchar2_table(516) := '3132303137382C37312C3132303233302C37312C3132303238322C37312C3132303333342C37312C3132303338362C37312C3132303433382C37312C313239322C37312C353035362C37312C353130372C37312C34323139382C37312C36353335322C31';
wwv_flow_imp.g_varchar2_table(517) := '30342C383436322C3130342C3131393834312C3130342C3131393934352C3130342C3131393939372C3130342C3132303034392C3130342C3132303130312C3130342C3132303135332C3130342C3132303230352C3130342C3132303235372C3130342C';
wwv_flow_imp.g_varchar2_table(518) := '3132303330392C3130342C3132303336312C3130342C3132303431332C3130342C3132303436352C3130342C313231312C3130342C313339322C3130342C353035382C3130342C36353332302C37322C383435392C37322C383436302C37322C38343631';
wwv_flow_imp.g_varchar2_table(519) := '2C37322C3131393831352C37322C3131393836372C37322C3131393931392C37322C3132303032332C37322C3132303137392C37322C3132303233312C37322C3132303238332C37322C3132303333352C37322C3132303338372C37322C313230343339';
wwv_flow_imp.g_varchar2_table(520) := '2C37322C3931392C37322C3132303439342C37322C3132303535322C37322C3132303631302C37322C3132303636382C37322C3132303732362C37322C31313430362C37322C353035312C37322C353530302C37322C34323231352C37322C3636323535';
wwv_flow_imp.g_varchar2_table(521) := '2C37322C3733312C3130352C393037352C3130352C36353335332C3130352C383536302C3130352C383530352C3130352C383532302C3130352C3131393834322C3130352C3131393839342C3130352C3131393934362C3130352C3131393939382C3130';
wwv_flow_imp.g_varchar2_table(522) := '352C3132303035302C3130352C3132303130322C3130352C3132303135342C3130352C3132303230362C3130352C3132303235382C3130352C3132303331302C3130352C3132303336322C3130352C3132303431342C3130352C3132303436362C313035';
wwv_flow_imp.g_varchar2_table(523) := '2C3132303438342C3130352C3631382C3130352C3631372C3130352C3935332C3130352C383132362C3130352C3839302C3130352C3132303532322C3130352C3132303538302C3130352C3132303633382C3130352C3132303639362C3130352C313230';
wwv_flow_imp.g_varchar2_table(524) := '3735342C3130352C313131302C3130352C34323536372C3130352C313233312C3130352C34333839332C3130352C353032392C3130352C37313837352C3130352C36353335342C3130362C383532312C3130362C3131393834332C3130362C3131393839';
wwv_flow_imp.g_varchar2_table(525) := '352C3130362C3131393934372C3130362C3131393939392C3130362C3132303035312C3130362C3132303130332C3130362C3132303135352C3130362C3132303230372C3130362C3132303235392C3130362C3132303331312C3130362C313230333633';
wwv_flow_imp.g_varchar2_table(526) := '2C3130362C3132303431352C3130362C3132303436372C3130362C313031312C3130362C313131322C3130362C36353332322C37342C3131393831372C37342C3131393836392C37342C3131393932312C37342C3131393937332C37342C313230303235';
wwv_flow_imp.g_varchar2_table(527) := '2C37342C3132303037372C37342C3132303132392C37342C3132303138312C37342C3132303233332C37342C3132303238352C37342C3132303333372C37342C3132303338392C37342C3132303434312C37342C34323933302C37342C3839352C37342C';
wwv_flow_imp.g_varchar2_table(528) := '313033322C37342C353033352C37342C353236312C37342C34323230312C37342C3131393834342C3130372C3131393839362C3130372C3131393934382C3130372C3132303030302C3130372C3132303035322C3130372C3132303130342C3130372C31';
wwv_flow_imp.g_varchar2_table(529) := '32303135362C3130372C3132303230382C3130372C3132303236302C3130372C3132303331322C3130372C3132303336342C3130372C3132303431362C3130372C3132303436382C3130372C383439302C37352C36353332332C37352C3131393831382C';
wwv_flow_imp.g_varchar2_table(530) := '37352C3131393837302C37352C3131393932322C37352C3131393937342C37352C3132303032362C37352C3132303037382C37352C3132303133302C37352C3132303138322C37352C3132303233342C37352C3132303238362C37352C3132303333382C';
wwv_flow_imp.g_varchar2_table(531) := '37352C3132303339302C37352C3132303434322C37352C3932322C37352C3132303439372C37352C3132303535352C37352C3132303631332C37352C3132303637312C37352C3132303732392C37352C31313431322C37352C353039342C37352C353834';
wwv_flow_imp.g_varchar2_table(532) := '352C37352C34323139392C37352C36363834302C37352C313437322C3130382C383733392C37332C393231332C37332C36353531322C37332C313633332C3130382C313737372C37332C36363333362C3130382C3132353132372C3130382C3132303738';
wwv_flow_imp.g_varchar2_table(533) := '332C37332C3132303739332C37332C3132303830332C37332C3132303831332C37332C3132303832332C37332C3133303033332C37332C36353332312C37332C383534342C37332C383436342C37332C383436352C37332C3131393831362C37332C3131';
wwv_flow_imp.g_varchar2_table(534) := '393836382C37332C3131393932302C37332C3132303032342C37332C3132303132382C37332C3132303138302C37332C3132303233322C37332C3132303238342C37332C3132303333362C37332C3132303338382C37332C3132303434302C37332C3635';
wwv_flow_imp.g_varchar2_table(535) := '3335362C3130382C383537322C37332C383436372C3130382C3131393834352C3130382C3131393839372C3130382C3131393934392C3130382C3132303030312C3130382C3132303035332C3130382C3132303130352C37332C3132303135372C37332C';
wwv_flow_imp.g_varchar2_table(536) := '3132303230392C37332C3132303236312C37332C3132303331332C37332C3132303336352C37332C3132303431372C37332C3132303436392C37332C3434382C37332C3132303439362C37332C3132303535342C37332C3132303631322C37332C313230';
wwv_flow_imp.g_varchar2_table(537) := '3637302C37332C3132303732382C37332C31313431302C37332C313033302C37332C313231362C37332C313439332C3130382C313530332C3130382C313537352C3130382C3132363436342C3130382C3132363539322C3130382C36353136362C313038';
wwv_flow_imp.g_varchar2_table(538) := '2C36353136352C3130382C313939342C3130382C31313539392C37332C353832352C37332C34323232362C37332C39333939322C37332C36363138362C3132342C36363331332C3132342C3131393333382C37362C383535362C37362C383436362C3736';
wwv_flow_imp.g_varchar2_table(539) := '2C3131393831392C37362C3131393837312C37362C3131393932332C37362C3132303032372C37362C3132303037392C37362C3132303133312C37362C3132303138332C37362C3132303233352C37362C3132303238372C37362C3132303333392C3736';
wwv_flow_imp.g_varchar2_table(540) := '2C3132303339312C37362C3132303434332C37362C31313437322C37362C353038362C37362C353239302C37362C34323230392C37362C39333937342C37362C37313834332C37362C37313835382C37362C36363538372C37362C36363835342C37362C';
wwv_flow_imp.g_varchar2_table(541) := '36353332352C37372C383535392C37372C383439392C37372C3131393832302C37372C3131393837322C37372C3131393932342C37372C3132303032382C37372C3132303038302C37372C3132303133322C37372C3132303138342C37372C3132303233';
wwv_flow_imp.g_varchar2_table(542) := '362C37372C3132303238382C37372C3132303334302C37372C3132303339322C37372C3132303434342C37372C3932342C37372C3132303439392C37372C3132303535372C37372C3132303631352C37372C3132303637332C37372C3132303733312C37';
wwv_flow_imp.g_varchar2_table(543) := '372C313031382C37372C31313431362C37372C353034372C37372C353631362C37372C353834362C37372C34323230372C37372C36363232342C37372C36363332312C37372C3131393834372C3131302C3131393839392C3131302C3131393935312C31';
wwv_flow_imp.g_varchar2_table(544) := '31302C3132303030332C3131302C3132303035352C3131302C3132303130372C3131302C3132303135392C3131302C3132303231312C3131302C3132303236332C3131302C3132303331352C3131302C3132303336372C3131302C3132303431392C3131';
wwv_flow_imp.g_varchar2_table(545) := '302C3132303437312C3131302C313430302C3131302C313430342C3131302C36353332362C37382C383436392C37382C3131393832312C37382C3131393837332C37382C3131393932352C37382C3131393937372C37382C3132303032392C37382C3132';
wwv_flow_imp.g_varchar2_table(546) := '303038312C37382C3132303138352C37382C3132303233372C37382C3132303238392C37382C3132303334312C37382C3132303339332C37382C3132303434352C37382C3932352C37382C3132303530302C37382C3132303535382C37382C3132303631';
wwv_flow_imp.g_varchar2_table(547) := '362C37382C3132303637342C37382C3132303733322C37382C31313431382C37382C34323230382C37382C36363833352C37382C333037342C3131312C333230322C3131312C333333302C3131312C333435382C3131312C323430362C3131312C323636';
wwv_flow_imp.g_varchar2_table(548) := '322C3131312C323739302C3131312C333034362C3131312C333137342C3131312C333330322C3131312C333433302C3131312C333636342C3131312C333739322C3131312C343136302C3131312C313633372C3131312C313738312C3131312C36353335';
wwv_flow_imp.g_varchar2_table(549) := '392C3131312C383530302C3131312C3131393834382C3131312C3131393930302C3131312C3131393935322C3131312C3132303035362C3131312C3132303130382C3131312C3132303136302C3131312C3132303231322C3131312C3132303236342C31';
wwv_flow_imp.g_varchar2_table(550) := '31312C3132303331362C3131312C3132303336382C3131312C3132303432302C3131312C3132303437322C3131312C373433392C3131312C373434312C3131312C34333833372C3131312C3935392C3131312C3132303532382C3131312C313230353836';
wwv_flow_imp.g_varchar2_table(551) := '2C3131312C3132303634342C3131312C3132303730322C3131312C3132303736302C3131312C3936332C3131312C3132303533322C3131312C3132303539302C3131312C3132303634382C3131312C3132303730362C3131312C3132303736342C313131';
wwv_flow_imp.g_varchar2_table(552) := '2C31313432332C3131312C343335312C3131312C313431332C3131312C313530352C3131312C313630372C3131312C3132363530302C3131312C3132363536342C3131312C3132363539362C3131312C36353235392C3131312C36353236302C3131312C';
wwv_flow_imp.g_varchar2_table(553) := '36353235382C3131312C36353235372C3131312C313732362C3131312C36343432382C3131312C36343432392C3131312C36343432372C3131312C36343432362C3131312C313732392C3131312C36343432342C3131312C36343432352C3131312C3634';
wwv_flow_imp.g_varchar2_table(554) := '3432332C3131312C36343432322C3131312C313734392C3131312C333336302C3131312C343132352C3131312C36363739342C3131312C37313838302C3131312C37313839352C3131312C36363630342C3131312C313938342C37392C323533342C3739';
wwv_flow_imp.g_varchar2_table(555) := '2C323931382C37392C31323239352C37392C37303836342C37392C37313930342C37392C3132303738322C37392C3132303739322C37392C3132303830322C37392C3132303831322C37392C3132303832322C37392C3133303033322C37392C36353332';
wwv_flow_imp.g_varchar2_table(556) := '372C37392C3131393832322C37392C3131393837342C37392C3131393932362C37392C3131393937382C37392C3132303033302C37392C3132303038322C37392C3132303133342C37392C3132303138362C37392C3132303233382C37392C3132303239';
wwv_flow_imp.g_varchar2_table(557) := '302C37392C3132303334322C37392C3132303339342C37392C3132303434362C37392C3932372C37392C3132303530322C37392C3132303536302C37392C3132303631382C37392C3132303637362C37392C3132303733342C37392C31313432322C3739';
wwv_flow_imp.g_varchar2_table(558) := '2C313336352C37392C31313630342C37392C343831362C37392C323834382C37392C36363735342C37392C34323232372C37392C37313836312C37392C36363139342C37392C36363231392C37392C36363536342C37392C36363833382C37392C393037';
wwv_flow_imp.g_varchar2_table(559) := '362C3131322C36353336302C3131322C3131393834392C3131322C3131393930312C3131322C3131393935332C3131322C3132303030352C3131322C3132303035372C3131322C3132303130392C3131322C3132303136312C3131322C3132303231332C';
wwv_flow_imp.g_varchar2_table(560) := '3131322C3132303236352C3131322C3132303331372C3131322C3132303336392C3131322C3132303432312C3131322C3132303437332C3131322C3936312C3131322C3132303533302C3131322C3132303534342C3131322C3132303538382C3131322C';
wwv_flow_imp.g_varchar2_table(561) := '3132303630322C3131322C3132303634362C3131322C3132303636302C3131322C3132303730342C3131322C3132303731382C3131322C3132303736322C3131322C3132303737362C3131322C31313432372C3131322C36353332382C38302C38343733';
wwv_flow_imp.g_varchar2_table(562) := '2C38302C3131393832332C38302C3131393837352C38302C3131393932372C38302C3131393937392C38302C3132303033312C38302C3132303038332C38302C3132303138372C38302C3132303233392C38302C3132303239312C38302C313230333433';
wwv_flow_imp.g_varchar2_table(563) := '2C38302C3132303339352C38302C3132303434372C38302C3932392C38302C3132303530342C38302C3132303536322C38302C3132303632302C38302C3132303637382C38302C3132303733362C38302C31313432362C38302C353039302C38302C3532';
wwv_flow_imp.g_varchar2_table(564) := '32392C38302C34323139332C38302C36363139372C38302C3131393835302C3131332C3131393930322C3131332C3131393935342C3131332C3132303030362C3131332C3132303035382C3131332C3132303131302C3131332C3132303136322C313133';
wwv_flow_imp.g_varchar2_table(565) := '2C3132303231342C3131332C3132303236362C3131332C3132303331382C3131332C3132303337302C3131332C3132303432322C3131332C3132303437342C3131332C313330372C3131332C313337392C3131332C313338322C3131332C383437342C38';
wwv_flow_imp.g_varchar2_table(566) := '312C3131393832342C38312C3131393837362C38312C3131393932382C38312C3131393938302C38312C3132303033322C38312C3132303038342C38312C3132303138382C38312C3132303234302C38312C3132303239322C38312C3132303334342C38';
wwv_flow_imp.g_varchar2_table(567) := '312C3132303339362C38312C3132303434382C38312C31313630352C38312C3131393835312C3131342C3131393930332C3131342C3131393935352C3131342C3132303030372C3131342C3132303035392C3131342C3132303131312C3131342C313230';
wwv_flow_imp.g_varchar2_table(568) := '3136332C3131342C3132303231352C3131342C3132303236372C3131342C3132303331392C3131342C3132303337312C3131342C3132303432332C3131342C3132303437352C3131342C34333834372C3131342C34333834382C3131342C373436322C31';
wwv_flow_imp.g_varchar2_table(569) := '31342C31313339372C3131342C34333930352C3131342C3131393331382C38322C383437352C38322C383437362C38322C383437372C38322C3131393832352C38322C3131393837372C38322C3131393932392C38322C3132303033332C38322C313230';
wwv_flow_imp.g_varchar2_table(570) := '3138392C38322C3132303234312C38322C3132303239332C38322C3132303334352C38322C3132303339372C38322C3132303434392C38322C3432322C38322C353032352C38322C353037342C38322C36363734302C38322C353531312C38322C343232';
wwv_flow_imp.g_varchar2_table(571) := '31312C38322C39343030352C38322C36353336332C3131352C3131393835322C3131352C3131393930342C3131352C3131393935362C3131352C3132303030382C3131352C3132303036302C3131352C3132303131322C3131352C3132303136342C3131';
wwv_flow_imp.g_varchar2_table(572) := '352C3132303231362C3131352C3132303236382C3131352C3132303332302C3131352C3132303337322C3131352C3132303432342C3131352C3132303437362C3131352C34323830312C3131352C3434352C3131352C313130392C3131352C3433393436';
wwv_flow_imp.g_varchar2_table(573) := '2C3131352C37313837332C3131352C36363633322C3131352C36353333312C38332C3131393832362C38332C3131393837382C38332C3131393933302C38332C3131393938322C38332C3132303033342C38332C3132303038362C38332C313230313338';
wwv_flow_imp.g_varchar2_table(574) := '2C38332C3132303139302C38332C3132303234322C38332C3132303239342C38332C3132303334362C38332C3132303339382C38332C3132303435302C38332C313032392C38332C313335392C38332C353037372C38332C353038322C38332C34323231';
wwv_flow_imp.g_varchar2_table(575) := '302C38332C39343031302C38332C36363139382C38332C36363539322C38332C3131393835332C3131362C3131393930352C3131362C3131393935372C3131362C3132303030392C3131362C3132303036312C3131362C3132303131332C3131362C3132';
wwv_flow_imp.g_varchar2_table(576) := '303136352C3131362C3132303231372C3131362C3132303236392C3131362C3132303332312C3131362C3132303337332C3131362C3132303432352C3131362C3132303437372C3131362C383836382C38342C31303230312C38342C3132383837322C38';
wwv_flow_imp.g_varchar2_table(577) := '342C36353333322C38342C3131393832372C38342C3131393837392C38342C3131393933312C38342C3131393938332C38342C3132303033352C38342C3132303038372C38342C3132303133392C38342C3132303139312C38342C3132303234332C3834';
wwv_flow_imp.g_varchar2_table(578) := '2C3132303239352C38342C3132303334372C38342C3132303339392C38342C3132303435312C38342C3933322C38342C3132303530372C38342C3132303536352C38342C3132303632332C38342C3132303638312C38342C3132303733392C38342C3131';
wwv_flow_imp.g_varchar2_table(579) := '3433302C38342C353032362C38342C34323139362C38342C39333936322C38342C37313836382C38342C36363139392C38342C36363232352C38342C36363332352C38342C3131393835342C3131372C3131393930362C3131372C3131393935382C3131';
wwv_flow_imp.g_varchar2_table(580) := '372C3132303031302C3131372C3132303036322C3131372C3132303131342C3131372C3132303136362C3131372C3132303231382C3131372C3132303237302C3131372C3132303332322C3131372C3132303337342C3131372C3132303432362C313137';
wwv_flow_imp.g_varchar2_table(581) := '2C3132303437382C3131372C34323931312C3131372C373435322C3131372C34333835342C3131372C34333835382C3131372C3635312C3131372C3936352C3131372C3132303533342C3131372C3132303539322C3131372C3132303635302C3131372C';
wwv_flow_imp.g_varchar2_table(582) := '3132303730382C3131372C3132303736362C3131372C313430352C3131372C36363830362C3131372C37313839362C3131372C383734362C38352C383839392C38352C3131393832382C38352C3131393838302C38352C3131393933322C38352C313139';
wwv_flow_imp.g_varchar2_table(583) := '3938342C38352C3132303033362C38352C3132303038382C38352C3132303134302C38352C3132303139322C38352C3132303234342C38352C3132303239362C38352C3132303334382C38352C3132303430302C38352C3132303435322C38352C313335';
wwv_flow_imp.g_varchar2_table(584) := '372C38352C343630382C38352C36363736362C38352C353139362C38352C34323232382C38352C39343031382C38352C37313836342C38352C383734342C3131382C383839372C3131382C36353336362C3131382C383536342C3131382C313139383535';
wwv_flow_imp.g_varchar2_table(585) := '2C3131382C3131393930372C3131382C3131393935392C3131382C3132303031312C3131382C3132303036332C3131382C3132303131352C3131382C3132303136372C3131382C3132303231392C3131382C3132303237312C3131382C3132303332332C';
wwv_flow_imp.g_varchar2_table(586) := '3131382C3132303337352C3131382C3132303432372C3131382C3132303437392C3131382C373435362C3131382C3935372C3131382C3132303532362C3131382C3132303538342C3131382C3132303634322C3131382C3132303730302C3131382C3132';
wwv_flow_imp.g_varchar2_table(587) := '303735382C3131382C313134312C3131382C313439362C3131382C37313433302C3131382C34333934352C3131382C37313837322C3131382C3131393330392C38362C313633392C38362C313738332C38362C383534382C38362C3131393832392C3836';
wwv_flow_imp.g_varchar2_table(588) := '2C3131393838312C38362C3131393933332C38362C3131393938352C38362C3132303033372C38362C3132303038392C38362C3132303134312C38362C3132303139332C38362C3132303234352C38362C3132303239372C38362C3132303334392C3836';
wwv_flow_imp.g_varchar2_table(589) := '2C3132303430312C38362C3132303435332C38362C313134302C38362C31313537362C38362C353038312C38362C353136372C38362C34323731392C38362C34323231342C38362C39333936302C38362C37313834302C38362C36363834352C38362C36';
wwv_flow_imp.g_varchar2_table(590) := '32332C3131392C3131393835362C3131392C3131393930382C3131392C3131393936302C3131392C3132303031322C3131392C3132303036342C3131392C3132303131362C3131392C3132303136382C3131392C3132303232302C3131392C3132303237';
wwv_flow_imp.g_varchar2_table(591) := '322C3131392C3132303332342C3131392C3132303337362C3131392C3132303432382C3131392C3132303438302C3131392C373435372C3131392C313132312C3131392C313330392C3131392C313337372C3131392C37313433342C3131392C37313433';
wwv_flow_imp.g_varchar2_table(592) := '382C3131392C37313433392C3131392C34333930372C3131392C37313931392C38372C37313931302C38372C3131393833302C38372C3131393838322C38372C3131393933342C38372C3131393938362C38372C3132303033382C38372C313230303930';
wwv_flow_imp.g_varchar2_table(593) := '2C38372C3132303134322C38372C3132303139342C38372C3132303234362C38372C3132303239382C38372C3132303335302C38372C3132303430322C38372C3132303435342C38372C313330382C38372C353034332C38372C353037362C38372C3432';
wwv_flow_imp.g_varchar2_table(594) := '3231382C38372C353734322C3132302C31303533392C3132302C31303534302C3132302C31303739392C3132302C36353336382C3132302C383536392C3132302C3131393835372C3132302C3131393930392C3132302C3131393936312C3132302C3132';
wwv_flow_imp.g_varchar2_table(595) := '303031332C3132302C3132303036352C3132302C3132303131372C3132302C3132303136392C3132302C3132303232312C3132302C3132303237332C3132302C3132303332352C3132302C3132303337372C3132302C3132303432392C3132302C313230';
wwv_flow_imp.g_varchar2_table(596) := '3438312C3132302C353434312C3132302C353530312C3132302C353734312C38382C393538372C38382C36363333382C38382C37313931362C38382C36353333362C38382C383535332C38382C3131393833312C38382C3131393838332C38382C313139';
wwv_flow_imp.g_varchar2_table(597) := '3933352C38382C3131393938372C38382C3132303033392C38382C3132303039312C38382C3132303134332C38382C3132303139352C38382C3132303234372C38382C3132303239392C38382C3132303335312C38382C3132303430332C38382C313230';
wwv_flow_imp.g_varchar2_table(598) := '3435352C38382C34323933312C38382C3933352C38382C3132303531302C38382C3132303536382C38382C3132303632362C38382C3132303638342C38382C3132303734322C38382C31313433362C38382C31313631332C38382C353831352C38382C34';
wwv_flow_imp.g_varchar2_table(599) := '323231392C38382C36363139322C38382C36363232382C38382C36363332372C38382C36363835352C38382C3631312C3132312C373536342C3132312C36353336392C3132312C3131393835382C3132312C3131393931302C3132312C3131393936322C';
wwv_flow_imp.g_varchar2_table(600) := '3132312C3132303031342C3132312C3132303036362C3132312C3132303131382C3132312C3132303137302C3132312C3132303232322C3132312C3132303237342C3132312C3132303332362C3132312C3132303337382C3132312C3132303433302C31';
wwv_flow_imp.g_varchar2_table(601) := '32312C3132303438322C3132312C3635352C3132312C373933352C3132312C34333836362C3132312C3934372C3132312C383530392C3132312C3132303531362C3132312C3132303537342C3132312C3132303633322C3132312C3132303639302C3132';
wwv_flow_imp.g_varchar2_table(602) := '312C3132303734382C3132312C313139392C3132312C343332372C3132312C37313930302C3132312C36353333372C38392C3131393833322C38392C3131393838342C38392C3131393933362C38392C3131393938382C38392C3132303034302C38392C';
wwv_flow_imp.g_varchar2_table(603) := '3132303039322C38392C3132303134342C38392C3132303139362C38392C3132303234382C38392C3132303330302C38392C3132303335322C38392C3132303430342C38392C3132303435362C38392C3933332C38392C3937382C38392C313230353038';
wwv_flow_imp.g_varchar2_table(604) := '2C38392C3132303536362C38392C3132303632342C38392C3132303638322C38392C3132303734302C38392C31313433322C38392C313139382C38392C353033332C38392C353035332C38392C34323232302C38392C39343031392C38392C3731383434';
wwv_flow_imp.g_varchar2_table(605) := '2C38392C36363232362C38392C3131393835392C3132322C3131393931312C3132322C3131393936332C3132322C3132303031352C3132322C3132303036372C3132322C3132303131392C3132322C3132303137312C3132322C3132303232332C313232';
wwv_flow_imp.g_varchar2_table(606) := '2C3132303237352C3132322C3132303332372C3132322C3132303337392C3132322C3132303433312C3132322C3132303438332C3132322C373435382C3132322C34333932332C3132322C37313837362C3132322C36363239332C39302C37313930392C';
wwv_flow_imp.g_varchar2_table(607) := '39302C36353333382C39302C383438342C39302C383438382C39302C3131393833332C39302C3131393838352C39302C3131393933372C39302C3131393938392C39302C3132303034312C39302C3132303139372C39302C3132303234392C39302C3132';
wwv_flow_imp.g_varchar2_table(608) := '303330312C39302C3132303335332C39302C3132303430352C39302C3132303435372C39302C3931382C39302C3132303439332C39302C3132303535312C39302C3132303630392C39302C3132303636372C39302C3132303732352C39302C353035392C';
wwv_flow_imp.g_varchar2_table(609) := '39302C34323230342C39302C37313834392C39302C36353238322C33342C36353238342C33362C36353238352C33372C36353238362C33382C36353239302C34322C36353239312C34332C36353239342C34362C36353239352C34372C36353239362C34';
wwv_flow_imp.g_varchar2_table(610) := '382C36353239372C34392C36353239382C35302C36353239392C35312C36353330302C35322C36353330312C35332C36353330322C35342C36353330332C35352C36353330342C35362C36353330352C35372C36353330382C36302C36353330392C3631';
wwv_flow_imp.g_varchar2_table(611) := '2C36353331302C36322C36353331322C36342C36353331362C36382C36353331382C37302C36353331392C37312C36353332342C37362C36353332392C38312C36353333302C38322C36353333332C38352C36353333342C38362C36353333352C38372C';
wwv_flow_imp.g_varchar2_table(612) := '36353334332C39352C36353334362C39382C36353334382C3130302C36353335302C3130322C36353335352C3130372C36353335372C3130392C36353335382C3131302C36353336312C3131332C36353336322C3131342C36353336342C3131362C3635';
wwv_flow_imp.g_varchar2_table(613) := '3336352C3131372C36353336372C3131392C36353337302C3132322C36353337312C3132332C36353337332C3132352C3131393834362C3130395D2C225F64656661756C74223A5B3136302C33322C383231312C34352C36353337342C3132362C363533';
wwv_flow_imp.g_varchar2_table(614) := '30362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C';
wwv_flow_imp.g_varchar2_table(615) := '36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C313132';
wwv_flow_imp.g_varchar2_table(616) := '2C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C3635323839';
wwv_flow_imp.g_varchar2_table(617) := '2C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226373223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C313234';
wwv_flow_imp.g_varchar2_table(618) := '39342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C31';
wwv_flow_imp.g_varchar2_table(619) := '30352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C313039332C3132302C313036312C';
wwv_flow_imp.g_varchar2_table(620) := '38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226465223A5B36353337342C3132362C36353330362C35382C';
wwv_flow_imp.g_varchar2_table(621) := '36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038';
wwv_flow_imp.g_varchar2_table(622) := '392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C';
wwv_flow_imp.g_varchar2_table(623) := '3131322C313035362C38302C313037352C3131342C313035382C38342C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36';
wwv_flow_imp.g_varchar2_table(624) := '353330372C35392C36353331312C36335D2C226573223A5B383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C';
wwv_flow_imp.g_varchar2_table(625) := '313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C313035322C37372C313038';
wwv_flow_imp.g_varchar2_table(626) := '362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36';
wwv_flow_imp.g_varchar2_table(627) := '353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226672223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C38323435';
wwv_flow_imp.g_varchar2_table(628) := '2C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37';
wwv_flow_imp.g_varchar2_table(629) := '322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C313230';
wwv_flow_imp.g_varchar2_table(630) := '2C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226974223A5B3136302C';
wwv_flow_imp.g_varchar2_table(631) := '33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C';
wwv_flow_imp.g_varchar2_table(632) := '36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C';
wwv_flow_imp.g_varchar2_table(633) := '313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33';
wwv_flow_imp.g_varchar2_table(634) := '352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226A61223A5B383231312C34352C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C38323435';
wwv_flow_imp.g_varchar2_table(635) := '2C39362C3138302C39362C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C';
wwv_flow_imp.g_varchar2_table(636) := '3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C31';
wwv_flow_imp.g_varchar2_table(637) := '3039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353239322C34342C36353330372C35395D2C226B6F223A5B383231312C34352C36353337342C3132362C36353330362C35382C36353238312C';
wwv_flow_imp.g_varchar2_table(638) := '33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C';
wwv_flow_imp.g_varchar2_table(639) := '313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C31';
wwv_flow_imp.g_varchar2_table(640) := '3035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C';
wwv_flow_imp.g_varchar2_table(641) := '36335D2C22706C223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39';
wwv_flow_imp.g_varchar2_table(642) := '372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C3130';
wwv_flow_imp.g_varchar2_table(643) := '38362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C';
wwv_flow_imp.g_varchar2_table(644) := '36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C2270742D4252223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C';
wwv_flow_imp.g_varchar2_table(645) := '383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C31303737';
wwv_flow_imp.g_varchar2_table(646) := '2C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C';
wwv_flow_imp.g_varchar2_table(647) := '3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36';
wwv_flow_imp.g_varchar2_table(648) := '353331312C36335D2C227170732D706C6F63223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C3132343934';
wwv_flow_imp.g_varchar2_table(649) := '2C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C313035';
wwv_flow_imp.g_varchar2_table(650) := '2C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C';
wwv_flow_imp.g_varchar2_table(651) := '313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227275223A5B36353337342C3132362C36353330362C35382C363532';
wwv_flow_imp.g_varchar2_table(652) := '38312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C3330352C3130352C3932312C37332C313030392C3131322C3231352C3132302C36353238332C33352C36353238382C34302C36353238';
wwv_flow_imp.g_varchar2_table(653) := '392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227472223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C313234';
wwv_flow_imp.g_varchar2_table(654) := '39342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C313035302C';
wwv_flow_imp.g_varchar2_table(655) := '37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C';
wwv_flow_imp.g_varchar2_table(656) := '38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227A682D68616E73223A5B36353337342C3132362C36353330';
wwv_flow_imp.g_varchar2_table(657) := '362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36';
wwv_flow_imp.g_varchar2_table(658) := '372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C3830';
wwv_flow_imp.g_varchar2_table(659) := '2C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238382C34302C36353238392C34315D2C227A682D68616E74223A5B383231312C34352C3635';
wwv_flow_imp.g_varchar2_table(660) := '3337342C3132362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034';
wwv_flow_imp.g_varchar2_table(661) := '352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C31303538';
wwv_flow_imp.g_varchar2_table(662) := '2C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353330372C35395D7D272929292C66652E63616368653D6E657720636C6173737B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(663) := '28652C74297B746869732E6C61737443616368653D766F696420302C746869732E6C6173744172674B65793D766F696420302C2266756E6374696F6E223D3D747970656F6620653F28746869732E5F666E3D652C746869732E5F636F6D707574654B6579';
wwv_flow_imp.g_varchar2_table(664) := '3D7365293A28746869732E5F666E3D742C746869732E5F636F6D707574654B65793D652E67657443616368654B6579297D6765742865297B636F6E737420743D746869732E5F636F6D707574654B65792865293B72657475726E20746869732E6C617374';
wwv_flow_imp.g_varchar2_table(665) := '4172674B6579213D3D74262628746869732E6C6173744172674B65793D742C746869732E6C61737443616368653D746869732E5F666E286529292C746869732E6C61737443616368657D7D287B67657443616368654B65793A4A534F4E2E737472696E67';
wwv_flow_imp.g_varchar2_table(666) := '6966797D2C28653D3E7B66756E6374696F6E20742865297B636F6E737420743D6E6577204D61703B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B3D3229742E73657428655B6E5D2C655B6E2B315D293B72657475726E20747D66756E63';
wwv_flow_imp.g_varchar2_table(667) := '74696F6E206E28652C74297B69662821652972657475726E20743B636F6E7374206E3D6E6577204D61703B666F7228636F6E73745B692C725D6F66206529742E68617328692926266E2E73657428692C72293B72657475726E206E7D636F6E737420693D';
wwv_flow_imp.g_varchar2_table(668) := '61652E616D626967756F7573436861726163746572446174612E76616C75653B6C657420722C733D652E66696C7465722828653D3E21652E7374617274735769746828225F222926266520696E206929293B303D3D3D732E6C656E677468262628733D5B';
wwv_flow_imp.g_varchar2_table(669) := '225F64656661756C74225D293B666F7228636F6E73742065206F66207329723D6E28722C7428695B655D29293B636F6E7374206F3D66756E6374696F6E28652C74297B636F6E7374206E3D6E6577204D61702865293B666F7228636F6E73745B652C695D';
wwv_flow_imp.g_varchar2_table(670) := '6F662074296E2E73657428652C69293B72657475726E206E7D287428692E5F636F6D6D6F6E292C72293B72657475726E206E6577206165286F297D29292C66652E5F6C6F63616C65733D6E6577206F65282828293D3E4F626A6563742E6B657973286165';
wwv_flow_imp.g_varchar2_table(671) := '2E616D626967756F7573436861726163746572446174612E76616C7565292E66696C7465722828653D3E21652E7374617274735769746828225F2229292929293B636C6173732070657B737461746963206765745261774461746128297B72657475726E';
wwv_flow_imp.g_varchar2_table(672) := '204A534F4E2E706172736528225B392C31302C31312C31322C31332C33322C3132372C3136302C3137332C3834372C313536342C343434372C343434382C363036382C363036392C363135352C363135362C363135372C363135382C373335352C373335';
wwv_flow_imp.g_varchar2_table(673) := '362C383139322C383139332C383139342C383139352C383139362C383139372C383139382C383139392C383230302C383230312C383230322C383230332C383230342C383230352C383230362C383230372C383233342C383233352C383233362C383233';
wwv_flow_imp.g_varchar2_table(674) := '372C383233382C383233392C383238372C383238382C383238392C383239302C383239312C383239322C383239332C383239342C383239352C383239362C383239372C383239382C383239392C383330302C383330312C383330322C383330332C313032';
wwv_flow_imp.g_varchar2_table(675) := '34302C31323238382C31323634342C36353032342C36353032352C36353032362C36353032372C36353032382C36353032392C36353033302C36353033312C36353033322C36353033332C36353033342C36353033352C36353033362C36353033372C36';
wwv_flow_imp.g_varchar2_table(676) := '353033382C36353033392C36353237392C36353434302C36353532302C36353532312C36353532322C36353532332C36353532342C36353532352C36353532362C36353532372C36353532382C36353533322C37383834342C3131393135352C31313931';
wwv_flow_imp.g_varchar2_table(677) := '35362C3131393135372C3131393135382C3131393135392C3131393136302C3131393136312C3131393136322C3931373530342C3931373530352C3931373530362C3931373530372C3931373530382C3931373530392C3931373531302C393137353131';
wwv_flow_imp.g_varchar2_table(678) := '2C3931373531322C3931373531332C3931373531342C3931373531352C3931373531362C3931373531372C3931373531382C3931373531392C3931373532302C3931373532312C3931373532322C3931373532332C3931373532342C3931373532352C39';
wwv_flow_imp.g_varchar2_table(679) := '31373532362C3931373532372C3931373532382C3931373532392C3931373533302C3931373533312C3931373533322C3931373533332C3931373533342C3931373533352C3931373533362C3931373533372C3931373533382C3931373533392C393137';
wwv_flow_imp.g_varchar2_table(680) := '3534302C3931373534312C3931373534322C3931373534332C3931373534342C3931373534352C3931373534362C3931373534372C3931373534382C3931373534392C3931373535302C3931373535312C3931373535322C3931373535332C3931373535';
wwv_flow_imp.g_varchar2_table(681) := '342C3931373535352C3931373535362C3931373535372C3931373535382C3931373535392C3931373536302C3931373536312C3931373536322C3931373536332C3931373536342C3931373536352C3931373536362C3931373536372C3931373536382C';
wwv_flow_imp.g_varchar2_table(682) := '3931373536392C3931373537302C3931373537312C3931373537322C3931373537332C3931373537342C3931373537352C3931373537362C3931373537372C3931373537382C3931373537392C3931373538302C3931373538312C3931373538322C3931';
wwv_flow_imp.g_varchar2_table(683) := '373538332C3931373538342C3931373538352C3931373538362C3931373538372C3931373538382C3931373538392C3931373539302C3931373539312C3931373539322C3931373539332C3931373539342C3931373539352C3931373539362C39313735';
wwv_flow_imp.g_varchar2_table(684) := '39372C3931373539382C3931373539392C3931373630302C3931373630312C3931373630322C3931373630332C3931373630342C3931373630352C3931373630362C3931373630372C3931373630382C3931373630392C3931373631302C393137363131';
wwv_flow_imp.g_varchar2_table(685) := '2C3931373631322C3931373631332C3931373631342C3931373631352C3931373631362C3931373631372C3931373631382C3931373631392C3931373632302C3931373632312C3931373632322C3931373632332C3931373632342C3931373632352C39';
wwv_flow_imp.g_varchar2_table(686) := '31373632362C3931373632372C3931373632382C3931373632392C3931373633302C3931373633312C3931373736302C3931373736312C3931373736322C3931373736332C3931373736342C3931373736352C3931373736362C3931373736372C393137';
wwv_flow_imp.g_varchar2_table(687) := '3736382C3931373736392C3931373737302C3931373737312C3931373737322C3931373737332C3931373737342C3931373737352C3931373737362C3931373737372C3931373737382C3931373737392C3931373738302C3931373738312C3931373738';
wwv_flow_imp.g_varchar2_table(688) := '322C3931373738332C3931373738342C3931373738352C3931373738362C3931373738372C3931373738382C3931373738392C3931373739302C3931373739312C3931373739322C3931373739332C3931373739342C3931373739352C3931373739362C';
wwv_flow_imp.g_varchar2_table(689) := '3931373739372C3931373739382C3931373739392C3931373830302C3931373830312C3931373830322C3931373830332C3931373830342C3931373830352C3931373830362C3931373830372C3931373830382C3931373830392C3931373831302C3931';
wwv_flow_imp.g_varchar2_table(690) := '373831312C3931373831322C3931373831332C3931373831342C3931373831352C3931373831362C3931373831372C3931373831382C3931373831392C3931373832302C3931373832312C3931373832322C3931373832332C3931373832342C39313738';
wwv_flow_imp.g_varchar2_table(691) := '32352C3931373832362C3931373832372C3931373832382C3931373832392C3931373833302C3931373833312C3931373833322C3931373833332C3931373833342C3931373833352C3931373833362C3931373833372C3931373833382C393137383339';
wwv_flow_imp.g_varchar2_table(692) := '2C3931373834302C3931373834312C3931373834322C3931373834332C3931373834342C3931373834352C3931373834362C3931373834372C3931373834382C3931373834392C3931373835302C3931373835312C3931373835322C3931373835332C39';
wwv_flow_imp.g_varchar2_table(693) := '31373835342C3931373835352C3931373835362C3931373835372C3931373835382C3931373835392C3931373836302C3931373836312C3931373836322C3931373836332C3931373836342C3931373836352C3931373836362C3931373836372C393137';
wwv_flow_imp.g_varchar2_table(694) := '3836382C3931373836392C3931373837302C3931373837312C3931373837322C3931373837332C3931373837342C3931373837352C3931373837362C3931373837372C3931373837382C3931373837392C3931373838302C3931373838312C3931373838';
wwv_flow_imp.g_varchar2_table(695) := '322C3931373838332C3931373838342C3931373838352C3931373838362C3931373838372C3931373838382C3931373838392C3931373839302C3931373839312C3931373839322C3931373839332C3931373839342C3931373839352C3931373839362C';
wwv_flow_imp.g_varchar2_table(696) := '3931373839372C3931373839382C3931373839392C3931373930302C3931373930312C3931373930322C3931373930332C3931373930342C3931373930352C3931373930362C3931373930372C3931373930382C3931373930392C3931373931302C3931';
wwv_flow_imp.g_varchar2_table(697) := '373931312C3931373931322C3931373931332C3931373931342C3931373931352C3931373931362C3931373931372C3931373931382C3931373931392C3931373932302C3931373932312C3931373932322C3931373932332C3931373932342C39313739';
wwv_flow_imp.g_varchar2_table(698) := '32352C3931373932362C3931373932372C3931373932382C3931373932392C3931373933302C3931373933312C3931373933322C3931373933332C3931373933342C3931373933352C3931373933362C3931373933372C3931373933382C393137393339';
wwv_flow_imp.g_varchar2_table(699) := '2C3931373934302C3931373934312C3931373934322C3931373934332C3931373934342C3931373934352C3931373934362C3931373934372C3931373934382C3931373934392C3931373935302C3931373935312C3931373935322C3931373935332C39';
wwv_flow_imp.g_varchar2_table(700) := '31373935342C3931373935352C3931373935362C3931373935372C3931373935382C3931373935392C3931373936302C3931373936312C3931373936322C3931373936332C3931373936342C3931373936352C3931373936362C3931373936372C393137';
wwv_flow_imp.g_varchar2_table(701) := '3936382C3931373936392C3931373937302C3931373937312C3931373937322C3931373937332C3931373937342C3931373937352C3931373937362C3931373937372C3931373937382C3931373937392C3931373938302C3931373938312C3931373938';
wwv_flow_imp.g_varchar2_table(702) := '322C3931373938332C3931373938342C3931373938352C3931373938362C3931373938372C3931373938382C3931373938392C3931373939302C3931373939312C3931373939322C3931373939332C3931373939342C3931373939352C3931373939362C';
wwv_flow_imp.g_varchar2_table(703) := '3931373939372C3931373939382C3931373939395D22297D737461746963206765744461746128297B72657475726E20746869732E5F646174617C7C28746869732E5F646174613D6E6577205365742870652E67657452617744617461282929292C7468';
wwv_flow_imp.g_varchar2_table(704) := '69732E5F646174617D737461746963206973496E76697369626C654368617261637465722865297B72657475726E2070652E6765744461746128292E6861732865297D7374617469632067657420636F6465506F696E747328297B72657475726E207065';
wwv_flow_imp.g_varchar2_table(705) := '2E6765744461746128297D7D70652E5F646174613D766F696420303B6C65742062653B636C617373205F657B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6D6574';
wwv_flow_imp.g_varchar2_table(706) := '686F643D6E2C746869732E617267733D692C746869732E747970653D307D7D636C6173732076657B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7365713D742C746869732E7265733D6E2C74';
wwv_flow_imp.g_varchar2_table(707) := '6869732E6572723D692C746869732E747970653D317D7D636C6173732043657B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E744E616D653D6E2C746869';
wwv_flow_imp.g_varchar2_table(708) := '732E6172673D692C746869732E747970653D327D7D636C6173732079657B636F6E7374727563746F7228652C742C6E297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E743D6E2C746869732E747970653D33';
wwv_flow_imp.g_varchar2_table(709) := '7D7D636C617373204C657B636F6E7374727563746F7228652C74297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E747970653D347D7D636C6173732077657B636F6E7374727563746F722865297B746869732E5F776F';
wwv_flow_imp.g_varchar2_table(710) := '726B657249643D2D312C746869732E5F68616E646C65723D652C746869732E5F6C61737453656E745265713D302C746869732E5F70656E64696E675265706C6965733D4F626A6563742E637265617465286E756C6C292C746869732E5F70656E64696E67';
wwv_flow_imp.g_varchar2_table(711) := '456D6974746572733D6E6577204D61702C746869732E5F70656E64696E674576656E74733D6E6577204D61707D736574576F726B657249642865297B746869732E5F776F726B657249643D657D73656E644D65737361676528652C74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(712) := '6E3D537472696E67282B2B746869732E5F6C61737453656E74526571293B72657475726E206E65772050726F6D697365282828692C72293D3E7B746869732E5F70656E64696E675265706C6965735B6E5D3D7B7265736F6C76653A692C72656A6563743A';
wwv_flow_imp.g_varchar2_table(713) := '727D2C746869732E5F73656E64286E6577205F6528746869732E5F776F726B657249642C6E2C652C7429297D29297D6C697374656E28652C74297B6C6574206E3D6E756C6C3B636F6E737420693D6E65772053287B6F6E57696C6C41646446697273744C';
wwv_flow_imp.g_varchar2_table(714) := '697374656E65723A28293D3E7B6E3D537472696E67282B2B746869732E5F6C61737453656E74526571292C746869732E5F70656E64696E67456D6974746572732E736574286E2C69292C746869732E5F73656E64286E657720436528746869732E5F776F';
wwv_flow_imp.g_varchar2_table(715) := '726B657249642C6E2C652C7429297D2C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E7B746869732E5F70656E64696E67456D6974746572732E64656C657465286E292C746869732E5F73656E64286E6577204C6528746869732E';
wwv_flow_imp.g_varchar2_table(716) := '5F776F726B657249642C6E29292C6E3D6E756C6C7D7D293B72657475726E20692E6576656E747D68616E646C654D6573736167652865297B652626652E7673576F726B65722626282D31213D3D746869732E5F776F726B657249642626652E7673576F72';
wwv_flow_imp.g_varchar2_table(717) := '6B6572213D3D746869732E5F776F726B657249647C7C746869732E5F68616E646C654D657373616765286529297D5F68616E646C654D6573736167652865297B73776974636828652E74797065297B6361736520313A72657475726E20746869732E5F68';
wwv_flow_imp.g_varchar2_table(718) := '616E646C655265706C794D6573736167652865293B6361736520303A72657475726E20746869732E5F68616E646C65526571756573744D6573736167652865293B6361736520323A72657475726E20746869732E5F68616E646C65537562736372696265';
wwv_flow_imp.g_varchar2_table(719) := '4576656E744D6573736167652865293B6361736520333A72657475726E20746869732E5F68616E646C654576656E744D6573736167652865293B6361736520343A72657475726E20746869732E5F68616E646C65556E7375627363726962654576656E74';
wwv_flow_imp.g_varchar2_table(720) := '4D6573736167652865297D7D5F68616E646C655265706C794D6573736167652865297B69662821746869732E5F70656E64696E675265706C6965735B652E7365715D2972657475726E20766F696420636F6E736F6C652E7761726E2822476F7420726570';
wwv_flow_imp.g_varchar2_table(721) := '6C7920746F20756E6B6E6F776E2073657122293B636F6E737420743D746869732E5F70656E64696E675265706C6965735B652E7365715D3B69662864656C65746520746869732E5F70656E64696E675265706C6965735B652E7365715D2C652E65727229';
wwv_flow_imp.g_varchar2_table(722) := '7B6C6574206E3D652E6572723B72657475726E20652E6572722E2469734572726F722626286E3D6E6577204572726F722C6E2E6E616D653D652E6572722E6E616D652C6E2E6D6573736167653D652E6572722E6D6573736167652C6E2E737461636B3D65';
wwv_flow_imp.g_varchar2_table(723) := '2E6572722E737461636B292C766F696420742E72656A656374286E297D742E7265736F6C766528652E726573297D5F68616E646C65526571756573744D6573736167652865297B636F6E737420743D652E7265713B746869732E5F68616E646C65722E68';
wwv_flow_imp.g_varchar2_table(724) := '616E646C654D65737361676528652E6D6574686F642C652E61726773292E7468656E2828653D3E7B746869732E5F73656E64286E657720766528746869732E5F776F726B657249642C742C652C766F6964203029297D292C28653D3E7B652E6465746169';
wwv_flow_imp.g_varchar2_table(725) := '6C20696E7374616E63656F66204572726F72262628652E64657461696C3D6E28652E64657461696C29292C746869732E5F73656E64286E657720766528746869732E5F776F726B657249642C742C766F696420302C6E28652929297D29297D5F68616E64';
wwv_flow_imp.g_varchar2_table(726) := '6C655375627363726962654576656E744D6573736167652865297B636F6E737420743D652E7265712C6E3D746869732E5F68616E646C65722E68616E646C654576656E7428652E6576656E744E616D652C652E617267292828653D3E7B746869732E5F73';
wwv_flow_imp.g_varchar2_table(727) := '656E64286E657720796528746869732E5F776F726B657249642C742C6529297D29293B746869732E5F70656E64696E674576656E74732E73657428742C6E297D5F68616E646C654576656E744D6573736167652865297B746869732E5F70656E64696E67';
wwv_flow_imp.g_varchar2_table(728) := '456D6974746572732E68617328652E726571293F746869732E5F70656E64696E67456D6974746572732E67657428652E726571292E6669726528652E6576656E74293A636F6E736F6C652E7761726E2822476F74206576656E7420666F7220756E6B6E6F';
wwv_flow_imp.g_varchar2_table(729) := '776E2072657122297D5F68616E646C65556E7375627363726962654576656E744D6573736167652865297B746869732E5F70656E64696E674576656E74732E68617328652E726571293F28746869732E5F70656E64696E674576656E74732E6765742865';
wwv_flow_imp.g_varchar2_table(730) := '2E726571292E646973706F736528292C746869732E5F70656E64696E674576656E74732E64656C65746528652E72657129293A636F6E736F6C652E7761726E2822476F7420756E73756273637269626520666F7220756E6B6E6F776E2072657122297D5F';
wwv_flow_imp.g_varchar2_table(731) := '73656E642865297B636F6E737420743D5B5D3B696628303D3D3D652E7479706529666F72286C6574206E3D303B6E3C652E617267732E6C656E6774683B6E2B2B29652E617267735B6E5D696E7374616E63656F662041727261794275666665722626742E';
wwv_flow_imp.g_varchar2_table(732) := '7075736828652E617267735B6E5D293B656C736520313D3D3D652E747970652626652E72657320696E7374616E63656F662041727261794275666665722626742E7075736828652E726573293B746869732E5F68616E646C65722E73656E644D65737361';
wwv_flow_imp.g_varchar2_table(733) := '676528652C74297D7D66756E6374696F6E204E652865297B72657475726E226F223D3D3D655B305D2626226E223D3D3D655B315D26266C6528652E63686172436F64654174283229297D66756E6374696F6E2045652865297B72657475726E2F5E6F6E44';
wwv_flow_imp.g_varchar2_table(734) := '796E616D69632F2E7465737428652926266C6528652E63686172436F64654174283929297D636C6173732053657B636F6E7374727563746F7228652C74297B746869732E5F7265717565737448616E646C6572466163746F72793D742C746869732E5F72';
wwv_flow_imp.g_varchar2_table(735) := '65717565737448616E646C65723D6E756C6C2C746869732E5F70726F746F636F6C3D6E6577207765287B73656E644D6573736167653A28742C6E293D3E7B6528742C6E297D2C68616E646C654D6573736167653A28652C74293D3E746869732E5F68616E';
wwv_flow_imp.g_varchar2_table(736) := '646C654D65737361676528652C74292C68616E646C654576656E743A28652C74293D3E746869732E5F68616E646C654576656E7428652C74297D297D6F6E6D6573736167652865297B746869732E5F70726F746F636F6C2E68616E646C654D6573736167';
wwv_flow_imp.g_varchar2_table(737) := '652865297D5F68616E646C654D65737361676528652C74297B6966282224696E697469616C697A65223D3D3D652972657475726E20746869732E696E697469616C697A6528745B305D2C745B315D2C745B325D2C745B335D293B69662821746869732E5F';
wwv_flow_imp.g_varchar2_table(738) := '7265717565737448616E646C65727C7C2266756E6374696F6E22213D747970656F6620746869732E5F7265717565737448616E646C65725B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E6720';
wwv_flow_imp.g_varchar2_table(739) := '7265717565737448616E646C6572206F72206D6574686F643A20222B6529293B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F7265717565737448616E646C65725B655D2E6170706C7928746869732E5F7265717565';
wwv_flow_imp.g_varchar2_table(740) := '737448616E646C65722C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D5F68616E646C654576656E7428652C74297B69662821746869732E5F7265717565737448616E646C6572297468726F77206E65';
wwv_flow_imp.g_varchar2_table(741) := '77204572726F7228224D697373696E67207265717565737448616E646C657222293B6966284565286529297B636F6E7374206E3D746869732E5F7265717565737448616E646C65725B655D2E63616C6C28746869732E5F7265717565737448616E646C65';
wwv_flow_imp.g_varchar2_table(742) := '722C74293B6966282266756E6374696F6E22213D747970656F66206E297468726F77206E6577204572726F7228604D697373696E672064796E616D6963206576656E7420247B657D206F6E20726571756573742068616E646C65722E60293B7265747572';
wwv_flow_imp.g_varchar2_table(743) := '6E206E7D6966284E65286529297B636F6E737420743D746869732E5F7265717565737448616E646C65725B655D3B6966282266756E6374696F6E22213D747970656F662074297468726F77206E6577204572726F7228604D697373696E67206576656E74';
wwv_flow_imp.g_varchar2_table(744) := '20247B657D206F6E20726571756573742068616E646C65722E60293B72657475726E20747D7468726F77206E6577204572726F7228604D616C666F726D6564206576656E74206E616D6520247B657D60297D696E697469616C697A6528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(745) := '297B746869732E5F70726F746F636F6C2E736574576F726B657249642865293B636F6E737420723D66756E6374696F6E28652C742C6E297B636F6E737420693D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970';
wwv_flow_imp.g_varchar2_table(746) := '652E736C6963652E63616C6C28617267756D656E74732C30293B72657475726E207428652C6E297D2C723D653D3E66756E6374696F6E2874297B72657475726E206E28652C74297D2C733D7B7D3B666F7228636F6E73742074206F662065294565287429';
wwv_flow_imp.g_varchar2_table(747) := '3F735B745D3D722874293A4E652874293F735B745D3D6E28742C766F69642030293A735B745D3D692874293B72657475726E20737D28692C2828652C74293D3E746869732E5F70726F746F636F6C2E73656E644D65737361676528652C7429292C282865';
wwv_flow_imp.g_varchar2_table(748) := '2C74293D3E746869732E5F70726F746F636F6C2E6C697374656E28652C742929293B72657475726E20746869732E5F7265717565737448616E646C6572466163746F72793F28746869732E5F7265717565737448616E646C65723D746869732E5F726571';
wwv_flow_imp.g_varchar2_table(749) := '7565737448616E646C6572466163746F72792872292C50726F6D6973652E7265736F6C7665284128746869732E5F7265717565737448616E646C65722929293A2874262628766F69642030213D3D742E6261736555726C262664656C65746520742E6261';
wwv_flow_imp.g_varchar2_table(750) := '736555726C2C766F69642030213D3D742E70617468732626766F69642030213D3D742E70617468732E7673262664656C65746520742E70617468732E76732C766F69642030213D3D742E747275737465645479706573506F6C696379262664656C657465';
wwv_flow_imp.g_varchar2_table(751) := '20742E747275737465645479706573506F6C6963792C742E63617463684572726F723D21302C676C6F62616C546869732E726571756972652E636F6E666967287429292C6E65772050726F6D697365282828652C74293D3E7B28302C676C6F62616C5468';
wwv_flow_imp.g_varchar2_table(752) := '69732E7265717569726529285B6E5D2C286E3D3E7B746869732E5F7265717565737448616E646C65723D6E2E6372656174652872292C746869732E5F7265717565737448616E646C65723F65284128746869732E5F7265717565737448616E646C657229';
wwv_flow_imp.g_varchar2_table(753) := '293A74286E6577204572726F7228224E6F205265717565737448616E646C6572212229297D292C74297D2929297D7D636C6173732052657B636F6E7374727563746F7228652C742C6E2C69297B746869732E6F726967696E616C53746172743D652C7468';
wwv_flow_imp.g_varchar2_table(754) := '69732E6F726967696E616C4C656E6774683D742C746869732E6D6F64696669656453746172743D6E2C746869732E6D6F6469666965644C656E6774683D697D6765744F726967696E616C456E6428297B72657475726E20746869732E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(755) := '53746172742B746869732E6F726967696E616C4C656E6774687D6765744D6F646966696564456E6428297B72657475726E20746869732E6D6F64696669656453746172742B746869732E6D6F6469666965644C656E6774687D7D66756E6374696F6E2041';
wwv_flow_imp.g_varchar2_table(756) := '6528652C74297B72657475726E28743C3C35292D742B657C307D66756E6374696F6E20786528652C74297B743D4165283134393431372C74293B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29743D416528652E63686172';
wwv_flow_imp.g_varchar2_table(757) := '436F64654174286E292C74293B72657475726E20747D66756E6374696F6E204D6528652C742C6E3D3332297B636F6E737420693D6E2D743B72657475726E28653C3C747C287E2828313C3C69292D31292665293E3E3E69293E3E3E307D66756E6374696F';
wwv_flow_imp.g_varchar2_table(758) := '6E206B6528652C743D302C6E3D652E627974654C656E6774682C693D30297B666F72286C657420723D303B723C6E3B722B2B29655B742B725D3D697D66756E6374696F6E204F6528652C743D3332297B72657475726E206520696E7374616E63656F6620';
wwv_flow_imp.g_varchar2_table(759) := '41727261794275666665723F41727261792E66726F6D286E65772055696E74384172726179286529292E6D61702828653D3E652E746F537472696E67283136292E706164537461727428322C2230222929292E6A6F696E282222293A66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(760) := '28652C742C6E3D223022297B666F72283B652E6C656E6774683C743B29653D6E2B653B72657475726E20657D2828653E3E3E30292E746F537472696E67283136292C742F34297D636C6173732054657B636F6E7374727563746F7228297B746869732E5F';
wwv_flow_imp.g_varchar2_table(761) := '68303D313733323538343139332C746869732E5F68313D343032333233333431372C746869732E5F68323D323536323338333130322C746869732E5F68333D3237313733333837382C746869732E5F68343D333238353337373532302C746869732E5F62';
wwv_flow_imp.g_varchar2_table(762) := '7566663D6E65772055696E74384172726179283637292C746869732E5F6275666644563D6E657720446174615669657728746869732E5F627566662E627566666572292C746869732E5F627566664C656E3D302C746869732E5F746F74616C4C656E3D30';
wwv_flow_imp.g_varchar2_table(763) := '2C746869732E5F6C6566746F76657248696768537572726F676174653D302C746869732E5F66696E69736865643D21317D7570646174652865297B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E3B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(764) := '746869732E5F627566663B6C657420692C722C733D746869732E5F627566664C656E2C6F3D746869732E5F6C6566746F76657248696768537572726F676174653B666F722830213D3D6F3F28693D6F2C723D2D312C6F3D30293A28693D652E6368617243';
wwv_flow_imp.g_varchar2_table(765) := '6F646541742830292C723D30293B3B297B6C657420613D693B6966287565286929297B6966282128722B313C7429297B6F3D693B627265616B7D7B636F6E737420743D652E63686172436F6465417428722B31293B68652874293F28722B2B2C613D6365';
wwv_flow_imp.g_varchar2_table(766) := '28692C7429293A613D36353533337D7D656C7365206865286929262628613D3635353333293B696628733D746869732E5F70757368286E2C732C61292C722B2B2C2128723C742929627265616B3B693D652E63686172436F646541742872297D74686973';
wwv_flow_imp.g_varchar2_table(767) := '2E5F627566664C656E3D732C746869732E5F6C6566746F76657248696768537572726F676174653D6F7D5F7075736828652C742C6E297B72657475726E206E3C3132383F655B742B2B5D3D6E3A6E3C323034383F28655B742B2B5D3D3139327C28313938';
wwv_flow_imp.g_varchar2_table(768) := '34266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30293A6E3C36353533363F28655B742B2B5D3D3232347C283631343430266E293E3E3E31322C655B742B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132';
wwv_flow_imp.g_varchar2_table(769) := '387C283633266E293E3E3E30293A28655B742B2B5D3D3234307C2831383335303038266E293E3E3E31382C655B742B2B5D3D3132387C28323538303438266E293E3E3E31322C655B742B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D';
wwv_flow_imp.g_varchar2_table(770) := '3D3132387C283633266E293E3E3E30292C743E3D3634262628746869732E5F7374657028292C742D3D36342C746869732E5F746F74616C4C656E2B3D36342C655B305D3D655B36345D2C655B315D3D655B36355D2C655B325D3D655B36365D292C747D64';
wwv_flow_imp.g_varchar2_table(771) := '696765737428297B72657475726E20746869732E5F66696E69736865647C7C28746869732E5F66696E69736865643D21302C746869732E5F6C6566746F76657248696768537572726F67617465262628746869732E5F6C6566746F766572486967685375';
wwv_flow_imp.g_varchar2_table(772) := '72726F676174653D302C746869732E5F627566664C656E3D746869732E5F7075736828746869732E5F627566662C746869732E5F627566664C656E2C363535333329292C746869732E5F746F74616C4C656E2B3D746869732E5F627566664C656E2C7468';
wwv_flow_imp.g_varchar2_table(773) := '69732E5F7772617055702829292C4F6528746869732E5F6830292B4F6528746869732E5F6831292B4F6528746869732E5F6832292B4F6528746869732E5F6833292B4F6528746869732E5F6834297D5F77726170557028297B746869732E5F627566665B';
wwv_flow_imp.g_varchar2_table(774) := '746869732E5F627566664C656E2B2B5D3D3132382C6B6528746869732E5F627566662C746869732E5F627566664C656E292C746869732E5F627566664C656E3E3536262628746869732E5F7374657028292C6B6528746869732E5F6275666629293B636F';
wwv_flow_imp.g_varchar2_table(775) := '6E737420653D382A746869732E5F746F74616C4C656E3B746869732E5F6275666644562E73657455696E7433322835362C4D6174682E666C6F6F7228652F34323934393637323936292C2131292C746869732E5F6275666644562E73657455696E743332';
wwv_flow_imp.g_varchar2_table(776) := '2836302C6525343239343936373239362C2131292C746869732E5F7374657028297D5F7374657028297B636F6E737420653D54652E5F626967426C6F636B33322C743D746869732E5F6275666644563B666F72286C6574206E3D303B6E3C36343B6E2B3D';
wwv_flow_imp.g_varchar2_table(777) := '3429652E73657455696E743332286E2C742E67657455696E743332286E2C2131292C2131293B666F72286C657420743D36343B743C3332303B742B3D3429652E73657455696E74333228742C4D6528652E67657455696E74333228742D31322C2131295E';
wwv_flow_imp.g_varchar2_table(778) := '652E67657455696E74333228742D33322C2131295E652E67657455696E74333228742D35362C2131295E652E67657455696E74333228742D36342C2131292C31292C2131293B6C6574206E2C692C722C733D746869732E5F68302C6F3D746869732E5F68';
wwv_flow_imp.g_varchar2_table(779) := '312C613D746869732E5F68322C6C3D746869732E5F68332C753D746869732E5F68343B666F72286C657420743D303B743C38303B742B2B29743C32303F286E3D6F26617C7E6F266C2C693D31353138353030323439293A743C34303F286E3D6F5E615E6C';
wwv_flow_imp.g_varchar2_table(780) := '2C693D31383539373735333933293A743C36303F286E3D6F26617C6F266C7C61266C2C693D32343030393539373038293A286E3D6F5E615E6C2C693D33333935343639373832292C723D4D6528732C35292B6E2B752B692B652E67657455696E74333228';
wwv_flow_imp.g_varchar2_table(781) := '342A742C21312926343239343936373239352C753D6C2C6C3D612C613D4D65286F2C3330292C6F3D732C733D723B746869732E5F68303D746869732E5F68302B7326343239343936373239352C746869732E5F68313D746869732E5F68312B6F26343239';
wwv_flow_imp.g_varchar2_table(782) := '343936373239352C746869732E5F68323D746869732E5F68322B6126343239343936373239352C746869732E5F68333D746869732E5F68332B6C26343239343936373239352C746869732E5F68343D746869732E5F68342B752634323934393637323935';
wwv_flow_imp.g_varchar2_table(783) := '7D7D54652E5F626967426C6F636B33323D6E6577204461746156696577286E65772041727261794275666665722833323029293B636C6173732049657B636F6E7374727563746F722865297B746869732E736F757263653D657D676574456C656D656E74';
wwv_flow_imp.g_varchar2_table(784) := '7328297B636F6E737420653D746869732E736F757263652C743D6E657720496E743332417272617928652E6C656E677468293B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(785) := '6E293B72657475726E20747D7D66756E6374696F6E20506528652C742C6E297B72657475726E206E6577207165286E65772049652865292C6E6577204965287429292E436F6D7075746544696666286E292E6368616E6765737D636C6173732044657B73';
wwv_flow_imp.g_varchar2_table(786) := '74617469632041737365727428652C74297B6966282165297468726F77206E6577204572726F722874297D7D636C6173732046657B73746174696320436F707928652C742C6E2C692C72297B666F72286C657420733D303B733C723B732B2B296E5B692B';
wwv_flow_imp.g_varchar2_table(787) := '735D3D655B742B735D7D73746174696320436F70793228652C742C6E2C692C72297B666F72286C657420733D303B733C723B732B2B296E5B692B735D3D655B742B735D7D7D636C617373204B657B636F6E7374727563746F7228297B746869732E6D5F63';
wwv_flow_imp.g_varchar2_table(788) := '68616E6765733D5B5D2C746869732E6D5F6F726967696E616C53746172743D313037333734313832342C746869732E6D5F6D6F64696669656453746172743D313037333734313832342C746869732E6D5F6F726967696E616C436F756E743D302C746869';
wwv_flow_imp.g_varchar2_table(789) := '732E6D5F6D6F646966696564436F756E743D307D4D61726B4E6578744368616E676528297B28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E6D5F6368616E6765';
wwv_flow_imp.g_varchar2_table(790) := '732E70757368286E657720526528746869732E6D5F6F726967696E616C53746172742C746869732E6D5F6F726967696E616C436F756E742C746869732E6D5F6D6F64696669656453746172742C746869732E6D5F6D6F646966696564436F756E7429292C';
wwv_flow_imp.g_varchar2_table(791) := '746869732E6D5F6F726967696E616C436F756E743D302C746869732E6D5F6D6F646966696564436F756E743D302C746869732E6D5F6F726967696E616C53746172743D313037333734313832342C746869732E6D5F6D6F64696669656453746172743D31';
wwv_flow_imp.g_varchar2_table(792) := '3037333734313832347D4164644F726967696E616C456C656D656E7428652C74297B746869732E6D5F6F726967696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F726967696E616C53746172742C65292C746869732E6D5F6D6F646966';
wwv_flow_imp.g_varchar2_table(793) := '69656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669656453746172742C74292C746869732E6D5F6F726967696E616C436F756E742B2B7D4164644D6F646966696564456C656D656E7428652C74297B746869732E6D5F6F726967';
wwv_flow_imp.g_varchar2_table(794) := '696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F726967696E616C53746172742C65292C746869732E6D5F6D6F64696669656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669656453746172742C74292C746869';
wwv_flow_imp.g_varchar2_table(795) := '732E6D5F6D6F646966696564436F756E742B2B7D6765744368616E67657328297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E4D61726B4E65';
wwv_flow_imp.g_varchar2_table(796) := '78744368616E676528292C746869732E6D5F6368616E6765737D676574526576657273654368616E67657328297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E3029';
wwv_flow_imp.g_varchar2_table(797) := '2626746869732E4D61726B4E6578744368616E676528292C746869732E6D5F6368616E6765732E7265766572736528292C746869732E6D5F6368616E6765737D7D636C6173732071657B636F6E7374727563746F7228652C742C6E3D6E756C6C297B7468';
wwv_flow_imp.g_varchar2_table(798) := '69732E436F6E74696E756550726F63657373696E675072656469636174653D6E2C746869732E5F6F726967696E616C53657175656E63653D652C746869732E5F6D6F64696669656453657175656E63653D743B636F6E73745B692C722C735D3D71652E5F';
wwv_flow_imp.g_varchar2_table(799) := '676574456C656D656E74732865292C5B6F2C612C6C5D3D71652E5F676574456C656D656E74732874293B746869732E5F686173537472696E67733D7326266C2C746869732E5F6F726967696E616C537472696E67456C656D656E74733D692C746869732E';
wwv_flow_imp.g_varchar2_table(800) := '5F6F726967696E616C456C656D656E74734F72486173683D722C746869732E5F6D6F646966696564537472696E67456C656D656E74733D6F2C746869732E5F6D6F646966696564456C656D656E74734F72486173683D612C746869732E6D5F666F727761';
wwv_flow_imp.g_varchar2_table(801) := '7264486973746F72793D5B5D2C746869732E6D5F72657665727365486973746F72793D5B5D7D737461746963205F6973537472696E6741727261792865297B72657475726E20652E6C656E6774683E30262622737472696E67223D3D747970656F662065';
wwv_flow_imp.g_varchar2_table(802) := '5B305D7D737461746963205F676574456C656D656E74732865297B636F6E737420743D652E676574456C656D656E747328293B69662871652E5F6973537472696E674172726179287429297B636F6E737420653D6E657720496E74333241727261792874';
wwv_flow_imp.g_varchar2_table(803) := '2E6C656E677468293B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29655B6E5D3D786528745B6E5D2C30293B72657475726E5B742C652C21305D7D72657475726E207420696E7374616E63656F6620496E74333241727261';
wwv_flow_imp.g_varchar2_table(804) := '793F5B5B5D2C742C21315D3A5B5B5D2C6E657720496E74333241727261792874292C21315D7D456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6F726967696E616C456C656D656E74734F72486173685B655D3D3D';
wwv_flow_imp.g_varchar2_table(805) := '3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D3D3D3D746869732E5F6D6F64696669';
wwv_flow_imp.g_varchar2_table(806) := '6564537472696E67456C656D656E74735B745D297D456C656D656E7473417265537472696374457175616C28652C74297B72657475726E2121746869732E456C656D656E7473417265457175616C28652C7429262671652E5F676574537472696374456C';
wwv_flow_imp.g_varchar2_table(807) := '656D656E7428746869732E5F6F726967696E616C53657175656E63652C65293D3D3D71652E5F676574537472696374456C656D656E7428746869732E5F6D6F64696669656453657175656E63652C74297D737461746963205F676574537472696374456C';
wwv_flow_imp.g_varchar2_table(808) := '656D656E7428652C74297B72657475726E2266756E6374696F6E223D3D747970656F6620652E676574537472696374456C656D656E743F652E676574537472696374456C656D656E742874293A6E756C6C7D4F726967696E616C456C656D656E74734172';
wwv_flow_imp.g_varchar2_table(809) := '65457175616C28652C74297B72657475726E20746869732E5F6F726967696E616C456C656D656E74734F72486173685B655D3D3D3D746869732E5F6F726967696E616C456C656D656E74734F72486173685B745D26262821746869732E5F686173537472';
wwv_flow_imp.g_varchar2_table(810) := '696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D3D3D3D746869732E5F6F726967696E616C537472696E67456C656D656E74735B745D297D4D6F646966696564456C656D656E7473417265457175616C28652C';
wwv_flow_imp.g_varchar2_table(811) := '74297B72657475726E20746869732E5F6D6F646966696564456C656D656E74734F72486173685B655D3D3D3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869';
wwv_flow_imp.g_varchar2_table(812) := '732E5F6D6F646966696564537472696E67456C656D656E74735B655D3D3D3D746869732E5F6D6F646966696564537472696E67456C656D656E74735B745D297D436F6D70757465446966662865297B72657475726E20746869732E5F436F6D7075746544';
wwv_flow_imp.g_varchar2_table(813) := '69666628302C746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E6774682D312C302C746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682D312C65297D5F436F6D707574654469666628';
wwv_flow_imp.g_varchar2_table(814) := '652C742C6E2C692C72297B636F6E737420733D5B21315D3B6C6574206F3D746869732E436F6D707574654469666652656375727369766528652C742C6E2C692C73293B72657475726E20722626286F3D746869732E50726574746966794368616E676573';
wwv_flow_imp.g_varchar2_table(815) := '286F29292C7B717569744561726C793A735B305D2C6368616E6765733A6F7D7D436F6D707574654469666652656375727369766528652C742C6E2C692C72297B666F7228725B305D3D21313B653C3D7426266E3C3D692626746869732E456C656D656E74';
wwv_flow_imp.g_varchar2_table(816) := '73417265457175616C28652C6E293B29652B2B2C6E2B2B3B666F72283B743E3D652626693E3D6E2626746869732E456C656D656E7473417265457175616C28742C69293B29742D2D2C692D2D3B696628653E747C7C6E3E69297B6C657420723B72657475';
wwv_flow_imp.g_varchar2_table(817) := '726E206E3C3D693F2844652E41737365727428653D3D3D742B312C226F726967696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C723D5B6E657720526528652C302C6E';
wwv_flow_imp.g_varchar2_table(818) := '2C692D6E2B31295D293A653C3D743F2844652E417373657274286E3D3D3D692B312C226D6F64696669656453746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C723D5B6E65772052';
wwv_flow_imp.g_varchar2_table(819) := '6528652C742D652B312C6E2C30295D293A2844652E41737365727428653D3D3D742B312C226F726967696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C44652E417373';
wwv_flow_imp.g_varchar2_table(820) := '657274286E3D3D3D692B312C226D6F64696669656453746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C723D5B5D292C727D636F6E737420733D5B305D2C6F3D5B305D2C613D7468';
wwv_flow_imp.g_varchar2_table(821) := '69732E436F6D70757465526563757273696F6E506F696E7428652C742C6E2C692C732C6F2C72292C6C3D735B305D2C753D6F5B305D3B6966286E756C6C213D3D612972657475726E20613B69662821725B305D297B636F6E737420733D746869732E436F';
wwv_flow_imp.g_varchar2_table(822) := '6D707574654469666652656375727369766528652C6C2C6E2C752C72293B6C6574206F3D5B5D3B72657475726E206F3D725B305D3F5B6E6577205265286C2B312C742D286C2B31292B312C752B312C692D28752B31292B31295D3A746869732E436F6D70';
wwv_flow_imp.g_varchar2_table(823) := '75746544696666526563757273697665286C2B312C742C752B312C692C72292C746869732E436F6E636174656E6174654368616E67657328732C6F297D72657475726E5B6E657720526528652C742D652B312C6E2C692D6E2B31295D7D57414C4B545241';
wwv_flow_imp.g_varchar2_table(824) := '434528652C742C6E2C692C722C732C6F2C612C6C2C752C682C632C642C6D2C672C662C702C62297B6C6574205F3D6E756C6C2C763D6E756C6C2C433D6E6577204B652C793D742C4C3D6E2C773D645B305D2D665B305D2D692C4E3D2D3130373337343138';
wwv_flow_imp.g_varchar2_table(825) := '32342C453D746869732E6D5F666F7277617264486973746F72792E6C656E6774682D313B646F7B636F6E737420743D772B653B743D3D3D797C7C743C4C26266C5B742D315D3C6C5B742B315D3F286D3D28683D6C5B742B315D292D772D692C683C4E2626';
wwv_flow_imp.g_varchar2_table(826) := '432E4D61726B4E6578744368616E676528292C4E3D682C432E4164644D6F646966696564456C656D656E7428682B312C6D292C773D742B312D65293A286D3D28683D6C5B742D315D2B31292D772D692C683C4E2626432E4D61726B4E6578744368616E67';
wwv_flow_imp.g_varchar2_table(827) := '6528292C4E3D682D312C432E4164644F726967696E616C456C656D656E7428682C6D2B31292C773D742D312D65292C453E3D30262628653D286C3D746869732E6D5F666F7277617264486973746F72795B455D295B305D2C793D312C4C3D6C2E6C656E67';
wwv_flow_imp.g_varchar2_table(828) := '74682D31297D7768696C65282D2D453E3D2D31293B6966285F3D432E676574526576657273654368616E67657328292C625B305D297B6C657420653D645B305D2B312C743D665B305D2B313B6966286E756C6C213D3D5F26265F2E6C656E6774683E3029';
wwv_flow_imp.g_varchar2_table(829) := '7B636F6E7374206E3D5F5B5F2E6C656E6774682D315D3B653D4D6174682E6D617828652C6E2E6765744F726967696E616C456E642829292C743D4D6174682E6D617828742C6E2E6765744D6F646966696564456E642829297D763D5B6E65772052652865';
wwv_flow_imp.g_varchar2_table(830) := '2C632D652B312C742C672D742B31295D7D656C73657B433D6E6577204B652C793D732C4C3D6F2C773D645B305D2D665B305D2D612C4E3D313037333734313832342C453D703F746869732E6D5F72657665727365486973746F72792E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(831) := '3A746869732E6D5F72657665727365486973746F72792E6C656E6774682D323B646F7B636F6E737420653D772B723B653D3D3D797C7C653C4C2626755B652D315D3E3D755B652B315D3F286D3D28683D755B652B315D2D31292D772D612C683E4E262643';
wwv_flow_imp.g_varchar2_table(832) := '2E4D61726B4E6578744368616E676528292C4E3D682B312C432E4164644F726967696E616C456C656D656E7428682B312C6D2B31292C773D652B312D72293A286D3D28683D755B652D315D292D772D612C683E4E2626432E4D61726B4E6578744368616E';
wwv_flow_imp.g_varchar2_table(833) := '676528292C4E3D682C432E4164644D6F646966696564456C656D656E7428682B312C6D2B31292C773D652D312D72292C453E3D30262628723D28753D746869732E6D5F72657665727365486973746F72795B455D295B305D2C793D312C4C3D752E6C656E';
wwv_flow_imp.g_varchar2_table(834) := '6774682D31297D7768696C65282D2D453E3D2D31293B763D432E6765744368616E67657328297D72657475726E20746869732E436F6E636174656E6174654368616E676573285F2C76297D436F6D70757465526563757273696F6E506F696E7428652C74';
wwv_flow_imp.g_varchar2_table(835) := '2C6E2C692C722C732C6F297B6C657420613D302C6C3D302C753D302C683D302C633D302C643D303B652D2D2C6E2D2D2C725B305D3D302C735B305D3D302C746869732E6D5F666F7277617264486973746F72793D5B5D2C746869732E6D5F726576657273';
wwv_flow_imp.g_varchar2_table(836) := '65486973746F72793D5B5D3B636F6E7374206D3D742D652B28692D6E292C673D6D2B312C663D6E657720496E74333241727261792867292C703D6E657720496E74333241727261792867292C623D692D6E2C5F3D742D652C763D652D6E2C433D742D692C';
wwv_flow_imp.g_varchar2_table(837) := '793D285F2D622925323D3D303B665B625D3D652C705B5F5D3D742C6F5B305D3D21313B666F72286C6574204C3D313B4C3C3D6D2F322B313B4C2B2B297B6C6574206D3D302C773D303B753D746869732E436C6970446961676F6E616C426F756E6428622D';
wwv_flow_imp.g_varchar2_table(838) := '4C2C4C2C622C67292C683D746869732E436C6970446961676F6E616C426F756E6428622B4C2C4C2C622C67293B666F72286C657420653D753B653C3D683B652B3D32297B613D653D3D3D757C7C653C682626665B652D315D3C665B652B315D3F665B652B';
wwv_flow_imp.g_varchar2_table(839) := '315D3A665B652D315D2B312C6C3D612D28652D62292D763B636F6E7374206E3D613B666F72283B613C7426266C3C692626746869732E456C656D656E7473417265457175616C28612B312C6C2B31293B29612B2B2C6C2B2B3B696628665B655D3D612C61';
wwv_flow_imp.g_varchar2_table(840) := '2B6C3E6D2B772626286D3D612C773D6C292C217926264D6174682E61627328652D5F293C3D4C2D312626613E3D705B655D2972657475726E20725B305D3D612C735B305D3D6C2C6E3C3D705B655D26264C3C3D313434383F746869732E57414C4B545241';
wwv_flow_imp.g_varchar2_table(841) := '434528622C752C682C762C5F2C632C642C432C662C702C612C742C722C6C2C692C732C792C6F293A6E756C6C7D636F6E7374204E3D286D2D652B28772D6E292D4C292F323B6966286E756C6C213D3D746869732E436F6E74696E756550726F6365737369';
wwv_flow_imp.g_varchar2_table(842) := '6E67507265646963617465262621746869732E436F6E74696E756550726F63657373696E67507265646963617465286D2C4E292972657475726E206F5B305D3D21302C725B305D3D6D2C735B305D3D772C4E3E3026264C3C3D313434383F746869732E57';
wwv_flow_imp.g_varchar2_table(843) := '414C4B545241434528622C752C682C762C5F2C632C642C432C662C702C612C742C722C6C2C692C732C792C6F293A28652B2B2C6E2B2B2C5B6E657720526528652C742D652B312C6E2C692D6E2B31295D293B633D746869732E436C6970446961676F6E61';
wwv_flow_imp.g_varchar2_table(844) := '6C426F756E64285F2D4C2C4C2C5F2C67292C643D746869732E436C6970446961676F6E616C426F756E64285F2B4C2C4C2C5F2C67293B666F72286C6574206D3D633B6D3C3D643B6D2B3D32297B613D6D3D3D3D637C7C6D3C642626705B6D2D315D3E3D70';
wwv_flow_imp.g_varchar2_table(845) := '5B6D2B315D3F705B6D2B315D2D313A705B6D2D315D2C6C3D612D286D2D5F292D433B636F6E737420673D613B666F72283B613E6526266C3E6E2626746869732E456C656D656E7473417265457175616C28612C6C293B29612D2D2C6C2D2D3B696628705B';
wwv_flow_imp.g_varchar2_table(846) := '6D5D3D612C7926264D6174682E616273286D2D62293C3D4C2626613C3D665B6D5D2972657475726E20725B305D3D612C735B305D3D6C2C673E3D665B6D5D26264C3C3D313434383F746869732E57414C4B545241434528622C752C682C762C5F2C632C64';
wwv_flow_imp.g_varchar2_table(847) := '2C432C662C702C612C742C722C6C2C692C732C792C6F293A6E756C6C7D6966284C3C3D31343437297B6C657420653D6E657720496E743332417272617928682D752B32293B655B305D3D622D752B312C46652E436F70793228662C752C652C312C682D75';
wwv_flow_imp.g_varchar2_table(848) := '2B31292C746869732E6D5F666F7277617264486973746F72792E707573682865292C653D6E657720496E743332417272617928642D632B32292C655B305D3D5F2D632B312C46652E436F70793228702C632C652C312C642D632B31292C746869732E6D5F';
wwv_flow_imp.g_varchar2_table(849) := '72657665727365486973746F72792E707573682865297D7D72657475726E20746869732E57414C4B545241434528622C752C682C762C5F2C632C642C432C662C702C612C742C722C6C2C692C732C792C6F297D50726574746966794368616E6765732865';
wwv_flow_imp.g_varchar2_table(850) := '297B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B636F6E7374206E3D655B745D2C693D743C652E6C656E6774682D313F655B742B315D2E6F726967696E616C53746172743A746869732E5F6F726967696E616C456C656D656E74';
wwv_flow_imp.g_varchar2_table(851) := '734F72486173682E6C656E6774682C723D743C652E6C656E6774682D313F655B742B315D2E6D6F64696669656453746172743A746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682C733D6E2E6F726967696E616C4C';
wwv_flow_imp.g_varchar2_table(852) := '656E6774683E302C6F3D6E2E6D6F6469666965644C656E6774683E303B666F72283B6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774683C6926266E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E67';
wwv_flow_imp.g_varchar2_table(853) := '74683C7226262821737C7C746869732E4F726967696E616C456C656D656E7473417265457175616C286E2E6F726967696E616C53746172742C6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682929262628216F7C7C7468';
wwv_flow_imp.g_varchar2_table(854) := '69732E4D6F646966696564456C656D656E7473417265457175616C286E2E6D6F64696669656453746172742C6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E67746829293B297B636F6E737420653D746869732E456C656D656E';
wwv_flow_imp.g_varchar2_table(855) := '7473417265537472696374457175616C286E2E6F726967696E616C53746172742C6E2E6D6F6469666965645374617274293B696628746869732E456C656D656E7473417265537472696374457175616C286E2E6F726967696E616C53746172742B6E2E6F';
wwv_flow_imp.g_varchar2_table(856) := '726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E677468292626216529627265616B3B6E2E6F726967696E616C53746172742B2B2C6E2E6D6F64696669656453746172742B2B7D636F6E737420';
wwv_flow_imp.g_varchar2_table(857) := '613D5B6E756C6C5D3B743C652E6C656E6774682D312626746869732E4368616E6765734F7665726C617028655B745D2C655B742B315D2C6129262628655B745D3D615B305D2C652E73706C69636528742B312C31292C742D2D297D666F72286C65742074';
wwv_flow_imp.g_varchar2_table(858) := '3D652E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D655B745D3B6C657420693D302C723D303B696628743E30297B636F6E7374206E3D655B742D315D3B693D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C65';
wwv_flow_imp.g_varchar2_table(859) := '6E6774682C723D6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E6774687D636F6E737420733D6E2E6F726967696E616C4C656E6774683E302C6F3D6E2E6D6F6469666965644C656E6774683E303B6C657420613D302C6C3D7468';
wwv_flow_imp.g_varchar2_table(860) := '69732E5F626F756E6461727953636F7265286E2E6F726967696E616C53746172742C6E2E6F726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742C6E2E6D6F6469666965644C656E677468293B666F72286C657420653D313B3B652B';
wwv_flow_imp.g_varchar2_table(861) := '2B297B636F6E737420743D6E2E6F726967696E616C53746172742D652C753D6E2E6D6F64696669656453746172742D653B696628743C697C7C753C7229627265616B3B69662873262621746869732E4F726967696E616C456C656D656E74734172654571';
wwv_flow_imp.g_varchar2_table(862) := '75616C28742C742B6E2E6F726967696E616C4C656E6774682929627265616B3B6966286F262621746869732E4D6F646966696564456C656D656E7473417265457175616C28752C752B6E2E6D6F6469666965644C656E6774682929627265616B3B636F6E';
wwv_flow_imp.g_varchar2_table(863) := '737420683D28743D3D3D692626753D3D3D723F353A30292B746869732E5F626F756E6461727953636F726528742C6E2E6F726967696E616C4C656E6774682C752C6E2E6D6F6469666965644C656E677468293B683E6C2626286C3D682C613D65297D6E2E';
wwv_flow_imp.g_varchar2_table(864) := '6F726967696E616C53746172742D3D612C6E2E6D6F64696669656453746172742D3D613B636F6E737420753D5B6E756C6C5D3B743E302626746869732E4368616E6765734F7665726C617028655B742D315D2C655B745D2C7529262628655B742D315D3D';
wwv_flow_imp.g_varchar2_table(865) := '755B305D2C652E73706C69636528742C31292C742B2B297D696628746869732E5F686173537472696E677329666F72286C657420743D312C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B742D315D2C693D655B745D2C723D';
wwv_flow_imp.g_varchar2_table(866) := '692E6F726967696E616C53746172742D6E2E6F726967696E616C53746172742D6E2E6F726967696E616C4C656E6774682C733D6E2E6F726967696E616C53746172742C6F3D692E6F726967696E616C53746172742B692E6F726967696E616C4C656E6774';
wwv_flow_imp.g_varchar2_table(867) := '682C613D6F2D732C6C3D6E2E6D6F64696669656453746172742C753D692E6D6F64696669656453746172742B692E6D6F6469666965644C656E6774682C683D752D6C3B696628723C352626613C32302626683C3230297B636F6E737420653D746869732E';
wwv_flow_imp.g_varchar2_table(868) := '5F66696E64426574746572436F6E746967756F757353657175656E636528732C612C6C2C682C72293B69662865297B636F6E73745B742C735D3D653B743D3D3D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682626733D';
wwv_flow_imp.g_varchar2_table(869) := '3D3D6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E6774687C7C286E2E6F726967696E616C4C656E6774683D742D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D732D6E2E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(870) := '6453746172742C692E6F726967696E616C53746172743D742B722C692E6D6F64696669656453746172743D732B722C692E6F726967696E616C4C656E6774683D6F2D692E6F726967696E616C53746172742C692E6D6F6469666965644C656E6774683D75';
wwv_flow_imp.g_varchar2_table(871) := '2D692E6D6F6469666965645374617274297D7D7D72657475726E20657D5F66696E64426574746572436F6E746967756F757353657175656E636528652C742C6E2C692C72297B696628743C727C7C693C722972657475726E206E756C6C3B636F6E737420';
wwv_flow_imp.g_varchar2_table(872) := '733D652B742D722B312C6F3D6E2B692D722B313B6C657420613D302C6C3D302C753D303B666F72286C657420743D653B743C733B742B2B29666F72286C657420653D6E3B653C6F3B652B2B297B636F6E7374206E3D746869732E5F636F6E746967756F75';
wwv_flow_imp.g_varchar2_table(873) := '7353657175656E636553636F726528742C652C72293B6E3E3026266E3E61262628613D6E2C6C3D742C753D65297D72657475726E20613E303F5B6C2C755D3A6E756C6C7D5F636F6E746967756F757353657175656E636553636F726528652C742C6E297B';
wwv_flow_imp.g_varchar2_table(874) := '6C657420693D303B666F72286C657420723D303B723C6E3B722B2B297B69662821746869732E456C656D656E7473417265457175616C28652B722C742B72292972657475726E20303B692B3D746869732E5F6F726967696E616C537472696E67456C656D';
wwv_flow_imp.g_varchar2_table(875) := '656E74735B652B725D2E6C656E6774687D72657475726E20697D5F4F726967696E616C4973426F756E646172792865297B72657475726E20653C3D307C7C653E3D746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E677468';
wwv_flow_imp.g_varchar2_table(876) := '2D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E7465737428746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D297D5F4F726967696E616C526567696F6E4973426F756E6461727928652C74297B69';
wwv_flow_imp.g_varchar2_table(877) := '6628746869732E5F4F726967696E616C4973426F756E646172792865297C7C746869732E5F4F726967696E616C4973426F756E6461727928652D31292972657475726E21303B696628743E30297B636F6E7374206E3D652B743B696628746869732E5F4F';
wwv_flow_imp.g_varchar2_table(878) := '726967696E616C4973426F756E64617279286E2D31297C7C746869732E5F4F726967696E616C4973426F756E64617279286E292972657475726E21307D72657475726E21317D5F4D6F6469666965644973426F756E646172792865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(879) := '653C3D307C7C653E3D746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E7465737428746869732E5F6D6F646966696564537472696E6745';
wwv_flow_imp.g_varchar2_table(880) := '6C656D656E74735B655D297D5F4D6F646966696564526567696F6E4973426F756E6461727928652C74297B696628746869732E5F4D6F6469666965644973426F756E646172792865297C7C746869732E5F4D6F6469666965644973426F756E6461727928';
wwv_flow_imp.g_varchar2_table(881) := '652D31292972657475726E21303B696628743E30297B636F6E7374206E3D652B743B696628746869732E5F4D6F6469666965644973426F756E64617279286E2D31297C7C746869732E5F4D6F6469666965644973426F756E64617279286E292972657475';
wwv_flow_imp.g_varchar2_table(882) := '726E21307D72657475726E21317D5F626F756E6461727953636F726528652C742C6E2C69297B72657475726E28746869732E5F4F726967696E616C526567696F6E4973426F756E6461727928652C74293F313A30292B28746869732E5F4D6F6469666965';
wwv_flow_imp.g_varchar2_table(883) := '64526567696F6E4973426F756E64617279286E2C69293F313A30297D436F6E636174656E6174654368616E67657328652C74297B636F6E7374206E3D5B5D3B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E20';
wwv_flow_imp.g_varchar2_table(884) := '742E6C656E6774683E303F743A653B696628746869732E4368616E6765734F7665726C617028655B652E6C656E6774682D315D2C745B305D2C6E29297B636F6E737420693D6E657720417272617928652E6C656E6774682B742E6C656E6774682D31293B';
wwv_flow_imp.g_varchar2_table(885) := '72657475726E2046652E436F707928652C302C692C302C652E6C656E6774682D31292C695B652E6C656E6774682D315D3D6E5B305D2C46652E436F707928742C312C692C652E6C656E6774682C742E6C656E6774682D31292C697D7B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(886) := '6E657720417272617928652E6C656E6774682B742E6C656E677468293B72657475726E2046652E436F707928652C302C6E2C302C652E6C656E677468292C46652E436F707928742C302C6E2C652E6C656E6774682C742E6C656E677468292C6E7D7D4368';
wwv_flow_imp.g_varchar2_table(887) := '616E6765734F7665726C617028652C742C6E297B69662844652E41737365727428652E6F726967696E616C53746172743C3D742E6F726967696E616C53746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F722065';
wwv_flow_imp.g_varchar2_table(888) := '7175616C20746F207269676874206368616E676522292C44652E41737365727428652E6D6F64696669656453746172743C3D742E6D6F64696669656453746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F722065';
wwv_flow_imp.g_varchar2_table(889) := '7175616C20746F207269676874206368616E676522292C652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C53746172747C7C652E6D6F64696669656453746172742B652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(890) := '4C656E6774683E3D742E6D6F6469666965645374617274297B636F6E737420693D652E6F726967696E616C53746172743B6C657420723D652E6F726967696E616C4C656E6774683B636F6E737420733D652E6D6F64696669656453746172743B6C657420';
wwv_flow_imp.g_varchar2_table(891) := '6F3D652E6D6F6469666965644C656E6774683B72657475726E20652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C5374617274262628723D742E6F726967696E616C53746172742B742E6F72';
wwv_flow_imp.g_varchar2_table(892) := '6967696E616C4C656E6774682D652E6F726967696E616C5374617274292C652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774683E3D742E6D6F64696669656453746172742626286F3D742E6D6F64696669656453746172742B';
wwv_flow_imp.g_varchar2_table(893) := '742E6D6F6469666965644C656E6774682D652E6D6F6469666965645374617274292C6E5B305D3D6E657720526528692C722C732C6F292C21307D72657475726E206E5B305D3D6E756C6C2C21317D436C6970446961676F6E616C426F756E6428652C742C';
wwv_flow_imp.g_varchar2_table(894) := '6E2C69297B696628653E3D302626653C692972657475726E20653B636F6E737420723D7425323D3D303B72657475726E20653C303F723D3D3D286E25323D3D30293F303A313A723D3D3D2828692D6E2D312925323D3D30293F692D313A692D327D7D636F';
wwv_flow_imp.g_varchar2_table(895) := '6E73742056653D676C6F62616C546869732E7673636F64653B696628766F69642030213D3D56652626766F69642030213D3D56652E70726F63657373297B636F6E737420653D56652E70726F636573733B62653D7B67657420706C6174666F726D28297B';
wwv_flow_imp.g_varchar2_table(896) := '72657475726E20652E706C6174666F726D7D2C676574206172636828297B72657475726E20652E617263687D2C67657420656E7628297B72657475726E20652E656E767D2C6377643A28293D3E652E63776428297D7D656C73652062653D22756E646566';
wwv_flow_imp.g_varchar2_table(897) := '696E656422213D747970656F662070726F636573733F7B67657420706C6174666F726D28297B72657475726E2070726F636573732E706C6174666F726D7D2C676574206172636828297B72657475726E2070726F636573732E617263687D2C6765742065';
wwv_flow_imp.g_varchar2_table(898) := '6E7628297B72657475726E2070726F636573732E656E767D2C6377643A28293D3E70726F636573732E656E762E5653434F44455F4357447C7C70726F636573732E63776428297D3A7B67657420706C6174666F726D28297B72657475726E2065653F2277';
wwv_flow_imp.g_varchar2_table(899) := '696E3332223A74653F2264617277696E223A226C696E7578227D2C676574206172636828297B7D2C67657420656E7628297B72657475726E7B7D7D2C6377643A28293D3E222F227D3B636F6E73742042653D62652E6377642C55653D62652E656E762C7A';
wwv_flow_imp.g_varchar2_table(900) := '653D62652E706C6174666F726D2C48653D34362C57653D34372C24653D39322C6A653D35383B636C61737320476520657874656E6473204572726F727B636F6E7374727563746F7228652C742C6E297B6C657420693B22737472696E67223D3D74797065';
wwv_flow_imp.g_varchar2_table(901) := '6F6620742626303D3D3D742E696E6465784F6628226E6F742022293F28693D226D757374206E6F74206265222C743D742E7265706C616365282F5E6E6F74202F2C222229293A693D226D757374206265223B636F6E737420723D2D31213D3D652E696E64';
wwv_flow_imp.g_varchar2_table(902) := '65784F6628222E22293F2270726F7065727479223A22617267756D656E74223B6C657420733D605468652022247B657D2220247B727D20247B697D206F66207479706520247B747D603B732B3D222E205265636569766564207479706520222B74797065';
wwv_flow_imp.g_varchar2_table(903) := '6F66206E2C73757065722873292C746869732E636F64653D224552525F494E56414C49445F4152475F54595045227D7D66756E6374696F6E20516528652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720476528';
wwv_flow_imp.g_varchar2_table(904) := '742C22737472696E67222C65297D636F6E73742058653D2277696E3332223D3D3D7A653B66756E6374696F6E204A652865297B72657475726E20653D3D3D57657C7C653D3D3D24657D66756E6374696F6E2059652865297B72657475726E20653D3D3D57';
wwv_flow_imp.g_varchar2_table(905) := '657D66756E6374696F6E205A652865297B72657475726E20653E3D36352626653C3D39307C7C653E3D39372626653C3D3132327D66756E6374696F6E20657428652C742C6E2C69297B6C657420723D22222C733D302C6F3D2D312C613D302C6C3D303B66';
wwv_flow_imp.g_varchar2_table(906) := '6F72286C657420753D303B753C3D652E6C656E6774683B2B2B75297B696628753C652E6C656E677468296C3D652E63686172436F646541742875293B656C73657B69662869286C2929627265616B3B6C3D57657D69662869286C29297B6966286F3D3D3D';
wwv_flow_imp.g_varchar2_table(907) := '752D317C7C313D3D3D61293B656C736520696628323D3D3D61297B696628722E6C656E6774683C327C7C32213D3D737C7C722E63686172436F6465417428722E6C656E6774682D3129213D3D48657C7C722E63686172436F6465417428722E6C656E6774';
wwv_flow_imp.g_varchar2_table(908) := '682D3229213D3D4865297B696628722E6C656E6774683E32297B636F6E737420653D722E6C617374496E6465784F66286E293B2D313D3D3D653F28723D22222C733D30293A28723D722E736C69636528302C65292C733D722E6C656E6774682D312D722E';
wwv_flow_imp.g_varchar2_table(909) := '6C617374496E6465784F66286E29292C6F3D752C613D303B636F6E74696E75657D69662830213D3D722E6C656E677468297B723D22222C733D302C6F3D752C613D303B636F6E74696E75657D7D74262628722B3D722E6C656E6774683E303F60247B6E7D';
wwv_flow_imp.g_varchar2_table(910) := '2E2E603A222E2E222C733D32297D656C736520722E6C656E6774683E303F722B3D60247B6E7D247B652E736C696365286F2B312C75297D603A723D652E736C696365286F2B312C75292C733D752D6F2D313B6F3D752C613D307D656C7365206C3D3D3D48';
wwv_flow_imp.g_varchar2_table(911) := '6526262D31213D3D613F2B2B613A613D2D317D72657475726E20727D66756E6374696F6E20747428652C74297B2166756E6374696F6E2865297B6966286E756C6C3D3D3D657C7C226F626A65637422213D747970656F662065297468726F77206E657720';
wwv_flow_imp.g_varchar2_table(912) := '47652822706174684F626A656374222C224F626A656374222C65297D2874293B636F6E7374206E3D742E6469727C7C742E726F6F742C693D742E626173657C7C60247B742E6E616D657C7C22227D247B742E6578747C7C22227D603B72657475726E206E';
wwv_flow_imp.g_varchar2_table(913) := '3F6E3D3D3D742E726F6F743F60247B6E7D247B697D603A60247B6E7D247B657D247B697D603A697D636F6E7374206E743D7B7265736F6C7665282E2E2E65297B6C657420743D22222C6E3D22222C693D21313B666F72286C657420723D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(914) := '682D313B723E3D2D313B722D2D297B6C657420733B696628723E3D30297B696628733D655B725D2C516528732C227061746822292C303D3D3D732E6C656E67746829636F6E74696E75657D656C736520303D3D3D742E6C656E6774683F733D426528293A';
wwv_flow_imp.g_varchar2_table(915) := '28733D55655B603D247B747D605D7C7C426528292C28766F696420303D3D3D737C7C732E736C69636528302C32292E746F4C6F776572436173652829213D3D742E746F4C6F7765724361736528292626732E63686172436F646541742832293D3D3D2465';
wwv_flow_imp.g_varchar2_table(916) := '29262628733D60247B747D5C5C6029293B636F6E7374206F3D732E6C656E6774683B6C657420613D302C6C3D22222C753D21313B636F6E737420683D732E63686172436F646541742830293B696628313D3D3D6F294A65286829262628613D312C753D21';
wwv_flow_imp.g_varchar2_table(917) := '30293B656C7365206966284A6528682929696628753D21302C4A6528732E63686172436F6465417428312929297B6C657420653D322C743D653B666F72283B653C6F2626214A6528732E63686172436F64654174286529293B29652B2B3B696628653C6F';
wwv_flow_imp.g_varchar2_table(918) := '262665213D3D74297B636F6E7374206E3D732E736C69636528742C65293B666F7228743D653B653C6F26264A6528732E63686172436F64654174286529293B29652B2B3B696628653C6F262665213D3D74297B666F7228743D653B653C6F2626214A6528';
wwv_flow_imp.g_varchar2_table(919) := '732E63686172436F64654174286529293B29652B2B3B65213D3D6F2626653D3D3D747C7C286C3D605C5C5C5C247B6E7D5C5C247B732E736C69636528742C65297D602C613D65297D7D7D656C736520613D313B656C7365205A652868292626732E636861';
wwv_flow_imp.g_varchar2_table(920) := '72436F646541742831293D3D3D6A652626286C3D732E736C69636528302C32292C613D322C6F3E3226264A6528732E63686172436F6465417428322929262628753D21302C613D3329293B6966286C2E6C656E6774683E3029696628742E6C656E677468';
wwv_flow_imp.g_varchar2_table(921) := '3E30297B6966286C2E746F4C6F776572436173652829213D3D742E746F4C6F77657243617365282929636F6E74696E75657D656C736520743D6C3B69662869297B696628742E6C656E6774683E3029627265616B7D656C7365206966286E3D60247B732E';
wwv_flow_imp.g_varchar2_table(922) := '736C6963652861297D5C5C247B6E7D602C693D752C752626742E6C656E6774683E3029627265616B7D72657475726E206E3D6574286E2C21692C225C5C222C4A65292C693F60247B747D5C5C247B6E7D603A60247B747D247B6E7D607C7C222E227D2C6E';
wwv_flow_imp.g_varchar2_table(923) := '6F726D616C697A652865297B516528652C227061746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E222E223B6C6574206E2C693D302C723D21313B636F6E737420733D652E63686172436F646541742830293B';
wwv_flow_imp.g_varchar2_table(924) := '696628313D3D3D742972657475726E2059652873293F225C5C223A653B6966284A6528732929696628723D21302C4A6528652E63686172436F6465417428312929297B6C657420723D322C733D723B666F72283B723C742626214A6528652E6368617243';
wwv_flow_imp.g_varchar2_table(925) := '6F64654174287229293B29722B2B3B696628723C74262672213D3D73297B636F6E7374206F3D652E736C69636528732C72293B666F7228733D723B723C7426264A6528652E63686172436F64654174287229293B29722B2B3B696628723C74262672213D';
wwv_flow_imp.g_varchar2_table(926) := '3D73297B666F7228733D723B723C742626214A6528652E63686172436F64654174287229293B29722B2B3B696628723D3D3D742972657475726E605C5C5C5C247B6F7D5C5C247B652E736C6963652873297D5C5C603B72213D3D732626286E3D605C5C5C';
wwv_flow_imp.g_varchar2_table(927) := '5C247B6F7D5C5C247B652E736C69636528732C72297D602C693D72297D7D7D656C736520693D313B656C7365205A652873292626652E63686172436F646541742831293D3D3D6A652626286E3D652E736C69636528302C32292C693D322C743E3226264A';
wwv_flow_imp.g_varchar2_table(928) := '6528652E63686172436F6465417428322929262628723D21302C693D3329293B6C6574206F3D693C743F657428652E736C6963652869292C21722C225C5C222C4A65293A22223B72657475726E2030213D3D6F2E6C656E6774687C7C727C7C286F3D222E';
wwv_flow_imp.g_varchar2_table(929) := '22292C6F2E6C656E6774683E3026264A6528652E63686172436F6465417428742D3129292626286F2B3D225C5C22292C766F696420303D3D3D6E3F723F605C5C247B6F7D603A6F3A723F60247B6E7D5C5C247B6F7D603A60247B6E7D247B6F7D607D2C69';
wwv_flow_imp.g_varchar2_table(930) := '734162736F6C7574652865297B516528652C227061746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E21313B636F6E7374206E3D652E63686172436F646541742830293B72657475726E204A65286E297C7C74';
wwv_flow_imp.g_varchar2_table(931) := '3E3226265A65286E292626652E63686172436F646541742831293D3D3D6A6526264A6528652E63686172436F64654174283229297D2C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420742C6E3B66';
wwv_flow_imp.g_varchar2_table(932) := '6F72286C657420693D303B693C652E6C656E6774683B2B2B69297B636F6E737420723D655B695D3B516528722C227061746822292C722E6C656E6774683E30262628766F696420303D3D3D743F743D6E3D723A742B3D605C5C247B727D60297D69662876';
wwv_flow_imp.g_varchar2_table(933) := '6F696420303D3D3D742972657475726E222E223B6C657420693D21302C723D303B69662822737472696E67223D3D747970656F66206E26264A65286E2E63686172436F6465417428302929297B2B2B723B636F6E737420653D6E2E6C656E6774683B653E';
wwv_flow_imp.g_varchar2_table(934) := '3126264A65286E2E63686172436F64654174283129292626282B2B722C653E322626284A65286E2E63686172436F64654174283229293F2B2B723A693D213129297D69662869297B666F72283B723C742E6C656E67746826264A6528742E63686172436F';
wwv_flow_imp.g_varchar2_table(935) := '64654174287229293B29722B2B3B723E3D32262628743D605C5C247B742E736C6963652872297D60297D72657475726E206E742E6E6F726D616C697A652874297D2C72656C617469766528652C74297B696628516528652C2266726F6D22292C51652874';
wwv_flow_imp.g_varchar2_table(936) := '2C22746F22292C653D3D3D742972657475726E22223B636F6E7374206E3D6E742E7265736F6C76652865292C693D6E742E7265736F6C76652874293B6966286E3D3D3D692972657475726E22223B69662828653D6E2E746F4C6F77657243617365282929';
wwv_flow_imp.g_varchar2_table(937) := '3D3D3D28743D692E746F4C6F776572436173652829292972657475726E22223B6C657420723D303B666F72283B723C652E6C656E6774682626652E63686172436F646541742872293D3D3D24653B29722B2B3B6C657420733D652E6C656E6774683B666F';
wwv_flow_imp.g_varchar2_table(938) := '72283B732D313E722626652E63686172436F6465417428732D31293D3D3D24653B29732D2D3B636F6E7374206F3D732D723B6C657420613D303B666F72283B613C742E6C656E6774682626742E63686172436F646541742861293D3D3D24653B29612B2B';
wwv_flow_imp.g_varchar2_table(939) := '3B6C6574206C3D742E6C656E6774683B666F72283B6C2D313E612626742E63686172436F64654174286C2D31293D3D3D24653B296C2D2D3B636F6E737420753D6C2D612C683D6F3C753F6F3A753B6C657420633D2D312C643D303B666F72283B643C683B';
wwv_flow_imp.g_varchar2_table(940) := '642B2B297B636F6E7374206E3D652E63686172436F6465417428722B64293B6966286E213D3D742E63686172436F6465417428612B642929627265616B3B6E3D3D3D2465262628633D64297D69662864213D3D68297B6966282D313D3D3D632972657475';
wwv_flow_imp.g_varchar2_table(941) := '726E20697D656C73657B696628753E68297B696628742E63686172436F6465417428612B64293D3D3D24652972657475726E20692E736C69636528612B642B31293B696628323D3D3D642972657475726E20692E736C69636528612B64297D6F3E682626';
wwv_flow_imp.g_varchar2_table(942) := '28652E63686172436F6465417428722B64293D3D3D24653F633D643A323D3D3D64262628633D3329292C2D313D3D3D63262628633D30297D6C6574206D3D22223B666F7228643D722B632B313B643C3D733B2B2B642964213D3D732626652E6368617243';
wwv_flow_imp.g_varchar2_table(943) := '6F64654174286429213D3D24657C7C286D2B3D303D3D3D6D2E6C656E6774683F222E2E223A225C5C2E2E22293B72657475726E20612B3D632C6D2E6C656E6774683E303F60247B6D7D247B692E736C69636528612C6C297D603A28692E63686172436F64';
wwv_flow_imp.g_varchar2_table(944) := '6541742861293D3D3D246526262B2B612C692E736C69636528612C6C29297D2C746F4E616D65737061636564506174682865297B69662822737472696E6722213D747970656F6620657C7C303D3D3D652E6C656E6774682972657475726E20653B636F6E';
wwv_flow_imp.g_varchar2_table(945) := '737420743D6E742E7265736F6C76652865293B696628742E6C656E6774683C3D322972657475726E20653B696628742E63686172436F646541742830293D3D3D2465297B696628742E63686172436F646541742831293D3D3D2465297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(946) := '3D742E63686172436F646541742832293B6966283633213D3D65262665213D3D48652972657475726E605C5C5C5C3F5C5C554E435C5C247B742E736C6963652832297D607D7D656C7365206966285A6528742E63686172436F6465417428302929262674';
wwv_flow_imp.g_varchar2_table(947) := '2E63686172436F646541742831293D3D3D6A652626742E63686172436F646541742832293D3D3D24652972657475726E605C5C5C5C3F5C5C247B747D603B72657475726E20657D2C6469726E616D652865297B516528652C227061746822293B636F6E73';
wwv_flow_imp.g_varchar2_table(948) := '7420743D652E6C656E6774683B696628303D3D3D742972657475726E222E223B6C6574206E3D2D312C693D303B636F6E737420723D652E63686172436F646541742830293B696628313D3D3D742972657475726E204A652872293F653A222E223B696628';
wwv_flow_imp.g_varchar2_table(949) := '4A65287229297B6966286E3D693D312C4A6528652E63686172436F6465417428312929297B6C657420723D322C733D723B666F72283B723C742626214A6528652E63686172436F64654174287229293B29722B2B3B696628723C74262672213D3D73297B';
wwv_flow_imp.g_varchar2_table(950) := '666F7228733D723B723C7426264A6528652E63686172436F64654174287229293B29722B2B3B696628723C74262672213D3D73297B666F7228733D723B723C742626214A6528652E63686172436F64654174287229293B29722B2B3B696628723D3D3D74';
wwv_flow_imp.g_varchar2_table(951) := '2972657475726E20653B72213D3D732626286E3D693D722B31297D7D7D7D656C7365205A652872292626652E63686172436F646541742831293D3D3D6A652626286E3D743E3226264A6528652E63686172436F64654174283229293F333A322C693D6E29';
wwv_flow_imp.g_varchar2_table(952) := '3B6C657420733D2D312C6F3D21303B666F72286C6574206E3D742D313B6E3E3D693B2D2D6E296966284A6528652E63686172436F64654174286E2929297B696628216F297B733D6E3B627265616B7D7D656C7365206F3D21313B6966282D313D3D3D7329';
wwv_flow_imp.g_varchar2_table(953) := '7B6966282D313D3D3D6E2972657475726E222E223B733D6E7D72657475726E20652E736C69636528302C73297D2C626173656E616D6528652C74297B766F69642030213D3D742626516528742C2265787422292C516528652C227061746822293B6C6574';
wwv_flow_imp.g_varchar2_table(954) := '206E2C693D302C723D2D312C733D21303B696628652E6C656E6774683E3D3226265A6528652E63686172436F64654174283029292626652E63686172436F646541742831293D3D3D6A65262628693D32292C766F69642030213D3D742626742E6C656E67';
wwv_flow_imp.g_varchar2_table(955) := '74683E302626742E6C656E6774683C3D652E6C656E677468297B696628743D3D3D652972657475726E22223B6C6574206F3D742E6C656E6774682D312C613D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D693B2D2D6E297B636F6E7374206C';
wwv_flow_imp.g_varchar2_table(956) := '3D652E63686172436F64654174286E293B6966284A65286C29297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D61262628733D21312C613D6E2B31292C6F3E3D302626286C3D3D3D742E63686172436F64654174286F293F2D';
wwv_flow_imp.g_varchar2_table(957) := '313D3D2D2D6F262628723D6E293A286F3D2D312C723D6129297D72657475726E20693D3D3D723F723D613A2D313D3D3D72262628723D652E6C656E677468292C652E736C69636528692C72297D666F72286E3D652E6C656E6774682D313B6E3E3D693B2D';
wwv_flow_imp.g_varchar2_table(958) := '2D6E296966284A6528652E63686172436F64654174286E2929297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D72262628733D21312C723D6E2B31293B72657475726E2D313D3D3D723F22223A652E736C69636528692C7229';
wwv_flow_imp.g_varchar2_table(959) := '7D2C6578746E616D652865297B516528652C227061746822293B6C657420743D302C6E3D2D312C693D302C723D2D312C733D21302C6F3D303B652E6C656E6774683E3D322626652E63686172436F646541742831293D3D3D6A6526265A6528652E636861';
wwv_flow_imp.g_varchar2_table(960) := '72436F6465417428302929262628743D693D32293B666F72286C657420613D652E6C656E6774682D313B613E3D743B2D2D61297B636F6E737420743D652E63686172436F646541742861293B6966284A65287429297B6966282173297B693D612B313B62';
wwv_flow_imp.g_varchar2_table(961) := '7265616B7D7D656C73652D313D3D3D72262628733D21312C723D612B31292C743D3D3D48653F2D313D3D3D6E3F6E3D613A31213D3D6F2626286F3D31293A2D31213D3D6E2626286F3D2D31297D72657475726E2D313D3D3D6E7C7C2D313D3D3D727C7C30';
wwv_flow_imp.g_varchar2_table(962) := '3D3D3D6F7C7C313D3D3D6F26266E3D3D3D722D3126266E3D3D3D692B313F22223A652E736C696365286E2C72297D2C666F726D61743A74742E62696E64286E756C6C2C225C5C22292C70617273652865297B516528652C227061746822293B636F6E7374';
wwv_flow_imp.g_varchar2_table(963) := '20743D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E6C656E6774683B6C657420693D302C723D652E636861';
wwv_flow_imp.g_varchar2_table(964) := '72436F646541742830293B696628313D3D3D6E2972657475726E204A652872293F28742E726F6F743D742E6469723D652C74293A28742E626173653D742E6E616D653D652C74293B6966284A65287229297B696628693D312C4A6528652E63686172436F';
wwv_flow_imp.g_varchar2_table(965) := '6465417428312929297B6C657420743D322C723D743B666F72283B743C6E2626214A6528652E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D72297B666F7228723D743B743C6E26264A6528652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(966) := '74287429293B29742B2B3B696628743C6E262674213D3D72297B666F7228723D743B743C6E2626214A6528652E63686172436F64654174287429293B29742B2B3B743D3D3D6E3F693D743A74213D3D72262628693D742B31297D7D7D7D656C7365206966';
wwv_flow_imp.g_varchar2_table(967) := '285A652872292626652E63686172436F646541742831293D3D3D6A65297B6966286E3C3D322972657475726E20742E726F6F743D742E6469723D652C743B696628693D322C4A6528652E63686172436F6465417428322929297B696628333D3D3D6E2972';
wwv_flow_imp.g_varchar2_table(968) := '657475726E20742E726F6F743D742E6469723D652C743B693D337D7D693E30262628742E726F6F743D652E736C69636528302C6929293B6C657420733D2D312C6F3D692C613D2D312C6C3D21302C753D652E6C656E6774682D312C683D303B666F72283B';
wwv_flow_imp.g_varchar2_table(969) := '753E3D693B2D2D7529696628723D652E63686172436F646541742875292C4A65287229297B696628216C297B6F3D752B313B627265616B7D7D656C73652D313D3D3D612626286C3D21312C613D752B31292C723D3D3D48653F2D313D3D3D733F733D753A';
wwv_flow_imp.g_varchar2_table(970) := '31213D3D68262628683D31293A2D31213D3D73262628683D2D31293B72657475726E2D31213D3D612626282D313D3D3D737C7C303D3D3D687C7C313D3D3D682626733D3D3D612D312626733D3D3D6F2B313F742E626173653D742E6E616D653D652E736C';
wwv_flow_imp.g_varchar2_table(971) := '696365286F2C61293A28742E6E616D653D652E736C696365286F2C73292C742E626173653D652E736C696365286F2C61292C742E6578743D652E736C69636528732C612929292C742E6469723D6F3E3026266F213D3D693F652E736C69636528302C6F2D';
wwv_flow_imp.g_varchar2_table(972) := '31293A742E726F6F742C747D2C7365703A225C5C222C64656C696D697465723A223B222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D2C69743D2828293D3E7B6966285865297B636F6E737420653D2F5C5C2F673B72657475726E28293D3E7B';
wwv_flow_imp.g_varchar2_table(973) := '636F6E737420743D426528292E7265706C61636528652C222F22293B72657475726E20742E736C69636528742E696E6465784F6628222F2229297D7D72657475726E28293D3E426528297D2928292C72743D7B7265736F6C7665282E2E2E65297B6C6574';
wwv_flow_imp.g_varchar2_table(974) := '20743D22222C6E3D21313B666F72286C657420693D652E6C656E6774682D313B693E3D2D312626216E3B692D2D297B636F6E737420723D693E3D303F655B695D3A697428293B516528722C227061746822292C30213D3D722E6C656E677468262628743D';
wwv_flow_imp.g_varchar2_table(975) := '60247B727D2F247B747D602C6E3D722E63686172436F646541742830293D3D3D5765297D72657475726E20743D657428742C216E2C222F222C5965292C6E3F602F247B747D603A742E6C656E6774683E303F743A222E227D2C6E6F726D616C697A652865';
wwv_flow_imp.g_varchar2_table(976) := '297B696628516528652C227061746822292C303D3D3D652E6C656E6774682972657475726E222E223B636F6E737420743D652E63686172436F646541742830293D3D3D57652C6E3D652E63686172436F6465417428652E6C656E6774682D31293D3D3D57';
wwv_flow_imp.g_varchar2_table(977) := '653B72657475726E20303D3D3D28653D657428652C21742C222F222C596529292E6C656E6774683F743F222F223A6E3F222E2F223A222E223A286E262628652B3D222F22292C743F602F247B657D603A65297D2C69734162736F6C7574653A653D3E2851';
wwv_flow_imp.g_varchar2_table(978) := '6528652C227061746822292C652E6C656E6774683E302626652E63686172436F646541742830293D3D3D5765292C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420743B666F72286C6574206E3D30';
wwv_flow_imp.g_varchar2_table(979) := '3B6E3C652E6C656E6774683B2B2B6E297B636F6E737420693D655B6E5D3B516528692C227061746822292C692E6C656E6774683E30262628766F696420303D3D3D743F743D693A742B3D602F247B697D60297D72657475726E20766F696420303D3D3D74';
wwv_flow_imp.g_varchar2_table(980) := '3F222E223A72742E6E6F726D616C697A652874297D2C72656C617469766528652C74297B696628516528652C2266726F6D22292C516528742C22746F22292C653D3D3D742972657475726E22223B69662828653D72742E7265736F6C7665286529293D3D';
wwv_flow_imp.g_varchar2_table(981) := '3D28743D72742E7265736F6C7665287429292972657475726E22223B636F6E7374206E3D652E6C656E6774682C693D6E2D312C723D742E6C656E6774682D312C733D693C723F693A723B6C6574206F3D2D312C613D303B666F72283B613C733B612B2B29';
wwv_flow_imp.g_varchar2_table(982) := '7B636F6E7374206E3D652E63686172436F6465417428312B61293B6966286E213D3D742E63686172436F6465417428312B612929627265616B3B6E3D3D3D57652626286F3D61297D696628613D3D3D7329696628723E73297B696628742E63686172436F';
wwv_flow_imp.g_varchar2_table(983) := '6465417428312B61293D3D3D57652972657475726E20742E736C69636528312B612B31293B696628303D3D3D612972657475726E20742E736C69636528312B61297D656C736520693E73262628652E63686172436F6465417428312B61293D3D3D57653F';
wwv_flow_imp.g_varchar2_table(984) := '6F3D613A303D3D3D612626286F3D3029293B6C6574206C3D22223B666F7228613D312B6F2B313B613C3D6E3B2B2B612961213D3D6E2626652E63686172436F64654174286129213D3D57657C7C286C2B3D303D3D3D6C2E6C656E6774683F222E2E223A22';
wwv_flow_imp.g_varchar2_table(985) := '2F2E2E22293B72657475726E60247B6C7D247B742E736C69636528312B6F297D607D2C746F4E616D65737061636564506174683A653D3E652C6469726E616D652865297B696628516528652C227061746822292C303D3D3D652E6C656E67746829726574';
wwv_flow_imp.g_varchar2_table(986) := '75726E222E223B636F6E737420743D652E63686172436F646541742830293D3D3D57653B6C6574206E3D2D312C693D21303B666F72286C657420743D652E6C656E6774682D313B743E3D313B2D2D7429696628652E63686172436F646541742874293D3D';
wwv_flow_imp.g_varchar2_table(987) := '3D5765297B6966282169297B6E3D743B627265616B7D7D656C736520693D21313B72657475726E2D313D3D3D6E3F743F222F223A222E223A742626313D3D3D6E3F222F2F223A652E736C69636528302C6E297D2C626173656E616D6528652C74297B766F';
wwv_flow_imp.g_varchar2_table(988) := '69642030213D3D742626516528742C2265787422292C516528652C227061746822293B6C6574206E2C693D302C723D2D312C733D21303B696628766F69642030213D3D742626742E6C656E6774683E302626742E6C656E6774683C3D652E6C656E677468';
wwv_flow_imp.g_varchar2_table(989) := '297B696628743D3D3D652972657475726E22223B6C6574206F3D742E6C656E6774682D312C613D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E297B636F6E7374206C3D652E63686172436F64654174286E293B6966286C3D3D3D';
wwv_flow_imp.g_varchar2_table(990) := '5765297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D61262628733D21312C613D6E2B31292C6F3E3D302626286C3D3D3D742E63686172436F64654174286F293F2D313D3D2D2D6F262628723D6E293A286F3D2D312C723D61';
wwv_flow_imp.g_varchar2_table(991) := '29297D72657475726E20693D3D3D723F723D613A2D313D3D3D72262628723D652E6C656E677468292C652E736C69636528692C72297D666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E29696628652E63686172436F64654174286E293D3D';
wwv_flow_imp.g_varchar2_table(992) := '3D5765297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D72262628733D21312C723D6E2B31293B72657475726E2D313D3D3D723F22223A652E736C69636528692C72297D2C6578746E616D652865297B516528652C22706174';
wwv_flow_imp.g_varchar2_table(993) := '6822293B6C657420743D2D312C6E3D302C693D2D312C723D21302C733D303B666F72286C6574206F3D652E6C656E6774682D313B6F3E3D303B2D2D6F297B636F6E737420613D652E63686172436F64654174286F293B69662861213D3D5765292D313D3D';
wwv_flow_imp.g_varchar2_table(994) := '3D69262628723D21312C693D6F2B31292C613D3D3D48653F2D313D3D3D743F743D6F3A31213D3D73262628733D31293A2D31213D3D74262628733D2D31293B656C7365206966282172297B6E3D6F2B313B627265616B7D7D72657475726E2D313D3D3D74';
wwv_flow_imp.g_varchar2_table(995) := '7C7C2D313D3D3D697C7C303D3D3D737C7C313D3D3D732626743D3D3D692D312626743D3D3D6E2B313F22223A652E736C69636528742C69297D2C666F726D61743A74742E62696E64286E756C6C2C222F22292C70617273652865297B516528652C227061';
wwv_flow_imp.g_varchar2_table(996) := '746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E63686172436F646541742830';
wwv_flow_imp.g_varchar2_table(997) := '293D3D3D57653B6C657420693B6E3F28742E726F6F743D222F222C693D31293A693D303B6C657420723D2D312C733D302C6F3D2D312C613D21302C6C3D652E6C656E6774682D312C753D303B666F72283B6C3E3D693B2D2D6C297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(998) := '2E63686172436F64654174286C293B69662874213D3D5765292D313D3D3D6F262628613D21312C6F3D6C2B31292C743D3D3D48653F2D313D3D3D723F723D6C3A31213D3D75262628753D31293A2D31213D3D72262628753D2D31293B656C736520696628';
wwv_flow_imp.g_varchar2_table(999) := '2161297B733D6C2B313B627265616B7D7D6966282D31213D3D6F297B636F6E737420693D303D3D3D7326266E3F313A733B2D313D3D3D727C7C303D3D3D757C7C313D3D3D752626723D3D3D6F2D312626723D3D3D732B313F742E626173653D742E6E616D';
wwv_flow_imp.g_varchar2_table(1000) := '653D652E736C69636528692C6F293A28742E6E616D653D652E736C69636528692C72292C742E626173653D652E736C69636528692C6F292C742E6578743D652E736C69636528722C6F29297D72657475726E20733E303F742E6469723D652E736C696365';
wwv_flow_imp.g_varchar2_table(1001) := '28302C732D31293A6E262628742E6469723D222F22292C747D2C7365703A222F222C64656C696D697465723A223A222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D3B72742E77696E33323D6E742E77696E33323D6E742C72742E706F736978';
wwv_flow_imp.g_varchar2_table(1002) := '3D6E742E706F7369783D72742C58653F6E742E6E6F726D616C697A653A72742E6E6F726D616C697A652C58653F6E742E7265736F6C76653A72742E7265736F6C76652C58653F6E742E72656C61746976653A72742E72656C61746976652C58653F6E742E';
wwv_flow_imp.g_varchar2_table(1003) := '6469726E616D653A72742E6469726E616D652C58653F6E742E626173656E616D653A72742E626173656E616D652C58653F6E742E6578746E616D653A72742E6578746E616D652C58653F6E742E7365703A72742E7365703B636F6E73742073743D2F5E5C';
wwv_flow_imp.g_varchar2_table(1004) := '775B5C775C642B2E2D5D2A242F2C6F743D2F5E5C2F2F2C61743D2F5E5C2F5C2F2F2C6C743D22222C75743D222F222C68743D2F5E28285B5E3A2F3F235D2B3F293A293F285C2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A';
wwv_flow_imp.g_varchar2_table(1005) := '29293F2823282E2A29293F2F3B636C6173732063747B7374617469632069735572692865297B72657475726E206520696E7374616E63656F662063747C7C212165262622737472696E67223D3D747970656F6620652E617574686F726974792626227374';
wwv_flow_imp.g_varchar2_table(1006) := '72696E67223D3D747970656F6620652E667261676D656E74262622737472696E67223D3D747970656F6620652E70617468262622737472696E67223D3D747970656F6620652E7175657279262622737472696E67223D3D747970656F6620652E73636865';
wwv_flow_imp.g_varchar2_table(1007) := '6D65262622737472696E67223D3D747970656F6620652E66735061746826262266756E6374696F6E223D3D747970656F6620652E7769746826262266756E6374696F6E223D3D747970656F6620652E746F537472696E677D636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(1008) := '652C742C6E2C692C722C733D2131297B226F626A656374223D3D747970656F6620653F28746869732E736368656D653D652E736368656D657C7C6C742C746869732E617574686F726974793D652E617574686F726974797C7C6C742C746869732E706174';
wwv_flow_imp.g_varchar2_table(1009) := '683D652E706174687C7C6C742C746869732E71756572793D652E71756572797C7C6C742C746869732E667261676D656E743D652E667261676D656E747C7C6C74293A28746869732E736368656D653D66756E6374696F6E28652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(1010) := '657C7C743F653A2266696C65227D28652C73292C746869732E617574686F726974793D747C7C6C742C746869732E706174683D66756E6374696F6E28652C74297B7377697463682865297B63617365226874747073223A636173652268747470223A6361';
wwv_flow_imp.g_varchar2_table(1011) := '73652266696C65223A743F745B305D213D3D7574262628743D75742B74293A743D75747D72657475726E20747D28746869732E736368656D652C6E7C7C6C74292C746869732E71756572793D697C7C6C742C746869732E667261676D656E743D727C7C6C';
wwv_flow_imp.g_varchar2_table(1012) := '742C66756E6374696F6E28652C74297B69662821652E736368656D65262674297468726F77206E6577204572726F7228605B5572694572726F725D3A20536368656D65206973206D697373696E673A207B736368656D653A2022222C20617574686F7269';
wwv_flow_imp.g_varchar2_table(1013) := '74793A2022247B652E617574686F726974797D222C20706174683A2022247B652E706174687D222C2071756572793A2022247B652E71756572797D222C20667261676D656E743A2022247B652E667261676D656E747D227D60293B696628652E73636865';
wwv_flow_imp.g_varchar2_table(1014) := '6D6526262173742E7465737428652E736368656D6529297468726F77206E6577204572726F7228225B5572694572726F725D3A20536368656D6520636F6E7461696E7320696C6C6567616C20636861726163746572732E22293B696628652E7061746829';
wwv_flow_imp.g_varchar2_table(1015) := '696628652E617574686F72697479297B696628216F742E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920636F6E7461696E7320616E20617574686F7269747920636F6D70';
wwv_flow_imp.g_varchar2_table(1016) := '6F6E656E742C207468656E20746865207061746820636F6D706F6E656E74206D7573742065697468657220626520656D707479206F7220626567696E2077697468206120736C6173682028222F22292063686172616374657227297D656C736520696628';
wwv_flow_imp.g_varchar2_table(1017) := '61742E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920646F6573206E6F7420636F6E7461696E20616E20617574686F7269747920636F6D706F6E656E742C207468656E20';
wwv_flow_imp.g_varchar2_table(1018) := '74686520706174682063616E6E6F7420626567696E20776974682074776F20736C61736820636861726163746572732028222F2F222927297D28746869732C7329297D6765742066735061746828297B72657475726E20627428746869732C2131297D77';
wwv_flow_imp.g_varchar2_table(1019) := '6974682865297B69662821652972657475726E20746869733B6C65747B736368656D653A742C617574686F726974793A6E2C706174683A692C71756572793A722C667261676D656E743A737D3D653B72657475726E20766F696420303D3D3D743F743D74';
wwv_flow_imp.g_varchar2_table(1020) := '6869732E736368656D653A6E756C6C3D3D3D74262628743D6C74292C766F696420303D3D3D6E3F6E3D746869732E617574686F726974793A6E756C6C3D3D3D6E2626286E3D6C74292C766F696420303D3D3D693F693D746869732E706174683A6E756C6C';
wwv_flow_imp.g_varchar2_table(1021) := '3D3D3D69262628693D6C74292C766F696420303D3D3D723F723D746869732E71756572793A6E756C6C3D3D3D72262628723D6C74292C766F696420303D3D3D733F733D746869732E667261676D656E743A6E756C6C3D3D3D73262628733D6C74292C743D';
wwv_flow_imp.g_varchar2_table(1022) := '3D3D746869732E736368656D6526266E3D3D3D746869732E617574686F726974792626693D3D3D746869732E706174682626723D3D3D746869732E71756572792626733D3D3D746869732E667261676D656E743F746869733A6E6577206D7428742C6E2C';
wwv_flow_imp.g_varchar2_table(1023) := '692C722C73297D73746174696320706172736528652C743D2131297B636F6E7374206E3D68742E657865632865293B72657475726E206E3F6E6577206D74286E5B325D7C7C6C742C7974286E5B345D7C7C6C74292C7974286E5B355D7C7C6C74292C7974';
wwv_flow_imp.g_varchar2_table(1024) := '286E5B375D7C7C6C74292C7974286E5B395D7C7C6C74292C74293A6E6577206D74286C742C6C742C6C742C6C742C6C74297D7374617469632066696C652865297B6C657420743D6C743B6966286565262628653D652E7265706C616365282F5C5C2F672C';
wwv_flow_imp.g_varchar2_table(1025) := '757429292C655B305D3D3D3D75742626655B315D3D3D3D7574297B636F6E7374206E3D652E696E6465784F662875742C32293B2D313D3D3D6E3F28743D652E737562737472696E672832292C653D7574293A28743D652E737562737472696E6728322C6E';
wwv_flow_imp.g_varchar2_table(1026) := '292C653D652E737562737472696E67286E297C7C7574297D72657475726E206E6577206D74282266696C65222C742C652C6C742C6C74297D7374617469632066726F6D28652C74297B72657475726E206E6577206D7428652E736368656D652C652E6175';
wwv_flow_imp.g_varchar2_table(1027) := '74686F726974792C652E706174682C652E71756572792C652E667261676D656E742C74297D737461746963206A6F696E5061746828652C2E2E2E74297B69662821652E70617468297468726F77206E6577204572726F7228225B5572694572726F725D3A';
wwv_flow_imp.g_varchar2_table(1028) := '2063616E6E6F742063616C6C206A6F696E50617468206F6E2055524920776974686F7574207061746822293B6C6574206E3B72657475726E206E3D656526262266696C65223D3D3D652E736368656D653F63742E66696C65286E742E6A6F696E28627428';
wwv_flow_imp.g_varchar2_table(1029) := '652C2130292C2E2E2E7429292E706174683A72742E6A6F696E28652E706174682C2E2E2E74292C652E77697468287B706174683A6E7D297D746F537472696E6728653D2131297B72657475726E205F7428746869732C65297D746F4A534F4E28297B7265';
wwv_flow_imp.g_varchar2_table(1030) := '7475726E20746869737D737461746963207265766976652865297B76617220742C6E3B69662865297B6966286520696E7374616E63656F662063742972657475726E20653B7B636F6E737420693D6E6577206D742865293B72657475726E20692E5F666F';
wwv_flow_imp.g_varchar2_table(1031) := '726D61747465643D6E756C6C213D3D28743D652E65787465726E616C292626766F69642030213D3D743F743A6E756C6C2C692E5F6673506174683D652E5F7365703D3D3D647426266E756C6C213D3D286E3D652E667350617468292626766F6964203021';
wwv_flow_imp.g_varchar2_table(1032) := '3D3D6E3F6E3A6E756C6C2C697D7D72657475726E20657D7D636F6E73742064743D65653F313A766F696420303B636C617373206D7420657874656E64732063747B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C74';
wwv_flow_imp.g_varchar2_table(1033) := '6869732E5F666F726D61747465643D6E756C6C2C746869732E5F6673506174683D6E756C6C7D6765742066735061746828297B72657475726E20746869732E5F6673506174687C7C28746869732E5F6673506174683D627428746869732C213129292C74';
wwv_flow_imp.g_varchar2_table(1034) := '6869732E5F6673506174687D746F537472696E6728653D2131297B72657475726E20653F5F7428746869732C2130293A28746869732E5F666F726D61747465647C7C28746869732E5F666F726D61747465643D5F7428746869732C213129292C74686973';
wwv_flow_imp.g_varchar2_table(1035) := '2E5F666F726D6174746564297D746F4A534F4E28297B636F6E737420653D7B246D69643A317D3B72657475726E20746869732E5F667350617468262628652E6673506174683D746869732E5F6673506174682C652E5F7365703D6474292C746869732E5F';
wwv_flow_imp.g_varchar2_table(1036) := '666F726D6174746564262628652E65787465726E616C3D746869732E5F666F726D6174746564292C746869732E70617468262628652E706174683D746869732E70617468292C746869732E736368656D65262628652E736368656D653D746869732E7363';
wwv_flow_imp.g_varchar2_table(1037) := '68656D65292C746869732E617574686F72697479262628652E617574686F726974793D746869732E617574686F72697479292C746869732E7175657279262628652E71756572793D746869732E7175657279292C746869732E667261676D656E74262628';
wwv_flow_imp.g_varchar2_table(1038) := '652E667261676D656E743D746869732E667261676D656E74292C657D7D636F6E73742067743D7B35383A22253341222C34373A22253246222C36333A22253346222C33353A22253233222C39313A22253542222C39333A22253544222C36343A22253430';
wwv_flow_imp.g_varchar2_table(1039) := '222C33333A22253231222C33363A22253234222C33383A22253236222C33393A22253237222C34303A22253238222C34313A22253239222C34323A22253241222C34333A22253242222C34343A22253243222C35393A22253342222C36313A2225334422';
wwv_flow_imp.g_varchar2_table(1040) := '2C33323A22253230227D3B66756E6374696F6E20667428652C742C6E297B6C657420692C723D2D313B666F72286C657420733D303B733C652E6C656E6774683B732B2B297B636F6E7374206F3D652E63686172436F646541742873293B6966286F3E3D39';
wwv_flow_imp.g_varchar2_table(1041) := '3726266F3C3D3132327C7C6F3E3D363526266F3C3D39307C7C6F3E3D343826266F3C3D35377C7C34353D3D3D6F7C7C34363D3D3D6F7C7C39353D3D3D6F7C7C3132363D3D3D6F7C7C74262634373D3D3D6F7C7C6E262639313D3D3D6F7C7C6E262639333D';
wwv_flow_imp.g_varchar2_table(1042) := '3D3D6F7C7C6E262635383D3D3D6F292D31213D3D72262628692B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728722C7329292C723D2D31292C766F69642030213D3D69262628692B3D652E636861724174287329293B65';
wwv_flow_imp.g_varchar2_table(1043) := '6C73657B766F696420303D3D3D69262628693D652E73756273747228302C7329293B636F6E737420743D67745B6F5D3B766F69642030213D3D743F282D31213D3D72262628692B3D656E636F6465555249436F6D706F6E656E7428652E73756273747269';
wwv_flow_imp.g_varchar2_table(1044) := '6E6728722C7329292C723D2D31292C692B3D74293A2D313D3D3D72262628723D73297D7D72657475726E2D31213D3D72262628692B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728722929292C766F69642030213D3D69';
wwv_flow_imp.g_varchar2_table(1045) := '3F693A657D66756E6374696F6E2070742865297B6C657420743B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D652E63686172436F64654174286E293B33353D3D3D697C7C36333D3D3D693F28766F69642030';
wwv_flow_imp.g_varchar2_table(1046) := '3D3D3D74262628743D652E73756273747228302C6E29292C742B3D67745B695D293A766F69642030213D3D74262628742B3D655B6E5D297D72657475726E20766F69642030213D3D743F743A657D66756E6374696F6E20627428652C74297B6C6574206E';
wwv_flow_imp.g_varchar2_table(1047) := '3B72657475726E206E3D652E617574686F726974792626652E706174682E6C656E6774683E3126262266696C65223D3D3D652E736368656D653F602F2F247B652E617574686F726974797D247B652E706174687D603A34373D3D3D652E706174682E6368';
wwv_flow_imp.g_varchar2_table(1048) := '6172436F64654174283029262628652E706174682E63686172436F646541742831293E3D36352626652E706174682E63686172436F646541742831293C3D39307C7C652E706174682E63686172436F646541742831293E3D39372626652E706174682E63';
wwv_flow_imp.g_varchar2_table(1049) := '686172436F646541742831293C3D31323229262635383D3D3D652E706174682E63686172436F646541742832293F743F652E706174682E7375627374722831293A652E706174685B315D2E746F4C6F7765724361736528292B652E706174682E73756273';
wwv_flow_imp.g_varchar2_table(1050) := '74722832293A652E706174682C65652626286E3D6E2E7265706C616365282F5C2F2F672C225C5C2229292C6E7D66756E6374696F6E205F7428652C74297B636F6E7374206E3D743F70743A66743B6C657420693D22222C7B736368656D653A722C617574';
wwv_flow_imp.g_varchar2_table(1051) := '686F726974793A732C706174683A6F2C71756572793A612C667261676D656E743A6C7D3D653B69662872262628692B3D722C692B3D223A22292C28737C7C2266696C65223D3D3D7229262628692B3D75742C692B3D7574292C73297B6C657420653D732E';
wwv_flow_imp.g_varchar2_table(1052) := '696E6465784F6628224022293B6966282D31213D3D65297B636F6E737420743D732E73756273747228302C65293B733D732E73756273747228652B31292C653D742E6C617374496E6465784F6628223A22292C2D313D3D3D653F692B3D6E28742C21312C';
wwv_flow_imp.g_varchar2_table(1053) := '2131293A28692B3D6E28742E73756273747228302C65292C21312C2131292C692B3D223A222C692B3D6E28742E73756273747228652B31292C21312C213029292C692B3D2240227D733D732E746F4C6F7765724361736528292C653D732E6C617374496E';
wwv_flow_imp.g_varchar2_table(1054) := '6465784F6628223A22292C2D313D3D3D653F692B3D6E28732C21312C2130293A28692B3D6E28732E73756273747228302C65292C21312C2130292C692B3D732E737562737472286529297D6966286F297B6966286F2E6C656E6774683E3D33262634373D';
wwv_flow_imp.g_varchar2_table(1055) := '3D3D6F2E63686172436F64654174283029262635383D3D3D6F2E63686172436F64654174283229297B636F6E737420653D6F2E63686172436F646541742831293B653E3D36352626653C3D39302626286F3D602F247B537472696E672E66726F6D436861';
wwv_flow_imp.g_varchar2_table(1056) := '72436F646528652B3332297D3A247B6F2E7375627374722833297D60297D656C7365206966286F2E6C656E6774683E3D32262635383D3D3D6F2E63686172436F64654174283129297B636F6E737420653D6F2E63686172436F646541742830293B653E3D';
wwv_flow_imp.g_varchar2_table(1057) := '36352626653C3D39302626286F3D60247B537472696E672E66726F6D43686172436F646528652B3332297D3A247B6F2E7375627374722832297D60297D692B3D6E286F2C21302C2131297D72657475726E2061262628692B3D223F222C692B3D6E28612C';
wwv_flow_imp.g_varchar2_table(1058) := '21312C213129292C6C262628692B3D2223222C692B3D743F6C3A6674286C2C21312C213129292C697D66756E6374696F6E2076742865297B7472797B72657475726E206465636F6465555249436F6D706F6E656E742865297D63617463682874297B7265';
wwv_flow_imp.g_varchar2_table(1059) := '7475726E20652E6C656E6774683E333F652E73756273747228302C33292B767428652E737562737472283329293A657D7D636F6E73742043743D2F28255B302D39412D5A612D7A5D5B302D39412D5A612D7A5D292B2F673B66756E6374696F6E20797428';
wwv_flow_imp.g_varchar2_table(1060) := '65297B72657475726E20652E6D61746368284374293F652E7265706C6163652843742C28653D3E767428652929293A657D636C617373204C747B636F6E7374727563746F7228652C74297B746869732E6C696E654E756D6265723D652C746869732E636F';
wwv_flow_imp.g_varchar2_table(1061) := '6C756D6E3D747D7769746828653D746869732E6C696E654E756D6265722C743D746869732E636F6C756D6E297B72657475726E20653D3D3D746869732E6C696E654E756D6265722626743D3D3D746869732E636F6C756D6E3F746869733A6E6577204C74';
wwv_flow_imp.g_varchar2_table(1062) := '28652C74297D64656C746128653D302C743D30297B72657475726E20746869732E7769746828746869732E6C696E654E756D6265722B652C746869732E636F6C756D6E2B74297D657175616C732865297B72657475726E204C742E657175616C73287468';
wwv_flow_imp.g_varchar2_table(1063) := '69732C65297D73746174696320657175616C7328652C74297B72657475726E2165262621747C7C21216526262121742626652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265722626652E636F6C756D6E3D3D3D742E636F6C756D6E7D6973';
wwv_flow_imp.g_varchar2_table(1064) := '4265666F72652865297B72657475726E204C742E69734265666F726528746869732C65297D7374617469632069734265666F726528652C74297B72657475726E20652E6C696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E65';
wwv_flow_imp.g_varchar2_table(1065) := '4E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C742E636F6C756D6E7D69734265666F72654F72457175616C2865297B72657475726E204C742E69734265666F72654F72457175616C28746869732C65297D73746174696320';
wwv_flow_imp.g_varchar2_table(1066) := '69734265666F72654F72457175616C28652C74297B72657475726E20652E6C696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C3D742E636F6C';
wwv_flow_imp.g_varchar2_table(1067) := '756D6E7D73746174696320636F6D7061726528652C74297B636F6E7374206E3D307C652E6C696E654E756D6265722C693D307C742E6C696E654E756D6265723B72657475726E206E3D3D3D693F28307C652E636F6C756D6E292D28307C742E636F6C756D';
wwv_flow_imp.g_varchar2_table(1068) := '6E293A6E2D697D636C6F6E6528297B72657475726E206E6577204C7428746869732E6C696E654E756D6265722C746869732E636F6C756D6E297D746F537472696E6728297B72657475726E2228222B746869732E6C696E654E756D6265722B222C222B74';
wwv_flow_imp.g_varchar2_table(1069) := '6869732E636F6C756D6E2B2229227D737461746963206C6966742865297B72657475726E206E6577204C7428652E6C696E654E756D6265722C652E636F6C756D6E297D73746174696320697349506F736974696F6E2865297B72657475726E2065262622';
wwv_flow_imp.g_varchar2_table(1070) := '6E756D626572223D3D747970656F6620652E6C696E654E756D6265722626226E756D626572223D3D747970656F6620652E636F6C756D6E7D746F4A534F4E28297B72657475726E7B6C696E654E756D6265723A746869732E6C696E654E756D6265722C63';
wwv_flow_imp.g_varchar2_table(1071) := '6F6C756D6E3A746869732E636F6C756D6E7D7D7D636C6173732077747B636F6E7374727563746F7228652C742C6E2C69297B653E6E7C7C653D3D3D6E2626743E693F28746869732E73746172744C696E654E756D6265723D6E2C746869732E7374617274';
wwv_flow_imp.g_varchar2_table(1072) := '436F6C756D6E3D692C746869732E656E644C696E654E756D6265723D652C746869732E656E64436F6C756D6E3D74293A28746869732E73746172744C696E654E756D6265723D652C746869732E7374617274436F6C756D6E3D742C746869732E656E644C';
wwv_flow_imp.g_varchar2_table(1073) := '696E654E756D6265723D6E2C746869732E656E64436F6C756D6E3D69297D6973456D70747928297B72657475726E2077742E6973456D7074792874686973297D737461746963206973456D7074792865297B72657475726E20652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(1074) := '4E756D6265723D3D3D652E656E644C696E654E756D6265722626652E7374617274436F6C756D6E3D3D3D652E656E64436F6C756D6E7D636F6E7461696E73506F736974696F6E2865297B72657475726E2077742E636F6E7461696E73506F736974696F6E';
wwv_flow_imp.g_varchar2_table(1075) := '28746869732C65297D73746174696320636F6E7461696E73506F736974696F6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E65';
wwv_flow_imp.g_varchar2_table(1076) := '4E756D6265727C7C742E6C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E636F6C756D6E3C652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E';
wwv_flow_imp.g_varchar2_table(1077) := '636F6C756D6E3E652E656E64436F6C756D6E297D73746174696320737472696374436F6E7461696E73506F736974696F6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E';
wwv_flow_imp.g_varchar2_table(1078) := '654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E636F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D65';
wwv_flow_imp.g_varchar2_table(1079) := '2E656E644C696E654E756D6265722626742E636F6C756D6E3E3D652E656E64436F6C756D6E297D636F6E7461696E7352616E67652865297B72657475726E2077742E636F6E7461696E7352616E676528746869732C65297D73746174696320636F6E7461';
wwv_flow_imp.g_varchar2_table(1080) := '696E7352616E676528652C74297B72657475726E2128742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172';
wwv_flow_imp.g_varchar2_table(1081) := '744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D62657226';
wwv_flow_imp.g_varchar2_table(1082) := '26742E7374617274436F6C756D6E3C652E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E656E64436F6C756D6E3E652E656E64436F6C756D6E297D737472696374436F6E74';
wwv_flow_imp.g_varchar2_table(1083) := '61696E7352616E67652865297B72657475726E2077742E737472696374436F6E7461696E7352616E676528746869732C65297D73746174696320737472696374436F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C69';
wwv_flow_imp.g_varchar2_table(1084) := '6E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E';
wwv_flow_imp.g_varchar2_table(1085) := '656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C3D652E7374617274436F6C756D6E7C7C';
wwv_flow_imp.g_varchar2_table(1086) := '742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E656E64436F6C756D6E3E3D652E656E64436F6C756D6E297D706C757352616E67652865297B72657475726E2077742E706C757352616E676528746869732C65';
wwv_flow_imp.g_varchar2_table(1087) := '297D73746174696320706C757352616E676528652C74297B6C6574206E2C692C722C733B72657475726E20742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(1088) := '693D742E7374617274436F6C756D6E293A742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C693D4D6174682E6D696E28742E7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(1089) := '2C652E7374617274436F6C756D6E29293A286E3D652E73746172744C696E654E756D6265722C693D652E7374617274436F6C756D6E292C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265723F28723D742E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(1090) := '756D6265722C733D742E656E64436F6C756D6E293A742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265723F28723D742E656E644C696E654E756D6265722C733D4D6174682E6D617828742E656E64436F6C756D6E2C652E65';
wwv_flow_imp.g_varchar2_table(1091) := '6E64436F6C756D6E29293A28723D652E656E644C696E654E756D6265722C733D652E656E64436F6C756D6E292C6E6577207774286E2C692C722C73297D696E7465727365637452616E6765732865297B72657475726E2077742E696E7465727365637452';
wwv_flow_imp.g_varchar2_table(1092) := '616E67657328746869732C65297D73746174696320696E7465727365637452616E67657328652C74297B6C6574206E3D652E73746172744C696E654E756D6265722C693D652E7374617274436F6C756D6E2C723D652E656E644C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(1093) := '733D652E656E64436F6C756D6E3B636F6E7374206F3D742E73746172744C696E654E756D6265722C613D742E7374617274436F6C756D6E2C6C3D742E656E644C696E654E756D6265722C753D742E656E64436F6C756D6E3B72657475726E206E3C6F3F28';
wwv_flow_imp.g_varchar2_table(1094) := '6E3D6F2C693D61293A6E3D3D3D6F262628693D4D6174682E6D617828692C6129292C723E6C3F28723D6C2C733D75293A723D3D3D6C262628733D4D6174682E6D696E28732C7529292C6E3E727C7C6E3D3D3D722626693E733F6E756C6C3A6E6577207774';
wwv_flow_imp.g_varchar2_table(1095) := '286E2C692C722C73297D657175616C7352616E67652865297B72657475726E2077742E657175616C7352616E676528746869732C65297D73746174696320657175616C7352616E676528652C74297B72657475726E2165262621747C7C21216526262121';
wwv_flow_imp.g_varchar2_table(1096) := '742626652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E7374617274436F6C756D6E3D3D3D742E7374617274436F6C756D6E2626652E656E644C696E654E756D6265723D3D3D742E656E644C696E65';
wwv_flow_imp.g_varchar2_table(1097) := '4E756D6265722626652E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E7D676574456E64506F736974696F6E28297B72657475726E2077742E676574456E64506F736974696F6E2874686973297D73746174696320676574456E64506F736974';
wwv_flow_imp.g_varchar2_table(1098) := '696F6E2865297B72657475726E206E6577204C7428652E656E644C696E654E756D6265722C652E656E64436F6C756D6E297D6765745374617274506F736974696F6E28297B72657475726E2077742E6765745374617274506F736974696F6E2874686973';
wwv_flow_imp.g_varchar2_table(1099) := '297D737461746963206765745374617274506F736974696F6E2865297B72657475726E206E6577204C7428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D746F537472696E6728297B72657475726E225B222B746869';
wwv_flow_imp.g_varchar2_table(1100) := '732E73746172744C696E654E756D6265722B222C222B746869732E7374617274436F6C756D6E2B22202D3E20222B746869732E656E644C696E654E756D6265722B222C222B746869732E656E64436F6C756D6E2B225D227D736574456E64506F73697469';
wwv_flow_imp.g_varchar2_table(1101) := '6F6E28652C74297B72657475726E206E657720777428746869732E73746172744C696E654E756D6265722C746869732E7374617274436F6C756D6E2C652C74297D7365745374617274506F736974696F6E28652C74297B72657475726E206E6577207774';
wwv_flow_imp.g_varchar2_table(1102) := '28652C742C746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E297D636F6C6C61707365546F537461727428297B72657475726E2077742E636F6C6C61707365546F53746172742874686973297D73746174696320636F6C';
wwv_flow_imp.g_varchar2_table(1103) := '6C61707365546F53746172742865297B72657475726E206E657720777428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D636F6C6C61';
wwv_flow_imp.g_varchar2_table(1104) := '707365546F456E6428297B72657475726E2077742E636F6C6C61707365546F456E642874686973297D73746174696320636F6C6C61707365546F456E642865297B72657475726E206E657720777428652E656E644C696E654E756D6265722C652E656E64';
wwv_flow_imp.g_varchar2_table(1105) := '436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E297D64656C74612865297B72657475726E206E657720777428746869732E73746172744C696E654E756D6265722B652C746869732E7374617274436F6C756D6E2C74';
wwv_flow_imp.g_varchar2_table(1106) := '6869732E656E644C696E654E756D6265722B652C746869732E656E64436F6C756D6E297D7374617469632066726F6D506F736974696F6E7328652C743D65297B72657475726E206E657720777428652E6C696E654E756D6265722C652E636F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(1107) := '742E6C696E654E756D6265722C742E636F6C756D6E297D737461746963206C6966742865297B72657475726E20653F6E657720777428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1108) := '722C652E656E64436F6C756D6E293A6E756C6C7D7374617469632069734952616E67652865297B72657475726E20652626226E756D626572223D3D747970656F6620652E73746172744C696E654E756D6265722626226E756D626572223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1109) := '6620652E7374617274436F6C756D6E2626226E756D626572223D3D747970656F6620652E656E644C696E654E756D6265722626226E756D626572223D3D747970656F6620652E656E64436F6C756D6E7D73746174696320617265496E7465727365637469';
wwv_flow_imp.g_varchar2_table(1110) := '6E674F72546F756368696E6728652C74297B72657475726E2128652E656E644C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E';
wwv_flow_imp.g_varchar2_table(1111) := '656E64436F6C756D6E3C742E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E65';
wwv_flow_imp.g_varchar2_table(1112) := '6E64436F6C756D6E3C652E7374617274436F6C756D6E297D73746174696320617265496E74657273656374696E6728652C74297B72657475726E2128652E656E644C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E64';
wwv_flow_imp.g_varchar2_table(1113) := '4C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E656E64436F6C756D6E3C3D742E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E64';
wwv_flow_imp.g_varchar2_table(1114) := '4C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E656E64436F6C756D6E3C3D652E7374617274436F6C756D6E297D73746174696320636F6D7061726552616E6765735573696E6753746172747328652C74297B696628';
wwv_flow_imp.g_varchar2_table(1115) := '65262674297B636F6E7374206E3D307C652E73746172744C696E654E756D6265722C693D307C742E73746172744C696E654E756D6265723B6966286E3D3D3D69297B636F6E7374206E3D307C652E7374617274436F6C756D6E2C693D307C742E73746172';
wwv_flow_imp.g_varchar2_table(1116) := '74436F6C756D6E3B6966286E3D3D3D69297B636F6E7374206E3D307C652E656E644C696E654E756D6265722C693D307C742E656E644C696E654E756D6265723B72657475726E206E3D3D3D693F28307C652E656E64436F6C756D6E292D28307C742E656E';
wwv_flow_imp.g_varchar2_table(1117) := '64436F6C756D6E293A6E2D697D72657475726E206E2D697D72657475726E206E2D697D72657475726E28653F313A30292D28743F313A30297D73746174696320636F6D7061726552616E6765735573696E67456E647328652C74297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(1118) := '2E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265723F652E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E3F652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E73';
wwv_flow_imp.g_varchar2_table(1119) := '74617274436F6C756D6E2D742E7374617274436F6C756D6E3A652E73746172744C696E654E756D6265722D742E73746172744C696E654E756D6265723A652E656E64436F6C756D6E2D742E656E64436F6C756D6E3A652E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(1120) := '2D742E656E644C696E654E756D6265727D737461746963207370616E734D756C7469706C654C696E65732865297B72657475726E20652E656E644C696E654E756D6265723E652E73746172744C696E654E756D6265727D746F4A534F4E28297B72657475';
wwv_flow_imp.g_varchar2_table(1121) := '726E20746869737D7D766172204E743B66756E6374696F6E20457428652C74297B72657475726E286E2C69293D3E742865286E292C65286929297D2166756E6374696F6E2865297B652E69734C6573735468616E3D66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(1122) := '75726E20653C307D2C652E69734C6573735468616E4F72457175616C3D66756E6374696F6E2865297B72657475726E20653C3D307D2C652E6973477265617465725468616E3D66756E6374696F6E2865297B72657475726E20653E307D2C652E69734E65';
wwv_flow_imp.g_varchar2_table(1123) := '69746865724C6573734F72477265617465725468616E3D66756E6374696F6E2865297B72657475726E20303D3D3D657D2C652E677265617465725468616E3D312C652E6C6573735468616E3D2D312C652E6E6569746865724C6573734F72477265617465';
wwv_flow_imp.g_varchar2_table(1124) := '725468616E3D307D284E747C7C284E743D7B7D29293B636F6E73742053743D28652C74293D3E652D743B636C6173732052747B636F6E7374727563746F722865297B746869732E697465726174653D657D746F417272617928297B636F6E737420653D5B';
wwv_flow_imp.g_varchar2_table(1125) := '5D3B72657475726E20746869732E697465726174652828743D3E28652E707573682874292C21302929292C657D66696C7465722865297B72657475726E206E65772052742828743D3E746869732E6974657261746528286E3D3E2165286E297C7C74286E';
wwv_flow_imp.g_varchar2_table(1126) := '29292929297D6D61702865297B72657475726E206E65772052742828743D3E746869732E6974657261746528286E3D3E742865286E2929292929297D66696E644C6173742865297B6C657420743B72657475726E20746869732E6974657261746528286E';
wwv_flow_imp.g_varchar2_table(1127) := '3D3E2865286E29262628743D6E292C21302929292C747D66696E644C6173744D617842792865297B6C657420742C6E3D21303B72657475726E20746869732E697465726174652828693D3E28286E7C7C4E742E6973477265617465725468616E28652869';
wwv_flow_imp.g_varchar2_table(1128) := '2C742929292626286E3D21312C743D69292C21302929292C747D7D66756E6374696F6E2041742865297B72657475726E20653C303F303A653E3235353F3235353A307C657D66756E6374696F6E2078742865297B72657475726E20653C303F303A653E34';
wwv_flow_imp.g_varchar2_table(1129) := '3239343936373239353F343239343936373239353A307C657D52742E656D7074793D6E65772052742828653D3E7B7D29293B636C617373204D747B636F6E7374727563746F722865297B746869732E76616C7565733D652C746869732E70726566697853';
wwv_flow_imp.g_varchar2_table(1130) := '756D3D6E65772055696E743332417272617928652E6C656E677468292C746869732E70726566697853756D56616C6964496E6465783D6E657720496E74333241727261792831292C746869732E70726566697853756D56616C6964496E6465785B305D3D';
wwv_flow_imp.g_varchar2_table(1131) := '2D317D696E7365727456616C75657328652C74297B653D78742865293B636F6E7374206E3D746869732E76616C7565732C693D746869732E70726566697853756D2C723D742E6C656E6774683B72657475726E2030213D3D72262628746869732E76616C';
wwv_flow_imp.g_varchar2_table(1132) := '7565733D6E65772055696E7433324172726179286E2E6C656E6774682B72292C746869732E76616C7565732E736574286E2E737562617272617928302C65292C30292C746869732E76616C7565732E736574286E2E73756261727261792865292C652B72';
wwv_flow_imp.g_varchar2_table(1133) := '292C746869732E76616C7565732E73657428742C65292C652D313C746869732E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C746869732E7072656669';
wwv_flow_imp.g_varchar2_table(1134) := '7853756D3D6E65772055696E743332417272617928746869732E76616C7565732E6C656E677468292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853756D2E73657428692E737562617272';
wwv_flow_imp.g_varchar2_table(1135) := '617928302C746869732E70726566697853756D56616C6964496E6465785B305D2B3129292C2130297D73657456616C756528652C74297B72657475726E20653D78742865292C743D78742874292C746869732E76616C7565735B655D213D3D7426262874';
wwv_flow_imp.g_varchar2_table(1136) := '6869732E76616C7565735B655D3D742C652D313C746869732E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C2130297D72656D6F766556616C75657328';
wwv_flow_imp.g_varchar2_table(1137) := '652C74297B653D78742865292C743D78742874293B636F6E7374206E3D746869732E76616C7565732C693D746869732E70726566697853756D3B696628653E3D6E2E6C656E6774682972657475726E21313B636F6E737420723D6E2E6C656E6774682D65';
wwv_flow_imp.g_varchar2_table(1138) := '3B72657475726E20743E3D72262628743D72292C30213D3D74262628746869732E76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682D74292C746869732E76616C7565732E736574286E2E737562617272617928302C65292C';
wwv_flow_imp.g_varchar2_table(1139) := '30292C746869732E76616C7565732E736574286E2E737562617272617928652B74292C65292C746869732E70726566697853756D3D6E65772055696E743332417272617928746869732E76616C7565732E6C656E677468292C652D313C746869732E7072';
wwv_flow_imp.g_varchar2_table(1140) := '6566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853';
wwv_flow_imp.g_varchar2_table(1141) := '756D2E73657428692E737562617272617928302C746869732E70726566697853756D56616C6964496E6465785B305D2B3129292C2130297D676574546F74616C53756D28297B72657475726E20303D3D3D746869732E76616C7565732E6C656E6774683F';
wwv_flow_imp.g_varchar2_table(1142) := '303A746869732E5F67657450726566697853756D28746869732E76616C7565732E6C656E6774682D31297D67657450726566697853756D2865297B72657475726E20653C303F303A28653D78742865292C746869732E5F67657450726566697853756D28';
wwv_flow_imp.g_varchar2_table(1143) := '6529297D5F67657450726566697853756D2865297B696628653C3D746869732E70726566697853756D56616C6964496E6465785B305D2972657475726E20746869732E70726566697853756D5B655D3B6C657420743D746869732E70726566697853756D';
wwv_flow_imp.g_varchar2_table(1144) := '56616C6964496E6465785B305D2B313B303D3D3D74262628746869732E70726566697853756D5B305D3D746869732E76616C7565735B305D2C742B2B292C653E3D746869732E76616C7565732E6C656E677468262628653D746869732E76616C7565732E';
wwv_flow_imp.g_varchar2_table(1145) := '6C656E6774682D31293B666F72286C6574206E3D743B6E3C3D653B6E2B2B29746869732E70726566697853756D5B6E5D3D746869732E70726566697853756D5B6E2D315D2B746869732E76616C7565735B6E5D3B72657475726E20746869732E70726566';
wwv_flow_imp.g_varchar2_table(1146) := '697853756D56616C6964496E6465785B305D3D4D6174682E6D617828746869732E70726566697853756D56616C6964496E6465785B305D2C65292C746869732E70726566697853756D5B655D7D676574496E6465784F662865297B653D4D6174682E666C';
wwv_flow_imp.g_varchar2_table(1147) := '6F6F722865292C746869732E676574546F74616C53756D28293B6C657420743D302C6E3D746869732E76616C7565732E6C656E6774682D312C693D302C723D302C733D303B666F72283B743C3D6E3B29696628693D742B286E2D74292F327C302C723D74';
wwv_flow_imp.g_varchar2_table(1148) := '6869732E70726566697853756D5B695D2C733D722D746869732E76616C7565735B695D2C653C73296E3D692D313B656C73657B6966282128653E3D722929627265616B3B743D692B317D72657475726E206E6577206B7428692C652D73297D7D636C6173';
wwv_flow_imp.g_varchar2_table(1149) := '73206B747B636F6E7374727563746F7228652C74297B746869732E696E6465783D652C746869732E72656D61696E6465723D742C746869732E5F70726566697853756D496E6465784F66526573756C744272616E643D766F696420302C746869732E696E';
wwv_flow_imp.g_varchar2_table(1150) := '6465783D652C746869732E72656D61696E6465723D747D7D636C617373204F747B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F7572693D652C746869732E5F6C696E65733D742C746869732E5F656F6C3D6E2C746869732E5F7665';
wwv_flow_imp.g_varchar2_table(1151) := '7273696F6E49643D692C746869732E5F6C696E655374617274733D6E756C6C2C746869732E5F6361636865645465787456616C75653D6E756C6C7D646973706F736528297B746869732E5F6C696E65732E6C656E6774683D307D6765742076657273696F';
wwv_flow_imp.g_varchar2_table(1152) := '6E28297B72657475726E20746869732E5F76657273696F6E49647D6765745465787428297B72657475726E206E756C6C3D3D3D746869732E5F6361636865645465787456616C7565262628746869732E5F6361636865645465787456616C75653D746869';
wwv_flow_imp.g_varchar2_table(1153) := '732E5F6C696E65732E6A6F696E28746869732E5F656F6C29292C746869732E5F6361636865645465787456616C75657D6F6E4576656E74732865297B652E656F6C2626652E656F6C213D3D746869732E5F656F6C262628746869732E5F656F6C3D652E65';
wwv_flow_imp.g_varchar2_table(1154) := '6F6C2C746869732E5F6C696E655374617274733D6E756C6C293B636F6E737420743D652E6368616E6765733B666F7228636F6E73742065206F66207429746869732E5F61636365707444656C65746552616E676528652E72616E6765292C746869732E5F';
wwv_flow_imp.g_varchar2_table(1155) := '616363657074496E7365727454657874286E6577204C7428652E72616E67652E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E292C652E74657874293B746869732E5F76657273696F6E49643D652E7665727369';
wwv_flow_imp.g_varchar2_table(1156) := '6F6E49642C746869732E5F6361636865645465787456616C75653D6E756C6C7D5F656E737572654C696E6553746172747328297B69662821746869732E5F6C696E65537461727473297B636F6E737420653D746869732E5F656F6C2E6C656E6774682C74';
wwv_flow_imp.g_varchar2_table(1157) := '3D746869732E5F6C696E65732E6C656E6774682C6E3D6E65772055696E74333241727261792874293B666F72286C657420693D303B693C743B692B2B296E5B695D3D746869732E5F6C696E65735B695D2E6C656E6774682B653B746869732E5F6C696E65';
wwv_flow_imp.g_varchar2_table(1158) := '5374617274733D6E6577204D74286E297D7D5F7365744C696E655465787428652C74297B746869732E5F6C696E65735B655D3D742C746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E73657456616C756528652C74';
wwv_flow_imp.g_varchar2_table(1159) := '6869732E5F6C696E65735B655D2E6C656E6774682B746869732E5F656F6C2E6C656E677468297D5F61636365707444656C65746552616E67652865297B696628652E73746172744C696E654E756D626572213D3D652E656E644C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(1160) := '746869732E5F7365744C696E655465787428652E73746172744C696E654E756D6265722D312C746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B';
wwv_flow_imp.g_varchar2_table(1161) := '746869732E5F6C696E65735B652E656E644C696E654E756D6265722D315D2E737562737472696E6728652E656E64436F6C756D6E2D3129292C746869732E5F6C696E65732E73706C69636528652E73746172744C696E654E756D6265722C652E656E644C';
wwv_flow_imp.g_varchar2_table(1162) := '696E654E756D6265722D652E73746172744C696E654E756D626572292C746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E72656D6F766556616C75657328652E73746172744C696E654E756D6265722C652E656E64';
wwv_flow_imp.g_varchar2_table(1163) := '4C696E654E756D6265722D652E73746172744C696E654E756D626572293B656C73657B696628652E7374617274436F6C756D6E3D3D3D652E656E64436F6C756D6E2972657475726E3B746869732E5F7365744C696E655465787428652E73746172744C69';
wwv_flow_imp.g_varchar2_table(1164) := '6E654E756D6265722D312C746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1165) := '65722D315D2E737562737472696E6728652E656E64436F6C756D6E2D3129297D7D5F616363657074496E736572745465787428652C74297B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D742E73706C6974282F5C725C6E';
wwv_flow_imp.g_varchar2_table(1166) := '7C5C727C5C6E2F293B696628313D3D3D6E2E6C656E6774682972657475726E20766F696420746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E7375';
wwv_flow_imp.g_varchar2_table(1167) := '62737472696E6728302C652E636F6C756D6E2D31292B6E5B305D2B746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728652E636F6C756D6E2D3129293B6E5B6E2E6C656E6774682D315D2B3D746869732E5F6C';
wwv_flow_imp.g_varchar2_table(1168) := '696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728652E636F6C756D6E2D31292C746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(1169) := '2D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B305D293B636F6E737420693D6E65772055696E7433324172726179286E2E6C656E6774682D31293B666F72286C657420743D313B743C6E2E6C656E6774683B742B2B29746869';
wwv_flow_imp.g_varchar2_table(1170) := '732E5F6C696E65732E73706C69636528652E6C696E654E756D6265722B742D312C302C6E5B745D292C695B742D315D3D6E5B745D2E6C656E6774682B746869732E5F656F6C2E6C656E6774683B746869732E5F6C696E655374617274732626746869732E';
wwv_flow_imp.g_varchar2_table(1171) := '5F6C696E655374617274732E696E7365727456616C75657328652E6C696E654E756D6265722C69297D7D636F6E73742054743D66756E6374696F6E28653D2222297B6C657420743D22282D3F5C5C642A5C5C2E5C5C645C5C772A297C285B5E223B666F72';
wwv_flow_imp.g_varchar2_table(1172) := '28636F6E7374206E206F6622607E21402324255E262A28292D3D2B5B7B5D7D5C5C7C3B3A275C222C2E3C3E2F3F2229652E696E6465784F66286E293E3D307C7C28742B3D225C5C222B6E293B72657475726E20742B3D225C5C735D2B29222C6E65772052';
wwv_flow_imp.g_varchar2_table(1173) := '656745787028742C226722297D28293B66756E6374696F6E2049742865297B6C657420743D54743B6966286526266520696E7374616E63656F662052656745787029696628652E676C6F62616C29743D653B656C73657B6C6574206E3D2267223B652E69';
wwv_flow_imp.g_varchar2_table(1174) := '676E6F7265436173652626286E2B3D226922292C652E6D756C74696C696E652626286E2B3D226D22292C652E756E69636F64652626286E2B3D227522292C743D6E65772052656745787028652E736F757263652C6E297D72657475726E20742E6C617374';
wwv_flow_imp.g_varchar2_table(1175) := '496E6465783D302C747D636F6E73742050743D6E6577205F3B66756E6374696F6E20447428652C742C6E2C692C72297B696628743D49742874292C727C7C28723D6C2E666972737428507429292C6E2E6C656E6774683E722E6D61784C656E297B6C6574';
wwv_flow_imp.g_varchar2_table(1176) := '20733D652D722E6D61784C656E2F323B72657475726E20733C303F733D303A692B3D732C447428652C742C6E3D6E2E737562737472696E6728732C652B722E6D61784C656E2F32292C692C72297D636F6E737420733D446174652E6E6F7728292C6F3D65';
wwv_flow_imp.g_varchar2_table(1177) := '2D312D693B6C657420613D2D312C753D6E756C6C3B666F72286C657420653D313B2128446174652E6E6F7728292D733E3D722E74696D65427564676574293B652B2B297B636F6E737420693D6F2D722E77696E646F7753697A652A653B742E6C61737449';
wwv_flow_imp.g_varchar2_table(1178) := '6E6465783D4D6174682E6D617828302C69293B636F6E737420733D467428742C6E2C6F2C61293B696628217326267529627265616B3B696628753D732C693C3D3029627265616B3B613D697D69662875297B636F6E737420653D7B776F72643A755B305D';
wwv_flow_imp.g_varchar2_table(1179) := '2C7374617274436F6C756D6E3A692B312B752E696E6465782C656E64436F6C756D6E3A692B312B752E696E6465782B755B305D2E6C656E6774687D3B72657475726E20742E6C617374496E6465783D302C657D72657475726E206E756C6C7D66756E6374';
wwv_flow_imp.g_varchar2_table(1180) := '696F6E20467428652C742C6E2C69297B6C657420723B666F72283B723D652E657865632874293B297B636F6E737420743D722E696E6465787C7C303B696628743C3D6E2626652E6C617374496E6465783E3D6E2972657475726E20723B696628693E3026';
wwv_flow_imp.g_varchar2_table(1181) := '26743E692972657475726E206E756C6C7D72657475726E206E756C6C7D50742E756E7368696674287B6D61784C656E3A3165332C77696E646F7753697A653A31352C74696D654275646765743A3135307D293B636C617373204B747B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(1182) := '746F722865297B636F6E737420743D41742865293B746869732E5F64656661756C7456616C75653D742C746869732E5F61736369694D61703D4B742E5F63726561746541736369694D61702874292C746869732E5F6D61703D6E6577204D61707D737461';
wwv_flow_imp.g_varchar2_table(1183) := '746963205F63726561746541736369694D61702865297B636F6E737420743D6E65772055696E7438417272617928323536293B72657475726E20742E66696C6C2865292C747D73657428652C74297B636F6E7374206E3D41742874293B653E3D30262665';
wwv_flow_imp.g_varchar2_table(1184) := '3C3235363F746869732E5F61736369694D61705B655D3D6E3A746869732E5F6D61702E73657428652C6E297D6765742865297B72657475726E20653E3D302626653C3235363F746869732E5F61736369694D61705B655D3A746869732E5F6D61702E6765';
wwv_flow_imp.g_varchar2_table(1185) := '742865297C7C746869732E5F64656661756C7456616C75657D636C65617228297B746869732E5F61736369694D61702E66696C6C28746869732E5F64656661756C7456616C7565292C746869732E5F6D61702E636C65617228297D7D636C617373207174';
wwv_flow_imp.g_varchar2_table(1186) := '7B636F6E7374727563746F7228652C742C6E297B636F6E737420693D6E65772055696E7438417272617928652A74293B666F72286C657420723D302C733D652A743B723C733B722B2B29695B725D3D6E3B746869732E5F646174613D692C746869732E72';
wwv_flow_imp.g_varchar2_table(1187) := '6F77733D652C746869732E636F6C733D747D67657428652C74297B72657475726E20746869732E5F646174615B652A746869732E636F6C732B745D7D73657428652C742C6E297B746869732E5F646174615B652A746869732E636F6C732B745D3D6E7D7D';
wwv_flow_imp.g_varchar2_table(1188) := '636C6173732056747B636F6E7374727563746F722865297B6C657420743D302C6E3D303B666F72286C657420693D302C723D652E6C656E6774683B693C723B692B2B297B636F6E73745B722C732C6F5D3D655B695D3B733E74262628743D73292C723E6E';
wwv_flow_imp.g_varchar2_table(1189) := '2626286E3D72292C6F3E6E2626286E3D6F297D742B2B2C6E2B2B3B636F6E737420693D6E6577207174286E2C742C30293B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E73745B6E2C722C735D3D655B745D3B69';
wwv_flow_imp.g_varchar2_table(1190) := '2E736574286E2C722C73297D746869732E5F7374617465733D692C746869732E5F6D617843686172436F64653D747D6E657874537461746528652C74297B72657475726E20743C307C7C743E3D746869732E5F6D617843686172436F64653F303A746869';
wwv_flow_imp.g_varchar2_table(1191) := '732E5F7374617465732E67657428652C74297D7D6C65742042743D6E756C6C2C55743D6E756C6C3B636C617373207A747B737461746963205F6372656174654C696E6B28652C742C6E2C692C72297B6C657420733D722D313B646F7B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(1192) := '742E63686172436F646541742873293B69662832213D3D652E676574286E2929627265616B3B732D2D7D7768696C6528733E69293B696628693E30297B636F6E737420653D742E63686172436F6465417428692D31292C6E3D742E63686172436F646541';
wwv_flow_imp.g_varchar2_table(1193) := '742873293B2834303D3D3D65262634313D3D3D6E7C7C39313D3D3D65262639333D3D3D6E7C7C3132333D3D3D6526263132353D3D3D6E292626732D2D7D72657475726E7B72616E67653A7B73746172744C696E654E756D6265723A6E2C7374617274436F';
wwv_flow_imp.g_varchar2_table(1194) := '6C756D6E3A692B312C656E644C696E654E756D6265723A6E2C656E64436F6C756D6E3A732B327D2C75726C3A742E737562737472696E6728692C732B31297D7D73746174696320636F6D707574654C696E6B7328652C743D66756E6374696F6E28297B72';
wwv_flow_imp.g_varchar2_table(1195) := '657475726E206E756C6C3D3D3D427426262842743D6E6577205674285B5B312C3130342C325D2C5B312C37322C325D2C5B312C3130322C365D2C5B312C37302C365D2C5B322C3131362C335D2C5B322C38342C335D2C5B332C3131362C345D2C5B332C38';
wwv_flow_imp.g_varchar2_table(1196) := '342C345D2C5B342C3131322C355D2C5B342C38302C355D2C5B352C3131352C395D2C5B352C38332C395D2C5B352C35382C31305D2C5B362C3130352C375D2C5B362C37332C375D2C5B372C3130382C385D2C5B372C37362C385D2C5B382C3130312C395D';
wwv_flow_imp.g_varchar2_table(1197) := '2C5B382C36392C395D2C5B392C35382C31305D2C5B31302C34372C31315D2C5B31312C34372C31325D5D29292C42747D2829297B636F6E7374206E3D66756E6374696F6E28297B6966286E756C6C3D3D3D5574297B55743D6E6577204B742830293B636F';
wwv_flow_imp.g_varchar2_table(1198) := '6E737420653D22205C743C3E275C22E38081E38082EFBDA1EFBDA4EFBC8CEFBC8EEFBC9AEFBC9BE28098E38088E3808CE3808EE38094EFBC88EFBCBBEFBD9BEFBDA2EFBDA3EFBD9DEFBCBDEFBC89E38095E3808FE3808DE38089E28099EFBD80EFBD9EE2';
wwv_flow_imp.g_varchar2_table(1199) := '80A6223B666F72286C657420743D303B743C652E6C656E6774683B742B2B2955742E73657428652E63686172436F646541742874292C31293B636F6E737420743D222E2C3B3A223B666F72286C657420653D303B653C742E6C656E6774683B652B2B2955';
wwv_flow_imp.g_varchar2_table(1200) := '742E73657428742E63686172436F646541742865292C32297D72657475726E2055747D28292C693D5B5D3B666F72286C657420723D312C733D652E6765744C696E65436F756E7428293B723C3D733B722B2B297B636F6E737420733D652E6765744C696E';
wwv_flow_imp.g_varchar2_table(1201) := '65436F6E74656E742872292C6F3D732E6C656E6774683B6C657420613D302C6C3D302C753D302C683D312C633D21312C643D21312C6D3D21312C673D21313B666F72283B613C6F3B297B6C657420653D21313B636F6E7374206F3D732E63686172436F64';
wwv_flow_imp.g_varchar2_table(1202) := '6541742861293B69662831333D3D3D68297B6C657420743B737769746368286F297B636173652034303A633D21302C743D303B627265616B3B636173652034313A743D633F303A313B627265616B3B636173652039313A6D3D21302C643D21302C743D30';
wwv_flow_imp.g_varchar2_table(1203) := '3B627265616B3B636173652039333A6D3D21312C743D643F303A313B627265616B3B63617365203132333A673D21302C743D303B627265616B3B63617365203132353A743D673F303A313B627265616B3B636173652033393A636173652033343A636173';
wwv_flow_imp.g_varchar2_table(1204) := '652039363A743D753D3D3D6F3F313A33393D3D3D757C7C33343D3D3D757C7C39363D3D3D753F303A313B627265616B3B636173652034323A743D34323D3D3D753F313A303B627265616B3B63617365203132343A743D3132343D3D3D753F313A303B6272';
wwv_flow_imp.g_varchar2_table(1205) := '65616B3B636173652033323A743D6D3F303A313B627265616B3B64656661756C743A743D6E2E676574286F297D313D3D3D74262628692E70757368287A742E5F6372656174654C696E6B286E2C732C722C6C2C6129292C653D2130297D656C7365206966';
wwv_flow_imp.g_varchar2_table(1206) := '2831323D3D3D68297B6C657420743B39313D3D3D6F3F28643D21302C743D30293A743D6E2E676574286F292C313D3D3D743F653D21303A683D31337D656C736520683D742E6E657874537461746528682C6F292C303D3D3D68262628653D2130293B6526';
wwv_flow_imp.g_varchar2_table(1207) := '2628683D312C633D21312C643D21312C673D21312C6C3D612B312C753D6F292C612B2B7D31333D3D3D682626692E70757368287A742E5F6372656174654C696E6B286E2C732C722C6C2C6F29297D72657475726E20697D7D636C6173732048747B636F6E';
wwv_flow_imp.g_varchar2_table(1208) := '7374727563746F7228297B746869732E5F64656661756C7456616C75655365743D5B5B2274727565222C2266616C7365225D2C5B2254727565222C2246616C7365225D2C5B2250726976617465222C225075626C6963222C22467269656E64222C225265';
wwv_flow_imp.g_varchar2_table(1209) := '61644F6E6C79222C225061727469616C222C2250726F746563746564222C2257726974654F6E6C79225D2C5B227075626C6963222C2270726F746563746564222C2270726976617465225D5D7D6E6176696761746556616C756553657428652C742C6E2C';
wwv_flow_imp.g_varchar2_table(1210) := '692C72297B69662865262674297B636F6E7374206E3D746869732E646F4E6176696761746556616C756553657428742C72293B6966286E2972657475726E7B72616E67653A652C76616C75653A6E7D7D6966286E262669297B636F6E737420653D746869';
wwv_flow_imp.g_varchar2_table(1211) := '732E646F4E6176696761746556616C756553657428692C72293B696628652972657475726E7B72616E67653A6E2C76616C75653A657D7D72657475726E206E756C6C7D646F4E6176696761746556616C756553657428652C74297B636F6E7374206E3D74';
wwv_flow_imp.g_varchar2_table(1212) := '6869732E6E756D6265725265706C61636528652C74293B72657475726E206E756C6C213D3D6E3F6E3A746869732E746578745265706C61636528652C74297D6E756D6265725265706C61636528652C74297B636F6E7374206E3D4D6174682E706F772831';
wwv_flow_imp.g_varchar2_table(1213) := '302C652E6C656E6774682D28652E6C617374496E6465784F6628222E22292B3129293B6C657420693D4E756D6265722865293B636F6E737420723D7061727365466C6F61742865293B72657475726E2069734E614E2869297C7C69734E614E2872297C7C';
wwv_flow_imp.g_varchar2_table(1214) := '69213D3D723F6E756C6C3A30213D3D697C7C743F28693D4D6174682E666C6F6F7228692A6E292C692B3D743F6E3A2D6E2C537472696E6728692F6E29293A6E756C6C7D746578745265706C61636528652C74297B72657475726E20746869732E76616C75';
wwv_flow_imp.g_varchar2_table(1215) := '65536574735265706C61636528746869732E5F64656661756C7456616C75655365742C652C74297D76616C7565536574735265706C61636528652C742C6E297B6C657420693D6E756C6C3B666F72286C657420723D302C733D652E6C656E6774683B6E75';
wwv_flow_imp.g_varchar2_table(1216) := '6C6C3D3D3D692626723C733B722B2B29693D746869732E76616C75655365745265706C61636528655B725D2C742C6E293B72657475726E20697D76616C75655365745265706C61636528652C742C6E297B6C657420693D652E696E6465784F662874293B';
wwv_flow_imp.g_varchar2_table(1217) := '72657475726E20693E3D303F28692B3D6E3F313A2D312C693C303F693D652E6C656E6774682D313A69253D652E6C656E6774682C655B695D293A6E756C6C7D7D48742E494E5354414E43453D6E65772048743B636F6E73742057743D4F626A6563742E66';
wwv_flow_imp.g_varchar2_table(1218) := '7265657A65282866756E6374696F6E28652C74297B636F6E7374206E3D73657454696D656F757428652E62696E642874292C30293B72657475726E7B646973706F736528297B636C65617254696D656F7574286E297D7D7D29293B7661722024743B2166';
wwv_flow_imp.g_varchar2_table(1219) := '756E6374696F6E2865297B652E697343616E63656C6C6174696F6E546F6B656E3D66756E6374696F6E2874297B72657475726E20743D3D3D652E4E6F6E657C7C743D3D3D652E43616E63656C6C65647C7C7420696E7374616E63656F66206A747C7C2128';
wwv_flow_imp.g_varchar2_table(1220) := '21747C7C226F626A65637422213D747970656F66207429262622626F6F6C65616E223D3D747970656F6620742E697343616E63656C6C6174696F6E52657175657374656426262266756E6374696F6E223D3D747970656F6620742E6F6E43616E63656C6C';
wwv_flow_imp.g_varchar2_table(1221) := '6174696F6E5265717565737465647D2C652E4E6F6E653D4F626A6563742E667265657A65287B697343616E63656C6C6174696F6E5265717565737465643A21312C6F6E43616E63656C6C6174696F6E5265717565737465643A792E4E6F6E657D292C652E';
wwv_flow_imp.g_varchar2_table(1222) := '43616E63656C6C65643D4F626A6563742E667265657A65287B697343616E63656C6C6174696F6E5265717565737465643A21302C6F6E43616E63656C6C6174696F6E5265717565737465643A57747D297D2824747C7C2824743D7B7D29293B636C617373';
wwv_flow_imp.g_varchar2_table(1223) := '206A747B636F6E7374727563746F7228297B746869732E5F697343616E63656C6C65643D21312C746869732E5F656D69747465723D6E756C6C7D63616E63656C28297B746869732E5F697343616E63656C6C65647C7C28746869732E5F697343616E6365';
wwv_flow_imp.g_varchar2_table(1224) := '6C6C65643D21302C746869732E5F656D6974746572262628746869732E5F656D69747465722E6669726528766F69642030292C746869732E646973706F7365282929297D67657420697343616E63656C6C6174696F6E52657175657374656428297B7265';
wwv_flow_imp.g_varchar2_table(1225) := '7475726E20746869732E5F697343616E63656C6C65647D676574206F6E43616E63656C6C6174696F6E52657175657374656428297B72657475726E20746869732E5F697343616E63656C6C65643F57743A28746869732E5F656D69747465727C7C287468';
wwv_flow_imp.g_varchar2_table(1226) := '69732E5F656D69747465723D6E65772053292C746869732E5F656D69747465722E6576656E74297D646973706F736528297B746869732E5F656D6974746572262628746869732E5F656D69747465722E646973706F736528292C746869732E5F656D6974';
wwv_flow_imp.g_varchar2_table(1227) := '7465723D6E756C6C297D7D636C6173732047747B636F6E7374727563746F7228297B746869732E5F6B6579436F6465546F5374723D5B5D2C746869732E5F737472546F4B6579436F64653D4F626A6563742E637265617465286E756C6C297D646566696E';
wwv_flow_imp.g_varchar2_table(1228) := '6528652C74297B746869732E5F6B6579436F6465546F5374725B655D3D742C746869732E5F737472546F4B6579436F64655B742E746F4C6F7765724361736528295D3D657D6B6579436F6465546F5374722865297B72657475726E20746869732E5F6B65';
wwv_flow_imp.g_varchar2_table(1229) := '79436F6465546F5374725B655D7D737472546F4B6579436F64652865297B72657475726E20746869732E5F737472546F4B6579436F64655B652E746F4C6F7765724361736528295D7C7C307D7D636F6E73742051743D6E65772047742C58743D6E657720';
wwv_flow_imp.g_varchar2_table(1230) := '47742C4A743D6E65772047742C59743D6E657720417272617928323330292C5A743D7B7D2C656E3D5B5D2C746E3D4F626A6563742E637265617465286E756C6C292C6E6E3D4F626A6563742E637265617465286E756C6C292C726E3D5B5D2C736E3D5B5D';
wwv_flow_imp.g_varchar2_table(1231) := '3B666F72286C657420653D303B653C3D3139333B652B2B29726E5B655D3D2D313B666F72286C657420653D303B653C3D3133323B652B2B29736E5B655D3D2D313B766172206F6E3B2166756E6374696F6E28297B636F6E737420653D22222C743D5B5B31';
wwv_flow_imp.g_varchar2_table(1232) := '2C302C224E6F6E65222C302C22756E6B6E6F776E222C302C22564B5F554E4B4E4F574E222C652C655D2C5B312C312C224879706572222C302C652C302C652C652C655D2C5B312C322C225375706572222C302C652C302C652C652C655D2C5B312C332C22';
wwv_flow_imp.g_varchar2_table(1233) := '466E222C302C652C302C652C652C655D2C5B312C342C22466E4C6F636B222C302C652C302C652C652C655D2C5B312C352C2253757370656E64222C302C652C302C652C652C655D2C5B312C362C22526573756D65222C302C652C302C652C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(1234) := '312C372C22547572626F222C302C652C302C652C652C655D2C5B312C382C22536C656570222C302C652C302C22564B5F534C454550222C652C655D2C5B312C392C2257616B655570222C302C652C302C652C652C655D2C5B302C31302C224B657941222C';
wwv_flow_imp.g_varchar2_table(1235) := '33312C2241222C36352C22564B5F41222C652C655D2C5B302C31312C224B657942222C33322C2242222C36362C22564B5F42222C652C655D2C5B302C31322C224B657943222C33332C2243222C36372C22564B5F43222C652C655D2C5B302C31332C224B';
wwv_flow_imp.g_varchar2_table(1236) := '657944222C33342C2244222C36382C22564B5F44222C652C655D2C5B302C31342C224B657945222C33352C2245222C36392C22564B5F45222C652C655D2C5B302C31352C224B657946222C33362C2246222C37302C22564B5F46222C652C655D2C5B302C';
wwv_flow_imp.g_varchar2_table(1237) := '31362C224B657947222C33372C2247222C37312C22564B5F47222C652C655D2C5B302C31372C224B657948222C33382C2248222C37322C22564B5F48222C652C655D2C5B302C31382C224B657949222C33392C2249222C37332C22564B5F49222C652C65';
wwv_flow_imp.g_varchar2_table(1238) := '5D2C5B302C31392C224B65794A222C34302C224A222C37342C22564B5F4A222C652C655D2C5B302C32302C224B65794B222C34312C224B222C37352C22564B5F4B222C652C655D2C5B302C32312C224B65794C222C34322C224C222C37362C22564B5F4C';
wwv_flow_imp.g_varchar2_table(1239) := '222C652C655D2C5B302C32322C224B65794D222C34332C224D222C37372C22564B5F4D222C652C655D2C5B302C32332C224B65794E222C34342C224E222C37382C22564B5F4E222C652C655D2C5B302C32342C224B65794F222C34352C224F222C37392C';
wwv_flow_imp.g_varchar2_table(1240) := '22564B5F4F222C652C655D2C5B302C32352C224B657950222C34362C2250222C38302C22564B5F50222C652C655D2C5B302C32362C224B657951222C34372C2251222C38312C22564B5F51222C652C655D2C5B302C32372C224B657952222C34382C2252';
wwv_flow_imp.g_varchar2_table(1241) := '222C38322C22564B5F52222C652C655D2C5B302C32382C224B657953222C34392C2253222C38332C22564B5F53222C652C655D2C5B302C32392C224B657954222C35302C2254222C38342C22564B5F54222C652C655D2C5B302C33302C224B657955222C';
wwv_flow_imp.g_varchar2_table(1242) := '35312C2255222C38352C22564B5F55222C652C655D2C5B302C33312C224B657956222C35322C2256222C38362C22564B5F56222C652C655D2C5B302C33322C224B657957222C35332C2257222C38372C22564B5F57222C652C655D2C5B302C33332C224B';
wwv_flow_imp.g_varchar2_table(1243) := '657958222C35342C2258222C38382C22564B5F58222C652C655D2C5B302C33342C224B657959222C35352C2259222C38392C22564B5F59222C652C655D2C5B302C33352C224B65795A222C35362C225A222C39302C22564B5F5A222C652C655D2C5B302C';
wwv_flow_imp.g_varchar2_table(1244) := '33362C22446967697431222C32322C2231222C34392C22564B5F31222C652C655D2C5B302C33372C22446967697432222C32332C2232222C35302C22564B5F32222C652C655D2C5B302C33382C22446967697433222C32342C2233222C35312C22564B5F';
wwv_flow_imp.g_varchar2_table(1245) := '33222C652C655D2C5B302C33392C22446967697434222C32352C2234222C35322C22564B5F34222C652C655D2C5B302C34302C22446967697435222C32362C2235222C35332C22564B5F35222C652C655D2C5B302C34312C22446967697436222C32372C';
wwv_flow_imp.g_varchar2_table(1246) := '2236222C35342C22564B5F36222C652C655D2C5B302C34322C22446967697437222C32382C2237222C35352C22564B5F37222C652C655D2C5B302C34332C22446967697438222C32392C2238222C35362C22564B5F38222C652C655D2C5B302C34342C22';
wwv_flow_imp.g_varchar2_table(1247) := '446967697439222C33302C2239222C35372C22564B5F39222C652C655D2C5B302C34352C22446967697430222C32312C2230222C34382C22564B5F30222C652C655D2C5B312C34362C22456E746572222C332C22456E746572222C31332C22564B5F5245';
wwv_flow_imp.g_varchar2_table(1248) := '5455524E222C652C655D2C5B312C34372C22457363617065222C392C22457363617065222C32372C22564B5F455343415045222C652C655D2C5B312C34382C224261636B7370616365222C312C224261636B7370616365222C382C22564B5F4241434B22';
wwv_flow_imp.g_varchar2_table(1249) := '2C652C655D2C5B312C34392C22546162222C322C22546162222C392C22564B5F544142222C652C655D2C5B312C35302C225370616365222C31302C225370616365222C33322C22564B5F5350414345222C652C655D2C5B302C35312C224D696E7573222C';
wwv_flow_imp.g_varchar2_table(1250) := '38382C222D222C3138392C22564B5F4F454D5F4D494E5553222C222D222C224F454D5F4D494E5553225D2C5B302C35322C22457175616C222C38362C223D222C3138372C22564B5F4F454D5F504C5553222C223D222C224F454D5F504C5553225D2C5B30';
wwv_flow_imp.g_varchar2_table(1251) := '2C35332C22427261636B65744C656674222C39322C225B222C3231392C22564B5F4F454D5F34222C225B222C224F454D5F34225D2C5B302C35342C22427261636B65745269676874222C39342C225D222C3232312C22564B5F4F454D5F36222C225D222C';
wwv_flow_imp.g_varchar2_table(1252) := '224F454D5F36225D2C5B302C35352C224261636B736C617368222C39332C225C5C222C3232302C22564B5F4F454D5F35222C225C5C222C224F454D5F35225D2C5B302C35362C22496E746C48617368222C302C652C302C652C652C655D2C5B302C35372C';
wwv_flow_imp.g_varchar2_table(1253) := '2253656D69636F6C6F6E222C38352C223B222C3138362C22564B5F4F454D5F31222C223B222C224F454D5F31225D2C5B302C35382C2251756F7465222C39352C2227222C3232322C22564B5F4F454D5F37222C2227222C224F454D5F37225D2C5B302C35';
wwv_flow_imp.g_varchar2_table(1254) := '392C224261636B71756F7465222C39312C2260222C3139322C22564B5F4F454D5F33222C2260222C224F454D5F33225D2C5B302C36302C22436F6D6D61222C38372C222C222C3138382C22564B5F4F454D5F434F4D4D41222C222C222C224F454D5F434F';
wwv_flow_imp.g_varchar2_table(1255) := '4D4D41225D2C5B302C36312C22506572696F64222C38392C222E222C3139302C22564B5F4F454D5F504552494F44222C222E222C224F454D5F504552494F44225D2C5B302C36322C22536C617368222C39302C222F222C3139312C22564B5F4F454D5F32';
wwv_flow_imp.g_varchar2_table(1256) := '222C222F222C224F454D5F32225D2C5B312C36332C22436170734C6F636B222C382C22436170734C6F636B222C32302C22564B5F4341504954414C222C652C655D2C5B312C36342C224631222C35392C224631222C3131322C22564B5F4631222C652C65';
wwv_flow_imp.g_varchar2_table(1257) := '5D2C5B312C36352C224632222C36302C224632222C3131332C22564B5F4632222C652C655D2C5B312C36362C224633222C36312C224633222C3131342C22564B5F4633222C652C655D2C5B312C36372C224634222C36322C224634222C3131352C22564B';
wwv_flow_imp.g_varchar2_table(1258) := '5F4634222C652C655D2C5B312C36382C224635222C36332C224635222C3131362C22564B5F4635222C652C655D2C5B312C36392C224636222C36342C224636222C3131372C22564B5F4636222C652C655D2C5B312C37302C224637222C36352C22463722';
wwv_flow_imp.g_varchar2_table(1259) := '2C3131382C22564B5F4637222C652C655D2C5B312C37312C224638222C36362C224638222C3131392C22564B5F4638222C652C655D2C5B312C37322C224639222C36372C224639222C3132302C22564B5F4639222C652C655D2C5B312C37332C22463130';
wwv_flow_imp.g_varchar2_table(1260) := '222C36382C22463130222C3132312C22564B5F463130222C652C655D2C5B312C37342C22463131222C36392C22463131222C3132322C22564B5F463131222C652C655D2C5B312C37352C22463132222C37302C22463132222C3132332C22564B5F463132';
wwv_flow_imp.g_varchar2_table(1261) := '222C652C655D2C5B312C37362C225072696E7453637265656E222C302C652C302C652C652C655D2C5B312C37372C225363726F6C6C4C6F636B222C38342C225363726F6C6C4C6F636B222C3134352C22564B5F5343524F4C4C222C652C655D2C5B312C37';
wwv_flow_imp.g_varchar2_table(1262) := '382C225061757365222C372C225061757365427265616B222C31392C22564B5F5041555345222C652C655D2C5B312C37392C22496E73657274222C31392C22496E73657274222C34352C22564B5F494E53455254222C652C655D2C5B312C38302C22486F';
wwv_flow_imp.g_varchar2_table(1263) := '6D65222C31342C22486F6D65222C33362C22564B5F484F4D45222C652C655D2C5B312C38312C22506167655570222C31312C22506167655570222C33332C22564B5F5052494F52222C652C655D2C5B312C38322C2244656C657465222C32302C2244656C';
wwv_flow_imp.g_varchar2_table(1264) := '657465222C34362C22564B5F44454C455445222C652C655D2C5B312C38332C22456E64222C31332C22456E64222C33352C22564B5F454E44222C652C655D2C5B312C38342C2250616765446F776E222C31322C2250616765446F776E222C33342C22564B';
wwv_flow_imp.g_varchar2_table(1265) := '5F4E455854222C652C655D2C5B312C38352C224172726F775269676874222C31372C2252696768744172726F77222C33392C22564B5F5249474854222C225269676874222C655D2C5B312C38362C224172726F774C656674222C31352C224C6566744172';
wwv_flow_imp.g_varchar2_table(1266) := '726F77222C33372C22564B5F4C454654222C224C656674222C655D2C5B312C38372C224172726F77446F776E222C31382C22446F776E4172726F77222C34302C22564B5F444F574E222C22446F776E222C655D2C5B312C38382C224172726F775570222C';
wwv_flow_imp.g_varchar2_table(1267) := '31362C2255704172726F77222C33382C22564B5F5550222C225570222C655D2C5B312C38392C224E756D4C6F636B222C38332C224E756D4C6F636B222C3134342C22564B5F4E554D4C4F434B222C652C655D2C5B312C39302C224E756D70616444697669';
wwv_flow_imp.g_varchar2_table(1268) := '6465222C3131332C224E756D5061645F446976696465222C3131312C22564B5F444956494445222C652C655D2C5B312C39312C224E756D7061644D756C7469706C79222C3130382C224E756D5061645F4D756C7469706C79222C3130362C22564B5F4D55';
wwv_flow_imp.g_varchar2_table(1269) := '4C5449504C59222C652C655D2C5B312C39322C224E756D7061645375627472616374222C3131312C224E756D5061645F5375627472616374222C3130392C22564B5F5355425452414354222C652C655D2C5B312C39332C224E756D706164416464222C31';
wwv_flow_imp.g_varchar2_table(1270) := '30392C224E756D5061645F416464222C3130372C22564B5F414444222C652C655D2C5B312C39342C224E756D706164456E746572222C332C652C302C652C652C655D2C5B312C39352C224E756D70616431222C39392C224E756D50616431222C39372C22';
wwv_flow_imp.g_varchar2_table(1271) := '564B5F4E554D50414431222C652C655D2C5B312C39362C224E756D70616432222C3130302C224E756D50616432222C39382C22564B5F4E554D50414432222C652C655D2C5B312C39372C224E756D70616433222C3130312C224E756D50616433222C3939';
wwv_flow_imp.g_varchar2_table(1272) := '2C22564B5F4E554D50414433222C652C655D2C5B312C39382C224E756D70616434222C3130322C224E756D50616434222C3130302C22564B5F4E554D50414434222C652C655D2C5B312C39392C224E756D70616435222C3130332C224E756D5061643522';
wwv_flow_imp.g_varchar2_table(1273) := '2C3130312C22564B5F4E554D50414435222C652C655D2C5B312C3130302C224E756D70616436222C3130342C224E756D50616436222C3130322C22564B5F4E554D50414436222C652C655D2C5B312C3130312C224E756D70616437222C3130352C224E75';
wwv_flow_imp.g_varchar2_table(1274) := '6D50616437222C3130332C22564B5F4E554D50414437222C652C655D2C5B312C3130322C224E756D70616438222C3130362C224E756D50616438222C3130342C22564B5F4E554D50414438222C652C655D2C5B312C3130332C224E756D70616439222C31';
wwv_flow_imp.g_varchar2_table(1275) := '30372C224E756D50616439222C3130352C22564B5F4E554D50414439222C652C655D2C5B312C3130342C224E756D70616430222C39382C224E756D50616430222C39362C22564B5F4E554D50414430222C652C655D2C5B312C3130352C224E756D706164';
wwv_flow_imp.g_varchar2_table(1276) := '446563696D616C222C3131322C224E756D5061645F446563696D616C222C3131302C22564B5F444543494D414C222C652C655D2C5B302C3130362C22496E746C4261636B736C617368222C39372C224F454D5F313032222C3232362C22564B5F4F454D5F';
wwv_flow_imp.g_varchar2_table(1277) := '313032222C652C655D2C5B312C3130372C22436F6E746578744D656E75222C35382C22436F6E746578744D656E75222C39332C652C652C655D2C5B312C3130382C22506F776572222C302C652C302C652C652C655D2C5B312C3130392C224E756D706164';
wwv_flow_imp.g_varchar2_table(1278) := '457175616C222C302C652C302C652C652C655D2C5B312C3131302C22463133222C37312C22463133222C3132342C22564B5F463133222C652C655D2C5B312C3131312C22463134222C37322C22463134222C3132352C22564B5F463134222C652C655D2C';
wwv_flow_imp.g_varchar2_table(1279) := '5B312C3131322C22463135222C37332C22463135222C3132362C22564B5F463135222C652C655D2C5B312C3131332C22463136222C37342C22463136222C3132372C22564B5F463136222C652C655D2C5B312C3131342C22463137222C37352C22463137';
wwv_flow_imp.g_varchar2_table(1280) := '222C3132382C22564B5F463137222C652C655D2C5B312C3131352C22463138222C37362C22463138222C3132392C22564B5F463138222C652C655D2C5B312C3131362C22463139222C37372C22463139222C3133302C22564B5F463139222C652C655D2C';
wwv_flow_imp.g_varchar2_table(1281) := '5B312C3131372C22463230222C37382C22463230222C3133312C22564B5F463230222C652C655D2C5B312C3131382C22463231222C37392C22463231222C3133322C22564B5F463231222C652C655D2C5B312C3131392C22463232222C38302C22463232';
wwv_flow_imp.g_varchar2_table(1282) := '222C3133332C22564B5F463232222C652C655D2C5B312C3132302C22463233222C38312C22463233222C3133342C22564B5F463233222C652C655D2C5B312C3132312C22463234222C38322C22463234222C3133352C22564B5F463234222C652C655D2C';
wwv_flow_imp.g_varchar2_table(1283) := '5B312C3132322C224F70656E222C302C652C302C652C652C655D2C5B312C3132332C2248656C70222C302C652C302C652C652C655D2C5B312C3132342C2253656C656374222C302C652C302C652C652C655D2C5B312C3132352C22416761696E222C302C';
wwv_flow_imp.g_varchar2_table(1284) := '652C302C652C652C655D2C5B312C3132362C22556E646F222C302C652C302C652C652C655D2C5B312C3132372C22437574222C302C652C302C652C652C655D2C5B312C3132382C22436F7079222C302C652C302C652C652C655D2C5B312C3132392C2250';
wwv_flow_imp.g_varchar2_table(1285) := '61737465222C302C652C302C652C652C655D2C5B312C3133302C2246696E64222C302C652C302C652C652C655D2C5B312C3133312C22417564696F566F6C756D654D757465222C3131372C22417564696F566F6C756D654D757465222C3137332C22564B';
wwv_flow_imp.g_varchar2_table(1286) := '5F564F4C554D455F4D555445222C652C655D2C5B312C3133322C22417564696F566F6C756D655570222C3131382C22417564696F566F6C756D655570222C3137352C22564B5F564F4C554D455F5550222C652C655D2C5B312C3133332C22417564696F56';
wwv_flow_imp.g_varchar2_table(1287) := '6F6C756D65446F776E222C3131392C22417564696F566F6C756D65446F776E222C3137342C22564B5F564F4C554D455F444F574E222C652C655D2C5B312C3133342C224E756D706164436F6D6D61222C3131302C224E756D5061645F536570617261746F';
wwv_flow_imp.g_varchar2_table(1288) := '72222C3130382C22564B5F534550415241544F52222C652C655D2C5B302C3133352C22496E746C526F222C3131352C2241424E545F4331222C3139332C22564B5F41424E545F4331222C652C655D2C5B312C3133362C224B616E614D6F6465222C302C65';
wwv_flow_imp.g_varchar2_table(1289) := '2C302C652C652C655D2C5B302C3133372C22496E746C59656E222C302C652C302C652C652C655D2C5B312C3133382C22436F6E76657274222C302C652C302C652C652C655D2C5B312C3133392C224E6F6E436F6E76657274222C302C652C302C652C652C';
wwv_flow_imp.g_varchar2_table(1290) := '655D2C5B312C3134302C224C616E6731222C302C652C302C652C652C655D2C5B312C3134312C224C616E6732222C302C652C302C652C652C655D2C5B312C3134322C224C616E6733222C302C652C302C652C652C655D2C5B312C3134332C224C616E6734';
wwv_flow_imp.g_varchar2_table(1291) := '222C302C652C302C652C652C655D2C5B312C3134342C224C616E6735222C302C652C302C652C652C655D2C5B312C3134352C2241626F7274222C302C652C302C652C652C655D2C5B312C3134362C2250726F7073222C302C652C302C652C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(1292) := '312C3134372C224E756D706164506172656E4C656674222C302C652C302C652C652C655D2C5B312C3134382C224E756D706164506172656E5269676874222C302C652C302C652C652C655D2C5B312C3134392C224E756D7061644261636B737061636522';
wwv_flow_imp.g_varchar2_table(1293) := '2C302C652C302C652C652C655D2C5B312C3135302C224E756D7061644D656D6F727953746F7265222C302C652C302C652C652C655D2C5B312C3135312C224E756D7061644D656D6F7279526563616C6C222C302C652C302C652C652C655D2C5B312C3135';
wwv_flow_imp.g_varchar2_table(1294) := '322C224E756D7061644D656D6F7279436C656172222C302C652C302C652C652C655D2C5B312C3135332C224E756D7061644D656D6F7279416464222C302C652C302C652C652C655D2C5B312C3135342C224E756D7061644D656D6F727953756274726163';
wwv_flow_imp.g_varchar2_table(1295) := '74222C302C652C302C652C652C655D2C5B312C3135352C224E756D706164436C656172222C3133312C22436C656172222C31322C22564B5F434C454152222C652C655D2C5B312C3135362C224E756D706164436C656172456E747279222C302C652C302C';
wwv_flow_imp.g_varchar2_table(1296) := '652C652C655D2C5B312C302C652C352C224374726C222C31372C22564B5F434F4E54524F4C222C652C655D2C5B312C302C652C342C225368696674222C31362C22564B5F5348494654222C652C655D2C5B312C302C652C362C22416C74222C31382C2256';
wwv_flow_imp.g_varchar2_table(1297) := '4B5F4D454E55222C652C655D2C5B312C302C652C35372C224D657461222C39312C22564B5F434F4D4D414E44222C652C655D2C5B312C3135372C22436F6E74726F6C4C656674222C352C652C302C22564B5F4C434F4E54524F4C222C652C655D2C5B312C';
wwv_flow_imp.g_varchar2_table(1298) := '3135382C2253686966744C656674222C342C652C302C22564B5F4C5348494654222C652C655D2C5B312C3135392C22416C744C656674222C362C652C302C22564B5F4C4D454E55222C652C655D2C5B312C3136302C224D6574614C656674222C35372C65';
wwv_flow_imp.g_varchar2_table(1299) := '2C302C22564B5F4C57494E222C652C655D2C5B312C3136312C22436F6E74726F6C5269676874222C352C652C302C22564B5F52434F4E54524F4C222C652C655D2C5B312C3136322C2253686966745269676874222C342C652C302C22564B5F5253484946';
wwv_flow_imp.g_varchar2_table(1300) := '54222C652C655D2C5B312C3136332C22416C745269676874222C362C652C302C22564B5F524D454E55222C652C655D2C5B312C3136342C224D6574615269676874222C35372C652C302C22564B5F5257494E222C652C655D2C5B312C3136352C22427269';
wwv_flow_imp.g_varchar2_table(1301) := '6768746E6573735570222C302C652C302C652C652C655D2C5B312C3136362C224272696768746E657373446F776E222C302C652C302C652C652C655D2C5B312C3136372C224D65646961506C6179222C302C652C302C652C652C655D2C5B312C3136382C';
wwv_flow_imp.g_varchar2_table(1302) := '224D656469615265636F7264222C302C652C302C652C652C655D2C5B312C3136392C224D6564696146617374466F7277617264222C302C652C302C652C652C655D2C5B312C3137302C224D65646961526577696E64222C302C652C302C652C652C655D2C';
wwv_flow_imp.g_varchar2_table(1303) := '5B312C3137312C224D65646961547261636B4E657874222C3132342C224D65646961547261636B4E657874222C3137362C22564B5F4D454449415F4E4558545F545241434B222C652C655D2C5B312C3137322C224D65646961547261636B50726576696F';
wwv_flow_imp.g_varchar2_table(1304) := '7573222C3132352C224D65646961547261636B50726576696F7573222C3137372C22564B5F4D454449415F505245565F545241434B222C652C655D2C5B312C3137332C224D6564696153746F70222C3132362C224D6564696153746F70222C3137382C22';
wwv_flow_imp.g_varchar2_table(1305) := '564B5F4D454449415F53544F50222C652C655D2C5B312C3137342C22456A656374222C302C652C302C652C652C655D2C5B312C3137352C224D65646961506C61795061757365222C3132372C224D65646961506C61795061757365222C3137392C22564B';
wwv_flow_imp.g_varchar2_table(1306) := '5F4D454449415F504C41595F5041555345222C652C655D2C5B312C3137362C224D6564696153656C656374222C3132382C224C61756E63684D65646961506C61796572222C3138312C22564B5F4D454449415F4C41554E43485F4D454449415F53454C45';
wwv_flow_imp.g_varchar2_table(1307) := '4354222C652C655D2C5B312C3137372C224C61756E63684D61696C222C3132392C224C61756E63684D61696C222C3138302C22564B5F4D454449415F4C41554E43485F4D41494C222C652C655D2C5B312C3137382C224C61756E636841707032222C3133';
wwv_flow_imp.g_varchar2_table(1308) := '302C224C61756E636841707032222C3138332C22564B5F4D454449415F4C41554E43485F41505032222C652C655D2C5B312C3137392C224C61756E636841707031222C302C652C302C22564B5F4D454449415F4C41554E43485F41505031222C652C655D';
wwv_flow_imp.g_varchar2_table(1309) := '2C5B312C3138302C2253656C6563745461736B222C302C652C302C652C652C655D2C5B312C3138312C224C61756E636853637265656E5361766572222C302C652C302C652C652C655D2C5B312C3138322C2242726F77736572536561726368222C313230';
wwv_flow_imp.g_varchar2_table(1310) := '2C2242726F77736572536561726368222C3137302C22564B5F42524F575345525F534541524348222C652C655D2C5B312C3138332C2242726F77736572486F6D65222C3132312C2242726F77736572486F6D65222C3137322C22564B5F42524F57534552';
wwv_flow_imp.g_varchar2_table(1311) := '5F484F4D45222C652C655D2C5B312C3138342C2242726F777365724261636B222C3132322C2242726F777365724261636B222C3136362C22564B5F42524F575345525F4241434B222C652C655D2C5B312C3138352C2242726F77736572466F7277617264';
wwv_flow_imp.g_varchar2_table(1312) := '222C3132332C2242726F77736572466F7277617264222C3136372C22564B5F42524F575345525F464F5257415244222C652C655D2C5B312C3138362C2242726F7773657253746F70222C302C652C302C22564B5F42524F575345525F53544F50222C652C';
wwv_flow_imp.g_varchar2_table(1313) := '655D2C5B312C3138372C2242726F7773657252656672657368222C302C652C302C22564B5F42524F575345525F52454652455348222C652C655D2C5B312C3138382C2242726F777365724661766F7269746573222C302C652C302C22564B5F42524F5753';
wwv_flow_imp.g_varchar2_table(1314) := '45525F4641564F5249544553222C652C655D2C5B312C3138392C225A6F6F6D546F67676C65222C302C652C302C652C652C655D2C5B312C3139302C224D61696C5265706C79222C302C652C302C652C652C655D2C5B312C3139312C224D61696C466F7277';
wwv_flow_imp.g_varchar2_table(1315) := '617264222C302C652C302C652C652C655D2C5B312C3139322C224D61696C53656E64222C302C652C302C652C652C655D2C5B312C302C652C3131342C224B6579496E436F6D706F736974696F6E222C3232392C652C652C655D2C5B312C302C652C313136';
wwv_flow_imp.g_varchar2_table(1316) := '2C2241424E545F4332222C3139342C22564B5F41424E545F4332222C652C655D2C5B312C302C652C39362C224F454D5F38222C3232332C22564B5F4F454D5F38222C652C655D2C5B312C302C652C302C652C302C22564B5F4B414E41222C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(1317) := '312C302C652C302C652C302C22564B5F48414E47554C222C652C655D2C5B312C302C652C302C652C302C22564B5F4A554E4A41222C652C655D2C5B312C302C652C302C652C302C22564B5F46494E414C222C652C655D2C5B312C302C652C302C652C302C';
wwv_flow_imp.g_varchar2_table(1318) := '22564B5F48414E4A41222C652C655D2C5B312C302C652C302C652C302C22564B5F4B414E4A49222C652C655D2C5B312C302C652C302C652C302C22564B5F434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E434F4E56';
wwv_flow_imp.g_varchar2_table(1319) := '455254222C652C655D2C5B312C302C652C302C652C302C22564B5F414343455054222C652C655D2C5B312C302C652C302C652C302C22564B5F4D4F44454348414E4745222C652C655D2C5B312C302C652C302C652C302C22564B5F53454C454354222C65';
wwv_flow_imp.g_varchar2_table(1320) := '2C655D2C5B312C302C652C302C652C302C22564B5F5052494E54222C652C655D2C5B312C302C652C302C652C302C22564B5F45584543555445222C652C655D2C5B312C302C652C302C652C302C22564B5F534E415053484F54222C652C655D2C5B312C30';
wwv_flow_imp.g_varchar2_table(1321) := '2C652C302C652C302C22564B5F48454C50222C652C655D2C5B312C302C652C302C652C302C22564B5F41505053222C652C655D2C5B312C302C652C302C652C302C22564B5F50524F434553534B4559222C652C655D2C5B312C302C652C302C652C302C22';
wwv_flow_imp.g_varchar2_table(1322) := '564B5F5041434B4554222C652C655D2C5B312C302C652C302C652C302C22564B5F4442455F5342435343484152222C652C655D2C5B312C302C652C302C652C302C22564B5F4442455F4442435343484152222C652C655D2C5B312C302C652C302C652C30';
wwv_flow_imp.g_varchar2_table(1323) := '2C22564B5F4154544E222C652C655D2C5B312C302C652C302C652C302C22564B5F435253454C222C652C655D2C5B312C302C652C302C652C302C22564B5F455853454C222C652C655D2C5B312C302C652C302C652C302C22564B5F4552454F46222C652C';
wwv_flow_imp.g_varchar2_table(1324) := '655D2C5B312C302C652C302C652C302C22564B5F504C4159222C652C655D2C5B312C302C652C302C652C302C22564B5F5A4F4F4D222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E414D45222C652C655D2C5B312C302C652C302C652C';
wwv_flow_imp.g_varchar2_table(1325) := '302C22564B5F504131222C652C655D2C5B312C302C652C302C652C302C22564B5F4F454D5F434C454152222C652C655D5D2C6E3D5B5D2C693D5B5D3B666F7228636F6E73742065206F662074297B636F6E73745B742C722C732C6F2C612C6C2C752C682C';
wwv_flow_imp.g_varchar2_table(1326) := '635D3D653B696628695B725D7C7C28695B725D3D21302C656E5B725D3D732C746E5B735D3D722C6E6E5B732E746F4C6F7765724361736528295D3D722C74262628726E5B725D3D6F2C30213D3D6F262633213D3D6F262635213D3D6F262634213D3D6F26';
wwv_flow_imp.g_varchar2_table(1327) := '2636213D3D6F26263537213D3D6F262628736E5B6F5D3D722929292C216E5B6F5D297B6966286E5B6F5D3D21302C2161297468726F77206E6577204572726F722860537472696E6720726570726573656E746174696F6E206D697373696E6720666F7220';
wwv_flow_imp.g_varchar2_table(1328) := '6B657920636F646520247B6F7D2061726F756E64207363616E20636F646520247B737D60293B51742E646566696E65286F2C61292C58742E646566696E65286F2C687C7C61292C4A742E646566696E65286F2C637C7C687C7C61297D6C26262859745B6C';
wwv_flow_imp.g_varchar2_table(1329) := '5D3D6F292C752626285A745B755D3D6F297D736E5B335D3D34367D28292C66756E6374696F6E2865297B652E746F537472696E673D66756E6374696F6E2865297B72657475726E2051742E6B6579436F6465546F5374722865297D2C652E66726F6D5374';
wwv_flow_imp.g_varchar2_table(1330) := '72696E673D66756E6374696F6E2865297B72657475726E2051742E737472546F4B6579436F64652865297D2C652E746F5573657253657474696E677355533D66756E6374696F6E2865297B72657475726E2058742E6B6579436F6465546F537472286529';
wwv_flow_imp.g_varchar2_table(1331) := '7D2C652E746F5573657253657474696E677347656E6572616C3D66756E6374696F6E2865297B72657475726E204A742E6B6579436F6465546F5374722865297D2C652E66726F6D5573657253657474696E67733D66756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(1332) := '726E2058742E737472546F4B6579436F64652865297C7C4A742E737472546F4B6579436F64652865297D2C652E746F456C656374726F6E416363656C657261746F723D66756E6374696F6E2865297B696628653E3D39382626653C3D3131332972657475';
wwv_flow_imp.g_varchar2_table(1333) := '726E206E756C6C3B7377697463682865297B636173652031363A72657475726E225570223B636173652031383A72657475726E22446F776E223B636173652031353A72657475726E224C656674223B636173652031373A72657475726E22526967687422';
wwv_flow_imp.g_varchar2_table(1334) := '7D72657475726E2051742E6B6579436F6465546F5374722865297D7D286F6E7C7C286F6E3D7B7D29293B636C61737320616E20657874656E64732077747B636F6E7374727563746F7228652C742C6E2C69297B737570657228652C742C6E2C69292C7468';
wwv_flow_imp.g_varchar2_table(1335) := '69732E73656C656374696F6E53746172744C696E654E756D6265723D652C746869732E73656C656374696F6E5374617274436F6C756D6E3D742C746869732E706F736974696F6E4C696E654E756D6265723D6E2C746869732E706F736974696F6E436F6C';
wwv_flow_imp.g_varchar2_table(1336) := '756D6E3D697D746F537472696E6728297B72657475726E225B222B746869732E73656C656374696F6E53746172744C696E654E756D6265722B222C222B746869732E73656C656374696F6E5374617274436F6C756D6E2B22202D3E20222B746869732E70';
wwv_flow_imp.g_varchar2_table(1337) := '6F736974696F6E4C696E654E756D6265722B222C222B746869732E706F736974696F6E436F6C756D6E2B225D227D657175616C7353656C656374696F6E2865297B72657475726E20616E2E73656C656374696F6E73457175616C28746869732C65297D73';
wwv_flow_imp.g_varchar2_table(1338) := '74617469632073656C656374696F6E73457175616C28652C74297B72657475726E20652E73656C656374696F6E53746172744C696E654E756D6265723D3D3D742E73656C656374696F6E53746172744C696E654E756D6265722626652E73656C65637469';
wwv_flow_imp.g_varchar2_table(1339) := '6F6E5374617274436F6C756D6E3D3D3D742E73656C656374696F6E5374617274436F6C756D6E2626652E706F736974696F6E4C696E654E756D6265723D3D3D742E706F736974696F6E4C696E654E756D6265722626652E706F736974696F6E436F6C756D';
wwv_flow_imp.g_varchar2_table(1340) := '6E3D3D3D742E706F736974696F6E436F6C756D6E7D676574446972656374696F6E28297B72657475726E20746869732E73656C656374696F6E53746172744C696E654E756D6265723D3D3D746869732E73746172744C696E654E756D6265722626746869';
wwv_flow_imp.g_varchar2_table(1341) := '732E73656C656374696F6E5374617274436F6C756D6E3D3D3D746869732E7374617274436F6C756D6E3F303A317D736574456E64506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E6577';
wwv_flow_imp.g_varchar2_table(1342) := '20616E28746869732E73746172744C696E654E756D6265722C746869732E7374617274436F6C756D6E2C652C74293A6E657720616E28652C742C746869732E73746172744C696E654E756D6265722C746869732E7374617274436F6C756D6E297D676574';
wwv_flow_imp.g_varchar2_table(1343) := '506F736974696F6E28297B72657475726E206E6577204C7428746869732E706F736974696F6E4C696E654E756D6265722C746869732E706F736974696F6E436F6C756D6E297D67657453656C656374696F6E537461727428297B72657475726E206E6577';
wwv_flow_imp.g_varchar2_table(1344) := '204C7428746869732E73656C656374696F6E53746172744C696E654E756D6265722C746869732E73656C656374696F6E5374617274436F6C756D6E297D7365745374617274506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E67';
wwv_flow_imp.g_varchar2_table(1345) := '6574446972656374696F6E28293F6E657720616E28652C742C746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E293A6E657720616E28746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E';
wwv_flow_imp.g_varchar2_table(1346) := '2C652C74297D7374617469632066726F6D506F736974696F6E7328652C743D65297B72657475726E206E657720616E28652E6C696E654E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D73746174696320';
wwv_flow_imp.g_varchar2_table(1347) := '66726F6D52616E676528652C74297B72657475726E20303D3D3D743F6E657720616E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E657720';
wwv_flow_imp.g_varchar2_table(1348) := '616E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D737461746963206C69667453656C656374696F6E2865297B72657475726E206E65772061';
wwv_flow_imp.g_varchar2_table(1349) := '6E28652E73656C656374696F6E53746172744C696E654E756D6265722C652E73656C656374696F6E5374617274436F6C756D6E2C652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E297D737461746963207365';
wwv_flow_imp.g_varchar2_table(1350) := '6C656374696F6E73417272457175616C28652C74297B69662865262621747C7C21652626742972657475726E21313B6966282165262621742972657475726E21303B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F';
wwv_flow_imp.g_varchar2_table(1351) := '72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B2969662821746869732E73656C656374696F6E73457175616C28655B6E5D2C745B6E5D292972657475726E21313B72657475726E21307D7374617469632069734953656C65637469';
wwv_flow_imp.g_varchar2_table(1352) := '6F6E2865297B72657475726E20652626226E756D626572223D3D747970656F6620652E73656C656374696F6E53746172744C696E654E756D6265722626226E756D626572223D3D747970656F6620652E73656C656374696F6E5374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(1353) := '2626226E756D626572223D3D747970656F6620652E706F736974696F6E4C696E654E756D6265722626226E756D626572223D3D747970656F6620652E706F736974696F6E436F6C756D6E7D7374617469632063726561746557697468446972656374696F';
wwv_flow_imp.g_varchar2_table(1354) := '6E28652C742C6E2C692C72297B72657475726E20303D3D3D723F6E657720616E28652C742C6E2C69293A6E657720616E286E2C692C652C74297D7D636F6E7374206C6E3D4F626A6563742E637265617465286E756C6C293B66756E6374696F6E20756E28';
wwv_flow_imp.g_varchar2_table(1355) := '652C74297B69662822737472696E67223D3D747970656F662074297B636F6E7374206E3D6C6E5B745D3B696628766F696420303D3D3D6E297468726F77206E6577204572726F722860247B657D207265666572656E63657320616E20756E6B6E6F776E20';
wwv_flow_imp.g_varchar2_table(1356) := '636F6469636F6E3A20247B747D60293B743D6E7D72657475726E206C6E5B655D3D742C7B69643A657D7D636F6E737420686E3D7B6164643A756E2822616464222C366534292C706C75733A756E2822706C7573222C366534292C676973744E65773A756E';
wwv_flow_imp.g_varchar2_table(1357) := '2822676973742D6E6577222C366534292C7265706F4372656174653A756E28227265706F2D637265617465222C366534292C6C6967687462756C623A756E28226C6967687462756C62222C3630303031292C6C6967687442756C623A756E28226C696768';
wwv_flow_imp.g_varchar2_table(1358) := '742D62756C62222C3630303031292C7265706F3A756E28227265706F222C3630303032292C7265706F44656C6574653A756E28227265706F2D64656C657465222C3630303032292C67697374466F726B3A756E2822676973742D666F726B222C36303030';
wwv_flow_imp.g_varchar2_table(1359) := '33292C7265706F466F726B65643A756E28227265706F2D666F726B6564222C3630303033292C67697450756C6C526571756573743A756E28226769742D70756C6C2D72657175657374222C3630303034292C67697450756C6C526571756573744162616E';
wwv_flow_imp.g_varchar2_table(1360) := '646F6E65643A756E28226769742D70756C6C2D726571756573742D6162616E646F6E6564222C3630303034292C7265636F72644B6579733A756E28227265636F72642D6B657973222C3630303035292C6B6579626F6172643A756E28226B6579626F6172';
wwv_flow_imp.g_varchar2_table(1361) := '64222C3630303035292C7461673A756E2822746167222C3630303036292C67697450756C6C526571756573744C6162656C3A756E28226769742D70756C6C2D726571756573742D6C6162656C222C3630303036292C7461674164643A756E28227461672D';
wwv_flow_imp.g_varchar2_table(1362) := '616464222C3630303036292C74616752656D6F76653A756E28227461672D72656D6F7665222C3630303036292C706572736F6E3A756E2822706572736F6E222C3630303037292C706572736F6E466F6C6C6F773A756E2822706572736F6E2D666F6C6C6F';
wwv_flow_imp.g_varchar2_table(1363) := '77222C3630303037292C706572736F6E4F75746C696E653A756E2822706572736F6E2D6F75746C696E65222C3630303037292C706572736F6E46696C6C65643A756E2822706572736F6E2D66696C6C6564222C3630303037292C6769744272616E63683A';
wwv_flow_imp.g_varchar2_table(1364) := '756E28226769742D6272616E6368222C3630303038292C6769744272616E63684372656174653A756E28226769742D6272616E63682D637265617465222C3630303038292C6769744272616E636844656C6574653A756E28226769742D6272616E63682D';
wwv_flow_imp.g_varchar2_table(1365) := '64656C657465222C3630303038292C736F75726365436F6E74726F6C3A756E2822736F757263652D636F6E74726F6C222C3630303038292C6D6972726F723A756E28226D6972726F72222C3630303039292C6D6972726F725075626C69633A756E28226D';
wwv_flow_imp.g_varchar2_table(1366) := '6972726F722D7075626C6963222C3630303039292C737461723A756E282273746172222C3630303130292C737461724164643A756E2822737461722D616464222C3630303130292C7374617244656C6574653A756E2822737461722D64656C657465222C';
wwv_flow_imp.g_varchar2_table(1367) := '3630303130292C73746172456D7074793A756E2822737461722D656D707479222C3630303130292C636F6D6D656E743A756E2822636F6D6D656E74222C3630303131292C636F6D6D656E744164643A756E2822636F6D6D656E742D616464222C36303031';
wwv_flow_imp.g_varchar2_table(1368) := '31292C616C6572743A756E2822616C657274222C3630303132292C7761726E696E673A756E28227761726E696E67222C3630303132292C7365617263683A756E2822736561726368222C3630303133292C736561726368536176653A756E282273656172';
wwv_flow_imp.g_varchar2_table(1369) := '63682D73617665222C3630303133292C6C6F674F75743A756E28226C6F672D6F7574222C3630303134292C7369676E4F75743A756E28227369676E2D6F7574222C3630303134292C6C6F67496E3A756E28226C6F672D696E222C3630303135292C736967';
wwv_flow_imp.g_varchar2_table(1370) := '6E496E3A756E28227369676E2D696E222C3630303135292C6579653A756E2822657965222C3630303136292C657965556E77617463683A756E28226579652D756E7761746368222C3630303136292C65796557617463683A756E28226579652D77617463';
wwv_flow_imp.g_varchar2_table(1371) := '68222C3630303136292C636972636C6546696C6C65643A756E2822636972636C652D66696C6C6564222C3630303137292C7072696D6974697665446F743A756E28227072696D69746976652D646F74222C3630303137292C636C6F736544697274793A75';
wwv_flow_imp.g_varchar2_table(1372) := '6E2822636C6F73652D6469727479222C3630303137292C6465627567427265616B706F696E743A756E282264656275672D627265616B706F696E74222C3630303137292C6465627567427265616B706F696E7444697361626C65643A756E282264656275';
wwv_flow_imp.g_varchar2_table(1373) := '672D627265616B706F696E742D64697361626C6564222C3630303137292C646562756748696E743A756E282264656275672D68696E74222C3630303137292C7465726D696E616C4465636F726174696F6E537563636573733A756E28227465726D696E61';
wwv_flow_imp.g_varchar2_table(1374) := '6C2D6465636F726174696F6E2D73756363657373222C3630303137292C7072696D69746976655371756172653A756E28227072696D69746976652D737175617265222C3630303138292C656469743A756E282265646974222C3630303139292C70656E63';
wwv_flow_imp.g_varchar2_table(1375) := '696C3A756E282270656E63696C222C3630303139292C696E666F3A756E2822696E666F222C3630303230292C69737375654F70656E65643A756E282269737375652D6F70656E6564222C3630303230292C67697374507269766174653A756E2822676973';
wwv_flow_imp.g_varchar2_table(1376) := '742D70726976617465222C3630303231292C676974466F726B507269766174653A756E28226769742D666F726B2D70726976617465222C3630303231292C6C6F636B3A756E28226C6F636B222C3630303231292C6D6972726F72507269766174653A756E';
wwv_flow_imp.g_varchar2_table(1377) := '28226D6972726F722D70726976617465222C3630303231292C636C6F73653A756E2822636C6F7365222C3630303232292C72656D6F7665436C6F73653A756E282272656D6F76652D636C6F7365222C3630303232292C783A756E282278222C3630303232';
wwv_flow_imp.g_varchar2_table(1378) := '292C7265706F53796E633A756E28227265706F2D73796E63222C3630303233292C73796E633A756E282273796E63222C3630303233292C636C6F6E653A756E2822636C6F6E65222C3630303234292C6465736B746F70446F776E6C6F61643A756E282264';
wwv_flow_imp.g_varchar2_table(1379) := '65736B746F702D646F776E6C6F6164222C3630303234292C6265616B65723A756E28226265616B6572222C3630303235292C6D6963726F73636F70653A756E28226D6963726F73636F7065222C3630303235292C766D3A756E2822766D222C3630303236';
wwv_flow_imp.g_varchar2_table(1380) := '292C6465766963654465736B746F703A756E28226465766963652D6465736B746F70222C3630303236292C66696C653A756E282266696C65222C3630303237292C66696C65546578743A756E282266696C652D74657874222C3630303237292C6D6F7265';
wwv_flow_imp.g_varchar2_table(1381) := '3A756E28226D6F7265222C3630303238292C656C6C69707369733A756E2822656C6C6970736973222C3630303238292C6B65626162486F72697A6F6E74616C3A756E28226B656261622D686F72697A6F6E74616C222C3630303238292C6D61696C526570';
wwv_flow_imp.g_varchar2_table(1382) := '6C793A756E28226D61696C2D7265706C79222C3630303239292C7265706C793A756E28227265706C79222C3630303239292C6F7267616E697A6174696F6E3A756E28226F7267616E697A6174696F6E222C3630303330292C6F7267616E697A6174696F6E';
wwv_flow_imp.g_varchar2_table(1383) := '46696C6C65643A756E28226F7267616E697A6174696F6E2D66696C6C6564222C3630303330292C6F7267616E697A6174696F6E4F75746C696E653A756E28226F7267616E697A6174696F6E2D6F75746C696E65222C3630303330292C6E657746696C653A';
wwv_flow_imp.g_varchar2_table(1384) := '756E28226E65772D66696C65222C3630303331292C66696C654164643A756E282266696C652D616464222C3630303331292C6E6577466F6C6465723A756E28226E65772D666F6C646572222C3630303332292C66696C654469726563746F727943726561';
wwv_flow_imp.g_varchar2_table(1385) := '74653A756E282266696C652D6469726563746F72792D637265617465222C3630303332292C74726173683A756E28227472617368222C3630303333292C747261736863616E3A756E2822747261736863616E222C3630303333292C686973746F72793A75';
wwv_flow_imp.g_varchar2_table(1386) := '6E2822686973746F7279222C3630303334292C636C6F636B3A756E2822636C6F636B222C3630303334292C666F6C6465723A756E2822666F6C646572222C3630303335292C66696C654469726563746F72793A756E282266696C652D6469726563746F72';
wwv_flow_imp.g_varchar2_table(1387) := '79222C3630303335292C73796D626F6C466F6C6465723A756E282273796D626F6C2D666F6C646572222C3630303335292C6C6F676F4769746875623A756E28226C6F676F2D676974687562222C3630303336292C6D61726B4769746875623A756E28226D';
wwv_flow_imp.g_varchar2_table(1388) := '61726B2D676974687562222C3630303336292C6769746875623A756E2822676974687562222C3630303336292C7465726D696E616C3A756E28227465726D696E616C222C3630303337292C636F6E736F6C653A756E2822636F6E736F6C65222C36303033';
wwv_flow_imp.g_varchar2_table(1389) := '37292C7265706C3A756E28227265706C222C3630303337292C7A61703A756E28227A6170222C3630303338292C73796D626F6C4576656E743A756E282273796D626F6C2D6576656E74222C3630303338292C6572726F723A756E28226572726F72222C36';
wwv_flow_imp.g_varchar2_table(1390) := '30303339292C73746F703A756E282273746F70222C3630303339292C7661726961626C653A756E28227661726961626C65222C3630303430292C73796D626F6C5661726961626C653A756E282273796D626F6C2D7661726961626C65222C363030343029';
wwv_flow_imp.g_varchar2_table(1391) := '2C61727261793A756E28226172726179222C3630303432292C73796D626F6C41727261793A756E282273796D626F6C2D6172726179222C3630303432292C73796D626F6C4D6F64756C653A756E282273796D626F6C2D6D6F64756C65222C363030343329';
wwv_flow_imp.g_varchar2_table(1392) := '2C73796D626F6C5061636B6167653A756E282273796D626F6C2D7061636B616765222C3630303433292C73796D626F6C4E616D6573706163653A756E282273796D626F6C2D6E616D657370616365222C3630303433292C73796D626F6C4F626A6563743A';
wwv_flow_imp.g_varchar2_table(1393) := '756E282273796D626F6C2D6F626A656374222C3630303433292C73796D626F6C4D6574686F643A756E282273796D626F6C2D6D6574686F64222C3630303434292C73796D626F6C46756E6374696F6E3A756E282273796D626F6C2D66756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(1394) := '2C3630303434292C73796D626F6C436F6E7374727563746F723A756E282273796D626F6C2D636F6E7374727563746F72222C3630303434292C73796D626F6C426F6F6C65616E3A756E282273796D626F6C2D626F6F6C65616E222C3630303437292C7379';
wwv_flow_imp.g_varchar2_table(1395) := '6D626F6C4E756C6C3A756E282273796D626F6C2D6E756C6C222C3630303437292C73796D626F6C4E756D657269633A756E282273796D626F6C2D6E756D65726963222C3630303438292C73796D626F6C4E756D6265723A756E282273796D626F6C2D6E75';
wwv_flow_imp.g_varchar2_table(1396) := '6D626572222C3630303438292C73796D626F6C5374727563747572653A756E282273796D626F6C2D737472756374757265222C3630303439292C73796D626F6C5374727563743A756E282273796D626F6C2D737472756374222C3630303439292C73796D';
wwv_flow_imp.g_varchar2_table(1397) := '626F6C506172616D657465723A756E282273796D626F6C2D706172616D65746572222C3630303530292C73796D626F6C54797065506172616D657465723A756E282273796D626F6C2D747970652D706172616D65746572222C3630303530292C73796D62';
wwv_flow_imp.g_varchar2_table(1398) := '6F6C4B65793A756E282273796D626F6C2D6B6579222C3630303531292C73796D626F6C546578743A756E282273796D626F6C2D74657874222C3630303531292C73796D626F6C5265666572656E63653A756E282273796D626F6C2D7265666572656E6365';
wwv_flow_imp.g_varchar2_table(1399) := '222C3630303532292C676F546F46696C653A756E2822676F2D746F2D66696C65222C3630303532292C73796D626F6C456E756D3A756E282273796D626F6C2D656E756D222C3630303533292C73796D626F6C56616C75653A756E282273796D626F6C2D76';
wwv_flow_imp.g_varchar2_table(1400) := '616C7565222C3630303533292C73796D626F6C52756C65723A756E282273796D626F6C2D72756C6572222C3630303534292C73796D626F6C556E69743A756E282273796D626F6C2D756E6974222C3630303534292C6163746976617465427265616B706F';
wwv_flow_imp.g_varchar2_table(1401) := '696E74733A756E282261637469766174652D627265616B706F696E7473222C3630303535292C617263686976653A756E282261726368697665222C3630303536292C6172726F77426F74683A756E28226172726F772D626F7468222C3630303537292C61';
wwv_flow_imp.g_varchar2_table(1402) := '72726F77446F776E3A756E28226172726F772D646F776E222C3630303538292C6172726F774C6566743A756E28226172726F772D6C656674222C3630303539292C6172726F7752696768743A756E28226172726F772D7269676874222C3630303630292C';
wwv_flow_imp.g_varchar2_table(1403) := '6172726F77536D616C6C446F776E3A756E28226172726F772D736D616C6C2D646F776E222C3630303631292C6172726F77536D616C6C4C6566743A756E28226172726F772D736D616C6C2D6C656674222C3630303632292C6172726F77536D616C6C5269';
wwv_flow_imp.g_varchar2_table(1404) := '6768743A756E28226172726F772D736D616C6C2D7269676874222C3630303633292C6172726F77536D616C6C55703A756E28226172726F772D736D616C6C2D7570222C3630303634292C6172726F7755703A756E28226172726F772D7570222C36303036';
wwv_flow_imp.g_varchar2_table(1405) := '35292C62656C6C3A756E282262656C6C222C3630303636292C626F6C643A756E2822626F6C64222C3630303637292C626F6F6B3A756E2822626F6F6B222C3630303638292C626F6F6B6D61726B3A756E2822626F6F6B6D61726B222C3630303639292C64';
wwv_flow_imp.g_varchar2_table(1406) := '65627567427265616B706F696E74436F6E646974696F6E616C556E76657269666965643A756E282264656275672D627265616B706F696E742D636F6E646974696F6E616C2D756E7665726966696564222C3630303730292C6465627567427265616B706F';
wwv_flow_imp.g_varchar2_table(1407) := '696E74436F6E646974696F6E616C3A756E282264656275672D627265616B706F696E742D636F6E646974696F6E616C222C3630303731292C6465627567427265616B706F696E74436F6E646974696F6E616C44697361626C65643A756E28226465627567';
wwv_flow_imp.g_varchar2_table(1408) := '2D627265616B706F696E742D636F6E646974696F6E616C2D64697361626C6564222C3630303731292C6465627567427265616B706F696E7444617461556E76657269666965643A756E282264656275672D627265616B706F696E742D646174612D756E76';
wwv_flow_imp.g_varchar2_table(1409) := '65726966696564222C3630303732292C6465627567427265616B706F696E74446174613A756E282264656275672D627265616B706F696E742D64617461222C3630303733292C6465627567427265616B706F696E744461746144697361626C65643A756E';
wwv_flow_imp.g_varchar2_table(1410) := '282264656275672D627265616B706F696E742D646174612D64697361626C6564222C3630303733292C6465627567427265616B706F696E744C6F67556E76657269666965643A756E282264656275672D627265616B706F696E742D6C6F672D756E766572';
wwv_flow_imp.g_varchar2_table(1411) := '6966696564222C3630303734292C6465627567427265616B706F696E744C6F673A756E282264656275672D627265616B706F696E742D6C6F67222C3630303735292C6465627567427265616B706F696E744C6F6744697361626C65643A756E2822646562';
wwv_flow_imp.g_varchar2_table(1412) := '75672D627265616B706F696E742D6C6F672D64697361626C6564222C3630303735292C6272696566636173653A756E2822627269656663617365222C3630303736292C62726F6164636173743A756E282262726F616463617374222C3630303737292C62';
wwv_flow_imp.g_varchar2_table(1413) := '726F777365723A756E282262726F77736572222C3630303738292C6275673A756E2822627567222C3630303739292C63616C656E6461723A756E282263616C656E646172222C3630303830292C6361736553656E7369746976653A756E2822636173652D';
wwv_flow_imp.g_varchar2_table(1414) := '73656E736974697665222C3630303831292C636865636B3A756E2822636865636B222C3630303832292C636865636B6C6973743A756E2822636865636B6C697374222C3630303833292C63686576726F6E446F776E3A756E282263686576726F6E2D646F';
wwv_flow_imp.g_varchar2_table(1415) := '776E222C3630303834292C63686576726F6E4C6566743A756E282263686576726F6E2D6C656674222C3630303835292C63686576726F6E52696768743A756E282263686576726F6E2D7269676874222C3630303836292C63686576726F6E55703A756E28';
wwv_flow_imp.g_varchar2_table(1416) := '2263686576726F6E2D7570222C3630303837292C6368726F6D65436C6F73653A756E28226368726F6D652D636C6F7365222C3630303838292C6368726F6D654D6178696D697A653A756E28226368726F6D652D6D6178696D697A65222C3630303839292C';
wwv_flow_imp.g_varchar2_table(1417) := '6368726F6D654D696E696D697A653A756E28226368726F6D652D6D696E696D697A65222C3630303930292C6368726F6D65526573746F72653A756E28226368726F6D652D726573746F7265222C3630303931292C636972636C654F75746C696E653A756E';
wwv_flow_imp.g_varchar2_table(1418) := '2822636972636C652D6F75746C696E65222C3630303932292C636972636C653A756E2822636972636C65222C3630303932292C6465627567427265616B706F696E74556E76657269666965643A756E282264656275672D627265616B706F696E742D756E';
wwv_flow_imp.g_varchar2_table(1419) := '7665726966696564222C3630303932292C7465726D696E616C4465636F726174696F6E496E636F6D706C6574653A756E28227465726D696E616C2D6465636F726174696F6E2D696E636F6D706C657465222C3630303932292C636972636C65536C617368';
wwv_flow_imp.g_varchar2_table(1420) := '3A756E2822636972636C652D736C617368222C3630303933292C63697263756974426F6172643A756E2822636972637569742D626F617264222C3630303934292C636C656172416C6C3A756E2822636C6561722D616C6C222C3630303935292C636C6970';
wwv_flow_imp.g_varchar2_table(1421) := '70793A756E2822636C69707079222C3630303936292C636C6F7365416C6C3A756E2822636C6F73652D616C6C222C3630303937292C636C6F7564446F776E6C6F61643A756E2822636C6F75642D646F776E6C6F6164222C3630303938292C636C6F756455';
wwv_flow_imp.g_varchar2_table(1422) := '706C6F61643A756E2822636C6F75642D75706C6F6164222C3630303939292C636F64653A756E2822636F6465222C3630313030292C636F6C6C61707365416C6C3A756E2822636F6C6C617073652D616C6C222C3630313031292C636F6C6F724D6F64653A';
wwv_flow_imp.g_varchar2_table(1423) := '756E2822636F6C6F722D6D6F6465222C3630313032292C636F6D6D656E7444697363757373696F6E3A756E2822636F6D6D656E742D64697363757373696F6E222C3630313033292C637265646974436172643A756E28226372656469742D63617264222C';
wwv_flow_imp.g_varchar2_table(1424) := '3630313035292C646173683A756E282264617368222C3630313038292C64617368626F6172643A756E282264617368626F617264222C3630313039292C64617461626173653A756E28226461746162617365222C3630313130292C6465627567436F6E74';
wwv_flow_imp.g_varchar2_table(1425) := '696E75653A756E282264656275672D636F6E74696E7565222C3630313131292C6465627567446973636F6E6E6563743A756E282264656275672D646973636F6E6E656374222C3630313132292C646562756750617573653A756E282264656275672D7061';
wwv_flow_imp.g_varchar2_table(1426) := '757365222C3630313133292C6465627567526573746172743A756E282264656275672D72657374617274222C3630313134292C646562756753746172743A756E282264656275672D7374617274222C3630313135292C646562756753746570496E746F3A';
wwv_flow_imp.g_varchar2_table(1427) := '756E282264656275672D737465702D696E746F222C3630313136292C6465627567537465704F75743A756E282264656275672D737465702D6F7574222C3630313137292C6465627567537465704F7665723A756E282264656275672D737465702D6F7665';
wwv_flow_imp.g_varchar2_table(1428) := '72222C3630313138292C646562756753746F703A756E282264656275672D73746F70222C3630313139292C64656275673A756E28226465627567222C3630313230292C64657669636543616D657261566964656F3A756E28226465766963652D63616D65';
wwv_flow_imp.g_varchar2_table(1429) := '72612D766964656F222C3630313231292C64657669636543616D6572613A756E28226465766963652D63616D657261222C3630313232292C6465766963654D6F62696C653A756E28226465766963652D6D6F62696C65222C3630313233292C6469666641';
wwv_flow_imp.g_varchar2_table(1430) := '646465643A756E2822646966662D6164646564222C3630313234292C6469666649676E6F7265643A756E2822646966662D69676E6F726564222C3630313235292C646966664D6F6469666965643A756E2822646966662D6D6F646966696564222C363031';
wwv_flow_imp.g_varchar2_table(1431) := '3236292C6469666652656D6F7665643A756E2822646966662D72656D6F766564222C3630313237292C6469666652656E616D65643A756E2822646966662D72656E616D6564222C3630313238292C646966663A756E282264696666222C3630313239292C';
wwv_flow_imp.g_varchar2_table(1432) := '64696666536964656279736964653A756E2822646966662D73696465627973696465222C3630313239292C646973636172643A756E282264697363617264222C3630313330292C656469746F724C61796F75743A756E2822656469746F722D6C61796F75';
wwv_flow_imp.g_varchar2_table(1433) := '74222C3630313331292C656D70747957696E646F773A756E2822656D7074792D77696E646F77222C3630313332292C6578636C7564653A756E28226578636C756465222C3630313333292C657874656E73696F6E733A756E2822657874656E73696F6E73';
wwv_flow_imp.g_varchar2_table(1434) := '222C3630313334292C657965436C6F7365643A756E28226579652D636C6F736564222C3630313335292C66696C6542696E6172793A756E282266696C652D62696E617279222C3630313336292C66696C65436F64653A756E282266696C652D636F646522';
wwv_flow_imp.g_varchar2_table(1435) := '2C3630313337292C66696C654D656469613A756E282266696C652D6D65646961222C3630313338292C66696C655064663A756E282266696C652D706466222C3630313339292C66696C655375626D6F64756C653A756E282266696C652D7375626D6F6475';
wwv_flow_imp.g_varchar2_table(1436) := '6C65222C3630313430292C66696C6553796D6C696E6B4469726563746F72793A756E282266696C652D73796D6C696E6B2D6469726563746F7279222C3630313431292C66696C6553796D6C696E6B46696C653A756E282266696C652D73796D6C696E6B2D';
wwv_flow_imp.g_varchar2_table(1437) := '66696C65222C3630313432292C66696C655A69703A756E282266696C652D7A6970222C3630313433292C66696C65733A756E282266696C6573222C3630313434292C66696C7465723A756E282266696C746572222C3630313435292C666C616D653A756E';
wwv_flow_imp.g_varchar2_table(1438) := '2822666C616D65222C3630313436292C666F6C64446F776E3A756E2822666F6C642D646F776E222C3630313437292C666F6C6455703A756E2822666F6C642D7570222C3630313438292C666F6C643A756E2822666F6C64222C3630313439292C666F6C64';
wwv_flow_imp.g_varchar2_table(1439) := '65724163746976653A756E2822666F6C6465722D616374697665222C3630313530292C666F6C6465724F70656E65643A756E2822666F6C6465722D6F70656E6564222C3630313531292C676561723A756E282267656172222C3630313532292C67696674';
wwv_flow_imp.g_varchar2_table(1440) := '3A756E282267696674222C3630313533292C676973745365637265743A756E2822676973742D736563726574222C3630313534292C676973743A756E282267697374222C3630313535292C676974436F6D6D69743A756E28226769742D636F6D6D697422';
wwv_flow_imp.g_varchar2_table(1441) := '2C3630313536292C676974436F6D706172653A756E28226769742D636F6D70617265222C3630313537292C636F6D706172654368616E6765733A756E2822636F6D706172652D6368616E676573222C3630313537292C6769744D657267653A756E282267';
wwv_flow_imp.g_varchar2_table(1442) := '69742D6D65726765222C3630313538292C676974687562416374696F6E3A756E28226769746875622D616374696F6E222C3630313539292C676974687562416C743A756E28226769746875622D616C74222C3630313630292C676C6F62653A756E282267';
wwv_flow_imp.g_varchar2_table(1443) := '6C6F6265222C3630313631292C677261626265723A756E282267726162626572222C3630313632292C67726170683A756E28226772617068222C3630313633292C677269707065723A756E282267726970706572222C3630313634292C68656172743A75';
wwv_flow_imp.g_varchar2_table(1444) := '6E28226865617274222C3630313635292C686F6D653A756E2822686F6D65222C3630313636292C686F72697A6F6E74616C52756C653A756E2822686F72697A6F6E74616C2D72756C65222C3630313637292C6875626F743A756E28226875626F74222C36';
wwv_flow_imp.g_varchar2_table(1445) := '30313638292C696E626F783A756E2822696E626F78222C3630313639292C697373756552656F70656E65643A756E282269737375652D72656F70656E6564222C3630313731292C6973737565733A756E2822697373756573222C3630313732292C697461';
wwv_flow_imp.g_varchar2_table(1446) := '6C69633A756E28226974616C6963222C3630313733292C6A65727365793A756E28226A6572736579222C3630313734292C6A736F6E3A756E28226A736F6E222C3630313735292C6B65626162566572746963616C3A756E28226B656261622D7665727469';
wwv_flow_imp.g_varchar2_table(1447) := '63616C222C3630313736292C6B65793A756E28226B6579222C3630313737292C6C61773A756E28226C6177222C3630313738292C6C6967687462756C624175746F6669783A756E28226C6967687462756C622D6175746F666978222C3630313739292C6C';
wwv_flow_imp.g_varchar2_table(1448) := '696E6B45787465726E616C3A756E28226C696E6B2D65787465726E616C222C3630313830292C6C696E6B3A756E28226C696E6B222C3630313831292C6C6973744F7264657265643A756E28226C6973742D6F726465726564222C3630313832292C6C6973';
wwv_flow_imp.g_varchar2_table(1449) := '74556E6F7264657265643A756E28226C6973742D756E6F726465726564222C3630313833292C6C69766553686172653A756E28226C6976652D7368617265222C3630313834292C6C6F6164696E673A756E28226C6F6164696E67222C3630313835292C6C';
wwv_flow_imp.g_varchar2_table(1450) := '6F636174696F6E3A756E28226C6F636174696F6E222C3630313836292C6D61696C526561643A756E28226D61696C2D72656164222C3630313837292C6D61696C3A756E28226D61696C222C3630313838292C6D61726B646F776E3A756E28226D61726B64';
wwv_flow_imp.g_varchar2_table(1451) := '6F776E222C3630313839292C6D65676170686F6E653A756E28226D65676170686F6E65222C3630313930292C6D656E74696F6E3A756E28226D656E74696F6E222C3630313931292C6D696C6573746F6E653A756E28226D696C6573746F6E65222C363031';
wwv_flow_imp.g_varchar2_table(1452) := '3932292C67697450756C6C526571756573744D696C6573746F6E653A756E28226769742D70756C6C2D726571756573742D6D696C6573746F6E65222C3630313932292C6D6F72746172426F6172643A756E28226D6F727461722D626F617264222C363031';
wwv_flow_imp.g_varchar2_table(1453) := '3933292C6D6F76653A756E28226D6F7665222C3630313934292C6D756C7469706C6557696E646F77733A756E28226D756C7469706C652D77696E646F7773222C3630313935292C6D7574653A756E28226D757465222C3630313936292C6E6F4E65776C69';
wwv_flow_imp.g_varchar2_table(1454) := '6E653A756E28226E6F2D6E65776C696E65222C3630313937292C6E6F74653A756E28226E6F7465222C3630313938292C6F63746F666163653A756E28226F63746F66616365222C3630313939292C6F70656E507265766965773A756E28226F70656E2D70';
wwv_flow_imp.g_varchar2_table(1455) := '726576696577222C3630323030292C7061636B6167653A756E28227061636B616765222C3630323031292C7061696E7463616E3A756E28227061696E7463616E222C3630323032292C70696E3A756E282270696E222C3630323033292C706C61793A756E';
wwv_flow_imp.g_varchar2_table(1456) := '2822706C6179222C3630323034292C72756E3A756E282272756E222C3630323034292C706C75673A756E2822706C7567222C3630323035292C7072657365727665436173653A756E282270726573657276652D63617365222C3630323036292C70726576';
wwv_flow_imp.g_varchar2_table(1457) := '6965773A756E282270726576696577222C3630323037292C70726F6A6563743A756E282270726F6A656374222C3630323038292C70756C73653A756E282270756C7365222C3630323039292C7175657374696F6E3A756E28227175657374696F6E222C36';
wwv_flow_imp.g_varchar2_table(1458) := '30323130292C71756F74653A756E282271756F7465222C3630323131292C726164696F546F7765723A756E2822726164696F2D746F776572222C3630323132292C7265616374696F6E733A756E28227265616374696F6E73222C3630323133292C726566';
wwv_flow_imp.g_varchar2_table(1459) := '6572656E6365733A756E28227265666572656E636573222C3630323134292C726566726573683A756E282272656672657368222C3630323135292C72656765783A756E28227265676578222C3630323136292C72656D6F74654578706C6F7265723A756E';
wwv_flow_imp.g_varchar2_table(1460) := '282272656D6F74652D6578706C6F726572222C3630323137292C72656D6F74653A756E282272656D6F7465222C3630323138292C72656D6F76653A756E282272656D6F7665222C3630323139292C7265706C616365416C6C3A756E28227265706C616365';
wwv_flow_imp.g_varchar2_table(1461) := '2D616C6C222C3630323230292C7265706C6163653A756E28227265706C616365222C3630323231292C7265706F436C6F6E653A756E28227265706F2D636C6F6E65222C3630323232292C7265706F466F726365507573683A756E28227265706F2D666F72';
wwv_flow_imp.g_varchar2_table(1462) := '63652D70757368222C3630323233292C7265706F50756C6C3A756E28227265706F2D70756C6C222C3630323234292C7265706F507573683A756E28227265706F2D70757368222C3630323235292C7265706F72743A756E28227265706F7274222C363032';
wwv_flow_imp.g_varchar2_table(1463) := '3236292C726571756573744368616E6765733A756E2822726571756573742D6368616E676573222C3630323237292C726F636B65743A756E2822726F636B6574222C3630323238292C726F6F74466F6C6465724F70656E65643A756E2822726F6F742D66';
wwv_flow_imp.g_varchar2_table(1464) := '6F6C6465722D6F70656E6564222C3630323239292C726F6F74466F6C6465723A756E2822726F6F742D666F6C646572222C3630323330292C7273733A756E2822727373222C3630323331292C727562793A756E282272756279222C3630323332292C7361';
wwv_flow_imp.g_varchar2_table(1465) := '7665416C6C3A756E2822736176652D616C6C222C3630323333292C7361766541733A756E2822736176652D6173222C3630323334292C736176653A756E282273617665222C3630323335292C73637265656E46756C6C3A756E282273637265656E2D6675';
wwv_flow_imp.g_varchar2_table(1466) := '6C6C222C3630323336292C73637265656E4E6F726D616C3A756E282273637265656E2D6E6F726D616C222C3630323337292C73656172636853746F703A756E28227365617263682D73746F70222C3630323338292C7365727665723A756E282273657276';
wwv_flow_imp.g_varchar2_table(1467) := '6572222C3630323430292C73657474696E6773476561723A756E282273657474696E67732D67656172222C3630323431292C73657474696E67733A756E282273657474696E6773222C3630323432292C736869656C643A756E2822736869656C64222C36';
wwv_flow_imp.g_varchar2_table(1468) := '30323433292C736D696C65793A756E2822736D696C6579222C3630323434292C736F7274507265636564656E63653A756E2822736F72742D707265636564656E6365222C3630323435292C73706C6974486F72697A6F6E74616C3A756E282273706C6974';
wwv_flow_imp.g_varchar2_table(1469) := '2D686F72697A6F6E74616C222C3630323436292C73706C6974566572746963616C3A756E282273706C69742D766572746963616C222C3630323437292C737175697272656C3A756E2822737175697272656C222C3630323438292C7374617246756C6C3A';
wwv_flow_imp.g_varchar2_table(1470) := '756E2822737461722D66756C6C222C3630323439292C7374617248616C663A756E2822737461722D68616C66222C3630323530292C73796D626F6C436C6173733A756E282273796D626F6C2D636C617373222C3630323531292C73796D626F6C436F6C6F';
wwv_flow_imp.g_varchar2_table(1471) := '723A756E282273796D626F6C2D636F6C6F72222C3630323532292C73796D626F6C436F6E7374616E743A756E282273796D626F6C2D636F6E7374616E74222C3630323533292C73796D626F6C456E756D4D656D6265723A756E282273796D626F6C2D656E';
wwv_flow_imp.g_varchar2_table(1472) := '756D2D6D656D626572222C3630323534292C73796D626F6C4669656C643A756E282273796D626F6C2D6669656C64222C3630323535292C73796D626F6C46696C653A756E282273796D626F6C2D66696C65222C3630323536292C73796D626F6C496E7465';
wwv_flow_imp.g_varchar2_table(1473) := '72666163653A756E282273796D626F6C2D696E74657266616365222C3630323537292C73796D626F6C4B6579776F72643A756E282273796D626F6C2D6B6579776F7264222C3630323538292C73796D626F6C4D6973633A756E282273796D626F6C2D6D69';
wwv_flow_imp.g_varchar2_table(1474) := '7363222C3630323539292C73796D626F6C4F70657261746F723A756E282273796D626F6C2D6F70657261746F72222C3630323630292C73796D626F6C50726F70657274793A756E282273796D626F6C2D70726F7065727479222C3630323631292C777265';
wwv_flow_imp.g_varchar2_table(1475) := '6E63683A756E28227772656E6368222C3630323631292C7772656E6368537562616374696F6E3A756E28227772656E63682D737562616374696F6E222C3630323631292C73796D626F6C536E69707065743A756E282273796D626F6C2D736E6970706574';
wwv_flow_imp.g_varchar2_table(1476) := '222C3630323632292C7461736B6C6973743A756E28227461736B6C697374222C3630323633292C74656C6573636F70653A756E282274656C6573636F7065222C3630323634292C7465787453697A653A756E2822746578742D73697A65222C3630323635';
wwv_flow_imp.g_varchar2_table(1477) := '292C7468726565426172733A756E282274687265652D62617273222C3630323636292C7468756D6273646F776E3A756E28227468756D6273646F776E222C3630323637292C7468756D627375703A756E28227468756D62737570222C3630323638292C74';
wwv_flow_imp.g_varchar2_table(1478) := '6F6F6C733A756E2822746F6F6C73222C3630323639292C747269616E676C65446F776E3A756E2822747269616E676C652D646F776E222C3630323730292C747269616E676C654C6566743A756E2822747269616E676C652D6C656674222C363032373129';
wwv_flow_imp.g_varchar2_table(1479) := '2C747269616E676C6552696768743A756E2822747269616E676C652D7269676874222C3630323732292C747269616E676C6555703A756E2822747269616E676C652D7570222C3630323733292C747769747465723A756E282274776974746572222C3630';
wwv_flow_imp.g_varchar2_table(1480) := '323734292C756E666F6C643A756E2822756E666F6C64222C3630323735292C756E6C6F636B3A756E2822756E6C6F636B222C3630323736292C756E6D7574653A756E2822756E6D757465222C3630323737292C756E76657269666965643A756E2822756E';
wwv_flow_imp.g_varchar2_table(1481) := '7665726966696564222C3630323738292C76657269666965643A756E28227665726966696564222C3630323739292C76657273696F6E733A756E282276657273696F6E73222C3630323830292C766D4163746976653A756E2822766D2D61637469766522';
wwv_flow_imp.g_varchar2_table(1482) := '2C3630323831292C766D4F75746C696E653A756E2822766D2D6F75746C696E65222C3630323832292C766D52756E6E696E673A756E2822766D2D72756E6E696E67222C3630323833292C77617463683A756E28227761746368222C3630323834292C7768';
wwv_flow_imp.g_varchar2_table(1483) := '69746573706163653A756E282277686974657370616365222C3630323835292C77686F6C65576F72643A756E282277686F6C652D776F7264222C3630323836292C77696E646F773A756E282277696E646F77222C3630323837292C776F7264577261703A';
wwv_flow_imp.g_varchar2_table(1484) := '756E2822776F72642D77726170222C3630323838292C7A6F6F6D496E3A756E28227A6F6F6D2D696E222C3630323839292C7A6F6F6D4F75743A756E28227A6F6F6D2D6F7574222C3630323930292C6C69737446696C7465723A756E28226C6973742D6669';
wwv_flow_imp.g_varchar2_table(1485) := '6C746572222C3630323931292C6C697374466C61743A756E28226C6973742D666C6174222C3630323932292C6C69737453656C656374696F6E3A756E28226C6973742D73656C656374696F6E222C3630323933292C73656C656374696F6E3A756E282273';
wwv_flow_imp.g_varchar2_table(1486) := '656C656374696F6E222C3630323933292C6C697374547265653A756E28226C6973742D74726565222C3630323934292C6465627567427265616B706F696E7446756E6374696F6E556E76657269666965643A756E282264656275672D627265616B706F69';
wwv_flow_imp.g_varchar2_table(1487) := '6E742D66756E6374696F6E2D756E7665726966696564222C3630323935292C6465627567427265616B706F696E7446756E6374696F6E3A756E282264656275672D627265616B706F696E742D66756E6374696F6E222C3630323936292C64656275674272';
wwv_flow_imp.g_varchar2_table(1488) := '65616B706F696E7446756E6374696F6E44697361626C65643A756E282264656275672D627265616B706F696E742D66756E6374696F6E2D64697361626C6564222C3630323936292C6465627567537461636B6672616D654163746976653A756E28226465';
wwv_flow_imp.g_varchar2_table(1489) := '6275672D737461636B6672616D652D616374697665222C3630323937292C636972636C65536D616C6C46696C6C65643A756E2822636972636C652D736D616C6C2D66696C6C6564222C3630323938292C6465627567537461636B6672616D65446F743A75';
wwv_flow_imp.g_varchar2_table(1490) := '6E282264656275672D737461636B6672616D652D646F74222C3630323938292C7465726D696E616C4465636F726174696F6E4D61726B3A756E28227465726D696E616C2D6465636F726174696F6E2D6D61726B222C3630323938292C6465627567537461';
wwv_flow_imp.g_varchar2_table(1491) := '636B6672616D653A756E282264656275672D737461636B6672616D65222C3630323939292C6465627567537461636B6672616D65466F63757365643A756E282264656275672D737461636B6672616D652D666F6375736564222C3630323939292C646562';
wwv_flow_imp.g_varchar2_table(1492) := '7567427265616B706F696E74556E737570706F727465643A756E282264656275672D627265616B706F696E742D756E737570706F72746564222C3630333030292C73796D626F6C537472696E673A756E282273796D626F6C2D737472696E67222C363033';
wwv_flow_imp.g_varchar2_table(1493) := '3031292C646562756752657665727365436F6E74696E75653A756E282264656275672D726576657273652D636F6E74696E7565222C3630333032292C6465627567537465704261636B3A756E282264656275672D737465702D6261636B222C3630333033';
wwv_flow_imp.g_varchar2_table(1494) := '292C6465627567526573746172744672616D653A756E282264656275672D726573746172742D6672616D65222C3630333034292C6465627567416C743A756E282264656275672D616C74222C3630333035292C63616C6C496E636F6D696E673A756E2822';
wwv_flow_imp.g_varchar2_table(1495) := '63616C6C2D696E636F6D696E67222C3630333036292C63616C6C4F7574676F696E673A756E282263616C6C2D6F7574676F696E67222C3630333037292C6D656E753A756E28226D656E75222C3630333038292C657870616E64416C6C3A756E2822657870';
wwv_flow_imp.g_varchar2_table(1496) := '616E642D616C6C222C3630333039292C666565646261636B3A756E2822666565646261636B222C3630333130292C67697450756C6C5265717565737452657669657765723A756E28226769742D70756C6C2D726571756573742D7265766965776572222C';
wwv_flow_imp.g_varchar2_table(1497) := '3630333130292C67726F75704279526566547970653A756E282267726F75702D62792D7265662D74797065222C3630333131292C756E67726F75704279526566547970653A756E2822756E67726F75702D62792D7265662D74797065222C363033313229';
wwv_flow_imp.g_varchar2_table(1498) := '2C6163636F756E743A756E28226163636F756E74222C3630333133292C67697450756C6C5265717565737441737369676E65653A756E28226769742D70756C6C2D726571756573742D61737369676E6565222C3630333133292C62656C6C446F743A756E';
wwv_flow_imp.g_varchar2_table(1499) := '282262656C6C2D646F74222C3630333134292C6465627567436F6E736F6C653A756E282264656275672D636F6E736F6C65222C3630333135292C6C6962726172793A756E28226C696272617279222C3630333136292C6F75747075743A756E28226F7574';
wwv_flow_imp.g_varchar2_table(1500) := '707574222C3630333137292C72756E416C6C3A756E282272756E2D616C6C222C3630333138292C73796E6349676E6F7265643A756E282273796E632D69676E6F726564222C3630333139292C70696E6E65643A756E282270696E6E6564222C3630333230';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '292C676974687562496E7665727465643A756E28226769746875622D696E766572746564222C3630333231292C73657276657250726F636573733A756E28227365727665722D70726F63657373222C3630333232292C736572766572456E7669726F6E6D';
wwv_flow_imp.g_varchar2_table(1502) := '656E743A756E28227365727665722D656E7669726F6E6D656E74222C3630333233292C706173733A756E282270617373222C3630333234292C6973737565436C6F7365643A756E282269737375652D636C6F736564222C3630333234292C73746F704369';
wwv_flow_imp.g_varchar2_table(1503) := '72636C653A756E282273746F702D636972636C65222C3630333235292C706C6179436972636C653A756E2822706C61792D636972636C65222C3630333236292C7265636F72643A756E28227265636F7264222C3630333237292C6465627567416C74536D';
wwv_flow_imp.g_varchar2_table(1504) := '616C6C3A756E282264656275672D616C742D736D616C6C222C3630333238292C766D436F6E6E6563743A756E2822766D2D636F6E6E656374222C3630333239292C636C6F75643A756E2822636C6F7564222C3630333330292C6D657267653A756E28226D';
wwv_flow_imp.g_varchar2_table(1505) := '65726765222C3630333331292C6578706F72743A756E28226578706F7274222C3630333332292C67726170684C6566743A756E282267726170682D6C656674222C3630333333292C6D61676E65743A756E28226D61676E6574222C3630333334292C6E6F';
wwv_flow_imp.g_varchar2_table(1506) := '7465626F6F6B3A756E28226E6F7465626F6F6B222C3630333335292C7265646F3A756E28227265646F222C3630333336292C636865636B416C6C3A756E2822636865636B2D616C6C222C3630333337292C70696E6E656444697274793A756E282270696E';
wwv_flow_imp.g_varchar2_table(1507) := '6E65642D6469727479222C3630333338292C7061737346696C6C65643A756E2822706173732D66696C6C6564222C3630333339292C636972636C654C6172676546696C6C65643A756E2822636972636C652D6C617267652D66696C6C6564222C36303334';
wwv_flow_imp.g_varchar2_table(1508) := '30292C636972636C654C617267653A756E2822636972636C652D6C61726765222C3630333431292C636972636C654C617267654F75746C696E653A756E2822636972636C652D6C617267652D6F75746C696E65222C3630333431292C636F6D62696E653A';
wwv_flow_imp.g_varchar2_table(1509) := '756E2822636F6D62696E65222C3630333432292C6761746865723A756E2822676174686572222C3630333432292C7461626C653A756E28227461626C65222C3630333433292C7661726961626C6547726F75703A756E28227661726961626C652D67726F';
wwv_flow_imp.g_varchar2_table(1510) := '7570222C3630333434292C747970654869657261726368793A756E2822747970652D686965726172636879222C3630333435292C747970654869657261726368795375623A756E2822747970652D6869657261726368792D737562222C3630333436292C';
wwv_flow_imp.g_varchar2_table(1511) := '7479706548696572617263687953757065723A756E2822747970652D6869657261726368792D7375706572222C3630333437292C67697450756C6C526571756573744372656174653A756E28226769742D70756C6C2D726571756573742D637265617465';
wwv_flow_imp.g_varchar2_table(1512) := '222C3630333438292C72756E41626F76653A756E282272756E2D61626F7665222C3630333439292C72756E42656C6F773A756E282272756E2D62656C6F77222C3630333530292C6E6F7465626F6F6B54656D706C6174653A756E28226E6F7465626F6F6B';
wwv_flow_imp.g_varchar2_table(1513) := '2D74656D706C617465222C3630333531292C6465627567526572756E3A756E282264656275672D726572756E222C3630333532292C776F726B7370616365547275737465643A756E2822776F726B73706163652D74727573746564222C3630333533292C';
wwv_flow_imp.g_varchar2_table(1514) := '776F726B7370616365556E747275737465643A756E2822776F726B73706163652D756E74727573746564222C3630333534292C776F726B7370616365556E6B6E6F776E3A756E2822776F726B73706163652D756E6B6E6F776E222C3630333535292C7465';
wwv_flow_imp.g_varchar2_table(1515) := '726D696E616C436D643A756E28227465726D696E616C2D636D64222C3630333536292C7465726D696E616C44656269616E3A756E28227465726D696E616C2D64656269616E222C3630333537292C7465726D696E616C4C696E75783A756E28227465726D';
wwv_flow_imp.g_varchar2_table(1516) := '696E616C2D6C696E7578222C3630333538292C7465726D696E616C506F7765727368656C6C3A756E28227465726D696E616C2D706F7765727368656C6C222C3630333539292C7465726D696E616C546D75783A756E28227465726D696E616C2D746D7578';
wwv_flow_imp.g_varchar2_table(1517) := '222C3630333630292C7465726D696E616C5562756E74753A756E28227465726D696E616C2D7562756E7475222C3630333631292C7465726D696E616C426173683A756E28227465726D696E616C2D62617368222C3630333632292C6172726F7753776170';
wwv_flow_imp.g_varchar2_table(1518) := '3A756E28226172726F772D73776170222C3630333633292C636F70793A756E2822636F7079222C3630333634292C706572736F6E4164643A756E2822706572736F6E2D616464222C3630333635292C66696C74657246696C6C65643A756E282266696C74';
wwv_flow_imp.g_varchar2_table(1519) := '65722D66696C6C6564222C3630333636292C77616E643A756E282277616E64222C3630333637292C64656275674C696E6542794C696E653A756E282264656275672D6C696E652D62792D6C696E65222C3630333638292C696E73706563743A756E282269';
wwv_flow_imp.g_varchar2_table(1520) := '6E7370656374222C3630333639292C6C61796572733A756E28226C6179657273222C3630333730292C6C6179657273446F743A756E28226C61796572732D646F74222C3630333731292C6C61796572734163746976653A756E28226C61796572732D6163';
wwv_flow_imp.g_varchar2_table(1521) := '74697665222C3630333732292C636F6D706173733A756E2822636F6D70617373222C3630333733292C636F6D70617373446F743A756E2822636F6D706173732D646F74222C3630333734292C636F6D706173734163746976653A756E2822636F6D706173';
wwv_flow_imp.g_varchar2_table(1522) := '732D616374697665222C3630333735292C617A7572653A756E2822617A757265222C3630333736292C697373756544726166743A756E282269737375652D6472616674222C3630333737292C67697450756C6C52657175657374436C6F7365643A756E28';
wwv_flow_imp.g_varchar2_table(1523) := '226769742D70756C6C2D726571756573742D636C6F736564222C3630333738292C67697450756C6C5265717565737444726166743A756E28226769742D70756C6C2D726571756573742D6472616674222C3630333739292C6465627567416C6C3A756E28';
wwv_flow_imp.g_varchar2_table(1524) := '2264656275672D616C6C222C3630333830292C6465627567436F7665726167653A756E282264656275672D636F766572616765222C3630333831292C72756E4572726F72733A756E282272756E2D6572726F7273222C3630333832292C666F6C6465724C';
wwv_flow_imp.g_varchar2_table(1525) := '6962726172793A756E2822666F6C6465722D6C696272617279222C3630333833292C6465627567436F6E74696E7565536D616C6C3A756E282264656275672D636F6E74696E75652D736D616C6C222C3630333834292C6265616B657253746F703A756E28';
wwv_flow_imp.g_varchar2_table(1526) := '226265616B65722D73746F70222C3630333835292C67726170684C696E653A756E282267726170682D6C696E65222C3630333836292C6772617068536361747465723A756E282267726170682D73636174746572222C3630333837292C70696543686172';
wwv_flow_imp.g_varchar2_table(1527) := '743A756E28227069652D6368617274222C3630333838292C627261636B65743A756E2822627261636B6574222C3630313735292C627261636B6574446F743A756E2822627261636B65742D646F74222C3630333839292C627261636B65744572726F723A';
wwv_flow_imp.g_varchar2_table(1528) := '756E2822627261636B65742D6572726F72222C3630333930292C6C6F636B536D616C6C3A756E28226C6F636B2D736D616C6C222C3630333931292C617A7572654465766F70733A756E2822617A7572652D6465766F7073222C3630333932292C76657269';
wwv_flow_imp.g_varchar2_table(1529) := '6669656446696C6C65643A756E282276657269666965642D66696C6C6564222C3630333933292C6E65776C696E653A756E28226E65776C696E65222C3630333934292C6C61796F75743A756E28226C61796F7574222C3630333935292C6C61796F757441';
wwv_flow_imp.g_varchar2_table(1530) := '637469766974796261724C6566743A756E28226C61796F75742D61637469766974796261722D6C656674222C3630333936292C6C61796F7574416374697669747962617252696768743A756E28226C61796F75742D61637469766974796261722D726967';
wwv_flow_imp.g_varchar2_table(1531) := '6874222C3630333937292C6C61796F757450616E656C4C6566743A756E28226C61796F75742D70616E656C2D6C656674222C3630333938292C6C61796F757450616E656C43656E7465723A756E28226C61796F75742D70616E656C2D63656E746572222C';
wwv_flow_imp.g_varchar2_table(1532) := '3630333939292C6C61796F757450616E656C4A7573746966793A756E28226C61796F75742D70616E656C2D6A757374696679222C3630343030292C6C61796F757450616E656C52696768743A756E28226C61796F75742D70616E656C2D7269676874222C';
wwv_flow_imp.g_varchar2_table(1533) := '3630343031292C6C61796F757450616E656C3A756E28226C61796F75742D70616E656C222C3630343032292C6C61796F7574536964656261724C6566743A756E28226C61796F75742D736964656261722D6C656674222C3630343033292C6C61796F7574';
wwv_flow_imp.g_varchar2_table(1534) := '5369646562617252696768743A756E28226C61796F75742D736964656261722D7269676874222C3630343034292C6C61796F75745374617475736261723A756E28226C61796F75742D737461747573626172222C3630343035292C6C61796F75744D656E';
wwv_flow_imp.g_varchar2_table(1535) := '756261723A756E28226C61796F75742D6D656E75626172222C3630343036292C6C61796F757443656E74657265643A756E28226C61796F75742D63656E7465726564222C3630343037292C7461726765743A756E2822746172676574222C363034303829';
wwv_flow_imp.g_varchar2_table(1536) := '2C696E64656E743A756E2822696E64656E74222C3630343039292C7265636F7264536D616C6C3A756E28227265636F72642D736D616C6C222C3630343130292C6572726F72536D616C6C3A756E28226572726F722D736D616C6C222C3630343131292C74';
wwv_flow_imp.g_varchar2_table(1537) := '65726D696E616C4465636F726174696F6E4572726F723A756E28227465726D696E616C2D6465636F726174696F6E2D6572726F72222C3630343131292C6172726F77436972636C65446F776E3A756E28226172726F772D636972636C652D646F776E222C';
wwv_flow_imp.g_varchar2_table(1538) := '3630343132292C6172726F77436972636C654C6566743A756E28226172726F772D636972636C652D6C656674222C3630343133292C6172726F77436972636C6552696768743A756E28226172726F772D636972636C652D7269676874222C363034313429';
wwv_flow_imp.g_varchar2_table(1539) := '2C6172726F77436972636C6555703A756E28226172726F772D636972636C652D7570222C3630343135292C6C61796F75745369646562617252696768744F66663A756E28226C61796F75742D736964656261722D72696768742D6F6666222C3630343136';
wwv_flow_imp.g_varchar2_table(1540) := '292C6C61796F757450616E656C4F66663A756E28226C61796F75742D70616E656C2D6F6666222C3630343137292C6C61796F7574536964656261724C6566744F66663A756E28226C61796F75742D736964656261722D6C6566742D6F6666222C36303431';
wwv_flow_imp.g_varchar2_table(1541) := '38292C626C616E6B3A756E2822626C616E6B222C3630343139292C686561727446696C6C65643A756E282268656172742D66696C6C6564222C3630343230292C6D61703A756E28226D6170222C3630343231292C6D6170486F72697A6F6E74616C3A756E';
wwv_flow_imp.g_varchar2_table(1542) := '28226D61702D686F72697A6F6E74616C222C3630343231292C666F6C64486F72697A6F6E74616C3A756E2822666F6C642D686F72697A6F6E74616C222C3630343231292C6D617046696C6C65643A756E28226D61702D66696C6C6564222C363034323229';
wwv_flow_imp.g_varchar2_table(1543) := '2C6D6170486F72697A6F6E74616C46696C6C65643A756E28226D61702D686F72697A6F6E74616C2D66696C6C6564222C3630343232292C666F6C64486F72697A6F6E74616C46696C6C65643A756E2822666F6C642D686F72697A6F6E74616C2D66696C6C';
wwv_flow_imp.g_varchar2_table(1544) := '6564222C3630343232292C636972636C65536D616C6C3A756E2822636972636C652D736D616C6C222C3630343233292C62656C6C536C6173683A756E282262656C6C2D736C617368222C3630343234292C62656C6C536C617368446F743A756E28226265';
wwv_flow_imp.g_varchar2_table(1545) := '6C6C2D736C6173682D646F74222C3630343235292C636F6D6D656E74556E7265736F6C7665643A756E2822636F6D6D656E742D756E7265736F6C766564222C3630343236292C67697450756C6C52657175657374476F546F4368616E6765733A756E2822';
wwv_flow_imp.g_varchar2_table(1546) := '6769742D70756C6C2D726571756573742D676F2D746F2D6368616E676573222C3630343237292C67697450756C6C526571756573744E65774368616E6765733A756E28226769742D70756C6C2D726571756573742D6E65772D6368616E676573222C3630';
wwv_flow_imp.g_varchar2_table(1547) := '343238292C73656172636846757A7A793A756E28227365617263682D66757A7A79222C3630343239292C636F6D6D656E7444726166743A756E2822636F6D6D656E742D6472616674222C3630343330292C73656E643A756E282273656E64222C36303433';
wwv_flow_imp.g_varchar2_table(1548) := '31292C737061726B6C653A756E2822737061726B6C65222C3630343332292C696E736572743A756E2822696E73657274222C3630343333292C6D69633A756E28226D6963222C3630343334292C7468756D6273646F776E46696C6C65643A756E28227468';
wwv_flow_imp.g_varchar2_table(1549) := '756D6273646F776E2D66696C6C6564222C3630343335292C7468756D6273757046696C6C65643A756E28227468756D627375702D66696C6C6564222C3630343336292C636F666665653A756E2822636F66666565222C3630343337292C736E616B653A75';
wwv_flow_imp.g_varchar2_table(1550) := '6E2822736E616B65222C3630343338292C67616D653A756E282267616D65222C3630343339292C76723A756E28227672222C3630343430292C636869703A756E282263686970222C3630343431292C7069616E6F3A756E28227069616E6F222C36303434';
wwv_flow_imp.g_varchar2_table(1551) := '32292C6D757369633A756E28226D75736963222C3630343433292C6D696346696C6C65643A756E28226D69632D66696C6C6564222C3630343434292C7265706F46657463683A756E28227265706F2D6665746368222C3630343435292C636F70696C6F74';
wwv_flow_imp.g_varchar2_table(1552) := '3A756E2822636F70696C6F74222C3630343436292C6C6967687462756C62537061726B6C653A756E28226C6967687462756C622D737061726B6C65222C3630343437292C726F626F743A756E2822726F626F74222C3630343438292C737061726B6C6546';
wwv_flow_imp.g_varchar2_table(1553) := '696C6C65643A756E2822737061726B6C652D66696C6C6564222C3630343439292C6469666653696E676C653A756E2822646966662D73696E676C65222C3630343530292C646966664D756C7469706C653A756E2822646966662D6D756C7469706C65222C';
wwv_flow_imp.g_varchar2_table(1554) := '3630343531292C737572726F756E64576974683A756E2822737572726F756E642D77697468222C3630343532292C73686172653A756E28227368617265222C3630343533292C67697453746173683A756E28226769742D7374617368222C363034353429';
wwv_flow_imp.g_varchar2_table(1555) := '2C67697453746173684170706C793A756E28226769742D73746173682D6170706C79222C3630343535292C6769745374617368506F703A756E28226769742D73746173682D706F70222C3630343536292C7673636F64653A756E28227673636F6465222C';
wwv_flow_imp.g_varchar2_table(1556) := '3630343537292C7673636F6465496E7369646572733A756E28227673636F64652D696E736964657273222C3630343538292C636F64654F73733A756E2822636F64652D6F7373222C3630343539292C72756E436F7665726167653A756E282272756E2D63';
wwv_flow_imp.g_varchar2_table(1557) := '6F766572616765222C3630343630292C72756E416C6C436F7665726167653A756E282272756E2D616C6C2D636F766572616765222C3630343631292C636F7665726167653A756E2822636F766572616765222C3630343632292C67697468756250726F6A';
wwv_flow_imp.g_varchar2_table(1558) := '6563743A756E28226769746875622D70726F6A656374222C3630343633292C6D6170566572746963616C3A756E28226D61702D766572746963616C222C3630343634292C666F6C64566572746963616C3A756E2822666F6C642D766572746963616C222C';
wwv_flow_imp.g_varchar2_table(1559) := '3630343634292C6D6170566572746963616C46696C6C65643A756E28226D61702D766572746963616C2D66696C6C6564222C3630343635292C666F6C64566572746963616C46696C6C65643A756E2822666F6C642D766572746963616C2D66696C6C6564';
wwv_flow_imp.g_varchar2_table(1560) := '222C3630343635292C676F546F5365617263683A756E2822676F2D746F2D736561726368222C3630343636292C70657263656E746167653A756E282270657263656E74616765222C3630343637292C736F727450657263656E746167653A756E2822736F';
wwv_flow_imp.g_varchar2_table(1561) := '72742D70657263656E74616765222C3630343637292C6469616C6F674572726F723A756E28226469616C6F672D6572726F72222C226572726F7222292C6469616C6F675761726E696E673A756E28226469616C6F672D7761726E696E67222C227761726E';
wwv_flow_imp.g_varchar2_table(1562) := '696E6722292C6469616C6F67496E666F3A756E28226469616C6F672D696E666F222C22696E666F22292C6469616C6F67436C6F73653A756E28226469616C6F672D636C6F7365222C22636C6F736522292C747265654974656D457870616E6465643A756E';
wwv_flow_imp.g_varchar2_table(1563) := '2822747265652D6974656D2D657870616E646564222C2263686576726F6E2D646F776E22292C7472656546696C7465724F6E547970654F6E3A756E2822747265652D66696C7465722D6F6E2D747970652D6F6E222C226C6973742D66696C74657222292C';
wwv_flow_imp.g_varchar2_table(1564) := '7472656546696C7465724F6E547970654F66663A756E2822747265652D66696C7465722D6F6E2D747970652D6F6666222C226C6973742D73656C656374696F6E22292C7472656546696C746572436C6561723A756E2822747265652D66696C7465722D63';
wwv_flow_imp.g_varchar2_table(1565) := '6C656172222C22636C6F736522292C747265654974656D4C6F6164696E673A756E2822747265652D6974656D2D6C6F6164696E67222C226C6F6164696E6722292C6D656E7553656C656374696F6E3A756E28226D656E752D73656C656374696F6E222C22';
wwv_flow_imp.g_varchar2_table(1566) := '636865636B22292C6D656E755375626D656E753A756E28226D656E752D7375626D656E75222C2263686576726F6E2D726967687422292C6D656E754261724D6F72653A756E28226D656E756261722D6D6F7265222C226D6F726522292C7363726F6C6C62';
wwv_flow_imp.g_varchar2_table(1567) := '6172427574746F6E4C6566743A756E28227363726F6C6C6261722D627574746F6E2D6C656674222C22747269616E676C652D6C65667422292C7363726F6C6C626172427574746F6E52696768743A756E28227363726F6C6C6261722D627574746F6E2D72';
wwv_flow_imp.g_varchar2_table(1568) := '69676874222C22747269616E676C652D726967687422292C7363726F6C6C626172427574746F6E55703A756E28227363726F6C6C6261722D627574746F6E2D7570222C22747269616E676C652D757022292C7363726F6C6C626172427574746F6E446F77';
wwv_flow_imp.g_varchar2_table(1569) := '6E3A756E28227363726F6C6C6261722D627574746F6E2D646F776E222C22747269616E676C652D646F776E22292C746F6F6C4261724D6F72653A756E2822746F6F6C6261722D6D6F7265222C226D6F726522292C717569636B496E7075744261636B3A75';
wwv_flow_imp.g_varchar2_table(1570) := '6E2822717569636B2D696E7075742D6261636B222C226172726F772D6C65667422292C64726F70446F776E427574746F6E3A756E282264726F702D646F776E2D627574746F6E222C3630303834292C73796D626F6C437573746F6D436F6C6F723A756E28';
wwv_flow_imp.g_varchar2_table(1571) := '2273796D626F6C2D637573746F6D636F6C6F72222C3630323532292C6578706F727449636F6E3A756E28226578706F7274222C3630333332292C776F726B7370616365556E7370656369666965643A756E2822776F726B73706163652D756E7370656369';
wwv_flow_imp.g_varchar2_table(1572) := '66696564222C3630333535292C6E65774C696E653A756E28226E65776C696E65222C3630333934292C7468756D6273446F776E46696C6C65643A756E28227468756D6273646F776E2D66696C6C6564222C3630343335292C7468756D6273557046696C6C';
wwv_flow_imp.g_varchar2_table(1573) := '65643A756E28227468756D627375702D66696C6C6564222C3630343336292C67697446657463683A756E28226769742D6665746368222C3630343435292C6C6967687462756C62537061726B6C654175746F6669783A756E28226C6967687462756C622D';
wwv_flow_imp.g_varchar2_table(1574) := '737061726B6C652D6175746F666978222C3630343437292C6465627567427265616B706F696E7450656E64696E673A756E282264656275672D627265616B706F696E742D70656E64696E67222C3630333737297D3B636C61737320636E20657874656E64';
wwv_flow_imp.g_varchar2_table(1575) := '7320707B6765742069735265736F6C76656428297B72657475726E20746869732E5F69735265736F6C7665647D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F72656769737472793D652C746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(1576) := '61676549643D742C746869732E5F666163746F72793D6E2C746869732E5F6973446973706F7365643D21312C746869732E5F7265736F6C766550726F6D6973653D6E756C6C2C746869732E5F69735265736F6C7665643D21317D646973706F736528297B';
wwv_flow_imp.g_varchar2_table(1577) := '746869732E5F6973446973706F7365643D21302C73757065722E646973706F736528297D6173796E63207265736F6C766528297B72657475726E20746869732E5F7265736F6C766550726F6D6973657C7C28746869732E5F7265736F6C766550726F6D69';
wwv_flow_imp.g_varchar2_table(1578) := '73653D746869732E5F6372656174652829292C746869732E5F7265736F6C766550726F6D6973657D6173796E63205F63726561746528297B636F6E737420653D617761697420746869732E5F666163746F72792E746F6B656E697A6174696F6E53757070';
wwv_flow_imp.g_varchar2_table(1579) := '6F72743B746869732E5F69735265736F6C7665643D21302C65262621746869732E5F6973446973706F7365642626746869732E5F726567697374657228746869732E5F72656769737472792E726567697374657228746869732E5F6C616E677561676549';
wwv_flow_imp.g_varchar2_table(1580) := '642C6529297D7D76617220646E2C6D6E2C676E2C666E2C706E2C626E2C5F6E2C766E2C436E2C796E2C4C6E2C776E2C4E6E2C456E2C536E2C526E2C416E2C786E2C4D6E2C6B6E2C4F6E2C546E2C496E2C506E2C446E2C466E2C4B6E2C716E2C566E2C426E';
wwv_flow_imp.g_varchar2_table(1581) := '2C556E2C7A6E2C486E2C576E2C246E2C6A6E2C476E2C516E2C586E2C4A6E2C596E2C5A6E2C65692C74692C6E692C69692C72692C73692C6F692C61692C6C692C75692C68692C63692C64692C6D692C67692C66692C70692C62692C5F692C76692C43693B';
wwv_flow_imp.g_varchar2_table(1582) := '2166756E6374696F6E2865297B655B652E496E6372656173653D305D3D22496E637265617365222C655B652E44656372656173653D315D3D224465637265617365227D28646E7C7C28646E3D7B7D29292C66756E6374696F6E2865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(1583) := '3D6E6577204D61703B742E73657428302C686E2E73796D626F6C4D6574686F64292C742E73657428312C686E2E73796D626F6C46756E6374696F6E292C742E73657428322C686E2E73796D626F6C436F6E7374727563746F72292C742E73657428332C68';
wwv_flow_imp.g_varchar2_table(1584) := '6E2E73796D626F6C4669656C64292C742E73657428342C686E2E73796D626F6C5661726961626C65292C742E73657428352C686E2E73796D626F6C436C617373292C742E73657428362C686E2E73796D626F6C537472756374292C742E73657428372C68';
wwv_flow_imp.g_varchar2_table(1585) := '6E2E73796D626F6C496E74657266616365292C742E73657428382C686E2E73796D626F6C4D6F64756C65292C742E73657428392C686E2E73796D626F6C50726F7065727479292C742E7365742831302C686E2E73796D626F6C4576656E74292C742E7365';
wwv_flow_imp.g_varchar2_table(1586) := '742831312C686E2E73796D626F6C4F70657261746F72292C742E7365742831322C686E2E73796D626F6C556E6974292C742E7365742831332C686E2E73796D626F6C56616C7565292C742E7365742831352C686E2E73796D626F6C456E756D292C742E73';
wwv_flow_imp.g_varchar2_table(1587) := '65742831342C686E2E73796D626F6C436F6E7374616E74292C742E7365742831352C686E2E73796D626F6C456E756D292C742E7365742831362C686E2E73796D626F6C456E756D4D656D626572292C742E7365742831372C686E2E73796D626F6C4B6579';
wwv_flow_imp.g_varchar2_table(1588) := '776F7264292C742E7365742832372C686E2E73796D626F6C536E6970706574292C742E7365742831382C686E2E73796D626F6C54657874292C742E7365742831392C686E2E73796D626F6C436F6C6F72292C742E7365742832302C686E2E73796D626F6C';
wwv_flow_imp.g_varchar2_table(1589) := '46696C65292C742E7365742832312C686E2E73796D626F6C5265666572656E6365292C742E7365742832322C686E2E73796D626F6C437573746F6D436F6C6F72292C742E7365742832332C686E2E73796D626F6C466F6C646572292C742E736574283234';
wwv_flow_imp.g_varchar2_table(1590) := '2C686E2E73796D626F6C54797065506172616D65746572292C742E7365742832352C686E2E6163636F756E74292C742E7365742832362C686E2E697373756573292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865';
wwv_flow_imp.g_varchar2_table(1591) := '293B72657475726E206E7C7C28636F6E736F6C652E696E666F28224E6F20636F6469636F6E20666F756E6420666F7220436F6D706C6574696F6E4974656D4B696E6420222B65292C6E3D686E2E73796D626F6C50726F7065727479292C6E7D3B636F6E73';
wwv_flow_imp.g_varchar2_table(1592) := '74206E3D6E6577204D61703B6E2E73657428226D6574686F64222C30292C6E2E736574282266756E6374696F6E222C31292C6E2E7365742822636F6E7374727563746F72222C32292C6E2E73657428226669656C64222C33292C6E2E7365742822766172';
wwv_flow_imp.g_varchar2_table(1593) := '6961626C65222C34292C6E2E7365742822636C617373222C35292C6E2E7365742822737472756374222C36292C6E2E7365742822696E74657266616365222C37292C6E2E73657428226D6F64756C65222C38292C6E2E736574282270726F706572747922';
wwv_flow_imp.g_varchar2_table(1594) := '2C39292C6E2E73657428226576656E74222C3130292C6E2E73657428226F70657261746F72222C3131292C6E2E7365742822756E6974222C3132292C6E2E736574282276616C7565222C3133292C6E2E7365742822636F6E7374616E74222C3134292C6E';
wwv_flow_imp.g_varchar2_table(1595) := '2E7365742822656E756D222C3135292C6E2E7365742822656E756D2D6D656D626572222C3136292C6E2E7365742822656E756D4D656D626572222C3136292C6E2E73657428226B6579776F7264222C3137292C6E2E7365742822736E6970706574222C32';
wwv_flow_imp.g_varchar2_table(1596) := '37292C6E2E736574282274657874222C3138292C6E2E7365742822636F6C6F72222C3139292C6E2E736574282266696C65222C3230292C6E2E73657428227265666572656E6365222C3231292C6E2E7365742822637573746F6D636F6C6F72222C323229';
wwv_flow_imp.g_varchar2_table(1597) := '2C6E2E7365742822666F6C646572222C3233292C6E2E7365742822747970652D706172616D65746572222C3234292C6E2E736574282274797065506172616D65746572222C3234292C6E2E73657428226163636F756E74222C3235292C6E2E7365742822';
wwv_flow_imp.g_varchar2_table(1598) := '6973737565222C3236292C652E66726F6D537472696E673D66756E6374696F6E28652C74297B6C657420693D6E2E6765742865293B72657475726E20766F69642030213D3D697C7C747C7C28693D39292C697D7D286D6E7C7C286D6E3D7B7D29292C6675';
wwv_flow_imp.g_varchar2_table(1599) := '6E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B652E4578706C696369743D315D3D224578706C69636974227D28676E7C7C28676E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F';
wwv_flow_imp.g_varchar2_table(1600) := '6D617469633D305D3D224175746F6D61746963222C655B652E506173746541733D315D3D2250617374654173227D28666E7C7C28666E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E54';
wwv_flow_imp.g_varchar2_table(1601) := '7269676765724368617261637465723D325D3D2254726967676572436861726163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E6765227D28706E7C7C28706E3D7B7D29292C66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(1602) := '7B655B652E546578743D305D3D2254657874222C655B652E526561643D315D3D2252656164222C655B652E57726974653D325D3D225772697465227D28626E7C7C28626E3D7B7D29292C4D28302C22617272617922292C4D28302C22626F6F6C65616E22';
wwv_flow_imp.g_varchar2_table(1603) := '292C4D28302C22636C61737322292C4D28302C22636F6E7374616E7422292C4D28302C22636F6E7374727563746F7222292C4D28302C22656E756D65726174696F6E22292C4D28302C22656E756D65726174696F6E206D656D62657222292C4D28302C22';
wwv_flow_imp.g_varchar2_table(1604) := '6576656E7422292C4D28302C226669656C6422292C4D28302C2266696C6522292C4D28302C2266756E6374696F6E22292C4D28302C22696E7465726661636522292C4D28302C226B657922292C4D28302C226D6574686F6422292C4D28302C226D6F6475';
wwv_flow_imp.g_varchar2_table(1605) := '6C6522292C4D28302C226E616D65737061636522292C4D28302C226E756C6C22292C4D28302C226E756D62657222292C4D28302C226F626A65637422292C4D28302C226F70657261746F7222292C4D28302C227061636B61676522292C4D28302C227072';
wwv_flow_imp.g_varchar2_table(1606) := '6F706572747922292C4D28302C22737472696E6722292C4D28302C2273747275637422292C4D28302C227479706520706172616D6574657222292C4D28302C227661726961626C6522292C66756E6374696F6E2865297B636F6E737420743D6E6577204D';
wwv_flow_imp.g_varchar2_table(1607) := '61703B742E73657428302C686E2E73796D626F6C46696C65292C742E73657428312C686E2E73796D626F6C4D6F64756C65292C742E73657428322C686E2E73796D626F6C4E616D657370616365292C742E73657428332C686E2E73796D626F6C5061636B';
wwv_flow_imp.g_varchar2_table(1608) := '616765292C742E73657428342C686E2E73796D626F6C436C617373292C742E73657428352C686E2E73796D626F6C4D6574686F64292C742E73657428362C686E2E73796D626F6C50726F7065727479292C742E73657428372C686E2E73796D626F6C4669';
wwv_flow_imp.g_varchar2_table(1609) := '656C64292C742E73657428382C686E2E73796D626F6C436F6E7374727563746F72292C742E73657428392C686E2E73796D626F6C456E756D292C742E7365742831302C686E2E73796D626F6C496E74657266616365292C742E7365742831312C686E2E73';
wwv_flow_imp.g_varchar2_table(1610) := '796D626F6C46756E6374696F6E292C742E7365742831322C686E2E73796D626F6C5661726961626C65292C742E7365742831332C686E2E73796D626F6C436F6E7374616E74292C742E7365742831342C686E2E73796D626F6C537472696E67292C742E73';
wwv_flow_imp.g_varchar2_table(1611) := '65742831352C686E2E73796D626F6C4E756D626572292C742E7365742831362C686E2E73796D626F6C426F6F6C65616E292C742E7365742831372C686E2E73796D626F6C4172726179292C742E7365742831382C686E2E73796D626F6C4F626A65637429';
wwv_flow_imp.g_varchar2_table(1612) := '2C742E7365742831392C686E2E73796D626F6C4B6579292C742E7365742832302C686E2E73796D626F6C4E756C6C292C742E7365742832312C686E2E73796D626F6C456E756D4D656D626572292C742E7365742832322C686E2E73796D626F6C53747275';
wwv_flow_imp.g_varchar2_table(1613) := '6374292C742E7365742832332C686E2E73796D626F6C4576656E74292C742E7365742832342C686E2E73796D626F6C4F70657261746F72292C742E7365742832352C686E2E73796D626F6C54797065506172616D65746572292C652E746F49636F6E3D66';
wwv_flow_imp.g_varchar2_table(1614) := '756E6374696F6E2865297B6C6574206E3D742E6765742865293B72657475726E206E7C7C28636F6E736F6C652E696E666F28224E6F20636F6469636F6E20666F756E6420666F722053796D626F6C4B696E6420222B65292C6E3D686E2E73796D626F6C50';
wwv_flow_imp.g_varchar2_table(1615) := '726F7065727479292C6E7D7D285F6E7C7C285F6E3D7B7D29293B636C6173732079697B7374617469632066726F6D56616C75652865297B7377697463682865297B6361736522636F6D6D656E74223A72657475726E2079692E436F6D6D656E743B636173';
wwv_flow_imp.g_varchar2_table(1616) := '6522696D706F727473223A72657475726E2079692E496D706F7274733B6361736522726567696F6E223A72657475726E2079692E526567696F6E7D72657475726E206E65772079692865297D636F6E7374727563746F722865297B746869732E76616C75';
wwv_flow_imp.g_varchar2_table(1617) := '653D657D7D79692E436F6D6D656E743D6E65772079692822636F6D6D656E7422292C79692E496D706F7274733D6E65772079692822696D706F72747322292C79692E526567696F6E3D6E65772079692822726567696F6E22292C66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1618) := '297B655B652E414947656E6572617465643D315D3D22414947656E657261746564227D28766E7C7C28766E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D';
wwv_flow_imp.g_varchar2_table(1619) := '3D224175746F6D61746963227D28436E7C7C28436E3D7B7D29292C66756E6374696F6E2865297B652E69733D66756E6374696F6E2865297B72657475726E212821657C7C226F626A65637422213D747970656F66206529262622737472696E67223D3D74';
wwv_flow_imp.g_varchar2_table(1620) := '7970656F6620652E6964262622737472696E67223D3D747970656F6620652E7469746C657D7D28796E7C7C28796E3D7B7D29292C66756E6374696F6E2865297B655B652E547970653D315D3D2254797065222C655B652E506172616D657465723D325D3D';
wwv_flow_imp.g_varchar2_table(1621) := '22506172616D65746572227D284C6E7C7C284C6E3D7B7D29292C6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F746F6B656E697A6174696F6E537570706F7274733D6E6577204D61702C746869732E5F666163746F72696573';
wwv_flow_imp.g_varchar2_table(1622) := '3D6E6577204D61702C746869732E5F6F6E4469644368616E67653D6E657720532C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F636F6C6F724D61703D6E756C6C7D68616E646C65';
wwv_flow_imp.g_varchar2_table(1623) := '4368616E67652865297B746869732E5F6F6E4469644368616E67652E66697265287B6368616E6765644C616E6775616765733A652C6368616E676564436F6C6F724D61703A21317D297D726567697374657228652C74297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(1624) := '5F746F6B656E697A6174696F6E537570706F7274732E73657428652C74292C746869732E68616E646C654368616E6765285B655D292C67282828293D3E7B746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865293D3D3D7426';
wwv_flow_imp.g_varchar2_table(1625) := '2628746869732E5F746F6B656E697A6174696F6E537570706F7274732E64656C6574652865292C746869732E68616E646C654368616E6765285B655D29297D29297D6765742865297B72657475726E20746869732E5F746F6B656E697A6174696F6E5375';
wwv_flow_imp.g_varchar2_table(1626) := '70706F7274732E6765742865297C7C6E756C6C7D7265676973746572466163746F727928652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E5F666163746F726965732E676574286529297C7C766F696420303D3D3D6E7C7C6E2E64697370';
wwv_flow_imp.g_varchar2_table(1627) := '6F736528293B636F6E737420693D6E657720636E28746869732C652C74293B72657475726E20746869732E5F666163746F726965732E73657428652C69292C67282828293D3E7B636F6E737420743D746869732E5F666163746F726965732E6765742865';
wwv_flow_imp.g_varchar2_table(1628) := '293B742626743D3D3D69262628746869732E5F666163746F726965732E64656C6574652865292C742E646973706F73652829297D29297D6173796E63206765744F724372656174652865297B636F6E737420743D746869732E6765742865293B69662874';
wwv_flow_imp.g_varchar2_table(1629) := '2972657475726E20743B636F6E7374206E3D746869732E5F666163746F726965732E6765742865293B72657475726E216E7C7C6E2E69735265736F6C7665643F6E756C6C3A286177616974206E2E7265736F6C766528292C746869732E67657428652929';
wwv_flow_imp.g_varchar2_table(1630) := '7D69735265736F6C7665642865297B696628746869732E6765742865292972657475726E21303B636F6E737420743D746869732E5F666163746F726965732E6765742865293B72657475726E212874262621742E69735265736F6C766564297D73657443';
wwv_flow_imp.g_varchar2_table(1631) := '6F6C6F724D61702865297B746869732E5F636F6C6F724D61703D652C746869732E5F6F6E4469644368616E67652E66697265287B6368616E6765644C616E6775616765733A41727261792E66726F6D28746869732E5F746F6B656E697A6174696F6E5375';
wwv_flow_imp.g_varchar2_table(1632) := '70706F7274732E6B6579732829292C6368616E676564436F6C6F724D61703A21307D297D676574436F6C6F724D617028297B72657475726E20746869732E5F636F6C6F724D61707D67657444656661756C744261636B67726F756E6428297B7265747572';
wwv_flow_imp.g_varchar2_table(1633) := '6E20746869732E5F636F6C6F724D61702626746869732E5F636F6C6F724D61702E6C656E6774683E323F746869732E5F636F6C6F724D61705B325D3A6E756C6C7D7D2C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65';
wwv_flow_imp.g_varchar2_table(1634) := '222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D28776E7C7C28776E3D7B7D29292C66756E6374696F6E2865297B655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C655B652E44697361626C65643D315D3D2244';
wwv_flow_imp.g_varchar2_table(1635) := '697361626C6564222C655B652E456E61626C65643D325D3D22456E61626C6564227D284E6E7C7C284E6E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E4175746F3D325D3D224175746F';
wwv_flow_imp.g_varchar2_table(1636) := '227D28456E7C7C28456E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E4B656570576869746573706163653D315D3D224B65657057686974657370616365222C655B652E496E736572744173536E';
wwv_flow_imp.g_varchar2_table(1637) := '69707065743D345D3D22496E736572744173536E6970706574227D28536E7C7C28536E3D7B7D29292C66756E6374696F6E2865297B655B652E4D6574686F643D305D3D224D6574686F64222C655B652E46756E6374696F6E3D315D3D2246756E6374696F';
wwv_flow_imp.g_varchar2_table(1638) := '6E222C655B652E436F6E7374727563746F723D325D3D22436F6E7374727563746F72222C655B652E4669656C643D335D3D224669656C64222C655B652E5661726961626C653D345D3D225661726961626C65222C655B652E436C6173733D355D3D22436C';
wwv_flow_imp.g_varchar2_table(1639) := '617373222C655B652E5374727563743D365D3D22537472756374222C655B652E496E746572666163653D375D3D22496E74657266616365222C655B652E4D6F64756C653D385D3D224D6F64756C65222C655B652E50726F70657274793D395D3D2250726F';
wwv_flow_imp.g_varchar2_table(1640) := '7065727479222C655B652E4576656E743D31305D3D224576656E74222C655B652E4F70657261746F723D31315D3D224F70657261746F72222C655B652E556E69743D31325D3D22556E6974222C655B652E56616C75653D31335D3D2256616C7565222C65';
wwv_flow_imp.g_varchar2_table(1641) := '5B652E436F6E7374616E743D31345D3D22436F6E7374616E74222C655B652E456E756D3D31355D3D22456E756D222C655B652E456E756D4D656D6265723D31365D3D22456E756D4D656D626572222C655B652E4B6579776F72643D31375D3D224B657977';
wwv_flow_imp.g_varchar2_table(1642) := '6F7264222C655B652E546578743D31385D3D2254657874222C655B652E436F6C6F723D31395D3D22436F6C6F72222C655B652E46696C653D32305D3D2246696C65222C655B652E5265666572656E63653D32315D3D225265666572656E6365222C655B65';
wwv_flow_imp.g_varchar2_table(1643) := '2E437573746F6D636F6C6F723D32325D3D22437573746F6D636F6C6F72222C655B652E466F6C6465723D32335D3D22466F6C646572222C655B652E54797065506172616D657465723D32345D3D2254797065506172616D65746572222C655B652E557365';
wwv_flow_imp.g_varchar2_table(1644) := '723D32355D3D2255736572222C655B652E49737375653D32365D3D224973737565222C655B652E536E69707065743D32375D3D22536E6970706574227D28526E7C7C28526E3D7B7D29292C66756E6374696F6E2865297B655B652E446570726563617465';
wwv_flow_imp.g_varchar2_table(1645) := '643D315D3D2244657072656361746564227D28416E7C7C28416E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E547269676765724368617261637465723D315D3D225472696767657243';
wwv_flow_imp.g_varchar2_table(1646) := '6861726163746572222C655B652E54726967676572466F72496E636F6D706C657465436F6D706C6574696F6E733D325D3D2254726967676572466F72496E636F6D706C657465436F6D706C6574696F6E73227D28786E7C7C28786E3D7B7D29292C66756E';
wwv_flow_imp.g_varchar2_table(1647) := '6374696F6E2865297B655B652E45584143543D305D3D224558414354222C655B652E41424F56453D315D3D2241424F5645222C655B652E42454C4F573D325D3D2242454C4F57227D284D6E7C7C284D6E3D7B7D29292C66756E6374696F6E2865297B655B';
wwv_flow_imp.g_varchar2_table(1648) := '652E4E6F745365743D305D3D224E6F74536574222C655B652E436F6E74656E74466C7573683D315D3D22436F6E74656E74466C757368222C655B652E5265636F76657246726F6D4D61726B6572733D325D3D225265636F76657246726F6D4D61726B6572';
wwv_flow_imp.g_varchar2_table(1649) := '73222C655B652E4578706C696369743D335D3D224578706C69636974222C655B652E50617374653D345D3D225061737465222C655B652E556E646F3D355D3D22556E646F222C655B652E5265646F3D365D3D225265646F227D286B6E7C7C286B6E3D7B7D';
wwv_flow_imp.g_varchar2_table(1650) := '29292C66756E6374696F6E2865297B655B652E4C463D315D3D224C46222C655B652E43524C463D325D3D2243524C46227D284F6E7C7C284F6E3D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E5265';
wwv_flow_imp.g_varchar2_table(1651) := '61643D315D3D2252656164222C655B652E57726974653D325D3D225772697465227D28546E7C7C28546E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E4B6565703D315D3D224B656570222C655B';
wwv_flow_imp.g_varchar2_table(1652) := '652E427261636B6574733D325D3D22427261636B657473222C655B652E416476616E6365643D335D3D22416476616E636564222C655B652E46756C6C3D345D3D2246756C6C227D28496E7C7C28496E3D7B7D29292C66756E6374696F6E2865297B655B65';
wwv_flow_imp.g_varchar2_table(1653) := '2E61636365707453756767657374696F6E4F6E436F6D6D69744368617261637465723D305D3D2261636365707453756767657374696F6E4F6E436F6D6D6974436861726163746572222C655B652E61636365707453756767657374696F6E4F6E456E7465';
wwv_flow_imp.g_varchar2_table(1654) := '723D315D3D2261636365707453756767657374696F6E4F6E456E746572222C655B652E6163636573736962696C697479537570706F72743D325D3D226163636573736962696C697479537570706F7274222C655B652E6163636573736962696C69747950';
wwv_flow_imp.g_varchar2_table(1655) := '61676553697A653D335D3D226163636573736962696C6974795061676553697A65222C655B652E617269614C6162656C3D345D3D22617269614C6162656C222C655B652E6172696152657175697265643D355D3D22617269615265717569726564222C65';
wwv_flow_imp.g_varchar2_table(1656) := '5B652E6175746F436C6F73696E67427261636B6574733D365D3D226175746F436C6F73696E67427261636B657473222C655B652E6175746F436C6F73696E67436F6D6D656E74733D375D3D226175746F436C6F73696E67436F6D6D656E7473222C655B65';
wwv_flow_imp.g_varchar2_table(1657) := '2E73637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E3D385D3D2273637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E222C655B652E6175746F436C6F73696E6744656C6574';
wwv_flow_imp.g_varchar2_table(1658) := '653D395D3D226175746F436C6F73696E6744656C657465222C655B652E6175746F436C6F73696E674F766572747970653D31305D3D226175746F436C6F73696E674F76657274797065222C655B652E6175746F436C6F73696E6751756F7465733D31315D';
wwv_flow_imp.g_varchar2_table(1659) := '3D226175746F436C6F73696E6751756F746573222C655B652E6175746F496E64656E743D31325D3D226175746F496E64656E74222C655B652E6175746F6D617469634C61796F75743D31335D3D226175746F6D617469634C61796F7574222C655B652E61';
wwv_flow_imp.g_varchar2_table(1660) := '75746F537572726F756E643D31345D3D226175746F537572726F756E64222C655B652E627261636B657450616972436F6C6F72697A6174696F6E3D31355D3D22627261636B657450616972436F6C6F72697A6174696F6E222C655B652E6775696465733D';
wwv_flow_imp.g_varchar2_table(1661) := '31365D3D22677569646573222C655B652E636F64654C656E733D31375D3D22636F64654C656E73222C655B652E636F64654C656E73466F6E7446616D696C793D31385D3D22636F64654C656E73466F6E7446616D696C79222C655B652E636F64654C656E';
wwv_flow_imp.g_varchar2_table(1662) := '73466F6E7453697A653D31395D3D22636F64654C656E73466F6E7453697A65222C655B652E636F6C6F724465636F7261746F72733D32305D3D22636F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734C696D69743D';
wwv_flow_imp.g_varchar2_table(1663) := '32315D3D22636F6C6F724465636F7261746F72734C696D6974222C655B652E636F6C756D6E53656C656374696F6E3D32325D3D22636F6C756D6E53656C656374696F6E222C655B652E636F6D6D656E74733D32335D3D22636F6D6D656E7473222C655B65';
wwv_flow_imp.g_varchar2_table(1664) := '2E636F6E746578746D656E753D32345D3D22636F6E746578746D656E75222C655B652E636F70795769746853796E746178486967686C69676874696E673D32355D3D22636F70795769746853796E746178486967686C69676874696E67222C655B652E63';
wwv_flow_imp.g_varchar2_table(1665) := '7572736F72426C696E6B696E673D32365D3D22637572736F72426C696E6B696E67222C655B652E637572736F72536D6F6F74684361726574416E696D6174696F6E3D32375D3D22637572736F72536D6F6F74684361726574416E696D6174696F6E222C65';
wwv_flow_imp.g_varchar2_table(1666) := '5B652E637572736F725374796C653D32385D3D22637572736F725374796C65222C655B652E637572736F72537572726F756E64696E674C696E65733D32395D3D22637572736F72537572726F756E64696E674C696E6573222C655B652E637572736F7253';
wwv_flow_imp.g_varchar2_table(1667) := '7572726F756E64696E674C696E65735374796C653D33305D3D22637572736F72537572726F756E64696E674C696E65735374796C65222C655B652E637572736F7257696474683D33315D3D22637572736F725769647468222C655B652E64697361626C65';
wwv_flow_imp.g_varchar2_table(1668) := '4C6179657248696E74696E673D33325D3D2264697361626C654C6179657248696E74696E67222C655B652E64697361626C654D6F6E6F73706163654F7074696D697A6174696F6E733D33335D3D2264697361626C654D6F6E6F73706163654F7074696D69';
wwv_flow_imp.g_varchar2_table(1669) := '7A6174696F6E73222C655B652E646F6D526561644F6E6C793D33345D3D22646F6D526561644F6E6C79222C655B652E64726167416E6444726F703D33355D3D2264726167416E6444726F70222C655B652E64726F70496E746F456469746F723D33365D3D';
wwv_flow_imp.g_varchar2_table(1670) := '2264726F70496E746F456469746F72222C655B652E656D70747953656C656374696F6E436C6970626F6172643D33375D3D22656D70747953656C656374696F6E436C6970626F617264222C655B652E6578706572696D656E74616C576869746573706163';
wwv_flow_imp.g_varchar2_table(1671) := '6552656E646572696E673D33385D3D226578706572696D656E74616C5768697465737061636552656E646572696E67222C655B652E6578747261456469746F72436C6173734E616D653D33395D3D226578747261456469746F72436C6173734E616D6522';
wwv_flow_imp.g_varchar2_table(1672) := '2C655B652E666173745363726F6C6C53656E73697469766974793D34305D3D22666173745363726F6C6C53656E7369746976697479222C655B652E66696E643D34315D3D2266696E64222C655B652E66697865644F766572666C6F77576964676574733D';
wwv_flow_imp.g_varchar2_table(1673) := '34325D3D2266697865644F766572666C6F7757696467657473222C655B652E666F6C64696E673D34335D3D22666F6C64696E67222C655B652E666F6C64696E6753747261746567793D34345D3D22666F6C64696E675374726174656779222C655B652E66';
wwv_flow_imp.g_varchar2_table(1674) := '6F6C64696E67486967686C696768743D34355D3D22666F6C64696E67486967686C69676874222C655B652E666F6C64696E67496D706F727473427944656661756C743D34365D3D22666F6C64696E67496D706F727473427944656661756C74222C655B65';
wwv_flow_imp.g_varchar2_table(1675) := '2E666F6C64696E674D6178696D756D526567696F6E733D34375D3D22666F6C64696E674D6178696D756D526567696F6E73222C655B652E756E666F6C644F6E436C69636B4166746572456E644F664C696E653D34385D3D22756E666F6C644F6E436C6963';
wwv_flow_imp.g_varchar2_table(1676) := '6B4166746572456E644F664C696E65222C655B652E666F6E7446616D696C793D34395D3D22666F6E7446616D696C79222C655B652E666F6E74496E666F3D35305D3D22666F6E74496E666F222C655B652E666F6E744C69676174757265733D35315D3D22';
wwv_flow_imp.g_varchar2_table(1677) := '666F6E744C6967617475726573222C655B652E666F6E7453697A653D35325D3D22666F6E7453697A65222C655B652E666F6E745765696768743D35335D3D22666F6E74576569676874222C655B652E666F6E74566172696174696F6E733D35345D3D2266';
wwv_flow_imp.g_varchar2_table(1678) := '6F6E74566172696174696F6E73222C655B652E666F726D61744F6E50617374653D35355D3D22666F726D61744F6E5061737465222C655B652E666F726D61744F6E547970653D35365D3D22666F726D61744F6E54797065222C655B652E676C7970684D61';
wwv_flow_imp.g_varchar2_table(1679) := '7267696E3D35375D3D22676C7970684D617267696E222C655B652E676F746F4C6F636174696F6E3D35385D3D22676F746F4C6F636174696F6E222C655B652E68696465437572736F72496E4F7665727669657752756C65723D35395D3D22686964654375';
wwv_flow_imp.g_varchar2_table(1680) := '72736F72496E4F7665727669657752756C6572222C655B652E686F7665723D36305D3D22686F766572222C655B652E696E44696666456469746F723D36315D3D22696E44696666456469746F72222C655B652E696E6C696E65537567676573743D36325D';
wwv_flow_imp.g_varchar2_table(1681) := '3D22696E6C696E6553756767657374222C655B652E696E6C696E65456469743D36335D3D22696E6C696E6545646974222C655B652E6C657474657253706163696E673D36345D3D226C657474657253706163696E67222C655B652E6C6967687462756C62';
wwv_flow_imp.g_varchar2_table(1682) := '3D36355D3D226C6967687462756C62222C655B652E6C696E654465636F726174696F6E7357696474683D36365D3D226C696E654465636F726174696F6E735769647468222C655B652E6C696E654865696768743D36375D3D226C696E6548656967687422';
wwv_flow_imp.g_varchar2_table(1683) := '2C655B652E6C696E654E756D626572733D36385D3D226C696E654E756D62657273222C655B652E6C696E654E756D626572734D696E43686172733D36395D3D226C696E654E756D626572734D696E4368617273222C655B652E6C696E6B65644564697469';
wwv_flow_imp.g_varchar2_table(1684) := '6E673D37305D3D226C696E6B656445646974696E67222C655B652E6C696E6B733D37315D3D226C696E6B73222C655B652E6D61746368427261636B6574733D37325D3D226D61746368427261636B657473222C655B652E6D696E696D61703D37335D3D22';
wwv_flow_imp.g_varchar2_table(1685) := '6D696E696D6170222C655B652E6D6F7573655374796C653D37345D3D226D6F7573655374796C65222C655B652E6D6F757365576865656C5363726F6C6C53656E73697469766974793D37355D3D226D6F757365576865656C5363726F6C6C53656E736974';
wwv_flow_imp.g_varchar2_table(1686) := '6976697479222C655B652E6D6F757365576865656C5A6F6F6D3D37365D3D226D6F757365576865656C5A6F6F6D222C655B652E6D756C7469437572736F724D657267654F7665726C617070696E673D37375D3D226D756C7469437572736F724D65726765';
wwv_flow_imp.g_varchar2_table(1687) := '4F7665726C617070696E67222C655B652E6D756C7469437572736F724D6F6469666965723D37385D3D226D756C7469437572736F724D6F646966696572222C655B652E6D756C7469437572736F7250617374653D37395D3D226D756C7469437572736F72';
wwv_flow_imp.g_varchar2_table(1688) := '5061737465222C655B652E6D756C7469437572736F724C696D69743D38305D3D226D756C7469437572736F724C696D6974222C655B652E6F6363757272656E636573486967686C696768743D38315D3D226F6363757272656E636573486967686C696768';
wwv_flow_imp.g_varchar2_table(1689) := '74222C655B652E6F7665727669657752756C6572426F726465723D38325D3D226F7665727669657752756C6572426F72646572222C655B652E6F7665727669657752756C65724C616E65733D38335D3D226F7665727669657752756C65724C616E657322';
wwv_flow_imp.g_varchar2_table(1690) := '2C655B652E70616464696E673D38345D3D2270616464696E67222C655B652E706173746541733D38355D3D2270617374654173222C655B652E706172616D6574657248696E74733D38365D3D22706172616D6574657248696E7473222C655B652E706565';
wwv_flow_imp.g_varchar2_table(1691) := '6B57696467657444656661756C74466F6375733D38375D3D227065656B57696467657444656661756C74466F637573222C655B652E646566696E6974696F6E4C696E6B4F70656E73496E5065656B3D38385D3D22646566696E6974696F6E4C696E6B4F70';
wwv_flow_imp.g_varchar2_table(1692) := '656E73496E5065656B222C655B652E717569636B53756767657374696F6E733D38395D3D22717569636B53756767657374696F6E73222C655B652E717569636B53756767657374696F6E7344656C61793D39305D3D22717569636B53756767657374696F';
wwv_flow_imp.g_varchar2_table(1693) := '6E7344656C6179222C655B652E726561644F6E6C793D39315D3D22726561644F6E6C79222C655B652E726561644F6E6C794D6573736167653D39325D3D22726561644F6E6C794D657373616765222C655B652E72656E616D654F6E547970653D39335D3D';
wwv_flow_imp.g_varchar2_table(1694) := '2272656E616D654F6E54797065222C655B652E72656E646572436F6E74726F6C436861726163746572733D39345D3D2272656E646572436F6E74726F6C43686172616374657273222C655B652E72656E64657246696E616C4E65776C696E653D39355D3D';
wwv_flow_imp.g_varchar2_table(1695) := '2272656E64657246696E616C4E65776C696E65222C655B652E72656E6465724C696E65486967686C696768743D39365D3D2272656E6465724C696E65486967686C69676874222C655B652E72656E6465724C696E65486967686C696768744F6E6C795768';
wwv_flow_imp.g_varchar2_table(1696) := '656E466F6375733D39375D3D2272656E6465724C696E65486967686C696768744F6E6C795768656E466F637573222C655B652E72656E64657256616C69646174696F6E4465636F726174696F6E733D39385D3D2272656E64657256616C69646174696F6E';
wwv_flow_imp.g_varchar2_table(1697) := '4465636F726174696F6E73222C655B652E72656E646572576869746573706163653D39395D3D2272656E64657257686974657370616365222C655B652E72657665616C486F72697A6F6E74616C526967687450616464696E673D3130305D3D2272657665';
wwv_flow_imp.g_varchar2_table(1698) := '616C486F72697A6F6E74616C526967687450616464696E67222C655B652E726F756E64656453656C656374696F6E3D3130315D3D22726F756E64656453656C656374696F6E222C655B652E72756C6572733D3130325D3D2272756C657273222C655B652E';
wwv_flow_imp.g_varchar2_table(1699) := '7363726F6C6C6261723D3130335D3D227363726F6C6C626172222C655B652E7363726F6C6C4265796F6E644C617374436F6C756D6E3D3130345D3D227363726F6C6C4265796F6E644C617374436F6C756D6E222C655B652E7363726F6C6C4265796F6E64';
wwv_flow_imp.g_varchar2_table(1700) := '4C6173744C696E653D3130355D3D227363726F6C6C4265796F6E644C6173744C696E65222C655B652E7363726F6C6C507265646F6D696E616E74417869733D3130365D3D227363726F6C6C507265646F6D696E616E7441786973222C655B652E73656C65';
wwv_flow_imp.g_varchar2_table(1701) := '6374696F6E436C6970626F6172643D3130375D3D2273656C656374696F6E436C6970626F617264222C655B652E73656C656374696F6E486967686C696768743D3130385D3D2273656C656374696F6E486967686C69676874222C655B652E73656C656374';
wwv_flow_imp.g_varchar2_table(1702) := '4F6E4C696E654E756D626572733D3130395D3D2273656C6563744F6E4C696E654E756D62657273222C655B652E73686F77466F6C64696E67436F6E74726F6C733D3131305D3D2273686F77466F6C64696E67436F6E74726F6C73222C655B652E73686F77';
wwv_flow_imp.g_varchar2_table(1703) := '556E757365643D3131315D3D2273686F77556E75736564222C655B652E736E697070657453756767657374696F6E733D3131325D3D22736E697070657453756767657374696F6E73222C655B652E736D61727453656C6563743D3131335D3D22736D6172';
wwv_flow_imp.g_varchar2_table(1704) := '7453656C656374222C655B652E736D6F6F74685363726F6C6C696E673D3131345D3D22736D6F6F74685363726F6C6C696E67222C655B652E737469636B795363726F6C6C3D3131355D3D22737469636B795363726F6C6C222C655B652E737469636B7954';
wwv_flow_imp.g_varchar2_table(1705) := '616253746F70733D3131365D3D22737469636B7954616253746F7073222C655B652E73746F7052656E646572696E674C696E6541667465723D3131375D3D2273746F7052656E646572696E674C696E654166746572222C655B652E737567676573743D31';
wwv_flow_imp.g_varchar2_table(1706) := '31385D3D2273756767657374222C655B652E73756767657374466F6E7453697A653D3131395D3D2273756767657374466F6E7453697A65222C655B652E737567676573744C696E654865696768743D3132305D3D22737567676573744C696E6548656967';
wwv_flow_imp.g_varchar2_table(1707) := '6874222C655B652E737567676573744F6E54726967676572436861726163746572733D3132315D3D22737567676573744F6E5472696767657243686172616374657273222C655B652E7375676765737453656C656374696F6E3D3132325D3D2273756767';
wwv_flow_imp.g_varchar2_table(1708) := '65737453656C656374696F6E222C655B652E746162436F6D706C6574696F6E3D3132335D3D22746162436F6D706C6574696F6E222C655B652E746162496E6465783D3132345D3D22746162496E646578222C655B652E756E69636F6465486967686C6967';
wwv_flow_imp.g_varchar2_table(1709) := '6874696E673D3132355D3D22756E69636F6465486967686C69676874696E67222C655B652E756E757375616C4C696E655465726D696E61746F72733D3132365D3D22756E757375616C4C696E655465726D696E61746F7273222C655B652E757365536861';
wwv_flow_imp.g_varchar2_table(1710) := '646F77444F4D3D3132375D3D22757365536861646F77444F4D222C655B652E75736554616253746F70733D3132385D3D2275736554616253746F7073222C655B652E776F7264427265616B3D3132395D3D22776F7264427265616B222C655B652E776F72';
wwv_flow_imp.g_varchar2_table(1711) := '645365676D656E7465724C6F63616C65733D3133305D3D22776F72645365676D656E7465724C6F63616C6573222C655B652E776F7264536570617261746F72733D3133315D3D22776F7264536570617261746F7273222C655B652E776F7264577261703D';
wwv_flow_imp.g_varchar2_table(1712) := '3133325D3D22776F726457726170222C655B652E776F726457726170427265616B4166746572436861726163746572733D3133335D3D22776F726457726170427265616B416674657243686172616374657273222C655B652E776F726457726170427265';
wwv_flow_imp.g_varchar2_table(1713) := '616B4265666F7265436861726163746572733D3133345D3D22776F726457726170427265616B4265666F726543686172616374657273222C655B652E776F726457726170436F6C756D6E3D3133355D3D22776F726457726170436F6C756D6E222C655B65';
wwv_flow_imp.g_varchar2_table(1714) := '2E776F7264577261704F76657272696465313D3133365D3D22776F7264577261704F7665727269646531222C655B652E776F7264577261704F76657272696465323D3133375D3D22776F7264577261704F7665727269646532222C655B652E7772617070';
wwv_flow_imp.g_varchar2_table(1715) := '696E67496E64656E743D3133385D3D227772617070696E67496E64656E74222C655B652E7772617070696E6753747261746567793D3133395D3D227772617070696E675374726174656779222C655B652E73686F77446570726563617465643D3134305D';
wwv_flow_imp.g_varchar2_table(1716) := '3D2273686F7744657072656361746564222C655B652E696E6C617948696E74733D3134315D3D22696E6C617948696E7473222C655B652E656469746F72436C6173734E616D653D3134325D3D22656469746F72436C6173734E616D65222C655B652E7069';
wwv_flow_imp.g_varchar2_table(1717) := '78656C526174696F3D3134335D3D22706978656C526174696F222C655B652E746162466F6375734D6F64653D3134345D3D22746162466F6375734D6F6465222C655B652E6C61796F7574496E666F3D3134355D3D226C61796F7574496E666F222C655B65';
wwv_flow_imp.g_varchar2_table(1718) := '2E7772617070696E67496E666F3D3134365D3D227772617070696E67496E666F222C655B652E64656661756C74436F6C6F724465636F7261746F72733D3134375D3D2264656661756C74436F6C6F724465636F7261746F7273222C655B652E636F6C6F72';
wwv_flow_imp.g_varchar2_table(1719) := '4465636F7261746F72734163746976617465644F6E3D3134385D3D22636F6C6F724465636F7261746F72734163746976617465644F6E222C655B652E696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F73653D3134';
wwv_flow_imp.g_varchar2_table(1720) := '395D3D22696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F7365227D28506E7C7C28506E3D7B7D29292C66756E6374696F6E2865297B655B652E54657874446566696E65643D305D3D2254657874446566696E6564';
wwv_flow_imp.g_varchar2_table(1721) := '222C655B652E4C463D315D3D224C46222C655B652E43524C463D325D3D2243524C46227D28446E7C7C28446E3D7B7D29292C66756E6374696F6E2865297B655B652E4C463D305D3D224C46222C655B652E43524C463D315D3D2243524C46227D28466E7C';
wwv_flow_imp.g_varchar2_table(1722) := '7C28466E3D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D284B6E7C7C284B6E3D7B7D29292C66';
wwv_flow_imp.g_varchar2_table(1723) := '756E6374696F6E2865297B655B652E496E6372656173653D305D3D22496E637265617365222C655B652E44656372656173653D315D3D224465637265617365227D28716E7C7C28716E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D';
wwv_flow_imp.g_varchar2_table(1724) := '305D3D224E6F6E65222C655B652E496E64656E743D315D3D22496E64656E74222C655B652E496E64656E744F757464656E743D325D3D22496E64656E744F757464656E74222C655B652E4F757464656E743D335D3D224F757464656E74227D28566E7C7C';
wwv_flow_imp.g_varchar2_table(1725) := '28566E3D7B7D29292C66756E6374696F6E2865297B655B652E426F74683D305D3D22426F7468222C655B652E52696768743D315D3D225269676874222C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D28';
wwv_flow_imp.g_varchar2_table(1726) := '426E7C7C28426E3D7B7D29292C66756E6374696F6E2865297B655B652E547970653D315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D28556E7C7C28556E3D7B7D29292C66756E6374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(1727) := '5B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B652E4578706C696369743D315D3D224578706C69636974227D287A6E7C7C287A6E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F';
wwv_flow_imp.g_varchar2_table(1728) := '6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D28486E7C7C28486E3D7B7D29292C66756E6374696F6E2865297B655B652E446570656E64734F6E4B624C61796F75743D2D315D3D22446570656E64734F6E4B624C6179';
wwv_flow_imp.g_varchar2_table(1729) := '6F7574222C655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C655B652E4261636B73706163653D315D3D224261636B7370616365222C655B652E5461623D325D3D22546162222C655B652E456E7465723D335D3D22456E746572222C655B65';
wwv_flow_imp.g_varchar2_table(1730) := '2E53686966743D345D3D225368696674222C655B652E4374726C3D355D3D224374726C222C655B652E416C743D365D3D22416C74222C655B652E5061757365427265616B3D375D3D225061757365427265616B222C655B652E436170734C6F636B3D385D';
wwv_flow_imp.g_varchar2_table(1731) := '3D22436170734C6F636B222C655B652E4573636170653D395D3D22457363617065222C655B652E53706163653D31305D3D225370616365222C655B652E5061676555703D31315D3D22506167655570222C655B652E50616765446F776E3D31325D3D2250';
wwv_flow_imp.g_varchar2_table(1732) := '616765446F776E222C655B652E456E643D31335D3D22456E64222C655B652E486F6D653D31345D3D22486F6D65222C655B652E4C6566744172726F773D31355D3D224C6566744172726F77222C655B652E55704172726F773D31365D3D2255704172726F';
wwv_flow_imp.g_varchar2_table(1733) := '77222C655B652E52696768744172726F773D31375D3D2252696768744172726F77222C655B652E446F776E4172726F773D31385D3D22446F776E4172726F77222C655B652E496E736572743D31395D3D22496E73657274222C655B652E44656C6574653D';
wwv_flow_imp.g_varchar2_table(1734) := '32305D3D2244656C657465222C655B652E4469676974303D32315D3D22446967697430222C655B652E4469676974313D32325D3D22446967697431222C655B652E4469676974323D32335D3D22446967697432222C655B652E4469676974333D32345D3D';
wwv_flow_imp.g_varchar2_table(1735) := '22446967697433222C655B652E4469676974343D32355D3D22446967697434222C655B652E4469676974353D32365D3D22446967697435222C655B652E4469676974363D32375D3D22446967697436222C655B652E4469676974373D32385D3D22446967';
wwv_flow_imp.g_varchar2_table(1736) := '697437222C655B652E4469676974383D32395D3D22446967697438222C655B652E4469676974393D33305D3D22446967697439222C655B652E4B6579413D33315D3D224B657941222C655B652E4B6579423D33325D3D224B657942222C655B652E4B6579';
wwv_flow_imp.g_varchar2_table(1737) := '433D33335D3D224B657943222C655B652E4B6579443D33345D3D224B657944222C655B652E4B6579453D33355D3D224B657945222C655B652E4B6579463D33365D3D224B657946222C655B652E4B6579473D33375D3D224B657947222C655B652E4B6579';
wwv_flow_imp.g_varchar2_table(1738) := '483D33385D3D224B657948222C655B652E4B6579493D33395D3D224B657949222C655B652E4B65794A3D34305D3D224B65794A222C655B652E4B65794B3D34315D3D224B65794B222C655B652E4B65794C3D34325D3D224B65794C222C655B652E4B6579';
wwv_flow_imp.g_varchar2_table(1739) := '4D3D34335D3D224B65794D222C655B652E4B65794E3D34345D3D224B65794E222C655B652E4B65794F3D34355D3D224B65794F222C655B652E4B6579503D34365D3D224B657950222C655B652E4B6579513D34375D3D224B657951222C655B652E4B6579';
wwv_flow_imp.g_varchar2_table(1740) := '523D34385D3D224B657952222C655B652E4B6579533D34395D3D224B657953222C655B652E4B6579543D35305D3D224B657954222C655B652E4B6579553D35315D3D224B657955222C655B652E4B6579563D35325D3D224B657956222C655B652E4B6579';
wwv_flow_imp.g_varchar2_table(1741) := '573D35335D3D224B657957222C655B652E4B6579583D35345D3D224B657958222C655B652E4B6579593D35355D3D224B657959222C655B652E4B65795A3D35365D3D224B65795A222C655B652E4D6574613D35375D3D224D657461222C655B652E436F6E';
wwv_flow_imp.g_varchar2_table(1742) := '746578744D656E753D35385D3D22436F6E746578744D656E75222C655B652E46313D35395D3D224631222C655B652E46323D36305D3D224632222C655B652E46333D36315D3D224633222C655B652E46343D36325D3D224634222C655B652E46353D3633';
wwv_flow_imp.g_varchar2_table(1743) := '5D3D224635222C655B652E46363D36345D3D224636222C655B652E46373D36355D3D224637222C655B652E46383D36365D3D224638222C655B652E46393D36375D3D224639222C655B652E4631303D36385D3D22463130222C655B652E4631313D36395D';
wwv_flow_imp.g_varchar2_table(1744) := '3D22463131222C655B652E4631323D37305D3D22463132222C655B652E4631333D37315D3D22463133222C655B652E4631343D37325D3D22463134222C655B652E4631353D37335D3D22463135222C655B652E4631363D37345D3D22463136222C655B65';
wwv_flow_imp.g_varchar2_table(1745) := '2E4631373D37355D3D22463137222C655B652E4631383D37365D3D22463138222C655B652E4631393D37375D3D22463139222C655B652E4632303D37385D3D22463230222C655B652E4632313D37395D3D22463231222C655B652E4632323D38305D3D22';
wwv_flow_imp.g_varchar2_table(1746) := '463232222C655B652E4632333D38315D3D22463233222C655B652E4632343D38325D3D22463234222C655B652E4E756D4C6F636B3D38335D3D224E756D4C6F636B222C655B652E5363726F6C6C4C6F636B3D38345D3D225363726F6C6C4C6F636B222C65';
wwv_flow_imp.g_varchar2_table(1747) := '5B652E53656D69636F6C6F6E3D38355D3D2253656D69636F6C6F6E222C655B652E457175616C3D38365D3D22457175616C222C655B652E436F6D6D613D38375D3D22436F6D6D61222C655B652E4D696E75733D38385D3D224D696E7573222C655B652E50';
wwv_flow_imp.g_varchar2_table(1748) := '6572696F643D38395D3D22506572696F64222C655B652E536C6173683D39305D3D22536C617368222C655B652E4261636B71756F74653D39315D3D224261636B71756F7465222C655B652E427261636B65744C6566743D39325D3D22427261636B65744C';
wwv_flow_imp.g_varchar2_table(1749) := '656674222C655B652E4261636B736C6173683D39335D3D224261636B736C617368222C655B652E427261636B657452696768743D39345D3D22427261636B65745269676874222C655B652E51756F74653D39355D3D2251756F7465222C655B652E4F454D';
wwv_flow_imp.g_varchar2_table(1750) := '5F383D39365D3D224F454D5F38222C655B652E496E746C4261636B736C6173683D39375D3D22496E746C4261636B736C617368222C655B652E4E756D706164303D39385D3D224E756D70616430222C655B652E4E756D706164313D39395D3D224E756D70';
wwv_flow_imp.g_varchar2_table(1751) := '616431222C655B652E4E756D706164323D3130305D3D224E756D70616432222C655B652E4E756D706164333D3130315D3D224E756D70616433222C655B652E4E756D706164343D3130325D3D224E756D70616434222C655B652E4E756D706164353D3130';
wwv_flow_imp.g_varchar2_table(1752) := '335D3D224E756D70616435222C655B652E4E756D706164363D3130345D3D224E756D70616436222C655B652E4E756D706164373D3130355D3D224E756D70616437222C655B652E4E756D706164383D3130365D3D224E756D70616438222C655B652E4E75';
wwv_flow_imp.g_varchar2_table(1753) := '6D706164393D3130375D3D224E756D70616439222C655B652E4E756D7061644D756C7469706C793D3130385D3D224E756D7061644D756C7469706C79222C655B652E4E756D7061644164643D3130395D3D224E756D706164416464222C655B652E4E554D';
wwv_flow_imp.g_varchar2_table(1754) := '5041445F534550415241544F523D3131305D3D224E554D5041445F534550415241544F52222C655B652E4E756D70616453756274726163743D3131315D3D224E756D7061645375627472616374222C655B652E4E756D706164446563696D616C3D313132';
wwv_flow_imp.g_varchar2_table(1755) := '5D3D224E756D706164446563696D616C222C655B652E4E756D7061644469766964653D3131335D3D224E756D706164446976696465222C655B652E4B45595F494E5F434F4D504F534954494F4E3D3131345D3D224B45595F494E5F434F4D504F53495449';
wwv_flow_imp.g_varchar2_table(1756) := '4F4E222C655B652E41424E545F43313D3131355D3D2241424E545F4331222C655B652E41424E545F43323D3131365D3D2241424E545F4332222C655B652E417564696F566F6C756D654D7574653D3131375D3D22417564696F566F6C756D654D75746522';
wwv_flow_imp.g_varchar2_table(1757) := '2C655B652E417564696F566F6C756D6555703D3131385D3D22417564696F566F6C756D655570222C655B652E417564696F566F6C756D65446F776E3D3131395D3D22417564696F566F6C756D65446F776E222C655B652E42726F77736572536561726368';
wwv_flow_imp.g_varchar2_table(1758) := '3D3132305D3D2242726F77736572536561726368222C655B652E42726F77736572486F6D653D3132315D3D2242726F77736572486F6D65222C655B652E42726F777365724261636B3D3132325D3D2242726F777365724261636B222C655B652E42726F77';
wwv_flow_imp.g_varchar2_table(1759) := '736572466F72776172643D3132335D3D2242726F77736572466F7277617264222C655B652E4D65646961547261636B4E6578743D3132345D3D224D65646961547261636B4E657874222C655B652E4D65646961547261636B50726576696F75733D313235';
wwv_flow_imp.g_varchar2_table(1760) := '5D3D224D65646961547261636B50726576696F7573222C655B652E4D6564696153746F703D3132365D3D224D6564696153746F70222C655B652E4D65646961506C617950617573653D3132375D3D224D65646961506C61795061757365222C655B652E4C';
wwv_flow_imp.g_varchar2_table(1761) := '61756E63684D65646961506C617965723D3132385D3D224C61756E63684D65646961506C61796572222C655B652E4C61756E63684D61696C3D3132395D3D224C61756E63684D61696C222C655B652E4C61756E6368417070323D3133305D3D224C61756E';
wwv_flow_imp.g_varchar2_table(1762) := '636841707032222C655B652E436C6561723D3133315D3D22436C656172222C655B652E4D41585F56414C55453D3133325D3D224D41585F56414C5545227D28576E7C7C28576E3D7B7D29292C66756E6374696F6E2865297B655B652E48696E743D315D3D';
wwv_flow_imp.g_varchar2_table(1763) := '2248696E74222C655B652E496E666F3D325D3D22496E666F222C655B652E5761726E696E673D345D3D225761726E696E67222C655B652E4572726F723D385D3D224572726F72227D28246E7C7C28246E3D7B7D29292C66756E6374696F6E2865297B655B';
wwv_flow_imp.g_varchar2_table(1764) := '652E556E6E65636573736172793D315D3D22556E6E6563657373617279222C655B652E446570726563617465643D325D3D2244657072656361746564227D286A6E7C7C286A6E3D7B7D29292C66756E6374696F6E2865297B655B652E496E6C696E653D31';
wwv_flow_imp.g_varchar2_table(1765) := '5D3D22496E6C696E65222C655B652E4775747465723D325D3D22477574746572227D28476E7C7C28476E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F726D616C3D315D3D224E6F726D616C222C655B652E556E6465726C696E65643D325D';
wwv_flow_imp.g_varchar2_table(1766) := '3D22556E6465726C696E6564227D28516E7C7C28516E3D7B7D29292C66756E6374696F6E2865297B655B652E554E4B4E4F574E3D305D3D22554E4B4E4F574E222C655B652E54455854415245413D315D3D225445585441524541222C655B652E47555454';
wwv_flow_imp.g_varchar2_table(1767) := '45525F474C5950485F4D415247494E3D325D3D224755545445525F474C5950485F4D415247494E222C655B652E4755545445525F4C494E455F4E554D424552533D335D3D224755545445525F4C494E455F4E554D42455253222C655B652E475554544552';
wwv_flow_imp.g_varchar2_table(1768) := '5F4C494E455F4445434F524154494F4E533D345D3D224755545445525F4C494E455F4445434F524154494F4E53222C655B652E4755545445525F564945575F5A4F4E453D355D3D224755545445525F564945575F5A4F4E45222C655B652E434F4E54454E';
wwv_flow_imp.g_varchar2_table(1769) := '545F544558543D365D3D22434F4E54454E545F54455854222C655B652E434F4E54454E545F454D5054593D375D3D22434F4E54454E545F454D505459222C655B652E434F4E54454E545F564945575F5A4F4E453D385D3D22434F4E54454E545F56494557';
wwv_flow_imp.g_varchar2_table(1770) := '5F5A4F4E45222C655B652E434F4E54454E545F5749444745543D395D3D22434F4E54454E545F574944474554222C655B652E4F564552564945575F52554C45523D31305D3D224F564552564945575F52554C4552222C655B652E5343524F4C4C4241523D';
wwv_flow_imp.g_varchar2_table(1771) := '31315D3D225343524F4C4C424152222C655B652E4F5645524C41595F5749444745543D31325D3D224F5645524C41595F574944474554222C655B652E4F5554534944455F454449544F523D31335D3D224F5554534944455F454449544F52227D28586E7C';
wwv_flow_imp.g_varchar2_table(1772) := '7C28586E3D7B7D29292C66756E6374696F6E2865297B655B652E414947656E6572617465643D315D3D22414947656E657261746564227D284A6E7C7C284A6E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F';
wwv_flow_imp.g_varchar2_table(1773) := '6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D28596E7C7C28596E3D7B7D29292C66756E6374696F6E2865297B655B652E544F505F52494748545F434F524E45523D305D3D22544F505F52494748545F434F524E4552';
wwv_flow_imp.g_varchar2_table(1774) := '222C655B652E424F54544F4D5F52494748545F434F524E45523D315D3D22424F54544F4D5F52494748545F434F524E4552222C655B652E544F505F43454E5445523D325D3D22544F505F43454E544552227D285A6E7C7C285A6E3D7B7D29292C66756E63';
wwv_flow_imp.g_varchar2_table(1775) := '74696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D2865697C7C2865693D7B';
wwv_flow_imp.g_varchar2_table(1776) := '7D29292C66756E6374696F6E2865297B655B652E576F72643D305D3D22576F7264222C655B652E4C696E653D315D3D224C696E65222C655B652E537567676573743D325D3D2253756767657374227D2874697C7C2874693D7B7D29292C66756E6374696F';
wwv_flow_imp.g_varchar2_table(1777) := '6E2865297B655B652E4C6566743D305D3D224C656674222C655B652E52696768743D315D3D225269676874222C655B652E4E6F6E653D325D3D224E6F6E65222C655B652E4C6566744F66496E6A6563746564546578743D335D3D224C6566744F66496E6A';
wwv_flow_imp.g_varchar2_table(1778) := '656374656454657874222C655B652E52696768744F66496E6A6563746564546578743D345D3D2252696768744F66496E6A656374656454657874227D286E697C7C286E693D7B7D29292C66756E6374696F6E2865297B655B652E4F66663D305D3D224F66';
wwv_flow_imp.g_varchar2_table(1779) := '66222C655B652E4F6E3D315D3D224F6E222C655B652E52656C61746976653D325D3D2252656C6174697665222C655B652E496E74657276616C3D335D3D22496E74657276616C222C655B652E437573746F6D3D345D3D22437573746F6D227D2869697C7C';
wwv_flow_imp.g_varchar2_table(1780) := '2869693D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E546578743D315D3D2254657874222C655B652E426C6F636B733D325D3D22426C6F636B73227D2872697C7C2872693D7B7D29292C66756E63';
wwv_flow_imp.g_varchar2_table(1781) := '74696F6E2865297B655B652E536D6F6F74683D305D3D22536D6F6F7468222C655B652E496D6D6564696174653D315D3D22496D6D656469617465227D2873697C7C2873693D7B7D29292C66756E6374696F6E2865297B655B652E4175746F3D315D3D2241';
wwv_flow_imp.g_varchar2_table(1782) := '75746F222C655B652E48696464656E3D325D3D2248696464656E222C655B652E56697369626C653D335D3D2256697369626C65227D286F697C7C286F693D7B7D29292C66756E6374696F6E2865297B655B652E4C54523D305D3D224C5452222C655B652E';
wwv_flow_imp.g_varchar2_table(1783) := '52544C3D315D3D2252544C227D2861697C7C2861693D7B7D29292C66756E6374696F6E2865297B652E4F66663D226F6666222C652E4F6E436F64653D226F6E436F6465222C652E4F6E3D226F6E227D286C697C7C286C693D7B7D29292C66756E6374696F';
wwv_flow_imp.g_varchar2_table(1784) := '6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E547269676765724368617261637465723D325D3D2254726967676572436861726163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E74';
wwv_flow_imp.g_varchar2_table(1785) := '4368616E6765227D2875697C7C2875693D7B7D29292C66756E6374696F6E2865297B655B652E46696C653D305D3D2246696C65222C655B652E4D6F64756C653D315D3D224D6F64756C65222C655B652E4E616D6573706163653D325D3D224E616D657370';
wwv_flow_imp.g_varchar2_table(1786) := '616365222C655B652E5061636B6167653D335D3D225061636B616765222C655B652E436C6173733D345D3D22436C617373222C655B652E4D6574686F643D355D3D224D6574686F64222C655B652E50726F70657274793D365D3D2250726F706572747922';
wwv_flow_imp.g_varchar2_table(1787) := '2C655B652E4669656C643D375D3D224669656C64222C655B652E436F6E7374727563746F723D385D3D22436F6E7374727563746F72222C655B652E456E756D3D395D3D22456E756D222C655B652E496E746572666163653D31305D3D22496E7465726661';
wwv_flow_imp.g_varchar2_table(1788) := '6365222C655B652E46756E6374696F6E3D31315D3D2246756E6374696F6E222C655B652E5661726961626C653D31325D3D225661726961626C65222C655B652E436F6E7374616E743D31335D3D22436F6E7374616E74222C655B652E537472696E673D31';
wwv_flow_imp.g_varchar2_table(1789) := '345D3D22537472696E67222C655B652E4E756D6265723D31355D3D224E756D626572222C655B652E426F6F6C65616E3D31365D3D22426F6F6C65616E222C655B652E41727261793D31375D3D224172726179222C655B652E4F626A6563743D31385D3D22';
wwv_flow_imp.g_varchar2_table(1790) := '4F626A656374222C655B652E4B65793D31395D3D224B6579222C655B652E4E756C6C3D32305D3D224E756C6C222C655B652E456E756D4D656D6265723D32315D3D22456E756D4D656D626572222C655B652E5374727563743D32325D3D22537472756374';
wwv_flow_imp.g_varchar2_table(1791) := '222C655B652E4576656E743D32335D3D224576656E74222C655B652E4F70657261746F723D32345D3D224F70657261746F72222C655B652E54797065506172616D657465723D32355D3D2254797065506172616D65746572227D2868697C7C2868693D7B';
wwv_flow_imp.g_varchar2_table(1792) := '7D29292C66756E6374696F6E2865297B655B652E446570726563617465643D315D3D2244657072656361746564227D2863697C7C2863693D7B7D29292C66756E6374696F6E2865297B655B652E48696464656E3D305D3D2248696464656E222C655B652E';
wwv_flow_imp.g_varchar2_table(1793) := '426C696E6B3D315D3D22426C696E6B222C655B652E536D6F6F74683D325D3D22536D6F6F7468222C655B652E50686173653D335D3D225068617365222C655B652E457870616E643D345D3D22457870616E64222C655B652E536F6C69643D355D3D22536F';
wwv_flow_imp.g_varchar2_table(1794) := '6C6964227D2864697C7C2864693D7B7D29292C66756E6374696F6E2865297B655B652E4C696E653D315D3D224C696E65222C655B652E426C6F636B3D325D3D22426C6F636B222C655B652E556E6465726C696E653D335D3D22556E6465726C696E65222C';
wwv_flow_imp.g_varchar2_table(1795) := '655B652E4C696E655468696E3D345D3D224C696E655468696E222C655B652E426C6F636B4F75746C696E653D355D3D22426C6F636B4F75746C696E65222C655B652E556E6465726C696E655468696E3D365D3D22556E6465726C696E655468696E227D28';
wwv_flow_imp.g_varchar2_table(1796) := '6D697C7C286D693D7B7D29292C66756E6374696F6E2865297B655B652E416C7761797347726F77735768656E547970696E67417445646765733D305D3D22416C7761797347726F77735768656E547970696E6741744564676573222C655B652E4E657665';
wwv_flow_imp.g_varchar2_table(1797) := '7247726F77735768656E547970696E67417445646765733D315D3D224E6576657247726F77735768656E547970696E6741744564676573222C655B652E47726F77734F6E6C795768656E547970696E674265666F72653D325D3D2247726F77734F6E6C79';
wwv_flow_imp.g_varchar2_table(1798) := '5768656E547970696E674265666F7265222C655B652E47726F77734F6E6C795768656E547970696E6741667465723D335D3D2247726F77734F6E6C795768656E547970696E674166746572227D2867697C7C2867693D7B7D29292C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1799) := '65297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E53616D653D315D3D2253616D65222C655B652E496E64656E743D325D3D22496E64656E74222C655B652E44656570496E64656E743D335D3D2244656570496E64656E74227D2866697C7C';
wwv_flow_imp.g_varchar2_table(1800) := '2866693D7B7D29293B636C617373204C697B7374617469632063686F726428652C74297B72657475726E2066756E6374696F6E28652C74297B72657475726E28657C2836353533352674293C3C31363E3E3E30293E3E3E307D28652C74297D7D4C692E43';
wwv_flow_imp.g_varchar2_table(1801) := '74726C436D643D323034382C4C692E53686966743D313032342C4C692E416C743D3531322C4C692E57696E4374726C3D3235363B636C6173732077697B636F6E7374727563746F7228652C74297B746869732E7572693D652C746869732E76616C75653D';
wwv_flow_imp.g_varchar2_table(1802) := '747D7D636C617373204E697B636F6E7374727563746F7228652C74297B696628746869735B70695D3D225265736F757263654D6170222C6520696E7374616E63656F66204E6929746869732E6D61703D6E6577204D617028652E6D6170292C746869732E';
wwv_flow_imp.g_varchar2_table(1803) := '746F4B65793D6E756C6C213D743F743A4E692E64656661756C74546F4B65793B656C73652069662866756E6374696F6E2865297B72657475726E2041727261792E697341727261792865297D286529297B746869732E6D61703D6E6577204D61702C7468';
wwv_flow_imp.g_varchar2_table(1804) := '69732E746F4B65793D6E756C6C213D743F743A4E692E64656661756C74546F4B65793B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D656C736520746869732E6D61703D6E6577204D61702C746869732E746F4B6579';
wwv_flow_imp.g_varchar2_table(1805) := '3D6E756C6C213D653F653A4E692E64656661756C74546F4B65797D73657428652C74297B72657475726E20746869732E6D61702E73657428746869732E746F4B65792865292C6E657720776928652C7429292C746869737D6765742865297B7661722074';
wwv_flow_imp.g_varchar2_table(1806) := '3B72657475726E206E756C6C3D3D3D28743D746869732E6D61702E67657428746869732E746F4B657928652929297C7C766F696420303D3D3D743F766F696420303A742E76616C75657D6861732865297B72657475726E20746869732E6D61702E686173';
wwv_flow_imp.g_varchar2_table(1807) := '28746869732E746F4B6579286529297D6765742073697A6528297B72657475726E20746869732E6D61702E73697A657D636C65617228297B746869732E6D61702E636C65617228297D64656C6574652865297B72657475726E20746869732E6D61702E64';
wwv_flow_imp.g_varchar2_table(1808) := '656C65746528746869732E746F4B6579286529297D666F724561636828652C74297B766F69642030213D3D74262628653D652E62696E64287429293B666F7228636F6E73745B742C6E5D6F6620746869732E6D61702965286E2E76616C75652C6E2E7572';
wwv_flow_imp.g_varchar2_table(1809) := '692C74686973297D2A76616C75657328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C6420652E76616C75657D2A6B65797328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C';
wwv_flow_imp.g_varchar2_table(1810) := '7565732829297969656C6420652E7572697D2A656E747269657328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C645B652E7572692C652E76616C75655D7D2A5B2870693D53796D626F6C2E746F5374';
wwv_flow_imp.g_varchar2_table(1811) := '72696E675461672C53796D626F6C2E6974657261746F72295D28297B666F7228636F6E73745B2C655D6F6620746869732E6D6170297969656C645B652E7572692C652E76616C75655D7D7D4E692E64656661756C74546F4B65793D653D3E652E746F5374';
wwv_flow_imp.g_varchar2_table(1812) := '72696E6728293B636C6173732045697B636F6E7374727563746F7228297B746869735B62695D3D224C696E6B65644D6170222C746869732E5F6D61703D6E6577204D61702C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F';
wwv_flow_imp.g_varchar2_table(1813) := '696420302C746869732E5F73697A653D302C746869732E5F73746174653D307D636C65617228297B746869732E5F6D61702E636C65617228292C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F';
wwv_flow_imp.g_varchar2_table(1814) := '73697A653D302C746869732E5F73746174652B2B7D6973456D70747928297B72657475726E21746869732E5F68656164262621746869732E5F7461696C7D6765742073697A6528297B72657475726E20746869732E5F73697A657D676574206669727374';
wwv_flow_imp.g_varchar2_table(1815) := '28297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F68656164297C7C766F696420303D3D3D653F766F696420303A652E76616C75657D676574206C61737428297B76617220653B72657475726E206E756C6C3D3D3D28653D74';
wwv_flow_imp.g_varchar2_table(1816) := '6869732E5F7461696C297C7C766F696420303D3D3D653F766F696420303A652E76616C75657D6861732865297B72657475726E20746869732E5F6D61702E6861732865297D67657428652C743D30297B636F6E7374206E3D746869732E5F6D61702E6765';
wwv_flow_imp.g_varchar2_table(1817) := '742865293B6966286E2972657475726E2030213D3D742626746869732E746F756368286E2C74292C6E2E76616C75657D73657428652C742C6E3D30297B6C657420693D746869732E5F6D61702E6765742865293B6966286929692E76616C75653D742C30';
wwv_flow_imp.g_varchar2_table(1818) := '213D3D6E2626746869732E746F75636828692C6E293B656C73657B73776974636828693D7B6B65793A652C76616C75653A742C6E6578743A766F696420302C70726576696F75733A766F696420307D2C6E297B6361736520303A6361736520323A646566';
wwv_flow_imp.g_varchar2_table(1819) := '61756C743A746869732E6164644974656D4C6173742869293B627265616B3B6361736520313A746869732E6164644974656D46697273742869297D746869732E5F6D61702E73657428652C69292C746869732E5F73697A652B2B7D72657475726E207468';
wwv_flow_imp.g_varchar2_table(1820) := '69737D64656C6574652865297B72657475726E2121746869732E72656D6F76652865297D72656D6F76652865297B636F6E737420743D746869732E5F6D61702E6765742865293B696628742972657475726E20746869732E5F6D61702E64656C65746528';
wwv_flow_imp.g_varchar2_table(1821) := '65292C746869732E72656D6F76654974656D2874292C746869732E5F73697A652D2D2C742E76616C75657D736869667428297B69662821746869732E5F68656164262621746869732E5F7461696C2972657475726E3B69662821746869732E5F68656164';
wwv_flow_imp.g_varchar2_table(1822) := '7C7C21746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B636F6E737420653D746869732E5F686561643B72657475726E20746869732E5F6D61702E64656C65746528652E6B6579292C74686973';
wwv_flow_imp.g_varchar2_table(1823) := '2E72656D6F76654974656D2865292C746869732E5F73697A652D2D2C652E76616C75657D666F724561636828652C74297B636F6E7374206E3D746869732E5F73746174653B6C657420693D746869732E5F686561643B666F72283B693B297B696628743F';
wwv_flow_imp.g_varchar2_table(1824) := '652E62696E6428742928692E76616C75652C692E6B65792C74686973293A6528692E76616C75652C692E6B65792C74686973292C746869732E5F7374617465213D3D6E297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D';
wwv_flow_imp.g_varchar2_table(1825) := '6F64696669656420647572696E6720697465726174696F6E2E22293B693D692E6E6578747D7D6B65797328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53';
wwv_flow_imp.g_varchar2_table(1826) := '796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F';
wwv_flow_imp.g_varchar2_table(1827) := '6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E6B65792C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D76';
wwv_flow_imp.g_varchar2_table(1828) := '616C75657328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374';
wwv_flow_imp.g_varchar2_table(1829) := '617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E76616C75652C646F6E';
wwv_flow_imp.g_varchar2_table(1830) := '653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D656E747269657328297B636F6E737420653D746869732C743D746869732E5F7374617465';
wwv_flow_imp.g_varchar2_table(1831) := '3B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D6170';
wwv_flow_imp.g_varchar2_table(1832) := '20676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A5B6E2E6B65792C6E2E76616C75655D2C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D7265';
wwv_flow_imp.g_varchar2_table(1833) := '7475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D5B2862693D53796D626F6C2E746F537472696E675461672C53796D626F6C2E6974657261746F72295D28297B72657475726E20746869732E656E74726965';
wwv_flow_imp.g_varchar2_table(1834) := '7328297D7472696D4F6C642865297B696628653E3D746869732E73697A652972657475726E3B696628303D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F686561642C6E3D746869732E73697A65';
wwv_flow_imp.g_varchar2_table(1835) := '3B666F72283B7426266E3E653B29746869732E5F6D61702E64656C65746528742E6B6579292C743D742E6E6578742C6E2D2D3B746869732E5F686561643D742C746869732E5F73697A653D6E2C74262628742E70726576696F75733D766F69642030292C';
wwv_flow_imp.g_varchar2_table(1836) := '746869732E5F73746174652B2B7D7472696D4E65772865297B696628653E3D746869732E73697A652972657475726E3B696628303D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F7461696C2C6E';
wwv_flow_imp.g_varchar2_table(1837) := '3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D61702E64656C65746528742E6B6579292C743D742E70726576696F75732C6E2D2D3B746869732E5F7461696C3D742C746869732E5F73697A653D6E2C74262628742E6E6578';
wwv_flow_imp.g_varchar2_table(1838) := '743D766F69642030292C746869732E5F73746174652B2B7D6164644974656D46697273742865297B696628746869732E5F686561647C7C746869732E5F7461696C297B69662821746869732E5F68656164297468726F77206E6577204572726F72282249';
wwv_flow_imp.g_varchar2_table(1839) := '6E76616C6964206C69737422293B652E6E6578743D746869732E5F686561642C746869732E5F686561642E70726576696F75733D657D656C736520746869732E5F7461696C3D653B746869732E5F686561643D652C746869732E5F73746174652B2B7D61';
wwv_flow_imp.g_varchar2_table(1840) := '64644974656D4C6173742865297B696628746869732E5F686561647C7C746869732E5F7461696C297B69662821746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E70726576696F75733D74';
wwv_flow_imp.g_varchar2_table(1841) := '6869732E5F7461696C2C746869732E5F7461696C2E6E6578743D657D656C736520746869732E5F686561643D653B746869732E5F7461696C3D652C746869732E5F73746174652B2B7D72656D6F76654974656D2865297B696628653D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(1842) := '686561642626653D3D3D746869732E5F7461696C29746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420303B656C736520696628653D3D3D746869732E5F68656164297B69662821652E6E657874297468726F77206E65';
wwv_flow_imp.g_varchar2_table(1843) := '77204572726F722822496E76616C6964206C69737422293B652E6E6578742E70726576696F75733D766F696420302C746869732E5F686561643D652E6E6578747D656C736520696628653D3D3D746869732E5F7461696C297B69662821652E7072657669';
wwv_flow_imp.g_varchar2_table(1844) := '6F7573297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E70726576696F75732E6E6578743D766F696420302C746869732E5F7461696C3D652E70726576696F75737D656C73657B636F6E737420743D652E6E657874';
wwv_flow_imp.g_varchar2_table(1845) := '2C6E3D652E70726576696F75733B69662821747C7C216E297468726F77206E6577204572726F722822496E76616C6964206C69737422293B742E70726576696F75733D6E2C6E2E6E6578743D747D652E6E6578743D766F696420302C652E70726576696F';
wwv_flow_imp.g_varchar2_table(1846) := '75733D766F696420302C746869732E5F73746174652B2B7D746F75636828652C74297B69662821746869732E5F686561647C7C21746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B696628313D';
wwv_flow_imp.g_varchar2_table(1847) := '3D3D747C7C323D3D3D7429696628313D3D3D74297B696628653D3D3D746869732E5F686561642972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F7461696C3F286E2E6E6578743D766F69';
wwv_flow_imp.g_varchar2_table(1848) := '6420302C746869732E5F7461696C3D6E293A28742E70726576696F75733D6E2C6E2E6E6578743D74292C652E70726576696F75733D766F696420302C652E6E6578743D746869732E5F686561642C746869732E5F686561642E70726576696F75733D652C';
wwv_flow_imp.g_varchar2_table(1849) := '746869732E5F686561643D652C746869732E5F73746174652B2B7D656C736520696628323D3D3D74297B696628653D3D3D746869732E5F7461696C2972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D74';
wwv_flow_imp.g_varchar2_table(1850) := '6869732E5F686561643F28742E70726576696F75733D766F696420302C746869732E5F686561643D74293A28742E70726576696F75733D6E2C6E2E6E6578743D74292C652E6E6578743D766F696420302C652E70726576696F75733D746869732E5F7461';
wwv_flow_imp.g_varchar2_table(1851) := '696C2C746869732E5F7461696C2E6E6578743D652C746869732E5F7461696C3D652C746869732E5F73746174652B2B7D7D746F4A534F4E28297B636F6E737420653D5B5D3B72657475726E20746869732E666F7245616368282828742C6E293D3E7B652E';
wwv_flow_imp.g_varchar2_table(1852) := '70757368285B6E2C745D297D29292C657D66726F6D4A534F4E2865297B746869732E636C65617228293B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D7D636C61737320536920657874656E64732045697B636F6E73';
wwv_flow_imp.g_varchar2_table(1853) := '74727563746F7228652C743D31297B737570657228292C746869732E5F6C696D69743D652C746869732E5F726174696F3D4D6174682E6D696E284D6174682E6D617828302C74292C31297D676574206C696D697428297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(1854) := '6C696D69747D736574206C696D69742865297B746869732E5F6C696D69743D652C746869732E636865636B5472696D28297D67657428652C743D32297B72657475726E2073757065722E67657428652C74297D7065656B2865297B72657475726E207375';
wwv_flow_imp.g_varchar2_table(1855) := '7065722E67657428652C30297D73657428652C74297B72657475726E2073757065722E73657428652C742C32292C746869737D636865636B5472696D28297B746869732E73697A653E746869732E5F6C696D69742626746869732E7472696D284D617468';
wwv_flow_imp.g_varchar2_table(1856) := '2E726F756E6428746869732E5F6C696D69742A746869732E5F726174696F29297D7D636C6173732052697B636F6E7374727563746F7228297B746869732E6D61703D6E6577204D61707D61646428652C74297B6C6574206E3D746869732E6D61702E6765';
wwv_flow_imp.g_varchar2_table(1857) := '742865293B6E7C7C286E3D6E6577205365742C746869732E6D61702E73657428652C6E29292C6E2E6164642874297D64656C65746528652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E2626286E2E64656C6574652874292C30';
wwv_flow_imp.g_varchar2_table(1858) := '3D3D3D6E2E73697A652626746869732E6D61702E64656C657465286529297D666F724561636828652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E26266E2E666F72456163682874297D6765742865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(1859) := '69732E6D61702E6765742865297C7C6E6577205365747D7D66756E6374696F6E20416928652C742C6E2C692C72297B72657475726E2066756E6374696F6E28652C742C6E2C692C72297B696628303D3D3D692972657475726E21303B636F6E737420733D';
wwv_flow_imp.g_varchar2_table(1860) := '742E63686172436F6465417428692D31293B69662830213D3D652E6765742873292972657475726E21303B69662831333D3D3D737C7C31303D3D3D732972657475726E21303B696628723E30297B636F6E7374206E3D742E63686172436F646541742869';
wwv_flow_imp.g_varchar2_table(1861) := '293B69662830213D3D652E676574286E292972657475726E21307D72657475726E21317D28652C742C302C692C7229262666756E6374696F6E28652C742C6E2C692C72297B696628692B723D3D3D6E2972657475726E21303B636F6E737420733D742E63';
wwv_flow_imp.g_varchar2_table(1862) := '686172436F6465417428692B72293B69662830213D3D652E6765742873292972657475726E21303B69662831333D3D3D737C7C31303D3D3D732972657475726E21303B696628723E30297B636F6E7374206E3D742E63686172436F6465417428692B722D';
wwv_flow_imp.g_varchar2_table(1863) := '31293B69662830213D3D652E676574286E292972657475726E21307D72657475726E21317D28652C742C6E2C692C72297D6E657720636C61737320657874656E64732053697B636F6E7374727563746F7228652C743D31297B737570657228652C74297D';
wwv_flow_imp.g_varchar2_table(1864) := '7472696D2865297B746869732E7472696D4F6C642865297D73657428652C74297B72657475726E2073757065722E73657428652C74292C746869732E636865636B5472696D28292C746869737D7D283130292C66756E6374696F6E2865297B655B652E4C';
wwv_flow_imp.g_varchar2_table(1865) := '6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D285F697C7C285F693D7B7D29292C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1866) := '65297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D2876697C7C2876693D7B7D29292C66756E6374696F6E2865297B655B652E426F7468';
wwv_flow_imp.g_varchar2_table(1867) := '3D305D3D22426F7468222C655B652E52696768743D315D3D225269676874222C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D2843697C7C2843693D7B7D29293B636C6173732078697B636F6E73747275';
wwv_flow_imp.g_varchar2_table(1868) := '63746F7228652C74297B746869732E5F776F7264536570617261746F72733D652C746869732E5F73656172636852656765783D742C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E';
wwv_flow_imp.g_varchar2_table(1869) := '6774683D307D72657365742865297B746869732E5F73656172636852656765782E6C617374496E6465783D652C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E6774683D307D6E65';
wwv_flow_imp.g_varchar2_table(1870) := '78742865297B636F6E737420743D652E6C656E6774683B6C6574206E3B646F7B696628746869732E5F707265764D617463685374617274496E6465782B746869732E5F707265764D617463684C656E6774683D3D3D742972657475726E206E756C6C3B69';
wwv_flow_imp.g_varchar2_table(1871) := '66286E3D746869732E5F73656172636852656765782E657865632865292C216E2972657475726E206E756C6C3B636F6E737420693D6E2E696E6465782C723D6E5B305D2E6C656E6774683B696628693D3D3D746869732E5F707265764D61746368537461';
wwv_flow_imp.g_varchar2_table(1872) := '7274496E6465782626723D3D3D746869732E5F707265764D617463684C656E677468297B696628303D3D3D72297B646528652C742C746869732E5F73656172636852656765782E6C617374496E646578293E36353533353F746869732E5F736561726368';
wwv_flow_imp.g_varchar2_table(1873) := '52656765782E6C617374496E6465782B3D323A746869732E5F73656172636852656765782E6C617374496E6465782B3D313B636F6E74696E75657D72657475726E206E756C6C7D696628746869732E5F707265764D617463685374617274496E6465783D';
wwv_flow_imp.g_varchar2_table(1874) := '692C746869732E5F707265764D617463684C656E6774683D722C21746869732E5F776F7264536570617261746F72737C7C416928746869732E5F776F7264536570617261746F72732C652C742C692C72292972657475726E206E7D7768696C65286E293B';
wwv_flow_imp.g_varchar2_table(1875) := '72657475726E206E756C6C7D7D66756E6374696F6E204D6928652C743D22556E726561636861626C6522297B7468726F77206E6577204572726F722874297D66756E6374696F6E206B692865297B6528297C7C286528292C74286E6577206F2822417373';
wwv_flow_imp.g_varchar2_table(1876) := '657274696F6E204661696C6564222929297D66756E6374696F6E204F6928652C74297B6C6574206E3D303B666F72283B6E3C652E6C656E6774682D313B297B696628217428655B6E5D2C655B6E2B315D292972657475726E21313B6E2B2B7D7265747572';
wwv_flow_imp.g_varchar2_table(1877) := '6E21307D636C6173732054697B73746174696320636F6D70757465556E69636F6465486967686C696768747328652C742C6E297B636F6E737420693D6E3F6E2E73746172744C696E654E756D6265723A312C723D6E3F6E2E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1878) := '723A652E6765744C696E65436F756E7428292C733D6E65772049692874292C6F3D732E67657443616E646964617465436F6465506F696E747328293B6C657420613B766172206C3B613D22616C6C4E6F6E42617369634173636969223D3D3D6F3F6E6577';
wwv_flow_imp.g_varchar2_table(1879) := '2052656745787028225B5E5C5C745C5C6E5C5C725C5C7832302D5C5C7837455D222C226722293A6E65772052656745787028605B247B6C3D41727261792E66726F6D286F292E6D61702828653D3E537472696E672E66726F6D436F6465506F696E742865';
wwv_flow_imp.g_varchar2_table(1880) := '2929292E6A6F696E282222292C6C2E7265706C616365282F5B5C5C5C7B5C7D5C2A5C2B5C3F5C7C5C5E5C245C2E5C5B5C5D5C285C295D2F672C225C5C242622297D5D602C226722293B636F6E737420753D6E6577207869286E756C6C2C61292C683D5B5D';
wwv_flow_imp.g_varchar2_table(1881) := '3B6C657420632C643D21312C6D3D302C673D302C663D303B653A666F72286C657420743D692C6E3D723B743C3D6E3B742B2B297B636F6E7374206E3D652E6765744C696E65436F6E74656E742874292C693D6E2E6C656E6774683B752E72657365742830';
wwv_flow_imp.g_varchar2_table(1882) := '293B646F7B696628633D752E6E657874286E292C63297B6C657420653D632E696E6465782C723D632E696E6465782B635B305D2E6C656E6774683B653E3026267565286E2E63686172436F6465417428652D3129292626652D2D2C722B313C6926267565';
wwv_flow_imp.g_varchar2_table(1883) := '286E2E63686172436F6465417428722D3129292626722B2B3B636F6E7374206F3D6E2E737562737472696E6728652C72293B6C657420613D447428652B312C54742C6E2C30293B612626612E656E64436F6C756D6E3C3D652B31262628613D6E756C6C29';
wwv_flow_imp.g_varchar2_table(1884) := '3B636F6E7374206C3D732E73686F756C64486967686C696768744E6F6E42617369634153434949286F2C613F612E776F72643A6E756C6C293B69662830213D3D6C297B333D3D3D6C3F6D2B2B3A323D3D3D6C3F672B2B3A313D3D3D6C3F662B2B3A4D6928';
wwv_flow_imp.g_varchar2_table(1885) := '293B636F6E7374206E3D3165333B696628682E6C656E6774683E3D6E297B643D21303B627265616B20657D682E70757368286E657720777428742C652B312C742C722B3129297D7D7D7768696C652863297D72657475726E7B72616E6765733A682C6861';
wwv_flow_imp.g_varchar2_table(1886) := '734D6F72653A642C616D626967756F7573436861726163746572436F756E743A6D2C696E76697369626C65436861726163746572436F756E743A672C6E6F6E42617369634173636969436861726163746572436F756E743A667D7D73746174696320636F';
wwv_flow_imp.g_varchar2_table(1887) := '6D70757465556E69636F6465486967686C69676874526561736F6E28652C74297B636F6E7374206E3D6E65772049692874293B737769746368286E2E73686F756C64486967686C696768744E6F6E4261736963415343494928652C6E756C6C29297B6361';
wwv_flow_imp.g_varchar2_table(1888) := '736520303A72657475726E206E756C6C3B6361736520323A72657475726E7B6B696E643A317D3B6361736520333A7B636F6E737420693D652E636F6465506F696E7441742830292C723D6E2E616D626967756F7573436861726163746572732E67657450';
wwv_flow_imp.g_varchar2_table(1889) := '72696D617279436F6E66757361626C652869292C733D66652E6765744C6F63616C657328292E66696C7465722828653D3E2166652E676574496E7374616E6365286E657720536574285B2E2E2E742E616C6C6F7765644C6F63616C65732C655D29292E69';
wwv_flow_imp.g_varchar2_table(1890) := '73416D626967756F757328692929293B72657475726E7B6B696E643A302C636F6E66757361626C65576974683A537472696E672E66726F6D436F6465506F696E742872292C6E6F74416D626967756F7573496E4C6F63616C65733A737D7D636173652031';
wwv_flow_imp.g_varchar2_table(1891) := '3A72657475726E7B6B696E643A327D7D7D7D636C6173732049697B636F6E7374727563746F722865297B746869732E6F7074696F6E733D652C746869732E616C6C6F776564436F6465506F696E74733D6E65772053657428652E616C6C6F776564436F64';
wwv_flow_imp.g_varchar2_table(1892) := '65506F696E7473292C746869732E616D626967756F7573436861726163746572733D66652E676574496E7374616E6365286E65772053657428652E616C6C6F7765644C6F63616C657329297D67657443616E646964617465436F6465506F696E74732829';
wwv_flow_imp.g_varchar2_table(1893) := '7B696628746869732E6F7074696F6E732E6E6F6E426173696341534349492972657475726E22616C6C4E6F6E42617369634173636969223B636F6E737420653D6E6577205365743B696628746869732E6F7074696F6E732E696E76697369626C65436861';
wwv_flow_imp.g_varchar2_table(1894) := '7261637465727329666F7228636F6E73742074206F662070652E636F6465506F696E747329506928537472696E672E66726F6D436F6465506F696E74287429297C7C652E6164642874293B696628746869732E6F7074696F6E732E616D626967756F7573';
wwv_flow_imp.g_varchar2_table(1895) := '4368617261637465727329666F7228636F6E73742074206F6620746869732E616D626967756F7573436861726163746572732E676574436F6E66757361626C65436F6465506F696E7473282929652E6164642874293B666F7228636F6E73742074206F66';
wwv_flow_imp.g_varchar2_table(1896) := '20746869732E616C6C6F776564436F6465506F696E747329652E64656C6574652874293B72657475726E20657D73686F756C64486967686C696768744E6F6E4261736963415343494928652C74297B636F6E7374206E3D652E636F6465506F696E744174';
wwv_flow_imp.g_varchar2_table(1897) := '2830293B696628746869732E616C6C6F776564436F6465506F696E74732E686173286E292972657475726E20303B696628746869732E6F7074696F6E732E6E6F6E426173696341534349492972657475726E20313B6C657420693D21312C723D21313B69';
wwv_flow_imp.g_varchar2_table(1898) := '66287429666F7228636F6E73742065206F662074297B636F6E737420743D652E636F6465506F696E7441742830292C6E3D28733D652C6D652E74657374287329293B693D697C7C6E2C6E7C7C746869732E616D626967756F757343686172616374657273';
wwv_flow_imp.g_varchar2_table(1899) := '2E6973416D626967756F75732874297C7C70652E6973496E76697369626C654368617261637465722874297C7C28723D2130297D76617220733B72657475726E21692626723F303A746869732E6F7074696F6E732E696E76697369626C65436861726163';
wwv_flow_imp.g_varchar2_table(1900) := '746572732626215069286529262670652E6973496E76697369626C65436861726163746572286E293F323A746869732E6F7074696F6E732E616D626967756F7573436861726163746572732626746869732E616D626967756F7573436861726163746572';
wwv_flow_imp.g_varchar2_table(1901) := '732E6973416D626967756F7573286E293F333A307D7D66756E6374696F6E2050692865297B72657475726E2220223D3D3D657C7C225C6E223D3D3D657C7C225C74223D3D3D657D636C6173732044697B636F6E7374727563746F7228652C742C6E297B74';
wwv_flow_imp.g_varchar2_table(1902) := '6869732E6368616E6765733D652C746869732E6D6F7665733D742C746869732E68697454696D656F75743D6E7D7D636C6173732046697B636F6E7374727563746F7228652C74297B746869732E6C696E6552616E67654D617070696E673D652C74686973';
wwv_flow_imp.g_varchar2_table(1903) := '2E6368616E6765733D747D7D636C617373204B697B7374617469632061646452616E676528652C74297B6C6574206E3D303B666F72283B6E3C742E6C656E6774682626745B6E5D2E656E644578636C75736976653C652E73746172743B296E2B2B3B6C65';
wwv_flow_imp.g_varchar2_table(1904) := '7420693D6E3B666F72283B693C742E6C656E6774682626745B695D2E73746172743C3D652E656E644578636C75736976653B29692B2B3B6966286E3D3D3D6929742E73706C696365286E2C302C65293B656C73657B636F6E737420723D4D6174682E6D69';
wwv_flow_imp.g_varchar2_table(1905) := '6E28652E73746172742C745B6E5D2E7374617274292C733D4D6174682E6D617828652E656E644578636C75736976652C745B692D315D2E656E644578636C7573697665293B742E73706C696365286E2C692D6E2C6E6577204B6928722C7329297D7D7374';
wwv_flow_imp.g_varchar2_table(1906) := '617469632074727943726561746528652C74297B6966282128653E74292972657475726E206E6577204B6928652C74297D737461746963206F664C656E6774682865297B72657475726E206E6577204B6928302C65297D737461746963206F6653746172';
wwv_flow_imp.g_varchar2_table(1907) := '74416E644C656E67746828652C74297B72657475726E206E6577204B6928652C652B74297D636F6E7374727563746F7228652C74297B696628746869732E73746172743D652C746869732E656E644578636C75736976653D742C653E74297468726F7720';
wwv_flow_imp.g_varchar2_table(1908) := '6E6577206F2860496E76616C69642072616E67653A20247B746869732E746F537472696E6728297D60297D676574206973456D70747928297B72657475726E20746869732E73746172743D3D3D746869732E656E644578636C75736976657D64656C7461';
wwv_flow_imp.g_varchar2_table(1909) := '2865297B72657475726E206E6577204B6928746869732E73746172742B652C746869732E656E644578636C75736976652B65297D64656C746153746172742865297B72657475726E206E6577204B6928746869732E73746172742B652C746869732E656E';
wwv_flow_imp.g_varchar2_table(1910) := '644578636C7573697665297D64656C7461456E642865297B72657475726E206E6577204B6928746869732E73746172742C746869732E656E644578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644578';
wwv_flow_imp.g_varchar2_table(1911) := '636C75736976652D746869732E73746172747D746F537472696E6728297B72657475726E605B247B746869732E73746172747D2C20247B746869732E656E644578636C75736976657D29607D636F6E7461696E732865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(1912) := '73746172743C3D652626653C746869732E656E644578636C75736976657D6A6F696E2865297B72657475726E206E6577204B69284D6174682E6D696E28746869732E73746172742C652E7374617274292C4D6174682E6D617828746869732E656E644578';
wwv_flow_imp.g_varchar2_table(1913) := '636C75736976652C652E656E644578636C757369766529297D696E746572736563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172742C652E7374617274292C6E3D4D6174682E6D696E28746869732E656E644578636C7573';
wwv_flow_imp.g_varchar2_table(1914) := '6976652C652E656E644578636C7573697665293B696628743C3D6E2972657475726E206E6577204B6928742C6E297D696E74657273656374732865297B72657475726E204D6174682E6D617828746869732E73746172742C652E7374617274293C4D6174';
wwv_flow_imp.g_varchar2_table(1915) := '682E6D696E28746869732E656E644578636C75736976652C652E656E644578636C7573697665297D69734265666F72652865297B72657475726E20746869732E656E644578636C75736976653C3D652E73746172747D697341667465722865297B726574';
wwv_flow_imp.g_varchar2_table(1916) := '75726E20746869732E73746172743E3D652E656E644578636C75736976657D736C6963652865297B72657475726E20652E736C69636528746869732E73746172742C746869732E656E644578636C7573697665297D737562737472696E672865297B7265';
wwv_flow_imp.g_varchar2_table(1917) := '7475726E20652E737562737472696E6728746869732E73746172742C746869732E656E644578636C7573697665297D636C69702865297B696628746869732E6973456D707479297468726F77206E6577206F2860496E76616C696420636C697070696E67';
wwv_flow_imp.g_varchar2_table(1918) := '2072616E67653A20247B746869732E746F537472696E6728297D60293B72657475726E204D6174682E6D617828746869732E73746172742C4D6174682E6D696E28746869732E656E644578636C75736976652D312C6529297D636C69704379636C696328';
wwv_flow_imp.g_varchar2_table(1919) := '65297B696628746869732E6973456D707479297468726F77206E6577206F2860496E76616C696420636C697070696E672072616E67653A20247B746869732E746F537472696E6728297D60293B72657475726E20653C746869732E73746172743F746869';
wwv_flow_imp.g_varchar2_table(1920) := '732E656E644578636C75736976652D28746869732E73746172742D652925746869732E6C656E6774683A653E3D746869732E656E644578636C75736976653F746869732E73746172742B28652D746869732E73746172742925746869732E6C656E677468';
wwv_flow_imp.g_varchar2_table(1921) := '3A657D666F72456163682865297B666F72286C657420743D746869732E73746172743B743C746869732E656E644578636C75736976653B742B2B29652874297D7D66756E6374696F6E20716928652C74297B636F6E7374206E3D566928652C74293B7265';
wwv_flow_imp.g_varchar2_table(1922) := '7475726E2D313D3D3D6E3F766F696420303A655B6E5D7D66756E6374696F6E20566928652C742C6E3D302C693D652E6C656E677468297B6C657420723D6E2C733D693B666F72283B723C733B297B636F6E7374206E3D4D6174682E666C6F6F722828722B';
wwv_flow_imp.g_varchar2_table(1923) := '73292F32293B7428655B6E5D293F723D6E2B313A733D6E7D72657475726E20722D317D66756E6374696F6E20426928652C742C6E3D302C693D652E6C656E677468297B6C657420723D6E2C733D693B666F72283B723C733B297B636F6E7374206E3D4D61';
wwv_flow_imp.g_varchar2_table(1924) := '74682E666C6F6F722828722B73292F32293B7428655B6E5D293F733D6E3A723D6E2B317D72657475726E20727D636C6173732055697B636F6E7374727563746F722865297B746869732E5F61727261793D652C746869732E5F66696E644C6173744D6F6E';
wwv_flow_imp.g_varchar2_table(1925) := '6F746F6E6F75734C6173744964783D307D66696E644C6173744D6F6E6F746F6E6F75732865297B69662855692E617373657274496E76617269616E7473297B696628746869732E5F7072657646696E644C61737450726564696361746529666F7228636F';
wwv_flow_imp.g_varchar2_table(1926) := '6E73742074206F6620746869732E5F617272617929696628746869732E5F7072657646696E644C61737450726564696361746528742926262165287429297468726F77206E6577204572726F7228224D6F6E6F746F6E6F757341727261793A2063757272';
wwv_flow_imp.g_varchar2_table(1927) := '656E7420707265646963617465206D757374206265207765616B6572207468616E20286F7220657175616C20746F29207468652070726576696F7573207072656469636174652E22293B746869732E5F7072657646696E644C6173745072656469636174';
wwv_flow_imp.g_varchar2_table(1928) := '653D657D636F6E737420743D566928746869732E5F61727261792C652C746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C617374496478293B72657475726E20746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C617374496478';
wwv_flow_imp.g_varchar2_table(1929) := '3D742B312C2D313D3D3D743F766F696420303A746869732E5F61727261795B745D7D7D55692E617373657274496E76617269616E74733D21313B636C617373207A697B7374617469632066726F6D52616E6765496E636C75736976652865297B72657475';
wwv_flow_imp.g_varchar2_table(1930) := '726E206E6577207A6928652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722B31297D737461746963206A6F696E4D616E792865297B696628303D3D3D652E6C656E6774682972657475726E5B5D3B6C657420743D6E6577';
wwv_flow_imp.g_varchar2_table(1931) := '20486928655B305D2E736C6963652829293B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B29743D742E676574556E696F6E286E657720486928655B6E5D2E736C696365282929293B72657475726E20742E72616E6765737D73746174';
wwv_flow_imp.g_varchar2_table(1932) := '6963206A6F696E2865297B696628303D3D3D652E6C656E677468297468726F77206E6577206F28226C696E6552616E6765732063616E6E6F7420626520656D70747922293B6C657420743D655B305D2E73746172744C696E654E756D6265722C6E3D655B';
wwv_flow_imp.g_varchar2_table(1933) := '305D2E656E644C696E654E756D6265724578636C75736976653B666F72286C657420693D313B693C652E6C656E6774683B692B2B29743D4D6174682E6D696E28742C655B695D2E73746172744C696E654E756D626572292C6E3D4D6174682E6D6178286E';
wwv_flow_imp.g_varchar2_table(1934) := '2C655B695D2E656E644C696E654E756D6265724578636C7573697665293B72657475726E206E6577207A6928742C6E297D737461746963206F664C656E67746828652C74297B72657475726E206E6577207A6928652C652B74297D737461746963206465';
wwv_flow_imp.g_varchar2_table(1935) := '73657269616C697A652865297B72657475726E206E6577207A6928655B305D2C655B315D297D636F6E7374727563746F7228652C74297B696628653E74297468726F77206E6577206F286073746172744C696E654E756D62657220247B657D2063616E6E';
wwv_flow_imp.g_varchar2_table(1936) := '6F7420626520616674657220656E644C696E654E756D6265724578636C757369766520247B747D60293B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D6265724578636C75736976653D747D636F6E7461';
wwv_flow_imp.g_varchar2_table(1937) := '696E732865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652626653C746869732E656E644C696E654E756D6265724578636C75736976657D676574206973456D70747928297B72657475726E20746869732E7374617274';
wwv_flow_imp.g_varchar2_table(1938) := '4C696E654E756D6265723D3D3D746869732E656E644C696E654E756D6265724578636C75736976657D64656C74612865297B72657475726E206E6577207A6928746869732E73746172744C696E654E756D6265722B652C746869732E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(1939) := '756D6265724578636C75736976652B65297D64656C74614C656E6774682865297B72657475726E206E6577207A6928746869732E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976652B65297D67';
wwv_flow_imp.g_varchar2_table(1940) := '6574206C656E67746828297B72657475726E20746869732E656E644C696E654E756D6265724578636C75736976652D746869732E73746172744C696E654E756D6265727D6A6F696E2865297B72657475726E206E6577207A69284D6174682E6D696E2874';
wwv_flow_imp.g_varchar2_table(1941) := '6869732E73746172744C696E654E756D6265722C652E73746172744C696E654E756D626572292C4D6174682E6D617828746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E654E756D6265724578636C7573697665';
wwv_flow_imp.g_varchar2_table(1942) := '29297D746F537472696E6728297B72657475726E605B247B746869732E73746172744C696E654E756D6265727D2C247B746869732E656E644C696E654E756D6265724578636C75736976657D29607D696E746572736563742865297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(1943) := '4D6174682E6D617828746869732E73746172744C696E654E756D6265722C652E73746172744C696E654E756D626572292C6E3D4D6174682E6D696E28746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(1944) := '6265724578636C7573697665293B696628743C3D6E2972657475726E206E6577207A6928742C6E297D696E74657273656374735374726963742865297B72657475726E20746869732E73746172744C696E654E756D6265723C652E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(1945) := '6D6265724578636C75736976652626652E73746172744C696E654E756D6265723C746869732E656E644C696E654E756D6265724578636C75736976657D6F7665726C61704F72546F7563682865297B72657475726E20746869732E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(1946) := '4E756D6265723C3D652E656E644C696E654E756D6265724578636C75736976652626652E73746172744C696E654E756D6265723C3D746869732E656E644C696E654E756D6265724578636C75736976657D657175616C732865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(1947) := '69732E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626746869732E656E644C696E654E756D6265724578636C75736976653D3D3D652E656E644C696E654E756D6265724578636C75736976657D746F496E63';
wwv_flow_imp.g_varchar2_table(1948) := '6C757369766552616E676528297B72657475726E20746869732E6973456D7074793F6E756C6C3A6E657720777428746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D6265724578636C75736976652D312C4E';
wwv_flow_imp.g_varchar2_table(1949) := '756D6265722E4D41585F534146455F494E5445474552297D746F4578636C757369766552616E676528297B72657475726E206E657720777428746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D6265724578';
wwv_flow_imp.g_varchar2_table(1950) := '636C75736976652C31297D6D6170546F4C696E6541727261792865297B636F6E737420743D5B5D3B666F72286C6574206E3D746869732E73746172744C696E654E756D6265723B6E3C746869732E656E644C696E654E756D6265724578636C7573697665';
wwv_flow_imp.g_varchar2_table(1951) := '3B6E2B2B29742E707573682865286E29293B72657475726E20747D666F72456163682865297B666F72286C657420743D746869732E73746172744C696E654E756D6265723B743C746869732E656E644C696E654E756D6265724578636C75736976653B74';
wwv_flow_imp.g_varchar2_table(1952) := '2B2B29652874297D73657269616C697A6528297B72657475726E5B746869732E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976655D7D696E636C756465732865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(1953) := '2E73746172744C696E654E756D6265723C3D652626653C746869732E656E644C696E654E756D6265724578636C75736976657D746F4F666673657452616E676528297B72657475726E206E6577204B6928746869732E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1954) := '722D312C746869732E656E644C696E654E756D6265724578636C75736976652D31297D7D636C6173732048697B636F6E7374727563746F7228653D5B5D297B746869732E5F6E6F726D616C697A656452616E6765733D657D6765742072616E6765732829';
wwv_flow_imp.g_varchar2_table(1955) := '7B72657475726E20746869732E5F6E6F726D616C697A656452616E6765737D61646452616E67652865297B696628303D3D3D652E6C656E6774682972657475726E3B636F6E737420743D426928746869732E5F6E6F726D616C697A656452616E6765732C';
wwv_flow_imp.g_varchar2_table(1956) := '28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D652E73746172744C696E654E756D62657229292C6E3D566928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C';
wwv_flow_imp.g_varchar2_table(1957) := '3D652E656E644C696E654E756D6265724578636C757369766529292B313B696628743D3D3D6E29746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C302C65293B656C736520696628743D3D3D6E2D31297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(1958) := '3D746869732E5F6E6F726D616C697A656452616E6765735B745D3B746869732E5F6E6F726D616C697A656452616E6765735B745D3D6E2E6A6F696E2865297D656C73657B636F6E737420693D746869732E5F6E6F726D616C697A656452616E6765735B74';
wwv_flow_imp.g_varchar2_table(1959) := '5D2E6A6F696E28746869732E5F6E6F726D616C697A656452616E6765735B6E2D315D292E6A6F696E2865293B746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C6E2D742C69297D7D636F6E7461696E732865297B636F6E73';
wwv_flow_imp.g_varchar2_table(1960) := '7420743D716928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D6529293B72657475726E2121742626742E656E644C696E654E756D6265724578636C75736976653E657D696E746572';
wwv_flow_imp.g_varchar2_table(1961) := '73656374732865297B636F6E737420743D716928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C652E656E644C696E654E756D6265724578636C757369766529293B72657475726E2121';
wwv_flow_imp.g_varchar2_table(1962) := '742626742E656E644C696E654E756D6265724578636C75736976653E652E73746172744C696E654E756D6265727D676574556E696F6E2865297B696628303D3D3D746869732E5F6E6F726D616C697A656452616E6765732E6C656E677468297265747572';
wwv_flow_imp.g_varchar2_table(1963) := '6E20653B696628303D3D3D652E5F6E6F726D616C697A656452616E6765732E6C656E6774682972657475726E20746869733B636F6E737420743D5B5D3B6C6574206E3D302C693D302C723D6E756C6C3B666F72283B6E3C746869732E5F6E6F726D616C69';
wwv_flow_imp.g_varchar2_table(1964) := '7A656452616E6765732E6C656E6774687C7C693C652E5F6E6F726D616C697A656452616E6765732E6C656E6774683B297B6C657420733D6E756C6C3B6966286E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626693C652E';
wwv_flow_imp.g_varchar2_table(1965) := '5F6E6F726D616C697A656452616E6765732E6C656E677468297B636F6E737420743D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C723D652E5F6E6F726D616C697A656452616E6765735B695D3B742E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1966) := '65723C722E73746172744C696E654E756D6265723F28733D742C6E2B2B293A28733D722C692B2B297D656C7365206E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774683F28733D746869732E5F6E6F726D616C697A656452616E';
wwv_flow_imp.g_varchar2_table(1967) := '6765735B6E5D2C6E2B2B293A28733D652E5F6E6F726D616C697A656452616E6765735B695D2C692B2B293B6E756C6C3D3D3D723F723D733A722E656E644C696E654E756D6265724578636C75736976653E3D732E73746172744C696E654E756D6265723F';
wwv_flow_imp.g_varchar2_table(1968) := '723D6E6577207A6928722E73746172744C696E654E756D6265722C4D6174682E6D617828722E656E644C696E654E756D6265724578636C75736976652C732E656E644C696E654E756D6265724578636C757369766529293A28742E707573682872292C72';
wwv_flow_imp.g_varchar2_table(1969) := '3D73297D72657475726E206E756C6C213D3D722626742E707573682872292C6E65772048692874297D737562747261637446726F6D2865297B636F6E737420743D426928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E656E64';
wwv_flow_imp.g_varchar2_table(1970) := '4C696E654E756D6265724578636C75736976653E3D652E73746172744C696E654E756D62657229292C6E3D566928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D652E656E644C696E';
wwv_flow_imp.g_varchar2_table(1971) := '654E756D6265724578636C757369766529292B313B696628743D3D3D6E2972657475726E206E6577204869285B655D293B636F6E737420693D5B5D3B6C657420723D652E73746172744C696E654E756D6265723B666F72286C657420653D743B653C6E3B';
wwv_flow_imp.g_varchar2_table(1972) := '652B2B297B636F6E737420743D746869732E5F6E6F726D616C697A656452616E6765735B655D3B742E73746172744C696E654E756D6265723E722626692E70757368286E6577207A6928722C742E73746172744C696E654E756D62657229292C723D742E';
wwv_flow_imp.g_varchar2_table(1973) := '656E644C696E654E756D6265724578636C75736976657D72657475726E20723C652E656E644C696E654E756D6265724578636C75736976652626692E70757368286E6577207A6928722C652E656E644C696E654E756D6265724578636C75736976652929';
wwv_flow_imp.g_varchar2_table(1974) := '2C6E65772048692869297D746F537472696E6728297B72657475726E20746869732E5F6E6F726D616C697A656452616E6765732E6D61702828653D3E652E746F537472696E67282929292E6A6F696E28222C2022297D676574496E74657273656374696F';
wwv_flow_imp.g_varchar2_table(1975) := '6E2865297B636F6E737420743D5B5D3B6C6574206E3D302C693D303B666F72283B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626693C652E5F6E6F726D616C697A656452616E6765732E6C656E6774683B297B636F6E';
wwv_flow_imp.g_varchar2_table(1976) := '737420723D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C733D652E5F6E6F726D616C697A656452616E6765735B695D2C6F3D722E696E746572736563742873293B6F2626216F2E6973456D7074792626742E70757368286F292C722E';
wwv_flow_imp.g_varchar2_table(1977) := '656E644C696E654E756D6265724578636C75736976653C732E656E644C696E654E756D6265724578636C75736976653F6E2B2B3A692B2B7D72657475726E206E65772048692874297D6765745769746844656C74612865297B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(1978) := '486928746869732E5F6E6F726D616C697A656452616E6765732E6D61702828743D3E742E64656C74612865292929297D7D636C6173732057697B737461746963206265747765656E506F736974696F6E7328652C74297B72657475726E20652E6C696E65';
wwv_flow_imp.g_varchar2_table(1979) := '4E756D6265723D3D3D742E6C696E654E756D6265723F6E657720576928302C742E636F6C756D6E2D652E636F6C756D6E293A6E657720576928742E6C696E654E756D6265722D652E6C696E654E756D6265722C742E636F6C756D6E2D31297D7374617469';
wwv_flow_imp.g_varchar2_table(1980) := '63206F6652616E67652865297B72657475726E2057692E6265747765656E506F736974696F6E7328652E6765745374617274506F736974696F6E28292C652E676574456E64506F736974696F6E2829297D737461746963206F66546578742865297B6C65';
wwv_flow_imp.g_varchar2_table(1981) := '7420743D302C6E3D303B666F7228636F6E73742069206F66206529225C6E223D3D3D693F28742B2B2C6E3D30293A6E2B2B3B72657475726E206E657720576928742C6E297D636F6E7374727563746F7228652C74297B746869732E6C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(1982) := '3D652C746869732E636F6C756D6E436F756E743D747D6973477265617465725468616E4F72457175616C546F2865297B72657475726E20746869732E6C696E65436F756E74213D3D652E6C696E65436F756E743F746869732E6C696E65436F756E743E65';
wwv_flow_imp.g_varchar2_table(1983) := '2E6C696E65436F756E743A746869732E636F6C756D6E436F756E743E3D652E636F6C756D6E436F756E747D63726561746552616E67652865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E657720777428652E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(1984) := '6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C756D6E2B746869732E636F6C756D6E436F756E74293A6E657720777428652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722B746869732E';
wwv_flow_imp.g_varchar2_table(1985) := '6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D616464546F506F736974696F6E2865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E6577204C7428652E6C696E654E756D6265722C652E636F6C756D';
wwv_flow_imp.g_varchar2_table(1986) := '6E2B746869732E636F6C756D6E436F756E74293A6E6577204C7428652E6C696E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D746F537472696E6728297B72657475726E60247B746869732E';
wwv_flow_imp.g_varchar2_table(1987) := '6C696E65436F756E747D2C247B746869732E636F6C756D6E436F756E747D607D7D57692E7A65726F3D6E657720576928302C30293B636C6173732024697B636F6E7374727563746F7228652C74297B746869732E72616E67653D652C746869732E746578';
wwv_flow_imp.g_varchar2_table(1988) := '743D747D7D636C617373206A697B73746174696320696E766572736528652C742C6E297B636F6E737420693D5B5D3B6C657420723D312C733D313B666F7228636F6E73742074206F662065297B636F6E737420653D6E6577206A69286E6577207A692872';
wwv_flow_imp.g_varchar2_table(1989) := '2C742E6F726967696E616C2E73746172744C696E654E756D626572292C6E6577207A6928732C742E6D6F6469666965642E73746172744C696E654E756D62657229293B652E6D6F6469666965642E6973456D7074797C7C692E707573682865292C723D74';
wwv_flow_imp.g_varchar2_table(1990) := '2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C733D742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976657D636F6E7374206F3D6E6577206A69286E6577207A6928722C742B31292C6E65';
wwv_flow_imp.g_varchar2_table(1991) := '77207A6928732C6E2B3129293B72657475726E206F2E6D6F6469666965642E6973456D7074797C7C692E70757368286F292C697D73746174696320636C697028652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E73742072206F662065297B';
wwv_flow_imp.g_varchar2_table(1992) := '636F6E737420653D722E6F726967696E616C2E696E746572736563742874292C733D722E6D6F6469666965642E696E74657273656374286E293B65262621652E6973456D707479262673262621732E6973456D7074792626692E70757368286E6577206A';
wwv_flow_imp.g_varchar2_table(1993) := '6928652C7329297D72657475726E20697D636F6E7374727563746F7228652C74297B746869732E6F726967696E616C3D652C746869732E6D6F6469666965643D747D746F537472696E6728297B72657475726E607B247B746869732E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(1994) := '2E746F537472696E6728297D2D3E247B746869732E6D6F6469666965642E746F537472696E6728297D7D607D666C697028297B72657475726E206E6577206A6928746869732E6D6F6469666965642C746869732E6F726967696E616C297D6A6F696E2865';
wwv_flow_imp.g_varchar2_table(1995) := '297B72657475726E206E6577206A6928746869732E6F726967696E616C2E6A6F696E28652E6F726967696E616C292C746869732E6D6F6469666965642E6A6F696E28652E6D6F64696669656429297D746F52616E67654D617070696E6728297B636F6E73';
wwv_flow_imp.g_varchar2_table(1996) := '7420653D746869732E6F726967696E616C2E746F496E636C757369766552616E676528292C743D746869732E6D6F6469666965642E746F496E636C757369766552616E676528293B696628652626742972657475726E206E657720516928652C74293B69';
wwv_flow_imp.g_varchar2_table(1997) := '6628313D3D3D746869732E6F726967696E616C2E73746172744C696E654E756D6265727C7C313D3D3D746869732E6D6F6469666965642E73746172744C696E654E756D626572297B69662831213D3D746869732E6D6F6469666965642E73746172744C69';
wwv_flow_imp.g_varchar2_table(1998) := '6E654E756D6265727C7C31213D3D746869732E6F726967696E616C2E73746172744C696E654E756D626572297468726F77206E6577206F28226E6F7420612076616C6964206469666622293B72657475726E206E6577205169286E657720777428746869';
wwv_flow_imp.g_varchar2_table(1999) := '732E6F726967696E616C2E73746172744C696E654E756D6265722C312C746869732E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C31292C6E657720777428746869732E6D6F6469666965642E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(2000) := '756D6265722C312C746869732E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C3129297D72657475726E206E6577205169286E657720777428746869732E6F726967696E616C2E73746172744C696E654E756D6265722D';
wwv_flow_imp.g_varchar2_table(2001) := '312C4E756D6265722E4D41585F534146455F494E54454745522C746869732E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445474552292C6E657720777428746869';
wwv_flow_imp.g_varchar2_table(2002) := '732E6D6F6469666965642E73746172744C696E654E756D6265722D312C4E756D6265722E4D41585F534146455F494E54454745522C746869732E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D';
wwv_flow_imp.g_varchar2_table(2003) := '41585F534146455F494E544547455229297D7D636C61737320476920657874656E6473206A697B7374617469632066726F6D52616E67654D617070696E67732865297B636F6E737420743D7A692E6A6F696E28652E6D61702828653D3E7A692E66726F6D';
wwv_flow_imp.g_varchar2_table(2004) := '52616E6765496E636C757369766528652E6F726967696E616C52616E6765292929292C6E3D7A692E6A6F696E28652E6D61702828653D3E7A692E66726F6D52616E6765496E636C757369766528652E6D6F64696669656452616E6765292929293B726574';
wwv_flow_imp.g_varchar2_table(2005) := '75726E206E657720476928742C6E2C65297D636F6E7374727563746F7228652C742C6E297B737570657228652C74292C746869732E696E6E65724368616E6765733D6E7D666C697028297B76617220653B72657475726E206E657720476928746869732E';
wwv_flow_imp.g_varchar2_table(2006) := '6D6F6469666965642C746869732E6F726967696E616C2C6E756C6C3D3D3D28653D746869732E696E6E65724368616E676573297C7C766F696420303D3D3D653F766F696420303A652E6D61702828653D3E652E666C697028292929297D77697468496E6E';
wwv_flow_imp.g_varchar2_table(2007) := '65724368616E67657346726F6D4C696E6552616E67657328297B72657475726E206E657720476928746869732E6F726967696E616C2C746869732E6D6F6469666965642C5B746869732E746F52616E67654D617070696E6728295D297D7D636C61737320';
wwv_flow_imp.g_varchar2_table(2008) := '51697B636F6E7374727563746F7228652C74297B746869732E6F726967696E616C52616E67653D652C746869732E6D6F64696669656452616E67653D747D746F537472696E6728297B72657475726E607B247B746869732E6F726967696E616C52616E67';
wwv_flow_imp.g_varchar2_table(2009) := '652E746F537472696E6728297D2D3E247B746869732E6D6F64696669656452616E67652E746F537472696E6728297D7D607D666C697028297B72657475726E206E657720516928746869732E6D6F64696669656452616E67652C746869732E6F72696769';
wwv_flow_imp.g_varchar2_table(2010) := '6E616C52616E6765297D746F54657874456469742865297B636F6E737420743D652E67657456616C75654F6652616E676528746869732E6D6F64696669656452616E6765293B72657475726E206E657720246928746869732E6F726967696E616C52616E';
wwv_flow_imp.g_varchar2_table(2011) := '67652C74297D7D636C6173732058697B636F6D707574654469666628652C742C6E297B76617220693B636F6E737420723D6E6577206E7228652C742C7B6D6178436F6D7075746174696F6E54696D653A6E2E6D6178436F6D7075746174696F6E54696D65';
wwv_flow_imp.g_varchar2_table(2012) := '4D732C73686F756C6449676E6F72655472696D576869746573706163653A6E2E69676E6F72655472696D576869746573706163652C73686F756C64436F6D70757465436861724368616E6765733A21302C73686F756C644D616B65507265747479446966';
wwv_flow_imp.g_varchar2_table(2013) := '663A21302C73686F756C64506F737450726F63657373436861724368616E6765733A21307D292E636F6D707574654469666628292C733D5B5D3B6C6574206F3D6E756C6C3B666F7228636F6E73742065206F6620722E6368616E676573297B6C65742074';
wwv_flow_imp.g_varchar2_table(2014) := '2C6E3B743D303D3D3D652E6F726967696E616C456E644C696E654E756D6265723F6E6577207A6928652E6F726967696E616C53746172744C696E654E756D6265722B312C652E6F726967696E616C53746172744C696E654E756D6265722B31293A6E6577';
wwv_flow_imp.g_varchar2_table(2015) := '207A6928652E6F726967696E616C53746172744C696E654E756D6265722C652E6F726967696E616C456E644C696E654E756D6265722B31292C6E3D303D3D3D652E6D6F646966696564456E644C696E654E756D6265723F6E6577207A6928652E6D6F6469';
wwv_flow_imp.g_varchar2_table(2016) := '6669656453746172744C696E654E756D6265722B312C652E6D6F64696669656453746172744C696E654E756D6265722B31293A6E6577207A6928652E6D6F64696669656453746172744C696E654E756D6265722C652E6D6F646966696564456E644C696E';
wwv_flow_imp.g_varchar2_table(2017) := '654E756D6265722B31293B6C657420723D6E657720476928742C6E2C6E756C6C3D3D3D28693D652E636861724368616E676573297C7C766F696420303D3D3D693F766F696420303A692E6D61702828653D3E6E6577205169286E657720777428652E6F72';
wwv_flow_imp.g_varchar2_table(2018) := '6967696E616C53746172744C696E654E756D6265722C652E6F726967696E616C5374617274436F6C756D6E2C652E6F726967696E616C456E644C696E654E756D6265722C652E6F726967696E616C456E64436F6C756D6E292C6E657720777428652E6D6F';
wwv_flow_imp.g_varchar2_table(2019) := '64696669656453746172744C696E654E756D6265722C652E6D6F6469666965645374617274436F6C756D6E2C652E6D6F646966696564456E644C696E654E756D6265722C652E6D6F646966696564456E64436F6C756D6E29292929293B6F2626286F2E6D';
wwv_flow_imp.g_varchar2_table(2020) := '6F6469666965642E656E644C696E654E756D6265724578636C7573697665213D3D722E6D6F6469666965642E73746172744C696E654E756D62657226266F2E6F726967696E616C2E656E644C696E654E756D6265724578636C7573697665213D3D722E6F';
wwv_flow_imp.g_varchar2_table(2021) := '726967696E616C2E73746172744C696E654E756D6265727C7C28723D6E6577204769286F2E6F726967696E616C2E6A6F696E28722E6F726967696E616C292C6F2E6D6F6469666965642E6A6F696E28722E6D6F646966696564292C6F2E696E6E65724368';
wwv_flow_imp.g_varchar2_table(2022) := '616E6765732626722E696E6E65724368616E6765733F6F2E696E6E65724368616E6765732E636F6E63617428722E696E6E65724368616E676573293A766F69642030292C732E706F70282929292C732E707573682872292C6F3D727D72657475726E206B';
wwv_flow_imp.g_varchar2_table(2023) := '69282828293D3E4F6928732C2828652C74293D3E742E6F726967696E616C2E73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965642E73746172744C69';
wwv_flow_imp.g_varchar2_table(2024) := '6E654E756D6265722D652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(2025) := '6D6265722626652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D626572292929292C6E657720446928732C5B5D2C722E717569744561726C79297D7D66756E';
wwv_flow_imp.g_varchar2_table(2026) := '6374696F6E204A6928652C742C6E2C69297B72657475726E206E657720716528652C742C6E292E436F6D70757465446966662869297D636C6173732059697B636F6E7374727563746F722865297B636F6E737420743D5B5D2C6E3D5B5D3B666F72286C65';
wwv_flow_imp.g_varchar2_table(2027) := '7420693D302C723D652E6C656E6774683B693C723B692B2B29745B695D3D697228655B695D2C31292C6E5B695D3D727228655B695D2C31293B746869732E6C696E65733D652C746869732E5F7374617274436F6C756D6E733D742C746869732E5F656E64';
wwv_flow_imp.g_varchar2_table(2028) := '436F6C756D6E733D6E7D676574456C656D656E747328297B636F6E737420653D5B5D3B666F72286C657420743D302C6E3D746869732E6C696E65732E6C656E6774683B743C6E3B742B2B29655B745D3D746869732E6C696E65735B745D2E737562737472';
wwv_flow_imp.g_varchar2_table(2029) := '696E6728746869732E5F7374617274436F6C756D6E735B745D2D312C746869732E5F656E64436F6C756D6E735B745D2D31293B72657475726E20657D676574537472696374456C656D656E742865297B72657475726E20746869732E6C696E65735B655D';
wwv_flow_imp.g_varchar2_table(2030) := '7D67657453746172744C696E654E756D6265722865297B72657475726E20652B317D676574456E644C696E654E756D6265722865297B72657475726E20652B317D6372656174654368617253657175656E636528652C742C6E297B636F6E737420693D5B';
wwv_flow_imp.g_varchar2_table(2031) := '5D2C723D5B5D2C733D5B5D3B6C6574206F3D303B666F72286C657420613D743B613C3D6E3B612B2B297B636F6E737420743D746869732E6C696E65735B615D2C6C3D653F746869732E5F7374617274436F6C756D6E735B615D3A312C753D653F74686973';
wwv_flow_imp.g_varchar2_table(2032) := '2E5F656E64436F6C756D6E735B615D3A742E6C656E6774682B313B666F72286C657420653D6C3B653C753B652B2B29695B6F5D3D742E63686172436F6465417428652D31292C725B6F5D3D612B312C735B6F5D3D652C6F2B2B3B21652626613C6E262628';
wwv_flow_imp.g_varchar2_table(2033) := '695B6F5D3D31302C725B6F5D3D612B312C735B6F5D3D742E6C656E6774682B312C6F2B2B297D72657475726E206E6577205A6928692C722C73297D7D636C617373205A697B636F6E7374727563746F7228652C742C6E297B746869732E5F63686172436F';
wwv_flow_imp.g_varchar2_table(2034) := '6465733D652C746869732E5F6C696E654E756D626572733D742C746869732E5F636F6C756D6E733D6E7D746F537472696E6728297B72657475726E225B222B746869732E5F63686172436F6465732E6D6170282828652C74293D3E2831303D3D3D653F22';
wwv_flow_imp.g_varchar2_table(2035) := '5C5C6E223A537472696E672E66726F6D43686172436F6465286529292B602D28247B746869732E5F6C696E654E756D626572735B745D7D2C247B746869732E5F636F6C756D6E735B745D7D296029292E6A6F696E28222C2022292B225D227D5F61737365';
wwv_flow_imp.g_varchar2_table(2036) := '7274496E64657828652C74297B696628653C307C7C653E3D742E6C656E677468297468726F77206E6577204572726F722822496C6C6567616C20696E64657822297D676574456C656D656E747328297B72657475726E20746869732E5F63686172436F64';
wwv_flow_imp.g_varchar2_table(2037) := '65737D67657453746172744C696E654E756D6265722865297B72657475726E20653E302626653D3D3D746869732E5F6C696E654E756D626572732E6C656E6774683F746869732E676574456E644C696E654E756D62657228652D31293A28746869732E5F';
wwv_flow_imp.g_varchar2_table(2038) := '617373657274496E64657828652C746869732E5F6C696E654E756D62657273292C746869732E5F6C696E654E756D626572735B655D297D676574456E644C696E654E756D6265722865297B72657475726E2D313D3D3D653F746869732E67657453746172';
wwv_flow_imp.g_varchar2_table(2039) := '744C696E654E756D62657228652B31293A28746869732E5F617373657274496E64657828652C746869732E5F6C696E654E756D62657273292C31303D3D3D746869732E5F63686172436F6465735B655D3F746869732E5F6C696E654E756D626572735B65';
wwv_flow_imp.g_varchar2_table(2040) := '5D2B313A746869732E5F6C696E654E756D626572735B655D297D6765745374617274436F6C756D6E2865297B72657475726E20653E302626653D3D3D746869732E5F636F6C756D6E732E6C656E6774683F746869732E676574456E64436F6C756D6E2865';
wwv_flow_imp.g_varchar2_table(2041) := '2D31293A28746869732E5F617373657274496E64657828652C746869732E5F636F6C756D6E73292C746869732E5F636F6C756D6E735B655D297D676574456E64436F6C756D6E2865297B72657475726E2D313D3D3D653F746869732E6765745374617274';
wwv_flow_imp.g_varchar2_table(2042) := '436F6C756D6E28652B31293A28746869732E5F617373657274496E64657828652C746869732E5F636F6C756D6E73292C31303D3D3D746869732E5F63686172436F6465735B655D3F313A746869732E5F636F6C756D6E735B655D2B31297D7D636C617373';
wwv_flow_imp.g_varchar2_table(2043) := '2065727B636F6E7374727563746F7228652C742C6E2C692C722C732C6F2C61297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C5374617274436F6C756D6E3D742C746869732E6F726967';
wwv_flow_imp.g_varchar2_table(2044) := '696E616C456E644C696E654E756D6265723D6E2C746869732E6F726967696E616C456E64436F6C756D6E3D692C746869732E6D6F64696669656453746172744C696E654E756D6265723D722C746869732E6D6F6469666965645374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(2045) := '3D732C746869732E6D6F646966696564456E644C696E654E756D6265723D6F2C746869732E6D6F646966696564456E64436F6C756D6E3D617D7374617469632063726561746546726F6D446966664368616E676528652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(2046) := '742E67657453746172744C696E654E756D62657228652E6F726967696E616C5374617274292C723D742E6765745374617274436F6C756D6E28652E6F726967696E616C5374617274292C733D742E676574456E644C696E654E756D62657228652E6F7269';
wwv_flow_imp.g_varchar2_table(2047) := '67696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C6F3D742E676574456E64436F6C756D6E28652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C613D6E2E67657453746172744C696E65';
wwv_flow_imp.g_varchar2_table(2048) := '4E756D62657228652E6D6F6469666965645374617274292C6C3D6E2E6765745374617274436F6C756D6E28652E6D6F6469666965645374617274292C753D6E2E676574456E644C696E654E756D62657228652E6D6F64696669656453746172742B652E6D';
wwv_flow_imp.g_varchar2_table(2049) := '6F6469666965644C656E6774682D31292C683D6E2E676574456E64436F6C756D6E28652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682D31293B72657475726E206E657720657228692C722C732C6F2C612C6C2C752C6829';
wwv_flow_imp.g_varchar2_table(2050) := '7D7D636C6173732074727B636F6E7374727563746F7228652C742C6E2C692C72297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C456E644C696E654E756D6265723D742C746869732E6D';
wwv_flow_imp.g_varchar2_table(2051) := '6F64696669656453746172744C696E654E756D6265723D6E2C746869732E6D6F646966696564456E644C696E654E756D6265723D692C746869732E636861724368616E6765733D727D7374617469632063726561746546726F6D44696666526573756C74';
wwv_flow_imp.g_varchar2_table(2052) := '28652C742C6E2C692C722C732C6F297B6C657420612C6C2C752C682C633B696628303D3D3D742E6F726967696E616C4C656E6774683F28613D6E2E67657453746172744C696E654E756D62657228742E6F726967696E616C5374617274292D312C6C3D30';
wwv_flow_imp.g_varchar2_table(2053) := '293A28613D6E2E67657453746172744C696E654E756D62657228742E6F726967696E616C5374617274292C6C3D6E2E676574456E644C696E654E756D62657228742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D312929';
wwv_flow_imp.g_varchar2_table(2054) := '2C303D3D3D742E6D6F6469666965644C656E6774683F28753D692E67657453746172744C696E654E756D62657228742E6D6F6469666965645374617274292D312C683D30293A28753D692E67657453746172744C696E654E756D62657228742E6D6F6469';
wwv_flow_imp.g_varchar2_table(2055) := '666965645374617274292C683D692E676574456E644C696E654E756D62657228742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D3129292C732626742E6F726967696E616C4C656E6774683E302626742E6F726967696E';
wwv_flow_imp.g_varchar2_table(2056) := '616C4C656E6774683C32302626742E6D6F6469666965644C656E6774683E302626742E6D6F6469666965644C656E6774683C32302626722829297B636F6E737420733D6E2E6372656174654368617253657175656E636528652C742E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2057) := '53746172742C742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D31292C613D692E6372656174654368617253657175656E636528652C742E6D6F64696669656453746172742C742E6D6F64696669656453746172742B74';
wwv_flow_imp.g_varchar2_table(2058) := '2E6D6F6469666965644C656E6774682D31293B696628732E676574456C656D656E747328292E6C656E6774683E302626612E676574456C656D656E747328292E6C656E6774683E30297B6C657420653D4A6928732C612C722C2130292E6368616E676573';
wwv_flow_imp.g_varchar2_table(2059) := '3B6F262628653D66756E6374696F6E2865297B696628652E6C656E6774683C3D312972657475726E20653B636F6E737420743D5B655B305D5D3B6C6574206E3D745B305D3B666F72286C657420693D312C723D652E6C656E6774683B693C723B692B2B29';
wwv_flow_imp.g_varchar2_table(2060) := '7B636F6E737420723D655B695D2C733D722E6F726967696E616C53746172742D286E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E677468292C6F3D722E6D6F64696669656453746172742D286E2E6D6F64696669656453746172';
wwv_flow_imp.g_varchar2_table(2061) := '742B6E2E6D6F6469666965644C656E677468293B4D6174682E6D696E28732C6F293C333F286E2E6F726967696E616C4C656E6774683D722E6F726967696E616C53746172742B722E6F726967696E616C4C656E6774682D6E2E6F726967696E616C537461';
wwv_flow_imp.g_varchar2_table(2062) := '72742C6E2E6D6F6469666965644C656E6774683D722E6D6F64696669656453746172742B722E6D6F6469666965644C656E6774682D6E2E6D6F6469666965645374617274293A28742E707573682872292C6E3D72297D72657475726E20747D286529292C';
wwv_flow_imp.g_varchar2_table(2063) := '633D5B5D3B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B29632E707573682865722E63726561746546726F6D446966664368616E676528655B745D2C732C6129297D7D72657475726E206E657720747228612C6C2C752C68';
wwv_flow_imp.g_varchar2_table(2064) := '2C63297D7D636C617373206E727B636F6E7374727563746F7228652C742C6E297B746869732E73686F756C64436F6D70757465436861724368616E6765733D6E2E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C';
wwv_flow_imp.g_varchar2_table(2065) := '64506F737450726F63657373436861724368616E6765733D6E2E73686F756C64506F737450726F63657373436861724368616E6765732C746869732E73686F756C6449676E6F72655472696D576869746573706163653D6E2E73686F756C6449676E6F72';
wwv_flow_imp.g_varchar2_table(2066) := '655472696D576869746573706163652C746869732E73686F756C644D616B65507265747479446966663D6E2E73686F756C644D616B65507265747479446966662C746869732E6F726967696E616C4C696E65733D652C746869732E6D6F6469666965644C';
wwv_flow_imp.g_varchar2_table(2067) := '696E65733D742C746869732E6F726967696E616C3D6E65772059692865292C746869732E6D6F6469666965643D6E65772059692874292C746869732E636F6E74696E75654C696E65446966663D7372286E2E6D6178436F6D7075746174696F6E54696D65';
wwv_flow_imp.g_varchar2_table(2068) := '292C746869732E636F6E74696E756543686172446966663D737228303D3D3D6E2E6D6178436F6D7075746174696F6E54696D653F303A4D6174682E6D696E286E2E6D6178436F6D7075746174696F6E54696D652C35653329297D636F6D70757465446966';
wwv_flow_imp.g_varchar2_table(2069) := '6628297B696628313D3D3D746869732E6F726967696E616C2E6C696E65732E6C656E6774682626303D3D3D746869732E6F726967696E616C2E6C696E65735B305D2E6C656E6774682972657475726E20313D3D3D746869732E6D6F6469666965642E6C69';
wwv_flow_imp.g_varchar2_table(2070) := '6E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C696E65735B305D2E6C656E6774683F7B717569744561726C793A21312C6368616E6765733A5B5D7D3A7B717569744561726C793A21312C6368616E6765733A5B7B6F726967';
wwv_flow_imp.g_varchar2_table(2071) := '696E616C53746172744C696E654E756D6265723A312C6F726967696E616C456E644C696E654E756D6265723A312C6D6F64696669656453746172744C696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A746869732E6D';
wwv_flow_imp.g_varchar2_table(2072) := '6F6469666965642E6C696E65732E6C656E6774682C636861724368616E6765733A766F696420307D5D7D3B696628313D3D3D746869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C696E65';
wwv_flow_imp.g_varchar2_table(2073) := '735B305D2E6C656E6774682972657475726E7B717569744561726C793A21312C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C456E644C696E654E756D6265723A746869732E6F72696769';
wwv_flow_imp.g_varchar2_table(2074) := '6E616C2E6C696E65732E6C656E6774682C6D6F64696669656453746172744C696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A312C636861724368616E6765733A766F696420307D5D7D3B636F6E737420653D4A6928';
wwv_flow_imp.g_varchar2_table(2075) := '746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E75654C696E65446966662C746869732E73686F756C644D616B6550726574747944696666292C743D652E6368616E6765732C6E3D652E71756974456172';
wwv_flow_imp.g_varchar2_table(2076) := '6C793B696628746869732E73686F756C6449676E6F72655472696D57686974657370616365297B636F6E737420653D5B5D3B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29652E707573682874722E63726561746546726F';
wwv_flow_imp.g_varchar2_table(2077) := '6D44696666526573756C7428746869732E73686F756C6449676E6F72655472696D576869746573706163652C745B6E5D2C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E756543686172446966662C74';
wwv_flow_imp.g_varchar2_table(2078) := '6869732E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E67657329293B72657475726E7B717569744561726C793A6E2C6368616E6765733A657D7D636F6E7374';
wwv_flow_imp.g_varchar2_table(2079) := '20693D5B5D3B6C657420723D302C733D303B666F72286C657420653D2D312C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206F3D652B313C6E3F745B652B315D3A6E756C6C2C613D6F3F6F2E6F726967696E616C53746172743A746869';
wwv_flow_imp.g_varchar2_table(2080) := '732E6F726967696E616C4C696E65732E6C656E6774682C6C3D6F3F6F2E6D6F64696669656453746172743A746869732E6D6F6469666965644C696E65732E6C656E6774683B666F72283B723C612626733C6C3B297B636F6E737420653D746869732E6F72';
wwv_flow_imp.g_varchar2_table(2081) := '6967696E616C4C696E65735B725D2C743D746869732E6D6F6469666965644C696E65735B735D3B69662865213D3D74297B7B6C6574206E3D697228652C31292C6F3D697228742C31293B666F72283B6E3E3126266F3E312626652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(2082) := '74286E2D32293D3D3D742E63686172436F64654174286F2D32293B296E2D2D2C6F2D2D3B286E3E317C7C6F3E31292626746869732E5F707573685472696D57686974657370616365436861724368616E676528692C722B312C312C6E2C732B312C312C6F';
wwv_flow_imp.g_varchar2_table(2083) := '297D7B6C6574206E3D727228652C31292C6F3D727228742C31293B636F6E737420613D652E6C656E6774682B312C6C3D742E6C656E6774682B313B666F72283B6E3C6126266F3C6C2626652E63686172436F64654174286E2D31293D3D3D652E63686172';
wwv_flow_imp.g_varchar2_table(2084) := '436F64654174286F2D31293B296E2B2B2C6F2B2B3B286E3C617C7C6F3C6C292626746869732E5F707573685472696D57686974657370616365436861724368616E676528692C722B312C6E2C612C732B312C6F2C6C297D7D722B2B2C732B2B7D6F262628';
wwv_flow_imp.g_varchar2_table(2085) := '692E707573682874722E63726561746546726F6D44696666526573756C7428746869732E73686F756C6449676E6F72655472696D576869746573706163652C6F2C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F';
wwv_flow_imp.g_varchar2_table(2086) := '6E74696E756543686172446966662C746869732E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E67657329292C722B3D6F2E6F726967696E616C4C656E677468';
wwv_flow_imp.g_varchar2_table(2087) := '2C732B3D6F2E6D6F6469666965644C656E677468297D72657475726E7B717569744561726C793A6E2C6368616E6765733A697D7D5F707573685472696D57686974657370616365436861724368616E676528652C742C6E2C692C722C732C6F297B696628';
wwv_flow_imp.g_varchar2_table(2088) := '746869732E5F6D657267655472696D57686974657370616365436861724368616E676528652C742C6E2C692C722C732C6F292972657475726E3B6C657420613B746869732E73686F756C64436F6D70757465436861724368616E676573262628613D5B6E';
wwv_flow_imp.g_varchar2_table(2089) := '657720657228742C6E2C742C692C722C732C722C6F295D292C652E70757368286E657720747228742C742C722C722C6129297D5F6D657267655472696D57686974657370616365436861724368616E676528652C742C6E2C692C722C732C6F297B636F6E';
wwv_flow_imp.g_varchar2_table(2090) := '737420613D652E6C656E6774683B696628303D3D3D612972657475726E21313B636F6E7374206C3D655B612D315D3B72657475726E2030213D3D6C2E6F726967696E616C456E644C696E654E756D626572262630213D3D6C2E6D6F646966696564456E64';
wwv_flow_imp.g_varchar2_table(2091) := '4C696E654E756D6265722626286C2E6F726967696E616C456E644C696E654E756D6265723D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265723D3D3D723F28746869732E73686F756C64436F6D70757465436861724368616E676573';
wwv_flow_imp.g_varchar2_table(2092) := '26266C2E636861724368616E67657326266C2E636861724368616E6765732E70757368286E657720657228742C6E2C742C692C722C732C722C6F29292C2130293A6C2E6F726967696E616C456E644C696E654E756D6265722B313D3D3D7426266C2E6D6F';
wwv_flow_imp.g_varchar2_table(2093) := '646966696564456E644C696E654E756D6265722B313D3D3D722626286C2E6F726967696E616C456E644C696E654E756D6265723D742C6C2E6D6F646966696564456E644C696E654E756D6265723D722C746869732E73686F756C64436F6D707574654368';
wwv_flow_imp.g_varchar2_table(2094) := '61724368616E67657326266C2E636861724368616E67657326266C2E636861724368616E6765732E70757368286E657720657228742C6E2C742C692C722C732C722C6F29292C213029297D7D66756E6374696F6E20697228652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(2095) := '3D66756E6374696F6E2865297B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D652E63686172436F646541742874293B6966283332213D3D6E262639213D3D6E2972657475726E20747D7265747572';
wwv_flow_imp.g_varchar2_table(2096) := '6E2D317D2865293B72657475726E2D313D3D3D6E3F743A6E2B317D66756E6374696F6E20727228652C74297B636F6E7374206E3D66756E6374696F6E28652C743D652E6C656E6774682D31297B666F72286C6574206E3D743B6E3E3D303B6E2D2D297B63';
wwv_flow_imp.g_varchar2_table(2097) := '6F6E737420743D652E63686172436F64654174286E293B6966283332213D3D74262639213D3D742972657475726E206E7D72657475726E2D317D2865293B72657475726E2D313D3D3D6E3F743A6E2B327D66756E6374696F6E2073722865297B69662830';
wwv_flow_imp.g_varchar2_table(2098) := '3D3D3D652972657475726E28293D3E21303B636F6E737420743D446174652E6E6F7728293B72657475726E28293D3E446174652E6E6F7728292D743C657D636C617373206F727B737461746963207472697669616C28652C74297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(2099) := '77206F72285B6E6577206172284B692E6F664C656E67746828652E6C656E677468292C4B692E6F664C656E67746828742E6C656E67746829295D2C2131297D737461746963207472697669616C54696D65644F757428652C74297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(2100) := '77206F72285B6E6577206172284B692E6F664C656E67746828652E6C656E677468292C4B692E6F664C656E67746828742E6C656E67746829295D2C2130297D636F6E7374727563746F7228652C74297B746869732E64696666733D652C746869732E6869';
wwv_flow_imp.g_varchar2_table(2101) := '7454696D656F75743D747D7D636C6173732061727B73746174696320696E7665727428652C74297B636F6E7374206E3D5B5D3B72657475726E2066756E6374696F6E2865297B666F72286C657420733D303B733C3D652E6C656E6774683B732B2B29693D';
wwv_flow_imp.g_varchar2_table(2102) := '303D3D3D733F766F696420303A655B732D315D2C723D733D3D3D652E6C656E6774683F766F696420303A655B735D2C6E2E707573682861722E66726F6D4F6666736574506169727328693F692E676574456E644578636C75736976657328293A6C722E7A';
wwv_flow_imp.g_varchar2_table(2103) := '65726F2C723F722E67657453746172747328293A6E6577206C7228742C28693F692E7365713252616E67652E656E644578636C75736976652D692E7365713152616E67652E656E644578636C75736976653A30292B742929293B76617220692C727D2865';
wwv_flow_imp.g_varchar2_table(2104) := '292C6E7D7374617469632066726F6D4F6666736574506169727328652C74297B72657475726E206E6577206172286E6577204B6928652E6F6666736574312C742E6F666673657431292C6E6577204B6928652E6F6666736574322C742E6F666673657432';
wwv_flow_imp.g_varchar2_table(2105) := '29297D636F6E7374727563746F7228652C74297B746869732E7365713152616E67653D652C746869732E7365713252616E67653D747D7377617028297B72657475726E206E657720617228746869732E7365713252616E67652C746869732E7365713152';
wwv_flow_imp.g_varchar2_table(2106) := '616E6765297D746F537472696E6728297B72657475726E60247B746869732E7365713152616E67657D203C2D3E20247B746869732E7365713252616E67657D607D6A6F696E2865297B72657475726E206E657720617228746869732E7365713152616E67';
wwv_flow_imp.g_varchar2_table(2107) := '652E6A6F696E28652E7365713152616E6765292C746869732E7365713252616E67652E6A6F696E28652E7365713252616E676529297D64656C74612865297B72657475726E20303D3D3D653F746869733A6E657720617228746869732E7365713152616E';
wwv_flow_imp.g_varchar2_table(2108) := '67652E64656C74612865292C746869732E7365713252616E67652E64656C7461286529297D64656C746153746172742865297B72657475726E20303D3D3D653F746869733A6E657720617228746869732E7365713152616E67652E64656C746153746172';
wwv_flow_imp.g_varchar2_table(2109) := '742865292C746869732E7365713252616E67652E64656C74615374617274286529297D64656C7461456E642865297B72657475726E20303D3D3D653F746869733A6E657720617228746869732E7365713152616E67652E64656C7461456E642865292C74';
wwv_flow_imp.g_varchar2_table(2110) := '6869732E7365713252616E67652E64656C7461456E64286529297D696E746572736563742865297B636F6E737420743D746869732E7365713152616E67652E696E7465727365637428652E7365713152616E6765292C6E3D746869732E7365713252616E';
wwv_flow_imp.g_varchar2_table(2111) := '67652E696E7465727365637428652E7365713252616E6765293B6966287426266E2972657475726E206E657720617228742C6E297D67657453746172747328297B72657475726E206E6577206C7228746869732E7365713152616E67652E73746172742C';
wwv_flow_imp.g_varchar2_table(2112) := '746869732E7365713252616E67652E7374617274297D676574456E644578636C75736976657328297B72657475726E206E6577206C7228746869732E7365713152616E67652E656E644578636C75736976652C746869732E7365713252616E67652E656E';
wwv_flow_imp.g_varchar2_table(2113) := '644578636C7573697665297D7D636C617373206C727B636F6E7374727563746F7228652C74297B746869732E6F6666736574313D652C746869732E6F6666736574323D747D746F537472696E6728297B72657475726E60247B746869732E6F6666736574';
wwv_flow_imp.g_varchar2_table(2114) := '317D203C2D3E20247B746869732E6F6666736574327D607D64656C74612865297B72657475726E20303D3D3D653F746869733A6E6577206C7228746869732E6F6666736574312B652C746869732E6F6666736574322B65297D657175616C732865297B72';
wwv_flow_imp.g_varchar2_table(2115) := '657475726E20746869732E6F6666736574313D3D3D652E6F6666736574312626746869732E6F6666736574323D3D3D652E6F6666736574327D7D6C722E7A65726F3D6E6577206C7228302C30292C6C722E6D61783D6E6577206C72284E756D6265722E4D';
wwv_flow_imp.g_varchar2_table(2116) := '41585F534146455F494E54454745522C4E756D6265722E4D41585F534146455F494E5445474552293B636C6173732075727B697356616C696428297B72657475726E21307D7D75722E696E7374616E63653D6E65772075723B636C6173732068727B636F';
wwv_flow_imp.g_varchar2_table(2117) := '6E7374727563746F722865297B696628746869732E74696D656F75743D652C746869732E737461727454696D653D446174652E6E6F7728292C746869732E76616C69643D21302C653C3D30297468726F77206E6577206F282274696D656F7574206D7573';
wwv_flow_imp.g_varchar2_table(2118) := '7420626520706F73697469766522297D697356616C696428297B72657475726E2128446174652E6E6F7728292D746869732E737461727454696D653C746869732E74696D656F7574292626746869732E76616C6964262628746869732E76616C69643D21';
wwv_flow_imp.g_varchar2_table(2119) := '31292C746869732E76616C69647D7D636C6173732063727B636F6E7374727563746F7228652C74297B746869732E77696474683D652C746869732E6865696768743D742C746869732E61727261793D5B5D2C746869732E61727261793D6E657720417272';
wwv_flow_imp.g_varchar2_table(2120) := '617928652A74297D67657428652C74297B72657475726E20746869732E61727261795B652B742A746869732E77696474685D7D73657428652C742C6E297B746869732E61727261795B652B742A746869732E77696474685D3D6E7D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2121) := '2064722865297B72657475726E2033323D3D3D657C7C393D3D3D657D636C617373206D727B737461746963206765744B65792865297B6C657420743D746869732E6368724B6579732E6765742865293B72657475726E20766F696420303D3D3D74262628';
wwv_flow_imp.g_varchar2_table(2122) := '743D746869732E6368724B6579732E73697A652C746869732E6368724B6579732E73657428652C7429292C747D636F6E7374727563746F7228652C742C6E297B746869732E72616E67653D652C746869732E6C696E65733D742C746869732E736F757263';
wwv_flow_imp.g_varchar2_table(2123) := '653D6E2C746869732E686973746F6772616D3D5B5D3B6C657420693D303B666F72286C6574206E3D652E73746172744C696E654E756D6265722D313B6E3C652E656E644C696E654E756D6265724578636C75736976652D313B6E2B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(2124) := '653D745B6E5D3B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B692B2B3B636F6E7374206E3D655B745D2C723D6D722E6765744B6579286E293B746869732E686973746F6772616D5B725D3D28746869732E686973746F6772616D';
wwv_flow_imp.g_varchar2_table(2125) := '5B725D7C7C30292B317D692B2B3B636F6E737420723D6D722E6765744B657928225C6E22293B746869732E686973746F6772616D5B725D3D28746869732E686973746F6772616D5B725D7C7C30292B317D746869732E746F74616C436F756E743D697D63';
wwv_flow_imp.g_varchar2_table(2126) := '6F6D7075746553696D696C61726974792865297B76617220742C6E3B6C657420693D303B636F6E737420723D4D6174682E6D617828746869732E686973746F6772616D2E6C656E6774682C652E686973746F6772616D2E6C656E677468293B666F72286C';
wwv_flow_imp.g_varchar2_table(2127) := '657420733D303B733C723B732B2B29692B3D4D6174682E61627328286E756C6C213D3D28743D746869732E686973746F6772616D5B735D292626766F69642030213D3D743F743A30292D286E756C6C213D3D286E3D652E686973746F6772616D5B735D29';
wwv_flow_imp.g_varchar2_table(2128) := '2626766F69642030213D3D6E3F6E3A3029293B72657475726E20312D692F28746869732E746F74616C436F756E742B652E746F74616C436F756E74297D7D6D722E6368724B6579733D6E6577204D61703B636C6173732067727B636F6D7075746528652C';
wwv_flow_imp.g_varchar2_table(2129) := '742C6E3D75722E696E7374616E63652C69297B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E206F722E7472697669616C28652C74293B636F6E737420723D6E657720637228652E6C656E6774682C742E6C65';
wwv_flow_imp.g_varchar2_table(2130) := '6E677468292C733D6E657720637228652E6C656E6774682C742E6C656E677468292C6F3D6E657720637228652E6C656E6774682C742E6C656E677468293B666F72286C657420613D303B613C652E6C656E6774683B612B2B29666F72286C6574206C3D30';
wwv_flow_imp.g_varchar2_table(2131) := '3B6C3C742E6C656E6774683B6C2B2B297B696628216E2E697356616C696428292972657475726E206F722E7472697669616C54696D65644F757428652C74293B636F6E737420753D303D3D3D613F303A722E67657428612D312C6C292C683D303D3D3D6C';
wwv_flow_imp.g_varchar2_table(2132) := '3F303A722E67657428612C6C2D31293B6C657420633B652E676574456C656D656E742861293D3D3D742E676574456C656D656E74286C293F28633D303D3D3D617C7C303D3D3D6C3F303A722E67657428612D312C6C2D31292C613E3026266C3E30262633';
wwv_flow_imp.g_varchar2_table(2133) := '3D3D3D732E67657428612D312C6C2D3129262628632B3D6F2E67657428612D312C6C2D3129292C632B3D693F6928612C6C293A31293A633D2D313B636F6E737420643D4D6174682E6D617828752C682C63293B696628643D3D3D63297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(2134) := '3D613E3026266C3E303F6F2E67657428612D312C6C2D31293A303B6F2E73657428612C6C2C652B31292C732E73657428612C6C2C33297D656C736520643D3D3D753F286F2E73657428612C6C2C30292C732E73657428612C6C2C3129293A643D3D3D6826';
wwv_flow_imp.g_varchar2_table(2135) := '26286F2E73657428612C6C2C30292C732E73657428612C6C2C3229293B722E73657428612C6C2C64297D636F6E737420613D5B5D3B6C6574206C3D652E6C656E6774682C753D742E6C656E6774683B66756E6374696F6E206828652C74297B652B313D3D';
wwv_flow_imp.g_varchar2_table(2136) := '3D6C2626742B313D3D3D757C7C612E70757368286E6577206172286E6577204B6928652B312C6C292C6E6577204B6928742B312C752929292C6C3D652C753D747D6C657420633D652E6C656E6774682D312C643D742E6C656E6774682D313B666F72283B';
wwv_flow_imp.g_varchar2_table(2137) := '633E3D302626643E3D303B29333D3D3D732E67657428632C64293F286828632C64292C632D2D2C642D2D293A313D3D3D732E67657428632C64293F632D2D3A642D2D3B72657475726E2068282D312C2D31292C612E7265766572736528292C6E6577206F';
wwv_flow_imp.g_varchar2_table(2138) := '7228612C2131297D7D636C6173732066727B636F6D7075746528652C742C6E3D75722E696E7374616E6365297B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E206F722E7472697669616C28652C74293B636F';
wwv_flow_imp.g_varchar2_table(2139) := '6E737420693D652C723D743B66756E6374696F6E207328652C74297B666F72283B653C692E6C656E6774682626743C722E6C656E6774682626692E676574456C656D656E742865293D3D3D722E676574456C656D656E742874293B29652B2B2C742B2B3B';
wwv_flow_imp.g_varchar2_table(2140) := '72657475726E20657D6C6574206F3D303B636F6E737420613D6E65772062723B612E73657428302C7328302C3029293B636F6E7374206C3D6E6577205F723B6C2E73657428302C303D3D3D612E6765742830293F6E756C6C3A6E6577207072286E756C6C';
wwv_flow_imp.g_varchar2_table(2141) := '2C302C302C612E67657428302929293B6C657420753D303B653A666F72283B3B297B6966286F2B2B2C216E2E697356616C696428292972657475726E206F722E7472697669616C54696D65644F757428692C72293B636F6E737420653D2D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(2142) := '696E286F2C722E6C656E6774682B6F2532292C743D4D6174682E6D696E286F2C692E6C656E6774682B6F2532293B666F7228753D653B753C3D743B752B3D32297B6C6574206E3D303B636F6E7374206F3D753D3D3D743F2D313A612E67657428752B3129';
wwv_flow_imp.g_varchar2_table(2143) := '2C683D753D3D3D653F2D313A612E67657428752D31292B313B6E2B2B3B636F6E737420633D4D6174682E6D696E284D6174682E6D6178286F2C68292C692E6C656E677468292C643D632D753B6966286E2B2B2C633E692E6C656E6774687C7C643E722E6C';
wwv_flow_imp.g_varchar2_table(2144) := '656E67746829636F6E74696E75653B636F6E7374206D3D7328632C64293B612E73657428752C6D293B636F6E737420673D633D3D3D6F3F6C2E67657428752B31293A6C2E67657428752D31293B6966286C2E73657428752C6D213D3D633F6E6577207072';
wwv_flow_imp.g_varchar2_table(2145) := '28672C632C642C6D2D63293A67292C612E6765742875293D3D3D692E6C656E6774682626612E6765742875292D753D3D3D722E6C656E67746829627265616B20657D7D6C657420683D6C2E6765742875293B636F6E737420633D5B5D3B6C657420643D69';
wwv_flow_imp.g_varchar2_table(2146) := '2E6C656E6774682C6D3D722E6C656E6774683B666F72283B3B297B636F6E737420653D683F682E782B682E6C656E6774683A302C743D683F682E792B682E6C656E6774683A303B696628653D3D3D642626743D3D3D6D7C7C632E70757368286E65772061';
wwv_flow_imp.g_varchar2_table(2147) := '72286E6577204B6928652C64292C6E6577204B6928742C6D2929292C216829627265616B3B643D682E782C6D3D682E792C683D682E707265767D72657475726E20632E7265766572736528292C6E6577206F7228632C2131297D7D636C6173732070727B';
wwv_flow_imp.g_varchar2_table(2148) := '636F6E7374727563746F7228652C742C6E2C69297B746869732E707265763D652C746869732E783D742C746869732E793D6E2C746869732E6C656E6774683D697D7D636C6173732062727B636F6E7374727563746F7228297B746869732E706F73697469';
wwv_flow_imp.g_varchar2_table(2149) := '76654172723D6E657720496E7433324172726179283130292C746869732E6E656761746976654172723D6E657720496E7433324172726179283130297D6765742865297B72657475726E20653C303F28653D2D652D312C746869732E6E65676174697665';
wwv_flow_imp.g_varchar2_table(2150) := '4172725B655D293A746869732E706F7369746976654172725B655D7D73657428652C74297B696628653C30297B69662828653D2D652D31293E3D746869732E6E656761746976654172722E6C656E677468297B636F6E737420653D746869732E6E656761';
wwv_flow_imp.g_varchar2_table(2151) := '746976654172723B746869732E6E656761746976654172723D6E657720496E743332417272617928322A652E6C656E677468292C746869732E6E656761746976654172722E7365742865297D746869732E6E656761746976654172725B655D3D747D656C';
wwv_flow_imp.g_varchar2_table(2152) := '73657B696628653E3D746869732E706F7369746976654172722E6C656E677468297B636F6E737420653D746869732E706F7369746976654172723B746869732E706F7369746976654172723D6E657720496E743332417272617928322A652E6C656E6774';
wwv_flow_imp.g_varchar2_table(2153) := '68292C746869732E706F7369746976654172722E7365742865297D746869732E706F7369746976654172725B655D3D747D7D7D636C617373205F727B636F6E7374727563746F7228297B746869732E706F7369746976654172723D5B5D2C746869732E6E';
wwv_flow_imp.g_varchar2_table(2154) := '656761746976654172723D5B5D7D6765742865297B72657475726E20653C303F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976654172725B655D7D73657428652C74297B653C303F28653D2D652D';
wwv_flow_imp.g_varchar2_table(2155) := '312C746869732E6E656761746976654172725B655D3D74293A746869732E706F7369746976654172725B655D3D747D7D636C6173732076727B636F6E7374727563746F7228652C742C6E297B746869732E6C696E65733D652C746869732E636F6E736964';
wwv_flow_imp.g_varchar2_table(2156) := '6572576869746573706163654368616E6765733D6E2C746869732E656C656D656E74733D5B5D2C746869732E6669727374436861724F666673657442794C696E653D5B5D2C746869732E6164646974696F6E616C4F666673657442794C696E653D5B5D3B';
wwv_flow_imp.g_varchar2_table(2157) := '6C657420693D21313B742E73746172743E302626742E656E644578636C75736976653E3D652E6C656E677468262628743D6E6577204B6928742E73746172742D312C742E656E644578636C7573697665292C693D2130292C746869732E6C696E6552616E';
wwv_flow_imp.g_varchar2_table(2158) := '67653D742C746869732E6669727374436861724F666673657442794C696E655B305D3D303B666F72286C657420743D746869732E6C696E6552616E67652E73746172743B743C746869732E6C696E6552616E67652E656E644578636C75736976653B742B';
wwv_flow_imp.g_varchar2_table(2159) := '2B297B6C657420723D655B745D2C733D303B6966286929733D722E6C656E6774682C723D22222C693D21313B656C736520696628216E297B636F6E737420653D722E7472696D537461727428293B733D722E6C656E6774682D652E6C656E6774682C723D';
wwv_flow_imp.g_varchar2_table(2160) := '652E7472696D456E6428297D746869732E6164646974696F6E616C4F666673657442794C696E652E707573682873293B666F72286C657420653D303B653C722E6C656E6774683B652B2B29746869732E656C656D656E74732E7075736828722E63686172';
wwv_flow_imp.g_varchar2_table(2161) := '436F64654174286529293B743C652E6C656E6774682D31262628746869732E656C656D656E74732E7075736828225C6E222E63686172436F64654174283029292C746869732E6669727374436861724F666673657442794C696E655B742D746869732E6C';
wwv_flow_imp.g_varchar2_table(2162) := '696E6552616E67652E73746172742B315D3D746869732E656C656D656E74732E6C656E677468297D746869732E6164646974696F6E616C4F666673657442794C696E652E707573682830297D746F537472696E6728297B72657475726E60536C6963653A';
wwv_flow_imp.g_varchar2_table(2163) := '2022247B746869732E746578747D22607D676574207465787428297B72657475726E20746869732E67657454657874286E6577204B6928302C746869732E6C656E67746829297D676574546578742865297B72657475726E20746869732E656C656D656E';
wwv_flow_imp.g_varchar2_table(2164) := '74732E736C69636528652E73746172742C652E656E644578636C7573697665292E6D61702828653D3E537472696E672E66726F6D43686172436F646528652929292E6A6F696E282222297D676574456C656D656E742865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(2165) := '2E656C656D656E74735B655D7D676574206C656E67746828297B72657475726E20746869732E656C656D656E74732E6C656E6774687D676574426F756E6461727953636F72652865297B636F6E737420743D777228653E303F746869732E656C656D656E';
wwv_flow_imp.g_varchar2_table(2166) := '74735B652D315D3A2D31292C6E3D777228653C746869732E656C656D656E74732E6C656E6774683F746869732E656C656D656E74735B655D3A2D31293B696628373D3D3D742626383D3D3D6E2972657475726E20303B696628383D3D3D74297265747572';
wwv_flow_imp.g_varchar2_table(2167) := '6E203135303B6C657420693D303B72657475726E2074213D3D6E262628692B3D31302C303D3D3D742626313D3D3D6E262628692B3D3129292C692B3D4C722874292C692B3D4C72286E292C697D7472616E736C6174654F66667365742865297B69662874';
wwv_flow_imp.g_varchar2_table(2168) := '6869732E6C696E6552616E67652E6973456D7074792972657475726E206E6577204C7428746869732E6C696E6552616E67652E73746172742B312C31293B636F6E737420743D566928746869732E6669727374436861724F666673657442794C696E652C';
wwv_flow_imp.g_varchar2_table(2169) := '28743D3E743C3D6529293B72657475726E206E6577204C7428746869732E6C696E6552616E67652E73746172742B742B312C652D746869732E6669727374436861724F666673657442794C696E655B745D2B746869732E6164646974696F6E616C4F6666';
wwv_flow_imp.g_varchar2_table(2170) := '73657442794C696E655B745D2B31297D7472616E736C61746552616E67652865297B72657475726E2077742E66726F6D506F736974696F6E7328746869732E7472616E736C6174654F666673657428652E7374617274292C746869732E7472616E736C61';
wwv_flow_imp.g_varchar2_table(2171) := '74654F666673657428652E656E644578636C757369766529297D66696E64576F7264436F6E7461696E696E672865297B696628653C307C7C653E3D746869732E656C656D656E74732E6C656E6774682972657475726E3B69662821437228746869732E65';
wwv_flow_imp.g_varchar2_table(2172) := '6C656D656E74735B655D292972657475726E3B6C657420743D653B666F72283B743E302626437228746869732E656C656D656E74735B742D315D293B29742D2D3B6C6574206E3D653B666F72283B6E3C746869732E656C656D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(2173) := '2626437228746869732E656C656D656E74735B6E5D293B296E2B2B3B72657475726E206E6577204B6928742C6E297D636F756E744C696E6573496E2865297B72657475726E20746869732E7472616E736C6174654F666673657428652E656E644578636C';
wwv_flow_imp.g_varchar2_table(2174) := '7573697665292E6C696E654E756D6265722D746869732E7472616E736C6174654F666673657428652E7374617274292E6C696E654E756D6265727D69735374726F6E676C79457175616C28652C74297B72657475726E20746869732E656C656D656E7473';
wwv_flow_imp.g_varchar2_table(2175) := '5B655D3D3D3D746869732E656C656D656E74735B745D7D657874656E64546F46756C6C4C696E65732865297B76617220742C6E3B636F6E737420693D6E756C6C213D3D28743D716928746869732E6669727374436861724F666673657442794C696E652C';
wwv_flow_imp.g_varchar2_table(2176) := '28743D3E743C3D652E73746172742929292626766F69642030213D3D743F743A302C723D6E756C6C213D3D286E3D66756E6374696F6E2874297B636F6E7374206E3D426928742C28743D3E652E656E644578636C75736976653C3D7429293B7265747572';
wwv_flow_imp.g_varchar2_table(2177) := '6E206E3D3D3D742E6C656E6774683F766F696420303A745B6E5D7D28746869732E6669727374436861724F666673657442794C696E6529292626766F69642030213D3D6E3F6E3A746869732E656C656D656E74732E6C656E6774683B72657475726E206E';
wwv_flow_imp.g_varchar2_table(2178) := '6577204B6928692C72297D7D66756E6374696F6E2043722865297B72657475726E20653E3D39372626653C3D3132327C7C653E3D36352626653C3D39307C7C653E3D34382626653C3D35377D636F6E73742079723D7B303A302C313A302C323A302C333A';
wwv_flow_imp.g_varchar2_table(2179) := '31302C343A322C353A33302C363A332C373A31302C383A31307D3B66756E6374696F6E204C722865297B72657475726E2079725B655D7D66756E6374696F6E2077722865297B72657475726E2031303D3D3D653F383A31333D3D3D653F373A6472286529';
wwv_flow_imp.g_varchar2_table(2180) := '3F363A653E3D39372626653C3D3132323F303A653E3D36352626653C3D39303F313A653E3D34382626653C3D35373F323A2D313D3D3D653F333A34343D3D3D657C7C35393D3D3D653F353A347D66756E6374696F6E204E7228652C742C6E297B69662865';
wwv_flow_imp.g_varchar2_table(2181) := '2E7472696D28293D3D3D742E7472696D28292972657475726E21303B696628652E6C656E6774683E3330302626742E6C656E6774683E3330302972657475726E21313B636F6E737420693D286E6577206672292E636F6D70757465286E6577207672285B';
wwv_flow_imp.g_varchar2_table(2182) := '655D2C6E6577204B6928302C31292C2131292C6E6577207672285B745D2C6E6577204B6928302C31292C2131292C6E293B6C657420723D303B636F6E737420733D61722E696E7665727428692E64696666732C652E6C656E677468293B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(2183) := '73742074206F66207329742E7365713152616E67652E666F72456163682828743D3E7B647228652E63686172436F64654174287429297C7C722B2B7D29293B636F6E7374206F3D66756E6374696F6E2874297B6C6574206E3D303B666F72286C65742069';
wwv_flow_imp.g_varchar2_table(2184) := '3D303B693C652E6C656E6774683B692B2B29647228742E63686172436F64654174286929297C7C6E2B2B3B72657475726E206E7D28652E6C656E6774683E742E6C656E6774683F653A74293B72657475726E20722F6F3E2E3626266F3E31307D66756E63';
wwv_flow_imp.g_varchar2_table(2185) := '74696F6E20457228652C742C6E297B6C657420693D6E3B72657475726E20693D537228652C742C69292C693D537228652C742C69292C693D66756E6374696F6E28652C742C6E297B69662821652E676574426F756E6461727953636F72657C7C21742E67';
wwv_flow_imp.g_varchar2_table(2186) := '6574426F756E6461727953636F72652972657475726E206E3B666F72286C657420693D303B693C6E2E6C656E6774683B692B2B297B636F6E737420723D693E303F6E5B692D315D3A766F696420302C733D6E5B695D2C6F3D692B313C6E2E6C656E677468';
wwv_flow_imp.g_varchar2_table(2187) := '3F6E5B692B315D3A766F696420302C613D6E6577204B6928723F722E7365713152616E67652E656E644578636C75736976652B313A302C6F3F6F2E7365713152616E67652E73746172742D313A652E6C656E677468292C6C3D6E6577204B6928723F722E';
wwv_flow_imp.g_varchar2_table(2188) := '7365713252616E67652E656E644578636C75736976652B313A302C6F3F6F2E7365713252616E67652E73746172742D313A742E6C656E677468293B732E7365713152616E67652E6973456D7074793F6E5B695D3D527228732C652C742C612C6C293A732E';
wwv_flow_imp.g_varchar2_table(2189) := '7365713252616E67652E6973456D7074792626286E5B695D3D527228732E7377617028292C742C652C6C2C61292E737761702829297D72657475726E206E7D28652C742C69292C697D66756E6374696F6E20537228652C742C6E297B696628303D3D3D6E';
wwv_flow_imp.g_varchar2_table(2190) := '2E6C656E6774682972657475726E206E3B636F6E737420693D5B5D3B692E70757368286E5B305D293B666F72286C657420723D313B723C6E2E6C656E6774683B722B2B297B636F6E737420733D695B692E6C656E6774682D315D3B6C6574206F3D6E5B72';
wwv_flow_imp.g_varchar2_table(2191) := '5D3B6966286F2E7365713152616E67652E6973456D7074797C7C6F2E7365713252616E67652E6973456D707479297B636F6E7374206E3D6F2E7365713152616E67652E73746172742D732E7365713152616E67652E656E644578636C75736976653B6C65';
wwv_flow_imp.g_varchar2_table(2192) := '7420723B666F7228723D313B723C3D6E2626652E676574456C656D656E74286F2E7365713152616E67652E73746172742D72293D3D3D652E676574456C656D656E74286F2E7365713152616E67652E656E644578636C75736976652D72292626742E6765';
wwv_flow_imp.g_varchar2_table(2193) := '74456C656D656E74286F2E7365713252616E67652E73746172742D72293D3D3D742E676574456C656D656E74286F2E7365713252616E67652E656E644578636C75736976652D72293B722B2B293B696628722D2D2C723D3D3D6E297B695B692E6C656E67';
wwv_flow_imp.g_varchar2_table(2194) := '74682D315D3D6E6577206172286E6577204B6928732E7365713152616E67652E73746172742C6F2E7365713152616E67652E656E644578636C75736976652D6E292C6E6577204B6928732E7365713252616E67652E73746172742C6F2E7365713252616E';
wwv_flow_imp.g_varchar2_table(2195) := '67652E656E644578636C75736976652D6E29293B636F6E74696E75657D6F3D6F2E64656C7461282D72297D692E70757368286F297D636F6E737420723D5B5D3B666F72286C6574206E3D303B6E3C692E6C656E6774682D313B6E2B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(2196) := '733D695B6E2B315D3B6C6574206F3D695B6E5D3B6966286F2E7365713152616E67652E6973456D7074797C7C6F2E7365713252616E67652E6973456D707479297B636F6E737420723D732E7365713152616E67652E73746172742D6F2E7365713152616E';
wwv_flow_imp.g_varchar2_table(2197) := '67652E656E644578636C75736976653B6C657420613B666F7228613D303B613C722626652E69735374726F6E676C79457175616C286F2E7365713152616E67652E73746172742B612C6F2E7365713152616E67652E656E644578636C75736976652B6129';
wwv_flow_imp.g_varchar2_table(2198) := '2626742E69735374726F6E676C79457175616C286F2E7365713252616E67652E73746172742B612C6F2E7365713252616E67652E656E644578636C75736976652B61293B612B2B293B696628613D3D3D72297B695B6E2B315D3D6E6577206172286E6577';
wwv_flow_imp.g_varchar2_table(2199) := '204B69286F2E7365713152616E67652E73746172742B722C732E7365713152616E67652E656E644578636C7573697665292C6E6577204B69286F2E7365713252616E67652E73746172742B722C732E7365713252616E67652E656E644578636C75736976';
wwv_flow_imp.g_varchar2_table(2200) := '6529293B636F6E74696E75657D613E302626286F3D6F2E64656C7461286129297D722E70757368286F297D72657475726E20692E6C656E6774683E302626722E7075736828695B692E6C656E6774682D315D292C727D66756E6374696F6E20527228652C';
wwv_flow_imp.g_varchar2_table(2201) := '742C6E2C692C72297B6C657420733D313B666F72283B652E7365713152616E67652E73746172742D733E3D692E73746172742626652E7365713252616E67652E73746172742D733E3D722E737461727426266E2E69735374726F6E676C79457175616C28';
wwv_flow_imp.g_varchar2_table(2202) := '652E7365713252616E67652E73746172742D732C652E7365713252616E67652E656E644578636C75736976652D73292626733C3130303B29732B2B3B732D2D3B6C6574206F3D303B666F72283B652E7365713152616E67652E73746172742B6F3C692E65';
wwv_flow_imp.g_varchar2_table(2203) := '6E644578636C75736976652626652E7365713252616E67652E656E644578636C75736976652B6F3C722E656E644578636C757369766526266E2E69735374726F6E676C79457175616C28652E7365713252616E67652E73746172742B6F2C652E73657132';
wwv_flow_imp.g_varchar2_table(2204) := '52616E67652E656E644578636C75736976652B6F2926266F3C3130303B296F2B2B3B696628303D3D3D732626303D3D3D6F2972657475726E20653B6C657420613D302C6C3D2D313B666F72286C657420693D2D733B693C3D6F3B692B2B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(2205) := '20723D652E7365713252616E67652E73746172742B692C733D652E7365713252616E67652E656E644578636C75736976652B692C6F3D652E7365713152616E67652E73746172742B692C753D742E676574426F756E6461727953636F7265286F292B6E2E';
wwv_flow_imp.g_varchar2_table(2206) := '676574426F756E6461727953636F72652872292B6E2E676574426F756E6461727953636F72652873293B753E6C2626286C3D752C613D69297D72657475726E20652E64656C74612861297D636C6173732041727B636F6E7374727563746F7228652C7429';
wwv_flow_imp.g_varchar2_table(2207) := '7B746869732E7472696D6D6564486173683D652C746869732E6C696E65733D747D676574456C656D656E742865297B72657475726E20746869732E7472696D6D6564486173685B655D7D676574206C656E67746828297B72657475726E20746869732E74';
wwv_flow_imp.g_varchar2_table(2208) := '72696D6D6564486173682E6C656E6774687D676574426F756E6461727953636F72652865297B72657475726E203165332D2828303D3D3D653F303A787228746869732E6C696E65735B652D315D29292B28653D3D3D746869732E6C696E65732E6C656E67';
wwv_flow_imp.g_varchar2_table(2209) := '74683F303A787228746869732E6C696E65735B655D2929297D676574546578742865297B72657475726E20746869732E6C696E65732E736C69636528652E73746172742C652E656E644578636C7573697665292E6A6F696E28225C6E22297D6973537472';
wwv_flow_imp.g_varchar2_table(2210) := '6F6E676C79457175616C28652C74297B72657475726E20746869732E6C696E65735B655D3D3D3D746869732E6C696E65735B745D7D7D66756E6374696F6E2078722865297B6C657420743D303B666F72283B743C652E6C656E67746826262833323D3D3D';
wwv_flow_imp.g_varchar2_table(2211) := '652E63686172436F646541742874297C7C393D3D3D652E63686172436F64654174287429293B29742B2B3B72657475726E20747D636C617373204D727B636F6E7374727563746F7228297B746869732E64796E616D696350726F6772616D6D696E674469';
wwv_flow_imp.g_varchar2_table(2212) := '6666696E673D6E65772067722C746869732E6D7965727344696666696E67416C676F726974686D3D6E65772066727D636F6D707574654469666628652C742C6E297B696628652E6C656E6774683C3D31262666756E6374696F6E28652C742C6E3D28652C';
wwv_flow_imp.g_varchar2_table(2213) := '74293D3E653D3D3D74297B696628653D3D3D742972657475726E21303B69662821657C7C21742972657475726E21313B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C657420693D302C723D652E6C656E67';
wwv_flow_imp.g_varchar2_table(2214) := '74683B693C723B692B2B29696628216E28655B695D2C745B695D292972657475726E21313B72657475726E21307D28652C742C2828652C74293D3E653D3D3D7429292972657475726E206E6577204469285B5D2C5B5D2C2131293B696628313D3D3D652E';
wwv_flow_imp.g_varchar2_table(2215) := '6C656E6774682626303D3D3D655B305D2E6C656E6774687C7C313D3D3D742E6C656E6774682626303D3D3D745B305D2E6C656E6774682972657475726E206E6577204469285B6E6577204769286E6577207A6928312C652E6C656E6774682B31292C6E65';
wwv_flow_imp.g_varchar2_table(2216) := '77207A6928312C742E6C656E6774682B31292C5B6E6577205169286E657720777428312C312C652E6C656E6774682C655B652E6C656E6774682D315D2E6C656E6774682B31292C6E657720777428312C312C742E6C656E6774682C745B742E6C656E6774';
wwv_flow_imp.g_varchar2_table(2217) := '682D315D2E6C656E6774682B3129295D295D2C5B5D2C2131293B636F6E737420693D303D3D3D6E2E6D6178436F6D7075746174696F6E54696D654D733F75722E696E7374616E63653A6E6577206872286E2E6D6178436F6D7075746174696F6E54696D65';
wwv_flow_imp.g_varchar2_table(2218) := '4D73292C723D216E2E69676E6F72655472696D576869746573706163652C733D6E6577204D61703B66756E6374696F6E206F2865297B6C657420743D732E6765742865293B72657475726E20766F696420303D3D3D74262628743D732E73697A652C732E';
wwv_flow_imp.g_varchar2_table(2219) := '73657428652C7429292C747D636F6E737420613D652E6D61702828653D3E6F28652E7472696D28292929292C6C3D742E6D61702828653D3E6F28652E7472696D28292929292C753D6E657720417228612C65292C683D6E6577204172286C2C74292C633D';
wwv_flow_imp.g_varchar2_table(2220) := '2828293D3E752E6C656E6774682B682E6C656E6774683C313730303F746869732E64796E616D696350726F6772616D6D696E6744696666696E672E636F6D7075746528752C682C692C28286E2C69293D3E655B6E5D3D3D3D745B695D3F303D3D3D745B69';
wwv_flow_imp.g_varchar2_table(2221) := '5D2E6C656E6774683F2E313A312B4D6174682E6C6F6728312B745B695D2E6C656E677468293A2E393929293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528752C68292928293B6C657420643D632E6469666673';
wwv_flow_imp.g_varchar2_table(2222) := '2C6D3D632E68697454696D656F75743B643D457228752C682C64292C643D66756E6374696F6E28652C742C6E297B6C657420693D6E3B696628303D3D3D692E6C656E6774682972657475726E20693B6C657420722C733D303B646F7B723D21313B636F6E';
wwv_flow_imp.g_varchar2_table(2223) := '7374206F3D5B695B305D5D3B666F72286C657420613D313B613C692E6C656E6774683B612B2B297B636F6E7374206C3D695B615D2C753D6F5B6F2E6C656E6774682D315D3B66756E6374696F6E206828742C6E297B636F6E737420693D6E6577204B6928';
wwv_flow_imp.g_varchar2_table(2224) := '752E7365713152616E67652E656E644578636C75736976652C6C2E7365713152616E67652E7374617274293B72657475726E20652E676574546578742869292E7265706C616365282F5C732F672C2222292E6C656E6774683C3D34262628742E73657131';
wwv_flow_imp.g_varchar2_table(2225) := '52616E67652E6C656E6774682B742E7365713252616E67652E6C656E6774683E357C7C6E2E7365713152616E67652E6C656E6774682B6E2E7365713252616E67652E6C656E6774683E35297D6828752C6C293F28723D21302C6F5B6F2E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(2226) := '315D3D6F5B6F2E6C656E6774682D315D2E6A6F696E286C29293A6F2E70757368286C297D693D6F7D7768696C6528732B2B3C3130262672293B72657475726E20697D28752C302C64293B636F6E737420673D5B5D2C663D6E3D3E7B6966287229666F7228';
wwv_flow_imp.g_varchar2_table(2227) := '6C657420733D303B733C6E3B732B2B297B636F6E7374206E3D702B732C6F3D622B733B696628655B6E5D213D3D745B6F5D297B636F6E737420733D746869732E726566696E654469666628652C742C6E6577206172286E6577204B69286E2C6E2B31292C';
wwv_flow_imp.g_varchar2_table(2228) := '6E6577204B69286F2C6F2B3129292C692C72293B666F7228636F6E73742065206F6620732E6D617070696E677329672E707573682865293B732E68697454696D656F75742626286D3D2130297D7D7D3B6C657420703D302C623D303B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(2229) := '74206E206F662064297B6B69282828293D3E6E2E7365713152616E67652E73746172742D703D3D6E2E7365713252616E67652E73746172742D6229292C66286E2E7365713152616E67652E73746172742D70292C703D6E2E7365713152616E67652E656E';
wwv_flow_imp.g_varchar2_table(2230) := '644578636C75736976652C623D6E2E7365713252616E67652E656E644578636C75736976653B636F6E737420733D746869732E726566696E654469666628652C742C6E2C692C72293B732E68697454696D656F75742626286D3D2130293B666F7228636F';
wwv_flow_imp.g_varchar2_table(2231) := '6E73742065206F6620732E6D617070696E677329672E707573682865297D6628652E6C656E6774682D70293B636F6E7374205F3D6B7228672C652C74293B6C657420763D5B5D3B72657475726E206E2E636F6D707574654D6F766573262628763D746869';
wwv_flow_imp.g_varchar2_table(2232) := '732E636F6D707574654D6F766573285F2C652C742C612C6C2C692C7229292C6B69282828293D3E7B66756E6374696F6E206E28652C74297B696628652E6C696E654E756D6265723C317C7C652E6C696E654E756D6265723E742E6C656E67746829726574';
wwv_flow_imp.g_varchar2_table(2233) := '75726E21313B636F6E7374206E3D745B652E6C696E654E756D6265722D315D3B72657475726E2128652E636F6C756D6E3C317C7C652E636F6C756D6E3E6E2E6C656E6774682B31297D66756E6374696F6E206928652C74297B72657475726E2128652E73';
wwv_flow_imp.g_varchar2_table(2234) := '746172744C696E654E756D6265723C317C7C652E73746172744C696E654E756D6265723E742E6C656E6774682B317C7C652E656E644C696E654E756D6265724578636C75736976653C317C7C652E656E644C696E654E756D6265724578636C7573697665';
wwv_flow_imp.g_varchar2_table(2235) := '3E742E6C656E6774682B31297D666F7228636F6E73742072206F66205F297B69662821722E696E6E65724368616E6765732972657475726E21313B666F7228636F6E73742069206F6620722E696E6E65724368616E6765732969662821286E28692E6D6F';
wwv_flow_imp.g_varchar2_table(2236) := '64696669656452616E67652E6765745374617274506F736974696F6E28292C742926266E28692E6D6F64696669656452616E67652E676574456E64506F736974696F6E28292C742926266E28692E6F726967696E616C52616E67652E6765745374617274';
wwv_flow_imp.g_varchar2_table(2237) := '506F736974696F6E28292C652926266E28692E6F726967696E616C52616E67652E676574456E64506F736974696F6E28292C6529292972657475726E21313B696628216928722E6D6F6469666965642C74297C7C216928722E6F726967696E616C2C6529';
wwv_flow_imp.g_varchar2_table(2238) := '2972657475726E21317D72657475726E21307D29292C6E6577204469285F2C762C6D297D636F6D707574654D6F76657328652C742C6E2C692C722C732C6F297B72657475726E2066756E6374696F6E28652C742C6E2C692C722C73297B6C65747B6D6F76';
wwv_flow_imp.g_varchar2_table(2239) := '65733A6F2C6578636C756465644368616E6765733A617D3D66756E6374696F6E28652C742C6E2C69297B636F6E737420723D5B5D2C733D652E66696C7465722828653D3E652E6D6F6469666965642E6973456D7074792626652E6F726967696E616C2E6C';
wwv_flow_imp.g_varchar2_table(2240) := '656E6774683E3D3329292E6D61702828653D3E6E6577206D7228652E6F726967696E616C2C742C652929292C6F3D6E65772053657428652E66696C7465722828653D3E652E6F726967696E616C2E6973456D7074792626652E6D6F6469666965642E6C65';
wwv_flow_imp.g_varchar2_table(2241) := '6E6774683E3D3329292E6D61702828653D3E6E6577206D7228652E6D6F6469666965642C6E2C65292929292C613D6E6577205365743B666F7228636F6E73742065206F662073297B6C657420742C6E3D2D313B666F7228636F6E73742069206F66206F29';
wwv_flow_imp.g_varchar2_table(2242) := '7B636F6E737420723D652E636F6D7075746553696D696C61726974792869293B723E6E2626286E3D722C743D69297D6966286E3E2E392626742626286F2E64656C6574652874292C722E70757368286E6577206A6928652E72616E67652C742E72616E67';
wwv_flow_imp.g_varchar2_table(2243) := '6529292C612E61646428652E736F75726365292C612E61646428742E736F7572636529292C21692E697356616C696428292972657475726E7B6D6F7665733A722C6578636C756465644368616E6765733A617D7D72657475726E7B6D6F7665733A722C65';
wwv_flow_imp.g_varchar2_table(2244) := '78636C756465644368616E6765733A617D7D28652C742C6E2C73293B69662821732E697356616C696428292972657475726E5B5D3B636F6E7374206C3D66756E6374696F6E28652C742C6E2C692C722C73297B636F6E7374206F3D5B5D2C613D6E657720';
wwv_flow_imp.g_varchar2_table(2245) := '52693B666F7228636F6E7374206E206F66206529666F72286C657420653D6E2E6F726967696E616C2E73746172744C696E654E756D6265723B653C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D323B652B2B297B';
wwv_flow_imp.g_varchar2_table(2246) := '636F6E7374206E3D60247B745B652D315D7D3A247B745B652B312D315D7D3A247B745B652B322D315D7D603B612E616464286E2C7B72616E67653A6E6577207A6928652C652B33297D297D636F6E7374206C3D5B5D3B652E736F72742845742828653D3E';
wwv_flow_imp.g_varchar2_table(2247) := '652E6D6F6469666965642E73746172744C696E654E756D626572292C537429293B666F7228636F6E73742074206F662065297B6C657420653D5B5D3B666F72286C657420693D742E6D6F6469666965642E73746172744C696E654E756D6265723B693C74';
wwv_flow_imp.g_varchar2_table(2248) := '2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D323B692B2B297B636F6E737420743D60247B6E5B692D315D7D3A247B6E5B692B312D315D7D3A247B6E5B692B322D315D7D602C723D6E6577207A6928692C692B33292C';
wwv_flow_imp.g_varchar2_table(2249) := '733D5B5D3B612E666F724561636828742C28287B72616E67653A747D293D3E7B666F7228636F6E7374206E206F662065296966286E2E6F726967696E616C4C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D74';
wwv_flow_imp.g_varchar2_table(2250) := '2E656E644C696E654E756D6265724578636C757369766526266E2E6D6F6469666965644C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D722E656E644C696E654E756D6265724578636C757369766529726574';
wwv_flow_imp.g_varchar2_table(2251) := '75726E206E2E6F726967696E616C4C696E6552616E67653D6E6577207A69286E2E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C742E656E644C696E654E756D6265724578636C7573697665292C6E2E6D6F646966';
wwv_flow_imp.g_varchar2_table(2252) := '6965644C696E6552616E67653D6E6577207A69286E2E6D6F6469666965644C696E6552616E67652E73746172744C696E654E756D6265722C722E656E644C696E654E756D6265724578636C7573697665292C766F696420732E70757368286E293B636F6E';
wwv_flow_imp.g_varchar2_table(2253) := '7374206E3D7B6D6F6469666965644C696E6552616E67653A722C6F726967696E616C4C696E6552616E67653A747D3B6C2E70757368286E292C732E70757368286E297D29292C653D737D69662821732E697356616C696428292972657475726E5B5D7D76';
wwv_flow_imp.g_varchar2_table(2254) := '617220753B6C2E736F72742828753D45742828653D3E652E6D6F6469666965644C696E6552616E67652E6C656E677468292C5374292C28652C74293D3E2D7528652C742929293B636F6E737420683D6E65772048692C633D6E65772048693B666F722863';
wwv_flow_imp.g_varchar2_table(2255) := '6F6E73742065206F66206C297B636F6E737420743D652E6D6F6469666965644C696E6552616E67652E73746172744C696E654E756D6265722D652E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C6E3D682E737562';
wwv_flow_imp.g_varchar2_table(2256) := '747261637446726F6D28652E6D6F6469666965644C696E6552616E6765292C693D632E737562747261637446726F6D28652E6F726967696E616C4C696E6552616E6765292E6765745769746844656C74612874292C723D6E2E676574496E746572736563';
wwv_flow_imp.g_varchar2_table(2257) := '74696F6E2869293B666F7228636F6E73742065206F6620722E72616E676573297B696628652E6C656E6774683C3329636F6E74696E75653B636F6E7374206E3D652C693D652E64656C7461282D74293B6F2E70757368286E6577206A6928692C6E29292C';
wwv_flow_imp.g_varchar2_table(2258) := '682E61646452616E6765286E292C632E61646452616E67652869297D7D6F2E736F72742845742828653D3E652E6F726967696E616C2E73746172744C696E654E756D626572292C537429293B636F6E737420643D6E65772055692865293B666F72286C65';
wwv_flow_imp.g_varchar2_table(2259) := '7420743D303B743C6F2E6C656E6774683B742B2B297B636F6E7374206E3D6F5B745D2C613D642E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C3D6E2E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2260) := '2E73746172744C696E654E756D62657229292C6C3D716928652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C3D6E2E6D6F6469666965642E73746172744C696E654E756D62657229292C753D4D6174682E6D6178286E2E';
wwv_flow_imp.g_varchar2_table(2261) := '6F726967696E616C2E73746172744C696E654E756D6265722D612E6F726967696E616C2E73746172744C696E654E756D6265722C6E2E6D6F6469666965642E73746172744C696E654E756D6265722D6C2E6D6F6469666965642E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(2262) := '756D626572292C6D3D642E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529292C673D71';
wwv_flow_imp.g_varchar2_table(2263) := '6928652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C757369766529292C663D4D6174682E6D6178286D2E6F726967696E616C2E656E644C696E65';
wwv_flow_imp.g_varchar2_table(2264) := '4E756D6265724578636C75736976652D6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C672E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D6E2E6D6F6469666965642E656E644C69';
wwv_flow_imp.g_varchar2_table(2265) := '6E654E756D6265724578636C7573697665293B6C657420702C623B666F7228703D303B703C753B702B2B297B636F6E737420653D6E2E6F726967696E616C2E73746172744C696E654E756D6265722D702D312C743D6E2E6D6F6469666965642E73746172';
wwv_flow_imp.g_varchar2_table(2266) := '744C696E654E756D6265722D702D313B696628653E692E6C656E6774687C7C743E722E6C656E67746829627265616B3B696628682E636F6E7461696E732874297C7C632E636F6E7461696E7328652929627265616B3B696628214E7228695B652D315D2C';
wwv_flow_imp.g_varchar2_table(2267) := '725B742D315D2C732929627265616B7D666F7228703E30262628632E61646452616E6765286E6577207A69286E2E6F726967696E616C2E73746172744C696E654E756D6265722D702C6E2E6F726967696E616C2E73746172744C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(2268) := '292C682E61646452616E6765286E6577207A69286E2E6D6F6469666965642E73746172744C696E654E756D6265722D702C6E2E6D6F6469666965642E73746172744C696E654E756D6265722929292C623D303B623C663B622B2B297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(2269) := '6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B622C743D6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B623B696628653E692E6C656E6774687C7C743E722E6C656E67746829';
wwv_flow_imp.g_varchar2_table(2270) := '627265616B3B696628682E636F6E7461696E732874297C7C632E636F6E7461696E7328652929627265616B3B696628214E7228695B652D315D2C725B742D315D2C732929627265616B7D623E30262628632E61646452616E6765286E6577207A69286E2E';
wwv_flow_imp.g_varchar2_table(2271) := '6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B6229292C682E61646452616E6765286E6577207A69286E2E6D6F6469666965642E65';
wwv_flow_imp.g_varchar2_table(2272) := '6E644C696E654E756D6265724578636C75736976652C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B622929292C28703E307C7C623E30292626286F5B745D3D6E6577206A69286E6577207A69286E2E6F72696769';
wwv_flow_imp.g_varchar2_table(2273) := '6E616C2E73746172744C696E654E756D6265722D702C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B62292C6E6577207A69286E2E6D6F6469666965642E73746172744C696E654E756D6265722D702C6E2E6D6F64';
wwv_flow_imp.g_varchar2_table(2274) := '69666965642E656E644C696E654E756D6265724578636C75736976652B622929297D72657475726E206F7D28652E66696C7465722828653D3E21612E68617328652929292C692C722C742C6E2C73293B72657475726E2066756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(2275) := '7B666F7228636F6E7374206E206F66207429652E70757368286E297D286F2C6C292C6F3D66756E6374696F6E2865297B696628303D3D3D652E6C656E6774682972657475726E20653B652E736F72742845742828653D3E652E6F726967696E616C2E7374';
wwv_flow_imp.g_varchar2_table(2276) := '6172744C696E654E756D626572292C537429293B636F6E737420743D5B655B305D5D3B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D745B742E6C656E6774682D315D2C723D655B6E5D2C733D722E6F726967';
wwv_flow_imp.g_varchar2_table(2277) := '696E616C2E73746172744C696E654E756D6265722D692E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C6F3D722E6D6F6469666965642E73746172744C696E654E756D6265722D692E6D6F6469666965642E656E644C69';
wwv_flow_imp.g_varchar2_table(2278) := '6E654E756D6265724578636C75736976653B733E3D3026266F3E3D302626732B6F3C3D323F745B742E6C656E6774682D315D3D692E6A6F696E2872293A742E707573682872297D72657475726E20747D286F292C6F3D6F2E66696C7465722828653D3E7B';
wwv_flow_imp.g_varchar2_table(2279) := '636F6E7374206E3D652E6F726967696E616C2E746F4F666673657452616E676528292E736C6963652874292E6D61702828653D3E652E7472696D282929293B72657475726E206E2E6A6F696E28225C6E22292E6C656E6774683E3D3135262666756E6374';
wwv_flow_imp.g_varchar2_table(2280) := '696F6E2865297B6C657420743D303B666F7228636F6E7374206E206F662065296E2E6C656E6774683E3D322626742B2B3B72657475726E20747D286E293E3D327D29292C6F3D66756E6374696F6E28652C74297B636F6E7374206E3D6E65772055692865';
wwv_flow_imp.g_varchar2_table(2281) := '293B72657475726E20742E66696C7465722828743D3E286E2E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C742E6F726967696E616C2E656E644C696E654E756D62657245';
wwv_flow_imp.g_varchar2_table(2282) := '78636C757369766529297C7C6E6577206A69286E6577207A6928312C31292C6E6577207A6928312C31292929213D3D716928652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C742E6D6F6469666965642E656E644C696E';
wwv_flow_imp.g_varchar2_table(2283) := '654E756D6265724578636C7573697665292929297D28652C6F292C6F7D28652C742C6E2C692C722C73292E6D61702828653D3E7B636F6E737420693D6B7228746869732E726566696E654469666628742C6E2C6E657720617228652E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2284) := '2E746F4F666673657452616E676528292C652E6D6F6469666965642E746F4F666673657452616E67652829292C732C6F292E6D617070696E67732C742C6E2C2130293B72657475726E206E657720466928652C69297D29297D726566696E654469666628';
wwv_flow_imp.g_varchar2_table(2285) := '652C742C6E2C692C72297B636F6E737420733D6E657720767228652C6E2E7365713152616E67652C72292C6F3D6E657720767228742C6E2E7365713252616E67652C72292C613D732E6C656E6774682B6F2E6C656E6774683C3530303F746869732E6479';
wwv_flow_imp.g_varchar2_table(2286) := '6E616D696350726F6772616D6D696E6744696666696E672E636F6D7075746528732C6F2C69293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528732C6F2C69293B6C6574206C3D612E64696666733B7265747572';
wwv_flow_imp.g_varchar2_table(2287) := '6E206C3D457228732C6F2C6C292C6C3D66756E6374696F6E28652C742C6E297B636F6E737420693D61722E696E76657274286E2C652E6C656E677468292C723D5B5D3B6C657420733D6E6577206C7228302C30293B66756E6374696F6E206F286E2C6F29';
wwv_flow_imp.g_varchar2_table(2288) := '7B6966286E2E6F6666736574313C732E6F6666736574317C7C6E2E6F6666736574323C732E6F6666736574322972657475726E3B636F6E737420613D652E66696E64576F7264436F6E7461696E696E67286E2E6F666673657431292C6C3D742E66696E64';
wwv_flow_imp.g_varchar2_table(2289) := '576F7264436F6E7461696E696E67286E2E6F666673657432293B69662821617C7C216C2972657475726E3B6C657420753D6E657720617228612C6C293B636F6E737420683D752E696E74657273656374286F293B6C657420633D682E7365713152616E67';
wwv_flow_imp.g_varchar2_table(2290) := '652E6C656E6774682C643D682E7365713252616E67652E6C656E6774683B666F72283B692E6C656E6774683E303B297B636F6E7374206E3D695B305D3B696628216E2E7365713152616E67652E696E746572736563747328752E7365713152616E676529';
wwv_flow_imp.g_varchar2_table(2291) := '2626216E2E7365713252616E67652E696E746572736563747328752E7365713252616E67652929627265616B3B636F6E737420723D652E66696E64576F7264436F6E7461696E696E67286E2E7365713152616E67652E7374617274292C733D742E66696E';
wwv_flow_imp.g_varchar2_table(2292) := '64576F7264436F6E7461696E696E67286E2E7365713252616E67652E7374617274292C6F3D6E657720617228722C73292C613D6F2E696E74657273656374286E293B696628632B3D612E7365713152616E67652E6C656E6774682C642B3D612E73657132';
wwv_flow_imp.g_varchar2_table(2293) := '52616E67652E6C656E6774682C753D752E6A6F696E286F292C2128752E7365713152616E67652E656E644578636C75736976653E3D6E2E7365713152616E67652E656E644578636C75736976652929627265616B3B692E736869667428297D632B643C32';
wwv_flow_imp.g_varchar2_table(2294) := '2A28752E7365713152616E67652E6C656E6774682B752E7365713252616E67652E6C656E677468292F332626722E707573682875292C733D752E676574456E644578636C75736976657328297D666F72283B692E6C656E6774683E303B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(2295) := '20653D692E736869667428293B652E7365713152616E67652E6973456D7074797C7C286F28652E67657453746172747328292C65292C6F28652E676574456E644578636C75736976657328292E64656C7461282D31292C6529297D72657475726E206675';
wwv_flow_imp.g_varchar2_table(2296) := '6E6374696F6E28652C74297B636F6E7374206E3D5B5D3B666F72283B652E6C656E6774683E307C7C742E6C656E6774683E303B297B636F6E737420693D655B305D2C723D745B305D3B6C657420733B733D6926262821727C7C692E7365713152616E6765';
wwv_flow_imp.g_varchar2_table(2297) := '2E73746172743C722E7365713152616E67652E7374617274293F652E736869667428293A742E736869667428292C6E2E6C656E6774683E3026266E5B6E2E6C656E6774682D315D2E7365713152616E67652E656E644578636C75736976653E3D732E7365';
wwv_flow_imp.g_varchar2_table(2298) := '713152616E67652E73746172743F6E5B6E2E6C656E6774682D315D3D6E5B6E2E6C656E6774682D315D2E6A6F696E2873293A6E2E707573682873297D72657475726E206E7D286E2C72297D28732C6F2C6C292C6C3D66756E6374696F6E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(2299) := '7B636F6E737420693D5B5D3B666F7228636F6E73742065206F66206E297B636F6E737420743D695B692E6C656E6774682D315D3B74262628652E7365713152616E67652E73746172742D742E7365713152616E67652E656E644578636C75736976653C3D';
wwv_flow_imp.g_varchar2_table(2300) := '327C7C652E7365713252616E67652E73746172742D742E7365713252616E67652E656E644578636C75736976653C3D32293F695B692E6C656E6774682D315D3D6E657720617228742E7365713152616E67652E6A6F696E28652E7365713152616E676529';
wwv_flow_imp.g_varchar2_table(2301) := '2C742E7365713252616E67652E6A6F696E28652E7365713252616E676529293A692E707573682865297D72657475726E20697D28302C302C6C292C6C3D66756E6374696F6E28652C742C6E297B6C657420693D6E3B696628303D3D3D692E6C656E677468';
wwv_flow_imp.g_varchar2_table(2302) := '2972657475726E20693B6C657420722C733D303B646F7B723D21313B636F6E737420613D5B695B305D5D3B666F72286C6574206C3D313B6C3C692E6C656E6774683B6C2B2B297B636F6E737420753D695B6C5D2C683D615B612E6C656E6774682D315D3B';
wwv_flow_imp.g_varchar2_table(2303) := '66756E6374696F6E2063286E2C69297B636F6E737420723D6E6577204B6928682E7365713152616E67652E656E644578636C75736976652C752E7365713152616E67652E7374617274293B696628652E636F756E744C696E6573496E2872293E357C7C72';
wwv_flow_imp.g_varchar2_table(2304) := '2E6C656E6774683E3530302972657475726E21313B636F6E737420733D652E676574546578742872292E7472696D28293B696628732E6C656E6774683E32307C7C732E73706C6974282F5C725C6E7C5C727C5C6E2F292E6C656E6774683E312972657475';
wwv_flow_imp.g_varchar2_table(2305) := '726E21313B636F6E7374206F3D652E636F756E744C696E6573496E286E2E7365713152616E6765292C613D6E2E7365713152616E67652E6C656E6774682C6C3D742E636F756E744C696E6573496E286E2E7365713252616E6765292C633D6E2E73657132';
wwv_flow_imp.g_varchar2_table(2306) := '52616E67652E6C656E6774682C643D652E636F756E744C696E6573496E28692E7365713152616E6765292C6D3D692E7365713152616E67652E6C656E6774682C673D742E636F756E744C696E6573496E28692E7365713252616E6765292C663D692E7365';
wwv_flow_imp.g_varchar2_table(2307) := '713252616E67652E6C656E6774683B66756E6374696F6E20702865297B72657475726E204D6174682E6D696E28652C313330297D72657475726E204D6174682E706F77284D6174682E706F7728702834302A6F2B61292C312E35292B4D6174682E706F77';
wwv_flow_imp.g_varchar2_table(2308) := '28702834302A6C2B63292C312E35292C312E35292B4D6174682E706F77284D6174682E706F7728702834302A642B6D292C312E35292B4D6174682E706F7728702834302A672B66292C312E35292C312E35293E37343138342E3936343830373231323433';
wwv_flow_imp.g_varchar2_table(2309) := '7D6328682C75293F28723D21302C615B612E6C656E6774682D315D3D615B612E6C656E6774682D315D2E6A6F696E287529293A612E707573682875297D693D617D7768696C6528732B2B3C3130262672293B636F6E7374206F3D5B5D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(2310) := '66756E6374696F6E28652C74297B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297428303D3D3D6E3F766F696420303A655B6E2D315D2C655B6E5D2C6E2B313D3D3D652E6C656E6774683F766F696420303A655B6E2B315D297D2869';
wwv_flow_imp.g_varchar2_table(2311) := '2C2828742C6E2C69293D3E7B6C657420723D6E3B66756E6374696F6E20732865297B72657475726E20652E6C656E6774683E302626652E7472696D28292E6C656E6774683C3D3326266E2E7365713152616E67652E6C656E6774682B6E2E736571325261';
wwv_flow_imp.g_varchar2_table(2312) := '6E67652E6C656E6774683E3130307D636F6E737420613D652E657874656E64546F46756C6C4C696E6573286E2E7365713152616E6765292C6C3D652E67657454657874286E6577204B6928612E73746172742C6E2E7365713152616E67652E7374617274';
wwv_flow_imp.g_varchar2_table(2313) := '29293B73286C29262628723D722E64656C74615374617274282D6C2E6C656E67746829293B636F6E737420753D652E67657454657874286E6577204B69286E2E7365713152616E67652E656E644578636C75736976652C612E656E644578636C75736976';
wwv_flow_imp.g_varchar2_table(2314) := '6529293B73287529262628723D722E64656C7461456E6428752E6C656E67746829293B636F6E737420683D61722E66726F6D4F6666736574506169727328743F742E676574456E644578636C75736976657328293A6C722E7A65726F2C693F692E676574';
wwv_flow_imp.g_varchar2_table(2315) := '53746172747328293A6C722E6D6178292C633D722E696E746572736563742868293B6F2E6C656E6774683E302626632E67657453746172747328292E657175616C73286F5B6F2E6C656E6774682D315D2E676574456E644578636C757369766573282929';
wwv_flow_imp.g_varchar2_table(2316) := '3F6F5B6F2E6C656E6774682D315D3D6F5B6F2E6C656E6774682D315D2E6A6F696E2863293A6F2E707573682863297D29292C6F7D28732C6F2C6C292C7B6D617070696E67733A6C2E6D61702828653D3E6E657720516928732E7472616E736C6174655261';
wwv_flow_imp.g_varchar2_table(2317) := '6E676528652E7365713152616E6765292C6F2E7472616E736C61746552616E676528652E7365713252616E6765292929292C68697454696D656F75743A612E68697454696D656F75747D7D7D66756E6374696F6E206B7228652C742C6E2C693D2131297B';
wwv_flow_imp.g_varchar2_table(2318) := '636F6E737420723D5B5D3B666F7228636F6E73742069206F662066756E6374696F6E2A2865297B6C657420742C6E3B666F7228636F6E73742073206F66206529766F69642030213D3D6E262628723D732C28693D6E292E6F726967696E616C2E6F766572';
wwv_flow_imp.g_varchar2_table(2319) := '6C61704F72546F75636828722E6F726967696E616C297C7C692E6D6F6469666965642E6F7665726C61704F72546F75636828722E6D6F64696669656429293F742E707573682873293A28742626287969656C642074292C743D5B735D292C6E3D733B7661';
wwv_flow_imp.g_varchar2_table(2320) := '7220692C723B742626287969656C642074297D28652E6D61702828653D3E66756E6374696F6E28652C742C6E297B6C657420693D302C723D303B313D3D3D652E6D6F64696669656452616E67652E656E64436F6C756D6E2626313D3D3D652E6F72696769';
wwv_flow_imp.g_varchar2_table(2321) := '6E616C52616E67652E656E64436F6C756D6E2626652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722B693C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722626652E6D6F64696669656452616E67';
wwv_flow_imp.g_varchar2_table(2322) := '652E73746172744C696E654E756D6265722B693C3D652E6D6F64696669656452616E67652E656E644C696E654E756D626572262628723D2D31292C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2D313E3D6E5B652E6D6F64696669';
wwv_flow_imp.g_varchar2_table(2323) := '656452616E67652E73746172744C696E654E756D6265722D315D2E6C656E6774682626652E6F726967696E616C52616E67652E7374617274436F6C756D6E2D313E3D745B652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722D';
wwv_flow_imp.g_varchar2_table(2324) := '315D2E6C656E6774682626652E6F726967696E616C52616E67652E73746172744C696E654E756D6265723C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722B722626652E6D6F64696669656452616E67652E73746172744C69';
wwv_flow_imp.g_varchar2_table(2325) := '6E654E756D6265723C3D652E6D6F64696669656452616E67652E656E644C696E654E756D6265722B72262628693D31293B636F6E737420733D6E6577207A6928652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722B692C652E';
wwv_flow_imp.g_varchar2_table(2326) := '6F726967696E616C52616E67652E656E644C696E654E756D6265722B312B72292C6F3D6E6577207A6928652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B692C652E6D6F64696669656452616E67652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(2327) := '756D6265722B312B72293B72657475726E206E657720476928732C6F2C5B655D297D28652C742C6E29292929297B636F6E737420653D695B305D2C743D695B692E6C656E6774682D315D3B722E70757368286E657720476928652E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(2328) := '6A6F696E28742E6F726967696E616C292C652E6D6F6469666965642E6A6F696E28742E6D6F646966696564292C692E6D61702828653D3E652E696E6E65724368616E6765735B305D292929297D72657475726E206B69282828293D3E7B69662821692626';
wwv_flow_imp.g_varchar2_table(2329) := '722E6C656E6774683E30297B696628725B305D2E6D6F6469666965642E73746172744C696E654E756D626572213D3D725B305D2E6F726967696E616C2E73746172744C696E654E756D6265722972657475726E21313B6966286E2E6C656E6774682D725B';
wwv_flow_imp.g_varchar2_table(2330) := '722E6C656E6774682D315D2E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665213D742E6C656E6774682D725B722E6C656E6774682D315D2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529';
wwv_flow_imp.g_varchar2_table(2331) := '72657475726E21317D72657475726E204F6928722C2828652C74293D3E742E6F726967696E616C2E73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2332) := '642E73746172744C696E654E756D6265722D652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E7374';
wwv_flow_imp.g_varchar2_table(2333) := '6172744C696E654E756D6265722626652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D62657229297D29292C727D66756E6374696F6E204F7228652C74297B';
wwv_flow_imp.g_varchar2_table(2334) := '636F6E7374206E3D4D6174682E706F772831302C74293B72657475726E204D6174682E726F756E6428652A6E292F6E7D636C6173732054727B636F6E7374727563746F7228652C742C6E2C693D31297B746869732E5F726762614272616E643D766F6964';
wwv_flow_imp.g_varchar2_table(2335) := '20302C746869732E723D307C4D6174682E6D696E283235352C4D6174682E6D617828302C6529292C746869732E673D307C4D6174682E6D696E283235352C4D6174682E6D617828302C7429292C746869732E623D307C4D6174682E6D696E283235352C4D';
wwv_flow_imp.g_varchar2_table(2336) := '6174682E6D617828302C6E29292C746869732E613D4F72284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E723D3D3D742E722626652E673D3D3D742E6726';
wwv_flow_imp.g_varchar2_table(2337) := '26652E623D3D3D742E622626652E613D3D3D742E617D7D636C6173732049727B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F68736C614272616E643D766F696420302C746869732E683D307C4D6174682E6D6178284D6174682E6D';
wwv_flow_imp.g_varchar2_table(2338) := '696E283336302C65292C30292C746869732E733D4F72284D6174682E6D6178284D6174682E6D696E28312C74292C30292C33292C746869732E6C3D4F72284D6174682E6D6178284D6174682E6D696E28312C6E292C30292C33292C746869732E613D4F72';
wwv_flow_imp.g_varchar2_table(2339) := '284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E6C3D3D3D742E6C2626652E613D3D3D742E617D73';
wwv_flow_imp.g_varchar2_table(2340) := '74617469632066726F6D524742412865297B636F6E737420743D652E722F3235352C6E3D652E672F3235352C693D652E622F3235352C723D652E612C733D4D6174682E6D617828742C6E2C69292C6F3D4D6174682E6D696E28742C6E2C69293B6C657420';
wwv_flow_imp.g_varchar2_table(2341) := '613D302C6C3D303B636F6E737420753D286F2B73292F322C683D732D6F3B696628683E30297B737769746368286C3D4D6174682E6D696E28753C3D2E353F682F28322A75293A682F28322D322A75292C31292C73297B6361736520743A613D286E2D6929';
wwv_flow_imp.g_varchar2_table(2342) := '2F682B286E3C693F363A30293B627265616B3B63617365206E3A613D28692D74292F682B323B627265616B3B6361736520693A613D28742D6E292F682B347D612A3D36302C613D4D6174682E726F756E642861297D72657475726E206E65772049722861';
wwv_flow_imp.g_varchar2_table(2343) := '2C6C2C752C72297D737461746963205F6875653272676228652C742C6E297B72657475726E206E3C302626286E2B3D31292C6E3E312626286E2D3D31292C6E3C312F363F652B362A28742D65292A6E3A6E3C2E353F743A6E3C322F333F652B28742D6529';
wwv_flow_imp.g_varchar2_table(2344) := '2A28322F332D6E292A363A657D73746174696320746F524742412865297B636F6E737420743D652E682F3336302C7B733A6E2C6C3A692C613A727D3D653B6C657420732C6F2C613B696628303D3D3D6E29733D6F3D613D693B656C73657B636F6E737420';
wwv_flow_imp.g_varchar2_table(2345) := '653D693C2E353F692A28312B6E293A692B6E2D692A6E2C723D322A692D653B733D49722E5F6875653272676228722C652C742B312F33292C6F3D49722E5F6875653272676228722C652C74292C613D49722E5F6875653272676228722C652C742D312F33';
wwv_flow_imp.g_varchar2_table(2346) := '297D72657475726E206E6577205472284D6174682E726F756E64283235352A73292C4D6174682E726F756E64283235352A6F292C4D6174682E726F756E64283235352A61292C72297D7D636C6173732050727B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(2347) := '2C69297B746869732E5F687376614272616E643D766F696420302C746869732E683D307C4D6174682E6D6178284D6174682E6D696E283336302C65292C30292C746869732E733D4F72284D6174682E6D6178284D6174682E6D696E28312C74292C30292C';
wwv_flow_imp.g_varchar2_table(2348) := '33292C746869732E763D4F72284D6174682E6D6178284D6174682E6D696E28312C6E292C30292C33292C746869732E613D4F72284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B';
wwv_flow_imp.g_varchar2_table(2349) := '72657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E763D3D3D742E762626652E613D3D3D742E617D7374617469632066726F6D524742412865297B636F6E737420743D652E722F3235352C6E3D652E672F3235352C693D652E62';
wwv_flow_imp.g_varchar2_table(2350) := '2F3235352C723D4D6174682E6D617828742C6E2C69292C733D722D4D6174682E6D696E28742C6E2C69292C6F3D303D3D3D723F303A732F723B6C657420613B72657475726E20613D303D3D3D733F303A723D3D3D743F28286E2D69292F7325362B362925';
wwv_flow_imp.g_varchar2_table(2351) := '363A723D3D3D6E3F28692D74292F732B323A28742D6E292F732B342C6E6577205072284D6174682E726F756E642836302A61292C6F2C722C652E61297D73746174696320746F524742412865297B636F6E73747B683A742C733A6E2C763A692C613A727D';
wwv_flow_imp.g_varchar2_table(2352) := '3D652C733D692A6E2C6F3D732A28312D4D6174682E61627328742F363025322D3129292C613D692D733B6C65745B6C2C752C685D3D5B302C302C305D3B72657475726E20743C36303F286C3D732C753D6F293A743C3132303F286C3D6F2C753D73293A74';
wwv_flow_imp.g_varchar2_table(2353) := '3C3138303F28753D732C683D6F293A743C3234303F28753D6F2C683D73293A743C3330303F286C3D6F2C683D73293A743C3D3336302626286C3D732C683D6F292C6C3D4D6174682E726F756E64283235352A286C2B6129292C753D4D6174682E726F756E';
wwv_flow_imp.g_varchar2_table(2354) := '64283235352A28752B6129292C683D4D6174682E726F756E64283235352A28682B6129292C6E6577205472286C2C752C682C72297D7D636C6173732044727B7374617469632066726F6D4865782865297B72657475726E2044722E466F726D61742E4353';
wwv_flow_imp.g_varchar2_table(2355) := '532E70617273654865782865297C7C44722E7265647D73746174696320657175616C7328652C74297B72657475726E2165262621747C7C212821657C7C2174292626652E657175616C732874297D6765742068736C6128297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(2356) := '2E5F68736C613F746869732E5F68736C613A49722E66726F6D5247424128746869732E72676261297D676574206873766128297B72657475726E20746869732E5F687376613F746869732E5F687376613A50722E66726F6D5247424128746869732E7267';
wwv_flow_imp.g_varchar2_table(2357) := '6261297D636F6E7374727563746F722865297B6966282165297468726F77206E6577204572726F722822436F6C6F72206E6565647320612076616C756522293B6966286520696E7374616E63656F6620547229746869732E726762613D653B656C736520';
wwv_flow_imp.g_varchar2_table(2358) := '6966286520696E7374616E63656F6620497229746869732E5F68736C613D652C746869732E726762613D49722E746F524742412865293B656C73657B69662821286520696E7374616E63656F6620507229297468726F77206E6577204572726F72282249';
wwv_flow_imp.g_varchar2_table(2359) := '6E76616C696420636F6C6F722063746F7220617267756D656E7422293B746869732E5F687376613D652C746869732E726762613D50722E746F524742412865297D7D657175616C732865297B72657475726E212165262654722E657175616C7328746869';
wwv_flow_imp.g_varchar2_table(2360) := '732E726762612C652E7267626129262649722E657175616C7328746869732E68736C612C652E68736C6129262650722E657175616C7328746869732E687376612C652E68737661297D67657452656C61746976654C756D696E616E636528297B72657475';
wwv_flow_imp.g_varchar2_table(2361) := '726E204F72282E323132362A44722E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E72292B2E373135322A44722E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E742874';
wwv_flow_imp.g_varchar2_table(2362) := '6869732E726762612E67292B2E303732322A44722E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E62292C34297D737461746963205F72656C61746976654C756D696E616E6365466F72436F6D70';
wwv_flow_imp.g_varchar2_table(2363) := '6F6E656E742865297B636F6E737420743D652F3235353B72657475726E20743C3D2E30333932383F742F31322E39323A4D6174682E706F772828742B2E303535292F312E3035352C322E34297D69734C69676874657228297B72657475726E283239392A';
wwv_flow_imp.g_varchar2_table(2364) := '746869732E726762612E722B3538372A746869732E726762612E672B3131342A746869732E726762612E62292F3165333E3D3132387D69734C6967687465725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E61';
wwv_flow_imp.g_varchar2_table(2365) := '6E636528293E652E67657452656C61746976654C756D696E616E636528297D69734461726B65725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E616E636528293C652E67657452656C61746976654C756D696E';
wwv_flow_imp.g_varchar2_table(2366) := '616E636528297D6C69676874656E2865297B72657475726E206E6577204472286E657720497228746869732E68736C612E682C746869732E68736C612E732C746869732E68736C612E6C2B746869732E68736C612E6C2A652C746869732E68736C612E61';
wwv_flow_imp.g_varchar2_table(2367) := '29297D6461726B656E2865297B72657475726E206E6577204472286E657720497228746869732E68736C612E682C746869732E68736C612E732C746869732E68736C612E6C2D746869732E68736C612E6C2A652C746869732E68736C612E6129297D7472';
wwv_flow_imp.g_varchar2_table(2368) := '616E73706172656E742865297B636F6E73747B723A742C673A6E2C623A692C613A727D3D746869732E726762613B72657475726E206E6577204472286E657720547228742C6E2C692C722A6529297D69735472616E73706172656E7428297B7265747572';
wwv_flow_imp.g_varchar2_table(2369) := '6E20303D3D3D746869732E726762612E617D69734F706171756528297B72657475726E20313D3D3D746869732E726762612E617D6F70706F7369746528297B72657475726E206E6577204472286E6577205472283235352D746869732E726762612E722C';
wwv_flow_imp.g_varchar2_table(2370) := '3235352D746869732E726762612E672C3235352D746869732E726762612E622C746869732E726762612E6129297D6D616B654F70617175652865297B696628746869732E69734F706171756528297C7C31213D3D652E726762612E612972657475726E20';
wwv_flow_imp.g_varchar2_table(2371) := '746869733B636F6E73747B723A742C673A6E2C623A692C613A727D3D746869732E726762613B72657475726E206E6577204472286E657720547228652E726762612E722D722A28652E726762612E722D74292C652E726762612E672D722A28652E726762';
wwv_flow_imp.g_varchar2_table(2372) := '612E672D6E292C652E726762612E622D722A28652E726762612E622D69292C3129297D746F537472696E6728297B72657475726E20746869732E5F746F537472696E677C7C28746869732E5F746F537472696E673D44722E466F726D61742E4353532E66';
wwv_flow_imp.g_varchar2_table(2373) := '6F726D6174287468697329292C746869732E5F746F537472696E677D737461746963206765744C696768746572436F6C6F7228652C742C6E297B696628652E69734C6967687465725468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E';
wwv_flow_imp.g_varchar2_table(2374) := '737420693D652E67657452656C61746976654C756D696E616E636528292C723D742E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A28722D69292F722C652E6C69676874656E286E297D7374617469632067657444';
wwv_flow_imp.g_varchar2_table(2375) := '61726B6572436F6C6F7228652C742C6E297B696628652E69734461726B65725468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E737420693D652E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A';
wwv_flow_imp.g_varchar2_table(2376) := '28692D742E67657452656C61746976654C756D696E616E63652829292F692C652E6461726B656E286E297D7D66756E6374696F6E2046722865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065297B636F6E737420653D4E756D62';
wwv_flow_imp.g_varchar2_table(2377) := '6572286E293B28657C7C303D3D3D6526262222213D3D6E2E7265706C616365282F5C732F672C222229292626742E707573682865297D72657475726E20747D66756E6374696F6E204B7228652C742C6E2C69297B72657475726E7B7265643A652F323535';
wwv_flow_imp.g_varchar2_table(2378) := '2C626C75653A6E2F3235352C677265656E3A742F3235352C616C7068613A697D7D66756E6374696F6E20717228652C74297B636F6E7374206E3D742E696E6465782C693D745B305D2E6C656E6774683B696628216E2972657475726E3B636F6E73742072';
wwv_flow_imp.g_varchar2_table(2379) := '3D652E706F736974696F6E4174286E293B72657475726E7B73746172744C696E654E756D6265723A722E6C696E654E756D6265722C7374617274436F6C756D6E3A722E636F6C756D6E2C656E644C696E654E756D6265723A722E6C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(2380) := '2C656E64436F6C756D6E3A722E636F6C756D6E2B697D7D66756E6374696F6E20567228652C74297B69662821652972657475726E3B636F6E7374206E3D44722E466F726D61742E4353532E70617273654865782874293B72657475726E206E3F7B72616E';
wwv_flow_imp.g_varchar2_table(2381) := '67653A652C636F6C6F723A4B72286E2E726762612E722C6E2E726762612E672C6E2E726762612E622C6E2E726762612E61297D3A766F696420307D66756E6374696F6E20427228652C742C6E297B69662821657C7C31213D3D742E6C656E677468297265';
wwv_flow_imp.g_varchar2_table(2382) := '7475726E3B636F6E737420693D467228745B305D2E76616C7565732829293B72657475726E7B72616E67653A652C636F6C6F723A4B7228695B305D2C695B315D2C695B325D2C6E3F695B335D3A31297D7D66756E6374696F6E20557228652C742C6E297B';
wwv_flow_imp.g_varchar2_table(2383) := '69662821657C7C31213D3D742E6C656E6774682972657475726E3B636F6E737420693D467228745B305D2E76616C7565732829292C723D6E6577204472286E657720497228695B305D2C695B315D2F3130302C695B325D2F3130302C6E3F695B335D3A31';
wwv_flow_imp.g_varchar2_table(2384) := '29293B72657475726E7B72616E67653A652C636F6C6F723A4B7228722E726762612E722C722E726762612E672C722E726762612E622C722E726762612E61297D7D66756E6374696F6E207A7228652C74297B72657475726E22737472696E67223D3D7479';
wwv_flow_imp.g_varchar2_table(2385) := '70656F6620653F5B2E2E2E652E6D61746368416C6C2874295D3A652E66696E644D6174636865732874297D44722E77686974653D6E6577204472286E6577205472283235352C3235352C3235352C3129292C44722E626C61636B3D6E6577204472286E65';
wwv_flow_imp.g_varchar2_table(2386) := '7720547228302C302C302C3129292C44722E7265643D6E6577204472286E6577205472283235352C302C302C3129292C44722E626C75653D6E6577204472286E657720547228302C302C3235352C3129292C44722E677265656E3D6E6577204472286E65';
wwv_flow_imp.g_varchar2_table(2387) := '7720547228302C3235352C302C3129292C44722E6379616E3D6E6577204472286E657720547228302C3235352C3235352C3129292C44722E6C69676874677265793D6E6577204472286E6577205472283231312C3231312C3231312C3129292C44722E74';
wwv_flow_imp.g_varchar2_table(2388) := '72616E73706172656E743D6E6577204472286E657720547228302C302C302C3029292C66756E6374696F6E2865297B6C657420743B2166756E6374696F6E2874297B6C6574206E3B2166756E6374696F6E2874297B66756E6374696F6E206E2865297B63';
wwv_flow_imp.g_varchar2_table(2389) := '6F6E737420743D652E746F537472696E67283136293B72657475726E2032213D3D742E6C656E6774683F2230222B743A747D66756E6374696F6E20692865297B7377697463682865297B636173652034383A72657475726E20303B636173652034393A72';
wwv_flow_imp.g_varchar2_table(2390) := '657475726E20313B636173652035303A72657475726E20323B636173652035313A72657475726E20333B636173652035323A72657475726E20343B636173652035333A72657475726E20353B636173652035343A72657475726E20363B63617365203535';
wwv_flow_imp.g_varchar2_table(2391) := '3A72657475726E20373B636173652035363A72657475726E20383B636173652035373A72657475726E20393B636173652039373A636173652036353A72657475726E2031303B636173652039383A636173652036363A72657475726E2031313B63617365';
wwv_flow_imp.g_varchar2_table(2392) := '2039393A636173652036373A72657475726E2031323B63617365203130303A636173652036383A72657475726E2031333B63617365203130313A636173652036393A72657475726E2031343B63617365203130323A636173652037303A72657475726E20';
wwv_flow_imp.g_varchar2_table(2393) := '31357D72657475726E20307D742E666F726D61745247423D66756E6374696F6E2874297B72657475726E20313D3D3D742E726762612E613F6072676228247B742E726762612E727D2C20247B742E726762612E677D2C20247B742E726762612E627D2960';
wwv_flow_imp.g_varchar2_table(2394) := '3A652E466F726D61742E4353532E666F726D6174524742412874297D2C742E666F726D6174524742413D66756E6374696F6E2865297B72657475726E607267626128247B652E726762612E727D2C20247B652E726762612E677D2C20247B652E72676261';
wwv_flow_imp.g_varchar2_table(2395) := '2E627D2C20247B2B652E726762612E612E746F46697865642832297D29607D2C742E666F726D617448534C3D66756E6374696F6E2874297B72657475726E20313D3D3D742E68736C612E613F6068736C28247B742E68736C612E687D2C20247B28313030';
wwv_flow_imp.g_varchar2_table(2396) := '2A742E68736C612E73292E746F46697865642832297D252C20247B283130302A742E68736C612E6C292E746F46697865642832297D2529603A652E466F726D61742E4353532E666F726D617448534C412874297D2C742E666F726D617448534C413D6675';
wwv_flow_imp.g_varchar2_table(2397) := '6E6374696F6E2865297B72657475726E6068736C6128247B652E68736C612E687D2C20247B283130302A652E68736C612E73292E746F46697865642832297D252C20247B283130302A652E68736C612E6C292E746F46697865642832297D252C20247B65';
wwv_flow_imp.g_varchar2_table(2398) := '2E68736C612E612E746F46697865642832297D29607D2C742E666F726D61744865783D66756E6374696F6E2865297B72657475726E6023247B6E28652E726762612E72297D247B6E28652E726762612E67297D247B6E28652E726762612E62297D607D2C';
wwv_flow_imp.g_varchar2_table(2399) := '742E666F726D6174486578413D66756E6374696F6E28742C693D2131297B72657475726E20692626313D3D3D742E726762612E613F652E466F726D61742E4353532E666F726D61744865782874293A6023247B6E28742E726762612E72297D247B6E2874';
wwv_flow_imp.g_varchar2_table(2400) := '2E726762612E67297D247B6E28742E726762612E62297D247B6E284D6174682E726F756E64283235352A742E726762612E6129297D607D2C742E666F726D61743D66756E6374696F6E2874297B72657475726E20742E69734F706171756528293F652E46';
wwv_flow_imp.g_varchar2_table(2401) := '6F726D61742E4353532E666F726D61744865782874293A652E466F726D61742E4353532E666F726D6174524742412874297D2C742E70617273654865783D66756E6374696F6E2874297B636F6E7374206E3D742E6C656E6774683B696628303D3D3D6E29';
wwv_flow_imp.g_varchar2_table(2402) := '72657475726E206E756C6C3B6966283335213D3D742E63686172436F646541742830292972657475726E206E756C6C3B696628373D3D3D6E297B636F6E7374206E3D31362A6928742E63686172436F64654174283129292B6928742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(2403) := '4174283229292C723D31362A6928742E63686172436F64654174283329292B6928742E63686172436F64654174283429292C733D31362A6928742E63686172436F64654174283529292B6928742E63686172436F64654174283629293B72657475726E20';
wwv_flow_imp.g_varchar2_table(2404) := '6E65772065286E6577205472286E2C722C732C3129297D696628393D3D3D6E297B636F6E7374206E3D31362A6928742E63686172436F64654174283129292B6928742E63686172436F64654174283229292C723D31362A6928742E63686172436F646541';
wwv_flow_imp.g_varchar2_table(2405) := '74283329292B6928742E63686172436F64654174283429292C733D31362A6928742E63686172436F64654174283529292B6928742E63686172436F64654174283629292C6F3D31362A6928742E63686172436F64654174283729292B6928742E63686172';
wwv_flow_imp.g_varchar2_table(2406) := '436F64654174283829293B72657475726E206E65772065286E6577205472286E2C722C732C6F2F32353529297D696628343D3D3D6E297B636F6E7374206E3D6928742E63686172436F64654174283129292C723D6928742E63686172436F646541742832';
wwv_flow_imp.g_varchar2_table(2407) := '29292C733D6928742E63686172436F64654174283329293B72657475726E206E65772065286E65772054722831362A6E2B6E2C31362A722B722C31362A732B7329297D696628353D3D3D6E297B636F6E7374206E3D6928742E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(2408) := '3129292C723D6928742E63686172436F64654174283229292C733D6928742E63686172436F64654174283329292C6F3D6928742E63686172436F64654174283429293B72657475726E206E65772065286E65772054722831362A6E2B6E2C31362A722B72';
wwv_flow_imp.g_varchar2_table(2409) := '2C31362A732B732C2831362A6F2B6F292F32353529297D72657475726E206E756C6C7D7D286E3D742E4353537C7C28742E4353533D7B7D29297D28743D652E466F726D61747C7C28652E466F726D61743D7B7D29297D2844727C7C2844723D7B7D29293B';
wwv_flow_imp.g_varchar2_table(2410) := '636F6E73742048723D2F5C624D41524B3A5C732A282E2A29242F642C57723D2F5E2D2B7C2D2B242F673B66756E6374696F6E20247228652C742C6E297B48722E6C617374496E6465783D303B636F6E737420693D48722E657865632865293B6966286929';
wwv_flow_imp.g_varchar2_table(2411) := '7B636F6E737420653D7B73746172744C696E654E756D6265723A742C7374617274436F6C756D6E3A692E696E64696365735B315D5B305D2B312C656E644C696E654E756D6265723A742C656E64436F6C756D6E3A692E696E64696365735B315D5B315D2B';
wwv_flow_imp.g_varchar2_table(2412) := '317D3B696628652E656E64436F6C756D6E3E652E7374617274436F6C756D6E297B636F6E737420743D7B72616E67653A652C2E2E2E6A7228695B315D292C73686F756C644265496E436F6D6D656E74733A21307D3B28742E746578747C7C742E68617353';
wwv_flow_imp.g_varchar2_table(2413) := '6570617261746F724C696E652926266E2E707573682874297D7D7D66756E6374696F6E206A722865297B636F6E737420743D28653D652E7472696D2829292E7374617274735769746828222D22293B72657475726E7B746578743A653D652E7265706C61';
wwv_flow_imp.g_varchar2_table(2414) := '63652857722C2222292C686173536570617261746F724C696E653A747D7D636C61737320477220657874656E6473204F747B6765742075726928297B72657475726E20746869732E5F7572697D67657420656F6C28297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(2415) := '656F6C7D67657456616C756528297B72657475726E20746869732E6765745465787428297D66696E644D6174636865732865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C746869732E5F6C696E65732E6C656E6774683B6E2B2B29';
wwv_flow_imp.g_varchar2_table(2416) := '7B636F6E737420693D746869732E5F6C696E65735B6E5D2C723D746869732E6F66667365744174286E6577204C74286E2B312C3129292C733D692E6D61746368416C6C2865293B666F7228636F6E73742065206F6620732928652E696E6465787C7C303D';
wwv_flow_imp.g_varchar2_table(2417) := '3D3D652E696E64657829262628652E696E6465783D652E696E6465782B72292C742E707573682865297D72657475726E20747D6765744C696E6573436F6E74656E7428297B72657475726E20746869732E5F6C696E65732E736C6963652830297D676574';
wwv_flow_imp.g_varchar2_table(2418) := '4C696E65436F756E7428297B72657475726E20746869732E5F6C696E65732E6C656E6774687D6765744C696E65436F6E74656E742865297B72657475726E20746869732E5F6C696E65735B652D315D7D676574576F72644174506F736974696F6E28652C';
wwv_flow_imp.g_varchar2_table(2419) := '74297B636F6E7374206E3D447428652E636F6C756D6E2C49742874292C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2C30293B72657475726E206E3F6E657720777428652E6C696E654E756D6265722C6E2E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(2420) := '6D6E2C652E6C696E654E756D6265722C6E2E656E64436F6C756D6E293A6E756C6C7D776F7264732865297B636F6E737420743D746869732E5F6C696E65732C6E3D746869732E5F776F7264656E697A652E62696E642874686973293B6C657420693D302C';
wwv_flow_imp.g_varchar2_table(2421) := '723D22222C733D302C6F3D5B5D3B72657475726E7B2A5B53796D626F6C2E6974657261746F725D28297B666F72283B3B29696628733C6F2E6C656E677468297B636F6E737420653D722E737562737472696E67286F5B735D2E73746172742C6F5B735D2E';
wwv_flow_imp.g_varchar2_table(2422) := '656E64293B732B3D312C7969656C6420657D656C73657B6966282128693C742E6C656E6774682929627265616B3B723D745B695D2C6F3D6E28722C65292C733D302C692B3D317D7D7D7D6765744C696E65576F72647328652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(2423) := '746869732E5F6C696E65735B652D315D2C693D746869732E5F776F7264656E697A65286E2C74292C723D5B5D3B666F7228636F6E73742065206F66206929722E70757368287B776F72643A6E2E737562737472696E6728652E73746172742C652E656E64';
wwv_flow_imp.g_varchar2_table(2424) := '292C7374617274436F6C756D6E3A652E73746172742B312C656E64436F6C756D6E3A652E656E642B317D293B72657475726E20727D5F776F7264656E697A6528652C74297B636F6E7374206E3D5B5D3B6C657420693B666F7228742E6C617374496E6465';
wwv_flow_imp.g_varchar2_table(2425) := '783D303B28693D742E6578656328652929262630213D3D695B305D2E6C656E6774683B296E2E70757368287B73746172743A692E696E6465782C656E643A692E696E6465782B695B305D2E6C656E6774687D293B72657475726E206E7D67657456616C75';
wwv_flow_imp.g_varchar2_table(2426) := '65496E52616E67652865297B69662828653D746869732E5F76616C696461746552616E6765286529292E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722972657475726E20746869732E5F6C696E65735B652E737461';
wwv_flow_imp.g_varchar2_table(2427) := '72744C696E654E756D6265722D315D2E737562737472696E6728652E7374617274436F6C756D6E2D312C652E656E64436F6C756D6E2D31293B636F6E737420743D746869732E5F656F6C2C6E3D652E73746172744C696E654E756D6265722D312C693D65';
wwv_flow_imp.g_varchar2_table(2428) := '2E656E644C696E654E756D6265722D312C723D5B5D3B722E7075736828746869732E5F6C696E65735B6E5D2E737562737472696E6728652E7374617274436F6C756D6E2D3129293B666F72286C657420653D6E2B313B653C693B652B2B29722E70757368';
wwv_flow_imp.g_varchar2_table(2429) := '28746869732E5F6C696E65735B655D293B72657475726E20722E7075736828746869732E5F6C696E65735B695D2E737562737472696E6728302C652E656E64436F6C756D6E2D3129292C722E6A6F696E2874297D6F666673657441742865297B72657475';
wwv_flow_imp.g_varchar2_table(2430) := '726E20653D746869732E5F76616C6964617465506F736974696F6E2865292C746869732E5F656E737572654C696E6553746172747328292C746869732E5F6C696E655374617274732E67657450726566697853756D28652E6C696E654E756D6265722D32';
wwv_flow_imp.g_varchar2_table(2431) := '292B28652E636F6C756D6E2D31297D706F736974696F6E41742865297B653D4D6174682E666C6F6F722865292C653D4D6174682E6D617828302C65292C746869732E5F656E737572654C696E6553746172747328293B636F6E737420743D746869732E5F';
wwv_flow_imp.g_varchar2_table(2432) := '6C696E655374617274732E676574496E6465784F662865292C6E3D746869732E5F6C696E65735B742E696E6465785D2E6C656E6774683B72657475726E7B6C696E654E756D6265723A312B742E696E6465782C636F6C756D6E3A312B4D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(2433) := '28742E72656D61696E6465722C6E297D7D5F76616C696461746552616E67652865297B636F6E737420743D746869732E5F76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E73746172744C696E654E756D6265722C636F6C75';
wwv_flow_imp.g_varchar2_table(2434) := '6D6E3A652E7374617274436F6C756D6E7D292C6E3D746869732E5F76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E656E644C696E654E756D6265722C636F6C756D6E3A652E656E64436F6C756D6E7D293B72657475726E20';
wwv_flow_imp.g_varchar2_table(2435) := '742E6C696E654E756D626572213D3D652E73746172744C696E654E756D6265727C7C742E636F6C756D6E213D3D652E7374617274436F6C756D6E7C7C6E2E6C696E654E756D626572213D3D652E656E644C696E654E756D6265727C7C6E2E636F6C756D6E';
wwv_flow_imp.g_varchar2_table(2436) := '213D3D652E656E64436F6C756D6E3F7B73746172744C696E654E756D6265723A742E6C696E654E756D6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C75';
wwv_flow_imp.g_varchar2_table(2437) := '6D6E3A6E2E636F6C756D6E7D3A657D5F76616C6964617465506F736974696F6E2865297B696628214C742E697349506F736974696F6E286529297468726F77206E6577204572726F72282262616420706F736974696F6E22293B6C65747B6C696E654E75';
wwv_flow_imp.g_varchar2_table(2438) := '6D6265723A742C636F6C756D6E3A6E7D3D652C693D21313B696628743C3129743D312C6E3D312C693D21303B656C736520696628743E746869732E5F6C696E65732E6C656E67746829743D746869732E5F6C696E65732E6C656E6774682C6E3D74686973';
wwv_flow_imp.g_varchar2_table(2439) := '2E5F6C696E65735B742D315D2E6C656E6774682B312C693D21303B656C73657B636F6E737420653D746869732E5F6C696E65735B742D315D2E6C656E6774682B313B6E3C313F286E3D312C693D2130293A6E3E652626286E3D652C693D2130297D726574';
wwv_flow_imp.g_varchar2_table(2440) := '75726E20693F7B6C696E654E756D6265723A742C636F6C756D6E3A6E7D3A657D7D636C6173732051727B636F6E7374727563746F7228652C74297B746869732E5F686F73743D652C746869732E5F6D6F64656C733D4F626A6563742E637265617465286E';
wwv_flow_imp.g_varchar2_table(2441) := '756C6C292C746869732E5F666F726569676E4D6F64756C65466163746F72793D742C746869732E5F666F726569676E4D6F64756C653D6E756C6C7D646973706F736528297B746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C';
wwv_flow_imp.g_varchar2_table(2442) := '297D5F6765744D6F64656C2865297B72657475726E20746869732E5F6D6F64656C735B655D7D5F6765744D6F64656C7328297B636F6E737420653D5B5D3B72657475726E204F626A6563742E6B65797328746869732E5F6D6F64656C73292E666F724561';
wwv_flow_imp.g_varchar2_table(2443) := '63682828743D3E652E7075736828746869732E5F6D6F64656C735B745D2929292C657D6163636570744E65774D6F64656C2865297B746869732E5F6D6F64656C735B652E75726C5D3D6E65772047722863742E706172736528652E75726C292C652E6C69';
wwv_flow_imp.g_varchar2_table(2444) := '6E65732C652E454F4C2C652E76657273696F6E4964297D6163636570744D6F64656C4368616E67656428652C74297B746869732E5F6D6F64656C735B655D2626746869732E5F6D6F64656C735B655D2E6F6E4576656E74732874297D6163636570745265';
wwv_flow_imp.g_varchar2_table(2445) := '6D6F7665644D6F64656C2865297B746869732E5F6D6F64656C735B655D262664656C65746520746869732E5F6D6F64656C735B655D7D6173796E6320636F6D70757465556E69636F6465486967686C696768747328652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(2446) := '746869732E5F6765744D6F64656C2865293B72657475726E20693F54692E636F6D70757465556E69636F6465486967686C696768747328692C742C6E293A7B72616E6765733A5B5D2C6861734D6F72653A21312C616D626967756F757343686172616374';
wwv_flow_imp.g_varchar2_table(2447) := '6572436F756E743A302C696E76697369626C65436861726163746572436F756E743A302C6E6F6E42617369634173636969436861726163746572436F756E743A307D7D6173796E632066696E6453656374696F6E4865616465727328652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(2448) := '7374206E3D746869732E5F6765744D6F64656C2865293B72657475726E206E3F66756E6374696F6E28652C74297B766172206E3B6C657420693D5B5D3B696628742E66696E64526567696F6E53656374696F6E486561646572732626286E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(2449) := '286E3D742E666F6C64696E6752756C6573297C7C766F696420303D3D3D6E3F766F696420303A6E2E6D61726B65727329297B636F6E7374206E3D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D2C693D652E6765744C696E65436F756E7428';
wwv_flow_imp.g_varchar2_table(2450) := '293B666F72286C657420723D313B723C3D693B722B2B297B636F6E737420693D652E6765744C696E65436F6E74656E742872292C733D692E6D6174636828742E666F6C64696E6752756C65732E6D61726B6572732E7374617274293B69662873297B636F';
wwv_flow_imp.g_varchar2_table(2451) := '6E737420653D7B73746172744C696E654E756D6265723A722C7374617274436F6C756D6E3A735B305D2E6C656E6774682B312C656E644C696E654E756D6265723A722C656E64436F6C756D6E3A692E6C656E6774682B317D3B696628652E656E64436F6C';
wwv_flow_imp.g_varchar2_table(2452) := '756D6E3E652E7374617274436F6C756D6E297B636F6E737420743D7B72616E67653A652C2E2E2E6A7228692E737562737472696E6728735B305D2E6C656E67746829292C73686F756C644265496E436F6D6D656E74733A21317D3B28742E746578747C7C';
wwv_flow_imp.g_varchar2_table(2453) := '742E686173536570617261746F724C696E652926266E2E707573682874297D7D7D72657475726E206E7D28652C74293B693D692E636F6E636174286E297D696628742E66696E644D61726B53656374696F6E48656164657273297B636F6E737420743D66';
wwv_flow_imp.g_varchar2_table(2454) := '756E6374696F6E2865297B636F6E737420743D5B5D2C6E3D652E6765744C696E65436F756E7428293B666F72286C657420693D313B693C3D6E3B692B2B29247228652E6765744C696E65436F6E74656E742869292C692C74293B72657475726E20747D28';
wwv_flow_imp.g_varchar2_table(2455) := '65293B693D692E636F6E6361742874297D72657475726E20697D286E2C74293A5B5D7D6173796E6320636F6D707574654469666628652C742C6E2C69297B636F6E737420723D746869732E5F6765744D6F64656C2865292C733D746869732E5F6765744D';
wwv_flow_imp.g_varchar2_table(2456) := '6F64656C2874293B72657475726E20722626733F51722E636F6D707574654469666628722C732C6E2C69293A6E756C6C7D73746174696320636F6D707574654469666628652C742C6E2C69297B636F6E737420723D22616476616E636564223D3D3D693F';
wwv_flow_imp.g_varchar2_table(2457) := '6E6577204D723A6E65772058692C733D652E6765744C696E6573436F6E74656E7428292C6F3D742E6765744C696E6573436F6E74656E7428292C613D722E636F6D707574654469666628732C6F2C6E293B66756E6374696F6E206C2865297B7265747572';
wwv_flow_imp.g_varchar2_table(2458) := '6E20652E6D61702828653D3E7B76617220743B72657475726E5B652E6F726967696E616C2E73746172744C696E654E756D6265722C652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6D6F6469666965642E7374';
wwv_flow_imp.g_varchar2_table(2459) := '6172744C696E654E756D6265722C652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6E756C6C3D3D3D28743D652E696E6E65724368616E676573297C7C766F696420303D3D3D743F766F696420303A742E6D61702828';
wwv_flow_imp.g_varchar2_table(2460) := '653D3E5B652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722C652E6F726967696E616C52616E67652E7374617274436F6C756D6E2C652E6F726967696E616C52616E67652E656E644C696E654E756D6265722C652E6F726967';
wwv_flow_imp.g_varchar2_table(2461) := '696E616C52616E67652E656E64436F6C756D6E2C652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2C652E6D6F64696669656452616E67652E656E644C';
wwv_flow_imp.g_varchar2_table(2462) := '696E654E756D6265722C652E6D6F64696669656452616E67652E656E64436F6C756D6E5D29295D7D29297D72657475726E7B6964656E746963616C3A2128612E6368616E6765732E6C656E6774683E30292626746869732E5F6D6F64656C734172654964';
wwv_flow_imp.g_varchar2_table(2463) := '656E746963616C28652C74292C717569744561726C793A612E68697454696D656F75742C6368616E6765733A6C28612E6368616E676573292C6D6F7665733A612E6D6F7665732E6D61702828653D3E5B652E6C696E6552616E67654D617070696E672E6F';
wwv_flow_imp.g_varchar2_table(2464) := '726967696E616C2E73746172744C696E654E756D6265722C652E6C696E6552616E67654D617070696E672E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6C696E6552616E67654D617070696E672E6D6F64696669';
wwv_flow_imp.g_varchar2_table(2465) := '65642E73746172744C696E654E756D6265722C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6C28652E6368616E676573295D29297D7D737461746963205F6D6F64656C';
wwv_flow_imp.g_varchar2_table(2466) := '734172654964656E746963616C28652C74297B636F6E7374206E3D652E6765744C696E65436F756E7428293B6966286E213D3D742E6765744C696E65436F756E7428292972657475726E21313B666F72286C657420693D313B693C3D6E3B692B2B296966';
wwv_flow_imp.g_varchar2_table(2467) := '28652E6765744C696E65436F6E74656E74286929213D3D742E6765744C696E65436F6E74656E742869292972657475726E21313B72657475726E21307D6173796E6320636F6D707574654D6F72654D696E696D616C456469747328652C742C6E297B636F';
wwv_flow_imp.g_varchar2_table(2468) := '6E737420693D746869732E5F6765744D6F64656C2865293B69662821692972657475726E20743B636F6E737420723D5B5D3B6C657420733B743D742E736C6963652830292E736F7274282828652C74293D3E652E72616E67652626742E72616E67653F77';
wwv_flow_imp.g_varchar2_table(2469) := '742E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E6765293A28652E72616E67653F303A31292D28742E72616E67653F303A312929293B6C6574206F3D303B666F72286C657420653D313B653C742E6C65';
wwv_flow_imp.g_varchar2_table(2470) := '6E6774683B652B2B2977742E676574456E64506F736974696F6E28745B6F5D2E72616E6765292E657175616C732877742E6765745374617274506F736974696F6E28745B655D2E72616E676529293F28745B6F5D2E72616E67653D77742E66726F6D506F';
wwv_flow_imp.g_varchar2_table(2471) := '736974696F6E732877742E6765745374617274506F736974696F6E28745B6F5D2E72616E6765292C77742E676574456E64506F736974696F6E28745B655D2E72616E676529292C745B6F5D2E746578742B3D745B655D2E74657874293A286F2B2B2C745B';
wwv_flow_imp.g_varchar2_table(2472) := '6F5D3D745B655D293B742E6C656E6774683D6F2B313B666F72286C65747B72616E67653A652C746578743A6F2C656F6C3A617D6F662074297B696628226E756D626572223D3D747970656F662061262628733D61292C77742E6973456D70747928652926';
wwv_flow_imp.g_varchar2_table(2473) := '26216F29636F6E74696E75653B636F6E737420743D692E67657456616C7565496E52616E67652865293B6966286F3D6F2E7265706C616365282F5C725C6E7C5C6E7C5C722F672C692E656F6C292C743D3D3D6F29636F6E74696E75653B6966284D617468';
wwv_flow_imp.g_varchar2_table(2474) := '2E6D6178286F2E6C656E6774682C742E6C656E677468293E51722E5F646966664C696D6974297B722E70757368287B72616E67653A652C746578743A6F7D293B636F6E74696E75657D636F6E7374206C3D506528742C6F2C6E292C753D692E6F66667365';
wwv_flow_imp.g_varchar2_table(2475) := '7441742877742E6C6966742865292E6765745374617274506F736974696F6E2829293B666F7228636F6E73742065206F66206C297B636F6E737420743D692E706F736974696F6E417428752B652E6F726967696E616C5374617274292C6E3D692E706F73';
wwv_flow_imp.g_varchar2_table(2476) := '6974696F6E417428752B652E6F726967696E616C53746172742B652E6F726967696E616C4C656E677468292C733D7B746578743A6F2E73756273747228652E6D6F64696669656453746172742C652E6D6F6469666965644C656E677468292C72616E6765';
wwv_flow_imp.g_varchar2_table(2477) := '3A7B73746172744C696E654E756D6265723A742E6C696E654E756D6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D7D3B';
wwv_flow_imp.g_varchar2_table(2478) := '692E67657456616C7565496E52616E676528732E72616E676529213D3D732E746578742626722E707573682873297D7D72657475726E226E756D626572223D3D747970656F6620732626722E70757368287B656F6C3A732C746578743A22222C72616E67';
wwv_flow_imp.g_varchar2_table(2479) := '653A7B73746172744C696E654E756D6265723A302C7374617274436F6C756D6E3A302C656E644C696E654E756D6265723A302C656E64436F6C756D6E3A307D7D292C727D6173796E6320636F6D707574654C696E6B732865297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(2480) := '69732E5F6765744D6F64656C2865293B72657475726E20743F66756E6374696F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F756E7426262266756E6374696F6E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(2481) := '20652E6765744C696E65436F6E74656E743F7A742E636F6D707574654C696E6B732865293A5B5D7D2874293A6E756C6C7D6173796E6320636F6D7075746544656661756C74446F63756D656E74436F6C6F72732865297B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(2482) := '5F6765744D6F64656C2865293B72657475726E20743F66756E6374696F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E67657456616C756526262266756E6374696F6E223D3D747970656F6620652E706F7369';
wwv_flow_imp.g_varchar2_table(2483) := '74696F6E41743F66756E6374696F6E2865297B636F6E737420743D5B5D2C6E3D7A7228652C2F5C62287267627C726762617C68736C7C68736C6129285C285B302D395C732C2E5C255D2A5C29297C282329285B412D46612D66302D395D7B337D295C627C';
wwv_flow_imp.g_varchar2_table(2484) := '282329285B412D46612D66302D395D7B347D295C627C282329285B412D46612D66302D395D7B367D295C627C282329285B412D46612D66302D395D7B387D295C622F676D293B6966286E2E6C656E6774683E3029666F7228636F6E73742069206F66206E';
wwv_flow_imp.g_varchar2_table(2485) := '297B636F6E7374206E3D692E66696C7465722828653D3E766F69642030213D3D6529292C723D6E5B315D2C733D6E5B325D3B696628217329636F6E74696E75653B6C6574206F3B69662822726762223D3D3D72297B636F6E737420743D2F5E5C285C732A';
wwv_flow_imp.g_varchar2_table(2486) := '2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D';
wwv_flow_imp.g_varchar2_table(2487) := '395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A5C29242F676D3B6F3D427228717228652C69292C7A7228732C74292C2131297D656C7365206966';
wwv_flow_imp.g_varchar2_table(2488) := '282272676261223D3D3D72297B636F6E737420743D2F5E5C285C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B30';
wwv_flow_imp.g_varchar2_table(2489) := '2D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A28305B2E5D5B30';
wwv_flow_imp.g_varchar2_table(2490) := '2D395D2B7C5B2E5D5B302D395D2B7C5B30315D5B2E5D7C5B30315D295C732A5C29242F676D3B6F3D427228717228652C69292C7A7228732C74292C2130297D656C7365206966282268736C223D3D3D72297B636F6E737420743D2F5E5C285C732A283336';
wwv_flow_imp.g_varchar2_table(2491) := '5B305D7C335B302D355D5B302D395D7C5B31325D5B302D395D5B302D395D7C5B312D395D3F5B302D395D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D';
wwv_flow_imp.g_varchar2_table(2492) := '5C642A7C5C647B312C327D29255C732A5C29242F676D3B6F3D557228717228652C69292C7A7228732C74292C2131297D656C7365206966282268736C61223D3D3D72297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D39';
wwv_flow_imp.g_varchar2_table(2493) := '5D7C5B31325D5B302D395D5B302D395D7C5B312D395D3F5B302D395D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C';
wwv_flow_imp.g_varchar2_table(2494) := '732A2C5C732A28305B2E5D5B302D395D2B7C5B2E5D5B302D395D2B7C5B30315D5B2E5D7C5B30315D295C732A5C29242F676D3B6F3D557228717228652C69292C7A7228732C74292C2130297D656C73652223223D3D3D722626286F3D567228717228652C';
wwv_flow_imp.g_varchar2_table(2495) := '69292C722B7329293B6F2626742E70757368286F297D72657475726E20747D2865293A5B5D7D2874293A6E756C6C7D6173796E63207465787475616C5375676765737428652C742C6E2C69297B636F6E737420723D6E657720432C733D6E657720526567';
wwv_flow_imp.g_varchar2_table(2496) := '457870286E2C69292C6F3D6E6577205365743B653A666F7228636F6E7374206E206F662065297B636F6E737420653D746869732E5F6765744D6F64656C286E293B6966286529666F7228636F6E7374206E206F6620652E776F726473287329296966286E';
wwv_flow_imp.g_varchar2_table(2497) := '213D3D74262669734E614E284E756D626572286E29292626286F2E616464286E292C6F2E73697A653E51722E5F73756767657374696F6E734C696D69742929627265616B20657D72657475726E7B776F7264733A41727261792E66726F6D286F292C6475';
wwv_flow_imp.g_varchar2_table(2498) := '726174696F6E3A722E656C617073656428297D7D6173796E6320636F6D70757465576F726452616E67657328652C742C6E2C69297B636F6E737420723D746869732E5F6765744D6F64656C2865293B69662821722972657475726E204F626A6563742E63';
wwv_flow_imp.g_varchar2_table(2499) := '7265617465286E756C6C293B636F6E737420733D6E657720526567457870286E2C69292C6F3D4F626A6563742E637265617465286E756C6C293B666F72286C657420653D742E73746172744C696E654E756D6265723B653C742E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(2500) := '6265723B652B2B297B636F6E737420743D722E6765744C696E65576F72647328652C73293B666F7228636F6E7374206E206F662074297B6966282169734E614E284E756D626572286E2E776F7264292929636F6E74696E75653B6C657420743D6F5B6E2E';
wwv_flow_imp.g_varchar2_table(2501) := '776F72645D3B747C7C28743D5B5D2C6F5B6E2E776F72645D3D74292C742E70757368287B73746172744C696E654E756D6265723A652C7374617274436F6C756D6E3A6E2E7374617274436F6C756D6E2C656E644C696E654E756D6265723A652C656E6443';
wwv_flow_imp.g_varchar2_table(2502) := '6F6C756D6E3A6E2E656E64436F6C756D6E7D297D7D72657475726E206F7D6173796E63206E6176696761746556616C756553657428652C742C6E2C692C72297B636F6E737420733D746869732E5F6765744D6F64656C2865293B69662821732972657475';
wwv_flow_imp.g_varchar2_table(2503) := '726E206E756C6C3B636F6E7374206F3D6E65772052656745787028692C72293B742E7374617274436F6C756D6E3D3D3D742E656E64436F6C756D6E262628743D7B73746172744C696E654E756D6265723A742E73746172744C696E654E756D6265722C73';
wwv_flow_imp.g_varchar2_table(2504) := '74617274436F6C756D6E3A742E7374617274436F6C756D6E2C656E644C696E654E756D6265723A742E656E644C696E654E756D6265722C656E64436F6C756D6E3A742E656E64436F6C756D6E2B317D293B636F6E737420613D732E67657456616C756549';
wwv_flow_imp.g_varchar2_table(2505) := '6E52616E67652874292C6C3D732E676574576F72644174506F736974696F6E287B6C696E654E756D6265723A742E73746172744C696E654E756D6265722C636F6C756D6E3A742E7374617274436F6C756D6E7D2C6F293B696628216C2972657475726E20';
wwv_flow_imp.g_varchar2_table(2506) := '6E756C6C3B636F6E737420753D732E67657456616C7565496E52616E6765286C293B72657475726E2048742E494E5354414E43452E6E6176696761746556616C756553657428742C612C6C2C752C6E297D6C6F6164466F726569676E4D6F64756C652865';
wwv_flow_imp.g_varchar2_table(2507) := '2C742C6E297B636F6E737420693D66756E6374696F6E28652C74297B636F6E7374206E3D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B7265';
wwv_flow_imp.g_varchar2_table(2508) := '7475726E207428652C6E297D2C693D7B7D3B666F7228636F6E73742074206F66206529695B745D3D6E2874293B72657475726E20697D286E2C2828652C74293D3E746869732E5F686F73742E66687228652C742929292C723D7B686F73743A692C676574';
wwv_flow_imp.g_varchar2_table(2509) := '4D6972726F724D6F64656C733A28293D3E746869732E5F6765744D6F64656C7328297D3B72657475726E20746869732E5F666F726569676E4D6F64756C65466163746F72793F28746869732E5F666F726569676E4D6F64756C653D746869732E5F666F72';
wwv_flow_imp.g_varchar2_table(2510) := '6569676E4D6F64756C65466163746F727928722C74292C50726F6D6973652E7265736F6C7665284128746869732E5F666F726569676E4D6F64756C652929293A50726F6D6973652E72656A656374286E6577204572726F722822556E6578706563746564';
wwv_flow_imp.g_varchar2_table(2511) := '2075736167652229297D666D7228652C74297B69662821746869732E5F666F726569676E4D6F64756C657C7C2266756E6374696F6E22213D747970656F6620746869732E5F666F726569676E4D6F64756C655B655D2972657475726E2050726F6D697365';
wwv_flow_imp.g_varchar2_table(2512) := '2E72656A656374286E6577204572726F7228224D697373696E67207265717565737448616E646C6572206F72206D6574686F643A20222B6529293B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F666F726569676E4D';
wwv_flow_imp.g_varchar2_table(2513) := '6F64756C655B655D2E6170706C7928746869732E5F666F726569676E4D6F64756C652C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D7D51722E5F646966664C696D69743D3165352C51722E5F737567';
wwv_flow_imp.g_varchar2_table(2514) := '67657374696F6E734C696D69743D3165342C2266756E6374696F6E223D3D747970656F6620696D706F727453637269707473262628676C6F62616C546869732E6D6F6E61636F3D7B656469746F723A766F696420302C6C616E6775616765733A766F6964';
wwv_flow_imp.g_varchar2_table(2515) := '20302C43616E63656C6C6174696F6E546F6B656E536F757263653A636C6173737B636F6E7374727563746F722865297B746869732E5F746F6B656E3D766F696420302C746869732E5F706172656E744C697374656E65723D766F696420302C746869732E';
wwv_flow_imp.g_varchar2_table(2516) := '5F706172656E744C697374656E65723D652626652E6F6E43616E63656C6C6174696F6E52657175657374656428746869732E63616E63656C2C74686973297D67657420746F6B656E28297B72657475726E20746869732E5F746F6B656E7C7C2874686973';
wwv_flow_imp.g_varchar2_table(2517) := '2E5F746F6B656E3D6E6577206A74292C746869732E5F746F6B656E7D63616E63656C28297B746869732E5F746F6B656E3F746869732E5F746F6B656E20696E7374616E63656F66206A742626746869732E5F746F6B656E2E63616E63656C28293A746869';
wwv_flow_imp.g_varchar2_table(2518) := '732E5F746F6B656E3D24742E43616E63656C6C65647D646973706F736528653D2131297B76617220743B652626746869732E63616E63656C28292C6E756C6C3D3D3D28743D746869732E5F706172656E744C697374656E6572297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(2519) := '3D747C7C742E646973706F736528292C746869732E5F746F6B656E3F746869732E5F746F6B656E20696E7374616E63656F66206A742626746869732E5F746F6B656E2E646973706F736528293A746869732E5F746F6B656E3D24742E4E6F6E657D7D2C45';
wwv_flow_imp.g_varchar2_table(2520) := '6D69747465723A532C4B6579436F64653A576E2C4B65794D6F643A4C692C506F736974696F6E3A4C742C52616E67653A77742C53656C656374696F6E3A616E2C53656C656374696F6E446972656374696F6E3A61692C4D61726B65725365766572697479';
wwv_flow_imp.g_varchar2_table(2521) := '3A246E2C4D61726B65725461673A6A6E2C5572693A63742C546F6B656E3A636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E6F66667365743D652C746869732E747970653D742C746869732E6C616E67756167653D6E2C746869';
wwv_flow_imp.g_varchar2_table(2522) := '732E5F746F6B656E4272616E643D766F696420307D746F537472696E6728297B72657475726E2228222B746869732E6F66667365742B222C20222B746869732E747970652B2229227D7D7D293B6C65742058723D21313B676C6F62616C546869732E6F6E';
wwv_flow_imp.g_varchar2_table(2523) := '6D6573736167653D653D3E7B58727C7C66756E6374696F6E28297B69662858722972657475726E3B58723D21303B636F6E737420653D6E65772053652828653D3E7B676C6F62616C546869732E706F73744D6573736167652865297D292C28653D3E6E65';
wwv_flow_imp.g_varchar2_table(2524) := '7720517228652C6E756C6C2929293B676C6F62616C546869732E6F6E6D6573736167653D743D3E7B652E6F6E6D65737361676528742E64617461297D7D28297D7D2928293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5450022707531700)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/editor.worker.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C65617365207365652068746D6C2E776F726B65722E6A732E4C4943454E53452E747874202A2F0A2828293D3E7B2275736520737472696374223B636F6E737420653D6E657720';
wwv_flow_imp.g_varchar2_table(2) := '636C6173737B636F6E7374727563746F7228297B746869732E6C697374656E6572733D5B5D2C746869732E756E65787065637465644572726F7248616E646C65723D66756E6374696F6E2865297B73657454696D656F7574282828293D3E7B696628652E';
wwv_flow_imp.g_varchar2_table(3) := '737461636B297B6966286F2E69734572726F724E6F54656C656D65747279286529297468726F77206E6577206F28652E6D6573736167652B225C6E5C6E222B652E737461636B293B7468726F77206E6577204572726F7228652E6D6573736167652B225C';
wwv_flow_imp.g_varchar2_table(4) := '6E5C6E222B652E737461636B297D7468726F7720657D292C30297D7D656D69742865297B746869732E6C697374656E6572732E666F72456163682828743D3E7B742865297D29297D6F6E556E65787065637465644572726F722865297B746869732E756E';
wwv_flow_imp.g_varchar2_table(5) := '65787065637465644572726F7248616E646C65722865292C746869732E656D69742865297D6F6E556E657870656374656445787465726E616C4572726F722865297B746869732E756E65787065637465644572726F7248616E646C65722865297D7D3B66';
wwv_flow_imp.g_varchar2_table(6) := '756E6374696F6E20742874297B766172206E3B286E3D7429696E7374616E63656F6620727C7C6E20696E7374616E63656F66204572726F7226266E2E6E616D653D3D3D6926266E2E6D6573736167653D3D3D697C7C652E6F6E556E657870656374656445';
wwv_flow_imp.g_varchar2_table(7) := '72726F722874297D66756E6374696F6E206E2865297B6966286520696E7374616E63656F66204572726F72297B636F6E73747B6E616D653A742C6D6573736167653A6E7D3D653B72657475726E7B2469734572726F723A21302C6E616D653A742C6D6573';
wwv_flow_imp.g_varchar2_table(8) := '736167653A6E2C737461636B3A652E737461636B74726163657C7C652E737461636B2C6E6F54656C656D657472793A6F2E69734572726F724E6F54656C656D657472792865297D7D72657475726E20657D636F6E737420693D2243616E63656C6564223B';
wwv_flow_imp.g_varchar2_table(9) := '636C617373207220657874656E6473204572726F727B636F6E7374727563746F7228297B73757065722869292C746869732E6E616D653D746869732E6D6573736167657D7D4572726F723B636C617373206F20657874656E6473204572726F727B636F6E';
wwv_flow_imp.g_varchar2_table(10) := '7374727563746F722865297B73757065722865292C746869732E6E616D653D22436F646545787065637465644572726F72227D7374617469632066726F6D4572726F722865297B6966286520696E7374616E63656F66206F2972657475726E20653B636F';
wwv_flow_imp.g_varchar2_table(11) := '6E737420743D6E6577206F3B72657475726E20742E6D6573736167653D652E6D6573736167652C742E737461636B3D652E737461636B2C747D7374617469632069734572726F724E6F54656C656D657472792865297B72657475726E22436F6465457870';
wwv_flow_imp.g_varchar2_table(12) := '65637465644572726F72223D3D3D652E6E616D657D7D636C617373206120657874656E6473204572726F727B636F6E7374727563746F722865297B737570657228657C7C22416E20756E657870656374656420627567206F636375727265642E22292C4F';
wwv_flow_imp.g_varchar2_table(13) := '626A6563742E73657450726F746F747970654F6628746869732C612E70726F746F74797065297D7D66756E6374696F6E207328652C74297B636F6E7374206E3D746869733B6C657420692C723D21313B72657475726E2066756E6374696F6E28297B6966';
wwv_flow_imp.g_varchar2_table(14) := '28722972657475726E20693B696628723D21302C74297472797B693D652E6170706C79286E2C617267756D656E7473297D66696E616C6C797B7428297D656C736520693D652E6170706C79286E2C617267756D656E7473293B72657475726E20697D7D76';
wwv_flow_imp.g_varchar2_table(15) := '6172206C3B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E20652626226F626A656374223D3D747970656F66206526262266756E6374696F6E223D3D747970656F6620655B53796D626F6C2E6974657261746F725D7D';
wwv_flow_imp.g_varchar2_table(16) := '652E69733D743B636F6E7374206E3D4F626A6563742E667265657A65285B5D293B66756E6374696F6E2A692865297B7969656C6420657D652E656D7074793D66756E6374696F6E28297B72657475726E206E7D2C652E73696E676C653D692C652E777261';
wwv_flow_imp.g_varchar2_table(17) := '703D66756E6374696F6E2865297B72657475726E20742865293F653A692865297D2C652E66726F6D3D66756E6374696F6E2865297B72657475726E20657C7C6E7D2C652E726576657273653D66756E6374696F6E2A2865297B666F72286C657420743D65';
wwv_flow_imp.g_varchar2_table(18) := '2E6C656E6774682D313B743E3D303B742D2D297969656C6420655B745D7D2C652E6973456D7074793D66756E6374696F6E2865297B72657475726E21657C7C21303D3D3D655B53796D626F6C2E6974657261746F725D28292E6E65787428292E646F6E65';
wwv_flow_imp.g_varchar2_table(19) := '7D2C652E66697273743D66756E6374696F6E2865297B72657475726E20655B53796D626F6C2E6974657261746F725D28292E6E65787428292E76616C75657D2C652E736F6D653D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F6620';
wwv_flow_imp.g_varchar2_table(20) := '652969662874286E292972657475726E21303B72657475726E21317D2C652E66696E643D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F6620652969662874286E292972657475726E206E7D2C652E66696C7465723D66756E637469';
wwv_flow_imp.g_varchar2_table(21) := '6F6E2A28652C74297B666F7228636F6E7374206E206F6620652974286E292626287969656C64206E297D2C652E6D61703D66756E6374696F6E2A28652C74297B6C6574206E3D303B666F7228636F6E73742069206F662065297969656C64207428692C6E';
wwv_flow_imp.g_varchar2_table(22) := '2B2B297D2C652E636F6E6361743D66756E6374696F6E2A282E2E2E65297B666F7228636F6E73742074206F662065297969656C642A747D2C652E7265647563653D66756E6374696F6E28652C742C6E297B6C657420693D6E3B666F7228636F6E7374206E';
wwv_flow_imp.g_varchar2_table(23) := '206F66206529693D7428692C6E293B72657475726E20697D2C652E736C6963653D66756E6374696F6E2A28652C742C6E3D652E6C656E677468297B666F7228743C30262628742B3D652E6C656E677468292C6E3C303F6E2B3D652E6C656E6774683A6E3E';
wwv_flow_imp.g_varchar2_table(24) := '652E6C656E6774682626286E3D652E6C656E677468293B743C6E3B742B2B297969656C6420655B745D7D2C652E636F6E73756D653D66756E6374696F6E28742C6E3D4E756D6265722E504F5349544956455F494E46494E495459297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(25) := '5B5D3B696628303D3D3D6E2972657475726E5B692C745D3B636F6E737420723D745B53796D626F6C2E6974657261746F725D28293B666F72286C657420743D303B743C6E3B742B2B297B636F6E737420743D722E6E65787428293B696628742E646F6E65';
wwv_flow_imp.g_varchar2_table(26) := '2972657475726E5B692C652E656D70747928295D3B692E7075736828742E76616C7565297D72657475726E5B692C7B5B53796D626F6C2E6974657261746F725D3A28293D3E727D5D7D2C652E6173796E63546F41727261793D6173796E632066756E6374';
wwv_flow_imp.g_varchar2_table(27) := '696F6E2865297B636F6E737420743D5B5D3B666F7220617761697428636F6E7374206E206F66206529742E70757368286E293B72657475726E2050726F6D6973652E7265736F6C76652874297D7D286C7C7C286C3D7B7D29293B6C657420683D6E756C6C';
wwv_flow_imp.g_varchar2_table(28) := '3B66756E6374696F6E20632865297B72657475726E206E756C6C3D3D687C7C682E747261636B446973706F7361626C652865292C657D66756E6374696F6E20642865297B6E756C6C3D3D687C7C682E6D61726B4173446973706F7365642865297D66756E';
wwv_flow_imp.g_varchar2_table(29) := '6374696F6E207528652C74297B6E756C6C3D3D687C7C682E736574506172656E7428652C74297D66756E6374696F6E206D2865297B6966286C2E6973286529297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065296966286E297472';
wwv_flow_imp.g_varchar2_table(30) := '797B6E2E646973706F736528297D63617463682865297B742E707573682865297D696628313D3D3D742E6C656E677468297468726F7720745B305D3B696628742E6C656E6774683E31297468726F77206E6577204167677265676174654572726F722874';
wwv_flow_imp.g_varchar2_table(31) := '2C22456E636F756E7465726564206572726F7273207768696C6520646973706F73696E67206F662073746F726522293B72657475726E2041727261792E697341727261792865293F5B5D3A657D696628652972657475726E20652E646973706F73652829';
wwv_flow_imp.g_varchar2_table(32) := '2C657D66756E6374696F6E20702865297B636F6E737420743D63287B646973706F73653A73282828293D3E7B642874292C6528297D29297D293B72657475726E20747D636C61737320667B636F6E7374727563746F7228297B746869732E5F746F446973';
wwv_flow_imp.g_varchar2_table(33) := '706F73653D6E6577205365742C746869732E5F6973446973706F7365643D21312C632874686973297D646973706F736528297B746869732E5F6973446973706F7365647C7C28642874686973292C746869732E5F6973446973706F7365643D21302C7468';
wwv_flow_imp.g_varchar2_table(34) := '69732E636C6561722829297D676574206973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D636C65617228297B69662830213D3D746869732E5F746F446973706F73652E73697A65297472797B6D28746869732E';
wwv_flow_imp.g_varchar2_table(35) := '5F746F446973706F7365297D66696E616C6C797B746869732E5F746F446973706F73652E636C65617228297D7D6164642865297B69662821652972657475726E20653B696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E';
wwv_flow_imp.g_varchar2_table(36) := '6F74207265676973746572206120646973706F7361626C65206F6E20697473656C662122293B72657475726E207528652C74686973292C746869732E5F6973446973706F7365643F662E44495341424C455F444953504F5345445F5741524E494E477C7C';
wwv_flow_imp.g_varchar2_table(37) := '636F6E736F6C652E7761726E286E6577204572726F722822547279696E6720746F20616464206120646973706F7361626C6520746F206120446973706F7361626C6553746F726520746861742068617320616C7265616479206265656E20646973706F73';
wwv_flow_imp.g_varchar2_table(38) := '6564206F662E20546865206164646564206F626A6563742077696C6C206265206C65616B65642122292E737461636B293A746869732E5F746F446973706F73652E6164642865292C657D64656C657465416E644C65616B2865297B652626746869732E5F';
wwv_flow_imp.g_varchar2_table(39) := '746F446973706F73652E686173286529262628746869732E5F746F446973706F73652E64656C6574652865292C7528652C6E756C6C29297D7D662E44495341424C455F444953504F5345445F5741524E494E473D21313B636C61737320677B636F6E7374';
wwv_flow_imp.g_varchar2_table(40) := '727563746F7228297B746869732E5F73746F72653D6E657720662C632874686973292C7528746869732E5F73746F72652C74686973297D646973706F736528297B642874686973292C746869732E5F73746F72652E646973706F736528297D5F72656769';
wwv_flow_imp.g_varchar2_table(41) := '737465722865297B696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E6F74207265676973746572206120646973706F7361626C65206F6E20697473656C662122293B72657475726E20746869732E5F73746F72652E6164';
wwv_flow_imp.g_varchar2_table(42) := '642865297D7D672E4E6F6E653D4F626A6563742E667265657A65287B646973706F736528297B7D7D292C53796D626F6C2E6974657261746F723B636C61737320627B636F6E7374727563746F722865297B746869732E656C656D656E743D652C74686973';
wwv_flow_imp.g_varchar2_table(43) := '2E6E6578743D622E556E646566696E65642C746869732E707265763D622E556E646566696E65647D7D622E556E646566696E65643D6E6577206228766F69642030293B636C617373205F7B636F6E7374727563746F7228297B746869732E5F6669727374';
wwv_flow_imp.g_varchar2_table(44) := '3D622E556E646566696E65642C746869732E5F6C6173743D622E556E646566696E65642C746869732E5F73697A653D307D6765742073697A6528297B72657475726E20746869732E5F73697A657D6973456D70747928297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(45) := '5F66697273743D3D3D622E556E646566696E65647D636C65617228297B6C657420653D746869732E5F66697273743B666F72283B65213D3D622E556E646566696E65643B297B636F6E737420743D652E6E6578743B652E707265763D622E556E64656669';
wwv_flow_imp.g_varchar2_table(46) := '6E65642C652E6E6578743D622E556E646566696E65642C653D747D746869732E5F66697273743D622E556E646566696E65642C746869732E5F6C6173743D622E556E646566696E65642C746869732E5F73697A653D307D756E73686966742865297B7265';
wwv_flow_imp.g_varchar2_table(47) := '7475726E20746869732E5F696E7365727428652C2131297D707573682865297B72657475726E20746869732E5F696E7365727428652C2130297D5F696E7365727428652C74297B636F6E7374206E3D6E657720622865293B696628746869732E5F666972';
wwv_flow_imp.g_varchar2_table(48) := '73743D3D3D622E556E646566696E656429746869732E5F66697273743D6E2C746869732E5F6C6173743D6E3B656C73652069662874297B636F6E737420653D746869732E5F6C6173743B746869732E5F6C6173743D6E2C6E2E707265763D652C652E6E65';
wwv_flow_imp.g_varchar2_table(49) := '78743D6E7D656C73657B636F6E737420653D746869732E5F66697273743B746869732E5F66697273743D6E2C6E2E6E6578743D652C652E707265763D6E7D746869732E5F73697A652B3D313B6C657420693D21313B72657475726E28293D3E7B697C7C28';
wwv_flow_imp.g_varchar2_table(50) := '693D21302C746869732E5F72656D6F7665286E29297D7D736869667428297B696628746869732E5F6669727374213D3D622E556E646566696E6564297B636F6E737420653D746869732E5F66697273742E656C656D656E743B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(51) := '2E5F72656D6F766528746869732E5F6669727374292C657D7D706F7028297B696628746869732E5F6C617374213D3D622E556E646566696E6564297B636F6E737420653D746869732E5F6C6173742E656C656D656E743B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(52) := '72656D6F766528746869732E5F6C617374292C657D7D5F72656D6F76652865297B696628652E70726576213D3D622E556E646566696E65642626652E6E657874213D3D622E556E646566696E6564297B636F6E737420743D652E707265763B742E6E6578';
wwv_flow_imp.g_varchar2_table(53) := '743D652E6E6578742C652E6E6578742E707265763D747D656C736520652E707265763D3D3D622E556E646566696E65642626652E6E6578743D3D3D622E556E646566696E65643F28746869732E5F66697273743D622E556E646566696E65642C74686973';
wwv_flow_imp.g_varchar2_table(54) := '2E5F6C6173743D622E556E646566696E6564293A652E6E6578743D3D3D622E556E646566696E65643F28746869732E5F6C6173743D746869732E5F6C6173742E707265762C746869732E5F6C6173742E6E6578743D622E556E646566696E6564293A652E';
wwv_flow_imp.g_varchar2_table(55) := '707265763D3D3D622E556E646566696E6564262628746869732E5F66697273743D746869732E5F66697273742E6E6578742C746869732E5F66697273742E707265763D622E556E646566696E6564293B746869732E5F73697A652D3D317D2A5B53796D62';
wwv_flow_imp.g_varchar2_table(56) := '6F6C2E6974657261746F725D28297B6C657420653D746869732E5F66697273743B666F72283B65213D3D622E556E646566696E65643B297969656C6420652E656C656D656E742C653D652E6E6578747D7D636F6E737420763D676C6F62616C546869732E';
wwv_flow_imp.g_varchar2_table(57) := '706572666F726D616E636526262266756E6374696F6E223D3D747970656F6620676C6F62616C546869732E706572666F726D616E63652E6E6F773B636C61737320777B737461746963206372656174652865297B72657475726E206E657720772865297D';
wwv_flow_imp.g_varchar2_table(58) := '636F6E7374727563746F722865297B746869732E5F6E6F773D76262621313D3D3D653F446174652E6E6F773A676C6F62616C546869732E706572666F726D616E63652E6E6F772E62696E6428676C6F62616C546869732E706572666F726D616E6365292C';
wwv_flow_imp.g_varchar2_table(59) := '746869732E5F737461727454696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D73746F7028297B746869732E5F73746F7054696D653D746869732E5F6E6F7728297D726573657428297B746869732E5F737461727454';
wwv_flow_imp.g_varchar2_table(60) := '696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D656C617073656428297B72657475726E2D31213D3D746869732E5F73746F7054696D653F746869732E5F73746F7054696D652D746869732E5F737461727454696D65';
wwv_flow_imp.g_varchar2_table(61) := '3A746869732E5F6E6F7728292D746869732E5F737461727454696D657D7D76617220793B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E28742C6E3D6E756C6C2C69293D3E7B6C657420722C6F3D21313B7265747572';
wwv_flow_imp.g_varchar2_table(62) := '6E20723D652828653D3E7B696628216F2972657475726E20723F722E646973706F736528293A6F3D21302C742E63616C6C286E2C65297D292C6E756C6C2C69292C6F2626722E646973706F736528292C727D7D66756E6374696F6E206E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(63) := '7B72657475726E20722828286E2C693D6E756C6C2C72293D3E652828653D3E6E2E63616C6C28692C7428652929292C6E756C6C2C7229292C6E297D66756E6374696F6E206928652C742C6E297B72657475726E20722828286E2C693D6E756C6C2C72293D';
wwv_flow_imp.g_varchar2_table(64) := '3E652828653D3E7428652926266E2E63616C6C28692C6529292C6E756C6C2C7229292C6E297D66756E6374696F6E207228652C74297B6C6574206E3B636F6E737420693D6E6577204C287B6F6E57696C6C41646446697273744C697374656E657228297B';
wwv_flow_imp.g_varchar2_table(65) := '6E3D6528692E666972652C69297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B6E756C6C3D3D6E7C7C6E2E646973706F736528297D7D293B72657475726E206E756C6C3D3D747C7C742E6164642869292C692E6576656E747D6675';
wwv_flow_imp.g_varchar2_table(66) := '6E6374696F6E206F28652C742C6E3D3130302C693D21312C723D21312C6F2C61297B6C657420732C6C2C682C632C643D303B636F6E737420753D6E6577204C287B6C65616B5761726E696E675468726573686F6C643A6F2C6F6E57696C6C416464466972';
wwv_flow_imp.g_varchar2_table(67) := '73744C697374656E657228297B733D652828653D3E7B642B2B2C6C3D74286C2C65292C6926262168262628752E66697265286C292C6C3D766F69642030292C633D28293D3E7B636F6E737420653D6C3B6C3D766F696420302C683D766F696420302C2821';
wwv_flow_imp.g_varchar2_table(68) := '697C7C643E31292626752E666972652865292C643D307D2C226E756D626572223D3D747970656F66206E3F28636C65617254696D656F75742868292C683D73657454696D656F757428632C6E29293A766F696420303D3D3D68262628683D302C71756575';
wwv_flow_imp.g_varchar2_table(69) := '654D6963726F7461736B286329297D29297D2C6F6E57696C6C52656D6F76654C697374656E657228297B722626643E302626286E756C6C3D3D637C7C632829297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B633D766F69642030';
wwv_flow_imp.g_varchar2_table(70) := '2C732E646973706F736528297D7D293B72657475726E206E756C6C3D3D617C7C612E6164642875292C752E6576656E747D652E4E6F6E653D28293D3E672E4E6F6E652C652E64656665723D66756E6374696F6E28652C74297B72657475726E206F28652C';
wwv_flow_imp.g_varchar2_table(71) := '2828293D3E7B7D292C302C766F696420302C21302C766F696420302C74297D2C652E6F6E63653D742C652E6D61703D6E2C652E666F72456163683D66756E6374696F6E28652C742C6E297B72657475726E20722828286E2C693D6E756C6C2C72293D3E65';
wwv_flow_imp.g_varchar2_table(72) := '2828653D3E7B742865292C6E2E63616C6C28692C65297D292C6E756C6C2C7229292C6E297D2C652E66696C7465723D692C652E7369676E616C3D66756E6374696F6E2865297B72657475726E20657D2C652E616E793D66756E6374696F6E282E2E2E6529';
wwv_flow_imp.g_varchar2_table(73) := '7B72657475726E28742C6E3D6E756C6C2C69293D3E7B72657475726E20723D66756E6374696F6E282E2E2E65297B636F6E737420743D70282828293D3E6D28652929293B72657475726E2066756E6374696F6E28652C74297B6966286829666F7228636F';
wwv_flow_imp.g_varchar2_table(74) := '6E7374206E206F66206529682E736574506172656E74286E2C74297D28652C74292C747D282E2E2E652E6D61702828653D3E652828653D3E742E63616C6C286E2C652929292929292C286F3D6929696E7374616E63656F662041727261793F6F2E707573';
wwv_flow_imp.g_varchar2_table(75) := '682872293A6F26266F2E6164642872292C723B76617220722C6F7D7D2C652E7265647563653D66756E6374696F6E28652C742C692C72297B6C6574206F3D693B72657475726E206E28652C28653D3E286F3D74286F2C65292C6F29292C72297D2C652E64';
wwv_flow_imp.g_varchar2_table(76) := '65626F756E63653D6F2C652E616363756D756C6174653D66756E6374696F6E28742C6E3D302C69297B72657475726E20652E6465626F756E636528742C2828652C74293D3E653F28652E707573682874292C65293A5B745D292C6E2C766F696420302C21';
wwv_flow_imp.g_varchar2_table(77) := '302C766F696420302C69297D2C652E6C617463683D66756E6374696F6E28652C743D28652C74293D3E653D3D3D742C6E297B6C657420722C6F3D21303B72657475726E206928652C28653D3E7B636F6E7374206E3D6F7C7C217428652C72293B72657475';
wwv_flow_imp.g_varchar2_table(78) := '726E206F3D21312C723D652C6E7D292C6E297D2C652E73706C69743D66756E6374696F6E28742C6E2C69297B72657475726E5B652E66696C74657228742C6E2C69292C652E66696C74657228742C28653D3E216E286529292C69295D7D2C652E62756666';
wwv_flow_imp.g_varchar2_table(79) := '65723D66756E6374696F6E28652C743D21312C6E3D5B5D2C69297B6C657420723D6E2E736C69636528292C6F3D652828653D3E7B723F722E707573682865293A732E666972652865297D29293B692626692E616464286F293B636F6E737420613D28293D';
wwv_flow_imp.g_varchar2_table(80) := '3E7B6E756C6C3D3D727C7C722E666F72456163682828653D3E732E6669726528652929292C723D6E756C6C7D2C733D6E6577204C287B6F6E57696C6C41646446697273744C697374656E657228297B6F7C7C286F3D652828653D3E732E66697265286529';
wwv_flow_imp.g_varchar2_table(81) := '29292C692626692E616464286F29297D2C6F6E44696441646446697273744C697374656E657228297B72262628743F73657454696D656F75742861293A612829297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B6F26266F2E6469';
wwv_flow_imp.g_varchar2_table(82) := '73706F736528292C6F3D6E756C6C7D7D293B72657475726E20692626692E6164642873292C732E6576656E747D2C652E636861696E3D66756E6374696F6E28652C74297B72657475726E286E2C692C72293D3E7B636F6E7374206F3D74286E6577207329';
wwv_flow_imp.g_varchar2_table(83) := '3B72657475726E2065282866756E6374696F6E2865297B636F6E737420743D6F2E6576616C756174652865293B74213D3D6126266E2E63616C6C28692C74297D292C766F696420302C72297D7D3B636F6E737420613D53796D626F6C282248616C744368';
wwv_flow_imp.g_varchar2_table(84) := '61696E61626C6522293B636C61737320737B636F6E7374727563746F7228297B746869732E73746570733D5B5D7D6D61702865297B72657475726E20746869732E73746570732E707573682865292C746869737D666F72456163682865297B7265747572';
wwv_flow_imp.g_varchar2_table(85) := '6E20746869732E73746570732E707573682828743D3E28652874292C742929292C746869737D66696C7465722865297B72657475726E20746869732E73746570732E707573682828743D3E652874293F743A6129292C746869737D72656475636528652C';
wwv_flow_imp.g_varchar2_table(86) := '74297B6C6574206E3D743B72657475726E20746869732E73746570732E707573682828743D3E286E3D65286E2C74292C6E2929292C746869737D6C6174636828653D28652C74293D3E653D3D3D74297B6C657420742C6E3D21303B72657475726E207468';
wwv_flow_imp.g_varchar2_table(87) := '69732E73746570732E707573682828693D3E7B636F6E737420723D6E7C7C216528692C74293B72657475726E206E3D21312C743D692C723F693A617D29292C746869737D6576616C756174652865297B666F7228636F6E73742074206F6620746869732E';
wwv_flow_imp.g_varchar2_table(88) := '73746570732969662828653D74286529293D3D3D6129627265616B3B72657475726E20657D7D652E66726F6D4E6F64654576656E74456D69747465723D66756E6374696F6E28652C742C6E3D653D3E65297B636F6E737420693D282E2E2E65293D3E722E';
wwv_flow_imp.g_varchar2_table(89) := '66697265286E282E2E2E6529292C723D6E6577204C287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6F6E28742C69292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F76654C697374';
wwv_flow_imp.g_varchar2_table(90) := '656E657228742C69297D293B72657475726E20722E6576656E747D2C652E66726F6D444F4D4576656E74456D69747465723D66756E6374696F6E28652C742C6E3D653D3E65297B636F6E737420693D282E2E2E65293D3E722E66697265286E282E2E2E65';
wwv_flow_imp.g_varchar2_table(91) := '29292C723D6E6577204C287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6164644576656E744C697374656E657228742C69292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F766545';
wwv_flow_imp.g_varchar2_table(92) := '76656E744C697374656E657228742C69297D293B72657475726E20722E6576656E747D2C652E746F50726F6D6973653D66756E6374696F6E2865297B72657475726E206E65772050726F6D69736528286E3D3E74286529286E2929297D2C652E66726F6D';
wwv_flow_imp.g_varchar2_table(93) := '50726F6D6973653D66756E6374696F6E2865297B636F6E737420743D6E6577204C3B72657475726E20652E7468656E2828653D3E7B742E666972652865297D292C2828293D3E7B742E6669726528766F69642030297D29292E66696E616C6C7928282829';
wwv_flow_imp.g_varchar2_table(94) := '3D3E7B742E646973706F736528297D29292C742E6576656E747D2C652E72756E416E645375627363726962653D66756E6374696F6E28652C742C6E297B72657475726E2074286E292C652828653D3E7428652929297D3B636C617373206C7B636F6E7374';
wwv_flow_imp.g_varchar2_table(95) := '727563746F7228652C74297B746869732E5F6F627365727661626C653D652C746869732E5F636F756E7465723D302C746869732E5F6861734368616E6765643D21313B636F6E7374206E3D7B6F6E57696C6C41646446697273744C697374656E65723A28';
wwv_flow_imp.g_varchar2_table(96) := '293D3E7B652E6164644F627365727665722874686973297D2C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E7B652E72656D6F76654F627365727665722874686973297D7D3B746869732E656D69747465723D6E6577204C286E29';
wwv_flow_imp.g_varchar2_table(97) := '2C742626742E61646428746869732E656D6974746572297D626567696E5570646174652865297B746869732E5F636F756E7465722B2B7D68616E646C65506F737369626C654368616E67652865297B7D68616E646C654368616E676528652C74297B7468';
wwv_flow_imp.g_varchar2_table(98) := '69732E5F6861734368616E6765643D21307D656E645570646174652865297B746869732E5F636F756E7465722D2D2C303D3D3D746869732E5F636F756E746572262628746869732E5F6F627365727661626C652E7265706F72744368616E67657328292C';
wwv_flow_imp.g_varchar2_table(99) := '746869732E5F6861734368616E676564262628746869732E5F6861734368616E6765643D21312C746869732E656D69747465722E6669726528746869732E5F6F627365727661626C652E67657428292929297D7D652E66726F6D4F627365727661626C65';
wwv_flow_imp.g_varchar2_table(100) := '3D66756E6374696F6E28652C74297B72657475726E206E6577206C28652C74292E656D69747465722E6576656E747D2C652E66726F6D4F627365727661626C654C696768743D66756E6374696F6E2865297B72657475726E28742C6E2C69293D3E7B6C65';
wwv_flow_imp.g_varchar2_table(101) := '7420723D302C6F3D21313B636F6E737420613D7B626567696E55706461746528297B722B2B7D2C656E6455706461746528297B722D2D2C303D3D3D72262628652E7265706F72744368616E67657328292C6F2626286F3D21312C742E63616C6C286E2929';
wwv_flow_imp.g_varchar2_table(102) := '297D2C68616E646C65506F737369626C654368616E676528297B7D2C68616E646C654368616E676528297B6F3D21307D7D3B652E6164644F627365727665722861292C652E7265706F72744368616E67657328293B636F6E737420733D7B646973706F73';
wwv_flow_imp.g_varchar2_table(103) := '6528297B652E72656D6F76654F627365727665722861297D7D3B72657475726E206920696E7374616E63656F6620663F692E6164642873293A41727261792E697341727261792869292626692E707573682873292C737D7D7D28797C7C28793D7B7D2929';
wwv_flow_imp.g_varchar2_table(104) := '3B636C61737320547B636F6E7374727563746F722865297B746869732E6C697374656E6572436F756E743D302C746869732E696E766F636174696F6E436F756E743D302C746869732E656C61707365644F766572616C6C3D302C746869732E6475726174';
wwv_flow_imp.g_varchar2_table(105) := '696F6E733D5B5D2C746869732E6E616D653D60247B657D5F247B542E5F6964506F6F6C2B2B7D602C542E616C6C2E6164642874686973297D73746172742865297B746869732E5F73746F7057617463683D6E657720772C746869732E6C697374656E6572';
wwv_flow_imp.g_varchar2_table(106) := '436F756E743D657D73746F7028297B696628746869732E5F73746F705761746368297B636F6E737420653D746869732E5F73746F7057617463682E656C617073656428293B746869732E6475726174696F6E732E707573682865292C746869732E656C61';
wwv_flow_imp.g_varchar2_table(107) := '707365644F766572616C6C2B3D652C746869732E696E766F636174696F6E436F756E742B3D312C746869732E5F73746F7057617463683D766F696420307D7D7D542E616C6C3D6E6577205365742C542E5F6964506F6F6C3D303B636C617373206B7B636F';
wwv_flow_imp.g_varchar2_table(108) := '6E7374727563746F7228652C743D4D6174682E72616E646F6D28292E746F537472696E67283138292E736C69636528322C3529297B746869732E7468726573686F6C643D652C746869732E6E616D653D742C746869732E5F7761726E436F756E74646F77';
wwv_flow_imp.g_varchar2_table(109) := '6E3D307D646973706F736528297B76617220653B6E756C6C3D3D3D28653D746869732E5F737461636B73297C7C766F696420303D3D3D657C7C652E636C65617228297D636865636B28652C74297B636F6E7374206E3D746869732E7468726573686F6C64';
wwv_flow_imp.g_varchar2_table(110) := '3B6966286E3C3D307C7C743C6E2972657475726E3B746869732E5F737461636B737C7C28746869732E5F737461636B733D6E6577204D6170293B636F6E737420693D746869732E5F737461636B732E67657428652E76616C7565297C7C303B6966287468';
wwv_flow_imp.g_varchar2_table(111) := '69732E5F737461636B732E73657428652E76616C75652C692B31292C746869732E5F7761726E436F756E74646F776E2D3D312C746869732E5F7761726E436F756E74646F776E3C3D30297B6C657420653B746869732E5F7761726E436F756E74646F776E';
wwv_flow_imp.g_varchar2_table(112) := '3D2E352A6E3B6C657420693D303B666F7228636F6E73745B742C6E5D6F6620746869732E5F737461636B73292821657C7C693C6E29262628653D742C693D6E293B636F6E736F6C652E7761726E28605B247B746869732E6E616D657D5D20706F74656E74';
wwv_flow_imp.g_varchar2_table(113) := '69616C206C697374656E6572204C45414B2064657465637465642C20686176696E6720247B747D206C697374656E65727320616C72656164792E204D4F5354206672657175656E74206C697374656E65722028247B697D293A60292C636F6E736F6C652E';
wwv_flow_imp.g_varchar2_table(114) := '7761726E2865297D72657475726E28293D3E7B636F6E737420743D746869732E5F737461636B732E67657428652E76616C7565297C7C303B746869732E5F737461636B732E73657428652E76616C75652C742D31297D7D7D636C61737320537B73746174';
wwv_flow_imp.g_varchar2_table(115) := '69632063726561746528297B76617220653B72657475726E206E65772053286E756C6C213D3D28653D286E6577204572726F72292E737461636B292626766F69642030213D3D653F653A2222297D636F6E7374727563746F722865297B746869732E7661';
wwv_flow_imp.g_varchar2_table(116) := '6C75653D657D7072696E7428297B636F6E736F6C652E7761726E28746869732E76616C75652E73706C697428225C6E22292E736C6963652832292E6A6F696E28225C6E2229297D7D636C61737320787B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(117) := '76616C75653D657D7D636C617373204C7B636F6E7374727563746F722865297B76617220742C6E2C692C722C6F3B746869732E5F73697A653D302C746869732E5F6F7074696F6E733D652C746869732E5F6C65616B6167654D6F6E3D286E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(118) := '28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6C65616B5761726E696E675468726573686F6C64293F6E6577206B286E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(119) := '297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C65616B5761726E696E675468726573686F6C64292626766F69642030213D3D693F693A2D31293A766F696420302C746869732E5F706572664D6F6E3D286E756C6C3D3D3D28723D746869732E';
wwv_flow_imp.g_varchar2_table(120) := '5F6F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E5F70726F664E616D65293F6E6577205428746869732E5F6F7074696F6E732E5F70726F664E616D65293A766F696420302C746869732E5F64656C697665727951756575653D';
wwv_flow_imp.g_varchar2_table(121) := '6E756C6C3D3D3D286F3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E64656C697665727951756575657D646973706F736528297B76617220652C742C6E2C693B746869732E5F646973706F7365647C7C2874';
wwv_flow_imp.g_varchar2_table(122) := '6869732E5F646973706F7365643D21302C286E756C6C3D3D3D28653D746869732E5F64656C69766572795175657565297C7C766F696420303D3D3D653F766F696420303A652E63757272656E74293D3D3D746869732626746869732E5F64656C69766572';
wwv_flow_imp.g_varchar2_table(123) := '7951756575652E726573657428292C746869732E5F6C697374656E657273262628746869732E5F6C697374656E6572733D766F696420302C746869732E5F73697A653D30292C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F707469';
wwv_flow_imp.g_varchar2_table(124) := '6F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D6E7C7C6E2E63616C6C2874292C6E756C6C3D3D3D28693D746869732E5F6C65616B6167654D6F6E';
wwv_flow_imp.g_varchar2_table(125) := '297C7C766F696420303D3D3D697C7C692E646973706F73652829297D676574206576656E7428297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F6576656E74292626766F69642030213D3D657C7C28746869732E5F6576656E';
wwv_flow_imp.g_varchar2_table(126) := '743D28652C742C6E293D3E7B76617220692C722C6F2C612C733B696628746869732E5F6C65616B6167654D6F6E2626746869732E5F73697A653E332A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C642972657475726E20636F6E736F6C';
wwv_flow_imp.g_varchar2_table(127) := '652E7761726E28605B247B746869732E5F6C65616B6167654D6F6E2E6E616D657D5D205245465553455320746F20616363657074206E6577206C697374656E657273206265636175736520697420657863656564656420697473207468726573686F6C64';
wwv_flow_imp.g_varchar2_table(128) := '2062792066617260292C672E4E6F6E653B696628746869732E5F646973706F7365642972657475726E20672E4E6F6E653B74262628653D652E62696E64287429293B636F6E7374206C3D6E657720782865293B6C657420683B746869732E5F6C65616B61';
wwv_flow_imp.g_varchar2_table(129) := '67654D6F6E2626746869732E5F73697A653E3D4D6174682E6365696C282E322A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C64292626286C2E737461636B3D532E63726561746528292C683D746869732E5F6C65616B6167654D6F6E2E';
wwv_flow_imp.g_varchar2_table(130) := '636865636B286C2E737461636B2C746869732E5F73697A652B3129292C746869732E5F6C697374656E6572733F746869732E5F6C697374656E65727320696E7374616E63656F6620783F286E756C6C213D3D28733D746869732E5F64656C697665727951';
wwv_flow_imp.g_varchar2_table(131) := '75657565292626766F69642030213D3D737C7C28746869732E5F64656C697665727951756575653D6E65772043292C746869732E5F6C697374656E6572733D5B746869732E5F6C697374656E6572732C6C5D293A746869732E5F6C697374656E6572732E';
wwv_flow_imp.g_varchar2_table(132) := '70757368286C293A286E756C6C3D3D3D28723D6E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E57696C6C41646446697273744C697374656E6572297C7C766F696420303D3D3D72';
wwv_flow_imp.g_varchar2_table(133) := '7C7C722E63616C6C28692C74686973292C746869732E5F6C697374656E6572733D6C2C6E756C6C3D3D3D28613D6E756C6C3D3D3D286F3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E6F6E44696441646446';
wwv_flow_imp.g_varchar2_table(134) := '697273744C697374656E6572297C7C766F696420303D3D3D617C7C612E63616C6C286F2C7468697329292C746869732E5F73697A652B2B3B636F6E737420633D70282828293D3E7B6E756C6C3D3D687C7C6828292C746869732E5F72656D6F76654C6973';
wwv_flow_imp.g_varchar2_table(135) := '74656E6572286C297D29293B72657475726E206E20696E7374616E63656F6620663F6E2E6164642863293A41727261792E69734172726179286E2926266E2E707573682863292C637D292C746869732E5F6576656E747D5F72656D6F76654C697374656E';
wwv_flow_imp.g_varchar2_table(136) := '65722865297B76617220742C6E2C692C723B6966286E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E57696C6C52656D6F76654C697374656E6572297C7C';
wwv_flow_imp.g_varchar2_table(137) := '766F696420303D3D3D6E7C7C6E2E63616C6C28742C74686973292C21746869732E5F6C697374656E6572732972657475726E3B696628313D3D3D746869732E5F73697A652972657475726E20746869732E5F6C697374656E6572733D766F696420302C6E';
wwv_flow_imp.g_varchar2_table(138) := '756C6C3D3D3D28723D6E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D727C7C722E63616C6C28';
wwv_flow_imp.g_varchar2_table(139) := '692C74686973292C766F696428746869732E5F73697A653D30293B636F6E7374206F3D746869732E5F6C697374656E6572732C613D6F2E696E6465784F662865293B6966282D313D3D3D61297468726F7720636F6E736F6C652E6C6F672822646973706F';
wwv_flow_imp.g_varchar2_table(140) := '7365643F222C746869732E5F646973706F736564292C636F6E736F6C652E6C6F67282273697A653F222C746869732E5F73697A65292C636F6E736F6C652E6C6F6728226172723F222C4A534F4E2E737472696E6769667928746869732E5F6C697374656E';
wwv_flow_imp.g_varchar2_table(141) := '65727329292C6E6577204572726F722822417474656D7074656420746F20646973706F736520756E6B6E6F776E206C697374656E657222293B746869732E5F73697A652D2D2C6F5B615D3D766F696420303B636F6E737420733D746869732E5F64656C69';
wwv_flow_imp.g_varchar2_table(142) := '7665727951756575652E63757272656E743D3D3D746869733B696628322A746869732E5F73697A653C3D6F2E6C656E677468297B6C657420653D303B666F72286C657420743D303B743C6F2E6C656E6774683B742B2B296F5B745D3F6F5B652B2B5D3D6F';
wwv_flow_imp.g_varchar2_table(143) := '5B745D3A73262628746869732E5F64656C697665727951756575652E656E642D2D2C653C746869732E5F64656C697665727951756575652E692626746869732E5F64656C697665727951756575652E692D2D293B6F2E6C656E6774683D657D7D5F64656C';
wwv_flow_imp.g_varchar2_table(144) := '6976657228652C6E297B76617220693B69662821652972657475726E3B636F6E737420723D286E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E4C697374656E65724572726F7229';
wwv_flow_imp.g_varchar2_table(145) := '7C7C743B69662872297472797B652E76616C7565286E297D63617463682865297B722865297D656C736520652E76616C7565286E297D5F64656C6976657251756575652865297B636F6E737420743D652E63757272656E742E5F6C697374656E6572733B';
wwv_flow_imp.g_varchar2_table(146) := '666F72283B652E693C652E656E643B29746869732E5F64656C6976657228745B652E692B2B5D2C652E76616C7565293B652E726573657428297D666972652865297B76617220742C6E2C692C723B696628286E756C6C3D3D3D28743D746869732E5F6465';
wwv_flow_imp.g_varchar2_table(147) := '6C69766572795175657565297C7C766F696420303D3D3D743F766F696420303A742E63757272656E7429262628746869732E5F64656C69766572517565756528746869732E5F64656C69766572795175657565292C6E756C6C3D3D3D286E3D746869732E';
wwv_flow_imp.g_varchar2_table(148) := '5F706572664D6F6E297C7C766F696420303D3D3D6E7C7C6E2E73746F702829292C6E756C6C3D3D3D28693D746869732E5F706572664D6F6E297C7C766F696420303D3D3D697C7C692E737461727428746869732E5F73697A65292C746869732E5F6C6973';
wwv_flow_imp.g_varchar2_table(149) := '74656E65727329696628746869732E5F6C697374656E65727320696E7374616E63656F66207829746869732E5F64656C6976657228746869732E5F6C697374656E6572732C65293B656C73657B636F6E737420743D746869732E5F64656C697665727951';
wwv_flow_imp.g_varchar2_table(150) := '756575653B742E656E717565756528746869732C652C746869732E5F6C697374656E6572732E6C656E677468292C746869732E5F64656C6976657251756575652874297D6E756C6C3D3D3D28723D746869732E5F706572664D6F6E297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(151) := '3D3D3D727C7C722E73746F7028297D6861734C697374656E65727328297B72657475726E20746869732E5F73697A653E307D7D636C61737320437B636F6E7374727563746F7228297B746869732E693D2D312C746869732E656E643D307D656E71756575';
wwv_flow_imp.g_varchar2_table(152) := '6528652C742C6E297B746869732E693D302C746869732E656E643D6E2C746869732E63757272656E743D652C746869732E76616C75653D747D726573657428297B746869732E693D746869732E656E642C746869732E63757272656E743D766F69642030';
wwv_flow_imp.g_varchar2_table(153) := '2C746869732E76616C75653D766F696420307D7D66756E6374696F6E20452865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662066756E6374696F6E2865297B6C657420743D5B5D3B666F72283B4F626A6563742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(154) := '7065213D3D653B29743D742E636F6E636174284F626A6563742E6765744F776E50726F70657274794E616D6573286529292C653D4F626A6563742E67657450726F746F747970654F662865293B72657475726E20747D286529292266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(155) := '3D3D747970656F6620655B6E5D2626742E70757368286E293B72657475726E20747D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B6C657420413D22756E646566696E656422213D747970656F6620646F63756D656E74';
wwv_flow_imp.g_varchar2_table(156) := '2626646F63756D656E742E6C6F636174696F6E2626646F63756D656E742E6C6F636174696F6E2E686173682E696E6465784F66282270736575646F3D7472756522293E3D303B66756E6374696F6E205228652C742C2E2E2E6E297B72657475726E206675';
wwv_flow_imp.g_varchar2_table(157) := '6E6374696F6E28652C74297B6C6574206E3B72657475726E206E3D303D3D3D742E6C656E6774683F653A652E7265706C616365282F5C7B285C642B295C7D2F672C2828652C6E293D3E7B636F6E737420693D6E5B305D2C723D745B695D3B6C6574206F3D';
wwv_flow_imp.g_varchar2_table(158) := '653B72657475726E22737472696E67223D3D747970656F6620723F6F3D723A226E756D62657222213D747970656F662072262622626F6F6C65616E22213D747970656F66207226266E756C6C213D727C7C286F3D537472696E67287229292C6F7D29292C';
wwv_flow_imp.g_varchar2_table(159) := '412626286E3D22EFBCBB222B6E2E7265706C616365282F5B616F7565695D2F672C222426242622292B22EFBCBD22292C6E7D28742C6E297D766172204D2C4E3B636F6E737420493D22656E223B6C6574207A2C552C483D21312C443D21312C4F3D21312C';
wwv_flow_imp.g_varchar2_table(160) := '573D21312C503D21312C713D21312C463D21312C423D21312C563D21312C4B3D21312C6A3D6E756C6C2C473D6E756C6C2C243D6E756C6C3B636F6E737420583D676C6F62616C546869733B6C6574204A3B766F69642030213D3D582E7673636F64652626';
wwv_flow_imp.g_varchar2_table(161) := '766F69642030213D3D582E7673636F64652E70726F636573733F4A3D582E7673636F64652E70726F636573733A22756E646566696E656422213D747970656F662070726F63657373262622737472696E67223D3D747970656F66286E756C6C3D3D3D284D';
wwv_flow_imp.g_varchar2_table(162) := '3D6E756C6C3D3D3D70726F636573737C7C766F696420303D3D3D70726F636573733F766F696420303A70726F636573732E76657273696F6E73297C7C766F696420303D3D3D4D3F766F696420303A4D2E6E6F6465292626284A3D70726F63657373293B63';
wwv_flow_imp.g_varchar2_table(163) := '6F6E737420593D22737472696E67223D3D747970656F66286E756C6C3D3D3D284E3D6E756C6C3D3D4A3F766F696420303A4A2E76657273696F6E73297C7C766F696420303D3D3D4E3F766F696420303A4E2E656C656374726F6E292C513D592626227265';
wwv_flow_imp.g_varchar2_table(164) := '6E6465726572223D3D3D286E756C6C3D3D4A3F766F696420303A4A2E74797065293B696628226F626A656374223D3D747970656F66204A297B483D2277696E3332223D3D3D4A2E706C6174666F726D2C443D2264617277696E223D3D3D4A2E706C617466';
wwv_flow_imp.g_varchar2_table(165) := '6F726D2C4F3D226C696E7578223D3D3D4A2E706C6174666F726D2C573D4F262621214A2E656E762E534E4150262621214A2E656E762E534E41505F5245564953494F4E2C463D592C563D21214A2E656E762E43497C7C21214A2E656E762E4255494C445F';
wwv_flow_imp.g_varchar2_table(166) := '415254494641435453544147494E474449524543544F52592C7A3D492C6A3D493B636F6E737420653D4A2E656E762E5653434F44455F4E4C535F434F4E4649473B69662865297472797B636F6E737420743D4A534F4E2E70617273652865292C6E3D742E';
wwv_flow_imp.g_varchar2_table(167) := '617661696C61626C654C616E6775616765735B222A225D3B7A3D742E6C6F63616C652C473D742E6F734C6F63616C652C6A3D6E7C7C492C243D742E5F7472616E736C6174696F6E73436F6E66696746696C657D63617463682865297B7D503D21307D656C';
wwv_flow_imp.g_varchar2_table(168) := '7365226F626A65637422213D747970656F66206E6176696761746F727C7C513F636F6E736F6C652E6572726F722822556E61626C6520746F207265736F6C766520706C6174666F726D2E22293A28553D6E6176696761746F722E757365724167656E742C';
wwv_flow_imp.g_varchar2_table(169) := '483D552E696E6465784F66282257696E646F777322293E3D302C443D552E696E6465784F6628224D6163696E746F736822293E3D302C423D28552E696E6465784F6628224D6163696E746F736822293E3D307C7C552E696E6465784F6628226950616422';
wwv_flow_imp.g_varchar2_table(170) := '293E3D307C7C552E696E6465784F6628226950686F6E6522293E3D3029262621216E6176696761746F722E6D6178546F756368506F696E747326266E6176696761746F722E6D6178546F756368506F696E74733E302C4F3D552E696E6465784F6628224C';
wwv_flow_imp.g_varchar2_table(171) := '696E757822293E3D302C4B3D286E756C6C3D3D553F766F696420303A552E696E6465784F6628224D6F62692229293E3D302C713D21302C7A3D766F6964205228302C225F22297C7C492C6A3D7A2C473D6E6176696761746F722E6C616E6775616765293B';
wwv_flow_imp.g_varchar2_table(172) := '6C6574205A3D303B443F5A3D313A483F5A3D333A4F2626285A3D32293B636F6E73742065653D482C74653D442C6E653D287126262266756E6374696F6E223D3D747970656F6620582E696D706F7274536372697074732626582E6F726967696E2C55292C';
wwv_flow_imp.g_varchar2_table(173) := '69653D2266756E6374696F6E223D3D747970656F6620582E706F73744D657373616765262621582E696D706F7274536372697074733B2828293D3E7B6966286965297B636F6E737420653D5B5D3B582E6164644576656E744C697374656E657228226D65';
wwv_flow_imp.g_varchar2_table(174) := '7373616765222C28743D3E7B696628742E646174612626742E646174612E7673636F64655363686564756C654173796E63576F726B29666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B69';
wwv_flow_imp.g_varchar2_table(175) := '6628692E69643D3D3D742E646174612E7673636F64655363686564756C654173796E63576F726B2972657475726E20652E73706C696365286E2C31292C766F696420692E63616C6C6261636B28297D7D29293B6C657420743D307D7D2928293B636F6E73';
wwv_flow_imp.g_varchar2_table(176) := '742072653D2121286E6526266E652E696E6465784F6628224368726F6D6522293E3D30293B66756E6374696F6E206F652865297B72657475726E20657D6E6526266E652E696E6465784F66282246697265666F7822292C21726526266E6526266E652E69';
wwv_flow_imp.g_varchar2_table(177) := '6E6465784F66282253616661726922292C6E6526266E652E696E6465784F6628224564672F22292C6E6526266E652E696E6465784F662822416E64726F696422293B636C6173732061657B636F6E7374727563746F722865297B746869732E6578656375';
wwv_flow_imp.g_varchar2_table(178) := '746F723D652C746869732E5F64696452756E3D21317D6765742076616C756528297B69662821746869732E5F64696452756E297472797B746869732E5F76616C75653D746869732E6578656375746F7228297D63617463682865297B746869732E5F6572';
wwv_flow_imp.g_varchar2_table(179) := '726F723D657D66696E616C6C797B746869732E5F64696452756E3D21307D696628746869732E5F6572726F72297468726F7720746869732E5F6572726F723B72657475726E20746869732E5F76616C75657D6765742072617756616C756528297B726574';
wwv_flow_imp.g_varchar2_table(180) := '75726E20746869732E5F76616C75657D7D7661722073653B66756E6374696F6E206C652865297B72657475726E20653E3D36352626653C3D39307D66756E6374696F6E2068652865297B72657475726E2035353239363C3D652626653C3D35363331397D';
wwv_flow_imp.g_varchar2_table(181) := '66756E6374696F6E2063652865297B72657475726E2035363332303C3D652626653C3D35373334337D66756E6374696F6E20646528652C74297B72657475726E20742D35363332302B28652D35353239363C3C3130292B36353533367D66756E6374696F';
wwv_flow_imp.g_varchar2_table(182) := '6E20756528652C742C6E297B636F6E737420693D652E63686172436F64654174286E293B696628686528692926266E2B313C74297B636F6E737420743D652E63686172436F64654174286E2B31293B69662863652874292972657475726E20646528692C';
wwv_flow_imp.g_varchar2_table(183) := '74297D72657475726E20697D636F6E7374206D653D2F5E5B5C745C6E5C725C7832302D5C7837455D2A242F3B537472696E672E66726F6D43686172436F6465283635323739293B636C6173732070657B73746174696320676574496E7374616E63652829';
wwv_flow_imp.g_varchar2_table(184) := '7B72657475726E2070652E5F494E5354414E43457C7C2870652E5F494E5354414E43453D6E6577207065292C70652E5F494E5354414E43457D636F6E7374727563746F7228297B746869732E5F646174613D4A534F4E2E706172736528225B302C302C30';
wwv_flow_imp.g_varchar2_table(185) := '2C35313232392C35313235352C31322C34343036312C34343038372C31322C3132373436322C3132373438372C362C373038332C373038352C352C34373634352C34373637312C31322C35343831332C35343833392C31322C3132383637382C31323836';
wwv_flow_imp.g_varchar2_table(186) := '37382C31342C333237302C333237302C352C393931392C393932332C31342C34353835332C34353837392C31322C34393433372C34393436332C31322C35333032312C35333034372C31322C37313231362C37313231382C372C3132383339382C313238';
wwv_flow_imp.g_varchar2_table(187) := '3339392C31342C3132393336302C3132393337342C31342C323531392C323531392C352C343434382C343531392C392C393734322C393734322C31342C31323333362C31323333362C31342C34343935372C34343938332C31322C34363734392C343637';
wwv_flow_imp.g_varchar2_table(188) := '37352C31322C34383534312C34383536372C31322C35303333332C35303335392C31322C35323132352C35323135312C31322C35333931372C35333934332C31322C36393838382C36393839302C352C37333031382C37333031382C352C313237393930';
wwv_flow_imp.g_varchar2_table(189) := '2C3132373939302C31342C3132383535382C3132383535392C31342C3132383735392C3132383736302C31342C3132393635332C3132393635352C31342C323032372C323033352C352C323839312C323839322C372C333736312C333736312C352C3636';
wwv_flow_imp.g_varchar2_table(190) := '38332C363638332C352C383239332C383239332C342C393832352C393832362C31342C393939392C393939392C31342C34333435322C34333435332C352C34343530392C34343533352C31322C34353430352C34353433312C31322C34363330312C3436';
wwv_flow_imp.g_varchar2_table(191) := '3332372C31322C34373139372C34373232332C31322C34383039332C34383131392C31322C34383938392C34393031352C31322C34393838352C34393931312C31322C35303738312C35303830372C31322C35313637372C35313730332C31322C353235';
wwv_flow_imp.g_varchar2_table(192) := '37332C35323539392C31322C35333436392C35333439352C31322C35343336352C35343339312C31322C36353237392C36353237392C342C37303437312C37303437322C372C37323134352C37323134372C372C3131393137332C3131393137392C352C';
wwv_flow_imp.g_varchar2_table(193) := '3132373739392C3132373831382C31342C3132383234302C3132383234342C31342C3132383531322C3132383531322C31342C3132383635322C3132383635322C31342C3132383732312C3132383732322C31342C3132393239322C3132393239322C31';
wwv_flow_imp.g_varchar2_table(194) := '342C3132393434352C3132393435302C31342C3132393733342C3132393734332C31342C313437362C313437372C352C323336362C323336382C372C323735302C323735322C372C333037362C333037362C352C333431352C333431352C352C34313431';
wwv_flow_imp.g_varchar2_table(195) := '2C343134342C352C363130392C363130392C352C363936342C363936342C352C373339342C373430302C352C393139372C393139382C31342C393737302C393737302C31342C393837372C393837372C31342C393936382C393936392C31342C31303038';
wwv_flow_imp.g_varchar2_table(196) := '342C31303038342C31342C34333035322C34333035322C352C34333731332C34333731332C352C34343238352C34343331312C31322C34343733332C34343735392C31322C34353138312C34353230372C31322C34353632392C34353635352C31322C34';
wwv_flow_imp.g_varchar2_table(197) := '363037372C34363130332C31322C34363532352C34363535312C31322C34363937332C34363939392C31322C34373432312C34373434372C31322C34373836392C34373839352C31322C34383331372C34383334332C31322C34383736352C3438373931';
wwv_flow_imp.g_varchar2_table(198) := '2C31322C34393231332C34393233392C31322C34393636312C34393638372C31322C35303130392C35303133352C31322C35303535372C35303538332C31322C35313030352C35313033312C31322C35313435332C35313437392C31322C35313930312C';
wwv_flow_imp.g_varchar2_table(199) := '35313932372C31322C35323334392C35323337352C31322C35323739372C35323832332C31322C35333234352C35333237312C31322C35333639332C35333731392C31322C35343134312C35343136372C31322C35343538392C35343631352C31322C35';
wwv_flow_imp.g_varchar2_table(200) := '353033372C35353036332C31322C36393530362C36393530392C352C37303139312C37303139332C352C37303834312C37303834312C372C37313436332C37313436372C352C37323333302C37323334322C352C39343033312C39343033312C352C3132';
wwv_flow_imp.g_varchar2_table(201) := '333632382C3132333633312C352C3132373736332C3132373736352C31342C3132373934312C3132373934312C31342C3132383034332C3132383036322C31342C3132383330322C3132383331372C31342C3132383436352C3132383436372C31342C31';
wwv_flow_imp.g_varchar2_table(202) := '32383533392C3132383533392C31342C3132383634302C3132383634302C31342C3132383636322C3132383636322C31342C3132383730332C3132383730332C31342C3132383734352C3132383734352C31342C3132393030342C3132393030372C3134';
wwv_flow_imp.g_varchar2_table(203) := '2C3132393332392C3132393333302C31342C3132393430322C3132393430322C31342C3132393438332C3132393438332C31342C3132393638362C3132393730342C31342C3133303034382C3133313036392C31342C3137332C3137332C342C31373537';
wwv_flow_imp.g_varchar2_table(204) := '2C313735372C312C323230302C323230372C352C323433342C323433352C372C323633312C323633322C352C323831372C323831372C352C333030382C333030382C352C333230312C333230312C352C333338372C333338382C352C333534322C333534';
wwv_flow_imp.g_varchar2_table(205) := '322C352C333930322C333930332C372C343139302C343139322C352C363030322C363030332C352C363433392C363434302C352C363736352C363737302C372C373031392C373032372C352C373135342C373135352C372C383230352C383230352C3133';
wwv_flow_imp.g_varchar2_table(206) := '2C383530352C383530352C31342C393635342C393635342C31342C393735372C393735372C31342C393739322C393739322C31342C393835322C393835332C31342C393839302C393839342C31342C393933372C393933372C31342C393938312C393938';
wwv_flow_imp.g_varchar2_table(207) := '312C31342C31303033352C31303033362C31342C31313033352C31313033362C31342C34323635342C34323635352C352C34333334362C34333334372C372C34333538372C34333538372C352C34343030362C34343030372C372C34343137332C343431';
wwv_flow_imp.g_varchar2_table(208) := '39392C31322C34343339372C34343432332C31322C34343632312C34343634372C31322C34343834352C34343837312C31322C34353036392C34353039352C31322C34353239332C34353331392C31322C34353531372C34353534332C31322C34353734';
wwv_flow_imp.g_varchar2_table(209) := '312C34353736372C31322C34353936352C34353939312C31322C34363138392C34363231352C31322C34363431332C34363433392C31322C34363633372C34363636332C31322C34363836312C34363838372C31322C34373038352C34373131312C3132';
wwv_flow_imp.g_varchar2_table(210) := '2C34373330392C34373333352C31322C34373533332C34373535392C31322C34373735372C34373738332C31322C34373938312C34383030372C31322C34383230352C34383233312C31322C34383432392C34383435352C31322C34383635332C343836';
wwv_flow_imp.g_varchar2_table(211) := '37392C31322C34383837372C34383930332C31322C34393130312C34393132372C31322C34393332352C34393335312C31322C34393534392C34393537352C31322C34393737332C34393739392C31322C34393939372C35303032332C31322C35303232';
wwv_flow_imp.g_varchar2_table(212) := '312C35303234372C31322C35303434352C35303437312C31322C35303636392C35303639352C31322C35303839332C35303931392C31322C35313131372C35313134332C31322C35313334312C35313336372C31322C35313536352C35313539312C3132';
wwv_flow_imp.g_varchar2_table(213) := '2C35313738392C35313831352C31322C35323031332C35323033392C31322C35323233372C35323236332C31322C35323436312C35323438372C31322C35323638352C35323731312C31322C35323930392C35323933352C31322C35333133332C353331';
wwv_flow_imp.g_varchar2_table(214) := '35392C31322C35333335372C35333338332C31322C35333538312C35333630372C31322C35333830352C35333833312C31322C35343032392C35343035352C31322C35343235332C35343237392C31322C35343437372C35343530332C31322C35343730';
wwv_flow_imp.g_varchar2_table(215) := '312C35343732372C31322C35343932352C35343935312C31322C35353134392C35353137352C31322C36383130312C36383130322C352C36393736322C36393736322C372C37303036372C37303036392C372C37303337312C37303337382C352C373037';
wwv_flow_imp.g_varchar2_table(216) := '32302C37303732312C372C37313038372C37313038372C352C37313334312C37313334312C352C37313939352C37313939362C352C37323234392C37323234392C372C37323835302C37323837312C352C37333130392C37333130392C352C3131383537';
wwv_flow_imp.g_varchar2_table(217) := '362C3131383539382C352C3132313530352C3132313531392C352C3132373234352C3132373234372C31342C3132373536382C3132373536392C31342C3132373737372C3132373737372C31342C3132373837322C3132373839312C31342C3132373935';
wwv_flow_imp.g_varchar2_table(218) := '362C3132373936372C31342C3132383031352C3132383031362C31342C3132383131302C3132383137322C31342C3132383235392C3132383235392C31342C3132383336372C3132383336382C31342C3132383432342C3132383432342C31342C313238';
wwv_flow_imp.g_varchar2_table(219) := '3438382C3132383438382C31342C3132383533302C3132383533322C31342C3132383535302C3132383535312C31342C3132383536362C3132383536362C31342C3132383634372C3132383634372C31342C3132383635362C3132383635362C31342C31';
wwv_flow_imp.g_varchar2_table(220) := '32383636372C3132383637332C31342C3132383639312C3132383639332C31342C3132383731352C3132383731352C31342C3132383732382C3132383733322C31342C3132383735322C3132383735322C31342C3132383736352C3132383736372C3134';
wwv_flow_imp.g_varchar2_table(221) := '2C3132393039362C3132393130332C31342C3132393331312C3132393331312C31342C3132393334342C3132393334392C31342C3132393339342C3132393339342C31342C3132393431332C3132393432352C31342C3132393436362C3132393437312C';
wwv_flow_imp.g_varchar2_table(222) := '31342C3132393531312C3132393533352C31342C3132393636342C3132393636362C31342C3132393731392C3132393732322C31342C3132393736302C3132393736372C31342C3931373533362C3931373633312C352C31332C31332C322C313136302C';
wwv_flow_imp.g_varchar2_table(223) := '313136312C352C313536342C313536342C342C313830372C313830372C312C323038352C323038372C352C323330372C323330372C372C323338322C323338332C372C323439372C323530302C352C323536332C323536332C372C323637372C32363737';
wwv_flow_imp.g_varchar2_table(224) := '2C352C323736332C323736342C372C323837392C323837392C352C323931342C323931352C352C333032312C333032312C352C333134322C333134342C352C333236332C333236332C352C333238352C333238362C352C333339382C333430302C372C33';
wwv_flow_imp.g_varchar2_table(225) := '3533302C333533302C352C333633332C333633332C352C333836342C333836352C352C333937342C333937352C352C343135352C343135362C372C343232392C343233302C352C353930392C353930392C372C363037382C363038352C372C363237372C';
wwv_flow_imp.g_varchar2_table(226) := '363237382C352C363435312C363435362C372C363734342C363735302C352C363834362C363834362C352C363937322C363937322C352C373037342C373037372C352C373134362C373134382C372C373232322C373232332C352C373431362C37343137';
wwv_flow_imp.g_varchar2_table(227) := '2C352C383233342C383233382C342C383431372C383431372C352C393030302C393030302C31342C393230332C393230332C31342C393733302C393733312C31342C393734382C393734392C31342C393736322C393736332C31342C393737362C393738';
wwv_flow_imp.g_varchar2_table(228) := '332C31342C393830302C393831312C31342C393833312C393833312C31342C393837322C393837332C31342C393838322C393838322C31342C393930302C393930332C31342C393932392C393933332C31342C393934312C393936302C31342C39393734';
wwv_flow_imp.g_varchar2_table(229) := '2C393937342C31342C393938392C393938392C31342C31303030362C31303030362C31342C31303036322C31303036322C31342C31303136302C31303136302C31342C31313634372C31313634372C352C31323935332C31323935332C31342C34333031';
wwv_flow_imp.g_varchar2_table(230) := '392C34333031392C352C34333233322C34333234392C352C34333434332C34333434332C352C34333536372C34333536382C372C34333639362C34333639362C352C34333736352C34333736352C372C34343031332C34343031332C352C34343131372C';
wwv_flow_imp.g_varchar2_table(231) := '34343134332C31322C34343232392C34343235352C31322C34343334312C34343336372C31322C34343435332C34343437392C31322C34343536352C34343539312C31322C34343637372C34343730332C31322C34343738392C34343831352C31322C34';
wwv_flow_imp.g_varchar2_table(232) := '343930312C34343932372C31322C34353031332C34353033392C31322C34353132352C34353135312C31322C34353233372C34353236332C31322C34353334392C34353337352C31322C34353436312C34353438372C31322C34353537332C3435353939';
wwv_flow_imp.g_varchar2_table(233) := '2C31322C34353638352C34353731312C31322C34353739372C34353832332C31322C34353930392C34353933352C31322C34363032312C34363034372C31322C34363133332C34363135392C31322C34363234352C34363237312C31322C34363335372C';
wwv_flow_imp.g_varchar2_table(234) := '34363338332C31322C34363436392C34363439352C31322C34363538312C34363630372C31322C34363639332C34363731392C31322C34363830352C34363833312C31322C34363931372C34363934332C31322C34373032392C34373035352C31322C34';
wwv_flow_imp.g_varchar2_table(235) := '373134312C34373136372C31322C34373235332C34373237392C31322C34373336352C34373339312C31322C34373437372C34373530332C31322C34373538392C34373631352C31322C34373730312C34373732372C31322C34373831332C3437383339';
wwv_flow_imp.g_varchar2_table(236) := '2C31322C34373932352C34373935312C31322C34383033372C34383036332C31322C34383134392C34383137352C31322C34383236312C34383238372C31322C34383337332C34383339392C31322C34383438352C34383531312C31322C34383539372C';
wwv_flow_imp.g_varchar2_table(237) := '34383632332C31322C34383730392C34383733352C31322C34383832312C34383834372C31322C34383933332C34383935392C31322C34393034352C34393037312C31322C34393135372C34393138332C31322C34393236392C34393239352C31322C34';
wwv_flow_imp.g_varchar2_table(238) := '393338312C34393430372C31322C34393439332C34393531392C31322C34393630352C34393633312C31322C34393731372C34393734332C31322C34393832392C34393835352C31322C34393934312C34393936372C31322C35303035332C3530303739';
wwv_flow_imp.g_varchar2_table(239) := '2C31322C35303136352C35303139312C31322C35303237372C35303330332C31322C35303338392C35303431352C31322C35303530312C35303532372C31322C35303631332C35303633392C31322C35303732352C35303735312C31322C35303833372C';
wwv_flow_imp.g_varchar2_table(240) := '35303836332C31322C35303934392C35303937352C31322C35313036312C35313038372C31322C35313137332C35313139392C31322C35313238352C35313331312C31322C35313339372C35313432332C31322C35313530392C35313533352C31322C35';
wwv_flow_imp.g_varchar2_table(241) := '313632312C35313634372C31322C35313733332C35313735392C31322C35313834352C35313837312C31322C35313935372C35313938332C31322C35323036392C35323039352C31322C35323138312C35323230372C31322C35323239332C3532333139';
wwv_flow_imp.g_varchar2_table(242) := '2C31322C35323430352C35323433312C31322C35323531372C35323534332C31322C35323632392C35323635352C31322C35323734312C35323736372C31322C35323835332C35323837392C31322C35323936352C35323939312C31322C35333037372C';
wwv_flow_imp.g_varchar2_table(243) := '35333130332C31322C35333138392C35333231352C31322C35333330312C35333332372C31322C35333431332C35333433392C31322C35333532352C35333535312C31322C35333633372C35333636332C31322C35333734392C35333737352C31322C35';
wwv_flow_imp.g_varchar2_table(244) := '333836312C35333838372C31322C35333937332C35333939392C31322C35343038352C35343131312C31322C35343139372C35343232332C31322C35343330392C35343333352C31322C35343432312C35343434372C31322C35343533332C3534353539';
wwv_flow_imp.g_varchar2_table(245) := '2C31322C35343634352C35343637312C31322C35343735372C35343738332C31322C35343836392C35343839352C31322C35343938312C35353030372C31322C35353039332C35353131392C31322C35353234332C35353239312C31302C36363034352C';
wwv_flow_imp.g_varchar2_table(246) := '36363034352C352C36383332352C36383332362C352C36393638382C36393730322C352C36393831372C36393831382C352C36393935372C36393935382C372C37303038392C37303039322C352C37303139382C37303139392C352C37303436322C3730';
wwv_flow_imp.g_varchar2_table(247) := '3436322C352C37303530322C37303530382C352C37303735302C37303735302C352C37303834362C37303834362C372C37313130302C37313130312C352C37313233302C37313233302C372C37313335312C37313335312C352C37313733372C37313733';
wwv_flow_imp.g_varchar2_table(248) := '382C352C37323030302C37323030302C372C37323136302C37323136302C352C37323237332C37323237382C352C37323735322C37323735382C352C37323838322C37323838332C352C37333033312C37333033312C352C37333436312C37333436322C';
wwv_flow_imp.g_varchar2_table(249) := '372C39343139322C39343139332C372C3131393134392C3131393134392C372C3132313430332C3132313435322C352C3132323931352C3132323931362C352C3132363938302C3132363938302C31342C3132373335382C3132373335392C31342C3132';
wwv_flow_imp.g_varchar2_table(250) := '373533352C3132373533352C31342C3132373735392C3132373735392C31342C3132373737312C3132373737312C31342C3132373739322C3132373739332C31342C3132373832352C3132373836372C31342C3132373839372C3132373839392C31342C';
wwv_flow_imp.g_varchar2_table(251) := '3132373934352C3132373934352C31342C3132373938352C3132373938362C31342C3132383030302C3132383030372C31342C3132383032312C3132383032312C31342C3132383036362C3132383130302C31342C3132383138342C3132383233352C31';
wwv_flow_imp.g_varchar2_table(252) := '342C3132383234392C3132383235322C31342C3132383236362C3132383237362C31342C3132383333352C3132383333352C31342C3132383337392C3132383339302C31342C3132383430372C3132383431392C31342C3132383434342C313238343434';
wwv_flow_imp.g_varchar2_table(253) := '2C31342C3132383438312C3132383438312C31342C3132383439392C3132383439392C31342C3132383532362C3132383532362C31342C3132383533362C3132383533362C31342C3132383534332C3132383534332C31342C3132383535362C31323835';
wwv_flow_imp.g_varchar2_table(254) := '35362C31342C3132383536342C3132383536342C31342C3132383537372C3132383538302C31342C3132383634332C3132383634352C31342C3132383634392C3132383634392C31342C3132383635342C3132383635342C31342C3132383636302C3132';
wwv_flow_imp.g_varchar2_table(255) := '383636302C31342C3132383636342C3132383636342C31342C3132383637352C3132383637352C31342C3132383638362C3132383638392C31342C3132383639352C3132383639362C31342C3132383730352C3132383730392C31342C3132383731372C';
wwv_flow_imp.g_varchar2_table(256) := '3132383731392C31342C3132383732352C3132383732352C31342C3132383733362C3132383734312C31342C3132383734372C3132383734382C31342C3132383735352C3132383735352C31342C3132383736322C3132383736322C31342C3132383938';
wwv_flow_imp.g_varchar2_table(257) := '312C3132383939312C31342C3132393030392C3132393032332C31342C3132393136302C3132393136372C31342C3132393239362C3132393330342C31342C3132393332302C3132393332372C31342C3132393334302C3132393334322C31342C313239';
wwv_flow_imp.g_varchar2_table(258) := '3335362C3132393335362C31342C3132393338382C3132393339322C31342C3132393339392C3132393430302C31342C3132393430342C3132393430372C31342C3132393433322C3132393434322C31342C3132393435342C3132393435352C31342C31';
wwv_flow_imp.g_varchar2_table(259) := '32393437332C3132393437342C31342C3132393438352C3132393438372C31342C3132393634382C3132393635312C31342C3132393635392C3132393636302C31342C3132393637312C3132393637392C31342C3132393730392C3132393731312C3134';
wwv_flow_imp.g_varchar2_table(260) := '2C3132393732382C3132393733302C31342C3132393735312C3132393735332C31342C3132393737362C3132393738322C31342C3931373530352C3931373530352C342C3931373736302C3931373939392C352C31302C31302C332C3132372C3135392C';
wwv_flow_imp.g_varchar2_table(261) := '342C3736382C3837392C352C313437312C313437312C352C313533362C313534312C312C313634382C313634382C352C313736372C313736382C352C313834302C313836362C352C323037302C323037332C352C323133372C323133392C352C32323734';
wwv_flow_imp.g_varchar2_table(262) := '2C323237342C312C323336332C323336332C372C323337372C323338302C372C323430322C323430332C352C323439342C323439342C352C323530372C323530382C372C323535382C323535382C352C323632322C323632342C372C323634312C323634';
wwv_flow_imp.g_varchar2_table(263) := '312C352C323639312C323639312C372C323735392C323736302C352C323738362C323738372C352C323837362C323837362C352C323838312C323838342C352C323930312C323930322C352C333030362C333030362C352C333031342C333031362C372C';
wwv_flow_imp.g_varchar2_table(264) := '333037322C333037322C352C333133342C333133362C352C333135372C333135382C352C333236302C333236302C352C333236362C333236362C352C333237342C333237352C372C333332382C333332392C352C333339312C333339322C372C33343035';
wwv_flow_imp.g_varchar2_table(265) := '2C333430352C352C333435372C333435372C352C333533362C333533372C372C333535312C333535312C352C333633362C333634322C352C333736342C333737322C352C333839352C333839352C352C333936372C333936372C372C333939332C343032';
wwv_flow_imp.g_varchar2_table(266) := '382C352C343134362C343135312C352C343138322C343138332C372C343232362C343232362C352C343235332C343235332C352C343935372C343935392C352C353934302C353934302C372C363037302C363037302C372C363038372C363038382C372C';
wwv_flow_imp.g_varchar2_table(267) := '363135382C363135382C342C363433322C363433342C352C363434382C363434392C372C363637392C363638302C352C363734322C363734322C352C363735342C363735342C352C363738332C363738332C352C363931322C363931352C352C36393636';
wwv_flow_imp.g_varchar2_table(268) := '2C363937302C352C363937382C363937382C352C373034322C373034322C372C373038302C373038312C352C373134332C373134332C372C373135302C373135302C372C373231322C373231392C352C373338302C373339322C352C373431322C373431';
wwv_flow_imp.g_varchar2_table(269) := '322C352C383230332C383230332C342C383233322C383233322C342C383236352C383236352C31342C383430302C383431322C352C383432312C383433322C352C383631372C383631382C31342C393136372C393136372C31342C393230302C39323030';
wwv_flow_imp.g_varchar2_table(270) := '2C31342C393431302C393431302C31342C393732332C393732362C31342C393733332C393733332C31342C393734352C393734352C31342C393735322C393735322C31342C393736302C393736302C31342C393736362C393736362C31342C393737342C';
wwv_flow_imp.g_varchar2_table(271) := '393737342C31342C393738362C393738362C31342C393739342C393739342C31342C393832332C393832332C31342C393832382C393832382C31342C393833332C393835302C31342C393835352C393835352C31342C393837352C393837352C31342C39';
wwv_flow_imp.g_varchar2_table(272) := '3838302C393838302C31342C393838352C393838372C31342C393839362C393839372C31342C393930362C393931362C31342C393932362C393932372C31342C393933352C393933352C31342C393933392C393933392C31342C393936322C393936322C';
wwv_flow_imp.g_varchar2_table(273) := '31342C393937322C393937322C31342C393937382C393937382C31342C393938362C393938362C31342C393939372C393939372C31342C31303030322C31303030322C31342C31303031372C31303031372C31342C31303035352C31303035352C31342C';
wwv_flow_imp.g_varchar2_table(274) := '31303037312C31303037312C31342C31303133332C31303133352C31342C31303534382C31303534392C31342C31313039332C31313039332C31342C31323333302C31323333332C352C31323434312C31323434322C352C34323630382C34323631302C';
wwv_flow_imp.g_varchar2_table(275) := '352C34333031302C34333031302C352C34333034352C34333034362C352C34333138382C34333230332C372C34333330322C34333330392C352C34333339322C34333339342C352C34333434362C34333434392C352C34333439332C34333439332C352C';
wwv_flow_imp.g_varchar2_table(276) := '34333537312C34333537322C372C34333539372C34333539372C372C34333730332C34333730342C352C34333735362C34333735372C352C34343030332C34343030342C372C34343030392C34343031302C372C34343033332C34343035392C31322C34';
wwv_flow_imp.g_varchar2_table(277) := '343038392C34343131352C31322C34343134352C34343137312C31322C34343230312C34343232372C31322C34343235372C34343238332C31322C34343331332C34343333392C31322C34343336392C34343339352C31322C34343432352C3434343531';
wwv_flow_imp.g_varchar2_table(278) := '2C31322C34343438312C34343530372C31322C34343533372C34343536332C31322C34343539332C34343631392C31322C34343634392C34343637352C31322C34343730352C34343733312C31322C34343736312C34343738372C31322C34343831372C';
wwv_flow_imp.g_varchar2_table(279) := '34343834332C31322C34343837332C34343839392C31322C34343932392C34343935352C31322C34343938352C34353031312C31322C34353034312C34353036372C31322C34353039372C34353132332C31322C34353135332C34353137392C31322C34';
wwv_flow_imp.g_varchar2_table(280) := '353230392C34353233352C31322C34353236352C34353239312C31322C34353332312C34353334372C31322C34353337372C34353430332C31322C34353433332C34353435392C31322C34353438392C34353531352C31322C34353534352C3435353731';
wwv_flow_imp.g_varchar2_table(281) := '2C31322C34353630312C34353632372C31322C34353635372C34353638332C31322C34353731332C34353733392C31322C34353736392C34353739352C31322C34353832352C34353835312C31322C34353838312C34353930372C31322C34353933372C';
wwv_flow_imp.g_varchar2_table(282) := '34353936332C31322C34353939332C34363031392C31322C34363034392C34363037352C31322C34363130352C34363133312C31322C34363136312C34363138372C31322C34363231372C34363234332C31322C34363237332C34363239392C31322C34';
wwv_flow_imp.g_varchar2_table(283) := '363332392C34363335352C31322C34363338352C34363431312C31322C34363434312C34363436372C31322C34363439372C34363532332C31322C34363535332C34363537392C31322C34363630392C34363633352C31322C34363636352C3436363931';
wwv_flow_imp.g_varchar2_table(284) := '2C31322C34363732312C34363734372C31322C34363737372C34363830332C31322C34363833332C34363835392C31322C34363838392C34363931352C31322C34363934352C34363937312C31322C34373030312C34373032372C31322C34373035372C';
wwv_flow_imp.g_varchar2_table(285) := '34373038332C31322C34373131332C34373133392C31322C34373136392C34373139352C31322C34373232352C34373235312C31322C34373238312C34373330372C31322C34373333372C34373336332C31322C34373339332C34373431392C31322C34';
wwv_flow_imp.g_varchar2_table(286) := '373434392C34373437352C31322C34373530352C34373533312C31322C34373536312C34373538372C31322C34373631372C34373634332C31322C34373637332C34373639392C31322C34373732392C34373735352C31322C34373738352C3437383131';
wwv_flow_imp.g_varchar2_table(287) := '2C31322C34373834312C34373836372C31322C34373839372C34373932332C31322C34373935332C34373937392C31322C34383030392C34383033352C31322C34383036352C34383039312C31322C34383132312C34383134372C31322C34383137372C';
wwv_flow_imp.g_varchar2_table(288) := '34383230332C31322C34383233332C34383235392C31322C34383238392C34383331352C31322C34383334352C34383337312C31322C34383430312C34383432372C31322C34383435372C34383438332C31322C34383531332C34383533392C31322C34';
wwv_flow_imp.g_varchar2_table(289) := '383536392C34383539352C31322C34383632352C34383635312C31322C34383638312C34383730372C31322C34383733372C34383736332C31322C34383739332C34383831392C31322C34383834392C34383837352C31322C34383930352C3438393331';
wwv_flow_imp.g_varchar2_table(290) := '2C31322C34383936312C34383938372C31322C34393031372C34393034332C31322C34393037332C34393039392C31322C34393132392C34393135352C31322C34393138352C34393231312C31322C34393234312C34393236372C31322C34393239372C';
wwv_flow_imp.g_varchar2_table(291) := '34393332332C31322C34393335332C34393337392C31322C34393430392C34393433352C31322C34393436352C34393439312C31322C34393532312C34393534372C31322C34393537372C34393630332C31322C34393633332C34393635392C31322C34';
wwv_flow_imp.g_varchar2_table(292) := '393638392C34393731352C31322C34393734352C34393737312C31322C34393830312C34393832372C31322C34393835372C34393838332C31322C34393931332C34393933392C31322C34393936392C34393939352C31322C35303032352C3530303531';
wwv_flow_imp.g_varchar2_table(293) := '2C31322C35303038312C35303130372C31322C35303133372C35303136332C31322C35303139332C35303231392C31322C35303234392C35303237352C31322C35303330352C35303333312C31322C35303336312C35303338372C31322C35303431372C';
wwv_flow_imp.g_varchar2_table(294) := '35303434332C31322C35303437332C35303439392C31322C35303532392C35303535352C31322C35303538352C35303631312C31322C35303634312C35303636372C31322C35303639372C35303732332C31322C35303735332C35303737392C31322C35';
wwv_flow_imp.g_varchar2_table(295) := '303830392C35303833352C31322C35303836352C35303839312C31322C35303932312C35303934372C31322C35303937372C35313030332C31322C35313033332C35313035392C31322C35313038392C35313131352C31322C35313134352C3531313731';
wwv_flow_imp.g_varchar2_table(296) := '2C31322C35313230312C35313232372C31322C35313235372C35313238332C31322C35313331332C35313333392C31322C35313336392C35313339352C31322C35313432352C35313435312C31322C35313438312C35313530372C31322C35313533372C';
wwv_flow_imp.g_varchar2_table(297) := '35313536332C31322C35313539332C35313631392C31322C35313634392C35313637352C31322C35313730352C35313733312C31322C35313736312C35313738372C31322C35313831372C35313834332C31322C35313837332C35313839392C31322C35';
wwv_flow_imp.g_varchar2_table(298) := '313932392C35313935352C31322C35313938352C35323031312C31322C35323034312C35323036372C31322C35323039372C35323132332C31322C35323135332C35323137392C31322C35323230392C35323233352C31322C35323236352C3532323931';
wwv_flow_imp.g_varchar2_table(299) := '2C31322C35323332312C35323334372C31322C35323337372C35323430332C31322C35323433332C35323435392C31322C35323438392C35323531352C31322C35323534352C35323537312C31322C35323630312C35323632372C31322C35323635372C';
wwv_flow_imp.g_varchar2_table(300) := '35323638332C31322C35323731332C35323733392C31322C35323736392C35323739352C31322C35323832352C35323835312C31322C35323838312C35323930372C31322C35323933372C35323936332C31322C35323939332C35333031392C31322C35';
wwv_flow_imp.g_varchar2_table(301) := '333034392C35333037352C31322C35333130352C35333133312C31322C35333136312C35333138372C31322C35333231372C35333234332C31322C35333237332C35333239392C31322C35333332392C35333335352C31322C35333338352C3533343131';
wwv_flow_imp.g_varchar2_table(302) := '2C31322C35333434312C35333436372C31322C35333439372C35333532332C31322C35333535332C35333537392C31322C35333630392C35333633352C31322C35333636352C35333639312C31322C35333732312C35333734372C31322C35333737372C';
wwv_flow_imp.g_varchar2_table(303) := '35333830332C31322C35333833332C35333835392C31322C35333838392C35333931352C31322C35333934352C35333937312C31322C35343030312C35343032372C31322C35343035372C35343038332C31322C35343131332C35343133392C31322C35';
wwv_flow_imp.g_varchar2_table(304) := '343136392C35343139352C31322C35343232352C35343235312C31322C35343238312C35343330372C31322C35343333372C35343336332C31322C35343339332C35343431392C31322C35343434392C35343437352C31322C35343530352C3534353331';
wwv_flow_imp.g_varchar2_table(305) := '2C31322C35343536312C35343538372C31322C35343631372C35343634332C31322C35343637332C35343639392C31322C35343732392C35343735352C31322C35343738352C35343831312C31322C35343834312C35343836372C31322C35343839372C';
wwv_flow_imp.g_varchar2_table(306) := '35343932332C31322C35343935332C35343937392C31322C35353030392C35353033352C31322C35353036352C35353039312C31322C35353132312C35353134372C31322C35353137372C35353230332C31322C36353032342C36353033392C352C3635';
wwv_flow_imp.g_varchar2_table(307) := '3532302C36353532382C342C36363432322C36363432362C352C36383135322C36383135342C352C36393239312C36393239322C352C36393633332C36393633332C352C36393734372C36393734382C352C36393831312C36393831342C352C36393832';
wwv_flow_imp.g_varchar2_table(308) := '362C36393832362C352C36393933322C36393933322C372C37303031362C37303031372C352C37303037392C37303038302C372C37303039352C37303039352C352C37303139362C37303139362C352C37303336372C37303336372C352C37303430322C';
wwv_flow_imp.g_varchar2_table(309) := '37303430332C372C37303436342C37303436342C352C37303438372C37303438372C352C37303730392C37303731312C372C37303732352C37303732352C372C37303833332C37303833342C372C37303834332C37303834342C372C37303834392C3730';
wwv_flow_imp.g_varchar2_table(310) := '3834392C372C37313039302C37313039332C352C37313130332C37313130342C352C37313232372C37313232382C372C37313333392C37313333392C352C37313334342C37313334392C352C37313435382C37313436312C352C37313732372C37313733';
wwv_flow_imp.g_varchar2_table(311) := '352C352C37313938352C37313938392C372C37313939382C37313939382C352C37323030322C37323030322C372C37323135342C37323135352C352C37323139332C37323230322C352C37323235312C37323235342C352C37323238312C37323238332C';
wwv_flow_imp.g_varchar2_table(312) := '352C37323334342C37323334352C352C37323736362C37323736362C372C37323837342C37323838302C352C37323838352C37323838362C352C37333032332C37333032392C352C37333130342C37333130352C352C37333131312C37333131312C352C';
wwv_flow_imp.g_varchar2_table(313) := '39323931322C39323931362C352C39343039352C39343039382C352C3131333832342C3131333832372C342C3131393134322C3131393134322C372C3131393135352C3131393136322C342C3131393336322C3131393336342C352C3132313437362C31';
wwv_flow_imp.g_varchar2_table(314) := '32313437362C352C3132323838382C3132323930342C352C3132333138342C3132333139302C352C3132353235322C3132353235382C352C3132373138332C3132373138332C31342C3132373334302C3132373334332C31342C3132373337372C313237';
wwv_flow_imp.g_varchar2_table(315) := '3338362C31342C3132373439312C3132373530332C31342C3132373534382C3132373535312C31342C3132373734342C3132373735362C31342C3132373736312C3132373736312C31342C3132373736392C3132373736392C31342C3132373737332C31';
wwv_flow_imp.g_varchar2_table(316) := '32373737342C31342C3132373738302C3132373738382C31342C3132373739362C3132373739372C31342C3132373832302C3132373832332C31342C3132373836392C3132373836392C31342C3132373839342C3132373839352C31342C313237393032';
wwv_flow_imp.g_varchar2_table(317) := '2C3132373930332C31342C3132373934332C3132373934332C31342C3132373934372C3132373935302C31342C3132373937322C3132373937322C31342C3132373938382C3132373938382C31342C3132373939322C3132373939342C31342C31323830';
wwv_flow_imp.g_varchar2_table(318) := '30392C3132383031312C31342C3132383031392C3132383031392C31342C3132383032332C3132383034312C31342C3132383036342C3132383036342C31342C3132383130322C3132383130372C31342C3132383137342C3132383138312C31342C3132';
wwv_flow_imp.g_varchar2_table(319) := '383233382C3132383233382C31342C3132383234362C3132383234372C31342C3132383235342C3132383235342C31342C3132383236342C3132383236342C31342C3132383237382C3132383239392C31342C3132383332392C3132383333302C31342C';
wwv_flow_imp.g_varchar2_table(320) := '3132383334382C3132383335392C31342C3132383337312C3132383337372C31342C3132383339322C3132383339332C31342C3132383430312C3132383430342C31342C3132383432312C3132383432312C31342C3132383433332C3132383433342C31';
wwv_flow_imp.g_varchar2_table(321) := '342C3132383435302C3132383435322C31342C3132383437362C3132383437382C31342C3132383438332C3132383438332C31342C3132383439352C3132383439352C31342C3132383530362C3132383530362C31342C3132383531392C313238353230';
wwv_flow_imp.g_varchar2_table(322) := '2C31342C3132383532382C3132383532382C31342C3132383533342C3132383533342C31342C3132383533382C3132383533382C31342C3132383534302C3132383534322C31342C3132383534342C3132383534392C31342C3132383535322C31323835';
wwv_flow_imp.g_varchar2_table(323) := '35352C31342C3132383535372C3132383535372C31342C3132383536302C3132383536332C31342C3132383536352C3132383536352C31342C3132383536372C3132383537362C31342C3132383538312C3132383539312C31342C3132383634312C3132';
wwv_flow_imp.g_varchar2_table(324) := '383634322C31342C3132383634362C3132383634362C31342C3132383634382C3132383634382C31342C3132383635302C3132383635312C31342C3132383635332C3132383635332C31342C3132383635352C3132383635352C31342C3132383635372C';
wwv_flow_imp.g_varchar2_table(325) := '3132383635392C31342C3132383636312C3132383636312C31342C3132383636332C3132383636332C31342C3132383636352C3132383636362C31342C3132383637342C3132383637342C31342C3132383637362C3132383637372C31342C3132383637';
wwv_flow_imp.g_varchar2_table(326) := '392C3132383638352C31342C3132383639302C3132383639302C31342C3132383639342C3132383639342C31342C3132383639372C3132383730322C31342C3132383730342C3132383730342C31342C3132383731302C3132383731342C31342C313238';
wwv_flow_imp.g_varchar2_table(327) := '3731362C3132383731362C31342C3132383732302C3132383732302C31342C3132383732332C3132383732342C31342C3132383732362C3132383732372C31342C3132383733332C3132383733352C31342C3132383734322C3132383734342C31342C31';
wwv_flow_imp.g_varchar2_table(328) := '32383734362C3132383734362C31342C3132383734392C3132383735312C31342C3132383735332C3132383735342C31342C3132383735362C3132383735382C31342C3132383736312C3132383736312C31342C3132383736332C3132383736342C3134';
wwv_flow_imp.g_varchar2_table(329) := '2C3132383838342C3132383839352C31342C3132383939322C3132393030332C31342C3132393030382C3132393030382C31342C3132393033362C3132393033392C31342C3132393131342C3132393131392C31342C3132393139382C3132393237392C';
wwv_flow_imp.g_varchar2_table(330) := '31342C3132393239332C3132393239352C31342C3132393330352C3132393331302C31342C3132393331322C3132393331392C31342C3132393332382C3132393332382C31342C3132393333312C3132393333382C31342C3132393334332C3132393334';
wwv_flow_imp.g_varchar2_table(331) := '332C31342C3132393335312C3132393335352C31342C3132393335372C3132393335392C31342C3132393337352C3132393338372C31342C3132393339332C3132393339332C31342C3132393339352C3132393339382C31342C3132393430312C313239';
wwv_flow_imp.g_varchar2_table(332) := '3430312C31342C3132393430332C3132393430332C31342C3132393430382C3132393431322C31342C3132393432362C3132393433312C31342C3132393434332C3132393434342C31342C3132393435312C3132393435332C31342C3132393435362C31';
wwv_flow_imp.g_varchar2_table(333) := '32393436352C31342C3132393437322C3132393437322C31342C3132393437352C3132393438322C31342C3132393438342C3132393438342C31342C3132393438382C3132393531302C31342C3132393533362C3132393634372C31342C313239363532';
wwv_flow_imp.g_varchar2_table(334) := '2C3132393635322C31342C3132393635362C3132393635382C31342C3132393636312C3132393636332C31342C3132393636372C3132393637302C31342C3132393638302C3132393638352C31342C3132393730352C3132393730382C31342C31323937';
wwv_flow_imp.g_varchar2_table(335) := '31322C3132393731382C31342C3132393732332C3132393732372C31342C3132393733312C3132393733332C31342C3132393734342C3132393735302C31342C3132393735342C3132393735392C31342C3132393736382C3132393737352C31342C3132';
wwv_flow_imp.g_varchar2_table(336) := '393738332C3132393739312C31342C3931373530342C3931373530342C342C3931373530362C3931373533352C342C3931373633322C3931373735392C342C3931383030302C3932313539392C342C302C392C342C31312C31322C342C31342C33312C34';
wwv_flow_imp.g_varchar2_table(337) := '2C3136392C3136392C31342C3137342C3137342C31342C313135352C313135392C352C313432352C313436392C352C313437332C313437342C352C313437392C313437392C352C313535322C313536322C352C313631312C313633312C352C313735302C';
wwv_flow_imp.g_varchar2_table(338) := '313735362C352C313735392C313736342C352C313737302C313737332C352C313830392C313830392C352C313935382C313936382C352C323034352C323034352C352C323037352C323038332C352C323038392C323039332C352C323139322C32313933';
wwv_flow_imp.g_varchar2_table(339) := '2C312C323235302C323237332C352C323237352C323330362C352C323336322C323336322C352C323336342C323336342C352C323336392C323337362C352C323338312C323338312C352C323338352C323339312C352C323433332C323433332C352C32';
wwv_flow_imp.g_varchar2_table(340) := '3439322C323439322C352C323439352C323439362C372C323530332C323530342C372C323530392C323530392C352C323533302C323533312C352C323536312C323536322C352C323632302C323632302C352C323632352C323632362C352C323633352C';
wwv_flow_imp.g_varchar2_table(341) := '323633372C352C323637322C323637332C352C323638392C323639302C352C323734382C323734382C352C323735332C323735372C352C323736312C323736312C372C323736352C323736352C352C323831302C323831352C352C323831382C32383139';
wwv_flow_imp.g_varchar2_table(342) := '2C372C323837382C323837382C352C323838302C323838302C372C323838372C323838382C372C323839332C323839332C352C323930332C323930332C352C323934362C323934362C352C333030372C333030372C372C333030392C333031302C372C33';
wwv_flow_imp.g_varchar2_table(343) := '3031382C333032302C372C333033312C333033312C352C333037332C333037352C372C333133322C333133322C352C333133372C333134302C372C333134362C333134392C352C333137302C333137312C352C333230322C333230332C372C333236322C';
wwv_flow_imp.g_varchar2_table(344) := '333236322C372C333236342C333236352C372C333236372C333236382C372C333237312C333237322C372C333237362C333237372C352C333239382C333239392C352C333333302C333333312C372C333339302C333339302C352C333339332C33333936';
wwv_flow_imp.g_varchar2_table(345) := '2C352C333430322C333430342C372C333430362C333430362C312C333432362C333432372C352C333435382C333435392C372C333533352C333533352C352C333533382C333534302C352C333534342C333535302C372C333537302C333537312C372C33';
wwv_flow_imp.g_varchar2_table(346) := '3633352C333633352C372C333635352C333636322C352C333736332C333736332C372C333738342C333738392C352C333839332C333839332C352C333839372C333839372C352C333935332C333936362C352C333936382C333937322C352C333938312C';
wwv_flow_imp.g_varchar2_table(347) := '333939312C352C343033382C343033382C352C343134352C343134352C372C343135332C343135342C352C343135372C343135382C352C343138342C343138352C352C343230392C343231322C352C343232382C343232382C372C343233372C34323337';
wwv_flow_imp.g_varchar2_table(348) := '2C352C343335322C343434372C382C343532302C343630372C31302C353930362C353930382C352C353933382C353933392C352C353937302C353937312C352C363036382C363036392C352C363037312C363037372C352C363038362C363038362C352C';
wwv_flow_imp.g_varchar2_table(349) := '363038392C363039392C352C363135352C363135372C352C363135392C363135392C352C363331332C363331332C352C363433352C363433382C372C363434312C363434332C372C363435302C363435302C352C363435372C363435392C352C36363831';
wwv_flow_imp.g_varchar2_table(350) := '2C363638322C372C363734312C363734312C372C363734332C363734332C372C363735322C363735322C352C363735372C363736342C352C363737312C363738302C352C363833322C363834352C352C363834372C363836322C352C363931362C363931';
wwv_flow_imp.g_varchar2_table(351) := '362C372C363936352C363936352C352C363937312C363937312C372C363937332C363937372C372C363937392C363938302C372C373034302C373034312C352C373037332C373037332C372C373037382C373037392C372C373038322C373038322C372C';
wwv_flow_imp.g_varchar2_table(352) := '373134322C373134322C352C373134342C373134352C352C373134392C373134392C352C373135312C373135332C352C373230342C373231312C372C373232302C373232312C372C373337362C373337382C352C373339332C373339332C372C37343035';
wwv_flow_imp.g_varchar2_table(353) := '2C373430352C352C373431352C373431352C372C373631362C373637392C352C383230342C383230342C352C383230362C383230372C342C383233332C383233332C342C383235322C383235322C31342C383238382C383239322C342C383239342C3833';
wwv_flow_imp.g_varchar2_table(354) := '30332C342C383431332C383431362C352C383431382C383432302C352C383438322C383438322C31342C383539362C383630312C31342C383938362C383938372C31342C393039362C393039362C31342C393139332C393139362C31342C393139392C39';
wwv_flow_imp.g_varchar2_table(355) := '3139392C31342C393230312C393230322C31342C393230382C393231302C31342C393634322C393634332C31342C393636342C393636342C31342C393732382C393732392C31342C393733322C393733322C31342C393733352C393734312C31342C3937';
wwv_flow_imp.g_varchar2_table(356) := '34332C393734342C31342C393734362C393734362C31342C393735302C393735312C31342C393735332C393735362C31342C393735382C393735392C31342C393736312C393736312C31342C393736342C393736352C31342C393736372C393736392C31';
wwv_flow_imp.g_varchar2_table(357) := '342C393737312C393737332C31342C393737352C393737352C31342C393738342C393738352C31342C393738372C393739312C31342C393739332C393739332C31342C393739352C393739392C31342C393831322C393832322C31342C393832342C3938';
wwv_flow_imp.g_varchar2_table(358) := '32342C31342C393832372C393832372C31342C393832392C393833302C31342C393833322C393833322C31342C393835312C393835312C31342C393835342C393835342C31342C393835362C393836312C31342C393837342C393837342C31342C393837';
wwv_flow_imp.g_varchar2_table(359) := '362C393837362C31342C393837382C393837392C31342C393838312C393838312C31342C393838332C393838342C31342C393838382C393838392C31342C393839352C393839352C31342C393839382C393839392C31342C393930342C393930352C3134';
wwv_flow_imp.g_varchar2_table(360) := '2C393931372C393931382C31342C393932342C393932352C31342C393932382C393932382C31342C393933342C393933342C31342C393933362C393933362C31342C393933382C393933382C31342C393934302C393934302C31342C393936312C393936';
wwv_flow_imp.g_varchar2_table(361) := '312C31342C393936332C393936372C31342C393937302C393937312C31342C393937332C393937332C31342C393937352C393937372C31342C393937392C393938302C31342C393938322C393938352C31342C393938372C393938382C31342C39393932';
wwv_flow_imp.g_varchar2_table(362) := '2C393939362C31342C393939382C393939382C31342C31303030302C31303030312C31342C31303030342C31303030342C31342C31303031332C31303031332C31342C31303032342C31303032342C31342C31303035322C31303035322C31342C313030';
wwv_flow_imp.g_varchar2_table(363) := '36302C31303036302C31342C31303036372C31303036392C31342C31303038332C31303038332C31342C31303038352C31303038372C31342C31303134352C31303134352C31342C31303137352C31303137352C31342C31313031332C31313031352C31';
wwv_flow_imp.g_varchar2_table(364) := '342C31313038382C31313038382C31342C31313530332C31313530352C352C31313734342C31313737352C352C31323333342C31323333352C352C31323334392C31323334392C31342C31323935312C31323935312C31342C34323630372C3432363037';
wwv_flow_imp.g_varchar2_table(365) := '2C352C34323631322C34323632312C352C34323733362C34323733372C352C34333031342C34333031342C352C34333034332C34333034342C372C34333034372C34333034372C372C34333133362C34333133372C372C34333230342C34333230352C35';
wwv_flow_imp.g_varchar2_table(366) := '2C34333236332C34333236332C352C34333333352C34333334352C352C34333336302C34333338382C382C34333339352C34333339352C372C34333434342C34333434352C372C34333435302C34333435312C372C34333435342C34333435362C372C34';
wwv_flow_imp.g_varchar2_table(367) := '333536312C34333536362C352C34333536392C34333537302C352C34333537332C34333537342C352C34333539362C34333539362C352C34333634342C34333634342C352C34333639382C34333730302C352C34333731302C34333731312C352C343337';
wwv_flow_imp.g_varchar2_table(368) := '35352C34333735352C372C34333735382C34333735392C372C34333736362C34333736362C352C34343030352C34343030352C352C34343030382C34343030382C352C34343031322C34343031322C372C34343033322C34343033322C31312C34343036';
wwv_flow_imp.g_varchar2_table(369) := '302C34343036302C31312C34343038382C34343038382C31312C34343131362C34343131362C31312C34343134342C34343134342C31312C34343137322C34343137322C31312C34343230302C34343230302C31312C34343232382C34343232382C3131';
wwv_flow_imp.g_varchar2_table(370) := '2C34343235362C34343235362C31312C34343238342C34343238342C31312C34343331322C34343331322C31312C34343334302C34343334302C31312C34343336382C34343336382C31312C34343339362C34343339362C31312C34343432342C343434';
wwv_flow_imp.g_varchar2_table(371) := '32342C31312C34343435322C34343435322C31312C34343438302C34343438302C31312C34343530382C34343530382C31312C34343533362C34343533362C31312C34343536342C34343536342C31312C34343539322C34343539322C31312C34343632';
wwv_flow_imp.g_varchar2_table(372) := '302C34343632302C31312C34343634382C34343634382C31312C34343637362C34343637362C31312C34343730342C34343730342C31312C34343733322C34343733322C31312C34343736302C34343736302C31312C34343738382C34343738382C3131';
wwv_flow_imp.g_varchar2_table(373) := '2C34343831362C34343831362C31312C34343834342C34343834342C31312C34343837322C34343837322C31312C34343930302C34343930302C31312C34343932382C34343932382C31312C34343935362C34343935362C31312C34343938342C343439';
wwv_flow_imp.g_varchar2_table(374) := '38342C31312C34353031322C34353031322C31312C34353034302C34353034302C31312C34353036382C34353036382C31312C34353039362C34353039362C31312C34353132342C34353132342C31312C34353135322C34353135322C31312C34353138';
wwv_flow_imp.g_varchar2_table(375) := '302C34353138302C31312C34353230382C34353230382C31312C34353233362C34353233362C31312C34353236342C34353236342C31312C34353239322C34353239322C31312C34353332302C34353332302C31312C34353334382C34353334382C3131';
wwv_flow_imp.g_varchar2_table(376) := '2C34353337362C34353337362C31312C34353430342C34353430342C31312C34353433322C34353433322C31312C34353436302C34353436302C31312C34353438382C34353438382C31312C34353531362C34353531362C31312C34353534342C343535';
wwv_flow_imp.g_varchar2_table(377) := '34342C31312C34353537322C34353537322C31312C34353630302C34353630302C31312C34353632382C34353632382C31312C34353635362C34353635362C31312C34353638342C34353638342C31312C34353731322C34353731322C31312C34353734';
wwv_flow_imp.g_varchar2_table(378) := '302C34353734302C31312C34353736382C34353736382C31312C34353739362C34353739362C31312C34353832342C34353832342C31312C34353835322C34353835322C31312C34353838302C34353838302C31312C34353930382C34353930382C3131';
wwv_flow_imp.g_varchar2_table(379) := '2C34353933362C34353933362C31312C34353936342C34353936342C31312C34353939322C34353939322C31312C34363032302C34363032302C31312C34363034382C34363034382C31312C34363037362C34363037362C31312C34363130342C343631';
wwv_flow_imp.g_varchar2_table(380) := '30342C31312C34363133322C34363133322C31312C34363136302C34363136302C31312C34363138382C34363138382C31312C34363231362C34363231362C31312C34363234342C34363234342C31312C34363237322C34363237322C31312C34363330';
wwv_flow_imp.g_varchar2_table(381) := '302C34363330302C31312C34363332382C34363332382C31312C34363335362C34363335362C31312C34363338342C34363338342C31312C34363431322C34363431322C31312C34363434302C34363434302C31312C34363436382C34363436382C3131';
wwv_flow_imp.g_varchar2_table(382) := '2C34363439362C34363439362C31312C34363532342C34363532342C31312C34363535322C34363535322C31312C34363538302C34363538302C31312C34363630382C34363630382C31312C34363633362C34363633362C31312C34363636342C343636';
wwv_flow_imp.g_varchar2_table(383) := '36342C31312C34363639322C34363639322C31312C34363732302C34363732302C31312C34363734382C34363734382C31312C34363737362C34363737362C31312C34363830342C34363830342C31312C34363833322C34363833322C31312C34363836';
wwv_flow_imp.g_varchar2_table(384) := '302C34363836302C31312C34363838382C34363838382C31312C34363931362C34363931362C31312C34363934342C34363934342C31312C34363937322C34363937322C31312C34373030302C34373030302C31312C34373032382C34373032382C3131';
wwv_flow_imp.g_varchar2_table(385) := '2C34373035362C34373035362C31312C34373038342C34373038342C31312C34373131322C34373131322C31312C34373134302C34373134302C31312C34373136382C34373136382C31312C34373139362C34373139362C31312C34373232342C343732';
wwv_flow_imp.g_varchar2_table(386) := '32342C31312C34373235322C34373235322C31312C34373238302C34373238302C31312C34373330382C34373330382C31312C34373333362C34373333362C31312C34373336342C34373336342C31312C34373339322C34373339322C31312C34373432';
wwv_flow_imp.g_varchar2_table(387) := '302C34373432302C31312C34373434382C34373434382C31312C34373437362C34373437362C31312C34373530342C34373530342C31312C34373533322C34373533322C31312C34373536302C34373536302C31312C34373538382C34373538382C3131';
wwv_flow_imp.g_varchar2_table(388) := '2C34373631362C34373631362C31312C34373634342C34373634342C31312C34373637322C34373637322C31312C34373730302C34373730302C31312C34373732382C34373732382C31312C34373735362C34373735362C31312C34373738342C343737';
wwv_flow_imp.g_varchar2_table(389) := '38342C31312C34373831322C34373831322C31312C34373834302C34373834302C31312C34373836382C34373836382C31312C34373839362C34373839362C31312C34373932342C34373932342C31312C34373935322C34373935322C31312C34373938';
wwv_flow_imp.g_varchar2_table(390) := '302C34373938302C31312C34383030382C34383030382C31312C34383033362C34383033362C31312C34383036342C34383036342C31312C34383039322C34383039322C31312C34383132302C34383132302C31312C34383134382C34383134382C3131';
wwv_flow_imp.g_varchar2_table(391) := '2C34383137362C34383137362C31312C34383230342C34383230342C31312C34383233322C34383233322C31312C34383236302C34383236302C31312C34383238382C34383238382C31312C34383331362C34383331362C31312C34383334342C343833';
wwv_flow_imp.g_varchar2_table(392) := '34342C31312C34383337322C34383337322C31312C34383430302C34383430302C31312C34383432382C34383432382C31312C34383435362C34383435362C31312C34383438342C34383438342C31312C34383531322C34383531322C31312C34383534';
wwv_flow_imp.g_varchar2_table(393) := '302C34383534302C31312C34383536382C34383536382C31312C34383539362C34383539362C31312C34383632342C34383632342C31312C34383635322C34383635322C31312C34383638302C34383638302C31312C34383730382C34383730382C3131';
wwv_flow_imp.g_varchar2_table(394) := '2C34383733362C34383733362C31312C34383736342C34383736342C31312C34383739322C34383739322C31312C34383832302C34383832302C31312C34383834382C34383834382C31312C34383837362C34383837362C31312C34383930342C343839';
wwv_flow_imp.g_varchar2_table(395) := '30342C31312C34383933322C34383933322C31312C34383936302C34383936302C31312C34383938382C34383938382C31312C34393031362C34393031362C31312C34393034342C34393034342C31312C34393037322C34393037322C31312C34393130';
wwv_flow_imp.g_varchar2_table(396) := '302C34393130302C31312C34393132382C34393132382C31312C34393135362C34393135362C31312C34393138342C34393138342C31312C34393231322C34393231322C31312C34393234302C34393234302C31312C34393236382C34393236382C3131';
wwv_flow_imp.g_varchar2_table(397) := '2C34393239362C34393239362C31312C34393332342C34393332342C31312C34393335322C34393335322C31312C34393338302C34393338302C31312C34393430382C34393430382C31312C34393433362C34393433362C31312C34393436342C343934';
wwv_flow_imp.g_varchar2_table(398) := '36342C31312C34393439322C34393439322C31312C34393532302C34393532302C31312C34393534382C34393534382C31312C34393537362C34393537362C31312C34393630342C34393630342C31312C34393633322C34393633322C31312C34393636';
wwv_flow_imp.g_varchar2_table(399) := '302C34393636302C31312C34393638382C34393638382C31312C34393731362C34393731362C31312C34393734342C34393734342C31312C34393737322C34393737322C31312C34393830302C34393830302C31312C34393832382C34393832382C3131';
wwv_flow_imp.g_varchar2_table(400) := '2C34393835362C34393835362C31312C34393838342C34393838342C31312C34393931322C34393931322C31312C34393934302C34393934302C31312C34393936382C34393936382C31312C34393939362C34393939362C31312C35303032342C353030';
wwv_flow_imp.g_varchar2_table(401) := '32342C31312C35303035322C35303035322C31312C35303038302C35303038302C31312C35303130382C35303130382C31312C35303133362C35303133362C31312C35303136342C35303136342C31312C35303139322C35303139322C31312C35303232';
wwv_flow_imp.g_varchar2_table(402) := '302C35303232302C31312C35303234382C35303234382C31312C35303237362C35303237362C31312C35303330342C35303330342C31312C35303333322C35303333322C31312C35303336302C35303336302C31312C35303338382C35303338382C3131';
wwv_flow_imp.g_varchar2_table(403) := '2C35303431362C35303431362C31312C35303434342C35303434342C31312C35303437322C35303437322C31312C35303530302C35303530302C31312C35303532382C35303532382C31312C35303535362C35303535362C31312C35303538342C353035';
wwv_flow_imp.g_varchar2_table(404) := '38342C31312C35303631322C35303631322C31312C35303634302C35303634302C31312C35303636382C35303636382C31312C35303639362C35303639362C31312C35303732342C35303732342C31312C35303735322C35303735322C31312C35303738';
wwv_flow_imp.g_varchar2_table(405) := '302C35303738302C31312C35303830382C35303830382C31312C35303833362C35303833362C31312C35303836342C35303836342C31312C35303839322C35303839322C31312C35303932302C35303932302C31312C35303934382C35303934382C3131';
wwv_flow_imp.g_varchar2_table(406) := '2C35303937362C35303937362C31312C35313030342C35313030342C31312C35313033322C35313033322C31312C35313036302C35313036302C31312C35313038382C35313038382C31312C35313131362C35313131362C31312C35313134342C353131';
wwv_flow_imp.g_varchar2_table(407) := '34342C31312C35313137322C35313137322C31312C35313230302C35313230302C31312C35313232382C35313232382C31312C35313235362C35313235362C31312C35313238342C35313238342C31312C35313331322C35313331322C31312C35313334';
wwv_flow_imp.g_varchar2_table(408) := '302C35313334302C31312C35313336382C35313336382C31312C35313339362C35313339362C31312C35313432342C35313432342C31312C35313435322C35313435322C31312C35313438302C35313438302C31312C35313530382C35313530382C3131';
wwv_flow_imp.g_varchar2_table(409) := '2C35313533362C35313533362C31312C35313536342C35313536342C31312C35313539322C35313539322C31312C35313632302C35313632302C31312C35313634382C35313634382C31312C35313637362C35313637362C31312C35313730342C353137';
wwv_flow_imp.g_varchar2_table(410) := '30342C31312C35313733322C35313733322C31312C35313736302C35313736302C31312C35313738382C35313738382C31312C35313831362C35313831362C31312C35313834342C35313834342C31312C35313837322C35313837322C31312C35313930';
wwv_flow_imp.g_varchar2_table(411) := '302C35313930302C31312C35313932382C35313932382C31312C35313935362C35313935362C31312C35313938342C35313938342C31312C35323031322C35323031322C31312C35323034302C35323034302C31312C35323036382C35323036382C3131';
wwv_flow_imp.g_varchar2_table(412) := '2C35323039362C35323039362C31312C35323132342C35323132342C31312C35323135322C35323135322C31312C35323138302C35323138302C31312C35323230382C35323230382C31312C35323233362C35323233362C31312C35323236342C353232';
wwv_flow_imp.g_varchar2_table(413) := '36342C31312C35323239322C35323239322C31312C35323332302C35323332302C31312C35323334382C35323334382C31312C35323337362C35323337362C31312C35323430342C35323430342C31312C35323433322C35323433322C31312C35323436';
wwv_flow_imp.g_varchar2_table(414) := '302C35323436302C31312C35323438382C35323438382C31312C35323531362C35323531362C31312C35323534342C35323534342C31312C35323537322C35323537322C31312C35323630302C35323630302C31312C35323632382C35323632382C3131';
wwv_flow_imp.g_varchar2_table(415) := '2C35323635362C35323635362C31312C35323638342C35323638342C31312C35323731322C35323731322C31312C35323734302C35323734302C31312C35323736382C35323736382C31312C35323739362C35323739362C31312C35323832342C353238';
wwv_flow_imp.g_varchar2_table(416) := '32342C31312C35323835322C35323835322C31312C35323838302C35323838302C31312C35323930382C35323930382C31312C35323933362C35323933362C31312C35323936342C35323936342C31312C35323939322C35323939322C31312C35333032';
wwv_flow_imp.g_varchar2_table(417) := '302C35333032302C31312C35333034382C35333034382C31312C35333037362C35333037362C31312C35333130342C35333130342C31312C35333133322C35333133322C31312C35333136302C35333136302C31312C35333138382C35333138382C3131';
wwv_flow_imp.g_varchar2_table(418) := '2C35333231362C35333231362C31312C35333234342C35333234342C31312C35333237322C35333237322C31312C35333330302C35333330302C31312C35333332382C35333332382C31312C35333335362C35333335362C31312C35333338342C353333';
wwv_flow_imp.g_varchar2_table(419) := '38342C31312C35333431322C35333431322C31312C35333434302C35333434302C31312C35333436382C35333436382C31312C35333439362C35333439362C31312C35333532342C35333532342C31312C35333535322C35333535322C31312C35333538';
wwv_flow_imp.g_varchar2_table(420) := '302C35333538302C31312C35333630382C35333630382C31312C35333633362C35333633362C31312C35333636342C35333636342C31312C35333639322C35333639322C31312C35333732302C35333732302C31312C35333734382C35333734382C3131';
wwv_flow_imp.g_varchar2_table(421) := '2C35333737362C35333737362C31312C35333830342C35333830342C31312C35333833322C35333833322C31312C35333836302C35333836302C31312C35333838382C35333838382C31312C35333931362C35333931362C31312C35333934342C353339';
wwv_flow_imp.g_varchar2_table(422) := '34342C31312C35333937322C35333937322C31312C35343030302C35343030302C31312C35343032382C35343032382C31312C35343035362C35343035362C31312C35343038342C35343038342C31312C35343131322C35343131322C31312C35343134';
wwv_flow_imp.g_varchar2_table(423) := '302C35343134302C31312C35343136382C35343136382C31312C35343139362C35343139362C31312C35343232342C35343232342C31312C35343235322C35343235322C31312C35343238302C35343238302C31312C35343330382C35343330382C3131';
wwv_flow_imp.g_varchar2_table(424) := '2C35343333362C35343333362C31312C35343336342C35343336342C31312C35343339322C35343339322C31312C35343432302C35343432302C31312C35343434382C35343434382C31312C35343437362C35343437362C31312C35343530342C353435';
wwv_flow_imp.g_varchar2_table(425) := '30342C31312C35343533322C35343533322C31312C35343536302C35343536302C31312C35343538382C35343538382C31312C35343631362C35343631362C31312C35343634342C35343634342C31312C35343637322C35343637322C31312C35343730';
wwv_flow_imp.g_varchar2_table(426) := '302C35343730302C31312C35343732382C35343732382C31312C35343735362C35343735362C31312C35343738342C35343738342C31312C35343831322C35343831322C31312C35343834302C35343834302C31312C35343836382C35343836382C3131';
wwv_flow_imp.g_varchar2_table(427) := '2C35343839362C35343839362C31312C35343932342C35343932342C31312C35343935322C35343935322C31312C35343938302C35343938302C31312C35353030382C35353030382C31312C35353033362C35353033362C31312C35353036342C353530';
wwv_flow_imp.g_varchar2_table(428) := '36342C31312C35353039322C35353039322C31312C35353132302C35353132302C31312C35353134382C35353134382C31312C35353137362C35353137362C31312C35353231362C35353233382C392C36343238362C36343238362C352C36353035362C';
wwv_flow_imp.g_varchar2_table(429) := '36353037312C352C36353433382C36353433392C352C36353532392C36353533312C342C36363237322C36363237322C352C36383039372C36383039392C352C36383130382C36383131312C352C36383135392C36383135392C352C36383930302C3638';
wwv_flow_imp.g_varchar2_table(430) := '3930332C352C36393434362C36393435362C352C36393633322C36393633322C372C36393633342C36393633342C372C36393734342C36393734342C352C36393735392C36393736312C352C36393830382C36393831302C372C36393831352C36393831';
wwv_flow_imp.g_varchar2_table(431) := '362C372C36393832312C36393832312C312C36393833372C36393833372C312C36393932372C36393933312C352C36393933332C36393934302C352C37303030332C37303030332C352C37303031382C37303031382C372C37303037302C37303037382C';
wwv_flow_imp.g_varchar2_table(432) := '352C37303038322C37303038332C312C37303039342C37303039342C372C37303138382C37303139302C372C37303139342C37303139352C372C37303139372C37303139372C372C37303230362C37303230362C352C37303336382C37303337302C372C';
wwv_flow_imp.g_varchar2_table(433) := '37303430302C37303430312C352C37303435392C37303436302C352C37303436332C37303436332C372C37303436352C37303436382C372C37303437352C37303437372C372C37303439382C37303439392C372C37303531322C37303531362C352C3730';
wwv_flow_imp.g_varchar2_table(434) := '3731322C37303731392C352C37303732322C37303732342C352C37303732362C37303732362C352C37303833322C37303833322C352C37303833352C37303834302C352C37303834322C37303834322C352C37303834352C37303834352C352C37303834';
wwv_flow_imp.g_varchar2_table(435) := '372C37303834382C352C37303835302C37303835312C352C37313038382C37313038392C372C37313039362C37313039392C372C37313130322C37313130322C372C37313133322C37313133332C352C37313231392C37313232362C352C37313232392C';
wwv_flow_imp.g_varchar2_table(436) := '37313232392C352C37313233312C37313233322C352C37313334302C37313334302C372C37313334322C37313334332C372C37313335302C37313335302C372C37313435332C37313435352C352C37313436322C37313436322C372C37313732342C3731';
wwv_flow_imp.g_varchar2_table(437) := '3732362C372C37313733362C37313733362C372C37313938342C37313938342C352C37313939312C37313939322C372C37313939372C37313939372C372C37313939392C37313939392C312C37323030312C37323030312C312C37323030332C37323030';
wwv_flow_imp.g_varchar2_table(438) := '332C352C37323134382C37323135312C352C37323135362C37323135392C372C37323136342C37323136342C372C37323234332C37323234382C352C37323235302C37323235302C312C37323236332C37323236332C352C37323237392C37323238302C';
wwv_flow_imp.g_varchar2_table(439) := '372C37323332342C37323332392C312C37323334332C37323334332C372C37323735312C37323735312C372C37323736302C37323736352C352C37323736372C37323736372C352C37323837332C37323837332C372C37323838312C37323838312C372C';
wwv_flow_imp.g_varchar2_table(440) := '37323838342C37323838342C372C37333030392C37333031342C352C37333032302C37333032312C352C37333033302C37333033302C312C37333039382C37333130322C372C37333130372C37333130382C372C37333131302C37333131302C372C3733';
wwv_flow_imp.g_varchar2_table(441) := '3435392C37333436302C352C37383839362C37383930342C342C39323937362C39323938322C352C39343033332C39343038372C372C39343138302C39343138302C352C3131333832312C3131333832322C352C3131383532382C3131383537332C352C';
wwv_flow_imp.g_varchar2_table(442) := '3131393134312C3131393134312C352C3131393134332C3131393134352C352C3131393135302C3131393135342C352C3131393136332C3131393137302C352C3131393231302C3131393231332C352C3132313334342C3132313339382C352C31323134';
wwv_flow_imp.g_varchar2_table(443) := '36312C3132313436312C352C3132313439392C3132313530332C352C3132323838302C3132323838362C352C3132323930372C3132323931332C352C3132323931382C3132323932322C352C3132333536362C3132333536362C352C3132353133362C31';
wwv_flow_imp.g_varchar2_table(444) := '32353134322C352C3132363937362C3132363937392C31342C3132363938312C3132373138322C31342C3132373138342C3132373233312C31342C3132373237392C3132373237392C31342C3132373334342C3132373334352C31342C3132373337342C';
wwv_flow_imp.g_varchar2_table(445) := '3132373337342C31342C3132373430352C3132373436312C31342C3132373438392C3132373439302C31342C3132373531342C3132373531342C31342C3132373533382C3132373534362C31342C3132373536312C3132373536372C31342C3132373537';
wwv_flow_imp.g_varchar2_table(446) := '302C3132373734332C31342C3132373735372C3132373735382C31342C3132373736302C3132373736302C31342C3132373736322C3132373736322C31342C3132373736362C3132373736382C31342C3132373737302C3132373737302C31342C313237';
wwv_flow_imp.g_varchar2_table(447) := '3737322C3132373737322C31342C3132373737352C3132373737362C31342C3132373737382C3132373737392C31342C3132373738392C3132373739312C31342C3132373739342C3132373739352C31342C3132373739382C3132373739382C31342C31';
wwv_flow_imp.g_varchar2_table(448) := '32373831392C3132373831392C31342C3132373832342C3132373832342C31342C3132373836382C3132373836382C31342C3132373837302C3132373837312C31342C3132373839322C3132373839332C31342C3132373839362C3132373839362C3134';
wwv_flow_imp.g_varchar2_table(449) := '2C3132373930302C3132373930312C31342C3132373930342C3132373934302C31342C3132373934322C3132373934322C31342C3132373934342C3132373934342C31342C3132373934362C3132373934362C31342C3132373935312C3132373935352C';
wwv_flow_imp.g_varchar2_table(450) := '31342C3132373936382C3132373937312C31342C3132373937332C3132373938342C31342C3132373938372C3132373938372C31342C3132373938392C3132373938392C31342C3132373939312C3132373939312C31342C3132373939352C3132373939';
wwv_flow_imp.g_varchar2_table(451) := '392C352C3132383030382C3132383030382C31342C3132383031322C3132383031342C31342C3132383031372C3132383031382C31342C3132383032302C3132383032302C31342C3132383032322C3132383032322C31342C3132383034322C31323830';
wwv_flow_imp.g_varchar2_table(452) := '34322C31342C3132383036332C3132383036332C31342C3132383036352C3132383036352C31342C3132383130312C3132383130312C31342C3132383130382C3132383130392C31342C3132383137332C3132383137332C31342C3132383138322C3132';
wwv_flow_imp.g_varchar2_table(453) := '383138332C31342C3132383233362C3132383233372C31342C3132383233392C3132383233392C31342C3132383234352C3132383234352C31342C3132383234382C3132383234382C31342C3132383235332C3132383235332C31342C3132383235352C';
wwv_flow_imp.g_varchar2_table(454) := '3132383235382C31342C3132383236302C3132383236332C31342C3132383236352C3132383236352C31342C3132383237372C3132383237372C31342C3132383330302C3132383330312C31342C3132383332362C3132383332382C31342C3132383333';
wwv_flow_imp.g_varchar2_table(455) := '312C3132383333342C31342C3132383333362C3132383334372C31342C3132383336302C3132383336362C31342C3132383336392C3132383337302C31342C3132383337382C3132383337382C31342C3132383339312C3132383339312C31342C313238';
wwv_flow_imp.g_varchar2_table(456) := '3339342C3132383339372C31342C3132383430302C3132383430302C31342C3132383430352C3132383430362C31342C3132383432302C3132383432302C31342C3132383432322C3132383432332C31342C3132383432352C3132383433322C31342C31';
wwv_flow_imp.g_varchar2_table(457) := '32383433352C3132383434332C31342C3132383434352C3132383434392C31342C3132383435332C3132383436342C31342C3132383436382C3132383437352C31342C3132383437392C3132383438302C31342C3132383438322C3132383438322C3134';
wwv_flow_imp.g_varchar2_table(458) := '2C3132383438342C3132383438372C31342C3132383438392C3132383439342C31342C3132383439362C3132383439382C31342C3132383530302C3132383530352C31342C3132383530372C3132383531312C31342C3132383531332C3132383531382C';
wwv_flow_imp.g_varchar2_table(459) := '31342C3132383532312C3132383532352C31342C3132383532372C3132383532372C31342C3132383532392C3132383532392C31342C3132383533332C3132383533332C31342C3132383533352C3132383533352C31342C3132383533372C3132383533';
wwv_flow_imp.g_varchar2_table(460) := '372C31345D22297D6765744772617068656D65427265616B547970652865297B696628653C33322972657475726E2031303D3D3D653F333A31333D3D3D653F323A343B696628653C3132372972657475726E20303B636F6E737420743D746869732E5F64';
wwv_flow_imp.g_varchar2_table(461) := '6174612C6E3D742E6C656E6774682F333B6C657420693D313B666F72283B693C3D6E3B29696628653C745B332A695D29692A3D323B656C73657B6966282128653E745B332A692B315D292972657475726E20745B332A692B325D3B693D322A692B317D72';
wwv_flow_imp.g_varchar2_table(462) := '657475726E20307D7D70652E5F494E5354414E43453D6E756C6C3B636C6173732066657B73746174696320676574496E7374616E63652865297B72657475726E2073652E63616368652E6765742841727261792E66726F6D286529297D73746174696320';
wwv_flow_imp.g_varchar2_table(463) := '6765744C6F63616C657328297B72657475726E2073652E5F6C6F63616C65732E76616C75657D636F6E7374727563746F722865297B746869732E636F6E66757361626C6544696374696F6E6172793D657D6973416D626967756F75732865297B72657475';
wwv_flow_imp.g_varchar2_table(464) := '726E20746869732E636F6E66757361626C6544696374696F6E6172792E6861732865297D6765745072696D617279436F6E66757361626C652865297B72657475726E20746869732E636F6E66757361626C6544696374696F6E6172792E6765742865297D';
wwv_flow_imp.g_varchar2_table(465) := '676574436F6E66757361626C65436F6465506F696E747328297B72657475726E206E65772053657428746869732E636F6E66757361626C6544696374696F6E6172792E6B6579732829297D7D73653D66652C66652E616D626967756F7573436861726163';
wwv_flow_imp.g_varchar2_table(466) := '746572446174613D6E6577206165282828293D3E4A534F4E2E706172736528277B225F636F6D6D6F6E223A5B383233322C33322C383233332C33322C353736302C33322C383139322C33322C383139332C33322C383139342C33322C383139352C33322C';
wwv_flow_imp.g_varchar2_table(467) := '383139362C33322C383139372C33322C383139382C33322C383230302C33322C383230312C33322C383230322C33322C383238372C33322C383139392C33322C383233392C33322C323034322C39352C36353130312C39352C36353130322C39352C3635';
wwv_flow_imp.g_varchar2_table(468) := '3130332C39352C383230382C34352C383230392C34352C383231302C34352C36353131322C34352C313734382C34352C383235392C34352C3732372C34352C383732322C34352C31303133342C34352C31313435302C34352C313534392C34342C313634';
wwv_flow_imp.g_varchar2_table(469) := '332C34342C383231382C34342C3138342C34342C34323233332C34342C3839342C35392C323330372C35382C323639312C35382C313431372C35382C313739352C35382C313739362C35382C353836382C35382C36353037322C35382C363134372C3538';
wwv_flow_imp.g_varchar2_table(470) := '2C363135332C35382C383238322C35382C313437352C35382C3736302C35382C34323838392C35382C383735382C35382C3732302C35382C34323233372C35382C3435312C33332C31313630312C33332C3636302C36332C3537372C36332C323432392C';
wwv_flow_imp.g_varchar2_table(471) := '36332C353033382C36332C34323733312C36332C3131393134392C34362C383232382C34362C313739332C34362C313739342C34362C34323531302C34362C36383137362C34362C313633322C34362C313737362C34362C34323233322C34362C313337';
wwv_flow_imp.g_varchar2_table(472) := '332C39362C36353238372C39362C383231392C39362C383234322C39362C313337302C39362C313532332C39362C383137352C39362C36353334342C39362C3930302C39362C383138392C39362C383132352C39362C383132372C39362C383139302C39';
wwv_flow_imp.g_varchar2_table(473) := '362C3639372C39362C3838342C39362C3731322C39362C3731342C39362C3731352C39362C3735362C39362C3639392C39362C3730312C39362C3730302C39362C3730322C39362C34323839322C39362C313439372C39362C323033362C39362C323033';
wwv_flow_imp.g_varchar2_table(474) := '372C39362C353139342C39362C353833362C39362C39343033332C39362C39343033342C39362C36353333392C39312C31303038382C34302C31303039382C34302C31323330382C34302C36343833302C34302C36353334312C39332C31303038392C34';
wwv_flow_imp.g_varchar2_table(475) := '312C31303039392C34312C31323330392C34312C36343833312C34312C31303130302C3132332C3131393036302C3132332C31303130312C3132352C36353334322C39342C383237302C34322C313634352C34322C383732372C34322C36363333352C34';
wwv_flow_imp.g_varchar2_table(476) := '322C353934312C34372C383235372C34372C383732352C34372C383236302C34372C393538352C34372C31303138372C34372C31303734342C34372C3131393335342C34372C31323735352C34372C31323333392C34372C31313436322C34372C323030';
wwv_flow_imp.g_varchar2_table(477) := '33312C34372C31323033352C34372C36353334302C39322C36353132382C39322C383732362C39322C31303138392C39322C31303734312C39322C31303734352C39322C3131393331312C39322C3131393335352C39322C31323735362C39322C323030';
wwv_flow_imp.g_varchar2_table(478) := '32322C39322C31323033342C39322C34323837322C33382C3730382C39342C3731302C39342C353836392C34332C31303133332C34332C36363230332C34332C383234392C36302C31303039342C36302C3730362C36302C3131393335302C36302C3531';
wwv_flow_imp.g_varchar2_table(479) := '37362C36302C353831302C36302C353132302C36312C31313834302C36312C31323434382C36312C34323233392C36312C383235302C36322C31303039352C36322C3730372C36322C3131393335312C36322C353137312C36322C39343031352C36322C';
wwv_flow_imp.g_varchar2_table(480) := '383237352C3132362C3733322C3132362C383132382C3132362C383736342C3132362C36353337322C3132342C36353239332C34352C3132303738342C35302C3132303739342C35302C3132303830342C35302C3132303831342C35302C313230383234';
wwv_flow_imp.g_varchar2_table(481) := '2C35302C3133303033342C35302C34323834322C35302C3432332C35302C313030302C35302C34323536342C35302C353331312C35302C34323733352C35302C3131393330322C35312C3132303738352C35312C3132303739352C35312C313230383035';
wwv_flow_imp.g_varchar2_table(482) := '2C35312C3132303831352C35312C3132303832352C35312C3133303033352C35312C34323932332C35312C3534302C35312C3433392C35312C34323835382C35312C31313436382C35312C313234382C35312C39343031312C35312C37313838322C3531';
wwv_flow_imp.g_varchar2_table(483) := '2C3132303738362C35322C3132303739362C35322C3132303830362C35322C3132303831362C35322C3132303832362C35322C3133303033362C35322C353037302C35322C37313835352C35322C3132303738372C35332C3132303739372C35332C3132';
wwv_flow_imp.g_varchar2_table(484) := '303830372C35332C3132303831372C35332C3132303832372C35332C3133303033372C35332C3434342C35332C37313836372C35332C3132303738382C35342C3132303739382C35342C3132303830382C35342C3132303831382C35342C313230383238';
wwv_flow_imp.g_varchar2_table(485) := '2C35342C3133303033382C35342C31313437342C35342C353130322C35342C37313839332C35342C3131393331342C35352C3132303738392C35352C3132303739392C35352C3132303830392C35352C3132303831392C35352C3132303832392C35352C';
wwv_flow_imp.g_varchar2_table(486) := '3133303033392C35352C36363737302C35352C37313837382C35352C323831392C35362C323533382C35362C323636362C35362C3132353133312C35362C3132303739302C35362C3132303830302C35362C3132303831302C35362C3132303832302C35';
wwv_flow_imp.g_varchar2_table(487) := '362C3132303833302C35362C3133303034302C35362C3534372C35362C3534362C35362C36363333302C35362C323636332C35372C323932302C35372C323534312C35372C333433372C35372C3132303739312C35372C3132303830312C35372C313230';
wwv_flow_imp.g_varchar2_table(488) := '3831312C35372C3132303832312C35372C3132303833312C35372C3133303034312C35372C34323836322C35372C31313436362C35372C37313838342C35372C37313835322C35372C37313839342C35372C393038322C39372C36353334352C39372C31';
wwv_flow_imp.g_varchar2_table(489) := '31393833342C39372C3131393838362C39372C3131393933382C39372C3131393939302C39372C3132303034322C39372C3132303039342C39372C3132303134362C39372C3132303139382C39372C3132303235302C39372C3132303330322C39372C31';
wwv_flow_imp.g_varchar2_table(490) := '32303335342C39372C3132303430362C39372C3132303435382C39372C3539332C39372C3934352C39372C3132303531342C39372C3132303537322C39372C3132303633302C39372C3132303638382C39372C3132303734362C39372C36353331332C36';
wwv_flow_imp.g_varchar2_table(491) := '352C3131393830382C36352C3131393836302C36352C3131393931322C36352C3131393936342C36352C3132303031362C36352C3132303036382C36352C3132303132302C36352C3132303137322C36352C3132303232342C36352C3132303237362C36';
wwv_flow_imp.g_varchar2_table(492) := '352C3132303332382C36352C3132303338302C36352C3132303433322C36352C3931332C36352C3132303438382C36352C3132303534362C36352C3132303630342C36352C3132303636322C36352C3132303732302C36352C353033342C36352C353537';
wwv_flow_imp.g_varchar2_table(493) := '332C36352C34323232322C36352C39343031362C36352C36363230382C36352C3131393833352C39382C3131393838372C39382C3131393933392C39382C3131393939312C39382C3132303034332C39382C3132303039352C39382C3132303134372C39';
wwv_flow_imp.g_varchar2_table(494) := '382C3132303139392C39382C3132303235312C39382C3132303330332C39382C3132303335352C39382C3132303430372C39382C3132303435392C39382C3338382C39382C353037312C39382C353233342C39382C353535312C39382C36353331342C36';
wwv_flow_imp.g_varchar2_table(495) := '362C383439322C36362C3131393830392C36362C3131393836312C36362C3131393931332C36362C3132303031372C36362C3132303036392C36362C3132303132312C36362C3132303137332C36362C3132303232352C36362C3132303237372C36362C';
wwv_flow_imp.g_varchar2_table(496) := '3132303332392C36362C3132303338312C36362C3132303433332C36362C34323933322C36362C3931342C36362C3132303438392C36362C3132303534372C36362C3132303630352C36362C3132303636332C36362C3132303732312C36362C35313038';
wwv_flow_imp.g_varchar2_table(497) := '2C36362C353632332C36362C34323139322C36362C36363137382C36362C36363230392C36362C36363330352C36362C36353334372C39392C383537332C39392C3131393833362C39392C3131393838382C39392C3131393934302C39392C3131393939';
wwv_flow_imp.g_varchar2_table(498) := '322C39392C3132303034342C39392C3132303039362C39392C3132303134382C39392C3132303230302C39392C3132303235322C39392C3132303330342C39392C3132303335362C39392C3132303430382C39392C3132303436302C39392C373432382C';
wwv_flow_imp.g_varchar2_table(499) := '39392C313031302C39392C31313432392C39392C34333935312C39392C36363632312C39392C3132383834342C36372C37313932322C36372C37313931332C36372C36353331352C36372C383535372C36372C383435302C36372C383439332C36372C31';
wwv_flow_imp.g_varchar2_table(500) := '31393831302C36372C3131393836322C36372C3131393931342C36372C3131393936362C36372C3132303031382C36372C3132303137342C36372C3132303232362C36372C3132303237382C36372C3132303333302C36372C3132303338322C36372C31';
wwv_flow_imp.g_varchar2_table(501) := '32303433342C36372C313031372C36372C31313432382C36372C353038372C36372C34323230322C36372C36363231302C36372C36363330362C36372C36363538312C36372C36363834342C36372C383537342C3130302C383531382C3130302C313139';
wwv_flow_imp.g_varchar2_table(502) := '3833372C3130302C3131393838392C3130302C3131393934312C3130302C3131393939332C3130302C3132303034352C3130302C3132303039372C3130302C3132303134392C3130302C3132303230312C3130302C3132303235332C3130302C31323033';
wwv_flow_imp.g_varchar2_table(503) := '30352C3130302C3132303335372C3130302C3132303430392C3130302C3132303436312C3130302C313238312C3130302C353039352C3130302C353233312C3130302C34323139342C3130302C383535382C36382C383531372C36382C3131393831312C';
wwv_flow_imp.g_varchar2_table(504) := '36382C3131393836332C36382C3131393931352C36382C3131393936372C36382C3132303031392C36382C3132303037312C36382C3132303132332C36382C3132303137352C36382C3132303232372C36382C3132303237392C36382C3132303333312C';
wwv_flow_imp.g_varchar2_table(505) := '36382C3132303338332C36382C3132303433352C36382C353032342C36382C353539382C36382C353631302C36382C34323139352C36382C383439342C3130312C36353334392C3130312C383439352C3130312C383531392C3130312C3131393833382C';
wwv_flow_imp.g_varchar2_table(506) := '3130312C3131393839302C3130312C3131393934322C3130312C3132303034362C3130312C3132303039382C3130312C3132303135302C3130312C3132303230322C3130312C3132303235342C3130312C3132303330362C3130312C3132303335382C31';
wwv_flow_imp.g_varchar2_table(507) := '30312C3132303431302C3130312C3132303436322C3130312C34333832362C3130312C313231332C3130312C383935392C36392C36353331372C36392C383439362C36392C3131393831322C36392C3131393836342C36392C3131393931362C36392C31';
wwv_flow_imp.g_varchar2_table(508) := '32303032302C36392C3132303037322C36392C3132303132342C36392C3132303137362C36392C3132303232382C36392C3132303238302C36392C3132303333322C36392C3132303338342C36392C3132303433362C36392C3931372C36392C31323034';
wwv_flow_imp.g_varchar2_table(509) := '39322C36392C3132303535302C36392C3132303630382C36392C3132303636362C36392C3132303732342C36392C31313537372C36392C353033362C36392C34323232342C36392C37313834362C36392C37313835342C36392C36363138322C36392C31';
wwv_flow_imp.g_varchar2_table(510) := '31393833392C3130322C3131393839312C3130322C3131393934332C3130322C3131393939352C3130322C3132303034372C3130322C3132303039392C3130322C3132303135312C3130322C3132303230332C3130322C3132303235352C3130322C3132';
wwv_flow_imp.g_varchar2_table(511) := '303330372C3130322C3132303335392C3130322C3132303431312C3130322C3132303436332C3130322C34333832392C3130322C34323930352C3130322C3338332C3130322C373833372C3130322C313431322C3130322C3131393331352C37302C3834';
wwv_flow_imp.g_varchar2_table(512) := '39372C37302C3131393831332C37302C3131393836352C37302C3131393931372C37302C3132303032312C37302C3132303037332C37302C3132303132352C37302C3132303137372C37302C3132303232392C37302C3132303238312C37302C31323033';
wwv_flow_imp.g_varchar2_table(513) := '33332C37302C3132303338352C37302C3132303433372C37302C34323930342C37302C3938382C37302C3132303737382C37302C353535362C37302C34323230352C37302C37313837342C37302C37313834322C37302C36363138332C37302C36363231';
wwv_flow_imp.g_varchar2_table(514) := '332C37302C36363835332C37302C36353335312C3130332C383435382C3130332C3131393834302C3130332C3131393839322C3130332C3131393934342C3130332C3132303034382C3130332C3132303130302C3130332C3132303135322C3130332C31';
wwv_flow_imp.g_varchar2_table(515) := '32303230342C3130332C3132303235362C3130332C3132303330382C3130332C3132303336302C3130332C3132303431322C3130332C3132303436342C3130332C3630392C3130332C373535352C3130332C3339372C3130332C313430392C3130332C31';
wwv_flow_imp.g_varchar2_table(516) := '31393831342C37312C3131393836362C37312C3131393931382C37312C3131393937302C37312C3132303032322C37312C3132303037342C37312C3132303132362C37312C3132303137382C37312C3132303233302C37312C3132303238322C37312C31';
wwv_flow_imp.g_varchar2_table(517) := '32303333342C37312C3132303338362C37312C3132303433382C37312C313239322C37312C353035362C37312C353130372C37312C34323139382C37312C36353335322C3130342C383436322C3130342C3131393834312C3130342C3131393934352C31';
wwv_flow_imp.g_varchar2_table(518) := '30342C3131393939372C3130342C3132303034392C3130342C3132303130312C3130342C3132303135332C3130342C3132303230352C3130342C3132303235372C3130342C3132303330392C3130342C3132303336312C3130342C3132303431332C3130';
wwv_flow_imp.g_varchar2_table(519) := '342C3132303436352C3130342C313231312C3130342C313339322C3130342C353035382C3130342C36353332302C37322C383435392C37322C383436302C37322C383436312C37322C3131393831352C37322C3131393836372C37322C3131393931392C';
wwv_flow_imp.g_varchar2_table(520) := '37322C3132303032332C37322C3132303137392C37322C3132303233312C37322C3132303238332C37322C3132303333352C37322C3132303338372C37322C3132303433392C37322C3931392C37322C3132303439342C37322C3132303535322C37322C';
wwv_flow_imp.g_varchar2_table(521) := '3132303631302C37322C3132303636382C37322C3132303732362C37322C31313430362C37322C353035312C37322C353530302C37322C34323231352C37322C36363235352C37322C3733312C3130352C393037352C3130352C36353335332C3130352C';
wwv_flow_imp.g_varchar2_table(522) := '383536302C3130352C383530352C3130352C383532302C3130352C3131393834322C3130352C3131393839342C3130352C3131393934362C3130352C3131393939382C3130352C3132303035302C3130352C3132303130322C3130352C3132303135342C';
wwv_flow_imp.g_varchar2_table(523) := '3130352C3132303230362C3130352C3132303235382C3130352C3132303331302C3130352C3132303336322C3130352C3132303431342C3130352C3132303436362C3130352C3132303438342C3130352C3631382C3130352C3631372C3130352C393533';
wwv_flow_imp.g_varchar2_table(524) := '2C3130352C383132362C3130352C3839302C3130352C3132303532322C3130352C3132303538302C3130352C3132303633382C3130352C3132303639362C3130352C3132303735342C3130352C313131302C3130352C34323536372C3130352C31323331';
wwv_flow_imp.g_varchar2_table(525) := '2C3130352C34333839332C3130352C353032392C3130352C37313837352C3130352C36353335342C3130362C383532312C3130362C3131393834332C3130362C3131393839352C3130362C3131393934372C3130362C3131393939392C3130362C313230';
wwv_flow_imp.g_varchar2_table(526) := '3035312C3130362C3132303130332C3130362C3132303135352C3130362C3132303230372C3130362C3132303235392C3130362C3132303331312C3130362C3132303336332C3130362C3132303431352C3130362C3132303436372C3130362C31303131';
wwv_flow_imp.g_varchar2_table(527) := '2C3130362C313131322C3130362C36353332322C37342C3131393831372C37342C3131393836392C37342C3131393932312C37342C3131393937332C37342C3132303032352C37342C3132303037372C37342C3132303132392C37342C3132303138312C';
wwv_flow_imp.g_varchar2_table(528) := '37342C3132303233332C37342C3132303238352C37342C3132303333372C37342C3132303338392C37342C3132303434312C37342C34323933302C37342C3839352C37342C313033322C37342C353033352C37342C353236312C37342C34323230312C37';
wwv_flow_imp.g_varchar2_table(529) := '342C3131393834342C3130372C3131393839362C3130372C3131393934382C3130372C3132303030302C3130372C3132303035322C3130372C3132303130342C3130372C3132303135362C3130372C3132303230382C3130372C3132303236302C313037';
wwv_flow_imp.g_varchar2_table(530) := '2C3132303331322C3130372C3132303336342C3130372C3132303431362C3130372C3132303436382C3130372C383439302C37352C36353332332C37352C3131393831382C37352C3131393837302C37352C3131393932322C37352C3131393937342C37';
wwv_flow_imp.g_varchar2_table(531) := '352C3132303032362C37352C3132303037382C37352C3132303133302C37352C3132303138322C37352C3132303233342C37352C3132303238362C37352C3132303333382C37352C3132303339302C37352C3132303434322C37352C3932322C37352C31';
wwv_flow_imp.g_varchar2_table(532) := '32303439372C37352C3132303535352C37352C3132303631332C37352C3132303637312C37352C3132303732392C37352C31313431322C37352C353039342C37352C353834352C37352C34323139392C37352C36363834302C37352C313437322C313038';
wwv_flow_imp.g_varchar2_table(533) := '2C383733392C37332C393231332C37332C36353531322C37332C313633332C3130382C313737372C37332C36363333362C3130382C3132353132372C3130382C3132303738332C37332C3132303739332C37332C3132303830332C37332C313230383133';
wwv_flow_imp.g_varchar2_table(534) := '2C37332C3132303832332C37332C3133303033332C37332C36353332312C37332C383534342C37332C383436342C37332C383436352C37332C3131393831362C37332C3131393836382C37332C3131393932302C37332C3132303032342C37332C313230';
wwv_flow_imp.g_varchar2_table(535) := '3132382C37332C3132303138302C37332C3132303233322C37332C3132303238342C37332C3132303333362C37332C3132303338382C37332C3132303434302C37332C36353335362C3130382C383537322C37332C383436372C3130382C313139383435';
wwv_flow_imp.g_varchar2_table(536) := '2C3130382C3131393839372C3130382C3131393934392C3130382C3132303030312C3130382C3132303035332C3130382C3132303130352C37332C3132303135372C37332C3132303230392C37332C3132303236312C37332C3132303331332C37332C31';
wwv_flow_imp.g_varchar2_table(537) := '32303336352C37332C3132303431372C37332C3132303436392C37332C3434382C37332C3132303439362C37332C3132303535342C37332C3132303631322C37332C3132303637302C37332C3132303732382C37332C31313431302C37332C313033302C';
wwv_flow_imp.g_varchar2_table(538) := '37332C313231362C37332C313439332C3130382C313530332C3130382C313537352C3130382C3132363436342C3130382C3132363539322C3130382C36353136362C3130382C36353136352C3130382C313939342C3130382C31313539392C37332C3538';
wwv_flow_imp.g_varchar2_table(539) := '32352C37332C34323232362C37332C39333939322C37332C36363138362C3132342C36363331332C3132342C3131393333382C37362C383535362C37362C383436362C37362C3131393831392C37362C3131393837312C37362C3131393932332C37362C';
wwv_flow_imp.g_varchar2_table(540) := '3132303032372C37362C3132303037392C37362C3132303133312C37362C3132303138332C37362C3132303233352C37362C3132303238372C37362C3132303333392C37362C3132303339312C37362C3132303434332C37362C31313437322C37362C35';
wwv_flow_imp.g_varchar2_table(541) := '3038362C37362C353239302C37362C34323230392C37362C39333937342C37362C37313834332C37362C37313835382C37362C36363538372C37362C36363835342C37362C36353332352C37372C383535392C37372C383439392C37372C313139383230';
wwv_flow_imp.g_varchar2_table(542) := '2C37372C3131393837322C37372C3131393932342C37372C3132303032382C37372C3132303038302C37372C3132303133322C37372C3132303138342C37372C3132303233362C37372C3132303238382C37372C3132303334302C37372C313230333932';
wwv_flow_imp.g_varchar2_table(543) := '2C37372C3132303434342C37372C3932342C37372C3132303439392C37372C3132303535372C37372C3132303631352C37372C3132303637332C37372C3132303733312C37372C313031382C37372C31313431362C37372C353034372C37372C35363136';
wwv_flow_imp.g_varchar2_table(544) := '2C37372C353834362C37372C34323230372C37372C36363232342C37372C36363332312C37372C3131393834372C3131302C3131393839392C3131302C3131393935312C3131302C3132303030332C3131302C3132303035352C3131302C313230313037';
wwv_flow_imp.g_varchar2_table(545) := '2C3131302C3132303135392C3131302C3132303231312C3131302C3132303236332C3131302C3132303331352C3131302C3132303336372C3131302C3132303431392C3131302C3132303437312C3131302C313430302C3131302C313430342C3131302C';
wwv_flow_imp.g_varchar2_table(546) := '36353332362C37382C383436392C37382C3131393832312C37382C3131393837332C37382C3131393932352C37382C3131393937372C37382C3132303032392C37382C3132303038312C37382C3132303138352C37382C3132303233372C37382C313230';
wwv_flow_imp.g_varchar2_table(547) := '3238392C37382C3132303334312C37382C3132303339332C37382C3132303434352C37382C3932352C37382C3132303530302C37382C3132303535382C37382C3132303631362C37382C3132303637342C37382C3132303733322C37382C31313431382C';
wwv_flow_imp.g_varchar2_table(548) := '37382C34323230382C37382C36363833352C37382C333037342C3131312C333230322C3131312C333333302C3131312C333435382C3131312C323430362C3131312C323636322C3131312C323739302C3131312C333034362C3131312C333137342C3131';
wwv_flow_imp.g_varchar2_table(549) := '312C333330322C3131312C333433302C3131312C333636342C3131312C333739322C3131312C343136302C3131312C313633372C3131312C313738312C3131312C36353335392C3131312C383530302C3131312C3131393834382C3131312C3131393930';
wwv_flow_imp.g_varchar2_table(550) := '302C3131312C3131393935322C3131312C3132303035362C3131312C3132303130382C3131312C3132303136302C3131312C3132303231322C3131312C3132303236342C3131312C3132303331362C3131312C3132303336382C3131312C313230343230';
wwv_flow_imp.g_varchar2_table(551) := '2C3131312C3132303437322C3131312C373433392C3131312C373434312C3131312C34333833372C3131312C3935392C3131312C3132303532382C3131312C3132303538362C3131312C3132303634342C3131312C3132303730322C3131312C31323037';
wwv_flow_imp.g_varchar2_table(552) := '36302C3131312C3936332C3131312C3132303533322C3131312C3132303539302C3131312C3132303634382C3131312C3132303730362C3131312C3132303736342C3131312C31313432332C3131312C343335312C3131312C313431332C3131312C3135';
wwv_flow_imp.g_varchar2_table(553) := '30352C3131312C313630372C3131312C3132363530302C3131312C3132363536342C3131312C3132363539362C3131312C36353235392C3131312C36353236302C3131312C36353235382C3131312C36353235372C3131312C313732362C3131312C3634';
wwv_flow_imp.g_varchar2_table(554) := '3432382C3131312C36343432392C3131312C36343432372C3131312C36343432362C3131312C313732392C3131312C36343432342C3131312C36343432352C3131312C36343432332C3131312C36343432322C3131312C313734392C3131312C33333630';
wwv_flow_imp.g_varchar2_table(555) := '2C3131312C343132352C3131312C36363739342C3131312C37313838302C3131312C37313839352C3131312C36363630342C3131312C313938342C37392C323533342C37392C323931382C37392C31323239352C37392C37303836342C37392C37313930';
wwv_flow_imp.g_varchar2_table(556) := '342C37392C3132303738322C37392C3132303739322C37392C3132303830322C37392C3132303831322C37392C3132303832322C37392C3133303033322C37392C36353332372C37392C3131393832322C37392C3131393837342C37392C313139393236';
wwv_flow_imp.g_varchar2_table(557) := '2C37392C3131393937382C37392C3132303033302C37392C3132303038322C37392C3132303133342C37392C3132303138362C37392C3132303233382C37392C3132303239302C37392C3132303334322C37392C3132303339342C37392C313230343436';
wwv_flow_imp.g_varchar2_table(558) := '2C37392C3932372C37392C3132303530322C37392C3132303536302C37392C3132303631382C37392C3132303637362C37392C3132303733342C37392C31313432322C37392C313336352C37392C31313630342C37392C343831362C37392C323834382C';
wwv_flow_imp.g_varchar2_table(559) := '37392C36363735342C37392C34323232372C37392C37313836312C37392C36363139342C37392C36363231392C37392C36363536342C37392C36363833382C37392C393037362C3131322C36353336302C3131322C3131393834392C3131322C31313939';
wwv_flow_imp.g_varchar2_table(560) := '30312C3131322C3131393935332C3131322C3132303030352C3131322C3132303035372C3131322C3132303130392C3131322C3132303136312C3131322C3132303231332C3131322C3132303236352C3131322C3132303331372C3131322C3132303336';
wwv_flow_imp.g_varchar2_table(561) := '392C3131322C3132303432312C3131322C3132303437332C3131322C3936312C3131322C3132303533302C3131322C3132303534342C3131322C3132303538382C3131322C3132303630322C3131322C3132303634362C3131322C3132303636302C3131';
wwv_flow_imp.g_varchar2_table(562) := '322C3132303730342C3131322C3132303731382C3131322C3132303736322C3131322C3132303737362C3131322C31313432372C3131322C36353332382C38302C383437332C38302C3131393832332C38302C3131393837352C38302C3131393932372C';
wwv_flow_imp.g_varchar2_table(563) := '38302C3131393937392C38302C3132303033312C38302C3132303038332C38302C3132303138372C38302C3132303233392C38302C3132303239312C38302C3132303334332C38302C3132303339352C38302C3132303434372C38302C3932392C38302C';
wwv_flow_imp.g_varchar2_table(564) := '3132303530342C38302C3132303536322C38302C3132303632302C38302C3132303637382C38302C3132303733362C38302C31313432362C38302C353039302C38302C353232392C38302C34323139332C38302C36363139372C38302C3131393835302C';
wwv_flow_imp.g_varchar2_table(565) := '3131332C3131393930322C3131332C3131393935342C3131332C3132303030362C3131332C3132303035382C3131332C3132303131302C3131332C3132303136322C3131332C3132303231342C3131332C3132303236362C3131332C3132303331382C31';
wwv_flow_imp.g_varchar2_table(566) := '31332C3132303337302C3131332C3132303432322C3131332C3132303437342C3131332C313330372C3131332C313337392C3131332C313338322C3131332C383437342C38312C3131393832342C38312C3131393837362C38312C3131393932382C3831';
wwv_flow_imp.g_varchar2_table(567) := '2C3131393938302C38312C3132303033322C38312C3132303038342C38312C3132303138382C38312C3132303234302C38312C3132303239322C38312C3132303334342C38312C3132303339362C38312C3132303434382C38312C31313630352C38312C';
wwv_flow_imp.g_varchar2_table(568) := '3131393835312C3131342C3131393930332C3131342C3131393935352C3131342C3132303030372C3131342C3132303035392C3131342C3132303131312C3131342C3132303136332C3131342C3132303231352C3131342C3132303236372C3131342C31';
wwv_flow_imp.g_varchar2_table(569) := '32303331392C3131342C3132303337312C3131342C3132303432332C3131342C3132303437352C3131342C34333834372C3131342C34333834382C3131342C373436322C3131342C31313339372C3131342C34333930352C3131342C3131393331382C38';
wwv_flow_imp.g_varchar2_table(570) := '322C383437352C38322C383437362C38322C383437372C38322C3131393832352C38322C3131393837372C38322C3131393932392C38322C3132303033332C38322C3132303138392C38322C3132303234312C38322C3132303239332C38322C31323033';
wwv_flow_imp.g_varchar2_table(571) := '34352C38322C3132303339372C38322C3132303434392C38322C3432322C38322C353032352C38322C353037342C38322C36363734302C38322C353531312C38322C34323231312C38322C39343030352C38322C36353336332C3131352C313139383532';
wwv_flow_imp.g_varchar2_table(572) := '2C3131352C3131393930342C3131352C3131393935362C3131352C3132303030382C3131352C3132303036302C3131352C3132303131322C3131352C3132303136342C3131352C3132303231362C3131352C3132303236382C3131352C3132303332302C';
wwv_flow_imp.g_varchar2_table(573) := '3131352C3132303337322C3131352C3132303432342C3131352C3132303437362C3131352C34323830312C3131352C3434352C3131352C313130392C3131352C34333934362C3131352C37313837332C3131352C36363633322C3131352C36353333312C';
wwv_flow_imp.g_varchar2_table(574) := '38332C3131393832362C38332C3131393837382C38332C3131393933302C38332C3131393938322C38332C3132303033342C38332C3132303038362C38332C3132303133382C38332C3132303139302C38332C3132303234322C38332C3132303239342C';
wwv_flow_imp.g_varchar2_table(575) := '38332C3132303334362C38332C3132303339382C38332C3132303435302C38332C313032392C38332C313335392C38332C353037372C38332C353038322C38332C34323231302C38332C39343031302C38332C36363139382C38332C36363539322C3833';
wwv_flow_imp.g_varchar2_table(576) := '2C3131393835332C3131362C3131393930352C3131362C3131393935372C3131362C3132303030392C3131362C3132303036312C3131362C3132303131332C3131362C3132303136352C3131362C3132303231372C3131362C3132303236392C3131362C';
wwv_flow_imp.g_varchar2_table(577) := '3132303332312C3131362C3132303337332C3131362C3132303432352C3131362C3132303437372C3131362C383836382C38342C31303230312C38342C3132383837322C38342C36353333322C38342C3131393832372C38342C3131393837392C38342C';
wwv_flow_imp.g_varchar2_table(578) := '3131393933312C38342C3131393938332C38342C3132303033352C38342C3132303038372C38342C3132303133392C38342C3132303139312C38342C3132303234332C38342C3132303239352C38342C3132303334372C38342C3132303339392C38342C';
wwv_flow_imp.g_varchar2_table(579) := '3132303435312C38342C3933322C38342C3132303530372C38342C3132303536352C38342C3132303632332C38342C3132303638312C38342C3132303733392C38342C31313433302C38342C353032362C38342C34323139362C38342C39333936322C38';
wwv_flow_imp.g_varchar2_table(580) := '342C37313836382C38342C36363139392C38342C36363232352C38342C36363332352C38342C3131393835342C3131372C3131393930362C3131372C3131393935382C3131372C3132303031302C3131372C3132303036322C3131372C3132303131342C';
wwv_flow_imp.g_varchar2_table(581) := '3131372C3132303136362C3131372C3132303231382C3131372C3132303237302C3131372C3132303332322C3131372C3132303337342C3131372C3132303432362C3131372C3132303437382C3131372C34323931312C3131372C373435322C3131372C';
wwv_flow_imp.g_varchar2_table(582) := '34333835342C3131372C34333835382C3131372C3635312C3131372C3936352C3131372C3132303533342C3131372C3132303539322C3131372C3132303635302C3131372C3132303730382C3131372C3132303736362C3131372C313430352C3131372C';
wwv_flow_imp.g_varchar2_table(583) := '36363830362C3131372C37313839362C3131372C383734362C38352C383839392C38352C3131393832382C38352C3131393838302C38352C3131393933322C38352C3131393938342C38352C3132303033362C38352C3132303038382C38352C31323031';
wwv_flow_imp.g_varchar2_table(584) := '34302C38352C3132303139322C38352C3132303234342C38352C3132303239362C38352C3132303334382C38352C3132303430302C38352C3132303435322C38352C313335372C38352C343630382C38352C36363736362C38352C353139362C38352C34';
wwv_flow_imp.g_varchar2_table(585) := '323232382C38352C39343031382C38352C37313836342C38352C383734342C3131382C383839372C3131382C36353336362C3131382C383536342C3131382C3131393835352C3131382C3131393930372C3131382C3131393935392C3131382C31323030';
wwv_flow_imp.g_varchar2_table(586) := '31312C3131382C3132303036332C3131382C3132303131352C3131382C3132303136372C3131382C3132303231392C3131382C3132303237312C3131382C3132303332332C3131382C3132303337352C3131382C3132303432372C3131382C3132303437';
wwv_flow_imp.g_varchar2_table(587) := '392C3131382C373435362C3131382C3935372C3131382C3132303532362C3131382C3132303538342C3131382C3132303634322C3131382C3132303730302C3131382C3132303735382C3131382C313134312C3131382C313439362C3131382C37313433';
wwv_flow_imp.g_varchar2_table(588) := '302C3131382C34333934352C3131382C37313837322C3131382C3131393330392C38362C313633392C38362C313738332C38362C383534382C38362C3131393832392C38362C3131393838312C38362C3131393933332C38362C3131393938352C38362C';
wwv_flow_imp.g_varchar2_table(589) := '3132303033372C38362C3132303038392C38362C3132303134312C38362C3132303139332C38362C3132303234352C38362C3132303239372C38362C3132303334392C38362C3132303430312C38362C3132303435332C38362C313134302C38362C3131';
wwv_flow_imp.g_varchar2_table(590) := '3537362C38362C353038312C38362C353136372C38362C34323731392C38362C34323231342C38362C39333936302C38362C37313834302C38362C36363834352C38362C3632332C3131392C3131393835362C3131392C3131393930382C3131392C3131';
wwv_flow_imp.g_varchar2_table(591) := '393936302C3131392C3132303031322C3131392C3132303036342C3131392C3132303131362C3131392C3132303136382C3131392C3132303232302C3131392C3132303237322C3131392C3132303332342C3131392C3132303337362C3131392C313230';
wwv_flow_imp.g_varchar2_table(592) := '3432382C3131392C3132303438302C3131392C373435372C3131392C313132312C3131392C313330392C3131392C313337372C3131392C37313433342C3131392C37313433382C3131392C37313433392C3131392C34333930372C3131392C3731393139';
wwv_flow_imp.g_varchar2_table(593) := '2C38372C37313931302C38372C3131393833302C38372C3131393838322C38372C3131393933342C38372C3131393938362C38372C3132303033382C38372C3132303039302C38372C3132303134322C38372C3132303139342C38372C3132303234362C';
wwv_flow_imp.g_varchar2_table(594) := '38372C3132303239382C38372C3132303335302C38372C3132303430322C38372C3132303435342C38372C313330382C38372C353034332C38372C353037362C38372C34323231382C38372C353734322C3132302C31303533392C3132302C3130353430';
wwv_flow_imp.g_varchar2_table(595) := '2C3132302C31303739392C3132302C36353336382C3132302C383536392C3132302C3131393835372C3132302C3131393930392C3132302C3131393936312C3132302C3132303031332C3132302C3132303036352C3132302C3132303131372C3132302C';
wwv_flow_imp.g_varchar2_table(596) := '3132303136392C3132302C3132303232312C3132302C3132303237332C3132302C3132303332352C3132302C3132303337372C3132302C3132303432392C3132302C3132303438312C3132302C353434312C3132302C353530312C3132302C353734312C';
wwv_flow_imp.g_varchar2_table(597) := '38382C393538372C38382C36363333382C38382C37313931362C38382C36353333362C38382C383535332C38382C3131393833312C38382C3131393838332C38382C3131393933352C38382C3131393938372C38382C3132303033392C38382C31323030';
wwv_flow_imp.g_varchar2_table(598) := '39312C38382C3132303134332C38382C3132303139352C38382C3132303234372C38382C3132303239392C38382C3132303335312C38382C3132303430332C38382C3132303435352C38382C34323933312C38382C3933352C38382C3132303531302C38';
wwv_flow_imp.g_varchar2_table(599) := '382C3132303536382C38382C3132303632362C38382C3132303638342C38382C3132303734322C38382C31313433362C38382C31313631332C38382C353831352C38382C34323231392C38382C36363139322C38382C36363232382C38382C3636333237';
wwv_flow_imp.g_varchar2_table(600) := '2C38382C36363835352C38382C3631312C3132312C373536342C3132312C36353336392C3132312C3131393835382C3132312C3131393931302C3132312C3131393936322C3132312C3132303031342C3132312C3132303036362C3132312C3132303131';
wwv_flow_imp.g_varchar2_table(601) := '382C3132312C3132303137302C3132312C3132303232322C3132312C3132303237342C3132312C3132303332362C3132312C3132303337382C3132312C3132303433302C3132312C3132303438322C3132312C3635352C3132312C373933352C3132312C';
wwv_flow_imp.g_varchar2_table(602) := '34333836362C3132312C3934372C3132312C383530392C3132312C3132303531362C3132312C3132303537342C3132312C3132303633322C3132312C3132303639302C3132312C3132303734382C3132312C313139392C3132312C343332372C3132312C';
wwv_flow_imp.g_varchar2_table(603) := '37313930302C3132312C36353333372C38392C3131393833322C38392C3131393838342C38392C3131393933362C38392C3131393938382C38392C3132303034302C38392C3132303039322C38392C3132303134342C38392C3132303139362C38392C31';
wwv_flow_imp.g_varchar2_table(604) := '32303234382C38392C3132303330302C38392C3132303335322C38392C3132303430342C38392C3132303435362C38392C3933332C38392C3937382C38392C3132303530382C38392C3132303536362C38392C3132303632342C38392C3132303638322C';
wwv_flow_imp.g_varchar2_table(605) := '38392C3132303734302C38392C31313433322C38392C313139382C38392C353033332C38392C353035332C38392C34323232302C38392C39343031392C38392C37313834342C38392C36363232362C38392C3131393835392C3132322C3131393931312C';
wwv_flow_imp.g_varchar2_table(606) := '3132322C3131393936332C3132322C3132303031352C3132322C3132303036372C3132322C3132303131392C3132322C3132303137312C3132322C3132303232332C3132322C3132303237352C3132322C3132303332372C3132322C3132303337392C31';
wwv_flow_imp.g_varchar2_table(607) := '32322C3132303433312C3132322C3132303438332C3132322C373435382C3132322C34333932332C3132322C37313837362C3132322C36363239332C39302C37313930392C39302C36353333382C39302C383438342C39302C383438382C39302C313139';
wwv_flow_imp.g_varchar2_table(608) := '3833332C39302C3131393838352C39302C3131393933372C39302C3131393938392C39302C3132303034312C39302C3132303139372C39302C3132303234392C39302C3132303330312C39302C3132303335332C39302C3132303430352C39302C313230';
wwv_flow_imp.g_varchar2_table(609) := '3435372C39302C3931382C39302C3132303439332C39302C3132303535312C39302C3132303630392C39302C3132303636372C39302C3132303732352C39302C353035392C39302C34323230342C39302C37313834392C39302C36353238322C33342C36';
wwv_flow_imp.g_varchar2_table(610) := '353238342C33362C36353238352C33372C36353238362C33382C36353239302C34322C36353239312C34332C36353239342C34362C36353239352C34372C36353239362C34382C36353239372C34392C36353239382C35302C36353239392C35312C3635';
wwv_flow_imp.g_varchar2_table(611) := '3330302C35322C36353330312C35332C36353330322C35342C36353330332C35352C36353330342C35362C36353330352C35372C36353330382C36302C36353330392C36312C36353331302C36322C36353331322C36342C36353331362C36382C363533';
wwv_flow_imp.g_varchar2_table(612) := '31382C37302C36353331392C37312C36353332342C37362C36353332392C38312C36353333302C38322C36353333332C38352C36353333342C38362C36353333352C38372C36353334332C39352C36353334362C39382C36353334382C3130302C363533';
wwv_flow_imp.g_varchar2_table(613) := '35302C3130322C36353335352C3130372C36353335372C3130392C36353335382C3131302C36353336312C3131332C36353336322C3131342C36353336342C3131362C36353336352C3131372C36353336372C3131392C36353337302C3132322C363533';
wwv_flow_imp.g_varchar2_table(614) := '37312C3132332C36353337332C3132352C3131393834362C3130395D2C225F64656661756C74223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C';
wwv_flow_imp.g_varchar2_table(615) := '383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034';
wwv_flow_imp.g_varchar2_table(616) := '352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C31303538';
wwv_flow_imp.g_varchar2_table(617) := '2C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D';
wwv_flow_imp.g_varchar2_table(618) := '2C226373223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C31';
wwv_flow_imp.g_varchar2_table(619) := '3034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C';
wwv_flow_imp.g_varchar2_table(620) := '3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C3635';
wwv_flow_imp.g_varchar2_table(621) := '3238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226465223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39';
wwv_flow_imp.g_varchar2_table(622) := '362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C31';
wwv_flow_imp.g_varchar2_table(623) := '3035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3130';
wwv_flow_imp.g_varchar2_table(624) := '39332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226573223A5B383231312C3435';
wwv_flow_imp.g_varchar2_table(625) := '2C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C3636';
wwv_flow_imp.g_varchar2_table(626) := '2C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C313132';
wwv_flow_imp.g_varchar2_table(627) := '2C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C3635323932';
wwv_flow_imp.g_varchar2_table(628) := '2C34342C36353330372C35392C36353331312C36335D2C226672223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383234352C39362C31323439342C34372C313034372C35312C313037332C35342C3130';
wwv_flow_imp.g_varchar2_table(629) := '37322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37';
wwv_flow_imp.g_varchar2_table(630) := '372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C31303539';
wwv_flow_imp.g_varchar2_table(631) := '2C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226974223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36';
wwv_flow_imp.g_varchar2_table(632) := '353238312C33332C383231362C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C31303537';
wwv_flow_imp.g_varchar2_table(633) := '2C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C';
wwv_flow_imp.g_varchar2_table(634) := '38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C3635';
wwv_flow_imp.g_varchar2_table(635) := '3330372C35392C36353331312C36335D2C226A61223A5B383231312C34352C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C313034372C35312C313037332C35342C31303732';
wwv_flow_imp.g_varchar2_table(636) := '2C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C';
wwv_flow_imp.g_varchar2_table(637) := '313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38';
wwv_flow_imp.g_varchar2_table(638) := '392C36353238332C33352C36353239322C34342C36353330372C35395D2C226B6F223A5B383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C31303437';
wwv_flow_imp.g_varchar2_table(639) := '2C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C3735';
wwv_flow_imp.g_varchar2_table(640) := '2C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C3838';
wwv_flow_imp.g_varchar2_table(641) := '2C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C22706C223A5B36353337342C3132362C36353330362C35382C3635';
wwv_flow_imp.g_varchar2_table(642) := '3238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C';
wwv_flow_imp.g_varchar2_table(643) := '39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131';
wwv_flow_imp.g_varchar2_table(644) := '322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239';
wwv_flow_imp.g_varchar2_table(645) := '322C34342C36353330372C35392C36353331312C36335D2C2270742D4252223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C3437';
wwv_flow_imp.g_varchar2_table(646) := '2C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C3130';
wwv_flow_imp.g_varchar2_table(647) := '35302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C3130';
wwv_flow_imp.g_varchar2_table(648) := '36312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227170732D706C6F63223A5B3136302C33322C383231';
wwv_flow_imp.g_varchar2_table(649) := '312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034';
wwv_flow_imp.g_varchar2_table(650) := '302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131';
wwv_flow_imp.g_varchar2_table(651) := '312C313035342C37392C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C3635323838';
wwv_flow_imp.g_varchar2_table(652) := '2C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227275223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C31';
wwv_flow_imp.g_varchar2_table(653) := '38302C39362C31323439342C34372C3330352C3130352C3932312C37332C313030392C3131322C3231352C3132302C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C3633';
wwv_flow_imp.g_varchar2_table(654) := '5D2C227472223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C31';
wwv_flow_imp.g_varchar2_table(655) := '3034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C31303534';
wwv_flow_imp.g_varchar2_table(656) := '2C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C3635';
wwv_flow_imp.g_varchar2_table(657) := '3238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227A682D68616E73223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C3132';
wwv_flow_imp.g_varchar2_table(658) := '3439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C';
wwv_flow_imp.g_varchar2_table(659) := '3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C';
wwv_flow_imp.g_varchar2_table(660) := '3132302C313036312C38382C313039312C3132312C313035392C38392C36353238382C34302C36353238392C34315D2C227A682D68616E74223A5B383231312C34352C36353337342C3132362C3138302C39362C31323439342C34372C313034372C3531';
wwv_flow_imp.g_varchar2_table(661) := '2C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932';
wwv_flow_imp.g_varchar2_table(662) := '312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C3130';
wwv_flow_imp.g_varchar2_table(663) := '39312C3132312C313035392C38392C36353238332C33352C36353330372C35395D7D272929292C66652E63616368653D6E657720636C6173737B636F6E7374727563746F7228652C74297B746869732E6C61737443616368653D766F696420302C746869';
wwv_flow_imp.g_varchar2_table(664) := '732E6C6173744172674B65793D766F696420302C2266756E6374696F6E223D3D747970656F6620653F28746869732E5F666E3D652C746869732E5F636F6D707574654B65793D6F65293A28746869732E5F666E3D742C746869732E5F636F6D707574654B';
wwv_flow_imp.g_varchar2_table(665) := '65793D652E67657443616368654B6579297D6765742865297B636F6E737420743D746869732E5F636F6D707574654B65792865293B72657475726E20746869732E6C6173744172674B6579213D3D74262628746869732E6C6173744172674B65793D742C';
wwv_flow_imp.g_varchar2_table(666) := '746869732E6C61737443616368653D746869732E5F666E286529292C746869732E6C61737443616368657D7D287B67657443616368654B65793A4A534F4E2E737472696E676966797D2C28653D3E7B66756E6374696F6E20742865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(667) := '3D6E6577204D61703B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B3D3229742E73657428655B6E5D2C655B6E2B315D293B72657475726E20747D66756E6374696F6E206E28652C74297B69662821652972657475726E20743B636F6E73';
wwv_flow_imp.g_varchar2_table(668) := '74206E3D6E6577204D61703B666F7228636F6E73745B692C725D6F66206529742E68617328692926266E2E73657428692C72293B72657475726E206E7D636F6E737420693D73652E616D626967756F7573436861726163746572446174612E76616C7565';
wwv_flow_imp.g_varchar2_table(669) := '3B6C657420722C6F3D652E66696C7465722828653D3E21652E7374617274735769746828225F222926266520696E206929293B303D3D3D6F2E6C656E6774682626286F3D5B225F64656661756C74225D293B666F7228636F6E73742065206F66206F2972';
wwv_flow_imp.g_varchar2_table(670) := '3D6E28722C7428695B655D29293B636F6E737420613D66756E6374696F6E28652C74297B636F6E7374206E3D6E6577204D61702865293B666F7228636F6E73745B652C695D6F662074296E2E73657428652C69293B72657475726E206E7D287428692E5F';
wwv_flow_imp.g_varchar2_table(671) := '636F6D6D6F6E292C72293B72657475726E206E65772073652861297D29292C66652E5F6C6F63616C65733D6E6577206165282828293D3E4F626A6563742E6B6579732873652E616D626967756F7573436861726163746572446174612E76616C7565292E';
wwv_flow_imp.g_varchar2_table(672) := '66696C7465722828653D3E21652E7374617274735769746828225F2229292929293B636C6173732067657B737461746963206765745261774461746128297B72657475726E204A534F4E2E706172736528225B392C31302C31312C31322C31332C33322C';
wwv_flow_imp.g_varchar2_table(673) := '3132372C3136302C3137332C3834372C313536342C343434372C343434382C363036382C363036392C363135352C363135362C363135372C363135382C373335352C373335362C383139322C383139332C383139342C383139352C383139362C38313937';
wwv_flow_imp.g_varchar2_table(674) := '2C383139382C383139392C383230302C383230312C383230322C383230332C383230342C383230352C383230362C383230372C383233342C383233352C383233362C383233372C383233382C383233392C383238372C383238382C383238392C38323930';
wwv_flow_imp.g_varchar2_table(675) := '2C383239312C383239322C383239332C383239342C383239352C383239362C383239372C383239382C383239392C383330302C383330312C383330322C383330332C31303234302C31323238382C31323634342C36353032342C36353032352C36353032';
wwv_flow_imp.g_varchar2_table(676) := '362C36353032372C36353032382C36353032392C36353033302C36353033312C36353033322C36353033332C36353033342C36353033352C36353033362C36353033372C36353033382C36353033392C36353237392C36353434302C36353532302C3635';
wwv_flow_imp.g_varchar2_table(677) := '3532312C36353532322C36353532332C36353532342C36353532352C36353532362C36353532372C36353532382C36353533322C37383834342C3131393135352C3131393135362C3131393135372C3131393135382C3131393135392C3131393136302C';
wwv_flow_imp.g_varchar2_table(678) := '3131393136312C3131393136322C3931373530342C3931373530352C3931373530362C3931373530372C3931373530382C3931373530392C3931373531302C3931373531312C3931373531322C3931373531332C3931373531342C3931373531352C3931';
wwv_flow_imp.g_varchar2_table(679) := '373531362C3931373531372C3931373531382C3931373531392C3931373532302C3931373532312C3931373532322C3931373532332C3931373532342C3931373532352C3931373532362C3931373532372C3931373532382C3931373532392C39313735';
wwv_flow_imp.g_varchar2_table(680) := '33302C3931373533312C3931373533322C3931373533332C3931373533342C3931373533352C3931373533362C3931373533372C3931373533382C3931373533392C3931373534302C3931373534312C3931373534322C3931373534332C393137353434';
wwv_flow_imp.g_varchar2_table(681) := '2C3931373534352C3931373534362C3931373534372C3931373534382C3931373534392C3931373535302C3931373535312C3931373535322C3931373535332C3931373535342C3931373535352C3931373535362C3931373535372C3931373535382C39';
wwv_flow_imp.g_varchar2_table(682) := '31373535392C3931373536302C3931373536312C3931373536322C3931373536332C3931373536342C3931373536352C3931373536362C3931373536372C3931373536382C3931373536392C3931373537302C3931373537312C3931373537322C393137';
wwv_flow_imp.g_varchar2_table(683) := '3537332C3931373537342C3931373537352C3931373537362C3931373537372C3931373537382C3931373537392C3931373538302C3931373538312C3931373538322C3931373538332C3931373538342C3931373538352C3931373538362C3931373538';
wwv_flow_imp.g_varchar2_table(684) := '372C3931373538382C3931373538392C3931373539302C3931373539312C3931373539322C3931373539332C3931373539342C3931373539352C3931373539362C3931373539372C3931373539382C3931373539392C3931373630302C3931373630312C';
wwv_flow_imp.g_varchar2_table(685) := '3931373630322C3931373630332C3931373630342C3931373630352C3931373630362C3931373630372C3931373630382C3931373630392C3931373631302C3931373631312C3931373631322C3931373631332C3931373631342C3931373631352C3931';
wwv_flow_imp.g_varchar2_table(686) := '373631362C3931373631372C3931373631382C3931373631392C3931373632302C3931373632312C3931373632322C3931373632332C3931373632342C3931373632352C3931373632362C3931373632372C3931373632382C3931373632392C39313736';
wwv_flow_imp.g_varchar2_table(687) := '33302C3931373633312C3931373736302C3931373736312C3931373736322C3931373736332C3931373736342C3931373736352C3931373736362C3931373736372C3931373736382C3931373736392C3931373737302C3931373737312C393137373732';
wwv_flow_imp.g_varchar2_table(688) := '2C3931373737332C3931373737342C3931373737352C3931373737362C3931373737372C3931373737382C3931373737392C3931373738302C3931373738312C3931373738322C3931373738332C3931373738342C3931373738352C3931373738362C39';
wwv_flow_imp.g_varchar2_table(689) := '31373738372C3931373738382C3931373738392C3931373739302C3931373739312C3931373739322C3931373739332C3931373739342C3931373739352C3931373739362C3931373739372C3931373739382C3931373739392C3931373830302C393137';
wwv_flow_imp.g_varchar2_table(690) := '3830312C3931373830322C3931373830332C3931373830342C3931373830352C3931373830362C3931373830372C3931373830382C3931373830392C3931373831302C3931373831312C3931373831322C3931373831332C3931373831342C3931373831';
wwv_flow_imp.g_varchar2_table(691) := '352C3931373831362C3931373831372C3931373831382C3931373831392C3931373832302C3931373832312C3931373832322C3931373832332C3931373832342C3931373832352C3931373832362C3931373832372C3931373832382C3931373832392C';
wwv_flow_imp.g_varchar2_table(692) := '3931373833302C3931373833312C3931373833322C3931373833332C3931373833342C3931373833352C3931373833362C3931373833372C3931373833382C3931373833392C3931373834302C3931373834312C3931373834322C3931373834332C3931';
wwv_flow_imp.g_varchar2_table(693) := '373834342C3931373834352C3931373834362C3931373834372C3931373834382C3931373834392C3931373835302C3931373835312C3931373835322C3931373835332C3931373835342C3931373835352C3931373835362C3931373835372C39313738';
wwv_flow_imp.g_varchar2_table(694) := '35382C3931373835392C3931373836302C3931373836312C3931373836322C3931373836332C3931373836342C3931373836352C3931373836362C3931373836372C3931373836382C3931373836392C3931373837302C3931373837312C393137383732';
wwv_flow_imp.g_varchar2_table(695) := '2C3931373837332C3931373837342C3931373837352C3931373837362C3931373837372C3931373837382C3931373837392C3931373838302C3931373838312C3931373838322C3931373838332C3931373838342C3931373838352C3931373838362C39';
wwv_flow_imp.g_varchar2_table(696) := '31373838372C3931373838382C3931373838392C3931373839302C3931373839312C3931373839322C3931373839332C3931373839342C3931373839352C3931373839362C3931373839372C3931373839382C3931373839392C3931373930302C393137';
wwv_flow_imp.g_varchar2_table(697) := '3930312C3931373930322C3931373930332C3931373930342C3931373930352C3931373930362C3931373930372C3931373930382C3931373930392C3931373931302C3931373931312C3931373931322C3931373931332C3931373931342C3931373931';
wwv_flow_imp.g_varchar2_table(698) := '352C3931373931362C3931373931372C3931373931382C3931373931392C3931373932302C3931373932312C3931373932322C3931373932332C3931373932342C3931373932352C3931373932362C3931373932372C3931373932382C3931373932392C';
wwv_flow_imp.g_varchar2_table(699) := '3931373933302C3931373933312C3931373933322C3931373933332C3931373933342C3931373933352C3931373933362C3931373933372C3931373933382C3931373933392C3931373934302C3931373934312C3931373934322C3931373934332C3931';
wwv_flow_imp.g_varchar2_table(700) := '373934342C3931373934352C3931373934362C3931373934372C3931373934382C3931373934392C3931373935302C3931373935312C3931373935322C3931373935332C3931373935342C3931373935352C3931373935362C3931373935372C39313739';
wwv_flow_imp.g_varchar2_table(701) := '35382C3931373935392C3931373936302C3931373936312C3931373936322C3931373936332C3931373936342C3931373936352C3931373936362C3931373936372C3931373936382C3931373936392C3931373937302C3931373937312C393137393732';
wwv_flow_imp.g_varchar2_table(702) := '2C3931373937332C3931373937342C3931373937352C3931373937362C3931373937372C3931373937382C3931373937392C3931373938302C3931373938312C3931373938322C3931373938332C3931373938342C3931373938352C3931373938362C39';
wwv_flow_imp.g_varchar2_table(703) := '31373938372C3931373938382C3931373938392C3931373939302C3931373939312C3931373939322C3931373939332C3931373939342C3931373939352C3931373939362C3931373939372C3931373939382C3931373939395D22297D73746174696320';
wwv_flow_imp.g_varchar2_table(704) := '6765744461746128297B72657475726E20746869732E5F646174617C7C28746869732E5F646174613D6E6577205365742867652E67657452617744617461282929292C746869732E5F646174617D737461746963206973496E76697369626C6543686172';
wwv_flow_imp.g_varchar2_table(705) := '61637465722865297B72657475726E2067652E6765744461746128292E6861732865297D7374617469632067657420636F6465506F696E747328297B72657475726E2067652E6765744461746128297D7D67652E5F646174613D766F696420303B6C6574';
wwv_flow_imp.g_varchar2_table(706) := '2062653B636C617373205F657B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6D6574686F643D6E2C746869732E617267733D692C746869732E747970653D307D7D';
wwv_flow_imp.g_varchar2_table(707) := '636C6173732076657B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7365713D742C746869732E7265733D6E2C746869732E6572723D692C746869732E747970653D317D7D636C617373207765';
wwv_flow_imp.g_varchar2_table(708) := '7B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E744E616D653D6E2C746869732E6172673D692C746869732E747970653D327D7D636C6173732079657B63';
wwv_flow_imp.g_varchar2_table(709) := '6F6E7374727563746F7228652C742C6E297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E743D6E2C746869732E747970653D337D7D636C6173732054657B636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(710) := '732E7673576F726B65723D652C746869732E7265713D742C746869732E747970653D347D7D636C617373206B657B636F6E7374727563746F722865297B746869732E5F776F726B657249643D2D312C746869732E5F68616E646C65723D652C746869732E';
wwv_flow_imp.g_varchar2_table(711) := '5F6C61737453656E745265713D302C746869732E5F70656E64696E675265706C6965733D4F626A6563742E637265617465286E756C6C292C746869732E5F70656E64696E67456D6974746572733D6E6577204D61702C746869732E5F70656E64696E6745';
wwv_flow_imp.g_varchar2_table(712) := '76656E74733D6E6577204D61707D736574576F726B657249642865297B746869732E5F776F726B657249643D657D73656E644D65737361676528652C74297B636F6E7374206E3D537472696E67282B2B746869732E5F6C61737453656E74526571293B72';
wwv_flow_imp.g_varchar2_table(713) := '657475726E206E65772050726F6D697365282828692C72293D3E7B746869732E5F70656E64696E675265706C6965735B6E5D3D7B7265736F6C76653A692C72656A6563743A727D2C746869732E5F73656E64286E6577205F6528746869732E5F776F726B';
wwv_flow_imp.g_varchar2_table(714) := '657249642C6E2C652C7429297D29297D6C697374656E28652C74297B6C6574206E3D6E756C6C3B636F6E737420693D6E6577204C287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E7B6E3D537472696E67282B2B746869732E5F6C';
wwv_flow_imp.g_varchar2_table(715) := '61737453656E74526571292C746869732E5F70656E64696E67456D6974746572732E736574286E2C69292C746869732E5F73656E64286E657720776528746869732E5F776F726B657249642C6E2C652C7429297D2C6F6E44696452656D6F76654C617374';
wwv_flow_imp.g_varchar2_table(716) := '4C697374656E65723A28293D3E7B746869732E5F70656E64696E67456D6974746572732E64656C657465286E292C746869732E5F73656E64286E657720546528746869732E5F776F726B657249642C6E29292C6E3D6E756C6C7D7D293B72657475726E20';
wwv_flow_imp.g_varchar2_table(717) := '692E6576656E747D68616E646C654D6573736167652865297B652626652E7673576F726B65722626282D31213D3D746869732E5F776F726B657249642626652E7673576F726B6572213D3D746869732E5F776F726B657249647C7C746869732E5F68616E';
wwv_flow_imp.g_varchar2_table(718) := '646C654D657373616765286529297D5F68616E646C654D6573736167652865297B73776974636828652E74797065297B6361736520313A72657475726E20746869732E5F68616E646C655265706C794D6573736167652865293B6361736520303A726574';
wwv_flow_imp.g_varchar2_table(719) := '75726E20746869732E5F68616E646C65526571756573744D6573736167652865293B6361736520323A72657475726E20746869732E5F68616E646C655375627363726962654576656E744D6573736167652865293B6361736520333A72657475726E2074';
wwv_flow_imp.g_varchar2_table(720) := '6869732E5F68616E646C654576656E744D6573736167652865293B6361736520343A72657475726E20746869732E5F68616E646C65556E7375627363726962654576656E744D6573736167652865297D7D5F68616E646C655265706C794D657373616765';
wwv_flow_imp.g_varchar2_table(721) := '2865297B69662821746869732E5F70656E64696E675265706C6965735B652E7365715D2972657475726E20766F696420636F6E736F6C652E7761726E2822476F74207265706C7920746F20756E6B6E6F776E2073657122293B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(722) := '732E5F70656E64696E675265706C6965735B652E7365715D3B69662864656C65746520746869732E5F70656E64696E675265706C6965735B652E7365715D2C652E657272297B6C6574206E3D652E6572723B72657475726E20652E6572722E2469734572';
wwv_flow_imp.g_varchar2_table(723) := '726F722626286E3D6E6577204572726F722C6E2E6E616D653D652E6572722E6E616D652C6E2E6D6573736167653D652E6572722E6D6573736167652C6E2E737461636B3D652E6572722E737461636B292C766F696420742E72656A656374286E297D742E';
wwv_flow_imp.g_varchar2_table(724) := '7265736F6C766528652E726573297D5F68616E646C65526571756573744D6573736167652865297B636F6E737420743D652E7265713B746869732E5F68616E646C65722E68616E646C654D65737361676528652E6D6574686F642C652E61726773292E74';
wwv_flow_imp.g_varchar2_table(725) := '68656E2828653D3E7B746869732E5F73656E64286E657720766528746869732E5F776F726B657249642C742C652C766F6964203029297D292C28653D3E7B652E64657461696C20696E7374616E63656F66204572726F72262628652E64657461696C3D6E';
wwv_flow_imp.g_varchar2_table(726) := '28652E64657461696C29292C746869732E5F73656E64286E657720766528746869732E5F776F726B657249642C742C766F696420302C6E28652929297D29297D5F68616E646C655375627363726962654576656E744D6573736167652865297B636F6E73';
wwv_flow_imp.g_varchar2_table(727) := '7420743D652E7265712C6E3D746869732E5F68616E646C65722E68616E646C654576656E7428652E6576656E744E616D652C652E617267292828653D3E7B746869732E5F73656E64286E657720796528746869732E5F776F726B657249642C742C652929';
wwv_flow_imp.g_varchar2_table(728) := '7D29293B746869732E5F70656E64696E674576656E74732E73657428742C6E297D5F68616E646C654576656E744D6573736167652865297B746869732E5F70656E64696E67456D6974746572732E68617328652E726571293F746869732E5F70656E6469';
wwv_flow_imp.g_varchar2_table(729) := '6E67456D6974746572732E67657428652E726571292E6669726528652E6576656E74293A636F6E736F6C652E7761726E2822476F74206576656E7420666F7220756E6B6E6F776E2072657122297D5F68616E646C65556E7375627363726962654576656E';
wwv_flow_imp.g_varchar2_table(730) := '744D6573736167652865297B746869732E5F70656E64696E674576656E74732E68617328652E726571293F28746869732E5F70656E64696E674576656E74732E67657428652E726571292E646973706F736528292C746869732E5F70656E64696E674576';
wwv_flow_imp.g_varchar2_table(731) := '656E74732E64656C65746528652E72657129293A636F6E736F6C652E7761726E2822476F7420756E73756273637269626520666F7220756E6B6E6F776E2072657122297D5F73656E642865297B636F6E737420743D5B5D3B696628303D3D3D652E747970';
wwv_flow_imp.g_varchar2_table(732) := '6529666F72286C6574206E3D303B6E3C652E617267732E6C656E6774683B6E2B2B29652E617267735B6E5D696E7374616E63656F662041727261794275666665722626742E7075736828652E617267735B6E5D293B656C736520313D3D3D652E74797065';
wwv_flow_imp.g_varchar2_table(733) := '2626652E72657320696E7374616E63656F662041727261794275666665722626742E7075736828652E726573293B746869732E5F68616E646C65722E73656E644D65737361676528652C74297D7D66756E6374696F6E2053652865297B72657475726E22';
wwv_flow_imp.g_varchar2_table(734) := '6F223D3D3D655B305D2626226E223D3D3D655B315D26266C6528652E63686172436F64654174283229297D66756E6374696F6E2078652865297B72657475726E2F5E6F6E44796E616D69632F2E7465737428652926266C6528652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(735) := '74283929297D636C617373204C657B636F6E7374727563746F7228652C74297B746869732E5F7265717565737448616E646C6572466163746F72793D742C746869732E5F7265717565737448616E646C65723D6E756C6C2C746869732E5F70726F746F63';
wwv_flow_imp.g_varchar2_table(736) := '6F6C3D6E6577206B65287B73656E644D6573736167653A28742C6E293D3E7B6528742C6E297D2C68616E646C654D6573736167653A28652C74293D3E746869732E5F68616E646C654D65737361676528652C74292C68616E646C654576656E743A28652C';
wwv_flow_imp.g_varchar2_table(737) := '74293D3E746869732E5F68616E646C654576656E7428652C74297D297D6F6E6D6573736167652865297B746869732E5F70726F746F636F6C2E68616E646C654D6573736167652865297D5F68616E646C654D65737361676528652C74297B696628222469';
wwv_flow_imp.g_varchar2_table(738) := '6E697469616C697A65223D3D3D652972657475726E20746869732E696E697469616C697A6528745B305D2C745B315D2C745B325D2C745B335D293B69662821746869732E5F7265717565737448616E646C65727C7C2266756E6374696F6E22213D747970';
wwv_flow_imp.g_varchar2_table(739) := '656F6620746869732E5F7265717565737448616E646C65725B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E67207265717565737448616E646C6572206F72206D6574686F643A20222B652929';
wwv_flow_imp.g_varchar2_table(740) := '3B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F7265717565737448616E646C65725B655D2E6170706C7928746869732E5F7265717565737448616E646C65722C7429297D63617463682865297B72657475726E2050';
wwv_flow_imp.g_varchar2_table(741) := '726F6D6973652E72656A6563742865297D7D5F68616E646C654576656E7428652C74297B69662821746869732E5F7265717565737448616E646C6572297468726F77206E6577204572726F7228224D697373696E67207265717565737448616E646C6572';
wwv_flow_imp.g_varchar2_table(742) := '22293B6966287865286529297B636F6E7374206E3D746869732E5F7265717565737448616E646C65725B655D2E63616C6C28746869732E5F7265717565737448616E646C65722C74293B6966282266756E6374696F6E22213D747970656F66206E297468';
wwv_flow_imp.g_varchar2_table(743) := '726F77206E6577204572726F7228604D697373696E672064796E616D6963206576656E7420247B657D206F6E20726571756573742068616E646C65722E60293B72657475726E206E7D6966285365286529297B636F6E737420743D746869732E5F726571';
wwv_flow_imp.g_varchar2_table(744) := '7565737448616E646C65725B655D3B6966282266756E6374696F6E22213D747970656F662074297468726F77206E6577204572726F7228604D697373696E67206576656E7420247B657D206F6E20726571756573742068616E646C65722E60293B726574';
wwv_flow_imp.g_varchar2_table(745) := '75726E20747D7468726F77206E6577204572726F7228604D616C666F726D6564206576656E74206E616D6520247B657D60297D696E697469616C697A6528652C742C6E2C69297B746869732E5F70726F746F636F6C2E736574576F726B65724964286529';
wwv_flow_imp.g_varchar2_table(746) := '3B636F6E737420723D66756E6374696F6E28652C742C6E297B636F6E737420693D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B7265747572';
wwv_flow_imp.g_varchar2_table(747) := '6E207428652C6E297D2C723D653D3E66756E6374696F6E2874297B72657475726E206E28652C74297D2C6F3D7B7D3B666F7228636F6E73742074206F6620652978652874293F6F5B745D3D722874293A53652874293F6F5B745D3D6E28742C766F696420';
wwv_flow_imp.g_varchar2_table(748) := '30293A6F5B745D3D692874293B72657475726E206F7D28692C2828652C74293D3E746869732E5F70726F746F636F6C2E73656E644D65737361676528652C7429292C2828652C74293D3E746869732E5F70726F746F636F6C2E6C697374656E28652C7429';
wwv_flow_imp.g_varchar2_table(749) := '29293B72657475726E20746869732E5F7265717565737448616E646C6572466163746F72793F28746869732E5F7265717565737448616E646C65723D746869732E5F7265717565737448616E646C6572466163746F72792872292C50726F6D6973652E72';
wwv_flow_imp.g_varchar2_table(750) := '65736F6C7665284528746869732E5F7265717565737448616E646C65722929293A2874262628766F69642030213D3D742E6261736555726C262664656C65746520742E6261736555726C2C766F69642030213D3D742E70617468732626766F6964203021';
wwv_flow_imp.g_varchar2_table(751) := '3D3D742E70617468732E7673262664656C65746520742E70617468732E76732C766F69642030213D3D742E747275737465645479706573506F6C696379262664656C65746520742E747275737465645479706573506F6C6963792C742E63617463684572';
wwv_flow_imp.g_varchar2_table(752) := '726F723D21302C676C6F62616C546869732E726571756972652E636F6E666967287429292C6E65772050726F6D697365282828652C74293D3E7B28302C676C6F62616C546869732E7265717569726529285B6E5D2C286E3D3E7B746869732E5F72657175';
wwv_flow_imp.g_varchar2_table(753) := '65737448616E646C65723D6E2E6372656174652872292C746869732E5F7265717565737448616E646C65723F65284528746869732E5F7265717565737448616E646C657229293A74286E6577204572726F7228224E6F205265717565737448616E646C65';
wwv_flow_imp.g_varchar2_table(754) := '72212229297D292C74297D2929297D7D636C6173732043657B636F6E7374727563746F7228652C742C6E2C69297B746869732E6F726967696E616C53746172743D652C746869732E6F726967696E616C4C656E6774683D742C746869732E6D6F64696669';
wwv_flow_imp.g_varchar2_table(755) := '656453746172743D6E2C746869732E6D6F6469666965644C656E6774683D697D6765744F726967696E616C456E6428297B72657475726E20746869732E6F726967696E616C53746172742B746869732E6F726967696E616C4C656E6774687D6765744D6F';
wwv_flow_imp.g_varchar2_table(756) := '646966696564456E6428297B72657475726E20746869732E6D6F64696669656453746172742B746869732E6D6F6469666965644C656E6774687D7D66756E6374696F6E20456528652C74297B72657475726E28743C3C35292D742B657C307D66756E6374';
wwv_flow_imp.g_varchar2_table(757) := '696F6E20416528652C74297B743D4565283134393431372C74293B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29743D456528652E63686172436F64654174286E292C74293B72657475726E20747D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(758) := '526528652C742C6E3D3332297B636F6E737420693D6E2D743B72657475726E28653C3C747C287E2828313C3C69292D31292665293E3E3E69293E3E3E307D66756E6374696F6E204D6528652C743D302C6E3D652E627974654C656E6774682C693D30297B';
wwv_flow_imp.g_varchar2_table(759) := '666F72286C657420723D303B723C6E3B722B2B29655B742B725D3D697D66756E6374696F6E204E6528652C743D3332297B72657475726E206520696E7374616E63656F662041727261794275666665723F41727261792E66726F6D286E65772055696E74';
wwv_flow_imp.g_varchar2_table(760) := '384172726179286529292E6D61702828653D3E652E746F537472696E67283136292E706164537461727428322C2230222929292E6A6F696E282222293A66756E6374696F6E28652C742C6E3D223022297B666F72283B652E6C656E6774683C743B29653D';
wwv_flow_imp.g_varchar2_table(761) := '6E2B653B72657475726E20657D2828653E3E3E30292E746F537472696E67283136292C742F34297D636C6173732049657B636F6E7374727563746F7228297B746869732E5F68303D313733323538343139332C746869732E5F68313D3430323332333334';
wwv_flow_imp.g_varchar2_table(762) := '31372C746869732E5F68323D323536323338333130322C746869732E5F68333D3237313733333837382C746869732E5F68343D333238353337373532302C746869732E5F627566663D6E65772055696E74384172726179283637292C746869732E5F6275';
wwv_flow_imp.g_varchar2_table(763) := '666644563D6E657720446174615669657728746869732E5F627566662E627566666572292C746869732E5F627566664C656E3D302C746869732E5F746F74616C4C656E3D302C746869732E5F6C6566746F76657248696768537572726F676174653D302C';
wwv_flow_imp.g_varchar2_table(764) := '746869732E5F66696E69736865643D21317D7570646174652865297B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E3B636F6E7374206E3D746869732E5F627566663B6C657420692C722C6F3D746869732E5F62756666';
wwv_flow_imp.g_varchar2_table(765) := '4C656E2C613D746869732E5F6C6566746F76657248696768537572726F676174653B666F722830213D3D613F28693D612C723D2D312C613D30293A28693D652E63686172436F646541742830292C723D30293B3B297B6C657420733D693B696628686528';
wwv_flow_imp.g_varchar2_table(766) := '6929297B6966282128722B313C7429297B613D693B627265616B7D7B636F6E737420743D652E63686172436F6465417428722B31293B63652874293F28722B2B2C733D646528692C7429293A733D36353533337D7D656C7365206365286929262628733D';
wwv_flow_imp.g_varchar2_table(767) := '3635353333293B6966286F3D746869732E5F70757368286E2C6F2C73292C722B2B2C2128723C742929627265616B3B693D652E63686172436F646541742872297D746869732E5F627566664C656E3D6F2C746869732E5F6C6566746F7665724869676853';
wwv_flow_imp.g_varchar2_table(768) := '7572726F676174653D617D5F7075736828652C742C6E297B72657475726E206E3C3132383F655B742B2B5D3D6E3A6E3C323034383F28655B742B2B5D3D3139327C2831393834266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E3029';
wwv_flow_imp.g_varchar2_table(769) := '3A6E3C36353533363F28655B742B2B5D3D3232347C283631343430266E293E3E3E31322C655B742B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30293A28655B742B2B5D3D3234307C2831383335';
wwv_flow_imp.g_varchar2_table(770) := '303038266E293E3E3E31382C655B742B2B5D3D3132387C28323538303438266E293E3E3E31322C655B742B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30292C743E3D3634262628746869732E5F';
wwv_flow_imp.g_varchar2_table(771) := '7374657028292C742D3D36342C746869732E5F746F74616C4C656E2B3D36342C655B305D3D655B36345D2C655B315D3D655B36355D2C655B325D3D655B36365D292C747D64696765737428297B72657475726E20746869732E5F66696E69736865647C7C';
wwv_flow_imp.g_varchar2_table(772) := '28746869732E5F66696E69736865643D21302C746869732E5F6C6566746F76657248696768537572726F67617465262628746869732E5F6C6566746F76657248696768537572726F676174653D302C746869732E5F627566664C656E3D746869732E5F70';
wwv_flow_imp.g_varchar2_table(773) := '75736828746869732E5F627566662C746869732E5F627566664C656E2C363535333329292C746869732E5F746F74616C4C656E2B3D746869732E5F627566664C656E2C746869732E5F7772617055702829292C4E6528746869732E5F6830292B4E652874';
wwv_flow_imp.g_varchar2_table(774) := '6869732E5F6831292B4E6528746869732E5F6832292B4E6528746869732E5F6833292B4E6528746869732E5F6834297D5F77726170557028297B746869732E5F627566665B746869732E5F627566664C656E2B2B5D3D3132382C4D6528746869732E5F62';
wwv_flow_imp.g_varchar2_table(775) := '7566662C746869732E5F627566664C656E292C746869732E5F627566664C656E3E3536262628746869732E5F7374657028292C4D6528746869732E5F6275666629293B636F6E737420653D382A746869732E5F746F74616C4C656E3B746869732E5F6275';
wwv_flow_imp.g_varchar2_table(776) := '666644562E73657455696E7433322835362C4D6174682E666C6F6F7228652F34323934393637323936292C2131292C746869732E5F6275666644562E73657455696E7433322836302C6525343239343936373239362C2131292C746869732E5F73746570';
wwv_flow_imp.g_varchar2_table(777) := '28297D5F7374657028297B636F6E737420653D49652E5F626967426C6F636B33322C743D746869732E5F6275666644563B666F72286C6574206E3D303B6E3C36343B6E2B3D3429652E73657455696E743332286E2C742E67657455696E743332286E2C21';
wwv_flow_imp.g_varchar2_table(778) := '31292C2131293B666F72286C657420743D36343B743C3332303B742B3D3429652E73657455696E74333228742C526528652E67657455696E74333228742D31322C2131295E652E67657455696E74333228742D33322C2131295E652E67657455696E7433';
wwv_flow_imp.g_varchar2_table(779) := '3228742D35362C2131295E652E67657455696E74333228742D36342C2131292C31292C2131293B6C6574206E2C692C722C6F3D746869732E5F68302C613D746869732E5F68312C733D746869732E5F68322C6C3D746869732E5F68332C683D746869732E';
wwv_flow_imp.g_varchar2_table(780) := '5F68343B666F72286C657420743D303B743C38303B742B2B29743C32303F286E3D6126737C7E61266C2C693D31353138353030323439293A743C34303F286E3D615E735E6C2C693D31383539373735333933293A743C36303F286E3D6126737C61266C7C';
wwv_flow_imp.g_varchar2_table(781) := '73266C2C693D32343030393539373038293A286E3D615E735E6C2C693D33333935343639373832292C723D5265286F2C35292B6E2B682B692B652E67657455696E74333228342A742C21312926343239343936373239352C683D6C2C6C3D732C733D5265';
wwv_flow_imp.g_varchar2_table(782) := '28612C3330292C613D6F2C6F3D723B746869732E5F68303D746869732E5F68302B6F26343239343936373239352C746869732E5F68313D746869732E5F68312B6126343239343936373239352C746869732E5F68323D746869732E5F68322B7326343239';
wwv_flow_imp.g_varchar2_table(783) := '343936373239352C746869732E5F68333D746869732E5F68332B6C26343239343936373239352C746869732E5F68343D746869732E5F68342B6826343239343936373239357D7D49652E5F626967426C6F636B33323D6E6577204461746156696577286E';
wwv_flow_imp.g_varchar2_table(784) := '65772041727261794275666665722833323029293B636C617373207A657B636F6E7374727563746F722865297B746869732E736F757263653D657D676574456C656D656E747328297B636F6E737420653D746869732E736F757263652C743D6E65772049';
wwv_flow_imp.g_varchar2_table(785) := '6E743332417272617928652E6C656E677468293B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D652E63686172436F64654174286E293B72657475726E20747D7D66756E6374696F6E20556528652C742C6E29';
wwv_flow_imp.g_varchar2_table(786) := '7B72657475726E206E6577205765286E6577207A652865292C6E6577207A65287429292E436F6D7075746544696666286E292E6368616E6765737D636C6173732048657B7374617469632041737365727428652C74297B6966282165297468726F77206E';
wwv_flow_imp.g_varchar2_table(787) := '6577204572726F722874297D7D636C6173732044657B73746174696320436F707928652C742C6E2C692C72297B666F72286C6574206F3D303B6F3C723B6F2B2B296E5B692B6F5D3D655B742B6F5D7D73746174696320436F70793228652C742C6E2C692C';
wwv_flow_imp.g_varchar2_table(788) := '72297B666F72286C6574206F3D303B6F3C723B6F2B2B296E5B692B6F5D3D655B742B6F5D7D7D636C617373204F657B636F6E7374727563746F7228297B746869732E6D5F6368616E6765733D5B5D2C746869732E6D5F6F726967696E616C53746172743D';
wwv_flow_imp.g_varchar2_table(789) := '313037333734313832342C746869732E6D5F6D6F64696669656453746172743D313037333734313832342C746869732E6D5F6F726967696E616C436F756E743D302C746869732E6D5F6D6F646966696564436F756E743D307D4D61726B4E657874436861';
wwv_flow_imp.g_varchar2_table(790) := '6E676528297B28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E6D5F6368616E6765732E70757368286E657720436528746869732E6D5F6F726967696E616C5374';
wwv_flow_imp.g_varchar2_table(791) := '6172742C746869732E6D5F6F726967696E616C436F756E742C746869732E6D5F6D6F64696669656453746172742C746869732E6D5F6D6F646966696564436F756E7429292C746869732E6D5F6F726967696E616C436F756E743D302C746869732E6D5F6D';
wwv_flow_imp.g_varchar2_table(792) := '6F646966696564436F756E743D302C746869732E6D5F6F726967696E616C53746172743D313037333734313832342C746869732E6D5F6D6F64696669656453746172743D313037333734313832347D4164644F726967696E616C456C656D656E7428652C';
wwv_flow_imp.g_varchar2_table(793) := '74297B746869732E6D5F6F726967696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F726967696E616C53746172742C65292C746869732E6D5F6D6F64696669656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669';
wwv_flow_imp.g_varchar2_table(794) := '656453746172742C74292C746869732E6D5F6F726967696E616C436F756E742B2B7D4164644D6F646966696564456C656D656E7428652C74297B746869732E6D5F6F726967696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F72696769';
wwv_flow_imp.g_varchar2_table(795) := '6E616C53746172742C65292C746869732E6D5F6D6F64696669656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669656453746172742C74292C746869732E6D5F6D6F646966696564436F756E742B2B7D6765744368616E67657328';
wwv_flow_imp.g_varchar2_table(796) := '297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E4D61726B4E6578744368616E676528292C746869732E6D5F6368616E6765737D6765745265';
wwv_flow_imp.g_varchar2_table(797) := '76657273654368616E67657328297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E4D61726B4E6578744368616E676528292C746869732E6D5F';
wwv_flow_imp.g_varchar2_table(798) := '6368616E6765732E7265766572736528292C746869732E6D5F6368616E6765737D7D636C6173732057657B636F6E7374727563746F7228652C742C6E3D6E756C6C297B746869732E436F6E74696E756550726F63657373696E675072656469636174653D';
wwv_flow_imp.g_varchar2_table(799) := '6E2C746869732E5F6F726967696E616C53657175656E63653D652C746869732E5F6D6F64696669656453657175656E63653D743B636F6E73745B692C722C6F5D3D57652E5F676574456C656D656E74732865292C5B612C732C6C5D3D57652E5F67657445';
wwv_flow_imp.g_varchar2_table(800) := '6C656D656E74732874293B746869732E5F686173537472696E67733D6F26266C2C746869732E5F6F726967696E616C537472696E67456C656D656E74733D692C746869732E5F6F726967696E616C456C656D656E74734F72486173683D722C746869732E';
wwv_flow_imp.g_varchar2_table(801) := '5F6D6F646966696564537472696E67456C656D656E74733D612C746869732E5F6D6F646966696564456C656D656E74734F72486173683D732C746869732E6D5F666F7277617264486973746F72793D5B5D2C746869732E6D5F7265766572736548697374';
wwv_flow_imp.g_varchar2_table(802) := '6F72793D5B5D7D737461746963205F6973537472696E6741727261792865297B72657475726E20652E6C656E6774683E30262622737472696E67223D3D747970656F6620655B305D7D737461746963205F676574456C656D656E74732865297B636F6E73';
wwv_flow_imp.g_varchar2_table(803) := '7420743D652E676574456C656D656E747328293B69662857652E5F6973537472696E674172726179287429297B636F6E737420653D6E657720496E743332417272617928742E6C656E677468293B666F72286C6574206E3D302C693D742E6C656E677468';
wwv_flow_imp.g_varchar2_table(804) := '3B6E3C693B6E2B2B29655B6E5D3D416528745B6E5D2C30293B72657475726E5B742C652C21305D7D72657475726E207420696E7374616E63656F6620496E74333241727261793F5B5B5D2C742C21315D3A5B5B5D2C6E657720496E743332417272617928';
wwv_flow_imp.g_varchar2_table(805) := '74292C21315D7D456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6F726967696E616C456C656D656E74734F72486173685B655D3D3D3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B74';
wwv_flow_imp.g_varchar2_table(806) := '5D26262821746869732E5F686173537472696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D3D3D3D746869732E5F6D6F646966696564537472696E67456C656D656E74735B745D297D456C656D656E74734172';
wwv_flow_imp.g_varchar2_table(807) := '65537472696374457175616C28652C74297B72657475726E2121746869732E456C656D656E7473417265457175616C28652C7429262657652E5F676574537472696374456C656D656E7428746869732E5F6F726967696E616C53657175656E63652C6529';
wwv_flow_imp.g_varchar2_table(808) := '3D3D3D57652E5F676574537472696374456C656D656E7428746869732E5F6D6F64696669656453657175656E63652C74297D737461746963205F676574537472696374456C656D656E7428652C74297B72657475726E2266756E6374696F6E223D3D7479';
wwv_flow_imp.g_varchar2_table(809) := '70656F6620652E676574537472696374456C656D656E743F652E676574537472696374456C656D656E742874293A6E756C6C7D4F726967696E616C456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6F726967696E';
wwv_flow_imp.g_varchar2_table(810) := '616C456C656D656E74734F72486173685B655D3D3D3D746869732E5F6F726967696E616C456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D65';
wwv_flow_imp.g_varchar2_table(811) := '6E74735B655D3D3D3D746869732E5F6F726967696E616C537472696E67456C656D656E74735B745D297D4D6F646966696564456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6D6F646966696564456C656D656E74';
wwv_flow_imp.g_varchar2_table(812) := '734F72486173685B655D3D3D3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869732E5F6D6F646966696564537472696E67456C656D656E74735B655D3D3D3D';
wwv_flow_imp.g_varchar2_table(813) := '746869732E5F6D6F646966696564537472696E67456C656D656E74735B745D297D436F6D70757465446966662865297B72657475726E20746869732E5F436F6D707574654469666628302C746869732E5F6F726967696E616C456C656D656E74734F7248';
wwv_flow_imp.g_varchar2_table(814) := '6173682E6C656E6774682D312C302C746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682D312C65297D5F436F6D707574654469666628652C742C6E2C692C72297B636F6E7374206F3D5B21315D3B6C657420613D74';
wwv_flow_imp.g_varchar2_table(815) := '6869732E436F6D707574654469666652656375727369766528652C742C6E2C692C6F293B72657475726E2072262628613D746869732E50726574746966794368616E676573286129292C7B717569744561726C793A6F5B305D2C6368616E6765733A617D';
wwv_flow_imp.g_varchar2_table(816) := '7D436F6D707574654469666652656375727369766528652C742C6E2C692C72297B666F7228725B305D3D21313B653C3D7426266E3C3D692626746869732E456C656D656E7473417265457175616C28652C6E293B29652B2B2C6E2B2B3B666F72283B743E';
wwv_flow_imp.g_varchar2_table(817) := '3D652626693E3D6E2626746869732E456C656D656E7473417265457175616C28742C69293B29742D2D2C692D2D3B696628653E747C7C6E3E69297B6C657420723B72657475726E206E3C3D693F2848652E41737365727428653D3D3D742B312C226F7269';
wwv_flow_imp.g_varchar2_table(818) := '67696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C723D5B6E657720436528652C302C6E2C692D6E2B31295D293A653C3D743F2848652E417373657274286E3D3D3D69';
wwv_flow_imp.g_varchar2_table(819) := '2B312C226D6F64696669656453746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C723D5B6E657720436528652C742D652B312C6E2C30295D293A2848652E41737365727428653D3D';
wwv_flow_imp.g_varchar2_table(820) := '3D742B312C226F726967696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C48652E417373657274286E3D3D3D692B312C226D6F64696669656453746172742073686F75';
wwv_flow_imp.g_varchar2_table(821) := '6C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C723D5B5D292C727D636F6E7374206F3D5B305D2C613D5B305D2C733D746869732E436F6D70757465526563757273696F6E506F696E7428652C742C6E2C';
wwv_flow_imp.g_varchar2_table(822) := '692C6F2C612C72292C6C3D6F5B305D2C683D615B305D3B6966286E756C6C213D3D732972657475726E20733B69662821725B305D297B636F6E7374206F3D746869732E436F6D707574654469666652656375727369766528652C6C2C6E2C682C72293B6C';
wwv_flow_imp.g_varchar2_table(823) := '657420613D5B5D3B72657475726E20613D725B305D3F5B6E6577204365286C2B312C742D286C2B31292B312C682B312C692D28682B31292B31295D3A746869732E436F6D7075746544696666526563757273697665286C2B312C742C682B312C692C7229';
wwv_flow_imp.g_varchar2_table(824) := '2C746869732E436F6E636174656E6174654368616E676573286F2C61297D72657475726E5B6E657720436528652C742D652B312C6E2C692D6E2B31295D7D57414C4B545241434528652C742C6E2C692C722C6F2C612C732C6C2C682C632C642C752C6D2C';
wwv_flow_imp.g_varchar2_table(825) := '702C662C672C62297B6C6574205F3D6E756C6C2C763D6E756C6C2C773D6E6577204F652C793D742C543D6E2C6B3D755B305D2D665B305D2D692C533D2D313037333734313832342C783D746869732E6D5F666F7277617264486973746F72792E6C656E67';
wwv_flow_imp.g_varchar2_table(826) := '74682D313B646F7B636F6E737420743D6B2B653B743D3D3D797C7C743C5426266C5B742D315D3C6C5B742B315D3F286D3D28633D6C5B742B315D292D6B2D692C633C532626772E4D61726B4E6578744368616E676528292C533D632C772E4164644D6F64';
wwv_flow_imp.g_varchar2_table(827) := '6966696564456C656D656E7428632B312C6D292C6B3D742B312D65293A286D3D28633D6C5B742D315D2B31292D6B2D692C633C532626772E4D61726B4E6578744368616E676528292C533D632D312C772E4164644F726967696E616C456C656D656E7428';
wwv_flow_imp.g_varchar2_table(828) := '632C6D2B31292C6B3D742D312D65292C783E3D30262628653D286C3D746869732E6D5F666F7277617264486973746F72795B785D295B305D2C793D312C543D6C2E6C656E6774682D31297D7768696C65282D2D783E3D2D31293B6966285F3D772E676574';
wwv_flow_imp.g_varchar2_table(829) := '526576657273654368616E67657328292C625B305D297B6C657420653D755B305D2B312C743D665B305D2B313B6966286E756C6C213D3D5F26265F2E6C656E6774683E30297B636F6E7374206E3D5F5B5F2E6C656E6774682D315D3B653D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(830) := '617828652C6E2E6765744F726967696E616C456E642829292C743D4D6174682E6D617828742C6E2E6765744D6F646966696564456E642829297D763D5B6E657720436528652C642D652B312C742C702D742B31295D7D656C73657B773D6E6577204F652C';
wwv_flow_imp.g_varchar2_table(831) := '793D6F2C543D612C6B3D755B305D2D665B305D2D732C533D313037333734313832342C783D673F746869732E6D5F72657665727365486973746F72792E6C656E6774682D313A746869732E6D5F72657665727365486973746F72792E6C656E6774682D32';
wwv_flow_imp.g_varchar2_table(832) := '3B646F7B636F6E737420653D6B2B723B653D3D3D797C7C653C542626685B652D315D3E3D685B652B315D3F286D3D28633D685B652B315D2D31292D6B2D732C633E532626772E4D61726B4E6578744368616E676528292C533D632B312C772E4164644F72';
wwv_flow_imp.g_varchar2_table(833) := '6967696E616C456C656D656E7428632B312C6D2B31292C6B3D652B312D72293A286D3D28633D685B652D315D292D6B2D732C633E532626772E4D61726B4E6578744368616E676528292C533D632C772E4164644D6F646966696564456C656D656E742863';
wwv_flow_imp.g_varchar2_table(834) := '2B312C6D2B31292C6B3D652D312D72292C783E3D30262628723D28683D746869732E6D5F72657665727365486973746F72795B785D295B305D2C793D312C543D682E6C656E6774682D31297D7768696C65282D2D783E3D2D31293B763D772E6765744368';
wwv_flow_imp.g_varchar2_table(835) := '616E67657328297D72657475726E20746869732E436F6E636174656E6174654368616E676573285F2C76297D436F6D70757465526563757273696F6E506F696E7428652C742C6E2C692C722C6F2C61297B6C657420733D302C6C3D302C683D302C633D30';
wwv_flow_imp.g_varchar2_table(836) := '2C643D302C753D303B652D2D2C6E2D2D2C725B305D3D302C6F5B305D3D302C746869732E6D5F666F7277617264486973746F72793D5B5D2C746869732E6D5F72657665727365486973746F72793D5B5D3B636F6E7374206D3D742D652B28692D6E292C70';
wwv_flow_imp.g_varchar2_table(837) := '3D6D2B312C663D6E657720496E74333241727261792870292C673D6E657720496E74333241727261792870292C623D692D6E2C5F3D742D652C763D652D6E2C773D742D692C793D285F2D622925323D3D303B665B625D3D652C675B5F5D3D742C615B305D';
wwv_flow_imp.g_varchar2_table(838) := '3D21313B666F72286C657420543D313B543C3D6D2F322B313B542B2B297B6C6574206D3D302C6B3D303B683D746869732E436C6970446961676F6E616C426F756E6428622D542C542C622C70292C633D746869732E436C6970446961676F6E616C426F75';
wwv_flow_imp.g_varchar2_table(839) := '6E6428622B542C542C622C70293B666F72286C657420653D683B653C3D633B652B3D32297B733D653D3D3D687C7C653C632626665B652D315D3C665B652B315D3F665B652B315D3A665B652D315D2B312C6C3D732D28652D62292D763B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(840) := '3D733B666F72283B733C7426266C3C692626746869732E456C656D656E7473417265457175616C28732B312C6C2B31293B29732B2B2C6C2B2B3B696628665B655D3D732C732B6C3E6D2B6B2626286D3D732C6B3D6C292C217926264D6174682E61627328';
wwv_flow_imp.g_varchar2_table(841) := '652D5F293C3D542D312626733E3D675B655D2972657475726E20725B305D3D732C6F5B305D3D6C2C6E3C3D675B655D2626543C3D313434383F746869732E57414C4B545241434528622C682C632C762C5F2C642C752C772C662C672C732C742C722C6C2C';
wwv_flow_imp.g_varchar2_table(842) := '692C6F2C792C61293A6E756C6C7D636F6E737420533D286D2D652B286B2D6E292D54292F323B6966286E756C6C213D3D746869732E436F6E74696E756550726F63657373696E67507265646963617465262621746869732E436F6E74696E756550726F63';
wwv_flow_imp.g_varchar2_table(843) := '657373696E67507265646963617465286D2C53292972657475726E20615B305D3D21302C725B305D3D6D2C6F5B305D3D6B2C533E302626543C3D313434383F746869732E57414C4B545241434528622C682C632C762C5F2C642C752C772C662C672C732C';
wwv_flow_imp.g_varchar2_table(844) := '742C722C6C2C692C6F2C792C61293A28652B2B2C6E2B2B2C5B6E657720436528652C742D652B312C6E2C692D6E2B31295D293B643D746869732E436C6970446961676F6E616C426F756E64285F2D542C542C5F2C70292C753D746869732E436C69704469';
wwv_flow_imp.g_varchar2_table(845) := '61676F6E616C426F756E64285F2B542C542C5F2C70293B666F72286C6574206D3D643B6D3C3D753B6D2B3D32297B733D6D3D3D3D647C7C6D3C752626675B6D2D315D3E3D675B6D2B315D3F675B6D2B315D2D313A675B6D2D315D2C6C3D732D286D2D5F29';
wwv_flow_imp.g_varchar2_table(846) := '2D773B636F6E737420703D733B666F72283B733E6526266C3E6E2626746869732E456C656D656E7473417265457175616C28732C6C293B29732D2D2C6C2D2D3B696628675B6D5D3D732C7926264D6174682E616273286D2D62293C3D542626733C3D665B';
wwv_flow_imp.g_varchar2_table(847) := '6D5D2972657475726E20725B305D3D732C6F5B305D3D6C2C703E3D665B6D5D2626543C3D313434383F746869732E57414C4B545241434528622C682C632C762C5F2C642C752C772C662C672C732C742C722C6C2C692C6F2C792C61293A6E756C6C7D6966';
wwv_flow_imp.g_varchar2_table(848) := '28543C3D31343437297B6C657420653D6E657720496E743332417272617928632D682B32293B655B305D3D622D682B312C44652E436F70793228662C682C652C312C632D682B31292C746869732E6D5F666F7277617264486973746F72792E7075736828';
wwv_flow_imp.g_varchar2_table(849) := '65292C653D6E657720496E743332417272617928752D642B32292C655B305D3D5F2D642B312C44652E436F70793228672C642C652C312C752D642B31292C746869732E6D5F72657665727365486973746F72792E707573682865297D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(850) := '746869732E57414C4B545241434528622C682C632C762C5F2C642C752C772C662C672C732C742C722C6C2C692C6F2C792C61297D50726574746966794368616E6765732865297B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B63';
wwv_flow_imp.g_varchar2_table(851) := '6F6E7374206E3D655B745D2C693D743C652E6C656E6774682D313F655B742B315D2E6F726967696E616C53746172743A746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E6774682C723D743C652E6C656E6774682D313F65';
wwv_flow_imp.g_varchar2_table(852) := '5B742B315D2E6D6F64696669656453746172743A746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682C6F3D6E2E6F726967696E616C4C656E6774683E302C613D6E2E6D6F6469666965644C656E6774683E303B666F';
wwv_flow_imp.g_varchar2_table(853) := '72283B6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774683C6926266E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E6774683C72262628216F7C7C746869732E4F726967696E616C456C656D656E74';
wwv_flow_imp.g_varchar2_table(854) := '73417265457175616C286E2E6F726967696E616C53746172742C6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E677468292926262821617C7C746869732E4D6F646966696564456C656D656E7473417265457175616C286E2E6D';
wwv_flow_imp.g_varchar2_table(855) := '6F64696669656453746172742C6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E67746829293B297B636F6E737420653D746869732E456C656D656E7473417265537472696374457175616C286E2E6F726967696E616C53746172';
wwv_flow_imp.g_varchar2_table(856) := '742C6E2E6D6F6469666965645374617274293B696628746869732E456C656D656E7473417265537472696374457175616C286E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742B6E';
wwv_flow_imp.g_varchar2_table(857) := '2E6D6F6469666965644C656E677468292626216529627265616B3B6E2E6F726967696E616C53746172742B2B2C6E2E6D6F64696669656453746172742B2B7D636F6E737420733D5B6E756C6C5D3B743C652E6C656E6774682D312626746869732E436861';
wwv_flow_imp.g_varchar2_table(858) := '6E6765734F7665726C617028655B745D2C655B742B315D2C7329262628655B745D3D735B305D2C652E73706C69636528742B312C31292C742D2D297D666F72286C657420743D652E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D65';
wwv_flow_imp.g_varchar2_table(859) := '5B745D3B6C657420693D302C723D303B696628743E30297B636F6E7374206E3D655B742D315D3B693D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682C723D6E2E6D6F64696669656453746172742B6E2E6D6F64696669';
wwv_flow_imp.g_varchar2_table(860) := '65644C656E6774687D636F6E7374206F3D6E2E6F726967696E616C4C656E6774683E302C613D6E2E6D6F6469666965644C656E6774683E303B6C657420733D302C6C3D746869732E5F626F756E6461727953636F7265286E2E6F726967696E616C537461';
wwv_flow_imp.g_varchar2_table(861) := '72742C6E2E6F726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742C6E2E6D6F6469666965644C656E677468293B666F72286C657420653D313B3B652B2B297B636F6E737420743D6E2E6F726967696E616C53746172742D652C683D';
wwv_flow_imp.g_varchar2_table(862) := '6E2E6D6F64696669656453746172742D653B696628743C697C7C683C7229627265616B3B6966286F262621746869732E4F726967696E616C456C656D656E7473417265457175616C28742C742B6E2E6F726967696E616C4C656E6774682929627265616B';
wwv_flow_imp.g_varchar2_table(863) := '3B69662861262621746869732E4D6F646966696564456C656D656E7473417265457175616C28682C682B6E2E6D6F6469666965644C656E6774682929627265616B3B636F6E737420633D28743D3D3D692626683D3D3D723F353A30292B746869732E5F62';
wwv_flow_imp.g_varchar2_table(864) := '6F756E6461727953636F726528742C6E2E6F726967696E616C4C656E6774682C682C6E2E6D6F6469666965644C656E677468293B633E6C2626286C3D632C733D65297D6E2E6F726967696E616C53746172742D3D732C6E2E6D6F64696669656453746172';
wwv_flow_imp.g_varchar2_table(865) := '742D3D733B636F6E737420683D5B6E756C6C5D3B743E302626746869732E4368616E6765734F7665726C617028655B742D315D2C655B745D2C6829262628655B742D315D3D685B305D2C652E73706C69636528742C31292C742B2B297D69662874686973';
wwv_flow_imp.g_varchar2_table(866) := '2E5F686173537472696E677329666F72286C657420743D312C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B742D315D2C693D655B745D2C723D692E6F726967696E616C53746172742D6E2E6F726967696E616C5374617274';
wwv_flow_imp.g_varchar2_table(867) := '2D6E2E6F726967696E616C4C656E6774682C6F3D6E2E6F726967696E616C53746172742C613D692E6F726967696E616C53746172742B692E6F726967696E616C4C656E6774682C733D612D6F2C6C3D6E2E6D6F64696669656453746172742C683D692E6D';
wwv_flow_imp.g_varchar2_table(868) := '6F64696669656453746172742B692E6D6F6469666965644C656E6774682C633D682D6C3B696628723C352626733C32302626633C3230297B636F6E737420653D746869732E5F66696E64426574746572436F6E746967756F757353657175656E6365286F';
wwv_flow_imp.g_varchar2_table(869) := '2C732C6C2C632C72293B69662865297B636F6E73745B742C6F5D3D653B743D3D3D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E67746826266F3D3D3D6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E';
wwv_flow_imp.g_varchar2_table(870) := '6774687C7C286E2E6F726967696E616C4C656E6774683D742D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D6F2D6E2E6D6F64696669656453746172742C692E6F726967696E616C53746172743D742B722C692E6D6F';
wwv_flow_imp.g_varchar2_table(871) := '64696669656453746172743D6F2B722C692E6F726967696E616C4C656E6774683D612D692E6F726967696E616C53746172742C692E6D6F6469666965644C656E6774683D682D692E6D6F6469666965645374617274297D7D7D72657475726E20657D5F66';
wwv_flow_imp.g_varchar2_table(872) := '696E64426574746572436F6E746967756F757353657175656E636528652C742C6E2C692C72297B696628743C727C7C693C722972657475726E206E756C6C3B636F6E7374206F3D652B742D722B312C613D6E2B692D722B313B6C657420733D302C6C3D30';
wwv_flow_imp.g_varchar2_table(873) := '2C683D303B666F72286C657420743D653B743C6F3B742B2B29666F72286C657420653D6E3B653C613B652B2B297B636F6E7374206E3D746869732E5F636F6E746967756F757353657175656E636553636F726528742C652C72293B6E3E3026266E3E7326';
wwv_flow_imp.g_varchar2_table(874) := '2628733D6E2C6C3D742C683D65297D72657475726E20733E303F5B6C2C685D3A6E756C6C7D5F636F6E746967756F757353657175656E636553636F726528652C742C6E297B6C657420693D303B666F72286C657420723D303B723C6E3B722B2B297B6966';
wwv_flow_imp.g_varchar2_table(875) := '2821746869732E456C656D656E7473417265457175616C28652B722C742B72292972657475726E20303B692B3D746869732E5F6F726967696E616C537472696E67456C656D656E74735B652B725D2E6C656E6774687D72657475726E20697D5F4F726967';
wwv_flow_imp.g_varchar2_table(876) := '696E616C4973426F756E646172792865297B72657475726E20653C3D307C7C653E3D746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E6774682D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E74';
wwv_flow_imp.g_varchar2_table(877) := '65737428746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D297D5F4F726967696E616C526567696F6E4973426F756E6461727928652C74297B696628746869732E5F4F726967696E616C4973426F756E646172792865297C7C';
wwv_flow_imp.g_varchar2_table(878) := '746869732E5F4F726967696E616C4973426F756E6461727928652D31292972657475726E21303B696628743E30297B636F6E7374206E3D652B743B696628746869732E5F4F726967696E616C4973426F756E64617279286E2D31297C7C746869732E5F4F';
wwv_flow_imp.g_varchar2_table(879) := '726967696E616C4973426F756E64617279286E292972657475726E21307D72657475726E21317D5F4D6F6469666965644973426F756E646172792865297B72657475726E20653C3D307C7C653E3D746869732E5F6D6F646966696564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(880) := '4F72486173682E6C656E6774682D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E7465737428746869732E5F6D6F646966696564537472696E67456C656D656E74735B655D297D5F4D6F646966696564526567696F6E4973426F';
wwv_flow_imp.g_varchar2_table(881) := '756E6461727928652C74297B696628746869732E5F4D6F6469666965644973426F756E646172792865297C7C746869732E5F4D6F6469666965644973426F756E6461727928652D31292972657475726E21303B696628743E30297B636F6E7374206E3D65';
wwv_flow_imp.g_varchar2_table(882) := '2B743B696628746869732E5F4D6F6469666965644973426F756E64617279286E2D31297C7C746869732E5F4D6F6469666965644973426F756E64617279286E292972657475726E21307D72657475726E21317D5F626F756E6461727953636F726528652C';
wwv_flow_imp.g_varchar2_table(883) := '742C6E2C69297B72657475726E28746869732E5F4F726967696E616C526567696F6E4973426F756E6461727928652C74293F313A30292B28746869732E5F4D6F646966696564526567696F6E4973426F756E64617279286E2C69293F313A30297D436F6E';
wwv_flow_imp.g_varchar2_table(884) := '636174656E6174654368616E67657328652C74297B636F6E7374206E3D5B5D3B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E20742E6C656E6774683E303F743A653B696628746869732E4368616E6765734F';
wwv_flow_imp.g_varchar2_table(885) := '7665726C617028655B652E6C656E6774682D315D2C745B305D2C6E29297B636F6E737420693D6E657720417272617928652E6C656E6774682B742E6C656E6774682D31293B72657475726E2044652E436F707928652C302C692C302C652E6C656E677468';
wwv_flow_imp.g_varchar2_table(886) := '2D31292C695B652E6C656E6774682D315D3D6E5B305D2C44652E436F707928742C312C692C652E6C656E6774682C742E6C656E6774682D31292C697D7B636F6E7374206E3D6E657720417272617928652E6C656E6774682B742E6C656E677468293B7265';
wwv_flow_imp.g_varchar2_table(887) := '7475726E2044652E436F707928652C302C6E2C302C652E6C656E677468292C44652E436F707928742C302C6E2C652E6C656E6774682C742E6C656E677468292C6E7D7D4368616E6765734F7665726C617028652C742C6E297B69662848652E4173736572';
wwv_flow_imp.g_varchar2_table(888) := '7428652E6F726967696E616C53746172743C3D742E6F726967696E616C53746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F7220657175616C20746F207269676874206368616E676522292C48652E4173736572';
wwv_flow_imp.g_varchar2_table(889) := '7428652E6D6F64696669656453746172743C3D742E6D6F64696669656453746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F7220657175616C20746F207269676874206368616E676522292C652E6F726967696E';
wwv_flow_imp.g_varchar2_table(890) := '616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C53746172747C7C652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774683E3D742E6D6F6469666965645374617274297B636F6E737420';
wwv_flow_imp.g_varchar2_table(891) := '693D652E6F726967696E616C53746172743B6C657420723D652E6F726967696E616C4C656E6774683B636F6E7374206F3D652E6D6F64696669656453746172743B6C657420613D652E6D6F6469666965644C656E6774683B72657475726E20652E6F7269';
wwv_flow_imp.g_varchar2_table(892) := '67696E616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C5374617274262628723D742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D652E6F726967696E616C5374617274292C65';
wwv_flow_imp.g_varchar2_table(893) := '2E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774683E3D742E6D6F6469666965645374617274262628613D742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D652E6D6F64696669656453746172';
wwv_flow_imp.g_varchar2_table(894) := '74292C6E5B305D3D6E657720436528692C722C6F2C61292C21307D72657475726E206E5B305D3D6E756C6C2C21317D436C6970446961676F6E616C426F756E6428652C742C6E2C69297B696628653E3D302626653C692972657475726E20653B636F6E73';
wwv_flow_imp.g_varchar2_table(895) := '7420723D7425323D3D303B72657475726E20653C303F723D3D3D286E25323D3D30293F303A313A723D3D3D2828692D6E2D312925323D3D30293F692D313A692D327D7D636F6E73742050653D676C6F62616C546869732E7673636F64653B696628766F69';
wwv_flow_imp.g_varchar2_table(896) := '642030213D3D50652626766F69642030213D3D50652E70726F63657373297B636F6E737420653D50652E70726F636573733B62653D7B67657420706C6174666F726D28297B72657475726E20652E706C6174666F726D7D2C676574206172636828297B72';
wwv_flow_imp.g_varchar2_table(897) := '657475726E20652E617263687D2C67657420656E7628297B72657475726E20652E656E767D2C6377643A28293D3E652E63776428297D7D656C73652062653D22756E646566696E656422213D747970656F662070726F636573733F7B67657420706C6174';
wwv_flow_imp.g_varchar2_table(898) := '666F726D28297B72657475726E2070726F636573732E706C6174666F726D7D2C676574206172636828297B72657475726E2070726F636573732E617263687D2C67657420656E7628297B72657475726E2070726F636573732E656E767D2C6377643A2829';
wwv_flow_imp.g_varchar2_table(899) := '3D3E70726F636573732E656E762E5653434F44455F4357447C7C70726F636573732E63776428297D3A7B67657420706C6174666F726D28297B72657475726E2065653F2277696E3332223A74653F2264617277696E223A226C696E7578227D2C67657420';
wwv_flow_imp.g_varchar2_table(900) := '6172636828297B7D2C67657420656E7628297B72657475726E7B7D7D2C6377643A28293D3E222F227D3B636F6E73742071653D62652E6377642C46653D62652E656E762C42653D62652E706C6174666F726D2C56653D34362C4B653D34372C6A653D3932';
wwv_flow_imp.g_varchar2_table(901) := '2C47653D35383B636C61737320246520657874656E6473204572726F727B636F6E7374727563746F7228652C742C6E297B6C657420693B22737472696E67223D3D747970656F6620742626303D3D3D742E696E6465784F6628226E6F742022293F28693D';
wwv_flow_imp.g_varchar2_table(902) := '226D757374206E6F74206265222C743D742E7265706C616365282F5E6E6F74202F2C222229293A693D226D757374206265223B636F6E737420723D2D31213D3D652E696E6465784F6628222E22293F2270726F7065727479223A22617267756D656E7422';
wwv_flow_imp.g_varchar2_table(903) := '3B6C6574206F3D605468652022247B657D2220247B727D20247B697D206F66207479706520247B747D603B6F2B3D222E205265636569766564207479706520222B747970656F66206E2C7375706572286F292C746869732E636F64653D224552525F494E';
wwv_flow_imp.g_varchar2_table(904) := '56414C49445F4152475F54595045227D7D66756E6374696F6E20586528652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720246528742C22737472696E67222C65297D636F6E7374204A653D2277696E3332223D';
wwv_flow_imp.g_varchar2_table(905) := '3D3D42653B66756E6374696F6E2059652865297B72657475726E20653D3D3D4B657C7C653D3D3D6A657D66756E6374696F6E2051652865297B72657475726E20653D3D3D4B657D66756E6374696F6E205A652865297B72657475726E20653E3D36352626';
wwv_flow_imp.g_varchar2_table(906) := '653C3D39307C7C653E3D39372626653C3D3132327D66756E6374696F6E20657428652C742C6E2C69297B6C657420723D22222C6F3D302C613D2D312C733D302C6C3D303B666F72286C657420683D303B683C3D652E6C656E6774683B2B2B68297B696628';
wwv_flow_imp.g_varchar2_table(907) := '683C652E6C656E677468296C3D652E63686172436F646541742868293B656C73657B69662869286C2929627265616B3B6C3D4B657D69662869286C29297B696628613D3D3D682D317C7C313D3D3D73293B656C736520696628323D3D3D73297B69662872';
wwv_flow_imp.g_varchar2_table(908) := '2E6C656E6774683C327C7C32213D3D6F7C7C722E63686172436F6465417428722E6C656E6774682D3129213D3D56657C7C722E63686172436F6465417428722E6C656E6774682D3229213D3D5665297B696628722E6C656E6774683E32297B636F6E7374';
wwv_flow_imp.g_varchar2_table(909) := '20653D722E6C617374496E6465784F66286E293B2D313D3D3D653F28723D22222C6F3D30293A28723D722E736C69636528302C65292C6F3D722E6C656E6774682D312D722E6C617374496E6465784F66286E29292C613D682C733D303B636F6E74696E75';
wwv_flow_imp.g_varchar2_table(910) := '657D69662830213D3D722E6C656E677468297B723D22222C6F3D302C613D682C733D303B636F6E74696E75657D7D74262628722B3D722E6C656E6774683E303F60247B6E7D2E2E603A222E2E222C6F3D32297D656C736520722E6C656E6774683E303F72';
wwv_flow_imp.g_varchar2_table(911) := '2B3D60247B6E7D247B652E736C69636528612B312C68297D603A723D652E736C69636528612B312C68292C6F3D682D612D313B613D682C733D307D656C7365206C3D3D3D566526262D31213D3D733F2B2B733A733D2D317D72657475726E20727D66756E';
wwv_flow_imp.g_varchar2_table(912) := '6374696F6E20747428652C74297B2166756E6374696F6E2865297B6966286E756C6C3D3D3D657C7C226F626A65637422213D747970656F662065297468726F77206E65772024652822706174684F626A656374222C224F626A656374222C65297D287429';
wwv_flow_imp.g_varchar2_table(913) := '3B636F6E7374206E3D742E6469727C7C742E726F6F742C693D742E626173657C7C60247B742E6E616D657C7C22227D247B742E6578747C7C22227D603B72657475726E206E3F6E3D3D3D742E726F6F743F60247B6E7D247B697D603A60247B6E7D247B65';
wwv_flow_imp.g_varchar2_table(914) := '7D247B697D603A697D636F6E7374206E743D7B7265736F6C7665282E2E2E65297B6C657420743D22222C6E3D22222C693D21313B666F72286C657420723D652E6C656E6774682D313B723E3D2D313B722D2D297B6C6574206F3B696628723E3D30297B69';
wwv_flow_imp.g_varchar2_table(915) := '66286F3D655B725D2C5865286F2C227061746822292C303D3D3D6F2E6C656E67746829636F6E74696E75657D656C736520303D3D3D742E6C656E6774683F6F3D716528293A286F3D46655B603D247B747D605D7C7C716528292C28766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(916) := '6F7C7C6F2E736C69636528302C32292E746F4C6F776572436173652829213D3D742E746F4C6F77657243617365282926266F2E63686172436F646541742832293D3D3D6A65292626286F3D60247B747D5C5C6029293B636F6E737420613D6F2E6C656E67';
wwv_flow_imp.g_varchar2_table(917) := '74683B6C657420733D302C6C3D22222C683D21313B636F6E737420633D6F2E63686172436F646541742830293B696628313D3D3D61295965286329262628733D312C683D2130293B656C736520696628596528632929696628683D21302C5965286F2E63';
wwv_flow_imp.g_varchar2_table(918) := '686172436F6465417428312929297B6C657420653D322C743D653B666F72283B653C612626215965286F2E63686172436F64654174286529293B29652B2B3B696628653C61262665213D3D74297B636F6E7374206E3D6F2E736C69636528742C65293B66';
wwv_flow_imp.g_varchar2_table(919) := '6F7228743D653B653C6126265965286F2E63686172436F64654174286529293B29652B2B3B696628653C61262665213D3D74297B666F7228743D653B653C612626215965286F2E63686172436F64654174286529293B29652B2B3B65213D3D612626653D';
wwv_flow_imp.g_varchar2_table(920) := '3D3D747C7C286C3D605C5C5C5C247B6E7D5C5C247B6F2E736C69636528742C65297D602C733D65297D7D7D656C736520733D313B656C7365205A6528632926266F2E63686172436F646541742831293D3D3D47652626286C3D6F2E736C69636528302C32';
wwv_flow_imp.g_varchar2_table(921) := '292C733D322C613E3226265965286F2E63686172436F6465417428322929262628683D21302C733D3329293B6966286C2E6C656E6774683E3029696628742E6C656E6774683E30297B6966286C2E746F4C6F776572436173652829213D3D742E746F4C6F';
wwv_flow_imp.g_varchar2_table(922) := '77657243617365282929636F6E74696E75657D656C736520743D6C3B69662869297B696628742E6C656E6774683E3029627265616B7D656C7365206966286E3D60247B6F2E736C6963652873297D5C5C247B6E7D602C693D682C682626742E6C656E6774';
wwv_flow_imp.g_varchar2_table(923) := '683E3029627265616B7D72657475726E206E3D6574286E2C21692C225C5C222C5965292C693F60247B747D5C5C247B6E7D603A60247B747D247B6E7D607C7C222E227D2C6E6F726D616C697A652865297B586528652C227061746822293B636F6E737420';
wwv_flow_imp.g_varchar2_table(924) := '743D652E6C656E6774683B696628303D3D3D742972657475726E222E223B6C6574206E2C693D302C723D21313B636F6E7374206F3D652E63686172436F646541742830293B696628313D3D3D742972657475726E205165286F293F225C5C223A653B6966';
wwv_flow_imp.g_varchar2_table(925) := '285965286F2929696628723D21302C596528652E63686172436F6465417428312929297B6C657420723D322C6F3D723B666F72283B723C74262621596528652E63686172436F64654174287229293B29722B2B3B696628723C74262672213D3D6F297B63';
wwv_flow_imp.g_varchar2_table(926) := '6F6E737420613D652E736C696365286F2C72293B666F72286F3D723B723C742626596528652E63686172436F64654174287229293B29722B2B3B696628723C74262672213D3D6F297B666F72286F3D723B723C74262621596528652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(927) := '4174287229293B29722B2B3B696628723D3D3D742972657475726E605C5C5C5C247B617D5C5C247B652E736C696365286F297D5C5C603B72213D3D6F2626286E3D605C5C5C5C247B617D5C5C247B652E736C696365286F2C72297D602C693D72297D7D7D';
wwv_flow_imp.g_varchar2_table(928) := '656C736520693D313B656C7365205A65286F292626652E63686172436F646541742831293D3D3D47652626286E3D652E736C69636528302C32292C693D322C743E322626596528652E63686172436F6465417428322929262628723D21302C693D332929';
wwv_flow_imp.g_varchar2_table(929) := '3B6C657420613D693C743F657428652E736C6963652869292C21722C225C5C222C5965293A22223B72657475726E2030213D3D612E6C656E6774687C7C727C7C28613D222E22292C612E6C656E6774683E302626596528652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(930) := '742D312929262628612B3D225C5C22292C766F696420303D3D3D6E3F723F605C5C247B617D603A613A723F60247B6E7D5C5C247B617D603A60247B6E7D247B617D607D2C69734162736F6C7574652865297B586528652C227061746822293B636F6E7374';
wwv_flow_imp.g_varchar2_table(931) := '20743D652E6C656E6774683B696628303D3D3D742972657475726E21313B636F6E7374206E3D652E63686172436F646541742830293B72657475726E205965286E297C7C743E3226265A65286E292626652E63686172436F646541742831293D3D3D4765';
wwv_flow_imp.g_varchar2_table(932) := '2626596528652E63686172436F64654174283229297D2C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420742C6E3B666F72286C657420693D303B693C652E6C656E6774683B2B2B69297B636F6E73';
wwv_flow_imp.g_varchar2_table(933) := '7420723D655B695D3B586528722C227061746822292C722E6C656E6774683E30262628766F696420303D3D3D743F743D6E3D723A742B3D605C5C247B727D60297D696628766F696420303D3D3D742972657475726E222E223B6C657420693D21302C723D';
wwv_flow_imp.g_varchar2_table(934) := '303B69662822737472696E67223D3D747970656F66206E26265965286E2E63686172436F6465417428302929297B2B2B723B636F6E737420653D6E2E6C656E6774683B653E3126265965286E2E63686172436F64654174283129292626282B2B722C653E';
wwv_flow_imp.g_varchar2_table(935) := '322626285965286E2E63686172436F64654174283229293F2B2B723A693D213129297D69662869297B666F72283B723C742E6C656E6774682626596528742E63686172436F64654174287229293B29722B2B3B723E3D32262628743D605C5C247B742E73';
wwv_flow_imp.g_varchar2_table(936) := '6C6963652872297D60297D72657475726E206E742E6E6F726D616C697A652874297D2C72656C617469766528652C74297B696628586528652C2266726F6D22292C586528742C22746F22292C653D3D3D742972657475726E22223B636F6E7374206E3D6E';
wwv_flow_imp.g_varchar2_table(937) := '742E7265736F6C76652865292C693D6E742E7265736F6C76652874293B6966286E3D3D3D692972657475726E22223B69662828653D6E2E746F4C6F776572436173652829293D3D3D28743D692E746F4C6F776572436173652829292972657475726E2222';
wwv_flow_imp.g_varchar2_table(938) := '3B6C657420723D303B666F72283B723C652E6C656E6774682626652E63686172436F646541742872293D3D3D6A653B29722B2B3B6C6574206F3D652E6C656E6774683B666F72283B6F2D313E722626652E63686172436F64654174286F2D31293D3D3D6A';
wwv_flow_imp.g_varchar2_table(939) := '653B296F2D2D3B636F6E737420613D6F2D723B6C657420733D303B666F72283B733C742E6C656E6774682626742E63686172436F646541742873293D3D3D6A653B29732B2B3B6C6574206C3D742E6C656E6774683B666F72283B6C2D313E732626742E63';
wwv_flow_imp.g_varchar2_table(940) := '686172436F64654174286C2D31293D3D3D6A653B296C2D2D3B636F6E737420683D6C2D732C633D613C683F613A683B6C657420643D2D312C753D303B666F72283B753C633B752B2B297B636F6E7374206E3D652E63686172436F6465417428722B75293B';
wwv_flow_imp.g_varchar2_table(941) := '6966286E213D3D742E63686172436F6465417428732B752929627265616B3B6E3D3D3D6A65262628643D75297D69662875213D3D63297B6966282D313D3D3D642972657475726E20697D656C73657B696628683E63297B696628742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(942) := '417428732B75293D3D3D6A652972657475726E20692E736C69636528732B752B31293B696628323D3D3D752972657475726E20692E736C69636528732B75297D613E63262628652E63686172436F6465417428722B75293D3D3D6A653F643D753A323D3D';
wwv_flow_imp.g_varchar2_table(943) := '3D75262628643D3329292C2D313D3D3D64262628643D30297D6C6574206D3D22223B666F7228753D722B642B313B753C3D6F3B2B2B752975213D3D6F2626652E63686172436F64654174287529213D3D6A657C7C286D2B3D303D3D3D6D2E6C656E677468';
wwv_flow_imp.g_varchar2_table(944) := '3F222E2E223A225C5C2E2E22293B72657475726E20732B3D642C6D2E6C656E6774683E303F60247B6D7D247B692E736C69636528732C6C297D603A28692E63686172436F646541742873293D3D3D6A6526262B2B732C692E736C69636528732C6C29297D';
wwv_flow_imp.g_varchar2_table(945) := '2C746F4E616D65737061636564506174682865297B69662822737472696E6722213D747970656F6620657C7C303D3D3D652E6C656E6774682972657475726E20653B636F6E737420743D6E742E7265736F6C76652865293B696628742E6C656E6774683C';
wwv_flow_imp.g_varchar2_table(946) := '3D322972657475726E20653B696628742E63686172436F646541742830293D3D3D6A65297B696628742E63686172436F646541742831293D3D3D6A65297B636F6E737420653D742E63686172436F646541742832293B6966283633213D3D65262665213D';
wwv_flow_imp.g_varchar2_table(947) := '3D56652972657475726E605C5C5C5C3F5C5C554E435C5C247B742E736C6963652832297D607D7D656C7365206966285A6528742E63686172436F64654174283029292626742E63686172436F646541742831293D3D3D47652626742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(948) := '41742832293D3D3D6A652972657475726E605C5C5C5C3F5C5C247B747D603B72657475726E20657D2C6469726E616D652865297B586528652C227061746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E222E22';
wwv_flow_imp.g_varchar2_table(949) := '3B6C6574206E3D2D312C693D303B636F6E737420723D652E63686172436F646541742830293B696628313D3D3D742972657475726E2059652872293F653A222E223B6966285965287229297B6966286E3D693D312C596528652E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(950) := '28312929297B6C657420723D322C6F3D723B666F72283B723C74262621596528652E63686172436F64654174287229293B29722B2B3B696628723C74262672213D3D6F297B666F72286F3D723B723C742626596528652E63686172436F64654174287229';
wwv_flow_imp.g_varchar2_table(951) := '293B29722B2B3B696628723C74262672213D3D6F297B666F72286F3D723B723C74262621596528652E63686172436F64654174287229293B29722B2B3B696628723D3D3D742972657475726E20653B72213D3D6F2626286E3D693D722B31297D7D7D7D65';
wwv_flow_imp.g_varchar2_table(952) := '6C7365205A652872292626652E63686172436F646541742831293D3D3D47652626286E3D743E322626596528652E63686172436F64654174283229293F333A322C693D6E293B6C6574206F3D2D312C613D21303B666F72286C6574206E3D742D313B6E3E';
wwv_flow_imp.g_varchar2_table(953) := '3D693B2D2D6E29696628596528652E63686172436F64654174286E2929297B6966282161297B6F3D6E3B627265616B7D7D656C736520613D21313B6966282D313D3D3D6F297B6966282D313D3D3D6E2972657475726E222E223B6F3D6E7D72657475726E';
wwv_flow_imp.g_varchar2_table(954) := '20652E736C69636528302C6F297D2C626173656E616D6528652C74297B766F69642030213D3D742626586528742C2265787422292C586528652C227061746822293B6C6574206E2C693D302C723D2D312C6F3D21303B696628652E6C656E6774683E3D32';
wwv_flow_imp.g_varchar2_table(955) := '26265A6528652E63686172436F64654174283029292626652E63686172436F646541742831293D3D3D4765262628693D32292C766F69642030213D3D742626742E6C656E6774683E302626742E6C656E6774683C3D652E6C656E677468297B696628743D';
wwv_flow_imp.g_varchar2_table(956) := '3D3D652972657475726E22223B6C657420613D742E6C656E6774682D312C733D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D693B2D2D6E297B636F6E7374206C3D652E63686172436F64654174286E293B6966285965286C29297B69662821';
wwv_flow_imp.g_varchar2_table(957) := '6F297B693D6E2B313B627265616B7D7D656C73652D313D3D3D732626286F3D21312C733D6E2B31292C613E3D302626286C3D3D3D742E63686172436F646541742861293F2D313D3D2D2D61262628723D6E293A28613D2D312C723D7329297D7265747572';
wwv_flow_imp.g_varchar2_table(958) := '6E20693D3D3D723F723D733A2D313D3D3D72262628723D652E6C656E677468292C652E736C69636528692C72297D666F72286E3D652E6C656E6774682D313B6E3E3D693B2D2D6E29696628596528652E63686172436F64654174286E2929297B69662821';
wwv_flow_imp.g_varchar2_table(959) := '6F297B693D6E2B313B627265616B7D7D656C73652D313D3D3D722626286F3D21312C723D6E2B31293B72657475726E2D313D3D3D723F22223A652E736C69636528692C72297D2C6578746E616D652865297B586528652C227061746822293B6C65742074';
wwv_flow_imp.g_varchar2_table(960) := '3D302C6E3D2D312C693D302C723D2D312C6F3D21302C613D303B652E6C656E6774683E3D322626652E63686172436F646541742831293D3D3D476526265A6528652E63686172436F6465417428302929262628743D693D32293B666F72286C657420733D';
wwv_flow_imp.g_varchar2_table(961) := '652E6C656E6774682D313B733E3D743B2D2D73297B636F6E737420743D652E63686172436F646541742873293B6966285965287429297B696628216F297B693D732B313B627265616B7D7D656C73652D313D3D3D722626286F3D21312C723D732B31292C';
wwv_flow_imp.g_varchar2_table(962) := '743D3D3D56653F2D313D3D3D6E3F6E3D733A31213D3D61262628613D31293A2D31213D3D6E262628613D2D31297D72657475726E2D313D3D3D6E7C7C2D313D3D3D727C7C303D3D3D617C7C313D3D3D6126266E3D3D3D722D3126266E3D3D3D692B313F22';
wwv_flow_imp.g_varchar2_table(963) := '223A652E736C696365286E2C72297D2C666F726D61743A74742E62696E64286E756C6C2C225C5C22292C70617273652865297B586528652C227061746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A';
wwv_flow_imp.g_varchar2_table(964) := '22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E6C656E6774683B6C657420693D302C723D652E63686172436F646541742830293B696628313D3D3D6E2972657475726E2059652872';
wwv_flow_imp.g_varchar2_table(965) := '293F28742E726F6F743D742E6469723D652C74293A28742E626173653D742E6E616D653D652C74293B6966285965287229297B696628693D312C596528652E63686172436F6465417428312929297B6C657420743D322C723D743B666F72283B743C6E26';
wwv_flow_imp.g_varchar2_table(966) := '2621596528652E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D72297B666F7228723D743B743C6E2626596528652E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D72297B666F722872';
wwv_flow_imp.g_varchar2_table(967) := '3D743B743C6E262621596528652E63686172436F64654174287429293B29742B2B3B743D3D3D6E3F693D743A74213D3D72262628693D742B31297D7D7D7D656C7365206966285A652872292626652E63686172436F646541742831293D3D3D4765297B69';
wwv_flow_imp.g_varchar2_table(968) := '66286E3C3D322972657475726E20742E726F6F743D742E6469723D652C743B696628693D322C596528652E63686172436F6465417428322929297B696628333D3D3D6E2972657475726E20742E726F6F743D742E6469723D652C743B693D337D7D693E30';
wwv_flow_imp.g_varchar2_table(969) := '262628742E726F6F743D652E736C69636528302C6929293B6C6574206F3D2D312C613D692C733D2D312C6C3D21302C683D652E6C656E6774682D312C633D303B666F72283B683E3D693B2D2D6829696628723D652E63686172436F646541742868292C59';
wwv_flow_imp.g_varchar2_table(970) := '65287229297B696628216C297B613D682B313B627265616B7D7D656C73652D313D3D3D732626286C3D21312C733D682B31292C723D3D3D56653F2D313D3D3D6F3F6F3D683A31213D3D63262628633D31293A2D31213D3D6F262628633D2D31293B726574';
wwv_flow_imp.g_varchar2_table(971) := '75726E2D31213D3D732626282D313D3D3D6F7C7C303D3D3D637C7C313D3D3D6326266F3D3D3D732D3126266F3D3D3D612B313F742E626173653D742E6E616D653D652E736C69636528612C73293A28742E6E616D653D652E736C69636528612C6F292C74';
wwv_flow_imp.g_varchar2_table(972) := '2E626173653D652E736C69636528612C73292C742E6578743D652E736C696365286F2C732929292C742E6469723D613E30262661213D3D693F652E736C69636528302C612D31293A742E726F6F742C747D2C7365703A225C5C222C64656C696D69746572';
wwv_flow_imp.g_varchar2_table(973) := '3A223B222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D2C69743D2828293D3E7B6966284A65297B636F6E737420653D2F5C5C2F673B72657475726E28293D3E7B636F6E737420743D716528292E7265706C61636528652C222F22293B726574';
wwv_flow_imp.g_varchar2_table(974) := '75726E20742E736C69636528742E696E6465784F6628222F2229297D7D72657475726E28293D3E716528297D2928292C72743D7B7265736F6C7665282E2E2E65297B6C657420743D22222C6E3D21313B666F72286C657420693D652E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(975) := '3B693E3D2D312626216E3B692D2D297B636F6E737420723D693E3D303F655B695D3A697428293B586528722C227061746822292C30213D3D722E6C656E677468262628743D60247B727D2F247B747D602C6E3D722E63686172436F646541742830293D3D';
wwv_flow_imp.g_varchar2_table(976) := '3D4B65297D72657475726E20743D657428742C216E2C222F222C5165292C6E3F602F247B747D603A742E6C656E6774683E303F743A222E227D2C6E6F726D616C697A652865297B696628586528652C227061746822292C303D3D3D652E6C656E67746829';
wwv_flow_imp.g_varchar2_table(977) := '72657475726E222E223B636F6E737420743D652E63686172436F646541742830293D3D3D4B652C6E3D652E63686172436F6465417428652E6C656E6774682D31293D3D3D4B653B72657475726E20303D3D3D28653D657428652C21742C222F222C516529';
wwv_flow_imp.g_varchar2_table(978) := '292E6C656E6774683F743F222F223A6E3F222E2F223A222E223A286E262628652B3D222F22292C743F602F247B657D603A65297D2C69734162736F6C7574653A653D3E28586528652C227061746822292C652E6C656E6774683E302626652E6368617243';
wwv_flow_imp.g_varchar2_table(979) := '6F646541742830293D3D3D4B65292C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420743B666F72286C6574206E3D303B6E3C652E6C656E6774683B2B2B6E297B636F6E737420693D655B6E5D3B58';
wwv_flow_imp.g_varchar2_table(980) := '6528692C227061746822292C692E6C656E6774683E30262628766F696420303D3D3D743F743D693A742B3D602F247B697D60297D72657475726E20766F696420303D3D3D743F222E223A72742E6E6F726D616C697A652874297D2C72656C617469766528';
wwv_flow_imp.g_varchar2_table(981) := '652C74297B696628586528652C2266726F6D22292C586528742C22746F22292C653D3D3D742972657475726E22223B69662828653D72742E7265736F6C7665286529293D3D3D28743D72742E7265736F6C7665287429292972657475726E22223B636F6E';
wwv_flow_imp.g_varchar2_table(982) := '7374206E3D652E6C656E6774682C693D6E2D312C723D742E6C656E6774682D312C6F3D693C723F693A723B6C657420613D2D312C733D303B666F72283B733C6F3B732B2B297B636F6E7374206E3D652E63686172436F6465417428312B73293B6966286E';
wwv_flow_imp.g_varchar2_table(983) := '213D3D742E63686172436F6465417428312B732929627265616B3B6E3D3D3D4B65262628613D73297D696628733D3D3D6F29696628723E6F297B696628742E63686172436F6465417428312B73293D3D3D4B652972657475726E20742E736C6963652831';
wwv_flow_imp.g_varchar2_table(984) := '2B732B31293B696628303D3D3D732972657475726E20742E736C69636528312B73297D656C736520693E6F262628652E63686172436F6465417428312B73293D3D3D4B653F613D733A303D3D3D73262628613D3029293B6C6574206C3D22223B666F7228';
wwv_flow_imp.g_varchar2_table(985) := '733D312B612B313B733C3D6E3B2B2B732973213D3D6E2626652E63686172436F64654174287329213D3D4B657C7C286C2B3D303D3D3D6C2E6C656E6774683F222E2E223A222F2E2E22293B72657475726E60247B6C7D247B742E736C69636528312B6129';
wwv_flow_imp.g_varchar2_table(986) := '7D607D2C746F4E616D65737061636564506174683A653D3E652C6469726E616D652865297B696628586528652C227061746822292C303D3D3D652E6C656E6774682972657475726E222E223B636F6E737420743D652E63686172436F646541742830293D';
wwv_flow_imp.g_varchar2_table(987) := '3D3D4B653B6C6574206E3D2D312C693D21303B666F72286C657420743D652E6C656E6774682D313B743E3D313B2D2D7429696628652E63686172436F646541742874293D3D3D4B65297B6966282169297B6E3D743B627265616B7D7D656C736520693D21';
wwv_flow_imp.g_varchar2_table(988) := '313B72657475726E2D313D3D3D6E3F743F222F223A222E223A742626313D3D3D6E3F222F2F223A652E736C69636528302C6E297D2C626173656E616D6528652C74297B766F69642030213D3D742626586528742C2265787422292C586528652C22706174';
wwv_flow_imp.g_varchar2_table(989) := '6822293B6C6574206E2C693D302C723D2D312C6F3D21303B696628766F69642030213D3D742626742E6C656E6774683E302626742E6C656E6774683C3D652E6C656E677468297B696628743D3D3D652972657475726E22223B6C657420613D742E6C656E';
wwv_flow_imp.g_varchar2_table(990) := '6774682D312C733D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E297B636F6E7374206C3D652E63686172436F64654174286E293B6966286C3D3D3D4B65297B696628216F297B693D6E2B313B627265616B7D7D656C73652D313D';
wwv_flow_imp.g_varchar2_table(991) := '3D3D732626286F3D21312C733D6E2B31292C613E3D302626286C3D3D3D742E63686172436F646541742861293F2D313D3D2D2D61262628723D6E293A28613D2D312C723D7329297D72657475726E20693D3D3D723F723D733A2D313D3D3D72262628723D';
wwv_flow_imp.g_varchar2_table(992) := '652E6C656E677468292C652E736C69636528692C72297D666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E29696628652E63686172436F64654174286E293D3D3D4B65297B696628216F297B693D6E2B313B627265616B7D7D656C73652D31';
wwv_flow_imp.g_varchar2_table(993) := '3D3D3D722626286F3D21312C723D6E2B31293B72657475726E2D313D3D3D723F22223A652E736C69636528692C72297D2C6578746E616D652865297B586528652C227061746822293B6C657420743D2D312C6E3D302C693D2D312C723D21302C6F3D303B';
wwv_flow_imp.g_varchar2_table(994) := '666F72286C657420613D652E6C656E6774682D313B613E3D303B2D2D61297B636F6E737420733D652E63686172436F646541742861293B69662873213D3D4B65292D313D3D3D69262628723D21312C693D612B31292C733D3D3D56653F2D313D3D3D743F';
wwv_flow_imp.g_varchar2_table(995) := '743D613A31213D3D6F2626286F3D31293A2D31213D3D742626286F3D2D31293B656C7365206966282172297B6E3D612B313B627265616B7D7D72657475726E2D313D3D3D747C7C2D313D3D3D697C7C303D3D3D6F7C7C313D3D3D6F2626743D3D3D692D31';
wwv_flow_imp.g_varchar2_table(996) := '2626743D3D3D6E2B313F22223A652E736C69636528742C69297D2C666F726D61743A74742E62696E64286E756C6C2C222F22292C70617273652865297B586528652C227061746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C6261';
wwv_flow_imp.g_varchar2_table(997) := '73653A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E63686172436F646541742830293D3D3D4B653B6C657420693B6E3F28742E726F6F743D222F222C693D3129';
wwv_flow_imp.g_varchar2_table(998) := '3A693D303B6C657420723D2D312C6F3D302C613D2D312C733D21302C6C3D652E6C656E6774682D312C683D303B666F72283B6C3E3D693B2D2D6C297B636F6E737420743D652E63686172436F64654174286C293B69662874213D3D4B65292D313D3D3D61';
wwv_flow_imp.g_varchar2_table(999) := '262628733D21312C613D6C2B31292C743D3D3D56653F2D313D3D3D723F723D6C3A31213D3D68262628683D31293A2D31213D3D72262628683D2D31293B656C7365206966282173297B6F3D6C2B313B627265616B7D7D6966282D31213D3D61297B636F6E';
wwv_flow_imp.g_varchar2_table(1000) := '737420693D303D3D3D6F26266E3F313A6F3B2D313D3D3D727C7C303D3D3D687C7C313D3D3D682626723D3D3D612D312626723D3D3D6F2B313F742E626173653D742E6E616D653D652E736C69636528692C61293A28742E6E616D653D652E736C69636528';
wwv_flow_imp.g_varchar2_table(1001) := '692C72292C742E626173653D652E736C69636528692C61292C742E6578743D652E736C69636528722C6129297D72657475726E206F3E303F742E6469723D652E736C69636528302C6F2D31293A6E262628742E6469723D222F22292C747D2C7365703A22';
wwv_flow_imp.g_varchar2_table(1002) := '2F222C64656C696D697465723A223A222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D3B72742E77696E33323D6E742E77696E33323D6E742C72742E706F7369783D6E742E706F7369783D72742C4A653F6E742E6E6F726D616C697A653A7274';
wwv_flow_imp.g_varchar2_table(1003) := '2E6E6F726D616C697A652C4A653F6E742E7265736F6C76653A72742E7265736F6C76652C4A653F6E742E72656C61746976653A72742E72656C61746976652C4A653F6E742E6469726E616D653A72742E6469726E616D652C4A653F6E742E626173656E61';
wwv_flow_imp.g_varchar2_table(1004) := '6D653A72742E626173656E616D652C4A653F6E742E6578746E616D653A72742E6578746E616D652C4A653F6E742E7365703A72742E7365703B636F6E7374206F743D2F5E5C775B5C775C642B2E2D5D2A242F2C61743D2F5E5C2F2F2C73743D2F5E5C2F5C';
wwv_flow_imp.g_varchar2_table(1005) := '2F2F2C6C743D22222C68743D222F222C63743D2F5E28285B5E3A2F3F235D2B3F293A293F285C2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A29293F2823282E2A29293F2F3B636C6173732064747B737461746963206973';
wwv_flow_imp.g_varchar2_table(1006) := '5572692865297B72657475726E206520696E7374616E63656F662064747C7C212165262622737472696E67223D3D747970656F6620652E617574686F72697479262622737472696E67223D3D747970656F6620652E667261676D656E7426262273747269';
wwv_flow_imp.g_varchar2_table(1007) := '6E67223D3D747970656F6620652E70617468262622737472696E67223D3D747970656F6620652E7175657279262622737472696E67223D3D747970656F6620652E736368656D65262622737472696E67223D3D747970656F6620652E6673506174682626';
wwv_flow_imp.g_varchar2_table(1008) := '2266756E6374696F6E223D3D747970656F6620652E7769746826262266756E6374696F6E223D3D747970656F6620652E746F537472696E677D636F6E7374727563746F7228652C742C6E2C692C722C6F3D2131297B226F626A656374223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1009) := '6620653F28746869732E736368656D653D652E736368656D657C7C6C742C746869732E617574686F726974793D652E617574686F726974797C7C6C742C746869732E706174683D652E706174687C7C6C742C746869732E71756572793D652E7175657279';
wwv_flow_imp.g_varchar2_table(1010) := '7C7C6C742C746869732E667261676D656E743D652E667261676D656E747C7C6C74293A28746869732E736368656D653D66756E6374696F6E28652C74297B72657475726E20657C7C743F653A2266696C65227D28652C6F292C746869732E617574686F72';
wwv_flow_imp.g_varchar2_table(1011) := '6974793D747C7C6C742C746869732E706174683D66756E6374696F6E28652C74297B7377697463682865297B63617365226874747073223A636173652268747470223A636173652266696C65223A743F745B305D213D3D6874262628743D68742B74293A';
wwv_flow_imp.g_varchar2_table(1012) := '743D68747D72657475726E20747D28746869732E736368656D652C6E7C7C6C74292C746869732E71756572793D697C7C6C742C746869732E667261676D656E743D727C7C6C742C66756E6374696F6E28652C74297B69662821652E736368656D65262674';
wwv_flow_imp.g_varchar2_table(1013) := '297468726F77206E6577204572726F7228605B5572694572726F725D3A20536368656D65206973206D697373696E673A207B736368656D653A2022222C20617574686F726974793A2022247B652E617574686F726974797D222C20706174683A2022247B';
wwv_flow_imp.g_varchar2_table(1014) := '652E706174687D222C2071756572793A2022247B652E71756572797D222C20667261676D656E743A2022247B652E667261676D656E747D227D60293B696628652E736368656D652626216F742E7465737428652E736368656D6529297468726F77206E65';
wwv_flow_imp.g_varchar2_table(1015) := '77204572726F7228225B5572694572726F725D3A20536368656D6520636F6E7461696E7320696C6C6567616C20636861726163746572732E22293B696628652E7061746829696628652E617574686F72697479297B6966282161742E7465737428652E70';
wwv_flow_imp.g_varchar2_table(1016) := '61746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920636F6E7461696E7320616E20617574686F7269747920636F6D706F6E656E742C207468656E20746865207061746820636F6D706F6E656E7420';
wwv_flow_imp.g_varchar2_table(1017) := '6D7573742065697468657220626520656D707479206F7220626567696E2077697468206120736C6173682028222F22292063686172616374657227297D656C73652069662873742E7465737428652E7061746829297468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(1018) := '28275B5572694572726F725D3A20496620612055524920646F6573206E6F7420636F6E7461696E20616E20617574686F7269747920636F6D706F6E656E742C207468656E2074686520706174682063616E6E6F7420626567696E20776974682074776F20';
wwv_flow_imp.g_varchar2_table(1019) := '736C61736820636861726163746572732028222F2F222927297D28746869732C6F29297D6765742066735061746828297B72657475726E20627428746869732C2131297D776974682865297B69662821652972657475726E20746869733B6C65747B7363';
wwv_flow_imp.g_varchar2_table(1020) := '68656D653A742C617574686F726974793A6E2C706174683A692C71756572793A722C667261676D656E743A6F7D3D653B72657475726E20766F696420303D3D3D743F743D746869732E736368656D653A6E756C6C3D3D3D74262628743D6C74292C766F69';
wwv_flow_imp.g_varchar2_table(1021) := '6420303D3D3D6E3F6E3D746869732E617574686F726974793A6E756C6C3D3D3D6E2626286E3D6C74292C766F696420303D3D3D693F693D746869732E706174683A6E756C6C3D3D3D69262628693D6C74292C766F696420303D3D3D723F723D746869732E';
wwv_flow_imp.g_varchar2_table(1022) := '71756572793A6E756C6C3D3D3D72262628723D6C74292C766F696420303D3D3D6F3F6F3D746869732E667261676D656E743A6E756C6C3D3D3D6F2626286F3D6C74292C743D3D3D746869732E736368656D6526266E3D3D3D746869732E617574686F7269';
wwv_flow_imp.g_varchar2_table(1023) := '74792626693D3D3D746869732E706174682626723D3D3D746869732E717565727926266F3D3D3D746869732E667261676D656E743F746869733A6E6577206D7428742C6E2C692C722C6F297D73746174696320706172736528652C743D2131297B636F6E';
wwv_flow_imp.g_varchar2_table(1024) := '7374206E3D63742E657865632865293B72657475726E206E3F6E6577206D74286E5B325D7C7C6C742C7974286E5B345D7C7C6C74292C7974286E5B355D7C7C6C74292C7974286E5B375D7C7C6C74292C7974286E5B395D7C7C6C74292C74293A6E657720';
wwv_flow_imp.g_varchar2_table(1025) := '6D74286C742C6C742C6C742C6C742C6C74297D7374617469632066696C652865297B6C657420743D6C743B6966286565262628653D652E7265706C616365282F5C5C2F672C687429292C655B305D3D3D3D68742626655B315D3D3D3D6874297B636F6E73';
wwv_flow_imp.g_varchar2_table(1026) := '74206E3D652E696E6465784F662868742C32293B2D313D3D3D6E3F28743D652E737562737472696E672832292C653D6874293A28743D652E737562737472696E6728322C6E292C653D652E737562737472696E67286E297C7C6874297D72657475726E20';
wwv_flow_imp.g_varchar2_table(1027) := '6E6577206D74282266696C65222C742C652C6C742C6C74297D7374617469632066726F6D28652C74297B72657475726E206E6577206D7428652E736368656D652C652E617574686F726974792C652E706174682C652E71756572792C652E667261676D65';
wwv_flow_imp.g_varchar2_table(1028) := '6E742C74297D737461746963206A6F696E5061746828652C2E2E2E74297B69662821652E70617468297468726F77206E6577204572726F7228225B5572694572726F725D3A2063616E6E6F742063616C6C206A6F696E50617468206F6E20555249207769';
wwv_flow_imp.g_varchar2_table(1029) := '74686F7574207061746822293B6C6574206E3B72657475726E206E3D656526262266696C65223D3D3D652E736368656D653F64742E66696C65286E742E6A6F696E28627428652C2130292C2E2E2E7429292E706174683A72742E6A6F696E28652E706174';
wwv_flow_imp.g_varchar2_table(1030) := '682C2E2E2E74292C652E77697468287B706174683A6E7D297D746F537472696E6728653D2131297B72657475726E205F7428746869732C65297D746F4A534F4E28297B72657475726E20746869737D737461746963207265766976652865297B76617220';
wwv_flow_imp.g_varchar2_table(1031) := '742C6E3B69662865297B6966286520696E7374616E63656F662064742972657475726E20653B7B636F6E737420693D6E6577206D742865293B72657475726E20692E5F666F726D61747465643D6E756C6C213D3D28743D652E65787465726E616C292626';
wwv_flow_imp.g_varchar2_table(1032) := '766F69642030213D3D743F743A6E756C6C2C692E5F6673506174683D652E5F7365703D3D3D757426266E756C6C213D3D286E3D652E667350617468292626766F69642030213D3D6E3F6E3A6E756C6C2C697D7D72657475726E20657D7D636F6E73742075';
wwv_flow_imp.g_varchar2_table(1033) := '743D65653F313A766F696420303B636C617373206D7420657874656E64732064747B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F666F726D61747465643D6E756C6C2C746869732E5F6673506174';
wwv_flow_imp.g_varchar2_table(1034) := '683D6E756C6C7D6765742066735061746828297B72657475726E20746869732E5F6673506174687C7C28746869732E5F6673506174683D627428746869732C213129292C746869732E5F6673506174687D746F537472696E6728653D2131297B72657475';
wwv_flow_imp.g_varchar2_table(1035) := '726E20653F5F7428746869732C2130293A28746869732E5F666F726D61747465647C7C28746869732E5F666F726D61747465643D5F7428746869732C213129292C746869732E5F666F726D6174746564297D746F4A534F4E28297B636F6E737420653D7B';
wwv_flow_imp.g_varchar2_table(1036) := '246D69643A317D3B72657475726E20746869732E5F667350617468262628652E6673506174683D746869732E5F6673506174682C652E5F7365703D7574292C746869732E5F666F726D6174746564262628652E65787465726E616C3D746869732E5F666F';
wwv_flow_imp.g_varchar2_table(1037) := '726D6174746564292C746869732E70617468262628652E706174683D746869732E70617468292C746869732E736368656D65262628652E736368656D653D746869732E736368656D65292C746869732E617574686F72697479262628652E617574686F72';
wwv_flow_imp.g_varchar2_table(1038) := '6974793D746869732E617574686F72697479292C746869732E7175657279262628652E71756572793D746869732E7175657279292C746869732E667261676D656E74262628652E667261676D656E743D746869732E667261676D656E74292C657D7D636F';
wwv_flow_imp.g_varchar2_table(1039) := '6E73742070743D7B35383A22253341222C34373A22253246222C36333A22253346222C33353A22253233222C39313A22253542222C39333A22253544222C36343A22253430222C33333A22253231222C33363A22253234222C33383A22253236222C3339';
wwv_flow_imp.g_varchar2_table(1040) := '3A22253237222C34303A22253238222C34313A22253239222C34323A22253241222C34333A22253242222C34343A22253243222C35393A22253342222C36313A22253344222C33323A22253230227D3B66756E6374696F6E20667428652C742C6E297B6C';
wwv_flow_imp.g_varchar2_table(1041) := '657420692C723D2D313B666F72286C6574206F3D303B6F3C652E6C656E6774683B6F2B2B297B636F6E737420613D652E63686172436F64654174286F293B696628613E3D39372626613C3D3132327C7C613E3D36352626613C3D39307C7C613E3D343826';
wwv_flow_imp.g_varchar2_table(1042) := '26613C3D35377C7C34353D3D3D617C7C34363D3D3D617C7C39353D3D3D617C7C3132363D3D3D617C7C74262634373D3D3D617C7C6E262639313D3D3D617C7C6E262639333D3D3D617C7C6E262635383D3D3D61292D31213D3D72262628692B3D656E636F';
wwv_flow_imp.g_varchar2_table(1043) := '6465555249436F6D706F6E656E7428652E737562737472696E6728722C6F29292C723D2D31292C766F69642030213D3D69262628692B3D652E636861724174286F29293B656C73657B766F696420303D3D3D69262628693D652E73756273747228302C6F';
wwv_flow_imp.g_varchar2_table(1044) := '29293B636F6E737420743D70745B615D3B766F69642030213D3D743F282D31213D3D72262628692B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728722C6F29292C723D2D31292C692B3D74293A2D313D3D3D7226262872';
wwv_flow_imp.g_varchar2_table(1045) := '3D6F297D7D72657475726E2D31213D3D72262628692B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728722929292C766F69642030213D3D693F693A657D66756E6374696F6E2067742865297B6C657420743B666F72286C';
wwv_flow_imp.g_varchar2_table(1046) := '6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D652E63686172436F64654174286E293B33353D3D3D697C7C36333D3D3D693F28766F696420303D3D3D74262628743D652E73756273747228302C6E29292C742B3D70745B69';
wwv_flow_imp.g_varchar2_table(1047) := '5D293A766F69642030213D3D74262628742B3D655B6E5D297D72657475726E20766F69642030213D3D743F743A657D66756E6374696F6E20627428652C74297B6C6574206E3B72657475726E206E3D652E617574686F726974792626652E706174682E6C';
wwv_flow_imp.g_varchar2_table(1048) := '656E6774683E3126262266696C65223D3D3D652E736368656D653F602F2F247B652E617574686F726974797D247B652E706174687D603A34373D3D3D652E706174682E63686172436F64654174283029262628652E706174682E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(1049) := '2831293E3D36352626652E706174682E63686172436F646541742831293C3D39307C7C652E706174682E63686172436F646541742831293E3D39372626652E706174682E63686172436F646541742831293C3D31323229262635383D3D3D652E70617468';
wwv_flow_imp.g_varchar2_table(1050) := '2E63686172436F646541742832293F743F652E706174682E7375627374722831293A652E706174685B315D2E746F4C6F7765724361736528292B652E706174682E7375627374722832293A652E706174682C65652626286E3D6E2E7265706C616365282F';
wwv_flow_imp.g_varchar2_table(1051) := '5C2F2F672C225C5C2229292C6E7D66756E6374696F6E205F7428652C74297B636F6E7374206E3D743F67743A66743B6C657420693D22222C7B736368656D653A722C617574686F726974793A6F2C706174683A612C71756572793A732C667261676D656E';
wwv_flow_imp.g_varchar2_table(1052) := '743A6C7D3D653B69662872262628692B3D722C692B3D223A22292C286F7C7C2266696C65223D3D3D7229262628692B3D68742C692B3D6874292C6F297B6C657420653D6F2E696E6465784F6628224022293B6966282D31213D3D65297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(1053) := '3D6F2E73756273747228302C65293B6F3D6F2E73756273747228652B31292C653D742E6C617374496E6465784F6628223A22292C2D313D3D3D653F692B3D6E28742C21312C2131293A28692B3D6E28742E73756273747228302C65292C21312C2131292C';
wwv_flow_imp.g_varchar2_table(1054) := '692B3D223A222C692B3D6E28742E73756273747228652B31292C21312C213029292C692B3D2240227D6F3D6F2E746F4C6F7765724361736528292C653D6F2E6C617374496E6465784F6628223A22292C2D313D3D3D653F692B3D6E286F2C21312C213029';
wwv_flow_imp.g_varchar2_table(1055) := '3A28692B3D6E286F2E73756273747228302C65292C21312C2130292C692B3D6F2E737562737472286529297D69662861297B696628612E6C656E6774683E3D33262634373D3D3D612E63686172436F64654174283029262635383D3D3D612E6368617243';
wwv_flow_imp.g_varchar2_table(1056) := '6F64654174283229297B636F6E737420653D612E63686172436F646541742831293B653E3D36352626653C3D3930262628613D602F247B537472696E672E66726F6D43686172436F646528652B3332297D3A247B612E7375627374722833297D60297D65';
wwv_flow_imp.g_varchar2_table(1057) := '6C736520696628612E6C656E6774683E3D32262635383D3D3D612E63686172436F64654174283129297B636F6E737420653D612E63686172436F646541742830293B653E3D36352626653C3D3930262628613D60247B537472696E672E66726F6D436861';
wwv_flow_imp.g_varchar2_table(1058) := '72436F646528652B3332297D3A247B612E7375627374722832297D60297D692B3D6E28612C21302C2131297D72657475726E2073262628692B3D223F222C692B3D6E28732C21312C213129292C6C262628692B3D2223222C692B3D743F6C3A6674286C2C';
wwv_flow_imp.g_varchar2_table(1059) := '21312C213129292C697D66756E6374696F6E2076742865297B7472797B72657475726E206465636F6465555249436F6D706F6E656E742865297D63617463682874297B72657475726E20652E6C656E6774683E333F652E73756273747228302C33292B76';
wwv_flow_imp.g_varchar2_table(1060) := '7428652E737562737472283329293A657D7D636F6E73742077743D2F28255B302D39412D5A612D7A5D5B302D39412D5A612D7A5D292B2F673B66756E6374696F6E2079742865297B72657475726E20652E6D61746368287774293F652E7265706C616365';
wwv_flow_imp.g_varchar2_table(1061) := '2877742C28653D3E767428652929293A657D636C6173732054747B636F6E7374727563746F7228652C74297B746869732E6C696E654E756D6265723D652C746869732E636F6C756D6E3D747D7769746828653D746869732E6C696E654E756D6265722C74';
wwv_flow_imp.g_varchar2_table(1062) := '3D746869732E636F6C756D6E297B72657475726E20653D3D3D746869732E6C696E654E756D6265722626743D3D3D746869732E636F6C756D6E3F746869733A6E657720547428652C74297D64656C746128653D302C743D30297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(1063) := '732E7769746828746869732E6C696E654E756D6265722B652C746869732E636F6C756D6E2B74297D657175616C732865297B72657475726E2054742E657175616C7328746869732C65297D73746174696320657175616C7328652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(1064) := '2165262621747C7C21216526262121742626652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265722626652E636F6C756D6E3D3D3D742E636F6C756D6E7D69734265666F72652865297B72657475726E2054742E69734265666F7265287468';
wwv_flow_imp.g_varchar2_table(1065) := '69732C65297D7374617469632069734265666F726528652C74297B72657475726E20652E6C696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C';
wwv_flow_imp.g_varchar2_table(1066) := '742E636F6C756D6E7D69734265666F72654F72457175616C2865297B72657475726E2054742E69734265666F72654F72457175616C28746869732C65297D7374617469632069734265666F72654F72457175616C28652C74297B72657475726E20652E6C';
wwv_flow_imp.g_varchar2_table(1067) := '696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C3D742E636F6C756D6E7D73746174696320636F6D7061726528652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(1068) := '3D307C652E6C696E654E756D6265722C693D307C742E6C696E654E756D6265723B72657475726E206E3D3D3D693F28307C652E636F6C756D6E292D28307C742E636F6C756D6E293A6E2D697D636C6F6E6528297B72657475726E206E6577205474287468';
wwv_flow_imp.g_varchar2_table(1069) := '69732E6C696E654E756D6265722C746869732E636F6C756D6E297D746F537472696E6728297B72657475726E2228222B746869732E6C696E654E756D6265722B222C222B746869732E636F6C756D6E2B2229227D737461746963206C6966742865297B72';
wwv_flow_imp.g_varchar2_table(1070) := '657475726E206E657720547428652E6C696E654E756D6265722C652E636F6C756D6E297D73746174696320697349506F736974696F6E2865297B72657475726E20652626226E756D626572223D3D747970656F6620652E6C696E654E756D626572262622';
wwv_flow_imp.g_varchar2_table(1071) := '6E756D626572223D3D747970656F6620652E636F6C756D6E7D746F4A534F4E28297B72657475726E7B6C696E654E756D6265723A746869732E6C696E654E756D6265722C636F6C756D6E3A746869732E636F6C756D6E7D7D7D636C617373206B747B636F';
wwv_flow_imp.g_varchar2_table(1072) := '6E7374727563746F7228652C742C6E2C69297B653E6E7C7C653D3D3D6E2626743E693F28746869732E73746172744C696E654E756D6265723D6E2C746869732E7374617274436F6C756D6E3D692C746869732E656E644C696E654E756D6265723D652C74';
wwv_flow_imp.g_varchar2_table(1073) := '6869732E656E64436F6C756D6E3D74293A28746869732E73746172744C696E654E756D6265723D652C746869732E7374617274436F6C756D6E3D742C746869732E656E644C696E654E756D6265723D6E2C746869732E656E64436F6C756D6E3D69297D69';
wwv_flow_imp.g_varchar2_table(1074) := '73456D70747928297B72657475726E206B742E6973456D7074792874686973297D737461746963206973456D7074792865297B72657475726E20652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626652E737461';
wwv_flow_imp.g_varchar2_table(1075) := '7274436F6C756D6E3D3D3D652E656E64436F6C756D6E7D636F6E7461696E73506F736974696F6E2865297B72657475726E206B742E636F6E7461696E73506F736974696F6E28746869732C65297D73746174696320636F6E7461696E73506F736974696F';
wwv_flow_imp.g_varchar2_table(1076) := '6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E654E756D6265723D3D3D652E73746172744C';
wwv_flow_imp.g_varchar2_table(1077) := '696E654E756D6265722626742E636F6C756D6E3C652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E636F6C756D6E3E652E656E64436F6C756D6E297D7374617469632073747269';
wwv_flow_imp.g_varchar2_table(1078) := '6374436F6E7461696E73506F736974696F6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E65';
wwv_flow_imp.g_varchar2_table(1079) := '4E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E636F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E636F6C756D6E3E3D652E656E64';
wwv_flow_imp.g_varchar2_table(1080) := '436F6C756D6E297D636F6E7461696E7352616E67652865297B72657475726E206B742E636F6E7461696E7352616E676528746869732C65297D73746174696320636F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C69';
wwv_flow_imp.g_varchar2_table(1081) := '6E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E';
wwv_flow_imp.g_varchar2_table(1082) := '656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C652E7374617274436F6C756D6E7C7C74';
wwv_flow_imp.g_varchar2_table(1083) := '2E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E656E64436F6C756D6E3E652E656E64436F6C756D6E297D737472696374436F6E7461696E7352616E67652865297B72657475726E206B742E737472696374436F';
wwv_flow_imp.g_varchar2_table(1084) := '6E7461696E7352616E676528746869732C65297D73746174696320737472696374436F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E65';
wwv_flow_imp.g_varchar2_table(1085) := '6E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C';
wwv_flow_imp.g_varchar2_table(1086) := '742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1087) := '65722626742E656E64436F6C756D6E3E3D652E656E64436F6C756D6E297D706C757352616E67652865297B72657475726E206B742E706C757352616E676528746869732C65297D73746174696320706C757352616E676528652C74297B6C6574206E2C69';
wwv_flow_imp.g_varchar2_table(1088) := '2C722C6F3B72657475726E20742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C693D742E7374617274436F6C756D6E293A742E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(1089) := '6265723D3D3D652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C693D4D6174682E6D696E28742E7374617274436F6C756D6E2C652E7374617274436F6C756D6E29293A286E3D652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(1090) := '4E756D6265722C693D652E7374617274436F6C756D6E292C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265723F28723D742E656E644C696E654E756D6265722C6F3D742E656E64436F6C756D6E293A742E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(1091) := '756D6265723D3D3D652E656E644C696E654E756D6265723F28723D742E656E644C696E654E756D6265722C6F3D4D6174682E6D617828742E656E64436F6C756D6E2C652E656E64436F6C756D6E29293A28723D652E656E644C696E654E756D6265722C6F';
wwv_flow_imp.g_varchar2_table(1092) := '3D652E656E64436F6C756D6E292C6E6577206B74286E2C692C722C6F297D696E7465727365637452616E6765732865297B72657475726E206B742E696E7465727365637452616E67657328746869732C65297D73746174696320696E7465727365637452';
wwv_flow_imp.g_varchar2_table(1093) := '616E67657328652C74297B6C6574206E3D652E73746172744C696E654E756D6265722C693D652E7374617274436F6C756D6E2C723D652E656E644C696E654E756D6265722C6F3D652E656E64436F6C756D6E3B636F6E737420613D742E73746172744C69';
wwv_flow_imp.g_varchar2_table(1094) := '6E654E756D6265722C733D742E7374617274436F6C756D6E2C6C3D742E656E644C696E654E756D6265722C683D742E656E64436F6C756D6E3B72657475726E206E3C613F286E3D612C693D73293A6E3D3D3D61262628693D4D6174682E6D617828692C73';
wwv_flow_imp.g_varchar2_table(1095) := '29292C723E6C3F28723D6C2C6F3D68293A723D3D3D6C2626286F3D4D6174682E6D696E286F2C6829292C6E3E727C7C6E3D3D3D722626693E6F3F6E756C6C3A6E6577206B74286E2C692C722C6F297D657175616C7352616E67652865297B72657475726E';
wwv_flow_imp.g_varchar2_table(1096) := '206B742E657175616C7352616E676528746869732C65297D73746174696320657175616C7352616E676528652C74297B72657475726E2165262621747C7C21216526262121742626652E73746172744C696E654E756D6265723D3D3D742E73746172744C';
wwv_flow_imp.g_varchar2_table(1097) := '696E654E756D6265722626652E7374617274436F6C756D6E3D3D3D742E7374617274436F6C756D6E2626652E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265722626652E656E64436F6C756D6E3D3D3D742E656E64436F6C75';
wwv_flow_imp.g_varchar2_table(1098) := '6D6E7D676574456E64506F736974696F6E28297B72657475726E206B742E676574456E64506F736974696F6E2874686973297D73746174696320676574456E64506F736974696F6E2865297B72657475726E206E657720547428652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(1099) := '756D6265722C652E656E64436F6C756D6E297D6765745374617274506F736974696F6E28297B72657475726E206B742E6765745374617274506F736974696F6E2874686973297D737461746963206765745374617274506F736974696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(1100) := '7475726E206E657720547428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D746F537472696E6728297B72657475726E225B222B746869732E73746172744C696E654E756D6265722B222C222B746869732E73746172';
wwv_flow_imp.g_varchar2_table(1101) := '74436F6C756D6E2B22202D3E20222B746869732E656E644C696E654E756D6265722B222C222B746869732E656E64436F6C756D6E2B225D227D736574456E64506F736974696F6E28652C74297B72657475726E206E6577206B7428746869732E73746172';
wwv_flow_imp.g_varchar2_table(1102) := '744C696E654E756D6265722C746869732E7374617274436F6C756D6E2C652C74297D7365745374617274506F736974696F6E28652C74297B72657475726E206E6577206B7428652C742C746869732E656E644C696E654E756D6265722C746869732E656E';
wwv_flow_imp.g_varchar2_table(1103) := '64436F6C756D6E297D636F6C6C61707365546F537461727428297B72657475726E206B742E636F6C6C61707365546F53746172742874686973297D73746174696320636F6C6C61707365546F53746172742865297B72657475726E206E6577206B742865';
wwv_flow_imp.g_varchar2_table(1104) := '2E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D636F6C6C61707365546F456E6428297B72657475726E206B742E636F6C6C61707365546F';
wwv_flow_imp.g_varchar2_table(1105) := '456E642874686973297D73746174696320636F6C6C61707365546F456E642865297B72657475726E206E6577206B7428652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C';
wwv_flow_imp.g_varchar2_table(1106) := '756D6E297D64656C74612865297B72657475726E206E6577206B7428746869732E73746172744C696E654E756D6265722B652C746869732E7374617274436F6C756D6E2C746869732E656E644C696E654E756D6265722B652C746869732E656E64436F6C';
wwv_flow_imp.g_varchar2_table(1107) := '756D6E297D7374617469632066726F6D506F736974696F6E7328652C743D65297B72657475726E206E6577206B7428652E6C696E654E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D737461746963206C';
wwv_flow_imp.g_varchar2_table(1108) := '6966742865297B72657475726E20653F6E6577206B7428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E756C6C7D7374617469632069734952';
wwv_flow_imp.g_varchar2_table(1109) := '616E67652865297B72657475726E20652626226E756D626572223D3D747970656F6620652E73746172744C696E654E756D6265722626226E756D626572223D3D747970656F6620652E7374617274436F6C756D6E2626226E756D626572223D3D74797065';
wwv_flow_imp.g_varchar2_table(1110) := '6F6620652E656E644C696E654E756D6265722626226E756D626572223D3D747970656F6620652E656E64436F6C756D6E7D73746174696320617265496E74657273656374696E674F72546F756368696E6728652C74297B72657475726E2128652E656E64';
wwv_flow_imp.g_varchar2_table(1111) := '4C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E656E64436F6C756D6E3C742E7374617274436F6C756D6E7C7C742E656E644C';
wwv_flow_imp.g_varchar2_table(1112) := '696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E656E64436F6C756D6E3C652E7374617274436F6C756D6E297D73746174696320';
wwv_flow_imp.g_varchar2_table(1113) := '617265496E74657273656374696E6728652C74297B72657475726E2128652E656E644C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D62657226';
wwv_flow_imp.g_varchar2_table(1114) := '26652E656E64436F6C756D6E3C3D742E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D62657226';
wwv_flow_imp.g_varchar2_table(1115) := '26742E656E64436F6C756D6E3C3D652E7374617274436F6C756D6E297D73746174696320636F6D7061726552616E6765735573696E6753746172747328652C74297B69662865262674297B636F6E7374206E3D307C652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1116) := '65722C693D307C742E73746172744C696E654E756D6265723B6966286E3D3D3D69297B636F6E7374206E3D307C652E7374617274436F6C756D6E2C693D307C742E7374617274436F6C756D6E3B6966286E3D3D3D69297B636F6E7374206E3D307C652E65';
wwv_flow_imp.g_varchar2_table(1117) := '6E644C696E654E756D6265722C693D307C742E656E644C696E654E756D6265723B72657475726E206E3D3D3D693F28307C652E656E64436F6C756D6E292D28307C742E656E64436F6C756D6E293A6E2D697D72657475726E206E2D697D72657475726E20';
wwv_flow_imp.g_varchar2_table(1118) := '6E2D697D72657475726E28653F313A30292D28743F313A30297D73746174696320636F6D7061726552616E6765735573696E67456E647328652C74297B72657475726E20652E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1119) := '723F652E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E3F652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E2D742E7374617274436F6C756D6E3A652E73746172';
wwv_flow_imp.g_varchar2_table(1120) := '744C696E654E756D6265722D742E73746172744C696E654E756D6265723A652E656E64436F6C756D6E2D742E656E64436F6C756D6E3A652E656E644C696E654E756D6265722D742E656E644C696E654E756D6265727D737461746963207370616E734D75';
wwv_flow_imp.g_varchar2_table(1121) := '6C7469706C654C696E65732865297B72657475726E20652E656E644C696E654E756D6265723E652E73746172744C696E654E756D6265727D746F4A534F4E28297B72657475726E20746869737D7D7661722053743B66756E6374696F6E20787428652C74';
wwv_flow_imp.g_varchar2_table(1122) := '297B72657475726E286E2C69293D3E742865286E292C65286929297D2166756E6374696F6E2865297B652E69734C6573735468616E3D66756E6374696F6E2865297B72657475726E20653C307D2C652E69734C6573735468616E4F72457175616C3D6675';
wwv_flow_imp.g_varchar2_table(1123) := '6E6374696F6E2865297B72657475726E20653C3D307D2C652E6973477265617465725468616E3D66756E6374696F6E2865297B72657475726E20653E307D2C652E69734E6569746865724C6573734F72477265617465725468616E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1124) := '2865297B72657475726E20303D3D3D657D2C652E677265617465725468616E3D312C652E6C6573735468616E3D2D312C652E6E6569746865724C6573734F72477265617465725468616E3D307D2853747C7C2853743D7B7D29293B636F6E7374204C743D';
wwv_flow_imp.g_varchar2_table(1125) := '28652C74293D3E652D743B636C6173732043747B636F6E7374727563746F722865297B746869732E697465726174653D657D746F417272617928297B636F6E737420653D5B5D3B72657475726E20746869732E697465726174652828743D3E28652E7075';
wwv_flow_imp.g_varchar2_table(1126) := '73682874292C21302929292C657D66696C7465722865297B72657475726E206E65772043742828743D3E746869732E6974657261746528286E3D3E2165286E297C7C74286E29292929297D6D61702865297B72657475726E206E65772043742828743D3E';
wwv_flow_imp.g_varchar2_table(1127) := '746869732E6974657261746528286E3D3E742865286E2929292929297D66696E644C6173742865297B6C657420743B72657475726E20746869732E6974657261746528286E3D3E2865286E29262628743D6E292C21302929292C747D66696E644C617374';
wwv_flow_imp.g_varchar2_table(1128) := '4D617842792865297B6C657420742C6E3D21303B72657475726E20746869732E697465726174652828693D3E28286E7C7C53742E6973477265617465725468616E286528692C742929292626286E3D21312C743D69292C21302929292C747D7D66756E63';
wwv_flow_imp.g_varchar2_table(1129) := '74696F6E2045742865297B72657475726E20653C303F303A653E3235353F3235353A307C657D66756E6374696F6E2041742865297B72657475726E20653C303F303A653E343239343936373239353F343239343936373239353A307C657D43742E656D70';
wwv_flow_imp.g_varchar2_table(1130) := '74793D6E65772043742828653D3E7B7D29293B636C6173732052747B636F6E7374727563746F722865297B746869732E76616C7565733D652C746869732E70726566697853756D3D6E65772055696E743332417272617928652E6C656E677468292C7468';
wwv_flow_imp.g_varchar2_table(1131) := '69732E70726566697853756D56616C6964496E6465783D6E657720496E74333241727261792831292C746869732E70726566697853756D56616C6964496E6465785B305D3D2D317D696E7365727456616C75657328652C74297B653D41742865293B636F';
wwv_flow_imp.g_varchar2_table(1132) := '6E7374206E3D746869732E76616C7565732C693D746869732E70726566697853756D2C723D742E6C656E6774683B72657475726E2030213D3D72262628746869732E76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682B7229';
wwv_flow_imp.g_varchar2_table(1133) := '2C746869732E76616C7565732E736574286E2E737562617272617928302C65292C30292C746869732E76616C7565732E736574286E2E73756261727261792865292C652B72292C746869732E76616C7565732E73657428742C65292C652D313C74686973';
wwv_flow_imp.g_varchar2_table(1134) := '2E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C746869732E70726566697853756D3D6E65772055696E743332417272617928746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(1135) := '732E6C656E677468292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853756D2E73657428692E737562617272617928302C746869732E70726566697853756D56616C6964496E6465785B30';
wwv_flow_imp.g_varchar2_table(1136) := '5D2B3129292C2130297D73657456616C756528652C74297B72657475726E20653D41742865292C743D41742874292C746869732E76616C7565735B655D213D3D74262628746869732E76616C7565735B655D3D742C652D313C746869732E707265666978';
wwv_flow_imp.g_varchar2_table(1137) := '53756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C2130297D72656D6F766556616C75657328652C74297B653D41742865292C743D41742874293B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(1138) := '69732E76616C7565732C693D746869732E70726566697853756D3B696628653E3D6E2E6C656E6774682972657475726E21313B636F6E737420723D6E2E6C656E6774682D653B72657475726E20743E3D72262628743D72292C30213D3D74262628746869';
wwv_flow_imp.g_varchar2_table(1139) := '732E76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682D74292C746869732E76616C7565732E736574286E2E737562617272617928302C65292C30292C746869732E76616C7565732E736574286E2E73756261727261792865';
wwv_flow_imp.g_varchar2_table(1140) := '2B74292C65292C746869732E70726566697853756D3D6E65772055696E743332417272617928746869732E76616C7565732E6C656E677468292C652D313C746869732E70726566697853756D56616C6964496E6465785B305D262628746869732E707265';
wwv_flow_imp.g_varchar2_table(1141) := '66697853756D56616C6964496E6465785B305D3D652D31292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853756D2E73657428692E737562617272617928302C746869732E707265666978';
wwv_flow_imp.g_varchar2_table(1142) := '53756D56616C6964496E6465785B305D2B3129292C2130297D676574546F74616C53756D28297B72657475726E20303D3D3D746869732E76616C7565732E6C656E6774683F303A746869732E5F67657450726566697853756D28746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(1143) := '732E6C656E6774682D31297D67657450726566697853756D2865297B72657475726E20653C303F303A28653D41742865292C746869732E5F67657450726566697853756D286529297D5F67657450726566697853756D2865297B696628653C3D74686973';
wwv_flow_imp.g_varchar2_table(1144) := '2E70726566697853756D56616C6964496E6465785B305D2972657475726E20746869732E70726566697853756D5B655D3B6C657420743D746869732E70726566697853756D56616C6964496E6465785B305D2B313B303D3D3D74262628746869732E7072';
wwv_flow_imp.g_varchar2_table(1145) := '6566697853756D5B305D3D746869732E76616C7565735B305D2C742B2B292C653E3D746869732E76616C7565732E6C656E677468262628653D746869732E76616C7565732E6C656E6774682D31293B666F72286C6574206E3D743B6E3C3D653B6E2B2B29';
wwv_flow_imp.g_varchar2_table(1146) := '746869732E70726566697853756D5B6E5D3D746869732E70726566697853756D5B6E2D315D2B746869732E76616C7565735B6E5D3B72657475726E20746869732E70726566697853756D56616C6964496E6465785B305D3D4D6174682E6D617828746869';
wwv_flow_imp.g_varchar2_table(1147) := '732E70726566697853756D56616C6964496E6465785B305D2C65292C746869732E70726566697853756D5B655D7D676574496E6465784F662865297B653D4D6174682E666C6F6F722865292C746869732E676574546F74616C53756D28293B6C65742074';
wwv_flow_imp.g_varchar2_table(1148) := '3D302C6E3D746869732E76616C7565732E6C656E6774682D312C693D302C723D302C6F3D303B666F72283B743C3D6E3B29696628693D742B286E2D74292F327C302C723D746869732E70726566697853756D5B695D2C6F3D722D746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(1149) := '735B695D2C653C6F296E3D692D313B656C73657B6966282128653E3D722929627265616B3B743D692B317D72657475726E206E6577204D7428692C652D6F297D7D636C617373204D747B636F6E7374727563746F7228652C74297B746869732E696E6465';
wwv_flow_imp.g_varchar2_table(1150) := '783D652C746869732E72656D61696E6465723D742C746869732E5F70726566697853756D496E6465784F66526573756C744272616E643D766F696420302C746869732E696E6465783D652C746869732E72656D61696E6465723D747D7D636C617373204E';
wwv_flow_imp.g_varchar2_table(1151) := '747B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F7572693D652C746869732E5F6C696E65733D742C746869732E5F656F6C3D6E2C746869732E5F76657273696F6E49643D692C746869732E5F6C696E655374617274733D6E756C6C';
wwv_flow_imp.g_varchar2_table(1152) := '2C746869732E5F6361636865645465787456616C75653D6E756C6C7D646973706F736528297B746869732E5F6C696E65732E6C656E6774683D307D6765742076657273696F6E28297B72657475726E20746869732E5F76657273696F6E49647D67657454';
wwv_flow_imp.g_varchar2_table(1153) := '65787428297B72657475726E206E756C6C3D3D3D746869732E5F6361636865645465787456616C7565262628746869732E5F6361636865645465787456616C75653D746869732E5F6C696E65732E6A6F696E28746869732E5F656F6C29292C746869732E';
wwv_flow_imp.g_varchar2_table(1154) := '5F6361636865645465787456616C75657D6F6E4576656E74732865297B652E656F6C2626652E656F6C213D3D746869732E5F656F6C262628746869732E5F656F6C3D652E656F6C2C746869732E5F6C696E655374617274733D6E756C6C293B636F6E7374';
wwv_flow_imp.g_varchar2_table(1155) := '20743D652E6368616E6765733B666F7228636F6E73742065206F66207429746869732E5F61636365707444656C65746552616E676528652E72616E6765292C746869732E5F616363657074496E7365727454657874286E657720547428652E72616E6765';
wwv_flow_imp.g_varchar2_table(1156) := '2E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E292C652E74657874293B746869732E5F76657273696F6E49643D652E76657273696F6E49642C746869732E5F6361636865645465787456616C75653D6E756C6C';
wwv_flow_imp.g_varchar2_table(1157) := '7D5F656E737572654C696E6553746172747328297B69662821746869732E5F6C696E65537461727473297B636F6E737420653D746869732E5F656F6C2E6C656E6774682C743D746869732E5F6C696E65732E6C656E6774682C6E3D6E65772055696E7433';
wwv_flow_imp.g_varchar2_table(1158) := '3241727261792874293B666F72286C657420693D303B693C743B692B2B296E5B695D3D746869732E5F6C696E65735B695D2E6C656E6774682B653B746869732E5F6C696E655374617274733D6E6577205274286E297D7D5F7365744C696E655465787428';
wwv_flow_imp.g_varchar2_table(1159) := '652C74297B746869732E5F6C696E65735B655D3D742C746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E73657456616C756528652C746869732E5F6C696E65735B655D2E6C656E6774682B746869732E5F656F6C2E';
wwv_flow_imp.g_varchar2_table(1160) := '6C656E677468297D5F61636365707444656C65746552616E67652865297B696628652E73746172744C696E654E756D626572213D3D652E656E644C696E654E756D62657229746869732E5F7365744C696E655465787428652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(1161) := '6D6265722D312C746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E656E644C696E654E756D6265722D315D2E';
wwv_flow_imp.g_varchar2_table(1162) := '737562737472696E6728652E656E64436F6C756D6E2D3129292C746869732E5F6C696E65732E73706C69636528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D626572292C7468';
wwv_flow_imp.g_varchar2_table(1163) := '69732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E72656D6F766556616C75657328652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D626572293B65';
wwv_flow_imp.g_varchar2_table(1164) := '6C73657B696628652E7374617274436F6C756D6E3D3D3D652E656E64436F6C756D6E2972657475726E3B746869732E5F7365744C696E655465787428652E73746172744C696E654E756D6265722D312C746869732E5F6C696E65735B652E73746172744C';
wwv_flow_imp.g_varchar2_table(1165) := '696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728652E656E64436F6C756D6E2D312929';
wwv_flow_imp.g_varchar2_table(1166) := '7D7D5F616363657074496E736572745465787428652C74297B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D742E73706C6974282F5C725C6E7C5C727C5C6E2F293B696628313D3D3D6E2E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(1167) := '20766F696420746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B305D2B74686973';
wwv_flow_imp.g_varchar2_table(1168) := '2E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728652E636F6C756D6E2D3129293B6E5B6E2E6C656E6774682D315D2B3D746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728';
wwv_flow_imp.g_varchar2_table(1169) := '652E636F6C756D6E2D31292C746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B30';
wwv_flow_imp.g_varchar2_table(1170) := '5D293B636F6E737420693D6E65772055696E7433324172726179286E2E6C656E6774682D31293B666F72286C657420743D313B743C6E2E6C656E6774683B742B2B29746869732E5F6C696E65732E73706C69636528652E6C696E654E756D6265722B742D';
wwv_flow_imp.g_varchar2_table(1171) := '312C302C6E5B745D292C695B742D315D3D6E5B745D2E6C656E6774682B746869732E5F656F6C2E6C656E6774683B746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E696E7365727456616C75657328652E6C696E65';
wwv_flow_imp.g_varchar2_table(1172) := '4E756D6265722C69297D7D636F6E73742049743D66756E6374696F6E28653D2222297B6C657420743D22282D3F5C5C642A5C5C2E5C5C645C5C772A297C285B5E223B666F7228636F6E7374206E206F6622607E21402324255E262A28292D3D2B5B7B5D7D';
wwv_flow_imp.g_varchar2_table(1173) := '5C5C7C3B3A275C222C2E3C3E2F3F2229652E696E6465784F66286E293E3D307C7C28742B3D225C5C222B6E293B72657475726E20742B3D225C5C735D2B29222C6E65772052656745787028742C226722297D28293B66756E6374696F6E207A742865297B';
wwv_flow_imp.g_varchar2_table(1174) := '6C657420743D49743B6966286526266520696E7374616E63656F662052656745787029696628652E676C6F62616C29743D653B656C73657B6C6574206E3D2267223B652E69676E6F7265436173652626286E2B3D226922292C652E6D756C74696C696E65';
wwv_flow_imp.g_varchar2_table(1175) := '2626286E2B3D226D22292C652E756E69636F64652626286E2B3D227522292C743D6E65772052656745787028652E736F757263652C6E297D72657475726E20742E6C617374496E6465783D302C747D636F6E73742055743D6E6577205F3B66756E637469';
wwv_flow_imp.g_varchar2_table(1176) := '6F6E20487428652C742C6E2C692C72297B696628743D7A742874292C727C7C28723D6C2E666972737428557429292C6E2E6C656E6774683E722E6D61784C656E297B6C6574206F3D652D722E6D61784C656E2F323B72657475726E206F3C303F6F3D303A';
wwv_flow_imp.g_varchar2_table(1177) := '692B3D6F2C487428652C742C6E3D6E2E737562737472696E67286F2C652B722E6D61784C656E2F32292C692C72297D636F6E7374206F3D446174652E6E6F7728292C613D652D312D693B6C657420733D2D312C683D6E756C6C3B666F72286C657420653D';
wwv_flow_imp.g_varchar2_table(1178) := '313B2128446174652E6E6F7728292D6F3E3D722E74696D65427564676574293B652B2B297B636F6E737420693D612D722E77696E646F7753697A652A653B742E6C617374496E6465783D4D6174682E6D617828302C69293B636F6E7374206F3D44742874';
wwv_flow_imp.g_varchar2_table(1179) := '2C6E2C612C73293B696628216F26266829627265616B3B696628683D6F2C693C3D3029627265616B3B733D697D69662868297B636F6E737420653D7B776F72643A685B305D2C7374617274436F6C756D6E3A692B312B682E696E6465782C656E64436F6C';
wwv_flow_imp.g_varchar2_table(1180) := '756D6E3A692B312B682E696E6465782B685B305D2E6C656E6774687D3B72657475726E20742E6C617374496E6465783D302C657D72657475726E206E756C6C7D66756E6374696F6E20447428652C742C6E2C69297B6C657420723B666F72283B723D652E';
wwv_flow_imp.g_varchar2_table(1181) := '657865632874293B297B636F6E737420743D722E696E6465787C7C303B696628743C3D6E2626652E6C617374496E6465783E3D6E2972657475726E20723B696628693E302626743E692972657475726E206E756C6C7D72657475726E206E756C6C7D5574';
wwv_flow_imp.g_varchar2_table(1182) := '2E756E7368696674287B6D61784C656E3A3165332C77696E646F7753697A653A31352C74696D654275646765743A3135307D293B636C617373204F747B636F6E7374727563746F722865297B636F6E737420743D45742865293B746869732E5F64656661';
wwv_flow_imp.g_varchar2_table(1183) := '756C7456616C75653D742C746869732E5F61736369694D61703D4F742E5F63726561746541736369694D61702874292C746869732E5F6D61703D6E6577204D61707D737461746963205F63726561746541736369694D61702865297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(1184) := '6E65772055696E7438417272617928323536293B72657475726E20742E66696C6C2865292C747D73657428652C74297B636F6E7374206E3D45742874293B653E3D302626653C3235363F746869732E5F61736369694D61705B655D3D6E3A746869732E5F';
wwv_flow_imp.g_varchar2_table(1185) := '6D61702E73657428652C6E297D6765742865297B72657475726E20653E3D302626653C3235363F746869732E5F61736369694D61705B655D3A746869732E5F6D61702E6765742865297C7C746869732E5F64656661756C7456616C75657D636C65617228';
wwv_flow_imp.g_varchar2_table(1186) := '297B746869732E5F61736369694D61702E66696C6C28746869732E5F64656661756C7456616C7565292C746869732E5F6D61702E636C65617228297D7D636C6173732057747B636F6E7374727563746F7228652C742C6E297B636F6E737420693D6E6577';
wwv_flow_imp.g_varchar2_table(1187) := '2055696E7438417272617928652A74293B666F72286C657420723D302C6F3D652A743B723C6F3B722B2B29695B725D3D6E3B746869732E5F646174613D692C746869732E726F77733D652C746869732E636F6C733D747D67657428652C74297B72657475';
wwv_flow_imp.g_varchar2_table(1188) := '726E20746869732E5F646174615B652A746869732E636F6C732B745D7D73657428652C742C6E297B746869732E5F646174615B652A746869732E636F6C732B745D3D6E7D7D636C6173732050747B636F6E7374727563746F722865297B6C657420743D30';
wwv_flow_imp.g_varchar2_table(1189) := '2C6E3D303B666F72286C657420693D302C723D652E6C656E6774683B693C723B692B2B297B636F6E73745B722C6F2C615D3D655B695D3B6F3E74262628743D6F292C723E6E2626286E3D72292C613E6E2626286E3D61297D742B2B2C6E2B2B3B636F6E73';
wwv_flow_imp.g_varchar2_table(1190) := '7420693D6E6577205774286E2C742C30293B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E73745B6E2C722C6F5D3D655B745D3B692E736574286E2C722C6F297D746869732E5F7374617465733D692C74686973';
wwv_flow_imp.g_varchar2_table(1191) := '2E5F6D617843686172436F64653D747D6E657874537461746528652C74297B72657475726E20743C307C7C743E3D746869732E5F6D617843686172436F64653F303A746869732E5F7374617465732E67657428652C74297D7D6C65742071743D6E756C6C';
wwv_flow_imp.g_varchar2_table(1192) := '2C46743D6E756C6C3B636C6173732042747B737461746963205F6372656174654C696E6B28652C742C6E2C692C72297B6C6574206F3D722D313B646F7B636F6E7374206E3D742E63686172436F64654174286F293B69662832213D3D652E676574286E29';
wwv_flow_imp.g_varchar2_table(1193) := '29627265616B3B6F2D2D7D7768696C65286F3E69293B696628693E30297B636F6E737420653D742E63686172436F6465417428692D31292C6E3D742E63686172436F64654174286F293B2834303D3D3D65262634313D3D3D6E7C7C39313D3D3D65262639';
wwv_flow_imp.g_varchar2_table(1194) := '333D3D3D6E7C7C3132333D3D3D6526263132353D3D3D6E2926266F2D2D7D72657475726E7B72616E67653A7B73746172744C696E654E756D6265723A6E2C7374617274436F6C756D6E3A692B312C656E644C696E654E756D6265723A6E2C656E64436F6C';
wwv_flow_imp.g_varchar2_table(1195) := '756D6E3A6F2B327D2C75726C3A742E737562737472696E6728692C6F2B31297D7D73746174696320636F6D707574654C696E6B7328652C743D66756E6374696F6E28297B72657475726E206E756C6C3D3D3D717426262871743D6E6577205074285B5B31';
wwv_flow_imp.g_varchar2_table(1196) := '2C3130342C325D2C5B312C37322C325D2C5B312C3130322C365D2C5B312C37302C365D2C5B322C3131362C335D2C5B322C38342C335D2C5B332C3131362C345D2C5B332C38342C345D2C5B342C3131322C355D2C5B342C38302C355D2C5B352C3131352C';
wwv_flow_imp.g_varchar2_table(1197) := '395D2C5B352C38332C395D2C5B352C35382C31305D2C5B362C3130352C375D2C5B362C37332C375D2C5B372C3130382C385D2C5B372C37362C385D2C5B382C3130312C395D2C5B382C36392C395D2C5B392C35382C31305D2C5B31302C34372C31315D2C';
wwv_flow_imp.g_varchar2_table(1198) := '5B31312C34372C31325D5D29292C71747D2829297B636F6E7374206E3D66756E6374696F6E28297B6966286E756C6C3D3D3D4674297B46743D6E6577204F742830293B636F6E737420653D22205C743C3E275C22E38081E38082EFBDA1EFBDA4EFBC8CEF';
wwv_flow_imp.g_varchar2_table(1199) := 'BC8EEFBC9AEFBC9BE28098E38088E3808CE3808EE38094EFBC88EFBCBBEFBD9BEFBDA2EFBDA3EFBD9DEFBCBDEFBC89E38095E3808FE3808DE38089E28099EFBD80EFBD9EE280A6223B666F72286C657420743D303B743C652E6C656E6774683B742B2B29';
wwv_flow_imp.g_varchar2_table(1200) := '46742E73657428652E63686172436F646541742874292C31293B636F6E737420743D222E2C3B3A223B666F72286C657420653D303B653C742E6C656E6774683B652B2B2946742E73657428742E63686172436F646541742865292C32297D72657475726E';
wwv_flow_imp.g_varchar2_table(1201) := '2046747D28292C693D5B5D3B666F72286C657420723D312C6F3D652E6765744C696E65436F756E7428293B723C3D6F3B722B2B297B636F6E7374206F3D652E6765744C696E65436F6E74656E742872292C613D6F2E6C656E6774683B6C657420733D302C';
wwv_flow_imp.g_varchar2_table(1202) := '6C3D302C683D302C633D312C643D21312C753D21312C6D3D21312C703D21313B666F72283B733C613B297B6C657420653D21313B636F6E737420613D6F2E63686172436F646541742873293B69662831333D3D3D63297B6C657420743B73776974636828';
wwv_flow_imp.g_varchar2_table(1203) := '61297B636173652034303A643D21302C743D303B627265616B3B636173652034313A743D643F303A313B627265616B3B636173652039313A6D3D21302C753D21302C743D303B627265616B3B636173652039333A6D3D21312C743D753F303A313B627265';
wwv_flow_imp.g_varchar2_table(1204) := '616B3B63617365203132333A703D21302C743D303B627265616B3B63617365203132353A743D703F303A313B627265616B3B636173652033393A636173652033343A636173652039363A743D683D3D3D613F313A33393D3D3D687C7C33343D3D3D687C7C';
wwv_flow_imp.g_varchar2_table(1205) := '39363D3D3D683F303A313B627265616B3B636173652034323A743D34323D3D3D683F313A303B627265616B3B63617365203132343A743D3132343D3D3D683F313A303B627265616B3B636173652033323A743D6D3F303A313B627265616B3B6465666175';
wwv_flow_imp.g_varchar2_table(1206) := '6C743A743D6E2E6765742861297D313D3D3D74262628692E707573682842742E5F6372656174654C696E6B286E2C6F2C722C6C2C7329292C653D2130297D656C73652069662831323D3D3D63297B6C657420743B39313D3D3D613F28753D21302C743D30';
wwv_flow_imp.g_varchar2_table(1207) := '293A743D6E2E6765742861292C313D3D3D743F653D21303A633D31337D656C736520633D742E6E657874537461746528632C61292C303D3D3D63262628653D2130293B65262628633D312C643D21312C753D21312C703D21312C6C3D732B312C683D6129';
wwv_flow_imp.g_varchar2_table(1208) := '2C732B2B7D31333D3D3D632626692E707573682842742E5F6372656174654C696E6B286E2C6F2C722C6C2C6129297D72657475726E20697D7D636C6173732056747B636F6E7374727563746F7228297B746869732E5F64656661756C7456616C75655365';
wwv_flow_imp.g_varchar2_table(1209) := '743D5B5B2274727565222C2266616C7365225D2C5B2254727565222C2246616C7365225D2C5B2250726976617465222C225075626C6963222C22467269656E64222C22526561644F6E6C79222C225061727469616C222C2250726F746563746564222C22';
wwv_flow_imp.g_varchar2_table(1210) := '57726974654F6E6C79225D2C5B227075626C6963222C2270726F746563746564222C2270726976617465225D5D7D6E6176696761746556616C756553657428652C742C6E2C692C72297B69662865262674297B636F6E7374206E3D746869732E646F4E61';
wwv_flow_imp.g_varchar2_table(1211) := '76696761746556616C756553657428742C72293B6966286E2972657475726E7B72616E67653A652C76616C75653A6E7D7D6966286E262669297B636F6E737420653D746869732E646F4E6176696761746556616C756553657428692C72293B6966286529';
wwv_flow_imp.g_varchar2_table(1212) := '72657475726E7B72616E67653A6E2C76616C75653A657D7D72657475726E206E756C6C7D646F4E6176696761746556616C756553657428652C74297B636F6E7374206E3D746869732E6E756D6265725265706C61636528652C74293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(1213) := '756C6C213D3D6E3F6E3A746869732E746578745265706C61636528652C74297D6E756D6265725265706C61636528652C74297B636F6E7374206E3D4D6174682E706F772831302C652E6C656E6774682D28652E6C617374496E6465784F6628222E22292B';
wwv_flow_imp.g_varchar2_table(1214) := '3129293B6C657420693D4E756D6265722865293B636F6E737420723D7061727365466C6F61742865293B72657475726E2069734E614E2869297C7C69734E614E2872297C7C69213D3D723F6E756C6C3A30213D3D697C7C743F28693D4D6174682E666C6F';
wwv_flow_imp.g_varchar2_table(1215) := '6F7228692A6E292C692B3D743F6E3A2D6E2C537472696E6728692F6E29293A6E756C6C7D746578745265706C61636528652C74297B72657475726E20746869732E76616C7565536574735265706C61636528746869732E5F64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(1216) := '5365742C652C74297D76616C7565536574735265706C61636528652C742C6E297B6C657420693D6E756C6C3B666F72286C657420723D302C6F3D652E6C656E6774683B6E756C6C3D3D3D692626723C6F3B722B2B29693D746869732E76616C7565536574';
wwv_flow_imp.g_varchar2_table(1217) := '5265706C61636528655B725D2C742C6E293B72657475726E20697D76616C75655365745265706C61636528652C742C6E297B6C657420693D652E696E6465784F662874293B72657475726E20693E3D303F28692B3D6E3F313A2D312C693C303F693D652E';
wwv_flow_imp.g_varchar2_table(1218) := '6C656E6774682D313A69253D652E6C656E6774682C655B695D293A6E756C6C7D7D56742E494E5354414E43453D6E65772056743B636F6E7374204B743D4F626A6563742E667265657A65282866756E6374696F6E28652C74297B636F6E7374206E3D7365';
wwv_flow_imp.g_varchar2_table(1219) := '7454696D656F757428652E62696E642874292C30293B72657475726E7B646973706F736528297B636C65617254696D656F7574286E297D7D7D29293B766172206A743B2166756E6374696F6E2865297B652E697343616E63656C6C6174696F6E546F6B65';
wwv_flow_imp.g_varchar2_table(1220) := '6E3D66756E6374696F6E2874297B72657475726E20743D3D3D652E4E6F6E657C7C743D3D3D652E43616E63656C6C65647C7C7420696E7374616E63656F662047747C7C212821747C7C226F626A65637422213D747970656F66207429262622626F6F6C65';
wwv_flow_imp.g_varchar2_table(1221) := '616E223D3D747970656F6620742E697343616E63656C6C6174696F6E52657175657374656426262266756E6374696F6E223D3D747970656F6620742E6F6E43616E63656C6C6174696F6E5265717565737465647D2C652E4E6F6E653D4F626A6563742E66';
wwv_flow_imp.g_varchar2_table(1222) := '7265657A65287B697343616E63656C6C6174696F6E5265717565737465643A21312C6F6E43616E63656C6C6174696F6E5265717565737465643A792E4E6F6E657D292C652E43616E63656C6C65643D4F626A6563742E667265657A65287B697343616E63';
wwv_flow_imp.g_varchar2_table(1223) := '656C6C6174696F6E5265717565737465643A21302C6F6E43616E63656C6C6174696F6E5265717565737465643A4B747D297D286A747C7C286A743D7B7D29293B636C6173732047747B636F6E7374727563746F7228297B746869732E5F697343616E6365';
wwv_flow_imp.g_varchar2_table(1224) := '6C6C65643D21312C746869732E5F656D69747465723D6E756C6C7D63616E63656C28297B746869732E5F697343616E63656C6C65647C7C28746869732E5F697343616E63656C6C65643D21302C746869732E5F656D6974746572262628746869732E5F65';
wwv_flow_imp.g_varchar2_table(1225) := '6D69747465722E6669726528766F69642030292C746869732E646973706F7365282929297D67657420697343616E63656C6C6174696F6E52657175657374656428297B72657475726E20746869732E5F697343616E63656C6C65647D676574206F6E4361';
wwv_flow_imp.g_varchar2_table(1226) := '6E63656C6C6174696F6E52657175657374656428297B72657475726E20746869732E5F697343616E63656C6C65643F4B743A28746869732E5F656D69747465727C7C28746869732E5F656D69747465723D6E6577204C292C746869732E5F656D69747465';
wwv_flow_imp.g_varchar2_table(1227) := '722E6576656E74297D646973706F736528297B746869732E5F656D6974746572262628746869732E5F656D69747465722E646973706F736528292C746869732E5F656D69747465723D6E756C6C297D7D636C6173732024747B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(1228) := '28297B746869732E5F6B6579436F6465546F5374723D5B5D2C746869732E5F737472546F4B6579436F64653D4F626A6563742E637265617465286E756C6C297D646566696E6528652C74297B746869732E5F6B6579436F6465546F5374725B655D3D742C';
wwv_flow_imp.g_varchar2_table(1229) := '746869732E5F737472546F4B6579436F64655B742E746F4C6F7765724361736528295D3D657D6B6579436F6465546F5374722865297B72657475726E20746869732E5F6B6579436F6465546F5374725B655D7D737472546F4B6579436F64652865297B72';
wwv_flow_imp.g_varchar2_table(1230) := '657475726E20746869732E5F737472546F4B6579436F64655B652E746F4C6F7765724361736528295D7C7C307D7D636F6E73742058743D6E65772024742C4A743D6E65772024742C59743D6E65772024742C51743D6E657720417272617928323330292C';
wwv_flow_imp.g_varchar2_table(1231) := '5A743D7B7D2C656E3D5B5D2C746E3D4F626A6563742E637265617465286E756C6C292C6E6E3D4F626A6563742E637265617465286E756C6C292C726E3D5B5D2C6F6E3D5B5D3B666F72286C657420653D303B653C3D3139333B652B2B29726E5B655D3D2D';
wwv_flow_imp.g_varchar2_table(1232) := '313B666F72286C657420653D303B653C3D3133323B652B2B296F6E5B655D3D2D313B76617220616E3B2166756E6374696F6E28297B636F6E737420653D22222C743D5B5B312C302C224E6F6E65222C302C22756E6B6E6F776E222C302C22564B5F554E4B';
wwv_flow_imp.g_varchar2_table(1233) := '4E4F574E222C652C655D2C5B312C312C224879706572222C302C652C302C652C652C655D2C5B312C322C225375706572222C302C652C302C652C652C655D2C5B312C332C22466E222C302C652C302C652C652C655D2C5B312C342C22466E4C6F636B222C';
wwv_flow_imp.g_varchar2_table(1234) := '302C652C302C652C652C655D2C5B312C352C2253757370656E64222C302C652C302C652C652C655D2C5B312C362C22526573756D65222C302C652C302C652C652C655D2C5B312C372C22547572626F222C302C652C302C652C652C655D2C5B312C382C22';
wwv_flow_imp.g_varchar2_table(1235) := '536C656570222C302C652C302C22564B5F534C454550222C652C655D2C5B312C392C2257616B655570222C302C652C302C652C652C655D2C5B302C31302C224B657941222C33312C2241222C36352C22564B5F41222C652C655D2C5B302C31312C224B65';
wwv_flow_imp.g_varchar2_table(1236) := '7942222C33322C2242222C36362C22564B5F42222C652C655D2C5B302C31322C224B657943222C33332C2243222C36372C22564B5F43222C652C655D2C5B302C31332C224B657944222C33342C2244222C36382C22564B5F44222C652C655D2C5B302C31';
wwv_flow_imp.g_varchar2_table(1237) := '342C224B657945222C33352C2245222C36392C22564B5F45222C652C655D2C5B302C31352C224B657946222C33362C2246222C37302C22564B5F46222C652C655D2C5B302C31362C224B657947222C33372C2247222C37312C22564B5F47222C652C655D';
wwv_flow_imp.g_varchar2_table(1238) := '2C5B302C31372C224B657948222C33382C2248222C37322C22564B5F48222C652C655D2C5B302C31382C224B657949222C33392C2249222C37332C22564B5F49222C652C655D2C5B302C31392C224B65794A222C34302C224A222C37342C22564B5F4A22';
wwv_flow_imp.g_varchar2_table(1239) := '2C652C655D2C5B302C32302C224B65794B222C34312C224B222C37352C22564B5F4B222C652C655D2C5B302C32312C224B65794C222C34322C224C222C37362C22564B5F4C222C652C655D2C5B302C32322C224B65794D222C34332C224D222C37372C22';
wwv_flow_imp.g_varchar2_table(1240) := '564B5F4D222C652C655D2C5B302C32332C224B65794E222C34342C224E222C37382C22564B5F4E222C652C655D2C5B302C32342C224B65794F222C34352C224F222C37392C22564B5F4F222C652C655D2C5B302C32352C224B657950222C34362C225022';
wwv_flow_imp.g_varchar2_table(1241) := '2C38302C22564B5F50222C652C655D2C5B302C32362C224B657951222C34372C2251222C38312C22564B5F51222C652C655D2C5B302C32372C224B657952222C34382C2252222C38322C22564B5F52222C652C655D2C5B302C32382C224B657953222C34';
wwv_flow_imp.g_varchar2_table(1242) := '392C2253222C38332C22564B5F53222C652C655D2C5B302C32392C224B657954222C35302C2254222C38342C22564B5F54222C652C655D2C5B302C33302C224B657955222C35312C2255222C38352C22564B5F55222C652C655D2C5B302C33312C224B65';
wwv_flow_imp.g_varchar2_table(1243) := '7956222C35322C2256222C38362C22564B5F56222C652C655D2C5B302C33322C224B657957222C35332C2257222C38372C22564B5F57222C652C655D2C5B302C33332C224B657958222C35342C2258222C38382C22564B5F58222C652C655D2C5B302C33';
wwv_flow_imp.g_varchar2_table(1244) := '342C224B657959222C35352C2259222C38392C22564B5F59222C652C655D2C5B302C33352C224B65795A222C35362C225A222C39302C22564B5F5A222C652C655D2C5B302C33362C22446967697431222C32322C2231222C34392C22564B5F31222C652C';
wwv_flow_imp.g_varchar2_table(1245) := '655D2C5B302C33372C22446967697432222C32332C2232222C35302C22564B5F32222C652C655D2C5B302C33382C22446967697433222C32342C2233222C35312C22564B5F33222C652C655D2C5B302C33392C22446967697434222C32352C2234222C35';
wwv_flow_imp.g_varchar2_table(1246) := '322C22564B5F34222C652C655D2C5B302C34302C22446967697435222C32362C2235222C35332C22564B5F35222C652C655D2C5B302C34312C22446967697436222C32372C2236222C35342C22564B5F36222C652C655D2C5B302C34322C224469676974';
wwv_flow_imp.g_varchar2_table(1247) := '37222C32382C2237222C35352C22564B5F37222C652C655D2C5B302C34332C22446967697438222C32392C2238222C35362C22564B5F38222C652C655D2C5B302C34342C22446967697439222C33302C2239222C35372C22564B5F39222C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(1248) := '302C34352C22446967697430222C32312C2230222C34382C22564B5F30222C652C655D2C5B312C34362C22456E746572222C332C22456E746572222C31332C22564B5F52455455524E222C652C655D2C5B312C34372C22457363617065222C392C224573';
wwv_flow_imp.g_varchar2_table(1249) := '63617065222C32372C22564B5F455343415045222C652C655D2C5B312C34382C224261636B7370616365222C312C224261636B7370616365222C382C22564B5F4241434B222C652C655D2C5B312C34392C22546162222C322C22546162222C392C22564B';
wwv_flow_imp.g_varchar2_table(1250) := '5F544142222C652C655D2C5B312C35302C225370616365222C31302C225370616365222C33322C22564B5F5350414345222C652C655D2C5B302C35312C224D696E7573222C38382C222D222C3138392C22564B5F4F454D5F4D494E5553222C222D222C22';
wwv_flow_imp.g_varchar2_table(1251) := '4F454D5F4D494E5553225D2C5B302C35322C22457175616C222C38362C223D222C3138372C22564B5F4F454D5F504C5553222C223D222C224F454D5F504C5553225D2C5B302C35332C22427261636B65744C656674222C39322C225B222C3231392C2256';
wwv_flow_imp.g_varchar2_table(1252) := '4B5F4F454D5F34222C225B222C224F454D5F34225D2C5B302C35342C22427261636B65745269676874222C39342C225D222C3232312C22564B5F4F454D5F36222C225D222C224F454D5F36225D2C5B302C35352C224261636B736C617368222C39332C22';
wwv_flow_imp.g_varchar2_table(1253) := '5C5C222C3232302C22564B5F4F454D5F35222C225C5C222C224F454D5F35225D2C5B302C35362C22496E746C48617368222C302C652C302C652C652C655D2C5B302C35372C2253656D69636F6C6F6E222C38352C223B222C3138362C22564B5F4F454D5F';
wwv_flow_imp.g_varchar2_table(1254) := '31222C223B222C224F454D5F31225D2C5B302C35382C2251756F7465222C39352C2227222C3232322C22564B5F4F454D5F37222C2227222C224F454D5F37225D2C5B302C35392C224261636B71756F7465222C39312C2260222C3139322C22564B5F4F45';
wwv_flow_imp.g_varchar2_table(1255) := '4D5F33222C2260222C224F454D5F33225D2C5B302C36302C22436F6D6D61222C38372C222C222C3138382C22564B5F4F454D5F434F4D4D41222C222C222C224F454D5F434F4D4D41225D2C5B302C36312C22506572696F64222C38392C222E222C313930';
wwv_flow_imp.g_varchar2_table(1256) := '2C22564B5F4F454D5F504552494F44222C222E222C224F454D5F504552494F44225D2C5B302C36322C22536C617368222C39302C222F222C3139312C22564B5F4F454D5F32222C222F222C224F454D5F32225D2C5B312C36332C22436170734C6F636B22';
wwv_flow_imp.g_varchar2_table(1257) := '2C382C22436170734C6F636B222C32302C22564B5F4341504954414C222C652C655D2C5B312C36342C224631222C35392C224631222C3131322C22564B5F4631222C652C655D2C5B312C36352C224632222C36302C224632222C3131332C22564B5F4632';
wwv_flow_imp.g_varchar2_table(1258) := '222C652C655D2C5B312C36362C224633222C36312C224633222C3131342C22564B5F4633222C652C655D2C5B312C36372C224634222C36322C224634222C3131352C22564B5F4634222C652C655D2C5B312C36382C224635222C36332C224635222C3131';
wwv_flow_imp.g_varchar2_table(1259) := '362C22564B5F4635222C652C655D2C5B312C36392C224636222C36342C224636222C3131372C22564B5F4636222C652C655D2C5B312C37302C224637222C36352C224637222C3131382C22564B5F4637222C652C655D2C5B312C37312C224638222C3636';
wwv_flow_imp.g_varchar2_table(1260) := '2C224638222C3131392C22564B5F4638222C652C655D2C5B312C37322C224639222C36372C224639222C3132302C22564B5F4639222C652C655D2C5B312C37332C22463130222C36382C22463130222C3132312C22564B5F463130222C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(1261) := '2C37342C22463131222C36392C22463131222C3132322C22564B5F463131222C652C655D2C5B312C37352C22463132222C37302C22463132222C3132332C22564B5F463132222C652C655D2C5B312C37362C225072696E7453637265656E222C302C652C';
wwv_flow_imp.g_varchar2_table(1262) := '302C652C652C655D2C5B312C37372C225363726F6C6C4C6F636B222C38342C225363726F6C6C4C6F636B222C3134352C22564B5F5343524F4C4C222C652C655D2C5B312C37382C225061757365222C372C225061757365427265616B222C31392C22564B';
wwv_flow_imp.g_varchar2_table(1263) := '5F5041555345222C652C655D2C5B312C37392C22496E73657274222C31392C22496E73657274222C34352C22564B5F494E53455254222C652C655D2C5B312C38302C22486F6D65222C31342C22486F6D65222C33362C22564B5F484F4D45222C652C655D';
wwv_flow_imp.g_varchar2_table(1264) := '2C5B312C38312C22506167655570222C31312C22506167655570222C33332C22564B5F5052494F52222C652C655D2C5B312C38322C2244656C657465222C32302C2244656C657465222C34362C22564B5F44454C455445222C652C655D2C5B312C38332C';
wwv_flow_imp.g_varchar2_table(1265) := '22456E64222C31332C22456E64222C33352C22564B5F454E44222C652C655D2C5B312C38342C2250616765446F776E222C31322C2250616765446F776E222C33342C22564B5F4E455854222C652C655D2C5B312C38352C224172726F775269676874222C';
wwv_flow_imp.g_varchar2_table(1266) := '31372C2252696768744172726F77222C33392C22564B5F5249474854222C225269676874222C655D2C5B312C38362C224172726F774C656674222C31352C224C6566744172726F77222C33372C22564B5F4C454654222C224C656674222C655D2C5B312C';
wwv_flow_imp.g_varchar2_table(1267) := '38372C224172726F77446F776E222C31382C22446F776E4172726F77222C34302C22564B5F444F574E222C22446F776E222C655D2C5B312C38382C224172726F775570222C31362C2255704172726F77222C33382C22564B5F5550222C225570222C655D';
wwv_flow_imp.g_varchar2_table(1268) := '2C5B312C38392C224E756D4C6F636B222C38332C224E756D4C6F636B222C3134342C22564B5F4E554D4C4F434B222C652C655D2C5B312C39302C224E756D706164446976696465222C3131332C224E756D5061645F446976696465222C3131312C22564B';
wwv_flow_imp.g_varchar2_table(1269) := '5F444956494445222C652C655D2C5B312C39312C224E756D7061644D756C7469706C79222C3130382C224E756D5061645F4D756C7469706C79222C3130362C22564B5F4D554C5449504C59222C652C655D2C5B312C39322C224E756D7061645375627472';
wwv_flow_imp.g_varchar2_table(1270) := '616374222C3131312C224E756D5061645F5375627472616374222C3130392C22564B5F5355425452414354222C652C655D2C5B312C39332C224E756D706164416464222C3130392C224E756D5061645F416464222C3130372C22564B5F414444222C652C';
wwv_flow_imp.g_varchar2_table(1271) := '655D2C5B312C39342C224E756D706164456E746572222C332C652C302C652C652C655D2C5B312C39352C224E756D70616431222C39392C224E756D50616431222C39372C22564B5F4E554D50414431222C652C655D2C5B312C39362C224E756D70616432';
wwv_flow_imp.g_varchar2_table(1272) := '222C3130302C224E756D50616432222C39382C22564B5F4E554D50414432222C652C655D2C5B312C39372C224E756D70616433222C3130312C224E756D50616433222C39392C22564B5F4E554D50414433222C652C655D2C5B312C39382C224E756D7061';
wwv_flow_imp.g_varchar2_table(1273) := '6434222C3130322C224E756D50616434222C3130302C22564B5F4E554D50414434222C652C655D2C5B312C39392C224E756D70616435222C3130332C224E756D50616435222C3130312C22564B5F4E554D50414435222C652C655D2C5B312C3130302C22';
wwv_flow_imp.g_varchar2_table(1274) := '4E756D70616436222C3130342C224E756D50616436222C3130322C22564B5F4E554D50414436222C652C655D2C5B312C3130312C224E756D70616437222C3130352C224E756D50616437222C3130332C22564B5F4E554D50414437222C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(1275) := '2C3130322C224E756D70616438222C3130362C224E756D50616438222C3130342C22564B5F4E554D50414438222C652C655D2C5B312C3130332C224E756D70616439222C3130372C224E756D50616439222C3130352C22564B5F4E554D50414439222C65';
wwv_flow_imp.g_varchar2_table(1276) := '2C655D2C5B312C3130342C224E756D70616430222C39382C224E756D50616430222C39362C22564B5F4E554D50414430222C652C655D2C5B312C3130352C224E756D706164446563696D616C222C3131322C224E756D5061645F446563696D616C222C31';
wwv_flow_imp.g_varchar2_table(1277) := '31302C22564B5F444543494D414C222C652C655D2C5B302C3130362C22496E746C4261636B736C617368222C39372C224F454D5F313032222C3232362C22564B5F4F454D5F313032222C652C655D2C5B312C3130372C22436F6E746578744D656E75222C';
wwv_flow_imp.g_varchar2_table(1278) := '35382C22436F6E746578744D656E75222C39332C652C652C655D2C5B312C3130382C22506F776572222C302C652C302C652C652C655D2C5B312C3130392C224E756D706164457175616C222C302C652C302C652C652C655D2C5B312C3131302C22463133';
wwv_flow_imp.g_varchar2_table(1279) := '222C37312C22463133222C3132342C22564B5F463133222C652C655D2C5B312C3131312C22463134222C37322C22463134222C3132352C22564B5F463134222C652C655D2C5B312C3131322C22463135222C37332C22463135222C3132362C22564B5F46';
wwv_flow_imp.g_varchar2_table(1280) := '3135222C652C655D2C5B312C3131332C22463136222C37342C22463136222C3132372C22564B5F463136222C652C655D2C5B312C3131342C22463137222C37352C22463137222C3132382C22564B5F463137222C652C655D2C5B312C3131352C22463138';
wwv_flow_imp.g_varchar2_table(1281) := '222C37362C22463138222C3132392C22564B5F463138222C652C655D2C5B312C3131362C22463139222C37372C22463139222C3133302C22564B5F463139222C652C655D2C5B312C3131372C22463230222C37382C22463230222C3133312C22564B5F46';
wwv_flow_imp.g_varchar2_table(1282) := '3230222C652C655D2C5B312C3131382C22463231222C37392C22463231222C3133322C22564B5F463231222C652C655D2C5B312C3131392C22463232222C38302C22463232222C3133332C22564B5F463232222C652C655D2C5B312C3132302C22463233';
wwv_flow_imp.g_varchar2_table(1283) := '222C38312C22463233222C3133342C22564B5F463233222C652C655D2C5B312C3132312C22463234222C38322C22463234222C3133352C22564B5F463234222C652C655D2C5B312C3132322C224F70656E222C302C652C302C652C652C655D2C5B312C31';
wwv_flow_imp.g_varchar2_table(1284) := '32332C2248656C70222C302C652C302C652C652C655D2C5B312C3132342C2253656C656374222C302C652C302C652C652C655D2C5B312C3132352C22416761696E222C302C652C302C652C652C655D2C5B312C3132362C22556E646F222C302C652C302C';
wwv_flow_imp.g_varchar2_table(1285) := '652C652C655D2C5B312C3132372C22437574222C302C652C302C652C652C655D2C5B312C3132382C22436F7079222C302C652C302C652C652C655D2C5B312C3132392C225061737465222C302C652C302C652C652C655D2C5B312C3133302C2246696E64';
wwv_flow_imp.g_varchar2_table(1286) := '222C302C652C302C652C652C655D2C5B312C3133312C22417564696F566F6C756D654D757465222C3131372C22417564696F566F6C756D654D757465222C3137332C22564B5F564F4C554D455F4D555445222C652C655D2C5B312C3133322C2241756469';
wwv_flow_imp.g_varchar2_table(1287) := '6F566F6C756D655570222C3131382C22417564696F566F6C756D655570222C3137352C22564B5F564F4C554D455F5550222C652C655D2C5B312C3133332C22417564696F566F6C756D65446F776E222C3131392C22417564696F566F6C756D65446F776E';
wwv_flow_imp.g_varchar2_table(1288) := '222C3137342C22564B5F564F4C554D455F444F574E222C652C655D2C5B312C3133342C224E756D706164436F6D6D61222C3131302C224E756D5061645F536570617261746F72222C3130382C22564B5F534550415241544F52222C652C655D2C5B302C31';
wwv_flow_imp.g_varchar2_table(1289) := '33352C22496E746C526F222C3131352C2241424E545F4331222C3139332C22564B5F41424E545F4331222C652C655D2C5B312C3133362C224B616E614D6F6465222C302C652C302C652C652C655D2C5B302C3133372C22496E746C59656E222C302C652C';
wwv_flow_imp.g_varchar2_table(1290) := '302C652C652C655D2C5B312C3133382C22436F6E76657274222C302C652C302C652C652C655D2C5B312C3133392C224E6F6E436F6E76657274222C302C652C302C652C652C655D2C5B312C3134302C224C616E6731222C302C652C302C652C652C655D2C';
wwv_flow_imp.g_varchar2_table(1291) := '5B312C3134312C224C616E6732222C302C652C302C652C652C655D2C5B312C3134322C224C616E6733222C302C652C302C652C652C655D2C5B312C3134332C224C616E6734222C302C652C302C652C652C655D2C5B312C3134342C224C616E6735222C30';
wwv_flow_imp.g_varchar2_table(1292) := '2C652C302C652C652C655D2C5B312C3134352C2241626F7274222C302C652C302C652C652C655D2C5B312C3134362C2250726F7073222C302C652C302C652C652C655D2C5B312C3134372C224E756D706164506172656E4C656674222C302C652C302C65';
wwv_flow_imp.g_varchar2_table(1293) := '2C652C655D2C5B312C3134382C224E756D706164506172656E5269676874222C302C652C302C652C652C655D2C5B312C3134392C224E756D7061644261636B7370616365222C302C652C302C652C652C655D2C5B312C3135302C224E756D7061644D656D';
wwv_flow_imp.g_varchar2_table(1294) := '6F727953746F7265222C302C652C302C652C652C655D2C5B312C3135312C224E756D7061644D656D6F7279526563616C6C222C302C652C302C652C652C655D2C5B312C3135322C224E756D7061644D656D6F7279436C656172222C302C652C302C652C65';
wwv_flow_imp.g_varchar2_table(1295) := '2C655D2C5B312C3135332C224E756D7061644D656D6F7279416464222C302C652C302C652C652C655D2C5B312C3135342C224E756D7061644D656D6F72795375627472616374222C302C652C302C652C652C655D2C5B312C3135352C224E756D70616443';
wwv_flow_imp.g_varchar2_table(1296) := '6C656172222C3133312C22436C656172222C31322C22564B5F434C454152222C652C655D2C5B312C3135362C224E756D706164436C656172456E747279222C302C652C302C652C652C655D2C5B312C302C652C352C224374726C222C31372C22564B5F43';
wwv_flow_imp.g_varchar2_table(1297) := '4F4E54524F4C222C652C655D2C5B312C302C652C342C225368696674222C31362C22564B5F5348494654222C652C655D2C5B312C302C652C362C22416C74222C31382C22564B5F4D454E55222C652C655D2C5B312C302C652C35372C224D657461222C39';
wwv_flow_imp.g_varchar2_table(1298) := '312C22564B5F434F4D4D414E44222C652C655D2C5B312C3135372C22436F6E74726F6C4C656674222C352C652C302C22564B5F4C434F4E54524F4C222C652C655D2C5B312C3135382C2253686966744C656674222C342C652C302C22564B5F4C53484946';
wwv_flow_imp.g_varchar2_table(1299) := '54222C652C655D2C5B312C3135392C22416C744C656674222C362C652C302C22564B5F4C4D454E55222C652C655D2C5B312C3136302C224D6574614C656674222C35372C652C302C22564B5F4C57494E222C652C655D2C5B312C3136312C22436F6E7472';
wwv_flow_imp.g_varchar2_table(1300) := '6F6C5269676874222C352C652C302C22564B5F52434F4E54524F4C222C652C655D2C5B312C3136322C2253686966745269676874222C342C652C302C22564B5F525348494654222C652C655D2C5B312C3136332C22416C745269676874222C362C652C30';
wwv_flow_imp.g_varchar2_table(1301) := '2C22564B5F524D454E55222C652C655D2C5B312C3136342C224D6574615269676874222C35372C652C302C22564B5F5257494E222C652C655D2C5B312C3136352C224272696768746E6573735570222C302C652C302C652C652C655D2C5B312C3136362C';
wwv_flow_imp.g_varchar2_table(1302) := '224272696768746E657373446F776E222C302C652C302C652C652C655D2C5B312C3136372C224D65646961506C6179222C302C652C302C652C652C655D2C5B312C3136382C224D656469615265636F7264222C302C652C302C652C652C655D2C5B312C31';
wwv_flow_imp.g_varchar2_table(1303) := '36392C224D6564696146617374466F7277617264222C302C652C302C652C652C655D2C5B312C3137302C224D65646961526577696E64222C302C652C302C652C652C655D2C5B312C3137312C224D65646961547261636B4E657874222C3132342C224D65';
wwv_flow_imp.g_varchar2_table(1304) := '646961547261636B4E657874222C3137362C22564B5F4D454449415F4E4558545F545241434B222C652C655D2C5B312C3137322C224D65646961547261636B50726576696F7573222C3132352C224D65646961547261636B50726576696F7573222C3137';
wwv_flow_imp.g_varchar2_table(1305) := '372C22564B5F4D454449415F505245565F545241434B222C652C655D2C5B312C3137332C224D6564696153746F70222C3132362C224D6564696153746F70222C3137382C22564B5F4D454449415F53544F50222C652C655D2C5B312C3137342C22456A65';
wwv_flow_imp.g_varchar2_table(1306) := '6374222C302C652C302C652C652C655D2C5B312C3137352C224D65646961506C61795061757365222C3132372C224D65646961506C61795061757365222C3137392C22564B5F4D454449415F504C41595F5041555345222C652C655D2C5B312C3137362C';
wwv_flow_imp.g_varchar2_table(1307) := '224D6564696153656C656374222C3132382C224C61756E63684D65646961506C61796572222C3138312C22564B5F4D454449415F4C41554E43485F4D454449415F53454C454354222C652C655D2C5B312C3137372C224C61756E63684D61696C222C3132';
wwv_flow_imp.g_varchar2_table(1308) := '392C224C61756E63684D61696C222C3138302C22564B5F4D454449415F4C41554E43485F4D41494C222C652C655D2C5B312C3137382C224C61756E636841707032222C3133302C224C61756E636841707032222C3138332C22564B5F4D454449415F4C41';
wwv_flow_imp.g_varchar2_table(1309) := '554E43485F41505032222C652C655D2C5B312C3137392C224C61756E636841707031222C302C652C302C22564B5F4D454449415F4C41554E43485F41505031222C652C655D2C5B312C3138302C2253656C6563745461736B222C302C652C302C652C652C';
wwv_flow_imp.g_varchar2_table(1310) := '655D2C5B312C3138312C224C61756E636853637265656E5361766572222C302C652C302C652C652C655D2C5B312C3138322C2242726F77736572536561726368222C3132302C2242726F77736572536561726368222C3137302C22564B5F42524F575345';
wwv_flow_imp.g_varchar2_table(1311) := '525F534541524348222C652C655D2C5B312C3138332C2242726F77736572486F6D65222C3132312C2242726F77736572486F6D65222C3137322C22564B5F42524F575345525F484F4D45222C652C655D2C5B312C3138342C2242726F777365724261636B';
wwv_flow_imp.g_varchar2_table(1312) := '222C3132322C2242726F777365724261636B222C3136362C22564B5F42524F575345525F4241434B222C652C655D2C5B312C3138352C2242726F77736572466F7277617264222C3132332C2242726F77736572466F7277617264222C3136372C22564B5F';
wwv_flow_imp.g_varchar2_table(1313) := '42524F575345525F464F5257415244222C652C655D2C5B312C3138362C2242726F7773657253746F70222C302C652C302C22564B5F42524F575345525F53544F50222C652C655D2C5B312C3138372C2242726F7773657252656672657368222C302C652C';
wwv_flow_imp.g_varchar2_table(1314) := '302C22564B5F42524F575345525F52454652455348222C652C655D2C5B312C3138382C2242726F777365724661766F7269746573222C302C652C302C22564B5F42524F575345525F4641564F5249544553222C652C655D2C5B312C3138392C225A6F6F6D';
wwv_flow_imp.g_varchar2_table(1315) := '546F67676C65222C302C652C302C652C652C655D2C5B312C3139302C224D61696C5265706C79222C302C652C302C652C652C655D2C5B312C3139312C224D61696C466F7277617264222C302C652C302C652C652C655D2C5B312C3139322C224D61696C53';
wwv_flow_imp.g_varchar2_table(1316) := '656E64222C302C652C302C652C652C655D2C5B312C302C652C3131342C224B6579496E436F6D706F736974696F6E222C3232392C652C652C655D2C5B312C302C652C3131362C2241424E545F4332222C3139342C22564B5F41424E545F4332222C652C65';
wwv_flow_imp.g_varchar2_table(1317) := '5D2C5B312C302C652C39362C224F454D5F38222C3232332C22564B5F4F454D5F38222C652C655D2C5B312C302C652C302C652C302C22564B5F4B414E41222C652C655D2C5B312C302C652C302C652C302C22564B5F48414E47554C222C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(1318) := '2C302C652C302C652C302C22564B5F4A554E4A41222C652C655D2C5B312C302C652C302C652C302C22564B5F46494E414C222C652C655D2C5B312C302C652C302C652C302C22564B5F48414E4A41222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1319) := '4B5F4B414E4A49222C652C655D2C5B312C302C652C302C652C302C22564B5F434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F41434345';
wwv_flow_imp.g_varchar2_table(1320) := '5054222C652C655D2C5B312C302C652C302C652C302C22564B5F4D4F44454348414E4745222C652C655D2C5B312C302C652C302C652C302C22564B5F53454C454354222C652C655D2C5B312C302C652C302C652C302C22564B5F5052494E54222C652C65';
wwv_flow_imp.g_varchar2_table(1321) := '5D2C5B312C302C652C302C652C302C22564B5F45584543555445222C652C655D2C5B312C302C652C302C652C302C22564B5F534E415053484F54222C652C655D2C5B312C302C652C302C652C302C22564B5F48454C50222C652C655D2C5B312C302C652C';
wwv_flow_imp.g_varchar2_table(1322) := '302C652C302C22564B5F41505053222C652C655D2C5B312C302C652C302C652C302C22564B5F50524F434553534B4559222C652C655D2C5B312C302C652C302C652C302C22564B5F5041434B4554222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1323) := '4B5F4442455F5342435343484152222C652C655D2C5B312C302C652C302C652C302C22564B5F4442455F4442435343484152222C652C655D2C5B312C302C652C302C652C302C22564B5F4154544E222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1324) := '4B5F435253454C222C652C655D2C5B312C302C652C302C652C302C22564B5F455853454C222C652C655D2C5B312C302C652C302C652C302C22564B5F4552454F46222C652C655D2C5B312C302C652C302C652C302C22564B5F504C4159222C652C655D2C';
wwv_flow_imp.g_varchar2_table(1325) := '5B312C302C652C302C652C302C22564B5F5A4F4F4D222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E414D45222C652C655D2C5B312C302C652C302C652C302C22564B5F504131222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1326) := '4B5F4F454D5F434C454152222C652C655D5D2C6E3D5B5D2C693D5B5D3B666F7228636F6E73742065206F662074297B636F6E73745B742C722C6F2C612C732C6C2C682C632C645D3D653B696628695B725D7C7C28695B725D3D21302C656E5B725D3D6F2C';
wwv_flow_imp.g_varchar2_table(1327) := '746E5B6F5D3D722C6E6E5B6F2E746F4C6F7765724361736528295D3D722C74262628726E5B725D3D612C30213D3D61262633213D3D61262635213D3D61262634213D3D61262636213D3D6126263537213D3D612626286F6E5B615D3D722929292C216E5B';
wwv_flow_imp.g_varchar2_table(1328) := '615D297B6966286E5B615D3D21302C2173297468726F77206E6577204572726F722860537472696E6720726570726573656E746174696F6E206D697373696E6720666F72206B657920636F646520247B617D2061726F756E64207363616E20636F646520';
wwv_flow_imp.g_varchar2_table(1329) := '247B6F7D60293B58742E646566696E6528612C73292C4A742E646566696E6528612C637C7C73292C59742E646566696E6528612C647C7C637C7C73297D6C26262851745B6C5D3D61292C682626285A745B685D3D61297D6F6E5B335D3D34367D28292C66';
wwv_flow_imp.g_varchar2_table(1330) := '756E6374696F6E2865297B652E746F537472696E673D66756E6374696F6E2865297B72657475726E2058742E6B6579436F6465546F5374722865297D2C652E66726F6D537472696E673D66756E6374696F6E2865297B72657475726E2058742E73747254';
wwv_flow_imp.g_varchar2_table(1331) := '6F4B6579436F64652865297D2C652E746F5573657253657474696E677355533D66756E6374696F6E2865297B72657475726E204A742E6B6579436F6465546F5374722865297D2C652E746F5573657253657474696E677347656E6572616C3D66756E6374';
wwv_flow_imp.g_varchar2_table(1332) := '696F6E2865297B72657475726E2059742E6B6579436F6465546F5374722865297D2C652E66726F6D5573657253657474696E67733D66756E6374696F6E2865297B72657475726E204A742E737472546F4B6579436F64652865297C7C59742E737472546F';
wwv_flow_imp.g_varchar2_table(1333) := '4B6579436F64652865297D2C652E746F456C656374726F6E416363656C657261746F723D66756E6374696F6E2865297B696628653E3D39382626653C3D3131332972657475726E206E756C6C3B7377697463682865297B636173652031363A7265747572';
wwv_flow_imp.g_varchar2_table(1334) := '6E225570223B636173652031383A72657475726E22446F776E223B636173652031353A72657475726E224C656674223B636173652031373A72657475726E225269676874227D72657475726E2058742E6B6579436F6465546F5374722865297D7D28616E';
wwv_flow_imp.g_varchar2_table(1335) := '7C7C28616E3D7B7D29293B636C61737320736E20657874656E6473206B747B636F6E7374727563746F7228652C742C6E2C69297B737570657228652C742C6E2C69292C746869732E73656C656374696F6E53746172744C696E654E756D6265723D652C74';
wwv_flow_imp.g_varchar2_table(1336) := '6869732E73656C656374696F6E5374617274436F6C756D6E3D742C746869732E706F736974696F6E4C696E654E756D6265723D6E2C746869732E706F736974696F6E436F6C756D6E3D697D746F537472696E6728297B72657475726E225B222B74686973';
wwv_flow_imp.g_varchar2_table(1337) := '2E73656C656374696F6E53746172744C696E654E756D6265722B222C222B746869732E73656C656374696F6E5374617274436F6C756D6E2B22202D3E20222B746869732E706F736974696F6E4C696E654E756D6265722B222C222B746869732E706F7369';
wwv_flow_imp.g_varchar2_table(1338) := '74696F6E436F6C756D6E2B225D227D657175616C7353656C656374696F6E2865297B72657475726E20736E2E73656C656374696F6E73457175616C28746869732C65297D7374617469632073656C656374696F6E73457175616C28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(1339) := '726E20652E73656C656374696F6E53746172744C696E654E756D6265723D3D3D742E73656C656374696F6E53746172744C696E654E756D6265722626652E73656C656374696F6E5374617274436F6C756D6E3D3D3D742E73656C656374696F6E53746172';
wwv_flow_imp.g_varchar2_table(1340) := '74436F6C756D6E2626652E706F736974696F6E4C696E654E756D6265723D3D3D742E706F736974696F6E4C696E654E756D6265722626652E706F736974696F6E436F6C756D6E3D3D3D742E706F736974696F6E436F6C756D6E7D67657444697265637469';
wwv_flow_imp.g_varchar2_table(1341) := '6F6E28297B72657475726E20746869732E73656C656374696F6E53746172744C696E654E756D6265723D3D3D746869732E73746172744C696E654E756D6265722626746869732E73656C656374696F6E5374617274436F6C756D6E3D3D3D746869732E73';
wwv_flow_imp.g_varchar2_table(1342) := '74617274436F6C756D6E3F303A317D736574456E64506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E657720736E28746869732E73746172744C696E654E756D6265722C746869732E73';
wwv_flow_imp.g_varchar2_table(1343) := '74617274436F6C756D6E2C652C74293A6E657720736E28652C742C746869732E73746172744C696E654E756D6265722C746869732E7374617274436F6C756D6E297D676574506F736974696F6E28297B72657475726E206E657720547428746869732E70';
wwv_flow_imp.g_varchar2_table(1344) := '6F736974696F6E4C696E654E756D6265722C746869732E706F736974696F6E436F6C756D6E297D67657453656C656374696F6E537461727428297B72657475726E206E657720547428746869732E73656C656374696F6E53746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1345) := '65722C746869732E73656C656374696F6E5374617274436F6C756D6E297D7365745374617274506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E657720736E28652C742C746869732E65';
wwv_flow_imp.g_varchar2_table(1346) := '6E644C696E654E756D6265722C746869732E656E64436F6C756D6E293A6E657720736E28746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E2C652C74297D7374617469632066726F6D506F736974696F6E7328652C743D';
wwv_flow_imp.g_varchar2_table(1347) := '65297B72657475726E206E657720736E28652E6C696E654E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D7374617469632066726F6D52616E676528652C74297B72657475726E20303D3D3D743F6E6577';
wwv_flow_imp.g_varchar2_table(1348) := '20736E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E657720736E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(1349) := '652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D737461746963206C69667453656C656374696F6E2865297B72657475726E206E657720736E28652E73656C656374696F6E53746172744C696E654E756D6265722C652E';
wwv_flow_imp.g_varchar2_table(1350) := '73656C656374696F6E5374617274436F6C756D6E2C652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E297D7374617469632073656C656374696F6E73417272457175616C28652C74297B69662865262621747C';
wwv_flow_imp.g_varchar2_table(1351) := '7C21652626742972657475726E21313B6966282165262621742972657475726E21303B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B296966';
wwv_flow_imp.g_varchar2_table(1352) := '2821746869732E73656C656374696F6E73457175616C28655B6E5D2C745B6E5D292972657475726E21313B72657475726E21307D7374617469632069734953656C656374696F6E2865297B72657475726E20652626226E756D626572223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1353) := '6620652E73656C656374696F6E53746172744C696E654E756D6265722626226E756D626572223D3D747970656F6620652E73656C656374696F6E5374617274436F6C756D6E2626226E756D626572223D3D747970656F6620652E706F736974696F6E4C69';
wwv_flow_imp.g_varchar2_table(1354) := '6E654E756D6265722626226E756D626572223D3D747970656F6620652E706F736974696F6E436F6C756D6E7D7374617469632063726561746557697468446972656374696F6E28652C742C6E2C692C72297B72657475726E20303D3D3D723F6E65772073';
wwv_flow_imp.g_varchar2_table(1355) := '6E28652C742C6E2C69293A6E657720736E286E2C692C652C74297D7D636F6E7374206C6E3D4F626A6563742E637265617465286E756C6C293B66756E6374696F6E20686E28652C74297B69662822737472696E67223D3D747970656F662074297B636F6E';
wwv_flow_imp.g_varchar2_table(1356) := '7374206E3D6C6E5B745D3B696628766F696420303D3D3D6E297468726F77206E6577204572726F722860247B657D207265666572656E63657320616E20756E6B6E6F776E20636F6469636F6E3A20247B747D60293B743D6E7D72657475726E206C6E5B65';
wwv_flow_imp.g_varchar2_table(1357) := '5D3D742C7B69643A657D7D636F6E737420636E3D7B6164643A686E2822616464222C366534292C706C75733A686E2822706C7573222C366534292C676973744E65773A686E2822676973742D6E6577222C366534292C7265706F4372656174653A686E28';
wwv_flow_imp.g_varchar2_table(1358) := '227265706F2D637265617465222C366534292C6C6967687462756C623A686E28226C6967687462756C62222C3630303031292C6C6967687442756C623A686E28226C696768742D62756C62222C3630303031292C7265706F3A686E28227265706F222C36';
wwv_flow_imp.g_varchar2_table(1359) := '30303032292C7265706F44656C6574653A686E28227265706F2D64656C657465222C3630303032292C67697374466F726B3A686E2822676973742D666F726B222C3630303033292C7265706F466F726B65643A686E28227265706F2D666F726B6564222C';
wwv_flow_imp.g_varchar2_table(1360) := '3630303033292C67697450756C6C526571756573743A686E28226769742D70756C6C2D72657175657374222C3630303034292C67697450756C6C526571756573744162616E646F6E65643A686E28226769742D70756C6C2D726571756573742D6162616E';
wwv_flow_imp.g_varchar2_table(1361) := '646F6E6564222C3630303034292C7265636F72644B6579733A686E28227265636F72642D6B657973222C3630303035292C6B6579626F6172643A686E28226B6579626F617264222C3630303035292C7461673A686E2822746167222C3630303036292C67';
wwv_flow_imp.g_varchar2_table(1362) := '697450756C6C526571756573744C6162656C3A686E28226769742D70756C6C2D726571756573742D6C6162656C222C3630303036292C7461674164643A686E28227461672D616464222C3630303036292C74616752656D6F76653A686E28227461672D72';
wwv_flow_imp.g_varchar2_table(1363) := '656D6F7665222C3630303036292C706572736F6E3A686E2822706572736F6E222C3630303037292C706572736F6E466F6C6C6F773A686E2822706572736F6E2D666F6C6C6F77222C3630303037292C706572736F6E4F75746C696E653A686E2822706572';
wwv_flow_imp.g_varchar2_table(1364) := '736F6E2D6F75746C696E65222C3630303037292C706572736F6E46696C6C65643A686E2822706572736F6E2D66696C6C6564222C3630303037292C6769744272616E63683A686E28226769742D6272616E6368222C3630303038292C6769744272616E63';
wwv_flow_imp.g_varchar2_table(1365) := '684372656174653A686E28226769742D6272616E63682D637265617465222C3630303038292C6769744272616E636844656C6574653A686E28226769742D6272616E63682D64656C657465222C3630303038292C736F75726365436F6E74726F6C3A686E';
wwv_flow_imp.g_varchar2_table(1366) := '2822736F757263652D636F6E74726F6C222C3630303038292C6D6972726F723A686E28226D6972726F72222C3630303039292C6D6972726F725075626C69633A686E28226D6972726F722D7075626C6963222C3630303039292C737461723A686E282273';
wwv_flow_imp.g_varchar2_table(1367) := '746172222C3630303130292C737461724164643A686E2822737461722D616464222C3630303130292C7374617244656C6574653A686E2822737461722D64656C657465222C3630303130292C73746172456D7074793A686E2822737461722D656D707479';
wwv_flow_imp.g_varchar2_table(1368) := '222C3630303130292C636F6D6D656E743A686E2822636F6D6D656E74222C3630303131292C636F6D6D656E744164643A686E2822636F6D6D656E742D616464222C3630303131292C616C6572743A686E2822616C657274222C3630303132292C7761726E';
wwv_flow_imp.g_varchar2_table(1369) := '696E673A686E28227761726E696E67222C3630303132292C7365617263683A686E2822736561726368222C3630303133292C736561726368536176653A686E28227365617263682D73617665222C3630303133292C6C6F674F75743A686E28226C6F672D';
wwv_flow_imp.g_varchar2_table(1370) := '6F7574222C3630303134292C7369676E4F75743A686E28227369676E2D6F7574222C3630303134292C6C6F67496E3A686E28226C6F672D696E222C3630303135292C7369676E496E3A686E28227369676E2D696E222C3630303135292C6579653A686E28';
wwv_flow_imp.g_varchar2_table(1371) := '22657965222C3630303136292C657965556E77617463683A686E28226579652D756E7761746368222C3630303136292C65796557617463683A686E28226579652D7761746368222C3630303136292C636972636C6546696C6C65643A686E282263697263';
wwv_flow_imp.g_varchar2_table(1372) := '6C652D66696C6C6564222C3630303137292C7072696D6974697665446F743A686E28227072696D69746976652D646F74222C3630303137292C636C6F736544697274793A686E2822636C6F73652D6469727479222C3630303137292C6465627567427265';
wwv_flow_imp.g_varchar2_table(1373) := '616B706F696E743A686E282264656275672D627265616B706F696E74222C3630303137292C6465627567427265616B706F696E7444697361626C65643A686E282264656275672D627265616B706F696E742D64697361626C6564222C3630303137292C64';
wwv_flow_imp.g_varchar2_table(1374) := '6562756748696E743A686E282264656275672D68696E74222C3630303137292C7465726D696E616C4465636F726174696F6E537563636573733A686E28227465726D696E616C2D6465636F726174696F6E2D73756363657373222C3630303137292C7072';
wwv_flow_imp.g_varchar2_table(1375) := '696D69746976655371756172653A686E28227072696D69746976652D737175617265222C3630303138292C656469743A686E282265646974222C3630303139292C70656E63696C3A686E282270656E63696C222C3630303139292C696E666F3A686E2822';
wwv_flow_imp.g_varchar2_table(1376) := '696E666F222C3630303230292C69737375654F70656E65643A686E282269737375652D6F70656E6564222C3630303230292C67697374507269766174653A686E2822676973742D70726976617465222C3630303231292C676974466F726B507269766174';
wwv_flow_imp.g_varchar2_table(1377) := '653A686E28226769742D666F726B2D70726976617465222C3630303231292C6C6F636B3A686E28226C6F636B222C3630303231292C6D6972726F72507269766174653A686E28226D6972726F722D70726976617465222C3630303231292C636C6F73653A';
wwv_flow_imp.g_varchar2_table(1378) := '686E2822636C6F7365222C3630303232292C72656D6F7665436C6F73653A686E282272656D6F76652D636C6F7365222C3630303232292C783A686E282278222C3630303232292C7265706F53796E633A686E28227265706F2D73796E63222C3630303233';
wwv_flow_imp.g_varchar2_table(1379) := '292C73796E633A686E282273796E63222C3630303233292C636C6F6E653A686E2822636C6F6E65222C3630303234292C6465736B746F70446F776E6C6F61643A686E28226465736B746F702D646F776E6C6F6164222C3630303234292C6265616B65723A';
wwv_flow_imp.g_varchar2_table(1380) := '686E28226265616B6572222C3630303235292C6D6963726F73636F70653A686E28226D6963726F73636F7065222C3630303235292C766D3A686E2822766D222C3630303236292C6465766963654465736B746F703A686E28226465766963652D6465736B';
wwv_flow_imp.g_varchar2_table(1381) := '746F70222C3630303236292C66696C653A686E282266696C65222C3630303237292C66696C65546578743A686E282266696C652D74657874222C3630303237292C6D6F72653A686E28226D6F7265222C3630303238292C656C6C69707369733A686E2822';
wwv_flow_imp.g_varchar2_table(1382) := '656C6C6970736973222C3630303238292C6B65626162486F72697A6F6E74616C3A686E28226B656261622D686F72697A6F6E74616C222C3630303238292C6D61696C5265706C793A686E28226D61696C2D7265706C79222C3630303239292C7265706C79';
wwv_flow_imp.g_varchar2_table(1383) := '3A686E28227265706C79222C3630303239292C6F7267616E697A6174696F6E3A686E28226F7267616E697A6174696F6E222C3630303330292C6F7267616E697A6174696F6E46696C6C65643A686E28226F7267616E697A6174696F6E2D66696C6C656422';
wwv_flow_imp.g_varchar2_table(1384) := '2C3630303330292C6F7267616E697A6174696F6E4F75746C696E653A686E28226F7267616E697A6174696F6E2D6F75746C696E65222C3630303330292C6E657746696C653A686E28226E65772D66696C65222C3630303331292C66696C654164643A686E';
wwv_flow_imp.g_varchar2_table(1385) := '282266696C652D616464222C3630303331292C6E6577466F6C6465723A686E28226E65772D666F6C646572222C3630303332292C66696C654469726563746F72794372656174653A686E282266696C652D6469726563746F72792D637265617465222C36';
wwv_flow_imp.g_varchar2_table(1386) := '30303332292C74726173683A686E28227472617368222C3630303333292C747261736863616E3A686E2822747261736863616E222C3630303333292C686973746F72793A686E2822686973746F7279222C3630303334292C636C6F636B3A686E2822636C';
wwv_flow_imp.g_varchar2_table(1387) := '6F636B222C3630303334292C666F6C6465723A686E2822666F6C646572222C3630303335292C66696C654469726563746F72793A686E282266696C652D6469726563746F7279222C3630303335292C73796D626F6C466F6C6465723A686E282273796D62';
wwv_flow_imp.g_varchar2_table(1388) := '6F6C2D666F6C646572222C3630303335292C6C6F676F4769746875623A686E28226C6F676F2D676974687562222C3630303336292C6D61726B4769746875623A686E28226D61726B2D676974687562222C3630303336292C6769746875623A686E282267';
wwv_flow_imp.g_varchar2_table(1389) := '6974687562222C3630303336292C7465726D696E616C3A686E28227465726D696E616C222C3630303337292C636F6E736F6C653A686E2822636F6E736F6C65222C3630303337292C7265706C3A686E28227265706C222C3630303337292C7A61703A686E';
wwv_flow_imp.g_varchar2_table(1390) := '28227A6170222C3630303338292C73796D626F6C4576656E743A686E282273796D626F6C2D6576656E74222C3630303338292C6572726F723A686E28226572726F72222C3630303339292C73746F703A686E282273746F70222C3630303339292C766172';
wwv_flow_imp.g_varchar2_table(1391) := '6961626C653A686E28227661726961626C65222C3630303430292C73796D626F6C5661726961626C653A686E282273796D626F6C2D7661726961626C65222C3630303430292C61727261793A686E28226172726179222C3630303432292C73796D626F6C';
wwv_flow_imp.g_varchar2_table(1392) := '41727261793A686E282273796D626F6C2D6172726179222C3630303432292C73796D626F6C4D6F64756C653A686E282273796D626F6C2D6D6F64756C65222C3630303433292C73796D626F6C5061636B6167653A686E282273796D626F6C2D7061636B61';
wwv_flow_imp.g_varchar2_table(1393) := '6765222C3630303433292C73796D626F6C4E616D6573706163653A686E282273796D626F6C2D6E616D657370616365222C3630303433292C73796D626F6C4F626A6563743A686E282273796D626F6C2D6F626A656374222C3630303433292C73796D626F';
wwv_flow_imp.g_varchar2_table(1394) := '6C4D6574686F643A686E282273796D626F6C2D6D6574686F64222C3630303434292C73796D626F6C46756E6374696F6E3A686E282273796D626F6C2D66756E6374696F6E222C3630303434292C73796D626F6C436F6E7374727563746F723A686E282273';
wwv_flow_imp.g_varchar2_table(1395) := '796D626F6C2D636F6E7374727563746F72222C3630303434292C73796D626F6C426F6F6C65616E3A686E282273796D626F6C2D626F6F6C65616E222C3630303437292C73796D626F6C4E756C6C3A686E282273796D626F6C2D6E756C6C222C3630303437';
wwv_flow_imp.g_varchar2_table(1396) := '292C73796D626F6C4E756D657269633A686E282273796D626F6C2D6E756D65726963222C3630303438292C73796D626F6C4E756D6265723A686E282273796D626F6C2D6E756D626572222C3630303438292C73796D626F6C5374727563747572653A686E';
wwv_flow_imp.g_varchar2_table(1397) := '282273796D626F6C2D737472756374757265222C3630303439292C73796D626F6C5374727563743A686E282273796D626F6C2D737472756374222C3630303439292C73796D626F6C506172616D657465723A686E282273796D626F6C2D706172616D6574';
wwv_flow_imp.g_varchar2_table(1398) := '6572222C3630303530292C73796D626F6C54797065506172616D657465723A686E282273796D626F6C2D747970652D706172616D65746572222C3630303530292C73796D626F6C4B65793A686E282273796D626F6C2D6B6579222C3630303531292C7379';
wwv_flow_imp.g_varchar2_table(1399) := '6D626F6C546578743A686E282273796D626F6C2D74657874222C3630303531292C73796D626F6C5265666572656E63653A686E282273796D626F6C2D7265666572656E6365222C3630303532292C676F546F46696C653A686E2822676F2D746F2D66696C';
wwv_flow_imp.g_varchar2_table(1400) := '65222C3630303532292C73796D626F6C456E756D3A686E282273796D626F6C2D656E756D222C3630303533292C73796D626F6C56616C75653A686E282273796D626F6C2D76616C7565222C3630303533292C73796D626F6C52756C65723A686E28227379';
wwv_flow_imp.g_varchar2_table(1401) := '6D626F6C2D72756C6572222C3630303534292C73796D626F6C556E69743A686E282273796D626F6C2D756E6974222C3630303534292C6163746976617465427265616B706F696E74733A686E282261637469766174652D627265616B706F696E7473222C';
wwv_flow_imp.g_varchar2_table(1402) := '3630303535292C617263686976653A686E282261726368697665222C3630303536292C6172726F77426F74683A686E28226172726F772D626F7468222C3630303537292C6172726F77446F776E3A686E28226172726F772D646F776E222C363030353829';
wwv_flow_imp.g_varchar2_table(1403) := '2C6172726F774C6566743A686E28226172726F772D6C656674222C3630303539292C6172726F7752696768743A686E28226172726F772D7269676874222C3630303630292C6172726F77536D616C6C446F776E3A686E28226172726F772D736D616C6C2D';
wwv_flow_imp.g_varchar2_table(1404) := '646F776E222C3630303631292C6172726F77536D616C6C4C6566743A686E28226172726F772D736D616C6C2D6C656674222C3630303632292C6172726F77536D616C6C52696768743A686E28226172726F772D736D616C6C2D7269676874222C36303036';
wwv_flow_imp.g_varchar2_table(1405) := '33292C6172726F77536D616C6C55703A686E28226172726F772D736D616C6C2D7570222C3630303634292C6172726F7755703A686E28226172726F772D7570222C3630303635292C62656C6C3A686E282262656C6C222C3630303636292C626F6C643A68';
wwv_flow_imp.g_varchar2_table(1406) := '6E2822626F6C64222C3630303637292C626F6F6B3A686E2822626F6F6B222C3630303638292C626F6F6B6D61726B3A686E2822626F6F6B6D61726B222C3630303639292C6465627567427265616B706F696E74436F6E646974696F6E616C556E76657269';
wwv_flow_imp.g_varchar2_table(1407) := '666965643A686E282264656275672D627265616B706F696E742D636F6E646974696F6E616C2D756E7665726966696564222C3630303730292C6465627567427265616B706F696E74436F6E646974696F6E616C3A686E282264656275672D627265616B70';
wwv_flow_imp.g_varchar2_table(1408) := '6F696E742D636F6E646974696F6E616C222C3630303731292C6465627567427265616B706F696E74436F6E646974696F6E616C44697361626C65643A686E282264656275672D627265616B706F696E742D636F6E646974696F6E616C2D64697361626C65';
wwv_flow_imp.g_varchar2_table(1409) := '64222C3630303731292C6465627567427265616B706F696E7444617461556E76657269666965643A686E282264656275672D627265616B706F696E742D646174612D756E7665726966696564222C3630303732292C6465627567427265616B706F696E74';
wwv_flow_imp.g_varchar2_table(1410) := '446174613A686E282264656275672D627265616B706F696E742D64617461222C3630303733292C6465627567427265616B706F696E744461746144697361626C65643A686E282264656275672D627265616B706F696E742D646174612D64697361626C65';
wwv_flow_imp.g_varchar2_table(1411) := '64222C3630303733292C6465627567427265616B706F696E744C6F67556E76657269666965643A686E282264656275672D627265616B706F696E742D6C6F672D756E7665726966696564222C3630303734292C6465627567427265616B706F696E744C6F';
wwv_flow_imp.g_varchar2_table(1412) := '673A686E282264656275672D627265616B706F696E742D6C6F67222C3630303735292C6465627567427265616B706F696E744C6F6744697361626C65643A686E282264656275672D627265616B706F696E742D6C6F672D64697361626C6564222C363030';
wwv_flow_imp.g_varchar2_table(1413) := '3735292C6272696566636173653A686E2822627269656663617365222C3630303736292C62726F6164636173743A686E282262726F616463617374222C3630303737292C62726F777365723A686E282262726F77736572222C3630303738292C6275673A';
wwv_flow_imp.g_varchar2_table(1414) := '686E2822627567222C3630303739292C63616C656E6461723A686E282263616C656E646172222C3630303830292C6361736553656E7369746976653A686E2822636173652D73656E736974697665222C3630303831292C636865636B3A686E2822636865';
wwv_flow_imp.g_varchar2_table(1415) := '636B222C3630303832292C636865636B6C6973743A686E2822636865636B6C697374222C3630303833292C63686576726F6E446F776E3A686E282263686576726F6E2D646F776E222C3630303834292C63686576726F6E4C6566743A686E282263686576';
wwv_flow_imp.g_varchar2_table(1416) := '726F6E2D6C656674222C3630303835292C63686576726F6E52696768743A686E282263686576726F6E2D7269676874222C3630303836292C63686576726F6E55703A686E282263686576726F6E2D7570222C3630303837292C6368726F6D65436C6F7365';
wwv_flow_imp.g_varchar2_table(1417) := '3A686E28226368726F6D652D636C6F7365222C3630303838292C6368726F6D654D6178696D697A653A686E28226368726F6D652D6D6178696D697A65222C3630303839292C6368726F6D654D696E696D697A653A686E28226368726F6D652D6D696E696D';
wwv_flow_imp.g_varchar2_table(1418) := '697A65222C3630303930292C6368726F6D65526573746F72653A686E28226368726F6D652D726573746F7265222C3630303931292C636972636C654F75746C696E653A686E2822636972636C652D6F75746C696E65222C3630303932292C636972636C65';
wwv_flow_imp.g_varchar2_table(1419) := '3A686E2822636972636C65222C3630303932292C6465627567427265616B706F696E74556E76657269666965643A686E282264656275672D627265616B706F696E742D756E7665726966696564222C3630303932292C7465726D696E616C4465636F7261';
wwv_flow_imp.g_varchar2_table(1420) := '74696F6E496E636F6D706C6574653A686E28227465726D696E616C2D6465636F726174696F6E2D696E636F6D706C657465222C3630303932292C636972636C65536C6173683A686E2822636972636C652D736C617368222C3630303933292C6369726375';
wwv_flow_imp.g_varchar2_table(1421) := '6974426F6172643A686E2822636972637569742D626F617264222C3630303934292C636C656172416C6C3A686E2822636C6561722D616C6C222C3630303935292C636C697070793A686E2822636C69707079222C3630303936292C636C6F7365416C6C3A';
wwv_flow_imp.g_varchar2_table(1422) := '686E2822636C6F73652D616C6C222C3630303937292C636C6F7564446F776E6C6F61643A686E2822636C6F75642D646F776E6C6F6164222C3630303938292C636C6F756455706C6F61643A686E2822636C6F75642D75706C6F6164222C3630303939292C';
wwv_flow_imp.g_varchar2_table(1423) := '636F64653A686E2822636F6465222C3630313030292C636F6C6C61707365416C6C3A686E2822636F6C6C617073652D616C6C222C3630313031292C636F6C6F724D6F64653A686E2822636F6C6F722D6D6F6465222C3630313032292C636F6D6D656E7444';
wwv_flow_imp.g_varchar2_table(1424) := '697363757373696F6E3A686E2822636F6D6D656E742D64697363757373696F6E222C3630313033292C637265646974436172643A686E28226372656469742D63617264222C3630313035292C646173683A686E282264617368222C3630313038292C6461';
wwv_flow_imp.g_varchar2_table(1425) := '7368626F6172643A686E282264617368626F617264222C3630313039292C64617461626173653A686E28226461746162617365222C3630313130292C6465627567436F6E74696E75653A686E282264656275672D636F6E74696E7565222C363031313129';
wwv_flow_imp.g_varchar2_table(1426) := '2C6465627567446973636F6E6E6563743A686E282264656275672D646973636F6E6E656374222C3630313132292C646562756750617573653A686E282264656275672D7061757365222C3630313133292C6465627567526573746172743A686E28226465';
wwv_flow_imp.g_varchar2_table(1427) := '6275672D72657374617274222C3630313134292C646562756753746172743A686E282264656275672D7374617274222C3630313135292C646562756753746570496E746F3A686E282264656275672D737465702D696E746F222C3630313136292C646562';
wwv_flow_imp.g_varchar2_table(1428) := '7567537465704F75743A686E282264656275672D737465702D6F7574222C3630313137292C6465627567537465704F7665723A686E282264656275672D737465702D6F766572222C3630313138292C646562756753746F703A686E282264656275672D73';
wwv_flow_imp.g_varchar2_table(1429) := '746F70222C3630313139292C64656275673A686E28226465627567222C3630313230292C64657669636543616D657261566964656F3A686E28226465766963652D63616D6572612D766964656F222C3630313231292C64657669636543616D6572613A68';
wwv_flow_imp.g_varchar2_table(1430) := '6E28226465766963652D63616D657261222C3630313232292C6465766963654D6F62696C653A686E28226465766963652D6D6F62696C65222C3630313233292C6469666641646465643A686E2822646966662D6164646564222C3630313234292C646966';
wwv_flow_imp.g_varchar2_table(1431) := '6649676E6F7265643A686E2822646966662D69676E6F726564222C3630313235292C646966664D6F6469666965643A686E2822646966662D6D6F646966696564222C3630313236292C6469666652656D6F7665643A686E2822646966662D72656D6F7665';
wwv_flow_imp.g_varchar2_table(1432) := '64222C3630313237292C6469666652656E616D65643A686E2822646966662D72656E616D6564222C3630313238292C646966663A686E282264696666222C3630313239292C64696666536964656279736964653A686E2822646966662D73696465627973';
wwv_flow_imp.g_varchar2_table(1433) := '696465222C3630313239292C646973636172643A686E282264697363617264222C3630313330292C656469746F724C61796F75743A686E2822656469746F722D6C61796F7574222C3630313331292C656D70747957696E646F773A686E2822656D707479';
wwv_flow_imp.g_varchar2_table(1434) := '2D77696E646F77222C3630313332292C6578636C7564653A686E28226578636C756465222C3630313333292C657874656E73696F6E733A686E2822657874656E73696F6E73222C3630313334292C657965436C6F7365643A686E28226579652D636C6F73';
wwv_flow_imp.g_varchar2_table(1435) := '6564222C3630313335292C66696C6542696E6172793A686E282266696C652D62696E617279222C3630313336292C66696C65436F64653A686E282266696C652D636F6465222C3630313337292C66696C654D656469613A686E282266696C652D6D656469';
wwv_flow_imp.g_varchar2_table(1436) := '61222C3630313338292C66696C655064663A686E282266696C652D706466222C3630313339292C66696C655375626D6F64756C653A686E282266696C652D7375626D6F64756C65222C3630313430292C66696C6553796D6C696E6B4469726563746F7279';
wwv_flow_imp.g_varchar2_table(1437) := '3A686E282266696C652D73796D6C696E6B2D6469726563746F7279222C3630313431292C66696C6553796D6C696E6B46696C653A686E282266696C652D73796D6C696E6B2D66696C65222C3630313432292C66696C655A69703A686E282266696C652D7A';
wwv_flow_imp.g_varchar2_table(1438) := '6970222C3630313433292C66696C65733A686E282266696C6573222C3630313434292C66696C7465723A686E282266696C746572222C3630313435292C666C616D653A686E2822666C616D65222C3630313436292C666F6C64446F776E3A686E2822666F';
wwv_flow_imp.g_varchar2_table(1439) := '6C642D646F776E222C3630313437292C666F6C6455703A686E2822666F6C642D7570222C3630313438292C666F6C643A686E2822666F6C64222C3630313439292C666F6C6465724163746976653A686E2822666F6C6465722D616374697665222C363031';
wwv_flow_imp.g_varchar2_table(1440) := '3530292C666F6C6465724F70656E65643A686E2822666F6C6465722D6F70656E6564222C3630313531292C676561723A686E282267656172222C3630313532292C676966743A686E282267696674222C3630313533292C676973745365637265743A686E';
wwv_flow_imp.g_varchar2_table(1441) := '2822676973742D736563726574222C3630313534292C676973743A686E282267697374222C3630313535292C676974436F6D6D69743A686E28226769742D636F6D6D6974222C3630313536292C676974436F6D706172653A686E28226769742D636F6D70';
wwv_flow_imp.g_varchar2_table(1442) := '617265222C3630313537292C636F6D706172654368616E6765733A686E2822636F6D706172652D6368616E676573222C3630313537292C6769744D657267653A686E28226769742D6D65726765222C3630313538292C676974687562416374696F6E3A68';
wwv_flow_imp.g_varchar2_table(1443) := '6E28226769746875622D616374696F6E222C3630313539292C676974687562416C743A686E28226769746875622D616C74222C3630313630292C676C6F62653A686E2822676C6F6265222C3630313631292C677261626265723A686E2822677261626265';
wwv_flow_imp.g_varchar2_table(1444) := '72222C3630313632292C67726170683A686E28226772617068222C3630313633292C677269707065723A686E282267726970706572222C3630313634292C68656172743A686E28226865617274222C3630313635292C686F6D653A686E2822686F6D6522';
wwv_flow_imp.g_varchar2_table(1445) := '2C3630313636292C686F72697A6F6E74616C52756C653A686E2822686F72697A6F6E74616C2D72756C65222C3630313637292C6875626F743A686E28226875626F74222C3630313638292C696E626F783A686E2822696E626F78222C3630313639292C69';
wwv_flow_imp.g_varchar2_table(1446) := '7373756552656F70656E65643A686E282269737375652D72656F70656E6564222C3630313731292C6973737565733A686E2822697373756573222C3630313732292C6974616C69633A686E28226974616C6963222C3630313733292C6A65727365793A68';
wwv_flow_imp.g_varchar2_table(1447) := '6E28226A6572736579222C3630313734292C6A736F6E3A686E28226A736F6E222C3630313735292C6B65626162566572746963616C3A686E28226B656261622D766572746963616C222C3630313736292C6B65793A686E28226B6579222C363031373729';
wwv_flow_imp.g_varchar2_table(1448) := '2C6C61773A686E28226C6177222C3630313738292C6C6967687462756C624175746F6669783A686E28226C6967687462756C622D6175746F666978222C3630313739292C6C696E6B45787465726E616C3A686E28226C696E6B2D65787465726E616C222C';
wwv_flow_imp.g_varchar2_table(1449) := '3630313830292C6C696E6B3A686E28226C696E6B222C3630313831292C6C6973744F7264657265643A686E28226C6973742D6F726465726564222C3630313832292C6C697374556E6F7264657265643A686E28226C6973742D756E6F726465726564222C';
wwv_flow_imp.g_varchar2_table(1450) := '3630313833292C6C69766553686172653A686E28226C6976652D7368617265222C3630313834292C6C6F6164696E673A686E28226C6F6164696E67222C3630313835292C6C6F636174696F6E3A686E28226C6F636174696F6E222C3630313836292C6D61';
wwv_flow_imp.g_varchar2_table(1451) := '696C526561643A686E28226D61696C2D72656164222C3630313837292C6D61696C3A686E28226D61696C222C3630313838292C6D61726B646F776E3A686E28226D61726B646F776E222C3630313839292C6D65676170686F6E653A686E28226D65676170';
wwv_flow_imp.g_varchar2_table(1452) := '686F6E65222C3630313930292C6D656E74696F6E3A686E28226D656E74696F6E222C3630313931292C6D696C6573746F6E653A686E28226D696C6573746F6E65222C3630313932292C67697450756C6C526571756573744D696C6573746F6E653A686E28';
wwv_flow_imp.g_varchar2_table(1453) := '226769742D70756C6C2D726571756573742D6D696C6573746F6E65222C3630313932292C6D6F72746172426F6172643A686E28226D6F727461722D626F617264222C3630313933292C6D6F76653A686E28226D6F7665222C3630313934292C6D756C7469';
wwv_flow_imp.g_varchar2_table(1454) := '706C6557696E646F77733A686E28226D756C7469706C652D77696E646F7773222C3630313935292C6D7574653A686E28226D757465222C3630313936292C6E6F4E65776C696E653A686E28226E6F2D6E65776C696E65222C3630313937292C6E6F74653A';
wwv_flow_imp.g_varchar2_table(1455) := '686E28226E6F7465222C3630313938292C6F63746F666163653A686E28226F63746F66616365222C3630313939292C6F70656E507265766965773A686E28226F70656E2D70726576696577222C3630323030292C7061636B6167653A686E28227061636B';
wwv_flow_imp.g_varchar2_table(1456) := '616765222C3630323031292C7061696E7463616E3A686E28227061696E7463616E222C3630323032292C70696E3A686E282270696E222C3630323033292C706C61793A686E2822706C6179222C3630323034292C72756E3A686E282272756E222C363032';
wwv_flow_imp.g_varchar2_table(1457) := '3034292C706C75673A686E2822706C7567222C3630323035292C7072657365727665436173653A686E282270726573657276652D63617365222C3630323036292C707265766965773A686E282270726576696577222C3630323037292C70726F6A656374';
wwv_flow_imp.g_varchar2_table(1458) := '3A686E282270726F6A656374222C3630323038292C70756C73653A686E282270756C7365222C3630323039292C7175657374696F6E3A686E28227175657374696F6E222C3630323130292C71756F74653A686E282271756F7465222C3630323131292C72';
wwv_flow_imp.g_varchar2_table(1459) := '6164696F546F7765723A686E2822726164696F2D746F776572222C3630323132292C7265616374696F6E733A686E28227265616374696F6E73222C3630323133292C7265666572656E6365733A686E28227265666572656E636573222C3630323134292C';
wwv_flow_imp.g_varchar2_table(1460) := '726566726573683A686E282272656672657368222C3630323135292C72656765783A686E28227265676578222C3630323136292C72656D6F74654578706C6F7265723A686E282272656D6F74652D6578706C6F726572222C3630323137292C72656D6F74';
wwv_flow_imp.g_varchar2_table(1461) := '653A686E282272656D6F7465222C3630323138292C72656D6F76653A686E282272656D6F7665222C3630323139292C7265706C616365416C6C3A686E28227265706C6163652D616C6C222C3630323230292C7265706C6163653A686E28227265706C6163';
wwv_flow_imp.g_varchar2_table(1462) := '65222C3630323231292C7265706F436C6F6E653A686E28227265706F2D636C6F6E65222C3630323232292C7265706F466F726365507573683A686E28227265706F2D666F7263652D70757368222C3630323233292C7265706F50756C6C3A686E28227265';
wwv_flow_imp.g_varchar2_table(1463) := '706F2D70756C6C222C3630323234292C7265706F507573683A686E28227265706F2D70757368222C3630323235292C7265706F72743A686E28227265706F7274222C3630323236292C726571756573744368616E6765733A686E2822726571756573742D';
wwv_flow_imp.g_varchar2_table(1464) := '6368616E676573222C3630323237292C726F636B65743A686E2822726F636B6574222C3630323238292C726F6F74466F6C6465724F70656E65643A686E2822726F6F742D666F6C6465722D6F70656E6564222C3630323239292C726F6F74466F6C646572';
wwv_flow_imp.g_varchar2_table(1465) := '3A686E2822726F6F742D666F6C646572222C3630323330292C7273733A686E2822727373222C3630323331292C727562793A686E282272756279222C3630323332292C73617665416C6C3A686E2822736176652D616C6C222C3630323333292C73617665';
wwv_flow_imp.g_varchar2_table(1466) := '41733A686E2822736176652D6173222C3630323334292C736176653A686E282273617665222C3630323335292C73637265656E46756C6C3A686E282273637265656E2D66756C6C222C3630323336292C73637265656E4E6F726D616C3A686E2822736372';
wwv_flow_imp.g_varchar2_table(1467) := '65656E2D6E6F726D616C222C3630323337292C73656172636853746F703A686E28227365617263682D73746F70222C3630323338292C7365727665723A686E2822736572766572222C3630323430292C73657474696E6773476561723A686E2822736574';
wwv_flow_imp.g_varchar2_table(1468) := '74696E67732D67656172222C3630323431292C73657474696E67733A686E282273657474696E6773222C3630323432292C736869656C643A686E2822736869656C64222C3630323433292C736D696C65793A686E2822736D696C6579222C363032343429';
wwv_flow_imp.g_varchar2_table(1469) := '2C736F7274507265636564656E63653A686E2822736F72742D707265636564656E6365222C3630323435292C73706C6974486F72697A6F6E74616C3A686E282273706C69742D686F72697A6F6E74616C222C3630323436292C73706C6974566572746963';
wwv_flow_imp.g_varchar2_table(1470) := '616C3A686E282273706C69742D766572746963616C222C3630323437292C737175697272656C3A686E2822737175697272656C222C3630323438292C7374617246756C6C3A686E2822737461722D66756C6C222C3630323439292C7374617248616C663A';
wwv_flow_imp.g_varchar2_table(1471) := '686E2822737461722D68616C66222C3630323530292C73796D626F6C436C6173733A686E282273796D626F6C2D636C617373222C3630323531292C73796D626F6C436F6C6F723A686E282273796D626F6C2D636F6C6F72222C3630323532292C73796D62';
wwv_flow_imp.g_varchar2_table(1472) := '6F6C436F6E7374616E743A686E282273796D626F6C2D636F6E7374616E74222C3630323533292C73796D626F6C456E756D4D656D6265723A686E282273796D626F6C2D656E756D2D6D656D626572222C3630323534292C73796D626F6C4669656C643A68';
wwv_flow_imp.g_varchar2_table(1473) := '6E282273796D626F6C2D6669656C64222C3630323535292C73796D626F6C46696C653A686E282273796D626F6C2D66696C65222C3630323536292C73796D626F6C496E746572666163653A686E282273796D626F6C2D696E74657266616365222C363032';
wwv_flow_imp.g_varchar2_table(1474) := '3537292C73796D626F6C4B6579776F72643A686E282273796D626F6C2D6B6579776F7264222C3630323538292C73796D626F6C4D6973633A686E282273796D626F6C2D6D697363222C3630323539292C73796D626F6C4F70657261746F723A686E282273';
wwv_flow_imp.g_varchar2_table(1475) := '796D626F6C2D6F70657261746F72222C3630323630292C73796D626F6C50726F70657274793A686E282273796D626F6C2D70726F7065727479222C3630323631292C7772656E63683A686E28227772656E6368222C3630323631292C7772656E63685375';
wwv_flow_imp.g_varchar2_table(1476) := '62616374696F6E3A686E28227772656E63682D737562616374696F6E222C3630323631292C73796D626F6C536E69707065743A686E282273796D626F6C2D736E6970706574222C3630323632292C7461736B6C6973743A686E28227461736B6C69737422';
wwv_flow_imp.g_varchar2_table(1477) := '2C3630323633292C74656C6573636F70653A686E282274656C6573636F7065222C3630323634292C7465787453697A653A686E2822746578742D73697A65222C3630323635292C7468726565426172733A686E282274687265652D62617273222C363032';
wwv_flow_imp.g_varchar2_table(1478) := '3636292C7468756D6273646F776E3A686E28227468756D6273646F776E222C3630323637292C7468756D627375703A686E28227468756D62737570222C3630323638292C746F6F6C733A686E2822746F6F6C73222C3630323639292C747269616E676C65';
wwv_flow_imp.g_varchar2_table(1479) := '446F776E3A686E2822747269616E676C652D646F776E222C3630323730292C747269616E676C654C6566743A686E2822747269616E676C652D6C656674222C3630323731292C747269616E676C6552696768743A686E2822747269616E676C652D726967';
wwv_flow_imp.g_varchar2_table(1480) := '6874222C3630323732292C747269616E676C6555703A686E2822747269616E676C652D7570222C3630323733292C747769747465723A686E282274776974746572222C3630323734292C756E666F6C643A686E2822756E666F6C64222C3630323735292C';
wwv_flow_imp.g_varchar2_table(1481) := '756E6C6F636B3A686E2822756E6C6F636B222C3630323736292C756E6D7574653A686E2822756E6D757465222C3630323737292C756E76657269666965643A686E2822756E7665726966696564222C3630323738292C76657269666965643A686E282276';
wwv_flow_imp.g_varchar2_table(1482) := '65726966696564222C3630323739292C76657273696F6E733A686E282276657273696F6E73222C3630323830292C766D4163746976653A686E2822766D2D616374697665222C3630323831292C766D4F75746C696E653A686E2822766D2D6F75746C696E';
wwv_flow_imp.g_varchar2_table(1483) := '65222C3630323832292C766D52756E6E696E673A686E2822766D2D72756E6E696E67222C3630323833292C77617463683A686E28227761746368222C3630323834292C776869746573706163653A686E282277686974657370616365222C363032383529';
wwv_flow_imp.g_varchar2_table(1484) := '2C77686F6C65576F72643A686E282277686F6C652D776F7264222C3630323836292C77696E646F773A686E282277696E646F77222C3630323837292C776F7264577261703A686E2822776F72642D77726170222C3630323838292C7A6F6F6D496E3A686E';
wwv_flow_imp.g_varchar2_table(1485) := '28227A6F6F6D2D696E222C3630323839292C7A6F6F6D4F75743A686E28227A6F6F6D2D6F7574222C3630323930292C6C69737446696C7465723A686E28226C6973742D66696C746572222C3630323931292C6C697374466C61743A686E28226C6973742D';
wwv_flow_imp.g_varchar2_table(1486) := '666C6174222C3630323932292C6C69737453656C656374696F6E3A686E28226C6973742D73656C656374696F6E222C3630323933292C73656C656374696F6E3A686E282273656C656374696F6E222C3630323933292C6C697374547265653A686E28226C';
wwv_flow_imp.g_varchar2_table(1487) := '6973742D74726565222C3630323934292C6465627567427265616B706F696E7446756E6374696F6E556E76657269666965643A686E282264656275672D627265616B706F696E742D66756E6374696F6E2D756E7665726966696564222C3630323935292C';
wwv_flow_imp.g_varchar2_table(1488) := '6465627567427265616B706F696E7446756E6374696F6E3A686E282264656275672D627265616B706F696E742D66756E6374696F6E222C3630323936292C6465627567427265616B706F696E7446756E6374696F6E44697361626C65643A686E28226465';
wwv_flow_imp.g_varchar2_table(1489) := '6275672D627265616B706F696E742D66756E6374696F6E2D64697361626C6564222C3630323936292C6465627567537461636B6672616D654163746976653A686E282264656275672D737461636B6672616D652D616374697665222C3630323937292C63';
wwv_flow_imp.g_varchar2_table(1490) := '6972636C65536D616C6C46696C6C65643A686E2822636972636C652D736D616C6C2D66696C6C6564222C3630323938292C6465627567537461636B6672616D65446F743A686E282264656275672D737461636B6672616D652D646F74222C363032393829';
wwv_flow_imp.g_varchar2_table(1491) := '2C7465726D696E616C4465636F726174696F6E4D61726B3A686E28227465726D696E616C2D6465636F726174696F6E2D6D61726B222C3630323938292C6465627567537461636B6672616D653A686E282264656275672D737461636B6672616D65222C36';
wwv_flow_imp.g_varchar2_table(1492) := '30323939292C6465627567537461636B6672616D65466F63757365643A686E282264656275672D737461636B6672616D652D666F6375736564222C3630323939292C6465627567427265616B706F696E74556E737570706F727465643A686E2822646562';
wwv_flow_imp.g_varchar2_table(1493) := '75672D627265616B706F696E742D756E737570706F72746564222C3630333030292C73796D626F6C537472696E673A686E282273796D626F6C2D737472696E67222C3630333031292C646562756752657665727365436F6E74696E75653A686E28226465';
wwv_flow_imp.g_varchar2_table(1494) := '6275672D726576657273652D636F6E74696E7565222C3630333032292C6465627567537465704261636B3A686E282264656275672D737465702D6261636B222C3630333033292C6465627567526573746172744672616D653A686E282264656275672D72';
wwv_flow_imp.g_varchar2_table(1495) := '6573746172742D6672616D65222C3630333034292C6465627567416C743A686E282264656275672D616C74222C3630333035292C63616C6C496E636F6D696E673A686E282263616C6C2D696E636F6D696E67222C3630333036292C63616C6C4F7574676F';
wwv_flow_imp.g_varchar2_table(1496) := '696E673A686E282263616C6C2D6F7574676F696E67222C3630333037292C6D656E753A686E28226D656E75222C3630333038292C657870616E64416C6C3A686E2822657870616E642D616C6C222C3630333039292C666565646261636B3A686E28226665';
wwv_flow_imp.g_varchar2_table(1497) := '65646261636B222C3630333130292C67697450756C6C5265717565737452657669657765723A686E28226769742D70756C6C2D726571756573742D7265766965776572222C3630333130292C67726F75704279526566547970653A686E282267726F7570';
wwv_flow_imp.g_varchar2_table(1498) := '2D62792D7265662D74797065222C3630333131292C756E67726F75704279526566547970653A686E2822756E67726F75702D62792D7265662D74797065222C3630333132292C6163636F756E743A686E28226163636F756E74222C3630333133292C6769';
wwv_flow_imp.g_varchar2_table(1499) := '7450756C6C5265717565737441737369676E65653A686E28226769742D70756C6C2D726571756573742D61737369676E6565222C3630333133292C62656C6C446F743A686E282262656C6C2D646F74222C3630333134292C6465627567436F6E736F6C65';
wwv_flow_imp.g_varchar2_table(1500) := '3A686E282264656275672D636F6E736F6C65222C3630333135292C6C6962726172793A686E28226C696272617279222C3630333136292C6F75747075743A686E28226F7574707574222C3630333137292C72756E416C6C3A686E282272756E2D616C6C22';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '2C3630333138292C73796E6349676E6F7265643A686E282273796E632D69676E6F726564222C3630333139292C70696E6E65643A686E282270696E6E6564222C3630333230292C676974687562496E7665727465643A686E28226769746875622D696E76';
wwv_flow_imp.g_varchar2_table(1502) := '6572746564222C3630333231292C73657276657250726F636573733A686E28227365727665722D70726F63657373222C3630333232292C736572766572456E7669726F6E6D656E743A686E28227365727665722D656E7669726F6E6D656E74222C363033';
wwv_flow_imp.g_varchar2_table(1503) := '3233292C706173733A686E282270617373222C3630333234292C6973737565436C6F7365643A686E282269737375652D636C6F736564222C3630333234292C73746F70436972636C653A686E282273746F702D636972636C65222C3630333235292C706C';
wwv_flow_imp.g_varchar2_table(1504) := '6179436972636C653A686E2822706C61792D636972636C65222C3630333236292C7265636F72643A686E28227265636F7264222C3630333237292C6465627567416C74536D616C6C3A686E282264656275672D616C742D736D616C6C222C363033323829';
wwv_flow_imp.g_varchar2_table(1505) := '2C766D436F6E6E6563743A686E2822766D2D636F6E6E656374222C3630333239292C636C6F75643A686E2822636C6F7564222C3630333330292C6D657267653A686E28226D65726765222C3630333331292C6578706F72743A686E28226578706F727422';
wwv_flow_imp.g_varchar2_table(1506) := '2C3630333332292C67726170684C6566743A686E282267726170682D6C656674222C3630333333292C6D61676E65743A686E28226D61676E6574222C3630333334292C6E6F7465626F6F6B3A686E28226E6F7465626F6F6B222C3630333335292C726564';
wwv_flow_imp.g_varchar2_table(1507) := '6F3A686E28227265646F222C3630333336292C636865636B416C6C3A686E2822636865636B2D616C6C222C3630333337292C70696E6E656444697274793A686E282270696E6E65642D6469727479222C3630333338292C7061737346696C6C65643A686E';
wwv_flow_imp.g_varchar2_table(1508) := '2822706173732D66696C6C6564222C3630333339292C636972636C654C6172676546696C6C65643A686E2822636972636C652D6C617267652D66696C6C6564222C3630333430292C636972636C654C617267653A686E2822636972636C652D6C61726765';
wwv_flow_imp.g_varchar2_table(1509) := '222C3630333431292C636972636C654C617267654F75746C696E653A686E2822636972636C652D6C617267652D6F75746C696E65222C3630333431292C636F6D62696E653A686E2822636F6D62696E65222C3630333432292C6761746865723A686E2822';
wwv_flow_imp.g_varchar2_table(1510) := '676174686572222C3630333432292C7461626C653A686E28227461626C65222C3630333433292C7661726961626C6547726F75703A686E28227661726961626C652D67726F7570222C3630333434292C747970654869657261726368793A686E28227479';
wwv_flow_imp.g_varchar2_table(1511) := '70652D686965726172636879222C3630333435292C747970654869657261726368795375623A686E2822747970652D6869657261726368792D737562222C3630333436292C7479706548696572617263687953757065723A686E2822747970652D686965';
wwv_flow_imp.g_varchar2_table(1512) := '7261726368792D7375706572222C3630333437292C67697450756C6C526571756573744372656174653A686E28226769742D70756C6C2D726571756573742D637265617465222C3630333438292C72756E41626F76653A686E282272756E2D61626F7665';
wwv_flow_imp.g_varchar2_table(1513) := '222C3630333439292C72756E42656C6F773A686E282272756E2D62656C6F77222C3630333530292C6E6F7465626F6F6B54656D706C6174653A686E28226E6F7465626F6F6B2D74656D706C617465222C3630333531292C6465627567526572756E3A686E';
wwv_flow_imp.g_varchar2_table(1514) := '282264656275672D726572756E222C3630333532292C776F726B7370616365547275737465643A686E2822776F726B73706163652D74727573746564222C3630333533292C776F726B7370616365556E747275737465643A686E2822776F726B73706163';
wwv_flow_imp.g_varchar2_table(1515) := '652D756E74727573746564222C3630333534292C776F726B7370616365556E6B6E6F776E3A686E2822776F726B73706163652D756E6B6E6F776E222C3630333535292C7465726D696E616C436D643A686E28227465726D696E616C2D636D64222C363033';
wwv_flow_imp.g_varchar2_table(1516) := '3536292C7465726D696E616C44656269616E3A686E28227465726D696E616C2D64656269616E222C3630333537292C7465726D696E616C4C696E75783A686E28227465726D696E616C2D6C696E7578222C3630333538292C7465726D696E616C506F7765';
wwv_flow_imp.g_varchar2_table(1517) := '727368656C6C3A686E28227465726D696E616C2D706F7765727368656C6C222C3630333539292C7465726D696E616C546D75783A686E28227465726D696E616C2D746D7578222C3630333630292C7465726D696E616C5562756E74753A686E2822746572';
wwv_flow_imp.g_varchar2_table(1518) := '6D696E616C2D7562756E7475222C3630333631292C7465726D696E616C426173683A686E28227465726D696E616C2D62617368222C3630333632292C6172726F77537761703A686E28226172726F772D73776170222C3630333633292C636F70793A686E';
wwv_flow_imp.g_varchar2_table(1519) := '2822636F7079222C3630333634292C706572736F6E4164643A686E2822706572736F6E2D616464222C3630333635292C66696C74657246696C6C65643A686E282266696C7465722D66696C6C6564222C3630333636292C77616E643A686E282277616E64';
wwv_flow_imp.g_varchar2_table(1520) := '222C3630333637292C64656275674C696E6542794C696E653A686E282264656275672D6C696E652D62792D6C696E65222C3630333638292C696E73706563743A686E2822696E7370656374222C3630333639292C6C61796572733A686E28226C61796572';
wwv_flow_imp.g_varchar2_table(1521) := '73222C3630333730292C6C6179657273446F743A686E28226C61796572732D646F74222C3630333731292C6C61796572734163746976653A686E28226C61796572732D616374697665222C3630333732292C636F6D706173733A686E2822636F6D706173';
wwv_flow_imp.g_varchar2_table(1522) := '73222C3630333733292C636F6D70617373446F743A686E2822636F6D706173732D646F74222C3630333734292C636F6D706173734163746976653A686E2822636F6D706173732D616374697665222C3630333735292C617A7572653A686E2822617A7572';
wwv_flow_imp.g_varchar2_table(1523) := '65222C3630333736292C697373756544726166743A686E282269737375652D6472616674222C3630333737292C67697450756C6C52657175657374436C6F7365643A686E28226769742D70756C6C2D726571756573742D636C6F736564222C3630333738';
wwv_flow_imp.g_varchar2_table(1524) := '292C67697450756C6C5265717565737444726166743A686E28226769742D70756C6C2D726571756573742D6472616674222C3630333739292C6465627567416C6C3A686E282264656275672D616C6C222C3630333830292C6465627567436F7665726167';
wwv_flow_imp.g_varchar2_table(1525) := '653A686E282264656275672D636F766572616765222C3630333831292C72756E4572726F72733A686E282272756E2D6572726F7273222C3630333832292C666F6C6465724C6962726172793A686E2822666F6C6465722D6C696272617279222C36303338';
wwv_flow_imp.g_varchar2_table(1526) := '33292C6465627567436F6E74696E7565536D616C6C3A686E282264656275672D636F6E74696E75652D736D616C6C222C3630333834292C6265616B657253746F703A686E28226265616B65722D73746F70222C3630333835292C67726170684C696E653A';
wwv_flow_imp.g_varchar2_table(1527) := '686E282267726170682D6C696E65222C3630333836292C6772617068536361747465723A686E282267726170682D73636174746572222C3630333837292C70696543686172743A686E28227069652D6368617274222C3630333838292C627261636B6574';
wwv_flow_imp.g_varchar2_table(1528) := '3A686E2822627261636B6574222C3630313735292C627261636B6574446F743A686E2822627261636B65742D646F74222C3630333839292C627261636B65744572726F723A686E2822627261636B65742D6572726F72222C3630333930292C6C6F636B53';
wwv_flow_imp.g_varchar2_table(1529) := '6D616C6C3A686E28226C6F636B2D736D616C6C222C3630333931292C617A7572654465766F70733A686E2822617A7572652D6465766F7073222C3630333932292C766572696669656446696C6C65643A686E282276657269666965642D66696C6C656422';
wwv_flow_imp.g_varchar2_table(1530) := '2C3630333933292C6E65776C696E653A686E28226E65776C696E65222C3630333934292C6C61796F75743A686E28226C61796F7574222C3630333935292C6C61796F757441637469766974796261724C6566743A686E28226C61796F75742D6163746976';
wwv_flow_imp.g_varchar2_table(1531) := '6974796261722D6C656674222C3630333936292C6C61796F7574416374697669747962617252696768743A686E28226C61796F75742D61637469766974796261722D7269676874222C3630333937292C6C61796F757450616E656C4C6566743A686E2822';
wwv_flow_imp.g_varchar2_table(1532) := '6C61796F75742D70616E656C2D6C656674222C3630333938292C6C61796F757450616E656C43656E7465723A686E28226C61796F75742D70616E656C2D63656E746572222C3630333939292C6C61796F757450616E656C4A7573746966793A686E28226C';
wwv_flow_imp.g_varchar2_table(1533) := '61796F75742D70616E656C2D6A757374696679222C3630343030292C6C61796F757450616E656C52696768743A686E28226C61796F75742D70616E656C2D7269676874222C3630343031292C6C61796F757450616E656C3A686E28226C61796F75742D70';
wwv_flow_imp.g_varchar2_table(1534) := '616E656C222C3630343032292C6C61796F7574536964656261724C6566743A686E28226C61796F75742D736964656261722D6C656674222C3630343033292C6C61796F75745369646562617252696768743A686E28226C61796F75742D73696465626172';
wwv_flow_imp.g_varchar2_table(1535) := '2D7269676874222C3630343034292C6C61796F75745374617475736261723A686E28226C61796F75742D737461747573626172222C3630343035292C6C61796F75744D656E756261723A686E28226C61796F75742D6D656E75626172222C363034303629';
wwv_flow_imp.g_varchar2_table(1536) := '2C6C61796F757443656E74657265643A686E28226C61796F75742D63656E7465726564222C3630343037292C7461726765743A686E2822746172676574222C3630343038292C696E64656E743A686E2822696E64656E74222C3630343039292C7265636F';
wwv_flow_imp.g_varchar2_table(1537) := '7264536D616C6C3A686E28227265636F72642D736D616C6C222C3630343130292C6572726F72536D616C6C3A686E28226572726F722D736D616C6C222C3630343131292C7465726D696E616C4465636F726174696F6E4572726F723A686E28227465726D';
wwv_flow_imp.g_varchar2_table(1538) := '696E616C2D6465636F726174696F6E2D6572726F72222C3630343131292C6172726F77436972636C65446F776E3A686E28226172726F772D636972636C652D646F776E222C3630343132292C6172726F77436972636C654C6566743A686E28226172726F';
wwv_flow_imp.g_varchar2_table(1539) := '772D636972636C652D6C656674222C3630343133292C6172726F77436972636C6552696768743A686E28226172726F772D636972636C652D7269676874222C3630343134292C6172726F77436972636C6555703A686E28226172726F772D636972636C65';
wwv_flow_imp.g_varchar2_table(1540) := '2D7570222C3630343135292C6C61796F75745369646562617252696768744F66663A686E28226C61796F75742D736964656261722D72696768742D6F6666222C3630343136292C6C61796F757450616E656C4F66663A686E28226C61796F75742D70616E';
wwv_flow_imp.g_varchar2_table(1541) := '656C2D6F6666222C3630343137292C6C61796F7574536964656261724C6566744F66663A686E28226C61796F75742D736964656261722D6C6566742D6F6666222C3630343138292C626C616E6B3A686E2822626C616E6B222C3630343139292C68656172';
wwv_flow_imp.g_varchar2_table(1542) := '7446696C6C65643A686E282268656172742D66696C6C6564222C3630343230292C6D61703A686E28226D6170222C3630343231292C6D6170486F72697A6F6E74616C3A686E28226D61702D686F72697A6F6E74616C222C3630343231292C666F6C64486F';
wwv_flow_imp.g_varchar2_table(1543) := '72697A6F6E74616C3A686E2822666F6C642D686F72697A6F6E74616C222C3630343231292C6D617046696C6C65643A686E28226D61702D66696C6C6564222C3630343232292C6D6170486F72697A6F6E74616C46696C6C65643A686E28226D61702D686F';
wwv_flow_imp.g_varchar2_table(1544) := '72697A6F6E74616C2D66696C6C6564222C3630343232292C666F6C64486F72697A6F6E74616C46696C6C65643A686E2822666F6C642D686F72697A6F6E74616C2D66696C6C6564222C3630343232292C636972636C65536D616C6C3A686E282263697263';
wwv_flow_imp.g_varchar2_table(1545) := '6C652D736D616C6C222C3630343233292C62656C6C536C6173683A686E282262656C6C2D736C617368222C3630343234292C62656C6C536C617368446F743A686E282262656C6C2D736C6173682D646F74222C3630343235292C636F6D6D656E74556E72';
wwv_flow_imp.g_varchar2_table(1546) := '65736F6C7665643A686E2822636F6D6D656E742D756E7265736F6C766564222C3630343236292C67697450756C6C52657175657374476F546F4368616E6765733A686E28226769742D70756C6C2D726571756573742D676F2D746F2D6368616E67657322';
wwv_flow_imp.g_varchar2_table(1547) := '2C3630343237292C67697450756C6C526571756573744E65774368616E6765733A686E28226769742D70756C6C2D726571756573742D6E65772D6368616E676573222C3630343238292C73656172636846757A7A793A686E28227365617263682D66757A';
wwv_flow_imp.g_varchar2_table(1548) := '7A79222C3630343239292C636F6D6D656E7444726166743A686E2822636F6D6D656E742D6472616674222C3630343330292C73656E643A686E282273656E64222C3630343331292C737061726B6C653A686E2822737061726B6C65222C3630343332292C';
wwv_flow_imp.g_varchar2_table(1549) := '696E736572743A686E2822696E73657274222C3630343333292C6D69633A686E28226D6963222C3630343334292C7468756D6273646F776E46696C6C65643A686E28227468756D6273646F776E2D66696C6C6564222C3630343335292C7468756D627375';
wwv_flow_imp.g_varchar2_table(1550) := '7046696C6C65643A686E28227468756D627375702D66696C6C6564222C3630343336292C636F666665653A686E2822636F66666565222C3630343337292C736E616B653A686E2822736E616B65222C3630343338292C67616D653A686E282267616D6522';
wwv_flow_imp.g_varchar2_table(1551) := '2C3630343339292C76723A686E28227672222C3630343430292C636869703A686E282263686970222C3630343431292C7069616E6F3A686E28227069616E6F222C3630343432292C6D757369633A686E28226D75736963222C3630343433292C6D696346';
wwv_flow_imp.g_varchar2_table(1552) := '696C6C65643A686E28226D69632D66696C6C6564222C3630343434292C7265706F46657463683A686E28227265706F2D6665746368222C3630343435292C636F70696C6F743A686E2822636F70696C6F74222C3630343436292C6C6967687462756C6253';
wwv_flow_imp.g_varchar2_table(1553) := '7061726B6C653A686E28226C6967687462756C622D737061726B6C65222C3630343437292C726F626F743A686E2822726F626F74222C3630343438292C737061726B6C6546696C6C65643A686E2822737061726B6C652D66696C6C6564222C3630343439';
wwv_flow_imp.g_varchar2_table(1554) := '292C6469666653696E676C653A686E2822646966662D73696E676C65222C3630343530292C646966664D756C7469706C653A686E2822646966662D6D756C7469706C65222C3630343531292C737572726F756E64576974683A686E2822737572726F756E';
wwv_flow_imp.g_varchar2_table(1555) := '642D77697468222C3630343532292C73686172653A686E28227368617265222C3630343533292C67697453746173683A686E28226769742D7374617368222C3630343534292C67697453746173684170706C793A686E28226769742D73746173682D6170';
wwv_flow_imp.g_varchar2_table(1556) := '706C79222C3630343535292C6769745374617368506F703A686E28226769742D73746173682D706F70222C3630343536292C7673636F64653A686E28227673636F6465222C3630343537292C7673636F6465496E7369646572733A686E28227673636F64';
wwv_flow_imp.g_varchar2_table(1557) := '652D696E736964657273222C3630343538292C636F64654F73733A686E2822636F64652D6F7373222C3630343539292C72756E436F7665726167653A686E282272756E2D636F766572616765222C3630343630292C72756E416C6C436F7665726167653A';
wwv_flow_imp.g_varchar2_table(1558) := '686E282272756E2D616C6C2D636F766572616765222C3630343631292C636F7665726167653A686E2822636F766572616765222C3630343632292C67697468756250726F6A6563743A686E28226769746875622D70726F6A656374222C3630343633292C';
wwv_flow_imp.g_varchar2_table(1559) := '6D6170566572746963616C3A686E28226D61702D766572746963616C222C3630343634292C666F6C64566572746963616C3A686E2822666F6C642D766572746963616C222C3630343634292C6D6170566572746963616C46696C6C65643A686E28226D61';
wwv_flow_imp.g_varchar2_table(1560) := '702D766572746963616C2D66696C6C6564222C3630343635292C666F6C64566572746963616C46696C6C65643A686E2822666F6C642D766572746963616C2D66696C6C6564222C3630343635292C676F546F5365617263683A686E2822676F2D746F2D73';
wwv_flow_imp.g_varchar2_table(1561) := '6561726368222C3630343636292C70657263656E746167653A686E282270657263656E74616765222C3630343637292C736F727450657263656E746167653A686E2822736F72742D70657263656E74616765222C3630343637292C6469616C6F67457272';
wwv_flow_imp.g_varchar2_table(1562) := '6F723A686E28226469616C6F672D6572726F72222C226572726F7222292C6469616C6F675761726E696E673A686E28226469616C6F672D7761726E696E67222C227761726E696E6722292C6469616C6F67496E666F3A686E28226469616C6F672D696E66';
wwv_flow_imp.g_varchar2_table(1563) := '6F222C22696E666F22292C6469616C6F67436C6F73653A686E28226469616C6F672D636C6F7365222C22636C6F736522292C747265654974656D457870616E6465643A686E2822747265652D6974656D2D657870616E646564222C2263686576726F6E2D';
wwv_flow_imp.g_varchar2_table(1564) := '646F776E22292C7472656546696C7465724F6E547970654F6E3A686E2822747265652D66696C7465722D6F6E2D747970652D6F6E222C226C6973742D66696C74657222292C7472656546696C7465724F6E547970654F66663A686E2822747265652D6669';
wwv_flow_imp.g_varchar2_table(1565) := '6C7465722D6F6E2D747970652D6F6666222C226C6973742D73656C656374696F6E22292C7472656546696C746572436C6561723A686E2822747265652D66696C7465722D636C656172222C22636C6F736522292C747265654974656D4C6F6164696E673A';
wwv_flow_imp.g_varchar2_table(1566) := '686E2822747265652D6974656D2D6C6F6164696E67222C226C6F6164696E6722292C6D656E7553656C656374696F6E3A686E28226D656E752D73656C656374696F6E222C22636865636B22292C6D656E755375626D656E753A686E28226D656E752D7375';
wwv_flow_imp.g_varchar2_table(1567) := '626D656E75222C2263686576726F6E2D726967687422292C6D656E754261724D6F72653A686E28226D656E756261722D6D6F7265222C226D6F726522292C7363726F6C6C626172427574746F6E4C6566743A686E28227363726F6C6C6261722D62757474';
wwv_flow_imp.g_varchar2_table(1568) := '6F6E2D6C656674222C22747269616E676C652D6C65667422292C7363726F6C6C626172427574746F6E52696768743A686E28227363726F6C6C6261722D627574746F6E2D7269676874222C22747269616E676C652D726967687422292C7363726F6C6C62';
wwv_flow_imp.g_varchar2_table(1569) := '6172427574746F6E55703A686E28227363726F6C6C6261722D627574746F6E2D7570222C22747269616E676C652D757022292C7363726F6C6C626172427574746F6E446F776E3A686E28227363726F6C6C6261722D627574746F6E2D646F776E222C2274';
wwv_flow_imp.g_varchar2_table(1570) := '7269616E676C652D646F776E22292C746F6F6C4261724D6F72653A686E2822746F6F6C6261722D6D6F7265222C226D6F726522292C717569636B496E7075744261636B3A686E2822717569636B2D696E7075742D6261636B222C226172726F772D6C6566';
wwv_flow_imp.g_varchar2_table(1571) := '7422292C64726F70446F776E427574746F6E3A686E282264726F702D646F776E2D627574746F6E222C3630303834292C73796D626F6C437573746F6D436F6C6F723A686E282273796D626F6C2D637573746F6D636F6C6F72222C3630323532292C657870';
wwv_flow_imp.g_varchar2_table(1572) := '6F727449636F6E3A686E28226578706F7274222C3630333332292C776F726B7370616365556E7370656369666965643A686E2822776F726B73706163652D756E737065636966696564222C3630333535292C6E65774C696E653A686E28226E65776C696E';
wwv_flow_imp.g_varchar2_table(1573) := '65222C3630333934292C7468756D6273446F776E46696C6C65643A686E28227468756D6273646F776E2D66696C6C6564222C3630343335292C7468756D6273557046696C6C65643A686E28227468756D627375702D66696C6C6564222C3630343336292C';
wwv_flow_imp.g_varchar2_table(1574) := '67697446657463683A686E28226769742D6665746368222C3630343435292C6C6967687462756C62537061726B6C654175746F6669783A686E28226C6967687462756C622D737061726B6C652D6175746F666978222C3630343437292C64656275674272';
wwv_flow_imp.g_varchar2_table(1575) := '65616B706F696E7450656E64696E673A686E282264656275672D627265616B706F696E742D70656E64696E67222C3630333737297D3B636C61737320646E20657874656E647320677B6765742069735265736F6C76656428297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(1576) := '732E5F69735265736F6C7665647D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F72656769737472793D652C746869732E5F6C616E677561676549643D742C746869732E5F666163746F72793D6E2C746869732E5F69';
wwv_flow_imp.g_varchar2_table(1577) := '73446973706F7365643D21312C746869732E5F7265736F6C766550726F6D6973653D6E756C6C2C746869732E5F69735265736F6C7665643D21317D646973706F736528297B746869732E5F6973446973706F7365643D21302C73757065722E646973706F';
wwv_flow_imp.g_varchar2_table(1578) := '736528297D6173796E63207265736F6C766528297B72657475726E20746869732E5F7265736F6C766550726F6D6973657C7C28746869732E5F7265736F6C766550726F6D6973653D746869732E5F6372656174652829292C746869732E5F7265736F6C76';
wwv_flow_imp.g_varchar2_table(1579) := '6550726F6D6973657D6173796E63205F63726561746528297B636F6E737420653D617761697420746869732E5F666163746F72792E746F6B656E697A6174696F6E537570706F72743B746869732E5F69735265736F6C7665643D21302C65262621746869';
wwv_flow_imp.g_varchar2_table(1580) := '732E5F6973446973706F7365642626746869732E5F726567697374657228746869732E5F72656769737472792E726567697374657228746869732E5F6C616E677561676549642C6529297D7D76617220756E2C6D6E2C706E2C666E2C676E2C626E2C5F6E';
wwv_flow_imp.g_varchar2_table(1581) := '2C766E2C776E2C796E2C546E2C6B6E2C536E2C786E2C4C6E2C436E2C456E2C416E2C526E2C4D6E2C4E6E2C496E2C7A6E2C556E2C486E2C446E2C4F6E2C576E2C506E2C716E2C466E2C426E2C566E2C4B6E2C6A6E2C476E2C246E2C586E2C4A6E2C596E2C';
wwv_flow_imp.g_varchar2_table(1582) := '516E2C5A6E2C65692C74692C6E692C69692C72692C6F692C61692C73692C6C692C68692C63692C64692C75692C6D692C70692C66692C67692C62692C5F692C76692C77693B2166756E6374696F6E2865297B655B652E496E6372656173653D305D3D2249';
wwv_flow_imp.g_varchar2_table(1583) := '6E637265617365222C655B652E44656372656173653D315D3D224465637265617365227D28756E7C7C28756E3D7B7D29292C66756E6374696F6E2865297B636F6E737420743D6E6577204D61703B742E73657428302C636E2E73796D626F6C4D6574686F';
wwv_flow_imp.g_varchar2_table(1584) := '64292C742E73657428312C636E2E73796D626F6C46756E6374696F6E292C742E73657428322C636E2E73796D626F6C436F6E7374727563746F72292C742E73657428332C636E2E73796D626F6C4669656C64292C742E73657428342C636E2E73796D626F';
wwv_flow_imp.g_varchar2_table(1585) := '6C5661726961626C65292C742E73657428352C636E2E73796D626F6C436C617373292C742E73657428362C636E2E73796D626F6C537472756374292C742E73657428372C636E2E73796D626F6C496E74657266616365292C742E73657428382C636E2E73';
wwv_flow_imp.g_varchar2_table(1586) := '796D626F6C4D6F64756C65292C742E73657428392C636E2E73796D626F6C50726F7065727479292C742E7365742831302C636E2E73796D626F6C4576656E74292C742E7365742831312C636E2E73796D626F6C4F70657261746F72292C742E7365742831';
wwv_flow_imp.g_varchar2_table(1587) := '322C636E2E73796D626F6C556E6974292C742E7365742831332C636E2E73796D626F6C56616C7565292C742E7365742831352C636E2E73796D626F6C456E756D292C742E7365742831342C636E2E73796D626F6C436F6E7374616E74292C742E73657428';
wwv_flow_imp.g_varchar2_table(1588) := '31352C636E2E73796D626F6C456E756D292C742E7365742831362C636E2E73796D626F6C456E756D4D656D626572292C742E7365742831372C636E2E73796D626F6C4B6579776F7264292C742E7365742832372C636E2E73796D626F6C536E6970706574';
wwv_flow_imp.g_varchar2_table(1589) := '292C742E7365742831382C636E2E73796D626F6C54657874292C742E7365742831392C636E2E73796D626F6C436F6C6F72292C742E7365742832302C636E2E73796D626F6C46696C65292C742E7365742832312C636E2E73796D626F6C5265666572656E';
wwv_flow_imp.g_varchar2_table(1590) := '6365292C742E7365742832322C636E2E73796D626F6C437573746F6D436F6C6F72292C742E7365742832332C636E2E73796D626F6C466F6C646572292C742E7365742832342C636E2E73796D626F6C54797065506172616D65746572292C742E73657428';
wwv_flow_imp.g_varchar2_table(1591) := '32352C636E2E6163636F756E74292C742E7365742832362C636E2E697373756573292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865293B72657475726E206E7C7C28636F6E736F6C652E696E666F28224E6F2063';
wwv_flow_imp.g_varchar2_table(1592) := '6F6469636F6E20666F756E6420666F7220436F6D706C6574696F6E4974656D4B696E6420222B65292C6E3D636E2E73796D626F6C50726F7065727479292C6E7D3B636F6E7374206E3D6E6577204D61703B6E2E73657428226D6574686F64222C30292C6E';
wwv_flow_imp.g_varchar2_table(1593) := '2E736574282266756E6374696F6E222C31292C6E2E7365742822636F6E7374727563746F72222C32292C6E2E73657428226669656C64222C33292C6E2E73657428227661726961626C65222C34292C6E2E7365742822636C617373222C35292C6E2E7365';
wwv_flow_imp.g_varchar2_table(1594) := '742822737472756374222C36292C6E2E7365742822696E74657266616365222C37292C6E2E73657428226D6F64756C65222C38292C6E2E736574282270726F7065727479222C39292C6E2E73657428226576656E74222C3130292C6E2E73657428226F70';
wwv_flow_imp.g_varchar2_table(1595) := '657261746F72222C3131292C6E2E7365742822756E6974222C3132292C6E2E736574282276616C7565222C3133292C6E2E7365742822636F6E7374616E74222C3134292C6E2E7365742822656E756D222C3135292C6E2E7365742822656E756D2D6D656D';
wwv_flow_imp.g_varchar2_table(1596) := '626572222C3136292C6E2E7365742822656E756D4D656D626572222C3136292C6E2E73657428226B6579776F7264222C3137292C6E2E7365742822736E6970706574222C3237292C6E2E736574282274657874222C3138292C6E2E7365742822636F6C6F';
wwv_flow_imp.g_varchar2_table(1597) := '72222C3139292C6E2E736574282266696C65222C3230292C6E2E73657428227265666572656E6365222C3231292C6E2E7365742822637573746F6D636F6C6F72222C3232292C6E2E7365742822666F6C646572222C3233292C6E2E736574282274797065';
wwv_flow_imp.g_varchar2_table(1598) := '2D706172616D65746572222C3234292C6E2E736574282274797065506172616D65746572222C3234292C6E2E73657428226163636F756E74222C3235292C6E2E73657428226973737565222C3236292C652E66726F6D537472696E673D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1599) := '6E28652C74297B6C657420693D6E2E6765742865293B72657475726E20766F69642030213D3D697C7C747C7C28693D39292C697D7D286D6E7C7C286D6E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D22417574';
wwv_flow_imp.g_varchar2_table(1600) := '6F6D61746963222C655B652E4578706C696369743D315D3D224578706C69636974227D28706E7C7C28706E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B652E506173746541';
wwv_flow_imp.g_varchar2_table(1601) := '733D315D3D2250617374654173227D28666E7C7C28666E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E547269676765724368617261637465723D325D3D225472696767657243686172';
wwv_flow_imp.g_varchar2_table(1602) := '6163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E6765227D28676E7C7C28676E3D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E526561643D315D';
wwv_flow_imp.g_varchar2_table(1603) := '3D2252656164222C655B652E57726974653D325D3D225772697465227D28626E7C7C28626E3D7B7D29292C5228302C22617272617922292C5228302C22626F6F6C65616E22292C5228302C22636C61737322292C5228302C22636F6E7374616E7422292C';
wwv_flow_imp.g_varchar2_table(1604) := '5228302C22636F6E7374727563746F7222292C5228302C22656E756D65726174696F6E22292C5228302C22656E756D65726174696F6E206D656D62657222292C5228302C226576656E7422292C5228302C226669656C6422292C5228302C2266696C6522';
wwv_flow_imp.g_varchar2_table(1605) := '292C5228302C2266756E6374696F6E22292C5228302C22696E7465726661636522292C5228302C226B657922292C5228302C226D6574686F6422292C5228302C226D6F64756C6522292C5228302C226E616D65737061636522292C5228302C226E756C6C';
wwv_flow_imp.g_varchar2_table(1606) := '22292C5228302C226E756D62657222292C5228302C226F626A65637422292C5228302C226F70657261746F7222292C5228302C227061636B61676522292C5228302C2270726F706572747922292C5228302C22737472696E6722292C5228302C22737472';
wwv_flow_imp.g_varchar2_table(1607) := '75637422292C5228302C227479706520706172616D6574657222292C5228302C227661726961626C6522292C66756E6374696F6E2865297B636F6E737420743D6E6577204D61703B742E73657428302C636E2E73796D626F6C46696C65292C742E736574';
wwv_flow_imp.g_varchar2_table(1608) := '28312C636E2E73796D626F6C4D6F64756C65292C742E73657428322C636E2E73796D626F6C4E616D657370616365292C742E73657428332C636E2E73796D626F6C5061636B616765292C742E73657428342C636E2E73796D626F6C436C617373292C742E';
wwv_flow_imp.g_varchar2_table(1609) := '73657428352C636E2E73796D626F6C4D6574686F64292C742E73657428362C636E2E73796D626F6C50726F7065727479292C742E73657428372C636E2E73796D626F6C4669656C64292C742E73657428382C636E2E73796D626F6C436F6E737472756374';
wwv_flow_imp.g_varchar2_table(1610) := '6F72292C742E73657428392C636E2E73796D626F6C456E756D292C742E7365742831302C636E2E73796D626F6C496E74657266616365292C742E7365742831312C636E2E73796D626F6C46756E6374696F6E292C742E7365742831322C636E2E73796D62';
wwv_flow_imp.g_varchar2_table(1611) := '6F6C5661726961626C65292C742E7365742831332C636E2E73796D626F6C436F6E7374616E74292C742E7365742831342C636E2E73796D626F6C537472696E67292C742E7365742831352C636E2E73796D626F6C4E756D626572292C742E736574283136';
wwv_flow_imp.g_varchar2_table(1612) := '2C636E2E73796D626F6C426F6F6C65616E292C742E7365742831372C636E2E73796D626F6C4172726179292C742E7365742831382C636E2E73796D626F6C4F626A656374292C742E7365742831392C636E2E73796D626F6C4B6579292C742E7365742832';
wwv_flow_imp.g_varchar2_table(1613) := '302C636E2E73796D626F6C4E756C6C292C742E7365742832312C636E2E73796D626F6C456E756D4D656D626572292C742E7365742832322C636E2E73796D626F6C537472756374292C742E7365742832332C636E2E73796D626F6C4576656E74292C742E';
wwv_flow_imp.g_varchar2_table(1614) := '7365742832342C636E2E73796D626F6C4F70657261746F72292C742E7365742832352C636E2E73796D626F6C54797065506172616D65746572292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865293B7265747572';
wwv_flow_imp.g_varchar2_table(1615) := '6E206E7C7C28636F6E736F6C652E696E666F28224E6F20636F6469636F6E20666F756E6420666F722053796D626F6C4B696E6420222B65292C6E3D636E2E73796D626F6C50726F7065727479292C6E7D7D285F6E7C7C285F6E3D7B7D29293B636C617373';
wwv_flow_imp.g_varchar2_table(1616) := '2079697B7374617469632066726F6D56616C75652865297B7377697463682865297B6361736522636F6D6D656E74223A72657475726E2079692E436F6D6D656E743B6361736522696D706F727473223A72657475726E2079692E496D706F7274733B6361';
wwv_flow_imp.g_varchar2_table(1617) := '736522726567696F6E223A72657475726E2079692E526567696F6E7D72657475726E206E65772079692865297D636F6E7374727563746F722865297B746869732E76616C75653D657D7D79692E436F6D6D656E743D6E65772079692822636F6D6D656E74';
wwv_flow_imp.g_varchar2_table(1618) := '22292C79692E496D706F7274733D6E65772079692822696D706F72747322292C79692E526567696F6E3D6E65772079692822726567696F6E22292C66756E6374696F6E2865297B655B652E414947656E6572617465643D315D3D22414947656E65726174';
wwv_flow_imp.g_varchar2_table(1619) := '6564227D28766E7C7C28766E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D28776E7C7C28776E3D7B7D29292C66756E63';
wwv_flow_imp.g_varchar2_table(1620) := '74696F6E2865297B652E69733D66756E6374696F6E2865297B72657475726E212821657C7C226F626A65637422213D747970656F66206529262622737472696E67223D3D747970656F6620652E6964262622737472696E67223D3D747970656F6620652E';
wwv_flow_imp.g_varchar2_table(1621) := '7469746C657D7D28796E7C7C28796E3D7B7D29292C66756E6374696F6E2865297B655B652E547970653D315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D28546E7C7C28546E3D7B7D29292C6E65772063';
wwv_flow_imp.g_varchar2_table(1622) := '6C6173737B636F6E7374727563746F7228297B746869732E5F746F6B656E697A6174696F6E537570706F7274733D6E6577204D61702C746869732E5F666163746F726965733D6E6577204D61702C746869732E5F6F6E4469644368616E67653D6E657720';
wwv_flow_imp.g_varchar2_table(1623) := '4C2C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F636F6C6F724D61703D6E756C6C7D68616E646C654368616E67652865297B746869732E5F6F6E4469644368616E67652E666972';
wwv_flow_imp.g_varchar2_table(1624) := '65287B6368616E6765644C616E6775616765733A652C6368616E676564436F6C6F724D61703A21317D297D726567697374657228652C74297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F7274732E73657428652C74292C';
wwv_flow_imp.g_varchar2_table(1625) := '746869732E68616E646C654368616E6765285B655D292C70282828293D3E7B746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865293D3D3D74262628746869732E5F746F6B656E697A6174696F6E537570706F7274732E6465';
wwv_flow_imp.g_varchar2_table(1626) := '6C6574652865292C746869732E68616E646C654368616E6765285B655D29297D29297D6765742865297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865297C7C6E756C6C7D7265676973746572466163';
wwv_flow_imp.g_varchar2_table(1627) := '746F727928652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E5F666163746F726965732E676574286529297C7C766F696420303D3D3D6E7C7C6E2E646973706F736528293B636F6E737420693D6E657720646E28746869732C652C74293B';
wwv_flow_imp.g_varchar2_table(1628) := '72657475726E20746869732E5F666163746F726965732E73657428652C69292C70282828293D3E7B636F6E737420743D746869732E5F666163746F726965732E6765742865293B742626743D3D3D69262628746869732E5F666163746F726965732E6465';
wwv_flow_imp.g_varchar2_table(1629) := '6C6574652865292C742E646973706F73652829297D29297D6173796E63206765744F724372656174652865297B636F6E737420743D746869732E6765742865293B696628742972657475726E20743B636F6E7374206E3D746869732E5F666163746F7269';
wwv_flow_imp.g_varchar2_table(1630) := '65732E6765742865293B72657475726E216E7C7C6E2E69735265736F6C7665643F6E756C6C3A286177616974206E2E7265736F6C766528292C746869732E676574286529297D69735265736F6C7665642865297B696628746869732E6765742865292972';
wwv_flow_imp.g_varchar2_table(1631) := '657475726E21303B636F6E737420743D746869732E5F666163746F726965732E6765742865293B72657475726E212874262621742E69735265736F6C766564297D736574436F6C6F724D61702865297B746869732E5F636F6C6F724D61703D652C746869';
wwv_flow_imp.g_varchar2_table(1632) := '732E5F6F6E4469644368616E67652E66697265287B6368616E6765644C616E6775616765733A41727261792E66726F6D28746869732E5F746F6B656E697A6174696F6E537570706F7274732E6B6579732829292C6368616E676564436F6C6F724D61703A';
wwv_flow_imp.g_varchar2_table(1633) := '21307D297D676574436F6C6F724D617028297B72657475726E20746869732E5F636F6C6F724D61707D67657444656661756C744261636B67726F756E6428297B72657475726E20746869732E5F636F6C6F724D61702626746869732E5F636F6C6F724D61';
wwv_flow_imp.g_varchar2_table(1634) := '702E6C656E6774683E323F746869732E5F636F6C6F724D61705B325D3A6E756C6C7D7D2C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D';
wwv_flow_imp.g_varchar2_table(1635) := '286B6E7C7C286B6E3D7B7D29292C66756E6374696F6E2865297B655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C655B652E44697361626C65643D315D3D2244697361626C6564222C655B652E456E61626C65643D325D3D22456E61626C65';
wwv_flow_imp.g_varchar2_table(1636) := '64227D28536E7C7C28536E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E4175746F3D325D3D224175746F227D28786E7C7C28786E3D7B7D29292C66756E6374696F6E2865297B655B65';
wwv_flow_imp.g_varchar2_table(1637) := '2E4E6F6E653D305D3D224E6F6E65222C655B652E4B656570576869746573706163653D315D3D224B65657057686974657370616365222C655B652E496E736572744173536E69707065743D345D3D22496E736572744173536E6970706574227D284C6E7C';
wwv_flow_imp.g_varchar2_table(1638) := '7C284C6E3D7B7D29292C66756E6374696F6E2865297B655B652E4D6574686F643D305D3D224D6574686F64222C655B652E46756E6374696F6E3D315D3D2246756E6374696F6E222C655B652E436F6E7374727563746F723D325D3D22436F6E7374727563';
wwv_flow_imp.g_varchar2_table(1639) := '746F72222C655B652E4669656C643D335D3D224669656C64222C655B652E5661726961626C653D345D3D225661726961626C65222C655B652E436C6173733D355D3D22436C617373222C655B652E5374727563743D365D3D22537472756374222C655B65';
wwv_flow_imp.g_varchar2_table(1640) := '2E496E746572666163653D375D3D22496E74657266616365222C655B652E4D6F64756C653D385D3D224D6F64756C65222C655B652E50726F70657274793D395D3D2250726F7065727479222C655B652E4576656E743D31305D3D224576656E74222C655B';
wwv_flow_imp.g_varchar2_table(1641) := '652E4F70657261746F723D31315D3D224F70657261746F72222C655B652E556E69743D31325D3D22556E6974222C655B652E56616C75653D31335D3D2256616C7565222C655B652E436F6E7374616E743D31345D3D22436F6E7374616E74222C655B652E';
wwv_flow_imp.g_varchar2_table(1642) := '456E756D3D31355D3D22456E756D222C655B652E456E756D4D656D6265723D31365D3D22456E756D4D656D626572222C655B652E4B6579776F72643D31375D3D224B6579776F7264222C655B652E546578743D31385D3D2254657874222C655B652E436F';
wwv_flow_imp.g_varchar2_table(1643) := '6C6F723D31395D3D22436F6C6F72222C655B652E46696C653D32305D3D2246696C65222C655B652E5265666572656E63653D32315D3D225265666572656E6365222C655B652E437573746F6D636F6C6F723D32325D3D22437573746F6D636F6C6F72222C';
wwv_flow_imp.g_varchar2_table(1644) := '655B652E466F6C6465723D32335D3D22466F6C646572222C655B652E54797065506172616D657465723D32345D3D2254797065506172616D65746572222C655B652E557365723D32355D3D2255736572222C655B652E49737375653D32365D3D22497373';
wwv_flow_imp.g_varchar2_table(1645) := '7565222C655B652E536E69707065743D32375D3D22536E6970706574227D28436E7C7C28436E3D7B7D29292C66756E6374696F6E2865297B655B652E446570726563617465643D315D3D2244657072656361746564227D28456E7C7C28456E3D7B7D2929';
wwv_flow_imp.g_varchar2_table(1646) := '2C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E547269676765724368617261637465723D315D3D2254726967676572436861726163746572222C655B652E54726967676572466F72496E636F6D706C';
wwv_flow_imp.g_varchar2_table(1647) := '657465436F6D706C6574696F6E733D325D3D2254726967676572466F72496E636F6D706C657465436F6D706C6574696F6E73227D28416E7C7C28416E3D7B7D29292C66756E6374696F6E2865297B655B652E45584143543D305D3D224558414354222C65';
wwv_flow_imp.g_varchar2_table(1648) := '5B652E41424F56453D315D3D2241424F5645222C655B652E42454C4F573D325D3D2242454C4F57227D28526E7C7C28526E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F745365743D305D3D224E6F74536574222C655B652E436F6E74656E';
wwv_flow_imp.g_varchar2_table(1649) := '74466C7573683D315D3D22436F6E74656E74466C757368222C655B652E5265636F76657246726F6D4D61726B6572733D325D3D225265636F76657246726F6D4D61726B657273222C655B652E4578706C696369743D335D3D224578706C69636974222C65';
wwv_flow_imp.g_varchar2_table(1650) := '5B652E50617374653D345D3D225061737465222C655B652E556E646F3D355D3D22556E646F222C655B652E5265646F3D365D3D225265646F227D284D6E7C7C284D6E3D7B7D29292C66756E6374696F6E2865297B655B652E4C463D315D3D224C46222C65';
wwv_flow_imp.g_varchar2_table(1651) := '5B652E43524C463D325D3D2243524C46227D284E6E7C7C284E6E3D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E526561643D315D3D2252656164222C655B652E57726974653D325D3D2257726974';
wwv_flow_imp.g_varchar2_table(1652) := '65227D28496E7C7C28496E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E4B6565703D315D3D224B656570222C655B652E427261636B6574733D325D3D22427261636B657473222C655B652E4164';
wwv_flow_imp.g_varchar2_table(1653) := '76616E6365643D335D3D22416476616E636564222C655B652E46756C6C3D345D3D2246756C6C227D287A6E7C7C287A6E3D7B7D29292C66756E6374696F6E2865297B655B652E61636365707453756767657374696F6E4F6E436F6D6D6974436861726163';
wwv_flow_imp.g_varchar2_table(1654) := '7465723D305D3D2261636365707453756767657374696F6E4F6E436F6D6D6974436861726163746572222C655B652E61636365707453756767657374696F6E4F6E456E7465723D315D3D2261636365707453756767657374696F6E4F6E456E746572222C';
wwv_flow_imp.g_varchar2_table(1655) := '655B652E6163636573736962696C697479537570706F72743D325D3D226163636573736962696C697479537570706F7274222C655B652E6163636573736962696C6974795061676553697A653D335D3D226163636573736962696C697479506167655369';
wwv_flow_imp.g_varchar2_table(1656) := '7A65222C655B652E617269614C6162656C3D345D3D22617269614C6162656C222C655B652E6172696152657175697265643D355D3D22617269615265717569726564222C655B652E6175746F436C6F73696E67427261636B6574733D365D3D226175746F';
wwv_flow_imp.g_varchar2_table(1657) := '436C6F73696E67427261636B657473222C655B652E6175746F436C6F73696E67436F6D6D656E74733D375D3D226175746F436C6F73696E67436F6D6D656E7473222C655B652E73637265656E526561646572416E6E6F756E6365496E6C696E6553756767';
wwv_flow_imp.g_varchar2_table(1658) := '657374696F6E3D385D3D2273637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E222C655B652E6175746F436C6F73696E6744656C6574653D395D3D226175746F436C6F73696E6744656C657465222C655B652E6175';
wwv_flow_imp.g_varchar2_table(1659) := '746F436C6F73696E674F766572747970653D31305D3D226175746F436C6F73696E674F76657274797065222C655B652E6175746F436C6F73696E6751756F7465733D31315D3D226175746F436C6F73696E6751756F746573222C655B652E6175746F496E';
wwv_flow_imp.g_varchar2_table(1660) := '64656E743D31325D3D226175746F496E64656E74222C655B652E6175746F6D617469634C61796F75743D31335D3D226175746F6D617469634C61796F7574222C655B652E6175746F537572726F756E643D31345D3D226175746F537572726F756E64222C';
wwv_flow_imp.g_varchar2_table(1661) := '655B652E627261636B657450616972436F6C6F72697A6174696F6E3D31355D3D22627261636B657450616972436F6C6F72697A6174696F6E222C655B652E6775696465733D31365D3D22677569646573222C655B652E636F64654C656E733D31375D3D22';
wwv_flow_imp.g_varchar2_table(1662) := '636F64654C656E73222C655B652E636F64654C656E73466F6E7446616D696C793D31385D3D22636F64654C656E73466F6E7446616D696C79222C655B652E636F64654C656E73466F6E7453697A653D31395D3D22636F64654C656E73466F6E7453697A65';
wwv_flow_imp.g_varchar2_table(1663) := '222C655B652E636F6C6F724465636F7261746F72733D32305D3D22636F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734C696D69743D32315D3D22636F6C6F724465636F7261746F72734C696D6974222C655B652E';
wwv_flow_imp.g_varchar2_table(1664) := '636F6C756D6E53656C656374696F6E3D32325D3D22636F6C756D6E53656C656374696F6E222C655B652E636F6D6D656E74733D32335D3D22636F6D6D656E7473222C655B652E636F6E746578746D656E753D32345D3D22636F6E746578746D656E75222C';
wwv_flow_imp.g_varchar2_table(1665) := '655B652E636F70795769746853796E746178486967686C69676874696E673D32355D3D22636F70795769746853796E746178486967686C69676874696E67222C655B652E637572736F72426C696E6B696E673D32365D3D22637572736F72426C696E6B69';
wwv_flow_imp.g_varchar2_table(1666) := '6E67222C655B652E637572736F72536D6F6F74684361726574416E696D6174696F6E3D32375D3D22637572736F72536D6F6F74684361726574416E696D6174696F6E222C655B652E637572736F725374796C653D32385D3D22637572736F725374796C65';
wwv_flow_imp.g_varchar2_table(1667) := '222C655B652E637572736F72537572726F756E64696E674C696E65733D32395D3D22637572736F72537572726F756E64696E674C696E6573222C655B652E637572736F72537572726F756E64696E674C696E65735374796C653D33305D3D22637572736F';
wwv_flow_imp.g_varchar2_table(1668) := '72537572726F756E64696E674C696E65735374796C65222C655B652E637572736F7257696474683D33315D3D22637572736F725769647468222C655B652E64697361626C654C6179657248696E74696E673D33325D3D2264697361626C654C6179657248';
wwv_flow_imp.g_varchar2_table(1669) := '696E74696E67222C655B652E64697361626C654D6F6E6F73706163654F7074696D697A6174696F6E733D33335D3D2264697361626C654D6F6E6F73706163654F7074696D697A6174696F6E73222C655B652E646F6D526561644F6E6C793D33345D3D2264';
wwv_flow_imp.g_varchar2_table(1670) := '6F6D526561644F6E6C79222C655B652E64726167416E6444726F703D33355D3D2264726167416E6444726F70222C655B652E64726F70496E746F456469746F723D33365D3D2264726F70496E746F456469746F72222C655B652E656D70747953656C6563';
wwv_flow_imp.g_varchar2_table(1671) := '74696F6E436C6970626F6172643D33375D3D22656D70747953656C656374696F6E436C6970626F617264222C655B652E6578706572696D656E74616C5768697465737061636552656E646572696E673D33385D3D226578706572696D656E74616C576869';
wwv_flow_imp.g_varchar2_table(1672) := '7465737061636552656E646572696E67222C655B652E6578747261456469746F72436C6173734E616D653D33395D3D226578747261456469746F72436C6173734E616D65222C655B652E666173745363726F6C6C53656E73697469766974793D34305D3D';
wwv_flow_imp.g_varchar2_table(1673) := '22666173745363726F6C6C53656E7369746976697479222C655B652E66696E643D34315D3D2266696E64222C655B652E66697865644F766572666C6F77576964676574733D34325D3D2266697865644F766572666C6F7757696467657473222C655B652E';
wwv_flow_imp.g_varchar2_table(1674) := '666F6C64696E673D34335D3D22666F6C64696E67222C655B652E666F6C64696E6753747261746567793D34345D3D22666F6C64696E675374726174656779222C655B652E666F6C64696E67486967686C696768743D34355D3D22666F6C64696E67486967';
wwv_flow_imp.g_varchar2_table(1675) := '686C69676874222C655B652E666F6C64696E67496D706F727473427944656661756C743D34365D3D22666F6C64696E67496D706F727473427944656661756C74222C655B652E666F6C64696E674D6178696D756D526567696F6E733D34375D3D22666F6C';
wwv_flow_imp.g_varchar2_table(1676) := '64696E674D6178696D756D526567696F6E73222C655B652E756E666F6C644F6E436C69636B4166746572456E644F664C696E653D34385D3D22756E666F6C644F6E436C69636B4166746572456E644F664C696E65222C655B652E666F6E7446616D696C79';
wwv_flow_imp.g_varchar2_table(1677) := '3D34395D3D22666F6E7446616D696C79222C655B652E666F6E74496E666F3D35305D3D22666F6E74496E666F222C655B652E666F6E744C69676174757265733D35315D3D22666F6E744C6967617475726573222C655B652E666F6E7453697A653D35325D';
wwv_flow_imp.g_varchar2_table(1678) := '3D22666F6E7453697A65222C655B652E666F6E745765696768743D35335D3D22666F6E74576569676874222C655B652E666F6E74566172696174696F6E733D35345D3D22666F6E74566172696174696F6E73222C655B652E666F726D61744F6E50617374';
wwv_flow_imp.g_varchar2_table(1679) := '653D35355D3D22666F726D61744F6E5061737465222C655B652E666F726D61744F6E547970653D35365D3D22666F726D61744F6E54797065222C655B652E676C7970684D617267696E3D35375D3D22676C7970684D617267696E222C655B652E676F746F';
wwv_flow_imp.g_varchar2_table(1680) := '4C6F636174696F6E3D35385D3D22676F746F4C6F636174696F6E222C655B652E68696465437572736F72496E4F7665727669657752756C65723D35395D3D2268696465437572736F72496E4F7665727669657752756C6572222C655B652E686F7665723D';
wwv_flow_imp.g_varchar2_table(1681) := '36305D3D22686F766572222C655B652E696E44696666456469746F723D36315D3D22696E44696666456469746F72222C655B652E696E6C696E65537567676573743D36325D3D22696E6C696E6553756767657374222C655B652E696E6C696E6545646974';
wwv_flow_imp.g_varchar2_table(1682) := '3D36335D3D22696E6C696E6545646974222C655B652E6C657474657253706163696E673D36345D3D226C657474657253706163696E67222C655B652E6C6967687462756C623D36355D3D226C6967687462756C62222C655B652E6C696E654465636F7261';
wwv_flow_imp.g_varchar2_table(1683) := '74696F6E7357696474683D36365D3D226C696E654465636F726174696F6E735769647468222C655B652E6C696E654865696768743D36375D3D226C696E65486569676874222C655B652E6C696E654E756D626572733D36385D3D226C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1684) := '7273222C655B652E6C696E654E756D626572734D696E43686172733D36395D3D226C696E654E756D626572734D696E4368617273222C655B652E6C696E6B656445646974696E673D37305D3D226C696E6B656445646974696E67222C655B652E6C696E6B';
wwv_flow_imp.g_varchar2_table(1685) := '733D37315D3D226C696E6B73222C655B652E6D61746368427261636B6574733D37325D3D226D61746368427261636B657473222C655B652E6D696E696D61703D37335D3D226D696E696D6170222C655B652E6D6F7573655374796C653D37345D3D226D6F';
wwv_flow_imp.g_varchar2_table(1686) := '7573655374796C65222C655B652E6D6F757365576865656C5363726F6C6C53656E73697469766974793D37355D3D226D6F757365576865656C5363726F6C6C53656E7369746976697479222C655B652E6D6F757365576865656C5A6F6F6D3D37365D3D22';
wwv_flow_imp.g_varchar2_table(1687) := '6D6F757365576865656C5A6F6F6D222C655B652E6D756C7469437572736F724D657267654F7665726C617070696E673D37375D3D226D756C7469437572736F724D657267654F7665726C617070696E67222C655B652E6D756C7469437572736F724D6F64';
wwv_flow_imp.g_varchar2_table(1688) := '69666965723D37385D3D226D756C7469437572736F724D6F646966696572222C655B652E6D756C7469437572736F7250617374653D37395D3D226D756C7469437572736F725061737465222C655B652E6D756C7469437572736F724C696D69743D38305D';
wwv_flow_imp.g_varchar2_table(1689) := '3D226D756C7469437572736F724C696D6974222C655B652E6F6363757272656E636573486967686C696768743D38315D3D226F6363757272656E636573486967686C69676874222C655B652E6F7665727669657752756C6572426F726465723D38325D3D';
wwv_flow_imp.g_varchar2_table(1690) := '226F7665727669657752756C6572426F72646572222C655B652E6F7665727669657752756C65724C616E65733D38335D3D226F7665727669657752756C65724C616E6573222C655B652E70616464696E673D38345D3D2270616464696E67222C655B652E';
wwv_flow_imp.g_varchar2_table(1691) := '706173746541733D38355D3D2270617374654173222C655B652E706172616D6574657248696E74733D38365D3D22706172616D6574657248696E7473222C655B652E7065656B57696467657444656661756C74466F6375733D38375D3D227065656B5769';
wwv_flow_imp.g_varchar2_table(1692) := '6467657444656661756C74466F637573222C655B652E646566696E6974696F6E4C696E6B4F70656E73496E5065656B3D38385D3D22646566696E6974696F6E4C696E6B4F70656E73496E5065656B222C655B652E717569636B53756767657374696F6E73';
wwv_flow_imp.g_varchar2_table(1693) := '3D38395D3D22717569636B53756767657374696F6E73222C655B652E717569636B53756767657374696F6E7344656C61793D39305D3D22717569636B53756767657374696F6E7344656C6179222C655B652E726561644F6E6C793D39315D3D2272656164';
wwv_flow_imp.g_varchar2_table(1694) := '4F6E6C79222C655B652E726561644F6E6C794D6573736167653D39325D3D22726561644F6E6C794D657373616765222C655B652E72656E616D654F6E547970653D39335D3D2272656E616D654F6E54797065222C655B652E72656E646572436F6E74726F';
wwv_flow_imp.g_varchar2_table(1695) := '6C436861726163746572733D39345D3D2272656E646572436F6E74726F6C43686172616374657273222C655B652E72656E64657246696E616C4E65776C696E653D39355D3D2272656E64657246696E616C4E65776C696E65222C655B652E72656E646572';
wwv_flow_imp.g_varchar2_table(1696) := '4C696E65486967686C696768743D39365D3D2272656E6465724C696E65486967686C69676874222C655B652E72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375733D39375D3D2272656E6465724C696E65486967686C696768';
wwv_flow_imp.g_varchar2_table(1697) := '744F6E6C795768656E466F637573222C655B652E72656E64657256616C69646174696F6E4465636F726174696F6E733D39385D3D2272656E64657256616C69646174696F6E4465636F726174696F6E73222C655B652E72656E6465725768697465737061';
wwv_flow_imp.g_varchar2_table(1698) := '63653D39395D3D2272656E64657257686974657370616365222C655B652E72657665616C486F72697A6F6E74616C526967687450616464696E673D3130305D3D2272657665616C486F72697A6F6E74616C526967687450616464696E67222C655B652E72';
wwv_flow_imp.g_varchar2_table(1699) := '6F756E64656453656C656374696F6E3D3130315D3D22726F756E64656453656C656374696F6E222C655B652E72756C6572733D3130325D3D2272756C657273222C655B652E7363726F6C6C6261723D3130335D3D227363726F6C6C626172222C655B652E';
wwv_flow_imp.g_varchar2_table(1700) := '7363726F6C6C4265796F6E644C617374436F6C756D6E3D3130345D3D227363726F6C6C4265796F6E644C617374436F6C756D6E222C655B652E7363726F6C6C4265796F6E644C6173744C696E653D3130355D3D227363726F6C6C4265796F6E644C617374';
wwv_flow_imp.g_varchar2_table(1701) := '4C696E65222C655B652E7363726F6C6C507265646F6D696E616E74417869733D3130365D3D227363726F6C6C507265646F6D696E616E7441786973222C655B652E73656C656374696F6E436C6970626F6172643D3130375D3D2273656C656374696F6E43';
wwv_flow_imp.g_varchar2_table(1702) := '6C6970626F617264222C655B652E73656C656374696F6E486967686C696768743D3130385D3D2273656C656374696F6E486967686C69676874222C655B652E73656C6563744F6E4C696E654E756D626572733D3130395D3D2273656C6563744F6E4C696E';
wwv_flow_imp.g_varchar2_table(1703) := '654E756D62657273222C655B652E73686F77466F6C64696E67436F6E74726F6C733D3131305D3D2273686F77466F6C64696E67436F6E74726F6C73222C655B652E73686F77556E757365643D3131315D3D2273686F77556E75736564222C655B652E736E';
wwv_flow_imp.g_varchar2_table(1704) := '697070657453756767657374696F6E733D3131325D3D22736E697070657453756767657374696F6E73222C655B652E736D61727453656C6563743D3131335D3D22736D61727453656C656374222C655B652E736D6F6F74685363726F6C6C696E673D3131';
wwv_flow_imp.g_varchar2_table(1705) := '345D3D22736D6F6F74685363726F6C6C696E67222C655B652E737469636B795363726F6C6C3D3131355D3D22737469636B795363726F6C6C222C655B652E737469636B7954616253746F70733D3131365D3D22737469636B7954616253746F7073222C65';
wwv_flow_imp.g_varchar2_table(1706) := '5B652E73746F7052656E646572696E674C696E6541667465723D3131375D3D2273746F7052656E646572696E674C696E654166746572222C655B652E737567676573743D3131385D3D2273756767657374222C655B652E73756767657374466F6E745369';
wwv_flow_imp.g_varchar2_table(1707) := '7A653D3131395D3D2273756767657374466F6E7453697A65222C655B652E737567676573744C696E654865696768743D3132305D3D22737567676573744C696E65486569676874222C655B652E737567676573744F6E5472696767657243686172616374';
wwv_flow_imp.g_varchar2_table(1708) := '6572733D3132315D3D22737567676573744F6E5472696767657243686172616374657273222C655B652E7375676765737453656C656374696F6E3D3132325D3D227375676765737453656C656374696F6E222C655B652E746162436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(1709) := '3D3132335D3D22746162436F6D706C6574696F6E222C655B652E746162496E6465783D3132345D3D22746162496E646578222C655B652E756E69636F6465486967686C69676874696E673D3132355D3D22756E69636F6465486967686C69676874696E67';
wwv_flow_imp.g_varchar2_table(1710) := '222C655B652E756E757375616C4C696E655465726D696E61746F72733D3132365D3D22756E757375616C4C696E655465726D696E61746F7273222C655B652E757365536861646F77444F4D3D3132375D3D22757365536861646F77444F4D222C655B652E';
wwv_flow_imp.g_varchar2_table(1711) := '75736554616253746F70733D3132385D3D2275736554616253746F7073222C655B652E776F7264427265616B3D3132395D3D22776F7264427265616B222C655B652E776F72645365676D656E7465724C6F63616C65733D3133305D3D22776F7264536567';
wwv_flow_imp.g_varchar2_table(1712) := '6D656E7465724C6F63616C6573222C655B652E776F7264536570617261746F72733D3133315D3D22776F7264536570617261746F7273222C655B652E776F7264577261703D3133325D3D22776F726457726170222C655B652E776F726457726170427265';
wwv_flow_imp.g_varchar2_table(1713) := '616B4166746572436861726163746572733D3133335D3D22776F726457726170427265616B416674657243686172616374657273222C655B652E776F726457726170427265616B4265666F7265436861726163746572733D3133345D3D22776F72645772';
wwv_flow_imp.g_varchar2_table(1714) := '6170427265616B4265666F726543686172616374657273222C655B652E776F726457726170436F6C756D6E3D3133355D3D22776F726457726170436F6C756D6E222C655B652E776F7264577261704F76657272696465313D3133365D3D22776F72645772';
wwv_flow_imp.g_varchar2_table(1715) := '61704F7665727269646531222C655B652E776F7264577261704F76657272696465323D3133375D3D22776F7264577261704F7665727269646532222C655B652E7772617070696E67496E64656E743D3133385D3D227772617070696E67496E64656E7422';
wwv_flow_imp.g_varchar2_table(1716) := '2C655B652E7772617070696E6753747261746567793D3133395D3D227772617070696E675374726174656779222C655B652E73686F77446570726563617465643D3134305D3D2273686F7744657072656361746564222C655B652E696E6C617948696E74';
wwv_flow_imp.g_varchar2_table(1717) := '733D3134315D3D22696E6C617948696E7473222C655B652E656469746F72436C6173734E616D653D3134325D3D22656469746F72436C6173734E616D65222C655B652E706978656C526174696F3D3134335D3D22706978656C526174696F222C655B652E';
wwv_flow_imp.g_varchar2_table(1718) := '746162466F6375734D6F64653D3134345D3D22746162466F6375734D6F6465222C655B652E6C61796F7574496E666F3D3134355D3D226C61796F7574496E666F222C655B652E7772617070696E67496E666F3D3134365D3D227772617070696E67496E66';
wwv_flow_imp.g_varchar2_table(1719) := '6F222C655B652E64656661756C74436F6C6F724465636F7261746F72733D3134375D3D2264656661756C74436F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734163746976617465644F6E3D3134385D3D22636F6C';
wwv_flow_imp.g_varchar2_table(1720) := '6F724465636F7261746F72734163746976617465644F6E222C655B652E696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F73653D3134395D3D22696E6C696E65436F6D706C6574696F6E734163636573736962696C';
wwv_flow_imp.g_varchar2_table(1721) := '697479566572626F7365227D28556E7C7C28556E3D7B7D29292C66756E6374696F6E2865297B655B652E54657874446566696E65643D305D3D2254657874446566696E6564222C655B652E4C463D315D3D224C46222C655B652E43524C463D325D3D2243';
wwv_flow_imp.g_varchar2_table(1722) := '524C46227D28486E7C7C28486E3D7B7D29292C66756E6374696F6E2865297B655B652E4C463D305D3D224C46222C655B652E43524C463D315D3D2243524C46227D28446E7C7C28446E3D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D';
wwv_flow_imp.g_varchar2_table(1723) := '315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D284F6E7C7C284F6E3D7B7D29292C66756E6374696F6E2865297B655B652E496E6372656173653D305D3D22496E63';
wwv_flow_imp.g_varchar2_table(1724) := '7265617365222C655B652E44656372656173653D315D3D224465637265617365227D28576E7C7C28576E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E496E64656E743D315D3D22496E64656E74';
wwv_flow_imp.g_varchar2_table(1725) := '222C655B652E496E64656E744F757464656E743D325D3D22496E64656E744F757464656E74222C655B652E4F757464656E743D335D3D224F757464656E74227D28506E7C7C28506E3D7B7D29292C66756E6374696F6E2865297B655B652E426F74683D30';
wwv_flow_imp.g_varchar2_table(1726) := '5D3D22426F7468222C655B652E52696768743D315D3D225269676874222C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D28716E7C7C28716E3D7B7D29292C66756E6374696F6E2865297B655B652E5479';
wwv_flow_imp.g_varchar2_table(1727) := '70653D315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D28466E7C7C28466E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B65';
wwv_flow_imp.g_varchar2_table(1728) := '2E4578706C696369743D315D3D224578706C69636974227D28426E7C7C28426E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963';
wwv_flow_imp.g_varchar2_table(1729) := '227D28566E7C7C28566E3D7B7D29292C66756E6374696F6E2865297B655B652E446570656E64734F6E4B624C61796F75743D2D315D3D22446570656E64734F6E4B624C61796F7574222C655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C65';
wwv_flow_imp.g_varchar2_table(1730) := '5B652E4261636B73706163653D315D3D224261636B7370616365222C655B652E5461623D325D3D22546162222C655B652E456E7465723D335D3D22456E746572222C655B652E53686966743D345D3D225368696674222C655B652E4374726C3D355D3D22';
wwv_flow_imp.g_varchar2_table(1731) := '4374726C222C655B652E416C743D365D3D22416C74222C655B652E5061757365427265616B3D375D3D225061757365427265616B222C655B652E436170734C6F636B3D385D3D22436170734C6F636B222C655B652E4573636170653D395D3D2245736361';
wwv_flow_imp.g_varchar2_table(1732) := '7065222C655B652E53706163653D31305D3D225370616365222C655B652E5061676555703D31315D3D22506167655570222C655B652E50616765446F776E3D31325D3D2250616765446F776E222C655B652E456E643D31335D3D22456E64222C655B652E';
wwv_flow_imp.g_varchar2_table(1733) := '486F6D653D31345D3D22486F6D65222C655B652E4C6566744172726F773D31355D3D224C6566744172726F77222C655B652E55704172726F773D31365D3D2255704172726F77222C655B652E52696768744172726F773D31375D3D225269676874417272';
wwv_flow_imp.g_varchar2_table(1734) := '6F77222C655B652E446F776E4172726F773D31385D3D22446F776E4172726F77222C655B652E496E736572743D31395D3D22496E73657274222C655B652E44656C6574653D32305D3D2244656C657465222C655B652E4469676974303D32315D3D224469';
wwv_flow_imp.g_varchar2_table(1735) := '67697430222C655B652E4469676974313D32325D3D22446967697431222C655B652E4469676974323D32335D3D22446967697432222C655B652E4469676974333D32345D3D22446967697433222C655B652E4469676974343D32355D3D22446967697434';
wwv_flow_imp.g_varchar2_table(1736) := '222C655B652E4469676974353D32365D3D22446967697435222C655B652E4469676974363D32375D3D22446967697436222C655B652E4469676974373D32385D3D22446967697437222C655B652E4469676974383D32395D3D22446967697438222C655B';
wwv_flow_imp.g_varchar2_table(1737) := '652E4469676974393D33305D3D22446967697439222C655B652E4B6579413D33315D3D224B657941222C655B652E4B6579423D33325D3D224B657942222C655B652E4B6579433D33335D3D224B657943222C655B652E4B6579443D33345D3D224B657944';
wwv_flow_imp.g_varchar2_table(1738) := '222C655B652E4B6579453D33355D3D224B657945222C655B652E4B6579463D33365D3D224B657946222C655B652E4B6579473D33375D3D224B657947222C655B652E4B6579483D33385D3D224B657948222C655B652E4B6579493D33395D3D224B657949';
wwv_flow_imp.g_varchar2_table(1739) := '222C655B652E4B65794A3D34305D3D224B65794A222C655B652E4B65794B3D34315D3D224B65794B222C655B652E4B65794C3D34325D3D224B65794C222C655B652E4B65794D3D34335D3D224B65794D222C655B652E4B65794E3D34345D3D224B65794E';
wwv_flow_imp.g_varchar2_table(1740) := '222C655B652E4B65794F3D34355D3D224B65794F222C655B652E4B6579503D34365D3D224B657950222C655B652E4B6579513D34375D3D224B657951222C655B652E4B6579523D34385D3D224B657952222C655B652E4B6579533D34395D3D224B657953';
wwv_flow_imp.g_varchar2_table(1741) := '222C655B652E4B6579543D35305D3D224B657954222C655B652E4B6579553D35315D3D224B657955222C655B652E4B6579563D35325D3D224B657956222C655B652E4B6579573D35335D3D224B657957222C655B652E4B6579583D35345D3D224B657958';
wwv_flow_imp.g_varchar2_table(1742) := '222C655B652E4B6579593D35355D3D224B657959222C655B652E4B65795A3D35365D3D224B65795A222C655B652E4D6574613D35375D3D224D657461222C655B652E436F6E746578744D656E753D35385D3D22436F6E746578744D656E75222C655B652E';
wwv_flow_imp.g_varchar2_table(1743) := '46313D35395D3D224631222C655B652E46323D36305D3D224632222C655B652E46333D36315D3D224633222C655B652E46343D36325D3D224634222C655B652E46353D36335D3D224635222C655B652E46363D36345D3D224636222C655B652E46373D36';
wwv_flow_imp.g_varchar2_table(1744) := '355D3D224637222C655B652E46383D36365D3D224638222C655B652E46393D36375D3D224639222C655B652E4631303D36385D3D22463130222C655B652E4631313D36395D3D22463131222C655B652E4631323D37305D3D22463132222C655B652E4631';
wwv_flow_imp.g_varchar2_table(1745) := '333D37315D3D22463133222C655B652E4631343D37325D3D22463134222C655B652E4631353D37335D3D22463135222C655B652E4631363D37345D3D22463136222C655B652E4631373D37355D3D22463137222C655B652E4631383D37365D3D22463138';
wwv_flow_imp.g_varchar2_table(1746) := '222C655B652E4631393D37375D3D22463139222C655B652E4632303D37385D3D22463230222C655B652E4632313D37395D3D22463231222C655B652E4632323D38305D3D22463232222C655B652E4632333D38315D3D22463233222C655B652E4632343D';
wwv_flow_imp.g_varchar2_table(1747) := '38325D3D22463234222C655B652E4E756D4C6F636B3D38335D3D224E756D4C6F636B222C655B652E5363726F6C6C4C6F636B3D38345D3D225363726F6C6C4C6F636B222C655B652E53656D69636F6C6F6E3D38355D3D2253656D69636F6C6F6E222C655B';
wwv_flow_imp.g_varchar2_table(1748) := '652E457175616C3D38365D3D22457175616C222C655B652E436F6D6D613D38375D3D22436F6D6D61222C655B652E4D696E75733D38385D3D224D696E7573222C655B652E506572696F643D38395D3D22506572696F64222C655B652E536C6173683D3930';
wwv_flow_imp.g_varchar2_table(1749) := '5D3D22536C617368222C655B652E4261636B71756F74653D39315D3D224261636B71756F7465222C655B652E427261636B65744C6566743D39325D3D22427261636B65744C656674222C655B652E4261636B736C6173683D39335D3D224261636B736C61';
wwv_flow_imp.g_varchar2_table(1750) := '7368222C655B652E427261636B657452696768743D39345D3D22427261636B65745269676874222C655B652E51756F74653D39355D3D2251756F7465222C655B652E4F454D5F383D39365D3D224F454D5F38222C655B652E496E746C4261636B736C6173';
wwv_flow_imp.g_varchar2_table(1751) := '683D39375D3D22496E746C4261636B736C617368222C655B652E4E756D706164303D39385D3D224E756D70616430222C655B652E4E756D706164313D39395D3D224E756D70616431222C655B652E4E756D706164323D3130305D3D224E756D7061643222';
wwv_flow_imp.g_varchar2_table(1752) := '2C655B652E4E756D706164333D3130315D3D224E756D70616433222C655B652E4E756D706164343D3130325D3D224E756D70616434222C655B652E4E756D706164353D3130335D3D224E756D70616435222C655B652E4E756D706164363D3130345D3D22';
wwv_flow_imp.g_varchar2_table(1753) := '4E756D70616436222C655B652E4E756D706164373D3130355D3D224E756D70616437222C655B652E4E756D706164383D3130365D3D224E756D70616438222C655B652E4E756D706164393D3130375D3D224E756D70616439222C655B652E4E756D706164';
wwv_flow_imp.g_varchar2_table(1754) := '4D756C7469706C793D3130385D3D224E756D7061644D756C7469706C79222C655B652E4E756D7061644164643D3130395D3D224E756D706164416464222C655B652E4E554D5041445F534550415241544F523D3131305D3D224E554D5041445F53455041';
wwv_flow_imp.g_varchar2_table(1755) := '5241544F52222C655B652E4E756D70616453756274726163743D3131315D3D224E756D7061645375627472616374222C655B652E4E756D706164446563696D616C3D3131325D3D224E756D706164446563696D616C222C655B652E4E756D706164446976';
wwv_flow_imp.g_varchar2_table(1756) := '6964653D3131335D3D224E756D706164446976696465222C655B652E4B45595F494E5F434F4D504F534954494F4E3D3131345D3D224B45595F494E5F434F4D504F534954494F4E222C655B652E41424E545F43313D3131355D3D2241424E545F4331222C';
wwv_flow_imp.g_varchar2_table(1757) := '655B652E41424E545F43323D3131365D3D2241424E545F4332222C655B652E417564696F566F6C756D654D7574653D3131375D3D22417564696F566F6C756D654D757465222C655B652E417564696F566F6C756D6555703D3131385D3D22417564696F56';
wwv_flow_imp.g_varchar2_table(1758) := '6F6C756D655570222C655B652E417564696F566F6C756D65446F776E3D3131395D3D22417564696F566F6C756D65446F776E222C655B652E42726F777365725365617263683D3132305D3D2242726F77736572536561726368222C655B652E42726F7773';
wwv_flow_imp.g_varchar2_table(1759) := '6572486F6D653D3132315D3D2242726F77736572486F6D65222C655B652E42726F777365724261636B3D3132325D3D2242726F777365724261636B222C655B652E42726F77736572466F72776172643D3132335D3D2242726F77736572466F7277617264';
wwv_flow_imp.g_varchar2_table(1760) := '222C655B652E4D65646961547261636B4E6578743D3132345D3D224D65646961547261636B4E657874222C655B652E4D65646961547261636B50726576696F75733D3132355D3D224D65646961547261636B50726576696F7573222C655B652E4D656469';
wwv_flow_imp.g_varchar2_table(1761) := '6153746F703D3132365D3D224D6564696153746F70222C655B652E4D65646961506C617950617573653D3132375D3D224D65646961506C61795061757365222C655B652E4C61756E63684D65646961506C617965723D3132385D3D224C61756E63684D65';
wwv_flow_imp.g_varchar2_table(1762) := '646961506C61796572222C655B652E4C61756E63684D61696C3D3132395D3D224C61756E63684D61696C222C655B652E4C61756E6368417070323D3133305D3D224C61756E636841707032222C655B652E436C6561723D3133315D3D22436C656172222C';
wwv_flow_imp.g_varchar2_table(1763) := '655B652E4D41585F56414C55453D3133325D3D224D41585F56414C5545227D284B6E7C7C284B6E3D7B7D29292C66756E6374696F6E2865297B655B652E48696E743D315D3D2248696E74222C655B652E496E666F3D325D3D22496E666F222C655B652E57';
wwv_flow_imp.g_varchar2_table(1764) := '61726E696E673D345D3D225761726E696E67222C655B652E4572726F723D385D3D224572726F72227D286A6E7C7C286A6E3D7B7D29292C66756E6374696F6E2865297B655B652E556E6E65636573736172793D315D3D22556E6E6563657373617279222C';
wwv_flow_imp.g_varchar2_table(1765) := '655B652E446570726563617465643D325D3D2244657072656361746564227D28476E7C7C28476E3D7B7D29292C66756E6374696F6E2865297B655B652E496E6C696E653D315D3D22496E6C696E65222C655B652E4775747465723D325D3D224775747465';
wwv_flow_imp.g_varchar2_table(1766) := '72227D28246E7C7C28246E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F726D616C3D315D3D224E6F726D616C222C655B652E556E6465726C696E65643D325D3D22556E6465726C696E6564227D28586E7C7C28586E3D7B7D29292C66756E';
wwv_flow_imp.g_varchar2_table(1767) := '6374696F6E2865297B655B652E554E4B4E4F574E3D305D3D22554E4B4E4F574E222C655B652E54455854415245413D315D3D225445585441524541222C655B652E4755545445525F474C5950485F4D415247494E3D325D3D224755545445525F474C5950';
wwv_flow_imp.g_varchar2_table(1768) := '485F4D415247494E222C655B652E4755545445525F4C494E455F4E554D424552533D335D3D224755545445525F4C494E455F4E554D42455253222C655B652E4755545445525F4C494E455F4445434F524154494F4E533D345D3D224755545445525F4C49';
wwv_flow_imp.g_varchar2_table(1769) := '4E455F4445434F524154494F4E53222C655B652E4755545445525F564945575F5A4F4E453D355D3D224755545445525F564945575F5A4F4E45222C655B652E434F4E54454E545F544558543D365D3D22434F4E54454E545F54455854222C655B652E434F';
wwv_flow_imp.g_varchar2_table(1770) := '4E54454E545F454D5054593D375D3D22434F4E54454E545F454D505459222C655B652E434F4E54454E545F564945575F5A4F4E453D385D3D22434F4E54454E545F564945575F5A4F4E45222C655B652E434F4E54454E545F5749444745543D395D3D2243';
wwv_flow_imp.g_varchar2_table(1771) := '4F4E54454E545F574944474554222C655B652E4F564552564945575F52554C45523D31305D3D224F564552564945575F52554C4552222C655B652E5343524F4C4C4241523D31315D3D225343524F4C4C424152222C655B652E4F5645524C41595F574944';
wwv_flow_imp.g_varchar2_table(1772) := '4745543D31325D3D224F5645524C41595F574944474554222C655B652E4F5554534944455F454449544F523D31335D3D224F5554534944455F454449544F52227D284A6E7C7C284A6E3D7B7D29292C66756E6374696F6E2865297B655B652E414947656E';
wwv_flow_imp.g_varchar2_table(1773) := '6572617465643D315D3D22414947656E657261746564227D28596E7C7C28596E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963';
wwv_flow_imp.g_varchar2_table(1774) := '227D28516E7C7C28516E3D7B7D29292C66756E6374696F6E2865297B655B652E544F505F52494748545F434F524E45523D305D3D22544F505F52494748545F434F524E4552222C655B652E424F54544F4D5F52494748545F434F524E45523D315D3D2242';
wwv_flow_imp.g_varchar2_table(1775) := '4F54544F4D5F52494748545F434F524E4552222C655B652E544F505F43454E5445523D325D3D22544F505F43454E544552227D285A6E7C7C285A6E3D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E';
wwv_flow_imp.g_varchar2_table(1776) := '43656E7465723D325D3D2243656E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D2865697C7C2865693D7B7D29292C66756E6374696F6E2865297B655B652E576F72643D305D3D22576F';
wwv_flow_imp.g_varchar2_table(1777) := '7264222C655B652E4C696E653D315D3D224C696E65222C655B652E537567676573743D325D3D2253756767657374227D2874697C7C2874693D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D305D3D224C656674222C655B652E526967';
wwv_flow_imp.g_varchar2_table(1778) := '68743D315D3D225269676874222C655B652E4E6F6E653D325D3D224E6F6E65222C655B652E4C6566744F66496E6A6563746564546578743D335D3D224C6566744F66496E6A656374656454657874222C655B652E52696768744F66496E6A656374656454';
wwv_flow_imp.g_varchar2_table(1779) := '6578743D345D3D2252696768744F66496E6A656374656454657874227D286E697C7C286E693D7B7D29292C66756E6374696F6E2865297B655B652E4F66663D305D3D224F6666222C655B652E4F6E3D315D3D224F6E222C655B652E52656C61746976653D';
wwv_flow_imp.g_varchar2_table(1780) := '325D3D2252656C6174697665222C655B652E496E74657276616C3D335D3D22496E74657276616C222C655B652E437573746F6D3D345D3D22437573746F6D227D2869697C7C2869693D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D30';
wwv_flow_imp.g_varchar2_table(1781) := '5D3D224E6F6E65222C655B652E546578743D315D3D2254657874222C655B652E426C6F636B733D325D3D22426C6F636B73227D2872697C7C2872693D7B7D29292C66756E6374696F6E2865297B655B652E536D6F6F74683D305D3D22536D6F6F7468222C';
wwv_flow_imp.g_varchar2_table(1782) := '655B652E496D6D6564696174653D315D3D22496D6D656469617465227D286F697C7C286F693D7B7D29292C66756E6374696F6E2865297B655B652E4175746F3D315D3D224175746F222C655B652E48696464656E3D325D3D2248696464656E222C655B65';
wwv_flow_imp.g_varchar2_table(1783) := '2E56697369626C653D335D3D2256697369626C65227D2861697C7C2861693D7B7D29292C66756E6374696F6E2865297B655B652E4C54523D305D3D224C5452222C655B652E52544C3D315D3D2252544C227D2873697C7C2873693D7B7D29292C66756E63';
wwv_flow_imp.g_varchar2_table(1784) := '74696F6E2865297B652E4F66663D226F6666222C652E4F6E436F64653D226F6E436F6465222C652E4F6E3D226F6E227D286C697C7C286C693D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B65';
wwv_flow_imp.g_varchar2_table(1785) := '2E547269676765724368617261637465723D325D3D2254726967676572436861726163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E6765227D2868697C7C2868693D7B7D29292C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1786) := '65297B655B652E46696C653D305D3D2246696C65222C655B652E4D6F64756C653D315D3D224D6F64756C65222C655B652E4E616D6573706163653D325D3D224E616D657370616365222C655B652E5061636B6167653D335D3D225061636B616765222C65';
wwv_flow_imp.g_varchar2_table(1787) := '5B652E436C6173733D345D3D22436C617373222C655B652E4D6574686F643D355D3D224D6574686F64222C655B652E50726F70657274793D365D3D2250726F7065727479222C655B652E4669656C643D375D3D224669656C64222C655B652E436F6E7374';
wwv_flow_imp.g_varchar2_table(1788) := '727563746F723D385D3D22436F6E7374727563746F72222C655B652E456E756D3D395D3D22456E756D222C655B652E496E746572666163653D31305D3D22496E74657266616365222C655B652E46756E6374696F6E3D31315D3D2246756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(1789) := '2C655B652E5661726961626C653D31325D3D225661726961626C65222C655B652E436F6E7374616E743D31335D3D22436F6E7374616E74222C655B652E537472696E673D31345D3D22537472696E67222C655B652E4E756D6265723D31355D3D224E756D';
wwv_flow_imp.g_varchar2_table(1790) := '626572222C655B652E426F6F6C65616E3D31365D3D22426F6F6C65616E222C655B652E41727261793D31375D3D224172726179222C655B652E4F626A6563743D31385D3D224F626A656374222C655B652E4B65793D31395D3D224B6579222C655B652E4E';
wwv_flow_imp.g_varchar2_table(1791) := '756C6C3D32305D3D224E756C6C222C655B652E456E756D4D656D6265723D32315D3D22456E756D4D656D626572222C655B652E5374727563743D32325D3D22537472756374222C655B652E4576656E743D32335D3D224576656E74222C655B652E4F7065';
wwv_flow_imp.g_varchar2_table(1792) := '7261746F723D32345D3D224F70657261746F72222C655B652E54797065506172616D657465723D32355D3D2254797065506172616D65746572227D2863697C7C2863693D7B7D29292C66756E6374696F6E2865297B655B652E446570726563617465643D';
wwv_flow_imp.g_varchar2_table(1793) := '315D3D2244657072656361746564227D2864697C7C2864693D7B7D29292C66756E6374696F6E2865297B655B652E48696464656E3D305D3D2248696464656E222C655B652E426C696E6B3D315D3D22426C696E6B222C655B652E536D6F6F74683D325D3D';
wwv_flow_imp.g_varchar2_table(1794) := '22536D6F6F7468222C655B652E50686173653D335D3D225068617365222C655B652E457870616E643D345D3D22457870616E64222C655B652E536F6C69643D355D3D22536F6C6964227D2875697C7C2875693D7B7D29292C66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(1795) := '655B652E4C696E653D315D3D224C696E65222C655B652E426C6F636B3D325D3D22426C6F636B222C655B652E556E6465726C696E653D335D3D22556E6465726C696E65222C655B652E4C696E655468696E3D345D3D224C696E655468696E222C655B652E';
wwv_flow_imp.g_varchar2_table(1796) := '426C6F636B4F75746C696E653D355D3D22426C6F636B4F75746C696E65222C655B652E556E6465726C696E655468696E3D365D3D22556E6465726C696E655468696E227D286D697C7C286D693D7B7D29292C66756E6374696F6E2865297B655B652E416C';
wwv_flow_imp.g_varchar2_table(1797) := '7761797347726F77735768656E547970696E67417445646765733D305D3D22416C7761797347726F77735768656E547970696E6741744564676573222C655B652E4E6576657247726F77735768656E547970696E67417445646765733D315D3D224E6576';
wwv_flow_imp.g_varchar2_table(1798) := '657247726F77735768656E547970696E6741744564676573222C655B652E47726F77734F6E6C795768656E547970696E674265666F72653D325D3D2247726F77734F6E6C795768656E547970696E674265666F7265222C655B652E47726F77734F6E6C79';
wwv_flow_imp.g_varchar2_table(1799) := '5768656E547970696E6741667465723D335D3D2247726F77734F6E6C795768656E547970696E674166746572227D2870697C7C2870693D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E53616D653D';
wwv_flow_imp.g_varchar2_table(1800) := '315D3D2253616D65222C655B652E496E64656E743D325D3D22496E64656E74222C655B652E44656570496E64656E743D335D3D2244656570496E64656E74227D2866697C7C2866693D7B7D29293B636C6173732054697B7374617469632063686F726428';
wwv_flow_imp.g_varchar2_table(1801) := '652C74297B72657475726E2066756E6374696F6E28652C74297B72657475726E28657C2836353533352674293C3C31363E3E3E30293E3E3E307D28652C74297D7D54692E4374726C436D643D323034382C54692E53686966743D313032342C54692E416C';
wwv_flow_imp.g_varchar2_table(1802) := '743D3531322C54692E57696E4374726C3D3235363B636C617373206B697B636F6E7374727563746F7228652C74297B746869732E7572693D652C746869732E76616C75653D747D7D636C6173732053697B636F6E7374727563746F7228652C74297B6966';
wwv_flow_imp.g_varchar2_table(1803) := '28746869735B67695D3D225265736F757263654D6170222C6520696E7374616E63656F6620536929746869732E6D61703D6E6577204D617028652E6D6170292C746869732E746F4B65793D6E756C6C213D743F743A53692E64656661756C74546F4B6579';
wwv_flow_imp.g_varchar2_table(1804) := '3B656C73652069662866756E6374696F6E2865297B72657475726E2041727261792E697341727261792865297D286529297B746869732E6D61703D6E6577204D61702C746869732E746F4B65793D6E756C6C213D743F743A53692E64656661756C74546F';
wwv_flow_imp.g_varchar2_table(1805) := '4B65793B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D656C736520746869732E6D61703D6E6577204D61702C746869732E746F4B65793D6E756C6C213D653F653A53692E64656661756C74546F4B65797D73657428';
wwv_flow_imp.g_varchar2_table(1806) := '652C74297B72657475726E20746869732E6D61702E73657428746869732E746F4B65792865292C6E6577206B6928652C7429292C746869737D6765742865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E6D61702E67657428';
wwv_flow_imp.g_varchar2_table(1807) := '746869732E746F4B657928652929297C7C766F696420303D3D3D743F766F696420303A742E76616C75657D6861732865297B72657475726E20746869732E6D61702E68617328746869732E746F4B6579286529297D6765742073697A6528297B72657475';
wwv_flow_imp.g_varchar2_table(1808) := '726E20746869732E6D61702E73697A657D636C65617228297B746869732E6D61702E636C65617228297D64656C6574652865297B72657475726E20746869732E6D61702E64656C65746528746869732E746F4B6579286529297D666F724561636828652C';
wwv_flow_imp.g_varchar2_table(1809) := '74297B766F69642030213D3D74262628653D652E62696E64287429293B666F7228636F6E73745B742C6E5D6F6620746869732E6D61702965286E2E76616C75652C6E2E7572692C74686973297D2A76616C75657328297B666F7228636F6E73742065206F';
wwv_flow_imp.g_varchar2_table(1810) := '6620746869732E6D61702E76616C7565732829297969656C6420652E76616C75657D2A6B65797328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C6420652E7572697D2A656E747269657328297B666F';
wwv_flow_imp.g_varchar2_table(1811) := '7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C645B652E7572692C652E76616C75655D7D2A5B2867693D53796D626F6C2E746F537472696E675461672C53796D626F6C2E6974657261746F72295D28297B666F72';
wwv_flow_imp.g_varchar2_table(1812) := '28636F6E73745B2C655D6F6620746869732E6D6170297969656C645B652E7572692C652E76616C75655D7D7D53692E64656661756C74546F4B65793D653D3E652E746F537472696E6728293B636C6173732078697B636F6E7374727563746F7228297B74';
wwv_flow_imp.g_varchar2_table(1813) := '6869735B62695D3D224C696E6B65644D6170222C746869732E5F6D61703D6E6577204D61702C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F73697A653D302C746869732E5F73746174653D30';
wwv_flow_imp.g_varchar2_table(1814) := '7D636C65617228297B746869732E5F6D61702E636C65617228292C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F73697A653D302C746869732E5F73746174652B2B7D6973456D70747928297B';
wwv_flow_imp.g_varchar2_table(1815) := '72657475726E21746869732E5F68656164262621746869732E5F7461696C7D6765742073697A6528297B72657475726E20746869732E5F73697A657D67657420666972737428297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E';
wwv_flow_imp.g_varchar2_table(1816) := '5F68656164297C7C766F696420303D3D3D653F766F696420303A652E76616C75657D676574206C61737428297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F7461696C297C7C766F696420303D3D3D653F766F696420303A65';
wwv_flow_imp.g_varchar2_table(1817) := '2E76616C75657D6861732865297B72657475726E20746869732E5F6D61702E6861732865297D67657428652C743D30297B636F6E7374206E3D746869732E5F6D61702E6765742865293B6966286E2972657475726E2030213D3D742626746869732E746F';
wwv_flow_imp.g_varchar2_table(1818) := '756368286E2C74292C6E2E76616C75657D73657428652C742C6E3D30297B6C657420693D746869732E5F6D61702E6765742865293B6966286929692E76616C75653D742C30213D3D6E2626746869732E746F75636828692C6E293B656C73657B73776974';
wwv_flow_imp.g_varchar2_table(1819) := '636828693D7B6B65793A652C76616C75653A742C6E6578743A766F696420302C70726576696F75733A766F696420307D2C6E297B6361736520303A6361736520323A64656661756C743A746869732E6164644974656D4C6173742869293B627265616B3B';
wwv_flow_imp.g_varchar2_table(1820) := '6361736520313A746869732E6164644974656D46697273742869297D746869732E5F6D61702E73657428652C69292C746869732E5F73697A652B2B7D72657475726E20746869737D64656C6574652865297B72657475726E2121746869732E72656D6F76';
wwv_flow_imp.g_varchar2_table(1821) := '652865297D72656D6F76652865297B636F6E737420743D746869732E5F6D61702E6765742865293B696628742972657475726E20746869732E5F6D61702E64656C6574652865292C746869732E72656D6F76654974656D2874292C746869732E5F73697A';
wwv_flow_imp.g_varchar2_table(1822) := '652D2D2C742E76616C75657D736869667428297B69662821746869732E5F68656164262621746869732E5F7461696C2972657475726E3B69662821746869732E5F686561647C7C21746869732E5F7461696C297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(1823) := '496E76616C6964206C69737422293B636F6E737420653D746869732E5F686561643B72657475726E20746869732E5F6D61702E64656C65746528652E6B6579292C746869732E72656D6F76654974656D2865292C746869732E5F73697A652D2D2C652E76';
wwv_flow_imp.g_varchar2_table(1824) := '616C75657D666F724561636828652C74297B636F6E7374206E3D746869732E5F73746174653B6C657420693D746869732E5F686561643B666F72283B693B297B696628743F652E62696E6428742928692E76616C75652C692E6B65792C74686973293A65';
wwv_flow_imp.g_varchar2_table(1825) := '28692E76616C75652C692E6B65792C74686973292C746869732E5F7374617465213D3D6E297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B693D69';
wwv_flow_imp.g_varchar2_table(1826) := '2E6E6578747D7D6B65797328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B6966';
wwv_flow_imp.g_varchar2_table(1827) := '28652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E6B6579';
wwv_flow_imp.g_varchar2_table(1828) := '2C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D76616C75657328297B636F6E737420653D746869732C743D746869732E5F7374';
wwv_flow_imp.g_varchar2_table(1829) := '6174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B6564';
wwv_flow_imp.g_varchar2_table(1830) := '4D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E76616C75652C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B';
wwv_flow_imp.g_varchar2_table(1831) := '76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D656E747269657328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D';
wwv_flow_imp.g_varchar2_table(1832) := '626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E';
wwv_flow_imp.g_varchar2_table(1833) := '22293B6966286E297B636F6E737420653D7B76616C75653A5B6E2E6B65792C6E2E76616C75655D2C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B7265';
wwv_flow_imp.g_varchar2_table(1834) := '7475726E20697D5B2862693D53796D626F6C2E746F537472696E675461672C53796D626F6C2E6974657261746F72295D28297B72657475726E20746869732E656E747269657328297D7472696D4F6C642865297B696628653E3D746869732E73697A6529';
wwv_flow_imp.g_varchar2_table(1835) := '72657475726E3B696628303D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F686561642C6E3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D61702E64656C65746528';
wwv_flow_imp.g_varchar2_table(1836) := '742E6B6579292C743D742E6E6578742C6E2D2D3B746869732E5F686561643D742C746869732E5F73697A653D6E2C74262628742E70726576696F75733D766F69642030292C746869732E5F73746174652B2B7D7472696D4E65772865297B696628653E3D';
wwv_flow_imp.g_varchar2_table(1837) := '746869732E73697A652972657475726E3B696628303D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F7461696C2C6E3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D';
wwv_flow_imp.g_varchar2_table(1838) := '61702E64656C65746528742E6B6579292C743D742E70726576696F75732C6E2D2D3B746869732E5F7461696C3D742C746869732E5F73697A653D6E2C74262628742E6E6578743D766F69642030292C746869732E5F73746174652B2B7D6164644974656D';
wwv_flow_imp.g_varchar2_table(1839) := '46697273742865297B696628746869732E5F686561647C7C746869732E5F7461696C297B69662821746869732E5F68656164297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E6E6578743D746869732E5F68656164';
wwv_flow_imp.g_varchar2_table(1840) := '2C746869732E5F686561642E70726576696F75733D657D656C736520746869732E5F7461696C3D653B746869732E5F686561643D652C746869732E5F73746174652B2B7D6164644974656D4C6173742865297B696628746869732E5F686561647C7C7468';
wwv_flow_imp.g_varchar2_table(1841) := '69732E5F7461696C297B69662821746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E70726576696F75733D746869732E5F7461696C2C746869732E5F7461696C2E6E6578743D657D656C73';
wwv_flow_imp.g_varchar2_table(1842) := '6520746869732E5F686561643D653B746869732E5F7461696C3D652C746869732E5F73746174652B2B7D72656D6F76654974656D2865297B696628653D3D3D746869732E5F686561642626653D3D3D746869732E5F7461696C29746869732E5F68656164';
wwv_flow_imp.g_varchar2_table(1843) := '3D766F696420302C746869732E5F7461696C3D766F696420303B656C736520696628653D3D3D746869732E5F68656164297B69662821652E6E657874297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E6E6578742E';
wwv_flow_imp.g_varchar2_table(1844) := '70726576696F75733D766F696420302C746869732E5F686561643D652E6E6578747D656C736520696628653D3D3D746869732E5F7461696C297B69662821652E70726576696F7573297468726F77206E6577204572726F722822496E76616C6964206C69';
wwv_flow_imp.g_varchar2_table(1845) := '737422293B652E70726576696F75732E6E6578743D766F696420302C746869732E5F7461696C3D652E70726576696F75737D656C73657B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B69662821747C7C216E297468726F77206E';
wwv_flow_imp.g_varchar2_table(1846) := '6577204572726F722822496E76616C6964206C69737422293B742E70726576696F75733D6E2C6E2E6E6578743D747D652E6E6578743D766F696420302C652E70726576696F75733D766F696420302C746869732E5F73746174652B2B7D746F7563682865';
wwv_flow_imp.g_varchar2_table(1847) := '2C74297B69662821746869732E5F686561647C7C21746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B696628313D3D3D747C7C323D3D3D7429696628313D3D3D74297B696628653D3D3D746869';
wwv_flow_imp.g_varchar2_table(1848) := '732E5F686561642972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F7461696C3F286E2E6E6578743D766F696420302C746869732E5F7461696C3D6E293A28742E70726576696F75733D6E';
wwv_flow_imp.g_varchar2_table(1849) := '2C6E2E6E6578743D74292C652E70726576696F75733D766F696420302C652E6E6578743D746869732E5F686561642C746869732E5F686561642E70726576696F75733D652C746869732E5F686561643D652C746869732E5F73746174652B2B7D656C7365';
wwv_flow_imp.g_varchar2_table(1850) := '20696628323D3D3D74297B696628653D3D3D746869732E5F7461696C2972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F686561643F28742E70726576696F75733D766F696420302C7468';
wwv_flow_imp.g_varchar2_table(1851) := '69732E5F686561643D74293A28742E70726576696F75733D6E2C6E2E6E6578743D74292C652E6E6578743D766F696420302C652E70726576696F75733D746869732E5F7461696C2C746869732E5F7461696C2E6E6578743D652C746869732E5F7461696C';
wwv_flow_imp.g_varchar2_table(1852) := '3D652C746869732E5F73746174652B2B7D7D746F4A534F4E28297B636F6E737420653D5B5D3B72657475726E20746869732E666F7245616368282828742C6E293D3E7B652E70757368285B6E2C745D297D29292C657D66726F6D4A534F4E2865297B7468';
wwv_flow_imp.g_varchar2_table(1853) := '69732E636C65617228293B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D7D636C617373204C6920657874656E64732078697B636F6E7374727563746F7228652C743D31297B737570657228292C746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(1854) := '6D69743D652C746869732E5F726174696F3D4D6174682E6D696E284D6174682E6D617828302C74292C31297D676574206C696D697428297B72657475726E20746869732E5F6C696D69747D736574206C696D69742865297B746869732E5F6C696D69743D';
wwv_flow_imp.g_varchar2_table(1855) := '652C746869732E636865636B5472696D28297D67657428652C743D32297B72657475726E2073757065722E67657428652C74297D7065656B2865297B72657475726E2073757065722E67657428652C30297D73657428652C74297B72657475726E207375';
wwv_flow_imp.g_varchar2_table(1856) := '7065722E73657428652C742C32292C746869737D636865636B5472696D28297B746869732E73697A653E746869732E5F6C696D69742626746869732E7472696D284D6174682E726F756E6428746869732E5F6C696D69742A746869732E5F726174696F29';
wwv_flow_imp.g_varchar2_table(1857) := '297D7D636C6173732043697B636F6E7374727563746F7228297B746869732E6D61703D6E6577204D61707D61646428652C74297B6C6574206E3D746869732E6D61702E6765742865293B6E7C7C286E3D6E6577205365742C746869732E6D61702E736574';
wwv_flow_imp.g_varchar2_table(1858) := '28652C6E29292C6E2E6164642874297D64656C65746528652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E2626286E2E64656C6574652874292C303D3D3D6E2E73697A652626746869732E6D61702E64656C657465286529297D';
wwv_flow_imp.g_varchar2_table(1859) := '666F724561636828652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E26266E2E666F72456163682874297D6765742865297B72657475726E20746869732E6D61702E6765742865297C7C6E6577205365747D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1860) := '6E20456928652C742C6E2C692C72297B72657475726E2066756E6374696F6E28652C742C6E2C692C72297B696628303D3D3D692972657475726E21303B636F6E7374206F3D742E63686172436F6465417428692D31293B69662830213D3D652E67657428';
wwv_flow_imp.g_varchar2_table(1861) := '6F292972657475726E21303B69662831333D3D3D6F7C7C31303D3D3D6F2972657475726E21303B696628723E30297B636F6E7374206E3D742E63686172436F646541742869293B69662830213D3D652E676574286E292972657475726E21307D72657475';
wwv_flow_imp.g_varchar2_table(1862) := '726E21317D28652C742C302C692C7229262666756E6374696F6E28652C742C6E2C692C72297B696628692B723D3D3D6E2972657475726E21303B636F6E7374206F3D742E63686172436F6465417428692B72293B69662830213D3D652E676574286F2929';
wwv_flow_imp.g_varchar2_table(1863) := '72657475726E21303B69662831333D3D3D6F7C7C31303D3D3D6F2972657475726E21303B696628723E30297B636F6E7374206E3D742E63686172436F6465417428692B722D31293B69662830213D3D652E676574286E292972657475726E21307D726574';
wwv_flow_imp.g_varchar2_table(1864) := '75726E21317D28652C742C6E2C692C72297D6E657720636C61737320657874656E6473204C697B636F6E7374727563746F7228652C743D31297B737570657228652C74297D7472696D2865297B746869732E7472696D4F6C642865297D73657428652C74';
wwv_flow_imp.g_varchar2_table(1865) := '297B72657475726E2073757065722E73657428652C74292C746869732E636865636B5472696D28292C746869737D7D283130292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D224365';
wwv_flow_imp.g_varchar2_table(1866) := '6E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D285F697C7C285F693D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465';
wwv_flow_imp.g_varchar2_table(1867) := '723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D2876697C7C2876693D7B7D29292C66756E6374696F6E2865297B655B652E426F74683D305D3D22426F7468222C655B652E52696768743D315D3D22526967687422';
wwv_flow_imp.g_varchar2_table(1868) := '2C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D2877697C7C2877693D7B7D29293B636C6173732041697B636F6E7374727563746F7228652C74297B746869732E5F776F7264536570617261746F72733D';
wwv_flow_imp.g_varchar2_table(1869) := '652C746869732E5F73656172636852656765783D742C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E6774683D307D72657365742865297B746869732E5F73656172636852656765';
wwv_flow_imp.g_varchar2_table(1870) := '782E6C617374496E6465783D652C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E6774683D307D6E6578742865297B636F6E737420743D652E6C656E6774683B6C6574206E3B646F';
wwv_flow_imp.g_varchar2_table(1871) := '7B696628746869732E5F707265764D617463685374617274496E6465782B746869732E5F707265764D617463684C656E6774683D3D3D742972657475726E206E756C6C3B6966286E3D746869732E5F73656172636852656765782E657865632865292C21';
wwv_flow_imp.g_varchar2_table(1872) := '6E2972657475726E206E756C6C3B636F6E737420693D6E2E696E6465782C723D6E5B305D2E6C656E6774683B696628693D3D3D746869732E5F707265764D617463685374617274496E6465782626723D3D3D746869732E5F707265764D617463684C656E';
wwv_flow_imp.g_varchar2_table(1873) := '677468297B696628303D3D3D72297B756528652C742C746869732E5F73656172636852656765782E6C617374496E646578293E36353533353F746869732E5F73656172636852656765782E6C617374496E6465782B3D323A746869732E5F736561726368';
wwv_flow_imp.g_varchar2_table(1874) := '52656765782E6C617374496E6465782B3D313B636F6E74696E75657D72657475726E206E756C6C7D696628746869732E5F707265764D617463685374617274496E6465783D692C746869732E5F707265764D617463684C656E6774683D722C2174686973';
wwv_flow_imp.g_varchar2_table(1875) := '2E5F776F7264536570617261746F72737C7C456928746869732E5F776F7264536570617261746F72732C652C742C692C72292972657475726E206E7D7768696C65286E293B72657475726E206E756C6C7D7D66756E6374696F6E20526928652C743D2255';
wwv_flow_imp.g_varchar2_table(1876) := '6E726561636861626C6522297B7468726F77206E6577204572726F722874297D66756E6374696F6E204D692865297B6528297C7C286528292C74286E657720612822417373657274696F6E204661696C6564222929297D66756E6374696F6E204E692865';
wwv_flow_imp.g_varchar2_table(1877) := '2C74297B6C6574206E3D303B666F72283B6E3C652E6C656E6774682D313B297B696628217428655B6E5D2C655B6E2B315D292972657475726E21313B6E2B2B7D72657475726E21307D636C6173732049697B73746174696320636F6D70757465556E6963';
wwv_flow_imp.g_varchar2_table(1878) := '6F6465486967686C696768747328652C742C6E297B636F6E737420693D6E3F6E2E73746172744C696E654E756D6265723A312C723D6E3F6E2E656E644C696E654E756D6265723A652E6765744C696E65436F756E7428292C6F3D6E6577207A692874292C';
wwv_flow_imp.g_varchar2_table(1879) := '613D6F2E67657443616E646964617465436F6465506F696E747328293B6C657420733B766172206C3B733D22616C6C4E6F6E42617369634173636969223D3D3D613F6E65772052656745787028225B5E5C5C745C5C6E5C5C725C5C7832302D5C5C783745';
wwv_flow_imp.g_varchar2_table(1880) := '5D222C226722293A6E65772052656745787028605B247B6C3D41727261792E66726F6D2861292E6D61702828653D3E537472696E672E66726F6D436F6465506F696E7428652929292E6A6F696E282222292C6C2E7265706C616365282F5B5C5C5C7B5C7D';
wwv_flow_imp.g_varchar2_table(1881) := '5C2A5C2B5C3F5C7C5C5E5C245C2E5C5B5C5D5C285C295D2F672C225C5C242622297D5D602C226722293B636F6E737420683D6E6577204169286E756C6C2C73292C633D5B5D3B6C657420642C753D21312C6D3D302C703D302C663D303B653A666F72286C';
wwv_flow_imp.g_varchar2_table(1882) := '657420743D692C6E3D723B743C3D6E3B742B2B297B636F6E7374206E3D652E6765744C696E65436F6E74656E742874292C693D6E2E6C656E6774683B682E72657365742830293B646F7B696628643D682E6E657874286E292C64297B6C657420653D642E';
wwv_flow_imp.g_varchar2_table(1883) := '696E6465782C723D642E696E6465782B645B305D2E6C656E6774683B653E3026266865286E2E63686172436F6465417428652D3129292626652D2D2C722B313C6926266865286E2E63686172436F6465417428722D3129292626722B2B3B636F6E737420';
wwv_flow_imp.g_varchar2_table(1884) := '613D6E2E737562737472696E6728652C72293B6C657420733D487428652B312C49742C6E2C30293B732626732E656E64436F6C756D6E3C3D652B31262628733D6E756C6C293B636F6E7374206C3D6F2E73686F756C64486967686C696768744E6F6E4261';
wwv_flow_imp.g_varchar2_table(1885) := '736963415343494928612C733F732E776F72643A6E756C6C293B69662830213D3D6C297B333D3D3D6C3F6D2B2B3A323D3D3D6C3F702B2B3A313D3D3D6C3F662B2B3A526928293B636F6E7374206E3D3165333B696628632E6C656E6774683E3D6E297B75';
wwv_flow_imp.g_varchar2_table(1886) := '3D21303B627265616B20657D632E70757368286E6577206B7428742C652B312C742C722B3129297D7D7D7768696C652864297D72657475726E7B72616E6765733A632C6861734D6F72653A752C616D626967756F7573436861726163746572436F756E74';
wwv_flow_imp.g_varchar2_table(1887) := '3A6D2C696E76697369626C65436861726163746572436F756E743A702C6E6F6E42617369634173636969436861726163746572436F756E743A667D7D73746174696320636F6D70757465556E69636F6465486967686C69676874526561736F6E28652C74';
wwv_flow_imp.g_varchar2_table(1888) := '297B636F6E7374206E3D6E6577207A692874293B737769746368286E2E73686F756C64486967686C696768744E6F6E4261736963415343494928652C6E756C6C29297B6361736520303A72657475726E206E756C6C3B6361736520323A72657475726E7B';
wwv_flow_imp.g_varchar2_table(1889) := '6B696E643A317D3B6361736520333A7B636F6E737420693D652E636F6465506F696E7441742830292C723D6E2E616D626967756F7573436861726163746572732E6765745072696D617279436F6E66757361626C652869292C6F3D66652E6765744C6F63';
wwv_flow_imp.g_varchar2_table(1890) := '616C657328292E66696C7465722828653D3E2166652E676574496E7374616E6365286E657720536574285B2E2E2E742E616C6C6F7765644C6F63616C65732C655D29292E6973416D626967756F757328692929293B72657475726E7B6B696E643A302C63';
wwv_flow_imp.g_varchar2_table(1891) := '6F6E66757361626C65576974683A537472696E672E66726F6D436F6465506F696E742872292C6E6F74416D626967756F7573496E4C6F63616C65733A6F7D7D6361736520313A72657475726E7B6B696E643A327D7D7D7D636C617373207A697B636F6E73';
wwv_flow_imp.g_varchar2_table(1892) := '74727563746F722865297B746869732E6F7074696F6E733D652C746869732E616C6C6F776564436F6465506F696E74733D6E65772053657428652E616C6C6F776564436F6465506F696E7473292C746869732E616D626967756F75734368617261637465';
wwv_flow_imp.g_varchar2_table(1893) := '72733D66652E676574496E7374616E6365286E65772053657428652E616C6C6F7765644C6F63616C657329297D67657443616E646964617465436F6465506F696E747328297B696628746869732E6F7074696F6E732E6E6F6E4261736963415343494929';
wwv_flow_imp.g_varchar2_table(1894) := '72657475726E22616C6C4E6F6E42617369634173636969223B636F6E737420653D6E6577205365743B696628746869732E6F7074696F6E732E696E76697369626C654368617261637465727329666F7228636F6E73742074206F662067652E636F646550';
wwv_flow_imp.g_varchar2_table(1895) := '6F696E747329556928537472696E672E66726F6D436F6465506F696E74287429297C7C652E6164642874293B696628746869732E6F7074696F6E732E616D626967756F75734368617261637465727329666F7228636F6E73742074206F6620746869732E';
wwv_flow_imp.g_varchar2_table(1896) := '616D626967756F7573436861726163746572732E676574436F6E66757361626C65436F6465506F696E7473282929652E6164642874293B666F7228636F6E73742074206F6620746869732E616C6C6F776564436F6465506F696E747329652E64656C6574';
wwv_flow_imp.g_varchar2_table(1897) := '652874293B72657475726E20657D73686F756C64486967686C696768744E6F6E4261736963415343494928652C74297B636F6E7374206E3D652E636F6465506F696E7441742830293B696628746869732E616C6C6F776564436F6465506F696E74732E68';
wwv_flow_imp.g_varchar2_table(1898) := '6173286E292972657475726E20303B696628746869732E6F7074696F6E732E6E6F6E426173696341534349492972657475726E20313B6C657420693D21312C723D21313B6966287429666F7228636F6E73742065206F662074297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(1899) := '2E636F6465506F696E7441742830292C6E3D286F3D652C6D652E74657374286F29293B693D697C7C6E2C6E7C7C746869732E616D626967756F7573436861726163746572732E6973416D626967756F75732874297C7C67652E6973496E76697369626C65';
wwv_flow_imp.g_varchar2_table(1900) := '4368617261637465722874297C7C28723D2130297D766172206F3B72657475726E21692626723F303A746869732E6F7074696F6E732E696E76697369626C65436861726163746572732626215569286529262667652E6973496E76697369626C65436861';
wwv_flow_imp.g_varchar2_table(1901) := '726163746572286E293F323A746869732E6F7074696F6E732E616D626967756F7573436861726163746572732626746869732E616D626967756F7573436861726163746572732E6973416D626967756F7573286E293F333A307D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1902) := '55692865297B72657475726E2220223D3D3D657C7C225C6E223D3D3D657C7C225C74223D3D3D657D636C6173732048697B636F6E7374727563746F7228652C742C6E297B746869732E6368616E6765733D652C746869732E6D6F7665733D742C74686973';
wwv_flow_imp.g_varchar2_table(1903) := '2E68697454696D656F75743D6E7D7D636C6173732044697B636F6E7374727563746F7228652C74297B746869732E6C696E6552616E67654D617070696E673D652C746869732E6368616E6765733D747D7D636C617373204F697B73746174696320616464';
wwv_flow_imp.g_varchar2_table(1904) := '52616E676528652C74297B6C6574206E3D303B666F72283B6E3C742E6C656E6774682626745B6E5D2E656E644578636C75736976653C652E73746172743B296E2B2B3B6C657420693D6E3B666F72283B693C742E6C656E6774682626745B695D2E737461';
wwv_flow_imp.g_varchar2_table(1905) := '72743C3D652E656E644578636C75736976653B29692B2B3B6966286E3D3D3D6929742E73706C696365286E2C302C65293B656C73657B636F6E737420723D4D6174682E6D696E28652E73746172742C745B6E5D2E7374617274292C6F3D4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(1906) := '7828652E656E644578636C75736976652C745B692D315D2E656E644578636C7573697665293B742E73706C696365286E2C692D6E2C6E6577204F6928722C6F29297D7D7374617469632074727943726561746528652C74297B6966282128653E74292972';
wwv_flow_imp.g_varchar2_table(1907) := '657475726E206E6577204F6928652C74297D737461746963206F664C656E6774682865297B72657475726E206E6577204F6928302C65297D737461746963206F665374617274416E644C656E67746828652C74297B72657475726E206E6577204F692865';
wwv_flow_imp.g_varchar2_table(1908) := '2C652B74297D636F6E7374727563746F7228652C74297B696628746869732E73746172743D652C746869732E656E644578636C75736976653D742C653E74297468726F77206E657720612860496E76616C69642072616E67653A20247B746869732E746F';
wwv_flow_imp.g_varchar2_table(1909) := '537472696E6728297D60297D676574206973456D70747928297B72657475726E20746869732E73746172743D3D3D746869732E656E644578636C75736976657D64656C74612865297B72657475726E206E6577204F6928746869732E73746172742B652C';
wwv_flow_imp.g_varchar2_table(1910) := '746869732E656E644578636C75736976652B65297D64656C746153746172742865297B72657475726E206E6577204F6928746869732E73746172742B652C746869732E656E644578636C7573697665297D64656C7461456E642865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(1911) := '6E6577204F6928746869732E73746172742C746869732E656E644578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644578636C75736976652D746869732E73746172747D746F537472696E6728297B72';
wwv_flow_imp.g_varchar2_table(1912) := '657475726E605B247B746869732E73746172747D2C20247B746869732E656E644578636C75736976657D29607D636F6E7461696E732865297B72657475726E20746869732E73746172743C3D652626653C746869732E656E644578636C75736976657D6A';
wwv_flow_imp.g_varchar2_table(1913) := '6F696E2865297B72657475726E206E6577204F69284D6174682E6D696E28746869732E73746172742C652E7374617274292C4D6174682E6D617828746869732E656E644578636C75736976652C652E656E644578636C757369766529297D696E74657273';
wwv_flow_imp.g_varchar2_table(1914) := '6563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172742C652E7374617274292C6E3D4D6174682E6D696E28746869732E656E644578636C75736976652C652E656E644578636C7573697665293B696628743C3D6E29726574';
wwv_flow_imp.g_varchar2_table(1915) := '75726E206E6577204F6928742C6E297D696E74657273656374732865297B72657475726E204D6174682E6D617828746869732E73746172742C652E7374617274293C4D6174682E6D696E28746869732E656E644578636C75736976652C652E656E644578';
wwv_flow_imp.g_varchar2_table(1916) := '636C7573697665297D69734265666F72652865297B72657475726E20746869732E656E644578636C75736976653C3D652E73746172747D697341667465722865297B72657475726E20746869732E73746172743E3D652E656E644578636C75736976657D';
wwv_flow_imp.g_varchar2_table(1917) := '736C6963652865297B72657475726E20652E736C69636528746869732E73746172742C746869732E656E644578636C7573697665297D737562737472696E672865297B72657475726E20652E737562737472696E6728746869732E73746172742C746869';
wwv_flow_imp.g_varchar2_table(1918) := '732E656E644578636C7573697665297D636C69702865297B696628746869732E6973456D707479297468726F77206E657720612860496E76616C696420636C697070696E672072616E67653A20247B746869732E746F537472696E6728297D60293B7265';
wwv_flow_imp.g_varchar2_table(1919) := '7475726E204D6174682E6D617828746869732E73746172742C4D6174682E6D696E28746869732E656E644578636C75736976652D312C6529297D636C69704379636C69632865297B696628746869732E6973456D707479297468726F77206E6577206128';
wwv_flow_imp.g_varchar2_table(1920) := '60496E76616C696420636C697070696E672072616E67653A20247B746869732E746F537472696E6728297D60293B72657475726E20653C746869732E73746172743F746869732E656E644578636C75736976652D28746869732E73746172742D65292574';
wwv_flow_imp.g_varchar2_table(1921) := '6869732E6C656E6774683A653E3D746869732E656E644578636C75736976653F746869732E73746172742B28652D746869732E73746172742925746869732E6C656E6774683A657D666F72456163682865297B666F72286C657420743D746869732E7374';
wwv_flow_imp.g_varchar2_table(1922) := '6172743B743C746869732E656E644578636C75736976653B742B2B29652874297D7D66756E6374696F6E20576928652C74297B636F6E7374206E3D506928652C74293B72657475726E2D313D3D3D6E3F766F696420303A655B6E5D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1923) := '20506928652C742C6E3D302C693D652E6C656E677468297B6C657420723D6E2C6F3D693B666F72283B723C6F3B297B636F6E7374206E3D4D6174682E666C6F6F722828722B6F292F32293B7428655B6E5D293F723D6E2B313A6F3D6E7D72657475726E20';
wwv_flow_imp.g_varchar2_table(1924) := '722D317D66756E6374696F6E20716928652C742C6E3D302C693D652E6C656E677468297B6C657420723D6E2C6F3D693B666F72283B723C6F3B297B636F6E7374206E3D4D6174682E666C6F6F722828722B6F292F32293B7428655B6E5D293F6F3D6E3A72';
wwv_flow_imp.g_varchar2_table(1925) := '3D6E2B317D72657475726E20727D636C6173732046697B636F6E7374727563746F722865297B746869732E5F61727261793D652C746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C6173744964783D307D66696E644C6173744D6F6E6F746F';
wwv_flow_imp.g_varchar2_table(1926) := '6E6F75732865297B69662846692E617373657274496E76617269616E7473297B696628746869732E5F7072657646696E644C61737450726564696361746529666F7228636F6E73742074206F6620746869732E5F617272617929696628746869732E5F70';
wwv_flow_imp.g_varchar2_table(1927) := '72657646696E644C61737450726564696361746528742926262165287429297468726F77206E6577204572726F7228224D6F6E6F746F6E6F757341727261793A2063757272656E7420707265646963617465206D757374206265207765616B6572207468';
wwv_flow_imp.g_varchar2_table(1928) := '616E20286F7220657175616C20746F29207468652070726576696F7573207072656469636174652E22293B746869732E5F7072657646696E644C6173745072656469636174653D657D636F6E737420743D506928746869732E5F61727261792C652C7468';
wwv_flow_imp.g_varchar2_table(1929) := '69732E5F66696E644C6173744D6F6E6F746F6E6F75734C617374496478293B72657475726E20746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C6173744964783D742B312C2D313D3D3D743F766F696420303A746869732E5F61727261795B';
wwv_flow_imp.g_varchar2_table(1930) := '745D7D7D46692E617373657274496E76617269616E74733D21313B636C6173732042697B7374617469632066726F6D52616E6765496E636C75736976652865297B72657475726E206E657720426928652E73746172744C696E654E756D6265722C652E65';
wwv_flow_imp.g_varchar2_table(1931) := '6E644C696E654E756D6265722B31297D737461746963206A6F696E4D616E792865297B696628303D3D3D652E6C656E6774682972657475726E5B5D3B6C657420743D6E657720566928655B305D2E736C6963652829293B666F72286C6574206E3D313B6E';
wwv_flow_imp.g_varchar2_table(1932) := '3C652E6C656E6774683B6E2B2B29743D742E676574556E696F6E286E657720566928655B6E5D2E736C696365282929293B72657475726E20742E72616E6765737D737461746963206A6F696E2865297B696628303D3D3D652E6C656E677468297468726F';
wwv_flow_imp.g_varchar2_table(1933) := '77206E6577206128226C696E6552616E6765732063616E6E6F7420626520656D70747922293B6C657420743D655B305D2E73746172744C696E654E756D6265722C6E3D655B305D2E656E644C696E654E756D6265724578636C75736976653B666F72286C';
wwv_flow_imp.g_varchar2_table(1934) := '657420693D313B693C652E6C656E6774683B692B2B29743D4D6174682E6D696E28742C655B695D2E73746172744C696E654E756D626572292C6E3D4D6174682E6D6178286E2C655B695D2E656E644C696E654E756D6265724578636C7573697665293B72';
wwv_flow_imp.g_varchar2_table(1935) := '657475726E206E657720426928742C6E297D737461746963206F664C656E67746828652C74297B72657475726E206E657720426928652C652B74297D73746174696320646573657269616C697A652865297B72657475726E206E657720426928655B305D';
wwv_flow_imp.g_varchar2_table(1936) := '2C655B315D297D636F6E7374727563746F7228652C74297B696628653E74297468726F77206E65772061286073746172744C696E654E756D62657220247B657D2063616E6E6F7420626520616674657220656E644C696E654E756D6265724578636C7573';
wwv_flow_imp.g_varchar2_table(1937) := '69766520247B747D60293B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D6265724578636C75736976653D747D636F6E7461696E732865297B72657475726E20746869732E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(1938) := '6265723C3D652626653C746869732E656E644C696E654E756D6265724578636C75736976657D676574206973456D70747928297B72657475726E20746869732E73746172744C696E654E756D6265723D3D3D746869732E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(1939) := '4578636C75736976657D64656C74612865297B72657475726E206E657720426928746869732E73746172744C696E654E756D6265722B652C746869732E656E644C696E654E756D6265724578636C75736976652B65297D64656C74614C656E6774682865';
wwv_flow_imp.g_varchar2_table(1940) := '297B72657475726E206E657720426928746869732E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644C696E65';
wwv_flow_imp.g_varchar2_table(1941) := '4E756D6265724578636C75736976652D746869732E73746172744C696E654E756D6265727D6A6F696E2865297B72657475726E206E6577204269284D6174682E6D696E28746869732E73746172744C696E654E756D6265722C652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(1942) := '4E756D626572292C4D6174682E6D617828746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E654E756D6265724578636C757369766529297D746F537472696E6728297B72657475726E605B247B746869732E7374';
wwv_flow_imp.g_varchar2_table(1943) := '6172744C696E654E756D6265727D2C247B746869732E656E644C696E654E756D6265724578636C75736976657D29607D696E746572736563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172744C696E654E756D6265722C65';
wwv_flow_imp.g_varchar2_table(1944) := '2E73746172744C696E654E756D626572292C6E3D4D6174682E6D696E28746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E654E756D6265724578636C7573697665293B696628743C3D6E2972657475726E206E65';
wwv_flow_imp.g_varchar2_table(1945) := '7720426928742C6E297D696E74657273656374735374726963742865297B72657475726E20746869732E73746172744C696E654E756D6265723C652E656E644C696E654E756D6265724578636C75736976652626652E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1946) := '723C746869732E656E644C696E654E756D6265724578636C75736976657D6F7665726C61704F72546F7563682865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(1947) := '652626652E73746172744C696E654E756D6265723C3D746869732E656E644C696E654E756D6265724578636C75736976657D657175616C732865297B72657475726E20746869732E73746172744C696E654E756D6265723D3D3D652E73746172744C696E';
wwv_flow_imp.g_varchar2_table(1948) := '654E756D6265722626746869732E656E644C696E654E756D6265724578636C75736976653D3D3D652E656E644C696E654E756D6265724578636C75736976657D746F496E636C757369766552616E676528297B72657475726E20746869732E6973456D70';
wwv_flow_imp.g_varchar2_table(1949) := '74793F6E756C6C3A6E6577206B7428746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445474552297D746F4578636C75';
wwv_flow_imp.g_varchar2_table(1950) := '7369766552616E676528297B72657475726E206E6577206B7428746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D6265724578636C75736976652C31297D6D6170546F4C696E6541727261792865297B636F';
wwv_flow_imp.g_varchar2_table(1951) := '6E737420743D5B5D3B666F72286C6574206E3D746869732E73746172744C696E654E756D6265723B6E3C746869732E656E644C696E654E756D6265724578636C75736976653B6E2B2B29742E707573682865286E29293B72657475726E20747D666F7245';
wwv_flow_imp.g_varchar2_table(1952) := '6163682865297B666F72286C657420743D746869732E73746172744C696E654E756D6265723B743C746869732E656E644C696E654E756D6265724578636C75736976653B742B2B29652874297D73657269616C697A6528297B72657475726E5B74686973';
wwv_flow_imp.g_varchar2_table(1953) := '2E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976655D7D696E636C756465732865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652626653C746869732E656E64';
wwv_flow_imp.g_varchar2_table(1954) := '4C696E654E756D6265724578636C75736976657D746F4F666673657452616E676528297B72657475726E206E6577204F6928746869732E73746172744C696E654E756D6265722D312C746869732E656E644C696E654E756D6265724578636C7573697665';
wwv_flow_imp.g_varchar2_table(1955) := '2D31297D7D636C6173732056697B636F6E7374727563746F7228653D5B5D297B746869732E5F6E6F726D616C697A656452616E6765733D657D6765742072616E67657328297B72657475726E20746869732E5F6E6F726D616C697A656452616E6765737D';
wwv_flow_imp.g_varchar2_table(1956) := '61646452616E67652865297B696628303D3D3D652E6C656E6774682972657475726E3B636F6E737420743D716928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D65';
wwv_flow_imp.g_varchar2_table(1957) := '2E73746172744C696E654E756D62657229292C6E3D506928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C757369766529292B313B69';
wwv_flow_imp.g_varchar2_table(1958) := '6628743D3D3D6E29746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C302C65293B656C736520696628743D3D3D6E2D31297B636F6E7374206E3D746869732E5F6E6F726D616C697A656452616E6765735B745D3B74686973';
wwv_flow_imp.g_varchar2_table(1959) := '2E5F6E6F726D616C697A656452616E6765735B745D3D6E2E6A6F696E2865297D656C73657B636F6E737420693D746869732E5F6E6F726D616C697A656452616E6765735B745D2E6A6F696E28746869732E5F6E6F726D616C697A656452616E6765735B6E';
wwv_flow_imp.g_varchar2_table(1960) := '2D315D292E6A6F696E2865293B746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C6E2D742C69297D7D636F6E7461696E732865297B636F6E737420743D576928746869732E5F6E6F726D616C697A656452616E6765732C28';
wwv_flow_imp.g_varchar2_table(1961) := '743D3E742E73746172744C696E654E756D6265723C3D6529293B72657475726E2121742626742E656E644C696E654E756D6265724578636C75736976653E657D696E74657273656374732865297B636F6E737420743D576928746869732E5F6E6F726D61';
wwv_flow_imp.g_varchar2_table(1962) := '6C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C652E656E644C696E654E756D6265724578636C757369766529293B72657475726E2121742626742E656E644C696E654E756D6265724578636C75736976653E652E73';
wwv_flow_imp.g_varchar2_table(1963) := '746172744C696E654E756D6265727D676574556E696F6E2865297B696628303D3D3D746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682972657475726E20653B696628303D3D3D652E5F6E6F726D616C697A656452616E6765732E';
wwv_flow_imp.g_varchar2_table(1964) := '6C656E6774682972657475726E20746869733B636F6E737420743D5B5D3B6C6574206E3D302C693D302C723D6E756C6C3B666F72283B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774687C7C693C652E5F6E6F726D616C697A';
wwv_flow_imp.g_varchar2_table(1965) := '656452616E6765732E6C656E6774683B297B6C6574206F3D6E756C6C3B6966286E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626693C652E5F6E6F726D616C697A656452616E6765732E6C656E677468297B636F6E7374';
wwv_flow_imp.g_varchar2_table(1966) := '20743D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C723D652E5F6E6F726D616C697A656452616E6765735B695D3B742E73746172744C696E654E756D6265723C722E73746172744C696E654E756D6265723F286F3D742C6E2B2B293A';
wwv_flow_imp.g_varchar2_table(1967) := '286F3D722C692B2B297D656C7365206E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774683F286F3D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C6E2B2B293A286F3D652E5F6E6F726D616C697A656452616E';
wwv_flow_imp.g_varchar2_table(1968) := '6765735B695D2C692B2B293B6E756C6C3D3D3D723F723D6F3A722E656E644C696E654E756D6265724578636C75736976653E3D6F2E73746172744C696E654E756D6265723F723D6E657720426928722E73746172744C696E654E756D6265722C4D617468';
wwv_flow_imp.g_varchar2_table(1969) := '2E6D617828722E656E644C696E654E756D6265724578636C75736976652C6F2E656E644C696E654E756D6265724578636C757369766529293A28742E707573682872292C723D6F297D72657475726E206E756C6C213D3D722626742E707573682872292C';
wwv_flow_imp.g_varchar2_table(1970) := '6E65772056692874297D737562747261637446726F6D2865297B636F6E737420743D716928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D652E73746172744C696E';
wwv_flow_imp.g_varchar2_table(1971) := '654E756D62657229292C6E3D506928746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C757369766529292B313B696628743D3D3D6E2972';
wwv_flow_imp.g_varchar2_table(1972) := '657475726E206E6577205669285B655D293B636F6E737420693D5B5D3B6C657420723D652E73746172744C696E654E756D6265723B666F72286C657420653D743B653C6E3B652B2B297B636F6E737420743D746869732E5F6E6F726D616C697A65645261';
wwv_flow_imp.g_varchar2_table(1973) := '6E6765735B655D3B742E73746172744C696E654E756D6265723E722626692E70757368286E657720426928722C742E73746172744C696E654E756D62657229292C723D742E656E644C696E654E756D6265724578636C75736976657D72657475726E2072';
wwv_flow_imp.g_varchar2_table(1974) := '3C652E656E644C696E654E756D6265724578636C75736976652626692E70757368286E657720426928722C652E656E644C696E654E756D6265724578636C757369766529292C6E65772056692869297D746F537472696E6728297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(1975) := '69732E5F6E6F726D616C697A656452616E6765732E6D61702828653D3E652E746F537472696E67282929292E6A6F696E28222C2022297D676574496E74657273656374696F6E2865297B636F6E737420743D5B5D3B6C6574206E3D302C693D303B666F72';
wwv_flow_imp.g_varchar2_table(1976) := '283B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626693C652E5F6E6F726D616C697A656452616E6765732E6C656E6774683B297B636F6E737420723D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C';
wwv_flow_imp.g_varchar2_table(1977) := '6F3D652E5F6E6F726D616C697A656452616E6765735B695D2C613D722E696E74657273656374286F293B61262621612E6973456D7074792626742E707573682861292C722E656E644C696E654E756D6265724578636C75736976653C6F2E656E644C696E';
wwv_flow_imp.g_varchar2_table(1978) := '654E756D6265724578636C75736976653F6E2B2B3A692B2B7D72657475726E206E65772056692874297D6765745769746844656C74612865297B72657475726E206E657720566928746869732E5F6E6F726D616C697A656452616E6765732E6D61702828';
wwv_flow_imp.g_varchar2_table(1979) := '743D3E742E64656C74612865292929297D7D636C617373204B697B737461746963206265747765656E506F736974696F6E7328652C74297B72657475726E20652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265723F6E6577204B6928302C';
wwv_flow_imp.g_varchar2_table(1980) := '742E636F6C756D6E2D652E636F6C756D6E293A6E6577204B6928742E6C696E654E756D6265722D652E6C696E654E756D6265722C742E636F6C756D6E2D31297D737461746963206F6652616E67652865297B72657475726E204B692E6265747765656E50';
wwv_flow_imp.g_varchar2_table(1981) := '6F736974696F6E7328652E6765745374617274506F736974696F6E28292C652E676574456E64506F736974696F6E2829297D737461746963206F66546578742865297B6C657420743D302C6E3D303B666F7228636F6E73742069206F66206529225C6E22';
wwv_flow_imp.g_varchar2_table(1982) := '3D3D3D693F28742B2B2C6E3D30293A6E2B2B3B72657475726E206E6577204B6928742C6E297D636F6E7374727563746F7228652C74297B746869732E6C696E65436F756E743D652C746869732E636F6C756D6E436F756E743D747D697347726561746572';
wwv_flow_imp.g_varchar2_table(1983) := '5468616E4F72457175616C546F2865297B72657475726E20746869732E6C696E65436F756E74213D3D652E6C696E65436F756E743F746869732E6C696E65436F756E743E652E6C696E65436F756E743A746869732E636F6C756D6E436F756E743E3D652E';
wwv_flow_imp.g_varchar2_table(1984) := '636F6C756D6E436F756E747D63726561746552616E67652865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E6577206B7428652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C';
wwv_flow_imp.g_varchar2_table(1985) := '756D6E2B746869732E636F6C756D6E436F756E74293A6E6577206B7428652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D61';
wwv_flow_imp.g_varchar2_table(1986) := '6464546F506F736974696F6E2865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E657720547428652E6C696E654E756D6265722C652E636F6C756D6E2B746869732E636F6C756D6E436F756E74293A6E657720547428652E6C69';
wwv_flow_imp.g_varchar2_table(1987) := '6E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D746F537472696E6728297B72657475726E60247B746869732E6C696E65436F756E747D2C247B746869732E636F6C756D6E436F756E747D60';
wwv_flow_imp.g_varchar2_table(1988) := '7D7D4B692E7A65726F3D6E6577204B6928302C30293B636C617373206A697B636F6E7374727563746F7228652C74297B746869732E72616E67653D652C746869732E746578743D747D7D636C6173732047697B73746174696320696E766572736528652C';
wwv_flow_imp.g_varchar2_table(1989) := '742C6E297B636F6E737420693D5B5D3B6C657420723D312C6F3D313B666F7228636F6E73742074206F662065297B636F6E737420653D6E6577204769286E657720426928722C742E6F726967696E616C2E73746172744C696E654E756D626572292C6E65';
wwv_flow_imp.g_varchar2_table(1990) := '77204269286F2C742E6D6F6469666965642E73746172744C696E654E756D62657229293B652E6D6F6469666965642E6973456D7074797C7C692E707573682865292C723D742E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(1991) := '652C6F3D742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976657D636F6E737420613D6E6577204769286E657720426928722C742B31292C6E6577204269286F2C6E2B3129293B72657475726E20612E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(1992) := '6973456D7074797C7C692E707573682861292C697D73746174696320636C697028652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E73742072206F662065297B636F6E737420653D722E6F726967696E616C2E696E74657273656374287429';
wwv_flow_imp.g_varchar2_table(1993) := '2C6F3D722E6D6F6469666965642E696E74657273656374286E293B65262621652E6973456D70747926266F2626216F2E6973456D7074792626692E70757368286E657720476928652C6F29297D72657475726E20697D636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(1994) := '74297B746869732E6F726967696E616C3D652C746869732E6D6F6469666965643D747D746F537472696E6728297B72657475726E607B247B746869732E6F726967696E616C2E746F537472696E6728297D2D3E247B746869732E6D6F6469666965642E74';
wwv_flow_imp.g_varchar2_table(1995) := '6F537472696E6728297D7D607D666C697028297B72657475726E206E657720476928746869732E6D6F6469666965642C746869732E6F726967696E616C297D6A6F696E2865297B72657475726E206E657720476928746869732E6F726967696E616C2E6A';
wwv_flow_imp.g_varchar2_table(1996) := '6F696E28652E6F726967696E616C292C746869732E6D6F6469666965642E6A6F696E28652E6D6F64696669656429297D746F52616E67654D617070696E6728297B636F6E737420653D746869732E6F726967696E616C2E746F496E636C75736976655261';
wwv_flow_imp.g_varchar2_table(1997) := '6E676528292C743D746869732E6D6F6469666965642E746F496E636C757369766552616E676528293B696628652626742972657475726E206E657720586928652C74293B696628313D3D3D746869732E6F726967696E616C2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(1998) := '6D6265727C7C313D3D3D746869732E6D6F6469666965642E73746172744C696E654E756D626572297B69662831213D3D746869732E6D6F6469666965642E73746172744C696E654E756D6265727C7C31213D3D746869732E6F726967696E616C2E737461';
wwv_flow_imp.g_varchar2_table(1999) := '72744C696E654E756D626572297468726F77206E6577206128226E6F7420612076616C6964206469666622293B72657475726E206E6577205869286E6577206B7428746869732E6F726967696E616C2E73746172744C696E654E756D6265722C312C7468';
wwv_flow_imp.g_varchar2_table(2000) := '69732E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C31292C6E6577206B7428746869732E6D6F6469666965642E73746172744C696E654E756D6265722C312C746869732E6D6F6469666965642E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(2001) := '6D6265724578636C75736976652C3129297D72657475726E206E6577205869286E6577206B7428746869732E6F726967696E616C2E73746172744C696E654E756D6265722D312C4E756D6265722E4D41585F534146455F494E54454745522C746869732E';
wwv_flow_imp.g_varchar2_table(2002) := '6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445474552292C6E6577206B7428746869732E6D6F6469666965642E73746172744C696E654E756D6265722D312C4E75';
wwv_flow_imp.g_varchar2_table(2003) := '6D6265722E4D41585F534146455F494E54454745522C746869732E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E544547455229297D7D636C61737320246920657874';
wwv_flow_imp.g_varchar2_table(2004) := '656E64732047697B7374617469632066726F6D52616E67654D617070696E67732865297B636F6E737420743D42692E6A6F696E28652E6D61702828653D3E42692E66726F6D52616E6765496E636C757369766528652E6F726967696E616C52616E676529';
wwv_flow_imp.g_varchar2_table(2005) := '2929292C6E3D42692E6A6F696E28652E6D61702828653D3E42692E66726F6D52616E6765496E636C757369766528652E6D6F64696669656452616E6765292929293B72657475726E206E657720246928742C6E2C65297D636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(2006) := '2C742C6E297B737570657228652C74292C746869732E696E6E65724368616E6765733D6E7D666C697028297B76617220653B72657475726E206E657720246928746869732E6D6F6469666965642C746869732E6F726967696E616C2C6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(2007) := '653D746869732E696E6E65724368616E676573297C7C766F696420303D3D3D653F766F696420303A652E6D61702828653D3E652E666C697028292929297D77697468496E6E65724368616E67657346726F6D4C696E6552616E67657328297B7265747572';
wwv_flow_imp.g_varchar2_table(2008) := '6E206E657720246928746869732E6F726967696E616C2C746869732E6D6F6469666965642C5B746869732E746F52616E67654D617070696E6728295D297D7D636C6173732058697B636F6E7374727563746F7228652C74297B746869732E6F726967696E';
wwv_flow_imp.g_varchar2_table(2009) := '616C52616E67653D652C746869732E6D6F64696669656452616E67653D747D746F537472696E6728297B72657475726E607B247B746869732E6F726967696E616C52616E67652E746F537472696E6728297D2D3E247B746869732E6D6F64696669656452';
wwv_flow_imp.g_varchar2_table(2010) := '616E67652E746F537472696E6728297D7D607D666C697028297B72657475726E206E657720586928746869732E6D6F64696669656452616E67652C746869732E6F726967696E616C52616E6765297D746F54657874456469742865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(2011) := '3D652E67657456616C75654F6652616E676528746869732E6D6F64696669656452616E6765293B72657475726E206E6577206A6928746869732E6F726967696E616C52616E67652C74297D7D636C617373204A697B636F6D707574654469666628652C74';
wwv_flow_imp.g_varchar2_table(2012) := '2C6E297B76617220693B636F6E737420723D6E6577206E7228652C742C7B6D6178436F6D7075746174696F6E54696D653A6E2E6D6178436F6D7075746174696F6E54696D654D732C73686F756C6449676E6F72655472696D576869746573706163653A6E';
wwv_flow_imp.g_varchar2_table(2013) := '2E69676E6F72655472696D576869746573706163652C73686F756C64436F6D70757465436861724368616E6765733A21302C73686F756C644D616B65507265747479446966663A21302C73686F756C64506F737450726F63657373436861724368616E67';
wwv_flow_imp.g_varchar2_table(2014) := '65733A21307D292E636F6D707574654469666628292C6F3D5B5D3B6C657420613D6E756C6C3B666F7228636F6E73742065206F6620722E6368616E676573297B6C657420742C6E3B743D303D3D3D652E6F726967696E616C456E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(2015) := '723F6E657720426928652E6F726967696E616C53746172744C696E654E756D6265722B312C652E6F726967696E616C53746172744C696E654E756D6265722B31293A6E657720426928652E6F726967696E616C53746172744C696E654E756D6265722C65';
wwv_flow_imp.g_varchar2_table(2016) := '2E6F726967696E616C456E644C696E654E756D6265722B31292C6E3D303D3D3D652E6D6F646966696564456E644C696E654E756D6265723F6E657720426928652E6D6F64696669656453746172744C696E654E756D6265722B312C652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2017) := '6453746172744C696E654E756D6265722B31293A6E657720426928652E6D6F64696669656453746172744C696E654E756D6265722C652E6D6F646966696564456E644C696E654E756D6265722B31293B6C657420723D6E657720246928742C6E2C6E756C';
wwv_flow_imp.g_varchar2_table(2018) := '6C3D3D3D28693D652E636861724368616E676573297C7C766F696420303D3D3D693F766F696420303A692E6D61702828653D3E6E6577205869286E6577206B7428652E6F726967696E616C53746172744C696E654E756D6265722C652E6F726967696E61';
wwv_flow_imp.g_varchar2_table(2019) := '6C5374617274436F6C756D6E2C652E6F726967696E616C456E644C696E654E756D6265722C652E6F726967696E616C456E64436F6C756D6E292C6E6577206B7428652E6D6F64696669656453746172744C696E654E756D6265722C652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2020) := '645374617274436F6C756D6E2C652E6D6F646966696564456E644C696E654E756D6265722C652E6D6F646966696564456E64436F6C756D6E29292929293B61262628612E6D6F6469666965642E656E644C696E654E756D6265724578636C757369766521';
wwv_flow_imp.g_varchar2_table(2021) := '3D3D722E6D6F6469666965642E73746172744C696E654E756D6265722626612E6F726967696E616C2E656E644C696E654E756D6265724578636C7573697665213D3D722E6F726967696E616C2E73746172744C696E654E756D6265727C7C28723D6E6577';
wwv_flow_imp.g_varchar2_table(2022) := '20246928612E6F726967696E616C2E6A6F696E28722E6F726967696E616C292C612E6D6F6469666965642E6A6F696E28722E6D6F646966696564292C612E696E6E65724368616E6765732626722E696E6E65724368616E6765733F612E696E6E65724368';
wwv_flow_imp.g_varchar2_table(2023) := '616E6765732E636F6E63617428722E696E6E65724368616E676573293A766F69642030292C6F2E706F70282929292C6F2E707573682872292C613D727D72657475726E204D69282828293D3E4E69286F2C2828652C74293D3E742E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(2024) := '73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965642E73746172744C696E654E756D6265722D652E6D6F6469666965642E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(2025) := '65724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E73746172744C696E654E756D6265722626652E6D6F6469666965642E656E644C696E654E756D62657245';
wwv_flow_imp.g_varchar2_table(2026) := '78636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D626572292929292C6E6577204869286F2C5B5D2C722E717569744561726C79297D7D66756E6374696F6E20596928652C742C6E2C69297B72657475726E206E6577205765';
wwv_flow_imp.g_varchar2_table(2027) := '28652C742C6E292E436F6D70757465446966662869297D636C6173732051697B636F6E7374727563746F722865297B636F6E737420743D5B5D2C6E3D5B5D3B666F72286C657420693D302C723D652E6C656E6774683B693C723B692B2B29745B695D3D69';
wwv_flow_imp.g_varchar2_table(2028) := '7228655B695D2C31292C6E5B695D3D727228655B695D2C31293B746869732E6C696E65733D652C746869732E5F7374617274436F6C756D6E733D742C746869732E5F656E64436F6C756D6E733D6E7D676574456C656D656E747328297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(2029) := '3D5B5D3B666F72286C657420743D302C6E3D746869732E6C696E65732E6C656E6774683B743C6E3B742B2B29655B745D3D746869732E6C696E65735B745D2E737562737472696E6728746869732E5F7374617274436F6C756D6E735B745D2D312C746869';
wwv_flow_imp.g_varchar2_table(2030) := '732E5F656E64436F6C756D6E735B745D2D31293B72657475726E20657D676574537472696374456C656D656E742865297B72657475726E20746869732E6C696E65735B655D7D67657453746172744C696E654E756D6265722865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(2031) := '2B317D676574456E644C696E654E756D6265722865297B72657475726E20652B317D6372656174654368617253657175656E636528652C742C6E297B636F6E737420693D5B5D2C723D5B5D2C6F3D5B5D3B6C657420613D303B666F72286C657420733D74';
wwv_flow_imp.g_varchar2_table(2032) := '3B733C3D6E3B732B2B297B636F6E737420743D746869732E6C696E65735B735D2C6C3D653F746869732E5F7374617274436F6C756D6E735B735D3A312C683D653F746869732E5F656E64436F6C756D6E735B735D3A742E6C656E6774682B313B666F7228';
wwv_flow_imp.g_varchar2_table(2033) := '6C657420653D6C3B653C683B652B2B29695B615D3D742E63686172436F6465417428652D31292C725B615D3D732B312C6F5B615D3D652C612B2B3B21652626733C6E262628695B615D3D31302C725B615D3D732B312C6F5B615D3D742E6C656E6774682B';
wwv_flow_imp.g_varchar2_table(2034) := '312C612B2B297D72657475726E206E6577205A6928692C722C6F297D7D636C617373205A697B636F6E7374727563746F7228652C742C6E297B746869732E5F63686172436F6465733D652C746869732E5F6C696E654E756D626572733D742C746869732E';
wwv_flow_imp.g_varchar2_table(2035) := '5F636F6C756D6E733D6E7D746F537472696E6728297B72657475726E225B222B746869732E5F63686172436F6465732E6D6170282828652C74293D3E2831303D3D3D653F225C5C6E223A537472696E672E66726F6D43686172436F6465286529292B602D';
wwv_flow_imp.g_varchar2_table(2036) := '28247B746869732E5F6C696E654E756D626572735B745D7D2C247B746869732E5F636F6C756D6E735B745D7D296029292E6A6F696E28222C2022292B225D227D5F617373657274496E64657828652C74297B696628653C307C7C653E3D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(2037) := '68297468726F77206E6577204572726F722822496C6C6567616C20696E64657822297D676574456C656D656E747328297B72657475726E20746869732E5F63686172436F6465737D67657453746172744C696E654E756D6265722865297B72657475726E';
wwv_flow_imp.g_varchar2_table(2038) := '20653E302626653D3D3D746869732E5F6C696E654E756D626572732E6C656E6774683F746869732E676574456E644C696E654E756D62657228652D31293A28746869732E5F617373657274496E64657828652C746869732E5F6C696E654E756D62657273';
wwv_flow_imp.g_varchar2_table(2039) := '292C746869732E5F6C696E654E756D626572735B655D297D676574456E644C696E654E756D6265722865297B72657475726E2D313D3D3D653F746869732E67657453746172744C696E654E756D62657228652B31293A28746869732E5F61737365727449';
wwv_flow_imp.g_varchar2_table(2040) := '6E64657828652C746869732E5F6C696E654E756D62657273292C31303D3D3D746869732E5F63686172436F6465735B655D3F746869732E5F6C696E654E756D626572735B655D2B313A746869732E5F6C696E654E756D626572735B655D297D6765745374';
wwv_flow_imp.g_varchar2_table(2041) := '617274436F6C756D6E2865297B72657475726E20653E302626653D3D3D746869732E5F636F6C756D6E732E6C656E6774683F746869732E676574456E64436F6C756D6E28652D31293A28746869732E5F617373657274496E64657828652C746869732E5F';
wwv_flow_imp.g_varchar2_table(2042) := '636F6C756D6E73292C746869732E5F636F6C756D6E735B655D297D676574456E64436F6C756D6E2865297B72657475726E2D313D3D3D653F746869732E6765745374617274436F6C756D6E28652B31293A28746869732E5F617373657274496E64657828';
wwv_flow_imp.g_varchar2_table(2043) := '652C746869732E5F636F6C756D6E73292C31303D3D3D746869732E5F63686172436F6465735B655D3F313A746869732E5F636F6C756D6E735B655D2B31297D7D636C6173732065727B636F6E7374727563746F7228652C742C6E2C692C722C6F2C612C73';
wwv_flow_imp.g_varchar2_table(2044) := '297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C5374617274436F6C756D6E3D742C746869732E6F726967696E616C456E644C696E654E756D6265723D6E2C746869732E6F726967696E';
wwv_flow_imp.g_varchar2_table(2045) := '616C456E64436F6C756D6E3D692C746869732E6D6F64696669656453746172744C696E654E756D6265723D722C746869732E6D6F6469666965645374617274436F6C756D6E3D6F2C746869732E6D6F646966696564456E644C696E654E756D6265723D61';
wwv_flow_imp.g_varchar2_table(2046) := '2C746869732E6D6F646966696564456E64436F6C756D6E3D737D7374617469632063726561746546726F6D446966664368616E676528652C742C6E297B636F6E737420693D742E67657453746172744C696E654E756D62657228652E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2047) := '5374617274292C723D742E6765745374617274436F6C756D6E28652E6F726967696E616C5374617274292C6F3D742E676574456E644C696E654E756D62657228652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C';
wwv_flow_imp.g_varchar2_table(2048) := '613D742E676574456E64436F6C756D6E28652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C733D6E2E67657453746172744C696E654E756D62657228652E6D6F6469666965645374617274292C6C3D6E2E676574';
wwv_flow_imp.g_varchar2_table(2049) := '5374617274436F6C756D6E28652E6D6F6469666965645374617274292C683D6E2E676574456E644C696E654E756D62657228652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682D31292C633D6E2E676574456E64436F6C75';
wwv_flow_imp.g_varchar2_table(2050) := '6D6E28652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682D31293B72657475726E206E657720657228692C722C6F2C612C732C6C2C682C63297D7D636C6173732074727B636F6E7374727563746F7228652C742C6E2C692C';
wwv_flow_imp.g_varchar2_table(2051) := '72297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C456E644C696E654E756D6265723D742C746869732E6D6F64696669656453746172744C696E654E756D6265723D6E2C746869732E6D';
wwv_flow_imp.g_varchar2_table(2052) := '6F646966696564456E644C696E654E756D6265723D692C746869732E636861724368616E6765733D727D7374617469632063726561746546726F6D44696666526573756C7428652C742C6E2C692C722C6F2C61297B6C657420732C6C2C682C632C643B69';
wwv_flow_imp.g_varchar2_table(2053) := '6628303D3D3D742E6F726967696E616C4C656E6774683F28733D6E2E67657453746172744C696E654E756D62657228742E6F726967696E616C5374617274292D312C6C3D30293A28733D6E2E67657453746172744C696E654E756D62657228742E6F7269';
wwv_flow_imp.g_varchar2_table(2054) := '67696E616C5374617274292C6C3D6E2E676574456E644C696E654E756D62657228742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D3129292C303D3D3D742E6D6F6469666965644C656E6774683F28683D692E67657453';
wwv_flow_imp.g_varchar2_table(2055) := '746172744C696E654E756D62657228742E6D6F6469666965645374617274292D312C633D30293A28683D692E67657453746172744C696E654E756D62657228742E6D6F6469666965645374617274292C633D692E676574456E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(2056) := '28742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D3129292C6F2626742E6F726967696E616C4C656E6774683E302626742E6F726967696E616C4C656E6774683C32302626742E6D6F6469666965644C656E6774683E30';
wwv_flow_imp.g_varchar2_table(2057) := '2626742E6D6F6469666965644C656E6774683C32302626722829297B636F6E7374206F3D6E2E6372656174654368617253657175656E636528652C742E6F726967696E616C53746172742C742E6F726967696E616C53746172742B742E6F726967696E61';
wwv_flow_imp.g_varchar2_table(2058) := '6C4C656E6774682D31292C733D692E6372656174654368617253657175656E636528652C742E6D6F64696669656453746172742C742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D31293B6966286F2E676574456C656D';
wwv_flow_imp.g_varchar2_table(2059) := '656E747328292E6C656E6774683E302626732E676574456C656D656E747328292E6C656E6774683E30297B6C657420653D5969286F2C732C722C2130292E6368616E6765733B61262628653D66756E6374696F6E2865297B696628652E6C656E6774683C';
wwv_flow_imp.g_varchar2_table(2060) := '3D312972657475726E20653B636F6E737420743D5B655B305D5D3B6C6574206E3D745B305D3B666F72286C657420693D312C723D652E6C656E6774683B693C723B692B2B297B636F6E737420723D655B695D2C6F3D722E6F726967696E616C5374617274';
wwv_flow_imp.g_varchar2_table(2061) := '2D286E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E677468292C613D722E6D6F64696669656453746172742D286E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E677468293B4D6174682E6D696E286F2C';
wwv_flow_imp.g_varchar2_table(2062) := '61293C333F286E2E6F726967696E616C4C656E6774683D722E6F726967696E616C53746172742B722E6F726967696E616C4C656E6774682D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D722E6D6F64696669656453';
wwv_flow_imp.g_varchar2_table(2063) := '746172742B722E6D6F6469666965644C656E6774682D6E2E6D6F6469666965645374617274293A28742E707573682872292C6E3D72297D72657475726E20747D286529292C643D5B5D3B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E';
wwv_flow_imp.g_varchar2_table(2064) := '3B742B2B29642E707573682865722E63726561746546726F6D446966664368616E676528655B745D2C6F2C7329297D7D72657475726E206E657720747228732C6C2C682C632C64297D7D636C617373206E727B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(2065) := '297B746869732E73686F756C64436F6D70757465436861724368616E6765733D6E2E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E6765733D6E2E73686F756C';
wwv_flow_imp.g_varchar2_table(2066) := '64506F737450726F63657373436861724368616E6765732C746869732E73686F756C6449676E6F72655472696D576869746573706163653D6E2E73686F756C6449676E6F72655472696D576869746573706163652C746869732E73686F756C644D616B65';
wwv_flow_imp.g_varchar2_table(2067) := '507265747479446966663D6E2E73686F756C644D616B65507265747479446966662C746869732E6F726967696E616C4C696E65733D652C746869732E6D6F6469666965644C696E65733D742C746869732E6F726967696E616C3D6E65772051692865292C';
wwv_flow_imp.g_varchar2_table(2068) := '746869732E6D6F6469666965643D6E65772051692874292C746869732E636F6E74696E75654C696E65446966663D6F72286E2E6D6178436F6D7075746174696F6E54696D65292C746869732E636F6E74696E756543686172446966663D6F7228303D3D3D';
wwv_flow_imp.g_varchar2_table(2069) := '6E2E6D6178436F6D7075746174696F6E54696D653F303A4D6174682E6D696E286E2E6D6178436F6D7075746174696F6E54696D652C35653329297D636F6D707574654469666628297B696628313D3D3D746869732E6F726967696E616C2E6C696E65732E';
wwv_flow_imp.g_varchar2_table(2070) := '6C656E6774682626303D3D3D746869732E6F726967696E616C2E6C696E65735B305D2E6C656E6774682972657475726E20313D3D3D746869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C';
wwv_flow_imp.g_varchar2_table(2071) := '696E65735B305D2E6C656E6774683F7B717569744561726C793A21312C6368616E6765733A5B5D7D3A7B717569744561726C793A21312C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C45';
wwv_flow_imp.g_varchar2_table(2072) := '6E644C696E654E756D6265723A312C6D6F64696669656453746172744C696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A746869732E6D6F6469666965642E6C696E65732E6C656E6774682C636861724368616E6765';
wwv_flow_imp.g_varchar2_table(2073) := '733A766F696420307D5D7D3B696628313D3D3D746869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C696E65735B305D2E6C656E6774682972657475726E7B717569744561726C793A2131';
wwv_flow_imp.g_varchar2_table(2074) := '2C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C456E644C696E654E756D6265723A746869732E6F726967696E616C2E6C696E65732E6C656E6774682C6D6F64696669656453746172744C';
wwv_flow_imp.g_varchar2_table(2075) := '696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A312C636861724368616E6765733A766F696420307D5D7D3B636F6E737420653D596928746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869';
wwv_flow_imp.g_varchar2_table(2076) := '732E636F6E74696E75654C696E65446966662C746869732E73686F756C644D616B6550726574747944696666292C743D652E6368616E6765732C6E3D652E717569744561726C793B696628746869732E73686F756C6449676E6F72655472696D57686974';
wwv_flow_imp.g_varchar2_table(2077) := '657370616365297B636F6E737420653D5B5D3B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29652E707573682874722E63726561746546726F6D44696666526573756C7428746869732E73686F756C6449676E6F72655472';
wwv_flow_imp.g_varchar2_table(2078) := '696D576869746573706163652C745B6E5D2C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E756543686172446966662C746869732E73686F756C64436F6D70757465436861724368616E6765732C7468';
wwv_flow_imp.g_varchar2_table(2079) := '69732E73686F756C64506F737450726F63657373436861724368616E67657329293B72657475726E7B717569744561726C793A6E2C6368616E6765733A657D7D636F6E737420693D5B5D3B6C657420723D302C6F3D303B666F72286C657420653D2D312C';
wwv_flow_imp.g_varchar2_table(2080) := '6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E737420613D652B313C6E3F745B652B315D3A6E756C6C2C733D613F612E6F726967696E616C53746172743A746869732E6F726967696E616C4C696E65732E6C656E6774682C6C3D613F612E6D6F';
wwv_flow_imp.g_varchar2_table(2081) := '64696669656453746172743A746869732E6D6F6469666965644C696E65732E6C656E6774683B666F72283B723C7326266F3C6C3B297B636F6E737420653D746869732E6F726967696E616C4C696E65735B725D2C743D746869732E6D6F6469666965644C';
wwv_flow_imp.g_varchar2_table(2082) := '696E65735B6F5D3B69662865213D3D74297B7B6C6574206E3D697228652C31292C613D697228742C31293B666F72283B6E3E312626613E312626652E63686172436F64654174286E2D32293D3D3D742E63686172436F6465417428612D32293B296E2D2D';
wwv_flow_imp.g_varchar2_table(2083) := '2C612D2D3B286E3E317C7C613E31292626746869732E5F707573685472696D57686974657370616365436861724368616E676528692C722B312C312C6E2C6F2B312C312C61297D7B6C6574206E3D727228652C31292C613D727228742C31293B636F6E73';
wwv_flow_imp.g_varchar2_table(2084) := '7420733D652E6C656E6774682B312C6C3D742E6C656E6774682B313B666F72283B6E3C732626613C6C2626652E63686172436F64654174286E2D31293D3D3D652E63686172436F6465417428612D31293B296E2B2B2C612B2B3B286E3C737C7C613C6C29';
wwv_flow_imp.g_varchar2_table(2085) := '2626746869732E5F707573685472696D57686974657370616365436861724368616E676528692C722B312C6E2C732C6F2B312C612C6C297D7D722B2B2C6F2B2B7D61262628692E707573682874722E63726561746546726F6D44696666526573756C7428';
wwv_flow_imp.g_varchar2_table(2086) := '746869732E73686F756C6449676E6F72655472696D576869746573706163652C612C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E756543686172446966662C746869732E73686F756C64436F6D7075';
wwv_flow_imp.g_varchar2_table(2087) := '7465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E67657329292C722B3D612E6F726967696E616C4C656E6774682C6F2B3D612E6D6F6469666965644C656E677468297D72657475726E7B7175';
wwv_flow_imp.g_varchar2_table(2088) := '69744561726C793A6E2C6368616E6765733A697D7D5F707573685472696D57686974657370616365436861724368616E676528652C742C6E2C692C722C6F2C61297B696628746869732E5F6D657267655472696D57686974657370616365436861724368';
wwv_flow_imp.g_varchar2_table(2089) := '616E676528652C742C6E2C692C722C6F2C61292972657475726E3B6C657420733B746869732E73686F756C64436F6D70757465436861724368616E676573262628733D5B6E657720657228742C6E2C742C692C722C6F2C722C61295D292C652E70757368';
wwv_flow_imp.g_varchar2_table(2090) := '286E657720747228742C742C722C722C7329297D5F6D657267655472696D57686974657370616365436861724368616E676528652C742C6E2C692C722C6F2C61297B636F6E737420733D652E6C656E6774683B696628303D3D3D732972657475726E2131';
wwv_flow_imp.g_varchar2_table(2091) := '3B636F6E7374206C3D655B732D315D3B72657475726E2030213D3D6C2E6F726967696E616C456E644C696E654E756D626572262630213D3D6C2E6D6F646966696564456E644C696E654E756D6265722626286C2E6F726967696E616C456E644C696E654E';
wwv_flow_imp.g_varchar2_table(2092) := '756D6265723D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265723D3D3D723F28746869732E73686F756C64436F6D70757465436861724368616E67657326266C2E636861724368616E67657326266C2E636861724368616E6765732E';
wwv_flow_imp.g_varchar2_table(2093) := '70757368286E657720657228742C6E2C742C692C722C6F2C722C6129292C2130293A6C2E6F726967696E616C456E644C696E654E756D6265722B313D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265722B313D3D3D722626286C2E6F';
wwv_flow_imp.g_varchar2_table(2094) := '726967696E616C456E644C696E654E756D6265723D742C6C2E6D6F646966696564456E644C696E654E756D6265723D722C746869732E73686F756C64436F6D70757465436861724368616E67657326266C2E636861724368616E67657326266C2E636861';
wwv_flow_imp.g_varchar2_table(2095) := '724368616E6765732E70757368286E657720657228742C6E2C742C692C722C6F2C722C6129292C213029297D7D66756E6374696F6E20697228652C74297B636F6E7374206E3D66756E6374696F6E2865297B666F72286C657420743D302C6E3D652E6C65';
wwv_flow_imp.g_varchar2_table(2096) := '6E6774683B743C6E3B742B2B297B636F6E7374206E3D652E63686172436F646541742874293B6966283332213D3D6E262639213D3D6E2972657475726E20747D72657475726E2D317D2865293B72657475726E2D313D3D3D6E3F743A6E2B317D66756E63';
wwv_flow_imp.g_varchar2_table(2097) := '74696F6E20727228652C74297B636F6E7374206E3D66756E6374696F6E28652C743D652E6C656E6774682D31297B666F72286C6574206E3D743B6E3E3D303B6E2D2D297B636F6E737420743D652E63686172436F64654174286E293B6966283332213D3D';
wwv_flow_imp.g_varchar2_table(2098) := '74262639213D3D742972657475726E206E7D72657475726E2D317D2865293B72657475726E2D313D3D3D6E3F743A6E2B327D66756E6374696F6E206F722865297B696628303D3D3D652972657475726E28293D3E21303B636F6E737420743D446174652E';
wwv_flow_imp.g_varchar2_table(2099) := '6E6F7728293B72657475726E28293D3E446174652E6E6F7728292D743C657D636C6173732061727B737461746963207472697669616C28652C74297B72657475726E206E6577206172285B6E6577207372284F692E6F664C656E67746828652E6C656E67';
wwv_flow_imp.g_varchar2_table(2100) := '7468292C4F692E6F664C656E67746828742E6C656E67746829295D2C2131297D737461746963207472697669616C54696D65644F757428652C74297B72657475726E206E6577206172285B6E6577207372284F692E6F664C656E67746828652E6C656E67';
wwv_flow_imp.g_varchar2_table(2101) := '7468292C4F692E6F664C656E67746828742E6C656E67746829295D2C2130297D636F6E7374727563746F7228652C74297B746869732E64696666733D652C746869732E68697454696D656F75743D747D7D636C6173732073727B73746174696320696E76';
wwv_flow_imp.g_varchar2_table(2102) := '65727428652C74297B636F6E7374206E3D5B5D3B72657475726E2066756E6374696F6E2865297B666F72286C6574206F3D303B6F3C3D652E6C656E6774683B6F2B2B29693D303D3D3D6F3F766F696420303A655B6F2D315D2C723D6F3D3D3D652E6C656E';
wwv_flow_imp.g_varchar2_table(2103) := '6774683F766F696420303A655B6F5D2C6E2E707573682873722E66726F6D4F6666736574506169727328693F692E676574456E644578636C75736976657328293A6C722E7A65726F2C723F722E67657453746172747328293A6E6577206C7228742C2869';
wwv_flow_imp.g_varchar2_table(2104) := '3F692E7365713252616E67652E656E644578636C75736976652D692E7365713152616E67652E656E644578636C75736976653A30292B742929293B76617220692C727D2865292C6E7D7374617469632066726F6D4F6666736574506169727328652C7429';
wwv_flow_imp.g_varchar2_table(2105) := '7B72657475726E206E6577207372286E6577204F6928652E6F6666736574312C742E6F666673657431292C6E6577204F6928652E6F6666736574322C742E6F66667365743229297D636F6E7374727563746F7228652C74297B746869732E736571315261';
wwv_flow_imp.g_varchar2_table(2106) := '6E67653D652C746869732E7365713252616E67653D747D7377617028297B72657475726E206E657720737228746869732E7365713252616E67652C746869732E7365713152616E6765297D746F537472696E6728297B72657475726E60247B746869732E';
wwv_flow_imp.g_varchar2_table(2107) := '7365713152616E67657D203C2D3E20247B746869732E7365713252616E67657D607D6A6F696E2865297B72657475726E206E657720737228746869732E7365713152616E67652E6A6F696E28652E7365713152616E6765292C746869732E736571325261';
wwv_flow_imp.g_varchar2_table(2108) := '6E67652E6A6F696E28652E7365713252616E676529297D64656C74612865297B72657475726E20303D3D3D653F746869733A6E657720737228746869732E7365713152616E67652E64656C74612865292C746869732E7365713252616E67652E64656C74';
wwv_flow_imp.g_varchar2_table(2109) := '61286529297D64656C746153746172742865297B72657475726E20303D3D3D653F746869733A6E657720737228746869732E7365713152616E67652E64656C746153746172742865292C746869732E7365713252616E67652E64656C7461537461727428';
wwv_flow_imp.g_varchar2_table(2110) := '6529297D64656C7461456E642865297B72657475726E20303D3D3D653F746869733A6E657720737228746869732E7365713152616E67652E64656C7461456E642865292C746869732E7365713252616E67652E64656C7461456E64286529297D696E7465';
wwv_flow_imp.g_varchar2_table(2111) := '72736563742865297B636F6E737420743D746869732E7365713152616E67652E696E7465727365637428652E7365713152616E6765292C6E3D746869732E7365713252616E67652E696E7465727365637428652E7365713252616E6765293B6966287426';
wwv_flow_imp.g_varchar2_table(2112) := '266E2972657475726E206E657720737228742C6E297D67657453746172747328297B72657475726E206E6577206C7228746869732E7365713152616E67652E73746172742C746869732E7365713252616E67652E7374617274297D676574456E64457863';
wwv_flow_imp.g_varchar2_table(2113) := '6C75736976657328297B72657475726E206E6577206C7228746869732E7365713152616E67652E656E644578636C75736976652C746869732E7365713252616E67652E656E644578636C7573697665297D7D636C617373206C727B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(2114) := '6F7228652C74297B746869732E6F6666736574313D652C746869732E6F6666736574323D747D746F537472696E6728297B72657475726E60247B746869732E6F6666736574317D203C2D3E20247B746869732E6F6666736574327D607D64656C74612865';
wwv_flow_imp.g_varchar2_table(2115) := '297B72657475726E20303D3D3D653F746869733A6E6577206C7228746869732E6F6666736574312B652C746869732E6F6666736574322B65297D657175616C732865297B72657475726E20746869732E6F6666736574313D3D3D652E6F66667365743126';
wwv_flow_imp.g_varchar2_table(2116) := '26746869732E6F6666736574323D3D3D652E6F6666736574327D7D6C722E7A65726F3D6E6577206C7228302C30292C6C722E6D61783D6E6577206C72284E756D6265722E4D41585F534146455F494E54454745522C4E756D6265722E4D41585F53414645';
wwv_flow_imp.g_varchar2_table(2117) := '5F494E5445474552293B636C6173732068727B697356616C696428297B72657475726E21307D7D68722E696E7374616E63653D6E65772068723B636C6173732063727B636F6E7374727563746F722865297B696628746869732E74696D656F75743D652C';
wwv_flow_imp.g_varchar2_table(2118) := '746869732E737461727454696D653D446174652E6E6F7728292C746869732E76616C69643D21302C653C3D30297468726F77206E65772061282274696D656F7574206D75737420626520706F73697469766522297D697356616C696428297B7265747572';
wwv_flow_imp.g_varchar2_table(2119) := '6E2128446174652E6E6F7728292D746869732E737461727454696D653C746869732E74696D656F7574292626746869732E76616C6964262628746869732E76616C69643D2131292C746869732E76616C69647D7D636C6173732064727B636F6E73747275';
wwv_flow_imp.g_varchar2_table(2120) := '63746F7228652C74297B746869732E77696474683D652C746869732E6865696768743D742C746869732E61727261793D5B5D2C746869732E61727261793D6E657720417272617928652A74297D67657428652C74297B72657475726E20746869732E6172';
wwv_flow_imp.g_varchar2_table(2121) := '7261795B652B742A746869732E77696474685D7D73657428652C742C6E297B746869732E61727261795B652B742A746869732E77696474685D3D6E7D7D66756E6374696F6E2075722865297B72657475726E2033323D3D3D657C7C393D3D3D657D636C61';
wwv_flow_imp.g_varchar2_table(2122) := '7373206D727B737461746963206765744B65792865297B6C657420743D746869732E6368724B6579732E6765742865293B72657475726E20766F696420303D3D3D74262628743D746869732E6368724B6579732E73697A652C746869732E6368724B6579';
wwv_flow_imp.g_varchar2_table(2123) := '732E73657428652C7429292C747D636F6E7374727563746F7228652C742C6E297B746869732E72616E67653D652C746869732E6C696E65733D742C746869732E736F757263653D6E2C746869732E686973746F6772616D3D5B5D3B6C657420693D303B66';
wwv_flow_imp.g_varchar2_table(2124) := '6F72286C6574206E3D652E73746172744C696E654E756D6265722D313B6E3C652E656E644C696E654E756D6265724578636C75736976652D313B6E2B2B297B636F6E737420653D745B6E5D3B666F72286C657420743D303B743C652E6C656E6774683B74';
wwv_flow_imp.g_varchar2_table(2125) := '2B2B297B692B2B3B636F6E7374206E3D655B745D2C723D6D722E6765744B6579286E293B746869732E686973746F6772616D5B725D3D28746869732E686973746F6772616D5B725D7C7C30292B317D692B2B3B636F6E737420723D6D722E6765744B6579';
wwv_flow_imp.g_varchar2_table(2126) := '28225C6E22293B746869732E686973746F6772616D5B725D3D28746869732E686973746F6772616D5B725D7C7C30292B317D746869732E746F74616C436F756E743D697D636F6D7075746553696D696C61726974792865297B76617220742C6E3B6C6574';
wwv_flow_imp.g_varchar2_table(2127) := '20693D303B636F6E737420723D4D6174682E6D617828746869732E686973746F6772616D2E6C656E6774682C652E686973746F6772616D2E6C656E677468293B666F72286C6574206F3D303B6F3C723B6F2B2B29692B3D4D6174682E61627328286E756C';
wwv_flow_imp.g_varchar2_table(2128) := '6C213D3D28743D746869732E686973746F6772616D5B6F5D292626766F69642030213D3D743F743A30292D286E756C6C213D3D286E3D652E686973746F6772616D5B6F5D292626766F69642030213D3D6E3F6E3A3029293B72657475726E20312D692F28';
wwv_flow_imp.g_varchar2_table(2129) := '746869732E746F74616C436F756E742B652E746F74616C436F756E74297D7D6D722E6368724B6579733D6E6577204D61703B636C6173732070727B636F6D7075746528652C742C6E3D68722E696E7374616E63652C69297B696628303D3D3D652E6C656E';
wwv_flow_imp.g_varchar2_table(2130) := '6774687C7C303D3D3D742E6C656E6774682972657475726E2061722E7472697669616C28652C74293B636F6E737420723D6E657720647228652E6C656E6774682C742E6C656E677468292C6F3D6E657720647228652E6C656E6774682C742E6C656E6774';
wwv_flow_imp.g_varchar2_table(2131) := '68292C613D6E657720647228652E6C656E6774682C742E6C656E677468293B666F72286C657420733D303B733C652E6C656E6774683B732B2B29666F72286C6574206C3D303B6C3C742E6C656E6774683B6C2B2B297B696628216E2E697356616C696428';
wwv_flow_imp.g_varchar2_table(2132) := '292972657475726E2061722E7472697669616C54696D65644F757428652C74293B636F6E737420683D303D3D3D733F303A722E67657428732D312C6C292C633D303D3D3D6C3F303A722E67657428732C6C2D31293B6C657420643B652E676574456C656D';
wwv_flow_imp.g_varchar2_table(2133) := '656E742873293D3D3D742E676574456C656D656E74286C293F28643D303D3D3D737C7C303D3D3D6C3F303A722E67657428732D312C6C2D31292C733E3026266C3E302626333D3D3D6F2E67657428732D312C6C2D3129262628642B3D612E67657428732D';
wwv_flow_imp.g_varchar2_table(2134) := '312C6C2D3129292C642B3D693F6928732C6C293A31293A643D2D313B636F6E737420753D4D6174682E6D617828682C632C64293B696628753D3D3D64297B636F6E737420653D733E3026266C3E303F612E67657428732D312C6C2D31293A303B612E7365';
wwv_flow_imp.g_varchar2_table(2135) := '7428732C6C2C652B31292C6F2E73657428732C6C2C33297D656C736520753D3D3D683F28612E73657428732C6C2C30292C6F2E73657428732C6C2C3129293A753D3D3D63262628612E73657428732C6C2C30292C6F2E73657428732C6C2C3229293B722E';
wwv_flow_imp.g_varchar2_table(2136) := '73657428732C6C2C75297D636F6E737420733D5B5D3B6C6574206C3D652E6C656E6774682C683D742E6C656E6774683B66756E6374696F6E206328652C74297B652B313D3D3D6C2626742B313D3D3D687C7C732E70757368286E6577207372286E657720';
wwv_flow_imp.g_varchar2_table(2137) := '4F6928652B312C6C292C6E6577204F6928742B312C682929292C6C3D652C683D747D6C657420643D652E6C656E6774682D312C753D742E6C656E6774682D313B666F72283B643E3D302626753E3D303B29333D3D3D6F2E67657428642C75293F28632864';
wwv_flow_imp.g_varchar2_table(2138) := '2C75292C642D2D2C752D2D293A313D3D3D6F2E67657428642C75293F642D2D3A752D2D3B72657475726E2063282D312C2D31292C732E7265766572736528292C6E657720617228732C2131297D7D636C6173732066727B636F6D7075746528652C742C6E';
wwv_flow_imp.g_varchar2_table(2139) := '3D68722E696E7374616E6365297B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E2061722E7472697669616C28652C74293B636F6E737420693D652C723D743B66756E6374696F6E206F28652C74297B666F72';
wwv_flow_imp.g_varchar2_table(2140) := '283B653C692E6C656E6774682626743C722E6C656E6774682626692E676574456C656D656E742865293D3D3D722E676574456C656D656E742874293B29652B2B2C742B2B3B72657475726E20657D6C657420613D303B636F6E737420733D6E6577206272';
wwv_flow_imp.g_varchar2_table(2141) := '3B732E73657428302C6F28302C3029293B636F6E7374206C3D6E6577205F723B6C2E73657428302C303D3D3D732E6765742830293F6E756C6C3A6E6577206772286E756C6C2C302C302C732E67657428302929293B6C657420683D303B653A666F72283B';
wwv_flow_imp.g_varchar2_table(2142) := '3B297B696628612B2B2C216E2E697356616C696428292972657475726E2061722E7472697669616C54696D65644F757428692C72293B636F6E737420653D2D4D6174682E6D696E28612C722E6C656E6774682B612532292C743D4D6174682E6D696E2861';
wwv_flow_imp.g_varchar2_table(2143) := '2C692E6C656E6774682B612532293B666F7228683D653B683C3D743B682B3D32297B6C6574206E3D303B636F6E737420613D683D3D3D743F2D313A732E67657428682B31292C633D683D3D3D653F2D313A732E67657428682D31292B313B6E2B2B3B636F';
wwv_flow_imp.g_varchar2_table(2144) := '6E737420643D4D6174682E6D696E284D6174682E6D617828612C63292C692E6C656E677468292C753D642D683B6966286E2B2B2C643E692E6C656E6774687C7C753E722E6C656E67746829636F6E74696E75653B636F6E7374206D3D6F28642C75293B73';
wwv_flow_imp.g_varchar2_table(2145) := '2E73657428682C6D293B636F6E737420703D643D3D3D613F6C2E67657428682B31293A6C2E67657428682D31293B6966286C2E73657428682C6D213D3D643F6E657720677228702C642C752C6D2D64293A70292C732E6765742868293D3D3D692E6C656E';
wwv_flow_imp.g_varchar2_table(2146) := '6774682626732E6765742868292D683D3D3D722E6C656E67746829627265616B20657D7D6C657420633D6C2E6765742868293B636F6E737420643D5B5D3B6C657420753D692E6C656E6774682C6D3D722E6C656E6774683B666F72283B3B297B636F6E73';
wwv_flow_imp.g_varchar2_table(2147) := '7420653D633F632E782B632E6C656E6774683A302C743D633F632E792B632E6C656E6774683A303B696628653D3D3D752626743D3D3D6D7C7C642E70757368286E6577207372286E6577204F6928652C75292C6E6577204F6928742C6D2929292C216329';
wwv_flow_imp.g_varchar2_table(2148) := '627265616B3B753D632E782C6D3D632E792C633D632E707265767D72657475726E20642E7265766572736528292C6E657720617228642C2131297D7D636C6173732067727B636F6E7374727563746F7228652C742C6E2C69297B746869732E707265763D';
wwv_flow_imp.g_varchar2_table(2149) := '652C746869732E783D742C746869732E793D6E2C746869732E6C656E6774683D697D7D636C6173732062727B636F6E7374727563746F7228297B746869732E706F7369746976654172723D6E657720496E7433324172726179283130292C746869732E6E';
wwv_flow_imp.g_varchar2_table(2150) := '656761746976654172723D6E657720496E7433324172726179283130297D6765742865297B72657475726E20653C303F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976654172725B655D7D736574';
wwv_flow_imp.g_varchar2_table(2151) := '28652C74297B696628653C30297B69662828653D2D652D31293E3D746869732E6E656761746976654172722E6C656E677468297B636F6E737420653D746869732E6E656761746976654172723B746869732E6E656761746976654172723D6E657720496E';
wwv_flow_imp.g_varchar2_table(2152) := '743332417272617928322A652E6C656E677468292C746869732E6E656761746976654172722E7365742865297D746869732E6E656761746976654172725B655D3D747D656C73657B696628653E3D746869732E706F7369746976654172722E6C656E6774';
wwv_flow_imp.g_varchar2_table(2153) := '68297B636F6E737420653D746869732E706F7369746976654172723B746869732E706F7369746976654172723D6E657720496E743332417272617928322A652E6C656E677468292C746869732E706F7369746976654172722E7365742865297D74686973';
wwv_flow_imp.g_varchar2_table(2154) := '2E706F7369746976654172725B655D3D747D7D7D636C617373205F727B636F6E7374727563746F7228297B746869732E706F7369746976654172723D5B5D2C746869732E6E656761746976654172723D5B5D7D6765742865297B72657475726E20653C30';
wwv_flow_imp.g_varchar2_table(2155) := '3F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976654172725B655D7D73657428652C74297B653C303F28653D2D652D312C746869732E6E656761746976654172725B655D3D74293A746869732E70';
wwv_flow_imp.g_varchar2_table(2156) := '6F7369746976654172725B655D3D747D7D636C6173732076727B636F6E7374727563746F7228652C742C6E297B746869732E6C696E65733D652C746869732E636F6E7369646572576869746573706163654368616E6765733D6E2C746869732E656C656D';
wwv_flow_imp.g_varchar2_table(2157) := '656E74733D5B5D2C746869732E6669727374436861724F666673657442794C696E653D5B5D2C746869732E6164646974696F6E616C4F666673657442794C696E653D5B5D3B6C657420693D21313B742E73746172743E302626742E656E644578636C7573';
wwv_flow_imp.g_varchar2_table(2158) := '6976653E3D652E6C656E677468262628743D6E6577204F6928742E73746172742D312C742E656E644578636C7573697665292C693D2130292C746869732E6C696E6552616E67653D742C746869732E6669727374436861724F666673657442794C696E65';
wwv_flow_imp.g_varchar2_table(2159) := '5B305D3D303B666F72286C657420743D746869732E6C696E6552616E67652E73746172743B743C746869732E6C696E6552616E67652E656E644578636C75736976653B742B2B297B6C657420723D655B745D2C6F3D303B69662869296F3D722E6C656E67';
wwv_flow_imp.g_varchar2_table(2160) := '74682C723D22222C693D21313B656C736520696628216E297B636F6E737420653D722E7472696D537461727428293B6F3D722E6C656E6774682D652E6C656E6774682C723D652E7472696D456E6428297D746869732E6164646974696F6E616C4F666673';
wwv_flow_imp.g_varchar2_table(2161) := '657442794C696E652E70757368286F293B666F72286C657420653D303B653C722E6C656E6774683B652B2B29746869732E656C656D656E74732E7075736828722E63686172436F64654174286529293B743C652E6C656E6774682D31262628746869732E';
wwv_flow_imp.g_varchar2_table(2162) := '656C656D656E74732E7075736828225C6E222E63686172436F64654174283029292C746869732E6669727374436861724F666673657442794C696E655B742D746869732E6C696E6552616E67652E73746172742B315D3D746869732E656C656D656E7473';
wwv_flow_imp.g_varchar2_table(2163) := '2E6C656E677468297D746869732E6164646974696F6E616C4F666673657442794C696E652E707573682830297D746F537472696E6728297B72657475726E60536C6963653A2022247B746869732E746578747D22607D676574207465787428297B726574';
wwv_flow_imp.g_varchar2_table(2164) := '75726E20746869732E67657454657874286E6577204F6928302C746869732E6C656E67746829297D676574546578742865297B72657475726E20746869732E656C656D656E74732E736C69636528652E73746172742C652E656E644578636C7573697665';
wwv_flow_imp.g_varchar2_table(2165) := '292E6D61702828653D3E537472696E672E66726F6D43686172436F646528652929292E6A6F696E282222297D676574456C656D656E742865297B72657475726E20746869732E656C656D656E74735B655D7D676574206C656E67746828297B7265747572';
wwv_flow_imp.g_varchar2_table(2166) := '6E20746869732E656C656D656E74732E6C656E6774687D676574426F756E6461727953636F72652865297B636F6E737420743D6B7228653E303F746869732E656C656D656E74735B652D315D3A2D31292C6E3D6B7228653C746869732E656C656D656E74';
wwv_flow_imp.g_varchar2_table(2167) := '732E6C656E6774683F746869732E656C656D656E74735B655D3A2D31293B696628373D3D3D742626383D3D3D6E2972657475726E20303B696628383D3D3D742972657475726E203135303B6C657420693D303B72657475726E2074213D3D6E262628692B';
wwv_flow_imp.g_varchar2_table(2168) := '3D31302C303D3D3D742626313D3D3D6E262628692B3D3129292C692B3D54722874292C692B3D5472286E292C697D7472616E736C6174654F66667365742865297B696628746869732E6C696E6552616E67652E6973456D7074792972657475726E206E65';
wwv_flow_imp.g_varchar2_table(2169) := '7720547428746869732E6C696E6552616E67652E73746172742B312C31293B636F6E737420743D506928746869732E6669727374436861724F666673657442794C696E652C28743D3E743C3D6529293B72657475726E206E657720547428746869732E6C';
wwv_flow_imp.g_varchar2_table(2170) := '696E6552616E67652E73746172742B742B312C652D746869732E6669727374436861724F666673657442794C696E655B745D2B746869732E6164646974696F6E616C4F666673657442794C696E655B745D2B31297D7472616E736C61746552616E676528';
wwv_flow_imp.g_varchar2_table(2171) := '65297B72657475726E206B742E66726F6D506F736974696F6E7328746869732E7472616E736C6174654F666673657428652E7374617274292C746869732E7472616E736C6174654F666673657428652E656E644578636C757369766529297D66696E6457';
wwv_flow_imp.g_varchar2_table(2172) := '6F7264436F6E7461696E696E672865297B696628653C307C7C653E3D746869732E656C656D656E74732E6C656E6774682972657475726E3B69662821777228746869732E656C656D656E74735B655D292972657475726E3B6C657420743D653B666F7228';
wwv_flow_imp.g_varchar2_table(2173) := '3B743E302626777228746869732E656C656D656E74735B742D315D293B29742D2D3B6C6574206E3D653B666F72283B6E3C746869732E656C656D656E74732E6C656E6774682626777228746869732E656C656D656E74735B6E5D293B296E2B2B3B726574';
wwv_flow_imp.g_varchar2_table(2174) := '75726E206E6577204F6928742C6E297D636F756E744C696E6573496E2865297B72657475726E20746869732E7472616E736C6174654F666673657428652E656E644578636C7573697665292E6C696E654E756D6265722D746869732E7472616E736C6174';
wwv_flow_imp.g_varchar2_table(2175) := '654F666673657428652E7374617274292E6C696E654E756D6265727D69735374726F6E676C79457175616C28652C74297B72657475726E20746869732E656C656D656E74735B655D3D3D3D746869732E656C656D656E74735B745D7D657874656E64546F';
wwv_flow_imp.g_varchar2_table(2176) := '46756C6C4C696E65732865297B76617220742C6E3B636F6E737420693D6E756C6C213D3D28743D576928746869732E6669727374436861724F666673657442794C696E652C28743D3E743C3D652E73746172742929292626766F69642030213D3D743F74';
wwv_flow_imp.g_varchar2_table(2177) := '3A302C723D6E756C6C213D3D286E3D66756E6374696F6E2874297B636F6E7374206E3D716928742C28743D3E652E656E644578636C75736976653C3D7429293B72657475726E206E3D3D3D742E6C656E6774683F766F696420303A745B6E5D7D28746869';
wwv_flow_imp.g_varchar2_table(2178) := '732E6669727374436861724F666673657442794C696E6529292626766F69642030213D3D6E3F6E3A746869732E656C656D656E74732E6C656E6774683B72657475726E206E6577204F6928692C72297D7D66756E6374696F6E2077722865297B72657475';
wwv_flow_imp.g_varchar2_table(2179) := '726E20653E3D39372626653C3D3132327C7C653E3D36352626653C3D39307C7C653E3D34382626653C3D35377D636F6E73742079723D7B303A302C313A302C323A302C333A31302C343A322C353A33302C363A332C373A31302C383A31307D3B66756E63';
wwv_flow_imp.g_varchar2_table(2180) := '74696F6E2054722865297B72657475726E2079725B655D7D66756E6374696F6E206B722865297B72657475726E2031303D3D3D653F383A31333D3D3D653F373A75722865293F363A653E3D39372626653C3D3132323F303A653E3D36352626653C3D3930';
wwv_flow_imp.g_varchar2_table(2181) := '3F313A653E3D34382626653C3D35373F323A2D313D3D3D653F333A34343D3D3D657C7C35393D3D3D653F353A347D66756E6374696F6E20537228652C742C6E297B696628652E7472696D28293D3D3D742E7472696D28292972657475726E21303B696628';
wwv_flow_imp.g_varchar2_table(2182) := '652E6C656E6774683E3330302626742E6C656E6774683E3330302972657475726E21313B636F6E737420693D286E6577206672292E636F6D70757465286E6577207672285B655D2C6E6577204F6928302C31292C2131292C6E6577207672285B745D2C6E';
wwv_flow_imp.g_varchar2_table(2183) := '6577204F6928302C31292C2131292C6E293B6C657420723D303B636F6E7374206F3D73722E696E7665727428692E64696666732C652E6C656E677468293B666F7228636F6E73742074206F66206F29742E7365713152616E67652E666F72456163682828';
wwv_flow_imp.g_varchar2_table(2184) := '743D3E7B757228652E63686172436F64654174287429297C7C722B2B7D29293B636F6E737420613D66756E6374696F6E2874297B6C6574206E3D303B666F72286C657420693D303B693C652E6C656E6774683B692B2B29757228742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(2185) := '4174286929297C7C6E2B2B3B72657475726E206E7D28652E6C656E6774683E742E6C656E6774683F653A74293B72657475726E20722F613E2E362626613E31307D66756E6374696F6E20787228652C742C6E297B6C657420693D6E3B72657475726E2069';
wwv_flow_imp.g_varchar2_table(2186) := '3D4C7228652C742C69292C693D4C7228652C742C69292C693D66756E6374696F6E28652C742C6E297B69662821652E676574426F756E6461727953636F72657C7C21742E676574426F756E6461727953636F72652972657475726E206E3B666F72286C65';
wwv_flow_imp.g_varchar2_table(2187) := '7420693D303B693C6E2E6C656E6774683B692B2B297B636F6E737420723D693E303F6E5B692D315D3A766F696420302C6F3D6E5B695D2C613D692B313C6E2E6C656E6774683F6E5B692B315D3A766F696420302C733D6E6577204F6928723F722E736571';
wwv_flow_imp.g_varchar2_table(2188) := '3152616E67652E656E644578636C75736976652B313A302C613F612E7365713152616E67652E73746172742D313A652E6C656E677468292C6C3D6E6577204F6928723F722E7365713252616E67652E656E644578636C75736976652B313A302C613F612E';
wwv_flow_imp.g_varchar2_table(2189) := '7365713252616E67652E73746172742D313A742E6C656E677468293B6F2E7365713152616E67652E6973456D7074793F6E5B695D3D4372286F2C652C742C732C6C293A6F2E7365713252616E67652E6973456D7074792626286E5B695D3D4372286F2E73';
wwv_flow_imp.g_varchar2_table(2190) := '77617028292C742C652C6C2C73292E737761702829297D72657475726E206E7D28652C742C69292C697D66756E6374696F6E204C7228652C742C6E297B696628303D3D3D6E2E6C656E6774682972657475726E206E3B636F6E737420693D5B5D3B692E70';
wwv_flow_imp.g_varchar2_table(2191) := '757368286E5B305D293B666F72286C657420723D313B723C6E2E6C656E6774683B722B2B297B636F6E7374206F3D695B692E6C656E6774682D315D3B6C657420613D6E5B725D3B696628612E7365713152616E67652E6973456D7074797C7C612E736571';
wwv_flow_imp.g_varchar2_table(2192) := '3252616E67652E6973456D707479297B636F6E7374206E3D612E7365713152616E67652E73746172742D6F2E7365713152616E67652E656E644578636C75736976653B6C657420723B666F7228723D313B723C3D6E2626652E676574456C656D656E7428';
wwv_flow_imp.g_varchar2_table(2193) := '612E7365713152616E67652E73746172742D72293D3D3D652E676574456C656D656E7428612E7365713152616E67652E656E644578636C75736976652D72292626742E676574456C656D656E7428612E7365713252616E67652E73746172742D72293D3D';
wwv_flow_imp.g_varchar2_table(2194) := '3D742E676574456C656D656E7428612E7365713252616E67652E656E644578636C75736976652D72293B722B2B293B696628722D2D2C723D3D3D6E297B695B692E6C656E6774682D315D3D6E6577207372286E6577204F69286F2E7365713152616E6765';
wwv_flow_imp.g_varchar2_table(2195) := '2E73746172742C612E7365713152616E67652E656E644578636C75736976652D6E292C6E6577204F69286F2E7365713252616E67652E73746172742C612E7365713252616E67652E656E644578636C75736976652D6E29293B636F6E74696E75657D613D';
wwv_flow_imp.g_varchar2_table(2196) := '612E64656C7461282D72297D692E707573682861297D636F6E737420723D5B5D3B666F72286C6574206E3D303B6E3C692E6C656E6774682D313B6E2B2B297B636F6E7374206F3D695B6E2B315D3B6C657420613D695B6E5D3B696628612E736571315261';
wwv_flow_imp.g_varchar2_table(2197) := '6E67652E6973456D7074797C7C612E7365713252616E67652E6973456D707479297B636F6E737420723D6F2E7365713152616E67652E73746172742D612E7365713152616E67652E656E644578636C75736976653B6C657420733B666F7228733D303B73';
wwv_flow_imp.g_varchar2_table(2198) := '3C722626652E69735374726F6E676C79457175616C28612E7365713152616E67652E73746172742B732C612E7365713152616E67652E656E644578636C75736976652B73292626742E69735374726F6E676C79457175616C28612E7365713252616E6765';
wwv_flow_imp.g_varchar2_table(2199) := '2E73746172742B732C612E7365713252616E67652E656E644578636C75736976652B73293B732B2B293B696628733D3D3D72297B695B6E2B315D3D6E6577207372286E6577204F6928612E7365713152616E67652E73746172742B722C6F2E7365713152';
wwv_flow_imp.g_varchar2_table(2200) := '616E67652E656E644578636C7573697665292C6E6577204F6928612E7365713252616E67652E73746172742B722C6F2E7365713252616E67652E656E644578636C757369766529293B636F6E74696E75657D733E30262628613D612E64656C7461287329';
wwv_flow_imp.g_varchar2_table(2201) := '297D722E707573682861297D72657475726E20692E6C656E6774683E302626722E7075736828695B692E6C656E6774682D315D292C727D66756E6374696F6E20437228652C742C6E2C692C72297B6C6574206F3D313B666F72283B652E7365713152616E';
wwv_flow_imp.g_varchar2_table(2202) := '67652E73746172742D6F3E3D692E73746172742626652E7365713252616E67652E73746172742D6F3E3D722E737461727426266E2E69735374726F6E676C79457175616C28652E7365713252616E67652E73746172742D6F2C652E7365713252616E6765';
wwv_flow_imp.g_varchar2_table(2203) := '2E656E644578636C75736976652D6F2926266F3C3130303B296F2B2B3B6F2D2D3B6C657420613D303B666F72283B652E7365713152616E67652E73746172742B613C692E656E644578636C75736976652626652E7365713252616E67652E656E64457863';
wwv_flow_imp.g_varchar2_table(2204) := '6C75736976652B613C722E656E644578636C757369766526266E2E69735374726F6E676C79457175616C28652E7365713252616E67652E73746172742B612C652E7365713252616E67652E656E644578636C75736976652B61292626613C3130303B2961';
wwv_flow_imp.g_varchar2_table(2205) := '2B2B3B696628303D3D3D6F2626303D3D3D612972657475726E20653B6C657420733D302C6C3D2D313B666F72286C657420693D2D6F3B693C3D613B692B2B297B636F6E737420723D652E7365713252616E67652E73746172742B692C6F3D652E73657132';
wwv_flow_imp.g_varchar2_table(2206) := '52616E67652E656E644578636C75736976652B692C613D652E7365713152616E67652E73746172742B692C683D742E676574426F756E6461727953636F72652861292B6E2E676574426F756E6461727953636F72652872292B6E2E676574426F756E6461';
wwv_flow_imp.g_varchar2_table(2207) := '727953636F7265286F293B683E6C2626286C3D682C733D69297D72657475726E20652E64656C74612873297D636C6173732045727B636F6E7374727563746F7228652C74297B746869732E7472696D6D6564486173683D652C746869732E6C696E65733D';
wwv_flow_imp.g_varchar2_table(2208) := '747D676574456C656D656E742865297B72657475726E20746869732E7472696D6D6564486173685B655D7D676574206C656E67746828297B72657475726E20746869732E7472696D6D6564486173682E6C656E6774687D676574426F756E646172795363';
wwv_flow_imp.g_varchar2_table(2209) := '6F72652865297B72657475726E203165332D2828303D3D3D653F303A417228746869732E6C696E65735B652D315D29292B28653D3D3D746869732E6C696E65732E6C656E6774683F303A417228746869732E6C696E65735B655D2929297D676574546578';
wwv_flow_imp.g_varchar2_table(2210) := '742865297B72657475726E20746869732E6C696E65732E736C69636528652E73746172742C652E656E644578636C7573697665292E6A6F696E28225C6E22297D69735374726F6E676C79457175616C28652C74297B72657475726E20746869732E6C696E';
wwv_flow_imp.g_varchar2_table(2211) := '65735B655D3D3D3D746869732E6C696E65735B745D7D7D66756E6374696F6E2041722865297B6C657420743D303B666F72283B743C652E6C656E67746826262833323D3D3D652E63686172436F646541742874297C7C393D3D3D652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(2212) := '4174287429293B29742B2B3B72657475726E20747D636C6173732052727B636F6E7374727563746F7228297B746869732E64796E616D696350726F6772616D6D696E6744696666696E673D6E65772070722C746869732E6D7965727344696666696E6741';
wwv_flow_imp.g_varchar2_table(2213) := '6C676F726974686D3D6E65772066727D636F6D707574654469666628652C742C6E297B696628652E6C656E6774683C3D31262666756E6374696F6E28652C742C6E3D28652C74293D3E653D3D3D74297B696628653D3D3D742972657475726E21303B6966';
wwv_flow_imp.g_varchar2_table(2214) := '2821657C7C21742972657475726E21313B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C657420693D302C723D652E6C656E6774683B693C723B692B2B29696628216E28655B695D2C745B695D2929726574';
wwv_flow_imp.g_varchar2_table(2215) := '75726E21313B72657475726E21307D28652C742C2828652C74293D3E653D3D3D7429292972657475726E206E6577204869285B5D2C5B5D2C2131293B696628313D3D3D652E6C656E6774682626303D3D3D655B305D2E6C656E6774687C7C313D3D3D742E';
wwv_flow_imp.g_varchar2_table(2216) := '6C656E6774682626303D3D3D745B305D2E6C656E6774682972657475726E206E6577204869285B6E6577202469286E657720426928312C652E6C656E6774682B31292C6E657720426928312C742E6C656E6774682B31292C5B6E6577205869286E657720';
wwv_flow_imp.g_varchar2_table(2217) := '6B7428312C312C652E6C656E6774682C655B652E6C656E6774682D315D2E6C656E6774682B31292C6E6577206B7428312C312C742E6C656E6774682C745B742E6C656E6774682D315D2E6C656E6774682B3129295D295D2C5B5D2C2131293B636F6E7374';
wwv_flow_imp.g_varchar2_table(2218) := '20693D303D3D3D6E2E6D6178436F6D7075746174696F6E54696D654D733F68722E696E7374616E63653A6E6577206372286E2E6D6178436F6D7075746174696F6E54696D654D73292C723D216E2E69676E6F72655472696D576869746573706163652C6F';
wwv_flow_imp.g_varchar2_table(2219) := '3D6E6577204D61703B66756E6374696F6E20612865297B6C657420743D6F2E6765742865293B72657475726E20766F696420303D3D3D74262628743D6F2E73697A652C6F2E73657428652C7429292C747D636F6E737420733D652E6D61702828653D3E61';
wwv_flow_imp.g_varchar2_table(2220) := '28652E7472696D28292929292C6C3D742E6D61702828653D3E6128652E7472696D28292929292C683D6E657720457228732C65292C633D6E6577204572286C2C74292C643D2828293D3E682E6C656E6774682B632E6C656E6774683C313730303F746869';
wwv_flow_imp.g_varchar2_table(2221) := '732E64796E616D696350726F6772616D6D696E6744696666696E672E636F6D7075746528682C632C692C28286E2C69293D3E655B6E5D3D3D3D745B695D3F303D3D3D745B695D2E6C656E6774683F2E313A312B4D6174682E6C6F6728312B745B695D2E6C';
wwv_flow_imp.g_varchar2_table(2222) := '656E677468293A2E393929293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528682C63292928293B6C657420753D642E64696666732C6D3D642E68697454696D656F75743B753D787228682C632C75292C753D66';
wwv_flow_imp.g_varchar2_table(2223) := '756E6374696F6E28652C742C6E297B6C657420693D6E3B696628303D3D3D692E6C656E6774682972657475726E20693B6C657420722C6F3D303B646F7B723D21313B636F6E737420613D5B695B305D5D3B666F72286C657420733D313B733C692E6C656E';
wwv_flow_imp.g_varchar2_table(2224) := '6774683B732B2B297B636F6E7374206C3D695B735D2C683D615B612E6C656E6774682D315D3B66756E6374696F6E206328742C6E297B636F6E737420693D6E6577204F6928682E7365713152616E67652E656E644578636C75736976652C6C2E73657131';
wwv_flow_imp.g_varchar2_table(2225) := '52616E67652E7374617274293B72657475726E20652E676574546578742869292E7265706C616365282F5C732F672C2222292E6C656E6774683C3D34262628742E7365713152616E67652E6C656E6774682B742E7365713252616E67652E6C656E677468';
wwv_flow_imp.g_varchar2_table(2226) := '3E357C7C6E2E7365713152616E67652E6C656E6774682B6E2E7365713252616E67652E6C656E6774683E35297D6328682C6C293F28723D21302C615B612E6C656E6774682D315D3D615B612E6C656E6774682D315D2E6A6F696E286C29293A612E707573';
wwv_flow_imp.g_varchar2_table(2227) := '68286C297D693D617D7768696C65286F2B2B3C3130262672293B72657475726E20697D28682C302C75293B636F6E737420703D5B5D2C663D6E3D3E7B6966287229666F72286C6574206F3D303B6F3C6E3B6F2B2B297B636F6E7374206E3D672B6F2C613D';
wwv_flow_imp.g_varchar2_table(2228) := '622B6F3B696628655B6E5D213D3D745B615D297B636F6E7374206F3D746869732E726566696E654469666628652C742C6E6577207372286E6577204F69286E2C6E2B31292C6E6577204F6928612C612B3129292C692C72293B666F7228636F6E73742065';
wwv_flow_imp.g_varchar2_table(2229) := '206F66206F2E6D617070696E677329702E707573682865293B6F2E68697454696D656F75742626286D3D2130297D7D7D3B6C657420673D302C623D303B666F7228636F6E7374206E206F662075297B4D69282828293D3E6E2E7365713152616E67652E73';
wwv_flow_imp.g_varchar2_table(2230) := '746172742D673D3D6E2E7365713252616E67652E73746172742D6229292C66286E2E7365713152616E67652E73746172742D67292C673D6E2E7365713152616E67652E656E644578636C75736976652C623D6E2E7365713252616E67652E656E64457863';
wwv_flow_imp.g_varchar2_table(2231) := '6C75736976653B636F6E7374206F3D746869732E726566696E654469666628652C742C6E2C692C72293B6F2E68697454696D656F75742626286D3D2130293B666F7228636F6E73742065206F66206F2E6D617070696E677329702E707573682865297D66';
wwv_flow_imp.g_varchar2_table(2232) := '28652E6C656E6774682D67293B636F6E7374205F3D4D7228702C652C74293B6C657420763D5B5D3B72657475726E206E2E636F6D707574654D6F766573262628763D746869732E636F6D707574654D6F766573285F2C652C742C732C6C2C692C7229292C';
wwv_flow_imp.g_varchar2_table(2233) := '4D69282828293D3E7B66756E6374696F6E206E28652C74297B696628652E6C696E654E756D6265723C317C7C652E6C696E654E756D6265723E742E6C656E6774682972657475726E21313B636F6E7374206E3D745B652E6C696E654E756D6265722D315D';
wwv_flow_imp.g_varchar2_table(2234) := '3B72657475726E2128652E636F6C756D6E3C317C7C652E636F6C756D6E3E6E2E6C656E6774682B31297D66756E6374696F6E206928652C74297B72657475726E2128652E73746172744C696E654E756D6265723C317C7C652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(2235) := '6D6265723E742E6C656E6774682B317C7C652E656E644C696E654E756D6265724578636C75736976653C317C7C652E656E644C696E654E756D6265724578636C75736976653E742E6C656E6774682B31297D666F7228636F6E73742072206F66205F297B';
wwv_flow_imp.g_varchar2_table(2236) := '69662821722E696E6E65724368616E6765732972657475726E21313B666F7228636F6E73742069206F6620722E696E6E65724368616E6765732969662821286E28692E6D6F64696669656452616E67652E6765745374617274506F736974696F6E28292C';
wwv_flow_imp.g_varchar2_table(2237) := '742926266E28692E6D6F64696669656452616E67652E676574456E64506F736974696F6E28292C742926266E28692E6F726967696E616C52616E67652E6765745374617274506F736974696F6E28292C652926266E28692E6F726967696E616C52616E67';
wwv_flow_imp.g_varchar2_table(2238) := '652E676574456E64506F736974696F6E28292C6529292972657475726E21313B696628216928722E6D6F6469666965642C74297C7C216928722E6F726967696E616C2C65292972657475726E21317D72657475726E21307D29292C6E6577204869285F2C';
wwv_flow_imp.g_varchar2_table(2239) := '762C6D297D636F6D707574654D6F76657328652C742C6E2C692C722C6F2C61297B72657475726E2066756E6374696F6E28652C742C6E2C692C722C6F297B6C65747B6D6F7665733A612C6578636C756465644368616E6765733A737D3D66756E6374696F';
wwv_flow_imp.g_varchar2_table(2240) := '6E28652C742C6E2C69297B636F6E737420723D5B5D2C6F3D652E66696C7465722828653D3E652E6D6F6469666965642E6973456D7074792626652E6F726967696E616C2E6C656E6774683E3D3329292E6D61702828653D3E6E6577206D7228652E6F7269';
wwv_flow_imp.g_varchar2_table(2241) := '67696E616C2C742C652929292C613D6E65772053657428652E66696C7465722828653D3E652E6F726967696E616C2E6973456D7074792626652E6D6F6469666965642E6C656E6774683E3D3329292E6D61702828653D3E6E6577206D7228652E6D6F6469';
wwv_flow_imp.g_varchar2_table(2242) := '666965642C6E2C65292929292C733D6E6577205365743B666F7228636F6E73742065206F66206F297B6C657420742C6E3D2D313B666F7228636F6E73742069206F662061297B636F6E737420723D652E636F6D7075746553696D696C6172697479286929';
wwv_flow_imp.g_varchar2_table(2243) := '3B723E6E2626286E3D722C743D69297D6966286E3E2E39262674262628612E64656C6574652874292C722E70757368286E657720476928652E72616E67652C742E72616E676529292C732E61646428652E736F75726365292C732E61646428742E736F75';
wwv_flow_imp.g_varchar2_table(2244) := '72636529292C21692E697356616C696428292972657475726E7B6D6F7665733A722C6578636C756465644368616E6765733A737D7D72657475726E7B6D6F7665733A722C6578636C756465644368616E6765733A737D7D28652C742C6E2C6F293B696628';
wwv_flow_imp.g_varchar2_table(2245) := '216F2E697356616C696428292972657475726E5B5D3B636F6E7374206C3D66756E6374696F6E28652C742C6E2C692C722C6F297B636F6E737420613D5B5D2C733D6E65772043693B666F7228636F6E7374206E206F66206529666F72286C657420653D6E';
wwv_flow_imp.g_varchar2_table(2246) := '2E6F726967696E616C2E73746172744C696E654E756D6265723B653C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D323B652B2B297B636F6E7374206E3D60247B745B652D315D7D3A247B745B652B312D315D7D3A';
wwv_flow_imp.g_varchar2_table(2247) := '247B745B652B322D315D7D603B732E616464286E2C7B72616E67653A6E657720426928652C652B33297D297D636F6E7374206C3D5B5D3B652E736F72742878742828653D3E652E6D6F6469666965642E73746172744C696E654E756D626572292C4C7429';
wwv_flow_imp.g_varchar2_table(2248) := '293B666F7228636F6E73742074206F662065297B6C657420653D5B5D3B666F72286C657420693D742E6D6F6469666965642E73746172744C696E654E756D6265723B693C742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(2249) := '652D323B692B2B297B636F6E737420743D60247B6E5B692D315D7D3A247B6E5B692B312D315D7D3A247B6E5B692B322D315D7D602C723D6E657720426928692C692B33292C6F3D5B5D3B732E666F724561636828742C28287B72616E67653A747D293D3E';
wwv_flow_imp.g_varchar2_table(2250) := '7B666F7228636F6E7374206E206F662065296966286E2E6F726967696E616C4C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D742E656E644C696E654E756D6265724578636C757369766526266E2E6D6F6469';
wwv_flow_imp.g_varchar2_table(2251) := '666965644C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D722E656E644C696E654E756D6265724578636C75736976652972657475726E206E2E6F726967696E616C4C696E6552616E67653D6E657720426928';
wwv_flow_imp.g_varchar2_table(2252) := '6E2E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C742E656E644C696E654E756D6265724578636C7573697665292C6E2E6D6F6469666965644C696E6552616E67653D6E6577204269286E2E6D6F6469666965644C';
wwv_flow_imp.g_varchar2_table(2253) := '696E6552616E67652E73746172744C696E654E756D6265722C722E656E644C696E654E756D6265724578636C7573697665292C766F6964206F2E70757368286E293B636F6E7374206E3D7B6D6F6469666965644C696E6552616E67653A722C6F72696769';
wwv_flow_imp.g_varchar2_table(2254) := '6E616C4C696E6552616E67653A747D3B6C2E70757368286E292C6F2E70757368286E297D29292C653D6F7D696628216F2E697356616C696428292972657475726E5B5D7D76617220683B6C2E736F72742828683D78742828653D3E652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2255) := '644C696E6552616E67652E6C656E677468292C4C74292C28652C74293D3E2D6828652C742929293B636F6E737420633D6E65772056692C643D6E65772056693B666F7228636F6E73742065206F66206C297B636F6E737420743D652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(2256) := '4C696E6552616E67652E73746172744C696E654E756D6265722D652E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C6E3D632E737562747261637446726F6D28652E6D6F6469666965644C696E6552616E6765292C';
wwv_flow_imp.g_varchar2_table(2257) := '693D642E737562747261637446726F6D28652E6F726967696E616C4C696E6552616E6765292E6765745769746844656C74612874292C723D6E2E676574496E74657273656374696F6E2869293B666F7228636F6E73742065206F6620722E72616E676573';
wwv_flow_imp.g_varchar2_table(2258) := '297B696628652E6C656E6774683C3329636F6E74696E75653B636F6E7374206E3D652C693D652E64656C7461282D74293B612E70757368286E657720476928692C6E29292C632E61646452616E6765286E292C642E61646452616E67652869297D7D612E';
wwv_flow_imp.g_varchar2_table(2259) := '736F72742878742828653D3E652E6F726967696E616C2E73746172744C696E654E756D626572292C4C7429293B636F6E737420753D6E65772046692865293B666F72286C657420743D303B743C612E6C656E6774683B742B2B297B636F6E7374206E3D61';
wwv_flow_imp.g_varchar2_table(2260) := '5B745D2C733D752E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C3D6E2E6F726967696E616C2E73746172744C696E654E756D62657229292C6C3D576928652C28653D3E65';
wwv_flow_imp.g_varchar2_table(2261) := '2E6D6F6469666965642E73746172744C696E654E756D6265723C3D6E2E6D6F6469666965642E73746172744C696E654E756D62657229292C683D4D6174682E6D6178286E2E6F726967696E616C2E73746172744C696E654E756D6265722D732E6F726967';
wwv_flow_imp.g_varchar2_table(2262) := '696E616C2E73746172744C696E654E756D6265722C6E2E6D6F6469666965642E73746172744C696E654E756D6265722D6C2E6D6F6469666965642E73746172744C696E654E756D626572292C6D3D752E66696E644C6173744D6F6E6F746F6E6F75732828';
wwv_flow_imp.g_varchar2_table(2263) := '653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529292C703D576928652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(2264) := '6265723C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C757369766529292C663D4D6174682E6D6178286D2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D6E2E6F726967696E616C2E656E644C';
wwv_flow_imp.g_varchar2_table(2265) := '696E654E756D6265724578636C75736976652C702E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665293B6C657420672C623B666F7228';
wwv_flow_imp.g_varchar2_table(2266) := '673D303B673C683B672B2B297B636F6E737420653D6E2E6F726967696E616C2E73746172744C696E654E756D6265722D672D312C743D6E2E6D6F6469666965642E73746172744C696E654E756D6265722D672D313B696628653E692E6C656E6774687C7C';
wwv_flow_imp.g_varchar2_table(2267) := '743E722E6C656E67746829627265616B3B696628632E636F6E7461696E732874297C7C642E636F6E7461696E7328652929627265616B3B69662821537228695B652D315D2C725B742D315D2C6F2929627265616B7D666F7228673E30262628642E616464';
wwv_flow_imp.g_varchar2_table(2268) := '52616E6765286E6577204269286E2E6F726967696E616C2E73746172744C696E654E756D6265722D672C6E2E6F726967696E616C2E73746172744C696E654E756D62657229292C632E61646452616E6765286E6577204269286E2E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(2269) := '73746172744C696E654E756D6265722D672C6E2E6D6F6469666965642E73746172744C696E654E756D6265722929292C623D303B623C663B622B2B297B636F6E737420653D6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369';
wwv_flow_imp.g_varchar2_table(2270) := '76652B622C743D6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B623B696628653E692E6C656E6774687C7C743E722E6C656E67746829627265616B3B696628632E636F6E7461696E732874297C7C642E636F6E7461';
wwv_flow_imp.g_varchar2_table(2271) := '696E7328652929627265616B3B69662821537228695B652D315D2C725B742D315D2C6F2929627265616B7D623E30262628642E61646452616E6765286E6577204269286E2E6F726967696E616C2E656E644C696E654E756D6265724578636C7573697665';
wwv_flow_imp.g_varchar2_table(2272) := '2C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B6229292C632E61646452616E6765286E6577204269286E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6E2E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2273) := '642E656E644C696E654E756D6265724578636C75736976652B622929292C28673E307C7C623E3029262628615B745D3D6E6577204769286E6577204269286E2E6F726967696E616C2E73746172744C696E654E756D6265722D672C6E2E6F726967696E61';
wwv_flow_imp.g_varchar2_table(2274) := '6C2E656E644C696E654E756D6265724578636C75736976652B62292C6E6577204269286E2E6D6F6469666965642E73746172744C696E654E756D6265722D672C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B6229';
wwv_flow_imp.g_varchar2_table(2275) := '29297D72657475726E20617D28652E66696C7465722828653D3E21732E68617328652929292C692C722C742C6E2C6F293B72657475726E2066756E6374696F6E28652C74297B666F7228636F6E7374206E206F66207429652E70757368286E297D28612C';
wwv_flow_imp.g_varchar2_table(2276) := '6C292C613D66756E6374696F6E2865297B696628303D3D3D652E6C656E6774682972657475726E20653B652E736F72742878742828653D3E652E6F726967696E616C2E73746172744C696E654E756D626572292C4C7429293B636F6E737420743D5B655B';
wwv_flow_imp.g_varchar2_table(2277) := '305D5D3B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D745B742E6C656E6774682D315D2C723D655B6E5D2C6F3D722E6F726967696E616C2E73746172744C696E654E756D6265722D692E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2278) := '2E656E644C696E654E756D6265724578636C75736976652C613D722E6D6F6469666965642E73746172744C696E654E756D6265722D692E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653B6F3E3D302626613E3D3026266F';
wwv_flow_imp.g_varchar2_table(2279) := '2B613C3D323F745B742E6C656E6774682D315D3D692E6A6F696E2872293A742E707573682872297D72657475726E20747D2861292C613D612E66696C7465722828653D3E7B636F6E7374206E3D652E6F726967696E616C2E746F4F666673657452616E67';
wwv_flow_imp.g_varchar2_table(2280) := '6528292E736C6963652874292E6D61702828653D3E652E7472696D282929293B72657475726E206E2E6A6F696E28225C6E22292E6C656E6774683E3D3135262666756E6374696F6E2865297B6C657420743D303B666F7228636F6E7374206E206F662065';
wwv_flow_imp.g_varchar2_table(2281) := '296E2E6C656E6774683E3D322626742B2B3B72657475726E20747D286E293E3D327D29292C613D66756E6374696F6E28652C74297B636F6E7374206E3D6E65772046692865293B72657475726E20742E66696C7465722828743D3E286E2E66696E644C61';
wwv_flow_imp.g_varchar2_table(2282) := '73744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C742E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529297C7C6E6577204769286E657720426928312C31292C';
wwv_flow_imp.g_varchar2_table(2283) := '6E657720426928312C31292929213D3D576928652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C742E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665292929297D28652C61292C617D2865';
wwv_flow_imp.g_varchar2_table(2284) := '2C742C6E2C692C722C6F292E6D61702828653D3E7B636F6E737420693D4D7228746869732E726566696E654469666628742C6E2C6E657720737228652E6F726967696E616C2E746F4F666673657452616E676528292C652E6D6F6469666965642E746F4F';
wwv_flow_imp.g_varchar2_table(2285) := '666673657452616E67652829292C6F2C61292E6D617070696E67732C742C6E2C2130293B72657475726E206E657720446928652C69297D29297D726566696E654469666628652C742C6E2C692C72297B636F6E7374206F3D6E657720767228652C6E2E73';
wwv_flow_imp.g_varchar2_table(2286) := '65713152616E67652C72292C613D6E657720767228742C6E2E7365713252616E67652C72292C733D6F2E6C656E6774682B612E6C656E6774683C3530303F746869732E64796E616D696350726F6772616D6D696E6744696666696E672E636F6D70757465';
wwv_flow_imp.g_varchar2_table(2287) := '286F2C612C69293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D70757465286F2C612C69293B6C6574206C3D732E64696666733B72657475726E206C3D7872286F2C612C6C292C6C3D66756E6374696F6E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(2288) := '7B636F6E737420693D73722E696E76657274286E2C652E6C656E677468292C723D5B5D3B6C6574206F3D6E6577206C7228302C30293B66756E6374696F6E2061286E2C61297B6966286E2E6F6666736574313C6F2E6F6666736574317C7C6E2E6F666673';
wwv_flow_imp.g_varchar2_table(2289) := '6574323C6F2E6F6666736574322972657475726E3B636F6E737420733D652E66696E64576F7264436F6E7461696E696E67286E2E6F666673657431292C6C3D742E66696E64576F7264436F6E7461696E696E67286E2E6F666673657432293B6966282173';
wwv_flow_imp.g_varchar2_table(2290) := '7C7C216C2972657475726E3B6C657420683D6E657720737228732C6C293B636F6E737420633D682E696E746572736563742861293B6C657420643D632E7365713152616E67652E6C656E6774682C753D632E7365713252616E67652E6C656E6774683B66';
wwv_flow_imp.g_varchar2_table(2291) := '6F72283B692E6C656E6774683E303B297B636F6E7374206E3D695B305D3B696628216E2E7365713152616E67652E696E746572736563747328682E7365713152616E6765292626216E2E7365713252616E67652E696E746572736563747328682E736571';
wwv_flow_imp.g_varchar2_table(2292) := '3252616E67652929627265616B3B636F6E737420723D652E66696E64576F7264436F6E7461696E696E67286E2E7365713152616E67652E7374617274292C6F3D742E66696E64576F7264436F6E7461696E696E67286E2E7365713252616E67652E737461';
wwv_flow_imp.g_varchar2_table(2293) := '7274292C613D6E657720737228722C6F292C733D612E696E74657273656374286E293B696628642B3D732E7365713152616E67652E6C656E6774682C752B3D732E7365713252616E67652E6C656E6774682C683D682E6A6F696E2861292C2128682E7365';
wwv_flow_imp.g_varchar2_table(2294) := '713152616E67652E656E644578636C75736976653E3D6E2E7365713152616E67652E656E644578636C75736976652929627265616B3B692E736869667428297D642B753C322A28682E7365713152616E67652E6C656E6774682B682E7365713252616E67';
wwv_flow_imp.g_varchar2_table(2295) := '652E6C656E677468292F332626722E707573682868292C6F3D682E676574456E644578636C75736976657328297D666F72283B692E6C656E6774683E303B297B636F6E737420653D692E736869667428293B652E7365713152616E67652E6973456D7074';
wwv_flow_imp.g_varchar2_table(2296) := '797C7C286128652E67657453746172747328292C65292C6128652E676574456E644578636C75736976657328292E64656C7461282D31292C6529297D72657475726E2066756E6374696F6E28652C74297B636F6E7374206E3D5B5D3B666F72283B652E6C';
wwv_flow_imp.g_varchar2_table(2297) := '656E6774683E307C7C742E6C656E6774683E303B297B636F6E737420693D655B305D2C723D745B305D3B6C6574206F3B6F3D6926262821727C7C692E7365713152616E67652E73746172743C722E7365713152616E67652E7374617274293F652E736869';
wwv_flow_imp.g_varchar2_table(2298) := '667428293A742E736869667428292C6E2E6C656E6774683E3026266E5B6E2E6C656E6774682D315D2E7365713152616E67652E656E644578636C75736976653E3D6F2E7365713152616E67652E73746172743F6E5B6E2E6C656E6774682D315D3D6E5B6E';
wwv_flow_imp.g_varchar2_table(2299) := '2E6C656E6774682D315D2E6A6F696E286F293A6E2E70757368286F297D72657475726E206E7D286E2C72297D286F2C612C6C292C6C3D66756E6374696F6E28652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E73742065206F66206E297B63';
wwv_flow_imp.g_varchar2_table(2300) := '6F6E737420743D695B692E6C656E6774682D315D3B74262628652E7365713152616E67652E73746172742D742E7365713152616E67652E656E644578636C75736976653C3D327C7C652E7365713252616E67652E73746172742D742E7365713252616E67';
wwv_flow_imp.g_varchar2_table(2301) := '652E656E644578636C75736976653C3D32293F695B692E6C656E6774682D315D3D6E657720737228742E7365713152616E67652E6A6F696E28652E7365713152616E6765292C742E7365713252616E67652E6A6F696E28652E7365713252616E67652929';
wwv_flow_imp.g_varchar2_table(2302) := '3A692E707573682865297D72657475726E20697D28302C302C6C292C6C3D66756E6374696F6E28652C742C6E297B6C657420693D6E3B696628303D3D3D692E6C656E6774682972657475726E20693B6C657420722C6F3D303B646F7B723D21313B636F6E';
wwv_flow_imp.g_varchar2_table(2303) := '737420733D5B695B305D5D3B666F72286C6574206C3D313B6C3C692E6C656E6774683B6C2B2B297B636F6E737420683D695B6C5D2C633D735B732E6C656E6774682D315D3B66756E6374696F6E2064286E2C69297B636F6E737420723D6E6577204F6928';
wwv_flow_imp.g_varchar2_table(2304) := '632E7365713152616E67652E656E644578636C75736976652C682E7365713152616E67652E7374617274293B696628652E636F756E744C696E6573496E2872293E357C7C722E6C656E6774683E3530302972657475726E21313B636F6E7374206F3D652E';
wwv_flow_imp.g_varchar2_table(2305) := '676574546578742872292E7472696D28293B6966286F2E6C656E6774683E32307C7C6F2E73706C6974282F5C725C6E7C5C727C5C6E2F292E6C656E6774683E312972657475726E21313B636F6E737420613D652E636F756E744C696E6573496E286E2E73';
wwv_flow_imp.g_varchar2_table(2306) := '65713152616E6765292C733D6E2E7365713152616E67652E6C656E6774682C6C3D742E636F756E744C696E6573496E286E2E7365713252616E6765292C643D6E2E7365713252616E67652E6C656E6774682C753D652E636F756E744C696E6573496E2869';
wwv_flow_imp.g_varchar2_table(2307) := '2E7365713152616E6765292C6D3D692E7365713152616E67652E6C656E6774682C703D742E636F756E744C696E6573496E28692E7365713252616E6765292C663D692E7365713252616E67652E6C656E6774683B66756E6374696F6E20672865297B7265';
wwv_flow_imp.g_varchar2_table(2308) := '7475726E204D6174682E6D696E28652C313330297D72657475726E204D6174682E706F77284D6174682E706F7728672834302A612B73292C312E35292B4D6174682E706F7728672834302A6C2B64292C312E35292C312E35292B4D6174682E706F77284D';
wwv_flow_imp.g_varchar2_table(2309) := '6174682E706F7728672834302A752B6D292C312E35292B4D6174682E706F7728672834302A702B66292C312E35292C312E35293E37343138342E39363438303732313234337D6428632C68293F28723D21302C735B732E6C656E6774682D315D3D735B73';
wwv_flow_imp.g_varchar2_table(2310) := '2E6C656E6774682D315D2E6A6F696E286829293A732E707573682868297D693D737D7768696C65286F2B2B3C3130262672293B636F6E737420613D5B5D3B72657475726E2066756E6374696F6E28652C74297B666F72286C6574206E3D303B6E3C652E6C';
wwv_flow_imp.g_varchar2_table(2311) := '656E6774683B6E2B2B297428303D3D3D6E3F766F696420303A655B6E2D315D2C655B6E5D2C6E2B313D3D3D652E6C656E6774683F766F696420303A655B6E2B315D297D28692C2828742C6E2C69293D3E7B6C657420723D6E3B66756E6374696F6E206F28';
wwv_flow_imp.g_varchar2_table(2312) := '65297B72657475726E20652E6C656E6774683E302626652E7472696D28292E6C656E6774683C3D3326266E2E7365713152616E67652E6C656E6774682B6E2E7365713252616E67652E6C656E6774683E3130307D636F6E737420733D652E657874656E64';
wwv_flow_imp.g_varchar2_table(2313) := '546F46756C6C4C696E6573286E2E7365713152616E6765292C6C3D652E67657454657874286E6577204F6928732E73746172742C6E2E7365713152616E67652E737461727429293B6F286C29262628723D722E64656C74615374617274282D6C2E6C656E';
wwv_flow_imp.g_varchar2_table(2314) := '67746829293B636F6E737420683D652E67657454657874286E6577204F69286E2E7365713152616E67652E656E644578636C75736976652C732E656E644578636C757369766529293B6F286829262628723D722E64656C7461456E6428682E6C656E6774';
wwv_flow_imp.g_varchar2_table(2315) := '6829293B636F6E737420633D73722E66726F6D4F6666736574506169727328743F742E676574456E644578636C75736976657328293A6C722E7A65726F2C693F692E67657453746172747328293A6C722E6D6178292C643D722E696E7465727365637428';
wwv_flow_imp.g_varchar2_table(2316) := '63293B612E6C656E6774683E302626642E67657453746172747328292E657175616C7328615B612E6C656E6774682D315D2E676574456E644578636C7573697665732829293F615B612E6C656E6774682D315D3D615B612E6C656E6774682D315D2E6A6F';
wwv_flow_imp.g_varchar2_table(2317) := '696E2864293A612E707573682864297D29292C617D286F2C612C6C292C7B6D617070696E67733A6C2E6D61702828653D3E6E6577205869286F2E7472616E736C61746552616E676528652E7365713152616E6765292C612E7472616E736C61746552616E';
wwv_flow_imp.g_varchar2_table(2318) := '676528652E7365713252616E6765292929292C68697454696D656F75743A732E68697454696D656F75747D7D7D66756E6374696F6E204D7228652C742C6E2C693D2131297B636F6E737420723D5B5D3B666F7228636F6E73742069206F662066756E6374';
wwv_flow_imp.g_varchar2_table(2319) := '696F6E2A2865297B6C657420742C6E3B666F7228636F6E7374206F206F66206529766F69642030213D3D6E262628723D6F2C28693D6E292E6F726967696E616C2E6F7665726C61704F72546F75636828722E6F726967696E616C297C7C692E6D6F646966';
wwv_flow_imp.g_varchar2_table(2320) := '6965642E6F7665726C61704F72546F75636828722E6D6F64696669656429293F742E70757368286F293A28742626287969656C642074292C743D5B6F5D292C6E3D6F3B76617220692C723B742626287969656C642074297D28652E6D61702828653D3E66';
wwv_flow_imp.g_varchar2_table(2321) := '756E6374696F6E28652C742C6E297B6C657420693D302C723D303B313D3D3D652E6D6F64696669656452616E67652E656E64436F6C756D6E2626313D3D3D652E6F726967696E616C52616E67652E656E64436F6C756D6E2626652E6F726967696E616C52';
wwv_flow_imp.g_varchar2_table(2322) := '616E67652E73746172744C696E654E756D6265722B693C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722626652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B693C3D652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(2323) := '52616E67652E656E644C696E654E756D626572262628723D2D31292C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2D313E3D6E5B652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722D315D2E6C656E67';
wwv_flow_imp.g_varchar2_table(2324) := '74682626652E6F726967696E616C52616E67652E7374617274436F6C756D6E2D313E3D745B652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722D315D2E6C656E6774682626652E6F726967696E616C52616E67652E73746172';
wwv_flow_imp.g_varchar2_table(2325) := '744C696E654E756D6265723C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722B722626652E6D6F64696669656452616E67652E73746172744C696E654E756D6265723C3D652E6D6F64696669656452616E67652E656E644C69';
wwv_flow_imp.g_varchar2_table(2326) := '6E654E756D6265722B72262628693D31293B636F6E7374206F3D6E657720426928652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722B692C652E6F726967696E616C52616E67652E656E644C696E654E756D6265722B312B72';
wwv_flow_imp.g_varchar2_table(2327) := '292C613D6E657720426928652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B692C652E6D6F64696669656452616E67652E656E644C696E654E756D6265722B312B72293B72657475726E206E6577202469286F2C612C5B65';
wwv_flow_imp.g_varchar2_table(2328) := '5D297D28652C742C6E29292929297B636F6E737420653D695B305D2C743D695B692E6C656E6774682D315D3B722E70757368286E657720246928652E6F726967696E616C2E6A6F696E28742E6F726967696E616C292C652E6D6F6469666965642E6A6F69';
wwv_flow_imp.g_varchar2_table(2329) := '6E28742E6D6F646966696564292C692E6D61702828653D3E652E696E6E65724368616E6765735B305D292929297D72657475726E204D69282828293D3E7B69662821692626722E6C656E6774683E30297B696628725B305D2E6D6F6469666965642E7374';
wwv_flow_imp.g_varchar2_table(2330) := '6172744C696E654E756D626572213D3D725B305D2E6F726967696E616C2E73746172744C696E654E756D6265722972657475726E21313B6966286E2E6C656E6774682D725B722E6C656E6774682D315D2E6D6F6469666965642E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(2331) := '6265724578636C7573697665213D742E6C656E6774682D725B722E6C656E6774682D315D2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652972657475726E21317D72657475726E204E6928722C2828652C74293D3E742E';
wwv_flow_imp.g_varchar2_table(2332) := '6F726967696E616C2E73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965642E73746172744C696E654E756D6265722D652E6D6F6469666965642E656E';
wwv_flow_imp.g_varchar2_table(2333) := '644C696E654E756D6265724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E73746172744C696E654E756D6265722626652E6D6F6469666965642E656E644C69';
wwv_flow_imp.g_varchar2_table(2334) := '6E654E756D6265724578636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D62657229297D29292C727D66756E6374696F6E204E7228652C74297B636F6E7374206E3D4D6174682E706F772831302C74293B72657475726E204D';
wwv_flow_imp.g_varchar2_table(2335) := '6174682E726F756E6428652A6E292F6E7D636C6173732049727B636F6E7374727563746F7228652C742C6E2C693D31297B746869732E5F726762614272616E643D766F696420302C746869732E723D307C4D6174682E6D696E283235352C4D6174682E6D';
wwv_flow_imp.g_varchar2_table(2336) := '617828302C6529292C746869732E673D307C4D6174682E6D696E283235352C4D6174682E6D617828302C7429292C746869732E623D307C4D6174682E6D696E283235352C4D6174682E6D617828302C6E29292C746869732E613D4E72284D6174682E6D61';
wwv_flow_imp.g_varchar2_table(2337) := '78284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E723D3D3D742E722626652E673D3D3D742E672626652E623D3D3D742E622626652E613D3D3D742E617D7D636C617373207A72';
wwv_flow_imp.g_varchar2_table(2338) := '7B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F68736C614272616E643D766F696420302C746869732E683D307C4D6174682E6D6178284D6174682E6D696E283336302C65292C30292C746869732E733D4E72284D6174682E6D6178';
wwv_flow_imp.g_varchar2_table(2339) := '284D6174682E6D696E28312C74292C30292C33292C746869732E6C3D4E72284D6174682E6D6178284D6174682E6D696E28312C6E292C30292C33292C746869732E613D4E72284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73';
wwv_flow_imp.g_varchar2_table(2340) := '746174696320657175616C7328652C74297B72657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E6C3D3D3D742E6C2626652E613D3D3D742E617D7374617469632066726F6D524742412865297B636F6E737420743D652E722F32';
wwv_flow_imp.g_varchar2_table(2341) := '35352C6E3D652E672F3235352C693D652E622F3235352C723D652E612C6F3D4D6174682E6D617828742C6E2C69292C613D4D6174682E6D696E28742C6E2C69293B6C657420733D302C6C3D303B636F6E737420683D28612B6F292F322C633D6F2D613B69';
wwv_flow_imp.g_varchar2_table(2342) := '6628633E30297B737769746368286C3D4D6174682E6D696E28683C3D2E353F632F28322A68293A632F28322D322A68292C31292C6F297B6361736520743A733D286E2D69292F632B286E3C693F363A30293B627265616B3B63617365206E3A733D28692D';
wwv_flow_imp.g_varchar2_table(2343) := '74292F632B323B627265616B3B6361736520693A733D28742D6E292F632B347D732A3D36302C733D4D6174682E726F756E642873297D72657475726E206E6577207A7228732C6C2C682C72297D737461746963205F6875653272676228652C742C6E297B';
wwv_flow_imp.g_varchar2_table(2344) := '72657475726E206E3C302626286E2B3D31292C6E3E312626286E2D3D31292C6E3C312F363F652B362A28742D65292A6E3A6E3C2E353F743A6E3C322F333F652B28742D65292A28322F332D6E292A363A657D73746174696320746F524742412865297B63';
wwv_flow_imp.g_varchar2_table(2345) := '6F6E737420743D652E682F3336302C7B733A6E2C6C3A692C613A727D3D653B6C6574206F2C612C733B696628303D3D3D6E296F3D613D733D693B656C73657B636F6E737420653D693C2E353F692A28312B6E293A692B6E2D692A6E2C723D322A692D653B';
wwv_flow_imp.g_varchar2_table(2346) := '6F3D7A722E5F6875653272676228722C652C742B312F33292C613D7A722E5F6875653272676228722C652C74292C733D7A722E5F6875653272676228722C652C742D312F33297D72657475726E206E6577204972284D6174682E726F756E64283235352A';
wwv_flow_imp.g_varchar2_table(2347) := '6F292C4D6174682E726F756E64283235352A61292C4D6174682E726F756E64283235352A73292C72297D7D636C6173732055727B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F687376614272616E643D766F696420302C74686973';
wwv_flow_imp.g_varchar2_table(2348) := '2E683D307C4D6174682E6D6178284D6174682E6D696E283336302C65292C30292C746869732E733D4E72284D6174682E6D6178284D6174682E6D696E28312C74292C30292C33292C746869732E763D4E72284D6174682E6D6178284D6174682E6D696E28';
wwv_flow_imp.g_varchar2_table(2349) := '312C6E292C30292C33292C746869732E613D4E72284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E';
wwv_flow_imp.g_varchar2_table(2350) := '763D3D3D742E762626652E613D3D3D742E617D7374617469632066726F6D524742412865297B636F6E737420743D652E722F3235352C6E3D652E672F3235352C693D652E622F3235352C723D4D6174682E6D617828742C6E2C69292C6F3D722D4D617468';
wwv_flow_imp.g_varchar2_table(2351) := '2E6D696E28742C6E2C69292C613D303D3D3D723F303A6F2F723B6C657420733B72657475726E20733D303D3D3D6F3F303A723D3D3D743F28286E2D69292F6F25362B362925363A723D3D3D6E3F28692D74292F6F2B323A28742D6E292F6F2B342C6E6577';
wwv_flow_imp.g_varchar2_table(2352) := '205572284D6174682E726F756E642836302A73292C612C722C652E61297D73746174696320746F524742412865297B636F6E73747B683A742C733A6E2C763A692C613A727D3D652C6F3D692A6E2C613D6F2A28312D4D6174682E61627328742F36302532';
wwv_flow_imp.g_varchar2_table(2353) := '2D3129292C733D692D6F3B6C65745B6C2C682C635D3D5B302C302C305D3B72657475726E20743C36303F286C3D6F2C683D61293A743C3132303F286C3D612C683D6F293A743C3138303F28683D6F2C633D61293A743C3234303F28683D612C633D6F293A';
wwv_flow_imp.g_varchar2_table(2354) := '743C3330303F286C3D612C633D6F293A743C3D3336302626286C3D6F2C633D61292C6C3D4D6174682E726F756E64283235352A286C2B7329292C683D4D6174682E726F756E64283235352A28682B7329292C633D4D6174682E726F756E64283235352A28';
wwv_flow_imp.g_varchar2_table(2355) := '632B7329292C6E6577204972286C2C682C632C72297D7D636C6173732048727B7374617469632066726F6D4865782865297B72657475726E2048722E466F726D61742E4353532E70617273654865782865297C7C48722E7265647D737461746963206571';
wwv_flow_imp.g_varchar2_table(2356) := '75616C7328652C74297B72657475726E2165262621747C7C212821657C7C2174292626652E657175616C732874297D6765742068736C6128297B72657475726E20746869732E5F68736C613F746869732E5F68736C613A7A722E66726F6D524742412874';
wwv_flow_imp.g_varchar2_table(2357) := '6869732E72676261297D676574206873766128297B72657475726E20746869732E5F687376613F746869732E5F687376613A55722E66726F6D5247424128746869732E72676261297D636F6E7374727563746F722865297B6966282165297468726F7720';
wwv_flow_imp.g_varchar2_table(2358) := '6E6577204572726F722822436F6C6F72206E6565647320612076616C756522293B6966286520696E7374616E63656F6620497229746869732E726762613D653B656C7365206966286520696E7374616E63656F66207A7229746869732E5F68736C613D65';
wwv_flow_imp.g_varchar2_table(2359) := '2C746869732E726762613D7A722E746F524742412865293B656C73657B69662821286520696E7374616E63656F6620557229297468726F77206E6577204572726F722822496E76616C696420636F6C6F722063746F7220617267756D656E7422293B7468';
wwv_flow_imp.g_varchar2_table(2360) := '69732E5F687376613D652C746869732E726762613D55722E746F524742412865297D7D657175616C732865297B72657475726E212165262649722E657175616C7328746869732E726762612C652E726762612926267A722E657175616C7328746869732E';
wwv_flow_imp.g_varchar2_table(2361) := '68736C612C652E68736C6129262655722E657175616C7328746869732E687376612C652E68737661297D67657452656C61746976654C756D696E616E636528297B72657475726E204E72282E323132362A48722E5F72656C61746976654C756D696E616E';
wwv_flow_imp.g_varchar2_table(2362) := '6365466F72436F6D706F6E656E7428746869732E726762612E72292B2E373135322A48722E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E67292B2E303732322A48722E5F72656C61746976654C';
wwv_flow_imp.g_varchar2_table(2363) := '756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E62292C34297D737461746963205F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E742865297B636F6E737420743D652F3235353B72657475726E2074';
wwv_flow_imp.g_varchar2_table(2364) := '3C3D2E30333932383F742F31322E39323A4D6174682E706F772828742B2E303535292F312E3035352C322E34297D69734C69676874657228297B72657475726E283239392A746869732E726762612E722B3538372A746869732E726762612E672B313134';
wwv_flow_imp.g_varchar2_table(2365) := '2A746869732E726762612E62292F3165333E3D3132387D69734C6967687465725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E616E636528293E652E67657452656C61746976654C756D696E616E636528297D';
wwv_flow_imp.g_varchar2_table(2366) := '69734461726B65725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E616E636528293C652E67657452656C61746976654C756D696E616E636528297D6C69676874656E2865297B72657475726E206E6577204872';
wwv_flow_imp.g_varchar2_table(2367) := '286E6577207A7228746869732E68736C612E682C746869732E68736C612E732C746869732E68736C612E6C2B746869732E68736C612E6C2A652C746869732E68736C612E6129297D6461726B656E2865297B72657475726E206E6577204872286E657720';
wwv_flow_imp.g_varchar2_table(2368) := '7A7228746869732E68736C612E682C746869732E68736C612E732C746869732E68736C612E6C2D746869732E68736C612E6C2A652C746869732E68736C612E6129297D7472616E73706172656E742865297B636F6E73747B723A742C673A6E2C623A692C';
wwv_flow_imp.g_varchar2_table(2369) := '613A727D3D746869732E726762613B72657475726E206E6577204872286E657720497228742C6E2C692C722A6529297D69735472616E73706172656E7428297B72657475726E20303D3D3D746869732E726762612E617D69734F706171756528297B7265';
wwv_flow_imp.g_varchar2_table(2370) := '7475726E20313D3D3D746869732E726762612E617D6F70706F7369746528297B72657475726E206E6577204872286E6577204972283235352D746869732E726762612E722C3235352D746869732E726762612E672C3235352D746869732E726762612E62';
wwv_flow_imp.g_varchar2_table(2371) := '2C746869732E726762612E6129297D6D616B654F70617175652865297B696628746869732E69734F706171756528297C7C31213D3D652E726762612E612972657475726E20746869733B636F6E73747B723A742C673A6E2C623A692C613A727D3D746869';
wwv_flow_imp.g_varchar2_table(2372) := '732E726762613B72657475726E206E6577204872286E657720497228652E726762612E722D722A28652E726762612E722D74292C652E726762612E672D722A28652E726762612E672D6E292C652E726762612E622D722A28652E726762612E622D69292C';
wwv_flow_imp.g_varchar2_table(2373) := '3129297D746F537472696E6728297B72657475726E20746869732E5F746F537472696E677C7C28746869732E5F746F537472696E673D48722E466F726D61742E4353532E666F726D6174287468697329292C746869732E5F746F537472696E677D737461';
wwv_flow_imp.g_varchar2_table(2374) := '746963206765744C696768746572436F6C6F7228652C742C6E297B696628652E69734C6967687465725468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E737420693D652E67657452656C61746976654C756D696E616E636528292C72';
wwv_flow_imp.g_varchar2_table(2375) := '3D742E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A28722D69292F722C652E6C69676874656E286E297D737461746963206765744461726B6572436F6C6F7228652C742C6E297B696628652E69734461726B6572';
wwv_flow_imp.g_varchar2_table(2376) := '5468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E737420693D652E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A28692D742E67657452656C61746976654C756D696E616E63652829292F692C';
wwv_flow_imp.g_varchar2_table(2377) := '652E6461726B656E286E297D7D66756E6374696F6E2044722865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065297B636F6E737420653D4E756D626572286E293B28657C7C303D3D3D6526262222213D3D6E2E7265706C616365';
wwv_flow_imp.g_varchar2_table(2378) := '282F5C732F672C222229292626742E707573682865297D72657475726E20747D66756E6374696F6E204F7228652C742C6E2C69297B72657475726E7B7265643A652F3235352C626C75653A6E2F3235352C677265656E3A742F3235352C616C7068613A69';
wwv_flow_imp.g_varchar2_table(2379) := '7D7D66756E6374696F6E20577228652C74297B636F6E7374206E3D742E696E6465782C693D745B305D2E6C656E6774683B696628216E2972657475726E3B636F6E737420723D652E706F736974696F6E4174286E293B72657475726E7B73746172744C69';
wwv_flow_imp.g_varchar2_table(2380) := '6E654E756D6265723A722E6C696E654E756D6265722C7374617274436F6C756D6E3A722E636F6C756D6E2C656E644C696E654E756D6265723A722E6C696E654E756D6265722C656E64436F6C756D6E3A722E636F6C756D6E2B697D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2381) := '20507228652C74297B69662821652972657475726E3B636F6E7374206E3D48722E466F726D61742E4353532E70617273654865782874293B72657475726E206E3F7B72616E67653A652C636F6C6F723A4F72286E2E726762612E722C6E2E726762612E67';
wwv_flow_imp.g_varchar2_table(2382) := '2C6E2E726762612E622C6E2E726762612E61297D3A766F696420307D66756E6374696F6E20717228652C742C6E297B69662821657C7C31213D3D742E6C656E6774682972657475726E3B636F6E737420693D447228745B305D2E76616C7565732829293B';
wwv_flow_imp.g_varchar2_table(2383) := '72657475726E7B72616E67653A652C636F6C6F723A4F7228695B305D2C695B315D2C695B325D2C6E3F695B335D3A31297D7D66756E6374696F6E20467228652C742C6E297B69662821657C7C31213D3D742E6C656E6774682972657475726E3B636F6E73';
wwv_flow_imp.g_varchar2_table(2384) := '7420693D447228745B305D2E76616C7565732829292C723D6E6577204872286E6577207A7228695B305D2C695B315D2F3130302C695B325D2F3130302C6E3F695B335D3A3129293B72657475726E7B72616E67653A652C636F6C6F723A4F7228722E7267';
wwv_flow_imp.g_varchar2_table(2385) := '62612E722C722E726762612E672C722E726762612E622C722E726762612E61297D7D66756E6374696F6E20427228652C74297B72657475726E22737472696E67223D3D747970656F6620653F5B2E2E2E652E6D61746368416C6C2874295D3A652E66696E';
wwv_flow_imp.g_varchar2_table(2386) := '644D6174636865732874297D48722E77686974653D6E6577204872286E6577204972283235352C3235352C3235352C3129292C48722E626C61636B3D6E6577204872286E657720497228302C302C302C3129292C48722E7265643D6E6577204872286E65';
wwv_flow_imp.g_varchar2_table(2387) := '77204972283235352C302C302C3129292C48722E626C75653D6E6577204872286E657720497228302C302C3235352C3129292C48722E677265656E3D6E6577204872286E657720497228302C3235352C302C3129292C48722E6379616E3D6E6577204872';
wwv_flow_imp.g_varchar2_table(2388) := '286E657720497228302C3235352C3235352C3129292C48722E6C69676874677265793D6E6577204872286E6577204972283231312C3231312C3231312C3129292C48722E7472616E73706172656E743D6E6577204872286E657720497228302C302C302C';
wwv_flow_imp.g_varchar2_table(2389) := '3029292C66756E6374696F6E2865297B6C657420743B2166756E6374696F6E2874297B6C6574206E3B2166756E6374696F6E2874297B66756E6374696F6E206E2865297B636F6E737420743D652E746F537472696E67283136293B72657475726E203221';
wwv_flow_imp.g_varchar2_table(2390) := '3D3D742E6C656E6774683F2230222B743A747D66756E6374696F6E20692865297B7377697463682865297B636173652034383A72657475726E20303B636173652034393A72657475726E20313B636173652035303A72657475726E20323B636173652035';
wwv_flow_imp.g_varchar2_table(2391) := '313A72657475726E20333B636173652035323A72657475726E20343B636173652035333A72657475726E20353B636173652035343A72657475726E20363B636173652035353A72657475726E20373B636173652035363A72657475726E20383B63617365';
wwv_flow_imp.g_varchar2_table(2392) := '2035373A72657475726E20393B636173652039373A636173652036353A72657475726E2031303B636173652039383A636173652036363A72657475726E2031313B636173652039393A636173652036373A72657475726E2031323B63617365203130303A';
wwv_flow_imp.g_varchar2_table(2393) := '636173652036383A72657475726E2031333B63617365203130313A636173652036393A72657475726E2031343B63617365203130323A636173652037303A72657475726E2031357D72657475726E20307D742E666F726D61745247423D66756E6374696F';
wwv_flow_imp.g_varchar2_table(2394) := '6E2874297B72657475726E20313D3D3D742E726762612E613F6072676228247B742E726762612E727D2C20247B742E726762612E677D2C20247B742E726762612E627D29603A652E466F726D61742E4353532E666F726D6174524742412874297D2C742E';
wwv_flow_imp.g_varchar2_table(2395) := '666F726D6174524742413D66756E6374696F6E2865297B72657475726E607267626128247B652E726762612E727D2C20247B652E726762612E677D2C20247B652E726762612E627D2C20247B2B652E726762612E612E746F46697865642832297D29607D';
wwv_flow_imp.g_varchar2_table(2396) := '2C742E666F726D617448534C3D66756E6374696F6E2874297B72657475726E20313D3D3D742E68736C612E613F6068736C28247B742E68736C612E687D2C20247B283130302A742E68736C612E73292E746F46697865642832297D252C20247B28313030';
wwv_flow_imp.g_varchar2_table(2397) := '2A742E68736C612E6C292E746F46697865642832297D2529603A652E466F726D61742E4353532E666F726D617448534C412874297D2C742E666F726D617448534C413D66756E6374696F6E2865297B72657475726E6068736C6128247B652E68736C612E';
wwv_flow_imp.g_varchar2_table(2398) := '687D2C20247B283130302A652E68736C612E73292E746F46697865642832297D252C20247B283130302A652E68736C612E6C292E746F46697865642832297D252C20247B652E68736C612E612E746F46697865642832297D29607D2C742E666F726D6174';
wwv_flow_imp.g_varchar2_table(2399) := '4865783D66756E6374696F6E2865297B72657475726E6023247B6E28652E726762612E72297D247B6E28652E726762612E67297D247B6E28652E726762612E62297D607D2C742E666F726D6174486578413D66756E6374696F6E28742C693D2131297B72';
wwv_flow_imp.g_varchar2_table(2400) := '657475726E20692626313D3D3D742E726762612E613F652E466F726D61742E4353532E666F726D61744865782874293A6023247B6E28742E726762612E72297D247B6E28742E726762612E67297D247B6E28742E726762612E62297D247B6E284D617468';
wwv_flow_imp.g_varchar2_table(2401) := '2E726F756E64283235352A742E726762612E6129297D607D2C742E666F726D61743D66756E6374696F6E2874297B72657475726E20742E69734F706171756528293F652E466F726D61742E4353532E666F726D61744865782874293A652E466F726D6174';
wwv_flow_imp.g_varchar2_table(2402) := '2E4353532E666F726D6174524742412874297D2C742E70617273654865783D66756E6374696F6E2874297B636F6E7374206E3D742E6C656E6774683B696628303D3D3D6E2972657475726E206E756C6C3B6966283335213D3D742E63686172436F646541';
wwv_flow_imp.g_varchar2_table(2403) := '742830292972657475726E206E756C6C3B696628373D3D3D6E297B636F6E7374206E3D31362A6928742E63686172436F64654174283129292B6928742E63686172436F64654174283229292C723D31362A6928742E63686172436F64654174283329292B';
wwv_flow_imp.g_varchar2_table(2404) := '6928742E63686172436F64654174283429292C6F3D31362A6928742E63686172436F64654174283529292B6928742E63686172436F64654174283629293B72657475726E206E65772065286E6577204972286E2C722C6F2C3129297D696628393D3D3D6E';
wwv_flow_imp.g_varchar2_table(2405) := '297B636F6E7374206E3D31362A6928742E63686172436F64654174283129292B6928742E63686172436F64654174283229292C723D31362A6928742E63686172436F64654174283329292B6928742E63686172436F64654174283429292C6F3D31362A69';
wwv_flow_imp.g_varchar2_table(2406) := '28742E63686172436F64654174283529292B6928742E63686172436F64654174283629292C613D31362A6928742E63686172436F64654174283729292B6928742E63686172436F64654174283829293B72657475726E206E65772065286E657720497228';
wwv_flow_imp.g_varchar2_table(2407) := '6E2C722C6F2C612F32353529297D696628343D3D3D6E297B636F6E7374206E3D6928742E63686172436F64654174283129292C723D6928742E63686172436F64654174283229292C6F3D6928742E63686172436F64654174283329293B72657475726E20';
wwv_flow_imp.g_varchar2_table(2408) := '6E65772065286E65772049722831362A6E2B6E2C31362A722B722C31362A6F2B6F29297D696628353D3D3D6E297B636F6E7374206E3D6928742E63686172436F64654174283129292C723D6928742E63686172436F64654174283229292C6F3D6928742E';
wwv_flow_imp.g_varchar2_table(2409) := '63686172436F64654174283329292C613D6928742E63686172436F64654174283429293B72657475726E206E65772065286E65772049722831362A6E2B6E2C31362A722B722C31362A6F2B6F2C2831362A612B61292F32353529297D72657475726E206E';
wwv_flow_imp.g_varchar2_table(2410) := '756C6C7D7D286E3D742E4353537C7C28742E4353533D7B7D29297D28743D652E466F726D61747C7C28652E466F726D61743D7B7D29297D2848727C7C2848723D7B7D29293B636F6E73742056723D2F5C624D41524B3A5C732A282E2A29242F642C4B723D';
wwv_flow_imp.g_varchar2_table(2411) := '2F5E2D2B7C2D2B242F673B66756E6374696F6E206A7228652C742C6E297B56722E6C617374496E6465783D303B636F6E737420693D56722E657865632865293B69662869297B636F6E737420653D7B73746172744C696E654E756D6265723A742C737461';
wwv_flow_imp.g_varchar2_table(2412) := '7274436F6C756D6E3A692E696E64696365735B315D5B305D2B312C656E644C696E654E756D6265723A742C656E64436F6C756D6E3A692E696E64696365735B315D5B315D2B317D3B696628652E656E64436F6C756D6E3E652E7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(2413) := '297B636F6E737420743D7B72616E67653A652C2E2E2E477228695B315D292C73686F756C644265496E436F6D6D656E74733A21307D3B28742E746578747C7C742E686173536570617261746F724C696E652926266E2E707573682874297D7D7D66756E63';
wwv_flow_imp.g_varchar2_table(2414) := '74696F6E2047722865297B636F6E737420743D28653D652E7472696D2829292E7374617274735769746828222D22293B72657475726E7B746578743A653D652E7265706C616365284B722C2222292C686173536570617261746F724C696E653A747D7D63';
wwv_flow_imp.g_varchar2_table(2415) := '6C61737320247220657874656E6473204E747B6765742075726928297B72657475726E20746869732E5F7572697D67657420656F6C28297B72657475726E20746869732E5F656F6C7D67657456616C756528297B72657475726E20746869732E67657454';
wwv_flow_imp.g_varchar2_table(2416) := '65787428297D66696E644D6174636865732865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C746869732E5F6C696E65732E6C656E6774683B6E2B2B297B636F6E737420693D746869732E5F6C696E65735B6E5D2C723D746869732E';
wwv_flow_imp.g_varchar2_table(2417) := '6F66667365744174286E6577205474286E2B312C3129292C6F3D692E6D61746368416C6C2865293B666F7228636F6E73742065206F66206F2928652E696E6465787C7C303D3D3D652E696E64657829262628652E696E6465783D652E696E6465782B7229';
wwv_flow_imp.g_varchar2_table(2418) := '2C742E707573682865297D72657475726E20747D6765744C696E6573436F6E74656E7428297B72657475726E20746869732E5F6C696E65732E736C6963652830297D6765744C696E65436F756E7428297B72657475726E20746869732E5F6C696E65732E';
wwv_flow_imp.g_varchar2_table(2419) := '6C656E6774687D6765744C696E65436F6E74656E742865297B72657475726E20746869732E5F6C696E65735B652D315D7D676574576F72644174506F736974696F6E28652C74297B636F6E7374206E3D487428652E636F6C756D6E2C7A742874292C7468';
wwv_flow_imp.g_varchar2_table(2420) := '69732E5F6C696E65735B652E6C696E654E756D6265722D315D2C30293B72657475726E206E3F6E6577206B7428652E6C696E654E756D6265722C6E2E7374617274436F6C756D6E2C652E6C696E654E756D6265722C6E2E656E64436F6C756D6E293A6E75';
wwv_flow_imp.g_varchar2_table(2421) := '6C6C7D776F7264732865297B636F6E737420743D746869732E5F6C696E65732C6E3D746869732E5F776F7264656E697A652E62696E642874686973293B6C657420693D302C723D22222C6F3D302C613D5B5D3B72657475726E7B2A5B53796D626F6C2E69';
wwv_flow_imp.g_varchar2_table(2422) := '74657261746F725D28297B666F72283B3B296966286F3C612E6C656E677468297B636F6E737420653D722E737562737472696E6728615B6F5D2E73746172742C615B6F5D2E656E64293B6F2B3D312C7969656C6420657D656C73657B6966282128693C74';
wwv_flow_imp.g_varchar2_table(2423) := '2E6C656E6774682929627265616B3B723D745B695D2C613D6E28722C65292C6F3D302C692B3D317D7D7D7D6765744C696E65576F72647328652C74297B636F6E7374206E3D746869732E5F6C696E65735B652D315D2C693D746869732E5F776F7264656E';
wwv_flow_imp.g_varchar2_table(2424) := '697A65286E2C74292C723D5B5D3B666F7228636F6E73742065206F66206929722E70757368287B776F72643A6E2E737562737472696E6728652E73746172742C652E656E64292C7374617274436F6C756D6E3A652E73746172742B312C656E64436F6C75';
wwv_flow_imp.g_varchar2_table(2425) := '6D6E3A652E656E642B317D293B72657475726E20727D5F776F7264656E697A6528652C74297B636F6E7374206E3D5B5D3B6C657420693B666F7228742E6C617374496E6465783D303B28693D742E6578656328652929262630213D3D695B305D2E6C656E';
wwv_flow_imp.g_varchar2_table(2426) := '6774683B296E2E70757368287B73746172743A692E696E6465782C656E643A692E696E6465782B695B305D2E6C656E6774687D293B72657475726E206E7D67657456616C7565496E52616E67652865297B69662828653D746869732E5F76616C69646174';
wwv_flow_imp.g_varchar2_table(2427) := '6552616E6765286529292E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722972657475726E20746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728652E737461';
wwv_flow_imp.g_varchar2_table(2428) := '7274436F6C756D6E2D312C652E656E64436F6C756D6E2D31293B636F6E737420743D746869732E5F656F6C2C6E3D652E73746172744C696E654E756D6265722D312C693D652E656E644C696E654E756D6265722D312C723D5B5D3B722E70757368287468';
wwv_flow_imp.g_varchar2_table(2429) := '69732E5F6C696E65735B6E5D2E737562737472696E6728652E7374617274436F6C756D6E2D3129293B666F72286C657420653D6E2B313B653C693B652B2B29722E7075736828746869732E5F6C696E65735B655D293B72657475726E20722E7075736828';
wwv_flow_imp.g_varchar2_table(2430) := '746869732E5F6C696E65735B695D2E737562737472696E6728302C652E656E64436F6C756D6E2D3129292C722E6A6F696E2874297D6F666673657441742865297B72657475726E20653D746869732E5F76616C6964617465506F736974696F6E2865292C';
wwv_flow_imp.g_varchar2_table(2431) := '746869732E5F656E737572654C696E6553746172747328292C746869732E5F6C696E655374617274732E67657450726566697853756D28652E6C696E654E756D6265722D32292B28652E636F6C756D6E2D31297D706F736974696F6E41742865297B653D';
wwv_flow_imp.g_varchar2_table(2432) := '4D6174682E666C6F6F722865292C653D4D6174682E6D617828302C65292C746869732E5F656E737572654C696E6553746172747328293B636F6E737420743D746869732E5F6C696E655374617274732E676574496E6465784F662865292C6E3D74686973';
wwv_flow_imp.g_varchar2_table(2433) := '2E5F6C696E65735B742E696E6465785D2E6C656E6774683B72657475726E7B6C696E654E756D6265723A312B742E696E6465782C636F6C756D6E3A312B4D6174682E6D696E28742E72656D61696E6465722C6E297D7D5F76616C696461746552616E6765';
wwv_flow_imp.g_varchar2_table(2434) := '2865297B636F6E737420743D746869732E5F76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E73746172744C696E654E756D6265722C636F6C756D6E3A652E7374617274436F6C756D6E7D292C6E3D746869732E5F76616C69';
wwv_flow_imp.g_varchar2_table(2435) := '64617465506F736974696F6E287B6C696E654E756D6265723A652E656E644C696E654E756D6265722C636F6C756D6E3A652E656E64436F6C756D6E7D293B72657475726E20742E6C696E654E756D626572213D3D652E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(2436) := '727C7C742E636F6C756D6E213D3D652E7374617274436F6C756D6E7C7C6E2E6C696E654E756D626572213D3D652E656E644C696E654E756D6265727C7C6E2E636F6C756D6E213D3D652E656E64436F6C756D6E3F7B73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(2437) := '3A742E6C696E654E756D6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D3A657D5F76616C6964617465506F736974696F';
wwv_flow_imp.g_varchar2_table(2438) := '6E2865297B6966282154742E697349506F736974696F6E286529297468726F77206E6577204572726F72282262616420706F736974696F6E22293B6C65747B6C696E654E756D6265723A742C636F6C756D6E3A6E7D3D652C693D21313B696628743C3129';
wwv_flow_imp.g_varchar2_table(2439) := '743D312C6E3D312C693D21303B656C736520696628743E746869732E5F6C696E65732E6C656E67746829743D746869732E5F6C696E65732E6C656E6774682C6E3D746869732E5F6C696E65735B742D315D2E6C656E6774682B312C693D21303B656C7365';
wwv_flow_imp.g_varchar2_table(2440) := '7B636F6E737420653D746869732E5F6C696E65735B742D315D2E6C656E6774682B313B6E3C313F286E3D312C693D2130293A6E3E652626286E3D652C693D2130297D72657475726E20693F7B6C696E654E756D6265723A742C636F6C756D6E3A6E7D3A65';
wwv_flow_imp.g_varchar2_table(2441) := '7D7D636C6173732058727B636F6E7374727563746F7228652C74297B746869732E5F686F73743D652C746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C292C746869732E5F666F726569676E4D6F64756C65466163746F7279';
wwv_flow_imp.g_varchar2_table(2442) := '3D742C746869732E5F666F726569676E4D6F64756C653D6E756C6C7D646973706F736528297B746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C297D5F6765744D6F64656C2865297B72657475726E20746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(2443) := '656C735B655D7D5F6765744D6F64656C7328297B636F6E737420653D5B5D3B72657475726E204F626A6563742E6B65797328746869732E5F6D6F64656C73292E666F72456163682828743D3E652E7075736828746869732E5F6D6F64656C735B745D2929';
wwv_flow_imp.g_varchar2_table(2444) := '292C657D6163636570744E65774D6F64656C2865297B746869732E5F6D6F64656C735B652E75726C5D3D6E65772024722864742E706172736528652E75726C292C652E6C696E65732C652E454F4C2C652E76657273696F6E4964297D6163636570744D6F';
wwv_flow_imp.g_varchar2_table(2445) := '64656C4368616E67656428652C74297B746869732E5F6D6F64656C735B655D2626746869732E5F6D6F64656C735B655D2E6F6E4576656E74732874297D61636365707452656D6F7665644D6F64656C2865297B746869732E5F6D6F64656C735B655D2626';
wwv_flow_imp.g_varchar2_table(2446) := '64656C65746520746869732E5F6D6F64656C735B655D7D6173796E6320636F6D70757465556E69636F6465486967686C696768747328652C742C6E297B636F6E737420693D746869732E5F6765744D6F64656C2865293B72657475726E20693F49692E63';
wwv_flow_imp.g_varchar2_table(2447) := '6F6D70757465556E69636F6465486967686C696768747328692C742C6E293A7B72616E6765733A5B5D2C6861734D6F72653A21312C616D626967756F7573436861726163746572436F756E743A302C696E76697369626C65436861726163746572436F75';
wwv_flow_imp.g_varchar2_table(2448) := '6E743A302C6E6F6E42617369634173636969436861726163746572436F756E743A307D7D6173796E632066696E6453656374696F6E4865616465727328652C74297B636F6E7374206E3D746869732E5F6765744D6F64656C2865293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(2449) := '3F66756E6374696F6E28652C74297B766172206E3B6C657420693D5B5D3B696628742E66696E64526567696F6E53656374696F6E486561646572732626286E756C6C3D3D3D286E3D742E666F6C64696E6752756C6573297C7C766F696420303D3D3D6E3F';
wwv_flow_imp.g_varchar2_table(2450) := '766F696420303A6E2E6D61726B65727329297B636F6E7374206E3D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D2C693D652E6765744C696E65436F756E7428293B666F72286C657420723D313B723C3D693B722B2B297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(2451) := '3D652E6765744C696E65436F6E74656E742872292C6F3D692E6D6174636828742E666F6C64696E6752756C65732E6D61726B6572732E7374617274293B6966286F297B636F6E737420653D7B73746172744C696E654E756D6265723A722C737461727443';
wwv_flow_imp.g_varchar2_table(2452) := '6F6C756D6E3A6F5B305D2E6C656E6774682B312C656E644C696E654E756D6265723A722C656E64436F6C756D6E3A692E6C656E6774682B317D3B696628652E656E64436F6C756D6E3E652E7374617274436F6C756D6E297B636F6E737420743D7B72616E';
wwv_flow_imp.g_varchar2_table(2453) := '67653A652C2E2E2E477228692E737562737472696E67286F5B305D2E6C656E67746829292C73686F756C644265496E436F6D6D656E74733A21317D3B28742E746578747C7C742E686173536570617261746F724C696E652926266E2E707573682874297D';
wwv_flow_imp.g_varchar2_table(2454) := '7D7D72657475726E206E7D28652C74293B693D692E636F6E636174286E297D696628742E66696E644D61726B53656374696F6E48656164657273297B636F6E737420743D66756E6374696F6E2865297B636F6E737420743D5B5D2C6E3D652E6765744C69';
wwv_flow_imp.g_varchar2_table(2455) := '6E65436F756E7428293B666F72286C657420693D313B693C3D6E3B692B2B296A7228652E6765744C696E65436F6E74656E742869292C692C74293B72657475726E20747D2865293B693D692E636F6E6361742874297D72657475726E20697D286E2C7429';
wwv_flow_imp.g_varchar2_table(2456) := '3A5B5D7D6173796E6320636F6D707574654469666628652C742C6E2C69297B636F6E737420723D746869732E5F6765744D6F64656C2865292C6F3D746869732E5F6765744D6F64656C2874293B72657475726E207226266F3F58722E636F6D7075746544';
wwv_flow_imp.g_varchar2_table(2457) := '69666628722C6F2C6E2C69293A6E756C6C7D73746174696320636F6D707574654469666628652C742C6E2C69297B636F6E737420723D22616476616E636564223D3D3D693F6E65772052723A6E6577204A692C6F3D652E6765744C696E6573436F6E7465';
wwv_flow_imp.g_varchar2_table(2458) := '6E7428292C613D742E6765744C696E6573436F6E74656E7428292C733D722E636F6D7075746544696666286F2C612C6E293B66756E6374696F6E206C2865297B72657475726E20652E6D61702828653D3E7B76617220743B72657475726E5B652E6F7269';
wwv_flow_imp.g_varchar2_table(2459) := '67696E616C2E73746172744C696E654E756D6265722C652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6D6F6469666965642E73746172744C696E654E756D6265722C652E6D6F6469666965642E656E644C696E';
wwv_flow_imp.g_varchar2_table(2460) := '654E756D6265724578636C75736976652C6E756C6C3D3D3D28743D652E696E6E65724368616E676573297C7C766F696420303D3D3D743F766F696420303A742E6D61702828653D3E5B652E6F726967696E616C52616E67652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(2461) := '6D6265722C652E6F726967696E616C52616E67652E7374617274436F6C756D6E2C652E6F726967696E616C52616E67652E656E644C696E654E756D6265722C652E6F726967696E616C52616E67652E656E64436F6C756D6E2C652E6D6F64696669656452';
wwv_flow_imp.g_varchar2_table(2462) := '616E67652E73746172744C696E654E756D6265722C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2C652E6D6F64696669656452616E67652E656E644C696E654E756D6265722C652E6D6F64696669656452616E67652E656E64436F';
wwv_flow_imp.g_varchar2_table(2463) := '6C756D6E5D29295D7D29297D72657475726E7B6964656E746963616C3A2128732E6368616E6765732E6C656E6774683E30292626746869732E5F6D6F64656C734172654964656E746963616C28652C74292C717569744561726C793A732E68697454696D';
wwv_flow_imp.g_varchar2_table(2464) := '656F75742C6368616E6765733A6C28732E6368616E676573292C6D6F7665733A732E6D6F7665732E6D61702828653D3E5B652E6C696E6552616E67654D617070696E672E6F726967696E616C2E73746172744C696E654E756D6265722C652E6C696E6552';
wwv_flow_imp.g_varchar2_table(2465) := '616E67654D617070696E672E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D6265722C652E6C696E6552616E67654D';
wwv_flow_imp.g_varchar2_table(2466) := '617070696E672E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6C28652E6368616E676573295D29297D7D737461746963205F6D6F64656C734172654964656E746963616C28652C74297B636F6E7374206E3D652E6765';
wwv_flow_imp.g_varchar2_table(2467) := '744C696E65436F756E7428293B6966286E213D3D742E6765744C696E65436F756E7428292972657475726E21313B666F72286C657420693D313B693C3D6E3B692B2B29696628652E6765744C696E65436F6E74656E74286929213D3D742E6765744C696E';
wwv_flow_imp.g_varchar2_table(2468) := '65436F6E74656E742869292972657475726E21313B72657475726E21307D6173796E6320636F6D707574654D6F72654D696E696D616C456469747328652C742C6E297B636F6E737420693D746869732E5F6765744D6F64656C2865293B69662821692972';
wwv_flow_imp.g_varchar2_table(2469) := '657475726E20743B636F6E737420723D5B5D3B6C6574206F3B743D742E736C6963652830292E736F7274282828652C74293D3E652E72616E67652626742E72616E67653F6B742E636F6D7061726552616E6765735573696E6753746172747328652E7261';
wwv_flow_imp.g_varchar2_table(2470) := '6E67652C742E72616E6765293A28652E72616E67653F303A31292D28742E72616E67653F303A312929293B6C657420613D303B666F72286C657420653D313B653C742E6C656E6774683B652B2B296B742E676574456E64506F736974696F6E28745B615D';
wwv_flow_imp.g_varchar2_table(2471) := '2E72616E6765292E657175616C73286B742E6765745374617274506F736974696F6E28745B655D2E72616E676529293F28745B615D2E72616E67653D6B742E66726F6D506F736974696F6E73286B742E6765745374617274506F736974696F6E28745B61';
wwv_flow_imp.g_varchar2_table(2472) := '5D2E72616E6765292C6B742E676574456E64506F736974696F6E28745B655D2E72616E676529292C745B615D2E746578742B3D745B655D2E74657874293A28612B2B2C745B615D3D745B655D293B742E6C656E6774683D612B313B666F72286C65747B72';
wwv_flow_imp.g_varchar2_table(2473) := '616E67653A652C746578743A612C656F6C3A737D6F662074297B696628226E756D626572223D3D747970656F6620732626286F3D73292C6B742E6973456D7074792865292626216129636F6E74696E75653B636F6E737420743D692E67657456616C7565';
wwv_flow_imp.g_varchar2_table(2474) := '496E52616E67652865293B696628613D612E7265706C616365282F5C725C6E7C5C6E7C5C722F672C692E656F6C292C743D3D3D6129636F6E74696E75653B6966284D6174682E6D617828612E6C656E6774682C742E6C656E677468293E58722E5F646966';
wwv_flow_imp.g_varchar2_table(2475) := '664C696D6974297B722E70757368287B72616E67653A652C746578743A617D293B636F6E74696E75657D636F6E7374206C3D556528742C612C6E292C683D692E6F66667365744174286B742E6C6966742865292E6765745374617274506F736974696F6E';
wwv_flow_imp.g_varchar2_table(2476) := '2829293B666F7228636F6E73742065206F66206C297B636F6E737420743D692E706F736974696F6E417428682B652E6F726967696E616C5374617274292C6E3D692E706F736974696F6E417428682B652E6F726967696E616C53746172742B652E6F7269';
wwv_flow_imp.g_varchar2_table(2477) := '67696E616C4C656E677468292C6F3D7B746578743A612E73756273747228652E6D6F64696669656453746172742C652E6D6F6469666965644C656E677468292C72616E67653A7B73746172744C696E654E756D6265723A742E6C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(2478) := '7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D7D3B692E67657456616C7565496E52616E6765286F2E72616E676529213D3D6F2E';
wwv_flow_imp.g_varchar2_table(2479) := '746578742626722E70757368286F297D7D72657475726E226E756D626572223D3D747970656F66206F2626722E70757368287B656F6C3A6F2C746578743A22222C72616E67653A7B73746172744C696E654E756D6265723A302C7374617274436F6C756D';
wwv_flow_imp.g_varchar2_table(2480) := '6E3A302C656E644C696E654E756D6265723A302C656E64436F6C756D6E3A307D7D292C727D6173796E6320636F6D707574654C696E6B732865297B636F6E737420743D746869732E5F6765744D6F64656C2865293B72657475726E20743F66756E637469';
wwv_flow_imp.g_varchar2_table(2481) := '6F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F756E7426262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F6E74656E743F42742E636F6D707574654C696E';
wwv_flow_imp.g_varchar2_table(2482) := '6B732865293A5B5D7D2874293A6E756C6C7D6173796E6320636F6D7075746544656661756C74446F63756D656E74436F6C6F72732865297B636F6E737420743D746869732E5F6765744D6F64656C2865293B72657475726E20743F66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(2483) := '65297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E67657456616C756526262266756E6374696F6E223D3D747970656F6620652E706F736974696F6E41743F66756E6374696F6E2865297B636F6E737420743D5B5D2C6E';
wwv_flow_imp.g_varchar2_table(2484) := '3D427228652C2F5C62287267627C726762617C68736C7C68736C6129285C285B302D395C732C2E5C255D2A5C29297C282329285B412D46612D66302D395D7B337D295C627C282329285B412D46612D66302D395D7B347D295C627C282329285B412D4661';
wwv_flow_imp.g_varchar2_table(2485) := '2D66302D395D7B367D295C627C282329285B412D46612D66302D395D7B387D295C622F676D293B6966286E2E6C656E6774683E3029666F7228636F6E73742069206F66206E297B636F6E7374206E3D692E66696C7465722828653D3E766F69642030213D';
wwv_flow_imp.g_varchar2_table(2486) := '3D6529292C723D6E5B315D2C6F3D6E5B325D3B696628216F29636F6E74696E75653B6C657420613B69662822726762223D3D3D72297B636F6E737420743D2F5E5C285C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C';
wwv_flow_imp.g_varchar2_table(2487) := '5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C';
wwv_flow_imp.g_varchar2_table(2488) := '315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A5C29242F676D3B613D717228577228652C69292C4272286F2C74292C2131297D656C7365206966282272676261223D3D3D72297B636F6E737420743D2F5E5C285C732A283235';
wwv_flow_imp.g_varchar2_table(2489) := '5B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D29';
wwv_flow_imp.g_varchar2_table(2490) := '5C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A28305B2E5D5B302D395D2B7C5B2E5D5B302D395D2B7C5B30315D5B2E5D7C5B30315D295C732A';
wwv_flow_imp.g_varchar2_table(2491) := '5C29242F676D3B613D717228577228652C69292C4272286F2C74292C2130297D656C7365206966282268736C223D3D3D72297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D395D7C5B31325D5B302D395D5B302D395D7C';
wwv_flow_imp.g_varchar2_table(2492) := '5B312D395D3F5B302D395D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A5C29242F676D3B613D467228577228';
wwv_flow_imp.g_varchar2_table(2493) := '652C69292C4272286F2C74292C2131297D656C7365206966282268736C61223D3D3D72297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D395D7C5B31325D5B302D395D5B302D395D7C5B312D395D3F5B302D395D295C73';
wwv_flow_imp.g_varchar2_table(2494) := '2A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A28305B2E5D5B302D395D2B7C5B2E5D5B302D395D2B7C5B3031';
wwv_flow_imp.g_varchar2_table(2495) := '5D5B2E5D7C5B30315D295C732A5C29242F676D3B613D467228577228652C69292C4272286F2C74292C2130297D656C73652223223D3D3D72262628613D507228577228652C69292C722B6F29293B612626742E707573682861297D72657475726E20747D';
wwv_flow_imp.g_varchar2_table(2496) := '2865293A5B5D7D2874293A6E756C6C7D6173796E63207465787475616C5375676765737428652C742C6E2C69297B636F6E737420723D6E657720772C6F3D6E657720526567457870286E2C69292C613D6E6577205365743B653A666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(2497) := '6E206F662065297B636F6E737420653D746869732E5F6765744D6F64656C286E293B6966286529666F7228636F6E7374206E206F6620652E776F726473286F29296966286E213D3D74262669734E614E284E756D626572286E2929262628612E61646428';
wwv_flow_imp.g_varchar2_table(2498) := '6E292C612E73697A653E58722E5F73756767657374696F6E734C696D69742929627265616B20657D72657475726E7B776F7264733A41727261792E66726F6D2861292C6475726174696F6E3A722E656C617073656428297D7D6173796E6320636F6D7075';
wwv_flow_imp.g_varchar2_table(2499) := '7465576F726452616E67657328652C742C6E2C69297B636F6E737420723D746869732E5F6765744D6F64656C2865293B69662821722972657475726E204F626A6563742E637265617465286E756C6C293B636F6E7374206F3D6E65772052656745787028';
wwv_flow_imp.g_varchar2_table(2500) := '6E2C69292C613D4F626A6563742E637265617465286E756C6C293B666F72286C657420653D742E73746172744C696E654E756D6265723B653C742E656E644C696E654E756D6265723B652B2B297B636F6E737420743D722E6765744C696E65576F726473';
wwv_flow_imp.g_varchar2_table(2501) := '28652C6F293B666F7228636F6E7374206E206F662074297B6966282169734E614E284E756D626572286E2E776F7264292929636F6E74696E75653B6C657420743D615B6E2E776F72645D3B747C7C28743D5B5D2C615B6E2E776F72645D3D74292C742E70';
wwv_flow_imp.g_varchar2_table(2502) := '757368287B73746172744C696E654E756D6265723A652C7374617274436F6C756D6E3A6E2E7374617274436F6C756D6E2C656E644C696E654E756D6265723A652C656E64436F6C756D6E3A6E2E656E64436F6C756D6E7D297D7D72657475726E20617D61';
wwv_flow_imp.g_varchar2_table(2503) := '73796E63206E6176696761746556616C756553657428652C742C6E2C692C72297B636F6E7374206F3D746869732E5F6765744D6F64656C2865293B696628216F2972657475726E206E756C6C3B636F6E737420613D6E65772052656745787028692C7229';
wwv_flow_imp.g_varchar2_table(2504) := '3B742E7374617274436F6C756D6E3D3D3D742E656E64436F6C756D6E262628743D7B73746172744C696E654E756D6265723A742E73746172744C696E654E756D6265722C7374617274436F6C756D6E3A742E7374617274436F6C756D6E2C656E644C696E';
wwv_flow_imp.g_varchar2_table(2505) := '654E756D6265723A742E656E644C696E654E756D6265722C656E64436F6C756D6E3A742E656E64436F6C756D6E2B317D293B636F6E737420733D6F2E67657456616C7565496E52616E67652874292C6C3D6F2E676574576F72644174506F736974696F6E';
wwv_flow_imp.g_varchar2_table(2506) := '287B6C696E654E756D6265723A742E73746172744C696E654E756D6265722C636F6C756D6E3A742E7374617274436F6C756D6E7D2C61293B696628216C2972657475726E206E756C6C3B636F6E737420683D6F2E67657456616C7565496E52616E676528';
wwv_flow_imp.g_varchar2_table(2507) := '6C293B72657475726E2056742E494E5354414E43452E6E6176696761746556616C756553657428742C732C6C2C682C6E297D6C6F6164466F726569676E4D6F64756C6528652C742C6E297B636F6E737420693D66756E6374696F6E28652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(2508) := '7374206E3D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B72657475726E207428652C6E297D2C693D7B7D3B666F7228636F6E73742074206F';
wwv_flow_imp.g_varchar2_table(2509) := '66206529695B745D3D6E2874293B72657475726E20697D286E2C2828652C74293D3E746869732E5F686F73742E66687228652C742929292C723D7B686F73743A692C6765744D6972726F724D6F64656C733A28293D3E746869732E5F6765744D6F64656C';
wwv_flow_imp.g_varchar2_table(2510) := '7328297D3B72657475726E20746869732E5F666F726569676E4D6F64756C65466163746F72793F28746869732E5F666F726569676E4D6F64756C653D746869732E5F666F726569676E4D6F64756C65466163746F727928722C74292C50726F6D6973652E';
wwv_flow_imp.g_varchar2_table(2511) := '7265736F6C7665284528746869732E5F666F726569676E4D6F64756C652929293A50726F6D6973652E72656A656374286E6577204572726F722822556E65787065637465642075736167652229297D666D7228652C74297B69662821746869732E5F666F';
wwv_flow_imp.g_varchar2_table(2512) := '726569676E4D6F64756C657C7C2266756E6374696F6E22213D747970656F6620746869732E5F666F726569676E4D6F64756C655B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E672072657175';
wwv_flow_imp.g_varchar2_table(2513) := '65737448616E646C6572206F72206D6574686F643A20222B6529293B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F666F726569676E4D6F64756C655B655D2E6170706C7928746869732E5F666F726569676E4D6F64';
wwv_flow_imp.g_varchar2_table(2514) := '756C652C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D7D58722E5F646966664C696D69743D3165352C58722E5F73756767657374696F6E734C696D69743D3165342C2266756E6374696F6E223D3D74';
wwv_flow_imp.g_varchar2_table(2515) := '7970656F6620696D706F727453637269707473262628676C6F62616C546869732E6D6F6E61636F3D7B656469746F723A766F696420302C6C616E6775616765733A766F696420302C43616E63656C6C6174696F6E546F6B656E536F757263653A636C6173';
wwv_flow_imp.g_varchar2_table(2516) := '737B636F6E7374727563746F722865297B746869732E5F746F6B656E3D766F696420302C746869732E5F706172656E744C697374656E65723D766F696420302C746869732E5F706172656E744C697374656E65723D652626652E6F6E43616E63656C6C61';
wwv_flow_imp.g_varchar2_table(2517) := '74696F6E52657175657374656428746869732E63616E63656C2C74686973297D67657420746F6B656E28297B72657475726E20746869732E5F746F6B656E7C7C28746869732E5F746F6B656E3D6E6577204774292C746869732E5F746F6B656E7D63616E';
wwv_flow_imp.g_varchar2_table(2518) := '63656C28297B746869732E5F746F6B656E3F746869732E5F746F6B656E20696E7374616E63656F662047742626746869732E5F746F6B656E2E63616E63656C28293A746869732E5F746F6B656E3D6A742E43616E63656C6C65647D646973706F73652865';
wwv_flow_imp.g_varchar2_table(2519) := '3D2131297B76617220743B652626746869732E63616E63656C28292C6E756C6C3D3D3D28743D746869732E5F706172656E744C697374656E6572297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E5F746F6B656E3F746869';
wwv_flow_imp.g_varchar2_table(2520) := '732E5F746F6B656E20696E7374616E63656F662047742626746869732E5F746F6B656E2E646973706F736528293A746869732E5F746F6B656E3D6A742E4E6F6E657D7D2C456D69747465723A4C2C4B6579436F64653A4B6E2C4B65794D6F643A54692C50';
wwv_flow_imp.g_varchar2_table(2521) := '6F736974696F6E3A54742C52616E67653A6B742C53656C656374696F6E3A736E2C53656C656374696F6E446972656374696F6E3A73692C4D61726B657253657665726974793A6A6E2C4D61726B65725461673A476E2C5572693A64742C546F6B656E3A63';
wwv_flow_imp.g_varchar2_table(2522) := '6C6173737B636F6E7374727563746F7228652C742C6E297B746869732E6F66667365743D652C746869732E747970653D742C746869732E6C616E67756167653D6E2C746869732E5F746F6B656E4272616E643D766F696420307D746F537472696E672829';
wwv_flow_imp.g_varchar2_table(2523) := '7B72657475726E2228222B746869732E6F66667365742B222C20222B746869732E747970652B2229227D7D7D293B6C6574204A723D21313B66756E6374696F6E2059722865297B6966284A722972657475726E3B4A723D21303B636F6E737420743D6E65';
wwv_flow_imp.g_varchar2_table(2524) := '77204C652828653D3E7B676C6F62616C546869732E706F73744D6573736167652865297D292C28743D3E6E657720587228742C652929293B676C6F62616C546869732E6F6E6D6573736167653D653D3E7B742E6F6E6D65737361676528652E6461746129';
wwv_flow_imp.g_varchar2_table(2525) := '7D7D66756E6374696F6E20517228652C742C2E2E2E6E297B72657475726E2066756E6374696F6E28652C74297B6C6574206E3B72657475726E206E3D303D3D3D742E6C656E6774683F653A652E7265706C616365282F5C7B285C642B295C7D2F672C2828';
wwv_flow_imp.g_varchar2_table(2526) := '652C6E293D3E7B6C657420693D6E5B305D3B72657475726E20766F69642030213D3D745B695D3F745B695D3A657D29292C6E7D28742C6E297D66756E6374696F6E205A722865297B72657475726E2051727D76617220656F2C746F2C6E6F2C696F2C726F';
wwv_flow_imp.g_varchar2_table(2527) := '2C6F6F2C616F2C736F2C6C6F2C686F2C636F2C756F2C6D6F2C706F2C666F2C676F2C626F2C5F6F2C766F2C776F2C796F2C546F2C6B6F2C536F2C786F2C4C6F2C436F2C456F2C416F2C526F2C4D6F2C4E6F2C496F2C7A6F2C556F2C486F2C446F2C4F6F2C';
wwv_flow_imp.g_varchar2_table(2528) := '576F2C506F2C716F2C466F2C426F2C566F2C4B6F2C6A6F2C476F2C246F2C586F3B676C6F62616C546869732E6F6E6D6573736167653D653D3E7B4A727C7C5972286E756C6C297D2C28746F3D656F7C7C28656F3D7B7D29292E4D494E5F56414C55453D2D';
wwv_flow_imp.g_varchar2_table(2529) := '323134373438333634382C746F2E4D41585F56414C55453D323134373438333634372C28696F3D6E6F7C7C286E6F3D7B7D29292E4D494E5F56414C55453D302C696F2E4D41585F56414C55453D323134373438333634372C286F6F3D726F7C7C28726F3D';
wwv_flow_imp.g_varchar2_table(2530) := '7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E20653D3D3D4E756D6265722E4D41585F56414C5545262628653D6E6F2E4D41585F56414C5545292C743D3D3D4E756D6265722E4D41585F56414C5545262628743D6E6F2E';
wwv_flow_imp.g_varchar2_table(2531) := '4D41585F56414C5545292C7B6C696E653A652C6368617261637465723A747D7D2C6F6F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E6F626A6563744C69746572616C287429262658612E75696E74656765722874';
wwv_flow_imp.g_varchar2_table(2532) := '2E6C696E6529262658612E75696E746567657228742E636861726163746572297D2C28736F3D616F7C7C28616F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C69297B69662858612E75696E7465676572286529262658612E7569';
wwv_flow_imp.g_varchar2_table(2533) := '6E7465676572287429262658612E75696E7465676572286E29262658612E75696E74656765722869292972657475726E7B73746172743A726F2E63726561746528652C74292C656E643A726F2E637265617465286E2C69297D3B696628726F2E69732865';
wwv_flow_imp.g_varchar2_table(2534) := '292626726F2E69732874292972657475726E7B73746172743A652C656E643A747D3B7468726F77206E6577204572726F72282252616E6765236372656174652063616C6C6564207769746820696E76616C696420617267756D656E74735B222B652B222C';
wwv_flow_imp.g_varchar2_table(2535) := '20222B742B222C20222B6E2B222C20222B692B225D22297D2C736F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E6F626A6563744C69746572616C2874292626726F2E697328742E7374617274292626726F2E6973';
wwv_flow_imp.g_varchar2_table(2536) := '28742E656E64297D2C28686F3D6C6F7C7C286C6F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C72616E67653A747D7D2C686F2E69733D66756E6374696F6E2865297B76617220743D653B72657475';
wwv_flow_imp.g_varchar2_table(2537) := '726E2058612E646566696E65642874292626616F2E697328742E72616E67652926262858612E737472696E6728742E757269297C7C58612E756E646566696E656428742E75726929297D2C28756F3D636F7C7C28636F3D7B7D29292E6372656174653D66';
wwv_flow_imp.g_varchar2_table(2538) := '756E6374696F6E28652C742C6E2C69297B72657475726E7B7461726765745572693A652C74617267657452616E67653A742C74617267657453656C656374696F6E52616E67653A6E2C6F726967696E53656C656374696F6E52616E67653A697D7D2C756F';
wwv_flow_imp.g_varchar2_table(2539) := '2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E65642874292626616F2E697328742E74617267657452616E676529262658612E737472696E6728742E74617267657455726929262628616F2E69732874';
wwv_flow_imp.g_varchar2_table(2540) := '2E74617267657453656C656374696F6E52616E6765297C7C58612E756E646566696E656428742E74617267657453656C656374696F6E52616E67652929262628616F2E697328742E6F726967696E53656C656374696F6E52616E6765297C7C58612E756E';
wwv_flow_imp.g_varchar2_table(2541) := '646566696E656428742E6F726967696E53656C656374696F6E52616E676529297D2C28706F3D6D6F7C7C286D6F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C69297B72657475726E7B7265643A652C677265656E3A742C626C75';
wwv_flow_imp.g_varchar2_table(2542) := '653A6E2C616C7068613A697D7D2C706F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E6E756D62657252616E676528742E7265642C302C3129262658612E6E756D62657252616E676528742E677265656E2C302C31';
wwv_flow_imp.g_varchar2_table(2543) := '29262658612E6E756D62657252616E676528742E626C75652C302C3129262658612E6E756D62657252616E676528742E616C7068612C302C31297D2C28676F3D666F7C7C28666F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B7265';
wwv_flow_imp.g_varchar2_table(2544) := '7475726E7B72616E67653A652C636F6C6F723A747D7D2C676F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20616F2E697328742E72616E67652926266D6F2E697328742E636F6C6F72297D2C285F6F3D626F7C7C28626F3D';
wwv_flow_imp.g_varchar2_table(2545) := '7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B6C6162656C3A652C74657874456469743A742C6164646974696F6E616C5465787445646974733A6E7D7D2C5F6F2E69733D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(2546) := '743D653B72657475726E2058612E737472696E6728742E6C6162656C2926262858612E756E646566696E656428742E7465787445646974297C7C7A6F2E69732874292926262858612E756E646566696E656428742E6164646974696F6E616C5465787445';
wwv_flow_imp.g_varchar2_table(2547) := '64697473297C7C58612E7479706564417272617928742E6164646974696F6E616C5465787445646974732C7A6F2E697329297D2C28776F3D766F7C7C28766F3D7B7D29292E436F6D6D656E743D22636F6D6D656E74222C776F2E496D706F7274733D2269';
wwv_flow_imp.g_varchar2_table(2548) := '6D706F727473222C776F2E526567696F6E3D22726567696F6E222C28546F3D796F7C7C28796F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C692C72297B766172206F3D7B73746172744C696E653A652C656E644C696E653A747D';
wwv_flow_imp.g_varchar2_table(2549) := '3B72657475726E2058612E646566696E6564286E292626286F2E73746172744368617261637465723D6E292C58612E646566696E65642869292626286F2E656E644368617261637465723D69292C58612E646566696E65642872292626286F2E6B696E64';
wwv_flow_imp.g_varchar2_table(2550) := '3D72292C6F7D2C546F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E75696E746567657228742E73746172744C696E6529262658612E75696E746567657228742E73746172744C696E652926262858612E756E6465';
wwv_flow_imp.g_varchar2_table(2551) := '66696E656428742E7374617274436861726163746572297C7C58612E75696E746567657228742E7374617274436861726163746572292926262858612E756E646566696E656428742E656E64436861726163746572297C7C58612E75696E746567657228';
wwv_flow_imp.g_varchar2_table(2552) := '742E656E64436861726163746572292926262858612E756E646566696E656428742E6B696E64297C7C58612E737472696E6728742E6B696E6429297D2C28536F3D6B6F7C7C286B6F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(2553) := '657475726E7B6C6F636174696F6E3A652C6D6573736167653A747D7D2C536F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E656428742926266C6F2E697328742E6C6F636174696F6E29262658612E73';
wwv_flow_imp.g_varchar2_table(2554) := '7472696E6728742E6D657373616765297D2C284C6F3D786F7C7C28786F3D7B7D29292E4572726F723D312C4C6F2E5761726E696E673D322C4C6F2E496E666F726D6174696F6E3D332C4C6F2E48696E743D342C28456F3D436F7C7C28436F3D7B7D29292E';
wwv_flow_imp.g_varchar2_table(2555) := '556E6E65636573736172793D312C456F2E446570726563617465643D322C28416F7C7C28416F3D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206E756C6C213D74262658612E737472696E6728742E6872656629';
wwv_flow_imp.g_varchar2_table(2556) := '7D2C284D6F3D526F7C7C28526F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C692C722C6F297B76617220613D7B72616E67653A652C6D6573736167653A747D3B72657475726E2058612E646566696E6564286E29262628612E73';
wwv_flow_imp.g_varchar2_table(2557) := '657665726974793D6E292C58612E646566696E6564286929262628612E636F64653D69292C58612E646566696E6564287229262628612E736F757263653D72292C58612E646566696E6564286F29262628612E72656C61746564496E666F726D6174696F';
wwv_flow_imp.g_varchar2_table(2558) := '6E3D6F292C617D2C4D6F2E69733D66756E6374696F6E2865297B76617220742C6E3D653B72657475726E2058612E646566696E6564286E292626616F2E6973286E2E72616E676529262658612E737472696E67286E2E6D6573736167652926262858612E';
wwv_flow_imp.g_varchar2_table(2559) := '6E756D626572286E2E7365766572697479297C7C58612E756E646566696E6564286E2E7365766572697479292926262858612E696E7465676572286E2E636F6465297C7C58612E737472696E67286E2E636F6465297C7C58612E756E646566696E656428';
wwv_flow_imp.g_varchar2_table(2560) := '6E2E636F6465292926262858612E756E646566696E6564286E2E636F64654465736372697074696F6E297C7C58612E737472696E67286E756C6C3D3D3D28743D6E2E636F64654465736372697074696F6E297C7C766F696420303D3D3D743F766F696420';
wwv_flow_imp.g_varchar2_table(2561) := '303A742E68726566292926262858612E737472696E67286E2E736F75726365297C7C58612E756E646566696E6564286E2E736F75726365292926262858612E756E646566696E6564286E2E72656C61746564496E666F726D6174696F6E297C7C58612E74';
wwv_flow_imp.g_varchar2_table(2562) := '797065644172726179286E2E72656C61746564496E666F726D6174696F6E2C6B6F2E697329297D2C28496F3D4E6F7C7C284E6F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B666F7228766172206E3D5B5D2C693D323B693C617267';
wwv_flow_imp.g_varchar2_table(2563) := '756D656E74732E6C656E6774683B692B2B296E5B692D325D3D617267756D656E74735B695D3B76617220723D7B7469746C653A652C636F6D6D616E643A747D3B72657475726E2058612E646566696E6564286E2926266E2E6C656E6774683E3026262872';
wwv_flow_imp.g_varchar2_table(2564) := '2E617267756D656E74733D6E292C727D2C496F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E6564287429262658612E737472696E6728742E7469746C6529262658612E737472696E6728742E636F6D';
wwv_flow_imp.g_varchar2_table(2565) := '6D616E64297D2C28556F3D7A6F7C7C287A6F3D7B7D29292E7265706C6163653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A747D7D2C556F2E696E736572743D66756E6374696F6E28652C74297B726574';
wwv_flow_imp.g_varchar2_table(2566) := '75726E7B72616E67653A7B73746172743A652C656E643A657D2C6E6577546578743A747D7D2C556F2E64656C3D66756E6374696F6E2865297B72657475726E7B72616E67653A652C6E6577546578743A22227D7D2C556F2E69733D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(2567) := '65297B76617220743D653B72657475726E2058612E6F626A6563744C69746572616C287429262658612E737472696E6728742E6E657754657874292626616F2E697328742E72616E6765297D2C28446F3D486F7C7C28486F3D7B7D29292E637265617465';
wwv_flow_imp.g_varchar2_table(2568) := '3D66756E6374696F6E28652C742C6E297B76617220693D7B6C6162656C3A657D3B72657475726E20766F69642030213D3D74262628692E6E65656473436F6E6669726D6174696F6E3D74292C766F69642030213D3D6E262628692E646573637269707469';
wwv_flow_imp.g_varchar2_table(2569) := '6F6E3D6E292C697D2C446F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20766F69642030213D3D74262658612E6F626A6563744C69746572616C287429262658612E737472696E6728742E6C6162656C2926262858612E62';
wwv_flow_imp.g_varchar2_table(2570) := '6F6F6C65616E28742E6E65656473436F6E6669726D6174696F6E297C7C766F696420303D3D3D742E6E65656473436F6E6669726D6174696F6E2926262858612E737472696E6728742E6465736372697074696F6E297C7C766F696420303D3D3D742E6465';
wwv_flow_imp.g_varchar2_table(2571) := '736372697074696F6E297D2C284F6F7C7C284F6F3D7B7D29292E69733D66756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620657D2C28506F3D576F7C7C28576F3D7B7D29292E7265706C6163653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2572) := '28652C742C6E297B72657475726E7B72616E67653A652C6E6577546578743A742C616E6E6F746174696F6E49643A6E7D7D2C506F2E696E736572743D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A7B73746172743A652C656E';
wwv_flow_imp.g_varchar2_table(2573) := '643A657D2C6E6577546578743A742C616E6E6F746174696F6E49643A6E7D7D2C506F2E64656C3D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A22222C616E6E6F746174696F6E49643A747D7D2C506F2E69';
wwv_flow_imp.g_varchar2_table(2574) := '733D66756E6374696F6E2865297B76617220743D653B72657475726E207A6F2E6973287429262628486F2E697328742E616E6E6F746174696F6E4964297C7C4F6F2E697328742E616E6E6F746174696F6E496429297D2C28466F3D716F7C7C28716F3D7B';
wwv_flow_imp.g_varchar2_table(2575) := '7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B74657874446F63756D656E743A652C65646974733A747D7D2C466F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E6564';
wwv_flow_imp.g_varchar2_table(2576) := '287429262665612E697328742E74657874446F63756D656E7429262641727261792E6973417272617928742E6564697473297D2C28566F3D426F7C7C28426F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220693D7B6B';
wwv_flow_imp.g_varchar2_table(2577) := '696E643A22637265617465222C7572693A657D3B72657475726E20766F696420303D3D3D747C7C766F696420303D3D3D742E6F76657277726974652626766F696420303D3D3D742E69676E6F726549664578697374737C7C28692E6F7074696F6E733D74';
wwv_flow_imp.g_varchar2_table(2578) := '292C766F69642030213D3D6E262628692E616E6E6F746174696F6E49643D6E292C697D2C566F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262622637265617465223D3D3D742E6B696E64262658612E737472696E67';
wwv_flow_imp.g_varchar2_table(2579) := '28742E75726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E6F76657277726974657C7C58612E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974652929262628766F6964';
wwv_flow_imp.g_varchar2_table(2580) := '20303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C58612E626F6F6C65616E28742E6F7074696F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C4F6F2E';
wwv_flow_imp.g_varchar2_table(2581) := '697328742E616E6E6F746174696F6E496429297D2C286A6F3D4B6F7C7C284B6F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C69297B76617220723D7B6B696E643A2272656E616D65222C6F6C645572693A652C6E65775572693A';
wwv_flow_imp.g_varchar2_table(2582) := '747D3B72657475726E20766F696420303D3D3D6E7C7C766F696420303D3D3D6E2E6F76657277726974652626766F696420303D3D3D6E2E69676E6F726549664578697374737C7C28722E6F7074696F6E733D6E292C766F69642030213D3D69262628722E';
wwv_flow_imp.g_varchar2_table(2583) := '616E6E6F746174696F6E49643D69292C727D2C6A6F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426262272656E616D65223D3D3D742E6B696E64262658612E737472696E6728742E6F6C6455726929262658612E7374';
wwv_flow_imp.g_varchar2_table(2584) := '72696E6728742E6E657755726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E6F76657277726974657C7C58612E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974652929';
wwv_flow_imp.g_varchar2_table(2585) := '262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C58612E626F6F6C65616E28742E6F7074696F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E';
wwv_flow_imp.g_varchar2_table(2586) := '49647C7C4F6F2E697328742E616E6E6F746174696F6E496429297D2C28246F3D476F7C7C28476F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220693D7B6B696E643A2264656C657465222C7572693A657D3B72657475';
wwv_flow_imp.g_varchar2_table(2587) := '726E20766F696420303D3D3D747C7C766F696420303D3D3D742E7265637572736976652626766F696420303D3D3D742E69676E6F726549664E6F744578697374737C7C28692E6F7074696F6E733D74292C766F69642030213D3D6E262628692E616E6E6F';
wwv_flow_imp.g_varchar2_table(2588) := '746174696F6E49643D6E292C697D2C246F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426262264656C657465223D3D3D742E6B696E64262658612E737472696E6728742E75726929262628766F696420303D3D3D742E';
wwv_flow_imp.g_varchar2_table(2589) := '6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E7265637572736976657C7C58612E626F6F6C65616E28742E6F7074696F6E732E7265637572736976652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F7265';
wwv_flow_imp.g_varchar2_table(2590) := '49664E6F744578697374737C7C58612E626F6F6C65616E28742E6F7074696F6E732E69676E6F726549664E6F74457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C4F6F2E697328742E616E6E6F746174696F6E';
wwv_flow_imp.g_varchar2_table(2591) := '496429297D2C28586F7C7C28586F3D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262628766F69642030213D3D742E6368616E6765737C7C766F69642030213D3D742E646F63756D656E744368616E676573';
wwv_flow_imp.g_varchar2_table(2592) := '29262628766F696420303D3D3D742E646F63756D656E744368616E6765737C7C742E646F63756D656E744368616E6765732E6576657279282866756E6374696F6E2865297B72657475726E2058612E737472696E6728652E6B696E64293F426F2E697328';
wwv_flow_imp.g_varchar2_table(2593) := '65297C7C4B6F2E69732865297C7C476F2E69732865293A716F2E69732865297D2929297D3B766172204A6F2C596F2C516F2C5A6F2C65612C74612C6E612C69612C72612C6F612C61612C73612C6C612C68612C63612C64612C75612C6D612C70612C6661';
wwv_flow_imp.g_varchar2_table(2594) := '2C67612C62612C5F612C76612C77612C79612C54612C6B612C53612C78612C4C612C43612C45612C41612C52612C4D612C4E612C49612C7A612C55612C48612C44612C4F612C57612C50612C71612C46612C42612C56612C4B612C6A612C47613D66756E';
wwv_flow_imp.g_varchar2_table(2595) := '6374696F6E28297B66756E6374696F6E206528652C74297B746869732E65646974733D652C746869732E6368616E6765416E6E6F746174696F6E733D747D72657475726E20652E70726F746F747970652E696E736572743D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(2596) := '2C6E297B76617220692C723B696628766F696420303D3D3D6E3F693D7A6F2E696E7365727428652C74293A4F6F2E6973286E293F28723D6E2C693D576F2E696E7365727428652C742C6E29293A28746869732E6173736572744368616E6765416E6E6F74';
wwv_flow_imp.g_varchar2_table(2597) := '6174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C723D746869732E6368616E6765416E6E6F746174696F6E732E6D616E616765286E292C693D576F2E696E7365727428652C742C7229292C746869732E65646974732E707573';
wwv_flow_imp.g_varchar2_table(2598) := '682869292C766F69642030213D3D722972657475726E20727D2C652E70726F746F747970652E7265706C6163653D66756E6374696F6E28652C742C6E297B76617220692C723B696628766F696420303D3D3D6E3F693D7A6F2E7265706C61636528652C74';
wwv_flow_imp.g_varchar2_table(2599) := '293A4F6F2E6973286E293F28723D6E2C693D576F2E7265706C61636528652C742C6E29293A28746869732E6173736572744368616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C723D746869732E6368';
wwv_flow_imp.g_varchar2_table(2600) := '616E6765416E6E6F746174696F6E732E6D616E616765286E292C693D576F2E7265706C61636528652C742C7229292C746869732E65646974732E707573682869292C766F69642030213D3D722972657475726E20727D2C652E70726F746F747970652E64';
wwv_flow_imp.g_varchar2_table(2601) := '656C6574653D66756E6374696F6E28652C74297B766172206E2C693B696628766F696420303D3D3D743F6E3D7A6F2E64656C2865293A4F6F2E69732874293F28693D742C6E3D576F2E64656C28652C7429293A28746869732E6173736572744368616E67';
wwv_flow_imp.g_varchar2_table(2602) := '65416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C693D746869732E6368616E6765416E6E6F746174696F6E732E6D616E6167652874292C6E3D576F2E64656C28652C6929292C746869732E65646974732E7075';
wwv_flow_imp.g_varchar2_table(2603) := '7368286E292C766F69642030213D3D692972657475726E20697D2C652E70726F746F747970652E6164643D66756E6374696F6E2865297B746869732E65646974732E707573682865297D2C652E70726F746F747970652E616C6C3D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(2604) := '297B72657475726E20746869732E65646974737D2C652E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E65646974732E73706C69636528302C746869732E65646974732E6C656E677468297D2C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(2605) := '652E6173736572744368616E6765416E6E6F746174696F6E733D66756E6374696F6E2865297B696628766F696420303D3D3D65297468726F77206E6577204572726F722822546578742065646974206368616E6765206973206E6F7420636F6E66696775';
wwv_flow_imp.g_varchar2_table(2606) := '72656420746F206D616E616765206368616E676520616E6E6F746174696F6E732E22297D2C657D28292C24613D66756E6374696F6E28297B66756E6374696F6E20652865297B746869732E5F616E6E6F746174696F6E733D766F696420303D3D3D653F4F';
wwv_flow_imp.g_varchar2_table(2607) := '626A6563742E637265617465286E756C6C293A652C746869732E5F636F756E7465723D302C746869732E5F73697A653D307D72657475726E20652E70726F746F747970652E616C6C3D66756E6374696F6E28297B72657475726E20746869732E5F616E6E';
wwv_flow_imp.g_varchar2_table(2608) := '6F746174696F6E737D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2273697A65222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F73697A657D2C656E756D657261626C653A21312C';
wwv_flow_imp.g_varchar2_table(2609) := '636F6E666967757261626C653A21307D292C652E70726F746F747970652E6D616E6167653D66756E6374696F6E28652C74297B766172206E3B6966284F6F2E69732865293F6E3D653A286E3D746869732E6E657874496428292C743D65292C766F696420';
wwv_flow_imp.g_varchar2_table(2610) := '30213D3D746869732E5F616E6E6F746174696F6E735B6E5D297468726F77206E6577204572726F722822496420222B6E2B2220697320616C726561647920696E207573652E22293B696628766F696420303D3D3D74297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(2611) := '7228224E6F20616E6E6F746174696F6E2070726F766964656420666F7220696420222B6E293B72657475726E20746869732E5F616E6E6F746174696F6E735B6E5D3D742C746869732E5F73697A652B2B2C6E7D2C652E70726F746F747970652E6E657874';
wwv_flow_imp.g_varchar2_table(2612) := '49643D66756E6374696F6E28297B72657475726E20746869732E5F636F756E7465722B2B2C746869732E5F636F756E7465722E746F537472696E6728297D2C657D28293B2166756E6374696F6E28297B66756E6374696F6E20652865297B76617220743D';
wwv_flow_imp.g_varchar2_table(2613) := '746869733B746869732E5F74657874456469744368616E6765733D4F626A6563742E637265617465286E756C6C292C766F69642030213D3D653F28746869732E5F776F726B7370616365456469743D652C652E646F63756D656E744368616E6765733F28';
wwv_flow_imp.g_varchar2_table(2614) := '746869732E5F6368616E6765416E6E6F746174696F6E733D6E657720246128652E6368616E6765416E6E6F746174696F6E73292C652E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C28';
wwv_flow_imp.g_varchar2_table(2615) := '292C652E646F63756D656E744368616E6765732E666F7245616368282866756E6374696F6E2865297B696628716F2E6973286529297B766172206E3D6E657720476128652E65646974732C742E5F6368616E6765416E6E6F746174696F6E73293B742E5F';
wwv_flow_imp.g_varchar2_table(2616) := '74657874456469744368616E6765735B652E74657874446F63756D656E742E7572695D3D6E7D7D2929293A652E6368616E67657326264F626A6563742E6B65797328652E6368616E676573292E666F7245616368282866756E6374696F6E286E297B7661';
wwv_flow_imp.g_varchar2_table(2617) := '7220693D6E657720476128652E6368616E6765735B6E5D293B742E5F74657874456469744368616E6765735B6E5D3D697D2929293A746869732E5F776F726B7370616365456469743D7B7D7D4F626A6563742E646566696E6550726F706572747928652E';
wwv_flow_imp.g_varchar2_table(2618) := '70726F746F747970652C2265646974222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E696E6974446F63756D656E744368616E67657328292C766F69642030213D3D746869732E5F6368616E6765416E6E6F746174696F6E7326';
wwv_flow_imp.g_varchar2_table(2619) := '2628303D3D3D746869732E5F6368616E6765416E6E6F746174696F6E732E73697A653F746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D766F696420303A746869732E5F776F726B7370616365456469742E';
wwv_flow_imp.g_varchar2_table(2620) := '6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829292C746869732E5F776F726B7370616365456469747D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D';
wwv_flow_imp.g_varchar2_table(2621) := '292C652E70726F746F747970652E67657454657874456469744368616E67653D66756E6374696F6E2865297B69662865612E6973286529297B696628746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D74686973';
wwv_flow_imp.g_varchar2_table(2622) := '2E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368616E67';
wwv_flow_imp.g_varchar2_table(2623) := '65732E22293B76617220743D7B7572693A652E7572692C76657273696F6E3A652E76657273696F6E7D3B6966282128693D746869732E5F74657874456469744368616E6765735B742E7572695D29297B766172206E3D7B74657874446F63756D656E743A';
wwv_flow_imp.g_varchar2_table(2624) := '742C65646974733A723D5B5D7D3B746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E70757368286E292C693D6E657720476128722C746869732E5F6368616E6765416E6E6F746174696F6E73292C746869732E5F';
wwv_flow_imp.g_varchar2_table(2625) := '74657874456469744368616E6765735B742E7572695D3D697D72657475726E20697D696628746869732E696E69744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573297468726F77206E';
wwv_flow_imp.g_varchar2_table(2626) := '6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F72206E6F726D616C20746578742065646974206368616E6765732E22293B76617220693B6966282128693D746869732E5F746578744564';
wwv_flow_imp.g_varchar2_table(2627) := '69744368616E6765735B655D29297B76617220723D5B5D3B746869732E5F776F726B7370616365456469742E6368616E6765735B655D3D722C693D6E65772047612872292C746869732E5F74657874456469744368616E6765735B655D3D697D72657475';
wwv_flow_imp.g_varchar2_table(2628) := '726E20697D2C652E70726F746F747970652E696E6974446F63756D656E744368616E6765733D66756E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F696420';
wwv_flow_imp.g_varchar2_table(2629) := '303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869732E5F6368616E6765416E6E6F746174696F6E733D6E65772024612C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573';
wwv_flow_imp.g_varchar2_table(2630) := '3D5B5D2C746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829297D2C652E70726F746F747970652E696E69744368616E6765733D6675';
wwv_flow_imp.g_varchar2_table(2631) := '6E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869732E5F';
wwv_flow_imp.g_varchar2_table(2632) := '776F726B7370616365456469742E6368616E6765733D4F626A6563742E637265617465286E756C6C29297D2C652E70726F746F747970652E63726561746546696C653D66756E6374696F6E28652C742C6E297B696628746869732E696E6974446F63756D';
wwv_flow_imp.g_varchar2_table(2633) := '656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E';
wwv_flow_imp.g_varchar2_table(2634) := '6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220692C722C6F3B696628486F2E69732874297C7C4F6F2E69732874293F693D743A6E3D742C766F696420303D3D3D693F723D426F2E63726561746528652C6E293A';
wwv_flow_imp.g_varchar2_table(2635) := '286F3D4F6F2E69732869293F693A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652869292C723D426F2E63726561746528652C6E2C6F29292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E';
wwv_flow_imp.g_varchar2_table(2636) := '6765732E707573682872292C766F69642030213D3D6F2972657475726E206F7D2C652E70726F746F747970652E72656E616D6546696C653D66756E6374696F6E28652C742C6E2C69297B696628746869732E696E6974446F63756D656E744368616E6765';
wwv_flow_imp.g_varchar2_table(2637) := '7328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E666967757265642066';
wwv_flow_imp.g_varchar2_table(2638) := '6F7220646F63756D656E74206368616E6765732E22293B76617220722C6F2C613B696628486F2E6973286E297C7C4F6F2E6973286E293F723D6E3A693D6E2C766F696420303D3D3D723F6F3D4B6F2E63726561746528652C742C69293A28613D4F6F2E69';
wwv_flow_imp.g_varchar2_table(2639) := '732872293F723A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C6F3D4B6F2E63726561746528652C742C692C6129292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E70';
wwv_flow_imp.g_varchar2_table(2640) := '757368286F292C766F69642030213D3D612972657475726E20617D2C652E70726F746F747970652E64656C65746546696C653D66756E6374696F6E28652C742C6E297B696628746869732E696E6974446F63756D656E744368616E67657328292C766F69';
wwv_flow_imp.g_varchar2_table(2641) := '6420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F7220646F6375';
wwv_flow_imp.g_varchar2_table(2642) := '6D656E74206368616E6765732E22293B76617220692C722C6F3B696628486F2E69732874297C7C4F6F2E69732874293F693D743A6E3D742C766F696420303D3D3D693F723D476F2E63726561746528652C6E293A286F3D4F6F2E69732869293F693A7468';
wwv_flow_imp.g_varchar2_table(2643) := '69732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652869292C723D476F2E63726561746528652C6E2C6F29292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E707573682872292C766F6964';
wwv_flow_imp.g_varchar2_table(2644) := '2030213D3D6F2972657475726E206F7D7D28292C28596F3D4A6F7C7C284A6F3D7B7D29292E6372656174653D66756E6374696F6E2865297B72657475726E7B7572693A657D7D2C596F2E69733D66756E6374696F6E2865297B76617220743D653B726574';
wwv_flow_imp.g_varchar2_table(2645) := '75726E2058612E646566696E6564287429262658612E737472696E6728742E757269297D2C285A6F3D516F7C7C28516F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C76657273696F6E3A747D7D2C';
wwv_flow_imp.g_varchar2_table(2646) := '5A6F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E6564287429262658612E737472696E6728742E75726929262658612E696E746567657228742E76657273696F6E297D2C2874613D65617C7C286561';
wwv_flow_imp.g_varchar2_table(2647) := '3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C76657273696F6E3A747D7D2C74612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E65642874292626';
wwv_flow_imp.g_varchar2_table(2648) := '58612E737472696E6728742E757269292626286E756C6C3D3D3D742E76657273696F6E7C7C58612E696E746567657228742E76657273696F6E29297D2C2869613D6E617C7C286E613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(2649) := '69297B72657475726E7B7572693A652C6C616E677561676549643A742C76657273696F6E3A6E2C746578743A697D7D2C69612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E6564287429262658612E73';
wwv_flow_imp.g_varchar2_table(2650) := '7472696E6728742E75726929262658612E737472696E6728742E6C616E6775616765496429262658612E696E746567657228742E76657273696F6E29262658612E737472696E6728742E74657874297D2C286F613D72617C7C2872613D7B7D29292E506C';
wwv_flow_imp.g_varchar2_table(2651) := '61696E546578743D22706C61696E74657874222C6F612E4D61726B646F776E3D226D61726B646F776E222C66756E6374696F6E2865297B652E69733D66756E6374696F6E2874297B766172206E3D743B72657475726E206E3D3D3D652E506C61696E5465';
wwv_flow_imp.g_varchar2_table(2652) := '78747C7C6E3D3D3D652E4D61726B646F776E7D7D2872617C7C2872613D7B7D29292C2861617C7C2861613D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E6F626A6563744C69746572616C286529262672';
wwv_flow_imp.g_varchar2_table(2653) := '612E697328742E6B696E6429262658612E737472696E6728742E76616C7565297D2C286C613D73617C7C2873613D7B7D29292E546578743D312C6C612E4D6574686F643D322C6C612E46756E6374696F6E3D332C6C612E436F6E7374727563746F723D34';
wwv_flow_imp.g_varchar2_table(2654) := '2C6C612E4669656C643D352C6C612E5661726961626C653D362C6C612E436C6173733D372C6C612E496E746572666163653D382C6C612E4D6F64756C653D392C6C612E50726F70657274793D31302C6C612E556E69743D31312C6C612E56616C75653D31';
wwv_flow_imp.g_varchar2_table(2655) := '322C6C612E456E756D3D31332C6C612E4B6579776F72643D31342C6C612E536E69707065743D31352C6C612E436F6C6F723D31362C6C612E46696C653D31372C6C612E5265666572656E63653D31382C6C612E466F6C6465723D31392C6C612E456E756D';
wwv_flow_imp.g_varchar2_table(2656) := '4D656D6265723D32302C6C612E436F6E7374616E743D32312C6C612E5374727563743D32322C6C612E4576656E743D32332C6C612E4F70657261746F723D32342C6C612E54797065506172616D657465723D32352C2863613D68617C7C2868613D7B7D29';
wwv_flow_imp.g_varchar2_table(2657) := '292E506C61696E546578743D312C63612E536E69707065743D322C2864617C7C2864613D7B7D29292E446570726563617465643D312C286D613D75617C7C2875613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E';
wwv_flow_imp.g_varchar2_table(2658) := '7B6E6577546578743A652C696E736572743A742C7265706C6163653A6E7D7D2C6D612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262658612E737472696E6728742E6E657754657874292626616F2E697328742E696E';
wwv_flow_imp.g_varchar2_table(2659) := '73657274292626616F2E697328742E7265706C616365297D2C2866613D70617C7C2870613D7B7D29292E617349733D312C66612E61646A757374496E64656E746174696F6E3D322C2867617C7C2867613D7B7D29292E6372656174653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(2660) := '6E2865297B72657475726E7B6C6162656C3A657D7D2C2862617C7C2862613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B6974656D733A657C7C5B5D2C6973496E636F6D706C6574653A2121747D7D2C2876613D5F';
wwv_flow_imp.g_varchar2_table(2661) := '617C7C285F613D7B7D29292E66726F6D506C61696E546578743D66756E6374696F6E2865297B72657475726E20652E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D2E215D2F672C225C5C242622297D2C76612E69733D66756E637469';
wwv_flow_imp.g_varchar2_table(2662) := '6F6E2865297B76617220743D653B72657475726E2058612E737472696E672874297C7C58612E6F626A6563744C69746572616C287429262658612E737472696E6728742E6C616E677561676529262658612E737472696E6728742E76616C7565297D2C28';
wwv_flow_imp.g_varchar2_table(2663) := '77617C7C2877613D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E212174262658612E6F626A6563744C69746572616C28742926262861612E697328742E636F6E74656E7473297C7C5F612E697328742E636F6E74';
wwv_flow_imp.g_varchar2_table(2664) := '656E7473297C7C58612E7479706564417272617928742E636F6E74656E74732C5F612E69732929262628766F696420303D3D3D652E72616E67657C7C616F2E697328652E72616E676529297D2C2879617C7C2879613D7B7D29292E6372656174653D6675';
wwv_flow_imp.g_varchar2_table(2665) := '6E6374696F6E28652C74297B72657475726E20743F7B6C6162656C3A652C646F63756D656E746174696F6E3A747D3A7B6C6162656C3A657D7D2C2854617C7C2854613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B666F7228766172';
wwv_flow_imp.g_varchar2_table(2666) := '206E3D5B5D2C693D323B693C617267756D656E74732E6C656E6774683B692B2B296E5B692D325D3D617267756D656E74735B695D3B76617220723D7B6C6162656C3A657D3B72657475726E2058612E646566696E6564287429262628722E646F63756D65';
wwv_flow_imp.g_varchar2_table(2667) := '6E746174696F6E3D74292C58612E646566696E6564286E293F722E706172616D65746572733D6E3A722E706172616D65746572733D5B5D2C727D2C2853613D6B617C7C286B613D7B7D29292E546578743D312C53612E526561643D322C53612E57726974';
wwv_flow_imp.g_varchar2_table(2668) := '653D332C2878617C7C2878613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475726E2058612E6E756D6265722874292626286E2E6B696E643D74292C6E7D2C2843613D4C617C7C284C';
wwv_flow_imp.g_varchar2_table(2669) := '613D7B7D29292E46696C653D312C43612E4D6F64756C653D322C43612E4E616D6573706163653D332C43612E5061636B6167653D342C43612E436C6173733D352C43612E4D6574686F643D362C43612E50726F70657274793D372C43612E4669656C643D';
wwv_flow_imp.g_varchar2_table(2670) := '382C43612E436F6E7374727563746F723D392C43612E456E756D3D31302C43612E496E746572666163653D31312C43612E46756E6374696F6E3D31322C43612E5661726961626C653D31332C43612E436F6E7374616E743D31342C43612E537472696E67';
wwv_flow_imp.g_varchar2_table(2671) := '3D31352C43612E4E756D6265723D31362C43612E426F6F6C65616E3D31372C43612E41727261793D31382C43612E4F626A6563743D31392C43612E4B65793D32302C43612E4E756C6C3D32312C43612E456E756D4D656D6265723D32322C43612E537472';
wwv_flow_imp.g_varchar2_table(2672) := '7563743D32332C43612E4576656E743D32342C43612E4F70657261746F723D32352C43612E54797065506172616D657465723D32362C2845617C7C2845613D7B7D29292E446570726563617465643D312C2841617C7C2841613D7B7D29292E6372656174';
wwv_flow_imp.g_varchar2_table(2673) := '653D66756E6374696F6E28652C742C6E2C692C72297B766172206F3D7B6E616D653A652C6B696E643A742C6C6F636174696F6E3A7B7572693A692C72616E67653A6E7D7D3B72657475726E20722626286F2E636F6E7461696E65724E616D653D72292C6F';
wwv_flow_imp.g_varchar2_table(2674) := '7D2C284D613D52617C7C2852613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C692C722C6F297B76617220613D7B6E616D653A652C64657461696C3A742C6B696E643A6E2C72616E67653A692C73656C656374696F6E52616E6765';
wwv_flow_imp.g_varchar2_table(2675) := '3A727D3B72657475726E20766F69642030213D3D6F262628612E6368696C6472656E3D6F292C617D2C4D612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262658612E737472696E6728742E6E616D6529262658612E6E';
wwv_flow_imp.g_varchar2_table(2676) := '756D62657228742E6B696E64292626616F2E697328742E72616E6765292626616F2E697328742E73656C656374696F6E52616E676529262628766F696420303D3D3D742E64657461696C7C7C58612E737472696E6728742E64657461696C292926262876';
wwv_flow_imp.g_varchar2_table(2677) := '6F696420303D3D3D742E646570726563617465647C7C58612E626F6F6C65616E28742E646570726563617465642929262628766F696420303D3D3D742E6368696C6472656E7C7C41727261792E6973417272617928742E6368696C6472656E2929262628';
wwv_flow_imp.g_varchar2_table(2678) := '766F696420303D3D3D742E746167737C7C41727261792E6973417272617928742E7461677329297D2C2849613D4E617C7C284E613D7B7D29292E456D7074793D22222C49612E517569636B4669783D22717569636B666978222C49612E5265666163746F';
wwv_flow_imp.g_varchar2_table(2679) := '723D227265666163746F72222C49612E5265666163746F72457874726163743D227265666163746F722E65787472616374222C49612E5265666163746F72496E6C696E653D227265666163746F722E696E6C696E65222C49612E5265666163746F725265';
wwv_flow_imp.g_varchar2_table(2680) := '77726974653D227265666163746F722E72657772697465222C49612E536F757263653D22736F75726365222C49612E536F757263654F7267616E697A65496D706F7274733D22736F757263652E6F7267616E697A65496D706F727473222C49612E536F75';
wwv_flow_imp.g_varchar2_table(2681) := '726365466978416C6C3D22736F757263652E666978416C6C222C2855613D7A617C7C287A613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B646961676E6F73746963733A657D3B72657475726E206E756C6C213D74';
wwv_flow_imp.g_varchar2_table(2682) := '2626286E2E6F6E6C793D74292C6E7D2C55612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E6564287429262658612E7479706564417272617928742E646961676E6F73746963732C526F2E6973292626';
wwv_flow_imp.g_varchar2_table(2683) := '28766F696420303D3D3D742E6F6E6C797C7C58612E7479706564417272617928742E6F6E6C792C58612E737472696E6729297D2C2844613D48617C7C2848613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220693D7B74';
wwv_flow_imp.g_varchar2_table(2684) := '69746C653A657D2C723D21303B72657475726E22737472696E67223D3D747970656F6620743F28723D21312C692E6B696E643D74293A4E6F2E69732874293F692E636F6D6D616E643D743A692E656469743D742C722626766F69642030213D3D6E262628';
wwv_flow_imp.g_varchar2_table(2685) := '692E6B696E643D6E292C697D2C44612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262658612E737472696E6728742E7469746C6529262628766F696420303D3D3D742E646961676E6F73746963737C7C58612E747970';
wwv_flow_imp.g_varchar2_table(2686) := '6564417272617928742E646961676E6F73746963732C526F2E69732929262628766F696420303D3D3D742E6B696E647C7C58612E737472696E6728742E6B696E642929262628766F69642030213D3D742E656469747C7C766F69642030213D3D742E636F';
wwv_flow_imp.g_varchar2_table(2687) := '6D6D616E6429262628766F696420303D3D3D742E636F6D6D616E647C7C4E6F2E697328742E636F6D6D616E642929262628766F696420303D3D3D742E69735072656665727265647C7C58612E626F6F6C65616E28742E6973507265666572726564292926';
wwv_flow_imp.g_varchar2_table(2688) := '2628766F696420303D3D3D742E656469747C7C586F2E697328742E6564697429297D2C2857613D4F617C7C284F613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475726E2058612E64';
wwv_flow_imp.g_varchar2_table(2689) := '6566696E65642874292626286E2E646174613D74292C6E7D2C57612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E65642874292626616F2E697328742E72616E67652926262858612E756E646566696E';
wwv_flow_imp.g_varchar2_table(2690) := '656428742E636F6D6D616E64297C7C4E6F2E697328742E636F6D6D616E6429297D2C2871613D50617C7C2850613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B74616253697A653A652C696E736572745370616365';
wwv_flow_imp.g_varchar2_table(2691) := '733A747D7D2C71612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2058612E646566696E6564287429262658612E75696E746567657228742E74616253697A6529262658612E626F6F6C65616E28742E696E73657274537061';
wwv_flow_imp.g_varchar2_table(2692) := '636573297D2C2842613D46617C7C2846613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A652C7461726765743A742C646174613A6E7D7D2C42612E69733D66756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(2693) := '20743D653B72657475726E2058612E646566696E65642874292626616F2E697328742E72616E67652926262858612E756E646566696E656428742E746172676574297C7C58612E737472696E6728742E74617267657429297D2C284B613D56617C7C2856';
wwv_flow_imp.g_varchar2_table(2694) := '613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C706172656E743A747D7D2C4B612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20766F69642030213D3D74262661';
wwv_flow_imp.g_varchar2_table(2695) := '6F2E697328742E72616E676529262628766F696420303D3D3D742E706172656E747C7C4B612E697328742E706172656E7429297D2C66756E6374696F6E2865297B66756E6374696F6E207428652C6E297B696628652E6C656E6774683C3D312972657475';
wwv_flow_imp.g_varchar2_table(2696) := '726E20653B76617220693D652E6C656E6774682F327C302C723D652E736C69636528302C69292C6F3D652E736C6963652869293B7428722C6E292C74286F2C6E293B666F722876617220613D302C733D302C6C3D303B613C722E6C656E6774682626733C';
wwv_flow_imp.g_varchar2_table(2697) := '6F2E6C656E6774683B297B76617220683D6E28725B615D2C6F5B735D293B655B6C2B2B5D3D683C3D303F725B612B2B5D3A6F5B732B2B5D7D666F72283B613C722E6C656E6774683B29655B6C2B2B5D3D725B612B2B5D3B666F72283B733C6F2E6C656E67';
wwv_flow_imp.g_varchar2_table(2698) := '74683B29655B6C2B2B5D3D6F5B732B2B5D3B72657475726E20657D652E6372656174653D66756E6374696F6E28652C742C6E2C69297B72657475726E206E657720516128652C742C6E2C69297D2C652E69733D66756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(2699) := '3D653B72657475726E21212858612E646566696E6564287429262658612E737472696E6728742E7572692926262858612E756E646566696E656428742E6C616E67756167654964297C7C58612E737472696E6728742E6C616E6775616765496429292626';
wwv_flow_imp.g_varchar2_table(2700) := '58612E75696E746567657228742E6C696E65436F756E7429262658612E66756E6328742E6765745465787429262658612E66756E6328742E706F736974696F6E417429262658612E66756E6328742E6F6666736574417429297D2C652E6170706C794564';
wwv_flow_imp.g_varchar2_table(2701) := '6974733D66756E6374696F6E28652C6E297B666F722876617220693D652E6765745465787428292C723D74286E2C2866756E6374696F6E28652C74297B766172206E3D652E72616E67652E73746172742E6C696E652D742E72616E67652E73746172742E';
wwv_flow_imp.g_varchar2_table(2702) := '6C696E653B72657475726E20303D3D3D6E3F652E72616E67652E73746172742E6368617261637465722D742E72616E67652E73746172742E6368617261637465723A6E7D29292C6F3D692E6C656E6774682C613D722E6C656E6774682D313B613E3D303B';
wwv_flow_imp.g_varchar2_table(2703) := '612D2D297B76617220733D725B615D2C6C3D652E6F6666736574417428732E72616E67652E7374617274292C683D652E6F6666736574417428732E72616E67652E656E64293B6966282128683C3D6F29297468726F77206E6577204572726F7228224F76';
wwv_flow_imp.g_varchar2_table(2704) := '65726C617070696E67206564697422293B693D692E737562737472696E6728302C6C292B732E6E6577546578742B692E737562737472696E6728682C692E6C656E677468292C6F3D6C7D72657475726E20697D7D286A617C7C286A613D7B7D29293B7661';
wwv_flow_imp.g_varchar2_table(2705) := '722058612C4A612C59612C51613D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C69297B746869732E5F7572693D652C746869732E5F6C616E677561676549643D742C746869732E5F76657273696F6E3D6E2C746869732E5F636F';
wwv_flow_imp.g_varchar2_table(2706) := '6E74656E743D692C746869732E5F6C696E654F6666736574733D766F696420307D72657475726E204F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C22757269222C7B6765743A66756E6374696F6E28297B72657475';
wwv_flow_imp.g_varchar2_table(2707) := '726E20746869732E5F7572697D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C616E67756167654964222C7B6765743A6675';
wwv_flow_imp.g_varchar2_table(2708) := '6E6374696F6E28297B72657475726E20746869732E5F6C616E677561676549647D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C';
wwv_flow_imp.g_varchar2_table(2709) := '2276657273696F6E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F76657273696F6E7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E676574546578743D';
wwv_flow_imp.g_varchar2_table(2710) := '66756E6374696F6E2865297B69662865297B76617220743D746869732E6F6666736574417428652E7374617274292C6E3D746869732E6F6666736574417428652E656E64293B72657475726E20746869732E5F636F6E74656E742E737562737472696E67';
wwv_flow_imp.g_varchar2_table(2711) := '28742C6E297D72657475726E20746869732E5F636F6E74656E747D2C652E70726F746F747970652E7570646174653D66756E6374696F6E28652C74297B746869732E5F636F6E74656E743D652E746578742C746869732E5F76657273696F6E3D742C7468';
wwv_flow_imp.g_varchar2_table(2712) := '69732E5F6C696E654F6666736574733D766F696420307D2C652E70726F746F747970652E6765744C696E654F6666736574733D66756E6374696F6E28297B696628766F696420303D3D3D746869732E5F6C696E654F666673657473297B666F7228766172';
wwv_flow_imp.g_varchar2_table(2713) := '20653D5B5D2C743D746869732E5F636F6E74656E742C6E3D21302C693D303B693C742E6C656E6774683B692B2B297B6E262628652E707573682869292C6E3D2131293B76617220723D742E6368617241742869293B6E3D225C72223D3D3D727C7C225C6E';
wwv_flow_imp.g_varchar2_table(2714) := '223D3D3D722C225C72223D3D3D722626692B313C742E6C656E6774682626225C6E223D3D3D742E63686172417428692B31292626692B2B7D6E2626742E6C656E6774683E302626652E7075736828742E6C656E677468292C746869732E5F6C696E654F66';
wwv_flow_imp.g_varchar2_table(2715) := '66736574733D657D72657475726E20746869732E5F6C696E654F6666736574737D2C652E70726F746F747970652E706F736974696F6E41743D66756E6374696F6E2865297B653D4D6174682E6D6178284D6174682E6D696E28652C746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(2716) := '74656E742E6C656E677468292C30293B76617220743D746869732E6765744C696E654F66667365747328292C6E3D302C693D742E6C656E6774683B696628303D3D3D692972657475726E20726F2E63726561746528302C65293B666F72283B6E3C693B29';
wwv_flow_imp.g_varchar2_table(2717) := '7B76617220723D4D6174682E666C6F6F7228286E2B69292F32293B745B725D3E653F693D723A6E3D722B317D766172206F3D6E2D313B72657475726E20726F2E637265617465286F2C652D745B6F5D297D2C652E70726F746F747970652E6F6666736574';
wwv_flow_imp.g_varchar2_table(2718) := '41743D66756E6374696F6E2865297B76617220743D746869732E6765744C696E654F66667365747328293B696628652E6C696E653E3D742E6C656E6774682972657475726E20746869732E5F636F6E74656E742E6C656E6774683B696628652E6C696E65';
wwv_flow_imp.g_varchar2_table(2719) := '3C302972657475726E20303B766172206E3D745B652E6C696E655D2C693D652E6C696E652B313C742E6C656E6774683F745B652E6C696E652B315D3A746869732E5F636F6E74656E742E6C656E6774683B72657475726E204D6174682E6D6178284D6174';
wwv_flow_imp.g_varchar2_table(2720) := '682E6D696E286E2B652E6368617261637465722C69292C6E297D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C696E65436F756E74222C7B6765743A66756E6374696F6E28297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(2721) := '2E6765744C696E654F66667365747328292E6C656E6774687D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C657D28293B4A613D58617C7C2858613D7B7D292C59613D4F626A6563742E70726F746F747970652E746F';
wwv_flow_imp.g_varchar2_table(2722) := '537472696E672C4A612E646566696E65643D66756E6374696F6E2865297B72657475726E20766F69642030213D3D657D2C4A612E756E646566696E65643D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D657D2C4A612E626F6F6C';
wwv_flow_imp.g_varchar2_table(2723) := '65616E3D66756E6374696F6E2865297B72657475726E21303D3D3D657C7C21313D3D3D657D2C4A612E737472696E673D66756E6374696F6E2865297B72657475726E225B6F626A65637420537472696E675D223D3D3D59612E63616C6C2865297D2C4A61';
wwv_flow_imp.g_varchar2_table(2724) := '2E6E756D6265723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D59612E63616C6C2865297D2C4A612E6E756D62657252616E67653D66756E6374696F6E28652C742C6E297B72657475726E225B6F626A';
wwv_flow_imp.g_varchar2_table(2725) := '656374204E756D6265725D223D3D3D59612E63616C6C2865292626743C3D652626653C3D6E7D2C4A612E696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D59612E63616C6C2865292626';
wwv_flow_imp.g_varchar2_table(2726) := '2D323134373438333634383C3D652626653C3D323134373438333634377D2C4A612E75696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D59612E63616C6C2865292626303C3D65262665';
wwv_flow_imp.g_varchar2_table(2727) := '3C3D323134373438333634377D2C4A612E66756E633D66756E6374696F6E2865297B72657475726E225B6F626A6563742046756E6374696F6E5D223D3D3D59612E63616C6C2865297D2C4A612E6F626A6563744C69746572616C3D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(2728) := '65297B72657475726E206E756C6C213D3D652626226F626A656374223D3D747970656F6620657D2C4A612E747970656441727261793D66756E6374696F6E28652C74297B72657475726E2041727261792E697341727261792865292626652E6576657279';
wwv_flow_imp.g_varchar2_table(2729) := '2874297D3B766172205A612C65732C74732C6E732C69732C72732C6F732C61732C73732C6C733D636C61737320657B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F7572693D652C746869732E5F6C616E677561676549643D742C74';
wwv_flow_imp.g_varchar2_table(2730) := '6869732E5F76657273696F6E3D6E2C746869732E5F636F6E74656E743D692C746869732E5F6C696E654F6666736574733D766F696420307D6765742075726928297B72657475726E20746869732E5F7572697D676574206C616E6775616765496428297B';
wwv_flow_imp.g_varchar2_table(2731) := '72657475726E20746869732E5F6C616E677561676549647D6765742076657273696F6E28297B72657475726E20746869732E5F76657273696F6E7D676574546578742865297B69662865297B636F6E737420743D746869732E6F6666736574417428652E';
wwv_flow_imp.g_varchar2_table(2732) := '7374617274292C6E3D746869732E6F6666736574417428652E656E64293B72657475726E20746869732E5F636F6E74656E742E737562737472696E6728742C6E297D72657475726E20746869732E5F636F6E74656E747D75706461746528742C6E297B66';
wwv_flow_imp.g_varchar2_table(2733) := '6F72286C6574206E206F66207429696628652E6973496E6372656D656E74616C286E29297B636F6E737420653D6473286E2E72616E6765292C743D746869732E6F6666736574417428652E7374617274292C693D746869732E6F6666736574417428652E';
wwv_flow_imp.g_varchar2_table(2734) := '656E64293B746869732E5F636F6E74656E743D746869732E5F636F6E74656E742E737562737472696E6728302C74292B6E2E746578742B746869732E5F636F6E74656E742E737562737472696E6728692C746869732E5F636F6E74656E742E6C656E6774';
wwv_flow_imp.g_varchar2_table(2735) := '68293B636F6E737420723D4D6174682E6D617828652E73746172742E6C696E652C30292C6F3D4D6174682E6D617828652E656E642E6C696E652C30293B6C657420613D746869732E5F6C696E654F6666736574733B636F6E737420733D6373286E2E7465';
wwv_flow_imp.g_varchar2_table(2736) := '78742C21312C74293B6966286F2D723D3D3D732E6C656E67746829666F72286C657420653D302C743D732E6C656E6774683B653C743B652B2B29615B652B722B315D3D735B655D3B656C736520732E6C656E6774683C3165343F612E73706C6963652872';
wwv_flow_imp.g_varchar2_table(2737) := '2B312C6F2D722C2E2E2E73293A746869732E5F6C696E654F6666736574733D613D612E736C69636528302C722B31292E636F6E63617428732C612E736C696365286F2B3129293B636F6E7374206C3D6E2E746578742E6C656E6774682D28692D74293B69';
wwv_flow_imp.g_varchar2_table(2738) := '662830213D3D6C29666F72286C657420653D722B312B732E6C656E6774682C743D612E6C656E6774683B653C743B652B2B29615B655D3D615B655D2B6C7D656C73657B69662821652E697346756C6C286E29297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(2739) := '556E6B6E6F776E206368616E6765206576656E7420726563656976656422293B746869732E5F636F6E74656E743D6E2E746578742C746869732E5F6C696E654F6666736574733D766F696420307D746869732E5F76657273696F6E3D6E7D6765744C696E';
wwv_flow_imp.g_varchar2_table(2740) := '654F66667365747328297B72657475726E20766F696420303D3D3D746869732E5F6C696E654F666673657473262628746869732E5F6C696E654F6666736574733D637328746869732E5F636F6E74656E742C213029292C746869732E5F6C696E654F6666';
wwv_flow_imp.g_varchar2_table(2741) := '736574737D706F736974696F6E41742865297B653D4D6174682E6D6178284D6174682E6D696E28652C746869732E5F636F6E74656E742E6C656E677468292C30293B6C657420743D746869732E6765744C696E654F66667365747328292C6E3D302C693D';
wwv_flow_imp.g_varchar2_table(2742) := '742E6C656E6774683B696628303D3D3D692972657475726E7B6C696E653A302C6368617261637465723A657D3B666F72283B6E3C693B297B6C657420723D4D6174682E666C6F6F7228286E2B69292F32293B745B725D3E653F693D723A6E3D722B317D6C';
wwv_flow_imp.g_varchar2_table(2743) := '657420723D6E2D313B72657475726E7B6C696E653A722C6368617261637465723A652D745B725D7D7D6F666673657441742865297B6C657420743D746869732E6765744C696E654F66667365747328293B696628652E6C696E653E3D742E6C656E677468';
wwv_flow_imp.g_varchar2_table(2744) := '2972657475726E20746869732E5F636F6E74656E742E6C656E6774683B696628652E6C696E653C302972657475726E20303B6C6574206E3D745B652E6C696E655D2C693D652E6C696E652B313C742E6C656E6774683F745B652E6C696E652B315D3A7468';
wwv_flow_imp.g_varchar2_table(2745) := '69732E5F636F6E74656E742E6C656E6774683B72657475726E204D6174682E6D6178284D6174682E6D696E286E2B652E6368617261637465722C69292C6E297D676574206C696E65436F756E7428297B72657475726E20746869732E6765744C696E654F';
wwv_flow_imp.g_varchar2_table(2746) := '66667365747328292E6C656E6774687D737461746963206973496E6372656D656E74616C2865297B6C657420743D653B72657475726E206E756C6C213D74262622737472696E67223D3D747970656F6620742E746578742626766F69642030213D3D742E';
wwv_flow_imp.g_varchar2_table(2747) := '72616E6765262628766F696420303D3D3D742E72616E67654C656E6774687C7C226E756D626572223D3D747970656F6620742E72616E67654C656E677468297D73746174696320697346756C6C2865297B6C657420743D653B72657475726E206E756C6C';
wwv_flow_imp.g_varchar2_table(2748) := '213D74262622737472696E67223D3D747970656F6620742E746578742626766F696420303D3D3D742E72616E67652626766F696420303D3D3D742E72616E67654C656E6774687D7D3B66756E6374696F6E20687328652C74297B696628652E6C656E6774';
wwv_flow_imp.g_varchar2_table(2749) := '683C3D312972657475726E20653B636F6E7374206E3D652E6C656E6774682F327C302C693D652E736C69636528302C6E292C723D652E736C696365286E293B687328692C74292C687328722C74293B6C6574206F3D302C613D302C733D303B666F72283B';
wwv_flow_imp.g_varchar2_table(2750) := '6F3C692E6C656E6774682626613C722E6C656E6774683B297B6C6574206E3D7428695B6F5D2C725B615D293B655B732B2B5D3D6E3C3D303F695B6F2B2B5D3A725B612B2B5D7D666F72283B6F3C692E6C656E6774683B29655B732B2B5D3D695B6F2B2B5D';
wwv_flow_imp.g_varchar2_table(2751) := '3B666F72283B613C722E6C656E6774683B29655B732B2B5D3D725B612B2B5D3B72657475726E20657D66756E6374696F6E20637328652C742C6E3D30297B636F6E737420693D743F5B6E5D3A5B5D3B666F72286C657420743D303B743C652E6C656E6774';
wwv_flow_imp.g_varchar2_table(2752) := '683B742B2B297B6C657420723D652E63686172436F646541742874293B3133213D3D7226263130213D3D727C7C2831333D3D3D722626742B313C652E6C656E677468262631303D3D3D652E63686172436F6465417428742B31292626742B2B2C692E7075';
wwv_flow_imp.g_varchar2_table(2753) := '7368286E2B742B3129297D72657475726E20697D66756E6374696F6E2064732865297B636F6E737420743D652E73746172742C6E3D652E656E643B72657475726E20742E6C696E653E6E2E6C696E657C7C742E6C696E653D3D3D6E2E6C696E652626742E';
wwv_flow_imp.g_varchar2_table(2754) := '6368617261637465723E6E2E6368617261637465723F7B73746172743A6E2C656E643A747D3A657D66756E6374696F6E2075732865297B636F6E737420743D647328652E72616E6765293B72657475726E2074213D3D652E72616E67653F7B6E65775465';
wwv_flow_imp.g_varchar2_table(2755) := '78743A652E6E6577546578742C72616E67653A747D3A657D2865733D5A617C7C285A613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C69297B72657475726E206E6577206C7328652C742C6E2C69297D2C65732E7570646174653D';
wwv_flow_imp.g_varchar2_table(2756) := '66756E6374696F6E28652C742C6E297B6966286520696E7374616E63656F66206C732972657475726E20652E75706461746528742C6E292C653B7468726F77206E6577204572726F72282254657874446F63756D656E742E7570646174653A20646F6375';
wwv_flow_imp.g_varchar2_table(2757) := '6D656E74206D75737420626520637265617465642062792054657874446F63756D656E742E63726561746522297D2C65732E6170706C7945646974733D66756E6374696F6E28652C74297B6C6574206E3D652E6765745465787428292C693D687328742E';
wwv_flow_imp.g_varchar2_table(2758) := '6D6170287573292C2828652C74293D3E7B6C6574206E3D652E72616E67652E73746172742E6C696E652D742E72616E67652E73746172742E6C696E653B72657475726E20303D3D3D6E3F652E72616E67652E73746172742E6368617261637465722D742E';
wwv_flow_imp.g_varchar2_table(2759) := '72616E67652E73746172742E6368617261637465723A6E7D29292C723D303B636F6E7374206F3D5B5D3B666F7228636F6E73742074206F662069297B6C657420693D652E6F6666736574417428742E72616E67652E7374617274293B696628693C722974';
wwv_flow_imp.g_varchar2_table(2760) := '68726F77206E6577204572726F7228224F7665726C617070696E67206564697422293B693E7226266F2E70757368286E2E737562737472696E6728722C6929292C742E6E6577546578742E6C656E67746826266F2E7075736828742E6E65775465787429';
wwv_flow_imp.g_varchar2_table(2761) := '2C723D652E6F6666736574417428742E72616E67652E656E64297D72657475726E206F2E70757368286E2E737562737472287229292C6F2E6A6F696E282222297D2C286E733D74737C7C2874733D7B7D29295B6E732E5374617274436F6D6D656E745461';
wwv_flow_imp.g_varchar2_table(2762) := '673D305D3D225374617274436F6D6D656E74546167222C6E735B6E732E436F6D6D656E743D315D3D22436F6D6D656E74222C6E735B6E732E456E64436F6D6D656E745461673D325D3D22456E64436F6D6D656E74546167222C6E735B6E732E5374617274';
wwv_flow_imp.g_varchar2_table(2763) := '5461674F70656E3D335D3D2253746172745461674F70656E222C6E735B6E732E5374617274546167436C6F73653D345D3D225374617274546167436C6F7365222C6E735B6E732E537461727454616753656C66436C6F73653D355D3D2253746172745461';
wwv_flow_imp.g_varchar2_table(2764) := '6753656C66436C6F7365222C6E735B6E732E53746172745461673D365D3D225374617274546167222C6E735B6E732E456E645461674F70656E3D375D3D22456E645461674F70656E222C6E735B6E732E456E64546167436C6F73653D385D3D22456E6454';
wwv_flow_imp.g_varchar2_table(2765) := '6167436C6F7365222C6E735B6E732E456E645461673D395D3D22456E64546167222C6E735B6E732E44656C696D6974657241737369676E3D31305D3D2244656C696D6974657241737369676E222C6E735B6E732E4174747269627574654E616D653D3131';
wwv_flow_imp.g_varchar2_table(2766) := '5D3D224174747269627574654E616D65222C6E735B6E732E41747472696275746556616C75653D31325D3D2241747472696275746556616C7565222C6E735B6E732E5374617274446F63747970655461673D31335D3D225374617274446F637479706554';
wwv_flow_imp.g_varchar2_table(2767) := '6167222C6E735B6E732E446F63747970653D31345D3D22446F6374797065222C6E735B6E732E456E64446F63747970655461673D31355D3D22456E64446F6374797065546167222C6E735B6E732E436F6E74656E743D31365D3D22436F6E74656E74222C';
wwv_flow_imp.g_varchar2_table(2768) := '6E735B6E732E576869746573706163653D31375D3D2257686974657370616365222C6E735B6E732E556E6B6E6F776E3D31385D3D22556E6B6E6F776E222C6E735B6E732E5363726970743D31395D3D22536372697074222C6E735B6E732E5374796C6573';
wwv_flow_imp.g_varchar2_table(2769) := '3D32305D3D225374796C6573222C6E735B6E732E454F533D32315D3D22454F53222C2872733D69737C7C2869733D7B7D29295B72732E57697468696E436F6E74656E743D305D3D2257697468696E436F6E74656E74222C72735B72732E41667465724F70';
wwv_flow_imp.g_varchar2_table(2770) := '656E696E6753746172745461673D315D3D2241667465724F70656E696E675374617274546167222C72735B72732E41667465724F70656E696E67456E645461673D325D3D2241667465724F70656E696E67456E64546167222C72735B72732E5769746869';
wwv_flow_imp.g_varchar2_table(2771) := '6E446F63747970653D335D3D2257697468696E446F6374797065222C72735B72732E57697468696E5461673D345D3D2257697468696E546167222C72735B72732E57697468696E456E645461673D355D3D2257697468696E456E64546167222C72735B72';
wwv_flow_imp.g_varchar2_table(2772) := '732E57697468696E436F6D6D656E743D365D3D2257697468696E436F6D6D656E74222C72735B72732E57697468696E536372697074436F6E74656E743D375D3D2257697468696E536372697074436F6E74656E74222C72735B72732E57697468696E5374';
wwv_flow_imp.g_varchar2_table(2773) := '796C65436F6E74656E743D385D3D2257697468696E5374796C65436F6E74656E74222C72735B72732E41667465724174747269627574654E616D653D395D3D2241667465724174747269627574654E616D65222C72735B72732E4265666F726541747472';
wwv_flow_imp.g_varchar2_table(2774) := '696275746556616C75653D31305D3D224265666F726541747472696275746556616C7565222C286F737C7C286F733D7B7D29292E4C41544553543D7B74657874446F63756D656E743A7B636F6D706C6574696F6E3A7B636F6D706C6574696F6E4974656D';
wwv_flow_imp.g_varchar2_table(2775) := '3A7B646F63756D656E746174696F6E466F726D61743A5B72612E4D61726B646F776E2C72612E506C61696E546578745D7D7D2C686F7665723A7B636F6E74656E74466F726D61743A5B72612E4D61726B646F776E2C72612E506C61696E546578745D7D7D';
wwv_flow_imp.g_varchar2_table(2776) := '7D2C2873733D61737C7C2861733D7B7D29295B73732E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C73735B73732E46696C653D315D3D2246696C65222C73735B73732E4469726563746F72793D325D3D224469726563746F7279222C73735B7373';
wwv_flow_imp.g_varchar2_table(2777) := '2E53796D626F6C69634C696E6B3D36345D3D2253796D626F6C69634C696E6B223B766172206D733D5A7228292C70733D66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E736F757263653D652C746869732E6C656E3D652E';
wwv_flow_imp.g_varchar2_table(2778) := '6C656E6774682C746869732E706F736974696F6E3D747D72657475726E20652E70726F746F747970652E656F733D66756E6374696F6E28297B72657475726E20746869732E6C656E3C3D746869732E706F736974696F6E7D2C652E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(2779) := '2E676574536F757263653D66756E6374696F6E28297B72657475726E20746869732E736F757263657D2C652E70726F746F747970652E706F733D66756E6374696F6E28297B72657475726E20746869732E706F736974696F6E7D2C652E70726F746F7479';
wwv_flow_imp.g_varchar2_table(2780) := '70652E676F4261636B546F3D66756E6374696F6E2865297B746869732E706F736974696F6E3D657D2C652E70726F746F747970652E676F4261636B3D66756E6374696F6E2865297B746869732E706F736974696F6E2D3D657D2C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(2781) := '652E616476616E63653D66756E6374696F6E2865297B746869732E706F736974696F6E2B3D657D2C652E70726F746F747970652E676F546F456E643D66756E6374696F6E28297B746869732E706F736974696F6E3D746869732E736F757263652E6C656E';
wwv_flow_imp.g_varchar2_table(2782) := '6774687D2C652E70726F746F747970652E6E657874436861723D66756E6374696F6E28297B72657475726E20746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E2B2B297C7C307D2C652E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(2783) := '7065656B436861723D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D65262628653D30292C746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E2B65297C7C307D2C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(2784) := '652E616476616E63654966436861723D66756E6374696F6E2865297B72657475726E20653D3D3D746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E29262628746869732E706F736974696F6E2B2B2C2130297D2C';
wwv_flow_imp.g_varchar2_table(2785) := '652E70726F746F747970652E616476616E6365496643686172733D66756E6374696F6E2865297B76617220743B696628746869732E706F736974696F6E2B652E6C656E6774683E746869732E736F757263652E6C656E6774682972657475726E21313B66';
wwv_flow_imp.g_varchar2_table(2786) := '6F7228743D303B743C652E6C656E6774683B742B2B29696628746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E2B7429213D3D655B745D2972657475726E21313B72657475726E20746869732E616476616E6365';
wwv_flow_imp.g_varchar2_table(2787) := '2874292C21307D2C652E70726F746F747970652E616476616E636549665265674578703D66756E6374696F6E2865297B76617220743D746869732E736F757263652E73756273747228746869732E706F736974696F6E292E6D617463682865293B726574';
wwv_flow_imp.g_varchar2_table(2788) := '75726E20743F28746869732E706F736974696F6E3D746869732E706F736974696F6E2B742E696E6465782B745B305D2E6C656E6774682C745B305D293A22227D2C652E70726F746F747970652E616476616E6365556E74696C5265674578703D66756E63';
wwv_flow_imp.g_varchar2_table(2789) := '74696F6E2865297B76617220743D746869732E736F757263652E73756273747228746869732E706F736974696F6E292E6D617463682865293B72657475726E20743F28746869732E706F736974696F6E3D746869732E706F736974696F6E2B742E696E64';
wwv_flow_imp.g_varchar2_table(2790) := '65782C745B305D293A28746869732E676F546F456E6428292C2222297D2C652E70726F746F747970652E616476616E6365556E74696C436861723D66756E6374696F6E2865297B666F72283B746869732E706F736974696F6E3C746869732E736F757263';
wwv_flow_imp.g_varchar2_table(2791) := '652E6C656E6774683B297B696628746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E293D3D3D652972657475726E21303B746869732E616476616E63652831297D72657475726E21317D2C652E70726F746F7479';
wwv_flow_imp.g_varchar2_table(2792) := '70652E616476616E6365556E74696C43686172733D66756E6374696F6E2865297B666F72283B746869732E706F736974696F6E2B652E6C656E6774683C3D746869732E736F757263652E6C656E6774683B297B666F722876617220743D303B743C652E6C';
wwv_flow_imp.g_varchar2_table(2793) := '656E6774682626746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E2B74293D3D3D655B745D3B742B2B293B696628743D3D3D652E6C656E6774682972657475726E21303B746869732E616476616E63652831297D';
wwv_flow_imp.g_varchar2_table(2794) := '72657475726E20746869732E676F546F456E6428292C21317D2C652E70726F746F747970652E736B6970576869746573706163653D66756E6374696F6E28297B72657475726E20746869732E616476616E63655768696C6543686172282866756E637469';
wwv_flow_imp.g_varchar2_table(2795) := '6F6E2865297B72657475726E20653D3D3D4C737C7C653D3D3D43737C7C653D3D3D6B737C7C653D3D3D78737C7C653D3D3D53737D29293E307D2C652E70726F746F747970652E616476616E63655768696C65436861723D66756E6374696F6E2865297B66';
wwv_flow_imp.g_varchar2_table(2796) := '6F722876617220743D746869732E706F736974696F6E3B746869732E706F736974696F6E3C746869732E6C656E26266528746869732E736F757263652E63686172436F6465417428746869732E706F736974696F6E29293B29746869732E706F73697469';
wwv_flow_imp.g_varchar2_table(2797) := '6F6E2B2B3B72657475726E20746869732E706F736974696F6E2D747D2C657D28292C66733D2221222E63686172436F646541742830292C67733D222D222E63686172436F646541742830292C62733D223C222E63686172436F646541742830292C5F733D';
wwv_flow_imp.g_varchar2_table(2798) := '223E222E63686172436F646541742830292C76733D222F222E63686172436F646541742830292C77733D223D222E63686172436F646541742830292C79733D2722272E63686172436F646541742830292C54733D2227222E63686172436F646541742830';
wwv_flow_imp.g_varchar2_table(2799) := '292C6B733D225C6E222E63686172436F646541742830292C53733D225C72222E63686172436F646541742830292C78733D225C66222E63686172436F646541742830292C4C733D2220222E63686172436F646541742830292C43733D225C74222E636861';
wwv_flow_imp.g_varchar2_table(2800) := '72436F646541742830292C45733D7B22746578742F782D68616E646C65626172732D74656D706C617465223A21302C22746578742F68746D6C223A21307D3B66756E6374696F6E20417328652C742C6E2C69297B766F696420303D3D3D74262628743D30';
wwv_flow_imp.g_varchar2_table(2801) := '292C766F696420303D3D3D6E2626286E3D69732E57697468696E436F6E74656E74292C766F696420303D3D3D69262628693D2131293B76617220722C6F2C612C732C6C2C683D6E657720707328652C74292C633D6E2C643D302C753D74732E556E6B6E6F';
wwv_flow_imp.g_varchar2_table(2802) := '776E3B66756E6374696F6E206D28297B72657475726E20682E616476616E63654966526567457870282F5E5B5F3A5C775D5B5F3A5C772D2E5C645D2A2F292E746F4C6F7765724361736528297D66756E6374696F6E207028652C742C6E297B7265747572';
wwv_flow_imp.g_varchar2_table(2803) := '6E20753D742C643D652C723D6E2C747D66756E6374696F6E206628297B76617220652C743D682E706F7328293B696628682E656F7328292972657475726E207028742C74732E454F53293B7377697463682863297B636173652069732E57697468696E43';
wwv_flow_imp.g_varchar2_table(2804) := '6F6D6D656E743A72657475726E20682E616476616E636549664368617273285B67732C67732C5F735D293F28633D69732E57697468696E436F6E74656E742C7028742C74732E456E64436F6D6D656E7454616729293A28682E616476616E6365556E7469';
wwv_flow_imp.g_varchar2_table(2805) := '6C4368617273285B67732C67732C5F735D292C7028742C74732E436F6D6D656E7429293B636173652069732E57697468696E446F63747970653A72657475726E20682E616476616E6365496643686172285F73293F28633D69732E57697468696E436F6E';
wwv_flow_imp.g_varchar2_table(2806) := '74656E742C7028742C74732E456E64446F637479706554616729293A28682E616476616E6365556E74696C43686172285F73292C7028742C74732E446F637479706529293B636173652069732E57697468696E436F6E74656E743A696628682E61647661';
wwv_flow_imp.g_varchar2_table(2807) := '6E636549664368617228627329297B69662821682E656F7328292626682E7065656B4368617228293D3D3D6673297B696628682E616476616E636549664368617273285B66732C67732C67735D292972657475726E20633D69732E57697468696E436F6D';
wwv_flow_imp.g_varchar2_table(2808) := '6D656E742C7028742C74732E5374617274436F6D6D656E74546167293B696628682E616476616E63654966526567457870282F5E21646F63747970652F69292972657475726E20633D69732E57697468696E446F63747970652C7028742C74732E537461';
wwv_flow_imp.g_varchar2_table(2809) := '7274446F6374797065546167297D72657475726E20682E616476616E6365496643686172287673293F28633D69732E41667465724F70656E696E67456E645461672C7028742C74732E456E645461674F70656E29293A28633D69732E41667465724F7065';
wwv_flow_imp.g_varchar2_table(2810) := '6E696E6753746172745461672C7028742C74732E53746172745461674F70656E29297D72657475726E20682E616476616E6365556E74696C43686172286273292C7028742C74732E436F6E74656E74293B636173652069732E41667465724F70656E696E';
wwv_flow_imp.g_varchar2_table(2811) := '67456E645461673A72657475726E206D28292E6C656E6774683E303F28633D69732E57697468696E456E645461672C7028742C74732E456E6454616729293A682E736B69705768697465737061636528293F7028742C74732E576869746573706163652C';
wwv_flow_imp.g_varchar2_table(2812) := '6D7328226572726F722E756E657870656374656457686974657370616365222C22546167206E616D65206D757374206469726563746C7920666F6C6C6F7720746865206F70656E20627261636B65742E2229293A28633D69732E57697468696E456E6454';
wwv_flow_imp.g_varchar2_table(2813) := '61672C682E616476616E6365556E74696C43686172285F73292C743C682E706F7328293F7028742C74732E556E6B6E6F776E2C6D7328226572726F722E656E645461674E616D654578706563746564222C22456E6420746167206E616D65206578706563';
wwv_flow_imp.g_varchar2_table(2814) := '7465642E2229293A662829293B636173652069732E57697468696E456E645461673A696628682E736B69705768697465737061636528292972657475726E207028742C74732E57686974657370616365293B696628682E616476616E6365496643686172';
wwv_flow_imp.g_varchar2_table(2815) := '285F73292972657475726E20633D69732E57697468696E436F6E74656E742C7028742C74732E456E64546167436C6F7365293B696628692626682E7065656B4368617228293D3D3D62732972657475726E20633D69732E57697468696E436F6E74656E74';
wwv_flow_imp.g_varchar2_table(2816) := '2C7028742C74732E456E64546167436C6F73652C6D7328226572726F722E636C6F73696E67427261636B65744D697373696E67222C22436C6F73696E6720627261636B6574206D697373696E672E2229293B653D6D7328226572726F722E636C6F73696E';
wwv_flow_imp.g_varchar2_table(2817) := '67427261636B65744578706563746564222C22436C6F73696E6720627261636B65742065787065637465642E22293B627265616B3B636173652069732E41667465724F70656E696E6753746172745461673A72657475726E20613D6D28292C6C3D766F69';
wwv_flow_imp.g_varchar2_table(2818) := '6420302C733D766F696420302C612E6C656E6774683E303F286F3D21312C633D69732E57697468696E5461672C7028742C74732E537461727454616729293A682E736B69705768697465737061636528293F7028742C74732E576869746573706163652C';
wwv_flow_imp.g_varchar2_table(2819) := '6D7328226572726F722E756E657870656374656457686974657370616365222C22546167206E616D65206D757374206469726563746C7920666F6C6C6F7720746865206F70656E20627261636B65742E2229293A28633D69732E57697468696E5461672C';
wwv_flow_imp.g_varchar2_table(2820) := '682E616476616E6365556E74696C43686172285F73292C743C682E706F7328293F7028742C74732E556E6B6E6F776E2C6D7328226572726F722E73746172745461674E616D654578706563746564222C22537461727420746167206E616D652065787065';
wwv_flow_imp.g_varchar2_table(2821) := '637465642E2229293A662829293B636173652069732E57697468696E5461673A72657475726E20682E736B69705768697465737061636528293F286F3D21302C7028742C74732E5768697465737061636529293A6F262628733D682E616476616E636549';
wwv_flow_imp.g_varchar2_table(2822) := '66526567457870282F5E5B5E5C7322273E3C2F3D5C7830302D5C7830465C7837465C7838302D5C7839465D2A2F292E746F4C6F776572436173652829292E6C656E6774683E303F28633D69732E41667465724174747269627574654E616D652C6F3D2131';
wwv_flow_imp.g_varchar2_table(2823) := '2C7028742C74732E4174747269627574654E616D6529293A682E616476616E636549664368617273285B76732C5F735D293F28633D69732E57697468696E436F6E74656E742C7028742C74732E537461727454616753656C66436C6F736529293A682E61';
wwv_flow_imp.g_varchar2_table(2824) := '6476616E6365496643686172285F73293F28633D22736372697074223D3D3D613F6C262645735B6C5D3F69732E57697468696E436F6E74656E743A69732E57697468696E536372697074436F6E74656E743A227374796C65223D3D3D613F69732E576974';
wwv_flow_imp.g_varchar2_table(2825) := '68696E5374796C65436F6E74656E743A69732E57697468696E436F6E74656E742C7028742C74732E5374617274546167436C6F736529293A692626682E7065656B4368617228293D3D3D62733F28633D69732E57697468696E436F6E74656E742C702874';
wwv_flow_imp.g_varchar2_table(2826) := '2C74732E5374617274546167436C6F73652C6D7328226572726F722E636C6F73696E67427261636B65744D697373696E67222C22436C6F73696E6720627261636B6574206D697373696E672E222929293A28682E616476616E63652831292C7028742C74';
wwv_flow_imp.g_varchar2_table(2827) := '732E556E6B6E6F776E2C6D7328226572726F722E756E6578706563746564436861726163746572496E546167222C22556E65787065637465642063686172616374657220696E207461672E222929293B636173652069732E416674657241747472696275';
wwv_flow_imp.g_varchar2_table(2828) := '74654E616D653A72657475726E20682E736B69705768697465737061636528293F286F3D21302C7028742C74732E5768697465737061636529293A682E616476616E6365496643686172287773293F28633D69732E4265666F7265417474726962757465';
wwv_flow_imp.g_varchar2_table(2829) := '56616C75652C7028742C74732E44656C696D6974657241737369676E29293A28633D69732E57697468696E5461672C662829293B636173652069732E4265666F726541747472696275746556616C75653A696628682E736B697057686974657370616365';
wwv_flow_imp.g_varchar2_table(2830) := '28292972657475726E207028742C74732E57686974657370616365293B766172206E3D682E616476616E63654966526567457870282F5E5B5E5C732227603D3C3E5D2B2F293B6966286E2E6C656E6774683E302972657475726E20682E7065656B436861';
wwv_flow_imp.g_varchar2_table(2831) := '7228293D3D3D5F732626682E7065656B43686172282D31293D3D3D7673262628682E676F4261636B2831292C6E3D6E2E73756273747228302C6E2E6C656E6774682D3129292C2274797065223D3D3D732626286C3D6E292C633D69732E57697468696E54';
wwv_flow_imp.g_varchar2_table(2832) := '61672C6F3D21312C7028742C74732E41747472696275746556616C7565293B76617220723D682E7065656B4368617228293B72657475726E20723D3D3D54737C7C723D3D3D79733F28682E616476616E63652831292C682E616476616E6365556E74696C';
wwv_flow_imp.g_varchar2_table(2833) := '436861722872292626682E616476616E63652831292C2274797065223D3D3D732626286C3D682E676574536F7572636528292E737562737472696E6728742B312C682E706F7328292D3129292C633D69732E57697468696E5461672C6F3D21312C702874';
wwv_flow_imp.g_varchar2_table(2834) := '2C74732E41747472696275746556616C756529293A28633D69732E57697468696E5461672C6F3D21312C662829293B636173652069732E57697468696E536372697074436F6E74656E743A666F722876617220643D313B21682E656F7328293B297B7661';
wwv_flow_imp.g_varchar2_table(2835) := '7220753D682E616476616E63654966526567457870282F3C212D2D7C2D2D3E7C3C5C2F3F7363726970745C732A5C2F3F3E3F2F69293B696628303D3D3D752E6C656E6774682972657475726E20682E676F546F456E6428292C7028742C74732E53637269';
wwv_flow_imp.g_varchar2_table(2836) := '7074293B696628225C783363212D2D223D3D3D7529313D3D3D64262628643D32293B656C736520696628222D2D5C783365223D3D3D7529643D313B656C736520696628222F22213D3D755B315D29323D3D3D64262628643D33293B656C73657B69662833';
wwv_flow_imp.g_varchar2_table(2837) := '213D3D64297B682E676F4261636B28752E6C656E677468293B627265616B7D643D327D7D72657475726E20633D69732E57697468696E436F6E74656E742C743C682E706F7328293F7028742C74732E536372697074293A6628293B636173652069732E57';
wwv_flow_imp.g_varchar2_table(2838) := '697468696E5374796C65436F6E74656E743A72657475726E20682E616476616E6365556E74696C526567457870282F3C5C2F7374796C652F69292C633D69732E57697468696E436F6E74656E742C743C682E706F7328293F7028742C74732E5374796C65';
wwv_flow_imp.g_varchar2_table(2839) := '73293A6628297D72657475726E20682E616476616E63652831292C633D69732E57697468696E436F6E74656E742C7028742C74732E556E6B6E6F776E2C65297D72657475726E7B7363616E3A66756E6374696F6E28297B76617220653D682E706F732829';
wwv_flow_imp.g_varchar2_table(2840) := '2C743D632C6E3D6628293B72657475726E206E3D3D3D74732E454F537C7C65213D3D682E706F7328297C7C692626286E3D3D3D74732E5374617274546167436C6F73657C7C6E3D3D3D74732E456E64546167436C6F7365293F6E3A28636F6E736F6C652E';
wwv_flow_imp.g_varchar2_table(2841) := '6C6F6728225363616E6E65722E7363616E20686173206E6F7420616476616E636564206174206F666673657420222B652B222C207374617465206265666F72653A20222B742B222061667465723A20222B63292C682E616476616E63652831292C702865';
wwv_flow_imp.g_varchar2_table(2842) := '2C74732E556E6B6E6F776E29297D2C676574546F6B656E547970653A66756E6374696F6E28297B72657475726E20757D2C676574546F6B656E4F66667365743A66756E6374696F6E28297B72657475726E20647D2C676574546F6B656E4C656E6774683A';
wwv_flow_imp.g_varchar2_table(2843) := '66756E6374696F6E28297B72657475726E20682E706F7328292D647D2C676574546F6B656E456E643A66756E6374696F6E28297B72657475726E20682E706F7328297D2C676574546F6B656E546578743A66756E6374696F6E28297B72657475726E2068';
wwv_flow_imp.g_varchar2_table(2844) := '2E676574536F7572636528292E737562737472696E6728642C682E706F732829297D2C6765745363616E6E657253746174653A66756E6374696F6E28297B72657475726E20637D2C676574546F6B656E4572726F723A66756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(2845) := '75726E20727D7D7D66756E6374696F6E20527328652C74297B766172206E3D302C693D652E6C656E6774683B696628303D3D3D692972657475726E20303B666F72283B6E3C693B297B76617220723D4D6174682E666C6F6F7228286E2B69292F32293B74';
wwv_flow_imp.g_varchar2_table(2846) := '28655B725D293F693D723A6E3D722B317D72657475726E206E7D766172204D733D5B2261726561222C2262617365222C226272222C22636F6C222C22656D626564222C226872222C22696D67222C22696E707574222C226B657967656E222C226C696E6B';
wwv_flow_imp.g_varchar2_table(2847) := '222C226D656E756974656D222C226D657461222C22706172616D222C22736F75726365222C22747261636B222C22776272225D3B66756E6374696F6E204E732865297B72657475726E212165262666756E6374696F6E28652C74297B666F722876617220';
wwv_flow_imp.g_varchar2_table(2848) := '6E3D302C693D652E6C656E6774682D313B6E3C3D693B297B76617220723D286E2B69292F327C302C6F3D28613D655B725D2C733D742C612E6C6F63616C65436F6D70617265287329293B6966286F3C30296E3D722B313B656C73657B69662821286F3E30';
wwv_flow_imp.g_varchar2_table(2849) := '292972657475726E20723B693D722D317D7D76617220612C733B72657475726E2D286E2B31297D284D732C652E746F4C6F776572436173652829293E3D307D7661722049733D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(2850) := '7B746869732E73746172743D652C746869732E656E643D742C746869732E6368696C6472656E3D6E2C746869732E706172656E743D692C746869732E636C6F7365643D21317D72657475726E204F626A6563742E646566696E6550726F70657274792865';
wwv_flow_imp.g_varchar2_table(2851) := '2E70726F746F747970652C226174747269627574654E616D6573222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E617474726962757465733F4F626A6563742E6B65797328746869732E61747472696275746573293A5B5D7D2C';
wwv_flow_imp.g_varchar2_table(2852) := '656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E697353616D655461673D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D746869732E7461673F766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(2853) := '653A766F69642030213D3D652626746869732E7461672E6C656E6774683D3D3D652E6C656E6774682626746869732E7461672E746F4C6F7765724361736528293D3D3D657D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F74';
wwv_flow_imp.g_varchar2_table(2854) := '7970652C2266697273744368696C64222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E6368696C6472656E5B305D7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566';
wwv_flow_imp.g_varchar2_table(2855) := '696E6550726F706572747928652E70726F746F747970652C226C6173744368696C64222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E6368696C6472656E2E6C656E6774683F746869732E6368696C6472656E5B746869732E63';
wwv_flow_imp.g_varchar2_table(2856) := '68696C6472656E2E6C656E6774682D315D3A766F696420307D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E66696E644E6F64654265666F72653D66756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(2857) := '20743D527328746869732E6368696C6472656E2C2866756E6374696F6E2874297B72657475726E20653C3D742E73746172747D29292D313B696628743E3D30297B766172206E3D746869732E6368696C6472656E5B745D3B696628653E6E2E7374617274';
wwv_flow_imp.g_varchar2_table(2858) := '297B696628653C6E2E656E642972657475726E206E2E66696E644E6F64654265666F72652865293B76617220693D6E2E6C6173744368696C643B72657475726E20692626692E656E643D3D3D6E2E656E643F6E2E66696E644E6F64654265666F72652865';
wwv_flow_imp.g_varchar2_table(2859) := '293A6E7D7D72657475726E20746869737D2C652E70726F746F747970652E66696E644E6F646541743D66756E6374696F6E2865297B76617220743D527328746869732E6368696C6472656E2C2866756E6374696F6E2874297B72657475726E20653C3D74';
wwv_flow_imp.g_varchar2_table(2860) := '2E73746172747D29292D313B696628743E3D30297B766172206E3D746869732E6368696C6472656E5B745D3B696628653E6E2E73746172742626653C3D6E2E656E642972657475726E206E2E66696E644E6F646541742865297D72657475726E20746869';
wwv_flow_imp.g_varchar2_table(2861) := '737D2C657D28293B66756E6374696F6E207A732865297B666F722876617220743D417328652C766F696420302C766F696420302C2130292C6E3D6E657720497328302C652E6C656E6774682C5B5D2C766F69642030292C693D6E2C723D2D312C6F3D766F';
wwv_flow_imp.g_varchar2_table(2862) := '696420302C613D6E756C6C2C733D742E7363616E28293B73213D3D74732E454F533B297B7377697463682873297B636173652074732E53746172745461674F70656E3A766172206C3D6E657720497328742E676574546F6B656E4F666673657428292C65';
wwv_flow_imp.g_varchar2_table(2863) := '2E6C656E6774682C5B5D2C69293B692E6368696C6472656E2E70757368286C292C693D6C3B627265616B3B636173652074732E53746172745461673A692E7461673D742E676574546F6B656E5465787428293B627265616B3B636173652074732E537461';
wwv_flow_imp.g_varchar2_table(2864) := '7274546167436C6F73653A692E706172656E74262628692E656E643D742E676574546F6B656E456E6428292C742E676574546F6B656E4C656E67746828293F28692E7374617274546167456E643D742E676574546F6B656E456E6428292C692E74616726';
wwv_flow_imp.g_varchar2_table(2865) := '264E7328692E74616729262628692E636C6F7365643D21302C693D692E706172656E7429293A693D692E706172656E74293B627265616B3B636173652074732E537461727454616753656C66436C6F73653A692E706172656E74262628692E636C6F7365';
wwv_flow_imp.g_varchar2_table(2866) := '643D21302C692E656E643D742E676574546F6B656E456E6428292C692E7374617274546167456E643D742E676574546F6B656E456E6428292C693D692E706172656E74293B627265616B3B636173652074732E456E645461674F70656E3A723D742E6765';
wwv_flow_imp.g_varchar2_table(2867) := '74546F6B656E4F666673657428292C6F3D766F696420303B627265616B3B636173652074732E456E645461673A6F3D742E676574546F6B656E5465787428292E746F4C6F7765724361736528293B627265616B3B636173652074732E456E64546167436C';
wwv_flow_imp.g_varchar2_table(2868) := '6F73653A666F722876617220683D693B21682E697353616D65546167286F292626682E706172656E743B29683D682E706172656E743B696628682E706172656E74297B666F72283B69213D3D683B29692E656E643D722C692E636C6F7365643D21312C69';
wwv_flow_imp.g_varchar2_table(2869) := '3D692E706172656E743B692E636C6F7365643D21302C692E656E6454616753746172743D722C692E656E643D742E676574546F6B656E456E6428292C693D692E706172656E747D627265616B3B636173652074732E4174747269627574654E616D653A61';
wwv_flow_imp.g_varchar2_table(2870) := '3D742E676574546F6B656E5465787428292C28633D692E61747472696275746573297C7C28692E617474726962757465733D633D7B7D292C635B615D3D6E756C6C3B627265616B3B636173652074732E41747472696275746556616C75653A7661722063';
wwv_flow_imp.g_varchar2_table(2871) := '2C643D742E676574546F6B656E5465787428293B28633D692E6174747269627574657329262661262628635B615D3D642C613D6E756C6C297D733D742E7363616E28297D666F72283B692E706172656E743B29692E656E643D652E6C656E6774682C692E';
wwv_flow_imp.g_varchar2_table(2872) := '636C6F7365643D21312C693D692E706172656E743B72657475726E7B726F6F74733A6E2E6368696C6472656E2C66696E644E6F64654265666F72653A6E2E66696E644E6F64654265666F72652E62696E64286E292C66696E644E6F646541743A6E2E6669';
wwv_flow_imp.g_varchar2_table(2873) := '6E644E6F646541742E62696E64286E297D7D7661722055733D7B224161637574653B223A22C381222C4161637574653A22C381222C226161637574653B223A22C3A1222C6161637574653A22C3A1222C224162726576653B223A22C482222C2261627265';
wwv_flow_imp.g_varchar2_table(2874) := '76653B223A22C483222C2261633B223A22E288BE222C226163643B223A22E288BF222C226163453B223A22E288BECCB3222C2241636972633B223A22C382222C41636972633A22C382222C2261636972633B223A22C3A2222C61636972633A22C3A2222C';
wwv_flow_imp.g_varchar2_table(2875) := '2261637574653B223A22C2B4222C61637574653A22C2B4222C224163793B223A22D090222C226163793B223A22D0B0222C2241456C69673B223A22C386222C41456C69673A22C386222C2261656C69673B223A22C3A6222C61656C69673A22C3A6222C22';
wwv_flow_imp.g_varchar2_table(2876) := '61663B223A22E281A1222C224166723B223A22F09D9484222C226166723B223A22F09D949E222C224167726176653B223A22C380222C4167726176653A22C380222C226167726176653B223A22C3A0222C6167726176653A22C3A0222C22616C65667379';
wwv_flow_imp.g_varchar2_table(2877) := '6D3B223A22E284B5222C22616C6570683B223A22E284B5222C22416C7068613B223A22CE91222C22616C7068613B223A22CEB1222C22416D6163723B223A22C480222C22616D6163723B223A22C481222C22616D616C673B223A22E2A8BF222C22414D50';
wwv_flow_imp.g_varchar2_table(2878) := '3B223A2226222C414D503A2226222C22616D703B223A2226222C616D703A2226222C22416E643B223A22E2A993222C22616E643B223A22E288A7222C22616E64616E643B223A22E2A995222C22616E64643B223A22E2A99C222C22616E64736C6F70653B';
wwv_flow_imp.g_varchar2_table(2879) := '223A22E2A998222C22616E64763B223A22E2A99A222C22616E673B223A22E288A0222C22616E67653B223A22E2A6A4222C22616E676C653B223A22E288A0222C22616E676D73643B223A22E288A1222C22616E676D736461613B223A22E2A6A8222C2261';
wwv_flow_imp.g_varchar2_table(2880) := '6E676D736461623B223A22E2A6A9222C22616E676D736461633B223A22E2A6AA222C22616E676D736461643B223A22E2A6AB222C22616E676D736461653B223A22E2A6AC222C22616E676D736461663B223A22E2A6AD222C22616E676D736461673B223A';
wwv_flow_imp.g_varchar2_table(2881) := '22E2A6AE222C22616E676D736461683B223A22E2A6AF222C22616E6772743B223A22E2889F222C22616E67727476623B223A22E28ABE222C22616E6772747662643B223A22E2A69D222C22616E677370683B223A22E288A2222C22616E6773743B223A22';
wwv_flow_imp.g_varchar2_table(2882) := 'C385222C22616E677A6172723B223A22E28DBC222C22416F676F6E3B223A22C484222C22616F676F6E3B223A22C485222C22416F70663B223A22F09D94B8222C22616F70663B223A22F09D9592222C2261703B223A22E28988222C226170616369723B22';
wwv_flow_imp.g_varchar2_table(2883) := '3A22E2A9AF222C226170453B223A22E2A9B0222C226170653B223A22E2898A222C22617069643B223A22E2898B222C2261706F733B223A2227222C224170706C7946756E6374696F6E3B223A22E281A1222C22617070726F783B223A22E28988222C2261';
wwv_flow_imp.g_varchar2_table(2884) := '7070726F7865713B223A22E2898A222C224172696E673B223A22C385222C4172696E673A22C385222C226172696E673B223A22C3A5222C6172696E673A22C3A5222C22417363723B223A22F09D929C222C22617363723B223A22F09D92B6222C22417373';
wwv_flow_imp.g_varchar2_table(2885) := '69676E3B223A22E28994222C226173743B223A222A222C226173796D703B223A22E28988222C226173796D7065713B223A22E2898D222C224174696C64653B223A22C383222C4174696C64653A22C383222C226174696C64653B223A22C3A3222C617469';
wwv_flow_imp.g_varchar2_table(2886) := '6C64653A22C3A3222C2241756D6C3B223A22C384222C41756D6C3A22C384222C2261756D6C3B223A22C3A4222C61756D6C3A22C3A4222C226177636F6E696E743B223A22E288B3222C226177696E743B223A22E2A891222C226261636B636F6E673B223A';
wwv_flow_imp.g_varchar2_table(2887) := '22E2898C222C226261636B657073696C6F6E3B223A22CFB6222C226261636B7072696D653B223A22E280B5222C226261636B73696D3B223A22E288BD222C226261636B73696D65713B223A22E28B8D222C224261636B736C6173683B223A22E28896222C';
wwv_flow_imp.g_varchar2_table(2888) := '22426172763B223A22E2ABA7222C226261727665653B223A22E28ABD222C224261727765643B223A22E28C86222C226261727765643B223A22E28C85222C2262617277656467653B223A22E28C85222C226262726B3B223A22E28EB5222C226262726B74';
wwv_flow_imp.g_varchar2_table(2889) := '62726B3B223A22E28EB6222C2262636F6E673B223A22E2898C222C224263793B223A22D091222C226263793B223A22D0B1222C22626471756F3B223A22E2809E222C226265636175733B223A22E288B5222C22426563617573653B223A22E288B5222C22';
wwv_flow_imp.g_varchar2_table(2890) := '626563617573653B223A22E288B5222C2262656D707479763B223A22E2A6B0222C2262657073693B223A22CFB6222C226265726E6F753B223A22E284AC222C224265726E6F756C6C69733B223A22E284AC222C22426574613B223A22CE92222C22626574';
wwv_flow_imp.g_varchar2_table(2891) := '613B223A22CEB2222C22626574683B223A22E284B6222C226265747765656E3B223A22E289AC222C224266723B223A22F09D9485222C226266723B223A22F09D949F222C226269676361703B223A22E28B82222C22626967636972633B223A22E297AF22';
wwv_flow_imp.g_varchar2_table(2892) := '2C226269676375703B223A22E28B83222C226269676F646F743B223A22E2A880222C226269676F706C75733B223A22E2A881222C226269676F74696D65733B223A22E2A882222C2262696773716375703B223A22E2A886222C22626967737461723B223A';
wwv_flow_imp.g_varchar2_table(2893) := '22E29885222C22626967747269616E676C65646F776E3B223A22E296BD222C22626967747269616E676C6575703B223A22E296B3222C2262696775706C75733B223A22E2A884222C226269677665653B223A22E28B81222C2262696777656467653B223A';
wwv_flow_imp.g_varchar2_table(2894) := '22E28B80222C22626B61726F773B223A22E2A48D222C22626C61636B6C6F7A656E67653B223A22E2A7AB222C22626C61636B7371756172653B223A22E296AA222C22626C61636B747269616E676C653B223A22E296B4222C22626C61636B747269616E67';
wwv_flow_imp.g_varchar2_table(2895) := '6C65646F776E3B223A22E296BE222C22626C61636B747269616E676C656C6566743B223A22E29782222C22626C61636B747269616E676C6572696768743B223A22E296B8222C22626C616E6B3B223A22E290A3222C22626C6B31323B223A22E29692222C';
wwv_flow_imp.g_varchar2_table(2896) := '22626C6B31343B223A22E29691222C22626C6B33343B223A22E29693222C22626C6F636B3B223A22E29688222C22626E653B223A223DE283A5222C22626E65717569763B223A22E289A1E283A5222C22624E6F743B223A22E2ABAD222C22626E6F743B22';
wwv_flow_imp.g_varchar2_table(2897) := '3A22E28C90222C22426F70663B223A22F09D94B9222C22626F70663B223A22F09D9593222C22626F743B223A22E28AA5222C22626F74746F6D3B223A22E28AA5222C22626F777469653B223A22E28B88222C22626F78626F783B223A22E2A789222C2262';
wwv_flow_imp.g_varchar2_table(2898) := '6F78444C3B223A22E29597222C22626F78446C3B223A22E29596222C22626F78644C3B223A22E29595222C22626F78646C3B223A22E29490222C22626F7844523B223A22E29594222C22626F7844723B223A22E29593222C22626F7864523B223A22E295';
wwv_flow_imp.g_varchar2_table(2899) := '92222C22626F7864723B223A22E2948C222C22626F78483B223A22E29590222C22626F78683B223A22E29480222C22626F7848443B223A22E295A6222C22626F7848643B223A22E295A4222C22626F7868443B223A22E295A5222C22626F7868643B223A';
wwv_flow_imp.g_varchar2_table(2900) := '22E294AC222C22626F7848553B223A22E295A9222C22626F7848753B223A22E295A7222C22626F7868553B223A22E295A8222C22626F7868753B223A22E294B4222C22626F786D696E75733B223A22E28A9F222C22626F78706C75733B223A22E28A9E22';
wwv_flow_imp.g_varchar2_table(2901) := '2C22626F7874696D65733B223A22E28AA0222C22626F78554C3B223A22E2959D222C22626F78556C3B223A22E2959C222C22626F78754C3B223A22E2959B222C22626F78756C3B223A22E29498222C22626F7855523B223A22E2959A222C22626F785572';
wwv_flow_imp.g_varchar2_table(2902) := '3B223A22E29599222C22626F7875523B223A22E29598222C22626F7875723B223A22E29494222C22626F78563B223A22E29591222C22626F78763B223A22E29482222C22626F7856483B223A22E295AC222C22626F7856683B223A22E295AB222C22626F';
wwv_flow_imp.g_varchar2_table(2903) := '7876483B223A22E295AA222C22626F7876683B223A22E294BC222C22626F78564C3B223A22E295A3222C22626F78566C3B223A22E295A2222C22626F78764C3B223A22E295A1222C22626F78766C3B223A22E294A4222C22626F7856523B223A22E295A0';
wwv_flow_imp.g_varchar2_table(2904) := '222C22626F7856723B223A22E2959F222C22626F7876523B223A22E2959E222C22626F7876723B223A22E2949C222C22627072696D653B223A22E280B5222C2242726576653B223A22CB98222C2262726576653B223A22CB98222C226272766261723B22';
wwv_flow_imp.g_varchar2_table(2905) := '3A22C2A6222C6272766261723A22C2A6222C22427363723B223A22E284AC222C22627363723B223A22F09D92B7222C226273656D693B223A22E2818F222C226273696D3B223A22E288BD222C226273696D653B223A22E28B8D222C2262736F6C3B223A22';
wwv_flow_imp.g_varchar2_table(2906) := '5C5C222C2262736F6C623B223A22E2A785222C2262736F6C687375623B223A22E29F88222C2262756C6C3B223A22E280A2222C2262756C6C65743B223A22E280A2222C2262756D703B223A22E2898E222C2262756D70453B223A22E2AAAE222C2262756D';
wwv_flow_imp.g_varchar2_table(2907) := '70653B223A22E2898F222C2242756D7065713B223A22E2898E222C2262756D7065713B223A22E2898F222C224361637574653B223A22C486222C226361637574653B223A22C487222C224361703B223A22E28B92222C226361703B223A22E288A9222C22';
wwv_flow_imp.g_varchar2_table(2908) := '636170616E643B223A22E2A984222C2263617062726375703B223A22E2A989222C226361706361703B223A22E2A98B222C226361706375703B223A22E2A987222C22636170646F743B223A22E2A980222C224361706974616C446966666572656E746961';
wwv_flow_imp.g_varchar2_table(2909) := '6C443B223A22E28585222C22636170733B223A22E288A9EFB880222C2263617265743B223A22E28181222C226361726F6E3B223A22CB87222C224361796C6579733B223A22E284AD222C2263636170733B223A22E2A98D222C22436361726F6E3B223A22';
wwv_flow_imp.g_varchar2_table(2910) := 'C48C222C22636361726F6E3B223A22C48D222C2243636564696C3B223A22C387222C43636564696C3A22C387222C2263636564696C3B223A22C3A7222C63636564696C3A22C3A7222C2243636972633B223A22C488222C2263636972633B223A22C48922';
wwv_flow_imp.g_varchar2_table(2911) := '2C2243636F6E696E743B223A22E288B0222C2263637570733B223A22E2A98C222C226363757073736D3B223A22E2A990222C2243646F743B223A22C48A222C2263646F743B223A22C48B222C22636564696C3B223A22C2B8222C636564696C3A22C2B822';
wwv_flow_imp.g_varchar2_table(2912) := '2C22436564696C6C613B223A22C2B8222C2263656D707479763B223A22E2A6B2222C2263656E743B223A22C2A2222C63656E743A22C2A2222C2243656E746572446F743B223A22C2B7222C2263656E746572646F743B223A22C2B7222C224366723B223A';
wwv_flow_imp.g_varchar2_table(2913) := '22E284AD222C226366723B223A22F09D94A0222C22434863793B223A22D0A7222C22636863793B223A22D187222C22636865636B3B223A22E29C93222C22636865636B6D61726B3B223A22E29C93222C224368693B223A22CEA7222C226368693B223A22';
wwv_flow_imp.g_varchar2_table(2914) := 'CF87222C226369723B223A22E2978B222C22636972633B223A22CB86222C226369726365713B223A22E28997222C22636972636C656172726F776C6566743B223A22E286BA222C22636972636C656172726F7772696768743B223A22E286BB222C226369';
wwv_flow_imp.g_varchar2_table(2915) := '72636C65646173743B223A22E28A9B222C22636972636C6564636972633B223A22E28A9A222C22636972636C6564646173683B223A22E28A9D222C22436972636C65446F743B223A22E28A99222C22636972636C6564523B223A22C2AE222C2263697263';
wwv_flow_imp.g_varchar2_table(2916) := '6C6564533B223A22E29388222C22436972636C654D696E75733B223A22E28A96222C22436972636C65506C75733B223A22E28A95222C22436972636C6554696D65733B223A22E28A97222C22636972453B223A22E2A783222C22636972653B223A22E289';
wwv_flow_imp.g_varchar2_table(2917) := '97222C22636972666E696E743B223A22E2A890222C226369726D69643B223A22E2ABAF222C22636972736369723B223A22E2A782222C22436C6F636B77697365436F6E746F7572496E74656772616C3B223A22E288B2222C22436C6F73654375726C7944';
wwv_flow_imp.g_varchar2_table(2918) := '6F75626C6551756F74653B223A22E2809D222C22436C6F73654375726C7951756F74653B223A22E28099222C22636C7562733B223A22E299A3222C22636C7562737569743B223A22E299A3222C22436F6C6F6E3B223A22E288B7222C22636F6C6F6E3B22';
wwv_flow_imp.g_varchar2_table(2919) := '3A223A222C22436F6C6F6E653B223A22E2A9B4222C22636F6C6F6E653B223A22E28994222C22636F6C6F6E65713B223A22E28994222C22636F6D6D613B223A222C222C22636F6D6D61743B223A2240222C22636F6D703B223A22E28881222C22636F6D70';
wwv_flow_imp.g_varchar2_table(2920) := '666E3B223A22E28898222C22636F6D706C656D656E743B223A22E28881222C22636F6D706C657865733B223A22E28482222C22636F6E673B223A22E28985222C22636F6E67646F743B223A22E2A9AD222C22436F6E677275656E743B223A22E289A1222C';
wwv_flow_imp.g_varchar2_table(2921) := '22436F6E696E743B223A22E288AF222C22636F6E696E743B223A22E288AE222C22436F6E746F7572496E74656772616C3B223A22E288AE222C22436F70663B223A22E28482222C22636F70663B223A22F09D9594222C22636F70726F643B223A22E28890';
wwv_flow_imp.g_varchar2_table(2922) := '222C22436F70726F647563743B223A22E28890222C22434F50593B223A22C2A9222C434F50593A22C2A9222C22636F70793B223A22C2A9222C636F70793A22C2A9222C22636F707973723B223A22E28497222C22436F756E746572436C6F636B77697365';
wwv_flow_imp.g_varchar2_table(2923) := '436F6E746F7572496E74656772616C3B223A22E288B3222C2263726172723B223A22E286B5222C2243726F73733B223A22E2A8AF222C2263726F73733B223A22E29C97222C22437363723B223A22F09D929E222C22637363723B223A22F09D92B8222C22';
wwv_flow_imp.g_varchar2_table(2924) := '637375623B223A22E2AB8F222C2263737562653B223A22E2AB91222C22637375703B223A22E2AB90222C2263737570653B223A22E2AB92222C226374646F743B223A22E28BAF222C226375646172726C3B223A22E2A4B8222C22637564617272723B223A';
wwv_flow_imp.g_varchar2_table(2925) := '22E2A4B5222C2263756570723B223A22E28B9E222C2263756573633B223A22E28B9F222C2263756C6172723B223A22E286B6222C2263756C617272703B223A22E2A4BD222C224375703B223A22E28B93222C226375703B223A22E288AA222C2263757062';
wwv_flow_imp.g_varchar2_table(2926) := '726361703B223A22E2A988222C224375704361703B223A22E2898D222C226375706361703B223A22E2A986222C226375706375703B223A22E2A98A222C22637570646F743B223A22E28A8D222C226375706F723B223A22E2A985222C22637570733B223A';
wwv_flow_imp.g_varchar2_table(2927) := '22E288AAEFB880222C226375726172723B223A22E286B7222C226375726172726D3B223A22E2A4BC222C226375726C796571707265633B223A22E28B9E222C226375726C796571737563633B223A22E28B9F222C226375726C797665653B223A22E28B8E';
wwv_flow_imp.g_varchar2_table(2928) := '222C226375726C7977656467653B223A22E28B8F222C2263757272656E3B223A22C2A4222C63757272656E3A22C2A4222C2263757276656172726F776C6566743B223A22E286B6222C2263757276656172726F7772696768743B223A22E286B7222C2263';
wwv_flow_imp.g_varchar2_table(2929) := '757665653B223A22E28B8E222C2263757765643B223A22E28B8F222C226377636F6E696E743B223A22E288B2222C226377696E743B223A22E288B1222C2263796C6374793B223A22E28CAD222C224461676765723B223A22E280A1222C22646167676572';
wwv_flow_imp.g_varchar2_table(2930) := '3B223A22E280A0222C2264616C6574683B223A22E284B8222C22446172723B223A22E286A1222C22644172723B223A22E28793222C22646172723B223A22E28693222C22646173683B223A22E28090222C2244617368763B223A22E2ABA4222C22646173';
wwv_flow_imp.g_varchar2_table(2931) := '68763B223A22E28AA3222C2264626B61726F773B223A22E2A48F222C2264626C61633B223A22CB9D222C22446361726F6E3B223A22C48E222C22646361726F6E3B223A22C48F222C224463793B223A22D094222C226463793B223A22D0B4222C2244443B';
wwv_flow_imp.g_varchar2_table(2932) := '223A22E28585222C2264643B223A22E28586222C22646461676765723B223A22E280A1222C2264646172723B223A22E2878A222C2244446F74726168643B223A22E2A491222C2264646F747365713B223A22E2A9B7222C226465673B223A22C2B0222C64';
wwv_flow_imp.g_varchar2_table(2933) := '65673A22C2B0222C2244656C3B223A22E28887222C2244656C74613B223A22CE94222C2264656C74613B223A22CEB4222C2264656D707479763B223A22E2A6B1222C226466697368743B223A22E2A5BF222C224466723B223A22F09D9487222C22646672';
wwv_flow_imp.g_varchar2_table(2934) := '3B223A22F09D94A1222C22644861723B223A22E2A5A5222C22646861726C3B223A22E28783222C2264686172723B223A22E28782222C22446961637269746963616C41637574653B223A22C2B4222C22446961637269746963616C446F743B223A22CB99';
wwv_flow_imp.g_varchar2_table(2935) := '222C22446961637269746963616C446F75626C6541637574653B223A22CB9D222C22446961637269746963616C47726176653B223A2260222C22446961637269746963616C54696C64653B223A22CB9C222C226469616D3B223A22E28B84222C22446961';
wwv_flow_imp.g_varchar2_table(2936) := '6D6F6E643B223A22E28B84222C226469616D6F6E643B223A22E28B84222C226469616D6F6E64737569743B223A22E299A6222C226469616D733B223A22E299A6222C226469653B223A22C2A8222C22446966666572656E7469616C443B223A22E2858622';
wwv_flow_imp.g_varchar2_table(2937) := '2C22646967616D6D613B223A22CF9D222C22646973696E3B223A22E28BB2222C226469763B223A22C3B7222C226469766964653B223A22C3B7222C6469766964653A22C3B7222C226469766964656F6E74696D65733B223A22E28B87222C226469766F6E';
wwv_flow_imp.g_varchar2_table(2938) := '783B223A22E28B87222C22444A63793B223A22D082222C22646A63793B223A22D192222C22646C636F726E3B223A22E28C9E222C22646C63726F703B223A22E28C8D222C22646F6C6C61723B223A2224222C22446F70663B223A22F09D94BB222C22646F';
wwv_flow_imp.g_varchar2_table(2939) := '70663B223A22F09D9595222C22446F743B223A22C2A8222C22646F743B223A22CB99222C22446F74446F743B223A22E2839C222C22646F7465713B223A22E28990222C22646F746571646F743B223A22E28991222C22446F74457175616C3B223A22E289';
wwv_flow_imp.g_varchar2_table(2940) := '90222C22646F746D696E75733B223A22E288B8222C22646F74706C75733B223A22E28894222C22646F747371756172653B223A22E28AA1222C22646F75626C6562617277656467653B223A22E28C86222C22446F75626C65436F6E746F7572496E746567';
wwv_flow_imp.g_varchar2_table(2941) := '72616C3B223A22E288AF222C22446F75626C65446F743B223A22C2A8222C22446F75626C65446F776E4172726F773B223A22E28793222C22446F75626C654C6566744172726F773B223A22E28790222C22446F75626C654C65667452696768744172726F';
wwv_flow_imp.g_varchar2_table(2942) := '773B223A22E28794222C22446F75626C654C6566745465653B223A22E2ABA4222C22446F75626C654C6F6E674C6566744172726F773B223A22E29FB8222C22446F75626C654C6F6E674C65667452696768744172726F773B223A22E29FBA222C22446F75';
wwv_flow_imp.g_varchar2_table(2943) := '626C654C6F6E6752696768744172726F773B223A22E29FB9222C22446F75626C6552696768744172726F773B223A22E28792222C22446F75626C6552696768745465653B223A22E28AA8222C22446F75626C6555704172726F773B223A22E28791222C22';
wwv_flow_imp.g_varchar2_table(2944) := '446F75626C655570446F776E4172726F773B223A22E28795222C22446F75626C65566572746963616C4261723B223A22E288A5222C22446F776E4172726F773B223A22E28693222C22446F776E6172726F773B223A22E28793222C22646F776E6172726F';
wwv_flow_imp.g_varchar2_table(2945) := '773B223A22E28693222C22446F776E4172726F774261723B223A22E2A493222C22446F776E4172726F7755704172726F773B223A22E287B5222C22446F776E42726576653B223A22CC91222C22646F776E646F776E6172726F77733B223A22E2878A222C';
wwv_flow_imp.g_varchar2_table(2946) := '22646F776E686172706F6F6E6C6566743B223A22E28783222C22646F776E686172706F6F6E72696768743B223A22E28782222C22446F776E4C6566745269676874566563746F723B223A22E2A590222C22446F776E4C656674546565566563746F723B22';
wwv_flow_imp.g_varchar2_table(2947) := '3A22E2A59E222C22446F776E4C656674566563746F723B223A22E286BD222C22446F776E4C656674566563746F724261723B223A22E2A596222C22446F776E5269676874546565566563746F723B223A22E2A59F222C22446F776E526967687456656374';
wwv_flow_imp.g_varchar2_table(2948) := '6F723B223A22E28781222C22446F776E5269676874566563746F724261723B223A22E2A597222C22446F776E5465653B223A22E28AA4222C22446F776E5465654172726F773B223A22E286A7222C226472626B61726F773B223A22E2A490222C22647263';
wwv_flow_imp.g_varchar2_table(2949) := '6F726E3B223A22E28C9F222C22647263726F703B223A22E28C8C222C22447363723B223A22F09D929F222C22647363723B223A22F09D92B9222C22445363793B223A22D085222C22647363793B223A22D195222C2264736F6C3B223A22E2A7B6222C2244';
wwv_flow_imp.g_varchar2_table(2950) := '7374726F6B3B223A22C490222C22647374726F6B3B223A22C491222C226474646F743B223A22E28BB1222C22647472693B223A22E296BF222C2264747269663B223A22E296BE222C2264756172723B223A22E287B5222C2264756861723B223A22E2A5AF';
wwv_flow_imp.g_varchar2_table(2951) := '222C226477616E676C653B223A22E2A6A6222C22445A63793B223A22D08F222C22647A63793B223A22D19F222C22647A6967726172723B223A22E29FBF222C224561637574653B223A22C389222C4561637574653A22C389222C226561637574653B223A';
wwv_flow_imp.g_varchar2_table(2952) := '22C3A9222C6561637574653A22C3A9222C226561737465723B223A22E2A9AE222C22456361726F6E3B223A22C49A222C22656361726F6E3B223A22C49B222C22656369723B223A22E28996222C2245636972633B223A22C38A222C45636972633A22C38A';
wwv_flow_imp.g_varchar2_table(2953) := '222C2265636972633B223A22C3AA222C65636972633A22C3AA222C2265636F6C6F6E3B223A22E28995222C224563793B223A22D0AD222C226563793B223A22D18D222C226544446F743B223A22E2A9B7222C2245646F743B223A22C496222C2265446F74';
wwv_flow_imp.g_varchar2_table(2954) := '3B223A22E28991222C2265646F743B223A22C497222C2265653B223A22E28587222C226566446F743B223A22E28992222C224566723B223A22F09D9488222C226566723B223A22F09D94A2222C2265673B223A22E2AA9A222C224567726176653B223A22';
wwv_flow_imp.g_varchar2_table(2955) := 'C388222C4567726176653A22C388222C226567726176653B223A22C3A8222C6567726176653A22C3A8222C226567733B223A22E2AA96222C22656773646F743B223A22E2AA98222C22656C3B223A22E2AA99222C22456C656D656E743B223A22E2888822';
wwv_flow_imp.g_varchar2_table(2956) := '2C22656C696E746572733B223A22E28FA7222C22656C6C3B223A22E28493222C22656C733B223A22E2AA95222C22656C73646F743B223A22E2AA97222C22456D6163723B223A22C492222C22656D6163723B223A22C493222C22656D7074793B223A22E2';
wwv_flow_imp.g_varchar2_table(2957) := '8885222C22656D7074797365743B223A22E28885222C22456D707479536D616C6C5371756172653B223A22E297BB222C22656D707479763B223A22E28885222C22456D70747956657279536D616C6C5371756172653B223A22E296AB222C22656D73703B';
wwv_flow_imp.g_varchar2_table(2958) := '223A22E28083222C22656D737031333B223A22E28084222C22656D737031343B223A22E28085222C22454E473B223A22C58A222C22656E673B223A22C58B222C22656E73703B223A22E28082222C22456F676F6E3B223A22C498222C22656F676F6E3B22';
wwv_flow_imp.g_varchar2_table(2959) := '3A22C499222C22456F70663B223A22F09D94BC222C22656F70663B223A22F09D9596222C22657061723B223A22E28B95222C2265706172736C3B223A22E2A7A3222C2265706C75733B223A22E2A9B1222C22657073693B223A22CEB5222C22457073696C';
wwv_flow_imp.g_varchar2_table(2960) := '6F6E3B223A22CE95222C22657073696C6F6E3B223A22CEB5222C2265707369763B223A22CFB5222C226571636972633B223A22E28996222C226571636F6C6F6E3B223A22E28995222C22657173696D3B223A22E28982222C226571736C616E746774723B';
wwv_flow_imp.g_varchar2_table(2961) := '223A22E2AA96222C226571736C616E746C6573733B223A22E2AA95222C22457175616C3B223A22E2A9B5222C22657175616C733B223A223D222C22457175616C54696C64653B223A22E28982222C226571756573743B223A22E2899F222C22457175696C';
wwv_flow_imp.g_varchar2_table(2962) := '69627269756D3B223A22E2878C222C2265717569763B223A22E289A1222C22657175697644443B223A22E2A9B8222C22657176706172736C3B223A22E2A7A5222C2265726172723B223A22E2A5B1222C226572446F743B223A22E28993222C2245736372';
wwv_flow_imp.g_varchar2_table(2963) := '3B223A22E284B0222C22657363723B223A22E284AF222C226573646F743B223A22E28990222C224573696D3B223A22E2A9B3222C226573696D3B223A22E28982222C224574613B223A22CE97222C226574613B223A22CEB7222C224554483B223A22C390';
wwv_flow_imp.g_varchar2_table(2964) := '222C4554483A22C390222C226574683B223A22C3B0222C6574683A22C3B0222C2245756D6C3B223A22C38B222C45756D6C3A22C38B222C2265756D6C3B223A22C3AB222C65756D6C3A22C3AB222C226575726F3B223A22E282AC222C226578636C3B223A';
wwv_flow_imp.g_varchar2_table(2965) := '2221222C2265786973743B223A22E28883222C224578697374733B223A22E28883222C226578706563746174696F6E3B223A22E284B0222C224578706F6E656E7469616C453B223A22E28587222C226578706F6E656E7469616C653B223A22E28587222C';
wwv_flow_imp.g_varchar2_table(2966) := '2266616C6C696E67646F747365713B223A22E28992222C224663793B223A22D0A4222C226663793B223A22D184222C2266656D616C653B223A22E29980222C226666696C69673B223A22EFAC83222C2266666C69673B223A22EFAC80222C2266666C6C69';
wwv_flow_imp.g_varchar2_table(2967) := '673B223A22EFAC84222C224666723B223A22F09D9489222C226666723B223A22F09D94A3222C2266696C69673B223A22EFAC81222C2246696C6C6564536D616C6C5371756172653B223A22E297BC222C2246696C6C656456657279536D616C6C53717561';
wwv_flow_imp.g_varchar2_table(2968) := '72653B223A22E296AA222C22666A6C69673B223A22666A222C22666C61743B223A22E299AD222C22666C6C69673B223A22EFAC82222C22666C746E733B223A22E296B1222C22666E6F663B223A22C692222C22466F70663B223A22F09D94BD222C22666F';
wwv_flow_imp.g_varchar2_table(2969) := '70663B223A22F09D9597222C22466F72416C6C3B223A22E28880222C22666F72616C6C3B223A22E28880222C22666F726B3B223A22E28B94222C22666F726B763B223A22E2AB99222C22466F75726965727472663B223A22E284B1222C22667061727469';
wwv_flow_imp.g_varchar2_table(2970) := '6E743B223A22E2A88D222C226672616331323B223A22C2BD222C6672616331323A22C2BD222C226672616331333B223A22E28593222C226672616331343B223A22C2BC222C6672616331343A22C2BC222C226672616331353B223A22E28595222C226672';
wwv_flow_imp.g_varchar2_table(2971) := '616331363B223A22E28599222C226672616331383B223A22E2859B222C226672616332333B223A22E28594222C226672616332353B223A22E28596222C226672616333343B223A22C2BE222C6672616333343A22C2BE222C226672616333353B223A22E2';
wwv_flow_imp.g_varchar2_table(2972) := '8597222C226672616333383B223A22E2859C222C226672616334353B223A22E28598222C226672616335363B223A22E2859A222C226672616335383B223A22E2859D222C226672616337383B223A22E2859E222C22667261736C3B223A22E28184222C22';
wwv_flow_imp.g_varchar2_table(2973) := '66726F776E3B223A22E28CA2222C22467363723B223A22E284B1222C22667363723B223A22F09D92BB222C226761637574653B223A22C7B5222C2247616D6D613B223A22CE93222C2267616D6D613B223A22CEB3222C2247616D6D61643B223A22CF9C22';
wwv_flow_imp.g_varchar2_table(2974) := '2C2267616D6D61643B223A22CF9D222C226761703B223A22E2AA86222C224762726576653B223A22C49E222C226762726576653B223A22C49F222C2247636564696C3B223A22C4A2222C2247636972633B223A22C49C222C2267636972633B223A22C49D';
wwv_flow_imp.g_varchar2_table(2975) := '222C224763793B223A22D093222C226763793B223A22D0B3222C2247646F743B223A22C4A0222C2267646F743B223A22C4A1222C2267453B223A22E289A7222C2267653B223A22E289A5222C2267456C3B223A22E2AA8C222C2267656C3B223A22E28B9B';
wwv_flow_imp.g_varchar2_table(2976) := '222C226765713B223A22E289A5222C22676571713B223A22E289A7222C22676571736C616E743B223A22E2A9BE222C226765733B223A22E2A9BE222C2267657363633B223A22E2AAA9222C22676573646F743B223A22E2AA80222C22676573646F746F3B';
wwv_flow_imp.g_varchar2_table(2977) := '223A22E2AA82222C22676573646F746F6C3B223A22E2AA84222C226765736C3B223A22E28B9BEFB880222C226765736C65733B223A22E2AA94222C224766723B223A22F09D948A222C226766723B223A22F09D94A4222C2247673B223A22E28B99222C22';
wwv_flow_imp.g_varchar2_table(2978) := '67673B223A22E289AB222C226767673B223A22E28B99222C2267696D656C3B223A22E284B7222C22474A63793B223A22D083222C22676A63793B223A22D193222C22676C3B223A22E289B7222C22676C613B223A22E2AAA5222C22676C453B223A22E2AA';
wwv_flow_imp.g_varchar2_table(2979) := '92222C22676C6A3B223A22E2AAA4222C22676E61703B223A22E2AA8A222C22676E617070726F783B223A22E2AA8A222C22676E453B223A22E289A9222C22676E653B223A22E2AA88222C22676E65713B223A22E2AA88222C22676E6571713B223A22E289';
wwv_flow_imp.g_varchar2_table(2980) := 'A9222C22676E73696D3B223A22E28BA7222C22476F70663B223A22F09D94BE222C22676F70663B223A22F09D9598222C2267726176653B223A2260222C2247726561746572457175616C3B223A22E289A5222C2247726561746572457175616C4C657373';
wwv_flow_imp.g_varchar2_table(2981) := '3B223A22E28B9B222C224772656174657246756C6C457175616C3B223A22E289A7222C2247726561746572477265617465723B223A22E2AAA2222C22477265617465724C6573733B223A22E289B7222C2247726561746572536C616E74457175616C3B22';
wwv_flow_imp.g_varchar2_table(2982) := '3A22E2A9BE222C224772656174657254696C64653B223A22E289B3222C22477363723B223A22F09D92A2222C22677363723B223A22E2848A222C226773696D3B223A22E289B3222C226773696D653B223A22E2AA8E222C226773696D6C3B223A22E2AA90';
wwv_flow_imp.g_varchar2_table(2983) := '222C2247543B223A223E222C47543A223E222C2247743B223A22E289AB222C2267743B223A223E222C67743A223E222C22677463633B223A22E2AAA7222C2267746369723B223A22E2A9BA222C226774646F743B223A22E28B97222C2267746C5061723B';
wwv_flow_imp.g_varchar2_table(2984) := '223A22E2A695222C22677471756573743B223A22E2A9BC222C22677472617070726F783B223A22E2AA86222C226774726172723B223A22E2A5B8222C22677472646F743B223A22E28B97222C2267747265716C6573733B223A22E28B9B222C2267747265';
wwv_flow_imp.g_varchar2_table(2985) := '71716C6573733B223A22E2AA8C222C226774726C6573733B223A22E289B7222C2267747273696D3B223A22E289B3222C2267766572746E6571713B223A22E289A9EFB880222C2267766E453B223A22E289A9EFB880222C22486163656B3B223A22CB8722';
wwv_flow_imp.g_varchar2_table(2986) := '2C226861697273703B223A22E2808A222C2268616C663B223A22C2BD222C2268616D696C743B223A22E2848B222C224841524463793B223A22D0AA222C226861726463793B223A22D18A222C22684172723B223A22E28794222C22686172723B223A22E2';
wwv_flow_imp.g_varchar2_table(2987) := '8694222C22686172726369723B223A22E2A588222C2268617272773B223A22E286AD222C224861743B223A225E222C22686261723B223A22E2848F222C2248636972633B223A22C4A4222C2268636972633B223A22C4A5222C226865617274733B223A22';
wwv_flow_imp.g_varchar2_table(2988) := 'E299A5222C226865617274737569743B223A22E299A5222C2268656C6C69703B223A22E280A6222C22686572636F6E3B223A22E28AB9222C224866723B223A22E2848C222C226866723B223A22F09D94A5222C2248696C6265727453706163653B223A22';
wwv_flow_imp.g_varchar2_table(2989) := 'E2848B222C22686B736561726F773B223A22E2A4A5222C22686B737761726F773B223A22E2A4A6222C22686F6172723B223A22E287BF222C22686F6D7468743B223A22E288BB222C22686F6F6B6C6566746172726F773B223A22E286A9222C22686F6F6B';
wwv_flow_imp.g_varchar2_table(2990) := '72696768746172726F773B223A22E286AA222C22486F70663B223A22E2848D222C22686F70663B223A22F09D9599222C22686F726261723B223A22E28095222C22486F72697A6F6E74616C4C696E653B223A22E29480222C22487363723B223A22E2848B';
wwv_flow_imp.g_varchar2_table(2991) := '222C22687363723B223A22F09D92BD222C2268736C6173683B223A22E2848F222C22487374726F6B3B223A22C4A6222C22687374726F6B3B223A22C4A7222C2248756D70446F776E48756D703B223A22E2898E222C2248756D70457175616C3B223A22E2';
wwv_flow_imp.g_varchar2_table(2992) := '898F222C22687962756C6C3B223A22E28183222C2268797068656E3B223A22E28090222C224961637574653B223A22C38D222C4961637574653A22C38D222C226961637574653B223A22C3AD222C6961637574653A22C3AD222C2269633B223A22E281A3';
wwv_flow_imp.g_varchar2_table(2993) := '222C2249636972633B223A22C38E222C49636972633A22C38E222C2269636972633B223A22C3AE222C69636972633A22C3AE222C224963793B223A22D098222C226963793B223A22D0B8222C2249646F743B223A22C4B0222C22494563793B223A22D095';
wwv_flow_imp.g_varchar2_table(2994) := '222C22696563793B223A22D0B5222C22696578636C3B223A22C2A1222C696578636C3A22C2A1222C226966663B223A22E28794222C224966723B223A22E28491222C226966723B223A22F09D94A6222C224967726176653B223A22C38C222C4967726176';
wwv_flow_imp.g_varchar2_table(2995) := '653A22C38C222C226967726176653B223A22C3AC222C6967726176653A22C3AC222C2269693B223A22E28588222C22696969696E743B223A22E2A88C222C226969696E743B223A22E288AD222C2269696E66696E3B223A22E2A79C222C2269696F74613B';
wwv_flow_imp.g_varchar2_table(2996) := '223A22E284A9222C22494A6C69673B223A22C4B2222C22696A6C69673B223A22C4B3222C22496D3B223A22E28491222C22496D6163723B223A22C4AA222C22696D6163723B223A22C4AB222C22696D6167653B223A22E28491222C22496D6167696E6172';
wwv_flow_imp.g_varchar2_table(2997) := '79493B223A22E28588222C22696D61676C696E653B223A22E28490222C22696D6167706172743B223A22E28491222C22696D6174683B223A22C4B1222C22696D6F663B223A22E28AB7222C22696D7065643B223A22C6B5222C22496D706C6965733B223A';
wwv_flow_imp.g_varchar2_table(2998) := '22E28792222C22696E3B223A22E28888222C22696E636172653B223A22E28485222C22696E66696E3B223A22E2889E222C22696E66696E7469653B223A22E2A79D222C22696E6F646F743B223A22C4B1222C22496E743B223A22E288AC222C22696E743B';
wwv_flow_imp.g_varchar2_table(2999) := '223A22E288AB222C22696E7463616C3B223A22E28ABA222C22696E7465676572733B223A22E284A4222C22496E74656772616C3B223A22E288AB222C22696E74657263616C3B223A22E28ABA222C22496E74657273656374696F6E3B223A22E28B82222C';
wwv_flow_imp.g_varchar2_table(3000) := '22696E746C6172686B3B223A22E2A897222C22696E7470726F643B223A22E2A8BC222C22496E76697369626C65436F6D6D613B223A22E281A3222C22496E76697369626C6554696D65733B223A22E281A2222C22494F63793B223A22D081222C22696F63';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(3001) := '793B223A22D191222C22496F676F6E3B223A22C4AE222C22696F676F6E3B223A22C4AF222C22496F70663B223A22F09D9580222C22696F70663B223A22F09D959A222C22496F74613B223A22CE99222C22696F74613B223A22CEB9222C226970726F643B';
wwv_flow_imp.g_varchar2_table(3002) := '223A22E2A8BC222C226971756573743B223A22C2BF222C6971756573743A22C2BF222C22497363723B223A22E28490222C22697363723B223A22F09D92BE222C226973696E3B223A22E28888222C226973696E646F743B223A22E28BB5222C226973696E';
wwv_flow_imp.g_varchar2_table(3003) := '453B223A22E28BB9222C226973696E733B223A22E28BB4222C226973696E73763B223A22E28BB3222C226973696E763B223A22E28888222C2269743B223A22E281A2222C224974696C64653B223A22C4A8222C226974696C64653B223A22C4A9222C2249';
wwv_flow_imp.g_varchar2_table(3004) := '756B63793B223A22D086222C2269756B63793B223A22D196222C2249756D6C3B223A22C38F222C49756D6C3A22C38F222C2269756D6C3B223A22C3AF222C69756D6C3A22C3AF222C224A636972633B223A22C4B4222C226A636972633B223A22C4B5222C';
wwv_flow_imp.g_varchar2_table(3005) := '224A63793B223A22D099222C226A63793B223A22D0B9222C224A66723B223A22F09D948D222C226A66723B223A22F09D94A7222C226A6D6174683B223A22C8B7222C224A6F70663B223A22F09D9581222C226A6F70663B223A22F09D959B222C224A7363';
wwv_flow_imp.g_varchar2_table(3006) := '723B223A22F09D92A5222C226A7363723B223A22F09D92BF222C224A73657263793B223A22D088222C226A73657263793B223A22D198222C224A756B63793B223A22D084222C226A756B63793B223A22D194222C224B617070613B223A22CE9A222C226B';
wwv_flow_imp.g_varchar2_table(3007) := '617070613B223A22CEBA222C226B61707061763B223A22CFB0222C224B636564696C3B223A22C4B6222C226B636564696C3B223A22C4B7222C224B63793B223A22D09A222C226B63793B223A22D0BA222C224B66723B223A22F09D948E222C226B66723B';
wwv_flow_imp.g_varchar2_table(3008) := '223A22F09D94A8222C226B677265656E3B223A22C4B8222C224B4863793B223A22D0A5222C226B6863793B223A22D185222C224B4A63793B223A22D08C222C226B6A63793B223A22D19C222C224B6F70663B223A22F09D9582222C226B6F70663B223A22';
wwv_flow_imp.g_varchar2_table(3009) := 'F09D959C222C224B7363723B223A22F09D92A6222C226B7363723B223A22F09D9380222C226C416172723B223A22E2879A222C224C61637574653B223A22C4B9222C226C61637574653B223A22C4BA222C226C61656D707479763B223A22E2A6B4222C22';
wwv_flow_imp.g_varchar2_table(3010) := '6C616772616E3B223A22E28492222C224C616D6264613B223A22CE9B222C226C616D6264613B223A22CEBB222C224C616E673B223A22E29FAA222C226C616E673B223A22E29FA8222C226C616E67643B223A22E2A691222C226C616E676C653B223A22E2';
wwv_flow_imp.g_varchar2_table(3011) := '9FA8222C226C61703B223A22E2AA85222C224C61706C6163657472663B223A22E28492222C226C6171756F3B223A22C2AB222C6C6171756F3A22C2AB222C224C6172723B223A22E2869E222C226C4172723B223A22E28790222C226C6172723B223A22E2';
wwv_flow_imp.g_varchar2_table(3012) := '8690222C226C617272623B223A22E287A4222C226C6172726266733B223A22E2A49F222C226C61727266733B223A22E2A49D222C226C617272686B3B223A22E286A9222C226C6172726C703B223A22E286AB222C226C617272706C3B223A22E2A4B9222C';
wwv_flow_imp.g_varchar2_table(3013) := '226C61727273696D3B223A22E2A5B3222C226C617272746C3B223A22E286A2222C226C61743B223A22E2AAAB222C226C417461696C3B223A22E2A49B222C226C617461696C3B223A22E2A499222C226C6174653B223A22E2AAAD222C226C617465733B22';
wwv_flow_imp.g_varchar2_table(3014) := '3A22E2AAADEFB880222C226C426172723B223A22E2A48E222C226C626172723B223A22E2A48C222C226C6262726B3B223A22E29DB2222C226C62726163653B223A227B222C226C627261636B3B223A225B222C226C62726B653B223A22E2A68B222C226C';
wwv_flow_imp.g_varchar2_table(3015) := '62726B736C643B223A22E2A68F222C226C62726B736C753B223A22E2A68D222C224C6361726F6E3B223A22C4BD222C226C6361726F6E3B223A22C4BE222C224C636564696C3B223A22C4BB222C226C636564696C3B223A22C4BC222C226C6365696C3B22';
wwv_flow_imp.g_varchar2_table(3016) := '3A22E28C88222C226C6375623B223A227B222C224C63793B223A22D09B222C226C63793B223A22D0BB222C226C6463613B223A22E2A4B6222C226C6471756F3B223A22E2809C222C226C6471756F723B223A22E2809E222C226C6472646861723B223A22';
wwv_flow_imp.g_varchar2_table(3017) := 'E2A5A7222C226C647275736861723B223A22E2A58B222C226C6473683B223A22E286B2222C226C453B223A22E289A6222C226C653B223A22E289A4222C224C656674416E676C65427261636B65743B223A22E29FA8222C224C6566744172726F773B223A';
wwv_flow_imp.g_varchar2_table(3018) := '22E28690222C224C6566746172726F773B223A22E28790222C226C6566746172726F773B223A22E28690222C224C6566744172726F774261723B223A22E287A4222C224C6566744172726F7752696768744172726F773B223A22E28786222C226C656674';
wwv_flow_imp.g_varchar2_table(3019) := '6172726F777461696C3B223A22E286A2222C224C6566744365696C696E673B223A22E28C88222C224C656674446F75626C65427261636B65743B223A22E29FA6222C224C656674446F776E546565566563746F723B223A22E2A5A1222C224C656674446F';
wwv_flow_imp.g_varchar2_table(3020) := '776E566563746F723B223A22E28783222C224C656674446F776E566563746F724261723B223A22E2A599222C224C656674466C6F6F723B223A22E28C8A222C226C656674686172706F6F6E646F776E3B223A22E286BD222C226C656674686172706F6F6E';
wwv_flow_imp.g_varchar2_table(3021) := '75703B223A22E286BC222C226C6566746C6566746172726F77733B223A22E28787222C224C65667452696768744172726F773B223A22E28694222C224C65667472696768746172726F773B223A22E28794222C226C65667472696768746172726F773B22';
wwv_flow_imp.g_varchar2_table(3022) := '3A22E28694222C226C65667472696768746172726F77733B223A22E28786222C226C6566747269676874686172706F6F6E733B223A22E2878B222C226C656674726967687473717569676172726F773B223A22E286AD222C224C65667452696768745665';
wwv_flow_imp.g_varchar2_table(3023) := '63746F723B223A22E2A58E222C224C6566745465653B223A22E28AA3222C224C6566745465654172726F773B223A22E286A4222C224C656674546565566563746F723B223A22E2A59A222C226C656674746872656574696D65733B223A22E28B8B222C22';
wwv_flow_imp.g_varchar2_table(3024) := '4C656674547269616E676C653B223A22E28AB2222C224C656674547269616E676C654261723B223A22E2A78F222C224C656674547269616E676C65457175616C3B223A22E28AB4222C224C6566745570446F776E566563746F723B223A22E2A591222C22';
wwv_flow_imp.g_varchar2_table(3025) := '4C6566745570546565566563746F723B223A22E2A5A0222C224C6566745570566563746F723B223A22E286BF222C224C6566745570566563746F724261723B223A22E2A598222C224C656674566563746F723B223A22E286BC222C224C65667456656374';
wwv_flow_imp.g_varchar2_table(3026) := '6F724261723B223A22E2A592222C226C45673B223A22E2AA8B222C226C65673B223A22E28B9A222C226C65713B223A22E289A4222C226C6571713B223A22E289A6222C226C6571736C616E743B223A22E2A9BD222C226C65733B223A22E2A9BD222C226C';
wwv_flow_imp.g_varchar2_table(3027) := '657363633B223A22E2AAA8222C226C6573646F743B223A22E2A9BF222C226C6573646F746F3B223A22E2AA81222C226C6573646F746F723B223A22E2AA83222C226C6573673B223A22E28B9AEFB880222C226C65736765733B223A22E2AA93222C226C65';
wwv_flow_imp.g_varchar2_table(3028) := '7373617070726F783B223A22E2AA85222C226C657373646F743B223A22E28B96222C226C65737365716774723B223A22E28B9A222C226C6573736571716774723B223A22E2AA8B222C224C657373457175616C477265617465723B223A22E28B9A222C22';
wwv_flow_imp.g_varchar2_table(3029) := '4C65737346756C6C457175616C3B223A22E289A6222C224C657373477265617465723B223A22E289B6222C226C6573736774723B223A22E289B6222C224C6573734C6573733B223A22E2AAA1222C226C65737373696D3B223A22E289B2222C224C657373';
wwv_flow_imp.g_varchar2_table(3030) := '536C616E74457175616C3B223A22E2A9BD222C224C65737354696C64653B223A22E289B2222C226C66697368743B223A22E2A5BC222C226C666C6F6F723B223A22E28C8A222C224C66723B223A22F09D948F222C226C66723B223A22F09D94A9222C226C';
wwv_flow_imp.g_varchar2_table(3031) := '673B223A22E289B6222C226C67453B223A22E2AA91222C226C4861723B223A22E2A5A2222C226C686172643B223A22E286BD222C226C686172753B223A22E286BC222C226C686172756C3B223A22E2A5AA222C226C68626C6B3B223A22E29684222C224C';
wwv_flow_imp.g_varchar2_table(3032) := '4A63793B223A22D089222C226C6A63793B223A22D199222C224C6C3B223A22E28B98222C226C6C3B223A22E289AA222C226C6C6172723B223A22E28787222C226C6C636F726E65723B223A22E28C9E222C224C6C6566746172726F773B223A22E2879A22';
wwv_flow_imp.g_varchar2_table(3033) := '2C226C6C686172643B223A22E2A5AB222C226C6C7472693B223A22E297BA222C224C6D69646F743B223A22C4BF222C226C6D69646F743B223A22C580222C226C6D6F7573743B223A22E28EB0222C226C6D6F757374616368653B223A22E28EB0222C226C';
wwv_flow_imp.g_varchar2_table(3034) := '6E61703B223A22E2AA89222C226C6E617070726F783B223A22E2AA89222C226C6E453B223A22E289A8222C226C6E653B223A22E2AA87222C226C6E65713B223A22E2AA87222C226C6E6571713B223A22E289A8222C226C6E73696D3B223A22E28BA6222C';
wwv_flow_imp.g_varchar2_table(3035) := '226C6F616E673B223A22E29FAC222C226C6F6172723B223A22E287BD222C226C6F62726B3B223A22E29FA6222C224C6F6E674C6566744172726F773B223A22E29FB5222C224C6F6E676C6566746172726F773B223A22E29FB8222C226C6F6E676C656674';
wwv_flow_imp.g_varchar2_table(3036) := '6172726F773B223A22E29FB5222C224C6F6E674C65667452696768744172726F773B223A22E29FB7222C224C6F6E676C65667472696768746172726F773B223A22E29FBA222C226C6F6E676C65667472696768746172726F773B223A22E29FB7222C226C';
wwv_flow_imp.g_varchar2_table(3037) := '6F6E676D617073746F3B223A22E29FBC222C224C6F6E6752696768744172726F773B223A22E29FB6222C224C6F6E6772696768746172726F773B223A22E29FB9222C226C6F6E6772696768746172726F773B223A22E29FB6222C226C6F6F706172726F77';
wwv_flow_imp.g_varchar2_table(3038) := '6C6566743B223A22E286AB222C226C6F6F706172726F7772696768743B223A22E286AC222C226C6F7061723B223A22E2A685222C224C6F70663B223A22F09D9583222C226C6F70663B223A22F09D959D222C226C6F706C75733B223A22E2A8AD222C226C';
wwv_flow_imp.g_varchar2_table(3039) := '6F74696D65733B223A22E2A8B4222C226C6F776173743B223A22E28897222C226C6F776261723B223A225F222C224C6F7765724C6566744172726F773B223A22E28699222C224C6F77657252696768744172726F773B223A22E28698222C226C6F7A3B22';
wwv_flow_imp.g_varchar2_table(3040) := '3A22E2978A222C226C6F7A656E67653B223A22E2978A222C226C6F7A663B223A22E2A7AB222C226C7061723B223A2228222C226C7061726C743B223A22E2A693222C226C726172723B223A22E28786222C226C72636F726E65723B223A22E28C9F222C22';
wwv_flow_imp.g_varchar2_table(3041) := '6C726861723B223A22E2878B222C226C72686172643B223A22E2A5AD222C226C726D3B223A22E2808E222C226C727472693B223A22E28ABF222C226C736171756F3B223A22E280B9222C224C7363723B223A22E28492222C226C7363723B223A22F09D93';
wwv_flow_imp.g_varchar2_table(3042) := '81222C224C73683B223A22E286B0222C226C73683B223A22E286B0222C226C73696D3B223A22E289B2222C226C73696D653B223A22E2AA8D222C226C73696D673B223A22E2AA8F222C226C7371623B223A225B222C226C7371756F3B223A22E28098222C';
wwv_flow_imp.g_varchar2_table(3043) := '226C7371756F723B223A22E2809A222C224C7374726F6B3B223A22C581222C226C7374726F6B3B223A22C582222C224C543B223A223C222C4C543A223C222C224C743B223A22E289AA222C226C743B223A223C222C6C743A223C222C226C7463633B223A';
wwv_flow_imp.g_varchar2_table(3044) := '22E2AAA6222C226C746369723B223A22E2A9B9222C226C74646F743B223A22E28B96222C226C74687265653B223A22E28B8B222C226C74696D65733B223A22E28B89222C226C746C6172723B223A22E2A5B6222C226C7471756573743B223A22E2A9BB22';
wwv_flow_imp.g_varchar2_table(3045) := '2C226C7472693B223A22E29783222C226C747269653B223A22E28AB4222C226C747269663B223A22E29782222C226C74725061723B223A22E2A696222C226C757264736861723B223A22E2A58A222C226C7572756861723B223A22E2A5A6222C226C7665';
wwv_flow_imp.g_varchar2_table(3046) := '72746E6571713B223A22E289A8EFB880222C226C766E453B223A22E289A8EFB880222C226D6163723B223A22C2AF222C6D6163723A22C2AF222C226D616C653B223A22E29982222C226D616C743B223A22E29CA0222C226D616C746573653B223A22E29C';
wwv_flow_imp.g_varchar2_table(3047) := 'A0222C224D61703B223A22E2A485222C226D61703B223A22E286A6222C226D617073746F3B223A22E286A6222C226D617073746F646F776E3B223A22E286A7222C226D617073746F6C6566743B223A22E286A4222C226D617073746F75703B223A22E286';
wwv_flow_imp.g_varchar2_table(3048) := 'A5222C226D61726B65723B223A22E296AE222C226D636F6D6D613B223A22E2A8A9222C224D63793B223A22D09C222C226D63793B223A22D0BC222C226D646173683B223A22E28094222C226D44446F743B223A22E288BA222C226D65617375726564616E';
wwv_flow_imp.g_varchar2_table(3049) := '676C653B223A22E288A1222C224D656469756D53706163653B223A22E2819F222C224D656C6C696E7472663B223A22E284B3222C224D66723B223A22F09D9490222C226D66723B223A22F09D94AA222C226D686F3B223A22E284A7222C226D6963726F3B';
wwv_flow_imp.g_varchar2_table(3050) := '223A22C2B5222C6D6963726F3A22C2B5222C226D69643B223A22E288A3222C226D69646173743B223A222A222C226D69646369723B223A22E2ABB0222C226D6964646F743B223A22C2B7222C6D6964646F743A22C2B7222C226D696E75733B223A22E288';
wwv_flow_imp.g_varchar2_table(3051) := '92222C226D696E7573623B223A22E28A9F222C226D696E7573643B223A22E288B8222C226D696E757364753B223A22E2A8AA222C224D696E7573506C75733B223A22E28893222C226D6C63703B223A22E2AB9B222C226D6C64723B223A22E280A6222C22';
wwv_flow_imp.g_varchar2_table(3052) := '6D6E706C75733B223A22E28893222C226D6F64656C733B223A22E28AA7222C224D6F70663B223A22F09D9584222C226D6F70663B223A22F09D959E222C226D703B223A22E28893222C224D7363723B223A22E284B3222C226D7363723B223A22F09D9382';
wwv_flow_imp.g_varchar2_table(3053) := '222C226D7374706F733B223A22E288BE222C224D753B223A22CE9C222C226D753B223A22CEBC222C226D756C74696D61703B223A22E28AB8222C226D756D61703B223A22E28AB8222C226E61626C613B223A22E28887222C224E61637574653B223A22C5';
wwv_flow_imp.g_varchar2_table(3054) := '83222C226E61637574653B223A22C584222C226E616E673B223A22E288A0E28392222C226E61703B223A22E28989222C226E6170453B223A22E2A9B0CCB8222C226E617069643B223A22E2898BCCB8222C226E61706F733B223A22C589222C226E617070';
wwv_flow_imp.g_varchar2_table(3055) := '726F783B223A22E28989222C226E617475723B223A22E299AE222C226E61747572616C3B223A22E299AE222C226E61747572616C733B223A22E28495222C226E6273703B223A22C2A0222C6E6273703A22C2A0222C226E62756D703B223A22E2898ECCB8';
wwv_flow_imp.g_varchar2_table(3056) := '222C226E62756D70653B223A22E2898FCCB8222C226E6361703B223A22E2A983222C224E6361726F6E3B223A22C587222C226E6361726F6E3B223A22C588222C224E636564696C3B223A22C585222C226E636564696C3B223A22C586222C226E636F6E67';
wwv_flow_imp.g_varchar2_table(3057) := '3B223A22E28987222C226E636F6E67646F743B223A22E2A9ADCCB8222C226E6375703B223A22E2A982222C224E63793B223A22D09D222C226E63793B223A22D0BD222C226E646173683B223A22E28093222C226E653B223A22E289A0222C226E65617268';
wwv_flow_imp.g_varchar2_table(3058) := '6B3B223A22E2A4A4222C226E654172723B223A22E28797222C226E656172723B223A22E28697222C226E656172726F773B223A22E28697222C226E65646F743B223A22E28990CCB8222C224E656761746976654D656469756D53706163653B223A22E280';
wwv_flow_imp.g_varchar2_table(3059) := '8B222C224E65676174697665546869636B53706163653B223A22E2808B222C224E656761746976655468696E53706163653B223A22E2808B222C224E65676174697665566572795468696E53706163653B223A22E2808B222C226E65717569763B223A22';
wwv_flow_imp.g_varchar2_table(3060) := 'E289A2222C226E65736561723B223A22E2A4A8222C226E6573696D3B223A22E28982CCB8222C224E657374656447726561746572477265617465723B223A22E289AB222C224E65737465644C6573734C6573733B223A22E289AA222C224E65774C696E65';
wwv_flow_imp.g_varchar2_table(3061) := '3B223A225C6E222C226E65786973743B223A22E28884222C226E6578697374733B223A22E28884222C224E66723B223A22F09D9491222C226E66723B223A22F09D94AB222C226E67453B223A22E289A7CCB8222C226E67653B223A22E289B1222C226E67';
wwv_flow_imp.g_varchar2_table(3062) := '65713B223A22E289B1222C226E676571713B223A22E289A7CCB8222C226E676571736C616E743B223A22E2A9BECCB8222C226E6765733B223A22E2A9BECCB8222C226E47673B223A22E28B99CCB8222C226E6773696D3B223A22E289B5222C226E47743B';
wwv_flow_imp.g_varchar2_table(3063) := '223A22E289ABE28392222C226E67743B223A22E289AF222C226E6774723B223A22E289AF222C226E4774763B223A22E289ABCCB8222C226E684172723B223A22E2878E222C226E686172723B223A22E286AE222C226E687061723B223A22E2ABB2222C22';
wwv_flow_imp.g_varchar2_table(3064) := '6E693B223A22E2888B222C226E69733B223A22E28BBC222C226E6973643B223A22E28BBA222C226E69763B223A22E2888B222C224E4A63793B223A22D08A222C226E6A63793B223A22D19A222C226E6C4172723B223A22E2878D222C226E6C6172723B22';
wwv_flow_imp.g_varchar2_table(3065) := '3A22E2869A222C226E6C64723B223A22E280A5222C226E6C453B223A22E289A6CCB8222C226E6C653B223A22E289B0222C226E4C6566746172726F773B223A22E2878D222C226E6C6566746172726F773B223A22E2869A222C226E4C6566747269676874';
wwv_flow_imp.g_varchar2_table(3066) := '6172726F773B223A22E2878E222C226E6C65667472696768746172726F773B223A22E286AE222C226E6C65713B223A22E289B0222C226E6C6571713B223A22E289A6CCB8222C226E6C6571736C616E743B223A22E2A9BDCCB8222C226E6C65733B223A22';
wwv_flow_imp.g_varchar2_table(3067) := 'E2A9BDCCB8222C226E6C6573733B223A22E289AE222C226E4C6C3B223A22E28B98CCB8222C226E6C73696D3B223A22E289B4222C226E4C743B223A22E289AAE28392222C226E6C743B223A22E289AE222C226E6C7472693B223A22E28BAA222C226E6C74';
wwv_flow_imp.g_varchar2_table(3068) := '7269653B223A22E28BAC222C226E4C74763B223A22E289AACCB8222C226E6D69643B223A22E288A4222C224E6F427265616B3B223A22E281A0222C224E6F6E427265616B696E6753706163653B223A22C2A0222C224E6F70663B223A22E28495222C226E';
wwv_flow_imp.g_varchar2_table(3069) := '6F70663B223A22F09D959F222C224E6F743B223A22E2ABAC222C226E6F743B223A22C2AC222C6E6F743A22C2AC222C224E6F74436F6E677275656E743B223A22E289A2222C224E6F744375704361703B223A22E289AD222C224E6F74446F75626C655665';
wwv_flow_imp.g_varchar2_table(3070) := '72746963616C4261723B223A22E288A6222C224E6F74456C656D656E743B223A22E28889222C224E6F74457175616C3B223A22E289A0222C224E6F74457175616C54696C64653B223A22E28982CCB8222C224E6F744578697374733B223A22E28884222C';
wwv_flow_imp.g_varchar2_table(3071) := '224E6F74477265617465723B223A22E289AF222C224E6F7447726561746572457175616C3B223A22E289B1222C224E6F744772656174657246756C6C457175616C3B223A22E289A7CCB8222C224E6F7447726561746572477265617465723B223A22E289';
wwv_flow_imp.g_varchar2_table(3072) := 'ABCCB8222C224E6F74477265617465724C6573733B223A22E289B9222C224E6F7447726561746572536C616E74457175616C3B223A22E2A9BECCB8222C224E6F744772656174657254696C64653B223A22E289B5222C224E6F7448756D70446F776E4875';
wwv_flow_imp.g_varchar2_table(3073) := '6D703B223A22E2898ECCB8222C224E6F7448756D70457175616C3B223A22E2898FCCB8222C226E6F74696E3B223A22E28889222C226E6F74696E646F743B223A22E28BB5CCB8222C226E6F74696E453B223A22E28BB9CCB8222C226E6F74696E76613B22';
wwv_flow_imp.g_varchar2_table(3074) := '3A22E28889222C226E6F74696E76623B223A22E28BB7222C226E6F74696E76633B223A22E28BB6222C224E6F744C656674547269616E676C653B223A22E28BAA222C224E6F744C656674547269616E676C654261723B223A22E2A78FCCB8222C224E6F74';
wwv_flow_imp.g_varchar2_table(3075) := '4C656674547269616E676C65457175616C3B223A22E28BAC222C224E6F744C6573733B223A22E289AE222C224E6F744C657373457175616C3B223A22E289B0222C224E6F744C657373477265617465723B223A22E289B8222C224E6F744C6573734C6573';
wwv_flow_imp.g_varchar2_table(3076) := '733B223A22E289AACCB8222C224E6F744C657373536C616E74457175616C3B223A22E2A9BDCCB8222C224E6F744C65737354696C64653B223A22E289B4222C224E6F744E657374656447726561746572477265617465723B223A22E2AAA2CCB8222C224E';
wwv_flow_imp.g_varchar2_table(3077) := '6F744E65737465644C6573734C6573733B223A22E2AAA1CCB8222C226E6F746E693B223A22E2888C222C226E6F746E6976613B223A22E2888C222C226E6F746E6976623B223A22E28BBE222C226E6F746E6976633B223A22E28BBD222C224E6F74507265';
wwv_flow_imp.g_varchar2_table(3078) := '63656465733B223A22E28A80222C224E6F745072656365646573457175616C3B223A22E2AAAFCCB8222C224E6F745072656365646573536C616E74457175616C3B223A22E28BA0222C224E6F7452657665727365456C656D656E743B223A22E2888C222C';
wwv_flow_imp.g_varchar2_table(3079) := '224E6F745269676874547269616E676C653B223A22E28BAB222C224E6F745269676874547269616E676C654261723B223A22E2A790CCB8222C224E6F745269676874547269616E676C65457175616C3B223A22E28BAD222C224E6F745371756172655375';
wwv_flow_imp.g_varchar2_table(3080) := '627365743B223A22E28A8FCCB8222C224E6F74537175617265537562736574457175616C3B223A22E28BA2222C224E6F7453717561726553757065727365743B223A22E28A90CCB8222C224E6F745371756172655375706572736574457175616C3B223A';
wwv_flow_imp.g_varchar2_table(3081) := '22E28BA3222C224E6F745375627365743B223A22E28A82E28392222C224E6F74537562736574457175616C3B223A22E28A88222C224E6F7453756363656564733B223A22E28A81222C224E6F745375636365656473457175616C3B223A22E2AAB0CCB822';
wwv_flow_imp.g_varchar2_table(3082) := '2C224E6F745375636365656473536C616E74457175616C3B223A22E28BA1222C224E6F74537563636565647354696C64653B223A22E289BFCCB8222C224E6F7453757065727365743B223A22E28A83E28392222C224E6F74537570657273657445717561';
wwv_flow_imp.g_varchar2_table(3083) := '6C3B223A22E28A89222C224E6F7454696C64653B223A22E28981222C224E6F7454696C6465457175616C3B223A22E28984222C224E6F7454696C646546756C6C457175616C3B223A22E28987222C224E6F7454696C646554696C64653B223A22E2898922';
wwv_flow_imp.g_varchar2_table(3084) := '2C224E6F74566572746963616C4261723B223A22E288A4222C226E7061723B223A22E288A6222C226E706172616C6C656C3B223A22E288A6222C226E706172736C3B223A22E2ABBDE283A5222C226E706172743B223A22E28882CCB8222C226E706F6C69';
wwv_flow_imp.g_varchar2_table(3085) := '6E743B223A22E2A894222C226E70723B223A22E28A80222C226E70726375653B223A22E28BA0222C226E7072653B223A22E2AAAFCCB8222C226E707265633B223A22E28A80222C226E7072656365713B223A22E2AAAFCCB8222C226E724172723B223A22';
wwv_flow_imp.g_varchar2_table(3086) := 'E2878F222C226E726172723B223A22E2869B222C226E72617272633B223A22E2A4B3CCB8222C226E72617272773B223A22E2869DCCB8222C226E52696768746172726F773B223A22E2878F222C226E72696768746172726F773B223A22E2869B222C226E';
wwv_flow_imp.g_varchar2_table(3087) := '727472693B223A22E28BAB222C226E72747269653B223A22E28BAD222C226E73633B223A22E28A81222C226E73636375653B223A22E28BA1222C226E7363653B223A22E2AAB0CCB8222C224E7363723B223A22F09D92A9222C226E7363723B223A22F09D';
wwv_flow_imp.g_varchar2_table(3088) := '9383222C226E73686F72746D69643B223A22E288A4222C226E73686F7274706172616C6C656C3B223A22E288A6222C226E73696D3B223A22E28981222C226E73696D653B223A22E28984222C226E73696D65713B223A22E28984222C226E736D69643B22';
wwv_flow_imp.g_varchar2_table(3089) := '3A22E288A4222C226E737061723B223A22E288A6222C226E7371737562653B223A22E28BA2222C226E7371737570653B223A22E28BA3222C226E7375623B223A22E28A84222C226E737562453B223A22E2AB85CCB8222C226E737562653B223A22E28A88';
wwv_flow_imp.g_varchar2_table(3090) := '222C226E7375627365743B223A22E28A82E28392222C226E73756273657465713B223A22E28A88222C226E7375627365746571713B223A22E2AB85CCB8222C226E737563633B223A22E28A81222C226E7375636365713B223A22E2AAB0CCB8222C226E73';
wwv_flow_imp.g_varchar2_table(3091) := '75703B223A22E28A85222C226E737570453B223A22E2AB86CCB8222C226E737570653B223A22E28A89222C226E7375707365743B223A22E28A83E28392222C226E73757073657465713B223A22E28A89222C226E7375707365746571713B223A22E2AB86';
wwv_flow_imp.g_varchar2_table(3092) := 'CCB8222C226E74676C3B223A22E289B9222C224E74696C64653B223A22C391222C4E74696C64653A22C391222C226E74696C64653B223A22C3B1222C6E74696C64653A22C3B1222C226E746C673B223A22E289B8222C226E747269616E676C656C656674';
wwv_flow_imp.g_varchar2_table(3093) := '3B223A22E28BAA222C226E747269616E676C656C65667465713B223A22E28BAC222C226E747269616E676C6572696768743B223A22E28BAB222C226E747269616E676C65726967687465713B223A22E28BAD222C224E753B223A22CE9D222C226E753B22';
wwv_flow_imp.g_varchar2_table(3094) := '3A22CEBD222C226E756D3B223A2223222C226E756D65726F3B223A22E28496222C226E756D73703B223A22E28087222C226E7661703B223A22E2898DE28392222C226E56446173683B223A22E28AAF222C226E56646173683B223A22E28AAE222C226E76';
wwv_flow_imp.g_varchar2_table(3095) := '446173683B223A22E28AAD222C226E76646173683B223A22E28AAC222C226E7667653B223A22E289A5E28392222C226E7667743B223A223EE28392222C226E76486172723B223A22E2A484222C226E76696E66696E3B223A22E2A79E222C226E766C4172';
wwv_flow_imp.g_varchar2_table(3096) := '723B223A22E2A482222C226E766C653B223A22E289A4E28392222C226E766C743B223A223CE28392222C226E766C747269653B223A22E28AB4E28392222C226E76724172723B223A22E2A483222C226E7672747269653B223A22E28AB5E28392222C226E';
wwv_flow_imp.g_varchar2_table(3097) := '7673696D3B223A22E288BCE28392222C226E776172686B3B223A22E2A4A3222C226E774172723B223A22E28796222C226E776172723B223A22E28696222C226E776172726F773B223A22E28696222C226E776E6561723B223A22E2A4A7222C224F616375';
wwv_flow_imp.g_varchar2_table(3098) := '74653B223A22C393222C4F61637574653A22C393222C226F61637574653B223A22C3B3222C6F61637574653A22C3B3222C226F6173743B223A22E28A9B222C226F6369723B223A22E28A9A222C224F636972633B223A22C394222C4F636972633A22C394';
wwv_flow_imp.g_varchar2_table(3099) := '222C226F636972633B223A22C3B4222C6F636972633A22C3B4222C224F63793B223A22D09E222C226F63793B223A22D0BE222C226F646173683B223A22E28A9D222C224F64626C61633B223A22C590222C226F64626C61633B223A22C591222C226F6469';
wwv_flow_imp.g_varchar2_table(3100) := '763B223A22E2A8B8222C226F646F743B223A22E28A99222C226F64736F6C643B223A22E2A6BC222C224F456C69673B223A22C592222C226F656C69673B223A22C593222C226F666369723B223A22E2A6BF222C224F66723B223A22F09D9492222C226F66';
wwv_flow_imp.g_varchar2_table(3101) := '723B223A22F09D94AC222C226F676F6E3B223A22CB9B222C224F67726176653B223A22C392222C4F67726176653A22C392222C226F67726176653B223A22C3B2222C6F67726176653A22C3B2222C226F67743B223A22E2A781222C226F686261723B223A';
wwv_flow_imp.g_varchar2_table(3102) := '22E2A6B5222C226F686D3B223A22CEA9222C226F696E743B223A22E288AE222C226F6C6172723B223A22E286BA222C226F6C6369723B223A22E2A6BE222C226F6C63726F73733B223A22E2A6BB222C226F6C696E653B223A22E280BE222C226F6C743B22';
wwv_flow_imp.g_varchar2_table(3103) := '3A22E2A780222C224F6D6163723B223A22C58C222C226F6D6163723B223A22C58D222C224F6D6567613B223A22CEA9222C226F6D6567613B223A22CF89222C224F6D6963726F6E3B223A22CE9F222C226F6D6963726F6E3B223A22CEBF222C226F6D6964';
wwv_flow_imp.g_varchar2_table(3104) := '3B223A22E2A6B6222C226F6D696E75733B223A22E28A96222C224F6F70663B223A22F09D9586222C226F6F70663B223A22F09D95A0222C226F7061723B223A22E2A6B7222C224F70656E4375726C79446F75626C6551756F74653B223A22E2809C222C22';
wwv_flow_imp.g_varchar2_table(3105) := '4F70656E4375726C7951756F74653B223A22E28098222C226F706572703B223A22E2A6B9222C226F706C75733B223A22E28A95222C224F723B223A22E2A994222C226F723B223A22E288A8222C226F726172723B223A22E286BB222C226F72643B223A22';
wwv_flow_imp.g_varchar2_table(3106) := 'E2A99D222C226F726465723B223A22E284B4222C226F726465726F663B223A22E284B4222C226F7264663B223A22C2AA222C6F7264663A22C2AA222C226F72646D3B223A22C2BA222C6F72646D3A22C2BA222C226F7269676F663B223A22E28AB6222C22';
wwv_flow_imp.g_varchar2_table(3107) := '6F726F723B223A22E2A996222C226F72736C6F70653B223A22E2A997222C226F72763B223A22E2A99B222C226F533B223A22E29388222C224F7363723B223A22F09D92AA222C226F7363723B223A22E284B4222C224F736C6173683B223A22C398222C4F';
wwv_flow_imp.g_varchar2_table(3108) := '736C6173683A22C398222C226F736C6173683B223A22C3B8222C6F736C6173683A22C3B8222C226F736F6C3B223A22E28A98222C224F74696C64653B223A22C395222C4F74696C64653A22C395222C226F74696C64653B223A22C3B5222C6F74696C6465';
wwv_flow_imp.g_varchar2_table(3109) := '3A22C3B5222C224F74696D65733B223A22E2A8B7222C226F74696D65733B223A22E28A97222C226F74696D657361733B223A22E2A8B6222C224F756D6C3B223A22C396222C4F756D6C3A22C396222C226F756D6C3B223A22C3B6222C6F756D6C3A22C3B6';
wwv_flow_imp.g_varchar2_table(3110) := '222C226F766261723B223A22E28CBD222C224F7665724261723B223A22E280BE222C224F76657242726163653B223A22E28F9E222C224F766572427261636B65743B223A22E28EB4222C224F766572506172656E7468657369733B223A22E28F9C222C22';
wwv_flow_imp.g_varchar2_table(3111) := '7061723B223A22E288A5222C22706172613B223A22C2B6222C706172613A22C2B6222C22706172616C6C656C3B223A22E288A5222C2270617273696D3B223A22E2ABB3222C22706172736C3B223A22E2ABBD222C22706172743B223A22E28882222C2250';
wwv_flow_imp.g_varchar2_table(3112) := '61727469616C443B223A22E28882222C225063793B223A22D09F222C227063793B223A22D0BF222C22706572636E743B223A2225222C22706572696F643B223A222E222C227065726D696C3B223A22E280B0222C22706572703B223A22E28AA5222C2270';
wwv_flow_imp.g_varchar2_table(3113) := '657274656E6B3B223A22E280B1222C225066723B223A22F09D9493222C227066723B223A22F09D94AD222C225068693B223A22CEA6222C227068693B223A22CF86222C22706869763B223A22CF95222C2270686D6D61743B223A22E284B3222C2270686F';
wwv_flow_imp.g_varchar2_table(3114) := '6E653B223A22E2988E222C2250693B223A22CEA0222C2270693B223A22CF80222C227069746368666F726B3B223A22E28B94222C227069763B223A22CF96222C22706C616E636B3B223A22E2848F222C22706C616E636B683B223A22E2848E222C22706C';
wwv_flow_imp.g_varchar2_table(3115) := '616E6B763B223A22E2848F222C22706C75733B223A222B222C22706C7573616369723B223A22E2A8A3222C22706C7573623B223A22E28A9E222C22706C75736369723B223A22E2A8A2222C22706C7573646F3B223A22E28894222C22706C757364753B22';
wwv_flow_imp.g_varchar2_table(3116) := '3A22E2A8A5222C22706C7573653B223A22E2A9B2222C22506C75734D696E75733B223A22C2B1222C22706C75736D6E3B223A22C2B1222C706C75736D6E3A22C2B1222C22706C757373696D3B223A22E2A8A6222C22706C757374776F3B223A22E2A8A722';
wwv_flow_imp.g_varchar2_table(3117) := '2C22706D3B223A22C2B1222C22506F696E63617265706C616E653B223A22E2848C222C22706F696E74696E743B223A22E2A895222C22506F70663B223A22E28499222C22706F70663B223A22F09D95A1222C22706F756E643B223A22C2A3222C706F756E';
wwv_flow_imp.g_varchar2_table(3118) := '643A22C2A3222C2250723B223A22E2AABB222C2270723B223A22E289BA222C22707261703B223A22E2AAB7222C2270726375653B223A22E289BC222C227072453B223A22E2AAB3222C227072653B223A22E2AAAF222C22707265633B223A22E289BA222C';
wwv_flow_imp.g_varchar2_table(3119) := '2270726563617070726F783B223A22E2AAB7222C22707265636375726C7965713B223A22E289BC222C2250726563656465733B223A22E289BA222C225072656365646573457175616C3B223A22E2AAAF222C225072656365646573536C616E7445717561';
wwv_flow_imp.g_varchar2_table(3120) := '6C3B223A22E289BC222C22507265636564657354696C64653B223A22E289BE222C227072656365713B223A22E2AAAF222C22707265636E617070726F783B223A22E2AAB9222C22707265636E6571713B223A22E2AAB5222C22707265636E73696D3B223A';
wwv_flow_imp.g_varchar2_table(3121) := '22E28BA8222C227072656373696D3B223A22E289BE222C225072696D653B223A22E280B3222C227072696D653B223A22E280B2222C227072696D65733B223A22E28499222C2270726E61703B223A22E2AAB9222C2270726E453B223A22E2AAB5222C2270';
wwv_flow_imp.g_varchar2_table(3122) := '726E73696D3B223A22E28BA8222C2270726F643B223A22E2888F222C2250726F647563743B223A22E2888F222C2270726F66616C61723B223A22E28CAE222C2270726F666C696E653B223A22E28C92222C2270726F66737572663B223A22E28C93222C22';
wwv_flow_imp.g_varchar2_table(3123) := '70726F703B223A22E2889D222C2250726F706F7274696F6E3B223A22E288B7222C2250726F706F7274696F6E616C3B223A22E2889D222C2270726F70746F3B223A22E2889D222C22707273696D3B223A22E289BE222C2270727572656C3B223A22E28AB0';
wwv_flow_imp.g_varchar2_table(3124) := '222C22507363723B223A22F09D92AB222C22707363723B223A22F09D9385222C225073693B223A22CEA8222C227073693B223A22CF88222C2270756E6373703B223A22E28088222C225166723B223A22F09D9494222C227166723B223A22F09D94AE222C';
wwv_flow_imp.g_varchar2_table(3125) := '2271696E743B223A22E2A88C222C22516F70663B223A22E2849A222C22716F70663B223A22F09D95A2222C22717072696D653B223A22E28197222C22517363723B223A22F09D92AC222C22717363723B223A22F09D9386222C227175617465726E696F6E';
wwv_flow_imp.g_varchar2_table(3126) := '733B223A22E2848D222C2271756174696E743B223A22E2A896222C2271756573743B223A223F222C22717565737465713B223A22E2899F222C2251554F543B223A2722272C51554F543A2722272C2271756F743B223A2722272C71756F743A2722272C22';
wwv_flow_imp.g_varchar2_table(3127) := '72416172723B223A22E2879B222C22726163653B223A22E288BDCCB1222C225261637574653B223A22C594222C227261637574653B223A22C595222C2272616469633B223A22E2889A222C227261656D707479763B223A22E2A6B3222C2252616E673B22';
wwv_flow_imp.g_varchar2_table(3128) := '3A22E29FAB222C2272616E673B223A22E29FA9222C2272616E67643B223A22E2A692222C2272616E67653B223A22E2A6A5222C2272616E676C653B223A22E29FA9222C22726171756F3B223A22C2BB222C726171756F3A22C2BB222C22526172723B223A';
wwv_flow_imp.g_varchar2_table(3129) := '22E286A0222C22724172723B223A22E28792222C22726172723B223A22E28692222C227261727261703B223A22E2A5B5222C2272617272623B223A22E287A5222C22726172726266733B223A22E2A4A0222C2272617272633B223A22E2A4B3222C227261';
wwv_flow_imp.g_varchar2_table(3130) := '727266733B223A22E2A49E222C2272617272686B3B223A22E286AA222C22726172726C703B223A22E286AC222C2272617272706C3B223A22E2A585222C227261727273696D3B223A22E2A5B4222C2252617272746C3B223A22E2A496222C227261727274';
wwv_flow_imp.g_varchar2_table(3131) := '6C3B223A22E286A3222C2272617272773B223A22E2869D222C2272417461696C3B223A22E2A49C222C2272617461696C3B223A22E2A49A222C22726174696F3B223A22E288B6222C22726174696F6E616C733B223A22E2849A222C2252426172723B223A';
wwv_flow_imp.g_varchar2_table(3132) := '22E2A490222C2272426172723B223A22E2A48F222C2272626172723B223A22E2A48D222C22726262726B3B223A22E29DB3222C227262726163653B223A227D222C2272627261636B3B223A225D222C227262726B653B223A22E2A68C222C227262726B73';
wwv_flow_imp.g_varchar2_table(3133) := '6C643B223A22E2A68E222C227262726B736C753B223A22E2A690222C22526361726F6E3B223A22C598222C22726361726F6E3B223A22C599222C2252636564696C3B223A22C596222C2272636564696C3B223A22C597222C22726365696C3B223A22E28C';
wwv_flow_imp.g_varchar2_table(3134) := '89222C22726375623B223A227D222C225263793B223A22D0A0222C227263793B223A22D180222C22726463613B223A22E2A4B7222C2272646C646861723B223A22E2A5A9222C22726471756F3B223A22E2809D222C22726471756F723B223A22E2809D22';
wwv_flow_imp.g_varchar2_table(3135) := '2C22726473683B223A22E286B3222C2252653B223A22E2849C222C227265616C3B223A22E2849C222C227265616C696E653B223A22E2849B222C227265616C706172743B223A22E2849C222C227265616C733B223A22E2849D222C22726563743B223A22';
wwv_flow_imp.g_varchar2_table(3136) := 'E296AD222C225245473B223A22C2AE222C5245473A22C2AE222C227265673B223A22C2AE222C7265673A22C2AE222C2252657665727365456C656D656E743B223A22E2888B222C2252657665727365457175696C69627269756D3B223A22E2878B222C22';
wwv_flow_imp.g_varchar2_table(3137) := '526576657273655570457175696C69627269756D3B223A22E2A5AF222C227266697368743B223A22E2A5BD222C2272666C6F6F723B223A22E28C8B222C225266723B223A22E2849C222C227266723B223A22F09D94AF222C22724861723B223A22E2A5A4';
wwv_flow_imp.g_varchar2_table(3138) := '222C2272686172643B223A22E28781222C2272686172753B223A22E28780222C2272686172756C3B223A22E2A5AC222C2252686F3B223A22CEA1222C2272686F3B223A22CF81222C2272686F763B223A22CFB1222C225269676874416E676C6542726163';
wwv_flow_imp.g_varchar2_table(3139) := '6B65743B223A22E29FA9222C2252696768744172726F773B223A22E28692222C2252696768746172726F773B223A22E28792222C2272696768746172726F773B223A22E28692222C2252696768744172726F774261723B223A22E287A5222C2252696768';
wwv_flow_imp.g_varchar2_table(3140) := '744172726F774C6566744172726F773B223A22E28784222C2272696768746172726F777461696C3B223A22E286A3222C2252696768744365696C696E673B223A22E28C89222C225269676874446F75626C65427261636B65743B223A22E29FA7222C2252';
wwv_flow_imp.g_varchar2_table(3141) := '69676874446F776E546565566563746F723B223A22E2A59D222C225269676874446F776E566563746F723B223A22E28782222C225269676874446F776E566563746F724261723B223A22E2A595222C225269676874466C6F6F723B223A22E28C8B222C22';
wwv_flow_imp.g_varchar2_table(3142) := '7269676874686172706F6F6E646F776E3B223A22E28781222C227269676874686172706F6F6E75703B223A22E28780222C2272696768746C6566746172726F77733B223A22E28784222C2272696768746C656674686172706F6F6E733B223A22E2878C22';
wwv_flow_imp.g_varchar2_table(3143) := '2C22726967687472696768746172726F77733B223A22E28789222C22726967687473717569676172726F773B223A22E2869D222C2252696768745465653B223A22E28AA2222C2252696768745465654172726F773B223A22E286A6222C22526967687454';
wwv_flow_imp.g_varchar2_table(3144) := '6565566563746F723B223A22E2A59B222C227269676874746872656574696D65733B223A22E28B8C222C225269676874547269616E676C653B223A22E28AB3222C225269676874547269616E676C654261723B223A22E2A790222C225269676874547269';
wwv_flow_imp.g_varchar2_table(3145) := '616E676C65457175616C3B223A22E28AB5222C2252696768745570446F776E566563746F723B223A22E2A58F222C2252696768745570546565566563746F723B223A22E2A59C222C2252696768745570566563746F723B223A22E286BE222C2252696768';
wwv_flow_imp.g_varchar2_table(3146) := '745570566563746F724261723B223A22E2A594222C225269676874566563746F723B223A22E28780222C225269676874566563746F724261723B223A22E2A593222C2272696E673B223A22CB9A222C22726973696E67646F747365713B223A22E2899322';
wwv_flow_imp.g_varchar2_table(3147) := '2C22726C6172723B223A22E28784222C22726C6861723B223A22E2878C222C22726C6D3B223A22E2808F222C22726D6F7573743B223A22E28EB1222C22726D6F757374616368653B223A22E28EB1222C22726E6D69643B223A22E2ABAE222C22726F616E';
wwv_flow_imp.g_varchar2_table(3148) := '673B223A22E29FAD222C22726F6172723B223A22E287BE222C22726F62726B3B223A22E29FA7222C22726F7061723B223A22E2A686222C22526F70663B223A22E2849D222C22726F70663B223A22F09D95A3222C22726F706C75733B223A22E2A8AE222C';
wwv_flow_imp.g_varchar2_table(3149) := '22726F74696D65733B223A22E2A8B5222C22526F756E64496D706C6965733B223A22E2A5B0222C22727061723B223A2229222C227270617267743B223A22E2A694222C227270706F6C696E743B223A22E2A892222C2272726172723B223A22E28789222C';
wwv_flow_imp.g_varchar2_table(3150) := '225272696768746172726F773B223A22E2879B222C2272736171756F3B223A22E280BA222C22527363723B223A22E2849B222C22727363723B223A22F09D9387222C225273683B223A22E286B1222C227273683B223A22E286B1222C22727371623B223A';
wwv_flow_imp.g_varchar2_table(3151) := '225D222C22727371756F3B223A22E28099222C22727371756F723B223A22E28099222C227274687265653B223A22E28B8C222C227274696D65733B223A22E28B8A222C22727472693B223A22E296B9222C2272747269653B223A22E28AB5222C22727472';
wwv_flow_imp.g_varchar2_table(3152) := '69663B223A22E296B8222C22727472696C7472693B223A22E2A78E222C2252756C6544656C617965643B223A22E2A7B4222C2272756C756861723B223A22E2A5A8222C2272783B223A22E2849E222C225361637574653B223A22C59A222C227361637574';
wwv_flow_imp.g_varchar2_table(3153) := '653B223A22C59B222C22736271756F3B223A22E2809A222C2253633B223A22E2AABC222C2273633B223A22E289BB222C22736361703B223A22E2AAB8222C22536361726F6E3B223A22C5A0222C22736361726F6E3B223A22C5A1222C2273636375653B22';
wwv_flow_imp.g_varchar2_table(3154) := '3A22E289BD222C227363453B223A22E2AAB4222C227363653B223A22E2AAB0222C2253636564696C3B223A22C59E222C2273636564696C3B223A22C59F222C2253636972633B223A22C59C222C2273636972633B223A22C59D222C2273636E61703B223A';
wwv_flow_imp.g_varchar2_table(3155) := '22E2AABA222C2273636E453B223A22E2AAB6222C2273636E73696D3B223A22E28BA9222C227363706F6C696E743B223A22E2A893222C22736373696D3B223A22E289BF222C225363793B223A22D0A1222C227363793B223A22D181222C2273646F743B22';
wwv_flow_imp.g_varchar2_table(3156) := '3A22E28B85222C2273646F74623B223A22E28AA1222C2273646F74653B223A22E2A9A6222C2273656172686B3B223A22E2A4A5222C2273654172723B223A22E28798222C2273656172723B223A22E28698222C2273656172726F773B223A22E28698222C';
wwv_flow_imp.g_varchar2_table(3157) := '22736563743B223A22C2A7222C736563743A22C2A7222C2273656D693B223A223B222C227365737761723B223A22E2A4A9222C227365746D696E75733B223A22E28896222C227365746D6E3B223A22E28896222C22736578743B223A22E29CB6222C2253';
wwv_flow_imp.g_varchar2_table(3158) := '66723B223A22F09D9496222C227366723B223A22F09D94B0222C227366726F776E3B223A22E28CA2222C2273686172703B223A22E299AF222C225348434863793B223A22D0A9222C227368636863793B223A22D189222C22534863793B223A22D0A8222C';
wwv_flow_imp.g_varchar2_table(3159) := '22736863793B223A22D188222C2253686F7274446F776E4172726F773B223A22E28693222C2253686F72744C6566744172726F773B223A22E28690222C2273686F72746D69643B223A22E288A3222C2273686F7274706172616C6C656C3B223A22E288A5';
wwv_flow_imp.g_varchar2_table(3160) := '222C2253686F727452696768744172726F773B223A22E28692222C2253686F727455704172726F773B223A22E28691222C227368793B223A22C2AD222C7368793A22C2AD222C225369676D613B223A22CEA3222C227369676D613B223A22CF83222C2273';
wwv_flow_imp.g_varchar2_table(3161) := '69676D61663B223A22CF82222C227369676D61763B223A22CF82222C2273696D3B223A22E288BC222C2273696D646F743B223A22E2A9AA222C2273696D653B223A22E28983222C2273696D65713B223A22E28983222C2273696D673B223A22E2AA9E222C';
wwv_flow_imp.g_varchar2_table(3162) := '2273696D67453B223A22E2AAA0222C2273696D6C3B223A22E2AA9D222C2273696D6C453B223A22E2AA9F222C2273696D6E653B223A22E28986222C2273696D706C75733B223A22E2A8A4222C2273696D726172723B223A22E2A5B2222C22736C6172723B';
wwv_flow_imp.g_varchar2_table(3163) := '223A22E28690222C22536D616C6C436972636C653B223A22E28898222C22736D616C6C7365746D696E75733B223A22E28896222C22736D617368703B223A22E2A8B3222C22736D65706172736C3B223A22E2A7A4222C22736D69643B223A22E288A3222C';
wwv_flow_imp.g_varchar2_table(3164) := '22736D696C653B223A22E28CA3222C22736D743B223A22E2AAAA222C22736D74653B223A22E2AAAC222C22736D7465733B223A22E2AAACEFB880222C22534F465463793B223A22D0AC222C22736F667463793B223A22D18C222C22736F6C3B223A222F22';
wwv_flow_imp.g_varchar2_table(3165) := '2C22736F6C623B223A22E2A784222C22736F6C6261723B223A22E28CBF222C22536F70663B223A22F09D958A222C22736F70663B223A22F09D95A4222C227370616465733B223A22E299A0222C227370616465737569743B223A22E299A0222C22737061';
wwv_flow_imp.g_varchar2_table(3166) := '723B223A22E288A5222C2273716361703B223A22E28A93222C227371636170733B223A22E28A93EFB880222C2273716375703B223A22E28A94222C227371637570733B223A22E28A94EFB880222C22537172743B223A22E2889A222C2273717375623B22';
wwv_flow_imp.g_varchar2_table(3167) := '3A22E28A8F222C227371737562653B223A22E28A91222C2273717375627365743B223A22E28A8F222C22737173756273657465713B223A22E28A91222C2273717375703B223A22E28A90222C227371737570653B223A22E28A92222C2273717375707365';
wwv_flow_imp.g_varchar2_table(3168) := '743B223A22E28A90222C22737173757073657465713B223A22E28A92222C227371753B223A22E296A1222C225371756172653B223A22E296A1222C227371756172653B223A22E296A1222C22537175617265496E74657273656374696F6E3B223A22E28A';
wwv_flow_imp.g_varchar2_table(3169) := '93222C225371756172655375627365743B223A22E28A8F222C22537175617265537562736574457175616C3B223A22E28A91222C2253717561726553757065727365743B223A22E28A90222C225371756172655375706572736574457175616C3B223A22';
wwv_flow_imp.g_varchar2_table(3170) := 'E28A92222C22537175617265556E696F6E3B223A22E28A94222C227371756172663B223A22E296AA222C22737175663B223A22E296AA222C2273726172723B223A22E28692222C22537363723B223A22F09D92AE222C22737363723B223A22F09D938822';
wwv_flow_imp.g_varchar2_table(3171) := '2C22737365746D6E3B223A22E28896222C2273736D696C653B223A22E28CA3222C227373746172663B223A22E28B86222C22537461723B223A22E28B86222C22737461723B223A22E29886222C2273746172663B223A22E29885222C2273747261696768';
wwv_flow_imp.g_varchar2_table(3172) := '74657073696C6F6E3B223A22CFB5222C2273747261696768747068693B223A22CF95222C227374726E733B223A22C2AF222C225375623B223A22E28B90222C227375623B223A22E28A82222C22737562646F743B223A22E2AABD222C22737562453B223A';
wwv_flow_imp.g_varchar2_table(3173) := '22E2AB85222C22737562653B223A22E28A86222C2273756265646F743B223A22E2AB83222C227375626D756C743B223A22E2AB81222C227375626E453B223A22E2AB8B222C227375626E653B223A22E28A8A222C22737562706C75733B223A22E2AABF22';
wwv_flow_imp.g_varchar2_table(3174) := '2C22737562726172723B223A22E2A5B9222C225375627365743B223A22E28B90222C227375627365743B223A22E28A82222C2273756273657465713B223A22E28A86222C227375627365746571713B223A22E2AB85222C22537562736574457175616C3B';
wwv_flow_imp.g_varchar2_table(3175) := '223A22E28A86222C227375627365746E65713B223A22E28A8A222C227375627365746E6571713B223A22E2AB8B222C2273756273696D3B223A22E2AB87222C227375627375623B223A22E2AB95222C227375627375703B223A22E2AB93222C2273756363';
wwv_flow_imp.g_varchar2_table(3176) := '3B223A22E289BB222C2273756363617070726F783B223A22E2AAB8222C22737563636375726C7965713B223A22E289BD222C2253756363656564733B223A22E289BB222C225375636365656473457175616C3B223A22E2AAB0222C225375636365656473';
wwv_flow_imp.g_varchar2_table(3177) := '536C616E74457175616C3B223A22E289BD222C22537563636565647354696C64653B223A22E289BF222C227375636365713B223A22E2AAB0222C22737563636E617070726F783B223A22E2AABA222C22737563636E6571713B223A22E2AAB6222C227375';
wwv_flow_imp.g_varchar2_table(3178) := '63636E73696D3B223A22E28BA9222C227375636373696D3B223A22E289BF222C2253756368546861743B223A22E2888B222C2253756D3B223A22E28891222C2273756D3B223A22E28891222C2273756E673B223A22E299AA222C225375703B223A22E28B';
wwv_flow_imp.g_varchar2_table(3179) := '91222C227375703B223A22E28A83222C22737570313B223A22C2B9222C737570313A22C2B9222C22737570323B223A22C2B2222C737570323A22C2B2222C22737570333B223A22C2B3222C737570333A22C2B3222C22737570646F743B223A22E2AABE22';
wwv_flow_imp.g_varchar2_table(3180) := '2C22737570647375623B223A22E2AB98222C22737570453B223A22E2AB86222C22737570653B223A22E28A87222C2273757065646F743B223A22E2AB84222C2253757065727365743B223A22E28A83222C225375706572736574457175616C3B223A22E2';
wwv_flow_imp.g_varchar2_table(3181) := '8A87222C2273757068736F6C3B223A22E29F89222C22737570687375623B223A22E2AB97222C227375706C6172723B223A22E2A5BB222C227375706D756C743B223A22E2AB82222C227375706E453B223A22E2AB8C222C227375706E653B223A22E28A8B';
wwv_flow_imp.g_varchar2_table(3182) := '222C22737570706C75733B223A22E2AB80222C225375707365743B223A22E28B91222C227375707365743B223A22E28A83222C2273757073657465713B223A22E28A87222C227375707365746571713B223A22E2AB86222C227375707365746E65713B22';
wwv_flow_imp.g_varchar2_table(3183) := '3A22E28A8B222C227375707365746E6571713B223A22E2AB8C222C2273757073696D3B223A22E2AB88222C227375707375623B223A22E2AB94222C227375707375703B223A22E2AB96222C2273776172686B3B223A22E2A4A6222C2273774172723B223A';
wwv_flow_imp.g_varchar2_table(3184) := '22E28799222C2273776172723B223A22E28699222C2273776172726F773B223A22E28699222C2273776E7761723B223A22E2A4AA222C22737A6C69673B223A22C39F222C737A6C69673A22C39F222C225461623B223A225C74222C227461726765743B22';
wwv_flow_imp.g_varchar2_table(3185) := '3A22E28C96222C225461753B223A22CEA4222C227461753B223A22CF84222C227462726B3B223A22E28EB4222C22546361726F6E3B223A22C5A4222C22746361726F6E3B223A22C5A5222C2254636564696C3B223A22C5A2222C2274636564696C3B223A';
wwv_flow_imp.g_varchar2_table(3186) := '22C5A3222C225463793B223A22D0A2222C227463793B223A22D182222C2274646F743B223A22E2839B222C2274656C7265633B223A22E28C95222C225466723B223A22F09D9497222C227466723B223A22F09D94B1222C227468657265343B223A22E288';
wwv_flow_imp.g_varchar2_table(3187) := 'B4222C225468657265666F72653B223A22E288B4222C227468657265666F72653B223A22E288B4222C2254686574613B223A22CE98222C2274686574613B223A22CEB8222C22746865746173796D3B223A22CF91222C227468657461763B223A22CF9122';
wwv_flow_imp.g_varchar2_table(3188) := '2C22746869636B617070726F783B223A22E28988222C22746869636B73696D3B223A22E288BC222C22546869636B53706163653B223A22E2819FE2808A222C227468696E73703B223A22E28089222C225468696E53706163653B223A22E28089222C2274';
wwv_flow_imp.g_varchar2_table(3189) := '686B61703B223A22E28988222C2274686B73696D3B223A22E288BC222C2254484F524E3B223A22C39E222C54484F524E3A22C39E222C2274686F726E3B223A22C3BE222C74686F726E3A22C3BE222C2254696C64653B223A22E288BC222C2274696C6465';
wwv_flow_imp.g_varchar2_table(3190) := '3B223A22CB9C222C2254696C6465457175616C3B223A22E28983222C2254696C646546756C6C457175616C3B223A22E28985222C2254696C646554696C64653B223A22E28988222C2274696D65733B223A22C397222C74696D65733A22C397222C227469';
wwv_flow_imp.g_varchar2_table(3191) := '6D6573623B223A22E28AA0222C2274696D65736261723B223A22E2A8B1222C2274696D6573643B223A22E2A8B0222C2274696E743B223A22E288AD222C22746F65613B223A22E2A4A8222C22746F703B223A22E28AA4222C22746F70626F743B223A22E2';
wwv_flow_imp.g_varchar2_table(3192) := '8CB6222C22746F706369723B223A22E2ABB1222C22546F70663B223A22F09D958B222C22746F70663B223A22F09D95A5222C22746F70666F726B3B223A22E2AB9A222C22746F73613B223A22E2A4A9222C22747072696D653B223A22E280B4222C225452';
wwv_flow_imp.g_varchar2_table(3193) := '4144453B223A22E284A2222C2274726164653B223A22E284A2222C22747269616E676C653B223A22E296B5222C22747269616E676C65646F776E3B223A22E296BF222C22747269616E676C656C6566743B223A22E29783222C22747269616E676C656C65';
wwv_flow_imp.g_varchar2_table(3194) := '667465713B223A22E28AB4222C22747269616E676C65713B223A22E2899C222C22747269616E676C6572696768743B223A22E296B9222C22747269616E676C65726967687465713B223A22E28AB5222C22747269646F743B223A22E297AC222C22747269';
wwv_flow_imp.g_varchar2_table(3195) := '653B223A22E2899C222C227472696D696E75733B223A22E2A8BA222C22547269706C65446F743B223A22E2839B222C22747269706C75733B223A22E2A8B9222C2274726973623B223A22E2A78D222C2274726974696D653B223A22E2A8BB222C22747270';
wwv_flow_imp.g_varchar2_table(3196) := '657A69756D3B223A22E28FA2222C22547363723B223A22F09D92AF222C22747363723B223A22F09D9389222C22545363793B223A22D0A6222C22747363793B223A22D186222C2254534863793B223A22D08B222C2274736863793B223A22D19B222C2254';
wwv_flow_imp.g_varchar2_table(3197) := '7374726F6B3B223A22C5A6222C22747374726F6B3B223A22C5A7222C2274776978743B223A22E289AC222C2274776F686561646C6566746172726F773B223A22E2869E222C2274776F6865616472696768746172726F773B223A22E286A0222C22556163';
wwv_flow_imp.g_varchar2_table(3198) := '7574653B223A22C39A222C5561637574653A22C39A222C227561637574653B223A22C3BA222C7561637574653A22C3BA222C22556172723B223A22E2869F222C22754172723B223A22E28791222C22756172723B223A22E28691222C22556172726F6369';
wwv_flow_imp.g_varchar2_table(3199) := '723B223A22E2A589222C2255627263793B223A22D08E222C2275627263793B223A22D19E222C225562726576653B223A22C5AC222C227562726576653B223A22C5AD222C2255636972633B223A22C39B222C55636972633A22C39B222C2275636972633B';
wwv_flow_imp.g_varchar2_table(3200) := '223A22C3BB222C75636972633A22C3BB222C225563793B223A22D0A3222C227563793B223A22D183222C2275646172723B223A22E28785222C225564626C61633B223A22C5B0222C227564626C61633B223A22C5B1222C2275646861723B223A22E2A5AE';
wwv_flow_imp.g_varchar2_table(3201) := '222C227566697368743B223A22E2A5BE222C225566723B223A22F09D9498222C227566723B223A22F09D94B2222C225567726176653B223A22C399222C5567726176653A22C399222C227567726176653B223A22C3B9222C7567726176653A22C3B9222C';
wwv_flow_imp.g_varchar2_table(3202) := '22754861723B223A22E2A5A3222C22756861726C3B223A22E286BF222C2275686172723B223A22E286BE222C227568626C6B3B223A22E29680222C22756C636F726E3B223A22E28C9C222C22756C636F726E65723B223A22E28C9C222C22756C63726F70';
wwv_flow_imp.g_varchar2_table(3203) := '3B223A22E28C8F222C22756C7472693B223A22E297B8222C22556D6163723B223A22C5AA222C22756D6163723B223A22C5AB222C22756D6C3B223A22C2A8222C756D6C3A22C2A8222C22556E6465724261723B223A225F222C22556E6465724272616365';
wwv_flow_imp.g_varchar2_table(3204) := '3B223A22E28F9F222C22556E646572427261636B65743B223A22E28EB5222C22556E646572506172656E7468657369733B223A22E28F9D222C22556E696F6E3B223A22E28B83222C22556E696F6E506C75733B223A22E28A8E222C22556F676F6E3B223A';
wwv_flow_imp.g_varchar2_table(3205) := '22C5B2222C22756F676F6E3B223A22C5B3222C22556F70663B223A22F09D958C222C22756F70663B223A22F09D95A6222C2255704172726F773B223A22E28691222C2255706172726F773B223A22E28791222C2275706172726F773B223A22E28691222C';
wwv_flow_imp.g_varchar2_table(3206) := '2255704172726F774261723B223A22E2A492222C2255704172726F77446F776E4172726F773B223A22E28785222C225570446F776E4172726F773B223A22E28695222C225570646F776E6172726F773B223A22E28795222C227570646F776E6172726F77';
wwv_flow_imp.g_varchar2_table(3207) := '3B223A22E28695222C225570457175696C69627269756D3B223A22E2A5AE222C227570686172706F6F6E6C6566743B223A22E286BF222C227570686172706F6F6E72696768743B223A22E286BE222C2275706C75733B223A22E28A8E222C225570706572';
wwv_flow_imp.g_varchar2_table(3208) := '4C6566744172726F773B223A22E28696222C22557070657252696768744172726F773B223A22E28697222C22557073693B223A22CF92222C22757073693B223A22CF85222C2275707369683B223A22CF92222C22557073696C6F6E3B223A22CEA5222C22';
wwv_flow_imp.g_varchar2_table(3209) := '757073696C6F6E3B223A22CF85222C2255705465653B223A22E28AA5222C2255705465654172726F773B223A22E286A5222C22757075706172726F77733B223A22E28788222C227572636F726E3B223A22E28C9D222C227572636F726E65723B223A22E2';
wwv_flow_imp.g_varchar2_table(3210) := '8C9D222C22757263726F703B223A22E28C8E222C225572696E673B223A22C5AE222C227572696E673B223A22C5AF222C2275727472693B223A22E297B9222C22557363723B223A22F09D92B0222C22757363723B223A22F09D938A222C227574646F743B';
wwv_flow_imp.g_varchar2_table(3211) := '223A22E28BB0222C225574696C64653B223A22C5A8222C227574696C64653B223A22C5A9222C22757472693B223A22E296B5222C2275747269663B223A22E296B4222C2275756172723B223A22E28788222C2255756D6C3B223A22C39C222C55756D6C3A';
wwv_flow_imp.g_varchar2_table(3212) := '22C39C222C2275756D6C3B223A22C3BC222C75756D6C3A22C3BC222C227577616E676C653B223A22E2A6A7222C2276616E6772743B223A22E2A69C222C22766172657073696C6F6E3B223A22CFB5222C227661726B617070613B223A22CFB0222C227661';
wwv_flow_imp.g_varchar2_table(3213) := '726E6F7468696E673B223A22E28885222C227661727068693B223A22CF95222C2276617270693B223A22CF96222C2276617270726F70746F3B223A22E2889D222C22764172723B223A22E28795222C22766172723B223A22E28695222C2276617272686F';
wwv_flow_imp.g_varchar2_table(3214) := '3B223A22CFB1222C227661727369676D613B223A22CF82222C227661727375627365746E65713B223A22E28A8AEFB880222C227661727375627365746E6571713B223A22E2AB8BEFB880222C227661727375707365746E65713B223A22E28A8BEFB88022';
wwv_flow_imp.g_varchar2_table(3215) := '2C227661727375707365746E6571713B223A22E2AB8CEFB880222C2276617274686574613B223A22CF91222C22766172747269616E676C656C6566743B223A22E28AB2222C22766172747269616E676C6572696768743B223A22E28AB3222C2256626172';
wwv_flow_imp.g_varchar2_table(3216) := '3B223A22E2ABAB222C22764261723B223A22E2ABA8222C2276426172763B223A22E2ABA9222C225663793B223A22D092222C227663793B223A22D0B2222C2256446173683B223A22E28AAB222C2256646173683B223A22E28AA9222C2276446173683B22';
wwv_flow_imp.g_varchar2_table(3217) := '3A22E28AA8222C2276646173683B223A22E28AA2222C2256646173686C3B223A22E2ABA6222C225665653B223A22E28B81222C227665653B223A22E288A8222C227665656261723B223A22E28ABB222C2276656565713B223A22E2899A222C2276656C6C';
wwv_flow_imp.g_varchar2_table(3218) := '69703B223A22E28BAE222C225665726261723B223A22E28096222C227665726261723B223A227C222C22566572743B223A22E28096222C22766572743B223A227C222C22566572746963616C4261723B223A22E288A3222C22566572746963616C4C696E';
wwv_flow_imp.g_varchar2_table(3219) := '653B223A227C222C22566572746963616C536570617261746F723B223A22E29D98222C22566572746963616C54696C64653B223A22E28980222C22566572795468696E53706163653B223A22E2808A222C225666723B223A22F09D9499222C227666723B';
wwv_flow_imp.g_varchar2_table(3220) := '223A22F09D94B3222C22766C7472693B223A22E28AB2222C22766E7375623B223A22E28A82E28392222C22766E7375703B223A22E28A83E28392222C22566F70663B223A22F09D958D222C22766F70663B223A22F09D95A7222C227670726F703B223A22';
wwv_flow_imp.g_varchar2_table(3221) := 'E2889D222C2276727472693B223A22E28AB3222C22567363723B223A22F09D92B1222C22767363723B223A22F09D938B222C22767375626E453B223A22E2AB8BEFB880222C22767375626E653B223A22E28A8AEFB880222C22767375706E453B223A22E2';
wwv_flow_imp.g_varchar2_table(3222) := 'AB8CEFB880222C22767375706E653B223A22E28A8BEFB880222C225676646173683B223A22E28AAA222C22767A69677A61673B223A22E2A69A222C2257636972633B223A22C5B4222C2277636972633B223A22C5B5222C227765646261723B223A22E2A9';
wwv_flow_imp.g_varchar2_table(3223) := '9F222C2257656467653B223A22E28B80222C2277656467653B223A22E288A7222C227765646765713B223A22E28999222C227765696572703B223A22E28498222C225766723B223A22F09D949A222C227766723B223A22F09D94B4222C22576F70663B22';
wwv_flow_imp.g_varchar2_table(3224) := '3A22F09D958E222C22776F70663B223A22F09D95A8222C2277703B223A22E28498222C2277723B223A22E28980222C227772656174683B223A22E28980222C22577363723B223A22F09D92B2222C22777363723B223A22F09D938C222C22786361703B22';
wwv_flow_imp.g_varchar2_table(3225) := '3A22E28B82222C2278636972633B223A22E297AF222C22786375703B223A22E28B83222C2278647472693B223A22E296BD222C225866723B223A22F09D949B222C227866723B223A22F09D94B5222C2278684172723B223A22E29FBA222C227868617272';
wwv_flow_imp.g_varchar2_table(3226) := '3B223A22E29FB7222C2258693B223A22CE9E222C2278693B223A22CEBE222C22786C4172723B223A22E29FB8222C22786C6172723B223A22E29FB5222C22786D61703B223A22E29FBC222C22786E69733B223A22E28BBB222C22786F646F743B223A22E2';
wwv_flow_imp.g_varchar2_table(3227) := 'A880222C22586F70663B223A22F09D958F222C22786F70663B223A22F09D95A9222C22786F706C75733B223A22E2A881222C22786F74696D653B223A22E2A882222C2278724172723B223A22E29FB9222C2278726172723B223A22E29FB6222C22587363';
wwv_flow_imp.g_varchar2_table(3228) := '723B223A22F09D92B3222C22787363723B223A22F09D938D222C227873716375703B223A22E2A886222C227875706C75733B223A22E2A884222C2278757472693B223A22E296B3222C22787665653B223A22E28B81222C227877656467653B223A22E28B';
wwv_flow_imp.g_varchar2_table(3229) := '80222C225961637574653B223A22C39D222C5961637574653A22C39D222C227961637574653B223A22C3BD222C7961637574653A22C3BD222C22594163793B223A22D0AF222C22796163793B223A22D18F222C2259636972633B223A22C5B6222C227963';
wwv_flow_imp.g_varchar2_table(3230) := '6972633B223A22C5B7222C225963793B223A22D0AB222C227963793B223A22D18B222C2279656E3B223A22C2A5222C79656E3A22C2A5222C225966723B223A22F09D949C222C227966723B223A22F09D94B6222C22594963793B223A22D087222C227969';
wwv_flow_imp.g_varchar2_table(3231) := '63793B223A22D197222C22596F70663B223A22F09D9590222C22796F70663B223A22F09D95AA222C22597363723B223A22F09D92B4222C22797363723B223A22F09D938E222C22595563793B223A22D0AE222C22797563793B223A22D18E222C2259756D';
wwv_flow_imp.g_varchar2_table(3232) := '6C3B223A22C5B8222C2279756D6C3B223A22C3BF222C79756D6C3A22C3BF222C225A61637574653B223A22C5B9222C227A61637574653B223A22C5BA222C225A6361726F6E3B223A22C5BD222C227A6361726F6E3B223A22C5BE222C225A63793B223A22';
wwv_flow_imp.g_varchar2_table(3233) := 'D097222C227A63793B223A22D0B7222C225A646F743B223A22C5BB222C227A646F743B223A22C5BC222C227A65657472663B223A22E284A8222C225A65726F576964746853706163653B223A22E2808B222C225A6574613B223A22CE96222C227A657461';
wwv_flow_imp.g_varchar2_table(3234) := '3B223A22CEB6222C225A66723B223A22E284A8222C227A66723B223A22F09D94B7222C225A4863793B223A22D096222C227A6863793B223A22D0B6222C227A6967726172723B223A22E2879D222C225A6F70663B223A22E284A4222C227A6F70663B223A';
wwv_flow_imp.g_varchar2_table(3235) := '22F09D95AB222C225A7363723B223A22F09D92B5222C227A7363723B223A22F09D938F222C227A776A3B223A22E2808D222C227A776E6A3B223A22E2808C227D3B66756E6374696F6E20487328652C74297B696628652E6C656E6774683C742E6C656E67';
wwv_flow_imp.g_varchar2_table(3236) := '74682972657475726E21313B666F7228766172206E3D303B6E3C742E6C656E6774683B6E2B2B29696628655B6E5D213D3D745B6E5D2972657475726E21313B72657475726E21307D66756E6374696F6E20447328652C74297B666F7228766172206E3D22';
wwv_flow_imp.g_varchar2_table(3237) := '223B743E303B2931267E747C7C286E2B3D65292C652B3D652C743E3E3E3D313B72657475726E206E7D766172204F733D2261222E63686172436F646541742830292C57733D227A222E63686172436F646541742830292C50733D2241222E63686172436F';
wwv_flow_imp.g_varchar2_table(3238) := '646541742830292C71733D225A222E63686172436F646541742830292C46733D2230222E63686172436F646541742830292C42733D2239222E63686172436F646541742830293B66756E6374696F6E20567328652C74297B766172206E3D652E63686172';
wwv_flow_imp.g_varchar2_table(3239) := '436F646541742874293B72657475726E204F733C3D6E26266E3C3D57737C7C50733C3D6E26266E3C3D71737C7C46733C3D6E26266E3C3D42737D66756E6374696F6E204B732865297B72657475726E20766F69642030213D3D657D766172206A733D6675';
wwv_flow_imp.g_varchar2_table(3240) := '6E6374696F6E28297B66756E6374696F6E206528652C74297B766172206E3D746869733B746869732E69643D652C746869732E5F746167733D5B5D2C746869732E5F7461674D61703D7B7D2C746869732E5F76616C75655365744D61703D7B7D2C746869';
wwv_flow_imp.g_varchar2_table(3241) := '732E5F746167733D742E746167737C7C5B5D2C746869732E5F676C6F62616C417474726962757465733D742E676C6F62616C417474726962757465737C7C5B5D2C746869732E5F746167732E666F7245616368282866756E6374696F6E2865297B6E2E5F';
wwv_flow_imp.g_varchar2_table(3242) := '7461674D61705B652E6E616D652E746F4C6F7765724361736528295D3D657D29292C742E76616C7565536574732626742E76616C7565536574732E666F7245616368282866756E6374696F6E2865297B6E2E5F76616C75655365744D61705B652E6E616D';
wwv_flow_imp.g_varchar2_table(3243) := '655D3D652E76616C7565737D29297D72657475726E20652E70726F746F747970652E69734170706C696361626C653D66756E6374696F6E28297B72657475726E21307D2C652E70726F746F747970652E67657449643D66756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(3244) := '75726E20746869732E69647D2C652E70726F746F747970652E70726F76696465546167733D66756E6374696F6E28297B72657475726E20746869732E5F746167737D2C652E70726F746F747970652E70726F76696465417474726962757465733D66756E';
wwv_flow_imp.g_varchar2_table(3245) := '6374696F6E2865297B76617220743D5B5D2C6E3D66756E6374696F6E2865297B742E707573682865297D2C693D746869732E5F7461674D61705B652E746F4C6F7765724361736528295D3B72657475726E20692626692E617474726962757465732E666F';
wwv_flow_imp.g_varchar2_table(3246) := '7245616368286E292C746869732E5F676C6F62616C417474726962757465732E666F7245616368286E292C747D2C652E70726F746F747970652E70726F7669646556616C7565733D66756E6374696F6E28652C74297B766172206E3D746869732C693D5B';
wwv_flow_imp.g_varchar2_table(3247) := '5D3B743D742E746F4C6F7765724361736528293B76617220723D66756E6374696F6E2865297B652E666F7245616368282866756E6374696F6E2865297B652E6E616D652E746F4C6F7765724361736528293D3D3D74262628652E76616C7565732626652E';
wwv_flow_imp.g_varchar2_table(3248) := '76616C7565732E666F7245616368282866756E6374696F6E2865297B692E707573682865297D29292C652E76616C756553657426266E2E5F76616C75655365744D61705B652E76616C75655365745D26266E2E5F76616C75655365744D61705B652E7661';
wwv_flow_imp.g_varchar2_table(3249) := '6C75655365745D2E666F7245616368282866756E6374696F6E2865297B692E707573682865297D2929297D29297D2C6F3D746869732E5F7461674D61705B652E746F4C6F7765724361736528295D3B72657475726E206F262672286F2E61747472696275';
wwv_flow_imp.g_varchar2_table(3250) := '746573292C7228746869732E5F676C6F62616C41747472696275746573292C697D2C657D28293B66756E6374696F6E20477328652C742C6E297B766F696420303D3D3D74262628743D7B7D293B76617220693D7B6B696E643A6E3F226D61726B646F776E';
wwv_flow_imp.g_varchar2_table(3251) := '223A22706C61696E74657874222C76616C75653A22227D3B696628652E6465736372697074696F6E26262131213D3D742E646F63756D656E746174696F6E297B76617220723D66756E6374696F6E2865297B696628652972657475726E22737472696E67';
wwv_flow_imp.g_varchar2_table(3252) := '223D3D747970656F6620653F7B6B696E643A226D61726B646F776E222C76616C75653A657D3A7B6B696E643A226D61726B646F776E222C76616C75653A652E76616C75657D7D28652E6465736372697074696F6E293B72262628692E76616C75652B3D72';
wwv_flow_imp.g_varchar2_table(3253) := '2E76616C7565297D696628652E7265666572656E6365732626652E7265666572656E6365732E6C656E6774683E3026262131213D3D742E7265666572656E636573262628692E76616C75652E6C656E677468262628692E76616C75652B3D225C6E5C6E22';
wwv_flow_imp.g_varchar2_table(3254) := '292C692E76616C75652B3D6E3F652E7265666572656E6365732E6D6170282866756E6374696F6E2865297B72657475726E225B222E636F6E63617428652E6E616D652C225D2822292E636F6E63617428652E75726C2C222922297D29292E6A6F696E2822';
wwv_flow_imp.g_varchar2_table(3255) := '207C2022293A652E7265666572656E6365732E6D6170282866756E6374696F6E2865297B72657475726E22222E636F6E63617428652E6E616D652C223A2022292E636F6E63617428652E75726C297D29292E6A6F696E28225C6E2229292C2222213D3D69';
wwv_flow_imp.g_varchar2_table(3256) := '2E76616C75652972657475726E20697D7661722024733D66756E6374696F6E28652C742C6E2C69297B72657475726E206E6577286E7C7C286E3D50726F6D6973652929282866756E6374696F6E28722C6F297B66756E6374696F6E20612865297B747279';
wwv_flow_imp.g_varchar2_table(3257) := '7B6C28692E6E657874286529297D63617463682865297B6F2865297D7D66756E6374696F6E20732865297B7472797B6C28692E7468726F77286529297D63617463682865297B6F2865297D7D66756E6374696F6E206C2865297B76617220743B652E646F';
wwv_flow_imp.g_varchar2_table(3258) := '6E653F7228652E76616C7565293A28743D652E76616C75652C7420696E7374616E63656F66206E3F743A6E6577206E282866756E6374696F6E2865297B652874297D2929292E7468656E28612C73297D6C2828693D692E6170706C7928652C747C7C5B5D';
wwv_flow_imp.g_varchar2_table(3259) := '29292E6E6578742829297D29297D2C58733D66756E6374696F6E28652C74297B766172206E2C692C722C6F2C613D7B6C6162656C3A302C73656E743A66756E6374696F6E28297B6966283126725B305D297468726F7720725B315D3B72657475726E2072';
wwv_flow_imp.g_varchar2_table(3260) := '5B315D7D2C747279733A5B5D2C6F70733A5B5D7D3B72657475726E206F3D7B6E6578743A732830292C7468726F773A732831292C72657475726E3A732832297D2C2266756E6374696F6E223D3D747970656F662053796D626F6C2626286F5B53796D626F';
wwv_flow_imp.g_varchar2_table(3261) := '6C2E6974657261746F725D3D66756E6374696F6E28297B72657475726E20746869737D292C6F3B66756E6374696F6E2073286F297B72657475726E2066756E6374696F6E2873297B72657475726E2066756E6374696F6E286F297B6966286E297468726F';
wwv_flow_imp.g_varchar2_table(3262) := '77206E657720547970654572726F72282247656E657261746F7220697320616C726561647920657865637574696E672E22293B666F72283B613B297472797B6966286E3D312C69262628723D32266F5B305D3F692E72657475726E3A6F5B305D3F692E74';
wwv_flow_imp.g_varchar2_table(3263) := '68726F777C7C2828723D692E72657475726E292626722E63616C6C2869292C30293A692E6E6578742926262128723D722E63616C6C28692C6F5B315D29292E646F6E652972657475726E20723B73776974636828693D302C722626286F3D5B32266F5B30';
wwv_flow_imp.g_varchar2_table(3264) := '5D2C722E76616C75655D292C6F5B305D297B6361736520303A6361736520313A723D6F3B627265616B3B6361736520343A72657475726E20612E6C6162656C2B2B2C7B76616C75653A6F5B315D2C646F6E653A21317D3B6361736520353A612E6C616265';
wwv_flow_imp.g_varchar2_table(3265) := '6C2B2B2C693D6F5B315D2C6F3D5B305D3B636F6E74696E75653B6361736520373A6F3D612E6F70732E706F7028292C612E747279732E706F7028293B636F6E74696E75653B64656661756C743A696628212828723D28723D612E74727973292E6C656E67';
wwv_flow_imp.g_varchar2_table(3266) := '74683E302626725B722E6C656E6774682D315D297C7C36213D3D6F5B305D262632213D3D6F5B305D29297B613D303B636F6E74696E75657D696628333D3D3D6F5B305D26262821727C7C6F5B315D3E725B305D26266F5B315D3C725B335D29297B612E6C';
wwv_flow_imp.g_varchar2_table(3267) := '6162656C3D6F5B315D3B627265616B7D696628363D3D3D6F5B305D2626612E6C6162656C3C725B315D297B612E6C6162656C3D725B315D2C723D6F3B627265616B7D696628722626612E6C6162656C3C725B325D297B612E6C6162656C3D725B325D2C61';
wwv_flow_imp.g_varchar2_table(3268) := '2E6F70732E70757368286F293B627265616B7D725B325D2626612E6F70732E706F7028292C612E747279732E706F7028293B636F6E74696E75657D6F3D742E63616C6C28652C61297D63617463682865297B6F3D5B362C655D2C693D307D66696E616C6C';
wwv_flow_imp.g_varchar2_table(3269) := '797B6E3D723D307D69662835266F5B305D297468726F77206F5B315D3B72657475726E7B76616C75653A6F5B305D3F6F5B315D3A766F696420302C646F6E653A21307D7D285B6F2C735D297D7D7D2C4A733D66756E6374696F6E28297B66756E6374696F';
wwv_flow_imp.g_varchar2_table(3270) := '6E20652865297B746869732E726561644469726563746F72793D652C746869732E6174726962757465436F6D706C6574696F6E733D5B5D7D72657475726E20652E70726F746F747970652E6F6E48746D6C41747472696275746556616C75653D66756E63';
wwv_flow_imp.g_varchar2_table(3271) := '74696F6E2865297B2866756E6374696F6E28652C74297B69662822737263223D3D3D747C7C2268726566223D3D3D742972657475726E21303B766172206E3D656C5B655D3B72657475726E21216E26262822737472696E67223D3D747970656F66206E3F';
wwv_flow_imp.g_varchar2_table(3272) := '6E3D3D3D743A2D31213D3D6E2E696E6465784F66287429297D2928652E7461672C652E617474726962757465292626746869732E6174726962757465436F6D706C6574696F6E732E707573682865297D2C652E70726F746F747970652E636F6D70757465';
wwv_flow_imp.g_varchar2_table(3273) := '436F6D706C6574696F6E733D66756E6374696F6E28652C74297B72657475726E20247328746869732C766F696420302C766F696420302C2866756E6374696F6E28297B766172206E2C692C722C6F2C612C732C6C2C682C632C643B72657475726E205873';
wwv_flow_imp.g_varchar2_table(3274) := '28746869732C2866756E6374696F6E2875297B73776974636828752E6C6162656C297B6361736520303A6E3D7B6974656D733A5B5D2C6973496E636F6D706C6574653A21317D2C693D302C723D746869732E6174726962757465436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(3275) := '732C752E6C6162656C3D313B6361736520313A72657475726E20693C722E6C656E6774683F286F3D725B695D2C6D3D613D66756E6374696F6E2865297B72657475726E20487328652C222722297C7C487328652C272227293F652E736C69636528312C2D';
wwv_flow_imp.g_varchar2_table(3276) := '31293A657D28652E67657454657874286F2E72616E676529292C4873286D2C226874747022297C7C4873286D2C22687474707322297C7C4873286D2C222F2F22293F5B332C345D3A222E22213D3D612626222E2E22213D3D613F5B332C325D3A286E2E69';
wwv_flow_imp.g_varchar2_table(3277) := '73496E636F6D706C6574653D21302C5B332C345D29293A5B332C355D3B6361736520323A72657475726E20733D66756E6374696F6E28652C742C6E297B76617220692C723D652E6C617374496E6465784F6628222F22293B6966282D313D3D3D7229693D';
wwv_flow_imp.g_varchar2_table(3278) := '66756E6374696F6E2865297B76617220743D5A7328652E73746172742C31292C6E3D5A7328652E656E642C2D31293B72657475726E20616F2E63726561746528742C6E297D286E293B656C73657B766172206F2C613D742E736C69636528722B31292C73';
wwv_flow_imp.g_varchar2_table(3279) := '3D5A73286E2E656E642C2D312D612E6C656E677468292C6C3D612E696E6465784F6628222022293B6F3D2D31213D3D6C3F5A7328732C6C293A5A73286E2E656E642C2D31292C693D616F2E63726561746528732C6F297D72657475726E20697D286F2E76';
wwv_flow_imp.g_varchar2_table(3280) := '616C75652C612C6F2E72616E6765292C5B342C746869732E70726F766964655061746853756767657374696F6E73286F2E76616C75652C732C652C74295D3B6361736520333A666F72286C3D752E73656E7428292C683D302C633D6C3B683C632E6C656E';
wwv_flow_imp.g_varchar2_table(3281) := '6774683B682B2B29643D635B685D2C6E2E6974656D732E707573682864293B752E6C6162656C3D343B6361736520343A72657475726E20692B2B2C5B332C315D3B6361736520353A72657475726E5B322C6E5D7D766172206D7D29297D29297D2C652E70';
wwv_flow_imp.g_varchar2_table(3282) := '726F746F747970652E70726F766964655061746853756767657374696F6E733D66756E6374696F6E28652C742C6E2C69297B72657475726E20247328746869732C766F696420302C766F696420302C2866756E6374696F6E28297B76617220722C6F2C61';
wwv_flow_imp.g_varchar2_table(3283) := '2C732C6C2C682C632C642C753B72657475726E20587328746869732C2866756E6374696F6E286D297B737769746368286D2E6C6162656C297B6361736520303A696628723D652E737562737472696E6728302C652E6C617374496E6465784F6628222F22';
wwv_flow_imp.g_varchar2_table(3284) := '292B31292C21286F3D692E7265736F6C76655265666572656E636528727C7C222E222C6E2E75726929292972657475726E5B332C345D3B6D2E6C6162656C3D313B6361736520313A72657475726E206D2E747279732E70757368285B312C332C2C345D29';
wwv_flow_imp.g_varchar2_table(3285) := '2C613D5B5D2C5B342C746869732E726561644469726563746F7279286F295D3B6361736520323A666F7228733D6D2E73656E7428292C6C3D302C683D733B6C3C682E6C656E6774683B6C2B2B29633D685B6C5D2C643D635B305D2C753D635B315D2C642E';
wwv_flow_imp.g_varchar2_table(3286) := '63686172436F64654174283029213D3D59732626612E7075736828517328642C753D3D3D61732E4469726563746F72792C7429293B72657475726E5B322C615D3B6361736520333A72657475726E206D2E73656E7428292C5B332C345D3B636173652034';
wwv_flow_imp.g_varchar2_table(3287) := '3A72657475726E5B322C5B5D5D7D7D29297D29297D2C657D28292C59733D222E222E63686172436F646541742830293B66756E6374696F6E20517328652C742C6E297B72657475726E20743F7B6C6162656C3A652B3D222F222C6B696E643A73612E466F';
wwv_flow_imp.g_varchar2_table(3288) := '6C6465722C74657874456469743A7A6F2E7265706C616365286E2C65292C636F6D6D616E643A7B7469746C653A2253756767657374222C636F6D6D616E643A22656469746F722E616374696F6E2E7472696767657253756767657374227D7D3A7B6C6162';
wwv_flow_imp.g_varchar2_table(3289) := '656C3A652C6B696E643A73612E46696C652C74657874456469743A7A6F2E7265706C616365286E2C65297D7D66756E6374696F6E205A7328652C74297B72657475726E20726F2E63726561746528652E6C696E652C652E6368617261637465722B74297D';
wwv_flow_imp.g_varchar2_table(3290) := '76617220656C3D7B613A2268726566222C617265613A2268726566222C626F64793A226261636B67726F756E64222C64656C3A2263697465222C666F726D3A22616374696F6E222C6672616D653A5B22737263222C226C6F6E6764657363225D2C696D67';
wwv_flow_imp.g_varchar2_table(3291) := '3A5B22737263222C226C6F6E6764657363225D2C696E733A2263697465222C6C696E6B3A2268726566222C6F626A6563743A2264617461222C713A2263697465222C7363726970743A22737263222C617564696F3A22737263222C627574746F6E3A2266';
wwv_flow_imp.g_varchar2_table(3292) := '6F726D616374696F6E222C636F6D6D616E643A2269636F6E222C656D6265643A22737263222C68746D6C3A226D616E6966657374222C696E7075743A5B22737263222C22666F726D616374696F6E225D2C736F757263653A22737263222C747261636B3A';
wwv_flow_imp.g_varchar2_table(3293) := '22737263222C766964656F3A5B22737263222C22706F73746572225D7D2C746C3D5A7228292C6E6C3D66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E6C734F7074696F6E733D652C746869732E646174614D616E616765';
wwv_flow_imp.g_varchar2_table(3294) := '723D742C746869732E636F6D706C6574696F6E5061727469636970616E74733D5B5D7D72657475726E20652E70726F746F747970652E736574436F6D706C6574696F6E5061727469636970616E74733D66756E6374696F6E2865297B746869732E636F6D';
wwv_flow_imp.g_varchar2_table(3295) := '706C6574696F6E5061727469636970616E74733D657C7C5B5D7D2C652E70726F746F747970652E646F436F6D706C657465323D66756E6374696F6E28652C742C6E2C692C72297B72657475726E206F3D746869732C613D766F696420302C6C3D66756E63';
wwv_flow_imp.g_varchar2_table(3296) := '74696F6E28297B766172206F2C612C732C6C3B72657475726E2066756E6374696F6E28652C74297B766172206E2C692C722C6F2C613D7B6C6162656C3A302C73656E743A66756E6374696F6E28297B6966283126725B305D297468726F7720725B315D3B';
wwv_flow_imp.g_varchar2_table(3297) := '72657475726E20725B315D7D2C747279733A5B5D2C6F70733A5B5D7D3B72657475726E206F3D7B6E6578743A732830292C7468726F773A732831292C72657475726E3A732832297D2C2266756E6374696F6E223D3D747970656F662053796D626F6C2626';
wwv_flow_imp.g_varchar2_table(3298) := '286F5B53796D626F6C2E6974657261746F725D3D66756E6374696F6E28297B72657475726E20746869737D292C6F3B66756E6374696F6E2073286F297B72657475726E2066756E6374696F6E2873297B72657475726E2066756E6374696F6E286F297B69';
wwv_flow_imp.g_varchar2_table(3299) := '66286E297468726F77206E657720547970654572726F72282247656E657261746F7220697320616C726561647920657865637574696E672E22293B666F72283B613B297472797B6966286E3D312C69262628723D32266F5B305D3F692E72657475726E3A';
wwv_flow_imp.g_varchar2_table(3300) := '6F5B305D3F692E7468726F777C7C2828723D692E72657475726E292626722E63616C6C2869292C30293A692E6E6578742926262128723D722E63616C6C28692C6F5B315D29292E646F6E652972657475726E20723B73776974636828693D302C72262628';
wwv_flow_imp.g_varchar2_table(3301) := '6F3D5B32266F5B305D2C722E76616C75655D292C6F5B305D297B6361736520303A6361736520313A723D6F3B627265616B3B6361736520343A72657475726E20612E6C6162656C2B2B2C7B76616C75653A6F5B315D2C646F6E653A21317D3B6361736520';
wwv_flow_imp.g_varchar2_table(3302) := '353A612E6C6162656C2B2B2C693D6F5B315D2C6F3D5B305D3B636F6E74696E75653B6361736520373A6F3D612E6F70732E706F7028292C612E747279732E706F7028293B636F6E74696E75653B64656661756C743A696628212828723D28723D612E7472';
wwv_flow_imp.g_varchar2_table(3303) := '7973292E6C656E6774683E302626725B722E6C656E6774682D315D297C7C36213D3D6F5B305D262632213D3D6F5B305D29297B613D303B636F6E74696E75657D696628333D3D3D6F5B305D26262821727C7C6F5B315D3E725B305D26266F5B315D3C725B';
wwv_flow_imp.g_varchar2_table(3304) := '335D29297B612E6C6162656C3D6F5B315D3B627265616B7D696628363D3D3D6F5B305D2626612E6C6162656C3C725B315D297B612E6C6162656C3D725B315D2C723D6F3B627265616B7D696628722626612E6C6162656C3C725B325D297B612E6C616265';
wwv_flow_imp.g_varchar2_table(3305) := '6C3D725B325D2C612E6F70732E70757368286F293B627265616B7D725B325D2626612E6F70732E706F7028292C612E747279732E706F7028293B636F6E74696E75657D6F3D742E63616C6C28652C61297D63617463682865297B6F3D5B362C655D2C693D';
wwv_flow_imp.g_varchar2_table(3306) := '307D66696E616C6C797B6E3D723D307D69662835266F5B305D297468726F77206F5B315D3B72657475726E7B76616C75653A6F5B305D3F6F5B315D3A766F696420302C646F6E653A21307D7D285B6F2C735D297D7D7D28746869732C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(3307) := '6E2868297B73776974636828682E6C6162656C297B6361736520303A69662821746869732E6C734F7074696F6E732E66696C6553797374656D50726F76696465727C7C21746869732E6C734F7074696F6E732E66696C6553797374656D50726F76696465';
wwv_flow_imp.g_varchar2_table(3308) := '722E726561644469726563746F72792972657475726E5B322C746869732E646F436F6D706C65746528652C742C6E2C72295D3B6F3D6E6577204A7328746869732E6C734F7074696F6E732E66696C6553797374656D50726F76696465722E726561644469';
wwv_flow_imp.g_varchar2_table(3309) := '726563746F7279292C613D746869732E636F6D706C6574696F6E5061727469636970616E74732C746869732E636F6D706C6574696F6E5061727469636970616E74733D5B6F5D2E636F6E6361742861292C733D746869732E646F436F6D706C6574652865';
wwv_flow_imp.g_varchar2_table(3310) := '2C742C6E2C72292C682E6C6162656C3D313B6361736520313A72657475726E20682E747279732E70757368285B312C2C332C345D292C5B342C6F2E636F6D70757465436F6D706C6574696F6E7328652C69295D3B6361736520323A72657475726E206C3D';
wwv_flow_imp.g_varchar2_table(3311) := '682E73656E7428292C5B322C7B6973496E636F6D706C6574653A732E6973496E636F6D706C6574657C7C6C2E6973496E636F6D706C6574652C6974656D733A6C2E6974656D732E636F6E63617428732E6974656D73297D5D3B6361736520333A72657475';
wwv_flow_imp.g_varchar2_table(3312) := '726E20746869732E636F6D706C6574696F6E5061727469636970616E74733D612C5B375D3B6361736520343A72657475726E5B325D7D7D29297D2C6E65772828733D766F69642030297C7C28733D50726F6D6973652929282866756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(3313) := '74297B66756E6374696F6E206E2865297B7472797B72286C2E6E657874286529297D63617463682865297B742865297D7D66756E6374696F6E20692865297B7472797B72286C2E7468726F77286529297D63617463682865297B742865297D7D66756E63';
wwv_flow_imp.g_varchar2_table(3314) := '74696F6E20722874297B76617220723B742E646F6E653F6528742E76616C7565293A28723D742E76616C75652C7220696E7374616E63656F6620733F723A6E65772073282866756E6374696F6E2865297B652872297D2929292E7468656E286E2C69297D';
wwv_flow_imp.g_varchar2_table(3315) := '7228286C3D6C2E6170706C79286F2C617C7C5B5D29292E6E6578742829297D29293B766172206F2C612C732C6C7D2C652E70726F746F747970652E646F436F6D706C6574653D66756E6374696F6E28652C742C6E2C69297B76617220723D746869732E5F';
wwv_flow_imp.g_varchar2_table(3316) := '646F436F6D706C65746528652C742C6E2C69293B72657475726E20746869732E636F6E76657274436F6D706C6574696F6E4C6973742872297D2C652E70726F746F747970652E5F646F436F6D706C6574653D66756E6374696F6E28652C742C6E2C69297B';
wwv_flow_imp.g_varchar2_table(3317) := '76617220723D7B6973496E636F6D706C6574653A21312C6974656D733A5B5D7D2C6F3D746869732E636F6D706C6574696F6E5061727469636970616E74732C613D746869732E646174614D616E616765722E6765744461746150726F7669646572732829';
wwv_flow_imp.g_varchar2_table(3318) := '2E66696C746572282866756E6374696F6E2874297B72657475726E20742E69734170706C696361626C6528652E6C616E677561676549642926262821697C7C2131213D3D695B742E676574496428295D297D29292C733D746869732E646F657353757070';
wwv_flow_imp.g_varchar2_table(3319) := '6F72744D61726B646F776E28292C6C3D652E6765745465787428292C683D652E6F666673657441742874292C633D6E2E66696E644E6F64654265666F72652868293B69662821632972657475726E20723B76617220642C752C6D3D4173286C2C632E7374';
wwv_flow_imp.g_varchar2_table(3320) := '617274292C703D22223B66756E6374696F6E206628742C6E297B72657475726E20766F696420303D3D3D6E2626286E3D68292C743E68262628743D68292C7B73746172743A652E706F736974696F6E41742874292C656E643A652E706F736974696F6E41';
wwv_flow_imp.g_varchar2_table(3321) := '74286E297D7D66756E6374696F6E206728652C74297B766172206E3D6628652C74293B72657475726E20612E666F7245616368282866756E6374696F6E2865297B652E70726F766964655461677328292E666F7245616368282866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(3322) := '297B722E6974656D732E70757368287B6C6162656C3A652E6E616D652C6B696E643A73612E50726F70657274792C646F63756D656E746174696F6E3A477328652C766F696420302C73292C74657874456469743A7A6F2E7265706C616365286E2C652E6E';
wwv_flow_imp.g_varchar2_table(3323) := '616D65292C696E7365727454657874466F726D61743A68612E506C61696E546578747D297D29297D29292C727D66756E6374696F6E20622865297B666F722876617220743D653B743E303B297B766172206E3D6C2E63686172417428742D31293B696628';
wwv_flow_imp.g_varchar2_table(3324) := '225C6E5C72222E696E6465784F66286E293E3D302972657475726E206C2E737562737472696E6728742C65293B69662821696C286E292972657475726E206E756C6C3B742D2D7D72657475726E206C2E737562737472696E6728302C65297D66756E6374';
wwv_flow_imp.g_varchar2_table(3325) := '696F6E205F28652C742C6E297B766F696420303D3D3D6E2626286E3D68293B76617220693D6628652C6E292C6F3D726C286C2C6E2C69732E57697468696E456E645461672C74732E456E64546167436C6F7365293F22223A223E222C643D633B666F7228';
wwv_flow_imp.g_varchar2_table(3326) := '74262628643D642E706172656E74293B643B297B76617220753D642E7461673B6966287526262821642E636C6F7365647C7C642E656E6454616753746172742626642E656E6454616753746172743E6829297B766172206D3D7B6C6162656C3A222F222B';
wwv_flow_imp.g_varchar2_table(3327) := '752C6B696E643A73612E50726F70657274792C66696C746572546578743A222F222B752C74657874456469743A7A6F2E7265706C61636528692C222F222B752B6F292C696E7365727454657874466F726D61743A68612E506C61696E546578747D2C703D';
wwv_flow_imp.g_varchar2_table(3328) := '6228642E7374617274292C673D6228652D31293B6966286E756C6C213D3D7026266E756C6C213D3D67262670213D3D67297B766172205F3D702B223C2F222B752B6F3B6D2E74657874456469743D7A6F2E7265706C616365286628652D312D672E6C656E';
wwv_flow_imp.g_varchar2_table(3329) := '677468292C5F292C6D2E66696C746572546578743D672B223C2F222B757D72657475726E20722E6974656D732E70757368286D292C727D643D642E706172656E747D72657475726E20747C7C612E666F7245616368282866756E6374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(3330) := '2E70726F766964655461677328292E666F7245616368282866756E6374696F6E2865297B722E6974656D732E70757368287B6C6162656C3A222F222B652E6E616D652C6B696E643A73612E50726F70657274792C646F63756D656E746174696F6E3A4773';
wwv_flow_imp.g_varchar2_table(3331) := '28652C766F696420302C73292C66696C746572546578743A222F222B652E6E616D652B6F2C74657874456469743A7A6F2E7265706C61636528692C222F222B652E6E616D652B6F292C696E7365727454657874466F726D61743A68612E506C61696E5465';
wwv_flow_imp.g_varchar2_table(3332) := '78747D297D29297D29292C727D66756E6374696F6E207628742C6E297B696628692626692E686964654175746F436F6D706C65746550726F706F73616C732972657475726E20723B696628214E73286E29297B766172206F3D652E706F736974696F6E41';
wwv_flow_imp.g_varchar2_table(3333) := '742874293B722E6974656D732E70757368287B6C6162656C3A223C2F222B6E2B223E222C6B696E643A73612E50726F70657274792C66696C746572546578743A223C2F222B6E2B223E222C74657874456469743A7A6F2E696E73657274286F2C2224303C';
wwv_flow_imp.g_varchar2_table(3334) := '2F222B6E2B223E22292C696E7365727454657874466F726D61743A68612E536E69707065747D297D72657475726E20727D66756E6374696F6E207728652C74297B72657475726E206728652C74292C5F28652C21302C74292C727D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(3335) := '7928652C74297B766172206F3B766F696420303D3D3D74262628743D68293B666F722876617220643D683B643C742626223C22213D3D6C5B645D3B29642B2B3B76617220753D6C2E737562737472696E6728652C74292C6D3D6628652C64292C673D2222';
wwv_flow_imp.g_varchar2_table(3336) := '3B69662821726C286C2C742C69732E41667465724174747269627574654E616D652C74732E44656C696D6974657241737369676E29297B76617220623D6E756C6C213D3D286F3D6E756C6C3D3D693F766F696420303A692E617474726962757465446566';
wwv_flow_imp.g_varchar2_table(3337) := '61756C7456616C7565292626766F69642030213D3D6F3F6F3A22646F75626C6571756F746573223B673D22656D707479223D3D3D623F223D2431223A2273696E676C6571756F746573223D3D3D623F223D27243127223A273D22243122277D766172205F';
wwv_flow_imp.g_varchar2_table(3338) := '2C763D285F3D4F626A6563742E637265617465286E756C6C292C632E6174747269627574654E616D65732E666F7245616368282866756E6374696F6E2865297B5F5B655D3D21307D29292C5F293B72657475726E20765B755D3D21312C612E666F724561';
wwv_flow_imp.g_varchar2_table(3339) := '6368282866756E6374696F6E2865297B652E70726F76696465417474726962757465732870292E666F7245616368282866756E6374696F6E2865297B69662821765B652E6E616D655D297B765B652E6E616D655D3D21303B76617220742C6E3D652E6E61';
wwv_flow_imp.g_varchar2_table(3340) := '6D653B227622213D3D652E76616C75655365742626672E6C656E6774682626286E2B3D672C28652E76616C75655365747C7C227374796C65223D3D3D652E6E616D6529262628743D7B7469746C653A2253756767657374222C636F6D6D616E643A226564';
wwv_flow_imp.g_varchar2_table(3341) := '69746F722E616374696F6E2E7472696767657253756767657374227D29292C722E6974656D732E70757368287B6C6162656C3A652E6E616D652C6B696E643A2268616E646C6572223D3D3D652E76616C75655365743F73612E46756E6374696F6E3A7361';
wwv_flow_imp.g_varchar2_table(3342) := '2E56616C75652C646F63756D656E746174696F6E3A477328652C766F696420302C73292C74657874456469743A7A6F2E7265706C616365286D2C6E292C696E7365727454657874466F726D61743A68612E536E69707065742C636F6D6D616E643A747D29';
wwv_flow_imp.g_varchar2_table(3343) := '7D7D29297D29292C66756E6374696F6E28652C74297B76617220693D22646174612D222C6F3D7B7D3B66756E6374696F6E20612865297B652E6174747269627574654E616D65732E666F7245616368282866756E6374696F6E2865297B21487328652C69';
wwv_flow_imp.g_varchar2_table(3344) := '297C7C6F5B655D7C7C745B655D7C7C286F5B655D3D652B273D2224312227297D29292C652E6368696C6472656E2E666F7245616368282866756E6374696F6E2865297B72657475726E20612865297D29297D6F5B695D3D22222E636F6E63617428692C27';
wwv_flow_imp.g_varchar2_table(3345) := '24313D2224322227292C6E26266E2E726F6F74732E666F7245616368282866756E6374696F6E2865297B72657475726E20612865297D29292C4F626A6563742E6B657973286F292E666F7245616368282866756E6374696F6E2874297B72657475726E20';
wwv_flow_imp.g_varchar2_table(3346) := '722E6974656D732E70757368287B6C6162656C3A742C6B696E643A73612E56616C75652C74657874456469743A7A6F2E7265706C61636528652C6F5B745D292C696E7365727454657874466F726D61743A68612E536E69707065747D297D29297D286D2C';
wwv_flow_imp.g_varchar2_table(3347) := '76292C727D66756E6374696F6E2054286E2C69297B76617220632C752C6D2C673B696628766F696420303D3D3D69262628693D68292C683E6E2626683C3D69262628673D6C5B6E5D2C2F5E5B22275D2A242F2E7465737428672929297B76617220623D6E';
wwv_flow_imp.g_varchar2_table(3348) := '2B312C5F3D693B693E6E26266C5B692D315D3D3D3D6C5B6E5D26265F2D2D3B76617220763D66756E6374696F6E28652C742C6E297B666F72283B743E6E262621696C28655B742D315D293B29742D2D3B72657475726E20747D286C2C682C62292C773D66';
wwv_flow_imp.g_varchar2_table(3349) := '756E6374696F6E28652C742C6E297B666F72283B743C6E262621696C28655B745D293B29742B2B3B72657475726E20747D286C2C682C5F293B633D6628762C77292C6D3D683E3D622626683C3D5F3F6C2E737562737472696E6728622C68293A22222C75';
wwv_flow_imp.g_varchar2_table(3350) := '3D21317D656C736520633D66286E2C69292C6D3D6C2E737562737472696E67286E2C68292C753D21303B6966286F2E6C656E6774683E3029666F722876617220793D702E746F4C6F7765724361736528292C543D642E746F4C6F7765724361736528292C';
wwv_flow_imp.g_varchar2_table(3351) := '6B3D66286E2C69292C533D302C4C3D6F3B533C4C2E6C656E6774683B532B2B297B76617220433D4C5B535D3B432E6F6E48746D6C41747472696275746556616C75652626432E6F6E48746D6C41747472696275746556616C7565287B646F63756D656E74';
wwv_flow_imp.g_varchar2_table(3352) := '3A652C706F736974696F6E3A742C7461673A792C6174747269627574653A542C76616C75653A6D2C72616E67653A6B7D297D72657475726E20612E666F7245616368282866756E6374696F6E2865297B652E70726F7669646556616C75657328702C6429';
wwv_flow_imp.g_varchar2_table(3353) := '2E666F7245616368282866756E6374696F6E2865297B76617220743D753F2722272B652E6E616D652B2722273A652E6E616D653B722E6974656D732E70757368287B6C6162656C3A652E6E616D652C66696C746572546578743A742C6B696E643A73612E';
wwv_flow_imp.g_varchar2_table(3354) := '556E69742C646F63756D656E746174696F6E3A477328652C766F696420302C73292C74657874456469743A7A6F2E7265706C61636528632C74292C696E7365727454657874466F726D61743A68612E506C61696E546578747D297D29297D29292C782829';
wwv_flow_imp.g_varchar2_table(3355) := '2C727D66756E6374696F6E206B2865297B72657475726E20683D3D3D6D2E676574546F6B656E456E6428292626284C3D6D2E7363616E2829293D3D3D6526266D2E676574546F6B656E4F666673657428293D3D3D683F6D2E676574546F6B656E456E6428';
wwv_flow_imp.g_varchar2_table(3356) := '293A687D66756E6374696F6E205328297B666F7228766172206E3D302C693D6F3B6E3C692E6C656E6774683B6E2B2B297B76617220723D695B6E5D3B722E6F6E48746D6C436F6E74656E742626722E6F6E48746D6C436F6E74656E74287B646F63756D65';
wwv_flow_imp.g_varchar2_table(3357) := '6E743A652C706F736974696F6E3A747D297D72657475726E207828297D66756E6374696F6E207828297B666F722876617220652C6E2C693D682D312C6F3D742E6368617261637465723B693E3D3026265673286C2C69293B29692D2D2C6F2D2D3B696628';
wwv_flow_imp.g_varchar2_table(3358) := '693E3D3026262226223D3D3D6C5B695D297B76617220613D616F2E63726561746528726F2E63726561746528742E6C696E652C6F2D31292C74293B666F7228766172207320696E20557329696628766F696420302C286E3D28653D73292E6C656E677468';
wwv_flow_imp.g_varchar2_table(3359) := '2D31293E303F652E6C617374496E6465784F6628223B22293D3D3D6E3A303D3D3D6E2626223B223D3D3D65297B76617220633D2226222B733B722E6974656D732E70757368287B6C6162656C3A632C6B696E643A73612E4B6579776F72642C646F63756D';
wwv_flow_imp.g_varchar2_table(3360) := '656E746174696F6E3A746C2822656E746974792E70726F706F7365222C2243686172616374657220656E7469747920726570726573656E74696E672027222E636F6E6361742855735B735D2C22272229292C74657874456469743A7A6F2E7265706C6163';
wwv_flow_imp.g_varchar2_table(3361) := '6528612C63292C696E7365727454657874466F726D61743A68612E506C61696E546578747D297D7D72657475726E20727D666F7228766172204C3D6D2E7363616E28293B4C213D3D74732E454F5326266D2E676574546F6B656E4F666673657428293C3D';
wwv_flow_imp.g_varchar2_table(3362) := '683B297B737769746368284C297B636173652074732E53746172745461674F70656E3A6966286D2E676574546F6B656E456E6428293D3D3D68297B76617220433D6B2874732E5374617274546167293B72657475726E20303D3D3D742E6C696E65262628';
wwv_flow_imp.g_varchar2_table(3363) := '753D766F696420302C753D6628682C43292C722E6974656D732E70757368287B6C6162656C3A2221444F4354595045222C6B696E643A73612E50726F70657274792C646F63756D656E746174696F6E3A224120707265616D626C6520666F7220616E2048';
wwv_flow_imp.g_varchar2_table(3364) := '544D4C20646F63756D656E742E222C74657874456469743A7A6F2E7265706C61636528752C2221444F43545950452068746D6C3E22292C696E7365727454657874466F726D61743A68612E506C61696E546578747D29292C7728682C43297D627265616B';
wwv_flow_imp.g_varchar2_table(3365) := '3B636173652074732E53746172745461673A6966286D2E676574546F6B656E4F666673657428293C3D682626683C3D6D2E676574546F6B656E456E6428292972657475726E2067286D2E676574546F6B656E4F666673657428292C6D2E676574546F6B65';
wwv_flow_imp.g_varchar2_table(3366) := '6E456E642829293B703D6D2E676574546F6B656E5465787428293B627265616B3B636173652074732E4174747269627574654E616D653A6966286D2E676574546F6B656E4F666673657428293C3D682626683C3D6D2E676574546F6B656E456E64282929';
wwv_flow_imp.g_varchar2_table(3367) := '72657475726E2079286D2E676574546F6B656E4F666673657428292C6D2E676574546F6B656E456E642829293B643D6D2E676574546F6B656E5465787428293B627265616B3B636173652074732E44656C696D6974657241737369676E3A6966286D2E67';
wwv_flow_imp.g_varchar2_table(3368) := '6574546F6B656E456E6428293D3D3D682972657475726E20433D6B2874732E41747472696275746556616C7565292C5428682C43293B627265616B3B636173652074732E41747472696275746556616C75653A6966286D2E676574546F6B656E4F666673';
wwv_flow_imp.g_varchar2_table(3369) := '657428293C3D682626683C3D6D2E676574546F6B656E456E6428292972657475726E2054286D2E676574546F6B656E4F666673657428292C6D2E676574546F6B656E456E642829293B627265616B3B636173652074732E576869746573706163653A6966';
wwv_flow_imp.g_varchar2_table(3370) := '28683C3D6D2E676574546F6B656E456E64282929737769746368286D2E6765745363616E6E657253746174652829297B636173652069732E41667465724F70656E696E6753746172745461673A72657475726E2077286D2E676574546F6B656E4F666673';
wwv_flow_imp.g_varchar2_table(3371) := '657428292C6B2874732E537461727454616729293B636173652069732E57697468696E5461673A636173652069732E41667465724174747269627574654E616D653A72657475726E2079286D2E676574546F6B656E456E642829293B636173652069732E';
wwv_flow_imp.g_varchar2_table(3372) := '4265666F726541747472696275746556616C75653A72657475726E2054286D2E676574546F6B656E456E642829293B636173652069732E41667465724F70656E696E67456E645461673A72657475726E205F286D2E676574546F6B656E4F666673657428';
wwv_flow_imp.g_varchar2_table(3373) := '292D312C2131293B636173652069732E57697468696E436F6E74656E743A72657475726E205328297D627265616B3B636173652074732E456E645461674F70656E3A696628683C3D6D2E676574546F6B656E456E6428292972657475726E205F286D2E67';
wwv_flow_imp.g_varchar2_table(3374) := '6574546F6B656E4F666673657428292B312C21312C6B2874732E456E6454616729293B627265616B3B636173652074732E456E645461673A696628683C3D6D2E676574546F6B656E456E64282929666F722876617220453D6D2E676574546F6B656E4F66';
wwv_flow_imp.g_varchar2_table(3375) := '6673657428292D313B453E3D303B297B76617220413D6C2E6368617241742845293B696628222F223D3D3D412972657475726E205F28452C21312C6D2E676574546F6B656E456E642829293B69662821696C28412929627265616B3B452D2D7D62726561';
wwv_flow_imp.g_varchar2_table(3376) := '6B3B636173652074732E5374617274546167436C6F73653A696628683C3D6D2E676574546F6B656E456E6428292626702972657475726E2076286D2E676574546F6B656E456E6428292C70293B627265616B3B636173652074732E436F6E74656E743A69';
wwv_flow_imp.g_varchar2_table(3377) := '6628683C3D6D2E676574546F6B656E456E6428292972657475726E205328293B627265616B3B64656661756C743A696628683C3D6D2E676574546F6B656E456E6428292972657475726E20727D4C3D6D2E7363616E28297D72657475726E20727D2C652E';
wwv_flow_imp.g_varchar2_table(3378) := '70726F746F747970652E646F51756F7465436F6D706C6574653D66756E6374696F6E28652C742C6E2C69297B76617220722C6F3D652E6F666673657441742874293B6966286F3C3D302972657475726E206E756C6C3B76617220613D6E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(3379) := '723D6E756C6C3D3D693F766F696420303A692E61747472696275746544656661756C7456616C7565292626766F69642030213D3D723F723A22646F75626C6571756F746573223B69662822656D707479223D3D3D612972657475726E206E756C6C3B6966';
wwv_flow_imp.g_varchar2_table(3380) := '28223D22213D3D652E6765745465787428292E636861724174286F2D31292972657475726E206E756C6C3B76617220733D22646F75626C6571756F746573223D3D3D613F2722243122273A2227243127222C6C3D6E2E66696E644E6F64654265666F7265';
wwv_flow_imp.g_varchar2_table(3381) := '286F293B6966286C26266C2E6174747269627574657326266C2E73746172743C6F262628216C2E656E6454616753746172747C7C6C2E656E6454616753746172743E6F2929666F722876617220683D417328652E6765745465787428292C6C2E73746172';
wwv_flow_imp.g_varchar2_table(3382) := '74292C633D682E7363616E28293B63213D3D74732E454F532626682E676574546F6B656E456E6428293C3D6F3B297B696628633D3D3D74732E4174747269627574654E616D652626682E676574546F6B656E456E6428293D3D3D6F2D312972657475726E';
wwv_flow_imp.g_varchar2_table(3383) := '28633D682E7363616E282929213D3D74732E44656C696D6974657241737369676E7C7C28633D682E7363616E2829293D3D3D74732E556E6B6E6F776E7C7C633D3D3D74732E41747472696275746556616C75653F6E756C6C3A733B633D682E7363616E28';
wwv_flow_imp.g_varchar2_table(3384) := '297D72657475726E206E756C6C7D2C652E70726F746F747970652E646F546167436F6D706C6574653D66756E6374696F6E28652C742C6E297B76617220693D652E6F666673657441742874293B696628693C3D302972657475726E206E756C6C3B766172';
wwv_flow_imp.g_varchar2_table(3385) := '20723D652E6765745465787428292E63686172417428692D31293B696628223E223D3D3D72297B69662828613D6E2E66696E644E6F64654265666F7265286929292626612E7461672626214E7328612E746167292626612E73746172743C692626282161';
wwv_flow_imp.g_varchar2_table(3386) := '2E656E6454616753746172747C7C612E656E6454616753746172743E692929666F7228766172206F3D28733D417328652E6765745465787428292C612E737461727429292E7363616E28293B6F213D3D74732E454F532626732E676574546F6B656E456E';
wwv_flow_imp.g_varchar2_table(3387) := '6428293C3D693B297B6966286F3D3D3D74732E5374617274546167436C6F73652626732E676574546F6B656E456E6428293D3D3D692972657475726E2224303C2F222E636F6E63617428612E7461672C223E22293B6F3D732E7363616E28297D7D656C73';
wwv_flow_imp.g_varchar2_table(3388) := '6520696628222F223D3D3D72297B666F722876617220613D6E2E66696E644E6F64654265666F72652869293B612626612E636C6F73656426262128612E656E6454616753746172742626612E656E6454616753746172743E69293B29613D612E70617265';
wwv_flow_imp.g_varchar2_table(3389) := '6E743B76617220733B696628612626612E74616729666F72286F3D28733D417328652E6765745465787428292C612E737461727429292E7363616E28293B6F213D3D74732E454F532626732E676574546F6B656E456E6428293C3D693B297B6966286F3D';
wwv_flow_imp.g_varchar2_table(3390) := '3D3D74732E456E645461674F70656E2626732E676574546F6B656E456E6428293D3D3D692972657475726E22222E636F6E63617428612E7461672C223E22293B6F3D732E7363616E28297D7D72657475726E206E756C6C7D2C652E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(3391) := '2E636F6E76657274436F6D706C6574696F6E4C6973743D66756E6374696F6E2865297B72657475726E20746869732E646F6573537570706F72744D61726B646F776E28297C7C652E6974656D732E666F7245616368282866756E6374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(3392) := '2E646F63756D656E746174696F6E262622737472696E6722213D747970656F6620652E646F63756D656E746174696F6E262628652E646F63756D656E746174696F6E3D7B6B696E643A22706C61696E74657874222C76616C75653A652E646F63756D656E';
wwv_flow_imp.g_varchar2_table(3393) := '746174696F6E2E76616C75657D297D29292C657D2C652E70726F746F747970652E646F6573537570706F72744D61726B646F776E3D66756E6374696F6E28297B76617220652C742C6E3B696628214B7328746869732E737570706F7274734D61726B646F';
wwv_flow_imp.g_varchar2_table(3394) := '776E29297B696628214B7328746869732E6C734F7074696F6E732E636C69656E744361706162696C6974696573292972657475726E20746869732E737570706F7274734D61726B646F776E3D21302C746869732E737570706F7274734D61726B646F776E';
wwv_flow_imp.g_varchar2_table(3395) := '3B76617220693D6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E6C734F7074696F6E732E636C69656E744361706162696C69746965732E74657874446F63756D656E74297C7C766F696420303D3D3D653F766F69';
wwv_flow_imp.g_varchar2_table(3396) := '6420303A652E636F6D706C6574696F6E297C7C766F696420303D3D3D743F766F696420303A742E636F6D706C6574696F6E4974656D297C7C766F696420303D3D3D6E3F766F696420303A6E2E646F63756D656E746174696F6E466F726D61743B74686973';
wwv_flow_imp.g_varchar2_table(3397) := '2E737570706F7274734D61726B646F776E3D41727261792E6973417272617928692926262D31213D3D692E696E6465784F662872612E4D61726B646F776E297D72657475726E20746869732E737570706F7274734D61726B646F776E7D2C657D28293B66';
wwv_flow_imp.g_varchar2_table(3398) := '756E6374696F6E20696C2865297B72657475726E2F5E5C732A242F2E746573742865297D66756E6374696F6E20726C28652C742C6E2C69297B666F722876617220723D417328652C742C6E292C6F3D722E7363616E28293B6F3D3D3D74732E5768697465';
wwv_flow_imp.g_varchar2_table(3399) := '73706163653B296F3D722E7363616E28293B72657475726E206F3D3D3D697D766172206F6C2C616C2C736C3D5A7228292C6C6C3D66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E6C734F7074696F6E733D652C74686973';
wwv_flow_imp.g_varchar2_table(3400) := '2E646174614D616E616765723D747D72657475726E20652E70726F746F747970652E646F486F7665723D66756E6374696F6E28652C742C6E2C69297B76617220723D746869732E636F6E76657274436F6E74656E74732E62696E642874686973292C6F3D';
wwv_flow_imp.g_varchar2_table(3401) := '746869732E646F6573537570706F72744D61726B646F776E28292C613D652E6F666673657441742874292C733D6E2E66696E644E6F646541742861292C6C3D652E6765745465787428293B69662821737C7C21732E7461672972657475726E206E756C6C';
wwv_flow_imp.g_varchar2_table(3402) := '3B76617220683D746869732E646174614D616E616765722E6765744461746150726F76696465727328292E66696C746572282866756E6374696F6E2874297B72657475726E20742E69734170706C696361626C6528652E6C616E67756167654964297D29';
wwv_flow_imp.g_varchar2_table(3403) := '293B66756E6374696F6E206328652C742C6E297B666F722876617220613D66756E6374696F6E286E297B76617220613D6E756C6C3B6966286E2E70726F766964655461677328292E666F7245616368282866756E6374696F6E286E297B6966286E2E6E61';
wwv_flow_imp.g_varchar2_table(3404) := '6D652E746F4C6F7765724361736528293D3D3D652E746F4C6F776572436173652829297B76617220723D4773286E2C692C6F293B727C7C28723D7B6B696E643A6F3F226D61726B646F776E223A22706C61696E74657874222C76616C75653A22227D292C';
wwv_flow_imp.g_varchar2_table(3405) := '613D7B636F6E74656E74733A722C72616E67653A747D7D7D29292C612972657475726E20612E636F6E74656E74733D7228612E636F6E74656E7473292C7B76616C75653A617D7D2C733D302C6C3D683B733C6C2E6C656E6774683B732B2B297B76617220';
wwv_flow_imp.g_varchar2_table(3406) := '633D61286C5B735D293B696628226F626A656374223D3D747970656F6620632972657475726E20632E76616C75657D72657475726E206E756C6C7D66756E6374696F6E206428742C6E297B666F722876617220693D417328652E6765745465787428292C';
wwv_flow_imp.g_varchar2_table(3407) := '6E292C723D692E7363616E28293B72213D3D74732E454F53262628692E676574546F6B656E456E6428293C617C7C692E676574546F6B656E456E6428293D3D3D61262672213D3D74293B29723D692E7363616E28293B72657475726E20723D3D3D742626';
wwv_flow_imp.g_varchar2_table(3408) := '613C3D692E676574546F6B656E456E6428293F7B73746172743A652E706F736974696F6E417428692E676574546F6B656E4F66667365742829292C656E643A652E706F736974696F6E417428692E676574546F6B656E456E642829297D3A6E756C6C7D69';
wwv_flow_imp.g_varchar2_table(3409) := '6628732E656E6454616753746172742626613E3D732E656E645461675374617274297B76617220753D642874732E456E645461672C732E656E645461675374617274293B72657475726E20753F6328732E7461672C75293A6E756C6C7D766172206D3D64';
wwv_flow_imp.g_varchar2_table(3410) := '2874732E53746172745461672C732E7374617274293B6966286D2972657475726E206328732E7461672C6D293B76617220703D642874732E4174747269627574654E616D652C732E7374617274293B696628702972657475726E2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3411) := '652C742C6E297B666F722876617220613D66756E6374696F6E2861297B76617220733D6E756C6C3B696628612E70726F76696465417474726962757465732865292E666F7245616368282866756E6374696F6E2865297B696628743D3D3D652E6E616D65';
wwv_flow_imp.g_varchar2_table(3412) := '2626652E6465736372697074696F6E297B76617220723D477328652C692C6F293B733D723F7B636F6E74656E74733A722C72616E67653A6E7D3A6E756C6C7D7D29292C732972657475726E20732E636F6E74656E74733D7228732E636F6E74656E747329';
wwv_flow_imp.g_varchar2_table(3413) := '2C7B76616C75653A737D7D2C733D302C6C3D683B733C6C2E6C656E6774683B732B2B297B76617220633D61286C5B735D293B696628226F626A656374223D3D747970656F6620632972657475726E20632E76616C75657D72657475726E206E756C6C7D28';
wwv_flow_imp.g_varchar2_table(3414) := '5F3D732E7461672C652E676574546578742870292C70293B76617220663D66756E6374696F6E28297B666F722876617220653D612D312C6E3D742E6368617261637465723B653E3D3026265673286C2C65293B29652D2D2C6E2D2D3B666F722876617220';
wwv_flow_imp.g_varchar2_table(3415) := '693D652B312C723D6E3B5673286C2C69293B29692B2B2C722B2B3B72657475726E20653E3D3026262226223D3D3D6C5B655D3F223B223D3D3D6C5B695D3F616F2E63726561746528726F2E63726561746528742E6C696E652C6E292C726F2E6372656174';
wwv_flow_imp.g_varchar2_table(3416) := '6528742E6C696E652C722B3129293A616F2E63726561746528726F2E63726561746528742E6C696E652C6E292C726F2E63726561746528742E6C696E652C7229293A6E756C6C7D28293B696628662972657475726E2066756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(3417) := '766172206E3D66756E6374696F6E2865297B666F722876617220743D612D312C6E3D2226223B743E3D302626567328652C74293B29742D2D3B666F7228742B3D313B567328652C74293B296E2B3D655B745D2C742B3D313B72657475726E206E2B223B22';
wwv_flow_imp.g_varchar2_table(3418) := '7D2865293B666F7228766172206920696E205573297B766172206F3D6E756C6C3B6966286E3D3D3D2226222B69297B76617220733D55735B695D2E63686172436F646541742830292E746F537472696E67283136292E746F55707065724361736528292C';
wwv_flow_imp.g_varchar2_table(3419) := '6C3D22552B223B696628732E6C656E6774683C3429666F722876617220683D342D732E6C656E6774682C633D303B633C683B296C2B3D2230222C632B3D313B6C2B3D733B76617220643D736C2822656E746974792E70726F706F7365222C224368617261';
wwv_flow_imp.g_varchar2_table(3420) := '6374657220656E7469747920726570726573656E74696E672027222E636F6E6361742855735B695D2C22272C20756E69636F6465206571756976616C656E74202722292E636F6E636174286C2C22272229293B6F3D643F7B636F6E74656E74733A642C72';
wwv_flow_imp.g_varchar2_table(3421) := '616E67653A747D3A6E756C6C7D6966286F2972657475726E206F2E636F6E74656E74733D72286F2E636F6E74656E7473292C6F7D72657475726E206E756C6C7D286C2C66293B76617220672C623D642874732E41747472696275746556616C75652C732E';
wwv_flow_imp.g_varchar2_table(3422) := '7374617274293B69662862297B766172205F3D732E7461672C763D28673D652E67657454657874286229292E6C656E6774683C3D313F672E7265706C616365282F5B27225D2F2C2222293A28222722213D3D675B305D2626272227213D3D675B305D7C7C';
wwv_flow_imp.g_varchar2_table(3423) := '28673D672E736C696365283129292C222722213D3D675B672E6C656E6774682D315D2626272227213D3D675B672E6C656E6774682D315D7C7C28673D672E736C69636528302C2D3129292C67292C773D66756E6374696F6E28742C6E297B666F72287661';
wwv_flow_imp.g_varchar2_table(3424) := '7220693D417328652E6765745465787428292C74292C723D692E7363616E28292C6F3D766F696420303B72213D3D74732E454F532626692E676574546F6B656E456E6428293C3D6E3B2928723D692E7363616E2829293D3D3D74732E4174747269627574';
wwv_flow_imp.g_varchar2_table(3425) := '654E616D652626286F3D692E676574546F6B656E546578742829293B72657475726E206F7D28732E73746172742C652E6F6666736574417428622E737461727429293B696628772972657475726E2066756E6374696F6E28652C742C6E2C61297B666F72';
wwv_flow_imp.g_varchar2_table(3426) := '2876617220733D66756E6374696F6E2873297B766172206C3D6E756C6C3B696628732E70726F7669646556616C75657328652C74292E666F7245616368282866756E6374696F6E2865297B6966286E3D3D3D652E6E616D652626652E6465736372697074';
wwv_flow_imp.g_varchar2_table(3427) := '696F6E297B76617220743D477328652C692C6F293B6C3D743F7B636F6E74656E74733A742C72616E67653A617D3A6E756C6C7D7D29292C6C2972657475726E206C2E636F6E74656E74733D72286C2E636F6E74656E7473292C7B76616C75653A6C7D7D2C';
wwv_flow_imp.g_varchar2_table(3428) := '6C3D302C633D683B6C3C632E6C656E6774683B6C2B2B297B76617220643D7328635B6C5D293B696628226F626A656374223D3D747970656F6620642972657475726E20642E76616C75657D72657475726E206E756C6C7D285F2C772C762C62297D726574';
wwv_flow_imp.g_varchar2_table(3429) := '75726E206E756C6C7D2C652E70726F746F747970652E636F6E76657274436F6E74656E74733D66756E6374696F6E2865297B69662821746869732E646F6573537570706F72744D61726B646F776E2829297B69662822737472696E67223D3D747970656F';
wwv_flow_imp.g_varchar2_table(3430) := '6620652972657475726E20653B696628226B696E6422696E20652972657475726E7B6B696E643A22706C61696E74657874222C76616C75653A652E76616C75657D3B6966282141727261792E697341727261792865292972657475726E20652E76616C75';
wwv_flow_imp.g_varchar2_table(3431) := '653B652E6D6170282866756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620653F653A652E76616C75657D29297D72657475726E20657D2C652E70726F746F747970652E646F6573537570706F72744D61726B646F776E';
wwv_flow_imp.g_varchar2_table(3432) := '3D66756E6374696F6E28297B76617220652C742C6E3B696628214B7328746869732E737570706F7274734D61726B646F776E29297B696628214B7328746869732E6C734F7074696F6E732E636C69656E744361706162696C697469657329297265747572';
wwv_flow_imp.g_varchar2_table(3433) := '6E20746869732E737570706F7274734D61726B646F776E3D21302C746869732E737570706F7274734D61726B646F776E3B76617220693D6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E6C734F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(3434) := '636C69656E744361706162696C6974696573297C7C766F696420303D3D3D653F766F696420303A652E74657874446F63756D656E74297C7C766F696420303D3D3D743F766F696420303A742E686F766572297C7C766F696420303D3D3D6E3F766F696420';
wwv_flow_imp.g_varchar2_table(3435) := '303A6E2E636F6E74656E74466F726D61743B746869732E737570706F7274734D61726B646F776E3D41727261792E6973417272617928692926262D31213D3D692E696E6465784F662872612E4D61726B646F776E297D72657475726E20746869732E7375';
wwv_flow_imp.g_varchar2_table(3436) := '70706F7274734D61726B646F776E7D2C657D28293B66756E6374696F6E20686C28652C74297B72657475726E20657D6F6C3D5B2C2C66756E6374696F6E2865297B66756E6374696F6E20742865297B746869732E5F5F706172656E743D652C746869732E';
wwv_flow_imp.g_varchar2_table(3437) := '5F5F6368617261637465725F636F756E743D302C746869732E5F5F696E64656E745F636F756E743D2D312C746869732E5F5F616C69676E6D656E745F636F756E743D302C746869732E5F5F777261705F706F696E745F696E6465783D302C746869732E5F';
wwv_flow_imp.g_varchar2_table(3438) := '5F777261705F706F696E745F6368617261637465725F636F756E743D302C746869732E5F5F777261705F706F696E745F696E64656E745F636F756E743D2D312C746869732E5F5F777261705F706F696E745F616C69676E6D656E745F636F756E743D302C';
wwv_flow_imp.g_varchar2_table(3439) := '746869732E5F5F6974656D733D5B5D7D66756E6374696F6E206E28652C74297B746869732E5F5F63616368653D5B22225D2C746869732E5F5F696E64656E745F73697A653D652E696E64656E745F73697A652C746869732E5F5F696E64656E745F737472';
wwv_flow_imp.g_varchar2_table(3440) := '696E673D652E696E64656E745F636861722C652E696E64656E745F776974685F746162737C7C28746869732E5F5F696E64656E745F737472696E673D6E657720417272617928652E696E64656E745F73697A652B31292E6A6F696E28652E696E64656E74';
wwv_flow_imp.g_varchar2_table(3441) := '5F6368617229292C743D747C7C22222C652E696E64656E745F6C6576656C3E30262628743D6E657720417272617928652E696E64656E745F6C6576656C2B31292E6A6F696E28746869732E5F5F696E64656E745F737472696E6729292C746869732E5F5F';
wwv_flow_imp.g_varchar2_table(3442) := '626173655F737472696E673D742C746869732E5F5F626173655F737472696E675F6C656E6774683D742E6C656E6774687D66756E6374696F6E206928652C69297B746869732E5F5F696E64656E745F63616368653D6E6577206E28652C69292C74686973';
wwv_flow_imp.g_varchar2_table(3443) := '2E7261773D21312C746869732E5F656E645F776974685F6E65776C696E653D652E656E645F776974685F6E65776C696E652C746869732E696E64656E745F73697A653D652E696E64656E745F73697A652C746869732E777261705F6C696E655F6C656E67';
wwv_flow_imp.g_varchar2_table(3444) := '74683D652E777261705F6C696E655F6C656E6774682C746869732E696E64656E745F656D7074795F6C696E65733D652E696E64656E745F656D7074795F6C696E65732C746869732E5F5F6C696E65733D5B5D2C746869732E70726576696F75735F6C696E';
wwv_flow_imp.g_varchar2_table(3445) := '653D6E756C6C2C746869732E63757272656E745F6C696E653D6E756C6C2C746869732E6E6578745F6C696E653D6E657720742874686973292C746869732E73706163655F6265666F72655F746F6B656E3D21312C746869732E6E6F6E5F627265616B696E';
wwv_flow_imp.g_varchar2_table(3446) := '675F73706163653D21312C746869732E70726576696F75735F746F6B656E5F777261707065643D21312C746869732E5F5F6164645F6F75747075746C696E6528297D742E70726F746F747970652E636C6F6E655F656D7074793D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(3447) := '7B76617220653D6E6577207428746869732E5F5F706172656E74293B72657475726E20652E7365745F696E64656E7428746869732E5F5F696E64656E745F636F756E742C746869732E5F5F616C69676E6D656E745F636F756E74292C657D2C742E70726F';
wwv_flow_imp.g_varchar2_table(3448) := '746F747970652E6974656D3D66756E6374696F6E2865297B72657475726E20653C303F746869732E5F5F6974656D735B746869732E5F5F6974656D732E6C656E6774682B655D3A746869732E5F5F6974656D735B655D7D2C742E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(3449) := '6861735F6D617463683D66756E6374696F6E2865297B666F722876617220743D746869732E5F5F6974656D732E6C656E6774682D313B743E3D303B742D2D29696628746869732E5F5F6974656D735B745D2E6D617463682865292972657475726E21303B';
wwv_flow_imp.g_varchar2_table(3450) := '72657475726E21317D2C742E70726F746F747970652E7365745F696E64656E743D66756E6374696F6E28652C74297B746869732E69735F656D7074792829262628746869732E5F5F696E64656E745F636F756E743D657C7C302C746869732E5F5F616C69';
wwv_flow_imp.g_varchar2_table(3451) := '676E6D656E745F636F756E743D747C7C302C746869732E5F5F6368617261637465725F636F756E743D746869732E5F5F706172656E742E6765745F696E64656E745F73697A6528746869732E5F5F696E64656E745F636F756E742C746869732E5F5F616C';
wwv_flow_imp.g_varchar2_table(3452) := '69676E6D656E745F636F756E7429297D2C742E70726F746F747970652E5F7365745F777261705F706F696E743D66756E6374696F6E28297B746869732E5F5F706172656E742E777261705F6C696E655F6C656E677468262628746869732E5F5F77726170';
wwv_flow_imp.g_varchar2_table(3453) := '5F706F696E745F696E6465783D746869732E5F5F6974656D732E6C656E6774682C746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E743D746869732E5F5F6368617261637465725F636F756E742C746869732E5F5F777261';
wwv_flow_imp.g_varchar2_table(3454) := '705F706F696E745F696E64656E745F636F756E743D746869732E5F5F706172656E742E6E6578745F6C696E652E5F5F696E64656E745F636F756E742C746869732E5F5F777261705F706F696E745F616C69676E6D656E745F636F756E743D746869732E5F';
wwv_flow_imp.g_varchar2_table(3455) := '5F706172656E742E6E6578745F6C696E652E5F5F616C69676E6D656E745F636F756E74297D2C742E70726F746F747970652E5F73686F756C645F777261703D66756E6374696F6E28297B72657475726E20746869732E5F5F777261705F706F696E745F69';
wwv_flow_imp.g_varchar2_table(3456) := '6E6465782626746869732E5F5F6368617261637465725F636F756E743E746869732E5F5F706172656E742E777261705F6C696E655F6C656E6774682626746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E743E746869732E';
wwv_flow_imp.g_varchar2_table(3457) := '5F5F706172656E742E6E6578745F6C696E652E5F5F6368617261637465725F636F756E747D2C742E70726F746F747970652E5F616C6C6F775F777261703D66756E6374696F6E28297B696628746869732E5F73686F756C645F777261702829297B746869';
wwv_flow_imp.g_varchar2_table(3458) := '732E5F5F706172656E742E6164645F6E65775F6C696E6528293B76617220653D746869732E5F5F706172656E742E63757272656E745F6C696E653B72657475726E20652E7365745F696E64656E7428746869732E5F5F777261705F706F696E745F696E64';
wwv_flow_imp.g_varchar2_table(3459) := '656E745F636F756E742C746869732E5F5F777261705F706F696E745F616C69676E6D656E745F636F756E74292C652E5F5F6974656D733D746869732E5F5F6974656D732E736C69636528746869732E5F5F777261705F706F696E745F696E646578292C74';
wwv_flow_imp.g_varchar2_table(3460) := '6869732E5F5F6974656D733D746869732E5F5F6974656D732E736C69636528302C746869732E5F5F777261705F706F696E745F696E646578292C652E5F5F6368617261637465725F636F756E742B3D746869732E5F5F6368617261637465725F636F756E';
wwv_flow_imp.g_varchar2_table(3461) := '742D746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E742C746869732E5F5F6368617261637465725F636F756E743D746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E742C2220223D3D3D65';
wwv_flow_imp.g_varchar2_table(3462) := '2E5F5F6974656D735B305D262628652E5F5F6974656D732E73706C69636528302C31292C652E5F5F6368617261637465725F636F756E742D3D31292C21307D72657475726E21317D2C742E70726F746F747970652E69735F656D7074793D66756E637469';
wwv_flow_imp.g_varchar2_table(3463) := '6F6E28297B72657475726E20303D3D3D746869732E5F5F6974656D732E6C656E6774687D2C742E70726F746F747970652E6C6173743D66756E6374696F6E28297B72657475726E20746869732E69735F656D70747928293F6E756C6C3A746869732E5F5F';
wwv_flow_imp.g_varchar2_table(3464) := '6974656D735B746869732E5F5F6974656D732E6C656E6774682D315D7D2C742E70726F746F747970652E707573683D66756E6374696F6E2865297B746869732E5F5F6974656D732E707573682865293B76617220743D652E6C617374496E6465784F6628';
wwv_flow_imp.g_varchar2_table(3465) := '225C6E22293B2D31213D3D743F746869732E5F5F6368617261637465725F636F756E743D652E6C656E6774682D743A746869732E5F5F6368617261637465725F636F756E742B3D652E6C656E6774687D2C742E70726F746F747970652E706F703D66756E';
wwv_flow_imp.g_varchar2_table(3466) := '6374696F6E28297B76617220653D6E756C6C3B72657475726E20746869732E69735F656D70747928297C7C28653D746869732E5F5F6974656D732E706F7028292C746869732E5F5F6368617261637465725F636F756E742D3D652E6C656E677468292C65';
wwv_flow_imp.g_varchar2_table(3467) := '7D2C742E70726F746F747970652E5F72656D6F76655F696E64656E743D66756E6374696F6E28297B746869732E5F5F696E64656E745F636F756E743E30262628746869732E5F5F696E64656E745F636F756E742D3D312C746869732E5F5F636861726163';
wwv_flow_imp.g_varchar2_table(3468) := '7465725F636F756E742D3D746869732E5F5F706172656E742E696E64656E745F73697A65297D2C742E70726F746F747970652E5F72656D6F76655F777261705F696E64656E743D66756E6374696F6E28297B746869732E5F5F777261705F706F696E745F';
wwv_flow_imp.g_varchar2_table(3469) := '696E64656E745F636F756E743E30262628746869732E5F5F777261705F706F696E745F696E64656E745F636F756E742D3D31297D2C742E70726F746F747970652E7472696D3D66756E6374696F6E28297B666F72283B2220223D3D3D746869732E6C6173';
wwv_flow_imp.g_varchar2_table(3470) := '7428293B29746869732E5F5F6974656D732E706F7028292C746869732E5F5F6368617261637465725F636F756E742D3D317D2C742E70726F746F747970652E746F537472696E673D66756E6374696F6E28297B76617220653D22223B72657475726E2074';
wwv_flow_imp.g_varchar2_table(3471) := '6869732E69735F656D70747928293F746869732E5F5F706172656E742E696E64656E745F656D7074795F6C696E6573262628653D746869732E5F5F706172656E742E6765745F696E64656E745F737472696E6728746869732E5F5F696E64656E745F636F';
wwv_flow_imp.g_varchar2_table(3472) := '756E7429293A28653D746869732E5F5F706172656E742E6765745F696E64656E745F737472696E6728746869732E5F5F696E64656E745F636F756E742C746869732E5F5F616C69676E6D656E745F636F756E74292C652B3D746869732E5F5F6974656D73';
wwv_flow_imp.g_varchar2_table(3473) := '2E6A6F696E28222229292C657D2C6E2E70726F746F747970652E6765745F696E64656E745F73697A653D66756E6374696F6E28652C74297B766172206E3D746869732E5F5F626173655F737472696E675F6C656E6774683B72657475726E20743D747C7C';
wwv_flow_imp.g_varchar2_table(3474) := '302C653C302626286E3D30292C286E2B3D652A746869732E5F5F696E64656E745F73697A65292B747D2C6E2E70726F746F747970652E6765745F696E64656E745F737472696E673D66756E6374696F6E28652C74297B766172206E3D746869732E5F5F62';
wwv_flow_imp.g_varchar2_table(3475) := '6173655F737472696E673B72657475726E20743D747C7C302C653C30262628653D302C6E3D2222292C742B3D652A746869732E5F5F696E64656E745F73697A652C746869732E5F5F656E737572655F63616368652874292C6E2B746869732E5F5F636163';
wwv_flow_imp.g_varchar2_table(3476) := '68655B745D7D2C6E2E70726F746F747970652E5F5F656E737572655F63616368653D66756E6374696F6E2865297B666F72283B653E3D746869732E5F5F63616368652E6C656E6774683B29746869732E5F5F6164645F636F6C756D6E28297D2C6E2E7072';
wwv_flow_imp.g_varchar2_table(3477) := '6F746F747970652E5F5F6164645F636F6C756D6E3D66756E6374696F6E28297B76617220653D746869732E5F5F63616368652E6C656E6774682C743D302C6E3D22223B746869732E5F5F696E64656E745F73697A652626653E3D746869732E5F5F696E64';
wwv_flow_imp.g_varchar2_table(3478) := '656E745F73697A65262628652D3D28743D4D6174682E666C6F6F7228652F746869732E5F5F696E64656E745F73697A6529292A746869732E5F5F696E64656E745F73697A652C6E3D6E657720417272617928742B31292E6A6F696E28746869732E5F5F69';
wwv_flow_imp.g_varchar2_table(3479) := '6E64656E745F737472696E6729292C652626286E2B3D6E657720417272617928652B31292E6A6F696E2822202229292C746869732E5F5F63616368652E70757368286E297D2C692E70726F746F747970652E5F5F6164645F6F75747075746C696E653D66';
wwv_flow_imp.g_varchar2_table(3480) := '756E6374696F6E28297B746869732E70726576696F75735F6C696E653D746869732E63757272656E745F6C696E652C746869732E63757272656E745F6C696E653D746869732E6E6578745F6C696E652E636C6F6E655F656D70747928292C746869732E5F';
wwv_flow_imp.g_varchar2_table(3481) := '5F6C696E65732E7075736828746869732E63757272656E745F6C696E65297D2C692E70726F746F747970652E6765745F6C696E655F6E756D6265723D66756E6374696F6E28297B72657475726E20746869732E5F5F6C696E65732E6C656E6774687D2C69';
wwv_flow_imp.g_varchar2_table(3482) := '2E70726F746F747970652E6765745F696E64656E745F737472696E673D66756E6374696F6E28652C74297B72657475726E20746869732E5F5F696E64656E745F63616368652E6765745F696E64656E745F737472696E6728652C74297D2C692E70726F74';
wwv_flow_imp.g_varchar2_table(3483) := '6F747970652E6765745F696E64656E745F73697A653D66756E6374696F6E28652C74297B72657475726E20746869732E5F5F696E64656E745F63616368652E6765745F696E64656E745F73697A6528652C74297D2C692E70726F746F747970652E69735F';
wwv_flow_imp.g_varchar2_table(3484) := '656D7074793D66756E6374696F6E28297B72657475726E21746869732E70726576696F75735F6C696E652626746869732E63757272656E745F6C696E652E69735F656D70747928297D2C692E70726F746F747970652E6164645F6E65775F6C696E653D66';
wwv_flow_imp.g_varchar2_table(3485) := '756E6374696F6E2865297B72657475726E2128746869732E69735F656D70747928297C7C21652626746869732E6A7573745F61646465645F6E65776C696E6528297C7C28746869732E7261777C7C746869732E5F5F6164645F6F75747075746C696E6528';
wwv_flow_imp.g_varchar2_table(3486) := '292C3029297D2C692E70726F746F747970652E6765745F636F64653D66756E6374696F6E2865297B746869732E7472696D282130293B76617220743D746869732E63757272656E745F6C696E652E706F7028293B74262628225C6E223D3D3D745B742E6C';
wwv_flow_imp.g_varchar2_table(3487) := '656E6774682D315D262628743D742E7265706C616365282F5C6E2B242F672C222229292C746869732E63757272656E745F6C696E652E70757368287429292C746869732E5F656E645F776974685F6E65776C696E652626746869732E5F5F6164645F6F75';
wwv_flow_imp.g_varchar2_table(3488) := '747075746C696E6528293B766172206E3D746869732E5F5F6C696E65732E6A6F696E28225C6E22293B72657475726E225C6E22213D3D652626286E3D6E2E7265706C616365282F5B5C6E5D2F672C6529292C6E7D2C692E70726F746F747970652E736574';
wwv_flow_imp.g_varchar2_table(3489) := '5F777261705F706F696E743D66756E6374696F6E28297B746869732E63757272656E745F6C696E652E5F7365745F777261705F706F696E7428297D2C692E70726F746F747970652E7365745F696E64656E743D66756E6374696F6E28652C74297B726574';
wwv_flow_imp.g_varchar2_table(3490) := '75726E20653D657C7C302C743D747C7C302C746869732E6E6578745F6C696E652E7365745F696E64656E7428652C74292C746869732E5F5F6C696E65732E6C656E6774683E313F28746869732E63757272656E745F6C696E652E7365745F696E64656E74';
wwv_flow_imp.g_varchar2_table(3491) := '28652C74292C2130293A28746869732E63757272656E745F6C696E652E7365745F696E64656E7428292C2131297D2C692E70726F746F747970652E6164645F7261775F746F6B656E3D66756E6374696F6E2865297B666F722876617220743D303B743C65';
wwv_flow_imp.g_varchar2_table(3492) := '2E6E65776C696E65733B742B2B29746869732E5F5F6164645F6F75747075746C696E6528293B746869732E63757272656E745F6C696E652E7365745F696E64656E74282D31292C746869732E63757272656E745F6C696E652E7075736828652E77686974';
wwv_flow_imp.g_varchar2_table(3493) := '6573706163655F6265666F7265292C746869732E63757272656E745F6C696E652E7075736828652E74657874292C746869732E73706163655F6265666F72655F746F6B656E3D21312C746869732E6E6F6E5F627265616B696E675F73706163653D21312C';
wwv_flow_imp.g_varchar2_table(3494) := '746869732E70726576696F75735F746F6B656E5F777261707065643D21317D2C692E70726F746F747970652E6164645F746F6B656E3D66756E6374696F6E2865297B746869732E5F5F6164645F73706163655F6265666F72655F746F6B656E28292C7468';
wwv_flow_imp.g_varchar2_table(3495) := '69732E63757272656E745F6C696E652E707573682865292C746869732E73706163655F6265666F72655F746F6B656E3D21312C746869732E6E6F6E5F627265616B696E675F73706163653D21312C746869732E70726576696F75735F746F6B656E5F7772';
wwv_flow_imp.g_varchar2_table(3496) := '61707065643D746869732E63757272656E745F6C696E652E5F616C6C6F775F7772617028297D2C692E70726F746F747970652E5F5F6164645F73706163655F6265666F72655F746F6B656E3D66756E6374696F6E28297B746869732E73706163655F6265';
wwv_flow_imp.g_varchar2_table(3497) := '666F72655F746F6B656E262621746869732E6A7573745F61646465645F6E65776C696E652829262628746869732E6E6F6E5F627265616B696E675F73706163657C7C746869732E7365745F777261705F706F696E7428292C746869732E63757272656E74';
wwv_flow_imp.g_varchar2_table(3498) := '5F6C696E652E707573682822202229297D2C692E70726F746F747970652E72656D6F76655F696E64656E743D66756E6374696F6E2865297B666F722876617220743D746869732E5F5F6C696E65732E6C656E6774683B653C743B29746869732E5F5F6C69';
wwv_flow_imp.g_varchar2_table(3499) := '6E65735B655D2E5F72656D6F76655F696E64656E7428292C652B2B3B746869732E63757272656E745F6C696E652E5F72656D6F76655F777261705F696E64656E7428297D2C692E70726F746F747970652E7472696D3D66756E6374696F6E2865297B666F';
wwv_flow_imp.g_varchar2_table(3500) := '7228653D766F69642030213D3D652626652C746869732E63757272656E745F6C696E652E7472696D28293B652626746869732E5F5F6C696E65732E6C656E6774683E312626746869732E63757272656E745F6C696E652E69735F656D70747928293B2974';
wwv_flow_imp.g_varchar2_table(3501) := '6869732E5F5F6C696E65732E706F7028292C746869732E63757272656E745F6C696E653D746869732E5F5F6C696E65735B746869732E5F5F6C696E65732E6C656E6774682D315D2C746869732E63757272656E745F6C696E652E7472696D28293B746869';
wwv_flow_imp.g_varchar2_table(3502) := '732E70726576696F75735F6C696E653D746869732E5F5F6C696E65732E6C656E6774683E313F746869732E5F5F6C696E65735B746869732E5F5F6C696E65732E6C656E6774682D325D3A6E756C6C7D2C692E70726F746F747970652E6A7573745F616464';
wwv_flow_imp.g_varchar2_table(3503) := '65645F6E65776C696E653D66756E6374696F6E28297B72657475726E20746869732E63757272656E745F6C696E652E69735F656D70747928297D2C692E70726F746F747970652E6A7573745F61646465645F626C616E6B6C696E653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3504) := '28297B72657475726E20746869732E69735F656D70747928297C7C746869732E63757272656E745F6C696E652E69735F656D70747928292626746869732E70726576696F75735F6C696E652E69735F656D70747928297D2C692E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(3505) := '656E737572655F656D7074795F6C696E655F61626F76653D66756E6374696F6E28652C6E297B666F722876617220693D746869732E5F5F6C696E65732E6C656E6774682D323B693E3D303B297B76617220723D746869732E5F5F6C696E65735B695D3B69';
wwv_flow_imp.g_varchar2_table(3506) := '6628722E69735F656D707479282929627265616B3B69662830213D3D722E6974656D2830292E696E6465784F662865292626722E6974656D282D3129213D3D6E297B746869732E5F5F6C696E65732E73706C69636528692B312C302C6E65772074287468';
wwv_flow_imp.g_varchar2_table(3507) := '697329292C746869732E70726576696F75735F6C696E653D746869732E5F5F6C696E65735B746869732E5F5F6C696E65732E6C656E6774682D325D3B627265616B7D692D2D7D7D2C652E6578706F7274732E4F75747075743D697D2C2C2C2C66756E6374';
wwv_flow_imp.g_varchar2_table(3508) := '696F6E2865297B66756E6374696F6E207428652C74297B746869732E7261775F6F7074696F6E733D6E28652C74292C746869732E64697361626C65643D746869732E5F6765745F626F6F6C65616E282264697361626C656422292C746869732E656F6C3D';
wwv_flow_imp.g_varchar2_table(3509) := '746869732E5F6765745F636861726163746572732822656F6C222C226175746F22292C746869732E656E645F776974685F6E65776C696E653D746869732E5F6765745F626F6F6C65616E2822656E645F776974685F6E65776C696E6522292C746869732E';
wwv_flow_imp.g_varchar2_table(3510) := '696E64656E745F73697A653D746869732E5F6765745F6E756D6265722822696E64656E745F73697A65222C34292C746869732E696E64656E745F636861723D746869732E5F6765745F636861726163746572732822696E64656E745F63686172222C2220';
wwv_flow_imp.g_varchar2_table(3511) := '22292C746869732E696E64656E745F6C6576656C3D746869732E5F6765745F6E756D6265722822696E64656E745F6C6576656C22292C746869732E70726573657276655F6E65776C696E65733D746869732E5F6765745F626F6F6C65616E282270726573';
wwv_flow_imp.g_varchar2_table(3512) := '657276655F6E65776C696E6573222C2130292C746869732E6D61785F70726573657276655F6E65776C696E65733D746869732E5F6765745F6E756D62657228226D61785F70726573657276655F6E65776C696E6573222C3332373836292C746869732E70';
wwv_flow_imp.g_varchar2_table(3513) := '726573657276655F6E65776C696E65737C7C28746869732E6D61785F70726573657276655F6E65776C696E65733D30292C746869732E696E64656E745F776974685F746162733D746869732E5F6765745F626F6F6C65616E2822696E64656E745F776974';
wwv_flow_imp.g_varchar2_table(3514) := '685F74616273222C225C74223D3D3D746869732E696E64656E745F63686172292C746869732E696E64656E745F776974685F74616273262628746869732E696E64656E745F636861723D225C74222C313D3D3D746869732E696E64656E745F73697A6526';
wwv_flow_imp.g_varchar2_table(3515) := '2628746869732E696E64656E745F73697A653D3429292C746869732E777261705F6C696E655F6C656E6774683D746869732E5F6765745F6E756D6265722822777261705F6C696E655F6C656E677468222C746869732E5F6765745F6E756D62657228226D';
wwv_flow_imp.g_varchar2_table(3516) := '61785F636861722229292C746869732E696E64656E745F656D7074795F6C696E65733D746869732E5F6765745F626F6F6C65616E2822696E64656E745F656D7074795F6C696E657322292C746869732E74656D706C6174696E673D746869732E5F676574';
wwv_flow_imp.g_varchar2_table(3517) := '5F73656C656374696F6E5F6C697374282274656D706C6174696E67222C5B226175746F222C226E6F6E65222C22646A616E676F222C22657262222C2268616E646C6562617273222C22706870222C22736D61727479225D2C5B226175746F225D297D6675';
wwv_flow_imp.g_varchar2_table(3518) := '6E6374696F6E206E28652C74297B766172206E2C723D7B7D3B666F72286E20696E20653D69286529296E213D3D74262628725B6E5D3D655B6E5D293B696628742626655B745D29666F72286E20696E20655B745D29725B6E5D3D655B745D5B6E5D3B7265';
wwv_flow_imp.g_varchar2_table(3519) := '7475726E20727D66756E6374696F6E20692865297B76617220742C6E3D7B7D3B666F72287420696E2065296E5B742E7265706C616365282F2D2F672C225F22295D3D655B745D3B72657475726E206E7D742E70726F746F747970652E5F6765745F617272';
wwv_flow_imp.g_varchar2_table(3520) := '61793D66756E6374696F6E28652C74297B766172206E3D746869732E7261775F6F7074696F6E735B655D2C693D747C7C5B5D3B72657475726E226F626A656374223D3D747970656F66206E3F6E756C6C213D3D6E26262266756E6374696F6E223D3D7479';
wwv_flow_imp.g_varchar2_table(3521) := '70656F66206E2E636F6E636174262628693D6E2E636F6E6361742829293A22737472696E67223D3D747970656F66206E262628693D6E2E73706C6974282F5B5E612D7A412D5A302D395F5C2F5C2D5D2B2F29292C697D2C742E70726F746F747970652E5F';
wwv_flow_imp.g_varchar2_table(3522) := '6765745F626F6F6C65616E3D66756E6374696F6E28652C74297B766172206E3D746869732E7261775F6F7074696F6E735B655D3B72657475726E20766F696420303D3D3D6E3F2121743A21216E7D2C742E70726F746F747970652E5F6765745F63686172';
wwv_flow_imp.g_varchar2_table(3523) := '6163746572733D66756E6374696F6E28652C74297B766172206E3D746869732E7261775F6F7074696F6E735B655D2C693D747C7C22223B72657475726E22737472696E67223D3D747970656F66206E262628693D6E2E7265706C616365282F5C5C722F2C';
wwv_flow_imp.g_varchar2_table(3524) := '225C7222292E7265706C616365282F5C5C6E2F2C225C6E22292E7265706C616365282F5C5C742F2C225C742229292C697D2C742E70726F746F747970652E5F6765745F6E756D6265723D66756E6374696F6E28652C74297B766172206E3D746869732E72';
wwv_flow_imp.g_varchar2_table(3525) := '61775F6F7074696F6E735B655D3B743D7061727365496E7428742C3130292C69734E614E287429262628743D30293B76617220693D7061727365496E74286E2C3130293B72657475726E2069734E614E286929262628693D74292C697D2C742E70726F74';
wwv_flow_imp.g_varchar2_table(3526) := '6F747970652E5F6765745F73656C656374696F6E3D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F6765745F73656C656374696F6E5F6C69737428652C742C6E293B69662831213D3D692E6C656E677468297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(3527) := '204572726F722822496E76616C6964204F7074696F6E2056616C75653A20546865206F7074696F6E2027222B652B22272063616E206F6E6C79206265206F6E65206F662074686520666F6C6C6F77696E672076616C7565733A5C6E222B742B225C6E596F';
wwv_flow_imp.g_varchar2_table(3528) := '752070617373656420696E3A2027222B746869732E7261775F6F7074696F6E735B655D2B222722293B72657475726E20695B305D7D2C742E70726F746F747970652E5F6765745F73656C656374696F6E5F6C6973743D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(3529) := '297B69662821747C7C303D3D3D742E6C656E677468297468726F77206E6577204572726F72282253656C656374696F6E206C6973742063616E6E6F7420626520656D7074792E22293B6966286E3D6E7C7C5B745B305D5D2C21746869732E5F69735F7661';
wwv_flow_imp.g_varchar2_table(3530) := '6C69645F73656C656374696F6E286E2C7429297468726F77206E6577204572726F722822496E76616C69642044656661756C742056616C75652122293B76617220693D746869732E5F6765745F617272617928652C6E293B69662821746869732E5F6973';
wwv_flow_imp.g_varchar2_table(3531) := '5F76616C69645F73656C656374696F6E28692C7429297468726F77206E6577204572726F722822496E76616C6964204F7074696F6E2056616C75653A20546865206F7074696F6E2027222B652B22272063616E20636F6E7461696E206F6E6C7920746865';
wwv_flow_imp.g_varchar2_table(3532) := '20666F6C6C6F77696E672076616C7565733A5C6E222B742B225C6E596F752070617373656420696E3A2027222B746869732E7261775F6F7074696F6E735B655D2B222722293B72657475726E20697D2C742E70726F746F747970652E5F69735F76616C69';
wwv_flow_imp.g_varchar2_table(3533) := '645F73656C656374696F6E3D66756E6374696F6E28652C74297B72657475726E20652E6C656E6774682626742E6C656E677468262621652E736F6D65282866756E6374696F6E2865297B72657475726E2D313D3D3D742E696E6465784F662865297D2929';
wwv_flow_imp.g_varchar2_table(3534) := '7D2C652E6578706F7274732E4F7074696F6E733D742C652E6578706F7274732E6E6F726D616C697A654F7074733D692C652E6578706F7274732E6D657267654F7074733D6E7D2C2C66756E6374696F6E2865297B76617220743D5265674578702E70726F';
wwv_flow_imp.g_varchar2_table(3535) := '746F747970652E6861734F776E50726F70657274792822737469636B7922293B66756E6374696F6E206E2865297B746869732E5F5F696E7075743D657C7C22222C746869732E5F5F696E7075745F6C656E6774683D746869732E5F5F696E7075742E6C65';
wwv_flow_imp.g_varchar2_table(3536) := '6E6774682C746869732E5F5F706F736974696F6E3D307D6E2E70726F746F747970652E726573746172743D66756E6374696F6E28297B746869732E5F5F706F736974696F6E3D307D2C6E2E70726F746F747970652E6261636B3D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(3537) := '7B746869732E5F5F706F736974696F6E3E30262628746869732E5F5F706F736974696F6E2D3D31297D2C6E2E70726F746F747970652E6861734E6578743D66756E6374696F6E28297B72657475726E20746869732E5F5F706F736974696F6E3C74686973';
wwv_flow_imp.g_varchar2_table(3538) := '2E5F5F696E7075745F6C656E6774687D2C6E2E70726F746F747970652E6E6578743D66756E6374696F6E28297B76617220653D6E756C6C3B72657475726E20746869732E6861734E6578742829262628653D746869732E5F5F696E7075742E6368617241';
wwv_flow_imp.g_varchar2_table(3539) := '7428746869732E5F5F706F736974696F6E292C746869732E5F5F706F736974696F6E2B3D31292C657D2C6E2E70726F746F747970652E7065656B3D66756E6374696F6E2865297B76617220743D6E756C6C3B72657475726E20653D657C7C302C28652B3D';
wwv_flow_imp.g_varchar2_table(3540) := '746869732E5F5F706F736974696F6E293E3D302626653C746869732E5F5F696E7075745F6C656E677468262628743D746869732E5F5F696E7075742E636861724174286529292C747D2C6E2E70726F746F747970652E5F5F6D617463683D66756E637469';
wwv_flow_imp.g_varchar2_table(3541) := '6F6E28652C6E297B652E6C617374496E6465783D6E3B76617220693D652E6578656328746869732E5F5F696E707574293B72657475726E21697C7C742626652E737469636B797C7C692E696E646578213D3D6E262628693D6E756C6C292C697D2C6E2E70';
wwv_flow_imp.g_varchar2_table(3542) := '726F746F747970652E746573743D66756E6374696F6E28652C74297B72657475726E20743D747C7C302C28742B3D746869732E5F5F706F736974696F6E293E3D302626743C746869732E5F5F696E7075745F6C656E67746826262121746869732E5F5F6D';
wwv_flow_imp.g_varchar2_table(3543) := '6174636828652C74297D2C6E2E70726F746F747970652E74657374436861723D66756E6374696F6E28652C74297B766172206E3D746869732E7065656B2874293B72657475726E20652E6C617374496E6465783D302C6E756C6C213D3D6E2626652E7465';
wwv_flow_imp.g_varchar2_table(3544) := '7374286E297D2C6E2E70726F746F747970652E6D617463683D66756E6374696F6E2865297B76617220743D746869732E5F5F6D6174636828652C746869732E5F5F706F736974696F6E293B72657475726E20743F746869732E5F5F706F736974696F6E2B';
wwv_flow_imp.g_varchar2_table(3545) := '3D745B305D2E6C656E6774683A743D6E756C6C2C747D2C6E2E70726F746F747970652E726561643D66756E6374696F6E28652C742C6E297B76617220692C723D22223B72657475726E2065262628693D746869732E6D6174636828652929262628722B3D';
wwv_flow_imp.g_varchar2_table(3546) := '695B305D292C21747C7C21692626657C7C28722B3D746869732E72656164556E74696C28742C6E29292C727D2C6E2E70726F746F747970652E72656164556E74696C3D66756E6374696F6E28652C74297B766172206E2C693D746869732E5F5F706F7369';
wwv_flow_imp.g_varchar2_table(3547) := '74696F6E3B652E6C617374496E6465783D746869732E5F5F706F736974696F6E3B76617220723D652E6578656328746869732E5F5F696E707574293B72657475726E20723F28693D722E696E6465782C74262628692B3D725B305D2E6C656E6774682929';
wwv_flow_imp.g_varchar2_table(3548) := '3A693D746869732E5F5F696E7075745F6C656E6774682C6E3D746869732E5F5F696E7075742E737562737472696E6728746869732E5F5F706F736974696F6E2C69292C746869732E5F5F706F736974696F6E3D692C6E7D2C6E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(3549) := '72656164556E74696C41667465723D66756E6374696F6E2865297B72657475726E20746869732E72656164556E74696C28652C2130297D2C6E2E70726F746F747970652E6765745F7265676578703D66756E6374696F6E28652C6E297B76617220693D6E';
wwv_flow_imp.g_varchar2_table(3550) := '756C6C2C723D2267223B72657475726E206E262674262628723D227922292C22737472696E67223D3D747970656F66206526262222213D3D653F693D6E65772052656745787028652C72293A65262628693D6E65772052656745787028652E736F757263';
wwv_flow_imp.g_varchar2_table(3551) := '652C7229292C697D2C6E2E70726F746F747970652E6765745F6C69746572616C5F7265676578703D66756E6374696F6E2865297B72657475726E2052656745787028652E7265706C616365282F5B2D5C2F5C5C5E242A2B3F2E28297C5B5C5D7B7D5D2F67';
wwv_flow_imp.g_varchar2_table(3552) := '2C225C5C24262229297D2C6E2E70726F746F747970652E7065656B556E74696C41667465723D66756E6374696F6E2865297B76617220743D746869732E5F5F706F736974696F6E2C6E3D746869732E72656164556E74696C41667465722865293B726574';
wwv_flow_imp.g_varchar2_table(3553) := '75726E20746869732E5F5F706F736974696F6E3D742C6E7D2C6E2E70726F746F747970652E6C6F6F6B4261636B3D66756E6374696F6E2865297B76617220743D746869732E5F5F706F736974696F6E2D313B72657475726E20743E3D652E6C656E677468';
wwv_flow_imp.g_varchar2_table(3554) := '2626746869732E5F5F696E7075742E737562737472696E6728742D652E6C656E6774682C74292E746F4C6F7765724361736528293D3D3D657D2C652E6578706F7274732E496E7075745363616E6E65723D6E7D2C2C2C2C2C66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(3555) := '66756E6374696F6E207428652C74297B653D22737472696E67223D3D747970656F6620653F653A652E736F757263652C743D22737472696E67223D3D747970656F6620743F743A742E736F757263652C746869732E5F5F646972656374697665735F626C';
wwv_flow_imp.g_varchar2_table(3556) := '6F636B5F7061747465726E3D6E65772052656745787028652B2F20626561757469667928205C772B5B3A5D5C772B292B202F2E736F757263652B742C226722292C746869732E5F5F6469726563746976655F7061747465726E3D2F20285C772B295B3A5D';
wwv_flow_imp.g_varchar2_table(3557) := '285C772B292F672C746869732E5F5F646972656374697665735F656E645F69676E6F72655F7061747465726E3D6E65772052656745787028652B2F5C7362656175746966795C7369676E6F72653A656E645C732F2E736F757263652B742C226722297D74';
wwv_flow_imp.g_varchar2_table(3558) := '2E70726F746F747970652E6765745F646972656374697665733D66756E6374696F6E2865297B69662821652E6D6174636828746869732E5F5F646972656374697665735F626C6F636B5F7061747465726E292972657475726E206E756C6C3B7661722074';
wwv_flow_imp.g_varchar2_table(3559) := '3D7B7D3B746869732E5F5F6469726563746976655F7061747465726E2E6C617374496E6465783D303B666F7228766172206E3D746869732E5F5F6469726563746976655F7061747465726E2E657865632865293B6E3B29745B6E5B315D5D3D6E5B325D2C';
wwv_flow_imp.g_varchar2_table(3560) := '6E3D746869732E5F5F6469726563746976655F7061747465726E2E657865632865293B72657475726E20747D2C742E70726F746F747970652E7265616449676E6F7265643D66756E6374696F6E2865297B72657475726E20652E72656164556E74696C41';
wwv_flow_imp.g_varchar2_table(3561) := '6674657228746869732E5F5F646972656374697665735F656E645F69676E6F72655F7061747465726E297D2C652E6578706F7274732E446972656374697665733D747D2C2C66756E6374696F6E28652C742C6E297B76617220693D6E283136292E426561';
wwv_flow_imp.g_varchar2_table(3562) := '757469666965722C723D6E283137292E4F7074696F6E733B652E6578706F7274733D66756E6374696F6E28652C74297B72657475726E206E6577206928652C74292E626561757469667928297D2C652E6578706F7274732E64656661756C744F7074696F';
wwv_flow_imp.g_varchar2_table(3563) := '6E733D66756E6374696F6E28297B72657475726E206E657720727D7D2C66756E6374696F6E28652C742C6E297B76617220693D6E283137292E4F7074696F6E732C723D6E2832292E4F75747075742C6F3D6E2838292E496E7075745363616E6E65722C61';
wwv_flow_imp.g_varchar2_table(3564) := '3D6E657728302C6E283133292E4469726563746976657329282F5C2F5C2A2F2C2F5C2A5C2F2F292C733D2F5C725C6E7C5B5C725C6E5D2F2C6C3D2F5C725C6E7C5B5C725C6E5D2F672C683D2F5C732F2C633D2F283F3A5C737C5C6E292B2F672C643D2F5C';
wwv_flow_imp.g_varchar2_table(3565) := '2F5C2A283F3A5B5C735C535D2A3F2928283F3A5C2A5C2F297C24292F672C753D2F5C2F5C2F283F3A5B5E5C6E5C725C75323032385C75323032395D2A292F673B66756E6374696F6E206D28652C74297B746869732E5F736F757263655F746578743D657C';
wwv_flow_imp.g_varchar2_table(3566) := '7C22222C746869732E5F6F7074696F6E733D6E657720692874292C746869732E5F63683D6E756C6C2C746869732E5F696E7075743D6E756C6C2C746869732E4E45535445445F41545F52554C453D7B224070616765223A21302C2240666F6E742D666163';
wwv_flow_imp.g_varchar2_table(3567) := '65223A21302C22406B65796672616D6573223A21302C22406D65646961223A21302C2240737570706F727473223A21302C2240646F63756D656E74223A21307D2C746869732E434F4E444954494F4E414C5F47524F55505F52554C453D7B22406D656469';
wwv_flow_imp.g_varchar2_table(3568) := '61223A21302C2240737570706F727473223A21302C2240646F63756D656E74223A21307D7D6D2E70726F746F747970652E656174537472696E673D66756E6374696F6E2865297B76617220743D22223B666F7228746869732E5F63683D746869732E5F69';
wwv_flow_imp.g_varchar2_table(3569) := '6E7075742E6E65787428293B746869732E5F63683B297B696628742B3D746869732E5F63682C225C5C223D3D3D746869732E5F636829742B3D746869732E5F696E7075742E6E65787428293B656C7365206966282D31213D3D652E696E6465784F662874';
wwv_flow_imp.g_varchar2_table(3570) := '6869732E5F6368297C7C225C6E223D3D3D746869732E5F636829627265616B3B746869732E5F63683D746869732E5F696E7075742E6E65787428297D72657475726E20747D2C6D2E70726F746F747970652E656174576869746573706163653D66756E63';
wwv_flow_imp.g_varchar2_table(3571) := '74696F6E2865297B666F722876617220743D682E7465737428746869732E5F696E7075742E7065656B2829292C6E3D303B682E7465737428746869732E5F696E7075742E7065656B2829293B29746869732E5F63683D746869732E5F696E7075742E6E65';
wwv_flow_imp.g_varchar2_table(3572) := '787428292C652626225C6E223D3D3D746869732E5F6368262628303D3D3D6E7C7C6E3C746869732E5F6F7074696F6E732E6D61785F70726573657276655F6E65776C696E6573292626286E2B2B2C746869732E5F6F75747075742E6164645F6E65775F6C';
wwv_flow_imp.g_varchar2_table(3573) := '696E6528213029293B72657475726E20747D2C6D2E70726F746F747970652E666F756E644E657374656450736575646F436C6173733D66756E6374696F6E28297B666F722876617220653D302C743D312C6E3D746869732E5F696E7075742E7065656B28';
wwv_flow_imp.g_varchar2_table(3574) := '74293B6E3B297B696628227B223D3D3D6E2972657475726E21303B6966282228223D3D3D6E29652B3D313B656C7365206966282229223D3D3D6E297B696628303D3D3D652972657475726E21313B652D3D317D656C736520696628223B223D3D3D6E7C7C';
wwv_flow_imp.g_varchar2_table(3575) := '227D223D3D3D6E2972657475726E21313B742B2B2C6E3D746869732E5F696E7075742E7065656B2874297D72657475726E21317D2C6D2E70726F746F747970652E7072696E745F737472696E673D66756E6374696F6E2865297B746869732E5F6F757470';
wwv_flow_imp.g_varchar2_table(3576) := '75742E7365745F696E64656E7428746869732E5F696E64656E744C6576656C292C746869732E5F6F75747075742E6E6F6E5F627265616B696E675F73706163653D21302C746869732E5F6F75747075742E6164645F746F6B656E2865297D2C6D2E70726F';
wwv_flow_imp.g_varchar2_table(3577) := '746F747970652E707265736572766553696E676C6553706163653D66756E6374696F6E2865297B65262628746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D2130297D2C6D2E70726F746F747970652E696E64656E743D66';
wwv_flow_imp.g_varchar2_table(3578) := '756E6374696F6E28297B746869732E5F696E64656E744C6576656C2B2B7D2C6D2E70726F746F747970652E6F757464656E743D66756E6374696F6E28297B746869732E5F696E64656E744C6576656C3E302626746869732E5F696E64656E744C6576656C';
wwv_flow_imp.g_varchar2_table(3579) := '2D2D7D2C6D2E70726F746F747970652E62656175746966793D66756E6374696F6E28297B696628746869732E5F6F7074696F6E732E64697361626C65642972657475726E20746869732E5F736F757263655F746578743B76617220653D746869732E5F73';
wwv_flow_imp.g_varchar2_table(3580) := '6F757263655F746578742C743D746869732E5F6F7074696F6E732E656F6C3B226175746F223D3D3D74262628743D225C6E222C652626732E7465737428657C7C222229262628743D652E6D617463682873295B305D29293B766172206E3D28653D652E72';
wwv_flow_imp.g_varchar2_table(3581) := '65706C616365286C2C225C6E2229292E6D61746368282F5E5B5C74205D2A2F295B305D3B746869732E5F6F75747075743D6E6577207228746869732E5F6F7074696F6E732C6E292C746869732E5F696E7075743D6E6577206F2865292C746869732E5F69';
wwv_flow_imp.g_varchar2_table(3582) := '6E64656E744C6576656C3D302C746869732E5F6E65737465644C6576656C3D302C746869732E5F63683D6E756C6C3B666F722876617220692C6D2C703D302C663D21312C673D21312C623D21312C5F3D21312C763D21312C773D746869732E5F63683B69';
wwv_flow_imp.g_varchar2_table(3583) := '3D2222213D3D746869732E5F696E7075742E726561642863292C6D3D772C746869732E5F63683D746869732E5F696E7075742E6E65787428292C225C5C223D3D3D746869732E5F63682626746869732E5F696E7075742E6861734E657874282926262874';
wwv_flow_imp.g_varchar2_table(3584) := '6869732E5F63682B3D746869732E5F696E7075742E6E6578742829292C773D746869732E5F63682C746869732E5F63683B29696628222F223D3D3D746869732E5F63682626222A223D3D3D746869732E5F696E7075742E7065656B2829297B746869732E';
wwv_flow_imp.g_varchar2_table(3585) := '5F6F75747075742E6164645F6E65775F6C696E6528292C746869732E5F696E7075742E6261636B28293B76617220793D746869732E5F696E7075742E726561642864292C543D612E6765745F646972656374697665732879293B54262622737461727422';
wwv_flow_imp.g_varchar2_table(3586) := '3D3D3D542E69676E6F7265262628792B3D612E7265616449676E6F72656428746869732E5F696E70757429292C746869732E7072696E745F737472696E672879292C746869732E65617457686974657370616365282130292C746869732E5F6F75747075';
wwv_flow_imp.g_varchar2_table(3587) := '742E6164645F6E65775F6C696E6528297D656C736520696628222F223D3D3D746869732E5F63682626222F223D3D3D746869732E5F696E7075742E7065656B282929746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D2130';
wwv_flow_imp.g_varchar2_table(3588) := '2C746869732E5F696E7075742E6261636B28292C746869732E7072696E745F737472696E6728746869732E5F696E7075742E72656164287529292C746869732E65617457686974657370616365282130293B656C7365206966282240223D3D3D74686973';
wwv_flow_imp.g_varchar2_table(3589) := '2E5F636829696628746869732E707265736572766553696E676C6553706163652869292C227B223D3D3D746869732E5F696E7075742E7065656B282929746869732E7072696E745F737472696E6728746869732E5F63682B746869732E65617453747269';
wwv_flow_imp.g_varchar2_table(3590) := '6E6728227D2229293B656C73657B746869732E7072696E745F737472696E6728746869732E5F6368293B766172206B3D746869732E5F696E7075742E7065656B556E74696C4166746572282F5B3A202C3B7B7D28295B5C5D5C2F3D27225D2F67293B6B2E';
wwv_flow_imp.g_varchar2_table(3591) := '6D61746368282F5B203A5D242F292626286B3D746869732E656174537472696E6728223A2022292E7265706C616365282F5C73242F2C2222292C746869732E7072696E745F737472696E67286B292C746869732E5F6F75747075742E73706163655F6265';
wwv_flow_imp.g_varchar2_table(3592) := '666F72655F746F6B656E3D2130292C22657874656E64223D3D3D286B3D6B2E7265706C616365282F5C73242F2C222229293F5F3D21303A22696D706F7274223D3D3D6B262628763D2130292C6B20696E20746869732E4E45535445445F41545F52554C45';
wwv_flow_imp.g_varchar2_table(3593) := '3F28746869732E5F6E65737465644C6576656C2B3D312C6B20696E20746869732E434F4E444954494F4E414C5F47524F55505F52554C45262628623D213029293A667C7C30213D3D707C7C2D313D3D3D6B2E696E6465784F6628223A22297C7C28673D21';
wwv_flow_imp.g_varchar2_table(3594) := '302C746869732E696E64656E742829297D656C73652223223D3D3D746869732E5F63682626227B223D3D3D746869732E5F696E7075742E7065656B28293F28746869732E707265736572766553696E676C6553706163652869292C746869732E7072696E';
wwv_flow_imp.g_varchar2_table(3595) := '745F737472696E6728746869732E5F63682B746869732E656174537472696E6728227D222929293A227B223D3D3D746869732E5F63683F2867262628673D21312C746869732E6F757464656E742829292C623F28623D21312C663D746869732E5F696E64';
wwv_flow_imp.g_varchar2_table(3596) := '656E744C6576656C3E3D746869732E5F6E65737465644C6576656C293A663D746869732E5F696E64656E744C6576656C3E3D746869732E5F6E65737465644C6576656C2D312C746869732E5F6F7074696F6E732E6E65776C696E655F6265747765656E5F';
wwv_flow_imp.g_varchar2_table(3597) := '72756C65732626662626746869732E5F6F75747075742E70726576696F75735F6C696E652626227B22213D3D746869732E5F6F75747075742E70726576696F75735F6C696E652E6974656D282D31292626746869732E5F6F75747075742E656E73757265';
wwv_flow_imp.g_varchar2_table(3598) := '5F656D7074795F6C696E655F61626F766528222F222C222C22292C746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D21302C22657870616E64223D3D3D746869732E5F6F7074696F6E732E62726163655F7374796C653F28';
wwv_flow_imp.g_varchar2_table(3599) := '746869732E5F6F75747075742E6164645F6E65775F6C696E6528292C746869732E7072696E745F737472696E6728746869732E5F6368292C746869732E696E64656E7428292C746869732E5F6F75747075742E7365745F696E64656E7428746869732E5F';
wwv_flow_imp.g_varchar2_table(3600) := '696E64656E744C6576656C29293A28746869732E696E64656E7428292C746869732E7072696E745F737472696E6728746869732E5F636829292C746869732E65617457686974657370616365282130292C746869732E5F6F75747075742E6164645F6E65';
wwv_flow_imp.g_varchar2_table(3601) := '775F6C696E652829293A227D223D3D3D746869732E5F63683F28746869732E6F757464656E7428292C746869732E5F6F75747075742E6164645F6E65775F6C696E6528292C227B223D3D3D6D2626746869732E5F6F75747075742E7472696D282130292C';
wwv_flow_imp.g_varchar2_table(3602) := '763D21312C5F3D21312C67262628746869732E6F757464656E7428292C673D2131292C746869732E7072696E745F737472696E6728746869732E5F6368292C663D21312C746869732E5F6E65737465644C6576656C2626746869732E5F6E65737465644C';
wwv_flow_imp.g_varchar2_table(3603) := '6576656C2D2D2C746869732E65617457686974657370616365282130292C746869732E5F6F75747075742E6164645F6E65775F6C696E6528292C746869732E5F6F7074696F6E732E6E65776C696E655F6265747765656E5F72756C657326262174686973';
wwv_flow_imp.g_varchar2_table(3604) := '2E5F6F75747075742E6A7573745F61646465645F626C616E6B6C696E6528292626227D22213D3D746869732E5F696E7075742E7065656B28292626746869732E5F6F75747075742E6164645F6E65775F6C696E6528213029293A223A223D3D3D74686973';
wwv_flow_imp.g_varchar2_table(3605) := '2E5F63683F2166262621627C7C746869732E5F696E7075742E6C6F6F6B4261636B28222622297C7C746869732E666F756E644E657374656450736575646F436C61737328297C7C746869732E5F696E7075742E6C6F6F6B4261636B28222822297C7C5F7C';
wwv_flow_imp.g_varchar2_table(3606) := '7C30213D3D703F28746869732E5F696E7075742E6C6F6F6B4261636B2822202229262628746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D2130292C223A223D3D3D746869732E5F696E7075742E7065656B28293F287468';
wwv_flow_imp.g_varchar2_table(3607) := '69732E5F63683D746869732E5F696E7075742E6E65787428292C746869732E7072696E745F737472696E6728223A3A2229293A746869732E7072696E745F737472696E6728223A2229293A28746869732E7072696E745F737472696E6728223A22292C67';
wwv_flow_imp.g_varchar2_table(3608) := '7C7C28673D21302C746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D21302C746869732E65617457686974657370616365282130292C746869732E696E64656E74282929293A2722273D3D3D746869732E5F63687C7C2227';
wwv_flow_imp.g_varchar2_table(3609) := '223D3D3D746869732E5F63683F28746869732E707265736572766553696E676C6553706163652869292C746869732E7072696E745F737472696E6728746869732E5F63682B746869732E656174537472696E6728746869732E5F636829292C746869732E';
wwv_flow_imp.g_varchar2_table(3610) := '6561745768697465737061636528213029293A223B223D3D3D746869732E5F63683F303D3D3D703F2867262628746869732E6F757464656E7428292C673D2131292C5F3D21312C763D21312C746869732E7072696E745F737472696E6728746869732E5F';
wwv_flow_imp.g_varchar2_table(3611) := '6368292C746869732E65617457686974657370616365282130292C222F22213D3D746869732E5F696E7075742E7065656B28292626746869732E5F6F75747075742E6164645F6E65775F6C696E652829293A28746869732E7072696E745F737472696E67';
wwv_flow_imp.g_varchar2_table(3612) := '28746869732E5F6368292C746869732E65617457686974657370616365282130292C746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D2130293A2228223D3D3D746869732E5F63683F746869732E5F696E7075742E6C6F6F';
wwv_flow_imp.g_varchar2_table(3613) := '6B4261636B282275726C22293F28746869732E7072696E745F737472696E6728746869732E5F6368292C746869732E6561745768697465737061636528292C702B2B2C746869732E696E64656E7428292C746869732E5F63683D746869732E5F696E7075';
wwv_flow_imp.g_varchar2_table(3614) := '742E6E65787428292C2229223D3D3D746869732E5F63687C7C2722273D3D3D746869732E5F63687C7C2227223D3D3D746869732E5F63683F746869732E5F696E7075742E6261636B28293A746869732E5F6368262628746869732E7072696E745F737472';
wwv_flow_imp.g_varchar2_table(3615) := '696E6728746869732E5F63682B746869732E656174537472696E672822292229292C70262628702D2D2C746869732E6F757464656E7428292929293A28746869732E707265736572766553696E676C6553706163652869292C746869732E7072696E745F';
wwv_flow_imp.g_varchar2_table(3616) := '737472696E6728746869732E5F6368292C746869732E6561745768697465737061636528292C702B2B2C746869732E696E64656E742829293A2229223D3D3D746869732E5F63683F2870262628702D2D2C746869732E6F757464656E742829292C746869';
wwv_flow_imp.g_varchar2_table(3617) := '732E7072696E745F737472696E6728746869732E5F636829293A222C223D3D3D746869732E5F63683F28746869732E7072696E745F737472696E6728746869732E5F6368292C746869732E65617457686974657370616365282130292C21746869732E5F';
wwv_flow_imp.g_varchar2_table(3618) := '6F7074696F6E732E73656C6563746F725F736570617261746F725F6E65776C696E657C7C677C7C30213D3D707C7C767C7C5F3F746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D21303A746869732E5F6F75747075742E61';
wwv_flow_imp.g_varchar2_table(3619) := '64645F6E65775F6C696E652829293A223E22213D3D746869732E5F63682626222B22213D3D746869732E5F63682626227E22213D3D746869732E5F63687C7C677C7C30213D3D703F225D223D3D3D746869732E5F63683F746869732E7072696E745F7374';
wwv_flow_imp.g_varchar2_table(3620) := '72696E6728746869732E5F6368293A225B223D3D3D746869732E5F63683F28746869732E707265736572766553696E676C6553706163652869292C746869732E7072696E745F737472696E6728746869732E5F636829293A223D223D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(3621) := '63683F28746869732E6561745768697465737061636528292C746869732E7072696E745F737472696E6728223D22292C682E7465737428746869732E5F636829262628746869732E5F63683D222229293A222122213D3D746869732E5F63687C7C746869';
wwv_flow_imp.g_varchar2_table(3622) := '732E5F696E7075742E6C6F6F6B4261636B28225C5C22293F28746869732E707265736572766553696E676C6553706163652869292C746869732E7072696E745F737472696E6728746869732E5F636829293A28746869732E7072696E745F737472696E67';
wwv_flow_imp.g_varchar2_table(3623) := '28222022292C746869732E7072696E745F737472696E6728746869732E5F636829293A746869732E5F6F7074696F6E732E73706163655F61726F756E645F636F6D62696E61746F723F28746869732E5F6F75747075742E73706163655F6265666F72655F';
wwv_flow_imp.g_varchar2_table(3624) := '746F6B656E3D21302C746869732E7072696E745F737472696E6728746869732E5F6368292C746869732E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D2130293A28746869732E7072696E745F737472696E6728746869732E5F6368';
wwv_flow_imp.g_varchar2_table(3625) := '292C746869732E6561745768697465737061636528292C746869732E5F63682626682E7465737428746869732E5F636829262628746869732E5F63683D222229293B72657475726E20746869732E5F6F75747075742E6765745F636F64652874297D2C65';
wwv_flow_imp.g_varchar2_table(3626) := '2E6578706F7274732E426561757469666965723D6D7D2C66756E6374696F6E28652C742C6E297B76617220693D6E2836292E4F7074696F6E733B66756E6374696F6E20722865297B692E63616C6C28746869732C652C2263737322292C746869732E7365';
wwv_flow_imp.g_varchar2_table(3627) := '6C6563746F725F736570617261746F725F6E65776C696E653D746869732E5F6765745F626F6F6C65616E282273656C6563746F725F736570617261746F725F6E65776C696E65222C2130292C746869732E6E65776C696E655F6265747765656E5F72756C';
wwv_flow_imp.g_varchar2_table(3628) := '65733D746869732E5F6765745F626F6F6C65616E28226E65776C696E655F6265747765656E5F72756C6573222C2130293B76617220743D746869732E5F6765745F626F6F6C65616E282273706163655F61726F756E645F73656C6563746F725F73657061';
wwv_flow_imp.g_varchar2_table(3629) := '7261746F7222293B746869732E73706163655F61726F756E645F636F6D62696E61746F723D746869732E5F6765745F626F6F6C65616E282273706163655F61726F756E645F636F6D62696E61746F7222297C7C743B766172206E3D746869732E5F676574';
wwv_flow_imp.g_varchar2_table(3630) := '5F73656C656374696F6E5F6C697374282262726163655F7374796C65222C5B22636F6C6C61707365222C22657870616E64222C22656E642D657870616E64222C226E6F6E65222C2270726573657276652D696E6C696E65225D293B746869732E62726163';
wwv_flow_imp.g_varchar2_table(3631) := '655F7374796C653D22636F6C6C61707365223B666F722876617220723D303B723C6E2E6C656E6774683B722B2B2922657870616E6422213D3D6E5B725D3F746869732E62726163655F7374796C653D22636F6C6C61707365223A746869732E6272616365';
wwv_flow_imp.g_varchar2_table(3632) := '5F7374796C653D6E5B725D7D722E70726F746F747970653D6E657720692C652E6578706F7274732E4F7074696F6E733D727D5D2C616C3D7B7D3B76617220636C2C646C2C756C3D66756E6374696F6E20652874297B766172206E3D616C5B745D3B696628';
wwv_flow_imp.g_varchar2_table(3633) := '766F69642030213D3D6E2972657475726E206E2E6578706F7274733B76617220693D616C5B745D3D7B6578706F7274733A7B7D7D3B72657475726E206F6C5B745D28692C692E6578706F7274732C65292C692E6578706F7274737D283135293B66756E63';
wwv_flow_imp.g_varchar2_table(3634) := '74696F6E206D6C28652C742C6E297B76617220693D652E6765745465787428292C723D21302C6F3D302C613D6E2E74616253697A657C7C343B69662874297B666F722876617220733D652E6F6666736574417428742E7374617274292C6C3D733B6C3E30';
wwv_flow_imp.g_varchar2_table(3635) := '26265F6C28692C6C2D31293B296C2D2D3B303D3D3D6C7C7C626C28692C6C2D31293F733D6C3A6C3C73262628733D6C2B31293B666F722876617220683D652E6F6666736574417428742E656E64292C633D683B633C692E6C656E67746826265F6C28692C';
wwv_flow_imp.g_varchar2_table(3636) := '63293B29632B2B3B28633D3D3D692E6C656E6774687C7C626C28692C632929262628683D63292C743D616F2E63726561746528652E706F736974696F6E41742873292C652E706F736974696F6E4174286829293B76617220643D692E737562737472696E';
wwv_flow_imp.g_varchar2_table(3637) := '6728302C73293B6966286E657720526567457870282F2E2A5B3C5D5B5E3E5D2A242F292E746573742864292972657475726E5B7B72616E67653A742C6E6577546578743A693D692E737562737472696E6728732C68297D5D3B696628723D683D3D3D692E';
wwv_flow_imp.g_varchar2_table(3638) := '6C656E6774682C693D692E737562737472696E6728732C68292C30213D3D73297B76617220753D652E6F6666736574417428726F2E63726561746528742E73746172742E6C696E652C3029293B6F3D66756E6374696F6E28652C742C6E297B666F722876';
wwv_flow_imp.g_varchar2_table(3639) := '617220693D742C723D302C6F3D6E2E74616253697A657C7C343B693C652E6C656E6774683B297B76617220613D652E6368617241742869293B6966282220223D3D3D6129722B2B3B656C73657B696628225C7422213D3D6129627265616B3B722B3D6F7D';
wwv_flow_imp.g_varchar2_table(3640) := '692B2B7D72657475726E204D6174682E666C6F6F7228722F6F297D28652E6765745465787428292C752C6E297D7D656C736520743D616F2E63726561746528726F2E63726561746528302C30292C652E706F736974696F6E417428692E6C656E67746829';
wwv_flow_imp.g_varchar2_table(3641) := '293B766172206D3D7B696E64656E745F73697A653A612C696E64656E745F636861723A6E2E696E736572745370616365733F2220223A225C74222C696E64656E745F656D7074795F6C696E65733A706C286E2C22696E64656E74456D7074794C696E6573';
wwv_flow_imp.g_varchar2_table(3642) := '222C2131292C777261705F6C696E655F6C656E6774683A706C286E2C22777261704C696E654C656E677468222C313230292C756E666F726D61747465643A666C286E2C22756E666F726D6174746564222C766F69642030292C636F6E74656E745F756E66';
wwv_flow_imp.g_varchar2_table(3643) := '6F726D61747465643A666C286E2C22636F6E74656E74556E666F726D6174746564222C766F69642030292C696E64656E745F696E6E65725F68746D6C3A706C286E2C22696E64656E74496E6E657248746D6C222C2131292C70726573657276655F6E6577';
wwv_flow_imp.g_varchar2_table(3644) := '6C696E65733A706C286E2C2270726573657276654E65774C696E6573222C2130292C6D61785F70726573657276655F6E65776C696E65733A706C286E2C226D617850726573657276654E65774C696E6573222C3332373836292C696E64656E745F68616E';
wwv_flow_imp.g_varchar2_table(3645) := '646C65626172733A706C286E2C22696E64656E7448616E646C6562617273222C2131292C656E645F776974685F6E65776C696E653A722626706C286E2C22656E64576974684E65776C696E65222C2131292C65787472615F6C696E6572733A666C286E2C';
wwv_flow_imp.g_varchar2_table(3646) := '2265787472614C696E657273222C766F69642030292C777261705F617474726962757465733A706C286E2C227772617041747472696275746573222C226175746F22292C777261705F617474726962757465735F696E64656E745F73697A653A706C286E';
wwv_flow_imp.g_varchar2_table(3647) := '2C227772617041747472696275746573496E64656E7453697A65222C766F69642030292C656F6C3A225C6E222C696E64656E745F736372697074733A706C286E2C22696E64656E7453637269707473222C226E6F726D616C22292C74656D706C6174696E';
wwv_flow_imp.g_varchar2_table(3648) := '673A676C286E2C22616C6C22292C756E666F726D61747465645F636F6E74656E745F64656C696D697465723A706C286E2C22756E666F726D6174746564436F6E74656E7444656C696D69746572222C2222297D2C703D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(3649) := '72657475726E20636C28652C742C686C2C756C297D28692E7265706C616365282F5E5C732B2F2C2222292C6D293B6966286F3E30297B76617220663D6E2E696E736572745370616365733F4473282220222C612A6F293A447328225C74222C6F293B703D';
wwv_flow_imp.g_varchar2_table(3650) := '702E73706C697428225C6E22292E6A6F696E28225C6E222B66292C303D3D3D742E73746172742E636861726163746572262628703D662B70297D72657475726E5B7B72616E67653A742C6E6577546578743A707D5D7D66756E6374696F6E20706C28652C';
wwv_flow_imp.g_varchar2_table(3651) := '742C6E297B696628652626652E6861734F776E50726F7065727479287429297B76617220693D655B745D3B6966286E756C6C213D3D692972657475726E20697D72657475726E206E7D66756E6374696F6E20666C28652C742C6E297B76617220693D706C';
wwv_flow_imp.g_varchar2_table(3652) := '28652C742C6E756C6C293B72657475726E22737472696E67223D3D747970656F6620693F692E6C656E6774683E303F692E73706C697428222C22292E6D6170282866756E6374696F6E2865297B72657475726E20652E7472696D28292E746F4C6F776572';
wwv_flow_imp.g_varchar2_table(3653) := '4361736528297D29293A5B5D3A6E7D66756E6374696F6E20676C28652C74297B72657475726E21303D3D3D706C28652C2274656D706C6174696E67222C74293F5B226175746F225D3A5B226E6F6E65225D7D66756E6374696F6E20626C28652C74297B72';
wwv_flow_imp.g_varchar2_table(3654) := '657475726E2D31213D3D225C725C6E222E696E6465784F6628652E636861724174287429297D66756E6374696F6E205F6C28652C74297B72657475726E2D31213D3D22205C74222E696E6465784F6628652E636861724174287429297D2166756E637469';
wwv_flow_imp.g_varchar2_table(3655) := '6F6E28297B76617220653D5B2C2C66756E6374696F6E2865297B66756E6374696F6E20742865297B746869732E5F5F706172656E743D652C746869732E5F5F6368617261637465725F636F756E743D302C746869732E5F5F696E64656E745F636F756E74';
wwv_flow_imp.g_varchar2_table(3656) := '3D2D312C746869732E5F5F616C69676E6D656E745F636F756E743D302C746869732E5F5F777261705F706F696E745F696E6465783D302C746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E743D302C746869732E5F5F7772';
wwv_flow_imp.g_varchar2_table(3657) := '61705F706F696E745F696E64656E745F636F756E743D2D312C746869732E5F5F777261705F706F696E745F616C69676E6D656E745F636F756E743D302C746869732E5F5F6974656D733D5B5D7D66756E6374696F6E206E28652C74297B746869732E5F5F';
wwv_flow_imp.g_varchar2_table(3658) := '63616368653D5B22225D2C746869732E5F5F696E64656E745F73697A653D652E696E64656E745F73697A652C746869732E5F5F696E64656E745F737472696E673D652E696E64656E745F636861722C652E696E64656E745F776974685F746162737C7C28';
wwv_flow_imp.g_varchar2_table(3659) := '746869732E5F5F696E64656E745F737472696E673D6E657720417272617928652E696E64656E745F73697A652B31292E6A6F696E28652E696E64656E745F6368617229292C743D747C7C22222C652E696E64656E745F6C6576656C3E30262628743D6E65';
wwv_flow_imp.g_varchar2_table(3660) := '7720417272617928652E696E64656E745F6C6576656C2B31292E6A6F696E28746869732E5F5F696E64656E745F737472696E6729292C746869732E5F5F626173655F737472696E673D742C746869732E5F5F626173655F737472696E675F6C656E677468';
wwv_flow_imp.g_varchar2_table(3661) := '3D742E6C656E6774687D66756E6374696F6E206928652C69297B746869732E5F5F696E64656E745F63616368653D6E6577206E28652C69292C746869732E7261773D21312C746869732E5F656E645F776974685F6E65776C696E653D652E656E645F7769';
wwv_flow_imp.g_varchar2_table(3662) := '74685F6E65776C696E652C746869732E696E64656E745F73697A653D652E696E64656E745F73697A652C746869732E777261705F6C696E655F6C656E6774683D652E777261705F6C696E655F6C656E6774682C746869732E696E64656E745F656D707479';
wwv_flow_imp.g_varchar2_table(3663) := '5F6C696E65733D652E696E64656E745F656D7074795F6C696E65732C746869732E5F5F6C696E65733D5B5D2C746869732E70726576696F75735F6C696E653D6E756C6C2C746869732E63757272656E745F6C696E653D6E756C6C2C746869732E6E657874';
wwv_flow_imp.g_varchar2_table(3664) := '5F6C696E653D6E657720742874686973292C746869732E73706163655F6265666F72655F746F6B656E3D21312C746869732E6E6F6E5F627265616B696E675F73706163653D21312C746869732E70726576696F75735F746F6B656E5F777261707065643D';
wwv_flow_imp.g_varchar2_table(3665) := '21312C746869732E5F5F6164645F6F75747075746C696E6528297D742E70726F746F747970652E636C6F6E655F656D7074793D66756E6374696F6E28297B76617220653D6E6577207428746869732E5F5F706172656E74293B72657475726E20652E7365';
wwv_flow_imp.g_varchar2_table(3666) := '745F696E64656E7428746869732E5F5F696E64656E745F636F756E742C746869732E5F5F616C69676E6D656E745F636F756E74292C657D2C742E70726F746F747970652E6974656D3D66756E6374696F6E2865297B72657475726E20653C303F74686973';
wwv_flow_imp.g_varchar2_table(3667) := '2E5F5F6974656D735B746869732E5F5F6974656D732E6C656E6774682B655D3A746869732E5F5F6974656D735B655D7D2C742E70726F746F747970652E6861735F6D617463683D66756E6374696F6E2865297B666F722876617220743D746869732E5F5F';
wwv_flow_imp.g_varchar2_table(3668) := '6974656D732E6C656E6774682D313B743E3D303B742D2D29696628746869732E5F5F6974656D735B745D2E6D617463682865292972657475726E21303B72657475726E21317D2C742E70726F746F747970652E7365745F696E64656E743D66756E637469';
wwv_flow_imp.g_varchar2_table(3669) := '6F6E28652C74297B746869732E69735F656D7074792829262628746869732E5F5F696E64656E745F636F756E743D657C7C302C746869732E5F5F616C69676E6D656E745F636F756E743D747C7C302C746869732E5F5F6368617261637465725F636F756E';
wwv_flow_imp.g_varchar2_table(3670) := '743D746869732E5F5F706172656E742E6765745F696E64656E745F73697A6528746869732E5F5F696E64656E745F636F756E742C746869732E5F5F616C69676E6D656E745F636F756E7429297D2C742E70726F746F747970652E5F7365745F777261705F';
wwv_flow_imp.g_varchar2_table(3671) := '706F696E743D66756E6374696F6E28297B746869732E5F5F706172656E742E777261705F6C696E655F6C656E677468262628746869732E5F5F777261705F706F696E745F696E6465783D746869732E5F5F6974656D732E6C656E6774682C746869732E5F';
wwv_flow_imp.g_varchar2_table(3672) := '5F777261705F706F696E745F6368617261637465725F636F756E743D746869732E5F5F6368617261637465725F636F756E742C746869732E5F5F777261705F706F696E745F696E64656E745F636F756E743D746869732E5F5F706172656E742E6E657874';
wwv_flow_imp.g_varchar2_table(3673) := '5F6C696E652E5F5F696E64656E745F636F756E742C746869732E5F5F777261705F706F696E745F616C69676E6D656E745F636F756E743D746869732E5F5F706172656E742E6E6578745F6C696E652E5F5F616C69676E6D656E745F636F756E74297D2C74';
wwv_flow_imp.g_varchar2_table(3674) := '2E70726F746F747970652E5F73686F756C645F777261703D66756E6374696F6E28297B72657475726E20746869732E5F5F777261705F706F696E745F696E6465782626746869732E5F5F6368617261637465725F636F756E743E746869732E5F5F706172';
wwv_flow_imp.g_varchar2_table(3675) := '656E742E777261705F6C696E655F6C656E6774682626746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E743E746869732E5F5F706172656E742E6E6578745F6C696E652E5F5F6368617261637465725F636F756E747D2C74';
wwv_flow_imp.g_varchar2_table(3676) := '2E70726F746F747970652E5F616C6C6F775F777261703D66756E6374696F6E28297B696628746869732E5F73686F756C645F777261702829297B746869732E5F5F706172656E742E6164645F6E65775F6C696E6528293B76617220653D746869732E5F5F';
wwv_flow_imp.g_varchar2_table(3677) := '706172656E742E63757272656E745F6C696E653B72657475726E20652E7365745F696E64656E7428746869732E5F5F777261705F706F696E745F696E64656E745F636F756E742C746869732E5F5F777261705F706F696E745F616C69676E6D656E745F63';
wwv_flow_imp.g_varchar2_table(3678) := '6F756E74292C652E5F5F6974656D733D746869732E5F5F6974656D732E736C69636528746869732E5F5F777261705F706F696E745F696E646578292C746869732E5F5F6974656D733D746869732E5F5F6974656D732E736C69636528302C746869732E5F';
wwv_flow_imp.g_varchar2_table(3679) := '5F777261705F706F696E745F696E646578292C652E5F5F6368617261637465725F636F756E742B3D746869732E5F5F6368617261637465725F636F756E742D746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E742C746869';
wwv_flow_imp.g_varchar2_table(3680) := '732E5F5F6368617261637465725F636F756E743D746869732E5F5F777261705F706F696E745F6368617261637465725F636F756E742C2220223D3D3D652E5F5F6974656D735B305D262628652E5F5F6974656D732E73706C69636528302C31292C652E5F';
wwv_flow_imp.g_varchar2_table(3681) := '5F6368617261637465725F636F756E742D3D31292C21307D72657475726E21317D2C742E70726F746F747970652E69735F656D7074793D66756E6374696F6E28297B72657475726E20303D3D3D746869732E5F5F6974656D732E6C656E6774687D2C742E';
wwv_flow_imp.g_varchar2_table(3682) := '70726F746F747970652E6C6173743D66756E6374696F6E28297B72657475726E20746869732E69735F656D70747928293F6E756C6C3A746869732E5F5F6974656D735B746869732E5F5F6974656D732E6C656E6774682D315D7D2C742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(3683) := '70652E707573683D66756E6374696F6E2865297B746869732E5F5F6974656D732E707573682865293B76617220743D652E6C617374496E6465784F6628225C6E22293B2D31213D3D743F746869732E5F5F6368617261637465725F636F756E743D652E6C';
wwv_flow_imp.g_varchar2_table(3684) := '656E6774682D743A746869732E5F5F6368617261637465725F636F756E742B3D652E6C656E6774687D2C742E70726F746F747970652E706F703D66756E6374696F6E28297B76617220653D6E756C6C3B72657475726E20746869732E69735F656D707479';
wwv_flow_imp.g_varchar2_table(3685) := '28297C7C28653D746869732E5F5F6974656D732E706F7028292C746869732E5F5F6368617261637465725F636F756E742D3D652E6C656E677468292C657D2C742E70726F746F747970652E5F72656D6F76655F696E64656E743D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(3686) := '7B746869732E5F5F696E64656E745F636F756E743E30262628746869732E5F5F696E64656E745F636F756E742D3D312C746869732E5F5F6368617261637465725F636F756E742D3D746869732E5F5F706172656E742E696E64656E745F73697A65297D2C';
wwv_flow_imp.g_varchar2_table(3687) := '742E70726F746F747970652E5F72656D6F76655F777261705F696E64656E743D66756E6374696F6E28297B746869732E5F5F777261705F706F696E745F696E64656E745F636F756E743E30262628746869732E5F5F777261705F706F696E745F696E6465';
wwv_flow_imp.g_varchar2_table(3688) := '6E745F636F756E742D3D31297D2C742E70726F746F747970652E7472696D3D66756E6374696F6E28297B666F72283B2220223D3D3D746869732E6C61737428293B29746869732E5F5F6974656D732E706F7028292C746869732E5F5F6368617261637465';
wwv_flow_imp.g_varchar2_table(3689) := '725F636F756E742D3D317D2C742E70726F746F747970652E746F537472696E673D66756E6374696F6E28297B76617220653D22223B72657475726E20746869732E69735F656D70747928293F746869732E5F5F706172656E742E696E64656E745F656D70';
wwv_flow_imp.g_varchar2_table(3690) := '74795F6C696E6573262628653D746869732E5F5F706172656E742E6765745F696E64656E745F737472696E6728746869732E5F5F696E64656E745F636F756E7429293A28653D746869732E5F5F706172656E742E6765745F696E64656E745F737472696E';
wwv_flow_imp.g_varchar2_table(3691) := '6728746869732E5F5F696E64656E745F636F756E742C746869732E5F5F616C69676E6D656E745F636F756E74292C652B3D746869732E5F5F6974656D732E6A6F696E28222229292C657D2C6E2E70726F746F747970652E6765745F696E64656E745F7369';
wwv_flow_imp.g_varchar2_table(3692) := '7A653D66756E6374696F6E28652C74297B766172206E3D746869732E5F5F626173655F737472696E675F6C656E6774683B72657475726E20743D747C7C302C653C302626286E3D30292C286E2B3D652A746869732E5F5F696E64656E745F73697A65292B';
wwv_flow_imp.g_varchar2_table(3693) := '747D2C6E2E70726F746F747970652E6765745F696E64656E745F737472696E673D66756E6374696F6E28652C74297B766172206E3D746869732E5F5F626173655F737472696E673B72657475726E20743D747C7C302C653C30262628653D302C6E3D2222';
wwv_flow_imp.g_varchar2_table(3694) := '292C742B3D652A746869732E5F5F696E64656E745F73697A652C746869732E5F5F656E737572655F63616368652874292C6E2B746869732E5F5F63616368655B745D7D2C6E2E70726F746F747970652E5F5F656E737572655F63616368653D66756E6374';
wwv_flow_imp.g_varchar2_table(3695) := '696F6E2865297B666F72283B653E3D746869732E5F5F63616368652E6C656E6774683B29746869732E5F5F6164645F636F6C756D6E28297D2C6E2E70726F746F747970652E5F5F6164645F636F6C756D6E3D66756E6374696F6E28297B76617220653D74';
wwv_flow_imp.g_varchar2_table(3696) := '6869732E5F5F63616368652E6C656E6774682C743D302C6E3D22223B746869732E5F5F696E64656E745F73697A652626653E3D746869732E5F5F696E64656E745F73697A65262628652D3D28743D4D6174682E666C6F6F7228652F746869732E5F5F696E';
wwv_flow_imp.g_varchar2_table(3697) := '64656E745F73697A6529292A746869732E5F5F696E64656E745F73697A652C6E3D6E657720417272617928742B31292E6A6F696E28746869732E5F5F696E64656E745F737472696E6729292C652626286E2B3D6E657720417272617928652B31292E6A6F';
wwv_flow_imp.g_varchar2_table(3698) := '696E2822202229292C746869732E5F5F63616368652E70757368286E297D2C692E70726F746F747970652E5F5F6164645F6F75747075746C696E653D66756E6374696F6E28297B746869732E70726576696F75735F6C696E653D746869732E6375727265';
wwv_flow_imp.g_varchar2_table(3699) := '6E745F6C696E652C746869732E63757272656E745F6C696E653D746869732E6E6578745F6C696E652E636C6F6E655F656D70747928292C746869732E5F5F6C696E65732E7075736828746869732E63757272656E745F6C696E65297D2C692E70726F746F';
wwv_flow_imp.g_varchar2_table(3700) := '747970652E6765745F6C696E655F6E756D6265723D66756E6374696F6E28297B72657475726E20746869732E5F5F6C696E65732E6C656E6774687D2C692E70726F746F747970652E6765745F696E64656E745F737472696E673D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(3701) := '2C74297B72657475726E20746869732E5F5F696E64656E745F63616368652E6765745F696E64656E745F737472696E6728652C74297D2C692E70726F746F747970652E6765745F696E64656E745F73697A653D66756E6374696F6E28652C74297B726574';
wwv_flow_imp.g_varchar2_table(3702) := '75726E20746869732E5F5F696E64656E745F63616368652E6765745F696E64656E745F73697A6528652C74297D2C692E70726F746F747970652E69735F656D7074793D66756E6374696F6E28297B72657475726E21746869732E70726576696F75735F6C';
wwv_flow_imp.g_varchar2_table(3703) := '696E652626746869732E63757272656E745F6C696E652E69735F656D70747928297D2C692E70726F746F747970652E6164645F6E65775F6C696E653D66756E6374696F6E2865297B72657475726E2128746869732E69735F656D70747928297C7C216526';
wwv_flow_imp.g_varchar2_table(3704) := '26746869732E6A7573745F61646465645F6E65776C696E6528297C7C28746869732E7261777C7C746869732E5F5F6164645F6F75747075746C696E6528292C3029297D2C692E70726F746F747970652E6765745F636F64653D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(3705) := '7B746869732E7472696D282130293B76617220743D746869732E63757272656E745F6C696E652E706F7028293B74262628225C6E223D3D3D745B742E6C656E6774682D315D262628743D742E7265706C616365282F5C6E2B242F672C222229292C746869';
wwv_flow_imp.g_varchar2_table(3706) := '732E63757272656E745F6C696E652E70757368287429292C746869732E5F656E645F776974685F6E65776C696E652626746869732E5F5F6164645F6F75747075746C696E6528293B766172206E3D746869732E5F5F6C696E65732E6A6F696E28225C6E22';
wwv_flow_imp.g_varchar2_table(3707) := '293B72657475726E225C6E22213D3D652626286E3D6E2E7265706C616365282F5B5C6E5D2F672C6529292C6E7D2C692E70726F746F747970652E7365745F777261705F706F696E743D66756E6374696F6E28297B746869732E63757272656E745F6C696E';
wwv_flow_imp.g_varchar2_table(3708) := '652E5F7365745F777261705F706F696E7428297D2C692E70726F746F747970652E7365745F696E64656E743D66756E6374696F6E28652C74297B72657475726E20653D657C7C302C743D747C7C302C746869732E6E6578745F6C696E652E7365745F696E';
wwv_flow_imp.g_varchar2_table(3709) := '64656E7428652C74292C746869732E5F5F6C696E65732E6C656E6774683E313F28746869732E63757272656E745F6C696E652E7365745F696E64656E7428652C74292C2130293A28746869732E63757272656E745F6C696E652E7365745F696E64656E74';
wwv_flow_imp.g_varchar2_table(3710) := '28292C2131297D2C692E70726F746F747970652E6164645F7261775F746F6B656E3D66756E6374696F6E2865297B666F722876617220743D303B743C652E6E65776C696E65733B742B2B29746869732E5F5F6164645F6F75747075746C696E6528293B74';
wwv_flow_imp.g_varchar2_table(3711) := '6869732E63757272656E745F6C696E652E7365745F696E64656E74282D31292C746869732E63757272656E745F6C696E652E7075736828652E776869746573706163655F6265666F7265292C746869732E63757272656E745F6C696E652E707573682865';
wwv_flow_imp.g_varchar2_table(3712) := '2E74657874292C746869732E73706163655F6265666F72655F746F6B656E3D21312C746869732E6E6F6E5F627265616B696E675F73706163653D21312C746869732E70726576696F75735F746F6B656E5F777261707065643D21317D2C692E70726F746F';
wwv_flow_imp.g_varchar2_table(3713) := '747970652E6164645F746F6B656E3D66756E6374696F6E2865297B746869732E5F5F6164645F73706163655F6265666F72655F746F6B656E28292C746869732E63757272656E745F6C696E652E707573682865292C746869732E73706163655F6265666F';
wwv_flow_imp.g_varchar2_table(3714) := '72655F746F6B656E3D21312C746869732E6E6F6E5F627265616B696E675F73706163653D21312C746869732E70726576696F75735F746F6B656E5F777261707065643D746869732E63757272656E745F6C696E652E5F616C6C6F775F7772617028297D2C';
wwv_flow_imp.g_varchar2_table(3715) := '692E70726F746F747970652E5F5F6164645F73706163655F6265666F72655F746F6B656E3D66756E6374696F6E28297B746869732E73706163655F6265666F72655F746F6B656E262621746869732E6A7573745F61646465645F6E65776C696E65282926';
wwv_flow_imp.g_varchar2_table(3716) := '2628746869732E6E6F6E5F627265616B696E675F73706163657C7C746869732E7365745F777261705F706F696E7428292C746869732E63757272656E745F6C696E652E707573682822202229297D2C692E70726F746F747970652E72656D6F76655F696E';
wwv_flow_imp.g_varchar2_table(3717) := '64656E743D66756E6374696F6E2865297B666F722876617220743D746869732E5F5F6C696E65732E6C656E6774683B653C743B29746869732E5F5F6C696E65735B655D2E5F72656D6F76655F696E64656E7428292C652B2B3B746869732E63757272656E';
wwv_flow_imp.g_varchar2_table(3718) := '745F6C696E652E5F72656D6F76655F777261705F696E64656E7428297D2C692E70726F746F747970652E7472696D3D66756E6374696F6E2865297B666F7228653D766F69642030213D3D652626652C746869732E63757272656E745F6C696E652E747269';
wwv_flow_imp.g_varchar2_table(3719) := '6D28293B652626746869732E5F5F6C696E65732E6C656E6774683E312626746869732E63757272656E745F6C696E652E69735F656D70747928293B29746869732E5F5F6C696E65732E706F7028292C746869732E63757272656E745F6C696E653D746869';
wwv_flow_imp.g_varchar2_table(3720) := '732E5F5F6C696E65735B746869732E5F5F6C696E65732E6C656E6774682D315D2C746869732E63757272656E745F6C696E652E7472696D28293B746869732E70726576696F75735F6C696E653D746869732E5F5F6C696E65732E6C656E6774683E313F74';
wwv_flow_imp.g_varchar2_table(3721) := '6869732E5F5F6C696E65735B746869732E5F5F6C696E65732E6C656E6774682D325D3A6E756C6C7D2C692E70726F746F747970652E6A7573745F61646465645F6E65776C696E653D66756E6374696F6E28297B72657475726E20746869732E6375727265';
wwv_flow_imp.g_varchar2_table(3722) := '6E745F6C696E652E69735F656D70747928297D2C692E70726F746F747970652E6A7573745F61646465645F626C616E6B6C696E653D66756E6374696F6E28297B72657475726E20746869732E69735F656D70747928297C7C746869732E63757272656E74';
wwv_flow_imp.g_varchar2_table(3723) := '5F6C696E652E69735F656D70747928292626746869732E70726576696F75735F6C696E652E69735F656D70747928297D2C692E70726F746F747970652E656E737572655F656D7074795F6C696E655F61626F76653D66756E6374696F6E28652C6E297B66';
wwv_flow_imp.g_varchar2_table(3724) := '6F722876617220693D746869732E5F5F6C696E65732E6C656E6774682D323B693E3D303B297B76617220723D746869732E5F5F6C696E65735B695D3B696628722E69735F656D707479282929627265616B3B69662830213D3D722E6974656D2830292E69';
wwv_flow_imp.g_varchar2_table(3725) := '6E6465784F662865292626722E6974656D282D3129213D3D6E297B746869732E5F5F6C696E65732E73706C69636528692B312C302C6E65772074287468697329292C746869732E70726576696F75735F6C696E653D746869732E5F5F6C696E65735B7468';
wwv_flow_imp.g_varchar2_table(3726) := '69732E5F5F6C696E65732E6C656E6774682D325D3B627265616B7D692D2D7D7D2C652E6578706F7274732E4F75747075743D697D2C66756E6374696F6E2865297B652E6578706F7274732E546F6B656E3D66756E6374696F6E28652C742C6E2C69297B74';
wwv_flow_imp.g_varchar2_table(3727) := '6869732E747970653D652C746869732E746578743D742C746869732E636F6D6D656E74735F6265666F72653D6E756C6C2C746869732E6E65776C696E65733D6E7C7C302C746869732E776869746573706163655F6265666F72653D697C7C22222C746869';
wwv_flow_imp.g_varchar2_table(3728) := '732E706172656E743D6E756C6C2C746869732E6E6578743D6E756C6C2C746869732E70726576696F75733D6E756C6C2C746869732E6F70656E65643D6E756C6C2C746869732E636C6F7365643D6E756C6C2C746869732E646972656374697665733D6E75';
wwv_flow_imp.g_varchar2_table(3729) := '6C6C7D7D2C2C2C66756E6374696F6E2865297B66756E6374696F6E207428652C74297B746869732E7261775F6F7074696F6E733D6E28652C74292C746869732E64697361626C65643D746869732E5F6765745F626F6F6C65616E282264697361626C6564';
wwv_flow_imp.g_varchar2_table(3730) := '22292C746869732E656F6C3D746869732E5F6765745F636861726163746572732822656F6C222C226175746F22292C746869732E656E645F776974685F6E65776C696E653D746869732E5F6765745F626F6F6C65616E2822656E645F776974685F6E6577';
wwv_flow_imp.g_varchar2_table(3731) := '6C696E6522292C746869732E696E64656E745F73697A653D746869732E5F6765745F6E756D6265722822696E64656E745F73697A65222C34292C746869732E696E64656E745F636861723D746869732E5F6765745F636861726163746572732822696E64';
wwv_flow_imp.g_varchar2_table(3732) := '656E745F63686172222C222022292C746869732E696E64656E745F6C6576656C3D746869732E5F6765745F6E756D6265722822696E64656E745F6C6576656C22292C746869732E70726573657276655F6E65776C696E65733D746869732E5F6765745F62';
wwv_flow_imp.g_varchar2_table(3733) := '6F6F6C65616E282270726573657276655F6E65776C696E6573222C2130292C746869732E6D61785F70726573657276655F6E65776C696E65733D746869732E5F6765745F6E756D62657228226D61785F70726573657276655F6E65776C696E6573222C33';
wwv_flow_imp.g_varchar2_table(3734) := '32373836292C746869732E70726573657276655F6E65776C696E65737C7C28746869732E6D61785F70726573657276655F6E65776C696E65733D30292C746869732E696E64656E745F776974685F746162733D746869732E5F6765745F626F6F6C65616E';
wwv_flow_imp.g_varchar2_table(3735) := '2822696E64656E745F776974685F74616273222C225C74223D3D3D746869732E696E64656E745F63686172292C746869732E696E64656E745F776974685F74616273262628746869732E696E64656E745F636861723D225C74222C313D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(3736) := '696E64656E745F73697A65262628746869732E696E64656E745F73697A653D3429292C746869732E777261705F6C696E655F6C656E6774683D746869732E5F6765745F6E756D6265722822777261705F6C696E655F6C656E677468222C746869732E5F67';
wwv_flow_imp.g_varchar2_table(3737) := '65745F6E756D62657228226D61785F636861722229292C746869732E696E64656E745F656D7074795F6C696E65733D746869732E5F6765745F626F6F6C65616E2822696E64656E745F656D7074795F6C696E657322292C746869732E74656D706C617469';
wwv_flow_imp.g_varchar2_table(3738) := '6E673D746869732E5F6765745F73656C656374696F6E5F6C697374282274656D706C6174696E67222C5B226175746F222C226E6F6E65222C22646A616E676F222C22657262222C2268616E646C6562617273222C22706870222C22736D61727479225D2C';
wwv_flow_imp.g_varchar2_table(3739) := '5B226175746F225D297D66756E6374696F6E206E28652C74297B766172206E2C723D7B7D3B666F72286E20696E20653D69286529296E213D3D74262628725B6E5D3D655B6E5D293B696628742626655B745D29666F72286E20696E20655B745D29725B6E';
wwv_flow_imp.g_varchar2_table(3740) := '5D3D655B745D5B6E5D3B72657475726E20727D66756E6374696F6E20692865297B76617220742C6E3D7B7D3B666F72287420696E2065296E5B742E7265706C616365282F2D2F672C225F22295D3D655B745D3B72657475726E206E7D742E70726F746F74';
wwv_flow_imp.g_varchar2_table(3741) := '7970652E5F6765745F61727261793D66756E6374696F6E28652C74297B766172206E3D746869732E7261775F6F7074696F6E735B655D2C693D747C7C5B5D3B72657475726E226F626A656374223D3D747970656F66206E3F6E756C6C213D3D6E26262266';
wwv_flow_imp.g_varchar2_table(3742) := '756E6374696F6E223D3D747970656F66206E2E636F6E636174262628693D6E2E636F6E6361742829293A22737472696E67223D3D747970656F66206E262628693D6E2E73706C6974282F5B5E612D7A412D5A302D395F5C2F5C2D5D2B2F29292C697D2C74';
wwv_flow_imp.g_varchar2_table(3743) := '2E70726F746F747970652E5F6765745F626F6F6C65616E3D66756E6374696F6E28652C74297B766172206E3D746869732E7261775F6F7074696F6E735B655D3B72657475726E20766F696420303D3D3D6E3F2121743A21216E7D2C742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(3744) := '70652E5F6765745F636861726163746572733D66756E6374696F6E28652C74297B766172206E3D746869732E7261775F6F7074696F6E735B655D2C693D747C7C22223B72657475726E22737472696E67223D3D747970656F66206E262628693D6E2E7265';
wwv_flow_imp.g_varchar2_table(3745) := '706C616365282F5C5C722F2C225C7222292E7265706C616365282F5C5C6E2F2C225C6E22292E7265706C616365282F5C5C742F2C225C742229292C697D2C742E70726F746F747970652E5F6765745F6E756D6265723D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(3746) := '766172206E3D746869732E7261775F6F7074696F6E735B655D3B743D7061727365496E7428742C3130292C69734E614E287429262628743D30293B76617220693D7061727365496E74286E2C3130293B72657475726E2069734E614E286929262628693D';
wwv_flow_imp.g_varchar2_table(3747) := '74292C697D2C742E70726F746F747970652E5F6765745F73656C656374696F6E3D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F6765745F73656C656374696F6E5F6C69737428652C742C6E293B69662831213D3D692E6C656E67';
wwv_flow_imp.g_varchar2_table(3748) := '7468297468726F77206E6577204572726F722822496E76616C6964204F7074696F6E2056616C75653A20546865206F7074696F6E2027222B652B22272063616E206F6E6C79206265206F6E65206F662074686520666F6C6C6F77696E672076616C756573';
wwv_flow_imp.g_varchar2_table(3749) := '3A5C6E222B742B225C6E596F752070617373656420696E3A2027222B746869732E7261775F6F7074696F6E735B655D2B222722293B72657475726E20695B305D7D2C742E70726F746F747970652E5F6765745F73656C656374696F6E5F6C6973743D6675';
wwv_flow_imp.g_varchar2_table(3750) := '6E6374696F6E28652C742C6E297B69662821747C7C303D3D3D742E6C656E677468297468726F77206E6577204572726F72282253656C656374696F6E206C6973742063616E6E6F7420626520656D7074792E22293B6966286E3D6E7C7C5B745B305D5D2C';
wwv_flow_imp.g_varchar2_table(3751) := '21746869732E5F69735F76616C69645F73656C656374696F6E286E2C7429297468726F77206E6577204572726F722822496E76616C69642044656661756C742056616C75652122293B76617220693D746869732E5F6765745F617272617928652C6E293B';
wwv_flow_imp.g_varchar2_table(3752) := '69662821746869732E5F69735F76616C69645F73656C656374696F6E28692C7429297468726F77206E6577204572726F722822496E76616C6964204F7074696F6E2056616C75653A20546865206F7074696F6E2027222B652B22272063616E20636F6E74';
wwv_flow_imp.g_varchar2_table(3753) := '61696E206F6E6C792074686520666F6C6C6F77696E672076616C7565733A5C6E222B742B225C6E596F752070617373656420696E3A2027222B746869732E7261775F6F7074696F6E735B655D2B222722293B72657475726E20697D2C742E70726F746F74';
wwv_flow_imp.g_varchar2_table(3754) := '7970652E5F69735F76616C69645F73656C656374696F6E3D66756E6374696F6E28652C74297B72657475726E20652E6C656E6774682626742E6C656E677468262621652E736F6D65282866756E6374696F6E2865297B72657475726E2D313D3D3D742E69';
wwv_flow_imp.g_varchar2_table(3755) := '6E6465784F662865297D29297D2C652E6578706F7274732E4F7074696F6E733D742C652E6578706F7274732E6E6F726D616C697A654F7074733D692C652E6578706F7274732E6D657267654F7074733D6E7D2C2C66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(3756) := '743D5265674578702E70726F746F747970652E6861734F776E50726F70657274792822737469636B7922293B66756E6374696F6E206E2865297B746869732E5F5F696E7075743D657C7C22222C746869732E5F5F696E7075745F6C656E6774683D746869';
wwv_flow_imp.g_varchar2_table(3757) := '732E5F5F696E7075742E6C656E6774682C746869732E5F5F706F736974696F6E3D307D6E2E70726F746F747970652E726573746172743D66756E6374696F6E28297B746869732E5F5F706F736974696F6E3D307D2C6E2E70726F746F747970652E626163';
wwv_flow_imp.g_varchar2_table(3758) := '6B3D66756E6374696F6E28297B746869732E5F5F706F736974696F6E3E30262628746869732E5F5F706F736974696F6E2D3D31297D2C6E2E70726F746F747970652E6861734E6578743D66756E6374696F6E28297B72657475726E20746869732E5F5F70';
wwv_flow_imp.g_varchar2_table(3759) := '6F736974696F6E3C746869732E5F5F696E7075745F6C656E6774687D2C6E2E70726F746F747970652E6E6578743D66756E6374696F6E28297B76617220653D6E756C6C3B72657475726E20746869732E6861734E6578742829262628653D746869732E5F';
wwv_flow_imp.g_varchar2_table(3760) := '5F696E7075742E63686172417428746869732E5F5F706F736974696F6E292C746869732E5F5F706F736974696F6E2B3D31292C657D2C6E2E70726F746F747970652E7065656B3D66756E6374696F6E2865297B76617220743D6E756C6C3B72657475726E';
wwv_flow_imp.g_varchar2_table(3761) := '20653D657C7C302C28652B3D746869732E5F5F706F736974696F6E293E3D302626653C746869732E5F5F696E7075745F6C656E677468262628743D746869732E5F5F696E7075742E636861724174286529292C747D2C6E2E70726F746F747970652E5F5F';
wwv_flow_imp.g_varchar2_table(3762) := '6D617463683D66756E6374696F6E28652C6E297B652E6C617374496E6465783D6E3B76617220693D652E6578656328746869732E5F5F696E707574293B72657475726E21697C7C742626652E737469636B797C7C692E696E646578213D3D6E262628693D';
wwv_flow_imp.g_varchar2_table(3763) := '6E756C6C292C697D2C6E2E70726F746F747970652E746573743D66756E6374696F6E28652C74297B72657475726E20743D747C7C302C28742B3D746869732E5F5F706F736974696F6E293E3D302626743C746869732E5F5F696E7075745F6C656E677468';
wwv_flow_imp.g_varchar2_table(3764) := '26262121746869732E5F5F6D6174636828652C74297D2C6E2E70726F746F747970652E74657374436861723D66756E6374696F6E28652C74297B766172206E3D746869732E7065656B2874293B72657475726E20652E6C617374496E6465783D302C6E75';
wwv_flow_imp.g_varchar2_table(3765) := '6C6C213D3D6E2626652E74657374286E297D2C6E2E70726F746F747970652E6D617463683D66756E6374696F6E2865297B76617220743D746869732E5F5F6D6174636828652C746869732E5F5F706F736974696F6E293B72657475726E20743F74686973';
wwv_flow_imp.g_varchar2_table(3766) := '2E5F5F706F736974696F6E2B3D745B305D2E6C656E6774683A743D6E756C6C2C747D2C6E2E70726F746F747970652E726561643D66756E6374696F6E28652C742C6E297B76617220692C723D22223B72657475726E2065262628693D746869732E6D6174';
wwv_flow_imp.g_varchar2_table(3767) := '636828652929262628722B3D695B305D292C21747C7C21692626657C7C28722B3D746869732E72656164556E74696C28742C6E29292C727D2C6E2E70726F746F747970652E72656164556E74696C3D66756E6374696F6E28652C74297B766172206E2C69';
wwv_flow_imp.g_varchar2_table(3768) := '3D746869732E5F5F706F736974696F6E3B652E6C617374496E6465783D746869732E5F5F706F736974696F6E3B76617220723D652E6578656328746869732E5F5F696E707574293B72657475726E20723F28693D722E696E6465782C74262628692B3D72';
wwv_flow_imp.g_varchar2_table(3769) := '5B305D2E6C656E67746829293A693D746869732E5F5F696E7075745F6C656E6774682C6E3D746869732E5F5F696E7075742E737562737472696E6728746869732E5F5F706F736974696F6E2C69292C746869732E5F5F706F736974696F6E3D692C6E7D2C';
wwv_flow_imp.g_varchar2_table(3770) := '6E2E70726F746F747970652E72656164556E74696C41667465723D66756E6374696F6E2865297B72657475726E20746869732E72656164556E74696C28652C2130297D2C6E2E70726F746F747970652E6765745F7265676578703D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3771) := '652C6E297B76617220693D6E756C6C2C723D2267223B72657475726E206E262674262628723D227922292C22737472696E67223D3D747970656F66206526262222213D3D653F693D6E65772052656745787028652C72293A65262628693D6E6577205265';
wwv_flow_imp.g_varchar2_table(3772) := '6745787028652E736F757263652C7229292C697D2C6E2E70726F746F747970652E6765745F6C69746572616C5F7265676578703D66756E6374696F6E2865297B72657475726E2052656745787028652E7265706C616365282F5B2D5C2F5C5C5E242A2B3F';
wwv_flow_imp.g_varchar2_table(3773) := '2E28297C5B5C5D7B7D5D2F672C225C5C24262229297D2C6E2E70726F746F747970652E7065656B556E74696C41667465723D66756E6374696F6E2865297B76617220743D746869732E5F5F706F736974696F6E2C6E3D746869732E72656164556E74696C';
wwv_flow_imp.g_varchar2_table(3774) := '41667465722865293B72657475726E20746869732E5F5F706F736974696F6E3D742C6E7D2C6E2E70726F746F747970652E6C6F6F6B4261636B3D66756E6374696F6E2865297B76617220743D746869732E5F5F706F736974696F6E2D313B72657475726E';
wwv_flow_imp.g_varchar2_table(3775) := '20743E3D652E6C656E6774682626746869732E5F5F696E7075742E737562737472696E6728742D652E6C656E6774682C74292E746F4C6F7765724361736528293D3D3D657D2C652E6578706F7274732E496E7075745363616E6E65723D6E7D2C66756E63';
wwv_flow_imp.g_varchar2_table(3776) := '74696F6E28652C742C6E297B76617220693D6E2838292E496E7075745363616E6E65722C723D6E2833292E546F6B656E2C6F3D6E283130292E546F6B656E53747265616D2C613D6E283131292E576869746573706163655061747465726E2C733D7B5354';
wwv_flow_imp.g_varchar2_table(3777) := '4152543A22544B5F5354415254222C5241573A22544B5F524157222C454F463A22544B5F454F46227D2C6C3D66756E6374696F6E28652C74297B746869732E5F696E7075743D6E657720692865292C746869732E5F6F7074696F6E733D747C7C7B7D2C74';
wwv_flow_imp.g_varchar2_table(3778) := '6869732E5F5F746F6B656E733D6E756C6C2C746869732E5F7061747465726E733D7B7D2C746869732E5F7061747465726E732E776869746573706163653D6E6577206128746869732E5F696E707574297D3B6C2E70726F746F747970652E746F6B656E69';
wwv_flow_imp.g_varchar2_table(3779) := '7A653D66756E6374696F6E28297B76617220653B746869732E5F696E7075742E7265737461727428292C746869732E5F5F746F6B656E733D6E6577206F2C746869732E5F726573657428293B666F722876617220743D6E6577207228732E53544152542C';
wwv_flow_imp.g_varchar2_table(3780) := '2222292C6E3D6E756C6C2C693D5B5D2C613D6E6577206F3B742E74797065213D3D732E454F463B297B666F7228653D746869732E5F6765745F6E6578745F746F6B656E28742C6E293B746869732E5F69735F636F6D6D656E742865293B29612E61646428';
wwv_flow_imp.g_varchar2_table(3781) := '65292C653D746869732E5F6765745F6E6578745F746F6B656E28742C6E293B612E6973456D70747928297C7C28652E636F6D6D656E74735F6265666F72653D612C613D6E6577206F292C652E706172656E743D6E2C746869732E5F69735F6F70656E696E';
wwv_flow_imp.g_varchar2_table(3782) := '672865293F28692E70757368286E292C6E3D65293A6E2626746869732E5F69735F636C6F73696E6728652C6E29262628652E6F70656E65643D6E2C6E2E636C6F7365643D652C6E3D692E706F7028292C652E706172656E743D6E292C652E70726576696F';
wwv_flow_imp.g_varchar2_table(3783) := '75733D742C742E6E6578743D652C746869732E5F5F746F6B656E732E6164642865292C743D657D72657475726E20746869732E5F5F746F6B656E737D2C6C2E70726F746F747970652E5F69735F66697273745F746F6B656E3D66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(3784) := '72657475726E20746869732E5F5F746F6B656E732E6973456D70747928297D2C6C2E70726F746F747970652E5F72657365743D66756E6374696F6E28297B7D2C6C2E70726F746F747970652E5F6765745F6E6578745F746F6B656E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3785) := '28652C74297B746869732E5F726561645768697465737061636528293B766172206E3D746869732E5F696E7075742E72656164282F2E2B2F67293B72657475726E206E3F746869732E5F6372656174655F746F6B656E28732E5241572C6E293A74686973';
wwv_flow_imp.g_varchar2_table(3786) := '2E5F6372656174655F746F6B656E28732E454F462C2222297D2C6C2E70726F746F747970652E5F69735F636F6D6D656E743D66756E6374696F6E2865297B72657475726E21317D2C6C2E70726F746F747970652E5F69735F6F70656E696E673D66756E63';
wwv_flow_imp.g_varchar2_table(3787) := '74696F6E2865297B72657475726E21317D2C6C2E70726F746F747970652E5F69735F636C6F73696E673D66756E6374696F6E28652C74297B72657475726E21317D2C6C2E70726F746F747970652E5F6372656174655F746F6B656E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3788) := '28652C74297B72657475726E206E6577207228652C742C746869732E5F7061747465726E732E776869746573706163652E6E65776C696E655F636F756E742C746869732E5F7061747465726E732E776869746573706163652E776869746573706163655F';
wwv_flow_imp.g_varchar2_table(3789) := '6265666F72655F746F6B656E297D2C6C2E70726F746F747970652E5F72656164576869746573706163653D66756E6374696F6E28297B72657475726E20746869732E5F7061747465726E732E776869746573706163652E7265616428297D2C652E657870';
wwv_flow_imp.g_varchar2_table(3790) := '6F7274732E546F6B656E697A65723D6C2C652E6578706F7274732E544F4B454E3D737D2C66756E6374696F6E2865297B66756E6374696F6E20742865297B746869732E5F5F746F6B656E733D5B5D2C746869732E5F5F746F6B656E735F6C656E6774683D';
wwv_flow_imp.g_varchar2_table(3791) := '746869732E5F5F746F6B656E732E6C656E6774682C746869732E5F5F706F736974696F6E3D302C746869732E5F5F706172656E745F746F6B656E3D657D742E70726F746F747970652E726573746172743D66756E6374696F6E28297B746869732E5F5F70';
wwv_flow_imp.g_varchar2_table(3792) := '6F736974696F6E3D307D2C742E70726F746F747970652E6973456D7074793D66756E6374696F6E28297B72657475726E20303D3D3D746869732E5F5F746F6B656E735F6C656E6774687D2C742E70726F746F747970652E6861734E6578743D66756E6374';
wwv_flow_imp.g_varchar2_table(3793) := '696F6E28297B72657475726E20746869732E5F5F706F736974696F6E3C746869732E5F5F746F6B656E735F6C656E6774687D2C742E70726F746F747970652E6E6578743D66756E6374696F6E28297B76617220653D6E756C6C3B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(3794) := '732E6861734E6578742829262628653D746869732E5F5F746F6B656E735B746869732E5F5F706F736974696F6E5D2C746869732E5F5F706F736974696F6E2B3D31292C657D2C742E70726F746F747970652E7065656B3D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(3795) := '617220743D6E756C6C3B72657475726E20653D657C7C302C28652B3D746869732E5F5F706F736974696F6E293E3D302626653C746869732E5F5F746F6B656E735F6C656E677468262628743D746869732E5F5F746F6B656E735B655D292C747D2C742E70';
wwv_flow_imp.g_varchar2_table(3796) := '726F746F747970652E6164643D66756E6374696F6E2865297B746869732E5F5F706172656E745F746F6B656E262628652E706172656E743D746869732E5F5F706172656E745F746F6B656E292C746869732E5F5F746F6B656E732E707573682865292C74';
wwv_flow_imp.g_varchar2_table(3797) := '6869732E5F5F746F6B656E735F6C656E6774682B3D317D2C652E6578706F7274732E546F6B656E53747265616D3D747D2C66756E6374696F6E28652C742C6E297B76617220693D6E283132292E5061747465726E3B66756E6374696F6E207228652C7429';
wwv_flow_imp.g_varchar2_table(3798) := '7B692E63616C6C28746869732C652C74292C743F746869732E5F6C696E655F7265676578703D746869732E5F696E7075742E6765745F72656765787028742E5F6C696E655F726567657870293A746869732E5F5F7365745F776869746573706163655F70';
wwv_flow_imp.g_varchar2_table(3799) := '61747465726E732822222C2222292C746869732E6E65776C696E655F636F756E743D302C746869732E776869746573706163655F6265666F72655F746F6B656E3D22227D722E70726F746F747970653D6E657720692C722E70726F746F747970652E5F5F';
wwv_flow_imp.g_varchar2_table(3800) := '7365745F776869746573706163655F7061747465726E733D66756E6374696F6E28652C74297B652B3D225C5C7420222C742B3D225C5C6E5C5C72222C746869732E5F6D617463685F7061747465726E3D746869732E5F696E7075742E6765745F72656765';
wwv_flow_imp.g_varchar2_table(3801) := '787028225B222B652B742B225D2B222C2130292C746869732E5F6E65776C696E655F7265676578703D746869732E5F696E7075742E6765745F72656765787028225C5C725C5C6E7C5B222B742B225D22297D2C722E70726F746F747970652E726561643D';
wwv_flow_imp.g_varchar2_table(3802) := '66756E6374696F6E28297B746869732E6E65776C696E655F636F756E743D302C746869732E776869746573706163655F6265666F72655F746F6B656E3D22223B76617220653D746869732E5F696E7075742E7265616428746869732E5F6D617463685F70';
wwv_flow_imp.g_varchar2_table(3803) := '61747465726E293B6966282220223D3D3D6529746869732E776869746573706163655F6265666F72655F746F6B656E3D2220223B656C73652069662865297B76617220743D746869732E5F5F73706C697428746869732E5F6E65776C696E655F72656765';
wwv_flow_imp.g_varchar2_table(3804) := '78702C65293B746869732E6E65776C696E655F636F756E743D742E6C656E6774682D312C746869732E776869746573706163655F6265666F72655F746F6B656E3D745B746869732E6E65776C696E655F636F756E745D7D72657475726E20657D2C722E70';
wwv_flow_imp.g_varchar2_table(3805) := '726F746F747970652E6D61746368696E673D66756E6374696F6E28652C74297B766172206E3D746869732E5F63726561746528293B72657475726E206E2E5F5F7365745F776869746573706163655F7061747465726E7328652C74292C6E2E5F75706461';
wwv_flow_imp.g_varchar2_table(3806) := '746528292C6E7D2C722E70726F746F747970652E5F6372656174653D66756E6374696F6E28297B72657475726E206E6577207228746869732E5F696E7075742C74686973297D2C722E70726F746F747970652E5F5F73706C69743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3807) := '652C74297B652E6C617374496E6465783D303B666F7228766172206E3D302C693D5B5D2C723D652E657865632874293B723B29692E7075736828742E737562737472696E67286E2C722E696E64657829292C6E3D722E696E6465782B725B305D2E6C656E';
wwv_flow_imp.g_varchar2_table(3808) := '6774682C723D652E657865632874293B72657475726E206E3C742E6C656E6774683F692E7075736828742E737562737472696E67286E2C742E6C656E67746829293A692E70757368282222292C697D2C652E6578706F7274732E57686974657370616365';
wwv_flow_imp.g_varchar2_table(3809) := '5061747465726E3D727D2C66756E6374696F6E2865297B66756E6374696F6E207428652C74297B746869732E5F696E7075743D652C746869732E5F7374617274696E675F7061747465726E3D6E756C6C2C746869732E5F6D617463685F7061747465726E';
wwv_flow_imp.g_varchar2_table(3810) := '3D6E756C6C2C746869732E5F756E74696C5F7061747465726E3D6E756C6C2C746869732E5F756E74696C5F61667465723D21312C74262628746869732E5F7374617274696E675F7061747465726E3D746869732E5F696E7075742E6765745F7265676578';
wwv_flow_imp.g_varchar2_table(3811) := '7028742E5F7374617274696E675F7061747465726E2C2130292C746869732E5F6D617463685F7061747465726E3D746869732E5F696E7075742E6765745F72656765787028742E5F6D617463685F7061747465726E2C2130292C746869732E5F756E7469';
wwv_flow_imp.g_varchar2_table(3812) := '6C5F7061747465726E3D746869732E5F696E7075742E6765745F72656765787028742E5F756E74696C5F7061747465726E292C746869732E5F756E74696C5F61667465723D742E5F756E74696C5F6166746572297D742E70726F746F747970652E726561';
wwv_flow_imp.g_varchar2_table(3813) := '643D66756E6374696F6E28297B76617220653D746869732E5F696E7075742E7265616428746869732E5F7374617274696E675F7061747465726E293B72657475726E20746869732E5F7374617274696E675F7061747465726E262621657C7C28652B3D74';
wwv_flow_imp.g_varchar2_table(3814) := '6869732E5F696E7075742E7265616428746869732E5F6D617463685F7061747465726E2C746869732E5F756E74696C5F7061747465726E2C746869732E5F756E74696C5F616674657229292C657D2C742E70726F746F747970652E726561645F6D617463';
wwv_flow_imp.g_varchar2_table(3815) := '683D66756E6374696F6E28297B72657475726E20746869732E5F696E7075742E6D6174636828746869732E5F6D617463685F7061747465726E297D2C742E70726F746F747970652E756E74696C5F61667465723D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(3816) := '743D746869732E5F63726561746528293B72657475726E20742E5F756E74696C5F61667465723D21302C742E5F756E74696C5F7061747465726E3D746869732E5F696E7075742E6765745F7265676578702865292C742E5F75706461746528292C747D2C';
wwv_flow_imp.g_varchar2_table(3817) := '742E70726F746F747970652E756E74696C3D66756E6374696F6E2865297B76617220743D746869732E5F63726561746528293B72657475726E20742E5F756E74696C5F61667465723D21312C742E5F756E74696C5F7061747465726E3D746869732E5F69';
wwv_flow_imp.g_varchar2_table(3818) := '6E7075742E6765745F7265676578702865292C742E5F75706461746528292C747D2C742E70726F746F747970652E7374617274696E675F776974683D66756E6374696F6E2865297B76617220743D746869732E5F63726561746528293B72657475726E20';
wwv_flow_imp.g_varchar2_table(3819) := '742E5F7374617274696E675F7061747465726E3D746869732E5F696E7075742E6765745F72656765787028652C2130292C742E5F75706461746528292C747D2C742E70726F746F747970652E6D61746368696E673D66756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(3820) := '20743D746869732E5F63726561746528293B72657475726E20742E5F6D617463685F7061747465726E3D746869732E5F696E7075742E6765745F72656765787028652C2130292C742E5F75706461746528292C747D2C742E70726F746F747970652E5F63';
wwv_flow_imp.g_varchar2_table(3821) := '72656174653D66756E6374696F6E28297B72657475726E206E6577207428746869732E5F696E7075742C74686973297D2C742E70726F746F747970652E5F7570646174653D66756E6374696F6E28297B7D2C652E6578706F7274732E5061747465726E3D';
wwv_flow_imp.g_varchar2_table(3822) := '747D2C66756E6374696F6E2865297B66756E6374696F6E207428652C74297B653D22737472696E67223D3D747970656F6620653F653A652E736F757263652C743D22737472696E67223D3D747970656F6620743F743A742E736F757263652C746869732E';
wwv_flow_imp.g_varchar2_table(3823) := '5F5F646972656374697665735F626C6F636B5F7061747465726E3D6E65772052656745787028652B2F20626561757469667928205C772B5B3A5D5C772B292B202F2E736F757263652B742C226722292C746869732E5F5F6469726563746976655F706174';
wwv_flow_imp.g_varchar2_table(3824) := '7465726E3D2F20285C772B295B3A5D285C772B292F672C746869732E5F5F646972656374697665735F656E645F69676E6F72655F7061747465726E3D6E65772052656745787028652B2F5C7362656175746966795C7369676E6F72653A656E645C732F2E';
wwv_flow_imp.g_varchar2_table(3825) := '736F757263652B742C226722297D742E70726F746F747970652E6765745F646972656374697665733D66756E6374696F6E2865297B69662821652E6D6174636828746869732E5F5F646972656374697665735F626C6F636B5F7061747465726E29297265';
wwv_flow_imp.g_varchar2_table(3826) := '7475726E206E756C6C3B76617220743D7B7D3B746869732E5F5F6469726563746976655F7061747465726E2E6C617374496E6465783D303B666F7228766172206E3D746869732E5F5F6469726563746976655F7061747465726E2E657865632865293B6E';
wwv_flow_imp.g_varchar2_table(3827) := '3B29745B6E5B315D5D3D6E5B325D2C6E3D746869732E5F5F6469726563746976655F7061747465726E2E657865632865293B72657475726E20747D2C742E70726F746F747970652E7265616449676E6F7265643D66756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(3828) := '726E20652E72656164556E74696C416674657228746869732E5F5F646972656374697665735F656E645F69676E6F72655F7061747465726E297D2C652E6578706F7274732E446972656374697665733D747D2C66756E6374696F6E28652C742C6E297B76';
wwv_flow_imp.g_varchar2_table(3829) := '617220693D6E283132292E5061747465726E2C723D7B646A616E676F3A21312C6572623A21312C68616E646C65626172733A21312C7068703A21312C736D617274793A21317D3B66756E6374696F6E206F28652C74297B692E63616C6C28746869732C65';
wwv_flow_imp.g_varchar2_table(3830) := '2C74292C746869732E5F5F74656D706C6174655F7061747465726E3D6E756C6C2C746869732E5F64697361626C65643D4F626A6563742E61737369676E287B7D2C72292C746869732E5F6578636C756465643D4F626A6563742E61737369676E287B7D2C';
wwv_flow_imp.g_varchar2_table(3831) := '72292C74262628746869732E5F5F74656D706C6174655F7061747465726E3D746869732E5F696E7075742E6765745F72656765787028742E5F5F74656D706C6174655F7061747465726E292C746869732E5F6578636C756465643D4F626A6563742E6173';
wwv_flow_imp.g_varchar2_table(3832) := '7369676E28746869732E5F6578636C756465642C742E5F6578636C75646564292C746869732E5F64697361626C65643D4F626A6563742E61737369676E28746869732E5F64697361626C65642C742E5F64697361626C656429293B766172206E3D6E6577';
wwv_flow_imp.g_varchar2_table(3833) := '20692865293B746869732E5F5F7061747465726E733D7B68616E646C65626172735F636F6D6D656E743A6E2E7374617274696E675F77697468282F7B7B212D2D2F292E756E74696C5F6166746572282F2D2D7D7D2F292C68616E646C65626172735F756E';
wwv_flow_imp.g_varchar2_table(3834) := '657363617065643A6E2E7374617274696E675F77697468282F7B7B7B2F292E756E74696C5F6166746572282F7D7D7D2F292C68616E646C65626172733A6E2E7374617274696E675F77697468282F7B7B2F292E756E74696C5F6166746572282F7D7D2F29';
wwv_flow_imp.g_varchar2_table(3835) := '2C7068703A6E2E7374617274696E675F77697468282F3C5C3F283F3A5B3D205D7C706870292F292E756E74696C5F6166746572282F5C3F3E2F292C6572623A6E2E7374617274696E675F77697468282F3C255B5E255D2F292E756E74696C5F6166746572';
wwv_flow_imp.g_varchar2_table(3836) := '282F5B5E255D253E2F292C646A616E676F3A6E2E7374617274696E675F77697468282F7B252F292E756E74696C5F6166746572282F257D2F292C646A616E676F5F76616C75653A6E2E7374617274696E675F77697468282F7B7B2F292E756E74696C5F61';
wwv_flow_imp.g_varchar2_table(3837) := '66746572282F7D7D2F292C646A616E676F5F636F6D6D656E743A6E2E7374617274696E675F77697468282F7B232F292E756E74696C5F6166746572282F237D2F292C736D617274793A6E2E7374617274696E675F77697468282F7B283F3D5B5E7D7B5C73';
wwv_flow_imp.g_varchar2_table(3838) := '5C6E5D292F292E756E74696C5F6166746572282F5B5E5C735C6E5D7D2F292C736D617274795F636F6D6D656E743A6E2E7374617274696E675F77697468282F7B5C2A2F292E756E74696C5F6166746572282F5C2A7D2F292C736D617274795F6C69746572';
wwv_flow_imp.g_varchar2_table(3839) := '616C3A6E2E7374617274696E675F77697468282F7B6C69746572616C7D2F292E756E74696C5F6166746572282F7B5C2F6C69746572616C7D2F297D7D6F2E70726F746F747970653D6E657720692C6F2E70726F746F747970652E5F6372656174653D6675';
wwv_flow_imp.g_varchar2_table(3840) := '6E6374696F6E28297B72657475726E206E6577206F28746869732E5F696E7075742C74686973297D2C6F2E70726F746F747970652E5F7570646174653D66756E6374696F6E28297B746869732E5F5F7365745F74656D706C617465645F7061747465726E';
wwv_flow_imp.g_varchar2_table(3841) := '28297D2C6F2E70726F746F747970652E64697361626C653D66756E6374696F6E2865297B76617220743D746869732E5F63726561746528293B72657475726E20742E5F64697361626C65645B655D3D21302C742E5F75706461746528292C747D2C6F2E70';
wwv_flow_imp.g_varchar2_table(3842) := '726F746F747970652E726561645F6F7074696F6E733D66756E6374696F6E2865297B76617220743D746869732E5F63726561746528293B666F7228766172206E20696E207229742E5F64697361626C65645B6E5D3D2D313D3D3D652E74656D706C617469';
wwv_flow_imp.g_varchar2_table(3843) := '6E672E696E6465784F66286E293B72657475726E20742E5F75706461746528292C747D2C6F2E70726F746F747970652E6578636C7564653D66756E6374696F6E2865297B76617220743D746869732E5F63726561746528293B72657475726E20742E5F65';
wwv_flow_imp.g_varchar2_table(3844) := '78636C756465645B655D3D21302C742E5F75706461746528292C747D2C6F2E70726F746F747970652E726561643D66756E6374696F6E28297B76617220653D22223B653D746869732E5F6D617463685F7061747465726E3F746869732E5F696E7075742E';
wwv_flow_imp.g_varchar2_table(3845) := '7265616428746869732E5F7374617274696E675F7061747465726E293A746869732E5F696E7075742E7265616428746869732E5F7374617274696E675F7061747465726E2C746869732E5F5F74656D706C6174655F7061747465726E293B666F72287661';
wwv_flow_imp.g_varchar2_table(3846) := '7220743D746869732E5F726561645F74656D706C61746528293B743B29746869732E5F6D617463685F7061747465726E3F742B3D746869732E5F696E7075742E7265616428746869732E5F6D617463685F7061747465726E293A742B3D746869732E5F69';
wwv_flow_imp.g_varchar2_table(3847) := '6E7075742E72656164556E74696C28746869732E5F5F74656D706C6174655F7061747465726E292C652B3D742C743D746869732E5F726561645F74656D706C61746528293B72657475726E20746869732E5F756E74696C5F6166746572262628652B3D74';
wwv_flow_imp.g_varchar2_table(3848) := '6869732E5F696E7075742E72656164556E74696C416674657228746869732E5F756E74696C5F7061747465726E29292C657D2C6F2E70726F746F747970652E5F5F7365745F74656D706C617465645F7061747465726E3D66756E6374696F6E28297B7661';
wwv_flow_imp.g_varchar2_table(3849) := '7220653D5B5D3B746869732E5F64697361626C65642E7068707C7C652E7075736828746869732E5F5F7061747465726E732E7068702E5F7374617274696E675F7061747465726E2E736F75726365292C746869732E5F64697361626C65642E68616E646C';
wwv_flow_imp.g_varchar2_table(3850) := '65626172737C7C652E7075736828746869732E5F5F7061747465726E732E68616E646C65626172732E5F7374617274696E675F7061747465726E2E736F75726365292C746869732E5F64697361626C65642E6572627C7C652E7075736828746869732E5F';
wwv_flow_imp.g_varchar2_table(3851) := '5F7061747465726E732E6572622E5F7374617274696E675F7061747465726E2E736F75726365292C746869732E5F64697361626C65642E646A616E676F7C7C28652E7075736828746869732E5F5F7061747465726E732E646A616E676F2E5F7374617274';
wwv_flow_imp.g_varchar2_table(3852) := '696E675F7061747465726E2E736F75726365292C652E7075736828746869732E5F5F7061747465726E732E646A616E676F5F76616C75652E5F7374617274696E675F7061747465726E2E736F75726365292C652E7075736828746869732E5F5F70617474';
wwv_flow_imp.g_varchar2_table(3853) := '65726E732E646A616E676F5F636F6D6D656E742E5F7374617274696E675F7061747465726E2E736F7572636529292C746869732E5F64697361626C65642E736D617274797C7C652E7075736828746869732E5F5F7061747465726E732E736D617274792E';
wwv_flow_imp.g_varchar2_table(3854) := '5F7374617274696E675F7061747465726E2E736F75726365292C746869732E5F756E74696C5F7061747465726E2626652E7075736828746869732E5F756E74696C5F7061747465726E2E736F75726365292C746869732E5F5F74656D706C6174655F7061';
wwv_flow_imp.g_varchar2_table(3855) := '747465726E3D746869732E5F696E7075742E6765745F7265676578702822283F3A222B652E6A6F696E28227C22292B222922297D2C6F2E70726F746F747970652E5F726561645F74656D706C6174653D66756E6374696F6E28297B76617220653D22222C';
wwv_flow_imp.g_varchar2_table(3856) := '743D746869732E5F696E7075742E7065656B28293B696628223C223D3D3D74297B766172206E3D746869732E5F696E7075742E7065656B2831293B746869732E5F64697361626C65642E7068707C7C746869732E5F6578636C756465642E7068707C7C22';
wwv_flow_imp.g_varchar2_table(3857) := '3F22213D3D6E7C7C28653D657C7C746869732E5F5F7061747465726E732E7068702E726561642829292C746869732E5F64697361626C65642E6572627C7C746869732E5F6578636C756465642E6572627C7C222522213D3D6E7C7C28653D657C7C746869';
wwv_flow_imp.g_varchar2_table(3858) := '732E5F5F7061747465726E732E6572622E726561642829297D656C7365227B223D3D3D74262628746869732E5F64697361626C65642E68616E646C65626172737C7C746869732E5F6578636C756465642E68616E646C65626172737C7C28653D28653D28';
wwv_flow_imp.g_varchar2_table(3859) := '653D657C7C746869732E5F5F7061747465726E732E68616E646C65626172735F636F6D6D656E742E726561642829297C7C746869732E5F5F7061747465726E732E68616E646C65626172735F756E657363617065642E726561642829297C7C746869732E';
wwv_flow_imp.g_varchar2_table(3860) := '5F5F7061747465726E732E68616E646C65626172732E726561642829292C746869732E5F64697361626C65642E646A616E676F7C7C28746869732E5F6578636C756465642E646A616E676F7C7C746869732E5F6578636C756465642E68616E646C656261';
wwv_flow_imp.g_varchar2_table(3861) := '72737C7C28653D657C7C746869732E5F5F7061747465726E732E646A616E676F5F76616C75652E726561642829292C746869732E5F6578636C756465642E646A616E676F7C7C28653D28653D657C7C746869732E5F5F7061747465726E732E646A616E67';
wwv_flow_imp.g_varchar2_table(3862) := '6F5F636F6D6D656E742E726561642829297C7C746869732E5F5F7061747465726E732E646A616E676F2E72656164282929292C746869732E5F64697361626C65642E736D617274797C7C746869732E5F64697361626C65642E646A616E676F2626746869';
wwv_flow_imp.g_varchar2_table(3863) := '732E5F64697361626C65642E68616E646C6562617273262628653D28653D28653D657C7C746869732E5F5F7061747465726E732E736D617274795F636F6D6D656E742E726561642829297C7C746869732E5F5F7061747465726E732E736D617274795F6C';
wwv_flow_imp.g_varchar2_table(3864) := '69746572616C2E726561642829297C7C746869732E5F5F7061747465726E732E736D617274792E72656164282929293B72657475726E20657D2C652E6578706F7274732E54656D706C617461626C655061747465726E3D6F7D2C2C2C2C66756E6374696F';
wwv_flow_imp.g_varchar2_table(3865) := '6E28652C742C6E297B76617220693D6E283139292E426561757469666965722C723D6E283230292E4F7074696F6E733B652E6578706F7274733D66756E6374696F6E28652C742C6E2C72297B72657475726E206E6577206928652C742C6E2C72292E6265';
wwv_flow_imp.g_varchar2_table(3866) := '61757469667928297D2C652E6578706F7274732E64656661756C744F7074696F6E733D66756E6374696F6E28297B72657475726E206E657720727D7D2C66756E6374696F6E28652C742C6E297B76617220693D6E283230292E4F7074696F6E732C723D6E';
wwv_flow_imp.g_varchar2_table(3867) := '2832292E4F75747075742C6F3D6E283231292E546F6B656E697A65722C613D6E283231292E544F4B454E2C733D2F5C725C6E7C5B5C725C6E5D2F2C6C3D2F5C725C6E7C5B5C725C6E5D2F672C683D66756E6374696F6E28652C74297B746869732E696E64';
wwv_flow_imp.g_varchar2_table(3868) := '656E745F6C6576656C3D302C746869732E616C69676E6D656E745F73697A653D302C746869732E6D61785F70726573657276655F6E65776C696E65733D652E6D61785F70726573657276655F6E65776C696E65732C746869732E70726573657276655F6E';
wwv_flow_imp.g_varchar2_table(3869) := '65776C696E65733D652E70726573657276655F6E65776C696E65732C746869732E5F6F75747075743D6E6577207228652C74297D3B682E70726F746F747970652E63757272656E745F6C696E655F6861735F6D617463683D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(3870) := '72657475726E20746869732E5F6F75747075742E63757272656E745F6C696E652E6861735F6D617463682865297D2C682E70726F746F747970652E7365745F73706163655F6265666F72655F746F6B656E3D66756E6374696F6E28652C74297B74686973';
wwv_flow_imp.g_varchar2_table(3871) := '2E5F6F75747075742E73706163655F6265666F72655F746F6B656E3D652C746869732E5F6F75747075742E6E6F6E5F627265616B696E675F73706163653D747D2C682E70726F746F747970652E7365745F777261705F706F696E743D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3872) := '28297B746869732E5F6F75747075742E7365745F696E64656E7428746869732E696E64656E745F6C6576656C2C746869732E616C69676E6D656E745F73697A65292C746869732E5F6F75747075742E7365745F777261705F706F696E7428297D2C682E70';
wwv_flow_imp.g_varchar2_table(3873) := '726F746F747970652E6164645F7261775F746F6B656E3D66756E6374696F6E2865297B746869732E5F6F75747075742E6164645F7261775F746F6B656E2865297D2C682E70726F746F747970652E7072696E745F7072657365727665645F6E65776C696E';
wwv_flow_imp.g_varchar2_table(3874) := '65733D66756E6374696F6E2865297B76617220743D303B652E74797065213D3D612E544558542626652E70726576696F75732E74797065213D3D612E54455854262628743D652E6E65776C696E65733F313A30292C746869732E70726573657276655F6E';
wwv_flow_imp.g_varchar2_table(3875) := '65776C696E6573262628743D652E6E65776C696E65733C746869732E6D61785F70726573657276655F6E65776C696E65732B313F652E6E65776C696E65733A746869732E6D61785F70726573657276655F6E65776C696E65732B31293B666F7228766172';
wwv_flow_imp.g_varchar2_table(3876) := '206E3D303B6E3C743B6E2B2B29746869732E7072696E745F6E65776C696E65286E3E30293B72657475726E2030213D3D747D2C682E70726F746F747970652E74726176657273655F776869746573706163653D66756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(3877) := '6E212821652E776869746573706163655F6265666F7265262621652E6E65776C696E65737C7C28746869732E7072696E745F7072657365727665645F6E65776C696E65732865297C7C28746869732E5F6F75747075742E73706163655F6265666F72655F';
wwv_flow_imp.g_varchar2_table(3878) := '746F6B656E3D2130292C3029297D2C682E70726F746F747970652E70726576696F75735F746F6B656E5F777261707065643D66756E6374696F6E28297B72657475726E20746869732E5F6F75747075742E70726576696F75735F746F6B656E5F77726170';
wwv_flow_imp.g_varchar2_table(3879) := '7065647D2C682E70726F746F747970652E7072696E745F6E65776C696E653D66756E6374696F6E2865297B746869732E5F6F75747075742E6164645F6E65775F6C696E652865297D2C682E70726F746F747970652E7072696E745F746F6B656E3D66756E';
wwv_flow_imp.g_varchar2_table(3880) := '6374696F6E2865297B652E74657874262628746869732E5F6F75747075742E7365745F696E64656E7428746869732E696E64656E745F6C6576656C2C746869732E616C69676E6D656E745F73697A65292C746869732E5F6F75747075742E6164645F746F';
wwv_flow_imp.g_varchar2_table(3881) := '6B656E28652E7465787429297D2C682E70726F746F747970652E696E64656E743D66756E6374696F6E28297B746869732E696E64656E745F6C6576656C2B2B7D2C682E70726F746F747970652E6765745F66756C6C5F696E64656E743D66756E6374696F';
wwv_flow_imp.g_varchar2_table(3882) := '6E2865297B72657475726E28653D746869732E696E64656E745F6C6576656C2B28657C7C3029293C313F22223A746869732E5F6F75747075742E6765745F696E64656E745F737472696E672865297D3B66756E6374696F6E206328652C74297B72657475';
wwv_flow_imp.g_varchar2_table(3883) := '726E2D31213D3D742E696E6465784F662865297D66756E6374696F6E206428652C742C6E297B746869732E706172656E743D657C7C6E756C6C2C746869732E7461673D743F742E7461675F6E616D653A22222C746869732E696E64656E745F6C6576656C';
wwv_flow_imp.g_varchar2_table(3884) := '3D6E7C7C302C746869732E7061727365725F746F6B656E3D747C7C6E756C6C7D66756E6374696F6E20752865297B746869732E5F7072696E7465723D652C746869732E5F63757272656E745F6672616D653D6E756C6C7D66756E6374696F6E206D28652C';
wwv_flow_imp.g_varchar2_table(3885) := '742C6E2C72297B746869732E5F736F757263655F746578743D657C7C22222C743D747C7C7B7D2C746869732E5F6A735F62656175746966793D6E2C746869732E5F6373735F62656175746966793D722C746869732E5F7461675F737461636B3D6E756C6C';
wwv_flow_imp.g_varchar2_table(3886) := '3B766172206F3D6E6577206928742C2268746D6C22293B746869732E5F6F7074696F6E733D6F2C746869732E5F69735F777261705F617474726962757465735F666F7263653D22666F726365223D3D3D746869732E5F6F7074696F6E732E777261705F61';
wwv_flow_imp.g_varchar2_table(3887) := '7474726962757465732E73756273747228302C35292C746869732E5F69735F777261705F617474726962757465735F666F7263655F657870616E645F6D756C74696C696E653D22666F7263652D657870616E642D6D756C74696C696E65223D3D3D746869';
wwv_flow_imp.g_varchar2_table(3888) := '732E5F6F7074696F6E732E777261705F617474726962757465732C746869732E5F69735F777261705F617474726962757465735F666F7263655F616C69676E65643D22666F7263652D616C69676E6564223D3D3D746869732E5F6F7074696F6E732E7772';
wwv_flow_imp.g_varchar2_table(3889) := '61705F617474726962757465732C746869732E5F69735F777261705F617474726962757465735F616C69676E65645F6D756C7469706C653D22616C69676E65642D6D756C7469706C65223D3D3D746869732E5F6F7074696F6E732E777261705F61747472';
wwv_flow_imp.g_varchar2_table(3890) := '6962757465732C746869732E5F69735F777261705F617474726962757465735F70726573657276653D227072657365727665223D3D3D746869732E5F6F7074696F6E732E777261705F617474726962757465732E73756273747228302C38292C74686973';
wwv_flow_imp.g_varchar2_table(3891) := '2E5F69735F777261705F617474726962757465735F70726573657276655F616C69676E65643D2270726573657276652D616C69676E6564223D3D3D746869732E5F6F7074696F6E732E777261705F617474726962757465737D752E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(3892) := '2E6765745F7061727365725F746F6B656E3D66756E6374696F6E28297B72657475726E20746869732E5F63757272656E745F6672616D653F746869732E5F63757272656E745F6672616D652E7061727365725F746F6B656E3A6E756C6C7D2C752E70726F';
wwv_flow_imp.g_varchar2_table(3893) := '746F747970652E7265636F72645F7461673D66756E6374696F6E2865297B76617220743D6E6577206428746869732E5F63757272656E745F6672616D652C652C746869732E5F7072696E7465722E696E64656E745F6C6576656C293B746869732E5F6375';
wwv_flow_imp.g_varchar2_table(3894) := '7272656E745F6672616D653D747D2C752E70726F746F747970652E5F7472795F706F705F6672616D653D66756E6374696F6E2865297B76617220743D6E756C6C3B72657475726E2065262628743D652E7061727365725F746F6B656E2C746869732E5F70';
wwv_flow_imp.g_varchar2_table(3895) := '72696E7465722E696E64656E745F6C6576656C3D652E696E64656E745F6C6576656C2C746869732E5F63757272656E745F6672616D653D652E706172656E74292C747D2C752E70726F746F747970652E5F6765745F6672616D653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3896) := '652C74297B666F7228766172206E3D746869732E5F63757272656E745F6672616D653B6E26262D313D3D3D652E696E6465784F66286E2E746167293B297B6966287426262D31213D3D742E696E6465784F66286E2E74616729297B6E3D6E756C6C3B6272';
wwv_flow_imp.g_varchar2_table(3897) := '65616B7D6E3D6E2E706172656E747D72657475726E206E7D2C752E70726F746F747970652E7472795F706F703D66756E6374696F6E28652C74297B766172206E3D746869732E5F6765745F6672616D65285B655D2C74293B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(3898) := '5F7472795F706F705F6672616D65286E297D2C752E70726F746F747970652E696E64656E745F746F5F7461673D66756E6374696F6E2865297B76617220743D746869732E5F6765745F6672616D652865293B74262628746869732E5F7072696E7465722E';
wwv_flow_imp.g_varchar2_table(3899) := '696E64656E745F6C6576656C3D742E696E64656E745F6C6576656C297D2C6D2E70726F746F747970652E62656175746966793D66756E6374696F6E28297B696628746869732E5F6F7074696F6E732E64697361626C65642972657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(3900) := '5F736F757263655F746578743B76617220653D746869732E5F736F757263655F746578742C743D746869732E5F6F7074696F6E732E656F6C3B226175746F223D3D3D746869732E5F6F7074696F6E732E656F6C262628743D225C6E222C652626732E7465';
wwv_flow_imp.g_varchar2_table(3901) := '7374286529262628743D652E6D617463682873295B305D29293B766172206E3D28653D652E7265706C616365286C2C225C6E2229292E6D61746368282F5E5B5C74205D2A2F295B305D2C693D7B746578743A22222C747970653A22227D2C723D6E657720';
wwv_flow_imp.g_varchar2_table(3902) := '702C633D6E6577206828746869732E5F6F7074696F6E732C6E292C643D6E6577206F28652C746869732E5F6F7074696F6E73292E746F6B656E697A6528293B746869732E5F7461675F737461636B3D6E657720752863293B666F7228766172206D3D6E75';
wwv_flow_imp.g_varchar2_table(3903) := '6C6C2C663D642E6E65787428293B662E74797065213D3D612E454F463B29662E747970653D3D3D612E5441475F4F50454E7C7C662E747970653D3D3D612E434F4D4D454E543F723D6D3D746869732E5F68616E646C655F7461675F6F70656E28632C662C';
wwv_flow_imp.g_varchar2_table(3904) := '722C69293A662E747970653D3D3D612E4154545249425554457C7C662E747970653D3D3D612E455155414C537C7C662E747970653D3D3D612E56414C55457C7C662E747970653D3D3D612E54455854262621722E7461675F636F6D706C6574653F6D3D74';
wwv_flow_imp.g_varchar2_table(3905) := '6869732E5F68616E646C655F696E736964655F74616728632C662C722C64293A662E747970653D3D3D612E5441475F434C4F53453F6D3D746869732E5F68616E646C655F7461675F636C6F736528632C662C72293A662E747970653D3D3D612E54455854';
wwv_flow_imp.g_varchar2_table(3906) := '3F6D3D746869732E5F68616E646C655F7465787428632C662C72293A632E6164645F7261775F746F6B656E2866292C693D6D2C663D642E6E65787428293B72657475726E20632E5F6F75747075742E6765745F636F64652874297D2C6D2E70726F746F74';
wwv_flow_imp.g_varchar2_table(3907) := '7970652E5F68616E646C655F7461675F636C6F73653D66756E6374696F6E28652C742C6E297B76617220693D7B746578743A742E746578742C747970653A742E747970657D3B72657475726E20652E616C69676E6D656E745F73697A653D302C6E2E7461';
wwv_flow_imp.g_varchar2_table(3908) := '675F636F6D706C6574653D21302C652E7365745F73706163655F6265666F72655F746F6B656E28742E6E65776C696E65737C7C2222213D3D742E776869746573706163655F6265666F72652C2130292C6E2E69735F756E666F726D61747465643F652E61';
wwv_flow_imp.g_varchar2_table(3909) := '64645F7261775F746F6B656E2874293A28223C223D3D3D6E2E7461675F73746172745F63686172262628652E7365745F73706163655F6265666F72655F746F6B656E28222F223D3D3D742E746578745B305D2C2130292C746869732E5F69735F77726170';
wwv_flow_imp.g_varchar2_table(3910) := '5F617474726962757465735F666F7263655F657870616E645F6D756C74696C696E6526266E2E6861735F777261707065645F61747472732626652E7072696E745F6E65776C696E6528213129292C652E7072696E745F746F6B656E287429292C216E2E69';
wwv_flow_imp.g_varchar2_table(3911) := '6E64656E745F636F6E74656E747C7C6E2E69735F756E666F726D61747465647C7C6E2E69735F636F6E74656E745F756E666F726D61747465647C7C28652E696E64656E7428292C6E2E696E64656E745F636F6E74656E743D2131292C6E2E69735F696E6C';
wwv_flow_imp.g_varchar2_table(3912) := '696E655F656C656D656E747C7C6E2E69735F756E666F726D61747465647C7C6E2E69735F636F6E74656E745F756E666F726D61747465647C7C652E7365745F777261705F706F696E7428292C697D2C6D2E70726F746F747970652E5F68616E646C655F69';
wwv_flow_imp.g_varchar2_table(3913) := '6E736964655F7461673D66756E6374696F6E28652C742C6E2C69297B76617220723D6E2E6861735F777261707065645F61747472732C6F3D7B746578743A742E746578742C747970653A742E747970657D3B696628652E7365745F73706163655F626566';
wwv_flow_imp.g_varchar2_table(3914) := '6F72655F746F6B656E28742E6E65776C696E65737C7C2222213D3D742E776869746573706163655F6265666F72652C2130292C6E2E69735F756E666F726D617474656429652E6164645F7261775F746F6B656E2874293B656C736520696628227B223D3D';
wwv_flow_imp.g_varchar2_table(3915) := '3D6E2E7461675F73746172745F636861722626742E747970653D3D3D612E5445585429652E7072696E745F7072657365727665645F6E65776C696E65732874293F28742E6E65776C696E65733D302C652E6164645F7261775F746F6B656E287429293A65';
wwv_flow_imp.g_varchar2_table(3916) := '2E7072696E745F746F6B656E2874293B656C73657B696628742E747970653D3D3D612E4154545249425554453F28652E7365745F73706163655F6265666F72655F746F6B656E282130292C6E2E617474725F636F756E742B3D31293A28742E747970653D';
wwv_flow_imp.g_varchar2_table(3917) := '3D3D612E455155414C537C7C742E747970653D3D3D612E56414C55452626742E70726576696F75732E747970653D3D3D612E455155414C53292626652E7365745F73706163655F6265666F72655F746F6B656E282131292C742E747970653D3D3D612E41';
wwv_flow_imp.g_varchar2_table(3918) := '54545249425554452626223C223D3D3D6E2E7461675F73746172745F6368617226262828746869732E5F69735F777261705F617474726962757465735F70726573657276657C7C746869732E5F69735F777261705F617474726962757465735F70726573';
wwv_flow_imp.g_varchar2_table(3919) := '657276655F616C69676E656429262628652E74726176657273655F776869746573706163652874292C723D727C7C30213D3D742E6E65776C696E6573292C746869732E5F69735F777261705F617474726962757465735F666F72636529297B7661722073';
wwv_flow_imp.g_varchar2_table(3920) := '3D6E2E617474725F636F756E743E313B696628746869732E5F69735F777261705F617474726962757465735F666F7263655F657870616E645F6D756C74696C696E652626313D3D3D6E2E617474725F636F756E74297B766172206C2C683D21302C633D30';
wwv_flow_imp.g_varchar2_table(3921) := '3B646F7B696628286C3D692E7065656B286329292E747970653D3D3D612E415454524942555445297B683D21313B627265616B7D632B3D317D7768696C6528633C3426266C2E74797065213D3D612E454F4626266C2E74797065213D3D612E5441475F43';
wwv_flow_imp.g_varchar2_table(3922) := '4C4F5345293B733D21687D73262628652E7072696E745F6E65776C696E65282131292C723D2130297D652E7072696E745F746F6B656E2874292C723D727C7C652E70726576696F75735F746F6B656E5F7772617070656428292C6E2E6861735F77726170';
wwv_flow_imp.g_varchar2_table(3923) := '7065645F61747472733D727D72657475726E206F7D2C6D2E70726F746F747970652E5F68616E646C655F746578743D66756E6374696F6E28652C742C6E297B76617220693D7B746578743A742E746578742C747970653A22544B5F434F4E54454E54227D';
wwv_flow_imp.g_varchar2_table(3924) := '3B72657475726E206E2E637573746F6D5F626561757469666965725F6E616D653F746869732E5F7072696E745F637573746F6D5F6265617469666965725F7465787428652C742C6E293A6E2E69735F756E666F726D61747465647C7C6E2E69735F636F6E';
wwv_flow_imp.g_varchar2_table(3925) := '74656E745F756E666F726D61747465643F652E6164645F7261775F746F6B656E2874293A28652E74726176657273655F776869746573706163652874292C652E7072696E745F746F6B656E287429292C697D2C6D2E70726F746F747970652E5F7072696E';
wwv_flow_imp.g_varchar2_table(3926) := '745F637573746F6D5F6265617469666965725F746578743D66756E6374696F6E28652C742C6E297B76617220693D746869733B6966282222213D3D742E74657874297B76617220722C6F3D742E746578742C613D312C733D22222C6C3D22223B226A6176';
wwv_flow_imp.g_varchar2_table(3927) := '61736372697074223D3D3D6E2E637573746F6D5F626561757469666965725F6E616D6526262266756E6374696F6E223D3D747970656F6620746869732E5F6A735F62656175746966793F723D746869732E5F6A735F62656175746966793A22637373223D';
wwv_flow_imp.g_varchar2_table(3928) := '3D3D6E2E637573746F6D5F626561757469666965725F6E616D6526262266756E6374696F6E223D3D747970656F6620746869732E5F6373735F62656175746966793F723D746869732E5F6373735F62656175746966793A2268746D6C223D3D3D6E2E6375';
wwv_flow_imp.g_varchar2_table(3929) := '73746F6D5F626561757469666965725F6E616D65262628723D66756E6374696F6E28652C74297B72657475726E206E6577206D28652C742C692E5F6A735F62656175746966792C692E5F6373735F6265617574696679292E626561757469667928297D29';
wwv_flow_imp.g_varchar2_table(3930) := '2C226B656570223D3D3D746869732E5F6F7074696F6E732E696E64656E745F736372697074733F613D303A227365706172617465223D3D3D746869732E5F6F7074696F6E732E696E64656E745F73637269707473262628613D2D652E696E64656E745F6C';
wwv_flow_imp.g_varchar2_table(3931) := '6576656C293B76617220683D652E6765745F66756C6C5F696E64656E742861293B6966286F3D6F2E7265706C616365282F5C6E5B205C745D2A242F2C2222292C2268746D6C22213D3D6E2E637573746F6D5F626561757469666965725F6E616D65262622';
wwv_flow_imp.g_varchar2_table(3932) := '3C223D3D3D6F5B305D26266F2E6D61746368282F5E283C212D2D7C3C215C5B43444154415C5B292F29297B76617220633D2F5E283C212D2D5B5E5C6E5D2A7C3C215C5B43444154415C5B29285C6E3F29285B205C745C6E5D2A29285B5C735C535D2A2928';
wwv_flow_imp.g_varchar2_table(3933) := '2D2D3E7C5D5D3E29242F2E65786563286F293B69662821632972657475726E20766F696420652E6164645F7261775F746F6B656E2874293B733D682B635B315D2B225C6E222C6F3D635B345D2C635B355D2626286C3D682B635B355D292C6F3D6F2E7265';
wwv_flow_imp.g_varchar2_table(3934) := '706C616365282F5C6E5B205C745D2A242F2C2222292C28635B325D7C7C2D31213D3D635B335D2E696E6465784F6628225C6E222929262628633D635B335D2E6D61746368282F5B205C745D2B242F2929262628742E776869746573706163655F6265666F';
wwv_flow_imp.g_varchar2_table(3935) := '72653D635B305D297D6966286F2969662872297B76617220643D66756E6374696F6E28297B746869732E656F6C3D225C6E227D3B642E70726F746F747970653D746869732E5F6F7074696F6E732E7261775F6F7074696F6E732C6F3D7228682B6F2C6E65';
wwv_flow_imp.g_varchar2_table(3936) := '772064297D656C73657B76617220753D742E776869746573706163655F6265666F72653B752626286F3D6F2E7265706C616365286E65772052656745787028225C6E28222B752B22293F222C226722292C225C6E2229292C6F3D682B6F2E7265706C6163';
wwv_flow_imp.g_varchar2_table(3937) := '65282F5C6E2F672C225C6E222B68297D732626286F3D6F3F732B6F2B225C6E222B6C3A732B6C292C652E7072696E745F6E65776C696E65282131292C6F262628742E746578743D6F2C742E776869746573706163655F6265666F72653D22222C742E6E65';
wwv_flow_imp.g_varchar2_table(3938) := '776C696E65733D302C652E6164645F7261775F746F6B656E2874292C652E7072696E745F6E65776C696E6528213029297D7D2C6D2E70726F746F747970652E5F68616E646C655F7461675F6F70656E3D66756E6374696F6E28652C742C6E2C69297B7661';
wwv_flow_imp.g_varchar2_table(3939) := '7220723D746869732E5F6765745F7461675F6F70656E5F746F6B656E2874293B72657475726E216E2E69735F756E666F726D61747465642626216E2E69735F636F6E74656E745F756E666F726D61747465647C7C6E2E69735F656D7074795F656C656D65';
wwv_flow_imp.g_varchar2_table(3940) := '6E747C7C742E74797065213D3D612E5441475F4F50454E7C7C30213D3D742E746578742E696E6465784F6628223C2F22293F28652E74726176657273655F776869746573706163652874292C746869732E5F7365745F7461675F706F736974696F6E2865';
wwv_flow_imp.g_varchar2_table(3941) := '2C742C722C6E2C69292C722E69735F696E6C696E655F656C656D656E747C7C652E7365745F777261705F706F696E7428292C652E7072696E745F746F6B656E287429293A28652E6164645F7261775F746F6B656E2874292C722E73746172745F7461675F';
wwv_flow_imp.g_varchar2_table(3942) := '746F6B656E3D746869732E5F7461675F737461636B2E7472795F706F7028722E7461675F6E616D6529292C28746869732E5F69735F777261705F617474726962757465735F666F7263655F616C69676E65647C7C746869732E5F69735F777261705F6174';
wwv_flow_imp.g_varchar2_table(3943) := '74726962757465735F616C69676E65645F6D756C7469706C657C7C746869732E5F69735F777261705F617474726962757465735F70726573657276655F616C69676E656429262628722E616C69676E6D656E745F73697A653D742E746578742E6C656E67';
wwv_flow_imp.g_varchar2_table(3944) := '74682B31292C722E7461675F636F6D706C6574657C7C722E69735F756E666F726D61747465647C7C28652E616C69676E6D656E745F73697A653D722E616C69676E6D656E745F73697A65292C727D3B76617220703D66756E6374696F6E28652C74297B76';
wwv_flow_imp.g_varchar2_table(3945) := '6172206E3B746869732E706172656E743D657C7C6E756C6C2C746869732E746578743D22222C746869732E747970653D22544B5F5441475F4F50454E222C746869732E7461675F6E616D653D22222C746869732E69735F696E6C696E655F656C656D656E';
wwv_flow_imp.g_varchar2_table(3946) := '743D21312C746869732E69735F756E666F726D61747465643D21312C746869732E69735F636F6E74656E745F756E666F726D61747465643D21312C746869732E69735F656D7074795F656C656D656E743D21312C746869732E69735F73746172745F7461';
wwv_flow_imp.g_varchar2_table(3947) := '673D21312C746869732E69735F656E645F7461673D21312C746869732E696E64656E745F636F6E74656E743D21312C746869732E6D756C74696C696E655F636F6E74656E743D21312C746869732E637573746F6D5F626561757469666965725F6E616D65';
wwv_flow_imp.g_varchar2_table(3948) := '3D6E756C6C2C746869732E73746172745F7461675F746F6B656E3D6E756C6C2C746869732E617474725F636F756E743D302C746869732E6861735F777261707065645F61747472733D21312C746869732E616C69676E6D656E745F73697A653D302C7468';
wwv_flow_imp.g_varchar2_table(3949) := '69732E7461675F636F6D706C6574653D21312C746869732E7461675F73746172745F636861723D22222C746869732E7461675F636865636B3D22222C743F28746869732E7461675F73746172745F636861723D742E746578745B305D2C746869732E7465';
wwv_flow_imp.g_varchar2_table(3950) := '78743D742E746578742C223C223D3D3D746869732E7461675F73746172745F636861723F286E3D742E746578742E6D61746368282F5E3C285B5E5C733E5D2A292F292C746869732E7461675F636865636B3D6E3F6E5B315D3A2222293A286E3D742E7465';
wwv_flow_imp.g_varchar2_table(3951) := '78742E6D61746368282F5E7B7B283F3A5B5C5E5D7C235C2A3F293F285B5E5C737D5D2B292F292C746869732E7461675F636865636B3D6E3F6E5B315D3A22222C227B7B233E223D3D3D742E746578742626223E223D3D3D746869732E7461675F63686563';
wwv_flow_imp.g_varchar2_table(3952) := '6B26266E756C6C213D3D742E6E657874262628746869732E7461675F636865636B3D742E6E6578742E7465787429292C746869732E7461675F636865636B3D746869732E7461675F636865636B2E746F4C6F7765724361736528292C742E747970653D3D';
wwv_flow_imp.g_varchar2_table(3953) := '3D612E434F4D4D454E54262628746869732E7461675F636F6D706C6574653D2130292C746869732E69735F73746172745F7461673D222F22213D3D746869732E7461675F636865636B2E6368617241742830292C746869732E7461675F6E616D653D7468';
wwv_flow_imp.g_varchar2_table(3954) := '69732E69735F73746172745F7461673F746869732E7461675F636865636B3A746869732E7461675F636865636B2E7375627374722831292C746869732E69735F656E645F7461673D21746869732E69735F73746172745F7461677C7C742E636C6F736564';
wwv_flow_imp.g_varchar2_table(3955) := '2626222F3E223D3D3D742E636C6F7365642E746578742C746869732E69735F656E645F7461673D746869732E69735F656E645F7461677C7C227B223D3D3D746869732E7461675F73746172745F63686172262628746869732E746578742E6C656E677468';
wwv_flow_imp.g_varchar2_table(3956) := '3C337C7C2F5B5E235C5E5D2F2E7465737428746869732E746578742E6368617241742832292929293A746869732E7461675F636F6D706C6574653D21307D3B6D2E70726F746F747970652E5F6765745F7461675F6F70656E5F746F6B656E3D66756E6374';
wwv_flow_imp.g_varchar2_table(3957) := '696F6E2865297B76617220743D6E6577207028746869732E5F7461675F737461636B2E6765745F7061727365725F746F6B656E28292C65293B72657475726E20742E616C69676E6D656E745F73697A653D746869732E5F6F7074696F6E732E777261705F';
wwv_flow_imp.g_varchar2_table(3958) := '617474726962757465735F696E64656E745F73697A652C742E69735F656E645F7461673D742E69735F656E645F7461677C7C6328742E7461675F636865636B2C746869732E5F6F7074696F6E732E766F69645F656C656D656E7473292C742E69735F656D';
wwv_flow_imp.g_varchar2_table(3959) := '7074795F656C656D656E743D742E7461675F636F6D706C6574657C7C742E69735F73746172745F7461672626742E69735F656E645F7461672C742E69735F756E666F726D61747465643D21742E7461675F636F6D706C65746526266328742E7461675F63';
wwv_flow_imp.g_varchar2_table(3960) := '6865636B2C746869732E5F6F7074696F6E732E756E666F726D6174746564292C742E69735F636F6E74656E745F756E666F726D61747465643D21742E69735F656D7074795F656C656D656E7426266328742E7461675F636865636B2C746869732E5F6F70';
wwv_flow_imp.g_varchar2_table(3961) := '74696F6E732E636F6E74656E745F756E666F726D6174746564292C742E69735F696E6C696E655F656C656D656E743D6328742E7461675F6E616D652C746869732E5F6F7074696F6E732E696E6C696E65297C7C227B223D3D3D742E7461675F7374617274';
wwv_flow_imp.g_varchar2_table(3962) := '5F636861722C747D2C6D2E70726F746F747970652E5F7365745F7461675F706F736974696F6E3D66756E6374696F6E28652C742C6E2C692C72297B6966286E2E69735F656D7074795F656C656D656E747C7C286E2E69735F656E645F7461673F6E2E7374';
wwv_flow_imp.g_varchar2_table(3963) := '6172745F7461675F746F6B656E3D746869732E5F7461675F737461636B2E7472795F706F70286E2E7461675F6E616D65293A28746869732E5F646F5F6F7074696F6E616C5F656E645F656C656D656E74286E292626286E2E69735F696E6C696E655F656C';
wwv_flow_imp.g_varchar2_table(3964) := '656D656E747C7C652E7072696E745F6E65776C696E6528213129292C746869732E5F7461675F737461636B2E7265636F72645F746167286E292C2273637269707422213D3D6E2E7461675F6E616D652626227374796C6522213D3D6E2E7461675F6E616D';
wwv_flow_imp.g_varchar2_table(3965) := '657C7C6E2E69735F756E666F726D61747465647C7C6E2E69735F636F6E74656E745F756E666F726D61747465647C7C286E2E637573746F6D5F626561757469666965725F6E616D653D66756E6374696F6E28652C74297B766172206E3D6E756C6C2C693D';
wwv_flow_imp.g_varchar2_table(3966) := '6E756C6C3B72657475726E20742E636C6F7365643F2822736372697074223D3D3D653F6E3D22746578742F6A617661736372697074223A227374796C65223D3D3D652626286E3D22746578742F63737322292C6E3D66756E6374696F6E2865297B666F72';
wwv_flow_imp.g_varchar2_table(3967) := '2876617220743D6E756C6C2C6E3D652E6E6578743B6E2E74797065213D3D612E454F462626652E636C6F736564213D3D6E3B297B6966286E2E747970653D3D3D612E41545452494255544526262274797065223D3D3D6E2E74657874297B6E2E6E657874';
wwv_flow_imp.g_varchar2_table(3968) := '26266E2E6E6578742E747970653D3D3D612E455155414C5326266E2E6E6578742E6E65787426266E2E6E6578742E6E6578742E747970653D3D3D612E56414C5545262628743D6E2E6E6578742E6E6578742E74657874293B627265616B7D6E3D6E2E6E65';
wwv_flow_imp.g_varchar2_table(3969) := '78747D72657475726E20747D2874297C7C6E2C6E2E7365617263682822746578742F63737322293E2D313F693D22637373223A6E2E736561726368282F6D6F64756C657C2828746578747C6170706C69636174696F6E7C646F6A6F295C2F28782D293F28';
wwv_flow_imp.g_varchar2_table(3970) := '6A6176617363726970747C65636D617363726970747C6A7363726970747C6C6976657363726970747C286C645C2B293F6A736F6E7C6D6574686F647C61737065637429292F293E2D313F693D226A617661736372697074223A6E2E736561726368282F28';
wwv_flow_imp.g_varchar2_table(3971) := '746578747C6170706C69636174696F6E7C646F6A6F295C2F28782D293F2868746D6C292F293E2D313F693D2268746D6C223A6E2E736561726368282F746573745C2F6E756C6C2F293E2D31262628693D226E756C6C22292C69293A6E756C6C7D286E2E74';
wwv_flow_imp.g_varchar2_table(3972) := '61675F636865636B2C74292929292C63286E2E7461675F636865636B2C746869732E5F6F7074696F6E732E65787472615F6C696E65727329262628652E7072696E745F6E65776C696E65282131292C652E5F6F75747075742E6A7573745F61646465645F';
wwv_flow_imp.g_varchar2_table(3973) := '626C616E6B6C696E6528297C7C652E7072696E745F6E65776C696E6528213029292C6E2E69735F656D7074795F656C656D656E7429227B223D3D3D6E2E7461675F73746172745F63686172262622656C7365223D3D3D6E2E7461675F636865636B262628';
wwv_flow_imp.g_varchar2_table(3974) := '746869732E5F7461675F737461636B2E696E64656E745F746F5F746167285B226966222C22756E6C657373222C2265616368225D292C6E2E696E64656E745F636F6E74656E743D21302C652E63757272656E745F6C696E655F6861735F6D61746368282F';
wwv_flow_imp.g_varchar2_table(3975) := '7B7B2369662F297C7C652E7072696E745F6E65776C696E6528213129292C22212D2D223D3D3D6E2E7461675F6E616D652626722E747970653D3D3D612E5441475F434C4F53452626692E69735F656E645F74616726262D313D3D3D6E2E746578742E696E';
wwv_flow_imp.g_varchar2_table(3976) := '6465784F6628225C6E22297C7C286E2E69735F696E6C696E655F656C656D656E747C7C6E2E69735F756E666F726D61747465647C7C652E7072696E745F6E65776C696E65282131292C746869732E5F63616C636C756174655F706172656E745F6D756C74';
wwv_flow_imp.g_varchar2_table(3977) := '696C696E6528652C6E29293B656C7365206966286E2E69735F656E645F746167297B766172206F3D21313B6F3D286F3D6E2E73746172745F7461675F746F6B656E26266E2E73746172745F7461675F746F6B656E2E6D756C74696C696E655F636F6E7465';
wwv_flow_imp.g_varchar2_table(3978) := '6E74297C7C216E2E69735F696E6C696E655F656C656D656E7426262128692E69735F696E6C696E655F656C656D656E747C7C692E69735F756E666F726D61747465642926262128722E747970653D3D3D612E5441475F434C4F534526266E2E7374617274';
wwv_flow_imp.g_varchar2_table(3979) := '5F7461675F746F6B656E3D3D3D6929262622544B5F434F4E54454E5422213D3D722E747970652C286E2E69735F636F6E74656E745F756E666F726D61747465647C7C6E2E69735F756E666F726D6174746564292626286F3D2131292C6F2626652E707269';
wwv_flow_imp.g_varchar2_table(3980) := '6E745F6E65776C696E65282131297D656C7365206E2E696E64656E745F636F6E74656E743D216E2E637573746F6D5F626561757469666965725F6E616D652C223C223D3D3D6E2E7461675F73746172745F636861722626282268746D6C223D3D3D6E2E74';
wwv_flow_imp.g_varchar2_table(3981) := '61675F6E616D653F6E2E696E64656E745F636F6E74656E743D746869732E5F6F7074696F6E732E696E64656E745F696E6E65725F68746D6C3A2268656164223D3D3D6E2E7461675F6E616D653F6E2E696E64656E745F636F6E74656E743D746869732E5F';
wwv_flow_imp.g_varchar2_table(3982) := '6F7074696F6E732E696E64656E745F686561645F696E6E65725F68746D6C3A22626F6479223D3D3D6E2E7461675F6E616D652626286E2E696E64656E745F636F6E74656E743D746869732E5F6F7074696F6E732E696E64656E745F626F64795F696E6E65';
wwv_flow_imp.g_varchar2_table(3983) := '725F68746D6C29292C6E2E69735F696E6C696E655F656C656D656E747C7C6E2E69735F756E666F726D61747465647C7C22544B5F434F4E54454E54223D3D3D722E747970652626216E2E69735F636F6E74656E745F756E666F726D61747465647C7C652E';
wwv_flow_imp.g_varchar2_table(3984) := '7072696E745F6E65776C696E65282131292C746869732E5F63616C636C756174655F706172656E745F6D756C74696C696E6528652C6E297D2C6D2E70726F746F747970652E5F63616C636C756174655F706172656E745F6D756C74696C696E653D66756E';
wwv_flow_imp.g_varchar2_table(3985) := '6374696F6E28652C74297B21742E706172656E747C7C21652E5F6F75747075742E6A7573745F61646465645F6E65776C696E6528297C7C28742E69735F696E6C696E655F656C656D656E747C7C742E69735F756E666F726D6174746564292626742E7061';
wwv_flow_imp.g_varchar2_table(3986) := '72656E742E69735F696E6C696E655F656C656D656E747C7C28742E706172656E742E6D756C74696C696E655F636F6E74656E743D2130297D3B76617220663D5B2261646472657373222C2261727469636C65222C226173696465222C22626C6F636B7175';
wwv_flow_imp.g_varchar2_table(3987) := '6F7465222C2264657461696C73222C22646976222C22646C222C226669656C64736574222C2266696763617074696F6E222C22666967757265222C22666F6F746572222C22666F726D222C226831222C226832222C226833222C226834222C226835222C';
wwv_flow_imp.g_varchar2_table(3988) := '226836222C22686561646572222C226872222C226D61696E222C226E6176222C226F6C222C2270222C22707265222C2273656374696F6E222C227461626C65222C22756C225D2C673D5B2261222C22617564696F222C2264656C222C22696E73222C226D';
wwv_flow_imp.g_varchar2_table(3989) := '6170222C226E6F736372697074222C22766964656F225D3B6D2E70726F746F747970652E5F646F5F6F7074696F6E616C5F656E645F656C656D656E743D66756E6374696F6E2865297B76617220743D6E756C6C3B69662821652E69735F656D7074795F65';
wwv_flow_imp.g_varchar2_table(3990) := '6C656D656E742626652E69735F73746172745F7461672626652E706172656E74297B69662822626F6479223D3D3D652E7461675F6E616D6529743D747C7C746869732E5F7461675F737461636B2E7472795F706F7028226865616422293B656C73652069';
wwv_flow_imp.g_varchar2_table(3991) := '6628226C69223D3D3D652E7461675F6E616D6529743D747C7C746869732E5F7461675F737461636B2E7472795F706F7028226C69222C5B226F6C222C22756C225D293B656C736520696628226464223D3D3D652E7461675F6E616D657C7C226474223D3D';
wwv_flow_imp.g_varchar2_table(3992) := '3D652E7461675F6E616D6529743D28743D747C7C746869732E5F7461675F737461636B2E7472795F706F7028226474222C5B22646C225D29297C7C746869732E5F7461675F737461636B2E7472795F706F7028226464222C5B22646C225D293B656C7365';
wwv_flow_imp.g_varchar2_table(3993) := '206966282270223D3D3D652E706172656E742E7461675F6E616D6526262D31213D3D662E696E6465784F6628652E7461675F6E616D6529297B766172206E3D652E706172656E742E706172656E743B6E26262D31213D3D672E696E6465784F66286E2E74';
wwv_flow_imp.g_varchar2_table(3994) := '61675F6E616D65297C7C28743D747C7C746869732E5F7461675F737461636B2E7472795F706F702822702229297D656C7365227270223D3D3D652E7461675F6E616D657C7C227274223D3D3D652E7461675F6E616D653F743D28743D747C7C746869732E';
wwv_flow_imp.g_varchar2_table(3995) := '5F7461675F737461636B2E7472795F706F7028227274222C5B2272756279222C22727463225D29297C7C746869732E5F7461675F737461636B2E7472795F706F7028227270222C5B2272756279222C22727463225D293A226F707467726F7570223D3D3D';
wwv_flow_imp.g_varchar2_table(3996) := '652E7461675F6E616D653F743D747C7C746869732E5F7461675F737461636B2E7472795F706F7028226F707467726F7570222C5B2273656C656374225D293A226F7074696F6E223D3D3D652E7461675F6E616D653F743D747C7C746869732E5F7461675F';
wwv_flow_imp.g_varchar2_table(3997) := '737461636B2E7472795F706F7028226F7074696F6E222C5B2273656C656374222C22646174616C697374222C226F707467726F7570225D293A22636F6C67726F7570223D3D3D652E7461675F6E616D653F743D747C7C746869732E5F7461675F73746163';
wwv_flow_imp.g_varchar2_table(3998) := '6B2E7472795F706F70282263617074696F6E222C5B227461626C65225D293A227468656164223D3D3D652E7461675F6E616D653F743D28743D747C7C746869732E5F7461675F737461636B2E7472795F706F70282263617074696F6E222C5B227461626C';
wwv_flow_imp.g_varchar2_table(3999) := '65225D29297C7C746869732E5F7461675F737461636B2E7472795F706F702822636F6C67726F7570222C5B227461626C65225D293A2274626F6479223D3D3D652E7461675F6E616D657C7C2274666F6F74223D3D3D652E7461675F6E616D653F743D2874';
wwv_flow_imp.g_varchar2_table(4000) := '3D28743D28743D747C7C746869732E5F7461675F737461636B2E7472795F706F70282263617074696F6E222C5B227461626C65225D29297C7C746869732E5F7461675F737461636B2E7472795F706F702822636F6C67726F7570222C5B227461626C6522';
wwv_flow_imp.g_varchar2_table(4001) := '5D29297C7C746869732E5F7461675F737461636B2E7472795F706F7028227468656164222C5B227461626C65225D29297C7C746869732E5F7461675F737461636B2E7472795F706F70282274626F6479222C5B227461626C65225D293A227472223D3D3D';
wwv_flow_imp.g_varchar2_table(4002) := '652E7461675F6E616D653F743D28743D28743D747C7C746869732E5F7461675F737461636B2E7472795F706F70282263617074696F6E222C5B227461626C65225D29297C7C746869732E5F7461675F737461636B2E7472795F706F702822636F6C67726F';
wwv_flow_imp.g_varchar2_table(4003) := '7570222C5B227461626C65225D29297C7C746869732E5F7461675F737461636B2E7472795F706F7028227472222C5B227461626C65222C227468656164222C2274626F6479222C2274666F6F74225D293A22746822213D3D652E7461675F6E616D652626';
wwv_flow_imp.g_varchar2_table(4004) := '22746422213D3D652E7461675F6E616D657C7C28743D28743D747C7C746869732E5F7461675F737461636B2E7472795F706F7028227464222C5B227461626C65222C227468656164222C2274626F6479222C2274666F6F74222C227472225D29297C7C74';
wwv_flow_imp.g_varchar2_table(4005) := '6869732E5F7461675F737461636B2E7472795F706F7028227468222C5B227461626C65222C227468656164222C2274626F6479222C2274666F6F74222C227472225D29293B72657475726E20652E706172656E743D746869732E5F7461675F737461636B';
wwv_flow_imp.g_varchar2_table(4006) := '2E6765745F7061727365725F746F6B656E28292C747D7D2C652E6578706F7274732E426561757469666965723D6D7D2C66756E6374696F6E28652C742C6E297B76617220693D6E2836292E4F7074696F6E733B66756E6374696F6E20722865297B692E63';
wwv_flow_imp.g_varchar2_table(4007) := '616C6C28746869732C652C2268746D6C22292C313D3D3D746869732E74656D706C6174696E672E6C656E6774682626226175746F223D3D3D746869732E74656D706C6174696E675B305D262628746869732E74656D706C6174696E673D5B22646A616E67';
wwv_flow_imp.g_varchar2_table(4008) := '6F222C22657262222C2268616E646C6562617273222C22706870225D292C746869732E696E64656E745F696E6E65725F68746D6C3D746869732E5F6765745F626F6F6C65616E2822696E64656E745F696E6E65725F68746D6C22292C746869732E696E64';
wwv_flow_imp.g_varchar2_table(4009) := '656E745F626F64795F696E6E65725F68746D6C3D746869732E5F6765745F626F6F6C65616E2822696E64656E745F626F64795F696E6E65725F68746D6C222C2130292C746869732E696E64656E745F686561645F696E6E65725F68746D6C3D746869732E';
wwv_flow_imp.g_varchar2_table(4010) := '5F6765745F626F6F6C65616E2822696E64656E745F686561645F696E6E65725F68746D6C222C2130292C746869732E696E64656E745F68616E646C65626172733D746869732E5F6765745F626F6F6C65616E2822696E64656E745F68616E646C65626172';
wwv_flow_imp.g_varchar2_table(4011) := '73222C2130292C746869732E777261705F617474726962757465733D746869732E5F6765745F73656C656374696F6E2822777261705F61747472696275746573222C5B226175746F222C22666F726365222C22666F7263652D616C69676E6564222C2266';
wwv_flow_imp.g_varchar2_table(4012) := '6F7263652D657870616E642D6D756C74696C696E65222C22616C69676E65642D6D756C7469706C65222C227072657365727665222C2270726573657276652D616C69676E6564225D292C746869732E777261705F617474726962757465735F696E64656E';
wwv_flow_imp.g_varchar2_table(4013) := '745F73697A653D746869732E5F6765745F6E756D6265722822777261705F617474726962757465735F696E64656E745F73697A65222C746869732E696E64656E745F73697A65292C746869732E65787472615F6C696E6572733D746869732E5F6765745F';
wwv_flow_imp.g_varchar2_table(4014) := '6172726179282265787472615F6C696E657273222C5B2268656164222C22626F6479222C222F68746D6C225D292C746869732E696E6C696E653D746869732E5F6765745F61727261792822696E6C696E65222C5B2261222C2261626272222C2261726561';
wwv_flow_imp.g_varchar2_table(4015) := '222C22617564696F222C2262222C22626469222C2262646F222C226272222C22627574746F6E222C2263616E766173222C2263697465222C22636F6465222C2264617461222C22646174616C697374222C2264656C222C2264666E222C22656D222C2265';
wwv_flow_imp.g_varchar2_table(4016) := '6D626564222C2269222C22696672616D65222C22696D67222C22696E707574222C22696E73222C226B6264222C226B657967656E222C226C6162656C222C226D6170222C226D61726B222C226D617468222C226D65746572222C226E6F73637269707422';
wwv_flow_imp.g_varchar2_table(4017) := '2C226F626A656374222C226F7574707574222C2270726F6772657373222C2271222C2272756279222C2273222C2273616D70222C2273656C656374222C22736D616C6C222C227370616E222C227374726F6E67222C22737562222C22737570222C227376';
wwv_flow_imp.g_varchar2_table(4018) := '67222C2274656D706C617465222C227465787461726561222C2274696D65222C2275222C22766172222C22766964656F222C22776272222C2274657874222C226163726F6E796D222C22626967222C22737472696B65222C227474225D292C746869732E';
wwv_flow_imp.g_varchar2_table(4019) := '766F69645F656C656D656E74733D746869732E5F6765745F61727261792822766F69645F656C656D656E7473222C5B2261726561222C2262617365222C226272222C22636F6C222C22656D626564222C226872222C22696D67222C22696E707574222C22';
wwv_flow_imp.g_varchar2_table(4020) := '6B657967656E222C226C696E6B222C226D656E756974656D222C226D657461222C22706172616D222C22736F75726365222C22747261636B222C22776272222C2221646F6374797065222C223F786D6C222C2262617365666F6E74222C226973696E6465';
wwv_flow_imp.g_varchar2_table(4021) := '78225D292C746869732E756E666F726D61747465643D746869732E5F6765745F61727261792822756E666F726D6174746564222C5B5D292C746869732E636F6E74656E745F756E666F726D61747465643D746869732E5F6765745F61727261792822636F';
wwv_flow_imp.g_varchar2_table(4022) := '6E74656E745F756E666F726D6174746564222C5B22707265222C227465787461726561225D292C746869732E756E666F726D61747465645F636F6E74656E745F64656C696D697465723D746869732E5F6765745F636861726163746572732822756E666F';
wwv_flow_imp.g_varchar2_table(4023) := '726D61747465645F636F6E74656E745F64656C696D6974657222292C746869732E696E64656E745F736372697074733D746869732E5F6765745F73656C656374696F6E2822696E64656E745F73637269707473222C5B226E6F726D616C222C226B656570';
wwv_flow_imp.g_varchar2_table(4024) := '222C227365706172617465225D297D722E70726F746F747970653D6E657720692C652E6578706F7274732E4F7074696F6E733D727D2C66756E6374696F6E28652C742C6E297B76617220693D6E2839292E546F6B656E697A65722C723D6E2839292E544F';
wwv_flow_imp.g_varchar2_table(4025) := '4B454E2C6F3D6E283133292E446972656374697665732C613D6E283134292E54656D706C617461626C655061747465726E2C733D6E283132292E5061747465726E2C6C3D7B5441475F4F50454E3A22544B5F5441475F4F50454E222C5441475F434C4F53';
wwv_flow_imp.g_varchar2_table(4026) := '453A22544B5F5441475F434C4F5345222C4154545249425554453A22544B5F415454524942555445222C455155414C533A22544B5F455155414C53222C56414C55453A22544B5F56414C5545222C434F4D4D454E543A22544B5F434F4D4D454E54222C54';
wwv_flow_imp.g_varchar2_table(4027) := '4558543A22544B5F54455854222C554E4B4E4F574E3A22544B5F554E4B4E4F574E222C53544152543A722E53544152542C5241573A722E5241572C454F463A722E454F467D2C683D6E6577206F282F3C5C212D2D2F2C2F2D2D3E2F292C633D66756E6374';
wwv_flow_imp.g_varchar2_table(4028) := '696F6E28652C74297B692E63616C6C28746869732C652C74292C746869732E5F63757272656E745F7461675F6E616D653D22223B766172206E3D6E6577206128746869732E5F696E707574292E726561645F6F7074696F6E7328746869732E5F6F707469';
wwv_flow_imp.g_varchar2_table(4029) := '6F6E73292C723D6E6577207328746869732E5F696E707574293B696628746869732E5F5F7061747465726E733D7B776F72643A6E2E756E74696C282F5B5C6E5C725C74203C5D2F292C73696E676C655F71756F74653A6E2E756E74696C5F616674657228';
wwv_flow_imp.g_varchar2_table(4030) := '2F272F292C646F75626C655F71756F74653A6E2E756E74696C5F6166746572282F222F292C6174747269627574653A6E2E756E74696C282F5B5C6E5C725C74203D3E5D7C5C2F3E2F292C656C656D656E745F6E616D653A6E2E756E74696C282F5B5C6E5C';
wwv_flow_imp.g_varchar2_table(4031) := '725C74203E5C2F5D2F292C68616E646C65626172735F636F6D6D656E743A722E7374617274696E675F77697468282F7B7B212D2D2F292E756E74696C5F6166746572282F2D2D7D7D2F292C68616E646C65626172733A722E7374617274696E675F776974';
wwv_flow_imp.g_varchar2_table(4032) := '68282F7B7B2F292E756E74696C5F6166746572282F7D7D2F292C68616E646C65626172735F6F70656E3A722E756E74696C282F5B5C6E5C725C74207D5D2F292C68616E646C65626172735F7261775F636C6F73653A722E756E74696C282F7D7D2F292C63';
wwv_flow_imp.g_varchar2_table(4033) := '6F6D6D656E743A722E7374617274696E675F77697468282F3C212D2D2F292E756E74696C5F6166746572282F2D2D3E2F292C63646174613A722E7374617274696E675F77697468282F3C215C5B43444154415C5B2F292E756E74696C5F6166746572282F';
wwv_flow_imp.g_varchar2_table(4034) := '5D5D3E2F292C636F6E646974696F6E616C5F636F6D6D656E743A722E7374617274696E675F77697468282F3C215C5B2F292E756E74696C5F6166746572282F5D3E2F292C70726F63657373696E673A722E7374617274696E675F77697468282F3C5C3F2F';
wwv_flow_imp.g_varchar2_table(4035) := '292E756E74696C5F6166746572282F5C3F3E2F297D2C746869732E5F6F7074696F6E732E696E64656E745F68616E646C6562617273262628746869732E5F5F7061747465726E732E776F72643D746869732E5F5F7061747465726E732E776F72642E6578';
wwv_flow_imp.g_varchar2_table(4036) := '636C756465282268616E646C65626172732229292C746869732E5F756E666F726D61747465645F636F6E74656E745F64656C696D697465723D6E756C6C2C746869732E5F6F7074696F6E732E756E666F726D61747465645F636F6E74656E745F64656C69';
wwv_flow_imp.g_varchar2_table(4037) := '6D69746572297B766172206F3D746869732E5F696E7075742E6765745F6C69746572616C5F72656765787028746869732E5F6F7074696F6E732E756E666F726D61747465645F636F6E74656E745F64656C696D69746572293B746869732E5F5F70617474';
wwv_flow_imp.g_varchar2_table(4038) := '65726E732E756E666F726D61747465645F636F6E74656E745F64656C696D697465723D722E6D61746368696E67286F292E756E74696C5F6166746572286F297D7D3B28632E70726F746F747970653D6E65772069292E5F69735F636F6D6D656E743D6675';
wwv_flow_imp.g_varchar2_table(4039) := '6E6374696F6E2865297B72657475726E21317D2C632E70726F746F747970652E5F69735F6F70656E696E673D66756E6374696F6E2865297B72657475726E20652E747970653D3D3D6C2E5441475F4F50454E7D2C632E70726F746F747970652E5F69735F';
wwv_flow_imp.g_varchar2_table(4040) := '636C6F73696E673D66756E6374696F6E28652C74297B72657475726E20652E747970653D3D3D6C2E5441475F434C4F534526267426262828223E223D3D3D652E746578747C7C222F3E223D3D3D652E74657874292626223C223D3D3D742E746578745B30';
wwv_flow_imp.g_varchar2_table(4041) := '5D7C7C227D7D223D3D3D652E746578742626227B223D3D3D742E746578745B305D2626227B223D3D3D742E746578745B315D297D2C632E70726F746F747970652E5F72657365743D66756E6374696F6E28297B746869732E5F63757272656E745F746167';
wwv_flow_imp.g_varchar2_table(4042) := '5F6E616D653D22227D2C632E70726F746F747970652E5F6765745F6E6578745F746F6B656E3D66756E6374696F6E28652C74297B766172206E3D6E756C6C3B746869732E5F726561645768697465737061636528293B76617220693D746869732E5F696E';
wwv_flow_imp.g_varchar2_table(4043) := '7075742E7065656B28293B72657475726E206E756C6C3D3D3D693F746869732E5F6372656174655F746F6B656E286C2E454F462C2222293A6E3D286E3D286E3D286E3D286E3D286E3D286E3D286E3D286E3D6E7C7C746869732E5F726561645F6F70656E';
wwv_flow_imp.g_varchar2_table(4044) := '5F68616E646C656261727328692C7429297C7C746869732E5F726561645F61747472696275746528692C652C7429297C7C746869732E5F726561645F636C6F736528692C7429297C7C746869732E5F726561645F7261775F636F6E74656E7428692C652C';
wwv_flow_imp.g_varchar2_table(4045) := '7429297C7C746869732E5F726561645F636F6E74656E745F776F7264286929297C7C746869732E5F726561645F636F6D6D656E745F6F725F6364617461286929297C7C746869732E5F726561645F70726F63657373696E67286929297C7C746869732E5F';
wwv_flow_imp.g_varchar2_table(4046) := '726561645F6F70656E28692C7429297C7C746869732E5F6372656174655F746F6B656E286C2E554E4B4E4F574E2C746869732E5F696E7075742E6E6578742829297D2C632E70726F746F747970652E5F726561645F636F6D6D656E745F6F725F63646174';
wwv_flow_imp.g_varchar2_table(4047) := '613D66756E6374696F6E2865297B76617220743D6E756C6C2C6E3D6E756C6C2C693D6E756C6C3B72657475726E223C223D3D3D652626282221223D3D3D746869732E5F696E7075742E7065656B283129262628286E3D746869732E5F5F7061747465726E';
wwv_flow_imp.g_varchar2_table(4048) := '732E636F6D6D656E742E726561642829293F28693D682E6765745F64697265637469766573286E29292626227374617274223D3D3D692E69676E6F72652626286E2B3D682E7265616449676E6F72656428746869732E5F696E70757429293A6E3D746869';
wwv_flow_imp.g_varchar2_table(4049) := '732E5F5F7061747465726E732E63646174612E726561642829292C6E26262828743D746869732E5F6372656174655F746F6B656E286C2E434F4D4D454E542C6E29292E646972656374697665733D6929292C747D2C632E70726F746F747970652E5F7265';
wwv_flow_imp.g_varchar2_table(4050) := '61645F70726F63657373696E673D66756E6374696F6E2865297B76617220743D6E756C6C2C6E3D6E756C6C3B696628223C223D3D3D65297B76617220693D746869732E5F696E7075742E7065656B2831293B222122213D3D692626223F22213D3D697C7C';
wwv_flow_imp.g_varchar2_table(4051) := '286E3D286E3D746869732E5F5F7061747465726E732E636F6E646974696F6E616C5F636F6D6D656E742E726561642829297C7C746869732E5F5F7061747465726E732E70726F63657373696E672E726561642829292C6E26262828743D746869732E5F63';
wwv_flow_imp.g_varchar2_table(4052) := '72656174655F746F6B656E286C2E434F4D4D454E542C6E29292E646972656374697665733D6E756C6C297D72657475726E20747D2C632E70726F746F747970652E5F726561645F6F70656E3D66756E6374696F6E28652C74297B766172206E3D6E756C6C';
wwv_flow_imp.g_varchar2_table(4053) := '2C693D6E756C6C3B72657475726E20747C7C223C223D3D3D652626286E3D746869732E5F696E7075742E6E65787428292C222F223D3D3D746869732E5F696E7075742E7065656B28292626286E2B3D746869732E5F696E7075742E6E6578742829292C6E';
wwv_flow_imp.g_varchar2_table(4054) := '2B3D746869732E5F5F7061747465726E732E656C656D656E745F6E616D652E7265616428292C693D746869732E5F6372656174655F746F6B656E286C2E5441475F4F50454E2C6E29292C697D2C632E70726F746F747970652E5F726561645F6F70656E5F';
wwv_flow_imp.g_varchar2_table(4055) := '68616E646C65626172733D66756E6374696F6E28652C74297B766172206E3D6E756C6C2C693D6E756C6C3B72657475726E20747C7C746869732E5F6F7074696F6E732E696E64656E745F68616E646C65626172732626227B223D3D3D652626227B223D3D';
wwv_flow_imp.g_varchar2_table(4056) := '3D746869732E5F696E7075742E7065656B2831292626282221223D3D3D746869732E5F696E7075742E7065656B2832293F286E3D286E3D746869732E5F5F7061747465726E732E68616E646C65626172735F636F6D6D656E742E726561642829297C7C74';
wwv_flow_imp.g_varchar2_table(4057) := '6869732E5F5F7061747465726E732E68616E646C65626172732E7265616428292C693D746869732E5F6372656174655F746F6B656E286C2E434F4D4D454E542C6E29293A286E3D746869732E5F5F7061747465726E732E68616E646C65626172735F6F70';
wwv_flow_imp.g_varchar2_table(4058) := '656E2E7265616428292C693D746869732E5F6372656174655F746F6B656E286C2E5441475F4F50454E2C6E2929292C697D2C632E70726F746F747970652E5F726561645F636C6F73653D66756E6374696F6E28652C74297B766172206E3D6E756C6C2C69';
wwv_flow_imp.g_varchar2_table(4059) := '3D6E756C6C3B72657475726E2074262628223C223D3D3D742E746578745B305D262628223E223D3D3D657C7C222F223D3D3D652626223E223D3D3D746869732E5F696E7075742E7065656B283129293F286E3D746869732E5F696E7075742E6E65787428';
wwv_flow_imp.g_varchar2_table(4060) := '292C222F223D3D3D652626286E2B3D746869732E5F696E7075742E6E6578742829292C693D746869732E5F6372656174655F746F6B656E286C2E5441475F434C4F53452C6E29293A227B223D3D3D742E746578745B305D2626227D223D3D3D652626227D';
wwv_flow_imp.g_varchar2_table(4061) := '223D3D3D746869732E5F696E7075742E7065656B283129262628746869732E5F696E7075742E6E65787428292C746869732E5F696E7075742E6E65787428292C693D746869732E5F6372656174655F746F6B656E286C2E5441475F434C4F53452C227D7D';
wwv_flow_imp.g_varchar2_table(4062) := '222929292C697D2C632E70726F746F747970652E5F726561645F6174747269627574653D66756E6374696F6E28652C742C6E297B76617220693D6E756C6C2C723D22223B6966286E2626223C223D3D3D6E2E746578745B305D29696628223D223D3D3D65';
wwv_flow_imp.g_varchar2_table(4063) := '29693D746869732E5F6372656174655F746F6B656E286C2E455155414C532C746869732E5F696E7075742E6E6578742829293B656C7365206966282722273D3D3D657C7C2227223D3D3D65297B766172206F3D746869732E5F696E7075742E6E65787428';
wwv_flow_imp.g_varchar2_table(4064) := '293B6F2B3D2722273D3D3D653F746869732E5F5F7061747465726E732E646F75626C655F71756F74652E7265616428293A746869732E5F5F7061747465726E732E73696E676C655F71756F74652E7265616428292C693D746869732E5F6372656174655F';
wwv_flow_imp.g_varchar2_table(4065) := '746F6B656E286C2E56414C55452C6F297D656C736528723D746869732E5F5F7061747465726E732E6174747269627574652E72656164282929262628693D742E747970653D3D3D6C2E455155414C533F746869732E5F6372656174655F746F6B656E286C';
wwv_flow_imp.g_varchar2_table(4066) := '2E56414C55452C72293A746869732E5F6372656174655F746F6B656E286C2E4154545249425554452C7229293B72657475726E20697D2C632E70726F746F747970652E5F69735F636F6E74656E745F756E666F726D61747465643D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(4067) := '65297B72657475726E2D313D3D3D746869732E5F6F7074696F6E732E766F69645F656C656D656E74732E696E6465784F662865292626282D31213D3D746869732E5F6F7074696F6E732E636F6E74656E745F756E666F726D61747465642E696E6465784F';
wwv_flow_imp.g_varchar2_table(4068) := '662865297C7C2D31213D3D746869732E5F6F7074696F6E732E756E666F726D61747465642E696E6465784F66286529297D2C632E70726F746F747970652E5F726561645F7261775F636F6E74656E743D66756E6374696F6E28652C742C6E297B76617220';
wwv_flow_imp.g_varchar2_table(4069) := '693D22223B6966286E2626227B223D3D3D6E2E746578745B305D29693D746869732E5F5F7061747465726E732E68616E646C65626172735F7261775F636C6F73652E7265616428293B656C736520696628742E747970653D3D3D6C2E5441475F434C4F53';
wwv_flow_imp.g_varchar2_table(4070) := '452626223C223D3D3D742E6F70656E65642E746578745B305D2626222F22213D3D742E746578745B305D297B76617220723D742E6F70656E65642E746578742E7375627374722831292E746F4C6F7765724361736528293B69662822736372697074223D';
wwv_flow_imp.g_varchar2_table(4071) := '3D3D727C7C227374796C65223D3D3D72297B766172206F3D746869732E5F726561645F636F6D6D656E745F6F725F63646174612865293B6966286F2972657475726E206F2E747970653D6C2E544558542C6F3B693D746869732E5F696E7075742E726561';
wwv_flow_imp.g_varchar2_table(4072) := '64556E74696C286E65772052656745787028223C2F222B722B225B5C5C6E5C5C725C5C74205D2A3F3E222C2269672229297D656C736520746869732E5F69735F636F6E74656E745F756E666F726D6174746564287229262628693D746869732E5F696E70';
wwv_flow_imp.g_varchar2_table(4073) := '75742E72656164556E74696C286E65772052656745787028223C2F222B722B225B5C5C6E5C5C725C5C74205D2A3F3E222C226967222929297D72657475726E20693F746869732E5F6372656174655F746F6B656E286C2E544558542C69293A6E756C6C7D';
wwv_flow_imp.g_varchar2_table(4074) := '2C632E70726F746F747970652E5F726561645F636F6E74656E745F776F72643D66756E6374696F6E2865297B76617220743D22223B696628746869732E5F6F7074696F6E732E756E666F726D61747465645F636F6E74656E745F64656C696D6974657226';
wwv_flow_imp.g_varchar2_table(4075) := '26653D3D3D746869732E5F6F7074696F6E732E756E666F726D61747465645F636F6E74656E745F64656C696D697465725B305D262628743D746869732E5F5F7061747465726E732E756E666F726D61747465645F636F6E74656E745F64656C696D697465';
wwv_flow_imp.g_varchar2_table(4076) := '722E726561642829292C747C7C28743D746869732E5F5F7061747465726E732E776F72642E726561642829292C742972657475726E20746869732E5F6372656174655F746F6B656E286C2E544558542C74297D2C652E6578706F7274732E546F6B656E69';
wwv_flow_imp.g_varchar2_table(4077) := '7A65723D632C652E6578706F7274732E544F4B454E3D6C7D5D2C743D7B7D2C6E3D66756E6374696F6E206E2869297B76617220723D745B695D3B696628766F69642030213D3D722972657475726E20722E6578706F7274733B766172206F3D745B695D3D';
wwv_flow_imp.g_varchar2_table(4078) := '7B6578706F7274733A7B7D7D3B72657475726E20655B695D286F2C6F2E6578706F7274732C6E292C6F2E6578706F7274737D283138293B636C3D6E7D28292C646C3D2828293D3E7B76617220653D7B3437303A653D3E7B66756E6374696F6E2074286529';
wwv_flow_imp.g_varchar2_table(4079) := '7B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F72282250617468206D757374206265206120737472696E672E20526563656976656420222B4A534F4E2E737472696E67696679286529297D66756E';
wwv_flow_imp.g_varchar2_table(4080) := '6374696F6E206E28652C74297B666F7228766172206E2C693D22222C723D302C6F3D2D312C613D302C733D303B733C3D652E6C656E6774683B2B2B73297B696628733C652E6C656E677468296E3D652E63686172436F646541742873293B656C73657B69';
wwv_flow_imp.g_varchar2_table(4081) := '662834373D3D3D6E29627265616B3B6E3D34377D69662834373D3D3D6E297B6966286F3D3D3D732D317C7C313D3D3D61293B656C7365206966286F213D3D732D312626323D3D3D61297B696628692E6C656E6774683C327C7C32213D3D727C7C3436213D';
wwv_flow_imp.g_varchar2_table(4082) := '3D692E63686172436F6465417428692E6C656E6774682D31297C7C3436213D3D692E63686172436F6465417428692E6C656E6774682D322929696628692E6C656E6774683E32297B766172206C3D692E6C617374496E6465784F6628222F22293B696628';
wwv_flow_imp.g_varchar2_table(4083) := '6C213D3D692E6C656E6774682D31297B2D313D3D3D6C3F28693D22222C723D30293A723D28693D692E736C69636528302C6C29292E6C656E6774682D312D692E6C617374496E6465784F6628222F22292C6F3D732C613D303B636F6E74696E75657D7D65';
wwv_flow_imp.g_varchar2_table(4084) := '6C736520696628323D3D3D692E6C656E6774687C7C313D3D3D692E6C656E677468297B693D22222C723D302C6F3D732C613D303B636F6E74696E75657D74262628692E6C656E6774683E303F692B3D222F2E2E223A693D222E2E222C723D32297D656C73';
wwv_flow_imp.g_varchar2_table(4085) := '6520692E6C656E6774683E303F692B3D222F222B652E736C696365286F2B312C73293A693D652E736C696365286F2B312C73292C723D732D6F2D313B6F3D732C613D307D656C73652034363D3D3D6E26262D31213D3D613F2B2B613A613D2D317D726574';
wwv_flow_imp.g_varchar2_table(4086) := '75726E20697D76617220693D7B7265736F6C76653A66756E6374696F6E28297B666F722876617220652C693D22222C723D21312C6F3D617267756D656E74732E6C656E6774682D313B6F3E3D2D31262621723B6F2D2D297B76617220613B6F3E3D303F61';
wwv_flow_imp.g_varchar2_table(4087) := '3D617267756D656E74735B6F5D3A28766F696420303D3D3D65262628653D70726F636573732E6377642829292C613D65292C742861292C30213D3D612E6C656E677468262628693D612B222F222B692C723D34373D3D3D612E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(4088) := '3029297D72657475726E20693D6E28692C2172292C723F692E6C656E6774683E303F222F222B693A222F223A692E6C656E6774683E303F693A222E227D2C6E6F726D616C697A653A66756E6374696F6E2865297B696628742865292C303D3D3D652E6C65';
wwv_flow_imp.g_varchar2_table(4089) := '6E6774682972657475726E222E223B76617220693D34373D3D3D652E63686172436F646541742830292C723D34373D3D3D652E63686172436F6465417428652E6C656E6774682D31293B72657475726E2030213D3D28653D6E28652C216929292E6C656E';
wwv_flow_imp.g_varchar2_table(4090) := '6774687C7C697C7C28653D222E22292C652E6C656E6774683E30262672262628652B3D222F22292C693F222F222B653A657D2C69734162736F6C7574653A66756E6374696F6E2865297B72657475726E20742865292C652E6C656E6774683E3026263437';
wwv_flow_imp.g_varchar2_table(4091) := '3D3D3D652E63686172436F646541742830297D2C6A6F696E3A66756E6374696F6E28297B696628303D3D3D617267756D656E74732E6C656E6774682972657475726E222E223B666F722876617220652C6E3D303B6E3C617267756D656E74732E6C656E67';
wwv_flow_imp.g_varchar2_table(4092) := '74683B2B2B6E297B76617220723D617267756D656E74735B6E5D3B742872292C722E6C656E6774683E30262628766F696420303D3D3D653F653D723A652B3D222F222B72297D72657475726E20766F696420303D3D3D653F222E223A692E6E6F726D616C';
wwv_flow_imp.g_varchar2_table(4093) := '697A652865297D2C72656C61746976653A66756E6374696F6E28652C6E297B696628742865292C74286E292C653D3D3D6E2972657475726E22223B69662828653D692E7265736F6C7665286529293D3D3D286E3D692E7265736F6C7665286E2929297265';
wwv_flow_imp.g_varchar2_table(4094) := '7475726E22223B666F722876617220723D313B723C652E6C656E677468262634373D3D3D652E63686172436F646541742872293B2B2B72293B666F7228766172206F3D652E6C656E6774682C613D6F2D722C733D313B733C6E2E6C656E67746826263437';
wwv_flow_imp.g_varchar2_table(4095) := '3D3D3D6E2E63686172436F646541742873293B2B2B73293B666F7228766172206C3D6E2E6C656E6774682D732C683D613C6C3F613A6C2C633D2D312C643D303B643C3D683B2B2B64297B696628643D3D3D68297B6966286C3E68297B69662834373D3D3D';
wwv_flow_imp.g_varchar2_table(4096) := '6E2E63686172436F6465417428732B64292972657475726E206E2E736C69636528732B642B31293B696628303D3D3D642972657475726E206E2E736C69636528732B64297D656C736520613E6826262834373D3D3D652E63686172436F6465417428722B';
wwv_flow_imp.g_varchar2_table(4097) := '64293F633D643A303D3D3D64262628633D3029293B627265616B7D76617220753D652E63686172436F6465417428722B64293B69662875213D3D6E2E63686172436F6465417428732B642929627265616B3B34373D3D3D75262628633D64297D76617220';
wwv_flow_imp.g_varchar2_table(4098) := '6D3D22223B666F7228643D722B632B313B643C3D6F3B2B2B642964213D3D6F26263437213D3D652E63686172436F646541742864297C7C28303D3D3D6D2E6C656E6774683F6D2B3D222E2E223A6D2B3D222F2E2E22293B72657475726E206D2E6C656E67';
wwv_flow_imp.g_varchar2_table(4099) := '74683E303F6D2B6E2E736C69636528732B63293A28732B3D632C34373D3D3D6E2E63686172436F6465417428732926262B2B732C6E2E736C696365287329297D2C5F6D616B654C6F6E673A66756E6374696F6E2865297B72657475726E20657D2C646972';
wwv_flow_imp.g_varchar2_table(4100) := '6E616D653A66756E6374696F6E2865297B696628742865292C303D3D3D652E6C656E6774682972657475726E222E223B666F7228766172206E3D652E63686172436F646541742830292C693D34373D3D3D6E2C723D2D312C6F3D21302C613D652E6C656E';
wwv_flow_imp.g_varchar2_table(4101) := '6774682D313B613E3D313B2D2D612969662834373D3D3D286E3D652E63686172436F6465417428612929297B696628216F297B723D613B627265616B7D7D656C7365206F3D21313B72657475726E2D313D3D3D723F693F222F223A222E223A692626313D';
wwv_flow_imp.g_varchar2_table(4102) := '3D3D723F222F2F223A652E736C69636528302C72297D2C626173656E616D653A66756E6374696F6E28652C6E297B696628766F69642030213D3D6E262622737472696E6722213D747970656F66206E297468726F77206E657720547970654572726F7228';
wwv_flow_imp.g_varchar2_table(4103) := '27226578742220617267756D656E74206D757374206265206120737472696E6727293B742865293B76617220692C723D302C6F3D2D312C613D21303B696628766F69642030213D3D6E26266E2E6C656E6774683E3026266E2E6C656E6774683C3D652E6C';
wwv_flow_imp.g_varchar2_table(4104) := '656E677468297B6966286E2E6C656E6774683D3D3D652E6C656E67746826266E3D3D3D652972657475726E22223B76617220733D6E2E6C656E6774682D312C6C3D2D313B666F7228693D652E6C656E6774682D313B693E3D303B2D2D69297B7661722068';
wwv_flow_imp.g_varchar2_table(4105) := '3D652E63686172436F646541742869293B69662834373D3D3D68297B6966282161297B723D692B313B627265616B7D7D656C73652D313D3D3D6C262628613D21312C6C3D692B31292C733E3D30262628683D3D3D6E2E63686172436F646541742873293F';
wwv_flow_imp.g_varchar2_table(4106) := '2D313D3D2D2D732626286F3D69293A28733D2D312C6F3D6C29297D72657475726E20723D3D3D6F3F6F3D6C3A2D313D3D3D6F2626286F3D652E6C656E677468292C652E736C69636528722C6F297D666F7228693D652E6C656E6774682D313B693E3D303B';
wwv_flow_imp.g_varchar2_table(4107) := '2D2D692969662834373D3D3D652E63686172436F64654174286929297B6966282161297B723D692B313B627265616B7D7D656C73652D313D3D3D6F262628613D21312C6F3D692B31293B72657475726E2D313D3D3D6F3F22223A652E736C69636528722C';
wwv_flow_imp.g_varchar2_table(4108) := '6F297D2C6578746E616D653A66756E6374696F6E2865297B742865293B666F7228766172206E3D2D312C693D302C723D2D312C6F3D21302C613D302C733D652E6C656E6774682D313B733E3D303B2D2D73297B766172206C3D652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(4109) := '742873293B6966283437213D3D6C292D313D3D3D722626286F3D21312C723D732B31292C34363D3D3D6C3F2D313D3D3D6E3F6E3D733A31213D3D61262628613D31293A2D31213D3D6E262628613D2D31293B656C736520696628216F297B693D732B313B';
wwv_flow_imp.g_varchar2_table(4110) := '627265616B7D7D72657475726E2D313D3D3D6E7C7C2D313D3D3D727C7C303D3D3D617C7C313D3D3D6126266E3D3D3D722D3126266E3D3D3D692B313F22223A652E736C696365286E2C72297D2C666F726D61743A66756E6374696F6E2865297B6966286E';
wwv_flow_imp.g_varchar2_table(4111) := '756C6C3D3D3D657C7C226F626A65637422213D747970656F662065297468726F77206E657720547970654572726F7228275468652022706174684F626A6563742220617267756D656E74206D757374206265206F662074797065204F626A6563742E2052';
wwv_flow_imp.g_varchar2_table(4112) := '65636569766564207479706520272B747970656F662065293B72657475726E206E3D28743D65292E6469727C7C742E726F6F742C693D742E626173657C7C28742E6E616D657C7C2222292B28742E6578747C7C2222292C6E3F6E3D3D3D742E726F6F743F';
wwv_flow_imp.g_varchar2_table(4113) := '6E2B693A6E2B222F222B693A693B76617220742C6E2C697D2C70617273653A66756E6374696F6E2865297B742865293B766172206E3D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A22222C6E616D653A22227D3B696628303D3D';
wwv_flow_imp.g_varchar2_table(4114) := '3D652E6C656E6774682972657475726E206E3B76617220692C723D652E63686172436F646541742830292C6F3D34373D3D3D723B6F3F286E2E726F6F743D222F222C693D31293A693D303B666F722876617220613D2D312C733D302C6C3D2D312C683D21';
wwv_flow_imp.g_varchar2_table(4115) := '302C633D652E6C656E6774682D312C643D303B633E3D693B2D2D63296966283437213D3D28723D652E63686172436F6465417428632929292D313D3D3D6C262628683D21312C6C3D632B31292C34363D3D3D723F2D313D3D3D613F613D633A31213D3D64';
wwv_flow_imp.g_varchar2_table(4116) := '262628643D31293A2D31213D3D61262628643D2D31293B656C7365206966282168297B733D632B313B627265616B7D72657475726E2D313D3D3D617C7C2D313D3D3D6C7C7C303D3D3D647C7C313D3D3D642626613D3D3D6C2D312626613D3D3D732B313F';
wwv_flow_imp.g_varchar2_table(4117) := '2D31213D3D6C2626286E2E626173653D6E2E6E616D653D303D3D3D7326266F3F652E736C69636528312C6C293A652E736C69636528732C6C29293A28303D3D3D7326266F3F286E2E6E616D653D652E736C69636528312C61292C6E2E626173653D652E73';
wwv_flow_imp.g_varchar2_table(4118) := '6C69636528312C6C29293A286E2E6E616D653D652E736C69636528732C61292C6E2E626173653D652E736C69636528732C6C29292C6E2E6578743D652E736C69636528612C6C29292C733E303F6E2E6469723D652E736C69636528302C732D31293A6F26';
wwv_flow_imp.g_varchar2_table(4119) := '26286E2E6469723D222F22292C6E7D2C7365703A222F222C64656C696D697465723A223A222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D3B692E706F7369783D692C652E6578706F7274733D697D2C3434373A28652C742C6E293D3E7B7661';
wwv_flow_imp.g_varchar2_table(4120) := '7220693B6966286E2E722874292C6E2E6428742C7B5552493A28293D3E662C5574696C733A28293D3E4C7D292C226F626A656374223D3D747970656F662070726F6365737329693D2277696E3332223D3D3D70726F636573732E706C6174666F726D3B65';
wwv_flow_imp.g_varchar2_table(4121) := '6C736520696628226F626A656374223D3D747970656F66206E6176696761746F72297B76617220723D6E6176696761746F722E757365724167656E743B693D722E696E6465784F66282257696E646F777322293E3D307D766172206F2C612C733D286F3D';
wwv_flow_imp.g_varchar2_table(4122) := '66756E6374696F6E28652C74297B72657475726E286F3D4F626A6563742E73657450726F746F747970654F667C7C7B5F5F70726F746F5F5F3A5B5D7D696E7374616E63656F66204172726179262666756E6374696F6E28652C74297B652E5F5F70726F74';
wwv_flow_imp.g_varchar2_table(4123) := '6F5F5F3D747D7C7C66756E6374696F6E28652C74297B666F7228766172206E20696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C6E29262628655B6E5D3D745B6E5D297D2928652C74297D2C';
wwv_flow_imp.g_varchar2_table(4124) := '66756E6374696F6E28652C74297B6966282266756E6374696F6E22213D747970656F66207426266E756C6C213D3D74297468726F77206E657720547970654572726F722822436C61737320657874656E64732076616C756520222B537472696E67287429';
wwv_flow_imp.g_varchar2_table(4125) := '2B22206973206E6F74206120636F6E7374727563746F72206F72206E756C6C22293B66756E6374696F6E206E28297B746869732E636F6E7374727563746F723D657D6F28652C74292C652E70726F746F747970653D6E756C6C3D3D3D743F4F626A656374';
wwv_flow_imp.g_varchar2_table(4126) := '2E6372656174652874293A286E2E70726F746F747970653D742E70726F746F747970652C6E6577206E297D292C6C3D2F5E5C775B5C775C642B2E2D5D2A242F2C683D2F5E5C2F2F2C633D2F5E5C2F5C2F2F3B66756E6374696F6E206428652C74297B6966';
wwv_flow_imp.g_varchar2_table(4127) := '2821652E736368656D65262674297468726F77206E6577204572726F7228275B5572694572726F725D3A20536368656D65206973206D697373696E673A207B736368656D653A2022222C20617574686F726974793A2022272E636F6E63617428652E6175';
wwv_flow_imp.g_varchar2_table(4128) := '74686F726974792C27222C20706174683A202227292E636F6E63617428652E706174682C27222C2071756572793A202227292E636F6E63617428652E71756572792C27222C20667261676D656E743A202227292E636F6E63617428652E667261676D656E';
wwv_flow_imp.g_varchar2_table(4129) := '742C27227D2729293B696628652E736368656D652626216C2E7465737428652E736368656D6529297468726F77206E6577204572726F7228225B5572694572726F725D3A20536368656D6520636F6E7461696E7320696C6C6567616C2063686172616374';
wwv_flow_imp.g_varchar2_table(4130) := '6572732E22293B696628652E7061746829696628652E617574686F72697479297B69662821682E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920636F6E7461696E732061';
wwv_flow_imp.g_varchar2_table(4131) := '6E20617574686F7269747920636F6D706F6E656E742C207468656E20746865207061746820636F6D706F6E656E74206D7573742065697468657220626520656D707479206F7220626567696E2077697468206120736C6173682028222F22292063686172';
wwv_flow_imp.g_varchar2_table(4132) := '616374657227297D656C736520696628632E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920646F6573206E6F7420636F6E7461696E20616E20617574686F726974792063';
wwv_flow_imp.g_varchar2_table(4133) := '6F6D706F6E656E742C207468656E2074686520706174682063616E6E6F7420626567696E20776974682074776F20736C61736820636861726163746572732028222F2F222927297D76617220753D22222C6D3D222F222C703D2F5E28285B5E3A2F3F235D';
wwv_flow_imp.g_varchar2_table(4134) := '2B3F293A293F285C2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A29293F2823282E2A29293F2F2C663D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C692C722C6F297B766F696420303D3D3D6F26';
wwv_flow_imp.g_varchar2_table(4135) := '26286F3D2131292C226F626A656374223D3D747970656F6620653F28746869732E736368656D653D652E736368656D657C7C752C746869732E617574686F726974793D652E617574686F726974797C7C752C746869732E706174683D652E706174687C7C';
wwv_flow_imp.g_varchar2_table(4136) := '752C746869732E71756572793D652E71756572797C7C752C746869732E667261676D656E743D652E667261676D656E747C7C75293A28746869732E736368656D653D66756E6374696F6E28652C74297B72657475726E20657C7C743F653A2266696C6522';
wwv_flow_imp.g_varchar2_table(4137) := '7D28652C6F292C746869732E617574686F726974793D747C7C752C746869732E706174683D66756E6374696F6E28652C74297B7377697463682865297B63617365226874747073223A636173652268747470223A636173652266696C65223A743F745B30';
wwv_flow_imp.g_varchar2_table(4138) := '5D213D3D6D262628743D6D2B74293A743D6D7D72657475726E20747D28746869732E736368656D652C6E7C7C75292C746869732E71756572793D697C7C752C746869732E667261676D656E743D727C7C752C6428746869732C6F29297D72657475726E20';
wwv_flow_imp.g_varchar2_table(4139) := '652E69735572693D66756E6374696F6E2874297B72657475726E207420696E7374616E63656F6620657C7C212174262622737472696E67223D3D747970656F6620742E617574686F72697479262622737472696E67223D3D747970656F6620742E667261';
wwv_flow_imp.g_varchar2_table(4140) := '676D656E74262622737472696E67223D3D747970656F6620742E70617468262622737472696E67223D3D747970656F6620742E7175657279262622737472696E67223D3D747970656F6620742E736368656D65262622737472696E67223D3D747970656F';
wwv_flow_imp.g_varchar2_table(4141) := '6620742E66735061746826262266756E6374696F6E223D3D747970656F6620742E7769746826262266756E6374696F6E223D3D747970656F6620742E746F537472696E677D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F74';
wwv_flow_imp.g_varchar2_table(4142) := '7970652C22667350617468222C7B6765743A66756E6374696F6E28297B72657475726E207928746869732C2131297D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E776974683D66756E';
wwv_flow_imp.g_varchar2_table(4143) := '6374696F6E2865297B69662821652972657475726E20746869733B76617220743D652E736368656D652C6E3D652E617574686F726974792C693D652E706174682C723D652E71756572792C6F3D652E667261676D656E743B72657475726E20766F696420';
wwv_flow_imp.g_varchar2_table(4144) := '303D3D3D743F743D746869732E736368656D653A6E756C6C3D3D3D74262628743D75292C766F696420303D3D3D6E3F6E3D746869732E617574686F726974793A6E756C6C3D3D3D6E2626286E3D75292C766F696420303D3D3D693F693D746869732E7061';
wwv_flow_imp.g_varchar2_table(4145) := '74683A6E756C6C3D3D3D69262628693D75292C766F696420303D3D3D723F723D746869732E71756572793A6E756C6C3D3D3D72262628723D75292C766F696420303D3D3D6F3F6F3D746869732E667261676D656E743A6E756C6C3D3D3D6F2626286F3D75';
wwv_flow_imp.g_varchar2_table(4146) := '292C743D3D3D746869732E736368656D6526266E3D3D3D746869732E617574686F726974792626693D3D3D746869732E706174682626723D3D3D746869732E717565727926266F3D3D3D746869732E667261676D656E743F746869733A6E657720622874';
wwv_flow_imp.g_varchar2_table(4147) := '2C6E2C692C722C6F297D2C652E70617273653D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D2131293B766172206E3D702E657865632865293B72657475726E206E3F6E65772062286E5B325D7C7C752C78286E5B345D7C7C75';
wwv_flow_imp.g_varchar2_table(4148) := '292C78286E5B355D7C7C75292C78286E5B375D7C7C75292C78286E5B395D7C7C75292C74293A6E6577206228752C752C752C752C75297D2C652E66696C653D66756E6374696F6E2865297B76617220743D753B69662869262628653D652E7265706C6163';
wwv_flow_imp.g_varchar2_table(4149) := '65282F5C5C2F672C6D29292C655B305D3D3D3D6D2626655B315D3D3D3D6D297B766172206E3D652E696E6465784F66286D2C32293B2D313D3D3D6E3F28743D652E737562737472696E672832292C653D6D293A28743D652E737562737472696E6728322C';
wwv_flow_imp.g_varchar2_table(4150) := '6E292C653D652E737562737472696E67286E297C7C6D297D72657475726E206E65772062282266696C65222C742C652C752C75297D2C652E66726F6D3D66756E6374696F6E2865297B76617220743D6E6577206228652E736368656D652C652E61757468';
wwv_flow_imp.g_varchar2_table(4151) := '6F726974792C652E706174682C652E71756572792C652E667261676D656E74293B72657475726E206428742C2130292C747D2C652E70726F746F747970652E746F537472696E673D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(4152) := '65262628653D2131292C5428746869732C65297D2C652E70726F746F747970652E746F4A534F4E3D66756E6374696F6E28297B72657475726E20746869737D2C652E7265766976653D66756E6374696F6E2874297B69662874297B6966287420696E7374';
wwv_flow_imp.g_varchar2_table(4153) := '616E63656F6620652972657475726E20743B766172206E3D6E657720622874293B72657475726E206E2E5F666F726D61747465643D742E65787465726E616C2C6E2E5F6673506174683D742E5F7365703D3D3D673F742E6673506174683A6E756C6C2C6E';
wwv_flow_imp.g_varchar2_table(4154) := '7D72657475726E20747D2C657D28292C673D693F313A766F696420302C623D66756E6374696F6E2865297B66756E6374696F6E207428297B76617220743D6E756C6C213D3D652626652E6170706C7928746869732C617267756D656E7473297C7C746869';
wwv_flow_imp.g_varchar2_table(4155) := '733B72657475726E20742E5F666F726D61747465643D6E756C6C2C742E5F6673506174683D6E756C6C2C747D72657475726E207328742C65292C4F626A6563742E646566696E6550726F706572747928742E70726F746F747970652C2266735061746822';
wwv_flow_imp.g_varchar2_table(4156) := '2C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F6673506174687C7C28746869732E5F6673506174683D7928746869732C213129292C746869732E5F6673506174687D2C656E756D657261626C653A21312C636F6E6669677572';
wwv_flow_imp.g_varchar2_table(4157) := '61626C653A21307D292C742E70726F746F747970652E746F537472696E673D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D65262628653D2131292C653F5428746869732C2130293A28746869732E5F666F726D61747465647C7C';
wwv_flow_imp.g_varchar2_table(4158) := '28746869732E5F666F726D61747465643D5428746869732C213129292C746869732E5F666F726D6174746564297D2C742E70726F746F747970652E746F4A534F4E3D66756E6374696F6E28297B76617220653D7B246D69643A317D3B72657475726E2074';
wwv_flow_imp.g_varchar2_table(4159) := '6869732E5F667350617468262628652E6673506174683D746869732E5F6673506174682C652E5F7365703D67292C746869732E5F666F726D6174746564262628652E65787465726E616C3D746869732E5F666F726D6174746564292C746869732E706174';
wwv_flow_imp.g_varchar2_table(4160) := '68262628652E706174683D746869732E70617468292C746869732E736368656D65262628652E736368656D653D746869732E736368656D65292C746869732E617574686F72697479262628652E617574686F726974793D746869732E617574686F726974';
wwv_flow_imp.g_varchar2_table(4161) := '79292C746869732E7175657279262628652E71756572793D746869732E7175657279292C746869732E667261676D656E74262628652E667261676D656E743D746869732E667261676D656E74292C657D2C747D2866292C5F3D2828613D7B7D295B35385D';
wwv_flow_imp.g_varchar2_table(4162) := '3D22253341222C615B34375D3D22253246222C615B36335D3D22253346222C615B33355D3D22253233222C615B39315D3D22253542222C615B39335D3D22253544222C615B36345D3D22253430222C615B33335D3D22253231222C615B33365D3D222532';
wwv_flow_imp.g_varchar2_table(4163) := '34222C615B33385D3D22253236222C615B33395D3D22253237222C615B34305D3D22253238222C615B34315D3D22253239222C615B34325D3D22253241222C615B34335D3D22253242222C615B34345D3D22253243222C615B35395D3D22253342222C61';
wwv_flow_imp.g_varchar2_table(4164) := '5B36315D3D22253344222C615B33325D3D22253230222C61293B66756E6374696F6E207628652C74297B666F7228766172206E3D766F696420302C693D2D312C723D303B723C652E6C656E6774683B722B2B297B766172206F3D652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(4165) := '41742872293B6966286F3E3D393726266F3C3D3132327C7C6F3E3D363526266F3C3D39307C7C6F3E3D343826266F3C3D35377C7C34353D3D3D6F7C7C34363D3D3D6F7C7C39353D3D3D6F7C7C3132363D3D3D6F7C7C74262634373D3D3D6F292D31213D3D';
wwv_flow_imp.g_varchar2_table(4166) := '692626286E2B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728692C7229292C693D2D31292C766F69642030213D3D6E2626286E2B3D652E636861724174287229293B656C73657B766F696420303D3D3D6E2626286E3D65';
wwv_flow_imp.g_varchar2_table(4167) := '2E73756273747228302C7229293B76617220613D5F5B6F5D3B766F69642030213D3D613F282D31213D3D692626286E2B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728692C7229292C693D2D31292C6E2B3D61293A2D31';
wwv_flow_imp.g_varchar2_table(4168) := '3D3D3D69262628693D72297D7D72657475726E2D31213D3D692626286E2B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728692929292C766F69642030213D3D6E3F6E3A657D66756E6374696F6E20772865297B666F7228';
wwv_flow_imp.g_varchar2_table(4169) := '76617220743D766F696420302C6E3D303B6E3C652E6C656E6774683B6E2B2B297B76617220693D652E63686172436F64654174286E293B33353D3D3D697C7C36333D3D3D693F28766F696420303D3D3D74262628743D652E73756273747228302C6E2929';
wwv_flow_imp.g_varchar2_table(4170) := '2C742B3D5F5B695D293A766F69642030213D3D74262628742B3D655B6E5D297D72657475726E20766F69642030213D3D743F743A657D66756E6374696F6E207928652C74297B766172206E3B72657475726E206E3D652E617574686F726974792626652E';
wwv_flow_imp.g_varchar2_table(4171) := '706174682E6C656E6774683E3126262266696C65223D3D3D652E736368656D653F222F2F222E636F6E63617428652E617574686F72697479292E636F6E63617428652E70617468293A34373D3D3D652E706174682E63686172436F646541742830292626';
wwv_flow_imp.g_varchar2_table(4172) := '28652E706174682E63686172436F646541742831293E3D36352626652E706174682E63686172436F646541742831293C3D39307C7C652E706174682E63686172436F646541742831293E3D39372626652E706174682E63686172436F646541742831293C';
wwv_flow_imp.g_varchar2_table(4173) := '3D31323229262635383D3D3D652E706174682E63686172436F646541742832293F743F652E706174682E7375627374722831293A652E706174685B315D2E746F4C6F7765724361736528292B652E706174682E7375627374722832293A652E706174682C';
wwv_flow_imp.g_varchar2_table(4174) := '692626286E3D6E2E7265706C616365282F5C2F2F672C225C5C2229292C6E7D66756E6374696F6E205428652C74297B766172206E3D743F773A762C693D22222C723D652E736368656D652C6F3D652E617574686F726974792C613D652E706174682C733D';
wwv_flow_imp.g_varchar2_table(4175) := '652E71756572792C6C3D652E667261676D656E743B69662872262628692B3D722C692B3D223A22292C286F7C7C2266696C65223D3D3D7229262628692B3D6D2C692B3D6D292C6F297B76617220683D6F2E696E6465784F6628224022293B6966282D3121';
wwv_flow_imp.g_varchar2_table(4176) := '3D3D68297B76617220633D6F2E73756273747228302C68293B6F3D6F2E73756273747228682B31292C2D313D3D3D28683D632E696E6465784F6628223A2229293F692B3D6E28632C2131293A28692B3D6E28632E73756273747228302C68292C2131292C';
wwv_flow_imp.g_varchar2_table(4177) := '692B3D223A222C692B3D6E28632E73756273747228682B31292C213129292C692B3D2240227D2D313D3D3D28683D286F3D6F2E746F4C6F776572436173652829292E696E6465784F6628223A2229293F692B3D6E286F2C2131293A28692B3D6E286F2E73';
wwv_flow_imp.g_varchar2_table(4178) := '756273747228302C68292C2131292C692B3D6F2E737562737472286829297D69662861297B696628612E6C656E6774683E3D33262634373D3D3D612E63686172436F64654174283029262635383D3D3D612E63686172436F646541742832292928643D61';
wwv_flow_imp.g_varchar2_table(4179) := '2E63686172436F64654174283129293E3D36352626643C3D3930262628613D222F222E636F6E63617428537472696E672E66726F6D43686172436F646528642B3332292C223A22292E636F6E63617428612E73756273747228332929293B656C73652069';
wwv_flow_imp.g_varchar2_table(4180) := '6628612E6C656E6774683E3D32262635383D3D3D612E63686172436F64654174283129297B76617220643B28643D612E63686172436F64654174283029293E3D36352626643C3D3930262628613D22222E636F6E63617428537472696E672E66726F6D43';
wwv_flow_imp.g_varchar2_table(4181) := '686172436F646528642B3332292C223A22292E636F6E63617428612E73756273747228322929297D692B3D6E28612C2130297D72657475726E2073262628692B3D223F222C692B3D6E28732C213129292C6C262628692B3D2223222C692B3D743F6C3A76';
wwv_flow_imp.g_varchar2_table(4182) := '286C2C213129292C697D66756E6374696F6E206B2865297B7472797B72657475726E206465636F6465555249436F6D706F6E656E742865297D63617463682874297B72657475726E20652E6C656E6774683E333F652E73756273747228302C33292B6B28';
wwv_flow_imp.g_varchar2_table(4183) := '652E737562737472283329293A657D7D76617220533D2F28255B302D39412D5A612D7A5D5B302D39412D5A612D7A5D292B2F673B66756E6374696F6E20782865297B72657475726E20652E6D617463682853293F652E7265706C61636528532C2866756E';
wwv_flow_imp.g_varchar2_table(4184) := '6374696F6E2865297B72657475726E206B2865297D29293A657D766172204C2C432C453D6E28343730292C413D66756E6374696F6E28652C742C6E297B6966286E7C7C323D3D3D617267756D656E74732E6C656E67746829666F722876617220692C723D';
wwv_flow_imp.g_varchar2_table(4185) := '302C6F3D742E6C656E6774683B723C6F3B722B2B29216926267220696E20747C7C28697C7C28693D41727261792E70726F746F747970652E736C6963652E63616C6C28742C302C7229292C695B725D3D745B725D293B72657475726E20652E636F6E6361';
wwv_flow_imp.g_varchar2_table(4186) := '7428697C7C41727261792E70726F746F747970652E736C6963652E63616C6C287429297D2C523D452E706F7369787C7C453B28433D4C7C7C284C3D7B7D29292E6A6F696E506174683D66756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D';
wwv_flow_imp.g_varchar2_table(4187) := '313B6E3C617267756D656E74732E6C656E6774683B6E2B2B29745B6E2D315D3D617267756D656E74735B6E5D3B72657475726E20652E77697468287B706174683A522E6A6F696E2E6170706C7928522C41285B652E706174685D2C742C213129297D297D';
wwv_flow_imp.g_varchar2_table(4188) := '2C432E7265736F6C7665506174683D66756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D313B6E3C617267756D656E74732E6C656E6774683B6E2B2B29745B6E2D315D3D617267756D656E74735B6E5D3B76617220693D652E706174687C';
wwv_flow_imp.g_varchar2_table(4189) := '7C222F223B72657475726E20652E77697468287B706174683A522E7265736F6C76652E6170706C7928522C41285B695D2C742C213129297D297D2C432E6469726E616D653D66756E6374696F6E2865297B76617220743D522E6469726E616D6528652E70';
wwv_flow_imp.g_varchar2_table(4190) := '617468293B72657475726E20313D3D3D742E6C656E677468262634363D3D3D742E63686172436F646541742830293F653A652E77697468287B706174683A747D297D2C432E626173656E616D653D66756E6374696F6E2865297B72657475726E20522E62';
wwv_flow_imp.g_varchar2_table(4191) := '6173656E616D6528652E70617468297D2C432E6578746E616D653D66756E6374696F6E2865297B72657475726E20522E6578746E616D6528652E70617468297D7D7D2C743D7B7D3B66756E6374696F6E206E2869297B696628745B695D2972657475726E';
wwv_flow_imp.g_varchar2_table(4192) := '20745B695D2E6578706F7274733B76617220723D745B695D3D7B6578706F7274733A7B7D7D3B72657475726E20655B695D28722C722E6578706F7274732C6E292C722E6578706F7274737D72657475726E206E2E643D28652C74293D3E7B666F72287661';
wwv_flow_imp.g_varchar2_table(4193) := '72206920696E2074296E2E6F28742C69292626216E2E6F28652C692926264F626A6563742E646566696E6550726F706572747928652C692C7B656E756D657261626C653A21302C6765743A745B695D7D297D2C6E2E6F3D28652C74293D3E4F626A656374';
wwv_flow_imp.g_varchar2_table(4194) := '2E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C74292C6E2E723D653D3E7B22756E646566696E656422213D747970656F662053796D626F6C262653796D626F6C2E746F537472696E6754616726264F626A6563742E64';
wwv_flow_imp.g_varchar2_table(4195) := '6566696E6550726F706572747928652C53796D626F6C2E746F537472696E675461672C7B76616C75653A224D6F64756C65227D292C4F626A6563742E646566696E6550726F706572747928652C225F5F65734D6F64756C65222C7B76616C75653A21307D';
wwv_flow_imp.g_varchar2_table(4196) := '297D2C6E28343437297D2928293B7661727B5552493A766C2C5574696C733A776C7D3D646C3B66756E6374696F6E20796C2865297B76617220743D655B305D3B72657475726E2074213D3D655B652E6C656E6774682D315D7C7C222722213D3D74262627';
wwv_flow_imp.g_varchar2_table(4197) := '2227213D3D747C7C28653D652E73756273747228312C652E6C656E6774682D3229292C657D66756E6374696F6E20546C28652C742C6E2C692C722C6F297B76617220613D796C286E293B696628733D612C6C3D652E6C616E677561676549642C732E6C65';
wwv_flow_imp.g_varchar2_table(4198) := '6E6774682626282268616E646C656261727322213D3D6C7C7C212F7B7B7C7D7D2F2E746573742873292926262F5C6228775B5C775C642B2E2D5D2A3A5C2F5C2F293F5B5E5C7328293C3E5D2B283F3A5C285B5C775C645D2B5C297C285B5E5B3A70756E63';
wwv_flow_imp.g_varchar2_table(4199) := '743A5D5C735D7C5C2F3F29292F2E74657374287329297B76617220732C6C3B612E6C656E6774683C6E2E6C656E677468262628692B2B2C722D2D293B76617220683D66756E6374696F6E28652C742C6E2C69297B696628212F5E5C732A6A617661736372';
wwv_flow_imp.g_varchar2_table(4200) := '6970745C3A2F692E746573742874292626212F5B5C6E5C725D2F2E746573742874292972657475726E20743D742E7265706C616365282F5E5C732A2F672C2222292C2F5E68747470733F3A5C2F5C2F2F692E746573742874297C7C2F5E66696C653A5C2F';
wwv_flow_imp.g_varchar2_table(4201) := '5C2F2F692E746573742874293F743A2F5E5C232F692E746573742874293F652B743A2F5E5C2F5C2F2F692E746573742874293F28487328652C2268747470733A2F2F22293F226874747073223A226874747022292B223A222B742E7265706C616365282F';
wwv_flow_imp.g_varchar2_table(4202) := '5E5C732A2F672C2222293A6E3F6E2E7265736F6C76655265666572656E636528742C697C7C65293A747D28652E7572692C612C742C6F293B69662868262666756E6374696F6E2865297B7472797B72657475726E20766C2E70617273652865292C21307D';
wwv_flow_imp.g_varchar2_table(4203) := '63617463682865297B72657475726E21317D7D2868292972657475726E7B72616E67653A616F2E63726561746528652E706F736974696F6E41742869292C652E706F736974696F6E4174287229292C7461726765743A687D7D7D66756E6374696F6E206B';
wwv_flow_imp.g_varchar2_table(4204) := '6C28652C74297B666F7228766172206E3D5B5D2C693D417328652E6765745465787428292C30292C723D692E7363616E28292C6F3D766F696420302C613D21312C733D766F696420302C6C3D7B7D3B72213D3D74732E454F533B297B7377697463682872';
wwv_flow_imp.g_varchar2_table(4205) := '297B636173652074732E53746172745461673A737C7C28613D2262617365223D3D3D692E676574546F6B656E5465787428292E746F4C6F776572436173652829293B627265616B3B636173652074732E4174747269627574654E616D653A6F3D692E6765';
wwv_flow_imp.g_varchar2_table(4206) := '74546F6B656E5465787428292E746F4C6F7765724361736528293B627265616B3B636173652074732E41747472696275746556616C75653A69662822737263223D3D3D6F7C7C2268726566223D3D3D6F297B76617220683D692E676574546F6B656E5465';
wwv_flow_imp.g_varchar2_table(4207) := '787428293B617C7C28753D546C28652C742C682C692E676574546F6B656E4F666673657428292C692E676574546F6B656E456E6428292C73292926266E2E707573682875292C612626766F696420303D3D3D73262628733D796C28682929262674262628';
wwv_flow_imp.g_varchar2_table(4208) := '733D742E7265736F6C76655265666572656E636528732C652E75726929292C613D21312C6F3D766F696420307D656C7365226964223D3D3D6F2626286C5B796C28692E676574546F6B656E546578742829295D3D692E676574546F6B656E4F6666736574';
wwv_flow_imp.g_varchar2_table(4209) := '2829297D723D692E7363616E28297D666F722876617220633D302C643D6E3B633C642E6C656E6774683B632B2B297B76617220753D645B635D2C6D3D652E7572692B2223223B696628752E7461726765742626487328752E7461726765742C6D29297B76';
wwv_flow_imp.g_varchar2_table(4210) := '617220703D6C5B752E7461726765742E737562737472286D2E6C656E677468295D3B696628766F69642030213D3D70297B76617220663D652E706F736974696F6E41742870293B752E7461726765743D22222E636F6E636174286D292E636F6E63617428';
wwv_flow_imp.g_varchar2_table(4211) := '662E6C696E652B312C222C22292E636F6E63617428662E6368617261637465722B31297D7D7D72657475726E206E7D66756E6374696F6E20536C28652C742C6E297B76617220693D652E6F666673657441742874292C723D6E2E66696E644E6F64654174';
wwv_flow_imp.g_varchar2_table(4212) := '2869293B69662821722E7461672972657475726E5B5D3B766172206F3D5B5D2C613D436C2874732E53746172745461672C652C722E7374617274292C733D226E756D626572223D3D747970656F6620722E656E6454616753746172742626436C2874732E';
wwv_flow_imp.g_varchar2_table(4213) := '456E645461672C652C722E656E645461675374617274293B72657475726E286126264C6C28612C74297C7C7326264C6C28732C7429292626286126266F2E70757368287B6B696E643A6B612E526561642C72616E67653A617D292C7326266F2E70757368';
wwv_flow_imp.g_varchar2_table(4214) := '287B6B696E643A6B612E526561642C72616E67653A737D29292C6F7D66756E6374696F6E20786C28652C74297B72657475726E20652E6C696E653C742E6C696E657C7C652E6C696E653D3D3D742E6C696E652626652E6368617261637465723C3D742E63';
wwv_flow_imp.g_varchar2_table(4215) := '68617261637465727D66756E6374696F6E204C6C28652C74297B72657475726E20786C28652E73746172742C74292626786C28742C652E656E64297D66756E6374696F6E20436C28652C742C6E297B666F722876617220693D417328742E676574546578';
wwv_flow_imp.g_varchar2_table(4216) := '7428292C6E292C723D692E7363616E28293B72213D3D74732E454F53262672213D3D653B29723D692E7363616E28293B72657475726E2072213D3D74732E454F533F7B73746172743A742E706F736974696F6E417428692E676574546F6B656E4F666673';
wwv_flow_imp.g_varchar2_table(4217) := '65742829292C656E643A742E706F736974696F6E417428692E676574546F6B656E456E642829297D3A6E756C6C7D66756E6374696F6E20456C28652C74297B766172206E3D5B5D3B72657475726E20742E726F6F74732E666F7245616368282866756E63';
wwv_flow_imp.g_varchar2_table(4218) := '74696F6E2874297B416C28652C742C22222C6E297D29292C6E7D66756E6374696F6E20416C28652C742C6E2C69297B76617220723D66756E6374696F6E2865297B76617220743D652E7461673B696628652E61747472696275746573297B766172206E3D';
wwv_flow_imp.g_varchar2_table(4219) := '652E617474726962757465732E69642C693D652E617474726962757465732E636C6173733B6E262628742B3D2223222E636F6E636174286E2E7265706C616365282F5B5C225C275D2F672C22222929292C69262628742B3D692E7265706C616365282F5B';
wwv_flow_imp.g_varchar2_table(4220) := '5C225C275D2F672C2222292E73706C6974282F5C732B2F292E6D6170282866756E6374696F6E2865297B72657475726E222E222E636F6E6361742865297D29292E6A6F696E28222229297D72657475726E20747C7C223F227D2874292C6F3D6C6F2E6372';
wwv_flow_imp.g_varchar2_table(4221) := '6561746528652E7572692C616F2E63726561746528652E706F736974696F6E417428742E7374617274292C652E706F736974696F6E417428742E656E642929292C613D7B6E616D653A722C6C6F636174696F6E3A6F2C636F6E7461696E65724E616D653A';
wwv_flow_imp.g_varchar2_table(4222) := '6E2C6B696E643A4C612E4669656C647D3B692E707573682861292C742E6368696C6472656E2E666F7245616368282866756E6374696F6E2874297B416C28652C742C722C69297D29297D66756E6374696F6E20526C28652C742C6E2C69297B7661722072';
wwv_flow_imp.g_varchar2_table(4223) := '2C6F3D652E6F666673657441742874292C613D692E66696E644E6F64654174286F293B69662821612E7461672972657475726E206E756C6C3B6966282166756E6374696F6E28652C742C6E297B72657475726E212128652E656E64546167537461727426';
wwv_flow_imp.g_varchar2_table(4224) := '26652E656E6454616753746172742B323C3D742626743C3D652E656E6454616753746172742B322B6E2E6C656E677468297C7C652E73746172742B313C3D742626743C3D652E73746172742B312B6E2E6C656E6774687D28612C6F2C612E746167292972';
wwv_flow_imp.g_varchar2_table(4225) := '657475726E206E756C6C3B76617220733D5B5D2C6C3D7B73746172743A652E706F736974696F6E417428612E73746172742B31292C656E643A652E706F736974696F6E417428612E73746172742B312B612E7461672E6C656E677468297D3B696628732E';
wwv_flow_imp.g_varchar2_table(4226) := '70757368287B72616E67653A6C2C6E6577546578743A6E7D292C612E656E645461675374617274297B76617220683D7B73746172743A652E706F736974696F6E417428612E656E6454616753746172742B32292C656E643A652E706F736974696F6E4174';
wwv_flow_imp.g_varchar2_table(4227) := '28612E656E6454616753746172742B322B612E7461672E6C656E677468297D3B732E70757368287B72616E67653A682C6E6577546578743A6E7D297D72657475726E7B6368616E6765733A2828723D7B7D295B652E7572692E746F537472696E6728295D';
wwv_flow_imp.g_varchar2_table(4228) := '3D732C72297D7D66756E6374696F6E204D6C28652C742C6E297B76617220693D652E6F666673657441742874292C723D6E2E66696E644E6F646541742869293B69662821722E7461672972657475726E206E756C6C3B69662821722E656E645461675374';
wwv_flow_imp.g_varchar2_table(4229) := '6172742972657475726E206E756C6C3B696628722E73746172742B313C3D692626693C3D722E73746172742B312B722E7461672E6C656E677468297B766172206F3D692D312D722E73746172742B722E656E6454616753746172742B323B72657475726E';
wwv_flow_imp.g_varchar2_table(4230) := '20652E706F736974696F6E4174286F297D72657475726E20722E656E6454616753746172742B323C3D692626693C3D722E656E6454616753746172742B322B722E7461672E6C656E6774683F286F3D692D322D722E656E6454616753746172742B722E73';
wwv_flow_imp.g_varchar2_table(4231) := '746172742B312C652E706F736974696F6E4174286F29293A6E756C6C7D66756E6374696F6E204E6C28652C742C6E297B76617220693D652E6F666673657441742874292C723D6E2E66696E644E6F646541742869292C6F3D722E7461673F722E7461672E';
wwv_flow_imp.g_varchar2_table(4232) := '6C656E6774683A303B72657475726E20722E656E645461675374617274262628722E73746172742B313C3D692626693C3D722E73746172742B312B6F7C7C722E656E6454616753746172742B323C3D692626693C3D722E656E6454616753746172742B32';
wwv_flow_imp.g_varchar2_table(4233) := '2B6F293F5B616F2E63726561746528652E706F736974696F6E417428722E73746172742B31292C652E706F736974696F6E417428722E73746172742B312B6F29292C616F2E63726561746528652E706F736974696F6E417428722E656E64546167537461';
wwv_flow_imp.g_varchar2_table(4234) := '72742B32292C652E706F736974696F6E417428722E656E6454616753746172742B322B6F29295D3A6E756C6C7D66756E6374696F6E20496C28652C74297B766172206E3D417328652E676574546578742829292C693D6E2E7363616E28292C723D5B5D2C';
wwv_flow_imp.g_varchar2_table(4235) := '6F3D5B5D2C613D6E756C6C2C733D2D313B66756E6374696F6E206C2865297B722E707573682865292C733D652E73746172744C696E657D666F72283B69213D3D74732E454F533B297B7377697463682869297B636173652074732E53746172745461673A';
wwv_flow_imp.g_varchar2_table(4236) := '76617220683D6E2E676574546F6B656E5465787428292C633D652E706F736974696F6E4174286E2E676574546F6B656E4F66667365742829292E6C696E653B6F2E70757368287B73746172744C696E653A632C7461674E616D653A687D292C613D683B62';
wwv_flow_imp.g_varchar2_table(4237) := '7265616B3B636173652074732E456E645461673A613D6E2E676574546F6B656E5465787428293B627265616B3B636173652074732E5374617274546167436C6F73653A69662821617C7C214E7328612929627265616B3B636173652074732E456E645461';
wwv_flow_imp.g_varchar2_table(4238) := '67436C6F73653A636173652074732E537461727454616753656C66436C6F73653A666F722876617220643D6F2E6C656E6774682D313B643E3D3026266F5B645D2E7461674E616D65213D3D613B29642D2D3B696628643E3D30297B76617220753D6F5B64';
wwv_flow_imp.g_varchar2_table(4239) := '5D3B6F2E6C656E6774683D642C28703D652E706F736974696F6E4174286E2E676574546F6B656E4F66667365742829292E6C696E652D31293E28633D752E73746172744C696E6529262673213D3D6326266C287B73746172744C696E653A632C656E644C';
wwv_flow_imp.g_varchar2_table(4240) := '696E653A707D297D627265616B3B636173652074732E436F6D6D656E743A633D652E706F736974696F6E4174286E2E676574546F6B656E4F66667365742829292E6C696E653B766172206D3D6E2E676574546F6B656E5465787428292E6D61746368282F';
wwv_flow_imp.g_varchar2_table(4241) := '5E5C732A2328726567696F6E5C62297C28656E64726567696F6E5C62292F293B6966286D296966286D5B315D296F2E70757368287B73746172744C696E653A632C7461674E616D653A22227D293B656C73657B666F7228643D6F2E6C656E6774682D313B';
wwv_flow_imp.g_varchar2_table(4242) := '643E3D3026266F5B645D2E7461674E616D652E6C656E6774683B29642D2D3B76617220703B696628643E3D3029753D6F5B645D2C6F2E6C656E6774683D642C28703D63293E28633D752E73746172744C696E6529262673213D3D6326266C287B73746172';
wwv_flow_imp.g_varchar2_table(4243) := '744C696E653A632C656E644C696E653A702C6B696E643A766F2E526567696F6E7D297D656C736520633C28703D652E706F736974696F6E4174286E2E676574546F6B656E4F666673657428292B6E2E676574546F6B656E4C656E6774682829292E6C696E';
wwv_flow_imp.g_varchar2_table(4244) := '652926266C287B73746172744C696E653A632C656E644C696E653A702C6B696E643A766F2E436F6D6D656E747D297D693D6E2E7363616E28297D76617220663D742626742E72616E67654C696D69747C7C4E756D6265722E4D41585F56414C55453B7265';
wwv_flow_imp.g_varchar2_table(4245) := '7475726E20722E6C656E6774683E663F66756E6374696F6E28652C74297B653D652E736F7274282866756E6374696F6E28652C74297B766172206E3D652E73746172744C696E652D742E73746172744C696E653B72657475726E20303D3D3D6E2626286E';
wwv_flow_imp.g_varchar2_table(4246) := '3D652E656E644C696E652D742E656E644C696E65292C6E7D29293B666F7228766172206E3D766F696420302C693D5B5D2C723D5B5D2C6F3D5B5D2C613D66756E6374696F6E28652C74297B725B655D3D742C743C33302626286F5B745D3D286F5B745D7C';
wwv_flow_imp.g_varchar2_table(4247) := '7C30292B31297D2C733D303B733C652E6C656E6774683B732B2B297B766172206C3D655B735D3B6966286E297B6966286C2E73746172744C696E653E6E2E73746172744C696E65296966286C2E656E644C696E653C3D6E2E656E644C696E6529692E7075';
wwv_flow_imp.g_varchar2_table(4248) := '7368286E292C6E3D6C2C6128732C692E6C656E677468293B656C7365206966286C2E73746172744C696E653E6E2E656E644C696E65297B646F7B6E3D692E706F7028297D7768696C65286E26266C2E73746172744C696E653E6E2E656E644C696E65293B';
wwv_flow_imp.g_varchar2_table(4249) := '6E2626692E70757368286E292C6E3D6C2C6128732C692E6C656E677468297D7D656C7365206E3D6C2C6128732C30297D76617220683D302C633D303B666F7228733D303B733C6F2E6C656E6774683B732B2B297B76617220643D6F5B735D3B6966286429';
wwv_flow_imp.g_varchar2_table(4250) := '7B696628642B683E74297B633D733B627265616B7D682B3D647D7D76617220753D5B5D3B666F7228733D303B733C652E6C656E6774683B732B2B297B766172206D3D725B735D3B226E756D626572223D3D747970656F66206D2626286D3C637C7C6D3D3D';
wwv_flow_imp.g_varchar2_table(4251) := '3D632626682B2B3C74292626752E7075736828655B735D297D72657475726E20757D28722C66293A727D66756E6374696F6E207A6C28652C74297B72657475726E20742E6D6170282866756E6374696F6E2874297B666F7228766172206E3D66756E6374';
wwv_flow_imp.g_varchar2_table(4252) := '696F6E28652C74297B766172206E3D7A7328652E676574546578742829292C693D652E6F666673657441742874292C723D6E2E66696E644E6F646541742869292C6F3D66756E6374696F6E2865297B666F722876617220742C6E3D652C693D5B5D3B6E2E';
wwv_flow_imp.g_varchar2_table(4253) := '706172656E743B2928743D6E3D6E2E706172656E742C742E7374617274546167456E642626742E656E6454616753746172742626742E7374617274546167456E643C742E656E6454616753746172743F5B5B742E7374617274546167456E642C742E656E';
wwv_flow_imp.g_varchar2_table(4254) := '6454616753746172745D2C5B742E73746172742C742E656E645D5D3A5B5B742E73746172742C742E656E645D5D292E666F7245616368282866756E6374696F6E2865297B72657475726E20692E707573682865297D29293B72657475726E20697D287229';
wwv_flow_imp.g_varchar2_table(4255) := '3B696628722E7374617274546167456E64262621722E656E645461675374617274297B696628722E7374617274546167456E64213D3D722E656E642972657475726E5B5B722E73746172742C722E656E645D5D3B76617220613D616F2E63726561746528';
wwv_flow_imp.g_varchar2_table(4256) := '652E706F736974696F6E417428722E7374617274546167456E642D32292C652E706F736974696F6E417428722E7374617274546167456E6429293B72657475726E222F3E223D3D3D652E676574546578742861293F6F2E756E7368696674285B722E7374';
wwv_flow_imp.g_varchar2_table(4257) := '6172742B312C722E7374617274546167456E642D325D293A6F2E756E7368696674285B722E73746172742B312C722E7374617274546167456E642D315D292C556C28652C722C69292E636F6E636174286F297D72657475726E20722E7374617274546167';
wwv_flow_imp.g_varchar2_table(4258) := '456E642626722E656E6454616753746172743F286F2E756E7368696674285B722E73746172742C722E656E645D292C722E73746172743C692626693C722E7374617274546167456E643F286F2E756E7368696674285B722E73746172742B312C722E7374';
wwv_flow_imp.g_varchar2_table(4259) := '617274546167456E642D315D292C6F3D556C28652C722C69292E636F6E636174286F29293A722E7374617274546167456E643C3D692626693C3D722E656E6454616753746172743F286F2E756E7368696674285B722E7374617274546167456E642C722E';
wwv_flow_imp.g_varchar2_table(4260) := '656E6454616753746172745D292C6F293A28693E3D722E656E6454616753746172742B3226266F2E756E7368696674285B722E656E6454616753746172742B322C722E656E642D315D292C6F29293A6F7D28652C74292C693D766F696420302C723D766F';
wwv_flow_imp.g_varchar2_table(4261) := '696420302C6F3D6E2E6C656E6774682D313B6F3E3D303B6F2D2D297B76617220613D6E5B6F5D3B692626615B305D3D3D3D695B305D2626615B315D3D3D3D695B315D7C7C28723D56612E63726561746528616F2E63726561746528652E706F736974696F';
wwv_flow_imp.g_varchar2_table(4262) := '6E4174286E5B6F5D5B305D292C652E706F736974696F6E4174286E5B6F5D5B315D29292C7229292C693D617D72657475726E20727C7C28723D56612E63726561746528616F2E63726561746528742C742929292C727D29297D66756E6374696F6E20556C';
wwv_flow_imp.g_varchar2_table(4263) := '28652C742C6E297B666F722876617220693D616F2E63726561746528652E706F736974696F6E417428742E7374617274292C652E706F736974696F6E417428742E656E6429292C723D652E676574546578742869292C6F3D6E2D742E73746172742C613D';
wwv_flow_imp.g_varchar2_table(4264) := '41732872292C733D612E7363616E28292C6C3D742E73746172742C683D5B5D2C633D21312C643D2D313B73213D3D74732E454F533B297B7377697463682873297B636173652074732E4174747269627574654E616D653A6966286F3C612E676574546F6B';
wwv_flow_imp.g_varchar2_table(4265) := '656E4F66667365742829297B633D21313B627265616B7D6F3C3D612E676574546F6B656E456E6428292626682E756E7368696674285B612E676574546F6B656E4F666673657428292C612E676574546F6B656E456E6428295D292C633D21302C643D612E';
wwv_flow_imp.g_varchar2_table(4266) := '676574546F6B656E4F666673657428293B627265616B3B636173652074732E41747472696275746556616C75653A696628216329627265616B3B76617220753D612E676574546F6B656E5465787428293B6966286F3C612E676574546F6B656E4F666673';
wwv_flow_imp.g_varchar2_table(4267) := '65742829297B682E70757368285B642C612E676574546F6B656E456E6428295D293B627265616B7D6F3E3D612E676574546F6B656E4F6666736574282926266F3C3D612E676574546F6B656E456E642829262628682E756E7368696674285B612E676574';
wwv_flow_imp.g_varchar2_table(4268) := '546F6B656E4F666673657428292C612E676574546F6B656E456E6428295D292C282722273D3D3D755B305D26262722273D3D3D755B752E6C656E6774682D315D7C7C2227223D3D3D755B305D26262227223D3D3D755B752E6C656E6774682D315D292626';
wwv_flow_imp.g_varchar2_table(4269) := '6F3E3D612E676574546F6B656E4F666673657428292B3126266F3C3D612E676574546F6B656E456E6428292D312626682E756E7368696674285B612E676574546F6B656E4F666673657428292B312C612E676574546F6B656E456E6428292D315D292C68';
wwv_flow_imp.g_varchar2_table(4270) := '2E70757368285B642C612E676574546F6B656E456E6428295D29297D733D612E7363616E28297D72657475726E20682E6D6170282866756E6374696F6E2865297B72657475726E5B655B305D2B6C2C655B315D2B6C5D7D29297D76617220486C3D7B7665';
wwv_flow_imp.g_varchar2_table(4271) := '7273696F6E3A312E312C746167733A5B7B6E616D653A2268746D6C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652068746D6C20656C656D656E7420726570726573656E74732074686520726F6F';
wwv_flow_imp.g_varchar2_table(4272) := '74206F6620616E2048544D4C20646F63756D656E742E227D2C617474726962757465733A5B7B6E616D653A226D616E6966657374222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2253706563696669657320';
wwv_flow_imp.g_varchar2_table(4273) := '74686520555249206F662061207265736F75726365206D616E696665737420696E6469636174696E67207265736F757263657320746861742073686F756C6420626520636163686564206C6F63616C6C792E20536565205B5573696E6720746865206170';
wwv_flow_imp.g_varchar2_table(4274) := '706C69636174696F6E2063616368655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F5573696E675F7468655F6170706C69636174696F6E5F63616368652920666F7220';
wwv_flow_imp.g_varchar2_table(4275) := '64657461696C732E227D7D2C7B6E616D653A2276657273696F6E222C6465736372697074696F6E3A27537065636966696573207468652076657273696F6E206F66207468652048544D4C205B446F63756D656E74205479706520446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(4276) := '5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4454442022446F63756D656E74205479706520446566696E6974696F6E3A20496E2048544D4C2C2074686520646F6374';
wwv_flow_imp.g_varchar2_table(4277) := '7970652069732074686520726571756972656420223C21444F43545950452068746D6C3E2220707265616D626C6520666F756E642061742074686520746F70206F6620616C6C20646F63756D656E74732E2049747320736F6C6520707572706F73652069';
wwv_flow_imp.g_varchar2_table(4278) := '7320746F2070726576656E7420612062726F777365722066726F6D20737769746368696E6720696E746F20736F2D63616C6C656420E2809C717569726B73206D6F6465E2809D207768656E2072656E646572696E67206120646F63756D656E743B207468';
wwv_flow_imp.g_varchar2_table(4279) := '61742069732C2074686520223C21444F43545950452068746D6C3E2220646F637479706520656E73757265732074686174207468652062726F77736572206D616B6573206120626573742D6566666F727420617474656D707420617420666F6C6C6F7769';
wwv_flow_imp.g_varchar2_table(4280) := '6E67207468652072656C6576616E742073706563696669636174696F6E732C20726174686572207468616E207573696E67206120646966666572656E742072656E646572696E67206D6F6465207468617420697320696E636F6D70617469626C65207769';
wwv_flow_imp.g_varchar2_table(4281) := '746820736F6D652073706563696669636174696F6E732E2229207468617420676F7665726E73207468652063757272656E7420646F63756D656E742E205468697320617474726962757465206973206E6F74206E65656465642C20626563617573652069';
wwv_flow_imp.g_varchar2_table(4282) := '7420697320726564756E64616E742077697468207468652076657273696F6E20696E666F726D6174696F6E20696E2074686520646F63756D656E742074797065206465636C61726174696F6E2E277D2C7B6E616D653A22786D6C6E73222C646573637269';
wwv_flow_imp.g_varchar2_table(4283) := '7074696F6E3A275370656369666965732074686520584D4C204E616D657370616365206F662074686520646F63756D656E742E2044656661756C742076616C7565206973206022687474703A2F2F7777772E77332E6F72672F313939392F7868746D6C22';
wwv_flow_imp.g_varchar2_table(4284) := '602E205468697320697320726571756972656420696E20646F63756D656E747320706172736564207769746820584D4C20706172736572732C20616E64206F7074696F6E616C20696E20746578742F68746D6C20646F63756D656E74732E277D5D2C7265';
wwv_flow_imp.g_varchar2_table(4285) := '666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F68746D6C227D5D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(4286) := '616D653A2268656164222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206865616420656C656D656E7420726570726573656E7473206120636F6C6C656374696F6E206F66206D6574616461746120';
wwv_flow_imp.g_varchar2_table(4287) := '666F722074686520446F63756D656E742E227D2C617474726962757465733A5B7B6E616D653A2270726F66696C65222C6465736372697074696F6E3A225468652055524973206F66206F6E65206F72206D6F7265206D657461646174612070726F66696C';
wwv_flow_imp.g_varchar2_table(4288) := '65732C207365706172617465642062792077686974652073706163652E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(4289) := '672F646F63732F5765622F48544D4C2F456C656D656E742F68656164227D5D7D2C7B6E616D653A227469746C65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207469746C6520656C656D656E74';
wwv_flow_imp.g_varchar2_table(4290) := '20726570726573656E74732074686520646F63756D656E742773207469746C65206F72206E616D652E20417574686F72732073686F756C6420757365207469746C65732074686174206964656E7469667920746865697220646F63756D656E7473206576';
wwv_flow_imp.g_varchar2_table(4291) := '656E207768656E2074686579206172652075736564206F7574206F6620636F6E746578742C20666F72206578616D706C6520696E20612075736572277320686973746F7279206F7220626F6F6B6D61726B732C206F7220696E2073656172636820726573';
wwv_flow_imp.g_varchar2_table(4292) := '756C74732E2054686520646F63756D656E742773207469746C65206973206F6674656E20646966666572656E742066726F6D206974732066697273742068656164696E672C2073696E6365207468652066697273742068656164696E6720646F6573206E';
wwv_flow_imp.g_varchar2_table(4293) := '6F74206861766520746F207374616E6420616C6F6E65207768656E2074616B656E206F7574206F6620636F6E746578742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C';
wwv_flow_imp.g_varchar2_table(4294) := '75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7469746C65227D5D7D2C7B6E616D653A2262617365222C6465736372697074696F6E3A7B6B696E643A226D';
wwv_flow_imp.g_varchar2_table(4295) := '61726B646F776E222C76616C75653A22546865206261736520656C656D656E7420616C6C6F777320617574686F727320746F20737065636966792074686520646F63756D656E7420626173652055524C20666F722074686520707572706F736573206F66';
wwv_flow_imp.g_varchar2_table(4296) := '207265736F6C76696E672072656C61746976652055524C732C20616E6420746865206E616D65206F66207468652064656661756C742062726F7773696E6720636F6E7465787420666F722074686520707572706F736573206F6620666F6C6C6F77696E67';
wwv_flow_imp.g_varchar2_table(4297) := '2068797065726C696E6B732E2054686520656C656D656E7420646F6573206E6F7420726570726573656E7420616E7920636F6E74656E74206265796F6E64207468697320696E666F726D6174696F6E2E227D2C617474726962757465733A5B7B6E616D65';
wwv_flow_imp.g_varchar2_table(4298) := '3A2268726566222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520626173652055524C20746F2062652075736564207468726F7567686F75742074686520646F63756D656E7420666F722072656C61';
wwv_flow_imp.g_varchar2_table(4299) := '746976652055524C206164647265737365732E204966207468697320617474726962757465206973207370656369666965642C207468697320656C656D656E74206D75737420636F6D65206265666F726520616E79206F7468657220656C656D656E7473';
wwv_flow_imp.g_varchar2_table(4300) := '207769746820617474726962757465732077686F73652076616C756573206172652055524C732E204162736F6C75746520616E642072656C61746976652055524C732061726520616C6C6F7765642E227D7D2C7B6E616D653A22746172676574222C6465';
wwv_flow_imp.g_varchar2_table(4301) := '736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241206E616D65206F72206B6579776F726420696E6469636174696E67207468652064656661756C74206C6F636174696F6E20746F20646973706C6179207468652072';
wwv_flow_imp.g_varchar2_table(4302) := '6573756C74207768656E2068797065726C696E6B73206F7220666F726D73206361757365206E617669676174696F6E2C20666F7220656C656D656E7473207468617420646F206E6F74206861766520616E206578706C6963697420746172676574207265';
wwv_flow_imp.g_varchar2_table(4303) := '666572656E63652E2049742069732061206E616D65206F662C206F72206B6579776F726420666F722C2061205F62726F7773696E6720636F6E746578745F2028666F72206578616D706C653A207461622C2077696E646F772C206F7220696E6C696E6520';
wwv_flow_imp.g_varchar2_table(4304) := '6672616D65292E2054686520666F6C6C6F77696E67206B6579776F7264732068617665207370656369616C206D65616E696E67733A5C6E5C6E2A202020605F73656C66603A204C6F61642074686520726573756C7420696E746F207468652073616D6520';
wwv_flow_imp.g_varchar2_table(4305) := '62726F7773696E6720636F6E74657874206173207468652063757272656E74206F6E652E20546869732076616C7565206973207468652064656661756C742069662074686520617474726962757465206973206E6F74207370656369666965642E5C6E2A';
wwv_flow_imp.g_varchar2_table(4306) := '202020605F626C616E6B603A204C6F61642074686520726573756C7420696E746F2061206E657720756E6E616D65642062726F7773696E6720636F6E746578742E5C6E2A202020605F706172656E74603A204C6F61642074686520726573756C7420696E';
wwv_flow_imp.g_varchar2_table(4307) := '746F2074686520706172656E742062726F7773696E6720636F6E74657874206F66207468652063757272656E74206F6E652E204966207468657265206973206E6F20706172656E742C2074686973206F7074696F6E206265686176657320746865207361';
wwv_flow_imp.g_varchar2_table(4308) := '6D652077617920617320605F73656C66602E5C6E2A202020605F746F70603A204C6F61642074686520726573756C7420696E746F2074686520746F702D6C6576656C2062726F7773696E6720636F6E746578742028746861742069732C20746865206272';
wwv_flow_imp.g_varchar2_table(4309) := '6F7773696E6720636F6E74657874207468617420697320616E20616E636573746F72206F66207468652063757272656E74206F6E652C20616E6420686173206E6F20706172656E74292E204966207468657265206973206E6F20706172656E742C207468';
wwv_flow_imp.g_varchar2_table(4310) := '6973206F7074696F6E2062656861766573207468652073616D652077617920617320605F73656C66602E5C6E5C6E4966207468697320617474726962757465206973207370656369666965642C207468697320656C656D656E74206D75737420636F6D65';
wwv_flow_imp.g_varchar2_table(4311) := '206265666F726520616E79206F7468657220656C656D656E7473207769746820617474726962757465732077686F73652076616C756573206172652055524C732E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E';
wwv_flow_imp.g_varchar2_table(4312) := '6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F62617365227D5D7D2C7B6E616D653A226C696E6B222C6465736372697074696F6E3A7B6B696E64';
wwv_flow_imp.g_varchar2_table(4313) := '3A226D61726B646F776E222C76616C75653A22546865206C696E6B20656C656D656E7420616C6C6F777320617574686F727320746F206C696E6B20746865697220646F63756D656E7420746F206F74686572207265736F75726365732E227D2C61747472';
wwv_flow_imp.g_varchar2_table(4314) := '6962757465733A5B7B6E616D653A2268726566222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686973206174747269627574652073706563696669657320746865205B55524C5D2868747470733A2F2F';
wwv_flow_imp.g_varchar2_table(4315) := '646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F55524C202255524C3A20556E69666F726D205265736F75726365204C6F6361746F72202855524C292069732061207465787420737472696E6720';
wwv_flow_imp.g_varchar2_table(4316) := '73706563696679696E672077686572652061207265736F757263652063616E20626520666F756E64206F6E2074686520496E7465726E65742E2229206F6620746865206C696E6B6564207265736F757263652E20412055524C2063616E20626520616273';
wwv_flow_imp.g_varchar2_table(4317) := '6F6C757465206F722072656C61746976652E277D7D2C7B6E616D653A2263726F73736F726967696E222C76616C75655365743A22786F222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320656E75';
wwv_flow_imp.g_varchar2_table(4318) := '6D6572617465642061747472696275746520696E646963617465732077686574686572205B434F52535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F434F5253202243';
wwv_flow_imp.g_varchar2_table(4319) := '4F52533A20434F5253202843726F73732D4F726967696E205265736F757263652053686172696E672920697320612073797374656D2C20636F6E73697374696E67206F66207472616E736D697474696E67204854545020686561646572732C2074686174';
wwv_flow_imp.g_varchar2_table(4320) := '2064657465726D696E657320776865746865722062726F777365727320626C6F636B2066726F6E74656E64204A61766153637269707420636F64652066726F6D20616363657373696E6720726573706F6E73657320666F722063726F73732D6F72696769';
wwv_flow_imp.g_varchar2_table(4321) := '6E2072657175657374732E2229206D7573742062652075736564207768656E206665746368696E6720746865207265736F757263652E205B434F52532D656E61626C656420696D616765735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(4322) := '6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F434F52535F456E61626C65645F496D616765292063616E2062652072657573656420696E20746865205B603C63616E7661733E605D2868747470733A2F2F646576656C6F7065722E6D';
wwv_flow_imp.g_varchar2_table(4323) := '6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F63616E7661732022557365207468652048544D4C203C63616E7661733E20656C656D656E74207769746820656974686572207468652063616E76617320';
wwv_flow_imp.g_varchar2_table(4324) := '736372697074696E6720415049206F722074686520576562474C2041504920746F206472617720677261706869637320616E6420616E696D6174696F6E732E222920656C656D656E7420776974686F7574206265696E67205F7461696E7465645F2E2054';
wwv_flow_imp.g_varchar2_table(4325) := '686520616C6C6F7765642076616C756573206172653A5C6E5C6E60616E6F6E796D6F7573605C6E5C6E412063726F73732D6F726967696E20726571756573742028692E652E207769746820616E205B604F726967696E605D2868747470733A2F2F646576';
wwv_flow_imp.g_varchar2_table(4326) := '656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F4F726967696E2022546865204F726967696E20726571756573742068656164657220696E6469636174657320776865726520612066';
wwv_flow_imp.g_varchar2_table(4327) := '65746368206F726967696E617465732066726F6D2E20497420646F65736E5C277420696E636C75646520616E79207061746820696E666F726D6174696F6E2C20627574206F6E6C792074686520736572766572206E616D652E2049742069732073656E74';
wwv_flow_imp.g_varchar2_table(4328) := '207769746820434F52532072657175657374732C2061732077656C6C206173207769746820504F53542072657175657374732E2049742069732073696D696C617220746F207468652052656665726572206865616465722C206275742C20756E6C696B65';
wwv_flow_imp.g_varchar2_table(4329) := '2074686973206865616465722C20697420646F65736E5C277420646973636C6F7365207468652077686F6C6520706174682E22292048545450206865616465722920697320706572666F726D65642C20627574206E6F2063726564656E7469616C206973';
wwv_flow_imp.g_varchar2_table(4330) := '2073656E742028692E652E206E6F20636F6F6B69652C20582E3530392063657274696669636174652C206F7220485454502042617369632061757468656E7469636174696F6E292E204966207468652073657276657220646F6573206E6F742067697665';
wwv_flow_imp.g_varchar2_table(4331) := '2063726564656E7469616C7320746F20746865206F726967696E207369746520286279206E6F742073657474696E6720746865205B604163636573732D436F6E74726F6C2D416C6C6F772D4F726967696E605D2868747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(4332) := '722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F4163636573732D436F6E74726F6C2D416C6C6F772D4F726967696E2022546865204163636573732D436F6E74726F6C2D416C6C6F772D4F726967';
wwv_flow_imp.g_varchar2_table(4333) := '696E20726573706F6E73652068656164657220696E6469636174657320776865746865722074686520726573706F6E73652063616E2062652073686172656420776974682072657175657374696E6720636F64652066726F6D2074686520676976656E20';
wwv_flow_imp.g_varchar2_table(4334) := '6F726967696E2E2229204854545020686561646572292074686520696D6167652077696C6C206265207461696E74656420616E642069747320757361676520726573747269637465642E5C6E5C6E607573652D63726564656E7469616C73605C6E5C6E41';
wwv_flow_imp.g_varchar2_table(4335) := '2063726F73732D6F726967696E20726571756573742028692E652E207769746820616E20604F726967696E602048545450206865616465722920697320706572666F726D656420616C6F6E67207769746820612063726564656E7469616C2073656E7420';
wwv_flow_imp.g_varchar2_table(4336) := '28692E652E206120636F6F6B69652C2063657274696669636174652C20616E642F6F7220485454502042617369632061757468656E7469636174696F6E20697320706572666F726D6564292E204966207468652073657276657220646F6573206E6F7420';
wwv_flow_imp.g_varchar2_table(4337) := '676976652063726564656E7469616C7320746F20746865206F726967696E207369746520287468726F756768205B604163636573732D436F6E74726F6C2D416C6C6F772D43726564656E7469616C73605D2868747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(4338) := '6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F4163636573732D436F6E74726F6C2D416C6C6F772D43726564656E7469616C732022546865204163636573732D436F6E74726F6C2D416C6C6F772D43';
wwv_flow_imp.g_varchar2_table(4339) := '726564656E7469616C7320726573706F6E7365206865616465722074656C6C732062726F7773657273207768657468657220746F206578706F73652074686520726573706F6E736520746F2066726F6E74656E64204A61766153637269707420636F6465';
wwv_flow_imp.g_varchar2_table(4340) := '207768656E2074686520726571756573745C27732063726564656E7469616C73206D6F64652028526571756573742E63726564656E7469616C73292069732022696E636C756465222E2229204854545020686561646572292C20746865207265736F7572';
wwv_flow_imp.g_varchar2_table(4341) := '63652077696C6C206265205F7461696E7465645F20616E642069747320757361676520726573747269637465642E5C6E5C6E49662074686520617474726962757465206973206E6F742070726573656E742C20746865207265736F757263652069732066';
wwv_flow_imp.g_varchar2_table(4342) := '65746368656420776974686F75742061205B434F52535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F434F52532022434F52533A20434F5253202843726F73732D4F72';
wwv_flow_imp.g_varchar2_table(4343) := '6967696E205265736F757263652053686172696E672920697320612073797374656D2C20636F6E73697374696E67206F66207472616E736D697474696E67204854545020686561646572732C20746861742064657465726D696E65732077686574686572';
wwv_flow_imp.g_varchar2_table(4344) := '2062726F777365727320626C6F636B2066726F6E74656E64204A61766153637269707420636F64652066726F6D20616363657373696E6720726573706F6E73657320666F722063726F73732D6F726967696E2072657175657374732E2229207265717565';
wwv_flow_imp.g_varchar2_table(4345) := '73742028692E652E20776974686F75742073656E64696E672074686520604F726967696E60204854545020686561646572292C2070726576656E74696E6720697473206E6F6E2D7461696E7465642075736167652E20496620696E76616C69642C206974';
wwv_flow_imp.g_varchar2_table(4346) := '2069732068616E646C65642061732069662074686520656E756D657261746564206B6579776F7264202A2A616E6F6E796D6F75732A2A2077617320757365642E20536565205B434F52532073657474696E677320617474726962757465735D2868747470';
wwv_flow_imp.g_varchar2_table(4347) := '733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F434F52535F73657474696E67735F617474726962757465732920666F72206164646974696F6E616C20696E666F726D6174696F6E2E27';
wwv_flow_imp.g_varchar2_table(4348) := '7D7D2C7B6E616D653A2272656C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320617474726962757465206E616D657320612072656C6174696F6E73686970206F6620746865206C696E6B6564';
wwv_flow_imp.g_varchar2_table(4349) := '20646F63756D656E7420746F207468652063757272656E7420646F63756D656E742E2054686520617474726962757465206D75737420626520612073706163652D736570617261746564206C697374206F6620746865205B6C696E6B2074797065732076';
wwv_flow_imp.g_varchar2_table(4350) := '616C7565735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F4C696E6B5F7479706573292E227D7D2C7B6E616D653A226D65646961222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(4351) := '6B696E643A226D61726B646F776E222C76616C75653A2254686973206174747269627574652073706563696669657320746865206D65646961207468617420746865206C696E6B6564207265736F75726365206170706C69657320746F2E204974732076';
wwv_flow_imp.g_varchar2_table(4352) := '616C7565206D7573742062652061206D656469612074797065202F205B6D656469612071756572795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F4D656469615F717565';
wwv_flow_imp.g_varchar2_table(4353) := '72696573292E205468697320617474726962757465206973206D61696E6C792075736566756C207768656E206C696E6B696E6720746F2065787465726E616C207374796C6573686565747320E2809420697420616C6C6F77732074686520757365722061';
wwv_flow_imp.g_varchar2_table(4354) := '67656E7420746F207069636B2074686520626573742061646170746564206F6E6520666F7220746865206465766963652069742072756E73206F6E2E5C6E5C6E2A2A4E6F7465733A2A2A5C6E5C6E2A202020496E2048544D4C20342C2074686973206361';
wwv_flow_imp.g_varchar2_table(4355) := '6E206F6E6C7920626520612073696D706C652077686974652D73706163652D736570617261746564206C697374206F66206D65646961206465736372697074696F6E206C69746572616C732C20692E652E2C205B6D6564696120747970657320616E6420';
wwv_flow_imp.g_varchar2_table(4356) := '67726F7570735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F406D65646961292C20776865726520646566696E656420616E6420616C6C6F7765642061732076616C7565';
wwv_flow_imp.g_varchar2_table(4357) := '7320666F722074686973206174747269627574652C207375636820617320607072696E74602C206073637265656E602C2060617572616C602C2060627261696C6C65602E2048544D4C3520657874656E646564207468697320746F20616E79206B696E64';
wwv_flow_imp.g_varchar2_table(4358) := '206F66205B6D6564696120717565726965735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F4D656469615F71756572696573292C20776869636820617265206120737570';
wwv_flow_imp.g_varchar2_table(4359) := '6572736574206F662074686520616C6C6F7765642076616C756573206F662048544D4C20342E5C6E2A20202042726F7773657273206E6F7420737570706F7274696E67205B43535333204D6564696120517565726965735D2868747470733A2F2F646576';
wwv_flow_imp.g_varchar2_table(4360) := '656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F4D656469615F717565726965732920776F6E2774206E65636573736172696C79207265636F676E697A6520746865206164657175617465206C696E6B3B20';
wwv_flow_imp.g_varchar2_table(4361) := '646F206E6F7420666F7267657420746F207365742066616C6C6261636B206C696E6B732C20746865207265737472696374656420736574206F66206D65646961207175657269657320646566696E656420696E2048544D4C20342E227D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(4362) := '3A22687265666C616E67222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520696E6469636174657320746865206C616E6775616765206F6620746865206C696E6B656420';
wwv_flow_imp.g_varchar2_table(4363) := '7265736F757263652E20497420697320707572656C792061647669736F72792E20416C6C6F7765642076616C756573206172652064657465726D696E6564206279205B42435034375D2868747470733A2F2F7777772E696574662E6F72672F7266632F62';
wwv_flow_imp.g_varchar2_table(4364) := '63702F62637034372E747874292E20557365207468697320617474726962757465206F6E6C7920696620746865205B6068726566605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F';
wwv_flow_imp.g_varchar2_table(4365) := '48544D4C2F456C656D656E742F6123617474722D6872656629206174747269627574652069732070726573656E742E227D7D2C7B6E616D653A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27';
wwv_flow_imp.g_varchar2_table(4366) := '5468697320617474726962757465206973207573656420746F20646566696E65207468652074797065206F662074686520636F6E74656E74206C696E6B656420746F2E205468652076616C7565206F6620746865206174747269627574652073686F756C';
wwv_flow_imp.g_varchar2_table(4367) := '642062652061204D494D4520747970652073756368206173202A2A746578742F68746D6C2A2A2C202A2A746578742F6373732A2A2C20616E6420736F206F6E2E2054686520636F6D6D6F6E20757365206F66207468697320617474726962757465206973';
wwv_flow_imp.g_varchar2_table(4368) := '20746F20646566696E65207468652074797065206F66207374796C657368656574206265696E67207265666572656E636564202873756368206173202A2A746578742F6373732A2A292C2062757420676976656E20746861742043535320697320746865';
wwv_flow_imp.g_varchar2_table(4369) := '206F6E6C79207374796C657368656574206C616E67756167652075736564206F6E20746865207765622C206E6F74206F6E6C7920697320697420706F737369626C6520746F206F6D69742074686520607479706560206174747269627574652C20627574';
wwv_flow_imp.g_varchar2_table(4370) := '2069732061637475616C6C79206E6F77207265636F6D6D656E6465642070726163746963652E20497420697320616C736F2075736564206F6E206072656C3D227072656C6F61642260206C696E6B2074797065732C20746F206D616B6520737572652074';
wwv_flow_imp.g_varchar2_table(4371) := '68652062726F77736572206F6E6C7920646F776E6C6F6164732066696C65207479706573207468617420697420737570706F7274732E277D7D2C7B6E616D653A2273697A6573222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(4372) := '2C76616C75653A22546869732061747472696275746520646566696E6573207468652073697A6573206F66207468652069636F6E7320666F722076697375616C206D6564696120636F6E7461696E656420696E20746865207265736F757263652E204974';
wwv_flow_imp.g_varchar2_table(4373) := '206D7573742062652070726573656E74206F6E6C7920696620746865205B6072656C605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6C696E6B23';
wwv_flow_imp.g_varchar2_table(4374) := '617474722D72656C2920636F6E7461696E7320612076616C7565206F66206069636F6E60206F722061206E6F6E2D7374616E6461726420747970652073756368206173204170706C65277320606170706C652D746F7563682D69636F6E602E204974206D';
wwv_flow_imp.g_varchar2_table(4375) := '617920686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A20202060616E79602C206D65616E696E672074686174207468652069636F6E2063616E206265207363616C656420746F20616E792073697A65206173206974206973';
wwv_flow_imp.g_varchar2_table(4376) := '20696E206120766563746F7220666F726D61742C206C696B652060696D6167652F7376672B786D6C602E5C6E2A202020612077686974652D737061636520736570617261746564206C697374206F662073697A65732C206561636820696E207468652066';
wwv_flow_imp.g_varchar2_table(4377) := '6F726D617420605F3C776964746820696E20706978656C733E5F785F3C68656967687420696E20706978656C733E5F60206F7220605F3C776964746820696E20706978656C733E5F585F3C68656967687420696E20706978656C733E5F602E2045616368';
wwv_flow_imp.g_varchar2_table(4378) := '206F662074686573652073697A6573206D75737420626520636F6E7461696E656420696E20746865207265736F757263652E5C6E5C6E2A2A4E6F74653A2A2A204D6F73742069636F6E20666F726D61747320617265206F6E6C792061626C6520746F2073';
wwv_flow_imp.g_varchar2_table(4379) := '746F7265206F6E652073696E676C652069636F6E3B207468657265666F7265206D6F7374206F66207468652074696D6520746865205B6073697A6573605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F64';
wwv_flow_imp.g_varchar2_table(4380) := '6F63732F5765622F48544D4C2F476C6F62616C5F6174747269627574657323617474722D73697A65732920636F6E7461696E73206F6E6C79206F6E6520656E7472792E204D5327732049434F20666F726D617420646F65732C2061732077656C6C206173';
wwv_flow_imp.g_varchar2_table(4381) := '204170706C6527732049434E532E2049434F206973206D6F726520756269717569746F75733B20796F752073686F756C6420646566696E6974656C79207573652069742E227D7D2C7B6E616D653A226173222C6465736372697074696F6E3A2754686973';
wwv_flow_imp.g_varchar2_table(4382) := '20617474726962757465206973206F6E6C792075736564207768656E206072656C3D227072656C6F61642260206F72206072656C3D227072656665746368226020686173206265656E20736574206F6E2074686520603C6C696E6B3E6020656C656D656E';
wwv_flow_imp.g_varchar2_table(4383) := '742E20497420737065636966696573207468652074797065206F6620636F6E74656E74206265696E67206C6F616465642062792074686520603C6C696E6B3E602C207768696368206973206E656365737361727920666F7220636F6E74656E7420707269';
wwv_flow_imp.g_varchar2_table(4384) := '6F726974697A6174696F6E2C2072657175657374206D61746368696E672C206170706C69636174696F6E206F6620636F7272656374205B636F6E74656E7420736563757269747920706F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(4385) := '7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F435350292C20616E642073657474696E67206F6620636F7272656374205B60416363657074605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F';
wwv_flow_imp.g_varchar2_table(4386) := '656E2D55532F646F63732F5765622F485454502F486561646572732F4163636570742022546865204163636570742072657175657374204854545020686561646572206164766572746973657320776869636820636F6E74656E742074797065732C2065';
wwv_flow_imp.g_varchar2_table(4387) := '7870726573736564206173204D494D452074797065732C2074686520636C69656E742069732061626C6520746F20756E6465727374616E642E205573696E6720636F6E74656E74206E65676F74696174696F6E2C2074686520736572766572207468656E';
wwv_flow_imp.g_varchar2_table(4388) := '2073656C65637473206F6E65206F66207468652070726F706F73616C732C207573657320697420616E6420696E666F726D732074686520636C69656E74206F66206974732063686F69636520776974682074686520436F6E74656E742D54797065207265';
wwv_flow_imp.g_varchar2_table(4389) := '73706F6E7365206865616465722E2042726F7773657273207365742061646571756174652076616C75657320666F7220746869732068656164657220646570656E64696E67206F6EC2A074686520636F6E74657874207768657265207468652072657175';
wwv_flow_imp.g_varchar2_table(4390) := '65737420697320646F6E653A207768656E206665746368696E67206120435353207374796C657368656574206120646966666572656E742076616C75652069732073657420666F72207468652072657175657374207468616E207768656E206665746368';
wwv_flow_imp.g_varchar2_table(4391) := '696E6720616E20696D6167652CC2A0766964656F206F722061207363726970742E22292072657175657374206865616465722E277D2C7B6E616D653A22696D706F7274616E6365222C6465736372697074696F6E3A22496E646963617465732074686520';
wwv_flow_imp.g_varchar2_table(4392) := '72656C617469766520696D706F7274616E6365206F6620746865207265736F757263652E205072696F726974792068696E7473206172652064656C656761746564207573696E67207468652076616C7565733A227D2C7B6E616D653A22696D706F727461';
wwv_flow_imp.g_varchar2_table(4393) := '6E6365222C6465736372697074696F6E3A272A2A606175746F602A2A3A20496E64696361746573C2A02A2A6E6FC2A0707265666572656E63652A2A2E205468652062726F77736572206D61792075736520697473206F776E206865757269737469637320';
wwv_flow_imp.g_varchar2_table(4394) := '746F2064656369646520746865207072696F72697479206F6620746865207265736F757263652E5C6E5C6E2A2A6068696768602A2A3A20496E6469636174657320746F20746865C2A062726F77736572C2A07468617420746865207265736F7572636520';
wwv_flow_imp.g_varchar2_table(4395) := '6973206F66C2A02A2A686967682A2A207072696F726974792E5C6E5C6E2A2A606C6F77602A2A3AC2A0496E6469636174657320746F20746865C2A062726F77736572C2A07468617420746865207265736F75726365206973206F66C2A02A2A6C6F772A2A';
wwv_flow_imp.g_varchar2_table(4396) := '207072696F726974792E5C6E5C6E2A2A4E6F74653A2A2A205468652060696D706F7274616E63656020617474726962757465206D6179206F6E6C79206265207573656420666F722074686520603C6C696E6B3E6020656C656D656E74206966206072656C';
wwv_flow_imp.g_varchar2_table(4397) := '3D227072656C6F61642260206F72206072656C3D22707265666574636822602069732070726573656E742E277D2C7B6E616D653A22696E74656772697479222C6465736372697074696F6E3A22436F6E7461696E7320696E6C696E65206D657461646174';
wwv_flow_imp.g_varchar2_table(4398) := '6120E280942061206261736536342D656E636F6465642063727970746F677261706869632068617368206F6620746865207265736F75726365202866696C652920796F75E2809972652074656C6C696E67207468652062726F7773657220746F20666574';
wwv_flow_imp.g_varchar2_table(4399) := '63682E205468652062726F777365722063616E20757365207468697320746F207665726966792074686174207468652066657463686564207265736F7572636520686173206265656E2064656C6976657265642066726565206F6620756E657870656374';
wwv_flow_imp.g_varchar2_table(4400) := '6564206D616E6970756C6174696F6E2E20536565205B5375627265736F7572636520496E746567726974795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F53656375726974792F53';
wwv_flow_imp.g_varchar2_table(4401) := '75627265736F757263655F496E74656772697479292E227D2C7B6E616D653A227265666572726572706F6C696379222C6465736372697074696F6E3A274120737472696E6720696E6469636174696E6720776869636820726566657272657220746F2075';
wwv_flow_imp.g_varchar2_table(4402) := '7365207768656E206665746368696E6720746865207265736F757263653A5C6E5C6E2A202020606E6F2D726566657272657260206D65616E73207468617420746865205B6052656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A';
wwv_flow_imp.g_varchar2_table(4403) := '696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F526566657265722022546865205265666572657220726571756573742068656164657220636F6E7461696E73207468652061646472657373206F6620746865';
wwv_flow_imp.g_varchar2_table(4404) := '2070726576696F75732077656220706167652066726F6D2077686963682061206C696E6B20746F207468652063757272656E746C792072657175657374656420706167652077617320666F6C6C6F7765642E205468652052656665726572206865616465';
wwv_flow_imp.g_varchar2_table(4405) := '7220616C6C6F7773207365727665727320746F206964656E746966792077686572652070656F706C6520617265207669736974696E67207468656D2066726F6D20616E64206D6179207573652074686174206461746120666F7220616E616C7974696373';
wwv_flow_imp.g_varchar2_table(4406) := '2C206C6F6767696E672C206F72206F7074696D697A65642063616368696E672C20666F72206578616D706C652E2229206865616465722077696C6C206E6F742062652073656E742E5C6E2A202020606E6F2D72656665727265722D7768656E2D646F776E';
wwv_flow_imp.g_varchar2_table(4407) := '677261646560206D65616E732074686174206E6F205B6052656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F526566657265722022';
wwv_flow_imp.g_varchar2_table(4408) := '546865205265666572657220726571756573742068656164657220636F6E7461696E73207468652061646472657373206F66207468652070726576696F75732077656220706167652066726F6D2077686963682061206C696E6B20746F20746865206375';
wwv_flow_imp.g_varchar2_table(4409) := '7272656E746C792072657175657374656420706167652077617320666F6C6C6F7765642E2054686520526566657265722068656164657220616C6C6F7773207365727665727320746F206964656E746966792077686572652070656F706C652061726520';
wwv_flow_imp.g_varchar2_table(4410) := '7669736974696E67207468656D2066726F6D20616E64206D6179207573652074686174206461746120666F7220616E616C79746963732C206C6F6767696E672C206F72206F7074696D697A65642063616368696E672C20666F72206578616D706C652E22';
wwv_flow_imp.g_varchar2_table(4411) := '29206865616465722077696C6C2062652073656E74207768656E206E617669676174696E6720746F20616E206F726967696E20776974686F757420544C5320284854545053292E205468697320697320612075736572206167656E74E280997320646566';
wwv_flow_imp.g_varchar2_table(4412) := '61756C74206265686176696F722C206966206E6F20706F6C696379206973206F7468657277697365207370656369666965642E5C6E2A202020606F726967696E60206D65616E732074686174207468652072656665727265722077696C6C206265207468';
wwv_flow_imp.g_varchar2_table(4413) := '65206F726967696E206F662074686520706167652C20776869636820697320726F7567686C792074686520736368656D652C2074686520686F73742C20616E642074686520706F72742E5C6E2A202020606F726967696E2D7768656E2D63726F73732D6F';
wwv_flow_imp.g_varchar2_table(4414) := '726967696E60206D65616E732074686174206E617669676174696E6720746F206F74686572206F726967696E732077696C6C206265206C696D6974656420746F2074686520736368656D652C2074686520686F73742C20616E642074686520706F72742C';
wwv_flow_imp.g_varchar2_table(4415) := '207768696C65206E617669676174696E67206F6E207468652073616D65206F726967696E2077696C6C20696E636C756465207468652072656665727265725C277320706174682E5C6E2A20202060756E736166652D75726C60206D65616E732074686174';
wwv_flow_imp.g_varchar2_table(4416) := '207468652072656665727265722077696C6C20696E636C75646520746865206F726967696E20616E642074686520706174682028627574206E6F742074686520667261676D656E742C2070617373776F72642C206F7220757365726E616D65292E205468';
wwv_flow_imp.g_varchar2_table(4417) := '6973206361736520697320756E7361666520626563617573652069742063616E206C65616B206F726967696E7320616E642070617468732066726F6D20544C532D70726F746563746564207265736F757263657320746F20696E736563757265206F7269';
wwv_flow_imp.g_varchar2_table(4418) := '67696E732E277D2C7B6E616D653A227469746C65222C6465736372697074696F6E3A2754686520607469746C65602061747472696275746520686173207370656369616C2073656D616E74696373206F6E2074686520603C6C696E6B3E6020656C656D65';
wwv_flow_imp.g_varchar2_table(4419) := '6E742E205768656E2075736564206F6E206120603C6C696E6B2072656C3D227374796C657368656574223E6020697420646566696E65732061205B707265666572726564206F7220616E20616C7465726E617465207374796C6573686565745D28687474';
wwv_flow_imp.g_varchar2_table(4420) := '70733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F416C7465726E61746976655F7374796C655F736865657473292E20496E636F72726563746C79207573696E67206974206D6179205B63';
wwv_flow_imp.g_varchar2_table(4421) := '6175736520746865207374796C65736865657420746F2062652069676E6F7265645D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F436F72726563746C795F5573696E675F5469746C65735F57';
wwv_flow_imp.g_varchar2_table(4422) := '6974685F45787465726E616C5F5374796C65736865657473292E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F64';
wwv_flow_imp.g_varchar2_table(4423) := '6F63732F5765622F48544D4C2F456C656D656E742F6C696E6B227D5D7D2C7B6E616D653A226D657461222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D65746120656C656D656E742072657072';
wwv_flow_imp.g_varchar2_table(4424) := '6573656E747320766172696F7573206B696E6473206F66206D6574616461746120746861742063616E6E6F7420626520657870726573736564207573696E6720746865207469746C652C20626173652C206C696E6B2C207374796C652C20616E64207363';
wwv_flow_imp.g_varchar2_table(4425) := '7269707420656C656D656E74732E227D2C617474726962757465733A5B7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546869732061747472696275746520646566696E6573';
wwv_flow_imp.g_varchar2_table(4426) := '20746865206E616D65206F662061207069656365206F6620646F63756D656E742D6C6576656C206D657461646174612E2049742073686F756C64206E6F7420626520736574206966206F6E65206F66207468652061747472696275746573205B60697465';
wwv_flow_imp.g_varchar2_table(4427) := '6D70726F70605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F476C6F62616C5F6174747269627574657323617474722D6974656D70726F70292C205B60687474702D65';
wwv_flow_imp.g_varchar2_table(4428) := '71756976605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D687474702D657175697629206F72205B606368617273657460';
wwv_flow_imp.g_varchar2_table(4429) := '5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D636861727365742920697320616C736F207365742E5C6E5C6E5468697320';
wwv_flow_imp.g_varchar2_table(4430) := '6D65746164617461206E616D65206973206173736F6369617465642077697468207468652076616C756520636F6E7461696E656420627920746865205B60636F6E74656E74605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(4431) := '672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D636F6E74656E7429206174747269627574652E2054686520706F737369626C652076616C75657320666F7220746865206E616D652061747472696275';
wwv_flow_imp.g_varchar2_table(4432) := '7465206172653A5C6E5C6E2A202020606170706C69636174696F6E2D6E616D656020776869636820646566696E657320746865206E616D65206F6620746865206170706C69636174696F6E2072756E6E696E6720696E207468652077656220706167652E';
wwv_flow_imp.g_varchar2_table(4433) := '5C6E202020205C6E202020202A2A4E6F74653A2A2A5C6E202020205C6E202020202A20202042726F7773657273206D617920757365207468697320746F206964656E7469667920746865206170706C69636174696F6E2E20497420697320646966666572';
wwv_flow_imp.g_varchar2_table(4434) := '656E742066726F6D20746865205B603C7469746C653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7469746C6520225468652048544D4C2054';
wwv_flow_imp.g_varchar2_table(4435) := '69746C6520656C656D656E7420283C7469746C653E2920646566696E65732074686520646F63756D656E745C2773207469746C6520746861742069732073686F776E20696E20612062726F777365725C2773207469746C6520626172206F722061207061';
wwv_flow_imp.g_varchar2_table(4436) := '67655C2773207461622E222920656C656D656E742C20776869636820757375616C6C7920636F6E7461696E20746865206170706C69636174696F6E206E616D652C20627574206D617920616C736F20636F6E7461696E20696E666F726D6174696F6E206C';
wwv_flow_imp.g_varchar2_table(4437) := '696B652074686520646F63756D656E74206E616D65206F722061207374617475732E5C6E202020202A20202053696D706C65207765622070616765732073686F756C646E5C277420646566696E6520616E206170706C69636174696F6E2D6E616D652E5C';
wwv_flow_imp.g_varchar2_table(4438) := '6E202020205C6E2A20202060617574686F726020776869636820646566696E657320746865206E616D65206F662074686520646F63756D656E745C277320617574686F722E5C6E2A202020606465736372697074696F6E6020776869636820636F6E7461';
wwv_flow_imp.g_varchar2_table(4439) := '696E7320612073686F727420616E642061636375726174652073756D6D617279206F662074686520636F6E74656E74206F662074686520706167652E205365766572616C2062726F77736572732C206C696B652046697265666F7820616E64204F706572';
wwv_flow_imp.g_varchar2_table(4440) := '612C207573652074686973206173207468652064656661756C74206465736372697074696F6E206F6620626F6F6B6D61726B65642070616765732E5C6E2A2020206067656E657261746F726020776869636820636F6E7461696E7320746865206964656E';
wwv_flow_imp.g_varchar2_table(4441) := '746966696572206F662074686520736F66747761726520746861742067656E6572617465642074686520706167652E5C6E2A202020606B6579776F7264736020776869636820636F6E7461696E7320776F7264732072656C6576616E7420746F20746865';
wwv_flow_imp.g_varchar2_table(4442) := '20706167655C277320636F6E74656E742073657061726174656420627920636F6D6D61732E5C6E2A2020206072656665727265726020776869636820636F6E74726F6C7320746865205B6052656665726572602048545450206865616465725D28687474';
wwv_flow_imp.g_varchar2_table(4443) := '70733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F526566657265722920617474616368656420746F2072657175657374732073656E742066726F6D207468652064';
wwv_flow_imp.g_varchar2_table(4444) := '6F63756D656E743A5C6E202020205C6E2020202056616C75657320666F72207468652060636F6E74656E746020617474726962757465206F6620603C6D657461206E616D653D227265666572726572223E605C6E202020205C6E20202020606E6F2D7265';
wwv_flow_imp.g_varchar2_table(4445) := '666572726572605C6E202020205C6E20202020446F206E6F742073656E64206120485454502060526566657272657260206865616465722E5C6E202020205C6E20202020606F726967696E605C6E202020205C6E2020202053656E6420746865205B6F72';
wwv_flow_imp.g_varchar2_table(4446) := '6967696E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4F726967696E29206F662074686520646F63756D656E742E5C6E202020205C6E20202020606E6F2D72656665';
wwv_flow_imp.g_varchar2_table(4447) := '727265722D7768656E2D646F776E6772616465605C6E202020205C6E2020202053656E6420746865205B6F726967696E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F';
wwv_flow_imp.g_varchar2_table(4448) := '4F726967696E29206173206120726566657272657220746F2055524C7320617320736563757265206173207468652063757272656E7420706167652C20286874747073E286926874747073292C2062757420646F6573206E6F742073656E642061207265';
wwv_flow_imp.g_varchar2_table(4449) := '66657272657220746F206C657373207365637572652055524C7320286874747073E2869268747470292E2054686973206973207468652064656661756C74206265686176696F75722E5C6E202020205C6E20202020606F726967696E2D7768656E2D6372';
wwv_flow_imp.g_varchar2_table(4450) := '6F73732D6F726967696E605C6E202020205C6E2020202053656E64207468652066756C6C2055524C20287374726970706564206F6620706172616D65746572732920666F722073616D652D6F726967696E2072657175657374732C20627574206F6E6C79';
wwv_flow_imp.g_varchar2_table(4451) := '2073656E6420746865205B6F726967696E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4F726967696E2920666F72206F746865722063617365732E5C6E202020205C';
wwv_flow_imp.g_varchar2_table(4452) := '6E202020206073616D652D6F726967696E605C6E202020205C6E20202020412072656665727265722077696C6C2062652073656E7420666F72205B73616D652D73697465206F726967696E735D2868747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(4453) := '6C6C612E6F72672F656E2D55532F646F63732F5765622F53656375726974792F53616D652D6F726967696E5F706F6C696379292C206275742063726F73732D6F726967696E2072657175657374732077696C6C20636F6E7461696E206E6F207265666572';
wwv_flow_imp.g_varchar2_table(4454) := '72657220696E666F726D6174696F6E2E5C6E202020205C6E20202020607374726963742D6F726967696E605C6E202020205C6E202020204F6E6C792073656E6420746865206F726967696E206F662074686520646F63756D656E74206173207468652072';
wwv_flow_imp.g_varchar2_table(4455) := '6566657272657220746F20612D7072696F72692061732D6D7563682D7365637572652064657374696E6174696F6E202848545450532D3E4854545053292C2062757420646F6E5C27742073656E6420697420746F2061206C657373207365637572652064';
wwv_flow_imp.g_varchar2_table(4456) := '657374696E6174696F6E202848545450532D3E48545450292E5C6E202020205C6E20202020607374726963742D6F726967696E2D7768656E2D63726F73732D6F726967696E605C6E202020205C6E2020202053656E6420612066756C6C2055524C207768';
wwv_flow_imp.g_varchar2_table(4457) := '656E20706572666F726D696E6720612073616D652D6F726967696E20726571756573742C206F6E6C792073656E6420746865206F726967696E206F662074686520646F63756D656E7420746F20612D7072696F72692061732D6D7563682D736563757265';
wwv_flow_imp.g_varchar2_table(4458) := '2064657374696E6174696F6E202848545450532D3E4854545053292C20616E642073656E64206E6F2068656164657220746F2061206C657373207365637572652064657374696E6174696F6E202848545450532D3E48545450292E5C6E202020205C6E20';
wwv_flow_imp.g_varchar2_table(4459) := '20202060756E736166652D55524C605C6E202020205C6E2020202053656E64207468652066756C6C2055524C20287374726970706564206F6620706172616D65746572732920666F722073616D652D6F726967696E206F722063726F73732D6F72696769';
wwv_flow_imp.g_varchar2_table(4460) := '6E2072657175657374732E5C6E202020205C6E202020202A2A4E6F7465733A2A2A5C6E202020205C6E202020202A202020536F6D652062726F777365727320737570706F72742074686520646570726563617465642076616C756573206F662060616C77';
wwv_flow_imp.g_varchar2_table(4461) := '617973602C206064656661756C74602C20616E6420606E657665726020666F722072656665727265722E5C6E202020202A20202044796E616D6963616C6C7920696E73657274696E6720603C6D657461206E616D653D227265666572726572223E602028';
wwv_flow_imp.g_varchar2_table(4462) := '77697468205B60646F63756D656E742E7772697465605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F446F63756D656E742F777269746529206F72205B60617070656E64';
wwv_flow_imp.g_varchar2_table(4463) := '4368696C64605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F4E6F64652F617070656E644368696C642929206D616B657320746865207265666572726572206265686176';
wwv_flow_imp.g_varchar2_table(4464) := '696F757220756E7072656469637461626C652E5C6E202020202A2020205768656E207365766572616C20636F6E666C696374696E6720706F6C69636965732061726520646566696E65642C20746865206E6F2D726566657272657220706F6C6963792069';
wwv_flow_imp.g_varchar2_table(4465) := '73206170706C6965642E5C6E202020205C6E5C6E5468697320617474726962757465206D617920616C736F206861766520612076616C75652074616B656E2066726F6D2074686520657874656E646564206C69737420646566696E6564206F6E205B5748';
wwv_flow_imp.g_varchar2_table(4466) := '415457472057696B69204D657461457874656E73696F6E7320706167655D2868747470733A2F2F77696B692E7768617477672E6F72672F77696B692F4D657461457874656E73696F6E73292E20416C74686F756768206E6F6E652068617665206265656E';
wwv_flow_imp.g_varchar2_table(4467) := '20666F726D616C6C79206163636570746564207965742C20612066657720636F6D6D6F6E6C792075736564206E616D6573206172653A5C6E5C6E2A2020206063726561746F726020776869636820646566696E657320746865206E616D65206F66207468';
wwv_flow_imp.g_varchar2_table(4468) := '652063726561746F72206F662074686520646F63756D656E742C207375636820617320616E206F7267616E697A6174696F6E206F7220696E737469747574696F6E2E20496620746865726520617265206D6F7265207468616E206F6E652C207365766572';
wwv_flow_imp.g_varchar2_table(4469) := '616C205B603C6D6574613E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746120225468652048544D4C203C6D6574613E20656C656D656E';
wwv_flow_imp.g_varchar2_table(4470) := '7420726570726573656E7473206D6574616461746120746861742063616E6E6F7420626520726570726573656E746564206279206F746865722048544D4C206D6574612D72656C6174656420656C656D656E74732C206C696B65203C626173653E2C203C';
wwv_flow_imp.g_varchar2_table(4471) := '6C696E6B3E2C203C7363726970743E2C203C7374796C653E206F72203C7469746C653E2E222920656C656D656E74732073686F756C6420626520757365642E5C6E2A20202060676F6F676C65626F74602C20612073796E6F6E796D206F662060726F626F';
wwv_flow_imp.g_varchar2_table(4472) := '7473602C206973206F6E6C7920666F6C6C6F77656420627920476F6F676C65626F74202874686520696E646578696E6720637261776C657220666F7220476F6F676C65292E5C6E2A202020607075626C69736865726020776869636820646566696E6573';
wwv_flow_imp.g_varchar2_table(4473) := '20746865206E616D65206F662074686520646F63756D656E745C2773207075626C69736865722E5C6E2A20202060726F626F74736020776869636820646566696E657320746865206265686176696F7572207468617420636F6F70657261746976652063';
wwv_flow_imp.g_varchar2_table(4474) := '7261776C6572732C206F722022726F626F7473222C2073686F756C642075736520776974682074686520706167652E204974206973206120636F6D6D612D736570617261746564206C697374206F66207468652076616C7565732062656C6F773A5C6E20';
wwv_flow_imp.g_varchar2_table(4475) := '2020205C6E2020202056616C75657320666F722074686520636F6E74656E74206F6620603C6D657461206E616D653D22726F626F7473223E605C6E202020205C6E2020202056616C75655C6E202020205C6E202020204465736372697074696F6E5C6E20';
wwv_flow_imp.g_varchar2_table(4476) := '2020205C6E20202020557365642062795C6E202020205C6E2020202060696E646578605C6E202020205C6E20202020416C6C6F77732074686520726F626F7420746F20696E646578207468652070616765202864656661756C74292E5C6E202020205C6E';
wwv_flow_imp.g_varchar2_table(4477) := '20202020416C6C5C6E202020205C6E20202020606E6F696E646578605C6E202020205C6E2020202052657175657374732074686520726F626F7420746F206E6F7420696E6465782074686520706167652E5C6E202020205C6E20202020416C6C5C6E2020';
wwv_flow_imp.g_varchar2_table(4478) := '20205C6E2020202060666F6C6C6F77605C6E202020205C6E20202020416C6C6F77732074686520726F626F7420746F20666F6C6C6F7720746865206C696E6B73206F6E207468652070616765202864656661756C74292E5C6E202020205C6E2020202041';
wwv_flow_imp.g_varchar2_table(4479) := '6C6C5C6E202020205C6E20202020606E6F666F6C6C6F77605C6E202020205C6E2020202052657175657374732074686520726F626F7420746F206E6F7420666F6C6C6F7720746865206C696E6B73206F6E2074686520706167652E5C6E202020205C6E20';
wwv_flow_imp.g_varchar2_table(4480) := '202020416C6C5C6E202020205C6E20202020606E6F6E65605C6E202020205C6E202020204571756976616C656E7420746F20606E6F696E6465782C206E6F666F6C6C6F77605C6E202020205C6E202020205B476F6F676C655D2868747470733A2F2F7375';
wwv_flow_imp.g_varchar2_table(4481) := '70706F72742E676F6F676C652E636F6D2F7765626D6173746572732F616E737765722F3739383132295C6E202020205C6E20202020606E6F6F6470605C6E202020205C6E2020202050726576656E7473207573696E6720746865205B4F70656E20446972';
wwv_flow_imp.g_varchar2_table(4482) := '6563746F72792050726F6A6563745D2868747470733A2F2F7777772E646D6F7A2E6F72672F29206465736372697074696F6E2C20696620616E792C206173207468652070616765206465736372697074696F6E20696E2073656172636820656E67696E65';
wwv_flow_imp.g_varchar2_table(4483) := '20726573756C74732E5C6E202020205C6E202020205B476F6F676C655D2868747470733A2F2F737570706F72742E676F6F676C652E636F6D2F7765626D6173746572732F616E737765722F3335363234236E6F646D6F7A292C205B5961686F6F5D286874';
wwv_flow_imp.g_varchar2_table(4484) := '7470733A2F2F68656C702E7961686F6F2E636F6D2F6B622F7365617263682D666F722D6465736B746F702F6D6574612D746167732D726F626F74737478742D7961686F6F2D7365617263682D736C6E323231332E68746D6C23636F6E7435292C205B4269';
wwv_flow_imp.g_varchar2_table(4485) := '6E675D2868747470733A2F2F7777772E62696E672E636F6D2F7765626D61737465722F68656C702F77686963682D726F626F74732D6D657461746167732D646F65732D62696E672D737570706F72742D3531393864323430295C6E202020205C6E202020';
wwv_flow_imp.g_varchar2_table(4486) := '20606E6F61726368697665605C6E202020205C6E202020205265717565737473207468652073656172636820656E67696E65206E6F7420746F20636163686520746865207061676520636F6E74656E742E5C6E202020205C6E202020205B476F6F676C65';
wwv_flow_imp.g_varchar2_table(4487) := '5D2868747470733A2F2F646576656C6F706572732E676F6F676C652E636F6D2F7765626D6173746572732F636F6E74726F6C2D637261776C2D696E6465782F646F63732F726F626F74735F6D6574615F7461672376616C69642D696E646578696E672D2D';
wwv_flow_imp.g_varchar2_table(4488) := '73657276696E672D64697265637469766573292C205B5961686F6F5D2868747470733A2F2F68656C702E7961686F6F2E636F6D2F6B622F7365617263682D666F722D6465736B746F702F534C4E323231332E68746D6C292C205B42696E675D2868747470';
wwv_flow_imp.g_varchar2_table(4489) := '733A2F2F7777772E62696E672E636F6D2F7765626D61737465722F68656C702F77686963682D726F626F74732D6D657461746167732D646F65732D62696E672D737570706F72742D3531393864323430295C6E202020205C6E20202020606E6F736E6970';
wwv_flow_imp.g_varchar2_table(4490) := '706574605C6E202020205C6E2020202050726576656E747320646973706C6179696E6720616E79206465736372697074696F6E206F6620746865207061676520696E2073656172636820656E67696E6520726573756C74732E5C6E202020205C6E202020';
wwv_flow_imp.g_varchar2_table(4491) := '205B476F6F676C655D2868747470733A2F2F646576656C6F706572732E676F6F676C652E636F6D2F7765626D6173746572732F636F6E74726F6C2D637261776C2D696E6465782F646F63732F726F626F74735F6D6574615F7461672376616C69642D696E';
wwv_flow_imp.g_varchar2_table(4492) := '646578696E672D2D73657276696E672D64697265637469766573292C205B42696E675D2868747470733A2F2F7777772E62696E672E636F6D2F7765626D61737465722F68656C702F77686963682D726F626F74732D6D657461746167732D646F65732D62';
wwv_flow_imp.g_varchar2_table(4493) := '696E672D737570706F72742D3531393864323430295C6E202020205C6E20202020606E6F696D616765696E646578605C6E202020205C6E20202020526571756573747320746869732070616765206E6F7420746F20617070656172206173207468652072';
wwv_flow_imp.g_varchar2_table(4494) := '6566657272696E672070616765206F6620616E20696E646578656420696D6167652E5C6E202020205C6E202020205B476F6F676C655D2868747470733A2F2F646576656C6F706572732E676F6F676C652E636F6D2F7765626D6173746572732F636F6E74';
wwv_flow_imp.g_varchar2_table(4495) := '726F6C2D637261776C2D696E6465782F646F63732F726F626F74735F6D6574615F7461672376616C69642D696E646578696E672D2D73657276696E672D64697265637469766573295C6E202020205C6E20202020606E6F6361636865605C6E202020205C';
wwv_flow_imp.g_varchar2_table(4496) := '6E2020202053796E6F6E796D206F6620606E6F61726368697665602E5C6E202020205C6E202020205B42696E675D2868747470733A2F2F7777772E62696E672E636F6D2F7765626D61737465722F68656C702F77686963682D726F626F74732D6D657461';
wwv_flow_imp.g_varchar2_table(4497) := '746167732D646F65732D62696E672D737570706F72742D3531393864323430295C6E202020205C6E202020202A2A4E6F7465733A2A2A5C6E202020205C6E202020202A2020204F6E6C7920636F6F706572617469766520726F626F747320666F6C6C6F77';
wwv_flow_imp.g_varchar2_table(4498) := '2074686573652072756C65732E20446F206E6F742065787065637420746F2070726576656E7420652D6D61696C20686172766573746572732077697468207468656D2E5C6E202020202A20202054686520726F626F74207374696C6C206E656564732074';
wwv_flow_imp.g_varchar2_table(4499) := '6F2061636365737320746865207061676520696E206F7264657220746F20726561642074686573652072756C65732E20546F2070726576656E742062616E64776964746820636F6E73756D7074696F6E2C207573652061205F5B726F626F74732E747874';
wwv_flow_imp.g_varchar2_table(4500) := '5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F726F626F74732E7478742022726F626F74732E7478743A20526F626F74732E74787420697320612066696C6520776869';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(4501) := '636820697320757375616C6C7920706C6163656420696E2074686520726F6F74206F6620616E7920776562736974652E20497420646563696465732077686574686572C2A0637261776C65727320617265207065726D6974746564206F7220666F726269';
wwv_flow_imp.g_varchar2_table(4502) := '6464656E2061636365737320746F207468652077656220736974652E22295F2066696C652E5C6E202020202A202020496620796F752077616E7420746F2072656D6F7665206120706167652C20606E6F696E646578602077696C6C20776F726B2C206275';
wwv_flow_imp.g_varchar2_table(4503) := '74206F6E6C792061667465722074686520726F626F742076697369747320746865207061676520616761696E2E20456E737572652074686174207468652060726F626F74732E747874602066696C65206973206E6F742070726576656E74696E67207265';
wwv_flow_imp.g_varchar2_table(4504) := '7669736974732E5C6E202020202A202020536F6D652076616C75657320617265206D757475616C6C79206578636C75736976652C206C696B652060696E6465786020616E6420606E6F696E646578602C206F722060666F6C6C6F776020616E6420606E6F';
wwv_flow_imp.g_varchar2_table(4505) := '666F6C6C6F77602E20496E2074686573652063617365732074686520726F626F745C2773206265686176696F757220697320756E646566696E656420616E64206D61792076617279206265747765656E207468656D2E5C6E202020202A202020536F6D65';
wwv_flow_imp.g_varchar2_table(4506) := '20637261776C657220726F626F74732C206C696B6520476F6F676C652C205961686F6F20616E642042696E672C20737570706F7274207468652073616D652076616C75657320666F72207468652048545450206865616465722060582D526F626F74732D';
wwv_flow_imp.g_varchar2_table(4507) := '546167603B207468697320616C6C6F7773206E6F6E2D48544D4C20646F63756D656E7473206C696B6520696D6167657320746F207573652074686573652072756C65732E5C6E202020205C6E2A20202060736C757270602C20697320612073796E6F6E79';
wwv_flow_imp.g_varchar2_table(4508) := '6D206F662060726F626F7473602C20627574206F6E6C7920666F7220536C757270202D2074686520637261776C657220666F72205961686F6F205365617263682E5C6E2A2020206076696577706F7274602C2077686963682067697665732068696E7473';
wwv_flow_imp.g_varchar2_table(4509) := '2061626F7574207468652073697A65206F662074686520696E697469616C2073697A65206F6620746865205B76696577706F72745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F7373';
wwv_flow_imp.g_varchar2_table(4510) := '6172792F76696577706F7274202276696577706F72743A20412076696577706F727420726570726573656E7473206120706F6C79676F6E616C20286E6F726D616C6C792072656374616E67756C617229206172656120696E20636F6D7075746572206772';
wwv_flow_imp.g_varchar2_table(4511) := '61706869637320746861742069732063757272656E746C79206265696E67207669657765642E20496E207765622062726F77736572207465726D732C2069742072656665727320746F207468652070617274206F662074686520646F63756D656E742079';
wwv_flow_imp.g_varchar2_table(4512) := '6F755C2772652076696577696E672077686963682069732063757272656E746C792076697369626C6520696E206974732077696E646F7720286F72207468652073637265656E2C2069662074686520646F63756D656E74206973206265696E6720766965';
wwv_flow_imp.g_varchar2_table(4513) := '77656420696E2066756C6C2073637265656E206D6F6465292E20436F6E74656E74206F757473696465207468652076696577706F7274206973206E6F742076697369626C65206F6E73637265656E20756E74696C207363726F6C6C656420696E746F2076';
wwv_flow_imp.g_varchar2_table(4514) := '6965772E22292E2055736564206279206D6F62696C652064657669636573206F6E6C792E5C6E202020205C6E2020202056616C75657320666F722074686520636F6E74656E74206F6620603C6D657461206E616D653D2276696577706F7274223E605C6E';
wwv_flow_imp.g_varchar2_table(4515) := '202020205C6E2020202056616C75655C6E202020205C6E20202020506F737369626C652073756276616C7565735C6E202020205C6E202020204465736372697074696F6E5C6E202020205C6E20202020607769647468605C6E202020205C6E2020202041';
wwv_flow_imp.g_varchar2_table(4516) := '20706F73697469766520696E7465676572206E756D6265722C206F7220746865207465787420606465766963652D7769647468605C6E202020205C6E20202020446566696E65732074686520706978656C207769647468206F6620746865207669657770';
wwv_flow_imp.g_varchar2_table(4517) := '6F7274207468617420796F752077616E742074686520776562207369746520746F2062652072656E64657265642061742E5C6E202020205C6E2020202060686569676874605C6E202020205C6E202020204120706F73697469766520696E74656765722C';
wwv_flow_imp.g_varchar2_table(4518) := '206F7220746865207465787420606465766963652D686569676874605C6E202020205C6E20202020446566696E65732074686520686569676874206F66207468652076696577706F72742E204E6F74207573656420627920616E792062726F777365722E';
wwv_flow_imp.g_varchar2_table(4519) := '5C6E202020205C6E2020202060696E697469616C2D7363616C65605C6E202020205C6E202020204120706F736974697665206E756D626572206265747765656E2060302E306020616E64206031302E30605C6E202020205C6E20202020446566696E6573';
wwv_flow_imp.g_varchar2_table(4520) := '2074686520726174696F206265747765656E20746865206465766963652077696474682028606465766963652D77696474686020696E20706F727472616974206D6F6465206F7220606465766963652D6865696768746020696E206C616E647363617065';
wwv_flow_imp.g_varchar2_table(4521) := '206D6F64652920616E64207468652076696577706F72742073697A652E5C6E202020205C6E20202020606D6178696D756D2D7363616C65605C6E202020205C6E202020204120706F736974697665206E756D626572206265747765656E2060302E306020';
wwv_flow_imp.g_varchar2_table(4522) := '616E64206031302E30605C6E202020205C6E20202020446566696E657320746865206D6178696D756D20616D6F756E7420746F207A6F6F6D20696E2E204974206D7573742062652067726561746572206F7220657175616C20746F2074686520606D696E';
wwv_flow_imp.g_varchar2_table(4523) := '696D756D2D7363616C6560206F7220746865206265686176696F757220697320756E646566696E65642E2042726F777365722073657474696E67732063616E2069676E6F726520746869732072756C6520616E6420694F5331302B2069676E6F72657320';
wwv_flow_imp.g_varchar2_table(4524) := '69742062792064656661756C742E5C6E202020205C6E20202020606D696E696D756D2D7363616C65605C6E202020205C6E202020204120706F736974697665206E756D626572206265747765656E2060302E306020616E64206031302E30605C6E202020';
wwv_flow_imp.g_varchar2_table(4525) := '205C6E20202020446566696E657320746865206D696E696D756D207A6F6F6D206C6576656C2E204974206D75737420626520736D616C6C6572206F7220657175616C20746F2074686520606D6178696D756D2D7363616C6560206F722074686520626568';
wwv_flow_imp.g_varchar2_table(4526) := '6176696F757220697320756E646566696E65642E2042726F777365722073657474696E67732063616E2069676E6F726520746869732072756C6520616E6420694F5331302B2069676E6F7265732069742062792064656661756C742E5C6E202020205C6E';
wwv_flow_imp.g_varchar2_table(4527) := '2020202060757365722D7363616C61626C65605C6E202020205C6E202020206079657360206F7220606E6F605C6E202020205C6E2020202049662073657420746F20606E6F602C207468652075736572206973206E6F742061626C6520746F207A6F6F6D';
wwv_flow_imp.g_varchar2_table(4528) := '20696E2074686520776562706167652E205468652064656661756C742069732060796573602E2042726F777365722073657474696E67732063616E2069676E6F726520746869732072756C652C20616E6420694F5331302B2069676E6F72657320697420';
wwv_flow_imp.g_varchar2_table(4529) := '62792064656661756C742E5C6E202020205C6E2020202053706563696669636174696F6E5C6E202020205C6E202020205374617475735C6E202020205C6E20202020436F6D6D656E745C6E202020205C6E202020205B4353532044657669636520416461';
wwv_flow_imp.g_varchar2_table(4530) := '70746174696F6E20205C6E2020202054686520646566696E6974696F6E206F66205C273C6D657461206E616D653D2276696577706F7274223E5C2720696E20746861742073706563696669636174696F6E2E5D2868747470733A2F2F6472616674732E63';
wwv_flow_imp.g_varchar2_table(4531) := '737377672E6F72672F6373732D6465766963652D61646170742F2376696577706F72742D6D657461295C6E202020205C6E20202020576F726B696E672044726166745C6E202020205C6E202020204E6F6E2D6E6F726D61746976656C7920646573637269';
wwv_flow_imp.g_varchar2_table(4532) := '626573207468652056696577706F7274204D45544120656C656D656E745C6E202020205C6E2020202053656520616C736F3A205B604076696577706F7274605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D5553';
wwv_flow_imp.g_varchar2_table(4533) := '2F646F63732F5765622F4353532F4076696577706F72742022546865204076696577706F7274204353532061742D72756C65206C65747320796F7520636F6E666967757265207468652076696577706F7274207468726F75676820776869636820746865';
wwv_flow_imp.g_varchar2_table(4534) := '20646F63756D656E74206973207669657765642E2049745C2773207072696D6172696C79207573656420666F72206D6F62696C6520646576696365732C2062757420697320616C736F2075736564206279206465736B746F702062726F77736572732074';
wwv_flow_imp.g_varchar2_table(4535) := '68617420737570706F7274206665617475726573206C696B652022736E617020746F206564676522202873756368206173204D6963726F736F66742045646765292E22295C6E202020205C6E202020202A2A4E6F7465733A2A2A5C6E202020205C6E2020';
wwv_flow_imp.g_varchar2_table(4536) := '20202A20202054686F75676820756E7374616E64617264697A65642C2074686973206465636C61726174696F6E20697320726573706563746564206279206D6F7374206D6F62696C652062726F77736572732064756520746F2064652D666163746F2064';
wwv_flow_imp.g_varchar2_table(4537) := '6F6D696E616E63652E5C6E202020202A2020205468652064656661756C742076616C756573206D61792076617279206265747765656E206465766963657320616E642062726F77736572732E5C6E202020202A202020546F206C6561726E2061626F7574';
wwv_flow_imp.g_varchar2_table(4538) := '2074686973206465636C61726174696F6E20696E2046697265666F7820666F72204D6F62696C652C20736565205B746869732061727469636C655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F6373';
wwv_flow_imp.g_varchar2_table(4539) := '2F4D6F62696C652F56696577706F72745F6D6574615F74616720224D6F62696C652F56696577706F7274206D6574612074616722292E277D7D2C7B6E616D653A22687474702D6571756976222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(4540) := '646F776E222C76616C75653A27446566696E6573206120707261676D61206469726563746976652E2054686520617474726962757465206973206E616D656420602A2A687474702D65717569762A2A28616C656E742960206265636175736520616C6C20';
wwv_flow_imp.g_varchar2_table(4541) := '74686520616C6C6F7765642076616C75657320617265206E616D6573206F6620706172746963756C6172204854545020686561646572733A5C6E5C6E2A2020206022636F6E74656E742D6C616E6775616765226020205C6E20202020446566696E657320';
wwv_flow_imp.g_varchar2_table(4542) := '7468652064656661756C74206C616E6775616765206F662074686520706167652E2049742063616E206265206F76657272696464656E20627920746865205B6C616E675D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(4543) := '6E2D55532F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6C616E672920617474726962757465206F6E20616E7920656C656D656E742E5C6E202020205C6E202020202A2A5761726E696E673A2A2A20446F206E6F7420';
wwv_flow_imp.g_varchar2_table(4544) := '75736520746869732076616C75652C206173206974206973206F62736F6C6574652E205072656665722074686520606C616E676020617474726962757465206F6E20746865205B603C68746D6C3E605D2868747470733A2F2F646576656C6F7065722E6D';
wwv_flow_imp.g_varchar2_table(4545) := '6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F68746D6C20225468652048544D4C203C68746D6C3E20656C656D656E7420726570726573656E74732074686520726F6F742028746F702D6C6576656C20';
wwv_flow_imp.g_varchar2_table(4546) := '656C656D656E7429206F6620616E2048544D4C20646F63756D656E742C20736F20697420697320616C736F20726566657272656420746F2061732074686520726F6F7420656C656D656E742E20416C6C206F7468657220656C656D656E7473206D757374';
wwv_flow_imp.g_varchar2_table(4547) := '2062652064657363656E64616E7473206F66207468697320656C656D656E742E222920656C656D656E742E5C6E202020205C6E2A2020206022636F6E74656E742D73656375726974792D706F6C696379226020205C6E20202020416C6C6F777320706167';
wwv_flow_imp.g_varchar2_table(4548) := '6520617574686F727320746F20646566696E652061205B636F6E74656E7420706F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F53656375726974792F4353502F435350';
wwv_flow_imp.g_varchar2_table(4549) := '5F706F6C6963795F646972656374697665732920666F72207468652063757272656E7420706167652E20436F6E74656E7420706F6C6963696573206D6F73746C79207370656369667920616C6C6F77656420736572766572206F726967696E7320616E64';
wwv_flow_imp.g_varchar2_table(4550) := '2073637269707420656E64706F696E74732077686963682068656C7020677561726420616761696E73742063726F73732D7369746520736372697074696E672061747461636B732E5C6E2A2020206022636F6E74656E742D74797065226020205C6E2020';
wwv_flow_imp.g_varchar2_table(4551) := '2020446566696E657320746865205B4D494D4520747970655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4D494D455F7479706529206F662074686520646F63756D65';
wwv_flow_imp.g_varchar2_table(4552) := '6E742C20666F6C6C6F776564206279206974732063686172616374657220656E636F64696E672E20497420666F6C6C6F7773207468652073616D652073796E7461782061732074686520485454502060636F6E74656E742D747970656020656E74697479';
wwv_flow_imp.g_varchar2_table(4553) := '2D686561646572206669656C642C2062757420617320697420697320696E7369646520612048544D4C20706167652C206D6F73742076616C756573206F74686572207468616E2060746578742F68746D6C602061726520696D706F737369626C652E2054';
wwv_flow_imp.g_varchar2_table(4554) := '68657265666F7265207468652076616C69642073796E74617820666F72206974732060636F6E74656E74602069732074686520737472696E67205C2760746578742F68746D6C605C2720666F6C6C6F776564206279206120636861726163746572207365';
wwv_flow_imp.g_varchar2_table(4555) := '7420776974682074686520666F6C6C6F77696E672073796E7461783A205C27603B20636861727365743D5F49414E41636861727365745F605C272C207768657265206049414E41636861727365746020697320746865205F707265666572726564204D49';
wwv_flow_imp.g_varchar2_table(4556) := '4D45206E616D655F20666F7220612063686172616374657220736574206173205B646566696E6564206279207468652049414E412E5D2868747470733A2F2F7777772E69616E612E6F72672F61737369676E6D656E74732F6368617261637465722D7365';
wwv_flow_imp.g_varchar2_table(4557) := '7473295C6E202020205C6E202020202A2A5761726E696E673A2A2A20446F206E6F742075736520746869732076616C75652C206173206974206973206F62736F6C6574652E2055736520746865205B6063686172736574605D2868747470733A2F2F6465';
wwv_flow_imp.g_varchar2_table(4558) := '76656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D636861727365742920617474726962757465206F6E20746865205B603C6D6574613E605D286874747073';
wwv_flow_imp.g_varchar2_table(4559) := '3A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746120225468652048544D4C203C6D6574613E20656C656D656E7420726570726573656E7473206D6574616461';
wwv_flow_imp.g_varchar2_table(4560) := '746120746861742063616E6E6F7420626520726570726573656E746564206279206F746865722048544D4C206D6574612D72656C6174656420656C656D656E74732C206C696B65203C626173653E2C203C6C696E6B3E2C203C7363726970743E2C203C73';
wwv_flow_imp.g_varchar2_table(4561) := '74796C653E206F72203C7469746C653E2E222920656C656D656E742E5C6E202020205C6E202020202A2A4E6F74653A2A2A204173205B603C6D6574613E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F';
wwv_flow_imp.g_varchar2_table(4562) := '646F63732F5765622F48544D4C2F456C656D656E742F6D65746120225468652048544D4C203C6D6574613E20656C656D656E7420726570726573656E7473206D6574616461746120746861742063616E6E6F7420626520726570726573656E7465642062';
wwv_flow_imp.g_varchar2_table(4563) := '79206F746865722048544D4C206D6574612D72656C6174656420656C656D656E74732C206C696B65203C626173653E2C203C6C696E6B3E2C203C7363726970743E2C203C7374796C653E206F72203C7469746C653E2E22292063616E5C2774206368616E';
wwv_flow_imp.g_varchar2_table(4564) := '676520646F63756D656E74735C2720747970657320696E205848544D4C206F722048544D4C355C2773205848544D4C2073657269616C697A6174696F6E2C206E657665722073657420746865204D494D45207479706520746F20616E205848544D4C204D';
wwv_flow_imp.g_varchar2_table(4565) := '494D452074797065207769746820603C6D6574613E602E5C6E202020205C6E2A202020602272656672657368226020205C6E202020205468697320696E737472756374696F6E207370656369666965733A5C6E202020202A202020546865206E756D6265';
wwv_flow_imp.g_varchar2_table(4566) := '72206F66207365636F6E647320756E74696C2074686520706167652073686F756C642062652072656C6F61646564202D206F6E6C7920696620746865205B60636F6E74656E74605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F';
wwv_flow_imp.g_varchar2_table(4567) := '72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D636F6E74656E74292061747472696275746520636F6E7461696E73206120706F73697469766520696E74656765722E5C6E202020202A2020205468';
wwv_flow_imp.g_varchar2_table(4568) := '65206E756D626572206F66207365636F6E647320756E74696C2074686520706167652073686F756C6420726564697265637420746F20616E6F74686572202D206F6E6C7920696620746865205B60636F6E74656E74605D2868747470733A2F2F64657665';
wwv_flow_imp.g_varchar2_table(4569) := '6C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D636F6E74656E74292061747472696275746520636F6E7461696E73206120706F73697469766520696E746567';
wwv_flow_imp.g_varchar2_table(4570) := '657220666F6C6C6F7765642062792074686520737472696E67205C27603B75726C3D605C272C20616E6420612076616C69642055524C2E5C6E2A20202060227365742D636F6F6B6965226020205C6E20202020446566696E65732061205B636F6F6B6965';
wwv_flow_imp.g_varchar2_table(4571) := '5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F636F6F6B69652920666F722074686520706167652E2049747320636F6E74656E74206D75737420666F6C6C6F77207468652073796E74617820';
wwv_flow_imp.g_varchar2_table(4572) := '646566696E656420696E20746865205B49455446204854545020436F6F6B69652053706563696669636174696F6E5D2868747470733A2F2F746F6F6C732E696574662E6F72672F68746D6C2F64726166742D696574662D6874747073746174652D636F6F';
wwv_flow_imp.g_varchar2_table(4573) := '6B69652D3134292E5C6E202020205C6E202020202A2A5761726E696E673A2A2A20446F206E6F7420757365207468697320696E737472756374696F6E2C206173206974206973206F62736F6C6574652E2055736520746865204854545020686561646572';
wwv_flow_imp.g_varchar2_table(4574) := '205B605365742D436F6F6B6965605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F5365742D436F6F6B69652920696E73746561642E277D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(4575) := '616D653A22636F6E74656E74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520636F6E7461696E73207468652076616C756520666F7220746865205B60687474702D65';
wwv_flow_imp.g_varchar2_table(4576) := '71756976605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D687474702D657175697629206F72205B606E616D65605D2868';
wwv_flow_imp.g_varchar2_table(4577) := '747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D6E616D6529206174747269627574652C20646570656E64696E67206F6E20776869';
wwv_flow_imp.g_varchar2_table(4578) := '636820697320757365642E227D7D2C7B6E616D653A2263686172736574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320617474726962757465206465636C617265732074686520706167655C';
wwv_flow_imp.g_varchar2_table(4579) := '27732063686172616374657220656E636F64696E672E204974206D75737420636F6E7461696E2061205B7374616E646172642049414E41204D494D45206E616D6520666F722063686172616374657220656E636F64696E67735D2868747470733A2F2F77';
wwv_flow_imp.g_varchar2_table(4580) := '77772E69616E612E6F72672F61737369676E6D656E74732F6368617261637465722D73657473292E20416C74686F75676820746865207374616E6461726420646F65736E5C27742072657175657374206120737065636966696320656E636F64696E672C';
wwv_flow_imp.g_varchar2_table(4581) := '2069742073756767657374733A5C6E5C6E2A202020417574686F72732061726520656E636F75726167656420746F20757365205B605554462D38605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63';
wwv_flow_imp.g_varchar2_table(4582) := '732F476C6F73736172792F5554462D38292E5C6E2A202020417574686F72732073686F756C64206E6F74207573652041534349492D696E636F6D70617469626C6520656E636F64696E677320746F2061766F6964207365637572697479207269736B3A20';
wwv_flow_imp.g_varchar2_table(4583) := '62726F7773657273206E6F7420737570706F7274696E67207468656D206D617920696E74657270726574206861726D66756C20636F6E74656E742061732048544D4C2E20546869732068617070656E7320776974682074686520604A49535F4336323236';
wwv_flow_imp.g_varchar2_table(4584) := '2D31393833602C20604A49535F58303231322D31393930602C2060485A2D47422D32333132602C20604A4F484142602C207468652049534F2D323032322066616D696C7920616E6420746865204542434449432066616D696C792E5C6E5C6E2A2A4E6F74';
wwv_flow_imp.g_varchar2_table(4585) := '653A2A2A2041534349492D696E636F6D70617469626C6520656E636F64696E6773206172652074686F7365207468617420646F6E5C2774206D61702074686520382D62697420636F646520706F696E74732060307832306020746F206030783745602074';
wwv_flow_imp.g_varchar2_table(4586) := '6F2074686520603078303032306020746F20603078303037456020556E69636F646520636F646520706F696E7473295C6E5C6E2A202020417574686F7273202A2A6D757374206E6F742A2A207573652060434553552D38602C20605554462D37602C2060';
wwv_flow_imp.g_varchar2_table(4587) := '424F43552D316020616E642F6F7220605343535560206173205B63726F73732D7369746520736372697074696E675D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4372';
wwv_flow_imp.g_varchar2_table(4588) := '6F73732D736974655F736372697074696E67292061747461636B73207769746820746865736520656E636F64696E67732068617665206265656E2064656D6F6E737472617465642E5C6E2A202020417574686F72732073686F756C64206E6F7420757365';
wwv_flow_imp.g_varchar2_table(4589) := '20605554462D3332602062656361757365206E6F7420616C6C2048544D4C3520656E636F64696E6720616C676F726974686D732063616E2064697374696E67756973682069742066726F6D20605554462D3136602E5C6E5C6E2A2A4E6F7465733A2A2A5C';
wwv_flow_imp.g_varchar2_table(4590) := '6E5C6E2A202020546865206465636C617265642063686172616374657220656E636F64696E67206D757374206D6174636820746865206F6E6520746865207061676520776173207361766564207769746820746F2061766F696420676172626C65642063';
wwv_flow_imp.g_varchar2_table(4591) := '68617261637465727320616E6420736563757269747920686F6C65732E5C6E2A202020546865205B603C6D6574613E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F';
wwv_flow_imp.g_varchar2_table(4592) := '456C656D656E742F6D65746120225468652048544D4C203C6D6574613E20656C656D656E7420726570726573656E7473206D6574616461746120746861742063616E6E6F7420626520726570726573656E746564206279206F746865722048544D4C206D';
wwv_flow_imp.g_varchar2_table(4593) := '6574612D72656C6174656420656C656D656E74732C206C696B65203C626173653E2C203C6C696E6B3E2C203C7363726970743E2C203C7374796C653E206F72203C7469746C653E2E222920656C656D656E74206465636C6172696E672074686520656E63';
wwv_flow_imp.g_varchar2_table(4594) := '6F64696E67206D75737420626520696E7369646520746865205B603C686561643E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F686561642022';
wwv_flow_imp.g_varchar2_table(4595) := '5468652048544D4C203C686561643E20656C656D656E742070726F76696465732067656E6572616C20696E666F726D6174696F6E20286D65746164617461292061626F75742074686520646F63756D656E742C20696E636C7564696E6720697473207469';
wwv_flow_imp.g_varchar2_table(4596) := '746C6520616E64206C696E6B7320746F20697473C2A07363726970747320616E64207374796C65207368656574732E222920656C656D656E7420616E64202A2A77697468696E2074686520666972737420313032342062797465732A2A206F6620746865';
wwv_flow_imp.g_varchar2_table(4597) := '2048544D4C20617320736F6D652062726F7773657273206F6E6C79206C6F6F6B2061742074686F7365206279746573206265666F72652063686F6F73696E6720616E20656E636F64696E672E5C6E2A20202054686973205B603C6D6574613E605D286874';
wwv_flow_imp.g_varchar2_table(4598) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746120225468652048544D4C203C6D6574613E20656C656D656E7420726570726573656E7473206D6574';
wwv_flow_imp.g_varchar2_table(4599) := '616461746120746861742063616E6E6F7420626520726570726573656E746564206279206F746865722048544D4C206D6574612D72656C6174656420656C656D656E74732C206C696B65203C626173653E2C203C6C696E6B3E2C203C7363726970743E2C';
wwv_flow_imp.g_varchar2_table(4600) := '203C7374796C653E206F72203C7469746C653E2E222920656C656D656E74206973206F6E6C79206F6E652070617274206F6620746865205B616C676F726974686D20746F2064657465726D696E65206120706167655C2773206368617261637465722073';
wwv_flow_imp.g_varchar2_table(4601) := '65745D2868747470733A2F2F7777772E7768617477672E6F72672F73706563732F7765622D617070732F63757272656E742D776F726B2F6D756C7469706167652F70617273696E672E68746D6C23656E636F64696E672D736E696666696E672D616C676F';
wwv_flow_imp.g_varchar2_table(4602) := '726974686D2022416C676F726974686D2063686172736574207061676522292E20546865205B60436F6E74656E742D5479706560206865616465725D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63';
wwv_flow_imp.g_varchar2_table(4603) := '732F5765622F485454502F486561646572732F436F6E74656E742D547970652920616E6420616E79205B427974652D4F72646572204D61726B735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F6373';
wwv_flow_imp.g_varchar2_table(4604) := '2F476C6F73736172792F427974652D4F726465725F4D61726B202254686520646566696E6974696F6E206F662074686174207465726D2028427974652D4F72646572204D61726B732920686173206E6F74206265656E207772697474656E207965743B20';
wwv_flow_imp.g_varchar2_table(4605) := '706C6561736520636F6E736964657220636F6E747269627574696E67206974212229206F76657272696465207468697320656C656D656E742E5C6E2A2020204974206973207374726F6E676C79207265636F6D6D656E64656420746F20646566696E6520';
wwv_flow_imp.g_varchar2_table(4606) := '7468652063686172616374657220656E636F64696E672E204966206120706167655C277320656E636F64696E6720697320756E646566696E65642C2063726F73732D736372697074696E6720746563686E69717565732061726520706F737369626C652C';
wwv_flow_imp.g_varchar2_table(4607) := '207375636820617320746865205B605554462D37602066616C6C6261636B2063726F73732D736372697074696E6720746563686E697175655D2868747470733A2F2F636F64652E676F6F676C652E636F6D2F702F646F63747970652D6D6972726F722F77';
wwv_flow_imp.g_varchar2_table(4608) := '696B692F41727469636C6555746637292E5C6E2A202020546865205B603C6D6574613E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D657461';
wwv_flow_imp.g_varchar2_table(4609) := '20225468652048544D4C203C6D6574613E20656C656D656E7420726570726573656E7473206D6574616461746120746861742063616E6E6F7420626520726570726573656E746564206279206F746865722048544D4C206D6574612D72656C6174656420';
wwv_flow_imp.g_varchar2_table(4610) := '656C656D656E74732C206C696B65203C626173653E2C203C6C696E6B3E2C203C7363726970743E2C203C7374796C653E206F72203C7469746C653E2E222920656C656D656E74207769746820612060636861727365746020617474726962757465206973';
wwv_flow_imp.g_varchar2_table(4611) := '20612073796E6F6E796D20666F7220746865207072652D48544D4C3520603C6D65746120687474702D65717569763D22436F6E74656E742D547970652220636F6E74656E743D22746578742F68746D6C3B20636861727365743D5F49414E416368617273';
wwv_flow_imp.g_varchar2_table(4612) := '65745F223E602C207768657265205F6049414E4163686172736574605F20636F6E7461696E73207468652076616C7565206F6620746865206571756976616C656E74205B6063686172736574605D2868747470733A2F2F646576656C6F7065722E6D6F7A';
wwv_flow_imp.g_varchar2_table(4613) := '696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D6368617273657429206174747269627574652E20546869732073796E746178206973207374696C6C20616C6C6F7765642C20616C74';
wwv_flow_imp.g_varchar2_table(4614) := '686F756768206E6F206C6F6E676572207265636F6D6D656E6465642E277D7D2C7B6E616D653A22736368656D65222C6465736372697074696F6E3A22546869732061747472696275746520646566696E65732074686520736368656D6520696E20776869';
wwv_flow_imp.g_varchar2_table(4615) := '6368206D65746164617461206973206465736372696265642E204120736368656D65206973206120636F6E74657874206C656164696E6720746F2074686520636F727265637420696E746572707265746174696F6E73206F6620746865205B60636F6E74';
wwv_flow_imp.g_varchar2_table(4616) := '656E74605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D65746123617474722D636F6E74656E74292076616C75652C206C696B65206120666F72';
wwv_flow_imp.g_varchar2_table(4617) := '6D61742E5C6E5C6E2A2A5761726E696E673A2A2A20446F206E6F742075736520746869732076616C75652C206173206974206973206F62736F6C6574652E205468657265206973206E6F207265706C6163656D656E742061732074686572652077617320';
wwv_flow_imp.g_varchar2_table(4618) := '6E6F207265616C20757361676520666F722069742E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F57';
wwv_flow_imp.g_varchar2_table(4619) := '65622F48544D4C2F456C656D656E742F6D657461227D5D7D2C7B6E616D653A227374796C65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207374796C6520656C656D656E7420616C6C6F777320';
wwv_flow_imp.g_varchar2_table(4620) := '617574686F727320746F20656D626564207374796C6520696E666F726D6174696F6E20696E20746865697220646F63756D656E74732E20546865207374796C6520656C656D656E74206973206F6E65206F66207365766572616C20696E7075747320746F';
wwv_flow_imp.g_varchar2_table(4621) := '20746865207374796C696E672070726F63657373696E67206D6F64656C2E2054686520656C656D656E7420646F6573206E6F7420726570726573656E7420636F6E74656E7420666F722074686520757365722E227D2C617474726962757465733A5B7B6E';
wwv_flow_imp.g_varchar2_table(4622) := '616D653A226D65646961222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520646566696E6573207768696368206D6564696120746865207374796C652073686F756C6420';
wwv_flow_imp.g_varchar2_table(4623) := '6265206170706C69656420746F2E204974732076616C75652069732061205B6D656469612071756572795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F47756964652F4353532F4D';
wwv_flow_imp.g_varchar2_table(4624) := '656469615F71756572696573292C2077686963682064656661756C747320746F2060616C6C602069662074686520617474726962757465206973206D697373696E672E227D7D2C7B6E616D653A226E6F6E6365222C6465736372697074696F6E3A7B6B69';
wwv_flow_imp.g_varchar2_table(4625) := '6E643A226D61726B646F776E222C76616C75653A22412063727970746F67726170686963206E6F6E636520286E756D6265722075736564206F6E636529207573656420746F2077686974656C69737420696E6C696E65207374796C657320696E2061205B';
wwv_flow_imp.g_varchar2_table(4626) := '7374796C652D73726320436F6E74656E742D53656375726974792D506F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F436F6E74656E74';
wwv_flow_imp.g_varchar2_table(4627) := '2D53656375726974792D506F6C6963792F7374796C652D737263292E2054686520736572766572206D7573742067656E6572617465206120756E69717565206E6F6E63652076616C756520656163682074696D65206974207472616E736D697473206120';
wwv_flow_imp.g_varchar2_table(4628) := '706F6C6963792E20497420697320637269746963616C20746F2070726F766964652061206E6F6E636520746861742063616E6E6F74206265206775657373656420617320627970617373696E672061207265736F75726365E280997320706F6C69637920';
wwv_flow_imp.g_varchar2_table(4629) := '6973206F7468657277697365207472697669616C2E227D7D2C7B6E616D653A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520646566696E657320746865';
wwv_flow_imp.g_varchar2_table(4630) := '207374796C696E67206C616E67756167652061732061204D494D4520747970652028636861727365742073686F756C64206E6F7420626520737065636966696564292E205468697320617474726962757465206973206F7074696F6E616C20616E642064';
wwv_flow_imp.g_varchar2_table(4631) := '656661756C747320746F2060746578742F63737360206966206974206973206E6F742073706563696669656420E280942074686572652069732076657279206C6974746C6520726561736F6E20746F20696E636C756465207468697320696E206D6F6465';
wwv_flow_imp.g_varchar2_table(4632) := '726E2077656220646F63756D656E74732E227D7D2C7B6E616D653A2273636F706564222C76616C75655365743A2276227D2C7B6E616D653A227469746C65222C6465736372697074696F6E3A225468697320617474726962757465207370656369666965';
wwv_flow_imp.g_varchar2_table(4633) := '73205B616C7465726E6174697665207374796C652073686565745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F416C7465726E61746976655F7374796C655F7368656574';
wwv_flow_imp.g_varchar2_table(4634) := '732920736574732E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D65';
wwv_flow_imp.g_varchar2_table(4635) := '6E742F7374796C65227D5D7D2C7B6E616D653A22626F6479222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520626F647920656C656D656E7420726570726573656E74732074686520636F6E74656E';
wwv_flow_imp.g_varchar2_table(4636) := '74206F662074686520646F63756D656E742E227D2C617474726962757465733A5B7B6E616D653A226F6E61667465727072696E74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E2074';
wwv_flow_imp.g_varchar2_table(4637) := '6F2063616C6C20616674657220746865207573657220686173207072696E7465642074686520646F63756D656E742E227D7D2C7B6E616D653A226F6E6265666F72657072696E74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E';
wwv_flow_imp.g_varchar2_table(4638) := '222C76616C75653A2246756E6374696F6E20746F2063616C6C207768656E207468652075736572207265717565737473207072696E74696E67206F662074686520646F63756D656E742E227D7D2C7B6E616D653A226F6E6265666F7265756E6C6F616422';
wwv_flow_imp.g_varchar2_table(4639) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E20746F2063616C6C207768656E2074686520646F63756D656E742069732061626F757420746F20626520756E6C6F616465642E227D7D2C';
wwv_flow_imp.g_varchar2_table(4640) := '7B6E616D653A226F6E686173686368616E6765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E20746F2063616C6C207768656E2074686520667261676D656E74206964656E74696669';
wwv_flow_imp.g_varchar2_table(4641) := '6572207061727420287374617274696E67207769746820746865206861736820286027232760292063686172616374657229206F662074686520646F63756D656E7427732063757272656E74206164647265737320686173206368616E6765642E227D7D';
wwv_flow_imp.g_varchar2_table(4642) := '2C7B6E616D653A226F6E6C616E67756167656368616E6765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E20746F2063616C6C207768656E2074686520707265666572726564206C61';
wwv_flow_imp.g_varchar2_table(4643) := '6E677561676573206368616E6765642E227D7D2C7B6E616D653A226F6E6D657373616765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E20746F2063616C6C207768656E2074686520';
wwv_flow_imp.g_varchar2_table(4644) := '646F63756D656E74206861732072656365697665642061206D6573736167652E227D7D2C7B6E616D653A226F6E6F66666C696E65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E2074';
wwv_flow_imp.g_varchar2_table(4645) := '6F2063616C6C207768656E206E6574776F726B20636F6D6D756E69636174696F6E20686173206661696C65642E227D7D2C7B6E616D653A226F6E6F6E6C696E65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C7565';
wwv_flow_imp.g_varchar2_table(4646) := '3A2246756E6374696F6E20746F2063616C6C207768656E206E6574776F726B20636F6D6D756E69636174696F6E20686173206265656E20726573746F7265642E227D7D2C7B6E616D653A226F6E7061676568696465227D2C7B6E616D653A226F6E706167';
wwv_flow_imp.g_varchar2_table(4647) := '6573686F77227D2C7B6E616D653A226F6E706F707374617465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E20746F2063616C6C207768656E20746865207573657220686173206E61';
wwv_flow_imp.g_varchar2_table(4648) := '766967617465642073657373696F6E20686973746F72792E227D7D2C7B6E616D653A226F6E73746F72616765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E20746F2063616C6C2077';
wwv_flow_imp.g_varchar2_table(4649) := '68656E207468652073746F72616765206172656120686173206368616E6765642E227D7D2C7B6E616D653A226F6E756E6C6F6164222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2246756E6374696F6E2074';
wwv_flow_imp.g_varchar2_table(4650) := '6F2063616C6C207768656E2074686520646F63756D656E7420697320676F696E6720617761792E227D7D2C7B6E616D653A22616C696E6B222C6465736372697074696F6E3A27436F6C6F72206F66207465787420666F722068797065726C696E6B732077';
wwv_flow_imp.g_varchar2_table(4651) := '68656E2073656C65637465642E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B60636F6C6F72605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F';
wwv_flow_imp.g_varchar2_table(4652) := '646F63732F5765622F4353532F636F6C6F72202254686520636F6C6F72204353532070726F706572747920736574732074686520666F726567726F756E6420636F6C6F722076616C7565206F6620616E20656C656D656E745C2773207465787420616E64';
wwv_flow_imp.g_varchar2_table(4653) := '2074657874206465636F726174696F6E732C20616E642073657473207468652063757272656E74636F6C6F722076616C75652E22292070726F706572747920696E20636F6E6A756E6374696F6E207769746820746865205B603A616374697665605D2868';
wwv_flow_imp.g_varchar2_table(4654) := '747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F3A6163746976652022546865203A616374697665204353532070736575646F2D636C61737320726570726573656E747320616E20';
wwv_flow_imp.g_varchar2_table(4655) := '656C656D656E74202873756368206173206120627574746F6E292074686174206973206265696E67206163746976617465642062792074686520757365722E22292070736575646F2D636C61737320696E73746561642E5F277D2C7B6E616D653A226261';
wwv_flow_imp.g_varchar2_table(4656) := '636B67726F756E64222C6465736372697074696F6E3A27555249206F66206120696D61676520746F207573652061732061206261636B67726F756E642E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C20757365204353';
wwv_flow_imp.g_varchar2_table(4657) := '53205B606261636B67726F756E64605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6261636B67726F756E642022546865206261636B67726F756E642073686F72746861';
wwv_flow_imp.g_varchar2_table(4658) := '6E64204353532070726F7065727479207365747320616C6C206261636B67726F756E64207374796C652070726F70657274696573206174206F6E63652C207375636820617320636F6C6F722C20696D6167652C206F726967696E20616E642073697A652C';
wwv_flow_imp.g_varchar2_table(4659) := '206F7220726570656174206D6574686F642E22292070726F7065727479206F6E2074686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A226267636F6C6F72222C6465736372697074696F6E3A274261636B67726F756E6420636F6C';
wwv_flow_imp.g_varchar2_table(4660) := '6F7220666F722074686520646F63756D656E742E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B606261636B67726F756E642D636F6C6F72605D2868747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(4661) := '6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6261636B67726F756E642D636F6C6F722022546865206261636B67726F756E642D636F6C6F72204353532070726F7065727479207365747320746865206261636B67726F75';
wwv_flow_imp.g_varchar2_table(4662) := '6E6420636F6C6F72206F6620616E20656C656D656E742E22292070726F7065727479206F6E2074686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A22626F74746F6D6D617267696E222C6465736372697074696F6E3A2754686520';
wwv_flow_imp.g_varchar2_table(4663) := '6D617267696E206F662074686520626F74746F6D206F662074686520626F64792E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B606D617267696E2D626F74746F6D605D2868747470733A2F2F';
wwv_flow_imp.g_varchar2_table(4664) := '646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6D617267696E2D626F74746F6D2022546865206D617267696E2D626F74746F6D204353532070726F7065727479207365747320746865206D617267';
wwv_flow_imp.g_varchar2_table(4665) := '696E2061726561206F6E2074686520626F74746F6D206F6620616E20656C656D656E742E204120706F7369746976652076616C756520706C6163657320697420666172746865722066726F6D20697473206E65696768626F72732C207768696C65206120';
wwv_flow_imp.g_varchar2_table(4666) := '6E656761746976652076616C756520706C6163657320697420636C6F7365722E22292070726F7065727479206F6E2074686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A226C6566746D617267696E222C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(4667) := '6E3A27546865206D617267696E206F6620746865206C656674206F662074686520626F64792E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B606D617267696E2D6C656674605D286874747073';
wwv_flow_imp.g_varchar2_table(4668) := '3A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6D617267696E2D6C6566742022546865206D617267696E2D6C656674204353532070726F7065727479207365747320746865206D61726769';
wwv_flow_imp.g_varchar2_table(4669) := '6E2061726561206F6E20746865206C6566742073696465206F6620616E20656C656D656E742E204120706F7369746976652076616C756520706C6163657320697420666172746865722066726F6D20697473206E65696768626F72732C207768696C6520';
wwv_flow_imp.g_varchar2_table(4670) := '61206E656761746976652076616C756520706C6163657320697420636C6F7365722E22292070726F7065727479206F6E2074686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A226C696E6B222C6465736372697074696F6E3A2743';
wwv_flow_imp.g_varchar2_table(4671) := '6F6C6F72206F66207465787420666F7220756E7669736974656420687970657274657874206C696E6B732E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B60636F6C6F72605D2868747470733A';
wwv_flow_imp.g_varchar2_table(4672) := '2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F636F6C6F72202254686520636F6C6F72204353532070726F706572747920736574732074686520666F726567726F756E6420636F6C6F722076';
wwv_flow_imp.g_varchar2_table(4673) := '616C7565206F6620616E20656C656D656E745C2773207465787420616E642074657874206465636F726174696F6E732C20616E642073657473207468652063757272656E74636F6C6F722076616C75652E22292070726F706572747920696E20636F6E6A';
wwv_flow_imp.g_varchar2_table(4674) := '756E6374696F6E207769746820746865205B603A6C696E6B605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F3A6C696E6B2022546865203A6C696E6B2043535320707365';
wwv_flow_imp.g_varchar2_table(4675) := '75646F2D636C61737320726570726573656E747320616E20656C656D656E74207468617420686173206E6F7420796574206265656E20766973697465642E204974206D61746368657320657665727920756E76697369746564203C613E2C203C61726561';
wwv_flow_imp.g_varchar2_table(4676) := '3E2C206F72203C6C696E6B3E20656C656D656E7420746861742068617320616E2068726566206174747269627574652E22292070736575646F2D636C61737320696E73746561642E5F277D2C7B6E616D653A226F6E626C7572222C646573637269707469';
wwv_flow_imp.g_varchar2_table(4677) := '6F6E3A2246756E6374696F6E20746F2063616C6C207768656E2074686520646F63756D656E74206C6F73657320666F6375732E227D2C7B6E616D653A226F6E6572726F72222C6465736372697074696F6E3A2246756E6374696F6E20746F2063616C6C20';
wwv_flow_imp.g_varchar2_table(4678) := '7768656E2074686520646F63756D656E74206661696C7320746F206C6F61642070726F7065726C792E227D2C7B6E616D653A226F6E666F637573222C6465736372697074696F6E3A2246756E6374696F6E20746F2063616C6C207768656E207468652064';
wwv_flow_imp.g_varchar2_table(4679) := '6F63756D656E7420726563656976657320666F6375732E227D2C7B6E616D653A226F6E6C6F6164222C6465736372697074696F6E3A2246756E6374696F6E20746F2063616C6C207768656E2074686520646F63756D656E74206861732066696E69736865';
wwv_flow_imp.g_varchar2_table(4680) := '64206C6F6164696E672E227D2C7B6E616D653A226F6E7265646F222C6465736372697074696F6E3A2246756E6374696F6E20746F2063616C6C207768656E20746865207573657220686173206D6F76656420666F727761726420696E20756E646F207472';
wwv_flow_imp.g_varchar2_table(4681) := '616E73616374696F6E20686973746F72792E227D2C7B6E616D653A226F6E726573697A65222C6465736372697074696F6E3A2246756E6374696F6E20746F2063616C6C207768656E2074686520646F63756D656E7420686173206265656E20726573697A';
wwv_flow_imp.g_varchar2_table(4682) := '65642E227D2C7B6E616D653A226F6E756E646F222C6465736372697074696F6E3A2246756E6374696F6E20746F2063616C6C207768656E20746865207573657220686173206D6F766564206261636B7761726420696E20756E646F207472616E73616374';
wwv_flow_imp.g_varchar2_table(4683) := '696F6E20686973746F72792E227D2C7B6E616D653A2272696768746D617267696E222C6465736372697074696F6E3A27546865206D617267696E206F6620746865207269676874206F662074686520626F64792E205F54686973206D6574686F64206973';
wwv_flow_imp.g_varchar2_table(4684) := '206E6F6E2D636F6E666F726D696E672C2075736520435353205B606D617267696E2D7269676874605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6D617267696E2D7269';
wwv_flow_imp.g_varchar2_table(4685) := '6768742022546865206D617267696E2D7269676874204353532070726F7065727479207365747320746865206D617267696E2061726561206F6E207468652072696768742073696465206F6620616E20656C656D656E742E204120706F73697469766520';
wwv_flow_imp.g_varchar2_table(4686) := '76616C756520706C6163657320697420666172746865722066726F6D20697473206E65696768626F72732C207768696C652061206E656761746976652076616C756520706C6163657320697420636C6F7365722E22292070726F7065727479206F6E2074';
wwv_flow_imp.g_varchar2_table(4687) := '686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A2274657874222C6465736372697074696F6E3A27466F726567726F756E6420636F6C6F72206F6620746578742E205F54686973206D6574686F64206973206E6F6E2D636F6E666F';
wwv_flow_imp.g_varchar2_table(4688) := '726D696E672C2075736520435353205B60636F6C6F72605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F636F6C6F72202254686520636F6C6F72204353532070726F7065';
wwv_flow_imp.g_varchar2_table(4689) := '72747920736574732074686520666F726567726F756E6420636F6C6F722076616C7565206F6620616E20656C656D656E745C2773207465787420616E642074657874206465636F726174696F6E732C20616E642073657473207468652063757272656E74';
wwv_flow_imp.g_varchar2_table(4690) := '636F6C6F722076616C75652E22292070726F7065727479206F6E2074686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A22746F706D617267696E222C6465736372697074696F6E3A27546865206D617267696E206F662074686520';
wwv_flow_imp.g_varchar2_table(4691) := '746F70206F662074686520626F64792E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B606D617267696E2D746F70605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(4692) := '672F656E2D55532F646F63732F5765622F4353532F6D617267696E2D746F702022546865206D617267696E2D746F70204353532070726F7065727479207365747320746865206D617267696E2061726561206F6E2074686520746F70206F6620616E2065';
wwv_flow_imp.g_varchar2_table(4693) := '6C656D656E742E204120706F7369746976652076616C756520706C6163657320697420666172746865722066726F6D20697473206E65696768626F72732C207768696C652061206E656761746976652076616C756520706C6163657320697420636C6F73';
wwv_flow_imp.g_varchar2_table(4694) := '65722E22292070726F7065727479206F6E2074686520656C656D656E7420696E73746561642E5F277D2C7B6E616D653A22766C696E6B222C6465736372697074696F6E3A27436F6C6F72206F66207465787420666F722076697369746564206879706572';
wwv_flow_imp.g_varchar2_table(4695) := '74657874206C696E6B732E205F54686973206D6574686F64206973206E6F6E2D636F6E666F726D696E672C2075736520435353205B60636F6C6F72605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F';
wwv_flow_imp.g_varchar2_table(4696) := '63732F5765622F4353532F636F6C6F72202254686520636F6C6F72204353532070726F706572747920736574732074686520666F726567726F756E6420636F6C6F722076616C7565206F6620616E20656C656D656E745C2773207465787420616E642074';
wwv_flow_imp.g_varchar2_table(4697) := '657874206465636F726174696F6E732C20616E642073657473207468652063757272656E74636F6C6F722076616C75652E22292070726F706572747920696E20636F6E6A756E6374696F6E207769746820746865205B603A76697369746564605D286874';
wwv_flow_imp.g_varchar2_table(4698) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F3A766973697465642022546865203A76697369746564204353532070736575646F2D636C61737320726570726573656E7473206C69';
wwv_flow_imp.g_varchar2_table(4699) := '6E6B7320746861742074686520757365722068617320616C726561647920766973697465642E20466F72207072697661637920726561736F6E732C20746865207374796C657320746861742063616E206265206D6F646966696564207573696E67207468';
wwv_flow_imp.g_varchar2_table(4700) := '69732073656C6563746F72206172652076657279206C696D697465642E22292070736575646F2D636C61737320696E73746561642E5F277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A22687474';
wwv_flow_imp.g_varchar2_table(4701) := '70733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F626F6479227D5D7D2C7B6E616D653A2261727469636C65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F77';
wwv_flow_imp.g_varchar2_table(4702) := '6E222C76616C75653A225468652061727469636C6520656C656D656E7420726570726573656E7473206120636F6D706C6574652C206F722073656C662D636F6E7461696E65642C20636F6D706F736974696F6E20696E206120646F63756D656E742C2070';
wwv_flow_imp.g_varchar2_table(4703) := '6167652C206170706C69636174696F6E2C206F72207369746520616E6420746861742069732C20696E207072696E6369706C652C20696E646570656E64656E746C792064697374726962757461626C65206F72207265757361626C652C20652E672E2069';
wwv_flow_imp.g_varchar2_table(4704) := '6E2073796E6469636174696F6E2E205468697320636F756C64206265206120666F72756D20706F73742C2061206D6167617A696E65206F72206E65777370617065722061727469636C652C206120626C6F6720656E7472792C206120757365722D737562';
wwv_flow_imp.g_varchar2_table(4705) := '6D697474656420636F6D6D656E742C20616E20696E74657261637469766520776964676574206F72206761646765742C206F7220616E79206F7468657220696E646570656E64656E74206974656D206F6620636F6E74656E742E20456163682061727469';
wwv_flow_imp.g_varchar2_table(4706) := '636C652073686F756C64206265206964656E7469666965642C207479706963616C6C7920627920696E636C7564696E6720612068656164696E6720286831E28093683620656C656D656E74292061732061206368696C64206F6620746865206172746963';
wwv_flow_imp.g_varchar2_table(4707) := '6C6520656C656D656E742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63';
wwv_flow_imp.g_varchar2_table(4708) := '732F5765622F48544D4C2F456C656D656E742F61727469636C65227D5D7D2C7B6E616D653A2273656374696F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652073656374696F6E20656C656D65';
wwv_flow_imp.g_varchar2_table(4709) := '6E7420726570726573656E747320612067656E657269632073656374696F6E206F66206120646F63756D656E74206F72206170706C69636174696F6E2E20412073656374696F6E2C20696E207468697320636F6E746578742C2069732061207468656D61';
wwv_flow_imp.g_varchar2_table(4710) := '7469632067726F7570696E67206F6620636F6E74656E742E20456163682073656374696F6E2073686F756C64206265206964656E7469666965642C207479706963616C6C7920627920696E636C7564696E6720612068656164696E6720282068312D2068';
wwv_flow_imp.g_varchar2_table(4711) := '3620656C656D656E74292061732061206368696C64206F66207468652073656374696F6E20656C656D656E742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A';
wwv_flow_imp.g_varchar2_table(4712) := '2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F73656374696F6E227D5D7D2C7B6E616D653A226E6176222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(4713) := '646F776E222C76616C75653A22546865206E617620656C656D656E7420726570726573656E747320612073656374696F6E206F66206120706167652074686174206C696E6B7320746F206F74686572207061676573206F7220746F207061727473207769';
wwv_flow_imp.g_varchar2_table(4714) := '7468696E2074686520706167653A20612073656374696F6E2077697468206E617669676174696F6E206C696E6B732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C7572';
wwv_flow_imp.g_varchar2_table(4715) := '6C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6E6176227D5D7D2C7B6E616D653A226173696465222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(4716) := '646F776E222C76616C75653A2254686520617369646520656C656D656E7420726570726573656E747320612073656374696F6E206F6620612070616765207468617420636F6E7369737473206F6620636F6E74656E7420746861742069732074616E6765';
wwv_flow_imp.g_varchar2_table(4717) := '6E7469616C6C792072656C6174656420746F2074686520636F6E74656E742061726F756E642074686520617369646520656C656D656E742C20616E6420776869636820636F756C6420626520636F6E736964657265642073657061726174652066726F6D';
wwv_flow_imp.g_varchar2_table(4718) := '207468617420636F6E74656E742E20537563682073656374696F6E7320617265206F6674656E20726570726573656E74656420617320736964656261727320696E207072696E746564207479706F6772617068792E227D2C617474726962757465733A5B';
wwv_flow_imp.g_varchar2_table(4719) := '5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6173696465227D';
wwv_flow_imp.g_varchar2_table(4720) := '5D7D2C7B6E616D653A226831222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520683120656C656D656E7420726570726573656E747320612073656374696F6E2068656164696E672E227D2C617474';
wwv_flow_imp.g_varchar2_table(4721) := '726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E';
wwv_flow_imp.g_varchar2_table(4722) := '742F48656164696E675F456C656D656E7473227D5D7D2C7B6E616D653A226832222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520683220656C656D656E7420726570726573656E74732061207365';
wwv_flow_imp.g_varchar2_table(4723) := '6374696F6E2068656164696E672E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F';
wwv_flow_imp.g_varchar2_table(4724) := '646F63732F5765622F48544D4C2F456C656D656E742F48656164696E675F456C656D656E7473227D5D7D2C7B6E616D653A226833222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520683320656C65';
wwv_flow_imp.g_varchar2_table(4725) := '6D656E7420726570726573656E747320612073656374696F6E2068656164696E672E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F6465';
wwv_flow_imp.g_varchar2_table(4726) := '76656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F48656164696E675F456C656D656E7473227D5D7D2C7B6E616D653A226834222C6465736372697074696F6E3A7B6B696E643A226D61726B646F77';
wwv_flow_imp.g_varchar2_table(4727) := '6E222C76616C75653A2254686520683420656C656D656E7420726570726573656E747320612073656374696F6E2068656164696E672E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E20526566657265';
wwv_flow_imp.g_varchar2_table(4728) := '6E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F48656164696E675F456C656D656E7473227D5D7D2C7B6E616D653A226835222C646573637269';
wwv_flow_imp.g_varchar2_table(4729) := '7074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520683520656C656D656E7420726570726573656E747320612073656374696F6E2068656164696E672E227D2C617474726962757465733A5B5D2C7265666572656E6365';
wwv_flow_imp.g_varchar2_table(4730) := '733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F48656164696E675F456C656D656E7473227D';
wwv_flow_imp.g_varchar2_table(4731) := '5D7D2C7B6E616D653A226836222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520683620656C656D656E7420726570726573656E747320612073656374696F6E2068656164696E672E227D2C617474';
wwv_flow_imp.g_varchar2_table(4732) := '726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E';
wwv_flow_imp.g_varchar2_table(4733) := '742F48656164696E675F456C656D656E7473227D5D7D2C7B6E616D653A22686561646572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652068656164657220656C656D656E742072657072657365';
wwv_flow_imp.g_varchar2_table(4734) := '6E747320696E74726F647563746F727920636F6E74656E7420666F7220697473206E65617265737420616E636573746F722073656374696F6E696E6720636F6E74656E74206F722073656374696F6E696E6720726F6F7420656C656D656E742E20412068';
wwv_flow_imp.g_varchar2_table(4735) := '6561646572207479706963616C6C7920636F6E7461696E7320612067726F7570206F6620696E74726F647563746F7279206F72206E617669676174696F6E616C20616964732E205768656E20746865206E65617265737420616E636573746F7220736563';
wwv_flow_imp.g_varchar2_table(4736) := '74696F6E696E6720636F6E74656E74206F722073656374696F6E696E6720726F6F7420656C656D656E742069732074686520626F647920656C656D656E742C207468656E206974206170706C69657320746F207468652077686F6C6520706167652E227D';
wwv_flow_imp.g_varchar2_table(4737) := '2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C';
wwv_flow_imp.g_varchar2_table(4738) := '656D656E742F686561646572227D5D7D2C7B6E616D653A22666F6F746572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520666F6F74657220656C656D656E7420726570726573656E7473206120';
wwv_flow_imp.g_varchar2_table(4739) := '666F6F74657220666F7220697473206E65617265737420616E636573746F722073656374696F6E696E6720636F6E74656E74206F722073656374696F6E696E6720726F6F7420656C656D656E742E204120666F6F746572207479706963616C6C7920636F';
wwv_flow_imp.g_varchar2_table(4740) := '6E7461696E7320696E666F726D6174696F6E2061626F7574206974732073656374696F6E20737563682061732077686F2077726F74652069742C206C696E6B7320746F2072656C6174656420646F63756D656E74732C20636F7079726967687420646174';
wwv_flow_imp.g_varchar2_table(4741) := '612C20616E6420746865206C696B652E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(4742) := '672F646F63732F5765622F48544D4C2F456C656D656E742F666F6F746572227D5D7D2C7B6E616D653A2261646472657373222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520616464726573732065';
wwv_flow_imp.g_varchar2_table(4743) := '6C656D656E7420726570726573656E74732074686520636F6E7461637420696E666F726D6174696F6E20666F7220697473206E6561726573742061727469636C65206F7220626F647920656C656D656E7420616E636573746F722E204966207468617420';
wwv_flow_imp.g_varchar2_table(4744) := '69732074686520626F647920656C656D656E742C207468656E2074686520636F6E7461637420696E666F726D6174696F6E206170706C69657320746F2074686520646F63756D656E7420617320612077686F6C652E227D2C617474726962757465733A5B';
wwv_flow_imp.g_varchar2_table(4745) := '5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F61646472657373';
wwv_flow_imp.g_varchar2_table(4746) := '227D5D7D2C7B6E616D653A2270222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207020656C656D656E7420726570726573656E74732061207061726167726170682E227D2C617474726962757465';
wwv_flow_imp.g_varchar2_table(4747) := '733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F70227D5D';
wwv_flow_imp.g_varchar2_table(4748) := '7D2C7B6E616D653A226872222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520687220656C656D656E7420726570726573656E74732061207061726167726170682D6C6576656C207468656D617469';
wwv_flow_imp.g_varchar2_table(4749) := '6320627265616B2C20652E672E2061207363656E65206368616E676520696E20612073746F72792C206F722061207472616E736974696F6E20746F20616E6F7468657220746F7069632077697468696E20612073656374696F6E206F6620612072656665';
wwv_flow_imp.g_varchar2_table(4750) := '72656E636520626F6F6B2E227D2C617474726962757465733A5B7B6E616D653A22616C69676E222C6465736372697074696F6E3A22536574732074686520616C69676E6D656E74206F66207468652072756C65206F6E2074686520706167652E20496620';
wwv_flow_imp.g_varchar2_table(4751) := '6E6F2076616C7565206973207370656369666965642C207468652064656661756C742076616C756520697320606C656674602E227D2C7B6E616D653A22636F6C6F72222C6465736372697074696F6E3A22536574732074686520636F6C6F72206F662074';
wwv_flow_imp.g_varchar2_table(4752) := '68652072756C65207468726F75676820636F6C6F72206E616D65206F722068657861646563696D616C2076616C75652E227D2C7B6E616D653A226E6F7368616465222C6465736372697074696F6E3A2253657473207468652072756C6520746F20686176';
wwv_flow_imp.g_varchar2_table(4753) := '65206E6F2073686164696E672E227D2C7B6E616D653A2273697A65222C6465736372697074696F6E3A225365747320746865206865696768742C20696E20706978656C732C206F66207468652072756C652E227D2C7B6E616D653A227769647468222C64';
wwv_flow_imp.g_varchar2_table(4754) := '65736372697074696F6E3A225365747320746865206C656E677468206F66207468652072756C65206F6E207468652070616765207468726F756768206120706978656C206F722070657263656E746167652076616C75652E227D5D2C7265666572656E63';
wwv_flow_imp.g_varchar2_table(4755) := '65733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6872227D5D7D2C7B6E616D653A22707265';
wwv_flow_imp.g_varchar2_table(4756) := '222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652070726520656C656D656E7420726570726573656E7473206120626C6F636B206F6620707265666F726D617474656420746578742C20696E207768';
wwv_flow_imp.g_varchar2_table(4757) := '6963682073747275637475726520697320726570726573656E746564206279207479706F6772617068696320636F6E76656E74696F6E7320726174686572207468616E20627920656C656D656E74732E227D2C617474726962757465733A5B7B6E616D65';
wwv_flow_imp.g_varchar2_table(4758) := '3A22636F6C73222C6465736372697074696F6E3A27436F6E7461696E7320746865205F7072656665727265645F20636F756E74206F66206368617261637465727320746861742061206C696E652073686F756C6420686176652E20497420776173206120';
wwv_flow_imp.g_varchar2_table(4759) := '6E6F6E2D7374616E646172642073796E6F6E796D206F66205B607769647468605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7072652361747472';
wwv_flow_imp.g_varchar2_table(4760) := '2D7769647468292E20546F2061636869657665207375636820616E206566666563742C2075736520435353205B607769647468605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F43';
wwv_flow_imp.g_varchar2_table(4761) := '53532F77696474682022546865207769647468204353532070726F7065727479207365747320616E20656C656D656E745C27732077696474682E2042792064656661756C74206974207365747320746865207769647468206F662074686520636F6E7465';
wwv_flow_imp.g_varchar2_table(4762) := '6E7420617265612C2062757420696620626F782D73697A696E672069732073657420746F20626F726465722D626F782C206974207365747320746865207769647468206F662074686520626F7264657220617265612E222920696E73746561642E277D2C';
wwv_flow_imp.g_varchar2_table(4763) := '7B6E616D653A227769647468222C6465736372697074696F6E3A27436F6E7461696E7320746865205F7072656665727265645F20636F756E74206F66206368617261637465727320746861742061206C696E652073686F756C6420686176652E2054686F';
wwv_flow_imp.g_varchar2_table(4764) := '75676820746563686E6963616C6C79207374696C6C20696D706C656D656E7465642C20746869732061747472696275746520686173206E6F2076697375616C206566666563743B20746F2061636869657665207375636820616E206566666563742C2075';
wwv_flow_imp.g_varchar2_table(4765) := '736520435353205B607769647468605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F77696474682022546865207769647468204353532070726F70657274792073657473';
wwv_flow_imp.g_varchar2_table(4766) := '20616E20656C656D656E745C27732077696474682E2042792064656661756C74206974207365747320746865207769647468206F662074686520636F6E74656E7420617265612C2062757420696620626F782D73697A696E672069732073657420746F20';
wwv_flow_imp.g_varchar2_table(4767) := '626F726465722D626F782C206974207365747320746865207769647468206F662074686520626F7264657220617265612E222920696E73746561642E277D2C7B6E616D653A2277726170222C6465736372697074696F6E3A2749732061205F68696E745F';
wwv_flow_imp.g_varchar2_table(4768) := '20696E6469636174696E6720686F7720746865206F766572666C6F77206D7573742068617070656E2E20496E206D6F6465726E2062726F7773657220746869732068696E742069732069676E6F72656420616E64206E6F2076697375616C206566666563';
wwv_flow_imp.g_varchar2_table(4769) := '7420726573756C747320696E206974732070726573656E743B20746F2061636869657665207375636820616E206566666563742C2075736520435353205B6077686974652D7370616365605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(4770) := '6C612E6F72672F656E2D55532F646F63732F5765622F4353532F77686974652D737061636520225468652077686974652D7370616365204353532070726F7065727479207365747320686F7720776869746520737061636520696E7369646520616E2065';
wwv_flow_imp.g_varchar2_table(4771) := '6C656D656E742069732068616E646C65642E222920696E73746561642E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(4772) := '672F646F63732F5765622F48544D4C2F456C656D656E742F707265227D5D7D2C7B6E616D653A22626C6F636B71756F7465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520626C6F636B71756F74';
wwv_flow_imp.g_varchar2_table(4773) := '6520656C656D656E7420726570726573656E747320636F6E74656E7420746861742069732071756F7465642066726F6D20616E6F7468657220736F757263652C206F7074696F6E616C6C7920776974682061206369746174696F6E207768696368206D75';
wwv_flow_imp.g_varchar2_table(4774) := '73742062652077697468696E206120666F6F746572206F72206369746520656C656D656E742C20616E64206F7074696F6E616C6C79207769746820696E2D6C696E65206368616E676573207375636820617320616E6E6F746174696F6E7320616E642061';
wwv_flow_imp.g_varchar2_table(4775) := '6262726576696174696F6E732E227D2C617474726962757465733A5B7B6E616D653A2263697465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22412055524C20746861742064657369676E617465732061';
wwv_flow_imp.g_varchar2_table(4776) := '20736F7572636520646F63756D656E74206F72206D65737361676520666F722074686520696E666F726D6174696F6E2071756F7465642E20546869732061747472696275746520697320696E74656E64656420746F20706F696E7420746F20696E666F72';
wwv_flow_imp.g_varchar2_table(4777) := '6D6174696F6E206578706C61696E696E672074686520636F6E74657874206F7220746865207265666572656E636520666F72207468652071756F74652E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C';
wwv_flow_imp.g_varchar2_table(4778) := '75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F626C6F636B71756F7465227D5D7D2C7B6E616D653A226F6C222C6465736372697074696F6E3A7B6B696E64';
wwv_flow_imp.g_varchar2_table(4779) := '3A226D61726B646F776E222C76616C75653A22546865206F6C20656C656D656E7420726570726573656E74732061206C697374206F66206974656D732C20776865726520746865206974656D732068617665206265656E20696E74656E74696F6E616C6C';
wwv_flow_imp.g_varchar2_table(4780) := '79206F7264657265642C20737563682074686174206368616E67696E6720746865206F7264657220776F756C64206368616E676520746865206D65616E696E67206F662074686520646F63756D656E742E227D2C617474726962757465733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(4781) := '653A227265766572736564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E2061747472696275746520737065636966696573207468617420';
wwv_flow_imp.g_varchar2_table(4782) := '746865206974656D73206F6620746865206C697374206172652073706563696669656420696E207265766572736564206F726465722E227D7D2C7B6E616D653A227374617274222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(4783) := '2C76616C75653A275468697320696E74656765722061747472696275746520737065636966696573207468652073746172742076616C756520666F72206E756D626572696E672074686520696E646976696475616C206C697374206974656D732E20416C';
wwv_flow_imp.g_varchar2_table(4784) := '74686F75676820746865206F72646572696E672074797065206F66206C69737420656C656D656E7473206D6967687420626520526F6D616E206E756D6572616C732C207375636820617320585858492C206F72206C6574746572732C207468652076616C';
wwv_flow_imp.g_varchar2_table(4785) := '7565206F6620737461727420697320616C7761797320726570726573656E7465642061732061206E756D6265722E20546F207374617274206E756D626572696E6720656C656D656E74732066726F6D20746865206C6574746572202243222C2075736520';
wwv_flow_imp.g_varchar2_table(4786) := '603C6F6C2073746172743D2233223E602E5C6E5C6E2A2A4E6F74652A2A3A20546869732061747472696275746520776173206465707265636174656420696E2048544D4C342C20627574207265696E74726F647563656420696E2048544D4C352E277D7D';
wwv_flow_imp.g_varchar2_table(4787) := '2C7B6E616D653A2274797065222C76616C75655365743A226C74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E6469636174657320746865206E756D626572696E6720747970653A5C6E5C6E2A2020';
wwv_flow_imp.g_varchar2_table(4788) := '20602761276020696E64696361746573206C6F77657263617365206C6574746572732C5C6E2A202020602741276020696E6469636174657320757070657263617365206C6574746572732C5C6E2A202020602769276020696E64696361746573206C6F77';
wwv_flow_imp.g_varchar2_table(4789) := '65726361736520526F6D616E206E756D6572616C732C5C6E2A202020602749276020696E646963617465732075707065726361736520526F6D616E206E756D6572616C732C5C6E2A202020616E6420602731276020696E64696361746573206E756D6265';
wwv_flow_imp.g_varchar2_table(4790) := '7273202864656661756C74292E5C6E5C6E546865207479706520736574206973207573656420666F722074686520656E74697265206C69737420756E6C657373206120646966666572656E74205B6074797065605D2868747470733A2F2F646576656C6F';
wwv_flow_imp.g_varchar2_table(4791) := '7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6C6923617474722D74797065292061747472696275746520697320757365642077697468696E20616E20656E636C6F736564205B603C6C69';
wwv_flow_imp.g_varchar2_table(4792) := '3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6C69205C225468652048544D4C203C6C693E20656C656D656E74206973207573656420746F20';
wwv_flow_imp.g_varchar2_table(4793) := '726570726573656E7420616E206974656D20696E2061206C6973742E204974206D75737420626520636F6E7461696E656420696E206120706172656E7420656C656D656E743A20616E206F726465726564206C69737420283C6F6C3E292C20616E20756E';
wwv_flow_imp.g_varchar2_table(4794) := '6F726465726564206C69737420283C756C3E292C206F722061206D656E7520283C6D656E753E292E20496E206D656E757320616E6420756E6F726465726564206C697374732C206C697374206974656D732061726520757375616C6C7920646973706C61';
wwv_flow_imp.g_varchar2_table(4795) := '796564207573696E672062756C6C657420706F696E74732E20496E206F726465726564206C697374732C20746865792061726520757375616C6C7920646973706C61796564207769746820616E20617363656E64696E6720636F756E746572206F6E2074';
wwv_flow_imp.g_varchar2_table(4796) := '6865206C6566742C20737563682061732061206E756D626572206F72206C65747465722E5C222920656C656D656E742E5C6E5C6E2A2A4E6F74653A2A2A20546869732061747472696275746520776173206465707265636174656420696E2048544D4C34';
wwv_flow_imp.g_varchar2_table(4797) := '2C20627574207265696E74726F647563656420696E2048544D4C352E5C6E5C6E556E6C657373207468652076616C7565206F6620746865206C697374206E756D626572206D6174746572732028652E672E20696E206C6567616C206F7220746563686E69';
wwv_flow_imp.g_varchar2_table(4798) := '63616C20646F63756D656E7473207768657265206974656D732061726520746F206265207265666572656E636564206279207468656972206E756D6265722F6C6574746572292C2074686520435353205B606C6973742D7374796C652D74797065605D28';
wwv_flow_imp.g_varchar2_table(4799) := '68747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6C6973742D7374796C652D74797065205C22546865206C6973742D7374796C652D74797065204353532070726F706572747920';
wwv_flow_imp.g_varchar2_table(4800) := '7365747320746865206D61726B6572202873756368206173206120646973632C206368617261637465722C206F7220637573746F6D20636F756E746572207374796C6529206F662061206C697374206974656D20656C656D656E742E5C22292070726F70';
wwv_flow_imp.g_varchar2_table(4801) := '657274792073686F756C64206265207573656420696E73746561642E227D7D2C7B6E616D653A22636F6D70616374222C6465736372697074696F6E3A275468697320426F6F6C65616E206174747269627574652068696E7473207468617420746865206C';
wwv_flow_imp.g_varchar2_table(4802) := '6973742073686F756C642062652072656E646572656420696E206120636F6D70616374207374796C652E2054686520696E746572707265746174696F6E206F6620746869732061747472696275746520646570656E6473206F6E20746865207573657220';
wwv_flow_imp.g_varchar2_table(4803) := '6167656E7420616E6420697420646F65736E5C277420776F726B20696E20616C6C2062726F77736572732E5C6E5C6E2A2A5761726E696E673A2A2A20446F206E6F74207573652074686973206174747269627574652C2061732069742068617320626565';
wwv_flow_imp.g_varchar2_table(4804) := '6E20646570726563617465643A20746865205B603C6F6C3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6F6C20225468652048544D4C203C6F';
wwv_flow_imp.g_varchar2_table(4805) := '6C3E20656C656D656E7420726570726573656E747320616E206F726465726564206C697374206F66206974656D732C207479706963616C6C792072656E64657265642061732061206E756D6265726564206C6973742E222920656C656D656E742073686F';
wwv_flow_imp.g_varchar2_table(4806) := '756C64206265207374796C6564207573696E67205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F435353292E20546F206769766520616E206566666563742073696D696C61722074';
wwv_flow_imp.g_varchar2_table(4807) := '6F207468652060636F6D7061637460206174747269627574652C20746865205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F435353292070726F7065727479205B606C696E652D68';
wwv_flow_imp.g_varchar2_table(4808) := '6569676874605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6C696E652D6865696768742022546865206C696E652D686569676874204353532070726F70657274792073';
wwv_flow_imp.g_varchar2_table(4809) := '6574732074686520616D6F756E74206F66207370616365207573656420666F72206C696E65732C207375636820617320696E20746578742E204F6E20626C6F636B2D6C6576656C20656C656D656E74732C2069742073706563696669657320746865206D';
wwv_flow_imp.g_varchar2_table(4810) := '696E696D756D20686569676874206F66206C696E6520626F7865732077697468696E2074686520656C656D656E742E204F6E206E6F6E2D7265706C6163656420696E6C696E6520656C656D656E74732C2069742073706563696669657320746865206865';
wwv_flow_imp.g_varchar2_table(4811) := '696768742074686174206973207573656420746F2063616C63756C617465206C696E6520626F78206865696768742E22292063616E2062652075736564207769746820612076616C7565206F662060383025602E277D5D2C7265666572656E6365733A5B';
wwv_flow_imp.g_varchar2_table(4812) := '7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6F6C227D5D7D2C7B6E616D653A22756C222C646573';
wwv_flow_imp.g_varchar2_table(4813) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520756C20656C656D656E7420726570726573656E74732061206C697374206F66206974656D732C20776865726520746865206F72646572206F66207468652069';
wwv_flow_imp.g_varchar2_table(4814) := '74656D73206973206E6F7420696D706F7274616E7420E2809420746861742069732C207768657265206368616E67696E6720746865206F7264657220776F756C64206E6F74206D6174657269616C6C79206368616E676520746865206D65616E696E6720';
wwv_flow_imp.g_varchar2_table(4815) := '6F662074686520646F63756D656E742E227D2C617474726962757465733A5B7B6E616D653A22636F6D70616374222C6465736372697074696F6E3A275468697320426F6F6C65616E206174747269627574652068696E7473207468617420746865206C69';
wwv_flow_imp.g_varchar2_table(4816) := '73742073686F756C642062652072656E646572656420696E206120636F6D70616374207374796C652E2054686520696E746572707265746174696F6E206F6620746869732061747472696275746520646570656E6473206F6E2074686520757365722061';
wwv_flow_imp.g_varchar2_table(4817) := '67656E7420616E6420697420646F65736E5C277420776F726B20696E20616C6C2062726F77736572732E5C6E5C6E2A2A5573616765206E6F74653AC2A02A2A446F206E6F74207573652074686973206174747269627574652C2061732069742068617320';
wwv_flow_imp.g_varchar2_table(4818) := '6265656E20646570726563617465643A20746865205B603C756C3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F756C20225468652048544D4C';
wwv_flow_imp.g_varchar2_table(4819) := '203C756C3E20656C656D656E7420726570726573656E747320616E20756E6F726465726564206C697374206F66206974656D732C207479706963616C6C792072656E646572656420617320612062756C6C65746564206C6973742E222920656C656D656E';
wwv_flow_imp.g_varchar2_table(4820) := '742073686F756C64206265207374796C6564207573696E67205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F435353292E20546F206769766520612073696D696C61722065666665';
wwv_flow_imp.g_varchar2_table(4821) := '6374206173207468652060636F6D7061637460206174747269627574652C20746865205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F435353292070726F7065727479205B6C696E';
wwv_flow_imp.g_varchar2_table(4822) := '652D6865696768745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F4353532F6C696E652D686569676874292063616E2062652075736564207769746820612076616C7565206F662060383025';
wwv_flow_imp.g_varchar2_table(4823) := '602E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F756C22';
wwv_flow_imp.g_varchar2_table(4824) := '7D5D7D2C7B6E616D653A226C69222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206C6920656C656D656E7420726570726573656E74732061206C697374206974656D2E2049662069747320706172';
wwv_flow_imp.g_varchar2_table(4825) := '656E7420656C656D656E7420697320616E206F6C2C20756C2C206F72206D656E7520656C656D656E742C207468656E2074686520656C656D656E7420697320616E206974656D206F662074686520706172656E7420656C656D656E742773206C6973742C';
wwv_flow_imp.g_varchar2_table(4826) := '20617320646566696E656420666F722074686F736520656C656D656E74732E204F74686572776973652C20746865206C697374206974656D20686173206E6F20646566696E6564206C6973742D72656C617465642072656C6174696F6E7368697020746F';
wwv_flow_imp.g_varchar2_table(4827) := '20616E79206F74686572206C6920656C656D656E742E227D2C617474726962757465733A5B7B6E616D653A2276616C7565222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320696E746567657220';
wwv_flow_imp.g_varchar2_table(4828) := '61747472696275746520696E64696361746573207468652063757272656E74206F7264696E616C2076616C7565206F6620746865206C697374206974656D20617320646566696E656420627920746865205B603C6F6C3E605D2868747470733A2F2F6465';
wwv_flow_imp.g_varchar2_table(4829) := '76656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6F6C20225468652048544D4C203C6F6C3E20656C656D656E7420726570726573656E747320616E206F726465726564206C697374';
wwv_flow_imp.g_varchar2_table(4830) := '206F66206974656D732C207479706963616C6C792072656E64657265642061732061206E756D6265726564206C6973742E222920656C656D656E742E20546865206F6E6C7920616C6C6F7765642076616C756520666F7220746869732061747472696275';
wwv_flow_imp.g_varchar2_table(4831) := '74652069732061206E756D6265722C206576656E20696620746865206C69737420697320646973706C61796564207769746820526F6D616E206E756D6572616C73206F72206C6574746572732E204C697374206974656D73207468617420666F6C6C6F77';
wwv_flow_imp.g_varchar2_table(4832) := '2074686973206F6E6520636F6E74696E7565206E756D626572696E672066726F6D207468652076616C7565207365742E20546865202A2A76616C75652A2A2061747472696275746520686173206E6F206D65616E696E6720666F7220756E6F7264657265';
wwv_flow_imp.g_varchar2_table(4833) := '64206C6973747320285B603C756C3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F756C20225468652048544D4C203C756C3E20656C656D656E';
wwv_flow_imp.g_varchar2_table(4834) := '7420726570726573656E747320616E20756E6F726465726564206C697374206F66206974656D732C207479706963616C6C792072656E646572656420617320612062756C6C65746564206C6973742E222929206F7220666F72206D656E757320285B603C';
wwv_flow_imp.g_varchar2_table(4835) := '6D656E753E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D656E7520225468652048544D4C203C6D656E753E20656C656D656E742072657072';
wwv_flow_imp.g_varchar2_table(4836) := '6573656E747320612067726F7570206F6620636F6D6D616E64732074686174206120757365722063616E20706572666F726D206F722061637469766174652E205468697320696E636C7564657320626F7468206C697374206D656E75732C207768696368';
wwv_flow_imp.g_varchar2_table(4837) := '206D6967687420617070656172206163726F73732074686520746F70206F6620612073637265656E2C2061732077656C6C20617320636F6E74657874206D656E75732C20737563682061732074686F73652074686174206D696768742061707065617220';
wwv_flow_imp.g_varchar2_table(4838) := '756E6465726E65617468206120627574746F6E20616674657220697420686173206265656E20636C69636B65642E2229292E5C6E5C6E2A2A4E6F74652A2A3A20546869732061747472696275746520776173206465707265636174656420696E2048544D';
wwv_flow_imp.g_varchar2_table(4839) := '4C342C20627574207265696E74726F647563656420696E2048544D4C352E5C6E5C6E2A2A4E6F74653A2A2A205072696F7220746F204765636B6FC2A0392E302C206E656761746976652076616C756573207765726520696E636F72726563746C7920636F';
wwv_flow_imp.g_varchar2_table(4840) := '6E76657274656420746F20302E205374617274696E6720696E204765636B6FC2A0392E3020616C6C20696E74656765722076616C7565732061726520636F72726563746C79207061727365642E277D7D2C7B6E616D653A2274797065222C646573637269';
wwv_flow_imp.g_varchar2_table(4841) := '7074696F6E3A2754686973206368617261637465722061747472696275746520696E6469636174657320746865206E756D626572696E6720747970653A5C6E5C6E2A2020206061603A206C6F77657263617365206C6574746572735C6E2A202020604160';
wwv_flow_imp.g_varchar2_table(4842) := '3A20757070657263617365206C6574746572735C6E2A2020206069603A206C6F7765726361736520526F6D616E206E756D6572616C735C6E2A2020206049603A2075707065726361736520526F6D616E206E756D6572616C735C6E2A2020206031603A20';
wwv_flow_imp.g_varchar2_table(4843) := '6E756D626572735C6E5C6E546869732074797065206F766572726964657320746865206F6E6520757365642062792069747320706172656E74205B603C6F6C3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D';
wwv_flow_imp.g_varchar2_table(4844) := '55532F646F63732F5765622F48544D4C2F456C656D656E742F6F6C20225468652048544D4C203C6F6C3E20656C656D656E7420726570726573656E747320616E206F726465726564206C697374206F66206974656D732C207479706963616C6C79207265';
wwv_flow_imp.g_varchar2_table(4845) := '6E64657265642061732061206E756D6265726564206C6973742E222920656C656D656E742C20696620616E792E5C6E5C6E2A2A5573616765206E6F74653A2A2A20546869732061747472696275746520686173206265656E20646570726563617465643A';
wwv_flow_imp.g_varchar2_table(4846) := '207573652074686520435353205B606C6973742D7374796C652D74797065605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6C6973742D7374796C652D74797065202254';
wwv_flow_imp.g_varchar2_table(4847) := '6865206C6973742D7374796C652D74797065204353532070726F7065727479207365747320746865206D61726B6572202873756368206173206120646973632C206368617261637465722C206F7220637573746F6D20636F756E746572207374796C6529';
wwv_flow_imp.g_varchar2_table(4848) := '206F662061206C697374206974656D20656C656D656E742E22292070726F706572747920696E73746561642E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C';
wwv_flow_imp.g_varchar2_table(4849) := '6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6C69227D5D7D2C7B6E616D653A22646C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520646C20';
wwv_flow_imp.g_varchar2_table(4850) := '656C656D656E7420726570726573656E747320616E206173736F63696174696F6E206C69737420636F6E73697374696E67206F66207A65726F206F72206D6F7265206E616D652D76616C75652067726F757073202861206465736372697074696F6E206C';
wwv_flow_imp.g_varchar2_table(4851) := '697374292E2041206E616D652D76616C75652067726F757020636F6E7369737473206F66206F6E65206F72206D6F7265206E616D65732028647420656C656D656E74732920666F6C6C6F776564206279206F6E65206F72206D6F72652076616C75657320';
wwv_flow_imp.g_varchar2_table(4852) := '28646420656C656D656E7473292C2069676E6F72696E6720616E79206E6F646573206F74686572207468616E20647420616E6420646420656C656D656E74732E2057697468696E20612073696E676C6520646C20656C656D656E742C2074686572652073';
wwv_flow_imp.g_varchar2_table(4853) := '686F756C64206E6F74206265206D6F7265207468616E206F6E6520647420656C656D656E7420666F722065616368206E616D652E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E63';
wwv_flow_imp.g_varchar2_table(4854) := '65222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F646C227D5D7D2C7B6E616D653A226474222C6465736372697074696F6E3A7B6B696E643A226D6172';
wwv_flow_imp.g_varchar2_table(4855) := '6B646F776E222C76616C75653A2254686520647420656C656D656E7420726570726573656E747320746865207465726D2C206F72206E616D652C2070617274206F662061207465726D2D6465736372697074696F6E2067726F757020696E206120646573';
wwv_flow_imp.g_varchar2_table(4856) := '6372697074696F6E206C6973742028646C20656C656D656E74292E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F706572';
wwv_flow_imp.g_varchar2_table(4857) := '2E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6474227D5D7D2C7B6E616D653A226464222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520646420656C656D';
wwv_flow_imp.g_varchar2_table(4858) := '656E7420726570726573656E747320746865206465736372697074696F6E2C20646566696E6974696F6E2C206F722076616C75652C2070617274206F662061207465726D2D6465736372697074696F6E2067726F757020696E2061206465736372697074';
wwv_flow_imp.g_varchar2_table(4859) := '696F6E206C6973742028646C20656C656D656E74292E227D2C617474726962757465733A5B7B6E616D653A226E6F77726170222C6465736372697074696F6E3A224966207468652076616C7565206F662074686973206174747269627574652069732073';
wwv_flow_imp.g_varchar2_table(4860) := '657420746F2060796573602C2074686520646566696E6974696F6E20746578742077696C6C206E6F7420777261702E205468652064656661756C742076616C756520697320606E6F602E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E';
wwv_flow_imp.g_varchar2_table(4861) := '205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6464227D5D7D2C7B6E616D653A22666967757265222C646573637269707469';
wwv_flow_imp.g_varchar2_table(4862) := '6F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652066696775726520656C656D656E7420726570726573656E747320736F6D6520666C6F7720636F6E74656E742C206F7074696F6E616C6C79207769746820612063617074696F';
wwv_flow_imp.g_varchar2_table(4863) := '6E2C20746861742069732073656C662D636F6E7461696E656420286C696B65206120636F6D706C6574652073656E74656E63652920616E64206973207479706963616C6C79207265666572656E63656420617320612073696E676C6520756E6974206672';
wwv_flow_imp.g_varchar2_table(4864) := '6F6D20746865206D61696E20666C6F77206F662074686520646F63756D656E742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576';
wwv_flow_imp.g_varchar2_table(4865) := '656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F666967757265227D5D7D2C7B6E616D653A2266696763617074696F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C';
wwv_flow_imp.g_varchar2_table(4866) := '76616C75653A225468652066696763617074696F6E20656C656D656E7420726570726573656E747320612063617074696F6E206F72206C6567656E6420666F72207468652072657374206F662074686520636F6E74656E7473206F662074686520666967';
wwv_flow_imp.g_varchar2_table(4867) := '63617074696F6E20656C656D656E74277320706172656E742066696775726520656C656D656E742C20696620616E792E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75';
wwv_flow_imp.g_varchar2_table(4868) := '726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F66696763617074696F6E227D5D7D2C7B6E616D653A226D61696E222C6465736372697074696F6E3A7B6B696E';
wwv_flow_imp.g_varchar2_table(4869) := '643A226D61726B646F776E222C76616C75653A22546865206D61696E20656C656D656E7420726570726573656E747320746865206D61696E20636F6E74656E74206F662074686520626F6479206F66206120646F63756D656E74206F72206170706C6963';
wwv_flow_imp.g_varchar2_table(4870) := '6174696F6E2E20546865206D61696E20636F6E74656E74206172656120636F6E7369737473206F6620636F6E74656E742074686174206973206469726563746C792072656C6174656420746F206F7220657870616E64732075706F6E207468652063656E';
wwv_flow_imp.g_varchar2_table(4871) := '7472616C20746F706963206F66206120646F63756D656E74206F722063656E7472616C2066756E6374696F6E616C697479206F6620616E206170706C69636174696F6E2E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(4872) := '6D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6D61696E227D5D7D2C7B6E616D653A22646976222C646573';
wwv_flow_imp.g_varchar2_table(4873) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652064697620656C656D656E7420686173206E6F207370656369616C206D65616E696E6720617420616C6C2E20497420726570726573656E747320697473206368';
wwv_flow_imp.g_varchar2_table(4874) := '696C6472656E2E2049742063616E206265207573656420776974682074686520636C6173732C206C616E672C20616E64207469746C65206174747269627574657320746F206D61726B2075702073656D616E7469637320636F6D6D6F6E20746F20612067';
wwv_flow_imp.g_varchar2_table(4875) := '726F7570206F6620636F6E736563757469766520656C656D656E74732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(4876) := '65722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F646976227D5D7D2C7B6E616D653A2261222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496620746865206120';
wwv_flow_imp.g_varchar2_table(4877) := '656C656D656E742068617320616E2068726566206174747269627574652C207468656E20697420726570726573656E747320612068797065726C696E6B2028612068797065727465787420616E63686F7229206C6162656C65642062792069747320636F';
wwv_flow_imp.g_varchar2_table(4878) := '6E74656E74732E227D2C617474726962757465733A5B7B6E616D653A2268726566222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22436F6E7461696E7320612055524C206F7220612055524C20667261676D';
wwv_flow_imp.g_varchar2_table(4879) := '656E742074686174207468652068797065726C696E6B20706F696E747320746F2E227D7D2C7B6E616D653A22746172676574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27537065636966696573207768';
wwv_flow_imp.g_varchar2_table(4880) := '65726520746F20646973706C617920746865206C696E6B65642055524C2E2049742069732061206E616D65206F662C206F72206B6579776F726420666F722C2061205F62726F7773696E6720636F6E746578745F3A2061207461622C2077696E646F772C';
wwv_flow_imp.g_varchar2_table(4881) := '206F7220603C696672616D653E602E2054686520666F6C6C6F77696E67206B6579776F7264732068617665207370656369616C206D65616E696E67733A5C6E5C6E2A202020605F73656C66603A204C6F6164207468652055524C20696E746F2074686520';
wwv_flow_imp.g_varchar2_table(4882) := '73616D652062726F7773696E6720636F6E74657874206173207468652063757272656E74206F6E652E2054686973206973207468652064656661756C74206265686176696F722E5C6E2A202020605F626C616E6B603A204C6F6164207468652055524C20';
wwv_flow_imp.g_varchar2_table(4883) := '696E746F2061206E65772062726F7773696E6720636F6E746578742E205468697320697320757375616C6C792061207461622C206275742075736572732063616E20636F6E6669677572652062726F777365727320746F20757365206E65772077696E64';
wwv_flow_imp.g_varchar2_table(4884) := '6F777320696E73746561642E5C6E2A202020605F706172656E74603A204C6F6164207468652055524C20696E746F2074686520706172656E742062726F7773696E6720636F6E74657874206F66207468652063757272656E74206F6E652E204966207468';
wwv_flow_imp.g_varchar2_table(4885) := '657265206973206E6F20706172656E742C20746869732062656861766573207468652073616D652077617920617320605F73656C66602E5C6E2A202020605F746F70603A204C6F6164207468652055524C20696E746F2074686520746F702D6C6576656C';
wwv_flow_imp.g_varchar2_table(4886) := '2062726F7773696E6720636F6E746578742028746861742069732C20746865202268696768657374222062726F7773696E6720636F6E74657874207468617420697320616E20616E636573746F72206F66207468652063757272656E74206F6E652C2061';
wwv_flow_imp.g_varchar2_table(4887) := '6E6420686173206E6F20706172656E74292E204966207468657265206973206E6F20706172656E742C20746869732062656861766573207468652073616D652077617920617320605F73656C66602E5C6E5C6E2A2A4E6F74653A2A2A205768656E207573';
wwv_flow_imp.g_varchar2_table(4888) := '696E672060746172676574602C20636F6E736964657220616464696E67206072656C3D226E6F7265666572726572226020746F2061766F6964206578706C6F69746174696F6E206F6620746865206077696E646F772E6F70656E657260204150492E5C6E';
wwv_flow_imp.g_varchar2_table(4889) := '5C6E2A2A4E6F74653A2A2A204C696E6B696E6720746F20616E6F746865722070616765207573696E6720607461726765743D225F626C616E6B22602077696C6C2072756E20746865206E65772070616765206F6E207468652073616D652070726F636573';
wwv_flow_imp.g_varchar2_table(4890) := '7320617320796F757220706167652E20496620746865206E6577207061676520697320657865637574696E6720657870656E73697665204A532C20796F757220706167655C277320706572666F726D616E6365206D6179207375666665722E20546F2061';
wwv_flow_imp.g_varchar2_table(4891) := '766F6964207468697320757365206072656C3D226E6F6F70656E657222602E277D7D2C7B6E616D653A22646F776E6C6F6164222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275';
wwv_flow_imp.g_varchar2_table(4892) := '746520696E737472756374732062726F777365727320746F20646F776E6C6F616420612055524C20696E7374656164206F66206E617669676174696E6720746F2069742C20736F2074686520757365722077696C6C2062652070726F6D7074656420746F';
wwv_flow_imp.g_varchar2_table(4893) := '20736176652069742061732061206C6F63616C2066696C652E20496620746865206174747269627574652068617320612076616C75652C206974206973207573656420617320746865207072652D66696C6C65642066696C65206E616D6520696E207468';
wwv_flow_imp.g_varchar2_table(4894) := '6520536176652070726F6D7074202874686520757365722063616E207374696C6C206368616E6765207468652066696C65206E616D6520696620746865792077616E74292E20546865726520617265206E6F207265737472696374696F6E73206F6E2061';
wwv_flow_imp.g_varchar2_table(4895) := '6C6C6F7765642076616C7565732C2074686F75676820602F6020616E6420605C5C602061726520636F6E76657274656420746F20756E64657273636F7265732E204D6F73742066696C652073797374656D73206C696D697420736F6D652070756E637475';
wwv_flow_imp.g_varchar2_table(4896) := '6174696F6E20696E2066696C65206E616D65732C20616E642062726F77736572732077696C6C2061646A7573742074686520737567676573746564206E616D65206163636F7264696E676C792E5C6E5C6E2A2A4E6F7465733A2A2A5C6E5C6E2A20202054';
wwv_flow_imp.g_varchar2_table(4897) := '68697320617474726962757465206F6E6C7920776F726B7320666F72205B73616D652D6F726967696E2055524C735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F53656375726974';
wwv_flow_imp.g_varchar2_table(4898) := '792F53616D652D6F726967696E5F706F6C696379292E5C6E2A202020416C74686F75676820485454502873292055524C73206E65656420746F20626520696E207468652073616D652D6F726967696E2C205B60626C6F623A602055524C735D2868747470';
wwv_flow_imp.g_varchar2_table(4899) := '733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F55524C2E6372656174654F626A65637455524C2920616E64205B60646174613A602055524C735D2868747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(4900) := '65722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F4261736963735F6F665F485454502F446174615F55524973292061726520616C6C6F77656420736F207468617420636F6E74656E742067656E6572617465642062';
wwv_flow_imp.g_varchar2_table(4901) := '79204A6176615363726970742C2073756368206173207069637475726573206372656174656420696E20616E20696D6167652D656469746F7220576562206170702C2063616E20626520646F776E6C6F616465642E5C6E2A202020496620746865204854';
wwv_flow_imp.g_varchar2_table(4902) := '545020686561646572205B60436F6E74656E742D446973706F736974696F6E3A605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F436F6E74656E74';
wwv_flow_imp.g_varchar2_table(4903) := '2D446973706F736974696F6E29206769766573206120646966666572656E742066696C656E616D65207468616E2074686973206174747269627574652C207468652048545450206865616465722074616B6573207072696F72697479206F766572207468';
wwv_flow_imp.g_varchar2_table(4904) := '6973206174747269627574652E5C6E2A20202049662060436F6E74656E742D446973706F736974696F6E3A602069732073657420746F2060696E6C696E65602C2046697265666F78207072696F726974697A65732060436F6E74656E742D446973706F73';
wwv_flow_imp.g_varchar2_table(4905) := '6974696F6E602C206C696B65207468652066696C656E616D6520636173652C207768696C65204368726F6D65207072696F726974697A6573207468652060646F776E6C6F616460206174747269627574652E227D7D2C7B6E616D653A2270696E67222C64';
wwv_flow_imp.g_varchar2_table(4906) := '65736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27436F6E7461696E7320612073706163652D736570617261746564206C697374206F662055524C7320746F2077686963682C207768656E207468652068797065726C';
wwv_flow_imp.g_varchar2_table(4907) := '696E6B20697320666F6C6C6F7765642C205B60504F5354605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F4D6574686F64732F504F5354202254686520485454502050';
wwv_flow_imp.g_varchar2_table(4908) := '4F5354206D6574686F642073656E6473206461746120746F20746865207365727665722E205468652074797065206F662074686520626F6479206F6620746865207265717565737420697320696E646963617465642062792074686520436F6E74656E74';
wwv_flow_imp.g_varchar2_table(4909) := '2D54797065206865616465722E222920726571756573747320776974682074686520626F6479206050494E47602077696C6C2062652073656E74206279207468652062726F777365722028696E20746865206261636B67726F756E64292E205479706963';
wwv_flow_imp.g_varchar2_table(4910) := '616C6C79207573656420666F7220747261636B696E672E277D7D2C7B6E616D653A2272656C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22537065636966696573207468652072656C6174696F6E736869';
wwv_flow_imp.g_varchar2_table(4911) := '70206F662074686520746172676574206F626A65637420746F20746865206C696E6B206F626A6563742E205468652076616C756520697320612073706163652D736570617261746564206C697374206F66205B6C696E6B2074797065735D286874747073';
wwv_flow_imp.g_varchar2_table(4912) := '3A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F4C696E6B5F7479706573292E227D7D2C7B6E616D653A22687265666C616E67222C6465736372697074696F6E3A7B6B696E643A226D6172';
wwv_flow_imp.g_varchar2_table(4913) := '6B646F776E222C76616C75653A27546869732061747472696275746520696E64696361746573207468652068756D616E206C616E6775616765206F6620746865206C696E6B6564207265736F757263652E20497420697320707572656C79206164766973';
wwv_flow_imp.g_varchar2_table(4914) := '6F72792C2077697468206E6F206275696C742D696E2066756E6374696F6E616C6974792E20416C6C6F7765642076616C756573206172652064657465726D696E6564206279205B42435034375D2868747470733A2F2F7777772E696574662E6F72672F72';
wwv_flow_imp.g_varchar2_table(4915) := '66632F6263702F62637034372E74787420225461677320666F72204964656E74696679696E67204C616E67756167657322292E277D7D2C7B6E616D653A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C';
wwv_flow_imp.g_varchar2_table(4916) := '75653A2753706563696669657320746865206D65646961207479706520696E2074686520666F726D206F662061205B4D494D4520747970655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F47';
wwv_flow_imp.g_varchar2_table(4917) := '6C6F73736172792F4D494D455F7479706520224D494D4520747970653A2041C2A04D494D452074797065C2A0286E6F772070726F7065726C792063616C6C656420226D656469612074797065222C20627574C2A0616C736F20736F6D6574696D65732022';
wwv_flow_imp.g_varchar2_table(4918) := '636F6E74656E7420747970652229206973206120737472696E672073656E7420616C6F6E67C2A07769746820612066696C6520696E6469636174696E67207468652074797065206F66207468652066696C65202864657363726962696E67207468652063';
wwv_flow_imp.g_varchar2_table(4919) := '6F6E74656E7420666F726D61742C20666F72206578616D706C652C206120736F756E642066696C65206D69676874206265206C6162656C6564C2A0617564696F2F6F67672C206F7220616E20696D6167652066696C65C2A0696D6167652F706E67292E22';
wwv_flow_imp.g_varchar2_table(4920) := '2920666F7220746865206C696E6B65642055524C2E20497420697320707572656C792061647669736F72792C2077697468206E6F206275696C742D696E2066756E6374696F6E616C6974792E277D7D2C7B6E616D653A227265666572726572706F6C6963';
wwv_flow_imp.g_varchar2_table(4921) := '79222C6465736372697074696F6E3A22496E64696361746573207768696368205B72656665727265725D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F48656164657273';
wwv_flow_imp.g_varchar2_table(4922) := '2F526566657265722920746F2073656E64207768656E206665746368696E67207468652055524C3A5C6E5C6E2A20202060276E6F2D72656665727265722760206D65616E73207468652060526566657265723A60206865616465722077696C6C206E6F74';
wwv_flow_imp.g_varchar2_table(4923) := '2062652073656E742E5C6E2A20202060276E6F2D72656665727265722D7768656E2D646F776E67726164652760206D65616E73206E6F2060526566657265723A60206865616465722077696C6C2062652073656E74207768656E206E617669676174696E';
wwv_flow_imp.g_varchar2_table(4924) := '6720746F20616E206F726967696E20776974686F75742048545450532E2054686973206973207468652064656661756C74206265686176696F722E5C6E2A20202060276F726967696E2760206D65616E73207468652072656665727265722077696C6C20';
wwv_flow_imp.g_varchar2_table(4925) := '626520746865205B6F726967696E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4F726967696E29206F662074686520706167652C206E6F7420696E636C7564696E67';
wwv_flow_imp.g_varchar2_table(4926) := '20696E666F726D6174696F6E2061667465722074686520646F6D61696E2E5C6E2A20202060276F726967696E2D7768656E2D63726F73732D6F726967696E2760206D65616E696E672074686174206E617669676174696F6E7320746F206F74686572206F';
wwv_flow_imp.g_varchar2_table(4927) := '726967696E732077696C6C206265206C696D6974656420746F2074686520736368656D652C2074686520686F737420616E642074686520706F72742C207768696C65206E617669676174696F6E73206F6E207468652073616D65206F726967696E207769';
wwv_flow_imp.g_varchar2_table(4928) := '6C6C20696E636C75646520746865207265666572726572277320706174682E5C6E2A20202060277374726963742D6F726967696E2D7768656E2D63726F73732D6F726967696E27605C6E2A2020206027756E736166652D75726C2760206D65616E732074';
wwv_flow_imp.g_varchar2_table(4929) := '68652072656665727265722077696C6C20696E636C75646520746865206F726967696E20616E6420706174682C20627574206E6F742074686520667261676D656E742C2070617373776F72642C206F7220757365726E616D652E20546869732069732075';
wwv_flow_imp.g_varchar2_table(4930) := '6E7361666520626563617573652069742063616E206C65616B20646174612066726F6D207365637572652055524C7320746F20696E736563757265206F6E65732E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E63';
wwv_flow_imp.g_varchar2_table(4931) := '65222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F61227D5D7D2C7B6E616D653A22656D222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(4932) := '646F776E222C76616C75653A2254686520656D20656C656D656E7420726570726573656E74732073747265737320656D706861736973206F662069747320636F6E74656E74732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B';
wwv_flow_imp.g_varchar2_table(4933) := '7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F656D227D5D7D2C7B6E616D653A227374726F6E6722';
wwv_flow_imp.g_varchar2_table(4934) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207374726F6E6720656C656D656E7420726570726573656E7473207374726F6E6720696D706F7274616E63652C20736572696F75736E6573732C206F';
wwv_flow_imp.g_varchar2_table(4935) := '7220757267656E637920666F722069747320636F6E74656E74732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F706572';
wwv_flow_imp.g_varchar2_table(4936) := '2E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7374726F6E67227D5D7D2C7B6E616D653A22736D616C6C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520';
wwv_flow_imp.g_varchar2_table(4937) := '736D616C6C20656C656D656E7420726570726573656E7473207369646520636F6D6D656E7473207375636820617320736D616C6C207072696E742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E2052';
wwv_flow_imp.g_varchar2_table(4938) := '65666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F736D616C6C227D5D7D2C7B6E616D653A2273222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(4939) := '6B696E643A226D61726B646F776E222C76616C75653A22546865207320656C656D656E7420726570726573656E747320636F6E74656E7473207468617420617265206E6F206C6F6E676572206163637572617465206F72206E6F206C6F6E676572207265';
wwv_flow_imp.g_varchar2_table(4940) := '6C6576616E742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765';
wwv_flow_imp.g_varchar2_table(4941) := '622F48544D4C2F456C656D656E742F73227D5D7D2C7B6E616D653A2263697465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206369746520656C656D656E7420726570726573656E7473206120';
wwv_flow_imp.g_varchar2_table(4942) := '7265666572656E636520746F206120637265617469766520776F726B2E204974206D75737420696E636C75646520746865207469746C65206F662074686520776F726B206F7220746865206E616D65206F662074686520617574686F7228706572736F6E';
wwv_flow_imp.g_varchar2_table(4943) := '2C2070656F706C65206F72206F7267616E697A6174696F6E29206F7220616E2055524C207265666572656E63652C206F722061207265666572656E636520696E20616262726576696174656420666F726D206173207065722074686520636F6E76656E74';
wwv_flow_imp.g_varchar2_table(4944) := '696F6E73207573656420666F7220746865206164646974696F6E206F66206369746174696F6E206D657461646174612E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75';
wwv_flow_imp.g_varchar2_table(4945) := '726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F63697465227D5D7D2C7B6E616D653A2271222C6465736372697074696F6E3A7B6B696E643A226D61726B646F';
wwv_flow_imp.g_varchar2_table(4946) := '776E222C76616C75653A22546865207120656C656D656E7420726570726573656E747320736F6D65207068726173696E6720636F6E74656E742071756F7465642066726F6D20616E6F7468657220736F757263652E227D2C617474726962757465733A5B';
wwv_flow_imp.g_varchar2_table(4947) := '7B6E616D653A2263697465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652076616C7565206F6620746869732061747472696275746520697320612055524C20746861742064657369676E617465';
wwv_flow_imp.g_varchar2_table(4948) := '73206120736F7572636520646F63756D656E74206F72206D65737361676520666F722074686520696E666F726D6174696F6E2071756F7465642E20546869732061747472696275746520697320696E74656E64656420746F20706F696E7420746F20696E';
wwv_flow_imp.g_varchar2_table(4949) := '666F726D6174696F6E206578706C61696E696E672074686520636F6E74657874206F7220746865207265666572656E636520666F72207468652071756F74652E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E63';
wwv_flow_imp.g_varchar2_table(4950) := '65222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F71227D5D7D2C7B6E616D653A2264666E222C6465736372697074696F6E3A7B6B696E643A226D6172';
wwv_flow_imp.g_varchar2_table(4951) := '6B646F776E222C76616C75653A225468652064666E20656C656D656E7420726570726573656E74732074686520646566696E696E6720696E7374616E6365206F662061207465726D2E20546865207061726167726170682C206465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(4952) := '206C6973742067726F75702C206F722073656374696F6E207468617420697320746865206E65617265737420616E636573746F72206F66207468652064666E20656C656D656E74206D75737420616C736F20636F6E7461696E2074686520646566696E69';
wwv_flow_imp.g_varchar2_table(4953) := '74696F6E28732920666F7220746865207465726D20676976656E206279207468652064666E20656C656D656E742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C';
wwv_flow_imp.g_varchar2_table(4954) := '3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F64666E227D5D7D2C7B6E616D653A2261626272222C6465736372697074696F6E3A7B6B696E643A226D61726B646F';
wwv_flow_imp.g_varchar2_table(4955) := '776E222C76616C75653A22546865206162627220656C656D656E7420726570726573656E747320616E20616262726576696174696F6E206F72206163726F6E796D2C206F7074696F6E616C6C7920776974682069747320657870616E73696F6E2E205468';
wwv_flow_imp.g_varchar2_table(4956) := '65207469746C6520617474726962757465206D6179206265207573656420746F2070726F7669646520616E20657870616E73696F6E206F662074686520616262726576696174696F6E2E20546865206174747269627574652C2069662073706563696669';
wwv_flow_imp.g_varchar2_table(4957) := '65642C206D75737420636F6E7461696E20616E20657870616E73696F6E206F662074686520616262726576696174696F6E2C20616E64206E6F7468696E6720656C73652E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(4958) := '6D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F61626272227D5D7D2C7B6E616D653A2272756279222C6465';
wwv_flow_imp.g_varchar2_table(4959) := '736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207275627920656C656D656E7420616C6C6F7773206F6E65206F72206D6F7265207370616E73206F66207068726173696E6720636F6E74656E7420746F2062';
wwv_flow_imp.g_varchar2_table(4960) := '65206D61726B65642077697468207275627920616E6E6F746174696F6E732E205275627920616E6E6F746174696F6E73206172652073686F72742072756E73206F6620746578742070726573656E74656420616C6F6E6773696465206261736520746578';
wwv_flow_imp.g_varchar2_table(4961) := '742C207072696D6172696C79207573656420696E204561737420417369616E207479706F677261706879206173206120677569646520666F722070726F6E756E63696174696F6E206F7220746F20696E636C756465206F7468657220616E6E6F74617469';
wwv_flow_imp.g_varchar2_table(4962) := '6F6E732E20496E204A6170616E6573652C207468697320666F726D206F66207479706F67726170687920697320616C736F206B6E6F776E206173206675726967616E612E205275627920746578742063616E20617070656172206F6E2065697468657220';
wwv_flow_imp.g_varchar2_table(4963) := '736964652C20616E6420736F6D6574696D657320626F74682073696465732C206F6620746865206261736520746578742C20616E6420697420697320706F737369626C6520746F20636F6E74726F6C2069747320706F736974696F6E207573696E672043';
wwv_flow_imp.g_varchar2_table(4964) := '53532E2041206D6F726520636F6D706C65746520696E74726F64756374696F6E20746F20727562792063616E20626520666F756E6420696E20746865205573652043617365732026204578706C6F7261746F727920417070726F616368657320666F7220';
wwv_flow_imp.g_varchar2_table(4965) := '52756279204D61726B757020646F63756D656E742061732077656C6C20617320696E204353532052756279204D6F64756C65204C6576656C20312E205B525542592D55435D205B435353525542595D227D2C617474726962757465733A5B5D2C72656665';
wwv_flow_imp.g_varchar2_table(4966) := '72656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F72756279227D5D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(4967) := '653A227262222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520726220656C656D656E74206D61726B73207468652062617365207465787420636F6D706F6E656E74206F662061207275627920616E';
wwv_flow_imp.g_varchar2_table(4968) := '6E6F746174696F6E2E205768656E20697420697320746865206368696C64206F662061207275627920656C656D656E742C20697420646F65736E277420726570726573656E7420616E797468696E6720697473656C662C20627574206974732070617265';
wwv_flow_imp.g_varchar2_table(4969) := '6E74207275627920656C656D656E7420757365732069742061732070617274206F662064657465726D696E696E67207768617420697420726570726573656E74732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D65';
wwv_flow_imp.g_varchar2_table(4970) := '3A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7262227D5D7D2C7B6E616D653A227274222C6465736372697074';
wwv_flow_imp.g_varchar2_table(4971) := '696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520727420656C656D656E74206D61726B73207468652072756279207465787420636F6D706F6E656E74206F662061207275627920616E6E6F746174696F6E2E205768656E20';
wwv_flow_imp.g_varchar2_table(4972) := '697420697320746865206368696C64206F662061207275627920656C656D656E74206F72206F6620616E2072746320656C656D656E74207468617420697320697473656C6620746865206368696C64206F662061207275627920656C656D656E742C2069';
wwv_flow_imp.g_varchar2_table(4973) := '7420646F65736E277420726570726573656E7420616E797468696E6720697473656C662C206275742069747320616E636573746F72207275627920656C656D656E7420757365732069742061732070617274206F662064657465726D696E696E67207768';
wwv_flow_imp.g_varchar2_table(4974) := '617420697420726570726573656E74732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F';
wwv_flow_imp.g_varchar2_table(4975) := '72672F646F63732F5765622F48544D4C2F456C656D656E742F7274227D5D7D2C7B6E616D653A227270222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520727020656C656D656E7420697320757365';
wwv_flow_imp.g_varchar2_table(4976) := '6420746F2070726F766964652066616C6C6261636B207465787420746F2062652073686F776E2062792075736572206167656E7473207468617420646F6E277420737570706F7274207275627920616E6E6F746174696F6E732E204F6E65207769646573';
wwv_flow_imp.g_varchar2_table(4977) := '707265616420636F6E76656E74696F6E20697320746F2070726F7669646520706172656E7468657365732061726F756E64207468652072756279207465787420636F6D706F6E656E74206F662061207275627920616E6E6F746174696F6E2E227D2C6174';
wwv_flow_imp.g_varchar2_table(4978) := '74726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D65';
wwv_flow_imp.g_varchar2_table(4979) := '6E742F7270227D5D7D2C7B6E616D653A2274696D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652074696D6520656C656D656E7420726570726573656E74732069747320636F6E74656E74732C';
wwv_flow_imp.g_varchar2_table(4980) := '20616C6F6E6720776974682061206D616368696E652D7265616461626C6520666F726D206F662074686F736520636F6E74656E747320696E20746865206461746574696D65206174747269627574652E20546865206B696E64206F6620636F6E74656E74';
wwv_flow_imp.g_varchar2_table(4981) := '206973206C696D6974656420746F20766172696F7573206B696E6473206F662064617465732C2074696D65732C2074696D652D7A6F6E65206F6666736574732C20616E64206475726174696F6E732C206173206465736372696265642062656C6F772E22';
wwv_flow_imp.g_varchar2_table(4982) := '7D2C617474726962757465733A5B7B6E616D653A226461746574696D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520696E64696361746573207468652074696D65';
wwv_flow_imp.g_varchar2_table(4983) := '20616E642F6F722064617465206F662074686520656C656D656E7420616E64206D75737420626520696E206F6E65206F662074686520666F726D617473206465736372696265642062656C6F772E227D7D5D2C7265666572656E6365733A5B7B6E616D65';
wwv_flow_imp.g_varchar2_table(4984) := '3A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F74696D65227D5D7D2C7B6E616D653A22636F6465222C64657363';
wwv_flow_imp.g_varchar2_table(4985) := '72697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520636F646520656C656D656E7420726570726573656E7473206120667261676D656E74206F6620636F6D707574657220636F64652E205468697320636F756C6420';
wwv_flow_imp.g_varchar2_table(4986) := '626520616E20584D4C20656C656D656E74206E616D652C20612066696C65206E616D652C206120636F6D70757465722070726F6772616D2C206F7220616E79206F7468657220737472696E672074686174206120636F6D707574657220776F756C642072';
wwv_flow_imp.g_varchar2_table(4987) := '65636F676E697A652E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F';
wwv_flow_imp.g_varchar2_table(4988) := '5765622F48544D4C2F456C656D656E742F636F6465227D5D7D2C7B6E616D653A22766172222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652076617220656C656D656E7420726570726573656E7473';
wwv_flow_imp.g_varchar2_table(4989) := '2061207661726961626C652E205468697320636F756C6420626520616E2061637475616C207661726961626C6520696E2061206D617468656D61746963616C2065787072657373696F6E206F722070726F6772616D6D696E6720636F6E746578742C2061';
wwv_flow_imp.g_varchar2_table(4990) := '6E206964656E74696669657220726570726573656E74696E67206120636F6E7374616E742C20612073796D626F6C206964656E74696679696E67206120706879736963616C207175616E746974792C20612066756E6374696F6E20706172616D65746572';
wwv_flow_imp.g_varchar2_table(4991) := '2C206F72206A7573742062652061207465726D2075736564206173206120706C616365686F6C64657220696E2070726F73652E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365';
wwv_flow_imp.g_varchar2_table(4992) := '222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F766172227D5D7D2C7B6E616D653A2273616D70222C6465736372697074696F6E3A7B6B696E643A226D';
wwv_flow_imp.g_varchar2_table(4993) := '61726B646F776E222C76616C75653A225468652073616D7020656C656D656E7420726570726573656E74732073616D706C65206F722071756F746564206F75747075742066726F6D20616E6F746865722070726F6772616D206F7220636F6D707574696E';
wwv_flow_imp.g_varchar2_table(4994) := '672073797374656D2E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F';
wwv_flow_imp.g_varchar2_table(4995) := '5765622F48544D4C2F456C656D656E742F73616D70227D5D7D2C7B6E616D653A226B6264222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206B626420656C656D656E7420726570726573656E7473';
wwv_flow_imp.g_varchar2_table(4996) := '207573657220696E70757420287479706963616C6C79206B6579626F61726420696E7075742C20616C74686F756768206974206D617920616C736F206265207573656420746F20726570726573656E74206F7468657220696E7075742C20737563682061';
wwv_flow_imp.g_varchar2_table(4997) := '7320766F69636520636F6D6D616E6473292E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E';
wwv_flow_imp.g_varchar2_table(4998) := '6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6B6264227D5D7D2C7B6E616D653A22737562222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652073756220656C656D656E74207265';
wwv_flow_imp.g_varchar2_table(4999) := '70726573656E74732061207375627363726970742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(5000) := '6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F737562227D5D7D2C7B6E616D653A22737570222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652073757020656C656D656E74';
wwv_flow_imp.g_varchar2_table(5001) := '20726570726573656E747320612073757065727363726970742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(5002) := '6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F737570227D5D7D2C7B6E616D653A2269222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206920656C656D656E';
wwv_flow_imp.g_varchar2_table(5003) := '7420726570726573656E74732061207370616E206F66207465787420696E20616E20616C7465726E61746520766F696365206F72206D6F6F642C206F72206F7468657277697365206F66667365742066726F6D20746865206E6F726D616C2070726F7365';
wwv_flow_imp.g_varchar2_table(5004) := '20696E2061206D616E6E657220696E6469636174696E67206120646966666572656E74207175616C697479206F6620746578742C20737563682061732061207461786F6E6F6D69632064657369676E6174696F6E2C206120746563686E6963616C207465';
wwv_flow_imp.g_varchar2_table(5005) := '726D2C20616E206964696F6D61746963207068726173652066726F6D20616E6F74686572206C616E67756167652C207472616E736C697465726174696F6E2C20612074686F756768742C206F7220612073686970206E616D6520696E205765737465726E';
wwv_flow_imp.g_varchar2_table(5006) := '2074657874732E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765';
wwv_flow_imp.g_varchar2_table(5007) := '622F48544D4C2F456C656D656E742F69227D5D7D2C7B6E616D653A2262222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206220656C656D656E7420726570726573656E74732061207370616E206F';
wwv_flow_imp.g_varchar2_table(5008) := '66207465787420746F20776869636820617474656E74696F6E206973206265696E6720647261776E20666F72207574696C6974617269616E20707572706F73657320776974686F757420636F6E766579696E6720616E7920657874726120696D706F7274';
wwv_flow_imp.g_varchar2_table(5009) := '616E636520616E642077697468206E6F20696D706C69636174696F6E206F6620616E20616C7465726E61746520766F696365206F72206D6F6F642C2073756368206173206B657920776F72647320696E206120646F63756D656E74206162737472616374';
wwv_flow_imp.g_varchar2_table(5010) := '2C2070726F64756374206E616D657320696E2061207265766965772C20616374696F6E61626C6520776F72647320696E20696E74657261637469766520746578742D64726976656E20736F6674776172652C206F7220616E2061727469636C65206C6564';
wwv_flow_imp.g_varchar2_table(5011) := '652E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D';
wwv_flow_imp.g_varchar2_table(5012) := '4C2F456C656D656E742F62227D5D7D2C7B6E616D653A2275222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207520656C656D656E7420726570726573656E74732061207370616E206F6620746578';
wwv_flow_imp.g_varchar2_table(5013) := '74207769746820616E20756E6172746963756C617465642C2074686F756768206578706C696369746C792072656E64657265642C206E6F6E2D7465787475616C20616E6E6F746174696F6E2C2073756368206173206C6162656C696E6720746865207465';
wwv_flow_imp.g_varchar2_table(5014) := '7874206173206265696E6720612070726F706572206E616D6520696E204368696E6573652074657874202861204368696E6573652070726F706572206E616D65206D61726B292C206F72206C6162656C696E67207468652074657874206173206265696E';
wwv_flow_imp.g_varchar2_table(5015) := '67206D69737370656C742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63';
wwv_flow_imp.g_varchar2_table(5016) := '732F5765622F48544D4C2F456C656D656E742F75227D5D7D2C7B6E616D653A226D61726B222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D61726B20656C656D656E7420726570726573656E74';
wwv_flow_imp.g_varchar2_table(5017) := '7320612072756E206F66207465787420696E206F6E6520646F63756D656E74206D61726B6564206F7220686967686C69676874656420666F72207265666572656E636520707572706F7365732C2064756520746F206974732072656C6576616E63652069';
wwv_flow_imp.g_varchar2_table(5018) := '6E20616E6F7468657220636F6E746578742E205768656E207573656420696E20612071756F746174696F6E206F72206F7468657220626C6F636B206F66207465787420726566657272656420746F2066726F6D207468652070726F73652C20697420696E';
wwv_flow_imp.g_varchar2_table(5019) := '64696361746573206120686967686C69676874207468617420776173206E6F74206F726967696E616C6C792070726573656E742062757420776869636820686173206265656E20616464656420746F206272696E67207468652072656164657227732061';
wwv_flow_imp.g_varchar2_table(5020) := '7474656E74696F6E20746F20612070617274206F662074686520746578742074686174206D69676874206E6F742068617665206265656E20636F6E7369646572656420696D706F7274616E7420627920746865206F726967696E616C20617574686F7220';
wwv_flow_imp.g_varchar2_table(5021) := '7768656E2074686520626C6F636B20776173206F726967696E616C6C79207772697474656E2C20627574207768696368206973206E6F7720756E6465722070726576696F75736C7920756E6578706563746564207363727574696E792E205768656E2075';
wwv_flow_imp.g_varchar2_table(5022) := '73656420696E20746865206D61696E2070726F7365206F66206120646F63756D656E742C20697420696E6469636174657320612070617274206F662074686520646F63756D656E74207468617420686173206265656E20686967686C6967687465642064';
wwv_flow_imp.g_varchar2_table(5023) := '756520746F20697473206C696B656C792072656C6576616E636520746F20746865207573657227732063757272656E742061637469766974792E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265';
wwv_flow_imp.g_varchar2_table(5024) := '666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6D61726B227D5D7D2C7B6E616D653A22626469222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(5025) := '6B696E643A226D61726B646F776E222C76616C75653A225468652062646920656C656D656E7420726570726573656E74732061207370616E206F662074657874207468617420697320746F2062652069736F6C617465642066726F6D2069747320737572';
wwv_flow_imp.g_varchar2_table(5026) := '726F756E64696E677320666F722074686520707572706F736573206F66206269646972656374696F6E616C207465787420666F726D617474696E672E205B424944495D227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(5027) := '653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F626469227D5D7D2C7B6E616D653A2262646F222C6465736372';
wwv_flow_imp.g_varchar2_table(5028) := '697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652062646F20656C656D656E7420726570726573656E7473206578706C69636974207465787420646972656374696F6E616C69747920666F726D617474696E6720636F';
wwv_flow_imp.g_varchar2_table(5029) := '6E74726F6C20666F7220697473206368696C6472656E2E20497420616C6C6F777320617574686F727320746F206F766572726964652074686520556E69636F6465206269646972656374696F6E616C20616C676F726974686D206279206578706C696369';
wwv_flow_imp.g_varchar2_table(5030) := '746C792073706563696679696E67206120646972656374696F6E206F766572726964652E205B424944495D227D2C617474726962757465733A5B7B6E616D653A22646972222C6465736372697074696F6E3A2254686520646972656374696F6E20696E20';
wwv_flow_imp.g_varchar2_table(5031) := '776869636820746578742073686F756C642062652072656E646572656420696E207468697320656C656D656E74277320636F6E74656E74732E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606C7472603A20496E6469636174';
wwv_flow_imp.g_varchar2_table(5032) := '657320746861742074686520746578742073686F756C6420676F20696E2061206C6566742D746F2D726967687420646972656374696F6E2E5C6E2A2020206072746C603A20496E6469636174657320746861742074686520746578742073686F756C6420';
wwv_flow_imp.g_varchar2_table(5033) := '676F20696E20612072696768742D746F2D6C65667420646972656374696F6E2E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C61';
wwv_flow_imp.g_varchar2_table(5034) := '2E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F62646F227D5D7D2C7B6E616D653A227370616E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207370616E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(5035) := '20646F65736E2774206D65616E20616E797468696E67206F6E20697473206F776E2C206275742063616E2062652075736566756C207768656E207573656420746F67657468657220776974682074686520676C6F62616C20617474726962757465732C20';
wwv_flow_imp.g_varchar2_table(5036) := '652E672E20636C6173732C206C616E672C206F72206469722E20497420726570726573656E747320697473206368696C6472656E2E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E';
wwv_flow_imp.g_varchar2_table(5037) := '6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7370616E227D5D7D2C7B6E616D653A226272222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(5038) := '6D61726B646F776E222C76616C75653A2254686520627220656C656D656E7420726570726573656E74732061206C696E6520627265616B2E227D2C617474726962757465733A5B7B6E616D653A22636C656172222C6465736372697074696F6E3A22496E';
wwv_flow_imp.g_varchar2_table(5039) := '6469636174657320776865726520746F20626567696E20746865206E657874206C696E652061667465722074686520627265616B2E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470';
wwv_flow_imp.g_varchar2_table(5040) := '733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6272227D5D7D2C7B6E616D653A22776272222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(5041) := '653A225468652077627220656C656D656E7420726570726573656E74732061206C696E6520627265616B206F70706F7274756E6974792E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572';
wwv_flow_imp.g_varchar2_table(5042) := '656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F776272227D5D7D2C7B6E616D653A22696E73222C6465736372697074696F6E3A7B6B696E64';
wwv_flow_imp.g_varchar2_table(5043) := '3A226D61726B646F776E222C76616C75653A2254686520696E7320656C656D656E7420726570726573656E747320616E206164646974696F6E20746F2074686520646F63756D656E742E227D2C617474726962757465733A5B7B6E616D653A2263697465';
wwv_flow_imp.g_varchar2_table(5044) := '222C6465736372697074696F6E3A22546869732061747472696275746520646566696E65732074686520555249206F662061207265736F757263652074686174206578706C61696E7320746865206368616E67652C20737563682061732061206C696E6B';
wwv_flow_imp.g_varchar2_table(5045) := '20746F206D656574696E67206D696E75746573206F722061207469636B657420696E20612074726F75626C6573686F6F74696E672073797374656D2E227D2C7B6E616D653A226461746574696D65222C6465736372697074696F6E3A2754686973206174';
wwv_flow_imp.g_varchar2_table(5046) := '7472696275746520696E64696361746573207468652074696D6520616E642064617465206F6620746865206368616E676520616E64206D75737420626520612076616C69642064617465207769746820616E206F7074696F6E616C2074696D6520737472';
wwv_flow_imp.g_varchar2_table(5047) := '696E672E204966207468652076616C75652063616E6E6F742062652070617273656420617320612064617465207769746820616E206F7074696F6E616C2074696D6520737472696E672C2074686520656C656D656E7420646F6573206E6F742068617665';
wwv_flow_imp.g_varchar2_table(5048) := '20616E206173736F6369617465642074696D65207374616D702E20466F722074686520666F726D6174206F662074686520737472696E6720776974686F757420612074696D652C20736565205B466F726D6174206F6620612076616C6964206461746520';
wwv_flow_imp.g_varchar2_table(5049) := '737472696E675D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747323466F726D61745F6F665F615F76616C69645F6461';
wwv_flow_imp.g_varchar2_table(5050) := '74655F737472696E6720224365727461696E2048544D4C20656C656D656E747320757365206461746520616E642F6F722074696D652076616C7565732E2054686520666F726D617473206F662074686520737472696E6773207468617420737065636966';
wwv_flow_imp.g_varchar2_table(5051) := '79207468657365206172652064657363726962656420696E20746869732061727469636C652E222920696E205B4461746520616E642074696D6520666F726D617473207573656420696E2048544D4C5D2868747470733A2F2F646576656C6F7065722E6D';
wwv_flow_imp.g_varchar2_table(5052) := '6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747320224365727461696E2048544D4C20656C656D656E747320757365206461746520616E642F6F722074696D652076616C';
wwv_flow_imp.g_varchar2_table(5053) := '7565732E2054686520666F726D617473206F662074686520737472696E677320746861742073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E22292E2054686520666F726D6174206F662074';
wwv_flow_imp.g_varchar2_table(5054) := '686520737472696E6720696620697420696E636C7564657320626F7468206461746520616E642074696D6520697320636F766572656420696E205B466F726D6174206F6620612076616C6964206C6F63616C206461746520616E642074696D6520737472';
wwv_flow_imp.g_varchar2_table(5055) := '696E675D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747323466F726D61745F6F665F615F76616C69645F6C6F63616C';
wwv_flow_imp.g_varchar2_table(5056) := '5F646174655F616E645F74696D655F737472696E6720224365727461696E2048544D4C20656C656D656E747320757365206461746520616E642F6F722074696D652076616C7565732E2054686520666F726D617473206F662074686520737472696E6773';
wwv_flow_imp.g_varchar2_table(5057) := '20746861742073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E222920696E205B4461746520616E642074696D6520666F726D617473207573656420696E2048544D4C5D2868747470733A2F';
wwv_flow_imp.g_varchar2_table(5058) := '2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747320224365727461696E2048544D4C20656C656D656E747320757365206461746520616E64';
wwv_flow_imp.g_varchar2_table(5059) := '2F6F722074696D652076616C7565732E2054686520666F726D617473206F662074686520737472696E677320746861742073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E22292E277D5D2C';
wwv_flow_imp.g_varchar2_table(5060) := '7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F696E73227D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(5061) := '6E616D653A2264656C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652064656C20656C656D656E7420726570726573656E747320612072656D6F76616C2066726F6D2074686520646F63756D656E';
wwv_flow_imp.g_varchar2_table(5062) := '742E227D2C617474726962757465733A5B7B6E616D653A2263697465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22412055524920666F722061207265736F757263652074686174206578706C61696E73';
wwv_flow_imp.g_varchar2_table(5063) := '20746865206368616E67652028666F72206578616D706C652C206D656574696E67206D696E75746573292E227D7D2C7B6E616D653A226461746574696D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27';
wwv_flow_imp.g_varchar2_table(5064) := '546869732061747472696275746520696E64696361746573207468652074696D6520616E642064617465206F6620746865206368616E676520616E64206D75737420626520612076616C6964206461746520737472696E67207769746820616E206F7074';
wwv_flow_imp.g_varchar2_table(5065) := '696F6E616C2074696D652E204966207468652076616C75652063616E6E6F742062652070617273656420617320612064617465207769746820616E206F7074696F6E616C2074696D6520737472696E672C2074686520656C656D656E7420646F6573206E';
wwv_flow_imp.g_varchar2_table(5066) := '6F74206861766520616E206173736F6369617465642074696D65207374616D702E20466F722074686520666F726D6174206F662074686520737472696E6720776974686F757420612074696D652C20736565205B466F726D6174206F6620612076616C69';
wwv_flow_imp.g_varchar2_table(5067) := '64206461746520737472696E675D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747323466F726D61745F6F665F615F76';
wwv_flow_imp.g_varchar2_table(5068) := '616C69645F646174655F737472696E6720224365727461696E2048544D4C20656C656D656E747320757365206461746520616E642F6F722074696D652076616C7565732E2054686520666F726D617473206F662074686520737472696E67732074686174';
wwv_flow_imp.g_varchar2_table(5069) := '2073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E222920696E205B4461746520616E642074696D6520666F726D617473207573656420696E2048544D4C5D2868747470733A2F2F64657665';
wwv_flow_imp.g_varchar2_table(5070) := '6C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747320224365727461696E2048544D4C20656C656D656E747320757365206461746520616E642F6F722074';
wwv_flow_imp.g_varchar2_table(5071) := '696D652076616C7565732E2054686520666F726D617473206F662074686520737472696E677320746861742073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E22292E2054686520666F726D';
wwv_flow_imp.g_varchar2_table(5072) := '6174206F662074686520737472696E6720696620697420696E636C7564657320626F7468206461746520616E642074696D6520697320636F766572656420696E205B466F726D6174206F6620612076616C6964206C6F63616C206461746520616E642074';
wwv_flow_imp.g_varchar2_table(5073) := '696D6520737472696E675D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747323466F726D61745F6F665F615F76616C69';
wwv_flow_imp.g_varchar2_table(5074) := '645F6C6F63616C5F646174655F616E645F74696D655F737472696E6720224365727461696E2048544D4C20656C656D656E747320757365206461746520616E642F6F722074696D652076616C7565732E2054686520666F726D617473206F662074686520';
wwv_flow_imp.g_varchar2_table(5075) := '737472696E677320746861742073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E222920696E205B4461746520616E642074696D6520666F726D617473207573656420696E2048544D4C5D28';
wwv_flow_imp.g_varchar2_table(5076) := '68747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F446174655F616E645F74696D655F666F726D61747320224365727461696E2048544D4C20656C656D656E7473207573652064';
wwv_flow_imp.g_varchar2_table(5077) := '61746520616E642F6F722074696D652076616C7565732E2054686520666F726D617473206F662074686520737472696E677320746861742073706563696679207468657365206172652064657363726962656420696E20746869732061727469636C652E';
wwv_flow_imp.g_varchar2_table(5078) := '22292E277D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F64';
wwv_flow_imp.g_varchar2_table(5079) := '656C227D5D7D2C7B6E616D653A2270696374757265222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207069637475726520656C656D656E74206973206120636F6E7461696E657220776869636820';
wwv_flow_imp.g_varchar2_table(5080) := '70726F7669646573206D756C7469706C6520736F757263657320746F2069747320636F6E7461696E656420696D6720656C656D656E7420746F20616C6C6F7720617574686F727320746F206465636C617261746976656C7920636F6E74726F6C206F7220';
wwv_flow_imp.g_varchar2_table(5081) := '676976652068696E747320746F207468652075736572206167656E742061626F757420776869636820696D616765207265736F7572636520746F207573652C206261736564206F6E207468652073637265656E20706978656C2064656E736974792C2076';
wwv_flow_imp.g_varchar2_table(5082) := '696577706F72742073697A652C20696D61676520666F726D61742C20616E64206F7468657220666163746F72732E20497420726570726573656E747320697473206368696C6472656E2E227D2C617474726962757465733A5B5D2C7265666572656E6365';
wwv_flow_imp.g_varchar2_table(5083) := '733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F70696374757265227D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(5084) := '22696D67222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20696D6720656C656D656E7420726570726573656E747320616E20696D6167652E227D2C617474726962757465733A5B7B6E616D653A2261';
wwv_flow_imp.g_varchar2_table(5085) := '6C74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546869732061747472696275746520646566696E657320616E20616C7465726E61746976652074657874206465736372697074696F6E206F66207468';
wwv_flow_imp.g_varchar2_table(5086) := '6520696D6167652E5C6E5C6E2A2A4E6F74653A2A2A2042726F777365727320646F206E6F7420616C7761797320646973706C61792074686520696D616765207265666572656E6365642062792074686520656C656D656E742E2054686973206973207468';
wwv_flow_imp.g_varchar2_table(5087) := '65206361736520666F72206E6F6E2D67726170686963616C2062726F77736572732028696E636C7564696E672074686F736520757365642062792070656F706C6520776974682076697375616C20696D706169726D656E7473292C206966207468652075';
wwv_flow_imp.g_varchar2_table(5088) := '7365722063686F6F736573206E6F7420746F20646973706C617920696D616765732C206F72206966207468652062726F777365722063616E6E6F7420646973706C61792074686520696D616765206265636175736520697420697320696E76616C696420';
wwv_flow_imp.g_varchar2_table(5089) := '6F7220616E205B756E737570706F7274656420747970655D2823537570706F727465645F696D6167655F666F726D617473292E20496E2074686573652063617365732C207468652062726F77736572206D6179207265706C6163652074686520696D6167';
wwv_flow_imp.g_varchar2_table(5090) := '65207769746820746865207465787420646566696E656420696E207468697320656C656D656E745C27732060616C7460206174747269627574652E20596F752073686F756C642C20666F7220746865736520726561736F6E7320616E64206F7468657273';
wwv_flow_imp.g_varchar2_table(5091) := '2C2070726F7669646520612075736566756C2076616C756520666F722060616C7460207768656E6576657220706F737369626C652E5C6E5C6E2A2A4E6F74653A2A2A204F6D697474696E6720746869732061747472696275746520616C746F6765746865';
wwv_flow_imp.g_varchar2_table(5092) := '7220696E6469636174657320746861742074686520696D6167652069732061206B65792070617274206F662074686520636F6E74656E742C20616E64206E6F207465787475616C206571756976616C656E7420697320617661696C61626C652E20536574';
wwv_flow_imp.g_varchar2_table(5093) := '74696E6720746869732061747472696275746520746F20616E20656D70747920737472696E67202860616C743D2222602920696E646963617465732074686174207468697320696D616765206973205F6E6F745F2061206B65792070617274206F662074';
wwv_flow_imp.g_varchar2_table(5094) := '686520636F6E74656E7420286465636F726174697665292C20616E642074686174206E6F6E2D76697375616C2062726F7773657273206D6179206F6D69742069742066726F6D2072656E646572696E672E277D7D2C7B6E616D653A22737263222C646573';
wwv_flow_imp.g_varchar2_table(5095) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520696D6167652055524C2E205468697320617474726962757465206973206D616E6461746F727920666F722074686520603C696D673E6020656C656D656E742E';
wwv_flow_imp.g_varchar2_table(5096) := '204F6E2062726F777365727320737570706F7274696E672060737263736574602C2060737263602069732074726561746564206C696B6520612063616E64696461746520696D6167652077697468206120706978656C2064656E73697479206465736372';
wwv_flow_imp.g_varchar2_table(5097) := '6970746F72206031786020756E6C65737320616E20696D6167652077697468207468697320706978656C2064656E736974792064657363726970746F7220697320616C726561647920646566696E656420696E20607372637365742C60206F7220756E6C';
wwv_flow_imp.g_varchar2_table(5098) := '65737320607372637365746020636F6E7461696E732027607760272064657363726970746F72732E227D7D2C7B6E616D653A22737263736574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241206C6973';
wwv_flow_imp.g_varchar2_table(5099) := '74206F66206F6E65206F72206D6F726520737472696E67732073657061726174656420627920636F6D6D617320696E6469636174696E67206120736574206F6620706F737369626C6520696D61676520736F757263657320666F72207468652075736572';
wwv_flow_imp.g_varchar2_table(5100) := '206167656E7420746F207573652E204561636820737472696E6720697320636F6D706F736564206F663A5C6E5C6E312E2020612055524C20746F20616E20696D6167652C5C6E322E20206F7074696F6E616C6C792C207768697465737061636520666F6C';
wwv_flow_imp.g_varchar2_table(5101) := '6C6F776564206279206F6E65206F663A5C6E202020202A202020412077696474682064657363726970746F722C206F72206120706F73697469766520696E7465676572206469726563746C7920666F6C6C6F7765642062792027607760272E2054686520';
wwv_flow_imp.g_varchar2_table(5102) := '77696474682064657363726970746F7220697320646976696465642062792074686520736F757263652073697A6520676976656E20696E20746865206073697A6573602061747472696275746520746F2063616C63756C61746520746865206566666563';
wwv_flow_imp.g_varchar2_table(5103) := '7469766520706978656C2064656E736974792E5C6E202020202A2020204120706978656C2064656E736974792064657363726970746F722C207768696368206973206120706F73697469766520666C6F6174696E6720706F696E74206E756D6265722064';
wwv_flow_imp.g_varchar2_table(5104) := '69726563746C7920666F6C6C6F7765642062792027607860272E5C6E5C6E4966206E6F2064657363726970746F72206973207370656369666965642C2074686520736F757263652069732061737369676E6564207468652064656661756C742064657363';
wwv_flow_imp.g_varchar2_table(5105) := '726970746F723A20603178602E5C6E5C6E497420697320696E636F727265637420746F206D69782077696474682064657363726970746F727320616E6420706978656C2064656E736974792064657363726970746F727320696E207468652073616D6520';
wwv_flow_imp.g_varchar2_table(5106) := '6073726373657460206174747269627574652E204475706C69636174652064657363726970746F72732028666F7220696E7374616E63652C2074776F20736F757263657320696E207468652073616D652060737263736574602077686963682061726520';
wwv_flow_imp.g_varchar2_table(5107) := '626F746820646573637269626564207769746820276032786027292061726520616C736F20696E76616C69642E5C6E5C6E5468652075736572206167656E742073656C6563747320616E79206F6E65206F662074686520617661696C61626C6520736F75';
wwv_flow_imp.g_varchar2_table(5108) := '72636573206174206974732064697363726574696F6E2E20546869732070726F7669646573207468656D2077697468207369676E69666963616E74206C656577617920746F207461696C6F722074686569722073656C656374696F6E206261736564206F';
wwv_flow_imp.g_varchar2_table(5109) := '6E207468696E6773206C696B65207573657220707265666572656E636573206F722062616E64776964746820636F6E646974696F6E732E20536565206F7572205B526573706F6E7369766520696D616765735D2868747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(5110) := '722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F4C6561726E2F48544D4C2F4D756C74696D656469615F616E645F656D62656464696E672F526573706F6E736976655F696D6167657329207475746F7269616C20666F7220616E206578616D';
wwv_flow_imp.g_varchar2_table(5111) := '706C652E227D7D2C7B6E616D653A2263726F73736F726967696E222C76616C75655365743A22786F222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320656E756D65726174656420617474726962';
wwv_flow_imp.g_varchar2_table(5112) := '75746520696E6469636174657320696620746865206665746368696E67206F66207468652072656C6174656420696D616765206D75737420626520646F6E65207573696E6720434F5253206F72206E6F742E205B434F52532D656E61626C656420696D61';
wwv_flow_imp.g_varchar2_table(5113) := '6765735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F434F52535F456E61626C65645F496D616765292063616E2062652072657573656420696E20746865205B603C63616E7661733E605D28';
wwv_flow_imp.g_varchar2_table(5114) := '68747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F63616E7661732022557365207468652048544D4C203C63616E7661733E20656C656D656E742077697468';
wwv_flow_imp.g_varchar2_table(5115) := '20656974686572207468652063616E76617320736372697074696E6720415049206F722074686520576562474C2041504920746F206472617720677261706869637320616E6420616E696D6174696F6E732E222920656C656D656E7420776974686F7574';
wwv_flow_imp.g_varchar2_table(5116) := '206265696E6720225B7461696E7465645D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F434F52535F656E61626C65645F696D61676523576861745F69735F615F746169';
wwv_flow_imp.g_varchar2_table(5117) := '6E7465645F63616E766173292E222054686520616C6C6F7765642076616C756573206172653A277D7D2C7B6E616D653A227573656D6170222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686520706172';
wwv_flow_imp.g_varchar2_table(5118) := '7469616C2055524C20287374617274696E672077697468205C27235C2729206F6620616E205B696D616765206D61705D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F48544D4C2F456C656D65';
wwv_flow_imp.g_varchar2_table(5119) := '6E742F6D617029206173736F63696174656420776974682074686520656C656D656E742E5C6E5C6E2A2A4E6F74653A2A2A20596F752063616E6E6F74207573652074686973206174747269627574652069662074686520603C696D673E6020656C656D65';
wwv_flow_imp.g_varchar2_table(5120) := '6E7420697320612064657363656E64616E74206F6620616E205B603C613E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F612022546865204854';
wwv_flow_imp.g_varchar2_table(5121) := '4D4C203C613E20656C656D656E7420286F7220616E63686F7220656C656D656E7429206372656174657320612068797065726C696E6B20746F206F74686572207765622070616765732C2066696C65732C206C6F636174696F6E732077697468696E2074';
wwv_flow_imp.g_varchar2_table(5122) := '68652073616D6520706167652C20656D61696C206164647265737365732C206F7220616E79206F746865722055524C2E2229206F72205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D';
wwv_flow_imp.g_varchar2_table(5123) := '55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C2077686963682063616E20';
wwv_flow_imp.g_varchar2_table(5124) := '6265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974792E222920656C656D65';
wwv_flow_imp.g_varchar2_table(5125) := '6E742E277D7D2C7B6E616D653A2269736D6170222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320426F6F6C65616E2061747472696275746520696E6469636174';
wwv_flow_imp.g_varchar2_table(5126) := '657320746861742074686520696D6167652069732070617274206F662061207365727665722D73696465206D61702E20496620736F2C20746865207072656369736520636F6F7264696E61746573206F66206120636C69636B206172652073656E742074';
wwv_flow_imp.g_varchar2_table(5127) := '6F20746865207365727665722E5C6E5C6E2A2A4E6F74653A2A2A20546869732061747472696275746520697320616C6C6F776564206F6E6C792069662074686520603C696D673E6020656C656D656E7420697320612064657363656E64616E74206F6620';
wwv_flow_imp.g_varchar2_table(5128) := '616E205B603C613E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6120225468652048544D4C203C613E20656C656D656E7420286F7220616E63';
wwv_flow_imp.g_varchar2_table(5129) := '686F7220656C656D656E7429206372656174657320612068797065726C696E6B20746F206F74686572207765622070616765732C2066696C65732C206C6F636174696F6E732077697468696E207468652073616D6520706167652C20656D61696C206164';
wwv_flow_imp.g_varchar2_table(5130) := '647265737365732C206F7220616E79206F746865722055524C2E222920656C656D656E74207769746820612076616C6964205B6068726566605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F';
wwv_flow_imp.g_varchar2_table(5131) := '5765622F48544D4C2F456C656D656E742F6123617474722D6872656629206174747269627574652E277D7D2C7B6E616D653A227769647468222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520696E';
wwv_flow_imp.g_varchar2_table(5132) := '7472696E736963207769647468206F662074686520696D61676520696E20706978656C732E227D7D2C7B6E616D653A22686569676874222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520696E7472';
wwv_flow_imp.g_varchar2_table(5133) := '696E73696320686569676874206F662074686520696D61676520696E20706978656C732E227D7D2C7B6E616D653A226465636F64696E67222C6465736372697074696F6E3A2250726F766964657320616E20696D616765206465636F64696E672068696E';
wwv_flow_imp.g_varchar2_table(5134) := '7420746F207468652062726F777365722E2054686520616C6C6F7765642076616C756573206172653A227D2C7B6E616D653A226465636F64696E67222C6465736372697074696F6E3A226073796E63605C6E5C6E4465636F64652074686520696D616765';
wwv_flow_imp.g_varchar2_table(5135) := '2073796E6368726F6E6F75736C7920666F722061746F6D69632070726573656E746174696F6E2077697468206F7468657220636F6E74656E742E5C6E5C6E606173796E63605C6E5C6E4465636F64652074686520696D616765206173796E6368726F6E6F';
wwv_flow_imp.g_varchar2_table(5136) := '75736C7920746F207265647563652064656C617920696E2070726573656E74696E67206F7468657220636F6E74656E742E5C6E5C6E606175746F605C6E5C6E44656661756C74206D6F64652C20776869636820696E64696361746573206E6F2070726566';
wwv_flow_imp.g_varchar2_table(5137) := '6572656E636520666F7220746865206465636F64696E67206D6F64652E205468652062726F7773657220646563696465732077686174206973206265737420666F722074686520757365722E227D2C7B6E616D653A22696D706F7274616E6365222C6465';
wwv_flow_imp.g_varchar2_table(5138) := '736372697074696F6E3A22496E64696361746573207468652072656C617469766520696D706F7274616E6365206F6620746865207265736F757263652E205072696F726974792068696E7473206172652064656C656761746564207573696E6720746865';
wwv_flow_imp.g_varchar2_table(5139) := '2076616C7565733A227D2C7B6E616D653A22696D706F7274616E6365222C6465736372697074696F6E3A22606175746F603A20496E64696361746573C2A02A2A6E6FC2A0707265666572656E63652A2A2E205468652062726F77736572206D6179207573';
wwv_flow_imp.g_varchar2_table(5140) := '6520697473206F776E206865757269737469637320746F2064656369646520746865207072696F72697479206F662074686520696D6167652E5C6E5C6E6068696768603A20496E6469636174657320746F20746865C2A062726F77736572C2A074686174';
wwv_flow_imp.g_varchar2_table(5141) := '2074686520696D616765206973206F66C2A02A2A686967682A2A207072696F726974792E5C6E5C6E606C6F77603AC2A0496E6469636174657320746F20746865C2A062726F77736572C2A0746861742074686520696D616765206973206F66C2A02A2A6C';
wwv_flow_imp.g_varchar2_table(5142) := '6F772A2A207072696F726974792E227D2C7B6E616D653A22696E7472696E73696373697A65222C6465736372697074696F6E3A2254686973206174747269627574652074656C6C73207468652062726F7773657220746F2069676E6F7265207468652061';
wwv_flow_imp.g_varchar2_table(5143) := '637475616C20696E7472696E7369632073697A65206F662074686520696D61676520616E642070726574656E64206974E2809973207468652073697A652073706563696669656420696E20746865206174747269627574652E205370656369666963616C';
wwv_flow_imp.g_varchar2_table(5144) := '6C792C2074686520696D61676520776F756C64207261737465722061742074686573652064696D656E73696F6E7320616E6420606E61747572616C5769647468602F606E61747572616C48656967687460206F6E20696D6167657320776F756C64207265';
wwv_flow_imp.g_varchar2_table(5145) := '7475726E207468652076616C7565732073706563696669656420696E2074686973206174747269627574652E205B4578706C61696E65725D2868747470733A2F2F6769746875622E636F6D2F6F6A616E76616661692F696E7472696E73696373697A652D';
wwv_flow_imp.g_varchar2_table(5146) := '617474726962757465292C205B6578616D706C65735D2868747470733A2F2F676F6F676C656368726F6D652E6769746875622E696F2F73616D706C65732F696E7472696E7369632D73697A652F696E6465782E68746D6C29227D2C7B6E616D653A227265';
wwv_flow_imp.g_varchar2_table(5147) := '666572726572706F6C696379222C6465736372697074696F6E3A224120737472696E6720696E6469636174696E6720776869636820726566657272657220746F20757365207768656E206665746368696E6720746865207265736F757263653A5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5148) := '2A202020606E6F2D72656665727265723A6020546865205B6052656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F52656665726572';
wwv_flow_imp.g_varchar2_table(5149) := '205C22546865205265666572657220726571756573742068656164657220636F6E7461696E73207468652061646472657373206F66207468652070726576696F75732077656220706167652066726F6D2077686963682061206C696E6B20746F20746865';
wwv_flow_imp.g_varchar2_table(5150) := '2063757272656E746C792072657175657374656420706167652077617320666F6C6C6F7765642E2054686520526566657265722068656164657220616C6C6F7773207365727665727320746F206964656E746966792077686572652070656F706C652061';
wwv_flow_imp.g_varchar2_table(5151) := '7265207669736974696E67207468656D2066726F6D20616E64206D6179207573652074686174206461746120666F7220616E616C79746963732C206C6F6767696E672C206F72206F7074696D697A65642063616368696E672C20666F72206578616D706C';
wwv_flow_imp.g_varchar2_table(5152) := '652E5C2229206865616465722077696C6C206E6F742062652073656E742E5C6E2A202020606E6F2D72656665727265722D7768656E2D646F776E67726164653A60204E6F20605265666572657260206865616465722077696C6C2062652073656E742077';
wwv_flow_imp.g_varchar2_table(5153) := '68656E206E617669676174696E6720746F20616E206F726967696E20776974686F757420544C5320284854545053292E205468697320697320612075736572206167656E74E28099732064656661756C74206265686176696F72206966206E6F20706F6C';
wwv_flow_imp.g_varchar2_table(5154) := '696379206973206F7468657277697365207370656369666965642E5C6E2A202020606F726967696E3A602054686520605265666572657260206865616465722077696C6C20696E636C756465207468652070616765206F66206F726967696E2773207363';
wwv_flow_imp.g_varchar2_table(5155) := '68656D652C2074686520686F73742C20616E642074686520706F72742E5C6E2A202020606F726967696E2D7768656E2D63726F73732D6F726967696E3A60204E617669676174696E6720746F206F74686572206F726967696E732077696C6C206C696D69';
wwv_flow_imp.g_varchar2_table(5156) := '742074686520696E636C7564656420726566657272616C206461746120746F2074686520736368656D652C2074686520686F737420616E642074686520706F72742C207768696C65206E617669676174696E672066726F6D207468652073616D65206F72';
wwv_flow_imp.g_varchar2_table(5157) := '6967696E2077696C6C20696E636C7564652074686520726566657272657227732066756C6C20706174682E5C6E2A20202060756E736166652D75726C3A602054686520605265666572657260206865616465722077696C6C20696E636C75646520746865';
wwv_flow_imp.g_varchar2_table(5158) := '206F726967696E20616E642074686520706174682C20627574206E6F742074686520667261676D656E742C2070617373776F72642C206F7220757365726E616D652E2054686973206361736520697320756E736166652062656361757365206974206361';
wwv_flow_imp.g_varchar2_table(5159) := '6E206C65616B206F726967696E7320616E642070617468732066726F6D20544C532D70726F746563746564207265736F757263657320746F20696E736563757265206F726967696E732E227D2C7B6E616D653A2273697A6573222C646573637269707469';
wwv_flow_imp.g_varchar2_table(5160) := '6F6E3A2241206C697374206F66206F6E65206F72206D6F726520737472696E67732073657061726174656420627920636F6D6D617320696E6469636174696E67206120736574206F6620736F757263652073697A65732E204561636820736F7572636520';
wwv_flow_imp.g_varchar2_table(5161) := '73697A6520636F6E7369737473206F663A5C6E5C6E312E202061206D6564696120636F6E646974696F6E2E2054686973206D757374206265206F6D697474656420666F7220746865206C617374206974656D2E5C6E322E20206120736F75726365207369';
wwv_flow_imp.g_varchar2_table(5162) := '7A652076616C75652E5C6E5C6E536F757263652073697A652076616C75657320737065636966792074686520696E74656E64656420646973706C61792073697A65206F662074686520696D6167652E2055736572206167656E7473207573652074686520';
wwv_flow_imp.g_varchar2_table(5163) := '63757272656E7420736F757263652073697A6520746F2073656C656374206F6E65206F662074686520736F757263657320737570706C69656420627920746865206073726373657460206174747269627574652C207768656E2074686F736520736F7572';
wwv_flow_imp.g_varchar2_table(5164) := '6365732061726520646573637269626564207573696E6720776964746820282760776027292064657363726970746F72732E205468652073656C656374656420736F757263652073697A6520616666656374732074686520696E7472696E736963207369';
wwv_flow_imp.g_varchar2_table(5165) := '7A65206F662074686520696D616765202874686520696D616765E280997320646973706C61792073697A65206966206E6F20435353207374796C696E67206973206170706C696564292E2049662074686520607372637365746020617474726962757465';
wwv_flow_imp.g_varchar2_table(5166) := '20697320616273656E742C206F7220636F6E7461696E73206E6F2076616C756573207769746820612077696474682028607760292064657363726970746F722C207468656E20746865206073697A6573602061747472696275746520686173206E6F2065';
wwv_flow_imp.g_varchar2_table(5167) := '66666563742E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E74';
wwv_flow_imp.g_varchar2_table(5168) := '2F696D67227D5D7D2C7B6E616D653A22696672616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520696672616D6520656C656D656E7420726570726573656E74732061206E65737465642062';
wwv_flow_imp.g_varchar2_table(5169) := '726F7773696E6720636F6E746578742E227D2C617474726962757465733A5B7B6E616D653A22737263222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468652055524C206F662074686520706167652074';
wwv_flow_imp.g_varchar2_table(5170) := '6F20656D6265642E2055736520612076616C7565206F66206061626F75743A626C616E6B6020746F20656D62656420616E20656D7074792070616765207468617420636F6E666F726D7320746F20746865205B73616D652D6F726967696E20706F6C6963';
wwv_flow_imp.g_varchar2_table(5171) := '795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F53656375726974792F53616D652D6F726967696E5F706F6C69637923496E686572697465645F6F726967696E73292E20416C736F';
wwv_flow_imp.g_varchar2_table(5172) := '206E6F746520746861742070726F6772616D61746963616C6C792072656D6F76696E6720616E20603C696672616D653E605C277320737263206174747269627574652028652E672E20766961205B60456C656D656E742E72656D6F766541747472696275';
wwv_flow_imp.g_varchar2_table(5173) := '74652829605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F456C656D656E742F72656D6F7665417474726962757465202254686520456C656D656E74206D6574686F6420';
wwv_flow_imp.g_varchar2_table(5174) := '72656D6F766541747472696275746528292072656D6F766573207468652061747472696275746520776974682074686520737065636966696564206E616D652066726F6D2074686520656C656D656E742E22292920636175736573206061626F75743A62';
wwv_flow_imp.g_varchar2_table(5175) := '6C616E6B6020746F206265206C6F6164656420696E20746865206672616D6520696E2046697265666F78202866726F6D2076657273696F6E203635292C204368726F6D69756D2D62617365642062726F77736572732C20616E64205361666172692F694F';
wwv_flow_imp.g_varchar2_table(5176) := '532E277D7D2C7B6E616D653A22737263646F63222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E6C696E652048544D4C20746F20656D6265642C206F766572726964696E672074686520607372636020';
wwv_flow_imp.g_varchar2_table(5177) := '6174747269627574652E20496620612062726F7773657220646F6573206E6F7420737570706F7274207468652060737263646F6360206174747269627574652C2069742077696C6C2066616C6C206261636B20746F207468652055524C20696E20746865';
wwv_flow_imp.g_varchar2_table(5178) := '206073726360206174747269627574652E227D7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27412074617267657461626C65206E616D6520666F722074686520656D6265';
wwv_flow_imp.g_varchar2_table(5179) := '646465642062726F7773696E6720636F6E746578742E20546869732063616E206265207573656420696E2074686520607461726765746020617474726962757465206F6620746865205B603C613E605D2868747470733A2F2F646576656C6F7065722E6D';
wwv_flow_imp.g_varchar2_table(5180) := '6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6120225468652048544D4C203C613E20656C656D656E7420286F7220616E63686F7220656C656D656E7429206372656174657320612068797065726C69';
wwv_flow_imp.g_varchar2_table(5181) := '6E6B20746F206F74686572207765622070616765732C2066696C65732C206C6F636174696F6E732077697468696E207468652073616D6520706167652C20656D61696C206164647265737365732C206F7220616E79206F746865722055524C2E22292C20';
wwv_flow_imp.g_varchar2_table(5182) := '5B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E742072';
wwv_flow_imp.g_varchar2_table(5183) := '6570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F20612077656220';
wwv_flow_imp.g_varchar2_table(5184) := '7365727665722E22292C206F72205B603C626173653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6261736520225468652048544D4C203C62';
wwv_flow_imp.g_varchar2_table(5185) := '6173653E20656C656D656E74207370656369666965732074686520626173652055524C20746F2075736520666F7220616C6C2072656C61746976652055524C7320636F6E7461696E65642077697468696E206120646F63756D656E742E20546865726520';
wwv_flow_imp.g_varchar2_table(5186) := '63616E206265206F6E6C79206F6E65203C626173653E20656C656D656E7420696E206120646F63756D656E742E222920656C656D656E74733B207468652060666F726D7461726765746020617474726962757465206F6620746865205B603C696E707574';
wwv_flow_imp.g_varchar2_table(5187) := '3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E7075743E20656C656D656E7420697320757365';
wwv_flow_imp.g_varchar2_table(5188) := '6420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D2074686520757365723B206120776964652076';
wwv_flow_imp.g_varchar2_table(5189) := '617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E207468652064657669636520616E642075736572206167';
wwv_flow_imp.g_varchar2_table(5190) := '656E742E2229206F72205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C62';
wwv_flow_imp.g_varchar2_table(5191) := '7574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C2077686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074';
wwv_flow_imp.g_varchar2_table(5192) := '686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974792E222920656C656D656E74733B206F7220746865206077696E646F774E616D656020706172616D6574657220696E20746865205B60';
wwv_flow_imp.g_varchar2_table(5193) := '77696E646F772E6F70656E2829605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F57696E646F772F6F70656E2022546865C2A057696E646F7720696E746572666163655C';
wwv_flow_imp.g_varchar2_table(5194) := '2773206F70656E2829206D6574686F64206C6F6164732074686520737065636966696564207265736F7572636520696E746F207468652062726F7773696E6720636F6E74657874202877696E646F772C203C696672616D653E206F722074616229207769';
wwv_flow_imp.g_varchar2_table(5195) := '74682074686520737065636966696564206E616D652E20496620746865206E616D6520646F65736E5C27742065786973742C207468656E2061206E65772077696E646F77206973206F70656E656420616E64207468652073706563696669656420726573';
wwv_flow_imp.g_varchar2_table(5196) := '6F75726365206973206C6F6164656420696E746F206974732062726F7773696E6720636F6E746578742E2229206D6574686F642E277D7D2C7B6E616D653A2273616E64626F78222C76616C75655365743A227362222C6465736372697074696F6E3A7B6B';
wwv_flow_imp.g_varchar2_table(5197) := '696E643A226D61726B646F776E222C76616C75653A274170706C696573206578747261207265737472696374696F6E7320746F2074686520636F6E74656E7420696E20746865206672616D652E205468652076616C7565206F6620746865206174747269';
wwv_flow_imp.g_varchar2_table(5198) := '627574652063616E2065697468657220626520656D70747920746F206170706C7920616C6C207265737472696374696F6E732C206F722073706163652D73657061726174656420746F6B656E7320746F206C69667420706172746963756C617220726573';
wwv_flow_imp.g_varchar2_table(5199) := '7472696374696F6E733A5C6E5C6E2A20202060616C6C6F772D666F726D73603A20416C6C6F777320746865207265736F7572636520746F207375626D697420666F726D732E2049662074686973206B6579776F7264206973206E6F7420757365642C2066';
wwv_flow_imp.g_varchar2_table(5200) := '6F726D207375626D697373696F6E20697320626C6F636B65642E5C6E2A20202060616C6C6F772D6D6F64616C73603A204C65747320746865207265736F75726365205B6F70656E206D6F64616C2077696E646F77735D2868747470733A2F2F68746D6C2E';
wwv_flow_imp.g_varchar2_table(5201) := '737065632E7768617477672E6F72672F6D756C7469706167652F6F726967696E2E68746D6C2373616E64626F7865642D6D6F64616C732D666C6167292E5C6E2A20202060616C6C6F772D6F7269656E746174696F6E2D6C6F636B603A204C657473207468';
wwv_flow_imp.g_varchar2_table(5202) := '65207265736F75726365205B6C6F636B207468652073637265656E206F7269656E746174696F6E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F53637265656E2F6C6F63';
wwv_flow_imp.g_varchar2_table(5203) := '6B4F7269656E746174696F6E292E5C6E2A20202060616C6C6F772D706F696E7465722D6C6F636B603A204C65747320746865207265736F757263652075736520746865205B506F696E746572204C6F636B204150495D2868747470733A2F2F646576656C';
wwv_flow_imp.g_varchar2_table(5204) := '6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765624150492F506F696E7465725F4C6F636B292E5C6E2A20202060616C6C6F772D706F70757073603A20416C6C6F777320706F70757073202873756368206173206077696E646F';
wwv_flow_imp.g_varchar2_table(5205) := '772E6F70656E2829602C20607461726765743D225F626C616E6B22602C206F72206073686F774D6F64616C4469616C6F67282960292E2049662074686973206B6579776F7264206973206E6F7420757365642C2074686520706F7075702077696C6C2073';
wwv_flow_imp.g_varchar2_table(5206) := '696C656E746C79206661696C20746F206F70656E2E5C6E2A20202060616C6C6F772D706F707570732D746F2D6573636170652D73616E64626F78603A204C657473207468652073616E64626F78656420646F63756D656E74206F70656E206E6577207769';
wwv_flow_imp.g_varchar2_table(5207) := '6E646F777320776974686F75742074686F73652077696E646F777320696E6865726974696E67207468652073616E64626F78696E672E20466F72206578616D706C652C20746869732063616E20736166656C792073616E64626F7820616E206164766572';
wwv_flow_imp.g_varchar2_table(5208) := '746973656D656E7420776974686F757420666F7263696E67207468652073616D65207265737472696374696F6E732075706F6E20746865207061676520746865206164206C696E6B7320746F2E5C6E2A20202060616C6C6F772D70726573656E74617469';
wwv_flow_imp.g_varchar2_table(5209) := '6F6E603A204C65747320746865207265736F757263652073746172742061205B70726573656E746174696F6E2073657373696F6E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F41';
wwv_flow_imp.g_varchar2_table(5210) := '50492F50726573656E746174696F6E52657175657374292E5C6E2A20202060616C6C6F772D73616D652D6F726967696E603A204966207468697320746F6B656E206973206E6F7420757365642C20746865207265736F7572636520697320747265617465';
wwv_flow_imp.g_varchar2_table(5211) := '64206173206265696E672066726F6D2061207370656369616C206F726967696E207468617420616C77617973206661696C7320746865205B73616D652D6F726967696E20706F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C';
wwv_flow_imp.g_varchar2_table(5212) := '612E6F72672F656E2D55532F646F63732F476C6F73736172792F73616D652D6F726967696E5F706F6C696379202273616D652D6F726967696E20706F6C6963793A205468652073616D652D6F726967696E20706F6C696379206973206120637269746963';
wwv_flow_imp.g_varchar2_table(5213) := '616C207365637572697479206D656368616E69736D20746861742072657374726963747320686F77206120646F63756D656E74206F7220736372697074206C6F616465642066726F6D206F6E65206F726967696E2063616E20696E746572616374207769';
wwv_flow_imp.g_varchar2_table(5214) := '74682061207265736F757263652066726F6D20616E6F74686572206F726967696E2E22292E5C6E2A20202060616C6C6F772D73637269707473603A204C65747320746865207265736F757263652072756E20736372697074732028627574206E6F742063';
wwv_flow_imp.g_varchar2_table(5215) := '726561746520706F7075702077696E646F7773292E5C6E2A20202060616C6C6F772D73746F726167652D6163636573732D62792D757365722D61637469766174696F6E60203A204C65747320746865207265736F75726365207265717565737420616363';
wwv_flow_imp.g_varchar2_table(5216) := '65737320746F2074686520706172656E745C27732073746F72616765206361706162696C6974696573207769746820746865205B53746F7261676520416363657373204150495D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(5217) := '672F656E2D55532F646F63732F5765622F4150492F53746F726167655F4163636573735F415049292E5C6E2A20202060616C6C6F772D746F702D6E617669676174696F6E603A204C65747320746865207265736F75726365206E61766967617465207468';
wwv_flow_imp.g_varchar2_table(5218) := '6520746F702D6C6576656C2062726F7773696E6720636F6E746578742028746865206F6E65206E616D656420605F746F7060292E5C6E2A20202060616C6C6F772D746F702D6E617669676174696F6E2D62792D757365722D61637469766174696F6E603A';
wwv_flow_imp.g_varchar2_table(5219) := '204C65747320746865207265736F75726365206E617669676174652074686520746F702D6C6576656C2062726F7773696E6720636F6E746578742C20627574206F6E6C7920696620696E697469617465642062792061207573657220676573747572652E';
wwv_flow_imp.g_varchar2_table(5220) := '5C6E5C6E2A2A4E6F7465732061626F75742073616E64626F78696E673A2A2A5C6E5C6E2A2020205768656E2074686520656D62656464656420646F63756D656E7420686173207468652073616D65206F726967696E2061732074686520656D6265646469';
wwv_flow_imp.g_varchar2_table(5221) := '6E6720706167652C206974206973202A2A7374726F6E676C7920646973636F7572616765642A2A20746F2075736520626F74682060616C6C6F772D736372697074736020616E642060616C6C6F772D73616D652D6F726967696E602C2061732074686174';
wwv_flow_imp.g_varchar2_table(5222) := '206C6574732074686520656D62656464656420646F63756D656E742072656D6F766520746865206073616E64626F78602061747472696275746520E28094206D616B696E67206974206E6F206D6F726520736563757265207468616E206E6F7420757369';
wwv_flow_imp.g_varchar2_table(5223) := '6E6720746865206073616E64626F78602061747472696275746520617420616C6C2E5C6E2A20202053616E64626F78696E67206973207573656C657373206966207468652061747461636B65722063616E20646973706C617920636F6E74656E74206F75';
wwv_flow_imp.g_varchar2_table(5224) := '747369646520612073616E64626F7865642060696672616D656020E2809420737563682061732069662074686520766965776572206F70656E7320746865206672616D6520696E2061206E6577207461622E205375636820636F6E74656E742073686F75';
wwv_flow_imp.g_varchar2_table(5225) := '6C6420626520616C736F207365727665642066726F6D2061205F7365706172617465206F726967696E5F20746F206C696D697420706F74656E7469616C2064616D6167652E5C6E2A202020546865206073616E64626F7860206174747269627574652069';
wwv_flow_imp.g_varchar2_table(5226) := '7320756E737570706F7274656420696E20496E7465726E6574204578706C6F726572203920616E64206561726C6965722E277D7D2C7B6E616D653A227365616D6C657373222C76616C75655365743A2276227D2C7B6E616D653A22616C6C6F7766756C6C';
wwv_flow_imp.g_varchar2_table(5227) := '73637265656E222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2753657420746F206074727565602069662074686520603C696672616D653E602063616E2061637469766174';
wwv_flow_imp.g_varchar2_table(5228) := '652066756C6C73637265656E206D6F64652062792063616C6C696E6720746865205B607265717565737446756C6C73637265656E2829605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(5229) := '622F4150492F456C656D656E742F7265717565737446756C6C73637265656E202254686520456C656D656E742E7265717565737446756C6C73637265656E2829206D6574686F642069737375657320616E206173796E6368726F6E6F7573207265717565';
wwv_flow_imp.g_varchar2_table(5230) := '737420746F206D616B652074686520656C656D656E7420626520646973706C6179656420696E2066756C6C2D73637265656E206D6F64652E2229206D6574686F642E277D7D2C7B6E616D653A227769647468222C6465736372697074696F6E3A7B6B696E';
wwv_flow_imp.g_varchar2_table(5231) := '643A226D61726B646F776E222C76616C75653A22546865207769647468206F6620746865206672616D6520696E2043535320706978656C732E2044656661756C742069732060333030602E227D7D2C7B6E616D653A22686569676874222C646573637269';
wwv_flow_imp.g_varchar2_table(5232) := '7074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520686569676874206F6620746865206672616D6520696E2043535320706978656C732E2044656661756C742069732060313530602E227D7D2C7B6E616D653A22616C6C';
wwv_flow_imp.g_varchar2_table(5233) := '6F77222C6465736372697074696F6E3A225370656369666965732061205B6665617475726520706F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F46656174';
wwv_flow_imp.g_varchar2_table(5234) := '7572655F506F6C6963792920666F722074686520603C696672616D653E602E227D2C7B6E616D653A22616C6C6F777061796D656E7472657175657374222C6465736372697074696F6E3A2253657420746F2060747275656020696620612063726F73732D';
wwv_flow_imp.g_varchar2_table(5235) := '6F726967696E20603C696672616D653E602073686F756C6420626520616C6C6F77656420746F20696E766F6B6520746865205B5061796D656E742052657175657374204150495D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(5236) := '672F656E2D55532F646F63732F5765622F4150492F5061796D656E745F526571756573745F415049292E227D2C7B6E616D653A22616C6C6F777061796D656E7472657175657374222C6465736372697074696F6E3A275468697320617474726962757465';
wwv_flow_imp.g_varchar2_table(5237) := '20697320636F6E736964657265642061206C65676163792061747472696275746520616E64207265646566696E65642061732060616C6C6F773D227061796D656E7422602E277D2C7B6E616D653A22637370222C6465736372697074696F6E3A2741205B';
wwv_flow_imp.g_varchar2_table(5238) := '436F6E74656E7420536563757269747920506F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F4353502920656E666F7263656420666F722074686520656D62';
wwv_flow_imp.g_varchar2_table(5239) := '6564646564207265736F757263652E20536565205B6048544D4C494672616D65456C656D656E742E637370605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48544D4C49';
wwv_flow_imp.g_varchar2_table(5240) := '4672616D65456C656D656E742F6373702022546865206373702070726F7065727479206F66207468652048544D4C494672616D65456C656D656E7420696E74657266616365207370656369666965732074686520436F6E74656E74205365637572697479';
wwv_flow_imp.g_varchar2_table(5241) := '20506F6C696379207468617420616E20656D62656464656420646F63756D656E74206D75737420616772656520746F20656E666F7263652075706F6E20697473656C662E222920666F722064657461696C732E277D2C7B6E616D653A22696D706F727461';
wwv_flow_imp.g_varchar2_table(5242) := '6E6365222C6465736372697074696F6E3A2254686520646F776E6C6F6164207072696F72697479206F6620746865207265736F7572636520696E2074686520603C696672616D653E602773206073726360206174747269627574652E20416C6C6F776564';
wwv_flow_imp.g_varchar2_table(5243) := '2076616C7565733A5C6E5C6E606175746F60202864656661756C74295C6E5C6E4E6F20707265666572656E63652E205468652062726F77736572207573657320697473206F776E206865757269737469637320746F206465636964652074686520707269';
wwv_flow_imp.g_varchar2_table(5244) := '6F72697479206F6620746865207265736F757263652E5C6E5C6E6068696768605C6E5C6E546865207265736F757263652073686F756C6420626520646F776E6C6F61646564206265666F7265206F74686572206C6F7765722D7072696F72697479207061';
wwv_flow_imp.g_varchar2_table(5245) := '6765207265736F75726365732E5C6E5C6E606C6F77605C6E5C6E546865207265736F757263652073686F756C6420626520646F776E6C6F61646564206166746572206F74686572206869676865722D7072696F726974792070616765207265736F757263';
wwv_flow_imp.g_varchar2_table(5246) := '65732E227D2C7B6E616D653A227265666572726572706F6C696379222C6465736372697074696F6E3A27496E64696361746573207768696368205B72656665727265725D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(5247) := '6E2D55532F646F63732F5765622F4150492F446F63756D656E742F72656665727265722920746F2073656E64207768656E206665746368696E6720746865206672616D655C2773207265736F757263653A5C6E5C6E2A202020606E6F2D72656665727265';
wwv_flow_imp.g_varchar2_table(5248) := '72603A20546865205B6052656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F52656665726572202254686520526566657265722072';
wwv_flow_imp.g_varchar2_table(5249) := '6571756573742068656164657220636F6E7461696E73207468652061646472657373206F66207468652070726576696F75732077656220706167652066726F6D2077686963682061206C696E6B20746F207468652063757272656E746C79207265717565';
wwv_flow_imp.g_varchar2_table(5250) := '7374656420706167652077617320666F6C6C6F7765642E2054686520526566657265722068656164657220616C6C6F7773207365727665727320746F206964656E746966792077686572652070656F706C6520617265207669736974696E67207468656D';
wwv_flow_imp.g_varchar2_table(5251) := '2066726F6D20616E64206D6179207573652074686174206461746120666F7220616E616C79746963732C206C6F6767696E672C206F72206F7074696D697A65642063616368696E672C20666F72206578616D706C652E2229206865616465722077696C6C';
wwv_flow_imp.g_varchar2_table(5252) := '206E6F742062652073656E742E5C6E2A202020606E6F2D72656665727265722D7768656E2D646F776E677261646560202864656661756C74293A20546865205B6052656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C61';
wwv_flow_imp.g_varchar2_table(5253) := '2E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F526566657265722022546865205265666572657220726571756573742068656164657220636F6E7461696E73207468652061646472657373206F662074686520707265';
wwv_flow_imp.g_varchar2_table(5254) := '76696F75732077656220706167652066726F6D2077686963682061206C696E6B20746F207468652063757272656E746C792072657175657374656420706167652077617320666F6C6C6F7765642E2054686520526566657265722068656164657220616C';
wwv_flow_imp.g_varchar2_table(5255) := '6C6F7773207365727665727320746F206964656E746966792077686572652070656F706C6520617265207669736974696E67207468656D2066726F6D20616E64206D6179207573652074686174206461746120666F7220616E616C79746963732C206C6F';
wwv_flow_imp.g_varchar2_table(5256) := '6767696E672C206F72206F7074696D697A65642063616368696E672C20666F72206578616D706C652E2229206865616465722077696C6C206E6F742062652073656E7420746F205B6F726967696E5D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(5257) := '7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F6F726967696E20226F726967696E3A2057656220636F6E74656E745C2773206F726967696E20697320646566696E65642062792074686520736368656D65202870726F746F63';
wwv_flow_imp.g_varchar2_table(5258) := '6F6C292C20686F73742028646F6D61696E292C20616E6420706F7274206F66207468652055524C207573656420746F206163636573732069742E2054776F206F626A656374732068617665207468652073616D65206F726967696E206F6E6C7920776865';
wwv_flow_imp.g_varchar2_table(5259) := '6E2074686520736368656D652C20686F73742C20616E6420706F727420616C6C206D617463682E22297320776974686F7574205B544C535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C';
wwv_flow_imp.g_varchar2_table(5260) := '6F73736172792F544C532022544C533A205472616E73706F7274204C617965722053656375726974792028544C53292C2070726576696F75736C79206B6E6F776E2061732053656375726520536F636B657473204C61796572202853534C292C20697320';
wwv_flow_imp.g_varchar2_table(5261) := '612070726F746F636F6C2075736564206279206170706C69636174696F6E7320746F20636F6D6D756E6963617465207365637572656C79206163726F73732061206E6574776F726B2C2070726576656E74696E672074616D706572696E67207769746820';
wwv_flow_imp.g_varchar2_table(5262) := '616E6420656176657364726F7070696E67206F6E20656D61696C2C207765622062726F7773696E672C206D6573736167696E672C20616E64206F746865722070726F746F636F6C732E222920285B48545450535D2868747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(5263) := '65722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F4854545053202248545450533A204854545053202848545450205365637572652920697320616E20656E637279707465642076657273696F6E206F662074686520';
wwv_flow_imp.g_varchar2_table(5264) := '485454502070726F746F636F6C2E20497420757375616C6C7920757365732053534C206F7220544C5320746F20656E637279707420616C6C20636F6D6D756E69636174696F6E206265747765656E206120636C69656E7420616E64206120736572766572';
wwv_flow_imp.g_varchar2_table(5265) := '2E20546869732073656375726520636F6E6E656374696F6E20616C6C6F777320636C69656E747320746F20736166656C792065786368616E67652073656E736974697665206461746120776974682061207365727665722C20666F72206578616D706C65';
wwv_flow_imp.g_varchar2_table(5266) := '20666F722062616E6B696E672061637469766974696573206F72206F6E6C696E652073686F7070696E672E2229292E5C6E2A202020606F726967696E603A205468652073656E742072656665727265722077696C6C206265206C696D6974656420746F20';
wwv_flow_imp.g_varchar2_table(5267) := '746865206F726967696E206F662074686520726566657272696E6720706167653A20697473205B736368656D655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F417263686976652F4D6F7A69';
wwv_flow_imp.g_varchar2_table(5268) := '6C6C612F555249536368656D65292C205B686F73745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F686F73742022686F73743A204120686F7374206973206120646576';
wwv_flow_imp.g_varchar2_table(5269) := '69636520636F6E6E656374656420746F2074686520496E7465726E657420286F722061206C6F63616C206E6574776F726B292E20536F6D6520686F7374732063616C6C65642073657276657273206F66666572206164646974696F6E616C207365727669';
wwv_flow_imp.g_varchar2_table(5270) := '636573206C696B652073657276696E67207765627061676573206F722073746F72696E672066696C657320616E6420656D61696C732E22292C20616E64205B706F72745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(5271) := '6E2D55532F646F63732F476C6F73736172792F706F72742022706F72743A20466F72206120636F6D707574657220636F6E6E656374656420746F2061206E6574776F726B207769746820616E20495020616464726573732C206120706F72742069732061';
wwv_flow_imp.g_varchar2_table(5272) := '20636F6D6D756E69636174696F6E20656E64706F696E742E20506F727473206172652064657369676E61746564206279206E756D626572732C20616E642062656C6F772031303234206561636820706F7274206973206173736F63696174656420627920';
wwv_flow_imp.g_varchar2_table(5273) := '64656661756C74207769746820612073706563696669632070726F746F636F6C2E22292E5C6E2A202020606F726967696E2D7768656E2D63726F73732D6F726967696E603A205468652072656665727265722073656E7420746F206F74686572206F7269';
wwv_flow_imp.g_varchar2_table(5274) := '67696E732077696C6C206265206C696D6974656420746F2074686520736368656D652C2074686520686F73742C20616E642074686520706F72742E204E617669676174696F6E73206F6E207468652073616D65206F726967696E2077696C6C207374696C';
wwv_flow_imp.g_varchar2_table(5275) := '6C20696E636C7564652074686520706174682E5C6E2A2020206073616D652D6F726967696E603A20412072656665727265722077696C6C2062652073656E7420666F72205B73616D65206F726967696E5D2868747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(5276) := '6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F53616D652D6F726967696E5F706F6C696379202273616D65206F726967696E3A205468652073616D652D6F726967696E20706F6C69637920697320612063726974696361';
wwv_flow_imp.g_varchar2_table(5277) := '6C207365637572697479206D656368616E69736D20746861742072657374726963747320686F77206120646F63756D656E74206F7220736372697074206C6F616465642066726F6D206F6E65206F726967696E2063616E20696E74657261637420776974';
wwv_flow_imp.g_varchar2_table(5278) := '682061207265736F757263652066726F6D20616E6F74686572206F726967696E2E22292C206275742063726F73732D6F726967696E2072657175657374732077696C6C20636F6E7461696E206E6F20726566657272657220696E666F726D6174696F6E2E';
wwv_flow_imp.g_varchar2_table(5279) := '5C6E2A202020607374726963742D6F726967696E603A204F6E6C792073656E6420746865206F726967696E206F662074686520646F63756D656E7420617320746865207265666572726572207768656E207468652070726F746F636F6C20736563757269';
wwv_flow_imp.g_varchar2_table(5280) := '7479206C6576656C207374617973207468652073616D6520284854545053E286924854545053292C2062757420646F6E5C27742073656E6420697420746F2061206C657373207365637572652064657374696E6174696F6E20284854545053E286924854';
wwv_flow_imp.g_varchar2_table(5281) := '5450292E5C6E2A202020607374726963742D6F726967696E2D7768656E2D63726F73732D6F726967696E603A2053656E6420612066756C6C2055524C207768656E20706572666F726D696E6720612073616D652D6F726967696E20726571756573742C20';
wwv_flow_imp.g_varchar2_table(5282) := '6F6E6C792073656E6420746865206F726967696E207768656E207468652070726F746F636F6C207365637572697479206C6576656C207374617973207468652073616D6520284854545053E286924854545053292C20616E642073656E64206E6F206865';
wwv_flow_imp.g_varchar2_table(5283) := '6164657220746F2061206C657373207365637572652064657374696E6174696F6E20284854545053E2869248545450292E5C6E2A20202060756E736166652D75726C603A205468652072656665727265722077696C6C20696E636C75646520746865206F';
wwv_flow_imp.g_varchar2_table(5284) := '726967696E205F616E645F2074686520706174682028627574206E6F7420746865205B667261676D656E745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48544D4C4879';
wwv_flow_imp.g_varchar2_table(5285) := '7065726C696E6B456C656D656E745574696C732F68617368292C205B70617373776F72645D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48544D4C48797065726C696E6B';
wwv_flow_imp.g_varchar2_table(5286) := '456C656D656E745574696C732F70617373776F7264292C206F72205B757365726E616D655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48544D4C48797065726C696E6B';
wwv_flow_imp.g_varchar2_table(5287) := '456C656D656E745574696C732F757365726E616D6529292E202A2A546869732076616C756520697320756E736166652A2A2C2062656361757365206974206C65616B73206F726967696E7320616E642070617468732066726F6D20544C532D70726F7465';
wwv_flow_imp.g_varchar2_table(5288) := '63746564207265736F757263657320746F20696E736563757265206F726967696E732E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5289) := '6C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F696672616D65227D5D7D2C7B6E616D653A22656D626564222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520656D626564';
wwv_flow_imp.g_varchar2_table(5290) := '20656C656D656E742070726F766964657320616E20696E746567726174696F6E20706F696E7420666F7220616E2065787465726E616C20287479706963616C6C79206E6F6E2D48544D4C29206170706C69636174696F6E206F7220696E74657261637469';
wwv_flow_imp.g_varchar2_table(5291) := '766520636F6E74656E742E227D2C617474726962757465733A5B7B6E616D653A22737263222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652055524CC2A06F6620746865207265736F757263652062';
wwv_flow_imp.g_varchar2_table(5292) := '65696E6720656D6265646465642E227D7D2C7B6E616D653A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865204D494D45C2A07479706520746F2075736520746F2073656C6563742074';
wwv_flow_imp.g_varchar2_table(5293) := '686520706C75672D696E20746F20696E7374616E74696174652E227D7D2C7B6E616D653A227769647468222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520646973706C6179656420776964746820';
wwv_flow_imp.g_varchar2_table(5294) := '6F6620746865207265736F757263652C20696E205B43535320706978656C735D2868747470733A2F2F6472616674732E63737377672E6F72672F6373732D76616C7565732F237078292E2054686973206D75737420626520616E206162736F6C75746520';
wwv_flow_imp.g_varchar2_table(5295) := '76616C75653B2070657263656E746167657320617265205F6E6F745F20616C6C6F7765642E227D7D2C7B6E616D653A22686569676874222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652064697370';
wwv_flow_imp.g_varchar2_table(5296) := '6C6179656420686569676874206F6620746865207265736F757263652C20696E205B43535320706978656C735D2868747470733A2F2F6472616674732E63737377672E6F72672F6373732D76616C7565732F237078292E2054686973206D757374206265';
wwv_flow_imp.g_varchar2_table(5297) := '20616E206162736F6C7574652076616C75653B2070657263656E746167657320617265205F6E6F745F20616C6C6F7765642E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A';
wwv_flow_imp.g_varchar2_table(5298) := '2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F656D626564227D5D7D2C7B6E616D653A226F626A656374222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C';
wwv_flow_imp.g_varchar2_table(5299) := '76616C75653A22546865206F626A65637420656C656D656E742063616E20726570726573656E7420616E2065787465726E616C207265736F757263652C2077686963682C20646570656E64696E67206F6E207468652074797065206F6620746865207265';
wwv_flow_imp.g_varchar2_table(5300) := '736F757263652C2077696C6C20656974686572206265207472656174656420617320616E20696D6167652C2061732061206E65737465642062726F7773696E6720636F6E746578742C206F7220617320616E2065787465726E616C207265736F75726365';
wwv_flow_imp.g_varchar2_table(5301) := '20746F2062652070726F636573736564206279206120706C7567696E2E227D2C617474726962757465733A5B7B6E616D653A2264617461222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520616464';
wwv_flow_imp.g_varchar2_table(5302) := '72657373206F6620746865207265736F7572636520617320612076616C69642055524C2E204174206C65617374206F6E65206F66202A2A646174612A2A20616E64202A2A747970652A2A206D75737420626520646566696E65642E227D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(5303) := '3A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865205B636F6E74656E7420747970655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F64';
wwv_flow_imp.g_varchar2_table(5304) := '6F63732F476C6F73736172792F436F6E74656E745F7479706529206F6620746865207265736F7572636520737065636966696564206279202A2A646174612A2A2E204174206C65617374206F6E65206F66202A2A646174612A2A20616E64202A2A747970';
wwv_flow_imp.g_varchar2_table(5305) := '652A2A206D75737420626520646566696E65642E227D7D2C7B6E616D653A22747970656D7573746D61746368222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320';
wwv_flow_imp.g_varchar2_table(5306) := '426F6F6C65616E2061747472696275746520696E6469636174657320696620746865202A2A747970652A2A2061747472696275746520616E64207468652061637475616C205B636F6E74656E7420747970655D2868747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(5307) := '722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F436F6E74656E745F7479706529206F6620746865207265736F75726365206D757374206D6174636820746F20626520757365642E227D7D2C7B6E616D653A226E616D';
wwv_flow_imp.g_varchar2_table(5308) := '65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206E616D65206F662076616C69642062726F7773696E6720636F6E74657874202848544D4C35292C206F7220746865206E616D65206F66207468';
wwv_flow_imp.g_varchar2_table(5309) := '6520636F6E74726F6C202848544D4C2034292E227D7D2C7B6E616D653A227573656D6170222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120686173682D6E616D65207265666572656E636520746F2061';
wwv_flow_imp.g_varchar2_table(5310) := '205B603C6D61703E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D6170205C225468652048544D4C203C6D61703E20656C656D656E74206973';
wwv_flow_imp.g_varchar2_table(5311) := '20757365642077697468203C617265613E20656C656D656E747320746F20646566696E6520616E20696D616765206D617020286120636C69636B61626C65206C696E6B2061726561292E5C222920656C656D656E743B2074686174206973206120272327';
wwv_flow_imp.g_varchar2_table(5312) := '20666F6C6C6F776564206279207468652076616C7565206F662061205B606E616D65605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6D61702361';
wwv_flow_imp.g_varchar2_table(5313) := '7474722D6E616D6529206F662061206D617020656C656D656E742E227D7D2C7B6E616D653A22666F726D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686520666F726D20656C656D656E742C206966';
wwv_flow_imp.g_varchar2_table(5314) := '20616E792C207468617420746865206F626A65637420656C656D656E74206973206173736F63696174656420776974682028697473205F666F726D206F776E65725F292E205468652076616C7565206F662074686520617474726962757465206D757374';
wwv_flow_imp.g_varchar2_table(5315) := '20626520616E204944206F662061205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C';
wwv_flow_imp.g_varchar2_table(5316) := '666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D';
wwv_flow_imp.g_varchar2_table(5317) := '6174696F6E20746F206120776562207365727665722E222920656C656D656E7420696E207468652073616D6520646F63756D656E742E277D7D2C7B6E616D653A227769647468222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(5318) := '2C76616C75653A22546865207769647468206F662074686520646973706C6179207265736F757263652C20696E205B43535320706978656C735D2868747470733A2F2F6472616674732E63737377672E6F72672F6373732D76616C7565732F237078292E';
wwv_flow_imp.g_varchar2_table(5319) := '202D2D20284162736F6C7574652076616C756573206F6E6C792E205B4E4F2070657263656E74616765735D2868747470733A2F2F68746D6C2E737065632E7768617477672E6F72672F6D756C7469706167652F656D6265646465642D636F6E74656E742E';
wwv_flow_imp.g_varchar2_table(5320) := '68746D6C2364696D656E73696F6E2D617474726962757465732929227D7D2C7B6E616D653A22686569676874222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520686569676874206F662074686520';
wwv_flow_imp.g_varchar2_table(5321) := '646973706C61796564207265736F757263652C20696E205B43535320706978656C735D2868747470733A2F2F6472616674732E63737377672E6F72672F6373732D76616C7565732F237078292E202D2D20284162736F6C7574652076616C756573206F6E';
wwv_flow_imp.g_varchar2_table(5322) := '6C792E205B4E4F2070657263656E74616765735D2868747470733A2F2F68746D6C2E737065632E7768617477672E6F72672F6D756C7469706167652F656D6265646465642D636F6E74656E742E68746D6C2364696D656E73696F6E2D6174747269627574';
wwv_flow_imp.g_varchar2_table(5323) := '65732929227D7D2C7B6E616D653A2261726368697665222C6465736372697074696F6E3A22412073706163652D736570617261746564206C697374206F66205552497320666F72206172636869766573206F66207265736F757263657320666F72207468';
wwv_flow_imp.g_varchar2_table(5324) := '65206F626A6563742E227D2C7B6E616D653A22626F72646572222C6465736372697074696F6E3A22546865207769647468206F66206120626F726465722061726F756E642074686520636F6E74726F6C2C20696E20706978656C732E227D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(5325) := '3A22636C6173736964222C6465736372697074696F6E3A2254686520555249206F6620746865206F626A656374277320696D706C656D656E746174696F6E2E2049742063616E206265207573656420746F67657468657220776974682C206F7220696E20';
wwv_flow_imp.g_varchar2_table(5326) := '706C616365206F662C20746865202A2A646174612A2A206174747269627574652E227D2C7B6E616D653A22636F646562617365222C6465736372697074696F6E3A2254686520626173652070617468207573656420746F207265736F6C76652072656C61';
wwv_flow_imp.g_varchar2_table(5327) := '74697665205552497320737065636966696564206279202A2A636C61737369642A2A2C202A2A646174612A2A2C206F72202A2A617263686976652A2A2E204966206E6F74207370656369666965642C207468652064656661756C74206973207468652062';
wwv_flow_imp.g_varchar2_table(5328) := '61736520555249206F66207468652063757272656E7420646F63756D656E742E227D2C7B6E616D653A22636F646574797065222C6465736372697074696F6E3A2254686520636F6E74656E742074797065206F6620746865206461746120737065636966';
wwv_flow_imp.g_varchar2_table(5329) := '696564206279202A2A636C61737369642A2A2E227D2C7B6E616D653A226465636C617265222C6465736372697074696F6E3A225468652070726573656E6365206F66207468697320426F6F6C65616E20617474726962757465206D616B65732074686973';
wwv_flow_imp.g_varchar2_table(5330) := '20656C656D656E742061206465636C61726174696F6E206F6E6C792E20546865206F626A656374206D75737420626520696E7374616E74696174656420627920612073756273657175656E7420603C6F626A6563743E6020656C656D656E742E20496E20';
wwv_flow_imp.g_varchar2_table(5331) := '48544D4C352C2072657065617420746865203C6F626A6563743E20656C656D656E7420636F6D706C6574656C7920656163682074686174207468617420746865207265736F75726365206973207265757365642E227D2C7B6E616D653A227374616E6462';
wwv_flow_imp.g_varchar2_table(5332) := '79222C6465736372697074696F6E3A2241206D6573736167652074686174207468652062726F777365722063616E2073686F77207768696C65206C6F6164696E6720746865206F626A656374277320696D706C656D656E746174696F6E20616E64206461';
wwv_flow_imp.g_varchar2_table(5333) := '74612E227D2C7B6E616D653A22746162696E646578222C6465736372697074696F6E3A2254686520706F736974696F6E206F662074686520656C656D656E7420696E207468652074616262696E67206E617669676174696F6E206F7264657220666F7220';
wwv_flow_imp.g_varchar2_table(5334) := '7468652063757272656E7420646F63756D656E742E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F57';
wwv_flow_imp.g_varchar2_table(5335) := '65622F48544D4C2F456C656D656E742F6F626A656374227D5D7D2C7B6E616D653A22706172616D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706172616D20656C656D656E7420646566696E';
wwv_flow_imp.g_varchar2_table(5336) := '657320706172616D657465727320666F7220706C7567696E7320696E766F6B6564206279206F626A65637420656C656D656E74732E20497420646F6573206E6F7420726570726573656E7420616E797468696E67206F6E20697473206F776E2E227D2C61';
wwv_flow_imp.g_varchar2_table(5337) := '7474726962757465733A5B7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224E616D65206F662074686520706172616D657465722E227D7D2C7B6E616D653A2276616C7565222C';
wwv_flow_imp.g_varchar2_table(5338) := '6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22537065636966696573207468652076616C7565206F662074686520706172616D657465722E227D7D2C7B6E616D653A2274797065222C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(5339) := '6E3A274F6E6C79207573656420696620746865206076616C756574797065602069732073657420746F2022726566222E2053706563696669657320746865204D494D452074797065206F662076616C75657320666F756E64206174207468652055524920';
wwv_flow_imp.g_varchar2_table(5340) := '7370656369666965642062792076616C75652E277D2C7B6E616D653A2276616C756574797065222C6465736372697074696F6E3A27537065636966696573207468652074797065206F6620746865206076616C756560206174747269627574652E20506F';
wwv_flow_imp.g_varchar2_table(5341) := '737369626C652076616C756573206172653A5C6E5C6E2A202020646174613A2044656661756C742076616C75652E205468652076616C75652069732070617373656420746F20746865206F626A6563745C277320696D706C656D656E746174696F6E2061';
wwv_flow_imp.g_varchar2_table(5342) := '73206120737472696E672E5C6E2A2020207265663A205468652076616C756520697320612055524920746F2061207265736F757263652077686572652072756E2D74696D652076616C756573206172652073746F7265642E5C6E2A2020206F626A656374';
wwv_flow_imp.g_varchar2_table(5343) := '3A20416E204944206F6620616E6F74686572205B603C6F626A6563743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6F626A65637420225468';
wwv_flow_imp.g_varchar2_table(5344) := '652048544D4C203C6F626A6563743E20656C656D656E7420726570726573656E747320616E2065787465726E616C207265736F757263652C2077686963682063616E206265207472656174656420617320616E20696D6167652C2061206E657374656420';
wwv_flow_imp.g_varchar2_table(5345) := '62726F7773696E6720636F6E746578742C206F722061207265736F7572636520746F2062652068616E646C6564206279206120706C7567696E2E222920696E207468652073616D6520646F63756D656E742E277D5D2C7265666572656E6365733A5B7B6E';
wwv_flow_imp.g_varchar2_table(5346) := '616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F706172616D227D5D7D2C7B6E616D653A22766964656F22';
wwv_flow_imp.g_varchar2_table(5347) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120766964656F20656C656D656E74206973207573656420666F7220706C6179696E6720766964656F73206F72206D6F766965732C20616E6420617564696F';
wwv_flow_imp.g_varchar2_table(5348) := '2066696C657320776974682063617074696F6E732E227D2C617474726962757465733A5B7B6E616D653A22737263227D2C7B6E616D653A2263726F73736F726967696E222C76616C75655365743A22786F227D2C7B6E616D653A22706F73746572227D2C';
wwv_flow_imp.g_varchar2_table(5349) := '7B6E616D653A227072656C6F6164222C76616C75655365743A22706C227D2C7B6E616D653A226175746F706C6179222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22412042';
wwv_flow_imp.g_varchar2_table(5350) := '6F6F6C65616E206174747269627574653B206966207370656369666965642C2074686520766964656F206175746F6D61746963616C6C7920626567696E7320746F20706C6179206261636B20617320736F6F6E2061732069742063616E20646F20736F20';
wwv_flow_imp.g_varchar2_table(5351) := '776974686F75742073746F7070696E6720746F2066696E697368206C6F6164696E672074686520646174612E227D7D2C7B6E616D653A226D6564696167726F7570227D2C7B6E616D653A226C6F6F70222C76616C75655365743A2276227D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(5352) := '3A226D75746564222C76616C75655365743A2276227D2C7B6E616D653A22636F6E74726F6C73222C76616C75655365743A2276227D2C7B6E616D653A227769647468227D2C7B6E616D653A22686569676874227D5D2C7265666572656E6365733A5B7B6E';
wwv_flow_imp.g_varchar2_table(5353) := '616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F766964656F227D5D7D2C7B6E616D653A22617564696F22';
wwv_flow_imp.g_varchar2_table(5354) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20617564696F20656C656D656E7420726570726573656E7473206120736F756E64206F7220617564696F2073747265616D2E227D2C6174747269627574';
wwv_flow_imp.g_varchar2_table(5355) := '65733A5B7B6E616D653A22737263222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468652055524C206F662074686520617564696F20746F20656D6265642E2054686973206973207375626A6563742074';
wwv_flow_imp.g_varchar2_table(5356) := '6F205B485454502061636365737320636F6E74726F6C735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F485454505F6163636573735F636F6E74726F6C292E2054686973206973206F707469';
wwv_flow_imp.g_varchar2_table(5357) := '6F6E616C3B20796F75206D617920696E73746561642075736520746865205B603C736F757263653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E74';
wwv_flow_imp.g_varchar2_table(5358) := '2F736F7572636520225468652048544D4C203C736F757263653E20656C656D656E7420737065636966696573206D756C7469706C65206D65646961207265736F757263657320666F7220746865203C706963747572653E2C20746865203C617564696F3E';
wwv_flow_imp.g_varchar2_table(5359) := '20656C656D656E742C206F7220746865203C766964656F3E20656C656D656E742E222920656C656D656E742077697468696E2074686520617564696F20626C6F636B20746F20737065636966792074686520617564696F20746F20656D6265642E277D7D';
wwv_flow_imp.g_varchar2_table(5360) := '2C7B6E616D653A2263726F73736F726967696E222C76616C75655365743A22786F222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320656E756D6572617465642061747472696275746520696E64';
wwv_flow_imp.g_varchar2_table(5361) := '696361746573207768657468657220746F2075736520434F525320746F206665746368207468652072656C6174656420696D6167652E205B434F52532D656E61626C6564207265736F75726365735D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(5362) := '7A696C6C612E6F72672F656E2D55532F646F63732F434F52535F456E61626C65645F496D616765292063616E2062652072657573656420696E20746865205B603C63616E7661733E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C61';
wwv_flow_imp.g_varchar2_table(5363) := '2E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F63616E7661732022557365207468652048544D4C203C63616E7661733E20656C656D656E74207769746820656974686572207468652063616E76617320736372697074';
wwv_flow_imp.g_varchar2_table(5364) := '696E6720415049206F722074686520576562474C2041504920746F206472617720677261706869637320616E6420616E696D6174696F6E732E222920656C656D656E7420776974686F7574206265696E67205F7461696E7465645F2E2054686520616C6C';
wwv_flow_imp.g_varchar2_table(5365) := '6F7765642076616C756573206172653A5C6E5C6E616E6F6E796D6F75735C6E5C6E53656E647320612063726F73732D6F726967696E207265717565737420776974686F757420612063726564656E7469616C2E20496E206F7468657220776F7264732C20';
wwv_flow_imp.g_varchar2_table(5366) := '69742073656E64732074686520604F726967696E3A6020485454502068656164657220776974686F7574206120636F6F6B69652C20582E3530392063657274696669636174652C206F7220706572666F726D696E67204854545020426173696320617574';
wwv_flow_imp.g_varchar2_table(5367) := '68656E7469636174696F6E2E204966207468652073657276657220646F6573206E6F7420676976652063726564656E7469616C7320746F20746865206F726967696E207369746520286279206E6F742073657474696E672074686520604163636573732D';
wwv_flow_imp.g_varchar2_table(5368) := '436F6E74726F6C2D416C6C6F772D4F726967696E3A60204854545020686561646572292C2074686520696D6167652077696C6C206265205F7461696E7465645F2C20616E642069747320757361676520726573747269637465642E5C6E5C6E7573652D63';
wwv_flow_imp.g_varchar2_table(5369) := '726564656E7469616C735C6E5C6E53656E647320612063726F73732D6F726967696E2072657175657374207769746820612063726564656E7469616C2E20496E206F7468657220776F7264732C2069742073656E64732074686520604F726967696E3A60';
wwv_flow_imp.g_varchar2_table(5370) := '2048545450206865616465722077697468206120636F6F6B69652C20612063657274696669636174652C206F7220706572666F726D696E6720485454502042617369632061757468656E7469636174696F6E2E204966207468652073657276657220646F';
wwv_flow_imp.g_varchar2_table(5371) := '6573206E6F7420676976652063726564656E7469616C7320746F20746865206F726967696E207369746520287468726F75676820604163636573732D436F6E74726F6C2D416C6C6F772D43726564656E7469616C733A6020485454502068656164657229';
wwv_flow_imp.g_varchar2_table(5372) := '2C2074686520696D6167652077696C6C206265205F7461696E7465645F20616E642069747320757361676520726573747269637465642E5C6E5C6E5768656E206E6F742070726573656E742C20746865207265736F757263652069732066657463686564';
wwv_flow_imp.g_varchar2_table(5373) := '20776974686F7574206120434F525320726571756573742028692E652E20776974686F75742073656E64696E672074686520604F726967696E3A60204854545020686561646572292C2070726576656E74696E6720697473206E6F6E2D7461696E746564';
wwv_flow_imp.g_varchar2_table(5374) := '207573656420696E205B603C63616E7661733E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F63616E7661732022557365207468652048544D4C';
wwv_flow_imp.g_varchar2_table(5375) := '203C63616E7661733E20656C656D656E74207769746820656974686572207468652063616E76617320736372697074696E6720415049206F722074686520576562474C2041504920746F206472617720677261706869637320616E6420616E696D617469';
wwv_flow_imp.g_varchar2_table(5376) := '6F6E732E222920656C656D656E74732E20496620696E76616C69642C2069742069732068616E646C65642061732069662074686520656E756D657261746564206B6579776F7264202A2A616E6F6E796D6F75732A2A2077617320757365642E2053656520';
wwv_flow_imp.g_varchar2_table(5377) := '5B434F52532073657474696E677320617474726962757465735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F48544D4C2F434F52535F73657474696E67735F61747472696275746573292066';
wwv_flow_imp.g_varchar2_table(5378) := '6F72206164646974696F6E616C20696E666F726D6174696F6E2E277D7D2C7B6E616D653A227072656C6F6164222C76616C75655365743A22706C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686973';
wwv_flow_imp.g_varchar2_table(5379) := '20656E756D6572617465642061747472696275746520697320696E74656E64656420746F2070726F7669646520612068696E7420746F207468652062726F777365722061626F757420776861742074686520617574686F72207468696E6B732077696C6C';
wwv_flow_imp.g_varchar2_table(5380) := '206C65616420746F207468652062657374207573657220657870657269656E63652E204974206D61792068617665206F6E65206F662074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A202020606E6F6E65603A20496E64696361746573';
wwv_flow_imp.g_varchar2_table(5381) := '20746861742074686520617564696F2073686F756C64206E6F74206265207072656C6F616465642E5C6E2A202020606D65746164617461603A20496E646963617465732074686174206F6E6C7920617564696F206D657461646174612028652E672E206C';
wwv_flow_imp.g_varchar2_table(5382) := '656E6774682920697320666574636865642E5C6E2A202020606175746F603A20496E646963617465732074686174207468652077686F6C6520617564696F2066696C652063616E20626520646F776E6C6F616465642C206576656E206966207468652075';
wwv_flow_imp.g_varchar2_table(5383) := '736572206973206E6F7420657870656374656420746F207573652069742E5C6E2A2020205F656D70747920737472696E675F3A20412073796E6F6E796D206F662074686520606175746F602076616C75652E5C6E5C6E4966206E6F74207365742C206070';
wwv_flow_imp.g_varchar2_table(5384) := '72656C6F61646027732064656661756C742076616C75652069732062726F777365722D646566696E65642028692E652E20656163682062726F77736572206D6179206861766520697473206F776E2064656661756C742076616C7565292E205468652073';
wwv_flow_imp.g_varchar2_table(5385) := '706563206164766973657320697420746F2062652073657420746F20606D65746164617461602E5C6E5C6E2A2A5573616765206E6F7465733A2A2A5C6E5C6E2A20202054686520606175746F706C61796020617474726962757465206861732070726563';
wwv_flow_imp.g_varchar2_table(5386) := '6564656E6365206F766572C2A0607072656C6F6164602E20496620606175746F706C617960206973207370656369666965642C207468652062726F7773657220776F756C64206F6276696F75736C79206E65656420746F20737461727420646F776E6C6F';
wwv_flow_imp.g_varchar2_table(5387) := '6164696E672074686520617564696F20666F7220706C61796261636B2E5C6E2A2020205468652062726F77736572206973206E6F7420666F72636564206279207468652073706563696669636174696F6E20746F20666F6C6C6F77207468652076616C75';
wwv_flow_imp.g_varchar2_table(5388) := '65206F662074686973206174747269627574653B2069742069732061206D6572652068696E742E227D7D2C7B6E616D653A226175746F706C6179222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E';
wwv_flow_imp.g_varchar2_table(5389) := '222C76616C75653A224120426F6F6C65616E206174747269627574653AC2A06966207370656369666965642C2074686520617564696F2077696C6C206175746F6D61746963616C6C7920626567696E20706C61796261636B20617320736F6F6E20617320';
wwv_flow_imp.g_varchar2_table(5390) := '69742063616E20646F20736F2C20776974686F75742077616974696E6720666F722074686520656E7469726520617564696F2066696C6520746F2066696E69736820646F776E6C6F6164696E672E5C6E5C6E2A2A4E6F74652A2A3A205369746573207468';
wwv_flow_imp.g_varchar2_table(5391) := '6174206175746F6D61746963616C6C7920706C617920617564696F20286F7220766964656F73207769746820616E20617564696F20747261636B292063616E20626520616E20756E706C656173616E7420657870657269656E636520666F722075736572';
wwv_flow_imp.g_varchar2_table(5392) := '732C20736F2073686F756C642062652061766F69646564207768656E20706F737369626C652E20496620796F75206D757374206F66666572206175746F706C61792066756E6374696F6E616C6974792C20796F752073686F756C64206D616B6520697420';
wwv_flow_imp.g_varchar2_table(5393) := '6F70742D696E2028726571756972696E672061207573657220746F207370656369666963616C6C7920656E61626C65206974292E20486F77657665722C20746869732063616E2062652075736566756C207768656E206372656174696E67206D65646961';
wwv_flow_imp.g_varchar2_table(5394) := '20656C656D656E74732077686F736520736F757263652077696C6C206265207365742061742061206C617465722074696D652C20756E646572207573657220636F6E74726F6C2E227D7D2C7B6E616D653A226D6564696167726F7570227D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(5395) := '3A226C6F6F70222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120426F6F6C65616E206174747269627574653AC2A06966207370656369666965642C2074686520617564';
wwv_flow_imp.g_varchar2_table(5396) := '696F20706C617965722077696C6CC2A06175746F6D61746963616C6C79207365656B206261636B20746F20746865207374617274C2A075706F6E207265616368696E672074686520656E64206F662074686520617564696F2E227D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(5397) := '6D75746564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120426F6F6C65616E20617474726962757465207468617420696E6469636174657320776865746865722074';
wwv_flow_imp.g_varchar2_table(5398) := '686520617564696F2077696C6C20626520696E697469616C6C792073696C656E6365642E204974732064656661756C742076616C7565206973206066616C7365602E227D7D2C7B6E616D653A22636F6E74726F6C73222C76616C75655365743A2276222C';
wwv_flow_imp.g_varchar2_table(5399) := '6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2249662074686973206174747269627574652069732070726573656E742C207468652062726F777365722077696C6C206F6666657220636F6E74726F6C7320746F';
wwv_flow_imp.g_varchar2_table(5400) := '20616C6C6F7720746865207573657220746F20636F6E74726F6C20617564696F20706C61796261636B2C20696E636C7564696E6720766F6C756D652C207365656B696E672C20616E642070617573652F726573756D6520706C61796261636B2E227D7D5D';
wwv_flow_imp.g_varchar2_table(5401) := '2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F617564696F227D5D';
wwv_flow_imp.g_varchar2_table(5402) := '7D2C7B6E616D653A22736F75726365222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520736F7572636520656C656D656E7420616C6C6F777320617574686F727320746F2073706563696679206D75';
wwv_flow_imp.g_varchar2_table(5403) := '6C7469706C6520616C7465726E6174697665206D65646961207265736F757263657320666F72206D6564696120656C656D656E74732E20497420646F6573206E6F7420726570726573656E7420616E797468696E67206F6E20697473206F776E2E227D2C';
wwv_flow_imp.g_varchar2_table(5404) := '617474726962757465733A5B7B6E616D653A22737263222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27526571756972656420666F72205B603C617564696F3E605D2868747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(5405) := '65722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F617564696F20225468652048544D4C203C617564696F3E20656C656D656E74206973207573656420746F20656D62656420736F756E6420636F';
wwv_flow_imp.g_varchar2_table(5406) := '6E74656E7420696E20646F63756D656E74732E204974206D617920636F6E7461696E206F6E65206F72206D6F726520617564696F20736F75726365732C20726570726573656E746564207573696E67207468652073726320617474726962757465206F72';
wwv_flow_imp.g_varchar2_table(5407) := '20746865203C736F757263653E20656C656D656E743AC2A07468652062726F777365722077696C6C2063686F6F736520746865206D6F7374207375697461626C65206F6E652E2049742063616E20616C736F206265207468652064657374696E6174696F';
wwv_flow_imp.g_varchar2_table(5408) := '6E20666F722073747265616D6564206D656469612C207573696E672061204D6564696153747265616D2E222920616E64205B603C766964656F3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63';
wwv_flow_imp.g_varchar2_table(5409) := '732F5765622F48544D4C2F456C656D656E742F766964656F20225468652048544D4C20566964656F20656C656D656E7420283C766964656F3E2920656D626564732061206D6564696120706C6179657220776869636820737570706F7274732076696465';
wwv_flow_imp.g_varchar2_table(5410) := '6F20706C61796261636B20696E746F2074686520646F63756D656E742E22292C2061646472657373206F6620746865206D65646961207265736F757263652E205468652076616C7565206F662074686973206174747269627574652069732069676E6F72';
wwv_flow_imp.g_varchar2_table(5411) := '6564207768656E2074686520603C736F757263653E6020656C656D656E7420697320706C6163656420696E736964652061205B603C706963747572653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F';
wwv_flow_imp.g_varchar2_table(5412) := '646F63732F5765622F48544D4C2F456C656D656E742F7069637475726520225468652048544D4C203C706963747572653E20656C656D656E7420636F6E7461696E73207A65726F206F72206D6F7265203C736F757263653E20656C656D656E747320616E';
wwv_flow_imp.g_varchar2_table(5413) := '64206F6E65203C696D673E20656C656D656E7420746F2070726F766964652076657273696F6E73206F6620616E20696D61676520666F7220646966666572656E7420646973706C61792F646576696365207363656E6172696F732E222920656C656D656E';
wwv_flow_imp.g_varchar2_table(5414) := '742E277D7D2C7B6E616D653A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865204D494D452D74797065206F6620746865207265736F757263652C206F7074696F6E616C6C7920776974';
wwv_flow_imp.g_varchar2_table(5415) := '6820612060636F646563736020706172616D657465722E20536565205B52464320343238315D2868747470733A2F2F746F6F6C732E696574662E6F72672F68746D6C2F726663343238312920666F7220696E666F726D6174696F6E2061626F757420686F';
wwv_flow_imp.g_varchar2_table(5416) := '7720746F207370656369667920636F646563732E227D7D2C7B6E616D653A2273697A6573222C6465736372697074696F6E3A2749732061206C697374206F6620736F757263652073697A6573207468617420646573637269626573207468652066696E61';
wwv_flow_imp.g_varchar2_table(5417) := '6C2072656E6465726564207769647468206F662074686520696D61676520726570726573656E7465642062792074686520736F757263652E204561636820736F757263652073697A6520636F6E7369737473206F66206120636F6D6D612D736570617261';
wwv_flow_imp.g_varchar2_table(5418) := '746564206C697374206F66206D6564696120636F6E646974696F6E2D6C656E6774682070616972732E205468697320696E666F726D6174696F6E2069732075736564206279207468652062726F7773657220746F2064657465726D696E652C206265666F';
wwv_flow_imp.g_varchar2_table(5419) := '7265206C6179696E67207468652070616765206F75742C20776869636820696D61676520646566696E656420696E205B60737263736574605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F57';
wwv_flow_imp.g_varchar2_table(5420) := '65622F48544D4C2F456C656D656E742F736F7572636523617474722D7372637365742920746F207573652E20205C6E546865206073697A657360206174747269627574652068617320616E20656666656374206F6E6C79207768656E20746865205B603C';
wwv_flow_imp.g_varchar2_table(5421) := '736F757263653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F736F7572636520225468652048544D4C203C736F757263653E20656C656D656E';
wwv_flow_imp.g_varchar2_table(5422) := '7420737065636966696573206D756C7469706C65206D65646961207265736F757263657320666F7220746865203C706963747572653E2C20746865203C617564696F3E20656C656D656E742C206F7220746865203C766964656F3E20656C656D656E742E';
wwv_flow_imp.g_varchar2_table(5423) := '222920656C656D656E742069732074686520646972656374206368696C64206F662061205B603C706963747572653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F';
wwv_flow_imp.g_varchar2_table(5424) := '456C656D656E742F7069637475726520225468652048544D4C203C706963747572653E20656C656D656E7420636F6E7461696E73207A65726F206F72206D6F7265203C736F757263653E20656C656D656E747320616E64206F6E65203C696D673E20656C';
wwv_flow_imp.g_varchar2_table(5425) := '656D656E7420746F2070726F766964652076657273696F6E73206F6620616E20696D61676520666F7220646966666572656E7420646973706C61792F646576696365207363656E6172696F732E222920656C656D656E742E277D2C7B6E616D653A227372';
wwv_flow_imp.g_varchar2_table(5426) := '63736574222C6465736372697074696F6E3A2241206C697374206F66206F6E65206F72206D6F726520737472696E67732073657061726174656420627920636F6D6D617320696E6469636174696E67206120736574206F6620706F737369626C6520696D';
wwv_flow_imp.g_varchar2_table(5427) := '6167657320726570726573656E7465642062792074686520736F7572636520666F72207468652062726F7773657220746F207573652E204561636820737472696E6720697320636F6D706F736564206F663A5C6E5C6E312E20206F6E652055524C20746F';
wwv_flow_imp.g_varchar2_table(5428) := '20616E20696D6167652C5C6E322E2020612077696474682064657363726970746F722C2074686174206973206120706F73697469766520696E7465676572206469726563746C7920666F6C6C6F7765642062792060277727602E20546865206465666175';
wwv_flow_imp.g_varchar2_table(5429) := '6C742076616C75652C206966206D697373696E672C2069732074686520696E66696E6974792E5C6E332E20206120706978656C2064656E736974792064657363726970746F722C2074686174206973206120706F73697469766520666C6F6174696E6720';
wwv_flow_imp.g_varchar2_table(5430) := '6E756D626572206469726563746C7920666F6C6C6F7765642062792060277827602E205468652064656661756C742076616C75652C206966206D697373696E672C20697320603178602E5C6E5C6E4561636820737472696E6720696E20746865206C6973';
wwv_flow_imp.g_varchar2_table(5431) := '74206D7573742068617665206174206C6561737420612077696474682064657363726970746F72206F72206120706978656C2064656E736974792064657363726970746F7220746F2062652076616C69642E20416D6F6E6720746865206C6973742C2074';
wwv_flow_imp.g_varchar2_table(5432) := '68657265206D757374206265206F6E6C79206F6E6520737472696E6720636F6E7461696E696E67207468652073616D65207475706C65206F662077696474682064657363726970746F7220616E6420706978656C2064656E736974792064657363726970';
wwv_flow_imp.g_varchar2_table(5433) := '746F722E20205C6E5468652062726F777365722063686F6F73657320746865206D6F737420616465717561746520696D61676520746F20646973706C6179206174206120676976656E20706F696E74206F662074696D652E20205C6E5468652060737263';
wwv_flow_imp.g_varchar2_table(5434) := '73657460206174747269627574652068617320616E20656666656374206F6E6C79207768656E20746865205B603C736F757263653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F576562';
wwv_flow_imp.g_varchar2_table(5435) := '2F48544D4C2F456C656D656E742F736F75726365205C225468652048544D4C203C736F757263653E20656C656D656E7420737065636966696573206D756C7469706C65206D65646961207265736F757263657320666F7220746865203C70696374757265';
wwv_flow_imp.g_varchar2_table(5436) := '3E2C20746865203C617564696F3E20656C656D656E742C206F7220746865203C766964656F3E20656C656D656E742E5C222920656C656D656E742069732074686520646972656374206368696C64206F662061205B603C706963747572653E605D286874';
wwv_flow_imp.g_varchar2_table(5437) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F70696374757265205C225468652048544D4C203C706963747572653E20656C656D656E7420636F6E7461696E';
wwv_flow_imp.g_varchar2_table(5438) := '73207A65726F206F72206D6F7265203C736F757263653E20656C656D656E747320616E64206F6E65203C696D673E20656C656D656E7420746F2070726F766964652076657273696F6E73206F6620616E20696D61676520666F7220646966666572656E74';
wwv_flow_imp.g_varchar2_table(5439) := '20646973706C61792F646576696365207363656E6172696F732E5C222920656C656D656E742E227D2C7B6E616D653A226D65646961222C6465736372697074696F6E3A275B4D656469612071756572795D2868747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(5440) := '6D6F7A696C6C612E6F72672F656E2D55532F646F63732F4353532F4D656469615F7175657269657329206F6620746865207265736F757263655C277320696E74656E646564206D656469613B20746869732073686F756C642062652075736564206F6E6C';
wwv_flow_imp.g_varchar2_table(5441) := '7920696E2061205B603C706963747572653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7069637475726520225468652048544D4C203C7069';
wwv_flow_imp.g_varchar2_table(5442) := '63747572653E20656C656D656E7420636F6E7461696E73207A65726F206F72206D6F7265203C736F757263653E20656C656D656E747320616E64206F6E65203C696D673E20656C656D656E7420746F2070726F766964652076657273696F6E73206F6620';
wwv_flow_imp.g_varchar2_table(5443) := '616E20696D61676520666F7220646966666572656E7420646973706C61792F646576696365207363656E6172696F732E222920656C656D656E742E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C';
wwv_flow_imp.g_varchar2_table(5444) := '3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F736F75726365227D5D7D2C7B6E616D653A22747261636B222C6465736372697074696F6E3A7B6B696E643A226D61';
wwv_flow_imp.g_varchar2_table(5445) := '726B646F776E222C76616C75653A2254686520747261636B20656C656D656E7420616C6C6F777320617574686F727320746F2073706563696679206578706C696369742065787465726E616C2074696D6564207465787420747261636B7320666F72206D';
wwv_flow_imp.g_varchar2_table(5446) := '6564696120656C656D656E74732E20497420646F6573206E6F7420726570726573656E7420616E797468696E67206F6E20697473206F776E2E227D2C617474726962757465733A5B7B6E616D653A2264656661756C74222C76616C75655365743A227622';
wwv_flow_imp.g_varchar2_table(5447) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520696E6469636174657320746861742074686520747261636B2073686F756C6420626520656E61626C656420756E6C6573';
wwv_flow_imp.g_varchar2_table(5448) := '73207468652075736572277320707265666572656E63657320696E646963617465207468617420616E6F7468657220747261636B206973206D6F726520617070726F7072696174652E2054686973206D6179206F6E6C792062652075736564206F6E206F';
wwv_flow_imp.g_varchar2_table(5449) := '6E652060747261636B6020656C656D656E7420706572206D6564696120656C656D656E742E227D7D2C7B6E616D653A226B696E64222C76616C75655365743A22746B222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C';
wwv_flow_imp.g_varchar2_table(5450) := '75653A22486F7720746865207465787420747261636B206973206D65616E7420746F20626520757365642E204966206F6D6974746564207468652064656661756C74206B696E6420697320607375627469746C6573602E20496620746865206174747269';
wwv_flow_imp.g_varchar2_table(5451) := '62757465206973206E6F742070726573656E742C2069742077696C6C207573652074686520607375627469746C6573602E204966207468652061747472696275746520636F6E7461696E7320616E20696E76616C69642076616C75652C2069742077696C';
wwv_flow_imp.g_varchar2_table(5452) := '6C2075736520606D65746164617461602E202856657273696F6E73206F66204368726F6D65206561726C696572207468616E203532207472656174656420616E20696E76616C69642076616C756520617320607375627469746C6573602E29C2A0546865';
wwv_flow_imp.g_varchar2_table(5453) := '20666F6C6C6F77696E67206B6579776F7264732061726520616C6C6F7765643A5C6E5C6E2A202020607375627469746C6573605C6E202020202A2020205375627469746C65732070726F76696465207472616E736C6174696F6E206F6620636F6E74656E';
wwv_flow_imp.g_varchar2_table(5454) := '7420746861742063616E6E6F7420626520756E64657273746F6F6420627920746865207669657765722E20466F72206578616D706C65206469616C6F677565206F7220746578742074686174206973206E6F7420456E676C69736820696E20616E20456E';
wwv_flow_imp.g_varchar2_table(5455) := '676C697368206C616E67756167652066696C6D2E5C6E202020202A2020205375627469746C6573206D617920636F6E7461696E206164646974696F6E616C20636F6E74656E742C20757375616C6C79206578747261206261636B67726F756E6420696E66';
wwv_flow_imp.g_varchar2_table(5456) := '6F726D6174696F6E2E20466F72206578616D706C652074686520746578742061742074686520626567696E6E696E67206F6620746865205374617220576172732066696C6D732C206F722074686520646174652C2074696D652C20616E64206C6F636174';
wwv_flow_imp.g_varchar2_table(5457) := '696F6E206F662061207363656E652E5C6E2A2020206063617074696F6E73605C6E202020202A202020436C6F7365642063617074696F6E732070726F766964652061207472616E736372697074696F6E20616E6420706F737369626C792061207472616E';
wwv_flow_imp.g_varchar2_table(5458) := '736C6174696F6E206F6620617564696F2E5C6E202020202A2020204974206D617920696E636C75646520696D706F7274616E74206E6F6E2D76657262616C20696E666F726D6174696F6E2073756368206173206D757369632063756573206F7220736F75';
wwv_flow_imp.g_varchar2_table(5459) := '6E6420656666656374732E204974206D617920696E6469636174652074686520637565277320736F757263652028652E672E206D757369632C20746578742C20636861726163746572292E5C6E202020202A2020205375697461626C6520666F72207573';
wwv_flow_imp.g_varchar2_table(5460) := '6572732077686F206172652064656166206F72207768656E2074686520736F756E64206973206D757465642E5C6E2A202020606465736372697074696F6E73605C6E202020202A2020205465787475616C206465736372697074696F6E206F6620746865';
wwv_flow_imp.g_varchar2_table(5461) := '20766964656F20636F6E74656E742E5C6E202020202A2020205375697461626C6520666F722075736572732077686F2061726520626C696E64206F722077686572652074686520766964656F2063616E6E6F74206265207365656E2E5C6E2A2020206063';
wwv_flow_imp.g_varchar2_table(5462) := '68617074657273605C6E202020202A20202043686170746572207469746C65732061726520696E74656E64656420746F2062652075736564207768656E207468652075736572206973206E617669676174696E6720746865206D65646961207265736F75';
wwv_flow_imp.g_varchar2_table(5463) := '7263652E5C6E2A202020606D65746164617461605C6E202020202A202020547261636B73207573656420627920736372697074732E204E6F742076697369626C6520746F2074686520757365722E227D7D2C7B6E616D653A226C6162656C222C64657363';
wwv_flow_imp.g_varchar2_table(5464) := '72697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120757365722D7265616461626C65207469746C65206F6620746865207465787420747261636B2077686963682069732075736564206279207468652062726F77736572';
wwv_flow_imp.g_varchar2_table(5465) := '207768656E206C697374696E6720617661696C61626C65207465787420747261636B732E227D7D2C7B6E616D653A22737263222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2741646472657373206F662074';
wwv_flow_imp.g_varchar2_table(5466) := '686520747261636B2028602E767474602066696C65292E204D75737420626520612076616C69642055524C2E205468697320617474726962757465206D7573742062652073706563696669656420616E64206974732055524C2076616C7565206D757374';
wwv_flow_imp.g_varchar2_table(5467) := '2068617665207468652073616D65206F726967696E2061732074686520646F63756D656E7420E2809420756E6C65737320746865205B603C617564696F3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D5553';
wwv_flow_imp.g_varchar2_table(5468) := '2F646F63732F5765622F48544D4C2F456C656D656E742F617564696F20225468652048544D4C203C617564696F3E20656C656D656E74206973207573656420746F20656D62656420736F756E6420636F6E74656E7420696E20646F63756D656E74732E20';
wwv_flow_imp.g_varchar2_table(5469) := '4974206D617920636F6E7461696E206F6E65206F72206D6F726520617564696F20736F75726365732C20726570726573656E746564207573696E67207468652073726320617474726962757465206F7220746865203C736F757263653E20656C656D656E';
wwv_flow_imp.g_varchar2_table(5470) := '743AC2A07468652062726F777365722077696C6C2063686F6F736520746865206D6F7374207375697461626C65206F6E652E2049742063616E20616C736F206265207468652064657374696E6174696F6E20666F722073747265616D6564206D65646961';
wwv_flow_imp.g_varchar2_table(5471) := '2C207573696E672061204D6564696153747265616D2E2229206F72205B603C766964656F3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7669';
wwv_flow_imp.g_varchar2_table(5472) := '64656F20225468652048544D4C20566964656F20656C656D656E7420283C766964656F3E2920656D626564732061206D6564696120706C6179657220776869636820737570706F72747320766964656F20706C61796261636B20696E746F207468652064';
wwv_flow_imp.g_varchar2_table(5473) := '6F63756D656E742E222920706172656E7420656C656D656E74206F66207468652060747261636B6020656C656D656E74206861732061205B6063726F73736F726967696E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F7267';
wwv_flow_imp.g_varchar2_table(5474) := '2F656E2D55532F646F63732F5765622F48544D4C2F434F52535F73657474696E67735F6174747269627574657329206174747269627574652E277D7D2C7B6E616D653A227372636C616E67222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(5475) := '646F776E222C76616C75653A224C616E6775616765206F662074686520747261636B207465787420646174612E204974206D75737420626520612076616C6964205B4243502034375D2868747470733A2F2F723132612E6769746875622E696F2F617070';
wwv_flow_imp.g_varchar2_table(5476) := '2D737562746167732F29206C616E6775616765207461672E2049662074686520606B696E6460206174747269627574652069732073657420746FC2A0607375627469746C65732C60207468656E20607372636C616E6760206D7573742062652064656669';
wwv_flow_imp.g_varchar2_table(5477) := '6E65642E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F';
wwv_flow_imp.g_varchar2_table(5478) := '747261636B227D5D7D2C7B6E616D653A226D6170222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D617020656C656D656E742C20696E20636F6E6A756E6374696F6E207769746820616E20696D';
wwv_flow_imp.g_varchar2_table(5479) := '6720656C656D656E7420616E6420616E79206172656120656C656D656E742064657363656E64616E74732C20646566696E657320616E20696D616765206D61702E2054686520656C656D656E7420726570726573656E747320697473206368696C647265';
wwv_flow_imp.g_varchar2_table(5480) := '6E2E227D2C617474726962757465733A5B7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206E616D652061747472696275746520676976657320746865206D61702061';
wwv_flow_imp.g_varchar2_table(5481) := '206E616D6520736F20746861742069742063616E206265207265666572656E6365642E2054686520617474726962757465206D7573742062652070726573656E7420616E64206D75737420686176652061206E6F6E2D656D7074792076616C7565207769';
wwv_flow_imp.g_varchar2_table(5482) := '7468206E6F20737061636520636861726163746572732E205468652076616C7565206F6620746865206E616D6520617474726962757465206D757374206E6F74206265206120636F6D7061746962696C6974792D636173656C657373206D617463682066';
wwv_flow_imp.g_varchar2_table(5483) := '6F72207468652076616C7565206F6620746865206E616D6520617474726962757465206F6620616E6F74686572206D617020656C656D656E7420696E207468652073616D6520646F63756D656E742E204966207468652069642061747472696275746520';
wwv_flow_imp.g_varchar2_table(5484) := '697320616C736F207370656369666965642C20626F74682061747472696275746573206D7573742068617665207468652073616D652076616C75652E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75';
wwv_flow_imp.g_varchar2_table(5485) := '726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6D6170227D5D7D2C7B6E616D653A2261726561222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(5486) := '646F776E222C76616C75653A22546865206172656120656C656D656E7420726570726573656E74732065697468657220612068797065726C696E6B207769746820736F6D65207465787420616E64206120636F72726573706F6E64696E67206172656120';
wwv_flow_imp.g_varchar2_table(5487) := '6F6E20616E20696D616765206D61702C206F72206120646561642061726561206F6E20616E20696D616765206D61702E227D2C617474726962757465733A5B7B6E616D653A22616C74227D2C7B6E616D653A22636F6F726473227D2C7B6E616D653A2273';
wwv_flow_imp.g_varchar2_table(5488) := '68617065222C76616C75655365743A227368227D2C7B6E616D653A2268726566227D2C7B6E616D653A22746172676574227D2C7B6E616D653A22646F776E6C6F6164227D2C7B6E616D653A2270696E67227D2C7B6E616D653A2272656C227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(5489) := '653A22687265666C616E67227D2C7B6E616D653A2274797065227D2C7B6E616D653A226163636573736B6579222C6465736372697074696F6E3A225370656369666965732061206B6579626F617264206E617669676174696F6E20616363656C65726174';
wwv_flow_imp.g_varchar2_table(5490) := '6F7220666F722074686520656C656D656E742E205072657373696E6720414C54206F7220612073696D696C6172206B657920696E206173736F63696174696F6E20776974682074686520737065636966696564206368617261637465722073656C656374';
wwv_flow_imp.g_varchar2_table(5491) := '732074686520666F726D20636F6E74726F6C20636F7272656C6174656420776974682074686174206B65792073657175656E63652E20506167652064657369676E6572732061726520666F72657761726E656420746F2061766F6964206B657920736571';
wwv_flow_imp.g_varchar2_table(5492) := '75656E63657320616C726561647920626F756E6420746F2062726F77736572732E20546869732061747472696275746520697320676C6F62616C2073696E63652048544D4C352E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265';
wwv_flow_imp.g_varchar2_table(5493) := '666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F61726561227D5D7D2C7B6E616D653A227461626C65222C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(5494) := '3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207461626C6520656C656D656E7420726570726573656E747320646174612077697468206D6F7265207468616E206F6E652064696D656E73696F6E2C20696E2074686520666F726D';
wwv_flow_imp.g_varchar2_table(5495) := '206F662061207461626C652E227D2C617474726962757465733A5B7B6E616D653A22626F72646572227D2C7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D6572617465642061747472696275746520696E6469';
wwv_flow_imp.g_varchar2_table(5496) := '636174657320686F7720746865207461626C65206D75737420626520616C69676E656420696E736964652074686520636F6E7461696E696E6720646F63756D656E742E204974206D617920686176652074686520666F6C6C6F77696E672076616C756573';
wwv_flow_imp.g_varchar2_table(5497) := '3A5C6E5C6E2A2020206C6566743A20746865207461626C6520697320646973706C61796564206F6E20746865206C6566742073696465206F662074686520646F63756D656E743B5C6E2A20202063656E7465723A20746865207461626C65206973206469';
wwv_flow_imp.g_varchar2_table(5498) := '73706C6179656420696E207468652063656E746572206F662074686520646F63756D656E743B5C6E2A20202072696768743A20746865207461626C6520697320646973706C61796564206F6E207468652072696768742073696465206F66207468652064';
wwv_flow_imp.g_varchar2_table(5499) := '6F63756D656E742E5C6E5C6E2A2A5573616765204E6F74652A2A5C6E5C6E2A2020202A2A446F206E6F74207573652074686973206174747269627574652A2A2C20617320697420686173206265656E20646570726563617465642E20546865205B603C74';
wwv_flow_imp.g_varchar2_table(5500) := '61626C653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7461626C6520225468652048544D4C203C7461626C653E20656C656D656E74207265';
wwv_flow_imp.g_varchar2_table(5501) := '70726573656E747320746162756C6172206461746120E2809420746861742069732C20696E666F726D6174696F6E2070726573656E74656420696E20612074776F2D64696D656E73696F6E616C207461626C6520636F6D707269736564206F6620726F77';
wwv_flow_imp.g_varchar2_table(5502) := '7320616E6420636F6C756D6E73206F662063656C6C7320636F6E7461696E696E6720646174612E222920656C656D656E742073686F756C64206265207374796C6564207573696E67205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A';
wwv_flow_imp.g_varchar2_table(5503) := '696C6C612E6F72672F656E2D55532F646F63732F435353292E20536574205B606D617267696E2D6C656674605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6D61726769';
wwv_flow_imp.g_varchar2_table(5504) := '6E2D6C6566742022546865206D617267696E2D6C656674204353532070726F7065727479207365747320746865206D617267696E2061726561206F6E20746865206C6566742073696465206F6620616E20656C656D656E742E204120706F736974697665';
wwv_flow_imp.g_varchar2_table(5505) := '2076616C756520706C6163657320697420666172746865722066726F6D20697473206E65696768626F72732C207768696C652061206E656761746976652076616C756520706C6163657320697420636C6F7365722E222920616E64205B606D617267696E';
wwv_flow_imp.g_varchar2_table(5506) := '2D7269676874605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6D617267696E2D72696768742022546865206D617267696E2D7269676874204353532070726F70657274';
wwv_flow_imp.g_varchar2_table(5507) := '79207365747320746865206D617267696E2061726561206F6E207468652072696768742073696465206F6620616E20656C656D656E742E204120706F7369746976652076616C756520706C6163657320697420666172746865722066726F6D2069747320';
wwv_flow_imp.g_varchar2_table(5508) := '6E65696768626F72732C207768696C652061206E656761746976652076616C756520706C6163657320697420636C6F7365722E222920746F20606175746F60206F72205B606D617267696E605D2868747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5509) := '6C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F6D617267696E2022546865206D617267696E204353532070726F7065727479207365747320746865206D617267696E2061726561206F6E20616C6C20666F7572207369646573206F66';
wwv_flow_imp.g_varchar2_table(5510) := '20616E20656C656D656E742E20497420697320612073686F727468616E6420666F72206D617267696E2D746F702C206D617267696E2D72696768742C206D617267696E2D626F74746F6D2C20616E64206D617267696E2D6C6566742E222920746F206030';
wwv_flow_imp.g_varchar2_table(5511) := '206175746F6020746F206163686965766520616E2065666665637420746861742069732073696D696C617220746F2074686520616C69676E206174747269627574652E5C6E2A2020205072696F7220746F2046697265666F7820342C2046697265666F78';
wwv_flow_imp.g_varchar2_table(5512) := '20616C736F20737570706F727465642074686520606D6964646C65602C20606162736D6964646C65602C20616E64206061627363656E746572602076616C7565732061732073796E6F6E796D73206F66206063656E746572602C20696E20717569726B73';
wwv_flow_imp.g_varchar2_table(5513) := '206D6F6465206F6E6C792E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C';
wwv_flow_imp.g_varchar2_table(5514) := '656D656E742F7461626C65227D5D7D2C7B6E616D653A2263617074696F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652063617074696F6E20656C656D656E7420726570726573656E74732074';
wwv_flow_imp.g_varchar2_table(5515) := '6865207469746C65206F6620746865207461626C6520746861742069732069747320706172656E742C20696620697420686173206120706172656E7420616E6420746861742069732061207461626C6520656C656D656E742E227D2C6174747269627574';
wwv_flow_imp.g_varchar2_table(5516) := '65733A5B7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D6572617465642061747472696275746520696E6469636174657320686F77207468652063617074696F6E206D75737420626520616C69676E65642077';
wwv_flow_imp.g_varchar2_table(5517) := '697468207265737065637420746F20746865207461626C652E204974206D61792068617665206F6E65206F662074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E606C656674605C6E5C6E5468652063617074696F6E20697320646973706C';
wwv_flow_imp.g_varchar2_table(5518) := '6179656420746F20746865206C656674206F6620746865207461626C652E5C6E5C6E60746F70605C6E5C6E5468652063617074696F6E20697320646973706C617965642061626F766520746865207461626C652E5C6E5C6E607269676874605C6E5C6E54';
wwv_flow_imp.g_varchar2_table(5519) := '68652063617074696F6E20697320646973706C6179656420746F20746865207269676874206F6620746865207461626C652E5C6E5C6E60626F74746F6D605C6E5C6E5468652063617074696F6E20697320646973706C617965642062656C6F7720746865';
wwv_flow_imp.g_varchar2_table(5520) := '207461626C652E5C6E5C6E2A2A5573616765206E6F74653A2A2A20446F206E6F74207573652074686973206174747269627574652C20617320697420686173206265656E20646570726563617465642E20546865205B603C63617074696F6E3E605D2868';
wwv_flow_imp.g_varchar2_table(5521) := '747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F63617074696F6E20225468652048544D4C205461626C652043617074696F6E20656C656D656E7420283C63';
wwv_flow_imp.g_varchar2_table(5522) := '617074696F6E3E2920737065636966696573207468652063617074696F6E20286F72207469746C6529206F662061207461626C652C20616E64206966207573656420697320616C7761797320746865206669727374206368696C64206F662061203C7461';
wwv_flow_imp.g_varchar2_table(5523) := '626C653E2E222920656C656D656E742073686F756C64206265207374796C6564207573696E6720746865205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F435353292070726F7065';
wwv_flow_imp.g_varchar2_table(5524) := '7274696573205B6063617074696F6E2D73696465605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F63617074696F6E2D7369646520225468652063617074696F6E2D7369';
wwv_flow_imp.g_varchar2_table(5525) := '6465204353532070726F706572747920707574732074686520636F6E74656E74206F662061207461626C655C2773203C63617074696F6E3E206F6E207468652073706563696669656420736964652E205468652076616C756573206172652072656C6174';
wwv_flow_imp.g_varchar2_table(5526) := '69766520746F207468652077726974696E672D6D6F6465206F6620746865207461626C652E222920616E64205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F';
wwv_flow_imp.g_varchar2_table(5527) := '5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D';
wwv_flow_imp.g_varchar2_table(5528) := '63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292E277D5D2C7265666572656E6365733A';
wwv_flow_imp.g_varchar2_table(5529) := '5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F63617074696F6E227D5D7D2C7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(5530) := '6F6C67726F7570222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520636F6C67726F757020656C656D656E7420726570726573656E747320612067726F7570206F66206F6E65206F72206D6F726520';
wwv_flow_imp.g_varchar2_table(5531) := '636F6C756D6E7320696E20746865207461626C6520746861742069732069747320706172656E742C20696620697420686173206120706172656E7420616E6420746861742069732061207461626C6520656C656D656E742E227D2C617474726962757465';
wwv_flow_imp.g_varchar2_table(5532) := '733A5B7B6E616D653A227370616E227D2C7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D657261746564206174747269627574652073706563696669657320686F7720686F72697A6F6E74616C20616C69676E';
wwv_flow_imp.g_varchar2_table(5533) := '6D656E74206F66206561636820636F6C756D6E2063656C6C20636F6E74656E742077696C6C2062652068616E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606C656674602C20616C69676E696E67207468652063';
wwv_flow_imp.g_varchar2_table(5534) := '6F6E74656E7420746F20746865206C656674206F66207468652063656C6C5C6E2A2020206063656E746572602C2063656E746572696E672074686520636F6E74656E7420696E207468652063656C6C5C6E2A202020607269676874602C20616C69676E69';
wwv_flow_imp.g_varchar2_table(5535) := '6E672074686520636F6E74656E7420746F20746865207269676874206F66207468652063656C6C5C6E2A202020606A757374696679602C20696E73657274696E672073706163657320696E746F20746865207465787475616C20636F6E74656E7420736F';
wwv_flow_imp.g_varchar2_table(5536) := '20746861742074686520636F6E74656E74206973206A757374696669656420696E207468652063656C6C5C6E2A2020206063686172602C20616C69676E696E6720746865207465787475616C20636F6E74656E74206F6E2061207370656369616C206368';
wwv_flow_imp.g_varchar2_table(5537) := '6172616374657220776974682061206D696E696D616C206F66667365742C20646566696E656420627920746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F';
wwv_flow_imp.g_varchar2_table(5538) := '48544D4C2F456C656D656E742F636F6C23617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E';
wwv_flow_imp.g_varchar2_table(5539) := '742F636F6C23617474722D636861726F666629206174747269627574657320556E696D706C656D656E7465642028736565205B627567C2A0323231325D2868747470733A2F2F6275677A696C6C612E6D6F7A696C6C612E6F72672F73686F775F6275672E';
wwv_flow_imp.g_varchar2_table(5540) := '6367693F69643D32323132202263686172616374657220616C69676E6D656E74206E6F7420696D706C656D656E7465642028616C69676E3D636861722C20636861726F66663D2C20746578742D616C69676E3A3C737472696E673E292229292E5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5541) := '4966207468697320617474726962757465206973206E6F74207365742C2074686520606C656674602076616C756520697320617373756D65642E205468652064657363656E64616E74205B603C636F6C3E605D2868747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(5542) := '722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C20225468652048544D4C203C636F6C3E20656C656D656E7420646566696E6573206120636F6C756D6E2077697468696E2061207461626C';
wwv_flow_imp.g_varchar2_table(5543) := '6520616E64206973207573656420666F7220646566696E696E6720636F6D6D6F6E2073656D616E74696373206F6E20616C6C20636F6D6D6F6E2063656C6C732E2049742069732067656E6572616C6C7920666F756E642077697468696E2061203C636F6C';
wwv_flow_imp.g_varchar2_table(5544) := '67726F75703E20656C656D656E742E222920656C656D656E7473206D6179206F7665727269646520746869732076616C7565207573696E67207468656972206F776E205B60616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(5545) := '6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C23617474722D616C69676E29206174747269627574652E5C6E5C6E2A2A4E6F74653A2A2A20446F206E6F7420757365207468697320617474726962757465';
wwv_flow_imp.g_varchar2_table(5546) := '206173206974206973206F62736F6C65746520286E6F7420737570706F727465642920696E20746865206C6174657374207374616E646172642E5C6E5C6E2A202020546F2061636869657665207468652073616D65206566666563742061732074686520';
wwv_flow_imp.g_varchar2_table(5547) := '606C656674602C206063656E746572602C2060726967687460206F7220606A757374696679602076616C7565733A5C6E202020202A202020446F206E6F742074727920746F2073657420746865205B60746578742D616C69676E605D2868747470733A2F';
wwv_flow_imp.g_varchar2_table(5548) := '2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E7461';
wwv_flow_imp.g_varchar2_table(5549) := '6C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A';
wwv_flow_imp.g_varchar2_table(5550) := '6F6E74616C20646972656374696F6E2E22292070726F7065727479206F6E20612073656C6563746F7220676976696E672061205B603C636F6C67726F75703E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55';
wwv_flow_imp.g_varchar2_table(5551) := '532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C67726F757020225468652048544D4C203C636F6C67726F75703E20656C656D656E7420646566696E657320612067726F7570206F6620636F6C756D6E732077697468696E2061207461';
wwv_flow_imp.g_varchar2_table(5552) := '626C652E222920656C656D656E742E2042656361757365205B603C74643E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746420225468652048';
wwv_flow_imp.g_varchar2_table(5553) := '544D4C203C74643E20656C656D656E7420646566696E657320612063656C6C206F662061207461626C65207468617420636F6E7461696E7320646174612E2049742070617274696369706174657320696E20746865207461626C65206D6F64656C2E2229';
wwv_flow_imp.g_varchar2_table(5554) := '20656C656D656E747320617265206E6F742064657363656E64616E74206F6620746865205B603C636F6C67726F75703E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C';
wwv_flow_imp.g_varchar2_table(5555) := '2F456C656D656E742F636F6C67726F757020225468652048544D4C203C636F6C67726F75703E20656C656D656E7420646566696E657320612067726F7570206F6620636F6C756D6E732077697468696E2061207461626C652E222920656C656D656E742C';
wwv_flow_imp.g_varchar2_table(5556) := '207468657920776F6E5C277420696E68657269742069742E5C6E202020202A202020496620746865207461626C6520646F65736E5C2774207573652061205B60636F6C7370616E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E';
wwv_flow_imp.g_varchar2_table(5557) := '6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D636F6C7370616E29206174747269627574652C20757365206F6E65206074643A6E74682D6368696C6428616E2B622960204353532073656C6563746F';
wwv_flow_imp.g_varchar2_table(5558) := '722070657220636F6C756D6E2C20776865726520612069732074686520746F74616C206E756D626572206F662074686520636F6C756D6E7320696E20746865207461626C6520616E64206220697320746865206F7264696E616C20706F736974696F6E20';
wwv_flow_imp.g_varchar2_table(5559) := '6F66207468697320636F6C756D6E20696E20746865207461626C652E204F6E6C7920616674657220746869732073656C6563746F7220746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F';
wwv_flow_imp.g_varchar2_table(5560) := '72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E';
wwv_flow_imp.g_varchar2_table(5561) := '6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070';
wwv_flow_imp.g_varchar2_table(5562) := '726F70657274792063616E20626520757365642E5C6E202020202A202020496620746865207461626C6520646F6573207573652061205B60636F6C7370616E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55';
wwv_flow_imp.g_varchar2_table(5563) := '532F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D636F6C7370616E29206174747269627574652C20746865206566666563742063616E20626520616368696576656420627920636F6D62696E696E67206164657175617465';
wwv_flow_imp.g_varchar2_table(5564) := '20435353206174747269627574652073656C6563746F7273206C696B6520605B636F6C7370616E3D6E5D602C2074686F7567682074686973206973206E6F74207472697669616C2E5C6E2A202020546F2061636869657665207468652073616D65206566';
wwv_flow_imp.g_varchar2_table(5565) := '6665637420617320746865206063686172602076616C75652C20696E20435353332C20796F752063616E20757365207468652076616C7565206F6620746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F';
wwv_flow_imp.g_varchar2_table(5566) := '72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C67726F757023617474722D6368617229206173207468652076616C7565206F6620746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F';
wwv_flow_imp.g_varchar2_table(5567) := '7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E';
wwv_flow_imp.g_varchar2_table(5568) := '6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C2064';
wwv_flow_imp.g_varchar2_table(5569) := '6972656374696F6E2E22292070726F706572747920556E696D706C656D656E7465642E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5570) := '6C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F636F6C67726F7570227D5D7D2C7B6E616D653A22636F6C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224966206120636F6C20';
wwv_flow_imp.g_varchar2_table(5571) := '656C656D656E7420686173206120706172656E7420616E642074686174206973206120636F6C67726F757020656C656D656E74207468617420697473656C6620686173206120706172656E7420746861742069732061207461626C6520656C656D656E74';
wwv_flow_imp.g_varchar2_table(5572) := '2C207468656E2074686520636F6C20656C656D656E7420726570726573656E7473206F6E65206F72206D6F726520636F6C756D6E7320696E2074686520636F6C756D6E2067726F757020726570726573656E746564206279207468617420636F6C67726F';
wwv_flow_imp.g_varchar2_table(5573) := '75702E227D2C617474726962757465733A5B7B6E616D653A227370616E227D2C7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D657261746564206174747269627574652073706563696669657320686F772068';
wwv_flow_imp.g_varchar2_table(5574) := '6F72697A6F6E74616C20616C69676E6D656E74206F66206561636820636F6C756D6E2063656C6C20636F6E74656E742077696C6C2062652068616E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606C656674602C';
wwv_flow_imp.g_varchar2_table(5575) := '20616C69676E696E672074686520636F6E74656E7420746F20746865206C656674206F66207468652063656C6C5C6E2A2020206063656E746572602C2063656E746572696E672074686520636F6E74656E7420696E207468652063656C6C5C6E2A202020';
wwv_flow_imp.g_varchar2_table(5576) := '607269676874602C20616C69676E696E672074686520636F6E74656E7420746F20746865207269676874206F66207468652063656C6C5C6E2A202020606A757374696679602C20696E73657274696E672073706163657320696E746F2074686520746578';
wwv_flow_imp.g_varchar2_table(5577) := '7475616C20636F6E74656E7420736F20746861742074686520636F6E74656E74206973206A757374696669656420696E207468652063656C6C5C6E2A2020206063686172602C20616C69676E696E6720746865207465787475616C20636F6E74656E7420';
wwv_flow_imp.g_varchar2_table(5578) := '6F6E2061207370656369616C2063686172616374657220776974682061206D696E696D616C206F66667365742C20646566696E656420627920746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F';
wwv_flow_imp.g_varchar2_table(5579) := '656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C23617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F';
wwv_flow_imp.g_varchar2_table(5580) := '5765622F48544D4C2F456C656D656E742F636F6C23617474722D636861726F666629206174747269627574657320556E696D706C656D656E7465642028736565205B627567C2A0323231325D2868747470733A2F2F6275677A696C6C612E6D6F7A696C6C';
wwv_flow_imp.g_varchar2_table(5581) := '612E6F72672F73686F775F6275672E6367693F69643D32323132202263686172616374657220616C69676E6D656E74206E6F7420696D706C656D656E7465642028616C69676E3D636861722C20636861726F66663D2C20746578742D616C69676E3A3C73';
wwv_flow_imp.g_varchar2_table(5582) := '7472696E673E292229292E5C6E5C6E4966207468697320617474726962757465206973206E6F74207365742C206974732076616C756520697320696E686572697465642066726F6D20746865205B60616C69676E605D2868747470733A2F2F646576656C';
wwv_flow_imp.g_varchar2_table(5583) := '6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C67726F757023617474722D616C69676E29206F6620746865205B603C636F6C67726F75703E605D2868747470733A2F2F64657665';
wwv_flow_imp.g_varchar2_table(5584) := '6C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C67726F757020225468652048544D4C203C636F6C67726F75703E20656C656D656E7420646566696E657320612067726F757020';
wwv_flow_imp.g_varchar2_table(5585) := '6F6620636F6C756D6E732077697468696E2061207461626C652E222920656C656D656E74207468697320603C636F6C3E6020656C656D656E742062656C6F6E677320746F6F2E20496620746865726520617265206E6F6E652C2074686520606C65667460';
wwv_flow_imp.g_varchar2_table(5586) := '2076616C756520697320617373756D65642E5C6E5C6E2A2A4E6F74653A2A2A20446F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C65746520286E6F7420737570706F727465642920696E20746865206C';
wwv_flow_imp.g_varchar2_table(5587) := '6174657374207374616E646172642E5C6E5C6E2A202020546F2061636869657665207468652073616D65206566666563742061732074686520606C656674602C206063656E746572602C2060726967687460206F7220606A757374696679602076616C75';
wwv_flow_imp.g_varchar2_table(5588) := '65733A5C6E202020202A202020446F206E6F742074727920746F2073657420746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F74';
wwv_flow_imp.g_varchar2_table(5589) := '6578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E';
wwv_flow_imp.g_varchar2_table(5590) := '2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F7065727479206F6E20612073656C6563746F722067';
wwv_flow_imp.g_varchar2_table(5591) := '6976696E672061205B603C636F6C3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C20225468652048544D4C203C636F6C3E20656C656D';
wwv_flow_imp.g_varchar2_table(5592) := '656E7420646566696E6573206120636F6C756D6E2077697468696E2061207461626C6520616E64206973207573656420666F7220646566696E696E6720636F6D6D6F6E2073656D616E74696373206F6E20616C6C20636F6D6D6F6E2063656C6C732E2049';
wwv_flow_imp.g_varchar2_table(5593) := '742069732067656E6572616C6C7920666F756E642077697468696E2061203C636F6C67726F75703E20656C656D656E742E222920656C656D656E742E2042656361757365205B603C74643E605D2868747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5594) := '6C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746420225468652048544D4C203C74643E20656C656D656E7420646566696E657320612063656C6C206F662061207461626C65207468617420636F6E7461696E';
wwv_flow_imp.g_varchar2_table(5595) := '7320646174612E2049742070617274696369706174657320696E20746865207461626C65206D6F64656C2E222920656C656D656E747320617265206E6F742064657363656E64616E74206F6620746865205B603C636F6C3E605D2868747470733A2F2F64';
wwv_flow_imp.g_varchar2_table(5596) := '6576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C20225468652048544D4C203C636F6C3E20656C656D656E7420646566696E6573206120636F6C756D6E2077697468696E';
wwv_flow_imp.g_varchar2_table(5597) := '2061207461626C6520616E64206973207573656420666F7220646566696E696E6720636F6D6D6F6E2073656D616E74696373206F6E20616C6C20636F6D6D6F6E2063656C6C732E2049742069732067656E6572616C6C7920666F756E642077697468696E';
wwv_flow_imp.g_varchar2_table(5598) := '2061203C636F6C67726F75703E20656C656D656E742E222920656C656D656E742C207468657920776F6E5C277420696E68657269742069742E5C6E202020202A202020496620746865207461626C6520646F65736E5C2774207573652061205B60636F6C';
wwv_flow_imp.g_varchar2_table(5599) := '7370616E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D636F6C7370616E29206174747269627574652C2075736520746865';
wwv_flow_imp.g_varchar2_table(5600) := '206074643A6E74682D6368696C6428616E2B622960204353532073656C6563746F722E205365742060616020746F207A65726F20616E642060626020746F2074686520706F736974696F6E206F662074686520636F6C756D6E20696E2074686520746162';
wwv_flow_imp.g_varchar2_table(5601) := '6C652C20652E672E206074643A6E74682D6368696C64283229207B20746578742D616C69676E3A2072696768743B207D6020746F2072696768742D616C69676E20746865207365636F6E6420636F6C756D6E2E5C6E202020202A20202049662074686520';
wwv_flow_imp.g_varchar2_table(5602) := '7461626C6520646F6573207573652061205B60636F6C7370616E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D636F6C7370';
wwv_flow_imp.g_varchar2_table(5603) := '616E29206174747269627574652C20746865206566666563742063616E20626520616368696576656420627920636F6D62696E696E6720616465717561746520435353206174747269627574652073656C6563746F7273206C696B6520605B636F6C7370';
wwv_flow_imp.g_varchar2_table(5604) := '616E3D6E5D602C2074686F7567682074686973206973206E6F74207472697669616C2E5C6E2A202020546F2061636869657665207468652073616D652065666665637420617320746865206063686172602076616C75652C20696E20435353332C20796F';
wwv_flow_imp.g_varchar2_table(5605) := '752063616E20757365207468652076616C7565206F6620746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F636F6C236174';
wwv_flow_imp.g_varchar2_table(5606) := '74722D6368617229206173207468652076616C7565206F6620746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C';
wwv_flow_imp.g_varchar2_table(5607) := '69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E205468697320';
wwv_flow_imp.g_varchar2_table(5608) := '6D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920556E696D706C656D656E7465642E277D5D2C726566';
wwv_flow_imp.g_varchar2_table(5609) := '6572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F636F6C227D5D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(5610) := '653A2274626F6479222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652074626F647920656C656D656E7420726570726573656E7473206120626C6F636B206F6620726F7773207468617420636F6E73';
wwv_flow_imp.g_varchar2_table(5611) := '697374206F66206120626F6479206F66206461746120666F722074686520706172656E74207461626C6520656C656D656E742C206966207468652074626F647920656C656D656E7420686173206120706172656E7420616E642069742069732061207461';
wwv_flow_imp.g_varchar2_table(5612) := '626C652E227D2C617474726962757465733A5B7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D657261746564206174747269627574652073706563696669657320686F7720686F72697A6F6E74616C20616C69';
wwv_flow_imp.g_varchar2_table(5613) := '676E6D656E74206F6620656163682063656C6C20636F6E74656E742077696C6C2062652068616E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606C656674602C20616C69676E696E672074686520636F6E74656E';
wwv_flow_imp.g_varchar2_table(5614) := '7420746F20746865206C656674206F66207468652063656C6C5C6E2A2020206063656E746572602C2063656E746572696E672074686520636F6E74656E7420696E207468652063656C6C5C6E2A202020607269676874602C20616C69676E696E67207468';
wwv_flow_imp.g_varchar2_table(5615) := '6520636F6E74656E7420746F20746865207269676874206F66207468652063656C6C5C6E2A202020606A757374696679602C20696E73657274696E672073706163657320696E746F20746865207465787475616C20636F6E74656E7420736F2074686174';
wwv_flow_imp.g_varchar2_table(5616) := '2074686520636F6E74656E74206973206A757374696669656420696E207468652063656C6C5C6E2A2020206063686172602C20616C69676E696E6720746865207465787475616C20636F6E74656E74206F6E2061207370656369616C2063686172616374';
wwv_flow_imp.g_varchar2_table(5617) := '657220776974682061206D696E696D616C206F66667365742C20646566696E656420627920746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F';
wwv_flow_imp.g_varchar2_table(5618) := '456C656D656E742F74626F647923617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F74';
wwv_flow_imp.g_varchar2_table(5619) := '626F647923617474722D636861726F66662920617474726962757465732E5C6E5C6E4966207468697320617474726962757465206973206E6F74207365742C2074686520606C656674602076616C756520697320617373756D65642E5C6E5C6E2A2A4E6F';
wwv_flow_imp.g_varchar2_table(5620) := '74653A2A2A20446F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C65746520286E6F7420737570706F727465642920696E20746865206C6174657374207374616E646172642E5C6E5C6E2A202020546F20';
wwv_flow_imp.g_varchar2_table(5621) := '61636869657665207468652073616D65206566666563742061732074686520606C656674602C206063656E746572602C2060726967687460206F7220606A757374696679602076616C7565732C207573652074686520435353205B60746578742D616C69';
wwv_flow_imp.g_varchar2_table(5622) := '676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074';
wwv_flow_imp.g_varchar2_table(5623) := '686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420';
wwv_flow_imp.g_varchar2_table(5624) := '696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F7065727479206F6E2069742E5C6E2A202020546F2061636869657665207468652073616D652065666665637420617320746865206063686172602076616C75652C20';
wwv_flow_imp.g_varchar2_table(5625) := '696E20435353332C20796F752063616E20757365207468652076616C7565206F6620746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C65';
wwv_flow_imp.g_varchar2_table(5626) := '6D656E742F74626F647923617474722D6368617229206173207468652076616C7565206F6620746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(5627) := '622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D6365';
wwv_flow_imp.g_varchar2_table(5628) := '6C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920556E696D706C656D';
wwv_flow_imp.g_varchar2_table(5629) := '656E7465642E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E74';
wwv_flow_imp.g_varchar2_table(5630) := '2F74626F6479227D5D7D2C7B6E616D653A227468656164222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520746865616420656C656D656E7420726570726573656E74732074686520626C6F636B20';
wwv_flow_imp.g_varchar2_table(5631) := '6F6620726F7773207468617420636F6E73697374206F662074686520636F6C756D6E206C6162656C732028686561646572732920666F722074686520706172656E74207461626C6520656C656D656E742C2069662074686520746865616420656C656D65';
wwv_flow_imp.g_varchar2_table(5632) := '6E7420686173206120706172656E7420616E642069742069732061207461626C652E227D2C617474726962757465733A5B7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D657261746564206174747269627574';
wwv_flow_imp.g_varchar2_table(5633) := '652073706563696669657320686F7720686F72697A6F6E74616C20616C69676E6D656E74206F6620656163682063656C6C20636F6E74656E742077696C6C2062652068616E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A';
wwv_flow_imp.g_varchar2_table(5634) := '202020606C656674602C20616C69676E696E672074686520636F6E74656E7420746F20746865206C656674206F66207468652063656C6C5C6E2A2020206063656E746572602C2063656E746572696E672074686520636F6E74656E7420696E2074686520';
wwv_flow_imp.g_varchar2_table(5635) := '63656C6C5C6E2A202020607269676874602C20616C69676E696E672074686520636F6E74656E7420746F20746865207269676874206F66207468652063656C6C5C6E2A202020606A757374696679602C20696E73657274696E672073706163657320696E';
wwv_flow_imp.g_varchar2_table(5636) := '746F20746865207465787475616C20636F6E74656E7420736F20746861742074686520636F6E74656E74206973206A757374696669656420696E207468652063656C6C5C6E2A2020206063686172602C20616C69676E696E672074686520746578747561';
wwv_flow_imp.g_varchar2_table(5637) := '6C20636F6E74656E74206F6E2061207370656369616C2063686172616374657220776974682061206D696E696D616C206F66667365742C20646566696E656420627920746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(5638) := '7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746865616423617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F7267';
wwv_flow_imp.g_varchar2_table(5639) := '2F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746865616423617474722D636861726F666629206174747269627574657320556E696D706C656D656E7465642028736565205B627567C2A0323231325D2868747470733A2F2F62';
wwv_flow_imp.g_varchar2_table(5640) := '75677A696C6C612E6D6F7A696C6C612E6F72672F73686F775F6275672E6367693F69643D32323132202263686172616374657220616C69676E6D656E74206E6F7420696D706C656D656E7465642028616C69676E3D636861722C20636861726F66663D2C';
wwv_flow_imp.g_varchar2_table(5641) := '20746578742D616C69676E3A3C737472696E673E292229292E5C6E5C6E4966207468697320617474726962757465206973206E6F74207365742C2074686520606C656674602076616C756520697320617373756D65642E5C6E5C6E2A2A4E6F74653A2A2A';
wwv_flow_imp.g_varchar2_table(5642) := '20446F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C65746520286E6F7420737570706F727465642920696E20746865206C6174657374207374616E646172642E5C6E5C6E2A202020546F206163686965';
wwv_flow_imp.g_varchar2_table(5643) := '7665207468652073616D65206566666563742061732074686520606C656674602C206063656E746572602C2060726967687460206F7220606A757374696679602076616C7565732C207573652074686520435353205B60746578742D616C69676E605D28';
wwv_flow_imp.g_varchar2_table(5644) := '68747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F';
wwv_flow_imp.g_varchar2_table(5645) := '72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E207468';
wwv_flow_imp.g_varchar2_table(5646) := '6520686F72697A6F6E74616C20646972656374696F6E2E22292070726F7065727479206F6E2069742E5C6E2A202020546F2061636869657665207468652073616D652065666665637420617320746865206063686172602076616C75652C20696E204353';
wwv_flow_imp.g_varchar2_table(5647) := '53332C20796F752063616E20757365207468652076616C7565206F6620746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F';
wwv_flow_imp.g_varchar2_table(5648) := '746865616423617474722D6368617229206173207468652076616C7565206F6620746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F435353';
wwv_flow_imp.g_varchar2_table(5649) := '2F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F';
wwv_flow_imp.g_varchar2_table(5650) := '782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920556E696D706C656D656E746564';
wwv_flow_imp.g_varchar2_table(5651) := '2E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F74686561';
wwv_flow_imp.g_varchar2_table(5652) := '64227D5D7D2C7B6E616D653A2274666F6F74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652074666F6F7420656C656D656E7420726570726573656E74732074686520626C6F636B206F6620726F';
wwv_flow_imp.g_varchar2_table(5653) := '7773207468617420636F6E73697374206F662074686520636F6C756D6E2073756D6D61726965732028666F6F746572732920666F722074686520706172656E74207461626C6520656C656D656E742C206966207468652074666F6F7420656C656D656E74';
wwv_flow_imp.g_varchar2_table(5654) := '20686173206120706172656E7420616E642069742069732061207461626C652E227D2C617474726962757465733A5B7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D6572617465642061747472696275746520';
wwv_flow_imp.g_varchar2_table(5655) := '73706563696669657320686F7720686F72697A6F6E74616C20616C69676E6D656E74206F6620656163682063656C6C20636F6E74656E742077696C6C2062652068616E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A2020';
wwv_flow_imp.g_varchar2_table(5656) := '20606C656674602C20616C69676E696E672074686520636F6E74656E7420746F20746865206C656674206F66207468652063656C6C5C6E2A2020206063656E746572602C2063656E746572696E672074686520636F6E74656E7420696E20746865206365';
wwv_flow_imp.g_varchar2_table(5657) := '6C6C5C6E2A202020607269676874602C20616C69676E696E672074686520636F6E74656E7420746F20746865207269676874206F66207468652063656C6C5C6E2A202020606A757374696679602C20696E73657274696E672073706163657320696E746F';
wwv_flow_imp.g_varchar2_table(5658) := '20746865207465787475616C20636F6E74656E7420736F20746861742074686520636F6E74656E74206973206A757374696669656420696E207468652063656C6C5C6E2A2020206063686172602C20616C69676E696E6720746865207465787475616C20';
wwv_flow_imp.g_varchar2_table(5659) := '636F6E74656E74206F6E2061207370656369616C2063686172616374657220776974682061206D696E696D616C206F66667365742C20646566696E656420627920746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5660) := '6C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F74626F647923617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(5661) := '6E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F74626F647923617474722D636861726F666629206174747269627574657320556E696D706C656D656E7465642028736565205B627567C2A0323231325D2868747470733A2F2F627567';
wwv_flow_imp.g_varchar2_table(5662) := '7A696C6C612E6D6F7A696C6C612E6F72672F73686F775F6275672E6367693F69643D32323132202263686172616374657220616C69676E6D656E74206E6F7420696D706C656D656E7465642028616C69676E3D636861722C20636861726F66663D2C2074';
wwv_flow_imp.g_varchar2_table(5663) := '6578742D616C69676E3A3C737472696E673E292229292E5C6E5C6E4966207468697320617474726962757465206973206E6F74207365742C2074686520606C656674602076616C756520697320617373756D65642E5C6E5C6E2A2A4E6F74653A2A2A2044';
wwv_flow_imp.g_varchar2_table(5664) := '6F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C65746520286E6F7420737570706F727465642920696E20746865206C6174657374207374616E646172642E5C6E5C6E2A202020546F2061636869657665';
wwv_flow_imp.g_varchar2_table(5665) := '207468652073616D65206566666563742061732074686520606C656674602C206063656E746572602C2060726967687460206F7220606A757374696679602076616C7565732C207573652074686520435353205B60746578742D616C69676E605D286874';
wwv_flow_imp.g_varchar2_table(5666) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F7269';
wwv_flow_imp.g_varchar2_table(5667) := '7A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520';
wwv_flow_imp.g_varchar2_table(5668) := '686F72697A6F6E74616C20646972656374696F6E2E22292070726F7065727479206F6E2069742E5C6E2A202020546F2061636869657665207468652073616D652065666665637420617320746865206063686172602076616C75652C20696E2043535333';
wwv_flow_imp.g_varchar2_table(5669) := '2C20796F752063616E20757365207468652076616C7565206F6620746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7466';
wwv_flow_imp.g_varchar2_table(5670) := '6F6F7423617474722D6368617229206173207468652076616C7565206F6620746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F74';
wwv_flow_imp.g_varchar2_table(5671) := '6578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E';
wwv_flow_imp.g_varchar2_table(5672) := '2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920556E696D706C656D656E7465642E27';
wwv_flow_imp.g_varchar2_table(5673) := '7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F74666F6F7422';
wwv_flow_imp.g_varchar2_table(5674) := '7D5D7D2C7B6E616D653A227472222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520747220656C656D656E7420726570726573656E7473206120726F77206F662063656C6C7320696E206120746162';
wwv_flow_imp.g_varchar2_table(5675) := '6C652E227D2C617474726962757465733A5B7B6E616D653A22616C69676E222C6465736372697074696F6E3A2741205B60444F4D537472696E67605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63';
wwv_flow_imp.g_varchar2_table(5676) := '732F5765622F4150492F444F4D537472696E672022444F4D537472696E672069732061205554462D313620537472696E672E204173204A61766153637269707420616C72656164792075736573207375636820737472696E67732C20444F4D537472696E';
wwv_flow_imp.g_varchar2_table(5677) := '67206973206D6170706564206469726563746C7920746F206120537472696E672E22292077686963682073706563696669657320686F77207468652063656C6C5C277320636F6E746578742073686F756C6420626520616C69676E656420686F72697A6F';
wwv_flow_imp.g_varchar2_table(5678) := '6E74616C6C792077697468696E207468652063656C6C7320696E2074686520726F773B20746869732069732073686F727468616E6420666F72207573696E672060616C69676E60206F6E2065766572792063656C6C20696E2074686520726F7720696E64';
wwv_flow_imp.g_varchar2_table(5679) := '6976696475616C6C792E20506F737369626C652076616C756573206172653A5C6E5C6E606C656674605C6E5C6E416C69676E2074686520636F6E74656E74206F6620656163682063656C6C20617420697473206C65667420656467652E5C6E5C6E606365';
wwv_flow_imp.g_varchar2_table(5680) := '6E746572605C6E5C6E43656E7465722074686520636F6E74656E7473206F6620656163682063656C6C206265747765656E207468656972206C65667420616E642072696768742065646765732E5C6E5C6E607269676874605C6E5C6E416C69676E207468';
wwv_flow_imp.g_varchar2_table(5681) := '6520636F6E74656E74206F6620656163682063656C6C2061742069747320726967687420656467652E5C6E5C6E606A757374696679605C6E5C6E576964656E2077686974657370616365732077697468696E207468652074657874206F66206561636820';
wwv_flow_imp.g_varchar2_table(5682) := '63656C6C20736F20746861742074686520746578742066696C6C73207468652066756C6C207769647468206F6620656163682063656C6C202866756C6C206A757374696669636174696F6E292E5C6E5C6E6063686172605C6E5C6E416C69676E20656163';
wwv_flow_imp.g_varchar2_table(5683) := '682063656C6C20696E2074686520726F77206F6E2061207370656369666963206368617261637465722028737563682074686174206561636820726F7720696E2074686520636F6C756D6E207468617420697320636F6E66696775726564207468697320';
wwv_flow_imp.g_varchar2_table(5684) := '7761792077696C6C20686F72697A6F6E74616C6C7920616C69676E206974732063656C6C73206F6E207468617420636861726163746572292E2054686973207573657320746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D';
wwv_flow_imp.g_varchar2_table(5685) := '6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F747223617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(5686) := '6E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F747223617474722D636861726F66662920746F2065737461626C6973682074686520616C69676E6D656E742063686172616374657220287479706963616C6C7920222E22206F722022';
wwv_flow_imp.g_varchar2_table(5687) := '2C22207768656E20616C69676E696E67206E756D65726963616C20646174612920616E6420746865206E756D626572206F66206368617261637465727320746861742073686F756C6420666F6C6C6F772074686520616C69676E6D656E74206368617261';
wwv_flow_imp.g_varchar2_table(5688) := '637465722E205468697320616C69676E6D656E74207479706520776173206E6576657220776964656C7920737570706F727465642E5C6E5C6E4966206E6F2076616C756520697320657870726573736C792073657420666F722060616C69676E602C2074';
wwv_flow_imp.g_varchar2_table(5689) := '686520706172656E74206E6F64655C27732076616C756520697320696E686572697465642E5C6E5C6E496E7374656164206F66207573696E6720746865206F62736F6C6574652060616C69676E60206174747269627574652C20796F752073686F756C64';
wwv_flow_imp.g_varchar2_table(5690) := '20696E7374656164207573652074686520435353205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E2022546865';
wwv_flow_imp.g_varchar2_table(5691) := '20746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E73206974';
wwv_flow_imp.g_varchar2_table(5692) := '20776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920746F2065737461626C69736820606C656674602C206063656E74657260';
wwv_flow_imp.g_varchar2_table(5693) := '2C20607269676874602C206F7220606A7573746966796020616C69676E6D656E7420666F722074686520726F775C27732063656C6C732E20546F206170706C79206368617261637465722D626173656420616C69676E6D656E742C207365742074686520';
wwv_flow_imp.g_varchar2_table(5694) := '435353205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070';
wwv_flow_imp.g_varchar2_table(5695) := '726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B65207665727469';
wwv_flow_imp.g_varchar2_table(5696) := '63616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920746F2074686520616C69676E6D656E74206368617261637465722028737563682061732060222E2260206F722060';
wwv_flow_imp.g_varchar2_table(5697) := '222C2260292E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E74';
wwv_flow_imp.g_varchar2_table(5698) := '2F7472227D5D7D2C7B6E616D653A227464222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520746420656C656D656E7420726570726573656E7473206120646174612063656C6C20696E2061207461';
wwv_flow_imp.g_varchar2_table(5699) := '626C652E227D2C617474726962757465733A5B7B6E616D653A22636F6C7370616E227D2C7B6E616D653A22726F777370616E227D2C7B6E616D653A2268656164657273227D2C7B6E616D653A2261626272222C6465736372697074696F6E3A2254686973';
wwv_flow_imp.g_varchar2_table(5700) := '2061747472696275746520636F6E7461696E7320612073686F7274206162627265766961746564206465736372697074696F6E206F66207468652063656C6C277320636F6E74656E742E20536F6D6520757365722D6167656E74732C2073756368206173';
wwv_flow_imp.g_varchar2_table(5701) := '2073706565636820726561646572732C206D61792070726573656E742074686973206465736372697074696F6E206265666F72652074686520636F6E74656E7420697473656C662E5C6E5C6E2A2A4E6F74653A2A2A20446F206E6F742075736520746869';
wwv_flow_imp.g_varchar2_table(5702) := '7320617474726962757465206173206974206973206F62736F6C65746520696E20746865206C6174657374207374616E646172642E20416C7465726E61746976656C792C20796F752063616E207075742074686520616262726576696174656420646573';
wwv_flow_imp.g_varchar2_table(5703) := '6372697074696F6E20696E73696465207468652063656C6C20616E6420706C61636520746865206C6F6E6720636F6E74656E7420696E20746865202A2A7469746C652A2A206174747269627574652E227D2C7B6E616D653A22616C69676E222C64657363';
wwv_flow_imp.g_varchar2_table(5704) := '72697074696F6E3A275468697320656E756D657261746564206174747269627574652073706563696669657320686F77207468652063656C6C20636F6E74656E745C277320686F72697A6F6E74616C20616C69676E6D656E742077696C6C206265206861';
wwv_flow_imp.g_varchar2_table(5705) := '6E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606C656674603A2054686520636F6E74656E7420697320616C69676E656420746F20746865206C656674206F66207468652063656C6C2E5C6E2A2020206063656E';
wwv_flow_imp.g_varchar2_table(5706) := '746572603A2054686520636F6E74656E742069732063656E746572656420696E207468652063656C6C2E5C6E2A202020607269676874603A2054686520636F6E74656E7420697320616C69676E656420746F20746865207269676874206F662074686520';
wwv_flow_imp.g_varchar2_table(5707) := '63656C6C2E5C6E2A202020606A757374696679602028776974682074657874206F6E6C79293A2054686520636F6E74656E7420697320737472657463686564206F757420696E73696465207468652063656C6C20736F207468617420697420636F766572';
wwv_flow_imp.g_varchar2_table(5708) := '732069747320656E746972652077696474682E5C6E2A2020206063686172602028776974682074657874206F6E6C79293A2054686520636F6E74656E7420697320616C69676E656420746F20612063686172616374657220696E73696465207468652060';
wwv_flow_imp.g_varchar2_table(5709) := '3C74683E6020656C656D656E742077697468206D696E696D616C206F66667365742E20546869732063686172616374657220697320646566696E656420627920746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(5710) := '6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D5553';
wwv_flow_imp.g_varchar2_table(5711) := '2F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D636861726F666629206174747269627574657320556E696D706C656D656E7465642028736565205B627567C2A0323231325D2868747470733A2F2F6275677A696C6C612E6D';
wwv_flow_imp.g_varchar2_table(5712) := '6F7A696C6C612E6F72672F73686F775F6275672E6367693F69643D32323132202263686172616374657220616C69676E6D656E74206E6F7420696D706C656D656E7465642028616C69676E3D636861722C20636861726F66663D2C20746578742D616C69';
wwv_flow_imp.g_varchar2_table(5713) := '676E3A3C737472696E673E292229292E5C6E5C6E5468652064656661756C742076616C7565207768656E207468697320617474726962757465206973206E6F742073706563696669656420697320606C656674602E5C6E5C6E2A2A4E6F74653A2A2A2044';
wwv_flow_imp.g_varchar2_table(5714) := '6F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C65746520696E20746865206C6174657374207374616E646172642E5C6E5C6E2A202020546F2061636869657665207468652073616D6520656666656374';
wwv_flow_imp.g_varchar2_table(5715) := '2061732074686520606C656674602C206063656E746572602C2060726967687460206F7220606A757374696679602076616C7565732C206170706C792074686520435353205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(5716) := '722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D65';
wwv_flow_imp.g_varchar2_table(5717) := '6E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972';
wwv_flow_imp.g_varchar2_table(5718) := '656374696F6E2E22292070726F706572747920746F2074686520656C656D656E742E5C6E2A202020546F2061636869657665207468652073616D652065666665637420617320746865206063686172602076616C75652C206769766520746865205B6074';
wwv_flow_imp.g_varchar2_table(5719) := '6578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F7065727479';
wwv_flow_imp.g_varchar2_table(5720) := '20736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69';
wwv_flow_imp.g_varchar2_table(5721) := '676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F7065727479207468652073616D652076616C756520796F7520776F756C642075736520666F7220746865205B6063686172605D2868747470733A2F';
wwv_flow_imp.g_varchar2_table(5722) := '2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746423617474722D63686172292E20556E696D706C656D656E74656420696E20435353332E277D2C7B6E616D653A226178';
wwv_flow_imp.g_varchar2_table(5723) := '6973222C6465736372697074696F6E3A22546869732061747472696275746520636F6E7461696E732061206C697374206F662073706163652D73657061726174656420737472696E67732E204561636820737472696E6720697320746865206069646020';
wwv_flow_imp.g_varchar2_table(5724) := '6F6620612067726F7570206F662063656C6C732074686174207468697320686561646572206170706C69657320746F2E5C6E5C6E2A2A4E6F74653A2A2A20446F206E6F7420757365207468697320617474726962757465206173206974206973206F6273';
wwv_flow_imp.g_varchar2_table(5725) := '6F6C65746520696E20746865206C6174657374207374616E646172642E227D2C7B6E616D653A226267636F6C6F72222C6465736372697074696F6E3A27546869732061747472696275746520646566696E657320746865206261636B67726F756E642063';
wwv_flow_imp.g_varchar2_table(5726) := '6F6C6F72206F6620656163682063656C6C20696E206120636F6C756D6E2E20497420636F6E7369737473206F66206120362D64696769742068657861646563696D616C20636F646520617320646566696E656420696E205B735247425D2868747470733A';
wwv_flow_imp.g_varchar2_table(5727) := '2F2F7777772E77332E6F72672F47726170686963732F436F6C6F722F735247422920616E64206973207072656669786564206279205C27235C272E205468697320617474726962757465206D617920626520757365642077697468206F6E65206F662073';
wwv_flow_imp.g_varchar2_table(5728) := '69787465656E20707265646566696E656420636F6C6F7220737472696E67733A5C6E5C6EC2A05C6E5C6E60626C61636B60203D202223303030303030225C6E5C6EC2A05C6E5C6E60677265656E60203D202223303038303030225C6E5C6EC2A05C6E5C6E';
wwv_flow_imp.g_varchar2_table(5729) := '6073696C76657260203D202223433043304330225C6E5C6EC2A05C6E5C6E606C696D6560203D202223303046463030225C6E5C6EC2A05C6E5C6E606772617960203D202223383038303830225C6E5C6EC2A05C6E5C6E606F6C69766560203D2022233830';
wwv_flow_imp.g_varchar2_table(5730) := '38303030225C6E5C6EC2A05C6E5C6E60776869746560203D202223464646464646225C6E5C6EC2A05C6E5C6E6079656C6C6F7760203D202223464646463030225C6E5C6EC2A05C6E5C6E606D61726F6F6E60203D202223383030303030225C6E5C6EC2A0';
wwv_flow_imp.g_varchar2_table(5731) := '5C6E5C6E606E61767960203D202223303030303830225C6E5C6EC2A05C6E5C6E6072656460203D202223464630303030225C6E5C6EC2A05C6E5C6E60626C756560203D202223303030304646225C6E5C6EC2A05C6E5C6E60707572706C6560203D202223';
wwv_flow_imp.g_varchar2_table(5732) := '383030303830225C6E5C6EC2A05C6E5C6E607465616C60203D202223303038303830225C6E5C6EC2A05C6E5C6E606675636873696160203D202223464630304646225C6E5C6EC2A05C6E5C6E606171756160203D202223303046464646225C6E5C6E2A2A';
wwv_flow_imp.g_varchar2_table(5733) := '4E6F74653A2A2A20446F206E6F74207573652074686973206174747269627574652C206173206974206973206E6F6E2D7374616E6461726420616E64206F6E6C7920696D706C656D656E74656420696E20736F6D652076657273696F6E73206F66204D69';
wwv_flow_imp.g_varchar2_table(5734) := '63726F736F667420496E7465726E6574204578706C6F7265723A20546865205B603C74643E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7464';
wwv_flow_imp.g_varchar2_table(5735) := '20225468652048544D4C203C74643E20656C656D656E7420646566696E657320612063656C6C206F662061207461626C65207468617420636F6E7461696E7320646174612E2049742070617274696369706174657320696E20746865207461626C65206D';
wwv_flow_imp.g_varchar2_table(5736) := '6F64656C2E222920656C656D656E742073686F756C64206265207374796C6564207573696E67205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F435353292E20546F206372656174';
wwv_flow_imp.g_varchar2_table(5737) := '6520612073696D696C6172206566666563742075736520746865205B606261636B67726F756E642D636F6C6F72605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F626163';
wwv_flow_imp.g_varchar2_table(5738) := '6B67726F756E642D636F6C6F722022546865206261636B67726F756E642D636F6C6F72204353532070726F7065727479207365747320746865206261636B67726F756E6420636F6C6F72206F6620616E20656C656D656E742E22292070726F7065727479';
wwv_flow_imp.g_varchar2_table(5739) := '20696E205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F4353532920696E73746561642E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365';
wwv_flow_imp.g_varchar2_table(5740) := '222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7464227D5D7D2C7B6E616D653A227468222C6465736372697074696F6E3A7B6B696E643A226D61726B';
wwv_flow_imp.g_varchar2_table(5741) := '646F776E222C76616C75653A2254686520746820656C656D656E7420726570726573656E74732061206865616465722063656C6C20696E2061207461626C652E227D2C617474726962757465733A5B7B6E616D653A22636F6C7370616E227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(5742) := '653A22726F777370616E227D2C7B6E616D653A2268656164657273227D2C7B6E616D653A2273636F7065222C76616C75655365743A2273227D2C7B6E616D653A22736F72746564227D2C7B6E616D653A2261626272222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(5743) := '6B696E643A226D61726B646F776E222C76616C75653A22546869732061747472696275746520636F6E7461696E7320612073686F7274206162627265766961746564206465736372697074696F6E206F66207468652063656C6C277320636F6E74656E74';
wwv_flow_imp.g_varchar2_table(5744) := '2E20536F6D6520757365722D6167656E74732C20737563682061732073706565636820726561646572732C206D61792070726573656E742074686973206465736372697074696F6E206265666F72652074686520636F6E74656E7420697473656C662E22';
wwv_flow_imp.g_varchar2_table(5745) := '7D7D2C7B6E616D653A22616C69676E222C6465736372697074696F6E3A275468697320656E756D657261746564206174747269627574652073706563696669657320686F77207468652063656C6C20636F6E74656E745C277320686F72697A6F6E74616C';
wwv_flow_imp.g_varchar2_table(5746) := '20616C69676E6D656E742077696C6C2062652068616E646C65642E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606C656674603A2054686520636F6E74656E7420697320616C69676E656420746F20746865206C656674206F';
wwv_flow_imp.g_varchar2_table(5747) := '66207468652063656C6C2E5C6E2A2020206063656E746572603A2054686520636F6E74656E742069732063656E746572656420696E207468652063656C6C2E5C6E2A202020607269676874603A2054686520636F6E74656E7420697320616C69676E6564';
wwv_flow_imp.g_varchar2_table(5748) := '20746F20746865207269676874206F66207468652063656C6C2E5C6E2A202020606A757374696679602028776974682074657874206F6E6C79293A2054686520636F6E74656E7420697320737472657463686564206F757420696E736964652074686520';
wwv_flow_imp.g_varchar2_table(5749) := '63656C6C20736F207468617420697420636F766572732069747320656E746972652077696474682E5C6E2A2020206063686172602028776974682074657874206F6E6C79293A2054686520636F6E74656E7420697320616C69676E656420746F20612063';
wwv_flow_imp.g_varchar2_table(5750) := '686172616374657220696E736964652074686520603C74683E6020656C656D656E742077697468206D696E696D616C206F66667365742E20546869732063686172616374657220697320646566696E656420627920746865205B6063686172605D286874';
wwv_flow_imp.g_varchar2_table(5751) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746823617474722D636861722920616E64205B60636861726F6666605D2868747470733A2F2F646576656C6F';
wwv_flow_imp.g_varchar2_table(5752) := '7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746823617474722D636861726F66662920617474726962757465732E5C6E5C6E5468652064656661756C742076616C7565207768656E2074';
wwv_flow_imp.g_varchar2_table(5753) := '68697320617474726962757465206973206E6F742073706563696669656420697320606C656674602E5C6E5C6E2A2A4E6F74653A2A2A20446F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C6574652069';
wwv_flow_imp.g_varchar2_table(5754) := '6E20746865206C6174657374207374616E646172642E5C6E5C6E2A202020546F2061636869657665207468652073616D65206566666563742061732074686520606C656674602C206063656E746572602C2060726967687460206F7220606A7573746966';
wwv_flow_imp.g_varchar2_table(5755) := '79602076616C7565732C206170706C792074686520435353205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532F746578742D616C69676E20';
wwv_flow_imp.g_varchar2_table(5756) := '2254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E65206F72207461626C652D63656C6C20626F782E2054686973206D65616E';
wwv_flow_imp.g_varchar2_table(5757) := '7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572747920746F2074686520656C656D656E742E5C6E2A202020546F2061';
wwv_flow_imp.g_varchar2_table(5758) := '636869657665207468652073616D652065666665637420617320746865206063686172602076616C75652C206769766520746865205B60746578742D616C69676E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E';
wwv_flow_imp.g_varchar2_table(5759) := '2D55532F646F63732F5765622F4353532F746578742D616C69676E202254686520746578742D616C69676E204353532070726F706572747920736574732074686520686F72697A6F6E74616C20616C69676E6D656E74206F6620616E20696E6C696E6520';
wwv_flow_imp.g_varchar2_table(5760) := '6F72207461626C652D63656C6C20626F782E2054686973206D65616E7320697420776F726B73206C696B6520766572746963616C2D616C69676E2062757420696E2074686520686F72697A6F6E74616C20646972656374696F6E2E22292070726F706572';
wwv_flow_imp.g_varchar2_table(5761) := '7479207468652073616D652076616C756520796F7520776F756C642075736520666F7220746865205B6063686172605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F45';
wwv_flow_imp.g_varchar2_table(5762) := '6C656D656E742F746823617474722D63686172292E20556E696D706C656D656E74656420696E20435353332E277D2C7B6E616D653A2261786973222C6465736372697074696F6E3A22546869732061747472696275746520636F6E7461696E732061206C';
wwv_flow_imp.g_varchar2_table(5763) := '697374206F662073706163652D73657061726174656420737472696E67732E204561636820737472696E67206973207468652060696460206F6620612067726F7570206F662063656C6C732074686174207468697320686561646572206170706C696573';
wwv_flow_imp.g_varchar2_table(5764) := '20746F2E5C6E5C6E2A2A4E6F74653A2A2A20446F206E6F7420757365207468697320617474726962757465206173206974206973206F62736F6C65746520696E20746865206C6174657374207374616E646172643A2075736520746865205B6073636F70';
wwv_flow_imp.g_varchar2_table(5765) := '65605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746823617474722D73636F7065292061747472696275746520696E73746561642E227D2C7B6E';
wwv_flow_imp.g_varchar2_table(5766) := '616D653A226267636F6C6F72222C6465736372697074696F6E3A27546869732061747472696275746520646566696E657320746865206261636B67726F756E6420636F6C6F72206F6620656163682063656C6C20696E206120636F6C756D6E2E20497420';
wwv_flow_imp.g_varchar2_table(5767) := '636F6E7369737473206F66206120362D64696769742068657861646563696D616C20636F646520617320646566696E656420696E205B735247425D2868747470733A2F2F7777772E77332E6F72672F47726170686963732F436F6C6F722F735247422920';
wwv_flow_imp.g_varchar2_table(5768) := '616E64206973207072656669786564206279205C27235C272E205468697320617474726962757465206D617920626520757365642077697468206F6E65206F66207369787465656E20707265646566696E656420636F6C6F7220737472696E67733A5C6E';
wwv_flow_imp.g_varchar2_table(5769) := '5C6EC2A05C6E5C6E60626C61636B60203D202223303030303030225C6E5C6EC2A05C6E5C6E60677265656E60203D202223303038303030225C6E5C6EC2A05C6E5C6E6073696C76657260203D202223433043304330225C6E5C6EC2A05C6E5C6E606C696D';
wwv_flow_imp.g_varchar2_table(5770) := '6560203D202223303046463030225C6E5C6EC2A05C6E5C6E606772617960203D202223383038303830225C6E5C6EC2A05C6E5C6E606F6C69766560203D202223383038303030225C6E5C6EC2A05C6E5C6E60776869746560203D20222346464646464622';
wwv_flow_imp.g_varchar2_table(5771) := '5C6E5C6EC2A05C6E5C6E6079656C6C6F7760203D202223464646463030225C6E5C6EC2A05C6E5C6E606D61726F6F6E60203D202223383030303030225C6E5C6EC2A05C6E5C6E606E61767960203D202223303030303830225C6E5C6EC2A05C6E5C6E6072';
wwv_flow_imp.g_varchar2_table(5772) := '656460203D202223464630303030225C6E5C6EC2A05C6E5C6E60626C756560203D202223303030304646225C6E5C6EC2A05C6E5C6E60707572706C6560203D202223383030303830225C6E5C6EC2A05C6E5C6E607465616C60203D202223303038303830';
wwv_flow_imp.g_varchar2_table(5773) := '225C6E5C6EC2A05C6E5C6E606675636873696160203D202223464630304646225C6E5C6EC2A05C6E5C6E606171756160203D202223303046464646225C6E5C6E2A2A4E6F74653A2A2A20446F206E6F74207573652074686973206174747269627574652C';
wwv_flow_imp.g_varchar2_table(5774) := '206173206974206973206E6F6E2D7374616E6461726420616E64206F6E6C7920696D706C656D656E74656420696E20736F6D652076657273696F6E73206F66204D6963726F736F667420496E7465726E6574204578706C6F7265723A20546865205B603C';
wwv_flow_imp.g_varchar2_table(5775) := '74683E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F746820225468652048544D4C203C74683E20656C656D656E7420646566696E6573206120';
wwv_flow_imp.g_varchar2_table(5776) := '63656C6C20617320686561646572206F6620612067726F7570206F66207461626C652063656C6C732E20546865206578616374206E6174757265206F6620746869732067726F757020697320646566696E6564206279207468652073636F706520616E64';
wwv_flow_imp.g_varchar2_table(5777) := '206865616465727320617474726962757465732E222920656C656D656E742073686F756C64206265207374796C6564207573696E67205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F6373';
wwv_flow_imp.g_varchar2_table(5778) := '2F5765622F435353292E20546F2063726561746520612073696D696C6172206566666563742075736520746865205B606261636B67726F756E642D636F6C6F72605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D';
wwv_flow_imp.g_varchar2_table(5779) := '55532F646F63732F5765622F4353532F6261636B67726F756E642D636F6C6F722022546865206261636B67726F756E642D636F6C6F72204353532070726F7065727479207365747320746865206261636B67726F756E6420636F6C6F72206F6620616E20';
wwv_flow_imp.g_varchar2_table(5780) := '656C656D656E742E22292070726F706572747920696E205B4353535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4353532920696E73746561642E277D5D2C7265666572656E6365';
wwv_flow_imp.g_varchar2_table(5781) := '733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7468227D5D7D2C7B6E616D653A22666F726D';
wwv_flow_imp.g_varchar2_table(5782) := '222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520666F726D20656C656D656E7420726570726573656E7473206120636F6C6C656374696F6E206F6620666F726D2D6173736F63696174656420656C';
wwv_flow_imp.g_varchar2_table(5783) := '656D656E74732C20736F6D65206F662077686963682063616E20726570726573656E74206564697461626C652076616C75657320746861742063616E206265207375626D697474656420746F20612073657276657220666F722070726F63657373696E67';
wwv_flow_imp.g_varchar2_table(5784) := '2E227D2C617474726962757465733A5B7B6E616D653A226163636570742D63686172736574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27412073706163652D206F7220636F6D6D612D64656C696D6974';
wwv_flow_imp.g_varchar2_table(5785) := '6564206C697374206F662063686172616374657220656E636F64696E67732074686174207468652073657276657220616363657074732E205468652062726F777365722075736573207468656D20696E20746865206F7264657220696E20776869636820';
wwv_flow_imp.g_varchar2_table(5786) := '7468657920617265206C69737465642E205468652064656661756C742076616C75652C2074686520726573657276656420737472696E67206022554E4B4E4F574E22602C20696E64696361746573207468652073616D6520656E636F64696E6720617320';
wwv_flow_imp.g_varchar2_table(5787) := '74686174206F662074686520646F63756D656E7420636F6E7461696E696E672074686520666F726D20656C656D656E742E20205C6E496E2070726576696F75732076657273696F6E73206F662048544D4C2C2074686520646966666572656E7420636861';
wwv_flow_imp.g_varchar2_table(5788) := '72616374657220656E636F64696E677320636F756C642062652064656C696D6974656420627920737061636573206F7220636F6D6D61732E20496E2048544D4C352C206F6E6C79207370616365732061726520616C6C6F7765642061732064656C696D69';
wwv_flow_imp.g_varchar2_table(5789) := '746572732E277D7D2C7B6E616D653A22616374696F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686520555249206F6620612070726F6772616D20746861742070726F6365737365732074686520';
wwv_flow_imp.g_varchar2_table(5790) := '666F726D20696E666F726D6174696F6E2E20546869732076616C75652063616E206265206F76657272696464656E2062792061205B60666F726D616374696F6E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D';
wwv_flow_imp.g_varchar2_table(5791) := '55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E23617474722D666F726D616374696F6E2920617474726962757465206F6E2061205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(5792) := '6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C20';
wwv_flow_imp.g_varchar2_table(5793) := '77686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974';
wwv_flow_imp.g_varchar2_table(5794) := '792E2229206F72205B603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E707574';
wwv_flow_imp.g_varchar2_table(5795) := '3E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D207468';
wwv_flow_imp.g_varchar2_table(5796) := '6520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E20746865206465';
wwv_flow_imp.g_varchar2_table(5797) := '7669636520616E642075736572206167656E742E222920656C656D656E742E277D7D2C7B6E616D653A226175746F636F6D706C657465222C76616C75655365743A226F222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C7661';
wwv_flow_imp.g_varchar2_table(5798) := '6C75653A22496E64696361746573207768657468657220696E70757420656C656D656E74732063616E2062792064656661756C7420686176652074686569722076616C756573206175746F6D61746963616C6C7920636F6D706C65746564206279207468';
wwv_flow_imp.g_varchar2_table(5799) := '652062726F777365722E20546869732073657474696E672063616E206265206F76657272696464656E20627920616E20606175746F636F6D706C6574656020617474726962757465206F6E20616E20656C656D656E742062656C6F6E67696E6720746F20';
wwv_flow_imp.g_varchar2_table(5800) := '74686520666F726D2E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606F6666603A205468652075736572206D757374206578706C696369746C7920656E74657220612076616C756520696E746F2065616368206669656C6420';
wwv_flow_imp.g_varchar2_table(5801) := '666F72206576657279207573652C206F722074686520646F63756D656E742070726F766964657320697473206F776E206175746F2D636F6D706C6574696F6E206D6574686F643B207468652062726F7773657220646F6573206E6F74206175746F6D6174';
wwv_flow_imp.g_varchar2_table(5802) := '6963616C6C7920636F6D706C65746520656E74726965732E5C6E2A202020606F6E603A205468652062726F777365722063616E206175746F6D61746963616C6C7920636F6D706C6574652076616C756573206261736564206F6E2076616C756573207468';
wwv_flow_imp.g_varchar2_table(5803) := '6174207468652075736572206861732070726576696F75736C7920656E746572656420696E2074686520666F726D2E5C6E5C6E466F72206D6F7374206D6F6465726E2062726F77736572732028696E636C7564696E672046697265666F782033382B2C20';
wwv_flow_imp.g_varchar2_table(5804) := '476F6F676C65204368726F6D652033342B2C2049452031312B292073657474696E6720746865206175746F636F6D706C657465206174747269627574652077696C6C206E6F742070726576656E7420612062726F7773657227732070617373776F726420';
wwv_flow_imp.g_varchar2_table(5805) := '6D616E616765722066726F6D2061736B696E6720746865207573657220696620746865792077616E7420746F2073746F7265206C6F67696E206669656C64732028757365726E616D6520616E642070617373776F7264292C206966207468652075736572';
wwv_flow_imp.g_varchar2_table(5806) := '207065726D697473207468652073746F72616765207468652062726F777365722077696C6C206175746F66696C6C20746865206C6F67696E20746865206E6578742074696D65207468652075736572207669736974732074686520706167652E20536565';
wwv_flow_imp.g_varchar2_table(5807) := '205B546865206175746F636F6D706C6574652061747472696275746520616E64206C6F67696E206669656C64735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F5365637572697479';
wwv_flow_imp.g_varchar2_table(5808) := '2F5365637572696E675F796F75725F736974652F5475726E696E675F6F66665F666F726D5F6175746F636F6D706C6574696F6E235468655F6175746F636F6D706C6574655F6174747269627574655F616E645F6C6F67696E5F6669656C6473292E227D7D';
wwv_flow_imp.g_varchar2_table(5809) := '2C7B6E616D653A22656E6374797065222C76616C75655365743A226574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275768656E207468652076616C7565206F662074686520606D6574686F6460206174';
wwv_flow_imp.g_varchar2_table(5810) := '747269627574652069732060706F7374602C20656E637479706520697320746865205B4D494D4520747970655D2868747470733A2F2F656E2E77696B6970656469612E6F72672F77696B692F4D696D655F7479706529206F6620636F6E74656E74207468';
wwv_flow_imp.g_varchar2_table(5811) := '6174206973207573656420746F207375626D69742074686520666F726D20746F20746865207365727665722E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606170706C69636174696F6E2F782D7777772D666F726D2D75726C';
wwv_flow_imp.g_varchar2_table(5812) := '656E636F646564603A205468652064656661756C742076616C75652069662074686520617474726962757465206973206E6F74207370656369666965642E5C6E2A202020606D756C7469706172742F666F726D2D64617461603A205468652076616C7565';
wwv_flow_imp.g_varchar2_table(5813) := '207573656420666F7220616E205B603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C';
wwv_flow_imp.g_varchar2_table(5814) := '696E7075743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F206163636570742064617461206672';
wwv_flow_imp.g_varchar2_table(5815) := '6F6D2074686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E2074';
wwv_flow_imp.g_varchar2_table(5816) := '68652064657669636520616E642075736572206167656E742E222920656C656D656E7420776974682074686520607479706560206174747269627574652073657420746F202266696C65222E5C6E2A20202060746578742F706C61696E603A202848544D';
wwv_flow_imp.g_varchar2_table(5817) := '4C35295C6E5C6E546869732076616C75652063616E206265206F76657272696464656E2062792061205B60666F726D656E6374797065605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(5818) := '622F48544D4C2F456C656D656E742F627574746F6E23617474722D666F726D656E63747970652920617474726962757465206F6E2061205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E';
wwv_flow_imp.g_varchar2_table(5819) := '2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C2077686963682063616E';
wwv_flow_imp.g_varchar2_table(5820) := '206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974792E2229206F72205B';
wwv_flow_imp.g_varchar2_table(5821) := '603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E7075743E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(5822) := '206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D2074686520757365723B2061';
wwv_flow_imp.g_varchar2_table(5823) := '20776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E207468652064657669636520616E6420';
wwv_flow_imp.g_varchar2_table(5824) := '75736572206167656E742E222920656C656D656E742E277D7D2C7B6E616D653A226D6574686F64222C76616C75655365743A226D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546865205B485454505D';
wwv_flow_imp.g_varchar2_table(5825) := '2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4854545029206D6574686F642074686174207468652062726F77736572207573657320746F207375626D69742074686520666F726D2E';
wwv_flow_imp.g_varchar2_table(5826) := '20506F737369626C652076616C756573206172653A5C6E5C6E2A20202060706F7374603A20436F72726573706F6E647320746F207468652048545450205B504F5354206D6574686F645D2868747470733A2F2F7777772E77332E6F72672F50726F746F63';
wwv_flow_imp.g_varchar2_table(5827) := '6F6C732F726663323631362F726663323631362D736563392E68746D6C23736563392E3529203B20666F726D20646174612061726520696E636C7564656420696E2074686520626F6479206F662074686520666F726D20616E642073656E7420746F2074';
wwv_flow_imp.g_varchar2_table(5828) := '6865207365727665722E5C6E2A20202060676574603A20436F72726573706F6E647320746F207468652048545450205B474554206D6574686F645D2868747470733A2F2F7777772E77332E6F72672F50726F746F636F6C732F726663323631362F726663';
wwv_flow_imp.g_varchar2_table(5829) := '323631362D736563392E68746D6C23736563392E33293B20666F726D20646174612061726520617070656E64656420746F207468652060616374696F6E60206174747269627574652055524920776974682061205C273F5C272061732073657061726174';
wwv_flow_imp.g_varchar2_table(5830) := '6F722C20616E642074686520726573756C74696E67205552492069732073656E7420746F20746865207365727665722E205573652074686973206D6574686F64207768656E2074686520666F726D20686173206E6F20736964652D656666656374732061';
wwv_flow_imp.g_varchar2_table(5831) := '6E6420636F6E7461696E73206F6E6C7920415343494920636861726163746572732E5C6E2A202020606469616C6F67603A20557365207768656E2074686520666F726D20697320696E736964652061C2A05B603C6469616C6F673E605D2868747470733A';
wwv_flow_imp.g_varchar2_table(5832) := '2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6469616C6F6720225468652048544D4C203C6469616C6F673E20656C656D656E7420726570726573656E747320612064';
wwv_flow_imp.g_varchar2_table(5833) := '69616C6F6720626F78206F72206F7468657220696E74657261637469766520636F6D706F6E656E742C207375636820617320616E20696E73706563746F72206F722077696E646F772E222920656C656D656E7420746F20636C6F73652074686520646961';
wwv_flow_imp.g_varchar2_table(5834) := '6C6F67207768656E207375626D69747465642E5C6E5C6E546869732076616C75652063616E206265206F76657272696464656E2062792061205B60666F726D6D6574686F64605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(5835) := '672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E23617474722D666F726D6D6574686F642920617474726962757465206F6E2061205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(5836) := '6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574';
wwv_flow_imp.g_varchar2_table(5837) := '746F6E2C2077686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F';
wwv_flow_imp.g_varchar2_table(5838) := '6E616C6974792E2229206F72205B603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C';
wwv_flow_imp.g_varchar2_table(5839) := '696E7075743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F206163636570742064617461206672';
wwv_flow_imp.g_varchar2_table(5840) := '6F6D2074686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E2074';
wwv_flow_imp.g_varchar2_table(5841) := '68652064657669636520616E642075736572206167656E742E222920656C656D656E742E277D7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206E616D65206F66';
wwv_flow_imp.g_varchar2_table(5842) := '2074686520666F726D2E20496E2048544D4C20342C206974732075736520697320646570726563617465642028606964602073686F756C64206265207573656420696E7374656164292E204974206D75737420626520756E6971756520616D6F6E672074';
wwv_flow_imp.g_varchar2_table(5843) := '686520666F726D7320696E206120646F63756D656E7420616E64206E6F74206A75737420616E20656D70747920737472696E6720696E2048544D4C20352E227D7D2C7B6E616D653A226E6F76616C6964617465222C76616C75655365743A2276222C6465';
wwv_flow_imp.g_varchar2_table(5844) := '736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320426F6F6C65616E2061747472696275746520696E6469636174657320746861742074686520666F726D206973206E6F7420746F2062652076616C696461';
wwv_flow_imp.g_varchar2_table(5845) := '746564207768656E207375626D69747465642E204966207468697320617474726962757465206973206E6F74207370656369666965642028616E64207468657265666F72652074686520666F726D2069732076616C696461746564292C20746869732064';
wwv_flow_imp.g_varchar2_table(5846) := '656661756C742073657474696E672063616E206265206F76657272696464656E2062792061205B60666F726D6E6F76616C6964617465605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(5847) := '622F48544D4C2F456C656D656E742F627574746F6E23617474722D666F726D6E6F76616C69646174652920617474726962757465206F6E2061205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F7267';
wwv_flow_imp.g_varchar2_table(5848) := '2F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C20776869636820';
wwv_flow_imp.g_varchar2_table(5849) := '63616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974792E2229206F';
wwv_flow_imp.g_varchar2_table(5850) := '72205B603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E7075743E20656C656D';
wwv_flow_imp.g_varchar2_table(5851) := '656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D207468652075736572';
wwv_flow_imp.g_varchar2_table(5852) := '3B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E20746865206465766963652061';
wwv_flow_imp.g_varchar2_table(5853) := '6E642075736572206167656E742E222920656C656D656E742062656C6F6E67696E6720746F2074686520666F726D2E277D7D2C7B6E616D653A22746172676574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C7565';
wwv_flow_imp.g_varchar2_table(5854) := '3A2741206E616D65206F72206B6579776F726420696E6469636174696E6720776865726520746F20646973706C61792074686520726573706F6E73652074686174206973207265636569766564206166746572207375626D697474696E67207468652066';
wwv_flow_imp.g_varchar2_table(5855) := '6F726D2E20496E2048544D4C20342C207468697320697320746865206E616D652F6B6579776F726420666F722061206672616D652E20496E2048544D4C352C2069742069732061206E616D652F6B6579776F726420666F722061205F62726F7773696E67';
wwv_flow_imp.g_varchar2_table(5856) := '20636F6E746578745F2028666F72206578616D706C652C207461622C2077696E646F772C206F7220696E6C696E65206672616D65292E2054686520666F6C6C6F77696E67206B6579776F7264732068617665207370656369616C206D65616E696E67733A';
wwv_flow_imp.g_varchar2_table(5857) := '5C6E5C6E2A202020605F73656C66603A204C6F61642074686520726573706F6E736520696E746F207468652073616D652048544D4C2034206672616D6520286F722048544D4C352062726F7773696E6720636F6E74657874292061732074686520637572';
wwv_flow_imp.g_varchar2_table(5858) := '72656E74206F6E652E20546869732076616C7565206973207468652064656661756C742069662074686520617474726962757465206973206E6F74207370656369666965642E5C6E2A202020605F626C616E6B603A204C6F61642074686520726573706F';
wwv_flow_imp.g_varchar2_table(5859) := '6E736520696E746F2061206E657720756E6E616D65642048544D4C20342077696E646F77206F722048544D4C352062726F7773696E6720636F6E746578742E5C6E2A202020605F706172656E74603A204C6F61642074686520726573706F6E736520696E';
wwv_flow_imp.g_varchar2_table(5860) := '746F207468652048544D4C2034206672616D6573657420706172656E74206F66207468652063757272656E74206672616D652C206F722048544D4C3520706172656E742062726F7773696E6720636F6E74657874206F66207468652063757272656E7420';
wwv_flow_imp.g_varchar2_table(5861) := '6F6E652E204966207468657265206973206E6F20706172656E742C2074686973206F7074696F6E2062656861766573207468652073616D652077617920617320605F73656C66602E5C6E2A202020605F746F70603A2048544D4C20343A204C6F61642074';
wwv_flow_imp.g_varchar2_table(5862) := '686520726573706F6E736520696E746F207468652066756C6C206F726967696E616C2077696E646F772C20616E642063616E63656C20616C6C206F74686572206672616D65732E2048544D4C353A204C6F61642074686520726573706F6E736520696E74';
wwv_flow_imp.g_varchar2_table(5863) := '6F2074686520746F702D6C6576656C2062726F7773696E6720636F6E746578742028692E652E2C207468652062726F7773696E6720636F6E74657874207468617420697320616E20616E636573746F72206F66207468652063757272656E74206F6E652C';
wwv_flow_imp.g_varchar2_table(5864) := '20616E6420686173206E6F20706172656E74292E204966207468657265206973206E6F20706172656E742C2074686973206F7074696F6E2062656861766573207468652073616D652077617920617320605F73656C66602E5C6E2A2020205F696672616D';
wwv_flow_imp.g_varchar2_table(5865) := '656E616D655F3A2054686520726573706F6E736520697320646973706C6179656420696E2061206E616D6564205B603C696672616D653E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F57';
wwv_flow_imp.g_varchar2_table(5866) := '65622F48544D4C2F456C656D656E742F696672616D6520225468652048544D4C20496E6C696E65204672616D6520656C656D656E7420283C696672616D653E2920726570726573656E74732061206E65737465642062726F7773696E6720636F6E746578';
wwv_flow_imp.g_varchar2_table(5867) := '742C20656D62656464696E6720616E6F746865722048544D4C207061676520696E746F207468652063757272656E74206F6E652E22292E5C6E5C6E48544D4C353A20546869732076616C75652063616E206265206F76657272696464656E206279206120';
wwv_flow_imp.g_varchar2_table(5868) := '5B60666F726D746172676574605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E23617474722D666F726D7461726765742920617474';
wwv_flow_imp.g_varchar2_table(5869) := '726962757465206F6E2061205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C20';
wwv_flow_imp.g_varchar2_table(5870) := '3C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C2077686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E74';
wwv_flow_imp.g_varchar2_table(5871) := '2074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974792E2229206F72205B603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E';
wwv_flow_imp.g_varchar2_table(5872) := '2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E7075743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72';
wwv_flow_imp.g_varchar2_table(5873) := '207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D2074686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F';
wwv_flow_imp.g_varchar2_table(5874) := '6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E207468652064657669636520616E642075736572206167656E742E222920656C656D656E742E277D7D2C7B6E616D653A22616363657074222C6465';
wwv_flow_imp.g_varchar2_table(5875) := '736372697074696F6E3A274120636F6D6D612D736570617261746564206C697374206F6620636F6E74656E742074797065732074686174207468652073657276657220616363657074732E5C6E5C6E2A2A5573616765206E6F74653A2A2A205468697320';
wwv_flow_imp.g_varchar2_table(5876) := '61747472696275746520686173206265656E2072656D6F76656420696E2048544D4C3520616E642073686F756C64206E6F206C6F6E67657220626520757365642E20496E73746561642C2075736520746865205B60616363657074605D2868747470733A';
wwv_flow_imp.g_varchar2_table(5877) := '2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757423617474722D6163636570742920617474726962757465206F6620746865207370656369666963205B603C';
wwv_flow_imp.g_varchar2_table(5878) := '696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E7075743E20656C656D656E742069';
wwv_flow_imp.g_varchar2_table(5879) := '73207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D2074686520757365723B20612077';
wwv_flow_imp.g_varchar2_table(5880) := '6964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E207468652064657669636520616E64207573';
wwv_flow_imp.g_varchar2_table(5881) := '6572206167656E742E222920656C656D656E742E277D2C7B6E616D653A226175746F6361706974616C697A65222C6465736372697074696F6E3A22546869732069732061206E6F6E7374616E646172642061747472696275746520757365642062792069';
wwv_flow_imp.g_varchar2_table(5882) := '4F5320536166617269204D6F62696C6520776869636820636F6E74726F6C73207768657468657220616E6420686F772074686520746578742076616C756520666F72207465787475616C20666F726D20636F6E74726F6C2064657363656E64616E747320';
wwv_flow_imp.g_varchar2_table(5883) := '73686F756C64206265206175746F6D61746963616C6C79206361706974616C697A656420617320697420697320656E74657265642F6564697465642062792074686520757365722E2049662074686520606175746F6361706974616C697A656020617474';
wwv_flow_imp.g_varchar2_table(5884) := '72696275746520697320737065636966696564206F6E20616E20696E646976696475616C20666F726D20636F6E74726F6C2064657363656E64616E742C206974207472756D70732074686520666F726D2D7769646520606175746F6361706974616C697A';
wwv_flow_imp.g_varchar2_table(5885) := '65602073657474696E672E20546865206E6F6E2D646570726563617465642076616C7565732061726520617661696C61626C6520696E20694F53203520616E64206C617465722E205468652064656661756C742076616C7565206973206073656E74656E';
wwv_flow_imp.g_varchar2_table(5886) := '636573602E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606E6F6E65603A20436F6D706C6574656C792064697361626C6573206175746F6D61746963206361706974616C697A6174696F6E5C6E2A2020206073656E74656E63';
wwv_flow_imp.g_varchar2_table(5887) := '6573603A204175746F6D61746963616C6C79206361706974616C697A6520746865206669727374206C6574746572206F662073656E74656E6365732E5C6E2A20202060776F726473603A204175746F6D61746963616C6C79206361706974616C697A6520';
wwv_flow_imp.g_varchar2_table(5888) := '746865206669727374206C6574746572206F6620776F7264732E5C6E2A2020206063686172616374657273603A204175746F6D61746963616C6C79206361706974616C697A6520616C6C20636861726163746572732E5C6E2A202020606F6E603A204465';
wwv_flow_imp.g_varchar2_table(5889) := '70726563617465642073696E636520694F5320352E5C6E2A202020606F6666603A20446570726563617465642073696E636520694F5320352E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A22';
wwv_flow_imp.g_varchar2_table(5890) := '68747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F666F726D227D5D7D2C7B6E616D653A226C6162656C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F';
wwv_flow_imp.g_varchar2_table(5891) := '776E222C76616C75653A22546865206C6162656C20656C656D656E7420726570726573656E747320612063617074696F6E20696E2061207573657220696E746572666163652E205468652063617074696F6E2063616E206265206173736F636961746564';
wwv_flow_imp.g_varchar2_table(5892) := '2077697468206120737065636966696320666F726D20636F6E74726F6C2C206B6E6F776E20617320746865206C6162656C20656C656D656E742773206C6162656C656420636F6E74726F6C2C20656974686572207573696E672074686520666F72206174';
wwv_flow_imp.g_varchar2_table(5893) := '747269627574652C206F722062792070757474696E672074686520666F726D20636F6E74726F6C20696E7369646520746865206C6162656C20656C656D656E7420697473656C662E227D2C617474726962757465733A5B7B6E616D653A22666F726D222C';
wwv_flow_imp.g_varchar2_table(5894) := '6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546865205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C';
wwv_flow_imp.g_varchar2_table(5895) := '2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261637469766520636F6E7472';
wwv_flow_imp.g_varchar2_table(5896) := '6F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E222920656C656D656E74207769746820776869636820746865206C6162656C206973206173736F6369617465642028697473205F66';
wwv_flow_imp.g_varchar2_table(5897) := '6F726D206F776E65725F292E204966207370656369666965642C207468652076616C7565206F662074686520617474726962757465206973207468652060696460206F662061205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E';
wwv_flow_imp.g_varchar2_table(5898) := '6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E20';
wwv_flow_imp.g_varchar2_table(5899) := '7468617420636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E222920656C656D656E7420696E207468652073616D65';
wwv_flow_imp.g_varchar2_table(5900) := '20646F63756D656E742E2054686973206C65747320796F7520706C616365206C6162656C20656C656D656E747320616E7977686572652077697468696E206120646F63756D656E742C206E6F74206A7573742061732064657363656E64616E7473206F66';
wwv_flow_imp.g_varchar2_table(5901) := '20746865697220666F726D20656C656D656E74732E277D7D2C7B6E616D653A22666F72222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865205B606964605D2868747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(5902) := '722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F476C6F62616C5F6174747269627574657323617474722D696429206F662061205B6C6162656C61626C655D2868747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5903) := '6C6C612E6F72672F656E2D55532F646F63732F5765622F47756964652F48544D4C2F436F6E74656E745F63617465676F7269657323466F726D5F6C6162656C61626C652920666F726D2D72656C6174656420656C656D656E7420696E207468652073616D';
wwv_flow_imp.g_varchar2_table(5904) := '6520646F63756D656E742061732074686520603C6C6162656C3E6020656C656D656E742E2054686520666972737420656C656D656E7420696E2074686520646F63756D656E74207769746820616E2060696460206D61746368696E67207468652076616C';
wwv_flow_imp.g_varchar2_table(5905) := '7565206F66207468652060666F72602061747472696275746520697320746865205F6C6162656C656420636F6E74726F6C5F20666F722074686973206C6162656C20656C656D656E742C2069662069742069732061206C6162656C61626C6520656C656D';
wwv_flow_imp.g_varchar2_table(5906) := '656E742E204966206974206973C2A06E6F74206C6162656C61626C65207468656E207468652060666F72602061747472696275746520686173206E6F206566666563742E20496620746865726520617265206F7468657220656C656D656E747320776869';
wwv_flow_imp.g_varchar2_table(5907) := '636820616C736F206D617463682074686520606964602076616C75652C206C6174657220696E2074686520646F63756D656E742C207468657920617265206E6F7420636F6E736964657265642E5C6E5C6E2A2A4E6F74652A2A3A204120603C6C6162656C';
wwv_flow_imp.g_varchar2_table(5908) := '3E6020656C656D656E742063616E206861766520626F746820612060666F72602061747472696275746520616E64206120636F6E7461696E656420636F6E74726F6C20656C656D656E742C206173206C6F6E67206173207468652060666F726020617474';
wwv_flow_imp.g_varchar2_table(5909) := '72696275746520706F696E747320746F2074686520636F6E7461696E656420636F6E74726F6C20656C656D656E742E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F64';
wwv_flow_imp.g_varchar2_table(5910) := '6576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6C6162656C227D5D7D2C7B6E616D653A22696E707574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(5911) := '653A2254686520696E70757420656C656D656E7420726570726573656E747320612074797065642064617461206669656C642C20757375616C6C792077697468206120666F726D20636F6E74726F6C20746F20616C6C6F7720746865207573657220746F';
wwv_flow_imp.g_varchar2_table(5912) := '20656469742074686520646174612E227D2C617474726962757465733A5B7B6E616D653A22616363657074227D2C7B6E616D653A22616C74227D2C7B6E616D653A226175746F636F6D706C657465222C76616C75655365743A22696E7075746175746F63';
wwv_flow_imp.g_varchar2_table(5913) := '6F6D706C657465227D2C7B6E616D653A226175746F666F637573222C76616C75655365743A2276227D2C7B6E616D653A22636865636B6564222C76616C75655365743A2276227D2C7B6E616D653A226469726E616D65227D2C7B6E616D653A2264697361';
wwv_flow_imp.g_varchar2_table(5914) := '626C6564222C76616C75655365743A2276227D2C7B6E616D653A22666F726D227D2C7B6E616D653A22666F726D616374696F6E227D2C7B6E616D653A22666F726D656E6374797065222C76616C75655365743A226574227D2C7B6E616D653A22666F726D';
wwv_flow_imp.g_varchar2_table(5915) := '6D6574686F64222C76616C75655365743A22666D227D2C7B6E616D653A22666F726D6E6F76616C6964617465222C76616C75655365743A2276227D2C7B6E616D653A22666F726D746172676574227D2C7B6E616D653A22686569676874227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(5916) := '653A22696E7075746D6F6465222C76616C75655365743A22696D227D2C7B6E616D653A226C697374227D2C7B6E616D653A226D6178227D2C7B6E616D653A226D61786C656E677468227D2C7B6E616D653A226D696E227D2C7B6E616D653A226D696E6C65';
wwv_flow_imp.g_varchar2_table(5917) := '6E677468227D2C7B6E616D653A226D756C7469706C65222C76616C75655365743A2276227D2C7B6E616D653A226E616D65227D2C7B6E616D653A227061747465726E227D2C7B6E616D653A22706C616365686F6C646572227D2C7B6E616D653A22726561';
wwv_flow_imp.g_varchar2_table(5918) := '646F6E6C79222C76616C75655365743A2276227D2C7B6E616D653A227265717569726564222C76616C75655365743A2276227D2C7B6E616D653A2273697A65227D2C7B6E616D653A22737263227D2C7B6E616D653A2273746570227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(5919) := '74797065222C76616C75655365743A2274227D2C7B6E616D653A2276616C7565227D2C7B6E616D653A227769647468227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F6465';
wwv_flow_imp.g_varchar2_table(5920) := '76656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F696E707574227D5D7D2C7B6E616D653A22627574746F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(5921) := '653A2254686520627574746F6E20656C656D656E7420726570726573656E7473206120627574746F6E206C6162656C65642062792069747320636F6E74656E74732E227D2C617474726962757465733A5B7B6E616D653A226175746F666F637573222C76';
wwv_flow_imp.g_varchar2_table(5922) := '616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E20617474726962757465206C65747320796F75207370656369667920746861742074686520627574';
wwv_flow_imp.g_varchar2_table(5923) := '746F6E2073686F756C64206861766520696E70757420666F637573207768656E207468652070616765206C6F6164732C20756E6C657373207468652075736572206F76657272696465732069742C20666F72206578616D706C6520627920747970696E67';
wwv_flow_imp.g_varchar2_table(5924) := '20696E206120646966666572656E7420636F6E74726F6C2E204F6E6C79206F6E6520666F726D2D6173736F63696174656420656C656D656E7420696E206120646F63756D656E742063616E20686176652074686973206174747269627574652073706563';
wwv_flow_imp.g_varchar2_table(5925) := '69666965642E227D7D2C7B6E616D653A2264697361626C6564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320426F6F6C65616E206174747269627574652069';
wwv_flow_imp.g_varchar2_table(5926) := '6E6469636174657320746861742074686520757365722063616E6E6F7420696E74657261637420776974682074686520627574746F6E2E204966207468697320617474726962757465206973206E6F74207370656369666965642C207468652062757474';
wwv_flow_imp.g_varchar2_table(5927) := '6F6E20696E686572697473206974732073657474696E672066726F6D2074686520636F6E7461696E696E6720656C656D656E742C20666F72206578616D706C65205B603C6669656C647365743E605D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(5928) := '7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6669656C6473657420225468652048544D4C203C6669656C647365743E20656C656D656E74206973207573656420746F2067726F7570207365766572616C';
wwv_flow_imp.g_varchar2_table(5929) := '20636F6E74726F6C732061732077656C6C206173206C6162656C7320283C6C6162656C3E292077697468696E20612077656220666F726D2E22293B206966207468657265206973206E6F20636F6E7461696E696E6720656C656D656E7420776974682074';
wwv_flow_imp.g_varchar2_table(5930) := '6865202A2A64697361626C65642A2A20617474726962757465207365742C207468656E2074686520627574746F6E20697320656E61626C65642E5C6E5C6E46697265666F782077696C6C2C20756E6C696B65206F746865722062726F77736572732C2062';
wwv_flow_imp.g_varchar2_table(5931) := '792064656661756C742C205B70657273697374207468652064796E616D69632064697361626C65642073746174655D2868747470733A2F2F737461636B6F766572666C6F772E636F6D2F7175657374696F6E732F353938353833392F6275672D77697468';
wwv_flow_imp.g_varchar2_table(5932) := '2D66697265666F782D64697361626C65642D6174747269627574652D6F662D696E7075742D6E6F742D726573657474696E672D7768656E2D72656672657368696E6729206F662061205B603C627574746F6E3E605D2868747470733A2F2F646576656C6F';
wwv_flow_imp.g_varchar2_table(5933) := '7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120636C69636B61626C65';
wwv_flow_imp.g_varchar2_table(5934) := '20627574746F6E2C2077686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E6461726420627574746F6E2066756E';
wwv_flow_imp.g_varchar2_table(5935) := '6374696F6E616C6974792E2229206163726F73732070616765206C6F6164732E2055736520746865205B606175746F636F6D706C657465605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F57';
wwv_flow_imp.g_varchar2_table(5936) := '65622F48544D4C2F456C656D656E742F627574746F6E23617474722D6175746F636F6D706C657465292061747472696275746520746F20636F6E74726F6C207468697320666561747572652E277D7D2C7B6E616D653A22666F726D222C64657363726970';
wwv_flow_imp.g_varchar2_table(5937) := '74696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686520666F726D20656C656D656E7420746861742074686520627574746F6E206973206173736F63696174656420776974682028697473205F666F726D206F776E65725F292E';
wwv_flow_imp.g_varchar2_table(5938) := '205468652076616C7565206F662074686520617474726962757465206D75737420626520746865202A2A69642A2A20617474726962757465206F662061205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F';
wwv_flow_imp.g_varchar2_table(5939) := '72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E74';
wwv_flow_imp.g_varchar2_table(5940) := '61696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E222920656C656D656E7420696E207468652073616D6520646F63756D656E74';
wwv_flow_imp.g_varchar2_table(5941) := '2E204966207468697320617474726962757465206973206E6F74207370656369666965642C2074686520603C627574746F6E3E6020656C656D656E742077696C6C206265206173736F63696174656420746F20616E20616E636573746F72205B603C666F';
wwv_flow_imp.g_varchar2_table(5942) := '726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573';
wwv_flow_imp.g_varchar2_table(5943) := '656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665';
wwv_flow_imp.g_varchar2_table(5944) := '722E222920656C656D656E742C206966206F6E65206578697374732E20546869732061747472696275746520656E61626C657320796F7520746F206173736F636961746520603C627574746F6E3E6020656C656D656E747320746F205B603C666F726D3E';
wwv_flow_imp.g_varchar2_table(5945) := '605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E74';
wwv_flow_imp.g_varchar2_table(5946) := '73206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E22';
wwv_flow_imp.g_varchar2_table(5947) := '2920656C656D656E747320616E7977686572652077697468696E206120646F63756D656E742C206E6F74206A7573742061732064657363656E64616E7473206F66205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C';
wwv_flow_imp.g_varchar2_table(5948) := '6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420';
wwv_flow_imp.g_varchar2_table(5949) := '636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E222920656C656D656E74732E277D7D2C7B6E616D653A22666F726D';
wwv_flow_imp.g_varchar2_table(5950) := '616374696F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520555249206F6620612070726F6772616D20746861742070726F6365737365732074686520696E666F726D6174696F6E207375626D';
wwv_flow_imp.g_varchar2_table(5951) := '69747465642062792074686520627574746F6E2E204966207370656369666965642C206974206F766572726964657320746865205B60616374696F6E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F64';
wwv_flow_imp.g_varchar2_table(5952) := '6F63732F5765622F48544D4C2F456C656D656E742F666F726D23617474722D616374696F6E2920617474726962757465206F662074686520627574746F6E277320666F726D206F776E65722E227D7D2C7B6E616D653A22666F726D656E6374797065222C';
wwv_flow_imp.g_varchar2_table(5953) := '76616C75655365743A226574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2749662074686520627574746F6E2069732061207375626D697420627574746F6E2C2074686973206174747269627574652073';
wwv_flow_imp.g_varchar2_table(5954) := '7065636966696573207468652074797065206F6620636F6E74656E742074686174206973207573656420746F207375626D69742074686520666F726D20746F20746865207365727665722E20506F737369626C652076616C756573206172653A5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5955) := '2A202020606170706C69636174696F6E2F782D7777772D666F726D2D75726C656E636F646564603A205468652064656661756C742076616C75652069662074686520617474726962757465206973206E6F74207370656369666965642E5C6E2A20202060';
wwv_flow_imp.g_varchar2_table(5956) := '6D756C7469706172742F666F726D2D64617461603A2055736520746869732076616C756520696620796F7520617265207573696E6720616E205B603C696E7075743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(5957) := '6E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E7075743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F';
wwv_flow_imp.g_varchar2_table(5958) := '72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D2074686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E642063';
wwv_flow_imp.g_varchar2_table(5959) := '6F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E207468652064657669636520616E642075736572206167656E742E222920656C656D656E74207769746820746865205B6074797065605D286874';
wwv_flow_imp.g_varchar2_table(5960) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757423617474722D7479706529206174747269627574652073657420746F206066696C65602E5C6E2A';
wwv_flow_imp.g_varchar2_table(5961) := '20202060746578742F706C61696E605C6E5C6E4966207468697320617474726962757465206973207370656369666965642C206974206F766572726964657320746865205B60656E6374797065605D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(5962) := '7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D23617474722D656E63747970652920617474726962757465206F662074686520627574746F6E5C277320666F726D206F776E65722E277D7D2C7B';
wwv_flow_imp.g_varchar2_table(5963) := '6E616D653A22666F726D6D6574686F64222C76616C75655365743A22666D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2249662074686520627574746F6E2069732061207375626D697420627574746F6E';
wwv_flow_imp.g_varchar2_table(5964) := '2C20746869732061747472696275746520737065636966696573207468652048545450206D6574686F642074686174207468652062726F77736572207573657320746F207375626D69742074686520666F726D2E20506F737369626C652076616C756573';
wwv_flow_imp.g_varchar2_table(5965) := '206172653A5C6E5C6E2A20202060706F7374603A2054686520646174612066726F6D2074686520666F726D2061726520696E636C7564656420696E2074686520626F6479206F662074686520666F726D20616E642073656E7420746F2074686520736572';
wwv_flow_imp.g_varchar2_table(5966) := '7665722E5C6E2A20202060676574603A2054686520646174612066726F6D2074686520666F726D2061726520617070656E64656420746F20746865202A2A666F726D2A2A20617474726962757465205552492C2077697468206120273F27206173206120';
wwv_flow_imp.g_varchar2_table(5967) := '736570617261746F722C20616E642074686520726573756C74696E67205552492069732073656E7420746F20746865207365727665722E205573652074686973206D6574686F64207768656E2074686520666F726D20686173206E6F20736964652D6566';
wwv_flow_imp.g_varchar2_table(5968) := '666563747320616E6420636F6E7461696E73206F6E6C7920415343494920636861726163746572732E5C6E5C6E4966207370656369666965642C207468697320617474726962757465206F766572726964657320746865205B606D6574686F64605D2868';
wwv_flow_imp.g_varchar2_table(5969) := '747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D23617474722D6D6574686F642920617474726962757465206F662074686520627574746F6E2773';
wwv_flow_imp.g_varchar2_table(5970) := '20666F726D206F776E65722E227D7D2C7B6E616D653A22666F726D6E6F76616C6964617465222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2249662074686520627574746F';
wwv_flow_imp.g_varchar2_table(5971) := '6E2069732061207375626D697420627574746F6E2C207468697320426F6F6C65616E206174747269627574652073706563696669657320746861742074686520666F726D206973206E6F7420746F2062652076616C696461746564207768656E20697420';
wwv_flow_imp.g_varchar2_table(5972) := '6973207375626D69747465642E204966207468697320617474726962757465206973207370656369666965642C206974206F766572726964657320746865205B606E6F76616C6964617465605D2868747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(5973) := '6C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D23617474722D6E6F76616C69646174652920617474726962757465206F662074686520627574746F6E277320666F726D206F776E65722E227D7D2C7B';
wwv_flow_imp.g_varchar2_table(5974) := '6E616D653A22666F726D746172676574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2249662074686520627574746F6E2069732061207375626D697420627574746F6E2C20746869732061747472696275';
wwv_flow_imp.g_varchar2_table(5975) := '74652069732061206E616D65206F72206B6579776F726420696E6469636174696E6720776865726520746F20646973706C61792074686520726573706F6E73652074686174206973207265636569766564206166746572207375626D697474696E672074';
wwv_flow_imp.g_varchar2_table(5976) := '686520666F726D2E20546869732069732061206E616D65206F662C206F72206B6579776F726420666F722C2061205F62726F7773696E6720636F6E746578745F2028666F72206578616D706C652C207461622C2077696E646F772C206F7220696E6C696E';
wwv_flow_imp.g_varchar2_table(5977) := '65206672616D65292E204966207468697320617474726962757465206973207370656369666965642C206974206F766572726964657320746865205B60746172676574605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F';
wwv_flow_imp.g_varchar2_table(5978) := '656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D23617474722D7461726765742920617474726962757465206F662074686520627574746F6E277320666F726D206F776E65722E2054686520666F6C6C6F77696E67206B65';
wwv_flow_imp.g_varchar2_table(5979) := '79776F7264732068617665207370656369616C206D65616E696E67733A5C6E5C6E2A202020605F73656C66603A204C6F61642074686520726573706F6E736520696E746F207468652073616D652062726F7773696E6720636F6E74657874206173207468';
wwv_flow_imp.g_varchar2_table(5980) := '652063757272656E74206F6E652E20546869732076616C7565206973207468652064656661756C742069662074686520617474726962757465206973206E6F74207370656369666965642E5C6E2A202020605F626C616E6B603A204C6F61642074686520';
wwv_flow_imp.g_varchar2_table(5981) := '726573706F6E736520696E746F2061206E657720756E6E616D65642062726F7773696E6720636F6E746578742E5C6E2A202020605F706172656E74603A204C6F61642074686520726573706F6E736520696E746F2074686520706172656E742062726F77';
wwv_flow_imp.g_varchar2_table(5982) := '73696E6720636F6E74657874206F66207468652063757272656E74206F6E652E204966207468657265206973206E6F20706172656E742C2074686973206F7074696F6E2062656861766573207468652073616D652077617920617320605F73656C66602E';
wwv_flow_imp.g_varchar2_table(5983) := '5C6E2A202020605F746F70603A204C6F61642074686520726573706F6E736520696E746F2074686520746F702D6C6576656C2062726F7773696E6720636F6E746578742028746861742069732C207468652062726F7773696E6720636F6E746578742074';
wwv_flow_imp.g_varchar2_table(5984) := '68617420697320616E20616E636573746F72206F66207468652063757272656E74206F6E652C20616E6420686173206E6F20706172656E74292E204966207468657265206973206E6F20706172656E742C2074686973206F7074696F6E20626568617665';
wwv_flow_imp.g_varchar2_table(5985) := '73207468652073616D652077617920617320605F73656C66602E227D7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206E616D65206F662074686520627574746F';
wwv_flow_imp.g_varchar2_table(5986) := '6E2C207768696368206973207375626D697474656420776974682074686520666F726D20646174612E227D7D2C7B6E616D653A2274797065222C76616C75655365743A226274222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(5987) := '2C76616C75653A225468652074797065206F662074686520627574746F6E2E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020607375626D6974603A2054686520627574746F6E207375626D6974732074686520666F726D206461';
wwv_flow_imp.g_varchar2_table(5988) := '746120746F20746865207365727665722E2054686973206973207468652064656661756C742069662074686520617474726962757465206973206E6F74207370656369666965642C206F7220696620746865206174747269627574652069732064796E61';
wwv_flow_imp.g_varchar2_table(5989) := '6D6963616C6C79206368616E67656420746F20616E20656D707479206F7220696E76616C69642076616C75652E5C6E2A202020607265736574603A2054686520627574746F6E2072657365747320616C6C2074686520636F6E74726F6C7320746F207468';
wwv_flow_imp.g_varchar2_table(5990) := '65697220696E697469616C2076616C7565732E5C6E2A20202060627574746F6E603A2054686520627574746F6E20686173206E6F2064656661756C74206265686176696F722E2049742063616E206861766520636C69656E742D73696465207363726970';
wwv_flow_imp.g_varchar2_table(5991) := '7473206173736F63696174656420776974682074686520656C656D656E742773206576656E74732C2077686963682061726520747269676765726564207768656E20746865206576656E7473206F636375722E227D7D2C7B6E616D653A2276616C756522';
wwv_flow_imp.g_varchar2_table(5992) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520696E697469616C2076616C7565206F662074686520627574746F6E2E20497420646566696E6573207468652076616C7565206173736F6369617465';
wwv_flow_imp.g_varchar2_table(5993) := '6420776974682074686520627574746F6E207768696368206973207375626D697474656420776974682074686520666F726D20646174612E20546869732076616C75652069732070617373656420746F207468652073657276657220696E20706172616D';
wwv_flow_imp.g_varchar2_table(5994) := '73207768656E2074686520666F726D206973207375626D69747465642E227D7D2C7B6E616D653A226175746F636F6D706C657465222C6465736372697074696F6E3A2754686520757365206F66207468697320617474726962757465206F6E2061205B60';
wwv_flow_imp.g_varchar2_table(5995) := '3C627574746F6E3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D65';
wwv_flow_imp.g_varchar2_table(5996) := '6E7420726570726573656E7473206120636C69636B61626C6520627574746F6E2C2077686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E65656473207369';
wwv_flow_imp.g_varchar2_table(5997) := '6D706C652C207374616E6461726420627574746F6E2066756E6374696F6E616C6974792E2229206973206E6F6E7374616E6461726420616E642046697265666F782D73706563696669632E2042792064656661756C742C20756E6C696B65206F74686572';
wwv_flow_imp.g_varchar2_table(5998) := '2062726F77736572732C205B46697265666F78207065727369737473207468652064796E616D69632064697361626C65642073746174655D2868747470733A2F2F737461636B6F766572666C6F772E636F6D2F7175657374696F6E732F35393835383339';
wwv_flow_imp.g_varchar2_table(5999) := '2F6275672D776974682D66697265666F782D64697361626C65642D6174747269627574652D6F662D696E7075742D6E6F742D726573657474696E672D7768656E2D72656672657368696E6729206F662061205B603C627574746F6E3E605D286874747073';
wwv_flow_imp.g_varchar2_table(6000) := '3A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F627574746F6E20225468652048544D4C203C627574746F6E3E20656C656D656E7420726570726573656E7473206120';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(6001) := '636C69636B61626C6520627574746F6E2C2077686963682063616E206265207573656420696E20666F726D73206F7220616E79776865726520696E206120646F63756D656E742074686174206E656564732073696D706C652C207374616E646172642062';
wwv_flow_imp.g_varchar2_table(6002) := '7574746F6E2066756E6374696F6E616C6974792E2229206163726F73732070616765206C6F6164732E2053657474696E67207468652076616C7565206F6620746869732061747472696275746520746F20606F6666602028692E652E20606175746F636F';
wwv_flow_imp.g_varchar2_table(6003) := '6D706C6574653D226F66662260292064697361626C6573207468697320666561747572652E20536565205B627567C2A03635343037325D2868747470733A2F2F6275677A696C6C612E6D6F7A696C6C612E6F72672F73686F775F6275672E6367693F6964';
wwv_flow_imp.g_varchar2_table(6004) := '3D363534303732202269662064697361626C6564207374617465206973206368616E6765642077697468206A6176617363726970742C20746865206E6F726D616C20737461746520646F65736E5C27742072657475726E20616674657220726566726573';
wwv_flow_imp.g_varchar2_table(6005) := '68696E6720746865207061676522292E277D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F4854';
wwv_flow_imp.g_varchar2_table(6006) := '4D4C2F456C656D656E742F627574746F6E227D5D7D2C7B6E616D653A2273656C656374222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652073656C65637420656C656D656E7420726570726573656E';
wwv_flow_imp.g_varchar2_table(6007) := '7473206120636F6E74726F6C20666F722073656C656374696E6720616D6F6E677374206120736574206F66206F7074696F6E732E227D2C617474726962757465733A5B7B6E616D653A226175746F636F6D706C657465222C76616C75655365743A22696E';
wwv_flow_imp.g_varchar2_table(6008) := '7075746175746F636F6D706C657465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2741205B60444F4D537472696E67605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(6009) := '6E2D55532F646F63732F5765622F4150492F444F4D537472696E672022444F4D537472696E672069732061205554462D313620537472696E672E204173204A61766153637269707420616C72656164792075736573207375636820737472696E67732C20';
wwv_flow_imp.g_varchar2_table(6010) := '444F4D537472696E67206973206D6170706564206469726563746C7920746F206120537472696E672E22292070726F766964696E6720612068696E7420666F722061205B75736572206167656E745C27735D2868747470733A2F2F646576656C6F706572';
wwv_flow_imp.g_varchar2_table(6011) := '2E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F757365725F6167656E74202275736572206167656E745C27733A20412075736572206167656E74206973206120636F6D70757465722070726F6772616D207265707265';
wwv_flow_imp.g_varchar2_table(6012) := '73656E74696E67206120706572736F6E2C20666F72206578616D706C652C20612062726F7773657220696E20612057656220636F6E746578742E2229206175746F636F6D706C65746520666561747572652E20536565205B5468652048544D4C20617574';
wwv_flow_imp.g_varchar2_table(6013) := '6F636F6D706C657465206174747269627574655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F417474726962757465732F6175746F636F6D706C6574652920666F7220';
wwv_flow_imp.g_varchar2_table(6014) := '6120636F6D706C657465206C697374206F662076616C75657320616E642064657461696C73206F6E20686F7720746F20757365206175746F636F6D706C6574652E277D7D2C7B6E616D653A226175746F666F637573222C76616C75655365743A2276222C';
wwv_flow_imp.g_varchar2_table(6015) := '6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E20617474726962757465206C65747320796F7520737065636966792074686174206120666F726D20636F6E74726F6C2073686F75';
wwv_flow_imp.g_varchar2_table(6016) := '6C64206861766520696E70757420666F637573207768656E207468652070616765206C6F6164732E204F6E6C79206F6E6520666F726D20656C656D656E7420696E206120646F63756D656E742063616E20686176652074686520606175746F666F637573';
wwv_flow_imp.g_varchar2_table(6017) := '60206174747269627574652E227D7D2C7B6E616D653A2264697361626C6564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E206174747269';
wwv_flow_imp.g_varchar2_table(6018) := '6275746520696E6469636174657320746861742074686520757365722063616E6E6F7420696E74657261637420776974682074686520636F6E74726F6C2E204966207468697320617474726962757465206973206E6F74207370656369666965642C2074';
wwv_flow_imp.g_varchar2_table(6019) := '686520636F6E74726F6C20696E686572697473206974732073657474696E672066726F6D2074686520636F6E7461696E696E6720656C656D656E742C20666F72206578616D706C6520606669656C64736574603B206966207468657265206973206E6F20';
wwv_flow_imp.g_varchar2_table(6020) := '636F6E7461696E696E6720656C656D656E74207769746820746865206064697361626C65646020617474726962757465207365742C207468656E2074686520636F6E74726F6C20697320656E61626C65642E227D7D2C7B6E616D653A22666F726D222C64';
wwv_flow_imp.g_varchar2_table(6021) := '65736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320617474726962757465206C65747320796F7520737065636966792074686520666F726D20656C656D656E7420746FC2A07768696368C2A07468652073';
wwv_flow_imp.g_varchar2_table(6022) := '656C65637420656C656D656E74206973206173736F636961746564C2A028746861742069732C206974732022666F726D206F776E657222292E204966207468697320617474726962757465206973207370656369666965642C206974732076616C756520';
wwv_flow_imp.g_varchar2_table(6023) := '6D757374206265207468652073616D65206173207468652060696460206F66206120666F726D20656C656D656E7420696E207468652073616D6520646F63756D656E742E205468697320656E61626C657320796F7520746F20706C6163652073656C6563';
wwv_flow_imp.g_varchar2_table(6024) := '7420656C656D656E747320616E7977686572652077697468696E206120646F63756D656E742C206E6F74206A7573742061732064657363656E64616E7473206F6620746865697220666F726D20656C656D656E74732E277D7D2C7B6E616D653A226D756C';
wwv_flow_imp.g_varchar2_table(6025) := '7469706C65222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E2061747472696275746520696E646963617465732074686174206D756C746970';
wwv_flow_imp.g_varchar2_table(6026) := '6C65206F7074696F6E732063616E2062652073656C656374656420696E20746865206C6973742E204966206974206973206E6F74207370656369666965642C207468656E206F6E6C79206F6E65206F7074696F6E2063616E2062652073656C6563746564';
wwv_flow_imp.g_varchar2_table(6027) := '20617420612074696D652E205768656E20606D756C7469706C6560206973207370656369666965642C206D6F73742062726F77736572732077696C6C2073686F772061207363726F6C6C696E67206C69737420626F7820696E7374656164206F66206120';
wwv_flow_imp.g_varchar2_table(6028) := '73696E676C65206C696E652064726F70646F776E2E227D7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320617474726962757465206973207573656420746F20';
wwv_flow_imp.g_varchar2_table(6029) := '7370656369667920746865206E616D65206F662074686520636F6E74726F6C2E227D7D2C7B6E616D653A227265717569726564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C7565';
wwv_flow_imp.g_varchar2_table(6030) := '3A224120426F6F6C65616E2061747472696275746520696E6469636174696E67207468617420616E206F7074696F6E20776974682061206E6F6E2D656D70747920737472696E672076616C7565206D7573742062652073656C65637465642E227D7D2C7B';
wwv_flow_imp.g_varchar2_table(6031) := '6E616D653A2273697A65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2249662074686520636F6E74726F6C2069732070726573656E7465642061732061207363726F6C6C696E67206C69737420626F7820';
wwv_flow_imp.g_varchar2_table(6032) := '28652E672E207768656E20606D756C7469706C656020697320737065636966696564292C20746869732061747472696275746520726570726573656E747320746865206E756D626572206F6620726F777320696E20746865206C69737420746861742073';
wwv_flow_imp.g_varchar2_table(6033) := '686F756C642062652076697369626C65206174206F6E652074696D652E2042726F777365727320617265206E6F7420726571756972656420746F2070726573656E7420612073656C65637420656C656D656E742061732061207363726F6C6C6564206C69';
wwv_flow_imp.g_varchar2_table(6034) := '737420626F782E205468652064656661756C742076616C756520697320302E5C6E5C6E2A2A4E6F74653A2A2A204163636F7264696E6720746F207468652048544D4C352073706563696669636174696F6E2C207468652064656661756C742076616C7565';
wwv_flow_imp.g_varchar2_table(6035) := '20666F722073697A652073686F756C6420626520313B20686F77657665722C20696E2070726163746963652C207468697320686173206265656E20666F756E6420746F20627265616B20736F6D65207765622073697465732C20616E64206E6F206F7468';
wwv_flow_imp.g_varchar2_table(6036) := '65722062726F777365722063757272656E746C7920646F657320746861742C20736F204D6F7A696C6C6120686173206F7074656420746F20636F6E74696E756520746F2072657475726E203020666F72207468652074696D65206265696E672077697468';
wwv_flow_imp.g_varchar2_table(6037) := '2046697265666F782E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C65';
wwv_flow_imp.g_varchar2_table(6038) := '6D656E742F73656C656374227D5D7D2C7B6E616D653A22646174616C697374222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520646174616C69737420656C656D656E7420726570726573656E7473';
wwv_flow_imp.g_varchar2_table(6039) := '206120736574206F66206F7074696F6E20656C656D656E7473207468617420726570726573656E7420707265646566696E6564206F7074696F6E7320666F72206F7468657220636F6E74726F6C732E20496E207468652072656E646572696E672C207468';
wwv_flow_imp.g_varchar2_table(6040) := '6520646174616C69737420656C656D656E7420726570726573656E7473206E6F7468696E6720616E642069742C20616C6F6E67207769746820697473206368696C6472656E2C2073686F756C642062652068696464656E2E227D2C617474726962757465';
wwv_flow_imp.g_varchar2_table(6041) := '733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F64617461';
wwv_flow_imp.g_varchar2_table(6042) := '6C697374227D5D7D2C7B6E616D653A226F707467726F7570222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206F707467726F757020656C656D656E7420726570726573656E747320612067726F75';
wwv_flow_imp.g_varchar2_table(6043) := '70206F66206F7074696F6E20656C656D656E74732077697468206120636F6D6D6F6E206C6162656C2E227D2C617474726962757465733A5B7B6E616D653A2264697361626C6564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B';
wwv_flow_imp.g_varchar2_table(6044) := '696E643A226D61726B646F776E222C76616C75653A224966207468697320426F6F6C65616E20617474726962757465206973207365742C206E6F6E65206F6620746865206974656D7320696E2074686973206F7074696F6E2067726F7570206973207365';
wwv_flow_imp.g_varchar2_table(6045) := '6C65637461626C652E204F6674656E2062726F77736572732067726579206F7574207375636820636F6E74726F6C20616E6420697420776F6E2774207265636569766520616E792062726F7773696E67206576656E74732C206C696B65206D6F75736520';
wwv_flow_imp.g_varchar2_table(6046) := '636C69636B73206F7220666F6375732D72656C61746564206F6E65732E227D7D2C7B6E616D653A226C6162656C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206E616D65206F66207468652067';
wwv_flow_imp.g_varchar2_table(6047) := '726F7570206F66206F7074696F6E732C207768696368207468652062726F777365722063616E20757365207768656E206C6162656C696E6720746865206F7074696F6E7320696E20746865207573657220696E746572666163652E205468697320617474';
wwv_flow_imp.g_varchar2_table(6048) := '726962757465206973206D616E6461746F7279206966207468697320656C656D656E7420697320757365642E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F64657665';
wwv_flow_imp.g_varchar2_table(6049) := '6C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6F707467726F7570227D5D7D2C7B6E616D653A226F7074696F6E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C';
wwv_flow_imp.g_varchar2_table(6050) := '75653A22546865206F7074696F6E20656C656D656E7420726570726573656E747320616E206F7074696F6E20696E20612073656C65637420656C656D656E74206F722061732070617274206F662061206C697374206F662073756767657374696F6E7320';
wwv_flow_imp.g_varchar2_table(6051) := '696E206120646174616C69737420656C656D656E742E227D2C617474726962757465733A5B7B6E616D653A2264697361626C6564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(6052) := '653A274966207468697320426F6F6C65616E20617474726962757465206973207365742C2074686973206F7074696F6E206973206E6F7420636865636B61626C652E204F6674656E2062726F77736572732067726579206F7574207375636820636F6E74';
wwv_flow_imp.g_varchar2_table(6053) := '726F6C20616E6420697420776F6E5C2774207265636569766520616E792062726F7773696E67206576656E742C206C696B65206D6F75736520636C69636B73206F7220666F6375732D72656C61746564206F6E65732E2049662074686973206174747269';
wwv_flow_imp.g_varchar2_table(6054) := '62757465206973206E6F74207365742C2074686520656C656D656E742063616E207374696C6C2062652064697361626C6564206966206F6E65206F662069747320616E636573746F727320697320612064697361626C6564205B603C6F707467726F7570';
wwv_flow_imp.g_varchar2_table(6055) := '3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6F707467726F757020225468652048544D4C203C6F707467726F75703E20656C656D656E7420';
wwv_flow_imp.g_varchar2_table(6056) := '6372656174657320612067726F7570696E67206F66206F7074696F6E732077697468696E2061203C73656C6563743E20656C656D656E742E222920656C656D656E742E277D7D2C7B6E616D653A226C6162656C222C6465736372697074696F6E3A7B6B69';
wwv_flow_imp.g_varchar2_table(6057) := '6E643A226D61726B646F776E222C76616C75653A225468697320617474726962757465206973207465787420666F7220746865206C6162656C20696E6469636174696E6720746865206D65616E696E67206F6620746865206F7074696F6E2E2049662074';
wwv_flow_imp.g_varchar2_table(6058) := '686520606C6162656C60206174747269627574652069736E277420646566696E65642C206974732076616C75652069732074686174206F662074686520656C656D656E74207465787420636F6E74656E742E227D7D2C7B6E616D653A2273656C65637465';
wwv_flow_imp.g_varchar2_table(6059) := '64222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2749662070726573656E742C207468697320426F6F6C65616E2061747472696275746520696E6469636174657320746861';
wwv_flow_imp.g_varchar2_table(6060) := '7420746865206F7074696F6E20697320696E697469616C6C792073656C65637465642E2049662074686520603C6F7074696F6E3E6020656C656D656E74206973207468652064657363656E64616E74206F662061205B603C73656C6563743E605D286874';
wwv_flow_imp.g_varchar2_table(6061) := '7470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F73656C65637420225468652048544D4C203C73656C6563743E20656C656D656E7420726570726573656E7473';
wwv_flow_imp.g_varchar2_table(6062) := '206120636F6E74726F6C20746861742070726F76696465732061206D656E75206F66206F7074696F6E73222920656C656D656E742077686F7365205B606D756C7469706C65605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(6063) := '672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F73656C65637423617474722D6D756C7469706C652920617474726962757465206973206E6F74207365742C206F6E6C79206F6E652073696E676C6520603C6F7074696F6E3E60';
wwv_flow_imp.g_varchar2_table(6064) := '206F662074686973205B603C73656C6563743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F73656C65637420225468652048544D4C203C7365';
wwv_flow_imp.g_varchar2_table(6065) := '6C6563743E20656C656D656E7420726570726573656E7473206120636F6E74726F6C20746861742070726F76696465732061206D656E75206F66206F7074696F6E73222920656C656D656E74206D6179206861766520746865206073656C656374656460';
wwv_flow_imp.g_varchar2_table(6066) := '206174747269627574652E277D7D2C7B6E616D653A2276616C7565222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520636F6E74656E74206F66207468697320617474726962757465207265707265';
wwv_flow_imp.g_varchar2_table(6067) := '73656E7473207468652076616C756520746F206265207375626D697474656420776974682074686520666F726D2C2073686F756C642074686973206F7074696F6E2062652073656C65637465642EC2A04966207468697320617474726962757465206973';
wwv_flow_imp.g_varchar2_table(6068) := '206F6D69747465642C207468652076616C75652069732074616B656E2066726F6D20746865207465787420636F6E74656E74206F6620746865206F7074696F6E20656C656D656E742E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E';
wwv_flow_imp.g_varchar2_table(6069) := '205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6F7074696F6E227D5D7D2C7B6E616D653A227465787461726561222C646573';
wwv_flow_imp.g_varchar2_table(6070) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520746578746172656120656C656D656E7420726570726573656E74732061206D756C74696C696E6520706C61696E2074657874206564697420636F6E74726F6C';
wwv_flow_imp.g_varchar2_table(6071) := '20666F722074686520656C656D656E742773207261772076616C75652E2054686520636F6E74656E7473206F662074686520636F6E74726F6C20726570726573656E742074686520636F6E74726F6C27732064656661756C742076616C75652E227D2C61';
wwv_flow_imp.g_varchar2_table(6072) := '7474726962757465733A5B7B6E616D653A226175746F636F6D706C657465222C76616C75655365743A22696E7075746175746F636F6D706C657465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546869';
wwv_flow_imp.g_varchar2_table(6073) := '732061747472696275746520696E646963617465732077686574686572207468652076616C7565206F662074686520636F6E74726F6C2063616E206265206175746F6D61746963616C6C7920636F6D706C65746564206279207468652062726F77736572';
wwv_flow_imp.g_varchar2_table(6074) := '2E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606F6666603A205468652075736572206D757374206578706C696369746C7920656E74657220612076616C756520696E746F2074686973206669656C6420666F722065766572';
wwv_flow_imp.g_varchar2_table(6075) := '79207573652C206F722074686520646F63756D656E742070726F766964657320697473206F776E206175746F2D636F6D706C6574696F6E206D6574686F643B207468652062726F7773657220646F6573206E6F74206175746F6D61746963616C6C792063';
wwv_flow_imp.g_varchar2_table(6076) := '6F6D706C6574652074686520656E7472792E5C6E2A202020606F6E603A205468652062726F777365722063616E206175746F6D61746963616C6C7920636F6D706C657465207468652076616C7565206261736564206F6E2076616C756573207468617420';
wwv_flow_imp.g_varchar2_table(6077) := '74686520757365722068617320656E746572656420647572696E672070726576696F757320757365732E5C6E5C6E49662074686520606175746F636F6D706C6574656020617474726962757465206973206E6F7420737065636966696564206F6E206120';
wwv_flow_imp.g_varchar2_table(6078) := '603C74657874617265613E6020656C656D656E742C207468656E207468652062726F7773657220757365732074686520606175746F636F6D706C65746560206174747269627574652076616C7565206F662074686520603C74657874617265613E602065';
wwv_flow_imp.g_varchar2_table(6079) := '6C656D656E745C277320666F726D206F776E65722E2054686520666F726D206F776E65722069732065697468657220746865205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F';
wwv_flow_imp.g_varchar2_table(6080) := '63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261';
wwv_flow_imp.g_varchar2_table(6081) := '637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E222920656C656D656E742074686174207468697320603C74657874617265613E6020656C656D656E7420';
wwv_flow_imp.g_varchar2_table(6082) := '697320612064657363656E64616E74206F66206F722074686520666F726D20656C656D656E742077686F7365206069646020697320737065636966696564206279207468652060666F726D6020617474726962757465206F662074686520696E70757420';
wwv_flow_imp.g_varchar2_table(6083) := '656C656D656E742E20466F72206D6F726520696E666F726D6174696F6E2C2073656520746865205B606175746F636F6D706C657465605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F576562';
wwv_flow_imp.g_varchar2_table(6084) := '2F48544D4C2F456C656D656E742F666F726D23617474722D6175746F636F6D706C657465292061747472696275746520696E205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F';
wwv_flow_imp.g_varchar2_table(6085) := '63732F5765622F48544D4C2F456C656D656E742F666F726D20225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261';
wwv_flow_imp.g_varchar2_table(6086) := '637469766520636F6E74726F6C7320666F72207375626D697474696E6720696E666F726D6174696F6E20746F206120776562207365727665722E22292E277D7D2C7B6E616D653A226175746F666F637573222C76616C75655365743A2276222C64657363';
wwv_flow_imp.g_varchar2_table(6087) := '72697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E20617474726962757465206C65747320796F7520737065636966792074686174206120666F726D20636F6E74726F6C2073686F756C642068';
wwv_flow_imp.g_varchar2_table(6088) := '61766520696E70757420666F637573207768656E207468652070616765206C6F6164732E204F6E6C79206F6E6520666F726D2D6173736F63696174656420656C656D656E7420696E206120646F63756D656E742063616E20686176652074686973206174';
wwv_flow_imp.g_varchar2_table(6089) := '74726962757465207370656369666965642E227D7D2C7B6E616D653A22636F6C73222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652076697369626C65207769647468206F66207468652074657874';
wwv_flow_imp.g_varchar2_table(6090) := '20636F6E74726F6C2C20696E206176657261676520636861726163746572207769647468732E204966206974206973207370656369666965642C206974206D757374206265206120706F73697469766520696E74656765722E204966206974206973206E';
wwv_flow_imp.g_varchar2_table(6091) := '6F74207370656369666965642C207468652064656661756C742076616C756520697320603230602E227D7D2C7B6E616D653A226469726E616D65227D2C7B6E616D653A2264697361626C6564222C76616C75655365743A2276222C646573637269707469';
wwv_flow_imp.g_varchar2_table(6092) := '6F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275468697320426F6F6C65616E2061747472696275746520696E6469636174657320746861742074686520757365722063616E6E6F7420696E7465726163742077697468207468652063';
wwv_flow_imp.g_varchar2_table(6093) := '6F6E74726F6C2E204966207468697320617474726962757465206973206E6F74207370656369666965642C2074686520636F6E74726F6C20696E686572697473206974732073657474696E672066726F6D2074686520636F6E7461696E696E6720656C65';
wwv_flow_imp.g_varchar2_table(6094) := '6D656E742C20666F72206578616D706C65205B603C6669656C647365743E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6669656C6473657420';
wwv_flow_imp.g_varchar2_table(6095) := '225468652048544D4C203C6669656C647365743E20656C656D656E74206973207573656420746F2067726F7570207365766572616C20636F6E74726F6C732061732077656C6C206173206C6162656C7320283C6C6162656C3E292077697468696E206120';
wwv_flow_imp.g_varchar2_table(6096) := '77656220666F726D2E22293B206966207468657265206973206E6F20636F6E7461696E696E6720656C656D656E74207768656E20746865206064697361626C65646020617474726962757465206973207365742C2074686520636F6E74726F6C20697320';
wwv_flow_imp.g_varchar2_table(6097) := '656E61626C65642E277D7D2C7B6E616D653A22666F726D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686520666F726D20656C656D656E7420746861742074686520603C74657874617265613E6020';
wwv_flow_imp.g_varchar2_table(6098) := '656C656D656E74206973206173736F636961746564207769746820286974732022666F726D206F776E657222292E205468652076616C7565206F662074686520617474726962757465206D757374206265207468652060696460206F66206120666F726D';
wwv_flow_imp.g_varchar2_table(6099) := '20656C656D656E7420696E207468652073616D6520646F63756D656E742E204966207468697320617474726962757465206973206E6F74207370656369666965642C2074686520603C74657874617265613E6020656C656D656E74206D75737420626520';
wwv_flow_imp.g_varchar2_table(6100) := '612064657363656E64616E74206F66206120666F726D20656C656D656E742E20546869732061747472696275746520656E61626C657320796F7520746F20706C61636520603C74657874617265613E6020656C656D656E747320616E7977686572652077';
wwv_flow_imp.g_varchar2_table(6101) := '697468696E206120646F63756D656E742C206E6F74206A7573742061732064657363656E64616E7473206F6620666F726D20656C656D656E74732E277D7D2C7B6E616D653A22696E7075746D6F6465222C76616C75655365743A22696D227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(6102) := '653A226D61786C656E677468222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D6178696D756D206E756D626572206F6620636861726163746572732028756E69636F646520636F646520706F69';
wwv_flow_imp.g_varchar2_table(6103) := '6E74732920746861742074686520757365722063616E20656E7465722E20496620746869732076616C75652069736E2774207370656369666965642C2074686520757365722063616E20656E74657220616E20756E6C696D69746564206E756D62657220';
wwv_flow_imp.g_varchar2_table(6104) := '6F6620636861726163746572732E227D7D2C7B6E616D653A226D696E6C656E677468222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D696E696D756D206E756D626572206F6620636861726163';
wwv_flow_imp.g_varchar2_table(6105) := '746572732028756E69636F646520636F646520706F696E74732920726571756972656420746861742074686520757365722073686F756C6420656E7465722E227D7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D';
wwv_flow_imp.g_varchar2_table(6106) := '61726B646F776E222C76616C75653A22546865206E616D65206F662074686520636F6E74726F6C2E227D7D2C7B6E616D653A22706C616365686F6C646572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27';
wwv_flow_imp.g_varchar2_table(6107) := '412068696E7420746F207468652075736572206F6620776861742063616E20626520656E746572656420696E2074686520636F6E74726F6C2E2043617272696167652072657475726E73206F72206C696E652D66656564732077697468696E2074686520';
wwv_flow_imp.g_varchar2_table(6108) := '706C616365686F6C6465722074657874206D7573742062652074726561746564206173206C696E6520627265616B73207768656E2072656E646572696E67207468652068696E742E5C6E5C6E2A2A4E6F74653A2A2A20506C616365686F6C646572732073';
wwv_flow_imp.g_varchar2_table(6109) := '686F756C64206F6E6C79206265207573656420746F2073686F7720616E206578616D706C65206F66207468652074797065206F66206461746120746861742073686F756C6420626520656E746572656420696E746F206120666F726D3B20746865792061';
wwv_flow_imp.g_varchar2_table(6110) := '7265205F6E6F745F2061207375627374697475746520666F7220612070726F706572205B603C6C6162656C3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C65';
wwv_flow_imp.g_varchar2_table(6111) := '6D656E742F6C6162656C20225468652048544D4C203C6C6162656C3E20656C656D656E7420726570726573656E747320612063617074696F6E20666F7220616E206974656D20696E2061207573657220696E746572666163652E222920656C656D656E74';
wwv_flow_imp.g_varchar2_table(6112) := '207469656420746F2074686520696E7075742E20536565205B4C6162656C7320616E6420706C616365686F6C646572735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F';
wwv_flow_imp.g_varchar2_table(6113) := '456C656D656E742F696E707574234C6162656C735F616E645F706C616365686F6C6465727320225468652048544D4C203C696E7075743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F';
wwv_flow_imp.g_varchar2_table(6114) := '6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D2074686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120';
wwv_flow_imp.g_varchar2_table(6115) := '616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E207468652064657669636520616E642075736572206167656E742E222920696E205B3C696E7075743E3A2054686520496E70757420';
wwv_flow_imp.g_varchar2_table(6116) := '28466F726D20496E7075742920656C656D656E745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F696E70757420225468652048544D4C203C696E70';
wwv_flow_imp.g_varchar2_table(6117) := '75743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264657220746F2061636365707420646174612066726F6D20';
wwv_flow_imp.g_varchar2_table(6118) := '74686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C61626C652C20646570656E64696E67206F6E2074686520';
wwv_flow_imp.g_varchar2_table(6119) := '64657669636520616E642075736572206167656E742E222920666F7220612066756C6C206578706C616E6174696F6E2E277D7D2C7B6E616D653A22726561646F6E6C79222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A';
wwv_flow_imp.g_varchar2_table(6120) := '226D61726B646F776E222C76616C75653A225468697320426F6F6C65616E2061747472696275746520696E6469636174657320746861742074686520757365722063616E6E6F74206D6F64696679207468652076616C7565206F662074686520636F6E74';
wwv_flow_imp.g_varchar2_table(6121) := '726F6C2E20556E6C696B6520746865206064697361626C656460206174747269627574652C207468652060726561646F6E6C79602061747472696275746520646F6573206E6F742070726576656E742074686520757365722066726F6D20636C69636B69';
wwv_flow_imp.g_varchar2_table(6122) := '6E67206F722073656C656374696E6720696E2074686520636F6E74726F6C2E205468652076616C7565206F66206120726561642D6F6E6C7920636F6E74726F6C206973207374696C6C207375626D697474656420776974682074686520666F726D2E227D';
wwv_flow_imp.g_varchar2_table(6123) := '7D2C7B6E616D653A227265717569726564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468697320617474726962757465207370656369666965732074686174207468';
wwv_flow_imp.g_varchar2_table(6124) := '652075736572206D7573742066696C6C20696E20612076616C7565206265666F7265207375626D697474696E67206120666F726D2E227D7D2C7B6E616D653A22726F7773222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76';
wwv_flow_imp.g_varchar2_table(6125) := '616C75653A22546865206E756D626572206F662076697369626C652074657874206C696E657320666F722074686520636F6E74726F6C2E227D7D2C7B6E616D653A2277726170222C76616C75655365743A2277222C6465736372697074696F6E3A7B6B69';
wwv_flow_imp.g_varchar2_table(6126) := '6E643A226D61726B646F776E222C76616C75653A22496E6469636174657320686F772074686520636F6E74726F6C20777261707320746578742E20506F737369626C652076616C756573206172653A5C6E5C6E2A2020206068617264603A205468652062';
wwv_flow_imp.g_varchar2_table(6127) := '726F77736572206175746F6D61746963616C6C7920696E7365727473206C696E6520627265616B73202843522B4C462920736F20746861742065616368206C696E6520686173206E6F206D6F7265207468616E20746865207769647468206F6620746865';
wwv_flow_imp.g_varchar2_table(6128) := '20636F6E74726F6C3B207468652060636F6C736020617474726962757465206D75737420616C736F2062652073706563696669656420666F72207468697320746F2074616B65206566666563742E5C6E2A20202060736F6674603A205468652062726F77';
wwv_flow_imp.g_varchar2_table(6129) := '73657220656E7375726573207468617420616C6C206C696E6520627265616B7320696E207468652076616C756520636F6E73697374206F6620612043522B4C4620706169722C2062757420646F6573206E6F7420696E7365727420616E79206164646974';
wwv_flow_imp.g_varchar2_table(6130) := '696F6E616C206C696E6520627265616B732E5C6E2A202020606F666660203A204C696B652060736F66746020627574206368616E67657320617070656172616E636520746F206077686974652D73706163653A207072656020736F206C696E6520736567';
wwv_flow_imp.g_varchar2_table(6131) := '6D656E747320657863656564696E672060636F6C736020617265206E6F74207772617070656420616E642074686520603C74657874617265613E60206265636F6D657320686F72697A6F6E74616C6C79207363726F6C6C61626C652E5C6E5C6E49662074';
wwv_flow_imp.g_varchar2_table(6132) := '68697320617474726962757465206973206E6F74207370656369666965642C2060736F667460206973206974732064656661756C742076616C75652E227D7D2C7B6E616D653A226175746F6361706974616C697A65222C6465736372697074696F6E3A22';
wwv_flow_imp.g_varchar2_table(6133) := '546869732069732061206E6F6E2D7374616E646172642061747472696275746520737570706F72746564206279205765624B6974206F6E20694F5320287468657265666F7265206E6561726C7920616C6C2062726F77736572732072756E6E696E67206F';
wwv_flow_imp.g_varchar2_table(6134) := '6E20694F532C20696E636C7564696E67205361666172692C2046697265666F782C20616E64204368726F6D65292C20776869636820636F6E74726F6C73207768657468657220616E6420686F772074686520746578742076616C75652073686F756C6420';
wwv_flow_imp.g_varchar2_table(6135) := '6265206175746F6D61746963616C6C79206361706974616C697A656420617320697420697320656E74657265642F6564697465642062792074686520757365722E20546865206E6F6E2D646570726563617465642076616C756573206172652061766169';
wwv_flow_imp.g_varchar2_table(6136) := '6C61626C6520696E20694F53203520616E64206C617465722E20506F737369626C652076616C756573206172653A5C6E5C6E2A202020606E6F6E65603A20436F6D706C6574656C792064697361626C6573206175746F6D61746963206361706974616C69';
wwv_flow_imp.g_varchar2_table(6137) := '7A6174696F6E2E5C6E2A2020206073656E74656E636573603A204175746F6D61746963616C6C79206361706974616C697A6520746865206669727374206C6574746572206F662073656E74656E6365732E5C6E2A20202060776F726473603A204175746F';
wwv_flow_imp.g_varchar2_table(6138) := '6D61746963616C6C79206361706974616C697A6520746865206669727374206C6574746572206F6620776F7264732E5C6E2A2020206063686172616374657273603A204175746F6D61746963616C6C79206361706974616C697A6520616C6C2063686172';
wwv_flow_imp.g_varchar2_table(6139) := '6163746572732E5C6E2A202020606F6E603A20446570726563617465642073696E636520694F5320352E5C6E2A202020606F6666603A20446570726563617465642073696E636520694F5320352E227D2C7B6E616D653A227370656C6C636865636B222C';
wwv_flow_imp.g_varchar2_table(6140) := '6465736372697074696F6E3A2253706563696669657320776865746865722074686520603C74657874617265613E60206973207375626A65637420746F207370656C6C20636865636B696E672062792074686520756E6465726C79696E672062726F7773';
wwv_flow_imp.g_varchar2_table(6141) := '65722F4F532E207468652076616C75652063616E2062653A5C6E5C6E2A2020206074727565603A20496E6469636174657320746861742074686520656C656D656E74206E6565647320746F206861766520697473207370656C6C696E6720616E64206772';
wwv_flow_imp.g_varchar2_table(6142) := '616D6D617220636865636B65642E5C6E2A2020206064656661756C7460203A20496E6469636174657320746861742074686520656C656D656E7420697320746F20616374206163636F7264696E6720746F20612064656661756C74206265686176696F72';
wwv_flow_imp.g_varchar2_table(6143) := '2C20706F737369626C79206261736564206F6E2074686520706172656E7420656C656D656E742773206F776E20607370656C6C636865636B602076616C75652E5C6E2A2020206066616C736560203A20496E646963617465732074686174207468652065';
wwv_flow_imp.g_varchar2_table(6144) := '6C656D656E742073686F756C64206E6F74206265207370656C6C20636865636B65642E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A69';
wwv_flow_imp.g_varchar2_table(6145) := '6C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F7465787461726561227D5D7D2C7B6E616D653A226F7574707574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206F75';
wwv_flow_imp.g_varchar2_table(6146) := '7470757420656C656D656E7420726570726573656E74732074686520726573756C74206F6620612063616C63756C6174696F6E20706572666F726D656420627920746865206170706C69636174696F6E2C206F722074686520726573756C74206F662061';
wwv_flow_imp.g_varchar2_table(6147) := '207573657220616374696F6E2E227D2C617474726962757465733A5B7B6E616D653A22666F72222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22412073706163652D736570617261746564206C697374206F';
wwv_flow_imp.g_varchar2_table(6148) := '66206F7468657220656C656D656E7473E28099205B606964605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F696429732C';
wwv_flow_imp.g_varchar2_table(6149) := '20696E6469636174696E6720746861742074686F736520656C656D656E747320636F6E747269627574656420696E7075742076616C75657320746F20286F72206F746865727769736520616666656374656429207468652063616C63756C6174696F6E2E';
wwv_flow_imp.g_varchar2_table(6150) := '227D7D2C7B6E616D653A22666F726D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546865205B666F726D20656C656D656E745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72';
wwv_flow_imp.g_varchar2_table(6151) := '672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D292074686174207468697320656C656D656E74206973206173736F636961746564207769746820286974732022666F726D206F776E657222292E205468652076616C';
wwv_flow_imp.g_varchar2_table(6152) := '7565206F662074686520617474726962757465206D75737420626520616E2060696460206F66206120666F726D20656C656D656E7420696E207468652073616D6520646F63756D656E742E204966207468697320617474726962757465206973206E6F74';
wwv_flow_imp.g_varchar2_table(6153) := '207370656369666965642C20746865206F757470757420656C656D656E74206D75737420626520612064657363656E64616E74206F66206120666F726D20656C656D656E742E20546869732061747472696275746520656E61626C657320796F7520746F';
wwv_flow_imp.g_varchar2_table(6154) := '20706C616365206F757470757420656C656D656E747320616E7977686572652077697468696E206120646F63756D656E742C206E6F74206A7573742061732064657363656E64616E7473206F6620746865697220666F726D20656C656D656E74732E277D';
wwv_flow_imp.g_varchar2_table(6155) := '7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546865206E616D65206F662074686520656C656D656E742C206578706F73656420696E20746865205B6048544D4C466F72';
wwv_flow_imp.g_varchar2_table(6156) := '6D456C656D656E74605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48544D4C466F726D456C656D656E7420225468652048544D4C466F726D456C656D656E7420696E74';
wwv_flow_imp.g_varchar2_table(6157) := '65726661636520726570726573656E74732061203C666F726D3E20656C656D656E7420696E2074686520444F4D3B20697420616C6C6F77732061636365737320746F20616E6420696E20736F6D65206361736573206D6F64696669636174696F6E206F66';
wwv_flow_imp.g_varchar2_table(6158) := '2061737065637473206F662074686520666F726D2C2061732077656C6C2061732061636365737320746F2069747320636F6D706F6E656E7420656C656D656E74732E2229204150492E277D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E';
wwv_flow_imp.g_varchar2_table(6159) := '205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6F7574707574227D5D7D2C7B6E616D653A2270726F6772657373222C646573';
wwv_flow_imp.g_varchar2_table(6160) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652070726F677265737320656C656D656E7420726570726573656E74732074686520636F6D706C6574696F6E2070726F6772657373206F662061207461736B2E20';
wwv_flow_imp.g_varchar2_table(6161) := '5468652070726F67726573732069732065697468657220696E64657465726D696E6174652C20696E6469636174696E6720746861742070726F6772657373206973206265696E67206D616465206275742074686174206974206973206E6F7420636C6561';
wwv_flow_imp.g_varchar2_table(6162) := '7220686F77206D756368206D6F726520776F726B2072656D61696E7320746F20626520646F6E65206265666F726520746865207461736B20697320636F6D706C6574652028652E672E206265636175736520746865207461736B2069732077616974696E';
wwv_flow_imp.g_varchar2_table(6163) := '6720666F7220612072656D6F746520686F737420746F20726573706F6E64292C206F72207468652070726F67726573732069732061206E756D62657220696E207468652072616E6765207A65726F20746F2061206D6178696D756D2C20676976696E6720';
wwv_flow_imp.g_varchar2_table(6164) := '746865206672616374696F6E206F6620776F726B20746861742068617320736F20666172206265656E20636F6D706C657465642E227D2C617474726962757465733A5B7B6E616D653A2276616C7565222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6165) := '6D61726B646F776E222C76616C75653A2254686973206174747269627574652073706563696669657320686F77206D756368206F6620746865207461736B207468617420686173206265656E20636F6D706C657465642E204974206D7573742062652061';
wwv_flow_imp.g_varchar2_table(6166) := '2076616C696420666C6F6174696E6720706F696E74206E756D626572206265747765656E203020616E6420606D6178602C206F72206265747765656E203020616E64203120696620606D617860206973206F6D69747465642E2049662074686572652069';
wwv_flow_imp.g_varchar2_table(6167) := '73206E6F206076616C756560206174747269627574652C207468652070726F67726573732062617220697320696E64657465726D696E6174653B207468697320696E64696361746573207468617420616E206163746976697479206973206F6E676F696E';
wwv_flow_imp.g_varchar2_table(6168) := '672077697468206E6F20696E6469636174696F6E206F6620686F77206C6F6E6720697420697320657870656374656420746F2074616B652E227D7D2C7B6E616D653A226D6178222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(6169) := '2C76616C75653A2254686973206174747269627574652064657363726962657320686F77206D75636820776F726B20746865207461736B20696E6469636174656420627920746865206070726F67726573736020656C656D656E74207265717569726573';
wwv_flow_imp.g_varchar2_table(6170) := '2E2054686520606D617860206174747269627574652C2069662070726573656E742C206D757374206861766520612076616C75652067726561746572207468616E207A65726F20616E6420626520612076616C696420666C6F6174696E6720706F696E74';
wwv_flow_imp.g_varchar2_table(6171) := '206E756D6265722E205468652064656661756C742076616C756520697320312E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C';
wwv_flow_imp.g_varchar2_table(6172) := '612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F70726F6772657373227D5D7D2C7B6E616D653A226D65746572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D65746572';
wwv_flow_imp.g_varchar2_table(6173) := '20656C656D656E7420726570726573656E74732061207363616C6172206D6561737572656D656E742077697468696E2061206B6E6F776E2072616E67652C206F722061206672616374696F6E616C2076616C75653B20666F72206578616D706C65206469';
wwv_flow_imp.g_varchar2_table(6174) := '736B2075736167652C207468652072656C6576616E6365206F66206120717565727920726573756C742C206F7220746865206672616374696F6E206F66206120766F74696E6720706F70756C6174696F6E20746F20686176652073656C65637465642061';
wwv_flow_imp.g_varchar2_table(6175) := '20706172746963756C61722063616E6469646174652E227D2C617474726962757465733A5B7B6E616D653A2276616C7565222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652063757272656E74206E';
wwv_flow_imp.g_varchar2_table(6176) := '756D657269632076616C75652E2054686973206D757374206265206265747765656E20746865206D696E696D756D20616E64206D6178696D756D2076616C7565732028606D696E602061747472696275746520616E6420606D6178602061747472696275';
wwv_flow_imp.g_varchar2_table(6177) := '746529206966207468657920617265207370656369666965642E20496620756E737065636966696564206F72206D616C666F726D65642C207468652076616C756520697320302E204966207370656369666965642C20627574206E6F742077697468696E';
wwv_flow_imp.g_varchar2_table(6178) := '207468652072616E676520676976656E2062792074686520606D696E602061747472696275746520616E6420606D617860206174747269627574652C207468652076616C756520697320657175616C20746F20746865206E65617265737420656E64206F';
wwv_flow_imp.g_varchar2_table(6179) := '66207468652072616E67652E5C6E5C6E2A2A5573616765206E6F74653A2A2A20556E6C65737320746865206076616C75656020617474726962757465206973206265747765656E2060306020616E64206031602028696E636C7573697665292C20746865';
wwv_flow_imp.g_varchar2_table(6180) := '20606D696E6020616E6420606D61786020617474726962757465732073686F756C6420646566696E65207468652072616E676520736F207468617420746865206076616C7565602061747472696275746527732076616C75652069732077697468696E20';
wwv_flow_imp.g_varchar2_table(6181) := '69742E227D7D2C7B6E616D653A226D696E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206C6F776572206E756D6572696320626F756E64206F6620746865206D656173757265642072616E6765';
wwv_flow_imp.g_varchar2_table(6182) := '2E2054686973206D757374206265206C657373207468616E20746865206D6178696D756D2076616C75652028606D61786020617474726962757465292C206966207370656369666965642E20496620756E7370656369666965642C20746865206D696E69';
wwv_flow_imp.g_varchar2_table(6183) := '6D756D2076616C756520697320302E227D7D2C7B6E616D653A226D6178222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207570706572206E756D6572696320626F756E64206F6620746865206D65';
wwv_flow_imp.g_varchar2_table(6184) := '6173757265642072616E67652E2054686973206D7573742062652067726561746572207468616E20746865206D696E696D756D2076616C75652028606D696E6020617474726962757465292C206966207370656369666965642E20496620756E73706563';
wwv_flow_imp.g_varchar2_table(6185) := '69666965642C20746865206D6178696D756D2076616C756520697320312E227D7D2C7B6E616D653A226C6F77222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207570706572206E756D6572696320';
wwv_flow_imp.g_varchar2_table(6186) := '626F756E64206F6620746865206C6F7720656E64206F6620746865206D656173757265642072616E67652E2054686973206D7573742062652067726561746572207468616E20746865206D696E696D756D2076616C75652028606D696E60206174747269';
wwv_flow_imp.g_varchar2_table(6187) := '62757465292C20616E6420697420616C736F206D757374206265206C657373207468616E2074686520686967682076616C756520616E64206D6178696D756D2076616C756520286068696768602061747472696275746520616E6420606D617860206174';
wwv_flow_imp.g_varchar2_table(6188) := '747269627574652C20726573706563746976656C79292C20696620616E7920617265207370656369666965642E20496620756E7370656369666965642C206F72206966206C657373207468616E20746865206D696E696D756D2076616C75652C20746865';
wwv_flow_imp.g_varchar2_table(6189) := '20606C6F77602076616C756520697320657175616C20746F20746865206D696E696D756D2076616C75652E227D7D2C7B6E616D653A2268696768222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520';
wwv_flow_imp.g_varchar2_table(6190) := '6C6F776572206E756D6572696320626F756E64206F6620746865206869676820656E64206F6620746865206D656173757265642072616E67652E2054686973206D757374206265206C657373207468616E20746865206D6178696D756D2076616C756520';
wwv_flow_imp.g_varchar2_table(6191) := '28606D61786020617474726962757465292C20616E6420697420616C736F206D7573742062652067726561746572207468616E20746865206C6F772076616C756520616E64206D696E696D756D2076616C75652028606C6F776020617474726962757465';
wwv_flow_imp.g_varchar2_table(6192) := '20616E64202A2A6D696E2A2A206174747269627574652C20726573706563746976656C79292C20696620616E7920617265207370656369666965642E20496620756E7370656369666965642C206F722069662067726561746572207468616E2074686520';
wwv_flow_imp.g_varchar2_table(6193) := '6D6178696D756D2076616C75652C20746865206068696768602076616C756520697320657175616C20746F20746865206D6178696D756D2076616C75652E227D7D2C7B6E616D653A226F7074696D756D222C6465736372697074696F6E3A7B6B696E643A';
wwv_flow_imp.g_varchar2_table(6194) := '226D61726B646F776E222C76616C75653A22546869732061747472696275746520696E6469636174657320746865206F7074696D616C206E756D657269632076616C75652E204974206D7573742062652077697468696E207468652072616E6765202861';
wwv_flow_imp.g_varchar2_table(6195) := '7320646566696E65642062792074686520606D696E602061747472696275746520616E6420606D61786020617474726962757465292E205768656E207573656420776974682074686520606C6F77602061747472696275746520616E6420606869676860';
wwv_flow_imp.g_varchar2_table(6196) := '206174747269627574652C20697420676976657320616E20696E6469636174696F6E20776865726520616C6F6E67207468652072616E676520697320636F6E736964657265642070726566657261626C652E20466F72206578616D706C652C2069662069';
wwv_flow_imp.g_varchar2_table(6197) := '74206973206265747765656E2074686520606D696E602061747472696275746520616E642074686520606C6F7760206174747269627574652C207468656E20746865206C6F7765722072616E676520697320636F6E736964657265642070726566657272';
wwv_flow_imp.g_varchar2_table(6198) := '65642E227D7D2C7B6E616D653A22666F726D222C6465736372697074696F6E3A225468697320617474726962757465206173736F6369617465732074686520656C656D656E74207769746820612060666F726D6020656C656D656E742074686174206861';
wwv_flow_imp.g_varchar2_table(6199) := '73206F776E657273686970206F662074686520606D657465726020656C656D656E742E20466F72206578616D706C652C206120606D6574657260206D6967687420626520646973706C6179696E6720612072616E676520636F72726573706F6E64696E67';
wwv_flow_imp.g_varchar2_table(6200) := '20746F20616E2060696E7075746020656C656D656E74206F6620607479706560205F6E756D6265725F2E205468697320617474726962757465206973206F6E6C7920757365642069662074686520606D657465726020656C656D656E7420697320626569';
wwv_flow_imp.g_varchar2_table(6201) := '6E672075736564206173206120666F726D2D6173736F63696174656420656C656D656E743B206576656E207468656E2C206974206D6179206265206F6D69747465642069662074686520656C656D656E7420617070656172732061732061206465736365';
wwv_flow_imp.g_varchar2_table(6202) := '6E64616E74206F6620612060666F726D6020656C656D656E742E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F64';
wwv_flow_imp.g_varchar2_table(6203) := '6F63732F5765622F48544D4C2F456C656D656E742F6D65746572227D5D7D2C7B6E616D653A226669656C64736574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206669656C6473657420656C65';
wwv_flow_imp.g_varchar2_table(6204) := '6D656E7420726570726573656E7473206120736574206F6620666F726D20636F6E74726F6C73206F7074696F6E616C6C792067726F7570656420756E646572206120636F6D6D6F6E206E616D652E227D2C617474726962757465733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(6205) := '64697361626C6564222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224966207468697320426F6F6C65616E20617474726962757465206973207365742C20616C6C20666F72';
wwv_flow_imp.g_varchar2_table(6206) := '6D20636F6E74726F6C732074686174206172652064657363656E64616E7473206F662074686520603C6669656C647365743E602C206172652064697361626C65642C206D65616E696E67207468657920617265206E6F74206564697461626C6520616E64';
wwv_flow_imp.g_varchar2_table(6207) := '20776F6E2774206265207375626D697474656420616C6F6E6720776974682074686520603C666F726D3E602E205468657920776F6E2774207265636569766520616E792062726F7773696E67206576656E74732C206C696B65206D6F75736520636C6963';
wwv_flow_imp.g_varchar2_table(6208) := '6B73206F7220666F6375732D72656C61746564206576656E74732E2042792064656661756C742062726F777365727320646973706C6179207375636820636F6E74726F6C7320677261796564206F75742E204E6F7465207468617420666F726D20656C65';
wwv_flow_imp.g_varchar2_table(6209) := '6D656E747320696E7369646520746865205B603C6C6567656E643E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6C6567656E64205C22546865';
wwv_flow_imp.g_varchar2_table(6210) := '2048544D4C203C6C6567656E643E20656C656D656E7420726570726573656E747320612063617074696F6E20666F722074686520636F6E74656E74206F662069747320706172656E74203C6669656C647365743E2E5C222920656C656D656E7420776F6E';
wwv_flow_imp.g_varchar2_table(6211) := '27742062652064697361626C65642E227D7D2C7B6E616D653A22666F726D222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686973206174747269627574652074616B6573207468652076616C7565206F';
wwv_flow_imp.g_varchar2_table(6212) := '6620746865206069646020617474726962757465206F662061205B603C666F726D3E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F666F726D20';
wwv_flow_imp.g_varchar2_table(6213) := '225468652048544D4C203C666F726D3E20656C656D656E7420726570726573656E7473206120646F63756D656E742073656374696F6E207468617420636F6E7461696E7320696E74657261637469766520636F6E74726F6C7320666F72207375626D6974';
wwv_flow_imp.g_varchar2_table(6214) := '74696E6720696E666F726D6174696F6E20746F206120776562207365727665722E222920656C656D656E7420796F752077616E742074686520603C6669656C647365743E6020746F2062652070617274206F662C206576656E206966206974206973206E';
wwv_flow_imp.g_varchar2_table(6215) := '6F7420696E736964652074686520666F726D2E277D7D2C7B6E616D653A226E616D65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27546865206E616D65206173736F636961746564207769746820746865';
wwv_flow_imp.g_varchar2_table(6216) := '2067726F75702E5C6E5C6E2A2A4E6F74652A2A3A205468652063617074696F6E20666F7220746865206669656C6473657420697320676976656E20627920746865206669727374205B603C6C6567656E643E605D2868747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(6217) := '65722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F6C6567656E6420225468652048544D4C203C6C6567656E643E20656C656D656E7420726570726573656E747320612063617074696F6E20666F';
wwv_flow_imp.g_varchar2_table(6218) := '722074686520636F6E74656E74206F662069747320706172656E74203C6669656C647365743E2E222920656C656D656E74206E657374656420696E736964652069742E277D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572';
wwv_flow_imp.g_varchar2_table(6219) := '656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6669656C64736574227D5D7D2C7B6E616D653A226C6567656E64222C646573637269707469';
wwv_flow_imp.g_varchar2_table(6220) := '6F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206C6567656E6420656C656D656E7420726570726573656E747320612063617074696F6E20666F72207468652072657374206F662074686520636F6E74656E7473206F662074';
wwv_flow_imp.g_varchar2_table(6221) := '6865206C6567656E6420656C656D656E74277320706172656E74206669656C6473657420656C656D656E742C20696620616E792E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E63';
wwv_flow_imp.g_varchar2_table(6222) := '65222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6C6567656E64227D5D7D2C7B6E616D653A2264657461696C73222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(6223) := '6B696E643A226D61726B646F776E222C76616C75653A225468652064657461696C7320656C656D656E7420726570726573656E7473206120646973636C6F73757265207769646765742066726F6D2077686963682074686520757365722063616E206F62';
wwv_flow_imp.g_varchar2_table(6224) := '7461696E206164646974696F6E616C20696E666F726D6174696F6E206F7220636F6E74726F6C732E227D2C617474726962757465733A5B7B6E616D653A226F70656E222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6225) := '6D61726B646F776E222C76616C75653A225468697320426F6F6C65616E2061747472696275746520696E646963617465732077686574686572206F72206E6F74207468652064657461696C7320E2809420746861742069732C2074686520636F6E74656E';
wwv_flow_imp.g_varchar2_table(6226) := '7473206F662074686520603C64657461696C733E6020656C656D656E7420E28094206172652063757272656E746C792076697369626C652E205468652064656661756C742C206066616C7365602C206D65616E73207468652064657461696C7320617265';
wwv_flow_imp.g_varchar2_table(6227) := '206E6F742076697369626C652E227D7D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C';
wwv_flow_imp.g_varchar2_table(6228) := '2F456C656D656E742F64657461696C73227D5D7D2C7B6E616D653A2273756D6D617279222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652073756D6D61727920656C656D656E742072657072657365';
wwv_flow_imp.g_varchar2_table(6229) := '6E747320612073756D6D6172792C2063617074696F6E2C206F72206C6567656E6420666F72207468652072657374206F662074686520636F6E74656E7473206F66207468652073756D6D61727920656C656D656E74277320706172656E74206465746169';
wwv_flow_imp.g_varchar2_table(6230) := '6C7320656C656D656E742C20696620616E792E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C61';
wwv_flow_imp.g_varchar2_table(6231) := '2E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F73756D6D617279227D5D7D2C7B6E616D653A226469616C6F67222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206469616C6F67';
wwv_flow_imp.g_varchar2_table(6232) := '20656C656D656E7420726570726573656E747320612070617274206F6620616E206170706C69636174696F6E20746861742061207573657220696E74657261637473207769746820746F20706572666F726D2061207461736B2C20666F72206578616D70';
wwv_flow_imp.g_varchar2_table(6233) := '6C652061206469616C6F6720626F782C20696E73706563746F722C206F722077696E646F772E227D2C617474726962757465733A5B7B6E616D653A226F70656E222C6465736372697074696F6E3A22496E64696361746573207468617420746865206469';
wwv_flow_imp.g_varchar2_table(6234) := '616C6F672069732061637469766520616E6420617661696C61626C6520666F7220696E746572616374696F6E2E205768656E2074686520606F70656E6020617474726962757465206973206E6F74207365742C20746865206469616C6F672073686F756C';
wwv_flow_imp.g_varchar2_table(6235) := '646E27742062652073686F776E20746F2074686520757365722E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F64';
wwv_flow_imp.g_varchar2_table(6236) := '6F63732F5765622F48544D4C2F456C656D656E742F6469616C6F67227D5D7D2C7B6E616D653A22736372697074222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652073637269707420656C656D656E';
wwv_flow_imp.g_varchar2_table(6237) := '7420616C6C6F777320617574686F727320746F20696E636C7564652064796E616D69632073637269707420616E64206461746120626C6F636B7320696E20746865697220646F63756D656E74732E2054686520656C656D656E7420646F6573206E6F7420';
wwv_flow_imp.g_varchar2_table(6238) := '726570726573656E7420636F6E74656E7420666F722074686520757365722E227D2C617474726962757465733A5B7B6E616D653A22737263222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546869732061';
wwv_flow_imp.g_varchar2_table(6239) := '7474726962757465207370656369666965732074686520555249206F6620616E2065787465726E616C207363726970743B20746869732063616E206265207573656420617320616E20616C7465726E617469766520746F20656D62656464696E67206120';
wwv_flow_imp.g_varchar2_table(6240) := '736372697074206469726563746C792077697468696E206120646F63756D656E742E5C6E5C6E4966206120607363726970746020656C656D656E7420686173206120607372636020617474726962757465207370656369666965642C2069742073686F75';
wwv_flow_imp.g_varchar2_table(6241) := '6C64206E6F74206861766520612073637269707420656D62656464656420696E736964652069747320746167732E227D7D2C7B6E616D653A2274797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754';
wwv_flow_imp.g_varchar2_table(6242) := '6869732061747472696275746520696E64696361746573207468652074797065206F662073637269707420726570726573656E7465642E205468652076616C7565206F662074686973206174747269627574652077696C6C20626520696E206F6E65206F';
wwv_flow_imp.g_varchar2_table(6243) := '662074686520666F6C6C6F77696E672063617465676F726965733A5C6E5C6E2A2020202A2A4F6D6974746564206F722061204A617661536372697074204D494D4520747970653A2A2A20466F722048544D4C352D636F6D706C69616E742062726F777365';
wwv_flow_imp.g_varchar2_table(6244) := '7273207468697320696E646963617465732074686520736372697074206973204A6176615363726970742E2048544D4C352073706563696669636174696F6E20757267657320617574686F727320746F206F6D6974207468652061747472696275746520';
wwv_flow_imp.g_varchar2_table(6245) := '726174686572207468616E2070726F76696465206120726564756E64616E74204D494D4520747970652E20496E206561726C6965722062726F77736572732C2074686973206964656E7469666965642074686520736372697074696E67206C616E677561';
wwv_flow_imp.g_varchar2_table(6246) := '6765206F662074686520656D626564646564206F7220696D706F72746564202876696120746865206073726360206174747269627574652920636F64652E204A617661536372697074204D494D4520747970657320617265205B6C697374656420696E20';
wwv_flow_imp.g_varchar2_table(6247) := '7468652073706563696669636174696F6E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F4261736963735F6F665F485454502F4D494D455F7479706573234A61766153';
wwv_flow_imp.g_varchar2_table(6248) := '63726970745F7479706573292E5C6E2A2020202A2A606D6F64756C65603A2A2A20466F722048544D4C352D636F6D706C69616E742062726F77736572732074686520636F646520697320747265617465642061732061204A617661536372697074206D6F';
wwv_flow_imp.g_varchar2_table(6249) := '64756C652E205468652070726F63657373696E67206F66207468652073637269707420636F6E74656E7473206973206E6F74206166666563746564206279207468652060636861727365746020616E64206064656665726020617474726962757465732E';
wwv_flow_imp.g_varchar2_table(6250) := '20466F7220696E666F726D6174696F6E206F6E207573696E6720606D6F64756C65602C20736565205B45533620696E2044657074683A204D6F64756C65735D2868747470733A2F2F6861636B732E6D6F7A696C6C612E6F72672F323031352F30382F6573';
wwv_flow_imp.g_varchar2_table(6251) := '362D696E2D64657074682D6D6F64756C65732F292E20436F6465206D61792062656861766520646966666572656E746C79207768656E2074686520606D6F64756C6560206B6579776F726420697320757365642E5C6E2A2020202A2A416E79206F746865';
wwv_flow_imp.g_varchar2_table(6252) := '722076616C75653A2A2A2054686520656D62656464656420636F6E74656E7420697320747265617465642061732061206461746120626C6F636B20776869636820776F6E5C27742062652070726F636573736564206279207468652062726F777365722E';
wwv_flow_imp.g_varchar2_table(6253) := '20446576656C6F70657273206D7573742075736520612076616C6964204D494D4520747970652074686174206973206E6F742061204A617661536372697074204D494D45207479706520746F2064656E6F7465206461746120626C6F636B732E20546865';
wwv_flow_imp.g_varchar2_table(6254) := '206073726360206174747269627574652077696C6C2062652069676E6F7265642E5C6E5C6E2A2A4E6F74653A2A2A20696E2046697265666F7820796F7520636F756C642073706563696679207468652076657273696F6E206F66204A6176615363726970';
wwv_flow_imp.g_varchar2_table(6255) := '7420636F6E7461696E656420696E206120603C7363726970743E6020656C656D656E7420627920696E636C7564696E672061206E6F6E2D7374616E64617264206076657273696F6E6020706172616D6574657220696E7369646520746865206074797065';
wwv_flow_imp.g_varchar2_table(6256) := '602061747472696275746520E2809420666F72206578616D706C652060747970653D22746578742F6A6176617363726970743B76657273696F6E3D312E3822602E205468697320686173206265656E2072656D6F76656420696E2046697265666F782035';
wwv_flow_imp.g_varchar2_table(6257) := '392028736565205B627567C2A0313432383734355D2868747470733A2F2F6275677A696C6C612E6D6F7A696C6C612E6F72672F73686F775F6275672E6367693F69643D31343238373435202246495845443A2052656D6F766520737570706F727420666F';
wwv_flow_imp.g_varchar2_table(6258) := '722076657273696F6E20706172616D657465722066726F6D20736372697074206C6F616465722229292E277D7D2C7B6E616D653A2263686172736574227D2C7B6E616D653A226173796E63222C76616C75655365743A2276222C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(6259) := '6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686973206973206120426F6F6C65616E2061747472696275746520696E6469636174696E672074686174207468652062726F777365722073686F756C642C20696620706F737369626C';
wwv_flow_imp.g_varchar2_table(6260) := '652C206C6F61642074686520736372697074206173796E6368726F6E6F75736C792E5C6E5C6E5468697320617474726962757465206D757374206E6F74206265207573656420696620746865206073726360206174747269627574652069732061627365';
wwv_flow_imp.g_varchar2_table(6261) := '6E742028692E652E20666F7220696E6C696E652073637269707473292E20496620697420697320696E636C7564656420696E207468697320636173652069742077696C6C2068617665206E6F206566666563742E5C6E5C6E42726F777365727320757375';
wwv_flow_imp.g_varchar2_table(6262) := '616C6C7920617373756D652074686520776F7273742063617365207363656E6172696F20616E64206C6F616420736372697074732073796E6368726F6E6F75736C792C2028692E652E20606173796E633D2266616C736522602920647572696E67204854';
wwv_flow_imp.g_varchar2_table(6263) := '4D4C2070617273696E672E5C6E5C6E44796E616D6963616C6C7920696E736572746564207363726970747320287573696E67205B60646F63756D656E742E637265617465456C656D656E742829605D2868747470733A2F2F646576656C6F7065722E6D6F';
wwv_flow_imp.g_varchar2_table(6264) := '7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F446F63756D656E742F637265617465456C656D656E742022496E20616E2048544D4C20646F63756D656E742C2074686520646F63756D656E742E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(6265) := '2829206D6574686F642063726561746573207468652048544D4C20656C656D656E7420737065636966696564206279207461674E616D652C206F7220616E2048544D4C556E6B6E6F776E456C656D656E74206966207461674E616D652069736E5C277420';
wwv_flow_imp.g_varchar2_table(6266) := '7265636F676E697A65642E222929206C6F6164206173796E6368726F6E6F75736C792062792064656661756C742C20736F20746F207475726E206F6E2073796E6368726F6E6F7573206C6F6164696E672028692E652E2073637269707473206C6F616420';
wwv_flow_imp.g_varchar2_table(6267) := '696E20746865206F726465722074686579207765726520696E736572746564292073657420606173796E633D2266616C736522602E5C6E5C6E536565205B42726F7773657220636F6D7061746962696C6974795D282342726F777365725F636F6D706174';
wwv_flow_imp.g_varchar2_table(6268) := '6962696C6974792920666F72206E6F746573206F6E2062726F7773657220737570706F72742E2053656520616C736F205B4173796E63207363726970747320666F722061736D2E6A735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C61';
wwv_flow_imp.g_varchar2_table(6269) := '2E6F72672F656E2D55532F646F63732F47616D65732F546563686E69717565732F4173796E635F73637269707473292E277D7D2C7B6E616D653A226465666572222C76616C75655365743A2276222C6465736372697074696F6E3A7B6B696E643A226D61';
wwv_flow_imp.g_varchar2_table(6270) := '726B646F776E222C76616C75653A275468697320426F6F6C65616E206174747269627574652069732073657420746F20696E64696361746520746F20612062726F7773657220746861742074686520736372697074206973206D65616E7420746F206265';
wwv_flow_imp.g_varchar2_table(6271) := '2065786563757465642061667465722074686520646F63756D656E7420686173206265656E207061727365642C20627574206265666F726520666972696E67205B60444F4D436F6E74656E744C6F61646564605D2868747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(6272) := '65722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4576656E74732F444F4D436F6E74656E744C6F6164656420222F656E2D55532F646F63732F5765622F4576656E74732F444F4D436F6E74656E744C6F6164656422292E5C6E5C';
wwv_flow_imp.g_varchar2_table(6273) := '6E536372697074732077697468207468652060646566657260206174747269627574652077696C6C2070726576656E74207468652060444F4D436F6E74656E744C6F6164656460206576656E742066726F6D20666972696E6720756E74696C2074686520';
wwv_flow_imp.g_varchar2_table(6274) := '73637269707420686173206C6F6164656420616E642066696E6973686564206576616C756174696E672E5C6E5C6E5468697320617474726962757465206D757374206E6F7420626520757365642069662074686520607372636020617474726962757465';
wwv_flow_imp.g_varchar2_table(6275) := '20697320616273656E742028692E652E20666F7220696E6C696E652073637269707473292C20696E2074686973206361736520697420776F756C642068617665206E6F206566666563742E5C6E5C6E546F206163686965766520612073696D696C617220';
wwv_flow_imp.g_varchar2_table(6276) := '65666665637420666F722064796E616D6963616C6C7920696E73657274656420736372697074732075736520606173796E633D2266616C7365226020696E73746561642E2053637269707473207769746820746865206064656665726020617474726962';
wwv_flow_imp.g_varchar2_table(6277) := '7574652077696C6C206578656375746520696E20746865206F7264657220696E20776869636820746865792061707065617220696E2074686520646F63756D656E742E277D7D2C7B6E616D653A2263726F73736F726967696E222C76616C75655365743A';
wwv_flow_imp.g_varchar2_table(6278) := '22786F222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A274E6F726D616C20607363726970746020656C656D656E74732070617373206D696E696D616C20696E666F726D6174696F6E20746F20746865205B60';
wwv_flow_imp.g_varchar2_table(6279) := '77696E646F772E6F6E6572726F72605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F476C6F62616C4576656E7448616E646C6572732F6F6E6572726F722022546865206F';
wwv_flow_imp.g_varchar2_table(6280) := '6E6572726F722070726F7065727479206F662074686520476C6F62616C4576656E7448616E646C657273206D6978696E20697320616E204576656E7448616E646C657220746861742070726F636573736573206572726F72206576656E74732E22292066';
wwv_flow_imp.g_varchar2_table(6281) := '6F72207363726970747320776869636820646F206E6F74207061737320746865207374616E64617264205B434F52535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F43';
wwv_flow_imp.g_varchar2_table(6282) := '4F52532022434F52533A20434F5253202843726F73732D4F726967696E205265736F757263652053686172696E672920697320612073797374656D2C20636F6E73697374696E67206F66207472616E736D697474696E6720485454502068656164657273';
wwv_flow_imp.g_varchar2_table(6283) := '2C20746861742064657465726D696E657320776865746865722062726F777365727320626C6F636B2066726F6E74656E64204A61766153637269707420636F64652066726F6D20616363657373696E6720726573706F6E73657320666F722063726F7373';
wwv_flow_imp.g_varchar2_table(6284) := '2D6F726967696E2072657175657374732E222920636865636B732E20546F20616C6C6F77206572726F72206C6F6767696E6720666F7220736974657320776869636820757365206120736570617261746520646F6D61696E20666F722073746174696320';
wwv_flow_imp.g_varchar2_table(6285) := '6D656469612C207573652074686973206174747269627574652E20536565205B434F52532073657474696E677320617474726962757465735D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F57';
wwv_flow_imp.g_varchar2_table(6286) := '65622F48544D4C2F434F52535F73657474696E67735F617474726962757465732920666F722061206D6F7265206465736372697074697665206578706C616E6174696F6E206F66206974732076616C696420617267756D656E74732E277D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(6287) := '653A226E6F6E6365222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22412063727970746F67726170686963206E6F6E636520286E756D6265722075736564206F6E63652920746F2077686974656C69737420';
wwv_flow_imp.g_varchar2_table(6288) := '696E6C696E65207363726970747320696E2061205B7363726970742D73726320436F6E74656E742D53656375726974792D506F6C6963795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(6289) := '622F485454502F486561646572732F436F6E74656E742D53656375726974792D506F6C6963792F7363726970742D737263292E2054686520736572766572206D7573742067656E6572617465206120756E69717565206E6F6E63652076616C7565206561';
wwv_flow_imp.g_varchar2_table(6290) := '63682074696D65206974207472616E736D697473206120706F6C6963792E20497420697320637269746963616C20746F2070726F766964652061206E6F6E636520746861742063616E6E6F74206265206775657373656420617320627970617373696E67';
wwv_flow_imp.g_varchar2_table(6291) := '2061207265736F75726365277320706F6C696379206973206F7468657277697365207472697669616C2E227D7D2C7B6E616D653A22696E74656772697479222C6465736372697074696F6E3A22546869732061747472696275746520636F6E7461696E73';
wwv_flow_imp.g_varchar2_table(6292) := '20696E6C696E65206D65746164617461207468617420612075736572206167656E742063616E2075736520746F20766572696679207468617420612066657463686564207265736F7572636520686173206265656E2064656C6976657265642066726565';
wwv_flow_imp.g_varchar2_table(6293) := '206F6620756E6578706563746564206D616E6970756C6174696F6E2E20536565205B5375627265736F7572636520496E746567726974795D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(6294) := '622F53656375726974792F5375627265736F757263655F496E74656772697479292E227D2C7B6E616D653A226E6F6D6F64756C65222C6465736372697074696F6E3A225468697320426F6F6C65616E206174747269627574652069732073657420746F20';
wwv_flow_imp.g_varchar2_table(6295) := '696E646963617465207468617420746865207363726970742073686F756C64206E6F7420626520657865637574656420696E2062726F7773657273207468617420737570706F7274205B455332303135206D6F64756C65735D2868747470733A2F2F6861';
wwv_flow_imp.g_varchar2_table(6296) := '636B732E6D6F7A696C6C612E6F72672F323031352F30382F6573362D696E2D64657074682D6D6F64756C65732F2920E2809420696E206566666563742C20746869732063616E206265207573656420746F2073657276652066616C6C6261636B20736372';
wwv_flow_imp.g_varchar2_table(6297) := '6970747320746F206F6C6465722062726F7773657273207468617420646F206E6F7420737570706F7274206D6F64756C6172204A61766153637269707420636F64652E227D2C7B6E616D653A227265666572726572706F6C696379222C64657363726970';
wwv_flow_imp.g_varchar2_table(6298) := '74696F6E3A27496E64696361746573207768696368205B72656665727265725D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F446F63756D656E742F726566657272657229';
wwv_flow_imp.g_varchar2_table(6299) := '20746F2073656E64207768656E206665746368696E6720746865207363726970742C206F72207265736F7572636573206665746368656420627920746865207363726970743A5C6E5C6E2A202020606E6F2D7265666572726572603A20546865205B6052';
wwv_flow_imp.g_varchar2_table(6300) := '656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F485454502F486561646572732F526566657265722022546865205265666572657220726571756573742068656164';
wwv_flow_imp.g_varchar2_table(6301) := '657220636F6E7461696E73207468652061646472657373206F66207468652070726576696F75732077656220706167652066726F6D2077686963682061206C696E6B20746F207468652063757272656E746C792072657175657374656420706167652077';
wwv_flow_imp.g_varchar2_table(6302) := '617320666F6C6C6F7765642E2054686520526566657265722068656164657220616C6C6F7773207365727665727320746F206964656E746966792077686572652070656F706C6520617265207669736974696E67207468656D2066726F6D20616E64206D';
wwv_flow_imp.g_varchar2_table(6303) := '6179207573652074686174206461746120666F7220616E616C79746963732C206C6F6767696E672C206F72206F7074696D697A65642063616368696E672C20666F72206578616D706C652E2229206865616465722077696C6C206E6F742062652073656E';
wwv_flow_imp.g_varchar2_table(6304) := '742E5C6E2A202020606E6F2D72656665727265722D7768656E2D646F776E677261646560202864656661756C74293A20546865205B6052656665726572605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F';
wwv_flow_imp.g_varchar2_table(6305) := '646F63732F5765622F485454502F486561646572732F526566657265722022546865205265666572657220726571756573742068656164657220636F6E7461696E73207468652061646472657373206F66207468652070726576696F7573207765622070';
wwv_flow_imp.g_varchar2_table(6306) := '6167652066726F6D2077686963682061206C696E6B20746F207468652063757272656E746C792072657175657374656420706167652077617320666F6C6C6F7765642E2054686520526566657265722068656164657220616C6C6F777320736572766572';
wwv_flow_imp.g_varchar2_table(6307) := '7320746F206964656E746966792077686572652070656F706C6520617265207669736974696E67207468656D2066726F6D20616E64206D6179207573652074686174206461746120666F7220616E616C79746963732C206C6F6767696E672C206F72206F';
wwv_flow_imp.g_varchar2_table(6308) := '7074696D697A65642063616368696E672C20666F72206578616D706C652E2229206865616465722077696C6C206E6F742062652073656E7420746F205B6F726967696E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F65';
wwv_flow_imp.g_varchar2_table(6309) := '6E2D55532F646F63732F476C6F73736172792F6F726967696E20226F726967696E3A2057656220636F6E74656E745C2773206F726967696E20697320646566696E65642062792074686520736368656D65202870726F746F636F6C292C20686F73742028';
wwv_flow_imp.g_varchar2_table(6310) := '646F6D61696E292C20616E6420706F7274206F66207468652055524C207573656420746F206163636573732069742E2054776F206F626A656374732068617665207468652073616D65206F726967696E206F6E6C79207768656E2074686520736368656D';
wwv_flow_imp.g_varchar2_table(6311) := '652C20686F73742C20616E6420706F727420616C6C206D617463682E22297320776974686F7574205B544C535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F544C5320';
wwv_flow_imp.g_varchar2_table(6312) := '22544C533A205472616E73706F7274204C617965722053656375726974792028544C53292C2070726576696F75736C79206B6E6F776E2061732053656375726520536F636B657473204C61796572202853534C292C20697320612070726F746F636F6C20';
wwv_flow_imp.g_varchar2_table(6313) := '75736564206279206170706C69636174696F6E7320746F20636F6D6D756E6963617465207365637572656C79206163726F73732061206E6574776F726B2C2070726576656E74696E672074616D706572696E67207769746820616E642065617665736472';
wwv_flow_imp.g_varchar2_table(6314) := '6F7070696E67206F6E20656D61696C2C207765622062726F7773696E672C206D6573736167696E672C20616E64206F746865722070726F746F636F6C732E222920285B48545450535D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E';
wwv_flow_imp.g_varchar2_table(6315) := '6F72672F656E2D55532F646F63732F476C6F73736172792F4854545053202248545450533A204854545053202848545450205365637572652920697320616E20656E637279707465642076657273696F6E206F662074686520485454502070726F746F63';
wwv_flow_imp.g_varchar2_table(6316) := '6F6C2E20497420757375616C6C7920757365732053534C206F7220544C5320746F20656E637279707420616C6C20636F6D6D756E69636174696F6E206265747765656E206120636C69656E7420616E642061207365727665722E20546869732073656375';
wwv_flow_imp.g_varchar2_table(6317) := '726520636F6E6E656374696F6E20616C6C6F777320636C69656E747320746F20736166656C792065786368616E67652073656E736974697665206461746120776974682061207365727665722C20666F72206578616D706C6520666F722062616E6B696E';
wwv_flow_imp.g_varchar2_table(6318) := '672061637469766974696573206F72206F6E6C696E652073686F7070696E672E2229292E5C6E2A202020606F726967696E603A205468652073656E742072656665727265722077696C6C206265206C696D6974656420746F20746865206F726967696E20';
wwv_flow_imp.g_varchar2_table(6319) := '6F662074686520726566657272696E6720706167653A20697473205B736368656D655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F417263686976652F4D6F7A696C6C612F55524953636865';
wwv_flow_imp.g_varchar2_table(6320) := '6D65292C205B686F73745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F476C6F73736172792F686F73742022686F73743A204120686F737420697320612064657669636520636F6E6E656374';
wwv_flow_imp.g_varchar2_table(6321) := '656420746F2074686520496E7465726E657420286F722061206C6F63616C206E6574776F726B292E20536F6D6520686F7374732063616C6C65642073657276657273206F66666572206164646974696F6E616C207365727669636573206C696B65207365';
wwv_flow_imp.g_varchar2_table(6322) := '7276696E67207765627061676573206F722073746F72696E672066696C657320616E6420656D61696C732E22292C20616E64205B706F72745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F47';
wwv_flow_imp.g_varchar2_table(6323) := '6C6F73736172792F706F72742022706F72743A20466F72206120636F6D707574657220636F6E6E656374656420746F2061206E6574776F726B207769746820616E20495020616464726573732C206120706F7274206973206120636F6D6D756E69636174';
wwv_flow_imp.g_varchar2_table(6324) := '696F6E20656E64706F696E742E20506F727473206172652064657369676E61746564206279206E756D626572732C20616E642062656C6F772031303234206561636820706F7274206973206173736F6369617465642062792064656661756C7420776974';
wwv_flow_imp.g_varchar2_table(6325) := '6820612073706563696669632070726F746F636F6C2E22292E5C6E2A202020606F726967696E2D7768656E2D63726F73732D6F726967696E603A205468652072656665727265722073656E7420746F206F74686572206F726967696E732077696C6C2062';
wwv_flow_imp.g_varchar2_table(6326) := '65206C696D6974656420746F2074686520736368656D652C2074686520686F73742C20616E642074686520706F72742E204E617669676174696F6E73206F6E207468652073616D65206F726967696E2077696C6C207374696C6C20696E636C7564652074';
wwv_flow_imp.g_varchar2_table(6327) := '686520706174682E5C6E2A2020206073616D652D6F726967696E603A20412072656665727265722077696C6C2062652073656E7420666F72205B73616D65206F726967696E5D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F7267';
wwv_flow_imp.g_varchar2_table(6328) := '2F656E2D55532F646F63732F476C6F73736172792F53616D652D6F726967696E5F706F6C696379202273616D65206F726967696E3A205468652073616D652D6F726967696E20706F6C696379206973206120637269746963616C20736563757269747920';
wwv_flow_imp.g_varchar2_table(6329) := '6D656368616E69736D20746861742072657374726963747320686F77206120646F63756D656E74206F7220736372697074206C6F616465642066726F6D206F6E65206F726967696E2063616E20696E74657261637420776974682061207265736F757263';
wwv_flow_imp.g_varchar2_table(6330) := '652066726F6D20616E6F74686572206F726967696E2E22292C206275742063726F73732D6F726967696E2072657175657374732077696C6C20636F6E7461696E206E6F20726566657272657220696E666F726D6174696F6E2E5C6E2A2020206073747269';
wwv_flow_imp.g_varchar2_table(6331) := '63742D6F726967696E603A204F6E6C792073656E6420746865206F726967696E206F662074686520646F63756D656E7420617320746865207265666572726572207768656E207468652070726F746F636F6C207365637572697479206C6576656C207374';
wwv_flow_imp.g_varchar2_table(6332) := '617973207468652073616D652028652E672E204854545053E286924854545053292C2062757420646F6E5C27742073656E6420697420746F2061206C657373207365637572652064657374696E6174696F6E2028652E672E204854545053E28692485454';
wwv_flow_imp.g_varchar2_table(6333) := '50292E5C6E2A202020607374726963742D6F726967696E2D7768656E2D63726F73732D6F726967696E603A2053656E6420612066756C6C2055524C207768656E20706572666F726D696E6720612073616D652D6F726967696E20726571756573742C2062';
wwv_flow_imp.g_varchar2_table(6334) := '7574206F6E6C792073656E6420746865206F726967696E207768656E207468652070726F746F636F6C207365637572697479206C6576656C207374617973207468652073616D652028652E672E4854545053E286924854545053292C20616E642073656E';
wwv_flow_imp.g_varchar2_table(6335) := '64206E6F2068656164657220746F2061206C657373207365637572652064657374696E6174696F6E2028652E672E204854545053E2869248545450292E5C6E2A20202060756E736166652D75726C603A205468652072656665727265722077696C6C2069';
wwv_flow_imp.g_varchar2_table(6336) := '6E636C75646520746865206F726967696E205F616E645F2074686520706174682028627574206E6F7420746865205B667261676D656E745D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765';
wwv_flow_imp.g_varchar2_table(6337) := '622F4150492F48544D4C48797065726C696E6B456C656D656E745574696C732F68617368292C205B70617373776F72645D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48';
wwv_flow_imp.g_varchar2_table(6338) := '544D4C48797065726C696E6B456C656D656E745574696C732F70617373776F7264292C206F72205B757365726E616D655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48';
wwv_flow_imp.g_varchar2_table(6339) := '544D4C48797065726C696E6B456C656D656E745574696C732F757365726E616D6529292E202A2A546869732076616C756520697320756E736166652A2A2C2062656361757365206974206C65616B73206F726967696E7320616E64207061746873206672';
wwv_flow_imp.g_varchar2_table(6340) := '6F6D20544C532D70726F746563746564207265736F757263657320746F20696E736563757265206F726967696E732E5C6E5C6E2A2A4E6F74652A2A3A20416E20656D70747920737472696E672076616C75652028602222602920697320626F7468207468';
wwv_flow_imp.g_varchar2_table(6341) := '652064656661756C742076616C75652C20616E6420612066616C6C6261636B2076616C756520696620607265666572726572706F6C69637960206973206E6F7420737570706F727465642E20496620607265666572726572706F6C69637960206973206E';
wwv_flow_imp.g_varchar2_table(6342) := '6F74206578706C696369746C7920737065636966696564206F6E2074686520603C7363726970743E6020656C656D656E742C2069742077696C6C2061646F70742061206869676865722D6C6576656C20726566657272657220706F6C6963792C20692E65';
wwv_flow_imp.g_varchar2_table(6343) := '2E206F6E6520736574206F6E207468652077686F6C6520646F63756D656E74206F7220646F6D61696E2E2049662061206869676865722D6C6576656C20706F6C696379206973206E6F7420617661696C61626C652CC2A074686520656D70747920737472';
wwv_flow_imp.g_varchar2_table(6344) := '696E672069732074726561746564206173206265696E67206571756976616C656E7420746F20606E6F2D72656665727265722D7768656E2D646F776E6772616465602E277D2C7B6E616D653A2274657874222C6465736372697074696F6E3A224C696B65';
wwv_flow_imp.g_varchar2_table(6345) := '20746865206074657874436F6E74656E7460206174747269627574652C207468697320617474726962757465207365747320746865207465787420636F6E74656E74206F662074686520656C656D656E742E20556E6C696B652074686520607465787443';
wwv_flow_imp.g_varchar2_table(6346) := '6F6E74656E7460206174747269627574652C20686F77657665722C207468697320617474726962757465206973206576616C75617465642061732065786563757461626C6520636F646520616674657220746865206E6F646520697320696E7365727465';
wwv_flow_imp.g_varchar2_table(6347) := '6420696E746F2074686520444F4D2E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D';
wwv_flow_imp.g_varchar2_table(6348) := '4C2F456C656D656E742F736372697074227D5D7D2C7B6E616D653A226E6F736372697074222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206E6F73637269707420656C656D656E74207265707265';
wwv_flow_imp.g_varchar2_table(6349) := '73656E7473206E6F7468696E6720696620736372697074696E6720697320656E61626C65642C20616E6420726570726573656E747320697473206368696C6472656E20696620736372697074696E672069732064697361626C65642E2049742069732075';
wwv_flow_imp.g_varchar2_table(6350) := '73656420746F2070726573656E7420646966666572656E74206D61726B757020746F2075736572206167656E7473207468617420737570706F727420736372697074696E6720616E642074686F7365207468617420646F6E277420737570706F72742073';
wwv_flow_imp.g_varchar2_table(6351) := '6372697074696E672C20627920616666656374696E6720686F772074686520646F63756D656E74206973207061727365642E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E636522';
wwv_flow_imp.g_varchar2_table(6352) := '2C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F6E6F736372697074227D5D7D2C7B6E616D653A2274656D706C617465222C6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(6353) := '7B6B696E643A226D61726B646F776E222C76616C75653A225468652074656D706C61746520656C656D656E74206973207573656420746F206465636C61726520667261676D656E7473206F662048544D4C20746861742063616E20626520636C6F6E6564';
wwv_flow_imp.g_varchar2_table(6354) := '20616E6420696E73657274656420696E2074686520646F63756D656E74206279207363726970742E227D2C617474726962757465733A5B5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470';
wwv_flow_imp.g_varchar2_table(6355) := '733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F74656D706C617465227D5D7D2C7B6E616D653A2263616E766173222C6465736372697074696F6E3A7B6B696E643A226D61726B64';
wwv_flow_imp.g_varchar2_table(6356) := '6F776E222C76616C75653A225468652063616E76617320656C656D656E742070726F7669646573207363726970747320776974682061207265736F6C7574696F6E2D646570656E64656E74206269746D61702063616E7661732C2077686963682063616E';
wwv_flow_imp.g_varchar2_table(6357) := '206265207573656420666F722072656E646572696E67206772617068732C2067616D652067726170686963732C206172742C206F72206F746865722076697375616C20696D61676573206F6E2074686520666C792E227D2C617474726962757465733A5B';
wwv_flow_imp.g_varchar2_table(6358) := '7B6E616D653A227769647468222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207769647468206F662074686520636F6F7264696E61746520737061636520696E2043535320706978656C732E2044';
wwv_flow_imp.g_varchar2_table(6359) := '656661756C747320746F203330302E227D7D2C7B6E616D653A22686569676874222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520686569676874206F662074686520636F6F7264696E6174652073';
wwv_flow_imp.g_varchar2_table(6360) := '7061636520696E2043535320706978656C732E2044656661756C747320746F203135302E227D7D2C7B6E616D653A226D6F7A2D6F7061717565222C6465736372697074696F6E3A224C657473207468652063616E766173206B6E6F772077686574686572';
wwv_flow_imp.g_varchar2_table(6361) := '206F72206E6F74207472616E736C7563656E63792077696C6C206265206120666163746F722E204966207468652063616E766173206B6E6F77732074686572652773206E6F207472616E736C7563656E63792C207061696E74696E6720706572666F726D';
wwv_flow_imp.g_varchar2_table(6362) := '616E63652063616E206265206F7074696D697A65642E2054686973206973206F6E6C7920737570706F72746564206279204D6F7A696C6C612D62617365642062726F77736572733B2075736520746865207374616E64617264697A6564205B6063616E76';
wwv_flow_imp.g_varchar2_table(6363) := '61732E676574436F6E7465787428273264272C207B20616C7068613A2066616C7365207D29605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F48544D4C43616E76617345';
wwv_flow_imp.g_varchar2_table(6364) := '6C656D656E742F676574436F6E74657874205C225468652048544D4C43616E766173456C656D656E742E676574436F6E746578742829206D6574686F642072657475726E7320612064726177696E6720636F6E74657874206F6E207468652063616E7661';
wwv_flow_imp.g_varchar2_table(6365) := '732C206F72206E756C6C2069662074686520636F6E74657874206964656E746966696572206973206E6F7420737570706F727465642E5C222920696E73746561642E227D5D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E';
wwv_flow_imp.g_varchar2_table(6366) := '6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F456C656D656E742F63616E766173227D5D7D5D2C676C6F62616C417474726962757465733A5B7B6E616D653A226163';
wwv_flow_imp.g_varchar2_table(6367) := '636573736B6579222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2250726F766964657320612068696E7420666F722067656E65726174696E672061206B6579626F6172642073686F727463757420666F7220';
wwv_flow_imp.g_varchar2_table(6368) := '7468652063757272656E7420656C656D656E742E20546869732061747472696275746520636F6E7369737473206F6620612073706163652D736570617261746564206C697374206F6620636861726163746572732E205468652062726F77736572207368';
wwv_flow_imp.g_varchar2_table(6369) := '6F756C642075736520746865206669727374206F6E65207468617420657869737473206F6E2074686520636F6D7075746572206B6579626F617264206C61796F75742E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E';
wwv_flow_imp.g_varchar2_table(6370) := '6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6163636573736B6579227D5D7D2C7B6E616D653A226175746F63617069';
wwv_flow_imp.g_varchar2_table(6371) := '74616C697A65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22436F6E74726F6C73207768657468657220616E6420686F77207465787420696E707574206973206175746F6D61746963616C6C7920636170';
wwv_flow_imp.g_varchar2_table(6372) := '6974616C697A656420617320697420697320656E74657265642F6564697465642062792074686520757365722E2049742063616E20686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A202020606F666660206F7220606E6F6E';
wwv_flow_imp.g_varchar2_table(6373) := '65602C206E6F206175746F6361706974616C697A6174696F6E206973206170706C6965642028616C6C206C6574746572732064656661756C7420746F206C6F77657263617365295C6E2A202020606F6E60206F72206073656E74656E636573602C207468';
wwv_flow_imp.g_varchar2_table(6374) := '65206669727374206C6574746572206F6620656163682073656E74656E63652064656661756C747320746F2061206361706974616C206C65747465723B20616C6C206F74686572206C6574746572732064656661756C7420746F206C6F77657263617365';
wwv_flow_imp.g_varchar2_table(6375) := '5C6E2A20202060776F726473602C20746865206669727374206C6574746572206F66206561636820776F72642064656661756C747320746F2061206361706974616C206C65747465723B20616C6C206F74686572206C6574746572732064656661756C74';
wwv_flow_imp.g_varchar2_table(6376) := '20746F206C6F776572636173655C6E2A2020206063686172616374657273602C20616C6C206C6574746572732073686F756C642064656661756C7420746F20757070657263617365227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265';
wwv_flow_imp.g_varchar2_table(6377) := '666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6175746F6361706974616C697A65227D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6378) := '3A22636C617373222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27412073706163652D736570617261746564206C697374206F662074686520636C6173736573206F662074686520656C656D656E742E2043';
wwv_flow_imp.g_varchar2_table(6379) := '6C617373657320616C6C6F77732043535320616E64204A61766153637269707420746F2073656C65637420616E642061636365737320737065636966696320656C656D656E74732076696120746865205B636C6173732073656C6563746F72735D282F65';
wwv_flow_imp.g_varchar2_table(6380) := '6E2D55532F646F63732F5765622F4353532F436C6173735F73656C6563746F727329206F722066756E6374696F6E73206C696B6520746865206D6574686F64205B60446F63756D656E742E676574456C656D656E74734279436C6173734E616D65282960';
wwv_flow_imp.g_varchar2_table(6381) := '5D282F656E2D55532F646F63732F5765622F4150492F446F63756D656E742F676574456C656D656E74734279436C6173734E616D65202272657475726E7320616E2061727261792D6C696B65206F626A656374206F6620616C6C206368696C6420656C65';
wwv_flow_imp.g_varchar2_table(6382) := '6D656E7473207768696368206861766520616C6C206F662074686520676976656E20636C617373206E616D65732E22292E277D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F64';
wwv_flow_imp.g_varchar2_table(6383) := '6576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F636C617373227D5D7D2C7B6E616D653A22636F6E74656E746564697461626C65222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(6384) := '6B696E643A226D61726B646F776E222C76616C75653A22416E20656E756D6572617465642061747472696275746520696E6469636174696E672069662074686520656C656D656E742073686F756C64206265206564697461626C65206279207468652075';
wwv_flow_imp.g_varchar2_table(6385) := '7365722E20496620736F2C207468652062726F77736572206D6F646966696573206974732077696467657420746F20616C6C6F772065646974696E672E2054686520617474726962757465206D7573742074616B65206F6E65206F662074686520666F6C';
wwv_flow_imp.g_varchar2_table(6386) := '6C6F77696E672076616C7565733A5C6E5C6E2A202020607472756560206F7220746865205F656D70747920737472696E675F2C20776869636820696E6469636174657320746861742074686520656C656D656E74206D757374206265206564697461626C';
wwv_flow_imp.g_varchar2_table(6387) := '653B5C6E2A2020206066616C7365602C20776869636820696E6469636174657320746861742074686520656C656D656E74206D757374206E6F74206265206564697461626C652E227D2C7265666572656E6365733A5B7B6E616D653A224D444E20526566';
wwv_flow_imp.g_varchar2_table(6388) := '6572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F636F6E74656E746564697461626C65227D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6389) := '3A22636F6E746578746D656E75222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2754686520605B2A2A69642A2A5D2823617474722D69642960206F662061205B603C6D656E753E605D282F656E2D55532F64';
wwv_flow_imp.g_varchar2_table(6390) := '6F63732F5765622F48544D4C2F456C656D656E742F6D656E7520225468652048544D4C203C6D656E753E20656C656D656E7420726570726573656E747320612067726F7570206F6620636F6D6D616E64732074686174206120757365722063616E207065';
wwv_flow_imp.g_varchar2_table(6391) := '72666F726D206F722061637469766174652E205468697320696E636C7564657320626F7468206C697374206D656E75732C207768696368206D6967687420617070656172206163726F73732074686520746F70206F6620612073637265656E2C20617320';
wwv_flow_imp.g_varchar2_table(6392) := '77656C6C20617320636F6E74657874206D656E75732C20737563682061732074686F73652074686174206D696768742061707065617220756E6465726E65617468206120627574746F6E20616674657220697420686173206265656E20636C69636B6564';
wwv_flow_imp.g_varchar2_table(6393) := '2E222920746F207573652061732074686520636F6E7465787475616C206D656E7520666F72207468697320656C656D656E742E277D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F';
wwv_flow_imp.g_varchar2_table(6394) := '2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F636F6E746578746D656E75227D5D7D2C7B6E616D653A22646972222C6465736372697074696F6E3A7B6B696E64';
wwv_flow_imp.g_varchar2_table(6395) := '3A226D61726B646F776E222C76616C75653A22416E20656E756D6572617465642061747472696275746520696E6469636174696E672074686520646972656374696F6E616C697479206F662074686520656C656D656E74277320746578742E2049742063';
wwv_flow_imp.g_varchar2_table(6396) := '616E20686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A202020606C7472602C207768696368206D65616E73205F6C65667420746F2072696768745F20616E6420697320746F206265207573656420666F72206C616E677561';
wwv_flow_imp.g_varchar2_table(6397) := '676573207468617420617265207772697474656E2066726F6D20746865206C65667420746F2074686520726967687420286C696B6520456E676C697368293B5C6E2A2020206072746C602C207768696368206D65616E73205F726967687420746F206C65';
wwv_flow_imp.g_varchar2_table(6398) := '66745F20616E6420697320746F206265207573656420666F72206C616E677561676573207468617420617265207772697474656E2066726F6D2074686520726967687420746F20746865206C65667420286C696B6520417261626963293B5C6E2A202020';
wwv_flow_imp.g_varchar2_table(6399) := '606175746F602C207768696368206C657473207468652075736572206167656E74206465636964652E2049742075736573206120626173696320616C676F726974686D2061732069742070617273657320746865206368617261637465727320696E7369';
wwv_flow_imp.g_varchar2_table(6400) := '64652074686520656C656D656E7420756E74696C2069742066696E647320612063686172616374657220776974682061207374726F6E6720646972656374696F6E616C6974792C207468656E206974206170706C69657320746861742064697265637469';
wwv_flow_imp.g_varchar2_table(6401) := '6F6E616C69747920746F207468652077686F6C6520656C656D656E742E227D2C76616C75655365743A2264222C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065';
wwv_flow_imp.g_varchar2_table(6402) := '722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F646972227D5D7D2C7B6E616D653A22647261676761626C65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(6403) := '2C76616C75653A22416E20656E756D6572617465642061747472696275746520696E6469636174696E6720776865746865722074686520656C656D656E742063616E20626520647261676765642C207573696E6720746865205B4472616720616E642044';
wwv_flow_imp.g_varchar2_table(6404) := '726F70204150495D282F656E2D75732F646F63732F4472616744726F702F447261675F616E645F44726F70292E2049742063616E20686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A2020206074727565602C207768696368';
wwv_flow_imp.g_varchar2_table(6405) := '20696E6469636174657320746861742074686520656C656D656E74206D617920626520647261676765645C6E2A2020206066616C7365602C20776869636820696E6469636174657320746861742074686520656C656D656E74206D6179206E6F74206265';
wwv_flow_imp.g_varchar2_table(6406) := '20647261676765642E227D2C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F57';
wwv_flow_imp.g_varchar2_table(6407) := '65622F48544D4C2F476C6F62616C5F617474726962757465732F647261676761626C65227D5D7D2C7B6E616D653A2264726F707A6F6E65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20656E756D';
wwv_flow_imp.g_varchar2_table(6408) := '6572617465642061747472696275746520696E6469636174696E672077686174207479706573206F6620636F6E74656E742063616E2062652064726F70706564206F6E20616E20656C656D656E742C207573696E6720746865205B4472616720616E6420';
wwv_flow_imp.g_varchar2_table(6409) := '44726F70204150495D282F656E2D55532F646F63732F4472616744726F702F447261675F616E645F44726F70292E2049742063616E20686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A20202060636F7079602C2077686963';
wwv_flow_imp.g_varchar2_table(6410) := '6820696E6469636174657320746861742064726F7070696E672077696C6C20637265617465206120636F7079206F662074686520656C656D656E7420746861742077617320647261676765645C6E2A202020606D6F7665602C20776869636820696E6469';
wwv_flow_imp.g_varchar2_table(6411) := '636174657320746861742074686520656C656D656E7420746861742077617320647261676765642077696C6C206265206D6F76656420746F2074686973206E6577206C6F636174696F6E2E5C6E2A202020606C696E6B602C2077696C6C20637265617465';
wwv_flow_imp.g_varchar2_table(6412) := '2061206C696E6B20746F20746865206472616767656420646174612E227D7D2C7B6E616D653A226578706F72747061727473222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225573656420746F207472616E';
wwv_flow_imp.g_varchar2_table(6413) := '7369746976656C79206578706F727420736861646F772070617274732066726F6D2061206E657374656420736861646F77207472656520696E746F206120636F6E7461696E696E67206C6967687420747265652E227D2C7265666572656E6365733A5B7B';
wwv_flow_imp.g_varchar2_table(6414) := '6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6578706F7274706172747322';
wwv_flow_imp.g_varchar2_table(6415) := '7D5D7D2C7B6E616D653A2268696464656E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120426F6F6C65616E2061747472696275746520696E6469636174657320746861742074686520656C656D656E';
wwv_flow_imp.g_varchar2_table(6416) := '74206973206E6F74207965742C206F72206973206E6F206C6F6E6765722C205F72656C6576616E745F2E20466F72206578616D706C652C2069742063616E206265207573656420746F206869646520656C656D656E7473206F6620746865207061676520';
wwv_flow_imp.g_varchar2_table(6417) := '746861742063616E2774206265207573656420756E74696C20746865206C6F67696E2070726F6365737320686173206265656E20636F6D706C657465642E205468652062726F7773657220776F6E27742072656E646572207375636820656C656D656E74';
wwv_flow_imp.g_varchar2_table(6418) := '732E205468697320617474726962757465206D757374206E6F74206265207573656420746F206869646520636F6E74656E74207468617420636F756C64206C65676974696D6174656C792062652073686F776E2E227D2C76616C75655365743A2276222C';
wwv_flow_imp.g_varchar2_table(6419) := '7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F61747472696275746573';
wwv_flow_imp.g_varchar2_table(6420) := '2F68696464656E227D5D7D2C7B6E616D653A226964222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E6573206120756E69717565206964656E7469666965722028494429207768696368206D75';
wwv_flow_imp.g_varchar2_table(6421) := '737420626520756E6971756520696E207468652077686F6C6520646F63756D656E742E2049747320707572706F736520697320746F206964656E746966792074686520656C656D656E74207768656E206C696E6B696E6720287573696E67206120667261';
wwv_flow_imp.g_varchar2_table(6422) := '676D656E74206964656E746966696572292C20736372697074696E672C206F72207374796C696E6720287769746820435353292E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A';
wwv_flow_imp.g_varchar2_table(6423) := '2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6964227D5D7D2C7B6E616D653A22696E7075746D6F6465222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6424) := '6D61726B646F776E222C76616C75653A2750726F766964657320612068696E7420746F2062726F777365727320617320746F207468652074797065206F66207669727475616C206B6579626F61726420636F6E66696775726174696F6E20746F20757365';
wwv_flow_imp.g_varchar2_table(6425) := '207768656E2065646974696E67207468697320656C656D656E74206F722069747320636F6E74656E74732E2055736564207072696D6172696C79206F6E205B603C696E7075743E605D282F656E2D55532F646F63732F5765622F48544D4C2F456C656D65';
wwv_flow_imp.g_varchar2_table(6426) := '6E742F696E70757420225468652048544D4C203C696E7075743E20656C656D656E74206973207573656420746F2063726561746520696E74657261637469766520636F6E74726F6C7320666F72207765622D626173656420666F726D7320696E206F7264';
wwv_flow_imp.g_varchar2_table(6427) := '657220746F2061636365707420646174612066726F6D2074686520757365723B206120776964652076617269657479206F66207479706573206F6620696E707574206461746120616E6420636F6E74726F6C20776964676574732061726520617661696C';
wwv_flow_imp.g_varchar2_table(6428) := '61626C652C20646570656E64696E67206F6E207468652064657669636520616E642075736572206167656E742E222920656C656D656E74732C2062757420697320757361626C65206F6E20616E7920656C656D656E74207768696C6520696E20605B636F';
wwv_flow_imp.g_varchar2_table(6429) := '6E74656E746564697461626C655D282F656E2D55532F646F63732F5765622F48544D4C2F476C6F62616C5F6174747269627574657323617474722D636F6E74656E746564697461626C652960206D6F64652E277D2C7265666572656E6365733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(6430) := '6D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F696E7075746D6F6465227D5D7D2C';
wwv_flow_imp.g_varchar2_table(6431) := '7B6E616D653A226973222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416C6C6F777320796F7520746F207370656369667920746861742061207374616E646172642048544D4C20656C656D656E74207368';
wwv_flow_imp.g_varchar2_table(6432) := '6F756C6420626568617665206C696B652061207265676973746572656420637573746F6D206275696C742D696E20656C656D656E742028736565205B5573696E6720637573746F6D20656C656D656E74735D282F656E2D55532F646F63732F5765622F57';
wwv_flow_imp.g_varchar2_table(6433) := '65625F436F6D706F6E656E74732F5573696E675F637573746F6D5F656C656D656E74732920666F72206D6F72652064657461696C73292E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A22687474';
wwv_flow_imp.g_varchar2_table(6434) := '70733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6973227D5D7D2C7B6E616D653A226974656D6964222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6435) := '6D61726B646F776E222C76616C75653A2254686520756E697175652C20676C6F62616C206964656E746966696572206F6620616E206974656D2E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A22';
wwv_flow_imp.g_varchar2_table(6436) := '68747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6974656D6964227D5D7D2C7B6E616D653A226974656D70726F70222C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(6437) := '6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225573656420746F206164642070726F7065727469657320746F20616E206974656D2E2045766572792048544D4C20656C656D656E74206D6179206861766520616E20606974656D70726F';
wwv_flow_imp.g_varchar2_table(6438) := '706020617474726962757465207370656369666965642C20776865726520616E20606974656D70726F706020636F6E7369737473206F662061206E616D6520616E642076616C756520706169722E227D2C7265666572656E6365733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(6439) := '4D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6974656D70726F70227D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6440) := '3A226974656D726566222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2250726F70657274696573207468617420617265206E6F742064657363656E64616E7473206F6620616E20656C656D656E7420776974';
wwv_flow_imp.g_varchar2_table(6441) := '682074686520606974656D73636F706560206174747269627574652063616E206265206173736F636961746564207769746820746865206974656D207573696E6720616E20606974656D726566602E2049742070726F76696465732061206C697374206F';
wwv_flow_imp.g_varchar2_table(6442) := '6620656C656D656E742069647320286E6F7420606974656D69646073292077697468206164646974696F6E616C2070726F7065727469657320656C7365776865726520696E2074686520646F63756D656E742E227D2C7265666572656E6365733A5B7B6E';
wwv_flow_imp.g_varchar2_table(6443) := '616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6974656D726566227D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(6444) := '6E616D653A226974656D73636F7065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22606974656D73636F7065602028757375616C6C792920776F726B7320616C6F6E67207769746820605B6974656D7479';
wwv_flow_imp.g_varchar2_table(6445) := '70655D282F656E2D55532F646F63732F5765622F48544D4C2F476C6F62616C5F6174747269627574657323617474722D6974656D74797065296020746F20737065636966792074686174207468652048544D4C20636F6E7461696E656420696E20612062';
wwv_flow_imp.g_varchar2_table(6446) := '6C6F636B2069732061626F7574206120706172746963756C6172206974656D2E20606974656D73636F706560206372656174657320746865204974656D20616E6420646566696E6573207468652073636F7065206F662074686520606974656D74797065';
wwv_flow_imp.g_varchar2_table(6447) := '60206173736F63696174656420776974682069742E20606974656D747970656020697320612076616C69642055524C206F66206120766F636162756C617279202873756368206173205B736368656D612E6F72675D2868747470733A2F2F736368656D61';
wwv_flow_imp.g_varchar2_table(6448) := '2E6F72672F292920746861742064657363726962657320746865206974656D20616E64206974732070726F7065727469657320636F6E746578742E227D2C76616C75655365743A2276222C7265666572656E6365733A5B7B6E616D653A224D444E205265';
wwv_flow_imp.g_varchar2_table(6449) := '666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6974656D73636F7065227D5D7D2C7B6E616D653A22697465';
wwv_flow_imp.g_varchar2_table(6450) := '6D74797065222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22537065636966696573207468652055524C206F662074686520766F636162756C61727920746861742077696C6C206265207573656420746F20';
wwv_flow_imp.g_varchar2_table(6451) := '646566696E6520606974656D70726F70607320286974656D2070726F706572746965732920696E207468652064617461207374727563747572652E20605B6974656D73636F70655D282F656E2D55532F646F63732F5765622F48544D4C2F476C6F62616C';
wwv_flow_imp.g_varchar2_table(6452) := '5F6174747269627574657323617474722D6974656D73636F70652960206973207573656420746F20736574207468652073636F7065206F6620776865726520696E207468652064617461207374727563747572652074686520766F636162756C61727920';
wwv_flow_imp.g_varchar2_table(6453) := '73657420627920606974656D74797065602077696C6C206265206163746976652E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C61';
wwv_flow_imp.g_varchar2_table(6454) := '2E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F6974656D74797065227D5D7D2C7B6E616D653A226C616E67222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2248';
wwv_flow_imp.g_varchar2_table(6455) := '656C707320646566696E6520746865206C616E6775616765206F6620616E20656C656D656E743A20746865206C616E67756167652074686174206E6F6E2D6564697461626C6520656C656D656E74732061726520696E2C206F7220746865206C616E6775';
wwv_flow_imp.g_varchar2_table(6456) := '6167652074686174206564697461626C6520656C656D656E74732073686F756C64206265207772697474656E20696E2062792074686520757365722E205468652061747472696275746520636F6E7461696E73206F6E6520E2809C6C616E677561676520';
wwv_flow_imp.g_varchar2_table(6457) := '746167E2809D20286D616465206F662068797068656E2D73657061726174656420E2809C6C616E67756167652073756274616773E2809D2920696E2074686520666F726D617420646566696E656420696E205B5F5461677320666F72204964656E746966';
wwv_flow_imp.g_varchar2_table(6458) := '79696E67204C616E67756167657320284243503437295F5D2868747470733A2F2F7777772E696574662E6F72672F7266632F6263702F62637034372E747874292E205B2A2A786D6C3A6C616E672A2A5D2823617474722D786D6C3A6C616E672920686173';
wwv_flow_imp.g_varchar2_table(6459) := '207072696F72697479206F7665722069742E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48';
wwv_flow_imp.g_varchar2_table(6460) := '544D4C2F476C6F62616C5F617474726962757465732F6C616E67227D5D7D2C7B6E616D653A2270617274222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27412073706163652D736570617261746564206C69';
wwv_flow_imp.g_varchar2_table(6461) := '7374206F66207468652070617274206E616D6573206F662074686520656C656D656E742E2050617274206E616D657320616C6C6F77732043535320746F2073656C65637420616E64207374796C6520737065636966696320656C656D656E747320696E20';
wwv_flow_imp.g_varchar2_table(6462) := '6120736861646F7720747265652076696120746865205B603A3A70617274605D282F656E2D55532F646F63732F5765622F4353532F3A3A706172742022546865203A3A70617274204353532070736575646F2D656C656D656E7420726570726573656E74';
wwv_flow_imp.g_varchar2_table(6463) := '7320616E7920656C656D656E742077697468696E206120736861646F7720747265652074686174206861732061206D61746368696E672070617274206174747269627574652E22292070736575646F2D656C656D656E742E277D2C7265666572656E6365';
wwv_flow_imp.g_varchar2_table(6464) := '733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F70617274227D5D7D';
wwv_flow_imp.g_varchar2_table(6465) := '2C7B6E616D653A22726F6C65222C76616C75655365743A22726F6C6573227D2C7B6E616D653A22736C6F74222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241737369676E73206120736C6F7420696E2061';
wwv_flow_imp.g_varchar2_table(6466) := '205B736861646F7720444F4D5D282F656E2D55532F646F63732F5765622F5765625F436F6D706F6E656E74732F536861646F775F444F4D2920736861646F77207472656520746F20616E20656C656D656E743A20416E20656C656D656E74207769746820';
wwv_flow_imp.g_varchar2_table(6467) := '612060736C6F7460206174747269627574652069732061737369676E656420746F2074686520736C6F74206372656174656420627920746865205B603C736C6F743E605D282F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F736C';
wwv_flow_imp.g_varchar2_table(6468) := '6F74205C225468652048544D4C203C736C6F743E20656C656D656E74E2809470617274206F66207468652057656220436F6D706F6E656E747320746563686E6F6C6F6779207375697465E280946973206120706C616365686F6C64657220696E73696465';
wwv_flow_imp.g_varchar2_table(6469) := '20612077656220636F6D706F6E656E74207468617420796F752063616E2066696C6C207769746820796F7572206F776E206D61726B75702C207768696368206C65747320796F752063726561746520736570617261746520444F4D20747265657320616E';
wwv_flow_imp.g_varchar2_table(6470) := '642070726573656E74207468656D20746F6765746865722E5C222920656C656D656E742077686F736520605B6E616D655D282F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F736C6F7423617474722D6E616D6529602061747472';
wwv_flow_imp.g_varchar2_table(6471) := '696275746527732076616C7565206D61746368657320746861742060736C6F74602061747472696275746527732076616C75652E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A';
wwv_flow_imp.g_varchar2_table(6472) := '2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F736C6F74227D5D7D2C7B6E616D653A227370656C6C636865636B222C6465736372697074696F6E3A7B6B696E';
wwv_flow_imp.g_varchar2_table(6473) := '643A226D61726B646F776E222C76616C75653A22416E20656E756D6572617465642061747472696275746520646566696E657320776865746865722074686520656C656D656E74206D617920626520636865636B656420666F72207370656C6C696E6720';
wwv_flow_imp.g_varchar2_table(6474) := '6572726F72732E204974206D617920686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A2020206074727565602C20776869636820696E6469636174657320746861742074686520656C656D656E742073686F756C642062652C';
wwv_flow_imp.g_varchar2_table(6475) := '20696620706F737369626C652C20636865636B656420666F72207370656C6C696E67206572726F72733B5C6E2A2020206066616C7365602C20776869636820696E6469636174657320746861742074686520656C656D656E742073686F756C64206E6F74';
wwv_flow_imp.g_varchar2_table(6476) := '20626520636865636B656420666F72207370656C6C696E67206572726F72732E227D2C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C';
wwv_flow_imp.g_varchar2_table(6477) := '6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F7370656C6C636865636B227D5D7D2C7B6E616D653A227374796C65222C6465736372697074696F6E3A7B6B696E643A226D6172';
wwv_flow_imp.g_varchar2_table(6478) := '6B646F776E222C76616C75653A27436F6E7461696E73205B4353535D282F656E2D55532F646F63732F5765622F43535329207374796C696E67206465636C61726174696F6E7320746F206265206170706C69656420746F2074686520656C656D656E742E';
wwv_flow_imp.g_varchar2_table(6479) := '204E6F74652074686174206974206973207265636F6D6D656E64656420666F72207374796C657320746F20626520646566696E656420696E20612073657061726174652066696C65206F722066696C65732E20546869732061747472696275746520616E';
wwv_flow_imp.g_varchar2_table(6480) := '6420746865205B603C7374796C653E605D282F656E2D55532F646F63732F5765622F48544D4C2F456C656D656E742F7374796C6520225468652048544D4C203C7374796C653E20656C656D656E7420636F6E7461696E73207374796C6520696E666F726D';
wwv_flow_imp.g_varchar2_table(6481) := '6174696F6E20666F72206120646F63756D656E742C206F722070617274206F66206120646F63756D656E742E222920656C656D656E742068617665206D61696E6C792074686520707572706F7365206F6620616C6C6F77696E6720666F7220717569636B';
wwv_flow_imp.g_varchar2_table(6482) := '207374796C696E672C20666F72206578616D706C6520666F722074657374696E6720707572706F7365732E277D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(6483) := '65722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F7374796C65227D5D7D2C7B6E616D653A22746162696E646578222C6465736372697074696F6E3A7B6B696E643A226D61726B646F77';
wwv_flow_imp.g_varchar2_table(6484) := '6E222C76616C75653A22416E20696E74656765722061747472696275746520696E6469636174696E672069662074686520656C656D656E742063616E2074616B6520696E70757420666F63757320286973205F666F63757361626C655F292C2069662069';
wwv_flow_imp.g_varchar2_table(6485) := '742073686F756C6420706172746963697061746520746F2073657175656E7469616C206B6579626F617264206E617669676174696F6E2C20616E6420696620736F2C206174207768617420706F736974696F6E2E2049742063616E2074616B6520736576';
wwv_flow_imp.g_varchar2_table(6486) := '6572616C2076616C7565733A5C6E5C6E2A20202061205F6E656761746976652076616C75655F206D65616E7320746861742074686520656C656D656E742073686F756C6420626520666F63757361626C652C206275742073686F756C64206E6F74206265';
wwv_flow_imp.g_varchar2_table(6487) := '20726561636861626C65207669612073657175656E7469616C206B6579626F617264206E617669676174696F6E3B5C6E2A202020603060206D65616E7320746861742074686520656C656D656E742073686F756C6420626520666F63757361626C652061';
wwv_flow_imp.g_varchar2_table(6488) := '6E6420726561636861626C65207669612073657175656E7469616C206B6579626F617264206E617669676174696F6E2C20627574206974732072656C6174697665206F7264657220697320646566696E65642062792074686520706C6174666F726D2063';
wwv_flow_imp.g_varchar2_table(6489) := '6F6E76656E74696F6E3B5C6E2A20202061205F706F7369746976652076616C75655F206D65616E7320746861742074686520656C656D656E742073686F756C6420626520666F63757361626C6520616E6420726561636861626C65207669612073657175';
wwv_flow_imp.g_varchar2_table(6490) := '656E7469616C206B6579626F617264206E617669676174696F6E3B20746865206F7264657220696E2077686963682074686520656C656D656E74732061726520666F63757365642069732074686520696E6372656173696E672076616C7565206F662074';
wwv_flow_imp.g_varchar2_table(6491) := '6865205B2A2A746162696E6465782A2A5D2823617474722D746162696E646578292E204966207365766572616C20656C656D656E7473207368617265207468652073616D6520746162696E6465782C2074686569722072656C6174697665206F72646572';
wwv_flow_imp.g_varchar2_table(6492) := '20666F6C6C6F77732074686569722072656C617469766520706F736974696F6E7320696E2074686520646F63756D656E742E227D2C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F';
wwv_flow_imp.g_varchar2_table(6493) := '646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F746162696E646578227D5D7D2C7B6E616D653A227469746C65222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6494) := '6D61726B646F776E222C76616C75653A22436F6E7461696E732061207465787420726570726573656E74696E672061647669736F727920696E666F726D6174696F6E2072656C6174656420746F2074686520656C656D656E742069742062656C6F6E6773';
wwv_flow_imp.g_varchar2_table(6495) := '20746F2E205375636820696E666F726D6174696F6E2063616E207479706963616C6C792C20627574206E6F74206E65636573736172696C792C2062652070726573656E74656420746F207468652075736572206173206120746F6F6C7469702E227D2C72';
wwv_flow_imp.g_varchar2_table(6496) := '65666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D4C2F476C6F62616C5F617474726962757465732F';
wwv_flow_imp.g_varchar2_table(6497) := '7469746C65227D5D7D2C7B6E616D653A227472616E736C617465222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20656E756D6572617465642061747472696275746520746861742069732075736564';
wwv_flow_imp.g_varchar2_table(6498) := '20746F2073706563696679207768657468657220616E20656C656D656E742773206174747269627574652076616C75657320616E64207468652076616C756573206F6620697473205B6054657874605D282F656E2D55532F646F63732F5765622F415049';
wwv_flow_imp.g_varchar2_table(6499) := '2F54657874205C22546865205465787420696E7465726661636520726570726573656E747320746865207465787475616C20636F6E74656E74206F6620456C656D656E74206F7220417474722E20496620616E20656C656D656E7420686173206E6F206D';
wwv_flow_imp.g_varchar2_table(6500) := '61726B75702077697468696E2069747320636F6E74656E742C2069742068617320612073696E676C65206368696C6420696D706C656D656E74696E672054657874207468617420636F6E7461696E732074686520656C656D656E74277320746578742E20';
wwv_flow_imp.g_varchar2_table(6501) := '486F77657665722C2069662074686520656C656D656E7420636F6E7461696E73206D61726B75702C2069742069732070617273656420696E746F20696E666F726D6174696F6E206974656D7320616E642054657874206E6F646573207468617420666F72';
wwv_flow_imp.g_varchar2_table(6502) := '6D20697473206368696C6472656E2E5C2229206E6F6465206368696C6472656E2061726520746F206265207472616E736C61746564207768656E207468652070616765206973206C6F63616C697A65642C206F72207768657468657220746F206C656176';
wwv_flow_imp.g_varchar2_table(6503) := '65207468656D20756E6368616E6765642E2049742063616E20686176652074686520666F6C6C6F77696E672076616C7565733A5C6E5C6E2A202020656D70747920737472696E6720616E642060796573602C20776869636820696E646963617465732074';
wwv_flow_imp.g_varchar2_table(6504) := '6861742074686520656C656D656E742077696C6C206265207472616E736C617465642E5C6E2A202020606E6F602C20776869636820696E6469636174657320746861742074686520656C656D656E742077696C6C206E6F74206265207472616E736C6174';
wwv_flow_imp.g_varchar2_table(6505) := '65642E227D2C76616C75655365743A2279222C7265666572656E6365733A5B7B6E616D653A224D444E205265666572656E6365222C75726C3A2268747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F646F63732F5765622F48544D';
wwv_flow_imp.g_varchar2_table(6506) := '4C2F476C6F62616C5F617474726962757465732F7472616E736C617465227D5D7D2C7B6E616D653A226F6E61626F7274222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206C6F6164696E67206F66';
wwv_flow_imp.g_varchar2_table(6507) := '2061207265736F7572636520686173206265656E2061626F727465642E227D7D2C7B6E616D653A226F6E626C7572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20656C656D656E7420686173206C';
wwv_flow_imp.g_varchar2_table(6508) := '6F737420666F6375732028646F6573206E6F7420627562626C65292E227D7D2C7B6E616D653A226F6E63616E706C6179222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652075736572206167656E74';
wwv_flow_imp.g_varchar2_table(6509) := '2063616E20706C617920746865206D656469612C2062757420657374696D617465732074686174206E6F7420656E6F756768206461746120686173206265656E206C6F6164656420746F20706C617920746865206D6564696120757020746F2069747320';
wwv_flow_imp.g_varchar2_table(6510) := '656E6420776974686F757420686176696E6720746F2073746F7020666F72206675727468657220627566666572696E67206F6620636F6E74656E742E227D7D2C7B6E616D653A226F6E63616E706C61797468726F756768222C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(6511) := '3A7B6B696E643A226D61726B646F776E222C76616C75653A225468652075736572206167656E742063616E20706C617920746865206D6564696120757020746F2069747320656E6420776974686F757420686176696E6720746F2073746F7020666F7220';
wwv_flow_imp.g_varchar2_table(6512) := '6675727468657220627566666572696E67206F6620636F6E74656E742E227D7D2C7B6E616D653A226F6E6368616E6765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206368616E676520657665';
wwv_flow_imp.g_varchar2_table(6513) := '6E7420697320666972656420666F72203C696E7075743E2C203C73656C6563743E2C20616E64203C74657874617265613E20656C656D656E7473207768656E2061206368616E676520746F2074686520656C656D656E7427732076616C75652069732063';
wwv_flow_imp.g_varchar2_table(6514) := '6F6D6D69747465642062792074686520757365722E227D7D2C7B6E616D653A226F6E636C69636B222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E74696E672064657669636520627574746F';
wwv_flow_imp.g_varchar2_table(6515) := '6E20686173206265656E207072657373656420616E642072656C6561736564206F6E20616E20656C656D656E742E227D7D2C7B6E616D653A226F6E636F6E746578746D656E75222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E22';
wwv_flow_imp.g_varchar2_table(6516) := '2C76616C75653A2254686520726967687420627574746F6E206F6620746865206D6F75736520697320636C69636B656420286265666F72652074686520636F6E74657874206D656E7520697320646973706C61796564292E227D7D2C7B6E616D653A226F';
wwv_flow_imp.g_varchar2_table(6517) := '6E64626C636C69636B222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E74696E672064657669636520627574746F6E20697320636C69636B6564207477696365206F6E20616E20656C656D65';
wwv_flow_imp.g_varchar2_table(6518) := '6E742E227D7D2C7B6E616D653A226F6E64726167222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20656C656D656E74206F7220746578742073656C656374696F6E206973206265696E672064726167';
wwv_flow_imp.g_varchar2_table(6519) := '67656420286576657279203335306D73292E227D7D2C7B6E616D653A226F6E64726167656E64222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22412064726167206F7065726174696F6E206973206265696E';
wwv_flow_imp.g_varchar2_table(6520) := '6720656E646564202862792072656C656173696E672061206D6F75736520627574746F6E206F722068697474696E672074686520657363617065206B6579292E227D7D2C7B6E616D653A226F6E64726167656E746572222C6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(6521) := '7B6B696E643A226D61726B646F776E222C76616C75653A2241206472616767656420656C656D656E74206F7220746578742073656C656374696F6E20656E7465727320612076616C69642064726F70207461726765742E227D7D2C7B6E616D653A226F6E';
wwv_flow_imp.g_varchar2_table(6522) := '647261676C65617665222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241206472616767656420656C656D656E74206F7220746578742073656C656374696F6E206C656176657320612076616C6964206472';
wwv_flow_imp.g_varchar2_table(6523) := '6F70207461726765742E227D7D2C7B6E616D653A226F6E647261676F766572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20656C656D656E74206F7220746578742073656C656374696F6E206973';
wwv_flow_imp.g_varchar2_table(6524) := '206265696E672064726167676564206F76657220612076616C69642064726F702074617267657420286576657279203335306D73292E227D7D2C7B6E616D653A226F6E647261677374617274222C6465736372697074696F6E3A7B6B696E643A226D6172';
wwv_flow_imp.g_varchar2_table(6525) := '6B646F776E222C76616C75653A22546865207573657220737461727473206472616767696E6720616E20656C656D656E74206F7220746578742073656C656374696F6E2E227D7D2C7B6E616D653A226F6E64726F70222C6465736372697074696F6E3A7B';
wwv_flow_imp.g_varchar2_table(6526) := '6B696E643A226D61726B646F776E222C76616C75653A22416E20656C656D656E742069732064726F70706564206F6E20612076616C69642064726F70207461726765742E227D7D2C7B6E616D653A226F6E6475726174696F6E6368616E6765222C646573';
wwv_flow_imp.g_varchar2_table(6527) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206475726174696F6E2061747472696275746520686173206265656E20757064617465642E227D7D2C7B6E616D653A226F6E656D7074696564222C6465736372';
wwv_flow_imp.g_varchar2_table(6528) := '697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D6564696120686173206265636F6D6520656D7074793B20666F72206578616D706C652C2074686973206576656E742069732073656E7420696620746865206D65';
wwv_flow_imp.g_varchar2_table(6529) := '6469612068617320616C7265616479206265656E206C6F6164656420286F72207061727469616C6C79206C6F61646564292C20616E6420746865206C6F61642829206D6574686F642069732063616C6C656420746F2072656C6F61642069742E227D7D2C';
wwv_flow_imp.g_varchar2_table(6530) := '7B6E616D653A226F6E656E646564222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22506C61796261636B206861732073746F7070656420626563617573652074686520656E64206F6620746865206D656469';
wwv_flow_imp.g_varchar2_table(6531) := '612077617320726561636865642E227D7D2C7B6E616D653A226F6E6572726F72222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241207265736F75726365206661696C656420746F206C6F61642E227D7D2C';
wwv_flow_imp.g_varchar2_table(6532) := '7B6E616D653A226F6E666F637573222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22416E20656C656D656E742068617320726563656976656420666F6375732028646F6573206E6F7420627562626C65292E';
wwv_flow_imp.g_varchar2_table(6533) := '227D7D2C7B6E616D653A226F6E666F726D6368616E6765227D2C7B6E616D653A226F6E666F726D696E707574227D2C7B6E616D653A226F6E696E707574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254';
wwv_flow_imp.g_varchar2_table(6534) := '68652076616C7565206F6620616E20656C656D656E74206368616E676573206F722074686520636F6E74656E74206F6620616E20656C656D656E742077697468207468652061747472696275746520636F6E74656E746564697461626C65206973206D6F';
wwv_flow_imp.g_varchar2_table(6535) := '6469666965642E227D7D2C7B6E616D653A226F6E696E76616C6964222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241207375626D69747461626C6520656C656D656E7420686173206265656E2063686563';
wwv_flow_imp.g_varchar2_table(6536) := '6B656420616E6420646F65736E277420736174697366792069747320636F6E73747261696E74732E227D7D2C7B6E616D653A226F6E6B6579646F776E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120';
wwv_flow_imp.g_varchar2_table(6537) := '6B6579206973207072657373656420646F776E2E227D7D2C7B6E616D653A226F6E6B65797072657373222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241206B6579206973207072657373656420646F776E';
wwv_flow_imp.g_varchar2_table(6538) := '20616E642074686174206B6579206E6F726D616C6C792070726F64756365732061206368617261637465722076616C7565202875736520696E70757420696E7374656164292E227D7D2C7B6E616D653A226F6E6B65797570222C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(6539) := '6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241206B65792069732072656C65617365642E227D7D2C7B6E616D653A226F6E6C6F6164222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241';
wwv_flow_imp.g_varchar2_table(6540) := '207265736F7572636520616E642069747320646570656E64656E74207265736F757263657320686176652066696E6973686564206C6F6164696E672E227D7D2C7B6E616D653A226F6E6C6F6164656464617461222C6465736372697074696F6E3A7B6B69';
wwv_flow_imp.g_varchar2_table(6541) := '6E643A226D61726B646F776E222C76616C75653A22546865206669727374206672616D65206F6620746865206D65646961206861732066696E6973686564206C6F6164696E672E227D7D2C7B6E616D653A226F6E6C6F616465646D65746164617461222C';
wwv_flow_imp.g_varchar2_table(6542) := '6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865206D6574616461746120686173206265656E206C6F616465642E227D7D2C7B6E616D653A226F6E6C6F61647374617274222C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(6543) := '3A7B6B696E643A226D61726B646F776E222C76616C75653A2250726F67726573732068617320626567756E2E227D7D2C7B6E616D653A226F6E6D6F757365646F776E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C';
wwv_flow_imp.g_varchar2_table(6544) := '75653A224120706F696E74696E672064657669636520627574746F6E2028757375616C6C792061206D6F757365292069732070726573736564206F6E20616E20656C656D656E742E227D7D2C7B6E616D653A226F6E6D6F7573656D6F7665222C64657363';
wwv_flow_imp.g_varchar2_table(6545) := '72697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E74696E6720646576696365206973206D6F766564206F76657220616E20656C656D656E742E227D7D2C7B6E616D653A226F6E6D6F7573656F7574222C6465';
wwv_flow_imp.g_varchar2_table(6546) := '736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E74696E6720646576696365206973206D6F766564206F66662074686520656C656D656E7420746861742068617320746865206C697374656E65722061';
wwv_flow_imp.g_varchar2_table(6547) := '74746163686564206F72206F6666206F6E65206F6620697473206368696C6472656E2E227D7D2C7B6E616D653A226F6E6D6F7573656F766572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F69';
wwv_flow_imp.g_varchar2_table(6548) := '6E74696E6720646576696365206973206D6F766564206F6E746F2074686520656C656D656E7420746861742068617320746865206C697374656E6572206174746163686564206F72206F6E746F206F6E65206F6620697473206368696C6472656E2E227D';
wwv_flow_imp.g_varchar2_table(6549) := '7D2C7B6E616D653A226F6E6D6F7573657570222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E74696E672064657669636520627574746F6E2069732072656C6561736564206F76657220616E';
wwv_flow_imp.g_varchar2_table(6550) := '20656C656D656E742E227D7D2C7B6E616D653A226F6E6D6F757365776865656C227D2C7B6E616D653A226F6E6D6F757365656E746572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E7469';
wwv_flow_imp.g_varchar2_table(6551) := '6E6720646576696365206973206D6F766564206F6E746F2074686520656C656D656E7420746861742068617320746865206C697374656E65722061747461636865642E227D7D2C7B6E616D653A226F6E6D6F7573656C65617665222C6465736372697074';
wwv_flow_imp.g_varchar2_table(6552) := '696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120706F696E74696E6720646576696365206973206D6F766564206F66662074686520656C656D656E7420746861742068617320746865206C697374656E65722061747461636865';
wwv_flow_imp.g_varchar2_table(6553) := '642E227D7D2C7B6E616D653A226F6E7061757365222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22506C61796261636B20686173206265656E207061757365642E227D7D2C7B6E616D653A226F6E706C6179';
wwv_flow_imp.g_varchar2_table(6554) := '222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22506C61796261636B2068617320626567756E2E227D7D2C7B6E616D653A226F6E706C6179696E67222C6465736372697074696F6E3A7B6B696E643A226D61';
wwv_flow_imp.g_varchar2_table(6555) := '726B646F776E222C76616C75653A22506C61796261636B20697320726561647920746F20737461727420616674657220686176696E67206265656E20706175736564206F722064656C617965642064756520746F206C61636B206F6620646174612E227D';
wwv_flow_imp.g_varchar2_table(6556) := '7D2C7B6E616D653A226F6E70726F6772657373222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E2070726F67726573732E227D7D2C7B6E616D653A226F6E726174656368616E6765222C646573637269';
wwv_flow_imp.g_varchar2_table(6557) := '7074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706C61796261636B207261746520686173206368616E6765642E227D7D2C7B6E616D653A226F6E7265736574222C6465736372697074696F6E3A7B6B696E643A226D';
wwv_flow_imp.g_varchar2_table(6558) := '61726B646F776E222C76616C75653A224120666F726D2069732072657365742E227D7D2C7B6E616D653A226F6E726573697A65222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520646F63756D656E';
wwv_flow_imp.g_varchar2_table(6559) := '74207669657720686173206265656E20726573697A65642E227D7D2C7B6E616D653A226F6E726561647973746174656368616E6765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22546865207265616479';
wwv_flow_imp.g_varchar2_table(6560) := '537461746520617474726962757465206F66206120646F63756D656E7420686173206368616E6765642E227D7D2C7B6E616D653A226F6E7363726F6C6C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254';
wwv_flow_imp.g_varchar2_table(6561) := '686520646F63756D656E742076696577206F7220616E20656C656D656E7420686173206265656E207363726F6C6C65642E227D7D2C7B6E616D653A226F6E7365656B6564222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76';
wwv_flow_imp.g_varchar2_table(6562) := '616C75653A2241207365656B206F7065726174696F6E20636F6D706C657465642E227D7D2C7B6E616D653A226F6E7365656B696E67222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2241207365656B206F70';
wwv_flow_imp.g_varchar2_table(6563) := '65726174696F6E20626567616E2E227D7D2C7B6E616D653A226F6E73656C656374222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22536F6D652074657874206973206265696E672073656C65637465642E22';
wwv_flow_imp.g_varchar2_table(6564) := '7D7D2C7B6E616D653A226F6E73686F77222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120636F6E746578746D656E75206576656E7420776173206669726564206F6E2F627562626C656420746F20616E';
wwv_flow_imp.g_varchar2_table(6565) := '20656C656D656E74207468617420686173206120636F6E746578746D656E7520617474726962757465227D7D2C7B6E616D653A226F6E7374616C6C6564222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254';
wwv_flow_imp.g_varchar2_table(6566) := '68652075736572206167656E7420697320747279696E6720746F206665746368206D6564696120646174612C20627574206461746120697320756E65787065637465646C79206E6F7420666F727468636F6D696E672E227D7D2C7B6E616D653A226F6E73';
wwv_flow_imp.g_varchar2_table(6567) := '75626D6974222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224120666F726D206973207375626D69747465642E227D7D2C7B6E616D653A226F6E73757370656E64222C6465736372697074696F6E3A7B6B69';
wwv_flow_imp.g_varchar2_table(6568) := '6E643A226D61726B646F776E222C76616C75653A224D656469612064617461206C6F6164696E6720686173206265656E2073757370656E6465642E227D7D2C7B6E616D653A226F6E74696D65757064617465222C6465736372697074696F6E3A7B6B696E';
wwv_flow_imp.g_varchar2_table(6569) := '643A226D61726B646F776E222C76616C75653A225468652074696D6520696E64696361746564206279207468652063757272656E7454696D652061747472696275746520686173206265656E20757064617465642E227D7D2C7B6E616D653A226F6E766F';
wwv_flow_imp.g_varchar2_table(6570) := '6C756D656368616E6765222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520766F6C756D6520686173206368616E6765642E227D7D2C7B6E616D653A226F6E77616974696E67222C64657363726970';
wwv_flow_imp.g_varchar2_table(6571) := '74696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22506C61796261636B206861732073746F707065642062656361757365206F6620612074656D706F72617279206C61636B206F6620646174612E227D7D2C7B6E616D653A226F6E70';
wwv_flow_imp.g_varchar2_table(6572) := '6F696E74657263616E63656C222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706F696E74657220697320756E6C696B656C7920746F2070726F6475636520616E79206D6F7265206576656E7473';
wwv_flow_imp.g_varchar2_table(6573) := '2E227D7D2C7B6E616D653A226F6E706F696E746572646F776E222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706F696E74657220656E74657273207468652061637469766520627574746F6E73';
wwv_flow_imp.g_varchar2_table(6574) := '2073746174652E227D7D2C7B6E616D653A226F6E706F696E746572656E746572222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22506F696E74696E6720646576696365206973206D6F76656420696E736964';
wwv_flow_imp.g_varchar2_table(6575) := '6520746865206869742D74657374696E6720626F756E646172792E227D7D2C7B6E616D653A226F6E706F696E7465726C65617665222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22506F696E74696E672064';
wwv_flow_imp.g_varchar2_table(6576) := '6576696365206973206D6F766564206F7574206F6620746865206869742D74657374696E6720626F756E646172792E227D7D2C7B6E616D653A226F6E706F696E7465726C6F636B6368616E6765222C6465736372697074696F6E3A7B6B696E643A226D61';
wwv_flow_imp.g_varchar2_table(6577) := '726B646F776E222C76616C75653A2254686520706F696E74657220776173206C6F636B6564206F722072656C65617365642E227D7D2C7B6E616D653A226F6E706F696E7465726C6F636B6572726F72222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6578) := '6D61726B646F776E222C76616C75653A2249742077617320696D706F737369626C6520746F206C6F636B2074686520706F696E74657220666F7220746563686E6963616C20726561736F6E73206F72206265636175736520746865207065726D69737369';
wwv_flow_imp.g_varchar2_table(6579) := '6F6E207761732064656E6965642E227D7D2C7B6E616D653A226F6E706F696E7465726D6F7665222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706F696E746572206368616E67656420636F6F72';
wwv_flow_imp.g_varchar2_table(6580) := '64696E617465732E227D7D2C7B6E616D653A226F6E706F696E7465726F7574222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706F696E74696E6720646576696365206D6F766564206F7574206F';
wwv_flow_imp.g_varchar2_table(6581) := '66206869742D74657374696E6720626F756E64617279206F72206C65617665732064657465637461626C6520686F7665722072616E67652E227D7D2C7B6E616D653A226F6E706F696E7465726F766572222C6465736372697074696F6E3A7B6B696E643A';
wwv_flow_imp.g_varchar2_table(6582) := '226D61726B646F776E222C76616C75653A2254686520706F696E74696E6720646576696365206973206D6F76656420696E746F20746865206869742D74657374696E6720626F756E646172792E227D7D2C7B6E616D653A226F6E706F696E746572757022';
wwv_flow_imp.g_varchar2_table(6583) := '2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2254686520706F696E746572206C6561766573207468652061637469766520627574746F6E732073746174652E227D7D2C7B6E616D653A22617269612D616374';
wwv_flow_imp.g_varchar2_table(6584) := '69766564657363656E64616E74222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D';
wwv_flow_imp.g_varchar2_table(6585) := '61637469766564657363656E64616E74227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E746966696573207468652063757272656E746C792061637469766520656C656D656E74207768656E';
wwv_flow_imp.g_varchar2_table(6586) := '20444F4D20666F637573206973206F6E2061205B60636F6D706F73697465605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23636F6D706F7369746529207769646765742C205B6074657874626F78605D28';
wwv_flow_imp.g_varchar2_table(6587) := '68747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2374657874626F78292C205B6067726F7570605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2367726F7570292C20';
wwv_flow_imp.g_varchar2_table(6588) := '6F72205B606170706C69636174696F6E605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F236170706C69636174696F6E292E227D7D2C7B6E616D653A22617269612D61746F6D6963222C76616C7565536574';
wwv_flow_imp.g_varchar2_table(6589) := '3A2262222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D61746F6D6963227D5D2C';
wwv_flow_imp.g_varchar2_table(6590) := '6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732077686574686572205B61737369737469766520746563686E6F6C6F676965735D2868747470733A2F2F7777772E77332E6F72672F5452';
wwv_flow_imp.g_varchar2_table(6591) := '2F7761692D617269612D312E312F2364666E2D6173736973746976652D746563686E6F6C6F6779292077696C6C2070726573656E7420616C6C2C206F72206F6E6C79207061727473206F662C20746865206368616E67656420726567696F6E2062617365';
wwv_flow_imp.g_varchar2_table(6592) := '64206F6E20746865206368616E6765206E6F74696669636174696F6E7320646566696E656420627920746865205B60617269612D72656C6576616E74605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2361';
wwv_flow_imp.g_varchar2_table(6593) := '7269612D72656C6576616E7429206174747269627574652E227D7D2C7B6E616D653A22617269612D6175746F636F6D706C657465222C76616C75655365743A226175746F636F6D706C657465222C7265666572656E6365733A5B7B6E616D653A22574149';
wwv_flow_imp.g_varchar2_table(6594) := '2D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6175746F636F6D706C657465227D5D2C6465736372697074696F6E3A7B6B696E643A226D61';
wwv_flow_imp.g_varchar2_table(6595) := '726B646F776E222C76616C75653A22496E64696361746573207768657468657220696E70757474696E67207465787420636F756C64207472696767657220646973706C6179206F66206F6E65206F72206D6F72652070726564696374696F6E73206F6620';
wwv_flow_imp.g_varchar2_table(6596) := '7468652075736572277320696E74656E6465642076616C756520666F7220616E20696E70757420616E642073706563696669657320686F772070726564696374696F6E7320776F756C642062652070726573656E74656420696620746865792061726520';
wwv_flow_imp.g_varchar2_table(6597) := '6D6164652E227D7D2C7B6E616D653A22617269612D62757379222C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F';
wwv_flow_imp.g_varchar2_table(6598) := '72672F54522F7761692D617269612D312E312F23617269612D62757379227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E6469636174657320616E20656C656D656E74206973206265696E67206D';
wwv_flow_imp.g_varchar2_table(6599) := '6F64696669656420616E6420746861742061737369737469766520746563686E6F6C6F67696573205F4D41595F2077616E7420746F207761697420756E74696C20746865206D6F64696669636174696F6E732061726520636F6D706C657465206265666F';
wwv_flow_imp.g_varchar2_table(6600) := '7265206578706F73696E67207468656D20746F2074686520757365722E227D7D2C7B6E616D653A22617269612D636865636B6564222C76616C75655365743A227472697374617465222C7265666572656E6365733A5B7B6E616D653A225741492D415249';
wwv_flow_imp.g_varchar2_table(6601) := '41205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636865636B6564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76';
wwv_flow_imp.g_varchar2_table(6602) := '616C75653A27496E64696361746573207468652063757272656E742022636865636B656422205B73746174655D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D737461746529206F662063686563';
wwv_flow_imp.g_varchar2_table(6603) := '6B626F7865732C20726164696F20627574746F6E732C20616E64206F74686572205B776964676574735D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D776964676574292E205365652072656C61';
wwv_flow_imp.g_varchar2_table(6604) := '746564205B60617269612D70726573736564605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D707265737365642920616E64205B60617269612D73656C6563746564605D2868747470733A2F';
wwv_flow_imp.g_varchar2_table(6605) := '2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D73656C6563746564292E277D7D2C7B6E616D653A22617269612D636F6C636F756E74222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265';
wwv_flow_imp.g_varchar2_table(6606) := '666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6C636F756E74227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(6607) := '653A22446566696E65732074686520746F74616C206E756D626572206F6620636F6C756D6E7320696E2061205B607461626C65605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237461626C65292C205B60';
wwv_flow_imp.g_varchar2_table(6608) := '67726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2367726964292C206F72205B607472656567726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E31';
wwv_flow_imp.g_varchar2_table(6609) := '2F237472656567726964292E205365652072656C61746564205B60617269612D636F6C696E646578605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6C696E646578292E227D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(6610) := '616D653A22617269612D636F6C696E646578222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23';
wwv_flow_imp.g_varchar2_table(6611) := '617269612D636F6C696E646578227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E657320616E205B656C656D656E7427735D2868747470733A2F2F7777772E77332E6F72672F54522F7761';
wwv_flow_imp.g_varchar2_table(6612) := '692D617269612D312E312F2364666E2D656C656D656E742920636F6C756D6E20696E646578206F7220706F736974696F6E2077697468207265737065637420746F2074686520746F74616C206E756D626572206F6620636F6C756D6E732077697468696E';
wwv_flow_imp.g_varchar2_table(6613) := '2061205B607461626C65605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237461626C65292C205B6067726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E31';
wwv_flow_imp.g_varchar2_table(6614) := '2F2367726964292C206F72205B607472656567726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237472656567726964292E205365652072656C61746564205B60617269612D636F6C636F756E7460';
wwv_flow_imp.g_varchar2_table(6615) := '5D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6C636F756E742920616E64205B60617269612D636F6C7370616E605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D';
wwv_flow_imp.g_varchar2_table(6616) := '617269612D312E312F23617269612D636F6C7370616E292E227D7D2C7B6E616D653A22617269612D636F6C7370616E222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F';
wwv_flow_imp.g_varchar2_table(6617) := '2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6C7370616E227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E657320746865206E756D62657220';
wwv_flow_imp.g_varchar2_table(6618) := '6F6620636F6C756D6E73207370616E6E656420627920612063656C6C206F72206772696463656C6C2077697468696E2061205B607461626C65605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237461626C';
wwv_flow_imp.g_varchar2_table(6619) := '65292C205B6067726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2367726964292C206F72205B607472656567726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D6172';
wwv_flow_imp.g_varchar2_table(6620) := '69612D312E312F237472656567726964292E205365652072656C61746564205B60617269612D636F6C696E646578605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6C696E6465782920';
wwv_flow_imp.g_varchar2_table(6621) := '616E64205B60617269612D726F777370616E605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726F777370616E292E227D7D2C7B6E616D653A22617269612D636F6E74726F6C73222C726566';
wwv_flow_imp.g_varchar2_table(6622) := '6572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6E74726F6C73227D5D2C646573637269';
wwv_flow_imp.g_varchar2_table(6623) := '7074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E74696669657320746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D65';
wwv_flow_imp.g_varchar2_table(6624) := '6E742920286F7220656C656D656E7473292077686F736520636F6E74656E7473206F722070726573656E63652061726520636F6E74726F6C6C6564206279207468652063757272656E7420656C656D656E742E205365652072656C61746564205B606172';
wwv_flow_imp.g_varchar2_table(6625) := '69612D6F776E73605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6F776E73292E227D7D2C7B6E616D653A22617269612D63757272656E74222C76616C75655365743A2263757272656E7422';
wwv_flow_imp.g_varchar2_table(6626) := '2C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D63757272656E74227D5D2C646573';
wwv_flow_imp.g_varchar2_table(6627) := '6372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E6469636174657320746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C65';
wwv_flow_imp.g_varchar2_table(6628) := '6D656E7429207468617420726570726573656E7473207468652063757272656E74206974656D2077697468696E206120636F6E7461696E6572206F7220736574206F662072656C6174656420656C656D656E74732E227D7D2C7B6E616D653A2261726961';
wwv_flow_imp.g_varchar2_table(6629) := '2D6465736372696265646279222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D64';
wwv_flow_imp.g_varchar2_table(6630) := '65736372696265646279227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E74696669657320746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F776169';
wwv_flow_imp.g_varchar2_table(6631) := '2D617269612D312E312F2364666E2D656C656D656E742920286F7220656C656D656E74732920746861742064657363726962657320746865205B6F626A6563745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E31';
wwv_flow_imp.g_varchar2_table(6632) := '2F2364666E2D6F626A656374292E205365652072656C61746564205B60617269612D6C6162656C6C65646279605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6C6162656C6C65646279292E';
wwv_flow_imp.g_varchar2_table(6633) := '227D7D2C7B6E616D653A22617269612D64697361626C6564222C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72';
wwv_flow_imp.g_varchar2_table(6634) := '672F54522F7761692D617269612D312E312F23617269612D64697361626C6564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E64696361746573207468617420746865205B656C656D656E745D';
wwv_flow_imp.g_varchar2_table(6635) := '2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E7429206973205B7065726365697661626C655D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E';
wwv_flow_imp.g_varchar2_table(6636) := '312F2364666E2D7065726365697661626C6529206275742064697361626C65642C20736F206974206973206E6F74206564697461626C65206F72206F7468657277697365205B6F70657261626C655D2868747470733A2F2F7777772E77332E6F72672F54';
wwv_flow_imp.g_varchar2_table(6637) := '522F7761692D617269612D312E312F2364666E2D6F70657261626C65292E205365652072656C61746564205B60617269612D68696464656E605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D';
wwv_flow_imp.g_varchar2_table(6638) := '68696464656E2920616E64205B60617269612D726561646F6E6C79605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726561646F6E6C79292E227D7D2C7B6E616D653A22617269612D64726F';
wwv_flow_imp.g_varchar2_table(6639) := '70656666656374222C76616C75655365743A2264726F70656666656374222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F776169';
wwv_flow_imp.g_varchar2_table(6640) := '2D617269612D312E312F23617269612D64726F70656666656374227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A225C5C5B4465707265636174656420696E204152494120312E315C5C5D20496E646963';
wwv_flow_imp.g_varchar2_table(6641) := '6174657320776861742066756E6374696F6E732063616E20626520706572666F726D6564207768656E20612064726167676564206F626A6563742069732072656C6561736564206F6E207468652064726F70207461726765742E227D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(6642) := '22617269612D6572726F726D657373616765222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23';
wwv_flow_imp.g_varchar2_table(6643) := '617269612D6572726F726D657373616765227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E74696669657320746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F7267';
wwv_flow_imp.g_varchar2_table(6644) := '2F54522F7761692D617269612D312E312F2364666E2D656C656D656E742920746861742070726F766964657320616E206572726F72206D65737361676520666F7220746865205B6F626A6563745D2868747470733A2F2F7777772E77332E6F72672F5452';
wwv_flow_imp.g_varchar2_table(6645) := '2F7761692D617269612D312E312F2364666E2D6F626A656374292E205365652072656C61746564205B60617269612D696E76616C6964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D696E';
wwv_flow_imp.g_varchar2_table(6646) := '76616C69642920616E64205B60617269612D6465736372696265646279605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6465736372696265646279292E227D7D2C7B6E616D653A22617269';
wwv_flow_imp.g_varchar2_table(6647) := '612D657870616E646564222C76616C75655365743A2275222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D';
wwv_flow_imp.g_varchar2_table(6648) := '312E312F23617269612D657870616E646564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E6469636174657320776865746865722074686520656C656D656E742C206F7220616E6F7468657220';
wwv_flow_imp.g_varchar2_table(6649) := '67726F7570696E6720656C656D656E7420697420636F6E74726F6C732C2069732063757272656E746C7920657870616E646564206F7220636F6C6C61707365642E227D7D2C7B6E616D653A22617269612D666C6F77746F222C7265666572656E6365733A';
wwv_flow_imp.g_varchar2_table(6650) := '5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D666C6F77746F227D5D2C6465736372697074696F6E3A7B6B696E';
wwv_flow_imp.g_varchar2_table(6651) := '643A226D61726B646F776E222C76616C75653A224964656E74696669657320746865206E657874205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E74292028';
wwv_flow_imp.g_varchar2_table(6652) := '6F7220656C656D656E74732920696E20616E20616C7465726E6174652072656164696E67206F72646572206F6620636F6E74656E742077686963682C20617420746865207573657227732064697363726574696F6E2C20616C6C6F777320617373697374';
wwv_flow_imp.g_varchar2_table(6653) := '69766520746563686E6F6C6F677920746F206F76657272696465207468652067656E6572616C2064656661756C74206F662072656164696E6720696E20646F63756D656E7420736F75726365206F726465722E227D7D2C7B6E616D653A22617269612D67';
wwv_flow_imp.g_varchar2_table(6654) := '726162626564222C76616C75655365743A2275222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F';
wwv_flow_imp.g_varchar2_table(6655) := '23617269612D67726162626564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A275C5C5B4465707265636174656420696E204152494120312E315C5C5D20496E6469636174657320616E20656C656D65';
wwv_flow_imp.g_varchar2_table(6656) := '6E745C277320226772616262656422205B73746174655D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D73746174652920696E206120647261672D616E642D64726F70206F7065726174696F6E2E';
wwv_flow_imp.g_varchar2_table(6657) := '277D7D2C7B6E616D653A22617269612D686173706F707570222C76616C75655365743A22686173706F707570222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777';
wwv_flow_imp.g_varchar2_table(6658) := '772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D686173706F707570227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686520617661696C6162';
wwv_flow_imp.g_varchar2_table(6659) := '696C69747920616E642074797065206F6620696E74657261637469766520706F70757020656C656D656E742C2073756368206173206D656E75206F72206469616C6F672C20746861742063616E2062652074726967676572656420627920616E205B656C';
wwv_flow_imp.g_varchar2_table(6660) := '656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E74292E227D7D2C7B6E616D653A22617269612D68696464656E222C76616C75655365743A2262222C7265666572656E';
wwv_flow_imp.g_varchar2_table(6661) := '6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D68696464656E227D5D2C6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(6662) := '7B6B696E643A226D61726B646F776E222C76616C75653A22496E64696361746573207768657468657220746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D';
wwv_flow_imp.g_varchar2_table(6663) := '656E7429206973206578706F73656420746F20616E206163636573736962696C697479204150492E205365652072656C61746564205B60617269612D64697361626C6564605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269';
wwv_flow_imp.g_varchar2_table(6664) := '612D312E312F23617269612D64697361626C6564292E227D7D2C7B6E616D653A22617269612D696E76616C6964222C76616C75655365743A22696E76616C6964222C7265666572656E6365733A5B7B6E616D653A225741492D4152494120526566657265';
wwv_flow_imp.g_varchar2_table(6665) := '6E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D696E76616C6964227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E';
wwv_flow_imp.g_varchar2_table(6666) := '646963617465732074686520656E74657265642076616C756520646F6573206E6F7420636F6E666F726D20746F2074686520666F726D617420657870656374656420627920746865206170706C69636174696F6E2E205365652072656C61746564205B60';
wwv_flow_imp.g_varchar2_table(6667) := '617269612D6572726F726D657373616765605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6572726F726D657373616765292E227D7D2C7B6E616D653A22617269612D6C6162656C222C7265';
wwv_flow_imp.g_varchar2_table(6668) := '666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6C6162656C227D5D2C6465736372697074';
wwv_flow_imp.g_varchar2_table(6669) := '696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E6573206120737472696E672076616C75652074686174206C6162656C73207468652063757272656E7420656C656D656E742E205365652072656C61746564205B606172';
wwv_flow_imp.g_varchar2_table(6670) := '69612D6C6162656C6C65646279605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6C6162656C6C65646279292E227D7D2C7B6E616D653A22617269612D6C6162656C6C65646279222C726566';
wwv_flow_imp.g_varchar2_table(6671) := '6572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6C6162656C6C65646279227D5D2C64657363';
wwv_flow_imp.g_varchar2_table(6672) := '72697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E74696669657320746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C65';
wwv_flow_imp.g_varchar2_table(6673) := '6D656E742920286F7220656C656D656E7473292074686174206C6162656C73207468652063757272656E7420656C656D656E742E205365652072656C61746564205B60617269612D6465736372696265646279605D2868747470733A2F2F7777772E7733';
wwv_flow_imp.g_varchar2_table(6674) := '2E6F72672F54522F7761692D617269612D312E312F23617269612D6465736372696265646279292E227D7D2C7B6E616D653A22617269612D6C6576656C222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365';
wwv_flow_imp.g_varchar2_table(6675) := '222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6C6576656C227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E6573';
wwv_flow_imp.g_varchar2_table(6676) := '207468652068696572617263686963616C206C6576656C206F6620616E205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E74292077697468696E2061207374';
wwv_flow_imp.g_varchar2_table(6677) := '727563747572652E227D7D2C7B6E616D653A22617269612D6C697665222C76616C75655365743A226C697665222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777';
wwv_flow_imp.g_varchar2_table(6678) := '772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6C697665227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E64696361746573207468617420616E205B656C656D656E';
wwv_flow_imp.g_varchar2_table(6679) := '745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E74292077696C6C20626520757064617465642C20616E642064657363726962657320746865207479706573206F662075706461';
wwv_flow_imp.g_varchar2_table(6680) := '74657320746865205B75736572206167656E74735D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D757365722D6167656E74292C205B61737369737469766520746563686E6F6C6F676965735D28';
wwv_flow_imp.g_varchar2_table(6681) := '68747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D6173736973746976652D746563686E6F6C6F6779292C20616E6420757365722063616E206578706563742066726F6D20746865205B6C697665207265';
wwv_flow_imp.g_varchar2_table(6682) := '67696F6E5D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D6C6976652D726567696F6E292E227D7D2C7B6E616D653A22617269612D6D6F64616C222C76616C75655365743A2262222C7265666572';
wwv_flow_imp.g_varchar2_table(6683) := '656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6D6F64616C227D5D2C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(6684) := '3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E64696361746573207768657468657220616E205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D';
wwv_flow_imp.g_varchar2_table(6685) := '656E7429206973206D6F64616C207768656E20646973706C617965642E227D7D2C7B6E616D653A22617269612D6D756C74696C696E65222C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A225741492D4152494120526566';
wwv_flow_imp.g_varchar2_table(6686) := '6572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6D756C74696C696E65227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(6687) := '653A22496E6469636174657320776865746865722061207465787420626F782061636365707473206D756C7469706C65206C696E6573206F6620696E707574206F72206F6E6C7920612073696E676C65206C696E652E227D7D2C7B6E616D653A22617269';
wwv_flow_imp.g_varchar2_table(6688) := '612D6D756C746973656C65637461626C65222C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761';
wwv_flow_imp.g_varchar2_table(6689) := '692D617269612D312E312F23617269612D6D756C746973656C65637461626C65227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686174207468652075736572206D617920';
wwv_flow_imp.g_varchar2_table(6690) := '73656C656374206D6F7265207468616E206F6E65206974656D2066726F6D207468652063757272656E742073656C65637461626C652064657363656E64616E74732E227D7D2C7B6E616D653A22617269612D6F7269656E746174696F6E222C76616C7565';
wwv_flow_imp.g_varchar2_table(6691) := '5365743A226F7269656E746174696F6E222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F236172';
wwv_flow_imp.g_varchar2_table(6692) := '69612D6F7269656E746174696F6E227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E6469636174657320776865746865722074686520656C656D656E742773206F7269656E746174696F6E206973';
wwv_flow_imp.g_varchar2_table(6693) := '20686F72697A6F6E74616C2C20766572746963616C2C206F7220756E6B6E6F776E2F616D626967756F75732E227D7D2C7B6E616D653A22617269612D6F776E73222C7265666572656E6365733A5B7B6E616D653A225741492D4152494120526566657265';
wwv_flow_imp.g_varchar2_table(6694) := '6E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6F776E73227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E74';
wwv_flow_imp.g_varchar2_table(6695) := '696669657320616E205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E742920286F7220656C656D656E74732920696E206F7264657220746F20646566696E65';
wwv_flow_imp.g_varchar2_table(6696) := '20612076697375616C2C2066756E6374696F6E616C2C206F7220636F6E7465787475616C20706172656E742F6368696C64205B72656C6174696F6E736869705D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F';
wwv_flow_imp.g_varchar2_table(6697) := '2364666E2D72656C6174696F6E7368697029206265747765656E20444F4D20656C656D656E74732077686572652074686520444F4D206869657261726368792063616E6E6F74206265207573656420746F20726570726573656E74207468652072656C61';
wwv_flow_imp.g_varchar2_table(6698) := '74696F6E736869702E205365652072656C61746564205B60617269612D636F6E74726F6C73605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6E74726F6C73292E227D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6699) := '3A22617269612D706C616365686F6C646572222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23';
wwv_flow_imp.g_varchar2_table(6700) := '617269612D706C616365686F6C646572227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E657320612073686F72742068696E7420286120776F7264206F722073686F727420706872617365';
wwv_flow_imp.g_varchar2_table(6701) := '2920696E74656E64656420746F206169642074686520757365722077697468206461746120656E747279207768656E2074686520636F6E74726F6C20686173206E6F2076616C75652E20412068696E7420636F756C6420626520612073616D706C652076';
wwv_flow_imp.g_varchar2_table(6702) := '616C7565206F722061206272696566206465736372697074696F6E206F662074686520657870656374656420666F726D61742E227D7D2C7B6E616D653A22617269612D706F73696E736574222C7265666572656E6365733A5B7B6E616D653A225741492D';
wwv_flow_imp.g_varchar2_table(6703) := '41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D706F73696E736574227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F77';
wwv_flow_imp.g_varchar2_table(6704) := '6E222C76616C75653A22446566696E657320616E205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E74292773206E756D626572206F7220706F736974696F6E';
wwv_flow_imp.g_varchar2_table(6705) := '20696E207468652063757272656E7420736574206F66206C6973746974656D73206F7220747265656974656D732E204E6F7420726571756972656420696620616C6C20656C656D656E747320696E2074686520736574206172652070726573656E742069';
wwv_flow_imp.g_varchar2_table(6706) := '6E2074686520444F4D2E205365652072656C61746564205B60617269612D73657473697A65605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D73657473697A65292E227D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(6707) := '22617269612D70726573736564222C76616C75655365743A227472697374617465222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F5452';
wwv_flow_imp.g_varchar2_table(6708) := '2F7761692D617269612D312E312F23617269612D70726573736564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27496E64696361746573207468652063757272656E7420227072657373656422205B';
wwv_flow_imp.g_varchar2_table(6709) := '73746174655D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D737461746529206F6620746F67676C6520627574746F6E732E205365652072656C61746564205B60617269612D636865636B656460';
wwv_flow_imp.g_varchar2_table(6710) := '5D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636865636B65642920616E64205B60617269612D73656C6563746564605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D';
wwv_flow_imp.g_varchar2_table(6711) := '617269612D312E312F23617269612D73656C6563746564292E277D7D2C7B6E616D653A22617269612D726561646F6E6C79222C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E63';
wwv_flow_imp.g_varchar2_table(6712) := '65222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726561646F6E6C79227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E64';
wwv_flow_imp.g_varchar2_table(6713) := '696361746573207468617420746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E7429206973206E6F74206564697461626C652C20627574206973206F';
wwv_flow_imp.g_varchar2_table(6714) := '7468657277697365205B6F70657261626C655D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D6F70657261626C65292E205365652072656C61746564205B60617269612D64697361626C6564605D';
wwv_flow_imp.g_varchar2_table(6715) := '2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D64697361626C6564292E227D7D2C7B6E616D653A22617269612D72656C6576616E74222C76616C75655365743A2272656C6576616E74222C7265';
wwv_flow_imp.g_varchar2_table(6716) := '666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D72656C6576616E74227D5D2C6465736372';
wwv_flow_imp.g_varchar2_table(6717) := '697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732077686174206E6F74696669636174696F6E73207468652075736572206167656E742077696C6C2074726967676572207768656E2074686520616363';
wwv_flow_imp.g_varchar2_table(6718) := '6573736962696C69747920747265652077697468696E2061206C69766520726567696F6E206973206D6F6469666965642E205365652072656C61746564205B60617269612D61746F6D6963605D2868747470733A2F2F7777772E77332E6F72672F54522F';
wwv_flow_imp.g_varchar2_table(6719) := '7761692D617269612D312E312F23617269612D61746F6D6963292E227D7D2C7B6E616D653A22617269612D7265717569726564222C76616C75655365743A2262222C7265666572656E6365733A5B7B6E616D653A225741492D4152494120526566657265';
wwv_flow_imp.g_varchar2_table(6720) := '6E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D7265717569726564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2249';
wwv_flow_imp.g_varchar2_table(6721) := '6E646963617465732074686174207573657220696E707574206973207265717569726564206F6E20746865205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E';
wwv_flow_imp.g_varchar2_table(6722) := '7429206265666F7265206120666F726D206D6179206265207375626D69747465642E227D7D2C7B6E616D653A22617269612D726F6C656465736372697074696F6E222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572';
wwv_flow_imp.g_varchar2_table(6723) := '656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726F6C656465736372697074696F6E227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C';
wwv_flow_imp.g_varchar2_table(6724) := '76616C75653A22446566696E657320612068756D616E2D7265616461626C652C20617574686F722D6C6F63616C697A6564206465736372697074696F6E20666F7220746865205B726F6C655D2868747470733A2F2F7777772E77332E6F72672F54522F77';
wwv_flow_imp.g_varchar2_table(6725) := '61692D617269612D312E312F2364666E2D726F6C6529206F6620616E205B656C656D656E745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E74292E227D7D2C7B6E616D653A2261';
wwv_flow_imp.g_varchar2_table(6726) := '7269612D726F77636F756E74222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D72';
wwv_flow_imp.g_varchar2_table(6727) := '6F77636F756E74227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E65732074686520746F74616C206E756D626572206F6620726F777320696E2061205B607461626C65605D286874747073';
wwv_flow_imp.g_varchar2_table(6728) := '3A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237461626C65292C205B6067726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2367726964292C206F72205B6074726565';
wwv_flow_imp.g_varchar2_table(6729) := '67726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237472656567726964292E205365652072656C61746564205B60617269612D726F77696E646578605D2868747470733A2F2F7777772E77332E6F';
wwv_flow_imp.g_varchar2_table(6730) := '72672F54522F7761692D617269612D312E312F23617269612D726F77696E646578292E227D7D2C7B6E616D653A22617269612D726F77696E646578222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C';
wwv_flow_imp.g_varchar2_table(6731) := '75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726F77696E646578227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E65';
wwv_flow_imp.g_varchar2_table(6732) := '7320616E205B656C656D656E7427735D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E742920726F7720696E646578206F7220706F736974696F6E20776974682072657370656374';
wwv_flow_imp.g_varchar2_table(6733) := '20746F2074686520746F74616C206E756D626572206F6620726F77732077697468696E2061205B607461626C65605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237461626C65292C205B6067726964605D';
wwv_flow_imp.g_varchar2_table(6734) := '2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2367726964292C206F72205B607472656567726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2374726565';
wwv_flow_imp.g_varchar2_table(6735) := '67726964292E205365652072656C61746564205B60617269612D726F77636F756E74605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726F77636F756E742920616E64205B60617269612D72';
wwv_flow_imp.g_varchar2_table(6736) := '6F777370616E605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726F777370616E292E227D7D2C7B6E616D653A22617269612D726F777370616E222C7265666572656E6365733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(6737) := '653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D726F777370616E227D5D2C6465736372697074696F6E3A7B6B696E643A226D';
wwv_flow_imp.g_varchar2_table(6738) := '61726B646F776E222C76616C75653A22446566696E657320746865206E756D626572206F6620726F7773207370616E6E656420627920612063656C6C206F72206772696463656C6C2077697468696E2061205B607461626C65605D2868747470733A2F2F';
wwv_flow_imp.g_varchar2_table(6739) := '7777772E77332E6F72672F54522F7761692D617269612D312E312F237461626C65292C205B6067726964605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2367726964292C206F72205B6074726565677269';
wwv_flow_imp.g_varchar2_table(6740) := '64605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F237472656567726964292E205365652072656C61746564205B60617269612D726F77696E646578605D2868747470733A2F2F7777772E77332E6F72672F';
wwv_flow_imp.g_varchar2_table(6741) := '54522F7761692D617269612D312E312F23617269612D726F77696E6465782920616E64205B60617269612D636F6C7370616E605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D636F6C737061';
wwv_flow_imp.g_varchar2_table(6742) := '6E292E227D7D2C7B6E616D653A22617269612D73656C6563746564222C76616C75655365743A2275222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E7733';
wwv_flow_imp.g_varchar2_table(6743) := '2E6F72672F54522F7761692D617269612D312E312F23617269612D73656C6563746564227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A27496E64696361746573207468652063757272656E7420227365';
wwv_flow_imp.g_varchar2_table(6744) := '6C656374656422205B73746174655D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D737461746529206F6620766172696F7573205B776964676574735D2868747470733A2F2F7777772E77332E6F';
wwv_flow_imp.g_varchar2_table(6745) := '72672F54522F7761692D617269612D312E312F2364666E2D776964676574292E205365652072656C61746564205B60617269612D636865636B6564605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F236172';
wwv_flow_imp.g_varchar2_table(6746) := '69612D636865636B65642920616E64205B60617269612D70726573736564605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D70726573736564292E277D7D2C7B6E616D653A22617269612D73';
wwv_flow_imp.g_varchar2_table(6747) := '657473697A65222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D73657473697A65';
wwv_flow_imp.g_varchar2_table(6748) := '227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E657320746865206E756D626572206F66206974656D7320696E207468652063757272656E7420736574206F66206C6973746974656D7320';
wwv_flow_imp.g_varchar2_table(6749) := '6F7220747265656974656D732E204E6F7420726571756972656420696620616C6C20656C656D656E747320696E2074686520736574206172652070726573656E7420696E2074686520444F4D2E205365652072656C61746564205B60617269612D706F73';
wwv_flow_imp.g_varchar2_table(6750) := '696E736574605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D706F73696E736574292E227D7D2C7B6E616D653A22617269612D736F7274222C76616C75655365743A22736F7274222C726566';
wwv_flow_imp.g_varchar2_table(6751) := '6572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D736F7274227D5D2C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(6752) := '6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E64696361746573206966206974656D7320696E2061207461626C65206F7220677269642061726520736F7274656420696E20617363656E64696E67206F722064657363656E64696E';
wwv_flow_imp.g_varchar2_table(6753) := '67206F726465722E227D7D2C7B6E616D653A22617269612D76616C75656D6178222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F';
wwv_flow_imp.g_varchar2_table(6754) := '7761692D617269612D312E312F23617269612D76616C75656D6178227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E657320746865206D6178696D756D20616C6C6F7765642076616C7565';
wwv_flow_imp.g_varchar2_table(6755) := '20666F7220612072616E6765205B7769646765745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D776964676574292E227D7D2C7B6E616D653A22617269612D76616C75656D696E222C72656665';
wwv_flow_imp.g_varchar2_table(6756) := '72656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D76616C75656D696E227D5D2C64657363726970';
wwv_flow_imp.g_varchar2_table(6757) := '74696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E657320746865206D696E696D756D20616C6C6F7765642076616C756520666F7220612072616E6765205B7769646765745D2868747470733A2F2F7777772E77332E6F';
wwv_flow_imp.g_varchar2_table(6758) := '72672F54522F7761692D617269612D312E312F2364666E2D776964676574292E227D7D2C7B6E616D653A22617269612D76616C75656E6F77222C7265666572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C';
wwv_flow_imp.g_varchar2_table(6759) := '3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D76616C75656E6F77227D5D2C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E65732074';
wwv_flow_imp.g_varchar2_table(6760) := '68652063757272656E742076616C756520666F7220612072616E6765205B7769646765745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D776964676574292E205365652072656C61746564205B';
wwv_flow_imp.g_varchar2_table(6761) := '60617269612D76616C756574657874605D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D76616C756574657874292E227D7D2C7B6E616D653A22617269612D76616C756574657874222C726566';
wwv_flow_imp.g_varchar2_table(6762) := '6572656E6365733A5B7B6E616D653A225741492D41524941205265666572656E6365222C75726C3A2268747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D76616C756574657874227D5D2C6465736372';
wwv_flow_imp.g_varchar2_table(6763) := '697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22446566696E6573207468652068756D616E207265616461626C65207465787420616C7465726E6174697665206F66205B60617269612D76616C75656E6F77605D2868747470';
wwv_flow_imp.g_varchar2_table(6764) := '733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D76616C75656E6F772920666F7220612072616E6765205B7769646765745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D31';
wwv_flow_imp.g_varchar2_table(6765) := '2E312F2364666E2D776964676574292E227D7D2C7B6E616D653A22617269612D64657461696C73222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A224964656E74696669657320746865205B656C656D656E74';
wwv_flow_imp.g_varchar2_table(6766) := '5D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D656C656D656E742920746861742070726F766964657320612064657461696C65642C20657874656E646564206465736372697074696F6E20666F';
wwv_flow_imp.g_varchar2_table(6767) := '7220746865205B6F626A6563745D2868747470733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F2364666E2D6F626A656374292E205365652072656C61746564205B60617269612D6465736372696265646279605D28687474';
wwv_flow_imp.g_varchar2_table(6768) := '70733A2F2F7777772E77332E6F72672F54522F7761692D617269612D312E312F23617269612D6465736372696265646279292E227D7D2C7B6E616D653A22617269612D6B657973686F727463757473222C6465736372697074696F6E3A7B6B696E643A22';
wwv_flow_imp.g_varchar2_table(6769) := '6D61726B646F776E222C76616C75653A22496E64696361746573206B6579626F6172642073686F727463757473207468617420616E20617574686F722068617320696D706C656D656E74656420746F206163746976617465206F72206769766520666F63';
wwv_flow_imp.g_varchar2_table(6770) := '757320746F20616E20656C656D656E742E227D7D5D2C76616C7565536574733A5B7B6E616D653A2262222C76616C7565733A5B7B6E616D653A2274727565227D2C7B6E616D653A2266616C7365227D5D7D2C7B6E616D653A2275222C76616C7565733A5B';
wwv_flow_imp.g_varchar2_table(6771) := '7B6E616D653A2274727565227D2C7B6E616D653A2266616C7365227D2C7B6E616D653A22756E646566696E6564227D5D7D2C7B6E616D653A226F222C76616C7565733A5B7B6E616D653A226F6E227D2C7B6E616D653A226F6666227D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6772) := '3A2279222C76616C7565733A5B7B6E616D653A22796573227D2C7B6E616D653A226E6F227D5D7D2C7B6E616D653A2277222C76616C7565733A5B7B6E616D653A22736F6674227D2C7B6E616D653A2268617264227D5D7D2C7B6E616D653A2264222C7661';
wwv_flow_imp.g_varchar2_table(6773) := '6C7565733A5B7B6E616D653A226C7472227D2C7B6E616D653A2272746C227D2C7B6E616D653A226175746F227D5D7D2C7B6E616D653A226D222C76616C7565733A5B7B6E616D653A22676574222C6465736372697074696F6E3A7B6B696E643A226D6172';
wwv_flow_imp.g_varchar2_table(6774) := '6B646F776E222C76616C75653A22436F72726573706F6E647320746F207468652048545450205B474554206D6574686F645D2868747470733A2F2F7777772E77332E6F72672F50726F746F636F6C732F726663323631362F726663323631362D73656339';
wwv_flow_imp.g_varchar2_table(6775) := '2E68746D6C23736563392E33293B20666F726D20646174612061726520617070656E64656420746F207468652060616374696F6E6020617474726962757465205552492077697468206120273F2720617320736570617261746F722C20616E6420746865';
wwv_flow_imp.g_varchar2_table(6776) := '20726573756C74696E67205552492069732073656E7420746F20746865207365727665722E205573652074686973206D6574686F64207768656E2074686520666F726D20686173206E6F20736964652D6566666563747320616E6420636F6E7461696E73';
wwv_flow_imp.g_varchar2_table(6777) := '206F6E6C7920415343494920636861726163746572732E227D7D2C7B6E616D653A22706F7374222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22436F72726573706F6E647320746F20746865204854545020';
wwv_flow_imp.g_varchar2_table(6778) := '5B504F5354206D6574686F645D2868747470733A2F2F7777772E77332E6F72672F50726F746F636F6C732F726663323631362F726663323631362D736563392E68746D6C23736563392E35293B20666F726D20646174612061726520696E636C75646564';
wwv_flow_imp.g_varchar2_table(6779) := '20696E2074686520626F6479206F662074686520666F726D20616E642073656E7420746F20746865207365727665722E227D7D2C7B6E616D653A226469616C6F67222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(6780) := '653A22557365207768656E2074686520666F726D20697320696E736964652061205B603C6469616C6F673E605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F48544D4C2F456C656D';
wwv_flow_imp.g_varchar2_table(6781) := '656E742F6469616C6F672920656C656D656E7420746F20636C6F736520746865206469616C6F67207768656E207375626D69747465642E227D7D5D7D2C7B6E616D653A22666D222C76616C7565733A5B7B6E616D653A22676574227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(6782) := '706F7374227D5D7D2C7B6E616D653A2273222C76616C7565733A5B7B6E616D653A22726F77227D2C7B6E616D653A22636F6C227D2C7B6E616D653A22726F7767726F7570227D2C7B6E616D653A22636F6C67726F7570227D5D7D2C7B6E616D653A227422';
wwv_flow_imp.g_varchar2_table(6783) := '2C76616C7565733A5B7B6E616D653A2268696464656E227D2C7B6E616D653A2274657874227D2C7B6E616D653A22736561726368227D2C7B6E616D653A2274656C227D2C7B6E616D653A2275726C227D2C7B6E616D653A22656D61696C227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(6784) := '653A2270617373776F7264227D2C7B6E616D653A226461746574696D65227D2C7B6E616D653A2264617465227D2C7B6E616D653A226D6F6E7468227D2C7B6E616D653A227765656B227D2C7B6E616D653A2274696D65227D2C7B6E616D653A2264617465';
wwv_flow_imp.g_varchar2_table(6785) := '74696D652D6C6F63616C227D2C7B6E616D653A226E756D626572227D2C7B6E616D653A2272616E6765227D2C7B6E616D653A22636F6C6F72227D2C7B6E616D653A22636865636B626F78227D2C7B6E616D653A22726164696F227D2C7B6E616D653A2266';
wwv_flow_imp.g_varchar2_table(6786) := '696C65227D2C7B6E616D653A227375626D6974227D2C7B6E616D653A22696D616765227D2C7B6E616D653A227265736574227D2C7B6E616D653A22627574746F6E227D5D7D2C7B6E616D653A22696D222C76616C7565733A5B7B6E616D653A2276657262';
wwv_flow_imp.g_varchar2_table(6787) := '6174696D227D2C7B6E616D653A226C6174696E227D2C7B6E616D653A226C6174696E2D6E616D65227D2C7B6E616D653A226C6174696E2D70726F7365227D2C7B6E616D653A2266756C6C2D77696474682D6C6174696E227D2C7B6E616D653A226B616E61';
wwv_flow_imp.g_varchar2_table(6788) := '227D2C7B6E616D653A226B616E612D6E616D65227D2C7B6E616D653A226B6174616B616E61227D2C7B6E616D653A226E756D65726963227D2C7B6E616D653A2274656C227D2C7B6E616D653A22656D61696C227D2C7B6E616D653A2275726C227D5D7D2C';
wwv_flow_imp.g_varchar2_table(6789) := '7B6E616D653A226274222C76616C7565733A5B7B6E616D653A22627574746F6E227D2C7B6E616D653A227375626D6974227D2C7B6E616D653A227265736574227D2C7B6E616D653A226D656E75227D5D7D2C7B6E616D653A226C74222C76616C7565733A';
wwv_flow_imp.g_varchar2_table(6790) := '5B7B6E616D653A2231227D2C7B6E616D653A2261227D2C7B6E616D653A2241227D2C7B6E616D653A2269227D2C7B6E616D653A2249227D5D7D2C7B6E616D653A226D74222C76616C7565733A5B7B6E616D653A22636F6E74657874227D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(6791) := '22746F6F6C626172227D5D7D2C7B6E616D653A226D6974222C76616C7565733A5B7B6E616D653A22636F6D6D616E64227D2C7B6E616D653A22636865636B626F78227D2C7B6E616D653A22726164696F227D5D7D2C7B6E616D653A226574222C76616C75';
wwv_flow_imp.g_varchar2_table(6792) := '65733A5B7B6E616D653A226170706C69636174696F6E2F782D7777772D666F726D2D75726C656E636F646564227D2C7B6E616D653A226D756C7469706172742F666F726D2D64617461227D2C7B6E616D653A22746578742F706C61696E227D5D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(6793) := '616D653A22746B222C76616C7565733A5B7B6E616D653A227375627469746C6573227D2C7B6E616D653A2263617074696F6E73227D2C7B6E616D653A226465736372697074696F6E73227D2C7B6E616D653A226368617074657273227D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(6794) := '226D65746164617461227D5D7D2C7B6E616D653A22706C222C76616C7565733A5B7B6E616D653A226E6F6E65227D2C7B6E616D653A226D65746164617461227D2C7B6E616D653A226175746F227D5D7D2C7B6E616D653A227368222C76616C7565733A5B';
wwv_flow_imp.g_varchar2_table(6795) := '7B6E616D653A22636972636C65227D2C7B6E616D653A2264656661756C74227D2C7B6E616D653A22706F6C79227D2C7B6E616D653A2272656374227D5D7D2C7B6E616D653A22786F222C76616C7565733A5B7B6E616D653A22616E6F6E796D6F7573227D';
wwv_flow_imp.g_varchar2_table(6796) := '2C7B6E616D653A227573652D63726564656E7469616C73227D5D7D2C7B6E616D653A227362222C76616C7565733A5B7B6E616D653A22616C6C6F772D666F726D73227D2C7B6E616D653A22616C6C6F772D6D6F64616C73227D2C7B6E616D653A22616C6C';
wwv_flow_imp.g_varchar2_table(6797) := '6F772D706F696E7465722D6C6F636B227D2C7B6E616D653A22616C6C6F772D706F70757073227D2C7B6E616D653A22616C6C6F772D706F707570732D746F2D6573636170652D73616E64626F78227D2C7B6E616D653A22616C6C6F772D73616D652D6F72';
wwv_flow_imp.g_varchar2_table(6798) := '6967696E227D2C7B6E616D653A22616C6C6F772D73637269707473227D2C7B6E616D653A22616C6C6F772D746F702D6E617669676174696F6E227D5D7D2C7B6E616D653A227472697374617465222C76616C7565733A5B7B6E616D653A2274727565227D';
wwv_flow_imp.g_varchar2_table(6799) := '2C7B6E616D653A2266616C7365227D2C7B6E616D653A226D69786564227D2C7B6E616D653A22756E646566696E6564227D5D7D2C7B6E616D653A22696E7075746175746F636F6D706C657465222C76616C7565733A5B7B6E616D653A226164646974696F';
wwv_flow_imp.g_varchar2_table(6800) := '6E616C2D6E616D65227D2C7B6E616D653A22616464726573732D6C6576656C31227D2C7B6E616D653A22616464726573732D6C6576656C32227D2C7B6E616D653A22616464726573732D6C6576656C33227D2C7B6E616D653A22616464726573732D6C65';
wwv_flow_imp.g_varchar2_table(6801) := '76656C34227D2C7B6E616D653A22616464726573732D6C696E6531227D2C7B6E616D653A22616464726573732D6C696E6532227D2C7B6E616D653A22616464726573732D6C696E6533227D2C7B6E616D653A2262646179227D2C7B6E616D653A22626461';
wwv_flow_imp.g_varchar2_table(6802) := '792D79656172227D2C7B6E616D653A22626461792D646179227D2C7B6E616D653A22626461792D6D6F6E7468227D2C7B6E616D653A2262696C6C696E67227D2C7B6E616D653A2263632D6164646974696F6E616C2D6E616D65227D2C7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(6803) := '632D637363227D2C7B6E616D653A2263632D657870227D2C7B6E616D653A2263632D6578702D6D6F6E7468227D2C7B6E616D653A2263632D6578702D79656172227D2C7B6E616D653A2263632D66616D696C792D6E616D65227D2C7B6E616D653A226363';
wwv_flow_imp.g_varchar2_table(6804) := '2D676976656E2D6E616D65227D2C7B6E616D653A2263632D6E616D65227D2C7B6E616D653A2263632D6E756D626572227D2C7B6E616D653A2263632D74797065227D2C7B6E616D653A22636F756E747279227D2C7B6E616D653A22636F756E7472792D6E';
wwv_flow_imp.g_varchar2_table(6805) := '616D65227D2C7B6E616D653A2263757272656E742D70617373776F7264227D2C7B6E616D653A22656D61696C227D2C7B6E616D653A2266616D696C792D6E616D65227D2C7B6E616D653A22666178227D2C7B6E616D653A22676976656E2D6E616D65227D';
wwv_flow_imp.g_varchar2_table(6806) := '2C7B6E616D653A22686F6D65227D2C7B6E616D653A22686F6E6F72696669632D707265666978227D2C7B6E616D653A22686F6E6F72696669632D737566666978227D2C7B6E616D653A22696D7070227D2C7B6E616D653A226C616E6775616765227D2C7B';
wwv_flow_imp.g_varchar2_table(6807) := '6E616D653A226D6F62696C65227D2C7B6E616D653A226E616D65227D2C7B6E616D653A226E65772D70617373776F7264227D2C7B6E616D653A226E69636B6E616D65227D2C7B6E616D653A226F7267616E697A6174696F6E227D2C7B6E616D653A226F72';
wwv_flow_imp.g_varchar2_table(6808) := '67616E697A6174696F6E2D7469746C65227D2C7B6E616D653A227061676572227D2C7B6E616D653A2270686F746F227D2C7B6E616D653A22706F7374616C2D636F6465227D2C7B6E616D653A22736578227D2C7B6E616D653A227368697070696E67227D';
wwv_flow_imp.g_varchar2_table(6809) := '2C7B6E616D653A227374726565742D61646472657373227D2C7B6E616D653A2274656C2D617265612D636F6465227D2C7B6E616D653A2274656C227D2C7B6E616D653A2274656C2D636F756E7472792D636F6465227D2C7B6E616D653A2274656C2D6578';
wwv_flow_imp.g_varchar2_table(6810) := '74656E73696F6E227D2C7B6E616D653A2274656C2D6C6F63616C227D2C7B6E616D653A2274656C2D6C6F63616C2D707265666978227D2C7B6E616D653A2274656C2D6C6F63616C2D737566666978227D2C7B6E616D653A2274656C2D6E6174696F6E616C';
wwv_flow_imp.g_varchar2_table(6811) := '227D2C7B6E616D653A227472616E73616374696F6E2D616D6F756E74227D2C7B6E616D653A227472616E73616374696F6E2D63757272656E6379227D2C7B6E616D653A2275726C227D2C7B6E616D653A22757365726E616D65227D2C7B6E616D653A2277';
wwv_flow_imp.g_varchar2_table(6812) := '6F726B227D5D7D2C7B6E616D653A226175746F636F6D706C657465222C76616C7565733A5B7B6E616D653A22696E6C696E65227D2C7B6E616D653A226C697374227D2C7B6E616D653A22626F7468227D2C7B6E616D653A226E6F6E65227D5D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(6813) := '6D653A2263757272656E74222C76616C7565733A5B7B6E616D653A2270616765227D2C7B6E616D653A2273746570227D2C7B6E616D653A226C6F636174696F6E227D2C7B6E616D653A2264617465227D2C7B6E616D653A2274696D65227D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6814) := '3A2274727565227D2C7B6E616D653A2266616C7365227D5D7D2C7B6E616D653A2264726F70656666656374222C76616C7565733A5B7B6E616D653A22636F7079227D2C7B6E616D653A226D6F7665227D2C7B6E616D653A226C696E6B227D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6815) := '3A2265786563757465227D2C7B6E616D653A22706F707570227D2C7B6E616D653A226E6F6E65227D5D7D2C7B6E616D653A22696E76616C6964222C76616C7565733A5B7B6E616D653A226772616D6D6172227D2C7B6E616D653A2266616C7365227D2C7B';
wwv_flow_imp.g_varchar2_table(6816) := '6E616D653A227370656C6C696E67227D2C7B6E616D653A2274727565227D5D7D2C7B6E616D653A226C697665222C76616C7565733A5B7B6E616D653A226F6666227D2C7B6E616D653A22706F6C697465227D2C7B6E616D653A2261737365727469766522';
wwv_flow_imp.g_varchar2_table(6817) := '7D5D7D2C7B6E616D653A226F7269656E746174696F6E222C76616C7565733A5B7B6E616D653A22766572746963616C227D2C7B6E616D653A22686F72697A6F6E74616C227D2C7B6E616D653A22756E646566696E6564227D5D7D2C7B6E616D653A227265';
wwv_flow_imp.g_varchar2_table(6818) := '6C6576616E74222C76616C7565733A5B7B6E616D653A226164646974696F6E73227D2C7B6E616D653A2272656D6F76616C73227D2C7B6E616D653A2274657874227D2C7B6E616D653A22616C6C227D2C7B6E616D653A226164646974696F6E7320746578';
wwv_flow_imp.g_varchar2_table(6819) := '74227D5D7D2C7B6E616D653A22736F7274222C76616C7565733A5B7B6E616D653A22617363656E64696E67227D2C7B6E616D653A2264657363656E64696E67227D2C7B6E616D653A226E6F6E65227D2C7B6E616D653A226F74686572227D5D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(6820) := '6D653A22726F6C6573222C76616C7565733A5B7B6E616D653A22616C657274227D2C7B6E616D653A22616C6572746469616C6F67227D2C7B6E616D653A22627574746F6E227D2C7B6E616D653A22636865636B626F78227D2C7B6E616D653A226469616C';
wwv_flow_imp.g_varchar2_table(6821) := '6F67227D2C7B6E616D653A226772696463656C6C227D2C7B6E616D653A226C696E6B227D2C7B6E616D653A226C6F67227D2C7B6E616D653A226D617271756565227D2C7B6E616D653A226D656E756974656D227D2C7B6E616D653A226D656E756974656D';
wwv_flow_imp.g_varchar2_table(6822) := '636865636B626F78227D2C7B6E616D653A226D656E756974656D726164696F227D2C7B6E616D653A226F7074696F6E227D2C7B6E616D653A2270726F6772657373626172227D2C7B6E616D653A22726164696F227D2C7B6E616D653A227363726F6C6C62';
wwv_flow_imp.g_varchar2_table(6823) := '6172227D2C7B6E616D653A22736561726368626F78227D2C7B6E616D653A22736C69646572227D2C7B6E616D653A227370696E627574746F6E227D2C7B6E616D653A22737461747573227D2C7B6E616D653A22737769746368227D2C7B6E616D653A2274';
wwv_flow_imp.g_varchar2_table(6824) := '6162227D2C7B6E616D653A2274616270616E656C227D2C7B6E616D653A2274657874626F78227D2C7B6E616D653A2274696D6572227D2C7B6E616D653A22746F6F6C746970227D2C7B6E616D653A22747265656974656D227D2C7B6E616D653A22636F6D';
wwv_flow_imp.g_varchar2_table(6825) := '626F626F78227D2C7B6E616D653A2267726964227D2C7B6E616D653A226C697374626F78227D2C7B6E616D653A226D656E75227D2C7B6E616D653A226D656E75626172227D2C7B6E616D653A22726164696F67726F7570227D2C7B6E616D653A22746162';
wwv_flow_imp.g_varchar2_table(6826) := '6C697374227D2C7B6E616D653A2274726565227D2C7B6E616D653A227472656567726964227D2C7B6E616D653A226170706C69636174696F6E227D2C7B6E616D653A2261727469636C65227D2C7B6E616D653A2263656C6C227D2C7B6E616D653A22636F';
wwv_flow_imp.g_varchar2_table(6827) := '6C756D6E686561646572227D2C7B6E616D653A22646566696E6974696F6E227D2C7B6E616D653A226469726563746F7279227D2C7B6E616D653A22646F63756D656E74227D2C7B6E616D653A2266656564227D2C7B6E616D653A22666967757265227D2C';
wwv_flow_imp.g_varchar2_table(6828) := '7B6E616D653A2267726F7570227D2C7B6E616D653A2268656164696E67227D2C7B6E616D653A22696D67227D2C7B6E616D653A226C697374227D2C7B6E616D653A226C6973746974656D227D2C7B6E616D653A226D617468227D2C7B6E616D653A226E6F';
wwv_flow_imp.g_varchar2_table(6829) := '6E65227D2C7B6E616D653A226E6F7465227D2C7B6E616D653A2270726573656E746174696F6E227D2C7B6E616D653A22726567696F6E227D2C7B6E616D653A22726F77227D2C7B6E616D653A22726F7767726F7570227D2C7B6E616D653A22726F776865';
wwv_flow_imp.g_varchar2_table(6830) := '61646572227D2C7B6E616D653A22736570617261746F72227D2C7B6E616D653A227461626C65227D2C7B6E616D653A227465726D227D2C7B6E616D653A2274657874227D2C7B6E616D653A22746F6F6C626172227D2C7B6E616D653A2262616E6E657222';
wwv_flow_imp.g_varchar2_table(6831) := '7D2C7B6E616D653A22636F6D706C656D656E74617279227D2C7B6E616D653A22636F6E74656E74696E666F227D2C7B6E616D653A22666F726D227D2C7B6E616D653A226D61696E227D2C7B6E616D653A226E617669676174696F6E227D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(6832) := '22726567696F6E227D2C7B6E616D653A22736561726368227D2C7B6E616D653A22646F632D6162737472616374227D2C7B6E616D653A22646F632D61636B6E6F776C6564676D656E7473227D2C7B6E616D653A22646F632D6166746572776F7264227D2C';
wwv_flow_imp.g_varchar2_table(6833) := '7B6E616D653A22646F632D617070656E646978227D2C7B6E616D653A22646F632D6261636B6C696E6B227D2C7B6E616D653A22646F632D6269626C696F656E747279227D2C7B6E616D653A22646F632D6269626C696F677261706879227D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(6834) := '3A22646F632D6269626C696F726566227D2C7B6E616D653A22646F632D63686170746572227D2C7B6E616D653A22646F632D636F6C6F70686F6E227D2C7B6E616D653A22646F632D636F6E636C7573696F6E227D2C7B6E616D653A22646F632D636F7665';
wwv_flow_imp.g_varchar2_table(6835) := '72227D2C7B6E616D653A22646F632D637265646974227D2C7B6E616D653A22646F632D63726564697473227D2C7B6E616D653A22646F632D64656469636174696F6E227D2C7B6E616D653A22646F632D656E646E6F7465227D2C7B6E616D653A22646F63';
wwv_flow_imp.g_varchar2_table(6836) := '2D656E646E6F746573227D2C7B6E616D653A22646F632D6570696772617068227D2C7B6E616D653A22646F632D6570696C6F677565227D2C7B6E616D653A22646F632D657272617461227D2C7B6E616D653A22646F632D6578616D706C65227D2C7B6E61';
wwv_flow_imp.g_varchar2_table(6837) := '6D653A22646F632D666F6F746E6F7465227D2C7B6E616D653A22646F632D666F7265776F7264227D2C7B6E616D653A22646F632D676C6F7373617279227D2C7B6E616D653A22646F632D676C6F7373726566227D2C7B6E616D653A22646F632D696E6465';
wwv_flow_imp.g_varchar2_table(6838) := '78227D2C7B6E616D653A22646F632D696E74726F64756374696F6E227D2C7B6E616D653A22646F632D6E6F7465726566227D2C7B6E616D653A22646F632D6E6F74696365227D2C7B6E616D653A22646F632D70616765627265616B227D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(6839) := '22646F632D706167656C697374227D2C7B6E616D653A22646F632D70617274227D2C7B6E616D653A22646F632D70726566616365227D2C7B6E616D653A22646F632D70726F6C6F677565227D2C7B6E616D653A22646F632D70756C6C71756F7465227D2C';
wwv_flow_imp.g_varchar2_table(6840) := '7B6E616D653A22646F632D716E61227D2C7B6E616D653A22646F632D7375627469746C65227D2C7B6E616D653A22646F632D746970227D2C7B6E616D653A22646F632D746F63227D5D7D2C7B6E616D653A226D6574616E616D6573222C76616C7565733A';
wwv_flow_imp.g_varchar2_table(6841) := '5B7B6E616D653A226170706C69636174696F6E2D6E616D65227D2C7B6E616D653A22617574686F72227D2C7B6E616D653A226465736372697074696F6E227D2C7B6E616D653A22666F726D61742D646574656374696F6E227D2C7B6E616D653A2267656E';
wwv_flow_imp.g_varchar2_table(6842) := '657261746F72227D2C7B6E616D653A226B6579776F726473227D2C7B6E616D653A227075626C6973686572227D2C7B6E616D653A227265666572726572227D2C7B6E616D653A22726F626F7473227D2C7B6E616D653A227468656D652D636F6C6F72227D';
wwv_flow_imp.g_varchar2_table(6843) := '2C7B6E616D653A2276696577706F7274227D5D7D2C7B6E616D653A22686173706F707570222C76616C7565733A5B7B6E616D653A2266616C7365222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A2228646566';
wwv_flow_imp.g_varchar2_table(6844) := '61756C742920496E646963617465732074686520656C656D656E7420646F6573206E6F742068617665206120706F7075702E227D7D2C7B6E616D653A2274727565222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75';
wwv_flow_imp.g_varchar2_table(6845) := '653A22496E646963617465732074686520706F7075702069732061206D656E752E227D7D2C7B6E616D653A226D656E75222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686520';
wwv_flow_imp.g_varchar2_table(6846) := '706F7075702069732061206D656E752E227D7D2C7B6E616D653A226C697374626F78222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686520706F7075702069732061206C6973';
wwv_flow_imp.g_varchar2_table(6847) := '74626F782E227D7D2C7B6E616D653A2274726565222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686520706F707570206973206120747265652E227D7D2C7B6E616D653A2267';
wwv_flow_imp.g_varchar2_table(6848) := '726964222C6465736372697074696F6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686520706F707570206973206120677269642E227D7D2C7B6E616D653A226469616C6F67222C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(6849) := '6E3A7B6B696E643A226D61726B646F776E222C76616C75653A22496E646963617465732074686520706F7075702069732061206469616C6F672E227D7D5D7D5D7D2C446C3D66756E6374696F6E28297B66756E6374696F6E20652865297B746869732E64';
wwv_flow_imp.g_varchar2_table(6850) := '61746150726F7669646572733D5B5D2C746869732E7365744461746150726F766964657273282131213D3D652E75736544656661756C744461746150726F76696465722C652E637573746F6D4461746150726F7669646572737C7C5B5D297D7265747572';
wwv_flow_imp.g_varchar2_table(6851) := '6E20652E70726F746F747970652E7365744461746150726F7669646572733D66756E6374696F6E28652C74297B766172206E3B746869732E6461746150726F7669646572733D5B5D2C652626746869732E6461746150726F7669646572732E7075736828';
wwv_flow_imp.g_varchar2_table(6852) := '6E6577206A73282268746D6C35222C486C29292C286E3D746869732E6461746150726F766964657273292E707573682E6170706C79286E2C74297D2C652E70726F746F747970652E6765744461746150726F7669646572733D66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(6853) := '72657475726E20746869732E6461746150726F7669646572737D2C657D28292C4F6C3D7B7D3B66756E6374696F6E20576C28652C74297B72657475726E206E6577206A7328652C74297D76617220506C3D636C6173737B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(6854) := '2C74297B746869732E5F6374783D652C746869732E5F6C616E677561676553657474696E67733D742E6C616E677561676553657474696E67732C746869732E5F6C616E677561676549643D742E6C616E677561676549643B636F6E7374206E3D74686973';
wwv_flow_imp.g_varchar2_table(6855) := '2E5F6C616E677561676553657474696E67732E646174612C693D6E3F2E75736544656661756C744461746150726F76696465722C723D5B5D3B6966286E3F2E6461746150726F76696465727329666F7228636F6E7374206520696E206E2E646174615072';
wwv_flow_imp.g_varchar2_table(6856) := '6F76696465727329722E7075736828576C28652C6E2E6461746150726F7669646572735B655D29293B746869732E5F6C616E6775616765536572766963653D66756E6374696F6E2865297B766F696420303D3D3D65262628653D4F6C293B76617220743D';
wwv_flow_imp.g_varchar2_table(6857) := '6E657720446C2865292C6E3D6E6577206C6C28652C74292C693D6E6577206E6C28652C74293B72657475726E7B7365744461746150726F7669646572733A742E7365744461746150726F7669646572732E62696E642874292C6372656174655363616E6E';
wwv_flow_imp.g_varchar2_table(6858) := '65723A41732C706172736548544D4C446F63756D656E743A66756E6374696F6E2865297B72657475726E207A7328652E676574546578742829297D2C646F436F6D706C6574653A692E646F436F6D706C6574652E62696E642869292C646F436F6D706C65';
wwv_flow_imp.g_varchar2_table(6859) := '7465323A692E646F436F6D706C657465322E62696E642869292C736574436F6D706C6574696F6E5061727469636970616E74733A692E736574436F6D706C6574696F6E5061727469636970616E74732E62696E642869292C646F486F7665723A6E2E646F';
wwv_flow_imp.g_varchar2_table(6860) := '486F7665722E62696E64286E292C666F726D61743A6D6C2C66696E64446F63756D656E74486967686C69676874733A536C2C66696E64446F63756D656E744C696E6B733A6B6C2C66696E64446F63756D656E7453796D626F6C733A456C2C676574466F6C';
wwv_flow_imp.g_varchar2_table(6861) := '64696E6752616E6765733A496C2C67657453656C656374696F6E52616E6765733A7A6C2C646F51756F7465436F6D706C6574653A692E646F51756F7465436F6D706C6574652E62696E642869292C646F546167436F6D706C6574653A692E646F54616743';
wwv_flow_imp.g_varchar2_table(6862) := '6F6D706C6574652E62696E642869292C646F52656E616D653A526C2C66696E644D61746368696E67546167506F736974696F6E3A4D6C2C66696E644F6E5479706552656E616D6552616E6765733A4E6C2C66696E644C696E6B656445646974696E675261';
wwv_flow_imp.g_varchar2_table(6863) := '6E6765733A4E6C7D7D287B75736544656661756C744461746150726F76696465723A692C637573746F6D4461746150726F7669646572733A727D297D6173796E6320646F436F6D706C65746528652C74297B6C6574206E3D746869732E5F676574546578';
wwv_flow_imp.g_varchar2_table(6864) := '74446F63756D656E742865293B696628216E2972657475726E206E756C6C3B6C657420693D746869732E5F6C616E6775616765536572766963652E706172736548544D4C446F63756D656E74286E293B72657475726E2050726F6D6973652E7265736F6C';
wwv_flow_imp.g_varchar2_table(6865) := '766528746869732E5F6C616E6775616765536572766963652E646F436F6D706C657465286E2C742C692C746869732E5F6C616E677561676553657474696E67732626746869732E5F6C616E677561676553657474696E67732E7375676765737429297D61';
wwv_flow_imp.g_varchar2_table(6866) := '73796E6320666F726D617428652C742C6E297B6C657420693D746869732E5F67657454657874446F63756D656E742865293B69662821692972657475726E5B5D3B6C657420723D7B2E2E2E746869732E5F6C616E677561676553657474696E67732E666F';
wwv_flow_imp.g_varchar2_table(6867) := '726D61742C2E2E2E6E7D2C6F3D746869732E5F6C616E6775616765536572766963652E666F726D617428692C742C72293B72657475726E2050726F6D6973652E7265736F6C7665286F297D6173796E6320646F486F76657228652C74297B6C6574206E3D';
wwv_flow_imp.g_varchar2_table(6868) := '746869732E5F67657454657874446F63756D656E742865293B696628216E2972657475726E206E756C6C3B6C657420693D746869732E5F6C616E6775616765536572766963652E706172736548544D4C446F63756D656E74286E292C723D746869732E5F';
wwv_flow_imp.g_varchar2_table(6869) := '6C616E6775616765536572766963652E646F486F766572286E2C742C69293B72657475726E2050726F6D6973652E7265736F6C76652872297D6173796E632066696E64446F63756D656E74486967686C696768747328652C74297B6C6574206E3D746869';
wwv_flow_imp.g_varchar2_table(6870) := '732E5F67657454657874446F63756D656E742865293B696628216E2972657475726E5B5D3B6C657420693D746869732E5F6C616E6775616765536572766963652E706172736548544D4C446F63756D656E74286E292C723D746869732E5F6C616E677561';
wwv_flow_imp.g_varchar2_table(6871) := '6765536572766963652E66696E64446F63756D656E74486967686C6967687473286E2C742C69293B72657475726E2050726F6D6973652E7265736F6C76652872297D6173796E632066696E64446F63756D656E744C696E6B732865297B6C657420743D74';
wwv_flow_imp.g_varchar2_table(6872) := '6869732E5F67657454657874446F63756D656E742865293B69662821742972657475726E5B5D3B6C6574206E3D746869732E5F6C616E6775616765536572766963652E66696E64446F63756D656E744C696E6B7328742C6E756C6C293B72657475726E20';
wwv_flow_imp.g_varchar2_table(6873) := '50726F6D6973652E7265736F6C7665286E297D6173796E632066696E64446F63756D656E7453796D626F6C732865297B6C657420743D746869732E5F67657454657874446F63756D656E742865293B69662821742972657475726E5B5D3B6C6574206E3D';
wwv_flow_imp.g_varchar2_table(6874) := '746869732E5F6C616E6775616765536572766963652E706172736548544D4C446F63756D656E742874292C693D746869732E5F6C616E6775616765536572766963652E66696E64446F63756D656E7453796D626F6C7328742C6E293B72657475726E2050';
wwv_flow_imp.g_varchar2_table(6875) := '726F6D6973652E7265736F6C76652869297D6173796E6320676574466F6C64696E6752616E67657328652C74297B6C6574206E3D746869732E5F67657454657874446F63756D656E742865293B696628216E2972657475726E5B5D3B6C657420693D7468';
wwv_flow_imp.g_varchar2_table(6876) := '69732E5F6C616E6775616765536572766963652E676574466F6C64696E6752616E676573286E2C74293B72657475726E2050726F6D6973652E7265736F6C76652869297D6173796E632067657453656C656374696F6E52616E67657328652C74297B6C65';
wwv_flow_imp.g_varchar2_table(6877) := '74206E3D746869732E5F67657454657874446F63756D656E742865293B696628216E2972657475726E5B5D3B6C657420693D746869732E5F6C616E6775616765536572766963652E67657453656C656374696F6E52616E676573286E2C74293B72657475';
wwv_flow_imp.g_varchar2_table(6878) := '726E2050726F6D6973652E7265736F6C76652869297D6173796E6320646F52656E616D6528652C742C6E297B6C657420693D746869732E5F67657454657874446F63756D656E742865293B69662821692972657475726E206E756C6C3B6C657420723D74';
wwv_flow_imp.g_varchar2_table(6879) := '6869732E5F6C616E6775616765536572766963652E706172736548544D4C446F63756D656E742869292C6F3D746869732E5F6C616E6775616765536572766963652E646F52656E616D6528692C742C6E2C72293B72657475726E2050726F6D6973652E72';
wwv_flow_imp.g_varchar2_table(6880) := '65736F6C7665286F297D5F67657454657874446F63756D656E742865297B6C657420743D746869732E5F6374782E6765744D6972726F724D6F64656C7328293B666F72286C6574206E206F662074296966286E2E7572692E746F537472696E6728293D3D';
wwv_flow_imp.g_varchar2_table(6881) := '3D652972657475726E205A612E63726561746528652C746869732E5F6C616E677561676549642C6E2E76657273696F6E2C6E2E67657456616C75652829293B72657475726E206E756C6C7D7D3B73656C662E6F6E6D6573736167653D28293D3E7B597228';
wwv_flow_imp.g_varchar2_table(6882) := '2828652C74293D3E6E657720506C28652C742929297D7D2928293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5450498221531701)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/html.worker.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C6561736520736565206A736F6E2E776F726B65722E6A732E4C4943454E53452E747874202A2F0A2828293D3E7B2275736520737472696374223B636F6E737420653D6E657720';
wwv_flow_imp.g_varchar2_table(2) := '636C6173737B636F6E7374727563746F7228297B746869732E6C697374656E6572733D5B5D2C746869732E756E65787065637465644572726F7248616E646C65723D66756E6374696F6E2865297B73657454696D656F7574282828293D3E7B696628652E';
wwv_flow_imp.g_varchar2_table(3) := '737461636B297B696628732E69734572726F724E6F54656C656D65747279286529297468726F77206E6577207328652E6D6573736167652B225C6E5C6E222B652E737461636B293B7468726F77206E6577204572726F7228652E6D6573736167652B225C';
wwv_flow_imp.g_varchar2_table(4) := '6E5C6E222B652E737461636B297D7468726F7720657D292C30297D7D656D69742865297B746869732E6C697374656E6572732E666F72456163682828743D3E7B742865297D29297D6F6E556E65787065637465644572726F722865297B746869732E756E';
wwv_flow_imp.g_varchar2_table(5) := '65787065637465644572726F7248616E646C65722865292C746869732E656D69742865297D6F6E556E657870656374656445787465726E616C4572726F722865297B746869732E756E65787065637465644572726F7248616E646C65722865297D7D3B66';
wwv_flow_imp.g_varchar2_table(6) := '756E6374696F6E20742874297B766172206E3B286E3D7429696E7374616E63656F6620697C7C6E20696E7374616E63656F66204572726F7226266E2E6E616D653D3D3D7226266E2E6D6573736167653D3D3D727C7C652E6F6E556E657870656374656445';
wwv_flow_imp.g_varchar2_table(7) := '72726F722874297D66756E6374696F6E206E2865297B6966286520696E7374616E63656F66204572726F72297B636F6E73747B6E616D653A742C6D6573736167653A6E7D3D653B72657475726E7B2469734572726F723A21302C6E616D653A742C6D6573';
wwv_flow_imp.g_varchar2_table(8) := '736167653A6E2C737461636B3A652E737461636B74726163657C7C652E737461636B2C6E6F54656C656D657472793A732E69734572726F724E6F54656C656D657472792865297D7D72657475726E20657D636F6E737420723D2243616E63656C6564223B';
wwv_flow_imp.g_varchar2_table(9) := '636C617373206920657874656E6473204572726F727B636F6E7374727563746F7228297B73757065722872292C746869732E6E616D653D746869732E6D6573736167657D7D4572726F723B636C617373207320657874656E6473204572726F727B636F6E';
wwv_flow_imp.g_varchar2_table(10) := '7374727563746F722865297B73757065722865292C746869732E6E616D653D22436F646545787065637465644572726F72227D7374617469632066726F6D4572726F722865297B6966286520696E7374616E63656F6620732972657475726E20653B636F';
wwv_flow_imp.g_varchar2_table(11) := '6E737420743D6E657720733B72657475726E20742E6D6573736167653D652E6D6573736167652C742E737461636B3D652E737461636B2C747D7374617469632069734572726F724E6F54656C656D657472792865297B72657475726E22436F6465457870';
wwv_flow_imp.g_varchar2_table(12) := '65637465644572726F72223D3D3D652E6E616D657D7D636C617373206F20657874656E6473204572726F727B636F6E7374727563746F722865297B737570657228657C7C22416E20756E657870656374656420627567206F636375727265642E22292C4F';
wwv_flow_imp.g_varchar2_table(13) := '626A6563742E73657450726F746F747970654F6628746869732C6F2E70726F746F74797065297D7D66756E6374696F6E206128652C74297B636F6E7374206E3D746869733B6C657420722C693D21313B72657475726E2066756E6374696F6E28297B6966';
wwv_flow_imp.g_varchar2_table(14) := '28692972657475726E20723B696628693D21302C74297472797B723D652E6170706C79286E2C617267756D656E7473297D66696E616C6C797B7428297D656C736520723D652E6170706C79286E2C617267756D656E7473293B72657475726E20727D7D76';
wwv_flow_imp.g_varchar2_table(15) := '6172206C3B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E20652626226F626A656374223D3D747970656F66206526262266756E6374696F6E223D3D747970656F6620655B53796D626F6C2E6974657261746F725D7D';
wwv_flow_imp.g_varchar2_table(16) := '652E69733D743B636F6E7374206E3D4F626A6563742E667265657A65285B5D293B66756E6374696F6E2A722865297B7969656C6420657D652E656D7074793D66756E6374696F6E28297B72657475726E206E7D2C652E73696E676C653D722C652E777261';
wwv_flow_imp.g_varchar2_table(17) := '703D66756E6374696F6E2865297B72657475726E20742865293F653A722865297D2C652E66726F6D3D66756E6374696F6E2865297B72657475726E20657C7C6E7D2C652E726576657273653D66756E6374696F6E2A2865297B666F72286C657420743D65';
wwv_flow_imp.g_varchar2_table(18) := '2E6C656E6774682D313B743E3D303B742D2D297969656C6420655B745D7D2C652E6973456D7074793D66756E6374696F6E2865297B72657475726E21657C7C21303D3D3D655B53796D626F6C2E6974657261746F725D28292E6E65787428292E646F6E65';
wwv_flow_imp.g_varchar2_table(19) := '7D2C652E66697273743D66756E6374696F6E2865297B72657475726E20655B53796D626F6C2E6974657261746F725D28292E6E65787428292E76616C75657D2C652E736F6D653D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F6620';
wwv_flow_imp.g_varchar2_table(20) := '652969662874286E292972657475726E21303B72657475726E21317D2C652E66696E643D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F6620652969662874286E292972657475726E206E7D2C652E66696C7465723D66756E637469';
wwv_flow_imp.g_varchar2_table(21) := '6F6E2A28652C74297B666F7228636F6E7374206E206F6620652974286E292626287969656C64206E297D2C652E6D61703D66756E6374696F6E2A28652C74297B6C6574206E3D303B666F7228636F6E73742072206F662065297969656C64207428722C6E';
wwv_flow_imp.g_varchar2_table(22) := '2B2B297D2C652E636F6E6361743D66756E6374696F6E2A282E2E2E65297B666F7228636F6E73742074206F662065297969656C642A747D2C652E7265647563653D66756E6374696F6E28652C742C6E297B6C657420723D6E3B666F7228636F6E7374206E';
wwv_flow_imp.g_varchar2_table(23) := '206F66206529723D7428722C6E293B72657475726E20727D2C652E736C6963653D66756E6374696F6E2A28652C742C6E3D652E6C656E677468297B666F7228743C30262628742B3D652E6C656E677468292C6E3C303F6E2B3D652E6C656E6774683A6E3E';
wwv_flow_imp.g_varchar2_table(24) := '652E6C656E6774682626286E3D652E6C656E677468293B743C6E3B742B2B297969656C6420655B745D7D2C652E636F6E73756D653D66756E6374696F6E28742C6E3D4E756D6265722E504F5349544956455F494E46494E495459297B636F6E737420723D';
wwv_flow_imp.g_varchar2_table(25) := '5B5D3B696628303D3D3D6E2972657475726E5B722C745D3B636F6E737420693D745B53796D626F6C2E6974657261746F725D28293B666F72286C657420743D303B743C6E3B742B2B297B636F6E737420743D692E6E65787428293B696628742E646F6E65';
wwv_flow_imp.g_varchar2_table(26) := '2972657475726E5B722C652E656D70747928295D3B722E7075736828742E76616C7565297D72657475726E5B722C7B5B53796D626F6C2E6974657261746F725D3A28293D3E697D5D7D2C652E6173796E63546F41727261793D6173796E632066756E6374';
wwv_flow_imp.g_varchar2_table(27) := '696F6E2865297B636F6E737420743D5B5D3B666F7220617761697428636F6E7374206E206F66206529742E70757368286E293B72657475726E2050726F6D6973652E7265736F6C76652874297D7D286C7C7C286C3D7B7D29293B6C657420753D6E756C6C';
wwv_flow_imp.g_varchar2_table(28) := '3B66756E6374696F6E20632865297B72657475726E206E756C6C3D3D757C7C752E747261636B446973706F7361626C652865292C657D66756E6374696F6E20682865297B6E756C6C3D3D757C7C752E6D61726B4173446973706F7365642865297D66756E';
wwv_flow_imp.g_varchar2_table(29) := '6374696F6E206428652C74297B6E756C6C3D3D757C7C752E736574506172656E7428652C74297D66756E6374696F6E20662865297B6966286C2E6973286529297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065296966286E297472';
wwv_flow_imp.g_varchar2_table(30) := '797B6E2E646973706F736528297D63617463682865297B742E707573682865297D696628313D3D3D742E6C656E677468297468726F7720745B305D3B696628742E6C656E6774683E31297468726F77206E6577204167677265676174654572726F722874';
wwv_flow_imp.g_varchar2_table(31) := '2C22456E636F756E7465726564206572726F7273207768696C6520646973706F73696E67206F662073746F726522293B72657475726E2041727261792E697341727261792865293F5B5D3A657D696628652972657475726E20652E646973706F73652829';
wwv_flow_imp.g_varchar2_table(32) := '2C657D66756E6374696F6E206D2865297B636F6E737420743D63287B646973706F73653A61282828293D3E7B682874292C6528297D29297D293B72657475726E20747D636C61737320677B636F6E7374727563746F7228297B746869732E5F746F446973';
wwv_flow_imp.g_varchar2_table(33) := '706F73653D6E6577205365742C746869732E5F6973446973706F7365643D21312C632874686973297D646973706F736528297B746869732E5F6973446973706F7365647C7C28682874686973292C746869732E5F6973446973706F7365643D21302C7468';
wwv_flow_imp.g_varchar2_table(34) := '69732E636C6561722829297D676574206973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D636C65617228297B69662830213D3D746869732E5F746F446973706F73652E73697A65297472797B6628746869732E';
wwv_flow_imp.g_varchar2_table(35) := '5F746F446973706F7365297D66696E616C6C797B746869732E5F746F446973706F73652E636C65617228297D7D6164642865297B69662821652972657475726E20653B696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E';
wwv_flow_imp.g_varchar2_table(36) := '6F74207265676973746572206120646973706F7361626C65206F6E20697473656C662122293B72657475726E206428652C74686973292C746869732E5F6973446973706F7365643F672E44495341424C455F444953504F5345445F5741524E494E477C7C';
wwv_flow_imp.g_varchar2_table(37) := '636F6E736F6C652E7761726E286E6577204572726F722822547279696E6720746F20616464206120646973706F7361626C6520746F206120446973706F7361626C6553746F726520746861742068617320616C7265616479206265656E20646973706F73';
wwv_flow_imp.g_varchar2_table(38) := '6564206F662E20546865206164646564206F626A6563742077696C6C206265206C65616B65642122292E737461636B293A746869732E5F746F446973706F73652E6164642865292C657D64656C657465416E644C65616B2865297B652626746869732E5F';
wwv_flow_imp.g_varchar2_table(39) := '746F446973706F73652E686173286529262628746869732E5F746F446973706F73652E64656C6574652865292C6428652C6E756C6C29297D7D672E44495341424C455F444953504F5345445F5741524E494E473D21313B636C61737320707B636F6E7374';
wwv_flow_imp.g_varchar2_table(40) := '727563746F7228297B746869732E5F73746F72653D6E657720672C632874686973292C6428746869732E5F73746F72652C74686973297D646973706F736528297B682874686973292C746869732E5F73746F72652E646973706F736528297D5F72656769';
wwv_flow_imp.g_varchar2_table(41) := '737465722865297B696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E6F74207265676973746572206120646973706F7361626C65206F6E20697473656C662122293B72657475726E20746869732E5F73746F72652E6164';
wwv_flow_imp.g_varchar2_table(42) := '642865297D7D702E4E6F6E653D4F626A6563742E667265657A65287B646973706F736528297B7D7D292C53796D626F6C2E6974657261746F723B636C61737320767B636F6E7374727563746F722865297B746869732E656C656D656E743D652C74686973';
wwv_flow_imp.g_varchar2_table(43) := '2E6E6578743D762E556E646566696E65642C746869732E707265763D762E556E646566696E65647D7D762E556E646566696E65643D6E6577207628766F69642030293B636C61737320627B636F6E7374727563746F7228297B746869732E5F6669727374';
wwv_flow_imp.g_varchar2_table(44) := '3D762E556E646566696E65642C746869732E5F6C6173743D762E556E646566696E65642C746869732E5F73697A653D307D6765742073697A6528297B72657475726E20746869732E5F73697A657D6973456D70747928297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(45) := '5F66697273743D3D3D762E556E646566696E65647D636C65617228297B6C657420653D746869732E5F66697273743B666F72283B65213D3D762E556E646566696E65643B297B636F6E737420743D652E6E6578743B652E707265763D762E556E64656669';
wwv_flow_imp.g_varchar2_table(46) := '6E65642C652E6E6578743D762E556E646566696E65642C653D747D746869732E5F66697273743D762E556E646566696E65642C746869732E5F6C6173743D762E556E646566696E65642C746869732E5F73697A653D307D756E73686966742865297B7265';
wwv_flow_imp.g_varchar2_table(47) := '7475726E20746869732E5F696E7365727428652C2131297D707573682865297B72657475726E20746869732E5F696E7365727428652C2130297D5F696E7365727428652C74297B636F6E7374206E3D6E657720762865293B696628746869732E5F666972';
wwv_flow_imp.g_varchar2_table(48) := '73743D3D3D762E556E646566696E656429746869732E5F66697273743D6E2C746869732E5F6C6173743D6E3B656C73652069662874297B636F6E737420653D746869732E5F6C6173743B746869732E5F6C6173743D6E2C6E2E707265763D652C652E6E65';
wwv_flow_imp.g_varchar2_table(49) := '78743D6E7D656C73657B636F6E737420653D746869732E5F66697273743B746869732E5F66697273743D6E2C6E2E6E6578743D652C652E707265763D6E7D746869732E5F73697A652B3D313B6C657420723D21313B72657475726E28293D3E7B727C7C28';
wwv_flow_imp.g_varchar2_table(50) := '723D21302C746869732E5F72656D6F7665286E29297D7D736869667428297B696628746869732E5F6669727374213D3D762E556E646566696E6564297B636F6E737420653D746869732E5F66697273742E656C656D656E743B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(51) := '2E5F72656D6F766528746869732E5F6669727374292C657D7D706F7028297B696628746869732E5F6C617374213D3D762E556E646566696E6564297B636F6E737420653D746869732E5F6C6173742E656C656D656E743B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(52) := '72656D6F766528746869732E5F6C617374292C657D7D5F72656D6F76652865297B696628652E70726576213D3D762E556E646566696E65642626652E6E657874213D3D762E556E646566696E6564297B636F6E737420743D652E707265763B742E6E6578';
wwv_flow_imp.g_varchar2_table(53) := '743D652E6E6578742C652E6E6578742E707265763D747D656C736520652E707265763D3D3D762E556E646566696E65642626652E6E6578743D3D3D762E556E646566696E65643F28746869732E5F66697273743D762E556E646566696E65642C74686973';
wwv_flow_imp.g_varchar2_table(54) := '2E5F6C6173743D762E556E646566696E6564293A652E6E6578743D3D3D762E556E646566696E65643F28746869732E5F6C6173743D746869732E5F6C6173742E707265762C746869732E5F6C6173742E6E6578743D762E556E646566696E6564293A652E';
wwv_flow_imp.g_varchar2_table(55) := '707265763D3D3D762E556E646566696E6564262628746869732E5F66697273743D746869732E5F66697273742E6E6578742C746869732E5F66697273742E707265763D762E556E646566696E6564293B746869732E5F73697A652D3D317D2A5B53796D62';
wwv_flow_imp.g_varchar2_table(56) := '6F6C2E6974657261746F725D28297B6C657420653D746869732E5F66697273743B666F72283B65213D3D762E556E646566696E65643B297969656C6420652E656C656D656E742C653D652E6E6578747D7D636F6E737420793D676C6F62616C546869732E';
wwv_flow_imp.g_varchar2_table(57) := '706572666F726D616E636526262266756E6374696F6E223D3D747970656F6620676C6F62616C546869732E706572666F726D616E63652E6E6F773B636C617373205F7B737461746963206372656174652865297B72657475726E206E6577205F2865297D';
wwv_flow_imp.g_varchar2_table(58) := '636F6E7374727563746F722865297B746869732E5F6E6F773D79262621313D3D3D653F446174652E6E6F773A676C6F62616C546869732E706572666F726D616E63652E6E6F772E62696E6428676C6F62616C546869732E706572666F726D616E6365292C';
wwv_flow_imp.g_varchar2_table(59) := '746869732E5F737461727454696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D73746F7028297B746869732E5F73746F7054696D653D746869732E5F6E6F7728297D726573657428297B746869732E5F737461727454';
wwv_flow_imp.g_varchar2_table(60) := '696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D656C617073656428297B72657475726E2D31213D3D746869732E5F73746F7054696D653F746869732E5F73746F7054696D652D746869732E5F737461727454696D65';
wwv_flow_imp.g_varchar2_table(61) := '3A746869732E5F6E6F7728292D746869732E5F737461727454696D657D7D76617220433B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E28742C6E3D6E756C6C2C72293D3E7B6C657420692C733D21313B7265747572';
wwv_flow_imp.g_varchar2_table(62) := '6E20693D652828653D3E7B69662821732972657475726E20693F692E646973706F736528293A733D21302C742E63616C6C286E2C65297D292C6E756C6C2C72292C732626692E646973706F736528292C697D7D66756E6374696F6E206E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(63) := '7B72657475726E20692828286E2C723D6E756C6C2C69293D3E652828653D3E6E2E63616C6C28722C7428652929292C6E756C6C2C6929292C6E297D66756E6374696F6E207228652C742C6E297B72657475726E20692828286E2C723D6E756C6C2C69293D';
wwv_flow_imp.g_varchar2_table(64) := '3E652828653D3E7428652926266E2E63616C6C28722C6529292C6E756C6C2C6929292C6E297D66756E6374696F6E206928652C74297B6C6574206E3B636F6E737420723D6E65772078287B6F6E57696C6C41646446697273744C697374656E657228297B';
wwv_flow_imp.g_varchar2_table(65) := '6E3D6528722E666972652C72297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B6E756C6C3D3D6E7C7C6E2E646973706F736528297D7D293B72657475726E206E756C6C3D3D747C7C742E6164642872292C722E6576656E747D6675';
wwv_flow_imp.g_varchar2_table(66) := '6E6374696F6E207328652C742C6E3D3130302C723D21312C693D21312C732C6F297B6C657420612C6C2C752C632C683D303B636F6E737420643D6E65772078287B6C65616B5761726E696E675468726573686F6C643A732C6F6E57696C6C416464466972';
wwv_flow_imp.g_varchar2_table(67) := '73744C697374656E657228297B613D652828653D3E7B682B2B2C6C3D74286C2C65292C7226262175262628642E66697265286C292C6C3D766F69642030292C633D28293D3E7B636F6E737420653D6C3B6C3D766F696420302C753D766F696420302C2821';
wwv_flow_imp.g_varchar2_table(68) := '727C7C683E31292626642E666972652865292C683D307D2C226E756D626572223D3D747970656F66206E3F28636C65617254696D656F75742875292C753D73657454696D656F757428632C6E29293A766F696420303D3D3D75262628753D302C71756575';
wwv_flow_imp.g_varchar2_table(69) := '654D6963726F7461736B286329297D29297D2C6F6E57696C6C52656D6F76654C697374656E657228297B692626683E302626286E756C6C3D3D637C7C632829297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B633D766F69642030';
wwv_flow_imp.g_varchar2_table(70) := '2C612E646973706F736528297D7D293B72657475726E206E756C6C3D3D6F7C7C6F2E6164642864292C642E6576656E747D652E4E6F6E653D28293D3E702E4E6F6E652C652E64656665723D66756E6374696F6E28652C74297B72657475726E207328652C';
wwv_flow_imp.g_varchar2_table(71) := '2828293D3E7B7D292C302C766F696420302C21302C766F696420302C74297D2C652E6F6E63653D742C652E6D61703D6E2C652E666F72456163683D66756E6374696F6E28652C742C6E297B72657475726E20692828286E2C723D6E756C6C2C69293D3E65';
wwv_flow_imp.g_varchar2_table(72) := '2828653D3E7B742865292C6E2E63616C6C28722C65297D292C6E756C6C2C6929292C6E297D2C652E66696C7465723D722C652E7369676E616C3D66756E6374696F6E2865297B72657475726E20657D2C652E616E793D66756E6374696F6E282E2E2E6529';
wwv_flow_imp.g_varchar2_table(73) := '7B72657475726E28742C6E3D6E756C6C2C72293D3E7B72657475726E20693D66756E6374696F6E282E2E2E65297B636F6E737420743D6D282828293D3E6628652929293B72657475726E2066756E6374696F6E28652C74297B6966287529666F7228636F';
wwv_flow_imp.g_varchar2_table(74) := '6E7374206E206F66206529752E736574506172656E74286E2C74297D28652C74292C747D282E2E2E652E6D61702828653D3E652828653D3E742E63616C6C286E2C652929292929292C28733D7229696E7374616E63656F662041727261793F732E707573';
wwv_flow_imp.g_varchar2_table(75) := '682869293A732626732E6164642869292C693B76617220692C737D7D2C652E7265647563653D66756E6374696F6E28652C742C722C69297B6C657420733D723B72657475726E206E28652C28653D3E28733D7428732C65292C7329292C69297D2C652E64';
wwv_flow_imp.g_varchar2_table(76) := '65626F756E63653D732C652E616363756D756C6174653D66756E6374696F6E28742C6E3D302C72297B72657475726E20652E6465626F756E636528742C2828652C74293D3E653F28652E707573682874292C65293A5B745D292C6E2C766F696420302C21';
wwv_flow_imp.g_varchar2_table(77) := '302C766F696420302C72297D2C652E6C617463683D66756E6374696F6E28652C743D28652C74293D3E653D3D3D742C6E297B6C657420692C733D21303B72657475726E207228652C28653D3E7B636F6E7374206E3D737C7C217428652C69293B72657475';
wwv_flow_imp.g_varchar2_table(78) := '726E20733D21312C693D652C6E7D292C6E297D2C652E73706C69743D66756E6374696F6E28742C6E2C72297B72657475726E5B652E66696C74657228742C6E2C72292C652E66696C74657228742C28653D3E216E286529292C72295D7D2C652E62756666';
wwv_flow_imp.g_varchar2_table(79) := '65723D66756E6374696F6E28652C743D21312C6E3D5B5D2C72297B6C657420693D6E2E736C69636528292C733D652828653D3E7B693F692E707573682865293A612E666972652865297D29293B722626722E6164642873293B636F6E7374206F3D28293D';
wwv_flow_imp.g_varchar2_table(80) := '3E7B6E756C6C3D3D697C7C692E666F72456163682828653D3E612E6669726528652929292C693D6E756C6C7D2C613D6E65772078287B6F6E57696C6C41646446697273744C697374656E657228297B737C7C28733D652828653D3E612E66697265286529';
wwv_flow_imp.g_varchar2_table(81) := '29292C722626722E616464287329297D2C6F6E44696441646446697273744C697374656E657228297B69262628743F73657454696D656F7574286F293A6F2829297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B732626732E6469';
wwv_flow_imp.g_varchar2_table(82) := '73706F736528292C733D6E756C6C7D7D293B72657475726E20722626722E6164642861292C612E6576656E747D2C652E636861696E3D66756E6374696F6E28652C74297B72657475726E286E2C722C69293D3E7B636F6E737420733D74286E6577206129';
wwv_flow_imp.g_varchar2_table(83) := '3B72657475726E2065282866756E6374696F6E2865297B636F6E737420743D732E6576616C756174652865293B74213D3D6F26266E2E63616C6C28722C74297D292C766F696420302C69297D7D3B636F6E7374206F3D53796D626F6C282248616C744368';
wwv_flow_imp.g_varchar2_table(84) := '61696E61626C6522293B636C61737320617B636F6E7374727563746F7228297B746869732E73746570733D5B5D7D6D61702865297B72657475726E20746869732E73746570732E707573682865292C746869737D666F72456163682865297B7265747572';
wwv_flow_imp.g_varchar2_table(85) := '6E20746869732E73746570732E707573682828743D3E28652874292C742929292C746869737D66696C7465722865297B72657475726E20746869732E73746570732E707573682828743D3E652874293F743A6F29292C746869737D72656475636528652C';
wwv_flow_imp.g_varchar2_table(86) := '74297B6C6574206E3D743B72657475726E20746869732E73746570732E707573682828743D3E286E3D65286E2C74292C6E2929292C746869737D6C6174636828653D28652C74293D3E653D3D3D74297B6C657420742C6E3D21303B72657475726E207468';
wwv_flow_imp.g_varchar2_table(87) := '69732E73746570732E707573682828723D3E7B636F6E737420693D6E7C7C216528722C74293B72657475726E206E3D21312C743D722C693F723A6F7D29292C746869737D6576616C756174652865297B666F7228636F6E73742074206F6620746869732E';
wwv_flow_imp.g_varchar2_table(88) := '73746570732969662828653D74286529293D3D3D6F29627265616B3B72657475726E20657D7D652E66726F6D4E6F64654576656E74456D69747465723D66756E6374696F6E28652C742C6E3D653D3E65297B636F6E737420723D282E2E2E65293D3E692E';
wwv_flow_imp.g_varchar2_table(89) := '66697265286E282E2E2E6529292C693D6E65772078287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6F6E28742C72292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F76654C697374';
wwv_flow_imp.g_varchar2_table(90) := '656E657228742C72297D293B72657475726E20692E6576656E747D2C652E66726F6D444F4D4576656E74456D69747465723D66756E6374696F6E28652C742C6E3D653D3E65297B636F6E737420723D282E2E2E65293D3E692E66697265286E282E2E2E65';
wwv_flow_imp.g_varchar2_table(91) := '29292C693D6E65772078287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6164644576656E744C697374656E657228742C72292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F766545';
wwv_flow_imp.g_varchar2_table(92) := '76656E744C697374656E657228742C72297D293B72657475726E20692E6576656E747D2C652E746F50726F6D6973653D66756E6374696F6E2865297B72657475726E206E65772050726F6D69736528286E3D3E74286529286E2929297D2C652E66726F6D';
wwv_flow_imp.g_varchar2_table(93) := '50726F6D6973653D66756E6374696F6E2865297B636F6E737420743D6E657720783B72657475726E20652E7468656E2828653D3E7B742E666972652865297D292C2828293D3E7B742E6669726528766F69642030297D29292E66696E616C6C7928282829';
wwv_flow_imp.g_varchar2_table(94) := '3D3E7B742E646973706F736528297D29292C742E6576656E747D2C652E72756E416E645375627363726962653D66756E6374696F6E28652C742C6E297B72657475726E2074286E292C652828653D3E7428652929297D3B636C617373206C7B636F6E7374';
wwv_flow_imp.g_varchar2_table(95) := '727563746F7228652C74297B746869732E5F6F627365727661626C653D652C746869732E5F636F756E7465723D302C746869732E5F6861734368616E6765643D21313B636F6E7374206E3D7B6F6E57696C6C41646446697273744C697374656E65723A28';
wwv_flow_imp.g_varchar2_table(96) := '293D3E7B652E6164644F627365727665722874686973297D2C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E7B652E72656D6F76654F627365727665722874686973297D7D3B746869732E656D69747465723D6E65772078286E29';
wwv_flow_imp.g_varchar2_table(97) := '2C742626742E61646428746869732E656D6974746572297D626567696E5570646174652865297B746869732E5F636F756E7465722B2B7D68616E646C65506F737369626C654368616E67652865297B7D68616E646C654368616E676528652C74297B7468';
wwv_flow_imp.g_varchar2_table(98) := '69732E5F6861734368616E6765643D21307D656E645570646174652865297B746869732E5F636F756E7465722D2D2C303D3D3D746869732E5F636F756E746572262628746869732E5F6F627365727661626C652E7265706F72744368616E67657328292C';
wwv_flow_imp.g_varchar2_table(99) := '746869732E5F6861734368616E676564262628746869732E5F6861734368616E6765643D21312C746869732E656D69747465722E6669726528746869732E5F6F627365727661626C652E67657428292929297D7D652E66726F6D4F627365727661626C65';
wwv_flow_imp.g_varchar2_table(100) := '3D66756E6374696F6E28652C74297B72657475726E206E6577206C28652C74292E656D69747465722E6576656E747D2C652E66726F6D4F627365727661626C654C696768743D66756E6374696F6E2865297B72657475726E28742C6E2C72293D3E7B6C65';
wwv_flow_imp.g_varchar2_table(101) := '7420693D302C733D21313B636F6E7374206F3D7B626567696E55706461746528297B692B2B7D2C656E6455706461746528297B692D2D2C303D3D3D69262628652E7265706F72744368616E67657328292C73262628733D21312C742E63616C6C286E2929';
wwv_flow_imp.g_varchar2_table(102) := '297D2C68616E646C65506F737369626C654368616E676528297B7D2C68616E646C654368616E676528297B733D21307D7D3B652E6164644F62736572766572286F292C652E7265706F72744368616E67657328293B636F6E737420613D7B646973706F73';
wwv_flow_imp.g_varchar2_table(103) := '6528297B652E72656D6F76654F62736572766572286F297D7D3B72657475726E207220696E7374616E63656F6620673F722E6164642861293A41727261792E697341727261792872292626722E707573682861292C617D7D7D28437C7C28433D7B7D2929';
wwv_flow_imp.g_varchar2_table(104) := '3B636C61737320777B636F6E7374727563746F722865297B746869732E6C697374656E6572436F756E743D302C746869732E696E766F636174696F6E436F756E743D302C746869732E656C61707365644F766572616C6C3D302C746869732E6475726174';
wwv_flow_imp.g_varchar2_table(105) := '696F6E733D5B5D2C746869732E6E616D653D60247B657D5F247B772E5F6964506F6F6C2B2B7D602C772E616C6C2E6164642874686973297D73746172742865297B746869732E5F73746F7057617463683D6E6577205F2C746869732E6C697374656E6572';
wwv_flow_imp.g_varchar2_table(106) := '436F756E743D657D73746F7028297B696628746869732E5F73746F705761746368297B636F6E737420653D746869732E5F73746F7057617463682E656C617073656428293B746869732E6475726174696F6E732E707573682865292C746869732E656C61';
wwv_flow_imp.g_varchar2_table(107) := '707365644F766572616C6C2B3D652C746869732E696E766F636174696F6E436F756E742B3D312C746869732E5F73746F7057617463683D766F696420307D7D7D772E616C6C3D6E6577205365742C772E5F6964506F6F6C3D303B636C61737320537B636F';
wwv_flow_imp.g_varchar2_table(108) := '6E7374727563746F7228652C743D4D6174682E72616E646F6D28292E746F537472696E67283138292E736C69636528322C3529297B746869732E7468726573686F6C643D652C746869732E6E616D653D742C746869732E5F7761726E436F756E74646F77';
wwv_flow_imp.g_varchar2_table(109) := '6E3D307D646973706F736528297B76617220653B6E756C6C3D3D3D28653D746869732E5F737461636B73297C7C766F696420303D3D3D657C7C652E636C65617228297D636865636B28652C74297B636F6E7374206E3D746869732E7468726573686F6C64';
wwv_flow_imp.g_varchar2_table(110) := '3B6966286E3C3D307C7C743C6E2972657475726E3B746869732E5F737461636B737C7C28746869732E5F737461636B733D6E6577204D6170293B636F6E737420723D746869732E5F737461636B732E67657428652E76616C7565297C7C303B6966287468';
wwv_flow_imp.g_varchar2_table(111) := '69732E5F737461636B732E73657428652E76616C75652C722B31292C746869732E5F7761726E436F756E74646F776E2D3D312C746869732E5F7761726E436F756E74646F776E3C3D30297B6C657420653B746869732E5F7761726E436F756E74646F776E';
wwv_flow_imp.g_varchar2_table(112) := '3D2E352A6E3B6C657420723D303B666F7228636F6E73745B742C6E5D6F6620746869732E5F737461636B73292821657C7C723C6E29262628653D742C723D6E293B636F6E736F6C652E7761726E28605B247B746869732E6E616D657D5D20706F74656E74';
wwv_flow_imp.g_varchar2_table(113) := '69616C206C697374656E6572204C45414B2064657465637465642C20686176696E6720247B747D206C697374656E65727320616C72656164792E204D4F5354206672657175656E74206C697374656E65722028247B727D293A60292C636F6E736F6C652E';
wwv_flow_imp.g_varchar2_table(114) := '7761726E2865297D72657475726E28293D3E7B636F6E737420743D746869732E5F737461636B732E67657428652E76616C7565297C7C303B746869732E5F737461636B732E73657428652E76616C75652C742D31297D7D7D636C617373204C7B73746174';
wwv_flow_imp.g_varchar2_table(115) := '69632063726561746528297B76617220653B72657475726E206E6577204C286E756C6C213D3D28653D286E6577204572726F72292E737461636B292626766F69642030213D3D653F653A2222297D636F6E7374727563746F722865297B746869732E7661';
wwv_flow_imp.g_varchar2_table(116) := '6C75653D657D7072696E7428297B636F6E736F6C652E7761726E28746869732E76616C75652E73706C697428225C6E22292E736C6963652832292E6A6F696E28225C6E2229297D7D636C61737320457B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(117) := '76616C75653D657D7D636C61737320787B636F6E7374727563746F722865297B76617220742C6E2C722C692C733B746869732E5F73697A653D302C746869732E5F6F7074696F6E733D652C746869732E5F6C65616B6167654D6F6E3D286E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(118) := '28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6C65616B5761726E696E675468726573686F6C64293F6E65772053286E756C6C213D3D28723D6E756C6C3D3D3D286E3D746869732E5F6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(119) := '297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C65616B5761726E696E675468726573686F6C64292626766F69642030213D3D723F723A2D31293A766F696420302C746869732E5F706572664D6F6E3D286E756C6C3D3D3D28693D746869732E';
wwv_flow_imp.g_varchar2_table(120) := '5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E5F70726F664E616D65293F6E6577207728746869732E5F6F7074696F6E732E5F70726F664E616D65293A766F696420302C746869732E5F64656C697665727951756575653D';
wwv_flow_imp.g_varchar2_table(121) := '6E756C6C3D3D3D28733D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D733F766F696420303A732E64656C697665727951756575657D646973706F736528297B76617220652C742C6E2C723B746869732E5F646973706F7365647C7C2874';
wwv_flow_imp.g_varchar2_table(122) := '6869732E5F646973706F7365643D21302C286E756C6C3D3D3D28653D746869732E5F64656C69766572795175657565297C7C766F696420303D3D3D653F766F696420303A652E63757272656E74293D3D3D746869732626746869732E5F64656C69766572';
wwv_flow_imp.g_varchar2_table(123) := '7951756575652E726573657428292C746869732E5F6C697374656E657273262628746869732E5F6C697374656E6572733D766F696420302C746869732E5F73697A653D30292C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F707469';
wwv_flow_imp.g_varchar2_table(124) := '6F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D6E7C7C6E2E63616C6C2874292C6E756C6C3D3D3D28723D746869732E5F6C65616B6167654D6F6E';
wwv_flow_imp.g_varchar2_table(125) := '297C7C766F696420303D3D3D727C7C722E646973706F73652829297D676574206576656E7428297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F6576656E74292626766F69642030213D3D657C7C28746869732E5F6576656E';
wwv_flow_imp.g_varchar2_table(126) := '743D28652C742C6E293D3E7B76617220722C692C732C6F2C613B696628746869732E5F6C65616B6167654D6F6E2626746869732E5F73697A653E332A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C642972657475726E20636F6E736F6C';
wwv_flow_imp.g_varchar2_table(127) := '652E7761726E28605B247B746869732E5F6C65616B6167654D6F6E2E6E616D657D5D205245465553455320746F20616363657074206E6577206C697374656E657273206265636175736520697420657863656564656420697473207468726573686F6C64';
wwv_flow_imp.g_varchar2_table(128) := '2062792066617260292C702E4E6F6E653B696628746869732E5F646973706F7365642972657475726E20702E4E6F6E653B74262628653D652E62696E64287429293B636F6E7374206C3D6E657720452865293B6C657420753B746869732E5F6C65616B61';
wwv_flow_imp.g_varchar2_table(129) := '67654D6F6E2626746869732E5F73697A653E3D4D6174682E6365696C282E322A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C64292626286C2E737461636B3D4C2E63726561746528292C753D746869732E5F6C65616B6167654D6F6E2E';
wwv_flow_imp.g_varchar2_table(130) := '636865636B286C2E737461636B2C746869732E5F73697A652B3129292C746869732E5F6C697374656E6572733F746869732E5F6C697374656E65727320696E7374616E63656F6620453F286E756C6C213D3D28613D746869732E5F64656C697665727951';
wwv_flow_imp.g_varchar2_table(131) := '75657565292626766F69642030213D3D617C7C28746869732E5F64656C697665727951756575653D6E6577204E292C746869732E5F6C697374656E6572733D5B746869732E5F6C697374656E6572732C6C5D293A746869732E5F6C697374656E6572732E';
wwv_flow_imp.g_varchar2_table(132) := '70757368286C293A286E756C6C3D3D3D28693D6E756C6C3D3D3D28723D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E6F6E57696C6C41646446697273744C697374656E6572297C7C766F696420303D3D3D69';
wwv_flow_imp.g_varchar2_table(133) := '7C7C692E63616C6C28722C74686973292C746869732E5F6C697374656E6572733D6C2C6E756C6C3D3D3D286F3D6E756C6C3D3D3D28733D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D733F766F696420303A732E6F6E44696441646446';
wwv_flow_imp.g_varchar2_table(134) := '697273744C697374656E6572297C7C766F696420303D3D3D6F7C7C6F2E63616C6C28732C7468697329292C746869732E5F73697A652B2B3B636F6E737420633D6D282828293D3E7B6E756C6C3D3D757C7C7528292C746869732E5F72656D6F76654C6973';
wwv_flow_imp.g_varchar2_table(135) := '74656E6572286C297D29293B72657475726E206E20696E7374616E63656F6620673F6E2E6164642863293A41727261792E69734172726179286E2926266E2E707573682863292C637D292C746869732E5F6576656E747D5F72656D6F76654C697374656E';
wwv_flow_imp.g_varchar2_table(136) := '65722865297B76617220742C6E2C722C693B6966286E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E57696C6C52656D6F76654C697374656E6572297C7C';
wwv_flow_imp.g_varchar2_table(137) := '766F696420303D3D3D6E7C7C6E2E63616C6C28742C74686973292C21746869732E5F6C697374656E6572732972657475726E3B696628313D3D3D746869732E5F73697A652972657475726E20746869732E5F6C697374656E6572733D766F696420302C6E';
wwv_flow_imp.g_varchar2_table(138) := '756C6C3D3D3D28693D6E756C6C3D3D3D28723D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E6F6E44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D697C7C692E63616C6C28';
wwv_flow_imp.g_varchar2_table(139) := '722C74686973292C766F696428746869732E5F73697A653D30293B636F6E737420733D746869732E5F6C697374656E6572732C6F3D732E696E6465784F662865293B6966282D313D3D3D6F297468726F7720636F6E736F6C652E6C6F672822646973706F';
wwv_flow_imp.g_varchar2_table(140) := '7365643F222C746869732E5F646973706F736564292C636F6E736F6C652E6C6F67282273697A653F222C746869732E5F73697A65292C636F6E736F6C652E6C6F6728226172723F222C4A534F4E2E737472696E6769667928746869732E5F6C697374656E';
wwv_flow_imp.g_varchar2_table(141) := '65727329292C6E6577204572726F722822417474656D7074656420746F20646973706F736520756E6B6E6F776E206C697374656E657222293B746869732E5F73697A652D2D2C735B6F5D3D766F696420303B636F6E737420613D746869732E5F64656C69';
wwv_flow_imp.g_varchar2_table(142) := '7665727951756575652E63757272656E743D3D3D746869733B696628322A746869732E5F73697A653C3D732E6C656E677468297B6C657420653D303B666F72286C657420743D303B743C732E6C656E6774683B742B2B29735B745D3F735B652B2B5D3D73';
wwv_flow_imp.g_varchar2_table(143) := '5B745D3A61262628746869732E5F64656C697665727951756575652E656E642D2D2C653C746869732E5F64656C697665727951756575652E692626746869732E5F64656C697665727951756575652E692D2D293B732E6C656E6774683D657D7D5F64656C';
wwv_flow_imp.g_varchar2_table(144) := '6976657228652C6E297B76617220723B69662821652972657475726E3B636F6E737420693D286E756C6C3D3D3D28723D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E6F6E4C697374656E65724572726F7229';
wwv_flow_imp.g_varchar2_table(145) := '7C7C743B69662869297472797B652E76616C7565286E297D63617463682865297B692865297D656C736520652E76616C7565286E297D5F64656C6976657251756575652865297B636F6E737420743D652E63757272656E742E5F6C697374656E6572733B';
wwv_flow_imp.g_varchar2_table(146) := '666F72283B652E693C652E656E643B29746869732E5F64656C6976657228745B652E692B2B5D2C652E76616C7565293B652E726573657428297D666972652865297B76617220742C6E2C722C693B696628286E756C6C3D3D3D28743D746869732E5F6465';
wwv_flow_imp.g_varchar2_table(147) := '6C69766572795175657565297C7C766F696420303D3D3D743F766F696420303A742E63757272656E7429262628746869732E5F64656C69766572517565756528746869732E5F64656C69766572795175657565292C6E756C6C3D3D3D286E3D746869732E';
wwv_flow_imp.g_varchar2_table(148) := '5F706572664D6F6E297C7C766F696420303D3D3D6E7C7C6E2E73746F702829292C6E756C6C3D3D3D28723D746869732E5F706572664D6F6E297C7C766F696420303D3D3D727C7C722E737461727428746869732E5F73697A65292C746869732E5F6C6973';
wwv_flow_imp.g_varchar2_table(149) := '74656E65727329696628746869732E5F6C697374656E65727320696E7374616E63656F66204529746869732E5F64656C6976657228746869732E5F6C697374656E6572732C65293B656C73657B636F6E737420743D746869732E5F64656C697665727951';
wwv_flow_imp.g_varchar2_table(150) := '756575653B742E656E717565756528746869732C652C746869732E5F6C697374656E6572732E6C656E677468292C746869732E5F64656C6976657251756575652874297D6E756C6C3D3D3D28693D746869732E5F706572664D6F6E297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(151) := '3D3D3D697C7C692E73746F7028297D6861734C697374656E65727328297B72657475726E20746869732E5F73697A653E307D7D636C617373204E7B636F6E7374727563746F7228297B746869732E693D2D312C746869732E656E643D307D656E71756575';
wwv_flow_imp.g_varchar2_table(152) := '6528652C742C6E297B746869732E693D302C746869732E656E643D6E2C746869732E63757272656E743D652C746869732E76616C75653D747D726573657428297B746869732E693D746869732E656E642C746869732E63757272656E743D766F69642030';
wwv_flow_imp.g_varchar2_table(153) := '2C746869732E76616C75653D766F696420307D7D66756E6374696F6E20412865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662066756E6374696F6E2865297B6C657420743D5B5D3B666F72283B4F626A6563742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(154) := '7065213D3D653B29743D742E636F6E636174284F626A6563742E6765744F776E50726F70657274794E616D6573286529292C653D4F626A6563742E67657450726F746F747970654F662865293B72657475726E20747D286529292266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(155) := '3D3D747970656F6620655B6E5D2626742E70757368286E293B72657475726E20747D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B6C6574206B3D22756E646566696E656422213D747970656F6620646F63756D656E74';
wwv_flow_imp.g_varchar2_table(156) := '2626646F63756D656E742E6C6F636174696F6E2626646F63756D656E742E6C6F636174696F6E2E686173682E696E6465784F66282270736575646F3D7472756522293E3D303B66756E6374696F6E205228652C742C2E2E2E6E297B72657475726E206675';
wwv_flow_imp.g_varchar2_table(157) := '6E6374696F6E28652C74297B6C6574206E3B72657475726E206E3D303D3D3D742E6C656E6774683F653A652E7265706C616365282F5C7B285C642B295C7D2F672C2828652C6E293D3E7B636F6E737420723D6E5B305D2C693D745B725D3B6C657420733D';
wwv_flow_imp.g_varchar2_table(158) := '653B72657475726E22737472696E67223D3D747970656F6620693F733D693A226E756D62657222213D747970656F662069262622626F6F6C65616E22213D747970656F66206926266E756C6C213D697C7C28733D537472696E67286929292C737D29292C';
wwv_flow_imp.g_varchar2_table(159) := '6B2626286E3D22EFBCBB222B6E2E7265706C616365282F5B616F7565695D2F672C222426242622292B22EFBCBD22292C6E7D28742C6E297D76617220542C4D3B636F6E7374204F3D22656E223B6C657420492C502C463D21312C563D21312C443D21312C';
wwv_flow_imp.g_varchar2_table(160) := '713D21312C4B3D21312C6A3D21312C553D21312C423D21312C243D21312C573D21312C7A3D6E756C6C2C483D6E756C6C2C473D6E756C6C3B636F6E7374204A3D676C6F62616C546869733B6C657420583B766F69642030213D3D4A2E7673636F64652626';
wwv_flow_imp.g_varchar2_table(161) := '766F69642030213D3D4A2E7673636F64652E70726F636573733F583D4A2E7673636F64652E70726F636573733A22756E646566696E656422213D747970656F662070726F63657373262622737472696E67223D3D747970656F66286E756C6C3D3D3D2854';
wwv_flow_imp.g_varchar2_table(162) := '3D6E756C6C3D3D3D70726F636573737C7C766F696420303D3D3D70726F636573733F766F696420303A70726F636573732E76657273696F6E73297C7C766F696420303D3D3D543F766F696420303A542E6E6F646529262628583D70726F63657373293B63';
wwv_flow_imp.g_varchar2_table(163) := '6F6E737420513D22737472696E67223D3D747970656F66286E756C6C3D3D3D284D3D6E756C6C3D3D583F766F696420303A582E76657273696F6E73297C7C766F696420303D3D3D4D3F766F696420303A4D2E656C656374726F6E292C5A3D512626227265';
wwv_flow_imp.g_varchar2_table(164) := '6E6465726572223D3D3D286E756C6C3D3D583F766F696420303A582E74797065293B696628226F626A656374223D3D747970656F662058297B463D2277696E3332223D3D3D582E706C6174666F726D2C563D2264617277696E223D3D3D582E706C617466';
wwv_flow_imp.g_varchar2_table(165) := '6F726D2C443D226C696E7578223D3D3D582E706C6174666F726D2C713D4426262121582E656E762E534E415026262121582E656E762E534E41505F5245564953494F4E2C553D512C243D2121582E656E762E43497C7C2121582E656E762E4255494C445F';
wwv_flow_imp.g_varchar2_table(166) := '415254494641435453544147494E474449524543544F52592C493D4F2C7A3D4F3B636F6E737420653D582E656E762E5653434F44455F4E4C535F434F4E4649473B69662865297472797B636F6E737420743D4A534F4E2E70617273652865292C6E3D742E';
wwv_flow_imp.g_varchar2_table(167) := '617661696C61626C654C616E6775616765735B222A225D3B493D742E6C6F63616C652C483D742E6F734C6F63616C652C7A3D6E7C7C4F2C473D742E5F7472616E736C6174696F6E73436F6E66696746696C657D63617463682865297B7D4B3D21307D656C';
wwv_flow_imp.g_varchar2_table(168) := '7365226F626A65637422213D747970656F66206E6176696761746F727C7C5A3F636F6E736F6C652E6572726F722822556E61626C6520746F207265736F6C766520706C6174666F726D2E22293A28503D6E6176696761746F722E757365724167656E742C';
wwv_flow_imp.g_varchar2_table(169) := '463D502E696E6465784F66282257696E646F777322293E3D302C563D502E696E6465784F6628224D6163696E746F736822293E3D302C423D28502E696E6465784F6628224D6163696E746F736822293E3D307C7C502E696E6465784F6628226950616422';
wwv_flow_imp.g_varchar2_table(170) := '293E3D307C7C502E696E6465784F6628226950686F6E6522293E3D3029262621216E6176696761746F722E6D6178546F756368506F696E747326266E6176696761746F722E6D6178546F756368506F696E74733E302C443D502E696E6465784F6628224C';
wwv_flow_imp.g_varchar2_table(171) := '696E757822293E3D302C573D286E756C6C3D3D503F766F696420303A502E696E6465784F6628224D6F62692229293E3D302C6A3D21302C493D766F6964205228302C225F22297C7C4F2C7A3D492C483D6E6176696761746F722E6C616E6775616765293B';
wwv_flow_imp.g_varchar2_table(172) := '6C657420593D303B563F593D313A463F593D333A44262628593D32293B636F6E73742065653D462C74653D562C6E653D286A26262266756E6374696F6E223D3D747970656F66204A2E696D706F72745363726970747326264A2E6F726967696E2C50292C';
wwv_flow_imp.g_varchar2_table(173) := '72653D2266756E6374696F6E223D3D747970656F66204A2E706F73744D6573736167652626214A2E696D706F7274536372697074733B2828293D3E7B6966287265297B636F6E737420653D5B5D3B4A2E6164644576656E744C697374656E657228226D65';
wwv_flow_imp.g_varchar2_table(174) := '7373616765222C28743D3E7B696628742E646174612626742E646174612E7673636F64655363686564756C654173796E63576F726B29666F72286C6574206E3D302C723D652E6C656E6774683B6E3C723B6E2B2B297B636F6E737420723D655B6E5D3B69';
wwv_flow_imp.g_varchar2_table(175) := '6628722E69643D3D3D742E646174612E7673636F64655363686564756C654173796E63576F726B2972657475726E20652E73706C696365286E2C31292C766F696420722E63616C6C6261636B28297D7D29293B6C657420743D307D7D2928293B636F6E73';
wwv_flow_imp.g_varchar2_table(176) := '742069653D2121286E6526266E652E696E6465784F6628224368726F6D6522293E3D30293B66756E6374696F6E2073652865297B72657475726E20657D6E6526266E652E696E6465784F66282246697265666F7822292C21696526266E6526266E652E69';
wwv_flow_imp.g_varchar2_table(177) := '6E6465784F66282253616661726922292C6E6526266E652E696E6465784F6628224564672F22292C6E6526266E652E696E6465784F662822416E64726F696422293B636C617373206F657B636F6E7374727563746F722865297B746869732E6578656375';
wwv_flow_imp.g_varchar2_table(178) := '746F723D652C746869732E5F64696452756E3D21317D6765742076616C756528297B69662821746869732E5F64696452756E297472797B746869732E5F76616C75653D746869732E6578656375746F7228297D63617463682865297B746869732E5F6572';
wwv_flow_imp.g_varchar2_table(179) := '726F723D657D66696E616C6C797B746869732E5F64696452756E3D21307D696628746869732E5F6572726F72297468726F7720746869732E5F6572726F723B72657475726E20746869732E5F76616C75657D6765742072617756616C756528297B726574';
wwv_flow_imp.g_varchar2_table(180) := '75726E20746869732E5F76616C75657D7D7661722061653B66756E6374696F6E206C652865297B72657475726E20653E3D36352626653C3D39307D66756E6374696F6E2075652865297B72657475726E2035353239363C3D652626653C3D35363331397D';
wwv_flow_imp.g_varchar2_table(181) := '66756E6374696F6E2063652865297B72657475726E2035363332303C3D652626653C3D35373334337D66756E6374696F6E20686528652C74297B72657475726E20742D35363332302B28652D35353239363C3C3130292B36353533367D66756E6374696F';
wwv_flow_imp.g_varchar2_table(182) := '6E20646528652C742C6E297B636F6E737420723D652E63686172436F64654174286E293B696628756528722926266E2B313C74297B636F6E737420743D652E63686172436F64654174286E2B31293B69662863652874292972657475726E20686528722C';
wwv_flow_imp.g_varchar2_table(183) := '74297D72657475726E20727D636F6E73742066653D2F5E5B5C745C6E5C725C7832302D5C7837455D2A242F3B537472696E672E66726F6D43686172436F6465283635323739293B636C617373206D657B73746174696320676574496E7374616E63652829';
wwv_flow_imp.g_varchar2_table(184) := '7B72657475726E206D652E5F494E5354414E43457C7C286D652E5F494E5354414E43453D6E6577206D65292C6D652E5F494E5354414E43457D636F6E7374727563746F7228297B746869732E5F646174613D4A534F4E2E706172736528225B302C302C30';
wwv_flow_imp.g_varchar2_table(185) := '2C35313232392C35313235352C31322C34343036312C34343038372C31322C3132373436322C3132373438372C362C373038332C373038352C352C34373634352C34373637312C31322C35343831332C35343833392C31322C3132383637382C31323836';
wwv_flow_imp.g_varchar2_table(186) := '37382C31342C333237302C333237302C352C393931392C393932332C31342C34353835332C34353837392C31322C34393433372C34393436332C31322C35333032312C35333034372C31322C37313231362C37313231382C372C3132383339382C313238';
wwv_flow_imp.g_varchar2_table(187) := '3339392C31342C3132393336302C3132393337342C31342C323531392C323531392C352C343434382C343531392C392C393734322C393734322C31342C31323333362C31323333362C31342C34343935372C34343938332C31322C34363734392C343637';
wwv_flow_imp.g_varchar2_table(188) := '37352C31322C34383534312C34383536372C31322C35303333332C35303335392C31322C35323132352C35323135312C31322C35333931372C35333934332C31322C36393838382C36393839302C352C37333031382C37333031382C352C313237393930';
wwv_flow_imp.g_varchar2_table(189) := '2C3132373939302C31342C3132383535382C3132383535392C31342C3132383735392C3132383736302C31342C3132393635332C3132393635352C31342C323032372C323033352C352C323839312C323839322C372C333736312C333736312C352C3636';
wwv_flow_imp.g_varchar2_table(190) := '38332C363638332C352C383239332C383239332C342C393832352C393832362C31342C393939392C393939392C31342C34333435322C34333435332C352C34343530392C34343533352C31322C34353430352C34353433312C31322C34363330312C3436';
wwv_flow_imp.g_varchar2_table(191) := '3332372C31322C34373139372C34373232332C31322C34383039332C34383131392C31322C34383938392C34393031352C31322C34393838352C34393931312C31322C35303738312C35303830372C31322C35313637372C35313730332C31322C353235';
wwv_flow_imp.g_varchar2_table(192) := '37332C35323539392C31322C35333436392C35333439352C31322C35343336352C35343339312C31322C36353237392C36353237392C342C37303437312C37303437322C372C37323134352C37323134372C372C3131393137332C3131393137392C352C';
wwv_flow_imp.g_varchar2_table(193) := '3132373739392C3132373831382C31342C3132383234302C3132383234342C31342C3132383531322C3132383531322C31342C3132383635322C3132383635322C31342C3132383732312C3132383732322C31342C3132393239322C3132393239322C31';
wwv_flow_imp.g_varchar2_table(194) := '342C3132393434352C3132393435302C31342C3132393733342C3132393734332C31342C313437362C313437372C352C323336362C323336382C372C323735302C323735322C372C333037362C333037362C352C333431352C333431352C352C34313431';
wwv_flow_imp.g_varchar2_table(195) := '2C343134342C352C363130392C363130392C352C363936342C363936342C352C373339342C373430302C352C393139372C393139382C31342C393737302C393737302C31342C393837372C393837372C31342C393936382C393936392C31342C31303038';
wwv_flow_imp.g_varchar2_table(196) := '342C31303038342C31342C34333035322C34333035322C352C34333731332C34333731332C352C34343238352C34343331312C31322C34343733332C34343735392C31322C34353138312C34353230372C31322C34353632392C34353635352C31322C34';
wwv_flow_imp.g_varchar2_table(197) := '363037372C34363130332C31322C34363532352C34363535312C31322C34363937332C34363939392C31322C34373432312C34373434372C31322C34373836392C34373839352C31322C34383331372C34383334332C31322C34383736352C3438373931';
wwv_flow_imp.g_varchar2_table(198) := '2C31322C34393231332C34393233392C31322C34393636312C34393638372C31322C35303130392C35303133352C31322C35303535372C35303538332C31322C35313030352C35313033312C31322C35313435332C35313437392C31322C35313930312C';
wwv_flow_imp.g_varchar2_table(199) := '35313932372C31322C35323334392C35323337352C31322C35323739372C35323832332C31322C35333234352C35333237312C31322C35333639332C35333731392C31322C35343134312C35343136372C31322C35343538392C35343631352C31322C35';
wwv_flow_imp.g_varchar2_table(200) := '353033372C35353036332C31322C36393530362C36393530392C352C37303139312C37303139332C352C37303834312C37303834312C372C37313436332C37313436372C352C37323333302C37323334322C352C39343033312C39343033312C352C3132';
wwv_flow_imp.g_varchar2_table(201) := '333632382C3132333633312C352C3132373736332C3132373736352C31342C3132373934312C3132373934312C31342C3132383034332C3132383036322C31342C3132383330322C3132383331372C31342C3132383436352C3132383436372C31342C31';
wwv_flow_imp.g_varchar2_table(202) := '32383533392C3132383533392C31342C3132383634302C3132383634302C31342C3132383636322C3132383636322C31342C3132383730332C3132383730332C31342C3132383734352C3132383734352C31342C3132393030342C3132393030372C3134';
wwv_flow_imp.g_varchar2_table(203) := '2C3132393332392C3132393333302C31342C3132393430322C3132393430322C31342C3132393438332C3132393438332C31342C3132393638362C3132393730342C31342C3133303034382C3133313036392C31342C3137332C3137332C342C31373537';
wwv_flow_imp.g_varchar2_table(204) := '2C313735372C312C323230302C323230372C352C323433342C323433352C372C323633312C323633322C352C323831372C323831372C352C333030382C333030382C352C333230312C333230312C352C333338372C333338382C352C333534322C333534';
wwv_flow_imp.g_varchar2_table(205) := '322C352C333930322C333930332C372C343139302C343139322C352C363030322C363030332C352C363433392C363434302C352C363736352C363737302C372C373031392C373032372C352C373135342C373135352C372C383230352C383230352C3133';
wwv_flow_imp.g_varchar2_table(206) := '2C383530352C383530352C31342C393635342C393635342C31342C393735372C393735372C31342C393739322C393739322C31342C393835322C393835332C31342C393839302C393839342C31342C393933372C393933372C31342C393938312C393938';
wwv_flow_imp.g_varchar2_table(207) := '312C31342C31303033352C31303033362C31342C31313033352C31313033362C31342C34323635342C34323635352C352C34333334362C34333334372C372C34333538372C34333538372C352C34343030362C34343030372C372C34343137332C343431';
wwv_flow_imp.g_varchar2_table(208) := '39392C31322C34343339372C34343432332C31322C34343632312C34343634372C31322C34343834352C34343837312C31322C34353036392C34353039352C31322C34353239332C34353331392C31322C34353531372C34353534332C31322C34353734';
wwv_flow_imp.g_varchar2_table(209) := '312C34353736372C31322C34353936352C34353939312C31322C34363138392C34363231352C31322C34363431332C34363433392C31322C34363633372C34363636332C31322C34363836312C34363838372C31322C34373038352C34373131312C3132';
wwv_flow_imp.g_varchar2_table(210) := '2C34373330392C34373333352C31322C34373533332C34373535392C31322C34373735372C34373738332C31322C34373938312C34383030372C31322C34383230352C34383233312C31322C34383432392C34383435352C31322C34383635332C343836';
wwv_flow_imp.g_varchar2_table(211) := '37392C31322C34383837372C34383930332C31322C34393130312C34393132372C31322C34393332352C34393335312C31322C34393534392C34393537352C31322C34393737332C34393739392C31322C34393939372C35303032332C31322C35303232';
wwv_flow_imp.g_varchar2_table(212) := '312C35303234372C31322C35303434352C35303437312C31322C35303636392C35303639352C31322C35303839332C35303931392C31322C35313131372C35313134332C31322C35313334312C35313336372C31322C35313536352C35313539312C3132';
wwv_flow_imp.g_varchar2_table(213) := '2C35313738392C35313831352C31322C35323031332C35323033392C31322C35323233372C35323236332C31322C35323436312C35323438372C31322C35323638352C35323731312C31322C35323930392C35323933352C31322C35333133332C353331';
wwv_flow_imp.g_varchar2_table(214) := '35392C31322C35333335372C35333338332C31322C35333538312C35333630372C31322C35333830352C35333833312C31322C35343032392C35343035352C31322C35343235332C35343237392C31322C35343437372C35343530332C31322C35343730';
wwv_flow_imp.g_varchar2_table(215) := '312C35343732372C31322C35343932352C35343935312C31322C35353134392C35353137352C31322C36383130312C36383130322C352C36393736322C36393736322C372C37303036372C37303036392C372C37303337312C37303337382C352C373037';
wwv_flow_imp.g_varchar2_table(216) := '32302C37303732312C372C37313038372C37313038372C352C37313334312C37313334312C352C37313939352C37313939362C352C37323234392C37323234392C372C37323835302C37323837312C352C37333130392C37333130392C352C3131383537';
wwv_flow_imp.g_varchar2_table(217) := '362C3131383539382C352C3132313530352C3132313531392C352C3132373234352C3132373234372C31342C3132373536382C3132373536392C31342C3132373737372C3132373737372C31342C3132373837322C3132373839312C31342C3132373935';
wwv_flow_imp.g_varchar2_table(218) := '362C3132373936372C31342C3132383031352C3132383031362C31342C3132383131302C3132383137322C31342C3132383235392C3132383235392C31342C3132383336372C3132383336382C31342C3132383432342C3132383432342C31342C313238';
wwv_flow_imp.g_varchar2_table(219) := '3438382C3132383438382C31342C3132383533302C3132383533322C31342C3132383535302C3132383535312C31342C3132383536362C3132383536362C31342C3132383634372C3132383634372C31342C3132383635362C3132383635362C31342C31';
wwv_flow_imp.g_varchar2_table(220) := '32383636372C3132383637332C31342C3132383639312C3132383639332C31342C3132383731352C3132383731352C31342C3132383732382C3132383733322C31342C3132383735322C3132383735322C31342C3132383736352C3132383736372C3134';
wwv_flow_imp.g_varchar2_table(221) := '2C3132393039362C3132393130332C31342C3132393331312C3132393331312C31342C3132393334342C3132393334392C31342C3132393339342C3132393339342C31342C3132393431332C3132393432352C31342C3132393436362C3132393437312C';
wwv_flow_imp.g_varchar2_table(222) := '31342C3132393531312C3132393533352C31342C3132393636342C3132393636362C31342C3132393731392C3132393732322C31342C3132393736302C3132393736372C31342C3931373533362C3931373633312C352C31332C31332C322C313136302C';
wwv_flow_imp.g_varchar2_table(223) := '313136312C352C313536342C313536342C342C313830372C313830372C312C323038352C323038372C352C323330372C323330372C372C323338322C323338332C372C323439372C323530302C352C323536332C323536332C372C323637372C32363737';
wwv_flow_imp.g_varchar2_table(224) := '2C352C323736332C323736342C372C323837392C323837392C352C323931342C323931352C352C333032312C333032312C352C333134322C333134342C352C333236332C333236332C352C333238352C333238362C352C333339382C333430302C372C33';
wwv_flow_imp.g_varchar2_table(225) := '3533302C333533302C352C333633332C333633332C352C333836342C333836352C352C333937342C333937352C352C343135352C343135362C372C343232392C343233302C352C353930392C353930392C372C363037382C363038352C372C363237372C';
wwv_flow_imp.g_varchar2_table(226) := '363237382C352C363435312C363435362C372C363734342C363735302C352C363834362C363834362C352C363937322C363937322C352C373037342C373037372C352C373134362C373134382C372C373232322C373232332C352C373431362C37343137';
wwv_flow_imp.g_varchar2_table(227) := '2C352C383233342C383233382C342C383431372C383431372C352C393030302C393030302C31342C393230332C393230332C31342C393733302C393733312C31342C393734382C393734392C31342C393736322C393736332C31342C393737362C393738';
wwv_flow_imp.g_varchar2_table(228) := '332C31342C393830302C393831312C31342C393833312C393833312C31342C393837322C393837332C31342C393838322C393838322C31342C393930302C393930332C31342C393932392C393933332C31342C393934312C393936302C31342C39393734';
wwv_flow_imp.g_varchar2_table(229) := '2C393937342C31342C393938392C393938392C31342C31303030362C31303030362C31342C31303036322C31303036322C31342C31303136302C31303136302C31342C31313634372C31313634372C352C31323935332C31323935332C31342C34333031';
wwv_flow_imp.g_varchar2_table(230) := '392C34333031392C352C34333233322C34333234392C352C34333434332C34333434332C352C34333536372C34333536382C372C34333639362C34333639362C352C34333736352C34333736352C372C34343031332C34343031332C352C34343131372C';
wwv_flow_imp.g_varchar2_table(231) := '34343134332C31322C34343232392C34343235352C31322C34343334312C34343336372C31322C34343435332C34343437392C31322C34343536352C34343539312C31322C34343637372C34343730332C31322C34343738392C34343831352C31322C34';
wwv_flow_imp.g_varchar2_table(232) := '343930312C34343932372C31322C34353031332C34353033392C31322C34353132352C34353135312C31322C34353233372C34353236332C31322C34353334392C34353337352C31322C34353436312C34353438372C31322C34353537332C3435353939';
wwv_flow_imp.g_varchar2_table(233) := '2C31322C34353638352C34353731312C31322C34353739372C34353832332C31322C34353930392C34353933352C31322C34363032312C34363034372C31322C34363133332C34363135392C31322C34363234352C34363237312C31322C34363335372C';
wwv_flow_imp.g_varchar2_table(234) := '34363338332C31322C34363436392C34363439352C31322C34363538312C34363630372C31322C34363639332C34363731392C31322C34363830352C34363833312C31322C34363931372C34363934332C31322C34373032392C34373035352C31322C34';
wwv_flow_imp.g_varchar2_table(235) := '373134312C34373136372C31322C34373235332C34373237392C31322C34373336352C34373339312C31322C34373437372C34373530332C31322C34373538392C34373631352C31322C34373730312C34373732372C31322C34373831332C3437383339';
wwv_flow_imp.g_varchar2_table(236) := '2C31322C34373932352C34373935312C31322C34383033372C34383036332C31322C34383134392C34383137352C31322C34383236312C34383238372C31322C34383337332C34383339392C31322C34383438352C34383531312C31322C34383539372C';
wwv_flow_imp.g_varchar2_table(237) := '34383632332C31322C34383730392C34383733352C31322C34383832312C34383834372C31322C34383933332C34383935392C31322C34393034352C34393037312C31322C34393135372C34393138332C31322C34393236392C34393239352C31322C34';
wwv_flow_imp.g_varchar2_table(238) := '393338312C34393430372C31322C34393439332C34393531392C31322C34393630352C34393633312C31322C34393731372C34393734332C31322C34393832392C34393835352C31322C34393934312C34393936372C31322C35303035332C3530303739';
wwv_flow_imp.g_varchar2_table(239) := '2C31322C35303136352C35303139312C31322C35303237372C35303330332C31322C35303338392C35303431352C31322C35303530312C35303532372C31322C35303631332C35303633392C31322C35303732352C35303735312C31322C35303833372C';
wwv_flow_imp.g_varchar2_table(240) := '35303836332C31322C35303934392C35303937352C31322C35313036312C35313038372C31322C35313137332C35313139392C31322C35313238352C35313331312C31322C35313339372C35313432332C31322C35313530392C35313533352C31322C35';
wwv_flow_imp.g_varchar2_table(241) := '313632312C35313634372C31322C35313733332C35313735392C31322C35313834352C35313837312C31322C35313935372C35313938332C31322C35323036392C35323039352C31322C35323138312C35323230372C31322C35323239332C3532333139';
wwv_flow_imp.g_varchar2_table(242) := '2C31322C35323430352C35323433312C31322C35323531372C35323534332C31322C35323632392C35323635352C31322C35323734312C35323736372C31322C35323835332C35323837392C31322C35323936352C35323939312C31322C35333037372C';
wwv_flow_imp.g_varchar2_table(243) := '35333130332C31322C35333138392C35333231352C31322C35333330312C35333332372C31322C35333431332C35333433392C31322C35333532352C35333535312C31322C35333633372C35333636332C31322C35333734392C35333737352C31322C35';
wwv_flow_imp.g_varchar2_table(244) := '333836312C35333838372C31322C35333937332C35333939392C31322C35343038352C35343131312C31322C35343139372C35343232332C31322C35343330392C35343333352C31322C35343432312C35343434372C31322C35343533332C3534353539';
wwv_flow_imp.g_varchar2_table(245) := '2C31322C35343634352C35343637312C31322C35343735372C35343738332C31322C35343836392C35343839352C31322C35343938312C35353030372C31322C35353039332C35353131392C31322C35353234332C35353239312C31302C36363034352C';
wwv_flow_imp.g_varchar2_table(246) := '36363034352C352C36383332352C36383332362C352C36393638382C36393730322C352C36393831372C36393831382C352C36393935372C36393935382C372C37303038392C37303039322C352C37303139382C37303139392C352C37303436322C3730';
wwv_flow_imp.g_varchar2_table(247) := '3436322C352C37303530322C37303530382C352C37303735302C37303735302C352C37303834362C37303834362C372C37313130302C37313130312C352C37313233302C37313233302C372C37313335312C37313335312C352C37313733372C37313733';
wwv_flow_imp.g_varchar2_table(248) := '382C352C37323030302C37323030302C372C37323136302C37323136302C352C37323237332C37323237382C352C37323735322C37323735382C352C37323838322C37323838332C352C37333033312C37333033312C352C37333436312C37333436322C';
wwv_flow_imp.g_varchar2_table(249) := '372C39343139322C39343139332C372C3131393134392C3131393134392C372C3132313430332C3132313435322C352C3132323931352C3132323931362C352C3132363938302C3132363938302C31342C3132373335382C3132373335392C31342C3132';
wwv_flow_imp.g_varchar2_table(250) := '373533352C3132373533352C31342C3132373735392C3132373735392C31342C3132373737312C3132373737312C31342C3132373739322C3132373739332C31342C3132373832352C3132373836372C31342C3132373839372C3132373839392C31342C';
wwv_flow_imp.g_varchar2_table(251) := '3132373934352C3132373934352C31342C3132373938352C3132373938362C31342C3132383030302C3132383030372C31342C3132383032312C3132383032312C31342C3132383036362C3132383130302C31342C3132383138342C3132383233352C31';
wwv_flow_imp.g_varchar2_table(252) := '342C3132383234392C3132383235322C31342C3132383236362C3132383237362C31342C3132383333352C3132383333352C31342C3132383337392C3132383339302C31342C3132383430372C3132383431392C31342C3132383434342C313238343434';
wwv_flow_imp.g_varchar2_table(253) := '2C31342C3132383438312C3132383438312C31342C3132383439392C3132383439392C31342C3132383532362C3132383532362C31342C3132383533362C3132383533362C31342C3132383534332C3132383534332C31342C3132383535362C31323835';
wwv_flow_imp.g_varchar2_table(254) := '35362C31342C3132383536342C3132383536342C31342C3132383537372C3132383538302C31342C3132383634332C3132383634352C31342C3132383634392C3132383634392C31342C3132383635342C3132383635342C31342C3132383636302C3132';
wwv_flow_imp.g_varchar2_table(255) := '383636302C31342C3132383636342C3132383636342C31342C3132383637352C3132383637352C31342C3132383638362C3132383638392C31342C3132383639352C3132383639362C31342C3132383730352C3132383730392C31342C3132383731372C';
wwv_flow_imp.g_varchar2_table(256) := '3132383731392C31342C3132383732352C3132383732352C31342C3132383733362C3132383734312C31342C3132383734372C3132383734382C31342C3132383735352C3132383735352C31342C3132383736322C3132383736322C31342C3132383938';
wwv_flow_imp.g_varchar2_table(257) := '312C3132383939312C31342C3132393030392C3132393032332C31342C3132393136302C3132393136372C31342C3132393239362C3132393330342C31342C3132393332302C3132393332372C31342C3132393334302C3132393334322C31342C313239';
wwv_flow_imp.g_varchar2_table(258) := '3335362C3132393335362C31342C3132393338382C3132393339322C31342C3132393339392C3132393430302C31342C3132393430342C3132393430372C31342C3132393433322C3132393434322C31342C3132393435342C3132393435352C31342C31';
wwv_flow_imp.g_varchar2_table(259) := '32393437332C3132393437342C31342C3132393438352C3132393438372C31342C3132393634382C3132393635312C31342C3132393635392C3132393636302C31342C3132393637312C3132393637392C31342C3132393730392C3132393731312C3134';
wwv_flow_imp.g_varchar2_table(260) := '2C3132393732382C3132393733302C31342C3132393735312C3132393735332C31342C3132393737362C3132393738322C31342C3931373530352C3931373530352C342C3931373736302C3931373939392C352C31302C31302C332C3132372C3135392C';
wwv_flow_imp.g_varchar2_table(261) := '342C3736382C3837392C352C313437312C313437312C352C313533362C313534312C312C313634382C313634382C352C313736372C313736382C352C313834302C313836362C352C323037302C323037332C352C323133372C323133392C352C32323734';
wwv_flow_imp.g_varchar2_table(262) := '2C323237342C312C323336332C323336332C372C323337372C323338302C372C323430322C323430332C352C323439342C323439342C352C323530372C323530382C372C323535382C323535382C352C323632322C323632342C372C323634312C323634';
wwv_flow_imp.g_varchar2_table(263) := '312C352C323639312C323639312C372C323735392C323736302C352C323738362C323738372C352C323837362C323837362C352C323838312C323838342C352C323930312C323930322C352C333030362C333030362C352C333031342C333031362C372C';
wwv_flow_imp.g_varchar2_table(264) := '333037322C333037322C352C333133342C333133362C352C333135372C333135382C352C333236302C333236302C352C333236362C333236362C352C333237342C333237352C372C333332382C333332392C352C333339312C333339322C372C33343035';
wwv_flow_imp.g_varchar2_table(265) := '2C333430352C352C333435372C333435372C352C333533362C333533372C372C333535312C333535312C352C333633362C333634322C352C333736342C333737322C352C333839352C333839352C352C333936372C333936372C372C333939332C343032';
wwv_flow_imp.g_varchar2_table(266) := '382C352C343134362C343135312C352C343138322C343138332C372C343232362C343232362C352C343235332C343235332C352C343935372C343935392C352C353934302C353934302C372C363037302C363037302C372C363038372C363038382C372C';
wwv_flow_imp.g_varchar2_table(267) := '363135382C363135382C342C363433322C363433342C352C363434382C363434392C372C363637392C363638302C352C363734322C363734322C352C363735342C363735342C352C363738332C363738332C352C363931322C363931352C352C36393636';
wwv_flow_imp.g_varchar2_table(268) := '2C363937302C352C363937382C363937382C352C373034322C373034322C372C373038302C373038312C352C373134332C373134332C372C373135302C373135302C372C373231322C373231392C352C373338302C373339322C352C373431322C373431';
wwv_flow_imp.g_varchar2_table(269) := '322C352C383230332C383230332C342C383233322C383233322C342C383236352C383236352C31342C383430302C383431322C352C383432312C383433322C352C383631372C383631382C31342C393136372C393136372C31342C393230302C39323030';
wwv_flow_imp.g_varchar2_table(270) := '2C31342C393431302C393431302C31342C393732332C393732362C31342C393733332C393733332C31342C393734352C393734352C31342C393735322C393735322C31342C393736302C393736302C31342C393736362C393736362C31342C393737342C';
wwv_flow_imp.g_varchar2_table(271) := '393737342C31342C393738362C393738362C31342C393739342C393739342C31342C393832332C393832332C31342C393832382C393832382C31342C393833332C393835302C31342C393835352C393835352C31342C393837352C393837352C31342C39';
wwv_flow_imp.g_varchar2_table(272) := '3838302C393838302C31342C393838352C393838372C31342C393839362C393839372C31342C393930362C393931362C31342C393932362C393932372C31342C393933352C393933352C31342C393933392C393933392C31342C393936322C393936322C';
wwv_flow_imp.g_varchar2_table(273) := '31342C393937322C393937322C31342C393937382C393937382C31342C393938362C393938362C31342C393939372C393939372C31342C31303030322C31303030322C31342C31303031372C31303031372C31342C31303035352C31303035352C31342C';
wwv_flow_imp.g_varchar2_table(274) := '31303037312C31303037312C31342C31303133332C31303133352C31342C31303534382C31303534392C31342C31313039332C31313039332C31342C31323333302C31323333332C352C31323434312C31323434322C352C34323630382C34323631302C';
wwv_flow_imp.g_varchar2_table(275) := '352C34333031302C34333031302C352C34333034352C34333034362C352C34333138382C34333230332C372C34333330322C34333330392C352C34333339322C34333339342C352C34333434362C34333434392C352C34333439332C34333439332C352C';
wwv_flow_imp.g_varchar2_table(276) := '34333537312C34333537322C372C34333539372C34333539372C372C34333730332C34333730342C352C34333735362C34333735372C352C34343030332C34343030342C372C34343030392C34343031302C372C34343033332C34343035392C31322C34';
wwv_flow_imp.g_varchar2_table(277) := '343038392C34343131352C31322C34343134352C34343137312C31322C34343230312C34343232372C31322C34343235372C34343238332C31322C34343331332C34343333392C31322C34343336392C34343339352C31322C34343432352C3434343531';
wwv_flow_imp.g_varchar2_table(278) := '2C31322C34343438312C34343530372C31322C34343533372C34343536332C31322C34343539332C34343631392C31322C34343634392C34343637352C31322C34343730352C34343733312C31322C34343736312C34343738372C31322C34343831372C';
wwv_flow_imp.g_varchar2_table(279) := '34343834332C31322C34343837332C34343839392C31322C34343932392C34343935352C31322C34343938352C34353031312C31322C34353034312C34353036372C31322C34353039372C34353132332C31322C34353135332C34353137392C31322C34';
wwv_flow_imp.g_varchar2_table(280) := '353230392C34353233352C31322C34353236352C34353239312C31322C34353332312C34353334372C31322C34353337372C34353430332C31322C34353433332C34353435392C31322C34353438392C34353531352C31322C34353534352C3435353731';
wwv_flow_imp.g_varchar2_table(281) := '2C31322C34353630312C34353632372C31322C34353635372C34353638332C31322C34353731332C34353733392C31322C34353736392C34353739352C31322C34353832352C34353835312C31322C34353838312C34353930372C31322C34353933372C';
wwv_flow_imp.g_varchar2_table(282) := '34353936332C31322C34353939332C34363031392C31322C34363034392C34363037352C31322C34363130352C34363133312C31322C34363136312C34363138372C31322C34363231372C34363234332C31322C34363237332C34363239392C31322C34';
wwv_flow_imp.g_varchar2_table(283) := '363332392C34363335352C31322C34363338352C34363431312C31322C34363434312C34363436372C31322C34363439372C34363532332C31322C34363535332C34363537392C31322C34363630392C34363633352C31322C34363636352C3436363931';
wwv_flow_imp.g_varchar2_table(284) := '2C31322C34363732312C34363734372C31322C34363737372C34363830332C31322C34363833332C34363835392C31322C34363838392C34363931352C31322C34363934352C34363937312C31322C34373030312C34373032372C31322C34373035372C';
wwv_flow_imp.g_varchar2_table(285) := '34373038332C31322C34373131332C34373133392C31322C34373136392C34373139352C31322C34373232352C34373235312C31322C34373238312C34373330372C31322C34373333372C34373336332C31322C34373339332C34373431392C31322C34';
wwv_flow_imp.g_varchar2_table(286) := '373434392C34373437352C31322C34373530352C34373533312C31322C34373536312C34373538372C31322C34373631372C34373634332C31322C34373637332C34373639392C31322C34373732392C34373735352C31322C34373738352C3437383131';
wwv_flow_imp.g_varchar2_table(287) := '2C31322C34373834312C34373836372C31322C34373839372C34373932332C31322C34373935332C34373937392C31322C34383030392C34383033352C31322C34383036352C34383039312C31322C34383132312C34383134372C31322C34383137372C';
wwv_flow_imp.g_varchar2_table(288) := '34383230332C31322C34383233332C34383235392C31322C34383238392C34383331352C31322C34383334352C34383337312C31322C34383430312C34383432372C31322C34383435372C34383438332C31322C34383531332C34383533392C31322C34';
wwv_flow_imp.g_varchar2_table(289) := '383536392C34383539352C31322C34383632352C34383635312C31322C34383638312C34383730372C31322C34383733372C34383736332C31322C34383739332C34383831392C31322C34383834392C34383837352C31322C34383930352C3438393331';
wwv_flow_imp.g_varchar2_table(290) := '2C31322C34383936312C34383938372C31322C34393031372C34393034332C31322C34393037332C34393039392C31322C34393132392C34393135352C31322C34393138352C34393231312C31322C34393234312C34393236372C31322C34393239372C';
wwv_flow_imp.g_varchar2_table(291) := '34393332332C31322C34393335332C34393337392C31322C34393430392C34393433352C31322C34393436352C34393439312C31322C34393532312C34393534372C31322C34393537372C34393630332C31322C34393633332C34393635392C31322C34';
wwv_flow_imp.g_varchar2_table(292) := '393638392C34393731352C31322C34393734352C34393737312C31322C34393830312C34393832372C31322C34393835372C34393838332C31322C34393931332C34393933392C31322C34393936392C34393939352C31322C35303032352C3530303531';
wwv_flow_imp.g_varchar2_table(293) := '2C31322C35303038312C35303130372C31322C35303133372C35303136332C31322C35303139332C35303231392C31322C35303234392C35303237352C31322C35303330352C35303333312C31322C35303336312C35303338372C31322C35303431372C';
wwv_flow_imp.g_varchar2_table(294) := '35303434332C31322C35303437332C35303439392C31322C35303532392C35303535352C31322C35303538352C35303631312C31322C35303634312C35303636372C31322C35303639372C35303732332C31322C35303735332C35303737392C31322C35';
wwv_flow_imp.g_varchar2_table(295) := '303830392C35303833352C31322C35303836352C35303839312C31322C35303932312C35303934372C31322C35303937372C35313030332C31322C35313033332C35313035392C31322C35313038392C35313131352C31322C35313134352C3531313731';
wwv_flow_imp.g_varchar2_table(296) := '2C31322C35313230312C35313232372C31322C35313235372C35313238332C31322C35313331332C35313333392C31322C35313336392C35313339352C31322C35313432352C35313435312C31322C35313438312C35313530372C31322C35313533372C';
wwv_flow_imp.g_varchar2_table(297) := '35313536332C31322C35313539332C35313631392C31322C35313634392C35313637352C31322C35313730352C35313733312C31322C35313736312C35313738372C31322C35313831372C35313834332C31322C35313837332C35313839392C31322C35';
wwv_flow_imp.g_varchar2_table(298) := '313932392C35313935352C31322C35313938352C35323031312C31322C35323034312C35323036372C31322C35323039372C35323132332C31322C35323135332C35323137392C31322C35323230392C35323233352C31322C35323236352C3532323931';
wwv_flow_imp.g_varchar2_table(299) := '2C31322C35323332312C35323334372C31322C35323337372C35323430332C31322C35323433332C35323435392C31322C35323438392C35323531352C31322C35323534352C35323537312C31322C35323630312C35323632372C31322C35323635372C';
wwv_flow_imp.g_varchar2_table(300) := '35323638332C31322C35323731332C35323733392C31322C35323736392C35323739352C31322C35323832352C35323835312C31322C35323838312C35323930372C31322C35323933372C35323936332C31322C35323939332C35333031392C31322C35';
wwv_flow_imp.g_varchar2_table(301) := '333034392C35333037352C31322C35333130352C35333133312C31322C35333136312C35333138372C31322C35333231372C35333234332C31322C35333237332C35333239392C31322C35333332392C35333335352C31322C35333338352C3533343131';
wwv_flow_imp.g_varchar2_table(302) := '2C31322C35333434312C35333436372C31322C35333439372C35333532332C31322C35333535332C35333537392C31322C35333630392C35333633352C31322C35333636352C35333639312C31322C35333732312C35333734372C31322C35333737372C';
wwv_flow_imp.g_varchar2_table(303) := '35333830332C31322C35333833332C35333835392C31322C35333838392C35333931352C31322C35333934352C35333937312C31322C35343030312C35343032372C31322C35343035372C35343038332C31322C35343131332C35343133392C31322C35';
wwv_flow_imp.g_varchar2_table(304) := '343136392C35343139352C31322C35343232352C35343235312C31322C35343238312C35343330372C31322C35343333372C35343336332C31322C35343339332C35343431392C31322C35343434392C35343437352C31322C35343530352C3534353331';
wwv_flow_imp.g_varchar2_table(305) := '2C31322C35343536312C35343538372C31322C35343631372C35343634332C31322C35343637332C35343639392C31322C35343732392C35343735352C31322C35343738352C35343831312C31322C35343834312C35343836372C31322C35343839372C';
wwv_flow_imp.g_varchar2_table(306) := '35343932332C31322C35343935332C35343937392C31322C35353030392C35353033352C31322C35353036352C35353039312C31322C35353132312C35353134372C31322C35353137372C35353230332C31322C36353032342C36353033392C352C3635';
wwv_flow_imp.g_varchar2_table(307) := '3532302C36353532382C342C36363432322C36363432362C352C36383135322C36383135342C352C36393239312C36393239322C352C36393633332C36393633332C352C36393734372C36393734382C352C36393831312C36393831342C352C36393832';
wwv_flow_imp.g_varchar2_table(308) := '362C36393832362C352C36393933322C36393933322C372C37303031362C37303031372C352C37303037392C37303038302C372C37303039352C37303039352C352C37303139362C37303139362C352C37303336372C37303336372C352C37303430322C';
wwv_flow_imp.g_varchar2_table(309) := '37303430332C372C37303436342C37303436342C352C37303438372C37303438372C352C37303730392C37303731312C372C37303732352C37303732352C372C37303833332C37303833342C372C37303834332C37303834342C372C37303834392C3730';
wwv_flow_imp.g_varchar2_table(310) := '3834392C372C37313039302C37313039332C352C37313130332C37313130342C352C37313232372C37313232382C372C37313333392C37313333392C352C37313334342C37313334392C352C37313435382C37313436312C352C37313732372C37313733';
wwv_flow_imp.g_varchar2_table(311) := '352C352C37313938352C37313938392C372C37313939382C37313939382C352C37323030322C37323030322C372C37323135342C37323135352C352C37323139332C37323230322C352C37323235312C37323235342C352C37323238312C37323238332C';
wwv_flow_imp.g_varchar2_table(312) := '352C37323334342C37323334352C352C37323736362C37323736362C372C37323837342C37323838302C352C37323838352C37323838362C352C37333032332C37333032392C352C37333130342C37333130352C352C37333131312C37333131312C352C';
wwv_flow_imp.g_varchar2_table(313) := '39323931322C39323931362C352C39343039352C39343039382C352C3131333832342C3131333832372C342C3131393134322C3131393134322C372C3131393135352C3131393136322C342C3131393336322C3131393336342C352C3132313437362C31';
wwv_flow_imp.g_varchar2_table(314) := '32313437362C352C3132323838382C3132323930342C352C3132333138342C3132333139302C352C3132353235322C3132353235382C352C3132373138332C3132373138332C31342C3132373334302C3132373334332C31342C3132373337372C313237';
wwv_flow_imp.g_varchar2_table(315) := '3338362C31342C3132373439312C3132373530332C31342C3132373534382C3132373535312C31342C3132373734342C3132373735362C31342C3132373736312C3132373736312C31342C3132373736392C3132373736392C31342C3132373737332C31';
wwv_flow_imp.g_varchar2_table(316) := '32373737342C31342C3132373738302C3132373738382C31342C3132373739362C3132373739372C31342C3132373832302C3132373832332C31342C3132373836392C3132373836392C31342C3132373839342C3132373839352C31342C313237393032';
wwv_flow_imp.g_varchar2_table(317) := '2C3132373930332C31342C3132373934332C3132373934332C31342C3132373934372C3132373935302C31342C3132373937322C3132373937322C31342C3132373938382C3132373938382C31342C3132373939322C3132373939342C31342C31323830';
wwv_flow_imp.g_varchar2_table(318) := '30392C3132383031312C31342C3132383031392C3132383031392C31342C3132383032332C3132383034312C31342C3132383036342C3132383036342C31342C3132383130322C3132383130372C31342C3132383137342C3132383138312C31342C3132';
wwv_flow_imp.g_varchar2_table(319) := '383233382C3132383233382C31342C3132383234362C3132383234372C31342C3132383235342C3132383235342C31342C3132383236342C3132383236342C31342C3132383237382C3132383239392C31342C3132383332392C3132383333302C31342C';
wwv_flow_imp.g_varchar2_table(320) := '3132383334382C3132383335392C31342C3132383337312C3132383337372C31342C3132383339322C3132383339332C31342C3132383430312C3132383430342C31342C3132383432312C3132383432312C31342C3132383433332C3132383433342C31';
wwv_flow_imp.g_varchar2_table(321) := '342C3132383435302C3132383435322C31342C3132383437362C3132383437382C31342C3132383438332C3132383438332C31342C3132383439352C3132383439352C31342C3132383530362C3132383530362C31342C3132383531392C313238353230';
wwv_flow_imp.g_varchar2_table(322) := '2C31342C3132383532382C3132383532382C31342C3132383533342C3132383533342C31342C3132383533382C3132383533382C31342C3132383534302C3132383534322C31342C3132383534342C3132383534392C31342C3132383535322C31323835';
wwv_flow_imp.g_varchar2_table(323) := '35352C31342C3132383535372C3132383535372C31342C3132383536302C3132383536332C31342C3132383536352C3132383536352C31342C3132383536372C3132383537362C31342C3132383538312C3132383539312C31342C3132383634312C3132';
wwv_flow_imp.g_varchar2_table(324) := '383634322C31342C3132383634362C3132383634362C31342C3132383634382C3132383634382C31342C3132383635302C3132383635312C31342C3132383635332C3132383635332C31342C3132383635352C3132383635352C31342C3132383635372C';
wwv_flow_imp.g_varchar2_table(325) := '3132383635392C31342C3132383636312C3132383636312C31342C3132383636332C3132383636332C31342C3132383636352C3132383636362C31342C3132383637342C3132383637342C31342C3132383637362C3132383637372C31342C3132383637';
wwv_flow_imp.g_varchar2_table(326) := '392C3132383638352C31342C3132383639302C3132383639302C31342C3132383639342C3132383639342C31342C3132383639372C3132383730322C31342C3132383730342C3132383730342C31342C3132383731302C3132383731342C31342C313238';
wwv_flow_imp.g_varchar2_table(327) := '3731362C3132383731362C31342C3132383732302C3132383732302C31342C3132383732332C3132383732342C31342C3132383732362C3132383732372C31342C3132383733332C3132383733352C31342C3132383734322C3132383734342C31342C31';
wwv_flow_imp.g_varchar2_table(328) := '32383734362C3132383734362C31342C3132383734392C3132383735312C31342C3132383735332C3132383735342C31342C3132383735362C3132383735382C31342C3132383736312C3132383736312C31342C3132383736332C3132383736342C3134';
wwv_flow_imp.g_varchar2_table(329) := '2C3132383838342C3132383839352C31342C3132383939322C3132393030332C31342C3132393030382C3132393030382C31342C3132393033362C3132393033392C31342C3132393131342C3132393131392C31342C3132393139382C3132393237392C';
wwv_flow_imp.g_varchar2_table(330) := '31342C3132393239332C3132393239352C31342C3132393330352C3132393331302C31342C3132393331322C3132393331392C31342C3132393332382C3132393332382C31342C3132393333312C3132393333382C31342C3132393334332C3132393334';
wwv_flow_imp.g_varchar2_table(331) := '332C31342C3132393335312C3132393335352C31342C3132393335372C3132393335392C31342C3132393337352C3132393338372C31342C3132393339332C3132393339332C31342C3132393339352C3132393339382C31342C3132393430312C313239';
wwv_flow_imp.g_varchar2_table(332) := '3430312C31342C3132393430332C3132393430332C31342C3132393430382C3132393431322C31342C3132393432362C3132393433312C31342C3132393434332C3132393434342C31342C3132393435312C3132393435332C31342C3132393435362C31';
wwv_flow_imp.g_varchar2_table(333) := '32393436352C31342C3132393437322C3132393437322C31342C3132393437352C3132393438322C31342C3132393438342C3132393438342C31342C3132393438382C3132393531302C31342C3132393533362C3132393634372C31342C313239363532';
wwv_flow_imp.g_varchar2_table(334) := '2C3132393635322C31342C3132393635362C3132393635382C31342C3132393636312C3132393636332C31342C3132393636372C3132393637302C31342C3132393638302C3132393638352C31342C3132393730352C3132393730382C31342C31323937';
wwv_flow_imp.g_varchar2_table(335) := '31322C3132393731382C31342C3132393732332C3132393732372C31342C3132393733312C3132393733332C31342C3132393734342C3132393735302C31342C3132393735342C3132393735392C31342C3132393736382C3132393737352C31342C3132';
wwv_flow_imp.g_varchar2_table(336) := '393738332C3132393739312C31342C3931373530342C3931373530342C342C3931373530362C3931373533352C342C3931373633322C3931373735392C342C3931383030302C3932313539392C342C302C392C342C31312C31322C342C31342C33312C34';
wwv_flow_imp.g_varchar2_table(337) := '2C3136392C3136392C31342C3137342C3137342C31342C313135352C313135392C352C313432352C313436392C352C313437332C313437342C352C313437392C313437392C352C313535322C313536322C352C313631312C313633312C352C313735302C';
wwv_flow_imp.g_varchar2_table(338) := '313735362C352C313735392C313736342C352C313737302C313737332C352C313830392C313830392C352C313935382C313936382C352C323034352C323034352C352C323037352C323038332C352C323038392C323039332C352C323139322C32313933';
wwv_flow_imp.g_varchar2_table(339) := '2C312C323235302C323237332C352C323237352C323330362C352C323336322C323336322C352C323336342C323336342C352C323336392C323337362C352C323338312C323338312C352C323338352C323339312C352C323433332C323433332C352C32';
wwv_flow_imp.g_varchar2_table(340) := '3439322C323439322C352C323439352C323439362C372C323530332C323530342C372C323530392C323530392C352C323533302C323533312C352C323536312C323536322C352C323632302C323632302C352C323632352C323632362C352C323633352C';
wwv_flow_imp.g_varchar2_table(341) := '323633372C352C323637322C323637332C352C323638392C323639302C352C323734382C323734382C352C323735332C323735372C352C323736312C323736312C372C323736352C323736352C352C323831302C323831352C352C323831382C32383139';
wwv_flow_imp.g_varchar2_table(342) := '2C372C323837382C323837382C352C323838302C323838302C372C323838372C323838382C372C323839332C323839332C352C323930332C323930332C352C323934362C323934362C352C333030372C333030372C372C333030392C333031302C372C33';
wwv_flow_imp.g_varchar2_table(343) := '3031382C333032302C372C333033312C333033312C352C333037332C333037352C372C333133322C333133322C352C333133372C333134302C372C333134362C333134392C352C333137302C333137312C352C333230322C333230332C372C333236322C';
wwv_flow_imp.g_varchar2_table(344) := '333236322C372C333236342C333236352C372C333236372C333236382C372C333237312C333237322C372C333237362C333237372C352C333239382C333239392C352C333333302C333333312C372C333339302C333339302C352C333339332C33333936';
wwv_flow_imp.g_varchar2_table(345) := '2C352C333430322C333430342C372C333430362C333430362C312C333432362C333432372C352C333435382C333435392C372C333533352C333533352C352C333533382C333534302C352C333534342C333535302C372C333537302C333537312C372C33';
wwv_flow_imp.g_varchar2_table(346) := '3633352C333633352C372C333635352C333636322C352C333736332C333736332C372C333738342C333738392C352C333839332C333839332C352C333839372C333839372C352C333935332C333936362C352C333936382C333937322C352C333938312C';
wwv_flow_imp.g_varchar2_table(347) := '333939312C352C343033382C343033382C352C343134352C343134352C372C343135332C343135342C352C343135372C343135382C352C343138342C343138352C352C343230392C343231322C352C343232382C343232382C372C343233372C34323337';
wwv_flow_imp.g_varchar2_table(348) := '2C352C343335322C343434372C382C343532302C343630372C31302C353930362C353930382C352C353933382C353933392C352C353937302C353937312C352C363036382C363036392C352C363037312C363037372C352C363038362C363038362C352C';
wwv_flow_imp.g_varchar2_table(349) := '363038392C363039392C352C363135352C363135372C352C363135392C363135392C352C363331332C363331332C352C363433352C363433382C372C363434312C363434332C372C363435302C363435302C352C363435372C363435392C352C36363831';
wwv_flow_imp.g_varchar2_table(350) := '2C363638322C372C363734312C363734312C372C363734332C363734332C372C363735322C363735322C352C363735372C363736342C352C363737312C363738302C352C363833322C363834352C352C363834372C363836322C352C363931362C363931';
wwv_flow_imp.g_varchar2_table(351) := '362C372C363936352C363936352C352C363937312C363937312C372C363937332C363937372C372C363937392C363938302C372C373034302C373034312C352C373037332C373037332C372C373037382C373037392C372C373038322C373038322C372C';
wwv_flow_imp.g_varchar2_table(352) := '373134322C373134322C352C373134342C373134352C352C373134392C373134392C352C373135312C373135332C352C373230342C373231312C372C373232302C373232312C372C373337362C373337382C352C373339332C373339332C372C37343035';
wwv_flow_imp.g_varchar2_table(353) := '2C373430352C352C373431352C373431352C372C373631362C373637392C352C383230342C383230342C352C383230362C383230372C342C383233332C383233332C342C383235322C383235322C31342C383238382C383239322C342C383239342C3833';
wwv_flow_imp.g_varchar2_table(354) := '30332C342C383431332C383431362C352C383431382C383432302C352C383438322C383438322C31342C383539362C383630312C31342C383938362C383938372C31342C393039362C393039362C31342C393139332C393139362C31342C393139392C39';
wwv_flow_imp.g_varchar2_table(355) := '3139392C31342C393230312C393230322C31342C393230382C393231302C31342C393634322C393634332C31342C393636342C393636342C31342C393732382C393732392C31342C393733322C393733322C31342C393733352C393734312C31342C3937';
wwv_flow_imp.g_varchar2_table(356) := '34332C393734342C31342C393734362C393734362C31342C393735302C393735312C31342C393735332C393735362C31342C393735382C393735392C31342C393736312C393736312C31342C393736342C393736352C31342C393736372C393736392C31';
wwv_flow_imp.g_varchar2_table(357) := '342C393737312C393737332C31342C393737352C393737352C31342C393738342C393738352C31342C393738372C393739312C31342C393739332C393739332C31342C393739352C393739392C31342C393831322C393832322C31342C393832342C3938';
wwv_flow_imp.g_varchar2_table(358) := '32342C31342C393832372C393832372C31342C393832392C393833302C31342C393833322C393833322C31342C393835312C393835312C31342C393835342C393835342C31342C393835362C393836312C31342C393837342C393837342C31342C393837';
wwv_flow_imp.g_varchar2_table(359) := '362C393837362C31342C393837382C393837392C31342C393838312C393838312C31342C393838332C393838342C31342C393838382C393838392C31342C393839352C393839352C31342C393839382C393839392C31342C393930342C393930352C3134';
wwv_flow_imp.g_varchar2_table(360) := '2C393931372C393931382C31342C393932342C393932352C31342C393932382C393932382C31342C393933342C393933342C31342C393933362C393933362C31342C393933382C393933382C31342C393934302C393934302C31342C393936312C393936';
wwv_flow_imp.g_varchar2_table(361) := '312C31342C393936332C393936372C31342C393937302C393937312C31342C393937332C393937332C31342C393937352C393937372C31342C393937392C393938302C31342C393938322C393938352C31342C393938372C393938382C31342C39393932';
wwv_flow_imp.g_varchar2_table(362) := '2C393939362C31342C393939382C393939382C31342C31303030302C31303030312C31342C31303030342C31303030342C31342C31303031332C31303031332C31342C31303032342C31303032342C31342C31303035322C31303035322C31342C313030';
wwv_flow_imp.g_varchar2_table(363) := '36302C31303036302C31342C31303036372C31303036392C31342C31303038332C31303038332C31342C31303038352C31303038372C31342C31303134352C31303134352C31342C31303137352C31303137352C31342C31313031332C31313031352C31';
wwv_flow_imp.g_varchar2_table(364) := '342C31313038382C31313038382C31342C31313530332C31313530352C352C31313734342C31313737352C352C31323333342C31323333352C352C31323334392C31323334392C31342C31323935312C31323935312C31342C34323630372C3432363037';
wwv_flow_imp.g_varchar2_table(365) := '2C352C34323631322C34323632312C352C34323733362C34323733372C352C34333031342C34333031342C352C34333034332C34333034342C372C34333034372C34333034372C372C34333133362C34333133372C372C34333230342C34333230352C35';
wwv_flow_imp.g_varchar2_table(366) := '2C34333236332C34333236332C352C34333333352C34333334352C352C34333336302C34333338382C382C34333339352C34333339352C372C34333434342C34333434352C372C34333435302C34333435312C372C34333435342C34333435362C372C34';
wwv_flow_imp.g_varchar2_table(367) := '333536312C34333536362C352C34333536392C34333537302C352C34333537332C34333537342C352C34333539362C34333539362C352C34333634342C34333634342C352C34333639382C34333730302C352C34333731302C34333731312C352C343337';
wwv_flow_imp.g_varchar2_table(368) := '35352C34333735352C372C34333735382C34333735392C372C34333736362C34333736362C352C34343030352C34343030352C352C34343030382C34343030382C352C34343031322C34343031322C372C34343033322C34343033322C31312C34343036';
wwv_flow_imp.g_varchar2_table(369) := '302C34343036302C31312C34343038382C34343038382C31312C34343131362C34343131362C31312C34343134342C34343134342C31312C34343137322C34343137322C31312C34343230302C34343230302C31312C34343232382C34343232382C3131';
wwv_flow_imp.g_varchar2_table(370) := '2C34343235362C34343235362C31312C34343238342C34343238342C31312C34343331322C34343331322C31312C34343334302C34343334302C31312C34343336382C34343336382C31312C34343339362C34343339362C31312C34343432342C343434';
wwv_flow_imp.g_varchar2_table(371) := '32342C31312C34343435322C34343435322C31312C34343438302C34343438302C31312C34343530382C34343530382C31312C34343533362C34343533362C31312C34343536342C34343536342C31312C34343539322C34343539322C31312C34343632';
wwv_flow_imp.g_varchar2_table(372) := '302C34343632302C31312C34343634382C34343634382C31312C34343637362C34343637362C31312C34343730342C34343730342C31312C34343733322C34343733322C31312C34343736302C34343736302C31312C34343738382C34343738382C3131';
wwv_flow_imp.g_varchar2_table(373) := '2C34343831362C34343831362C31312C34343834342C34343834342C31312C34343837322C34343837322C31312C34343930302C34343930302C31312C34343932382C34343932382C31312C34343935362C34343935362C31312C34343938342C343439';
wwv_flow_imp.g_varchar2_table(374) := '38342C31312C34353031322C34353031322C31312C34353034302C34353034302C31312C34353036382C34353036382C31312C34353039362C34353039362C31312C34353132342C34353132342C31312C34353135322C34353135322C31312C34353138';
wwv_flow_imp.g_varchar2_table(375) := '302C34353138302C31312C34353230382C34353230382C31312C34353233362C34353233362C31312C34353236342C34353236342C31312C34353239322C34353239322C31312C34353332302C34353332302C31312C34353334382C34353334382C3131';
wwv_flow_imp.g_varchar2_table(376) := '2C34353337362C34353337362C31312C34353430342C34353430342C31312C34353433322C34353433322C31312C34353436302C34353436302C31312C34353438382C34353438382C31312C34353531362C34353531362C31312C34353534342C343535';
wwv_flow_imp.g_varchar2_table(377) := '34342C31312C34353537322C34353537322C31312C34353630302C34353630302C31312C34353632382C34353632382C31312C34353635362C34353635362C31312C34353638342C34353638342C31312C34353731322C34353731322C31312C34353734';
wwv_flow_imp.g_varchar2_table(378) := '302C34353734302C31312C34353736382C34353736382C31312C34353739362C34353739362C31312C34353832342C34353832342C31312C34353835322C34353835322C31312C34353838302C34353838302C31312C34353930382C34353930382C3131';
wwv_flow_imp.g_varchar2_table(379) := '2C34353933362C34353933362C31312C34353936342C34353936342C31312C34353939322C34353939322C31312C34363032302C34363032302C31312C34363034382C34363034382C31312C34363037362C34363037362C31312C34363130342C343631';
wwv_flow_imp.g_varchar2_table(380) := '30342C31312C34363133322C34363133322C31312C34363136302C34363136302C31312C34363138382C34363138382C31312C34363231362C34363231362C31312C34363234342C34363234342C31312C34363237322C34363237322C31312C34363330';
wwv_flow_imp.g_varchar2_table(381) := '302C34363330302C31312C34363332382C34363332382C31312C34363335362C34363335362C31312C34363338342C34363338342C31312C34363431322C34363431322C31312C34363434302C34363434302C31312C34363436382C34363436382C3131';
wwv_flow_imp.g_varchar2_table(382) := '2C34363439362C34363439362C31312C34363532342C34363532342C31312C34363535322C34363535322C31312C34363538302C34363538302C31312C34363630382C34363630382C31312C34363633362C34363633362C31312C34363636342C343636';
wwv_flow_imp.g_varchar2_table(383) := '36342C31312C34363639322C34363639322C31312C34363732302C34363732302C31312C34363734382C34363734382C31312C34363737362C34363737362C31312C34363830342C34363830342C31312C34363833322C34363833322C31312C34363836';
wwv_flow_imp.g_varchar2_table(384) := '302C34363836302C31312C34363838382C34363838382C31312C34363931362C34363931362C31312C34363934342C34363934342C31312C34363937322C34363937322C31312C34373030302C34373030302C31312C34373032382C34373032382C3131';
wwv_flow_imp.g_varchar2_table(385) := '2C34373035362C34373035362C31312C34373038342C34373038342C31312C34373131322C34373131322C31312C34373134302C34373134302C31312C34373136382C34373136382C31312C34373139362C34373139362C31312C34373232342C343732';
wwv_flow_imp.g_varchar2_table(386) := '32342C31312C34373235322C34373235322C31312C34373238302C34373238302C31312C34373330382C34373330382C31312C34373333362C34373333362C31312C34373336342C34373336342C31312C34373339322C34373339322C31312C34373432';
wwv_flow_imp.g_varchar2_table(387) := '302C34373432302C31312C34373434382C34373434382C31312C34373437362C34373437362C31312C34373530342C34373530342C31312C34373533322C34373533322C31312C34373536302C34373536302C31312C34373538382C34373538382C3131';
wwv_flow_imp.g_varchar2_table(388) := '2C34373631362C34373631362C31312C34373634342C34373634342C31312C34373637322C34373637322C31312C34373730302C34373730302C31312C34373732382C34373732382C31312C34373735362C34373735362C31312C34373738342C343737';
wwv_flow_imp.g_varchar2_table(389) := '38342C31312C34373831322C34373831322C31312C34373834302C34373834302C31312C34373836382C34373836382C31312C34373839362C34373839362C31312C34373932342C34373932342C31312C34373935322C34373935322C31312C34373938';
wwv_flow_imp.g_varchar2_table(390) := '302C34373938302C31312C34383030382C34383030382C31312C34383033362C34383033362C31312C34383036342C34383036342C31312C34383039322C34383039322C31312C34383132302C34383132302C31312C34383134382C34383134382C3131';
wwv_flow_imp.g_varchar2_table(391) := '2C34383137362C34383137362C31312C34383230342C34383230342C31312C34383233322C34383233322C31312C34383236302C34383236302C31312C34383238382C34383238382C31312C34383331362C34383331362C31312C34383334342C343833';
wwv_flow_imp.g_varchar2_table(392) := '34342C31312C34383337322C34383337322C31312C34383430302C34383430302C31312C34383432382C34383432382C31312C34383435362C34383435362C31312C34383438342C34383438342C31312C34383531322C34383531322C31312C34383534';
wwv_flow_imp.g_varchar2_table(393) := '302C34383534302C31312C34383536382C34383536382C31312C34383539362C34383539362C31312C34383632342C34383632342C31312C34383635322C34383635322C31312C34383638302C34383638302C31312C34383730382C34383730382C3131';
wwv_flow_imp.g_varchar2_table(394) := '2C34383733362C34383733362C31312C34383736342C34383736342C31312C34383739322C34383739322C31312C34383832302C34383832302C31312C34383834382C34383834382C31312C34383837362C34383837362C31312C34383930342C343839';
wwv_flow_imp.g_varchar2_table(395) := '30342C31312C34383933322C34383933322C31312C34383936302C34383936302C31312C34383938382C34383938382C31312C34393031362C34393031362C31312C34393034342C34393034342C31312C34393037322C34393037322C31312C34393130';
wwv_flow_imp.g_varchar2_table(396) := '302C34393130302C31312C34393132382C34393132382C31312C34393135362C34393135362C31312C34393138342C34393138342C31312C34393231322C34393231322C31312C34393234302C34393234302C31312C34393236382C34393236382C3131';
wwv_flow_imp.g_varchar2_table(397) := '2C34393239362C34393239362C31312C34393332342C34393332342C31312C34393335322C34393335322C31312C34393338302C34393338302C31312C34393430382C34393430382C31312C34393433362C34393433362C31312C34393436342C343934';
wwv_flow_imp.g_varchar2_table(398) := '36342C31312C34393439322C34393439322C31312C34393532302C34393532302C31312C34393534382C34393534382C31312C34393537362C34393537362C31312C34393630342C34393630342C31312C34393633322C34393633322C31312C34393636';
wwv_flow_imp.g_varchar2_table(399) := '302C34393636302C31312C34393638382C34393638382C31312C34393731362C34393731362C31312C34393734342C34393734342C31312C34393737322C34393737322C31312C34393830302C34393830302C31312C34393832382C34393832382C3131';
wwv_flow_imp.g_varchar2_table(400) := '2C34393835362C34393835362C31312C34393838342C34393838342C31312C34393931322C34393931322C31312C34393934302C34393934302C31312C34393936382C34393936382C31312C34393939362C34393939362C31312C35303032342C353030';
wwv_flow_imp.g_varchar2_table(401) := '32342C31312C35303035322C35303035322C31312C35303038302C35303038302C31312C35303130382C35303130382C31312C35303133362C35303133362C31312C35303136342C35303136342C31312C35303139322C35303139322C31312C35303232';
wwv_flow_imp.g_varchar2_table(402) := '302C35303232302C31312C35303234382C35303234382C31312C35303237362C35303237362C31312C35303330342C35303330342C31312C35303333322C35303333322C31312C35303336302C35303336302C31312C35303338382C35303338382C3131';
wwv_flow_imp.g_varchar2_table(403) := '2C35303431362C35303431362C31312C35303434342C35303434342C31312C35303437322C35303437322C31312C35303530302C35303530302C31312C35303532382C35303532382C31312C35303535362C35303535362C31312C35303538342C353035';
wwv_flow_imp.g_varchar2_table(404) := '38342C31312C35303631322C35303631322C31312C35303634302C35303634302C31312C35303636382C35303636382C31312C35303639362C35303639362C31312C35303732342C35303732342C31312C35303735322C35303735322C31312C35303738';
wwv_flow_imp.g_varchar2_table(405) := '302C35303738302C31312C35303830382C35303830382C31312C35303833362C35303833362C31312C35303836342C35303836342C31312C35303839322C35303839322C31312C35303932302C35303932302C31312C35303934382C35303934382C3131';
wwv_flow_imp.g_varchar2_table(406) := '2C35303937362C35303937362C31312C35313030342C35313030342C31312C35313033322C35313033322C31312C35313036302C35313036302C31312C35313038382C35313038382C31312C35313131362C35313131362C31312C35313134342C353131';
wwv_flow_imp.g_varchar2_table(407) := '34342C31312C35313137322C35313137322C31312C35313230302C35313230302C31312C35313232382C35313232382C31312C35313235362C35313235362C31312C35313238342C35313238342C31312C35313331322C35313331322C31312C35313334';
wwv_flow_imp.g_varchar2_table(408) := '302C35313334302C31312C35313336382C35313336382C31312C35313339362C35313339362C31312C35313432342C35313432342C31312C35313435322C35313435322C31312C35313438302C35313438302C31312C35313530382C35313530382C3131';
wwv_flow_imp.g_varchar2_table(409) := '2C35313533362C35313533362C31312C35313536342C35313536342C31312C35313539322C35313539322C31312C35313632302C35313632302C31312C35313634382C35313634382C31312C35313637362C35313637362C31312C35313730342C353137';
wwv_flow_imp.g_varchar2_table(410) := '30342C31312C35313733322C35313733322C31312C35313736302C35313736302C31312C35313738382C35313738382C31312C35313831362C35313831362C31312C35313834342C35313834342C31312C35313837322C35313837322C31312C35313930';
wwv_flow_imp.g_varchar2_table(411) := '302C35313930302C31312C35313932382C35313932382C31312C35313935362C35313935362C31312C35313938342C35313938342C31312C35323031322C35323031322C31312C35323034302C35323034302C31312C35323036382C35323036382C3131';
wwv_flow_imp.g_varchar2_table(412) := '2C35323039362C35323039362C31312C35323132342C35323132342C31312C35323135322C35323135322C31312C35323138302C35323138302C31312C35323230382C35323230382C31312C35323233362C35323233362C31312C35323236342C353232';
wwv_flow_imp.g_varchar2_table(413) := '36342C31312C35323239322C35323239322C31312C35323332302C35323332302C31312C35323334382C35323334382C31312C35323337362C35323337362C31312C35323430342C35323430342C31312C35323433322C35323433322C31312C35323436';
wwv_flow_imp.g_varchar2_table(414) := '302C35323436302C31312C35323438382C35323438382C31312C35323531362C35323531362C31312C35323534342C35323534342C31312C35323537322C35323537322C31312C35323630302C35323630302C31312C35323632382C35323632382C3131';
wwv_flow_imp.g_varchar2_table(415) := '2C35323635362C35323635362C31312C35323638342C35323638342C31312C35323731322C35323731322C31312C35323734302C35323734302C31312C35323736382C35323736382C31312C35323739362C35323739362C31312C35323832342C353238';
wwv_flow_imp.g_varchar2_table(416) := '32342C31312C35323835322C35323835322C31312C35323838302C35323838302C31312C35323930382C35323930382C31312C35323933362C35323933362C31312C35323936342C35323936342C31312C35323939322C35323939322C31312C35333032';
wwv_flow_imp.g_varchar2_table(417) := '302C35333032302C31312C35333034382C35333034382C31312C35333037362C35333037362C31312C35333130342C35333130342C31312C35333133322C35333133322C31312C35333136302C35333136302C31312C35333138382C35333138382C3131';
wwv_flow_imp.g_varchar2_table(418) := '2C35333231362C35333231362C31312C35333234342C35333234342C31312C35333237322C35333237322C31312C35333330302C35333330302C31312C35333332382C35333332382C31312C35333335362C35333335362C31312C35333338342C353333';
wwv_flow_imp.g_varchar2_table(419) := '38342C31312C35333431322C35333431322C31312C35333434302C35333434302C31312C35333436382C35333436382C31312C35333439362C35333439362C31312C35333532342C35333532342C31312C35333535322C35333535322C31312C35333538';
wwv_flow_imp.g_varchar2_table(420) := '302C35333538302C31312C35333630382C35333630382C31312C35333633362C35333633362C31312C35333636342C35333636342C31312C35333639322C35333639322C31312C35333732302C35333732302C31312C35333734382C35333734382C3131';
wwv_flow_imp.g_varchar2_table(421) := '2C35333737362C35333737362C31312C35333830342C35333830342C31312C35333833322C35333833322C31312C35333836302C35333836302C31312C35333838382C35333838382C31312C35333931362C35333931362C31312C35333934342C353339';
wwv_flow_imp.g_varchar2_table(422) := '34342C31312C35333937322C35333937322C31312C35343030302C35343030302C31312C35343032382C35343032382C31312C35343035362C35343035362C31312C35343038342C35343038342C31312C35343131322C35343131322C31312C35343134';
wwv_flow_imp.g_varchar2_table(423) := '302C35343134302C31312C35343136382C35343136382C31312C35343139362C35343139362C31312C35343232342C35343232342C31312C35343235322C35343235322C31312C35343238302C35343238302C31312C35343330382C35343330382C3131';
wwv_flow_imp.g_varchar2_table(424) := '2C35343333362C35343333362C31312C35343336342C35343336342C31312C35343339322C35343339322C31312C35343432302C35343432302C31312C35343434382C35343434382C31312C35343437362C35343437362C31312C35343530342C353435';
wwv_flow_imp.g_varchar2_table(425) := '30342C31312C35343533322C35343533322C31312C35343536302C35343536302C31312C35343538382C35343538382C31312C35343631362C35343631362C31312C35343634342C35343634342C31312C35343637322C35343637322C31312C35343730';
wwv_flow_imp.g_varchar2_table(426) := '302C35343730302C31312C35343732382C35343732382C31312C35343735362C35343735362C31312C35343738342C35343738342C31312C35343831322C35343831322C31312C35343834302C35343834302C31312C35343836382C35343836382C3131';
wwv_flow_imp.g_varchar2_table(427) := '2C35343839362C35343839362C31312C35343932342C35343932342C31312C35343935322C35343935322C31312C35343938302C35343938302C31312C35353030382C35353030382C31312C35353033362C35353033362C31312C35353036342C353530';
wwv_flow_imp.g_varchar2_table(428) := '36342C31312C35353039322C35353039322C31312C35353132302C35353132302C31312C35353134382C35353134382C31312C35353137362C35353137362C31312C35353231362C35353233382C392C36343238362C36343238362C352C36353035362C';
wwv_flow_imp.g_varchar2_table(429) := '36353037312C352C36353433382C36353433392C352C36353532392C36353533312C342C36363237322C36363237322C352C36383039372C36383039392C352C36383130382C36383131312C352C36383135392C36383135392C352C36383930302C3638';
wwv_flow_imp.g_varchar2_table(430) := '3930332C352C36393434362C36393435362C352C36393633322C36393633322C372C36393633342C36393633342C372C36393734342C36393734342C352C36393735392C36393736312C352C36393830382C36393831302C372C36393831352C36393831';
wwv_flow_imp.g_varchar2_table(431) := '362C372C36393832312C36393832312C312C36393833372C36393833372C312C36393932372C36393933312C352C36393933332C36393934302C352C37303030332C37303030332C352C37303031382C37303031382C372C37303037302C37303037382C';
wwv_flow_imp.g_varchar2_table(432) := '352C37303038322C37303038332C312C37303039342C37303039342C372C37303138382C37303139302C372C37303139342C37303139352C372C37303139372C37303139372C372C37303230362C37303230362C352C37303336382C37303337302C372C';
wwv_flow_imp.g_varchar2_table(433) := '37303430302C37303430312C352C37303435392C37303436302C352C37303436332C37303436332C372C37303436352C37303436382C372C37303437352C37303437372C372C37303439382C37303439392C372C37303531322C37303531362C352C3730';
wwv_flow_imp.g_varchar2_table(434) := '3731322C37303731392C352C37303732322C37303732342C352C37303732362C37303732362C352C37303833322C37303833322C352C37303833352C37303834302C352C37303834322C37303834322C352C37303834352C37303834352C352C37303834';
wwv_flow_imp.g_varchar2_table(435) := '372C37303834382C352C37303835302C37303835312C352C37313038382C37313038392C372C37313039362C37313039392C372C37313130322C37313130322C372C37313133322C37313133332C352C37313231392C37313232362C352C37313232392C';
wwv_flow_imp.g_varchar2_table(436) := '37313232392C352C37313233312C37313233322C352C37313334302C37313334302C372C37313334322C37313334332C372C37313335302C37313335302C372C37313435332C37313435352C352C37313436322C37313436322C372C37313732342C3731';
wwv_flow_imp.g_varchar2_table(437) := '3732362C372C37313733362C37313733362C372C37313938342C37313938342C352C37313939312C37313939322C372C37313939372C37313939372C372C37313939392C37313939392C312C37323030312C37323030312C312C37323030332C37323030';
wwv_flow_imp.g_varchar2_table(438) := '332C352C37323134382C37323135312C352C37323135362C37323135392C372C37323136342C37323136342C372C37323234332C37323234382C352C37323235302C37323235302C312C37323236332C37323236332C352C37323237392C37323238302C';
wwv_flow_imp.g_varchar2_table(439) := '372C37323332342C37323332392C312C37323334332C37323334332C372C37323735312C37323735312C372C37323736302C37323736352C352C37323736372C37323736372C352C37323837332C37323837332C372C37323838312C37323838312C372C';
wwv_flow_imp.g_varchar2_table(440) := '37323838342C37323838342C372C37333030392C37333031342C352C37333032302C37333032312C352C37333033302C37333033302C312C37333039382C37333130322C372C37333130372C37333130382C372C37333131302C37333131302C372C3733';
wwv_flow_imp.g_varchar2_table(441) := '3435392C37333436302C352C37383839362C37383930342C342C39323937362C39323938322C352C39343033332C39343038372C372C39343138302C39343138302C352C3131333832312C3131333832322C352C3131383532382C3131383537332C352C';
wwv_flow_imp.g_varchar2_table(442) := '3131393134312C3131393134312C352C3131393134332C3131393134352C352C3131393135302C3131393135342C352C3131393136332C3131393137302C352C3131393231302C3131393231332C352C3132313334342C3132313339382C352C31323134';
wwv_flow_imp.g_varchar2_table(443) := '36312C3132313436312C352C3132313439392C3132313530332C352C3132323838302C3132323838362C352C3132323930372C3132323931332C352C3132323931382C3132323932322C352C3132333536362C3132333536362C352C3132353133362C31';
wwv_flow_imp.g_varchar2_table(444) := '32353134322C352C3132363937362C3132363937392C31342C3132363938312C3132373138322C31342C3132373138342C3132373233312C31342C3132373237392C3132373237392C31342C3132373334342C3132373334352C31342C3132373337342C';
wwv_flow_imp.g_varchar2_table(445) := '3132373337342C31342C3132373430352C3132373436312C31342C3132373438392C3132373439302C31342C3132373531342C3132373531342C31342C3132373533382C3132373534362C31342C3132373536312C3132373536372C31342C3132373537';
wwv_flow_imp.g_varchar2_table(446) := '302C3132373734332C31342C3132373735372C3132373735382C31342C3132373736302C3132373736302C31342C3132373736322C3132373736322C31342C3132373736362C3132373736382C31342C3132373737302C3132373737302C31342C313237';
wwv_flow_imp.g_varchar2_table(447) := '3737322C3132373737322C31342C3132373737352C3132373737362C31342C3132373737382C3132373737392C31342C3132373738392C3132373739312C31342C3132373739342C3132373739352C31342C3132373739382C3132373739382C31342C31';
wwv_flow_imp.g_varchar2_table(448) := '32373831392C3132373831392C31342C3132373832342C3132373832342C31342C3132373836382C3132373836382C31342C3132373837302C3132373837312C31342C3132373839322C3132373839332C31342C3132373839362C3132373839362C3134';
wwv_flow_imp.g_varchar2_table(449) := '2C3132373930302C3132373930312C31342C3132373930342C3132373934302C31342C3132373934322C3132373934322C31342C3132373934342C3132373934342C31342C3132373934362C3132373934362C31342C3132373935312C3132373935352C';
wwv_flow_imp.g_varchar2_table(450) := '31342C3132373936382C3132373937312C31342C3132373937332C3132373938342C31342C3132373938372C3132373938372C31342C3132373938392C3132373938392C31342C3132373939312C3132373939312C31342C3132373939352C3132373939';
wwv_flow_imp.g_varchar2_table(451) := '392C352C3132383030382C3132383030382C31342C3132383031322C3132383031342C31342C3132383031372C3132383031382C31342C3132383032302C3132383032302C31342C3132383032322C3132383032322C31342C3132383034322C31323830';
wwv_flow_imp.g_varchar2_table(452) := '34322C31342C3132383036332C3132383036332C31342C3132383036352C3132383036352C31342C3132383130312C3132383130312C31342C3132383130382C3132383130392C31342C3132383137332C3132383137332C31342C3132383138322C3132';
wwv_flow_imp.g_varchar2_table(453) := '383138332C31342C3132383233362C3132383233372C31342C3132383233392C3132383233392C31342C3132383234352C3132383234352C31342C3132383234382C3132383234382C31342C3132383235332C3132383235332C31342C3132383235352C';
wwv_flow_imp.g_varchar2_table(454) := '3132383235382C31342C3132383236302C3132383236332C31342C3132383236352C3132383236352C31342C3132383237372C3132383237372C31342C3132383330302C3132383330312C31342C3132383332362C3132383332382C31342C3132383333';
wwv_flow_imp.g_varchar2_table(455) := '312C3132383333342C31342C3132383333362C3132383334372C31342C3132383336302C3132383336362C31342C3132383336392C3132383337302C31342C3132383337382C3132383337382C31342C3132383339312C3132383339312C31342C313238';
wwv_flow_imp.g_varchar2_table(456) := '3339342C3132383339372C31342C3132383430302C3132383430302C31342C3132383430352C3132383430362C31342C3132383432302C3132383432302C31342C3132383432322C3132383432332C31342C3132383432352C3132383433322C31342C31';
wwv_flow_imp.g_varchar2_table(457) := '32383433352C3132383434332C31342C3132383434352C3132383434392C31342C3132383435332C3132383436342C31342C3132383436382C3132383437352C31342C3132383437392C3132383438302C31342C3132383438322C3132383438322C3134';
wwv_flow_imp.g_varchar2_table(458) := '2C3132383438342C3132383438372C31342C3132383438392C3132383439342C31342C3132383439362C3132383439382C31342C3132383530302C3132383530352C31342C3132383530372C3132383531312C31342C3132383531332C3132383531382C';
wwv_flow_imp.g_varchar2_table(459) := '31342C3132383532312C3132383532352C31342C3132383532372C3132383532372C31342C3132383532392C3132383532392C31342C3132383533332C3132383533332C31342C3132383533352C3132383533352C31342C3132383533372C3132383533';
wwv_flow_imp.g_varchar2_table(460) := '372C31345D22297D6765744772617068656D65427265616B547970652865297B696628653C33322972657475726E2031303D3D3D653F333A31333D3D3D653F323A343B696628653C3132372972657475726E20303B636F6E737420743D746869732E5F64';
wwv_flow_imp.g_varchar2_table(461) := '6174612C6E3D742E6C656E6774682F333B6C657420723D313B666F72283B723C3D6E3B29696628653C745B332A725D29722A3D323B656C73657B6966282128653E745B332A722B315D292972657475726E20745B332A722B325D3B723D322A722B317D72';
wwv_flow_imp.g_varchar2_table(462) := '657475726E20307D7D6D652E5F494E5354414E43453D6E756C6C3B636C6173732067657B73746174696320676574496E7374616E63652865297B72657475726E2061652E63616368652E6765742841727261792E66726F6D286529297D73746174696320';
wwv_flow_imp.g_varchar2_table(463) := '6765744C6F63616C657328297B72657475726E2061652E5F6C6F63616C65732E76616C75657D636F6E7374727563746F722865297B746869732E636F6E66757361626C6544696374696F6E6172793D657D6973416D626967756F75732865297B72657475';
wwv_flow_imp.g_varchar2_table(464) := '726E20746869732E636F6E66757361626C6544696374696F6E6172792E6861732865297D6765745072696D617279436F6E66757361626C652865297B72657475726E20746869732E636F6E66757361626C6544696374696F6E6172792E6765742865297D';
wwv_flow_imp.g_varchar2_table(465) := '676574436F6E66757361626C65436F6465506F696E747328297B72657475726E206E65772053657428746869732E636F6E66757361626C6544696374696F6E6172792E6B6579732829297D7D61653D67652C67652E616D626967756F7573436861726163';
wwv_flow_imp.g_varchar2_table(466) := '746572446174613D6E6577206F65282828293D3E4A534F4E2E706172736528277B225F636F6D6D6F6E223A5B383233322C33322C383233332C33322C353736302C33322C383139322C33322C383139332C33322C383139342C33322C383139352C33322C';
wwv_flow_imp.g_varchar2_table(467) := '383139362C33322C383139372C33322C383139382C33322C383230302C33322C383230312C33322C383230322C33322C383238372C33322C383139392C33322C383233392C33322C323034322C39352C36353130312C39352C36353130322C39352C3635';
wwv_flow_imp.g_varchar2_table(468) := '3130332C39352C383230382C34352C383230392C34352C383231302C34352C36353131322C34352C313734382C34352C383235392C34352C3732372C34352C383732322C34352C31303133342C34352C31313435302C34352C313534392C34342C313634';
wwv_flow_imp.g_varchar2_table(469) := '332C34342C383231382C34342C3138342C34342C34323233332C34342C3839342C35392C323330372C35382C323639312C35382C313431372C35382C313739352C35382C313739362C35382C353836382C35382C36353037322C35382C363134372C3538';
wwv_flow_imp.g_varchar2_table(470) := '2C363135332C35382C383238322C35382C313437352C35382C3736302C35382C34323838392C35382C383735382C35382C3732302C35382C34323233372C35382C3435312C33332C31313630312C33332C3636302C36332C3537372C36332C323432392C';
wwv_flow_imp.g_varchar2_table(471) := '36332C353033382C36332C34323733312C36332C3131393134392C34362C383232382C34362C313739332C34362C313739342C34362C34323531302C34362C36383137362C34362C313633322C34362C313737362C34362C34323233322C34362C313337';
wwv_flow_imp.g_varchar2_table(472) := '332C39362C36353238372C39362C383231392C39362C383234322C39362C313337302C39362C313532332C39362C383137352C39362C36353334342C39362C3930302C39362C383138392C39362C383132352C39362C383132372C39362C383139302C39';
wwv_flow_imp.g_varchar2_table(473) := '362C3639372C39362C3838342C39362C3731322C39362C3731342C39362C3731352C39362C3735362C39362C3639392C39362C3730312C39362C3730302C39362C3730322C39362C34323839322C39362C313439372C39362C323033362C39362C323033';
wwv_flow_imp.g_varchar2_table(474) := '372C39362C353139342C39362C353833362C39362C39343033332C39362C39343033342C39362C36353333392C39312C31303038382C34302C31303039382C34302C31323330382C34302C36343833302C34302C36353334312C39332C31303038392C34';
wwv_flow_imp.g_varchar2_table(475) := '312C31303039392C34312C31323330392C34312C36343833312C34312C31303130302C3132332C3131393036302C3132332C31303130312C3132352C36353334322C39342C383237302C34322C313634352C34322C383732372C34322C36363333352C34';
wwv_flow_imp.g_varchar2_table(476) := '322C353934312C34372C383235372C34372C383732352C34372C383236302C34372C393538352C34372C31303138372C34372C31303734342C34372C3131393335342C34372C31323735352C34372C31323333392C34372C31313436322C34372C323030';
wwv_flow_imp.g_varchar2_table(477) := '33312C34372C31323033352C34372C36353334302C39322C36353132382C39322C383732362C39322C31303138392C39322C31303734312C39322C31303734352C39322C3131393331312C39322C3131393335352C39322C31323735362C39322C323030';
wwv_flow_imp.g_varchar2_table(478) := '32322C39322C31323033342C39322C34323837322C33382C3730382C39342C3731302C39342C353836392C34332C31303133332C34332C36363230332C34332C383234392C36302C31303039342C36302C3730362C36302C3131393335302C36302C3531';
wwv_flow_imp.g_varchar2_table(479) := '37362C36302C353831302C36302C353132302C36312C31313834302C36312C31323434382C36312C34323233392C36312C383235302C36322C31303039352C36322C3730372C36322C3131393335312C36322C353137312C36322C39343031352C36322C';
wwv_flow_imp.g_varchar2_table(480) := '383237352C3132362C3733322C3132362C383132382C3132362C383736342C3132362C36353337322C3132342C36353239332C34352C3132303738342C35302C3132303739342C35302C3132303830342C35302C3132303831342C35302C313230383234';
wwv_flow_imp.g_varchar2_table(481) := '2C35302C3133303033342C35302C34323834322C35302C3432332C35302C313030302C35302C34323536342C35302C353331312C35302C34323733352C35302C3131393330322C35312C3132303738352C35312C3132303739352C35312C313230383035';
wwv_flow_imp.g_varchar2_table(482) := '2C35312C3132303831352C35312C3132303832352C35312C3133303033352C35312C34323932332C35312C3534302C35312C3433392C35312C34323835382C35312C31313436382C35312C313234382C35312C39343031312C35312C37313838322C3531';
wwv_flow_imp.g_varchar2_table(483) := '2C3132303738362C35322C3132303739362C35322C3132303830362C35322C3132303831362C35322C3132303832362C35322C3133303033362C35322C353037302C35322C37313835352C35322C3132303738372C35332C3132303739372C35332C3132';
wwv_flow_imp.g_varchar2_table(484) := '303830372C35332C3132303831372C35332C3132303832372C35332C3133303033372C35332C3434342C35332C37313836372C35332C3132303738382C35342C3132303739382C35342C3132303830382C35342C3132303831382C35342C313230383238';
wwv_flow_imp.g_varchar2_table(485) := '2C35342C3133303033382C35342C31313437342C35342C353130322C35342C37313839332C35342C3131393331342C35352C3132303738392C35352C3132303739392C35352C3132303830392C35352C3132303831392C35352C3132303832392C35352C';
wwv_flow_imp.g_varchar2_table(486) := '3133303033392C35352C36363737302C35352C37313837382C35352C323831392C35362C323533382C35362C323636362C35362C3132353133312C35362C3132303739302C35362C3132303830302C35362C3132303831302C35362C3132303832302C35';
wwv_flow_imp.g_varchar2_table(487) := '362C3132303833302C35362C3133303034302C35362C3534372C35362C3534362C35362C36363333302C35362C323636332C35372C323932302C35372C323534312C35372C333433372C35372C3132303739312C35372C3132303830312C35372C313230';
wwv_flow_imp.g_varchar2_table(488) := '3831312C35372C3132303832312C35372C3132303833312C35372C3133303034312C35372C34323836322C35372C31313436362C35372C37313838342C35372C37313835322C35372C37313839342C35372C393038322C39372C36353334352C39372C31';
wwv_flow_imp.g_varchar2_table(489) := '31393833342C39372C3131393838362C39372C3131393933382C39372C3131393939302C39372C3132303034322C39372C3132303039342C39372C3132303134362C39372C3132303139382C39372C3132303235302C39372C3132303330322C39372C31';
wwv_flow_imp.g_varchar2_table(490) := '32303335342C39372C3132303430362C39372C3132303435382C39372C3539332C39372C3934352C39372C3132303531342C39372C3132303537322C39372C3132303633302C39372C3132303638382C39372C3132303734362C39372C36353331332C36';
wwv_flow_imp.g_varchar2_table(491) := '352C3131393830382C36352C3131393836302C36352C3131393931322C36352C3131393936342C36352C3132303031362C36352C3132303036382C36352C3132303132302C36352C3132303137322C36352C3132303232342C36352C3132303237362C36';
wwv_flow_imp.g_varchar2_table(492) := '352C3132303332382C36352C3132303338302C36352C3132303433322C36352C3931332C36352C3132303438382C36352C3132303534362C36352C3132303630342C36352C3132303636322C36352C3132303732302C36352C353033342C36352C353537';
wwv_flow_imp.g_varchar2_table(493) := '332C36352C34323232322C36352C39343031362C36352C36363230382C36352C3131393833352C39382C3131393838372C39382C3131393933392C39382C3131393939312C39382C3132303034332C39382C3132303039352C39382C3132303134372C39';
wwv_flow_imp.g_varchar2_table(494) := '382C3132303139392C39382C3132303235312C39382C3132303330332C39382C3132303335352C39382C3132303430372C39382C3132303435392C39382C3338382C39382C353037312C39382C353233342C39382C353535312C39382C36353331342C36';
wwv_flow_imp.g_varchar2_table(495) := '362C383439322C36362C3131393830392C36362C3131393836312C36362C3131393931332C36362C3132303031372C36362C3132303036392C36362C3132303132312C36362C3132303137332C36362C3132303232352C36362C3132303237372C36362C';
wwv_flow_imp.g_varchar2_table(496) := '3132303332392C36362C3132303338312C36362C3132303433332C36362C34323933322C36362C3931342C36362C3132303438392C36362C3132303534372C36362C3132303630352C36362C3132303636332C36362C3132303732312C36362C35313038';
wwv_flow_imp.g_varchar2_table(497) := '2C36362C353632332C36362C34323139322C36362C36363137382C36362C36363230392C36362C36363330352C36362C36353334372C39392C383537332C39392C3131393833362C39392C3131393838382C39392C3131393934302C39392C3131393939';
wwv_flow_imp.g_varchar2_table(498) := '322C39392C3132303034342C39392C3132303039362C39392C3132303134382C39392C3132303230302C39392C3132303235322C39392C3132303330342C39392C3132303335362C39392C3132303430382C39392C3132303436302C39392C373432382C';
wwv_flow_imp.g_varchar2_table(499) := '39392C313031302C39392C31313432392C39392C34333935312C39392C36363632312C39392C3132383834342C36372C37313932322C36372C37313931332C36372C36353331352C36372C383535372C36372C383435302C36372C383439332C36372C31';
wwv_flow_imp.g_varchar2_table(500) := '31393831302C36372C3131393836322C36372C3131393931342C36372C3131393936362C36372C3132303031382C36372C3132303137342C36372C3132303232362C36372C3132303237382C36372C3132303333302C36372C3132303338322C36372C31';
wwv_flow_imp.g_varchar2_table(501) := '32303433342C36372C313031372C36372C31313432382C36372C353038372C36372C34323230322C36372C36363231302C36372C36363330362C36372C36363538312C36372C36363834342C36372C383537342C3130302C383531382C3130302C313139';
wwv_flow_imp.g_varchar2_table(502) := '3833372C3130302C3131393838392C3130302C3131393934312C3130302C3131393939332C3130302C3132303034352C3130302C3132303039372C3130302C3132303134392C3130302C3132303230312C3130302C3132303235332C3130302C31323033';
wwv_flow_imp.g_varchar2_table(503) := '30352C3130302C3132303335372C3130302C3132303430392C3130302C3132303436312C3130302C313238312C3130302C353039352C3130302C353233312C3130302C34323139342C3130302C383535382C36382C383531372C36382C3131393831312C';
wwv_flow_imp.g_varchar2_table(504) := '36382C3131393836332C36382C3131393931352C36382C3131393936372C36382C3132303031392C36382C3132303037312C36382C3132303132332C36382C3132303137352C36382C3132303232372C36382C3132303237392C36382C3132303333312C';
wwv_flow_imp.g_varchar2_table(505) := '36382C3132303338332C36382C3132303433352C36382C353032342C36382C353539382C36382C353631302C36382C34323139352C36382C383439342C3130312C36353334392C3130312C383439352C3130312C383531392C3130312C3131393833382C';
wwv_flow_imp.g_varchar2_table(506) := '3130312C3131393839302C3130312C3131393934322C3130312C3132303034362C3130312C3132303039382C3130312C3132303135302C3130312C3132303230322C3130312C3132303235342C3130312C3132303330362C3130312C3132303335382C31';
wwv_flow_imp.g_varchar2_table(507) := '30312C3132303431302C3130312C3132303436322C3130312C34333832362C3130312C313231332C3130312C383935392C36392C36353331372C36392C383439362C36392C3131393831322C36392C3131393836342C36392C3131393931362C36392C31';
wwv_flow_imp.g_varchar2_table(508) := '32303032302C36392C3132303037322C36392C3132303132342C36392C3132303137362C36392C3132303232382C36392C3132303238302C36392C3132303333322C36392C3132303338342C36392C3132303433362C36392C3931372C36392C31323034';
wwv_flow_imp.g_varchar2_table(509) := '39322C36392C3132303535302C36392C3132303630382C36392C3132303636362C36392C3132303732342C36392C31313537372C36392C353033362C36392C34323232342C36392C37313834362C36392C37313835342C36392C36363138322C36392C31';
wwv_flow_imp.g_varchar2_table(510) := '31393833392C3130322C3131393839312C3130322C3131393934332C3130322C3131393939352C3130322C3132303034372C3130322C3132303039392C3130322C3132303135312C3130322C3132303230332C3130322C3132303235352C3130322C3132';
wwv_flow_imp.g_varchar2_table(511) := '303330372C3130322C3132303335392C3130322C3132303431312C3130322C3132303436332C3130322C34333832392C3130322C34323930352C3130322C3338332C3130322C373833372C3130322C313431322C3130322C3131393331352C37302C3834';
wwv_flow_imp.g_varchar2_table(512) := '39372C37302C3131393831332C37302C3131393836352C37302C3131393931372C37302C3132303032312C37302C3132303037332C37302C3132303132352C37302C3132303137372C37302C3132303232392C37302C3132303238312C37302C31323033';
wwv_flow_imp.g_varchar2_table(513) := '33332C37302C3132303338352C37302C3132303433372C37302C34323930342C37302C3938382C37302C3132303737382C37302C353535362C37302C34323230352C37302C37313837342C37302C37313834322C37302C36363138332C37302C36363231';
wwv_flow_imp.g_varchar2_table(514) := '332C37302C36363835332C37302C36353335312C3130332C383435382C3130332C3131393834302C3130332C3131393839322C3130332C3131393934342C3130332C3132303034382C3130332C3132303130302C3130332C3132303135322C3130332C31';
wwv_flow_imp.g_varchar2_table(515) := '32303230342C3130332C3132303235362C3130332C3132303330382C3130332C3132303336302C3130332C3132303431322C3130332C3132303436342C3130332C3630392C3130332C373535352C3130332C3339372C3130332C313430392C3130332C31';
wwv_flow_imp.g_varchar2_table(516) := '31393831342C37312C3131393836362C37312C3131393931382C37312C3131393937302C37312C3132303032322C37312C3132303037342C37312C3132303132362C37312C3132303137382C37312C3132303233302C37312C3132303238322C37312C31';
wwv_flow_imp.g_varchar2_table(517) := '32303333342C37312C3132303338362C37312C3132303433382C37312C313239322C37312C353035362C37312C353130372C37312C34323139382C37312C36353335322C3130342C383436322C3130342C3131393834312C3130342C3131393934352C31';
wwv_flow_imp.g_varchar2_table(518) := '30342C3131393939372C3130342C3132303034392C3130342C3132303130312C3130342C3132303135332C3130342C3132303230352C3130342C3132303235372C3130342C3132303330392C3130342C3132303336312C3130342C3132303431332C3130';
wwv_flow_imp.g_varchar2_table(519) := '342C3132303436352C3130342C313231312C3130342C313339322C3130342C353035382C3130342C36353332302C37322C383435392C37322C383436302C37322C383436312C37322C3131393831352C37322C3131393836372C37322C3131393931392C';
wwv_flow_imp.g_varchar2_table(520) := '37322C3132303032332C37322C3132303137392C37322C3132303233312C37322C3132303238332C37322C3132303333352C37322C3132303338372C37322C3132303433392C37322C3931392C37322C3132303439342C37322C3132303535322C37322C';
wwv_flow_imp.g_varchar2_table(521) := '3132303631302C37322C3132303636382C37322C3132303732362C37322C31313430362C37322C353035312C37322C353530302C37322C34323231352C37322C36363235352C37322C3733312C3130352C393037352C3130352C36353335332C3130352C';
wwv_flow_imp.g_varchar2_table(522) := '383536302C3130352C383530352C3130352C383532302C3130352C3131393834322C3130352C3131393839342C3130352C3131393934362C3130352C3131393939382C3130352C3132303035302C3130352C3132303130322C3130352C3132303135342C';
wwv_flow_imp.g_varchar2_table(523) := '3130352C3132303230362C3130352C3132303235382C3130352C3132303331302C3130352C3132303336322C3130352C3132303431342C3130352C3132303436362C3130352C3132303438342C3130352C3631382C3130352C3631372C3130352C393533';
wwv_flow_imp.g_varchar2_table(524) := '2C3130352C383132362C3130352C3839302C3130352C3132303532322C3130352C3132303538302C3130352C3132303633382C3130352C3132303639362C3130352C3132303735342C3130352C313131302C3130352C34323536372C3130352C31323331';
wwv_flow_imp.g_varchar2_table(525) := '2C3130352C34333839332C3130352C353032392C3130352C37313837352C3130352C36353335342C3130362C383532312C3130362C3131393834332C3130362C3131393839352C3130362C3131393934372C3130362C3131393939392C3130362C313230';
wwv_flow_imp.g_varchar2_table(526) := '3035312C3130362C3132303130332C3130362C3132303135352C3130362C3132303230372C3130362C3132303235392C3130362C3132303331312C3130362C3132303336332C3130362C3132303431352C3130362C3132303436372C3130362C31303131';
wwv_flow_imp.g_varchar2_table(527) := '2C3130362C313131322C3130362C36353332322C37342C3131393831372C37342C3131393836392C37342C3131393932312C37342C3131393937332C37342C3132303032352C37342C3132303037372C37342C3132303132392C37342C3132303138312C';
wwv_flow_imp.g_varchar2_table(528) := '37342C3132303233332C37342C3132303238352C37342C3132303333372C37342C3132303338392C37342C3132303434312C37342C34323933302C37342C3839352C37342C313033322C37342C353033352C37342C353236312C37342C34323230312C37';
wwv_flow_imp.g_varchar2_table(529) := '342C3131393834342C3130372C3131393839362C3130372C3131393934382C3130372C3132303030302C3130372C3132303035322C3130372C3132303130342C3130372C3132303135362C3130372C3132303230382C3130372C3132303236302C313037';
wwv_flow_imp.g_varchar2_table(530) := '2C3132303331322C3130372C3132303336342C3130372C3132303431362C3130372C3132303436382C3130372C383439302C37352C36353332332C37352C3131393831382C37352C3131393837302C37352C3131393932322C37352C3131393937342C37';
wwv_flow_imp.g_varchar2_table(531) := '352C3132303032362C37352C3132303037382C37352C3132303133302C37352C3132303138322C37352C3132303233342C37352C3132303238362C37352C3132303333382C37352C3132303339302C37352C3132303434322C37352C3932322C37352C31';
wwv_flow_imp.g_varchar2_table(532) := '32303439372C37352C3132303535352C37352C3132303631332C37352C3132303637312C37352C3132303732392C37352C31313431322C37352C353039342C37352C353834352C37352C34323139392C37352C36363834302C37352C313437322C313038';
wwv_flow_imp.g_varchar2_table(533) := '2C383733392C37332C393231332C37332C36353531322C37332C313633332C3130382C313737372C37332C36363333362C3130382C3132353132372C3130382C3132303738332C37332C3132303739332C37332C3132303830332C37332C313230383133';
wwv_flow_imp.g_varchar2_table(534) := '2C37332C3132303832332C37332C3133303033332C37332C36353332312C37332C383534342C37332C383436342C37332C383436352C37332C3131393831362C37332C3131393836382C37332C3131393932302C37332C3132303032342C37332C313230';
wwv_flow_imp.g_varchar2_table(535) := '3132382C37332C3132303138302C37332C3132303233322C37332C3132303238342C37332C3132303333362C37332C3132303338382C37332C3132303434302C37332C36353335362C3130382C383537322C37332C383436372C3130382C313139383435';
wwv_flow_imp.g_varchar2_table(536) := '2C3130382C3131393839372C3130382C3131393934392C3130382C3132303030312C3130382C3132303035332C3130382C3132303130352C37332C3132303135372C37332C3132303230392C37332C3132303236312C37332C3132303331332C37332C31';
wwv_flow_imp.g_varchar2_table(537) := '32303336352C37332C3132303431372C37332C3132303436392C37332C3434382C37332C3132303439362C37332C3132303535342C37332C3132303631322C37332C3132303637302C37332C3132303732382C37332C31313431302C37332C313033302C';
wwv_flow_imp.g_varchar2_table(538) := '37332C313231362C37332C313439332C3130382C313530332C3130382C313537352C3130382C3132363436342C3130382C3132363539322C3130382C36353136362C3130382C36353136352C3130382C313939342C3130382C31313539392C37332C3538';
wwv_flow_imp.g_varchar2_table(539) := '32352C37332C34323232362C37332C39333939322C37332C36363138362C3132342C36363331332C3132342C3131393333382C37362C383535362C37362C383436362C37362C3131393831392C37362C3131393837312C37362C3131393932332C37362C';
wwv_flow_imp.g_varchar2_table(540) := '3132303032372C37362C3132303037392C37362C3132303133312C37362C3132303138332C37362C3132303233352C37362C3132303238372C37362C3132303333392C37362C3132303339312C37362C3132303434332C37362C31313437322C37362C35';
wwv_flow_imp.g_varchar2_table(541) := '3038362C37362C353239302C37362C34323230392C37362C39333937342C37362C37313834332C37362C37313835382C37362C36363538372C37362C36363835342C37362C36353332352C37372C383535392C37372C383439392C37372C313139383230';
wwv_flow_imp.g_varchar2_table(542) := '2C37372C3131393837322C37372C3131393932342C37372C3132303032382C37372C3132303038302C37372C3132303133322C37372C3132303138342C37372C3132303233362C37372C3132303238382C37372C3132303334302C37372C313230333932';
wwv_flow_imp.g_varchar2_table(543) := '2C37372C3132303434342C37372C3932342C37372C3132303439392C37372C3132303535372C37372C3132303631352C37372C3132303637332C37372C3132303733312C37372C313031382C37372C31313431362C37372C353034372C37372C35363136';
wwv_flow_imp.g_varchar2_table(544) := '2C37372C353834362C37372C34323230372C37372C36363232342C37372C36363332312C37372C3131393834372C3131302C3131393839392C3131302C3131393935312C3131302C3132303030332C3131302C3132303035352C3131302C313230313037';
wwv_flow_imp.g_varchar2_table(545) := '2C3131302C3132303135392C3131302C3132303231312C3131302C3132303236332C3131302C3132303331352C3131302C3132303336372C3131302C3132303431392C3131302C3132303437312C3131302C313430302C3131302C313430342C3131302C';
wwv_flow_imp.g_varchar2_table(546) := '36353332362C37382C383436392C37382C3131393832312C37382C3131393837332C37382C3131393932352C37382C3131393937372C37382C3132303032392C37382C3132303038312C37382C3132303138352C37382C3132303233372C37382C313230';
wwv_flow_imp.g_varchar2_table(547) := '3238392C37382C3132303334312C37382C3132303339332C37382C3132303434352C37382C3932352C37382C3132303530302C37382C3132303535382C37382C3132303631362C37382C3132303637342C37382C3132303733322C37382C31313431382C';
wwv_flow_imp.g_varchar2_table(548) := '37382C34323230382C37382C36363833352C37382C333037342C3131312C333230322C3131312C333333302C3131312C333435382C3131312C323430362C3131312C323636322C3131312C323739302C3131312C333034362C3131312C333137342C3131';
wwv_flow_imp.g_varchar2_table(549) := '312C333330322C3131312C333433302C3131312C333636342C3131312C333739322C3131312C343136302C3131312C313633372C3131312C313738312C3131312C36353335392C3131312C383530302C3131312C3131393834382C3131312C3131393930';
wwv_flow_imp.g_varchar2_table(550) := '302C3131312C3131393935322C3131312C3132303035362C3131312C3132303130382C3131312C3132303136302C3131312C3132303231322C3131312C3132303236342C3131312C3132303331362C3131312C3132303336382C3131312C313230343230';
wwv_flow_imp.g_varchar2_table(551) := '2C3131312C3132303437322C3131312C373433392C3131312C373434312C3131312C34333833372C3131312C3935392C3131312C3132303532382C3131312C3132303538362C3131312C3132303634342C3131312C3132303730322C3131312C31323037';
wwv_flow_imp.g_varchar2_table(552) := '36302C3131312C3936332C3131312C3132303533322C3131312C3132303539302C3131312C3132303634382C3131312C3132303730362C3131312C3132303736342C3131312C31313432332C3131312C343335312C3131312C313431332C3131312C3135';
wwv_flow_imp.g_varchar2_table(553) := '30352C3131312C313630372C3131312C3132363530302C3131312C3132363536342C3131312C3132363539362C3131312C36353235392C3131312C36353236302C3131312C36353235382C3131312C36353235372C3131312C313732362C3131312C3634';
wwv_flow_imp.g_varchar2_table(554) := '3432382C3131312C36343432392C3131312C36343432372C3131312C36343432362C3131312C313732392C3131312C36343432342C3131312C36343432352C3131312C36343432332C3131312C36343432322C3131312C313734392C3131312C33333630';
wwv_flow_imp.g_varchar2_table(555) := '2C3131312C343132352C3131312C36363739342C3131312C37313838302C3131312C37313839352C3131312C36363630342C3131312C313938342C37392C323533342C37392C323931382C37392C31323239352C37392C37303836342C37392C37313930';
wwv_flow_imp.g_varchar2_table(556) := '342C37392C3132303738322C37392C3132303739322C37392C3132303830322C37392C3132303831322C37392C3132303832322C37392C3133303033322C37392C36353332372C37392C3131393832322C37392C3131393837342C37392C313139393236';
wwv_flow_imp.g_varchar2_table(557) := '2C37392C3131393937382C37392C3132303033302C37392C3132303038322C37392C3132303133342C37392C3132303138362C37392C3132303233382C37392C3132303239302C37392C3132303334322C37392C3132303339342C37392C313230343436';
wwv_flow_imp.g_varchar2_table(558) := '2C37392C3932372C37392C3132303530322C37392C3132303536302C37392C3132303631382C37392C3132303637362C37392C3132303733342C37392C31313432322C37392C313336352C37392C31313630342C37392C343831362C37392C323834382C';
wwv_flow_imp.g_varchar2_table(559) := '37392C36363735342C37392C34323232372C37392C37313836312C37392C36363139342C37392C36363231392C37392C36363536342C37392C36363833382C37392C393037362C3131322C36353336302C3131322C3131393834392C3131322C31313939';
wwv_flow_imp.g_varchar2_table(560) := '30312C3131322C3131393935332C3131322C3132303030352C3131322C3132303035372C3131322C3132303130392C3131322C3132303136312C3131322C3132303231332C3131322C3132303236352C3131322C3132303331372C3131322C3132303336';
wwv_flow_imp.g_varchar2_table(561) := '392C3131322C3132303432312C3131322C3132303437332C3131322C3936312C3131322C3132303533302C3131322C3132303534342C3131322C3132303538382C3131322C3132303630322C3131322C3132303634362C3131322C3132303636302C3131';
wwv_flow_imp.g_varchar2_table(562) := '322C3132303730342C3131322C3132303731382C3131322C3132303736322C3131322C3132303737362C3131322C31313432372C3131322C36353332382C38302C383437332C38302C3131393832332C38302C3131393837352C38302C3131393932372C';
wwv_flow_imp.g_varchar2_table(563) := '38302C3131393937392C38302C3132303033312C38302C3132303038332C38302C3132303138372C38302C3132303233392C38302C3132303239312C38302C3132303334332C38302C3132303339352C38302C3132303434372C38302C3932392C38302C';
wwv_flow_imp.g_varchar2_table(564) := '3132303530342C38302C3132303536322C38302C3132303632302C38302C3132303637382C38302C3132303733362C38302C31313432362C38302C353039302C38302C353232392C38302C34323139332C38302C36363139372C38302C3131393835302C';
wwv_flow_imp.g_varchar2_table(565) := '3131332C3131393930322C3131332C3131393935342C3131332C3132303030362C3131332C3132303035382C3131332C3132303131302C3131332C3132303136322C3131332C3132303231342C3131332C3132303236362C3131332C3132303331382C31';
wwv_flow_imp.g_varchar2_table(566) := '31332C3132303337302C3131332C3132303432322C3131332C3132303437342C3131332C313330372C3131332C313337392C3131332C313338322C3131332C383437342C38312C3131393832342C38312C3131393837362C38312C3131393932382C3831';
wwv_flow_imp.g_varchar2_table(567) := '2C3131393938302C38312C3132303033322C38312C3132303038342C38312C3132303138382C38312C3132303234302C38312C3132303239322C38312C3132303334342C38312C3132303339362C38312C3132303434382C38312C31313630352C38312C';
wwv_flow_imp.g_varchar2_table(568) := '3131393835312C3131342C3131393930332C3131342C3131393935352C3131342C3132303030372C3131342C3132303035392C3131342C3132303131312C3131342C3132303136332C3131342C3132303231352C3131342C3132303236372C3131342C31';
wwv_flow_imp.g_varchar2_table(569) := '32303331392C3131342C3132303337312C3131342C3132303432332C3131342C3132303437352C3131342C34333834372C3131342C34333834382C3131342C373436322C3131342C31313339372C3131342C34333930352C3131342C3131393331382C38';
wwv_flow_imp.g_varchar2_table(570) := '322C383437352C38322C383437362C38322C383437372C38322C3131393832352C38322C3131393837372C38322C3131393932392C38322C3132303033332C38322C3132303138392C38322C3132303234312C38322C3132303239332C38322C31323033';
wwv_flow_imp.g_varchar2_table(571) := '34352C38322C3132303339372C38322C3132303434392C38322C3432322C38322C353032352C38322C353037342C38322C36363734302C38322C353531312C38322C34323231312C38322C39343030352C38322C36353336332C3131352C313139383532';
wwv_flow_imp.g_varchar2_table(572) := '2C3131352C3131393930342C3131352C3131393935362C3131352C3132303030382C3131352C3132303036302C3131352C3132303131322C3131352C3132303136342C3131352C3132303231362C3131352C3132303236382C3131352C3132303332302C';
wwv_flow_imp.g_varchar2_table(573) := '3131352C3132303337322C3131352C3132303432342C3131352C3132303437362C3131352C34323830312C3131352C3434352C3131352C313130392C3131352C34333934362C3131352C37313837332C3131352C36363633322C3131352C36353333312C';
wwv_flow_imp.g_varchar2_table(574) := '38332C3131393832362C38332C3131393837382C38332C3131393933302C38332C3131393938322C38332C3132303033342C38332C3132303038362C38332C3132303133382C38332C3132303139302C38332C3132303234322C38332C3132303239342C';
wwv_flow_imp.g_varchar2_table(575) := '38332C3132303334362C38332C3132303339382C38332C3132303435302C38332C313032392C38332C313335392C38332C353037372C38332C353038322C38332C34323231302C38332C39343031302C38332C36363139382C38332C36363539322C3833';
wwv_flow_imp.g_varchar2_table(576) := '2C3131393835332C3131362C3131393930352C3131362C3131393935372C3131362C3132303030392C3131362C3132303036312C3131362C3132303131332C3131362C3132303136352C3131362C3132303231372C3131362C3132303236392C3131362C';
wwv_flow_imp.g_varchar2_table(577) := '3132303332312C3131362C3132303337332C3131362C3132303432352C3131362C3132303437372C3131362C383836382C38342C31303230312C38342C3132383837322C38342C36353333322C38342C3131393832372C38342C3131393837392C38342C';
wwv_flow_imp.g_varchar2_table(578) := '3131393933312C38342C3131393938332C38342C3132303033352C38342C3132303038372C38342C3132303133392C38342C3132303139312C38342C3132303234332C38342C3132303239352C38342C3132303334372C38342C3132303339392C38342C';
wwv_flow_imp.g_varchar2_table(579) := '3132303435312C38342C3933322C38342C3132303530372C38342C3132303536352C38342C3132303632332C38342C3132303638312C38342C3132303733392C38342C31313433302C38342C353032362C38342C34323139362C38342C39333936322C38';
wwv_flow_imp.g_varchar2_table(580) := '342C37313836382C38342C36363139392C38342C36363232352C38342C36363332352C38342C3131393835342C3131372C3131393930362C3131372C3131393935382C3131372C3132303031302C3131372C3132303036322C3131372C3132303131342C';
wwv_flow_imp.g_varchar2_table(581) := '3131372C3132303136362C3131372C3132303231382C3131372C3132303237302C3131372C3132303332322C3131372C3132303337342C3131372C3132303432362C3131372C3132303437382C3131372C34323931312C3131372C373435322C3131372C';
wwv_flow_imp.g_varchar2_table(582) := '34333835342C3131372C34333835382C3131372C3635312C3131372C3936352C3131372C3132303533342C3131372C3132303539322C3131372C3132303635302C3131372C3132303730382C3131372C3132303736362C3131372C313430352C3131372C';
wwv_flow_imp.g_varchar2_table(583) := '36363830362C3131372C37313839362C3131372C383734362C38352C383839392C38352C3131393832382C38352C3131393838302C38352C3131393933322C38352C3131393938342C38352C3132303033362C38352C3132303038382C38352C31323031';
wwv_flow_imp.g_varchar2_table(584) := '34302C38352C3132303139322C38352C3132303234342C38352C3132303239362C38352C3132303334382C38352C3132303430302C38352C3132303435322C38352C313335372C38352C343630382C38352C36363736362C38352C353139362C38352C34';
wwv_flow_imp.g_varchar2_table(585) := '323232382C38352C39343031382C38352C37313836342C38352C383734342C3131382C383839372C3131382C36353336362C3131382C383536342C3131382C3131393835352C3131382C3131393930372C3131382C3131393935392C3131382C31323030';
wwv_flow_imp.g_varchar2_table(586) := '31312C3131382C3132303036332C3131382C3132303131352C3131382C3132303136372C3131382C3132303231392C3131382C3132303237312C3131382C3132303332332C3131382C3132303337352C3131382C3132303432372C3131382C3132303437';
wwv_flow_imp.g_varchar2_table(587) := '392C3131382C373435362C3131382C3935372C3131382C3132303532362C3131382C3132303538342C3131382C3132303634322C3131382C3132303730302C3131382C3132303735382C3131382C313134312C3131382C313439362C3131382C37313433';
wwv_flow_imp.g_varchar2_table(588) := '302C3131382C34333934352C3131382C37313837322C3131382C3131393330392C38362C313633392C38362C313738332C38362C383534382C38362C3131393832392C38362C3131393838312C38362C3131393933332C38362C3131393938352C38362C';
wwv_flow_imp.g_varchar2_table(589) := '3132303033372C38362C3132303038392C38362C3132303134312C38362C3132303139332C38362C3132303234352C38362C3132303239372C38362C3132303334392C38362C3132303430312C38362C3132303435332C38362C313134302C38362C3131';
wwv_flow_imp.g_varchar2_table(590) := '3537362C38362C353038312C38362C353136372C38362C34323731392C38362C34323231342C38362C39333936302C38362C37313834302C38362C36363834352C38362C3632332C3131392C3131393835362C3131392C3131393930382C3131392C3131';
wwv_flow_imp.g_varchar2_table(591) := '393936302C3131392C3132303031322C3131392C3132303036342C3131392C3132303131362C3131392C3132303136382C3131392C3132303232302C3131392C3132303237322C3131392C3132303332342C3131392C3132303337362C3131392C313230';
wwv_flow_imp.g_varchar2_table(592) := '3432382C3131392C3132303438302C3131392C373435372C3131392C313132312C3131392C313330392C3131392C313337372C3131392C37313433342C3131392C37313433382C3131392C37313433392C3131392C34333930372C3131392C3731393139';
wwv_flow_imp.g_varchar2_table(593) := '2C38372C37313931302C38372C3131393833302C38372C3131393838322C38372C3131393933342C38372C3131393938362C38372C3132303033382C38372C3132303039302C38372C3132303134322C38372C3132303139342C38372C3132303234362C';
wwv_flow_imp.g_varchar2_table(594) := '38372C3132303239382C38372C3132303335302C38372C3132303430322C38372C3132303435342C38372C313330382C38372C353034332C38372C353037362C38372C34323231382C38372C353734322C3132302C31303533392C3132302C3130353430';
wwv_flow_imp.g_varchar2_table(595) := '2C3132302C31303739392C3132302C36353336382C3132302C383536392C3132302C3131393835372C3132302C3131393930392C3132302C3131393936312C3132302C3132303031332C3132302C3132303036352C3132302C3132303131372C3132302C';
wwv_flow_imp.g_varchar2_table(596) := '3132303136392C3132302C3132303232312C3132302C3132303237332C3132302C3132303332352C3132302C3132303337372C3132302C3132303432392C3132302C3132303438312C3132302C353434312C3132302C353530312C3132302C353734312C';
wwv_flow_imp.g_varchar2_table(597) := '38382C393538372C38382C36363333382C38382C37313931362C38382C36353333362C38382C383535332C38382C3131393833312C38382C3131393838332C38382C3131393933352C38382C3131393938372C38382C3132303033392C38382C31323030';
wwv_flow_imp.g_varchar2_table(598) := '39312C38382C3132303134332C38382C3132303139352C38382C3132303234372C38382C3132303239392C38382C3132303335312C38382C3132303430332C38382C3132303435352C38382C34323933312C38382C3933352C38382C3132303531302C38';
wwv_flow_imp.g_varchar2_table(599) := '382C3132303536382C38382C3132303632362C38382C3132303638342C38382C3132303734322C38382C31313433362C38382C31313631332C38382C353831352C38382C34323231392C38382C36363139322C38382C36363232382C38382C3636333237';
wwv_flow_imp.g_varchar2_table(600) := '2C38382C36363835352C38382C3631312C3132312C373536342C3132312C36353336392C3132312C3131393835382C3132312C3131393931302C3132312C3131393936322C3132312C3132303031342C3132312C3132303036362C3132312C3132303131';
wwv_flow_imp.g_varchar2_table(601) := '382C3132312C3132303137302C3132312C3132303232322C3132312C3132303237342C3132312C3132303332362C3132312C3132303337382C3132312C3132303433302C3132312C3132303438322C3132312C3635352C3132312C373933352C3132312C';
wwv_flow_imp.g_varchar2_table(602) := '34333836362C3132312C3934372C3132312C383530392C3132312C3132303531362C3132312C3132303537342C3132312C3132303633322C3132312C3132303639302C3132312C3132303734382C3132312C313139392C3132312C343332372C3132312C';
wwv_flow_imp.g_varchar2_table(603) := '37313930302C3132312C36353333372C38392C3131393833322C38392C3131393838342C38392C3131393933362C38392C3131393938382C38392C3132303034302C38392C3132303039322C38392C3132303134342C38392C3132303139362C38392C31';
wwv_flow_imp.g_varchar2_table(604) := '32303234382C38392C3132303330302C38392C3132303335322C38392C3132303430342C38392C3132303435362C38392C3933332C38392C3937382C38392C3132303530382C38392C3132303536362C38392C3132303632342C38392C3132303638322C';
wwv_flow_imp.g_varchar2_table(605) := '38392C3132303734302C38392C31313433322C38392C313139382C38392C353033332C38392C353035332C38392C34323232302C38392C39343031392C38392C37313834342C38392C36363232362C38392C3131393835392C3132322C3131393931312C';
wwv_flow_imp.g_varchar2_table(606) := '3132322C3131393936332C3132322C3132303031352C3132322C3132303036372C3132322C3132303131392C3132322C3132303137312C3132322C3132303232332C3132322C3132303237352C3132322C3132303332372C3132322C3132303337392C31';
wwv_flow_imp.g_varchar2_table(607) := '32322C3132303433312C3132322C3132303438332C3132322C373435382C3132322C34333932332C3132322C37313837362C3132322C36363239332C39302C37313930392C39302C36353333382C39302C383438342C39302C383438382C39302C313139';
wwv_flow_imp.g_varchar2_table(608) := '3833332C39302C3131393838352C39302C3131393933372C39302C3131393938392C39302C3132303034312C39302C3132303139372C39302C3132303234392C39302C3132303330312C39302C3132303335332C39302C3132303430352C39302C313230';
wwv_flow_imp.g_varchar2_table(609) := '3435372C39302C3931382C39302C3132303439332C39302C3132303535312C39302C3132303630392C39302C3132303636372C39302C3132303732352C39302C353035392C39302C34323230342C39302C37313834392C39302C36353238322C33342C36';
wwv_flow_imp.g_varchar2_table(610) := '353238342C33362C36353238352C33372C36353238362C33382C36353239302C34322C36353239312C34332C36353239342C34362C36353239352C34372C36353239362C34382C36353239372C34392C36353239382C35302C36353239392C35312C3635';
wwv_flow_imp.g_varchar2_table(611) := '3330302C35322C36353330312C35332C36353330322C35342C36353330332C35352C36353330342C35362C36353330352C35372C36353330382C36302C36353330392C36312C36353331302C36322C36353331322C36342C36353331362C36382C363533';
wwv_flow_imp.g_varchar2_table(612) := '31382C37302C36353331392C37312C36353332342C37362C36353332392C38312C36353333302C38322C36353333332C38352C36353333342C38362C36353333352C38372C36353334332C39352C36353334362C39382C36353334382C3130302C363533';
wwv_flow_imp.g_varchar2_table(613) := '35302C3130322C36353335352C3130372C36353335372C3130392C36353335382C3131302C36353336312C3131332C36353336322C3131342C36353336342C3131362C36353336352C3131372C36353336372C3131392C36353337302C3132322C363533';
wwv_flow_imp.g_varchar2_table(614) := '37312C3132332C36353337332C3132352C3131393834362C3130395D2C225F64656661756C74223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C';
wwv_flow_imp.g_varchar2_table(615) := '383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034';
wwv_flow_imp.g_varchar2_table(616) := '352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C31303538';
wwv_flow_imp.g_varchar2_table(617) := '2C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D';
wwv_flow_imp.g_varchar2_table(618) := '2C226373223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C31';
wwv_flow_imp.g_varchar2_table(619) := '3034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C';
wwv_flow_imp.g_varchar2_table(620) := '3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C3635';
wwv_flow_imp.g_varchar2_table(621) := '3238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226465223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39';
wwv_flow_imp.g_varchar2_table(622) := '362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C31';
wwv_flow_imp.g_varchar2_table(623) := '3035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3130';
wwv_flow_imp.g_varchar2_table(624) := '39332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226573223A5B383231312C3435';
wwv_flow_imp.g_varchar2_table(625) := '2C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C3636';
wwv_flow_imp.g_varchar2_table(626) := '2C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C313132';
wwv_flow_imp.g_varchar2_table(627) := '2C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C3635323932';
wwv_flow_imp.g_varchar2_table(628) := '2C34342C36353330372C35392C36353331312C36335D2C226672223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383234352C39362C31323439342C34372C313034372C35312C313037332C35342C3130';
wwv_flow_imp.g_varchar2_table(629) := '37322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37';
wwv_flow_imp.g_varchar2_table(630) := '372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C31303539';
wwv_flow_imp.g_varchar2_table(631) := '2C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226974223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36';
wwv_flow_imp.g_varchar2_table(632) := '353238312C33332C383231362C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C31303537';
wwv_flow_imp.g_varchar2_table(633) := '2C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C';
wwv_flow_imp.g_varchar2_table(634) := '38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C3635';
wwv_flow_imp.g_varchar2_table(635) := '3330372C35392C36353331312C36335D2C226A61223A5B383231312C34352C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C313034372C35312C313037332C35342C31303732';
wwv_flow_imp.g_varchar2_table(636) := '2C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C';
wwv_flow_imp.g_varchar2_table(637) := '313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38';
wwv_flow_imp.g_varchar2_table(638) := '392C36353238332C33352C36353239322C34342C36353330372C35395D2C226B6F223A5B383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C31303437';
wwv_flow_imp.g_varchar2_table(639) := '2C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C3735';
wwv_flow_imp.g_varchar2_table(640) := '2C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C3838';
wwv_flow_imp.g_varchar2_table(641) := '2C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C22706C223A5B36353337342C3132362C36353330362C35382C3635';
wwv_flow_imp.g_varchar2_table(642) := '3238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C';
wwv_flow_imp.g_varchar2_table(643) := '39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131';
wwv_flow_imp.g_varchar2_table(644) := '322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239';
wwv_flow_imp.g_varchar2_table(645) := '322C34342C36353330372C35392C36353331312C36335D2C2270742D4252223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C3437';
wwv_flow_imp.g_varchar2_table(646) := '2C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C3130';
wwv_flow_imp.g_varchar2_table(647) := '35302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C3130';
wwv_flow_imp.g_varchar2_table(648) := '36312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227170732D706C6F63223A5B3136302C33322C383231';
wwv_flow_imp.g_varchar2_table(649) := '312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034';
wwv_flow_imp.g_varchar2_table(650) := '302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131';
wwv_flow_imp.g_varchar2_table(651) := '312C313035342C37392C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C3635323838';
wwv_flow_imp.g_varchar2_table(652) := '2C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227275223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C31';
wwv_flow_imp.g_varchar2_table(653) := '38302C39362C31323439342C34372C3330352C3130352C3932312C37332C313030392C3131322C3231352C3132302C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C3633';
wwv_flow_imp.g_varchar2_table(654) := '5D2C227472223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C31';
wwv_flow_imp.g_varchar2_table(655) := '3034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C31303534';
wwv_flow_imp.g_varchar2_table(656) := '2C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C3635';
wwv_flow_imp.g_varchar2_table(657) := '3238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227A682D68616E73223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C3132';
wwv_flow_imp.g_varchar2_table(658) := '3439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C';
wwv_flow_imp.g_varchar2_table(659) := '3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C';
wwv_flow_imp.g_varchar2_table(660) := '3132302C313036312C38382C313039312C3132312C313035392C38392C36353238382C34302C36353238392C34315D2C227A682D68616E74223A5B383231312C34352C36353337342C3132362C3138302C39362C31323439342C34372C313034372C3531';
wwv_flow_imp.g_varchar2_table(661) := '2C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932';
wwv_flow_imp.g_varchar2_table(662) := '312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C3130';
wwv_flow_imp.g_varchar2_table(663) := '39312C3132312C313035392C38392C36353238332C33352C36353330372C35395D7D272929292C67652E63616368653D6E657720636C6173737B636F6E7374727563746F7228652C74297B746869732E6C61737443616368653D766F696420302C746869';
wwv_flow_imp.g_varchar2_table(664) := '732E6C6173744172674B65793D766F696420302C2266756E6374696F6E223D3D747970656F6620653F28746869732E5F666E3D652C746869732E5F636F6D707574654B65793D7365293A28746869732E5F666E3D742C746869732E5F636F6D707574654B';
wwv_flow_imp.g_varchar2_table(665) := '65793D652E67657443616368654B6579297D6765742865297B636F6E737420743D746869732E5F636F6D707574654B65792865293B72657475726E20746869732E6C6173744172674B6579213D3D74262628746869732E6C6173744172674B65793D742C';
wwv_flow_imp.g_varchar2_table(666) := '746869732E6C61737443616368653D746869732E5F666E286529292C746869732E6C61737443616368657D7D287B67657443616368654B65793A4A534F4E2E737472696E676966797D2C28653D3E7B66756E6374696F6E20742865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(667) := '3D6E6577204D61703B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B3D3229742E73657428655B6E5D2C655B6E2B315D293B72657475726E20747D66756E6374696F6E206E28652C74297B69662821652972657475726E20743B636F6E73';
wwv_flow_imp.g_varchar2_table(668) := '74206E3D6E6577204D61703B666F7228636F6E73745B722C695D6F66206529742E68617328722926266E2E73657428722C69293B72657475726E206E7D636F6E737420723D61652E616D626967756F7573436861726163746572446174612E76616C7565';
wwv_flow_imp.g_varchar2_table(669) := '3B6C657420692C733D652E66696C7465722828653D3E21652E7374617274735769746828225F222926266520696E207229293B303D3D3D732E6C656E677468262628733D5B225F64656661756C74225D293B666F7228636F6E73742065206F6620732969';
wwv_flow_imp.g_varchar2_table(670) := '3D6E28692C7428725B655D29293B636F6E7374206F3D66756E6374696F6E28652C74297B636F6E7374206E3D6E6577204D61702865293B666F7228636F6E73745B652C725D6F662074296E2E73657428652C72293B72657475726E206E7D287428722E5F';
wwv_flow_imp.g_varchar2_table(671) := '636F6D6D6F6E292C69293B72657475726E206E6577206165286F297D29292C67652E5F6C6F63616C65733D6E6577206F65282828293D3E4F626A6563742E6B6579732861652E616D626967756F7573436861726163746572446174612E76616C7565292E';
wwv_flow_imp.g_varchar2_table(672) := '66696C7465722828653D3E21652E7374617274735769746828225F2229292929293B636C6173732070657B737461746963206765745261774461746128297B72657475726E204A534F4E2E706172736528225B392C31302C31312C31322C31332C33322C';
wwv_flow_imp.g_varchar2_table(673) := '3132372C3136302C3137332C3834372C313536342C343434372C343434382C363036382C363036392C363135352C363135362C363135372C363135382C373335352C373335362C383139322C383139332C383139342C383139352C383139362C38313937';
wwv_flow_imp.g_varchar2_table(674) := '2C383139382C383139392C383230302C383230312C383230322C383230332C383230342C383230352C383230362C383230372C383233342C383233352C383233362C383233372C383233382C383233392C383238372C383238382C383238392C38323930';
wwv_flow_imp.g_varchar2_table(675) := '2C383239312C383239322C383239332C383239342C383239352C383239362C383239372C383239382C383239392C383330302C383330312C383330322C383330332C31303234302C31323238382C31323634342C36353032342C36353032352C36353032';
wwv_flow_imp.g_varchar2_table(676) := '362C36353032372C36353032382C36353032392C36353033302C36353033312C36353033322C36353033332C36353033342C36353033352C36353033362C36353033372C36353033382C36353033392C36353237392C36353434302C36353532302C3635';
wwv_flow_imp.g_varchar2_table(677) := '3532312C36353532322C36353532332C36353532342C36353532352C36353532362C36353532372C36353532382C36353533322C37383834342C3131393135352C3131393135362C3131393135372C3131393135382C3131393135392C3131393136302C';
wwv_flow_imp.g_varchar2_table(678) := '3131393136312C3131393136322C3931373530342C3931373530352C3931373530362C3931373530372C3931373530382C3931373530392C3931373531302C3931373531312C3931373531322C3931373531332C3931373531342C3931373531352C3931';
wwv_flow_imp.g_varchar2_table(679) := '373531362C3931373531372C3931373531382C3931373531392C3931373532302C3931373532312C3931373532322C3931373532332C3931373532342C3931373532352C3931373532362C3931373532372C3931373532382C3931373532392C39313735';
wwv_flow_imp.g_varchar2_table(680) := '33302C3931373533312C3931373533322C3931373533332C3931373533342C3931373533352C3931373533362C3931373533372C3931373533382C3931373533392C3931373534302C3931373534312C3931373534322C3931373534332C393137353434';
wwv_flow_imp.g_varchar2_table(681) := '2C3931373534352C3931373534362C3931373534372C3931373534382C3931373534392C3931373535302C3931373535312C3931373535322C3931373535332C3931373535342C3931373535352C3931373535362C3931373535372C3931373535382C39';
wwv_flow_imp.g_varchar2_table(682) := '31373535392C3931373536302C3931373536312C3931373536322C3931373536332C3931373536342C3931373536352C3931373536362C3931373536372C3931373536382C3931373536392C3931373537302C3931373537312C3931373537322C393137';
wwv_flow_imp.g_varchar2_table(683) := '3537332C3931373537342C3931373537352C3931373537362C3931373537372C3931373537382C3931373537392C3931373538302C3931373538312C3931373538322C3931373538332C3931373538342C3931373538352C3931373538362C3931373538';
wwv_flow_imp.g_varchar2_table(684) := '372C3931373538382C3931373538392C3931373539302C3931373539312C3931373539322C3931373539332C3931373539342C3931373539352C3931373539362C3931373539372C3931373539382C3931373539392C3931373630302C3931373630312C';
wwv_flow_imp.g_varchar2_table(685) := '3931373630322C3931373630332C3931373630342C3931373630352C3931373630362C3931373630372C3931373630382C3931373630392C3931373631302C3931373631312C3931373631322C3931373631332C3931373631342C3931373631352C3931';
wwv_flow_imp.g_varchar2_table(686) := '373631362C3931373631372C3931373631382C3931373631392C3931373632302C3931373632312C3931373632322C3931373632332C3931373632342C3931373632352C3931373632362C3931373632372C3931373632382C3931373632392C39313736';
wwv_flow_imp.g_varchar2_table(687) := '33302C3931373633312C3931373736302C3931373736312C3931373736322C3931373736332C3931373736342C3931373736352C3931373736362C3931373736372C3931373736382C3931373736392C3931373737302C3931373737312C393137373732';
wwv_flow_imp.g_varchar2_table(688) := '2C3931373737332C3931373737342C3931373737352C3931373737362C3931373737372C3931373737382C3931373737392C3931373738302C3931373738312C3931373738322C3931373738332C3931373738342C3931373738352C3931373738362C39';
wwv_flow_imp.g_varchar2_table(689) := '31373738372C3931373738382C3931373738392C3931373739302C3931373739312C3931373739322C3931373739332C3931373739342C3931373739352C3931373739362C3931373739372C3931373739382C3931373739392C3931373830302C393137';
wwv_flow_imp.g_varchar2_table(690) := '3830312C3931373830322C3931373830332C3931373830342C3931373830352C3931373830362C3931373830372C3931373830382C3931373830392C3931373831302C3931373831312C3931373831322C3931373831332C3931373831342C3931373831';
wwv_flow_imp.g_varchar2_table(691) := '352C3931373831362C3931373831372C3931373831382C3931373831392C3931373832302C3931373832312C3931373832322C3931373832332C3931373832342C3931373832352C3931373832362C3931373832372C3931373832382C3931373832392C';
wwv_flow_imp.g_varchar2_table(692) := '3931373833302C3931373833312C3931373833322C3931373833332C3931373833342C3931373833352C3931373833362C3931373833372C3931373833382C3931373833392C3931373834302C3931373834312C3931373834322C3931373834332C3931';
wwv_flow_imp.g_varchar2_table(693) := '373834342C3931373834352C3931373834362C3931373834372C3931373834382C3931373834392C3931373835302C3931373835312C3931373835322C3931373835332C3931373835342C3931373835352C3931373835362C3931373835372C39313738';
wwv_flow_imp.g_varchar2_table(694) := '35382C3931373835392C3931373836302C3931373836312C3931373836322C3931373836332C3931373836342C3931373836352C3931373836362C3931373836372C3931373836382C3931373836392C3931373837302C3931373837312C393137383732';
wwv_flow_imp.g_varchar2_table(695) := '2C3931373837332C3931373837342C3931373837352C3931373837362C3931373837372C3931373837382C3931373837392C3931373838302C3931373838312C3931373838322C3931373838332C3931373838342C3931373838352C3931373838362C39';
wwv_flow_imp.g_varchar2_table(696) := '31373838372C3931373838382C3931373838392C3931373839302C3931373839312C3931373839322C3931373839332C3931373839342C3931373839352C3931373839362C3931373839372C3931373839382C3931373839392C3931373930302C393137';
wwv_flow_imp.g_varchar2_table(697) := '3930312C3931373930322C3931373930332C3931373930342C3931373930352C3931373930362C3931373930372C3931373930382C3931373930392C3931373931302C3931373931312C3931373931322C3931373931332C3931373931342C3931373931';
wwv_flow_imp.g_varchar2_table(698) := '352C3931373931362C3931373931372C3931373931382C3931373931392C3931373932302C3931373932312C3931373932322C3931373932332C3931373932342C3931373932352C3931373932362C3931373932372C3931373932382C3931373932392C';
wwv_flow_imp.g_varchar2_table(699) := '3931373933302C3931373933312C3931373933322C3931373933332C3931373933342C3931373933352C3931373933362C3931373933372C3931373933382C3931373933392C3931373934302C3931373934312C3931373934322C3931373934332C3931';
wwv_flow_imp.g_varchar2_table(700) := '373934342C3931373934352C3931373934362C3931373934372C3931373934382C3931373934392C3931373935302C3931373935312C3931373935322C3931373935332C3931373935342C3931373935352C3931373935362C3931373935372C39313739';
wwv_flow_imp.g_varchar2_table(701) := '35382C3931373935392C3931373936302C3931373936312C3931373936322C3931373936332C3931373936342C3931373936352C3931373936362C3931373936372C3931373936382C3931373936392C3931373937302C3931373937312C393137393732';
wwv_flow_imp.g_varchar2_table(702) := '2C3931373937332C3931373937342C3931373937352C3931373937362C3931373937372C3931373937382C3931373937392C3931373938302C3931373938312C3931373938322C3931373938332C3931373938342C3931373938352C3931373938362C39';
wwv_flow_imp.g_varchar2_table(703) := '31373938372C3931373938382C3931373938392C3931373939302C3931373939312C3931373939322C3931373939332C3931373939342C3931373939352C3931373939362C3931373939372C3931373939382C3931373939395D22297D73746174696320';
wwv_flow_imp.g_varchar2_table(704) := '6765744461746128297B72657475726E20746869732E5F646174617C7C28746869732E5F646174613D6E6577205365742870652E67657452617744617461282929292C746869732E5F646174617D737461746963206973496E76697369626C6543686172';
wwv_flow_imp.g_varchar2_table(705) := '61637465722865297B72657475726E2070652E6765744461746128292E6861732865297D7374617469632067657420636F6465506F696E747328297B72657475726E2070652E6765744461746128297D7D70652E5F646174613D766F696420303B6C6574';
wwv_flow_imp.g_varchar2_table(706) := '2076653B636C6173732062657B636F6E7374727563746F7228652C742C6E2C72297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6D6574686F643D6E2C746869732E617267733D722C746869732E747970653D307D7D';
wwv_flow_imp.g_varchar2_table(707) := '636C6173732079657B636F6E7374727563746F7228652C742C6E2C72297B746869732E7673576F726B65723D652C746869732E7365713D742C746869732E7265733D6E2C746869732E6572723D722C746869732E747970653D317D7D636C617373205F65';
wwv_flow_imp.g_varchar2_table(708) := '7B636F6E7374727563746F7228652C742C6E2C72297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E744E616D653D6E2C746869732E6172673D722C746869732E747970653D327D7D636C6173732043657B63';
wwv_flow_imp.g_varchar2_table(709) := '6F6E7374727563746F7228652C742C6E297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E743D6E2C746869732E747970653D337D7D636C6173732077657B636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(710) := '732E7673576F726B65723D652C746869732E7265713D742C746869732E747970653D347D7D636C6173732053657B636F6E7374727563746F722865297B746869732E5F776F726B657249643D2D312C746869732E5F68616E646C65723D652C746869732E';
wwv_flow_imp.g_varchar2_table(711) := '5F6C61737453656E745265713D302C746869732E5F70656E64696E675265706C6965733D4F626A6563742E637265617465286E756C6C292C746869732E5F70656E64696E67456D6974746572733D6E6577204D61702C746869732E5F70656E64696E6745';
wwv_flow_imp.g_varchar2_table(712) := '76656E74733D6E6577204D61707D736574576F726B657249642865297B746869732E5F776F726B657249643D657D73656E644D65737361676528652C74297B636F6E7374206E3D537472696E67282B2B746869732E5F6C61737453656E74526571293B72';
wwv_flow_imp.g_varchar2_table(713) := '657475726E206E65772050726F6D697365282828722C69293D3E7B746869732E5F70656E64696E675265706C6965735B6E5D3D7B7265736F6C76653A722C72656A6563743A697D2C746869732E5F73656E64286E657720626528746869732E5F776F726B';
wwv_flow_imp.g_varchar2_table(714) := '657249642C6E2C652C7429297D29297D6C697374656E28652C74297B6C6574206E3D6E756C6C3B636F6E737420723D6E65772078287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E7B6E3D537472696E67282B2B746869732E5F6C';
wwv_flow_imp.g_varchar2_table(715) := '61737453656E74526571292C746869732E5F70656E64696E67456D6974746572732E736574286E2C72292C746869732E5F73656E64286E6577205F6528746869732E5F776F726B657249642C6E2C652C7429297D2C6F6E44696452656D6F76654C617374';
wwv_flow_imp.g_varchar2_table(716) := '4C697374656E65723A28293D3E7B746869732E5F70656E64696E67456D6974746572732E64656C657465286E292C746869732E5F73656E64286E657720776528746869732E5F776F726B657249642C6E29292C6E3D6E756C6C7D7D293B72657475726E20';
wwv_flow_imp.g_varchar2_table(717) := '722E6576656E747D68616E646C654D6573736167652865297B652626652E7673576F726B65722626282D31213D3D746869732E5F776F726B657249642626652E7673576F726B6572213D3D746869732E5F776F726B657249647C7C746869732E5F68616E';
wwv_flow_imp.g_varchar2_table(718) := '646C654D657373616765286529297D5F68616E646C654D6573736167652865297B73776974636828652E74797065297B6361736520313A72657475726E20746869732E5F68616E646C655265706C794D6573736167652865293B6361736520303A726574';
wwv_flow_imp.g_varchar2_table(719) := '75726E20746869732E5F68616E646C65526571756573744D6573736167652865293B6361736520323A72657475726E20746869732E5F68616E646C655375627363726962654576656E744D6573736167652865293B6361736520333A72657475726E2074';
wwv_flow_imp.g_varchar2_table(720) := '6869732E5F68616E646C654576656E744D6573736167652865293B6361736520343A72657475726E20746869732E5F68616E646C65556E7375627363726962654576656E744D6573736167652865297D7D5F68616E646C655265706C794D657373616765';
wwv_flow_imp.g_varchar2_table(721) := '2865297B69662821746869732E5F70656E64696E675265706C6965735B652E7365715D2972657475726E20766F696420636F6E736F6C652E7761726E2822476F74207265706C7920746F20756E6B6E6F776E2073657122293B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(722) := '732E5F70656E64696E675265706C6965735B652E7365715D3B69662864656C65746520746869732E5F70656E64696E675265706C6965735B652E7365715D2C652E657272297B6C6574206E3D652E6572723B72657475726E20652E6572722E2469734572';
wwv_flow_imp.g_varchar2_table(723) := '726F722626286E3D6E6577204572726F722C6E2E6E616D653D652E6572722E6E616D652C6E2E6D6573736167653D652E6572722E6D6573736167652C6E2E737461636B3D652E6572722E737461636B292C766F696420742E72656A656374286E297D742E';
wwv_flow_imp.g_varchar2_table(724) := '7265736F6C766528652E726573297D5F68616E646C65526571756573744D6573736167652865297B636F6E737420743D652E7265713B746869732E5F68616E646C65722E68616E646C654D65737361676528652E6D6574686F642C652E61726773292E74';
wwv_flow_imp.g_varchar2_table(725) := '68656E2828653D3E7B746869732E5F73656E64286E657720796528746869732E5F776F726B657249642C742C652C766F6964203029297D292C28653D3E7B652E64657461696C20696E7374616E63656F66204572726F72262628652E64657461696C3D6E';
wwv_flow_imp.g_varchar2_table(726) := '28652E64657461696C29292C746869732E5F73656E64286E657720796528746869732E5F776F726B657249642C742C766F696420302C6E28652929297D29297D5F68616E646C655375627363726962654576656E744D6573736167652865297B636F6E73';
wwv_flow_imp.g_varchar2_table(727) := '7420743D652E7265712C6E3D746869732E5F68616E646C65722E68616E646C654576656E7428652E6576656E744E616D652C652E617267292828653D3E7B746869732E5F73656E64286E657720436528746869732E5F776F726B657249642C742C652929';
wwv_flow_imp.g_varchar2_table(728) := '7D29293B746869732E5F70656E64696E674576656E74732E73657428742C6E297D5F68616E646C654576656E744D6573736167652865297B746869732E5F70656E64696E67456D6974746572732E68617328652E726571293F746869732E5F70656E6469';
wwv_flow_imp.g_varchar2_table(729) := '6E67456D6974746572732E67657428652E726571292E6669726528652E6576656E74293A636F6E736F6C652E7761726E2822476F74206576656E7420666F7220756E6B6E6F776E2072657122297D5F68616E646C65556E7375627363726962654576656E';
wwv_flow_imp.g_varchar2_table(730) := '744D6573736167652865297B746869732E5F70656E64696E674576656E74732E68617328652E726571293F28746869732E5F70656E64696E674576656E74732E67657428652E726571292E646973706F736528292C746869732E5F70656E64696E674576';
wwv_flow_imp.g_varchar2_table(731) := '656E74732E64656C65746528652E72657129293A636F6E736F6C652E7761726E2822476F7420756E73756273637269626520666F7220756E6B6E6F776E2072657122297D5F73656E642865297B636F6E737420743D5B5D3B696628303D3D3D652E747970';
wwv_flow_imp.g_varchar2_table(732) := '6529666F72286C6574206E3D303B6E3C652E617267732E6C656E6774683B6E2B2B29652E617267735B6E5D696E7374616E63656F662041727261794275666665722626742E7075736828652E617267735B6E5D293B656C736520313D3D3D652E74797065';
wwv_flow_imp.g_varchar2_table(733) := '2626652E72657320696E7374616E63656F662041727261794275666665722626742E7075736828652E726573293B746869732E5F68616E646C65722E73656E644D65737361676528652C74297D7D66756E6374696F6E204C652865297B72657475726E22';
wwv_flow_imp.g_varchar2_table(734) := '6F223D3D3D655B305D2626226E223D3D3D655B315D26266C6528652E63686172436F64654174283229297D66756E6374696F6E2045652865297B72657475726E2F5E6F6E44796E616D69632F2E7465737428652926266C6528652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(735) := '74283929297D636C6173732078657B636F6E7374727563746F7228652C74297B746869732E5F7265717565737448616E646C6572466163746F72793D742C746869732E5F7265717565737448616E646C65723D6E756C6C2C746869732E5F70726F746F63';
wwv_flow_imp.g_varchar2_table(736) := '6F6C3D6E6577205365287B73656E644D6573736167653A28742C6E293D3E7B6528742C6E297D2C68616E646C654D6573736167653A28652C74293D3E746869732E5F68616E646C654D65737361676528652C74292C68616E646C654576656E743A28652C';
wwv_flow_imp.g_varchar2_table(737) := '74293D3E746869732E5F68616E646C654576656E7428652C74297D297D6F6E6D6573736167652865297B746869732E5F70726F746F636F6C2E68616E646C654D6573736167652865297D5F68616E646C654D65737361676528652C74297B696628222469';
wwv_flow_imp.g_varchar2_table(738) := '6E697469616C697A65223D3D3D652972657475726E20746869732E696E697469616C697A6528745B305D2C745B315D2C745B325D2C745B335D293B69662821746869732E5F7265717565737448616E646C65727C7C2266756E6374696F6E22213D747970';
wwv_flow_imp.g_varchar2_table(739) := '656F6620746869732E5F7265717565737448616E646C65725B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E67207265717565737448616E646C6572206F72206D6574686F643A20222B652929';
wwv_flow_imp.g_varchar2_table(740) := '3B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F7265717565737448616E646C65725B655D2E6170706C7928746869732E5F7265717565737448616E646C65722C7429297D63617463682865297B72657475726E2050';
wwv_flow_imp.g_varchar2_table(741) := '726F6D6973652E72656A6563742865297D7D5F68616E646C654576656E7428652C74297B69662821746869732E5F7265717565737448616E646C6572297468726F77206E6577204572726F7228224D697373696E67207265717565737448616E646C6572';
wwv_flow_imp.g_varchar2_table(742) := '22293B6966284565286529297B636F6E7374206E3D746869732E5F7265717565737448616E646C65725B655D2E63616C6C28746869732E5F7265717565737448616E646C65722C74293B6966282266756E6374696F6E22213D747970656F66206E297468';
wwv_flow_imp.g_varchar2_table(743) := '726F77206E6577204572726F7228604D697373696E672064796E616D6963206576656E7420247B657D206F6E20726571756573742068616E646C65722E60293B72657475726E206E7D6966284C65286529297B636F6E737420743D746869732E5F726571';
wwv_flow_imp.g_varchar2_table(744) := '7565737448616E646C65725B655D3B6966282266756E6374696F6E22213D747970656F662074297468726F77206E6577204572726F7228604D697373696E67206576656E7420247B657D206F6E20726571756573742068616E646C65722E60293B726574';
wwv_flow_imp.g_varchar2_table(745) := '75726E20747D7468726F77206E6577204572726F7228604D616C666F726D6564206576656E74206E616D6520247B657D60297D696E697469616C697A6528652C742C6E2C72297B746869732E5F70726F746F636F6C2E736574576F726B65724964286529';
wwv_flow_imp.g_varchar2_table(746) := '3B636F6E737420693D66756E6374696F6E28652C742C6E297B636F6E737420723D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B7265747572';
wwv_flow_imp.g_varchar2_table(747) := '6E207428652C6E297D2C693D653D3E66756E6374696F6E2874297B72657475726E206E28652C74297D2C733D7B7D3B666F7228636F6E73742074206F6620652945652874293F735B745D3D692874293A4C652874293F735B745D3D6E28742C766F696420';
wwv_flow_imp.g_varchar2_table(748) := '30293A735B745D3D722874293B72657475726E20737D28722C2828652C74293D3E746869732E5F70726F746F636F6C2E73656E644D65737361676528652C7429292C2828652C74293D3E746869732E5F70726F746F636F6C2E6C697374656E28652C7429';
wwv_flow_imp.g_varchar2_table(749) := '29293B72657475726E20746869732E5F7265717565737448616E646C6572466163746F72793F28746869732E5F7265717565737448616E646C65723D746869732E5F7265717565737448616E646C6572466163746F72792869292C50726F6D6973652E72';
wwv_flow_imp.g_varchar2_table(750) := '65736F6C7665284128746869732E5F7265717565737448616E646C65722929293A2874262628766F69642030213D3D742E6261736555726C262664656C65746520742E6261736555726C2C766F69642030213D3D742E70617468732626766F6964203021';
wwv_flow_imp.g_varchar2_table(751) := '3D3D742E70617468732E7673262664656C65746520742E70617468732E76732C766F69642030213D3D742E747275737465645479706573506F6C696379262664656C65746520742E747275737465645479706573506F6C6963792C742E63617463684572';
wwv_flow_imp.g_varchar2_table(752) := '726F723D21302C676C6F62616C546869732E726571756972652E636F6E666967287429292C6E65772050726F6D697365282828652C74293D3E7B28302C676C6F62616C546869732E7265717569726529285B6E5D2C286E3D3E7B746869732E5F72657175';
wwv_flow_imp.g_varchar2_table(753) := '65737448616E646C65723D6E2E6372656174652869292C746869732E5F7265717565737448616E646C65723F65284128746869732E5F7265717565737448616E646C657229293A74286E6577204572726F7228224E6F205265717565737448616E646C65';
wwv_flow_imp.g_varchar2_table(754) := '72212229297D292C74297D2929297D7D636C617373204E657B636F6E7374727563746F7228652C742C6E2C72297B746869732E6F726967696E616C53746172743D652C746869732E6F726967696E616C4C656E6774683D742C746869732E6D6F64696669';
wwv_flow_imp.g_varchar2_table(755) := '656453746172743D6E2C746869732E6D6F6469666965644C656E6774683D727D6765744F726967696E616C456E6428297B72657475726E20746869732E6F726967696E616C53746172742B746869732E6F726967696E616C4C656E6774687D6765744D6F';
wwv_flow_imp.g_varchar2_table(756) := '646966696564456E6428297B72657475726E20746869732E6D6F64696669656453746172742B746869732E6D6F6469666965644C656E6774687D7D66756E6374696F6E20416528652C74297B72657475726E28743C3C35292D742B657C307D66756E6374';
wwv_flow_imp.g_varchar2_table(757) := '696F6E206B6528652C74297B743D4165283134393431372C74293B666F72286C6574206E3D302C723D652E6C656E6774683B6E3C723B6E2B2B29743D416528652E63686172436F64654174286E292C74293B72657475726E20747D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(758) := '526528652C742C6E3D3332297B636F6E737420723D6E2D743B72657475726E28653C3C747C287E2828313C3C72292D31292665293E3E3E72293E3E3E307D66756E6374696F6E20546528652C743D302C6E3D652E627974654C656E6774682C723D30297B';
wwv_flow_imp.g_varchar2_table(759) := '666F72286C657420693D303B693C6E3B692B2B29655B742B695D3D727D66756E6374696F6E204D6528652C743D3332297B72657475726E206520696E7374616E63656F662041727261794275666665723F41727261792E66726F6D286E65772055696E74';
wwv_flow_imp.g_varchar2_table(760) := '384172726179286529292E6D61702828653D3E652E746F537472696E67283136292E706164537461727428322C2230222929292E6A6F696E282222293A66756E6374696F6E28652C742C6E3D223022297B666F72283B652E6C656E6774683C743B29653D';
wwv_flow_imp.g_varchar2_table(761) := '6E2B653B72657475726E20657D2828653E3E3E30292E746F537472696E67283136292C742F34297D636C617373204F657B636F6E7374727563746F7228297B746869732E5F68303D313733323538343139332C746869732E5F68313D3430323332333334';
wwv_flow_imp.g_varchar2_table(762) := '31372C746869732E5F68323D323536323338333130322C746869732E5F68333D3237313733333837382C746869732E5F68343D333238353337373532302C746869732E5F627566663D6E65772055696E74384172726179283637292C746869732E5F6275';
wwv_flow_imp.g_varchar2_table(763) := '666644563D6E657720446174615669657728746869732E5F627566662E627566666572292C746869732E5F627566664C656E3D302C746869732E5F746F74616C4C656E3D302C746869732E5F6C6566746F76657248696768537572726F676174653D302C';
wwv_flow_imp.g_varchar2_table(764) := '746869732E5F66696E69736865643D21317D7570646174652865297B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E3B636F6E7374206E3D746869732E5F627566663B6C657420722C692C733D746869732E5F62756666';
wwv_flow_imp.g_varchar2_table(765) := '4C656E2C6F3D746869732E5F6C6566746F76657248696768537572726F676174653B666F722830213D3D6F3F28723D6F2C693D2D312C6F3D30293A28723D652E63686172436F646541742830292C693D30293B3B297B6C657420613D723B696628756528';
wwv_flow_imp.g_varchar2_table(766) := '7229297B6966282128692B313C7429297B6F3D723B627265616B7D7B636F6E737420743D652E63686172436F6465417428692B31293B63652874293F28692B2B2C613D686528722C7429293A613D36353533337D7D656C7365206365287229262628613D';
wwv_flow_imp.g_varchar2_table(767) := '3635353333293B696628733D746869732E5F70757368286E2C732C61292C692B2B2C2128693C742929627265616B3B723D652E63686172436F646541742869297D746869732E5F627566664C656E3D732C746869732E5F6C6566746F7665724869676853';
wwv_flow_imp.g_varchar2_table(768) := '7572726F676174653D6F7D5F7075736828652C742C6E297B72657475726E206E3C3132383F655B742B2B5D3D6E3A6E3C323034383F28655B742B2B5D3D3139327C2831393834266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E3029';
wwv_flow_imp.g_varchar2_table(769) := '3A6E3C36353533363F28655B742B2B5D3D3232347C283631343430266E293E3E3E31322C655B742B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30293A28655B742B2B5D3D3234307C2831383335';
wwv_flow_imp.g_varchar2_table(770) := '303038266E293E3E3E31382C655B742B2B5D3D3132387C28323538303438266E293E3E3E31322C655B742B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30292C743E3D3634262628746869732E5F';
wwv_flow_imp.g_varchar2_table(771) := '7374657028292C742D3D36342C746869732E5F746F74616C4C656E2B3D36342C655B305D3D655B36345D2C655B315D3D655B36355D2C655B325D3D655B36365D292C747D64696765737428297B72657475726E20746869732E5F66696E69736865647C7C';
wwv_flow_imp.g_varchar2_table(772) := '28746869732E5F66696E69736865643D21302C746869732E5F6C6566746F76657248696768537572726F67617465262628746869732E5F6C6566746F76657248696768537572726F676174653D302C746869732E5F627566664C656E3D746869732E5F70';
wwv_flow_imp.g_varchar2_table(773) := '75736828746869732E5F627566662C746869732E5F627566664C656E2C363535333329292C746869732E5F746F74616C4C656E2B3D746869732E5F627566664C656E2C746869732E5F7772617055702829292C4D6528746869732E5F6830292B4D652874';
wwv_flow_imp.g_varchar2_table(774) := '6869732E5F6831292B4D6528746869732E5F6832292B4D6528746869732E5F6833292B4D6528746869732E5F6834297D5F77726170557028297B746869732E5F627566665B746869732E5F627566664C656E2B2B5D3D3132382C546528746869732E5F62';
wwv_flow_imp.g_varchar2_table(775) := '7566662C746869732E5F627566664C656E292C746869732E5F627566664C656E3E3536262628746869732E5F7374657028292C546528746869732E5F6275666629293B636F6E737420653D382A746869732E5F746F74616C4C656E3B746869732E5F6275';
wwv_flow_imp.g_varchar2_table(776) := '666644562E73657455696E7433322835362C4D6174682E666C6F6F7228652F34323934393637323936292C2131292C746869732E5F6275666644562E73657455696E7433322836302C6525343239343936373239362C2131292C746869732E5F73746570';
wwv_flow_imp.g_varchar2_table(777) := '28297D5F7374657028297B636F6E737420653D4F652E5F626967426C6F636B33322C743D746869732E5F6275666644563B666F72286C6574206E3D303B6E3C36343B6E2B3D3429652E73657455696E743332286E2C742E67657455696E743332286E2C21';
wwv_flow_imp.g_varchar2_table(778) := '31292C2131293B666F72286C657420743D36343B743C3332303B742B3D3429652E73657455696E74333228742C526528652E67657455696E74333228742D31322C2131295E652E67657455696E74333228742D33322C2131295E652E67657455696E7433';
wwv_flow_imp.g_varchar2_table(779) := '3228742D35362C2131295E652E67657455696E74333228742D36342C2131292C31292C2131293B6C6574206E2C722C692C733D746869732E5F68302C6F3D746869732E5F68312C613D746869732E5F68322C6C3D746869732E5F68332C753D746869732E';
wwv_flow_imp.g_varchar2_table(780) := '5F68343B666F72286C657420743D303B743C38303B742B2B29743C32303F286E3D6F26617C7E6F266C2C723D31353138353030323439293A743C34303F286E3D6F5E615E6C2C723D31383539373735333933293A743C36303F286E3D6F26617C6F266C7C';
wwv_flow_imp.g_varchar2_table(781) := '61266C2C723D32343030393539373038293A286E3D6F5E615E6C2C723D33333935343639373832292C693D526528732C35292B6E2B752B722B652E67657455696E74333228342A742C21312926343239343936373239352C753D6C2C6C3D612C613D5265';
wwv_flow_imp.g_varchar2_table(782) := '286F2C3330292C6F3D732C733D693B746869732E5F68303D746869732E5F68302B7326343239343936373239352C746869732E5F68313D746869732E5F68312B6F26343239343936373239352C746869732E5F68323D746869732E5F68322B6126343239';
wwv_flow_imp.g_varchar2_table(783) := '343936373239352C746869732E5F68333D746869732E5F68332B6C26343239343936373239352C746869732E5F68343D746869732E5F68342B7526343239343936373239357D7D4F652E5F626967426C6F636B33323D6E6577204461746156696577286E';
wwv_flow_imp.g_varchar2_table(784) := '65772041727261794275666665722833323029293B636C6173732049657B636F6E7374727563746F722865297B746869732E736F757263653D657D676574456C656D656E747328297B636F6E737420653D746869732E736F757263652C743D6E65772049';
wwv_flow_imp.g_varchar2_table(785) := '6E743332417272617928652E6C656E677468293B666F72286C6574206E3D302C723D652E6C656E6774683B6E3C723B6E2B2B29745B6E5D3D652E63686172436F64654174286E293B72657475726E20747D7D66756E6374696F6E20506528652C742C6E29';
wwv_flow_imp.g_varchar2_table(786) := '7B72657475726E206E6577207165286E65772049652865292C6E6577204965287429292E436F6D7075746544696666286E292E6368616E6765737D636C6173732046657B7374617469632041737365727428652C74297B6966282165297468726F77206E';
wwv_flow_imp.g_varchar2_table(787) := '6577204572726F722874297D7D636C6173732056657B73746174696320436F707928652C742C6E2C722C69297B666F72286C657420733D303B733C693B732B2B296E5B722B735D3D655B742B735D7D73746174696320436F70793228652C742C6E2C722C';
wwv_flow_imp.g_varchar2_table(788) := '69297B666F72286C657420733D303B733C693B732B2B296E5B722B735D3D655B742B735D7D7D636C6173732044657B636F6E7374727563746F7228297B746869732E6D5F6368616E6765733D5B5D2C746869732E6D5F6F726967696E616C53746172743D';
wwv_flow_imp.g_varchar2_table(789) := '313037333734313832342C746869732E6D5F6D6F64696669656453746172743D313037333734313832342C746869732E6D5F6F726967696E616C436F756E743D302C746869732E6D5F6D6F646966696564436F756E743D307D4D61726B4E657874436861';
wwv_flow_imp.g_varchar2_table(790) := '6E676528297B28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E6D5F6368616E6765732E70757368286E6577204E6528746869732E6D5F6F726967696E616C5374';
wwv_flow_imp.g_varchar2_table(791) := '6172742C746869732E6D5F6F726967696E616C436F756E742C746869732E6D5F6D6F64696669656453746172742C746869732E6D5F6D6F646966696564436F756E7429292C746869732E6D5F6F726967696E616C436F756E743D302C746869732E6D5F6D';
wwv_flow_imp.g_varchar2_table(792) := '6F646966696564436F756E743D302C746869732E6D5F6F726967696E616C53746172743D313037333734313832342C746869732E6D5F6D6F64696669656453746172743D313037333734313832347D4164644F726967696E616C456C656D656E7428652C';
wwv_flow_imp.g_varchar2_table(793) := '74297B746869732E6D5F6F726967696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F726967696E616C53746172742C65292C746869732E6D5F6D6F64696669656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669';
wwv_flow_imp.g_varchar2_table(794) := '656453746172742C74292C746869732E6D5F6F726967696E616C436F756E742B2B7D4164644D6F646966696564456C656D656E7428652C74297B746869732E6D5F6F726967696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F72696769';
wwv_flow_imp.g_varchar2_table(795) := '6E616C53746172742C65292C746869732E6D5F6D6F64696669656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669656453746172742C74292C746869732E6D5F6D6F646966696564436F756E742B2B7D6765744368616E67657328';
wwv_flow_imp.g_varchar2_table(796) := '297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E4D61726B4E6578744368616E676528292C746869732E6D5F6368616E6765737D6765745265';
wwv_flow_imp.g_varchar2_table(797) := '76657273654368616E67657328297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E4D61726B4E6578744368616E676528292C746869732E6D5F';
wwv_flow_imp.g_varchar2_table(798) := '6368616E6765732E7265766572736528292C746869732E6D5F6368616E6765737D7D636C6173732071657B636F6E7374727563746F7228652C742C6E3D6E756C6C297B746869732E436F6E74696E756550726F63657373696E675072656469636174653D';
wwv_flow_imp.g_varchar2_table(799) := '6E2C746869732E5F6F726967696E616C53657175656E63653D652C746869732E5F6D6F64696669656453657175656E63653D743B636F6E73745B722C692C735D3D71652E5F676574456C656D656E74732865292C5B6F2C612C6C5D3D71652E5F67657445';
wwv_flow_imp.g_varchar2_table(800) := '6C656D656E74732874293B746869732E5F686173537472696E67733D7326266C2C746869732E5F6F726967696E616C537472696E67456C656D656E74733D722C746869732E5F6F726967696E616C456C656D656E74734F72486173683D692C746869732E';
wwv_flow_imp.g_varchar2_table(801) := '5F6D6F646966696564537472696E67456C656D656E74733D6F2C746869732E5F6D6F646966696564456C656D656E74734F72486173683D612C746869732E6D5F666F7277617264486973746F72793D5B5D2C746869732E6D5F7265766572736548697374';
wwv_flow_imp.g_varchar2_table(802) := '6F72793D5B5D7D737461746963205F6973537472696E6741727261792865297B72657475726E20652E6C656E6774683E30262622737472696E67223D3D747970656F6620655B305D7D737461746963205F676574456C656D656E74732865297B636F6E73';
wwv_flow_imp.g_varchar2_table(803) := '7420743D652E676574456C656D656E747328293B69662871652E5F6973537472696E674172726179287429297B636F6E737420653D6E657720496E743332417272617928742E6C656E677468293B666F72286C6574206E3D302C723D742E6C656E677468';
wwv_flow_imp.g_varchar2_table(804) := '3B6E3C723B6E2B2B29655B6E5D3D6B6528745B6E5D2C30293B72657475726E5B742C652C21305D7D72657475726E207420696E7374616E63656F6620496E74333241727261793F5B5B5D2C742C21315D3A5B5B5D2C6E657720496E743332417272617928';
wwv_flow_imp.g_varchar2_table(805) := '74292C21315D7D456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6F726967696E616C456C656D656E74734F72486173685B655D3D3D3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B74';
wwv_flow_imp.g_varchar2_table(806) := '5D26262821746869732E5F686173537472696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D3D3D3D746869732E5F6D6F646966696564537472696E67456C656D656E74735B745D297D456C656D656E74734172';
wwv_flow_imp.g_varchar2_table(807) := '65537472696374457175616C28652C74297B72657475726E2121746869732E456C656D656E7473417265457175616C28652C7429262671652E5F676574537472696374456C656D656E7428746869732E5F6F726967696E616C53657175656E63652C6529';
wwv_flow_imp.g_varchar2_table(808) := '3D3D3D71652E5F676574537472696374456C656D656E7428746869732E5F6D6F64696669656453657175656E63652C74297D737461746963205F676574537472696374456C656D656E7428652C74297B72657475726E2266756E6374696F6E223D3D7479';
wwv_flow_imp.g_varchar2_table(809) := '70656F6620652E676574537472696374456C656D656E743F652E676574537472696374456C656D656E742874293A6E756C6C7D4F726967696E616C456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6F726967696E';
wwv_flow_imp.g_varchar2_table(810) := '616C456C656D656E74734F72486173685B655D3D3D3D746869732E5F6F726967696E616C456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D65';
wwv_flow_imp.g_varchar2_table(811) := '6E74735B655D3D3D3D746869732E5F6F726967696E616C537472696E67456C656D656E74735B745D297D4D6F646966696564456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6D6F646966696564456C656D656E74';
wwv_flow_imp.g_varchar2_table(812) := '734F72486173685B655D3D3D3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869732E5F6D6F646966696564537472696E67456C656D656E74735B655D3D3D3D';
wwv_flow_imp.g_varchar2_table(813) := '746869732E5F6D6F646966696564537472696E67456C656D656E74735B745D297D436F6D70757465446966662865297B72657475726E20746869732E5F436F6D707574654469666628302C746869732E5F6F726967696E616C456C656D656E74734F7248';
wwv_flow_imp.g_varchar2_table(814) := '6173682E6C656E6774682D312C302C746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682D312C65297D5F436F6D707574654469666628652C742C6E2C722C69297B636F6E737420733D5B21315D3B6C6574206F3D74';
wwv_flow_imp.g_varchar2_table(815) := '6869732E436F6D707574654469666652656375727369766528652C742C6E2C722C73293B72657475726E20692626286F3D746869732E50726574746966794368616E676573286F29292C7B717569744561726C793A735B305D2C6368616E6765733A6F7D';
wwv_flow_imp.g_varchar2_table(816) := '7D436F6D707574654469666652656375727369766528652C742C6E2C722C69297B666F7228695B305D3D21313B653C3D7426266E3C3D722626746869732E456C656D656E7473417265457175616C28652C6E293B29652B2B2C6E2B2B3B666F72283B743E';
wwv_flow_imp.g_varchar2_table(817) := '3D652626723E3D6E2626746869732E456C656D656E7473417265457175616C28742C72293B29742D2D2C722D2D3B696628653E747C7C6E3E72297B6C657420693B72657475726E206E3C3D723F2846652E41737365727428653D3D3D742B312C226F7269';
wwv_flow_imp.g_varchar2_table(818) := '67696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C693D5B6E6577204E6528652C302C6E2C722D6E2B31295D293A653C3D743F2846652E417373657274286E3D3D3D72';
wwv_flow_imp.g_varchar2_table(819) := '2B312C226D6F64696669656453746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C693D5B6E6577204E6528652C742D652B312C6E2C30295D293A2846652E41737365727428653D3D';
wwv_flow_imp.g_varchar2_table(820) := '3D742B312C226F726967696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C46652E417373657274286E3D3D3D722B312C226D6F64696669656453746172742073686F75';
wwv_flow_imp.g_varchar2_table(821) := '6C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C693D5B5D292C697D636F6E737420733D5B305D2C6F3D5B305D2C613D746869732E436F6D70757465526563757273696F6E506F696E7428652C742C6E2C';
wwv_flow_imp.g_varchar2_table(822) := '722C732C6F2C69292C6C3D735B305D2C753D6F5B305D3B6966286E756C6C213D3D612972657475726E20613B69662821695B305D297B636F6E737420733D746869732E436F6D707574654469666652656375727369766528652C6C2C6E2C752C69293B6C';
wwv_flow_imp.g_varchar2_table(823) := '6574206F3D5B5D3B72657475726E206F3D695B305D3F5B6E6577204E65286C2B312C742D286C2B31292B312C752B312C722D28752B31292B31295D3A746869732E436F6D7075746544696666526563757273697665286C2B312C742C752B312C722C6929';
wwv_flow_imp.g_varchar2_table(824) := '2C746869732E436F6E636174656E6174654368616E67657328732C6F297D72657475726E5B6E6577204E6528652C742D652B312C6E2C722D6E2B31295D7D57414C4B545241434528652C742C6E2C722C692C732C6F2C612C6C2C752C632C682C642C662C';
wwv_flow_imp.g_varchar2_table(825) := '6D2C672C702C76297B6C657420623D6E756C6C2C793D6E756C6C2C5F3D6E65772044652C433D742C773D6E2C533D645B305D2D675B305D2D722C4C3D2D313037333734313832342C453D746869732E6D5F666F7277617264486973746F72792E6C656E67';
wwv_flow_imp.g_varchar2_table(826) := '74682D313B646F7B636F6E737420743D532B653B743D3D3D437C7C743C7726266C5B742D315D3C6C5B742B315D3F28663D28633D6C5B742B315D292D532D722C633C4C26265F2E4D61726B4E6578744368616E676528292C4C3D632C5F2E4164644D6F64';
wwv_flow_imp.g_varchar2_table(827) := '6966696564456C656D656E7428632B312C66292C533D742B312D65293A28663D28633D6C5B742D315D2B31292D532D722C633C4C26265F2E4D61726B4E6578744368616E676528292C4C3D632D312C5F2E4164644F726967696E616C456C656D656E7428';
wwv_flow_imp.g_varchar2_table(828) := '632C662B31292C533D742D312D65292C453E3D30262628653D286C3D746869732E6D5F666F7277617264486973746F72795B455D295B305D2C433D312C773D6C2E6C656E6774682D31297D7768696C65282D2D453E3D2D31293B696628623D5F2E676574';
wwv_flow_imp.g_varchar2_table(829) := '526576657273654368616E67657328292C765B305D297B6C657420653D645B305D2B312C743D675B305D2B313B6966286E756C6C213D3D622626622E6C656E6774683E30297B636F6E7374206E3D625B622E6C656E6774682D315D3B653D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(830) := '617828652C6E2E6765744F726967696E616C456E642829292C743D4D6174682E6D617828742C6E2E6765744D6F646966696564456E642829297D793D5B6E6577204E6528652C682D652B312C742C6D2D742B31295D7D656C73657B5F3D6E65772044652C';
wwv_flow_imp.g_varchar2_table(831) := '433D732C773D6F2C533D645B305D2D675B305D2D612C4C3D313037333734313832342C453D703F746869732E6D5F72657665727365486973746F72792E6C656E6774682D313A746869732E6D5F72657665727365486973746F72792E6C656E6774682D32';
wwv_flow_imp.g_varchar2_table(832) := '3B646F7B636F6E737420653D532B693B653D3D3D437C7C653C772626755B652D315D3E3D755B652B315D3F28663D28633D755B652B315D2D31292D532D612C633E4C26265F2E4D61726B4E6578744368616E676528292C4C3D632B312C5F2E4164644F72';
wwv_flow_imp.g_varchar2_table(833) := '6967696E616C456C656D656E7428632B312C662B31292C533D652B312D69293A28663D28633D755B652D315D292D532D612C633E4C26265F2E4D61726B4E6578744368616E676528292C4C3D632C5F2E4164644D6F646966696564456C656D656E742863';
wwv_flow_imp.g_varchar2_table(834) := '2B312C662B31292C533D652D312D69292C453E3D30262628693D28753D746869732E6D5F72657665727365486973746F72795B455D295B305D2C433D312C773D752E6C656E6774682D31297D7768696C65282D2D453E3D2D31293B793D5F2E6765744368';
wwv_flow_imp.g_varchar2_table(835) := '616E67657328297D72657475726E20746869732E436F6E636174656E6174654368616E67657328622C79297D436F6D70757465526563757273696F6E506F696E7428652C742C6E2C722C692C732C6F297B6C657420613D302C6C3D302C753D302C633D30';
wwv_flow_imp.g_varchar2_table(836) := '2C683D302C643D303B652D2D2C6E2D2D2C695B305D3D302C735B305D3D302C746869732E6D5F666F7277617264486973746F72793D5B5D2C746869732E6D5F72657665727365486973746F72793D5B5D3B636F6E737420663D742D652B28722D6E292C6D';
wwv_flow_imp.g_varchar2_table(837) := '3D662B312C673D6E657720496E7433324172726179286D292C703D6E657720496E7433324172726179286D292C763D722D6E2C623D742D652C793D652D6E2C5F3D742D722C433D28622D762925323D3D303B675B765D3D652C705B625D3D742C6F5B305D';
wwv_flow_imp.g_varchar2_table(838) := '3D21313B666F72286C657420773D313B773C3D662F322B313B772B2B297B6C657420663D302C533D303B753D746869732E436C6970446961676F6E616C426F756E6428762D772C772C762C6D292C633D746869732E436C6970446961676F6E616C426F75';
wwv_flow_imp.g_varchar2_table(839) := '6E6428762B772C772C762C6D293B666F72286C657420653D753B653C3D633B652B3D32297B613D653D3D3D757C7C653C632626675B652D315D3C675B652B315D3F675B652B315D3A675B652D315D2B312C6C3D612D28652D76292D793B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(840) := '3D613B666F72283B613C7426266C3C722626746869732E456C656D656E7473417265457175616C28612B312C6C2B31293B29612B2B2C6C2B2B3B696628675B655D3D612C612B6C3E662B53262628663D612C533D6C292C214326264D6174682E61627328';
wwv_flow_imp.g_varchar2_table(841) := '652D62293C3D772D312626613E3D705B655D2972657475726E20695B305D3D612C735B305D3D6C2C6E3C3D705B655D2626773C3D313434383F746869732E57414C4B545241434528762C752C632C792C622C682C642C5F2C672C702C612C742C692C6C2C';
wwv_flow_imp.g_varchar2_table(842) := '722C732C432C6F293A6E756C6C7D636F6E7374204C3D28662D652B28532D6E292D77292F323B6966286E756C6C213D3D746869732E436F6E74696E756550726F63657373696E67507265646963617465262621746869732E436F6E74696E756550726F63';
wwv_flow_imp.g_varchar2_table(843) := '657373696E6750726564696361746528662C4C292972657475726E206F5B305D3D21302C695B305D3D662C735B305D3D532C4C3E302626773C3D313434383F746869732E57414C4B545241434528762C752C632C792C622C682C642C5F2C672C702C612C';
wwv_flow_imp.g_varchar2_table(844) := '742C692C6C2C722C732C432C6F293A28652B2B2C6E2B2B2C5B6E6577204E6528652C742D652B312C6E2C722D6E2B31295D293B683D746869732E436C6970446961676F6E616C426F756E6428622D772C772C622C6D292C643D746869732E436C69704469';
wwv_flow_imp.g_varchar2_table(845) := '61676F6E616C426F756E6428622B772C772C622C6D293B666F72286C657420663D683B663C3D643B662B3D32297B613D663D3D3D687C7C663C642626705B662D315D3E3D705B662B315D3F705B662B315D2D313A705B662D315D2C6C3D612D28662D6229';
wwv_flow_imp.g_varchar2_table(846) := '2D5F3B636F6E7374206D3D613B666F72283B613E6526266C3E6E2626746869732E456C656D656E7473417265457175616C28612C6C293B29612D2D2C6C2D2D3B696628705B665D3D612C4326264D6174682E61627328662D76293C3D772626613C3D675B';
wwv_flow_imp.g_varchar2_table(847) := '665D2972657475726E20695B305D3D612C735B305D3D6C2C6D3E3D675B665D2626773C3D313434383F746869732E57414C4B545241434528762C752C632C792C622C682C642C5F2C672C702C612C742C692C6C2C722C732C432C6F293A6E756C6C7D6966';
wwv_flow_imp.g_varchar2_table(848) := '28773C3D31343437297B6C657420653D6E657720496E743332417272617928632D752B32293B655B305D3D762D752B312C56652E436F70793228672C752C652C312C632D752B31292C746869732E6D5F666F7277617264486973746F72792E7075736828';
wwv_flow_imp.g_varchar2_table(849) := '65292C653D6E657720496E743332417272617928642D682B32292C655B305D3D622D682B312C56652E436F70793228702C682C652C312C642D682B31292C746869732E6D5F72657665727365486973746F72792E707573682865297D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(850) := '746869732E57414C4B545241434528762C752C632C792C622C682C642C5F2C672C702C612C742C692C6C2C722C732C432C6F297D50726574746966794368616E6765732865297B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B63';
wwv_flow_imp.g_varchar2_table(851) := '6F6E7374206E3D655B745D2C723D743C652E6C656E6774682D313F655B742B315D2E6F726967696E616C53746172743A746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E6774682C693D743C652E6C656E6774682D313F65';
wwv_flow_imp.g_varchar2_table(852) := '5B742B315D2E6D6F64696669656453746172743A746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682C733D6E2E6F726967696E616C4C656E6774683E302C6F3D6E2E6D6F6469666965644C656E6774683E303B666F';
wwv_flow_imp.g_varchar2_table(853) := '72283B6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774683C7226266E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E6774683C6926262821737C7C746869732E4F726967696E616C456C656D656E74';
wwv_flow_imp.g_varchar2_table(854) := '73417265457175616C286E2E6F726967696E616C53746172742C6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682929262628216F7C7C746869732E4D6F646966696564456C656D656E7473417265457175616C286E2E6D';
wwv_flow_imp.g_varchar2_table(855) := '6F64696669656453746172742C6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E67746829293B297B636F6E737420653D746869732E456C656D656E7473417265537472696374457175616C286E2E6F726967696E616C53746172';
wwv_flow_imp.g_varchar2_table(856) := '742C6E2E6D6F6469666965645374617274293B696628746869732E456C656D656E7473417265537472696374457175616C286E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742B6E';
wwv_flow_imp.g_varchar2_table(857) := '2E6D6F6469666965644C656E677468292626216529627265616B3B6E2E6F726967696E616C53746172742B2B2C6E2E6D6F64696669656453746172742B2B7D636F6E737420613D5B6E756C6C5D3B743C652E6C656E6774682D312626746869732E436861';
wwv_flow_imp.g_varchar2_table(858) := '6E6765734F7665726C617028655B745D2C655B742B315D2C6129262628655B745D3D615B305D2C652E73706C69636528742B312C31292C742D2D297D666F72286C657420743D652E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D65';
wwv_flow_imp.g_varchar2_table(859) := '5B745D3B6C657420723D302C693D303B696628743E30297B636F6E7374206E3D655B742D315D3B723D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682C693D6E2E6D6F64696669656453746172742B6E2E6D6F64696669';
wwv_flow_imp.g_varchar2_table(860) := '65644C656E6774687D636F6E737420733D6E2E6F726967696E616C4C656E6774683E302C6F3D6E2E6D6F6469666965644C656E6774683E303B6C657420613D302C6C3D746869732E5F626F756E6461727953636F7265286E2E6F726967696E616C537461';
wwv_flow_imp.g_varchar2_table(861) := '72742C6E2E6F726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742C6E2E6D6F6469666965644C656E677468293B666F72286C657420653D313B3B652B2B297B636F6E737420743D6E2E6F726967696E616C53746172742D652C753D';
wwv_flow_imp.g_varchar2_table(862) := '6E2E6D6F64696669656453746172742D653B696628743C727C7C753C6929627265616B3B69662873262621746869732E4F726967696E616C456C656D656E7473417265457175616C28742C742B6E2E6F726967696E616C4C656E6774682929627265616B';
wwv_flow_imp.g_varchar2_table(863) := '3B6966286F262621746869732E4D6F646966696564456C656D656E7473417265457175616C28752C752B6E2E6D6F6469666965644C656E6774682929627265616B3B636F6E737420633D28743D3D3D722626753D3D3D693F353A30292B746869732E5F62';
wwv_flow_imp.g_varchar2_table(864) := '6F756E6461727953636F726528742C6E2E6F726967696E616C4C656E6774682C752C6E2E6D6F6469666965644C656E677468293B633E6C2626286C3D632C613D65297D6E2E6F726967696E616C53746172742D3D612C6E2E6D6F64696669656453746172';
wwv_flow_imp.g_varchar2_table(865) := '742D3D613B636F6E737420753D5B6E756C6C5D3B743E302626746869732E4368616E6765734F7665726C617028655B742D315D2C655B745D2C7529262628655B742D315D3D755B305D2C652E73706C69636528742C31292C742B2B297D69662874686973';
wwv_flow_imp.g_varchar2_table(866) := '2E5F686173537472696E677329666F72286C657420743D312C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B742D315D2C723D655B745D2C693D722E6F726967696E616C53746172742D6E2E6F726967696E616C5374617274';
wwv_flow_imp.g_varchar2_table(867) := '2D6E2E6F726967696E616C4C656E6774682C733D6E2E6F726967696E616C53746172742C6F3D722E6F726967696E616C53746172742B722E6F726967696E616C4C656E6774682C613D6F2D732C6C3D6E2E6D6F64696669656453746172742C753D722E6D';
wwv_flow_imp.g_varchar2_table(868) := '6F64696669656453746172742B722E6D6F6469666965644C656E6774682C633D752D6C3B696628693C352626613C32302626633C3230297B636F6E737420653D746869732E5F66696E64426574746572436F6E746967756F757353657175656E63652873';
wwv_flow_imp.g_varchar2_table(869) := '2C612C6C2C632C69293B69662865297B636F6E73745B742C735D3D653B743D3D3D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682626733D3D3D6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E';
wwv_flow_imp.g_varchar2_table(870) := '6774687C7C286E2E6F726967696E616C4C656E6774683D742D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D732D6E2E6D6F64696669656453746172742C722E6F726967696E616C53746172743D742B692C722E6D6F';
wwv_flow_imp.g_varchar2_table(871) := '64696669656453746172743D732B692C722E6F726967696E616C4C656E6774683D6F2D722E6F726967696E616C53746172742C722E6D6F6469666965644C656E6774683D752D722E6D6F6469666965645374617274297D7D7D72657475726E20657D5F66';
wwv_flow_imp.g_varchar2_table(872) := '696E64426574746572436F6E746967756F757353657175656E636528652C742C6E2C722C69297B696628743C697C7C723C692972657475726E206E756C6C3B636F6E737420733D652B742D692B312C6F3D6E2B722D692B313B6C657420613D302C6C3D30';
wwv_flow_imp.g_varchar2_table(873) := '2C753D303B666F72286C657420743D653B743C733B742B2B29666F72286C657420653D6E3B653C6F3B652B2B297B636F6E7374206E3D746869732E5F636F6E746967756F757353657175656E636553636F726528742C652C69293B6E3E3026266E3E6126';
wwv_flow_imp.g_varchar2_table(874) := '2628613D6E2C6C3D742C753D65297D72657475726E20613E303F5B6C2C755D3A6E756C6C7D5F636F6E746967756F757353657175656E636553636F726528652C742C6E297B6C657420723D303B666F72286C657420693D303B693C6E3B692B2B297B6966';
wwv_flow_imp.g_varchar2_table(875) := '2821746869732E456C656D656E7473417265457175616C28652B692C742B69292972657475726E20303B722B3D746869732E5F6F726967696E616C537472696E67456C656D656E74735B652B695D2E6C656E6774687D72657475726E20727D5F4F726967';
wwv_flow_imp.g_varchar2_table(876) := '696E616C4973426F756E646172792865297B72657475726E20653C3D307C7C653E3D746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E6774682D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E74';
wwv_flow_imp.g_varchar2_table(877) := '65737428746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D297D5F4F726967696E616C526567696F6E4973426F756E6461727928652C74297B696628746869732E5F4F726967696E616C4973426F756E646172792865297C7C';
wwv_flow_imp.g_varchar2_table(878) := '746869732E5F4F726967696E616C4973426F756E6461727928652D31292972657475726E21303B696628743E30297B636F6E7374206E3D652B743B696628746869732E5F4F726967696E616C4973426F756E64617279286E2D31297C7C746869732E5F4F';
wwv_flow_imp.g_varchar2_table(879) := '726967696E616C4973426F756E64617279286E292972657475726E21307D72657475726E21317D5F4D6F6469666965644973426F756E646172792865297B72657475726E20653C3D307C7C653E3D746869732E5F6D6F646966696564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(880) := '4F72486173682E6C656E6774682D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E7465737428746869732E5F6D6F646966696564537472696E67456C656D656E74735B655D297D5F4D6F646966696564526567696F6E4973426F';
wwv_flow_imp.g_varchar2_table(881) := '756E6461727928652C74297B696628746869732E5F4D6F6469666965644973426F756E646172792865297C7C746869732E5F4D6F6469666965644973426F756E6461727928652D31292972657475726E21303B696628743E30297B636F6E7374206E3D65';
wwv_flow_imp.g_varchar2_table(882) := '2B743B696628746869732E5F4D6F6469666965644973426F756E64617279286E2D31297C7C746869732E5F4D6F6469666965644973426F756E64617279286E292972657475726E21307D72657475726E21317D5F626F756E6461727953636F726528652C';
wwv_flow_imp.g_varchar2_table(883) := '742C6E2C72297B72657475726E28746869732E5F4F726967696E616C526567696F6E4973426F756E6461727928652C74293F313A30292B28746869732E5F4D6F646966696564526567696F6E4973426F756E64617279286E2C72293F313A30297D436F6E';
wwv_flow_imp.g_varchar2_table(884) := '636174656E6174654368616E67657328652C74297B636F6E7374206E3D5B5D3B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E20742E6C656E6774683E303F743A653B696628746869732E4368616E6765734F';
wwv_flow_imp.g_varchar2_table(885) := '7665726C617028655B652E6C656E6774682D315D2C745B305D2C6E29297B636F6E737420723D6E657720417272617928652E6C656E6774682B742E6C656E6774682D31293B72657475726E2056652E436F707928652C302C722C302C652E6C656E677468';
wwv_flow_imp.g_varchar2_table(886) := '2D31292C725B652E6C656E6774682D315D3D6E5B305D2C56652E436F707928742C312C722C652E6C656E6774682C742E6C656E6774682D31292C727D7B636F6E7374206E3D6E657720417272617928652E6C656E6774682B742E6C656E677468293B7265';
wwv_flow_imp.g_varchar2_table(887) := '7475726E2056652E436F707928652C302C6E2C302C652E6C656E677468292C56652E436F707928742C302C6E2C652E6C656E6774682C742E6C656E677468292C6E7D7D4368616E6765734F7665726C617028652C742C6E297B69662846652E4173736572';
wwv_flow_imp.g_varchar2_table(888) := '7428652E6F726967696E616C53746172743C3D742E6F726967696E616C53746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F7220657175616C20746F207269676874206368616E676522292C46652E4173736572';
wwv_flow_imp.g_varchar2_table(889) := '7428652E6D6F64696669656453746172743C3D742E6D6F64696669656453746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F7220657175616C20746F207269676874206368616E676522292C652E6F726967696E';
wwv_flow_imp.g_varchar2_table(890) := '616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C53746172747C7C652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774683E3D742E6D6F6469666965645374617274297B636F6E737420';
wwv_flow_imp.g_varchar2_table(891) := '723D652E6F726967696E616C53746172743B6C657420693D652E6F726967696E616C4C656E6774683B636F6E737420733D652E6D6F64696669656453746172743B6C6574206F3D652E6D6F6469666965644C656E6774683B72657475726E20652E6F7269';
wwv_flow_imp.g_varchar2_table(892) := '67696E616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C5374617274262628693D742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D652E6F726967696E616C5374617274292C65';
wwv_flow_imp.g_varchar2_table(893) := '2E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774683E3D742E6D6F64696669656453746172742626286F3D742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D652E6D6F64696669656453746172';
wwv_flow_imp.g_varchar2_table(894) := '74292C6E5B305D3D6E6577204E6528722C692C732C6F292C21307D72657475726E206E5B305D3D6E756C6C2C21317D436C6970446961676F6E616C426F756E6428652C742C6E2C72297B696628653E3D302626653C722972657475726E20653B636F6E73';
wwv_flow_imp.g_varchar2_table(895) := '7420693D7425323D3D303B72657475726E20653C303F693D3D3D286E25323D3D30293F303A313A693D3D3D2828722D6E2D312925323D3D30293F722D313A722D327D7D636F6E7374204B653D676C6F62616C546869732E7673636F64653B696628766F69';
wwv_flow_imp.g_varchar2_table(896) := '642030213D3D4B652626766F69642030213D3D4B652E70726F63657373297B636F6E737420653D4B652E70726F636573733B76653D7B67657420706C6174666F726D28297B72657475726E20652E706C6174666F726D7D2C676574206172636828297B72';
wwv_flow_imp.g_varchar2_table(897) := '657475726E20652E617263687D2C67657420656E7628297B72657475726E20652E656E767D2C6377643A28293D3E652E63776428297D7D656C73652076653D22756E646566696E656422213D747970656F662070726F636573733F7B67657420706C6174';
wwv_flow_imp.g_varchar2_table(898) := '666F726D28297B72657475726E2070726F636573732E706C6174666F726D7D2C676574206172636828297B72657475726E2070726F636573732E617263687D2C67657420656E7628297B72657475726E2070726F636573732E656E767D2C6377643A2829';
wwv_flow_imp.g_varchar2_table(899) := '3D3E70726F636573732E656E762E5653434F44455F4357447C7C70726F636573732E63776428297D3A7B67657420706C6174666F726D28297B72657475726E2065653F2277696E3332223A74653F2264617277696E223A226C696E7578227D2C67657420';
wwv_flow_imp.g_varchar2_table(900) := '6172636828297B7D2C67657420656E7628297B72657475726E7B7D7D2C6377643A28293D3E222F227D3B636F6E7374206A653D76652E6377642C55653D76652E656E762C42653D76652E706C6174666F726D2C24653D34362C57653D34372C7A653D3932';
wwv_flow_imp.g_varchar2_table(901) := '2C48653D35383B636C61737320476520657874656E6473204572726F727B636F6E7374727563746F7228652C742C6E297B6C657420723B22737472696E67223D3D747970656F6620742626303D3D3D742E696E6465784F6628226E6F742022293F28723D';
wwv_flow_imp.g_varchar2_table(902) := '226D757374206E6F74206265222C743D742E7265706C616365282F5E6E6F74202F2C222229293A723D226D757374206265223B636F6E737420693D2D31213D3D652E696E6465784F6628222E22293F2270726F7065727479223A22617267756D656E7422';
wwv_flow_imp.g_varchar2_table(903) := '3B6C657420733D605468652022247B657D2220247B697D20247B727D206F66207479706520247B747D603B732B3D222E205265636569766564207479706520222B747970656F66206E2C73757065722873292C746869732E636F64653D224552525F494E';
wwv_flow_imp.g_varchar2_table(904) := '56414C49445F4152475F54595045227D7D66756E6374696F6E204A6528652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720476528742C22737472696E67222C65297D636F6E73742058653D2277696E3332223D';
wwv_flow_imp.g_varchar2_table(905) := '3D3D42653B66756E6374696F6E2051652865297B72657475726E20653D3D3D57657C7C653D3D3D7A657D66756E6374696F6E205A652865297B72657475726E20653D3D3D57657D66756E6374696F6E2059652865297B72657475726E20653E3D36352626';
wwv_flow_imp.g_varchar2_table(906) := '653C3D39307C7C653E3D39372626653C3D3132327D66756E6374696F6E20657428652C742C6E2C72297B6C657420693D22222C733D302C6F3D2D312C613D302C6C3D303B666F72286C657420753D303B753C3D652E6C656E6774683B2B2B75297B696628';
wwv_flow_imp.g_varchar2_table(907) := '753C652E6C656E677468296C3D652E63686172436F646541742875293B656C73657B69662872286C2929627265616B3B6C3D57657D69662872286C29297B6966286F3D3D3D752D317C7C313D3D3D61293B656C736520696628323D3D3D61297B69662869';
wwv_flow_imp.g_varchar2_table(908) := '2E6C656E6774683C327C7C32213D3D737C7C692E63686172436F6465417428692E6C656E6774682D3129213D3D24657C7C692E63686172436F6465417428692E6C656E6774682D3229213D3D2465297B696628692E6C656E6774683E32297B636F6E7374';
wwv_flow_imp.g_varchar2_table(909) := '20653D692E6C617374496E6465784F66286E293B2D313D3D3D653F28693D22222C733D30293A28693D692E736C69636528302C65292C733D692E6C656E6774682D312D692E6C617374496E6465784F66286E29292C6F3D752C613D303B636F6E74696E75';
wwv_flow_imp.g_varchar2_table(910) := '657D69662830213D3D692E6C656E677468297B693D22222C733D302C6F3D752C613D303B636F6E74696E75657D7D74262628692B3D692E6C656E6774683E303F60247B6E7D2E2E603A222E2E222C733D32297D656C736520692E6C656E6774683E303F69';
wwv_flow_imp.g_varchar2_table(911) := '2B3D60247B6E7D247B652E736C696365286F2B312C75297D603A693D652E736C696365286F2B312C75292C733D752D6F2D313B6F3D752C613D307D656C7365206C3D3D3D246526262D31213D3D613F2B2B613A613D2D317D72657475726E20697D66756E';
wwv_flow_imp.g_varchar2_table(912) := '6374696F6E20747428652C74297B2166756E6374696F6E2865297B6966286E756C6C3D3D3D657C7C226F626A65637422213D747970656F662065297468726F77206E65772047652822706174684F626A656374222C224F626A656374222C65297D287429';
wwv_flow_imp.g_varchar2_table(913) := '3B636F6E7374206E3D742E6469727C7C742E726F6F742C723D742E626173657C7C60247B742E6E616D657C7C22227D247B742E6578747C7C22227D603B72657475726E206E3F6E3D3D3D742E726F6F743F60247B6E7D247B727D603A60247B6E7D247B65';
wwv_flow_imp.g_varchar2_table(914) := '7D247B727D603A727D636F6E7374206E743D7B7265736F6C7665282E2E2E65297B6C657420743D22222C6E3D22222C723D21313B666F72286C657420693D652E6C656E6774682D313B693E3D2D313B692D2D297B6C657420733B696628693E3D30297B69';
wwv_flow_imp.g_varchar2_table(915) := '6628733D655B695D2C4A6528732C227061746822292C303D3D3D732E6C656E67746829636F6E74696E75657D656C736520303D3D3D742E6C656E6774683F733D6A6528293A28733D55655B603D247B747D605D7C7C6A6528292C28766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(916) := '737C7C732E736C69636528302C32292E746F4C6F776572436173652829213D3D742E746F4C6F7765724361736528292626732E63686172436F646541742832293D3D3D7A6529262628733D60247B747D5C5C6029293B636F6E7374206F3D732E6C656E67';
wwv_flow_imp.g_varchar2_table(917) := '74683B6C657420613D302C6C3D22222C753D21313B636F6E737420633D732E63686172436F646541742830293B696628313D3D3D6F295165286329262628613D312C753D2130293B656C736520696628516528632929696628753D21302C516528732E63';
wwv_flow_imp.g_varchar2_table(918) := '686172436F6465417428312929297B6C657420653D322C743D653B666F72283B653C6F262621516528732E63686172436F64654174286529293B29652B2B3B696628653C6F262665213D3D74297B636F6E7374206E3D732E736C69636528742C65293B66';
wwv_flow_imp.g_varchar2_table(919) := '6F7228743D653B653C6F2626516528732E63686172436F64654174286529293B29652B2B3B696628653C6F262665213D3D74297B666F7228743D653B653C6F262621516528732E63686172436F64654174286529293B29652B2B3B65213D3D6F2626653D';
wwv_flow_imp.g_varchar2_table(920) := '3D3D747C7C286C3D605C5C5C5C247B6E7D5C5C247B732E736C69636528742C65297D602C613D65297D7D7D656C736520613D313B656C73652059652863292626732E63686172436F646541742831293D3D3D48652626286C3D732E736C69636528302C32';
wwv_flow_imp.g_varchar2_table(921) := '292C613D322C6F3E322626516528732E63686172436F6465417428322929262628753D21302C613D3329293B6966286C2E6C656E6774683E3029696628742E6C656E6774683E30297B6966286C2E746F4C6F776572436173652829213D3D742E746F4C6F';
wwv_flow_imp.g_varchar2_table(922) := '77657243617365282929636F6E74696E75657D656C736520743D6C3B69662872297B696628742E6C656E6774683E3029627265616B7D656C7365206966286E3D60247B732E736C6963652861297D5C5C247B6E7D602C723D752C752626742E6C656E6774';
wwv_flow_imp.g_varchar2_table(923) := '683E3029627265616B7D72657475726E206E3D6574286E2C21722C225C5C222C5165292C723F60247B747D5C5C247B6E7D603A60247B747D247B6E7D607C7C222E227D2C6E6F726D616C697A652865297B4A6528652C227061746822293B636F6E737420';
wwv_flow_imp.g_varchar2_table(924) := '743D652E6C656E6774683B696628303D3D3D742972657475726E222E223B6C6574206E2C723D302C693D21313B636F6E737420733D652E63686172436F646541742830293B696628313D3D3D742972657475726E205A652873293F225C5C223A653B6966';
wwv_flow_imp.g_varchar2_table(925) := '28516528732929696628693D21302C516528652E63686172436F6465417428312929297B6C657420693D322C733D693B666F72283B693C74262621516528652E63686172436F64654174286929293B29692B2B3B696628693C74262669213D3D73297B63';
wwv_flow_imp.g_varchar2_table(926) := '6F6E7374206F3D652E736C69636528732C69293B666F7228733D693B693C742626516528652E63686172436F64654174286929293B29692B2B3B696628693C74262669213D3D73297B666F7228733D693B693C74262621516528652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(927) := '4174286929293B29692B2B3B696628693D3D3D742972657475726E605C5C5C5C247B6F7D5C5C247B652E736C6963652873297D5C5C603B69213D3D732626286E3D605C5C5C5C247B6F7D5C5C247B652E736C69636528732C69297D602C723D69297D7D7D';
wwv_flow_imp.g_varchar2_table(928) := '656C736520723D313B656C73652059652873292626652E63686172436F646541742831293D3D3D48652626286E3D652E736C69636528302C32292C723D322C743E322626516528652E63686172436F6465417428322929262628693D21302C723D332929';
wwv_flow_imp.g_varchar2_table(929) := '3B6C6574206F3D723C743F657428652E736C6963652872292C21692C225C5C222C5165293A22223B72657475726E2030213D3D6F2E6C656E6774687C7C697C7C286F3D222E22292C6F2E6C656E6774683E302626516528652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(930) := '742D3129292626286F2B3D225C5C22292C766F696420303D3D3D6E3F693F605C5C247B6F7D603A6F3A693F60247B6E7D5C5C247B6F7D603A60247B6E7D247B6F7D607D2C69734162736F6C7574652865297B4A6528652C227061746822293B636F6E7374';
wwv_flow_imp.g_varchar2_table(931) := '20743D652E6C656E6774683B696628303D3D3D742972657475726E21313B636F6E7374206E3D652E63686172436F646541742830293B72657475726E205165286E297C7C743E3226265965286E292626652E63686172436F646541742831293D3D3D4865';
wwv_flow_imp.g_varchar2_table(932) := '2626516528652E63686172436F64654174283229297D2C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420742C6E3B666F72286C657420723D303B723C652E6C656E6774683B2B2B72297B636F6E73';
wwv_flow_imp.g_varchar2_table(933) := '7420693D655B725D3B4A6528692C227061746822292C692E6C656E6774683E30262628766F696420303D3D3D743F743D6E3D693A742B3D605C5C247B697D60297D696628766F696420303D3D3D742972657475726E222E223B6C657420723D21302C693D';
wwv_flow_imp.g_varchar2_table(934) := '303B69662822737472696E67223D3D747970656F66206E26265165286E2E63686172436F6465417428302929297B2B2B693B636F6E737420653D6E2E6C656E6774683B653E3126265165286E2E63686172436F64654174283129292626282B2B692C653E';
wwv_flow_imp.g_varchar2_table(935) := '322626285165286E2E63686172436F64654174283229293F2B2B693A723D213129297D69662872297B666F72283B693C742E6C656E6774682626516528742E63686172436F64654174286929293B29692B2B3B693E3D32262628743D605C5C247B742E73';
wwv_flow_imp.g_varchar2_table(936) := '6C6963652869297D60297D72657475726E206E742E6E6F726D616C697A652874297D2C72656C617469766528652C74297B6966284A6528652C2266726F6D22292C4A6528742C22746F22292C653D3D3D742972657475726E22223B636F6E7374206E3D6E';
wwv_flow_imp.g_varchar2_table(937) := '742E7265736F6C76652865292C723D6E742E7265736F6C76652874293B6966286E3D3D3D722972657475726E22223B69662828653D6E2E746F4C6F776572436173652829293D3D3D28743D722E746F4C6F776572436173652829292972657475726E2222';
wwv_flow_imp.g_varchar2_table(938) := '3B6C657420693D303B666F72283B693C652E6C656E6774682626652E63686172436F646541742869293D3D3D7A653B29692B2B3B6C657420733D652E6C656E6774683B666F72283B732D313E692626652E63686172436F6465417428732D31293D3D3D7A';
wwv_flow_imp.g_varchar2_table(939) := '653B29732D2D3B636F6E7374206F3D732D693B6C657420613D303B666F72283B613C742E6C656E6774682626742E63686172436F646541742861293D3D3D7A653B29612B2B3B6C6574206C3D742E6C656E6774683B666F72283B6C2D313E612626742E63';
wwv_flow_imp.g_varchar2_table(940) := '686172436F64654174286C2D31293D3D3D7A653B296C2D2D3B636F6E737420753D6C2D612C633D6F3C753F6F3A753B6C657420683D2D312C643D303B666F72283B643C633B642B2B297B636F6E7374206E3D652E63686172436F6465417428692B64293B';
wwv_flow_imp.g_varchar2_table(941) := '6966286E213D3D742E63686172436F6465417428612B642929627265616B3B6E3D3D3D7A65262628683D64297D69662864213D3D63297B6966282D313D3D3D682972657475726E20727D656C73657B696628753E63297B696628742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(942) := '417428612B64293D3D3D7A652972657475726E20722E736C69636528612B642B31293B696628323D3D3D642972657475726E20722E736C69636528612B64297D6F3E63262628652E63686172436F6465417428692B64293D3D3D7A653F683D643A323D3D';
wwv_flow_imp.g_varchar2_table(943) := '3D64262628683D3329292C2D313D3D3D68262628683D30297D6C657420663D22223B666F7228643D692B682B313B643C3D733B2B2B642964213D3D732626652E63686172436F64654174286429213D3D7A657C7C28662B3D303D3D3D662E6C656E677468';
wwv_flow_imp.g_varchar2_table(944) := '3F222E2E223A225C5C2E2E22293B72657475726E20612B3D682C662E6C656E6774683E303F60247B667D247B722E736C69636528612C6C297D603A28722E63686172436F646541742861293D3D3D7A6526262B2B612C722E736C69636528612C6C29297D';
wwv_flow_imp.g_varchar2_table(945) := '2C746F4E616D65737061636564506174682865297B69662822737472696E6722213D747970656F6620657C7C303D3D3D652E6C656E6774682972657475726E20653B636F6E737420743D6E742E7265736F6C76652865293B696628742E6C656E6774683C';
wwv_flow_imp.g_varchar2_table(946) := '3D322972657475726E20653B696628742E63686172436F646541742830293D3D3D7A65297B696628742E63686172436F646541742831293D3D3D7A65297B636F6E737420653D742E63686172436F646541742832293B6966283633213D3D65262665213D';
wwv_flow_imp.g_varchar2_table(947) := '3D24652972657475726E605C5C5C5C3F5C5C554E435C5C247B742E736C6963652832297D607D7D656C736520696628596528742E63686172436F64654174283029292626742E63686172436F646541742831293D3D3D48652626742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(948) := '41742832293D3D3D7A652972657475726E605C5C5C5C3F5C5C247B747D603B72657475726E20657D2C6469726E616D652865297B4A6528652C227061746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E222E22';
wwv_flow_imp.g_varchar2_table(949) := '3B6C6574206E3D2D312C723D303B636F6E737420693D652E63686172436F646541742830293B696628313D3D3D742972657475726E2051652869293F653A222E223B6966285165286929297B6966286E3D723D312C516528652E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(950) := '28312929297B6C657420693D322C733D693B666F72283B693C74262621516528652E63686172436F64654174286929293B29692B2B3B696628693C74262669213D3D73297B666F7228733D693B693C742626516528652E63686172436F64654174286929';
wwv_flow_imp.g_varchar2_table(951) := '293B29692B2B3B696628693C74262669213D3D73297B666F7228733D693B693C74262621516528652E63686172436F64654174286929293B29692B2B3B696628693D3D3D742972657475726E20653B69213D3D732626286E3D723D692B31297D7D7D7D65';
wwv_flow_imp.g_varchar2_table(952) := '6C73652059652869292626652E63686172436F646541742831293D3D3D48652626286E3D743E322626516528652E63686172436F64654174283229293F333A322C723D6E293B6C657420733D2D312C6F3D21303B666F72286C6574206E3D742D313B6E3E';
wwv_flow_imp.g_varchar2_table(953) := '3D723B2D2D6E29696628516528652E63686172436F64654174286E2929297B696628216F297B733D6E3B627265616B7D7D656C7365206F3D21313B6966282D313D3D3D73297B6966282D313D3D3D6E2972657475726E222E223B733D6E7D72657475726E';
wwv_flow_imp.g_varchar2_table(954) := '20652E736C69636528302C73297D2C626173656E616D6528652C74297B766F69642030213D3D7426264A6528742C2265787422292C4A6528652C227061746822293B6C6574206E2C723D302C693D2D312C733D21303B696628652E6C656E6774683E3D32';
wwv_flow_imp.g_varchar2_table(955) := '2626596528652E63686172436F64654174283029292626652E63686172436F646541742831293D3D3D4865262628723D32292C766F69642030213D3D742626742E6C656E6774683E302626742E6C656E6774683C3D652E6C656E677468297B696628743D';
wwv_flow_imp.g_varchar2_table(956) := '3D3D652972657475726E22223B6C6574206F3D742E6C656E6774682D312C613D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D723B2D2D6E297B636F6E7374206C3D652E63686172436F64654174286E293B6966285165286C29297B69662821';
wwv_flow_imp.g_varchar2_table(957) := '73297B723D6E2B313B627265616B7D7D656C73652D313D3D3D61262628733D21312C613D6E2B31292C6F3E3D302626286C3D3D3D742E63686172436F64654174286F293F2D313D3D2D2D6F262628693D6E293A286F3D2D312C693D6129297D7265747572';
wwv_flow_imp.g_varchar2_table(958) := '6E20723D3D3D693F693D613A2D313D3D3D69262628693D652E6C656E677468292C652E736C69636528722C69297D666F72286E3D652E6C656E6774682D313B6E3E3D723B2D2D6E29696628516528652E63686172436F64654174286E2929297B69662821';
wwv_flow_imp.g_varchar2_table(959) := '73297B723D6E2B313B627265616B7D7D656C73652D313D3D3D69262628733D21312C693D6E2B31293B72657475726E2D313D3D3D693F22223A652E736C69636528722C69297D2C6578746E616D652865297B4A6528652C227061746822293B6C65742074';
wwv_flow_imp.g_varchar2_table(960) := '3D302C6E3D2D312C723D302C693D2D312C733D21302C6F3D303B652E6C656E6774683E3D322626652E63686172436F646541742831293D3D3D48652626596528652E63686172436F6465417428302929262628743D723D32293B666F72286C657420613D';
wwv_flow_imp.g_varchar2_table(961) := '652E6C656E6774682D313B613E3D743B2D2D61297B636F6E737420743D652E63686172436F646541742861293B6966285165287429297B6966282173297B723D612B313B627265616B7D7D656C73652D313D3D3D69262628733D21312C693D612B31292C';
wwv_flow_imp.g_varchar2_table(962) := '743D3D3D24653F2D313D3D3D6E3F6E3D613A31213D3D6F2626286F3D31293A2D31213D3D6E2626286F3D2D31297D72657475726E2D313D3D3D6E7C7C2D313D3D3D697C7C303D3D3D6F7C7C313D3D3D6F26266E3D3D3D692D3126266E3D3D3D722B313F22';
wwv_flow_imp.g_varchar2_table(963) := '223A652E736C696365286E2C69297D2C666F726D61743A74742E62696E64286E756C6C2C225C5C22292C70617273652865297B4A6528652C227061746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A';
wwv_flow_imp.g_varchar2_table(964) := '22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E6C656E6774683B6C657420723D302C693D652E63686172436F646541742830293B696628313D3D3D6E2972657475726E2051652869';
wwv_flow_imp.g_varchar2_table(965) := '293F28742E726F6F743D742E6469723D652C74293A28742E626173653D742E6E616D653D652C74293B6966285165286929297B696628723D312C516528652E63686172436F6465417428312929297B6C657420743D322C693D743B666F72283B743C6E26';
wwv_flow_imp.g_varchar2_table(966) := '2621516528652E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D69297B666F7228693D743B743C6E2626516528652E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D69297B666F722869';
wwv_flow_imp.g_varchar2_table(967) := '3D743B743C6E262621516528652E63686172436F64654174287429293B29742B2B3B743D3D3D6E3F723D743A74213D3D69262628723D742B31297D7D7D7D656C73652069662859652869292626652E63686172436F646541742831293D3D3D4865297B69';
wwv_flow_imp.g_varchar2_table(968) := '66286E3C3D322972657475726E20742E726F6F743D742E6469723D652C743B696628723D322C516528652E63686172436F6465417428322929297B696628333D3D3D6E2972657475726E20742E726F6F743D742E6469723D652C743B723D337D7D723E30';
wwv_flow_imp.g_varchar2_table(969) := '262628742E726F6F743D652E736C69636528302C7229293B6C657420733D2D312C6F3D722C613D2D312C6C3D21302C753D652E6C656E6774682D312C633D303B666F72283B753E3D723B2D2D7529696628693D652E63686172436F646541742875292C51';
wwv_flow_imp.g_varchar2_table(970) := '65286929297B696628216C297B6F3D752B313B627265616B7D7D656C73652D313D3D3D612626286C3D21312C613D752B31292C693D3D3D24653F2D313D3D3D733F733D753A31213D3D63262628633D31293A2D31213D3D73262628633D2D31293B726574';
wwv_flow_imp.g_varchar2_table(971) := '75726E2D31213D3D612626282D313D3D3D737C7C303D3D3D637C7C313D3D3D632626733D3D3D612D312626733D3D3D6F2B313F742E626173653D742E6E616D653D652E736C696365286F2C61293A28742E6E616D653D652E736C696365286F2C73292C74';
wwv_flow_imp.g_varchar2_table(972) := '2E626173653D652E736C696365286F2C61292C742E6578743D652E736C69636528732C612929292C742E6469723D6F3E3026266F213D3D723F652E736C69636528302C6F2D31293A742E726F6F742C747D2C7365703A225C5C222C64656C696D69746572';
wwv_flow_imp.g_varchar2_table(973) := '3A223B222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D2C72743D2828293D3E7B6966285865297B636F6E737420653D2F5C5C2F673B72657475726E28293D3E7B636F6E737420743D6A6528292E7265706C61636528652C222F22293B726574';
wwv_flow_imp.g_varchar2_table(974) := '75726E20742E736C69636528742E696E6465784F6628222F2229297D7D72657475726E28293D3E6A6528297D2928292C69743D7B7265736F6C7665282E2E2E65297B6C657420743D22222C6E3D21313B666F72286C657420723D652E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(975) := '3B723E3D2D312626216E3B722D2D297B636F6E737420693D723E3D303F655B725D3A727428293B4A6528692C227061746822292C30213D3D692E6C656E677468262628743D60247B697D2F247B747D602C6E3D692E63686172436F646541742830293D3D';
wwv_flow_imp.g_varchar2_table(976) := '3D5765297D72657475726E20743D657428742C216E2C222F222C5A65292C6E3F602F247B747D603A742E6C656E6774683E303F743A222E227D2C6E6F726D616C697A652865297B6966284A6528652C227061746822292C303D3D3D652E6C656E67746829';
wwv_flow_imp.g_varchar2_table(977) := '72657475726E222E223B636F6E737420743D652E63686172436F646541742830293D3D3D57652C6E3D652E63686172436F6465417428652E6C656E6774682D31293D3D3D57653B72657475726E20303D3D3D28653D657428652C21742C222F222C5A6529';
wwv_flow_imp.g_varchar2_table(978) := '292E6C656E6774683F743F222F223A6E3F222E2F223A222E223A286E262628652B3D222F22292C743F602F247B657D603A65297D2C69734162736F6C7574653A653D3E284A6528652C227061746822292C652E6C656E6774683E302626652E6368617243';
wwv_flow_imp.g_varchar2_table(979) := '6F646541742830293D3D3D5765292C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420743B666F72286C6574206E3D303B6E3C652E6C656E6774683B2B2B6E297B636F6E737420723D655B6E5D3B4A';
wwv_flow_imp.g_varchar2_table(980) := '6528722C227061746822292C722E6C656E6774683E30262628766F696420303D3D3D743F743D723A742B3D602F247B727D60297D72657475726E20766F696420303D3D3D743F222E223A69742E6E6F726D616C697A652874297D2C72656C617469766528';
wwv_flow_imp.g_varchar2_table(981) := '652C74297B6966284A6528652C2266726F6D22292C4A6528742C22746F22292C653D3D3D742972657475726E22223B69662828653D69742E7265736F6C7665286529293D3D3D28743D69742E7265736F6C7665287429292972657475726E22223B636F6E';
wwv_flow_imp.g_varchar2_table(982) := '7374206E3D652E6C656E6774682C723D6E2D312C693D742E6C656E6774682D312C733D723C693F723A693B6C6574206F3D2D312C613D303B666F72283B613C733B612B2B297B636F6E7374206E3D652E63686172436F6465417428312B61293B6966286E';
wwv_flow_imp.g_varchar2_table(983) := '213D3D742E63686172436F6465417428312B612929627265616B3B6E3D3D3D57652626286F3D61297D696628613D3D3D7329696628693E73297B696628742E63686172436F6465417428312B61293D3D3D57652972657475726E20742E736C6963652831';
wwv_flow_imp.g_varchar2_table(984) := '2B612B31293B696628303D3D3D612972657475726E20742E736C69636528312B61297D656C736520723E73262628652E63686172436F6465417428312B61293D3D3D57653F6F3D613A303D3D3D612626286F3D3029293B6C6574206C3D22223B666F7228';
wwv_flow_imp.g_varchar2_table(985) := '613D312B6F2B313B613C3D6E3B2B2B612961213D3D6E2626652E63686172436F64654174286129213D3D57657C7C286C2B3D303D3D3D6C2E6C656E6774683F222E2E223A222F2E2E22293B72657475726E60247B6C7D247B742E736C69636528312B6F29';
wwv_flow_imp.g_varchar2_table(986) := '7D607D2C746F4E616D65737061636564506174683A653D3E652C6469726E616D652865297B6966284A6528652C227061746822292C303D3D3D652E6C656E6774682972657475726E222E223B636F6E737420743D652E63686172436F646541742830293D';
wwv_flow_imp.g_varchar2_table(987) := '3D3D57653B6C6574206E3D2D312C723D21303B666F72286C657420743D652E6C656E6774682D313B743E3D313B2D2D7429696628652E63686172436F646541742874293D3D3D5765297B6966282172297B6E3D743B627265616B7D7D656C736520723D21';
wwv_flow_imp.g_varchar2_table(988) := '313B72657475726E2D313D3D3D6E3F743F222F223A222E223A742626313D3D3D6E3F222F2F223A652E736C69636528302C6E297D2C626173656E616D6528652C74297B766F69642030213D3D7426264A6528742C2265787422292C4A6528652C22706174';
wwv_flow_imp.g_varchar2_table(989) := '6822293B6C6574206E2C723D302C693D2D312C733D21303B696628766F69642030213D3D742626742E6C656E6774683E302626742E6C656E6774683C3D652E6C656E677468297B696628743D3D3D652972657475726E22223B6C6574206F3D742E6C656E';
wwv_flow_imp.g_varchar2_table(990) := '6774682D312C613D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E297B636F6E7374206C3D652E63686172436F64654174286E293B6966286C3D3D3D5765297B6966282173297B723D6E2B313B627265616B7D7D656C73652D313D';
wwv_flow_imp.g_varchar2_table(991) := '3D3D61262628733D21312C613D6E2B31292C6F3E3D302626286C3D3D3D742E63686172436F64654174286F293F2D313D3D2D2D6F262628693D6E293A286F3D2D312C693D6129297D72657475726E20723D3D3D693F693D613A2D313D3D3D69262628693D';
wwv_flow_imp.g_varchar2_table(992) := '652E6C656E677468292C652E736C69636528722C69297D666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E29696628652E63686172436F64654174286E293D3D3D5765297B6966282173297B723D6E2B313B627265616B7D7D656C73652D31';
wwv_flow_imp.g_varchar2_table(993) := '3D3D3D69262628733D21312C693D6E2B31293B72657475726E2D313D3D3D693F22223A652E736C69636528722C69297D2C6578746E616D652865297B4A6528652C227061746822293B6C657420743D2D312C6E3D302C723D2D312C693D21302C733D303B';
wwv_flow_imp.g_varchar2_table(994) := '666F72286C6574206F3D652E6C656E6774682D313B6F3E3D303B2D2D6F297B636F6E737420613D652E63686172436F64654174286F293B69662861213D3D5765292D313D3D3D72262628693D21312C723D6F2B31292C613D3D3D24653F2D313D3D3D743F';
wwv_flow_imp.g_varchar2_table(995) := '743D6F3A31213D3D73262628733D31293A2D31213D3D74262628733D2D31293B656C7365206966282169297B6E3D6F2B313B627265616B7D7D72657475726E2D313D3D3D747C7C2D313D3D3D727C7C303D3D3D737C7C313D3D3D732626743D3D3D722D31';
wwv_flow_imp.g_varchar2_table(996) := '2626743D3D3D6E2B313F22223A652E736C69636528742C72297D2C666F726D61743A74742E62696E64286E756C6C2C222F22292C70617273652865297B4A6528652C227061746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C6261';
wwv_flow_imp.g_varchar2_table(997) := '73653A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E63686172436F646541742830293D3D3D57653B6C657420723B6E3F28742E726F6F743D222F222C723D3129';
wwv_flow_imp.g_varchar2_table(998) := '3A723D303B6C657420693D2D312C733D302C6F3D2D312C613D21302C6C3D652E6C656E6774682D312C753D303B666F72283B6C3E3D723B2D2D6C297B636F6E737420743D652E63686172436F64654174286C293B69662874213D3D5765292D313D3D3D6F';
wwv_flow_imp.g_varchar2_table(999) := '262628613D21312C6F3D6C2B31292C743D3D3D24653F2D313D3D3D693F693D6C3A31213D3D75262628753D31293A2D31213D3D69262628753D2D31293B656C7365206966282161297B733D6C2B313B627265616B7D7D6966282D31213D3D6F297B636F6E';
wwv_flow_imp.g_varchar2_table(1000) := '737420723D303D3D3D7326266E3F313A733B2D313D3D3D697C7C303D3D3D757C7C313D3D3D752626693D3D3D6F2D312626693D3D3D732B313F742E626173653D742E6E616D653D652E736C69636528722C6F293A28742E6E616D653D652E736C69636528';
wwv_flow_imp.g_varchar2_table(1001) := '722C69292C742E626173653D652E736C69636528722C6F292C742E6578743D652E736C69636528692C6F29297D72657475726E20733E303F742E6469723D652E736C69636528302C732D31293A6E262628742E6469723D222F22292C747D2C7365703A22';
wwv_flow_imp.g_varchar2_table(1002) := '2F222C64656C696D697465723A223A222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D3B69742E77696E33323D6E742E77696E33323D6E742C69742E706F7369783D6E742E706F7369783D69742C58653F6E742E6E6F726D616C697A653A6974';
wwv_flow_imp.g_varchar2_table(1003) := '2E6E6F726D616C697A652C58653F6E742E7265736F6C76653A69742E7265736F6C76652C58653F6E742E72656C61746976653A69742E72656C61746976652C58653F6E742E6469726E616D653A69742E6469726E616D652C58653F6E742E626173656E61';
wwv_flow_imp.g_varchar2_table(1004) := '6D653A69742E626173656E616D652C58653F6E742E6578746E616D653A69742E6578746E616D652C58653F6E742E7365703A69742E7365703B636F6E73742073743D2F5E5C775B5C775C642B2E2D5D2A242F2C6F743D2F5E5C2F2F2C61743D2F5E5C2F5C';
wwv_flow_imp.g_varchar2_table(1005) := '2F2F2C6C743D22222C75743D222F222C63743D2F5E28285B5E3A2F3F235D2B3F293A293F285C2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A29293F2823282E2A29293F2F3B636C6173732068747B737461746963206973';
wwv_flow_imp.g_varchar2_table(1006) := '5572692865297B72657475726E206520696E7374616E63656F662068747C7C212165262622737472696E67223D3D747970656F6620652E617574686F72697479262622737472696E67223D3D747970656F6620652E667261676D656E7426262273747269';
wwv_flow_imp.g_varchar2_table(1007) := '6E67223D3D747970656F6620652E70617468262622737472696E67223D3D747970656F6620652E7175657279262622737472696E67223D3D747970656F6620652E736368656D65262622737472696E67223D3D747970656F6620652E6673506174682626';
wwv_flow_imp.g_varchar2_table(1008) := '2266756E6374696F6E223D3D747970656F6620652E7769746826262266756E6374696F6E223D3D747970656F6620652E746F537472696E677D636F6E7374727563746F7228652C742C6E2C722C692C733D2131297B226F626A656374223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1009) := '6620653F28746869732E736368656D653D652E736368656D657C7C6C742C746869732E617574686F726974793D652E617574686F726974797C7C6C742C746869732E706174683D652E706174687C7C6C742C746869732E71756572793D652E7175657279';
wwv_flow_imp.g_varchar2_table(1010) := '7C7C6C742C746869732E667261676D656E743D652E667261676D656E747C7C6C74293A28746869732E736368656D653D66756E6374696F6E28652C74297B72657475726E20657C7C743F653A2266696C65227D28652C73292C746869732E617574686F72';
wwv_flow_imp.g_varchar2_table(1011) := '6974793D747C7C6C742C746869732E706174683D66756E6374696F6E28652C74297B7377697463682865297B63617365226874747073223A636173652268747470223A636173652266696C65223A743F745B305D213D3D7574262628743D75742B74293A';
wwv_flow_imp.g_varchar2_table(1012) := '743D75747D72657475726E20747D28746869732E736368656D652C6E7C7C6C74292C746869732E71756572793D727C7C6C742C746869732E667261676D656E743D697C7C6C742C66756E6374696F6E28652C74297B69662821652E736368656D65262674';
wwv_flow_imp.g_varchar2_table(1013) := '297468726F77206E6577204572726F7228605B5572694572726F725D3A20536368656D65206973206D697373696E673A207B736368656D653A2022222C20617574686F726974793A2022247B652E617574686F726974797D222C20706174683A2022247B';
wwv_flow_imp.g_varchar2_table(1014) := '652E706174687D222C2071756572793A2022247B652E71756572797D222C20667261676D656E743A2022247B652E667261676D656E747D227D60293B696628652E736368656D6526262173742E7465737428652E736368656D6529297468726F77206E65';
wwv_flow_imp.g_varchar2_table(1015) := '77204572726F7228225B5572694572726F725D3A20536368656D6520636F6E7461696E7320696C6C6567616C20636861726163746572732E22293B696628652E7061746829696628652E617574686F72697479297B696628216F742E7465737428652E70';
wwv_flow_imp.g_varchar2_table(1016) := '61746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920636F6E7461696E7320616E20617574686F7269747920636F6D706F6E656E742C207468656E20746865207061746820636F6D706F6E656E7420';
wwv_flow_imp.g_varchar2_table(1017) := '6D7573742065697468657220626520656D707479206F7220626567696E2077697468206120736C6173682028222F22292063686172616374657227297D656C73652069662861742E7465737428652E7061746829297468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(1018) := '28275B5572694572726F725D3A20496620612055524920646F6573206E6F7420636F6E7461696E20616E20617574686F7269747920636F6D706F6E656E742C207468656E2074686520706174682063616E6E6F7420626567696E20776974682074776F20';
wwv_flow_imp.g_varchar2_table(1019) := '736C61736820636861726163746572732028222F2F222927297D28746869732C7329297D6765742066735061746828297B72657475726E20767428746869732C2131297D776974682865297B69662821652972657475726E20746869733B6C65747B7363';
wwv_flow_imp.g_varchar2_table(1020) := '68656D653A742C617574686F726974793A6E2C706174683A722C71756572793A692C667261676D656E743A737D3D653B72657475726E20766F696420303D3D3D743F743D746869732E736368656D653A6E756C6C3D3D3D74262628743D6C74292C766F69';
wwv_flow_imp.g_varchar2_table(1021) := '6420303D3D3D6E3F6E3D746869732E617574686F726974793A6E756C6C3D3D3D6E2626286E3D6C74292C766F696420303D3D3D723F723D746869732E706174683A6E756C6C3D3D3D72262628723D6C74292C766F696420303D3D3D693F693D746869732E';
wwv_flow_imp.g_varchar2_table(1022) := '71756572793A6E756C6C3D3D3D69262628693D6C74292C766F696420303D3D3D733F733D746869732E667261676D656E743A6E756C6C3D3D3D73262628733D6C74292C743D3D3D746869732E736368656D6526266E3D3D3D746869732E617574686F7269';
wwv_flow_imp.g_varchar2_table(1023) := '74792626723D3D3D746869732E706174682626693D3D3D746869732E71756572792626733D3D3D746869732E667261676D656E743F746869733A6E657720667428742C6E2C722C692C73297D73746174696320706172736528652C743D2131297B636F6E';
wwv_flow_imp.g_varchar2_table(1024) := '7374206E3D63742E657865632865293B72657475726E206E3F6E6577206674286E5B325D7C7C6C742C4374286E5B345D7C7C6C74292C4374286E5B355D7C7C6C74292C4374286E5B375D7C7C6C74292C4374286E5B395D7C7C6C74292C74293A6E657720';
wwv_flow_imp.g_varchar2_table(1025) := '6674286C742C6C742C6C742C6C742C6C74297D7374617469632066696C652865297B6C657420743D6C743B6966286565262628653D652E7265706C616365282F5C5C2F672C757429292C655B305D3D3D3D75742626655B315D3D3D3D7574297B636F6E73';
wwv_flow_imp.g_varchar2_table(1026) := '74206E3D652E696E6465784F662875742C32293B2D313D3D3D6E3F28743D652E737562737472696E672832292C653D7574293A28743D652E737562737472696E6728322C6E292C653D652E737562737472696E67286E297C7C7574297D72657475726E20';
wwv_flow_imp.g_varchar2_table(1027) := '6E6577206674282266696C65222C742C652C6C742C6C74297D7374617469632066726F6D28652C74297B72657475726E206E657720667428652E736368656D652C652E617574686F726974792C652E706174682C652E71756572792C652E667261676D65';
wwv_flow_imp.g_varchar2_table(1028) := '6E742C74297D737461746963206A6F696E5061746828652C2E2E2E74297B69662821652E70617468297468726F77206E6577204572726F7228225B5572694572726F725D3A2063616E6E6F742063616C6C206A6F696E50617468206F6E20555249207769';
wwv_flow_imp.g_varchar2_table(1029) := '74686F7574207061746822293B6C6574206E3B72657475726E206E3D656526262266696C65223D3D3D652E736368656D653F68742E66696C65286E742E6A6F696E28767428652C2130292C2E2E2E7429292E706174683A69742E6A6F696E28652E706174';
wwv_flow_imp.g_varchar2_table(1030) := '682C2E2E2E74292C652E77697468287B706174683A6E7D297D746F537472696E6728653D2131297B72657475726E20627428746869732C65297D746F4A534F4E28297B72657475726E20746869737D737461746963207265766976652865297B76617220';
wwv_flow_imp.g_varchar2_table(1031) := '742C6E3B69662865297B6966286520696E7374616E63656F662068742972657475726E20653B7B636F6E737420723D6E65772066742865293B72657475726E20722E5F666F726D61747465643D6E756C6C213D3D28743D652E65787465726E616C292626';
wwv_flow_imp.g_varchar2_table(1032) := '766F69642030213D3D743F743A6E756C6C2C722E5F6673506174683D652E5F7365703D3D3D647426266E756C6C213D3D286E3D652E667350617468292626766F69642030213D3D6E3F6E3A6E756C6C2C727D7D72657475726E20657D7D636F6E73742064';
wwv_flow_imp.g_varchar2_table(1033) := '743D65653F313A766F696420303B636C61737320667420657874656E64732068747B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F666F726D61747465643D6E756C6C2C746869732E5F6673506174';
wwv_flow_imp.g_varchar2_table(1034) := '683D6E756C6C7D6765742066735061746828297B72657475726E20746869732E5F6673506174687C7C28746869732E5F6673506174683D767428746869732C213129292C746869732E5F6673506174687D746F537472696E6728653D2131297B72657475';
wwv_flow_imp.g_varchar2_table(1035) := '726E20653F627428746869732C2130293A28746869732E5F666F726D61747465647C7C28746869732E5F666F726D61747465643D627428746869732C213129292C746869732E5F666F726D6174746564297D746F4A534F4E28297B636F6E737420653D7B';
wwv_flow_imp.g_varchar2_table(1036) := '246D69643A317D3B72657475726E20746869732E5F667350617468262628652E6673506174683D746869732E5F6673506174682C652E5F7365703D6474292C746869732E5F666F726D6174746564262628652E65787465726E616C3D746869732E5F666F';
wwv_flow_imp.g_varchar2_table(1037) := '726D6174746564292C746869732E70617468262628652E706174683D746869732E70617468292C746869732E736368656D65262628652E736368656D653D746869732E736368656D65292C746869732E617574686F72697479262628652E617574686F72';
wwv_flow_imp.g_varchar2_table(1038) := '6974793D746869732E617574686F72697479292C746869732E7175657279262628652E71756572793D746869732E7175657279292C746869732E667261676D656E74262628652E667261676D656E743D746869732E667261676D656E74292C657D7D636F';
wwv_flow_imp.g_varchar2_table(1039) := '6E7374206D743D7B35383A22253341222C34373A22253246222C36333A22253346222C33353A22253233222C39313A22253542222C39333A22253544222C36343A22253430222C33333A22253231222C33363A22253234222C33383A22253236222C3339';
wwv_flow_imp.g_varchar2_table(1040) := '3A22253237222C34303A22253238222C34313A22253239222C34323A22253241222C34333A22253242222C34343A22253243222C35393A22253342222C36313A22253344222C33323A22253230227D3B66756E6374696F6E20677428652C742C6E297B6C';
wwv_flow_imp.g_varchar2_table(1041) := '657420722C693D2D313B666F72286C657420733D303B733C652E6C656E6774683B732B2B297B636F6E7374206F3D652E63686172436F646541742873293B6966286F3E3D393726266F3C3D3132327C7C6F3E3D363526266F3C3D39307C7C6F3E3D343826';
wwv_flow_imp.g_varchar2_table(1042) := '266F3C3D35377C7C34353D3D3D6F7C7C34363D3D3D6F7C7C39353D3D3D6F7C7C3132363D3D3D6F7C7C74262634373D3D3D6F7C7C6E262639313D3D3D6F7C7C6E262639333D3D3D6F7C7C6E262635383D3D3D6F292D31213D3D69262628722B3D656E636F';
wwv_flow_imp.g_varchar2_table(1043) := '6465555249436F6D706F6E656E7428652E737562737472696E6728692C7329292C693D2D31292C766F69642030213D3D72262628722B3D652E636861724174287329293B656C73657B766F696420303D3D3D72262628723D652E73756273747228302C73';
wwv_flow_imp.g_varchar2_table(1044) := '29293B636F6E737420743D6D745B6F5D3B766F69642030213D3D743F282D31213D3D69262628722B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728692C7329292C693D2D31292C722B3D74293A2D313D3D3D6926262869';
wwv_flow_imp.g_varchar2_table(1045) := '3D73297D7D72657475726E2D31213D3D69262628722B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728692929292C766F69642030213D3D723F723A657D66756E6374696F6E2070742865297B6C657420743B666F72286C';
wwv_flow_imp.g_varchar2_table(1046) := '6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B636F6E737420723D652E63686172436F64654174286E293B33353D3D3D727C7C36333D3D3D723F28766F696420303D3D3D74262628743D652E73756273747228302C6E29292C742B3D6D745B72';
wwv_flow_imp.g_varchar2_table(1047) := '5D293A766F69642030213D3D74262628742B3D655B6E5D297D72657475726E20766F69642030213D3D743F743A657D66756E6374696F6E20767428652C74297B6C6574206E3B72657475726E206E3D652E617574686F726974792626652E706174682E6C';
wwv_flow_imp.g_varchar2_table(1048) := '656E6774683E3126262266696C65223D3D3D652E736368656D653F602F2F247B652E617574686F726974797D247B652E706174687D603A34373D3D3D652E706174682E63686172436F64654174283029262628652E706174682E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(1049) := '2831293E3D36352626652E706174682E63686172436F646541742831293C3D39307C7C652E706174682E63686172436F646541742831293E3D39372626652E706174682E63686172436F646541742831293C3D31323229262635383D3D3D652E70617468';
wwv_flow_imp.g_varchar2_table(1050) := '2E63686172436F646541742832293F743F652E706174682E7375627374722831293A652E706174685B315D2E746F4C6F7765724361736528292B652E706174682E7375627374722832293A652E706174682C65652626286E3D6E2E7265706C616365282F';
wwv_flow_imp.g_varchar2_table(1051) := '5C2F2F672C225C5C2229292C6E7D66756E6374696F6E20627428652C74297B636F6E7374206E3D743F70743A67743B6C657420723D22222C7B736368656D653A692C617574686F726974793A732C706174683A6F2C71756572793A612C667261676D656E';
wwv_flow_imp.g_varchar2_table(1052) := '743A6C7D3D653B69662869262628722B3D692C722B3D223A22292C28737C7C2266696C65223D3D3D6929262628722B3D75742C722B3D7574292C73297B6C657420653D732E696E6465784F6628224022293B6966282D31213D3D65297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(1053) := '3D732E73756273747228302C65293B733D732E73756273747228652B31292C653D742E6C617374496E6465784F6628223A22292C2D313D3D3D653F722B3D6E28742C21312C2131293A28722B3D6E28742E73756273747228302C65292C21312C2131292C';
wwv_flow_imp.g_varchar2_table(1054) := '722B3D223A222C722B3D6E28742E73756273747228652B31292C21312C213029292C722B3D2240227D733D732E746F4C6F7765724361736528292C653D732E6C617374496E6465784F6628223A22292C2D313D3D3D653F722B3D6E28732C21312C213029';
wwv_flow_imp.g_varchar2_table(1055) := '3A28722B3D6E28732E73756273747228302C65292C21312C2130292C722B3D732E737562737472286529297D6966286F297B6966286F2E6C656E6774683E3D33262634373D3D3D6F2E63686172436F64654174283029262635383D3D3D6F2E6368617243';
wwv_flow_imp.g_varchar2_table(1056) := '6F64654174283229297B636F6E737420653D6F2E63686172436F646541742831293B653E3D36352626653C3D39302626286F3D602F247B537472696E672E66726F6D43686172436F646528652B3332297D3A247B6F2E7375627374722833297D60297D65';
wwv_flow_imp.g_varchar2_table(1057) := '6C7365206966286F2E6C656E6774683E3D32262635383D3D3D6F2E63686172436F64654174283129297B636F6E737420653D6F2E63686172436F646541742830293B653E3D36352626653C3D39302626286F3D60247B537472696E672E66726F6D436861';
wwv_flow_imp.g_varchar2_table(1058) := '72436F646528652B3332297D3A247B6F2E7375627374722832297D60297D722B3D6E286F2C21302C2131297D72657475726E2061262628722B3D223F222C722B3D6E28612C21312C213129292C6C262628722B3D2223222C722B3D743F6C3A6774286C2C';
wwv_flow_imp.g_varchar2_table(1059) := '21312C213129292C727D66756E6374696F6E2079742865297B7472797B72657475726E206465636F6465555249436F6D706F6E656E742865297D63617463682874297B72657475726E20652E6C656E6774683E333F652E73756273747228302C33292B79';
wwv_flow_imp.g_varchar2_table(1060) := '7428652E737562737472283329293A657D7D636F6E7374205F743D2F28255B302D39412D5A612D7A5D5B302D39412D5A612D7A5D292B2F673B66756E6374696F6E2043742865297B72657475726E20652E6D61746368285F74293F652E7265706C616365';
wwv_flow_imp.g_varchar2_table(1061) := '285F742C28653D3E797428652929293A657D636C6173732077747B636F6E7374727563746F7228652C74297B746869732E6C696E654E756D6265723D652C746869732E636F6C756D6E3D747D7769746828653D746869732E6C696E654E756D6265722C74';
wwv_flow_imp.g_varchar2_table(1062) := '3D746869732E636F6C756D6E297B72657475726E20653D3D3D746869732E6C696E654E756D6265722626743D3D3D746869732E636F6C756D6E3F746869733A6E657720777428652C74297D64656C746128653D302C743D30297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(1063) := '732E7769746828746869732E6C696E654E756D6265722B652C746869732E636F6C756D6E2B74297D657175616C732865297B72657475726E2077742E657175616C7328746869732C65297D73746174696320657175616C7328652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(1064) := '2165262621747C7C21216526262121742626652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265722626652E636F6C756D6E3D3D3D742E636F6C756D6E7D69734265666F72652865297B72657475726E2077742E69734265666F7265287468';
wwv_flow_imp.g_varchar2_table(1065) := '69732C65297D7374617469632069734265666F726528652C74297B72657475726E20652E6C696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C';
wwv_flow_imp.g_varchar2_table(1066) := '742E636F6C756D6E7D69734265666F72654F72457175616C2865297B72657475726E2077742E69734265666F72654F72457175616C28746869732C65297D7374617469632069734265666F72654F72457175616C28652C74297B72657475726E20652E6C';
wwv_flow_imp.g_varchar2_table(1067) := '696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C3D742E636F6C756D6E7D73746174696320636F6D7061726528652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(1068) := '3D307C652E6C696E654E756D6265722C723D307C742E6C696E654E756D6265723B72657475726E206E3D3D3D723F28307C652E636F6C756D6E292D28307C742E636F6C756D6E293A6E2D727D636C6F6E6528297B72657475726E206E6577207774287468';
wwv_flow_imp.g_varchar2_table(1069) := '69732E6C696E654E756D6265722C746869732E636F6C756D6E297D746F537472696E6728297B72657475726E2228222B746869732E6C696E654E756D6265722B222C222B746869732E636F6C756D6E2B2229227D737461746963206C6966742865297B72';
wwv_flow_imp.g_varchar2_table(1070) := '657475726E206E657720777428652E6C696E654E756D6265722C652E636F6C756D6E297D73746174696320697349506F736974696F6E2865297B72657475726E20652626226E756D626572223D3D747970656F6620652E6C696E654E756D626572262622';
wwv_flow_imp.g_varchar2_table(1071) := '6E756D626572223D3D747970656F6620652E636F6C756D6E7D746F4A534F4E28297B72657475726E7B6C696E654E756D6265723A746869732E6C696E654E756D6265722C636F6C756D6E3A746869732E636F6C756D6E7D7D7D636C6173732053747B636F';
wwv_flow_imp.g_varchar2_table(1072) := '6E7374727563746F7228652C742C6E2C72297B653E6E7C7C653D3D3D6E2626743E723F28746869732E73746172744C696E654E756D6265723D6E2C746869732E7374617274436F6C756D6E3D722C746869732E656E644C696E654E756D6265723D652C74';
wwv_flow_imp.g_varchar2_table(1073) := '6869732E656E64436F6C756D6E3D74293A28746869732E73746172744C696E654E756D6265723D652C746869732E7374617274436F6C756D6E3D742C746869732E656E644C696E654E756D6265723D6E2C746869732E656E64436F6C756D6E3D72297D69';
wwv_flow_imp.g_varchar2_table(1074) := '73456D70747928297B72657475726E2053742E6973456D7074792874686973297D737461746963206973456D7074792865297B72657475726E20652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626652E737461';
wwv_flow_imp.g_varchar2_table(1075) := '7274436F6C756D6E3D3D3D652E656E64436F6C756D6E7D636F6E7461696E73506F736974696F6E2865297B72657475726E2053742E636F6E7461696E73506F736974696F6E28746869732C65297D73746174696320636F6E7461696E73506F736974696F';
wwv_flow_imp.g_varchar2_table(1076) := '6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E654E756D6265723D3D3D652E73746172744C';
wwv_flow_imp.g_varchar2_table(1077) := '696E654E756D6265722626742E636F6C756D6E3C652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E636F6C756D6E3E652E656E64436F6C756D6E297D7374617469632073747269';
wwv_flow_imp.g_varchar2_table(1078) := '6374436F6E7461696E73506F736974696F6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E65';
wwv_flow_imp.g_varchar2_table(1079) := '4E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E636F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E636F6C756D6E3E3D652E656E64';
wwv_flow_imp.g_varchar2_table(1080) := '436F6C756D6E297D636F6E7461696E7352616E67652865297B72657475726E2053742E636F6E7461696E7352616E676528746869732C65297D73746174696320636F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C69';
wwv_flow_imp.g_varchar2_table(1081) := '6E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E';
wwv_flow_imp.g_varchar2_table(1082) := '656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C652E7374617274436F6C756D6E7C7C74';
wwv_flow_imp.g_varchar2_table(1083) := '2E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E656E64436F6C756D6E3E652E656E64436F6C756D6E297D737472696374436F6E7461696E7352616E67652865297B72657475726E2053742E737472696374436F';
wwv_flow_imp.g_varchar2_table(1084) := '6E7461696E7352616E676528746869732C65297D73746174696320737472696374436F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E65';
wwv_flow_imp.g_varchar2_table(1085) := '6E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C';
wwv_flow_imp.g_varchar2_table(1086) := '742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1087) := '65722626742E656E64436F6C756D6E3E3D652E656E64436F6C756D6E297D706C757352616E67652865297B72657475726E2053742E706C757352616E676528746869732C65297D73746174696320706C757352616E676528652C74297B6C6574206E2C72';
wwv_flow_imp.g_varchar2_table(1088) := '2C692C733B72657475726E20742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C723D742E7374617274436F6C756D6E293A742E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(1089) := '6265723D3D3D652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C723D4D6174682E6D696E28742E7374617274436F6C756D6E2C652E7374617274436F6C756D6E29293A286E3D652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(1090) := '4E756D6265722C723D652E7374617274436F6C756D6E292C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265723F28693D742E656E644C696E654E756D6265722C733D742E656E64436F6C756D6E293A742E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(1091) := '756D6265723D3D3D652E656E644C696E654E756D6265723F28693D742E656E644C696E654E756D6265722C733D4D6174682E6D617828742E656E64436F6C756D6E2C652E656E64436F6C756D6E29293A28693D652E656E644C696E654E756D6265722C73';
wwv_flow_imp.g_varchar2_table(1092) := '3D652E656E64436F6C756D6E292C6E6577205374286E2C722C692C73297D696E7465727365637452616E6765732865297B72657475726E2053742E696E7465727365637452616E67657328746869732C65297D73746174696320696E7465727365637452';
wwv_flow_imp.g_varchar2_table(1093) := '616E67657328652C74297B6C6574206E3D652E73746172744C696E654E756D6265722C723D652E7374617274436F6C756D6E2C693D652E656E644C696E654E756D6265722C733D652E656E64436F6C756D6E3B636F6E7374206F3D742E73746172744C69';
wwv_flow_imp.g_varchar2_table(1094) := '6E654E756D6265722C613D742E7374617274436F6C756D6E2C6C3D742E656E644C696E654E756D6265722C753D742E656E64436F6C756D6E3B72657475726E206E3C6F3F286E3D6F2C723D61293A6E3D3D3D6F262628723D4D6174682E6D617828722C61';
wwv_flow_imp.g_varchar2_table(1095) := '29292C693E6C3F28693D6C2C733D75293A693D3D3D6C262628733D4D6174682E6D696E28732C7529292C6E3E697C7C6E3D3D3D692626723E733F6E756C6C3A6E6577205374286E2C722C692C73297D657175616C7352616E67652865297B72657475726E';
wwv_flow_imp.g_varchar2_table(1096) := '2053742E657175616C7352616E676528746869732C65297D73746174696320657175616C7352616E676528652C74297B72657475726E2165262621747C7C21216526262121742626652E73746172744C696E654E756D6265723D3D3D742E73746172744C';
wwv_flow_imp.g_varchar2_table(1097) := '696E654E756D6265722626652E7374617274436F6C756D6E3D3D3D742E7374617274436F6C756D6E2626652E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265722626652E656E64436F6C756D6E3D3D3D742E656E64436F6C75';
wwv_flow_imp.g_varchar2_table(1098) := '6D6E7D676574456E64506F736974696F6E28297B72657475726E2053742E676574456E64506F736974696F6E2874686973297D73746174696320676574456E64506F736974696F6E2865297B72657475726E206E657720777428652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(1099) := '756D6265722C652E656E64436F6C756D6E297D6765745374617274506F736974696F6E28297B72657475726E2053742E6765745374617274506F736974696F6E2874686973297D737461746963206765745374617274506F736974696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(1100) := '7475726E206E657720777428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D746F537472696E6728297B72657475726E225B222B746869732E73746172744C696E654E756D6265722B222C222B746869732E73746172';
wwv_flow_imp.g_varchar2_table(1101) := '74436F6C756D6E2B22202D3E20222B746869732E656E644C696E654E756D6265722B222C222B746869732E656E64436F6C756D6E2B225D227D736574456E64506F736974696F6E28652C74297B72657475726E206E657720537428746869732E73746172';
wwv_flow_imp.g_varchar2_table(1102) := '744C696E654E756D6265722C746869732E7374617274436F6C756D6E2C652C74297D7365745374617274506F736974696F6E28652C74297B72657475726E206E657720537428652C742C746869732E656E644C696E654E756D6265722C746869732E656E';
wwv_flow_imp.g_varchar2_table(1103) := '64436F6C756D6E297D636F6C6C61707365546F537461727428297B72657475726E2053742E636F6C6C61707365546F53746172742874686973297D73746174696320636F6C6C61707365546F53746172742865297B72657475726E206E65772053742865';
wwv_flow_imp.g_varchar2_table(1104) := '2E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D636F6C6C61707365546F456E6428297B72657475726E2053742E636F6C6C61707365546F';
wwv_flow_imp.g_varchar2_table(1105) := '456E642874686973297D73746174696320636F6C6C61707365546F456E642865297B72657475726E206E657720537428652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C';
wwv_flow_imp.g_varchar2_table(1106) := '756D6E297D64656C74612865297B72657475726E206E657720537428746869732E73746172744C696E654E756D6265722B652C746869732E7374617274436F6C756D6E2C746869732E656E644C696E654E756D6265722B652C746869732E656E64436F6C';
wwv_flow_imp.g_varchar2_table(1107) := '756D6E297D7374617469632066726F6D506F736974696F6E7328652C743D65297B72657475726E206E657720537428652E6C696E654E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D737461746963206C';
wwv_flow_imp.g_varchar2_table(1108) := '6966742865297B72657475726E20653F6E657720537428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E756C6C7D7374617469632069734952';
wwv_flow_imp.g_varchar2_table(1109) := '616E67652865297B72657475726E20652626226E756D626572223D3D747970656F6620652E73746172744C696E654E756D6265722626226E756D626572223D3D747970656F6620652E7374617274436F6C756D6E2626226E756D626572223D3D74797065';
wwv_flow_imp.g_varchar2_table(1110) := '6F6620652E656E644C696E654E756D6265722626226E756D626572223D3D747970656F6620652E656E64436F6C756D6E7D73746174696320617265496E74657273656374696E674F72546F756368696E6728652C74297B72657475726E2128652E656E64';
wwv_flow_imp.g_varchar2_table(1111) := '4C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E656E64436F6C756D6E3C742E7374617274436F6C756D6E7C7C742E656E644C';
wwv_flow_imp.g_varchar2_table(1112) := '696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E656E64436F6C756D6E3C652E7374617274436F6C756D6E297D73746174696320';
wwv_flow_imp.g_varchar2_table(1113) := '617265496E74657273656374696E6728652C74297B72657475726E2128652E656E644C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D62657226';
wwv_flow_imp.g_varchar2_table(1114) := '26652E656E64436F6C756D6E3C3D742E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D62657226';
wwv_flow_imp.g_varchar2_table(1115) := '26742E656E64436F6C756D6E3C3D652E7374617274436F6C756D6E297D73746174696320636F6D7061726552616E6765735573696E6753746172747328652C74297B69662865262674297B636F6E7374206E3D307C652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1116) := '65722C723D307C742E73746172744C696E654E756D6265723B6966286E3D3D3D72297B636F6E7374206E3D307C652E7374617274436F6C756D6E2C723D307C742E7374617274436F6C756D6E3B6966286E3D3D3D72297B636F6E7374206E3D307C652E65';
wwv_flow_imp.g_varchar2_table(1117) := '6E644C696E654E756D6265722C723D307C742E656E644C696E654E756D6265723B72657475726E206E3D3D3D723F28307C652E656E64436F6C756D6E292D28307C742E656E64436F6C756D6E293A6E2D727D72657475726E206E2D727D72657475726E20';
wwv_flow_imp.g_varchar2_table(1118) := '6E2D727D72657475726E28653F313A30292D28743F313A30297D73746174696320636F6D7061726552616E6765735573696E67456E647328652C74297B72657475726E20652E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1119) := '723F652E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E3F652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E2D742E7374617274436F6C756D6E3A652E73746172';
wwv_flow_imp.g_varchar2_table(1120) := '744C696E654E756D6265722D742E73746172744C696E654E756D6265723A652E656E64436F6C756D6E2D742E656E64436F6C756D6E3A652E656E644C696E654E756D6265722D742E656E644C696E654E756D6265727D737461746963207370616E734D75';
wwv_flow_imp.g_varchar2_table(1121) := '6C7469706C654C696E65732865297B72657475726E20652E656E644C696E654E756D6265723E652E73746172744C696E654E756D6265727D746F4A534F4E28297B72657475726E20746869737D7D766172204C743B66756E6374696F6E20457428652C74';
wwv_flow_imp.g_varchar2_table(1122) := '297B72657475726E286E2C72293D3E742865286E292C65287229297D2166756E6374696F6E2865297B652E69734C6573735468616E3D66756E6374696F6E2865297B72657475726E20653C307D2C652E69734C6573735468616E4F72457175616C3D6675';
wwv_flow_imp.g_varchar2_table(1123) := '6E6374696F6E2865297B72657475726E20653C3D307D2C652E6973477265617465725468616E3D66756E6374696F6E2865297B72657475726E20653E307D2C652E69734E6569746865724C6573734F72477265617465725468616E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1124) := '2865297B72657475726E20303D3D3D657D2C652E677265617465725468616E3D312C652E6C6573735468616E3D2D312C652E6E6569746865724C6573734F72477265617465725468616E3D307D284C747C7C284C743D7B7D29293B636F6E73742078743D';
wwv_flow_imp.g_varchar2_table(1125) := '28652C74293D3E652D743B636C617373204E747B636F6E7374727563746F722865297B746869732E697465726174653D657D746F417272617928297B636F6E737420653D5B5D3B72657475726E20746869732E697465726174652828743D3E28652E7075';
wwv_flow_imp.g_varchar2_table(1126) := '73682874292C21302929292C657D66696C7465722865297B72657475726E206E6577204E742828743D3E746869732E6974657261746528286E3D3E2165286E297C7C74286E29292929297D6D61702865297B72657475726E206E6577204E742828743D3E';
wwv_flow_imp.g_varchar2_table(1127) := '746869732E6974657261746528286E3D3E742865286E2929292929297D66696E644C6173742865297B6C657420743B72657475726E20746869732E6974657261746528286E3D3E2865286E29262628743D6E292C21302929292C747D66696E644C617374';
wwv_flow_imp.g_varchar2_table(1128) := '4D617842792865297B6C657420742C6E3D21303B72657475726E20746869732E697465726174652828723D3E28286E7C7C4C742E6973477265617465725468616E286528722C742929292626286E3D21312C743D72292C21302929292C747D7D66756E63';
wwv_flow_imp.g_varchar2_table(1129) := '74696F6E2041742865297B72657475726E20653C303F303A653E3235353F3235353A307C657D66756E6374696F6E206B742865297B72657475726E20653C303F303A653E343239343936373239353F343239343936373239353A307C657D4E742E656D70';
wwv_flow_imp.g_varchar2_table(1130) := '74793D6E6577204E742828653D3E7B7D29293B636C6173732052747B636F6E7374727563746F722865297B746869732E76616C7565733D652C746869732E70726566697853756D3D6E65772055696E743332417272617928652E6C656E677468292C7468';
wwv_flow_imp.g_varchar2_table(1131) := '69732E70726566697853756D56616C6964496E6465783D6E657720496E74333241727261792831292C746869732E70726566697853756D56616C6964496E6465785B305D3D2D317D696E7365727456616C75657328652C74297B653D6B742865293B636F';
wwv_flow_imp.g_varchar2_table(1132) := '6E7374206E3D746869732E76616C7565732C723D746869732E70726566697853756D2C693D742E6C656E6774683B72657475726E2030213D3D69262628746869732E76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682B6929';
wwv_flow_imp.g_varchar2_table(1133) := '2C746869732E76616C7565732E736574286E2E737562617272617928302C65292C30292C746869732E76616C7565732E736574286E2E73756261727261792865292C652B69292C746869732E76616C7565732E73657428742C65292C652D313C74686973';
wwv_flow_imp.g_varchar2_table(1134) := '2E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C746869732E70726566697853756D3D6E65772055696E743332417272617928746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(1135) := '732E6C656E677468292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853756D2E73657428722E737562617272617928302C746869732E70726566697853756D56616C6964496E6465785B30';
wwv_flow_imp.g_varchar2_table(1136) := '5D2B3129292C2130297D73657456616C756528652C74297B72657475726E20653D6B742865292C743D6B742874292C746869732E76616C7565735B655D213D3D74262628746869732E76616C7565735B655D3D742C652D313C746869732E707265666978';
wwv_flow_imp.g_varchar2_table(1137) := '53756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C2130297D72656D6F766556616C75657328652C74297B653D6B742865292C743D6B742874293B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(1138) := '69732E76616C7565732C723D746869732E70726566697853756D3B696628653E3D6E2E6C656E6774682972657475726E21313B636F6E737420693D6E2E6C656E6774682D653B72657475726E20743E3D69262628743D69292C30213D3D74262628746869';
wwv_flow_imp.g_varchar2_table(1139) := '732E76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682D74292C746869732E76616C7565732E736574286E2E737562617272617928302C65292C30292C746869732E76616C7565732E736574286E2E73756261727261792865';
wwv_flow_imp.g_varchar2_table(1140) := '2B74292C65292C746869732E70726566697853756D3D6E65772055696E743332417272617928746869732E76616C7565732E6C656E677468292C652D313C746869732E70726566697853756D56616C6964496E6465785B305D262628746869732E707265';
wwv_flow_imp.g_varchar2_table(1141) := '66697853756D56616C6964496E6465785B305D3D652D31292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853756D2E73657428722E737562617272617928302C746869732E707265666978';
wwv_flow_imp.g_varchar2_table(1142) := '53756D56616C6964496E6465785B305D2B3129292C2130297D676574546F74616C53756D28297B72657475726E20303D3D3D746869732E76616C7565732E6C656E6774683F303A746869732E5F67657450726566697853756D28746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(1143) := '732E6C656E6774682D31297D67657450726566697853756D2865297B72657475726E20653C303F303A28653D6B742865292C746869732E5F67657450726566697853756D286529297D5F67657450726566697853756D2865297B696628653C3D74686973';
wwv_flow_imp.g_varchar2_table(1144) := '2E70726566697853756D56616C6964496E6465785B305D2972657475726E20746869732E70726566697853756D5B655D3B6C657420743D746869732E70726566697853756D56616C6964496E6465785B305D2B313B303D3D3D74262628746869732E7072';
wwv_flow_imp.g_varchar2_table(1145) := '6566697853756D5B305D3D746869732E76616C7565735B305D2C742B2B292C653E3D746869732E76616C7565732E6C656E677468262628653D746869732E76616C7565732E6C656E6774682D31293B666F72286C6574206E3D743B6E3C3D653B6E2B2B29';
wwv_flow_imp.g_varchar2_table(1146) := '746869732E70726566697853756D5B6E5D3D746869732E70726566697853756D5B6E2D315D2B746869732E76616C7565735B6E5D3B72657475726E20746869732E70726566697853756D56616C6964496E6465785B305D3D4D6174682E6D617828746869';
wwv_flow_imp.g_varchar2_table(1147) := '732E70726566697853756D56616C6964496E6465785B305D2C65292C746869732E70726566697853756D5B655D7D676574496E6465784F662865297B653D4D6174682E666C6F6F722865292C746869732E676574546F74616C53756D28293B6C65742074';
wwv_flow_imp.g_varchar2_table(1148) := '3D302C6E3D746869732E76616C7565732E6C656E6774682D312C723D302C693D302C733D303B666F72283B743C3D6E3B29696628723D742B286E2D74292F327C302C693D746869732E70726566697853756D5B725D2C733D692D746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(1149) := '735B725D2C653C73296E3D722D313B656C73657B6966282128653E3D692929627265616B3B743D722B317D72657475726E206E657720547428722C652D73297D7D636C6173732054747B636F6E7374727563746F7228652C74297B746869732E696E6465';
wwv_flow_imp.g_varchar2_table(1150) := '783D652C746869732E72656D61696E6465723D742C746869732E5F70726566697853756D496E6465784F66526573756C744272616E643D766F696420302C746869732E696E6465783D652C746869732E72656D61696E6465723D747D7D636C617373204D';
wwv_flow_imp.g_varchar2_table(1151) := '747B636F6E7374727563746F7228652C742C6E2C72297B746869732E5F7572693D652C746869732E5F6C696E65733D742C746869732E5F656F6C3D6E2C746869732E5F76657273696F6E49643D722C746869732E5F6C696E655374617274733D6E756C6C';
wwv_flow_imp.g_varchar2_table(1152) := '2C746869732E5F6361636865645465787456616C75653D6E756C6C7D646973706F736528297B746869732E5F6C696E65732E6C656E6774683D307D6765742076657273696F6E28297B72657475726E20746869732E5F76657273696F6E49647D67657454';
wwv_flow_imp.g_varchar2_table(1153) := '65787428297B72657475726E206E756C6C3D3D3D746869732E5F6361636865645465787456616C7565262628746869732E5F6361636865645465787456616C75653D746869732E5F6C696E65732E6A6F696E28746869732E5F656F6C29292C746869732E';
wwv_flow_imp.g_varchar2_table(1154) := '5F6361636865645465787456616C75657D6F6E4576656E74732865297B652E656F6C2626652E656F6C213D3D746869732E5F656F6C262628746869732E5F656F6C3D652E656F6C2C746869732E5F6C696E655374617274733D6E756C6C293B636F6E7374';
wwv_flow_imp.g_varchar2_table(1155) := '20743D652E6368616E6765733B666F7228636F6E73742065206F66207429746869732E5F61636365707444656C65746552616E676528652E72616E6765292C746869732E5F616363657074496E7365727454657874286E657720777428652E72616E6765';
wwv_flow_imp.g_varchar2_table(1156) := '2E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E292C652E74657874293B746869732E5F76657273696F6E49643D652E76657273696F6E49642C746869732E5F6361636865645465787456616C75653D6E756C6C';
wwv_flow_imp.g_varchar2_table(1157) := '7D5F656E737572654C696E6553746172747328297B69662821746869732E5F6C696E65537461727473297B636F6E737420653D746869732E5F656F6C2E6C656E6774682C743D746869732E5F6C696E65732E6C656E6774682C6E3D6E65772055696E7433';
wwv_flow_imp.g_varchar2_table(1158) := '3241727261792874293B666F72286C657420723D303B723C743B722B2B296E5B725D3D746869732E5F6C696E65735B725D2E6C656E6774682B653B746869732E5F6C696E655374617274733D6E6577205274286E297D7D5F7365744C696E655465787428';
wwv_flow_imp.g_varchar2_table(1159) := '652C74297B746869732E5F6C696E65735B655D3D742C746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E73657456616C756528652C746869732E5F6C696E65735B655D2E6C656E6774682B746869732E5F656F6C2E';
wwv_flow_imp.g_varchar2_table(1160) := '6C656E677468297D5F61636365707444656C65746552616E67652865297B696628652E73746172744C696E654E756D626572213D3D652E656E644C696E654E756D62657229746869732E5F7365744C696E655465787428652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(1161) := '6D6265722D312C746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E656E644C696E654E756D6265722D315D2E';
wwv_flow_imp.g_varchar2_table(1162) := '737562737472696E6728652E656E64436F6C756D6E2D3129292C746869732E5F6C696E65732E73706C69636528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D626572292C7468';
wwv_flow_imp.g_varchar2_table(1163) := '69732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E72656D6F766556616C75657328652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D626572293B65';
wwv_flow_imp.g_varchar2_table(1164) := '6C73657B696628652E7374617274436F6C756D6E3D3D3D652E656E64436F6C756D6E2972657475726E3B746869732E5F7365744C696E655465787428652E73746172744C696E654E756D6265722D312C746869732E5F6C696E65735B652E73746172744C';
wwv_flow_imp.g_varchar2_table(1165) := '696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728652E656E64436F6C756D6E2D312929';
wwv_flow_imp.g_varchar2_table(1166) := '7D7D5F616363657074496E736572745465787428652C74297B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D742E73706C6974282F5C725C6E7C5C727C5C6E2F293B696628313D3D3D6E2E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(1167) := '20766F696420746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B305D2B74686973';
wwv_flow_imp.g_varchar2_table(1168) := '2E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728652E636F6C756D6E2D3129293B6E5B6E2E6C656E6774682D315D2B3D746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728';
wwv_flow_imp.g_varchar2_table(1169) := '652E636F6C756D6E2D31292C746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B30';
wwv_flow_imp.g_varchar2_table(1170) := '5D293B636F6E737420723D6E65772055696E7433324172726179286E2E6C656E6774682D31293B666F72286C657420743D313B743C6E2E6C656E6774683B742B2B29746869732E5F6C696E65732E73706C69636528652E6C696E654E756D6265722B742D';
wwv_flow_imp.g_varchar2_table(1171) := '312C302C6E5B745D292C725B742D315D3D6E5B745D2E6C656E6774682B746869732E5F656F6C2E6C656E6774683B746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E696E7365727456616C75657328652E6C696E65';
wwv_flow_imp.g_varchar2_table(1172) := '4E756D6265722C72297D7D636F6E7374204F743D66756E6374696F6E28653D2222297B6C657420743D22282D3F5C5C642A5C5C2E5C5C645C5C772A297C285B5E223B666F7228636F6E7374206E206F6622607E21402324255E262A28292D3D2B5B7B5D7D';
wwv_flow_imp.g_varchar2_table(1173) := '5C5C7C3B3A275C222C2E3C3E2F3F2229652E696E6465784F66286E293E3D307C7C28742B3D225C5C222B6E293B72657475726E20742B3D225C5C735D2B29222C6E65772052656745787028742C226722297D28293B66756E6374696F6E2049742865297B';
wwv_flow_imp.g_varchar2_table(1174) := '6C657420743D4F743B6966286526266520696E7374616E63656F662052656745787029696628652E676C6F62616C29743D653B656C73657B6C6574206E3D2267223B652E69676E6F7265436173652626286E2B3D226922292C652E6D756C74696C696E65';
wwv_flow_imp.g_varchar2_table(1175) := '2626286E2B3D226D22292C652E756E69636F64652626286E2B3D227522292C743D6E65772052656745787028652E736F757263652C6E297D72657475726E20742E6C617374496E6465783D302C747D636F6E73742050743D6E657720623B66756E637469';
wwv_flow_imp.g_varchar2_table(1176) := '6F6E20467428652C742C6E2C722C69297B696628743D49742874292C697C7C28693D6C2E666972737428507429292C6E2E6C656E6774683E692E6D61784C656E297B6C657420733D652D692E6D61784C656E2F323B72657475726E20733C303F733D303A';
wwv_flow_imp.g_varchar2_table(1177) := '722B3D732C467428652C742C6E3D6E2E737562737472696E6728732C652B692E6D61784C656E2F32292C722C69297D636F6E737420733D446174652E6E6F7728292C6F3D652D312D723B6C657420613D2D312C753D6E756C6C3B666F72286C657420653D';
wwv_flow_imp.g_varchar2_table(1178) := '313B2128446174652E6E6F7728292D733E3D692E74696D65427564676574293B652B2B297B636F6E737420723D6F2D692E77696E646F7753697A652A653B742E6C617374496E6465783D4D6174682E6D617828302C72293B636F6E737420733D56742874';
wwv_flow_imp.g_varchar2_table(1179) := '2C6E2C6F2C61293B696628217326267529627265616B3B696628753D732C723C3D3029627265616B3B613D727D69662875297B636F6E737420653D7B776F72643A755B305D2C7374617274436F6C756D6E3A722B312B752E696E6465782C656E64436F6C';
wwv_flow_imp.g_varchar2_table(1180) := '756D6E3A722B312B752E696E6465782B755B305D2E6C656E6774687D3B72657475726E20742E6C617374496E6465783D302C657D72657475726E206E756C6C7D66756E6374696F6E20567428652C742C6E2C72297B6C657420693B666F72283B693D652E';
wwv_flow_imp.g_varchar2_table(1181) := '657865632874293B297B636F6E737420743D692E696E6465787C7C303B696628743C3D6E2626652E6C617374496E6465783E3D6E2972657475726E20693B696628723E302626743E722972657475726E206E756C6C7D72657475726E206E756C6C7D5074';
wwv_flow_imp.g_varchar2_table(1182) := '2E756E7368696674287B6D61784C656E3A3165332C77696E646F7753697A653A31352C74696D654275646765743A3135307D293B636C6173732044747B636F6E7374727563746F722865297B636F6E737420743D41742865293B746869732E5F64656661';
wwv_flow_imp.g_varchar2_table(1183) := '756C7456616C75653D742C746869732E5F61736369694D61703D44742E5F63726561746541736369694D61702874292C746869732E5F6D61703D6E6577204D61707D737461746963205F63726561746541736369694D61702865297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(1184) := '6E65772055696E7438417272617928323536293B72657475726E20742E66696C6C2865292C747D73657428652C74297B636F6E7374206E3D41742874293B653E3D302626653C3235363F746869732E5F61736369694D61705B655D3D6E3A746869732E5F';
wwv_flow_imp.g_varchar2_table(1185) := '6D61702E73657428652C6E297D6765742865297B72657475726E20653E3D302626653C3235363F746869732E5F61736369694D61705B655D3A746869732E5F6D61702E6765742865297C7C746869732E5F64656661756C7456616C75657D636C65617228';
wwv_flow_imp.g_varchar2_table(1186) := '297B746869732E5F61736369694D61702E66696C6C28746869732E5F64656661756C7456616C7565292C746869732E5F6D61702E636C65617228297D7D636C6173732071747B636F6E7374727563746F7228652C742C6E297B636F6E737420723D6E6577';
wwv_flow_imp.g_varchar2_table(1187) := '2055696E7438417272617928652A74293B666F72286C657420693D302C733D652A743B693C733B692B2B29725B695D3D6E3B746869732E5F646174613D722C746869732E726F77733D652C746869732E636F6C733D747D67657428652C74297B72657475';
wwv_flow_imp.g_varchar2_table(1188) := '726E20746869732E5F646174615B652A746869732E636F6C732B745D7D73657428652C742C6E297B746869732E5F646174615B652A746869732E636F6C732B745D3D6E7D7D636C617373204B747B636F6E7374727563746F722865297B6C657420743D30';
wwv_flow_imp.g_varchar2_table(1189) := '2C6E3D303B666F72286C657420723D302C693D652E6C656E6774683B723C693B722B2B297B636F6E73745B692C732C6F5D3D655B725D3B733E74262628743D73292C693E6E2626286E3D69292C6F3E6E2626286E3D6F297D742B2B2C6E2B2B3B636F6E73';
wwv_flow_imp.g_varchar2_table(1190) := '7420723D6E6577207174286E2C742C30293B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E73745B6E2C692C735D3D655B745D3B722E736574286E2C692C73297D746869732E5F7374617465733D722C74686973';
wwv_flow_imp.g_varchar2_table(1191) := '2E5F6D617843686172436F64653D747D6E657874537461746528652C74297B72657475726E20743C307C7C743E3D746869732E5F6D617843686172436F64653F303A746869732E5F7374617465732E67657428652C74297D7D6C6574206A743D6E756C6C';
wwv_flow_imp.g_varchar2_table(1192) := '2C55743D6E756C6C3B636C6173732042747B737461746963205F6372656174654C696E6B28652C742C6E2C722C69297B6C657420733D692D313B646F7B636F6E7374206E3D742E63686172436F646541742873293B69662832213D3D652E676574286E29';
wwv_flow_imp.g_varchar2_table(1193) := '29627265616B3B732D2D7D7768696C6528733E72293B696628723E30297B636F6E737420653D742E63686172436F6465417428722D31292C6E3D742E63686172436F646541742873293B2834303D3D3D65262634313D3D3D6E7C7C39313D3D3D65262639';
wwv_flow_imp.g_varchar2_table(1194) := '333D3D3D6E7C7C3132333D3D3D6526263132353D3D3D6E292626732D2D7D72657475726E7B72616E67653A7B73746172744C696E654E756D6265723A6E2C7374617274436F6C756D6E3A722B312C656E644C696E654E756D6265723A6E2C656E64436F6C';
wwv_flow_imp.g_varchar2_table(1195) := '756D6E3A732B327D2C75726C3A742E737562737472696E6728722C732B31297D7D73746174696320636F6D707574654C696E6B7328652C743D66756E6374696F6E28297B72657475726E206E756C6C3D3D3D6A742626286A743D6E6577204B74285B5B31';
wwv_flow_imp.g_varchar2_table(1196) := '2C3130342C325D2C5B312C37322C325D2C5B312C3130322C365D2C5B312C37302C365D2C5B322C3131362C335D2C5B322C38342C335D2C5B332C3131362C345D2C5B332C38342C345D2C5B342C3131322C355D2C5B342C38302C355D2C5B352C3131352C';
wwv_flow_imp.g_varchar2_table(1197) := '395D2C5B352C38332C395D2C5B352C35382C31305D2C5B362C3130352C375D2C5B362C37332C375D2C5B372C3130382C385D2C5B372C37362C385D2C5B382C3130312C395D2C5B382C36392C395D2C5B392C35382C31305D2C5B31302C34372C31315D2C';
wwv_flow_imp.g_varchar2_table(1198) := '5B31312C34372C31325D5D29292C6A747D2829297B636F6E7374206E3D66756E6374696F6E28297B6966286E756C6C3D3D3D5574297B55743D6E65772044742830293B636F6E737420653D22205C743C3E275C22E38081E38082EFBDA1EFBDA4EFBC8CEF';
wwv_flow_imp.g_varchar2_table(1199) := 'BC8EEFBC9AEFBC9BE28098E38088E3808CE3808EE38094EFBC88EFBCBBEFBD9BEFBDA2EFBDA3EFBD9DEFBCBDEFBC89E38095E3808FE3808DE38089E28099EFBD80EFBD9EE280A6223B666F72286C657420743D303B743C652E6C656E6774683B742B2B29';
wwv_flow_imp.g_varchar2_table(1200) := '55742E73657428652E63686172436F646541742874292C31293B636F6E737420743D222E2C3B3A223B666F72286C657420653D303B653C742E6C656E6774683B652B2B2955742E73657428742E63686172436F646541742865292C32297D72657475726E';
wwv_flow_imp.g_varchar2_table(1201) := '2055747D28292C723D5B5D3B666F72286C657420693D312C733D652E6765744C696E65436F756E7428293B693C3D733B692B2B297B636F6E737420733D652E6765744C696E65436F6E74656E742869292C6F3D732E6C656E6774683B6C657420613D302C';
wwv_flow_imp.g_varchar2_table(1202) := '6C3D302C753D302C633D312C683D21312C643D21312C663D21312C6D3D21313B666F72283B613C6F3B297B6C657420653D21313B636F6E7374206F3D732E63686172436F646541742861293B69662831333D3D3D63297B6C657420743B73776974636828';
wwv_flow_imp.g_varchar2_table(1203) := '6F297B636173652034303A683D21302C743D303B627265616B3B636173652034313A743D683F303A313B627265616B3B636173652039313A663D21302C643D21302C743D303B627265616B3B636173652039333A663D21312C743D643F303A313B627265';
wwv_flow_imp.g_varchar2_table(1204) := '616B3B63617365203132333A6D3D21302C743D303B627265616B3B63617365203132353A743D6D3F303A313B627265616B3B636173652033393A636173652033343A636173652039363A743D753D3D3D6F3F313A33393D3D3D757C7C33343D3D3D757C7C';
wwv_flow_imp.g_varchar2_table(1205) := '39363D3D3D753F303A313B627265616B3B636173652034323A743D34323D3D3D753F313A303B627265616B3B63617365203132343A743D3132343D3D3D753F313A303B627265616B3B636173652033323A743D663F303A313B627265616B3B6465666175';
wwv_flow_imp.g_varchar2_table(1206) := '6C743A743D6E2E676574286F297D313D3D3D74262628722E707573682842742E5F6372656174654C696E6B286E2C732C692C6C2C6129292C653D2130297D656C73652069662831323D3D3D63297B6C657420743B39313D3D3D6F3F28643D21302C743D30';
wwv_flow_imp.g_varchar2_table(1207) := '293A743D6E2E676574286F292C313D3D3D743F653D21303A633D31337D656C736520633D742E6E657874537461746528632C6F292C303D3D3D63262628653D2130293B65262628633D312C683D21312C643D21312C6D3D21312C6C3D612B312C753D6F29';
wwv_flow_imp.g_varchar2_table(1208) := '2C612B2B7D31333D3D3D632626722E707573682842742E5F6372656174654C696E6B286E2C732C692C6C2C6F29297D72657475726E20727D7D636C6173732024747B636F6E7374727563746F7228297B746869732E5F64656661756C7456616C75655365';
wwv_flow_imp.g_varchar2_table(1209) := '743D5B5B2274727565222C2266616C7365225D2C5B2254727565222C2246616C7365225D2C5B2250726976617465222C225075626C6963222C22467269656E64222C22526561644F6E6C79222C225061727469616C222C2250726F746563746564222C22';
wwv_flow_imp.g_varchar2_table(1210) := '57726974654F6E6C79225D2C5B227075626C6963222C2270726F746563746564222C2270726976617465225D5D7D6E6176696761746556616C756553657428652C742C6E2C722C69297B69662865262674297B636F6E7374206E3D746869732E646F4E61';
wwv_flow_imp.g_varchar2_table(1211) := '76696761746556616C756553657428742C69293B6966286E2972657475726E7B72616E67653A652C76616C75653A6E7D7D6966286E262672297B636F6E737420653D746869732E646F4E6176696761746556616C756553657428722C69293B6966286529';
wwv_flow_imp.g_varchar2_table(1212) := '72657475726E7B72616E67653A6E2C76616C75653A657D7D72657475726E206E756C6C7D646F4E6176696761746556616C756553657428652C74297B636F6E7374206E3D746869732E6E756D6265725265706C61636528652C74293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(1213) := '756C6C213D3D6E3F6E3A746869732E746578745265706C61636528652C74297D6E756D6265725265706C61636528652C74297B636F6E7374206E3D4D6174682E706F772831302C652E6C656E6774682D28652E6C617374496E6465784F6628222E22292B';
wwv_flow_imp.g_varchar2_table(1214) := '3129293B6C657420723D4E756D6265722865293B636F6E737420693D7061727365466C6F61742865293B72657475726E2069734E614E2872297C7C69734E614E2869297C7C72213D3D693F6E756C6C3A30213D3D727C7C743F28723D4D6174682E666C6F';
wwv_flow_imp.g_varchar2_table(1215) := '6F7228722A6E292C722B3D743F6E3A2D6E2C537472696E6728722F6E29293A6E756C6C7D746578745265706C61636528652C74297B72657475726E20746869732E76616C7565536574735265706C61636528746869732E5F64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(1216) := '5365742C652C74297D76616C7565536574735265706C61636528652C742C6E297B6C657420723D6E756C6C3B666F72286C657420693D302C733D652E6C656E6774683B6E756C6C3D3D3D722626693C733B692B2B29723D746869732E76616C7565536574';
wwv_flow_imp.g_varchar2_table(1217) := '5265706C61636528655B695D2C742C6E293B72657475726E20727D76616C75655365745265706C61636528652C742C6E297B6C657420723D652E696E6465784F662874293B72657475726E20723E3D303F28722B3D6E3F313A2D312C723C303F723D652E';
wwv_flow_imp.g_varchar2_table(1218) := '6C656E6774682D313A72253D652E6C656E6774682C655B725D293A6E756C6C7D7D24742E494E5354414E43453D6E65772024743B636F6E73742057743D4F626A6563742E667265657A65282866756E6374696F6E28652C74297B636F6E7374206E3D7365';
wwv_flow_imp.g_varchar2_table(1219) := '7454696D656F757428652E62696E642874292C30293B72657475726E7B646973706F736528297B636C65617254696D656F7574286E297D7D7D29293B766172207A743B2166756E6374696F6E2865297B652E697343616E63656C6C6174696F6E546F6B65';
wwv_flow_imp.g_varchar2_table(1220) := '6E3D66756E6374696F6E2874297B72657475726E20743D3D3D652E4E6F6E657C7C743D3D3D652E43616E63656C6C65647C7C7420696E7374616E63656F662048747C7C212821747C7C226F626A65637422213D747970656F66207429262622626F6F6C65';
wwv_flow_imp.g_varchar2_table(1221) := '616E223D3D747970656F6620742E697343616E63656C6C6174696F6E52657175657374656426262266756E6374696F6E223D3D747970656F6620742E6F6E43616E63656C6C6174696F6E5265717565737465647D2C652E4E6F6E653D4F626A6563742E66';
wwv_flow_imp.g_varchar2_table(1222) := '7265657A65287B697343616E63656C6C6174696F6E5265717565737465643A21312C6F6E43616E63656C6C6174696F6E5265717565737465643A432E4E6F6E657D292C652E43616E63656C6C65643D4F626A6563742E667265657A65287B697343616E63';
wwv_flow_imp.g_varchar2_table(1223) := '656C6C6174696F6E5265717565737465643A21302C6F6E43616E63656C6C6174696F6E5265717565737465643A57747D297D287A747C7C287A743D7B7D29293B636C6173732048747B636F6E7374727563746F7228297B746869732E5F697343616E6365';
wwv_flow_imp.g_varchar2_table(1224) := '6C6C65643D21312C746869732E5F656D69747465723D6E756C6C7D63616E63656C28297B746869732E5F697343616E63656C6C65647C7C28746869732E5F697343616E63656C6C65643D21302C746869732E5F656D6974746572262628746869732E5F65';
wwv_flow_imp.g_varchar2_table(1225) := '6D69747465722E6669726528766F69642030292C746869732E646973706F7365282929297D67657420697343616E63656C6C6174696F6E52657175657374656428297B72657475726E20746869732E5F697343616E63656C6C65647D676574206F6E4361';
wwv_flow_imp.g_varchar2_table(1226) := '6E63656C6C6174696F6E52657175657374656428297B72657475726E20746869732E5F697343616E63656C6C65643F57743A28746869732E5F656D69747465727C7C28746869732E5F656D69747465723D6E65772078292C746869732E5F656D69747465';
wwv_flow_imp.g_varchar2_table(1227) := '722E6576656E74297D646973706F736528297B746869732E5F656D6974746572262628746869732E5F656D69747465722E646973706F736528292C746869732E5F656D69747465723D6E756C6C297D7D636C6173732047747B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(1228) := '28297B746869732E5F6B6579436F6465546F5374723D5B5D2C746869732E5F737472546F4B6579436F64653D4F626A6563742E637265617465286E756C6C297D646566696E6528652C74297B746869732E5F6B6579436F6465546F5374725B655D3D742C';
wwv_flow_imp.g_varchar2_table(1229) := '746869732E5F737472546F4B6579436F64655B742E746F4C6F7765724361736528295D3D657D6B6579436F6465546F5374722865297B72657475726E20746869732E5F6B6579436F6465546F5374725B655D7D737472546F4B6579436F64652865297B72';
wwv_flow_imp.g_varchar2_table(1230) := '657475726E20746869732E5F737472546F4B6579436F64655B652E746F4C6F7765724361736528295D7C7C307D7D636F6E7374204A743D6E65772047742C58743D6E65772047742C51743D6E65772047742C5A743D6E657720417272617928323330292C';
wwv_flow_imp.g_varchar2_table(1231) := '59743D7B7D2C656E3D5B5D2C746E3D4F626A6563742E637265617465286E756C6C292C6E6E3D4F626A6563742E637265617465286E756C6C292C726E3D5B5D2C736E3D5B5D3B666F72286C657420653D303B653C3D3139333B652B2B29726E5B655D3D2D';
wwv_flow_imp.g_varchar2_table(1232) := '313B666F72286C657420653D303B653C3D3133323B652B2B29736E5B655D3D2D313B766172206F6E3B2166756E6374696F6E28297B636F6E737420653D22222C743D5B5B312C302C224E6F6E65222C302C22756E6B6E6F776E222C302C22564B5F554E4B';
wwv_flow_imp.g_varchar2_table(1233) := '4E4F574E222C652C655D2C5B312C312C224879706572222C302C652C302C652C652C655D2C5B312C322C225375706572222C302C652C302C652C652C655D2C5B312C332C22466E222C302C652C302C652C652C655D2C5B312C342C22466E4C6F636B222C';
wwv_flow_imp.g_varchar2_table(1234) := '302C652C302C652C652C655D2C5B312C352C2253757370656E64222C302C652C302C652C652C655D2C5B312C362C22526573756D65222C302C652C302C652C652C655D2C5B312C372C22547572626F222C302C652C302C652C652C655D2C5B312C382C22';
wwv_flow_imp.g_varchar2_table(1235) := '536C656570222C302C652C302C22564B5F534C454550222C652C655D2C5B312C392C2257616B655570222C302C652C302C652C652C655D2C5B302C31302C224B657941222C33312C2241222C36352C22564B5F41222C652C655D2C5B302C31312C224B65';
wwv_flow_imp.g_varchar2_table(1236) := '7942222C33322C2242222C36362C22564B5F42222C652C655D2C5B302C31322C224B657943222C33332C2243222C36372C22564B5F43222C652C655D2C5B302C31332C224B657944222C33342C2244222C36382C22564B5F44222C652C655D2C5B302C31';
wwv_flow_imp.g_varchar2_table(1237) := '342C224B657945222C33352C2245222C36392C22564B5F45222C652C655D2C5B302C31352C224B657946222C33362C2246222C37302C22564B5F46222C652C655D2C5B302C31362C224B657947222C33372C2247222C37312C22564B5F47222C652C655D';
wwv_flow_imp.g_varchar2_table(1238) := '2C5B302C31372C224B657948222C33382C2248222C37322C22564B5F48222C652C655D2C5B302C31382C224B657949222C33392C2249222C37332C22564B5F49222C652C655D2C5B302C31392C224B65794A222C34302C224A222C37342C22564B5F4A22';
wwv_flow_imp.g_varchar2_table(1239) := '2C652C655D2C5B302C32302C224B65794B222C34312C224B222C37352C22564B5F4B222C652C655D2C5B302C32312C224B65794C222C34322C224C222C37362C22564B5F4C222C652C655D2C5B302C32322C224B65794D222C34332C224D222C37372C22';
wwv_flow_imp.g_varchar2_table(1240) := '564B5F4D222C652C655D2C5B302C32332C224B65794E222C34342C224E222C37382C22564B5F4E222C652C655D2C5B302C32342C224B65794F222C34352C224F222C37392C22564B5F4F222C652C655D2C5B302C32352C224B657950222C34362C225022';
wwv_flow_imp.g_varchar2_table(1241) := '2C38302C22564B5F50222C652C655D2C5B302C32362C224B657951222C34372C2251222C38312C22564B5F51222C652C655D2C5B302C32372C224B657952222C34382C2252222C38322C22564B5F52222C652C655D2C5B302C32382C224B657953222C34';
wwv_flow_imp.g_varchar2_table(1242) := '392C2253222C38332C22564B5F53222C652C655D2C5B302C32392C224B657954222C35302C2254222C38342C22564B5F54222C652C655D2C5B302C33302C224B657955222C35312C2255222C38352C22564B5F55222C652C655D2C5B302C33312C224B65';
wwv_flow_imp.g_varchar2_table(1243) := '7956222C35322C2256222C38362C22564B5F56222C652C655D2C5B302C33322C224B657957222C35332C2257222C38372C22564B5F57222C652C655D2C5B302C33332C224B657958222C35342C2258222C38382C22564B5F58222C652C655D2C5B302C33';
wwv_flow_imp.g_varchar2_table(1244) := '342C224B657959222C35352C2259222C38392C22564B5F59222C652C655D2C5B302C33352C224B65795A222C35362C225A222C39302C22564B5F5A222C652C655D2C5B302C33362C22446967697431222C32322C2231222C34392C22564B5F31222C652C';
wwv_flow_imp.g_varchar2_table(1245) := '655D2C5B302C33372C22446967697432222C32332C2232222C35302C22564B5F32222C652C655D2C5B302C33382C22446967697433222C32342C2233222C35312C22564B5F33222C652C655D2C5B302C33392C22446967697434222C32352C2234222C35';
wwv_flow_imp.g_varchar2_table(1246) := '322C22564B5F34222C652C655D2C5B302C34302C22446967697435222C32362C2235222C35332C22564B5F35222C652C655D2C5B302C34312C22446967697436222C32372C2236222C35342C22564B5F36222C652C655D2C5B302C34322C224469676974';
wwv_flow_imp.g_varchar2_table(1247) := '37222C32382C2237222C35352C22564B5F37222C652C655D2C5B302C34332C22446967697438222C32392C2238222C35362C22564B5F38222C652C655D2C5B302C34342C22446967697439222C33302C2239222C35372C22564B5F39222C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(1248) := '302C34352C22446967697430222C32312C2230222C34382C22564B5F30222C652C655D2C5B312C34362C22456E746572222C332C22456E746572222C31332C22564B5F52455455524E222C652C655D2C5B312C34372C22457363617065222C392C224573';
wwv_flow_imp.g_varchar2_table(1249) := '63617065222C32372C22564B5F455343415045222C652C655D2C5B312C34382C224261636B7370616365222C312C224261636B7370616365222C382C22564B5F4241434B222C652C655D2C5B312C34392C22546162222C322C22546162222C392C22564B';
wwv_flow_imp.g_varchar2_table(1250) := '5F544142222C652C655D2C5B312C35302C225370616365222C31302C225370616365222C33322C22564B5F5350414345222C652C655D2C5B302C35312C224D696E7573222C38382C222D222C3138392C22564B5F4F454D5F4D494E5553222C222D222C22';
wwv_flow_imp.g_varchar2_table(1251) := '4F454D5F4D494E5553225D2C5B302C35322C22457175616C222C38362C223D222C3138372C22564B5F4F454D5F504C5553222C223D222C224F454D5F504C5553225D2C5B302C35332C22427261636B65744C656674222C39322C225B222C3231392C2256';
wwv_flow_imp.g_varchar2_table(1252) := '4B5F4F454D5F34222C225B222C224F454D5F34225D2C5B302C35342C22427261636B65745269676874222C39342C225D222C3232312C22564B5F4F454D5F36222C225D222C224F454D5F36225D2C5B302C35352C224261636B736C617368222C39332C22';
wwv_flow_imp.g_varchar2_table(1253) := '5C5C222C3232302C22564B5F4F454D5F35222C225C5C222C224F454D5F35225D2C5B302C35362C22496E746C48617368222C302C652C302C652C652C655D2C5B302C35372C2253656D69636F6C6F6E222C38352C223B222C3138362C22564B5F4F454D5F';
wwv_flow_imp.g_varchar2_table(1254) := '31222C223B222C224F454D5F31225D2C5B302C35382C2251756F7465222C39352C2227222C3232322C22564B5F4F454D5F37222C2227222C224F454D5F37225D2C5B302C35392C224261636B71756F7465222C39312C2260222C3139322C22564B5F4F45';
wwv_flow_imp.g_varchar2_table(1255) := '4D5F33222C2260222C224F454D5F33225D2C5B302C36302C22436F6D6D61222C38372C222C222C3138382C22564B5F4F454D5F434F4D4D41222C222C222C224F454D5F434F4D4D41225D2C5B302C36312C22506572696F64222C38392C222E222C313930';
wwv_flow_imp.g_varchar2_table(1256) := '2C22564B5F4F454D5F504552494F44222C222E222C224F454D5F504552494F44225D2C5B302C36322C22536C617368222C39302C222F222C3139312C22564B5F4F454D5F32222C222F222C224F454D5F32225D2C5B312C36332C22436170734C6F636B22';
wwv_flow_imp.g_varchar2_table(1257) := '2C382C22436170734C6F636B222C32302C22564B5F4341504954414C222C652C655D2C5B312C36342C224631222C35392C224631222C3131322C22564B5F4631222C652C655D2C5B312C36352C224632222C36302C224632222C3131332C22564B5F4632';
wwv_flow_imp.g_varchar2_table(1258) := '222C652C655D2C5B312C36362C224633222C36312C224633222C3131342C22564B5F4633222C652C655D2C5B312C36372C224634222C36322C224634222C3131352C22564B5F4634222C652C655D2C5B312C36382C224635222C36332C224635222C3131';
wwv_flow_imp.g_varchar2_table(1259) := '362C22564B5F4635222C652C655D2C5B312C36392C224636222C36342C224636222C3131372C22564B5F4636222C652C655D2C5B312C37302C224637222C36352C224637222C3131382C22564B5F4637222C652C655D2C5B312C37312C224638222C3636';
wwv_flow_imp.g_varchar2_table(1260) := '2C224638222C3131392C22564B5F4638222C652C655D2C5B312C37322C224639222C36372C224639222C3132302C22564B5F4639222C652C655D2C5B312C37332C22463130222C36382C22463130222C3132312C22564B5F463130222C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(1261) := '2C37342C22463131222C36392C22463131222C3132322C22564B5F463131222C652C655D2C5B312C37352C22463132222C37302C22463132222C3132332C22564B5F463132222C652C655D2C5B312C37362C225072696E7453637265656E222C302C652C';
wwv_flow_imp.g_varchar2_table(1262) := '302C652C652C655D2C5B312C37372C225363726F6C6C4C6F636B222C38342C225363726F6C6C4C6F636B222C3134352C22564B5F5343524F4C4C222C652C655D2C5B312C37382C225061757365222C372C225061757365427265616B222C31392C22564B';
wwv_flow_imp.g_varchar2_table(1263) := '5F5041555345222C652C655D2C5B312C37392C22496E73657274222C31392C22496E73657274222C34352C22564B5F494E53455254222C652C655D2C5B312C38302C22486F6D65222C31342C22486F6D65222C33362C22564B5F484F4D45222C652C655D';
wwv_flow_imp.g_varchar2_table(1264) := '2C5B312C38312C22506167655570222C31312C22506167655570222C33332C22564B5F5052494F52222C652C655D2C5B312C38322C2244656C657465222C32302C2244656C657465222C34362C22564B5F44454C455445222C652C655D2C5B312C38332C';
wwv_flow_imp.g_varchar2_table(1265) := '22456E64222C31332C22456E64222C33352C22564B5F454E44222C652C655D2C5B312C38342C2250616765446F776E222C31322C2250616765446F776E222C33342C22564B5F4E455854222C652C655D2C5B312C38352C224172726F775269676874222C';
wwv_flow_imp.g_varchar2_table(1266) := '31372C2252696768744172726F77222C33392C22564B5F5249474854222C225269676874222C655D2C5B312C38362C224172726F774C656674222C31352C224C6566744172726F77222C33372C22564B5F4C454654222C224C656674222C655D2C5B312C';
wwv_flow_imp.g_varchar2_table(1267) := '38372C224172726F77446F776E222C31382C22446F776E4172726F77222C34302C22564B5F444F574E222C22446F776E222C655D2C5B312C38382C224172726F775570222C31362C2255704172726F77222C33382C22564B5F5550222C225570222C655D';
wwv_flow_imp.g_varchar2_table(1268) := '2C5B312C38392C224E756D4C6F636B222C38332C224E756D4C6F636B222C3134342C22564B5F4E554D4C4F434B222C652C655D2C5B312C39302C224E756D706164446976696465222C3131332C224E756D5061645F446976696465222C3131312C22564B';
wwv_flow_imp.g_varchar2_table(1269) := '5F444956494445222C652C655D2C5B312C39312C224E756D7061644D756C7469706C79222C3130382C224E756D5061645F4D756C7469706C79222C3130362C22564B5F4D554C5449504C59222C652C655D2C5B312C39322C224E756D7061645375627472';
wwv_flow_imp.g_varchar2_table(1270) := '616374222C3131312C224E756D5061645F5375627472616374222C3130392C22564B5F5355425452414354222C652C655D2C5B312C39332C224E756D706164416464222C3130392C224E756D5061645F416464222C3130372C22564B5F414444222C652C';
wwv_flow_imp.g_varchar2_table(1271) := '655D2C5B312C39342C224E756D706164456E746572222C332C652C302C652C652C655D2C5B312C39352C224E756D70616431222C39392C224E756D50616431222C39372C22564B5F4E554D50414431222C652C655D2C5B312C39362C224E756D70616432';
wwv_flow_imp.g_varchar2_table(1272) := '222C3130302C224E756D50616432222C39382C22564B5F4E554D50414432222C652C655D2C5B312C39372C224E756D70616433222C3130312C224E756D50616433222C39392C22564B5F4E554D50414433222C652C655D2C5B312C39382C224E756D7061';
wwv_flow_imp.g_varchar2_table(1273) := '6434222C3130322C224E756D50616434222C3130302C22564B5F4E554D50414434222C652C655D2C5B312C39392C224E756D70616435222C3130332C224E756D50616435222C3130312C22564B5F4E554D50414435222C652C655D2C5B312C3130302C22';
wwv_flow_imp.g_varchar2_table(1274) := '4E756D70616436222C3130342C224E756D50616436222C3130322C22564B5F4E554D50414436222C652C655D2C5B312C3130312C224E756D70616437222C3130352C224E756D50616437222C3130332C22564B5F4E554D50414437222C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(1275) := '2C3130322C224E756D70616438222C3130362C224E756D50616438222C3130342C22564B5F4E554D50414438222C652C655D2C5B312C3130332C224E756D70616439222C3130372C224E756D50616439222C3130352C22564B5F4E554D50414439222C65';
wwv_flow_imp.g_varchar2_table(1276) := '2C655D2C5B312C3130342C224E756D70616430222C39382C224E756D50616430222C39362C22564B5F4E554D50414430222C652C655D2C5B312C3130352C224E756D706164446563696D616C222C3131322C224E756D5061645F446563696D616C222C31';
wwv_flow_imp.g_varchar2_table(1277) := '31302C22564B5F444543494D414C222C652C655D2C5B302C3130362C22496E746C4261636B736C617368222C39372C224F454D5F313032222C3232362C22564B5F4F454D5F313032222C652C655D2C5B312C3130372C22436F6E746578744D656E75222C';
wwv_flow_imp.g_varchar2_table(1278) := '35382C22436F6E746578744D656E75222C39332C652C652C655D2C5B312C3130382C22506F776572222C302C652C302C652C652C655D2C5B312C3130392C224E756D706164457175616C222C302C652C302C652C652C655D2C5B312C3131302C22463133';
wwv_flow_imp.g_varchar2_table(1279) := '222C37312C22463133222C3132342C22564B5F463133222C652C655D2C5B312C3131312C22463134222C37322C22463134222C3132352C22564B5F463134222C652C655D2C5B312C3131322C22463135222C37332C22463135222C3132362C22564B5F46';
wwv_flow_imp.g_varchar2_table(1280) := '3135222C652C655D2C5B312C3131332C22463136222C37342C22463136222C3132372C22564B5F463136222C652C655D2C5B312C3131342C22463137222C37352C22463137222C3132382C22564B5F463137222C652C655D2C5B312C3131352C22463138';
wwv_flow_imp.g_varchar2_table(1281) := '222C37362C22463138222C3132392C22564B5F463138222C652C655D2C5B312C3131362C22463139222C37372C22463139222C3133302C22564B5F463139222C652C655D2C5B312C3131372C22463230222C37382C22463230222C3133312C22564B5F46';
wwv_flow_imp.g_varchar2_table(1282) := '3230222C652C655D2C5B312C3131382C22463231222C37392C22463231222C3133322C22564B5F463231222C652C655D2C5B312C3131392C22463232222C38302C22463232222C3133332C22564B5F463232222C652C655D2C5B312C3132302C22463233';
wwv_flow_imp.g_varchar2_table(1283) := '222C38312C22463233222C3133342C22564B5F463233222C652C655D2C5B312C3132312C22463234222C38322C22463234222C3133352C22564B5F463234222C652C655D2C5B312C3132322C224F70656E222C302C652C302C652C652C655D2C5B312C31';
wwv_flow_imp.g_varchar2_table(1284) := '32332C2248656C70222C302C652C302C652C652C655D2C5B312C3132342C2253656C656374222C302C652C302C652C652C655D2C5B312C3132352C22416761696E222C302C652C302C652C652C655D2C5B312C3132362C22556E646F222C302C652C302C';
wwv_flow_imp.g_varchar2_table(1285) := '652C652C655D2C5B312C3132372C22437574222C302C652C302C652C652C655D2C5B312C3132382C22436F7079222C302C652C302C652C652C655D2C5B312C3132392C225061737465222C302C652C302C652C652C655D2C5B312C3133302C2246696E64';
wwv_flow_imp.g_varchar2_table(1286) := '222C302C652C302C652C652C655D2C5B312C3133312C22417564696F566F6C756D654D757465222C3131372C22417564696F566F6C756D654D757465222C3137332C22564B5F564F4C554D455F4D555445222C652C655D2C5B312C3133322C2241756469';
wwv_flow_imp.g_varchar2_table(1287) := '6F566F6C756D655570222C3131382C22417564696F566F6C756D655570222C3137352C22564B5F564F4C554D455F5550222C652C655D2C5B312C3133332C22417564696F566F6C756D65446F776E222C3131392C22417564696F566F6C756D65446F776E';
wwv_flow_imp.g_varchar2_table(1288) := '222C3137342C22564B5F564F4C554D455F444F574E222C652C655D2C5B312C3133342C224E756D706164436F6D6D61222C3131302C224E756D5061645F536570617261746F72222C3130382C22564B5F534550415241544F52222C652C655D2C5B302C31';
wwv_flow_imp.g_varchar2_table(1289) := '33352C22496E746C526F222C3131352C2241424E545F4331222C3139332C22564B5F41424E545F4331222C652C655D2C5B312C3133362C224B616E614D6F6465222C302C652C302C652C652C655D2C5B302C3133372C22496E746C59656E222C302C652C';
wwv_flow_imp.g_varchar2_table(1290) := '302C652C652C655D2C5B312C3133382C22436F6E76657274222C302C652C302C652C652C655D2C5B312C3133392C224E6F6E436F6E76657274222C302C652C302C652C652C655D2C5B312C3134302C224C616E6731222C302C652C302C652C652C655D2C';
wwv_flow_imp.g_varchar2_table(1291) := '5B312C3134312C224C616E6732222C302C652C302C652C652C655D2C5B312C3134322C224C616E6733222C302C652C302C652C652C655D2C5B312C3134332C224C616E6734222C302C652C302C652C652C655D2C5B312C3134342C224C616E6735222C30';
wwv_flow_imp.g_varchar2_table(1292) := '2C652C302C652C652C655D2C5B312C3134352C2241626F7274222C302C652C302C652C652C655D2C5B312C3134362C2250726F7073222C302C652C302C652C652C655D2C5B312C3134372C224E756D706164506172656E4C656674222C302C652C302C65';
wwv_flow_imp.g_varchar2_table(1293) := '2C652C655D2C5B312C3134382C224E756D706164506172656E5269676874222C302C652C302C652C652C655D2C5B312C3134392C224E756D7061644261636B7370616365222C302C652C302C652C652C655D2C5B312C3135302C224E756D7061644D656D';
wwv_flow_imp.g_varchar2_table(1294) := '6F727953746F7265222C302C652C302C652C652C655D2C5B312C3135312C224E756D7061644D656D6F7279526563616C6C222C302C652C302C652C652C655D2C5B312C3135322C224E756D7061644D656D6F7279436C656172222C302C652C302C652C65';
wwv_flow_imp.g_varchar2_table(1295) := '2C655D2C5B312C3135332C224E756D7061644D656D6F7279416464222C302C652C302C652C652C655D2C5B312C3135342C224E756D7061644D656D6F72795375627472616374222C302C652C302C652C652C655D2C5B312C3135352C224E756D70616443';
wwv_flow_imp.g_varchar2_table(1296) := '6C656172222C3133312C22436C656172222C31322C22564B5F434C454152222C652C655D2C5B312C3135362C224E756D706164436C656172456E747279222C302C652C302C652C652C655D2C5B312C302C652C352C224374726C222C31372C22564B5F43';
wwv_flow_imp.g_varchar2_table(1297) := '4F4E54524F4C222C652C655D2C5B312C302C652C342C225368696674222C31362C22564B5F5348494654222C652C655D2C5B312C302C652C362C22416C74222C31382C22564B5F4D454E55222C652C655D2C5B312C302C652C35372C224D657461222C39';
wwv_flow_imp.g_varchar2_table(1298) := '312C22564B5F434F4D4D414E44222C652C655D2C5B312C3135372C22436F6E74726F6C4C656674222C352C652C302C22564B5F4C434F4E54524F4C222C652C655D2C5B312C3135382C2253686966744C656674222C342C652C302C22564B5F4C53484946';
wwv_flow_imp.g_varchar2_table(1299) := '54222C652C655D2C5B312C3135392C22416C744C656674222C362C652C302C22564B5F4C4D454E55222C652C655D2C5B312C3136302C224D6574614C656674222C35372C652C302C22564B5F4C57494E222C652C655D2C5B312C3136312C22436F6E7472';
wwv_flow_imp.g_varchar2_table(1300) := '6F6C5269676874222C352C652C302C22564B5F52434F4E54524F4C222C652C655D2C5B312C3136322C2253686966745269676874222C342C652C302C22564B5F525348494654222C652C655D2C5B312C3136332C22416C745269676874222C362C652C30';
wwv_flow_imp.g_varchar2_table(1301) := '2C22564B5F524D454E55222C652C655D2C5B312C3136342C224D6574615269676874222C35372C652C302C22564B5F5257494E222C652C655D2C5B312C3136352C224272696768746E6573735570222C302C652C302C652C652C655D2C5B312C3136362C';
wwv_flow_imp.g_varchar2_table(1302) := '224272696768746E657373446F776E222C302C652C302C652C652C655D2C5B312C3136372C224D65646961506C6179222C302C652C302C652C652C655D2C5B312C3136382C224D656469615265636F7264222C302C652C302C652C652C655D2C5B312C31';
wwv_flow_imp.g_varchar2_table(1303) := '36392C224D6564696146617374466F7277617264222C302C652C302C652C652C655D2C5B312C3137302C224D65646961526577696E64222C302C652C302C652C652C655D2C5B312C3137312C224D65646961547261636B4E657874222C3132342C224D65';
wwv_flow_imp.g_varchar2_table(1304) := '646961547261636B4E657874222C3137362C22564B5F4D454449415F4E4558545F545241434B222C652C655D2C5B312C3137322C224D65646961547261636B50726576696F7573222C3132352C224D65646961547261636B50726576696F7573222C3137';
wwv_flow_imp.g_varchar2_table(1305) := '372C22564B5F4D454449415F505245565F545241434B222C652C655D2C5B312C3137332C224D6564696153746F70222C3132362C224D6564696153746F70222C3137382C22564B5F4D454449415F53544F50222C652C655D2C5B312C3137342C22456A65';
wwv_flow_imp.g_varchar2_table(1306) := '6374222C302C652C302C652C652C655D2C5B312C3137352C224D65646961506C61795061757365222C3132372C224D65646961506C61795061757365222C3137392C22564B5F4D454449415F504C41595F5041555345222C652C655D2C5B312C3137362C';
wwv_flow_imp.g_varchar2_table(1307) := '224D6564696153656C656374222C3132382C224C61756E63684D65646961506C61796572222C3138312C22564B5F4D454449415F4C41554E43485F4D454449415F53454C454354222C652C655D2C5B312C3137372C224C61756E63684D61696C222C3132';
wwv_flow_imp.g_varchar2_table(1308) := '392C224C61756E63684D61696C222C3138302C22564B5F4D454449415F4C41554E43485F4D41494C222C652C655D2C5B312C3137382C224C61756E636841707032222C3133302C224C61756E636841707032222C3138332C22564B5F4D454449415F4C41';
wwv_flow_imp.g_varchar2_table(1309) := '554E43485F41505032222C652C655D2C5B312C3137392C224C61756E636841707031222C302C652C302C22564B5F4D454449415F4C41554E43485F41505031222C652C655D2C5B312C3138302C2253656C6563745461736B222C302C652C302C652C652C';
wwv_flow_imp.g_varchar2_table(1310) := '655D2C5B312C3138312C224C61756E636853637265656E5361766572222C302C652C302C652C652C655D2C5B312C3138322C2242726F77736572536561726368222C3132302C2242726F77736572536561726368222C3137302C22564B5F42524F575345';
wwv_flow_imp.g_varchar2_table(1311) := '525F534541524348222C652C655D2C5B312C3138332C2242726F77736572486F6D65222C3132312C2242726F77736572486F6D65222C3137322C22564B5F42524F575345525F484F4D45222C652C655D2C5B312C3138342C2242726F777365724261636B';
wwv_flow_imp.g_varchar2_table(1312) := '222C3132322C2242726F777365724261636B222C3136362C22564B5F42524F575345525F4241434B222C652C655D2C5B312C3138352C2242726F77736572466F7277617264222C3132332C2242726F77736572466F7277617264222C3136372C22564B5F';
wwv_flow_imp.g_varchar2_table(1313) := '42524F575345525F464F5257415244222C652C655D2C5B312C3138362C2242726F7773657253746F70222C302C652C302C22564B5F42524F575345525F53544F50222C652C655D2C5B312C3138372C2242726F7773657252656672657368222C302C652C';
wwv_flow_imp.g_varchar2_table(1314) := '302C22564B5F42524F575345525F52454652455348222C652C655D2C5B312C3138382C2242726F777365724661766F7269746573222C302C652C302C22564B5F42524F575345525F4641564F5249544553222C652C655D2C5B312C3138392C225A6F6F6D';
wwv_flow_imp.g_varchar2_table(1315) := '546F67676C65222C302C652C302C652C652C655D2C5B312C3139302C224D61696C5265706C79222C302C652C302C652C652C655D2C5B312C3139312C224D61696C466F7277617264222C302C652C302C652C652C655D2C5B312C3139322C224D61696C53';
wwv_flow_imp.g_varchar2_table(1316) := '656E64222C302C652C302C652C652C655D2C5B312C302C652C3131342C224B6579496E436F6D706F736974696F6E222C3232392C652C652C655D2C5B312C302C652C3131362C2241424E545F4332222C3139342C22564B5F41424E545F4332222C652C65';
wwv_flow_imp.g_varchar2_table(1317) := '5D2C5B312C302C652C39362C224F454D5F38222C3232332C22564B5F4F454D5F38222C652C655D2C5B312C302C652C302C652C302C22564B5F4B414E41222C652C655D2C5B312C302C652C302C652C302C22564B5F48414E47554C222C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(1318) := '2C302C652C302C652C302C22564B5F4A554E4A41222C652C655D2C5B312C302C652C302C652C302C22564B5F46494E414C222C652C655D2C5B312C302C652C302C652C302C22564B5F48414E4A41222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1319) := '4B5F4B414E4A49222C652C655D2C5B312C302C652C302C652C302C22564B5F434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F41434345';
wwv_flow_imp.g_varchar2_table(1320) := '5054222C652C655D2C5B312C302C652C302C652C302C22564B5F4D4F44454348414E4745222C652C655D2C5B312C302C652C302C652C302C22564B5F53454C454354222C652C655D2C5B312C302C652C302C652C302C22564B5F5052494E54222C652C65';
wwv_flow_imp.g_varchar2_table(1321) := '5D2C5B312C302C652C302C652C302C22564B5F45584543555445222C652C655D2C5B312C302C652C302C652C302C22564B5F534E415053484F54222C652C655D2C5B312C302C652C302C652C302C22564B5F48454C50222C652C655D2C5B312C302C652C';
wwv_flow_imp.g_varchar2_table(1322) := '302C652C302C22564B5F41505053222C652C655D2C5B312C302C652C302C652C302C22564B5F50524F434553534B4559222C652C655D2C5B312C302C652C302C652C302C22564B5F5041434B4554222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1323) := '4B5F4442455F5342435343484152222C652C655D2C5B312C302C652C302C652C302C22564B5F4442455F4442435343484152222C652C655D2C5B312C302C652C302C652C302C22564B5F4154544E222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1324) := '4B5F435253454C222C652C655D2C5B312C302C652C302C652C302C22564B5F455853454C222C652C655D2C5B312C302C652C302C652C302C22564B5F4552454F46222C652C655D2C5B312C302C652C302C652C302C22564B5F504C4159222C652C655D2C';
wwv_flow_imp.g_varchar2_table(1325) := '5B312C302C652C302C652C302C22564B5F5A4F4F4D222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E414D45222C652C655D2C5B312C302C652C302C652C302C22564B5F504131222C652C655D2C5B312C302C652C302C652C302C2256';
wwv_flow_imp.g_varchar2_table(1326) := '4B5F4F454D5F434C454152222C652C655D5D2C6E3D5B5D2C723D5B5D3B666F7228636F6E73742065206F662074297B636F6E73745B742C692C732C6F2C612C6C2C752C632C685D3D653B696628725B695D7C7C28725B695D3D21302C656E5B695D3D732C';
wwv_flow_imp.g_varchar2_table(1327) := '746E5B735D3D692C6E6E5B732E746F4C6F7765724361736528295D3D692C74262628726E5B695D3D6F2C30213D3D6F262633213D3D6F262635213D3D6F262634213D3D6F262636213D3D6F26263537213D3D6F262628736E5B6F5D3D692929292C216E5B';
wwv_flow_imp.g_varchar2_table(1328) := '6F5D297B6966286E5B6F5D3D21302C2161297468726F77206E6577204572726F722860537472696E6720726570726573656E746174696F6E206D697373696E6720666F72206B657920636F646520247B6F7D2061726F756E64207363616E20636F646520';
wwv_flow_imp.g_varchar2_table(1329) := '247B737D60293B4A742E646566696E65286F2C61292C58742E646566696E65286F2C637C7C61292C51742E646566696E65286F2C687C7C637C7C61297D6C2626285A745B6C5D3D6F292C7526262859745B755D3D6F297D736E5B335D3D34367D28292C66';
wwv_flow_imp.g_varchar2_table(1330) := '756E6374696F6E2865297B652E746F537472696E673D66756E6374696F6E2865297B72657475726E204A742E6B6579436F6465546F5374722865297D2C652E66726F6D537472696E673D66756E6374696F6E2865297B72657475726E204A742E73747254';
wwv_flow_imp.g_varchar2_table(1331) := '6F4B6579436F64652865297D2C652E746F5573657253657474696E677355533D66756E6374696F6E2865297B72657475726E2058742E6B6579436F6465546F5374722865297D2C652E746F5573657253657474696E677347656E6572616C3D66756E6374';
wwv_flow_imp.g_varchar2_table(1332) := '696F6E2865297B72657475726E2051742E6B6579436F6465546F5374722865297D2C652E66726F6D5573657253657474696E67733D66756E6374696F6E2865297B72657475726E2058742E737472546F4B6579436F64652865297C7C51742E737472546F';
wwv_flow_imp.g_varchar2_table(1333) := '4B6579436F64652865297D2C652E746F456C656374726F6E416363656C657261746F723D66756E6374696F6E2865297B696628653E3D39382626653C3D3131332972657475726E206E756C6C3B7377697463682865297B636173652031363A7265747572';
wwv_flow_imp.g_varchar2_table(1334) := '6E225570223B636173652031383A72657475726E22446F776E223B636173652031353A72657475726E224C656674223B636173652031373A72657475726E225269676874227D72657475726E204A742E6B6579436F6465546F5374722865297D7D286F6E';
wwv_flow_imp.g_varchar2_table(1335) := '7C7C286F6E3D7B7D29293B636C61737320616E20657874656E64732053747B636F6E7374727563746F7228652C742C6E2C72297B737570657228652C742C6E2C72292C746869732E73656C656374696F6E53746172744C696E654E756D6265723D652C74';
wwv_flow_imp.g_varchar2_table(1336) := '6869732E73656C656374696F6E5374617274436F6C756D6E3D742C746869732E706F736974696F6E4C696E654E756D6265723D6E2C746869732E706F736974696F6E436F6C756D6E3D727D746F537472696E6728297B72657475726E225B222B74686973';
wwv_flow_imp.g_varchar2_table(1337) := '2E73656C656374696F6E53746172744C696E654E756D6265722B222C222B746869732E73656C656374696F6E5374617274436F6C756D6E2B22202D3E20222B746869732E706F736974696F6E4C696E654E756D6265722B222C222B746869732E706F7369';
wwv_flow_imp.g_varchar2_table(1338) := '74696F6E436F6C756D6E2B225D227D657175616C7353656C656374696F6E2865297B72657475726E20616E2E73656C656374696F6E73457175616C28746869732C65297D7374617469632073656C656374696F6E73457175616C28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(1339) := '726E20652E73656C656374696F6E53746172744C696E654E756D6265723D3D3D742E73656C656374696F6E53746172744C696E654E756D6265722626652E73656C656374696F6E5374617274436F6C756D6E3D3D3D742E73656C656374696F6E53746172';
wwv_flow_imp.g_varchar2_table(1340) := '74436F6C756D6E2626652E706F736974696F6E4C696E654E756D6265723D3D3D742E706F736974696F6E4C696E654E756D6265722626652E706F736974696F6E436F6C756D6E3D3D3D742E706F736974696F6E436F6C756D6E7D67657444697265637469';
wwv_flow_imp.g_varchar2_table(1341) := '6F6E28297B72657475726E20746869732E73656C656374696F6E53746172744C696E654E756D6265723D3D3D746869732E73746172744C696E654E756D6265722626746869732E73656C656374696F6E5374617274436F6C756D6E3D3D3D746869732E73';
wwv_flow_imp.g_varchar2_table(1342) := '74617274436F6C756D6E3F303A317D736574456E64506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E657720616E28746869732E73746172744C696E654E756D6265722C746869732E73';
wwv_flow_imp.g_varchar2_table(1343) := '74617274436F6C756D6E2C652C74293A6E657720616E28652C742C746869732E73746172744C696E654E756D6265722C746869732E7374617274436F6C756D6E297D676574506F736974696F6E28297B72657475726E206E657720777428746869732E70';
wwv_flow_imp.g_varchar2_table(1344) := '6F736974696F6E4C696E654E756D6265722C746869732E706F736974696F6E436F6C756D6E297D67657453656C656374696F6E537461727428297B72657475726E206E657720777428746869732E73656C656374696F6E53746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(1345) := '65722C746869732E73656C656374696F6E5374617274436F6C756D6E297D7365745374617274506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E657720616E28652C742C746869732E65';
wwv_flow_imp.g_varchar2_table(1346) := '6E644C696E654E756D6265722C746869732E656E64436F6C756D6E293A6E657720616E28746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E2C652C74297D7374617469632066726F6D506F736974696F6E7328652C743D';
wwv_flow_imp.g_varchar2_table(1347) := '65297B72657475726E206E657720616E28652E6C696E654E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D7374617469632066726F6D52616E676528652C74297B72657475726E20303D3D3D743F6E6577';
wwv_flow_imp.g_varchar2_table(1348) := '20616E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E657720616E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(1349) := '652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D737461746963206C69667453656C656374696F6E2865297B72657475726E206E657720616E28652E73656C656374696F6E53746172744C696E654E756D6265722C652E';
wwv_flow_imp.g_varchar2_table(1350) := '73656C656374696F6E5374617274436F6C756D6E2C652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E297D7374617469632073656C656374696F6E73417272457175616C28652C74297B69662865262621747C';
wwv_flow_imp.g_varchar2_table(1351) := '7C21652626742972657475726E21313B6966282165262621742972657475726E21303B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C6574206E3D302C723D652E6C656E6774683B6E3C723B6E2B2B296966';
wwv_flow_imp.g_varchar2_table(1352) := '2821746869732E73656C656374696F6E73457175616C28655B6E5D2C745B6E5D292972657475726E21313B72657475726E21307D7374617469632069734953656C656374696F6E2865297B72657475726E20652626226E756D626572223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1353) := '6620652E73656C656374696F6E53746172744C696E654E756D6265722626226E756D626572223D3D747970656F6620652E73656C656374696F6E5374617274436F6C756D6E2626226E756D626572223D3D747970656F6620652E706F736974696F6E4C69';
wwv_flow_imp.g_varchar2_table(1354) := '6E654E756D6265722626226E756D626572223D3D747970656F6620652E706F736974696F6E436F6C756D6E7D7374617469632063726561746557697468446972656374696F6E28652C742C6E2C722C69297B72657475726E20303D3D3D693F6E65772061';
wwv_flow_imp.g_varchar2_table(1355) := '6E28652C742C6E2C72293A6E657720616E286E2C722C652C74297D7D636F6E7374206C6E3D4F626A6563742E637265617465286E756C6C293B66756E6374696F6E20756E28652C74297B69662822737472696E67223D3D747970656F662074297B636F6E';
wwv_flow_imp.g_varchar2_table(1356) := '7374206E3D6C6E5B745D3B696628766F696420303D3D3D6E297468726F77206E6577204572726F722860247B657D207265666572656E63657320616E20756E6B6E6F776E20636F6469636F6E3A20247B747D60293B743D6E7D72657475726E206C6E5B65';
wwv_flow_imp.g_varchar2_table(1357) := '5D3D742C7B69643A657D7D636F6E737420636E3D7B6164643A756E2822616464222C366534292C706C75733A756E2822706C7573222C366534292C676973744E65773A756E2822676973742D6E6577222C366534292C7265706F4372656174653A756E28';
wwv_flow_imp.g_varchar2_table(1358) := '227265706F2D637265617465222C366534292C6C6967687462756C623A756E28226C6967687462756C62222C3630303031292C6C6967687442756C623A756E28226C696768742D62756C62222C3630303031292C7265706F3A756E28227265706F222C36';
wwv_flow_imp.g_varchar2_table(1359) := '30303032292C7265706F44656C6574653A756E28227265706F2D64656C657465222C3630303032292C67697374466F726B3A756E2822676973742D666F726B222C3630303033292C7265706F466F726B65643A756E28227265706F2D666F726B6564222C';
wwv_flow_imp.g_varchar2_table(1360) := '3630303033292C67697450756C6C526571756573743A756E28226769742D70756C6C2D72657175657374222C3630303034292C67697450756C6C526571756573744162616E646F6E65643A756E28226769742D70756C6C2D726571756573742D6162616E';
wwv_flow_imp.g_varchar2_table(1361) := '646F6E6564222C3630303034292C7265636F72644B6579733A756E28227265636F72642D6B657973222C3630303035292C6B6579626F6172643A756E28226B6579626F617264222C3630303035292C7461673A756E2822746167222C3630303036292C67';
wwv_flow_imp.g_varchar2_table(1362) := '697450756C6C526571756573744C6162656C3A756E28226769742D70756C6C2D726571756573742D6C6162656C222C3630303036292C7461674164643A756E28227461672D616464222C3630303036292C74616752656D6F76653A756E28227461672D72';
wwv_flow_imp.g_varchar2_table(1363) := '656D6F7665222C3630303036292C706572736F6E3A756E2822706572736F6E222C3630303037292C706572736F6E466F6C6C6F773A756E2822706572736F6E2D666F6C6C6F77222C3630303037292C706572736F6E4F75746C696E653A756E2822706572';
wwv_flow_imp.g_varchar2_table(1364) := '736F6E2D6F75746C696E65222C3630303037292C706572736F6E46696C6C65643A756E2822706572736F6E2D66696C6C6564222C3630303037292C6769744272616E63683A756E28226769742D6272616E6368222C3630303038292C6769744272616E63';
wwv_flow_imp.g_varchar2_table(1365) := '684372656174653A756E28226769742D6272616E63682D637265617465222C3630303038292C6769744272616E636844656C6574653A756E28226769742D6272616E63682D64656C657465222C3630303038292C736F75726365436F6E74726F6C3A756E';
wwv_flow_imp.g_varchar2_table(1366) := '2822736F757263652D636F6E74726F6C222C3630303038292C6D6972726F723A756E28226D6972726F72222C3630303039292C6D6972726F725075626C69633A756E28226D6972726F722D7075626C6963222C3630303039292C737461723A756E282273';
wwv_flow_imp.g_varchar2_table(1367) := '746172222C3630303130292C737461724164643A756E2822737461722D616464222C3630303130292C7374617244656C6574653A756E2822737461722D64656C657465222C3630303130292C73746172456D7074793A756E2822737461722D656D707479';
wwv_flow_imp.g_varchar2_table(1368) := '222C3630303130292C636F6D6D656E743A756E2822636F6D6D656E74222C3630303131292C636F6D6D656E744164643A756E2822636F6D6D656E742D616464222C3630303131292C616C6572743A756E2822616C657274222C3630303132292C7761726E';
wwv_flow_imp.g_varchar2_table(1369) := '696E673A756E28227761726E696E67222C3630303132292C7365617263683A756E2822736561726368222C3630303133292C736561726368536176653A756E28227365617263682D73617665222C3630303133292C6C6F674F75743A756E28226C6F672D';
wwv_flow_imp.g_varchar2_table(1370) := '6F7574222C3630303134292C7369676E4F75743A756E28227369676E2D6F7574222C3630303134292C6C6F67496E3A756E28226C6F672D696E222C3630303135292C7369676E496E3A756E28227369676E2D696E222C3630303135292C6579653A756E28';
wwv_flow_imp.g_varchar2_table(1371) := '22657965222C3630303136292C657965556E77617463683A756E28226579652D756E7761746368222C3630303136292C65796557617463683A756E28226579652D7761746368222C3630303136292C636972636C6546696C6C65643A756E282263697263';
wwv_flow_imp.g_varchar2_table(1372) := '6C652D66696C6C6564222C3630303137292C7072696D6974697665446F743A756E28227072696D69746976652D646F74222C3630303137292C636C6F736544697274793A756E2822636C6F73652D6469727479222C3630303137292C6465627567427265';
wwv_flow_imp.g_varchar2_table(1373) := '616B706F696E743A756E282264656275672D627265616B706F696E74222C3630303137292C6465627567427265616B706F696E7444697361626C65643A756E282264656275672D627265616B706F696E742D64697361626C6564222C3630303137292C64';
wwv_flow_imp.g_varchar2_table(1374) := '6562756748696E743A756E282264656275672D68696E74222C3630303137292C7465726D696E616C4465636F726174696F6E537563636573733A756E28227465726D696E616C2D6465636F726174696F6E2D73756363657373222C3630303137292C7072';
wwv_flow_imp.g_varchar2_table(1375) := '696D69746976655371756172653A756E28227072696D69746976652D737175617265222C3630303138292C656469743A756E282265646974222C3630303139292C70656E63696C3A756E282270656E63696C222C3630303139292C696E666F3A756E2822';
wwv_flow_imp.g_varchar2_table(1376) := '696E666F222C3630303230292C69737375654F70656E65643A756E282269737375652D6F70656E6564222C3630303230292C67697374507269766174653A756E2822676973742D70726976617465222C3630303231292C676974466F726B507269766174';
wwv_flow_imp.g_varchar2_table(1377) := '653A756E28226769742D666F726B2D70726976617465222C3630303231292C6C6F636B3A756E28226C6F636B222C3630303231292C6D6972726F72507269766174653A756E28226D6972726F722D70726976617465222C3630303231292C636C6F73653A';
wwv_flow_imp.g_varchar2_table(1378) := '756E2822636C6F7365222C3630303232292C72656D6F7665436C6F73653A756E282272656D6F76652D636C6F7365222C3630303232292C783A756E282278222C3630303232292C7265706F53796E633A756E28227265706F2D73796E63222C3630303233';
wwv_flow_imp.g_varchar2_table(1379) := '292C73796E633A756E282273796E63222C3630303233292C636C6F6E653A756E2822636C6F6E65222C3630303234292C6465736B746F70446F776E6C6F61643A756E28226465736B746F702D646F776E6C6F6164222C3630303234292C6265616B65723A';
wwv_flow_imp.g_varchar2_table(1380) := '756E28226265616B6572222C3630303235292C6D6963726F73636F70653A756E28226D6963726F73636F7065222C3630303235292C766D3A756E2822766D222C3630303236292C6465766963654465736B746F703A756E28226465766963652D6465736B';
wwv_flow_imp.g_varchar2_table(1381) := '746F70222C3630303236292C66696C653A756E282266696C65222C3630303237292C66696C65546578743A756E282266696C652D74657874222C3630303237292C6D6F72653A756E28226D6F7265222C3630303238292C656C6C69707369733A756E2822';
wwv_flow_imp.g_varchar2_table(1382) := '656C6C6970736973222C3630303238292C6B65626162486F72697A6F6E74616C3A756E28226B656261622D686F72697A6F6E74616C222C3630303238292C6D61696C5265706C793A756E28226D61696C2D7265706C79222C3630303239292C7265706C79';
wwv_flow_imp.g_varchar2_table(1383) := '3A756E28227265706C79222C3630303239292C6F7267616E697A6174696F6E3A756E28226F7267616E697A6174696F6E222C3630303330292C6F7267616E697A6174696F6E46696C6C65643A756E28226F7267616E697A6174696F6E2D66696C6C656422';
wwv_flow_imp.g_varchar2_table(1384) := '2C3630303330292C6F7267616E697A6174696F6E4F75746C696E653A756E28226F7267616E697A6174696F6E2D6F75746C696E65222C3630303330292C6E657746696C653A756E28226E65772D66696C65222C3630303331292C66696C654164643A756E';
wwv_flow_imp.g_varchar2_table(1385) := '282266696C652D616464222C3630303331292C6E6577466F6C6465723A756E28226E65772D666F6C646572222C3630303332292C66696C654469726563746F72794372656174653A756E282266696C652D6469726563746F72792D637265617465222C36';
wwv_flow_imp.g_varchar2_table(1386) := '30303332292C74726173683A756E28227472617368222C3630303333292C747261736863616E3A756E2822747261736863616E222C3630303333292C686973746F72793A756E2822686973746F7279222C3630303334292C636C6F636B3A756E2822636C';
wwv_flow_imp.g_varchar2_table(1387) := '6F636B222C3630303334292C666F6C6465723A756E2822666F6C646572222C3630303335292C66696C654469726563746F72793A756E282266696C652D6469726563746F7279222C3630303335292C73796D626F6C466F6C6465723A756E282273796D62';
wwv_flow_imp.g_varchar2_table(1388) := '6F6C2D666F6C646572222C3630303335292C6C6F676F4769746875623A756E28226C6F676F2D676974687562222C3630303336292C6D61726B4769746875623A756E28226D61726B2D676974687562222C3630303336292C6769746875623A756E282267';
wwv_flow_imp.g_varchar2_table(1389) := '6974687562222C3630303336292C7465726D696E616C3A756E28227465726D696E616C222C3630303337292C636F6E736F6C653A756E2822636F6E736F6C65222C3630303337292C7265706C3A756E28227265706C222C3630303337292C7A61703A756E';
wwv_flow_imp.g_varchar2_table(1390) := '28227A6170222C3630303338292C73796D626F6C4576656E743A756E282273796D626F6C2D6576656E74222C3630303338292C6572726F723A756E28226572726F72222C3630303339292C73746F703A756E282273746F70222C3630303339292C766172';
wwv_flow_imp.g_varchar2_table(1391) := '6961626C653A756E28227661726961626C65222C3630303430292C73796D626F6C5661726961626C653A756E282273796D626F6C2D7661726961626C65222C3630303430292C61727261793A756E28226172726179222C3630303432292C73796D626F6C';
wwv_flow_imp.g_varchar2_table(1392) := '41727261793A756E282273796D626F6C2D6172726179222C3630303432292C73796D626F6C4D6F64756C653A756E282273796D626F6C2D6D6F64756C65222C3630303433292C73796D626F6C5061636B6167653A756E282273796D626F6C2D7061636B61';
wwv_flow_imp.g_varchar2_table(1393) := '6765222C3630303433292C73796D626F6C4E616D6573706163653A756E282273796D626F6C2D6E616D657370616365222C3630303433292C73796D626F6C4F626A6563743A756E282273796D626F6C2D6F626A656374222C3630303433292C73796D626F';
wwv_flow_imp.g_varchar2_table(1394) := '6C4D6574686F643A756E282273796D626F6C2D6D6574686F64222C3630303434292C73796D626F6C46756E6374696F6E3A756E282273796D626F6C2D66756E6374696F6E222C3630303434292C73796D626F6C436F6E7374727563746F723A756E282273';
wwv_flow_imp.g_varchar2_table(1395) := '796D626F6C2D636F6E7374727563746F72222C3630303434292C73796D626F6C426F6F6C65616E3A756E282273796D626F6C2D626F6F6C65616E222C3630303437292C73796D626F6C4E756C6C3A756E282273796D626F6C2D6E756C6C222C3630303437';
wwv_flow_imp.g_varchar2_table(1396) := '292C73796D626F6C4E756D657269633A756E282273796D626F6C2D6E756D65726963222C3630303438292C73796D626F6C4E756D6265723A756E282273796D626F6C2D6E756D626572222C3630303438292C73796D626F6C5374727563747572653A756E';
wwv_flow_imp.g_varchar2_table(1397) := '282273796D626F6C2D737472756374757265222C3630303439292C73796D626F6C5374727563743A756E282273796D626F6C2D737472756374222C3630303439292C73796D626F6C506172616D657465723A756E282273796D626F6C2D706172616D6574';
wwv_flow_imp.g_varchar2_table(1398) := '6572222C3630303530292C73796D626F6C54797065506172616D657465723A756E282273796D626F6C2D747970652D706172616D65746572222C3630303530292C73796D626F6C4B65793A756E282273796D626F6C2D6B6579222C3630303531292C7379';
wwv_flow_imp.g_varchar2_table(1399) := '6D626F6C546578743A756E282273796D626F6C2D74657874222C3630303531292C73796D626F6C5265666572656E63653A756E282273796D626F6C2D7265666572656E6365222C3630303532292C676F546F46696C653A756E2822676F2D746F2D66696C';
wwv_flow_imp.g_varchar2_table(1400) := '65222C3630303532292C73796D626F6C456E756D3A756E282273796D626F6C2D656E756D222C3630303533292C73796D626F6C56616C75653A756E282273796D626F6C2D76616C7565222C3630303533292C73796D626F6C52756C65723A756E28227379';
wwv_flow_imp.g_varchar2_table(1401) := '6D626F6C2D72756C6572222C3630303534292C73796D626F6C556E69743A756E282273796D626F6C2D756E6974222C3630303534292C6163746976617465427265616B706F696E74733A756E282261637469766174652D627265616B706F696E7473222C';
wwv_flow_imp.g_varchar2_table(1402) := '3630303535292C617263686976653A756E282261726368697665222C3630303536292C6172726F77426F74683A756E28226172726F772D626F7468222C3630303537292C6172726F77446F776E3A756E28226172726F772D646F776E222C363030353829';
wwv_flow_imp.g_varchar2_table(1403) := '2C6172726F774C6566743A756E28226172726F772D6C656674222C3630303539292C6172726F7752696768743A756E28226172726F772D7269676874222C3630303630292C6172726F77536D616C6C446F776E3A756E28226172726F772D736D616C6C2D';
wwv_flow_imp.g_varchar2_table(1404) := '646F776E222C3630303631292C6172726F77536D616C6C4C6566743A756E28226172726F772D736D616C6C2D6C656674222C3630303632292C6172726F77536D616C6C52696768743A756E28226172726F772D736D616C6C2D7269676874222C36303036';
wwv_flow_imp.g_varchar2_table(1405) := '33292C6172726F77536D616C6C55703A756E28226172726F772D736D616C6C2D7570222C3630303634292C6172726F7755703A756E28226172726F772D7570222C3630303635292C62656C6C3A756E282262656C6C222C3630303636292C626F6C643A75';
wwv_flow_imp.g_varchar2_table(1406) := '6E2822626F6C64222C3630303637292C626F6F6B3A756E2822626F6F6B222C3630303638292C626F6F6B6D61726B3A756E2822626F6F6B6D61726B222C3630303639292C6465627567427265616B706F696E74436F6E646974696F6E616C556E76657269';
wwv_flow_imp.g_varchar2_table(1407) := '666965643A756E282264656275672D627265616B706F696E742D636F6E646974696F6E616C2D756E7665726966696564222C3630303730292C6465627567427265616B706F696E74436F6E646974696F6E616C3A756E282264656275672D627265616B70';
wwv_flow_imp.g_varchar2_table(1408) := '6F696E742D636F6E646974696F6E616C222C3630303731292C6465627567427265616B706F696E74436F6E646974696F6E616C44697361626C65643A756E282264656275672D627265616B706F696E742D636F6E646974696F6E616C2D64697361626C65';
wwv_flow_imp.g_varchar2_table(1409) := '64222C3630303731292C6465627567427265616B706F696E7444617461556E76657269666965643A756E282264656275672D627265616B706F696E742D646174612D756E7665726966696564222C3630303732292C6465627567427265616B706F696E74';
wwv_flow_imp.g_varchar2_table(1410) := '446174613A756E282264656275672D627265616B706F696E742D64617461222C3630303733292C6465627567427265616B706F696E744461746144697361626C65643A756E282264656275672D627265616B706F696E742D646174612D64697361626C65';
wwv_flow_imp.g_varchar2_table(1411) := '64222C3630303733292C6465627567427265616B706F696E744C6F67556E76657269666965643A756E282264656275672D627265616B706F696E742D6C6F672D756E7665726966696564222C3630303734292C6465627567427265616B706F696E744C6F';
wwv_flow_imp.g_varchar2_table(1412) := '673A756E282264656275672D627265616B706F696E742D6C6F67222C3630303735292C6465627567427265616B706F696E744C6F6744697361626C65643A756E282264656275672D627265616B706F696E742D6C6F672D64697361626C6564222C363030';
wwv_flow_imp.g_varchar2_table(1413) := '3735292C6272696566636173653A756E2822627269656663617365222C3630303736292C62726F6164636173743A756E282262726F616463617374222C3630303737292C62726F777365723A756E282262726F77736572222C3630303738292C6275673A';
wwv_flow_imp.g_varchar2_table(1414) := '756E2822627567222C3630303739292C63616C656E6461723A756E282263616C656E646172222C3630303830292C6361736553656E7369746976653A756E2822636173652D73656E736974697665222C3630303831292C636865636B3A756E2822636865';
wwv_flow_imp.g_varchar2_table(1415) := '636B222C3630303832292C636865636B6C6973743A756E2822636865636B6C697374222C3630303833292C63686576726F6E446F776E3A756E282263686576726F6E2D646F776E222C3630303834292C63686576726F6E4C6566743A756E282263686576';
wwv_flow_imp.g_varchar2_table(1416) := '726F6E2D6C656674222C3630303835292C63686576726F6E52696768743A756E282263686576726F6E2D7269676874222C3630303836292C63686576726F6E55703A756E282263686576726F6E2D7570222C3630303837292C6368726F6D65436C6F7365';
wwv_flow_imp.g_varchar2_table(1417) := '3A756E28226368726F6D652D636C6F7365222C3630303838292C6368726F6D654D6178696D697A653A756E28226368726F6D652D6D6178696D697A65222C3630303839292C6368726F6D654D696E696D697A653A756E28226368726F6D652D6D696E696D';
wwv_flow_imp.g_varchar2_table(1418) := '697A65222C3630303930292C6368726F6D65526573746F72653A756E28226368726F6D652D726573746F7265222C3630303931292C636972636C654F75746C696E653A756E2822636972636C652D6F75746C696E65222C3630303932292C636972636C65';
wwv_flow_imp.g_varchar2_table(1419) := '3A756E2822636972636C65222C3630303932292C6465627567427265616B706F696E74556E76657269666965643A756E282264656275672D627265616B706F696E742D756E7665726966696564222C3630303932292C7465726D696E616C4465636F7261';
wwv_flow_imp.g_varchar2_table(1420) := '74696F6E496E636F6D706C6574653A756E28227465726D696E616C2D6465636F726174696F6E2D696E636F6D706C657465222C3630303932292C636972636C65536C6173683A756E2822636972636C652D736C617368222C3630303933292C6369726375';
wwv_flow_imp.g_varchar2_table(1421) := '6974426F6172643A756E2822636972637569742D626F617264222C3630303934292C636C656172416C6C3A756E2822636C6561722D616C6C222C3630303935292C636C697070793A756E2822636C69707079222C3630303936292C636C6F7365416C6C3A';
wwv_flow_imp.g_varchar2_table(1422) := '756E2822636C6F73652D616C6C222C3630303937292C636C6F7564446F776E6C6F61643A756E2822636C6F75642D646F776E6C6F6164222C3630303938292C636C6F756455706C6F61643A756E2822636C6F75642D75706C6F6164222C3630303939292C';
wwv_flow_imp.g_varchar2_table(1423) := '636F64653A756E2822636F6465222C3630313030292C636F6C6C61707365416C6C3A756E2822636F6C6C617073652D616C6C222C3630313031292C636F6C6F724D6F64653A756E2822636F6C6F722D6D6F6465222C3630313032292C636F6D6D656E7444';
wwv_flow_imp.g_varchar2_table(1424) := '697363757373696F6E3A756E2822636F6D6D656E742D64697363757373696F6E222C3630313033292C637265646974436172643A756E28226372656469742D63617264222C3630313035292C646173683A756E282264617368222C3630313038292C6461';
wwv_flow_imp.g_varchar2_table(1425) := '7368626F6172643A756E282264617368626F617264222C3630313039292C64617461626173653A756E28226461746162617365222C3630313130292C6465627567436F6E74696E75653A756E282264656275672D636F6E74696E7565222C363031313129';
wwv_flow_imp.g_varchar2_table(1426) := '2C6465627567446973636F6E6E6563743A756E282264656275672D646973636F6E6E656374222C3630313132292C646562756750617573653A756E282264656275672D7061757365222C3630313133292C6465627567526573746172743A756E28226465';
wwv_flow_imp.g_varchar2_table(1427) := '6275672D72657374617274222C3630313134292C646562756753746172743A756E282264656275672D7374617274222C3630313135292C646562756753746570496E746F3A756E282264656275672D737465702D696E746F222C3630313136292C646562';
wwv_flow_imp.g_varchar2_table(1428) := '7567537465704F75743A756E282264656275672D737465702D6F7574222C3630313137292C6465627567537465704F7665723A756E282264656275672D737465702D6F766572222C3630313138292C646562756753746F703A756E282264656275672D73';
wwv_flow_imp.g_varchar2_table(1429) := '746F70222C3630313139292C64656275673A756E28226465627567222C3630313230292C64657669636543616D657261566964656F3A756E28226465766963652D63616D6572612D766964656F222C3630313231292C64657669636543616D6572613A75';
wwv_flow_imp.g_varchar2_table(1430) := '6E28226465766963652D63616D657261222C3630313232292C6465766963654D6F62696C653A756E28226465766963652D6D6F62696C65222C3630313233292C6469666641646465643A756E2822646966662D6164646564222C3630313234292C646966';
wwv_flow_imp.g_varchar2_table(1431) := '6649676E6F7265643A756E2822646966662D69676E6F726564222C3630313235292C646966664D6F6469666965643A756E2822646966662D6D6F646966696564222C3630313236292C6469666652656D6F7665643A756E2822646966662D72656D6F7665';
wwv_flow_imp.g_varchar2_table(1432) := '64222C3630313237292C6469666652656E616D65643A756E2822646966662D72656E616D6564222C3630313238292C646966663A756E282264696666222C3630313239292C64696666536964656279736964653A756E2822646966662D73696465627973';
wwv_flow_imp.g_varchar2_table(1433) := '696465222C3630313239292C646973636172643A756E282264697363617264222C3630313330292C656469746F724C61796F75743A756E2822656469746F722D6C61796F7574222C3630313331292C656D70747957696E646F773A756E2822656D707479';
wwv_flow_imp.g_varchar2_table(1434) := '2D77696E646F77222C3630313332292C6578636C7564653A756E28226578636C756465222C3630313333292C657874656E73696F6E733A756E2822657874656E73696F6E73222C3630313334292C657965436C6F7365643A756E28226579652D636C6F73';
wwv_flow_imp.g_varchar2_table(1435) := '6564222C3630313335292C66696C6542696E6172793A756E282266696C652D62696E617279222C3630313336292C66696C65436F64653A756E282266696C652D636F6465222C3630313337292C66696C654D656469613A756E282266696C652D6D656469';
wwv_flow_imp.g_varchar2_table(1436) := '61222C3630313338292C66696C655064663A756E282266696C652D706466222C3630313339292C66696C655375626D6F64756C653A756E282266696C652D7375626D6F64756C65222C3630313430292C66696C6553796D6C696E6B4469726563746F7279';
wwv_flow_imp.g_varchar2_table(1437) := '3A756E282266696C652D73796D6C696E6B2D6469726563746F7279222C3630313431292C66696C6553796D6C696E6B46696C653A756E282266696C652D73796D6C696E6B2D66696C65222C3630313432292C66696C655A69703A756E282266696C652D7A';
wwv_flow_imp.g_varchar2_table(1438) := '6970222C3630313433292C66696C65733A756E282266696C6573222C3630313434292C66696C7465723A756E282266696C746572222C3630313435292C666C616D653A756E2822666C616D65222C3630313436292C666F6C64446F776E3A756E2822666F';
wwv_flow_imp.g_varchar2_table(1439) := '6C642D646F776E222C3630313437292C666F6C6455703A756E2822666F6C642D7570222C3630313438292C666F6C643A756E2822666F6C64222C3630313439292C666F6C6465724163746976653A756E2822666F6C6465722D616374697665222C363031';
wwv_flow_imp.g_varchar2_table(1440) := '3530292C666F6C6465724F70656E65643A756E2822666F6C6465722D6F70656E6564222C3630313531292C676561723A756E282267656172222C3630313532292C676966743A756E282267696674222C3630313533292C676973745365637265743A756E';
wwv_flow_imp.g_varchar2_table(1441) := '2822676973742D736563726574222C3630313534292C676973743A756E282267697374222C3630313535292C676974436F6D6D69743A756E28226769742D636F6D6D6974222C3630313536292C676974436F6D706172653A756E28226769742D636F6D70';
wwv_flow_imp.g_varchar2_table(1442) := '617265222C3630313537292C636F6D706172654368616E6765733A756E2822636F6D706172652D6368616E676573222C3630313537292C6769744D657267653A756E28226769742D6D65726765222C3630313538292C676974687562416374696F6E3A75';
wwv_flow_imp.g_varchar2_table(1443) := '6E28226769746875622D616374696F6E222C3630313539292C676974687562416C743A756E28226769746875622D616C74222C3630313630292C676C6F62653A756E2822676C6F6265222C3630313631292C677261626265723A756E2822677261626265';
wwv_flow_imp.g_varchar2_table(1444) := '72222C3630313632292C67726170683A756E28226772617068222C3630313633292C677269707065723A756E282267726970706572222C3630313634292C68656172743A756E28226865617274222C3630313635292C686F6D653A756E2822686F6D6522';
wwv_flow_imp.g_varchar2_table(1445) := '2C3630313636292C686F72697A6F6E74616C52756C653A756E2822686F72697A6F6E74616C2D72756C65222C3630313637292C6875626F743A756E28226875626F74222C3630313638292C696E626F783A756E2822696E626F78222C3630313639292C69';
wwv_flow_imp.g_varchar2_table(1446) := '7373756552656F70656E65643A756E282269737375652D72656F70656E6564222C3630313731292C6973737565733A756E2822697373756573222C3630313732292C6974616C69633A756E28226974616C6963222C3630313733292C6A65727365793A75';
wwv_flow_imp.g_varchar2_table(1447) := '6E28226A6572736579222C3630313734292C6A736F6E3A756E28226A736F6E222C3630313735292C6B65626162566572746963616C3A756E28226B656261622D766572746963616C222C3630313736292C6B65793A756E28226B6579222C363031373729';
wwv_flow_imp.g_varchar2_table(1448) := '2C6C61773A756E28226C6177222C3630313738292C6C6967687462756C624175746F6669783A756E28226C6967687462756C622D6175746F666978222C3630313739292C6C696E6B45787465726E616C3A756E28226C696E6B2D65787465726E616C222C';
wwv_flow_imp.g_varchar2_table(1449) := '3630313830292C6C696E6B3A756E28226C696E6B222C3630313831292C6C6973744F7264657265643A756E28226C6973742D6F726465726564222C3630313832292C6C697374556E6F7264657265643A756E28226C6973742D756E6F726465726564222C';
wwv_flow_imp.g_varchar2_table(1450) := '3630313833292C6C69766553686172653A756E28226C6976652D7368617265222C3630313834292C6C6F6164696E673A756E28226C6F6164696E67222C3630313835292C6C6F636174696F6E3A756E28226C6F636174696F6E222C3630313836292C6D61';
wwv_flow_imp.g_varchar2_table(1451) := '696C526561643A756E28226D61696C2D72656164222C3630313837292C6D61696C3A756E28226D61696C222C3630313838292C6D61726B646F776E3A756E28226D61726B646F776E222C3630313839292C6D65676170686F6E653A756E28226D65676170';
wwv_flow_imp.g_varchar2_table(1452) := '686F6E65222C3630313930292C6D656E74696F6E3A756E28226D656E74696F6E222C3630313931292C6D696C6573746F6E653A756E28226D696C6573746F6E65222C3630313932292C67697450756C6C526571756573744D696C6573746F6E653A756E28';
wwv_flow_imp.g_varchar2_table(1453) := '226769742D70756C6C2D726571756573742D6D696C6573746F6E65222C3630313932292C6D6F72746172426F6172643A756E28226D6F727461722D626F617264222C3630313933292C6D6F76653A756E28226D6F7665222C3630313934292C6D756C7469';
wwv_flow_imp.g_varchar2_table(1454) := '706C6557696E646F77733A756E28226D756C7469706C652D77696E646F7773222C3630313935292C6D7574653A756E28226D757465222C3630313936292C6E6F4E65776C696E653A756E28226E6F2D6E65776C696E65222C3630313937292C6E6F74653A';
wwv_flow_imp.g_varchar2_table(1455) := '756E28226E6F7465222C3630313938292C6F63746F666163653A756E28226F63746F66616365222C3630313939292C6F70656E507265766965773A756E28226F70656E2D70726576696577222C3630323030292C7061636B6167653A756E28227061636B';
wwv_flow_imp.g_varchar2_table(1456) := '616765222C3630323031292C7061696E7463616E3A756E28227061696E7463616E222C3630323032292C70696E3A756E282270696E222C3630323033292C706C61793A756E2822706C6179222C3630323034292C72756E3A756E282272756E222C363032';
wwv_flow_imp.g_varchar2_table(1457) := '3034292C706C75673A756E2822706C7567222C3630323035292C7072657365727665436173653A756E282270726573657276652D63617365222C3630323036292C707265766965773A756E282270726576696577222C3630323037292C70726F6A656374';
wwv_flow_imp.g_varchar2_table(1458) := '3A756E282270726F6A656374222C3630323038292C70756C73653A756E282270756C7365222C3630323039292C7175657374696F6E3A756E28227175657374696F6E222C3630323130292C71756F74653A756E282271756F7465222C3630323131292C72';
wwv_flow_imp.g_varchar2_table(1459) := '6164696F546F7765723A756E2822726164696F2D746F776572222C3630323132292C7265616374696F6E733A756E28227265616374696F6E73222C3630323133292C7265666572656E6365733A756E28227265666572656E636573222C3630323134292C';
wwv_flow_imp.g_varchar2_table(1460) := '726566726573683A756E282272656672657368222C3630323135292C72656765783A756E28227265676578222C3630323136292C72656D6F74654578706C6F7265723A756E282272656D6F74652D6578706C6F726572222C3630323137292C72656D6F74';
wwv_flow_imp.g_varchar2_table(1461) := '653A756E282272656D6F7465222C3630323138292C72656D6F76653A756E282272656D6F7665222C3630323139292C7265706C616365416C6C3A756E28227265706C6163652D616C6C222C3630323230292C7265706C6163653A756E28227265706C6163';
wwv_flow_imp.g_varchar2_table(1462) := '65222C3630323231292C7265706F436C6F6E653A756E28227265706F2D636C6F6E65222C3630323232292C7265706F466F726365507573683A756E28227265706F2D666F7263652D70757368222C3630323233292C7265706F50756C6C3A756E28227265';
wwv_flow_imp.g_varchar2_table(1463) := '706F2D70756C6C222C3630323234292C7265706F507573683A756E28227265706F2D70757368222C3630323235292C7265706F72743A756E28227265706F7274222C3630323236292C726571756573744368616E6765733A756E2822726571756573742D';
wwv_flow_imp.g_varchar2_table(1464) := '6368616E676573222C3630323237292C726F636B65743A756E2822726F636B6574222C3630323238292C726F6F74466F6C6465724F70656E65643A756E2822726F6F742D666F6C6465722D6F70656E6564222C3630323239292C726F6F74466F6C646572';
wwv_flow_imp.g_varchar2_table(1465) := '3A756E2822726F6F742D666F6C646572222C3630323330292C7273733A756E2822727373222C3630323331292C727562793A756E282272756279222C3630323332292C73617665416C6C3A756E2822736176652D616C6C222C3630323333292C73617665';
wwv_flow_imp.g_varchar2_table(1466) := '41733A756E2822736176652D6173222C3630323334292C736176653A756E282273617665222C3630323335292C73637265656E46756C6C3A756E282273637265656E2D66756C6C222C3630323336292C73637265656E4E6F726D616C3A756E2822736372';
wwv_flow_imp.g_varchar2_table(1467) := '65656E2D6E6F726D616C222C3630323337292C73656172636853746F703A756E28227365617263682D73746F70222C3630323338292C7365727665723A756E2822736572766572222C3630323430292C73657474696E6773476561723A756E2822736574';
wwv_flow_imp.g_varchar2_table(1468) := '74696E67732D67656172222C3630323431292C73657474696E67733A756E282273657474696E6773222C3630323432292C736869656C643A756E2822736869656C64222C3630323433292C736D696C65793A756E2822736D696C6579222C363032343429';
wwv_flow_imp.g_varchar2_table(1469) := '2C736F7274507265636564656E63653A756E2822736F72742D707265636564656E6365222C3630323435292C73706C6974486F72697A6F6E74616C3A756E282273706C69742D686F72697A6F6E74616C222C3630323436292C73706C6974566572746963';
wwv_flow_imp.g_varchar2_table(1470) := '616C3A756E282273706C69742D766572746963616C222C3630323437292C737175697272656C3A756E2822737175697272656C222C3630323438292C7374617246756C6C3A756E2822737461722D66756C6C222C3630323439292C7374617248616C663A';
wwv_flow_imp.g_varchar2_table(1471) := '756E2822737461722D68616C66222C3630323530292C73796D626F6C436C6173733A756E282273796D626F6C2D636C617373222C3630323531292C73796D626F6C436F6C6F723A756E282273796D626F6C2D636F6C6F72222C3630323532292C73796D62';
wwv_flow_imp.g_varchar2_table(1472) := '6F6C436F6E7374616E743A756E282273796D626F6C2D636F6E7374616E74222C3630323533292C73796D626F6C456E756D4D656D6265723A756E282273796D626F6C2D656E756D2D6D656D626572222C3630323534292C73796D626F6C4669656C643A75';
wwv_flow_imp.g_varchar2_table(1473) := '6E282273796D626F6C2D6669656C64222C3630323535292C73796D626F6C46696C653A756E282273796D626F6C2D66696C65222C3630323536292C73796D626F6C496E746572666163653A756E282273796D626F6C2D696E74657266616365222C363032';
wwv_flow_imp.g_varchar2_table(1474) := '3537292C73796D626F6C4B6579776F72643A756E282273796D626F6C2D6B6579776F7264222C3630323538292C73796D626F6C4D6973633A756E282273796D626F6C2D6D697363222C3630323539292C73796D626F6C4F70657261746F723A756E282273';
wwv_flow_imp.g_varchar2_table(1475) := '796D626F6C2D6F70657261746F72222C3630323630292C73796D626F6C50726F70657274793A756E282273796D626F6C2D70726F7065727479222C3630323631292C7772656E63683A756E28227772656E6368222C3630323631292C7772656E63685375';
wwv_flow_imp.g_varchar2_table(1476) := '62616374696F6E3A756E28227772656E63682D737562616374696F6E222C3630323631292C73796D626F6C536E69707065743A756E282273796D626F6C2D736E6970706574222C3630323632292C7461736B6C6973743A756E28227461736B6C69737422';
wwv_flow_imp.g_varchar2_table(1477) := '2C3630323633292C74656C6573636F70653A756E282274656C6573636F7065222C3630323634292C7465787453697A653A756E2822746578742D73697A65222C3630323635292C7468726565426172733A756E282274687265652D62617273222C363032';
wwv_flow_imp.g_varchar2_table(1478) := '3636292C7468756D6273646F776E3A756E28227468756D6273646F776E222C3630323637292C7468756D627375703A756E28227468756D62737570222C3630323638292C746F6F6C733A756E2822746F6F6C73222C3630323639292C747269616E676C65';
wwv_flow_imp.g_varchar2_table(1479) := '446F776E3A756E2822747269616E676C652D646F776E222C3630323730292C747269616E676C654C6566743A756E2822747269616E676C652D6C656674222C3630323731292C747269616E676C6552696768743A756E2822747269616E676C652D726967';
wwv_flow_imp.g_varchar2_table(1480) := '6874222C3630323732292C747269616E676C6555703A756E2822747269616E676C652D7570222C3630323733292C747769747465723A756E282274776974746572222C3630323734292C756E666F6C643A756E2822756E666F6C64222C3630323735292C';
wwv_flow_imp.g_varchar2_table(1481) := '756E6C6F636B3A756E2822756E6C6F636B222C3630323736292C756E6D7574653A756E2822756E6D757465222C3630323737292C756E76657269666965643A756E2822756E7665726966696564222C3630323738292C76657269666965643A756E282276';
wwv_flow_imp.g_varchar2_table(1482) := '65726966696564222C3630323739292C76657273696F6E733A756E282276657273696F6E73222C3630323830292C766D4163746976653A756E2822766D2D616374697665222C3630323831292C766D4F75746C696E653A756E2822766D2D6F75746C696E';
wwv_flow_imp.g_varchar2_table(1483) := '65222C3630323832292C766D52756E6E696E673A756E2822766D2D72756E6E696E67222C3630323833292C77617463683A756E28227761746368222C3630323834292C776869746573706163653A756E282277686974657370616365222C363032383529';
wwv_flow_imp.g_varchar2_table(1484) := '2C77686F6C65576F72643A756E282277686F6C652D776F7264222C3630323836292C77696E646F773A756E282277696E646F77222C3630323837292C776F7264577261703A756E2822776F72642D77726170222C3630323838292C7A6F6F6D496E3A756E';
wwv_flow_imp.g_varchar2_table(1485) := '28227A6F6F6D2D696E222C3630323839292C7A6F6F6D4F75743A756E28227A6F6F6D2D6F7574222C3630323930292C6C69737446696C7465723A756E28226C6973742D66696C746572222C3630323931292C6C697374466C61743A756E28226C6973742D';
wwv_flow_imp.g_varchar2_table(1486) := '666C6174222C3630323932292C6C69737453656C656374696F6E3A756E28226C6973742D73656C656374696F6E222C3630323933292C73656C656374696F6E3A756E282273656C656374696F6E222C3630323933292C6C697374547265653A756E28226C';
wwv_flow_imp.g_varchar2_table(1487) := '6973742D74726565222C3630323934292C6465627567427265616B706F696E7446756E6374696F6E556E76657269666965643A756E282264656275672D627265616B706F696E742D66756E6374696F6E2D756E7665726966696564222C3630323935292C';
wwv_flow_imp.g_varchar2_table(1488) := '6465627567427265616B706F696E7446756E6374696F6E3A756E282264656275672D627265616B706F696E742D66756E6374696F6E222C3630323936292C6465627567427265616B706F696E7446756E6374696F6E44697361626C65643A756E28226465';
wwv_flow_imp.g_varchar2_table(1489) := '6275672D627265616B706F696E742D66756E6374696F6E2D64697361626C6564222C3630323936292C6465627567537461636B6672616D654163746976653A756E282264656275672D737461636B6672616D652D616374697665222C3630323937292C63';
wwv_flow_imp.g_varchar2_table(1490) := '6972636C65536D616C6C46696C6C65643A756E2822636972636C652D736D616C6C2D66696C6C6564222C3630323938292C6465627567537461636B6672616D65446F743A756E282264656275672D737461636B6672616D652D646F74222C363032393829';
wwv_flow_imp.g_varchar2_table(1491) := '2C7465726D696E616C4465636F726174696F6E4D61726B3A756E28227465726D696E616C2D6465636F726174696F6E2D6D61726B222C3630323938292C6465627567537461636B6672616D653A756E282264656275672D737461636B6672616D65222C36';
wwv_flow_imp.g_varchar2_table(1492) := '30323939292C6465627567537461636B6672616D65466F63757365643A756E282264656275672D737461636B6672616D652D666F6375736564222C3630323939292C6465627567427265616B706F696E74556E737570706F727465643A756E2822646562';
wwv_flow_imp.g_varchar2_table(1493) := '75672D627265616B706F696E742D756E737570706F72746564222C3630333030292C73796D626F6C537472696E673A756E282273796D626F6C2D737472696E67222C3630333031292C646562756752657665727365436F6E74696E75653A756E28226465';
wwv_flow_imp.g_varchar2_table(1494) := '6275672D726576657273652D636F6E74696E7565222C3630333032292C6465627567537465704261636B3A756E282264656275672D737465702D6261636B222C3630333033292C6465627567526573746172744672616D653A756E282264656275672D72';
wwv_flow_imp.g_varchar2_table(1495) := '6573746172742D6672616D65222C3630333034292C6465627567416C743A756E282264656275672D616C74222C3630333035292C63616C6C496E636F6D696E673A756E282263616C6C2D696E636F6D696E67222C3630333036292C63616C6C4F7574676F';
wwv_flow_imp.g_varchar2_table(1496) := '696E673A756E282263616C6C2D6F7574676F696E67222C3630333037292C6D656E753A756E28226D656E75222C3630333038292C657870616E64416C6C3A756E2822657870616E642D616C6C222C3630333039292C666565646261636B3A756E28226665';
wwv_flow_imp.g_varchar2_table(1497) := '65646261636B222C3630333130292C67697450756C6C5265717565737452657669657765723A756E28226769742D70756C6C2D726571756573742D7265766965776572222C3630333130292C67726F75704279526566547970653A756E282267726F7570';
wwv_flow_imp.g_varchar2_table(1498) := '2D62792D7265662D74797065222C3630333131292C756E67726F75704279526566547970653A756E2822756E67726F75702D62792D7265662D74797065222C3630333132292C6163636F756E743A756E28226163636F756E74222C3630333133292C6769';
wwv_flow_imp.g_varchar2_table(1499) := '7450756C6C5265717565737441737369676E65653A756E28226769742D70756C6C2D726571756573742D61737369676E6565222C3630333133292C62656C6C446F743A756E282262656C6C2D646F74222C3630333134292C6465627567436F6E736F6C65';
wwv_flow_imp.g_varchar2_table(1500) := '3A756E282264656275672D636F6E736F6C65222C3630333135292C6C6962726172793A756E28226C696272617279222C3630333136292C6F75747075743A756E28226F7574707574222C3630333137292C72756E416C6C3A756E282272756E2D616C6C22';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '2C3630333138292C73796E6349676E6F7265643A756E282273796E632D69676E6F726564222C3630333139292C70696E6E65643A756E282270696E6E6564222C3630333230292C676974687562496E7665727465643A756E28226769746875622D696E76';
wwv_flow_imp.g_varchar2_table(1502) := '6572746564222C3630333231292C73657276657250726F636573733A756E28227365727665722D70726F63657373222C3630333232292C736572766572456E7669726F6E6D656E743A756E28227365727665722D656E7669726F6E6D656E74222C363033';
wwv_flow_imp.g_varchar2_table(1503) := '3233292C706173733A756E282270617373222C3630333234292C6973737565436C6F7365643A756E282269737375652D636C6F736564222C3630333234292C73746F70436972636C653A756E282273746F702D636972636C65222C3630333235292C706C';
wwv_flow_imp.g_varchar2_table(1504) := '6179436972636C653A756E2822706C61792D636972636C65222C3630333236292C7265636F72643A756E28227265636F7264222C3630333237292C6465627567416C74536D616C6C3A756E282264656275672D616C742D736D616C6C222C363033323829';
wwv_flow_imp.g_varchar2_table(1505) := '2C766D436F6E6E6563743A756E2822766D2D636F6E6E656374222C3630333239292C636C6F75643A756E2822636C6F7564222C3630333330292C6D657267653A756E28226D65726765222C3630333331292C6578706F72743A756E28226578706F727422';
wwv_flow_imp.g_varchar2_table(1506) := '2C3630333332292C67726170684C6566743A756E282267726170682D6C656674222C3630333333292C6D61676E65743A756E28226D61676E6574222C3630333334292C6E6F7465626F6F6B3A756E28226E6F7465626F6F6B222C3630333335292C726564';
wwv_flow_imp.g_varchar2_table(1507) := '6F3A756E28227265646F222C3630333336292C636865636B416C6C3A756E2822636865636B2D616C6C222C3630333337292C70696E6E656444697274793A756E282270696E6E65642D6469727479222C3630333338292C7061737346696C6C65643A756E';
wwv_flow_imp.g_varchar2_table(1508) := '2822706173732D66696C6C6564222C3630333339292C636972636C654C6172676546696C6C65643A756E2822636972636C652D6C617267652D66696C6C6564222C3630333430292C636972636C654C617267653A756E2822636972636C652D6C61726765';
wwv_flow_imp.g_varchar2_table(1509) := '222C3630333431292C636972636C654C617267654F75746C696E653A756E2822636972636C652D6C617267652D6F75746C696E65222C3630333431292C636F6D62696E653A756E2822636F6D62696E65222C3630333432292C6761746865723A756E2822';
wwv_flow_imp.g_varchar2_table(1510) := '676174686572222C3630333432292C7461626C653A756E28227461626C65222C3630333433292C7661726961626C6547726F75703A756E28227661726961626C652D67726F7570222C3630333434292C747970654869657261726368793A756E28227479';
wwv_flow_imp.g_varchar2_table(1511) := '70652D686965726172636879222C3630333435292C747970654869657261726368795375623A756E2822747970652D6869657261726368792D737562222C3630333436292C7479706548696572617263687953757065723A756E2822747970652D686965';
wwv_flow_imp.g_varchar2_table(1512) := '7261726368792D7375706572222C3630333437292C67697450756C6C526571756573744372656174653A756E28226769742D70756C6C2D726571756573742D637265617465222C3630333438292C72756E41626F76653A756E282272756E2D61626F7665';
wwv_flow_imp.g_varchar2_table(1513) := '222C3630333439292C72756E42656C6F773A756E282272756E2D62656C6F77222C3630333530292C6E6F7465626F6F6B54656D706C6174653A756E28226E6F7465626F6F6B2D74656D706C617465222C3630333531292C6465627567526572756E3A756E';
wwv_flow_imp.g_varchar2_table(1514) := '282264656275672D726572756E222C3630333532292C776F726B7370616365547275737465643A756E2822776F726B73706163652D74727573746564222C3630333533292C776F726B7370616365556E747275737465643A756E2822776F726B73706163';
wwv_flow_imp.g_varchar2_table(1515) := '652D756E74727573746564222C3630333534292C776F726B7370616365556E6B6E6F776E3A756E2822776F726B73706163652D756E6B6E6F776E222C3630333535292C7465726D696E616C436D643A756E28227465726D696E616C2D636D64222C363033';
wwv_flow_imp.g_varchar2_table(1516) := '3536292C7465726D696E616C44656269616E3A756E28227465726D696E616C2D64656269616E222C3630333537292C7465726D696E616C4C696E75783A756E28227465726D696E616C2D6C696E7578222C3630333538292C7465726D696E616C506F7765';
wwv_flow_imp.g_varchar2_table(1517) := '727368656C6C3A756E28227465726D696E616C2D706F7765727368656C6C222C3630333539292C7465726D696E616C546D75783A756E28227465726D696E616C2D746D7578222C3630333630292C7465726D696E616C5562756E74753A756E2822746572';
wwv_flow_imp.g_varchar2_table(1518) := '6D696E616C2D7562756E7475222C3630333631292C7465726D696E616C426173683A756E28227465726D696E616C2D62617368222C3630333632292C6172726F77537761703A756E28226172726F772D73776170222C3630333633292C636F70793A756E';
wwv_flow_imp.g_varchar2_table(1519) := '2822636F7079222C3630333634292C706572736F6E4164643A756E2822706572736F6E2D616464222C3630333635292C66696C74657246696C6C65643A756E282266696C7465722D66696C6C6564222C3630333636292C77616E643A756E282277616E64';
wwv_flow_imp.g_varchar2_table(1520) := '222C3630333637292C64656275674C696E6542794C696E653A756E282264656275672D6C696E652D62792D6C696E65222C3630333638292C696E73706563743A756E2822696E7370656374222C3630333639292C6C61796572733A756E28226C61796572';
wwv_flow_imp.g_varchar2_table(1521) := '73222C3630333730292C6C6179657273446F743A756E28226C61796572732D646F74222C3630333731292C6C61796572734163746976653A756E28226C61796572732D616374697665222C3630333732292C636F6D706173733A756E2822636F6D706173';
wwv_flow_imp.g_varchar2_table(1522) := '73222C3630333733292C636F6D70617373446F743A756E2822636F6D706173732D646F74222C3630333734292C636F6D706173734163746976653A756E2822636F6D706173732D616374697665222C3630333735292C617A7572653A756E2822617A7572';
wwv_flow_imp.g_varchar2_table(1523) := '65222C3630333736292C697373756544726166743A756E282269737375652D6472616674222C3630333737292C67697450756C6C52657175657374436C6F7365643A756E28226769742D70756C6C2D726571756573742D636C6F736564222C3630333738';
wwv_flow_imp.g_varchar2_table(1524) := '292C67697450756C6C5265717565737444726166743A756E28226769742D70756C6C2D726571756573742D6472616674222C3630333739292C6465627567416C6C3A756E282264656275672D616C6C222C3630333830292C6465627567436F7665726167';
wwv_flow_imp.g_varchar2_table(1525) := '653A756E282264656275672D636F766572616765222C3630333831292C72756E4572726F72733A756E282272756E2D6572726F7273222C3630333832292C666F6C6465724C6962726172793A756E2822666F6C6465722D6C696272617279222C36303338';
wwv_flow_imp.g_varchar2_table(1526) := '33292C6465627567436F6E74696E7565536D616C6C3A756E282264656275672D636F6E74696E75652D736D616C6C222C3630333834292C6265616B657253746F703A756E28226265616B65722D73746F70222C3630333835292C67726170684C696E653A';
wwv_flow_imp.g_varchar2_table(1527) := '756E282267726170682D6C696E65222C3630333836292C6772617068536361747465723A756E282267726170682D73636174746572222C3630333837292C70696543686172743A756E28227069652D6368617274222C3630333838292C627261636B6574';
wwv_flow_imp.g_varchar2_table(1528) := '3A756E2822627261636B6574222C3630313735292C627261636B6574446F743A756E2822627261636B65742D646F74222C3630333839292C627261636B65744572726F723A756E2822627261636B65742D6572726F72222C3630333930292C6C6F636B53';
wwv_flow_imp.g_varchar2_table(1529) := '6D616C6C3A756E28226C6F636B2D736D616C6C222C3630333931292C617A7572654465766F70733A756E2822617A7572652D6465766F7073222C3630333932292C766572696669656446696C6C65643A756E282276657269666965642D66696C6C656422';
wwv_flow_imp.g_varchar2_table(1530) := '2C3630333933292C6E65776C696E653A756E28226E65776C696E65222C3630333934292C6C61796F75743A756E28226C61796F7574222C3630333935292C6C61796F757441637469766974796261724C6566743A756E28226C61796F75742D6163746976';
wwv_flow_imp.g_varchar2_table(1531) := '6974796261722D6C656674222C3630333936292C6C61796F7574416374697669747962617252696768743A756E28226C61796F75742D61637469766974796261722D7269676874222C3630333937292C6C61796F757450616E656C4C6566743A756E2822';
wwv_flow_imp.g_varchar2_table(1532) := '6C61796F75742D70616E656C2D6C656674222C3630333938292C6C61796F757450616E656C43656E7465723A756E28226C61796F75742D70616E656C2D63656E746572222C3630333939292C6C61796F757450616E656C4A7573746966793A756E28226C';
wwv_flow_imp.g_varchar2_table(1533) := '61796F75742D70616E656C2D6A757374696679222C3630343030292C6C61796F757450616E656C52696768743A756E28226C61796F75742D70616E656C2D7269676874222C3630343031292C6C61796F757450616E656C3A756E28226C61796F75742D70';
wwv_flow_imp.g_varchar2_table(1534) := '616E656C222C3630343032292C6C61796F7574536964656261724C6566743A756E28226C61796F75742D736964656261722D6C656674222C3630343033292C6C61796F75745369646562617252696768743A756E28226C61796F75742D73696465626172';
wwv_flow_imp.g_varchar2_table(1535) := '2D7269676874222C3630343034292C6C61796F75745374617475736261723A756E28226C61796F75742D737461747573626172222C3630343035292C6C61796F75744D656E756261723A756E28226C61796F75742D6D656E75626172222C363034303629';
wwv_flow_imp.g_varchar2_table(1536) := '2C6C61796F757443656E74657265643A756E28226C61796F75742D63656E7465726564222C3630343037292C7461726765743A756E2822746172676574222C3630343038292C696E64656E743A756E2822696E64656E74222C3630343039292C7265636F';
wwv_flow_imp.g_varchar2_table(1537) := '7264536D616C6C3A756E28227265636F72642D736D616C6C222C3630343130292C6572726F72536D616C6C3A756E28226572726F722D736D616C6C222C3630343131292C7465726D696E616C4465636F726174696F6E4572726F723A756E28227465726D';
wwv_flow_imp.g_varchar2_table(1538) := '696E616C2D6465636F726174696F6E2D6572726F72222C3630343131292C6172726F77436972636C65446F776E3A756E28226172726F772D636972636C652D646F776E222C3630343132292C6172726F77436972636C654C6566743A756E28226172726F';
wwv_flow_imp.g_varchar2_table(1539) := '772D636972636C652D6C656674222C3630343133292C6172726F77436972636C6552696768743A756E28226172726F772D636972636C652D7269676874222C3630343134292C6172726F77436972636C6555703A756E28226172726F772D636972636C65';
wwv_flow_imp.g_varchar2_table(1540) := '2D7570222C3630343135292C6C61796F75745369646562617252696768744F66663A756E28226C61796F75742D736964656261722D72696768742D6F6666222C3630343136292C6C61796F757450616E656C4F66663A756E28226C61796F75742D70616E';
wwv_flow_imp.g_varchar2_table(1541) := '656C2D6F6666222C3630343137292C6C61796F7574536964656261724C6566744F66663A756E28226C61796F75742D736964656261722D6C6566742D6F6666222C3630343138292C626C616E6B3A756E2822626C616E6B222C3630343139292C68656172';
wwv_flow_imp.g_varchar2_table(1542) := '7446696C6C65643A756E282268656172742D66696C6C6564222C3630343230292C6D61703A756E28226D6170222C3630343231292C6D6170486F72697A6F6E74616C3A756E28226D61702D686F72697A6F6E74616C222C3630343231292C666F6C64486F';
wwv_flow_imp.g_varchar2_table(1543) := '72697A6F6E74616C3A756E2822666F6C642D686F72697A6F6E74616C222C3630343231292C6D617046696C6C65643A756E28226D61702D66696C6C6564222C3630343232292C6D6170486F72697A6F6E74616C46696C6C65643A756E28226D61702D686F';
wwv_flow_imp.g_varchar2_table(1544) := '72697A6F6E74616C2D66696C6C6564222C3630343232292C666F6C64486F72697A6F6E74616C46696C6C65643A756E2822666F6C642D686F72697A6F6E74616C2D66696C6C6564222C3630343232292C636972636C65536D616C6C3A756E282263697263';
wwv_flow_imp.g_varchar2_table(1545) := '6C652D736D616C6C222C3630343233292C62656C6C536C6173683A756E282262656C6C2D736C617368222C3630343234292C62656C6C536C617368446F743A756E282262656C6C2D736C6173682D646F74222C3630343235292C636F6D6D656E74556E72';
wwv_flow_imp.g_varchar2_table(1546) := '65736F6C7665643A756E2822636F6D6D656E742D756E7265736F6C766564222C3630343236292C67697450756C6C52657175657374476F546F4368616E6765733A756E28226769742D70756C6C2D726571756573742D676F2D746F2D6368616E67657322';
wwv_flow_imp.g_varchar2_table(1547) := '2C3630343237292C67697450756C6C526571756573744E65774368616E6765733A756E28226769742D70756C6C2D726571756573742D6E65772D6368616E676573222C3630343238292C73656172636846757A7A793A756E28227365617263682D66757A';
wwv_flow_imp.g_varchar2_table(1548) := '7A79222C3630343239292C636F6D6D656E7444726166743A756E2822636F6D6D656E742D6472616674222C3630343330292C73656E643A756E282273656E64222C3630343331292C737061726B6C653A756E2822737061726B6C65222C3630343332292C';
wwv_flow_imp.g_varchar2_table(1549) := '696E736572743A756E2822696E73657274222C3630343333292C6D69633A756E28226D6963222C3630343334292C7468756D6273646F776E46696C6C65643A756E28227468756D6273646F776E2D66696C6C6564222C3630343335292C7468756D627375';
wwv_flow_imp.g_varchar2_table(1550) := '7046696C6C65643A756E28227468756D627375702D66696C6C6564222C3630343336292C636F666665653A756E2822636F66666565222C3630343337292C736E616B653A756E2822736E616B65222C3630343338292C67616D653A756E282267616D6522';
wwv_flow_imp.g_varchar2_table(1551) := '2C3630343339292C76723A756E28227672222C3630343430292C636869703A756E282263686970222C3630343431292C7069616E6F3A756E28227069616E6F222C3630343432292C6D757369633A756E28226D75736963222C3630343433292C6D696346';
wwv_flow_imp.g_varchar2_table(1552) := '696C6C65643A756E28226D69632D66696C6C6564222C3630343434292C7265706F46657463683A756E28227265706F2D6665746368222C3630343435292C636F70696C6F743A756E2822636F70696C6F74222C3630343436292C6C6967687462756C6253';
wwv_flow_imp.g_varchar2_table(1553) := '7061726B6C653A756E28226C6967687462756C622D737061726B6C65222C3630343437292C726F626F743A756E2822726F626F74222C3630343438292C737061726B6C6546696C6C65643A756E2822737061726B6C652D66696C6C6564222C3630343439';
wwv_flow_imp.g_varchar2_table(1554) := '292C6469666653696E676C653A756E2822646966662D73696E676C65222C3630343530292C646966664D756C7469706C653A756E2822646966662D6D756C7469706C65222C3630343531292C737572726F756E64576974683A756E2822737572726F756E';
wwv_flow_imp.g_varchar2_table(1555) := '642D77697468222C3630343532292C73686172653A756E28227368617265222C3630343533292C67697453746173683A756E28226769742D7374617368222C3630343534292C67697453746173684170706C793A756E28226769742D73746173682D6170';
wwv_flow_imp.g_varchar2_table(1556) := '706C79222C3630343535292C6769745374617368506F703A756E28226769742D73746173682D706F70222C3630343536292C7673636F64653A756E28227673636F6465222C3630343537292C7673636F6465496E7369646572733A756E28227673636F64';
wwv_flow_imp.g_varchar2_table(1557) := '652D696E736964657273222C3630343538292C636F64654F73733A756E2822636F64652D6F7373222C3630343539292C72756E436F7665726167653A756E282272756E2D636F766572616765222C3630343630292C72756E416C6C436F7665726167653A';
wwv_flow_imp.g_varchar2_table(1558) := '756E282272756E2D616C6C2D636F766572616765222C3630343631292C636F7665726167653A756E2822636F766572616765222C3630343632292C67697468756250726F6A6563743A756E28226769746875622D70726F6A656374222C3630343633292C';
wwv_flow_imp.g_varchar2_table(1559) := '6D6170566572746963616C3A756E28226D61702D766572746963616C222C3630343634292C666F6C64566572746963616C3A756E2822666F6C642D766572746963616C222C3630343634292C6D6170566572746963616C46696C6C65643A756E28226D61';
wwv_flow_imp.g_varchar2_table(1560) := '702D766572746963616C2D66696C6C6564222C3630343635292C666F6C64566572746963616C46696C6C65643A756E2822666F6C642D766572746963616C2D66696C6C6564222C3630343635292C676F546F5365617263683A756E2822676F2D746F2D73';
wwv_flow_imp.g_varchar2_table(1561) := '6561726368222C3630343636292C70657263656E746167653A756E282270657263656E74616765222C3630343637292C736F727450657263656E746167653A756E2822736F72742D70657263656E74616765222C3630343637292C6469616C6F67457272';
wwv_flow_imp.g_varchar2_table(1562) := '6F723A756E28226469616C6F672D6572726F72222C226572726F7222292C6469616C6F675761726E696E673A756E28226469616C6F672D7761726E696E67222C227761726E696E6722292C6469616C6F67496E666F3A756E28226469616C6F672D696E66';
wwv_flow_imp.g_varchar2_table(1563) := '6F222C22696E666F22292C6469616C6F67436C6F73653A756E28226469616C6F672D636C6F7365222C22636C6F736522292C747265654974656D457870616E6465643A756E2822747265652D6974656D2D657870616E646564222C2263686576726F6E2D';
wwv_flow_imp.g_varchar2_table(1564) := '646F776E22292C7472656546696C7465724F6E547970654F6E3A756E2822747265652D66696C7465722D6F6E2D747970652D6F6E222C226C6973742D66696C74657222292C7472656546696C7465724F6E547970654F66663A756E2822747265652D6669';
wwv_flow_imp.g_varchar2_table(1565) := '6C7465722D6F6E2D747970652D6F6666222C226C6973742D73656C656374696F6E22292C7472656546696C746572436C6561723A756E2822747265652D66696C7465722D636C656172222C22636C6F736522292C747265654974656D4C6F6164696E673A';
wwv_flow_imp.g_varchar2_table(1566) := '756E2822747265652D6974656D2D6C6F6164696E67222C226C6F6164696E6722292C6D656E7553656C656374696F6E3A756E28226D656E752D73656C656374696F6E222C22636865636B22292C6D656E755375626D656E753A756E28226D656E752D7375';
wwv_flow_imp.g_varchar2_table(1567) := '626D656E75222C2263686576726F6E2D726967687422292C6D656E754261724D6F72653A756E28226D656E756261722D6D6F7265222C226D6F726522292C7363726F6C6C626172427574746F6E4C6566743A756E28227363726F6C6C6261722D62757474';
wwv_flow_imp.g_varchar2_table(1568) := '6F6E2D6C656674222C22747269616E676C652D6C65667422292C7363726F6C6C626172427574746F6E52696768743A756E28227363726F6C6C6261722D627574746F6E2D7269676874222C22747269616E676C652D726967687422292C7363726F6C6C62';
wwv_flow_imp.g_varchar2_table(1569) := '6172427574746F6E55703A756E28227363726F6C6C6261722D627574746F6E2D7570222C22747269616E676C652D757022292C7363726F6C6C626172427574746F6E446F776E3A756E28227363726F6C6C6261722D627574746F6E2D646F776E222C2274';
wwv_flow_imp.g_varchar2_table(1570) := '7269616E676C652D646F776E22292C746F6F6C4261724D6F72653A756E2822746F6F6C6261722D6D6F7265222C226D6F726522292C717569636B496E7075744261636B3A756E2822717569636B2D696E7075742D6261636B222C226172726F772D6C6566';
wwv_flow_imp.g_varchar2_table(1571) := '7422292C64726F70446F776E427574746F6E3A756E282264726F702D646F776E2D627574746F6E222C3630303834292C73796D626F6C437573746F6D436F6C6F723A756E282273796D626F6C2D637573746F6D636F6C6F72222C3630323532292C657870';
wwv_flow_imp.g_varchar2_table(1572) := '6F727449636F6E3A756E28226578706F7274222C3630333332292C776F726B7370616365556E7370656369666965643A756E2822776F726B73706163652D756E737065636966696564222C3630333535292C6E65774C696E653A756E28226E65776C696E';
wwv_flow_imp.g_varchar2_table(1573) := '65222C3630333934292C7468756D6273446F776E46696C6C65643A756E28227468756D6273646F776E2D66696C6C6564222C3630343335292C7468756D6273557046696C6C65643A756E28227468756D627375702D66696C6C6564222C3630343336292C';
wwv_flow_imp.g_varchar2_table(1574) := '67697446657463683A756E28226769742D6665746368222C3630343435292C6C6967687462756C62537061726B6C654175746F6669783A756E28226C6967687462756C622D737061726B6C652D6175746F666978222C3630343437292C64656275674272';
wwv_flow_imp.g_varchar2_table(1575) := '65616B706F696E7450656E64696E673A756E282264656275672D627265616B706F696E742D70656E64696E67222C3630333737297D3B636C61737320686E20657874656E647320707B6765742069735265736F6C76656428297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(1576) := '732E5F69735265736F6C7665647D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F72656769737472793D652C746869732E5F6C616E677561676549643D742C746869732E5F666163746F72793D6E2C746869732E5F69';
wwv_flow_imp.g_varchar2_table(1577) := '73446973706F7365643D21312C746869732E5F7265736F6C766550726F6D6973653D6E756C6C2C746869732E5F69735265736F6C7665643D21317D646973706F736528297B746869732E5F6973446973706F7365643D21302C73757065722E646973706F';
wwv_flow_imp.g_varchar2_table(1578) := '736528297D6173796E63207265736F6C766528297B72657475726E20746869732E5F7265736F6C766550726F6D6973657C7C28746869732E5F7265736F6C766550726F6D6973653D746869732E5F6372656174652829292C746869732E5F7265736F6C76';
wwv_flow_imp.g_varchar2_table(1579) := '6550726F6D6973657D6173796E63205F63726561746528297B636F6E737420653D617761697420746869732E5F666163746F72792E746F6B656E697A6174696F6E537570706F72743B746869732E5F69735265736F6C7665643D21302C65262621746869';
wwv_flow_imp.g_varchar2_table(1580) := '732E5F6973446973706F7365642626746869732E5F726567697374657228746869732E5F72656769737472792E726567697374657228746869732E5F6C616E677561676549642C6529297D7D76617220646E2C666E2C6D6E2C676E2C706E2C766E2C626E';
wwv_flow_imp.g_varchar2_table(1581) := '2C796E2C5F6E2C436E2C776E2C536E2C4C6E2C456E2C786E2C4E6E2C416E2C6B6E2C526E2C546E2C4D6E2C4F6E2C496E2C506E2C466E2C566E2C446E2C716E2C4B6E2C6A6E2C556E2C426E2C246E2C576E2C7A6E2C486E2C476E2C4A6E2C586E2C516E2C';
wwv_flow_imp.g_varchar2_table(1582) := '5A6E2C596E2C65722C74722C6E722C72722C69722C73722C6F722C61722C6C722C75722C63722C68722C64722C66722C6D722C67722C70722C76722C62722C79722C5F723B2166756E6374696F6E2865297B655B652E496E6372656173653D305D3D2249';
wwv_flow_imp.g_varchar2_table(1583) := '6E637265617365222C655B652E44656372656173653D315D3D224465637265617365227D28646E7C7C28646E3D7B7D29292C66756E6374696F6E2865297B636F6E737420743D6E6577204D61703B742E73657428302C636E2E73796D626F6C4D6574686F';
wwv_flow_imp.g_varchar2_table(1584) := '64292C742E73657428312C636E2E73796D626F6C46756E6374696F6E292C742E73657428322C636E2E73796D626F6C436F6E7374727563746F72292C742E73657428332C636E2E73796D626F6C4669656C64292C742E73657428342C636E2E73796D626F';
wwv_flow_imp.g_varchar2_table(1585) := '6C5661726961626C65292C742E73657428352C636E2E73796D626F6C436C617373292C742E73657428362C636E2E73796D626F6C537472756374292C742E73657428372C636E2E73796D626F6C496E74657266616365292C742E73657428382C636E2E73';
wwv_flow_imp.g_varchar2_table(1586) := '796D626F6C4D6F64756C65292C742E73657428392C636E2E73796D626F6C50726F7065727479292C742E7365742831302C636E2E73796D626F6C4576656E74292C742E7365742831312C636E2E73796D626F6C4F70657261746F72292C742E7365742831';
wwv_flow_imp.g_varchar2_table(1587) := '322C636E2E73796D626F6C556E6974292C742E7365742831332C636E2E73796D626F6C56616C7565292C742E7365742831352C636E2E73796D626F6C456E756D292C742E7365742831342C636E2E73796D626F6C436F6E7374616E74292C742E73657428';
wwv_flow_imp.g_varchar2_table(1588) := '31352C636E2E73796D626F6C456E756D292C742E7365742831362C636E2E73796D626F6C456E756D4D656D626572292C742E7365742831372C636E2E73796D626F6C4B6579776F7264292C742E7365742832372C636E2E73796D626F6C536E6970706574';
wwv_flow_imp.g_varchar2_table(1589) := '292C742E7365742831382C636E2E73796D626F6C54657874292C742E7365742831392C636E2E73796D626F6C436F6C6F72292C742E7365742832302C636E2E73796D626F6C46696C65292C742E7365742832312C636E2E73796D626F6C5265666572656E';
wwv_flow_imp.g_varchar2_table(1590) := '6365292C742E7365742832322C636E2E73796D626F6C437573746F6D436F6C6F72292C742E7365742832332C636E2E73796D626F6C466F6C646572292C742E7365742832342C636E2E73796D626F6C54797065506172616D65746572292C742E73657428';
wwv_flow_imp.g_varchar2_table(1591) := '32352C636E2E6163636F756E74292C742E7365742832362C636E2E697373756573292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865293B72657475726E206E7C7C28636F6E736F6C652E696E666F28224E6F2063';
wwv_flow_imp.g_varchar2_table(1592) := '6F6469636F6E20666F756E6420666F7220436F6D706C6574696F6E4974656D4B696E6420222B65292C6E3D636E2E73796D626F6C50726F7065727479292C6E7D3B636F6E7374206E3D6E6577204D61703B6E2E73657428226D6574686F64222C30292C6E';
wwv_flow_imp.g_varchar2_table(1593) := '2E736574282266756E6374696F6E222C31292C6E2E7365742822636F6E7374727563746F72222C32292C6E2E73657428226669656C64222C33292C6E2E73657428227661726961626C65222C34292C6E2E7365742822636C617373222C35292C6E2E7365';
wwv_flow_imp.g_varchar2_table(1594) := '742822737472756374222C36292C6E2E7365742822696E74657266616365222C37292C6E2E73657428226D6F64756C65222C38292C6E2E736574282270726F7065727479222C39292C6E2E73657428226576656E74222C3130292C6E2E73657428226F70';
wwv_flow_imp.g_varchar2_table(1595) := '657261746F72222C3131292C6E2E7365742822756E6974222C3132292C6E2E736574282276616C7565222C3133292C6E2E7365742822636F6E7374616E74222C3134292C6E2E7365742822656E756D222C3135292C6E2E7365742822656E756D2D6D656D';
wwv_flow_imp.g_varchar2_table(1596) := '626572222C3136292C6E2E7365742822656E756D4D656D626572222C3136292C6E2E73657428226B6579776F7264222C3137292C6E2E7365742822736E6970706574222C3237292C6E2E736574282274657874222C3138292C6E2E7365742822636F6C6F';
wwv_flow_imp.g_varchar2_table(1597) := '72222C3139292C6E2E736574282266696C65222C3230292C6E2E73657428227265666572656E6365222C3231292C6E2E7365742822637573746F6D636F6C6F72222C3232292C6E2E7365742822666F6C646572222C3233292C6E2E736574282274797065';
wwv_flow_imp.g_varchar2_table(1598) := '2D706172616D65746572222C3234292C6E2E736574282274797065506172616D65746572222C3234292C6E2E73657428226163636F756E74222C3235292C6E2E73657428226973737565222C3236292C652E66726F6D537472696E673D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1599) := '6E28652C74297B6C657420723D6E2E6765742865293B72657475726E20766F69642030213D3D727C7C747C7C28723D39292C727D7D28666E7C7C28666E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D22417574';
wwv_flow_imp.g_varchar2_table(1600) := '6F6D61746963222C655B652E4578706C696369743D315D3D224578706C69636974227D286D6E7C7C286D6E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B652E506173746541';
wwv_flow_imp.g_varchar2_table(1601) := '733D315D3D2250617374654173227D28676E7C7C28676E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E547269676765724368617261637465723D325D3D225472696767657243686172';
wwv_flow_imp.g_varchar2_table(1602) := '6163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E6765227D28706E7C7C28706E3D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E526561643D315D';
wwv_flow_imp.g_varchar2_table(1603) := '3D2252656164222C655B652E57726974653D325D3D225772697465227D28766E7C7C28766E3D7B7D29292C5228302C22617272617922292C5228302C22626F6F6C65616E22292C5228302C22636C61737322292C5228302C22636F6E7374616E7422292C';
wwv_flow_imp.g_varchar2_table(1604) := '5228302C22636F6E7374727563746F7222292C5228302C22656E756D65726174696F6E22292C5228302C22656E756D65726174696F6E206D656D62657222292C5228302C226576656E7422292C5228302C226669656C6422292C5228302C2266696C6522';
wwv_flow_imp.g_varchar2_table(1605) := '292C5228302C2266756E6374696F6E22292C5228302C22696E7465726661636522292C5228302C226B657922292C5228302C226D6574686F6422292C5228302C226D6F64756C6522292C5228302C226E616D65737061636522292C5228302C226E756C6C';
wwv_flow_imp.g_varchar2_table(1606) := '22292C5228302C226E756D62657222292C5228302C226F626A65637422292C5228302C226F70657261746F7222292C5228302C227061636B61676522292C5228302C2270726F706572747922292C5228302C22737472696E6722292C5228302C22737472';
wwv_flow_imp.g_varchar2_table(1607) := '75637422292C5228302C227479706520706172616D6574657222292C5228302C227661726961626C6522292C66756E6374696F6E2865297B636F6E737420743D6E6577204D61703B742E73657428302C636E2E73796D626F6C46696C65292C742E736574';
wwv_flow_imp.g_varchar2_table(1608) := '28312C636E2E73796D626F6C4D6F64756C65292C742E73657428322C636E2E73796D626F6C4E616D657370616365292C742E73657428332C636E2E73796D626F6C5061636B616765292C742E73657428342C636E2E73796D626F6C436C617373292C742E';
wwv_flow_imp.g_varchar2_table(1609) := '73657428352C636E2E73796D626F6C4D6574686F64292C742E73657428362C636E2E73796D626F6C50726F7065727479292C742E73657428372C636E2E73796D626F6C4669656C64292C742E73657428382C636E2E73796D626F6C436F6E737472756374';
wwv_flow_imp.g_varchar2_table(1610) := '6F72292C742E73657428392C636E2E73796D626F6C456E756D292C742E7365742831302C636E2E73796D626F6C496E74657266616365292C742E7365742831312C636E2E73796D626F6C46756E6374696F6E292C742E7365742831322C636E2E73796D62';
wwv_flow_imp.g_varchar2_table(1611) := '6F6C5661726961626C65292C742E7365742831332C636E2E73796D626F6C436F6E7374616E74292C742E7365742831342C636E2E73796D626F6C537472696E67292C742E7365742831352C636E2E73796D626F6C4E756D626572292C742E736574283136';
wwv_flow_imp.g_varchar2_table(1612) := '2C636E2E73796D626F6C426F6F6C65616E292C742E7365742831372C636E2E73796D626F6C4172726179292C742E7365742831382C636E2E73796D626F6C4F626A656374292C742E7365742831392C636E2E73796D626F6C4B6579292C742E7365742832';
wwv_flow_imp.g_varchar2_table(1613) := '302C636E2E73796D626F6C4E756C6C292C742E7365742832312C636E2E73796D626F6C456E756D4D656D626572292C742E7365742832322C636E2E73796D626F6C537472756374292C742E7365742832332C636E2E73796D626F6C4576656E74292C742E';
wwv_flow_imp.g_varchar2_table(1614) := '7365742832342C636E2E73796D626F6C4F70657261746F72292C742E7365742832352C636E2E73796D626F6C54797065506172616D65746572292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865293B7265747572';
wwv_flow_imp.g_varchar2_table(1615) := '6E206E7C7C28636F6E736F6C652E696E666F28224E6F20636F6469636F6E20666F756E6420666F722053796D626F6C4B696E6420222B65292C6E3D636E2E73796D626F6C50726F7065727479292C6E7D7D28626E7C7C28626E3D7B7D29293B636C617373';
wwv_flow_imp.g_varchar2_table(1616) := '2043727B7374617469632066726F6D56616C75652865297B7377697463682865297B6361736522636F6D6D656E74223A72657475726E2043722E436F6D6D656E743B6361736522696D706F727473223A72657475726E2043722E496D706F7274733B6361';
wwv_flow_imp.g_varchar2_table(1617) := '736522726567696F6E223A72657475726E2043722E526567696F6E7D72657475726E206E65772043722865297D636F6E7374727563746F722865297B746869732E76616C75653D657D7D43722E436F6D6D656E743D6E65772043722822636F6D6D656E74';
wwv_flow_imp.g_varchar2_table(1618) := '22292C43722E496D706F7274733D6E65772043722822696D706F72747322292C43722E526567696F6E3D6E65772043722822726567696F6E22292C66756E6374696F6E2865297B655B652E414947656E6572617465643D315D3D22414947656E65726174';
wwv_flow_imp.g_varchar2_table(1619) := '6564227D28796E7C7C28796E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D285F6E7C7C285F6E3D7B7D29292C66756E63';
wwv_flow_imp.g_varchar2_table(1620) := '74696F6E2865297B652E69733D66756E6374696F6E2865297B72657475726E212821657C7C226F626A65637422213D747970656F66206529262622737472696E67223D3D747970656F6620652E6964262622737472696E67223D3D747970656F6620652E';
wwv_flow_imp.g_varchar2_table(1621) := '7469746C657D7D28436E7C7C28436E3D7B7D29292C66756E6374696F6E2865297B655B652E547970653D315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D28776E7C7C28776E3D7B7D29292C6E65772063';
wwv_flow_imp.g_varchar2_table(1622) := '6C6173737B636F6E7374727563746F7228297B746869732E5F746F6B656E697A6174696F6E537570706F7274733D6E6577204D61702C746869732E5F666163746F726965733D6E6577204D61702C746869732E5F6F6E4469644368616E67653D6E657720';
wwv_flow_imp.g_varchar2_table(1623) := '782C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F636F6C6F724D61703D6E756C6C7D68616E646C654368616E67652865297B746869732E5F6F6E4469644368616E67652E666972';
wwv_flow_imp.g_varchar2_table(1624) := '65287B6368616E6765644C616E6775616765733A652C6368616E676564436F6C6F724D61703A21317D297D726567697374657228652C74297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F7274732E73657428652C74292C';
wwv_flow_imp.g_varchar2_table(1625) := '746869732E68616E646C654368616E6765285B655D292C6D282828293D3E7B746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865293D3D3D74262628746869732E5F746F6B656E697A6174696F6E537570706F7274732E6465';
wwv_flow_imp.g_varchar2_table(1626) := '6C6574652865292C746869732E68616E646C654368616E6765285B655D29297D29297D6765742865297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865297C7C6E756C6C7D7265676973746572466163';
wwv_flow_imp.g_varchar2_table(1627) := '746F727928652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E5F666163746F726965732E676574286529297C7C766F696420303D3D3D6E7C7C6E2E646973706F736528293B636F6E737420723D6E657720686E28746869732C652C74293B';
wwv_flow_imp.g_varchar2_table(1628) := '72657475726E20746869732E5F666163746F726965732E73657428652C72292C6D282828293D3E7B636F6E737420743D746869732E5F666163746F726965732E6765742865293B742626743D3D3D72262628746869732E5F666163746F726965732E6465';
wwv_flow_imp.g_varchar2_table(1629) := '6C6574652865292C742E646973706F73652829297D29297D6173796E63206765744F724372656174652865297B636F6E737420743D746869732E6765742865293B696628742972657475726E20743B636F6E7374206E3D746869732E5F666163746F7269';
wwv_flow_imp.g_varchar2_table(1630) := '65732E6765742865293B72657475726E216E7C7C6E2E69735265736F6C7665643F6E756C6C3A286177616974206E2E7265736F6C766528292C746869732E676574286529297D69735265736F6C7665642865297B696628746869732E6765742865292972';
wwv_flow_imp.g_varchar2_table(1631) := '657475726E21303B636F6E737420743D746869732E5F666163746F726965732E6765742865293B72657475726E212874262621742E69735265736F6C766564297D736574436F6C6F724D61702865297B746869732E5F636F6C6F724D61703D652C746869';
wwv_flow_imp.g_varchar2_table(1632) := '732E5F6F6E4469644368616E67652E66697265287B6368616E6765644C616E6775616765733A41727261792E66726F6D28746869732E5F746F6B656E697A6174696F6E537570706F7274732E6B6579732829292C6368616E676564436F6C6F724D61703A';
wwv_flow_imp.g_varchar2_table(1633) := '21307D297D676574436F6C6F724D617028297B72657475726E20746869732E5F636F6C6F724D61707D67657444656661756C744261636B67726F756E6428297B72657475726E20746869732E5F636F6C6F724D61702626746869732E5F636F6C6F724D61';
wwv_flow_imp.g_varchar2_table(1634) := '702E6C656E6774683E323F746869732E5F636F6C6F724D61705B325D3A6E756C6C7D7D2C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D';
wwv_flow_imp.g_varchar2_table(1635) := '28536E7C7C28536E3D7B7D29292C66756E6374696F6E2865297B655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C655B652E44697361626C65643D315D3D2244697361626C6564222C655B652E456E61626C65643D325D3D22456E61626C65';
wwv_flow_imp.g_varchar2_table(1636) := '64227D284C6E7C7C284C6E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E4175746F3D325D3D224175746F227D28456E7C7C28456E3D7B7D29292C66756E6374696F6E2865297B655B65';
wwv_flow_imp.g_varchar2_table(1637) := '2E4E6F6E653D305D3D224E6F6E65222C655B652E4B656570576869746573706163653D315D3D224B65657057686974657370616365222C655B652E496E736572744173536E69707065743D345D3D22496E736572744173536E6970706574227D28786E7C';
wwv_flow_imp.g_varchar2_table(1638) := '7C28786E3D7B7D29292C66756E6374696F6E2865297B655B652E4D6574686F643D305D3D224D6574686F64222C655B652E46756E6374696F6E3D315D3D2246756E6374696F6E222C655B652E436F6E7374727563746F723D325D3D22436F6E7374727563';
wwv_flow_imp.g_varchar2_table(1639) := '746F72222C655B652E4669656C643D335D3D224669656C64222C655B652E5661726961626C653D345D3D225661726961626C65222C655B652E436C6173733D355D3D22436C617373222C655B652E5374727563743D365D3D22537472756374222C655B65';
wwv_flow_imp.g_varchar2_table(1640) := '2E496E746572666163653D375D3D22496E74657266616365222C655B652E4D6F64756C653D385D3D224D6F64756C65222C655B652E50726F70657274793D395D3D2250726F7065727479222C655B652E4576656E743D31305D3D224576656E74222C655B';
wwv_flow_imp.g_varchar2_table(1641) := '652E4F70657261746F723D31315D3D224F70657261746F72222C655B652E556E69743D31325D3D22556E6974222C655B652E56616C75653D31335D3D2256616C7565222C655B652E436F6E7374616E743D31345D3D22436F6E7374616E74222C655B652E';
wwv_flow_imp.g_varchar2_table(1642) := '456E756D3D31355D3D22456E756D222C655B652E456E756D4D656D6265723D31365D3D22456E756D4D656D626572222C655B652E4B6579776F72643D31375D3D224B6579776F7264222C655B652E546578743D31385D3D2254657874222C655B652E436F';
wwv_flow_imp.g_varchar2_table(1643) := '6C6F723D31395D3D22436F6C6F72222C655B652E46696C653D32305D3D2246696C65222C655B652E5265666572656E63653D32315D3D225265666572656E6365222C655B652E437573746F6D636F6C6F723D32325D3D22437573746F6D636F6C6F72222C';
wwv_flow_imp.g_varchar2_table(1644) := '655B652E466F6C6465723D32335D3D22466F6C646572222C655B652E54797065506172616D657465723D32345D3D2254797065506172616D65746572222C655B652E557365723D32355D3D2255736572222C655B652E49737375653D32365D3D22497373';
wwv_flow_imp.g_varchar2_table(1645) := '7565222C655B652E536E69707065743D32375D3D22536E6970706574227D284E6E7C7C284E6E3D7B7D29292C66756E6374696F6E2865297B655B652E446570726563617465643D315D3D2244657072656361746564227D28416E7C7C28416E3D7B7D2929';
wwv_flow_imp.g_varchar2_table(1646) := '2C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E547269676765724368617261637465723D315D3D2254726967676572436861726163746572222C655B652E54726967676572466F72496E636F6D706C';
wwv_flow_imp.g_varchar2_table(1647) := '657465436F6D706C6574696F6E733D325D3D2254726967676572466F72496E636F6D706C657465436F6D706C6574696F6E73227D286B6E7C7C286B6E3D7B7D29292C66756E6374696F6E2865297B655B652E45584143543D305D3D224558414354222C65';
wwv_flow_imp.g_varchar2_table(1648) := '5B652E41424F56453D315D3D2241424F5645222C655B652E42454C4F573D325D3D2242454C4F57227D28526E7C7C28526E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F745365743D305D3D224E6F74536574222C655B652E436F6E74656E';
wwv_flow_imp.g_varchar2_table(1649) := '74466C7573683D315D3D22436F6E74656E74466C757368222C655B652E5265636F76657246726F6D4D61726B6572733D325D3D225265636F76657246726F6D4D61726B657273222C655B652E4578706C696369743D335D3D224578706C69636974222C65';
wwv_flow_imp.g_varchar2_table(1650) := '5B652E50617374653D345D3D225061737465222C655B652E556E646F3D355D3D22556E646F222C655B652E5265646F3D365D3D225265646F227D28546E7C7C28546E3D7B7D29292C66756E6374696F6E2865297B655B652E4C463D315D3D224C46222C65';
wwv_flow_imp.g_varchar2_table(1651) := '5B652E43524C463D325D3D2243524C46227D284D6E7C7C284D6E3D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E526561643D315D3D2252656164222C655B652E57726974653D325D3D2257726974';
wwv_flow_imp.g_varchar2_table(1652) := '65227D284F6E7C7C284F6E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E4B6565703D315D3D224B656570222C655B652E427261636B6574733D325D3D22427261636B657473222C655B652E4164';
wwv_flow_imp.g_varchar2_table(1653) := '76616E6365643D335D3D22416476616E636564222C655B652E46756C6C3D345D3D2246756C6C227D28496E7C7C28496E3D7B7D29292C66756E6374696F6E2865297B655B652E61636365707453756767657374696F6E4F6E436F6D6D6974436861726163';
wwv_flow_imp.g_varchar2_table(1654) := '7465723D305D3D2261636365707453756767657374696F6E4F6E436F6D6D6974436861726163746572222C655B652E61636365707453756767657374696F6E4F6E456E7465723D315D3D2261636365707453756767657374696F6E4F6E456E746572222C';
wwv_flow_imp.g_varchar2_table(1655) := '655B652E6163636573736962696C697479537570706F72743D325D3D226163636573736962696C697479537570706F7274222C655B652E6163636573736962696C6974795061676553697A653D335D3D226163636573736962696C697479506167655369';
wwv_flow_imp.g_varchar2_table(1656) := '7A65222C655B652E617269614C6162656C3D345D3D22617269614C6162656C222C655B652E6172696152657175697265643D355D3D22617269615265717569726564222C655B652E6175746F436C6F73696E67427261636B6574733D365D3D226175746F';
wwv_flow_imp.g_varchar2_table(1657) := '436C6F73696E67427261636B657473222C655B652E6175746F436C6F73696E67436F6D6D656E74733D375D3D226175746F436C6F73696E67436F6D6D656E7473222C655B652E73637265656E526561646572416E6E6F756E6365496E6C696E6553756767';
wwv_flow_imp.g_varchar2_table(1658) := '657374696F6E3D385D3D2273637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E222C655B652E6175746F436C6F73696E6744656C6574653D395D3D226175746F436C6F73696E6744656C657465222C655B652E6175';
wwv_flow_imp.g_varchar2_table(1659) := '746F436C6F73696E674F766572747970653D31305D3D226175746F436C6F73696E674F76657274797065222C655B652E6175746F436C6F73696E6751756F7465733D31315D3D226175746F436C6F73696E6751756F746573222C655B652E6175746F496E';
wwv_flow_imp.g_varchar2_table(1660) := '64656E743D31325D3D226175746F496E64656E74222C655B652E6175746F6D617469634C61796F75743D31335D3D226175746F6D617469634C61796F7574222C655B652E6175746F537572726F756E643D31345D3D226175746F537572726F756E64222C';
wwv_flow_imp.g_varchar2_table(1661) := '655B652E627261636B657450616972436F6C6F72697A6174696F6E3D31355D3D22627261636B657450616972436F6C6F72697A6174696F6E222C655B652E6775696465733D31365D3D22677569646573222C655B652E636F64654C656E733D31375D3D22';
wwv_flow_imp.g_varchar2_table(1662) := '636F64654C656E73222C655B652E636F64654C656E73466F6E7446616D696C793D31385D3D22636F64654C656E73466F6E7446616D696C79222C655B652E636F64654C656E73466F6E7453697A653D31395D3D22636F64654C656E73466F6E7453697A65';
wwv_flow_imp.g_varchar2_table(1663) := '222C655B652E636F6C6F724465636F7261746F72733D32305D3D22636F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734C696D69743D32315D3D22636F6C6F724465636F7261746F72734C696D6974222C655B652E';
wwv_flow_imp.g_varchar2_table(1664) := '636F6C756D6E53656C656374696F6E3D32325D3D22636F6C756D6E53656C656374696F6E222C655B652E636F6D6D656E74733D32335D3D22636F6D6D656E7473222C655B652E636F6E746578746D656E753D32345D3D22636F6E746578746D656E75222C';
wwv_flow_imp.g_varchar2_table(1665) := '655B652E636F70795769746853796E746178486967686C69676874696E673D32355D3D22636F70795769746853796E746178486967686C69676874696E67222C655B652E637572736F72426C696E6B696E673D32365D3D22637572736F72426C696E6B69';
wwv_flow_imp.g_varchar2_table(1666) := '6E67222C655B652E637572736F72536D6F6F74684361726574416E696D6174696F6E3D32375D3D22637572736F72536D6F6F74684361726574416E696D6174696F6E222C655B652E637572736F725374796C653D32385D3D22637572736F725374796C65';
wwv_flow_imp.g_varchar2_table(1667) := '222C655B652E637572736F72537572726F756E64696E674C696E65733D32395D3D22637572736F72537572726F756E64696E674C696E6573222C655B652E637572736F72537572726F756E64696E674C696E65735374796C653D33305D3D22637572736F';
wwv_flow_imp.g_varchar2_table(1668) := '72537572726F756E64696E674C696E65735374796C65222C655B652E637572736F7257696474683D33315D3D22637572736F725769647468222C655B652E64697361626C654C6179657248696E74696E673D33325D3D2264697361626C654C6179657248';
wwv_flow_imp.g_varchar2_table(1669) := '696E74696E67222C655B652E64697361626C654D6F6E6F73706163654F7074696D697A6174696F6E733D33335D3D2264697361626C654D6F6E6F73706163654F7074696D697A6174696F6E73222C655B652E646F6D526561644F6E6C793D33345D3D2264';
wwv_flow_imp.g_varchar2_table(1670) := '6F6D526561644F6E6C79222C655B652E64726167416E6444726F703D33355D3D2264726167416E6444726F70222C655B652E64726F70496E746F456469746F723D33365D3D2264726F70496E746F456469746F72222C655B652E656D70747953656C6563';
wwv_flow_imp.g_varchar2_table(1671) := '74696F6E436C6970626F6172643D33375D3D22656D70747953656C656374696F6E436C6970626F617264222C655B652E6578706572696D656E74616C5768697465737061636552656E646572696E673D33385D3D226578706572696D656E74616C576869';
wwv_flow_imp.g_varchar2_table(1672) := '7465737061636552656E646572696E67222C655B652E6578747261456469746F72436C6173734E616D653D33395D3D226578747261456469746F72436C6173734E616D65222C655B652E666173745363726F6C6C53656E73697469766974793D34305D3D';
wwv_flow_imp.g_varchar2_table(1673) := '22666173745363726F6C6C53656E7369746976697479222C655B652E66696E643D34315D3D2266696E64222C655B652E66697865644F766572666C6F77576964676574733D34325D3D2266697865644F766572666C6F7757696467657473222C655B652E';
wwv_flow_imp.g_varchar2_table(1674) := '666F6C64696E673D34335D3D22666F6C64696E67222C655B652E666F6C64696E6753747261746567793D34345D3D22666F6C64696E675374726174656779222C655B652E666F6C64696E67486967686C696768743D34355D3D22666F6C64696E67486967';
wwv_flow_imp.g_varchar2_table(1675) := '686C69676874222C655B652E666F6C64696E67496D706F727473427944656661756C743D34365D3D22666F6C64696E67496D706F727473427944656661756C74222C655B652E666F6C64696E674D6178696D756D526567696F6E733D34375D3D22666F6C';
wwv_flow_imp.g_varchar2_table(1676) := '64696E674D6178696D756D526567696F6E73222C655B652E756E666F6C644F6E436C69636B4166746572456E644F664C696E653D34385D3D22756E666F6C644F6E436C69636B4166746572456E644F664C696E65222C655B652E666F6E7446616D696C79';
wwv_flow_imp.g_varchar2_table(1677) := '3D34395D3D22666F6E7446616D696C79222C655B652E666F6E74496E666F3D35305D3D22666F6E74496E666F222C655B652E666F6E744C69676174757265733D35315D3D22666F6E744C6967617475726573222C655B652E666F6E7453697A653D35325D';
wwv_flow_imp.g_varchar2_table(1678) := '3D22666F6E7453697A65222C655B652E666F6E745765696768743D35335D3D22666F6E74576569676874222C655B652E666F6E74566172696174696F6E733D35345D3D22666F6E74566172696174696F6E73222C655B652E666F726D61744F6E50617374';
wwv_flow_imp.g_varchar2_table(1679) := '653D35355D3D22666F726D61744F6E5061737465222C655B652E666F726D61744F6E547970653D35365D3D22666F726D61744F6E54797065222C655B652E676C7970684D617267696E3D35375D3D22676C7970684D617267696E222C655B652E676F746F';
wwv_flow_imp.g_varchar2_table(1680) := '4C6F636174696F6E3D35385D3D22676F746F4C6F636174696F6E222C655B652E68696465437572736F72496E4F7665727669657752756C65723D35395D3D2268696465437572736F72496E4F7665727669657752756C6572222C655B652E686F7665723D';
wwv_flow_imp.g_varchar2_table(1681) := '36305D3D22686F766572222C655B652E696E44696666456469746F723D36315D3D22696E44696666456469746F72222C655B652E696E6C696E65537567676573743D36325D3D22696E6C696E6553756767657374222C655B652E696E6C696E6545646974';
wwv_flow_imp.g_varchar2_table(1682) := '3D36335D3D22696E6C696E6545646974222C655B652E6C657474657253706163696E673D36345D3D226C657474657253706163696E67222C655B652E6C6967687462756C623D36355D3D226C6967687462756C62222C655B652E6C696E654465636F7261';
wwv_flow_imp.g_varchar2_table(1683) := '74696F6E7357696474683D36365D3D226C696E654465636F726174696F6E735769647468222C655B652E6C696E654865696768743D36375D3D226C696E65486569676874222C655B652E6C696E654E756D626572733D36385D3D226C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1684) := '7273222C655B652E6C696E654E756D626572734D696E43686172733D36395D3D226C696E654E756D626572734D696E4368617273222C655B652E6C696E6B656445646974696E673D37305D3D226C696E6B656445646974696E67222C655B652E6C696E6B';
wwv_flow_imp.g_varchar2_table(1685) := '733D37315D3D226C696E6B73222C655B652E6D61746368427261636B6574733D37325D3D226D61746368427261636B657473222C655B652E6D696E696D61703D37335D3D226D696E696D6170222C655B652E6D6F7573655374796C653D37345D3D226D6F';
wwv_flow_imp.g_varchar2_table(1686) := '7573655374796C65222C655B652E6D6F757365576865656C5363726F6C6C53656E73697469766974793D37355D3D226D6F757365576865656C5363726F6C6C53656E7369746976697479222C655B652E6D6F757365576865656C5A6F6F6D3D37365D3D22';
wwv_flow_imp.g_varchar2_table(1687) := '6D6F757365576865656C5A6F6F6D222C655B652E6D756C7469437572736F724D657267654F7665726C617070696E673D37375D3D226D756C7469437572736F724D657267654F7665726C617070696E67222C655B652E6D756C7469437572736F724D6F64';
wwv_flow_imp.g_varchar2_table(1688) := '69666965723D37385D3D226D756C7469437572736F724D6F646966696572222C655B652E6D756C7469437572736F7250617374653D37395D3D226D756C7469437572736F725061737465222C655B652E6D756C7469437572736F724C696D69743D38305D';
wwv_flow_imp.g_varchar2_table(1689) := '3D226D756C7469437572736F724C696D6974222C655B652E6F6363757272656E636573486967686C696768743D38315D3D226F6363757272656E636573486967686C69676874222C655B652E6F7665727669657752756C6572426F726465723D38325D3D';
wwv_flow_imp.g_varchar2_table(1690) := '226F7665727669657752756C6572426F72646572222C655B652E6F7665727669657752756C65724C616E65733D38335D3D226F7665727669657752756C65724C616E6573222C655B652E70616464696E673D38345D3D2270616464696E67222C655B652E';
wwv_flow_imp.g_varchar2_table(1691) := '706173746541733D38355D3D2270617374654173222C655B652E706172616D6574657248696E74733D38365D3D22706172616D6574657248696E7473222C655B652E7065656B57696467657444656661756C74466F6375733D38375D3D227065656B5769';
wwv_flow_imp.g_varchar2_table(1692) := '6467657444656661756C74466F637573222C655B652E646566696E6974696F6E4C696E6B4F70656E73496E5065656B3D38385D3D22646566696E6974696F6E4C696E6B4F70656E73496E5065656B222C655B652E717569636B53756767657374696F6E73';
wwv_flow_imp.g_varchar2_table(1693) := '3D38395D3D22717569636B53756767657374696F6E73222C655B652E717569636B53756767657374696F6E7344656C61793D39305D3D22717569636B53756767657374696F6E7344656C6179222C655B652E726561644F6E6C793D39315D3D2272656164';
wwv_flow_imp.g_varchar2_table(1694) := '4F6E6C79222C655B652E726561644F6E6C794D6573736167653D39325D3D22726561644F6E6C794D657373616765222C655B652E72656E616D654F6E547970653D39335D3D2272656E616D654F6E54797065222C655B652E72656E646572436F6E74726F';
wwv_flow_imp.g_varchar2_table(1695) := '6C436861726163746572733D39345D3D2272656E646572436F6E74726F6C43686172616374657273222C655B652E72656E64657246696E616C4E65776C696E653D39355D3D2272656E64657246696E616C4E65776C696E65222C655B652E72656E646572';
wwv_flow_imp.g_varchar2_table(1696) := '4C696E65486967686C696768743D39365D3D2272656E6465724C696E65486967686C69676874222C655B652E72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375733D39375D3D2272656E6465724C696E65486967686C696768';
wwv_flow_imp.g_varchar2_table(1697) := '744F6E6C795768656E466F637573222C655B652E72656E64657256616C69646174696F6E4465636F726174696F6E733D39385D3D2272656E64657256616C69646174696F6E4465636F726174696F6E73222C655B652E72656E6465725768697465737061';
wwv_flow_imp.g_varchar2_table(1698) := '63653D39395D3D2272656E64657257686974657370616365222C655B652E72657665616C486F72697A6F6E74616C526967687450616464696E673D3130305D3D2272657665616C486F72697A6F6E74616C526967687450616464696E67222C655B652E72';
wwv_flow_imp.g_varchar2_table(1699) := '6F756E64656453656C656374696F6E3D3130315D3D22726F756E64656453656C656374696F6E222C655B652E72756C6572733D3130325D3D2272756C657273222C655B652E7363726F6C6C6261723D3130335D3D227363726F6C6C626172222C655B652E';
wwv_flow_imp.g_varchar2_table(1700) := '7363726F6C6C4265796F6E644C617374436F6C756D6E3D3130345D3D227363726F6C6C4265796F6E644C617374436F6C756D6E222C655B652E7363726F6C6C4265796F6E644C6173744C696E653D3130355D3D227363726F6C6C4265796F6E644C617374';
wwv_flow_imp.g_varchar2_table(1701) := '4C696E65222C655B652E7363726F6C6C507265646F6D696E616E74417869733D3130365D3D227363726F6C6C507265646F6D696E616E7441786973222C655B652E73656C656374696F6E436C6970626F6172643D3130375D3D2273656C656374696F6E43';
wwv_flow_imp.g_varchar2_table(1702) := '6C6970626F617264222C655B652E73656C656374696F6E486967686C696768743D3130385D3D2273656C656374696F6E486967686C69676874222C655B652E73656C6563744F6E4C696E654E756D626572733D3130395D3D2273656C6563744F6E4C696E';
wwv_flow_imp.g_varchar2_table(1703) := '654E756D62657273222C655B652E73686F77466F6C64696E67436F6E74726F6C733D3131305D3D2273686F77466F6C64696E67436F6E74726F6C73222C655B652E73686F77556E757365643D3131315D3D2273686F77556E75736564222C655B652E736E';
wwv_flow_imp.g_varchar2_table(1704) := '697070657453756767657374696F6E733D3131325D3D22736E697070657453756767657374696F6E73222C655B652E736D61727453656C6563743D3131335D3D22736D61727453656C656374222C655B652E736D6F6F74685363726F6C6C696E673D3131';
wwv_flow_imp.g_varchar2_table(1705) := '345D3D22736D6F6F74685363726F6C6C696E67222C655B652E737469636B795363726F6C6C3D3131355D3D22737469636B795363726F6C6C222C655B652E737469636B7954616253746F70733D3131365D3D22737469636B7954616253746F7073222C65';
wwv_flow_imp.g_varchar2_table(1706) := '5B652E73746F7052656E646572696E674C696E6541667465723D3131375D3D2273746F7052656E646572696E674C696E654166746572222C655B652E737567676573743D3131385D3D2273756767657374222C655B652E73756767657374466F6E745369';
wwv_flow_imp.g_varchar2_table(1707) := '7A653D3131395D3D2273756767657374466F6E7453697A65222C655B652E737567676573744C696E654865696768743D3132305D3D22737567676573744C696E65486569676874222C655B652E737567676573744F6E5472696767657243686172616374';
wwv_flow_imp.g_varchar2_table(1708) := '6572733D3132315D3D22737567676573744F6E5472696767657243686172616374657273222C655B652E7375676765737453656C656374696F6E3D3132325D3D227375676765737453656C656374696F6E222C655B652E746162436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(1709) := '3D3132335D3D22746162436F6D706C6574696F6E222C655B652E746162496E6465783D3132345D3D22746162496E646578222C655B652E756E69636F6465486967686C69676874696E673D3132355D3D22756E69636F6465486967686C69676874696E67';
wwv_flow_imp.g_varchar2_table(1710) := '222C655B652E756E757375616C4C696E655465726D696E61746F72733D3132365D3D22756E757375616C4C696E655465726D696E61746F7273222C655B652E757365536861646F77444F4D3D3132375D3D22757365536861646F77444F4D222C655B652E';
wwv_flow_imp.g_varchar2_table(1711) := '75736554616253746F70733D3132385D3D2275736554616253746F7073222C655B652E776F7264427265616B3D3132395D3D22776F7264427265616B222C655B652E776F72645365676D656E7465724C6F63616C65733D3133305D3D22776F7264536567';
wwv_flow_imp.g_varchar2_table(1712) := '6D656E7465724C6F63616C6573222C655B652E776F7264536570617261746F72733D3133315D3D22776F7264536570617261746F7273222C655B652E776F7264577261703D3133325D3D22776F726457726170222C655B652E776F726457726170427265';
wwv_flow_imp.g_varchar2_table(1713) := '616B4166746572436861726163746572733D3133335D3D22776F726457726170427265616B416674657243686172616374657273222C655B652E776F726457726170427265616B4265666F7265436861726163746572733D3133345D3D22776F72645772';
wwv_flow_imp.g_varchar2_table(1714) := '6170427265616B4265666F726543686172616374657273222C655B652E776F726457726170436F6C756D6E3D3133355D3D22776F726457726170436F6C756D6E222C655B652E776F7264577261704F76657272696465313D3133365D3D22776F72645772';
wwv_flow_imp.g_varchar2_table(1715) := '61704F7665727269646531222C655B652E776F7264577261704F76657272696465323D3133375D3D22776F7264577261704F7665727269646532222C655B652E7772617070696E67496E64656E743D3133385D3D227772617070696E67496E64656E7422';
wwv_flow_imp.g_varchar2_table(1716) := '2C655B652E7772617070696E6753747261746567793D3133395D3D227772617070696E675374726174656779222C655B652E73686F77446570726563617465643D3134305D3D2273686F7744657072656361746564222C655B652E696E6C617948696E74';
wwv_flow_imp.g_varchar2_table(1717) := '733D3134315D3D22696E6C617948696E7473222C655B652E656469746F72436C6173734E616D653D3134325D3D22656469746F72436C6173734E616D65222C655B652E706978656C526174696F3D3134335D3D22706978656C526174696F222C655B652E';
wwv_flow_imp.g_varchar2_table(1718) := '746162466F6375734D6F64653D3134345D3D22746162466F6375734D6F6465222C655B652E6C61796F7574496E666F3D3134355D3D226C61796F7574496E666F222C655B652E7772617070696E67496E666F3D3134365D3D227772617070696E67496E66';
wwv_flow_imp.g_varchar2_table(1719) := '6F222C655B652E64656661756C74436F6C6F724465636F7261746F72733D3134375D3D2264656661756C74436F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734163746976617465644F6E3D3134385D3D22636F6C';
wwv_flow_imp.g_varchar2_table(1720) := '6F724465636F7261746F72734163746976617465644F6E222C655B652E696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F73653D3134395D3D22696E6C696E65436F6D706C6574696F6E734163636573736962696C';
wwv_flow_imp.g_varchar2_table(1721) := '697479566572626F7365227D28506E7C7C28506E3D7B7D29292C66756E6374696F6E2865297B655B652E54657874446566696E65643D305D3D2254657874446566696E6564222C655B652E4C463D315D3D224C46222C655B652E43524C463D325D3D2243';
wwv_flow_imp.g_varchar2_table(1722) := '524C46227D28466E7C7C28466E3D7B7D29292C66756E6374696F6E2865297B655B652E4C463D305D3D224C46222C655B652E43524C463D315D3D2243524C46227D28566E7C7C28566E3D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D';
wwv_flow_imp.g_varchar2_table(1723) := '315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D28446E7C7C28446E3D7B7D29292C66756E6374696F6E2865297B655B652E496E6372656173653D305D3D22496E63';
wwv_flow_imp.g_varchar2_table(1724) := '7265617365222C655B652E44656372656173653D315D3D224465637265617365227D28716E7C7C28716E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E496E64656E743D315D3D22496E64656E74';
wwv_flow_imp.g_varchar2_table(1725) := '222C655B652E496E64656E744F757464656E743D325D3D22496E64656E744F757464656E74222C655B652E4F757464656E743D335D3D224F757464656E74227D284B6E7C7C284B6E3D7B7D29292C66756E6374696F6E2865297B655B652E426F74683D30';
wwv_flow_imp.g_varchar2_table(1726) := '5D3D22426F7468222C655B652E52696768743D315D3D225269676874222C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D286A6E7C7C286A6E3D7B7D29292C66756E6374696F6E2865297B655B652E5479';
wwv_flow_imp.g_varchar2_table(1727) := '70653D315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D28556E7C7C28556E3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B65';
wwv_flow_imp.g_varchar2_table(1728) := '2E4578706C696369743D315D3D224578706C69636974227D28426E7C7C28426E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963';
wwv_flow_imp.g_varchar2_table(1729) := '227D28246E7C7C28246E3D7B7D29292C66756E6374696F6E2865297B655B652E446570656E64734F6E4B624C61796F75743D2D315D3D22446570656E64734F6E4B624C61796F7574222C655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C65';
wwv_flow_imp.g_varchar2_table(1730) := '5B652E4261636B73706163653D315D3D224261636B7370616365222C655B652E5461623D325D3D22546162222C655B652E456E7465723D335D3D22456E746572222C655B652E53686966743D345D3D225368696674222C655B652E4374726C3D355D3D22';
wwv_flow_imp.g_varchar2_table(1731) := '4374726C222C655B652E416C743D365D3D22416C74222C655B652E5061757365427265616B3D375D3D225061757365427265616B222C655B652E436170734C6F636B3D385D3D22436170734C6F636B222C655B652E4573636170653D395D3D2245736361';
wwv_flow_imp.g_varchar2_table(1732) := '7065222C655B652E53706163653D31305D3D225370616365222C655B652E5061676555703D31315D3D22506167655570222C655B652E50616765446F776E3D31325D3D2250616765446F776E222C655B652E456E643D31335D3D22456E64222C655B652E';
wwv_flow_imp.g_varchar2_table(1733) := '486F6D653D31345D3D22486F6D65222C655B652E4C6566744172726F773D31355D3D224C6566744172726F77222C655B652E55704172726F773D31365D3D2255704172726F77222C655B652E52696768744172726F773D31375D3D225269676874417272';
wwv_flow_imp.g_varchar2_table(1734) := '6F77222C655B652E446F776E4172726F773D31385D3D22446F776E4172726F77222C655B652E496E736572743D31395D3D22496E73657274222C655B652E44656C6574653D32305D3D2244656C657465222C655B652E4469676974303D32315D3D224469';
wwv_flow_imp.g_varchar2_table(1735) := '67697430222C655B652E4469676974313D32325D3D22446967697431222C655B652E4469676974323D32335D3D22446967697432222C655B652E4469676974333D32345D3D22446967697433222C655B652E4469676974343D32355D3D22446967697434';
wwv_flow_imp.g_varchar2_table(1736) := '222C655B652E4469676974353D32365D3D22446967697435222C655B652E4469676974363D32375D3D22446967697436222C655B652E4469676974373D32385D3D22446967697437222C655B652E4469676974383D32395D3D22446967697438222C655B';
wwv_flow_imp.g_varchar2_table(1737) := '652E4469676974393D33305D3D22446967697439222C655B652E4B6579413D33315D3D224B657941222C655B652E4B6579423D33325D3D224B657942222C655B652E4B6579433D33335D3D224B657943222C655B652E4B6579443D33345D3D224B657944';
wwv_flow_imp.g_varchar2_table(1738) := '222C655B652E4B6579453D33355D3D224B657945222C655B652E4B6579463D33365D3D224B657946222C655B652E4B6579473D33375D3D224B657947222C655B652E4B6579483D33385D3D224B657948222C655B652E4B6579493D33395D3D224B657949';
wwv_flow_imp.g_varchar2_table(1739) := '222C655B652E4B65794A3D34305D3D224B65794A222C655B652E4B65794B3D34315D3D224B65794B222C655B652E4B65794C3D34325D3D224B65794C222C655B652E4B65794D3D34335D3D224B65794D222C655B652E4B65794E3D34345D3D224B65794E';
wwv_flow_imp.g_varchar2_table(1740) := '222C655B652E4B65794F3D34355D3D224B65794F222C655B652E4B6579503D34365D3D224B657950222C655B652E4B6579513D34375D3D224B657951222C655B652E4B6579523D34385D3D224B657952222C655B652E4B6579533D34395D3D224B657953';
wwv_flow_imp.g_varchar2_table(1741) := '222C655B652E4B6579543D35305D3D224B657954222C655B652E4B6579553D35315D3D224B657955222C655B652E4B6579563D35325D3D224B657956222C655B652E4B6579573D35335D3D224B657957222C655B652E4B6579583D35345D3D224B657958';
wwv_flow_imp.g_varchar2_table(1742) := '222C655B652E4B6579593D35355D3D224B657959222C655B652E4B65795A3D35365D3D224B65795A222C655B652E4D6574613D35375D3D224D657461222C655B652E436F6E746578744D656E753D35385D3D22436F6E746578744D656E75222C655B652E';
wwv_flow_imp.g_varchar2_table(1743) := '46313D35395D3D224631222C655B652E46323D36305D3D224632222C655B652E46333D36315D3D224633222C655B652E46343D36325D3D224634222C655B652E46353D36335D3D224635222C655B652E46363D36345D3D224636222C655B652E46373D36';
wwv_flow_imp.g_varchar2_table(1744) := '355D3D224637222C655B652E46383D36365D3D224638222C655B652E46393D36375D3D224639222C655B652E4631303D36385D3D22463130222C655B652E4631313D36395D3D22463131222C655B652E4631323D37305D3D22463132222C655B652E4631';
wwv_flow_imp.g_varchar2_table(1745) := '333D37315D3D22463133222C655B652E4631343D37325D3D22463134222C655B652E4631353D37335D3D22463135222C655B652E4631363D37345D3D22463136222C655B652E4631373D37355D3D22463137222C655B652E4631383D37365D3D22463138';
wwv_flow_imp.g_varchar2_table(1746) := '222C655B652E4631393D37375D3D22463139222C655B652E4632303D37385D3D22463230222C655B652E4632313D37395D3D22463231222C655B652E4632323D38305D3D22463232222C655B652E4632333D38315D3D22463233222C655B652E4632343D';
wwv_flow_imp.g_varchar2_table(1747) := '38325D3D22463234222C655B652E4E756D4C6F636B3D38335D3D224E756D4C6F636B222C655B652E5363726F6C6C4C6F636B3D38345D3D225363726F6C6C4C6F636B222C655B652E53656D69636F6C6F6E3D38355D3D2253656D69636F6C6F6E222C655B';
wwv_flow_imp.g_varchar2_table(1748) := '652E457175616C3D38365D3D22457175616C222C655B652E436F6D6D613D38375D3D22436F6D6D61222C655B652E4D696E75733D38385D3D224D696E7573222C655B652E506572696F643D38395D3D22506572696F64222C655B652E536C6173683D3930';
wwv_flow_imp.g_varchar2_table(1749) := '5D3D22536C617368222C655B652E4261636B71756F74653D39315D3D224261636B71756F7465222C655B652E427261636B65744C6566743D39325D3D22427261636B65744C656674222C655B652E4261636B736C6173683D39335D3D224261636B736C61';
wwv_flow_imp.g_varchar2_table(1750) := '7368222C655B652E427261636B657452696768743D39345D3D22427261636B65745269676874222C655B652E51756F74653D39355D3D2251756F7465222C655B652E4F454D5F383D39365D3D224F454D5F38222C655B652E496E746C4261636B736C6173';
wwv_flow_imp.g_varchar2_table(1751) := '683D39375D3D22496E746C4261636B736C617368222C655B652E4E756D706164303D39385D3D224E756D70616430222C655B652E4E756D706164313D39395D3D224E756D70616431222C655B652E4E756D706164323D3130305D3D224E756D7061643222';
wwv_flow_imp.g_varchar2_table(1752) := '2C655B652E4E756D706164333D3130315D3D224E756D70616433222C655B652E4E756D706164343D3130325D3D224E756D70616434222C655B652E4E756D706164353D3130335D3D224E756D70616435222C655B652E4E756D706164363D3130345D3D22';
wwv_flow_imp.g_varchar2_table(1753) := '4E756D70616436222C655B652E4E756D706164373D3130355D3D224E756D70616437222C655B652E4E756D706164383D3130365D3D224E756D70616438222C655B652E4E756D706164393D3130375D3D224E756D70616439222C655B652E4E756D706164';
wwv_flow_imp.g_varchar2_table(1754) := '4D756C7469706C793D3130385D3D224E756D7061644D756C7469706C79222C655B652E4E756D7061644164643D3130395D3D224E756D706164416464222C655B652E4E554D5041445F534550415241544F523D3131305D3D224E554D5041445F53455041';
wwv_flow_imp.g_varchar2_table(1755) := '5241544F52222C655B652E4E756D70616453756274726163743D3131315D3D224E756D7061645375627472616374222C655B652E4E756D706164446563696D616C3D3131325D3D224E756D706164446563696D616C222C655B652E4E756D706164446976';
wwv_flow_imp.g_varchar2_table(1756) := '6964653D3131335D3D224E756D706164446976696465222C655B652E4B45595F494E5F434F4D504F534954494F4E3D3131345D3D224B45595F494E5F434F4D504F534954494F4E222C655B652E41424E545F43313D3131355D3D2241424E545F4331222C';
wwv_flow_imp.g_varchar2_table(1757) := '655B652E41424E545F43323D3131365D3D2241424E545F4332222C655B652E417564696F566F6C756D654D7574653D3131375D3D22417564696F566F6C756D654D757465222C655B652E417564696F566F6C756D6555703D3131385D3D22417564696F56';
wwv_flow_imp.g_varchar2_table(1758) := '6F6C756D655570222C655B652E417564696F566F6C756D65446F776E3D3131395D3D22417564696F566F6C756D65446F776E222C655B652E42726F777365725365617263683D3132305D3D2242726F77736572536561726368222C655B652E42726F7773';
wwv_flow_imp.g_varchar2_table(1759) := '6572486F6D653D3132315D3D2242726F77736572486F6D65222C655B652E42726F777365724261636B3D3132325D3D2242726F777365724261636B222C655B652E42726F77736572466F72776172643D3132335D3D2242726F77736572466F7277617264';
wwv_flow_imp.g_varchar2_table(1760) := '222C655B652E4D65646961547261636B4E6578743D3132345D3D224D65646961547261636B4E657874222C655B652E4D65646961547261636B50726576696F75733D3132355D3D224D65646961547261636B50726576696F7573222C655B652E4D656469';
wwv_flow_imp.g_varchar2_table(1761) := '6153746F703D3132365D3D224D6564696153746F70222C655B652E4D65646961506C617950617573653D3132375D3D224D65646961506C61795061757365222C655B652E4C61756E63684D65646961506C617965723D3132385D3D224C61756E63684D65';
wwv_flow_imp.g_varchar2_table(1762) := '646961506C61796572222C655B652E4C61756E63684D61696C3D3132395D3D224C61756E63684D61696C222C655B652E4C61756E6368417070323D3133305D3D224C61756E636841707032222C655B652E436C6561723D3133315D3D22436C656172222C';
wwv_flow_imp.g_varchar2_table(1763) := '655B652E4D41585F56414C55453D3133325D3D224D41585F56414C5545227D28576E7C7C28576E3D7B7D29292C66756E6374696F6E2865297B655B652E48696E743D315D3D2248696E74222C655B652E496E666F3D325D3D22496E666F222C655B652E57';
wwv_flow_imp.g_varchar2_table(1764) := '61726E696E673D345D3D225761726E696E67222C655B652E4572726F723D385D3D224572726F72227D287A6E7C7C287A6E3D7B7D29292C66756E6374696F6E2865297B655B652E556E6E65636573736172793D315D3D22556E6E6563657373617279222C';
wwv_flow_imp.g_varchar2_table(1765) := '655B652E446570726563617465643D325D3D2244657072656361746564227D28486E7C7C28486E3D7B7D29292C66756E6374696F6E2865297B655B652E496E6C696E653D315D3D22496E6C696E65222C655B652E4775747465723D325D3D224775747465';
wwv_flow_imp.g_varchar2_table(1766) := '72227D28476E7C7C28476E3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F726D616C3D315D3D224E6F726D616C222C655B652E556E6465726C696E65643D325D3D22556E6465726C696E6564227D284A6E7C7C284A6E3D7B7D29292C66756E';
wwv_flow_imp.g_varchar2_table(1767) := '6374696F6E2865297B655B652E554E4B4E4F574E3D305D3D22554E4B4E4F574E222C655B652E54455854415245413D315D3D225445585441524541222C655B652E4755545445525F474C5950485F4D415247494E3D325D3D224755545445525F474C5950';
wwv_flow_imp.g_varchar2_table(1768) := '485F4D415247494E222C655B652E4755545445525F4C494E455F4E554D424552533D335D3D224755545445525F4C494E455F4E554D42455253222C655B652E4755545445525F4C494E455F4445434F524154494F4E533D345D3D224755545445525F4C49';
wwv_flow_imp.g_varchar2_table(1769) := '4E455F4445434F524154494F4E53222C655B652E4755545445525F564945575F5A4F4E453D355D3D224755545445525F564945575F5A4F4E45222C655B652E434F4E54454E545F544558543D365D3D22434F4E54454E545F54455854222C655B652E434F';
wwv_flow_imp.g_varchar2_table(1770) := '4E54454E545F454D5054593D375D3D22434F4E54454E545F454D505459222C655B652E434F4E54454E545F564945575F5A4F4E453D385D3D22434F4E54454E545F564945575F5A4F4E45222C655B652E434F4E54454E545F5749444745543D395D3D2243';
wwv_flow_imp.g_varchar2_table(1771) := '4F4E54454E545F574944474554222C655B652E4F564552564945575F52554C45523D31305D3D224F564552564945575F52554C4552222C655B652E5343524F4C4C4241523D31315D3D225343524F4C4C424152222C655B652E4F5645524C41595F574944';
wwv_flow_imp.g_varchar2_table(1772) := '4745543D31325D3D224F5645524C41595F574944474554222C655B652E4F5554534944455F454449544F523D31335D3D224F5554534944455F454449544F52227D28586E7C7C28586E3D7B7D29292C66756E6374696F6E2865297B655B652E414947656E';
wwv_flow_imp.g_varchar2_table(1773) := '6572617465643D315D3D22414947656E657261746564227D28516E7C7C28516E3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963';
wwv_flow_imp.g_varchar2_table(1774) := '227D285A6E7C7C285A6E3D7B7D29292C66756E6374696F6E2865297B655B652E544F505F52494748545F434F524E45523D305D3D22544F505F52494748545F434F524E4552222C655B652E424F54544F4D5F52494748545F434F524E45523D315D3D2242';
wwv_flow_imp.g_varchar2_table(1775) := '4F54544F4D5F52494748545F434F524E4552222C655B652E544F505F43454E5445523D325D3D22544F505F43454E544552227D28596E7C7C28596E3D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E';
wwv_flow_imp.g_varchar2_table(1776) := '43656E7465723D325D3D2243656E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D2865727C7C2865723D7B7D29292C66756E6374696F6E2865297B655B652E576F72643D305D3D22576F';
wwv_flow_imp.g_varchar2_table(1777) := '7264222C655B652E4C696E653D315D3D224C696E65222C655B652E537567676573743D325D3D2253756767657374227D2874727C7C2874723D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D305D3D224C656674222C655B652E526967';
wwv_flow_imp.g_varchar2_table(1778) := '68743D315D3D225269676874222C655B652E4E6F6E653D325D3D224E6F6E65222C655B652E4C6566744F66496E6A6563746564546578743D335D3D224C6566744F66496E6A656374656454657874222C655B652E52696768744F66496E6A656374656454';
wwv_flow_imp.g_varchar2_table(1779) := '6578743D345D3D2252696768744F66496E6A656374656454657874227D286E727C7C286E723D7B7D29292C66756E6374696F6E2865297B655B652E4F66663D305D3D224F6666222C655B652E4F6E3D315D3D224F6E222C655B652E52656C61746976653D';
wwv_flow_imp.g_varchar2_table(1780) := '325D3D2252656C6174697665222C655B652E496E74657276616C3D335D3D22496E74657276616C222C655B652E437573746F6D3D345D3D22437573746F6D227D2872727C7C2872723D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D30';
wwv_flow_imp.g_varchar2_table(1781) := '5D3D224E6F6E65222C655B652E546578743D315D3D2254657874222C655B652E426C6F636B733D325D3D22426C6F636B73227D2869727C7C2869723D7B7D29292C66756E6374696F6E2865297B655B652E536D6F6F74683D305D3D22536D6F6F7468222C';
wwv_flow_imp.g_varchar2_table(1782) := '655B652E496D6D6564696174653D315D3D22496D6D656469617465227D2873727C7C2873723D7B7D29292C66756E6374696F6E2865297B655B652E4175746F3D315D3D224175746F222C655B652E48696464656E3D325D3D2248696464656E222C655B65';
wwv_flow_imp.g_varchar2_table(1783) := '2E56697369626C653D335D3D2256697369626C65227D286F727C7C286F723D7B7D29292C66756E6374696F6E2865297B655B652E4C54523D305D3D224C5452222C655B652E52544C3D315D3D2252544C227D2861727C7C2861723D7B7D29292C66756E63';
wwv_flow_imp.g_varchar2_table(1784) := '74696F6E2865297B652E4F66663D226F6666222C652E4F6E436F64653D226F6E436F6465222C652E4F6E3D226F6E227D286C727C7C286C723D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B65';
wwv_flow_imp.g_varchar2_table(1785) := '2E547269676765724368617261637465723D325D3D2254726967676572436861726163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E6765227D2875727C7C2875723D7B7D29292C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1786) := '65297B655B652E46696C653D305D3D2246696C65222C655B652E4D6F64756C653D315D3D224D6F64756C65222C655B652E4E616D6573706163653D325D3D224E616D657370616365222C655B652E5061636B6167653D335D3D225061636B616765222C65';
wwv_flow_imp.g_varchar2_table(1787) := '5B652E436C6173733D345D3D22436C617373222C655B652E4D6574686F643D355D3D224D6574686F64222C655B652E50726F70657274793D365D3D2250726F7065727479222C655B652E4669656C643D375D3D224669656C64222C655B652E436F6E7374';
wwv_flow_imp.g_varchar2_table(1788) := '727563746F723D385D3D22436F6E7374727563746F72222C655B652E456E756D3D395D3D22456E756D222C655B652E496E746572666163653D31305D3D22496E74657266616365222C655B652E46756E6374696F6E3D31315D3D2246756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(1789) := '2C655B652E5661726961626C653D31325D3D225661726961626C65222C655B652E436F6E7374616E743D31335D3D22436F6E7374616E74222C655B652E537472696E673D31345D3D22537472696E67222C655B652E4E756D6265723D31355D3D224E756D';
wwv_flow_imp.g_varchar2_table(1790) := '626572222C655B652E426F6F6C65616E3D31365D3D22426F6F6C65616E222C655B652E41727261793D31375D3D224172726179222C655B652E4F626A6563743D31385D3D224F626A656374222C655B652E4B65793D31395D3D224B6579222C655B652E4E';
wwv_flow_imp.g_varchar2_table(1791) := '756C6C3D32305D3D224E756C6C222C655B652E456E756D4D656D6265723D32315D3D22456E756D4D656D626572222C655B652E5374727563743D32325D3D22537472756374222C655B652E4576656E743D32335D3D224576656E74222C655B652E4F7065';
wwv_flow_imp.g_varchar2_table(1792) := '7261746F723D32345D3D224F70657261746F72222C655B652E54797065506172616D657465723D32355D3D2254797065506172616D65746572227D2863727C7C2863723D7B7D29292C66756E6374696F6E2865297B655B652E446570726563617465643D';
wwv_flow_imp.g_varchar2_table(1793) := '315D3D2244657072656361746564227D2868727C7C2868723D7B7D29292C66756E6374696F6E2865297B655B652E48696464656E3D305D3D2248696464656E222C655B652E426C696E6B3D315D3D22426C696E6B222C655B652E536D6F6F74683D325D3D';
wwv_flow_imp.g_varchar2_table(1794) := '22536D6F6F7468222C655B652E50686173653D335D3D225068617365222C655B652E457870616E643D345D3D22457870616E64222C655B652E536F6C69643D355D3D22536F6C6964227D2864727C7C2864723D7B7D29292C66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(1795) := '655B652E4C696E653D315D3D224C696E65222C655B652E426C6F636B3D325D3D22426C6F636B222C655B652E556E6465726C696E653D335D3D22556E6465726C696E65222C655B652E4C696E655468696E3D345D3D224C696E655468696E222C655B652E';
wwv_flow_imp.g_varchar2_table(1796) := '426C6F636B4F75746C696E653D355D3D22426C6F636B4F75746C696E65222C655B652E556E6465726C696E655468696E3D365D3D22556E6465726C696E655468696E227D2866727C7C2866723D7B7D29292C66756E6374696F6E2865297B655B652E416C';
wwv_flow_imp.g_varchar2_table(1797) := '7761797347726F77735768656E547970696E67417445646765733D305D3D22416C7761797347726F77735768656E547970696E6741744564676573222C655B652E4E6576657247726F77735768656E547970696E67417445646765733D315D3D224E6576';
wwv_flow_imp.g_varchar2_table(1798) := '657247726F77735768656E547970696E6741744564676573222C655B652E47726F77734F6E6C795768656E547970696E674265666F72653D325D3D2247726F77734F6E6C795768656E547970696E674265666F7265222C655B652E47726F77734F6E6C79';
wwv_flow_imp.g_varchar2_table(1799) := '5768656E547970696E6741667465723D335D3D2247726F77734F6E6C795768656E547970696E674166746572227D286D727C7C286D723D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E53616D653D';
wwv_flow_imp.g_varchar2_table(1800) := '315D3D2253616D65222C655B652E496E64656E743D325D3D22496E64656E74222C655B652E44656570496E64656E743D335D3D2244656570496E64656E74227D2867727C7C2867723D7B7D29293B636C6173732077727B7374617469632063686F726428';
wwv_flow_imp.g_varchar2_table(1801) := '652C74297B72657475726E2066756E6374696F6E28652C74297B72657475726E28657C2836353533352674293C3C31363E3E3E30293E3E3E307D28652C74297D7D77722E4374726C436D643D323034382C77722E53686966743D313032342C77722E416C';
wwv_flow_imp.g_varchar2_table(1802) := '743D3531322C77722E57696E4374726C3D3235363B636C6173732053727B636F6E7374727563746F7228652C74297B746869732E7572693D652C746869732E76616C75653D747D7D636C617373204C727B636F6E7374727563746F7228652C74297B6966';
wwv_flow_imp.g_varchar2_table(1803) := '28746869735B70725D3D225265736F757263654D6170222C6520696E7374616E63656F66204C7229746869732E6D61703D6E6577204D617028652E6D6170292C746869732E746F4B65793D6E756C6C213D743F743A4C722E64656661756C74546F4B6579';
wwv_flow_imp.g_varchar2_table(1804) := '3B656C73652069662866756E6374696F6E2865297B72657475726E2041727261792E697341727261792865297D286529297B746869732E6D61703D6E6577204D61702C746869732E746F4B65793D6E756C6C213D743F743A4C722E64656661756C74546F';
wwv_flow_imp.g_varchar2_table(1805) := '4B65793B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D656C736520746869732E6D61703D6E6577204D61702C746869732E746F4B65793D6E756C6C213D653F653A4C722E64656661756C74546F4B65797D73657428';
wwv_flow_imp.g_varchar2_table(1806) := '652C74297B72657475726E20746869732E6D61702E73657428746869732E746F4B65792865292C6E657720537228652C7429292C746869737D6765742865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E6D61702E67657428';
wwv_flow_imp.g_varchar2_table(1807) := '746869732E746F4B657928652929297C7C766F696420303D3D3D743F766F696420303A742E76616C75657D6861732865297B72657475726E20746869732E6D61702E68617328746869732E746F4B6579286529297D6765742073697A6528297B72657475';
wwv_flow_imp.g_varchar2_table(1808) := '726E20746869732E6D61702E73697A657D636C65617228297B746869732E6D61702E636C65617228297D64656C6574652865297B72657475726E20746869732E6D61702E64656C65746528746869732E746F4B6579286529297D666F724561636828652C';
wwv_flow_imp.g_varchar2_table(1809) := '74297B766F69642030213D3D74262628653D652E62696E64287429293B666F7228636F6E73745B742C6E5D6F6620746869732E6D61702965286E2E76616C75652C6E2E7572692C74686973297D2A76616C75657328297B666F7228636F6E73742065206F';
wwv_flow_imp.g_varchar2_table(1810) := '6620746869732E6D61702E76616C7565732829297969656C6420652E76616C75657D2A6B65797328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C6420652E7572697D2A656E747269657328297B666F';
wwv_flow_imp.g_varchar2_table(1811) := '7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C645B652E7572692C652E76616C75655D7D2A5B2870723D53796D626F6C2E746F537472696E675461672C53796D626F6C2E6974657261746F72295D28297B666F72';
wwv_flow_imp.g_varchar2_table(1812) := '28636F6E73745B2C655D6F6620746869732E6D6170297969656C645B652E7572692C652E76616C75655D7D7D4C722E64656661756C74546F4B65793D653D3E652E746F537472696E6728293B636C6173732045727B636F6E7374727563746F7228297B74';
wwv_flow_imp.g_varchar2_table(1813) := '6869735B76725D3D224C696E6B65644D6170222C746869732E5F6D61703D6E6577204D61702C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F73697A653D302C746869732E5F73746174653D30';
wwv_flow_imp.g_varchar2_table(1814) := '7D636C65617228297B746869732E5F6D61702E636C65617228292C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F73697A653D302C746869732E5F73746174652B2B7D6973456D70747928297B';
wwv_flow_imp.g_varchar2_table(1815) := '72657475726E21746869732E5F68656164262621746869732E5F7461696C7D6765742073697A6528297B72657475726E20746869732E5F73697A657D67657420666972737428297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E';
wwv_flow_imp.g_varchar2_table(1816) := '5F68656164297C7C766F696420303D3D3D653F766F696420303A652E76616C75657D676574206C61737428297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F7461696C297C7C766F696420303D3D3D653F766F696420303A65';
wwv_flow_imp.g_varchar2_table(1817) := '2E76616C75657D6861732865297B72657475726E20746869732E5F6D61702E6861732865297D67657428652C743D30297B636F6E7374206E3D746869732E5F6D61702E6765742865293B6966286E2972657475726E2030213D3D742626746869732E746F';
wwv_flow_imp.g_varchar2_table(1818) := '756368286E2C74292C6E2E76616C75657D73657428652C742C6E3D30297B6C657420723D746869732E5F6D61702E6765742865293B6966287229722E76616C75653D742C30213D3D6E2626746869732E746F75636828722C6E293B656C73657B73776974';
wwv_flow_imp.g_varchar2_table(1819) := '636828723D7B6B65793A652C76616C75653A742C6E6578743A766F696420302C70726576696F75733A766F696420307D2C6E297B6361736520303A6361736520323A64656661756C743A746869732E6164644974656D4C6173742872293B627265616B3B';
wwv_flow_imp.g_varchar2_table(1820) := '6361736520313A746869732E6164644974656D46697273742872297D746869732E5F6D61702E73657428652C72292C746869732E5F73697A652B2B7D72657475726E20746869737D64656C6574652865297B72657475726E2121746869732E72656D6F76';
wwv_flow_imp.g_varchar2_table(1821) := '652865297D72656D6F76652865297B636F6E737420743D746869732E5F6D61702E6765742865293B696628742972657475726E20746869732E5F6D61702E64656C6574652865292C746869732E72656D6F76654974656D2874292C746869732E5F73697A';
wwv_flow_imp.g_varchar2_table(1822) := '652D2D2C742E76616C75657D736869667428297B69662821746869732E5F68656164262621746869732E5F7461696C2972657475726E3B69662821746869732E5F686561647C7C21746869732E5F7461696C297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(1823) := '496E76616C6964206C69737422293B636F6E737420653D746869732E5F686561643B72657475726E20746869732E5F6D61702E64656C65746528652E6B6579292C746869732E72656D6F76654974656D2865292C746869732E5F73697A652D2D2C652E76';
wwv_flow_imp.g_varchar2_table(1824) := '616C75657D666F724561636828652C74297B636F6E7374206E3D746869732E5F73746174653B6C657420723D746869732E5F686561643B666F72283B723B297B696628743F652E62696E6428742928722E76616C75652C722E6B65792C74686973293A65';
wwv_flow_imp.g_varchar2_table(1825) := '28722E76616C75652C722E6B65792C74686973292C746869732E5F7374617465213D3D6E297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B723D72';
wwv_flow_imp.g_varchar2_table(1826) := '2E6E6578747D7D6B65797328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420723D7B5B53796D626F6C2E6974657261746F725D3A28293D3E722C6E65787428297B6966';
wwv_flow_imp.g_varchar2_table(1827) := '28652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E6B6579';
wwv_flow_imp.g_varchar2_table(1828) := '2C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20727D76616C75657328297B636F6E737420653D746869732C743D746869732E5F7374';
wwv_flow_imp.g_varchar2_table(1829) := '6174653B6C6574206E3D746869732E5F686561643B636F6E737420723D7B5B53796D626F6C2E6974657261746F725D3A28293D3E722C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B6564';
wwv_flow_imp.g_varchar2_table(1830) := '4D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E76616C75652C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B';
wwv_flow_imp.g_varchar2_table(1831) := '76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20727D656E747269657328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420723D7B5B53796D';
wwv_flow_imp.g_varchar2_table(1832) := '626F6C2E6974657261746F725D3A28293D3E722C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E';
wwv_flow_imp.g_varchar2_table(1833) := '22293B6966286E297B636F6E737420653D7B76616C75653A5B6E2E6B65792C6E2E76616C75655D2C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B7265';
wwv_flow_imp.g_varchar2_table(1834) := '7475726E20727D5B2876723D53796D626F6C2E746F537472696E675461672C53796D626F6C2E6974657261746F72295D28297B72657475726E20746869732E656E747269657328297D7472696D4F6C642865297B696628653E3D746869732E73697A6529';
wwv_flow_imp.g_varchar2_table(1835) := '72657475726E3B696628303D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F686561642C6E3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D61702E64656C65746528';
wwv_flow_imp.g_varchar2_table(1836) := '742E6B6579292C743D742E6E6578742C6E2D2D3B746869732E5F686561643D742C746869732E5F73697A653D6E2C74262628742E70726576696F75733D766F69642030292C746869732E5F73746174652B2B7D7472696D4E65772865297B696628653E3D';
wwv_flow_imp.g_varchar2_table(1837) := '746869732E73697A652972657475726E3B696628303D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F7461696C2C6E3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D';
wwv_flow_imp.g_varchar2_table(1838) := '61702E64656C65746528742E6B6579292C743D742E70726576696F75732C6E2D2D3B746869732E5F7461696C3D742C746869732E5F73697A653D6E2C74262628742E6E6578743D766F69642030292C746869732E5F73746174652B2B7D6164644974656D';
wwv_flow_imp.g_varchar2_table(1839) := '46697273742865297B696628746869732E5F686561647C7C746869732E5F7461696C297B69662821746869732E5F68656164297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E6E6578743D746869732E5F68656164';
wwv_flow_imp.g_varchar2_table(1840) := '2C746869732E5F686561642E70726576696F75733D657D656C736520746869732E5F7461696C3D653B746869732E5F686561643D652C746869732E5F73746174652B2B7D6164644974656D4C6173742865297B696628746869732E5F686561647C7C7468';
wwv_flow_imp.g_varchar2_table(1841) := '69732E5F7461696C297B69662821746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E70726576696F75733D746869732E5F7461696C2C746869732E5F7461696C2E6E6578743D657D656C73';
wwv_flow_imp.g_varchar2_table(1842) := '6520746869732E5F686561643D653B746869732E5F7461696C3D652C746869732E5F73746174652B2B7D72656D6F76654974656D2865297B696628653D3D3D746869732E5F686561642626653D3D3D746869732E5F7461696C29746869732E5F68656164';
wwv_flow_imp.g_varchar2_table(1843) := '3D766F696420302C746869732E5F7461696C3D766F696420303B656C736520696628653D3D3D746869732E5F68656164297B69662821652E6E657874297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E6E6578742E';
wwv_flow_imp.g_varchar2_table(1844) := '70726576696F75733D766F696420302C746869732E5F686561643D652E6E6578747D656C736520696628653D3D3D746869732E5F7461696C297B69662821652E70726576696F7573297468726F77206E6577204572726F722822496E76616C6964206C69';
wwv_flow_imp.g_varchar2_table(1845) := '737422293B652E70726576696F75732E6E6578743D766F696420302C746869732E5F7461696C3D652E70726576696F75737D656C73657B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B69662821747C7C216E297468726F77206E';
wwv_flow_imp.g_varchar2_table(1846) := '6577204572726F722822496E76616C6964206C69737422293B742E70726576696F75733D6E2C6E2E6E6578743D747D652E6E6578743D766F696420302C652E70726576696F75733D766F696420302C746869732E5F73746174652B2B7D746F7563682865';
wwv_flow_imp.g_varchar2_table(1847) := '2C74297B69662821746869732E5F686561647C7C21746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B696628313D3D3D747C7C323D3D3D7429696628313D3D3D74297B696628653D3D3D746869';
wwv_flow_imp.g_varchar2_table(1848) := '732E5F686561642972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F7461696C3F286E2E6E6578743D766F696420302C746869732E5F7461696C3D6E293A28742E70726576696F75733D6E';
wwv_flow_imp.g_varchar2_table(1849) := '2C6E2E6E6578743D74292C652E70726576696F75733D766F696420302C652E6E6578743D746869732E5F686561642C746869732E5F686561642E70726576696F75733D652C746869732E5F686561643D652C746869732E5F73746174652B2B7D656C7365';
wwv_flow_imp.g_varchar2_table(1850) := '20696628323D3D3D74297B696628653D3D3D746869732E5F7461696C2972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F686561643F28742E70726576696F75733D766F696420302C7468';
wwv_flow_imp.g_varchar2_table(1851) := '69732E5F686561643D74293A28742E70726576696F75733D6E2C6E2E6E6578743D74292C652E6E6578743D766F696420302C652E70726576696F75733D746869732E5F7461696C2C746869732E5F7461696C2E6E6578743D652C746869732E5F7461696C';
wwv_flow_imp.g_varchar2_table(1852) := '3D652C746869732E5F73746174652B2B7D7D746F4A534F4E28297B636F6E737420653D5B5D3B72657475726E20746869732E666F7245616368282828742C6E293D3E7B652E70757368285B6E2C745D297D29292C657D66726F6D4A534F4E2865297B7468';
wwv_flow_imp.g_varchar2_table(1853) := '69732E636C65617228293B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D7D636C61737320787220657874656E64732045727B636F6E7374727563746F7228652C743D31297B737570657228292C746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(1854) := '6D69743D652C746869732E5F726174696F3D4D6174682E6D696E284D6174682E6D617828302C74292C31297D676574206C696D697428297B72657475726E20746869732E5F6C696D69747D736574206C696D69742865297B746869732E5F6C696D69743D';
wwv_flow_imp.g_varchar2_table(1855) := '652C746869732E636865636B5472696D28297D67657428652C743D32297B72657475726E2073757065722E67657428652C74297D7065656B2865297B72657475726E2073757065722E67657428652C30297D73657428652C74297B72657475726E207375';
wwv_flow_imp.g_varchar2_table(1856) := '7065722E73657428652C742C32292C746869737D636865636B5472696D28297B746869732E73697A653E746869732E5F6C696D69742626746869732E7472696D284D6174682E726F756E6428746869732E5F6C696D69742A746869732E5F726174696F29';
wwv_flow_imp.g_varchar2_table(1857) := '297D7D636C617373204E727B636F6E7374727563746F7228297B746869732E6D61703D6E6577204D61707D61646428652C74297B6C6574206E3D746869732E6D61702E6765742865293B6E7C7C286E3D6E6577205365742C746869732E6D61702E736574';
wwv_flow_imp.g_varchar2_table(1858) := '28652C6E29292C6E2E6164642874297D64656C65746528652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E2626286E2E64656C6574652874292C303D3D3D6E2E73697A652626746869732E6D61702E64656C657465286529297D';
wwv_flow_imp.g_varchar2_table(1859) := '666F724561636828652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E26266E2E666F72456163682874297D6765742865297B72657475726E20746869732E6D61702E6765742865297C7C6E6577205365747D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1860) := '6E20417228652C742C6E2C722C69297B72657475726E2066756E6374696F6E28652C742C6E2C722C69297B696628303D3D3D722972657475726E21303B636F6E737420733D742E63686172436F6465417428722D31293B69662830213D3D652E67657428';
wwv_flow_imp.g_varchar2_table(1861) := '73292972657475726E21303B69662831333D3D3D737C7C31303D3D3D732972657475726E21303B696628693E30297B636F6E7374206E3D742E63686172436F646541742872293B69662830213D3D652E676574286E292972657475726E21307D72657475';
wwv_flow_imp.g_varchar2_table(1862) := '726E21317D28652C742C302C722C6929262666756E6374696F6E28652C742C6E2C722C69297B696628722B693D3D3D6E2972657475726E21303B636F6E737420733D742E63686172436F6465417428722B69293B69662830213D3D652E67657428732929';
wwv_flow_imp.g_varchar2_table(1863) := '72657475726E21303B69662831333D3D3D737C7C31303D3D3D732972657475726E21303B696628693E30297B636F6E7374206E3D742E63686172436F6465417428722B692D31293B69662830213D3D652E676574286E292972657475726E21307D726574';
wwv_flow_imp.g_varchar2_table(1864) := '75726E21317D28652C742C6E2C722C69297D6E657720636C61737320657874656E64732078727B636F6E7374727563746F7228652C743D31297B737570657228652C74297D7472696D2865297B746869732E7472696D4F6C642865297D73657428652C74';
wwv_flow_imp.g_varchar2_table(1865) := '297B72657475726E2073757065722E73657428652C74292C746869732E636865636B5472696D28292C746869737D7D283130292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D224365';
wwv_flow_imp.g_varchar2_table(1866) := '6E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D2862727C7C2862723D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465';
wwv_flow_imp.g_varchar2_table(1867) := '723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D2879727C7C2879723D7B7D29292C66756E6374696F6E2865297B655B652E426F74683D305D3D22426F7468222C655B652E52696768743D315D3D22526967687422';
wwv_flow_imp.g_varchar2_table(1868) := '2C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D285F727C7C285F723D7B7D29293B636C617373206B727B636F6E7374727563746F7228652C74297B746869732E5F776F7264536570617261746F72733D';
wwv_flow_imp.g_varchar2_table(1869) := '652C746869732E5F73656172636852656765783D742C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E6774683D307D72657365742865297B746869732E5F73656172636852656765';
wwv_flow_imp.g_varchar2_table(1870) := '782E6C617374496E6465783D652C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E6774683D307D6E6578742865297B636F6E737420743D652E6C656E6774683B6C6574206E3B646F';
wwv_flow_imp.g_varchar2_table(1871) := '7B696628746869732E5F707265764D617463685374617274496E6465782B746869732E5F707265764D617463684C656E6774683D3D3D742972657475726E206E756C6C3B6966286E3D746869732E5F73656172636852656765782E657865632865292C21';
wwv_flow_imp.g_varchar2_table(1872) := '6E2972657475726E206E756C6C3B636F6E737420723D6E2E696E6465782C693D6E5B305D2E6C656E6774683B696628723D3D3D746869732E5F707265764D617463685374617274496E6465782626693D3D3D746869732E5F707265764D617463684C656E';
wwv_flow_imp.g_varchar2_table(1873) := '677468297B696628303D3D3D69297B646528652C742C746869732E5F73656172636852656765782E6C617374496E646578293E36353533353F746869732E5F73656172636852656765782E6C617374496E6465782B3D323A746869732E5F736561726368';
wwv_flow_imp.g_varchar2_table(1874) := '52656765782E6C617374496E6465782B3D313B636F6E74696E75657D72657475726E206E756C6C7D696628746869732E5F707265764D617463685374617274496E6465783D722C746869732E5F707265764D617463684C656E6774683D692C2174686973';
wwv_flow_imp.g_varchar2_table(1875) := '2E5F776F7264536570617261746F72737C7C417228746869732E5F776F7264536570617261746F72732C652C742C722C69292972657475726E206E7D7768696C65286E293B72657475726E206E756C6C7D7D66756E6374696F6E20527228652C743D2255';
wwv_flow_imp.g_varchar2_table(1876) := '6E726561636861626C6522297B7468726F77206E6577204572726F722874297D66756E6374696F6E2054722865297B6528297C7C286528292C74286E6577206F2822417373657274696F6E204661696C6564222929297D66756E6374696F6E204D722865';
wwv_flow_imp.g_varchar2_table(1877) := '2C74297B6C6574206E3D303B666F72283B6E3C652E6C656E6774682D313B297B696628217428655B6E5D2C655B6E2B315D292972657475726E21313B6E2B2B7D72657475726E21307D636C617373204F727B73746174696320636F6D70757465556E6963';
wwv_flow_imp.g_varchar2_table(1878) := '6F6465486967686C696768747328652C742C6E297B636F6E737420723D6E3F6E2E73746172744C696E654E756D6265723A312C693D6E3F6E2E656E644C696E654E756D6265723A652E6765744C696E65436F756E7428292C733D6E65772049722874292C';
wwv_flow_imp.g_varchar2_table(1879) := '6F3D732E67657443616E646964617465436F6465506F696E747328293B6C657420613B766172206C3B613D22616C6C4E6F6E42617369634173636969223D3D3D6F3F6E65772052656745787028225B5E5C5C745C5C6E5C5C725C5C7832302D5C5C783745';
wwv_flow_imp.g_varchar2_table(1880) := '5D222C226722293A6E65772052656745787028605B247B6C3D41727261792E66726F6D286F292E6D61702828653D3E537472696E672E66726F6D436F6465506F696E7428652929292E6A6F696E282222292C6C2E7265706C616365282F5B5C5C5C7B5C7D';
wwv_flow_imp.g_varchar2_table(1881) := '5C2A5C2B5C3F5C7C5C5E5C245C2E5C5B5C5D5C285C295D2F672C225C5C242622297D5D602C226722293B636F6E737420753D6E6577206B72286E756C6C2C61292C633D5B5D3B6C657420682C643D21312C663D302C6D3D302C673D303B653A666F72286C';
wwv_flow_imp.g_varchar2_table(1882) := '657420743D722C6E3D693B743C3D6E3B742B2B297B636F6E7374206E3D652E6765744C696E65436F6E74656E742874292C723D6E2E6C656E6774683B752E72657365742830293B646F7B696628683D752E6E657874286E292C68297B6C657420653D682E';
wwv_flow_imp.g_varchar2_table(1883) := '696E6465782C693D682E696E6465782B685B305D2E6C656E6774683B653E3026267565286E2E63686172436F6465417428652D3129292626652D2D2C692B313C7226267565286E2E63686172436F6465417428692D3129292626692B2B3B636F6E737420';
wwv_flow_imp.g_varchar2_table(1884) := '6F3D6E2E737562737472696E6728652C69293B6C657420613D467428652B312C4F742C6E2C30293B612626612E656E64436F6C756D6E3C3D652B31262628613D6E756C6C293B636F6E7374206C3D732E73686F756C64486967686C696768744E6F6E4261';
wwv_flow_imp.g_varchar2_table(1885) := '7369634153434949286F2C613F612E776F72643A6E756C6C293B69662830213D3D6C297B333D3D3D6C3F662B2B3A323D3D3D6C3F6D2B2B3A313D3D3D6C3F672B2B3A527228293B636F6E7374206E3D3165333B696628632E6C656E6774683E3D6E297B64';
wwv_flow_imp.g_varchar2_table(1886) := '3D21303B627265616B20657D632E70757368286E657720537428742C652B312C742C692B3129297D7D7D7768696C652868297D72657475726E7B72616E6765733A632C6861734D6F72653A642C616D626967756F7573436861726163746572436F756E74';
wwv_flow_imp.g_varchar2_table(1887) := '3A662C696E76697369626C65436861726163746572436F756E743A6D2C6E6F6E42617369634173636969436861726163746572436F756E743A677D7D73746174696320636F6D70757465556E69636F6465486967686C69676874526561736F6E28652C74';
wwv_flow_imp.g_varchar2_table(1888) := '297B636F6E7374206E3D6E65772049722874293B737769746368286E2E73686F756C64486967686C696768744E6F6E4261736963415343494928652C6E756C6C29297B6361736520303A72657475726E206E756C6C3B6361736520323A72657475726E7B';
wwv_flow_imp.g_varchar2_table(1889) := '6B696E643A317D3B6361736520333A7B636F6E737420723D652E636F6465506F696E7441742830292C693D6E2E616D626967756F7573436861726163746572732E6765745072696D617279436F6E66757361626C652872292C733D67652E6765744C6F63';
wwv_flow_imp.g_varchar2_table(1890) := '616C657328292E66696C7465722828653D3E2167652E676574496E7374616E6365286E657720536574285B2E2E2E742E616C6C6F7765644C6F63616C65732C655D29292E6973416D626967756F757328722929293B72657475726E7B6B696E643A302C63';
wwv_flow_imp.g_varchar2_table(1891) := '6F6E66757361626C65576974683A537472696E672E66726F6D436F6465506F696E742869292C6E6F74416D626967756F7573496E4C6F63616C65733A737D7D6361736520313A72657475726E7B6B696E643A327D7D7D7D636C6173732049727B636F6E73';
wwv_flow_imp.g_varchar2_table(1892) := '74727563746F722865297B746869732E6F7074696F6E733D652C746869732E616C6C6F776564436F6465506F696E74733D6E65772053657428652E616C6C6F776564436F6465506F696E7473292C746869732E616D626967756F75734368617261637465';
wwv_flow_imp.g_varchar2_table(1893) := '72733D67652E676574496E7374616E6365286E65772053657428652E616C6C6F7765644C6F63616C657329297D67657443616E646964617465436F6465506F696E747328297B696628746869732E6F7074696F6E732E6E6F6E4261736963415343494929';
wwv_flow_imp.g_varchar2_table(1894) := '72657475726E22616C6C4E6F6E42617369634173636969223B636F6E737420653D6E6577205365743B696628746869732E6F7074696F6E732E696E76697369626C654368617261637465727329666F7228636F6E73742074206F662070652E636F646550';
wwv_flow_imp.g_varchar2_table(1895) := '6F696E747329507228537472696E672E66726F6D436F6465506F696E74287429297C7C652E6164642874293B696628746869732E6F7074696F6E732E616D626967756F75734368617261637465727329666F7228636F6E73742074206F6620746869732E';
wwv_flow_imp.g_varchar2_table(1896) := '616D626967756F7573436861726163746572732E676574436F6E66757361626C65436F6465506F696E7473282929652E6164642874293B666F7228636F6E73742074206F6620746869732E616C6C6F776564436F6465506F696E747329652E64656C6574';
wwv_flow_imp.g_varchar2_table(1897) := '652874293B72657475726E20657D73686F756C64486967686C696768744E6F6E4261736963415343494928652C74297B636F6E7374206E3D652E636F6465506F696E7441742830293B696628746869732E616C6C6F776564436F6465506F696E74732E68';
wwv_flow_imp.g_varchar2_table(1898) := '6173286E292972657475726E20303B696628746869732E6F7074696F6E732E6E6F6E426173696341534349492972657475726E20313B6C657420723D21312C693D21313B6966287429666F7228636F6E73742065206F662074297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(1899) := '2E636F6465506F696E7441742830292C6E3D28733D652C66652E74657374287329293B723D727C7C6E2C6E7C7C746869732E616D626967756F7573436861726163746572732E6973416D626967756F75732874297C7C70652E6973496E76697369626C65';
wwv_flow_imp.g_varchar2_table(1900) := '4368617261637465722874297C7C28693D2130297D76617220733B72657475726E21722626693F303A746869732E6F7074696F6E732E696E76697369626C65436861726163746572732626215072286529262670652E6973496E76697369626C65436861';
wwv_flow_imp.g_varchar2_table(1901) := '726163746572286E293F323A746869732E6F7074696F6E732E616D626967756F7573436861726163746572732626746869732E616D626967756F7573436861726163746572732E6973416D626967756F7573286E293F333A307D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1902) := '50722865297B72657475726E2220223D3D3D657C7C225C6E223D3D3D657C7C225C74223D3D3D657D636C6173732046727B636F6E7374727563746F7228652C742C6E297B746869732E6368616E6765733D652C746869732E6D6F7665733D742C74686973';
wwv_flow_imp.g_varchar2_table(1903) := '2E68697454696D656F75743D6E7D7D636C6173732056727B636F6E7374727563746F7228652C74297B746869732E6C696E6552616E67654D617070696E673D652C746869732E6368616E6765733D747D7D636C6173732044727B73746174696320616464';
wwv_flow_imp.g_varchar2_table(1904) := '52616E676528652C74297B6C6574206E3D303B666F72283B6E3C742E6C656E6774682626745B6E5D2E656E644578636C75736976653C652E73746172743B296E2B2B3B6C657420723D6E3B666F72283B723C742E6C656E6774682626745B725D2E737461';
wwv_flow_imp.g_varchar2_table(1905) := '72743C3D652E656E644578636C75736976653B29722B2B3B6966286E3D3D3D7229742E73706C696365286E2C302C65293B656C73657B636F6E737420693D4D6174682E6D696E28652E73746172742C745B6E5D2E7374617274292C733D4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(1906) := '7828652E656E644578636C75736976652C745B722D315D2E656E644578636C7573697665293B742E73706C696365286E2C722D6E2C6E657720447228692C7329297D7D7374617469632074727943726561746528652C74297B6966282128653E74292972';
wwv_flow_imp.g_varchar2_table(1907) := '657475726E206E657720447228652C74297D737461746963206F664C656E6774682865297B72657475726E206E657720447228302C65297D737461746963206F665374617274416E644C656E67746828652C74297B72657475726E206E65772044722865';
wwv_flow_imp.g_varchar2_table(1908) := '2C652B74297D636F6E7374727563746F7228652C74297B696628746869732E73746172743D652C746869732E656E644578636C75736976653D742C653E74297468726F77206E6577206F2860496E76616C69642072616E67653A20247B746869732E746F';
wwv_flow_imp.g_varchar2_table(1909) := '537472696E6728297D60297D676574206973456D70747928297B72657475726E20746869732E73746172743D3D3D746869732E656E644578636C75736976657D64656C74612865297B72657475726E206E657720447228746869732E73746172742B652C';
wwv_flow_imp.g_varchar2_table(1910) := '746869732E656E644578636C75736976652B65297D64656C746153746172742865297B72657475726E206E657720447228746869732E73746172742B652C746869732E656E644578636C7573697665297D64656C7461456E642865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(1911) := '6E657720447228746869732E73746172742C746869732E656E644578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644578636C75736976652D746869732E73746172747D746F537472696E6728297B72';
wwv_flow_imp.g_varchar2_table(1912) := '657475726E605B247B746869732E73746172747D2C20247B746869732E656E644578636C75736976657D29607D636F6E7461696E732865297B72657475726E20746869732E73746172743C3D652626653C746869732E656E644578636C75736976657D6A';
wwv_flow_imp.g_varchar2_table(1913) := '6F696E2865297B72657475726E206E6577204472284D6174682E6D696E28746869732E73746172742C652E7374617274292C4D6174682E6D617828746869732E656E644578636C75736976652C652E656E644578636C757369766529297D696E74657273';
wwv_flow_imp.g_varchar2_table(1914) := '6563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172742C652E7374617274292C6E3D4D6174682E6D696E28746869732E656E644578636C75736976652C652E656E644578636C7573697665293B696628743C3D6E29726574';
wwv_flow_imp.g_varchar2_table(1915) := '75726E206E657720447228742C6E297D696E74657273656374732865297B72657475726E204D6174682E6D617828746869732E73746172742C652E7374617274293C4D6174682E6D696E28746869732E656E644578636C75736976652C652E656E644578';
wwv_flow_imp.g_varchar2_table(1916) := '636C7573697665297D69734265666F72652865297B72657475726E20746869732E656E644578636C75736976653C3D652E73746172747D697341667465722865297B72657475726E20746869732E73746172743E3D652E656E644578636C75736976657D';
wwv_flow_imp.g_varchar2_table(1917) := '736C6963652865297B72657475726E20652E736C69636528746869732E73746172742C746869732E656E644578636C7573697665297D737562737472696E672865297B72657475726E20652E737562737472696E6728746869732E73746172742C746869';
wwv_flow_imp.g_varchar2_table(1918) := '732E656E644578636C7573697665297D636C69702865297B696628746869732E6973456D707479297468726F77206E6577206F2860496E76616C696420636C697070696E672072616E67653A20247B746869732E746F537472696E6728297D60293B7265';
wwv_flow_imp.g_varchar2_table(1919) := '7475726E204D6174682E6D617828746869732E73746172742C4D6174682E6D696E28746869732E656E644578636C75736976652D312C6529297D636C69704379636C69632865297B696628746869732E6973456D707479297468726F77206E6577206F28';
wwv_flow_imp.g_varchar2_table(1920) := '60496E76616C696420636C697070696E672072616E67653A20247B746869732E746F537472696E6728297D60293B72657475726E20653C746869732E73746172743F746869732E656E644578636C75736976652D28746869732E73746172742D65292574';
wwv_flow_imp.g_varchar2_table(1921) := '6869732E6C656E6774683A653E3D746869732E656E644578636C75736976653F746869732E73746172742B28652D746869732E73746172742925746869732E6C656E6774683A657D666F72456163682865297B666F72286C657420743D746869732E7374';
wwv_flow_imp.g_varchar2_table(1922) := '6172743B743C746869732E656E644578636C75736976653B742B2B29652874297D7D66756E6374696F6E20717228652C74297B636F6E7374206E3D4B7228652C74293B72657475726E2D313D3D3D6E3F766F696420303A655B6E5D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1923) := '204B7228652C742C6E3D302C723D652E6C656E677468297B6C657420693D6E2C733D723B666F72283B693C733B297B636F6E7374206E3D4D6174682E666C6F6F722828692B73292F32293B7428655B6E5D293F693D6E2B313A733D6E7D72657475726E20';
wwv_flow_imp.g_varchar2_table(1924) := '692D317D66756E6374696F6E206A7228652C742C6E3D302C723D652E6C656E677468297B6C657420693D6E2C733D723B666F72283B693C733B297B636F6E7374206E3D4D6174682E666C6F6F722828692B73292F32293B7428655B6E5D293F733D6E3A69';
wwv_flow_imp.g_varchar2_table(1925) := '3D6E2B317D72657475726E20697D636C6173732055727B636F6E7374727563746F722865297B746869732E5F61727261793D652C746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C6173744964783D307D66696E644C6173744D6F6E6F746F';
wwv_flow_imp.g_varchar2_table(1926) := '6E6F75732865297B69662855722E617373657274496E76617269616E7473297B696628746869732E5F7072657646696E644C61737450726564696361746529666F7228636F6E73742074206F6620746869732E5F617272617929696628746869732E5F70';
wwv_flow_imp.g_varchar2_table(1927) := '72657646696E644C61737450726564696361746528742926262165287429297468726F77206E6577204572726F7228224D6F6E6F746F6E6F757341727261793A2063757272656E7420707265646963617465206D757374206265207765616B6572207468';
wwv_flow_imp.g_varchar2_table(1928) := '616E20286F7220657175616C20746F29207468652070726576696F7573207072656469636174652E22293B746869732E5F7072657646696E644C6173745072656469636174653D657D636F6E737420743D4B7228746869732E5F61727261792C652C7468';
wwv_flow_imp.g_varchar2_table(1929) := '69732E5F66696E644C6173744D6F6E6F746F6E6F75734C617374496478293B72657475726E20746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C6173744964783D742B312C2D313D3D3D743F766F696420303A746869732E5F61727261795B';
wwv_flow_imp.g_varchar2_table(1930) := '745D7D7D55722E617373657274496E76617269616E74733D21313B636C6173732042727B7374617469632066726F6D52616E6765496E636C75736976652865297B72657475726E206E657720427228652E73746172744C696E654E756D6265722C652E65';
wwv_flow_imp.g_varchar2_table(1931) := '6E644C696E654E756D6265722B31297D737461746963206A6F696E4D616E792865297B696628303D3D3D652E6C656E6774682972657475726E5B5D3B6C657420743D6E657720247228655B305D2E736C6963652829293B666F72286C6574206E3D313B6E';
wwv_flow_imp.g_varchar2_table(1932) := '3C652E6C656E6774683B6E2B2B29743D742E676574556E696F6E286E657720247228655B6E5D2E736C696365282929293B72657475726E20742E72616E6765737D737461746963206A6F696E2865297B696628303D3D3D652E6C656E677468297468726F';
wwv_flow_imp.g_varchar2_table(1933) := '77206E6577206F28226C696E6552616E6765732063616E6E6F7420626520656D70747922293B6C657420743D655B305D2E73746172744C696E654E756D6265722C6E3D655B305D2E656E644C696E654E756D6265724578636C75736976653B666F72286C';
wwv_flow_imp.g_varchar2_table(1934) := '657420723D313B723C652E6C656E6774683B722B2B29743D4D6174682E6D696E28742C655B725D2E73746172744C696E654E756D626572292C6E3D4D6174682E6D6178286E2C655B725D2E656E644C696E654E756D6265724578636C7573697665293B72';
wwv_flow_imp.g_varchar2_table(1935) := '657475726E206E657720427228742C6E297D737461746963206F664C656E67746828652C74297B72657475726E206E657720427228652C652B74297D73746174696320646573657269616C697A652865297B72657475726E206E657720427228655B305D';
wwv_flow_imp.g_varchar2_table(1936) := '2C655B315D297D636F6E7374727563746F7228652C74297B696628653E74297468726F77206E6577206F286073746172744C696E654E756D62657220247B657D2063616E6E6F7420626520616674657220656E644C696E654E756D6265724578636C7573';
wwv_flow_imp.g_varchar2_table(1937) := '69766520247B747D60293B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D6265724578636C75736976653D747D636F6E7461696E732865297B72657475726E20746869732E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(1938) := '6265723C3D652626653C746869732E656E644C696E654E756D6265724578636C75736976657D676574206973456D70747928297B72657475726E20746869732E73746172744C696E654E756D6265723D3D3D746869732E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(1939) := '4578636C75736976657D64656C74612865297B72657475726E206E657720427228746869732E73746172744C696E654E756D6265722B652C746869732E656E644C696E654E756D6265724578636C75736976652B65297D64656C74614C656E6774682865';
wwv_flow_imp.g_varchar2_table(1940) := '297B72657475726E206E657720427228746869732E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644C696E65';
wwv_flow_imp.g_varchar2_table(1941) := '4E756D6265724578636C75736976652D746869732E73746172744C696E654E756D6265727D6A6F696E2865297B72657475726E206E6577204272284D6174682E6D696E28746869732E73746172744C696E654E756D6265722C652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(1942) := '4E756D626572292C4D6174682E6D617828746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E654E756D6265724578636C757369766529297D746F537472696E6728297B72657475726E605B247B746869732E7374';
wwv_flow_imp.g_varchar2_table(1943) := '6172744C696E654E756D6265727D2C247B746869732E656E644C696E654E756D6265724578636C75736976657D29607D696E746572736563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172744C696E654E756D6265722C65';
wwv_flow_imp.g_varchar2_table(1944) := '2E73746172744C696E654E756D626572292C6E3D4D6174682E6D696E28746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E654E756D6265724578636C7573697665293B696628743C3D6E2972657475726E206E65';
wwv_flow_imp.g_varchar2_table(1945) := '7720427228742C6E297D696E74657273656374735374726963742865297B72657475726E20746869732E73746172744C696E654E756D6265723C652E656E644C696E654E756D6265724578636C75736976652626652E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(1946) := '723C746869732E656E644C696E654E756D6265724578636C75736976657D6F7665726C61704F72546F7563682865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(1947) := '652626652E73746172744C696E654E756D6265723C3D746869732E656E644C696E654E756D6265724578636C75736976657D657175616C732865297B72657475726E20746869732E73746172744C696E654E756D6265723D3D3D652E73746172744C696E';
wwv_flow_imp.g_varchar2_table(1948) := '654E756D6265722626746869732E656E644C696E654E756D6265724578636C75736976653D3D3D652E656E644C696E654E756D6265724578636C75736976657D746F496E636C757369766552616E676528297B72657475726E20746869732E6973456D70';
wwv_flow_imp.g_varchar2_table(1949) := '74793F6E756C6C3A6E657720537428746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445474552297D746F4578636C75';
wwv_flow_imp.g_varchar2_table(1950) := '7369766552616E676528297B72657475726E206E657720537428746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D6265724578636C75736976652C31297D6D6170546F4C696E6541727261792865297B636F';
wwv_flow_imp.g_varchar2_table(1951) := '6E737420743D5B5D3B666F72286C6574206E3D746869732E73746172744C696E654E756D6265723B6E3C746869732E656E644C696E654E756D6265724578636C75736976653B6E2B2B29742E707573682865286E29293B72657475726E20747D666F7245';
wwv_flow_imp.g_varchar2_table(1952) := '6163682865297B666F72286C657420743D746869732E73746172744C696E654E756D6265723B743C746869732E656E644C696E654E756D6265724578636C75736976653B742B2B29652874297D73657269616C697A6528297B72657475726E5B74686973';
wwv_flow_imp.g_varchar2_table(1953) := '2E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976655D7D696E636C756465732865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652626653C746869732E656E64';
wwv_flow_imp.g_varchar2_table(1954) := '4C696E654E756D6265724578636C75736976657D746F4F666673657452616E676528297B72657475726E206E657720447228746869732E73746172744C696E654E756D6265722D312C746869732E656E644C696E654E756D6265724578636C7573697665';
wwv_flow_imp.g_varchar2_table(1955) := '2D31297D7D636C6173732024727B636F6E7374727563746F7228653D5B5D297B746869732E5F6E6F726D616C697A656452616E6765733D657D6765742072616E67657328297B72657475726E20746869732E5F6E6F726D616C697A656452616E6765737D';
wwv_flow_imp.g_varchar2_table(1956) := '61646452616E67652865297B696628303D3D3D652E6C656E6774682972657475726E3B636F6E737420743D6A7228746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D65';
wwv_flow_imp.g_varchar2_table(1957) := '2E73746172744C696E654E756D62657229292C6E3D4B7228746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C757369766529292B313B69';
wwv_flow_imp.g_varchar2_table(1958) := '6628743D3D3D6E29746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C302C65293B656C736520696628743D3D3D6E2D31297B636F6E7374206E3D746869732E5F6E6F726D616C697A656452616E6765735B745D3B74686973';
wwv_flow_imp.g_varchar2_table(1959) := '2E5F6E6F726D616C697A656452616E6765735B745D3D6E2E6A6F696E2865297D656C73657B636F6E737420723D746869732E5F6E6F726D616C697A656452616E6765735B745D2E6A6F696E28746869732E5F6E6F726D616C697A656452616E6765735B6E';
wwv_flow_imp.g_varchar2_table(1960) := '2D315D292E6A6F696E2865293B746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C6E2D742C72297D7D636F6E7461696E732865297B636F6E737420743D717228746869732E5F6E6F726D616C697A656452616E6765732C28';
wwv_flow_imp.g_varchar2_table(1961) := '743D3E742E73746172744C696E654E756D6265723C3D6529293B72657475726E2121742626742E656E644C696E654E756D6265724578636C75736976653E657D696E74657273656374732865297B636F6E737420743D717228746869732E5F6E6F726D61';
wwv_flow_imp.g_varchar2_table(1962) := '6C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C652E656E644C696E654E756D6265724578636C757369766529293B72657475726E2121742626742E656E644C696E654E756D6265724578636C75736976653E652E73';
wwv_flow_imp.g_varchar2_table(1963) := '746172744C696E654E756D6265727D676574556E696F6E2865297B696628303D3D3D746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682972657475726E20653B696628303D3D3D652E5F6E6F726D616C697A656452616E6765732E';
wwv_flow_imp.g_varchar2_table(1964) := '6C656E6774682972657475726E20746869733B636F6E737420743D5B5D3B6C6574206E3D302C723D302C693D6E756C6C3B666F72283B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774687C7C723C652E5F6E6F726D616C697A';
wwv_flow_imp.g_varchar2_table(1965) := '656452616E6765732E6C656E6774683B297B6C657420733D6E756C6C3B6966286E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626723C652E5F6E6F726D616C697A656452616E6765732E6C656E677468297B636F6E7374';
wwv_flow_imp.g_varchar2_table(1966) := '20743D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C693D652E5F6E6F726D616C697A656452616E6765735B725D3B742E73746172744C696E654E756D6265723C692E73746172744C696E654E756D6265723F28733D742C6E2B2B293A';
wwv_flow_imp.g_varchar2_table(1967) := '28733D692C722B2B297D656C7365206E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774683F28733D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C6E2B2B293A28733D652E5F6E6F726D616C697A656452616E';
wwv_flow_imp.g_varchar2_table(1968) := '6765735B725D2C722B2B293B6E756C6C3D3D3D693F693D733A692E656E644C696E654E756D6265724578636C75736976653E3D732E73746172744C696E654E756D6265723F693D6E657720427228692E73746172744C696E654E756D6265722C4D617468';
wwv_flow_imp.g_varchar2_table(1969) := '2E6D617828692E656E644C696E654E756D6265724578636C75736976652C732E656E644C696E654E756D6265724578636C757369766529293A28742E707573682869292C693D73297D72657475726E206E756C6C213D3D692626742E707573682869292C';
wwv_flow_imp.g_varchar2_table(1970) := '6E65772024722874297D737562747261637446726F6D2865297B636F6E737420743D6A7228746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D652E73746172744C696E';
wwv_flow_imp.g_varchar2_table(1971) := '654E756D62657229292C6E3D4B7228746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C757369766529292B313B696628743D3D3D6E2972';
wwv_flow_imp.g_varchar2_table(1972) := '657475726E206E6577202472285B655D293B636F6E737420723D5B5D3B6C657420693D652E73746172744C696E654E756D6265723B666F72286C657420653D743B653C6E3B652B2B297B636F6E737420743D746869732E5F6E6F726D616C697A65645261';
wwv_flow_imp.g_varchar2_table(1973) := '6E6765735B655D3B742E73746172744C696E654E756D6265723E692626722E70757368286E657720427228692C742E73746172744C696E654E756D62657229292C693D742E656E644C696E654E756D6265724578636C75736976657D72657475726E2069';
wwv_flow_imp.g_varchar2_table(1974) := '3C652E656E644C696E654E756D6265724578636C75736976652626722E70757368286E657720427228692C652E656E644C696E654E756D6265724578636C757369766529292C6E65772024722872297D746F537472696E6728297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(1975) := '69732E5F6E6F726D616C697A656452616E6765732E6D61702828653D3E652E746F537472696E67282929292E6A6F696E28222C2022297D676574496E74657273656374696F6E2865297B636F6E737420743D5B5D3B6C6574206E3D302C723D303B666F72';
wwv_flow_imp.g_varchar2_table(1976) := '283B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626723C652E5F6E6F726D616C697A656452616E6765732E6C656E6774683B297B636F6E737420693D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C';
wwv_flow_imp.g_varchar2_table(1977) := '733D652E5F6E6F726D616C697A656452616E6765735B725D2C6F3D692E696E746572736563742873293B6F2626216F2E6973456D7074792626742E70757368286F292C692E656E644C696E654E756D6265724578636C75736976653C732E656E644C696E';
wwv_flow_imp.g_varchar2_table(1978) := '654E756D6265724578636C75736976653F6E2B2B3A722B2B7D72657475726E206E65772024722874297D6765745769746844656C74612865297B72657475726E206E657720247228746869732E5F6E6F726D616C697A656452616E6765732E6D61702828';
wwv_flow_imp.g_varchar2_table(1979) := '743D3E742E64656C74612865292929297D7D636C6173732057727B737461746963206265747765656E506F736974696F6E7328652C74297B72657475726E20652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265723F6E657720577228302C';
wwv_flow_imp.g_varchar2_table(1980) := '742E636F6C756D6E2D652E636F6C756D6E293A6E657720577228742E6C696E654E756D6265722D652E6C696E654E756D6265722C742E636F6C756D6E2D31297D737461746963206F6652616E67652865297B72657475726E2057722E6265747765656E50';
wwv_flow_imp.g_varchar2_table(1981) := '6F736974696F6E7328652E6765745374617274506F736974696F6E28292C652E676574456E64506F736974696F6E2829297D737461746963206F66546578742865297B6C657420743D302C6E3D303B666F7228636F6E73742072206F66206529225C6E22';
wwv_flow_imp.g_varchar2_table(1982) := '3D3D3D723F28742B2B2C6E3D30293A6E2B2B3B72657475726E206E657720577228742C6E297D636F6E7374727563746F7228652C74297B746869732E6C696E65436F756E743D652C746869732E636F6C756D6E436F756E743D747D697347726561746572';
wwv_flow_imp.g_varchar2_table(1983) := '5468616E4F72457175616C546F2865297B72657475726E20746869732E6C696E65436F756E74213D3D652E6C696E65436F756E743F746869732E6C696E65436F756E743E652E6C696E65436F756E743A746869732E636F6C756D6E436F756E743E3D652E';
wwv_flow_imp.g_varchar2_table(1984) := '636F6C756D6E436F756E747D63726561746552616E67652865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E657720537428652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C';
wwv_flow_imp.g_varchar2_table(1985) := '756D6E2B746869732E636F6C756D6E436F756E74293A6E657720537428652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D61';
wwv_flow_imp.g_varchar2_table(1986) := '6464546F506F736974696F6E2865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E657720777428652E6C696E654E756D6265722C652E636F6C756D6E2B746869732E636F6C756D6E436F756E74293A6E657720777428652E6C69';
wwv_flow_imp.g_varchar2_table(1987) := '6E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D746F537472696E6728297B72657475726E60247B746869732E6C696E65436F756E747D2C247B746869732E636F6C756D6E436F756E747D60';
wwv_flow_imp.g_varchar2_table(1988) := '7D7D57722E7A65726F3D6E657720577228302C30293B636C617373207A727B636F6E7374727563746F7228652C74297B746869732E72616E67653D652C746869732E746578743D747D7D636C6173732048727B73746174696320696E766572736528652C';
wwv_flow_imp.g_varchar2_table(1989) := '742C6E297B636F6E737420723D5B5D3B6C657420693D312C733D313B666F7228636F6E73742074206F662065297B636F6E737420653D6E6577204872286E657720427228692C742E6F726967696E616C2E73746172744C696E654E756D626572292C6E65';
wwv_flow_imp.g_varchar2_table(1990) := '7720427228732C742E6D6F6469666965642E73746172744C696E654E756D62657229293B652E6D6F6469666965642E6973456D7074797C7C722E707573682865292C693D742E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(1991) := '652C733D742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976657D636F6E7374206F3D6E6577204872286E657720427228692C742B31292C6E657720427228732C6E2B3129293B72657475726E206F2E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(1992) := '6973456D7074797C7C722E70757368286F292C727D73746174696320636C697028652C742C6E297B636F6E737420723D5B5D3B666F7228636F6E73742069206F662065297B636F6E737420653D692E6F726967696E616C2E696E74657273656374287429';
wwv_flow_imp.g_varchar2_table(1993) := '2C733D692E6D6F6469666965642E696E74657273656374286E293B65262621652E6973456D707479262673262621732E6973456D7074792626722E70757368286E657720487228652C7329297D72657475726E20727D636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(1994) := '74297B746869732E6F726967696E616C3D652C746869732E6D6F6469666965643D747D746F537472696E6728297B72657475726E607B247B746869732E6F726967696E616C2E746F537472696E6728297D2D3E247B746869732E6D6F6469666965642E74';
wwv_flow_imp.g_varchar2_table(1995) := '6F537472696E6728297D7D607D666C697028297B72657475726E206E657720487228746869732E6D6F6469666965642C746869732E6F726967696E616C297D6A6F696E2865297B72657475726E206E657720487228746869732E6F726967696E616C2E6A';
wwv_flow_imp.g_varchar2_table(1996) := '6F696E28652E6F726967696E616C292C746869732E6D6F6469666965642E6A6F696E28652E6D6F64696669656429297D746F52616E67654D617070696E6728297B636F6E737420653D746869732E6F726967696E616C2E746F496E636C75736976655261';
wwv_flow_imp.g_varchar2_table(1997) := '6E676528292C743D746869732E6D6F6469666965642E746F496E636C757369766552616E676528293B696628652626742972657475726E206E6577204A7228652C74293B696628313D3D3D746869732E6F726967696E616C2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(1998) := '6D6265727C7C313D3D3D746869732E6D6F6469666965642E73746172744C696E654E756D626572297B69662831213D3D746869732E6D6F6469666965642E73746172744C696E654E756D6265727C7C31213D3D746869732E6F726967696E616C2E737461';
wwv_flow_imp.g_varchar2_table(1999) := '72744C696E654E756D626572297468726F77206E6577206F28226E6F7420612076616C6964206469666622293B72657475726E206E6577204A72286E657720537428746869732E6F726967696E616C2E73746172744C696E654E756D6265722C312C7468';
wwv_flow_imp.g_varchar2_table(2000) := '69732E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C31292C6E657720537428746869732E6D6F6469666965642E73746172744C696E654E756D6265722C312C746869732E6D6F6469666965642E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(2001) := '6D6265724578636C75736976652C3129297D72657475726E206E6577204A72286E657720537428746869732E6F726967696E616C2E73746172744C696E654E756D6265722D312C4E756D6265722E4D41585F534146455F494E54454745522C746869732E';
wwv_flow_imp.g_varchar2_table(2002) := '6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445474552292C6E657720537428746869732E6D6F6469666965642E73746172744C696E654E756D6265722D312C4E75';
wwv_flow_imp.g_varchar2_table(2003) := '6D6265722E4D41585F534146455F494E54454745522C746869732E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E544547455229297D7D636C61737320477220657874';
wwv_flow_imp.g_varchar2_table(2004) := '656E64732048727B7374617469632066726F6D52616E67654D617070696E67732865297B636F6E737420743D42722E6A6F696E28652E6D61702828653D3E42722E66726F6D52616E6765496E636C757369766528652E6F726967696E616C52616E676529';
wwv_flow_imp.g_varchar2_table(2005) := '2929292C6E3D42722E6A6F696E28652E6D61702828653D3E42722E66726F6D52616E6765496E636C757369766528652E6D6F64696669656452616E6765292929293B72657475726E206E657720477228742C6E2C65297D636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(2006) := '2C742C6E297B737570657228652C74292C746869732E696E6E65724368616E6765733D6E7D666C697028297B76617220653B72657475726E206E657720477228746869732E6D6F6469666965642C746869732E6F726967696E616C2C6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(2007) := '653D746869732E696E6E65724368616E676573297C7C766F696420303D3D3D653F766F696420303A652E6D61702828653D3E652E666C697028292929297D77697468496E6E65724368616E67657346726F6D4C696E6552616E67657328297B7265747572';
wwv_flow_imp.g_varchar2_table(2008) := '6E206E657720477228746869732E6F726967696E616C2C746869732E6D6F6469666965642C5B746869732E746F52616E67654D617070696E6728295D297D7D636C617373204A727B636F6E7374727563746F7228652C74297B746869732E6F726967696E';
wwv_flow_imp.g_varchar2_table(2009) := '616C52616E67653D652C746869732E6D6F64696669656452616E67653D747D746F537472696E6728297B72657475726E607B247B746869732E6F726967696E616C52616E67652E746F537472696E6728297D2D3E247B746869732E6D6F64696669656452';
wwv_flow_imp.g_varchar2_table(2010) := '616E67652E746F537472696E6728297D7D607D666C697028297B72657475726E206E6577204A7228746869732E6D6F64696669656452616E67652C746869732E6F726967696E616C52616E6765297D746F54657874456469742865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(2011) := '3D652E67657456616C75654F6652616E676528746869732E6D6F64696669656452616E6765293B72657475726E206E6577207A7228746869732E6F726967696E616C52616E67652C74297D7D636C6173732058727B636F6D707574654469666628652C74';
wwv_flow_imp.g_varchar2_table(2012) := '2C6E297B76617220723B636F6E737420693D6E6577206E6928652C742C7B6D6178436F6D7075746174696F6E54696D653A6E2E6D6178436F6D7075746174696F6E54696D654D732C73686F756C6449676E6F72655472696D576869746573706163653A6E';
wwv_flow_imp.g_varchar2_table(2013) := '2E69676E6F72655472696D576869746573706163652C73686F756C64436F6D70757465436861724368616E6765733A21302C73686F756C644D616B65507265747479446966663A21302C73686F756C64506F737450726F63657373436861724368616E67';
wwv_flow_imp.g_varchar2_table(2014) := '65733A21307D292E636F6D707574654469666628292C733D5B5D3B6C6574206F3D6E756C6C3B666F7228636F6E73742065206F6620692E6368616E676573297B6C657420742C6E3B743D303D3D3D652E6F726967696E616C456E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(2015) := '723F6E657720427228652E6F726967696E616C53746172744C696E654E756D6265722B312C652E6F726967696E616C53746172744C696E654E756D6265722B31293A6E657720427228652E6F726967696E616C53746172744C696E654E756D6265722C65';
wwv_flow_imp.g_varchar2_table(2016) := '2E6F726967696E616C456E644C696E654E756D6265722B31292C6E3D303D3D3D652E6D6F646966696564456E644C696E654E756D6265723F6E657720427228652E6D6F64696669656453746172744C696E654E756D6265722B312C652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2017) := '6453746172744C696E654E756D6265722B31293A6E657720427228652E6D6F64696669656453746172744C696E654E756D6265722C652E6D6F646966696564456E644C696E654E756D6265722B31293B6C657420693D6E657720477228742C6E2C6E756C';
wwv_flow_imp.g_varchar2_table(2018) := '6C3D3D3D28723D652E636861724368616E676573297C7C766F696420303D3D3D723F766F696420303A722E6D61702828653D3E6E6577204A72286E657720537428652E6F726967696E616C53746172744C696E654E756D6265722C652E6F726967696E61';
wwv_flow_imp.g_varchar2_table(2019) := '6C5374617274436F6C756D6E2C652E6F726967696E616C456E644C696E654E756D6265722C652E6F726967696E616C456E64436F6C756D6E292C6E657720537428652E6D6F64696669656453746172744C696E654E756D6265722C652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2020) := '645374617274436F6C756D6E2C652E6D6F646966696564456E644C696E654E756D6265722C652E6D6F646966696564456E64436F6C756D6E29292929293B6F2626286F2E6D6F6469666965642E656E644C696E654E756D6265724578636C757369766521';
wwv_flow_imp.g_varchar2_table(2021) := '3D3D692E6D6F6469666965642E73746172744C696E654E756D62657226266F2E6F726967696E616C2E656E644C696E654E756D6265724578636C7573697665213D3D692E6F726967696E616C2E73746172744C696E654E756D6265727C7C28693D6E6577';
wwv_flow_imp.g_varchar2_table(2022) := '204772286F2E6F726967696E616C2E6A6F696E28692E6F726967696E616C292C6F2E6D6F6469666965642E6A6F696E28692E6D6F646966696564292C6F2E696E6E65724368616E6765732626692E696E6E65724368616E6765733F6F2E696E6E65724368';
wwv_flow_imp.g_varchar2_table(2023) := '616E6765732E636F6E63617428692E696E6E65724368616E676573293A766F69642030292C732E706F70282929292C732E707573682869292C6F3D697D72657475726E205472282828293D3E4D7228732C2828652C74293D3E742E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(2024) := '73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965642E73746172744C696E654E756D6265722D652E6D6F6469666965642E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(2025) := '65724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E73746172744C696E654E756D6265722626652E6D6F6469666965642E656E644C696E654E756D62657245';
wwv_flow_imp.g_varchar2_table(2026) := '78636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D626572292929292C6E657720467228732C5B5D2C692E717569744561726C79297D7D66756E6374696F6E20517228652C742C6E2C72297B72657475726E206E6577207165';
wwv_flow_imp.g_varchar2_table(2027) := '28652C742C6E292E436F6D70757465446966662872297D636C617373205A727B636F6E7374727563746F722865297B636F6E737420743D5B5D2C6E3D5B5D3B666F72286C657420723D302C693D652E6C656E6774683B723C693B722B2B29745B725D3D72';
wwv_flow_imp.g_varchar2_table(2028) := '6928655B725D2C31292C6E5B725D3D696928655B725D2C31293B746869732E6C696E65733D652C746869732E5F7374617274436F6C756D6E733D742C746869732E5F656E64436F6C756D6E733D6E7D676574456C656D656E747328297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(2029) := '3D5B5D3B666F72286C657420743D302C6E3D746869732E6C696E65732E6C656E6774683B743C6E3B742B2B29655B745D3D746869732E6C696E65735B745D2E737562737472696E6728746869732E5F7374617274436F6C756D6E735B745D2D312C746869';
wwv_flow_imp.g_varchar2_table(2030) := '732E5F656E64436F6C756D6E735B745D2D31293B72657475726E20657D676574537472696374456C656D656E742865297B72657475726E20746869732E6C696E65735B655D7D67657453746172744C696E654E756D6265722865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(2031) := '2B317D676574456E644C696E654E756D6265722865297B72657475726E20652B317D6372656174654368617253657175656E636528652C742C6E297B636F6E737420723D5B5D2C693D5B5D2C733D5B5D3B6C6574206F3D303B666F72286C657420613D74';
wwv_flow_imp.g_varchar2_table(2032) := '3B613C3D6E3B612B2B297B636F6E737420743D746869732E6C696E65735B615D2C6C3D653F746869732E5F7374617274436F6C756D6E735B615D3A312C753D653F746869732E5F656E64436F6C756D6E735B615D3A742E6C656E6774682B313B666F7228';
wwv_flow_imp.g_varchar2_table(2033) := '6C657420653D6C3B653C753B652B2B29725B6F5D3D742E63686172436F6465417428652D31292C695B6F5D3D612B312C735B6F5D3D652C6F2B2B3B21652626613C6E262628725B6F5D3D31302C695B6F5D3D612B312C735B6F5D3D742E6C656E6774682B';
wwv_flow_imp.g_varchar2_table(2034) := '312C6F2B2B297D72657475726E206E657720597228722C692C73297D7D636C6173732059727B636F6E7374727563746F7228652C742C6E297B746869732E5F63686172436F6465733D652C746869732E5F6C696E654E756D626572733D742C746869732E';
wwv_flow_imp.g_varchar2_table(2035) := '5F636F6C756D6E733D6E7D746F537472696E6728297B72657475726E225B222B746869732E5F63686172436F6465732E6D6170282828652C74293D3E2831303D3D3D653F225C5C6E223A537472696E672E66726F6D43686172436F6465286529292B602D';
wwv_flow_imp.g_varchar2_table(2036) := '28247B746869732E5F6C696E654E756D626572735B745D7D2C247B746869732E5F636F6C756D6E735B745D7D296029292E6A6F696E28222C2022292B225D227D5F617373657274496E64657828652C74297B696628653C307C7C653E3D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(2037) := '68297468726F77206E6577204572726F722822496C6C6567616C20696E64657822297D676574456C656D656E747328297B72657475726E20746869732E5F63686172436F6465737D67657453746172744C696E654E756D6265722865297B72657475726E';
wwv_flow_imp.g_varchar2_table(2038) := '20653E302626653D3D3D746869732E5F6C696E654E756D626572732E6C656E6774683F746869732E676574456E644C696E654E756D62657228652D31293A28746869732E5F617373657274496E64657828652C746869732E5F6C696E654E756D62657273';
wwv_flow_imp.g_varchar2_table(2039) := '292C746869732E5F6C696E654E756D626572735B655D297D676574456E644C696E654E756D6265722865297B72657475726E2D313D3D3D653F746869732E67657453746172744C696E654E756D62657228652B31293A28746869732E5F61737365727449';
wwv_flow_imp.g_varchar2_table(2040) := '6E64657828652C746869732E5F6C696E654E756D62657273292C31303D3D3D746869732E5F63686172436F6465735B655D3F746869732E5F6C696E654E756D626572735B655D2B313A746869732E5F6C696E654E756D626572735B655D297D6765745374';
wwv_flow_imp.g_varchar2_table(2041) := '617274436F6C756D6E2865297B72657475726E20653E302626653D3D3D746869732E5F636F6C756D6E732E6C656E6774683F746869732E676574456E64436F6C756D6E28652D31293A28746869732E5F617373657274496E64657828652C746869732E5F';
wwv_flow_imp.g_varchar2_table(2042) := '636F6C756D6E73292C746869732E5F636F6C756D6E735B655D297D676574456E64436F6C756D6E2865297B72657475726E2D313D3D3D653F746869732E6765745374617274436F6C756D6E28652B31293A28746869732E5F617373657274496E64657828';
wwv_flow_imp.g_varchar2_table(2043) := '652C746869732E5F636F6C756D6E73292C31303D3D3D746869732E5F63686172436F6465735B655D3F313A746869732E5F636F6C756D6E735B655D2B31297D7D636C6173732065697B636F6E7374727563746F7228652C742C6E2C722C692C732C6F2C61';
wwv_flow_imp.g_varchar2_table(2044) := '297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C5374617274436F6C756D6E3D742C746869732E6F726967696E616C456E644C696E654E756D6265723D6E2C746869732E6F726967696E';
wwv_flow_imp.g_varchar2_table(2045) := '616C456E64436F6C756D6E3D722C746869732E6D6F64696669656453746172744C696E654E756D6265723D692C746869732E6D6F6469666965645374617274436F6C756D6E3D732C746869732E6D6F646966696564456E644C696E654E756D6265723D6F';
wwv_flow_imp.g_varchar2_table(2046) := '2C746869732E6D6F646966696564456E64436F6C756D6E3D617D7374617469632063726561746546726F6D446966664368616E676528652C742C6E297B636F6E737420723D742E67657453746172744C696E654E756D62657228652E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2047) := '5374617274292C693D742E6765745374617274436F6C756D6E28652E6F726967696E616C5374617274292C733D742E676574456E644C696E654E756D62657228652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C';
wwv_flow_imp.g_varchar2_table(2048) := '6F3D742E676574456E64436F6C756D6E28652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C613D6E2E67657453746172744C696E654E756D62657228652E6D6F6469666965645374617274292C6C3D6E2E676574';
wwv_flow_imp.g_varchar2_table(2049) := '5374617274436F6C756D6E28652E6D6F6469666965645374617274292C753D6E2E676574456E644C696E654E756D62657228652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682D31292C633D6E2E676574456E64436F6C75';
wwv_flow_imp.g_varchar2_table(2050) := '6D6E28652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682D31293B72657475726E206E657720656928722C692C732C6F2C612C6C2C752C63297D7D636C6173732074697B636F6E7374727563746F7228652C742C6E2C722C';
wwv_flow_imp.g_varchar2_table(2051) := '69297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C456E644C696E654E756D6265723D742C746869732E6D6F64696669656453746172744C696E654E756D6265723D6E2C746869732E6D';
wwv_flow_imp.g_varchar2_table(2052) := '6F646966696564456E644C696E654E756D6265723D722C746869732E636861724368616E6765733D697D7374617469632063726561746546726F6D44696666526573756C7428652C742C6E2C722C692C732C6F297B6C657420612C6C2C752C632C683B69';
wwv_flow_imp.g_varchar2_table(2053) := '6628303D3D3D742E6F726967696E616C4C656E6774683F28613D6E2E67657453746172744C696E654E756D62657228742E6F726967696E616C5374617274292D312C6C3D30293A28613D6E2E67657453746172744C696E654E756D62657228742E6F7269';
wwv_flow_imp.g_varchar2_table(2054) := '67696E616C5374617274292C6C3D6E2E676574456E644C696E654E756D62657228742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D3129292C303D3D3D742E6D6F6469666965644C656E6774683F28753D722E67657453';
wwv_flow_imp.g_varchar2_table(2055) := '746172744C696E654E756D62657228742E6D6F6469666965645374617274292D312C633D30293A28753D722E67657453746172744C696E654E756D62657228742E6D6F6469666965645374617274292C633D722E676574456E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(2056) := '28742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D3129292C732626742E6F726967696E616C4C656E6774683E302626742E6F726967696E616C4C656E6774683C32302626742E6D6F6469666965644C656E6774683E30';
wwv_flow_imp.g_varchar2_table(2057) := '2626742E6D6F6469666965644C656E6774683C32302626692829297B636F6E737420733D6E2E6372656174654368617253657175656E636528652C742E6F726967696E616C53746172742C742E6F726967696E616C53746172742B742E6F726967696E61';
wwv_flow_imp.g_varchar2_table(2058) := '6C4C656E6774682D31292C613D722E6372656174654368617253657175656E636528652C742E6D6F64696669656453746172742C742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D31293B696628732E676574456C656D';
wwv_flow_imp.g_varchar2_table(2059) := '656E747328292E6C656E6774683E302626612E676574456C656D656E747328292E6C656E6774683E30297B6C657420653D517228732C612C692C2130292E6368616E6765733B6F262628653D66756E6374696F6E2865297B696628652E6C656E6774683C';
wwv_flow_imp.g_varchar2_table(2060) := '3D312972657475726E20653B636F6E737420743D5B655B305D5D3B6C6574206E3D745B305D3B666F72286C657420723D312C693D652E6C656E6774683B723C693B722B2B297B636F6E737420693D655B725D2C733D692E6F726967696E616C5374617274';
wwv_flow_imp.g_varchar2_table(2061) := '2D286E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E677468292C6F3D692E6D6F64696669656453746172742D286E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E677468293B4D6174682E6D696E28732C';
wwv_flow_imp.g_varchar2_table(2062) := '6F293C333F286E2E6F726967696E616C4C656E6774683D692E6F726967696E616C53746172742B692E6F726967696E616C4C656E6774682D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D692E6D6F64696669656453';
wwv_flow_imp.g_varchar2_table(2063) := '746172742B692E6D6F6469666965644C656E6774682D6E2E6D6F6469666965645374617274293A28742E707573682869292C6E3D69297D72657475726E20747D286529292C683D5B5D3B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E';
wwv_flow_imp.g_varchar2_table(2064) := '3B742B2B29682E707573682865692E63726561746546726F6D446966664368616E676528655B745D2C732C6129297D7D72657475726E206E657720746928612C6C2C752C632C68297D7D636C617373206E697B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(2065) := '297B746869732E73686F756C64436F6D70757465436861724368616E6765733D6E2E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E6765733D6E2E73686F756C';
wwv_flow_imp.g_varchar2_table(2066) := '64506F737450726F63657373436861724368616E6765732C746869732E73686F756C6449676E6F72655472696D576869746573706163653D6E2E73686F756C6449676E6F72655472696D576869746573706163652C746869732E73686F756C644D616B65';
wwv_flow_imp.g_varchar2_table(2067) := '507265747479446966663D6E2E73686F756C644D616B65507265747479446966662C746869732E6F726967696E616C4C696E65733D652C746869732E6D6F6469666965644C696E65733D742C746869732E6F726967696E616C3D6E6577205A722865292C';
wwv_flow_imp.g_varchar2_table(2068) := '746869732E6D6F6469666965643D6E6577205A722874292C746869732E636F6E74696E75654C696E65446966663D7369286E2E6D6178436F6D7075746174696F6E54696D65292C746869732E636F6E74696E756543686172446966663D736928303D3D3D';
wwv_flow_imp.g_varchar2_table(2069) := '6E2E6D6178436F6D7075746174696F6E54696D653F303A4D6174682E6D696E286E2E6D6178436F6D7075746174696F6E54696D652C35653329297D636F6D707574654469666628297B696628313D3D3D746869732E6F726967696E616C2E6C696E65732E';
wwv_flow_imp.g_varchar2_table(2070) := '6C656E6774682626303D3D3D746869732E6F726967696E616C2E6C696E65735B305D2E6C656E6774682972657475726E20313D3D3D746869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C';
wwv_flow_imp.g_varchar2_table(2071) := '696E65735B305D2E6C656E6774683F7B717569744561726C793A21312C6368616E6765733A5B5D7D3A7B717569744561726C793A21312C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C45';
wwv_flow_imp.g_varchar2_table(2072) := '6E644C696E654E756D6265723A312C6D6F64696669656453746172744C696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A746869732E6D6F6469666965642E6C696E65732E6C656E6774682C636861724368616E6765';
wwv_flow_imp.g_varchar2_table(2073) := '733A766F696420307D5D7D3B696628313D3D3D746869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C696E65735B305D2E6C656E6774682972657475726E7B717569744561726C793A2131';
wwv_flow_imp.g_varchar2_table(2074) := '2C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C456E644C696E654E756D6265723A746869732E6F726967696E616C2E6C696E65732E6C656E6774682C6D6F64696669656453746172744C';
wwv_flow_imp.g_varchar2_table(2075) := '696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A312C636861724368616E6765733A766F696420307D5D7D3B636F6E737420653D517228746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869';
wwv_flow_imp.g_varchar2_table(2076) := '732E636F6E74696E75654C696E65446966662C746869732E73686F756C644D616B6550726574747944696666292C743D652E6368616E6765732C6E3D652E717569744561726C793B696628746869732E73686F756C6449676E6F72655472696D57686974';
wwv_flow_imp.g_varchar2_table(2077) := '657370616365297B636F6E737420653D5B5D3B666F72286C6574206E3D302C723D742E6C656E6774683B6E3C723B6E2B2B29652E707573682874692E63726561746546726F6D44696666526573756C7428746869732E73686F756C6449676E6F72655472';
wwv_flow_imp.g_varchar2_table(2078) := '696D576869746573706163652C745B6E5D2C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E756543686172446966662C746869732E73686F756C64436F6D70757465436861724368616E6765732C7468';
wwv_flow_imp.g_varchar2_table(2079) := '69732E73686F756C64506F737450726F63657373436861724368616E67657329293B72657475726E7B717569744561726C793A6E2C6368616E6765733A657D7D636F6E737420723D5B5D3B6C657420693D302C733D303B666F72286C657420653D2D312C';
wwv_flow_imp.g_varchar2_table(2080) := '6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206F3D652B313C6E3F745B652B315D3A6E756C6C2C613D6F3F6F2E6F726967696E616C53746172743A746869732E6F726967696E616C4C696E65732E6C656E6774682C6C3D6F3F6F2E6D6F';
wwv_flow_imp.g_varchar2_table(2081) := '64696669656453746172743A746869732E6D6F6469666965644C696E65732E6C656E6774683B666F72283B693C612626733C6C3B297B636F6E737420653D746869732E6F726967696E616C4C696E65735B695D2C743D746869732E6D6F6469666965644C';
wwv_flow_imp.g_varchar2_table(2082) := '696E65735B735D3B69662865213D3D74297B7B6C6574206E3D726928652C31292C6F3D726928742C31293B666F72283B6E3E3126266F3E312626652E63686172436F64654174286E2D32293D3D3D742E63686172436F64654174286F2D32293B296E2D2D';
wwv_flow_imp.g_varchar2_table(2083) := '2C6F2D2D3B286E3E317C7C6F3E31292626746869732E5F707573685472696D57686974657370616365436861724368616E676528722C692B312C312C6E2C732B312C312C6F297D7B6C6574206E3D696928652C31292C6F3D696928742C31293B636F6E73';
wwv_flow_imp.g_varchar2_table(2084) := '7420613D652E6C656E6774682B312C6C3D742E6C656E6774682B313B666F72283B6E3C6126266F3C6C2626652E63686172436F64654174286E2D31293D3D3D652E63686172436F64654174286F2D31293B296E2B2B2C6F2B2B3B286E3C617C7C6F3C6C29';
wwv_flow_imp.g_varchar2_table(2085) := '2626746869732E5F707573685472696D57686974657370616365436861724368616E676528722C692B312C6E2C612C732B312C6F2C6C297D7D692B2B2C732B2B7D6F262628722E707573682874692E63726561746546726F6D44696666526573756C7428';
wwv_flow_imp.g_varchar2_table(2086) := '746869732E73686F756C6449676E6F72655472696D576869746573706163652C6F2C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E756543686172446966662C746869732E73686F756C64436F6D7075';
wwv_flow_imp.g_varchar2_table(2087) := '7465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E67657329292C692B3D6F2E6F726967696E616C4C656E6774682C732B3D6F2E6D6F6469666965644C656E677468297D72657475726E7B7175';
wwv_flow_imp.g_varchar2_table(2088) := '69744561726C793A6E2C6368616E6765733A727D7D5F707573685472696D57686974657370616365436861724368616E676528652C742C6E2C722C692C732C6F297B696628746869732E5F6D657267655472696D57686974657370616365436861724368';
wwv_flow_imp.g_varchar2_table(2089) := '616E676528652C742C6E2C722C692C732C6F292972657475726E3B6C657420613B746869732E73686F756C64436F6D70757465436861724368616E676573262628613D5B6E657720656928742C6E2C742C722C692C732C692C6F295D292C652E70757368';
wwv_flow_imp.g_varchar2_table(2090) := '286E657720746928742C742C692C692C6129297D5F6D657267655472696D57686974657370616365436861724368616E676528652C742C6E2C722C692C732C6F297B636F6E737420613D652E6C656E6774683B696628303D3D3D612972657475726E2131';
wwv_flow_imp.g_varchar2_table(2091) := '3B636F6E7374206C3D655B612D315D3B72657475726E2030213D3D6C2E6F726967696E616C456E644C696E654E756D626572262630213D3D6C2E6D6F646966696564456E644C696E654E756D6265722626286C2E6F726967696E616C456E644C696E654E';
wwv_flow_imp.g_varchar2_table(2092) := '756D6265723D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265723D3D3D693F28746869732E73686F756C64436F6D70757465436861724368616E67657326266C2E636861724368616E67657326266C2E636861724368616E6765732E';
wwv_flow_imp.g_varchar2_table(2093) := '70757368286E657720656928742C6E2C742C722C692C732C692C6F29292C2130293A6C2E6F726967696E616C456E644C696E654E756D6265722B313D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265722B313D3D3D692626286C2E6F';
wwv_flow_imp.g_varchar2_table(2094) := '726967696E616C456E644C696E654E756D6265723D742C6C2E6D6F646966696564456E644C696E654E756D6265723D692C746869732E73686F756C64436F6D70757465436861724368616E67657326266C2E636861724368616E67657326266C2E636861';
wwv_flow_imp.g_varchar2_table(2095) := '724368616E6765732E70757368286E657720656928742C6E2C742C722C692C732C692C6F29292C213029297D7D66756E6374696F6E20726928652C74297B636F6E7374206E3D66756E6374696F6E2865297B666F72286C657420743D302C6E3D652E6C65';
wwv_flow_imp.g_varchar2_table(2096) := '6E6774683B743C6E3B742B2B297B636F6E7374206E3D652E63686172436F646541742874293B6966283332213D3D6E262639213D3D6E2972657475726E20747D72657475726E2D317D2865293B72657475726E2D313D3D3D6E3F743A6E2B317D66756E63';
wwv_flow_imp.g_varchar2_table(2097) := '74696F6E20696928652C74297B636F6E7374206E3D66756E6374696F6E28652C743D652E6C656E6774682D31297B666F72286C6574206E3D743B6E3E3D303B6E2D2D297B636F6E737420743D652E63686172436F64654174286E293B6966283332213D3D';
wwv_flow_imp.g_varchar2_table(2098) := '74262639213D3D742972657475726E206E7D72657475726E2D317D2865293B72657475726E2D313D3D3D6E3F743A6E2B327D66756E6374696F6E2073692865297B696628303D3D3D652972657475726E28293D3E21303B636F6E737420743D446174652E';
wwv_flow_imp.g_varchar2_table(2099) := '6E6F7728293B72657475726E28293D3E446174652E6E6F7728292D743C657D636C617373206F697B737461746963207472697669616C28652C74297B72657475726E206E6577206F69285B6E65772061692844722E6F664C656E67746828652E6C656E67';
wwv_flow_imp.g_varchar2_table(2100) := '7468292C44722E6F664C656E67746828742E6C656E67746829295D2C2131297D737461746963207472697669616C54696D65644F757428652C74297B72657475726E206E6577206F69285B6E65772061692844722E6F664C656E67746828652E6C656E67';
wwv_flow_imp.g_varchar2_table(2101) := '7468292C44722E6F664C656E67746828742E6C656E67746829295D2C2130297D636F6E7374727563746F7228652C74297B746869732E64696666733D652C746869732E68697454696D656F75743D747D7D636C6173732061697B73746174696320696E76';
wwv_flow_imp.g_varchar2_table(2102) := '65727428652C74297B636F6E7374206E3D5B5D3B72657475726E2066756E6374696F6E28652C74297B666F72286C6574206E3D303B6E3C3D652E6C656E6774683B6E2B2B297428303D3D3D6E3F766F696420303A655B6E2D315D2C6E3D3D3D652E6C656E';
wwv_flow_imp.g_varchar2_table(2103) := '6774683F766F696420303A655B6E5D297D28652C2828652C72293D3E7B6E2E707573682861692E66726F6D4F6666736574506169727328653F652E676574456E644578636C75736976657328293A6C692E7A65726F2C723F722E67657453746172747328';
wwv_flow_imp.g_varchar2_table(2104) := '293A6E6577206C6928742C28653F652E7365713252616E67652E656E644578636C75736976652D652E7365713152616E67652E656E644578636C75736976653A30292B742929297D29292C6E7D7374617469632066726F6D4F6666736574506169727328';
wwv_flow_imp.g_varchar2_table(2105) := '652C74297B72657475726E206E6577206169286E657720447228652E6F6666736574312C742E6F666673657431292C6E657720447228652E6F6666736574322C742E6F66667365743229297D636F6E7374727563746F7228652C74297B746869732E7365';
wwv_flow_imp.g_varchar2_table(2106) := '713152616E67653D652C746869732E7365713252616E67653D747D7377617028297B72657475726E206E657720616928746869732E7365713252616E67652C746869732E7365713152616E6765297D746F537472696E6728297B72657475726E60247B74';
wwv_flow_imp.g_varchar2_table(2107) := '6869732E7365713152616E67657D203C2D3E20247B746869732E7365713252616E67657D607D6A6F696E2865297B72657475726E206E657720616928746869732E7365713152616E67652E6A6F696E28652E7365713152616E6765292C746869732E7365';
wwv_flow_imp.g_varchar2_table(2108) := '713252616E67652E6A6F696E28652E7365713252616E676529297D64656C74612865297B72657475726E20303D3D3D653F746869733A6E657720616928746869732E7365713152616E67652E64656C74612865292C746869732E7365713252616E67652E';
wwv_flow_imp.g_varchar2_table(2109) := '64656C7461286529297D64656C746153746172742865297B72657475726E20303D3D3D653F746869733A6E657720616928746869732E7365713152616E67652E64656C746153746172742865292C746869732E7365713252616E67652E64656C74615374';
wwv_flow_imp.g_varchar2_table(2110) := '617274286529297D64656C7461456E642865297B72657475726E20303D3D3D653F746869733A6E657720616928746869732E7365713152616E67652E64656C7461456E642865292C746869732E7365713252616E67652E64656C7461456E64286529297D';
wwv_flow_imp.g_varchar2_table(2111) := '696E746572736563742865297B636F6E737420743D746869732E7365713152616E67652E696E7465727365637428652E7365713152616E6765292C6E3D746869732E7365713252616E67652E696E7465727365637428652E7365713252616E6765293B69';
wwv_flow_imp.g_varchar2_table(2112) := '66287426266E2972657475726E206E657720616928742C6E297D67657453746172747328297B72657475726E206E6577206C6928746869732E7365713152616E67652E73746172742C746869732E7365713252616E67652E7374617274297D676574456E';
wwv_flow_imp.g_varchar2_table(2113) := '644578636C75736976657328297B72657475726E206E6577206C6928746869732E7365713152616E67652E656E644578636C75736976652C746869732E7365713252616E67652E656E644578636C7573697665297D7D636C617373206C697B636F6E7374';
wwv_flow_imp.g_varchar2_table(2114) := '727563746F7228652C74297B746869732E6F6666736574313D652C746869732E6F6666736574323D747D746F537472696E6728297B72657475726E60247B746869732E6F6666736574317D203C2D3E20247B746869732E6F6666736574327D607D64656C';
wwv_flow_imp.g_varchar2_table(2115) := '74612865297B72657475726E20303D3D3D653F746869733A6E6577206C6928746869732E6F6666736574312B652C746869732E6F6666736574322B65297D657175616C732865297B72657475726E20746869732E6F6666736574313D3D3D652E6F666673';
wwv_flow_imp.g_varchar2_table(2116) := '6574312626746869732E6F6666736574323D3D3D652E6F6666736574327D7D6C692E7A65726F3D6E6577206C6928302C30292C6C692E6D61783D6E6577206C69284E756D6265722E4D41585F534146455F494E54454745522C4E756D6265722E4D41585F';
wwv_flow_imp.g_varchar2_table(2117) := '534146455F494E5445474552293B636C6173732075697B697356616C696428297B72657475726E21307D7D75692E696E7374616E63653D6E65772075693B636C6173732063697B636F6E7374727563746F722865297B696628746869732E74696D656F75';
wwv_flow_imp.g_varchar2_table(2118) := '743D652C746869732E737461727454696D653D446174652E6E6F7728292C746869732E76616C69643D21302C653C3D30297468726F77206E6577206F282274696D656F7574206D75737420626520706F73697469766522297D697356616C696428297B72';
wwv_flow_imp.g_varchar2_table(2119) := '657475726E2128446174652E6E6F7728292D746869732E737461727454696D653C746869732E74696D656F7574292626746869732E76616C6964262628746869732E76616C69643D2131292C746869732E76616C69647D7D636C6173732068697B636F6E';
wwv_flow_imp.g_varchar2_table(2120) := '7374727563746F7228652C74297B746869732E77696474683D652C746869732E6865696768743D742C746869732E61727261793D5B5D2C746869732E61727261793D6E657720417272617928652A74297D67657428652C74297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(2121) := '732E61727261795B652B742A746869732E77696474685D7D73657428652C742C6E297B746869732E61727261795B652B742A746869732E77696474685D3D6E7D7D66756E6374696F6E2064692865297B72657475726E2033323D3D3D657C7C393D3D3D65';
wwv_flow_imp.g_varchar2_table(2122) := '7D636C6173732066697B737461746963206765744B65792865297B6C657420743D746869732E6368724B6579732E6765742865293B72657475726E20766F696420303D3D3D74262628743D746869732E6368724B6579732E73697A652C746869732E6368';
wwv_flow_imp.g_varchar2_table(2123) := '724B6579732E73657428652C7429292C747D636F6E7374727563746F7228652C742C6E297B746869732E72616E67653D652C746869732E6C696E65733D742C746869732E736F757263653D6E2C746869732E686973746F6772616D3D5B5D3B6C65742072';
wwv_flow_imp.g_varchar2_table(2124) := '3D303B666F72286C6574206E3D652E73746172744C696E654E756D6265722D313B6E3C652E656E644C696E654E756D6265724578636C75736976652D313B6E2B2B297B636F6E737420653D745B6E5D3B666F72286C657420743D303B743C652E6C656E67';
wwv_flow_imp.g_varchar2_table(2125) := '74683B742B2B297B722B2B3B636F6E7374206E3D655B745D2C693D66692E6765744B6579286E293B746869732E686973746F6772616D5B695D3D28746869732E686973746F6772616D5B695D7C7C30292B317D722B2B3B636F6E737420693D66692E6765';
wwv_flow_imp.g_varchar2_table(2126) := '744B657928225C6E22293B746869732E686973746F6772616D5B695D3D28746869732E686973746F6772616D5B695D7C7C30292B317D746869732E746F74616C436F756E743D727D636F6D7075746553696D696C61726974792865297B76617220742C6E';
wwv_flow_imp.g_varchar2_table(2127) := '3B6C657420723D303B636F6E737420693D4D6174682E6D617828746869732E686973746F6772616D2E6C656E6774682C652E686973746F6772616D2E6C656E677468293B666F72286C657420733D303B733C693B732B2B29722B3D4D6174682E61627328';
wwv_flow_imp.g_varchar2_table(2128) := '286E756C6C213D3D28743D746869732E686973746F6772616D5B735D292626766F69642030213D3D743F743A30292D286E756C6C213D3D286E3D652E686973746F6772616D5B735D292626766F69642030213D3D6E3F6E3A3029293B72657475726E2031';
wwv_flow_imp.g_varchar2_table(2129) := '2D722F28746869732E746F74616C436F756E742B652E746F74616C436F756E74297D7D66692E6368724B6579733D6E6577204D61703B636C617373206D697B636F6D7075746528652C742C6E3D75692E696E7374616E63652C72297B696628303D3D3D65';
wwv_flow_imp.g_varchar2_table(2130) := '2E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E206F692E7472697669616C28652C74293B636F6E737420693D6E657720686928652E6C656E6774682C742E6C656E677468292C733D6E657720686928652E6C656E6774682C742E6C';
wwv_flow_imp.g_varchar2_table(2131) := '656E677468292C6F3D6E657720686928652E6C656E6774682C742E6C656E677468293B666F72286C657420613D303B613C652E6C656E6774683B612B2B29666F72286C6574206C3D303B6C3C742E6C656E6774683B6C2B2B297B696628216E2E69735661';
wwv_flow_imp.g_varchar2_table(2132) := '6C696428292972657475726E206F692E7472697669616C54696D65644F757428652C74293B636F6E737420753D303D3D3D613F303A692E67657428612D312C6C292C633D303D3D3D6C3F303A692E67657428612C6C2D31293B6C657420683B652E676574';
wwv_flow_imp.g_varchar2_table(2133) := '456C656D656E742861293D3D3D742E676574456C656D656E74286C293F28683D303D3D3D617C7C303D3D3D6C3F303A692E67657428612D312C6C2D31292C613E3026266C3E302626333D3D3D732E67657428612D312C6C2D3129262628682B3D6F2E6765';
wwv_flow_imp.g_varchar2_table(2134) := '7428612D312C6C2D3129292C682B3D723F7228612C6C293A31293A683D2D313B636F6E737420643D4D6174682E6D617828752C632C68293B696628643D3D3D68297B636F6E737420653D613E3026266C3E303F6F2E67657428612D312C6C2D31293A303B';
wwv_flow_imp.g_varchar2_table(2135) := '6F2E73657428612C6C2C652B31292C732E73657428612C6C2C33297D656C736520643D3D3D753F286F2E73657428612C6C2C30292C732E73657428612C6C2C3129293A643D3D3D632626286F2E73657428612C6C2C30292C732E73657428612C6C2C3229';
wwv_flow_imp.g_varchar2_table(2136) := '293B692E73657428612C6C2C64297D636F6E737420613D5B5D3B6C6574206C3D652E6C656E6774682C753D742E6C656E6774683B66756E6374696F6E206328652C74297B652B313D3D3D6C2626742B313D3D3D757C7C612E70757368286E657720616928';
wwv_flow_imp.g_varchar2_table(2137) := '6E657720447228652B312C6C292C6E657720447228742B312C752929292C6C3D652C753D747D6C657420683D652E6C656E6774682D312C643D742E6C656E6774682D313B666F72283B683E3D302626643E3D303B29333D3D3D732E67657428682C64293F';
wwv_flow_imp.g_varchar2_table(2138) := '286328682C64292C682D2D2C642D2D293A313D3D3D732E67657428682C64293F682D2D3A642D2D3B72657475726E2063282D312C2D31292C612E7265766572736528292C6E6577206F6928612C2131297D7D636C6173732067697B636F6D707574652865';
wwv_flow_imp.g_varchar2_table(2139) := '2C742C6E3D75692E696E7374616E6365297B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E206F692E7472697669616C28652C74293B636F6E737420723D652C693D743B66756E6374696F6E207328652C7429';
wwv_flow_imp.g_varchar2_table(2140) := '7B666F72283B653C722E6C656E6774682626743C692E6C656E6774682626722E676574456C656D656E742865293D3D3D692E676574456C656D656E742874293B29652B2B2C742B2B3B72657475726E20657D6C6574206F3D303B636F6E737420613D6E65';
wwv_flow_imp.g_varchar2_table(2141) := '772076693B612E73657428302C7328302C3029293B636F6E7374206C3D6E65772062693B6C2E73657428302C303D3D3D612E6765742830293F6E756C6C3A6E6577207069286E756C6C2C302C302C612E67657428302929293B6C657420753D303B653A66';
wwv_flow_imp.g_varchar2_table(2142) := '6F72283B3B297B6966286F2B2B2C216E2E697356616C696428292972657475726E206F692E7472697669616C54696D65644F757428722C69293B636F6E737420653D2D4D6174682E6D696E286F2C692E6C656E6774682B6F2532292C743D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(2143) := '696E286F2C722E6C656E6774682B6F2532293B666F7228753D653B753C3D743B752B3D32297B6C6574206E3D303B636F6E7374206F3D753D3D3D743F2D313A612E67657428752B31292C633D753D3D3D653F2D313A612E67657428752D31292B313B6E2B';
wwv_flow_imp.g_varchar2_table(2144) := '2B3B636F6E737420683D4D6174682E6D696E284D6174682E6D6178286F2C63292C722E6C656E677468292C643D682D753B6966286E2B2B2C683E722E6C656E6774687C7C643E692E6C656E67746829636F6E74696E75653B636F6E737420663D7328682C';
wwv_flow_imp.g_varchar2_table(2145) := '64293B612E73657428752C66293B636F6E7374206D3D683D3D3D6F3F6C2E67657428752B31293A6C2E67657428752D31293B6966286C2E73657428752C66213D3D683F6E6577207069286D2C682C642C662D68293A6D292C612E6765742875293D3D3D72';
wwv_flow_imp.g_varchar2_table(2146) := '2E6C656E6774682626612E6765742875292D753D3D3D692E6C656E67746829627265616B20657D7D6C657420633D6C2E6765742875293B636F6E737420683D5B5D3B6C657420643D722E6C656E6774682C663D692E6C656E6774683B666F72283B3B297B';
wwv_flow_imp.g_varchar2_table(2147) := '636F6E737420653D633F632E782B632E6C656E6774683A302C743D633F632E792B632E6C656E6774683A303B696628653D3D3D642626743D3D3D667C7C682E70757368286E6577206169286E657720447228652C64292C6E657720447228742C66292929';
wwv_flow_imp.g_varchar2_table(2148) := '2C216329627265616B3B643D632E782C663D632E792C633D632E707265767D72657475726E20682E7265766572736528292C6E6577206F6928682C2131297D7D636C6173732070697B636F6E7374727563746F7228652C742C6E2C72297B746869732E70';
wwv_flow_imp.g_varchar2_table(2149) := '7265763D652C746869732E783D742C746869732E793D6E2C746869732E6C656E6774683D727D7D636C6173732076697B636F6E7374727563746F7228297B746869732E706F7369746976654172723D6E657720496E7433324172726179283130292C7468';
wwv_flow_imp.g_varchar2_table(2150) := '69732E6E656761746976654172723D6E657720496E7433324172726179283130297D6765742865297B72657475726E20653C303F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976654172725B655D';
wwv_flow_imp.g_varchar2_table(2151) := '7D73657428652C74297B696628653C30297B69662828653D2D652D31293E3D746869732E6E656761746976654172722E6C656E677468297B636F6E737420653D746869732E6E656761746976654172723B746869732E6E656761746976654172723D6E65';
wwv_flow_imp.g_varchar2_table(2152) := '7720496E743332417272617928322A652E6C656E677468292C746869732E6E656761746976654172722E7365742865297D746869732E6E656761746976654172725B655D3D747D656C73657B696628653E3D746869732E706F7369746976654172722E6C';
wwv_flow_imp.g_varchar2_table(2153) := '656E677468297B636F6E737420653D746869732E706F7369746976654172723B746869732E706F7369746976654172723D6E657720496E743332417272617928322A652E6C656E677468292C746869732E706F7369746976654172722E7365742865297D';
wwv_flow_imp.g_varchar2_table(2154) := '746869732E706F7369746976654172725B655D3D747D7D7D636C6173732062697B636F6E7374727563746F7228297B746869732E706F7369746976654172723D5B5D2C746869732E6E656761746976654172723D5B5D7D6765742865297B72657475726E';
wwv_flow_imp.g_varchar2_table(2155) := '20653C303F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976654172725B655D7D73657428652C74297B653C303F28653D2D652D312C746869732E6E656761746976654172725B655D3D74293A7468';
wwv_flow_imp.g_varchar2_table(2156) := '69732E706F7369746976654172725B655D3D747D7D636C6173732079697B636F6E7374727563746F7228652C742C6E297B746869732E6C696E65733D652C746869732E636F6E7369646572576869746573706163654368616E6765733D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(2157) := '656C656D656E74733D5B5D2C746869732E6669727374436861724F666673657442794C696E653D5B5D2C746869732E6164646974696F6E616C4F666673657442794C696E653D5B5D3B6C657420723D21313B742E73746172743E302626742E656E644578';
wwv_flow_imp.g_varchar2_table(2158) := '636C75736976653E3D652E6C656E677468262628743D6E657720447228742E73746172742D312C742E656E644578636C7573697665292C723D2130292C746869732E6C696E6552616E67653D742C746869732E6669727374436861724F66667365744279';
wwv_flow_imp.g_varchar2_table(2159) := '4C696E655B305D3D303B666F72286C657420743D746869732E6C696E6552616E67652E73746172743B743C746869732E6C696E6552616E67652E656E644578636C75736976653B742B2B297B6C657420693D655B745D2C733D303B6966287229733D692E';
wwv_flow_imp.g_varchar2_table(2160) := '6C656E6774682C693D22222C723D21313B656C736520696628216E297B636F6E737420653D692E7472696D537461727428293B733D692E6C656E6774682D652E6C656E6774682C693D652E7472696D456E6428297D746869732E6164646974696F6E616C';
wwv_flow_imp.g_varchar2_table(2161) := '4F666673657442794C696E652E707573682873293B666F72286C657420653D303B653C692E6C656E6774683B652B2B29746869732E656C656D656E74732E7075736828692E63686172436F64654174286529293B743C652E6C656E6774682D3126262874';
wwv_flow_imp.g_varchar2_table(2162) := '6869732E656C656D656E74732E7075736828225C6E222E63686172436F64654174283029292C746869732E6669727374436861724F666673657442794C696E655B742D746869732E6C696E6552616E67652E73746172742B315D3D746869732E656C656D';
wwv_flow_imp.g_varchar2_table(2163) := '656E74732E6C656E677468297D746869732E6164646974696F6E616C4F666673657442794C696E652E707573682830297D746F537472696E6728297B72657475726E60536C6963653A2022247B746869732E746578747D22607D67657420746578742829';
wwv_flow_imp.g_varchar2_table(2164) := '7B72657475726E20746869732E67657454657874286E657720447228302C746869732E6C656E67746829297D676574546578742865297B72657475726E20746869732E656C656D656E74732E736C69636528652E73746172742C652E656E644578636C75';
wwv_flow_imp.g_varchar2_table(2165) := '73697665292E6D61702828653D3E537472696E672E66726F6D43686172436F646528652929292E6A6F696E282222297D676574456C656D656E742865297B72657475726E20746869732E656C656D656E74735B655D7D676574206C656E67746828297B72';
wwv_flow_imp.g_varchar2_table(2166) := '657475726E20746869732E656C656D656E74732E6C656E6774687D676574426F756E6461727953636F72652865297B636F6E737420743D536928653E303F746869732E656C656D656E74735B652D315D3A2D31292C6E3D536928653C746869732E656C65';
wwv_flow_imp.g_varchar2_table(2167) := '6D656E74732E6C656E6774683F746869732E656C656D656E74735B655D3A2D31293B696628373D3D3D742626383D3D3D6E2972657475726E20303B696628383D3D3D742972657475726E203135303B6C657420723D303B72657475726E2074213D3D6E26';
wwv_flow_imp.g_varchar2_table(2168) := '2628722B3D31302C303D3D3D742626313D3D3D6E262628722B3D3129292C722B3D77692874292C722B3D7769286E292C727D7472616E736C6174654F66667365742865297B696628746869732E6C696E6552616E67652E6973456D707479297265747572';
wwv_flow_imp.g_varchar2_table(2169) := '6E206E657720777428746869732E6C696E6552616E67652E73746172742B312C31293B636F6E737420743D4B7228746869732E6669727374436861724F666673657442794C696E652C28743D3E743C3D6529293B72657475726E206E6577207774287468';
wwv_flow_imp.g_varchar2_table(2170) := '69732E6C696E6552616E67652E73746172742B742B312C652D746869732E6669727374436861724F666673657442794C696E655B745D2B746869732E6164646974696F6E616C4F666673657442794C696E655B745D2B31297D7472616E736C6174655261';
wwv_flow_imp.g_varchar2_table(2171) := '6E67652865297B72657475726E2053742E66726F6D506F736974696F6E7328746869732E7472616E736C6174654F666673657428652E7374617274292C746869732E7472616E736C6174654F666673657428652E656E644578636C757369766529297D66';
wwv_flow_imp.g_varchar2_table(2172) := '696E64576F7264436F6E7461696E696E672865297B696628653C307C7C653E3D746869732E656C656D656E74732E6C656E6774682972657475726E3B696628215F6928746869732E656C656D656E74735B655D292972657475726E3B6C657420743D653B';
wwv_flow_imp.g_varchar2_table(2173) := '666F72283B743E3026265F6928746869732E656C656D656E74735B742D315D293B29742D2D3B6C6574206E3D653B666F72283B6E3C746869732E656C656D656E74732E6C656E67746826265F6928746869732E656C656D656E74735B6E5D293B296E2B2B';
wwv_flow_imp.g_varchar2_table(2174) := '3B72657475726E206E657720447228742C6E297D636F756E744C696E6573496E2865297B72657475726E20746869732E7472616E736C6174654F666673657428652E656E644578636C7573697665292E6C696E654E756D6265722D746869732E7472616E';
wwv_flow_imp.g_varchar2_table(2175) := '736C6174654F666673657428652E7374617274292E6C696E654E756D6265727D69735374726F6E676C79457175616C28652C74297B72657475726E20746869732E656C656D656E74735B655D3D3D3D746869732E656C656D656E74735B745D7D65787465';
wwv_flow_imp.g_varchar2_table(2176) := '6E64546F46756C6C4C696E65732865297B76617220742C6E3B636F6E737420723D6E756C6C213D3D28743D717228746869732E6669727374436861724F666673657442794C696E652C28743D3E743C3D652E73746172742929292626766F69642030213D';
wwv_flow_imp.g_varchar2_table(2177) := '3D743F743A302C693D6E756C6C213D3D286E3D66756E6374696F6E2874297B636F6E7374206E3D6A7228742C28743D3E652E656E644578636C75736976653C3D7429293B72657475726E206E3D3D3D742E6C656E6774683F766F696420303A745B6E5D7D';
wwv_flow_imp.g_varchar2_table(2178) := '28746869732E6669727374436861724F666673657442794C696E6529292626766F69642030213D3D6E3F6E3A746869732E656C656D656E74732E6C656E6774683B72657475726E206E657720447228722C69297D7D66756E6374696F6E205F692865297B';
wwv_flow_imp.g_varchar2_table(2179) := '72657475726E20653E3D39372626653C3D3132327C7C653E3D36352626653C3D39307C7C653E3D34382626653C3D35377D636F6E73742043693D7B303A302C313A302C323A302C333A31302C343A322C353A33302C363A332C373A31302C383A31307D3B';
wwv_flow_imp.g_varchar2_table(2180) := '66756E6374696F6E2077692865297B72657475726E2043695B655D7D66756E6374696F6E2053692865297B72657475726E2031303D3D3D653F383A31333D3D3D653F373A64692865293F363A653E3D39372626653C3D3132323F303A653E3D3635262665';
wwv_flow_imp.g_varchar2_table(2181) := '3C3D39303F313A653E3D34382626653C3D35373F323A2D313D3D3D653F333A34343D3D3D657C7C35393D3D3D653F353A347D66756E6374696F6E204C6928652C742C6E297B696628652E7472696D28293D3D3D742E7472696D28292972657475726E2130';
wwv_flow_imp.g_varchar2_table(2182) := '3B696628652E6C656E6774683E3330302626742E6C656E6774683E3330302972657475726E21313B636F6E737420723D286E6577206769292E636F6D70757465286E6577207969285B655D2C6E657720447228302C31292C2131292C6E6577207969285B';
wwv_flow_imp.g_varchar2_table(2183) := '745D2C6E657720447228302C31292C2131292C6E293B6C657420693D303B636F6E737420733D61692E696E7665727428722E64696666732C652E6C656E677468293B666F7228636F6E73742074206F66207329742E7365713152616E67652E666F724561';
wwv_flow_imp.g_varchar2_table(2184) := '63682828743D3E7B646928652E63686172436F64654174287429297C7C692B2B7D29293B636F6E7374206F3D66756E6374696F6E2874297B6C6574206E3D303B666F72286C657420723D303B723C652E6C656E6774683B722B2B29646928742E63686172';
wwv_flow_imp.g_varchar2_table(2185) := '436F64654174287229297C7C6E2B2B3B72657475726E206E7D28652E6C656E6774683E742E6C656E6774683F653A74293B72657475726E20692F6F3E2E3626266F3E31307D66756E6374696F6E20456928652C742C6E297B6C657420723D6E3B72657475';
wwv_flow_imp.g_varchar2_table(2186) := '726E20723D786928652C742C72292C723D786928652C742C72292C723D66756E6374696F6E28652C742C6E297B69662821652E676574426F756E6461727953636F72657C7C21742E676574426F756E6461727953636F72652972657475726E206E3B666F';
wwv_flow_imp.g_varchar2_table(2187) := '72286C657420723D303B723C6E2E6C656E6774683B722B2B297B636F6E737420693D723E303F6E5B722D315D3A766F696420302C733D6E5B725D2C6F3D722B313C6E2E6C656E6774683F6E5B722B315D3A766F696420302C613D6E657720447228693F69';
wwv_flow_imp.g_varchar2_table(2188) := '2E7365713152616E67652E656E644578636C75736976652B313A302C6F3F6F2E7365713152616E67652E73746172742D313A652E6C656E677468292C6C3D6E657720447228693F692E7365713252616E67652E656E644578636C75736976652B313A302C';
wwv_flow_imp.g_varchar2_table(2189) := '6F3F6F2E7365713252616E67652E73746172742D313A742E6C656E677468293B732E7365713152616E67652E6973456D7074793F6E5B725D3D4E6928732C652C742C612C6C293A732E7365713252616E67652E6973456D7074792626286E5B725D3D4E69';
wwv_flow_imp.g_varchar2_table(2190) := '28732E7377617028292C742C652C6C2C61292E737761702829297D72657475726E206E7D28652C742C72292C727D66756E6374696F6E20786928652C742C6E297B696628303D3D3D6E2E6C656E6774682972657475726E206E3B636F6E737420723D5B5D';
wwv_flow_imp.g_varchar2_table(2191) := '3B722E70757368286E5B305D293B666F72286C657420693D313B693C6E2E6C656E6774683B692B2B297B636F6E737420733D725B722E6C656E6774682D315D3B6C6574206F3D6E5B695D3B6966286F2E7365713152616E67652E6973456D7074797C7C6F';
wwv_flow_imp.g_varchar2_table(2192) := '2E7365713252616E67652E6973456D707479297B636F6E7374206E3D6F2E7365713152616E67652E73746172742D732E7365713152616E67652E656E644578636C75736976653B6C657420693B666F7228693D313B693C3D6E2626652E676574456C656D';
wwv_flow_imp.g_varchar2_table(2193) := '656E74286F2E7365713152616E67652E73746172742D69293D3D3D652E676574456C656D656E74286F2E7365713152616E67652E656E644578636C75736976652D69292626742E676574456C656D656E74286F2E7365713252616E67652E73746172742D';
wwv_flow_imp.g_varchar2_table(2194) := '69293D3D3D742E676574456C656D656E74286F2E7365713252616E67652E656E644578636C75736976652D69293B692B2B293B696628692D2D2C693D3D3D6E297B725B722E6C656E6774682D315D3D6E6577206169286E657720447228732E7365713152';
wwv_flow_imp.g_varchar2_table(2195) := '616E67652E73746172742C6F2E7365713152616E67652E656E644578636C75736976652D6E292C6E657720447228732E7365713252616E67652E73746172742C6F2E7365713252616E67652E656E644578636C75736976652D6E29293B636F6E74696E75';
wwv_flow_imp.g_varchar2_table(2196) := '657D6F3D6F2E64656C7461282D69297D722E70757368286F297D636F6E737420693D5B5D3B666F72286C6574206E3D303B6E3C722E6C656E6774682D313B6E2B2B297B636F6E737420733D725B6E2B315D3B6C6574206F3D725B6E5D3B6966286F2E7365';
wwv_flow_imp.g_varchar2_table(2197) := '713152616E67652E6973456D7074797C7C6F2E7365713252616E67652E6973456D707479297B636F6E737420693D732E7365713152616E67652E73746172742D6F2E7365713152616E67652E656E644578636C75736976653B6C657420613B666F722861';
wwv_flow_imp.g_varchar2_table(2198) := '3D303B613C692626652E69735374726F6E676C79457175616C286F2E7365713152616E67652E73746172742B612C6F2E7365713152616E67652E656E644578636C75736976652B61292626742E69735374726F6E676C79457175616C286F2E7365713252';
wwv_flow_imp.g_varchar2_table(2199) := '616E67652E73746172742B612C6F2E7365713252616E67652E656E644578636C75736976652B61293B612B2B293B696628613D3D3D69297B725B6E2B315D3D6E6577206169286E6577204472286F2E7365713152616E67652E73746172742B692C732E73';
wwv_flow_imp.g_varchar2_table(2200) := '65713152616E67652E656E644578636C7573697665292C6E6577204472286F2E7365713252616E67652E73746172742B692C732E7365713252616E67652E656E644578636C757369766529293B636F6E74696E75657D613E302626286F3D6F2E64656C74';
wwv_flow_imp.g_varchar2_table(2201) := '61286129297D692E70757368286F297D72657475726E20722E6C656E6774683E302626692E7075736828725B722E6C656E6774682D315D292C697D66756E6374696F6E204E6928652C742C6E2C722C69297B6C657420733D313B666F72283B652E736571';
wwv_flow_imp.g_varchar2_table(2202) := '3152616E67652E73746172742D733E3D722E73746172742626652E7365713252616E67652E73746172742D733E3D692E737461727426266E2E69735374726F6E676C79457175616C28652E7365713252616E67652E73746172742D732C652E7365713252';
wwv_flow_imp.g_varchar2_table(2203) := '616E67652E656E644578636C75736976652D73292626733C3130303B29732B2B3B732D2D3B6C6574206F3D303B666F72283B652E7365713152616E67652E73746172742B6F3C722E656E644578636C75736976652626652E7365713252616E67652E656E';
wwv_flow_imp.g_varchar2_table(2204) := '644578636C75736976652B6F3C692E656E644578636C757369766526266E2E69735374726F6E676C79457175616C28652E7365713252616E67652E73746172742B6F2C652E7365713252616E67652E656E644578636C75736976652B6F2926266F3C3130';
wwv_flow_imp.g_varchar2_table(2205) := '303B296F2B2B3B696628303D3D3D732626303D3D3D6F2972657475726E20653B6C657420613D302C6C3D2D313B666F72286C657420723D2D733B723C3D6F3B722B2B297B636F6E737420693D652E7365713252616E67652E73746172742B722C733D652E';
wwv_flow_imp.g_varchar2_table(2206) := '7365713252616E67652E656E644578636C75736976652B722C6F3D652E7365713152616E67652E73746172742B722C753D742E676574426F756E6461727953636F7265286F292B6E2E676574426F756E6461727953636F72652869292B6E2E676574426F';
wwv_flow_imp.g_varchar2_table(2207) := '756E6461727953636F72652873293B753E6C2626286C3D752C613D72297D72657475726E20652E64656C74612861297D636C6173732041697B636F6E7374727563746F7228652C74297B746869732E7472696D6D6564486173683D652C746869732E6C69';
wwv_flow_imp.g_varchar2_table(2208) := '6E65733D747D676574456C656D656E742865297B72657475726E20746869732E7472696D6D6564486173685B655D7D676574206C656E67746828297B72657475726E20746869732E7472696D6D6564486173682E6C656E6774687D676574426F756E6461';
wwv_flow_imp.g_varchar2_table(2209) := '727953636F72652865297B72657475726E203165332D2828303D3D3D653F303A6B6928746869732E6C696E65735B652D315D29292B28653D3D3D746869732E6C696E65732E6C656E6774683F303A6B6928746869732E6C696E65735B655D2929297D6765';
wwv_flow_imp.g_varchar2_table(2210) := '74546578742865297B72657475726E20746869732E6C696E65732E736C69636528652E73746172742C652E656E644578636C7573697665292E6A6F696E28225C6E22297D69735374726F6E676C79457175616C28652C74297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(2211) := '2E6C696E65735B655D3D3D3D746869732E6C696E65735B745D7D7D66756E6374696F6E206B692865297B6C657420743D303B666F72283B743C652E6C656E67746826262833323D3D3D652E63686172436F646541742874297C7C393D3D3D652E63686172';
wwv_flow_imp.g_varchar2_table(2212) := '436F64654174287429293B29742B2B3B72657475726E20747D636C6173732052697B636F6E7374727563746F7228297B746869732E64796E616D696350726F6772616D6D696E6744696666696E673D6E6577206D692C746869732E6D7965727344696666';
wwv_flow_imp.g_varchar2_table(2213) := '696E67416C676F726974686D3D6E65772067697D636F6D707574654469666628652C742C6E297B696628652E6C656E6774683C3D31262666756E6374696F6E28652C742C6E3D28652C74293D3E653D3D3D74297B696628653D3D3D742972657475726E21';
wwv_flow_imp.g_varchar2_table(2214) := '303B69662821657C7C21742972657475726E21313B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C657420723D302C693D652E6C656E6774683B723C693B722B2B29696628216E28655B725D2C745B725D29';
wwv_flow_imp.g_varchar2_table(2215) := '2972657475726E21313B72657475726E21307D28652C742C2828652C74293D3E653D3D3D7429292972657475726E206E6577204672285B5D2C5B5D2C2131293B696628313D3D3D652E6C656E6774682626303D3D3D655B305D2E6C656E6774687C7C313D';
wwv_flow_imp.g_varchar2_table(2216) := '3D3D742E6C656E6774682626303D3D3D745B305D2E6C656E6774682972657475726E206E6577204672285B6E6577204772286E657720427228312C652E6C656E6774682B31292C6E657720427228312C742E6C656E6774682B31292C5B6E6577204A7228';
wwv_flow_imp.g_varchar2_table(2217) := '6E657720537428312C312C652E6C656E6774682C655B652E6C656E6774682D315D2E6C656E6774682B31292C6E657720537428312C312C742E6C656E6774682C745B742E6C656E6774682D315D2E6C656E6774682B3129295D295D2C5B5D2C2131293B63';
wwv_flow_imp.g_varchar2_table(2218) := '6F6E737420723D303D3D3D6E2E6D6178436F6D7075746174696F6E54696D654D733F75692E696E7374616E63653A6E6577206369286E2E6D6178436F6D7075746174696F6E54696D654D73292C693D216E2E69676E6F72655472696D5768697465737061';
wwv_flow_imp.g_varchar2_table(2219) := '63652C733D6E6577204D61703B66756E6374696F6E206F2865297B6C657420743D732E6765742865293B72657475726E20766F696420303D3D3D74262628743D732E73697A652C732E73657428652C7429292C747D636F6E737420613D652E6D61702828';
wwv_flow_imp.g_varchar2_table(2220) := '653D3E6F28652E7472696D28292929292C6C3D742E6D61702828653D3E6F28652E7472696D28292929292C753D6E657720416928612C65292C633D6E6577204169286C2C74292C683D2828293D3E752E6C656E6774682B632E6C656E6774683C31373030';
wwv_flow_imp.g_varchar2_table(2221) := '3F746869732E64796E616D696350726F6772616D6D696E6744696666696E672E636F6D7075746528752C632C722C28286E2C72293D3E655B6E5D3D3D3D745B725D3F303D3D3D745B725D2E6C656E6774683F2E313A312B4D6174682E6C6F6728312B745B';
wwv_flow_imp.g_varchar2_table(2222) := '725D2E6C656E677468293A2E393929293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528752C63292928293B6C657420643D682E64696666732C663D682E68697454696D656F75743B643D456928752C632C6429';
wwv_flow_imp.g_varchar2_table(2223) := '2C643D66756E6374696F6E28652C742C6E297B6C657420723D6E3B696628303D3D3D722E6C656E6774682972657475726E20723B6C657420692C733D303B646F7B693D21313B636F6E7374206F3D5B725B305D5D3B666F72286C657420613D313B613C72';
wwv_flow_imp.g_varchar2_table(2224) := '2E6C656E6774683B612B2B297B636F6E7374206C3D725B615D2C753D6F5B6F2E6C656E6774682D315D3B66756E6374696F6E206328742C6E297B636F6E737420723D6E657720447228752E7365713152616E67652E656E644578636C75736976652C6C2E';
wwv_flow_imp.g_varchar2_table(2225) := '7365713152616E67652E7374617274293B72657475726E20652E676574546578742872292E7265706C616365282F5C732F672C2222292E6C656E6774683C3D34262628742E7365713152616E67652E6C656E6774682B742E7365713252616E67652E6C65';
wwv_flow_imp.g_varchar2_table(2226) := '6E6774683E357C7C6E2E7365713152616E67652E6C656E6774682B6E2E7365713252616E67652E6C656E6774683E35297D6328752C6C293F28693D21302C6F5B6F2E6C656E6774682D315D3D6F5B6F2E6C656E6774682D315D2E6A6F696E286C29293A6F';
wwv_flow_imp.g_varchar2_table(2227) := '2E70757368286C297D723D6F7D7768696C6528732B2B3C3130262669293B72657475726E20727D28752C302C64293B636F6E7374206D3D5B5D2C673D6E3D3E7B6966286929666F72286C657420733D303B733C6E3B732B2B297B636F6E7374206E3D702B';
wwv_flow_imp.g_varchar2_table(2228) := '732C6F3D762B733B696628655B6E5D213D3D745B6F5D297B636F6E737420733D746869732E726566696E654469666628652C742C6E6577206169286E6577204472286E2C6E2B31292C6E6577204472286F2C6F2B3129292C722C69293B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(2229) := '73742065206F6620732E6D617070696E6773296D2E707573682865293B732E68697454696D656F7574262628663D2130297D7D7D3B6C657420703D302C763D303B666F7228636F6E7374206E206F662064297B5472282828293D3E6E2E7365713152616E';
wwv_flow_imp.g_varchar2_table(2230) := '67652E73746172742D703D3D6E2E7365713252616E67652E73746172742D7629292C67286E2E7365713152616E67652E73746172742D70292C703D6E2E7365713152616E67652E656E644578636C75736976652C763D6E2E7365713252616E67652E656E';
wwv_flow_imp.g_varchar2_table(2231) := '644578636C75736976653B636F6E737420733D746869732E726566696E654469666628652C742C6E2C722C69293B732E68697454696D656F7574262628663D2130293B666F7228636F6E73742065206F6620732E6D617070696E6773296D2E7075736828';
wwv_flow_imp.g_varchar2_table(2232) := '65297D6728652E6C656E6774682D70293B636F6E737420623D5469286D2C652C74293B6C657420793D5B5D3B72657475726E206E2E636F6D707574654D6F766573262628793D746869732E636F6D707574654D6F76657328622C652C742C612C6C2C722C';
wwv_flow_imp.g_varchar2_table(2233) := '6929292C5472282828293D3E7B66756E6374696F6E206E28652C74297B696628652E6C696E654E756D6265723C317C7C652E6C696E654E756D6265723E742E6C656E6774682972657475726E21313B636F6E7374206E3D745B652E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(2234) := '722D315D3B72657475726E2128652E636F6C756D6E3C317C7C652E636F6C756D6E3E6E2E6C656E6774682B31297D66756E6374696F6E207228652C74297B72657475726E2128652E73746172744C696E654E756D6265723C317C7C652E73746172744C69';
wwv_flow_imp.g_varchar2_table(2235) := '6E654E756D6265723E742E6C656E6774682B317C7C652E656E644C696E654E756D6265724578636C75736976653C317C7C652E656E644C696E654E756D6265724578636C75736976653E742E6C656E6774682B31297D666F7228636F6E73742069206F66';
wwv_flow_imp.g_varchar2_table(2236) := '2062297B69662821692E696E6E65724368616E6765732972657475726E21313B666F7228636F6E73742072206F6620692E696E6E65724368616E6765732969662821286E28722E6D6F64696669656452616E67652E6765745374617274506F736974696F';
wwv_flow_imp.g_varchar2_table(2237) := '6E28292C742926266E28722E6D6F64696669656452616E67652E676574456E64506F736974696F6E28292C742926266E28722E6F726967696E616C52616E67652E6765745374617274506F736974696F6E28292C652926266E28722E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(2238) := '52616E67652E676574456E64506F736974696F6E28292C6529292972657475726E21313B696628217228692E6D6F6469666965642C74297C7C217228692E6F726967696E616C2C65292972657475726E21317D72657475726E21307D29292C6E65772046';
wwv_flow_imp.g_varchar2_table(2239) := '7228622C792C66297D636F6D707574654D6F76657328652C742C6E2C722C692C732C6F297B72657475726E2066756E6374696F6E28652C742C6E2C722C692C73297B6C65747B6D6F7665733A6F2C6578636C756465644368616E6765733A617D3D66756E';
wwv_flow_imp.g_varchar2_table(2240) := '6374696F6E28652C742C6E2C72297B636F6E737420693D5B5D2C733D652E66696C7465722828653D3E652E6D6F6469666965642E6973456D7074792626652E6F726967696E616C2E6C656E6774683E3D3329292E6D61702828653D3E6E65772066692865';
wwv_flow_imp.g_varchar2_table(2241) := '2E6F726967696E616C2C742C652929292C6F3D6E65772053657428652E66696C7465722828653D3E652E6F726967696E616C2E6973456D7074792626652E6D6F6469666965642E6C656E6774683E3D3329292E6D61702828653D3E6E657720666928652E';
wwv_flow_imp.g_varchar2_table(2242) := '6D6F6469666965642C6E2C65292929292C613D6E6577205365743B666F7228636F6E73742065206F662073297B6C657420742C6E3D2D313B666F7228636F6E73742072206F66206F297B636F6E737420693D652E636F6D7075746553696D696C61726974';
wwv_flow_imp.g_varchar2_table(2243) := '792872293B693E6E2626286E3D692C743D72297D6966286E3E2E392626742626286F2E64656C6574652874292C692E70757368286E657720487228652E72616E67652C742E72616E676529292C612E61646428652E736F75726365292C612E6164642874';
wwv_flow_imp.g_varchar2_table(2244) := '2E736F7572636529292C21722E697356616C696428292972657475726E7B6D6F7665733A692C6578636C756465644368616E6765733A617D7D72657475726E7B6D6F7665733A692C6578636C756465644368616E6765733A617D7D28652C742C6E2C7329';
wwv_flow_imp.g_varchar2_table(2245) := '3B69662821732E697356616C696428292972657475726E5B5D3B636F6E7374206C3D66756E6374696F6E28652C742C6E2C722C692C73297B636F6E7374206F3D5B5D2C613D6E6577204E723B666F7228636F6E7374206E206F66206529666F72286C6574';
wwv_flow_imp.g_varchar2_table(2246) := '20653D6E2E6F726967696E616C2E73746172744C696E654E756D6265723B653C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D323B652B2B297B636F6E7374206E3D60247B745B652D315D7D3A247B745B652B312D';
wwv_flow_imp.g_varchar2_table(2247) := '315D7D3A247B745B652B322D315D7D603B612E616464286E2C7B72616E67653A6E657720427228652C652B33297D297D636F6E7374206C3D5B5D3B652E736F72742845742828653D3E652E6D6F6469666965642E73746172744C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(2248) := '2C787429293B666F7228636F6E73742074206F662065297B6C657420653D5B5D3B666F72286C657420723D742E6D6F6469666965642E73746172744C696E654E756D6265723B723C742E6D6F6469666965642E656E644C696E654E756D6265724578636C';
wwv_flow_imp.g_varchar2_table(2249) := '75736976652D323B722B2B297B636F6E737420743D60247B6E5B722D315D7D3A247B6E5B722B312D315D7D3A247B6E5B722B322D315D7D602C693D6E657720427228722C722B33292C733D5B5D3B612E666F724561636828742C28287B72616E67653A74';
wwv_flow_imp.g_varchar2_table(2250) := '7D293D3E7B666F7228636F6E7374206E206F662065296966286E2E6F726967696E616C4C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D742E656E644C696E654E756D6265724578636C757369766526266E2E';
wwv_flow_imp.g_varchar2_table(2251) := '6D6F6469666965644C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D692E656E644C696E654E756D6265724578636C75736976652972657475726E206E2E6F726967696E616C4C696E6552616E67653D6E6577';
wwv_flow_imp.g_varchar2_table(2252) := '204272286E2E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C742E656E644C696E654E756D6265724578636C7573697665292C6E2E6D6F6469666965644C696E6552616E67653D6E6577204272286E2E6D6F646966';
wwv_flow_imp.g_varchar2_table(2253) := '6965644C696E6552616E67652E73746172744C696E654E756D6265722C692E656E644C696E654E756D6265724578636C7573697665292C766F696420732E70757368286E293B636F6E7374206E3D7B6D6F6469666965644C696E6552616E67653A692C6F';
wwv_flow_imp.g_varchar2_table(2254) := '726967696E616C4C696E6552616E67653A747D3B6C2E70757368286E292C732E70757368286E297D29292C653D737D69662821732E697356616C696428292972657475726E5B5D7D76617220753B6C2E736F72742828753D45742828653D3E652E6D6F64';
wwv_flow_imp.g_varchar2_table(2255) := '69666965644C696E6552616E67652E6C656E677468292C7874292C28652C74293D3E2D7528652C742929293B636F6E737420633D6E65772024722C683D6E65772024723B666F7228636F6E73742065206F66206C297B636F6E737420743D652E6D6F6469';
wwv_flow_imp.g_varchar2_table(2256) := '666965644C696E6552616E67652E73746172744C696E654E756D6265722D652E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C6E3D632E737562747261637446726F6D28652E6D6F6469666965644C696E6552616E';
wwv_flow_imp.g_varchar2_table(2257) := '6765292C723D682E737562747261637446726F6D28652E6F726967696E616C4C696E6552616E6765292E6765745769746844656C74612874292C693D6E2E676574496E74657273656374696F6E2872293B666F7228636F6E73742065206F6620692E7261';
wwv_flow_imp.g_varchar2_table(2258) := '6E676573297B696628652E6C656E6774683C3329636F6E74696E75653B636F6E7374206E3D652C723D652E64656C7461282D74293B6F2E70757368286E657720487228722C6E29292C632E61646452616E6765286E292C682E61646452616E6765287229';
wwv_flow_imp.g_varchar2_table(2259) := '7D7D6F2E736F72742845742828653D3E652E6F726967696E616C2E73746172744C696E654E756D626572292C787429293B636F6E737420643D6E65772055722865293B666F72286C657420743D303B743C6F2E6C656E6774683B742B2B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(2260) := '206E3D6F5B745D2C613D642E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C3D6E2E6F726967696E616C2E73746172744C696E654E756D62657229292C6C3D717228652C28';
wwv_flow_imp.g_varchar2_table(2261) := '653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C3D6E2E6D6F6469666965642E73746172744C696E654E756D62657229292C753D4D6174682E6D6178286E2E6F726967696E616C2E73746172744C696E654E756D6265722D612E';
wwv_flow_imp.g_varchar2_table(2262) := '6F726967696E616C2E73746172744C696E654E756D6265722C6E2E6D6F6469666965642E73746172744C696E654E756D6265722D6C2E6D6F6469666965642E73746172744C696E654E756D626572292C663D642E66696E644C6173744D6F6E6F746F6E6F';
wwv_flow_imp.g_varchar2_table(2263) := '75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529292C6D3D717228652C28653D3E652E6D6F6469666965642E73746172744C696E';
wwv_flow_imp.g_varchar2_table(2264) := '654E756D6265723C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C757369766529292C673D4D6174682E6D617828662E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D6E2E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(2265) := '656E644C696E654E756D6265724578636C75736976652C6D2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665293B6C657420702C763B';
wwv_flow_imp.g_varchar2_table(2266) := '666F7228703D303B703C753B702B2B297B636F6E737420653D6E2E6F726967696E616C2E73746172744C696E654E756D6265722D702D312C743D6E2E6D6F6469666965642E73746172744C696E654E756D6265722D702D313B696628653E722E6C656E67';
wwv_flow_imp.g_varchar2_table(2267) := '74687C7C743E692E6C656E67746829627265616B3B696628632E636F6E7461696E732874297C7C682E636F6E7461696E7328652929627265616B3B696628214C6928725B652D315D2C695B742D315D2C732929627265616B7D666F7228703E3026262868';
wwv_flow_imp.g_varchar2_table(2268) := '2E61646452616E6765286E6577204272286E2E6F726967696E616C2E73746172744C696E654E756D6265722D702C6E2E6F726967696E616C2E73746172744C696E654E756D62657229292C632E61646452616E6765286E6577204272286E2E6D6F646966';
wwv_flow_imp.g_varchar2_table(2269) := '6965642E73746172744C696E654E756D6265722D702C6E2E6D6F6469666965642E73746172744C696E654E756D6265722929292C763D303B763C673B762B2B297B636F6E737420653D6E2E6F726967696E616C2E656E644C696E654E756D626572457863';
wwv_flow_imp.g_varchar2_table(2270) := '6C75736976652B762C743D6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B763B696628653E722E6C656E6774687C7C743E692E6C656E67746829627265616B3B696628632E636F6E7461696E732874297C7C682E63';
wwv_flow_imp.g_varchar2_table(2271) := '6F6E7461696E7328652929627265616B3B696628214C6928725B652D315D2C695B742D315D2C732929627265616B7D763E30262628682E61646452616E6765286E6577204272286E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75';
wwv_flow_imp.g_varchar2_table(2272) := '736976652C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B7629292C632E61646452616E6765286E6577204272286E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6E2E6D6F64';
wwv_flow_imp.g_varchar2_table(2273) := '69666965642E656E644C696E654E756D6265724578636C75736976652B762929292C28703E307C7C763E30292626286F5B745D3D6E6577204872286E6577204272286E2E6F726967696E616C2E73746172744C696E654E756D6265722D702C6E2E6F7269';
wwv_flow_imp.g_varchar2_table(2274) := '67696E616C2E656E644C696E654E756D6265724578636C75736976652B76292C6E6577204272286E2E6D6F6469666965642E73746172744C696E654E756D6265722D702C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(2275) := '652B762929297D72657475726E206F7D28652E66696C7465722828653D3E21612E68617328652929292C722C692C742C6E2C73293B72657475726E2066756E6374696F6E28652C74297B666F7228636F6E7374206E206F66207429652E70757368286E29';
wwv_flow_imp.g_varchar2_table(2276) := '7D286F2C6C292C6F3D66756E6374696F6E2865297B696628303D3D3D652E6C656E6774682972657475726E20653B652E736F72742845742828653D3E652E6F726967696E616C2E73746172744C696E654E756D626572292C787429293B636F6E73742074';
wwv_flow_imp.g_varchar2_table(2277) := '3D5B655B305D5D3B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B297B636F6E737420723D745B742E6C656E6774682D315D2C693D655B6E5D2C733D692E6F726967696E616C2E73746172744C696E654E756D6265722D722E6F726967';
wwv_flow_imp.g_varchar2_table(2278) := '696E616C2E656E644C696E654E756D6265724578636C75736976652C6F3D692E6D6F6469666965642E73746172744C696E654E756D6265722D722E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653B733E3D3026266F3E3D';
wwv_flow_imp.g_varchar2_table(2279) := '302626732B6F3C3D323F745B742E6C656E6774682D315D3D722E6A6F696E2869293A742E707573682869297D72657475726E20747D286F292C6F3D6F2E66696C7465722828653D3E7B636F6E7374206E3D652E6F726967696E616C2E746F4F6666736574';
wwv_flow_imp.g_varchar2_table(2280) := '52616E676528292E736C6963652874292E6D61702828653D3E652E7472696D282929293B72657475726E206E2E6A6F696E28225C6E22292E6C656E6774683E3D3135262666756E6374696F6E2865297B6C657420743D303B666F7228636F6E7374206E20';
wwv_flow_imp.g_varchar2_table(2281) := '6F662065296E2E6C656E6774683E3D322626742B2B3B72657475726E20747D286E293E3D327D29292C6F3D66756E6374696F6E28652C74297B636F6E7374206E3D6E65772055722865293B72657475726E20742E66696C7465722828743D3E286E2E6669';
wwv_flow_imp.g_varchar2_table(2282) := '6E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C742E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529297C7C6E6577204872286E65772042722831';
wwv_flow_imp.g_varchar2_table(2283) := '2C31292C6E657720427228312C31292929213D3D717228652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C742E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665292929297D28652C6F292C';
wwv_flow_imp.g_varchar2_table(2284) := '6F7D28652C742C6E2C722C692C73292E6D61702828653D3E7B636F6E737420723D546928746869732E726566696E654469666628742C6E2C6E657720616928652E6F726967696E616C2E746F4F666673657452616E676528292C652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(2285) := '2E746F4F666673657452616E67652829292C732C6F292E6D617070696E67732C742C6E2C2130293B72657475726E206E657720567228652C72297D29297D726566696E654469666628652C742C6E2C722C69297B636F6E737420733D6E65772079692865';
wwv_flow_imp.g_varchar2_table(2286) := '2C6E2E7365713152616E67652C69292C6F3D6E657720796928742C6E2E7365713252616E67652C69292C613D732E6C656E6774682B6F2E6C656E6774683C3530303F746869732E64796E616D696350726F6772616D6D696E6744696666696E672E636F6D';
wwv_flow_imp.g_varchar2_table(2287) := '7075746528732C6F2C72293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528732C6F2C72293B6C6574206C3D612E64696666733B72657475726E206C3D456928732C6F2C6C292C6C3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(2288) := '742C6E297B636F6E737420723D61692E696E76657274286E2C652E6C656E677468292C693D5B5D3B6C657420733D6E6577206C6928302C30293B66756E6374696F6E206F286E2C6F297B6966286E2E6F6666736574313C732E6F6666736574317C7C6E2E';
wwv_flow_imp.g_varchar2_table(2289) := '6F6666736574323C732E6F6666736574322972657475726E3B636F6E737420613D652E66696E64576F7264436F6E7461696E696E67286E2E6F666673657431292C6C3D742E66696E64576F7264436F6E7461696E696E67286E2E6F666673657432293B69';
wwv_flow_imp.g_varchar2_table(2290) := '662821617C7C216C2972657475726E3B6C657420753D6E657720616928612C6C293B636F6E737420633D752E696E74657273656374286F293B6C657420683D632E7365713152616E67652E6C656E6774682C643D632E7365713252616E67652E6C656E67';
wwv_flow_imp.g_varchar2_table(2291) := '74683B666F72283B722E6C656E6774683E303B297B636F6E7374206E3D725B305D3B696628216E2E7365713152616E67652E696E746572736563747328752E7365713152616E6765292626216E2E7365713252616E67652E696E74657273656374732875';
wwv_flow_imp.g_varchar2_table(2292) := '2E7365713252616E67652929627265616B3B636F6E737420693D652E66696E64576F7264436F6E7461696E696E67286E2E7365713152616E67652E7374617274292C733D742E66696E64576F7264436F6E7461696E696E67286E2E7365713252616E6765';
wwv_flow_imp.g_varchar2_table(2293) := '2E7374617274292C6F3D6E657720616928692C73292C613D6F2E696E74657273656374286E293B696628682B3D612E7365713152616E67652E6C656E6774682C642B3D612E7365713252616E67652E6C656E6774682C753D752E6A6F696E286F292C2128';
wwv_flow_imp.g_varchar2_table(2294) := '752E7365713152616E67652E656E644578636C75736976653E3D6E2E7365713152616E67652E656E644578636C75736976652929627265616B3B722E736869667428297D682B643C322A28752E7365713152616E67652E6C656E6774682B752E73657132';
wwv_flow_imp.g_varchar2_table(2295) := '52616E67652E6C656E677468292F332626692E707573682875292C733D752E676574456E644578636C75736976657328297D666F72283B722E6C656E6774683E303B297B636F6E737420653D722E736869667428293B652E7365713152616E67652E6973';
wwv_flow_imp.g_varchar2_table(2296) := '456D7074797C7C286F28652E67657453746172747328292C65292C6F28652E676574456E644578636C75736976657328292E64656C7461282D31292C6529297D72657475726E2066756E6374696F6E28652C74297B636F6E7374206E3D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(2297) := '3B652E6C656E6774683E307C7C742E6C656E6774683E303B297B636F6E737420723D655B305D2C693D745B305D3B6C657420733B733D7226262821697C7C722E7365713152616E67652E73746172743C692E7365713152616E67652E7374617274293F65';
wwv_flow_imp.g_varchar2_table(2298) := '2E736869667428293A742E736869667428292C6E2E6C656E6774683E3026266E5B6E2E6C656E6774682D315D2E7365713152616E67652E656E644578636C75736976653E3D732E7365713152616E67652E73746172743F6E5B6E2E6C656E6774682D315D';
wwv_flow_imp.g_varchar2_table(2299) := '3D6E5B6E2E6C656E6774682D315D2E6A6F696E2873293A6E2E707573682873297D72657475726E206E7D286E2C69297D28732C6F2C6C292C6C3D66756E6374696F6E28652C742C6E297B636F6E737420723D5B5D3B666F7228636F6E73742065206F6620';
wwv_flow_imp.g_varchar2_table(2300) := '6E297B636F6E737420743D725B722E6C656E6774682D315D3B74262628652E7365713152616E67652E73746172742D742E7365713152616E67652E656E644578636C75736976653C3D327C7C652E7365713252616E67652E73746172742D742E73657132';
wwv_flow_imp.g_varchar2_table(2301) := '52616E67652E656E644578636C75736976653C3D32293F725B722E6C656E6774682D315D3D6E657720616928742E7365713152616E67652E6A6F696E28652E7365713152616E6765292C742E7365713252616E67652E6A6F696E28652E7365713252616E';
wwv_flow_imp.g_varchar2_table(2302) := '676529293A722E707573682865297D72657475726E20727D28302C302C6C292C6C3D66756E6374696F6E28652C742C6E297B6C657420723D6E3B696628303D3D3D722E6C656E6774682972657475726E20723B6C657420692C733D303B646F7B693D2131';
wwv_flow_imp.g_varchar2_table(2303) := '3B636F6E737420613D5B725B305D5D3B666F72286C6574206C3D313B6C3C722E6C656E6774683B6C2B2B297B636F6E737420753D725B6C5D2C633D615B612E6C656E6774682D315D3B66756E6374696F6E2068286E2C72297B636F6E737420693D6E6577';
wwv_flow_imp.g_varchar2_table(2304) := '20447228632E7365713152616E67652E656E644578636C75736976652C752E7365713152616E67652E7374617274293B696628652E636F756E744C696E6573496E2869293E357C7C692E6C656E6774683E3530302972657475726E21313B636F6E737420';
wwv_flow_imp.g_varchar2_table(2305) := '733D652E676574546578742869292E7472696D28293B696628732E6C656E6774683E32307C7C732E73706C6974282F5C725C6E7C5C727C5C6E2F292E6C656E6774683E312972657475726E21313B636F6E7374206F3D652E636F756E744C696E6573496E';
wwv_flow_imp.g_varchar2_table(2306) := '286E2E7365713152616E6765292C613D6E2E7365713152616E67652E6C656E6774682C6C3D742E636F756E744C696E6573496E286E2E7365713252616E6765292C683D6E2E7365713252616E67652E6C656E6774682C643D652E636F756E744C696E6573';
wwv_flow_imp.g_varchar2_table(2307) := '496E28722E7365713152616E6765292C663D722E7365713152616E67652E6C656E6774682C6D3D742E636F756E744C696E6573496E28722E7365713252616E6765292C673D722E7365713252616E67652E6C656E6774683B66756E6374696F6E20702865';
wwv_flow_imp.g_varchar2_table(2308) := '297B72657475726E204D6174682E6D696E28652C313330297D72657475726E204D6174682E706F77284D6174682E706F7728702834302A6F2B61292C312E35292B4D6174682E706F7728702834302A6C2B68292C312E35292C312E35292B4D6174682E70';
wwv_flow_imp.g_varchar2_table(2309) := '6F77284D6174682E706F7728702834302A642B66292C312E35292B4D6174682E706F7728702834302A6D2B67292C312E35292C312E35293E37343138342E39363438303732313234337D6828632C75293F28693D21302C615B612E6C656E6774682D315D';
wwv_flow_imp.g_varchar2_table(2310) := '3D615B612E6C656E6774682D315D2E6A6F696E287529293A612E707573682875297D723D617D7768696C6528732B2B3C3130262669293B636F6E7374206F3D5B5D3B72657475726E2066756E6374696F6E28652C74297B666F72286C6574206E3D303B6E';
wwv_flow_imp.g_varchar2_table(2311) := '3C652E6C656E6774683B6E2B2B297428303D3D3D6E3F766F696420303A655B6E2D315D2C655B6E5D2C6E2B313D3D3D652E6C656E6774683F766F696420303A655B6E2B315D297D28722C2828742C6E2C72293D3E7B6C657420693D6E3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(2312) := '6E20732865297B72657475726E20652E6C656E6774683E302626652E7472696D28292E6C656E6774683C3D3326266E2E7365713152616E67652E6C656E6774682B6E2E7365713252616E67652E6C656E6774683E3130307D636F6E737420613D652E6578';
wwv_flow_imp.g_varchar2_table(2313) := '74656E64546F46756C6C4C696E6573286E2E7365713152616E6765292C6C3D652E67657454657874286E657720447228612E73746172742C6E2E7365713152616E67652E737461727429293B73286C29262628693D692E64656C74615374617274282D6C';
wwv_flow_imp.g_varchar2_table(2314) := '2E6C656E67746829293B636F6E737420753D652E67657454657874286E6577204472286E2E7365713152616E67652E656E644578636C75736976652C612E656E644578636C757369766529293B73287529262628693D692E64656C7461456E6428752E6C';
wwv_flow_imp.g_varchar2_table(2315) := '656E67746829293B636F6E737420633D61692E66726F6D4F6666736574506169727328743F742E676574456E644578636C75736976657328293A6C692E7A65726F2C723F722E67657453746172747328293A6C692E6D6178292C683D692E696E74657273';
wwv_flow_imp.g_varchar2_table(2316) := '6563742863293B6F2E6C656E6774683E302626682E67657453746172747328292E657175616C73286F5B6F2E6C656E6774682D315D2E676574456E644578636C7573697665732829293F6F5B6F2E6C656E6774682D315D3D6F5B6F2E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(2317) := '5D2E6A6F696E2868293A6F2E707573682868297D29292C6F7D28732C6F2C6C292C7B6D617070696E67733A6C2E6D61702828653D3E6E6577204A7228732E7472616E736C61746552616E676528652E7365713152616E6765292C6F2E7472616E736C6174';
wwv_flow_imp.g_varchar2_table(2318) := '6552616E676528652E7365713252616E6765292929292C68697454696D656F75743A612E68697454696D656F75747D7D7D66756E6374696F6E20546928652C742C6E2C723D2131297B636F6E737420693D5B5D3B666F7228636F6E73742072206F662066';
wwv_flow_imp.g_varchar2_table(2319) := '756E6374696F6E2A2865297B6C657420742C6E3B666F7228636F6E73742073206F66206529766F69642030213D3D6E262628693D732C28723D6E292E6F726967696E616C2E6F7665726C61704F72546F75636828692E6F726967696E616C297C7C722E6D';
wwv_flow_imp.g_varchar2_table(2320) := '6F6469666965642E6F7665726C61704F72546F75636828692E6D6F64696669656429293F742E707573682873293A28742626287969656C642074292C743D5B735D292C6E3D733B76617220722C693B742626287969656C642074297D28652E6D61702828';
wwv_flow_imp.g_varchar2_table(2321) := '653D3E66756E6374696F6E28652C742C6E297B6C657420723D302C693D303B313D3D3D652E6D6F64696669656452616E67652E656E64436F6C756D6E2626313D3D3D652E6F726967696E616C52616E67652E656E64436F6C756D6E2626652E6F72696769';
wwv_flow_imp.g_varchar2_table(2322) := '6E616C52616E67652E73746172744C696E654E756D6265722B723C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722626652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B723C3D652E6D6F6469';
wwv_flow_imp.g_varchar2_table(2323) := '6669656452616E67652E656E644C696E654E756D626572262628693D2D31292C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2D313E3D6E5B652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722D315D2E';
wwv_flow_imp.g_varchar2_table(2324) := '6C656E6774682626652E6F726967696E616C52616E67652E7374617274436F6C756D6E2D313E3D745B652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722D315D2E6C656E6774682626652E6F726967696E616C52616E67652E';
wwv_flow_imp.g_varchar2_table(2325) := '73746172744C696E654E756D6265723C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722B692626652E6D6F64696669656452616E67652E73746172744C696E654E756D6265723C3D652E6D6F64696669656452616E67652E65';
wwv_flow_imp.g_varchar2_table(2326) := '6E644C696E654E756D6265722B69262628723D31293B636F6E737420733D6E657720427228652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722B722C652E6F726967696E616C52616E67652E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(2327) := '2B312B69292C6F3D6E657720427228652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B722C652E6D6F64696669656452616E67652E656E644C696E654E756D6265722B312B69293B72657475726E206E657720477228732C';
wwv_flow_imp.g_varchar2_table(2328) := '6F2C5B655D297D28652C742C6E29292929297B636F6E737420653D725B305D2C743D725B722E6C656E6774682D315D3B692E70757368286E657720477228652E6F726967696E616C2E6A6F696E28742E6F726967696E616C292C652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(2329) := '2E6A6F696E28742E6D6F646966696564292C722E6D61702828653D3E652E696E6E65724368616E6765735B305D292929297D72657475726E205472282828293D3E7B69662821722626692E6C656E6774683E30297B696628695B305D2E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2330) := '642E73746172744C696E654E756D626572213D3D695B305D2E6F726967696E616C2E73746172744C696E654E756D6265722972657475726E21313B6966286E2E6C656E6774682D695B692E6C656E6774682D315D2E6D6F6469666965642E656E644C696E';
wwv_flow_imp.g_varchar2_table(2331) := '654E756D6265724578636C7573697665213D742E6C656E6774682D695B692E6C656E6774682D315D2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652972657475726E21317D72657475726E204D7228692C2828652C7429';
wwv_flow_imp.g_varchar2_table(2332) := '3D3E742E6F726967696E616C2E73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965642E73746172744C696E654E756D6265722D652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(2333) := '642E656E644C696E654E756D6265724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E73746172744C696E654E756D6265722626652E6D6F6469666965642E65';
wwv_flow_imp.g_varchar2_table(2334) := '6E644C696E654E756D6265724578636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D62657229297D29292C697D66756E6374696F6E204D6928652C74297B636F6E7374206E3D4D6174682E706F772831302C74293B72657475';
wwv_flow_imp.g_varchar2_table(2335) := '726E204D6174682E726F756E6428652A6E292F6E7D636C617373204F697B636F6E7374727563746F7228652C742C6E2C723D31297B746869732E5F726762614272616E643D766F696420302C746869732E723D307C4D6174682E6D696E283235352C4D61';
wwv_flow_imp.g_varchar2_table(2336) := '74682E6D617828302C6529292C746869732E673D307C4D6174682E6D696E283235352C4D6174682E6D617828302C7429292C746869732E623D307C4D6174682E6D696E283235352C4D6174682E6D617828302C6E29292C746869732E613D4D69284D6174';
wwv_flow_imp.g_varchar2_table(2337) := '682E6D6178284D6174682E6D696E28312C72292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E723D3D3D742E722626652E673D3D3D742E672626652E623D3D3D742E622626652E613D3D3D742E617D7D636C6173';
wwv_flow_imp.g_varchar2_table(2338) := '732049697B636F6E7374727563746F7228652C742C6E2C72297B746869732E5F68736C614272616E643D766F696420302C746869732E683D307C4D6174682E6D6178284D6174682E6D696E283336302C65292C30292C746869732E733D4D69284D617468';
wwv_flow_imp.g_varchar2_table(2339) := '2E6D6178284D6174682E6D696E28312C74292C30292C33292C746869732E6C3D4D69284D6174682E6D6178284D6174682E6D696E28312C6E292C30292C33292C746869732E613D4D69284D6174682E6D6178284D6174682E6D696E28312C72292C30292C';
wwv_flow_imp.g_varchar2_table(2340) := '33297D73746174696320657175616C7328652C74297B72657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E6C3D3D3D742E6C2626652E613D3D3D742E617D7374617469632066726F6D524742412865297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(2341) := '2E722F3235352C6E3D652E672F3235352C723D652E622F3235352C693D652E612C733D4D6174682E6D617828742C6E2C72292C6F3D4D6174682E6D696E28742C6E2C72293B6C657420613D302C6C3D303B636F6E737420753D286F2B73292F322C633D73';
wwv_flow_imp.g_varchar2_table(2342) := '2D6F3B696628633E30297B737769746368286C3D4D6174682E6D696E28753C3D2E353F632F28322A75293A632F28322D322A75292C31292C73297B6361736520743A613D286E2D72292F632B286E3C723F363A30293B627265616B3B63617365206E3A61';
wwv_flow_imp.g_varchar2_table(2343) := '3D28722D74292F632B323B627265616B3B6361736520723A613D28742D6E292F632B347D612A3D36302C613D4D6174682E726F756E642861297D72657475726E206E657720496928612C6C2C752C69297D737461746963205F6875653272676228652C74';
wwv_flow_imp.g_varchar2_table(2344) := '2C6E297B72657475726E206E3C302626286E2B3D31292C6E3E312626286E2D3D31292C6E3C312F363F652B362A28742D65292A6E3A6E3C2E353F743A6E3C322F333F652B28742D65292A28322F332D6E292A363A657D73746174696320746F5247424128';
wwv_flow_imp.g_varchar2_table(2345) := '65297B636F6E737420743D652E682F3336302C7B733A6E2C6C3A722C613A697D3D653B6C657420732C6F2C613B696628303D3D3D6E29733D6F3D613D723B656C73657B636F6E737420653D723C2E353F722A28312B6E293A722B6E2D722A6E2C693D322A';
wwv_flow_imp.g_varchar2_table(2346) := '722D653B733D49692E5F6875653272676228692C652C742B312F33292C6F3D49692E5F6875653272676228692C652C74292C613D49692E5F6875653272676228692C652C742D312F33297D72657475726E206E6577204F69284D6174682E726F756E6428';
wwv_flow_imp.g_varchar2_table(2347) := '3235352A73292C4D6174682E726F756E64283235352A6F292C4D6174682E726F756E64283235352A61292C69297D7D636C6173732050697B636F6E7374727563746F7228652C742C6E2C72297B746869732E5F687376614272616E643D766F696420302C';
wwv_flow_imp.g_varchar2_table(2348) := '746869732E683D307C4D6174682E6D6178284D6174682E6D696E283336302C65292C30292C746869732E733D4D69284D6174682E6D6178284D6174682E6D696E28312C74292C30292C33292C746869732E763D4D69284D6174682E6D6178284D6174682E';
wwv_flow_imp.g_varchar2_table(2349) := '6D696E28312C6E292C30292C33292C746869732E613D4D69284D6174682E6D6178284D6174682E6D696E28312C72292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E683D3D3D742E682626652E733D3D3D742E73';
wwv_flow_imp.g_varchar2_table(2350) := '2626652E763D3D3D742E762626652E613D3D3D742E617D7374617469632066726F6D524742412865297B636F6E737420743D652E722F3235352C6E3D652E672F3235352C723D652E622F3235352C693D4D6174682E6D617828742C6E2C72292C733D692D';
wwv_flow_imp.g_varchar2_table(2351) := '4D6174682E6D696E28742C6E2C72292C6F3D303D3D3D693F303A732F693B6C657420613B72657475726E20613D303D3D3D733F303A693D3D3D743F28286E2D72292F7325362B362925363A693D3D3D6E3F28722D74292F732B323A28742D6E292F732B34';
wwv_flow_imp.g_varchar2_table(2352) := '2C6E6577205069284D6174682E726F756E642836302A61292C6F2C692C652E61297D73746174696320746F524742412865297B636F6E73747B683A742C733A6E2C763A722C613A697D3D652C733D722A6E2C6F3D732A28312D4D6174682E61627328742F';
wwv_flow_imp.g_varchar2_table(2353) := '363025322D3129292C613D722D733B6C65745B6C2C752C635D3D5B302C302C305D3B72657475726E20743C36303F286C3D732C753D6F293A743C3132303F286C3D6F2C753D73293A743C3138303F28753D732C633D6F293A743C3234303F28753D6F2C63';
wwv_flow_imp.g_varchar2_table(2354) := '3D73293A743C3330303F286C3D6F2C633D73293A743C3D3336302626286C3D732C633D6F292C6C3D4D6174682E726F756E64283235352A286C2B6129292C753D4D6174682E726F756E64283235352A28752B6129292C633D4D6174682E726F756E642832';
wwv_flow_imp.g_varchar2_table(2355) := '35352A28632B6129292C6E6577204F69286C2C752C632C69297D7D636C6173732046697B7374617469632066726F6D4865782865297B72657475726E2046692E466F726D61742E4353532E70617273654865782865297C7C46692E7265647D7374617469';
wwv_flow_imp.g_varchar2_table(2356) := '6320657175616C7328652C74297B72657475726E2165262621747C7C212821657C7C2174292626652E657175616C732874297D6765742068736C6128297B72657475726E20746869732E5F68736C613F746869732E5F68736C613A49692E66726F6D5247';
wwv_flow_imp.g_varchar2_table(2357) := '424128746869732E72676261297D676574206873766128297B72657475726E20746869732E5F687376613F746869732E5F687376613A50692E66726F6D5247424128746869732E72676261297D636F6E7374727563746F722865297B6966282165297468';
wwv_flow_imp.g_varchar2_table(2358) := '726F77206E6577204572726F722822436F6C6F72206E6565647320612076616C756522293B6966286520696E7374616E63656F66204F6929746869732E726762613D653B656C7365206966286520696E7374616E63656F6620496929746869732E5F6873';
wwv_flow_imp.g_varchar2_table(2359) := '6C613D652C746869732E726762613D49692E746F524742412865293B656C73657B69662821286520696E7374616E63656F6620506929297468726F77206E6577204572726F722822496E76616C696420636F6C6F722063746F7220617267756D656E7422';
wwv_flow_imp.g_varchar2_table(2360) := '293B746869732E5F687376613D652C746869732E726762613D50692E746F524742412865297D7D657175616C732865297B72657475726E21216526264F692E657175616C7328746869732E726762612C652E7267626129262649692E657175616C732874';
wwv_flow_imp.g_varchar2_table(2361) := '6869732E68736C612C652E68736C6129262650692E657175616C7328746869732E687376612C652E68737661297D67657452656C61746976654C756D696E616E636528297B72657475726E204D69282E323132362A46692E5F72656C61746976654C756D';
wwv_flow_imp.g_varchar2_table(2362) := '696E616E6365466F72436F6D706F6E656E7428746869732E726762612E72292B2E373135322A46692E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E67292B2E303732322A46692E5F72656C6174';
wwv_flow_imp.g_varchar2_table(2363) := '6976654C756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E62292C34297D737461746963205F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E742865297B636F6E737420743D652F3235353B72657475';
wwv_flow_imp.g_varchar2_table(2364) := '726E20743C3D2E30333932383F742F31322E39323A4D6174682E706F772828742B2E303535292F312E3035352C322E34297D69734C69676874657228297B72657475726E283239392A746869732E726762612E722B3538372A746869732E726762612E67';
wwv_flow_imp.g_varchar2_table(2365) := '2B3131342A746869732E726762612E62292F3165333E3D3132387D69734C6967687465725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E616E636528293E652E67657452656C61746976654C756D696E616E63';
wwv_flow_imp.g_varchar2_table(2366) := '6528297D69734461726B65725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E616E636528293C652E67657452656C61746976654C756D696E616E636528297D6C69676874656E2865297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(2367) := '77204669286E657720496928746869732E68736C612E682C746869732E68736C612E732C746869732E68736C612E6C2B746869732E68736C612E6C2A652C746869732E68736C612E6129297D6461726B656E2865297B72657475726E206E657720466928';
wwv_flow_imp.g_varchar2_table(2368) := '6E657720496928746869732E68736C612E682C746869732E68736C612E732C746869732E68736C612E6C2D746869732E68736C612E6C2A652C746869732E68736C612E6129297D7472616E73706172656E742865297B636F6E73747B723A742C673A6E2C';
wwv_flow_imp.g_varchar2_table(2369) := '623A722C613A697D3D746869732E726762613B72657475726E206E6577204669286E6577204F6928742C6E2C722C692A6529297D69735472616E73706172656E7428297B72657475726E20303D3D3D746869732E726762612E617D69734F706171756528';
wwv_flow_imp.g_varchar2_table(2370) := '297B72657475726E20313D3D3D746869732E726762612E617D6F70706F7369746528297B72657475726E206E6577204669286E6577204F69283235352D746869732E726762612E722C3235352D746869732E726762612E672C3235352D746869732E7267';
wwv_flow_imp.g_varchar2_table(2371) := '62612E622C746869732E726762612E6129297D6D616B654F70617175652865297B696628746869732E69734F706171756528297C7C31213D3D652E726762612E612972657475726E20746869733B636F6E73747B723A742C673A6E2C623A722C613A697D';
wwv_flow_imp.g_varchar2_table(2372) := '3D746869732E726762613B72657475726E206E6577204669286E6577204F6928652E726762612E722D692A28652E726762612E722D74292C652E726762612E672D692A28652E726762612E672D6E292C652E726762612E622D692A28652E726762612E62';
wwv_flow_imp.g_varchar2_table(2373) := '2D72292C3129297D746F537472696E6728297B72657475726E20746869732E5F746F537472696E677C7C28746869732E5F746F537472696E673D46692E466F726D61742E4353532E666F726D6174287468697329292C746869732E5F746F537472696E67';
wwv_flow_imp.g_varchar2_table(2374) := '7D737461746963206765744C696768746572436F6C6F7228652C742C6E297B696628652E69734C6967687465725468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E737420723D652E67657452656C61746976654C756D696E616E6365';
wwv_flow_imp.g_varchar2_table(2375) := '28292C693D742E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A28692D72292F692C652E6C69676874656E286E297D737461746963206765744461726B6572436F6C6F7228652C742C6E297B696628652E69734461';
wwv_flow_imp.g_varchar2_table(2376) := '726B65725468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E737420723D652E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A28722D742E67657452656C61746976654C756D696E616E63652829';
wwv_flow_imp.g_varchar2_table(2377) := '292F722C652E6461726B656E286E297D7D66756E6374696F6E2056692865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065297B636F6E737420653D4E756D626572286E293B28657C7C303D3D3D6526262222213D3D6E2E726570';
wwv_flow_imp.g_varchar2_table(2378) := '6C616365282F5C732F672C222229292626742E707573682865297D72657475726E20747D66756E6374696F6E20446928652C742C6E2C72297B72657475726E7B7265643A652F3235352C626C75653A6E2F3235352C677265656E3A742F3235352C616C70';
wwv_flow_imp.g_varchar2_table(2379) := '68613A727D7D66756E6374696F6E20716928652C74297B636F6E7374206E3D742E696E6465782C723D745B305D2E6C656E6774683B696628216E2972657475726E3B636F6E737420693D652E706F736974696F6E4174286E293B72657475726E7B737461';
wwv_flow_imp.g_varchar2_table(2380) := '72744C696E654E756D6265723A692E6C696E654E756D6265722C7374617274436F6C756D6E3A692E636F6C756D6E2C656E644C696E654E756D6265723A692E6C696E654E756D6265722C656E64436F6C756D6E3A692E636F6C756D6E2B727D7D66756E63';
wwv_flow_imp.g_varchar2_table(2381) := '74696F6E204B6928652C74297B69662821652972657475726E3B636F6E7374206E3D46692E466F726D61742E4353532E70617273654865782874293B72657475726E206E3F7B72616E67653A652C636F6C6F723A4469286E2E726762612E722C6E2E7267';
wwv_flow_imp.g_varchar2_table(2382) := '62612E672C6E2E726762612E622C6E2E726762612E61297D3A766F696420307D66756E6374696F6E206A6928652C742C6E297B69662821657C7C31213D3D742E6C656E6774682972657475726E3B636F6E737420723D566928745B305D2E76616C756573';
wwv_flow_imp.g_varchar2_table(2383) := '2829293B72657475726E7B72616E67653A652C636F6C6F723A446928725B305D2C725B315D2C725B325D2C6E3F725B335D3A31297D7D66756E6374696F6E20556928652C742C6E297B69662821657C7C31213D3D742E6C656E6774682972657475726E3B';
wwv_flow_imp.g_varchar2_table(2384) := '636F6E737420723D566928745B305D2E76616C7565732829292C693D6E6577204669286E657720496928725B305D2C725B315D2F3130302C725B325D2F3130302C6E3F725B335D3A3129293B72657475726E7B72616E67653A652C636F6C6F723A446928';
wwv_flow_imp.g_varchar2_table(2385) := '692E726762612E722C692E726762612E672C692E726762612E622C692E726762612E61297D7D66756E6374696F6E20426928652C74297B72657475726E22737472696E67223D3D747970656F6620653F5B2E2E2E652E6D61746368416C6C2874295D3A65';
wwv_flow_imp.g_varchar2_table(2386) := '2E66696E644D6174636865732874297D46692E77686974653D6E6577204669286E6577204F69283235352C3235352C3235352C3129292C46692E626C61636B3D6E6577204669286E6577204F6928302C302C302C3129292C46692E7265643D6E65772046';
wwv_flow_imp.g_varchar2_table(2387) := '69286E6577204F69283235352C302C302C3129292C46692E626C75653D6E6577204669286E6577204F6928302C302C3235352C3129292C46692E677265656E3D6E6577204669286E6577204F6928302C3235352C302C3129292C46692E6379616E3D6E65';
wwv_flow_imp.g_varchar2_table(2388) := '77204669286E6577204F6928302C3235352C3235352C3129292C46692E6C69676874677265793D6E6577204669286E6577204F69283231312C3231312C3231312C3129292C46692E7472616E73706172656E743D6E6577204669286E6577204F6928302C';
wwv_flow_imp.g_varchar2_table(2389) := '302C302C3029292C66756E6374696F6E2865297B6C657420743B2166756E6374696F6E2874297B6C6574206E3B2166756E6374696F6E2874297B66756E6374696F6E206E2865297B636F6E737420743D652E746F537472696E67283136293B7265747572';
wwv_flow_imp.g_varchar2_table(2390) := '6E2032213D3D742E6C656E6774683F2230222B743A747D66756E6374696F6E20722865297B7377697463682865297B636173652034383A72657475726E20303B636173652034393A72657475726E20313B636173652035303A72657475726E20323B6361';
wwv_flow_imp.g_varchar2_table(2391) := '73652035313A72657475726E20333B636173652035323A72657475726E20343B636173652035333A72657475726E20353B636173652035343A72657475726E20363B636173652035353A72657475726E20373B636173652035363A72657475726E20383B';
wwv_flow_imp.g_varchar2_table(2392) := '636173652035373A72657475726E20393B636173652039373A636173652036353A72657475726E2031303B636173652039383A636173652036363A72657475726E2031313B636173652039393A636173652036373A72657475726E2031323B6361736520';
wwv_flow_imp.g_varchar2_table(2393) := '3130303A636173652036383A72657475726E2031333B63617365203130313A636173652036393A72657475726E2031343B63617365203130323A636173652037303A72657475726E2031357D72657475726E20307D742E666F726D61745247423D66756E';
wwv_flow_imp.g_varchar2_table(2394) := '6374696F6E2874297B72657475726E20313D3D3D742E726762612E613F6072676228247B742E726762612E727D2C20247B742E726762612E677D2C20247B742E726762612E627D29603A652E466F726D61742E4353532E666F726D617452474241287429';
wwv_flow_imp.g_varchar2_table(2395) := '7D2C742E666F726D6174524742413D66756E6374696F6E2865297B72657475726E607267626128247B652E726762612E727D2C20247B652E726762612E677D2C20247B652E726762612E627D2C20247B2B652E726762612E612E746F4669786564283229';
wwv_flow_imp.g_varchar2_table(2396) := '7D29607D2C742E666F726D617448534C3D66756E6374696F6E2874297B72657475726E20313D3D3D742E68736C612E613F6068736C28247B742E68736C612E687D2C20247B283130302A742E68736C612E73292E746F46697865642832297D252C20247B';
wwv_flow_imp.g_varchar2_table(2397) := '283130302A742E68736C612E6C292E746F46697865642832297D2529603A652E466F726D61742E4353532E666F726D617448534C412874297D2C742E666F726D617448534C413D66756E6374696F6E2865297B72657475726E6068736C6128247B652E68';
wwv_flow_imp.g_varchar2_table(2398) := '736C612E687D2C20247B283130302A652E68736C612E73292E746F46697865642832297D252C20247B283130302A652E68736C612E6C292E746F46697865642832297D252C20247B652E68736C612E612E746F46697865642832297D29607D2C742E666F';
wwv_flow_imp.g_varchar2_table(2399) := '726D61744865783D66756E6374696F6E2865297B72657475726E6023247B6E28652E726762612E72297D247B6E28652E726762612E67297D247B6E28652E726762612E62297D607D2C742E666F726D6174486578413D66756E6374696F6E28742C723D21';
wwv_flow_imp.g_varchar2_table(2400) := '31297B72657475726E20722626313D3D3D742E726762612E613F652E466F726D61742E4353532E666F726D61744865782874293A6023247B6E28742E726762612E72297D247B6E28742E726762612E67297D247B6E28742E726762612E62297D247B6E28';
wwv_flow_imp.g_varchar2_table(2401) := '4D6174682E726F756E64283235352A742E726762612E6129297D607D2C742E666F726D61743D66756E6374696F6E2874297B72657475726E20742E69734F706171756528293F652E466F726D61742E4353532E666F726D61744865782874293A652E466F';
wwv_flow_imp.g_varchar2_table(2402) := '726D61742E4353532E666F726D6174524742412874297D2C742E70617273654865783D66756E6374696F6E2874297B636F6E7374206E3D742E6C656E6774683B696628303D3D3D6E2972657475726E206E756C6C3B6966283335213D3D742E6368617243';
wwv_flow_imp.g_varchar2_table(2403) := '6F646541742830292972657475726E206E756C6C3B696628373D3D3D6E297B636F6E7374206E3D31362A7228742E63686172436F64654174283129292B7228742E63686172436F64654174283229292C693D31362A7228742E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(2404) := '3329292B7228742E63686172436F64654174283429292C733D31362A7228742E63686172436F64654174283529292B7228742E63686172436F64654174283629293B72657475726E206E65772065286E6577204F69286E2C692C732C3129297D69662839';
wwv_flow_imp.g_varchar2_table(2405) := '3D3D3D6E297B636F6E7374206E3D31362A7228742E63686172436F64654174283129292B7228742E63686172436F64654174283229292C693D31362A7228742E63686172436F64654174283329292B7228742E63686172436F64654174283429292C733D';
wwv_flow_imp.g_varchar2_table(2406) := '31362A7228742E63686172436F64654174283529292B7228742E63686172436F64654174283629292C6F3D31362A7228742E63686172436F64654174283729292B7228742E63686172436F64654174283829293B72657475726E206E65772065286E6577';
wwv_flow_imp.g_varchar2_table(2407) := '204F69286E2C692C732C6F2F32353529297D696628343D3D3D6E297B636F6E7374206E3D7228742E63686172436F64654174283129292C693D7228742E63686172436F64654174283229292C733D7228742E63686172436F64654174283329293B726574';
wwv_flow_imp.g_varchar2_table(2408) := '75726E206E65772065286E6577204F692831362A6E2B6E2C31362A692B692C31362A732B7329297D696628353D3D3D6E297B636F6E7374206E3D7228742E63686172436F64654174283129292C693D7228742E63686172436F64654174283229292C733D';
wwv_flow_imp.g_varchar2_table(2409) := '7228742E63686172436F64654174283329292C6F3D7228742E63686172436F64654174283429293B72657475726E206E65772065286E6577204F692831362A6E2B6E2C31362A692B692C31362A732B732C2831362A6F2B6F292F32353529297D72657475';
wwv_flow_imp.g_varchar2_table(2410) := '726E206E756C6C7D7D286E3D742E4353537C7C28742E4353533D7B7D29297D28743D652E466F726D61747C7C28652E466F726D61743D7B7D29297D2846697C7C2846693D7B7D29293B636F6E73742024693D2F5C624D41524B3A5C732A282E2A29242F64';
wwv_flow_imp.g_varchar2_table(2411) := '2C57693D2F5E2D2B7C2D2B242F673B66756E6374696F6E207A6928652C742C6E297B24692E6C617374496E6465783D303B636F6E737420723D24692E657865632865293B69662872297B636F6E737420653D7B73746172744C696E654E756D6265723A74';
wwv_flow_imp.g_varchar2_table(2412) := '2C7374617274436F6C756D6E3A722E696E64696365735B315D5B305D2B312C656E644C696E654E756D6265723A742C656E64436F6C756D6E3A722E696E64696365735B315D5B315D2B317D3B696628652E656E64436F6C756D6E3E652E7374617274436F';
wwv_flow_imp.g_varchar2_table(2413) := '6C756D6E297B636F6E737420743D7B72616E67653A652C2E2E2E486928725B315D292C73686F756C644265496E436F6D6D656E74733A21307D3B28742E746578747C7C742E686173536570617261746F724C696E652926266E2E707573682874297D7D7D';
wwv_flow_imp.g_varchar2_table(2414) := '66756E6374696F6E2048692865297B636F6E737420743D28653D652E7472696D2829292E7374617274735769746828222D22293B72657475726E7B746578743A653D652E7265706C6163652857692C2222292C686173536570617261746F724C696E653A';
wwv_flow_imp.g_varchar2_table(2415) := '747D7D636C61737320476920657874656E6473204D747B6765742075726928297B72657475726E20746869732E5F7572697D67657420656F6C28297B72657475726E20746869732E5F656F6C7D67657456616C756528297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(2416) := '6765745465787428297D66696E644D6174636865732865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C746869732E5F6C696E65732E6C656E6774683B6E2B2B297B636F6E737420723D746869732E5F6C696E65735B6E5D2C693D74';
wwv_flow_imp.g_varchar2_table(2417) := '6869732E6F66667365744174286E6577207774286E2B312C3129292C733D722E6D61746368416C6C2865293B666F7228636F6E73742065206F6620732928652E696E6465787C7C303D3D3D652E696E64657829262628652E696E6465783D652E696E6465';
wwv_flow_imp.g_varchar2_table(2418) := '782B69292C742E707573682865297D72657475726E20747D6765744C696E6573436F6E74656E7428297B72657475726E20746869732E5F6C696E65732E736C6963652830297D6765744C696E65436F756E7428297B72657475726E20746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(2419) := '6E65732E6C656E6774687D6765744C696E65436F6E74656E742865297B72657475726E20746869732E5F6C696E65735B652D315D7D676574576F72644174506F736974696F6E28652C74297B636F6E7374206E3D467428652E636F6C756D6E2C49742874';
wwv_flow_imp.g_varchar2_table(2420) := '292C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2C30293B72657475726E206E3F6E657720537428652E6C696E654E756D6265722C6E2E7374617274436F6C756D6E2C652E6C696E654E756D6265722C6E2E656E64436F6C756D6E';
wwv_flow_imp.g_varchar2_table(2421) := '293A6E756C6C7D776F7264732865297B636F6E737420743D746869732E5F6C696E65732C6E3D746869732E5F776F7264656E697A652E62696E642874686973293B6C657420723D302C693D22222C733D302C6F3D5B5D3B72657475726E7B2A5B53796D62';
wwv_flow_imp.g_varchar2_table(2422) := '6F6C2E6974657261746F725D28297B666F72283B3B29696628733C6F2E6C656E677468297B636F6E737420653D692E737562737472696E67286F5B735D2E73746172742C6F5B735D2E656E64293B732B3D312C7969656C6420657D656C73657B69662821';
wwv_flow_imp.g_varchar2_table(2423) := '28723C742E6C656E6774682929627265616B3B693D745B725D2C6F3D6E28692C65292C733D302C722B3D317D7D7D7D6765744C696E65576F72647328652C74297B636F6E7374206E3D746869732E5F6C696E65735B652D315D2C723D746869732E5F776F';
wwv_flow_imp.g_varchar2_table(2424) := '7264656E697A65286E2C74292C693D5B5D3B666F7228636F6E73742065206F66207229692E70757368287B776F72643A6E2E737562737472696E6728652E73746172742C652E656E64292C7374617274436F6C756D6E3A652E73746172742B312C656E64';
wwv_flow_imp.g_varchar2_table(2425) := '436F6C756D6E3A652E656E642B317D293B72657475726E20697D5F776F7264656E697A6528652C74297B636F6E7374206E3D5B5D3B6C657420723B666F7228742E6C617374496E6465783D303B28723D742E6578656328652929262630213D3D725B305D';
wwv_flow_imp.g_varchar2_table(2426) := '2E6C656E6774683B296E2E70757368287B73746172743A722E696E6465782C656E643A722E696E6465782B725B305D2E6C656E6774687D293B72657475726E206E7D67657456616C7565496E52616E67652865297B69662828653D746869732E5F76616C';
wwv_flow_imp.g_varchar2_table(2427) := '696461746552616E6765286529292E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722972657475726E20746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E672865';
wwv_flow_imp.g_varchar2_table(2428) := '2E7374617274436F6C756D6E2D312C652E656E64436F6C756D6E2D31293B636F6E737420743D746869732E5F656F6C2C6E3D652E73746172744C696E654E756D6265722D312C723D652E656E644C696E654E756D6265722D312C693D5B5D3B692E707573';
wwv_flow_imp.g_varchar2_table(2429) := '6828746869732E5F6C696E65735B6E5D2E737562737472696E6728652E7374617274436F6C756D6E2D3129293B666F72286C657420653D6E2B313B653C723B652B2B29692E7075736828746869732E5F6C696E65735B655D293B72657475726E20692E70';
wwv_flow_imp.g_varchar2_table(2430) := '75736828746869732E5F6C696E65735B725D2E737562737472696E6728302C652E656E64436F6C756D6E2D3129292C692E6A6F696E2874297D6F666673657441742865297B72657475726E20653D746869732E5F76616C6964617465506F736974696F6E';
wwv_flow_imp.g_varchar2_table(2431) := '2865292C746869732E5F656E737572654C696E6553746172747328292C746869732E5F6C696E655374617274732E67657450726566697853756D28652E6C696E654E756D6265722D32292B28652E636F6C756D6E2D31297D706F736974696F6E41742865';
wwv_flow_imp.g_varchar2_table(2432) := '297B653D4D6174682E666C6F6F722865292C653D4D6174682E6D617828302C65292C746869732E5F656E737572654C696E6553746172747328293B636F6E737420743D746869732E5F6C696E655374617274732E676574496E6465784F662865292C6E3D';
wwv_flow_imp.g_varchar2_table(2433) := '746869732E5F6C696E65735B742E696E6465785D2E6C656E6774683B72657475726E7B6C696E654E756D6265723A312B742E696E6465782C636F6C756D6E3A312B4D6174682E6D696E28742E72656D61696E6465722C6E297D7D5F76616C696461746552';
wwv_flow_imp.g_varchar2_table(2434) := '616E67652865297B636F6E737420743D746869732E5F76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E73746172744C696E654E756D6265722C636F6C756D6E3A652E7374617274436F6C756D6E7D292C6E3D746869732E5F';
wwv_flow_imp.g_varchar2_table(2435) := '76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E656E644C696E654E756D6265722C636F6C756D6E3A652E656E64436F6C756D6E7D293B72657475726E20742E6C696E654E756D626572213D3D652E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(2436) := '756D6265727C7C742E636F6C756D6E213D3D652E7374617274436F6C756D6E7C7C6E2E6C696E654E756D626572213D3D652E656E644C696E654E756D6265727C7C6E2E636F6C756D6E213D3D652E656E64436F6C756D6E3F7B73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(2437) := '6D6265723A742E6C696E654E756D6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D3A657D5F76616C6964617465506F73';
wwv_flow_imp.g_varchar2_table(2438) := '6974696F6E2865297B6966282177742E697349506F736974696F6E286529297468726F77206E6577204572726F72282262616420706F736974696F6E22293B6C65747B6C696E654E756D6265723A742C636F6C756D6E3A6E7D3D652C723D21313B696628';
wwv_flow_imp.g_varchar2_table(2439) := '743C3129743D312C6E3D312C723D21303B656C736520696628743E746869732E5F6C696E65732E6C656E67746829743D746869732E5F6C696E65732E6C656E6774682C6E3D746869732E5F6C696E65735B742D315D2E6C656E6774682B312C723D21303B';
wwv_flow_imp.g_varchar2_table(2440) := '656C73657B636F6E737420653D746869732E5F6C696E65735B742D315D2E6C656E6774682B313B6E3C313F286E3D312C723D2130293A6E3E652626286E3D652C723D2130297D72657475726E20723F7B6C696E654E756D6265723A742C636F6C756D6E3A';
wwv_flow_imp.g_varchar2_table(2441) := '6E7D3A657D7D636C617373204A697B636F6E7374727563746F7228652C74297B746869732E5F686F73743D652C746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C292C746869732E5F666F726569676E4D6F64756C65466163';
wwv_flow_imp.g_varchar2_table(2442) := '746F72793D742C746869732E5F666F726569676E4D6F64756C653D6E756C6C7D646973706F736528297B746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C297D5F6765744D6F64656C2865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(2443) := '5F6D6F64656C735B655D7D5F6765744D6F64656C7328297B636F6E737420653D5B5D3B72657475726E204F626A6563742E6B65797328746869732E5F6D6F64656C73292E666F72456163682828743D3E652E7075736828746869732E5F6D6F64656C735B';
wwv_flow_imp.g_varchar2_table(2444) := '745D2929292C657D6163636570744E65774D6F64656C2865297B746869732E5F6D6F64656C735B652E75726C5D3D6E65772047692868742E706172736528652E75726C292C652E6C696E65732C652E454F4C2C652E76657273696F6E4964297D61636365';
wwv_flow_imp.g_varchar2_table(2445) := '70744D6F64656C4368616E67656428652C74297B746869732E5F6D6F64656C735B655D2626746869732E5F6D6F64656C735B655D2E6F6E4576656E74732874297D61636365707452656D6F7665644D6F64656C2865297B746869732E5F6D6F64656C735B';
wwv_flow_imp.g_varchar2_table(2446) := '655D262664656C65746520746869732E5F6D6F64656C735B655D7D6173796E6320636F6D70757465556E69636F6465486967686C696768747328652C742C6E297B636F6E737420723D746869732E5F6765744D6F64656C2865293B72657475726E20723F';
wwv_flow_imp.g_varchar2_table(2447) := '4F722E636F6D70757465556E69636F6465486967686C696768747328722C742C6E293A7B72616E6765733A5B5D2C6861734D6F72653A21312C616D626967756F7573436861726163746572436F756E743A302C696E76697369626C654368617261637465';
wwv_flow_imp.g_varchar2_table(2448) := '72436F756E743A302C6E6F6E42617369634173636969436861726163746572436F756E743A307D7D6173796E632066696E6453656374696F6E4865616465727328652C74297B636F6E7374206E3D746869732E5F6765744D6F64656C2865293B72657475';
wwv_flow_imp.g_varchar2_table(2449) := '726E206E3F66756E6374696F6E28652C74297B766172206E3B6C657420723D5B5D3B696628742E66696E64526567696F6E53656374696F6E486561646572732626286E756C6C3D3D3D286E3D742E666F6C64696E6752756C6573297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(2450) := '3D3D6E3F766F696420303A6E2E6D61726B65727329297B636F6E7374206E3D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D2C723D652E6765744C696E65436F756E7428293B666F72286C657420693D313B693C3D723B692B2B297B636F6E';
wwv_flow_imp.g_varchar2_table(2451) := '737420723D652E6765744C696E65436F6E74656E742869292C733D722E6D6174636828742E666F6C64696E6752756C65732E6D61726B6572732E7374617274293B69662873297B636F6E737420653D7B73746172744C696E654E756D6265723A692C7374';
wwv_flow_imp.g_varchar2_table(2452) := '617274436F6C756D6E3A735B305D2E6C656E6774682B312C656E644C696E654E756D6265723A692C656E64436F6C756D6E3A722E6C656E6774682B317D3B696628652E656E64436F6C756D6E3E652E7374617274436F6C756D6E297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(2453) := '7B72616E67653A652C2E2E2E486928722E737562737472696E6728735B305D2E6C656E67746829292C73686F756C644265496E436F6D6D656E74733A21317D3B28742E746578747C7C742E686173536570617261746F724C696E652926266E2E70757368';
wwv_flow_imp.g_varchar2_table(2454) := '2874297D7D7D72657475726E206E7D28652C74293B723D722E636F6E636174286E297D696628742E66696E644D61726B53656374696F6E48656164657273297B636F6E737420743D66756E6374696F6E2865297B636F6E737420743D5B5D2C6E3D652E67';
wwv_flow_imp.g_varchar2_table(2455) := '65744C696E65436F756E7428293B666F72286C657420723D313B723C3D6E3B722B2B297A6928652E6765744C696E65436F6E74656E742872292C722C74293B72657475726E20747D2865293B723D722E636F6E6361742874297D72657475726E20727D28';
wwv_flow_imp.g_varchar2_table(2456) := '6E2C74293A5B5D7D6173796E6320636F6D707574654469666628652C742C6E2C72297B636F6E737420693D746869732E5F6765744D6F64656C2865292C733D746869732E5F6765744D6F64656C2874293B72657475726E20692626733F4A692E636F6D70';
wwv_flow_imp.g_varchar2_table(2457) := '7574654469666628692C732C6E2C72293A6E756C6C7D73746174696320636F6D707574654469666628652C742C6E2C72297B636F6E737420693D22616476616E636564223D3D3D723F6E65772052693A6E65772058722C733D652E6765744C696E657343';
wwv_flow_imp.g_varchar2_table(2458) := '6F6E74656E7428292C6F3D742E6765744C696E6573436F6E74656E7428292C613D692E636F6D707574654469666628732C6F2C6E293B66756E6374696F6E206C2865297B72657475726E20652E6D61702828653D3E7B76617220743B72657475726E5B65';
wwv_flow_imp.g_varchar2_table(2459) := '2E6F726967696E616C2E73746172744C696E654E756D6265722C652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6D6F6469666965642E73746172744C696E654E756D6265722C652E6D6F6469666965642E656E';
wwv_flow_imp.g_varchar2_table(2460) := '644C696E654E756D6265724578636C75736976652C6E756C6C3D3D3D28743D652E696E6E65724368616E676573297C7C766F696420303D3D3D743F766F696420303A742E6D61702828653D3E5B652E6F726967696E616C52616E67652E73746172744C69';
wwv_flow_imp.g_varchar2_table(2461) := '6E654E756D6265722C652E6F726967696E616C52616E67652E7374617274436F6C756D6E2C652E6F726967696E616C52616E67652E656E644C696E654E756D6265722C652E6F726967696E616C52616E67652E656E64436F6C756D6E2C652E6D6F646966';
wwv_flow_imp.g_varchar2_table(2462) := '69656452616E67652E73746172744C696E654E756D6265722C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2C652E6D6F64696669656452616E67652E656E644C696E654E756D6265722C652E6D6F64696669656452616E67652E65';
wwv_flow_imp.g_varchar2_table(2463) := '6E64436F6C756D6E5D29295D7D29297D72657475726E7B6964656E746963616C3A2128612E6368616E6765732E6C656E6774683E30292626746869732E5F6D6F64656C734172654964656E746963616C28652C74292C717569744561726C793A612E6869';
wwv_flow_imp.g_varchar2_table(2464) := '7454696D656F75742C6368616E6765733A6C28612E6368616E676573292C6D6F7665733A612E6D6F7665732E6D61702828653D3E5B652E6C696E6552616E67654D617070696E672E6F726967696E616C2E73746172744C696E654E756D6265722C652E6C';
wwv_flow_imp.g_varchar2_table(2465) := '696E6552616E67654D617070696E672E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D6265722C652E6C696E655261';
wwv_flow_imp.g_varchar2_table(2466) := '6E67654D617070696E672E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6C28652E6368616E676573295D29297D7D737461746963205F6D6F64656C734172654964656E746963616C28652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(2467) := '652E6765744C696E65436F756E7428293B6966286E213D3D742E6765744C696E65436F756E7428292972657475726E21313B666F72286C657420723D313B723C3D6E3B722B2B29696628652E6765744C696E65436F6E74656E74287229213D3D742E6765';
wwv_flow_imp.g_varchar2_table(2468) := '744C696E65436F6E74656E742872292972657475726E21313B72657475726E21307D6173796E6320636F6D707574654D6F72654D696E696D616C456469747328652C742C6E297B636F6E737420723D746869732E5F6765744D6F64656C2865293B696628';
wwv_flow_imp.g_varchar2_table(2469) := '21722972657475726E20743B636F6E737420693D5B5D3B6C657420733B743D742E736C6963652830292E736F7274282828652C74293D3E652E72616E67652626742E72616E67653F53742E636F6D7061726552616E6765735573696E6753746172747328';
wwv_flow_imp.g_varchar2_table(2470) := '652E72616E67652C742E72616E6765293A28652E72616E67653F303A31292D28742E72616E67653F303A312929293B6C6574206F3D303B666F72286C657420653D313B653C742E6C656E6774683B652B2B2953742E676574456E64506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(2471) := '745B6F5D2E72616E6765292E657175616C732853742E6765745374617274506F736974696F6E28745B655D2E72616E676529293F28745B6F5D2E72616E67653D53742E66726F6D506F736974696F6E732853742E6765745374617274506F736974696F6E';
wwv_flow_imp.g_varchar2_table(2472) := '28745B6F5D2E72616E6765292C53742E676574456E64506F736974696F6E28745B655D2E72616E676529292C745B6F5D2E746578742B3D745B655D2E74657874293A286F2B2B2C745B6F5D3D745B655D293B742E6C656E6774683D6F2B313B666F72286C';
wwv_flow_imp.g_varchar2_table(2473) := '65747B72616E67653A652C746578743A6F2C656F6C3A617D6F662074297B696628226E756D626572223D3D747970656F662061262628733D61292C53742E6973456D7074792865292626216F29636F6E74696E75653B636F6E737420743D722E67657456';
wwv_flow_imp.g_varchar2_table(2474) := '616C7565496E52616E67652865293B6966286F3D6F2E7265706C616365282F5C725C6E7C5C6E7C5C722F672C722E656F6C292C743D3D3D6F29636F6E74696E75653B6966284D6174682E6D6178286F2E6C656E6774682C742E6C656E677468293E4A692E';
wwv_flow_imp.g_varchar2_table(2475) := '5F646966664C696D6974297B692E70757368287B72616E67653A652C746578743A6F7D293B636F6E74696E75657D636F6E7374206C3D506528742C6F2C6E292C753D722E6F666673657441742853742E6C6966742865292E6765745374617274506F7369';
wwv_flow_imp.g_varchar2_table(2476) := '74696F6E2829293B666F7228636F6E73742065206F66206C297B636F6E737420743D722E706F736974696F6E417428752B652E6F726967696E616C5374617274292C6E3D722E706F736974696F6E417428752B652E6F726967696E616C53746172742B65';
wwv_flow_imp.g_varchar2_table(2477) := '2E6F726967696E616C4C656E677468292C733D7B746578743A6F2E73756273747228652E6D6F64696669656453746172742C652E6D6F6469666965644C656E677468292C72616E67653A7B73746172744C696E654E756D6265723A742E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(2478) := '6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D7D3B722E67657456616C7565496E52616E676528732E72616E67652921';
wwv_flow_imp.g_varchar2_table(2479) := '3D3D732E746578742626692E707573682873297D7D72657475726E226E756D626572223D3D747970656F6620732626692E70757368287B656F6C3A732C746578743A22222C72616E67653A7B73746172744C696E654E756D6265723A302C737461727443';
wwv_flow_imp.g_varchar2_table(2480) := '6F6C756D6E3A302C656E644C696E654E756D6265723A302C656E64436F6C756D6E3A307D7D292C697D6173796E6320636F6D707574654C696E6B732865297B636F6E737420743D746869732E5F6765744D6F64656C2865293B72657475726E20743F6675';
wwv_flow_imp.g_varchar2_table(2481) := '6E6374696F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F756E7426262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F6E74656E743F42742E636F6D707574';
wwv_flow_imp.g_varchar2_table(2482) := '654C696E6B732865293A5B5D7D2874293A6E756C6C7D6173796E6320636F6D7075746544656661756C74446F63756D656E74436F6C6F72732865297B636F6E737420743D746869732E5F6765744D6F64656C2865293B72657475726E20743F66756E6374';
wwv_flow_imp.g_varchar2_table(2483) := '696F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E67657456616C756526262266756E6374696F6E223D3D747970656F6620652E706F736974696F6E41743F66756E6374696F6E2865297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(2484) := '5B5D2C6E3D426928652C2F5C62287267627C726762617C68736C7C68736C6129285C285B302D395C732C2E5C255D2A5C29297C282329285B412D46612D66302D395D7B337D295C627C282329285B412D46612D66302D395D7B347D295C627C282329285B';
wwv_flow_imp.g_varchar2_table(2485) := '412D46612D66302D395D7B367D295C627C282329285B412D46612D66302D395D7B387D295C622F676D293B6966286E2E6C656E6774683E3029666F7228636F6E73742072206F66206E297B636F6E7374206E3D722E66696C7465722828653D3E766F6964';
wwv_flow_imp.g_varchar2_table(2486) := '2030213D3D6529292C693D6E5B315D2C733D6E5B325D3B696628217329636F6E74696E75653B6C6574206F3B69662822726762223D3D3D69297B636F6E737420743D2F5E5C285C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D';
wwv_flow_imp.g_varchar2_table(2487) := '7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B30';
wwv_flow_imp.g_varchar2_table(2488) := '2D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A5C29242F676D3B6F3D6A6928716928652C72292C426928732C74292C2131297D656C7365206966282272676261223D3D3D69297B636F6E737420743D2F5E5C285C73';
wwv_flow_imp.g_varchar2_table(2489) := '2A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B30';
wwv_flow_imp.g_varchar2_table(2490) := '2D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A28305B2E5D5B302D395D2B7C5B2E5D5B302D395D2B7C5B30315D5B2E5D7C5B30315D';
wwv_flow_imp.g_varchar2_table(2491) := '295C732A5C29242F676D3B6F3D6A6928716928652C72292C426928732C74292C2130297D656C7365206966282268736C223D3D3D69297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D395D7C5B31325D5B302D395D5B30';
wwv_flow_imp.g_varchar2_table(2492) := '2D395D7C5B312D395D3F5B302D395D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A5C29242F676D3B6F3D5569';
wwv_flow_imp.g_varchar2_table(2493) := '28716928652C72292C426928732C74292C2131297D656C7365206966282268736C61223D3D3D69297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D395D7C5B31325D5B302D395D5B302D395D7C5B312D395D3F5B302D39';
wwv_flow_imp.g_varchar2_table(2494) := '5D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A28305B2E5D5B302D395D2B7C5B2E5D5B302D395D2B';
wwv_flow_imp.g_varchar2_table(2495) := '7C5B30315D5B2E5D7C5B30315D295C732A5C29242F676D3B6F3D556928716928652C72292C426928732C74292C2130297D656C73652223223D3D3D692626286F3D4B6928716928652C72292C692B7329293B6F2626742E70757368286F297D7265747572';
wwv_flow_imp.g_varchar2_table(2496) := '6E20747D2865293A5B5D7D2874293A6E756C6C7D6173796E63207465787475616C5375676765737428652C742C6E2C72297B636F6E737420693D6E6577205F2C733D6E657720526567457870286E2C72292C6F3D6E6577205365743B653A666F7228636F';
wwv_flow_imp.g_varchar2_table(2497) := '6E7374206E206F662065297B636F6E737420653D746869732E5F6765744D6F64656C286E293B6966286529666F7228636F6E7374206E206F6620652E776F726473287329296966286E213D3D74262669734E614E284E756D626572286E29292626286F2E';
wwv_flow_imp.g_varchar2_table(2498) := '616464286E292C6F2E73697A653E4A692E5F73756767657374696F6E734C696D69742929627265616B20657D72657475726E7B776F7264733A41727261792E66726F6D286F292C6475726174696F6E3A692E656C617073656428297D7D6173796E632063';
wwv_flow_imp.g_varchar2_table(2499) := '6F6D70757465576F726452616E67657328652C742C6E2C72297B636F6E737420693D746869732E5F6765744D6F64656C2865293B69662821692972657475726E204F626A6563742E637265617465286E756C6C293B636F6E737420733D6E657720526567';
wwv_flow_imp.g_varchar2_table(2500) := '457870286E2C72292C6F3D4F626A6563742E637265617465286E756C6C293B666F72286C657420653D742E73746172744C696E654E756D6265723B653C742E656E644C696E654E756D6265723B652B2B297B636F6E737420743D692E6765744C696E6557';
wwv_flow_imp.g_varchar2_table(2501) := '6F72647328652C73293B666F7228636F6E7374206E206F662074297B6966282169734E614E284E756D626572286E2E776F7264292929636F6E74696E75653B6C657420743D6F5B6E2E776F72645D3B747C7C28743D5B5D2C6F5B6E2E776F72645D3D7429';
wwv_flow_imp.g_varchar2_table(2502) := '2C742E70757368287B73746172744C696E654E756D6265723A652C7374617274436F6C756D6E3A6E2E7374617274436F6C756D6E2C656E644C696E654E756D6265723A652C656E64436F6C756D6E3A6E2E656E64436F6C756D6E7D297D7D72657475726E';
wwv_flow_imp.g_varchar2_table(2503) := '206F7D6173796E63206E6176696761746556616C756553657428652C742C6E2C722C69297B636F6E737420733D746869732E5F6765744D6F64656C2865293B69662821732972657475726E206E756C6C3B636F6E7374206F3D6E65772052656745787028';
wwv_flow_imp.g_varchar2_table(2504) := '722C69293B742E7374617274436F6C756D6E3D3D3D742E656E64436F6C756D6E262628743D7B73746172744C696E654E756D6265723A742E73746172744C696E654E756D6265722C7374617274436F6C756D6E3A742E7374617274436F6C756D6E2C656E';
wwv_flow_imp.g_varchar2_table(2505) := '644C696E654E756D6265723A742E656E644C696E654E756D6265722C656E64436F6C756D6E3A742E656E64436F6C756D6E2B317D293B636F6E737420613D732E67657456616C7565496E52616E67652874292C6C3D732E676574576F72644174506F7369';
wwv_flow_imp.g_varchar2_table(2506) := '74696F6E287B6C696E654E756D6265723A742E73746172744C696E654E756D6265722C636F6C756D6E3A742E7374617274436F6C756D6E7D2C6F293B696628216C2972657475726E206E756C6C3B636F6E737420753D732E67657456616C7565496E5261';
wwv_flow_imp.g_varchar2_table(2507) := '6E6765286C293B72657475726E2024742E494E5354414E43452E6E6176696761746556616C756553657428742C612C6C2C752C6E297D6C6F6164466F726569676E4D6F64756C6528652C742C6E297B636F6E737420723D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(2508) := '7B636F6E7374206E3D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B72657475726E207428652C6E297D2C723D7B7D3B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(2509) := '2074206F66206529725B745D3D6E2874293B72657475726E20727D286E2C2828652C74293D3E746869732E5F686F73742E66687228652C742929292C693D7B686F73743A722C6765744D6972726F724D6F64656C733A28293D3E746869732E5F6765744D';
wwv_flow_imp.g_varchar2_table(2510) := '6F64656C7328297D3B72657475726E20746869732E5F666F726569676E4D6F64756C65466163746F72793F28746869732E5F666F726569676E4D6F64756C653D746869732E5F666F726569676E4D6F64756C65466163746F727928692C74292C50726F6D';
wwv_flow_imp.g_varchar2_table(2511) := '6973652E7265736F6C7665284128746869732E5F666F726569676E4D6F64756C652929293A50726F6D6973652E72656A656374286E6577204572726F722822556E65787065637465642075736167652229297D666D7228652C74297B6966282174686973';
wwv_flow_imp.g_varchar2_table(2512) := '2E5F666F726569676E4D6F64756C657C7C2266756E6374696F6E22213D747970656F6620746869732E5F666F726569676E4D6F64756C655B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E6720';
wwv_flow_imp.g_varchar2_table(2513) := '7265717565737448616E646C6572206F72206D6574686F643A20222B6529293B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F666F726569676E4D6F64756C655B655D2E6170706C7928746869732E5F666F72656967';
wwv_flow_imp.g_varchar2_table(2514) := '6E4D6F64756C652C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D7D4A692E5F646966664C696D69743D3165352C4A692E5F73756767657374696F6E734C696D69743D3165342C2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2515) := '223D3D747970656F6620696D706F727453637269707473262628676C6F62616C546869732E6D6F6E61636F3D7B656469746F723A766F696420302C6C616E6775616765733A766F696420302C43616E63656C6C6174696F6E546F6B656E536F757263653A';
wwv_flow_imp.g_varchar2_table(2516) := '636C6173737B636F6E7374727563746F722865297B746869732E5F746F6B656E3D766F696420302C746869732E5F706172656E744C697374656E65723D766F696420302C746869732E5F706172656E744C697374656E65723D652626652E6F6E43616E63';
wwv_flow_imp.g_varchar2_table(2517) := '656C6C6174696F6E52657175657374656428746869732E63616E63656C2C74686973297D67657420746F6B656E28297B72657475726E20746869732E5F746F6B656E7C7C28746869732E5F746F6B656E3D6E6577204874292C746869732E5F746F6B656E';
wwv_flow_imp.g_varchar2_table(2518) := '7D63616E63656C28297B746869732E5F746F6B656E3F746869732E5F746F6B656E20696E7374616E63656F662048742626746869732E5F746F6B656E2E63616E63656C28293A746869732E5F746F6B656E3D7A742E43616E63656C6C65647D646973706F';
wwv_flow_imp.g_varchar2_table(2519) := '736528653D2131297B76617220743B652626746869732E63616E63656C28292C6E756C6C3D3D3D28743D746869732E5F706172656E744C697374656E6572297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E5F746F6B656E';
wwv_flow_imp.g_varchar2_table(2520) := '3F746869732E5F746F6B656E20696E7374616E63656F662048742626746869732E5F746F6B656E2E646973706F736528293A746869732E5F746F6B656E3D7A742E4E6F6E657D7D2C456D69747465723A782C4B6579436F64653A576E2C4B65794D6F643A';
wwv_flow_imp.g_varchar2_table(2521) := '77722C506F736974696F6E3A77742C52616E67653A53742C53656C656374696F6E3A616E2C53656C656374696F6E446972656374696F6E3A61722C4D61726B657253657665726974793A7A6E2C4D61726B65725461673A486E2C5572693A68742C546F6B';
wwv_flow_imp.g_varchar2_table(2522) := '656E3A636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E6F66667365743D652C746869732E747970653D742C746869732E6C616E67756167653D6E2C746869732E5F746F6B656E4272616E643D766F696420307D746F53747269';
wwv_flow_imp.g_varchar2_table(2523) := '6E6728297B72657475726E2228222B746869732E6F66667365742B222C20222B746869732E747970652B2229227D7D7D293B6C65742058693D21313B66756E6374696F6E2051692865297B69662858692972657475726E3B58693D21303B636F6E737420';
wwv_flow_imp.g_varchar2_table(2524) := '743D6E65772078652828653D3E7B676C6F62616C546869732E706F73744D6573736167652865297D292C28743D3E6E6577204A6928742C652929293B676C6F62616C546869732E6F6E6D6573736167653D653D3E7B742E6F6E6D65737361676528652E64';
wwv_flow_imp.g_varchar2_table(2525) := '617461297D7D66756E6374696F6E205A6928652C74297B766F696420303D3D3D74262628743D2131293B766172206E3D652E6C656E6774682C723D302C693D22222C733D302C6F3D31362C613D302C6C3D302C753D302C633D302C683D303B66756E6374';
wwv_flow_imp.g_varchar2_table(2526) := '696F6E206428742C6E297B666F722876617220693D302C733D303B693C747C7C216E3B297B766172206F3D652E63686172436F646541742872293B6966286F3E3D343826266F3C3D353729733D31362A732B6F2D34383B656C7365206966286F3E3D3635';
wwv_flow_imp.g_varchar2_table(2527) := '26266F3C3D373029733D31362A732B6F2D36352B31303B656C73657B69662821286F3E3D393726266F3C3D3130322929627265616B3B733D31362A732B6F2D39372B31307D722B2B2C692B2B7D72657475726E20693C74262628733D2D31292C737D6675';
wwv_flow_imp.g_varchar2_table(2528) := '6E6374696F6E206628297B696628693D22222C683D302C733D722C6C3D612C633D752C723E3D6E2972657475726E20733D6E2C6F3D31373B76617220743D652E63686172436F646541742872293B6966285969287429297B646F7B722B2B2C692B3D5374';
wwv_flow_imp.g_varchar2_table(2529) := '72696E672E66726F6D43686172436F64652874292C743D652E63686172436F646541742872297D7768696C65285969287429293B72657475726E206F3D31357D69662865732874292972657475726E20722B2B2C692B3D537472696E672E66726F6D4368';
wwv_flow_imp.g_varchar2_table(2530) := '6172436F64652874292C31333D3D3D74262631303D3D3D652E63686172436F64654174287229262628722B2B2C692B3D225C6E22292C612B2B2C753D722C6F3D31343B7377697463682874297B63617365203132333A72657475726E20722B2B2C6F3D31';
wwv_flow_imp.g_varchar2_table(2531) := '3B63617365203132353A72657475726E20722B2B2C6F3D323B636173652039313A72657475726E20722B2B2C6F3D333B636173652039333A72657475726E20722B2B2C6F3D343B636173652035383A72657475726E20722B2B2C6F3D363B636173652034';
wwv_flow_imp.g_varchar2_table(2532) := '343A72657475726E20722B2B2C6F3D353B636173652033343A72657475726E20722B2B2C693D66756E6374696F6E28297B666F722876617220743D22222C693D723B3B297B696628723E3D6E297B742B3D652E737562737472696E6728692C72292C683D';
wwv_flow_imp.g_varchar2_table(2533) := '323B627265616B7D76617220733D652E63686172436F646541742872293B69662833343D3D3D73297B742B3D652E737562737472696E6728692C72292C722B2B3B627265616B7D6966283932213D3D73297B696628733E3D302626733C3D3331297B6966';
wwv_flow_imp.g_varchar2_table(2534) := '286573287329297B742B3D652E737562737472696E6728692C72292C683D323B627265616B7D683D367D722B2B7D656C73657B696628742B3D652E737562737472696E6728692C72292C2B2B723E3D6E297B683D323B627265616B7D7377697463682865';
wwv_flow_imp.g_varchar2_table(2535) := '2E63686172436F6465417428722B2B29297B636173652033343A742B3D2722273B627265616B3B636173652039323A742B3D225C5C223B627265616B3B636173652034373A742B3D222F223B627265616B3B636173652039383A742B3D225C62223B6272';
wwv_flow_imp.g_varchar2_table(2536) := '65616B3B63617365203130323A742B3D225C66223B627265616B3B63617365203131303A742B3D225C6E223B627265616B3B63617365203131343A742B3D225C72223B627265616B3B63617365203131363A742B3D225C74223B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(2537) := '203131373A766172206F3D6428342C2130293B6F3E3D303F742B3D537472696E672E66726F6D43686172436F6465286F293A683D343B627265616B3B64656661756C743A683D357D693D727D7D72657475726E20747D28292C6F3D31303B636173652034';
wwv_flow_imp.g_varchar2_table(2538) := '373A76617220663D722D313B69662834373D3D3D652E63686172436F6465417428722B3129297B666F7228722B3D323B723C6E262621657328652E63686172436F64654174287229293B29722B2B3B72657475726E20693D652E737562737472696E6728';
wwv_flow_imp.g_varchar2_table(2539) := '662C72292C6F3D31327D69662834323D3D3D652E63686172436F6465417428722B3129297B722B3D323B666F722876617220673D6E2D312C703D21313B723C673B297B76617220763D652E63686172436F646541742872293B69662834323D3D3D762626';
wwv_flow_imp.g_varchar2_table(2540) := '34373D3D3D652E63686172436F6465417428722B3129297B722B3D322C703D21303B627265616B7D722B2B2C657328762926262831333D3D3D76262631303D3D3D652E63686172436F646541742872292626722B2B2C612B2B2C753D72297D7265747572';
wwv_flow_imp.g_varchar2_table(2541) := '6E20707C7C28722B2B2C683D31292C693D652E737562737472696E6728662C72292C6F3D31337D72657475726E20692B3D537472696E672E66726F6D43686172436F64652874292C722B2B2C6F3D31363B636173652034353A696628692B3D537472696E';
wwv_flow_imp.g_varchar2_table(2542) := '672E66726F6D43686172436F64652874292C2B2B723D3D3D6E7C7C21747328652E63686172436F64654174287229292972657475726E206F3D31363B636173652034383A636173652034393A636173652035303A636173652035313A636173652035323A';
wwv_flow_imp.g_varchar2_table(2543) := '636173652035333A636173652035343A636173652035353A636173652035363A636173652035373A72657475726E20692B3D66756E6374696F6E28297B76617220743D723B69662834383D3D3D652E63686172436F6465417428722929722B2B3B656C73';
wwv_flow_imp.g_varchar2_table(2544) := '6520666F7228722B2B3B723C652E6C656E6774682626747328652E63686172436F64654174287229293B29722B2B3B696628723C652E6C656E677468262634363D3D3D652E63686172436F64654174287229297B69662821282B2B723C652E6C656E6774';
wwv_flow_imp.g_varchar2_table(2545) := '682626747328652E63686172436F6465417428722929292972657475726E20683D332C652E737562737472696E6728742C72293B666F7228722B2B3B723C652E6C656E6774682626747328652E63686172436F64654174287229293B29722B2B7D766172';
wwv_flow_imp.g_varchar2_table(2546) := '206E3D723B696628723C652E6C656E67746826262836393D3D3D652E63686172436F646541742872297C7C3130313D3D3D652E63686172436F646541742872292929696628282B2B723C652E6C656E677468262634333D3D3D652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(2547) := '742872297C7C34353D3D3D652E63686172436F64654174287229292626722B2B2C723C652E6C656E6774682626747328652E63686172436F6465417428722929297B666F7228722B2B3B723C652E6C656E6774682626747328652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(2548) := '74287229293B29722B2B3B6E3D727D656C736520683D333B72657475726E20652E737562737472696E6728742C6E297D28292C6F3D31313B64656661756C743A666F72283B723C6E26266D2874293B29722B2B2C743D652E63686172436F646541742872';
wwv_flow_imp.g_varchar2_table(2549) := '293B69662873213D3D72297B73776974636828693D652E737562737472696E6728732C7229297B636173652274727565223A72657475726E206F3D383B636173652266616C7365223A72657475726E206F3D393B63617365226E756C6C223A7265747572';
wwv_flow_imp.g_varchar2_table(2550) := '6E206F3D377D72657475726E206F3D31367D72657475726E20692B3D537472696E672E66726F6D43686172436F64652874292C722B2B2C6F3D31367D7D66756E6374696F6E206D2865297B69662859692865297C7C65732865292972657475726E21313B';
wwv_flow_imp.g_varchar2_table(2551) := '7377697463682865297B63617365203132353A636173652039333A63617365203132333A636173652039313A636173652033343A636173652035383A636173652034343A636173652034373A72657475726E21317D72657475726E21307D72657475726E';
wwv_flow_imp.g_varchar2_table(2552) := '7B736574506F736974696F6E3A66756E6374696F6E2865297B723D652C693D22222C733D302C6F3D31362C683D307D2C676574506F736974696F6E3A66756E6374696F6E28297B72657475726E20727D2C7363616E3A743F66756E6374696F6E28297B76';
wwv_flow_imp.g_varchar2_table(2553) := '617220653B646F7B653D6628297D7768696C6528653E3D31322626653C3D3135293B72657475726E20657D3A662C676574546F6B656E3A66756E6374696F6E28297B72657475726E206F7D2C676574546F6B656E56616C75653A66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(2554) := '7B72657475726E20697D2C676574546F6B656E4F66667365743A66756E6374696F6E28297B72657475726E20737D2C676574546F6B656E4C656E6774683A66756E6374696F6E28297B72657475726E20722D737D2C676574546F6B656E53746172744C69';
wwv_flow_imp.g_varchar2_table(2555) := '6E653A66756E6374696F6E28297B72657475726E206C7D2C676574546F6B656E53746172744368617261637465723A66756E6374696F6E28297B72657475726E20732D637D2C676574546F6B656E4572726F723A66756E6374696F6E28297B7265747572';
wwv_flow_imp.g_varchar2_table(2556) := '6E20687D7D7D66756E6374696F6E2059692865297B72657475726E2033323D3D3D657C7C393D3D3D657C7C31313D3D3D657C7C31323D3D3D657C7C3136303D3D3D657C7C353736303D3D3D657C7C653E3D383139322626653C3D383230337C7C38323339';
wwv_flow_imp.g_varchar2_table(2557) := '3D3D3D657C7C383238373D3D3D657C7C31323238383D3D3D657C7C36353237393D3D3D657D66756E6374696F6E2065732865297B72657475726E2031303D3D3D657C7C31333D3D3D657C7C383233323D3D3D657C7C383233333D3D3D657D66756E637469';
wwv_flow_imp.g_varchar2_table(2558) := '6F6E2074732865297B72657475726E20653E3D34382626653C3D35377D66756E6374696F6E206E7328652C74297B666F7228766172206E3D22222C723D303B723C743B722B2B296E2B3D653B72657475726E206E7D66756E6374696F6E20727328652C74';
wwv_flow_imp.g_varchar2_table(2559) := '297B72657475726E2D31213D3D225C725C6E222E696E6465784F6628652E636861724174287429297D7661722069733B676C6F62616C546869732E6F6E6D6573736167653D653D3E7B58697C7C5169286E756C6C297D2C2869737C7C2869733D7B7D2929';
wwv_flow_imp.g_varchar2_table(2560) := '2E44454641554C543D7B616C6C6F77547261696C696E67436F6D6D613A21317D3B7661722073732C6F732C61732C6C732C75732C63732C68732C64732C66732C6D732C67732C70732C76732C62732C79732C5F732C43732C77732C53732C4C732C45732C';
wwv_flow_imp.g_varchar2_table(2561) := '78732C4E732C41732C6B732C52732C54732C4D732C4F732C49732C50732C46732C56732C44732C71732C4B732C6A732C55732C42732C24732C57732C7A732C48732C47732C4A732C58732C51732C5A732C59732C656F3D5A692C746F3D66756E6374696F';
wwv_flow_imp.g_varchar2_table(2562) := '6E28652C742C6E297B766F696420303D3D3D74262628743D5B5D292C766F696420303D3D3D6E2626286E3D69732E44454641554C54293B76617220723D6E756C6C2C693D5B5D2C733D5B5D3B66756E6374696F6E206F2865297B41727261792E69734172';
wwv_flow_imp.g_varchar2_table(2563) := '7261792869293F692E707573682865293A6E756C6C213D3D72262628695B725D3D65297D72657475726E2066756E6374696F6E28652C742C6E297B766F696420303D3D3D6E2626286E3D69732E44454641554C54293B76617220723D5A6928652C213129';
wwv_flow_imp.g_varchar2_table(2564) := '3B66756E6374696F6E20692865297B72657475726E20653F66756E6374696F6E28297B72657475726E206528722E676574546F6B656E4F666673657428292C722E676574546F6B656E4C656E67746828292C722E676574546F6B656E53746172744C696E';
wwv_flow_imp.g_varchar2_table(2565) := '6528292C722E676574546F6B656E53746172744368617261637465722829297D3A66756E6374696F6E28297B72657475726E21307D7D66756E6374696F6E20732865297B72657475726E20653F66756E6374696F6E2874297B72657475726E206528742C';
wwv_flow_imp.g_varchar2_table(2566) := '722E676574546F6B656E4F666673657428292C722E676574546F6B656E4C656E67746828292C722E676574546F6B656E53746172744C696E6528292C722E676574546F6B656E53746172744368617261637465722829297D3A66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(2567) := '72657475726E21307D7D766172206F3D6928742E6F6E4F626A656374426567696E292C613D7328742E6F6E4F626A65637450726F7065727479292C6C3D6928742E6F6E4F626A656374456E64292C753D6928742E6F6E4172726179426567696E292C633D';
wwv_flow_imp.g_varchar2_table(2568) := '6928742E6F6E4172726179456E64292C683D7328742E6F6E4C69746572616C56616C7565292C643D7328742E6F6E536570617261746F72292C663D6928742E6F6E436F6D6D656E74292C6D3D7328742E6F6E4572726F72292C673D6E26266E2E64697361';
wwv_flow_imp.g_varchar2_table(2569) := '6C6C6F77436F6D6D656E74732C703D6E26266E2E616C6C6F77547261696C696E67436F6D6D613B66756E6374696F6E207628297B666F72283B3B297B76617220653D722E7363616E28293B73776974636828722E676574546F6B656E4572726F72282929';
wwv_flow_imp.g_varchar2_table(2570) := '7B6361736520343A62283134293B627265616B3B6361736520353A62283135293B627265616B3B6361736520333A62283133293B627265616B3B6361736520313A677C7C62283131293B627265616B3B6361736520323A62283132293B627265616B3B63';
wwv_flow_imp.g_varchar2_table(2571) := '61736520363A62283136297D7377697463682865297B636173652031323A636173652031333A673F62283130293A6628293B627265616B3B636173652031363A622831293B627265616B3B636173652031353A636173652031343A627265616B3B646566';
wwv_flow_imp.g_varchar2_table(2572) := '61756C743A72657475726E20657D7D7D66756E6374696F6E206228652C742C6E297B696628766F696420303D3D3D74262628743D5B5D292C766F696420303D3D3D6E2626286E3D5B5D292C6D2865292C742E6C656E6774682B6E2E6C656E6774683E3029';
wwv_flow_imp.g_varchar2_table(2573) := '666F722876617220693D722E676574546F6B656E28293B3137213D3D693B297B6966282D31213D3D742E696E6465784F66286929297B7628293B627265616B7D6966282D31213D3D6E2E696E6465784F6628692929627265616B3B693D7628297D7D6675';
wwv_flow_imp.g_varchar2_table(2574) := '6E6374696F6E20792865297B76617220743D722E676574546F6B656E56616C756528293B72657475726E20653F682874293A612874292C7628292C21307D66756E6374696F6E205F28297B73776974636828722E676574546F6B656E2829297B63617365';
wwv_flow_imp.g_varchar2_table(2575) := '20333A72657475726E2066756E6374696F6E28297B7528292C7628293B666F722876617220653D21313B34213D3D722E676574546F6B656E282926263137213D3D722E676574546F6B656E28293B297B696628353D3D3D722E676574546F6B656E282929';
wwv_flow_imp.g_varchar2_table(2576) := '7B696628657C7C6228342C5B5D2C5B5D292C6428222C22292C7628292C343D3D3D722E676574546F6B656E282926267029627265616B7D656C7365206526266228362C5B5D2C5B5D293B5F28297C7C6228342C5B5D2C5B342C355D292C653D21307D7265';
wwv_flow_imp.g_varchar2_table(2577) := '7475726E206328292C34213D3D722E676574546F6B656E28293F6228382C5B345D2C5B5D293A7628292C21307D28293B6361736520313A72657475726E2066756E6374696F6E28297B6F28292C7628293B666F722876617220653D21313B32213D3D722E';
wwv_flow_imp.g_varchar2_table(2578) := '676574546F6B656E282926263137213D3D722E676574546F6B656E28293B297B696628353D3D3D722E676574546F6B656E2829297B696628657C7C6228342C5B5D2C5B5D292C6428222C22292C7628292C323D3D3D722E676574546F6B656E2829262670';
wwv_flow_imp.g_varchar2_table(2579) := '29627265616B7D656C7365206526266228362C5B5D2C5B5D293B283130213D3D722E676574546F6B656E28293F286228332C5B5D2C5B322C355D292C2131293A2879282131292C363D3D3D722E676574546F6B656E28293F286428223A22292C7628292C';
wwv_flow_imp.g_varchar2_table(2580) := '5F28297C7C6228342C5B5D2C5B322C355D29293A6228352C5B5D2C5B322C355D292C213029297C7C6228342C5B5D2C5B322C355D292C653D21307D72657475726E206C28292C32213D3D722E676574546F6B656E28293F6228372C5B325D2C5B5D293A76';
wwv_flow_imp.g_varchar2_table(2581) := '28292C21307D28293B636173652031303A72657475726E2079282130293B64656661756C743A72657475726E2066756E6374696F6E28297B73776974636828722E676574546F6B656E2829297B636173652031313A76617220653D722E676574546F6B65';
wwv_flow_imp.g_varchar2_table(2582) := '6E56616C756528292C743D4E756D6265722865293B69734E614E287429262628622832292C743D30292C682874293B627265616B3B6361736520373A68286E756C6C293B627265616B3B6361736520383A68282130293B627265616B3B6361736520393A';
wwv_flow_imp.g_varchar2_table(2583) := '68282131293B627265616B3B64656661756C743A72657475726E21317D72657475726E207628292C21307D28297D7D7628292C31373D3D3D722E676574546F6B656E28293F21216E2E616C6C6F77456D707479436F6E74656E747C7C6228342C5B5D2C5B';
wwv_flow_imp.g_varchar2_table(2584) := '5D293A5F28293F3137213D3D722E676574546F6B656E282926266228392C5B5D2C5B5D293A6228342C5B5D2C5B5D297D28652C7B6F6E4F626A656374426567696E3A66756E6374696F6E28297B76617220653D7B7D3B6F2865292C732E70757368286929';
wwv_flow_imp.g_varchar2_table(2585) := '2C693D652C723D6E756C6C7D2C6F6E4F626A65637450726F70657274793A66756E6374696F6E2865297B723D657D2C6F6E4F626A656374456E643A66756E6374696F6E28297B693D732E706F7028297D2C6F6E4172726179426567696E3A66756E637469';
wwv_flow_imp.g_varchar2_table(2586) := '6F6E28297B76617220653D5B5D3B6F2865292C732E707573682869292C693D652C723D6E756C6C7D2C6F6E4172726179456E643A66756E6374696F6E28297B693D732E706F7028297D2C6F6E4C69746572616C56616C75653A6F2C6F6E4572726F723A66';
wwv_flow_imp.g_varchar2_table(2587) := '756E6374696F6E28652C6E2C72297B742E70757368287B6572726F723A652C6F66667365743A6E2C6C656E6774683A727D297D7D2C6E292C695B305D7D2C6E6F3D66756E6374696F6E206528742C6E2C72297B696628766F696420303D3D3D7226262872';
wwv_flow_imp.g_varchar2_table(2588) := '3D2131292C66756E6374696F6E28652C742C6E297B72657475726E20766F696420303D3D3D6E2626286E3D2131292C743E3D652E6F66667365742626743C652E6F66667365742B652E6C656E6774687C7C6E2626743D3D3D652E6F66667365742B652E6C';
wwv_flow_imp.g_varchar2_table(2589) := '656E6774687D28742C6E2C7229297B76617220693D742E6368696C6472656E3B69662841727261792E6973417272617928692929666F722876617220733D303B733C692E6C656E6774682626695B735D2E6F66667365743C3D6E3B732B2B297B76617220';
wwv_flow_imp.g_varchar2_table(2590) := '6F3D6528695B735D2C6E2C72293B6966286F2972657475726E206F7D72657475726E20747D7D2C726F3D66756E6374696F6E20652874297B69662821742E706172656E747C7C21742E706172656E742E6368696C6472656E2972657475726E5B5D3B7661';
wwv_flow_imp.g_varchar2_table(2591) := '72206E3D6528742E706172656E74293B6966282270726F7065727479223D3D3D742E706172656E742E74797065297B76617220723D742E706172656E742E6368696C6472656E5B305D2E76616C75653B6E2E707573682872297D656C7365206966282261';
wwv_flow_imp.g_varchar2_table(2592) := '72726179223D3D3D742E706172656E742E74797065297B76617220693D742E706172656E742E6368696C6472656E2E696E6465784F662874293B2D31213D3D6926266E2E707573682869297D72657475726E206E7D2C696F3D66756E6374696F6E206528';
wwv_flow_imp.g_varchar2_table(2593) := '74297B73776974636828742E74797065297B63617365226172726179223A72657475726E20742E6368696C6472656E2E6D61702865293B63617365226F626A656374223A666F7228766172206E3D4F626A6563742E637265617465286E756C6C292C723D';
wwv_flow_imp.g_varchar2_table(2594) := '302C693D742E6368696C6472656E3B723C692E6C656E6774683B722B2B297B76617220733D695B725D2C6F3D732E6368696C6472656E5B315D3B6F2626286E5B732E6368696C6472656E5B305D2E76616C75655D3D65286F29297D72657475726E206E3B';
wwv_flow_imp.g_varchar2_table(2595) := '63617365226E756C6C223A6361736522737472696E67223A63617365226E756D626572223A6361736522626F6F6C65616E223A72657475726E20742E76616C75653B64656661756C743A72657475726E7D7D3B66756E6374696F6E20736F28652C74297B';
wwv_flow_imp.g_varchar2_table(2596) := '696628653D3D3D742972657475726E21303B6966286E756C6C3D3D657C7C6E756C6C3D3D742972657475726E21313B696628747970656F662065213D747970656F6620742972657475726E21313B696628226F626A65637422213D747970656F66206529';
wwv_flow_imp.g_varchar2_table(2597) := '72657475726E21313B69662841727261792E69734172726179286529213D3D41727261792E697341727261792874292972657475726E21313B766172206E2C723B69662841727261792E69734172726179286529297B696628652E6C656E677468213D3D';
wwv_flow_imp.g_varchar2_table(2598) := '742E6C656E6774682972657475726E21313B666F72286E3D303B6E3C652E6C656E6774683B6E2B2B2969662821736F28655B6E5D2C745B6E5D292972657475726E21317D656C73657B76617220693D5B5D3B666F72287220696E206529692E7075736828';
wwv_flow_imp.g_varchar2_table(2599) := '72293B692E736F727428293B76617220733D5B5D3B666F72287220696E207429732E707573682872293B696628732E736F727428292C21736F28692C73292972657475726E21313B666F72286E3D303B6E3C692E6C656E6774683B6E2B2B296966282173';
wwv_flow_imp.g_varchar2_table(2600) := '6F28655B695B6E5D5D2C745B695B6E5D5D292972657475726E21317D72657475726E21307D66756E6374696F6E206F6F2865297B72657475726E226E756D626572223D3D747970656F6620657D66756E6374696F6E20616F2865297B72657475726E2076';
wwv_flow_imp.g_varchar2_table(2601) := '6F69642030213D3D657D66756E6374696F6E206C6F2865297B72657475726E22626F6F6C65616E223D3D747970656F6620657D66756E6374696F6E20756F28652C74297B766172206E3D652E6C656E6774682D742E6C656E6774683B72657475726E206E';
wwv_flow_imp.g_varchar2_table(2602) := '3E303F652E6C617374496E6465784F662874293D3D3D6E3A303D3D3D6E2626653D3D3D747D66756E6374696F6E20636F2865297B76617220743D22223B2866756E6374696F6E28652C74297B696628652E6C656E6774683C342972657475726E21313B66';
wwv_flow_imp.g_varchar2_table(2603) := '6F7228766172206E3D303B6E3C343B6E2B2B29696628655B6E5D213D3D745B6E5D2972657475726E21313B72657475726E21307D2928652C22283F69292229262628653D652E737562737472696E672834292C743D226922293B7472797B72657475726E';
wwv_flow_imp.g_varchar2_table(2604) := '206E65772052656745787028652C742B227522297D6361746368286E297B7472797B72657475726E206E65772052656745787028652C74297D63617463682865297B72657475726E7D7D7D286F733D73737C7C2873733D7B7D29292E4D494E5F56414C55';
wwv_flow_imp.g_varchar2_table(2605) := '453D2D323134373438333634382C6F732E4D41585F56414C55453D323134373438333634372C286C733D61737C7C2861733D7B7D29292E4D494E5F56414C55453D302C6C732E4D41585F56414C55453D323134373438333634372C2863733D75737C7C28';
wwv_flow_imp.g_varchar2_table(2606) := '75733D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E20653D3D3D4E756D6265722E4D41585F56414C5545262628653D61732E4D41585F56414C5545292C743D3D3D4E756D6265722E4D41585F56414C5545262628743D';
wwv_flow_imp.g_varchar2_table(2607) := '61732E4D41585F56414C5545292C7B6C696E653A652C6368617261637465723A747D7D2C63732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E6F626A6563744C69746572616C287429262668612E75696E74656765';
wwv_flow_imp.g_varchar2_table(2608) := '7228742E6C696E6529262668612E75696E746567657228742E636861726163746572297D2C2864733D68737C7C2868733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B69662868612E75696E746567657228652926266861';
wwv_flow_imp.g_varchar2_table(2609) := '2E75696E7465676572287429262668612E75696E7465676572286E29262668612E75696E74656765722872292972657475726E7B73746172743A75732E63726561746528652C74292C656E643A75732E637265617465286E2C72297D3B69662875732E69';
wwv_flow_imp.g_varchar2_table(2610) := '73286529262675732E69732874292972657475726E7B73746172743A652C656E643A747D3B7468726F77206E6577204572726F72282252616E6765236372656174652063616C6C6564207769746820696E76616C696420617267756D656E74735B222B65';
wwv_flow_imp.g_varchar2_table(2611) := '2B222C20222B742B222C20222B6E2B222C20222B722B225D22297D2C64732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E6F626A6563744C69746572616C287429262675732E697328742E73746172742926267573';
wwv_flow_imp.g_varchar2_table(2612) := '2E697328742E656E64297D2C286D733D66737C7C2866733D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C72616E67653A747D7D2C6D732E69733D66756E6374696F6E2865297B76617220743D653B72';
wwv_flow_imp.g_varchar2_table(2613) := '657475726E2068612E646566696E6564287429262668732E697328742E72616E67652926262868612E737472696E6728742E757269297C7C68612E756E646566696E656428742E75726929297D2C2870733D67737C7C2867733D7B7D29292E6372656174';
wwv_flow_imp.g_varchar2_table(2614) := '653D66756E6374696F6E28652C742C6E2C72297B72657475726E7B7461726765745572693A652C74617267657452616E67653A742C74617267657453656C656374696F6E52616E67653A6E2C6F726967696E53656C656374696F6E52616E67653A727D7D';
wwv_flow_imp.g_varchar2_table(2615) := '2C70732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668732E697328742E74617267657452616E676529262668612E737472696E6728742E7461726765745572692926262868732E69';
wwv_flow_imp.g_varchar2_table(2616) := '7328742E74617267657453656C656374696F6E52616E6765297C7C68612E756E646566696E656428742E74617267657453656C656374696F6E52616E6765292926262868732E697328742E6F726967696E53656C656374696F6E52616E6765297C7C6861';
wwv_flow_imp.g_varchar2_table(2617) := '2E756E646566696E656428742E6F726967696E53656C656374696F6E52616E676529297D2C2862733D76737C7C2876733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E7B7265643A652C677265656E3A742C';
wwv_flow_imp.g_varchar2_table(2618) := '626C75653A6E2C616C7068613A727D7D2C62732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E6E756D62657252616E676528742E7265642C302C3129262668612E6E756D62657252616E676528742E677265656E2C';
wwv_flow_imp.g_varchar2_table(2619) := '302C3129262668612E6E756D62657252616E676528742E626C75652C302C3129262668612E6E756D62657252616E676528742E616C7068612C302C31297D2C285F733D79737C7C2879733D7B7D29292E6372656174653D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(2620) := '7B72657475726E7B72616E67653A652C636F6C6F723A747D7D2C5F732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068732E697328742E72616E676529262676732E697328742E636F6C6F72297D2C2877733D43737C7C28';
wwv_flow_imp.g_varchar2_table(2621) := '43733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B6C6162656C3A652C74657874456469743A742C6164646974696F6E616C5465787445646974733A6E7D7D2C77732E69733D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(2622) := '617220743D653B72657475726E2068612E737472696E6728742E6C6162656C2926262868612E756E646566696E656428742E7465787445646974297C7C44732E69732874292926262868612E756E646566696E656428742E6164646974696F6E616C5465';
wwv_flow_imp.g_varchar2_table(2623) := '78744564697473297C7C68612E7479706564417272617928742E6164646974696F6E616C5465787445646974732C44732E697329297D2C284C733D53737C7C2853733D7B7D29292E436F6D6D656E743D22636F6D6D656E74222C4C732E496D706F727473';
wwv_flow_imp.g_varchar2_table(2624) := '3D22696D706F727473222C4C732E526567696F6E3D22726567696F6E222C2878733D45737C7C2845733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C69297B76617220733D7B73746172744C696E653A652C656E644C696E65';
wwv_flow_imp.g_varchar2_table(2625) := '3A747D3B72657475726E2068612E646566696E6564286E29262628732E73746172744368617261637465723D6E292C68612E646566696E6564287229262628732E656E644368617261637465723D72292C68612E646566696E6564286929262628732E6B';
wwv_flow_imp.g_varchar2_table(2626) := '696E643D69292C737D2C78732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E75696E746567657228742E73746172744C696E6529262668612E75696E746567657228742E73746172744C696E652926262868612E75';
wwv_flow_imp.g_varchar2_table(2627) := '6E646566696E656428742E7374617274436861726163746572297C7C68612E75696E746567657228742E7374617274436861726163746572292926262868612E756E646566696E656428742E656E64436861726163746572297C7C68612E75696E746567';
wwv_flow_imp.g_varchar2_table(2628) := '657228742E656E64436861726163746572292926262868612E756E646566696E656428742E6B696E64297C7C68612E737472696E6728742E6B696E6429297D2C2841733D4E737C7C284E733D7B7D29292E6372656174653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(2629) := '297B72657475726E7B6C6F636174696F6E3A652C6D6573736167653A747D7D2C41732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262666732E697328742E6C6F636174696F6E29262668';
wwv_flow_imp.g_varchar2_table(2630) := '612E737472696E6728742E6D657373616765297D2C2852733D6B737C7C286B733D7B7D29292E4572726F723D312C52732E5761726E696E673D322C52732E496E666F726D6174696F6E3D332C52732E48696E743D342C284D733D54737C7C2854733D7B7D';
wwv_flow_imp.g_varchar2_table(2631) := '29292E556E6E65636573736172793D312C4D732E446570726563617465643D322C284F737C7C284F733D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E206E756C6C213D74262668612E737472696E6728742E6872';
wwv_flow_imp.g_varchar2_table(2632) := '6566297D2C2850733D49737C7C2849733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C692C73297B766172206F3D7B72616E67653A652C6D6573736167653A747D3B72657475726E2068612E646566696E6564286E29262628';
wwv_flow_imp.g_varchar2_table(2633) := '6F2E73657665726974793D6E292C68612E646566696E65642872292626286F2E636F64653D72292C68612E646566696E65642869292626286F2E736F757263653D69292C68612E646566696E65642873292626286F2E72656C61746564496E666F726D61';
wwv_flow_imp.g_varchar2_table(2634) := '74696F6E3D73292C6F7D2C50732E69733D66756E6374696F6E2865297B76617220742C6E3D653B72657475726E2068612E646566696E6564286E29262668732E6973286E2E72616E676529262668612E737472696E67286E2E6D65737361676529262628';
wwv_flow_imp.g_varchar2_table(2635) := '68612E6E756D626572286E2E7365766572697479297C7C68612E756E646566696E6564286E2E7365766572697479292926262868612E696E7465676572286E2E636F6465297C7C68612E737472696E67286E2E636F6465297C7C68612E756E646566696E';
wwv_flow_imp.g_varchar2_table(2636) := '6564286E2E636F6465292926262868612E756E646566696E6564286E2E636F64654465736372697074696F6E297C7C68612E737472696E67286E756C6C3D3D3D28743D6E2E636F64654465736372697074696F6E297C7C766F696420303D3D3D743F766F';
wwv_flow_imp.g_varchar2_table(2637) := '696420303A742E68726566292926262868612E737472696E67286E2E736F75726365297C7C68612E756E646566696E6564286E2E736F75726365292926262868612E756E646566696E6564286E2E72656C61746564496E666F726D6174696F6E297C7C68';
wwv_flow_imp.g_varchar2_table(2638) := '612E74797065644172726179286E2E72656C61746564496E666F726D6174696F6E2C4E732E697329297D2C2856733D46737C7C2846733D7B7D29292E6372656174653D66756E6374696F6E28652C74297B666F7228766172206E3D5B5D2C723D323B723C';
wwv_flow_imp.g_varchar2_table(2639) := '617267756D656E74732E6C656E6774683B722B2B296E5B722D325D3D617267756D656E74735B725D3B76617220693D7B7469746C653A652C636F6D6D616E643A747D3B72657475726E2068612E646566696E6564286E2926266E2E6C656E6774683E3026';
wwv_flow_imp.g_varchar2_table(2640) := '2628692E617267756D656E74733D6E292C697D2C56732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668612E737472696E6728742E7469746C6529262668612E737472696E6728742E';
wwv_flow_imp.g_varchar2_table(2641) := '636F6D6D616E64297D2C2871733D44737C7C2844733D7B7D29292E7265706C6163653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A747D7D2C71732E696E736572743D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(2642) := '72657475726E7B72616E67653A7B73746172743A652C656E643A657D2C6E6577546578743A747D7D2C71732E64656C3D66756E6374696F6E2865297B72657475726E7B72616E67653A652C6E6577546578743A22227D7D2C71732E69733D66756E637469';
wwv_flow_imp.g_varchar2_table(2643) := '6F6E2865297B76617220743D653B72657475726E2068612E6F626A6563744C69746572616C287429262668612E737472696E6728742E6E65775465787429262668732E697328742E72616E6765297D2C286A733D4B737C7C284B733D7B7D29292E637265';
wwv_flow_imp.g_varchar2_table(2644) := '6174653D66756E6374696F6E28652C742C6E297B76617220723D7B6C6162656C3A657D3B72657475726E20766F69642030213D3D74262628722E6E65656473436F6E6669726D6174696F6E3D74292C766F69642030213D3D6E262628722E646573637269';
wwv_flow_imp.g_varchar2_table(2645) := '7074696F6E3D6E292C727D2C6A732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20766F69642030213D3D74262668612E6F626A6563744C69746572616C287429262668612E737472696E6728742E6C6162656C2926262868';
wwv_flow_imp.g_varchar2_table(2646) := '612E626F6F6C65616E28742E6E65656473436F6E6669726D6174696F6E297C7C766F696420303D3D3D742E6E65656473436F6E6669726D6174696F6E2926262868612E737472696E6728742E6465736372697074696F6E297C7C766F696420303D3D3D74';
wwv_flow_imp.g_varchar2_table(2647) := '2E6465736372697074696F6E297D2C2855737C7C2855733D7B7D29292E69733D66756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620657D2C2824733D42737C7C2842733D7B7D29292E7265706C6163653D66756E6374';
wwv_flow_imp.g_varchar2_table(2648) := '696F6E28652C742C6E297B72657475726E7B72616E67653A652C6E6577546578743A742C616E6E6F746174696F6E49643A6E7D7D2C24732E696E736572743D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A7B73746172743A65';
wwv_flow_imp.g_varchar2_table(2649) := '2C656E643A657D2C6E6577546578743A742C616E6E6F746174696F6E49643A6E7D7D2C24732E64656C3D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C6E6577546578743A22222C616E6E6F746174696F6E49643A747D7D2C24';
wwv_flow_imp.g_varchar2_table(2650) := '732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2044732E69732874292626284B732E697328742E616E6E6F746174696F6E4964297C7C55732E697328742E616E6E6F746174696F6E496429297D2C287A733D57737C7C2857';
wwv_flow_imp.g_varchar2_table(2651) := '733D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B74657874446F63756D656E743A652C65646974733A747D7D2C7A732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E64656669';
wwv_flow_imp.g_varchar2_table(2652) := '6E65642874292626706F2E697328742E74657874446F63756D656E7429262641727261792E6973417272617928742E6564697473297D2C2847733D48737C7C2848733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B7661722072';
wwv_flow_imp.g_varchar2_table(2653) := '3D7B6B696E643A22637265617465222C7572693A657D3B72657475726E20766F696420303D3D3D747C7C766F696420303D3D3D742E6F76657277726974652626766F696420303D3D3D742E69676E6F726549664578697374737C7C28722E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(2654) := '733D74292C766F69642030213D3D6E262628722E616E6E6F746174696F6E49643D6E292C727D2C47732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262622637265617465223D3D3D742E6B696E64262668612E737472';
wwv_flow_imp.g_varchar2_table(2655) := '696E6728742E75726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E6F76657277726974657C7C68612E626F6F6C65616E28742E6F7074696F6E732E6F7665727772697465292926262876';
wwv_flow_imp.g_varchar2_table(2656) := '6F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C68612E626F6F6C65616E28742E6F7074696F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C';
wwv_flow_imp.g_varchar2_table(2657) := '55732E697328742E616E6E6F746174696F6E496429297D2C2858733D4A737C7C284A733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B76617220693D7B6B696E643A2272656E616D65222C6F6C645572693A652C6E657755';
wwv_flow_imp.g_varchar2_table(2658) := '72693A747D3B72657475726E20766F696420303D3D3D6E7C7C766F696420303D3D3D6E2E6F76657277726974652626766F696420303D3D3D6E2E69676E6F726549664578697374737C7C28692E6F7074696F6E733D6E292C766F69642030213D3D722626';
wwv_flow_imp.g_varchar2_table(2659) := '28692E616E6E6F746174696F6E49643D72292C697D2C58732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426262272656E616D65223D3D3D742E6B696E64262668612E737472696E6728742E6F6C645572692926266861';
wwv_flow_imp.g_varchar2_table(2660) := '2E737472696E6728742E6E657755726929262628766F696420303D3D3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E6F76657277726974657C7C68612E626F6F6C65616E28742E6F7074696F6E732E6F76657277726974';
wwv_flow_imp.g_varchar2_table(2661) := '652929262628766F696420303D3D3D742E6F7074696F6E732E69676E6F726549664578697374737C7C68612E626F6F6C65616E28742E6F7074696F6E732E69676E6F72654966457869737473292929262628766F696420303D3D3D742E616E6E6F746174';
wwv_flow_imp.g_varchar2_table(2662) := '696F6E49647C7C55732E697328742E616E6E6F746174696F6E496429297D2C285A733D51737C7C2851733D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B76617220723D7B6B696E643A2264656C657465222C7572693A657D3B72';
wwv_flow_imp.g_varchar2_table(2663) := '657475726E20766F696420303D3D3D747C7C766F696420303D3D3D742E7265637572736976652626766F696420303D3D3D742E69676E6F726549664E6F744578697374737C7C28722E6F7074696F6E733D74292C766F69642030213D3D6E262628722E61';
wwv_flow_imp.g_varchar2_table(2664) := '6E6E6F746174696F6E49643D6E292C727D2C5A732E69733D66756E6374696F6E2865297B76617220743D653B72657475726E207426262264656C657465223D3D3D742E6B696E64262668612E737472696E6728742E75726929262628766F696420303D3D';
wwv_flow_imp.g_varchar2_table(2665) := '3D742E6F7074696F6E737C7C28766F696420303D3D3D742E6F7074696F6E732E7265637572736976657C7C68612E626F6F6C65616E28742E6F7074696F6E732E7265637572736976652929262628766F696420303D3D3D742E6F7074696F6E732E69676E';
wwv_flow_imp.g_varchar2_table(2666) := '6F726549664E6F744578697374737C7C68612E626F6F6C65616E28742E6F7074696F6E732E69676E6F726549664E6F74457869737473292929262628766F696420303D3D3D742E616E6E6F746174696F6E49647C7C55732E697328742E616E6E6F746174';
wwv_flow_imp.g_varchar2_table(2667) := '696F6E496429297D2C2859737C7C2859733D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262628766F69642030213D3D742E6368616E6765737C7C766F69642030213D3D742E646F63756D656E744368616E';
wwv_flow_imp.g_varchar2_table(2668) := '67657329262628766F696420303D3D3D742E646F63756D656E744368616E6765737C7C742E646F63756D656E744368616E6765732E6576657279282866756E6374696F6E2865297B72657475726E2068612E737472696E6728652E6B696E64293F48732E';
wwv_flow_imp.g_varchar2_table(2669) := '69732865297C7C4A732E69732865297C7C51732E69732865293A57732E69732865297D2929297D3B76617220686F2C666F2C6D6F2C676F2C706F2C766F2C626F2C796F2C5F6F2C436F2C776F2C536F2C4C6F2C456F2C786F2C4E6F2C416F2C6B6F2C526F';
wwv_flow_imp.g_varchar2_table(2670) := '2C546F2C4D6F2C4F6F2C496F2C506F2C466F2C566F2C446F2C716F2C4B6F2C6A6F2C556F2C426F2C246F2C576F2C7A6F2C486F2C476F2C4A6F2C586F2C516F2C5A6F2C596F2C65612C74612C6E612C72612C69612C73612C6F612C61612C6C612C75613D';
wwv_flow_imp.g_varchar2_table(2671) := '66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E65646974733D652C746869732E6368616E6765416E6E6F746174696F6E733D747D72657475726E20652E70726F746F747970652E696E736572743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(2672) := '652C742C6E297B76617220722C693B696628766F696420303D3D3D6E3F723D44732E696E7365727428652C74293A55732E6973286E293F28693D6E2C723D42732E696E7365727428652C742C6E29293A28746869732E6173736572744368616E6765416E';
wwv_flow_imp.g_varchar2_table(2673) := '6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C693D746869732E6368616E6765416E6E6F746174696F6E732E6D616E616765286E292C723D42732E696E7365727428652C742C6929292C746869732E65646974732E';
wwv_flow_imp.g_varchar2_table(2674) := '707573682872292C766F69642030213D3D692972657475726E20697D2C652E70726F746F747970652E7265706C6163653D66756E6374696F6E28652C742C6E297B76617220722C693B696628766F696420303D3D3D6E3F723D44732E7265706C61636528';
wwv_flow_imp.g_varchar2_table(2675) := '652C74293A55732E6973286E293F28693D6E2C723D42732E7265706C61636528652C742C6E29293A28746869732E6173736572744368616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C693D74686973';
wwv_flow_imp.g_varchar2_table(2676) := '2E6368616E6765416E6E6F746174696F6E732E6D616E616765286E292C723D42732E7265706C61636528652C742C6929292C746869732E65646974732E707573682872292C766F69642030213D3D692972657475726E20697D2C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(2677) := '652E64656C6574653D66756E6374696F6E28652C74297B766172206E2C723B696628766F696420303D3D3D743F6E3D44732E64656C2865293A55732E69732874293F28723D742C6E3D42732E64656C28652C7429293A28746869732E6173736572744368';
wwv_flow_imp.g_varchar2_table(2678) := '616E6765416E6E6F746174696F6E7328746869732E6368616E6765416E6E6F746174696F6E73292C723D746869732E6368616E6765416E6E6F746174696F6E732E6D616E6167652874292C6E3D42732E64656C28652C7229292C746869732E6564697473';
wwv_flow_imp.g_varchar2_table(2679) := '2E70757368286E292C766F69642030213D3D722972657475726E20727D2C652E70726F746F747970652E6164643D66756E6374696F6E2865297B746869732E65646974732E707573682865297D2C652E70726F746F747970652E616C6C3D66756E637469';
wwv_flow_imp.g_varchar2_table(2680) := '6F6E28297B72657475726E20746869732E65646974737D2C652E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E65646974732E73706C69636528302C746869732E65646974732E6C656E677468297D2C652E70726F746F';
wwv_flow_imp.g_varchar2_table(2681) := '747970652E6173736572744368616E6765416E6E6F746174696F6E733D66756E6374696F6E2865297B696628766F696420303D3D3D65297468726F77206E6577204572726F722822546578742065646974206368616E6765206973206E6F7420636F6E66';
wwv_flow_imp.g_varchar2_table(2682) := '69677572656420746F206D616E616765206368616E676520616E6E6F746174696F6E732E22297D2C657D28292C63613D66756E6374696F6E28297B66756E6374696F6E20652865297B746869732E5F616E6E6F746174696F6E733D766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(2683) := '653F4F626A6563742E637265617465286E756C6C293A652C746869732E5F636F756E7465723D302C746869732E5F73697A653D307D72657475726E20652E70726F746F747970652E616C6C3D66756E6374696F6E28297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(2684) := '616E6E6F746174696F6E737D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2273697A65222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F73697A657D2C656E756D657261626C653A';
wwv_flow_imp.g_varchar2_table(2685) := '21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E6D616E6167653D66756E6374696F6E28652C74297B766172206E3B69662855732E69732865293F6E3D653A286E3D746869732E6E657874496428292C743D65292C766F';
wwv_flow_imp.g_varchar2_table(2686) := '69642030213D3D746869732E5F616E6E6F746174696F6E735B6E5D297468726F77206E6577204572726F722822496420222B6E2B2220697320616C726561647920696E207573652E22293B696628766F696420303D3D3D74297468726F77206E65772045';
wwv_flow_imp.g_varchar2_table(2687) := '72726F7228224E6F20616E6E6F746174696F6E2070726F766964656420666F7220696420222B6E293B72657475726E20746869732E5F616E6E6F746174696F6E735B6E5D3D742C746869732E5F73697A652B2B2C6E7D2C652E70726F746F747970652E6E';
wwv_flow_imp.g_varchar2_table(2688) := '65787449643D66756E6374696F6E28297B72657475726E20746869732E5F636F756E7465722B2B2C746869732E5F636F756E7465722E746F537472696E6728297D2C657D28293B2166756E6374696F6E28297B66756E6374696F6E20652865297B766172';
wwv_flow_imp.g_varchar2_table(2689) := '20743D746869733B746869732E5F74657874456469744368616E6765733D4F626A6563742E637265617465286E756C6C292C766F69642030213D3D653F28746869732E5F776F726B7370616365456469743D652C652E646F63756D656E744368616E6765';
wwv_flow_imp.g_varchar2_table(2690) := '733F28746869732E5F6368616E6765416E6E6F746174696F6E733D6E657720636128652E6368616E6765416E6E6F746174696F6E73292C652E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E61';
wwv_flow_imp.g_varchar2_table(2691) := '6C6C28292C652E646F63756D656E744368616E6765732E666F7245616368282866756E6374696F6E2865297B69662857732E6973286529297B766172206E3D6E657720756128652E65646974732C742E5F6368616E6765416E6E6F746174696F6E73293B';
wwv_flow_imp.g_varchar2_table(2692) := '742E5F74657874456469744368616E6765735B652E74657874446F63756D656E742E7572695D3D6E7D7D2929293A652E6368616E67657326264F626A6563742E6B65797328652E6368616E676573292E666F7245616368282866756E6374696F6E286E29';
wwv_flow_imp.g_varchar2_table(2693) := '7B76617220723D6E657720756128652E6368616E6765735B6E5D293B742E5F74657874456469744368616E6765735B6E5D3D727D2929293A746869732E5F776F726B7370616365456469743D7B7D7D4F626A6563742E646566696E6550726F7065727479';
wwv_flow_imp.g_varchar2_table(2694) := '28652E70726F746F747970652C2265646974222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E696E6974446F63756D656E744368616E67657328292C766F69642030213D3D746869732E5F6368616E6765416E6E6F746174696F';
wwv_flow_imp.g_varchar2_table(2695) := '6E73262628303D3D3D746869732E5F6368616E6765416E6E6F746174696F6E732E73697A653F746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D766F696420303A746869732E5F776F726B73706163654564';
wwv_flow_imp.g_varchar2_table(2696) := '69742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829292C746869732E5F776F726B7370616365456469747D2C656E756D657261626C653A21312C636F6E666967757261626C653A';
wwv_flow_imp.g_varchar2_table(2697) := '21307D292C652E70726F746F747970652E67657454657874456469744368616E67653D66756E6374696F6E2865297B696628706F2E6973286529297B696628746869732E696E6974446F63756D656E744368616E67657328292C766F696420303D3D3D74';
wwv_flow_imp.g_varchar2_table(2698) := '6869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F7220646F63756D656E74206368';
wwv_flow_imp.g_varchar2_table(2699) := '616E6765732E22293B76617220743D7B7572693A652E7572692C76657273696F6E3A652E76657273696F6E7D3B6966282128723D746869732E5F74657874456469744368616E6765735B742E7572695D29297B766172206E3D7B74657874446F63756D65';
wwv_flow_imp.g_varchar2_table(2700) := '6E743A742C65646974733A693D5B5D7D3B746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E70757368286E292C723D6E657720756128692C746869732E5F6368616E6765416E6E6F746174696F6E73292C746869';
wwv_flow_imp.g_varchar2_table(2701) := '732E5F74657874456469744368616E6765735B742E7572695D3D727D72657475726E20727D696628746869732E696E69744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573297468726F';
wwv_flow_imp.g_varchar2_table(2702) := '77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F72206E6F726D616C20746578742065646974206368616E6765732E22293B76617220723B6966282128723D746869732E5F746578';
wwv_flow_imp.g_varchar2_table(2703) := '74456469744368616E6765735B655D29297B76617220693D5B5D3B746869732E5F776F726B7370616365456469742E6368616E6765735B655D3D692C723D6E65772075612869292C746869732E5F74657874456469744368616E6765735B655D3D727D72';
wwv_flow_imp.g_varchar2_table(2704) := '657475726E20727D2C652E70726F746F747970652E696E6974446F63756D656E744368616E6765733D66756E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F';
wwv_flow_imp.g_varchar2_table(2705) := '696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869732E5F6368616E6765416E6E6F746174696F6E733D6E65772063612C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E';
wwv_flow_imp.g_varchar2_table(2706) := '6765733D5B5D2C746869732E5F776F726B7370616365456469742E6368616E6765416E6E6F746174696F6E733D746869732E5F6368616E6765416E6E6F746174696F6E732E616C6C2829297D2C652E70726F746F747970652E696E69744368616E676573';
wwv_flow_imp.g_varchar2_table(2707) := '3D66756E6374696F6E28297B766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732626766F696420303D3D3D746869732E5F776F726B7370616365456469742E6368616E676573262628746869';
wwv_flow_imp.g_varchar2_table(2708) := '732E5F776F726B7370616365456469742E6368616E6765733D4F626A6563742E637265617465286E756C6C29297D2C652E70726F746F747970652E63726561746546696C653D66756E6374696F6E28652C742C6E297B696628746869732E696E6974446F';
wwv_flow_imp.g_varchar2_table(2709) := '63756D656E744368616E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420';
wwv_flow_imp.g_varchar2_table(2710) := '636F6E6669677572656420666F7220646F63756D656E74206368616E6765732E22293B76617220722C692C733B6966284B732E69732874297C7C55732E69732874293F723D743A6E3D742C766F696420303D3D3D723F693D48732E63726561746528652C';
wwv_flow_imp.g_varchar2_table(2711) := '6E293A28733D55732E69732872293F723A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C693D48732E63726561746528652C6E2C7329292C746869732E5F776F726B7370616365456469742E646F63756D656E7443';
wwv_flow_imp.g_varchar2_table(2712) := '68616E6765732E707573682869292C766F69642030213D3D732972657475726E20737D2C652E70726F746F747970652E72656E616D6546696C653D66756E6374696F6E28652C742C6E2C72297B696628746869732E696E6974446F63756D656E74436861';
wwv_flow_imp.g_varchar2_table(2713) := '6E67657328292C766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E666967757265';
wwv_flow_imp.g_varchar2_table(2714) := '6420666F7220646F63756D656E74206368616E6765732E22293B76617220692C732C6F3B6966284B732E6973286E297C7C55732E6973286E293F693D6E3A723D6E2C766F696420303D3D3D693F733D4A732E63726561746528652C742C72293A286F3D55';
wwv_flow_imp.g_varchar2_table(2715) := '732E69732869293F693A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652869292C733D4A732E63726561746528652C742C722C6F29292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765';
wwv_flow_imp.g_varchar2_table(2716) := '732E707573682873292C766F69642030213D3D6F2972657475726E206F7D2C652E70726F746F747970652E64656C65746546696C653D66756E6374696F6E28652C742C6E297B696628746869732E696E6974446F63756D656E744368616E67657328292C';
wwv_flow_imp.g_varchar2_table(2717) := '766F696420303D3D3D746869732E5F776F726B7370616365456469742E646F63756D656E744368616E676573297468726F77206E6577204572726F722822576F726B73706163652065646974206973206E6F7420636F6E6669677572656420666F722064';
wwv_flow_imp.g_varchar2_table(2718) := '6F63756D656E74206368616E6765732E22293B76617220722C692C733B6966284B732E69732874297C7C55732E69732874293F723D743A6E3D742C766F696420303D3D3D723F693D51732E63726561746528652C6E293A28733D55732E69732872293F72';
wwv_flow_imp.g_varchar2_table(2719) := '3A746869732E5F6368616E6765416E6E6F746174696F6E732E6D616E6167652872292C693D51732E63726561746528652C6E2C7329292C746869732E5F776F726B7370616365456469742E646F63756D656E744368616E6765732E707573682869292C76';
wwv_flow_imp.g_varchar2_table(2720) := '6F69642030213D3D732972657475726E20737D7D28292C28666F3D686F7C7C28686F3D7B7D29292E6372656174653D66756E6374696F6E2865297B72657475726E7B7572693A657D7D2C666F2E69733D66756E6374696F6E2865297B76617220743D653B';
wwv_flow_imp.g_varchar2_table(2721) := '72657475726E2068612E646566696E6564287429262668612E737472696E6728742E757269297D2C28676F3D6D6F7C7C286D6F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C76657273696F6E3A74';
wwv_flow_imp.g_varchar2_table(2722) := '7D7D2C676F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668612E737472696E6728742E75726929262668612E696E746567657228742E76657273696F6E297D2C28766F3D706F7C7C';
wwv_flow_imp.g_varchar2_table(2723) := '28706F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B7572693A652C76657273696F6E3A747D7D2C766F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E65642874';
wwv_flow_imp.g_varchar2_table(2724) := '29262668612E737472696E6728742E757269292626286E756C6C3D3D3D742E76657273696F6E7C7C68612E696E746567657228742E76657273696F6E29297D2C28796F3D626F7C7C28626F3D7B7D29292E6372656174653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(2725) := '2C6E2C72297B72657475726E7B7572693A652C6C616E677561676549643A742C76657273696F6E3A6E2C746578743A727D7D2C796F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668';
wwv_flow_imp.g_varchar2_table(2726) := '612E737472696E6728742E75726929262668612E737472696E6728742E6C616E6775616765496429262668612E696E746567657228742E76657273696F6E29262668612E737472696E6728742E74657874297D2C28436F3D5F6F7C7C285F6F3D7B7D2929';
wwv_flow_imp.g_varchar2_table(2727) := '2E506C61696E546578743D22706C61696E74657874222C436F2E4D61726B646F776E3D226D61726B646F776E222C66756E6374696F6E2865297B652E69733D66756E6374696F6E2874297B766172206E3D743B72657475726E206E3D3D3D652E506C6169';
wwv_flow_imp.g_varchar2_table(2728) := '6E546578747C7C6E3D3D3D652E4D61726B646F776E7D7D285F6F7C7C285F6F3D7B7D29292C28776F7C7C28776F3D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E6F626A6563744C69746572616C286529';
wwv_flow_imp.g_varchar2_table(2729) := '26265F6F2E697328742E6B696E6429262668612E737472696E6728742E76616C7565297D2C284C6F3D536F7C7C28536F3D7B7D29292E546578743D312C4C6F2E4D6574686F643D322C4C6F2E46756E6374696F6E3D332C4C6F2E436F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(2730) := '723D342C4C6F2E4669656C643D352C4C6F2E5661726961626C653D362C4C6F2E436C6173733D372C4C6F2E496E746572666163653D382C4C6F2E4D6F64756C653D392C4C6F2E50726F70657274793D31302C4C6F2E556E69743D31312C4C6F2E56616C75';
wwv_flow_imp.g_varchar2_table(2731) := '653D31322C4C6F2E456E756D3D31332C4C6F2E4B6579776F72643D31342C4C6F2E536E69707065743D31352C4C6F2E436F6C6F723D31362C4C6F2E46696C653D31372C4C6F2E5265666572656E63653D31382C4C6F2E466F6C6465723D31392C4C6F2E45';
wwv_flow_imp.g_varchar2_table(2732) := '6E756D4D656D6265723D32302C4C6F2E436F6E7374616E743D32312C4C6F2E5374727563743D32322C4C6F2E4576656E743D32332C4C6F2E4F70657261746F723D32342C4C6F2E54797065506172616D657465723D32352C28786F3D456F7C7C28456F3D';
wwv_flow_imp.g_varchar2_table(2733) := '7B7D29292E506C61696E546578743D312C786F2E536E69707065743D322C284E6F7C7C284E6F3D7B7D29292E446570726563617465643D312C286B6F3D416F7C7C28416F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B726574';
wwv_flow_imp.g_varchar2_table(2734) := '75726E7B6E6577546578743A652C696E736572743A742C7265706C6163653A6E7D7D2C6B6F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262668612E737472696E6728742E6E65775465787429262668732E69732874';
wwv_flow_imp.g_varchar2_table(2735) := '2E696E7365727429262668732E697328742E7265706C616365297D2C28546F3D526F7C7C28526F3D7B7D29292E617349733D312C546F2E61646A757374496E64656E746174696F6E3D322C284D6F7C7C284D6F3D7B7D29292E6372656174653D66756E63';
wwv_flow_imp.g_varchar2_table(2736) := '74696F6E2865297B72657475726E7B6C6162656C3A657D7D2C284F6F7C7C284F6F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B6974656D733A657C7C5B5D2C6973496E636F6D706C6574653A2121747D7D2C2850';
wwv_flow_imp.g_varchar2_table(2737) := '6F3D496F7C7C28496F3D7B7D29292E66726F6D506C61696E546578743D66756E6374696F6E2865297B72657475726E20652E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D2E215D2F672C225C5C242622297D2C506F2E69733D66756E';
wwv_flow_imp.g_varchar2_table(2738) := '6374696F6E2865297B76617220743D653B72657475726E2068612E737472696E672874297C7C68612E6F626A6563744C69746572616C287429262668612E737472696E6728742E6C616E677561676529262668612E737472696E6728742E76616C756529';
wwv_flow_imp.g_varchar2_table(2739) := '7D2C28466F7C7C28466F3D7B7D29292E69733D66756E6374696F6E2865297B76617220743D653B72657475726E212174262668612E6F626A6563744C69746572616C287429262628776F2E697328742E636F6E74656E7473297C7C496F2E697328742E63';
wwv_flow_imp.g_varchar2_table(2740) := '6F6E74656E7473297C7C68612E7479706564417272617928742E636F6E74656E74732C496F2E69732929262628766F696420303D3D3D652E72616E67657C7C68732E697328652E72616E676529297D2C28566F7C7C28566F3D7B7D29292E637265617465';
wwv_flow_imp.g_varchar2_table(2741) := '3D66756E6374696F6E28652C74297B72657475726E20743F7B6C6162656C3A652C646F63756D656E746174696F6E3A747D3A7B6C6162656C3A657D7D2C28446F7C7C28446F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B666F7228';
wwv_flow_imp.g_varchar2_table(2742) := '766172206E3D5B5D2C723D323B723C617267756D656E74732E6C656E6774683B722B2B296E5B722D325D3D617267756D656E74735B725D3B76617220693D7B6C6162656C3A657D3B72657475726E2068612E646566696E6564287429262628692E646F63';
wwv_flow_imp.g_varchar2_table(2743) := '756D656E746174696F6E3D74292C68612E646566696E6564286E293F692E706172616D65746572733D6E3A692E706172616D65746572733D5B5D2C697D2C284B6F3D716F7C7C28716F3D7B7D29292E546578743D312C4B6F2E526561643D322C4B6F2E57';
wwv_flow_imp.g_varchar2_table(2744) := '726974653D332C286A6F7C7C286A6F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475726E2068612E6E756D6265722874292626286E2E6B696E643D74292C6E7D2C28426F3D556F7C';
wwv_flow_imp.g_varchar2_table(2745) := '7C28556F3D7B7D29292E46696C653D312C426F2E4D6F64756C653D322C426F2E4E616D6573706163653D332C426F2E5061636B6167653D342C426F2E436C6173733D352C426F2E4D6574686F643D362C426F2E50726F70657274793D372C426F2E466965';
wwv_flow_imp.g_varchar2_table(2746) := '6C643D382C426F2E436F6E7374727563746F723D392C426F2E456E756D3D31302C426F2E496E746572666163653D31312C426F2E46756E6374696F6E3D31322C426F2E5661726961626C653D31332C426F2E436F6E7374616E743D31342C426F2E537472';
wwv_flow_imp.g_varchar2_table(2747) := '696E673D31352C426F2E4E756D6265723D31362C426F2E426F6F6C65616E3D31372C426F2E41727261793D31382C426F2E4F626A6563743D31392C426F2E4B65793D32302C426F2E4E756C6C3D32312C426F2E456E756D4D656D6265723D32322C426F2E';
wwv_flow_imp.g_varchar2_table(2748) := '5374727563743D32332C426F2E4576656E743D32342C426F2E4F70657261746F723D32352C426F2E54797065506172616D657465723D32362C28246F7C7C28246F3D7B7D29292E446570726563617465643D312C28576F7C7C28576F3D7B7D29292E6372';
wwv_flow_imp.g_varchar2_table(2749) := '656174653D66756E6374696F6E28652C742C6E2C722C69297B76617220733D7B6E616D653A652C6B696E643A742C6C6F636174696F6E3A7B7572693A722C72616E67653A6E7D7D3B72657475726E2069262628732E636F6E7461696E65724E616D653D69';
wwv_flow_imp.g_varchar2_table(2750) := '292C737D2C28486F3D7A6F7C7C287A6F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C722C692C73297B766172206F3D7B6E616D653A652C64657461696C3A742C6B696E643A6E2C72616E67653A722C73656C656374696F6E5261';
wwv_flow_imp.g_varchar2_table(2751) := '6E67653A697D3B72657475726E20766F69642030213D3D732626286F2E6368696C6472656E3D73292C6F7D2C486F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262668612E737472696E6728742E6E616D6529262668';
wwv_flow_imp.g_varchar2_table(2752) := '612E6E756D62657228742E6B696E6429262668732E697328742E72616E676529262668732E697328742E73656C656374696F6E52616E676529262628766F696420303D3D3D742E64657461696C7C7C68612E737472696E6728742E64657461696C292926';
wwv_flow_imp.g_varchar2_table(2753) := '2628766F696420303D3D3D742E646570726563617465647C7C68612E626F6F6C65616E28742E646570726563617465642929262628766F696420303D3D3D742E6368696C6472656E7C7C41727261792E6973417272617928742E6368696C6472656E2929';
wwv_flow_imp.g_varchar2_table(2754) := '262628766F696420303D3D3D742E746167737C7C41727261792E6973417272617928742E7461677329297D2C284A6F3D476F7C7C28476F3D7B7D29292E456D7074793D22222C4A6F2E517569636B4669783D22717569636B666978222C4A6F2E52656661';
wwv_flow_imp.g_varchar2_table(2755) := '63746F723D227265666163746F72222C4A6F2E5265666163746F72457874726163743D227265666163746F722E65787472616374222C4A6F2E5265666163746F72496E6C696E653D227265666163746F722E696E6C696E65222C4A6F2E5265666163746F';
wwv_flow_imp.g_varchar2_table(2756) := '72526577726974653D227265666163746F722E72657772697465222C4A6F2E536F757263653D22736F75726365222C4A6F2E536F757263654F7267616E697A65496D706F7274733D22736F757263652E6F7267616E697A65496D706F727473222C4A6F2E';
wwv_flow_imp.g_varchar2_table(2757) := '536F75726365466978416C6C3D22736F757263652E666978416C6C222C28516F3D586F7C7C28586F3D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B646961676E6F73746963733A657D3B72657475726E206E756C6C';
wwv_flow_imp.g_varchar2_table(2758) := '213D742626286E2E6F6E6C793D74292C6E7D2C516F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668612E7479706564417272617928742E646961676E6F73746963732C49732E6973';
wwv_flow_imp.g_varchar2_table(2759) := '29262628766F696420303D3D3D742E6F6E6C797C7C68612E7479706564417272617928742E6F6E6C792C68612E737472696E6729297D2C28596F3D5A6F7C7C285A6F3D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B7661722072';
wwv_flow_imp.g_varchar2_table(2760) := '3D7B7469746C653A657D2C693D21303B72657475726E22737472696E67223D3D747970656F6620743F28693D21312C722E6B696E643D74293A46732E69732874293F722E636F6D6D616E643D743A722E656469743D742C692626766F69642030213D3D6E';
wwv_flow_imp.g_varchar2_table(2761) := '262628722E6B696E643D6E292C727D2C596F2E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2074262668612E737472696E6728742E7469746C6529262628766F696420303D3D3D742E646961676E6F73746963737C7C68612E';
wwv_flow_imp.g_varchar2_table(2762) := '7479706564417272617928742E646961676E6F73746963732C49732E69732929262628766F696420303D3D3D742E6B696E647C7C68612E737472696E6728742E6B696E642929262628766F69642030213D3D742E656469747C7C766F69642030213D3D74';
wwv_flow_imp.g_varchar2_table(2763) := '2E636F6D6D616E6429262628766F696420303D3D3D742E636F6D6D616E647C7C46732E697328742E636F6D6D616E642929262628766F696420303D3D3D742E69735072656665727265647C7C68612E626F6F6C65616E28742E6973507265666572726564';
wwv_flow_imp.g_varchar2_table(2764) := '2929262628766F696420303D3D3D742E656469747C7C59732E697328742E6564697429297D2C2874613D65617C7C2865613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B766172206E3D7B72616E67653A657D3B72657475726E2068';
wwv_flow_imp.g_varchar2_table(2765) := '612E646566696E65642874292626286E2E646174613D74292C6E7D2C74612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668732E697328742E72616E67652926262868612E756E6465';
wwv_flow_imp.g_varchar2_table(2766) := '66696E656428742E636F6D6D616E64297C7C46732E697328742E636F6D6D616E6429297D2C2872613D6E617C7C286E613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B74616253697A653A652C696E736572745370';
wwv_flow_imp.g_varchar2_table(2767) := '616365733A747D7D2C72612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E2068612E646566696E6564287429262668612E75696E746567657228742E74616253697A6529262668612E626F6F6C65616E28742E696E73657274';
wwv_flow_imp.g_varchar2_table(2768) := '537061636573297D2C2873613D69617C7C2869613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E297B72657475726E7B72616E67653A652C7461726765743A742C646174613A6E7D7D2C73612E69733D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(2769) := '76617220743D653B72657475726E2068612E646566696E6564287429262668732E697328742E72616E67652926262868612E756E646566696E656428742E746172676574297C7C68612E737472696E6728742E74617267657429297D2C2861613D6F617C';
wwv_flow_imp.g_varchar2_table(2770) := '7C286F613D7B7D29292E6372656174653D66756E6374696F6E28652C74297B72657475726E7B72616E67653A652C706172656E743A747D7D2C61612E69733D66756E6374696F6E2865297B76617220743D653B72657475726E20766F69642030213D3D74';
wwv_flow_imp.g_varchar2_table(2771) := '262668732E697328742E72616E676529262628766F696420303D3D3D742E706172656E747C7C61612E697328742E706172656E7429297D2C66756E6374696F6E2865297B66756E6374696F6E207428652C6E297B696628652E6C656E6774683C3D312972';
wwv_flow_imp.g_varchar2_table(2772) := '657475726E20653B76617220723D652E6C656E6774682F327C302C693D652E736C69636528302C72292C733D652E736C6963652872293B7428692C6E292C7428732C6E293B666F7228766172206F3D302C613D302C6C3D303B6F3C692E6C656E67746826';
wwv_flow_imp.g_varchar2_table(2773) := '26613C732E6C656E6774683B297B76617220753D6E28695B6F5D2C735B615D293B655B6C2B2B5D3D753C3D303F695B6F2B2B5D3A735B612B2B5D7D666F72283B6F3C692E6C656E6774683B29655B6C2B2B5D3D695B6F2B2B5D3B666F72283B613C732E6C';
wwv_flow_imp.g_varchar2_table(2774) := '656E6774683B29655B6C2B2B5D3D735B612B2B5D3B72657475726E20657D652E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E206E6577206D6128652C742C6E2C72297D2C652E69733D66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(2775) := '7220743D653B72657475726E21212868612E646566696E6564287429262668612E737472696E6728742E7572692926262868612E756E646566696E656428742E6C616E67756167654964297C7C68612E737472696E6728742E6C616E6775616765496429';
wwv_flow_imp.g_varchar2_table(2776) := '29262668612E75696E746567657228742E6C696E65436F756E7429262668612E66756E6328742E6765745465787429262668612E66756E6328742E706F736974696F6E417429262668612E66756E6328742E6F6666736574417429297D2C652E6170706C';
wwv_flow_imp.g_varchar2_table(2777) := '7945646974733D66756E6374696F6E28652C6E297B666F722876617220723D652E6765745465787428292C693D74286E2C2866756E6374696F6E28652C74297B766172206E3D652E72616E67652E73746172742E6C696E652D742E72616E67652E737461';
wwv_flow_imp.g_varchar2_table(2778) := '72742E6C696E653B72657475726E20303D3D3D6E3F652E72616E67652E73746172742E6368617261637465722D742E72616E67652E73746172742E6368617261637465723A6E7D29292C733D722E6C656E6774682C6F3D692E6C656E6774682D313B6F3E';
wwv_flow_imp.g_varchar2_table(2779) := '3D303B6F2D2D297B76617220613D695B6F5D2C6C3D652E6F6666736574417428612E72616E67652E7374617274292C753D652E6F6666736574417428612E72616E67652E656E64293B6966282128753C3D7329297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(2780) := '224F7665726C617070696E67206564697422293B723D722E737562737472696E6728302C6C292B612E6E6577546578742B722E737562737472696E6728752C722E6C656E677468292C733D6C7D72657475726E20727D7D286C617C7C286C613D7B7D2929';
wwv_flow_imp.g_varchar2_table(2781) := '3B7661722068612C64612C66612C6D613D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C72297B746869732E5F7572693D652C746869732E5F6C616E677561676549643D742C746869732E5F76657273696F6E3D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(2782) := '5F636F6E74656E743D722C746869732E5F6C696E654F6666736574733D766F696420307D72657475726E204F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C22757269222C7B6765743A66756E6374696F6E28297B72';
wwv_flow_imp.g_varchar2_table(2783) := '657475726E20746869732E5F7572697D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C616E67756167654964222C7B676574';
wwv_flow_imp.g_varchar2_table(2784) := '3A66756E6374696F6E28297B72657475726E20746869732E5F6C616E677561676549647D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C4F626A6563742E646566696E6550726F706572747928652E70726F746F7479';
wwv_flow_imp.g_varchar2_table(2785) := '70652C2276657273696F6E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F76657273696F6E7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E6765745465';
wwv_flow_imp.g_varchar2_table(2786) := '78743D66756E6374696F6E2865297B69662865297B76617220743D746869732E6F6666736574417428652E7374617274292C6E3D746869732E6F6666736574417428652E656E64293B72657475726E20746869732E5F636F6E74656E742E737562737472';
wwv_flow_imp.g_varchar2_table(2787) := '696E6728742C6E297D72657475726E20746869732E5F636F6E74656E747D2C652E70726F746F747970652E7570646174653D66756E6374696F6E28652C74297B746869732E5F636F6E74656E743D652E746578742C746869732E5F76657273696F6E3D74';
wwv_flow_imp.g_varchar2_table(2788) := '2C746869732E5F6C696E654F6666736574733D766F696420307D2C652E70726F746F747970652E6765744C696E654F6666736574733D66756E6374696F6E28297B696628766F696420303D3D3D746869732E5F6C696E654F666673657473297B666F7228';
wwv_flow_imp.g_varchar2_table(2789) := '76617220653D5B5D2C743D746869732E5F636F6E74656E742C6E3D21302C723D303B723C742E6C656E6774683B722B2B297B6E262628652E707573682872292C6E3D2131293B76617220693D742E6368617241742872293B6E3D225C72223D3D3D697C7C';
wwv_flow_imp.g_varchar2_table(2790) := '225C6E223D3D3D692C225C72223D3D3D692626722B313C742E6C656E6774682626225C6E223D3D3D742E63686172417428722B31292626722B2B7D6E2626742E6C656E6774683E302626652E7075736828742E6C656E677468292C746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(2791) := '654F6666736574733D657D72657475726E20746869732E5F6C696E654F6666736574737D2C652E70726F746F747970652E706F736974696F6E41743D66756E6374696F6E2865297B653D4D6174682E6D6178284D6174682E6D696E28652C746869732E5F';
wwv_flow_imp.g_varchar2_table(2792) := '636F6E74656E742E6C656E677468292C30293B76617220743D746869732E6765744C696E654F66667365747328292C6E3D302C723D742E6C656E6774683B696628303D3D3D722972657475726E2075732E63726561746528302C65293B666F72283B6E3C';
wwv_flow_imp.g_varchar2_table(2793) := '723B297B76617220693D4D6174682E666C6F6F7228286E2B72292F32293B745B695D3E653F723D693A6E3D692B317D76617220733D6E2D313B72657475726E2075732E63726561746528732C652D745B735D297D2C652E70726F746F747970652E6F6666';
wwv_flow_imp.g_varchar2_table(2794) := '73657441743D66756E6374696F6E2865297B76617220743D746869732E6765744C696E654F66667365747328293B696628652E6C696E653E3D742E6C656E6774682972657475726E20746869732E5F636F6E74656E742E6C656E6774683B696628652E6C';
wwv_flow_imp.g_varchar2_table(2795) := '696E653C302972657475726E20303B766172206E3D745B652E6C696E655D2C723D652E6C696E652B313C742E6C656E6774683F745B652E6C696E652B315D3A746869732E5F636F6E74656E742E6C656E6774683B72657475726E204D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(2796) := '4D6174682E6D696E286E2B652E6368617261637465722C72292C6E297D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226C696E65436F756E74222C7B6765743A66756E6374696F6E28297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(2797) := '6869732E6765744C696E654F66667365747328292E6C656E6774687D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C657D28293B64613D68617C7C2868613D7B7D292C66613D4F626A6563742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(2798) := '2E746F537472696E672C64612E646566696E65643D66756E6374696F6E2865297B72657475726E20766F69642030213D3D657D2C64612E756E646566696E65643D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D657D2C64612E62';
wwv_flow_imp.g_varchar2_table(2799) := '6F6F6C65616E3D66756E6374696F6E2865297B72657475726E21303D3D3D657C7C21313D3D3D657D2C64612E737472696E673D66756E6374696F6E2865297B72657475726E225B6F626A65637420537472696E675D223D3D3D66612E63616C6C2865297D';
wwv_flow_imp.g_varchar2_table(2800) := '2C64612E6E756D6265723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D66612E63616C6C2865297D2C64612E6E756D62657252616E67653D66756E6374696F6E28652C742C6E297B72657475726E225B';
wwv_flow_imp.g_varchar2_table(2801) := '6F626A656374204E756D6265725D223D3D3D66612E63616C6C2865292626743C3D652626653C3D6E7D2C64612E696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D66612E63616C6C2865';
wwv_flow_imp.g_varchar2_table(2802) := '2926262D323134373438333634383C3D652626653C3D323134373438333634377D2C64612E75696E74656765723D66756E6374696F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D66612E63616C6C2865292626303C3D65';
wwv_flow_imp.g_varchar2_table(2803) := '2626653C3D323134373438333634377D2C64612E66756E633D66756E6374696F6E2865297B72657475726E225B6F626A6563742046756E6374696F6E5D223D3D3D66612E63616C6C2865297D2C64612E6F626A6563744C69746572616C3D66756E637469';
wwv_flow_imp.g_varchar2_table(2804) := '6F6E2865297B72657475726E206E756C6C213D3D652626226F626A656374223D3D747970656F6620657D2C64612E747970656441727261793D66756E6374696F6E28652C74297B72657475726E2041727261792E697341727261792865292626652E6576';
wwv_flow_imp.g_varchar2_table(2805) := '6572792874297D3B7661722067612C70612C76612C62612C79612C5F613D636C61737320657B636F6E7374727563746F7228652C742C6E2C72297B746869732E5F7572693D652C746869732E5F6C616E677561676549643D742C746869732E5F76657273';
wwv_flow_imp.g_varchar2_table(2806) := '696F6E3D6E2C746869732E5F636F6E74656E743D722C746869732E5F6C696E654F6666736574733D766F696420307D6765742075726928297B72657475726E20746869732E5F7572697D676574206C616E6775616765496428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(2807) := '69732E5F6C616E677561676549647D6765742076657273696F6E28297B72657475726E20746869732E5F76657273696F6E7D676574546578742865297B69662865297B636F6E737420743D746869732E6F6666736574417428652E7374617274292C6E3D';
wwv_flow_imp.g_varchar2_table(2808) := '746869732E6F6666736574417428652E656E64293B72657475726E20746869732E5F636F6E74656E742E737562737472696E6728742C6E297D72657475726E20746869732E5F636F6E74656E747D75706461746528742C6E297B666F72286C6574206E20';
wwv_flow_imp.g_varchar2_table(2809) := '6F66207429696628652E6973496E6372656D656E74616C286E29297B636F6E737420653D5361286E2E72616E6765292C743D746869732E6F6666736574417428652E7374617274292C723D746869732E6F6666736574417428652E656E64293B74686973';
wwv_flow_imp.g_varchar2_table(2810) := '2E5F636F6E74656E743D746869732E5F636F6E74656E742E737562737472696E6728302C74292B6E2E746578742B746869732E5F636F6E74656E742E737562737472696E6728722C746869732E5F636F6E74656E742E6C656E677468293B636F6E737420';
wwv_flow_imp.g_varchar2_table(2811) := '693D4D6174682E6D617828652E73746172742E6C696E652C30292C733D4D6174682E6D617828652E656E642E6C696E652C30293B6C6574206F3D746869732E5F6C696E654F6666736574733B636F6E737420613D7761286E2E746578742C21312C74293B';
wwv_flow_imp.g_varchar2_table(2812) := '696628732D693D3D3D612E6C656E67746829666F72286C657420653D302C743D612E6C656E6774683B653C743B652B2B296F5B652B692B315D3D615B655D3B656C736520612E6C656E6774683C3165343F6F2E73706C69636528692B312C732D692C2E2E';
wwv_flow_imp.g_varchar2_table(2813) := '2E61293A746869732E5F6C696E654F6666736574733D6F3D6F2E736C69636528302C692B31292E636F6E63617428612C6F2E736C69636528732B3129293B636F6E7374206C3D6E2E746578742E6C656E6774682D28722D74293B69662830213D3D6C2966';
wwv_flow_imp.g_varchar2_table(2814) := '6F72286C657420653D692B312B612E6C656E6774682C743D6F2E6C656E6774683B653C743B652B2B296F5B655D3D6F5B655D2B6C7D656C73657B69662821652E697346756C6C286E29297468726F77206E6577204572726F722822556E6B6E6F776E2063';
wwv_flow_imp.g_varchar2_table(2815) := '68616E6765206576656E7420726563656976656422293B746869732E5F636F6E74656E743D6E2E746578742C746869732E5F6C696E654F6666736574733D766F696420307D746869732E5F76657273696F6E3D6E7D6765744C696E654F66667365747328';
wwv_flow_imp.g_varchar2_table(2816) := '297B72657475726E20766F696420303D3D3D746869732E5F6C696E654F666673657473262628746869732E5F6C696E654F6666736574733D776128746869732E5F636F6E74656E742C213029292C746869732E5F6C696E654F6666736574737D706F7369';
wwv_flow_imp.g_varchar2_table(2817) := '74696F6E41742865297B653D4D6174682E6D6178284D6174682E6D696E28652C746869732E5F636F6E74656E742E6C656E677468292C30293B6C657420743D746869732E6765744C696E654F66667365747328292C6E3D302C723D742E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(2818) := '696628303D3D3D722972657475726E7B6C696E653A302C6368617261637465723A657D3B666F72283B6E3C723B297B6C657420693D4D6174682E666C6F6F7228286E2B72292F32293B745B695D3E653F723D693A6E3D692B317D6C657420693D6E2D313B';
wwv_flow_imp.g_varchar2_table(2819) := '72657475726E7B6C696E653A692C6368617261637465723A652D745B695D7D7D6F666673657441742865297B6C657420743D746869732E6765744C696E654F66667365747328293B696628652E6C696E653E3D742E6C656E6774682972657475726E2074';
wwv_flow_imp.g_varchar2_table(2820) := '6869732E5F636F6E74656E742E6C656E6774683B696628652E6C696E653C302972657475726E20303B6C6574206E3D745B652E6C696E655D2C723D652E6C696E652B313C742E6C656E6774683F745B652E6C696E652B315D3A746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(2821) := '6E742E6C656E6774683B72657475726E204D6174682E6D6178284D6174682E6D696E286E2B652E6368617261637465722C72292C6E297D676574206C696E65436F756E7428297B72657475726E20746869732E6765744C696E654F66667365747328292E';
wwv_flow_imp.g_varchar2_table(2822) := '6C656E6774687D737461746963206973496E6372656D656E74616C2865297B6C657420743D653B72657475726E206E756C6C213D74262622737472696E67223D3D747970656F6620742E746578742626766F69642030213D3D742E72616E676526262876';
wwv_flow_imp.g_varchar2_table(2823) := '6F696420303D3D3D742E72616E67654C656E6774687C7C226E756D626572223D3D747970656F6620742E72616E67654C656E677468297D73746174696320697346756C6C2865297B6C657420743D653B72657475726E206E756C6C213D74262622737472';
wwv_flow_imp.g_varchar2_table(2824) := '696E67223D3D747970656F6620742E746578742626766F696420303D3D3D742E72616E67652626766F696420303D3D3D742E72616E67654C656E6774687D7D3B66756E6374696F6E20436128652C74297B696628652E6C656E6774683C3D312972657475';
wwv_flow_imp.g_varchar2_table(2825) := '726E20653B636F6E7374206E3D652E6C656E6774682F327C302C723D652E736C69636528302C6E292C693D652E736C696365286E293B436128722C74292C436128692C74293B6C657420733D302C6F3D302C613D303B666F72283B733C722E6C656E6774';
wwv_flow_imp.g_varchar2_table(2826) := '6826266F3C692E6C656E6774683B297B6C6574206E3D7428725B735D2C695B6F5D293B655B612B2B5D3D6E3C3D303F725B732B2B5D3A695B6F2B2B5D7D666F72283B733C722E6C656E6774683B29655B612B2B5D3D725B732B2B5D3B666F72283B6F3C69';
wwv_flow_imp.g_varchar2_table(2827) := '2E6C656E6774683B29655B612B2B5D3D695B6F2B2B5D3B72657475726E20657D66756E6374696F6E20776128652C742C6E3D30297B636F6E737420723D743F5B6E5D3A5B5D3B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B6C65';
wwv_flow_imp.g_varchar2_table(2828) := '7420693D652E63686172436F646541742874293B3133213D3D6926263130213D3D697C7C2831333D3D3D692626742B313C652E6C656E677468262631303D3D3D652E63686172436F6465417428742B31292626742B2B2C722E70757368286E2B742B3129';
wwv_flow_imp.g_varchar2_table(2829) := '297D72657475726E20727D66756E6374696F6E2053612865297B636F6E737420743D652E73746172742C6E3D652E656E643B72657475726E20742E6C696E653E6E2E6C696E657C7C742E6C696E653D3D3D6E2E6C696E652626742E636861726163746572';
wwv_flow_imp.g_varchar2_table(2830) := '3E6E2E6368617261637465723F7B73746172743A6E2C656E643A747D3A657D66756E6374696F6E204C612865297B636F6E737420743D536128652E72616E6765293B72657475726E2074213D3D652E72616E67653F7B6E6577546578743A652E6E657754';
wwv_flow_imp.g_varchar2_table(2831) := '6578742C72616E67653A747D3A657D66756E6374696F6E20456128652C742C2E2E2E6E297B72657475726E2066756E6374696F6E28652C74297B6C6574206E3B72657475726E206E3D303D3D3D742E6C656E6774683F653A652E7265706C616365282F5C';
wwv_flow_imp.g_varchar2_table(2832) := '7B285C642B295C7D2F672C2828652C6E293D3E7B6C657420723D6E5B305D3B72657475726E20766F69642030213D3D745B725D3F745B725D3A657D29292C6E7D28742C6E297D66756E6374696F6E2078612865297B72657475726E2045617D2870613D67';
wwv_flow_imp.g_varchar2_table(2833) := '617C7C2867613D7B7D29292E6372656174653D66756E6374696F6E28652C742C6E2C72297B72657475726E206E6577205F6128652C742C6E2C72297D2C70612E7570646174653D66756E6374696F6E28652C742C6E297B6966286520696E7374616E6365';
wwv_flow_imp.g_varchar2_table(2834) := '6F66205F612972657475726E20652E75706461746528742C6E292C653B7468726F77206E6577204572726F72282254657874446F63756D656E742E7570646174653A20646F63756D656E74206D7573742062652063726561746564206279205465787444';
wwv_flow_imp.g_varchar2_table(2835) := '6F63756D656E742E63726561746522297D2C70612E6170706C7945646974733D66756E6374696F6E28652C74297B6C6574206E3D652E6765745465787428292C723D436128742E6D6170284C61292C2828652C74293D3E7B6C6574206E3D652E72616E67';
wwv_flow_imp.g_varchar2_table(2836) := '652E73746172742E6C696E652D742E72616E67652E73746172742E6C696E653B72657475726E20303D3D3D6E3F652E72616E67652E73746172742E6368617261637465722D742E72616E67652E73746172742E6368617261637465723A6E7D29292C693D';
wwv_flow_imp.g_varchar2_table(2837) := '303B636F6E737420733D5B5D3B666F7228636F6E73742074206F662072297B6C657420723D652E6F6666736574417428742E72616E67652E7374617274293B696628723C69297468726F77206E6577204572726F7228224F7665726C617070696E672065';
wwv_flow_imp.g_varchar2_table(2838) := '64697422293B723E692626732E70757368286E2E737562737472696E6728692C7229292C742E6E6577546578742E6C656E6774682626732E7075736828742E6E657754657874292C693D652E6F6666736574417428742E72616E67652E656E64297D7265';
wwv_flow_imp.g_varchar2_table(2839) := '7475726E20732E70757368286E2E737562737472286929292C732E6A6F696E282222297D2C2862613D76617C7C2876613D7B7D29295B62612E556E646566696E65643D305D3D22556E646566696E6564222C62615B62612E456E756D56616C75654D6973';
wwv_flow_imp.g_varchar2_table(2840) := '6D617463683D315D3D22456E756D56616C75654D69736D61746368222C62615B62612E446570726563617465643D325D3D2244657072656361746564222C62615B62612E556E6578706563746564456E644F66436F6D6D656E743D3235375D3D22556E65';
wwv_flow_imp.g_varchar2_table(2841) := '78706563746564456E644F66436F6D6D656E74222C62615B62612E556E6578706563746564456E644F66537472696E673D3235385D3D22556E6578706563746564456E644F66537472696E67222C62615B62612E556E6578706563746564456E644F664E';
wwv_flow_imp.g_varchar2_table(2842) := '756D6265723D3235395D3D22556E6578706563746564456E644F664E756D626572222C62615B62612E496E76616C6964556E69636F64653D3236305D3D22496E76616C6964556E69636F6465222C62615B62612E496E76616C6964457363617065436861';
wwv_flow_imp.g_varchar2_table(2843) := '7261637465723D3236315D3D22496E76616C6964457363617065436861726163746572222C62615B62612E496E76616C69644368617261637465723D3236325D3D22496E76616C6964436861726163746572222C62615B62612E50726F70657274794578';
wwv_flow_imp.g_varchar2_table(2844) := '7065637465643D3531335D3D2250726F70657274794578706563746564222C62615B62612E436F6D6D6145787065637465643D3531345D3D22436F6D6D614578706563746564222C62615B62612E436F6C6F6E45787065637465643D3531355D3D22436F';
wwv_flow_imp.g_varchar2_table(2845) := '6C6F6E4578706563746564222C62615B62612E56616C756545787065637465643D3531365D3D2256616C75654578706563746564222C62615B62612E436F6D6D614F72436C6F73654261636B657445787065637465643D3531375D3D22436F6D6D614F72';
wwv_flow_imp.g_varchar2_table(2846) := '436C6F73654261636B65744578706563746564222C62615B62612E436F6D6D614F72436C6F7365427261636545787065637465643D3531385D3D22436F6D6D614F72436C6F736542726163654578706563746564222C62615B62612E547261696C696E67';
wwv_flow_imp.g_varchar2_table(2847) := '436F6D6D613D3531395D3D22547261696C696E67436F6D6D61222C62615B62612E4475706C69636174654B65793D3532305D3D224475706C69636174654B6579222C62615B62612E436F6D6D656E744E6F745065726D69747465643D3532315D3D22436F';
wwv_flow_imp.g_varchar2_table(2848) := '6D6D656E744E6F745065726D6974746564222C62615B62612E536368656D615265736F6C76654572726F723D3736385D3D22536368656D615265736F6C76654572726F72222C2879617C7C2879613D7B7D29292E4C41544553543D7B74657874446F6375';
wwv_flow_imp.g_varchar2_table(2849) := '6D656E743A7B636F6D706C6574696F6E3A7B636F6D706C6574696F6E4974656D3A7B646F63756D656E746174696F6E466F726D61743A5B5F6F2E4D61726B646F776E2C5F6F2E506C61696E546578745D2C636F6D6D697443686172616374657273537570';
wwv_flow_imp.g_varchar2_table(2850) := '706F72743A21307D7D7D7D3B766172204E612C41612C6B613D66756E6374696F6E28297B76617220653D66756E6374696F6E28742C6E297B72657475726E28653D4F626A6563742E73657450726F746F747970654F667C7C7B5F5F70726F746F5F5F3A5B';
wwv_flow_imp.g_varchar2_table(2851) := '5D7D696E7374616E63656F66204172726179262666756E6374696F6E28652C74297B652E5F5F70726F746F5F5F3D747D7C7C66756E6374696F6E28652C74297B666F7228766172206E20696E2074294F626A6563742E70726F746F747970652E6861734F';
wwv_flow_imp.g_varchar2_table(2852) := '776E50726F70657274792E63616C6C28742C6E29262628655B6E5D3D745B6E5D297D2928742C6E297D3B72657475726E2066756E6374696F6E28742C6E297B6966282266756E6374696F6E22213D747970656F66206E26266E756C6C213D3D6E29746872';
wwv_flow_imp.g_varchar2_table(2853) := '6F77206E657720547970654572726F722822436C61737320657874656E64732076616C756520222B537472696E67286E292B22206973206E6F74206120636F6E7374727563746F72206F72206E756C6C22293B66756E6374696F6E207228297B74686973';
wwv_flow_imp.g_varchar2_table(2854) := '2E636F6E7374727563746F723D747D6528742C6E292C742E70726F746F747970653D6E756C6C3D3D3D6E3F4F626A6563742E637265617465286E293A28722E70726F746F747970653D6E2E70726F746F747970652C6E65772072297D7D28292C52613D78';
wwv_flow_imp.g_varchar2_table(2855) := '6128292C54613D7B22636F6C6F722D686578223A7B6572726F724D6573736167653A52612822636F6C6F72486578466F726D61745761726E696E67222C22496E76616C696420636F6C6F7220666F726D61742E2055736520235247422C2023524742412C';
wwv_flow_imp.g_varchar2_table(2856) := '2023525247474242206F72202352524747424241412E22292C7061747465726E3A2F5E23285B302D39412D46612D665D7B332C347D7C285B302D39412D46612D665D7B327D297B332C347D29242F7D2C22646174652D74696D65223A7B6572726F724D65';
wwv_flow_imp.g_varchar2_table(2857) := '73736167653A526128226461746554696D65466F726D61745761726E696E67222C22537472696E67206973206E6F742061205246433333333920646174652D74696D652E22292C7061747465726E3A2F5E285C647B347D292D28305B312D395D7C315B30';
wwv_flow_imp.g_varchar2_table(2858) := '2D325D292D28305B312D395D7C5B31325D5B302D395D7C335B30315D2954285B30315D5B302D395D7C325B302D335D293A285B302D355D5B302D395D293A285B302D355D5B302D395D7C363029285C2E5B302D395D2B293F285A7C285C2B7C2D29285B30';
wwv_flow_imp.g_varchar2_table(2859) := '315D5B302D395D7C325B302D335D293A285B302D355D5B302D395D2929242F697D2C646174653A7B6572726F724D6573736167653A5261282264617465466F726D61745761726E696E67222C22537472696E67206973206E6F7420612052464333333339';
wwv_flow_imp.g_varchar2_table(2860) := '20646174652E22292C7061747465726E3A2F5E285C647B347D292D28305B312D395D7C315B302D325D292D28305B312D395D7C5B31325D5B302D395D7C335B30315D29242F697D2C74696D653A7B6572726F724D6573736167653A5261282274696D6546';
wwv_flow_imp.g_varchar2_table(2861) := '6F726D61745761726E696E67222C22537472696E67206973206E6F74206120524643333333392074696D652E22292C7061747465726E3A2F5E285B30315D5B302D395D7C325B302D335D293A285B302D355D5B302D395D293A285B302D355D5B302D395D';
wwv_flow_imp.g_varchar2_table(2862) := '7C363029285C2E5B302D395D2B293F285A7C285C2B7C2D29285B30315D5B302D395D7C325B302D335D293A285B302D355D5B302D395D2929242F697D2C656D61696C3A7B6572726F724D6573736167653A52612822656D61696C466F726D61745761726E';
wwv_flow_imp.g_varchar2_table(2863) := '696E67222C22537472696E67206973206E6F7420616E20652D6D61696C20616464726573732E22292C7061747465726E3A2F5E28285B5E3C3E28295C5B5C5D5C5C2E2C3B3A5C7340225D2B285C2E5B5E3C3E28295C5B5C5D5C5C2E2C3B3A5C7340225D2B';
wwv_flow_imp.g_varchar2_table(2864) := '292A297C28222E2B2229294028285C5B5B302D395D7B312C337D5C2E5B302D395D7B312C337D5C2E5B302D395D7B312C337D5C2E5B302D395D7B312C337D5D297C28285B612D7A412D5A302D392D5D2B5C2E292B5B612D7A412D5A5D7B322C7D2929242F';
wwv_flow_imp.g_varchar2_table(2865) := '7D2C686F73746E616D653A7B6572726F724D6573736167653A52612822686F73746E616D65466F726D61745761726E696E67222C22537472696E67206973206E6F74206120686F73746E616D652E22292C7061747465726E3A2F5E283F3D2E7B312C3235';
wwv_flow_imp.g_varchar2_table(2866) := '337D5C2E3F24295B612D7A302D395D283F3A5B612D7A302D392D5D7B302C36317D5B612D7A302D395D293F283F3A5C2E5B612D7A302D395D283F3A5B2D302D39612D7A5D7B302C36317D5B302D39612D7A5D293F292A5C2E3F242F697D2C697076343A7B';
wwv_flow_imp.g_varchar2_table(2867) := '6572726F724D6573736167653A5261282269707634466F726D61745761726E696E67222C22537472696E67206973206E6F7420616E204950763420616464726573732E22292C7061747465726E3A2F5E283F3A283F3A32355B302D355D7C325B302D345D';
wwv_flow_imp.g_varchar2_table(2868) := '5C647C315C645C647C5B312D395D3F5C64295C2E297B337D283F3A32355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429242F7D2C697076363A7B6572726F724D6573736167653A5261282269707636466F726D61745761726E';
wwv_flow_imp.g_varchar2_table(2869) := '696E67222C22537472696E67206973206E6F7420616E204950763620616464726573732E22292C7061747465726E3A2F5E2828285B302D39612D665D7B312C347D3A297B377D285B302D39612D665D7B312C347D7C3A29297C28285B302D39612D665D7B';
wwv_flow_imp.g_varchar2_table(2870) := '312C347D3A297B367D283A5B302D39612D665D7B312C347D7C282832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429285C2E2832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429297B337D29';
wwv_flow_imp.g_varchar2_table(2871) := '7C3A29297C28285B302D39612D665D7B312C347D3A297B357D2828283A5B302D39612D665D7B312C347D297B312C327D297C3A282832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429285C2E2832355B302D355D7C325B30';
wwv_flow_imp.g_varchar2_table(2872) := '2D345D5C647C315C645C647C5B312D395D3F5C6429297B337D297C3A29297C28285B302D39612D665D7B312C347D3A297B347D2828283A5B302D39612D665D7B312C347D297B312C337D297C28283A5B302D39612D665D7B312C347D293F3A282832355B';
wwv_flow_imp.g_varchar2_table(2873) := '302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429285C2E2832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429297B337D29297C3A29297C28285B302D39612D665D7B312C347D3A297B337D2828283A';
wwv_flow_imp.g_varchar2_table(2874) := '5B302D39612D665D7B312C347D297B312C347D297C28283A5B302D39612D665D7B312C347D297B302C327D3A282832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429285C2E2832355B302D355D7C325B302D345D5C647C31';
wwv_flow_imp.g_varchar2_table(2875) := '5C645C647C5B312D395D3F5C6429297B337D29297C3A29297C28285B302D39612D665D7B312C347D3A297B327D2828283A5B302D39612D665D7B312C347D297B312C357D297C28283A5B302D39612D665D7B312C347D297B302C337D3A282832355B302D';
wwv_flow_imp.g_varchar2_table(2876) := '355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429285C2E2832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429297B337D29297C3A29297C28285B302D39612D665D7B312C347D3A297B317D2828283A5B30';
wwv_flow_imp.g_varchar2_table(2877) := '2D39612D665D7B312C347D297B312C367D297C28283A5B302D39612D665D7B312C347D297B302C347D3A282832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429285C2E2832355B302D355D7C325B302D345D5C647C315C64';
wwv_flow_imp.g_varchar2_table(2878) := '5C647C5B312D395D3F5C6429297B337D29297C3A29297C283A2828283A5B302D39612D665D7B312C347D297B312C377D297C28283A5B302D39612D665D7B312C347D297B302C357D3A282832355B302D355D7C325B302D345D5C647C315C645C647C5B31';
wwv_flow_imp.g_varchar2_table(2879) := '2D395D3F5C6429285C2E2832355B302D355D7C325B302D345D5C647C315C645C647C5B312D395D3F5C6429297B337D29297C3A292929242F697D7D2C4D613D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E297B766F696420303D3D';
wwv_flow_imp.g_varchar2_table(2880) := '3D6E2626286E3D30292C746869732E6F66667365743D742C746869732E6C656E6774683D6E2C746869732E706172656E743D657D72657475726E204F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C226368696C6472';
wwv_flow_imp.g_varchar2_table(2881) := '656E222C7B6765743A66756E6374696F6E28297B72657475726E5B5D7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E746F537472696E673D66756E6374696F6E28297B72657475726E';
wwv_flow_imp.g_varchar2_table(2882) := '22747970653A20222B746869732E747970652B222028222B746869732E6F66667365742B222F222B746869732E6C656E6774682B2229222B28746869732E706172656E743F2220706172656E743A207B222B746869732E706172656E742E746F53747269';
wwv_flow_imp.g_varchar2_table(2883) := '6E6728292B227D223A2222297D2C657D28292C4F613D66756E6374696F6E2865297B66756E6374696F6E207428742C6E297B76617220723D652E63616C6C28746869732C742C6E297C7C746869733B72657475726E20722E747970653D226E756C6C222C';
wwv_flow_imp.g_varchar2_table(2884) := '722E76616C75653D6E756C6C2C727D72657475726E206B6128742C65292C747D284D61292C49613D66756E6374696F6E2865297B66756E6374696F6E207428742C6E2C72297B76617220693D652E63616C6C28746869732C742C72297C7C746869733B72';
wwv_flow_imp.g_varchar2_table(2885) := '657475726E20692E747970653D22626F6F6C65616E222C692E76616C75653D6E2C697D72657475726E206B6128742C65292C747D284D61292C50613D66756E6374696F6E2865297B66756E6374696F6E207428742C6E297B76617220723D652E63616C6C';
wwv_flow_imp.g_varchar2_table(2886) := '28746869732C742C6E297C7C746869733B72657475726E20722E747970653D226172726179222C722E6974656D733D5B5D2C727D72657475726E206B6128742C65292C4F626A6563742E646566696E6550726F706572747928742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(2887) := '2C226368696C6472656E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E6974656D737D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C747D284D61292C46613D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(2888) := '7B66756E6374696F6E207428742C6E297B76617220723D652E63616C6C28746869732C742C6E297C7C746869733B72657475726E20722E747970653D226E756D626572222C722E6973496E74656765723D21302C722E76616C75653D4E756D6265722E4E';
wwv_flow_imp.g_varchar2_table(2889) := '614E2C727D72657475726E206B6128742C65292C747D284D61292C56613D66756E6374696F6E2865297B66756E6374696F6E207428742C6E2C72297B76617220693D652E63616C6C28746869732C742C6E2C72297C7C746869733B72657475726E20692E';
wwv_flow_imp.g_varchar2_table(2890) := '747970653D22737472696E67222C692E76616C75653D22222C697D72657475726E206B6128742C65292C747D284D61292C44613D66756E6374696F6E2865297B66756E6374696F6E207428742C6E2C72297B76617220693D652E63616C6C28746869732C';
wwv_flow_imp.g_varchar2_table(2891) := '742C6E297C7C746869733B72657475726E20692E747970653D2270726F7065727479222C692E636F6C6F6E4F66667365743D2D312C692E6B65794E6F64653D722C697D72657475726E206B6128742C65292C4F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(2892) := '72747928742E70726F746F747970652C226368696C6472656E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E76616C75654E6F64653F5B746869732E6B65794E6F64652C746869732E76616C75654E6F64655D3A5B74686973';
wwv_flow_imp.g_varchar2_table(2893) := '2E6B65794E6F64655D7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C747D284D61292C71613D66756E6374696F6E2865297B66756E6374696F6E207428742C6E297B76617220723D652E63616C6C28746869732C74';
wwv_flow_imp.g_varchar2_table(2894) := '2C6E297C7C746869733B72657475726E20722E747970653D226F626A656374222C722E70726F706572746965733D5B5D2C727D72657475726E206B6128742C65292C4F626A6563742E646566696E6550726F706572747928742E70726F746F747970652C';
wwv_flow_imp.g_varchar2_table(2895) := '226368696C6472656E222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E70726F706572746965737D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C747D284D61293B66756E6374696F6E204B';
wwv_flow_imp.g_varchar2_table(2896) := '612865297B72657475726E206C6F2865293F653F7B7D3A7B6E6F743A7B7D7D3A657D2841613D4E617C7C284E613D7B7D29295B41612E4B65793D305D3D224B6579222C41615B41612E456E756D3D315D3D22456E756D223B766172206A613D66756E6374';
wwv_flow_imp.g_varchar2_table(2897) := '696F6E28297B66756E6374696F6E206528652C74297B766F696420303D3D3D65262628653D2D31292C746869732E666F6375734F66667365743D652C746869732E6578636C7564653D742C746869732E736368656D61733D5B5D7D72657475726E20652E';
wwv_flow_imp.g_varchar2_table(2898) := '70726F746F747970652E6164643D66756E6374696F6E2865297B746869732E736368656D61732E707573682865297D2C652E70726F746F747970652E6D657267653D66756E6374696F6E2865297B41727261792E70726F746F747970652E707573682E61';
wwv_flow_imp.g_varchar2_table(2899) := '70706C7928746869732E736368656D61732C652E736368656D6173297D2C652E70726F746F747970652E696E636C7564653D66756E6374696F6E2865297B72657475726E282D313D3D3D746869732E666F6375734F66667365747C7C7A6128652C746869';
wwv_flow_imp.g_varchar2_table(2900) := '732E666F6375734F66667365742929262665213D3D746869732E6578636C7564657D2C652E70726F746F747970652E6E65775375623D66756E6374696F6E28297B72657475726E206E65772065282D312C746869732E6578636C756465297D2C657D2829';
wwv_flow_imp.g_varchar2_table(2901) := '2C55613D66756E6374696F6E28297B66756E6374696F6E206528297B7D72657475726E204F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C22736368656D6173222C7B6765743A66756E6374696F6E28297B72657475';
wwv_flow_imp.g_varchar2_table(2902) := '726E5B5D7D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E6164643D66756E6374696F6E2865297B7D2C652E70726F746F747970652E6D657267653D66756E6374696F6E2865297B7D2C';
wwv_flow_imp.g_varchar2_table(2903) := '652E70726F746F747970652E696E636C7564653D66756E6374696F6E2865297B72657475726E21307D2C652E70726F746F747970652E6E65775375623D66756E6374696F6E28297B72657475726E20746869737D2C652E696E7374616E63653D6E657720';
wwv_flow_imp.g_varchar2_table(2904) := '652C657D28292C42613D66756E6374696F6E28297B66756E6374696F6E206528297B746869732E70726F626C656D733D5B5D2C746869732E70726F706572746965734D6174636865733D302C746869732E70726F7065727469657356616C75654D617463';
wwv_flow_imp.g_varchar2_table(2905) := '6865733D302C746869732E7072696D61727956616C75654D6174636865733D302C746869732E656E756D56616C75654D617463683D21312C746869732E656E756D56616C7565733D766F696420307D72657475726E20652E70726F746F747970652E6861';
wwv_flow_imp.g_varchar2_table(2906) := '7350726F626C656D733D66756E6374696F6E28297B72657475726E2121746869732E70726F626C656D732E6C656E6774687D2C652E70726F746F747970652E6D65726765416C6C3D66756E6374696F6E2865297B666F722876617220743D302C6E3D653B';
wwv_flow_imp.g_varchar2_table(2907) := '743C6E2E6C656E6774683B742B2B297B76617220723D6E5B745D3B746869732E6D657267652872297D7D2C652E70726F746F747970652E6D657267653D66756E6374696F6E2865297B746869732E70726F626C656D733D746869732E70726F626C656D73';
wwv_flow_imp.g_varchar2_table(2908) := '2E636F6E63617428652E70726F626C656D73297D2C652E70726F746F747970652E6D65726765456E756D56616C7565733D66756E6374696F6E2865297B69662821746869732E656E756D56616C75654D61746368262621652E656E756D56616C75654D61';
wwv_flow_imp.g_varchar2_table(2909) := '7463682626746869732E656E756D56616C7565732626652E656E756D56616C756573297B746869732E656E756D56616C7565733D746869732E656E756D56616C7565732E636F6E63617428652E656E756D56616C756573293B666F722876617220743D30';
wwv_flow_imp.g_varchar2_table(2910) := '2C6E3D746869732E70726F626C656D733B743C6E2E6C656E6774683B742B2B297B76617220723D6E5B745D3B722E636F64653D3D3D76612E456E756D56616C75654D69736D61746368262628722E6D6573736167653D52612822656E756D5761726E696E';
wwv_flow_imp.g_varchar2_table(2911) := '67222C2256616C7565206973206E6F742061636365707465642E2056616C69642076616C7565733A207B307D2E222C746869732E656E756D56616C7565732E6D6170282866756E6374696F6E2865297B72657475726E204A534F4E2E737472696E676966';
wwv_flow_imp.g_varchar2_table(2912) := '792865297D29292E6A6F696E28222C20222929297D7D7D2C652E70726F746F747970652E6D6572676550726F70657274794D617463683D66756E6374696F6E2865297B746869732E6D657267652865292C746869732E70726F706572746965734D617463';
wwv_flow_imp.g_varchar2_table(2913) := '6865732B2B2C28652E656E756D56616C75654D617463687C7C21652E68617350726F626C656D7328292626652E70726F706572746965734D617463686573292626746869732E70726F7065727469657356616C75654D6174636865732B2B2C652E656E75';
wwv_flow_imp.g_varchar2_table(2914) := '6D56616C75654D617463682626652E656E756D56616C7565732626313D3D3D652E656E756D56616C7565732E6C656E6774682626746869732E7072696D61727956616C75654D6174636865732B2B7D2C652E70726F746F747970652E636F6D706172653D';
wwv_flow_imp.g_varchar2_table(2915) := '66756E6374696F6E2865297B76617220743D746869732E68617350726F626C656D7328293B72657475726E2074213D3D652E68617350726F626C656D7328293F743F2D313A313A746869732E656E756D56616C75654D61746368213D3D652E656E756D56';
wwv_flow_imp.g_varchar2_table(2916) := '616C75654D617463683F652E656E756D56616C75654D617463683F2D313A313A746869732E7072696D61727956616C75654D617463686573213D3D652E7072696D61727956616C75654D6174636865733F746869732E7072696D61727956616C75654D61';
wwv_flow_imp.g_varchar2_table(2917) := '74636865732D652E7072696D61727956616C75654D6174636865733A746869732E70726F7065727469657356616C75654D617463686573213D3D652E70726F7065727469657356616C75654D6174636865733F746869732E70726F706572746965735661';
wwv_flow_imp.g_varchar2_table(2918) := '6C75654D6174636865732D652E70726F7065727469657356616C75654D6174636865733A746869732E70726F706572746965734D6174636865732D652E70726F706572746965734D6174636865737D2C657D28293B66756E6374696F6E2024612865297B';
wwv_flow_imp.g_varchar2_table(2919) := '72657475726E20696F2865297D66756E6374696F6E2057612865297B72657475726E20726F2865297D66756E6374696F6E207A6128652C742C6E297B72657475726E20766F696420303D3D3D6E2626286E3D2131292C743E3D652E6F6666736574262674';
wwv_flow_imp.g_varchar2_table(2920) := '3C652E6F66667365742B652E6C656E6774687C7C6E2626743D3D3D652E6F66667365742B652E6C656E6774687D7661722048613D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E297B766F696420303D3D3D74262628743D5B5D292C';
wwv_flow_imp.g_varchar2_table(2921) := '766F696420303D3D3D6E2626286E3D5B5D292C746869732E726F6F743D652C746869732E73796E7461784572726F72733D742C746869732E636F6D6D656E74733D6E7D72657475726E20652E70726F746F747970652E6765744E6F646546726F6D4F6666';
wwv_flow_imp.g_varchar2_table(2922) := '7365743D66756E6374696F6E28652C74297B696628766F696420303D3D3D74262628743D2131292C746869732E726F6F742972657475726E206E6F28746869732E726F6F742C652C74297D2C652E70726F746F747970652E76697369743D66756E637469';
wwv_flow_imp.g_varchar2_table(2923) := '6F6E2865297B696628746869732E726F6F74297B76617220743D66756E6374696F6E286E297B76617220723D65286E292C693D6E2E6368696C6472656E3B69662841727261792E6973417272617928692929666F722876617220733D303B733C692E6C65';
wwv_flow_imp.g_varchar2_table(2924) := '6E6774682626723B732B2B29723D7428695B735D293B72657475726E20727D3B7428746869732E726F6F74297D7D2C652E70726F746F747970652E76616C69646174653D66756E6374696F6E28652C742C6E297B696628766F696420303D3D3D6E262628';
wwv_flow_imp.g_varchar2_table(2925) := '6E3D6B732E5761726E696E67292C746869732E726F6F74262674297B76617220723D6E65772042613B72657475726E20476128746869732E726F6F742C742C722C55612E696E7374616E6365292C722E70726F626C656D732E6D6170282866756E637469';
wwv_flow_imp.g_varchar2_table(2926) := '6F6E2874297B76617220722C693D68732E63726561746528652E706F736974696F6E417428742E6C6F636174696F6E2E6F6666736574292C652E706F736974696F6E417428742E6C6F636174696F6E2E6F66667365742B742E6C6F636174696F6E2E6C65';
wwv_flow_imp.g_varchar2_table(2927) := '6E67746829293B72657475726E2049732E63726561746528692C742E6D6573736167652C6E756C6C213D3D28723D742E7365766572697479292626766F69642030213D3D723F723A6E2C742E636F6465297D29297D7D2C652E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(2928) := '65744D61746368696E67536368656D61733D66756E6374696F6E28652C742C6E297B766F696420303D3D3D74262628743D2D31293B76617220723D6E6577206A6128742C6E293B72657475726E20746869732E726F6F742626652626476128746869732E';
wwv_flow_imp.g_varchar2_table(2929) := '726F6F742C652C6E65772042612C72292C722E736368656D61737D2C657D28293B66756E6374696F6E20476128652C742C6E2C72297B696628652626722E696E636C756465286529297B76617220693D653B73776974636828692E74797065297B636173';
wwv_flow_imp.g_varchar2_table(2930) := '65226F626A656374223A2166756E6374696F6E28652C742C6E2C72297B666F722876617220693D4F626A6563742E637265617465286E756C6C292C733D5B5D2C6F3D302C613D652E70726F706572746965733B6F3C612E6C656E6774683B6F2B2B29695B';
wwv_flow_imp.g_varchar2_table(2931) := '713D28703D615B6F5D292E6B65794E6F64652E76616C75655D3D702E76616C75654E6F64652C732E707573682871293B69662841727261792E6973417272617928742E72657175697265642929666F7228766172206C3D302C753D742E72657175697265';
wwv_flow_imp.g_varchar2_table(2932) := '643B6C3C752E6C656E6774683B6C2B2B2969662821695B533D755B6C5D5D297B76617220633D652E706172656E7426262270726F7065727479223D3D3D652E706172656E742E747970652626652E706172656E742E6B65794E6F64652C683D633F7B6F66';
wwv_flow_imp.g_varchar2_table(2933) := '667365743A632E6F66667365742C6C656E6774683A632E6C656E6774687D3A7B6F66667365743A652E6F66667365742C6C656E6774683A317D3B6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A682C6D6573736167653A526128224D69';
wwv_flow_imp.g_varchar2_table(2934) := '7373696E67526571756972656450726F705761726E696E67222C274D697373696E672070726F706572747920227B307D222E272C53297D297D76617220643D66756E6374696F6E2865297B666F722876617220743D732E696E6465784F662865293B743E';
wwv_flow_imp.g_varchar2_table(2935) := '3D303B29732E73706C69636528742C31292C743D732E696E6465784F662865297D3B696628742E70726F7065727469657329666F722876617220663D302C6D3D4F626A6563742E6B65797328742E70726F70657274696573293B663C6D2E6C656E677468';
wwv_flow_imp.g_varchar2_table(2936) := '3B662B2B297B6428533D6D5B665D293B76617220673D742E70726F706572746965735B535D3B6966286B3D695B535D296966286C6F2867292969662867296E2E70726F706572746965734D6174636865732B2B2C6E2E70726F7065727469657356616C75';
wwv_flow_imp.g_varchar2_table(2937) := '654D6174636865732B2B3B656C73657B76617220703D6B2E706172656E743B6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A702E6B65794E6F64652E6F66667365742C6C656E6774683A702E6B65794E6F64652E6C';
wwv_flow_imp.g_varchar2_table(2938) := '656E6774687D2C6D6573736167653A742E6572726F724D6573736167657C7C52612822446973616C6C6F776564457874726150726F705761726E696E67222C2250726F7065727479207B307D206973206E6F7420616C6C6F7765642E222C53297D297D65';
wwv_flow_imp.g_varchar2_table(2939) := '6C7365204761286B2C672C783D6E65772042612C72292C6E2E6D6572676550726F70657274794D617463682878297D696628742E7061747465726E50726F7065727469657329666F722876617220763D302C623D4F626A6563742E6B65797328742E7061';
wwv_flow_imp.g_varchar2_table(2940) := '747465726E50726F70657274696573293B763C622E6C656E6774683B762B2B29666F722876617220793D625B765D2C5F3D636F2879292C433D302C773D732E736C6963652830293B433C772E6C656E6774683B432B2B297B76617220533D775B435D3B28';
wwv_flow_imp.g_varchar2_table(2941) := '6E756C6C3D3D5F3F766F696420303A5F2E7465737428532929262628642853292C286B3D695B535D292626286C6F28673D742E7061747465726E50726F706572746965735B795D293F673F286E2E70726F706572746965734D6174636865732B2B2C6E2E';
wwv_flow_imp.g_varchar2_table(2942) := '70726F7065727469657356616C75654D6174636865732B2B293A28703D6B2E706172656E742C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A702E6B65794E6F64652E6F66667365742C6C656E6774683A702E6B65';
wwv_flow_imp.g_varchar2_table(2943) := '794E6F64652E6C656E6774687D2C6D6573736167653A742E6572726F724D6573736167657C7C52612822446973616C6C6F776564457874726150726F705761726E696E67222C2250726F7065727479207B307D206973206E6F7420616C6C6F7765642E22';
wwv_flow_imp.g_varchar2_table(2944) := '2C53297D29293A284761286B2C672C783D6E65772042612C72292C6E2E6D6572676550726F70657274794D617463682878292929297D696628226F626A656374223D3D747970656F6620742E6164646974696F6E616C50726F70657274696573297B666F';
wwv_flow_imp.g_varchar2_table(2945) := '7228766172204C3D302C453D733B4C3C452E6C656E6774683B4C2B2B296966286B3D695B533D455B4C5D5D297B76617220783D6E65772042613B4761286B2C742E6164646974696F6E616C50726F706572746965732C782C72292C6E2E6D657267655072';
wwv_flow_imp.g_varchar2_table(2946) := '6F70657274794D617463682878297D7D656C73652069662821313D3D3D742E6164646974696F6E616C50726F706572746965732626732E6C656E6774683E3029666F7228766172204E3D302C413D733B4E3C412E6C656E6774683B4E2B2B297B76617220';
wwv_flow_imp.g_varchar2_table(2947) := '6B3B286B3D695B533D415B4E5D5D29262628703D6B2E706172656E742C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A702E6B65794E6F64652E6F66667365742C6C656E6774683A702E6B65794E6F64652E6C656E';
wwv_flow_imp.g_varchar2_table(2948) := '6774687D2C6D6573736167653A742E6572726F724D6573736167657C7C52612822446973616C6C6F776564457874726150726F705761726E696E67222C2250726F7065727479207B307D206973206E6F7420616C6C6F7765642E222C53297D29297D6966';
wwv_flow_imp.g_varchar2_table(2949) := '286F6F28742E6D617850726F70657274696573292626652E70726F706572746965732E6C656E6774683E742E6D617850726F7065727469657326266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365';
wwv_flow_imp.g_varchar2_table(2950) := '742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128224D617850726F705761726E696E67222C224F626A65637420686173206D6F72652070726F70657274696573207468616E206C696D6974206F66207B307D2E222C742E6D6178';
wwv_flow_imp.g_varchar2_table(2951) := '50726F70657274696573297D292C6F6F28742E6D696E50726F70657274696573292626652E70726F706572746965732E6C656E6774683C742E6D696E50726F7065727469657326266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F';
wwv_flow_imp.g_varchar2_table(2952) := '66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128224D696E50726F705761726E696E67222C224F626A656374206861732066657765722070726F70657274696573207468616E20746865207265';
wwv_flow_imp.g_varchar2_table(2953) := '717569726564206E756D626572206F66207B307D222C742E6D696E50726F70657274696573297D292C742E646570656E64656E6369657329666F722876617220523D302C543D4F626A6563742E6B65797328742E646570656E64656E63696573293B523C';
wwv_flow_imp.g_varchar2_table(2954) := '542E6C656E6774683B522B2B29696628695B713D545B525D5D297B766172204D3D742E646570656E64656E636965735B715D3B69662841727261792E69734172726179284D2929666F7228766172204F3D302C493D4D3B4F3C492E6C656E6774683B4F2B';
wwv_flow_imp.g_varchar2_table(2955) := '2B297B76617220503D495B4F5D3B695B505D3F6E2E70726F7065727469657356616C75654D6174636865732B2B3A6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C65';
wwv_flow_imp.g_varchar2_table(2956) := '6E6774687D2C6D6573736167653A526128225265717569726564446570656E64656E7450726F705761726E696E67222C224F626A656374206973206D697373696E672070726F7065727479207B307D2072657175697265642062792070726F7065727479';
wwv_flow_imp.g_varchar2_table(2957) := '207B317D2E222C502C71297D297D656C736528673D4B61284D2929262628476128652C672C783D6E65772042612C72292C6E2E6D6572676550726F70657274794D61746368287829297D76617220463D4B6128742E70726F70657274794E616D6573293B';
wwv_flow_imp.g_varchar2_table(2958) := '6966284629666F722876617220563D302C443D652E70726F706572746965733B563C442E6C656E6774683B562B2B297B76617220713B28713D445B565D2E6B65794E6F6465292626476128712C462C6E2C55612E696E7374616E6365297D7D28692C742C';
wwv_flow_imp.g_varchar2_table(2959) := '6E2C72293B627265616B3B63617365226172726179223A2166756E6374696F6E28652C742C6E2C72297B69662841727261792E6973417272617928742E6974656D7329297B666F722876617220693D742E6974656D732C733D303B733C692E6C656E6774';
wwv_flow_imp.g_varchar2_table(2960) := '683B732B2B297B766172206F3D4B6128695B735D292C613D6E65772042613B28643D652E6974656D735B735D293F28476128642C6F2C612C72292C6E2E6D6572676550726F70657274794D61746368286129293A652E6974656D732E6C656E6774683E3D';
wwv_flow_imp.g_varchar2_table(2961) := '692E6C656E67746826266E2E70726F7065727469657356616C75654D6174636865732B2B7D696628652E6974656D732E6C656E6774683E692E6C656E67746829696628226F626A656374223D3D747970656F6620742E6164646974696F6E616C4974656D';
wwv_flow_imp.g_varchar2_table(2962) := '7329666F7228766172206C3D692E6C656E6774683B6C3C652E6974656D732E6C656E6774683B6C2B2B29613D6E65772042612C476128652E6974656D735B6C5D2C742E6164646974696F6E616C4974656D732C612C72292C6E2E6D6572676550726F7065';
wwv_flow_imp.g_varchar2_table(2963) := '7274794D617463682861293B656C736521313D3D3D742E6164646974696F6E616C4974656D7326266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C';
wwv_flow_imp.g_varchar2_table(2964) := '6D6573736167653A526128226164646974696F6E616C4974656D735761726E696E67222C2241727261792068617320746F6F206D616E79206974656D73206163636F7264696E6720746F20736368656D612E204578706563746564207B307D206F722066';
wwv_flow_imp.g_varchar2_table(2965) := '657765722E222C692E6C656E677468297D297D656C73657B76617220753D4B6128742E6974656D73293B6966287529666F722876617220633D302C683D652E6974656D733B633C682E6C656E6774683B632B2B297B76617220643B476128643D685B635D';
wwv_flow_imp.g_varchar2_table(2966) := '2C752C613D6E65772042612C72292C6E2E6D6572676550726F70657274794D617463682861297D7D76617220663D4B6128742E636F6E7461696E73293B69662866262628652E6974656D732E736F6D65282866756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(2967) := '6E65772042613B72657475726E20476128652C662C742C55612E696E7374616E6365292C21742E68617350726F626C656D7328297D29297C7C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C';
wwv_flow_imp.g_varchar2_table(2968) := '6C656E6774683A652E6C656E6774687D2C6D6573736167653A742E6572726F724D6573736167657C7C5261282272657175697265644974656D4D697373696E675761726E696E67222C22417272617920646F6573206E6F7420636F6E7461696E20726571';
wwv_flow_imp.g_varchar2_table(2969) := '7569726564206974656D2E22297D29292C6F6F28742E6D696E4974656D73292626652E6974656D732E6C656E6774683C742E6D696E4974656D7326266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F666673';
wwv_flow_imp.g_varchar2_table(2970) := '65742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226D696E4974656D735761726E696E67222C2241727261792068617320746F6F20666577206974656D732E204578706563746564207B307D206F72206D6F72652E222C742E';
wwv_flow_imp.g_varchar2_table(2971) := '6D696E4974656D73297D292C6F6F28742E6D61784974656D73292626652E6974656D732E6C656E6774683E742E6D61784974656D7326266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C65';
wwv_flow_imp.g_varchar2_table(2972) := '6E6774683A652E6C656E6774687D2C6D6573736167653A526128226D61784974656D735761726E696E67222C2241727261792068617320746F6F206D616E79206974656D732E204578706563746564207B307D206F722066657765722E222C742E6D6178';
wwv_flow_imp.g_varchar2_table(2973) := '4974656D73297D292C21303D3D3D742E756E697175654974656D73297B766172206D3D24612865293B6D2E736F6D65282866756E6374696F6E28652C74297B72657475726E2074213D3D6D2E6C617374496E6465784F662865297D292926266E2E70726F';
wwv_flow_imp.g_varchar2_table(2974) := '626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A52612822756E697175654974656D735761726E696E67222C22417272617920686173206475';
wwv_flow_imp.g_varchar2_table(2975) := '706C6963617465206974656D732E22297D297D7D28692C742C6E2C72293B627265616B3B6361736522737472696E67223A2166756E6374696F6E28652C742C6E297B6966286F6F28742E6D696E4C656E677468292626652E76616C75652E6C656E677468';
wwv_flow_imp.g_varchar2_table(2976) := '3C742E6D696E4C656E67746826266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226D696E4C656E6774685761726E69';
wwv_flow_imp.g_varchar2_table(2977) := '6E67222C22537472696E672069732073686F72746572207468616E20746865206D696E696D756D206C656E677468206F66207B307D2E222C742E6D696E4C656E677468297D292C6F6F28742E6D61784C656E677468292626652E76616C75652E6C656E67';
wwv_flow_imp.g_varchar2_table(2978) := '74683E742E6D61784C656E67746826266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226D61784C656E677468576172';
wwv_flow_imp.g_varchar2_table(2979) := '6E696E67222C22537472696E67206973206C6F6E676572207468616E20746865206D6178696D756D206C656E677468206F66207B307D2E222C742E6D61784C656E677468297D292C22737472696E67223D3D747970656F6620742E7061747465726E297B';
wwv_flow_imp.g_varchar2_table(2980) := '76617220723D636F28742E7061747465726E293B286E756C6C3D3D723F766F696420303A722E7465737428652E76616C756529297C7C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E';
wwv_flow_imp.g_varchar2_table(2981) := '6774683A652E6C656E6774687D2C6D6573736167653A742E7061747465726E4572726F724D6573736167657C7C742E6572726F724D6573736167657C7C526128227061747465726E5761726E696E67222C27537472696E6720646F6573206E6F74206D61';
wwv_flow_imp.g_varchar2_table(2982) := '74636820746865207061747465726E206F6620227B307D222E272C742E7061747465726E297D297D696628742E666F726D61742973776974636828742E666F726D6174297B6361736522757269223A63617365227572692D7265666572656E6365223A76';
wwv_flow_imp.g_varchar2_table(2983) := '617220693D766F696420303B696628652E76616C7565297B76617220733D2F5E28285B5E3A2F3F235D2B3F293A293F285C2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A29293F2823282E2A29293F2F2E6578656328652E';
wwv_flow_imp.g_varchar2_table(2984) := '76616C7565293B733F735B325D7C7C2275726922213D3D742E666F726D61747C7C28693D52612822757269536368656D654D697373696E67222C225552492077697468206120736368656D652069732065787065637465642E2229293A693D5261282275';
wwv_flow_imp.g_varchar2_table(2985) := '72694D697373696E67222C225552492069732065787065637465642E22297D656C736520693D52612822757269456D707479222C225552492065787065637465642E22293B6926266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F';
wwv_flow_imp.g_varchar2_table(2986) := '66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A742E7061747465726E4572726F724D6573736167657C7C742E6572726F724D6573736167657C7C52612822757269466F726D61745761726E696E6722';
wwv_flow_imp.g_varchar2_table(2987) := '2C22537472696E67206973206E6F742061205552493A207B307D222C69297D293B627265616B3B6361736522636F6C6F722D686578223A6361736522646174652D74696D65223A636173652264617465223A636173652274696D65223A6361736522656D';
wwv_flow_imp.g_varchar2_table(2988) := '61696C223A6361736522686F73746E616D65223A636173652269707634223A636173652269707636223A766172206F3D54615B742E666F726D61745D3B652E76616C756526266F2E7061747465726E2E6578656328652E76616C7565297C7C6E2E70726F';
wwv_flow_imp.g_varchar2_table(2989) := '626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A742E7061747465726E4572726F724D6573736167657C7C742E6572726F724D657373616765';
wwv_flow_imp.g_varchar2_table(2990) := '7C7C6F2E6572726F724D6573736167657D297D7D28692C742C6E293B627265616B3B63617365226E756D626572223A2166756E6374696F6E28652C742C6E297B76617220723D652E76616C75653B66756E6374696F6E20692865297B76617220742C6E3D';
wwv_flow_imp.g_varchar2_table(2991) := '2F5E282D3F5C642B29283F3A5C2E285C642B29293F283F3A65285B2D2B5D5C642B29293F242F2E6578656328652E746F537472696E672829293B72657475726E206E26267B76616C75653A4E756D626572286E5B315D2B286E5B325D7C7C222229292C6D';
wwv_flow_imp.g_varchar2_table(2992) := '756C7469706C6965723A28286E756C6C3D3D3D28743D6E5B325D297C7C766F696420303D3D3D743F766F696420303A742E6C656E677468297C7C30292D287061727365496E74286E5B335D297C7C30297D7D6966286F6F28742E6D756C7469706C654F66';
wwv_flow_imp.g_varchar2_table(2993) := '29297B76617220733D2D313B6966284E756D6265722E6973496E746567657228742E6D756C7469706C654F662929733D7225742E6D756C7469706C654F663B656C73657B766172206F3D6928742E6D756C7469706C654F66292C613D692872293B696628';
wwv_flow_imp.g_varchar2_table(2994) := '6F262661297B766172206C3D4D6174682E706F772831302C4D6174682E61627328612E6D756C7469706C6965722D6F2E6D756C7469706C69657229293B612E6D756C7469706C6965723C6F2E6D756C7469706C6965723F612E76616C75652A3D6C3A6F2E';
wwv_flow_imp.g_varchar2_table(2995) := '76616C75652A3D6C2C733D612E76616C7565256F2E76616C75657D7D30213D3D7326266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D65737361';
wwv_flow_imp.g_varchar2_table(2996) := '67653A526128226D756C7469706C654F665761726E696E67222C2256616C7565206973206E6F7420646976697369626C65206279207B307D2E222C742E6D756C7469706C654F66297D297D66756E6374696F6E207528652C74297B72657475726E206F6F';
wwv_flow_imp.g_varchar2_table(2997) := '2874293F743A6C6F2874292626743F653A766F696420307D66756E6374696F6E206328652C74297B696628216C6F2874297C7C21742972657475726E20657D76617220683D7528742E6D696E696D756D2C742E6578636C75736976654D696E696D756D29';
wwv_flow_imp.g_varchar2_table(2998) := '3B6F6F2868292626723C3D6826266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226578636C75736976654D696E696D';
wwv_flow_imp.g_varchar2_table(2999) := '756D5761726E696E67222C2256616C75652069732062656C6F7720746865206578636C7573697665206D696E696D756D206F66207B307D2E222C68297D293B76617220643D7528742E6D6178696D756D2C742E6578636C75736976654D6178696D756D29';
wwv_flow_imp.g_varchar2_table(3000) := '3B6F6F2864292626723E3D6426266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226578636C75736976654D6178696D';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(3001) := '756D5761726E696E67222C2256616C75652069732061626F766520746865206578636C7573697665206D6178696D756D206F66207B307D2E222C64297D293B76617220663D6328742E6D696E696D756D2C742E6578636C75736976654D696E696D756D29';
wwv_flow_imp.g_varchar2_table(3002) := '3B6F6F2866292626723C6626266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226D696E696D756D5761726E696E6722';
wwv_flow_imp.g_varchar2_table(3003) := '2C2256616C75652069732062656C6F7720746865206D696E696D756D206F66207B307D2E222C66297D293B766172206D3D6328742E6D6178696D756D2C742E6578636C75736976654D6178696D756D293B6F6F286D292626723E6D26266E2E70726F626C';
wwv_flow_imp.g_varchar2_table(3004) := '656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A652E6F66667365742C6C656E6774683A652E6C656E6774687D2C6D6573736167653A526128226D6178696D756D5761726E696E67222C2256616C75652069732061626F766520746865';
wwv_flow_imp.g_varchar2_table(3005) := '206D6178696D756D206F66207B307D2E222C6D297D297D28692C742C6E293B627265616B3B636173652270726F7065727479223A72657475726E20476128692E76616C75654E6F64652C742C6E2C72297D2166756E6374696F6E28297B66756E6374696F';
wwv_flow_imp.g_varchar2_table(3006) := '6E20652865297B72657475726E20692E747970653D3D3D657C7C22696E7465676572223D3D3D652626226E756D626572223D3D3D692E747970652626692E6973496E74656765727D69662841727261792E6973417272617928742E74797065293F742E74';
wwv_flow_imp.g_varchar2_table(3007) := '7970652E736F6D652865297C7C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E6F66667365742C6C656E6774683A692E6C656E6774687D2C6D6573736167653A742E6572726F724D6573736167657C7C526128';
wwv_flow_imp.g_varchar2_table(3008) := '227479706541727261794D69736D617463685761726E696E67222C22496E636F727265637420747970652E204578706563746564206F6E65206F66207B307D2E222C742E747970652E6A6F696E28222C202229297D293A742E747970652626286528742E';
wwv_flow_imp.g_varchar2_table(3009) := '74797065297C7C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E6F66667365742C6C656E6774683A692E6C656E6774687D2C6D6573736167653A742E6572726F724D6573736167657C7C52612822747970654D';
wwv_flow_imp.g_varchar2_table(3010) := '69736D617463685761726E696E67222C27496E636F727265637420747970652E20457870656374656420227B307D222E272C742E74797065297D29292C41727261792E6973417272617928742E616C6C4F662929666F722876617220733D302C6F3D742E';
wwv_flow_imp.g_varchar2_table(3011) := '616C6C4F663B733C6F2E6C656E6774683B732B2B297B76617220613D6F5B735D3B476128692C4B612861292C6E2C72297D766172206C3D4B6128742E6E6F74293B6966286C297B76617220753D6E65772042612C633D722E6E657753756228293B476128';
wwv_flow_imp.g_varchar2_table(3012) := '692C6C2C752C63292C752E68617350726F626C656D7328297C7C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E6F66667365742C6C656E6774683A692E6C656E6774687D2C6D6573736167653A526128226E6F';
wwv_flow_imp.g_varchar2_table(3013) := '74536368656D615761726E696E67222C224D617463686573206120736368656D612074686174206973206E6F7420616C6C6F7765642E22297D293B666F722876617220683D302C643D632E736368656D61733B683C642E6C656E6774683B682B2B297B76';
wwv_flow_imp.g_varchar2_table(3014) := '617220663D645B685D3B662E696E7665727465643D21662E696E7665727465642C722E6164642866297D7D766172206D3D66756E6374696F6E28652C74297B666F722876617220733D5B5D2C6F3D766F696420302C613D302C6C3D653B613C6C2E6C656E';
wwv_flow_imp.g_varchar2_table(3015) := '6774683B612B2B297B76617220753D4B61286C5B615D292C633D6E65772042612C683D722E6E657753756228293B696628476128692C752C632C68292C632E68617350726F626C656D7328297C7C732E707573682875292C6F29696628747C7C632E6861';
wwv_flow_imp.g_varchar2_table(3016) := '7350726F626C656D7328297C7C6F2E76616C69646174696F6E526573756C742E68617350726F626C656D732829297B76617220643D632E636F6D70617265286F2E76616C69646174696F6E526573756C74293B643E303F6F3D7B736368656D613A752C76';
wwv_flow_imp.g_varchar2_table(3017) := '616C69646174696F6E526573756C743A632C6D61746368696E67536368656D61733A687D3A303D3D3D642626286F2E6D61746368696E67536368656D61732E6D657267652868292C6F2E76616C69646174696F6E526573756C742E6D65726765456E756D';
wwv_flow_imp.g_varchar2_table(3018) := '56616C756573286329297D656C7365206F2E6D61746368696E67536368656D61732E6D657267652868292C6F2E76616C69646174696F6E526573756C742E70726F706572746965734D6174636865732B3D632E70726F706572746965734D617463686573';
wwv_flow_imp.g_varchar2_table(3019) := '2C6F2E76616C69646174696F6E526573756C742E70726F7065727469657356616C75654D6174636865732B3D632E70726F7065727469657356616C75654D6174636865733B656C7365206F3D7B736368656D613A752C76616C69646174696F6E52657375';
wwv_flow_imp.g_varchar2_table(3020) := '6C743A632C6D61746368696E67536368656D61733A687D7D72657475726E20732E6C656E6774683E3126267426266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E6F66667365742C6C656E6774683A317D2C6D';
wwv_flow_imp.g_varchar2_table(3021) := '6573736167653A526128226F6E654F665761726E696E67222C224D617463686573206D756C7469706C6520736368656D6173207768656E206F6E6C79206F6E65206D7573742076616C69646174652E22297D292C6F2626286E2E6D65726765286F2E7661';
wwv_flow_imp.g_varchar2_table(3022) := '6C69646174696F6E526573756C74292C6E2E70726F706572746965734D6174636865732B3D6F2E76616C69646174696F6E526573756C742E70726F706572746965734D6174636865732C6E2E70726F7065727469657356616C75654D6174636865732B3D';
wwv_flow_imp.g_varchar2_table(3023) := '6F2E76616C69646174696F6E526573756C742E70726F7065727469657356616C75654D6174636865732C722E6D65726765286F2E6D61746368696E67536368656D617329292C732E6C656E6774687D3B41727261792E6973417272617928742E616E794F';
wwv_flow_imp.g_varchar2_table(3024) := '662926266D28742E616E794F662C2131292C41727261792E6973417272617928742E6F6E654F662926266D28742E6F6E654F662C2130293B76617220672C702C762C622C792C5F2C433D66756E6374696F6E2865297B76617220743D6E65772042612C73';
wwv_flow_imp.g_varchar2_table(3025) := '3D722E6E657753756228293B476128692C4B612865292C742C73292C6E2E6D657267652874292C6E2E70726F706572746965734D6174636865732B3D742E70726F706572746965734D6174636865732C6E2E70726F7065727469657356616C75654D6174';
wwv_flow_imp.g_varchar2_table(3026) := '636865732B3D742E70726F7065727469657356616C75654D6174636865732C722E6D657267652873297D2C773D4B6128742E6966293B69662877262628673D772C703D4B6128742E7468656E292C763D4B6128742E656C7365292C623D4B612867292C79';
wwv_flow_imp.g_varchar2_table(3027) := '3D6E65772042612C5F3D722E6E657753756228292C476128692C622C792C5F292C722E6D65726765285F292C792E68617350726F626C656D7328293F762626432876293A70262643287029292C41727261792E6973417272617928742E656E756D29297B';
wwv_flow_imp.g_varchar2_table(3028) := '666F722876617220533D24612869292C4C3D21312C453D302C783D742E656E756D3B453C782E6C656E6774683B452B2B29696628736F28532C785B455D29297B4C3D21303B627265616B7D6E2E656E756D56616C7565733D742E656E756D2C6E2E656E75';
wwv_flow_imp.g_varchar2_table(3029) := '6D56616C75654D617463683D4C2C4C7C7C6E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E6F66667365742C6C656E6774683A692E6C656E6774687D2C636F64653A76612E456E756D56616C75654D69736D6174';
wwv_flow_imp.g_varchar2_table(3030) := '63682C6D6573736167653A742E6572726F724D6573736167657C7C52612822656E756D5761726E696E67222C2256616C7565206973206E6F742061636365707465642E2056616C69642076616C7565733A207B307D2E222C742E656E756D2E6D61702828';
wwv_flow_imp.g_varchar2_table(3031) := '66756E6374696F6E2865297B72657475726E204A534F4E2E737472696E676966792865297D29292E6A6F696E28222C202229297D297D616F28742E636F6E737429262628736F28533D24612869292C742E636F6E7374293F6E2E656E756D56616C75654D';
wwv_flow_imp.g_varchar2_table(3032) := '617463683D21303A286E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E6F66667365742C6C656E6774683A692E6C656E6774687D2C636F64653A76612E456E756D56616C75654D69736D617463682C6D65737361';
wwv_flow_imp.g_varchar2_table(3033) := '67653A742E6572726F724D6573736167657C7C52612822636F6E73745761726E696E67222C2256616C7565206D757374206265207B307D2E222C4A534F4E2E737472696E6769667928742E636F6E737429297D292C6E2E656E756D56616C75654D617463';
wwv_flow_imp.g_varchar2_table(3034) := '683D2131292C6E2E656E756D56616C7565733D5B742E636F6E73745D292C742E6465707265636174696F6E4D6573736167652626692E706172656E7426266E2E70726F626C656D732E70757368287B6C6F636174696F6E3A7B6F66667365743A692E7061';
wwv_flow_imp.g_varchar2_table(3035) := '72656E742E6F66667365742C6C656E6774683A692E706172656E742E6C656E6774687D2C73657665726974793A6B732E5761726E696E672C6D6573736167653A742E6465707265636174696F6E4D6573736167652C636F64653A76612E44657072656361';
wwv_flow_imp.g_varchar2_table(3036) := '7465647D297D28292C722E616464287B6E6F64653A692C736368656D613A747D297D7D66756E6374696F6E204A6128652C742C6E297B6966286E756C6C213D3D652626226F626A656374223D3D747970656F662065297B76617220723D742B225C74223B';
wwv_flow_imp.g_varchar2_table(3037) := '69662841727261792E69734172726179286529297B696628303D3D3D652E6C656E6774682972657475726E225B5D223B666F722876617220693D225B5C6E222C733D303B733C652E6C656E6774683B732B2B29692B3D722B4A6128655B735D2C722C6E29';
wwv_flow_imp.g_varchar2_table(3038) := '2C733C652E6C656E6774682D31262628692B3D222C22292C692B3D225C6E223B72657475726E20692B28742B225D22297D766172206F3D4F626A6563742E6B6579732865293B696628303D3D3D6F2E6C656E6774682972657475726E227B7D223B666F72';
wwv_flow_imp.g_varchar2_table(3039) := '28693D227B5C6E222C733D303B733C6F2E6C656E6774683B732B2B297B76617220613D6F5B735D3B692B3D722B4A534F4E2E737472696E676966792861292B223A20222B4A6128655B615D2C722C6E292C733C6F2E6C656E6774682D31262628692B3D22';
wwv_flow_imp.g_varchar2_table(3040) := '2C22292C692B3D225C6E227D72657475726E20692B28742B227D22297D72657475726E206E2865297D7661722058613D786128292C51613D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E2C72297B766F696420303D3D3D74262628';
wwv_flow_imp.g_varchar2_table(3041) := '743D5B5D292C766F696420303D3D3D6E2626286E3D50726F6D697365292C766F696420303D3D3D72262628723D7B7D292C746869732E736368656D61536572766963653D652C746869732E636F6E747269627574696F6E733D742C746869732E70726F6D';
wwv_flow_imp.g_varchar2_table(3042) := '697365436F6E7374727563746F723D6E2C746869732E636C69656E744361706162696C69746965733D727D72657475726E20652E70726F746F747970652E646F5265736F6C76653D66756E6374696F6E2865297B666F722876617220743D746869732E63';
wwv_flow_imp.g_varchar2_table(3043) := '6F6E747269627574696F6E732E6C656E6774682D313B743E3D303B742D2D297B766172206E3D746869732E636F6E747269627574696F6E735B745D2E7265736F6C7665436F6D706C6574696F6E3B6966286E297B76617220723D6E2865293B6966287229';
wwv_flow_imp.g_varchar2_table(3044) := '72657475726E20727D7D72657475726E20746869732E70726F6D697365436F6E7374727563746F722E7265736F6C76652865297D2C652E70726F746F747970652E646F436F6D706C6574653D66756E6374696F6E28652C742C6E297B76617220723D7468';
wwv_flow_imp.g_varchar2_table(3045) := '69732C693D7B6974656D733A5B5D2C6973496E636F6D706C6574653A21317D2C733D652E6765745465787428292C6F3D652E6F666673657441742874292C613D6E2E6765744E6F646546726F6D4F6666736574286F2C2130293B696628746869732E6973';
wwv_flow_imp.g_varchar2_table(3046) := '496E436F6D6D656E7428652C613F612E6F66667365743A302C6F292972657475726E2050726F6D6973652E7265736F6C76652869293B6966286126266F3D3D3D612E6F66667365742B612E6C656E67746826266F3E30297B766172206C3D735B6F2D315D';
wwv_flow_imp.g_varchar2_table(3047) := '3B28226F626A656374223D3D3D612E747970652626227D223D3D3D6C7C7C226172726179223D3D3D612E747970652626225D223D3D3D6C29262628613D612E706172656E74297D76617220752C633D746869732E67657443757272656E74576F72642865';
wwv_flow_imp.g_varchar2_table(3048) := '2C6F293B69662821617C7C22737472696E6722213D3D612E747970652626226E756D62657222213D3D612E74797065262622626F6F6C65616E22213D3D612E747970652626226E756C6C22213D3D612E74797065297B76617220683D6F2D632E6C656E67';
wwv_flow_imp.g_varchar2_table(3049) := '74683B683E3026262722273D3D3D735B682D315D2626682D2D2C753D68732E63726561746528652E706F736974696F6E41742868292C74297D656C736520753D68732E63726561746528652E706F736974696F6E417428612E6F6666736574292C652E70';
wwv_flow_imp.g_varchar2_table(3050) := '6F736974696F6E417428612E6F66667365742B612E6C656E67746829293B76617220643D7B7D2C663D7B6164643A66756E6374696F6E2865297B76617220743D652E6C6162656C2C6E3D645B745D3B6966286E296E2E646F63756D656E746174696F6E7C';
wwv_flow_imp.g_varchar2_table(3051) := '7C286E2E646F63756D656E746174696F6E3D652E646F63756D656E746174696F6E292C6E2E64657461696C7C7C286E2E64657461696C3D652E64657461696C293B656C73657B69662828743D742E7265706C616365282F5B5C6E5D2F672C22E286B52229';
wwv_flow_imp.g_varchar2_table(3052) := '292E6C656E6774683E3630297B76617220723D742E73756273747228302C3537292E7472696D28292B222E2E2E223B645B725D7C7C28743D72297D752626766F69642030213D3D652E696E7365727454657874262628652E74657874456469743D44732E';
wwv_flow_imp.g_varchar2_table(3053) := '7265706C61636528752C652E696E736572745465787429292C652E6C6162656C3D742C645B745D3D652C692E6974656D732E707573682865297D7D2C7365744173496E636F6D706C6574653A66756E6374696F6E28297B692E6973496E636F6D706C6574';
wwv_flow_imp.g_varchar2_table(3054) := '653D21307D2C6572726F723A66756E6374696F6E2865297B636F6E736F6C652E6572726F722865297D2C6C6F673A66756E6374696F6E2865297B636F6E736F6C652E6C6F672865297D2C6765744E756D6265724F6650726F706F73616C733A66756E6374';
wwv_flow_imp.g_varchar2_table(3055) := '696F6E28297B72657475726E20692E6974656D732E6C656E6774687D7D3B72657475726E20746869732E736368656D61536572766963652E676574536368656D61466F725265736F7572636528652E7572692C6E292E7468656E282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3056) := '2874297B766172206C3D5B5D2C683D21302C6D3D22222C673D766F696420303B69662861262622737472696E67223D3D3D612E74797065297B76617220703D612E706172656E743B7026262270726F7065727479223D3D3D702E747970652626702E6B65';
wwv_flow_imp.g_varchar2_table(3057) := '794E6F64653D3D3D61262628683D21702E76616C75654E6F64652C673D702C6D3D732E73756273747228612E6F66667365742B312C612E6C656E6774682D32292C70262628613D702E706172656E7429297D696628612626226F626A656374223D3D3D61';
wwv_flow_imp.g_varchar2_table(3058) := '2E74797065297B696628612E6F66667365743D3D3D6F2972657475726E20693B612E70726F706572746965732E666F7245616368282866756E6374696F6E2865297B672626673D3D3D657C7C28645B652E6B65794E6F64652E76616C75655D3D4D6F2E63';
wwv_flow_imp.g_varchar2_table(3059) := '726561746528225F5F2229297D29293B76617220763D22223B68262628763D722E6576616C75617465536570617261746F72416674657228652C652E6F6666736574417428752E656E642929292C743F722E67657450726F7065727479436F6D706C6574';
wwv_flow_imp.g_varchar2_table(3060) := '696F6E7328742C6E2C612C682C762C66293A722E676574536368656D614C65737350726F7065727479436F6D706C6574696F6E73286E2C612C6D2C66293B76617220623D57612861293B722E636F6E747269627574696F6E732E666F7245616368282866';
wwv_flow_imp.g_varchar2_table(3061) := '756E6374696F6E2874297B766172206E3D742E636F6C6C65637450726F7065727479436F6D706C6574696F6E7328652E7572692C622C632C682C22223D3D3D762C66293B6E26266C2E70757368286E297D29292C21742626632E6C656E6774683E302626';
wwv_flow_imp.g_varchar2_table(3062) := '272227213D3D732E636861724174286F2D632E6C656E6774682D3129262628662E616464287B6B696E643A536F2E50726F70657274792C6C6162656C3A722E6765744C6162656C466F7256616C75652863292C696E73657274546578743A722E67657449';
wwv_flow_imp.g_varchar2_table(3063) := '6E7365727454657874466F7250726F706572747928632C766F696420302C21312C76292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22227D292C662E7365744173496E636F6D706C657465';
wwv_flow_imp.g_varchar2_table(3064) := '2829297D76617220793D7B7D3B72657475726E20743F722E67657456616C7565436F6D706C6574696F6E7328742C6E2C612C6F2C652C662C79293A722E676574536368656D614C65737356616C7565436F6D706C6574696F6E73286E2C612C6F2C652C66';
wwv_flow_imp.g_varchar2_table(3065) := '292C722E636F6E747269627574696F6E732E6C656E6774683E302626722E676574436F6E747269627574656456616C7565436F6D706C6574696F6E73286E2C612C6F2C652C662C6C292C722E70726F6D697365436F6E7374727563746F722E616C6C286C';
wwv_flow_imp.g_varchar2_table(3066) := '292E7468656E282866756E6374696F6E28297B696628303D3D3D662E6765744E756D6265724F6650726F706F73616C732829297B76617220743D6F3B21617C7C22737472696E6722213D3D612E747970652626226E756D62657222213D3D612E74797065';
wwv_flow_imp.g_varchar2_table(3067) := '262622626F6F6C65616E22213D3D612E747970652626226E756C6C22213D3D612E747970657C7C28743D612E6F66667365742B612E6C656E677468293B766172206E3D722E6576616C75617465536570617261746F72416674657228652C74293B722E61';
wwv_flow_imp.g_varchar2_table(3068) := '646446696C6C657256616C7565436F6D706C6574696F6E7328792C6E2C66297D72657475726E20697D29297D29297D2C652E70726F746F747970652E67657450726F7065727479436F6D706C6574696F6E733D66756E6374696F6E28652C742C6E2C722C';
wwv_flow_imp.g_varchar2_table(3069) := '692C73297B766172206F3D746869733B742E6765744D61746368696E67536368656D617328652E736368656D612C6E2E6F6666736574292E666F7245616368282866756E6374696F6E2865297B696628652E6E6F64653D3D3D6E262621652E696E766572';
wwv_flow_imp.g_varchar2_table(3070) := '746564297B76617220743D652E736368656D612E70726F706572746965733B7426264F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E2865297B766172206E3D745B655D3B696628226F626A656374223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(3071) := '206E2626216E2E6465707265636174696F6E4D6573736167652626216E2E646F4E6F7453756767657374297B76617220613D7B6B696E643A536F2E50726F70657274792C6C6162656C3A652C696E73657274546578743A6F2E676574496E736572745465';
wwv_flow_imp.g_varchar2_table(3072) := '7874466F7250726F706572747928652C6E2C722C69292C696E7365727454657874466F726D61743A456F2E536E69707065742C66696C746572546578743A6F2E67657446696C74657254657874466F7256616C75652865292C646F63756D656E74617469';
wwv_flow_imp.g_varchar2_table(3073) := '6F6E3A6F2E66726F6D4D61726B7570286E2E6D61726B646F776E4465736372697074696F6E297C7C6E2E6465736372697074696F6E7C7C22227D3B766F69642030213D3D6E2E73756767657374536F727454657874262628612E736F7274546578743D6E';
wwv_flow_imp.g_varchar2_table(3074) := '2E73756767657374536F727454657874292C612E696E73657274546578742626756F28612E696E73657274546578742C222431222E636F6E63617428692929262628612E636F6D6D616E643D7B7469746C653A2253756767657374222C636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(3075) := '3A22656469746F722E616374696F6E2E7472696767657253756767657374227D292C732E6164642861297D7D29293B76617220613D652E736368656D612E70726F70657274794E616D65733B696628226F626A656374223D3D747970656F662061262621';
wwv_flow_imp.g_varchar2_table(3076) := '612E6465707265636174696F6E4D657373616765262621612E646F4E6F7453756767657374297B766172206C3D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D766F69642030293B766172206E3D7B6B696E643A536F2E50726F';
wwv_flow_imp.g_varchar2_table(3077) := '70657274792C6C6162656C3A652C696E73657274546578743A6F2E676574496E7365727454657874466F7250726F706572747928652C766F696420302C722C69292C696E7365727454657874466F726D61743A456F2E536E69707065742C66696C746572';
wwv_flow_imp.g_varchar2_table(3078) := '546578743A6F2E67657446696C74657254657874466F7256616C75652865292C646F63756D656E746174696F6E3A747C7C6F2E66726F6D4D61726B757028612E6D61726B646F776E4465736372697074696F6E297C7C612E6465736372697074696F6E7C';
wwv_flow_imp.g_varchar2_table(3079) := '7C22227D3B766F69642030213D3D612E73756767657374536F7274546578742626286E2E736F7274546578743D612E73756767657374536F727454657874292C6E2E696E73657274546578742626756F286E2E696E73657274546578742C222431222E63';
wwv_flow_imp.g_varchar2_table(3080) := '6F6E636174286929292626286E2E636F6D6D616E643D7B7469746C653A2253756767657374222C636F6D6D616E643A22656469746F722E616374696F6E2E7472696767657253756767657374227D292C732E616464286E297D3B696628612E656E756D29';
wwv_flow_imp.g_varchar2_table(3081) := '666F722876617220753D303B753C612E656E756D2E6C656E6774683B752B2B297B76617220633D766F696420303B612E6D61726B646F776E456E756D4465736372697074696F6E732626753C612E6D61726B646F776E456E756D4465736372697074696F';
wwv_flow_imp.g_varchar2_table(3082) := '6E732E6C656E6774683F633D6F2E66726F6D4D61726B757028612E6D61726B646F776E456E756D4465736372697074696F6E735B755D293A612E656E756D4465736372697074696F6E732626753C612E656E756D4465736372697074696F6E732E6C656E';
wwv_flow_imp.g_varchar2_table(3083) := '677468262628633D612E656E756D4465736372697074696F6E735B755D292C6C28612E656E756D5B755D2C63297D612E636F6E737426266C28612E636F6E7374297D7D7D29297D2C652E70726F746F747970652E676574536368656D614C65737350726F';
wwv_flow_imp.g_varchar2_table(3084) := '7065727479436F6D706C6574696F6E733D66756E6374696F6E28652C742C6E2C72297B76617220693D746869732C733D66756E6374696F6E2865297B652E70726F706572746965732E666F7245616368282866756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(3085) := '652E6B65794E6F64652E76616C75653B722E616464287B6B696E643A536F2E50726F70657274792C6C6162656C3A742C696E73657274546578743A692E676574496E7365727454657874466F7256616C756528742C2222292C696E736572745465787446';
wwv_flow_imp.g_varchar2_table(3086) := '6F726D61743A456F2E536E69707065742C66696C746572546578743A692E67657446696C74657254657874466F7256616C75652874292C646F63756D656E746174696F6E3A22227D297D29297D3B696628742E706172656E74296966282270726F706572';
wwv_flow_imp.g_varchar2_table(3087) := '7479223D3D3D742E706172656E742E74797065297B766172206F3D742E706172656E742E6B65794E6F64652E76616C75653B652E7669736974282866756E6374696F6E2865297B72657475726E2270726F7065727479223D3D3D652E7479706526266521';
wwv_flow_imp.g_varchar2_table(3088) := '3D3D742E706172656E742626652E6B65794E6F64652E76616C75653D3D3D6F2626652E76616C75654E6F64652626226F626A656374223D3D3D652E76616C75654E6F64652E7479706526267328652E76616C75654E6F6465292C21307D29297D656C7365';
wwv_flow_imp.g_varchar2_table(3089) := '226172726179223D3D3D742E706172656E742E747970652626742E706172656E742E6974656D732E666F7245616368282866756E6374696F6E2865297B226F626A656374223D3D3D652E74797065262665213D3D742626732865297D29293B656C736522';
wwv_flow_imp.g_varchar2_table(3090) := '6F626A656374223D3D3D742E747970652626722E616464287B6B696E643A536F2E50726F70657274792C6C6162656C3A2224736368656D61222C696E73657274546578743A746869732E676574496E7365727454657874466F7250726F70657274792822';
wwv_flow_imp.g_varchar2_table(3091) := '24736368656D61222C766F696420302C21302C2222292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22222C66696C746572546578743A746869732E67657446696C74657254657874466F72';
wwv_flow_imp.g_varchar2_table(3092) := '56616C7565282224736368656D6122297D297D2C652E70726F746F747970652E676574536368656D614C65737356616C7565436F6D706C6574696F6E733D66756E6374696F6E28652C742C6E2C722C69297B76617220733D746869732C6F3D6E3B696628';
wwv_flow_imp.g_varchar2_table(3093) := '21747C7C22737472696E6722213D3D742E747970652626226E756D62657222213D3D742E74797065262622626F6F6C65616E22213D3D742E747970652626226E756C6C22213D3D742E747970657C7C286F3D742E6F66667365742B742E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(3094) := '743D742E706172656E74292C21742972657475726E20692E616464287B6B696E643A746869732E67657453756767657374696F6E4B696E6428226F626A65637422292C6C6162656C3A22456D707479206F626A656374222C696E73657274546578743A74';
wwv_flow_imp.g_varchar2_table(3095) := '6869732E676574496E7365727454657874466F7256616C7565287B7D2C2222292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22227D292C766F696420692E616464287B6B696E643A746869';
wwv_flow_imp.g_varchar2_table(3096) := '732E67657453756767657374696F6E4B696E642822617272617922292C6C6162656C3A22456D707479206172726179222C696E73657274546578743A746869732E676574496E7365727454657874466F7256616C7565285B5D2C2222292C696E73657274';
wwv_flow_imp.g_varchar2_table(3097) := '54657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22227D293B76617220613D746869732E6576616C75617465536570617261746F72416674657228722C6F292C6C3D66756E6374696F6E2865297B652E70617265';
wwv_flow_imp.g_varchar2_table(3098) := '6E742626217A6128652E706172656E742C6E2C2130292626692E616464287B6B696E643A732E67657453756767657374696F6E4B696E6428652E74797065292C6C6162656C3A732E6765744C6162656C54657874466F724D61746368696E674E6F646528';
wwv_flow_imp.g_varchar2_table(3099) := '652C72292C696E73657274546578743A732E676574496E7365727454657874466F724D61746368696E674E6F646528652C722C61292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22227D29';
wwv_flow_imp.g_varchar2_table(3100) := '2C22626F6F6C65616E223D3D3D652E747970652626732E616464426F6F6C65616E56616C7565436F6D706C6574696F6E2821652E76616C75652C612C69297D3B6966282270726F7065727479223D3D3D742E7479706526266E3E28742E636F6C6F6E4F66';
wwv_flow_imp.g_varchar2_table(3101) := '667365747C7C3029297B76617220753D742E76616C75654E6F64653B696628752626286E3E752E6F66667365742B752E6C656E6774687C7C226F626A656374223D3D3D752E747970657C7C226172726179223D3D3D752E74797065292972657475726E3B';
wwv_flow_imp.g_varchar2_table(3102) := '76617220633D742E6B65794E6F64652E76616C75653B652E7669736974282866756E6374696F6E2865297B72657475726E2270726F7065727479223D3D3D652E747970652626652E6B65794E6F64652E76616C75653D3D3D632626652E76616C75654E6F';
wwv_flow_imp.g_varchar2_table(3103) := '646526266C28652E76616C75654E6F6465292C21307D29292C2224736368656D61223D3D3D632626742E706172656E74262621742E706172656E742E706172656E742626746869732E616464446F6C6C6172536368656D61436F6D706C6574696F6E7328';
wwv_flow_imp.g_varchar2_table(3104) := '612C69297D696628226172726179223D3D3D742E7479706529696628742E706172656E7426262270726F7065727479223D3D3D742E706172656E742E74797065297B76617220683D742E706172656E742E6B65794E6F64652E76616C75653B652E766973';
wwv_flow_imp.g_varchar2_table(3105) := '6974282866756E6374696F6E2865297B72657475726E2270726F7065727479223D3D3D652E747970652626652E6B65794E6F64652E76616C75653D3D3D682626652E76616C75654E6F64652626226172726179223D3D3D652E76616C75654E6F64652E74';
wwv_flow_imp.g_varchar2_table(3106) := '7970652626652E76616C75654E6F64652E6974656D732E666F7245616368286C292C21307D29297D656C736520742E6974656D732E666F7245616368286C297D2C652E70726F746F747970652E67657456616C7565436F6D706C6574696F6E733D66756E';
wwv_flow_imp.g_varchar2_table(3107) := '6374696F6E28652C742C6E2C722C692C732C6F297B76617220613D722C6C3D766F696420302C753D766F696420303B696628216E7C7C22737472696E6722213D3D6E2E747970652626226E756D62657222213D3D6E2E74797065262622626F6F6C65616E';
wwv_flow_imp.g_varchar2_table(3108) := '22213D3D6E2E747970652626226E756C6C22213D3D6E2E747970657C7C28613D6E2E6F66667365742B6E2E6C656E6774682C753D6E2C6E3D6E2E706172656E74292C6E297B6966282270726F7065727479223D3D3D6E2E747970652626723E286E2E636F';
wwv_flow_imp.g_varchar2_table(3109) := '6C6F6E4F66667365747C7C3029297B76617220633D6E2E76616C75654E6F64653B696628632626723E632E6F66667365742B632E6C656E6774682972657475726E3B6C3D6E2E6B65794E6F64652E76616C75652C6E3D6E2E706172656E747D6966286E26';
wwv_flow_imp.g_varchar2_table(3110) := '2628766F69642030213D3D6C7C7C226172726179223D3D3D6E2E7479706529297B666F722876617220683D746869732E6576616C75617465536570617261746F72416674657228692C61292C643D302C663D742E6765744D61746368696E67536368656D';
wwv_flow_imp.g_varchar2_table(3111) := '617328652E736368656D612C6E2E6F66667365742C75293B643C662E6C656E6774683B642B2B297B766172206D3D665B645D3B6966286D2E6E6F64653D3D3D6E2626216D2E696E76657274656426266D2E736368656D61297B696628226172726179223D';
wwv_flow_imp.g_varchar2_table(3112) := '3D3D6E2E7479706526266D2E736368656D612E6974656D732969662841727261792E69734172726179286D2E736368656D612E6974656D7329297B76617220673D746869732E66696E644974656D41744F6666736574286E2C692C72293B673C6D2E7363';
wwv_flow_imp.g_varchar2_table(3113) := '68656D612E6974656D732E6C656E6774682626746869732E616464536368656D6156616C7565436F6D706C6574696F6E73286D2E736368656D612E6974656D735B675D2C682C732C6F297D656C736520746869732E616464536368656D6156616C756543';
wwv_flow_imp.g_varchar2_table(3114) := '6F6D706C6574696F6E73286D2E736368656D612E6974656D732C682C732C6F293B696628766F69642030213D3D6C297B76617220703D21313B6966286D2E736368656D612E70726F70657274696573262628433D6D2E736368656D612E70726F70657274';
wwv_flow_imp.g_varchar2_table(3115) := '6965735B6C5D29262628703D21302C746869732E616464536368656D6156616C7565436F6D706C6574696F6E7328432C682C732C6F29292C6D2E736368656D612E7061747465726E50726F706572746965732626217029666F722876617220763D302C62';
wwv_flow_imp.g_varchar2_table(3116) := '3D4F626A6563742E6B657973286D2E736368656D612E7061747465726E50726F70657274696573293B763C622E6C656E6774683B762B2B297B76617220793D625B765D2C5F3D636F2879293B6966286E756C6C3D3D5F3F766F696420303A5F2E74657374';
wwv_flow_imp.g_varchar2_table(3117) := '286C29297B703D21303B76617220433D6D2E736368656D612E7061747465726E50726F706572746965735B795D3B746869732E616464536368656D6156616C7565436F6D706C6574696F6E7328432C682C732C6F297D7D6D2E736368656D612E61646469';
wwv_flow_imp.g_varchar2_table(3118) := '74696F6E616C50726F7065727469657326262170262628433D6D2E736368656D612E6164646974696F6E616C50726F706572746965732C746869732E616464536368656D6156616C7565436F6D706C6574696F6E7328432C682C732C6F29297D7D7D2224';
wwv_flow_imp.g_varchar2_table(3119) := '736368656D6122213D3D6C7C7C6E2E706172656E747C7C746869732E616464446F6C6C6172536368656D61436F6D706C6574696F6E7328682C73292C6F2E626F6F6C65616E262628746869732E616464426F6F6C65616E56616C7565436F6D706C657469';
wwv_flow_imp.g_varchar2_table(3120) := '6F6E2821302C682C73292C746869732E616464426F6F6C65616E56616C7565436F6D706C6574696F6E2821312C682C7329292C6F2E6E756C6C2626746869732E6164644E756C6C56616C7565436F6D706C6574696F6E28682C73297D7D656C7365207468';
wwv_flow_imp.g_varchar2_table(3121) := '69732E616464536368656D6156616C7565436F6D706C6574696F6E7328652E736368656D612C22222C732C6F297D2C652E70726F746F747970652E676574436F6E747269627574656456616C7565436F6D706C6574696F6E733D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(3122) := '2C742C6E2C722C692C73297B69662874297B69662822737472696E6722213D3D742E747970652626226E756D62657222213D3D742E74797065262622626F6F6C65616E22213D3D742E747970652626226E756C6C22213D3D742E747970657C7C28743D74';
wwv_flow_imp.g_varchar2_table(3123) := '2E706172656E74292C7426262270726F7065727479223D3D3D742E7479706526266E3E28742E636F6C6F6E4F66667365747C7C3029297B766172206F3D742E6B65794E6F64652E76616C75652C613D742E76616C75654E6F64653B6966282821617C7C6E';
wwv_flow_imp.g_varchar2_table(3124) := '3C3D612E6F66667365742B612E6C656E677468292626742E706172656E74297B766172206C3D576128742E706172656E74293B746869732E636F6E747269627574696F6E732E666F7245616368282866756E6374696F6E2865297B76617220743D652E63';
wwv_flow_imp.g_varchar2_table(3125) := '6F6C6C65637456616C7565436F6D706C6574696F6E7328722E7572692C6C2C6F2C69293B742626732E707573682874297D29297D7D7D656C736520746869732E636F6E747269627574696F6E732E666F7245616368282866756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(3126) := '617220743D652E636F6C6C65637444656661756C74436F6D706C6574696F6E7328722E7572692C69293B742626732E707573682874297D29297D2C652E70726F746F747970652E616464536368656D6156616C7565436F6D706C6574696F6E733D66756E';
wwv_flow_imp.g_varchar2_table(3127) := '6374696F6E28652C742C6E2C72297B76617220693D746869733B226F626A656374223D3D747970656F662065262628746869732E616464456E756D56616C7565436F6D706C6574696F6E7328652C742C6E292C746869732E61646444656661756C745661';
wwv_flow_imp.g_varchar2_table(3128) := '6C7565436F6D706C6574696F6E7328652C742C6E292C746869732E636F6C6C656374547970657328652C72292C41727261792E6973417272617928652E616C6C4F66292626652E616C6C4F662E666F7245616368282866756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(3129) := '7475726E20692E616464536368656D6156616C7565436F6D706C6574696F6E7328652C742C6E2C72297D29292C41727261792E6973417272617928652E616E794F66292626652E616E794F662E666F7245616368282866756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(3130) := '7475726E20692E616464536368656D6156616C7565436F6D706C6574696F6E7328652C742C6E2C72297D29292C41727261792E6973417272617928652E6F6E654F66292626652E6F6E654F662E666F7245616368282866756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(3131) := '7475726E20692E616464536368656D6156616C7565436F6D706C6574696F6E7328652C742C6E2C72297D2929297D2C652E70726F746F747970652E61646444656661756C7456616C7565436F6D706C6574696F6E733D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(3132) := '2C72297B76617220693D746869733B766F696420303D3D3D72262628723D30293B76617220733D21313B696628616F28652E64656661756C7429297B666F7228766172206F3D652E747970652C613D652E64656661756C742C6C3D723B6C3E303B6C2D2D';
wwv_flow_imp.g_varchar2_table(3133) := '29613D5B615D2C6F3D226172726179223B6E2E616464287B6B696E643A746869732E67657453756767657374696F6E4B696E64286F292C6C6162656C3A746869732E6765744C6162656C466F7256616C75652861292C696E73657274546578743A746869';
wwv_flow_imp.g_varchar2_table(3134) := '732E676574496E7365727454657874466F7256616C756528612C74292C696E7365727454657874466F726D61743A456F2E536E69707065742C64657461696C3A586128226A736F6E2E737567676573742E64656661756C74222C2244656661756C742076';
wwv_flow_imp.g_varchar2_table(3135) := '616C756522297D292C733D21307D41727261792E6973417272617928652E6578616D706C6573292626652E6578616D706C65732E666F7245616368282866756E6374696F6E286F297B666F722876617220613D652E747970652C6C3D6F2C753D723B753E';
wwv_flow_imp.g_varchar2_table(3136) := '303B752D2D296C3D5B6C5D2C613D226172726179223B6E2E616464287B6B696E643A692E67657453756767657374696F6E4B696E642861292C6C6162656C3A692E6765744C6162656C466F7256616C7565286C292C696E73657274546578743A692E6765';
wwv_flow_imp.g_varchar2_table(3137) := '74496E7365727454657874466F7256616C7565286C2C74292C696E7365727454657874466F726D61743A456F2E536E69707065747D292C733D21307D29292C41727261792E6973417272617928652E64656661756C74536E697070657473292626652E64';
wwv_flow_imp.g_varchar2_table(3138) := '656661756C74536E6970706574732E666F7245616368282866756E6374696F6E286F297B76617220612C6C2C753D652E747970652C633D6F2E626F64792C683D6F2E6C6162656C3B696628616F286329297B652E747970653B666F722876617220643D72';
wwv_flow_imp.g_varchar2_table(3139) := '3B643E303B642D2D29633D5B635D3B613D692E676574496E7365727454657874466F72536E697070657456616C756528632C74292C6C3D692E67657446696C74657254657874466F72536E697070657456616C75652863292C683D687C7C692E6765744C';
wwv_flow_imp.g_varchar2_table(3140) := '6162656C466F72536E697070657456616C75652863297D656C73657B69662822737472696E6722213D747970656F66206F2E626F6479546578742972657475726E3B76617220663D22222C6D3D22222C673D22223B666F7228643D723B643E303B642D2D';
wwv_flow_imp.g_varchar2_table(3141) := '29663D662B672B225B5C6E222C6D3D6D2B225C6E222B672B225D222C672B3D225C74222C753D226172726179223B613D662B672B6F2E626F6479546578742E73706C697428225C6E22292E6A6F696E28225C6E222B67292B6D2B742C683D687C7C612C6C';
wwv_flow_imp.g_varchar2_table(3142) := '3D612E7265706C616365282F5B5C6E5D2F672C2222297D6E2E616464287B6B696E643A692E67657453756767657374696F6E4B696E642875292C6C6162656C3A682C646F63756D656E746174696F6E3A692E66726F6D4D61726B7570286F2E6D61726B64';
wwv_flow_imp.g_varchar2_table(3143) := '6F776E4465736372697074696F6E297C7C6F2E6465736372697074696F6E2C696E73657274546578743A612C696E7365727454657874466F726D61743A456F2E536E69707065742C66696C746572546578743A6C7D292C733D21307D29292C2173262622';
wwv_flow_imp.g_varchar2_table(3144) := '6F626A656374223D3D747970656F6620652E6974656D7326262141727261792E6973417272617928652E6974656D73292626723C352626746869732E61646444656661756C7456616C7565436F6D706C6574696F6E7328652E6974656D732C742C6E2C72';
wwv_flow_imp.g_varchar2_table(3145) := '2B31297D2C652E70726F746F747970652E616464456E756D56616C7565436F6D706C6574696F6E733D66756E6374696F6E28652C742C6E297B696628616F28652E636F6E73742926266E2E616464287B6B696E643A746869732E67657453756767657374';
wwv_flow_imp.g_varchar2_table(3146) := '696F6E4B696E6428652E74797065292C6C6162656C3A746869732E6765744C6162656C466F7256616C756528652E636F6E7374292C696E73657274546578743A746869732E676574496E7365727454657874466F7256616C756528652E636F6E73742C74';
wwv_flow_imp.g_varchar2_table(3147) := '292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A746869732E66726F6D4D61726B757028652E6D61726B646F776E4465736372697074696F6E297C7C652E6465736372697074696F6E7D292C';
wwv_flow_imp.g_varchar2_table(3148) := '41727261792E6973417272617928652E656E756D2929666F722876617220723D302C693D652E656E756D2E6C656E6774683B723C693B722B2B297B76617220733D652E656E756D5B725D2C6F3D746869732E66726F6D4D61726B757028652E6D61726B64';
wwv_flow_imp.g_varchar2_table(3149) := '6F776E4465736372697074696F6E297C7C652E6465736372697074696F6E3B652E6D61726B646F776E456E756D4465736372697074696F6E732626723C652E6D61726B646F776E456E756D4465736372697074696F6E732E6C656E677468262674686973';
wwv_flow_imp.g_varchar2_table(3150) := '2E646F6573537570706F72744D61726B646F776E28293F6F3D746869732E66726F6D4D61726B757028652E6D61726B646F776E456E756D4465736372697074696F6E735B725D293A652E656E756D4465736372697074696F6E732626723C652E656E756D';
wwv_flow_imp.g_varchar2_table(3151) := '4465736372697074696F6E732E6C656E6774682626286F3D652E656E756D4465736372697074696F6E735B725D292C6E2E616464287B6B696E643A746869732E67657453756767657374696F6E4B696E6428652E74797065292C6C6162656C3A74686973';
wwv_flow_imp.g_varchar2_table(3152) := '2E6765744C6162656C466F7256616C75652873292C696E73657274546578743A746869732E676574496E7365727454657874466F7256616C756528732C74292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E74';
wwv_flow_imp.g_varchar2_table(3153) := '6174696F6E3A6F7D297D7D2C652E70726F746F747970652E636F6C6C65637454797065733D66756E6374696F6E28652C74297B6966282141727261792E6973417272617928652E656E756D29262621616F28652E636F6E737429297B766172206E3D652E';
wwv_flow_imp.g_varchar2_table(3154) := '747970653B41727261792E69734172726179286E293F6E2E666F7245616368282866756E6374696F6E2865297B72657475726E20745B655D3D21307D29293A6E262628745B6E5D3D2130297D7D2C652E70726F746F747970652E61646446696C6C657256';
wwv_flow_imp.g_varchar2_table(3155) := '616C7565436F6D706C6574696F6E733D66756E6374696F6E28652C742C6E297B652E6F626A65637426266E2E616464287B6B696E643A746869732E67657453756767657374696F6E4B696E6428226F626A65637422292C6C6162656C3A227B7D222C696E';
wwv_flow_imp.g_varchar2_table(3156) := '73657274546578743A746869732E676574496E7365727454657874466F724775657373656456616C7565287B7D2C74292C696E7365727454657874466F726D61743A456F2E536E69707065742C64657461696C3A5861282264656661756C74732E6F626A';
wwv_flow_imp.g_varchar2_table(3157) := '656374222C224E6577206F626A65637422292C646F63756D656E746174696F6E3A22227D292C652E617272617926266E2E616464287B6B696E643A746869732E67657453756767657374696F6E4B696E642822617272617922292C6C6162656C3A225B5D';
wwv_flow_imp.g_varchar2_table(3158) := '222C696E73657274546578743A746869732E676574496E7365727454657874466F724775657373656456616C7565285B5D2C74292C696E7365727454657874466F726D61743A456F2E536E69707065742C64657461696C3A5861282264656661756C7473';
wwv_flow_imp.g_varchar2_table(3159) := '2E6172726179222C224E657720617272617922292C646F63756D656E746174696F6E3A22227D297D2C652E70726F746F747970652E616464426F6F6C65616E56616C7565436F6D706C6574696F6E3D66756E6374696F6E28652C742C6E297B6E2E616464';
wwv_flow_imp.g_varchar2_table(3160) := '287B6B696E643A746869732E67657453756767657374696F6E4B696E642822626F6F6C65616E22292C6C6162656C3A653F2274727565223A2266616C7365222C696E73657274546578743A746869732E676574496E7365727454657874466F7256616C75';
wwv_flow_imp.g_varchar2_table(3161) := '6528652C74292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22227D297D2C652E70726F746F747970652E6164644E756C6C56616C7565436F6D706C6574696F6E3D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(3162) := '2C74297B742E616464287B6B696E643A746869732E67657453756767657374696F6E4B696E6428226E756C6C22292C6C6162656C3A226E756C6C222C696E73657274546578743A226E756C6C222B652C696E7365727454657874466F726D61743A456F2E';
wwv_flow_imp.g_varchar2_table(3163) := '536E69707065742C646F63756D656E746174696F6E3A22227D297D2C652E70726F746F747970652E616464446F6C6C6172536368656D61436F6D706C6574696F6E733D66756E6374696F6E28652C74297B766172206E3D746869732C723D746869732E73';
wwv_flow_imp.g_varchar2_table(3164) := '6368656D61536572766963652E67657452656769737465726564536368656D61496473282866756E6374696F6E2865297B72657475726E2268747470223D3D3D657C7C226874747073223D3D3D657D29293B722E666F7245616368282866756E6374696F';
wwv_flow_imp.g_varchar2_table(3165) := '6E2872297B72657475726E20742E616464287B6B696E643A536F2E4D6F64756C652C6C6162656C3A6E2E6765744C6162656C466F7256616C75652872292C66696C746572546578743A6E2E67657446696C74657254657874466F7256616C75652872292C';
wwv_flow_imp.g_varchar2_table(3166) := '696E73657274546578743A6E2E676574496E7365727454657874466F7256616C756528722C65292C696E7365727454657874466F726D61743A456F2E536E69707065742C646F63756D656E746174696F6E3A22227D297D29297D2C652E70726F746F7479';
wwv_flow_imp.g_varchar2_table(3167) := '70652E6765744C6162656C466F7256616C75653D66756E6374696F6E2865297B72657475726E204A534F4E2E737472696E676966792865297D2C652E70726F746F747970652E67657446696C74657254657874466F7256616C75653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3168) := '2865297B72657475726E204A534F4E2E737472696E676966792865297D2C652E70726F746F747970652E67657446696C74657254657874466F72536E697070657456616C75653D66756E6374696F6E2865297B72657475726E204A534F4E2E737472696E';
wwv_flow_imp.g_varchar2_table(3169) := '676966792865292E7265706C616365282F5C245C7B5C642B3A285B5E7D5D2B295C7D7C5C245C642B2F672C22243122297D2C652E70726F746F747970652E6765744C6162656C466F72536E697070657456616C75653D66756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(3170) := '7475726E204A534F4E2E737472696E676966792865292E7265706C616365282F5C245C7B5C642B3A285B5E7D5D2B295C7D7C5C245C642B2F672C22243122297D2C652E70726F746F747970652E676574496E7365727454657874466F72506C61696E5465';
wwv_flow_imp.g_varchar2_table(3171) := '78743D66756E6374696F6E2865297B72657475726E20652E7265706C616365282F5B5C5C5C245C7D5D2F672C225C5C242622297D2C652E70726F746F747970652E676574496E7365727454657874466F7256616C75653D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(3172) := '7B766172206E3D4A534F4E2E737472696E6769667928652C6E756C6C2C225C7422293B72657475726E227B7D223D3D3D6E3F227B24317D222B743A225B5D223D3D3D6E3F225B24315D222B743A746869732E676574496E7365727454657874466F72506C';
wwv_flow_imp.g_varchar2_table(3173) := '61696E54657874286E2B74297D2C652E70726F746F747970652E676574496E7365727454657874466F72536E697070657456616C75653D66756E6374696F6E28652C74297B72657475726E204A6128652C22222C2866756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(3174) := '75726E22737472696E67223D3D747970656F6620652626225E223D3D3D655B305D3F652E7375627374722831293A4A534F4E2E737472696E676966792865297D29292B747D2C652E70726F746F747970652E676574496E7365727454657874466F724775';
wwv_flow_imp.g_varchar2_table(3175) := '657373656456616C75653D66756E6374696F6E28652C74297B73776974636828747970656F662065297B63617365226F626A656374223A72657475726E206E756C6C3D3D3D653F22247B313A6E756C6C7D222B743A746869732E676574496E7365727454';
wwv_flow_imp.g_varchar2_table(3176) := '657874466F7256616C756528652C74293B6361736522737472696E67223A766172206E3D4A534F4E2E737472696E676966792865293B72657475726E206E3D6E2E73756273747228312C6E2E6C656E6774682D32292C2722247B313A272B286E3D746869';
wwv_flow_imp.g_varchar2_table(3177) := '732E676574496E7365727454657874466F72506C61696E54657874286E29292B277D22272B743B63617365226E756D626572223A6361736522626F6F6C65616E223A72657475726E22247B313A222B4A534F4E2E737472696E676966792865292B227D22';
wwv_flow_imp.g_varchar2_table(3178) := '2B747D72657475726E20746869732E676574496E7365727454657874466F7256616C756528652C74297D2C652E70726F746F747970652E67657453756767657374696F6E4B696E643D66756E6374696F6E2865297B69662841727261792E697341727261';
wwv_flow_imp.g_varchar2_table(3179) := '79286529297B76617220743D653B653D742E6C656E6774683E303F745B305D3A766F696420307D69662821652972657475726E20536F2E56616C75653B7377697463682865297B6361736522737472696E67223A64656661756C743A72657475726E2053';
wwv_flow_imp.g_varchar2_table(3180) := '6F2E56616C75653B63617365226F626A656374223A72657475726E20536F2E4D6F64756C653B636173652270726F7065727479223A72657475726E20536F2E50726F70657274797D7D2C652E70726F746F747970652E6765744C6162656C54657874466F';
wwv_flow_imp.g_varchar2_table(3181) := '724D61746368696E674E6F64653D66756E6374696F6E28652C74297B73776974636828652E74797065297B63617365226172726179223A72657475726E225B5D223B63617365226F626A656374223A72657475726E227B7D223B64656661756C743A7265';
wwv_flow_imp.g_varchar2_table(3182) := '7475726E20742E6765745465787428292E73756273747228652E6F66667365742C652E6C656E677468297D7D2C652E70726F746F747970652E676574496E7365727454657874466F724D61746368696E674E6F64653D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(3183) := '297B73776974636828652E74797065297B63617365226172726179223A72657475726E20746869732E676574496E7365727454657874466F7256616C7565285B5D2C6E293B63617365226F626A656374223A72657475726E20746869732E676574496E73';
wwv_flow_imp.g_varchar2_table(3184) := '65727454657874466F7256616C7565287B7D2C6E293B64656661756C743A76617220723D742E6765745465787428292E73756273747228652E6F66667365742C652E6C656E677468292B6E3B72657475726E20746869732E676574496E73657274546578';
wwv_flow_imp.g_varchar2_table(3185) := '74466F72506C61696E546578742872297D7D2C652E70726F746F747970652E676574496E7365727454657874466F7250726F70657274793D66756E6374696F6E28652C742C6E2C72297B76617220693D746869732E676574496E7365727454657874466F';
wwv_flow_imp.g_varchar2_table(3186) := '7256616C756528652C2222293B696628216E2972657475726E20693B76617220732C6F3D692B223A20222C613D303B69662874297B69662841727261792E6973417272617928742E64656661756C74536E69707065747329297B696628313D3D3D742E64';
wwv_flow_imp.g_varchar2_table(3187) := '656661756C74536E6970706574732E6C656E677468297B766172206C3D742E64656661756C74536E6970706574735B305D2E626F64793B616F286C29262628733D746869732E676574496E7365727454657874466F72536E697070657456616C7565286C';
wwv_flow_imp.g_varchar2_table(3188) := '2C222229297D612B3D742E64656661756C74536E6970706574732E6C656E6774687D696628742E656E756D262628737C7C31213D3D742E656E756D2E6C656E6774687C7C28733D746869732E676574496E7365727454657874466F724775657373656456';
wwv_flow_imp.g_varchar2_table(3189) := '616C756528742E656E756D5B305D2C222229292C612B3D742E656E756D2E6C656E677468292C616F28742E64656661756C7429262628737C7C28733D746869732E676574496E7365727454657874466F724775657373656456616C756528742E64656661';
wwv_flow_imp.g_varchar2_table(3190) := '756C742C222229292C612B2B292C41727261792E6973417272617928742E6578616D706C6573292626742E6578616D706C65732E6C656E677468262628737C7C28733D746869732E676574496E7365727454657874466F724775657373656456616C7565';
wwv_flow_imp.g_varchar2_table(3191) := '28742E6578616D706C65735B305D2C222229292C612B3D742E6578616D706C65732E6C656E677468292C303D3D3D61297B76617220753D41727261792E6973417272617928742E74797065293F742E747970655B305D3A742E747970653B737769746368';
wwv_flow_imp.g_varchar2_table(3192) := '28757C7C28742E70726F706572746965733F753D226F626A656374223A742E6974656D73262628753D2261727261792229292C75297B6361736522626F6F6C65616E223A733D222431223B627265616B3B6361736522737472696E67223A733D27222431';
wwv_flow_imp.g_varchar2_table(3193) := '22273B627265616B3B63617365226F626A656374223A733D227B24317D223B627265616B3B63617365226172726179223A733D225B24315D223B627265616B3B63617365226E756D626572223A6361736522696E7465676572223A733D22247B313A307D';
wwv_flow_imp.g_varchar2_table(3194) := '223B627265616B3B63617365226E756C6C223A733D22247B313A6E756C6C7D223B627265616B3B64656661756C743A72657475726E20697D7D7D72657475726E2821737C7C613E3129262628733D22243122292C6F2B732B727D2C652E70726F746F7479';
wwv_flow_imp.g_varchar2_table(3195) := '70652E67657443757272656E74576F72643D66756E6374696F6E28652C74297B666F7228766172206E3D742D312C723D652E6765745465787428293B6E3E3D3026262D313D3D3D27205C745C6E5C725C76223A7B5B2C5D7D272E696E6465784F6628722E';
wwv_flow_imp.g_varchar2_table(3196) := '636861724174286E29293B296E2D2D3B72657475726E20722E737562737472696E67286E2B312C74297D2C652E70726F746F747970652E6576616C75617465536570617261746F7241667465723D66756E6374696F6E28652C74297B766172206E3D656F';
wwv_flow_imp.g_varchar2_table(3197) := '28652E6765745465787428292C2130293B737769746368286E2E736574506F736974696F6E2874292C6E2E7363616E2829297B6361736520353A6361736520323A6361736520343A636173652031373A72657475726E22223B64656661756C743A726574';
wwv_flow_imp.g_varchar2_table(3198) := '75726E222C227D7D2C652E70726F746F747970652E66696E644974656D41744F66667365743D66756E6374696F6E28652C742C6E297B666F722876617220723D656F28742E6765745465787428292C2130292C693D652E6974656D732C733D692E6C656E';
wwv_flow_imp.g_varchar2_table(3199) := '6774682D313B733E3D303B732D2D297B766172206F3D695B735D3B6966286E3E6F2E6F66667365742B6F2E6C656E6774682972657475726E20722E736574506F736974696F6E286F2E6F66667365742B6F2E6C656E677468292C353D3D3D722E7363616E';
wwv_flow_imp.g_varchar2_table(3200) := '282926266E3E3D722E676574546F6B656E4F666673657428292B722E676574546F6B656E4C656E67746828293F732B313A733B6966286E3E3D6F2E6F66667365742972657475726E20737D72657475726E20307D2C652E70726F746F747970652E697349';
wwv_flow_imp.g_varchar2_table(3201) := '6E436F6D6D656E743D66756E6374696F6E28652C742C6E297B76617220723D656F28652E6765745465787428292C2131293B722E736574506F736974696F6E2874293B666F722876617220693D722E7363616E28293B3137213D3D692626722E67657454';
wwv_flow_imp.g_varchar2_table(3202) := '6F6B656E4F666673657428292B722E676574546F6B656E4C656E67746828293C6E3B29693D722E7363616E28293B72657475726E2831323D3D3D697C7C31333D3D3D69292626722E676574546F6B656E4F666673657428293C3D6E7D2C652E70726F746F';
wwv_flow_imp.g_varchar2_table(3203) := '747970652E66726F6D4D61726B75703D66756E6374696F6E2865297B696628652626746869732E646F6573537570706F72744D61726B646F776E28292972657475726E7B6B696E643A5F6F2E4D61726B646F776E2C76616C75653A657D7D2C652E70726F';
wwv_flow_imp.g_varchar2_table(3204) := '746F747970652E646F6573537570706F72744D61726B646F776E3D66756E6374696F6E28297B69662821616F28746869732E737570706F7274734D61726B646F776E29297B76617220653D746869732E636C69656E744361706162696C69746965732E74';
wwv_flow_imp.g_varchar2_table(3205) := '657874446F63756D656E742626746869732E636C69656E744361706162696C69746965732E74657874446F63756D656E742E636F6D706C6574696F6E3B746869732E737570706F7274734D61726B646F776E3D652626652E636F6D706C6574696F6E4974';
wwv_flow_imp.g_varchar2_table(3206) := '656D262641727261792E6973417272617928652E636F6D706C6574696F6E4974656D2E646F63756D656E746174696F6E466F726D61742926262D31213D3D652E636F6D706C6574696F6E4974656D2E646F63756D656E746174696F6E466F726D61742E69';
wwv_flow_imp.g_varchar2_table(3207) := '6E6465784F66285F6F2E4D61726B646F776E297D72657475726E20746869732E737570706F7274734D61726B646F776E7D2C652E70726F746F747970652E646F6573537570706F727473436F6D6D6974436861726163746572733D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3208) := '297B69662821616F28746869732E737570706F727473436F6D6D69744368617261637465727329297B76617220653D746869732E636C69656E744361706162696C69746965732E74657874446F63756D656E742626746869732E636C69656E7443617061';
wwv_flow_imp.g_varchar2_table(3209) := '62696C69746965732E74657874446F63756D656E742E636F6D706C6574696F6E3B746869732E737570706F727473436F6D6D6974436861726163746572733D652626652E636F6D706C6574696F6E4974656D26262121652E636F6D706C6574696F6E4974';
wwv_flow_imp.g_varchar2_table(3210) := '656D2E636F6D6D697443686172616374657273537570706F72747D72657475726E20746869732E737570706F727473436F6D6D6974436861726163746572737D2C657D28292C5A613D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E';
wwv_flow_imp.g_varchar2_table(3211) := '297B766F696420303D3D3D74262628743D5B5D292C746869732E736368656D61536572766963653D652C746869732E636F6E747269627574696F6E733D742C746869732E70726F6D6973653D6E7C7C50726F6D6973657D72657475726E20652E70726F74';
wwv_flow_imp.g_varchar2_table(3212) := '6F747970652E646F486F7665723D66756E6374696F6E28652C742C6E297B76617220723D652E6F666673657441742874292C693D6E2E6765744E6F646546726F6D4F66667365742872293B69662821697C7C28226F626A656374223D3D3D692E74797065';
wwv_flow_imp.g_varchar2_table(3213) := '7C7C226172726179223D3D3D692E74797065292626723E692E6F66667365742B312626723C692E6F66667365742B692E6C656E6774682D312972657475726E20746869732E70726F6D6973652E7265736F6C7665286E756C6C293B76617220733D693B69';
wwv_flow_imp.g_varchar2_table(3214) := '662822737472696E67223D3D3D692E74797065297B766172206F3D692E706172656E743B6966286F26262270726F7065727479223D3D3D6F2E7479706526266F2E6B65794E6F64653D3D3D6926262128693D6F2E76616C75654E6F646529297265747572';
wwv_flow_imp.g_varchar2_table(3215) := '6E20746869732E70726F6D6973652E7265736F6C7665286E756C6C297D666F722876617220613D68732E63726561746528652E706F736974696F6E417428732E6F6666736574292C652E706F736974696F6E417428732E6F66667365742B732E6C656E67';
wwv_flow_imp.g_varchar2_table(3216) := '746829292C6C3D66756E6374696F6E2865297B72657475726E7B636F6E74656E74733A652C72616E67653A617D7D2C753D57612869292C633D746869732E636F6E747269627574696F6E732E6C656E6774682D313B633E3D303B632D2D297B7661722068';
wwv_flow_imp.g_varchar2_table(3217) := '3D746869732E636F6E747269627574696F6E735B635D2E676574496E666F436F6E747269627574696F6E28652E7572692C75293B696628682972657475726E20682E7468656E282866756E6374696F6E2865297B72657475726E206C2865297D29297D72';
wwv_flow_imp.g_varchar2_table(3218) := '657475726E20746869732E736368656D61536572766963652E676574536368656D61466F725265736F7572636528652E7572692C6E292E7468656E282866756E6374696F6E2865297B69662865262669297B76617220743D6E2E6765744D61746368696E';
wwv_flow_imp.g_varchar2_table(3219) := '67536368656D617328652E736368656D612C692E6F6666736574292C723D766F696420302C733D766F696420302C6F3D766F696420302C613D766F696420303B742E6576657279282866756E6374696F6E2865297B696628652E6E6F64653D3D3D692626';
wwv_flow_imp.g_varchar2_table(3220) := '21652E696E7665727465642626652E736368656D61262628723D727C7C652E736368656D612E7469746C652C733D737C7C652E736368656D612E6D61726B646F776E4465736372697074696F6E7C7C596128652E736368656D612E646573637269707469';
wwv_flow_imp.g_varchar2_table(3221) := '6F6E292C652E736368656D612E656E756D29297B76617220743D652E736368656D612E656E756D2E696E6465784F66282461286929293B652E736368656D612E6D61726B646F776E456E756D4465736372697074696F6E733F6F3D652E736368656D612E';
wwv_flow_imp.g_varchar2_table(3222) := '6D61726B646F776E456E756D4465736372697074696F6E735B745D3A652E736368656D612E656E756D4465736372697074696F6E732626286F3D596128652E736368656D612E656E756D4465736372697074696F6E735B745D29292C6F26262273747269';
wwv_flow_imp.g_varchar2_table(3223) := '6E6722213D747970656F6628613D652E736368656D612E656E756D5B745D29262628613D4A534F4E2E737472696E67696679286129297D72657475726E21307D29293B76617220753D22223B72657475726E2072262628753D5961287229292C73262628';
wwv_flow_imp.g_varchar2_table(3224) := '752E6C656E6774683E30262628752B3D225C6E5C6E22292C752B3D73292C6F262628752E6C656E6774683E30262628752B3D225C6E5C6E22292C752B3D2260222E636F6E6361742828633D612C2D31213D3D632E696E6465784F6628226022293F226060';
wwv_flow_imp.g_varchar2_table(3225) := '20222B632B22206060223A63292C22603A2022292E636F6E636174286F29292C6C285B755D297D76617220633B72657475726E206E756C6C7D29297D2C657D28293B66756E6374696F6E2059612865297B696628652972657475726E20652E7265706C61';
wwv_flow_imp.g_varchar2_table(3226) := '6365282F285B5E5C6E5C725D29285C723F5C6E29285B5E5C6E5C725D292F676D2C2224315C6E5C6E243322292E7265706C616365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D2E215D2F672C225C5C242622297D76617220656C3D786128292C746C3D';
wwv_flow_imp.g_varchar2_table(3227) := '66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E6A736F6E536368656D61536572766963653D652C746869732E70726F6D6973653D742C746869732E76616C69646174696F6E456E61626C65643D21307D72657475726E20';
wwv_flow_imp.g_varchar2_table(3228) := '652E70726F746F747970652E636F6E6669677572653D66756E6374696F6E2865297B65262628746869732E76616C69646174696F6E456E61626C65643D2131213D3D652E76616C69646174652C746869732E636F6D6D656E7453657665726974793D652E';
wwv_flow_imp.g_varchar2_table(3229) := '616C6C6F77436F6D6D656E74733F766F696420303A6B732E4572726F72297D2C652E70726F746F747970652E646F56616C69646174696F6E3D66756E6374696F6E28652C742C6E2C72297B76617220693D746869733B69662821746869732E76616C6964';
wwv_flow_imp.g_varchar2_table(3230) := '6174696F6E456E61626C65642972657475726E20746869732E70726F6D6973652E7265736F6C7665285B5D293B76617220733D5B5D2C6F3D7B7D2C613D66756E6374696F6E2865297B76617220743D652E72616E67652E73746172742E6C696E652B2220';
wwv_flow_imp.g_varchar2_table(3231) := '222B652E72616E67652E73746172742E6368617261637465722B2220222B652E6D6573736167653B6F5B745D7C7C286F5B745D3D21302C732E70757368286529297D2C6C3D66756E6374696F6E2872297B766172206F3D286E756C6C3D3D6E3F766F6964';
wwv_flow_imp.g_varchar2_table(3232) := '20303A6E2E747261696C696E67436F6D6D6173293F736C286E2E747261696C696E67436F6D6D6173293A6B732E4572726F722C6C3D286E756C6C3D3D6E3F766F696420303A6E2E636F6D6D656E7473293F736C286E2E636F6D6D656E7473293A692E636F';
wwv_flow_imp.g_varchar2_table(3233) := '6D6D656E7453657665726974792C753D286E756C6C3D3D6E3F766F696420303A6E2E736368656D6156616C69646174696F6E293F736C286E2E736368656D6156616C69646174696F6E293A6B732E5761726E696E672C633D286E756C6C3D3D6E3F766F69';
wwv_flow_imp.g_varchar2_table(3234) := '6420303A6E2E736368656D6152657175657374293F736C286E2E736368656D6152657175657374293A6B732E5761726E696E673B69662872297B696628722E6572726F72732E6C656E6774682626742E726F6F74262663297B76617220683D742E726F6F';
wwv_flow_imp.g_varchar2_table(3235) := '742C643D226F626A656374223D3D3D682E747970653F682E70726F706572746965735B305D3A766F696420303B6966286426262224736368656D61223D3D3D642E6B65794E6F64652E76616C7565297B76617220663D642E76616C75654E6F64657C7C64';
wwv_flow_imp.g_varchar2_table(3236) := '2C6D3D68732E63726561746528652E706F736974696F6E417428662E6F6666736574292C652E706F736974696F6E417428662E6F66667365742B662E6C656E67746829293B612849732E637265617465286D2C722E6572726F72735B305D2C632C76612E';
wwv_flow_imp.g_varchar2_table(3237) := '536368656D615265736F6C76654572726F7229297D656C7365206D3D68732E63726561746528652E706F736974696F6E417428682E6F6666736574292C652E706F736974696F6E417428682E6F66667365742B3129292C612849732E637265617465286D';
wwv_flow_imp.g_varchar2_table(3238) := '2C722E6572726F72735B305D2C632C76612E536368656D615265736F6C76654572726F7229297D656C73652069662875297B76617220673D742E76616C696461746528652C722E736368656D612C75293B672626672E666F72456163682861297D726C28';
wwv_flow_imp.g_varchar2_table(3239) := '722E736368656D61292626286C3D766F69642030292C696C28722E736368656D61292626286F3D766F69642030297D666F722876617220703D302C763D742E73796E7461784572726F72733B703C762E6C656E6774683B702B2B297B76617220623D765B';
wwv_flow_imp.g_varchar2_table(3240) := '705D3B696628622E636F64653D3D3D76612E547261696C696E67436F6D6D61297B696628226E756D62657222213D747970656F66206F29636F6E74696E75653B622E73657665726974793D6F7D612862297D696628226E756D626572223D3D747970656F';
wwv_flow_imp.g_varchar2_table(3241) := '66206C297B76617220793D656C2822496E76616C6964436F6D6D656E74546F6B656E222C22436F6D6D656E747320617265206E6F74207065726D697474656420696E204A534F4E2E22293B742E636F6D6D656E74732E666F7245616368282866756E6374';
wwv_flow_imp.g_varchar2_table(3242) := '696F6E2865297B612849732E63726561746528652C792C6C2C76612E436F6D6D656E744E6F745065726D697474656429297D29297D72657475726E20737D3B69662872297B76617220753D722E69647C7C22736368656D61736572766963653A2F2F756E';
wwv_flow_imp.g_varchar2_table(3243) := '7469746C65642F222B6E6C2B2B3B72657475726E20746869732E6A736F6E536368656D61536572766963652E726567697374657245787465726E616C536368656D6128752C5B5D2C72292E6765745265736F6C766564536368656D6128292E7468656E28';
wwv_flow_imp.g_varchar2_table(3244) := '2866756E6374696F6E2865297B72657475726E206C2865297D29297D72657475726E20746869732E6A736F6E536368656D61536572766963652E676574536368656D61466F725265736F7572636528652E7572692C74292E7468656E282866756E637469';
wwv_flow_imp.g_varchar2_table(3245) := '6F6E2865297B72657475726E206C2865297D29297D2C652E70726F746F747970652E6765744C616E67756167655374617475733D66756E6374696F6E28652C74297B72657475726E7B736368656D61733A746869732E6A736F6E536368656D6153657276';
wwv_flow_imp.g_varchar2_table(3246) := '6963652E676574536368656D6155524973466F725265736F7572636528652E7572692C74297D7D2C657D28292C6E6C3D303B66756E6374696F6E20726C2865297B696628652626226F626A656374223D3D747970656F662065297B6966286C6F28652E61';
wwv_flow_imp.g_varchar2_table(3247) := '6C6C6F77436F6D6D656E7473292972657475726E20652E616C6C6F77436F6D6D656E74733B696628652E616C6C4F6629666F722876617220743D302C6E3D652E616C6C4F663B743C6E2E6C656E6774683B742B2B297B76617220723D726C286E5B745D29';
wwv_flow_imp.g_varchar2_table(3248) := '3B6966286C6F2872292972657475726E20727D7D7D66756E6374696F6E20696C2865297B696628652626226F626A656374223D3D747970656F662065297B6966286C6F28652E616C6C6F77547261696C696E67436F6D6D6173292972657475726E20652E';
wwv_flow_imp.g_varchar2_table(3249) := '616C6C6F77547261696C696E67436F6D6D61733B76617220743D653B6966286C6F28742E616C6C6F7773547261696C696E67436F6D6D6173292972657475726E20742E616C6C6F7773547261696C696E67436F6D6D61733B696628652E616C6C4F662966';
wwv_flow_imp.g_varchar2_table(3250) := '6F7228766172206E3D302C723D652E616C6C4F663B6E3C722E6C656E6774683B6E2B2B297B76617220693D696C28725B6E5D293B6966286C6F2869292972657475726E20697D7D7D66756E6374696F6E20736C2865297B7377697463682865297B636173';
wwv_flow_imp.g_varchar2_table(3251) := '65226572726F72223A72657475726E206B732E4572726F723B63617365227761726E696E67223A72657475726E206B732E5761726E696E673B636173652269676E6F7265223A72657475726E7D7D766172206F6C3D34382C616C3D35372C6C6C3D36352C';
wwv_flow_imp.g_varchar2_table(3252) := '756C3D39372C636C3D3130323B66756E6374696F6E20686C2865297B72657475726E20653C6F6C3F303A653C3D616C3F652D6F6C3A28653C756C262628652B3D756C2D6C6C292C653E3D756C2626653C3D636C3F652D756C2B31303A30297D66756E6374';
wwv_flow_imp.g_varchar2_table(3253) := '696F6E20646C2865297B6966282223223D3D3D655B305D2973776974636828652E6C656E677468297B6361736520343A72657475726E7B7265643A31372A686C28652E63686172436F64654174283129292F3235352C677265656E3A31372A686C28652E';
wwv_flow_imp.g_varchar2_table(3254) := '63686172436F64654174283229292F3235352C626C75653A31372A686C28652E63686172436F64654174283329292F3235352C616C7068613A317D3B6361736520353A72657475726E7B7265643A31372A686C28652E63686172436F6465417428312929';
wwv_flow_imp.g_varchar2_table(3255) := '2F3235352C677265656E3A31372A686C28652E63686172436F64654174283229292F3235352C626C75653A31372A686C28652E63686172436F64654174283329292F3235352C616C7068613A31372A686C28652E63686172436F64654174283429292F32';
wwv_flow_imp.g_varchar2_table(3256) := '35357D3B6361736520373A72657475726E7B7265643A2831362A686C28652E63686172436F64654174283129292B686C28652E63686172436F6465417428322929292F3235352C677265656E3A2831362A686C28652E63686172436F6465417428332929';
wwv_flow_imp.g_varchar2_table(3257) := '2B686C28652E63686172436F6465417428342929292F3235352C626C75653A2831362A686C28652E63686172436F64654174283529292B686C28652E63686172436F6465417428362929292F3235352C616C7068613A317D3B6361736520393A72657475';
wwv_flow_imp.g_varchar2_table(3258) := '726E7B7265643A2831362A686C28652E63686172436F64654174283129292B686C28652E63686172436F6465417428322929292F3235352C677265656E3A2831362A686C28652E63686172436F64654174283329292B686C28652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(3259) := '7428342929292F3235352C626C75653A2831362A686C28652E63686172436F64654174283529292B686C28652E63686172436F6465417428362929292F3235352C616C7068613A2831362A686C28652E63686172436F64654174283729292B686C28652E';
wwv_flow_imp.g_varchar2_table(3260) := '63686172436F6465417428382929292F3235357D7D7D76617220666C3D66756E6374696F6E28297B66756E6374696F6E20652865297B746869732E736368656D61536572766963653D657D72657475726E20652E70726F746F747970652E66696E64446F';
wwv_flow_imp.g_varchar2_table(3261) := '63756D656E7453796D626F6C733D66756E6374696F6E28652C742C6E297B76617220723D746869733B766F696420303D3D3D6E2626286E3D7B726573756C744C696D69743A4E756D6265722E4D41585F56414C55457D293B76617220693D742E726F6F74';
wwv_flow_imp.g_varchar2_table(3262) := '3B69662821692972657475726E5B5D3B76617220733D6E2E726573756C744C696D69747C7C4E756D6265722E4D41585F56414C55452C6F3D652E7572693B69662828227673636F64653A2F2F64656661756C7473657474696E67732F6B657962696E6469';
wwv_flow_imp.g_varchar2_table(3263) := '6E67732E6A736F6E223D3D3D6F7C7C756F286F2E746F4C6F7765724361736528292C222F757365722F6B657962696E64696E67732E6A736F6E2229292626226172726179223D3D3D692E74797065297B666F722876617220613D5B5D2C6C3D302C753D69';
wwv_flow_imp.g_varchar2_table(3264) := '2E6974656D733B6C3C752E6C656E6774683B6C2B2B297B76617220633D755B6C5D3B696628226F626A656374223D3D3D632E7479706529666F722876617220683D302C643D632E70726F706572746965733B683C642E6C656E6774683B682B2B297B7661';
wwv_flow_imp.g_varchar2_table(3265) := '7220663D645B685D3B696628226B6579223D3D3D662E6B65794E6F64652E76616C75652626662E76616C75654E6F6465297B766172206D3D66732E63726561746528652E7572692C6D6C28652C6329293B696628612E70757368287B6E616D653A246128';
wwv_flow_imp.g_varchar2_table(3266) := '662E76616C75654E6F6465292C6B696E643A556F2E46756E6374696F6E2C6C6F636174696F6E3A6D7D292C2D2D733C3D302972657475726E206E26266E2E6F6E526573756C744C696D6974457863656564656426266E2E6F6E526573756C744C696D6974';
wwv_flow_imp.g_varchar2_table(3267) := '4578636565646564286F292C617D7D7D72657475726E20617D666F722876617220673D5B7B6E6F64653A692C636F6E7461696E65724E616D653A22227D5D2C703D302C763D21312C623D5B5D2C793D66756E6374696F6E28742C6E297B22617272617922';
wwv_flow_imp.g_varchar2_table(3268) := '3D3D3D742E747970653F742E6974656D732E666F7245616368282866756E6374696F6E2865297B652626672E70757368287B6E6F64653A652C636F6E7461696E65724E616D653A6E7D297D29293A226F626A656374223D3D3D742E747970652626742E70';
wwv_flow_imp.g_varchar2_table(3269) := '726F706572746965732E666F7245616368282866756E6374696F6E2874297B76617220693D742E76616C75654E6F64653B6966286929696628733E30297B732D2D3B766172206F3D66732E63726561746528652E7572692C6D6C28652C7429292C613D6E';
wwv_flow_imp.g_varchar2_table(3270) := '3F6E2B222E222B742E6B65794E6F64652E76616C75653A742E6B65794E6F64652E76616C75653B622E70757368287B6E616D653A722E6765744B65794C6162656C2874292C6B696E643A722E67657453796D626F6C4B696E6428692E74797065292C6C6F';
wwv_flow_imp.g_varchar2_table(3271) := '636174696F6E3A6F2C636F6E7461696E65724E616D653A6E7D292C672E70757368287B6E6F64653A692C636F6E7461696E65724E616D653A617D297D656C736520763D21307D29297D3B703C672E6C656E6774683B297B766172205F3D675B702B2B5D3B';
wwv_flow_imp.g_varchar2_table(3272) := '79285F2E6E6F64652C5F2E636F6E7461696E65724E616D65297D72657475726E207626266E26266E2E6F6E526573756C744C696D6974457863656564656426266E2E6F6E526573756C744C696D69744578636565646564286F292C627D2C652E70726F74';
wwv_flow_imp.g_varchar2_table(3273) := '6F747970652E66696E64446F63756D656E7453796D626F6C73323D66756E6374696F6E28652C742C6E297B76617220723D746869733B766F696420303D3D3D6E2626286E3D7B726573756C744C696D69743A4E756D6265722E4D41585F56414C55457D29';
wwv_flow_imp.g_varchar2_table(3274) := '3B76617220693D742E726F6F743B69662821692972657475726E5B5D3B76617220733D6E2E726573756C744C696D69747C7C4E756D6265722E4D41585F56414C55452C6F3D652E7572693B69662828227673636F64653A2F2F64656661756C7473657474';
wwv_flow_imp.g_varchar2_table(3275) := '696E67732F6B657962696E64696E67732E6A736F6E223D3D3D6F7C7C756F286F2E746F4C6F7765724361736528292C222F757365722F6B657962696E64696E67732E6A736F6E2229292626226172726179223D3D3D692E74797065297B666F7228766172';
wwv_flow_imp.g_varchar2_table(3276) := '20613D5B5D2C6C3D302C753D692E6974656D733B6C3C752E6C656E6774683B6C2B2B297B76617220633D755B6C5D3B696628226F626A656374223D3D3D632E7479706529666F722876617220683D302C643D632E70726F706572746965733B683C642E6C';
wwv_flow_imp.g_varchar2_table(3277) := '656E6774683B682B2B297B76617220663D645B685D3B696628226B6579223D3D3D662E6B65794E6F64652E76616C75652626662E76616C75654E6F6465297B766172206D3D6D6C28652C63292C673D6D6C28652C662E6B65794E6F6465293B696628612E';
wwv_flow_imp.g_varchar2_table(3278) := '70757368287B6E616D653A246128662E76616C75654E6F6465292C6B696E643A556F2E46756E6374696F6E2C72616E67653A6D2C73656C656374696F6E52616E67653A677D292C2D2D733C3D302972657475726E206E26266E2E6F6E526573756C744C69';
wwv_flow_imp.g_varchar2_table(3279) := '6D6974457863656564656426266E2E6F6E526573756C744C696D69744578636565646564286F292C617D7D7D72657475726E20617D666F722876617220703D5B5D2C763D5B7B6E6F64653A692C726573756C743A707D5D2C623D302C793D21312C5F3D66';
wwv_flow_imp.g_varchar2_table(3280) := '756E6374696F6E28742C6E297B226172726179223D3D3D742E747970653F742E6974656D732E666F7245616368282866756E6374696F6E28742C69297B6966287429696628733E30297B732D2D3B766172206F3D6D6C28652C74292C613D6F2C6C3D7B6E';
wwv_flow_imp.g_varchar2_table(3281) := '616D653A537472696E672869292C6B696E643A722E67657453796D626F6C4B696E6428742E74797065292C72616E67653A6F2C73656C656374696F6E52616E67653A612C6368696C6472656E3A5B5D7D3B6E2E70757368286C292C762E70757368287B72';
wwv_flow_imp.g_varchar2_table(3282) := '6573756C743A6C2E6368696C6472656E2C6E6F64653A747D297D656C736520793D21307D29293A226F626A656374223D3D3D742E747970652626742E70726F706572746965732E666F7245616368282866756E6374696F6E2874297B76617220693D742E';
wwv_flow_imp.g_varchar2_table(3283) := '76616C75654E6F64653B6966286929696628733E30297B732D2D3B766172206F3D6D6C28652C74292C613D6D6C28652C742E6B65794E6F6465292C6C3D5B5D2C753D7B6E616D653A722E6765744B65794C6162656C2874292C6B696E643A722E67657453';
wwv_flow_imp.g_varchar2_table(3284) := '796D626F6C4B696E6428692E74797065292C72616E67653A6F2C73656C656374696F6E52616E67653A612C6368696C6472656E3A6C2C64657461696C3A722E67657444657461696C2869297D3B6E2E707573682875292C762E70757368287B726573756C';
wwv_flow_imp.g_varchar2_table(3285) := '743A6C2C6E6F64653A697D297D656C736520793D21307D29297D3B623C762E6C656E6774683B297B76617220433D765B622B2B5D3B5F28432E6E6F64652C432E726573756C74297D72657475726E207926266E26266E2E6F6E526573756C744C696D6974';
wwv_flow_imp.g_varchar2_table(3286) := '457863656564656426266E2E6F6E526573756C744C696D69744578636565646564286F292C707D2C652E70726F746F747970652E67657453796D626F6C4B696E643D66756E6374696F6E2865297B7377697463682865297B63617365226F626A65637422';
wwv_flow_imp.g_varchar2_table(3287) := '3A72657475726E20556F2E4D6F64756C653B6361736522737472696E67223A72657475726E20556F2E537472696E673B63617365226E756D626572223A72657475726E20556F2E4E756D6265723B63617365226172726179223A72657475726E20556F2E';
wwv_flow_imp.g_varchar2_table(3288) := '41727261793B6361736522626F6F6C65616E223A72657475726E20556F2E426F6F6C65616E3B64656661756C743A72657475726E20556F2E5661726961626C657D7D2C652E70726F746F747970652E6765744B65794C6162656C3D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3289) := '65297B76617220743D652E6B65794E6F64652E76616C75653B72657475726E2074262628743D742E7265706C616365282F5B5C6E5D2F672C22E286B52229292C742626742E7472696D28293F743A2722272E636F6E63617428742C272227297D2C652E70';
wwv_flow_imp.g_varchar2_table(3290) := '726F746F747970652E67657444657461696C3D66756E6374696F6E2865297B696628652972657475726E22626F6F6C65616E223D3D3D652E747970657C7C226E756D626572223D3D3D652E747970657C7C226E756C6C223D3D3D652E747970657C7C2273';
wwv_flow_imp.g_varchar2_table(3291) := '7472696E67223D3D3D652E747970653F537472696E6728652E76616C7565293A226172726179223D3D3D652E747970653F652E6368696C6472656E2E6C656E6774683F766F696420303A225B5D223A226F626A656374223D3D3D652E747970653F652E63';
wwv_flow_imp.g_varchar2_table(3292) := '68696C6472656E2E6C656E6774683F766F696420303A227B7D223A766F696420307D2C652E70726F746F747970652E66696E64446F63756D656E74436F6C6F72733D66756E6374696F6E28652C742C6E297B72657475726E20746869732E736368656D61';
wwv_flow_imp.g_varchar2_table(3293) := '536572766963652E676574536368656D61466F725265736F7572636528652E7572692C74292E7468656E282866756E6374696F6E2872297B76617220693D5B5D3B6966287229666F722876617220733D6E2626226E756D626572223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(3294) := '6E2E726573756C744C696D69743F6E2E726573756C744C696D69743A4E756D6265722E4D41585F56414C55452C6F3D7B7D2C613D302C6C3D742E6765744D61746368696E67536368656D617328722E736368656D61293B613C6C2E6C656E6774683B612B';
wwv_flow_imp.g_varchar2_table(3295) := '2B297B76617220753D6C5B615D3B69662821752E696E7665727465642626752E736368656D6126262822636F6C6F72223D3D3D752E736368656D612E666F726D61747C7C22636F6C6F722D686578223D3D3D752E736368656D612E666F726D6174292626';
wwv_flow_imp.g_varchar2_table(3296) := '752E6E6F6465262622737472696E67223D3D3D752E6E6F64652E74797065297B76617220633D537472696E6728752E6E6F64652E6F6666736574293B696628216F5B635D297B76617220683D646C28246128752E6E6F646529293B69662868297B766172';
wwv_flow_imp.g_varchar2_table(3297) := '20643D6D6C28652C752E6E6F6465293B692E70757368287B636F6C6F723A682C72616E67653A647D297D6966286F5B635D3D21302C2D2D733C3D302972657475726E206E26266E2E6F6E526573756C744C696D6974457863656564656426266E2E6F6E52';
wwv_flow_imp.g_varchar2_table(3298) := '6573756C744C696D6974457863656564656428652E757269292C697D7D7D72657475726E20697D29297D2C652E70726F746F747970652E676574436F6C6F7250726573656E746174696F6E733D66756E6374696F6E28652C742C6E2C72297B7661722069';
wwv_flow_imp.g_varchar2_table(3299) := '2C733D5B5D2C6F3D4D6174682E726F756E64283235352A6E2E726564292C613D4D6174682E726F756E64283235352A6E2E677265656E292C6C3D4D6174682E726F756E64283235352A6E2E626C7565293B66756E6374696F6E20752865297B7661722074';
wwv_flow_imp.g_varchar2_table(3300) := '3D652E746F537472696E67283136293B72657475726E2032213D3D742E6C656E6774683F2230222B743A747D72657475726E20693D313D3D3D6E2E616C7068613F2223222E636F6E6361742875286F29292E636F6E6361742875286129292E636F6E6361';
wwv_flow_imp.g_varchar2_table(3301) := '742875286C29293A2223222E636F6E6361742875286F29292E636F6E6361742875286129292E636F6E6361742875286C29292E636F6E6361742875284D6174682E726F756E64283235352A6E2E616C7068612929292C732E70757368287B6C6162656C3A';
wwv_flow_imp.g_varchar2_table(3302) := '692C74657874456469743A44732E7265706C61636528722C4A534F4E2E737472696E67696679286929297D292C737D2C657D28293B66756E6374696F6E206D6C28652C74297B72657475726E2068732E63726561746528652E706F736974696F6E417428';
wwv_flow_imp.g_varchar2_table(3303) := '742E6F6666736574292C652E706F736974696F6E417428742E6F66667365742B742E6C656E67746829297D76617220676C2C706C2C766C2C626C2C796C2C5F6C2C436C3D786128292C776C3D7B736368656D614173736F63696174696F6E733A5B5D2C73';
wwv_flow_imp.g_varchar2_table(3304) := '6368656D61733A7B22687474703A2F2F6A736F6E2D736368656D612E6F72672F736368656D6123223A7B247265663A22687474703A2F2F6A736F6E2D736368656D612E6F72672F64726166742D30372F736368656D6123227D2C22687474703A2F2F6A73';
wwv_flow_imp.g_varchar2_table(3305) := '6F6E2D736368656D612E6F72672F64726166742D30342F736368656D6123223A7B24736368656D613A22687474703A2F2F6A736F6E2D736368656D612E6F72672F64726166742D30342F736368656D6123222C646566696E6974696F6E733A7B73636865';
wwv_flow_imp.g_varchar2_table(3306) := '6D6141727261793A7B747970653A226172726179222C6D696E4974656D733A312C6974656D733A7B247265663A2223227D7D2C706F736974697665496E74656765723A7B747970653A22696E7465676572222C6D696E696D756D3A307D2C706F73697469';
wwv_flow_imp.g_varchar2_table(3307) := '7665496E746567657244656661756C74303A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F706F736974697665496E7465676572227D2C7B64656661756C743A307D5D7D2C73696D706C6554797065733A7B747970653A227374';
wwv_flow_imp.g_varchar2_table(3308) := '72696E67222C656E756D3A5B226172726179222C22626F6F6C65616E222C22696E7465676572222C226E756C6C222C226E756D626572222C226F626A656374222C22737472696E67225D7D2C737472696E6741727261793A7B747970653A226172726179';
wwv_flow_imp.g_varchar2_table(3309) := '222C6974656D733A7B747970653A22737472696E67227D2C6D696E4974656D733A312C756E697175654974656D733A21307D7D2C747970653A226F626A656374222C70726F706572746965733A7B69643A7B747970653A22737472696E67222C666F726D';
wwv_flow_imp.g_varchar2_table(3310) := '61743A22757269227D2C24736368656D613A7B747970653A22737472696E67222C666F726D61743A22757269227D2C7469746C653A7B747970653A22737472696E67227D2C6465736372697074696F6E3A7B747970653A22737472696E67227D2C646566';
wwv_flow_imp.g_varchar2_table(3311) := '61756C743A7B7D2C6D756C7469706C654F663A7B747970653A226E756D626572222C6D696E696D756D3A302C6578636C75736976654D696E696D756D3A21307D2C6D6178696D756D3A7B747970653A226E756D626572227D2C6578636C75736976654D61';
wwv_flow_imp.g_varchar2_table(3312) := '78696D756D3A7B747970653A22626F6F6C65616E222C64656661756C743A21317D2C6D696E696D756D3A7B747970653A226E756D626572227D2C6578636C75736976654D696E696D756D3A7B747970653A22626F6F6C65616E222C64656661756C743A21';
wwv_flow_imp.g_varchar2_table(3313) := '317D2C6D61784C656E6774683A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F706F736974697665496E7465676572227D5D7D2C6D696E4C656E6774683A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E73';
wwv_flow_imp.g_varchar2_table(3314) := '2F706F736974697665496E746567657244656661756C7430227D5D7D2C7061747465726E3A7B747970653A22737472696E67222C666F726D61743A227265676578227D2C6164646974696F6E616C4974656D733A7B616E794F663A5B7B747970653A2262';
wwv_flow_imp.g_varchar2_table(3315) := '6F6F6C65616E227D2C7B247265663A2223227D5D2C64656661756C743A7B7D7D2C6974656D733A7B616E794F663A5B7B247265663A2223227D2C7B247265663A22232F646566696E6974696F6E732F736368656D614172726179227D5D2C64656661756C';
wwv_flow_imp.g_varchar2_table(3316) := '743A7B7D7D2C6D61784974656D733A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F706F736974697665496E7465676572227D5D7D2C6D696E4974656D733A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(3317) := '732F706F736974697665496E746567657244656661756C7430227D5D7D2C756E697175654974656D733A7B747970653A22626F6F6C65616E222C64656661756C743A21317D2C6D617850726F706572746965733A7B616C6C4F663A5B7B247265663A2223';
wwv_flow_imp.g_varchar2_table(3318) := '2F646566696E6974696F6E732F706F736974697665496E7465676572227D5D7D2C6D696E50726F706572746965733A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F706F736974697665496E746567657244656661756C743022';
wwv_flow_imp.g_varchar2_table(3319) := '7D5D7D2C72657175697265643A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F737472696E674172726179227D5D7D2C6164646974696F6E616C50726F706572746965733A7B616E794F663A5B7B747970653A22626F6F6C6561';
wwv_flow_imp.g_varchar2_table(3320) := '6E227D2C7B247265663A2223227D5D2C64656661756C743A7B7D7D2C646566696E6974696F6E733A7B747970653A226F626A656374222C6164646974696F6E616C50726F706572746965733A7B247265663A2223227D2C64656661756C743A7B7D7D2C70';
wwv_flow_imp.g_varchar2_table(3321) := '726F706572746965733A7B747970653A226F626A656374222C6164646974696F6E616C50726F706572746965733A7B247265663A2223227D2C64656661756C743A7B7D7D2C7061747465726E50726F706572746965733A7B747970653A226F626A656374';
wwv_flow_imp.g_varchar2_table(3322) := '222C6164646974696F6E616C50726F706572746965733A7B247265663A2223227D2C64656661756C743A7B7D7D2C646570656E64656E636965733A7B747970653A226F626A656374222C6164646974696F6E616C50726F706572746965733A7B616E794F';
wwv_flow_imp.g_varchar2_table(3323) := '663A5B7B247265663A2223227D2C7B247265663A22232F646566696E6974696F6E732F737472696E674172726179227D5D7D7D2C656E756D3A7B747970653A226172726179222C6D696E4974656D733A312C756E697175654974656D733A21307D2C7479';
wwv_flow_imp.g_varchar2_table(3324) := '70653A7B616E794F663A5B7B247265663A22232F646566696E6974696F6E732F73696D706C655479706573227D2C7B747970653A226172726179222C6974656D733A7B247265663A22232F646566696E6974696F6E732F73696D706C655479706573227D';
wwv_flow_imp.g_varchar2_table(3325) := '2C6D696E4974656D733A312C756E697175654974656D733A21307D5D7D2C666F726D61743A7B616E794F663A5B7B747970653A22737472696E67222C656E756D3A5B22646174652D74696D65222C22757269222C22656D61696C222C22686F73746E616D';
wwv_flow_imp.g_varchar2_table(3326) := '65222C2269707634222C2269707636222C227265676578225D7D2C7B747970653A22737472696E67227D5D7D2C616C6C4F663A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F736368656D614172726179227D5D7D2C616E794F';
wwv_flow_imp.g_varchar2_table(3327) := '663A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F736368656D614172726179227D5D7D2C6F6E654F663A7B616C6C4F663A5B7B247265663A22232F646566696E6974696F6E732F736368656D614172726179227D5D7D2C6E6F';
wwv_flow_imp.g_varchar2_table(3328) := '743A7B616C6C4F663A5B7B247265663A2223227D5D7D7D2C646570656E64656E636965733A7B6578636C75736976654D6178696D756D3A5B226D6178696D756D225D2C6578636C75736976654D696E696D756D3A5B226D696E696D756D225D7D2C646566';
wwv_flow_imp.g_varchar2_table(3329) := '61756C743A7B7D7D2C22687474703A2F2F6A736F6E2D736368656D612E6F72672F64726166742D30372F736368656D6123223A7B646566696E6974696F6E733A7B736368656D6141727261793A7B747970653A226172726179222C6D696E4974656D733A';
wwv_flow_imp.g_varchar2_table(3330) := '312C6974656D733A7B247265663A2223227D7D2C6E6F6E4E65676174697665496E74656765723A7B747970653A22696E7465676572222C6D696E696D756D3A307D2C6E6F6E4E65676174697665496E746567657244656661756C74303A7B616C6C4F663A';
wwv_flow_imp.g_varchar2_table(3331) := '5B7B247265663A22232F646566696E6974696F6E732F6E6F6E4E65676174697665496E7465676572227D2C7B64656661756C743A307D5D7D2C73696D706C6554797065733A7B656E756D3A5B226172726179222C22626F6F6C65616E222C22696E746567';
wwv_flow_imp.g_varchar2_table(3332) := '6572222C226E756C6C222C226E756D626572222C226F626A656374222C22737472696E67225D7D2C737472696E6741727261793A7B747970653A226172726179222C6974656D733A7B747970653A22737472696E67227D2C756E697175654974656D733A';
wwv_flow_imp.g_varchar2_table(3333) := '21302C64656661756C743A5B5D7D7D2C747970653A5B226F626A656374222C22626F6F6C65616E225D2C70726F706572746965733A7B2469643A7B747970653A22737472696E67222C666F726D61743A227572692D7265666572656E6365227D2C247363';
wwv_flow_imp.g_varchar2_table(3334) := '68656D613A7B747970653A22737472696E67222C666F726D61743A22757269227D2C247265663A7B747970653A22737472696E67222C666F726D61743A227572692D7265666572656E6365227D2C24636F6D6D656E743A7B747970653A22737472696E67';
wwv_flow_imp.g_varchar2_table(3335) := '227D2C7469746C653A7B747970653A22737472696E67227D2C6465736372697074696F6E3A7B747970653A22737472696E67227D2C64656661756C743A21302C726561644F6E6C793A7B747970653A22626F6F6C65616E222C64656661756C743A21317D';
wwv_flow_imp.g_varchar2_table(3336) := '2C6578616D706C65733A7B747970653A226172726179222C6974656D733A21307D2C6D756C7469706C654F663A7B747970653A226E756D626572222C6578636C75736976654D696E696D756D3A307D2C6D6178696D756D3A7B747970653A226E756D6265';
wwv_flow_imp.g_varchar2_table(3337) := '72227D2C6578636C75736976654D6178696D756D3A7B747970653A226E756D626572227D2C6D696E696D756D3A7B747970653A226E756D626572227D2C6578636C75736976654D696E696D756D3A7B747970653A226E756D626572227D2C6D61784C656E';
wwv_flow_imp.g_varchar2_table(3338) := '6774683A7B247265663A22232F646566696E6974696F6E732F6E6F6E4E65676174697665496E7465676572227D2C6D696E4C656E6774683A7B247265663A22232F646566696E6974696F6E732F6E6F6E4E65676174697665496E74656765724465666175';
wwv_flow_imp.g_varchar2_table(3339) := '6C7430227D2C7061747465726E3A7B747970653A22737472696E67222C666F726D61743A227265676578227D2C6164646974696F6E616C4974656D733A7B247265663A2223227D2C6974656D733A7B616E794F663A5B7B247265663A2223227D2C7B2472';
wwv_flow_imp.g_varchar2_table(3340) := '65663A22232F646566696E6974696F6E732F736368656D614172726179227D5D2C64656661756C743A21307D2C6D61784974656D733A7B247265663A22232F646566696E6974696F6E732F6E6F6E4E65676174697665496E7465676572227D2C6D696E49';
wwv_flow_imp.g_varchar2_table(3341) := '74656D733A7B247265663A22232F646566696E6974696F6E732F6E6F6E4E65676174697665496E746567657244656661756C7430227D2C756E697175654974656D733A7B747970653A22626F6F6C65616E222C64656661756C743A21317D2C636F6E7461';
wwv_flow_imp.g_varchar2_table(3342) := '696E733A7B247265663A2223227D2C6D617850726F706572746965733A7B247265663A22232F646566696E6974696F6E732F6E6F6E4E65676174697665496E7465676572227D2C6D696E50726F706572746965733A7B247265663A22232F646566696E69';
wwv_flow_imp.g_varchar2_table(3343) := '74696F6E732F6E6F6E4E65676174697665496E746567657244656661756C7430227D2C72657175697265643A7B247265663A22232F646566696E6974696F6E732F737472696E674172726179227D2C6164646974696F6E616C50726F706572746965733A';
wwv_flow_imp.g_varchar2_table(3344) := '7B247265663A2223227D2C646566696E6974696F6E733A7B747970653A226F626A656374222C6164646974696F6E616C50726F706572746965733A7B247265663A2223227D2C64656661756C743A7B7D7D2C70726F706572746965733A7B747970653A22';
wwv_flow_imp.g_varchar2_table(3345) := '6F626A656374222C6164646974696F6E616C50726F706572746965733A7B247265663A2223227D2C64656661756C743A7B7D7D2C7061747465726E50726F706572746965733A7B747970653A226F626A656374222C6164646974696F6E616C50726F7065';
wwv_flow_imp.g_varchar2_table(3346) := '72746965733A7B247265663A2223227D2C70726F70657274794E616D65733A7B666F726D61743A227265676578227D2C64656661756C743A7B7D7D2C646570656E64656E636965733A7B747970653A226F626A656374222C6164646974696F6E616C5072';
wwv_flow_imp.g_varchar2_table(3347) := '6F706572746965733A7B616E794F663A5B7B247265663A2223227D2C7B247265663A22232F646566696E6974696F6E732F737472696E674172726179227D5D7D7D2C70726F70657274794E616D65733A7B247265663A2223227D2C636F6E73743A21302C';
wwv_flow_imp.g_varchar2_table(3348) := '656E756D3A7B747970653A226172726179222C6974656D733A21302C6D696E4974656D733A312C756E697175654974656D733A21307D2C747970653A7B616E794F663A5B7B247265663A22232F646566696E6974696F6E732F73696D706C655479706573';
wwv_flow_imp.g_varchar2_table(3349) := '227D2C7B747970653A226172726179222C6974656D733A7B247265663A22232F646566696E6974696F6E732F73696D706C655479706573227D2C6D696E4974656D733A312C756E697175654974656D733A21307D5D7D2C666F726D61743A7B747970653A';
wwv_flow_imp.g_varchar2_table(3350) := '22737472696E67227D2C636F6E74656E744D65646961547970653A7B747970653A22737472696E67227D2C636F6E74656E74456E636F64696E673A7B747970653A22737472696E67227D2C69663A7B247265663A2223227D2C7468656E3A7B247265663A';
wwv_flow_imp.g_varchar2_table(3351) := '2223227D2C656C73653A7B247265663A2223227D2C616C6C4F663A7B247265663A22232F646566696E6974696F6E732F736368656D614172726179227D2C616E794F663A7B247265663A22232F646566696E6974696F6E732F736368656D614172726179';
wwv_flow_imp.g_varchar2_table(3352) := '227D2C6F6E654F663A7B247265663A22232F646566696E6974696F6E732F736368656D614172726179227D2C6E6F743A7B247265663A2223227D7D2C64656661756C743A21307D7D7D2C536C3D7B69643A436C2822736368656D612E6A736F6E2E696422';
wwv_flow_imp.g_varchar2_table(3353) := '2C224120756E69717565206964656E74696669657220666F722074686520736368656D612E22292C24736368656D613A436C2822736368656D612E6A736F6E2E24736368656D61222C2254686520736368656D6120746F20766572696679207468697320';
wwv_flow_imp.g_varchar2_table(3354) := '646F63756D656E7420616761696E73742E22292C7469746C653A436C2822736368656D612E6A736F6E2E7469746C65222C2241206465736372697074697665207469746C65206F662074686520656C656D656E742E22292C6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(3355) := '436C2822736368656D612E6A736F6E2E6465736372697074696F6E222C2241206C6F6E67206465736372697074696F6E206F662074686520656C656D656E742E205573656420696E20686F766572206D656E757320616E642073756767657374696F6E73';
wwv_flow_imp.g_varchar2_table(3356) := '2E22292C64656661756C743A436C2822736368656D612E6A736F6E2E64656661756C74222C22412064656661756C742076616C75652E20557365642062792073756767657374696F6E732E22292C6D756C7469706C654F663A436C2822736368656D612E';
wwv_flow_imp.g_varchar2_table(3357) := '6A736F6E2E6D756C7469706C654F66222C2241206E756D62657220746861742073686F756C6420636C65616E6C7920646976696465207468652063757272656E742076616C75652028692E652E2068617665206E6F2072656D61696E646572292E22292C';
wwv_flow_imp.g_varchar2_table(3358) := '6D6178696D756D3A436C2822736368656D612E6A736F6E2E6D6178696D756D222C22546865206D6178696D756D206E756D65726963616C2076616C75652C20696E636C75736976652062792064656661756C742E22292C6578636C75736976654D617869';
wwv_flow_imp.g_varchar2_table(3359) := '6D756D3A436C2822736368656D612E6A736F6E2E6578636C75736976654D6178696D756D222C224D616B657320746865206D6178696D756D2070726F7065727479206578636C75736976652E22292C6D696E696D756D3A436C2822736368656D612E6A73';
wwv_flow_imp.g_varchar2_table(3360) := '6F6E2E6D696E696D756D222C22546865206D696E696D756D206E756D65726963616C2076616C75652C20696E636C75736976652062792064656661756C742E22292C6578636C75736976654D696E696D756D3A436C2822736368656D612E6A736F6E2E65';
wwv_flow_imp.g_varchar2_table(3361) := '78636C75736976654D696E696E756D222C224D616B657320746865206D696E696D756D2070726F7065727479206578636C75736976652E22292C6D61784C656E6774683A436C2822736368656D612E6A736F6E2E6D61784C656E677468222C2254686520';
wwv_flow_imp.g_varchar2_table(3362) := '6D6178696D756D206C656E677468206F66206120737472696E672E22292C6D696E4C656E6774683A436C2822736368656D612E6A736F6E2E6D696E4C656E677468222C22546865206D696E696D756D206C656E677468206F66206120737472696E672E22';
wwv_flow_imp.g_varchar2_table(3363) := '292C7061747465726E3A436C2822736368656D612E6A736F6E2E7061747465726E222C224120726567756C61722065787072657373696F6E20746F206D617463682074686520737472696E6720616761696E73742E204974206973206E6F7420696D706C';
wwv_flow_imp.g_varchar2_table(3364) := '696369746C7920616E63686F7265642E22292C6164646974696F6E616C4974656D733A436C2822736368656D612E6A736F6E2E6164646974696F6E616C4974656D73222C22466F72206172726179732C206F6E6C79207768656E206974656D7320697320';
wwv_flow_imp.g_varchar2_table(3365) := '73657420617320616E2061727261792E204966206974206973206120736368656D612C207468656E207468697320736368656D612076616C696461746573206974656D7320616674657220746865206F6E65732073706563696669656420627920746865';
wwv_flow_imp.g_varchar2_table(3366) := '206974656D732061727261792E2049662069742069732066616C73652C207468656E206164646974696F6E616C206974656D732077696C6C2063617573652076616C69646174696F6E20746F206661696C2E22292C6974656D733A436C2822736368656D';
wwv_flow_imp.g_varchar2_table(3367) := '612E6A736F6E2E6974656D73222C22466F72206172726179732E2043616E20656974686572206265206120736368656D6120746F2076616C696461746520657665727920656C656D656E7420616761696E7374206F7220616E206172726179206F662073';
wwv_flow_imp.g_varchar2_table(3368) := '6368656D617320746F2076616C69646174652065616368206974656D20616761696E737420696E206F72646572202874686520666972737420736368656D612077696C6C2076616C69646174652074686520666972737420656C656D656E742C20746865';
wwv_flow_imp.g_varchar2_table(3369) := '207365636F6E6420736368656D612077696C6C2076616C696461746520746865207365636F6E6420656C656D656E742C20616E6420736F206F6E2E22292C6D61784974656D733A436C2822736368656D612E6A736F6E2E6D61784974656D73222C225468';
wwv_flow_imp.g_varchar2_table(3370) := '65206D6178696D756D206E756D626572206F66206974656D7320746861742063616E20626520696E7369646520616E2061727261792E20496E636C75736976652E22292C6D696E4974656D733A436C2822736368656D612E6A736F6E2E6D696E4974656D';
wwv_flow_imp.g_varchar2_table(3371) := '73222C22546865206D696E696D756D206E756D626572206F66206974656D7320746861742063616E20626520696E7369646520616E2061727261792E20496E636C75736976652E22292C756E697175654974656D733A436C2822736368656D612E6A736F';
wwv_flow_imp.g_varchar2_table(3372) := '6E2E756E697175654974656D73222C22496620616C6C206F6620746865206974656D7320696E20746865206172726179206D75737420626520756E697175652E2044656661756C747320746F2066616C73652E22292C6D617850726F706572746965733A';
wwv_flow_imp.g_varchar2_table(3373) := '436C2822736368656D612E6A736F6E2E6D617850726F70657274696573222C22546865206D6178696D756D206E756D626572206F662070726F7065727469657320616E206F626A6563742063616E20686176652E20496E636C75736976652E22292C6D69';
wwv_flow_imp.g_varchar2_table(3374) := '6E50726F706572746965733A436C2822736368656D612E6A736F6E2E6D696E50726F70657274696573222C22546865206D696E696D756D206E756D626572206F662070726F7065727469657320616E206F626A6563742063616E20686176652E20496E63';
wwv_flow_imp.g_varchar2_table(3375) := '6C75736976652E22292C72657175697265643A436C2822736368656D612E6A736F6E2E7265717569726564222C22416E206172726179206F6620737472696E67732074686174206C6973747320746865206E616D6573206F6620616C6C2070726F706572';
wwv_flow_imp.g_varchar2_table(3376) := '74696573207265717569726564206F6E2074686973206F626A6563742E22292C6164646974696F6E616C50726F706572746965733A436C2822736368656D612E6A736F6E2E6164646974696F6E616C50726F70657274696573222C224569746865722061';
wwv_flow_imp.g_varchar2_table(3377) := '20736368656D61206F72206120626F6F6C65616E2E204966206120736368656D612C207468656E207573656420746F2076616C696461746520616C6C2070726F70657274696573206E6F74206D617463686564206279202770726F706572746965732720';
wwv_flow_imp.g_varchar2_table(3378) := '6F7220277061747465726E50726F70657274696573272E2049662066616C73652C207468656E20616E792070726F70657274696573206E6F74206D617463686564206279206569746865722077696C6C206361757365207468697320736368656D612074';
wwv_flow_imp.g_varchar2_table(3379) := '6F206661696C2E22292C646566696E6974696F6E733A436C2822736368656D612E6A736F6E2E646566696E6974696F6E73222C224E6F74207573656420666F722076616C69646174696F6E2E20506C61636520737562736368656D617320686572652074';
wwv_flow_imp.g_varchar2_table(3380) := '68617420796F75207769736820746F207265666572656E636520696E6C696E65207769746820247265662E22292C70726F706572746965733A436C2822736368656D612E6A736F6E2E70726F70657274696573222C2241206D6170206F662070726F7065';
wwv_flow_imp.g_varchar2_table(3381) := '727479206E616D657320746F20736368656D617320666F7220656163682070726F70657274792E22292C7061747465726E50726F706572746965733A436C2822736368656D612E6A736F6E2E7061747465726E50726F70657274696573222C2241206D61';
wwv_flow_imp.g_varchar2_table(3382) := '70206F6620726567756C61722065787072657373696F6E73206F6E2070726F7065727479206E616D657320746F20736368656D617320666F72206D61746368696E672070726F706572746965732E22292C646570656E64656E636965733A436C28227363';
wwv_flow_imp.g_varchar2_table(3383) := '68656D612E6A736F6E2E646570656E64656E63696573222C2241206D6170206F662070726F7065727479206E616D657320746F2065697468657220616E206172726179206F662070726F7065727479206E616D6573206F72206120736368656D612E2041';
wwv_flow_imp.g_varchar2_table(3384) := '6E206172726179206F662070726F7065727479206E616D6573206D65616E73207468652070726F7065727479206E616D656420696E20746865206B657920646570656E6473206F6E207468652070726F7065727469657320696E20746865206172726179';
wwv_flow_imp.g_varchar2_table(3385) := '206265696E672070726573656E7420696E20746865206F626A65637420696E206F7264657220746F2062652076616C69642E204966207468652076616C7565206973206120736368656D612C207468656E2074686520736368656D61206973206F6E6C79';
wwv_flow_imp.g_varchar2_table(3386) := '206170706C69656420746F20746865206F626A656374206966207468652070726F706572747920696E20746865206B657920657869737473206F6E20746865206F626A6563742E22292C656E756D3A436C2822736368656D612E6A736F6E2E656E756D22';
wwv_flow_imp.g_varchar2_table(3387) := '2C2254686520736574206F66206C69746572616C2076616C7565732074686174206172652076616C69642E22292C747970653A436C2822736368656D612E6A736F6E2E74797065222C22456974686572206120737472696E67206F66206F6E65206F6620';
wwv_flow_imp.g_varchar2_table(3388) := '74686520626173696320736368656D6120747970657320286E756D6265722C20696E74656765722C206E756C6C2C2061727261792C206F626A6563742C20626F6F6C65616E2C20737472696E6729206F7220616E206172726179206F6620737472696E67';
wwv_flow_imp.g_varchar2_table(3389) := '732073706563696679696E67206120737562736574206F662074686F73652074797065732E22292C666F726D61743A436C2822736368656D612E6A736F6E2E666F726D6174222C224465736372696265732074686520666F726D61742065787065637465';
wwv_flow_imp.g_varchar2_table(3390) := '6420666F72207468652076616C75652E22292C616C6C4F663A436C2822736368656D612E6A736F6E2E616C6C4F66222C22416E206172726179206F6620736368656D61732C20616C6C206F66207768696368206D757374206D617463682E22292C616E79';
wwv_flow_imp.g_varchar2_table(3391) := '4F663A436C2822736368656D612E6A736F6E2E616E794F66222C22416E206172726179206F6620736368656D61732C207768657265206174206C65617374206F6E65206D757374206D617463682E22292C6F6E654F663A436C2822736368656D612E6A73';
wwv_flow_imp.g_varchar2_table(3392) := '6F6E2E6F6E654F66222C22416E206172726179206F6620736368656D61732C2065786163746C79206F6E65206F66207768696368206D757374206D617463682E22292C6E6F743A436C2822736368656D612E6A736F6E2E6E6F74222C224120736368656D';
wwv_flow_imp.g_varchar2_table(3393) := '61207768696368206D757374206E6F74206D617463682E22292C2469643A436C2822736368656D612E6A736F6E2E246964222C224120756E69717565206964656E74696669657220666F722074686520736368656D612E22292C247265663A436C282273';
wwv_flow_imp.g_varchar2_table(3394) := '6368656D612E6A736F6E2E24726566222C225265666572656E6365206120646566696E6974696F6E20686F73746564206F6E20616E79206C6F636174696F6E2E22292C24636F6D6D656E743A436C2822736368656D612E6A736F6E2E24636F6D6D656E74';
wwv_flow_imp.g_varchar2_table(3395) := '222C22436F6D6D656E74732066726F6D20736368656D6120617574686F727320746F2072656164657273206F72206D61696E7461696E657273206F662074686520736368656D612E22292C726561644F6E6C793A436C2822736368656D612E6A736F6E2E';
wwv_flow_imp.g_varchar2_table(3396) := '726561644F6E6C79222C22496E646963617465732074686174207468652076616C7565206F662074686520696E7374616E6365206973206D616E61676564206578636C75736976656C7920627920746865206F776E696E6720617574686F726974792E22';
wwv_flow_imp.g_varchar2_table(3397) := '292C6578616D706C65733A436C2822736368656D612E6A736F6E2E6578616D706C6573222C2253616D706C65204A534F4E2076616C756573206173736F6369617465642077697468206120706172746963756C617220736368656D612C20666F72207468';
wwv_flow_imp.g_varchar2_table(3398) := '6520707572706F7365206F6620696C6C757374726174696E672075736167652E22292C636F6E7461696E733A436C2822736368656D612E6A736F6E2E636F6E7461696E73222C27416E20617272617920696E7374616E63652069732076616C6964206167';
wwv_flow_imp.g_varchar2_table(3399) := '61696E73742022636F6E7461696E7322206966206174206C65617374206F6E65206F662069747320656C656D656E74732069732076616C696420616761696E73742074686520676976656E20736368656D612E27292C70726F70657274794E616D65733A';
wwv_flow_imp.g_varchar2_table(3400) := '436C2822736368656D612E6A736F6E2E70726F70657274794E616D6573222C2249662074686520696E7374616E636520697320616E206F626A6563742C2074686973206B6579776F72642076616C6964617465732069662065766572792070726F706572';
wwv_flow_imp.g_varchar2_table(3401) := '7479206E616D6520696E2074686520696E7374616E63652076616C69646174657320616761696E7374207468652070726F766964656420736368656D612E22292C636F6E73743A436C2822736368656D612E6A736F6E2E636F6E7374222C22416E20696E';
wwv_flow_imp.g_varchar2_table(3402) := '7374616E63652076616C696461746573207375636365737366756C6C7920616761696E73742074686973206B6579776F7264206966206974732076616C756520697320657175616C20746F207468652076616C7565206F6620746865206B6579776F7264';
wwv_flow_imp.g_varchar2_table(3403) := '2E22292C636F6E74656E744D65646961547970653A436C2822736368656D612E6A736F6E2E636F6E74656E744D6564696154797065222C2244657363726962657320746865206D656469612074797065206F66206120737472696E672070726F70657274';
wwv_flow_imp.g_varchar2_table(3404) := '792E22292C636F6E74656E74456E636F64696E673A436C2822736368656D612E6A736F6E2E636F6E74656E74456E636F64696E67222C224465736372696265732074686520636F6E74656E7420656E636F64696E67206F66206120737472696E67207072';
wwv_flow_imp.g_varchar2_table(3405) := '6F70657274792E22292C69663A436C2822736368656D612E6A736F6E2E6966222C275468652076616C69646174696F6E206F7574636F6D65206F6620746865202269662220737562736368656D6120636F6E74726F6C73207768696368206F6620746865';
wwv_flow_imp.g_varchar2_table(3406) := '20227468656E22206F722022656C736522206B6579776F72647320617265206576616C75617465642E27292C7468656E3A436C2822736368656D612E6A736F6E2E7468656E222C27546865202269662220737562736368656D6120697320757365642066';
wwv_flow_imp.g_varchar2_table(3407) := '6F722076616C69646174696F6E207768656E20746865202269662220737562736368656D612073756363656564732E27292C656C73653A436C2822736368656D612E6A736F6E2E656C7365222C275468652022656C73652220737562736368656D612069';
wwv_flow_imp.g_varchar2_table(3408) := '73207573656420666F722076616C69646174696F6E207768656E20746865202269662220737562736368656D61206661696C732E27297D3B666F7228796C20696E20776C2E736368656D617329666F7228626C20696E28676C3D776C2E736368656D6173';
wwv_flow_imp.g_varchar2_table(3409) := '5B796C5D292E70726F706572746965732922626F6F6C65616E223D3D747970656F6628706C3D676C2E70726F706572746965735B626C5D29262628706C3D676C2E70726F706572746965735B626C5D3D7B7D292C28766C3D536C5B626C5D293F706C2E64';
wwv_flow_imp.g_varchar2_table(3410) := '65736372697074696F6E3D766C3A636F6E736F6C652E6C6F672822222E636F6E63617428626C2C223A206C6F63616C697A652827736368656D612E6A736F6E2E22292E636F6E63617428626C2C275C272C202222292729293B5F6C3D2828293D3E7B7661';
wwv_flow_imp.g_varchar2_table(3411) := '7220653D7B3437303A653D3E7B66756E6374696F6E20742865297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F72282250617468206D757374206265206120737472696E672E2052656365697665';
wwv_flow_imp.g_varchar2_table(3412) := '6420222B4A534F4E2E737472696E67696679286529297D66756E6374696F6E206E28652C74297B666F7228766172206E2C723D22222C693D302C733D2D312C6F3D302C613D303B613C3D652E6C656E6774683B2B2B61297B696628613C652E6C656E6774';
wwv_flow_imp.g_varchar2_table(3413) := '68296E3D652E63686172436F646541742861293B656C73657B69662834373D3D3D6E29627265616B3B6E3D34377D69662834373D3D3D6E297B696628733D3D3D612D317C7C313D3D3D6F293B656C73652069662873213D3D612D312626323D3D3D6F297B';
wwv_flow_imp.g_varchar2_table(3414) := '696628722E6C656E6774683C327C7C32213D3D697C7C3436213D3D722E63686172436F6465417428722E6C656E6774682D31297C7C3436213D3D722E63686172436F6465417428722E6C656E6774682D322929696628722E6C656E6774683E32297B7661';
wwv_flow_imp.g_varchar2_table(3415) := '72206C3D722E6C617374496E6465784F6628222F22293B6966286C213D3D722E6C656E6774682D31297B2D313D3D3D6C3F28723D22222C693D30293A693D28723D722E736C69636528302C6C29292E6C656E6774682D312D722E6C617374496E6465784F';
wwv_flow_imp.g_varchar2_table(3416) := '6628222F22292C733D612C6F3D303B636F6E74696E75657D7D656C736520696628323D3D3D722E6C656E6774687C7C313D3D3D722E6C656E677468297B723D22222C693D302C733D612C6F3D303B636F6E74696E75657D74262628722E6C656E6774683E';
wwv_flow_imp.g_varchar2_table(3417) := '303F722B3D222F2E2E223A723D222E2E222C693D32297D656C736520722E6C656E6774683E303F722B3D222F222B652E736C69636528732B312C61293A723D652E736C69636528732B312C61292C693D612D732D313B733D612C6F3D307D656C73652034';
wwv_flow_imp.g_varchar2_table(3418) := '363D3D3D6E26262D31213D3D6F3F2B2B6F3A6F3D2D317D72657475726E20727D76617220723D7B7265736F6C76653A66756E6374696F6E28297B666F722876617220652C723D22222C693D21312C733D617267756D656E74732E6C656E6774682D313B73';
wwv_flow_imp.g_varchar2_table(3419) := '3E3D2D31262621693B732D2D297B766172206F3B733E3D303F6F3D617267756D656E74735B735D3A28766F696420303D3D3D65262628653D70726F636573732E6377642829292C6F3D65292C74286F292C30213D3D6F2E6C656E677468262628723D6F2B';
wwv_flow_imp.g_varchar2_table(3420) := '222F222B722C693D34373D3D3D6F2E63686172436F64654174283029297D72657475726E20723D6E28722C2169292C693F722E6C656E6774683E303F222F222B723A222F223A722E6C656E6774683E303F723A222E227D2C6E6F726D616C697A653A6675';
wwv_flow_imp.g_varchar2_table(3421) := '6E6374696F6E2865297B696628742865292C303D3D3D652E6C656E6774682972657475726E222E223B76617220723D34373D3D3D652E63686172436F646541742830292C693D34373D3D3D652E63686172436F6465417428652E6C656E6774682D31293B';
wwv_flow_imp.g_varchar2_table(3422) := '72657475726E2030213D3D28653D6E28652C217229292E6C656E6774687C7C727C7C28653D222E22292C652E6C656E6774683E30262669262628652B3D222F22292C723F222F222B653A657D2C69734162736F6C7574653A66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(3423) := '72657475726E20742865292C652E6C656E6774683E30262634373D3D3D652E63686172436F646541742830297D2C6A6F696E3A66756E6374696F6E28297B696628303D3D3D617267756D656E74732E6C656E6774682972657475726E222E223B666F7228';
wwv_flow_imp.g_varchar2_table(3424) := '76617220652C6E3D303B6E3C617267756D656E74732E6C656E6774683B2B2B6E297B76617220693D617267756D656E74735B6E5D3B742869292C692E6C656E6774683E30262628766F696420303D3D3D653F653D693A652B3D222F222B69297D72657475';
wwv_flow_imp.g_varchar2_table(3425) := '726E20766F696420303D3D3D653F222E223A722E6E6F726D616C697A652865297D2C72656C61746976653A66756E6374696F6E28652C6E297B696628742865292C74286E292C653D3D3D6E2972657475726E22223B69662828653D722E7265736F6C7665';
wwv_flow_imp.g_varchar2_table(3426) := '286529293D3D3D286E3D722E7265736F6C7665286E29292972657475726E22223B666F722876617220693D313B693C652E6C656E677468262634373D3D3D652E63686172436F646541742869293B2B2B69293B666F722876617220733D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(3427) := '682C6F3D732D692C613D313B613C6E2E6C656E677468262634373D3D3D6E2E63686172436F646541742861293B2B2B61293B666F7228766172206C3D6E2E6C656E6774682D612C753D6F3C6C3F6F3A6C2C633D2D312C683D303B683C3D753B2B2B68297B';
wwv_flow_imp.g_varchar2_table(3428) := '696628683D3D3D75297B6966286C3E75297B69662834373D3D3D6E2E63686172436F6465417428612B68292972657475726E206E2E736C69636528612B682B31293B696628303D3D3D682972657475726E206E2E736C69636528612B68297D656C736520';
wwv_flow_imp.g_varchar2_table(3429) := '6F3E7526262834373D3D3D652E63686172436F6465417428692B68293F633D683A303D3D3D68262628633D3029293B627265616B7D76617220643D652E63686172436F6465417428692B68293B69662864213D3D6E2E63686172436F6465417428612B68';
wwv_flow_imp.g_varchar2_table(3430) := '2929627265616B3B34373D3D3D64262628633D68297D76617220663D22223B666F7228683D692B632B313B683C3D733B2B2B682968213D3D7326263437213D3D652E63686172436F646541742868297C7C28303D3D3D662E6C656E6774683F662B3D222E';
wwv_flow_imp.g_varchar2_table(3431) := '2E223A662B3D222F2E2E22293B72657475726E20662E6C656E6774683E303F662B6E2E736C69636528612B63293A28612B3D632C34373D3D3D6E2E63686172436F6465417428612926262B2B612C6E2E736C696365286129297D2C5F6D616B654C6F6E67';
wwv_flow_imp.g_varchar2_table(3432) := '3A66756E6374696F6E2865297B72657475726E20657D2C6469726E616D653A66756E6374696F6E2865297B696628742865292C303D3D3D652E6C656E6774682972657475726E222E223B666F7228766172206E3D652E63686172436F646541742830292C';
wwv_flow_imp.g_varchar2_table(3433) := '723D34373D3D3D6E2C693D2D312C733D21302C6F3D652E6C656E6774682D313B6F3E3D313B2D2D6F2969662834373D3D3D286E3D652E63686172436F64654174286F2929297B6966282173297B693D6F3B627265616B7D7D656C736520733D21313B7265';
wwv_flow_imp.g_varchar2_table(3434) := '7475726E2D313D3D3D693F723F222F223A222E223A722626313D3D3D693F222F2F223A652E736C69636528302C69297D2C626173656E616D653A66756E6374696F6E28652C6E297B696628766F69642030213D3D6E262622737472696E6722213D747970';
wwv_flow_imp.g_varchar2_table(3435) := '656F66206E297468726F77206E657720547970654572726F722827226578742220617267756D656E74206D757374206265206120737472696E6727293B742865293B76617220722C693D302C733D2D312C6F3D21303B696628766F69642030213D3D6E26';
wwv_flow_imp.g_varchar2_table(3436) := '266E2E6C656E6774683E3026266E2E6C656E6774683C3D652E6C656E677468297B6966286E2E6C656E6774683D3D3D652E6C656E67746826266E3D3D3D652972657475726E22223B76617220613D6E2E6C656E6774682D312C6C3D2D313B666F7228723D';
wwv_flow_imp.g_varchar2_table(3437) := '652E6C656E6774682D313B723E3D303B2D2D72297B76617220753D652E63686172436F646541742872293B69662834373D3D3D75297B696628216F297B693D722B313B627265616B7D7D656C73652D313D3D3D6C2626286F3D21312C6C3D722B31292C61';
wwv_flow_imp.g_varchar2_table(3438) := '3E3D30262628753D3D3D6E2E63686172436F646541742861293F2D313D3D2D2D61262628733D72293A28613D2D312C733D6C29297D72657475726E20693D3D3D733F733D6C3A2D313D3D3D73262628733D652E6C656E677468292C652E736C6963652869';
wwv_flow_imp.g_varchar2_table(3439) := '2C73297D666F7228723D652E6C656E6774682D313B723E3D303B2D2D722969662834373D3D3D652E63686172436F64654174287229297B696628216F297B693D722B313B627265616B7D7D656C73652D313D3D3D732626286F3D21312C733D722B31293B';
wwv_flow_imp.g_varchar2_table(3440) := '72657475726E2D313D3D3D733F22223A652E736C69636528692C73297D2C6578746E616D653A66756E6374696F6E2865297B742865293B666F7228766172206E3D2D312C723D302C693D2D312C733D21302C6F3D302C613D652E6C656E6774682D313B61';
wwv_flow_imp.g_varchar2_table(3441) := '3E3D303B2D2D61297B766172206C3D652E63686172436F646541742861293B6966283437213D3D6C292D313D3D3D69262628733D21312C693D612B31292C34363D3D3D6C3F2D313D3D3D6E3F6E3D613A31213D3D6F2626286F3D31293A2D31213D3D6E26';
wwv_flow_imp.g_varchar2_table(3442) := '26286F3D2D31293B656C7365206966282173297B723D612B313B627265616B7D7D72657475726E2D313D3D3D6E7C7C2D313D3D3D697C7C303D3D3D6F7C7C313D3D3D6F26266E3D3D3D692D3126266E3D3D3D722B313F22223A652E736C696365286E2C69';
wwv_flow_imp.g_varchar2_table(3443) := '297D2C666F726D61743A66756E6374696F6E2865297B6966286E756C6C3D3D3D657C7C226F626A65637422213D747970656F662065297468726F77206E657720547970654572726F7228275468652022706174684F626A6563742220617267756D656E74';
wwv_flow_imp.g_varchar2_table(3444) := '206D757374206265206F662074797065204F626A6563742E205265636569766564207479706520272B747970656F662065293B72657475726E206E3D28743D65292E6469727C7C742E726F6F742C723D742E626173657C7C28742E6E616D657C7C222229';
wwv_flow_imp.g_varchar2_table(3445) := '2B28742E6578747C7C2222292C6E3F6E3D3D3D742E726F6F743F6E2B723A6E2B222F222B723A723B76617220742C6E2C727D2C70617273653A66756E6374696F6E2865297B742865293B766172206E3D7B726F6F743A22222C6469723A22222C62617365';
wwv_flow_imp.g_varchar2_table(3446) := '3A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E206E3B76617220722C693D652E63686172436F646541742830292C733D34373D3D3D693B733F286E2E726F6F743D222F222C723D31293A723D30';
wwv_flow_imp.g_varchar2_table(3447) := '3B666F7228766172206F3D2D312C613D302C6C3D2D312C753D21302C633D652E6C656E6774682D312C683D303B633E3D723B2D2D63296966283437213D3D28693D652E63686172436F6465417428632929292D313D3D3D6C262628753D21312C6C3D632B';
wwv_flow_imp.g_varchar2_table(3448) := '31292C34363D3D3D693F2D313D3D3D6F3F6F3D633A31213D3D68262628683D31293A2D31213D3D6F262628683D2D31293B656C7365206966282175297B613D632B313B627265616B7D72657475726E2D313D3D3D6F7C7C2D313D3D3D6C7C7C303D3D3D68';
wwv_flow_imp.g_varchar2_table(3449) := '7C7C313D3D3D6826266F3D3D3D6C2D3126266F3D3D3D612B313F2D31213D3D6C2626286E2E626173653D6E2E6E616D653D303D3D3D612626733F652E736C69636528312C6C293A652E736C69636528612C6C29293A28303D3D3D612626733F286E2E6E61';
wwv_flow_imp.g_varchar2_table(3450) := '6D653D652E736C69636528312C6F292C6E2E626173653D652E736C69636528312C6C29293A286E2E6E616D653D652E736C69636528612C6F292C6E2E626173653D652E736C69636528612C6C29292C6E2E6578743D652E736C696365286F2C6C29292C61';
wwv_flow_imp.g_varchar2_table(3451) := '3E303F6E2E6469723D652E736C69636528302C612D31293A732626286E2E6469723D222F22292C6E7D2C7365703A222F222C64656C696D697465723A223A222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D3B722E706F7369783D722C652E65';
wwv_flow_imp.g_varchar2_table(3452) := '78706F7274733D727D2C3434373A28652C742C6E293D3E7B76617220723B6966286E2E722874292C6E2E6428742C7B5552493A28293D3E672C5574696C733A28293D3E787D292C226F626A656374223D3D747970656F662070726F6365737329723D2277';
wwv_flow_imp.g_varchar2_table(3453) := '696E3332223D3D3D70726F636573732E706C6174666F726D3B656C736520696628226F626A656374223D3D747970656F66206E6176696761746F72297B76617220693D6E6176696761746F722E757365724167656E743B723D692E696E6465784F662822';
wwv_flow_imp.g_varchar2_table(3454) := '57696E646F777322293E3D307D76617220732C6F2C613D28733D66756E6374696F6E28652C74297B72657475726E28733D4F626A6563742E73657450726F746F747970654F667C7C7B5F5F70726F746F5F5F3A5B5D7D696E7374616E63656F6620417272';
wwv_flow_imp.g_varchar2_table(3455) := '6179262666756E6374696F6E28652C74297B652E5F5F70726F746F5F5F3D747D7C7C66756E6374696F6E28652C74297B666F7228766172206E20696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28';
wwv_flow_imp.g_varchar2_table(3456) := '742C6E29262628655B6E5D3D745B6E5D297D2928652C74297D2C66756E6374696F6E28652C74297B6966282266756E6374696F6E22213D747970656F66207426266E756C6C213D3D74297468726F77206E657720547970654572726F722822436C617373';
wwv_flow_imp.g_varchar2_table(3457) := '20657874656E64732076616C756520222B537472696E672874292B22206973206E6F74206120636F6E7374727563746F72206F72206E756C6C22293B66756E6374696F6E206E28297B746869732E636F6E7374727563746F723D657D7328652C74292C65';
wwv_flow_imp.g_varchar2_table(3458) := '2E70726F746F747970653D6E756C6C3D3D3D743F4F626A6563742E6372656174652874293A286E2E70726F746F747970653D742E70726F746F747970652C6E6577206E297D292C6C3D2F5E5C775B5C775C642B2E2D5D2A242F2C753D2F5E5C2F2F2C633D';
wwv_flow_imp.g_varchar2_table(3459) := '2F5E5C2F5C2F2F3B66756E6374696F6E206828652C74297B69662821652E736368656D65262674297468726F77206E6577204572726F7228275B5572694572726F725D3A20536368656D65206973206D697373696E673A207B736368656D653A2022222C';
wwv_flow_imp.g_varchar2_table(3460) := '20617574686F726974793A2022272E636F6E63617428652E617574686F726974792C27222C20706174683A202227292E636F6E63617428652E706174682C27222C2071756572793A202227292E636F6E63617428652E71756572792C27222C2066726167';
wwv_flow_imp.g_varchar2_table(3461) := '6D656E743A202227292E636F6E63617428652E667261676D656E742C27227D2729293B696628652E736368656D652626216C2E7465737428652E736368656D6529297468726F77206E6577204572726F7228225B5572694572726F725D3A20536368656D';
wwv_flow_imp.g_varchar2_table(3462) := '6520636F6E7461696E7320696C6C6567616C20636861726163746572732E22293B696628652E7061746829696628652E617574686F72697479297B69662821752E7465737428652E7061746829297468726F77206E6577204572726F7228275B55726945';
wwv_flow_imp.g_varchar2_table(3463) := '72726F725D3A20496620612055524920636F6E7461696E7320616E20617574686F7269747920636F6D706F6E656E742C207468656E20746865207061746820636F6D706F6E656E74206D7573742065697468657220626520656D707479206F7220626567';
wwv_flow_imp.g_varchar2_table(3464) := '696E2077697468206120736C6173682028222F22292063686172616374657227297D656C736520696628632E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920646F657320';
wwv_flow_imp.g_varchar2_table(3465) := '6E6F7420636F6E7461696E20616E20617574686F7269747920636F6D706F6E656E742C207468656E2074686520706174682063616E6E6F7420626567696E20776974682074776F20736C61736820636861726163746572732028222F2F222927297D7661';
wwv_flow_imp.g_varchar2_table(3466) := '7220643D22222C663D222F222C6D3D2F5E28285B5E3A2F3F235D2B3F293A293F285C2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A29293F2823282E2A29293F2F2C673D66756E6374696F6E28297B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(3467) := '6528652C742C6E2C722C692C73297B766F696420303D3D3D73262628733D2131292C226F626A656374223D3D747970656F6620653F28746869732E736368656D653D652E736368656D657C7C642C746869732E617574686F726974793D652E617574686F';
wwv_flow_imp.g_varchar2_table(3468) := '726974797C7C642C746869732E706174683D652E706174687C7C642C746869732E71756572793D652E71756572797C7C642C746869732E667261676D656E743D652E667261676D656E747C7C64293A28746869732E736368656D653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3469) := '28652C74297B72657475726E20657C7C743F653A2266696C65227D28652C73292C746869732E617574686F726974793D747C7C642C746869732E706174683D66756E6374696F6E28652C74297B7377697463682865297B63617365226874747073223A63';
wwv_flow_imp.g_varchar2_table(3470) := '6173652268747470223A636173652266696C65223A743F745B305D213D3D66262628743D662B74293A743D667D72657475726E20747D28746869732E736368656D652C6E7C7C64292C746869732E71756572793D727C7C642C746869732E667261676D65';
wwv_flow_imp.g_varchar2_table(3471) := '6E743D697C7C642C6828746869732C7329297D72657475726E20652E69735572693D66756E6374696F6E2874297B72657475726E207420696E7374616E63656F6620657C7C212174262622737472696E67223D3D747970656F6620742E617574686F7269';
wwv_flow_imp.g_varchar2_table(3472) := '7479262622737472696E67223D3D747970656F6620742E667261676D656E74262622737472696E67223D3D747970656F6620742E70617468262622737472696E67223D3D747970656F6620742E7175657279262622737472696E67223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(3473) := '20742E736368656D65262622737472696E67223D3D747970656F6620742E66735061746826262266756E6374696F6E223D3D747970656F6620742E7769746826262266756E6374696F6E223D3D747970656F6620742E746F537472696E677D2C4F626A65';
wwv_flow_imp.g_varchar2_table(3474) := '63742E646566696E6550726F706572747928652E70726F746F747970652C22667350617468222C7B6765743A66756E6374696F6E28297B72657475726E204328746869732C2131297D2C656E756D657261626C653A21312C636F6E666967757261626C65';
wwv_flow_imp.g_varchar2_table(3475) := '3A21307D292C652E70726F746F747970652E776974683D66756E6374696F6E2865297B69662821652972657475726E20746869733B76617220743D652E736368656D652C6E3D652E617574686F726974792C723D652E706174682C693D652E7175657279';
wwv_flow_imp.g_varchar2_table(3476) := '2C733D652E667261676D656E743B72657475726E20766F696420303D3D3D743F743D746869732E736368656D653A6E756C6C3D3D3D74262628743D64292C766F696420303D3D3D6E3F6E3D746869732E617574686F726974793A6E756C6C3D3D3D6E2626';
wwv_flow_imp.g_varchar2_table(3477) := '286E3D64292C766F696420303D3D3D723F723D746869732E706174683A6E756C6C3D3D3D72262628723D64292C766F696420303D3D3D693F693D746869732E71756572793A6E756C6C3D3D3D69262628693D64292C766F696420303D3D3D733F733D7468';
wwv_flow_imp.g_varchar2_table(3478) := '69732E667261676D656E743A6E756C6C3D3D3D73262628733D64292C743D3D3D746869732E736368656D6526266E3D3D3D746869732E617574686F726974792626723D3D3D746869732E706174682626693D3D3D746869732E71756572792626733D3D3D';
wwv_flow_imp.g_varchar2_table(3479) := '746869732E667261676D656E743F746869733A6E6577207628742C6E2C722C692C73297D2C652E70617273653D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D2131293B766172206E3D6D2E657865632865293B72657475726E';
wwv_flow_imp.g_varchar2_table(3480) := '206E3F6E65772076286E5B325D7C7C642C45286E5B345D7C7C64292C45286E5B355D7C7C64292C45286E5B375D7C7C64292C45286E5B395D7C7C64292C74293A6E6577207628642C642C642C642C64297D2C652E66696C653D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(3481) := '7B76617220743D643B69662872262628653D652E7265706C616365282F5C5C2F672C6629292C655B305D3D3D3D662626655B315D3D3D3D66297B766172206E3D652E696E6465784F6628662C32293B2D313D3D3D6E3F28743D652E737562737472696E67';
wwv_flow_imp.g_varchar2_table(3482) := '2832292C653D66293A28743D652E737562737472696E6728322C6E292C653D652E737562737472696E67286E297C7C66297D72657475726E206E65772076282266696C65222C742C652C642C64297D2C652E66726F6D3D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(3483) := '617220743D6E6577207628652E736368656D652C652E617574686F726974792C652E706174682C652E71756572792C652E667261676D656E74293B72657475726E206828742C2130292C747D2C652E70726F746F747970652E746F537472696E673D6675';
wwv_flow_imp.g_varchar2_table(3484) := '6E6374696F6E2865297B72657475726E20766F696420303D3D3D65262628653D2131292C7728746869732C65297D2C652E70726F746F747970652E746F4A534F4E3D66756E6374696F6E28297B72657475726E20746869737D2C652E7265766976653D66';
wwv_flow_imp.g_varchar2_table(3485) := '756E6374696F6E2874297B69662874297B6966287420696E7374616E63656F6620652972657475726E20743B766172206E3D6E657720762874293B72657475726E206E2E5F666F726D61747465643D742E65787465726E616C2C6E2E5F6673506174683D';
wwv_flow_imp.g_varchar2_table(3486) := '742E5F7365703D3D3D703F742E6673506174683A6E756C6C2C6E7D72657475726E20747D2C657D28292C703D723F313A766F696420302C763D66756E6374696F6E2865297B66756E6374696F6E207428297B76617220743D6E756C6C213D3D652626652E';
wwv_flow_imp.g_varchar2_table(3487) := '6170706C7928746869732C617267756D656E7473297C7C746869733B72657475726E20742E5F666F726D61747465643D6E756C6C2C742E5F6673506174683D6E756C6C2C747D72657475726E206128742C65292C4F626A6563742E646566696E6550726F';
wwv_flow_imp.g_varchar2_table(3488) := '706572747928742E70726F746F747970652C22667350617468222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E5F6673506174687C7C28746869732E5F6673506174683D4328746869732C213129292C746869732E5F66735061';
wwv_flow_imp.g_varchar2_table(3489) := '74687D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C742E70726F746F747970652E746F537472696E673D66756E6374696F6E2865297B72657475726E20766F696420303D3D3D65262628653D2131292C653F772874';
wwv_flow_imp.g_varchar2_table(3490) := '6869732C2130293A28746869732E5F666F726D61747465647C7C28746869732E5F666F726D61747465643D7728746869732C213129292C746869732E5F666F726D6174746564297D2C742E70726F746F747970652E746F4A534F4E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3491) := '28297B76617220653D7B246D69643A317D3B72657475726E20746869732E5F667350617468262628652E6673506174683D746869732E5F6673506174682C652E5F7365703D70292C746869732E5F666F726D6174746564262628652E65787465726E616C';
wwv_flow_imp.g_varchar2_table(3492) := '3D746869732E5F666F726D6174746564292C746869732E70617468262628652E706174683D746869732E70617468292C746869732E736368656D65262628652E736368656D653D746869732E736368656D65292C746869732E617574686F726974792626';
wwv_flow_imp.g_varchar2_table(3493) := '28652E617574686F726974793D746869732E617574686F72697479292C746869732E7175657279262628652E71756572793D746869732E7175657279292C746869732E667261676D656E74262628652E667261676D656E743D746869732E667261676D65';
wwv_flow_imp.g_varchar2_table(3494) := '6E74292C657D2C747D2867292C623D28286F3D7B7D295B35385D3D22253341222C6F5B34375D3D22253246222C6F5B36335D3D22253346222C6F5B33355D3D22253233222C6F5B39315D3D22253542222C6F5B39335D3D22253544222C6F5B36345D3D22';
wwv_flow_imp.g_varchar2_table(3495) := '253430222C6F5B33335D3D22253231222C6F5B33365D3D22253234222C6F5B33385D3D22253236222C6F5B33395D3D22253237222C6F5B34305D3D22253238222C6F5B34315D3D22253239222C6F5B34325D3D22253241222C6F5B34335D3D2225324222';
wwv_flow_imp.g_varchar2_table(3496) := '2C6F5B34345D3D22253243222C6F5B35395D3D22253342222C6F5B36315D3D22253344222C6F5B33325D3D22253230222C6F293B66756E6374696F6E207928652C74297B666F7228766172206E3D766F696420302C723D2D312C693D303B693C652E6C65';
wwv_flow_imp.g_varchar2_table(3497) := '6E6774683B692B2B297B76617220733D652E63686172436F646541742869293B696628733E3D39372626733C3D3132327C7C733E3D36352626733C3D39307C7C733E3D34382626733C3D35377C7C34353D3D3D737C7C34363D3D3D737C7C39353D3D3D73';
wwv_flow_imp.g_varchar2_table(3498) := '7C7C3132363D3D3D737C7C74262634373D3D3D73292D31213D3D722626286E2B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728722C6929292C723D2D31292C766F69642030213D3D6E2626286E2B3D652E636861724174';
wwv_flow_imp.g_varchar2_table(3499) := '286929293B656C73657B766F696420303D3D3D6E2626286E3D652E73756273747228302C6929293B766172206F3D625B735D3B766F69642030213D3D6F3F282D31213D3D722626286E2B3D656E636F6465555249436F6D706F6E656E7428652E73756273';
wwv_flow_imp.g_varchar2_table(3500) := '7472696E6728722C6929292C723D2D31292C6E2B3D6F293A2D313D3D3D72262628723D69297D7D72657475726E2D31213D3D722626286E2B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E6728722929292C766F6964203021';
wwv_flow_imp.g_varchar2_table(3501) := '3D3D6E3F6E3A657D66756E6374696F6E205F2865297B666F722876617220743D766F696420302C6E3D303B6E3C652E6C656E6774683B6E2B2B297B76617220723D652E63686172436F64654174286E293B33353D3D3D727C7C36333D3D3D723F28766F69';
wwv_flow_imp.g_varchar2_table(3502) := '6420303D3D3D74262628743D652E73756273747228302C6E29292C742B3D625B725D293A766F69642030213D3D74262628742B3D655B6E5D297D72657475726E20766F69642030213D3D743F743A657D66756E6374696F6E204328652C74297B76617220';
wwv_flow_imp.g_varchar2_table(3503) := '6E3B72657475726E206E3D652E617574686F726974792626652E706174682E6C656E6774683E3126262266696C65223D3D3D652E736368656D653F222F2F222E636F6E63617428652E617574686F72697479292E636F6E63617428652E70617468293A34';
wwv_flow_imp.g_varchar2_table(3504) := '373D3D3D652E706174682E63686172436F64654174283029262628652E706174682E63686172436F646541742831293E3D36352626652E706174682E63686172436F646541742831293C3D39307C7C652E706174682E63686172436F646541742831293E';
wwv_flow_imp.g_varchar2_table(3505) := '3D39372626652E706174682E63686172436F646541742831293C3D31323229262635383D3D3D652E706174682E63686172436F646541742832293F743F652E706174682E7375627374722831293A652E706174685B315D2E746F4C6F7765724361736528';
wwv_flow_imp.g_varchar2_table(3506) := '292B652E706174682E7375627374722832293A652E706174682C722626286E3D6E2E7265706C616365282F5C2F2F672C225C5C2229292C6E7D66756E6374696F6E207728652C74297B766172206E3D743F5F3A792C723D22222C693D652E736368656D65';
wwv_flow_imp.g_varchar2_table(3507) := '2C733D652E617574686F726974792C6F3D652E706174682C613D652E71756572792C6C3D652E667261676D656E743B69662869262628722B3D692C722B3D223A22292C28737C7C2266696C65223D3D3D6929262628722B3D662C722B3D66292C73297B76';
wwv_flow_imp.g_varchar2_table(3508) := '617220753D732E696E6465784F6628224022293B6966282D31213D3D75297B76617220633D732E73756273747228302C75293B733D732E73756273747228752B31292C2D313D3D3D28753D632E696E6465784F6628223A2229293F722B3D6E28632C2131';
wwv_flow_imp.g_varchar2_table(3509) := '293A28722B3D6E28632E73756273747228302C75292C2131292C722B3D223A222C722B3D6E28632E73756273747228752B31292C213129292C722B3D2240227D2D313D3D3D28753D28733D732E746F4C6F776572436173652829292E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(3510) := '223A2229293F722B3D6E28732C2131293A28722B3D6E28732E73756273747228302C75292C2131292C722B3D732E737562737472287529297D6966286F297B6966286F2E6C656E6774683E3D33262634373D3D3D6F2E63686172436F6465417428302926';
wwv_flow_imp.g_varchar2_table(3511) := '2635383D3D3D6F2E63686172436F646541742832292928683D6F2E63686172436F64654174283129293E3D36352626683C3D39302626286F3D222F222E636F6E63617428537472696E672E66726F6D43686172436F646528682B3332292C223A22292E63';
wwv_flow_imp.g_varchar2_table(3512) := '6F6E636174286F2E73756273747228332929293B656C7365206966286F2E6C656E6774683E3D32262635383D3D3D6F2E63686172436F64654174283129297B76617220683B28683D6F2E63686172436F64654174283029293E3D36352626683C3D393026';
wwv_flow_imp.g_varchar2_table(3513) := '26286F3D22222E636F6E63617428537472696E672E66726F6D43686172436F646528682B3332292C223A22292E636F6E636174286F2E73756273747228322929297D722B3D6E286F2C2130297D72657475726E2061262628722B3D223F222C722B3D6E28';
wwv_flow_imp.g_varchar2_table(3514) := '612C213129292C6C262628722B3D2223222C722B3D743F6C3A79286C2C213129292C727D66756E6374696F6E20532865297B7472797B72657475726E206465636F6465555249436F6D706F6E656E742865297D63617463682874297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(3515) := '2E6C656E6774683E333F652E73756273747228302C33292B5328652E737562737472283329293A657D7D766172204C3D2F28255B302D39412D5A612D7A5D5B302D39412D5A612D7A5D292B2F673B66756E6374696F6E20452865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(3516) := '2E6D61746368284C293F652E7265706C616365284C2C2866756E6374696F6E2865297B72657475726E20532865297D29293A657D76617220782C4E2C413D6E28343730292C6B3D66756E6374696F6E28652C742C6E297B6966286E7C7C323D3D3D617267';
wwv_flow_imp.g_varchar2_table(3517) := '756D656E74732E6C656E67746829666F722876617220722C693D302C733D742E6C656E6774683B693C733B692B2B29217226266920696E20747C7C28727C7C28723D41727261792E70726F746F747970652E736C6963652E63616C6C28742C302C692929';
wwv_flow_imp.g_varchar2_table(3518) := '2C725B695D3D745B695D293B72657475726E20652E636F6E63617428727C7C41727261792E70726F746F747970652E736C6963652E63616C6C287429297D2C523D412E706F7369787C7C413B284E3D787C7C28783D7B7D29292E6A6F696E506174683D66';
wwv_flow_imp.g_varchar2_table(3519) := '756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D313B6E3C617267756D656E74732E6C656E6774683B6E2B2B29745B6E2D315D3D617267756D656E74735B6E5D3B72657475726E20652E77697468287B706174683A522E6A6F696E2E6170';
wwv_flow_imp.g_varchar2_table(3520) := '706C7928522C6B285B652E706174685D2C742C213129297D297D2C4E2E7265736F6C7665506174683D66756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D313B6E3C617267756D656E74732E6C656E6774683B6E2B2B29745B6E2D315D3D';
wwv_flow_imp.g_varchar2_table(3521) := '617267756D656E74735B6E5D3B76617220723D652E706174687C7C222F223B72657475726E20652E77697468287B706174683A522E7265736F6C76652E6170706C7928522C6B285B725D2C742C213129297D297D2C4E2E6469726E616D653D66756E6374';
wwv_flow_imp.g_varchar2_table(3522) := '696F6E2865297B76617220743D522E6469726E616D6528652E70617468293B72657475726E20313D3D3D742E6C656E677468262634363D3D3D742E63686172436F646541742830293F653A652E77697468287B706174683A747D297D2C4E2E626173656E';
wwv_flow_imp.g_varchar2_table(3523) := '616D653D66756E6374696F6E2865297B72657475726E20522E626173656E616D6528652E70617468297D2C4E2E6578746E616D653D66756E6374696F6E2865297B72657475726E20522E6578746E616D6528652E70617468297D7D7D2C743D7B7D3B6675';
wwv_flow_imp.g_varchar2_table(3524) := '6E6374696F6E206E2872297B696628745B725D2972657475726E20745B725D2E6578706F7274733B76617220693D745B725D3D7B6578706F7274733A7B7D7D3B72657475726E20655B725D28692C692E6578706F7274732C6E292C692E6578706F727473';
wwv_flow_imp.g_varchar2_table(3525) := '7D72657475726E206E2E643D28652C74293D3E7B666F7228766172207220696E2074296E2E6F28742C72292626216E2E6F28652C722926264F626A6563742E646566696E6550726F706572747928652C722C7B656E756D657261626C653A21302C676574';
wwv_flow_imp.g_varchar2_table(3526) := '3A745B725D7D297D2C6E2E6F3D28652C74293D3E4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C74292C6E2E723D653D3E7B22756E646566696E656422213D747970656F662053796D626F6C26265379';
wwv_flow_imp.g_varchar2_table(3527) := '6D626F6C2E746F537472696E6754616726264F626A6563742E646566696E6550726F706572747928652C53796D626F6C2E746F537472696E675461672C7B76616C75653A224D6F64756C65227D292C4F626A6563742E646566696E6550726F7065727479';
wwv_flow_imp.g_varchar2_table(3528) := '28652C225F5F65734D6F64756C65222C7B76616C75653A21307D297D2C6E28343437297D2928293B7661727B5552493A4C6C2C5574696C733A456C7D3D5F6C3B66756E6374696F6E20786C28652C74297B69662822737472696E6722213D747970656F66';
wwv_flow_imp.g_varchar2_table(3529) := '2065297468726F77206E657720547970654572726F7228224578706563746564206120737472696E6722293B666F7228766172206E2C723D537472696E672865292C693D22222C733D21217426262121742E657874656E6465642C6F3D21217426262121';
wwv_flow_imp.g_varchar2_table(3530) := '742E676C6F62737461722C613D21312C6C3D74262622737472696E67223D3D747970656F6620742E666C6167733F742E666C6167733A22222C753D302C633D722E6C656E6774683B753C633B752B2B29737769746368286E3D725B755D297B6361736522';
wwv_flow_imp.g_varchar2_table(3531) := '2F223A636173652224223A63617365225E223A63617365222B223A63617365222E223A636173652228223A636173652229223A63617365223D223A636173652221223A63617365227C223A692B3D225C5C222B6E3B627265616B3B63617365223F223A69';
wwv_flow_imp.g_varchar2_table(3532) := '662873297B692B3D222E223B627265616B7D63617365225B223A63617365225D223A69662873297B692B3D6E3B627265616B7D63617365227B223A69662873297B613D21302C692B3D2228223B627265616B7D63617365227D223A69662873297B613D21';
wwv_flow_imp.g_varchar2_table(3533) := '312C692B3D2229223B627265616B7D63617365222C223A69662861297B692B3D227C223B627265616B7D692B3D225C5C222B6E3B627265616B3B63617365222A223A666F722876617220683D725B752D315D2C643D313B222A223D3D3D725B752B315D3B';
wwv_flow_imp.g_varchar2_table(3534) := '29642B2B2C752B2B3B76617220663D725B752B315D3B6F3F2128643E31297C7C222F22213D3D682626766F69642030213D3D682626227B22213D3D682626222C22213D3D687C7C222F22213D3D662626766F69642030213D3D662626222C22213D3D6626';
wwv_flow_imp.g_varchar2_table(3535) := '26227D22213D3D663F692B3D22285B5E2F5D2A29223A28222F223D3D3D663F752B2B3A222F223D3D3D682626692E656E64735769746828225C5C2F2229262628693D692E73756273747228302C692E6C656E6774682D3229292C692B3D2228283F3A5B5E';
wwv_flow_imp.g_varchar2_table(3536) := '2F5D2A283F3A2F7C2429292A2922293A692B3D222E2A223B627265616B3B64656661756C743A692B3D6E7D72657475726E206C26267E6C2E696E6465784F6628226722297C7C28693D225E222B692B222422292C6E65772052656745787028692C6C297D';
wwv_flow_imp.g_varchar2_table(3537) := '766172204E6C2C416C3D786128292C6B6C3D66756E6374696F6E28297B66756E6374696F6E206528652C74297B746869732E676C6F6257726170706572733D5B5D3B7472797B666F7228766172206E3D302C723D653B6E3C722E6C656E6774683B6E2B2B';
wwv_flow_imp.g_varchar2_table(3538) := '297B76617220693D725B6E5D2C733D222122213D3D695B305D3B737C7C28693D692E737562737472696E67283129292C692E6C656E6774683E30262628222F223D3D3D695B305D262628693D692E737562737472696E67283129292C746869732E676C6F';
wwv_flow_imp.g_varchar2_table(3539) := '6257726170706572732E70757368287B7265676578703A786C28222A2A2F222B692C7B657874656E6465643A21302C676C6F62737461723A21307D292C696E636C7564653A737D29297D746869732E757269733D747D63617463682865297B746869732E';
wwv_flow_imp.g_varchar2_table(3540) := '676C6F6257726170706572732E6C656E6774683D302C746869732E757269733D5B5D7D7D72657475726E20652E70726F746F747970652E6D6174636865735061747465726E3D66756E6374696F6E2865297B666F722876617220743D21312C6E3D302C72';
wwv_flow_imp.g_varchar2_table(3541) := '3D746869732E676C6F6257726170706572733B6E3C722E6C656E6774683B6E2B2B297B76617220693D725B6E5D2C733D692E7265676578702C6F3D692E696E636C7564653B732E74657374286529262628743D6F297D72657475726E20747D2C652E7072';
wwv_flow_imp.g_varchar2_table(3542) := '6F746F747970652E676574555249733D66756E6374696F6E28297B72657475726E20746869732E757269737D2C657D28292C526C3D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E297B746869732E736572766963653D652C746869';
wwv_flow_imp.g_varchar2_table(3543) := '732E7572693D742C746869732E646570656E64656E636965733D6E6577205365742C746869732E616E63686F72733D766F696420302C6E262628746869732E756E7265736F6C766564536368656D613D746869732E736572766963652E70726F6D697365';
wwv_flow_imp.g_varchar2_table(3544) := '2E7265736F6C7665286E657720546C286E2929297D72657475726E20652E70726F746F747970652E676574556E7265736F6C766564536368656D613D66756E6374696F6E28297B72657475726E20746869732E756E7265736F6C766564536368656D617C';
wwv_flow_imp.g_varchar2_table(3545) := '7C28746869732E756E7265736F6C766564536368656D613D746869732E736572766963652E6C6F6164536368656D6128746869732E75726929292C746869732E756E7265736F6C766564536368656D617D2C652E70726F746F747970652E676574526573';
wwv_flow_imp.g_varchar2_table(3546) := '6F6C766564536368656D613D66756E6374696F6E28297B76617220653D746869733B72657475726E20746869732E7265736F6C766564536368656D617C7C28746869732E7265736F6C766564536368656D613D746869732E676574556E7265736F6C7665';
wwv_flow_imp.g_varchar2_table(3547) := '64536368656D6128292E7468656E282866756E6374696F6E2874297B72657475726E20652E736572766963652E7265736F6C7665536368656D61436F6E74656E7428742C65297D2929292C746869732E7265736F6C766564536368656D617D2C652E7072';
wwv_flow_imp.g_varchar2_table(3548) := '6F746F747970652E636C656172536368656D613D66756E6374696F6E28297B76617220653D2121746869732E756E7265736F6C766564536368656D613B72657475726E20746869732E7265736F6C766564536368656D613D766F696420302C746869732E';
wwv_flow_imp.g_varchar2_table(3549) := '756E7265736F6C766564536368656D613D766F696420302C746869732E646570656E64656E636965732E636C65617228292C746869732E616E63686F72733D766F696420302C657D2C657D28292C546C3D66756E6374696F6E28297B72657475726E2066';
wwv_flow_imp.g_varchar2_table(3550) := '756E6374696F6E28652C74297B766F696420303D3D3D74262628743D5B5D292C746869732E736368656D613D652C746869732E6572726F72733D747D7D28292C4D6C3D66756E6374696F6E28297B66756E6374696F6E206528652C74297B766F69642030';
wwv_flow_imp.g_varchar2_table(3551) := '3D3D3D74262628743D5B5D292C746869732E736368656D613D652C746869732E6572726F72733D747D72657475726E20652E70726F746F747970652E67657453656374696F6E3D66756E6374696F6E2865297B76617220743D746869732E676574536563';
wwv_flow_imp.g_varchar2_table(3552) := '74696F6E52656375727369766528652C746869732E736368656D61293B696628742972657475726E204B612874297D2C652E70726F746F747970652E67657453656374696F6E5265637572736976653D66756E6374696F6E28652C74297B69662821747C';
wwv_flow_imp.g_varchar2_table(3553) := '7C22626F6F6C65616E223D3D747970656F6620747C7C303D3D3D652E6C656E6774682972657475726E20743B766172206E3D652E736869667428293B696628742E70726F70657274696573262628742E70726F706572746965735B6E5D2C312929726574';
wwv_flow_imp.g_varchar2_table(3554) := '75726E20746869732E67657453656374696F6E52656375727369766528652C742E70726F706572746965735B6E5D293B696628742E7061747465726E50726F7065727469657329666F722876617220723D302C693D4F626A6563742E6B65797328742E70';
wwv_flow_imp.g_varchar2_table(3555) := '61747465726E50726F70657274696573293B723C692E6C656E6774683B722B2B297B76617220733D695B725D2C6F3D636F2873293B6966286E756C6C3D3D6F3F766F696420303A6F2E74657374286E292972657475726E20746869732E67657453656374';
wwv_flow_imp.g_varchar2_table(3556) := '696F6E52656375727369766528652C742E7061747465726E50726F706572746965735B735D297D656C73657B696628226F626A656374223D3D747970656F6620742E6164646974696F6E616C50726F706572746965732972657475726E20746869732E67';
wwv_flow_imp.g_varchar2_table(3557) := '657453656374696F6E52656375727369766528652C742E6164646974696F6E616C50726F70657274696573293B6966286E2E6D6174636828225B302D395D2B22292969662841727261792E6973417272617928742E6974656D7329297B76617220613D70';
wwv_flow_imp.g_varchar2_table(3558) := '61727365496E74286E2C3130293B6966282169734E614E2861292626742E6974656D735B615D2972657475726E20746869732E67657453656374696F6E52656375727369766528652C742E6974656D735B615D297D656C736520696628742E6974656D73';
wwv_flow_imp.g_varchar2_table(3559) := '2972657475726E20746869732E67657453656374696F6E52656375727369766528652C742E6974656D73297D7D2C657D28292C4F6C3D66756E6374696F6E28297B66756E6374696F6E206528652C742C6E297B746869732E636F6E746578745365727669';
wwv_flow_imp.g_varchar2_table(3560) := '63653D742C746869732E72657175657374536572766963653D652C746869732E70726F6D697365436F6E7374727563746F723D6E7C7C50726F6D6973652C746869732E63616C6C4F6E446973706F73653D5B5D2C746869732E636F6E747269627574696F';
wwv_flow_imp.g_varchar2_table(3561) := '6E536368656D61733D7B7D2C746869732E636F6E747269627574696F6E4173736F63696174696F6E733D5B5D2C746869732E736368656D6173427949643D7B7D2C746869732E66696C655061747465726E4173736F63696174696F6E733D5B5D2C746869';
wwv_flow_imp.g_varchar2_table(3562) := '732E72656769737465726564536368656D61734964733D7B7D7D72657475726E20652E70726F746F747970652E67657452656769737465726564536368656D614964733D66756E6374696F6E2865297B72657475726E204F626A6563742E6B6579732874';
wwv_flow_imp.g_varchar2_table(3563) := '6869732E72656769737465726564536368656D6173496473292E66696C746572282866756E6374696F6E2874297B766172206E3D4C6C2E70617273652874292E736368656D653B72657475726E22736368656D617365727669636522213D3D6E26262821';
wwv_flow_imp.g_varchar2_table(3564) := '657C7C65286E29297D29297D2C4F626A6563742E646566696E6550726F706572747928652E70726F746F747970652C2270726F6D697365222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E70726F6D697365436F6E7374727563';
wwv_flow_imp.g_varchar2_table(3565) := '746F727D2C656E756D657261626C653A21312C636F6E666967757261626C653A21307D292C652E70726F746F747970652E646973706F73653D66756E6374696F6E28297B666F72283B746869732E63616C6C4F6E446973706F73652E6C656E6774683E30';
wwv_flow_imp.g_varchar2_table(3566) := '3B29746869732E63616C6C4F6E446973706F73652E706F70282928297D2C652E70726F746F747970652E6F6E5265736F757263654368616E67653D66756E6374696F6E2865297B76617220743D746869733B746869732E636163686564536368656D6146';
wwv_flow_imp.g_varchar2_table(3567) := '6F725265736F757263653D766F696420303B666F7228766172206E3D21312C723D5B653D506C2865295D2C693D4F626A6563742E6B65797328746869732E736368656D617342794964292E6D6170282866756E6374696F6E2865297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(3568) := '2E736368656D6173427949645B655D7D29293B722E6C656E6774683B29666F722876617220733D722E706F7028292C6F3D303B6F3C692E6C656E6774683B6F2B2B297B76617220613D695B6F5D3B61262628612E7572693D3D3D737C7C612E646570656E';
wwv_flow_imp.g_varchar2_table(3569) := '64656E636965732E68617328732929262628612E757269213D3D732626722E7075736828612E757269292C612E636C656172536368656D6128292626286E3D2130292C695B6F5D3D766F69642030297D72657475726E206E7D2C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(3570) := '652E736574536368656D61436F6E747269627574696F6E733D66756E6374696F6E2865297B696628652E736368656D6173297B76617220743D652E736368656D61733B666F7228766172206E20696E2074297B76617220723D506C286E293B746869732E';
wwv_flow_imp.g_varchar2_table(3571) := '636F6E747269627574696F6E536368656D61735B725D3D746869732E616464536368656D6148616E646C6528722C745B6E5D297D7D69662841727261792E6973417272617928652E736368656D614173736F63696174696F6E732929666F722876617220';
wwv_flow_imp.g_varchar2_table(3572) := '693D302C733D652E736368656D614173736F63696174696F6E733B693C732E6C656E6774683B692B2B297B766172206F3D735B695D2C613D6F2E757269732E6D617028506C292C6C3D746869732E61646446696C655061747465726E4173736F63696174';
wwv_flow_imp.g_varchar2_table(3573) := '696F6E286F2E7061747465726E2C61293B746869732E636F6E747269627574696F6E4173736F63696174696F6E732E70757368286C297D7D2C652E70726F746F747970652E616464536368656D6148616E646C653D66756E6374696F6E28652C74297B76';
wwv_flow_imp.g_varchar2_table(3574) := '6172206E3D6E657720526C28746869732C652C74293B72657475726E20746869732E736368656D6173427949645B655D3D6E2C6E7D2C652E70726F746F747970652E6765744F72416464536368656D6148616E646C653D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(3575) := '7B72657475726E20746869732E736368656D6173427949645B655D7C7C746869732E616464536368656D6148616E646C6528652C74297D2C652E70726F746F747970652E61646446696C655061747465726E4173736F63696174696F6E3D66756E637469';
wwv_flow_imp.g_varchar2_table(3576) := '6F6E28652C74297B766172206E3D6E6577206B6C28652C74293B72657475726E20746869732E66696C655061747465726E4173736F63696174696F6E732E70757368286E292C6E7D2C652E70726F746F747970652E726567697374657245787465726E61';
wwv_flow_imp.g_varchar2_table(3577) := '6C536368656D613D66756E6374696F6E28652C742C6E297B76617220723D506C2865293B72657475726E20746869732E72656769737465726564536368656D61734964735B725D3D21302C746869732E636163686564536368656D61466F725265736F75';
wwv_flow_imp.g_varchar2_table(3578) := '7263653D766F696420302C742626746869732E61646446696C655061747465726E4173736F63696174696F6E28742C5B725D292C6E3F746869732E616464536368656D6148616E646C6528722C6E293A746869732E6765744F72416464536368656D6148';
wwv_flow_imp.g_varchar2_table(3579) := '616E646C652872297D2C652E70726F746F747970652E636C65617245787465726E616C536368656D61733D66756E6374696F6E28297B666F7228766172206520696E20746869732E736368656D6173427949643D7B7D2C746869732E66696C6550617474';
wwv_flow_imp.g_varchar2_table(3580) := '65726E4173736F63696174696F6E733D5B5D2C746869732E72656769737465726564536368656D61734964733D7B7D2C746869732E636163686564536368656D61466F725265736F757263653D766F696420302C746869732E636F6E747269627574696F';
wwv_flow_imp.g_varchar2_table(3581) := '6E536368656D617329746869732E736368656D6173427949645B655D3D746869732E636F6E747269627574696F6E536368656D61735B655D2C746869732E72656769737465726564536368656D61734964735B655D3D21303B666F722876617220743D30';
wwv_flow_imp.g_varchar2_table(3582) := '2C6E3D746869732E636F6E747269627574696F6E4173736F63696174696F6E733B743C6E2E6C656E6774683B742B2B297B76617220723D6E5B745D3B746869732E66696C655061747465726E4173736F63696174696F6E732E707573682872297D7D2C65';
wwv_flow_imp.g_varchar2_table(3583) := '2E70726F746F747970652E6765745265736F6C766564536368656D613D66756E6374696F6E2865297B76617220743D506C2865292C6E3D746869732E736368656D6173427949645B745D3B72657475726E206E3F6E2E6765745265736F6C766564536368';
wwv_flow_imp.g_varchar2_table(3584) := '656D6128293A746869732E70726F6D6973652E7265736F6C766528766F69642030297D2C652E70726F746F747970652E6C6F6164536368656D613D66756E6374696F6E2865297B69662821746869732E7265717565737453657276696365297B76617220';
wwv_flow_imp.g_varchar2_table(3585) := '743D416C28226A736F6E2E736368656D612E6E6F7265717565737473657276696365222C22556E61626C6520746F206C6F616420736368656D612066726F6D20277B307D272E204E6F20736368656D612072657175657374207365727669636520617661';
wwv_flow_imp.g_varchar2_table(3586) := '696C61626C65222C466C286529293B72657475726E20746869732E70726F6D6973652E7265736F6C7665286E657720546C287B7D2C5B745D29297D72657475726E20746869732E72657175657374536572766963652865292E7468656E282866756E6374';
wwv_flow_imp.g_varchar2_table(3587) := '696F6E2874297B6966282174297B766172206E3D416C28226A736F6E2E736368656D612E6E6F636F6E74656E74222C22556E61626C6520746F206C6F616420736368656D612066726F6D20277B307D273A204E6F20636F6E74656E742E222C466C286529';
wwv_flow_imp.g_varchar2_table(3588) := '293B72657475726E206E657720546C287B7D2C5B6E5D297D76617220722C693D5B5D3B723D746F28742C69293B76617220733D692E6C656E6774683F5B416C28226A736F6E2E736368656D612E696E76616C6964466F726D6174222C22556E61626C6520';
wwv_flow_imp.g_varchar2_table(3589) := '746F20706172736520636F6E74656E742066726F6D20277B307D273A205061727365206572726F72206174206F6666736574207B317D2E222C466C2865292C695B305D2E6F6666736574295D3A5B5D3B72657475726E206E657720546C28722C73297D29';
wwv_flow_imp.g_varchar2_table(3590) := '2C2866756E6374696F6E2874297B766172206E3D742E746F537472696E6728292C723D742E746F537472696E6728292E73706C697428224572726F723A2022293B72657475726E20722E6C656E6774683E312626286E3D725B315D292C756F286E2C222E';
wwv_flow_imp.g_varchar2_table(3591) := '22292626286E3D6E2E73756273747228302C6E2E6C656E6774682D3129292C6E657720546C287B7D2C5B416C28226A736F6E2E736368656D612E6E6F636F6E74656E74222C22556E61626C6520746F206C6F616420736368656D612066726F6D20277B30';
wwv_flow_imp.g_varchar2_table(3592) := '7D273A207B317D2E222C466C2865292C6E295D297D29297D2C652E70726F746F747970652E7265736F6C7665536368656D61436F6E74656E743D66756E6374696F6E28652C74297B766172206E3D746869732C723D652E6572726F72732E736C69636528';
wwv_flow_imp.g_varchar2_table(3593) := '30292C693D652E736368656D613B696628692E24736368656D61297B76617220733D506C28692E24736368656D61293B69662822687474703A2F2F6A736F6E2D736368656D612E6F72672F64726166742D30332F736368656D61223D3D3D732972657475';
wwv_flow_imp.g_varchar2_table(3594) := '726E20746869732E70726F6D6973652E7265736F6C7665286E6577204D6C287B7D2C5B416C28226A736F6E2E736368656D612E647261667430332E6E6F74737570706F72746564222C2244726166742D303320736368656D617320617265206E6F742073';
wwv_flow_imp.g_varchar2_table(3595) := '7570706F727465642E22295D29293B2268747470733A2F2F6A736F6E2D736368656D612E6F72672F64726166742F323031392D30392F736368656D61223D3D3D733F722E7075736828416C28226A736F6E2E736368656D612E6472616674323031393039';
wwv_flow_imp.g_varchar2_table(3596) := '2E6E6F74737570706F72746564222C22447261667420323031392D303920736368656D617320617265206E6F74207965742066756C6C7920737570706F727465642E2229293A2268747470733A2F2F6A736F6E2D736368656D612E6F72672F6472616674';
wwv_flow_imp.g_varchar2_table(3597) := '2F323032302D31322F736368656D61223D3D3D732626722E7075736828416C28226A736F6E2E736368656D612E64726166743230323031322E6E6F74737570706F72746564222C22447261667420323032302D313220736368656D617320617265206E6F';
wwv_flow_imp.g_varchar2_table(3598) := '74207965742066756C6C7920737570706F727465642E2229297D766172206F3D746869732E636F6E74657874536572766963652C613D66756E6374696F6E28652C742C6E2C69297B76617220732C6F2C612C6C3B766F696420303D3D3D697C7C303D3D3D';
wwv_flow_imp.g_varchar2_table(3599) := '692E6C656E6774683F733D743A222F223D3D3D692E6368617241742830293F733D66756E6374696F6E28652C74297B743D6465636F6465555249436F6D706F6E656E742874293B766172206E3D653B72657475726E222F223D3D3D745B305D262628743D';
wwv_flow_imp.g_varchar2_table(3600) := '742E737562737472696E67283129292C742E73706C697428222F22292E736F6D65282866756E6374696F6E2865297B72657475726E20653D652E7265706C616365282F7E312F672C222F22292E7265706C616365282F7E302F672C227E22292C21286E3D';
wwv_flow_imp.g_varchar2_table(3601) := '6E5B655D297D29292C6E7D28742C69293A286F3D742C6C3D692C28613D6E292E616E63686F72737C7C28612E616E63686F72733D63286F29292C733D612E616E63686F72732E676574286C29292C733F66756E6374696F6E28652C74297B666F72287661';
wwv_flow_imp.g_varchar2_table(3602) := '72206E20696E207429742E6861734F776E50726F7065727479286E29262621652E6861734F776E50726F7065727479286E29262622696422213D3D6E26262224696422213D3D6E262628655B6E5D3D745B6E5D297D28652C73293A722E7075736828416C';
wwv_flow_imp.g_varchar2_table(3603) := '28226A736F6E2E736368656D612E696E76616C69646964222C222472656620277B307D2720696E20277B317D272063616E206E6F74206265207265736F6C7665642E222C692C6E2E75726929297D2C6C3D66756E6374696F6E28652C742C692C73297B6F';
wwv_flow_imp.g_varchar2_table(3604) := '2626212F5E5B412D5A612D7A5D5B412D5A612D7A302D392B5C2D2E2B5D2A3A5C2F5C2F2E2A2F2E74657374287429262628743D6F2E7265736F6C766552656C61746976655061746828742C732E75726929292C743D506C2874293B766172206C3D6E2E67';
wwv_flow_imp.g_varchar2_table(3605) := '65744F72416464536368656D6148616E646C652874293B72657475726E206C2E676574556E7265736F6C766564536368656D6128292E7468656E282866756E6374696F6E286E297B696628732E646570656E64656E636965732E6164642874292C6E2E65';
wwv_flow_imp.g_varchar2_table(3606) := '72726F72732E6C656E677468297B766172206F3D693F742B2223222B693A743B722E7075736828416C28226A736F6E2E736368656D612E70726F626C656D6C6F6164696E67726566222C2250726F626C656D73206C6F6164696E67207265666572656E63';
wwv_flow_imp.g_varchar2_table(3607) := '6520277B307D273A207B317D222C6F2C6E2E6572726F72735B305D29297D72657475726E206128652C6E2E736368656D612C6C2C69292C7528652C6E2E736368656D612C6C297D29297D2C753D66756E6374696F6E28652C742C72297B76617220693D5B';
wwv_flow_imp.g_varchar2_table(3608) := '5D3B72657475726E206E2E74726176657273654E6F64657328652C2866756E6374696F6E2865297B666F7228766172206E3D6E6577205365743B652E247265663B297B76617220733D652E247265662C6F3D732E73706C6974282223222C32293B696628';
wwv_flow_imp.g_varchar2_table(3609) := '64656C65746520652E247265662C6F5B305D2E6C656E6774683E302972657475726E20766F696420692E70757368286C28652C6F5B305D2C6F5B315D2C7229293B696628216E2E686173287329297B76617220753D6F5B315D3B6128652C742C722C7529';
wwv_flow_imp.g_varchar2_table(3610) := '2C6E2E6164642873297D7D7D29292C6E2E70726F6D6973652E616C6C2869297D2C633D66756E6374696F6E2865297B76617220743D6E6577204D61703B72657475726E206E2E74726176657273654E6F64657328652C2866756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(3611) := '6172206E3D652E2469647C7C652E69643B69662822737472696E67223D3D747970656F66206E26262223223D3D3D6E2E636861724174283029297B76617220693D6E2E737562737472696E672831293B742E6861732869293F722E7075736828416C2822';
wwv_flow_imp.g_varchar2_table(3612) := '6A736F6E2E736368656D612E6475706C69636174656964222C224475706C6963617465206964206465636C61726174696F6E3A20277B307D27222C6E29293A742E73657428692C65297D7D29292C747D3B72657475726E207528692C692C74292E746865';
wwv_flow_imp.g_varchar2_table(3613) := '6E282866756E6374696F6E2865297B72657475726E206E6577204D6C28692C72297D29297D2C652E70726F746F747970652E74726176657273654E6F6465733D66756E6374696F6E28652C74297B69662821657C7C226F626A65637422213D747970656F';
wwv_flow_imp.g_varchar2_table(3614) := '6620652972657475726E2050726F6D6973652E7265736F6C7665286E756C6C293B666F7228766172206E3D6E6577205365742C723D66756E6374696F6E28297B666F722876617220653D5B5D2C743D303B743C617267756D656E74732E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(3615) := '742B2B29655B745D3D617267756D656E74735B745D3B666F7228766172206E3D302C723D653B6E3C722E6C656E6774683B6E2B2B297B76617220693D725B6E5D3B226F626A656374223D3D747970656F66206926266F2E707573682869297D7D2C693D66';
wwv_flow_imp.g_varchar2_table(3616) := '756E6374696F6E28297B666F722876617220653D5B5D2C743D303B743C617267756D656E74732E6C656E6774683B742B2B29655B745D3D617267756D656E74735B745D3B666F7228766172206E3D302C723D653B6E3C722E6C656E6774683B6E2B2B297B';
wwv_flow_imp.g_varchar2_table(3617) := '76617220693D725B6E5D3B696628226F626A656374223D3D747970656F66206929666F7228766172207320696E2069297B76617220613D695B735D3B226F626A656374223D3D747970656F66206126266F2E707573682861297D7D7D2C733D66756E6374';
wwv_flow_imp.g_varchar2_table(3618) := '696F6E28297B666F722876617220653D5B5D2C743D303B743C617267756D656E74732E6C656E6774683B742B2B29655B745D3D617267756D656E74735B745D3B666F7228766172206E3D302C723D653B6E3C722E6C656E6774683B6E2B2B297B76617220';
wwv_flow_imp.g_varchar2_table(3619) := '693D725B6E5D3B69662841727261792E6973417272617928692929666F722876617220733D302C613D693B733C612E6C656E6774683B732B2B297B766172206C3D615B735D3B226F626A656374223D3D747970656F66206C26266F2E70757368286C297D';
wwv_flow_imp.g_varchar2_table(3620) := '7D7D2C6F3D5B655D2C613D6F2E706F7028293B613B296E2E6861732861297C7C286E2E6164642861292C742861292C7228612E6974656D732C612E6164646974696F6E616C4974656D732C612E6164646974696F6E616C50726F706572746965732C612E';
wwv_flow_imp.g_varchar2_table(3621) := '6E6F742C612E636F6E7461696E732C612E70726F70657274794E616D65732C612E69662C612E7468656E2C612E656C7365292C6928612E646566696E6974696F6E732C612E70726F706572746965732C612E7061747465726E50726F706572746965732C';
wwv_flow_imp.g_varchar2_table(3622) := '612E646570656E64656E63696573292C7328612E616E794F662C612E616C6C4F662C612E6F6E654F662C612E6974656D7329292C613D6F2E706F7028297D2C652E70726F746F747970652E676574536368656D6146726F6D50726F70657274793D66756E';
wwv_flow_imp.g_varchar2_table(3623) := '6374696F6E28652C74297B766172206E2C723B696628226F626A656374223D3D3D286E756C6C3D3D3D286E3D742E726F6F74297C7C766F696420303D3D3D6E3F766F696420303A6E2E747970652929666F722876617220693D302C733D742E726F6F742E';
wwv_flow_imp.g_varchar2_table(3624) := '70726F706572746965733B693C732E6C656E6774683B692B2B297B766172206F3D735B695D3B6966282224736368656D61223D3D3D6F2E6B65794E6F64652E76616C7565262622737472696E67223D3D3D286E756C6C3D3D3D28723D6F2E76616C75654E';
wwv_flow_imp.g_varchar2_table(3625) := '6F6465297C7C766F696420303D3D3D723F766F696420303A722E7479706529297B76617220613D6F2E76616C75654E6F64652E76616C75653B72657475726E20746869732E636F6E74657874536572766963652626212F5E5C775B5C775C642B2E2D5D2A';
wwv_flow_imp.g_varchar2_table(3626) := '3A2F2E74657374286129262628613D746869732E636F6E74657874536572766963652E7265736F6C766552656C61746976655061746828612C6529292C617D7D7D2C652E70726F746F747970652E6765744173736F636961746564536368656D61733D66';
wwv_flow_imp.g_varchar2_table(3627) := '756E6374696F6E2865297B666F722876617220743D4F626A6563742E637265617465286E756C6C292C6E3D5B5D2C723D66756E6374696F6E2865297B7472797B72657475726E204C6C2E70617273652865292E77697468287B667261676D656E743A6E75';
wwv_flow_imp.g_varchar2_table(3628) := '6C6C2C71756572793A6E756C6C7D292E746F537472696E67282130297D63617463682874297B72657475726E20657D7D2865292C693D302C733D746869732E66696C655061747465726E4173736F63696174696F6E733B693C732E6C656E6774683B692B';
wwv_flow_imp.g_varchar2_table(3629) := '2B297B766172206F3D735B695D3B6966286F2E6D6174636865735061747465726E28722929666F722876617220613D302C6C3D6F2E6765745552497328293B613C6C2E6C656E6774683B612B2B297B76617220753D6C5B615D3B745B755D7C7C286E2E70';
wwv_flow_imp.g_varchar2_table(3630) := '7573682875292C745B755D3D2130297D7D72657475726E206E7D2C652E70726F746F747970652E676574536368656D6155524973466F725265736F757263653D66756E6374696F6E28652C74297B766172206E3D742626746869732E676574536368656D';
wwv_flow_imp.g_varchar2_table(3631) := '6146726F6D50726F706572747928652C74293B72657475726E206E3F5B6E5D3A746869732E6765744173736F636961746564536368656D61732865297D2C652E70726F746F747970652E676574536368656D61466F725265736F757263653D66756E6374';
wwv_flow_imp.g_varchar2_table(3632) := '696F6E28652C74297B69662874297B766172206E3D746869732E676574536368656D6146726F6D50726F706572747928652C74293B6966286E297B76617220723D506C286E293B72657475726E20746869732E6765744F72416464536368656D6148616E';
wwv_flow_imp.g_varchar2_table(3633) := '646C652872292E6765745265736F6C766564536368656D6128297D7D696628746869732E636163686564536368656D61466F725265736F757263652626746869732E636163686564536368656D61466F725265736F757263652E7265736F757263653D3D';
wwv_flow_imp.g_varchar2_table(3634) := '3D652972657475726E20746869732E636163686564536368656D61466F725265736F757263652E7265736F6C766564536368656D613B76617220693D746869732E6765744173736F636961746564536368656D61732865292C733D692E6C656E6774683E';
wwv_flow_imp.g_varchar2_table(3635) := '303F746869732E637265617465436F6D62696E6564536368656D6128652C69292E6765745265736F6C766564536368656D6128293A746869732E70726F6D6973652E7265736F6C766528766F69642030293B72657475726E20746869732E636163686564';
wwv_flow_imp.g_varchar2_table(3636) := '536368656D61466F725265736F757263653D7B7265736F757263653A652C7265736F6C766564536368656D613A737D2C737D2C652E70726F746F747970652E637265617465436F6D62696E6564536368656D613D66756E6374696F6E28652C74297B6966';
wwv_flow_imp.g_varchar2_table(3637) := '28313D3D3D742E6C656E6774682972657475726E20746869732E6765744F72416464536368656D6148616E646C6528745B305D293B766172206E3D22736368656D61736572766963653A2F2F636F6D62696E6564536368656D612F222B656E636F646555';
wwv_flow_imp.g_varchar2_table(3638) := '5249436F6D706F6E656E742865292C723D7B616C6C4F663A742E6D6170282866756E6374696F6E2865297B72657475726E7B247265663A657D7D29297D3B72657475726E20746869732E616464536368656D6148616E646C65286E2C72297D2C652E7072';
wwv_flow_imp.g_varchar2_table(3639) := '6F746F747970652E6765744D61746368696E67536368656D61733D66756E6374696F6E28652C742C6E297B6966286E297B76617220723D6E2E69647C7C22736368656D61736572766963653A2F2F756E7469746C65642F6D61746368696E67536368656D';
wwv_flow_imp.g_varchar2_table(3640) := '61732F222B496C2B2B3B72657475726E20746869732E616464536368656D6148616E646C6528722C6E292E6765745265736F6C766564536368656D6128292E7468656E282866756E6374696F6E2865297B72657475726E20742E6765744D61746368696E';
wwv_flow_imp.g_varchar2_table(3641) := '67536368656D617328652E736368656D61292E66696C746572282866756E6374696F6E2865297B72657475726E21652E696E7665727465647D29297D29297D72657475726E20746869732E676574536368656D61466F725265736F7572636528652E7572';
wwv_flow_imp.g_varchar2_table(3642) := '692C74292E7468656E282866756E6374696F6E2865297B72657475726E20653F742E6765744D61746368696E67536368656D617328652E736368656D61292E66696C746572282866756E6374696F6E2865297B72657475726E21652E696E766572746564';
wwv_flow_imp.g_varchar2_table(3643) := '7D29293A5B5D7D29297D2C657D28292C496C3D303B66756E6374696F6E20506C2865297B7472797B72657475726E204C6C2E70617273652865292E746F537472696E67282130297D63617463682874297B72657475726E20657D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(3644) := '466C2865297B7472797B76617220743D4C6C2E70617273652865293B6966282266696C65223D3D3D742E736368656D652972657475726E20742E6673506174687D63617463682865297B7D72657475726E20657D66756E6374696F6E20566C28652C7429';
wwv_flow_imp.g_varchar2_table(3645) := '7B766172206E3D5B5D2C723D5B5D2C693D5B5D2C733D2D312C6F3D656F28652E6765745465787428292C2131292C613D6F2E7363616E28293B66756E6374696F6E206C2865297B6E2E707573682865292C722E7075736828692E6C656E677468297D666F';
wwv_flow_imp.g_varchar2_table(3646) := '72283B3137213D3D613B297B7377697463682861297B6361736520313A6361736520333A76617220753D7B73746172744C696E653A643D652E706F736974696F6E4174286F2E676574546F6B656E4F66667365742829292E6C696E652C656E644C696E65';
wwv_flow_imp.g_varchar2_table(3647) := '3A642C6B696E643A313D3D3D613F226F626A656374223A226172726179227D3B692E707573682875293B627265616B3B6361736520323A6361736520343A76617220633D323D3D3D613F226F626A656374223A226172726179223B696628692E6C656E67';
wwv_flow_imp.g_varchar2_table(3648) := '74683E302626695B692E6C656E6774682D315D2E6B696E643D3D3D63297B753D692E706F7028293B76617220683D652E706F736974696F6E4174286F2E676574546F6B656E4F66667365742829292E6C696E653B752626683E752E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(3649) := '2B31262673213D3D752E73746172744C696E65262628752E656E644C696E653D682D312C6C2875292C733D752E73746172744C696E65297D627265616B3B636173652031333A76617220643D652E706F736974696F6E4174286F2E676574546F6B656E4F';
wwv_flow_imp.g_varchar2_table(3650) := '66667365742829292E6C696E652C663D652E706F736974696F6E4174286F2E676574546F6B656E4F666673657428292B6F2E676574546F6B656E4C656E6774682829292E6C696E653B313D3D3D6F2E676574546F6B656E4572726F7228292626642B313C';
wwv_flow_imp.g_varchar2_table(3651) := '652E6C696E65436F756E743F6F2E736574506F736974696F6E28652E6F666673657441742875732E63726561746528642B312C302929293A643C662626286C287B73746172744C696E653A642C656E644C696E653A662C6B696E643A53732E436F6D6D65';
wwv_flow_imp.g_varchar2_table(3652) := '6E747D292C733D64293B627265616B3B636173652031323A766172206D3D652E6765745465787428292E737562737472286F2E676574546F6B656E4F666673657428292C6F2E676574546F6B656E4C656E6774682829292E6D61746368282F5E5C2F5C2F';
wwv_flow_imp.g_varchar2_table(3653) := '5C732A2328726567696F6E5C62297C28656E64726567696F6E5C62292F293B6966286D29696628683D652E706F736974696F6E4174286F2E676574546F6B656E4F66667365742829292E6C696E652C6D5B315D29753D7B73746172744C696E653A682C65';
wwv_flow_imp.g_varchar2_table(3654) := '6E644C696E653A682C6B696E643A53732E526567696F6E7D2C692E707573682875293B656C73657B666F722876617220673D692E6C656E6774682D313B673E3D302626695B675D2E6B696E64213D3D53732E526567696F6E3B29672D2D3B673E3D302626';
wwv_flow_imp.g_varchar2_table(3655) := '28753D695B675D2C692E6C656E6774683D672C683E752E73746172744C696E65262673213D3D752E73746172744C696E65262628752E656E644C696E653D682C6C2875292C733D752E73746172744C696E6529297D7D613D6F2E7363616E28297D766172';
wwv_flow_imp.g_varchar2_table(3656) := '20703D742626742E72616E67654C696D69743B696628226E756D62657222213D747970656F6620707C7C6E2E6C656E6774683C3D702972657475726E206E3B742626742E6F6E52616E67654C696D697445786365656465642626742E6F6E52616E67654C';
wwv_flow_imp.g_varchar2_table(3657) := '696D6974457863656564656428652E757269293B666F722876617220763D5B5D2C623D302C793D723B623C792E6C656E6774683B622B2B29284C3D795B625D293C3330262628765B4C5D3D28765B4C5D7C7C30292B31293B766172205F3D302C433D303B';
wwv_flow_imp.g_varchar2_table(3658) := '666F7228673D303B673C762E6C656E6774683B672B2B297B76617220773D765B675D3B69662877297B696628772B5F3E70297B433D673B627265616B7D5F2B3D777D7D76617220533D5B5D3B666F7228673D303B673C6E2E6C656E6774683B672B2B297B';
wwv_flow_imp.g_varchar2_table(3659) := '766172204C3B226E756D626572223D3D747970656F66284C3D725B675D292626284C3C437C7C4C3D3D3D4326265F2B2B3C70292626532E70757368286E5B675D297D72657475726E20537D66756E6374696F6E20446C28652C742C6E297B66756E637469';
wwv_flow_imp.g_varchar2_table(3660) := '6F6E207228742C6E297B72657475726E2068732E63726561746528652E706F736974696F6E41742874292C652E706F736974696F6E4174286E29297D76617220693D656F28652E6765745465787428292C2130293B66756E6374696F6E207328652C7429';
wwv_flow_imp.g_varchar2_table(3661) := '7B72657475726E20692E736574506F736974696F6E2865292C692E7363616E28293D3D3D743F692E676574546F6B656E4F666673657428292B692E676574546F6B656E4C656E67746828293A2D317D72657475726E20742E6D6170282866756E6374696F';
wwv_flow_imp.g_varchar2_table(3662) := '6E2874297B666F722876617220693D652E6F666673657441742874292C6F3D6E2E6765744E6F646546726F6D4F666673657428692C2130292C613D5B5D3B6F3B297B737769746368286F2E74797065297B6361736522737472696E67223A63617365226F';
wwv_flow_imp.g_varchar2_table(3663) := '626A656374223A63617365226172726179223A766172206C3D6F2E6F66667365742B312C753D6F2E6F66667365742B6F2E6C656E6774682D313B6C3C752626693E3D6C2626693C3D752626612E707573682872286C2C7529292C612E707573682872286F';
wwv_flow_imp.g_varchar2_table(3664) := '2E6F66667365742C6F2E6F66667365742B6F2E6C656E67746829293B627265616B3B63617365226E756D626572223A6361736522626F6F6C65616E223A63617365226E756C6C223A636173652270726F7065727479223A612E707573682872286F2E6F66';
wwv_flow_imp.g_varchar2_table(3665) := '667365742C6F2E6F66667365742B6F2E6C656E67746829297D6966282270726F7065727479223D3D3D6F2E747970657C7C6F2E706172656E742626226172726179223D3D3D6F2E706172656E742E74797065297B76617220633D73286F2E6F6666736574';
wwv_flow_imp.g_varchar2_table(3666) := '2B6F2E6C656E6774682C35293B2D31213D3D632626612E707573682872286F2E6F66667365742C6329297D6F3D6F2E706172656E747D666F722876617220683D766F696420302C643D612E6C656E6774682D313B643E3D303B642D2D29683D6F612E6372';
wwv_flow_imp.g_varchar2_table(3667) := '6561746528615B645D2C68293B72657475726E20687C7C28683D6F612E6372656174652868732E63726561746528742C742929292C687D29297D66756E6374696F6E20716C28652C74297B766172206E3D5B5D3B72657475726E20742E76697369742828';
wwv_flow_imp.g_varchar2_table(3668) := '66756E6374696F6E2872297B76617220693B6966282270726F7065727479223D3D3D722E7479706526262224726566223D3D3D722E6B65794E6F64652E76616C7565262622737472696E67223D3D3D286E756C6C3D3D3D28693D722E76616C75654E6F64';
wwv_flow_imp.g_varchar2_table(3669) := '65297C7C766F696420303D3D3D693F766F696420303A692E7479706529297B76617220733D722E76616C75654E6F64652E76616C75652C6F3D66756E6374696F6E28652C74297B766172206E3D66756E6374696F6E2865297B72657475726E2223223D3D';
wwv_flow_imp.g_varchar2_table(3670) := '3D653F5B5D3A222322213D3D655B305D7C7C222F22213D3D655B315D3F6E756C6C3A652E737562737472696E672832292E73706C6974282F5C2F2F292E6D617028556C297D2874293B72657475726E206E3F6A6C286E2C652E726F6F74293A6E756C6C7D';
wwv_flow_imp.g_varchar2_table(3671) := '28742C73293B6966286F297B76617220613D652E706F736974696F6E4174286F2E6F6666736574293B6E2E70757368287B7461726765743A22222E636F6E63617428652E7572692C222322292E636F6E63617428612E6C696E652B312C222C22292E636F';
wwv_flow_imp.g_varchar2_table(3672) := '6E63617428612E6368617261637465722B31292C72616E67653A4B6C28652C722E76616C75654E6F6465297D297D7D72657475726E21307D29292C50726F6D6973652E7265736F6C7665286E297D66756E6374696F6E204B6C28652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(3673) := '6E2068732E63726561746528652E706F736974696F6E417428742E6F66667365742B31292C652E706F736974696F6E417428742E6F66667365742B742E6C656E6774682D3129297D66756E6374696F6E206A6C28652C74297B6966282174297265747572';
wwv_flow_imp.g_varchar2_table(3674) := '6E206E756C6C3B696628303D3D3D652E6C656E6774682972657475726E20743B766172206E3D652E736869667428293B696628742626226F626A656374223D3D3D742E74797065297B76617220723D742E70726F706572746965732E66696E6428286675';
wwv_flow_imp.g_varchar2_table(3675) := '6E6374696F6E2865297B72657475726E20652E6B65794E6F64652E76616C75653D3D3D6E7D29293B72657475726E20723F6A6C28652C722E76616C75654E6F6465293A6E756C6C7D696628742626226172726179223D3D3D742E7479706526266E2E6D61';
wwv_flow_imp.g_varchar2_table(3676) := '746368282F5E28307C5B312D395D5B302D395D2A29242F29297B76617220693D4E756D6265722E7061727365496E74286E292C733D742E6974656D735B695D3B72657475726E20733F6A6C28652C73293A6E756C6C7D72657475726E206E756C6C7D6675';
wwv_flow_imp.g_varchar2_table(3677) := '6E6374696F6E20556C2865297B72657475726E20652E7265706C616365282F7E312F672C222F22292E7265706C616365282F7E302F672C227E22297D66756E6374696F6E20426C2865297B76617220743D652E70726F6D697365436F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(3678) := '727C7C50726F6D6973652C6E3D6E6577204F6C28652E736368656D6152657175657374536572766963652C652E776F726B7370616365436F6E746578742C74293B6E2E736574536368656D61436F6E747269627574696F6E7328776C293B76617220723D';
wwv_flow_imp.g_varchar2_table(3679) := '6E6577205161286E2C652E636F6E747269627574696F6E732C742C652E636C69656E744361706162696C6974696573292C693D6E6577205A61286E2C652E636F6E747269627574696F6E732C74292C733D6E657720666C286E292C6F3D6E657720746C28';
wwv_flow_imp.g_varchar2_table(3680) := '6E2C74293B72657475726E7B636F6E6669677572653A66756E6374696F6E2865297B6E2E636C65617245787465726E616C536368656D617328292C652E736368656D61732626652E736368656D61732E666F7245616368282866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(3681) := '7B6E2E726567697374657245787465726E616C536368656D6128652E7572692C652E66696C654D617463682C652E736368656D61297D29292C6F2E636F6E6669677572652865297D2C7265736574536368656D613A66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(3682) := '75726E206E2E6F6E5265736F757263654368616E67652865297D2C646F56616C69646174696F6E3A6F2E646F56616C69646174696F6E2E62696E64286F292C6765744C616E67756167655374617475733A6F2E6765744C616E6775616765537461747573';
wwv_flow_imp.g_varchar2_table(3683) := '2E62696E64286F292C70617273654A534F4E446F63756D656E743A66756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B766172206E3D5B5D2C723D2D312C693D652E6765745465787428292C733D656F28692C2131292C6F';
wwv_flow_imp.g_varchar2_table(3684) := '3D742626742E636F6C6C656374436F6D6D656E74733F5B5D3A766F696420303B66756E6374696F6E206128297B666F72283B3B297B76617220743D732E7363616E28293B737769746368286328292C74297B636173652031323A636173652031333A4172';
wwv_flow_imp.g_varchar2_table(3685) := '7261792E69734172726179286F2926266F2E707573682868732E63726561746528652E706F736974696F6E417428732E676574546F6B656E4F66667365742829292C652E706F736974696F6E417428732E676574546F6B656E4F666673657428292B732E';
wwv_flow_imp.g_varchar2_table(3686) := '676574546F6B656E4C656E67746828292929293B627265616B3B636173652031353A636173652031343A627265616B3B64656661756C743A72657475726E20747D7D7D66756E6374696F6E206C28742C692C732C6F2C61297B696628766F696420303D3D';
wwv_flow_imp.g_varchar2_table(3687) := '3D61262628613D6B732E4572726F72292C303D3D3D6E2E6C656E6774687C7C73213D3D72297B766172206C3D68732E63726561746528652E706F736974696F6E41742873292C652E706F736974696F6E4174286F29293B6E2E707573682849732E637265';
wwv_flow_imp.g_varchar2_table(3688) := '617465286C2C742C612C692C652E6C616E6775616765496429292C723D737D7D66756E6374696F6E207528652C742C6E2C722C6F297B766F696420303D3D3D6E2626286E3D766F69642030292C766F696420303D3D3D72262628723D5B5D292C766F6964';
wwv_flow_imp.g_varchar2_table(3689) := '20303D3D3D6F2626286F3D5B5D293B76617220753D732E676574546F6B656E4F666673657428292C633D732E676574546F6B656E4F666673657428292B732E676574546F6B656E4C656E67746828293B696628753D3D3D632626753E30297B666F722875';
wwv_flow_imp.g_varchar2_table(3690) := '2D2D3B753E3026262F5C732F2E7465737428692E636861724174287529293B29752D2D3B633D752B317D6966286C28652C742C752C63292C6E262668286E2C2131292C722E6C656E6774682B6F2E6C656E6774683E3029666F722876617220643D732E67';
wwv_flow_imp.g_varchar2_table(3691) := '6574546F6B656E28293B3137213D3D643B297B6966282D31213D3D722E696E6465784F66286429297B6128293B627265616B7D6966282D31213D3D6F2E696E6465784F6628642929627265616B3B643D6128297D72657475726E206E7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(3692) := '6E206328297B73776974636828732E676574546F6B656E4572726F722829297B6361736520343A72657475726E20752852612822496E76616C6964556E69636F6465222C22496E76616C696420756E69636F64652073657175656E636520696E20737472';
wwv_flow_imp.g_varchar2_table(3693) := '696E672E22292C76612E496E76616C6964556E69636F6465292C21303B6361736520353A72657475726E20752852612822496E76616C6964457363617065436861726163746572222C22496E76616C696420657363617065206368617261637465722069';
wwv_flow_imp.g_varchar2_table(3694) := '6E20737472696E672E22292C76612E496E76616C6964457363617065436861726163746572292C21303B6361736520333A72657475726E20752852612822556E6578706563746564456E644F664E756D626572222C22556E657870656374656420656E64';
wwv_flow_imp.g_varchar2_table(3695) := '206F66206E756D6265722E22292C76612E556E6578706563746564456E644F664E756D626572292C21303B6361736520313A72657475726E20752852612822556E6578706563746564456E644F66436F6D6D656E74222C22556E65787065637465642065';
wwv_flow_imp.g_varchar2_table(3696) := '6E64206F6620636F6D6D656E742E22292C76612E556E6578706563746564456E644F66436F6D6D656E74292C21303B6361736520323A72657475726E20752852612822556E6578706563746564456E644F66537472696E67222C22556E65787065637465';
wwv_flow_imp.g_varchar2_table(3697) := '6420656E64206F6620737472696E672E22292C76612E556E6578706563746564456E644F66537472696E67292C21303B6361736520363A72657475726E20752852612822496E76616C6964436861726163746572222C22496E76616C6964206368617261';
wwv_flow_imp.g_varchar2_table(3698) := '637465727320696E20737472696E672E20436F6E74726F6C2063686172616374657273206D75737420626520657363617065642E22292C76612E496E76616C6964436861726163746572292C21307D72657475726E21317D66756E6374696F6E20682865';
wwv_flow_imp.g_varchar2_table(3699) := '2C74297B72657475726E20652E6C656E6774683D732E676574546F6B656E4F666673657428292B732E676574546F6B656E4C656E67746828292D652E6F66667365742C7426266128292C657D76617220643D6E657720566128766F696420302C302C3029';
wwv_flow_imp.g_varchar2_table(3700) := '3B66756E6374696F6E206628742C6E297B76617220723D6E657720446128742C732E676574546F6B656E4F666673657428292C64292C693D6D2872293B6966282169297B6966283136213D3D732E676574546F6B656E28292972657475726E3B75285261';
wwv_flow_imp.g_varchar2_table(3701) := '2822446F75626C6551756F7465734578706563746564222C2250726F7065727479206B657973206D75737420626520646F75626C6571756F74656422292C76612E556E646566696E6564293B766172206F3D6E657720566128722C732E676574546F6B65';
wwv_flow_imp.g_varchar2_table(3702) := '6E4F666673657428292C732E676574546F6B656E4C656E6774682829293B6F2E76616C75653D732E676574546F6B656E56616C756528292C693D6F2C6128297D722E6B65794E6F64653D693B76617220633D6E5B692E76616C75655D3B696628633F286C';
wwv_flow_imp.g_varchar2_table(3703) := '28526128224475706C69636174654B65795761726E696E67222C224475706C6963617465206F626A656374206B657922292C76612E4475706C69636174654B65792C722E6B65794E6F64652E6F66667365742C722E6B65794E6F64652E6F66667365742B';
wwv_flow_imp.g_varchar2_table(3704) := '722E6B65794E6F64652E6C656E6774682C6B732E5761726E696E67292C226F626A656374223D3D747970656F66206326266C28526128224475706C69636174654B65795761726E696E67222C224475706C6963617465206F626A656374206B657922292C';
wwv_flow_imp.g_varchar2_table(3705) := '76612E4475706C69636174654B65792C632E6B65794E6F64652E6F66667365742C632E6B65794E6F64652E6F66667365742B632E6B65794E6F64652E6C656E6774682C6B732E5761726E696E67292C6E5B692E76616C75655D3D2130293A6E5B692E7661';
wwv_flow_imp.g_varchar2_table(3706) := '6C75655D3D722C363D3D3D732E676574546F6B656E282929722E636F6C6F6E4F66667365743D732E676574546F6B656E4F666673657428292C6128293B656C736520696628752852612822436F6C6F6E4578706563746564222C22436F6C6F6E20657870';
wwv_flow_imp.g_varchar2_table(3707) := '656374656422292C76612E436F6C6F6E4578706563746564292C31303D3D3D732E676574546F6B656E28292626652E706F736974696F6E417428692E6F66667365742B692E6C656E677468292E6C696E653C652E706F736974696F6E417428732E676574';
wwv_flow_imp.g_varchar2_table(3708) := '546F6B656E4F66667365742829292E6C696E652972657475726E20722E6C656E6774683D692E6C656E6774682C723B76617220683D672872293B72657475726E20683F28722E76616C75654E6F64653D682C722E6C656E6774683D682E6F66667365742B';
wwv_flow_imp.g_varchar2_table(3709) := '682E6C656E6774682D722E6F66667365742C72293A75285261282256616C75654578706563746564222C2256616C756520657870656374656422292C76612E56616C756545787065637465642C722C5B5D2C5B322C355D297D66756E6374696F6E206D28';
wwv_flow_imp.g_varchar2_table(3710) := '65297B69662831303D3D3D732E676574546F6B656E2829297B76617220743D6E657720566128652C732E676574546F6B656E4F66667365742829293B72657475726E20742E76616C75653D732E676574546F6B656E56616C756528292C6828742C213029';
wwv_flow_imp.g_varchar2_table(3711) := '7D7D66756E6374696F6E20672865297B72657475726E2066756E6374696F6E2865297B696628333D3D3D732E676574546F6B656E2829297B76617220743D6E657720506128652C732E676574546F6B656E4F66667365742829293B6128293B666F722876';
wwv_flow_imp.g_varchar2_table(3712) := '6172206E3D21313B34213D3D732E676574546F6B656E282926263137213D3D732E676574546F6B656E28293B297B696628353D3D3D732E676574546F6B656E2829297B6E7C7C75285261282256616C75654578706563746564222C2256616C7565206578';
wwv_flow_imp.g_varchar2_table(3713) := '70656374656422292C76612E56616C75654578706563746564293B76617220723D732E676574546F6B656E4F666673657428293B6966286128292C343D3D3D732E676574546F6B656E2829297B6E26266C2852612822547261696C696E67436F6D6D6122';
wwv_flow_imp.g_varchar2_table(3714) := '2C22547261696C696E6720636F6D6D6122292C76612E547261696C696E67436F6D6D612C722C722B31293B636F6E74696E75657D7D656C7365206E26267528526128224578706563746564436F6D6D61222C22457870656374656420636F6D6D6122292C';
wwv_flow_imp.g_varchar2_table(3715) := '76612E436F6D6D614578706563746564293B76617220693D672874293B693F742E6974656D732E707573682869293A75285261282250726F70657274794578706563746564222C2256616C756520657870656374656422292C76612E56616C7565457870';
wwv_flow_imp.g_varchar2_table(3716) := '65637465642C766F696420302C5B5D2C5B342C355D292C6E3D21307D72657475726E2034213D3D732E676574546F6B656E28293F7528526128224578706563746564436C6F7365427261636B6574222C22457870656374656420636F6D6D61206F722063';
wwv_flow_imp.g_varchar2_table(3717) := '6C6F73696E6720627261636B657422292C76612E436F6D6D614F72436C6F73654261636B657445787065637465642C74293A6828742C2130297D7D2865297C7C66756E6374696F6E2865297B696628313D3D3D732E676574546F6B656E2829297B766172';
wwv_flow_imp.g_varchar2_table(3718) := '20743D6E657720716128652C732E676574546F6B656E4F66667365742829292C6E3D4F626A6563742E637265617465286E756C6C293B6128293B666F722876617220723D21313B32213D3D732E676574546F6B656E282926263137213D3D732E67657454';
wwv_flow_imp.g_varchar2_table(3719) := '6F6B656E28293B297B696628353D3D3D732E676574546F6B656E2829297B727C7C75285261282250726F70657274794578706563746564222C2250726F706572747920657870656374656422292C76612E50726F70657274794578706563746564293B76';
wwv_flow_imp.g_varchar2_table(3720) := '617220693D732E676574546F6B656E4F666673657428293B6966286128292C323D3D3D732E676574546F6B656E2829297B7226266C2852612822547261696C696E67436F6D6D61222C22547261696C696E6720636F6D6D6122292C76612E547261696C69';
wwv_flow_imp.g_varchar2_table(3721) := '6E67436F6D6D612C692C692B31293B636F6E74696E75657D7D656C7365207226267528526128224578706563746564436F6D6D61222C22457870656374656420636F6D6D6122292C76612E436F6D6D614578706563746564293B766172206F3D6628742C';
wwv_flow_imp.g_varchar2_table(3722) := '6E293B6F3F742E70726F706572746965732E70757368286F293A75285261282250726F70657274794578706563746564222C2250726F706572747920657870656374656422292C76612E50726F706572747945787065637465642C766F696420302C5B5D';
wwv_flow_imp.g_varchar2_table(3723) := '2C5B322C355D292C723D21307D72657475726E2032213D3D732E676574546F6B656E28293F7528526128224578706563746564436C6F73654272616365222C22457870656374656420636F6D6D61206F7220636C6F73696E6720627261636522292C7661';
wwv_flow_imp.g_varchar2_table(3724) := '2E436F6D6D614F72436C6F7365427261636545787065637465642C74293A6828742C2130297D7D2865297C7C6D2865297C7C66756E6374696F6E2865297B69662831313D3D3D732E676574546F6B656E2829297B76617220743D6E657720466128652C73';
wwv_flow_imp.g_varchar2_table(3725) := '2E676574546F6B656E4F66667365742829293B696628303D3D3D732E676574546F6B656E4572726F722829297B766172206E3D732E676574546F6B656E56616C756528293B7472797B76617220723D4A534F4E2E7061727365286E293B696628216F6F28';
wwv_flow_imp.g_varchar2_table(3726) := '72292972657475726E20752852612822496E76616C69644E756D626572466F726D6174222C22496E76616C6964206E756D62657220666F726D61742E22292C76612E556E646566696E65642C74293B742E76616C75653D727D63617463682865297B7265';
wwv_flow_imp.g_varchar2_table(3727) := '7475726E20752852612822496E76616C69644E756D626572466F726D6174222C22496E76616C6964206E756D62657220666F726D61742E22292C76612E556E646566696E65642C74297D742E6973496E74656765723D2D313D3D3D6E2E696E6465784F66';
wwv_flow_imp.g_varchar2_table(3728) := '28222E22297D72657475726E206828742C2130297D7D2865297C7C66756E6374696F6E2865297B73776974636828732E676574546F6B656E2829297B6361736520373A72657475726E2068286E6577204F6128652C732E676574546F6B656E4F66667365';
wwv_flow_imp.g_varchar2_table(3729) := '742829292C2130293B6361736520383A72657475726E2068286E657720496128652C21302C732E676574546F6B656E4F66667365742829292C2130293B6361736520393A72657475726E2068286E657720496128652C21312C732E676574546F6B656E4F';
wwv_flow_imp.g_varchar2_table(3730) := '66667365742829292C2130293B64656661756C743A72657475726E7D7D2865297D76617220703D766F696420303B72657475726E203137213D3D61282926262828703D67287029293F3137213D3D732E676574546F6B656E28292626752852612822456E';
wwv_flow_imp.g_varchar2_table(3731) := '64206F662066696C65206578706563746564222C22456E64206F662066696C652065787065637465642E22292C76612E556E646566696E6564293A752852612822496E76616C69642073796D626F6C222C2245787065637465642061204A534F4E206F62';
wwv_flow_imp.g_varchar2_table(3732) := '6A6563742C206172726179206F72206C69746572616C2E22292C76612E556E646566696E656429292C6E657720486128702C6E2C6F297D28652C7B636F6C6C656374436F6D6D656E74733A21307D297D2C6E65774A534F4E446F63756D656E743A66756E';
wwv_flow_imp.g_varchar2_table(3733) := '6374696F6E28652C74297B72657475726E2066756E6374696F6E28652C74297B72657475726E20766F696420303D3D3D74262628743D5B5D292C6E657720486128652C742C5B5D297D28652C74297D2C6765744D61746368696E67536368656D61733A6E';
wwv_flow_imp.g_varchar2_table(3734) := '2E6765744D61746368696E67536368656D61732E62696E64286E292C646F5265736F6C76653A722E646F5265736F6C76652E62696E642872292C646F436F6D706C6574653A722E646F436F6D706C6574652E62696E642872292C66696E64446F63756D65';
wwv_flow_imp.g_varchar2_table(3735) := '6E7453796D626F6C733A732E66696E64446F63756D656E7453796D626F6C732E62696E642873292C66696E64446F63756D656E7453796D626F6C73323A732E66696E64446F63756D656E7453796D626F6C73322E62696E642873292C66696E64446F6375';
wwv_flow_imp.g_varchar2_table(3736) := '6D656E74436F6C6F72733A732E66696E64446F63756D656E74436F6C6F72732E62696E642873292C676574436F6C6F7250726573656E746174696F6E733A732E676574436F6C6F7250726573656E746174696F6E732E62696E642873292C646F486F7665';
wwv_flow_imp.g_varchar2_table(3737) := '723A692E646F486F7665722E62696E642869292C676574466F6C64696E6752616E6765733A566C2C67657453656C656374696F6E52616E6765733A446C2C66696E64446566696E6974696F6E3A66756E6374696F6E28297B72657475726E2050726F6D69';
wwv_flow_imp.g_varchar2_table(3738) := '73652E7265736F6C7665285B5D297D2C66696E644C696E6B733A716C2C666F726D61743A66756E6374696F6E28652C742C6E297B76617220723D766F696420303B69662874297B76617220693D652E6F6666736574417428742E7374617274293B723D7B';
wwv_flow_imp.g_varchar2_table(3739) := '6F66667365743A692C6C656E6774683A652E6F6666736574417428742E656E64292D697D7D76617220733D7B74616253697A653A6E3F6E2E74616253697A653A342C696E736572745370616365733A21303D3D3D286E756C6C3D3D6E3F766F696420303A';
wwv_flow_imp.g_varchar2_table(3740) := '6E2E696E73657274537061636573292C696E7365727446696E616C4E65776C696E653A21303D3D3D286E756C6C3D3D6E3F766F696420303A6E2E696E7365727446696E616C4E65776C696E65292C656F6C3A225C6E227D3B72657475726E2066756E6374';
wwv_flow_imp.g_varchar2_table(3741) := '696F6E28652C742C6E297B72657475726E2066756E6374696F6E28652C742C6E297B76617220722C692C732C6F2C613B69662874297B666F72286F3D742E6F66667365742C613D6F2B742E6C656E6774682C733D6F3B733E30262621727328652C732D31';
wwv_flow_imp.g_varchar2_table(3742) := '293B29732D2D3B666F7228766172206C3D613B6C3C652E6C656E677468262621727328652C6C293B296C2B2B3B693D652E737562737472696E6728732C6C292C723D66756E6374696F6E28652C74297B666F7228766172206E3D302C723D302C693D742E';
wwv_flow_imp.g_varchar2_table(3743) := '74616253697A657C7C343B6E3C652E6C656E6774683B297B76617220733D652E636861724174286E293B6966282220223D3D3D7329722B2B3B656C73657B696628225C7422213D3D7329627265616B3B722B3D697D6E2B2B7D72657475726E204D617468';
wwv_flow_imp.g_varchar2_table(3744) := '2E666C6F6F7228722F69297D28692C6E297D656C736520693D652C723D302C733D302C6F3D302C613D652E6C656E6774683B76617220752C633D66756E6374696F6E28652C74297B666F7228766172206E3D303B6E3C742E6C656E6774683B6E2B2B297B';
wwv_flow_imp.g_varchar2_table(3745) := '76617220723D742E636861724174286E293B696628225C72223D3D3D722972657475726E206E2B313C742E6C656E6774682626225C6E223D3D3D742E636861724174286E2B31293F225C725C6E223A225C72223B696628225C6E223D3D3D722972657475';
wwv_flow_imp.g_varchar2_table(3746) := '726E225C6E227D72657475726E20652626652E656F6C7C7C225C6E227D286E2C65292C683D21312C643D303B753D6E2E696E736572745370616365733F6E73282220222C6E2E74616253697A657C7C34293A225C74223B76617220663D5A6928692C2131';
wwv_flow_imp.g_varchar2_table(3747) := '292C6D3D21313B66756E6374696F6E206728297B72657475726E20632B6E7328752C722B64297D66756E6374696F6E207028297B76617220653D662E7363616E28293B666F7228683D21313B31353D3D3D657C7C31343D3D3D653B29683D687C7C31343D';
wwv_flow_imp.g_varchar2_table(3748) := '3D3D652C653D662E7363616E28293B72657475726E206D3D31363D3D3D657C7C30213D3D662E676574546F6B656E4572726F7228292C657D76617220763D5B5D3B66756E6374696F6E2062286E2C722C69297B6D7C7C7426262128723C612626693E6F29';
wwv_flow_imp.g_varchar2_table(3749) := '7C7C652E737562737472696E6728722C69293D3D3D6E7C7C762E70757368287B6F66667365743A722C6C656E6774683A692D722C636F6E74656E743A6E7D297D76617220793D7028293B6966283137213D3D79297B766172205F3D662E676574546F6B65';
wwv_flow_imp.g_varchar2_table(3750) := '6E4F666673657428292B733B62286E7328752C72292C732C5F297D666F72283B3137213D3D793B297B666F722876617220433D662E676574546F6B656E4F666673657428292B662E676574546F6B656E4C656E67746828292B732C773D7028292C533D22';
wwv_flow_imp.g_varchar2_table(3751) := '222C4C3D21313B216826262831323D3D3D777C7C31333D3D3D77293B2962282220222C432C662E676574546F6B656E4F666673657428292B73292C433D662E676574546F6B656E4F666673657428292B662E676574546F6B656E4C656E67746828292B73';
wwv_flow_imp.g_varchar2_table(3752) := '2C533D284C3D31323D3D3D77293F6728293A22222C773D7028293B696628323D3D3D772931213D3D79262628642D2D2C533D672829293B656C736520696628343D3D3D772933213D3D79262628642D2D2C533D672829293B656C73657B73776974636828';
wwv_flow_imp.g_varchar2_table(3753) := '79297B6361736520333A6361736520313A642B2B2C533D6728293B627265616B3B6361736520353A636173652031323A533D6728293B627265616B3B636173652031333A683F533D6728293A4C7C7C28533D222022293B627265616B3B6361736520363A';
wwv_flow_imp.g_varchar2_table(3754) := '4C7C7C28533D222022293B627265616B3B636173652031303A696628363D3D3D77297B4C7C7C28533D2222293B627265616B7D6361736520373A6361736520383A6361736520393A636173652031313A6361736520323A6361736520343A31323D3D3D77';
wwv_flow_imp.g_varchar2_table(3755) := '7C7C31333D3D3D773F4C7C7C28533D222022293A35213D3D7726263137213D3D772626286D3D2130293B627265616B3B636173652031363A6D3D21307D21687C7C3132213D3D7726263133213D3D777C7C28533D672829297D31373D3D3D77262628533D';
wwv_flow_imp.g_varchar2_table(3756) := '6E2E696E7365727446696E616C4E65776C696E653F633A2222292C6228532C432C662E676574546F6B656E4F666673657428292B73292C793D777D72657475726E20767D28652C742C6E297D28652E6765745465787428292C722C73292E6D6170282866';
wwv_flow_imp.g_varchar2_table(3757) := '756E6374696F6E2874297B72657475726E2044732E7265706C6163652868732E63726561746528652E706F736974696F6E417428742E6F6666736574292C652E706F736974696F6E417428742E6F66667365742B742E6C656E67746829292C742E636F6E';
wwv_flow_imp.g_varchar2_table(3758) := '74656E74297D29297D7D7D22756E646566696E656422213D747970656F662066657463682626284E6C3D66756E6374696F6E2865297B72657475726E2066657463682865292E7468656E2828653D3E652E74657874282929297D293B76617220246C3D63';
wwv_flow_imp.g_varchar2_table(3759) := '6C6173737B636F6E7374727563746F7228652C74297B746869732E5F6374783D652C746869732E5F6C616E677561676553657474696E67733D742E6C616E677561676553657474696E67732C746869732E5F6C616E677561676549643D742E6C616E6775';
wwv_flow_imp.g_varchar2_table(3760) := '61676549642C746869732E5F6C616E6775616765536572766963653D426C287B776F726B7370616365436F6E746578743A7B7265736F6C766552656C6174697665506174683A28652C74293D3E66756E6374696F6E28652C74297B69662866756E637469';
wwv_flow_imp.g_varchar2_table(3761) := '6F6E2865297B72657475726E20652E63686172436F646541742830293D3D3D576C7D287429297B636F6E7374206E3D4C6C2E70617273652865292C723D742E73706C697428222F22293B72657475726E206E2E77697468287B706174683A486C2872297D';
wwv_flow_imp.g_varchar2_table(3762) := '292E746F537472696E6728297D72657475726E2066756E6374696F6E28652C2E2E2E74297B636F6E7374206E3D4C6C2E70617273652865292C723D6E2E706174682E73706C697428222F22293B666F72286C65742065206F66207429722E70757368282E';
wwv_flow_imp.g_varchar2_table(3763) := '2E2E652E73706C697428222F2229293B72657475726E206E2E77697468287B706174683A486C2872297D292E746F537472696E6728297D28652C74297D28742E73756273747228302C742E6C617374496E6465784F6628222F22292B31292C65297D2C73';
wwv_flow_imp.g_varchar2_table(3764) := '6368656D6152657175657374536572766963653A742E656E61626C65536368656D61526571756573743F4E6C3A766F696420302C636C69656E744361706162696C69746965733A79612E4C41544553547D292C746869732E5F6C616E6775616765536572';
wwv_flow_imp.g_varchar2_table(3765) := '766963652E636F6E66696775726528746869732E5F6C616E677561676553657474696E6773297D6173796E6320646F56616C69646174696F6E2865297B6C657420743D746869732E5F67657454657874446F63756D656E742865293B69662874297B6C65';
wwv_flow_imp.g_varchar2_table(3766) := '7420653D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E742874293B72657475726E20746869732E5F6C616E6775616765536572766963652E646F56616C69646174696F6E28742C652C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(3767) := '616E677561676553657474696E6773297D72657475726E2050726F6D6973652E7265736F6C7665285B5D297D6173796E6320646F436F6D706C65746528652C74297B6C6574206E3D746869732E5F67657454657874446F63756D656E742865293B696628';
wwv_flow_imp.g_varchar2_table(3768) := '216E2972657475726E206E756C6C3B6C657420723D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E74286E293B72657475726E20746869732E5F6C616E6775616765536572766963652E646F436F6D706C';
wwv_flow_imp.g_varchar2_table(3769) := '657465286E2C742C72297D6173796E6320646F5265736F6C76652865297B72657475726E20746869732E5F6C616E6775616765536572766963652E646F5265736F6C76652865297D6173796E6320646F486F76657228652C74297B6C6574206E3D746869';
wwv_flow_imp.g_varchar2_table(3770) := '732E5F67657454657874446F63756D656E742865293B696628216E2972657475726E206E756C6C3B6C657420723D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E74286E293B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(3771) := '2E5F6C616E6775616765536572766963652E646F486F766572286E2C742C72297D6173796E6320666F726D617428652C742C6E297B6C657420723D746869732E5F67657454657874446F63756D656E742865293B69662821722972657475726E5B5D3B6C';
wwv_flow_imp.g_varchar2_table(3772) := '657420693D746869732E5F6C616E6775616765536572766963652E666F726D617428722C742C6E293B72657475726E2050726F6D6973652E7265736F6C76652869297D6173796E63207265736574536368656D612865297B72657475726E2050726F6D69';
wwv_flow_imp.g_varchar2_table(3773) := '73652E7265736F6C766528746869732E5F6C616E6775616765536572766963652E7265736574536368656D61286529297D6173796E632066696E64446F63756D656E7453796D626F6C732865297B6C657420743D746869732E5F67657454657874446F63';
wwv_flow_imp.g_varchar2_table(3774) := '756D656E742865293B69662821742972657475726E5B5D3B6C6574206E3D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E742874292C723D746869732E5F6C616E6775616765536572766963652E66696E';
wwv_flow_imp.g_varchar2_table(3775) := '64446F63756D656E7453796D626F6C733228742C6E293B72657475726E2050726F6D6973652E7265736F6C76652872297D6173796E632066696E64446F63756D656E74436F6C6F72732865297B6C657420743D746869732E5F67657454657874446F6375';
wwv_flow_imp.g_varchar2_table(3776) := '6D656E742865293B69662821742972657475726E5B5D3B6C6574206E3D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E742874292C723D746869732E5F6C616E6775616765536572766963652E66696E64';
wwv_flow_imp.g_varchar2_table(3777) := '446F63756D656E74436F6C6F727328742C6E293B72657475726E2050726F6D6973652E7265736F6C76652872297D6173796E6320676574436F6C6F7250726573656E746174696F6E7328652C742C6E297B6C657420723D746869732E5F67657454657874';
wwv_flow_imp.g_varchar2_table(3778) := '446F63756D656E742865293B69662821722972657475726E5B5D3B6C657420693D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E742872292C733D746869732E5F6C616E6775616765536572766963652E';
wwv_flow_imp.g_varchar2_table(3779) := '676574436F6C6F7250726573656E746174696F6E7328722C692C742C6E293B72657475726E2050726F6D6973652E7265736F6C76652873297D6173796E6320676574466F6C64696E6752616E67657328652C74297B6C6574206E3D746869732E5F676574';
wwv_flow_imp.g_varchar2_table(3780) := '54657874446F63756D656E742865293B696628216E2972657475726E5B5D3B6C657420723D746869732E5F6C616E6775616765536572766963652E676574466F6C64696E6752616E676573286E2C74293B72657475726E2050726F6D6973652E7265736F';
wwv_flow_imp.g_varchar2_table(3781) := '6C76652872297D6173796E632067657453656C656374696F6E52616E67657328652C74297B6C6574206E3D746869732E5F67657454657874446F63756D656E742865293B696628216E2972657475726E5B5D3B6C657420723D746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(3782) := '616765536572766963652E70617273654A534F4E446F63756D656E74286E292C693D746869732E5F6C616E6775616765536572766963652E67657453656C656374696F6E52616E676573286E2C742C72293B72657475726E2050726F6D6973652E726573';
wwv_flow_imp.g_varchar2_table(3783) := '6F6C76652869297D6173796E632070617273654A534F4E446F63756D656E742865297B6C657420743D746869732E5F67657454657874446F63756D656E742865293B69662821742972657475726E206E756C6C3B6C6574206E3D746869732E5F6C616E67';
wwv_flow_imp.g_varchar2_table(3784) := '75616765536572766963652E70617273654A534F4E446F63756D656E742874293B72657475726E2050726F6D6973652E7265736F6C7665286E297D6173796E63206765744D61746368696E67536368656D61732865297B6C657420743D746869732E5F67';
wwv_flow_imp.g_varchar2_table(3785) := '657454657874446F63756D656E742865293B69662821742972657475726E5B5D3B6C6574206E3D746869732E5F6C616E6775616765536572766963652E70617273654A534F4E446F63756D656E742874293B72657475726E2050726F6D6973652E726573';
wwv_flow_imp.g_varchar2_table(3786) := '6F6C766528746869732E5F6C616E6775616765536572766963652E6765744D61746368696E67536368656D617328742C6E29297D5F67657454657874446F63756D656E742865297B6C657420743D746869732E5F6374782E6765744D6972726F724D6F64';
wwv_flow_imp.g_varchar2_table(3787) := '656C7328293B666F72286C6574206E206F662074296966286E2E7572692E746F537472696E6728293D3D3D652972657475726E2067612E63726561746528652C746869732E5F6C616E677561676549642C6E2E76657273696F6E2C6E2E67657456616C75';
wwv_flow_imp.g_varchar2_table(3788) := '652829293B72657475726E206E756C6C7D7D2C576C3D222F222E63686172436F646541742830292C7A6C3D222E222E63686172436F646541742830293B66756E6374696F6E20486C2865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F';
wwv_flow_imp.g_varchar2_table(3789) := '66206529303D3D3D6E2E6C656E6774687C7C313D3D3D6E2E6C656E67746826266E2E63686172436F646541742830293D3D3D7A6C7C7C28323D3D3D6E2E6C656E67746826266E2E63686172436F646541742830293D3D3D7A6C26266E2E63686172436F64';
wwv_flow_imp.g_varchar2_table(3790) := '6541742831293D3D3D7A6C3F742E706F7028293A742E70757368286E29293B652E6C656E6774683E312626303D3D3D655B652E6C656E6774682D315D2E6C656E6774682626742E70757368282222293B6C6574206E3D742E6A6F696E28222F22293B7265';
wwv_flow_imp.g_varchar2_table(3791) := '7475726E20303D3D3D655B305D2E6C656E6774682626286E3D222F222B6E292C6E7D73656C662E6F6E6D6573736167653D28293D3E7B5169282828652C74293D3E6E657720246C28652C742929297D7D2928293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5450897428531701)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/json.worker.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2120466F72206C6963656E736520696E666F726D6174696F6E20706C656173652073656520666C6F777334617065782E6D6F64656C65722E6D696E2E6A732E4C4943454E53452E747874202A2F0A7661722062706D6E4D6F64656C65723B2828293D';
wwv_flow_imp.g_varchar2_table(2) := '3E7B76617220652C742C6E3D7B313939353A653D3E7B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B2262706D6E3A53657175656E6365466C6F77223D3D3D652E247479706526';
wwv_flow_imp.g_varchar2_table(3) := '26215B2262706D6E3A4578636C757369766547617465776179222C2262706D6E3A496E636C757369766547617465776179222C2262706D6E3A436F6D706C657847617465776179225D2E696E636C7564657328652E736F757263655265662E2474797065';
wwv_flow_imp.g_varchar2_table(4) := '292626652E636F6E646974696F6E45787072657373696F6E2626742E7265706F727428652E69642C2253657175656E6365466C6F77207374617274696E672066726F6D206E6F6E2D4761746577617920656C656D656E7420697320636F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(5) := '616C22297D7D7D7D2C393334343A653D3E7B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B2262706D6E3A426F756E646172794576656E74223D3D3D652E247479706526262262';
wwv_flow_imp.g_varchar2_table(6) := '706D6E3A53756250726F63657373223D3D3D652E6174746163686564546F5265662E24747970652626652E6174746163686564546F5265662E6C6F6F704368617261637465726973746963732626742E7265706F727428652E69642C22426F756E646172';
wwv_flow_imp.g_varchar2_table(7) := '79206576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F7274656422292C2262706D6E3A43616C6C4163746976697479223D3D3D652E24747970652626652E6C';
wwv_flow_imp.g_varchar2_table(8) := '6F6F704368617261637465726973746963732626742E7265706F727428652E69642C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F7274656422297D7D7D7D2C313338323A65';
wwv_flow_imp.g_varchar2_table(9) := '3D3E7B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B636F6E73747B69643A6E7D3D653B6E26266E2E6C656E6774683E35302626742E7265706F727428652E69642C22456C656D';
wwv_flow_imp.g_varchar2_table(10) := '656E74204944206973206C6F6E676572207468616E203530206368617261637465727322297D7D7D7D2C313539343A653D3E7B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B22';
wwv_flow_imp.g_varchar2_table(11) := '62706D6E3A4578636C75736976654761746577617922213D3D652E247479706526262262706D6E3A506172616C6C656C4761746577617922213D3D652E247479706526262262706D6E3A496E636C75736976654761746577617922213D3D652E24747970';
wwv_flow_imp.g_varchar2_table(12) := '657C7C652E696E636F6D696E672626652E696E636F6D696E672E6C656E6774683E312626652E6F7574676F696E672626652E6F7574676F696E672E6C656E6774683E312626742E7265706F727428652E69642C224120676174657761792073686F756C64';
wwv_flow_imp.g_varchar2_table(13) := '206E6F74206D6572676520616E642073706C6974206174207468652073616D652074696D6522297D7D7D7D2C363532373A653D3E7B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(14) := '7B2262706D6E3A53746172744576656E74223D3D3D652E24747970652626652E6576656E74446566696E6974696F6E732626652E6576656E74446566696E6974696F6E735B305D2626282262706D6E3A4D6573736167654576656E74446566696E697469';
wwv_flow_imp.g_varchar2_table(15) := '6F6E223D3D3D652E6576656E74446566696E6974696F6E735B305D2E24747970653F742E7265706F727428652E69642C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E74';
wwv_flow_imp.g_varchar2_table(16) := '3E22293A2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E223D3D3D652E6576656E74446566696E6974696F6E735B305D2E24747970653F742E7265706F727428652E69642C22456C656D656E742068617320646973616C';
wwv_flow_imp.g_varchar2_table(17) := '6C6F7765642074797065203C62706D6E3A436F6E646974696F6E616C53746172744576656E743E22293A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E223D3D3D652E6576656E74446566696E6974696F6E735B305D2E2474797065';
wwv_flow_imp.g_varchar2_table(18) := '2626742E7265706F727428652E69642C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E2229297D7D7D7D2C353235373A28652C742C6E293D3E7B76617220693D7B222E';
wwv_flow_imp.g_varchar2_table(19) := '2F64652E6A736F6E223A343338372C222E2F65732E6A736F6E223A343431322C222E2F66722E6A736F6E223A363932382C222E2F69742E6A736F6E223A383536392C222E2F6A612E6A736F6E223A393736312C222E2F6B6F2E6A736F6E223A393239342C';
wwv_flow_imp.g_varchar2_table(20) := '222E2F70742D62722E6A736F6E223A3330372C222E2F746573742E6A736F6E223A323232302C222E2F7A682D636E2E6A736F6E223A383133322C222E2F7A682D74772E6A736F6E223A353538387D3B66756E6374696F6E206F2865297B76617220743D73';
wwv_flow_imp.g_varchar2_table(21) := '2865293B72657475726E206E2874297D66756E6374696F6E20732865297B696628216E2E6F28692C6529297B76617220743D6E6577204572726F72282243616E6E6F742066696E64206D6F64756C652027222B652B222722293B7468726F7720742E636F';
wwv_flow_imp.g_varchar2_table(22) := '64653D224D4F44554C455F4E4F545F464F554E44222C747D72657475726E20695B655D7D6F2E6B6579733D66756E6374696F6E28297B72657475726E204F626A6563742E6B6579732869297D2C6F2E7265736F6C76653D732C652E6578706F7274733D6F';
wwv_flow_imp.g_varchar2_table(23) := '2C6F2E69643D353235377D2C363438303A28652C742C6E293D3E7B2275736520737472696374223B76617220693D6E28363033293B66756E6374696F6E206F28652C742C6E297B766172206F3D66756E6374696F6E28652C74297B766172206E3D5B5D2C';
wwv_flow_imp.g_varchar2_table(24) := '6F3D652E6765742822657874656E73696F6E456C656D656E747322293B696628766F69642030213D3D6F297B76617220733D6F2E676574282276616C75657322293B766F69642030213D3D732626286E3D692E66696C74657228732C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(25) := '6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E24696E7374616E63654F662626652E24696E7374616E63654F662874297D28652C74297D2929297D726574';
wwv_flow_imp.g_varchar2_table(26) := '75726E206E7D28652C74293B72657475726E206E3F286F5B305D7C7C7B7D295B6E5D7C7C5B5D3A6F7D66756E6374696F6E207328652C74297B766172206E3D66756E6374696F6E2865297B72657475726E286F28652C2263616D756E64613A496E707574';
wwv_flow_imp.g_varchar2_table(27) := '4F757470757422297C7C5B5D295B305D7D2865293B72657475726E206E26266E2E6765742874297C7C5B5D7D66756E6374696F6E20722865297B666F722876617220743D5B5D2C6E3D653B6E2E24706172656E743B29742E70757368286E2E2470617265';
wwv_flow_imp.g_varchar2_table(28) := '6E74292C6E3D6E2E24706172656E743B72657475726E20747D66756E6374696F6E206128652C742C6E297B6E3D6E7C7C302C692E697341727261792865297C7C28653D5B655D292C692E666F724561636828652C2866756E6374696F6E28652C6F297B76';
wwv_flow_imp.g_varchar2_table(29) := '617220733D7428652C6F2C6E293B692E697341727261792873292626732E6C656E67746826266128732C742C6E2B31297D29297D66756E6374696F6E206C28652C742C6E297B76617220693D216E7C7C2D313D3D3D652E696E6465784F662874293B7265';
wwv_flow_imp.g_varchar2_table(30) := '7475726E20692626652E707573682874292C697D66756E6374696F6E206328652C742C6E297B76617220693D5B5D2C6F3D5B5D3B72657475726E206128652C2866756E6374696F6E28652C732C72297B6C28692C652C74293B76617220613D652E666C6F';
wwv_flow_imp.g_varchar2_table(31) := '77456C656D656E74733B696628282D313D3D3D6E7C7C723C6E2926266126266C286F2C612C74292972657475726E20617D29292C697D66756E6374696F6E206428652C74297B72657475726E206328652C21742C2D31297D66756E6374696F6E20682865';
wwv_flow_imp.g_varchar2_table(32) := '2C74297B766172206E2C6F2C733D692E66696E64496E64657828652C2866756E6374696F6E2865297B72657475726E20652E6E616D653D3D3D742E6E616D652626652E73636F70653D3D3D742E73636F70657D29293B733E3D303F655B735D2E6F726967';
wwv_flow_imp.g_varchar2_table(33) := '696E3D286E3D655B735D2E6F726967696E2C6F3D742E6F726967696E2C6E2E636F6E636174286F29293A652E707573682874297D66756E6374696F6E207528652C742C6E297B766172206F2C612C6C2C632C643D286F3D6E2C613D742C6C3D722865292C';
wwv_flow_imp.g_varchar2_table(34) := '633D692E66696E64286C2C2866756E6374696F6E2865297B72657475726E28743D652926262266756E6374696F6E223D3D747970656F6620742E24696E7374616E63654F662626742E24696E7374616E63654F66282262706D6E3A53756250726F636573';
wwv_flow_imp.g_varchar2_table(35) := '732229262666756E6374696F6E28652C74297B72657475726E20692E66696E642866756E6374696F6E2865297B72657475726E207328652C22696E707574506172616D657465727322297D2865292C2866756E6374696F6E2865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(36) := '2E6E616D653D3D3D747D29297D28652C61293B76617220747D29292C637C7C6F293B72657475726E7B6E616D653A742C6F726967696E3A5B655D2C73636F70653A647D7D66756E6374696F6E207028652C74297B766172206E3D652E6576656E74446566';
wwv_flow_imp.g_varchar2_table(37) := '696E6974696F6E733B72657475726E206E2626743F692E66696C746572286E2C2866756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E24696E';
wwv_flow_imp.g_varchar2_table(38) := '7374616E63654F662626652E24696E7374616E63654F662874297D28652C74297D29293A6E7D76617220673D5B66756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C6F3D652E70';
wwv_flow_imp.g_varchar2_table(39) := '726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E207328652C22';
wwv_flow_imp.g_varchar2_table(40) := '6F7574707574506172616D657465727322297D2865293B692E666F724561636828742C2866756E6374696F6E2874297B76617220693D7528652C742E6E616D652C6E293B68286F2C69297D29297D29292C6F7D2C66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(41) := '743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C6F3D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866756E';
wwv_flow_imp.g_varchar2_table(42) := '6374696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E20652E676574282263616D756E64613A726573756C745661726961626C6522297D2865293B69662874297B76617220693D7528652C742C6E293B68286F2C69297D7D29';
wwv_flow_imp.g_varchar2_table(43) := '292C6F7D2C66756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C733D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D';
wwv_flow_imp.g_varchar2_table(44) := '5B745D292C692E666F724561636828742C2866756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E206F28652C2263616D756E64613A466F726D4461746122295B305D7D';
wwv_flow_imp.g_varchar2_table(45) := '2865293B72657475726E20742626742E67657428226669656C647322297C7C5B5D7D2865293B692E666F724561636828742C2866756E6374696F6E2874297B76617220693D7528652C742E69642C6E293B6828732C69297D29297D29292C737D2C66756E';
wwv_flow_imp.g_varchar2_table(46) := '6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C733D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E66';
wwv_flow_imp.g_varchar2_table(47) := '6F724561636828742C2866756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E206F28652C2263616D756E64613A4F757422297D2865293B692E666F724561636828742C2866756E6374696F6E2874297B6966282174';
wwv_flow_imp.g_varchar2_table(48) := '2E6C6F63616C297B76617220693D7528652C742E7461726765742C6E293B6828732C69297D7D29297D29292C737D2C66756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C6F3D65';
wwv_flow_imp.g_varchar2_table(49) := '2E70726F636573735661726961626C65732C733D66756E6374696F6E28652C74297B76617220693D7528652C742C6E293B68286F2C69297D3B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866';
wwv_flow_imp.g_varchar2_table(50) := '756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E207028652C2262706D6E3A4572726F724576656E74446566696E6974696F6E22297D2865293B692E666F724561636828742C2866756E6374696F6E2874297B7661';
wwv_flow_imp.g_varchar2_table(51) := '72206E3D742E67657428226572726F72436F64655661726961626C6522292C693D742E67657428226572726F724D6573736167655661726961626C6522293B6E26267328652C6E292C6926267328652C69297D29293B766172206E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(52) := '2865297B72657475726E207028652C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E22297D2865293B692E666F7245616368286E2C2866756E6374696F6E2874297B766172206E3D742E6765742822657363616C6174696F';
wwv_flow_imp.g_varchar2_table(53) := '6E436F64655661726961626C6522293B6E26267328652C6E297D29297D29292C6F7D5D3B742E5A633D6173796E632066756E6374696F6E28652C742C6E3D5B5D297B766172206F2C733D61776169742066756E6374696F6E28652C743D5B5D297B636F6E';
wwv_flow_imp.g_varchar2_table(54) := '7374206E3D5B5D3B766172206F3D5B5D2C733D64285B655D2C2131293B72657475726E20692E666F7245616368285B2E2E2E672C2E2E2E745D2C2866756E6374696F6E2874297B6E2E707573682874287B656C656D656E74733A732C636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(55) := '72456C656D656E743A652C70726F636573735661726961626C65733A6F7D29297D29292C50726F6D6973652E616C6C286E292E7468656E282828293D3E6F29297D28742C6E292C613D66756E6374696F6E28652C74297B766172206E3D642874293B7265';
wwv_flow_imp.g_varchar2_table(56) := '7475726E20692E66696E64286E2C2866756E6374696F6E2874297B72657475726E20742E69643D3D3D657D29297D28652C74292C6C3D692E66696C74657228732C2866756E6374696F6E2865297B72657475726E20652E73636F70652E69643D3D3D612E';
wwv_flow_imp.g_varchar2_table(57) := '69647D29292C633D722861293B72657475726E206F3D692E66696C74657228732C2866756E6374696F6E2865297B72657475726E20692E66696E6428632C2866756E6374696F6E2874297B72657475726E20742E69643D3D3D652E73636F70652E69647D';
wwv_flow_imp.g_varchar2_table(58) := '29297D29292C6C2E636F6E636174286F297D7D2C353238353A28652C742C6E293D3E7B2275736520737472696374223B76617220693D6E28363033293B66756E6374696F6E206F2865297B72657475726E287328652C227A656562653A496F4D61707069';
wwv_flow_imp.g_varchar2_table(59) := '6E6722297C7C5B5D295B305D7D66756E6374696F6E207328652C742C6E297B766172206F3D66756E6374696F6E28652C74297B766172206E3D5B5D2C6F3D652E6765742822657874656E73696F6E456C656D656E747322293B696628766F69642030213D';
wwv_flow_imp.g_varchar2_table(60) := '3D6F297B76617220733D6F2E676574282276616C75657322293B766F69642030213D3D732626286E3D692E66696C74657228732C2866756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E206526262266756E';
wwv_flow_imp.g_varchar2_table(61) := '6374696F6E223D3D747970656F6620652E24696E7374616E63654F662626652E24696E7374616E63654F662874297D28652C74297D2929297D72657475726E206E7D28652C74293B72657475726E206E3F286F5B305D7C7C7B7D295B6E5D7C7C5B5D3A6F';
wwv_flow_imp.g_varchar2_table(62) := '7D66756E6374696F6E20722865297B666F722876617220743D5B5D2C6E3D653B6E2E24706172656E743B29742E70757368286E2E24706172656E74292C6E3D6E2E24706172656E743B72657475726E20747D66756E6374696F6E206128652C742C6E297B';
wwv_flow_imp.g_varchar2_table(63) := '6E3D6E7C7C302C692E697341727261792865297C7C28653D5B655D292C692E666F724561636828652C2866756E6374696F6E28652C6F297B76617220733D7428652C6F2C6E293B692E697341727261792873292626732E6C656E67746826266128732C74';
wwv_flow_imp.g_varchar2_table(64) := '2C6E2B31297D29297D66756E6374696F6E206C28652C742C6E297B76617220693D216E7C7C2D313D3D3D652E696E6465784F662874293B72657475726E20692626652E707573682874292C697D66756E6374696F6E206328652C742C6E297B7661722069';
wwv_flow_imp.g_varchar2_table(65) := '3D5B5D2C6F3D5B5D3B72657475726E206128652C2866756E6374696F6E28652C732C72297B6C28692C652C74293B76617220613D652E666C6F77456C656D656E74733B696628282D313D3D3D6E7C7C723C6E2926266126266C286F2C612C742929726574';
wwv_flow_imp.g_varchar2_table(66) := '75726E20617D29292C697D66756E6374696F6E206428652C74297B72657475726E206328652C21742C2D31297D66756E6374696F6E206828652C74297B766172206E2C6F2C733D692E66696E64496E64657828652C2866756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(67) := '7475726E20652E6E616D653D3D3D742E6E616D652626652E73636F70653D3D3D742E73636F70657D29293B733E3D303F655B735D2E6F726967696E3D286E3D655B735D2E6F726967696E2C6F3D742E6F726967696E2C6E2E636F6E636174286F29293A65';
wwv_flow_imp.g_varchar2_table(68) := '2E707573682874297D66756E6374696F6E207528652C742C6E297B76617220732C612C6C2C632C643D28733D6E2C613D742C6C3D722865292C633D692E66696E64286C2C2866756E6374696F6E2865297B72657475726E28743D652926262266756E6374';
wwv_flow_imp.g_varchar2_table(69) := '696F6E223D3D747970656F6620742E24696E7374616E63654F662626742E24696E7374616E63654F66282262706D6E3A53756250726F636573732229262666756E6374696F6E28652C74297B72657475726E20692E66696E642866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(70) := '297B72657475726E2066756E6374696F6E2865297B76617220743D6F2865293B72657475726E20742626742E6765742822696E707574506172616D657465727322297C7C5B5D7D2865297D2865292C2866756E6374696F6E2865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(71) := '2E7461726765743D3D3D747D29297D28652C61293B76617220747D29292C637C7C73293B72657475726E7B6E616D653A742C6F726967696E3A5B655D2C73636F70653A647D7D76617220703D5B66756E6374696F6E2865297B76617220743D652E656C65';
wwv_flow_imp.g_varchar2_table(72) := '6D656E74732C6E3D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(73) := '657475726E286F2865297C7C7B7D292E696E707574506172616D65746572737D2865293B692E666F724561636828742C2866756E6374696F6E2874297B76617220693D7528652C742E7461726765742C65293B68286E2C69297D29297D29292C6E7D2C66';
wwv_flow_imp.g_varchar2_table(74) := '756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(75) := '65297B76617220743D652E6C6F6F704368617261637465726973746963732C693D74262666756E6374696F6E2865297B636F6E737420743D7328652C227A656562653A4C6F6F7043686172616374657269737469637322295B305D3B72657475726E2074';
wwv_flow_imp.g_varchar2_table(76) := '2626742E696E707574456C656D656E747D2874293B69662869297B766172206F3D7528652C692C65293B68286E2C6F297D7D29292C6E7D2C66756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C';
wwv_flow_imp.g_varchar2_table(77) := '656D656E742C733D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(78) := '657475726E286F2865297C7C7B7D292E6F7574707574506172616D65746572737D2865293B692E666F724561636828742C2866756E6374696F6E2874297B76617220693D7528652C742E7461726765742C6E293B6828732C69297D29297D29292C737D2C';
wwv_flow_imp.g_varchar2_table(79) := '66756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C6F3D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C';
wwv_flow_imp.g_varchar2_table(80) := '692E666F724561636828742C2866756E6374696F6E2865297B76617220743D652E6C6F6F704368617261637465726973746963732C693D74262666756E6374696F6E2865297B636F6E737420743D7328652C227A656562653A4C6F6F7043686172616374';
wwv_flow_imp.g_varchar2_table(81) := '657269737469637322295B305D3B72657475726E20742626742E6F7574707574436F6C6C656374696F6E7D2874293B69662869297B76617220723D7528652C692C6E293B68286F2C72297D7D29292C6F7D2C66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(82) := '652E656C656D656E74732C6E3D652E636F6E7461696E6572456C656D656E742C6F3D652E70726F636573735661726961626C65733B72657475726E20692E697341727261792874297C7C28743D5B745D292C692E666F724561636828742C2866756E6374';
wwv_flow_imp.g_varchar2_table(83) := '696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E287328652C227A656562653A43616C6C65644465636973696F6E22297C7C5B5D295B305D7D2865297C7C66756E6374696F6E2865297B72657475726E287328652C227A6565';
wwv_flow_imp.g_varchar2_table(84) := '62653A53637269707422297C7C5B5D295B305D7D2865293B69662874297B76617220693D742E726573756C745661726961626C653B69662869297B76617220723D7528652C692C6E293B68286F2C72297D7D7D29292C6F7D5D3B6173796E632066756E63';
wwv_flow_imp.g_varchar2_table(85) := '74696F6E206728652C742C6E3D5B5D297B766172206F2C733D61776169742066756E6374696F6E28652C743D5B5D297B766172206E3D5B5D2C6F3D64285B655D2C2131293B636F6E737420733D5B5D3B72657475726E20692E666F7245616368285B2E2E';
wwv_flow_imp.g_varchar2_table(86) := '2E702C2E2E2E745D2C2866756E6374696F6E2874297B732E707573682874287B656C656D656E74733A6F2C636F6E7461696E6572456C656D656E743A652C70726F636573735661726961626C65733A6E7D29297D29292C50726F6D6973652E616C6C2873';
wwv_flow_imp.g_varchar2_table(87) := '292E7468656E282828293D3E6E29297D28742C6E292C613D66756E6374696F6E28652C74297B766172206E3D642874293B72657475726E20692E66696E64286E2C2866756E6374696F6E2874297B72657475726E20742E69643D3D3D657D29297D28652C';
wwv_flow_imp.g_varchar2_table(88) := '74292C6C3D692E66696C74657228732C2866756E6374696F6E2865297B72657475726E20652E73636F70652E69643D3D3D612E69647D29292C633D722861293B72657475726E206F3D692E66696C74657228732C2866756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(89) := '75726E20692E66696E6428632C2866756E6374696F6E2874297B72657475726E20742E69643D3D3D652E73636F70652E69647D29297D29292C6C2E636F6E636174286F297D66756E6374696F6E206D2865297B72657475726E20652626652E627573696E';
wwv_flow_imp.g_varchar2_table(90) := '6573734F626A6563747C7C657D66756E6374696F6E206628652C74297B766172206E3D6D2865293B72657475726E206E26262266756E6374696F6E223D3D747970656F66206E2E24696E7374616E63654F6626266E2E24696E7374616E63654F66287429';
wwv_flow_imp.g_varchar2_table(91) := '7D742E48703D66756E6374696F6E28652C743D5B5D297B72657475726E20672866756E6374696F6E2865297B636F6E737420743D6D2865293B72657475726E206628652C2262706D6E3A5061727469636970616E7422293F742E70726F63657373526566';
wwv_flow_imp.g_varchar2_table(92) := '2E69643A742E69647D2865292C66756E6374696F6E2865297B636F6E737420743D6D2865293B6966286628742C2262706D6E3A5061727469636970616E7422292972657475726E20742E70726F636573735265663B6966286628742C2262706D6E3A5072';
wwv_flow_imp.g_varchar2_table(93) := '6F6365737322292972657475726E20743B6C6574206E3D743B666F72283B6E2E24706172656E7426262166286E2C2262706D6E3A50726F6365737322293B296E3D6E2E24706172656E743B72657475726E206E7D2865292C74297D7D2C333130343A2865';
wwv_flow_imp.g_varchar2_table(94) := '2C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B464B3A28293D3E792C4F623A28293D3E6A2C51763A28293D3E572C58583A28293D3E482C5F333A28293D3E5F2C66463A28293D3E6F2C6E3A28293D3E762C71363A28293D3E712C75';
wwv_flow_imp.g_varchar2_table(95) := '413A28293D3E772C76323A28293D3E547D293B76617220692C6F2C732C722C612C6C2C632C642C683D7B7D2C753D5B5D2C703D2F616369747C6578283F3A737C677C6E7C707C24297C7270687C677269647C6F77737C6D6E637C6E74777C696E655B6368';
wwv_flow_imp.g_varchar2_table(96) := '5D7C7A6F6F7C5E6F72647C69746572612F692C673D41727261792E697341727261793B66756E6374696F6E206D28652C74297B666F7228766172206E20696E207429655B6E5D3D745B6E5D3B72657475726E20657D66756E6374696F6E20662865297B76';
wwv_flow_imp.g_varchar2_table(97) := '617220743D652E706172656E744E6F64653B742626742E72656D6F76654368696C642865297D66756E6374696F6E207628652C742C6E297B766172206F2C732C722C613D7B7D3B666F72287220696E207429226B6579223D3D723F6F3D745B725D3A2272';
wwv_flow_imp.g_varchar2_table(98) := '6566223D3D723F733D745B725D3A615B725D3D745B725D3B696628617267756D656E74732E6C656E6774683E32262628612E6368696C6472656E3D617267756D656E74732E6C656E6774683E333F692E63616C6C28617267756D656E74732C32293A6E29';
wwv_flow_imp.g_varchar2_table(99) := '2C2266756E6374696F6E223D3D747970656F66206526266E756C6C213D652E64656661756C7450726F707329666F72287220696E20652E64656661756C7450726F707329766F696420303D3D3D615B725D262628615B725D3D652E64656661756C745072';
wwv_flow_imp.g_varchar2_table(100) := '6F70735B725D293B72657475726E206228652C612C6F2C732C6E756C6C297D66756E6374696F6E206228652C742C6E2C692C72297B76617220613D7B747970653A652C70726F70733A742C6B65793A6E2C7265663A692C5F5F6B3A6E756C6C2C5F5F3A6E';
wwv_flow_imp.g_varchar2_table(101) := '756C6C2C5F5F623A302C5F5F653A6E756C6C2C5F5F643A766F696420302C5F5F633A6E756C6C2C636F6E7374727563746F723A766F696420302C5F5F763A6E756C6C3D3D723F2B2B733A722C5F5F693A2D312C5F5F753A307D3B72657475726E206E756C';
wwv_flow_imp.g_varchar2_table(102) := '6C3D3D7226266E756C6C213D6F2E766E6F646526266F2E766E6F64652861292C617D66756E6374696F6E205F28297B72657475726E7B63757272656E743A6E756C6C7D7D66756E6374696F6E20792865297B72657475726E20652E6368696C6472656E7D';
wwv_flow_imp.g_varchar2_table(103) := '66756E6374696F6E207728652C74297B746869732E70726F70733D652C746869732E636F6E746578743D747D66756E6374696F6E204328652C74297B6966286E756C6C3D3D742972657475726E20652E5F5F3F4328652E5F5F2C652E5F5F692B31293A6E';
wwv_flow_imp.g_varchar2_table(104) := '756C6C3B666F7228766172206E3B743C652E5F5F6B2E6C656E6774683B742B2B296966286E756C6C213D286E3D652E5F5F6B5B745D2926266E756C6C213D6E2E5F5F652972657475726E206E2E5F5F653B72657475726E2266756E6374696F6E223D3D74';
wwv_flow_imp.g_varchar2_table(105) := '7970656F6620652E747970653F432865293A6E756C6C7D66756E6374696F6E20532865297B76617220742C6E3B6966286E756C6C213D28653D652E5F5F2926266E756C6C213D652E5F5F63297B666F7228652E5F5F653D652E5F5F632E626173653D6E75';
wwv_flow_imp.g_varchar2_table(106) := '6C6C2C743D303B743C652E5F5F6B2E6C656E6774683B742B2B296966286E756C6C213D286E3D652E5F5F6B5B745D2926266E756C6C213D6E2E5F5F65297B652E5F5F653D652E5F5F632E626173653D6E2E5F5F653B627265616B7D72657475726E205328';
wwv_flow_imp.g_varchar2_table(107) := '65297D7D66756E6374696F6E20782865297B2821652E5F5F64262628652E5F5F643D2130292626722E707573682865292626216B2E5F5F722B2B7C7C61213D3D6F2E6465626F756E636552656E646572696E672926262828613D6F2E6465626F756E6365';
wwv_flow_imp.g_varchar2_table(108) := '52656E646572696E67297C7C6C29286B297D66756E6374696F6E206B28297B76617220652C742C6E2C692C732C612C6C2C642C683B666F7228722E736F72742863293B653D722E736869667428293B29652E5F5F64262628743D722E6C656E6774682C69';
wwv_flow_imp.g_varchar2_table(109) := '3D766F696420302C613D28733D286E3D65292E5F5F76292E5F5F652C643D5B5D2C683D5B5D2C286C3D6E2E5F5F502926262828693D6D287B7D2C7329292E5F5F763D732E5F5F762B312C6F2E766E6F646526266F2E766E6F64652869292C4F286C2C692C';
wwv_flow_imp.g_varchar2_table(110) := '732C6E2E5F5F6E2C766F69642030213D3D6C2E6F776E6572535647456C656D656E742C333226732E5F5F753F5B615D3A6E756C6C2C642C6E756C6C3D3D613F432873293A612C212128333226732E5F5F75292C68292C692E5F5F2E5F5F6B5B692E5F5F69';
wwv_flow_imp.g_varchar2_table(111) := '5D3D692C5228642C692C68292C692E5F5F65213D61262653286929292C722E6C656E6774683E742626722E736F7274286329293B6B2E5F5F723D307D66756E6374696F6E204528652C742C6E2C692C6F2C732C722C612C6C2C632C64297B76617220702C';
wwv_flow_imp.g_varchar2_table(112) := '672C6D2C662C762C623D692626692E5F5F6B7C7C752C5F3D742E6C656E6774683B666F72286E2E5F5F643D6C2C4C286E2C742C62292C6C3D6E2E5F5F642C703D303B703C5F3B702B2B296E756C6C213D286D3D6E2E5F5F6B5B705D29262622626F6F6C65';
wwv_flow_imp.g_varchar2_table(113) := '616E22213D747970656F66206D26262266756E6374696F6E22213D747970656F66206D262628673D2D313D3D3D6D2E5F5F693F683A625B6D2E5F5F695D7C7C682C6D2E5F5F693D702C4F28652C6D2C672C6F2C732C722C612C6C2C632C64292C663D6D2E';
wwv_flow_imp.g_varchar2_table(114) := '5F5F652C6D2E7265662626672E726566213D6D2E726566262628672E72656626264228672E7265662C6E756C6C2C6D292C642E70757368286D2E7265662C6D2E5F5F637C7C662C6D29292C6E756C6C3D3D7626266E756C6C213D66262628763D66292C36';
wwv_flow_imp.g_varchar2_table(115) := '35353336266D2E5F5F757C7C672E5F5F6B3D3D3D6D2E5F5F6B3F6C3D44286D2C6C2C65293A2266756E6374696F6E223D3D747970656F66206D2E747970652626766F69642030213D3D6D2E5F5F643F6C3D6D2E5F5F643A662626286C3D662E6E65787453';
wwv_flow_imp.g_varchar2_table(116) := '69626C696E67292C6D2E5F5F643D766F696420302C6D2E5F5F75263D2D313936363039293B6E2E5F5F643D6C2C6E2E5F5F653D767D66756E6374696F6E204C28652C742C6E297B76617220692C6F2C732C722C612C6C3D742E6C656E6774682C633D6E2E';
wwv_flow_imp.g_varchar2_table(117) := '6C656E6774682C643D632C683D303B666F7228652E5F5F6B3D5B5D2C693D303B693C6C3B692B2B296E756C6C213D286F3D652E5F5F6B5B695D3D6E756C6C3D3D286F3D745B695D297C7C22626F6F6C65616E223D3D747970656F66206F7C7C2266756E63';
wwv_flow_imp.g_varchar2_table(118) := '74696F6E223D3D747970656F66206F3F6E756C6C3A22737472696E67223D3D747970656F66206F7C7C226E756D626572223D3D747970656F66206F7C7C22626967696E74223D3D747970656F66206F7C7C6F2E636F6E7374727563746F723D3D53747269';
wwv_flow_imp.g_varchar2_table(119) := '6E673F62286E756C6C2C6F2C6E756C6C2C6E756C6C2C6F293A67286F293F6228792C7B6368696C6472656E3A6F7D2C6E756C6C2C6E756C6C2C6E756C6C293A766F696420303D3D3D6F2E636F6E7374727563746F7226266F2E5F5F623E303F62286F2E74';
wwv_flow_imp.g_varchar2_table(120) := '7970652C6F2E70726F70732C6F2E6B65792C6F2E7265663F6F2E7265663A6E756C6C2C6F2E5F5F76293A6F293F286F2E5F5F3D652C6F2E5F5F623D652E5F5F622B312C613D49286F2C6E2C723D692B682C64292C6F2E5F5F693D612C733D6E756C6C2C2D';
wwv_flow_imp.g_varchar2_table(121) := '31213D3D61262628642D2D2C28733D6E5B615D29262628732E5F5F757C3D31333130373229292C6E756C6C3D3D737C7C6E756C6C3D3D3D732E5F5F763F282D313D3D612626682D2D2C2266756E6374696F6E22213D747970656F66206F2E747970652626';
wwv_flow_imp.g_varchar2_table(122) := '286F2E5F5F757C3D363535333629293A61213D3D72262628613D3D3D722B313F682B2B3A613E723F643E6C2D723F682B3D612D723A682D2D3A683D613C722626613D3D722D313F612D723A302C61213D3D692B682626286F2E5F5F757C3D363535333629';
wwv_flow_imp.g_varchar2_table(123) := '29293A28733D6E5B695D2926266E756C6C3D3D732E6B65792626732E5F5F65262628732E5F5F653D3D652E5F5F64262628652E5F5F643D43287329292C5628732C732C2131292C6E5B695D3D6E756C6C2C642D2D293B6966286429666F7228693D303B69';
wwv_flow_imp.g_varchar2_table(124) := '3C633B692B2B296E756C6C213D28733D6E5B695D292626212831333130373226732E5F5F7529262628732E5F5F653D3D652E5F5F64262628652E5F5F643D43287329292C5628732C7329297D66756E6374696F6E204428652C742C6E297B76617220692C';
wwv_flow_imp.g_varchar2_table(125) := '6F3B6966282266756E6374696F6E223D3D747970656F6620652E74797065297B666F7228693D652E5F5F6B2C6F3D303B6926266F3C692E6C656E6774683B6F2B2B29695B6F5D262628695B6F5D2E5F5F3D652C743D4428695B6F5D2C742C6E29293B7265';
wwv_flow_imp.g_varchar2_table(126) := '7475726E20747D72657475726E20652E5F5F65213D742626286E2E696E736572744265666F726528652E5F5F652C747C7C6E756C6C292C743D652E5F5F65292C742626742E6E6578745369626C696E677D66756E6374696F6E205428652C74297B726574';
wwv_flow_imp.g_varchar2_table(127) := '75726E20743D747C7C5B5D2C6E756C6C3D3D657C7C22626F6F6C65616E223D3D747970656F6620657C7C28672865293F652E736F6D65282866756E6374696F6E2865297B5428652C74297D29293A742E70757368286529292C747D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(128) := '4928652C742C6E2C69297B766172206F3D652E6B65792C733D652E747970652C723D6E2D312C613D6E2B312C6C3D745B6E5D3B6966286E756C6C3D3D3D6C7C7C6C26266F3D3D6C2E6B65792626733D3D3D6C2E747970652972657475726E206E3B696628';
wwv_flow_imp.g_varchar2_table(129) := '693E286E756C6C3D3D6C7C7C313331303732266C2E5F5F753F303A312929666F72283B723E3D307C7C613C742E6C656E6774683B297B696628723E3D30297B696628286C3D745B725D2926262128313331303732266C2E5F5F752926266F3D3D6C2E6B65';
wwv_flow_imp.g_varchar2_table(130) := '792626733D3D3D6C2E747970652972657475726E20723B722D2D7D696628613C742E6C656E677468297B696628286C3D745B615D2926262128313331303732266C2E5F5F752926266F3D3D6C2E6B65792626733D3D3D6C2E747970652972657475726E20';
wwv_flow_imp.g_varchar2_table(131) := '613B612B2B7D7D72657475726E2D317D66756E6374696F6E204D28652C742C6E297B222D223D3D3D745B305D3F652E73657450726F706572747928742C6E756C6C3D3D6E3F22223A6E293A655B745D3D6E756C6C3D3D6E3F22223A226E756D6265722221';
wwv_flow_imp.g_varchar2_table(132) := '3D747970656F66206E7C7C702E746573742874293F6E3A6E2B227078227D66756E6374696F6E204128652C742C6E2C692C6F297B76617220733B653A696628227374796C65223D3D3D742969662822737472696E67223D3D747970656F66206E29652E73';
wwv_flow_imp.g_varchar2_table(133) := '74796C652E637373546578743D6E3B656C73657B69662822737472696E67223D3D747970656F662069262628652E7374796C652E637373546578743D693D2222292C6929666F72287420696E2069296E26267420696E206E7C7C4D28652E7374796C652C';
wwv_flow_imp.g_varchar2_table(134) := '742C2222293B6966286E29666F72287420696E206E296926266E5B745D3D3D3D695B745D7C7C4D28652E7374796C652C742C6E5B745D297D656C736520696628226F223D3D3D745B305D2626226E223D3D3D745B315D29733D74213D3D28743D742E7265';
wwv_flow_imp.g_varchar2_table(135) := '706C616365282F28506F696E7465724361707475726529247C43617074757265242F2C2224312229292C743D742E746F4C6F776572436173652829696E20653F742E746F4C6F7765724361736528292E736C6963652832293A742E736C6963652832292C';
wwv_flow_imp.g_varchar2_table(136) := '652E6C7C7C28652E6C3D7B7D292C652E6C5B742B735D3D6E2C6E3F693F6E2E753D692E753A286E2E753D446174652E6E6F7728292C652E6164644576656E744C697374656E657228742C733F503A4E2C7329293A652E72656D6F76654576656E744C6973';
wwv_flow_imp.g_varchar2_table(137) := '74656E657228742C733F503A4E2C73293B656C73657B6966286F29743D742E7265706C616365282F786C696E6B28487C3A68292F2C226822292E7265706C616365282F734E616D65242F2C227322293B656C73652069662822776964746822213D3D7426';
wwv_flow_imp.g_varchar2_table(138) := '262268656967687422213D3D742626226872656622213D3D742626226C69737422213D3D74262622666F726D22213D3D74262622746162496E64657822213D3D74262622646F776E6C6F616422213D3D74262622726F775370616E22213D3D7426262263';
wwv_flow_imp.g_varchar2_table(139) := '6F6C5370616E22213D3D74262622726F6C6522213D3D7426267420696E2065297472797B655B745D3D6E756C6C3D3D6E3F22223A6E3B627265616B20657D63617463682865297B7D2266756E6374696F6E223D3D747970656F66206E7C7C286E756C6C3D';
wwv_flow_imp.g_varchar2_table(140) := '3D6E7C7C21313D3D3D6E2626222D22213D3D745B345D3F652E72656D6F76654174747269627574652874293A652E73657441747472696275746528742C6E29297D7D66756E6374696F6E204E2865297B76617220743D746869732E6C5B652E747970652B';
wwv_flow_imp.g_varchar2_table(141) := '21315D3B696628652E74297B696628652E743C3D742E752972657475726E7D656C736520652E743D446174652E6E6F7728293B72657475726E2074286F2E6576656E743F6F2E6576656E742865293A65297D66756E6374696F6E20502865297B72657475';
wwv_flow_imp.g_varchar2_table(142) := '726E20746869732E6C5B652E747970652B21305D286F2E6576656E743F6F2E6576656E742865293A65297D66756E6374696F6E204F28652C742C6E2C692C732C722C612C6C2C632C64297B76617220682C752C702C662C762C622C5F2C432C532C782C6B';
wwv_flow_imp.g_varchar2_table(143) := '2C4C2C442C542C492C4D3D742E747970653B696628766F69642030213D3D742E636F6E7374727563746F722972657475726E206E756C6C3B313238266E2E5F5F75262628633D2121283332266E2E5F5F75292C723D5B6C3D742E5F5F653D6E2E5F5F655D';
wwv_flow_imp.g_varchar2_table(144) := '292C28683D6F2E5F5F62292626682874293B653A6966282266756E6374696F6E223D3D747970656F66204D297472797B696628433D742E70726F70732C533D28683D4D2E636F6E7465787454797065292626695B682E5F5F635D2C783D683F533F532E70';
wwv_flow_imp.g_varchar2_table(145) := '726F70732E76616C75653A682E5F5F3A692C6E2E5F5F633F5F3D28753D742E5F5F633D6E2E5F5F63292E5F5F3D752E5F5F453A282270726F746F7479706522696E204D26264D2E70726F746F747970652E72656E6465723F742E5F5F633D753D6E657720';
wwv_flow_imp.g_varchar2_table(146) := '4D28432C78293A28742E5F5F633D753D6E6577207728432C78292C752E636F6E7374727563746F723D4D2C752E72656E6465723D7A292C532626532E7375622875292C752E70726F70733D432C752E73746174657C7C28752E73746174653D7B7D292C75';
wwv_flow_imp.g_varchar2_table(147) := '2E636F6E746578743D782C752E5F5F6E3D692C703D752E5F5F643D21302C752E5F5F683D5B5D2C752E5F73623D5B5D292C6E756C6C3D3D752E5F5F73262628752E5F5F733D752E7374617465292C6E756C6C213D4D2E6765744465726976656453746174';
wwv_flow_imp.g_varchar2_table(148) := '6546726F6D50726F7073262628752E5F5F733D3D752E7374617465262628752E5F5F733D6D287B7D2C752E5F5F7329292C6D28752E5F5F732C4D2E67657444657269766564537461746546726F6D50726F707328432C752E5F5F732929292C663D752E70';
wwv_flow_imp.g_varchar2_table(149) := '726F70732C763D752E73746174652C752E5F5F763D742C70296E756C6C3D3D4D2E67657444657269766564537461746546726F6D50726F707326266E756C6C213D752E636F6D706F6E656E7457696C6C4D6F756E742626752E636F6D706F6E656E745769';
wwv_flow_imp.g_varchar2_table(150) := '6C6C4D6F756E7428292C6E756C6C213D752E636F6D706F6E656E744469644D6F756E742626752E5F5F682E7075736828752E636F6D706F6E656E744469644D6F756E74293B656C73657B6966286E756C6C3D3D4D2E676574446572697665645374617465';
wwv_flow_imp.g_varchar2_table(151) := '46726F6D50726F7073262643213D3D6626266E756C6C213D752E636F6D706F6E656E7457696C6C5265636569766550726F70732626752E636F6D706F6E656E7457696C6C5265636569766550726F707328432C78292C21752E5F5F652626286E756C6C21';
wwv_flow_imp.g_varchar2_table(152) := '3D752E73686F756C64436F6D706F6E656E74557064617465262621313D3D3D752E73686F756C64436F6D706F6E656E7455706461746528432C752E5F5F732C78297C7C742E5F5F763D3D3D6E2E5F5F7629297B666F7228742E5F5F76213D3D6E2E5F5F76';
wwv_flow_imp.g_varchar2_table(153) := '262628752E70726F70733D432C752E73746174653D752E5F5F732C752E5F5F643D2131292C742E5F5F653D6E2E5F5F652C742E5F5F6B3D6E2E5F5F6B2C742E5F5F6B2E666F7245616368282866756E6374696F6E2865297B65262628652E5F5F3D74297D';
wwv_flow_imp.g_varchar2_table(154) := '29292C6B3D303B6B3C752E5F73622E6C656E6774683B6B2B2B29752E5F5F682E7075736828752E5F73625B6B5D293B752E5F73623D5B5D2C752E5F5F682E6C656E6774682626612E707573682875293B627265616B20657D6E756C6C213D752E636F6D70';
wwv_flow_imp.g_varchar2_table(155) := '6F6E656E7457696C6C5570646174652626752E636F6D706F6E656E7457696C6C55706461746528432C752E5F5F732C78292C6E756C6C213D752E636F6D706F6E656E744469645570646174652626752E5F5F682E70757368282866756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(156) := '7B752E636F6D706F6E656E7444696455706461746528662C762C62297D29297D696628752E636F6E746578743D782C752E70726F70733D432C752E5F5F503D652C752E5F5F653D21312C4C3D6F2E5F5F722C443D302C2270726F746F7479706522696E20';
wwv_flow_imp.g_varchar2_table(157) := '4D26264D2E70726F746F747970652E72656E646572297B666F7228752E73746174653D752E5F5F732C752E5F5F643D21312C4C26264C2874292C683D752E72656E64657228752E70726F70732C752E73746174652C752E636F6E74657874292C543D303B';
wwv_flow_imp.g_varchar2_table(158) := '543C752E5F73622E6C656E6774683B542B2B29752E5F5F682E7075736828752E5F73625B545D293B752E5F73623D5B5D7D656C736520646F7B752E5F5F643D21312C4C26264C2874292C683D752E72656E64657228752E70726F70732C752E7374617465';
wwv_flow_imp.g_varchar2_table(159) := '2C752E636F6E74657874292C752E73746174653D752E5F5F737D7768696C6528752E5F5F6426262B2B443C3235293B752E73746174653D752E5F5F732C6E756C6C213D752E6765744368696C64436F6E74657874262628693D6D286D287B7D2C69292C75';
wwv_flow_imp.g_varchar2_table(160) := '2E6765744368696C64436F6E74657874282929292C707C7C6E756C6C3D3D752E676574536E617073686F744265666F72655570646174657C7C28623D752E676574536E617073686F744265666F726555706461746528662C7629292C4528652C6728493D';
wwv_flow_imp.g_varchar2_table(161) := '6E756C6C213D682626682E747970653D3D3D7926266E756C6C3D3D682E6B65793F682E70726F70732E6368696C6472656E3A68293F493A5B495D2C742C6E2C692C732C722C612C6C2C632C64292C752E626173653D742E5F5F652C742E5F5F75263D2D31';
wwv_flow_imp.g_varchar2_table(162) := '36312C752E5F5F682E6C656E6774682626612E707573682875292C5F262628752E5F5F453D752E5F5F3D6E756C6C297D63617463682865297B742E5F5F763D6E756C6C2C637C7C6E756C6C213D723F28742E5F5F653D6C2C742E5F5F757C3D633F313630';
wwv_flow_imp.g_varchar2_table(163) := '3A33322C725B722E696E6465784F66286C295D3D6E756C6C293A28742E5F5F653D6E2E5F5F652C742E5F5F6B3D6E2E5F5F6B292C6F2E5F5F6528652C742C6E297D656C7365206E756C6C3D3D722626742E5F5F763D3D3D6E2E5F5F763F28742E5F5F6B3D';
wwv_flow_imp.g_varchar2_table(164) := '6E2E5F5F6B2C742E5F5F653D6E2E5F5F65293A742E5F5F653D46286E2E5F5F652C742C6E2C692C732C722C612C632C64293B28683D6F2E646966666564292626682874297D66756E6374696F6E205228652C742C6E297B742E5F5F643D766F696420303B';
wwv_flow_imp.g_varchar2_table(165) := '666F722876617220693D303B693C6E2E6C656E6774683B692B2B2942286E5B695D2C6E5B2B2B695D2C6E5B2B2B695D293B6F2E5F5F6326266F2E5F5F6328742C65292C652E736F6D65282866756E6374696F6E2874297B7472797B653D742E5F5F682C74';
wwv_flow_imp.g_varchar2_table(166) := '2E5F5F683D5B5D2C652E736F6D65282866756E6374696F6E2865297B652E63616C6C2874297D29297D63617463682865297B6F2E5F5F6528652C742E5F5F76297D7D29297D66756E6374696F6E204628652C742C6E2C6F2C732C722C612C6C2C63297B76';
wwv_flow_imp.g_varchar2_table(167) := '617220642C752C702C6D2C762C622C5F2C793D6E2E70726F70732C773D742E70726F70732C533D742E747970653B69662822737667223D3D3D53262628733D2130292C6E756C6C213D7229666F7228643D303B643C722E6C656E6774683B642B2B296966';
wwv_flow_imp.g_varchar2_table(168) := '2828763D725B645D2926262273657441747472696275746522696E20763D3D212153262628533F762E6C6F63616C4E616D653D3D3D533A333D3D3D762E6E6F64655479706529297B653D762C725B645D3D6E756C6C3B627265616B7D6966286E756C6C3D';
wwv_flow_imp.g_varchar2_table(169) := '3D65297B6966286E756C6C3D3D3D532972657475726E20646F63756D656E742E637265617465546578744E6F64652877293B653D733F646F63756D656E742E637265617465456C656D656E744E532822687474703A2F2F7777772E77332E6F72672F3230';
wwv_flow_imp.g_varchar2_table(170) := '30302F737667222C53293A646F63756D656E742E637265617465456C656D656E7428532C772E6973262677292C723D6E756C6C2C6C3D21317D6966286E756C6C3D3D3D5329793D3D3D777C7C6C2626652E646174613D3D3D777C7C28652E646174613D77';
wwv_flow_imp.g_varchar2_table(171) := '293B656C73657B696628723D722626692E63616C6C28652E6368696C644E6F646573292C793D6E2E70726F70737C7C682C216C26266E756C6C213D7229666F7228793D7B7D2C643D303B643C652E617474726962757465732E6C656E6774683B642B2B29';
wwv_flow_imp.g_varchar2_table(172) := '795B28763D652E617474726962757465735B645D292E6E616D655D3D762E76616C75653B666F72286420696E207929763D795B645D2C226368696C6472656E223D3D647C7C282264616E6765726F75736C79536574496E6E657248544D4C223D3D643F70';
wwv_flow_imp.g_varchar2_table(173) := '3D763A226B6579223D3D3D647C7C6420696E20777C7C4128652C642C6E756C6C2C762C7329293B666F72286420696E207729763D775B645D2C226368696C6472656E223D3D643F6D3D763A2264616E6765726F75736C79536574496E6E657248544D4C22';
wwv_flow_imp.g_varchar2_table(174) := '3D3D643F753D763A2276616C7565223D3D643F623D763A22636865636B6564223D3D643F5F3D763A226B6579223D3D3D647C7C6C26262266756E6374696F6E22213D747970656F6620767C7C795B645D3D3D3D767C7C4128652C642C762C795B645D2C73';
wwv_flow_imp.g_varchar2_table(175) := '293B69662875296C7C7C70262628752E5F5F68746D6C3D3D3D702E5F5F68746D6C7C7C752E5F5F68746D6C3D3D3D652E696E6E657248544D4C297C7C28652E696E6E657248544D4C3D752E5F5F68746D6C292C742E5F5F6B3D5B5D3B656C736520696628';
wwv_flow_imp.g_varchar2_table(176) := '70262628652E696E6E657248544D4C3D2222292C4528652C67286D293F6D3A5B6D5D2C742C6E2C6F2C73262622666F726569676E4F626A65637422213D3D532C722C612C723F725B305D3A6E2E5F5F6B262643286E2C30292C6C2C63292C6E756C6C213D';
wwv_flow_imp.g_varchar2_table(177) := '7229666F7228643D722E6C656E6774683B642D2D3B296E756C6C213D725B645D26266628725B645D293B6C7C7C28643D2276616C7565222C766F69642030213D3D6226262862213D3D655B645D7C7C2270726F6772657373223D3D3D53262621627C7C22';
wwv_flow_imp.g_varchar2_table(178) := '6F7074696F6E223D3D3D53262662213D3D795B645D2926264128652C642C622C795B645D2C2131292C643D22636865636B6564222C766F69642030213D3D5F26265F213D3D655B645D26264128652C642C5F2C795B645D2C213129297D72657475726E20';
wwv_flow_imp.g_varchar2_table(179) := '657D66756E6374696F6E204228652C742C6E297B7472797B2266756E6374696F6E223D3D747970656F6620653F652874293A652E63757272656E743D747D63617463682865297B6F2E5F5F6528652C6E297D7D66756E6374696F6E205628652C742C6E29';
wwv_flow_imp.g_varchar2_table(180) := '7B76617220692C733B6966286F2E756E6D6F756E7426266F2E756E6D6F756E742865292C28693D652E72656629262628692E63757272656E742626692E63757272656E74213D3D652E5F5F657C7C4228692C6E756C6C2C7429292C6E756C6C213D28693D';
wwv_flow_imp.g_varchar2_table(181) := '652E5F5F6329297B696628692E636F6D706F6E656E7457696C6C556E6D6F756E74297472797B692E636F6D706F6E656E7457696C6C556E6D6F756E7428297D63617463682865297B6F2E5F5F6528652C74297D692E626173653D692E5F5F503D6E756C6C';
wwv_flow_imp.g_varchar2_table(182) := '2C652E5F5F633D766F696420307D696628693D652E5F5F6B29666F7228733D303B733C692E6C656E6774683B732B2B29695B735D26265628695B735D2C742C6E7C7C2266756E6374696F6E22213D747970656F6620652E74797065293B6E7C7C6E756C6C';
wwv_flow_imp.g_varchar2_table(183) := '3D3D652E5F5F657C7C6628652E5F5F65292C652E5F5F3D652E5F5F653D652E5F5F643D766F696420307D66756E6374696F6E207A28652C742C6E297B72657475726E20746869732E636F6E7374727563746F7228652C6E297D66756E6374696F6E204828';
wwv_flow_imp.g_varchar2_table(184) := '652C742C6E297B76617220732C722C612C6C3B6F2E5F5F26266F2E5F5F28652C74292C723D28733D2266756E6374696F6E223D3D747970656F66206E293F6E756C6C3A6E26266E2E5F5F6B7C7C742E5F5F6B2C613D5B5D2C6C3D5B5D2C4F28742C653D28';
wwv_flow_imp.g_varchar2_table(185) := '217326266E7C7C74292E5F5F6B3D7628792C6E756C6C2C5B655D292C727C7C682C682C766F69642030213D3D742E6F776E6572535647456C656D656E742C217326266E3F5B6E5D3A723F6E756C6C3A742E66697273744368696C643F692E63616C6C2874';
wwv_flow_imp.g_varchar2_table(186) := '2E6368696C644E6F646573293A6E756C6C2C612C217326266E3F6E3A723F722E5F5F653A742E66697273744368696C642C732C6C292C5228612C652C6C297D66756E6374696F6E205728652C74297B4828652C742C57297D66756E6374696F6E206A2865';
wwv_flow_imp.g_varchar2_table(187) := '2C742C6E297B766172206F2C732C722C612C6C3D6D287B7D2C652E70726F7073293B666F72287220696E20652E747970652626652E747970652E64656661756C7450726F7073262628613D652E747970652E64656661756C7450726F7073292C7429226B';
wwv_flow_imp.g_varchar2_table(188) := '6579223D3D723F6F3D745B725D3A22726566223D3D723F733D745B725D3A6C5B725D3D766F696420303D3D3D745B725D2626766F69642030213D3D613F615B725D3A745B725D3B72657475726E20617267756D656E74732E6C656E6774683E322626286C';
wwv_flow_imp.g_varchar2_table(189) := '2E6368696C6472656E3D617267756D656E74732E6C656E6774683E333F692E63616C6C28617267756D656E74732C32293A6E292C6228652E747970652C6C2C6F7C7C652E6B65792C737C7C652E7265662C6E756C6C297D66756E6374696F6E207128652C';
wwv_flow_imp.g_varchar2_table(190) := '74297B766172206E3D7B5F5F633A743D225F5F6343222B642B2B2C5F5F3A652C436F6E73756D65723A66756E6374696F6E28652C74297B72657475726E20652E6368696C6472656E2874297D2C50726F76696465723A66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(191) := '72206E2C693B72657475726E20746869732E6765744368696C64436F6E746578747C7C286E3D5B5D2C28693D7B7D295B745D3D746869732C746869732E6765744368696C64436F6E746578743D66756E6374696F6E28297B72657475726E20697D2C7468';
wwv_flow_imp.g_varchar2_table(192) := '69732E73686F756C64436F6D706F6E656E745570646174653D66756E6374696F6E2865297B746869732E70726F70732E76616C7565213D3D652E76616C756526266E2E736F6D65282866756E6374696F6E2865297B652E5F5F653D21302C782865297D29';
wwv_flow_imp.g_varchar2_table(193) := '297D2C746869732E7375623D66756E6374696F6E2865297B6E2E707573682865293B76617220743D652E636F6D706F6E656E7457696C6C556E6D6F756E743B652E636F6D706F6E656E7457696C6C556E6D6F756E743D66756E6374696F6E28297B6E2E73';
wwv_flow_imp.g_varchar2_table(194) := '706C696365286E2E696E6465784F662865292C31292C742626742E63616C6C2865297D7D292C652E6368696C6472656E7D7D3B72657475726E206E2E50726F76696465722E5F5F3D6E2E436F6E73756D65722E636F6E74657874547970653D6E7D693D75';
wwv_flow_imp.g_varchar2_table(195) := '2E736C6963652C6F3D7B5F5F653A66756E6374696F6E28652C742C6E2C69297B666F7228766172206F2C732C723B743D742E5F5F3B29696628286F3D742E5F5F63292626216F2E5F5F297472797B69662828733D6F2E636F6E7374727563746F72292626';
wwv_flow_imp.g_varchar2_table(196) := '6E756C6C213D732E67657444657269766564537461746546726F6D4572726F722626286F2E736574537461746528732E67657444657269766564537461746546726F6D4572726F72286529292C723D6F2E5F5F64292C6E756C6C213D6F2E636F6D706F6E';
wwv_flow_imp.g_varchar2_table(197) := '656E7444696443617463682626286F2E636F6D706F6E656E74446964436174636828652C697C7C7B7D292C723D6F2E5F5F64292C722972657475726E206F2E5F5F453D6F7D63617463682874297B653D747D7468726F7720657D7D2C733D302C772E7072';
wwv_flow_imp.g_varchar2_table(198) := '6F746F747970652E73657453746174653D66756E6374696F6E28652C74297B766172206E3B6E3D6E756C6C213D746869732E5F5F732626746869732E5F5F73213D3D746869732E73746174653F746869732E5F5F733A746869732E5F5F733D6D287B7D2C';
wwv_flow_imp.g_varchar2_table(199) := '746869732E7374617465292C2266756E6374696F6E223D3D747970656F662065262628653D65286D287B7D2C6E292C746869732E70726F707329292C6526266D286E2C65292C6E756C6C213D652626746869732E5F5F76262628742626746869732E5F73';
wwv_flow_imp.g_varchar2_table(200) := '622E707573682874292C78287468697329297D2C772E70726F746F747970652E666F7263655570646174653D66756E6374696F6E2865297B746869732E5F5F76262628746869732E5F5F653D21302C652626746869732E5F5F682E707573682865292C78';
wwv_flow_imp.g_varchar2_table(201) := '287468697329297D2C772E70726F746F747970652E72656E6465723D792C723D5B5D2C6C3D2266756E6374696F6E223D3D747970656F662050726F6D6973653F50726F6D6973652E70726F746F747970652E7468656E2E62696E642850726F6D6973652E';
wwv_flow_imp.g_varchar2_table(202) := '7265736F6C76652829293A73657454696D656F75742C633D66756E6374696F6E28652C74297B72657475726E20652E5F5F762E5F5F622D742E5F5F762E5F5F627D2C6B2E5F5F723D302C643D307D2C333432313A28652C742C6E293D3E7B227573652073';
wwv_flow_imp.g_varchar2_table(203) := '7472696374223B6E2E722874292C6E2E6428742C7B467261676D656E743A28293D3E692E464B2C6A73783A28293D3E632C6A7378417474723A28293D3E702C6A73784445563A28293D3E632C6A73784573636170653A28293D3E672C6A737854656D706C';
wwv_flow_imp.g_varchar2_table(204) := '6174653A28293D3E642C6A7378733A28293D3E637D293B76617220693D6E2833313034292C6F3D2F5B22263C5D2F3B66756E6374696F6E20732865297B696628303D3D3D652E6C656E6774687C7C21313D3D3D6F2E746573742865292972657475726E20';
wwv_flow_imp.g_varchar2_table(205) := '653B666F722876617220743D302C6E3D302C693D22222C733D22223B6E3C652E6C656E6774683B6E2B2B297B73776974636828652E63686172436F64654174286E29297B636173652033343A733D222671756F743B223B627265616B3B63617365203338';
wwv_flow_imp.g_varchar2_table(206) := '3A733D2226616D703B223B627265616B3B636173652036303A733D22266C743B223B627265616B3B64656661756C743A636F6E74696E75657D6E213D3D74262628692B3D652E736C69636528742C6E29292C692B3D732C743D6E2B317D72657475726E20';
wwv_flow_imp.g_varchar2_table(207) := '6E213D3D74262628692B3D652E736C69636528742C6E29292C697D76617220723D2F616369747C6578283F3A737C677C6E7C707C24297C7270687C677269647C6F77737C6D6E637C6E74777C696E655B63685D7C7A6F6F7C5E6F72647C69746572612F69';
wwv_flow_imp.g_varchar2_table(208) := '2C613D302C6C3D41727261792E697341727261793B66756E6374696F6E206328652C742C6E2C6F2C732C72297B766172206C2C632C643D7B7D3B666F72286320696E20742922726566223D3D633F6C3D745B635D3A645B635D3D745B635D3B7661722068';
wwv_flow_imp.g_varchar2_table(209) := '3D7B747970653A652C70726F70733A642C6B65793A6E2C7265663A6C2C5F5F6B3A6E756C6C2C5F5F3A6E756C6C2C5F5F623A302C5F5F653A6E756C6C2C5F5F643A766F696420302C5F5F633A6E756C6C2C636F6E7374727563746F723A766F696420302C';
wwv_flow_imp.g_varchar2_table(210) := '5F5F763A2D2D612C5F5F693A2D312C5F5F753A302C5F5F736F757263653A732C5F5F73656C663A727D3B6966282266756E6374696F6E223D3D747970656F6620652626286C3D652E64656661756C7450726F70732929666F72286320696E206C29766F69';
wwv_flow_imp.g_varchar2_table(211) := '6420303D3D3D645B635D262628645B635D3D6C5B635D293B72657475726E20692E66462E766E6F64652626692E66462E766E6F64652868292C687D66756E6374696F6E20642865297B76617220743D6328692E464B2C7B74706C3A652C65787072733A5B';
wwv_flow_imp.g_varchar2_table(212) := '5D2E736C6963652E63616C6C28617267756D656E74732C31297D293B72657475726E20742E6B65793D742E5F5F762C747D76617220683D7B7D2C753D2F5B412D5A5D2F673B66756E6374696F6E207028652C74297B696628692E66462E61747472297B76';
wwv_flow_imp.g_varchar2_table(213) := '6172206E3D692E66462E6174747228652C74293B69662822737472696E67223D3D747970656F66206E2972657475726E206E7D69662822726566223D3D3D657C7C226B6579223D3D3D652972657475726E22223B696628227374796C65223D3D3D652626';
wwv_flow_imp.g_varchar2_table(214) := '226F626A656374223D3D747970656F662074297B766172206F3D22223B666F7228766172206120696E2074297B766172206C3D745B615D3B6966286E756C6C213D6C26262222213D3D6C297B76617220633D222D223D3D615B305D3F613A685B615D7C7C';
wwv_flow_imp.g_varchar2_table(215) := '28685B615D3D612E7265706C61636528752C222D242622292E746F4C6F776572436173652829292C643D223B223B226E756D62657222213D747970656F66206C7C7C632E7374617274735769746828222D2D22297C7C722E746573742863297C7C28643D';
wwv_flow_imp.g_varchar2_table(216) := '2270783B22292C6F3D6F2B632B223A222B6C2B647D7D72657475726E20652B273D22272B6F2B2722277D72657475726E206E756C6C3D3D747C7C21313D3D3D747C7C2266756E6374696F6E223D3D747970656F6620747C7C226F626A656374223D3D7479';
wwv_flow_imp.g_varchar2_table(217) := '70656F6620743F22223A21303D3D3D743F653A652B273D22272B732874292B2722277D66756E6374696F6E20672865297B6966286E756C6C3D3D657C7C22626F6F6C65616E223D3D747970656F6620657C7C2266756E6374696F6E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(218) := '20652972657475726E206E756C6C3B696628226F626A656374223D3D747970656F662065297B696628766F696420303D3D3D652E636F6E7374727563746F722972657475726E20653B6966286C286529297B666F722876617220743D303B743C652E6C65';
wwv_flow_imp.g_varchar2_table(219) := '6E6774683B742B2B29655B745D3D6728655B745D293B72657475726E20657D7D72657475726E20732822222B65297D7D2C393838323A28652C742C6E293D3E7B2275736520737472696374223B6E2E722874292C6E2E6428742C7B676574506172656E74';
wwv_flow_imp.g_varchar2_table(220) := '3A28293D3E722C69733A28293D3E6F2E69732C6973416E793A28293D3E6F2E6973416E792C6973446972656374696F6E486F72697A6F6E74616C3A28293D3E617D293B76617220693D6E2839393035292C6F3D6E2839313932292C733D6E283131303229';
wwv_flow_imp.g_varchar2_table(221) := '3B66756E6374696F6E207228652C74297B666F722828302C692E4B6729287429262628743D5B745D293B653D652E706172656E743B2969662828302C6F2E6973416E792928652C74292972657475726E20653B72657475726E206E756C6C7D66756E6374';
wwv_flow_imp.g_varchar2_table(222) := '696F6E20612865297B76617220743D5B2262706D6E3A5061727469636970616E74222C2262706D6E3A4C616E65225D2C6E3D7228652C74293B72657475726E206E3F28302C732E246229286E293A2128302C6F2E6973416E792928652C74297C7C28302C';
wwv_flow_imp.g_varchar2_table(223) := '732E2462292865297D7D2C313130323A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B24623A28293D3E722C41763A28293D3E732C474D3A28293D3E642C49703A28293D3E632C51313A28293D3E6C2C66503A28293D3E752C';
wwv_flow_imp.g_varchar2_table(224) := '6F683A28293D3E612C70683A28293D3E687D293B76617220693D6E2839313932292C6F3D6E2839393035293B66756E6374696F6E207328652C74297B72657475726E2128302C692E69732928652C2262706D6E3A43616C6C416374697669747922292626';
wwv_flow_imp.g_varchar2_table(225) := '2828302C692E69732928652C2262706D6E3A53756250726F6365737322293F21282128743D747C7C28302C692E676574446929286529297C7C2128302C692E69732928742C2262706D6E64693A42504D4E506C616E652229297C7C7426262121742E6973';
wwv_flow_imp.g_varchar2_table(226) := '457870616E6465643A2128302C692E69732928652C2262706D6E3A5061727469636970616E7422297C7C212128302C692E676574427573696E6573734F626A656374292865292E70726F63657373526566297D66756E6374696F6E20722865297B696628';
wwv_flow_imp.g_varchar2_table(227) := '28302C692E69732928652C2262706D6E3A5061727469636970616E7422297C7C28302C692E69732928652C2262706D6E3A4C616E652229297B76617220743D28302C692E6765744469292865292E6973486F72697A6F6E74616C3B72657475726E20766F';
wwv_flow_imp.g_varchar2_table(228) := '696420303D3D3D747C7C747D7D66756E6374696F6E20612865297B72657475726E206526262131213D3D28302C692E676574427573696E6573734F626A656374292865292E6973496E74657272757074696E677D66756E6374696F6E206C2865297B7265';
wwv_flow_imp.g_varchar2_table(229) := '7475726E20652626212128302C692E676574427573696E6573734F626A656374292865292E74726967676572656442794576656E747D66756E6374696F6E206328652C74297B766172206E3D28302C692E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(230) := '65292E6576656E74446566696E6974696F6E733B72657475726E28302C6F2E7A4E29286E2C2866756E6374696F6E2865297B72657475726E28302C692E69732928652C74297D29297D66756E6374696F6E20642865297B72657475726E206328652C2262';
wwv_flow_imp.g_varchar2_table(231) := '706D6E3A4572726F724576656E74446566696E6974696F6E22297D66756E6374696F6E20682865297B72657475726E206328652C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E22297D66756E6374696F6E20752865297B';
wwv_flow_imp.g_varchar2_table(232) := '72657475726E206328652C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22297D7D2C393139323A28652C742C6E293D3E7B2275736520737472696374223B6E2E722874292C6E2E6428742C7B676574427573696E657373';
wwv_flow_imp.g_varchar2_table(233) := '4F626A6563743A28293D3E722C67657444693A28293D3E612C69733A28293D3E6F2C6973416E793A28293D3E737D293B76617220693D6E2839393035293B66756E6374696F6E206F28652C74297B766172206E3D722865293B72657475726E206E262622';
wwv_flow_imp.g_varchar2_table(234) := '66756E6374696F6E223D3D747970656F66206E2E24696E7374616E63654F6626266E2E24696E7374616E63654F662874297D66756E6374696F6E207328652C74297B72657475726E28302C692E7A4E2928742C2866756E6374696F6E2874297B72657475';
wwv_flow_imp.g_varchar2_table(235) := '726E206F28652C74297D29297D66756E6374696F6E20722865297B72657475726E20652626652E627573696E6573734F626A6563747C7C657D66756E6374696F6E20612865297B72657475726E20652626652E64697D7D2C373335373A28652C742C6E29';
wwv_flow_imp.g_varchar2_table(236) := '3D3E7B636F6E737420693D6E2832323531293B652E6578706F7274733D7B4C696E7465723A697D7D2C323235313A28652C742C6E293D3E7B636F6E737420693D6E2831393030292C6F3D7B303A226F6666222C313A227761726E222C323A226572726F72';
wwv_flow_imp.g_varchar2_table(237) := '222C333A22696E666F227D3B66756E6374696F6E207328653D7B7D297B636F6E73747B636F6E6669673A742C7265736F6C7665723A6E7D3D653B696628766F696420303D3D3D6E297468726F77206E6577204572726F7228226D7573742070726F766964';
wwv_flow_imp.g_varchar2_table(238) := '65203C6F7074696F6E732E7265736F6C7665723E22293B746869732E636F6E6669673D742C746869732E7265736F6C7665723D6E2C746869732E63616368656452756C65733D7B7D2C746869732E636163686564436F6E666967733D7B7D7D66756E6374';
wwv_flow_imp.g_varchar2_table(239) := '696F6E20722865297B72657475726E2262706D6E6C696E74223D3D3D653F2262706D6E6C696E74223A652E73746172747357697468282262706D6E6C696E742D706C7567696E2D22293F653A6062706D6E6C696E742D706C7567696E2D247B657D607D65';
wwv_flow_imp.g_varchar2_table(240) := '2E6578706F7274733D732C732E70726F746F747970652E6170706C7952756C653D66756E6374696F6E28652C74297B636F6E73747B636F6E6669673A6E2C72756C653A6F2C63617465676F72793A732C6E616D653A727D3D743B7472797B72657475726E';
wwv_flow_imp.g_varchar2_table(241) := '2069287B6D6F64646C65526F6F743A652C72756C653A6F2C636F6E6669673A6E7D292E6D6170282866756E6374696F6E2865297B72657475726E7B2E2E2E652C63617465676F72793A737D7D29297D63617463682865297B72657475726E20636F6E736F';
wwv_flow_imp.g_varchar2_table(242) := '6C652E6572726F72282272756C65203C222B722B223E206661696C65642077697468206572726F723A20222C65292C5B7B6D6573736167653A652E6D6573736167652C63617465676F72793A2272756C652D6572726F72227D5D7D7D2C732E70726F746F';
wwv_flow_imp.g_varchar2_table(243) := '747970652E7265736F6C766552756C653D66756E6374696F6E28652C74297B636F6E73747B706B673A6E2C72756C654E616D653A697D3D746869732E706172736552756C654E616D652865292C6F3D60247B6E7D2D247B697D602C733D746869732E6361';
wwv_flow_imp.g_varchar2_table(244) := '6368656452756C65735B6F5D3B72657475726E20733F50726F6D6973652E7265736F6C76652873293A50726F6D6973652E7265736F6C766528746869732E7265736F6C7665722E7265736F6C766552756C65286E2C6929292E7468656E28286E3D3E7B69';
wwv_flow_imp.g_varchar2_table(245) := '6628216E297468726F77206E6577204572726F722860756E6B6E6F776E2072756C65203C247B657D3E60293B72657475726E20746869732E63616368656452756C65735B6F5D3D6E2874297D29297D2C732E70726F746F747970652E7265736F6C766543';
wwv_flow_imp.g_varchar2_table(246) := '6F6E6669673D66756E6374696F6E2865297B636F6E73747B706B673A742C636F6E6669674E616D653A6E7D3D746869732E7061727365436F6E6669674E616D652865292C693D60247B747D2D247B6E7D602C6F3D746869732E636163686564436F6E6669';
wwv_flow_imp.g_varchar2_table(247) := '67735B695D3B72657475726E206F3F50726F6D6973652E7265736F6C7665286F293A50726F6D6973652E7265736F6C766528746869732E7265736F6C7665722E7265736F6C7665436F6E66696728742C6E29292E7468656E28286E3D3E7B696628216E29';
wwv_flow_imp.g_varchar2_table(248) := '7468726F77206E6577204572726F722860756E6B6E6F776E20636F6E666967203C247B657D3E60293B72657475726E20746869732E636163686564436F6E666967735B695D3D746869732E6E6F726D616C697A65436F6E666967286E2C74297D29297D2C';
wwv_flow_imp.g_varchar2_table(249) := '732E70726F746F747970652E7265736F6C766552756C65733D66756E6374696F6E2865297B72657475726E20746869732E7265736F6C7665436F6E6669677572656452756C65732865292E7468656E2828653D3E7B636F6E737420743D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(250) := '656E74726965732865292E6D61702828285B652C745D293D3E7B636F6E73747B63617465676F72793A6E2C636F6E6669673A697D3D746869732E706172736552756C6556616C75652874293B72657475726E7B6E616D653A652C63617465676F72793A6E';
wwv_flow_imp.g_varchar2_table(251) := '2C636F6E6669673A697D7D29292C6E3D742E66696C7465722828653D3E226F666622213D3D652E63617465676F727929292E6D61702828653D3E7B636F6E73747B6E616D653A742C636F6E6669673A6E7D3D653B72657475726E20746869732E7265736F';
wwv_flow_imp.g_varchar2_table(252) := '6C766552756C6528742C6E292E7468656E282866756E6374696F6E2874297B72657475726E7B2E2E2E652C72756C653A747D7D29297D29293B72657475726E2050726F6D6973652E616C6C286E297D29297D2C732E70726F746F747970652E7265736F6C';
wwv_flow_imp.g_varchar2_table(253) := '7665436F6E6669677572656452756C65733D66756E6374696F6E2865297B6C657420743D652E657874656E64733B72657475726E22737472696E67223D3D747970656F662074262628743D5B745D292C766F696420303D3D3D74262628743D5B5D292C50';
wwv_flow_imp.g_varchar2_table(254) := '726F6D6973652E616C6C28742E6D61702828653D3E746869732E7265736F6C7665436F6E6669672865292E7468656E2828653D3E746869732E7265736F6C7665436F6E6669677572656452756C657328652929292929292E7468656E2828743D3E5B2E2E';
wwv_flow_imp.g_varchar2_table(255) := '2E742C746869732E6E6F726D616C697A65436F6E66696728652C2262706D6E6C696E7422292E72756C65735D2E726564756365282828652C74293D3E287B2E2E2E652C2E2E2E747D29292C7B7D2929297D2C732E70726F746F747970652E6C696E743D66';
wwv_flow_imp.g_varchar2_table(256) := '756E6374696F6E28652C74297B72657475726E20743D747C7C746869732E636F6E6669672C746869732E7265736F6C766552756C65732874292E7468656E2828743D3E7B636F6E7374206E3D7B7D3B72657475726E20742E666F72456163682828743D3E';
wwv_flow_imp.g_varchar2_table(257) := '7B636F6E73747B6E616D653A697D3D742C6F3D746869732E6170706C7952756C6528652C74293B6F2E6C656E6774682626286E5B695D3D6F297D29292C6E7D29297D2C732E70726F746F747970652E706172736552756C6556616C75653D66756E637469';
wwv_flow_imp.g_varchar2_table(258) := '6F6E2865297B6C657420742C6E3B72657475726E2041727261792E697341727261792865293F28743D655B305D2C6E3D655B315D293A28743D652C6E3D7B7D292C22737472696E67223D3D747970656F662074262628743D742E746F4C6F776572436173';
wwv_flow_imp.g_varchar2_table(259) := '652829292C743D6F5B745D7C7C742C7B636F6E6669673A6E2C63617465676F72793A747D7D2C732E70726F746F747970652E706172736552756C654E616D653D66756E6374696F6E28652C743D2262706D6E6C696E7422297B636F6E7374206E3D2F5E28';
wwv_flow_imp.g_varchar2_table(260) := '3F3A283F3A28405B5E2F5D2B295C2F293F285B5E405D7B317D5B5E2F5D2A295C2F293F285B5E2F5D2B29242F2E657865632865293B696628216E297468726F77206E6577204572726F722860756E706172736561626C652072756C65206E616D65203C24';
wwv_flow_imp.g_varchar2_table(261) := '7B657D3E60293B636F6E73745B692C6F2C732C615D3D6E3B72657475726E20733F7B706B673A60247B6F3F6F2B222F223A22227D247B722873297D602C72756C654E616D653A617D3A7B706B673A742C72756C654E616D653A617D7D2C732E70726F746F';
wwv_flow_imp.g_varchar2_table(262) := '747970652E7061727365436F6E6669674E616D653D66756E6374696F6E2865297B636F6E737420743D2F5E283F3A283F3A706C7567696E3A283F3A28405B5E2F5D2B295C2F293F285B5E405D7B317D5B5E2F5D2A295C2F297C62706D6E6C696E743A2928';
wwv_flow_imp.g_varchar2_table(263) := '5B5E2F5D2B29242F2E657865632865293B6966282174297468726F77206E6577204572726F722860756E706172736561626C6520636F6E666967206E616D65203C247B657D3E60293B636F6E73745B6E2C692C6F2C735D3D743B72657475726E206F3F7B';
wwv_flow_imp.g_varchar2_table(264) := '706B673A60247B693F692B222F223A22227D247B72286F297D602C636F6E6669674E616D653A737D3A7B706B673A2262706D6E6C696E74222C636F6E6669674E616D653A737D7D2C732E70726F746F747970652E67657453696D706C655061636B616765';
wwv_flow_imp.g_varchar2_table(265) := '4E616D653D66756E6374696F6E2865297B636F6E737420743D2F5E283F3A28405B5E2F5D2B295C2F293F285B5E2F5D2B29242F2E657865632865293B6966282174297468726F77206E6577204572726F722860756E706172736561626C65207061636B61';
wwv_flow_imp.g_varchar2_table(266) := '6765206E616D65203C247B657D3E60293B636F6E73745B6E2C692C6F5D3D743B72657475726E60247B693F692B222F223A22227D247B733D6F2C732E73746172747357697468282262706D6E6C696E742D706C7567696E2D22293F732E73756273747269';
wwv_flow_imp.g_varchar2_table(267) := '6E67283136293A737D603B76617220737D2C732E70726F746F747970652E6E6F726D616C697A65436F6E6669673D66756E6374696F6E28652C74297B636F6E7374206E3D652E72756C65737C7C7B7D2C693D4F626A6563742E6B657973286E292E726564';
wwv_flow_imp.g_varchar2_table(268) := '756365282828652C69293D3E7B636F6E7374206F3D6E5B695D2C7B706B673A732C72756C654E616D653A727D3D746869732E706172736552756C654E616D6528692C74293B72657475726E20655B2262706D6E6C696E74223D3D3D733F723A60247B7468';
wwv_flow_imp.g_varchar2_table(269) := '69732E67657453696D706C655061636B6167654E616D652873297D2F247B727D605D3D6F2C657D292C7B7D293B72657475726E7B2E2E2E652C72756C65733A697D7D7D2C313930303A28652C742C6E293D3E7B636F6E737420693D6E2831393331292C7B';
wwv_flow_imp.g_varchar2_table(270) := '697341727261793A6F2C69734F626A6563743A737D3D6E28363033293B636C61737320727B636F6E7374727563746F72287B6D6F64646C65526F6F743A652C72756C653A747D297B746869732E72756C653D742C746869732E6D6F64646C65526F6F743D';
wwv_flow_imp.g_varchar2_table(271) := '652C746869732E6D657373616765733D5B5D2C746869732E7265706F72743D746869732E7265706F72742E62696E642874686973297D7265706F727428652C742C6E297B6C657420693D7B69643A652C6D6573736167653A747D3B6E26266F286E292626';
wwv_flow_imp.g_varchar2_table(272) := '28693D7B2E2E2E692C706174683A6E7D292C6E262673286E29262628693D7B2E2E2E692C2E2E2E6E7D292C746869732E6D657373616765732E707573682869297D7D652E6578706F7274733D66756E6374696F6E287B6D6F64646C65526F6F743A652C72';
wwv_flow_imp.g_varchar2_table(273) := '756C653A747D297B636F6E7374206E3D6E65772072287B72756C653A742C6D6F64646C65526F6F743A657D292C6F3D742E636865636B2C733D6F26266F2E656E7465727C7C6F2C613D6F26266F2E6C656176653B696628217326262161297468726F7720';
wwv_flow_imp.g_varchar2_table(274) := '6E6577204572726F7228226E6F20636865636B20696D706C656D656E74656422293B72657475726E206928652C7B656E7465723A733F653D3E7328652C6E293A6E756C6C2C6C656176653A613F653D3E6128652C6E293A6E756C6C7D292C6E2E6D657373';
wwv_flow_imp.g_varchar2_table(275) := '616765737D7D2C313933313A653D3E7B652E6578706F7274733D66756E6374696F6E206528742C6E297B636F6E737420693D6E2E656E7465727C7C6E756C6C2C6F3D6E2E6C656176657C7C6E756C6C2C733D692626692874292C723D742E246465736372';
wwv_flow_imp.g_varchar2_table(276) := '6970746F723B21313D3D3D737C7C722E697347656E657269637C7C722E70726F706572746965732E66696C7465722828653D3E21652E697341747472262621652E69735265666572656E6365262622537472696E6722213D3D652E7479706529292E666F';
wwv_flow_imp.g_varchar2_table(277) := '72456163682828693D3E7B696628692E6E616D6520696E2074297B636F6E7374206F3D745B692E6E616D655D3B692E69734D616E793F6F2E666F72456163682828743D3E7B6528742C6E297D29293A65286F2C6E297D7D29292C6F26266F2874297D7D2C';
wwv_flow_imp.g_varchar2_table(278) := '3230373A28652C742C6E293D3E7B636F6E73747B69733A692C6973416E793A6F7D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B6966286F28652C5B2262';
wwv_flow_imp.g_varchar2_table(279) := '706D6E3A50726F63657373222C2262706D6E3A53756250726F63657373225D2926262166756E6374696F6E2865297B72657475726E28652E666C6F77456C656D656E74737C7C5B5D292E736F6D652828653D3E6928652C2262706D6E3A456E644576656E';
wwv_flow_imp.g_varchar2_table(280) := '74222929297D286529297B636F6E7374206E3D6928652C2262706D6E3A53756250726F6365737322293F225375622070726F63657373223A2250726F63657373223B742E7265706F727428652E69642C6E2B22206973206D697373696E6720656E642065';
wwv_flow_imp.g_varchar2_table(281) := '76656E7422297D7D7D7D7D2C363539393A28652C742C6E293D3E7B636F6E73747B69733A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B6928652C22';
wwv_flow_imp.g_varchar2_table(282) := '62706D6E3A53756250726F6365737322292626652E74726967676572656442794576656E74262628652E666C6F77456C656D656E74737C7C5B5D292E666F7245616368282866756E6374696F6E2865297B696628216928652C2262706D6E3A5374617274';
wwv_flow_imp.g_varchar2_table(283) := '4576656E7422292972657475726E21313B303D3D3D28652E6576656E74446566696E6974696F6E737C7C5B5D292E6C656E6774682626742E7265706F727428652E69642C225374617274206576656E74206973206D697373696E67206576656E74206465';
wwv_flow_imp.g_varchar2_table(284) := '66696E6974696F6E222C5B226576656E74446566696E6974696F6E73225D297D29297D7D7D7D2C353238393A28652C742C6E293D3E7B636F6E73747B6973416E793A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(285) := '7475726E7B636865636B3A66756E6374696F6E28652C74297B6928652C5B2262706D6E3A4163746976697479222C2262706D6E3A4576656E74225D29262628652E696E636F6D696E677C7C5B5D292E6C656E6774683E312626742E7265706F727428652E';
wwv_flow_imp.g_varchar2_table(286) := '69642C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E22297D7D7D7D2C323334323A28652C742C6E293D3E7B636F6E73747B6973416E793A692C69733A6F7D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(287) := '7B72657475726E7B636865636B3A66756E6374696F6E28652C74297B696628216F28652C2262706D6E3A446566696E6974696F6E7322292972657475726E21313B636F6E7374206E3D652E726F6F74456C656D656E74732E66696C7465722828653D3E69';
wwv_flow_imp.g_varchar2_table(288) := '28652C5B2262706D6E3A4572726F72222C2262706D6E3A457363616C6174696F6E222C2262706D6E3A4D657373616765222C2262706D6E3A5369676E616C225D2929292C733D66756E6374696F6E2865297B636F6E737420743D5B5D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(289) := '66756E6374696F6E2065286E297B6E2E726F6F74456C656D656E747326266E2E726F6F74456C656D656E74732E666F72456163682865292C6E2E666C6F77456C656D656E747326266E2E666C6F77456C656D656E74732E666F72456163682865292C6E2E';
wwv_flow_imp.g_varchar2_table(290) := '6576656E74446566696E6974696F6E7326266E2E6576656E74446566696E6974696F6E732E666F72456163682828653D3E742E7075736828652929297D2865292C747D2865293B6E2E666F72456163682828653D3E7B2866756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(291) := '657475726E2222213D3D652E6E616D653F2E7472696D28297D292865297C7C742E7265706F727428652E69642C22456C656D656E74206973206D697373696E67206E616D6522292C66756E6374696F6E28652C74297B72657475726E206F28652C226270';
wwv_flow_imp.g_varchar2_table(292) := '6D6E3A4572726F7222293F742E736F6D652828743D3E6F28742C2262706D6E3A4572726F724576656E74446566696E6974696F6E22292626652E69643D3D3D742E6572726F725265663F2E696429293A6F28652C2262706D6E3A457363616C6174696F6E';
wwv_flow_imp.g_varchar2_table(293) := '22293F742E736F6D652828743D3E6F28742C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E22292626652E69643D3D3D742E657363616C6174696F6E5265663F2E696429293A6F28652C2262706D6E3A4D65737361676522';
wwv_flow_imp.g_varchar2_table(294) := '293F742E736F6D652828743D3E6F28742C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22292626652E69643D3D3D742E6D6573736167655265663F2E696429293A6F28652C2262706D6E3A5369676E616C22293F742E736F6D65';
wwv_flow_imp.g_varchar2_table(295) := '2828743D3E6F28742C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E22292626652E69643D3D3D742E7369676E616C5265663F2E696429293A766F696420307D28652C73297C7C742E7265706F727428652E69642C22456C656D656E';
wwv_flow_imp.g_varchar2_table(296) := '7420697320756E7573656422292C66756E6374696F6E28652C74297B72657475726E20313D3D3D742E66696C7465722828743D3E6F28742C652E2474797065292626652E6E616D653D3D3D742E6E616D6529292E6C656E6774687D28652C6E297C7C742E';
wwv_flow_imp.g_varchar2_table(297) := '7265706F727428652E69642C22456C656D656E74206E616D65206973206E6F7420756E6971756522297D29297D7D7D7D2C383439373A28652C742C6E293D3E7B636F6E73747B69733A697D3D6E2832323332293B652E6578706F7274732E593D66756E63';
wwv_flow_imp.g_varchar2_table(298) := '74696F6E2865297B72657475726E2066756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28742C6E297B6928742C652926266E2E7265706F727428742E69642C22456C656D656E742068617320646973616C6C6F7765642074';
wwv_flow_imp.g_varchar2_table(299) := '797065203C222B652B223E22297D7D7D7D7D2C333135373A28652C742C6E293D3E7B636F6E73747B69733A692C6973416E793A6F7D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E63';
wwv_flow_imp.g_varchar2_table(300) := '74696F6E28652C74297B6F28652C5B2262706D6E3A506172616C6C656C47617465776179222C2262706D6E3A4576656E74426173656447617465776179225D297C7C6928652C2262706D6E3A47617465776179222926262166756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(301) := '72657475726E28652E6F7574676F696E677C7C5B5D292E6C656E6774683E317D2865297C7C6928652C2262706D6E3A426F756E646172794576656E7422297C7C6928652C2262706D6E3A53756250726F6365737322297C7C6928652C2262706D6E3A5365';
wwv_flow_imp.g_varchar2_table(302) := '7175656E6365466C6F77222926262166756E6374696F6E2865297B72657475726E20652E636F6E646974696F6E45787072657373696F6E7D2865297C7C216F28652C5B2262706D6E3A466C6F774E6F6465222C2262706D6E3A53657175656E6365466C6F';
wwv_flow_imp.g_varchar2_table(303) := '77222C2262706D6E3A5061727469636970616E74222C2262706D6E3A4C616E65225D297C7C303D3D3D28652E6E616D657C7C2222292E7472696D28292E6C656E6774682626742E7265706F727428652E69642C22456C656D656E74206973206D69737369';
wwv_flow_imp.g_varchar2_table(304) := '6E67206C6162656C2F6E616D65222C5B226E616D65225D297D7D7D7D2C383234343A28652C742C6E293D3E7B636F6E73747B67726F757042793A697D3D6E28363033292C7B69733A6F7D3D6E2832323332293B66756E6374696F6E20732865297B766172';
wwv_flow_imp.g_varchar2_table(305) := '20743D652E6576656E74446566696E6974696F6E737C7C5B5D3B72657475726E21216F28652C2262706D6E3A4576656E7422292626742E736F6D652828653D3E6F28652C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E222929297D6675';
wwv_flow_imp.g_varchar2_table(306) := '6E6374696F6E20722865297B72657475726E206F28652C2262706D6E3A5468726F774576656E7422297D66756E6374696F6E20612865297B72657475726E206F28652C2262706D6E3A43617463684576656E7422297D652E6578706F7274733D66756E63';
wwv_flow_imp.g_varchar2_table(307) := '74696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B696628216F28652C2262706D6E3A466C6F77456C656D656E7473436F6E7461696E657222292972657475726E3B636F6E7374206E3D28652E666C6F77456C656D656E';
wwv_flow_imp.g_varchar2_table(308) := '74737C7C5B5D292E66696C7465722873293B666F7228636F6E73742065206F66206E29652E6E616D657C7C742E7265706F727428652E69642C224C696E6B206576656E74206973206D697373696E67206E616D6522293B636F6E7374206C3D69286E2C28';
wwv_flow_imp.g_varchar2_table(309) := '653D3E652E6E616D6529293B666F7228636F6E73745B652C6E5D6F66204F626A6563742E656E7472696573286C29297B696628216529636F6E74696E75653B696628313D3D3D6E2E6C656E677468297B636F6E737420693D6E5B305D3B742E7265706F72';
wwv_flow_imp.g_varchar2_table(310) := '7428692E69642C604C696E6B20247B722869293F226361746368223A227468726F77227D206576656E742077697468206E616D65203C247B657D3E206D697373696E6720696E2073636F706560297D636F6E737420693D6E2E66696C7465722872293B69';
wwv_flow_imp.g_varchar2_table(311) := '6628692E6C656E6774683E3129666F7228636F6E7374206E206F66206929742E7265706F7274286E2E69642C604475706C6963617465206C696E6B207468726F77206576656E742077697468206E616D65203C247B657D3E20696E2073636F706560293B';
wwv_flow_imp.g_varchar2_table(312) := '636F6E7374206F3D6E2E66696C7465722861293B6966286F2E6C656E6774683E3129666F7228636F6E7374206E206F66206F29742E7265706F7274286E2E69642C604475706C6963617465206C696E6B206361746368206576656E742077697468206E61';
wwv_flow_imp.g_varchar2_table(313) := '6D65203C247B657D3E20696E2073636F706560297D7D7D7D7D2C393737373A28652C742C6E293D3E7B636F6E73747B69733A697D3D6E2832323332292C7B666C617474656E3A6F7D3D6E28363033293B66756E6374696F6E20732865297B72657475726E';
wwv_flow_imp.g_varchar2_table(314) := '206F28652E6D61702828653D3E7B636F6E737420743D652E6C616E65536574732626652E6C616E65536574735B305D7C7C652E6368696C644C616E655365742C6E3D6F285B5D2E636F6E63617428652E666C6F77456C656D656E74737C7C5B5D2C652E66';
wwv_flow_imp.g_varchar2_table(315) := '6C6F77456C656D656E747326267328652E666C6F77456C656D656E74732E66696C746572286129297C7C5B5D2C652E7061727469636970616E74737C7C5B5D2C652E6172746966616374737C7C5B5D2C742626742E6C616E65737C7C5B5D2C742626742E';
wwv_flow_imp.g_varchar2_table(316) := '6C616E657326267328742E6C616E65732E66696C746572286C29297C7C5B5D2C652E6D657373616765466C6F77737C7C5B5D29293B72657475726E206E2E6C656E6774683E303F6E2E6D61702828653D3E287B69643A652E69642C24747970653A652E24';
wwv_flow_imp.g_varchar2_table(317) := '747970657D2929293A5B5D7D2929297D66756E6374696F6E20722865297B72657475726E215B2262706D6E3A446174614F626A656374225D2E696E636C7564657328652E2474797065297D66756E6374696F6E20612865297B72657475726E2121652E66';
wwv_flow_imp.g_varchar2_table(318) := '6C6F77456C656D656E74737D66756E6374696F6E206C2865297B72657475726E2121652E6368696C644C616E655365747D652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B696628';
wwv_flow_imp.g_varchar2_table(319) := '216928652C2262706D6E3A446566696E6974696F6E7322292972657475726E21313B636F6E7374206E3D7328652E726F6F74456C656D656E7473292E66696C7465722872292C613D6F28652E6469616772616D732E6D61702828653D3E28652E706C616E';
wwv_flow_imp.g_varchar2_table(320) := '652E706C616E65456C656D656E747C7C5B5D292E6D61702828653D3E652E62706D6E456C656D656E742E696429292929293B6E2E666F72456163682828653D3E7B2D313D3D3D612E696E6465784F6628652E6964292626742E7265706F727428652E6964';
wwv_flow_imp.g_varchar2_table(321) := '2C22456C656D656E74206973206D697373696E672062706D6E646922297D29297D7D7D7D2C3138383A28652C742C6E293D3E7B636F6E737420693D6E2838343937292E593B652E6578706F7274733D69282262706D6E3A436F6D706C6578476174657761';
wwv_flow_imp.g_varchar2_table(322) := '7922297D2C353932343A28652C742C6E293D3E7B636F6E73747B6973416E793A692C69733A6F7D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B69662821';
wwv_flow_imp.g_varchar2_table(323) := '6928652C5B2262706D6E3A5461736B222C2262706D6E3A47617465776179222C2262706D6E3A53756250726F63657373222C2262706D6E3A4576656E74225D297C7C652E74726967676572656442794576656E742972657475726E3B69662866756E6374';
wwv_flow_imp.g_varchar2_table(324) := '696F6E2865297B76617220743D66756E6374696F6E2865297B76617220743D652E6576656E74446566696E6974696F6E733B72657475726E21216F28652C2262706D6E3A426F756E646172794576656E742229262628212821747C7C31213D3D742E6C65';
wwv_flow_imp.g_varchar2_table(325) := '6E6774682926266F28745B305D2C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E2229297D2865292C6E3D66756E6374696F6E2865297B72657475726E20652E6973466F72436F6D70656E736174696F6E7D2865293B7265';
wwv_flow_imp.g_varchar2_table(326) := '7475726E20747C7C6E7D2865292972657475726E3B636F6E7374206E3D652E696E636F6D696E677C7C5B5D2C733D652E6F7574676F696E677C7C5B5D3B6E2E6C656E6774687C7C732E6C656E6774687C7C742E7265706F727428652E69642C22456C656D';
wwv_flow_imp.g_varchar2_table(327) := '656E74206973206E6F7420636F6E6E656374656422297D7D7D7D2C3731343A28652C742C6E293D3E7B636F6E73747B69733A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B636F6E737420653D7B7D2C743D7B7D2C6E3D';
wwv_flow_imp.g_varchar2_table(328) := '7B7D3B72657475726E7B636865636B3A66756E6374696F6E286F2C73297B6966282169286F2C2262706D6E3A53657175656E6365466C6F7722292972657475726E3B636F6E737420723D66756E6374696F6E2865297B636F6E737420743D652E636F6E64';
wwv_flow_imp.g_varchar2_table(329) := '6974696F6E45787072657373696F6E2C6E3D743F742E626F64793A22223B72657475726E28652E736F757263655265663F652E736F757263655265662E69643A652E6964292B2223222B28652E7461726765745265663F652E7461726765745265662E69';
wwv_flow_imp.g_varchar2_table(330) := '643A652E6964292B2223222B6E7D286F293B6966287220696E2065297B732E7265706F7274286F2E69642C2253657175656E6365466C6F772069732061206475706C696361746522293B636F6E737420653D6F2E736F757263655265662E69642C693D6F';
wwv_flow_imp.g_varchar2_table(331) := '2E7461726765745265662E69643B745B655D7C7C28732E7265706F727428652C224475706C6963617465206F7574676F696E672073657175656E636520666C6F777322292C745B655D3D2130292C6E5B695D7C7C28732E7265706F727428692C22447570';
wwv_flow_imp.g_varchar2_table(332) := '6C696361746520696E636F6D696E672073657175656E636520666C6F777322292C6E5B695D3D2130297D656C736520655B725D3D6F7D7D7D7D2C393433363A28652C742C6E293D3E7B636F6E73747B69733A692C6973416E793A6F7D3D6E283232333229';
wwv_flow_imp.g_varchar2_table(333) := '3B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B6F28652C5B2262706D6E3A4576656E74222C2262706D6E3A4163746976697479222C2262706D6E3A47617465776179225D2926';
wwv_flow_imp.g_varchar2_table(334) := '2666756E6374696F6E2865297B636F6E737420743D652E6F7574676F696E677C7C5B5D3B72657475726E21286928652C2262706D6E3A53756250726F6365737322292626652E74726967676572656442794576656E747C7C6928652C2262706D6E3A496E';
wwv_flow_imp.g_varchar2_table(335) := '7465726D6564696174655468726F774576656E742229262666756E6374696F6E2865297B636F6E737420743D652E6576656E74446566696E6974696F6E737C7C5B5D3B72657475726E20742E6C656E6774682626742E65766572792828653D3E6928652C';
wwv_flow_imp.g_varchar2_table(336) := '2262706D6E3A4C696E6B4576656E74446566696E6974696F6E222929297D2865297C7C6928652C2262706D6E3A456E644576656E7422297C7C30213D3D742E6C656E677468297D2865292626742E7265706F727428652E69642C22456C656D656E742069';
wwv_flow_imp.g_varchar2_table(337) := '7320616E20696D706C6963697420656E6422297D7D7D7D2C323730313A28652C742C6E293D3E7B636F6E73747B6973416E793A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E63';
wwv_flow_imp.g_varchar2_table(338) := '74696F6E28652C74297B6928652C5B2262706D6E3A4163746976697479222C2262706D6E3A4576656E74225D29262628652E6F7574676F696E677C7C5B5D292E66696C7465722828743D3E2166756E6374696F6E2865297B72657475726E2121652E636F';
wwv_flow_imp.g_varchar2_table(339) := '6E646974696F6E45787072657373696F6E7D28742926262166756E6374696F6E28652C74297B72657475726E20652E64656661756C743D3D3D747D28652C742929292E6C656E6774683E312626742E7265706F727428652E69642C22466C6F772073706C';
wwv_flow_imp.g_varchar2_table(340) := '69747320696D706C696369746C7922297D7D7D7D2C333635333A28652C742C6E293D3E7B636F6E73747B69733A692C6973416E793A6F7D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A6675';
wwv_flow_imp.g_varchar2_table(341) := '6E6374696F6E28652C74297B6F28652C5B2262706D6E3A4576656E74222C2262706D6E3A4163746976697479222C2262706D6E3A47617465776179225D29262666756E6374696F6E2865297B636F6E737420743D652E696E636F6D696E677C7C5B5D3B72';
wwv_flow_imp.g_varchar2_table(342) := '657475726E21286928652C2262706D6E3A416374697669747922292626652E6973466F72436F6D70656E736174696F6E7C7C6928652C2262706D6E3A53756250726F6365737322292626652E74726967676572656442794576656E747C7C6928652C2262';
wwv_flow_imp.g_varchar2_table(343) := '706D6E3A496E7465726D65646961746543617463684576656E742229262666756E6374696F6E2865297B636F6E737420743D652E6576656E74446566696E6974696F6E737C7C5B5D3B72657475726E20742E6C656E6774682626742E6576657279282865';
wwv_flow_imp.g_varchar2_table(344) := '3D3E6928652C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E222929297D2865297C7C6F28652C5B2262706D6E3A53746172744576656E74222C2262706D6E3A426F756E646172794576656E74225D297C7C30213D3D742E6C656E677468';
wwv_flow_imp.g_varchar2_table(345) := '297D2865292626742E7265706F727428652E69642C22456C656D656E7420697320616E20696D706C6963697420737461727422297D7D7D7D2C393730343A28652C742C6E293D3E7B636F6E73747B69733A697D3D6E2832323332293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(346) := '206F28652C742C6E2C722C6C297B636F6E737420633D652E666C6F77456C656D656E74737C7C5B5D2C643D632E66696C7465722828653D3E722E68617328652929293B7328642C742C72292C642E666F72456163682828653D3E7B216928652C2262706D';
wwv_flow_imp.g_varchar2_table(347) := '6E3A4461746153746F72655265666572656E63652229262666756E6374696F6E28652C74297B69662821612865297C7C21612874292972657475726E21313B636F6E7374206E3D652E783E3D742E782626652E793E3D742E792C693D652E782B652E7769';
wwv_flow_imp.g_varchar2_table(348) := '6474683C3D742E782B742E77696474682626652E792B652E6865696768743C3D742E792B742E6865696768743B72657475726E21286E262669297D28722E6765742865292E626F756E64732C6C2E626F756E64732926266E2E6164642865297D29292C63';
wwv_flow_imp.g_varchar2_table(349) := '2E66696C7465722828653D3E6928652C2262706D6E3A53756250726F63657373222929292E666F72456163682828653D3E7B636F6E737420693D722E6765742865297C7C7B7D2C733D692E6973457870616E6465643F693A7B7D3B6F28652C742C6E2C72';
wwv_flow_imp.g_varchar2_table(350) := '2C73297D29297D66756E6374696F6E207328652C742C6E297B666F72286C657420693D303B693C652E6C656E6774682D313B692B2B297B636F6E7374206F3D655B695D3B666F72286C657420733D692B313B733C652E6C656E6774683B732B2B297B636F';
wwv_flow_imp.g_varchar2_table(351) := '6E737420693D655B735D3B6F2E6174746163686564546F526566213D3D692626692E6174746163686564546F526566213D3D6F262672286E2E676574286F292E626F756E64732C6E2E6765742869292E626F756E647329262628742E616464286F292C74';
wwv_flow_imp.g_varchar2_table(352) := '2E616464286929297D7D7D66756E6374696F6E207228652C74297B69662821612865297C7C21612874292972657475726E21313B636F6E7374206E3D652E782B652E77696474683E3D742E782626742E782B742E77696474683E3D652E782C693D652E79';
wwv_flow_imp.g_varchar2_table(353) := '2B652E6865696768743E3D742E792626742E792B742E6865696768743E3D652E793B72657475726E206E2626697D66756E6374696F6E20612865297B72657475726E21216526266928652C2264633A426F756E647322292626226E756D626572223D3D74';
wwv_flow_imp.g_varchar2_table(354) := '7970656F6620652E782626226E756D626572223D3D747970656F6620652E792626226E756D626572223D3D747970656F6620652E77696474682626226E756D626572223D3D747970656F6620652E6865696768747D652E6578706F7274733D66756E6374';
wwv_flow_imp.g_varchar2_table(355) := '696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B696628216928652C2262706D6E3A446566696E6974696F6E7322292972657475726E3B636F6E7374206E3D652E726F6F74456C656D656E74737C7C5B5D2C723D6E6577';
wwv_flow_imp.g_varchar2_table(356) := '205365742C613D6E6577205365742C6C3D66756E6374696F6E2865297B636F6E737420743D6E6577204D61703B72657475726E28652E6469616772616D737C7C5B5D292E66696C7465722828653D3E2121652E706C616E6529292E666F72456163682828';
wwv_flow_imp.g_varchar2_table(357) := '653D3E7B28652E706C616E652E706C616E65456C656D656E747C7C5B5D292E66696C7465722828653D3E2121652E62706D6E456C656D656E7429292E666F72456163682828653D3E7B742E73657428652E62706D6E456C656D656E742C65297D29297D29';
wwv_flow_imp.g_varchar2_table(358) := '292C747D2865292C633D6E6577204D61703B6E2E66696C7465722828653D3E6928652C2262706D6E3A436F6C6C61626F726174696F6E222929292E666F72456163682828653D3E7B636F6E737420743D652E7061727469636970616E74737C7C5B5D3B73';
wwv_flow_imp.g_varchar2_table(359) := '28742C722C6C292C742E666F72456163682828653D3E7B632E73657428652E70726F636573735265662C6C2E676574286529297D29297D29292C6E2E66696C7465722828653D3E6928652C2262706D6E3A50726F63657373222929292E666F7245616368';
wwv_flow_imp.g_varchar2_table(360) := '2828653D3E7B636F6E737420743D632E6765742865297C7C7B7D3B6F28652C722C612C6C2C74297D29292C722E666F72456163682828653D3E742E7265706F727428652E69642C22456C656D656E74206F7665726C6170732077697468206F7468657220';
wwv_flow_imp.g_varchar2_table(361) := '656C656D656E74222929292C612E666F72456163682828653D3E742E7265706F727428652E69642C22456C656D656E74206973206F757473696465206F6620706172656E7420626F756E64617279222929297D7D7D7D2C323433383A28652C742C6E293D';
wwv_flow_imp.g_varchar2_table(362) := '3E7B636F6E73747B69733A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B6966286928652C2262706D6E3A466C6F77456C656D656E7473436F6E7461';
wwv_flow_imp.g_varchar2_table(363) := '696E65722229262628652E666C6F77456C656D656E74737C7C5B5D292E66696C746572282866756E6374696F6E2865297B72657475726E21216928652C2262706D6E3A53746172744576656E7422292626303D3D3D28652E6576656E74446566696E6974';
wwv_flow_imp.g_varchar2_table(364) := '696F6E737C7C5B5D292E6C656E6774687D29292E6C656E6774683E31297B636F6E7374206E3D6928652C2262706D6E3A53756250726F6365737322293F225375622070726F63657373223A2250726F63657373223B742E7265706F727428652E69642C6E';
wwv_flow_imp.g_varchar2_table(365) := '2B2220686173206D756C7469706C6520626C616E6B207374617274206576656E747322297D7D7D7D7D2C343331363A28652C742C6E293D3E7B636F6E73747B69733A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(366) := '7475726E7B636865636B3A66756E6374696F6E28652C74297B6928652C2262706D6E3A4576656E742229262628652E6576656E74446566696E6974696F6E737C7C5B5D292E6C656E6774683E312626742E7265706F727428652E69642C224576656E7420';
wwv_flow_imp.g_varchar2_table(367) := '686173206D756C7469706C65206576656E7420646566696E6974696F6E73222C5B226576656E74446566696E6974696F6E73225D297D7D7D7D2C313636303A28652C742C6E293D3E7B636F6E73747B69733A692C6973416E793A6F7D3D6E283232333229';
wwv_flow_imp.g_varchar2_table(368) := '3B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B6966286F28652C5B2262706D6E3A50726F63657373222C2262706D6E3A53756250726F63657373225D2926262166756E637469';
wwv_flow_imp.g_varchar2_table(369) := '6F6E2865297B72657475726E28652E666C6F77456C656D656E74737C7C5B5D292E736F6D652828653D3E6928652C2262706D6E3A53746172744576656E74222929297D286529297B636F6E7374206E3D6928652C2262706D6E3A53756250726F63657373';
wwv_flow_imp.g_varchar2_table(370) := '22293F225375622070726F63657373223A2250726F63657373223B742E7265706F727428652E69642C6E2B22206973206D697373696E67207374617274206576656E7422297D7D7D7D7D2C313537363A28652C742C6E293D3E7B636F6E73747B69733A69';
wwv_flow_imp.g_varchar2_table(371) := '7D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B6928652C2262706D6E3A53756250726F636573732229262621652E74726967676572656442794576656E';
wwv_flow_imp.g_varchar2_table(372) := '74262628652E666C6F77456C656D656E74737C7C5B5D292E666F7245616368282866756E6374696F6E2865297B696628216928652C2262706D6E3A53746172744576656E7422292972657475726E21313B28652E6576656E74446566696E6974696F6E73';
wwv_flow_imp.g_varchar2_table(373) := '7C7C5B5D292E6C656E6774683E302626742E7265706F727428652E69642C225374617274206576656E74206D75737420626520626C616E6B222C5B226576656E74446566696E6974696F6E73225D297D29297D7D7D7D2C393837313A28652C742C6E293D';
wwv_flow_imp.g_varchar2_table(374) := '3E7B636F6E73747B69733A697D3D6E2832323332293B652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B696628216928652C2262706D6E3A4761746577617922292972657475726E';
wwv_flow_imp.g_varchar2_table(375) := '3B636F6E7374206E3D652E696E636F6D696E677C7C5B5D2C6F3D652E6F7574676F696E677C7C5B5D3B313D3D3D6E2E6C656E6774682626313D3D3D6F2E6C656E6774682626742E7265706F727428652E69642C2247617465776179206973207375706572';
wwv_flow_imp.g_varchar2_table(376) := '666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E22297D7D7D7D2C323939313A28652C742C6E293D3E7B636F6E73747B69733A692C6973416E793A6F7D3D6E2832323332293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(377) := '20732865297B72657475726E206928652C2262706D6E3A456E644576656E742229262628652E6576656E74446566696E6974696F6E737C7C5B5D292E736F6D652828653D3E6928652C2262706D6E3A5465726D696E6174654576656E74446566696E6974';
wwv_flow_imp.g_varchar2_table(378) := '696F6E222929297D652E6578706F7274733D66756E6374696F6E28297B72657475726E7B636865636B3A66756E6374696F6E28652C74297B696628216F28652C5B2262706D6E3A50726F63657373222C2262706D6E3A53756250726F63657373225D2929';
wwv_flow_imp.g_varchar2_table(379) := '72657475726E3B636F6E7374206E3D28652E666C6F77456C656D656E74737C7C5B5D292E66696C7465722828653D3E6928652C2262706D6E3A466C6F774E6F646522292626303D3D3D28652E6F7574676F696E677C7C5B5D292E6C656E67746829292C72';
wwv_flow_imp.g_varchar2_table(380) := '3D6E2E66696C7465722873293B696628313D3D3D722E6C656E67746826266E2E65766572792828653D3E7B72657475726E206928743D652C2262706D6E3A53756250726F6365737322292626742E74726967676572656442794576656E74262628742E66';
wwv_flow_imp.g_varchar2_table(381) := '6C6F77456C656D656E74737C7C5B5D292E736F6D652828653D3E6928652C2262706D6E3A53746172744576656E7422292626652E6973496E74657272757074696E6729297C7C732865293B76617220747D292929666F7228636F6E73742065206F662072';
wwv_flow_imp.g_varchar2_table(382) := '29742E7265706F727428652E69642C225465726D696E6174696F6E206973207375706572666C756F75732E22297D7D7D7D2C343536363A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B7661722069';
wwv_flow_imp.g_varchar2_table(383) := '3D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(384) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C20';
wwv_flow_imp.g_varchar2_table(385) := '7269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E73';
wwv_flow_imp.g_varchar2_table(386) := '6520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(387) := '2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172207B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D62';
wwv_flow_imp.g_varchar2_table(388) := '6172202E616374696F6E732D636F6E7461696E6572207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D617267696E3A2030206175746F3B5C6E5C7470616464696E673A20303B5C6E5C746865696768743A20313030253B5C6E5C7477696474';
wwv_flow_imp.g_varchar2_table(389) := '683A20313030253B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E732D636F6E7461696E6572207B5C6E5C74646973706C61793A20';
wwv_flow_imp.g_varchar2_table(390) := '696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C74';
wwv_flow_imp.g_varchar2_table(391) := '6A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74706F736974696F6E3A2072656C61746976653B20202F2A20444F204E4F542052454D4F5645202D20746869732069732074686520';
wwv_flow_imp.g_varchar2_table(392) := '6B657920746F2070726576656E74696E67207468652067686F7374696E672069636F6E2062756720696E204368726F6D65203432202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E64697361626C';
wwv_flow_imp.g_varchar2_table(393) := '6564207B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E69636F6E2C5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974';
wwv_flow_imp.g_varchar2_table(394) := '656D202E636F6469636F6E207B5C6E5C74646973706C61793A20626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E636F6469636F6E207B5C6E5C74646973706C61793A20666C65783B5C';
wwv_flow_imp.g_varchar2_table(395) := '6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C7477696474683A20313670783B5C6E5C746865696768743A20313670783B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C';
wwv_flow_imp.g_varchar2_table(396) := '74646973706C61793A20666C65783B5C6E5C74666F6E742D73697A653A20313170783B5C6E5C7470616464696E673A203370783B5C6E5C74626F726465722D7261646975733A203570783B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172';
wwv_flow_imp.g_varchar2_table(397) := '202E616374696F6E2D6974656D2E64697361626C6564202E616374696F6E2D6C6162656C2C5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E64697361626C6564202E616374696F6E2D6C6162656C3A3A6265666F72';
wwv_flow_imp.g_varchar2_table(398) := '652C5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E64697361626C6564202E616374696F6E2D6C6162656C3A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D64697361626C6564466F';
wwv_flow_imp.g_varchar2_table(399) := '726567726F756E64293B5C6E7D5C6E5C6E2F2A20566572746963616C20616374696F6E73202A2F5C6E5C6E2E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C207B5C6E5C74746578742D616C69676E3A206C6566743B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(400) := '2E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D207B5C6E5C74646973706C61793A20626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374';
wwv_flow_imp.g_varchar2_table(401) := '696F6E2D6C6162656C2E736570617261746F72207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C696420236262623B5C6E5C7470616464696E672D746F703A203170783B5C6E5C746D';
wwv_flow_imp.g_varchar2_table(402) := '617267696E2D6C6566743A202E38656D3B5C6E5C746D617267696E2D72696768743A202E38656D3B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E616374696F6E2D6C6162656C2E73657061726174';
wwv_flow_imp.g_varchar2_table(403) := '6F72207B5C6E5C7477696474683A203170783B5C6E5C746865696768743A20313670783B5C6E5C746D617267696E3A20357078203470782021696D706F7274616E743B5C6E5C74637572736F723A2064656661756C743B5C6E5C746D696E2D7769647468';
wwv_flow_imp.g_varchar2_table(404) := '3A203170783B5C6E5C7470616464696E673A20303B5C6E5C746261636B67726F756E642D636F6C6F723A20236262623B5C6E7D5C6E5C6E2E7365636F6E646172792D616374696F6E73202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E';
wwv_flow_imp.g_varchar2_table(405) := '2D6C6162656C207B5C6E5C746D617267696E2D6C6566743A203670783B5C6E7D5C6E5C6E2F2A20416374696F6E204974656D73202A2F5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E73656C6563742D636F6E7461';
wwv_flow_imp.g_varchar2_table(406) := '696E6572207B5C6E5C746F766572666C6F773A2068696464656E3B202F2A20736F6D65686F77207468652064726F70646F776E206F766572666C6F77732069747320636F6E7461696E65722C2077652070726576656E74206974206865726520746F206E';
wwv_flow_imp.g_varchar2_table(407) := '6F742070757368202A2F5C6E5C74666C65783A20313B5C6E5C746D61782D77696474683A2031373070783B5C6E5C746D696E2D77696474683A20363070783B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A206365';
wwv_flow_imp.g_varchar2_table(408) := '6E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C746D617267696E2D72696768743A20313070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E616374696F';
wwv_flow_imp.g_varchar2_table(409) := '6E2D64726F70646F776E2D6974656D207B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E616374696F6E2D64726F70646F776E2D6974656D203E202E6163';
wwv_flow_imp.g_varchar2_table(410) := '74696F6E2D64726F70646F776E2D6974656D2D736570617261746F72207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(411) := '6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E616374696F6E2D64726F70646F776E2D6974656D203E202E616374696F6E2D64726F70646F776E2D6974656D2D736570617261746F72203E20646976207B5C6E5C74776964';
wwv_flow_imp.g_varchar2_table(412) := '74683A203170783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C353033383A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C73';
wwv_flow_imp.g_varchar2_table(413) := '3D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(414) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E20';
wwv_flow_imp.g_varchar2_table(415) := '2A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D';
wwv_flow_imp.g_varchar2_table(416) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(417) := '6E61636F2D617269612D636F6E7461696E6572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B202F2A2074727920746F20686964652066726F6D2077696E646F7720627574206E6F742066726F6D2073637265656E207265616465727320';
wwv_flow_imp.g_varchar2_table(418) := '2A2F5C6E5C746C6566743A2D393939656D3B5C6E7D222C22225D293B636F6E737420613D727D2C383838303A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D';
wwv_flow_imp.g_varchar2_table(419) := '6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(420) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365';
wwv_flow_imp.g_varchar2_table(421) := '727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D617469';
wwv_flow_imp.g_varchar2_table(422) := '6F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A';
wwv_flow_imp.g_varchar2_table(423) := '2F5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E207B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74646973706C61793A20666C65783B5C6E5C7477696474683A20313030253B5C6E5C7470616464696E673A20';
wwv_flow_imp.g_varchar2_table(424) := '3470783B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C74637572736F723A20706F696E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E';
wwv_flow_imp.g_varchar2_table(425) := '5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D627574746F6E2D626F726465722C207472616E73706172656E74293B5C6E5C746C696E652D686569676874';
wwv_flow_imp.g_varchar2_table(426) := '3A20313870783B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E3A666F637573207B5C6E5C746F75746C696E652D6F66667365743A203270782021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D62757474';
wwv_flow_imp.g_varchar2_table(427) := '6F6E3A686F766572207B5C6E5C74746578742D6465636F726174696F6E3A206E6F6E652021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2E64697361626C65643A666F6375732C5C6E2E6D6F6E61636F2D627574746F6E';
wwv_flow_imp.g_varchar2_table(428) := '2E64697361626C6564207B5C6E5C746F7061636974793A20302E342021696D706F7274616E743B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E202E636F6469636F6E207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(429) := '6D617267696E3A203020302E32656D3B5C6E5C74636F6C6F723A20696E68657269742021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E2E6D6F6E61636F2D746578742D627574746F6E2D776974682D73686F';
wwv_flow_imp.g_varchar2_table(430) := '72742D6C6162656C207B5C6E5C74666C65782D646972656374696F6E3A20726F773B5C6E5C74666C65782D777261703A20777261703B5C6E5C7470616464696E673A2030203470783B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C746865';
wwv_flow_imp.g_varchar2_table(431) := '696768743A20323870783B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E2E6D6F6E61636F2D746578742D627574746F6E2D776974682D73686F72742D6C6162656C203E202E6D6F6E61636F2D627574746F6E2D6C6162656C207B5C6E';
wwv_flow_imp.g_varchar2_table(432) := '5C74666C65782D62617369733A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E2E6D6F6E61636F2D746578742D627574746F6E2D776974682D73686F72742D6C6162656C203E202E6D6F6E61636F2D627574746F6E2D6C';
wwv_flow_imp.g_varchar2_table(433) := '6162656C2D73686F7274207B5C6E5C74666C65782D67726F773A20313B5C6E5C7477696474683A20303B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D746578742D627574746F6E2E6D6F6E61636F2D746578';
wwv_flow_imp.g_varchar2_table(434) := '742D627574746F6E2D776974682D73686F72742D6C6162656C203E202E6D6F6E61636F2D627574746F6E2D6C6162656C2C5C6E2E6D6F6E61636F2D746578742D627574746F6E2E6D6F6E61636F2D746578742D627574746F6E2D776974682D73686F7274';
wwv_flow_imp.g_varchar2_table(435) := '2D6C6162656C203E202E6D6F6E61636F2D627574746F6E2D6C6162656C2D73686F7274207B5C6E5C74646973706C61793A20666C65783B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74616C69676E2D6974656D733A20';
wwv_flow_imp.g_varchar2_table(436) := '63656E7465723B5C6E5C74666F6E742D7765696768743A206E6F726D616C3B5C6E5C74666F6E742D7374796C653A20696E68657269743B5C6E5C7470616464696E673A2034707820303B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70';
wwv_flow_imp.g_varchar2_table(437) := '646F776E207B5C6E5C74646973706C61793A20666C65783B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64697361626C6564207B5C6E5C74637572736F723A20646566';
wwv_flow_imp.g_varchar2_table(438) := '61756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E203E202E6D6F6E61636F2D627574746F6E3A666F637573207B5C6E5C746F75746C696E652D6F66667365743A202D3170782021696D706F7274616E743B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(439) := '6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64697361626C6564203E202E6D6F6E61636F2D627574746F6E2E64697361626C65642C5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64697361626C6564203E202E';
wwv_flow_imp.g_varchar2_table(440) := '6D6F6E61636F2D627574746F6E2E64697361626C65643A666F6375732C5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64697361626C6564203E202E6D6F6E61636F2D627574746F6E2D64726F70646F776E2D736570617261746F7220';
wwv_flow_imp.g_varchar2_table(441) := '7B5C6E5C746F7061636974793A20302E342021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E203E202E6D6F6E61636F2D627574746F6E2E6D6F6E61636F2D746578742D627574746F6E207B5C6E5C';
wwv_flow_imp.g_varchar2_table(442) := '74626F726465722D72696768742D77696474683A20302021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E202E6D6F6E61636F2D627574746F6E2D64726F70646F776E2D736570617261746F72207B';
wwv_flow_imp.g_varchar2_table(443) := '5C6E5C7470616464696E673A2034707820303B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E202E6D6F6E61636F2D627574746F6E2D64726F70646F776E2D736570617261';
wwv_flow_imp.g_varchar2_table(444) := '746F72203E20646976207B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A203170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E203E202E6D6F6E61636F2D627574746F6E2E6D6F6E61636F2D6472';
wwv_flow_imp.g_varchar2_table(445) := '6F70646F776E2D627574746F6E207B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D627574746F6E2D626F726465722C207472616E73706172656E74293B5C6E5C74626F726465722D6C6566742D77696474683A';
wwv_flow_imp.g_varchar2_table(446) := '20302021696D706F7274616E743B5C6E5C74626F726465722D7261646975733A2030203270782032707820303B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(447) := '6F2D627574746F6E2D64726F70646F776E203E202E6D6F6E61636F2D627574746F6E2E6D6F6E61636F2D746578742D627574746F6E207B5C6E5C74626F726465722D7261646975733A2032707820302030203270783B5C6E7D5C6E5C6E2E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(448) := '2D6465736372697074696F6E2D627574746F6E207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746D617267696E';
wwv_flow_imp.g_varchar2_table(449) := '3A20347078203570783B202F2A20616C6C6F777320627574746F6E20666F637573206F75746C696E6520746F2062652076697369626C65202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D6465736372697074696F6E2D627574746F6E202E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(450) := '627574746F6E2D6465736372697074696F6E207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E5C74666F6E742D73697A653A20313170783B5C6E5C7470616464696E673A2034707820323070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(451) := '6465736372697074696F6E2D627574746F6E202E6D6F6E61636F2D627574746F6E2D6C6162656C2C5C6E2E6D6F6E61636F2D6465736372697074696F6E2D627574746F6E202E6D6F6E61636F2D627574746F6E2D6465736372697074696F6E207B5C6E5C';
wwv_flow_imp.g_varchar2_table(452) := '74646973706C61793A20666C65783B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D6465736372697074696F6E2D627574746F6E';
wwv_flow_imp.g_varchar2_table(453) := '202E6D6F6E61636F2D627574746F6E2D6C6162656C203E202E636F6469636F6E2C5C6E2E6D6F6E61636F2D6465736372697074696F6E2D627574746F6E202E6D6F6E61636F2D627574746F6E2D6465736372697074696F6E203E202E636F6469636F6E20';
wwv_flow_imp.g_varchar2_table(454) := '7B5C6E5C746D617267696E3A203020302E32656D3B5C6E5C74636F6C6F723A20696E68657269742021696D706F7274616E743B5C6E7D5C6E5C6E2F2A2064656661756C7420636F6C6F72207374796C6573202D206261736564206F6E2043535320766172';
wwv_flow_imp.g_varchar2_table(455) := '6961626C6573202A2F5C6E5C6E2E6D6F6E61636F2D627574746F6E2E64656661756C742D636F6C6F72732C5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273203E202E6D6F6E61636F2D627574746F6E';
wwv_flow_imp.g_varchar2_table(456) := '7B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D666F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D6261636B67726F756E64293B5C6E';
wwv_flow_imp.g_varchar2_table(457) := '7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2E64656661756C742D636F6C6F72733A686F7665722C5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273203E202E6D6F6E61636F2D627574746F6E3A68';
wwv_flow_imp.g_varchar2_table(458) := '6F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2E64656661756C742D636F6C6F72';
wwv_flow_imp.g_varchar2_table(459) := '732E7365636F6E646172792C5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273203E202E6D6F6E61636F2D627574746F6E2E7365636F6E64617279207B5C6E5C74636F6C6F723A20766172282D2D7673';
wwv_flow_imp.g_varchar2_table(460) := '636F64652D627574746F6E2D7365636F6E64617279466F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D7365636F6E646172794261636B67726F756E64293B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(461) := '6E5C6E2E6D6F6E61636F2D627574746F6E2E64656661756C742D636F6C6F72732E7365636F6E646172793A686F7665722C5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273203E202E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(462) := '627574746F6E2E7365636F6E646172793A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D7365636F6E64617279486F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(463) := '6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273202E6D6F6E61636F2D627574746F6E2D64726F70646F776E2D736570617261746F72207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(464) := '2D7673636F64652D627574746F6E2D6261636B67726F756E64293B5C6E5C74626F726465722D746F703A2031707820736F6C696420766172282D2D7673636F64652D627574746F6E2D626F72646572293B5C6E5C74626F726465722D626F74746F6D3A20';
wwv_flow_imp.g_varchar2_table(465) := '31707820736F6C696420766172282D2D7673636F64652D627574746F6E2D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273202E6D6F6E61636F2D627574746F6E2E73';
wwv_flow_imp.g_varchar2_table(466) := '65636F6E64617279202B202E6D6F6E61636F2D627574746F6E2D64726F70646F776E2D736570617261746F72207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D7365636F6E64617279426163';
wwv_flow_imp.g_varchar2_table(467) := '6B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D627574746F6E2D64726F70646F776E2E64656661756C742D636F6C6F7273202E6D6F6E61636F2D627574746F6E2D64726F70646F776E2D736570617261746F72203E20646976207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(468) := '6261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D736570617261746F72293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383333333A28652C742C6E293D3E7B2275736520737472696374223B';
wwv_flow_imp.g_varchar2_table(469) := '6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(470) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F';
wwv_flow_imp.g_varchar2_table(471) := '736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070';
wwv_flow_imp.g_varchar2_table(472) := '726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(473) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E636F6469636F6E2D7772656E63682D737562616374696F6E207B5C6E5C746F7061636974793A20302E353B5C6E7D5C6E5C6E406B65796672616D657320';
wwv_flow_imp.g_varchar2_table(474) := '636F6469636F6E2D7370696E207B5C6E5C7431303025207B5C6E5C745C747472616E73666F726D3A726F7461746528333630646567293B5C6E5C747D5C6E7D5C6E5C6E2E636F6469636F6E2D73796E632E636F6469636F6E2D6D6F6469666965722D7370';
wwv_flow_imp.g_varchar2_table(475) := '696E2C5C6E2E636F6469636F6E2D6C6F6164696E672E636F6469636F6E2D6D6F6469666965722D7370696E2C5C6E2E636F6469636F6E2D676561722E636F6469636F6E2D6D6F6469666965722D7370696E2C5C6E2E636F6469636F6E2D6E6F7465626F6F';
wwv_flow_imp.g_varchar2_table(476) := '6B2D73746174652D657865637574696E672E636F6469636F6E2D6D6F6469666965722D7370696E207B5C6E5C742F2A2055736520737465707320746F207468726F74746C652046505320746F2072656475636520435055207573616765202A2F5C6E5C74';
wwv_flow_imp.g_varchar2_table(477) := '616E696D6174696F6E3A20636F6469636F6E2D7370696E20312E35732073746570732833302920696E66696E6974653B5C6E7D5C6E5C6E2E636F6469636F6E2D6D6F6469666965722D64697361626C6564207B5C6E5C746F7061636974793A20302E343B';
wwv_flow_imp.g_varchar2_table(478) := '5C6E7D5C6E5C6E2F2A20637573746F6D207370656564202620656173696E6720666F72206C6F6164696E672069636F6E202A2F5C6E2E636F6469636F6E2D6C6F6164696E672C5C6E2E636F6469636F6E2D747265652D6974656D2D6C6F6164696E673A3A';
wwv_flow_imp.g_varchar2_table(479) := '6265666F7265207B5C6E5C74616E696D6174696F6E2D6475726174696F6E3A2031732021696D706F7274616E743B5C6E5C74616E696D6174696F6E2D74696D696E672D66756E6374696F6E3A2063756269632D62657A69657228302E35332C20302E3231';
wwv_flow_imp.g_varchar2_table(480) := '2C20302E32392C20302E3637292021696D706F7274616E743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C323137313A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E757D293B76617220693D6E';
wwv_flow_imp.g_varchar2_table(481) := '2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292C613D6E2834343137292C6C3D6E2E6E2861292C633D6E65772055524C286E2831323838292C6E2E62292C643D722829286F2829292C683D6C28292863293B642E70';
wwv_flow_imp.g_varchar2_table(482) := '757368285B652E69642C602F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(483) := '2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C69';
wwv_flow_imp.g_varchar2_table(484) := '63656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(485) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E40666F6E742D66616365207B5C6E5C74666F6E742D66616D696C793A202263';
wwv_flow_imp.g_varchar2_table(486) := '6F6469636F6E223B5C6E5C74666F6E742D646973706C61793A20626C6F636B3B5C6E5C747372633A2075726C28247B687D2920666F726D61742822747275657479706522293B5C6E7D5C6E5C6E2E636F6469636F6E5B636C6173732A3D27636F6469636F';
wwv_flow_imp.g_varchar2_table(487) := '6E2D275D207B5C6E5C74666F6E743A206E6F726D616C206E6F726D616C206E6F726D616C20313670782F3120636F6469636F6E3B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74746578742D6465636F726174696F6E3A206E';
wwv_flow_imp.g_varchar2_table(488) := '6F6E653B5C6E5C74746578742D72656E646572696E673A206175746F3B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C74746578742D7472616E73666F726D3A206E6F6E653B5C6E5C742D7765626B69742D666F6E742D736D6F6F7468';
wwv_flow_imp.g_varchar2_table(489) := '696E673A20616E7469616C69617365643B5C6E5C742D6D6F7A2D6F73782D666F6E742D736D6F6F7468696E673A20677261797363616C653B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563';
wwv_flow_imp.g_varchar2_table(490) := '743A206E6F6E653B5C6E7D5C6E5C6E2F2A2069636F6E2072756C6573206172652064796E616D6963616C6C7920637265617465642062792074686520706C6174666F726D207468656D65207365727669636520287365652069636F6E735374796C655368';
wwv_flow_imp.g_varchar2_table(491) := '6565742E747329202A2F5C6E602C22225D293B636F6E737420753D647D2C383937303A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D';
wwv_flow_imp.g_varchar2_table(492) := '6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(493) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A';
wwv_flow_imp.g_varchar2_table(494) := '20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D';
wwv_flow_imp.g_varchar2_table(495) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E636F6E';
wwv_flow_imp.g_varchar2_table(496) := '746578742D76696577207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E636F6E746578742D766965772E6669786564207B5C6E5C74616C6C3A20696E697469616C3B5C6E5C74666F6E742D66616D696C793A20696E6865';
wwv_flow_imp.g_varchar2_table(497) := '7269743B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C74706F736974696F6E3A2066697865643B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313638343A28652C742C6E293D3E';
wwv_flow_imp.g_varchar2_table(498) := '7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D';
wwv_flow_imp.g_varchar2_table(499) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F707972';
wwv_flow_imp.g_varchar2_table(500) := '6967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73';
wwv_flow_imp.g_varchar2_table(501) := '652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(502) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D636F756E742D6261646765207B5C6E5C7470616464696E673A20337078203670783B5C6E5C74626F';
wwv_flow_imp.g_varchar2_table(503) := '726465722D7261646975733A20313170783B5C6E5C74666F6E742D73697A653A20313170783B5C6E5C746D696E2D77696474683A20313870783B5C6E5C746D696E2D6865696768743A20313870783B5C6E5C746C696E652D6865696768743A2031317078';
wwv_flow_imp.g_varchar2_table(504) := '3B5C6E5C74666F6E742D7765696768743A206E6F726D616C3B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74626F782D73697A696E673A20626F726465722D626F78';
wwv_flow_imp.g_varchar2_table(505) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F756E742D62616467652E6C6F6E67207B5C6E5C7470616464696E673A20327078203370783B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C746D696E2D6865696768743A206175746F3B5C';
wwv_flow_imp.g_varchar2_table(506) := '6E5C746C696E652D6865696768743A206E6F726D616C3B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C393836323A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831';
wwv_flow_imp.g_varchar2_table(507) := '363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(508) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C2072696768';
wwv_flow_imp.g_varchar2_table(509) := '74732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E';
wwv_flow_imp.g_varchar2_table(510) := '666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(511) := '2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D64726F70646F776E207B5C6E5C746865696768743A20313030253B5C6E5C7470616464696E673A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E203E202E64726F70646F776E2D6C61';
wwv_flow_imp.g_varchar2_table(512) := '62656C207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C746865696768743A20313030253B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74';
wwv_flow_imp.g_varchar2_table(513) := '656E743A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E203E202E64726F70646F776E2D6C6162656C203E202E616374696F6E2D6C6162656C2E64697361626C6564207B5C6E5C74637572736F723A2064656661756C743B';
wwv_flow_imp.g_varchar2_table(514) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D7072696D617279207B5C6E5C74646973706C61793A20666C65782021696D706F7274616E743B5C6E5C74666C65782D646972656374696F6E3A20726F773B5C6E5C74626F726465';
wwv_flow_imp.g_varchar2_table(515) := '722D7261646975733A203570783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D7072696D617279203E202E616374696F6E2D636F6E7461696E6572203E202E616374696F6E2D6C6162656C207B5C6E5C746D617267696E2D72';
wwv_flow_imp.g_varchar2_table(516) := '696768743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D7072696D617279203E202E64726F70646F776E2D616374696F6E2D636F6E7461696E6572203E202E6D6F6E61636F2D64726F70646F776E203E202E64726F70';
wwv_flow_imp.g_varchar2_table(517) := '646F776E2D6C6162656C202E636F6469636F6E5B636C6173732A3D27636F6469636F6E2D275D207B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C7470616464696E672D6C6566743A203070783B5C6E5C7470616464696E672D72696768743A';
wwv_flow_imp.g_varchar2_table(518) := '203070783B5C6E5C746C696E652D6865696768743A20313670783B5C6E5C746D617267696E2D6C6566743A202D3370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D7072696D617279203E202E64726F70646F776E2D6163';
wwv_flow_imp.g_varchar2_table(519) := '74696F6E2D636F6E7461696E6572203E202E6D6F6E61636F2D64726F70646F776E203E202E64726F70646F776E2D6C6162656C203E202E616374696F6E2D6C6162656C207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C746261636B67726F75';
wwv_flow_imp.g_varchar2_table(520) := '6E642D73697A653A20313670783B5C6E5C746261636B67726F756E642D706F736974696F6E3A2063656E7465722063656E7465723B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E7D5C6E222C22225D293B636F';
wwv_flow_imp.g_varchar2_table(521) := '6E737420613D727D2C383437343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F28';
wwv_flow_imp.g_varchar2_table(522) := '29293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(523) := '2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E6465722074686520';
wwv_flow_imp.g_varchar2_table(524) := '4D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(525) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2F2A202D2D2D2D2D2D2D2D2D2D2046696E6420696E707574202D2D';
wwv_flow_imp.g_varchar2_table(526) := '2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D66696E64496E707574207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E2E6D6F6E61636F2D66696E64496E707574202E6D6F6E61636F2D696E707574626F78207B';
wwv_flow_imp.g_varchar2_table(527) := '5C6E5C74666F6E742D73697A653A20313370783B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D66696E64496E707574203E202E636F6E74726F6C73207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C';
wwv_flow_imp.g_varchar2_table(528) := '74746F703A203370783B5C6E5C7472696768743A203270783B5C6E7D5C6E5C6E2E7673202E6D6F6E61636F2D66696E64496E7075742E64697361626C6564207B5C6E5C746261636B67726F756E642D636F6C6F723A20234531453145313B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(529) := '6E2F2A205468656D696E67202A2F5C6E2E76732D6461726B202E6D6F6E61636F2D66696E64496E7075742E64697361626C6564207B5C6E5C746261636B67726F756E642D636F6C6F723A20233333333B5C6E7D5C6E5C6E2F2A20486967686C6967687469';
wwv_flow_imp.g_varchar2_table(530) := '6E67202A2F5C6E2E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D30202E636F6E74726F6C732C5C6E2E68632D6C69676874202E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D30202E636F6E74726F6C73207B';
wwv_flow_imp.g_varchar2_table(531) := '5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D66696E64496E7075742D686967686C696768742D30203130306D73206C696E6561722030733B5C6E7D5C6E5C6E2E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D31202E636F';
wwv_flow_imp.g_varchar2_table(532) := '6E74726F6C732C5C6E2E68632D6C69676874202E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D31202E636F6E74726F6C73207B5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D66696E64496E7075742D686967686C696768';
wwv_flow_imp.g_varchar2_table(533) := '742D31203130306D73206C696E6561722030733B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D30202E636F6E74726F6C732C5C6E2E76732D6461726B20202E6D6F6E61636F2D66696E';
wwv_flow_imp.g_varchar2_table(534) := '64496E7075742E686967686C696768742D30202E636F6E74726F6C73207B5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D66696E64496E7075742D686967686C696768742D6461726B2D30203130306D73206C696E6561722030733B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(535) := '5C6E2E68632D626C61636B202E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D31202E636F6E74726F6C732C5C6E2E76732D6461726B20202E6D6F6E61636F2D66696E64496E7075742E686967686C696768742D31202E636F6E7472';
wwv_flow_imp.g_varchar2_table(536) := '6F6C73207B5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D66696E64496E7075742D686967686C696768742D6461726B2D31203130306D73206C696E6561722030733B5C6E7D5C6E5C6E406B65796672616D6573206D6F6E61636F2D66696E6449';
wwv_flow_imp.g_varchar2_table(537) := '6E7075742D686967686C696768742D30207B5C6E5C743025207B206261636B67726F756E643A2072676261283235332C203235352C20302C20302E38293B207D5C6E5C7431303025207B206261636B67726F756E643A207472616E73706172656E743B20';
wwv_flow_imp.g_varchar2_table(538) := '7D5C6E7D5C6E406B65796672616D6573206D6F6E61636F2D66696E64496E7075742D686967686C696768742D31207B5C6E5C743025207B206261636B67726F756E643A2072676261283235332C203235352C20302C20302E38293B207D5C6E5C742F2A20';
wwv_flow_imp.g_varchar2_table(539) := '4D61646520696E74656E74696F6E616C6C7920646966666572656E74207375636820746861742074686520435353206D696E696669657220646F6573206E6F7420636F6C6C61707365207468652074776F20616E696D6174696F6E7320696E746F206120';
wwv_flow_imp.g_varchar2_table(540) := '73696E676C65206F6E652A2F5C6E5C74393925207B206261636B67726F756E643A207472616E73706172656E743B207D5C6E7D5C6E5C6E406B65796672616D6573206D6F6E61636F2D66696E64496E7075742D686967686C696768742D6461726B2D3020';
wwv_flow_imp.g_varchar2_table(541) := '7B5C6E5C743025207B206261636B67726F756E643A2072676261283235352C203235352C203235352C20302E3434293B207D5C6E5C7431303025207B206261636B67726F756E643A207472616E73706172656E743B207D5C6E7D5C6E406B65796672616D';
wwv_flow_imp.g_varchar2_table(542) := '6573206D6F6E61636F2D66696E64496E7075742D686967686C696768742D6461726B2D31207B5C6E5C743025207B206261636B67726F756E643A2072676261283235352C203235352C203235352C20302E3434293B207D5C6E5C742F2A204D6164652069';
wwv_flow_imp.g_varchar2_table(543) := '6E74656E74696F6E616C6C7920646966666572656E74207375636820746861742074686520435353206D696E696669657220646F6573206E6F7420636F6C6C61707365207468652074776F20616E696D6174696F6E7320696E746F20612073696E676C65';
wwv_flow_imp.g_varchar2_table(544) := '206F6E652A2F5C6E5C74393925207B206261636B67726F756E643A207472616E73706172656E743B207D5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383639343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B';
wwv_flow_imp.g_varchar2_table(545) := '413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(546) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F';
wwv_flow_imp.g_varchar2_table(547) := '72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420';
wwv_flow_imp.g_varchar2_table(548) := '726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(549) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D686F766572207B5C6E5C74637572736F723A2064656661756C743B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746F766572666C6F';
wwv_flow_imp.g_varchar2_table(550) := '773A2068696464656E3B5C6E5C74757365722D73656C6563743A20746578743B5C6E5C742D7765626B69742D757365722D73656C6563743A20746578743B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74616E696D617469';
wwv_flow_imp.g_varchar2_table(551) := '6F6E3A2066616465696E203130306D73206C696E6561723B5C6E5C746C696E652D6865696768743A20312E35656D3B5C6E5C7477686974652D73706163653A20766172282D2D7673636F64652D686F7665722D776869746553706163652C206E6F726D61';
wwv_flow_imp.g_varchar2_table(552) := '6C293B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F7665722E68696464656E207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F76657220613A686F7665723A6E6F74282E64697361626C656429207B5C6E5C7463';
wwv_flow_imp.g_varchar2_table(553) := '7572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D636F6E74656E74733A6E6F74282E68746D6C2D686F7665722D636F6E74656E747329207B5C6E5C7470616464696E673A20347078203870783B';
wwv_flow_imp.g_varchar2_table(554) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E6D61726B646F776E2D686F766572203E202E686F7665722D636F6E74656E74733A6E6F74282E636F64652D686F7665722D636F6E74656E747329207B5C6E5C746D61782D77696474683A20766172';
wwv_flow_imp.g_varchar2_table(555) := '282D2D7673636F64652D686F7665722D6D617857696474682C203530307078293B5C6E5C74776F72642D777261703A20627265616B2D776F72643B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E6D61726B646F776E2D686F766572203E202E68';
wwv_flow_imp.g_varchar2_table(556) := '6F7665722D636F6E74656E74733A6E6F74282E636F64652D686F7665722D636F6E74656E747329206872207B5C6E5C746D696E2D77696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F76657220702C5C6E2E6D6F6E61636F2D686F76';
wwv_flow_imp.g_varchar2_table(557) := '6572202E636F64652C5C6E2E6D6F6E61636F2D686F76657220756C2C5C6E2E6D6F6E61636F2D686F7665722068312C5C6E2E6D6F6E61636F2D686F7665722068322C5C6E2E6D6F6E61636F2D686F7665722068332C5C6E2E6D6F6E61636F2D686F766572';
wwv_flow_imp.g_varchar2_table(558) := '2068342C5C6E2E6D6F6E61636F2D686F7665722068352C5C6E2E6D6F6E61636F2D686F766572206836207B5C6E5C746D617267696E3A2038707820303B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F7665722068312C5C6E2E6D6F6E61636F2D686F766572';
wwv_flow_imp.g_varchar2_table(559) := '2068322C5C6E2E6D6F6E61636F2D686F7665722068332C5C6E2E6D6F6E61636F2D686F7665722068342C5C6E2E6D6F6E61636F2D686F7665722068352C5C6E2E6D6F6E61636F2D686F766572206836207B5C6E5C746C696E652D6865696768743A20312E';
wwv_flow_imp.g_varchar2_table(560) := '313B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F76657220636F6465207B5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F6E6F73706163652D666F6E74293B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572206872207B';
wwv_flow_imp.g_varchar2_table(561) := '5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465722D6C6566743A203070783B5C6E5C74626F726465722D72696768743A203070783B5C6E5C746D617267696E2D746F703A203470783B5C6E5C746D617267696E';
wwv_flow_imp.g_varchar2_table(562) := '2D626F74746F6D3A202D3470783B5C6E5C746D617267696E2D6C6566743A202D3870783B5C6E5C746D617267696E2D72696768743A202D3870783B5C6E5C746865696768743A203170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F76657220703A6669';
wwv_flow_imp.g_varchar2_table(563) := '7273742D6368696C642C5C6E2E6D6F6E61636F2D686F766572202E636F64653A66697273742D6368696C642C5C6E2E6D6F6E61636F2D686F76657220756C3A66697273742D6368696C64207B5C6E5C746D617267696E2D746F703A20303B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(564) := '6E2E6D6F6E61636F2D686F76657220703A6C6173742D6368696C642C5C6E2E6D6F6E61636F2D686F766572202E636F64653A6C6173742D6368696C642C5C6E2E6D6F6E61636F2D686F76657220756C3A6C6173742D6368696C64207B5C6E5C746D617267';
wwv_flow_imp.g_varchar2_table(565) := '696E2D626F74746F6D3A20303B5C6E7D5C6E5C6E2F2A204D61726B7570436F6E74656E74204C61796F7574202A2F5C6E2E6D6F6E61636F2D686F76657220756C207B5C6E5C7470616464696E672D6C6566743A20323070783B5C6E7D5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(566) := '6F2D686F766572206F6C207B5C6E5C7470616464696E672D6C6566743A20323070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572206C69203E2070207B5C6E5C746D617267696E2D626F74746F6D3A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(567) := '686F766572206C69203E20756C207B5C6E5C746D617267696E2D746F703A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F76657220636F6465207B5C6E5C74626F726465722D7261646975733A203370783B5C6E5C7470616464696E673A203020302E';
wwv_flow_imp.g_varchar2_table(568) := '34656D3B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E6D6F6E61636F2D746F6B656E697A65642D736F75726365207B5C6E5C7477686974652D73706163653A20766172282D2D7673636F64652D686F7665722D736F7572636557686974655370';
wwv_flow_imp.g_varchar2_table(569) := '6163652C207072652D77726170293B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D726F772E7374617475732D626172207B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C746C696E652D6865696768743A2032327078';
wwv_flow_imp.g_varchar2_table(570) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D726F772E7374617475732D626172202E696E666F207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E5C7470616464696E673A20307078203870783B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(571) := '5C6E2E6D6F6E61636F2D686F766572202E686F7665722D726F772E7374617475732D626172202E616374696F6E73207B5C6E5C74646973706C61793A20666C65783B5C6E5C7470616464696E673A20307078203870783B5C6E5C7477696474683A203130';
wwv_flow_imp.g_varchar2_table(572) := '30253B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D726F772E7374617475732D626172202E616374696F6E73202E616374696F6E2D636F6E7461696E6572207B5C6E5C746D617267696E2D72696768743A20313670783B5C6E5C';
wwv_flow_imp.g_varchar2_table(573) := '74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D726F772E7374617475732D626172202E616374696F6E73202E616374696F6E2D636F6E7461696E6572202E616374696F6E202E69636F6E';
wwv_flow_imp.g_varchar2_table(574) := '207B5C6E5C7470616464696E672D72696768743A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E6D61726B646F776E2D686F766572202E686F7665722D636F6E74656E7473202E636F6469636F6E207B5C6E5C74636F6C6F723A2069';
wwv_flow_imp.g_varchar2_table(575) := '6E68657269743B5C6E5C74666F6E742D73697A653A20696E68657269743B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D636F6E74656E747320612E636F6465';
wwv_flow_imp.g_varchar2_table(576) := '2D6C696E6B3A686F7665722C5C6E2E6D6F6E61636F2D686F766572202E686F7665722D636F6E74656E747320612E636F64652D6C696E6B207B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F';
wwv_flow_imp.g_varchar2_table(577) := '7665722D636F6E74656E747320612E636F64652D6C696E6B3A6265666F7265207B5C6E5C74636F6E74656E743A202728273B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D636F6E74656E747320612E636F64652D6C696E6B3A61';
wwv_flow_imp.g_varchar2_table(578) := '66746572207B5C6E5C74636F6E74656E743A202729273B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F7665722D636F6E74656E747320612E636F64652D6C696E6B203E207370616E207B5C6E5C74746578742D6465636F726174696F6E3A';
wwv_flow_imp.g_varchar2_table(579) := '20756E6465726C696E653B5C6E5C742F2A2A204861636B20746F20666F72636520756E6465726C696E6520746F2073686F77202A2A2F5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C6964207472616E73706172656E743B5C6E5C7474';
wwv_flow_imp.g_varchar2_table(580) := '6578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572202E686F76';
wwv_flow_imp.g_varchar2_table(581) := '65722D636F6E74656E747320612E636F64652D6C696E6B203E207370616E3A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E5C6E2F2A2A20';
wwv_flow_imp.g_varchar2_table(582) := '5370616E7320696E206D61726B646F776E20686F76657273206E6565642061206D617267696E2D626F74746F6D20746F2061766F6964206C6F6F6B696E67206372616D7065643A2068747470733A2F2F6769746875622E636F6D2F6D6963726F736F6674';
wwv_flow_imp.g_varchar2_table(583) := '2F7673636F64652F6973737565732F313031343936202A2A2F5C6E2E6D6F6E61636F2D686F766572202E6D61726B646F776E2D686F766572202E686F7665722D636F6E74656E74733A6E6F74282E636F64652D686F7665722D636F6E74656E7473293A6E';
wwv_flow_imp.g_varchar2_table(584) := '6F74282E68746D6C2D686F7665722D636F6E74656E747329207370616E207B5C6E5C746D617267696E2D626F74746F6D3A203470783B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572';
wwv_flow_imp.g_varchar2_table(585) := '2D636F6E74656E74207B5C6E5C7470616464696E672D72696768743A203270783B5C6E5C7470616464696E672D626F74746F6D3A203270783B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E5C6E2E6D6F6E61636F2D68';
wwv_flow_imp.g_varchar2_table(586) := '6F7665722D636F6E74656E74202E616374696F6E2D636F6E7461696E65722061207B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(587) := '2D686F7665722D636F6E74656E74202E616374696F6E2D636F6E7461696E65722E64697361626C6564207B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E5C746F7061636974793A20302E343B5C6E5C74637572736F723A20646566';
wwv_flow_imp.g_varchar2_table(588) := '61756C743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383133343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E28';
wwv_flow_imp.g_varchar2_table(589) := '36333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(590) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A2020';
wwv_flow_imp.g_varchar2_table(591) := '4C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D';
wwv_flow_imp.g_varchar2_table(592) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A202D2D2D';
wwv_flow_imp.g_varchar2_table(593) := '2D2D2D2D2D2D2D2049636F6E206C6162656C202D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C207B5C6E5C74646973706C61793A20666C65783B202F2A20726571756972656420666F722069636F6E7320737570';
wwv_flow_imp.g_varchar2_table(594) := '706F7274203A6265666F72652072756C65202A2F5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C3A3A6265666F';
wwv_flow_imp.g_varchar2_table(595) := '7265207B5C6E5C6E5C742F2A207376672069636F6E732072656E6465726564206173206261636B67726F756E6420696D616765202A2F5C6E5C746261636B67726F756E642D73697A653A20313670783B5C6E5C746261636B67726F756E642D706F736974';
wwv_flow_imp.g_varchar2_table(596) := '696F6E3A206C6566742063656E7465723B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C7470616464696E672D72696768743A203670783B5C6E5C7477696474683A20313670783B5C6E5C746865696768743A';
wwv_flow_imp.g_varchar2_table(597) := '20323270783B5C6E5C746C696E652D6865696768743A20696E68657269742021696D706F7274616E743B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C6E5C742F2A20666F6E74732069636F6E73202A2F5C6E5C742D7765626B';
wwv_flow_imp.g_varchar2_table(598) := '69742D666F6E742D736D6F6F7468696E673A20616E7469616C69617365643B5C6E5C742D6D6F7A2D6F73782D666F6E742D736D6F6F7468696E673A20677261797363616C653B5C6E5C74766572746963616C2D616C69676E3A20746F703B5C6E5C6E5C74';
wwv_flow_imp.g_varchar2_table(599) := '666C65782D736872696E6B3A20303B202F2A2066697820666F722068747470733A2F2F6769746875622E636F6D2F6D6963726F736F66742F7673636F64652F6973737565732F3133373837202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C61';
wwv_flow_imp.g_varchar2_table(600) := '62656C2D636F6E7461696E65722E64697361626C6564207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D64697361626C6564466F726567726F756E64293B5C6E7D5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C203E202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(601) := '6F2D69636F6E2D6C6162656C2D636F6E7461696E6572207B5C6E5C746D696E2D77696474683A20303B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C74666C65783A20';
wwv_flow_imp.g_varchar2_table(602) := '313B5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6E616D652D636F6E7461696E6572203E202E6C6162656C2D6E61';
wwv_flow_imp.g_varchar2_table(603) := '6D65207B5C6E5C74636F6C6F723A20696E68657269743B5C6E5C7477686974652D73706163653A207072653B202F2A20656E61626C6520746F2073686F77206C6162656C73207468617420696E636C756465206D756C7469706C65207768697465737061';
wwv_flow_imp.g_varchar2_table(604) := '636573202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6E616D652D636F6E7461696E6572203E202E6C616265';
wwv_flow_imp.g_varchar2_table(605) := '6C2D6E616D65203E202E6C6162656C2D736570617261746F72207B5C6E5C746D617267696E3A2030203270783B5C6E5C746F7061636974793A20302E353B5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C203E202E6D6F6E61636F2D6963';
wwv_flow_imp.g_varchar2_table(606) := '6F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D7375666669782D636F6E7461696E6572203E202E6C6162656C2D737566666978207B5C6E5C746F7061636974793A202E373B5C6E5C7477686974652D73706163653A';
wwv_flow_imp.g_varchar2_table(607) := '207072653B5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6465736372697074696F6E2D636F6E7461696E6572203E';
wwv_flow_imp.g_varchar2_table(608) := '202E6C6162656C2D6465736372697074696F6E207B5C6E5C746F7061636974793A202E373B5C6E5C746D617267696E2D6C6566743A20302E35656D3B5C6E5C74666F6E742D73697A653A20302E39656D3B5C6E5C7477686974652D73706163653A207072';
wwv_flow_imp.g_varchar2_table(609) := '653B202F2A20656E61626C6520746F2073686F77206C6162656C73207468617420696E636C756465206D756C7469706C65207768697465737061636573202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E6E6F77726170203E202E';
wwv_flow_imp.g_varchar2_table(610) := '6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6465736372697074696F6E2D636F6E7461696E6572203E202E6C6162656C2D6465736372697074696F6E7B5C6E5C7477686974652D73706163';
wwv_flow_imp.g_varchar2_table(611) := '653A206E6F777261705C6E7D5C6E5C6E2E7673202E6D6F6E61636F2D69636F6E2D6C6162656C203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6465736372697074696F6E2D636F6E';
wwv_flow_imp.g_varchar2_table(612) := '7461696E6572203E202E6C6162656C2D6465736372697074696F6E207B5C6E5C746F7061636974793A202E39353B5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E6974616C6963203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D';
wwv_flow_imp.g_varchar2_table(613) := '636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6E616D652D636F6E7461696E6572203E202E6C6162656C2D6E616D652C5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E6974616C6963203E202E6D6F6E61636F2D69636F6E2D6C6162';
wwv_flow_imp.g_varchar2_table(614) := '656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6465736372697074696F6E2D636F6E7461696E6572203E202E6C6162656C2D6465736372697074696F6E207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(615) := '5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E64657072656361746564207B5C6E5C74746578742D6465636F726174696F6E3A206C696E652D7468726F7567683B5C6E5C746F7061636974793A20302E36363B5C6E7D5C6E5C6E2F2A206D616B6520';
wwv_flow_imp.g_varchar2_table(616) := '73757265206170706C79206974616C696320666F6E74207374796C6520746F206465636F726174696F6E732061732077656C6C202A2F5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E6974616C69633A3A6166746572207B5C6E5C74666F6E742D73';
wwv_flow_imp.g_varchar2_table(617) := '74796C653A206974616C69633B5C6E7D5C6E5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E737472696B657468726F756768203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6E';
wwv_flow_imp.g_varchar2_table(618) := '616D652D636F6E7461696E6572203E202E6C6162656C2D6E616D652C5C6E2E6D6F6E61636F2D69636F6E2D6C6162656C2E737472696B657468726F756768203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E';
wwv_flow_imp.g_varchar2_table(619) := '61636F2D69636F6E2D6465736372697074696F6E2D636F6E7461696E6572203E202E6C6162656C2D6465736372697074696F6E207B5C6E5C74746578742D6465636F726174696F6E3A206C696E652D7468726F7567683B5C6E7D5C6E5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(620) := '6F2D69636F6E2D6C6162656C3A3A6166746572207B5C6E5C746F7061636974793A20302E37353B5C6E5C74666F6E742D73697A653A203930253B5C6E5C74666F6E742D7765696768743A203630303B5C6E5C746D617267696E3A206175746F2031367078';
wwv_flow_imp.g_varchar2_table(621) := '2030203570783B202F2A2068747470733A2F2F6769746875622E636F6D2F6D6963726F736F66742F7673636F64652F6973737565732F313133323233202A2F5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E7D5C6E5C6E2F2A206D616B65';
wwv_flow_imp.g_varchar2_table(622) := '20737572652073656C656374696F6E20636F6C6F722077696E73207768656E2061206C6162656C206973206265696E672073656C6563746564202A2F5C6E2E6D6F6E61636F2D6C6973743A666F637573202E73656C6563746564202E6D6F6E61636F2D69';
wwv_flow_imp.g_varchar2_table(623) := '636F6E2D6C6162656C2C202F2A206C697374202A2F5C6E2E6D6F6E61636F2D6C6973743A666F637573202E73656C6563746564202E6D6F6E61636F2D69636F6E2D6C6162656C3A3A61667465725C6E7B5C6E5C74636F6C6F723A20696E68657269742021';
wwv_flow_imp.g_varchar2_table(624) := '696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742D726F772E666F63757365642E73656C6563746564202E6C6162656C2D6465736372697074696F6E2C5C6E2E6D6F6E61636F2D6C6973742D726F772E73656C6563746564202E6C';
wwv_flow_imp.g_varchar2_table(625) := '6162656C2D6465736372697074696F6E207B5C6E5C746F7061636974793A202E383B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313336363A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D';
wwv_flow_imp.g_varchar2_table(626) := '293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(627) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F';
wwv_flow_imp.g_varchar2_table(628) := '6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72';
wwv_flow_imp.g_varchar2_table(629) := '206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(630) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D696E707574626F78207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C7470616464696E673A20303B5C6E';
wwv_flow_imp.g_varchar2_table(631) := '5C74626F782D73697A696E673A5C74626F726465722D626F783B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C6E5C742F2A20437573746F6D697A61626C65202A2F5C6E5C74666F6E742D73697A653A20696E68657269743B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(632) := '6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E696E7075742C5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E6D6972726F72207B5C6E5C6E5C742F2A20437573746F6D';
wwv_flow_imp.g_varchar2_table(633) := '697A61626C65202A2F5C6E5C7470616464696E673A20347078203670783B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C747769647468';
wwv_flow_imp.g_varchar2_table(634) := '3A20313030253B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E696E707574207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C';
wwv_flow_imp.g_varchar2_table(635) := '74626F782D73697A696E673A5C74626F726465722D626F783B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C746C696E652D6865696768743A20696E68657269743B5C6E5C74626F726465723A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(636) := '5C6E5C74666F6E742D66616D696C793A20696E68657269743B5C6E5C74666F6E742D73697A653A20696E68657269743B5C6E5C74726573697A653A206E6F6E653B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E6D6F6E61636F2D69';
wwv_flow_imp.g_varchar2_table(637) := '6E707574626F78203E202E696277726170706572203E20696E707574207B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E20746578';
wwv_flow_imp.g_varchar2_table(638) := '74617265612E696E707574207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C747363726F6C6C6261722D77696474683A206E6F6E653B202F2A2046697265666F783A2068696465207363726F6C6C62617273202A2F5C6E5C746F75746C696E65';
wwv_flow_imp.g_varchar2_table(639) := '3A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E2074657874617265612E696E7075743A3A2D7765626B69742D7363726F6C6C626172207B5C6E5C74646973706C61793A206E6F6E653B20';
wwv_flow_imp.g_varchar2_table(640) := '2F2A204368726F6D65202B205361666172693A2068696465207363726F6C6C626172202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E2074657874617265612E696E7075742E656D707479207B5C6E';
wwv_flow_imp.g_varchar2_table(641) := '5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E6D6972726F72207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74646973';
wwv_flow_imp.g_varchar2_table(642) := '706C61793A20696E6C696E652D626C6F636B3B5C6E5C7477696474683A20313030253B5C6E5C74746F703A20303B5C6E5C746C6566743A20303B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C7477686974652D7370616365';
wwv_flow_imp.g_varchar2_table(643) := '3A207072652D777261703B5C6E5C747669736962696C6974793A2068696464656E3B5C6E5C74776F72642D777261703A20627265616B2D776F72643B5C6E7D5C6E5C6E2F2A20436F6E746578742076696577202A2F5C6E5C6E2E6D6F6E61636F2D696E70';
wwv_flow_imp.g_varchar2_table(644) := '7574626F782D636F6E7461696E6572207B5C6E5C74746578742D616C69676E3A2072696768743B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F782D636F6E7461696E6572202E6D6F6E61636F2D696E707574626F782D6D657373616765207B5C';
wwv_flow_imp.g_varchar2_table(645) := '6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D616C69676E3A206C6566743B5C6E5C7477696474683A20313030253B5C6E5C74626F782D73697A696E673A5C74';
wwv_flow_imp.g_varchar2_table(646) := '626F726465722D626F783B5C6E5C7470616464696E673A20302E34656D3B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C746C696E652D6865696768743A20313770783B5C6E5C746D617267696E2D746F703A202D3170783B5C6E5C74776F72';
wwv_flow_imp.g_varchar2_table(647) := '642D777261703A20627265616B2D776F72643B5C6E7D5C6E5C6E2F2A20416374696F6E2062617220737570706F7274202A2F5C6E2E6D6F6E61636F2D696E707574626F78202E6D6F6E61636F2D616374696F6E2D626172207B5C6E5C74706F736974696F';
wwv_flow_imp.g_varchar2_table(648) := '6E3A206162736F6C7574653B5C6E5C7472696768743A203270783B5C6E5C74746F703A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D207B5C6E5C';
wwv_flow_imp.g_varchar2_table(649) := '746D617267696E2D6C6566743A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D696E707574626F78202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E636F6469636F6E207B5C6E5C746261636B67726F756E642D72';
wwv_flow_imp.g_varchar2_table(650) := '65706561743A206E6F2D7265706561743B5C6E5C7477696474683A20313670783B5C6E5C746865696768743A20313670783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C353432323A28652C742C6E293D3E7B227573652073747269637422';
wwv_flow_imp.g_varchar2_table(651) := '3B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(652) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D696372';
wwv_flow_imp.g_varchar2_table(653) := '6F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E2074686520';
wwv_flow_imp.g_varchar2_table(654) := '70726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(655) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E746572';
wwv_flow_imp.g_varchar2_table(656) := '3B5C6E5C746C696E652D6865696768743A20313070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B';
wwv_flow_imp.g_varchar2_table(657) := '3B5C6E5C74626F726465722D7374796C653A20736F6C69643B5C6E5C74626F726465722D77696474683A203170783B5C6E5C74626F726465722D7261646975733A203370783B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E5C';
wwv_flow_imp.g_varchar2_table(658) := '74666F6E742D73697A653A20313170783B5C6E5C7470616464696E673A20337078203570783B5C6E5C746D617267696E3A2030203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E6469';
wwv_flow_imp.g_varchar2_table(659) := '6E672D6B65793A66697273742D6368696C64207B5C6E5C746D617267696E2D6C6566743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B65793A6C6173742D6368696C64';
wwv_flow_imp.g_varchar2_table(660) := '207B5C6E5C746D617267696E2D72696768743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B65792D736570617261746F72207B5C6E5C74646973706C61793A20696E6C';
wwv_flow_imp.g_varchar2_table(661) := '696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B65792D63686F72642D736570617261746F72207B5C6E5C7477696474683A203670783B5C6E7D5C6E222C';
wwv_flow_imp.g_varchar2_table(662) := '22225D293B636F6E737420613D727D2C373334303A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E28';
wwv_flow_imp.g_varchar2_table(663) := '73292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(664) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64';
wwv_flow_imp.g_varchar2_table(665) := '657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(666) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D6C697374207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(667) := '706F736974696F6E3A2072656C61746976653B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A20313030253B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742E6D6F7573';
wwv_flow_imp.g_varchar2_table(668) := '652D737570706F7274207B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C697374203E202E6D6F6E61636F2D7363726F6C6C61';
wwv_flow_imp.g_varchar2_table(669) := '626C652D656C656D656E74207B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742D726F7773207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C7477696474683A20313030253B5C6E5C7468';
wwv_flow_imp.g_varchar2_table(670) := '65696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742E686F72697A6F6E74616C2D7363726F6C6C696E67202E6D6F6E61636F2D6C6973742D726F7773207B5C6E5C7477696474683A206175746F3B5C6E5C746D696E2D77696474';
wwv_flow_imp.g_varchar2_table(671) := '683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742D726F77207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746F766572666C6F773A20686964';
wwv_flow_imp.g_varchar2_table(672) := '64656E3B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742E6D6F7573652D737570706F7274202E6D6F6E61636F2D6C6973742D726F77207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74746F7563';
wwv_flow_imp.g_varchar2_table(673) := '682D616374696F6E3A206E6F6E653B5C6E7D5C6E5C6E2F2A204D616B65207375726520746865207363726F6C6C6261722072656E646572732061626F7665206F7665726C6179732028737469636B79207363726F6C6C29202A2F5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(674) := '6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C6261722E766572746963616C2C5C6E2E6D6F6E61636F2D70616E652D76696577203E202E6D6F6E61636F2D73706C69742D76696577322E76657274';
wwv_flow_imp.g_varchar2_table(675) := '6963616C203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C6261722E766572746963616C207B5C6E5C747A2D696E6465783A2031343B5C6E7D5C6E5C6E2F2A20666F72204F5320582062616C6C69737469';
wwv_flow_imp.g_varchar2_table(676) := '63207363726F6C6C696E67202A2F5C6E2E6D6F6E61636F2D6C6973742D726F772E7363726F6C6C696E67207B5C6E5C74646973706C61793A206E6F6E652021696D706F7274616E743B5C6E7D5C6E5C6E2F2A20466F637573202A2F5C6E2E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(677) := '2D6C6973742E656C656D656E742D666F63757365642C5C6E2E6D6F6E61636F2D6C6973742E73656C656374696F6E2D73696E676C652C5C6E2E6D6F6E61636F2D6C6973742E73656C656374696F6E2D6D756C7469706C65207B5C6E5C746F75746C696E65';
wwv_flow_imp.g_varchar2_table(678) := '3A20302021696D706F7274616E743B5C6E7D5C6E5C6E2F2A20446E64202A2F5C6E2E6D6F6E61636F2D647261672D696D616765207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C7470616464696E673A20317078203770783B';
wwv_flow_imp.g_varchar2_table(679) := '5C6E5C74626F726465722D7261646975733A20313070783B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747A2D696E6465783A20313030303B5C6E7D5C6E5C6E2F2A2046696C7465';
wwv_flow_imp.g_varchar2_table(680) := '72202A2F5C6E5C6E2E6D6F6E61636F2D6C6973742D747970652D66696C7465722D6D657373616765207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C7477696474';
wwv_flow_imp.g_varchar2_table(681) := '683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C74746F703A20303B5C6E5C746C6566743A20303B5C6E5C7470616464696E673A20343070782031656D2031656D2031656D3B5C6E5C74746578742D616C69676E3A2063656E746572';
wwv_flow_imp.g_varchar2_table(682) := '3B5C6E5C7477686974652D73706163653A206E6F726D616C3B5C6E5C746F7061636974793A20302E373B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C6973742D747970652D66696C7465722D6D';
wwv_flow_imp.g_varchar2_table(683) := '6573736167653A656D707479207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C3236363A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76';
wwv_flow_imp.g_varchar2_table(684) := '617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(685) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20';
wwv_flow_imp.g_varchar2_table(686) := '416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C69';
wwv_flow_imp.g_varchar2_table(687) := '63656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(688) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D6D6F7573652D637572736F722D74657874207B5C6E5C74637572736F723A20746578743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C343937383A28652C742C6E293D';
wwv_flow_imp.g_varchar2_table(689) := '3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D';
wwv_flow_imp.g_varchar2_table(690) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079';
wwv_flow_imp.g_varchar2_table(691) := '726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E';
wwv_flow_imp.g_varchar2_table(692) := '73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(693) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D70726F67726573732D636F6E7461696E6572207B5C6E5C7477696474683A20313030253B5C6E5C';
wwv_flow_imp.g_varchar2_table(694) := '746865696768743A203270783B5C6E5C746F766572666C6F773A2068696464656E3B202F2A206B6565702070726F67726573732062697420696E20626F756E6473202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D70726F67726573732D636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(695) := '72202E70726F67726573732D626974207B5C6E5C7477696474683A2032253B5C6E5C746865696768743A203270783B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A20303B5C6E5C74646973706C61793A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(696) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D70726F67726573732D636F6E7461696E65722E616374697665202E70726F67726573732D626974207B5C6E5C74646973706C61793A20696E68657269743B5C6E7D5C6E5C6E2E6D6F6E61636F2D70726F6772657373';
wwv_flow_imp.g_varchar2_table(697) := '2D636F6E7461696E65722E6469736372657465202E70726F67726573732D626974207B5C6E5C746C6566743A20303B5C6E5C747472616E736974696F6E3A207769647468203130306D73206C696E6561723B5C6E7D5C6E5C6E2E6D6F6E61636F2D70726F';
wwv_flow_imp.g_varchar2_table(698) := '67726573732D636F6E7461696E65722E64697363726574652E646F6E65202E70726F67726573732D626974207B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D70726F67726573732D636F6E7461696E65722E696E66696E';
wwv_flow_imp.g_varchar2_table(699) := '697465202E70726F67726573732D626974207B5C6E5C74616E696D6174696F6E2D6E616D653A2070726F67726573733B5C6E5C74616E696D6174696F6E2D6475726174696F6E3A2034733B5C6E5C74616E696D6174696F6E2D697465726174696F6E2D63';
wwv_flow_imp.g_varchar2_table(700) := '6F756E743A20696E66696E6974653B5C6E5C747472616E73666F726D3A207472616E736C6174653364283070782C203070782C20307078293B5C6E5C74616E696D6174696F6E2D74696D696E672D66756E6374696F6E3A206C696E6561723B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(701) := '5C6E2E6D6F6E61636F2D70726F67726573732D636F6E7461696E65722E696E66696E6974652E696E66696E6974652D6C6F6E672D72756E6E696E67202E70726F67726573732D626974207B5C6E5C742F2A5C6E5C745C74546865206D6F726520736D6F6F';
wwv_flow_imp.g_varchar2_table(702) := '746820606C696E656172602074696D696E672066756E6374696F6E2063616E2063617573655C6E5C745C746869676865722047505520636F6E73756D7074696F6E20617320696E6469636174656420696E5C6E5C745C7468747470733A2F2F6769746875';
wwv_flow_imp.g_varchar2_table(703) := '622E636F6D2F6D6963726F736F66742F7673636F64652F6973737565732F393739303020265C6E5C745C7468747470733A2F2F6769746875622E636F6D2F6D6963726F736F66742F7673636F64652F6973737565732F3133383339365C6E5C742A2F5C6E';
wwv_flow_imp.g_varchar2_table(704) := '5C74616E696D6174696F6E2D74696D696E672D66756E6374696F6E3A20737465707328313030293B5C6E7D5C6E5C6E2F2A2A5C6E202A205468652070726F6772657373206269742068617320612077696474683A2032252028312F353029206F66207468';
wwv_flow_imp.g_varchar2_table(705) := '6520706172656E7420636F6E7461696E65722E2054686520616E696D6174696F6E206D6F7665732069742066726F6D20302520746F2031303025206F665C6E202A207468617420636F6E7461696E65722E2053696E6365207472616E736C617465582069';
wwv_flow_imp.g_varchar2_table(706) := '732072656C617469766520746F207468652070726F6772657373206269742073697A652C207765206861766520746F206D756C7469706C6520697420776974685C6E202A206974732072656C61746976652073697A6520746F2074686520706172656E74';
wwv_flow_imp.g_varchar2_table(707) := '20636F6E7461696E65723A5C6E202A20706172656E742077696474683A2035303030255C6E202A202020206269742077696474683A20313030255C6E202A207472616E736C617465582073686F756C6420626520617320666F6C6C6F773A5C6E202A2020';
wwv_flow_imp.g_varchar2_table(708) := '3530253A203530303025202A20353025202D20353025202873657420746F2063656E74657229203D2032343530255C6E202A20313030253A203530303025202A2031303025202D20313030252028646F206E6F74206F766572666C6F7729203D20343930';
wwv_flow_imp.g_varchar2_table(709) := '30255C6E202A2F5C6E406B65796672616D65732070726F6772657373207B2066726F6D207B207472616E73666F726D3A207472616E736C6174655828302529207363616C6558283129207D20353025207B207472616E73666F726D3A207472616E736C61';
wwv_flow_imp.g_varchar2_table(710) := '74655828323530302529207363616C6558283329207D20746F207B207472616E73666F726D3A207472616E736C6174655828343930302529207363616C6558283129207D207D5C6E222C22225D293B636F6E737420613D727D2C343136363A28652C742C';
wwv_flow_imp.g_varchar2_table(711) := '6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A';
wwv_flow_imp.g_varchar2_table(712) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A202043';
wwv_flow_imp.g_varchar2_table(713) := '6F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C69';
wwv_flow_imp.g_varchar2_table(714) := '63656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(715) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E3A726F6F74207B5C6E5C742D2D7673636F64652D736173682D73697A653A203470783B5C6E5C742D2D767363';
wwv_flow_imp.g_varchar2_table(716) := '6F64652D736173682D686F7665722D73697A653A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73617368207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747A2D696E6465783A2033353B5C6E5C74746F7563682D616374696F';
wwv_flow_imp.g_varchar2_table(717) := '6E3A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E64697361626C6564207B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E6D61632E766572746963616C207B5C6E5C';
wwv_flow_imp.g_varchar2_table(718) := '74637572736F723A20636F6C2D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E766572746963616C2E6D696E696D756D207B5C6E5C74637572736F723A20652D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E76';
wwv_flow_imp.g_varchar2_table(719) := '6572746963616C2E6D6178696D756D207B5C6E5C74637572736F723A20772D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E6D61632E686F72697A6F6E74616C207B5C6E5C74637572736F723A20726F772D726573697A653B5C6E7D';
wwv_flow_imp.g_varchar2_table(720) := '5C6E5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C2E6D696E696D756D207B5C6E5C74637572736F723A20732D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C2E6D6178696D756D207B5C6E';
wwv_flow_imp.g_varchar2_table(721) := '5C74637572736F723A206E2D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E64697361626C6564207B5C6E5C74637572736F723A2064656661756C742021696D706F7274616E743B5C6E5C74706F696E7465722D6576656E74733A20';
wwv_flow_imp.g_varchar2_table(722) := '6E6F6E652021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E766572746963616C207B5C6E5C74637572736F723A2065772D726573697A653B5C6E5C74746F703A20303B5C6E5C7477696474683A20766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(723) := '64652D736173682D73697A65293B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C207B5C6E5C74637572736F723A206E732D726573697A653B5C6E5C746C6566743A20303B5C6E5C';
wwv_flow_imp.g_varchar2_table(724) := '7477696474683A20313030253B5C6E5C746865696768743A20766172282D2D7673636F64652D736173682D73697A65293B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173683A6E6F74282E64697361626C656429203E202E6F7274686F676F6E616C2D6472';
wwv_flow_imp.g_varchar2_table(725) := '61672D68616E646C65207B5C6E5C74636F6E74656E743A205C22205C223B5C6E5C746865696768743A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202A2032293B5C6E5C7477696474683A2063616C6328766172282D2D7673';
wwv_flow_imp.g_varchar2_table(726) := '636F64652D736173682D73697A6529202A2032293B5C6E5C747A2D696E6465783A203130303B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74637572736F723A20616C6C2D7363726F6C6C3B5C6E5C74706F736974696F6E3A206162736F6C75';
wwv_flow_imp.g_varchar2_table(727) := '74653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C2E6F7274686F676F6E616C2D656467652D6E6F7274683A6E6F74282E64697361626C6564295C6E5C743E202E6F7274686F676F6E616C2D647261672D68616E646C652E';
wwv_flow_imp.g_varchar2_table(728) := '73746172742C5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C2E6F7274686F676F6E616C2D656467652D736F7574683A6E6F74282E64697361626C6564295C6E5C743E202E6F7274686F676F6E616C2D647261672D68616E646C652E656E';
wwv_flow_imp.g_varchar2_table(729) := '64207B5C6E5C74637572736F723A206E7773652D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C2E6F7274686F676F6E616C2D656467652D6E6F7274683A6E6F74282E64697361626C6564295C6E5C743E20';
wwv_flow_imp.g_varchar2_table(730) := '2E6F7274686F676F6E616C2D647261672D68616E646C652E656E642C5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C2E6F7274686F676F6E616C2D656467652D736F7574683A6E6F74282E64697361626C6564295C6E5C743E202E6F7274';
wwv_flow_imp.g_varchar2_table(731) := '686F676F6E616C2D647261672D68616E646C652E7374617274207B5C6E5C74637572736F723A206E6573772D726573697A653B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E766572746963616C203E202E6F7274686F676F6E616C2D647261672D68';
wwv_flow_imp.g_varchar2_table(732) := '616E646C652E7374617274207B5C6E5C746C6566743A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202A202D302E35293B5C6E5C74746F703A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202A20';
wwv_flow_imp.g_varchar2_table(733) := '2D31293B5C6E7D5C6E2E6D6F6E61636F2D736173682E766572746963616C203E202E6F7274686F676F6E616C2D647261672D68616E646C652E656E64207B5C6E5C746C6566743A2063616C6328766172282D2D7673636F64652D736173682D73697A6529';
wwv_flow_imp.g_varchar2_table(734) := '202A202D302E35293B5C6E5C74626F74746F6D3A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202A202D31293B5C6E7D5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C203E202E6F7274686F676F6E616C2D64';
wwv_flow_imp.g_varchar2_table(735) := '7261672D68616E646C652E7374617274207B5C6E5C74746F703A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202A202D302E35293B5C6E5C746C6566743A2063616C6328766172282D2D7673636F64652D736173682D73697A';
wwv_flow_imp.g_varchar2_table(736) := '6529202A202D31293B5C6E7D5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E74616C203E202E6F7274686F676F6E616C2D647261672D68616E646C652E656E64207B5C6E5C74746F703A2063616C6328766172282D2D7673636F64652D73617368';
wwv_flow_imp.g_varchar2_table(737) := '2D73697A6529202A202D302E35293B5C6E5C7472696768743A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202A202D31293B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173683A6265666F7265207B5C6E5C74636F6E74656E74';
wwv_flow_imp.g_varchar2_table(738) := '3A2027273B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C746261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(739) := '3A207472616E73706172656E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E63683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D736173683A6265666F7265207B5C6E5C747472616E736974696F6E3A206261636B';
wwv_flow_imp.g_varchar2_table(740) := '67726F756E642D636F6C6F7220302E317320656173652D6F75743B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E686F7665723A6265666F72652C5C6E2E6D6F6E61636F2D736173682E6163746976653A6265666F7265207B5C6E5C746261636B6772';
wwv_flow_imp.g_varchar2_table(741) := '6F756E643A20766172282D2D7673636F64652D736173682D686F766572426F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E766572746963616C3A6265666F7265207B5C6E5C7477696474683A20766172282D2D7673636F64652D7361';
wwv_flow_imp.g_varchar2_table(742) := '73682D686F7665722D73697A65293B5C6E5C746C6566743A2063616C6328353025202D2028766172282D2D7673636F64652D736173682D686F7665722D73697A6529202F203229293B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E686F72697A6F6E';
wwv_flow_imp.g_varchar2_table(743) := '74616C3A6265666F7265207B5C6E5C746865696768743A20766172282D2D7673636F64652D736173682D686F7665722D73697A65293B5C6E5C74746F703A2063616C6328353025202D2028766172282D2D7673636F64652D736173682D686F7665722D73';
wwv_flow_imp.g_varchar2_table(744) := '697A6529202F203229293B5C6E7D5C6E5C6E2E706F696E7465722D6576656E74732D64697361626C6564207B5C6E5C74706F696E7465722D6576656E74733A206E6F6E652021696D706F7274616E743B5C6E7D5C6E5C6E2F2A2A204465627567202A2A2F';
wwv_flow_imp.g_varchar2_table(745) := '5C6E5C6E2E6D6F6E61636F2D736173682E6465627567207B5C6E5C746261636B67726F756E643A206379616E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E64656275672E64697361626C6564207B5C6E5C746261636B67726F756E643A20726762';
wwv_flow_imp.g_varchar2_table(746) := '6128302C203235352C203235352C20302E32293B5C6E7D5C6E5C6E2E6D6F6E61636F2D736173682E64656275673A6E6F74282E64697361626C656429203E202E6F7274686F676F6E616C2D647261672D68616E646C65207B5C6E5C746261636B67726F75';
wwv_flow_imp.g_varchar2_table(747) := '6E643A207265643B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C3134303A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D';
wwv_flow_imp.g_varchar2_table(748) := '6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(749) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A';
wwv_flow_imp.g_varchar2_table(750) := '20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D';
wwv_flow_imp.g_varchar2_table(751) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A2041';
wwv_flow_imp.g_varchar2_table(752) := '72726F7773202A2F5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E73637261207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74666F6E742D73697A653A20313170782021';
wwv_flow_imp.g_varchar2_table(753) := '696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E76697369626C65207B5C6E5C746F7061636974793A20313B5C6E5C6E5C742F2A204261636B67726F756E642072756C652061646465';
wwv_flow_imp.g_varchar2_table(754) := '6420666F7220494539202D20746F20616C6C6F7720636C69636B73206F6E20646F6D206E6F6465202A2F5C6E5C746261636B67726F756E643A7267626128302C302C302C30293B5C6E5C6E5C747472616E736974696F6E3A206F70616369747920313030';
wwv_flow_imp.g_varchar2_table(755) := '6D73206C696E6561723B5C6E5C742F2A20496E2066726F6E74206F66207065656B2076696577202A2F5C6E5C747A2D696E6465783A2031313B5C6E7D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E696E76697369626C';
wwv_flow_imp.g_varchar2_table(756) := '65207B5C6E5C746F7061636974793A20303B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E696E76697369626C652E66616465207B5C6E5C747472';
wwv_flow_imp.g_varchar2_table(757) := '616E736974696F6E3A206F706163697479203830306D73206C696E6561723B5C6E7D5C6E5C6E2F2A205363726F6C6C61626C6520436F6E74656E7420496E73657420536861646F77202A2F5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D';
wwv_flow_imp.g_varchar2_table(758) := '656E74203E202E736861646F77207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F772E746F';
wwv_flow_imp.g_varchar2_table(759) := '70207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74746F703A20303B5C6E5C746C6566743A203370783B5C6E5C746865696768743A203370783B5C6E5C7477696474683A20313030253B5C6E5C74626F782D736861646F773A20766172282D';
wwv_flow_imp.g_varchar2_table(760) := '2D7673636F64652D7363726F6C6C6261722D736861646F772920302036707820367078202D36707820696E7365743B5C6E7D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F772E6C656674207B5C6E5C7464';
wwv_flow_imp.g_varchar2_table(761) := '6973706C61793A20626C6F636B3B5C6E5C74746F703A203370783B5C6E5C746C6566743A20303B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A203370783B5C6E5C74626F782D736861646F773A20766172282D2D7673636F64652D';
wwv_flow_imp.g_varchar2_table(762) := '7363726F6C6C6261722D736861646F772920367078203020367078202D36707820696E7365743B5C6E7D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F772E746F702D6C6566742D636F726E6572207B5C6E';
wwv_flow_imp.g_varchar2_table(763) := '5C74646973706C61793A20626C6F636B3B5C6E5C74746F703A20303B5C6E5C746C6566743A20303B5C6E5C746865696768743A203370783B5C6E5C7477696474683A203370783B5C6E7D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D65';
wwv_flow_imp.g_varchar2_table(764) := '6E74203E202E736861646F772E746F702E6C656674207B5C6E5C74626F782D736861646F773A20766172282D2D7673636F64652D7363726F6C6C6261722D736861646F772920367078203020367078202D36707820696E7365743B5C6E7D5C6E5C6E2E6D';
wwv_flow_imp.g_varchar2_table(765) := '6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E736C69646572207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D7363726F6C6C626172536C696465722D6261636B6772';
wwv_flow_imp.g_varchar2_table(766) := '6F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E736C696465723A686F766572207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D73';
wwv_flow_imp.g_varchar2_table(767) := '63726F6C6C626172536C696465722D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E736C696465722E616374697665207B5C6E5C';
wwv_flow_imp.g_varchar2_table(768) := '746261636B67726F756E643A20766172282D2D7673636F64652D7363726F6C6C626172536C696465722D6163746976654261636B67726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C353037303A28652C742C6E293D3E7B2275';
wwv_flow_imp.g_varchar2_table(769) := '736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(770) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F707972696768';
wwv_flow_imp.g_varchar2_table(771) := '7420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74';
wwv_flow_imp.g_varchar2_table(772) := '787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(773) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F78207B5C6E5C7477696474683A20313030253B5C6E5C74637572736F723A20706F69';
wwv_flow_imp.g_varchar2_table(774) := '6E7465723B5C6E5C74626F726465722D7261646975733A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572207B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C74666F';
wwv_flow_imp.g_varchar2_table(775) := '6E742D7765696768743A206E6F726D616C3B5C6E5C74746578742D7472616E73666F726D3A206E6F6E653B5C6E7D5C6E5C6E2F2A2A20416374696F6E73202A2F5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E';
wwv_flow_imp.g_varchar2_table(776) := '73656C6563742D636F6E7461696E6572207B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E6D6F6E61636F2D73656C6563742D626F78207B5C6E5C';
wwv_flow_imp.g_varchar2_table(777) := '74637572736F723A20706F696E7465723B5C6E5C746D696E2D77696474683A2031303070783B5C6E5C746D696E2D6865696768743A20313870783B5C6E5C7470616464696E673A20327078203233707820327078203870783B5C6E7D5C6E5C6E2E6D6163';
wwv_flow_imp.g_varchar2_table(778) := '202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E6D6F6E61636F2D73656C6563742D626F78207B5C6E5C74666F6E742D73697A653A20313170783B5C6E5C74626F726465722D7261646975733A203570783B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(779) := '6E222C22225D293B636F6E737420613D727D2C373631393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E';
wwv_flow_imp.g_varchar2_table(780) := '2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(781) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420';
wwv_flow_imp.g_varchar2_table(782) := '756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(783) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A2055736520637573746F6D2043';
wwv_flow_imp.g_varchar2_table(784) := '5353207661727320746F206578706F73652070616464696E6720696E746F20706172656E742073656C65637420666F722070616464696E672063616C63756C6174696F6E202A2F5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E';
wwv_flow_imp.g_varchar2_table(785) := '2D70616464696E67207B5C6E5C742D2D64726F70646F776E2D70616464696E672D746F703A203170783B5C6E5C742D2D64726F70646F776E2D70616464696E672D626F74746F6D3A203170783B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(786) := '6F2D73656C6563742D626F782D64726F70646F776E2D70616464696E672C5C6E2E68632D6C69676874202E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D70616464696E67207B5C6E5C742D2D64726F70646F776E2D70616464696E';
wwv_flow_imp.g_varchar2_table(787) := '672D746F703A203370783B5C6E5C742D2D64726F70646F776E2D70616464696E672D626F74746F6D3A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572207B5C6E5C7464697370';
wwv_flow_imp.g_varchar2_table(788) := '6C61793A206E6F6E653B5C6E5C74626F782D73697A696E673A5C74626F726465722D626F783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D646574';
wwv_flow_imp.g_varchar2_table(789) := '61696C732D70616E65203E202E73656C6563742D626F782D6465736372697074696F6E2D6D61726B646F776E202A207B5C6E5C746D617267696E3A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E';
wwv_flow_imp.g_varchar2_table(790) := '7461696E6572203E202E73656C6563742D626F782D64657461696C732D70616E65203E202E73656C6563742D626F782D6465736372697074696F6E2D6D61726B646F776E20613A666F637573207B5C6E5C746F75746C696E653A2031707820736F6C6964';
wwv_flow_imp.g_varchar2_table(791) := '202D7765626B69742D666F6375732D72696E672D636F6C6F723B5C6E5C746F75746C696E652D6F66667365743A202D3170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73';
wwv_flow_imp.g_varchar2_table(792) := '656C6563742D626F782D64657461696C732D70616E65203E202E73656C6563742D626F782D6465736372697074696F6E2D6D61726B646F776E20636F6465207B5C6E5C746C696E652D6865696768743A20313570783B202F2A2A20466F7220736F6D6520';
wwv_flow_imp.g_varchar2_table(793) := '726561736F6E2C2074686973206973206E65656465642C206F7468657277697365203C636F64653E2077696C6C2074616B65207570203230707820686569676874202A2F5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F';
wwv_flow_imp.g_varchar2_table(794) := '6E6F73706163652D666F6E74293B5C6E7D5C6E5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E65722E76697369626C65207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972';
wwv_flow_imp.g_varchar2_table(795) := '656374696F6E3A20636F6C756D6E3B5C6E5C74746578742D616C69676E3A206C6566743B5C6E5C7477696474683A203170783B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74626F726465722D626F74746F6D2D6C6566742D7261646975';
wwv_flow_imp.g_varchar2_table(796) := '733A203370783B5C6E5C74626F726465722D626F74746F6D2D72696768742D7261646975733A203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F';
wwv_flow_imp.g_varchar2_table(797) := '782D64726F70646F776E2D6C6973742D636F6E7461696E6572207B5C6E5C74666C65783A20302030206175746F3B5C6E5C74616C69676E2D73656C663A20666C65782D73746172743B5C6E5C7470616464696E672D746F703A20766172282D2D64726F70';
wwv_flow_imp.g_varchar2_table(798) := '646F776E2D70616464696E672D746F70293B5C6E5C7470616464696E672D626F74746F6D3A20766172282D2D64726F70646F776E2D70616464696E672D626F74746F6D293B5C6E5C7470616464696E672D6C6566743A203170783B5C6E5C747061646469';
wwv_flow_imp.g_varchar2_table(799) := '6E672D72696768743A203170783B5C6E5C7477696474683A20313030253B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74626F782D73697A696E673A5C74626F726465722D626F783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C656374';
wwv_flow_imp.g_varchar2_table(800) := '2D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64657461696C732D70616E65207B5C6E5C7470616464696E673A203570783B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D73656C656374';
wwv_flow_imp.g_varchar2_table(801) := '2D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572207B5C6E5C7470616464696E672D746F703A20766172282D2D64726F70646F776E2D7061646469';
wwv_flow_imp.g_varchar2_table(802) := '6E672D746F70293B5C6E5C7470616464696E672D626F74746F6D3A20766172282D2D64726F70646F776E2D70616464696E672D626F74746F6D293B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E746169';
wwv_flow_imp.g_varchar2_table(803) := '6E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(804) := '2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973';
wwv_flow_imp.g_varchar2_table(805) := '742D726F77203E202E6F7074696F6E2D74657874207B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C7470616464696E672D6C6566743A20332E3570783B5C6E5C7477';
wwv_flow_imp.g_varchar2_table(806) := '686974652D73706163653A206E6F777261703B5C6E5C74666C6F61743A206C6566743B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F';
wwv_flow_imp.g_varchar2_table(807) := '776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E6F7074696F6E2D64657461696C207B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F76';
wwv_flow_imp.g_varchar2_table(808) := '6572666C6F773A2068696464656E3B5C6E5C7470616464696E672D6C6566743A20332E3570783B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74666C6F61743A206C6566743B5C6E5C746F7061636974793A20302E373B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(809) := '6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(810) := '6C6973742D726F77203E202E6F7074696F6E2D6465636F7261746F722D7269676874207B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C7470616464696E672D726967';
wwv_flow_imp.g_varchar2_table(811) := '68743A20313070783B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74666C6F61743A2072696768743B5C6E7D5C6E5C6E5C6E2F2A2041636365707465642043535320686964696E6720746563686E6971756520666F722061636365';
wwv_flow_imp.g_varchar2_table(812) := '73736962696C69747920726561646572207465787420202A2F5C6E2F2A2068747470733A2F2F77656261696D2E6F72672F746563686E69717565732F6373732F696E76697369626C65636F6E74656E742F202A2F5C6E5C6E2E6D6F6E61636F2D73656C65';
wwv_flow_imp.g_varchar2_table(813) := '63742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E766973';
wwv_flow_imp.g_varchar2_table(814) := '75616C6C792D68696464656E207B5C6E5C745C74706F736974696F6E3A206162736F6C7574653B5C6E5C745C746C6566743A202D313030303070783B5C6E5C745C74746F703A206175746F3B5C6E5C745C7477696474683A203170783B5C6E5C745C7468';
wwv_flow_imp.g_varchar2_table(815) := '65696768743A203170783B5C6E5C745C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F77';
wwv_flow_imp.g_varchar2_table(816) := '6E2D636F6E7461696E65722D77696474682D636F6E74726F6C207B5C6E5C74666C65783A20312031206175746F3B5C6E5C74616C69676E2D73656C663A20666C65782D73746172743B5C6E5C746F7061636974793A20303B5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(817) := '636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D636F6E7461696E65722D77696474682D636F6E74726F6C203E202E77696474682D636F6E74726F6C2D646976';
wwv_flow_imp.g_varchar2_table(818) := '207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C746D61782D6865696768743A203070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F';
wwv_flow_imp.g_varchar2_table(819) := '782D64726F70646F776E2D636F6E7461696E65722D77696474682D636F6E74726F6C203E202E77696474682D636F6E74726F6C2D646976203E202E6F7074696F6E2D746578742D77696474682D636F6E74726F6C207B5C6E5C7470616464696E672D6C65';
wwv_flow_imp.g_varchar2_table(820) := '66743A203470783B5C6E5C7470616464696E672D72696768743A203870783B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C333437343A28652C742C6E293D3E7B22757365207374';
wwv_flow_imp.g_varchar2_table(821) := '72696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(822) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329';
wwv_flow_imp.g_varchar2_table(823) := '204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E';
wwv_flow_imp.g_varchar2_table(824) := '207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(825) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D73706C69742D7669657732207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C7477696474683A2031';
wwv_flow_imp.g_varchar2_table(826) := '3030253B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D7669657732203E202E736173682D636F6E7461696E6572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A';
wwv_flow_imp.g_varchar2_table(827) := '20313030253B5C6E5C746865696768743A20313030253B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D7669657732203E202E736173682D636F6E7461696E6572203E202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(828) := '636F2D73617368207B5C6E5C74706F696E7465722D6576656E74733A20696E697469616C3B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D7669657732203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74207B5C6E5C747769';
wwv_flow_imp.g_varchar2_table(829) := '6474683A20313030253B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D7669657732203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C69742D766965772D636F6E';
wwv_flow_imp.g_varchar2_table(830) := '7461696E6572207B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(831) := '636F2D73706C69742D7669657732203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C69742D766965772D636F6E7461696E6572203E202E73706C69742D766965772D76696577207B5C6E5C7477686974652D7370';
wwv_flow_imp.g_varchar2_table(832) := '6163653A20696E697469616C3B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D7669657732203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C6974';
wwv_flow_imp.g_varchar2_table(833) := '2D766965772D636F6E7461696E6572203E202E73706C69742D766965772D766965773A6E6F74282E76697369626C6529207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D76696577322E7665727469';
wwv_flow_imp.g_varchar2_table(834) := '63616C203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C69742D766965772D636F6E7461696E6572203E202E73706C69742D766965772D76696577207B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(835) := '2E6D6F6E61636F2D73706C69742D76696577322E686F72697A6F6E74616C203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C69742D766965772D636F6E7461696E6572203E202E73706C69742D766965772D7669';
wwv_flow_imp.g_varchar2_table(836) := '6577207B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D76696577322E736570617261746F722D626F72646572203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C';
wwv_flow_imp.g_varchar2_table(837) := '69742D766965772D636F6E7461696E6572203E202E73706C69742D766965772D766965773A6E6F74283A66697273742D6368696C64293A3A6265666F7265207B5C6E5C74636F6E74656E743A202720273B5C6E5C74706F736974696F6E3A206162736F6C';
wwv_flow_imp.g_varchar2_table(838) := '7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A20303B5C6E5C747A2D696E6465783A20353B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7365706172';
wwv_flow_imp.g_varchar2_table(839) := '61746F722D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D76696577322E736570617261746F722D626F726465722E686F72697A6F6E74616C203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E';
wwv_flow_imp.g_varchar2_table(840) := '73706C69742D766965772D636F6E7461696E6572203E202E73706C69742D766965772D766965773A6E6F74283A66697273742D6368696C64293A3A6265666F7265207B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A203170783B5C';
wwv_flow_imp.g_varchar2_table(841) := '6E7D5C6E5C6E2E6D6F6E61636F2D73706C69742D76696577322E736570617261746F722D626F726465722E766572746963616C203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E73706C69742D766965772D636F6E7461';
wwv_flow_imp.g_varchar2_table(842) := '696E6572203E202E73706C69742D766965772D766965773A6E6F74283A66697273742D6368696C64293A3A6265666F7265207B5C6E5C746865696768743A203170783B5C6E5C7477696474683A20313030253B5C6E7D5C6E222C22225D293B636F6E7374';
wwv_flow_imp.g_varchar2_table(843) := '20613D727D2C343233343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B';
wwv_flow_imp.g_varchar2_table(844) := '722E70757368285B652E69642C272F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(845) := '2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954';
wwv_flow_imp.g_varchar2_table(846) := '204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(847) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D7461626C65207B5C6E5C74646973706C61793A20';
wwv_flow_imp.g_varchar2_table(848) := '666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A20313030253B5C6E5C7477686974652D7370';
wwv_flow_imp.g_varchar2_table(849) := '6163653A206E6F777261703B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D73706C69742D7669657732207B5C6E5C74626F726465722D626F74746F6D3A2031707820';
wwv_flow_imp.g_varchar2_table(850) := '736F6C6964207472616E73706172656E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D6C697374207B5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D7461626C652D7472207B5C6E5C7464697370';
wwv_flow_imp.g_varchar2_table(851) := '6C61793A20666C65783B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D7461626C652D7468207B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C74666F6E742D776569676874';
wwv_flow_imp.g_varchar2_table(852) := '3A20626F6C643B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E7D5C6E5C6E2E6D6F6E61636F2D7461626C652D74682C5C6E2E6D6F6E61636F2D7461626C652D7464207B';
wwv_flow_imp.g_varchar2_table(853) := '5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74666C65782D736872696E6B3A20303B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74746578742D';
wwv_flow_imp.g_varchar2_table(854) := '6F766572666C6F773A20656C6C69707369733B5C6E7D5C6E5C6E2E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D73706C69742D7669657732202E6D6F6E61636F2D736173682E766572746963616C3A3A6265666F7265207B5C6E5C74636F6E';
wwv_flow_imp.g_varchar2_table(855) := '74656E743A2022223B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A2063616C6328766172282D2D7673636F64652D736173682D73697A6529202F2032293B5C6E5C7477696474683A20303B5C6E5C74626F726465722D';
wwv_flow_imp.g_varchar2_table(856) := '6C6566743A2031707820736F6C6964207472616E73706172656E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E63683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D73706C';
wwv_flow_imp.g_varchar2_table(857) := '69742D76696577322C5C6E2E6D6F6E61636F2D776F726B62656E63683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D73706C69742D7669657732202E6D6F6E61636F2D736173682E7665';
wwv_flow_imp.g_varchar2_table(858) := '72746963616C3A3A6265666F7265207B5C6E5C747472616E736974696F6E3A20626F726465722D636F6C6F7220302E327320656173652D6F75743B5C6E7D5C6E272C22225D293B636F6E737420613D727D2C323531363A28652C742C6E293D3E7B227573';
wwv_flow_imp.g_varchar2_table(859) := '6520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(860) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F70797269676874';
wwv_flow_imp.g_varchar2_table(861) := '20286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E7478';
wwv_flow_imp.g_varchar2_table(862) := '7420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(863) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D637573746F6D2D746F67676C65207B5C6E5C746D617267696E2D6C6566743A203270783B5C6E5C74666C6F61';
wwv_flow_imp.g_varchar2_table(864) := '743A206C6566743B5C6E5C74637572736F723A20706F696E7465723B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C7477696474683A20323070783B5C6E5C746865696768743A20323070783B5C6E5C74626F726465722D7261646975733A';
wwv_flow_imp.g_varchar2_table(865) := '203370783B5C6E5C74626F726465723A2031707820736F6C6964207472616E73706172656E743B5C6E5C7470616464696E673A203170783B5C6E5C74626F782D73697A696E673A5C74626F726465722D626F783B5C6E5C74757365722D73656C6563743A';
wwv_flow_imp.g_varchar2_table(866) := '206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D637573746F6D2D746F67676C653A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(867) := '7673636F64652D696E7075744F7074696F6E2D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D637573746F6D2D746F67676C653A686F7665722C5C6E2E68632D6C69676874202E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(868) := '2D637573746F6D2D746F67676C653A686F766572207B5C6E5C74626F726465723A203170782064617368656420766172282D2D7673636F64652D666F637573426F72646572293B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D63757374';
wwv_flow_imp.g_varchar2_table(869) := '6F6D2D746F67676C652C5C6E2E68632D6C69676874202E6D6F6E61636F2D637573746F6D2D746F67676C65207B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D637573746F6D2D746F';
wwv_flow_imp.g_varchar2_table(870) := '67676C653A686F7665722C5C6E2E68632D6C69676874202E6D6F6E61636F2D637573746F6D2D746F67676C653A686F766572207B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D637573746F6D2D746F67676C';
wwv_flow_imp.g_varchar2_table(871) := '652E6D6F6E61636F2D636865636B626F78207B5C6E5C746865696768743A20313870783B5C6E5C7477696474683A20313870783B5C6E5C74626F726465723A2031707820736F6C6964207472616E73706172656E743B5C6E5C74626F726465722D726164';
wwv_flow_imp.g_varchar2_table(872) := '6975733A203370783B5C6E5C746D617267696E2D72696768743A203970783B5C6E5C746D617267696E2D6C6566743A203070783B5C6E5C7470616464696E673A203070783B5C6E5C746F7061636974793A20313B5C6E5C746261636B67726F756E642D73';
wwv_flow_imp.g_varchar2_table(873) := '697A653A20313670782021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E636865636B626F782D616374696F6E2D6974656D207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974';
wwv_flow_imp.g_varchar2_table(874) := '656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E636865636B626F782D616374696F6E2D6974656D203E202E6D6F6E61636F2D637573746F6D2D746F67676C652E6D6F6E61636F2D636865636B626F7820';
wwv_flow_imp.g_varchar2_table(875) := '7B5C6E5C746D617267696E2D72696768743A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E636865636B626F782D616374696F6E2D6974656D203E202E636865636B626F782D6C6162656C207B5C6E5C74666F6E742D73';
wwv_flow_imp.g_varchar2_table(876) := '697A653A20313270783B5C6E7D5C6E5C6E2F2A206869646520636865636B207768656E20756E636865636B6564202A2F5C6E2E6D6F6E61636F2D637573746F6D2D746F67676C652E6D6F6E61636F2D636865636B626F783A6E6F74282E636865636B6564';
wwv_flow_imp.g_varchar2_table(877) := '293A3A6265666F7265207B5C6E5C747669736962696C6974793A2068696464656E3B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C373938323A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D';
wwv_flow_imp.g_varchar2_table(878) := '293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(879) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F';
wwv_flow_imp.g_varchar2_table(880) := '6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72';
wwv_flow_imp.g_varchar2_table(881) := '206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(882) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D746F6F6C626172207B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D746F6F6C626172202E746F6F6C6261722D746F67676C652D6D6F7265';
wwv_flow_imp.g_varchar2_table(883) := '207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C7470616464696E673A20303B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313936333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C';
wwv_flow_imp.g_varchar2_table(884) := '7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C272F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(885) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F66742043';
wwv_flow_imp.g_varchar2_table(886) := '6F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A656374';
wwv_flow_imp.g_varchar2_table(887) := '20726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(888) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D746C2D726F77207B5C6E5C74646973706C61793A20666C65783B5C6E5C746865696768743A20313030253B5C6E5C74616C69676E2D6974656D733A20';
wwv_flow_imp.g_varchar2_table(889) := '63656E7465723B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E2E6D6F6E61636F2D746C2D726F772E64697361626C6564207B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E2E6D6F6E61636F2D746C2D696E';
wwv_flow_imp.g_varchar2_table(890) := '64656E74207B5C6E5C746865696768743A20313030253B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A20313670783B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D';
wwv_flow_imp.g_varchar2_table(891) := '5C6E5C6E2E686964652D6172726F7773202E6D6F6E61636F2D746C2D696E64656E74207B5C6E5C746C6566743A20313270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D746C2D696E64656E74203E202E696E64656E742D6775696465207B5C6E5C74646973';
wwv_flow_imp.g_varchar2_table(892) := '706C61793A20696E6C696E652D626C6F636B3B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746865696768743A20313030253B5C6E5C74626F726465722D6C6566743A2031707820736F6C6964207472616E73706172656E';
wwv_flow_imp.g_varchar2_table(893) := '743B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E63683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D746C2D696E64656E74203E202E696E64656E742D6775696465207B5C6E5C747472616E736974696F6E3A20626F';
wwv_flow_imp.g_varchar2_table(894) := '726465722D636F6C6F7220302E3173206C696E6561723B5C6E7D5C6E5C6E2E6D6F6E61636F2D746C2D747769737469652C5C6E2E6D6F6E61636F2D746C2D636F6E74656E7473207B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(895) := '61636F2D746C2D74776973746965207B5C6E5C74666F6E742D73697A653A20313070783B5C6E5C74746578742D616C69676E3A2072696768743B5C6E5C7470616464696E672D72696768743A203670783B5C6E5C74666C65782D736872696E6B3A20303B';
wwv_flow_imp.g_varchar2_table(896) := '5C6E5C7477696474683A20313670783B5C6E5C74646973706C61793A20666C65782021696D706F7274616E743B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C';
wwv_flow_imp.g_varchar2_table(897) := '747472616E73666F726D3A207472616E736C6174655828337078293B5C6E7D5C6E5C6E2E6D6F6E61636F2D746C2D636F6E74656E7473207B5C6E5C74666C65783A20313B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(898) := '61636F2D746C2D747769737469653A3A6265666F7265207B5C6E5C74626F726465722D7261646975733A20323070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D746C2D747769737469652E636F6C6C61707365643A3A6265666F7265207B5C6E5C74747261';
wwv_flow_imp.g_varchar2_table(899) := '6E73666F726D3A20726F74617465282D3930646567293B5C6E7D5C6E5C6E2E6D6F6E61636F2D746C2D747769737469652E636F6469636F6E2D747265652D6974656D2D6C6F6164696E673A3A6265666F7265207B5C6E5C742F2A20557365207374657073';
wwv_flow_imp.g_varchar2_table(900) := '20746F207468726F74746C652046505320746F2072656475636520435055207573616765202A2F5C6E5C74616E696D6174696F6E3A20636F6469636F6E2D7370696E20312E3235732073746570732833302920696E66696E6974653B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(901) := '6D6F6E61636F2D747265652D747970652D66696C746572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C74646973706C61793A20666C65783B5C6E5C7470616464696E673A203370783B5C6E5C746D61';
wwv_flow_imp.g_varchar2_table(902) := '782D77696474683A2032303070783B5C6E5C747A2D696E6465783A203130303B5C6E5C746D617267696E3A2030203670783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D7769646765742D626F72646572293B';
wwv_flow_imp.g_varchar2_table(903) := '5C6E5C74626F726465722D626F74746F6D2D6C6566742D7261646975733A203470783B5C6E5C74626F726465722D626F74746F6D2D72696768742D7261646975733A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E63683A6E6F7428';
wwv_flow_imp.g_varchar2_table(904) := '2E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D747265652D747970652D66696C746572207B5C6E5C747472616E736974696F6E3A20746F7020302E33733B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722E64';
wwv_flow_imp.g_varchar2_table(905) := '697361626C6564207B5C6E5C74746F703A202D343070782021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D67726162207B5C6E5C74646973706C61793A20666C65782021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(906) := '743B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74637572736F723A20677261623B5C6E5C746D617267696E2D72696768743A203270783B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(907) := '2E6D6F6E61636F2D747265652D747970652D66696C7465722D677261622E6772616262696E67207B5C6E5C74637572736F723A206772616262696E673B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D696E707574207B';
wwv_flow_imp.g_varchar2_table(908) := '5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D696E707574202E6D6F6E61636F2D696E707574626F78207B5C6E5C746865696768743A20323370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(909) := '747265652D747970652D66696C7465722D696E707574202E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E696E7075742C5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D696E707574202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(910) := '636F2D696E707574626F78203E202E696277726170706572203E202E6D6972726F72207B5C6E5C7470616464696E673A20327078203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D696E707574202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(911) := '636F2D66696E64496E707574203E202E636F6E74726F6C73207B5C6E5C74746F703A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D616374696F6E626172207B5C6E5C746D617267696E2D6C6566743A2034';
wwv_flow_imp.g_varchar2_table(912) := '70783B5C6E7D5C6E5C6E2E6D6F6E61636F2D747265652D747970652D66696C7465722D616374696F6E626172202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C7470616464696E673A203270783B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(913) := '6E5C6E2E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65727B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74';
wwv_flow_imp.g_varchar2_table(914) := '746F703A20303B5C6E5C746C6566743A20303B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20303B5C6E5C747A2D696E6465783A2031333B202F2A2053657474696E677320656469746F722075736573207A2D696E6465783A2031';
wwv_flow_imp.g_varchar2_table(915) := '32202A2F5C6E5C6E5C742F2A204261636B757020636F6C6F7220696E206361736520746865207472656520646F6573206E6F742070726F7669646520746865206261636B67726F756E6420636F6C6F72202A2F5C6E5C746261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(916) := '6C6F723A20766172282D2D7673636F64652D736964654261722D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D7374';
wwv_flow_imp.g_varchar2_table(917) := '69636B792D636F6E7461696E6572202E6D6F6E61636F2D747265652D737469636B792D726F772E6D6F6E61636F2D6C6973742D726F777B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A20313030253B5C6E5C746F70';
wwv_flow_imp.g_varchar2_table(918) := '61636974793A20312021696D706F7274616E743B202F2A2053657474696E677320656469746F722075736573206F706163697479203C2031202A2F5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C6E5C742F2A204261636B757020636F6C6F';
wwv_flow_imp.g_varchar2_table(919) := '7220696E206361736520746865207472656520646F6573206E6F742070726F7669646520746865206261636B67726F756E6420636F6C6F72202A2F5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D736964654261';
wwv_flow_imp.g_varchar2_table(920) := '722D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E6572202E6D6F6E61636F2D74';
wwv_flow_imp.g_varchar2_table(921) := '7265652D737469636B792D726F773A686F7665727B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D6C6973742D686F7665724261636B67726F756E64292021696D706F7274616E743B5C6E5C74637572736F723A';
wwv_flow_imp.g_varchar2_table(922) := '20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722E656D7074792C5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(923) := '6F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722E656D707479202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722D';
wwv_flow_imp.g_varchar2_table(924) := '736861646F77207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E';
wwv_flow_imp.g_varchar2_table(925) := '6572202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722D736861646F77207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74626F74746F6D3A202D3370783B5C6E5C746C6566743A203070783B5C6E5C7468';
wwv_flow_imp.g_varchar2_table(926) := '65696768743A203070783B202F2A2068656967742069732033707820616E64206F6E6C7920736574207768656E20746865726520697320612074726565537469636B795363726F6C6C536861646F7720636F6C6F72202A2F5C6E5C7477696474683A2031';
wwv_flow_imp.g_varchar2_table(927) := '3030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65725B746162696E6465783D2230225D3A666F637573';
wwv_flow_imp.g_varchar2_table(928) := '7B5C6E5C746F75746C696E653A206E6F6E653B5C6E7D5C6E272C22225D293B636F6E737420613D727D2C363330373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E283136303129';
wwv_flow_imp.g_varchar2_table(929) := '2C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(930) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072';
wwv_flow_imp.g_varchar2_table(931) := '657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D';
wwv_flow_imp.g_varchar2_table(932) := '6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(933) := '2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E70757461726561207B5C6E5C746D696E2D77696474683A20303B5C6E5C746D696E2D6865696768743A20303B5C6E5C746D617267696E3A20303B5C6E5C7470616464696E673A20303B5C';
wwv_flow_imp.g_varchar2_table(934) := '6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746F75746C696E653A206E6F6E652021696D706F7274616E743B5C6E5C74726573697A653A206E6F6E653B5C6E5C74626F726465723A206E6F6E653B5C6E5C746F766572666C6F773A2068';
wwv_flow_imp.g_varchar2_table(935) := '696464656E3B5C6E5C74636F6C6F723A207472616E73706172656E743B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73706172656E743B5C6E5C747A2D696E6465783A202D31303B5C6E7D5C6E2F2A2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(936) := '72202E696E70757461726561207B5C6E5C74706F736974696F6E3A2066697865642021696D706F7274616E743B5C6E5C7477696474683A2038303070782021696D706F7274616E743B5C6E5C746865696768743A2035303070782021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(937) := '743B5C6E5C74746F703A20696E697469616C2021696D706F7274616E743B5C6E5C746C6566743A20696E697469616C2021696D706F7274616E743B5C6E5C74626F74746F6D3A20302021696D706F7274616E743B5C6E5C7472696768743A20302021696D';
wwv_flow_imp.g_varchar2_table(938) := '706F7274616E743B5C6E5C74636F6C6F723A20626C61636B2021696D706F7274616E743B5C6E5C746261636B67726F756E643A2077686974652021696D706F7274616E743B5C6E5C746C696E652D6865696768743A20313570782021696D706F7274616E';
wwv_flow_imp.g_varchar2_table(939) := '743B5C6E5C74666F6E742D73697A653A20313470782021696D706F7274616E743B5C6E5C747A2D696E6465783A2031302021696D706F7274616E743B5C6E7D2A2F5C6E2E6D6F6E61636F2D656469746F72202E696E707574617265612E696D652D696E70';
wwv_flow_imp.g_varchar2_table(940) := '7574207B5C6E5C747A2D696E6465783A2031303B5C6E5C7463617265742D636F6C6F723A20766172282D2D7673636F64652D656469746F72437572736F722D666F726567726F756E64293B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D65';
wwv_flow_imp.g_varchar2_table(941) := '6469746F722D666F726567726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C333337373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C';
wwv_flow_imp.g_varchar2_table(942) := '6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(943) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C20726967687473207265';
wwv_flow_imp.g_varchar2_table(944) := '7365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D61';
wwv_flow_imp.g_varchar2_table(945) := '74696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(946) := '2D2A2F5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F766572207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C746C696E652D6865696768';
wwv_flow_imp.g_varchar2_table(947) := '743A20313970783B5C6E5C742F2A204D75737420626520686967686572207468616E20736173682773207A2D696E64657820616E64207465726D696E616C2063616E7661736573202A2F5C6E5C747A2D696E6465783A2034303B5C6E5C746F766572666C';
wwv_flow_imp.g_varchar2_table(948) := '6F773A2068696464656E3B5C6E5C746D61782D77696474683A2037303070783B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465';
wwv_flow_imp.g_varchar2_table(949) := '723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E5C74626F726465722D7261646975733A203370783B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D65';
wwv_flow_imp.g_varchar2_table(950) := '6469746F72486F7665725769646765742D666F726567726F756E64293B5C6E5C74626F782D736861646F773A2030203270782038707820766172282D2D7673636F64652D7769646765742D736861646F77293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F';
wwv_flow_imp.g_varchar2_table(951) := '726B62656E6368202E776F726B62656E63682D686F766572206872207B5C6E5C74626F726465722D626F74746F6D3A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665723A6E6F74282E';
wwv_flow_imp.g_varchar2_table(952) := '736B69702D666164652D696E29207B5C6E5C74616E696D6174696F6E3A2066616465696E203130306D73206C696E6561723B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722E636F6D7061637420';
wwv_flow_imp.g_varchar2_table(953) := '7B5C6E5C74666F6E742D73697A653A20313270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722E636F6D70616374202E686F7665722D636F6E74656E7473207B5C6E5C7470616464696E673A';
wwv_flow_imp.g_varchar2_table(954) := '20327078203870783B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D636F6E7461696E65722E6C6F636B6564202E776F726B62656E63682D686F766572207B5C6E5C746F75746C696E653A2031';
wwv_flow_imp.g_varchar2_table(955) := '707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D636F6E7461696E65722E6C6F';
wwv_flow_imp.g_varchar2_table(956) := '636B6564202E776F726B62656E63682D686F7665723A666F6375732C5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D6C6F636B3A666F637573207B5C6E5C746F75746C696E653A2031707820736F6C696420';
wwv_flow_imp.g_varchar2_table(957) := '766172282D2D7673636F64652D666F637573426F72646572293B5C6E7D5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D636F6E7461696E65722E6C6F636B6564202E776F726B62656E63682D686F7665722D';
wwv_flow_imp.g_varchar2_table(958) := '6C6F636B3A686F766572207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D746F6F6C6261722D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63';
wwv_flow_imp.g_varchar2_table(959) := '682D686F7665722D706F696E746572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C742F2A204D75737420626520686967686572207468616E20776F726B62656E636820686F766572207A2D696E646578202A2F5C6E5C747A2D69';
wwv_flow_imp.g_varchar2_table(960) := '6E6465783A2034313B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D706F696E7465723A6166746572207B5C6E5C74636F6E7465';
wwv_flow_imp.g_varchar2_table(961) := '6E743A2027273B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A203570783B5C6E5C746865696768743A203570783B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D65646974';
wwv_flow_imp.g_varchar2_table(962) := '6F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465722D72696768743A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E5C74626F72';
wwv_flow_imp.g_varchar2_table(963) := '6465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E2E6D6F6E61636F2D776F726B62656E6368202E6C6F636B6564202E776F726B62656E';
wwv_flow_imp.g_varchar2_table(964) := '63682D686F7665722D706F696E7465723A6166746572207B5C6E5C7477696474683A203470783B5C6E5C746865696768743A203470783B5C6E5C74626F726465722D72696768742D77696474683A203270783B5C6E5C74626F726465722D626F74746F6D';
wwv_flow_imp.g_varchar2_table(965) := '2D77696474683A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D706F696E7465722E6C6566742020207B206C6566743A202D3370783B207D5C6E2E6D6F6E61636F2D776F726B6265';
wwv_flow_imp.g_varchar2_table(966) := '6E6368202E776F726B62656E63682D686F7665722D706F696E7465722E726967687420207B2072696768743A203370783B207D5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D706F696E7465722E746F7020';
wwv_flow_imp.g_varchar2_table(967) := '2020207B20746F703A202D3370783B207D5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D706F696E7465722E626F74746F6D207B20626F74746F6D3A203370783B207D5C6E5C6E2E6D6F6E61636F2D776F72';
wwv_flow_imp.g_varchar2_table(968) := '6B62656E6368202E776F726B62656E63682D686F7665722D706F696E7465722E6C6566743A6166746572207B5C6E5C747472616E73666F726D3A20726F7461746528313335646567293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E';
wwv_flow_imp.g_varchar2_table(969) := '776F726B62656E63682D686F7665722D706F696E7465722E72696768743A6166746572207B5C6E5C747472616E73666F726D3A20726F7461746528333135646567293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E';
wwv_flow_imp.g_varchar2_table(970) := '63682D686F7665722D706F696E7465722E746F703A6166746572207B5C6E5C747472616E73666F726D3A20726F7461746528323235646567293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722D';
wwv_flow_imp.g_varchar2_table(971) := '706F696E7465722E626F74746F6D3A6166746572207B5C6E5C747472616E73666F726D3A20726F74617465283435646567293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722061207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(972) := '636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F76657220613A666F637573207B5C6E5C746F75746C';
wwv_flow_imp.g_varchar2_table(973) := '696E653A2031707820736F6C69643B5C6E5C746F75746C696E652D6F66667365743A202D3170783B5C6E5C74746578742D6465636F726174696F6E3A20756E6465726C696E653B5C6E5C746F75746C696E652D636F6C6F723A20766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(974) := '64652D666F637573426F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F76657220613A686F7665722C5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F76';
wwv_flow_imp.g_varchar2_table(975) := '657220613A616374697665207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D';
wwv_flow_imp.g_varchar2_table(976) := '686F76657220636F6465207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D74657874436F6465426C6F636B2D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E';
wwv_flow_imp.g_varchar2_table(977) := '63682D686F766572202E686F7665722D726F77202E616374696F6E73207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D7374617475734261724261636B67726F756E64293B5C6E';
wwv_flow_imp.g_varchar2_table(978) := '7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722E72696768742D616C69676E6564207B5C6E5C742F2A2054686520636F6E746578742076696577207365727669636520777261707320737472616E6765';
wwv_flow_imp.g_varchar2_table(979) := '6C79207768656E206974277320726967687420757020616761696E737420746865206564676520776974686F75742074686973202A2F5C6E5C746C6566743A203170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E6368202E776F726B6265';
wwv_flow_imp.g_varchar2_table(980) := '6E63682D686F7665722E72696768742D616C69676E6564202E686F7665722D726F772E7374617475732D626172202E616374696F6E73207B5C6E5C74666C65782D646972656374696F6E3A20726F772D726576657273653B5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(981) := '636F2D776F726B62656E6368202E776F726B62656E63682D686F7665722E72696768742D616C69676E6564202E686F7665722D726F772E7374617475732D626172202E616374696F6E73202E616374696F6E2D636F6E7461696E6572207B5C6E5C746D61';
wwv_flow_imp.g_varchar2_table(982) := '7267696E2D72696768743A20303B5C6E5C746D617267696E2D6C6566743A20313670783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C323033353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E';
wwv_flow_imp.g_varchar2_table(983) := '617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(984) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174';
wwv_flow_imp.g_varchar2_table(985) := '696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F742066';
wwv_flow_imp.g_varchar2_table(986) := '6F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(987) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E626C6F636B4465636F726174696F6E732D636F6E7461696E6572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A';
wwv_flow_imp.g_varchar2_table(988) := '20303B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E626C6F636B4465636F726174696F6E732D626C6F636B207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E';
wwv_flow_imp.g_varchar2_table(989) := '5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383430353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E';
wwv_flow_imp.g_varchar2_table(990) := '2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(991) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269';
wwv_flow_imp.g_varchar2_table(992) := '676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520';
wwv_flow_imp.g_varchar2_table(993) := '696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(994) := '2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D6F7665726C617973202E63757272656E742D6C696E65207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74706F736974696F6E3A206162736F6C757465';
wwv_flow_imp.g_varchar2_table(995) := '3B5C6E5C746C6566743A20303B5C6E5C74746F703A20303B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D7669';
wwv_flow_imp.g_varchar2_table(996) := '65772D6F7665726C617973202E63757272656E742D6C696E65207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A20303B5C6E5C74746F703A20303B5C6E5C74626F782D';
wwv_flow_imp.g_varchar2_table(997) := '73697A696E673A20626F726465722D626F783B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F725C6E5C742E6D617267696E2D766965772D6F7665726C6179735C6E5C742E63757272656E742D6C696E652E';
wwv_flow_imp.g_varchar2_table(998) := '63757272656E742D6C696E652D6D617267696E2E63757272656E742D6C696E652D6D617267696E2D626F7468207B5C6E5C74626F726465722D72696768743A20303B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C333039333A28652C742C6E';
wwv_flow_imp.g_varchar2_table(999) := '293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D';
wwv_flow_imp.g_varchar2_table(1000) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F';
wwv_flow_imp.g_varchar2_table(1001) := '7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963';
wwv_flow_imp.g_varchar2_table(1002) := '656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1003) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A5C6E5C744B656570696E67206E616D652073686F727420666F72206661737465722070617273696E672E5C';
wwv_flow_imp.g_varchar2_table(1004) := '6E5C74636472203D20636F7265206465636F726174696F6E732072656E646572696E672028646976295C6E2A2F5C6E2E6D6F6E61636F2D656469746F72202E6C696E65732D636F6E74656E74202E636472207B5C6E5C74706F736974696F6E3A20616273';
wwv_flow_imp.g_varchar2_table(1005) := '6F6C7574653B5C6E5C746865696768743A20313030253B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383038313A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831';
wwv_flow_imp.g_varchar2_table(1006) := '363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1007) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C2072696768';
wwv_flow_imp.g_varchar2_table(1008) := '74732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E';
wwv_flow_imp.g_varchar2_table(1009) := '666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1010) := '2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E676C7970682D6D617267696E207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E7D5C6E5C6E2F2A5C6E5C744B656570696E67206E616D';
wwv_flow_imp.g_varchar2_table(1011) := '652073686F727420666F72206661737465722070617273696E672E5C6E5C7463676D72203D20636F726520676C797068206D617267696E2072656E646572696E672028646976295C6E2A2F5C6E2E6D6F6E61636F2D656469746F72202E676C7970682D6D';
wwv_flow_imp.g_varchar2_table(1012) := '617267696E2D77696467657473202E63676D72207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F';
wwv_flow_imp.g_varchar2_table(1013) := '6E74656E743A2063656E7465723B5C6E7D5C6E5C6E2F2A5C6E5C74456E73757265207370696E6E696E672069636F6E732061726520706978656C2D706572666563746C792063656E746572656420616E642061766F696420776F62626C652E5C6E5C7454';
wwv_flow_imp.g_varchar2_table(1014) := '686973206973206F6E6C79206170706C69656420746F2069636F6E732074686174207370696E20746F2061766F696420756E6E65636573736172795C6E5C74475055206C617965727320616E6420626C7572727920737562706978656C2041412E5C6E2A';
wwv_flow_imp.g_varchar2_table(1015) := '2F5C6E2E6D6F6E61636F2D656469746F72202E676C7970682D6D617267696E2D77696467657473202E63676D722E636F6469636F6E2D6D6F6469666965722D7370696E3A3A6265666F726520207B5C6E5C74706F736974696F6E3A206162736F6C757465';
wwv_flow_imp.g_varchar2_table(1016) := '3B5C6E5C74746F703A203530253B5C6E5C746C6566743A203530253B5C6E5C747472616E73666F726D3A207472616E736C617465282D3530252C202D353025293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C333737373A28652C742C6E29';
wwv_flow_imp.g_varchar2_table(1017) := '3D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D';
wwv_flow_imp.g_varchar2_table(1018) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F70';
wwv_flow_imp.g_varchar2_table(1019) := '79726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C696365';
wwv_flow_imp.g_varchar2_table(1020) := '6E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1021) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C696E65732D636F6E74656E74202E636F72652D6775696465207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1022) := '74706F736974696F6E3A206162736F6C7574653B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746865696768743A20313030253B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C363935333A28652C742C6E293D';
wwv_flow_imp.g_varchar2_table(1023) := '3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D';
wwv_flow_imp.g_varchar2_table(1024) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079';
wwv_flow_imp.g_varchar2_table(1025) := '726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E';
wwv_flow_imp.g_varchar2_table(1026) := '73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1027) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E6C696E652D6E756D62';
wwv_flow_imp.g_varchar2_table(1028) := '657273207B5C6E5C74626F74746F6D3A20303B5C6E5C74666F6E742D76617269616E742D6E756D657269633A20746162756C61722D6E756D733B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746578742D616C69676E3A20726967';
wwv_flow_imp.g_varchar2_table(1029) := '68743B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74637572736F723A206465666175';
wwv_flow_imp.g_varchar2_table(1030) := '6C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656C61746976652D63757272656E742D6C696E652D6E756D626572207B5C6E5C74746578742D616C69676E3A206C6566743B5C6E5C74646973706C61793A20696E6C696E652D626C6F';
wwv_flow_imp.g_varchar2_table(1031) := '636B3B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E6C696E652D6E756D626572732E6C682D6F6464207B5C6E5C746D617267696E2D746F703A';
wwv_flow_imp.g_varchar2_table(1032) := '203170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C696E652D6E756D62657273207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E654E756D6265722D666F726567726F756E64293B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1033) := '5C6E2E6D6F6E61636F2D656469746F72202E6C696E652D6E756D626572732E6163746976652D6C696E652D6E756D626572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E654E756D6265722D616374697665466F';
wwv_flow_imp.g_varchar2_table(1034) := '726567726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C373337353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E286929';
wwv_flow_imp.g_varchar2_table(1035) := '2C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1036) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C';
wwv_flow_imp.g_varchar2_table(1037) := '6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E20';
wwv_flow_imp.g_varchar2_table(1038) := '2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1039) := '6E61636F2D656469746F72202E6C696E65732D6465636F726174696F6E73207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746261636B67726F756E643A2077686974653B5C6E7D5C6E5C6E2F2A5C6E5C';
wwv_flow_imp.g_varchar2_table(1040) := '744B656570696E67206E616D652073686F727420666F72206661737465722070617273696E672E5C6E5C74636C6472203D20636F7265206C696E6573206465636F726174696F6E732072656E646572696E672028646976295C6E2A2F5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1041) := '6F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E636C6472207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746865696768743A20313030253B5C6E7D222C22225D293B636F6E737420613D727D2C35';
wwv_flow_imp.g_varchar2_table(1042) := '3837363A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E7075736828';
wwv_flow_imp.g_varchar2_table(1043) := '5B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1044) := '2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73';
wwv_flow_imp.g_varchar2_table(1045) := '652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1046) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A20556E636F6D6D656E7420746F20736565206C696E657320666C617368696E6720';
wwv_flow_imp.g_varchar2_table(1047) := '7768656E2074686579277265207061696E746564202A2F5C6E2F2A2E6D6F6E61636F2D656469746F72202E766965772D6C696E6573203E202E766965772D6C696E65207B5C6E5C746261636B67726F756E642D636F6C6F723A206E6F6E653B5C6E5C7461';
wwv_flow_imp.g_varchar2_table(1048) := '6E696D6174696F6E2D6E616D653A20666C6173682D6261636B67726F756E643B5C6E5C74616E696D6174696F6E2D6475726174696F6E3A203830306D733B5C6E7D5C6E406B65796672616D657320666C6173682D6261636B67726F756E64207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1049) := '30252020207B206261636B67726F756E642D636F6C6F723A206C69676874677265656E3B207D5C6E5C7431303025207B206261636B67726F756E642D636F6C6F723A206E6F6E65207D5C6E7D2A2F5C6E5C6E2E6D746B636F6E74726F6C207B5C6E5C7463';
wwv_flow_imp.g_varchar2_table(1050) := '6F6C6F723A20726762283235352C203235352C20323535292021696D706F7274616E743B5C6E5C746261636B67726F756E643A20726762283135302C20302C2030292021696D706F7274616E743B5C6E7D5C6E5C6E2E6D746B6F766572666C6F77207B5C';
wwv_flow_imp.g_varchar2_table(1051) := '6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D6261636B67726F756E642C20766172282D2D7673636F64652D656469746F722D6261636B67726F756E6429293B5C6E5C74636F6C6F723A20766172';
wwv_flow_imp.g_varchar2_table(1052) := '282D2D7673636F64652D627574746F6E2D666F726567726F756E642C20766172282D2D7673636F64652D656469746F722D666F726567726F756E6429293B5C6E5C74626F726465722D77696474683A203170783B5C6E5C74626F726465722D7374796C65';
wwv_flow_imp.g_varchar2_table(1053) := '3A20736F6C69643B5C6E5C74626F726465722D636F6C6F723A20766172282D2D7673636F64652D636F6E7472617374426F72646572293B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C7470616464696E673A203470783B5C6E5C7463';
wwv_flow_imp.g_varchar2_table(1054) := '7572736F723A20706F696E7465723B5C6E7D5C6E2E6D746B6F766572666C6F773A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D686F7665724261636B67726F756E64293B5C';
wwv_flow_imp.g_varchar2_table(1055) := '6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E6E6F2D757365722D73656C656374202E6C696E65732D636F6E74656E742C5C6E2E6D6F6E61636F2D656469746F722E6E6F2D757365722D73656C656374202E766965772D6C696E652C5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(1056) := '61636F2D656469746F722E6E6F2D757365722D73656C656374202E766965772D6C696E6573207B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E2F2A2055';
wwv_flow_imp.g_varchar2_table(1057) := '736520757365722D73656C6563743A207465787420666F72206C6F6F6B75702066656174757265206F6E206D61634F53202A2F5C6E2F2A2068747470733A2F2F6769746875622E636F6D2F6D6963726F736F66742F7673636F64652F6973737565732F38';
wwv_flow_imp.g_varchar2_table(1058) := '35363332202A2F5C6E2E6D6F6E61636F2D656469746F722E6D6163202E6C696E65732D636F6E74656E743A686F7665722C5C6E2E6D6F6E61636F2D656469746F722E6D6163202E766965772D6C696E653A686F7665722C5C6E2E6D6F6E61636F2D656469';
wwv_flow_imp.g_varchar2_table(1059) := '746F722E6D6163202E766965772D6C696E65733A686F766572207B5C6E5C74757365722D73656C6563743A20746578743B5C6E5C742D7765626B69742D757365722D73656C6563743A20746578743B5C6E5C742D6D732D757365722D73656C6563743A20';
wwv_flow_imp.g_varchar2_table(1060) := '746578743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E656E61626C652D757365722D73656C656374207B5C6E5C74757365722D73656C6563743A20696E697469616C3B5C6E5C742D7765626B69742D757365722D73656C6563743A20696E69';
wwv_flow_imp.g_varchar2_table(1061) := '7469616C3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D6C696E6573207B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D6C696E65207B5C6E';
wwv_flow_imp.g_varchar2_table(1062) := '5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2F2A2054686572652061726520766965772D6C696E657320696E20766965772D7A6F6E65732E205765206861766520746F206D616B652073';
wwv_flow_imp.g_varchar2_table(1063) := '75726520746869732072756C6520646F6573206E6F74206170706C7920746F207468656D2C206173207468657920646F6E2774207365742061206C696E6520686569676874202A2F5C6E2E6D6F6E61636F2D656469746F72202E6C696E65732D636F6E74';
wwv_flow_imp.g_varchar2_table(1064) := '656E74203E202E766965772D6C696E6573203E202E766965772D6C696E65203E207370616E207B5C6E5C74746F703A20303B5C6E5C74626F74746F6D3A20303B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1065) := '6F2D656469746F72202E6D746B77207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72576869746573706163652D666F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1066) := '72202E6D746B7A207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72576869746573706163652D666F726567726F756E64292021696D706F7274616E743B5C';
wwv_flow_imp.g_varchar2_table(1067) := '6E7D5C6E5C6E2F2A20544F444F40746F6B656E697A6174696F6E20626F6F74737472617020666978202A2F5C6E2F2A2E6D6F6E61636F2D656469746F72202E766965772D6C696E65203E207370616E203E207370616E207B5C6E5C74666C6F61743A206E';
wwv_flow_imp.g_varchar2_table(1068) := '6F6E653B5C6E5C746D696E2D6865696768743A20696E68657269743B5C6E5C746D617267696E2D6C6566743A20696E68657269743B5C6E7D2A2F5C6E222C22225D293B636F6E737420613D727D2C333331333A28652C742C6E293D3E7B22757365207374';
wwv_flow_imp.g_varchar2_table(1069) := '72696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1070) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329';
wwv_flow_imp.g_varchar2_table(1071) := '204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E';
wwv_flow_imp.g_varchar2_table(1072) := '207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1073) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A5C6E5C744B656570696E67206E616D652073686F727420666F72206661737465722070617273696E672E5C6E5C74636D6472203D2063';
wwv_flow_imp.g_varchar2_table(1074) := '6F7265206D617267696E206465636F726174696F6E732072656E646572696E672028646976295C6E2A2F5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E636D6472207B5C6E5C74706F736974696F6E';
wwv_flow_imp.g_varchar2_table(1075) := '3A206162736F6C7574653B5C6E5C746C6566743A20303B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E7D222C22225D293B636F6E737420613D727D2C383733313A28652C742C6E293D3E7B2275736520737472';
wwv_flow_imp.g_varchar2_table(1076) := '696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1077) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F707972696768742028632920';
wwv_flow_imp.g_varchar2_table(1078) := '4D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E20';
wwv_flow_imp.g_varchar2_table(1079) := '7468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1080) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(1081) := '652D656469746F724775747465722D6261636B67726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C363439333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B7661722069';
wwv_flow_imp.g_varchar2_table(1082) := '3D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1083) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C20';
wwv_flow_imp.g_varchar2_table(1084) := '7269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E73';
wwv_flow_imp.g_varchar2_table(1085) := '6520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1086) := '2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A20535441525420636F766572207468652063617365207468617420736C696465722069732076697369626C65206F6E206D6F7573656F766572202A2F5C6E2E6D6F6E61636F2D656469746F72202E6D696E69';
wwv_flow_imp.g_varchar2_table(1087) := '6D61702E736C696465722D6D6F7573656F766572202E6D696E696D61702D736C69646572207B5C6E5C746F7061636974793A20303B5C6E5C747472616E736974696F6E3A206F706163697479203130306D73206C696E6561723B5C6E7D5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1088) := '636F2D656469746F72202E6D696E696D61702E736C696465722D6D6F7573656F7665723A686F766572202E6D696E696D61702D736C69646572207B5C6E5C746F7061636974793A20313B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D';
wwv_flow_imp.g_varchar2_table(1089) := '61702E736C696465722D6D6F7573656F766572202E6D696E696D61702D736C696465722E616374697665207B5C6E5C746F7061636974793A20313B5C6E7D5C6E2F2A20454E4420636F766572207468652063617365207468617420736C69646572206973';
wwv_flow_imp.g_varchar2_table(1090) := '2076697369626C65206F6E206D6F7573656F766572202A2F5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D61702D736C69646572202E6D696E696D61702D736C696465722D686F72697A6F6E74616C207B5C6E5C746261636B67726F756E643A';
wwv_flow_imp.g_varchar2_table(1091) := '20766172282D2D7673636F64652D6D696E696D6170536C696465722D6261636B67726F756E64293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D61702D736C696465723A686F766572202E6D696E696D61702D736C696465722D686F';
wwv_flow_imp.g_varchar2_table(1092) := '72697A6F6E74616C207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D6D696E696D6170536C696465722D686F7665724261636B67726F756E64293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D61702D73';
wwv_flow_imp.g_varchar2_table(1093) := '6C696465722E616374697665202E6D696E696D61702D736C696465722D686F72697A6F6E74616C207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D6D696E696D6170536C696465722D6163746976654261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1094) := '293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D61702D736861646F772D76697369626C65207B5C6E5C74626F782D736861646F773A20766172282D2D7673636F64652D7363726F6C6C6261722D736861646F7729202D3670782030';
wwv_flow_imp.g_varchar2_table(1095) := '20367078202D36707820696E7365743B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D61702D736861646F772D68696464656E207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A20303B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1096) := '6E2E6D6F6E61636F2D656469746F72202E6D696E696D61702D736861646F772D76697369626C65207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A202D3670783B5C6E5C7477696474683A203670783B5C6E7D5C6E2E';
wwv_flow_imp.g_varchar2_table(1097) := '6D6F6E61636F2D656469746F722E6E6F2D6D696E696D61702D736861646F77202E6D696E696D61702D736861646F772D76697369626C65207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A202D3170783B5C6E5C7477';
wwv_flow_imp.g_varchar2_table(1098) := '696474683A203170783B5C6E7D5C6E5C6E2F2A20302E3573206661646520696E2F6F757420666F7220746865206D696E696D6170202A2F5C6E2E6D696E696D61702E6175746F68696465207B5C6E5C746F7061636974793A20303B5C6E5C747472616E73';
wwv_flow_imp.g_varchar2_table(1099) := '6974696F6E3A206F70616369747920302E35733B5C6E7D5C6E2E6D696E696D61702E6175746F686964653A686F766572207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D696E696D6170207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1100) := '747A2D696E6465783A20353B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C3231333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869';
wwv_flow_imp.g_varchar2_table(1101) := '292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1102) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E';
wwv_flow_imp.g_varchar2_table(1103) := '5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E';
wwv_flow_imp.g_varchar2_table(1104) := '202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1105) := '6F6E61636F2D656469746F72202E6F7665726C617957696467657473207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A303B5C6E7D222C22225D293B636F6E737420613D727D2C31363337';
wwv_flow_imp.g_varchar2_table(1106) := '3A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E';
wwv_flow_imp.g_varchar2_table(1107) := '69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C';
wwv_flow_imp.g_varchar2_table(1108) := '6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20';
wwv_flow_imp.g_varchar2_table(1109) := '536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1110) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D72756C6572207B5C6E5C74706F73697469';
wwv_flow_imp.g_varchar2_table(1111) := '6F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C74626F782D736861646F773A2031707820302030203020766172282D2D7673636F64652D656469746F7252756C65722D666F726567726F756E642920696E7365743B5C6E7D5C6E222C';
wwv_flow_imp.g_varchar2_table(1112) := '22225D293B636F6E737420613D727D2C393133333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E28';
wwv_flow_imp.g_varchar2_table(1113) := '73292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1114) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64';
wwv_flow_imp.g_varchar2_table(1115) := '657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1116) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E7363';
wwv_flow_imp.g_varchar2_table(1117) := '726F6C6C2D6465636F726174696F6E207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A20303B5C6E5C746865696768743A203670783B5C6E5C74626F782D736861646F773A20766172282D';
wwv_flow_imp.g_varchar2_table(1118) := '2D7673636F64652D7363726F6C6C6261722D736861646F772920302036707820367078202D36707820696E7365743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383832393A28652C742C6E293D3E7B2275736520737472696374223B6E2E';
wwv_flow_imp.g_varchar2_table(1119) := '6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1120) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F';
wwv_flow_imp.g_varchar2_table(1121) := '667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F';
wwv_flow_imp.g_varchar2_table(1122) := '6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1123) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A5C6E5C744B656570696E67206E616D652073686F727420666F72206661737465722070617273696E672E5C6E5C7463736C72203D20636F72652073656C65';
wwv_flow_imp.g_varchar2_table(1124) := '6374696F6E73206C617965722072656E646572696E672028646976295C6E2A2F5C6E2E6D6F6E61636F2D656469746F72202E6C696E65732D636F6E74656E74202E63736C72207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(1125) := '6E2E6D6F6E61636F2D656469746F72202E666F6375736564202E73656C65637465642D74657874207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D73656C656374696F6E4261636B67726F75';
wwv_flow_imp.g_varchar2_table(1126) := '6E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E73656C65637465642D74657874207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D696E61637469766553656C656374696F';
wwv_flow_imp.g_varchar2_table(1127) := '6E4261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F725C745C745C742E746F702D6C6566742D7261646975735C745C747B20626F726465722D746F702D6C6566742D7261646975733A203370783B207D5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1128) := '6F2D656469746F725C745C745C742E626F74746F6D2D6C6566742D7261646975735C745C747B20626F726465722D626F74746F6D2D6C6566742D7261646975733A203370783B207D5C6E2E6D6F6E61636F2D656469746F725C745C745C742E746F702D72';
wwv_flow_imp.g_varchar2_table(1129) := '696768742D7261646975735C745C747B20626F726465722D746F702D72696768742D7261646975733A203370783B207D5C6E2E6D6F6E61636F2D656469746F725C745C745C742E626F74746F6D2D72696768742D7261646975735C747B20626F72646572';
wwv_flow_imp.g_varchar2_table(1130) := '2D626F74746F6D2D72696768742D7261646975733A203370783B207D5C6E5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E746F702D6C6566742D7261646975735C745C747B20626F726465722D746F702D6C6566742D726164697573';
wwv_flow_imp.g_varchar2_table(1131) := '3A20303B207D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E626F74746F6D2D6C6566742D7261646975735C745C747B20626F726465722D626F74746F6D2D6C6566742D7261646975733A20303B207D5C6E2E6D6F6E61636F2D6564';
wwv_flow_imp.g_varchar2_table(1132) := '69746F722E68632D626C61636B202E746F702D72696768742D7261646975735C745C747B20626F726465722D746F702D72696768742D7261646975733A20303B207D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E626F74746F6D2D';
wwv_flow_imp.g_varchar2_table(1133) := '72696768742D7261646975735C747B20626F726465722D626F74746F6D2D72696768742D7261646975733A20303B207D5C6E5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E746F702D6C6566742D7261646975735C745C747B20626F';
wwv_flow_imp.g_varchar2_table(1134) := '726465722D746F702D6C6566742D7261646975733A20303B207D5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E626F74746F6D2D6C6566742D7261646975735C745C747B20626F726465722D626F74746F6D2D6C6566742D72616469';
wwv_flow_imp.g_varchar2_table(1135) := '75733A20303B207D5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E746F702D72696768742D7261646975735C745C747B20626F726465722D746F702D72696768742D7261646975733A20303B207D5C6E2E6D6F6E61636F2D65646974';
wwv_flow_imp.g_varchar2_table(1136) := '6F722E68632D6C69676874202E626F74746F6D2D72696768742D7261646975735C747B20626F726465722D626F74746F6D2D72696768742D7261646975733A20303B207D5C6E222C22225D293B636F6E737420613D727D2C323238393A28652C742C6E29';
wwv_flow_imp.g_varchar2_table(1137) := '3D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D';
wwv_flow_imp.g_varchar2_table(1138) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F70';
wwv_flow_imp.g_varchar2_table(1139) := '79726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C696365';
wwv_flow_imp.g_varchar2_table(1140) := '6E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1141) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2E6D6F6E61636F2D656469746F72202E637572736F72732D6C61796572207B5C6E5C74706F736974696F6E3A20616273';
wwv_flow_imp.g_varchar2_table(1142) := '6F6C7574653B5C6E5C74746F703A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E637572736F72732D6C61796572203E202E637572736F72207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746F766572666C6F77';
wwv_flow_imp.g_varchar2_table(1143) := '3A2068696464656E3B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E5C6E2F2A202D2D20736D6F6F74682D63617265742D616E696D6174696F6E202D2D202A2F5C6E2E6D6F6E61636F2D656469746F72202E637572736F';
wwv_flow_imp.g_varchar2_table(1144) := '72732D6C617965722E637572736F722D736D6F6F74682D63617265742D616E696D6174696F6E203E202E637572736F72207B5C6E5C747472616E736974696F6E3A20616C6C2038306D733B5C6E7D5C6E5C6E2F2A202D2D20626C6F636B2D6F75746C696E';
wwv_flow_imp.g_varchar2_table(1145) := '652D7374796C65202D2D202A2F5C6E2E6D6F6E61636F2D656469746F72202E637572736F72732D6C617965722E637572736F722D626C6F636B2D6F75746C696E652D7374796C65203E202E637572736F72207B5C6E5C746261636B67726F756E643A2074';
wwv_flow_imp.g_varchar2_table(1146) := '72616E73706172656E742021696D706F7274616E743B5C6E5C74626F726465722D7374796C653A20736F6C69643B5C6E5C74626F726465722D77696474683A203170783B5C6E7D5C6E5C6E2F2A202D2D20756E6465726C696E652D7374796C65202D2D20';
wwv_flow_imp.g_varchar2_table(1147) := '2A2F5C6E2E6D6F6E61636F2D656469746F72202E637572736F72732D6C617965722E637572736F722D756E6465726C696E652D7374796C65203E202E637572736F72207B5C6E5C74626F726465722D626F74746F6D2D77696474683A203270783B5C6E5C';
wwv_flow_imp.g_varchar2_table(1148) := '74626F726465722D626F74746F6D2D7374796C653A20736F6C69643B5C6E5C746261636B67726F756E643A207472616E73706172656E742021696D706F7274616E743B5C6E7D5C6E5C6E2F2A202D2D20756E6465726C696E652D7468696E2D7374796C65';
wwv_flow_imp.g_varchar2_table(1149) := '202D2D202A2F5C6E2E6D6F6E61636F2D656469746F72202E637572736F72732D6C617965722E637572736F722D756E6465726C696E652D7468696E2D7374796C65203E202E637572736F72207B5C6E5C74626F726465722D626F74746F6D2D7769647468';
wwv_flow_imp.g_varchar2_table(1150) := '3A203170783B5C6E5C74626F726465722D626F74746F6D2D7374796C653A20736F6C69643B5C6E5C746261636B67726F756E643A207472616E73706172656E742021696D706F7274616E743B5C6E7D5C6E5C6E406B65796672616D6573206D6F6E61636F';
wwv_flow_imp.g_varchar2_table(1151) := '2D637572736F722D736D6F6F7468207B5C6E5C7430252C5C6E5C74323025207B5C6E5C745C746F7061636974793A20313B5C6E5C747D5C6E5C743630252C5C6E5C7431303025207B5C6E5C745C746F7061636974793A20303B5C6E5C747D5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(1152) := '6E406B65796672616D6573206D6F6E61636F2D637572736F722D7068617365207B5C6E5C7430252C5C6E5C74323025207B5C6E5C745C746F7061636974793A20313B5C6E5C747D5C6E5C743930252C5C6E5C7431303025207B5C6E5C745C746F70616369';
wwv_flow_imp.g_varchar2_table(1153) := '74793A20303B5C6E5C747D5C6E7D5C6E5C6E406B65796672616D6573206D6F6E61636F2D637572736F722D657870616E64207B5C6E5C7430252C5C6E5C74323025207B5C6E5C745C747472616E73666F726D3A207363616C65592831293B5C6E5C747D5C';
wwv_flow_imp.g_varchar2_table(1154) := '6E5C743830252C5C6E5C7431303025207B5C6E5C745C747472616E73666F726D3A207363616C65592830293B5C6E5C747D5C6E7D5C6E5C6E2E637572736F722D736D6F6F7468207B5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D637572736F72';
wwv_flow_imp.g_varchar2_table(1155) := '2D736D6F6F746820302E357320656173652D696E2D6F757420307320323020616C7465726E6174653B5C6E7D5C6E5C6E2E637572736F722D7068617365207B5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D637572736F722D706861736520302E';
wwv_flow_imp.g_varchar2_table(1156) := '357320656173652D696E2D6F757420307320323020616C7465726E6174653B5C6E7D5C6E5C6E2E637572736F722D657870616E64203E202E637572736F72207B5C6E5C74616E696D6174696F6E3A206D6F6E61636F2D637572736F722D657870616E6420';
wwv_flow_imp.g_varchar2_table(1157) := '302E357320656173652D696E2D6F757420307320323020616C7465726E6174653B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383138393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D29';
wwv_flow_imp.g_varchar2_table(1158) := '3B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1159) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E';
wwv_flow_imp.g_varchar2_table(1160) := '2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F7220';
wwv_flow_imp.g_varchar2_table(1161) := '6C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1162) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D7768207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F7257686974';
wwv_flow_imp.g_varchar2_table(1163) := '6573706163652D666F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C363034393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B7661';
wwv_flow_imp.g_varchar2_table(1164) := '7220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1165) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E2041';
wwv_flow_imp.g_varchar2_table(1166) := '6C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963';
wwv_flow_imp.g_varchar2_table(1167) := '656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1168) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D20494531302072656D6F7665206175746F20636C65617220627574746F6E202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1169) := '3A3A2D6D732D636C656172207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2F2A20416C6C2077696467657473202A2F5C6E2F2A204920616D206E6F742061206269672066616E206F6620746869732072756C65202A2F5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(1170) := '61636F2D656469746F72202E656469746F722D77696467657420696E707574207B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2F2A202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D20456469746F72202D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1171) := '2D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D656469746F72207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746F766572666C6F773A2076697369626C653B5C6E5C742D7765626B69742D746578742D73697A652D';
wwv_flow_imp.g_varchar2_table(1172) := '61646A7573743A20313030253B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F722D666F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D6261';
wwv_flow_imp.g_varchar2_table(1173) := '636B67726F756E64293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722D6261636B67726F756E64207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D6261636B67726F756E64293B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1174) := '6E2E6D6F6E61636F2D656469746F72202E72616E6765486967686C69676874207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D72616E6765486967686C696768744261636B67726F756E6429';
wwv_flow_imp.g_varchar2_table(1175) := '3B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F722D72616E6765486967686C69676874426F72646572293B5C6E7D5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1176) := '6E61636F2D656469746F722E68632D626C61636B202E72616E6765486967686C696768742C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E72616E6765486967686C69676874207B5C6E5C74626F726465722D7374796C653A20646F74';
wwv_flow_imp.g_varchar2_table(1177) := '7465643B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E73796D626F6C486967686C69676874207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D73796D626F6C486967686C6967687442';
wwv_flow_imp.g_varchar2_table(1178) := '61636B67726F756E64293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F722D73796D626F6C486967686C69676874426F726465';
wwv_flow_imp.g_varchar2_table(1179) := '72293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E73796D626F6C486967686C696768742C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E73796D626F6C486967686C69676874207B5C6E5C74626F7264';
wwv_flow_imp.g_varchar2_table(1180) := '65722D7374796C653A20646F747465643B5C6E7D5C6E5C6E2F2A202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D204D697363202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E6F766572';
wwv_flow_imp.g_varchar2_table(1181) := '666C6F772D6775617264207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D6F7665726C617973207B5C6E5C74706F';
wwv_flow_imp.g_varchar2_table(1182) := '736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D6F7665726C617973203E206469762C202E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D';
wwv_flow_imp.g_varchar2_table(1183) := '6F7665726C617973203E20646976207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2F2A5C6E2E6D6F6E61636F2D656469746F72202E6175746F2D636C6F7365642D636861726163';
wwv_flow_imp.g_varchar2_table(1184) := '746572207B5C6E5C746F7061636974793A20302E333B5C6E7D5C6E2A2F5C6E5C6E5C6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D6572726F72207B5C6E5C74626F726465722D626F74746F6D3A2034707820646F75626C6520766172';
wwv_flow_imp.g_varchar2_table(1185) := '282D2D7673636F64652D656469746F724572726F722D626F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D6572726F723A3A6265666F7265207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74636F';
wwv_flow_imp.g_varchar2_table(1186) := '6E74656E743A2027273B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D656469746F724572726F722D6261636B67726F756E64293B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1187) := '6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D7761726E696E67207B5C6E5C74626F726465722D626F74746F6D3A2034707820646F75626C6520766172282D2D7673636F64652D656469746F725761726E696E672D626F72646572293B';
wwv_flow_imp.g_varchar2_table(1188) := '5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D7761726E696E673A3A6265666F7265207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74636F6E74656E743A2027273B5C6E5C7477696474683A20313030253B5C6E';
wwv_flow_imp.g_varchar2_table(1189) := '5C746865696768743A20313030253B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D656469746F725761726E696E672D6261636B67726F756E64293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D';
wwv_flow_imp.g_varchar2_table(1190) := '696E666F207B5C6E5C74626F726465722D626F74746F6D3A2034707820646F75626C6520766172282D2D7673636F64652D656469746F72496E666F2D626F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D696E';
wwv_flow_imp.g_varchar2_table(1191) := '666F3A3A6265666F7265207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74636F6E74656E743A2027273B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C746261636B67726F756E643A2076617228';
wwv_flow_imp.g_varchar2_table(1192) := '2D2D7673636F64652D656469746F72496E666F2D6261636B67726F756E64293B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E7371756967676C792D68696E74207B5C6E5C74626F726465722D626F74746F6D3A2032707820646F74746564207661';
wwv_flow_imp.g_varchar2_table(1193) := '72282D2D7673636F64652D656469746F7248696E742D626F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E73686F77556E75736564202E7371756967676C792D756E6E6563657373617279207B5C6E5C74626F726465722D626F74746F';
wwv_flow_imp.g_varchar2_table(1194) := '6D3A203270782064617368656420766172282D2D7673636F64652D656469746F72556E6E6563657373617279436F64652D626F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E73686F7744657072656361746564202E7371756967676C';
wwv_flow_imp.g_varchar2_table(1195) := '792D696E6C696E652D64657072656361746564207B5C6E5C74746578742D6465636F726174696F6E3A206C696E652D7468726F7567683B5C6E5C74746578742D6465636F726174696F6E2D636F6C6F723A20766172282D2D7673636F64652D656469746F';
wwv_flow_imp.g_varchar2_table(1196) := '722D666F726567726F756E642C20696E6865726974293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C323138303A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831';
wwv_flow_imp.g_varchar2_table(1197) := '363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1198) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C2072696768';
wwv_flow_imp.g_varchar2_table(1199) := '74732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E';
wwv_flow_imp.g_varchar2_table(1200) := '666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1201) := '2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577207B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E5C747A';
wwv_flow_imp.g_varchar2_table(1202) := '2D696E6465783A2039393B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E646966662D726576696577207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E';
wwv_flow_imp.g_varchar2_table(1203) := '742E646966662D726576696577202E646966662D7265766965772D6C696E652D6E756D626572207B5C6E5C74746578742D616C69676E3A2072696768743B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74636F6C6F723A2076';
wwv_flow_imp.g_varchar2_table(1204) := '6172282D2D7673636F64652D656469746F724C696E654E756D6265722D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E646966662D7265766965772D73756D6D617279207B';
wwv_flow_imp.g_varchar2_table(1205) := '5C6E5C7470616464696E672D6C6566743A20313070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E646966662D7265766965772D736861646F77207B5C6E5C74706F736974696F6E3A206162736F6C';
wwv_flow_imp.g_varchar2_table(1206) := '7574653B5C6E5C74626F782D736861646F773A20766172282D2D7673636F64652D7363726F6C6C6261722D736861646F77292030202D36707820367078202D36707820696E7365743B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E6469';
wwv_flow_imp.g_varchar2_table(1207) := '66662D726576696577202E646966662D7265766965772D726F77207B5C6E5C7477686974652D73706163653A207072653B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E646966662D7265766965772D74';
wwv_flow_imp.g_varchar2_table(1208) := '61626C65207B5C6E5C74646973706C61793A207461626C653B5C6E5C746D696E2D77696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E646966662D7265766965772D726F77207B';
wwv_flow_imp.g_varchar2_table(1209) := '5C6E5C74646973706C61793A207461626C652D726F773B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E646966662D7265766965772D737061636572207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1210) := '74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C7477696474683A20313070783B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D72657669';
wwv_flow_imp.g_varchar2_table(1211) := '6577202E646966662D7265766965772D737061636572203E202E636F6469636F6E207B5C6E5C74666F6E742D73697A653A203970782021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D7265766965';
wwv_flow_imp.g_varchar2_table(1212) := '77202E646966662D7265766965772D616374696F6E73207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7472696768743A20313070783B5C6E5C74746F703A203270';
wwv_flow_imp.g_varchar2_table(1213) := '783B5C6E5C747A2D696E6465783A203130303B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E646966662D7265766965772D616374696F6E73202E616374696F6E2D6C6162656C207B5C6E5C7477696474';
wwv_flow_imp.g_varchar2_table(1214) := '683A20313670783B5C6E5C746865696768743A20313670783B5C6E5C746D617267696E3A2032707820303B5C6E7D5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E742E646966662D726576696577202E726576657274427574746F6E207B5C6E5C7463';
wwv_flow_imp.g_varchar2_table(1215) := '7572736F723A20706F696E7465723B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313932313A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E';
wwv_flow_imp.g_varchar2_table(1216) := '2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1217) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C20726967687473207265736572';
wwv_flow_imp.g_varchar2_table(1218) := '7665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F';
wwv_flow_imp.g_varchar2_table(1219) := '6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F';
wwv_flow_imp.g_varchar2_table(1220) := '5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E65732D776964676574207B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E';
wwv_flow_imp.g_varchar2_table(1221) := '6573207B5C6E5C746865696768743A203070783B202F2A20546865206368696C6472656E206561636820686176652061206669786564206865696768742C20746865207472616E73666F726D20636F6E6675736573207468652062726F77736572202A2F';
wwv_flow_imp.g_varchar2_table(1222) := '5C6E5C747472616E73666F726D3A207472616E736C617465283070782C202D31307078293B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C746C696E652D6865696768743A20313470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1223) := '202E646966662D68696464656E2D6C696E65733A6E6F74282E6472616767696E6729202E746F703A686F7665722C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E65733A6E6F74282E6472616767696E6729202E626F';
wwv_flow_imp.g_varchar2_table(1224) := '74746F6D3A686F7665722C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E746F702E6472616767696E672C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E626F';
wwv_flow_imp.g_varchar2_table(1225) := '74746F6D2E6472616767696E67207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D666F637573426F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C69';
wwv_flow_imp.g_varchar2_table(1226) := '6E6573202E746F702C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E626F74746F6D207B5C6E5C747472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652D6F7574';
wwv_flow_imp.g_varchar2_table(1227) := '3B5C6E5C746865696768743A203470783B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73706172656E743B5C6E5C746261636B67726F756E642D636C69703A2070616464696E672D626F783B5C6E5C74626F726465722D626F74746F';
wwv_flow_imp.g_varchar2_table(1228) := '6D3A2032707820736F6C6964207472616E73706172656E743B5C6E5C74626F726465722D746F703A2034707820736F6C6964207472616E73706172656E743B5C6E5C742F2A637572736F723A206E2D726573697A653B2A2F5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1229) := '636F2D656469746F722E6472616767696E67556E6368616E676564526567696F6E2E63616E4D6F7665546F703A6E6F74282E63616E4D6F7665426F74746F6D29202A2C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E';
wwv_flow_imp.g_varchar2_table(1230) := '6573202E746F702E63616E4D6F7665546F703A6E6F74282E63616E4D6F7665426F74746F6D292C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E626F74746F6D2E63616E4D6F7665546F703A6E6F74282E63';
wwv_flow_imp.g_varchar2_table(1231) := '616E4D6F7665426F74746F6D29207B5C6E5C74637572736F723A206E2D726573697A652021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E6472616767696E67556E6368616E676564526567696F6E3A6E6F74282E6361';
wwv_flow_imp.g_varchar2_table(1232) := '6E4D6F7665546F70292E63616E4D6F7665426F74746F6D202A2C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E746F703A6E6F74282E63616E4D6F7665546F70292E63616E4D6F7665426F74746F6D2C5C6E';
wwv_flow_imp.g_varchar2_table(1233) := '2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E626F74746F6D3A6E6F74282E63616E4D6F7665546F70292E63616E4D6F7665426F74746F6D207B5C6E5C74637572736F723A20732D726573697A652021696D706F';
wwv_flow_imp.g_varchar2_table(1234) := '7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E6472616767696E67556E6368616E676564526567696F6E2E63616E4D6F7665546F702E63616E4D6F7665426F74746F6D202A2C5C6E2E6D6F6E61636F2D656469746F72202E646966';
wwv_flow_imp.g_varchar2_table(1235) := '662D68696464656E2D6C696E6573202E746F702E63616E4D6F7665546F702E63616E4D6F7665426F74746F6D2C5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E626F74746F6D2E63616E4D6F7665546F702E';
wwv_flow_imp.g_varchar2_table(1236) := '63616E4D6F7665426F74746F6D207B5C6E5C74637572736F723A206E732D726573697A652021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E746F70207B5C6E5C7474';
wwv_flow_imp.g_varchar2_table(1237) := '72616E73666F726D3A207472616E736C617465283070782C20347078293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E626F74746F6D207B5C6E5C747472616E73666F726D3A207472616E73';
wwv_flow_imp.g_varchar2_table(1238) := '6C617465283070782C202D367078293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D756E6368616E6765642D6C696E6573207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D64696666456469746F72';
wwv_flow_imp.g_varchar2_table(1239) := '2D756E6368616E676564436F64654261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6E6F4D6F64696669636174696F6E734F7665726C6179207B5C6E5C747A2D696E6465783A20313B5C6E5C746261636B67726F75';
wwv_flow_imp.g_varchar2_table(1240) := '6E643A20766172282D2D7673636F64652D656469746F722D6261636B67726F756E64293B5C6E5C6E5C74646973706C61793A20666C65783B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74616C69676E2D6974656D733A';
wwv_flow_imp.g_varchar2_table(1241) := '2063656E7465723B5C6E7D5C6E5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E63656E746572207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D64696666456469746F722D';
wwv_flow_imp.g_varchar2_table(1242) := '756E6368616E676564526567696F6E4261636B67726F756E64293B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D64696666456469746F722D756E6368616E676564526567696F6E466F726567726F756E64293B5C6E5C746F766572666C6F';
wwv_flow_imp.g_varchar2_table(1243) := '773A2068696464656E3B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C6E5C746865696768743A20323470783B';
wwv_flow_imp.g_varchar2_table(1244) := '5C6E5C74626F782D736861646F773A20696E7365742030202D35707820357078202D37707820766172282D2D7673636F64652D64696666456469746F722D756E6368616E676564526567696F6E536861646F77292C20696E736574203020357078203570';
wwv_flow_imp.g_varchar2_table(1245) := '78202D37707820766172282D2D7673636F64652D64696666456469746F722D756E6368616E676564526567696F6E536861646F77293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E63656E74';
wwv_flow_imp.g_varchar2_table(1246) := '6572207370616E2E636F6469636F6E207B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573202E63656E74657220613A686F766572';
wwv_flow_imp.g_varchar2_table(1247) := '202E636F6469636F6E207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E6B2D616374697665466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1248) := '5C6E2E6D6F6E61636F2D656469746F72202E646966662D68696464656E2D6C696E6573206469762E62726561646372756D622D6974656D207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E';
wwv_flow_imp.g_varchar2_table(1249) := '646966662D68696464656E2D6C696E6573206469762E62726561646372756D622D6974656D3A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E6B2D616374697665466F726567726F756E64293B5C6E';
wwv_flow_imp.g_varchar2_table(1250) := '7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F7665644F726967696E616C207B5C6E5C74626F726465723A2032707820736F6C696420766172282D2D7673636F64652D64696666456469746F722D6D6F76652D626F72646572293B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1251) := '5C6E2E6D6F6E61636F2D656469746F72202E6D6F7665644D6F646966696564207B5C6E5C74626F726465723A2032707820736F6C696420766172282D2D7673636F64652D64696666456469746F722D6D6F76652D626F72646572293B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(1252) := '6D6F6E61636F2D656469746F72202E6D6F7665644F726967696E616C2E63757272656E744D6F76652C202E6D6F6E61636F2D656469746F72202E6D6F7665644D6F6469666965642E63757272656E744D6F7665207B5C6E5C74626F726465723A20327078';
wwv_flow_imp.g_varchar2_table(1253) := '20736F6C696420766172282D2D7673636F64652D64696666456469746F722D6D6F76654163746976652D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6D6F7665642D626C6F636B732D6C696E657320706174';
wwv_flow_imp.g_varchar2_table(1254) := '682E63757272656E744D6F7665207B5C6E5C747374726F6B653A20766172282D2D7673636F64652D64696666456469746F722D6D6F76654163746976652D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6D6F';
wwv_flow_imp.g_varchar2_table(1255) := '7665642D626C6F636B732D6C696E65732070617468207B5C6E5C74706F696E7465722D6576656E74733A2076697369626C657374726F6B653B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6D6F7665642D626C6F636B732D6C69';
wwv_flow_imp.g_varchar2_table(1256) := '6E6573202E6172726F77207B5C6E5C7466696C6C3A20766172282D2D7673636F64652D64696666456469746F722D6D6F76652D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6D6F7665642D626C6F636B732D';
wwv_flow_imp.g_varchar2_table(1257) := '6C696E6573202E6172726F772E63757272656E744D6F7665207B5C6E5C7466696C6C3A20766172282D2D7673636F64652D64696666456469746F722D6D6F76654163746976652D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D65';
wwv_flow_imp.g_varchar2_table(1258) := '6469746F72202E6D6F7665642D626C6F636B732D6C696E6573202E6172726F772D72656374616E676C65207B5C6E5C7466696C6C3A20766172282D2D7673636F64652D656469746F722D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(1259) := '2D646966662D656469746F72202E6D6F7665642D626C6F636B732D6C696E6573207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966';
wwv_flow_imp.g_varchar2_table(1260) := '662D656469746F72202E6D6F7665642D626C6F636B732D6C696E65732070617468207B5C6E5C7466696C6C3A206E6F6E653B5C6E5C747374726F6B653A20766172282D2D7673636F64652D64696666456469746F722D6D6F76652D626F72646572293B5C';
wwv_flow_imp.g_varchar2_table(1261) := '6E5C747374726F6B652D77696474683A20323B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636861722D64656C6574652E646966662D72616E67652D656D707479207B5C6E5C746D617267696E2D6C6566743A202D3170783B5C6E5C74626F';
wwv_flow_imp.g_varchar2_table(1262) := '726465722D6C6566743A20736F6C696420766172282D2D7673636F64652D64696666456469746F722D72656D6F766564546578744261636B67726F756E6429203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636861722D696E7365';
wwv_flow_imp.g_varchar2_table(1263) := '72742E646966662D72616E67652D656D707479207B5C6E5C74626F726465722D6C6566743A20736F6C696420766172282D2D7673636F64652D64696666456469746F722D696E736572746564546578744261636B67726F756E6429203370783B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1264) := '6E5C6E2E6D6F6E61636F2D656469746F72202E666F6C642D756E6368616E676564207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E646966662D6D6F7665642D636F64652D62';
wwv_flow_imp.g_varchar2_table(1265) := '6C6F636B207B5C6E5C74646973706C61793A20666C65783B5C6E5C746A7573746966792D636F6E74656E743A20666C65782D656E643B5C6E5C746D617267696E2D746F703A202D3470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F';
wwv_flow_imp.g_varchar2_table(1266) := '72202E646966662D6D6F7665642D636F64652D626C6F636B202E616374696F6E2D626172202E616374696F6E2D6C6162656C2E636F6469636F6E207B5C6E5C7477696474683A20313270783B5C6E5C746865696768743A20313270783B5C6E5C74666F6E';
wwv_flow_imp.g_varchar2_table(1267) := '742D73697A653A20313270783B5C6E7D5C6E5C6E2F2A202D2D2D2D2D2D2D2D2D2D2044696666456469746F72202D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E646966664F76657276696577207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1268) := '747A2D696E6465783A20393B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E646966664F76657276696577202E6469666656696577706F7274207B5C6E5C747A2D696E6465783A2031303B5C6E7D5C6E5C6E2F2A20636F6C6F7273';
wwv_flow_imp.g_varchar2_table(1269) := '206E6F742065787465726E616C697A65643A207573696E67207472616E73706172616E6379206F6E206261636B67726F756E64202A2F5C6E2E6D6F6E61636F2D646966662D656469746F722E76735C745C745C742E646966664F76657276696577207B20';
wwv_flow_imp.g_varchar2_table(1270) := '6261636B67726F756E643A207267626128302C20302C20302C20302E3033293B207D5C6E2E6D6F6E61636F2D646966662D656469746F722E76732D6461726B5C745C742E646966664F76657276696577207B206261636B67726F756E643A207267626128';
wwv_flow_imp.g_varchar2_table(1271) := '3235352C203235352C203235352C20302E3031293B207D5C6E5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E742E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F722E76735C745C742E7363726F6C6C6261';
wwv_flow_imp.g_varchar2_table(1272) := '72207B206261636B67726F756E643A207267626128302C302C302C30293B207D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E742E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F722E76732D6461726B5C';
wwv_flow_imp.g_varchar2_table(1273) := '742E7363726F6C6C626172207B206261636B67726F756E643A207267626128302C302C302C30293B207D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E742E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F';
wwv_flow_imp.g_varchar2_table(1274) := '722E68632D626C61636B5C742E7363726F6C6C626172207B206261636B67726F756E643A206E6F6E653B207D5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E742E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469';
wwv_flow_imp.g_varchar2_table(1275) := '746F722E68632D6C696768745C742E7363726F6C6C626172207B206261636B67726F756E643A206E6F6E653B207D5C6E5C6E2E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E742E6D6F6469666965642D696E2D6D6F6E61636F2D64696666';
wwv_flow_imp.g_varchar2_table(1276) := '2D656469746F72202E736C69646572207B5C6E5C747A2D696E6465783A2031303B5C6E7D5C6E2E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F725C745C745C745C742E736C696465722E616374697665207B206261636B6772';
wwv_flow_imp.g_varchar2_table(1277) := '6F756E643A2072676261283137312C203137312C203137312C202E34293B207D5C6E2E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F722E68632D626C61636B5C742E736C696465722E616374697665207B206261636B67726F';
wwv_flow_imp.g_varchar2_table(1278) := '756E643A206E6F6E653B207D5C6E2E6D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F722E68632D6C696768745C742E736C696465722E616374697665207B206261636B67726F756E643A206E6F6E653B207D5C6E5C6E2F2A202D';
wwv_flow_imp.g_varchar2_table(1279) := '2D2D2D2D2D2D2D2D2D2044696666202D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E736572742D7369676E2C5C6E2E6D6F6E61636F2D646966662D656469746F72202E696E736572742D7369676E2C5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1280) := '6E61636F2D656469746F72202E64656C6574652D7369676E2C5C6E2E6D6F6E61636F2D646966662D656469746F72202E64656C6574652D7369676E207B5C6E5C74666F6E742D73697A653A20313170782021696D706F7274616E743B5C6E5C746F706163';
wwv_flow_imp.g_varchar2_table(1281) := '6974793A20302E372021696D706F7274616E743B5C6E5C74646973706C61793A20666C65782021696D706F7274616E743B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C6163';
wwv_flow_imp.g_varchar2_table(1282) := '6B202E696E736572742D7369676E2C5C6E2E6D6F6E61636F2D646966662D656469746F722E68632D626C61636B202E696E736572742D7369676E2C5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E64656C6574652D7369676E2C5C6E';
wwv_flow_imp.g_varchar2_table(1283) := '2E6D6F6E61636F2D646966662D656469746F722E68632D626C61636B202E64656C6574652D7369676E2C5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E696E736572742D7369676E2C5C6E2E6D6F6E61636F2D646966662D65646974';
wwv_flow_imp.g_varchar2_table(1284) := '6F722E68632D6C69676874202E696E736572742D7369676E2C5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E64656C6574652D7369676E2C5C6E2E6D6F6E61636F2D646966662D656469746F722E68632D6C69676874202E64656C65';
wwv_flow_imp.g_varchar2_table(1285) := '74652D7369676E207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D64656C657465642D6D617267696E2D766965772D7A6F6E65207B5C6E5C74746578742D616C69676E3A2072696768';
wwv_flow_imp.g_varchar2_table(1286) := '743B5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D61646465642D6D617267696E2D766965772D7A6F6E65207B5C6E5C74746578742D616C69676E3A2072696768743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E61';
wwv_flow_imp.g_varchar2_table(1287) := '72726F772D7265766572742D6368616E6765207B5C6E5C747A2D696E6465783A2031303B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6172726F772D7265766572742D6368616E67';
wwv_flow_imp.g_varchar2_table(1288) := '653A686F766572207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2F2A202D2D2D2D2D2D2D2D2D2D20496E6C696E652044696666202D2D2D2D2D2D2D2D2D2D202A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E766965772D';
wwv_flow_imp.g_varchar2_table(1289) := '7A6F6E6573202E766965772D6C696E6573202E766965772D6C696E65207370616E207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D7A6F6E65';
wwv_flow_imp.g_varchar2_table(1290) := '73202E6C6967687462756C622D676C7970683A686F766572207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636861722D696E736572742C202E6D6F6E61636F2D646966662D656469746F';
wwv_flow_imp.g_varchar2_table(1291) := '72202E636861722D696E73657274207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D64696666456469746F722D696E736572746564546578744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(1292) := '2D656469746F72202E6C696E652D696E736572742C202E6D6F6E61636F2D646966662D656469746F72202E6C696E652D696E73657274207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D64696666456469746F';
wwv_flow_imp.g_varchar2_table(1293) := '722D696E7365727465644C696E654261636B67726F756E642C20766172282D2D7673636F64652D64696666456469746F722D696E736572746564546578744261636B67726F756E6429293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C69';
wwv_flow_imp.g_varchar2_table(1294) := '6E652D696E736572742C5C6E2E6D6F6E61636F2D656469746F72202E636861722D696E73657274207B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(1295) := '64652D64696666456469746F722D696E73657274656454657874426F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E6C696E652D696E736572742C202E6D6F6E61636F2D656469746F722E68632D6C69676874';
wwv_flow_imp.g_varchar2_table(1296) := '202E6C696E652D696E736572742C5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E636861722D696E736572742C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E636861722D696E73657274207B5C6E5C74626F7264';
wwv_flow_imp.g_varchar2_table(1297) := '65722D7374796C653A206461736865643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C696E652D64656C6574652C5C6E2E6D6F6E61636F2D656469746F72202E636861722D64656C657465207B5C6E5C74626F782D73697A696E673A2062';
wwv_flow_imp.g_varchar2_table(1298) := '6F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D64696666456469746F722D72656D6F76656454657874426F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C';
wwv_flow_imp.g_varchar2_table(1299) := '61636B202E6C696E652D64656C6574652C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E6C696E652D64656C6574652C5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E636861722D64656C6574652C202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1300) := '636F2D656469746F722E68632D6C69676874202E636861722D64656C657465207B5C6E5C74626F726465722D7374796C653A206461736865643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D61646465642D6D617267696E';
wwv_flow_imp.g_varchar2_table(1301) := '2D766965772D7A6F6E652C5C6E2E6D6F6E61636F2D656469746F72202E6775747465722D696E736572742C202E6D6F6E61636F2D646966662D656469746F72202E6775747465722D696E73657274207B5C6E5C746261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1302) := '3A20766172282D2D7673636F64652D64696666456469746F724775747465722D696E7365727465644C696E654261636B67726F756E642C20766172282D2D7673636F64652D64696666456469746F722D696E7365727465644C696E654261636B67726F75';
wwv_flow_imp.g_varchar2_table(1303) := '6E64292C20766172282D2D7673636F64652D64696666456469746F722D696E736572746564546578744261636B67726F756E6429293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636861722D64656C6574652C202E6D6F6E61636F2D6469';
wwv_flow_imp.g_varchar2_table(1304) := '66662D656469746F72202E636861722D64656C657465207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D64696666456469746F722D72656D6F766564546578744261636B67726F756E64293B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1305) := '2E6D6F6E61636F2D656469746F72202E6C696E652D64656C6574652C202E6D6F6E61636F2D646966662D656469746F72202E6C696E652D64656C657465207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D6469';
wwv_flow_imp.g_varchar2_table(1306) := '6666456469746F722D72656D6F7665644C696E654261636B67726F756E642C20766172282D2D7673636F64652D64696666456469746F722D72656D6F766564546578744261636B67726F756E6429293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1307) := '72202E696E6C696E652D64656C657465642D6D617267696E2D766965772D7A6F6E652C5C6E2E6D6F6E61636F2D656469746F72202E6775747465722D64656C6574652C202E6D6F6E61636F2D646966662D656469746F72202E6775747465722D64656C65';
wwv_flow_imp.g_varchar2_table(1308) := '7465207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D64696666456469746F724775747465722D72656D6F7665644C696E654261636B67726F756E642C20766172282D2D7673636F64652D6469666645646974';
wwv_flow_imp.g_varchar2_table(1309) := '6F722D72656D6F7665644C696E654261636B67726F756E64292C20766172282D2D7673636F64652D64696666456469746F722D72656D6F766564546578744261636B67726F756E6429293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F';
wwv_flow_imp.g_varchar2_table(1310) := '722E736964652D62792D73696465202E656469746F722E6D6F646966696564207B5C6E5C74626F782D736861646F773A202D367078203020357078202D35707820766172282D2D7673636F64652D7363726F6C6C6261722D736861646F77293B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1311) := '626F726465722D6C6566743A2031707820736F6C696420766172282D2D7673636F64652D64696666456469746F722D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F722E736964652D62792D73696465202E65646974';
wwv_flow_imp.g_varchar2_table(1312) := '6F722E6F726967696E616C207B5C6E5C74626F782D736861646F773A20367078203020357078202D35707820766172282D2D7673636F64652D7363726F6C6C6261722D736861646F77293B5C6E5C74626F726465722D72696768743A2031707820736F6C';
wwv_flow_imp.g_varchar2_table(1313) := '696420766172282D2D7673636F64652D64696666456469746F722D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6469666656696577706F7274207B5C6E5C746261636B67726F756E643A20766172282D2D76';
wwv_flow_imp.g_varchar2_table(1314) := '73636F64652D7363726F6C6C626172536C696465722D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6469666656696577706F72743A686F766572207B5C6E5C746261636B67726F756E643A207661';
wwv_flow_imp.g_varchar2_table(1315) := '72282D2D7673636F64652D7363726F6C6C626172536C696465722D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D646966662D656469746F72202E6469666656696577706F72743A616374697665207B5C6E5C74626163';
wwv_flow_imp.g_varchar2_table(1316) := '6B67726F756E643A20766172282D2D7673636F64652D7363726F6C6C626172536C696465722D6163746976654261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E646961676F6E616C2D66696C6C207B5C6E5C746261';
wwv_flow_imp.g_varchar2_table(1317) := '636B67726F756E642D696D6167653A206C696E6561722D6772616469656E74285C6E5C745C742D34356465672C5C6E5C745C74766172282D2D7673636F64652D64696666456469746F722D646961676F6E616C46696C6C292031322E35252C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(1318) := '7423303030302031322E35252C202330303030203530252C5C6E5C745C74766172282D2D7673636F64652D64696666456469746F722D646961676F6E616C46696C6C29203530252C20766172282D2D7673636F64652D64696666456469746F722D646961';
wwv_flow_imp.g_varchar2_table(1319) := '676F6E616C46696C6C292036322E35252C5C6E5C745C7423303030302036322E35252C20233030303020313030255C6E5C74293B5C6E5C746261636B67726F756E642D73697A653A20387078203870783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64696666';
wwv_flow_imp.g_varchar2_table(1320) := '2D656469746F72202E677574746572207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74666C65782D736872696E6B3A20303B5C6E5C74666C65782D67726F773A20303B5C6E5C';
wwv_flow_imp.g_varchar2_table(1321) := '6E5C742E6775747465724974656D207B5C6E5C745C746F7061636974793A20303B5C6E5C745C747472616E736974696F6E3A206F70616369747920302E37733B5C6E5C6E5C745C74262E73686F77416C77617973207B5C6E5C745C745C746F7061636974';
wwv_flow_imp.g_varchar2_table(1322) := '793A20313B5C6E5C745C745C747472616E736974696F6E3A206E6F6E653B5C6E5C745C747D5C6E5C6E5C745C74262E6E6F5472616E736974696F6E207B5C6E5C745C745C747472616E736974696F6E3A206E6F6E653B5C6E5C745C747D5C6E5C747D5C6E';
wwv_flow_imp.g_varchar2_table(1323) := '5C6E5C74263A686F766572202E6775747465724974656D207B5C6E5C745C746F7061636974793A20313B5C6E5C745C747472616E736974696F6E3A206F70616369747920302E317320656173652D696E2D6F75743B5C6E5C747D5C6E5C6E5C742E677574';
wwv_flow_imp.g_varchar2_table(1324) := '7465724974656D207B5C6E5C745C742E6261636B67726F756E64207B5C6E5C745C745C74706F736974696F6E3A206162736F6C7574653B5C6E5C745C745C746865696768743A20313030253B5C6E5C745C745C746C6566743A203530253B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(1325) := '5C7477696474683A203170783B5C6E5C6E5C745C745C74626F726465722D6C6566743A2032707820766172282D2D7673636F64652D6D656E752D626F726465722920736F6C69643B5C6E5C745C747D5C6E5C6E5C745C742E627574746F6E73207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1326) := '745C745C74706F736974696F6E3A206162736F6C7574653B5C6E5C745C745C742F2A6865696768743A20313030253B2A2F5C6E5C745C745C7477696474683A20313030253B5C6E5C6E5C745C745C74646973706C61793A20666C65783B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(1327) := '746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C745C745C74616C69676E2D6974656D733A2063656E7465723B5C6E5C6E5C745C745C742E6D6F6E61636F2D746F6F6C626172207B5C6E5C745C745C745C746865696768743A206669';
wwv_flow_imp.g_varchar2_table(1328) := '742D636F6E74656E743B5C6E5C745C745C745C742E6D6F6E61636F2D616374696F6E2D62617220207B5C6E5C745C745C745C745C746C696E652D6865696768743A20313B5C6E5C6E5C745C745C745C745C742E616374696F6E732D636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(1329) := '207B5C6E5C745C745C745C745C745C7477696474683A206669742D636F6E74656E743B5C6E5C745C745C745C745C745C74626F726465722D7261646975733A203470783B5C6E5C745C745C745C745C745C74626F726465723A2031707820766172282D2D';
wwv_flow_imp.g_varchar2_table(1330) := '7673636F64652D6D656E752D626F726465722920736F6C69643B5C6E5C745C745C745C745C745C746261636B67726F756E643A20766172282D2D7673636F64652D656469746F722D6261636B67726F756E64293B5C6E5C6E5C745C745C745C745C745C74';
wwv_flow_imp.g_varchar2_table(1331) := '2E616374696F6E2D6974656D207B5C6E5C745C745C745C745C745C745C74263A686F766572207B5C6E5C745C745C745C745C745C745C745C746261636B67726F756E643A20766172282D2D7673636F64652D746F6F6C6261722D686F7665724261636B67';
wwv_flow_imp.g_varchar2_table(1332) := '726F756E64293B5C6E5C745C745C745C745C745C745C747D5C6E5C6E5C745C745C745C745C745C745C742E616374696F6E2D6C6162656C207B5C6E5C745C745C745C745C745C745C745C7470616464696E673A20302E357078203170783B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(1333) := '5C745C745C745C745C747D5C6E5C745C745C745C745C745C747D5C6E5C745C745C745C745C747D5C6E5C745C745C745C747D5C6E5C745C745C747D5C6E5C745C747D5C6E5C747D5C6E7D5C6E222C22225D293B636F6E737420613D727D2C363833353A28';
wwv_flow_imp.g_varchar2_table(1334) := '652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E6964';
wwv_flow_imp.g_varchar2_table(1335) := '2C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E20';
wwv_flow_imp.g_varchar2_table(1336) := '2A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E205365';
wwv_flow_imp.g_varchar2_table(1337) := '65204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1338) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E64657265642D6D61726B646F776E206B6264207B5C';
wwv_flow_imp.g_varchar2_table(1339) := '6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D6261636B67726F756E64293B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C616265';
wwv_flow_imp.g_varchar2_table(1340) := '6C2D666F726567726F756E64293B5C6E5C74626F726465722D7374796C653A20736F6C69643B5C6E5C74626F726465722D77696474683A203170783B5C6E5C74626F726465722D7261646975733A203370783B5C6E5C74626F726465722D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(1341) := '20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D626F72646572293B5C6E5C74626F726465722D626F74746F6D2D636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D626F74746F6D426F';
wwv_flow_imp.g_varchar2_table(1342) := '72646572293B5C6E5C74626F782D736861646F773A20696E7365742030202D317078203020766172282D2D7673636F64652D7769646765742D736861646F77293B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E5C7470616464';
wwv_flow_imp.g_varchar2_table(1343) := '696E673A20317078203370783B5C6E7D5C6E5C6E2E72656E64657265642D6D61726B646F776E206C693A68617328696E7075745B747970653D636865636B626F785D29207B5C6E5C746C6973742D7374796C652D747970653A206E6F6E653B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1344) := '222C22225D293B636F6E737420613D727D2C363531343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E';
wwv_flow_imp.g_varchar2_table(1345) := '6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1346) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E7365642075';
wwv_flow_imp.g_varchar2_table(1347) := '6E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1348) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D636F6D706F6E656E';
wwv_flow_imp.g_varchar2_table(1349) := '742E6D756C746944696666456469746F72207B5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D6D756C746944696666456469746F722D6261636B67726F756E64293B5C6E5C746F766572666C6F772D793A2068696464656E3B5C';
wwv_flow_imp.g_varchar2_table(1350) := '6E5C6E5C742E616374697665207B5C6E5C745C742D2D7673636F64652D6D756C746944696666456469746F722D626F726465723A20766172282D2D7673636F64652D666F637573426F72646572293B5C6E5C747D5C6E5C6E5C742E6D756C746944696666';
wwv_flow_imp.g_varchar2_table(1351) := '456E747279207B5C6E5C745C74646973706C61793A20666C65783B5C6E5C745C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C745C74666C65783A20313B5C6E5C745C746F766572666C6F773A2068696464656E3B5C6E5C6E5C6E5C';
wwv_flow_imp.g_varchar2_table(1352) := '745C742E636F6C6C617073652D627574746F6E207B5C6E5C745C745C746D617267696E3A2030203570783B5C6E5C745C745C74637572736F723A20706F696E7465723B5C6E5C6E5C745C745C7461207B5C6E5C745C745C745C74646973706C61793A2062';
wwv_flow_imp.g_varchar2_table(1353) := '6C6F636B3B5C6E5C745C745C747D5C6E5C745C747D5C6E5C6E5C745C742E686561646572207B5C6E5C745C745C747A2D696E6465783A20313030303B5C6E5C745C745C746261636B67726F756E643A20766172282D2D7673636F64652D656469746F722D';
wwv_flow_imp.g_varchar2_table(1354) := '6261636B67726F756E64293B5C6E5C6E5C745C745C74263A6E6F74282E636F6C6C617073656429202E6865616465722D636F6E74656E74207B5C6E5C745C745C745C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673';
wwv_flow_imp.g_varchar2_table(1355) := '636F64652D7369646542617253656374696F6E4865616465722D626F72646572293B5C6E5C745C745C747D5C6E5C6E5C745C745C742E6865616465722D636F6E74656E74207B5C6E5C745C745C745C746D617267696E3A20387078203070782030707820';
wwv_flow_imp.g_varchar2_table(1356) := '3070783B5C6E5C745C745C745C7470616464696E673A20347078203570783B5C6E5C6E5C745C745C745C74626F726465722D746F703A2031707820736F6C696420766172282D2D7673636F64652D6D756C746944696666456469746F722D626F72646572';
wwv_flow_imp.g_varchar2_table(1357) := '293B5C6E5C6E5C745C745C745C74646973706C61793A20666C65783B5C6E5C745C745C745C74616C69676E2D6974656D733A2063656E7465723B5C6E5C6E5C745C745C745C74636F6C6F723A20766172282D2D7673636F64652D666F726567726F756E64';
wwv_flow_imp.g_varchar2_table(1358) := '293B5C6E5C745C745C745C746261636B67726F756E643A20766172282D2D7673636F64652D6D756C746944696666456469746F722D6865616465724261636B67726F756E64293B5C6E5C6E5C745C745C745C74262E736861646F77207B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(1359) := '745C745C74626F782D736861646F773A20766172282D2D7673636F64652D7363726F6C6C6261722D736861646F7729203070782036707820367078202D3670783B5C6E5C745C745C745C747D5C6E5C6E5C745C745C745C742E66696C652D70617468207B';
wwv_flow_imp.g_varchar2_table(1360) := '5C6E5C745C745C745C745C74646973706C61793A20666C65783B5C6E5C745C745C745C745C74666C65783A20313B5C6E5C745C745C745C745C746D696E2D77696474683A20303B5C6E5C6E5C745C745C745C745C742E7469746C65207B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(1361) := '745C745C745C74666F6E742D73697A653A20313470783B5C6E5C745C745C745C745C745C746C696E652D6865696768743A20323270783B5C6E5C6E5C745C745C745C745C745C74262E6F726967696E616C207B5C6E5C745C745C745C745C745C745C7466';
wwv_flow_imp.g_varchar2_table(1362) := '6C65783A20313B5C6E5C745C745C745C745C745C745C746D696E2D77696474683A20303B5C6E5C745C745C745C745C745C745C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C745C745C745C745C745C747D5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(1363) := '745C747D5C6E5C6E5C745C745C745C745C742E737461747573207B5C6E5C745C745C745C745C745C74666F6E742D7765696768743A203630303B5C6E5C745C745C745C745C745C746F7061636974793A20302E37353B5C6E5C745C745C745C745C745C74';
wwv_flow_imp.g_varchar2_table(1364) := '6D617267696E3A2030707820313070783B5C6E5C745C745C745C745C745C746C696E652D6865696768743A20323270783B5C6E5C6E5C745C745C745C745C745C742F2A5C6E5C745C745C745C745C745C745C74544F444F406865646965743A206D6F7665';
wwv_flow_imp.g_varchar2_table(1365) := '20636F6C6F72732066726F6D2067697420657874656E73696F6E20746F20636F7265215C6E5C745C745C745C745C745C74262E72656E616D6564207B5C6E5C745C745C745C745C745C745C74636F6C6F723A2076206172282D2D7673636F64652D676974';
wwv_flow_imp.g_varchar2_table(1366) := '4465636F726174696F6E2D72656E616D65645265736F75726365466F726567726F756E64293B5C6E5C745C745C745C745C745C747D5C6E5C6E5C745C745C745C745C745C74262E64656C65746564207B5C6E5C745C745C745C745C745C745C74636F6C6F';
wwv_flow_imp.g_varchar2_table(1367) := '723A2076206172282D2D7673636F64652D6769744465636F726174696F6E2D64656C657465645265736F75726365466F726567726F756E64293B5C6E5C745C745C745C745C745C747D5C6E5C6E5C745C745C745C745C745C74262E6164646564207B5C6E';
wwv_flow_imp.g_varchar2_table(1368) := '5C745C745C745C745C745C745C74636F6C6F723A2076206172282D2D7673636F64652D6769744465636F726174696F6E2D61646465645265736F75726365466F726567726F756E64293B5C6E5C745C745C745C745C745C747D5C6E5C745C745C745C745C';
wwv_flow_imp.g_varchar2_table(1369) := '745C742A2F5C6E5C745C745C745C745C747D5C6E5C745C745C745C747D5C6E5C6E5C745C745C745C742E616374696F6E73207B5C6E5C745C745C745C745C7470616464696E673A2030203870783B5C6E5C745C745C745C747D5C6E5C745C745C747D5C6E';
wwv_flow_imp.g_varchar2_table(1370) := '5C6E5C6E5C745C747D5C6E5C6E5C745C742E656469746F72506172656E74207B5C6E5C745C745C74666C65783A20313B5C6E5C745C745C74646973706C61793A20666C65783B5C6E5C745C745C74666C65782D646972656374696F6E3A20636F6C756D6E';
wwv_flow_imp.g_varchar2_table(1371) := '3B5C6E5C6E5C745C745C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673636F64652D6D756C746944696666456469746F722D626F72646572293B5C6E5C745C745C746F766572666C6F773A2068696464656E3B5C6E';
wwv_flow_imp.g_varchar2_table(1372) := '5C745C747D5C6E5C6E5C745C742E656469746F72436F6E7461696E6572207B5C6E5C745C745C74666C65783A20313B5C6E5C745C747D5C6E5C747D5C6E7D5C6E222C22225D293B636F6E737420613D727D2C323735353A28652C742C6E293D3E7B227573';
wwv_flow_imp.g_varchar2_table(1373) := '6520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1374) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F70797269676874';
wwv_flow_imp.g_varchar2_table(1375) := '20286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E7478';
wwv_flow_imp.g_varchar2_table(1376) := '7420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1377) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E73656C656374696F6E2D616E63686F72207B5C6E5C746261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(1378) := '6F723A20233030374143433B5C6E5C7477696474683A203270782021696D706F7274616E743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C373939373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A2829';
wwv_flow_imp.g_varchar2_table(1379) := '3D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1380) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F72';
wwv_flow_imp.g_varchar2_table(1381) := '6174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F74';
wwv_flow_imp.g_varchar2_table(1382) := '20666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1383) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E627261636B65742D6D61746368207B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(1384) := '636F6C6F723A20766172282D2D7673636F64652D656469746F72427261636B65744D617463682D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72427261636B65744D';
wwv_flow_imp.g_varchar2_table(1385) := '617463682D626F72646572293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C343136393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E';
wwv_flow_imp.g_varchar2_table(1386) := '2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1387) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665';
wwv_flow_imp.g_varchar2_table(1388) := '642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E';
wwv_flow_imp.g_varchar2_table(1389) := '5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E';
wwv_flow_imp.g_varchar2_table(1390) := '5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C62576964676574207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A206365';
wwv_flow_imp.g_varchar2_table(1391) := '6E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C625769646765743A686F7665727B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C696768744275';
wwv_flow_imp.g_varchar2_table(1392) := '6C625769646765742E636F6469636F6E2D6C696768742D62756C622C5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C625769646765742E636F6469636F6E2D6C6967687462756C622D737061726B6C65207B5C6E5C74636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1393) := '766172282D2D7673636F64652D656469746F724C6967687442756C622D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C625769646765742E636F6469636F6E2D6C6967687462756C622D6175';
wwv_flow_imp.g_varchar2_table(1394) := '746F6669782C5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C625769646765742E636F6469636F6E2D6C6967687462756C622D737061726B6C652D6175746F666978207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D65';
wwv_flow_imp.g_varchar2_table(1395) := '6469746F724C6967687442756C624175746F4669782D666F726567726F756E642C20766172282D2D7673636F64652D656469746F724C6967687442756C622D666F726567726F756E6429293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C';
wwv_flow_imp.g_varchar2_table(1396) := '6967687442756C625769646765742E636F6469636F6E2D737061726B6C652D66696C6C6564207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C6967687442756C6241692D666F726567726F756E642C20766172282D2D76';
wwv_flow_imp.g_varchar2_table(1397) := '73636F64652D69636F6E2D666F726567726F756E6429293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C625769646765743A6265666F7265207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C747A2D';
wwv_flow_imp.g_varchar2_table(1398) := '696E6465783A20323B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6C6967687442756C625769646765743A6166746572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A2030';
wwv_flow_imp.g_varchar2_table(1399) := '3B5C6E5C74636F6E74656E743A2027273B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C746F7061636974793A20302E333B5C6E5C746261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1400) := '2D636F6C6F723A20766172282D2D7673636F64652D656469746F722D6261636B67726F756E64293B5C6E5C747A2D696E6465783A20313B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313732373A28652C742C6E293D3E7B22757365207374';
wwv_flow_imp.g_varchar2_table(1401) := '72696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1402) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329';
wwv_flow_imp.g_varchar2_table(1403) := '204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E';
wwv_flow_imp.g_varchar2_table(1404) := '207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1405) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E207B5C6E5C746F766572666C6F773A206869646465';
wwv_flow_imp.g_varchar2_table(1406) := '6E3B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74636F6C6F723A20766172282D2D767363';
wwv_flow_imp.g_varchar2_table(1407) := '6F64652D656469746F72436F64654C656E732D666F726567726F756E64293B5C6E5C746C696E652D6865696768743A20766172282D2D7673636F64652D656469746F72436F64654C656E732D6C696E65486569676874293B5C6E5C74666F6E742D73697A';
wwv_flow_imp.g_varchar2_table(1408) := '653A20766172282D2D7673636F64652D656469746F72436F64654C656E732D666F6E7453697A65293B5C6E5C7470616464696E672D72696768743A2063616C6328766172282D2D7673636F64652D656469746F72436F64654C656E732D666F6E7453697A';
wwv_flow_imp.g_varchar2_table(1409) := '65292A302E35293B5C6E5C74666F6E742D666561747572652D73657474696E67733A20766172282D2D7673636F64652D656469746F72436F64654C656E732D666F6E744665617475726553657474696E6773293B5C6E5C74666F6E742D66616D696C793A';
wwv_flow_imp.g_varchar2_table(1410) := '20766172282D2D7673636F64652D656469746F72436F64654C656E732D666F6E7446616D696C79292C20766172282D2D7673636F64652D656469746F72436F64654C656E732D666F6E7446616D696C7944656661756C74293B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(1411) := '61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E203E207370616E2C5C6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E203E2061207B5C6E5C74757365722D73656C6563743A206E';
wwv_flow_imp.g_varchar2_table(1412) := '6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74766572746963616C2D616C69676E3A207375623B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469';
wwv_flow_imp.g_varchar2_table(1413) := '746F72202E636F64656C656E732D6465636F726174696F6E203E2061207B5C6E5C74746578742D6465636F726174696F6E3A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E203E';
wwv_flow_imp.g_varchar2_table(1414) := '20613A686F766572207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E6B2D616374697665466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(1415) := '6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E203E20613A686F766572202E636F6469636F6E207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E6B2D616374697665466F';
wwv_flow_imp.g_varchar2_table(1416) := '726567726F756E64292021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E202E636F6469636F6E207B5C6E5C74766572746963616C2D616C69676E3A206D6964646C65';
wwv_flow_imp.g_varchar2_table(1417) := '3B5C6E5C74636F6C6F723A2063757272656E74436F6C6F722021696D706F7274616E743B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72436F64654C656E732D666F726567726F756E64293B5C6E5C746C696E652D68656967';
wwv_flow_imp.g_varchar2_table(1418) := '68743A20766172282D2D7673636F64652D656469746F72436F64654C656E732D6C696E65486569676874293B5C6E5C74666F6E742D73697A653A20766172282D2D7673636F64652D656469746F72436F64654C656E732D666F6E7453697A65293B5C6E7D';
wwv_flow_imp.g_varchar2_table(1419) := '5C6E5C6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E203E20613A686F766572202E636F6469636F6E3A3A6265666F7265207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E406B657966';
wwv_flow_imp.g_varchar2_table(1420) := '72616D65732066616465696E207B5C6E5C743025207B5C6E5C745C746F7061636974793A20303B5C6E5C745C747669736962696C6974793A2076697369626C653B5C6E5C747D5C6E5C6E5C7431303025207B5C6E5C745C746F7061636974793A20313B5C';
wwv_flow_imp.g_varchar2_table(1421) := '6E5C747D5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636F64656C656E732D6465636F726174696F6E2E66616465696E207B5C6E5C74616E696D6174696F6E3A2066616465696E20302E3173206C696E6561723B5C6E7D5C6E222C22225D29';
wwv_flow_imp.g_varchar2_table(1422) := '3B636F6E737420613D727D2C333334353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E757D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292C61';
wwv_flow_imp.g_varchar2_table(1423) := '3D6E2834343137292C6C3D6E2E6E2861292C633D6E65772055524C286E2838393638292C6E2E62292C643D722829286F2829292C683D6C28292863293B642E70757368285B652E69642C602F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1424) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420';
wwv_flow_imp.g_varchar2_table(1425) := '436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A6563';
wwv_flow_imp.g_varchar2_table(1426) := '7420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1427) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E636F6C6F727069636B65722D776964676574207B5C6E5C746865696768743A2031393070783B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C742D77';
wwv_flow_imp.g_varchar2_table(1428) := '65626B69742D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E2F2A204465636F726174696F6E202A2F5C6E5C6E2E636F6C6F727069636B65722D636F6C6F722D6465636F726174696F6E2C5C6E2E68632D6C69676874202E636F6C6F7270';
wwv_flow_imp.g_varchar2_table(1429) := '69636B65722D636F6C6F722D6465636F726174696F6E207B5C6E5C74626F726465723A20736F6C696420302E31656D20233030303B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746D617267696E3A20302E31656D20302E';
wwv_flow_imp.g_varchar2_table(1430) := '32656D203020302E32656D3B5C6E5C7477696474683A20302E38656D3B5C6E5C746865696768743A20302E38656D3B5C6E5C746C696E652D6865696768743A20302E38656D3B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1431) := '637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E68632D626C61636B202E636F6C6F727069636B65722D636F6C6F722D6465636F726174696F6E2C5C6E2E76732D6461726B202E636F6C6F727069636B65722D636F6C6F722D6465636F726174';
wwv_flow_imp.g_varchar2_table(1432) := '696F6E207B5C6E5C74626F726465723A20736F6C696420302E31656D20236565653B5C6E7D5C6E5C6E2F2A20486561646572202A2F5C6E5C6E2E636F6C6F727069636B65722D686561646572207B5C6E5C74646973706C61793A20666C65783B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1433) := '6865696768743A20323470783B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746261636B67726F756E643A2075726C28247B687D293B5C6E5C746261636B67726F756E642D73697A653A20397078203970783B5C6E5C74696D616765';
wwv_flow_imp.g_varchar2_table(1434) := '2D72656E646572696E673A20706978656C617465643B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E7069636B65642D636F6C6F72207B5C6E5C7477696474683A2032343070783B5C6E5C74646973706C61793A20666C65783B5C';
wwv_flow_imp.g_varchar2_table(1435) := '6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C746C696E652D6865696768743A20323470783B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74636F6C';
wwv_flow_imp.g_varchar2_table(1436) := '6F723A2077686974653B5C6E5C74666C65783A20313B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E7069636B65';
wwv_flow_imp.g_varchar2_table(1437) := '642D636F6C6F72202E7069636B65642D636F6C6F722D70726573656E746174696F6E207B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C746D617267696E2D6C6566743A203570783B5C6E5C746D617267696E2D72696768743A2035';
wwv_flow_imp.g_varchar2_table(1438) := '70783B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E7069636B65642D636F6C6F72202E636F6469636F6E207B5C6E5C74636F6C6F723A20696E68657269743B5C6E5C74666F6E742D73697A653A20313470783B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1439) := '2E636F6C6F727069636B65722D686561646572202E7069636B65642D636F6C6F722E6C69676874207B5C6E5C74636F6C6F723A20626C61636B3B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E6F726967696E616C2D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1440) := '207B5C6E5C7477696474683A20373470783B5C6E5C747A2D696E6465783A20696E68657269743B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E7374616E64616C6F6E652D636F6C6F727069636B6572207B5C6E5C74636F6C6F72';
wwv_flow_imp.g_varchar2_table(1441) := '3A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D666F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261';
wwv_flow_imp.g_varchar2_table(1442) := '636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D6865616465722E7374';
wwv_flow_imp.g_varchar2_table(1443) := '616E64616C6F6E652D636F6C6F727069636B6572207B5C6E5C74626F726465722D626F74746F6D3A206E6F6E653B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E636C6F73652D627574746F6E207B5C6E5C74637572736F723A20';
wwv_flow_imp.g_varchar2_table(1444) := '706F696E7465723B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465722D6C6566743A2031707820736F6C696420';
wwv_flow_imp.g_varchar2_table(1445) := '766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E636C6F73652D627574746F6E2D696E6E65722D646976207B5C6E5C747769647468';
wwv_flow_imp.g_varchar2_table(1446) := '3A20313030253B5C6E5C746865696768743A20313030253B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E636C6F73652D627574746F6E2D696E6E65722D6469763A686F';
wwv_flow_imp.g_varchar2_table(1447) := '766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D746F6F6C6261722D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D686561646572202E636C6F73652D69';
wwv_flow_imp.g_varchar2_table(1448) := '636F6E207B5C6E5C7470616464696E673A203370783B5C6E7D5C6E5C6E2F2A20426F6479202A2F5C6E5C6E2E636F6C6F727069636B65722D626F6479207B5C6E5C74646973706C61793A20666C65783B5C6E5C7470616464696E673A203870783B5C6E5C';
wwv_flow_imp.g_varchar2_table(1449) := '74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E73617475726174696F6E2D77726170207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C746865696768743A2031353070';
wwv_flow_imp.g_varchar2_table(1450) := '783B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746D696E2D77696474683A2032323070783B5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E73617475726174696F6E2D626F78207B';
wwv_flow_imp.g_varchar2_table(1451) := '5C6E5C746865696768743A2031353070783B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E73617475726174696F6E2D73656C656374696F6E207B5C6E5C7477696474683A20';
wwv_flow_imp.g_varchar2_table(1452) := '3970783B5C6E5C746865696768743A203970783B5C6E5C746D617267696E3A202D35707820302030202D3570783B5C6E5C74626F726465723A2031707820736F6C696420726762283235352C203235352C20323535293B5C6E5C74626F726465722D7261';
wwv_flow_imp.g_varchar2_table(1453) := '646975733A20313030253B5C6E5C74626F782D736861646F773A203070782030707820327078207267626128302C20302C20302C20302E38293B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E636F6C6F727069636B6572';
wwv_flow_imp.g_varchar2_table(1454) := '2D626F6479202E7374726970207B5C6E5C7477696474683A20323570783B5C6E5C746865696768743A2031353070783B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E7374616E64616C6F6E652D7374726970207B5C6E5C7477696474';
wwv_flow_imp.g_varchar2_table(1455) := '683A20323570783B5C6E5C746865696768743A2031323270783B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E6875652D7374726970207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746D617267696E2D6C6566';
wwv_flow_imp.g_varchar2_table(1456) := '743A203870783B5C6E5C74637572736F723A20677261623B5C6E5C746261636B67726F756E643A206C696E6561722D6772616469656E7428746F20626F74746F6D2C20236666303030302030252C2023666666663030203137252C202330306666303020';
wwv_flow_imp.g_varchar2_table(1457) := '3333252C2023303066666666203530252C2023303030306666203637252C2023666630306666203833252C20236666303030302031303025293B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E6F7061636974792D7374726970207B5C';
wwv_flow_imp.g_varchar2_table(1458) := '6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746D617267696E2D6C6566743A203870783B5C6E5C74637572736F723A20677261623B5C6E5C746261636B67726F756E643A2075726C28247B687D293B5C6E5C746261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1459) := '2D73697A653A20397078203970783B5C6E5C74696D6167652D72656E646572696E673A20706978656C617465643B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E73747269702E6772616262696E67207B5C6E5C74637572736F723A20';
wwv_flow_imp.g_varchar2_table(1460) := '6772616262696E673B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E736C69646572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A202D3270783B5C6E5C7477696474';
wwv_flow_imp.g_varchar2_table(1461) := '683A2063616C632831303025202B20347078293B5C6E5C746865696768743A203470783B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C69642072676261283235352C203235352C20';
wwv_flow_imp.g_varchar2_table(1462) := '3235352C20302E3731293B5C6E5C74626F782D736861646F773A203070782030707820317078207267626128302C20302C20302C20302E3835293B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E7374726970202E6F7665726C617920';
wwv_flow_imp.g_varchar2_table(1463) := '7B5C6E5C746865696768743A2031353070783B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E7374616E64616C6F6E652D7374726970202E7374616E64616C6F6E652D6F';
wwv_flow_imp.g_varchar2_table(1464) := '7665726C6179207B5C6E5C746865696768743A2031323270783B5C6E5C74706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E5C6E2E7374616E64616C6F6E652D636F6C6F727069636B65722D626F6479207B5C6E5C74646973706C61793A';
wwv_flow_imp.g_varchar2_table(1465) := '20626C6F636B3B5C6E5C74626F726465723A2031707820736F6C6964207472616E73706172656E743B5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F766572576964676574';
wwv_flow_imp.g_varchar2_table(1466) := '2D626F72646572293B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E696E736572742D627574746F6E207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746865';
wwv_flow_imp.g_varchar2_table(1467) := '696768743A20323070783B5C6E5C7477696474683A20353870783B5C6E5C7470616464696E673A203070783B5C6E5C7472696768743A203870783B5C6E5C74626F74746F6D3A203870783B5C6E5C746261636B67726F756E643A20766172282D2D767363';
wwv_flow_imp.g_varchar2_table(1468) := '6F64652D627574746F6E2D6261636B67726F756E64293B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D666F726567726F756E64293B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C74626F726465723A';
wwv_flow_imp.g_varchar2_table(1469) := '206E6F6E653B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E636F6C6F727069636B65722D626F6479202E696E736572742D627574746F6E3A686F7665727B5C6E5C746261636B67726F756E643A20766172282D2D7673636F6465';
wwv_flow_imp.g_varchar2_table(1470) := '2D627574746F6E2D686F7665724261636B67726F756E64293B5C6E7D5C6E602C22225D293B636F6E737420753D647D2C383335373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E';
wwv_flow_imp.g_varchar2_table(1471) := '2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1472) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269';
wwv_flow_imp.g_varchar2_table(1473) := '676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520';
wwv_flow_imp.g_varchar2_table(1474) := '696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1475) := '2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F722E7673202E646E642D7461726765742C5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E646E642D746172676574207B5C6E5C74626F726465722D72696768743A';
wwv_flow_imp.g_varchar2_table(1476) := '2032707820646F7474656420626C61636B3B5C6E5C74636F6C6F723A2077686974653B202F2A206F70706F73697465206F6620626C61636B202A2F5C6E7D5C6E2E6D6F6E61636F2D656469746F722E76732D6461726B202E646E642D746172676574207B';
wwv_flow_imp.g_varchar2_table(1477) := '5C6E5C74626F726465722D72696768743A2032707820646F7474656420234145414641443B5C6E5C74636F6C6F723A20233531353034663B202F2A206F70706F73697465206F662023414541464144202A2F5C6E7D5C6E2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1478) := '722E68632D626C61636B202E646E642D746172676574207B5C6E5C74626F726465722D72696768743A2032707820646F7474656420236666663B5C6E5C74636F6C6F723A20233030303B202F2A206F70706F73697465206F662023666666202A2F5C6E7D';
wwv_flow_imp.g_varchar2_table(1479) := '5C6E5C6E2E6D6F6E61636F2D656469746F722E6D6F7573652D64656661756C74202E766965772D6C696E65732C5C6E2E6D6F6E61636F2D656469746F722E76732D6461726B2E6D61632E6D6F7573652D64656661756C74202E766965772D6C696E65732C';
wwv_flow_imp.g_varchar2_table(1480) := '5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B2E6D61632E6D6F7573652D64656661756C74202E766965772D6C696E65732C5C6E2E6D6F6E61636F2D656469746F722E68632D6C696768742E6D61632E6D6F7573652D64656661756C7420';
wwv_flow_imp.g_varchar2_table(1481) := '2E766965772D6C696E6573207B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E6D6F7573652D636F7079202E766965772D6C696E65732C5C6E2E6D6F6E61636F2D656469746F722E76732D6461726B';
wwv_flow_imp.g_varchar2_table(1482) := '2E6D61632E6D6F7573652D636F7079202E766965772D6C696E65732C5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B2E6D61632E6D6F7573652D636F7079202E766965772D6C696E65732C5C6E2E6D6F6E61636F2D656469746F722E6863';
wwv_flow_imp.g_varchar2_table(1483) := '2D6C696768742E6D61632E6D6F7573652D636F7079202E766965772D6C696E6573207B5C6E5C74637572736F723A20636F70793B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C393932363A28652C742C6E293D3E7B22757365207374726963';
wwv_flow_imp.g_varchar2_table(1484) := '74223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1485) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D69';
wwv_flow_imp.g_varchar2_table(1486) := '63726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468';
wwv_flow_imp.g_varchar2_table(1487) := '652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1488) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E706F73742D656469742D776964676574207B5C6E5C74626F782D736861646F773A20302030203870782032707820766172282D2D7673636F6465';
wwv_flow_imp.g_varchar2_table(1489) := '2D7769646765742D736861646F77293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D7769646765742D626F726465722C207472616E73706172656E74293B5C6E5C74626F726465722D7261646975733A203470';
wwv_flow_imp.g_varchar2_table(1490) := '783B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D6261636B67726F756E64293B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E706F73742D65646974';
wwv_flow_imp.g_varchar2_table(1491) := '2D776964676574202E6D6F6E61636F2D627574746F6E207B5C6E5C7470616464696E673A203270783B5C6E5C74626F726465723A206E6F6E653B5C6E5C74626F726465722D7261646975733A20303B5C6E7D5C6E5C6E2E706F73742D656469742D776964';
wwv_flow_imp.g_varchar2_table(1492) := '676574202E6D6F6E61636F2D627574746F6E3A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D627574746F6E2D7365636F6E64617279486F7665724261636B67726F756E64292021696D706F72';
wwv_flow_imp.g_varchar2_table(1493) := '74616E743B5C6E7D5C6E5C6E2E706F73742D656469742D776964676574202E6D6F6E61636F2D627574746F6E202E636F6469636F6E207B5C6E5C746D617267696E3A20303B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C353636393A28652C';
wwv_flow_imp.g_varchar2_table(1494) := '742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C22';
wwv_flow_imp.g_varchar2_table(1495) := '2F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A20';
wwv_flow_imp.g_varchar2_table(1496) := '20436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E2053656520';
wwv_flow_imp.g_varchar2_table(1497) := '4C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1498) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E644F7074696F6E73576964676574207B5C6E5C74626163';
wwv_flow_imp.g_varchar2_table(1499) := '6B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D6261636B67726F756E64293B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D666F726567726F756E64';
wwv_flow_imp.g_varchar2_table(1500) := '293B5C6E5C74626F782D736861646F773A20302030203870782032707820766172282D2D7673636F64652D7769646765742D736861646F77293B5C6E5C74626F726465723A2032707820736F6C696420766172282D2D7673636F64652D636F6E74726173';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '74426F72646572293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C353339353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C';
wwv_flow_imp.g_varchar2_table(1502) := '733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1503) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E';
wwv_flow_imp.g_varchar2_table(1504) := '202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A';
wwv_flow_imp.g_varchar2_table(1505) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(1506) := '2046696E6420776964676574202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747A2D696E6465783A2033353B5C6E5C746865696768743A20333370';
wwv_flow_imp.g_varchar2_table(1507) := '783B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C746C696E652D6865696768743A20313970783B5C6E5C747472616E736974696F6E3A207472616E73666F726D203230306D73206C696E6561723B5C6E5C7470616464696E673A20302034';
wwv_flow_imp.g_varchar2_table(1508) := '70783B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C747472616E73666F726D3A207472616E736C617465592863616C63282D31303025202D203130707829293B202F2A20736861646F7720283130707829202A2F5C6E5C74';
wwv_flow_imp.g_varchar2_table(1509) := '626F782D736861646F773A20302030203870782032707820766172282D2D7673636F64652D7769646765742D736861646F77293B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D666F726567726F756E6429';
wwv_flow_imp.g_varchar2_table(1510) := '3B5C6E5C74626F726465722D6C6566743A2031707820736F6C696420766172282D2D7673636F64652D7769646765742D626F72646572293B5C6E5C74626F726465722D72696768743A2031707820736F6C696420766172282D2D7673636F64652D776964';
wwv_flow_imp.g_varchar2_table(1511) := '6765742D626F72646572293B5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673636F64652D7769646765742D626F72646572293B5C6E5C74626F726465722D626F74746F6D2D6C6566742D7261646975733A20';
wwv_flow_imp.g_varchar2_table(1512) := '3470783B5C6E5C74626F726465722D626F74746F6D2D72696768742D7261646975733A203470783B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D6261636B67726F756E64293B';
wwv_flow_imp.g_varchar2_table(1513) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E63682E7265647563652D6D6F74696F6E202E6D6F6E61636F2D656469746F72202E66696E642D776964676574207B5C6E5C747472616E736974696F6E3A207472616E73666F726D20306D73206C69';
wwv_flow_imp.g_varchar2_table(1514) := '6E6561723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574207465787461726561207B5C6E5C746D617267696E3A203070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574';
wwv_flow_imp.g_varchar2_table(1515) := '2E68696464656E456469746F72207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2F2A2046696E6420776964676574207768656E207265706C61636520697320746F67676C6564206F6E202A2F5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1516) := '202E66696E642D7769646765742E7265706C616365546F67676C6564203E202E7265706C6163652D70617274207B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E76';
wwv_flow_imp.g_varchar2_table(1517) := '697369626C6520207B5C6E5C747472616E73666F726D3A207472616E736C617465592830293B5C6E7D5C6E5C6E2F2A2054686973206F75746C696E652D636F6C6F722072756C65206973207573656420746F206F7665727269646520746865206F75746C';
wwv_flow_imp.g_varchar2_table(1518) := '696E6520636F6C6F7220666F722073796E7468657469632D666F6375732066696E6420696E7075742E202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D6F6E61636F2D696E707574626F782E73796E746865746963';
wwv_flow_imp.g_varchar2_table(1519) := '2D666F637573207B5C6E5C746F75746C696E653A2031707820736F6C6964202D7765626B69742D666F6375732D72696E672D636F6C6F723B5C6E5C746F75746C696E652D6F66667365743A202D3170783B5C6E5C746F75746C696E652D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1520) := '766172282D2D7673636F64652D666F637573426F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D6F6E61636F2D696E707574626F78202E696E707574207B5C6E5C746261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(1521) := '2D636F6C6F723A207472616E73706172656E743B5C6E5C746D696E2D6865696768743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D6F6E61636F2D66696E64496E707574202E696E707574207B5C';
wwv_flow_imp.g_varchar2_table(1522) := '6E5C74666F6E742D73697A653A20313370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E66696E642D706172742C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E';
wwv_flow_imp.g_varchar2_table(1523) := '7265706C6163652D70617274207B5C6E5C746D617267696E3A203370782032357078203020313770783B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1524) := '72202E66696E642D776964676574203E202E66696E642D70617274202E6D6F6E61636F2D696E707574626F782C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E7265706C6163652D70617274202E6D6F6E61636F2D69';
wwv_flow_imp.g_varchar2_table(1525) := '6E707574626F78207B5C6E5C746D696E2D6865696768743A20323570783B5C6E7D5C6E5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E7265706C6163652D70617274202E6D6F6E61636F2D696E707574626F7820';
wwv_flow_imp.g_varchar2_table(1526) := '3E202E696277726170706572203E202E6D6972726F72207B5C6E5C7470616464696E672D72696768743A20323270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E66696E642D70617274202E6D6F6E';
wwv_flow_imp.g_varchar2_table(1527) := '61636F2D696E707574626F78203E202E696277726170706572203E202E696E7075742C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E66696E642D70617274202E6D6F6E61636F2D696E707574626F78203E202E6962';
wwv_flow_imp.g_varchar2_table(1528) := '77726170706572203E202E6D6972726F722C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E7265706C6163652D70617274202E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E696E70';
wwv_flow_imp.g_varchar2_table(1529) := '75742C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E7265706C6163652D70617274202E6D6F6E61636F2D696E707574626F78203E202E696277726170706572203E202E6D6972726F72207B5C6E5C7470616464696E';
wwv_flow_imp.g_varchar2_table(1530) := '672D746F703A203270783B5C6E5C7470616464696E672D626F74746F6D3A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E66696E642D70617274202E66696E642D616374696F6E73207B5C6E';
wwv_flow_imp.g_varchar2_table(1531) := '5C746865696768743A20323570783B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E7265706C61';
wwv_flow_imp.g_varchar2_table(1532) := '63652D70617274202E7265706C6163652D616374696F6E73207B5C6E5C746865696768743A20323570783B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(1533) := '656469746F72202E66696E642D776964676574202E6D6F6E61636F2D66696E64496E707574207B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65783A313B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1534) := '5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D6F6E61636F2D66696E64496E707574202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74207B5C6E5C742F2A204D616B6520737572652074657874617265';
wwv_flow_imp.g_varchar2_table(1535) := '6120696E6865726974732074686520776964746820636F72726563746C79202A2F5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D6F6E61636F2D66696E64496E7075';
wwv_flow_imp.g_varchar2_table(1536) := '74202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E7363726F6C6C6261722E766572746963616C207B5C6E5C742F2A204869646520766572746963616C207363726F6C6C626172202A2F5C6E5C746F7061636974793A20303B5C6E';
wwv_flow_imp.g_varchar2_table(1537) := '7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D617463686573436F756E74207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65783A20696E697469616C3B5C6E5C746D617267696E3A2030203020';
wwv_flow_imp.g_varchar2_table(1538) := '30203370783B5C6E5C7470616464696E673A2032707820302030203270783B5C6E5C746865696768743A20323570783B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E5C74626F782D73697A696E673A20626F726465722D626F';
wwv_flow_imp.g_varchar2_table(1539) := '783B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C746C696E652D6865696768743A20323370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E627574746F6E207B5C6E5C747769647468';
wwv_flow_imp.g_varchar2_table(1540) := '3A20313670783B5C6E5C746865696768743A20313670783B5C6E5C7470616464696E673A203370783B5C6E5C74626F726465722D7261646975733A203570783B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65783A20696E697469616C3B';
wwv_flow_imp.g_varchar2_table(1541) := '5C6E5C746D617267696E2D6C6566743A203370783B5C6E5C746261636B67726F756E642D706F736974696F6E3A2063656E7465722063656E7465723B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C74637572';
wwv_flow_imp.g_varchar2_table(1542) := '736F723A20706F696E7465723B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E7D5C6E5C6E2F2A2066696E6420696E';
wwv_flow_imp.g_varchar2_table(1543) := '2073656C656374696F6E20627574746F6E202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E636F6469636F6E2D66696E642D73656C656374696F6E207B5C6E5C7477696474683A20323270783B5C6E5C746865696768';
wwv_flow_imp.g_varchar2_table(1544) := '743A20323270783B5C6E5C7470616464696E673A203370783B5C6E5C74626F726465722D7261646975733A203570783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E627574746F6E2E6C656674207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1545) := '746D617267696E2D6C6566743A20303B5C6E5C746D617267696E2D72696768743A203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E627574746F6E2E77696465207B5C6E5C7477696474683A206175';
wwv_flow_imp.g_varchar2_table(1546) := '746F3B5C6E5C7470616464696E673A20317078203670783B5C6E5C74746F703A202D3170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E627574746F6E2E746F67676C65207B5C6E5C74706F736974696F';
wwv_flow_imp.g_varchar2_table(1547) := '6E3A206162736F6C7574653B5C6E5C74746F703A20303B5C6E5C746C6566743A203370783B5C6E5C7477696474683A20313870783B5C6E5C746865696768743A20313030253B5C6E5C74626F726465722D7261646975733A20303B5C6E5C74626F782D73';
wwv_flow_imp.g_varchar2_table(1548) := '697A696E673A20626F726465722D626F783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E627574746F6E2E746F67676C652E64697361626C6564207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1549) := '6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E64697361626C6564207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D64697361626C6564466F726567726F756E64293B5C6E5C74637572736F723A206465';
wwv_flow_imp.g_varchar2_table(1550) := '6661756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E202E7265706C6163652D70617274207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66';
wwv_flow_imp.g_varchar2_table(1551) := '696E642D776964676574203E202E7265706C6163652D70617274203E202E6D6F6E61636F2D66696E64496E707574207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C74646973706C61793A20666C65783B5C6E5C7476657274696361';
wwv_flow_imp.g_varchar2_table(1552) := '6C2D616C69676E3A206D6964646C653B5C6E5C74666C65783A206175746F3B5C6E5C74666C65782D67726F773A20303B5C6E5C74666C65782D736872696E6B3A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765';
wwv_flow_imp.g_varchar2_table(1553) := '74203E202E7265706C6163652D70617274203E202E6D6F6E61636F2D66696E64496E707574203E202E636F6E74726F6C73207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A203370783B5C6E5C7472696768743A203270';
wwv_flow_imp.g_varchar2_table(1554) := '783B5C6E7D5C6E5C6E2F2A2052454455434544202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E726564756365642D66696E642D776964676574202E6D617463686573436F756E74207B5C6E5C74646973706C61793A6E';
wwv_flow_imp.g_varchar2_table(1555) := '6F6E653B5C6E7D5C6E5C6E2F2A204E4152524F572028534D414C4C4552205448414E205245445543454429202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E6E6172726F772D66696E642D776964676574207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1556) := '6D61782D77696474683A2032353770782021696D706F7274616E743B5C6E7D5C6E5C6E2F2A20434F4C4C41505345442028534D414C4C4552205448414E204E4152524F5729202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765';
wwv_flow_imp.g_varchar2_table(1557) := '742E636F6C6C61707365642D66696E642D776964676574207B5C6E5C746D61782D77696474683A2031373070782021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(1558) := '642D66696E642D776964676574202E627574746F6E2E70726576696F75732C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E636F6C6C61707365642D66696E642D776964676574202E627574746F6E2E6E6578742C5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1559) := '6F6E61636F2D656469746F72202E66696E642D7769646765742E636F6C6C61707365642D66696E642D776964676574202E627574746F6E2E7265706C6163652C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E636F6C6C6170';
wwv_flow_imp.g_varchar2_table(1560) := '7365642D66696E642D776964676574202E627574746F6E2E7265706C6163652D616C6C2C5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E636F6C6C61707365642D66696E642D776964676574203E202E66696E642D70617274';
wwv_flow_imp.g_varchar2_table(1561) := '202E6D6F6E61636F2D66696E64496E707574202E636F6E74726F6C73207B5C6E5C74646973706C61793A6E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D7769646765742E6E6F2D726573756C7473202E6D6174636865';
wwv_flow_imp.g_varchar2_table(1562) := '73436F756E74207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D6572726F72466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E644D61746368207B5C6E5C74616E696D6174696F6E2D647572';
wwv_flow_imp.g_varchar2_table(1563) := '6174696F6E3A20303B5C6E5C74616E696D6174696F6E2D6E616D653A20696E68657269742021696D706F7274616E743B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D66696E644D6174636848';
wwv_flow_imp.g_varchar2_table(1564) := '6967686C696768744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E63757272656E7446696E644D61746368207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D65646974';
wwv_flow_imp.g_varchar2_table(1565) := '6F722D66696E644D617463684261636B67726F756E64293B5C6E5C74626F726465723A2032707820736F6C696420766172282D2D7673636F64652D656469746F722D66696E644D61746368426F72646572293B5C6E5C7470616464696E673A203170783B';
wwv_flow_imp.g_varchar2_table(1566) := '5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E6453636F7065207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D65646974';
wwv_flow_imp.g_varchar2_table(1567) := '6F722D66696E6452616E6765486967686C696768744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E6D6F6E61636F2D73617368207B5C6E5C746C6566743A20302021696D706F72';
wwv_flow_imp.g_varchar2_table(1568) := '74616E743B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D726573697A65426F726465722C20766172282D2D7673636F64652D656469746F725769646765742D626F7264657229';
wwv_flow_imp.g_varchar2_table(1569) := '293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E66696E642D776964676574202E627574746F6E3A6265666F7265207B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C74746F703A203170783B5C6E';
wwv_flow_imp.g_varchar2_table(1570) := '5C746C6566743A203270783B5C6E7D5C6E5C6E2F2A20416374696F6E2062617273202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574202E627574746F6E3A6E6F74282E64697361626C6564293A686F7665722C5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1571) := '6E61636F2D656469746F72202E66696E642D776964676574202E636F6469636F6E2D66696E642D73656C656374696F6E3A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D746F6F6C6261722D68';
wwv_flow_imp.g_varchar2_table(1572) := '6F7665724261636B67726F756E64292021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E66696E644D61746368207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F';
wwv_flow_imp.g_varchar2_table(1573) := '722D66696E644D61746368486967686C696768744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E63757272656E7446696E644D61746368207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(1574) := '7673636F64652D656469746F722D66696E644D617463684261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E66696E6453636F7065207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(1575) := '64652D656469746F722D66696E6452616E6765486967686C696768744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E66696E644D61746368207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(1576) := '2D7673636F64652D656469746F725769646765742D6261636B67726F756E64293B5C6E7D5C6E5C6E2F2A20436C6F736520627574746F6E20706F736974696F6E2E202A2F5C6E2E6D6F6E61636F2D656469746F72202E66696E642D776964676574203E20';
wwv_flow_imp.g_varchar2_table(1577) := '2E627574746F6E2E636F6469636F6E2D7769646765742D636C6F7365207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74746F703A203570783B5C6E5C7472696768743A203470783B5C6E7D5C6E222C22225D293B636F6E73742061';
wwv_flow_imp.g_varchar2_table(1578) := '3D727D2C353430353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E';
wwv_flow_imp.g_varchar2_table(1579) := '70757368285B652E69642C272F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1580) := '2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C';
wwv_flow_imp.g_varchar2_table(1581) := '6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1582) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F766572';
wwv_flow_imp.g_varchar2_table(1583) := '6C617973202E636F6469636F6E2D666F6C64696E672D6D616E75616C2D636F6C6C61707365642C5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E636F6469636F6E2D666F6C64696E672D6D616E7561';
wwv_flow_imp.g_varchar2_table(1584) := '6C2D657870616E6465642C5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E636F6469636F6E2D666F6C64696E672D657870616E6465642C5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E';
wwv_flow_imp.g_varchar2_table(1585) := '2D766965772D6F7665726C617973202E636F6469636F6E2D666F6C64696E672D636F6C6C6170736564207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C746F7061636974793A20303B5C6E5C747472616E736974696F6E3A206F7061636974';
wwv_flow_imp.g_varchar2_table(1586) := '7920302E35733B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74666F6E742D73697A653A20313430253B5C6E5C';
wwv_flow_imp.g_varchar2_table(1587) := '746D617267696E2D6C6566743A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D776F726B62656E63682E7265647563652D6D6F74696F6E202E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E636F646963';
wwv_flow_imp.g_varchar2_table(1588) := '6F6E2D666F6C64696E672D6D616E75616C2D636F6C6C61707365642C5C6E2E6D6F6E61636F2D776F726B62656E63682E7265647563652D6D6F74696F6E202E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E';
wwv_flow_imp.g_varchar2_table(1589) := '636F6469636F6E2D666F6C64696E672D6D616E75616C2D657870616E6465642C5C6E2E6D6F6E61636F2D776F726B62656E63682E7265647563652D6D6F74696F6E202E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C61';
wwv_flow_imp.g_varchar2_table(1590) := '7973202E636F6469636F6E2D666F6C64696E672D657870616E6465642C5C6E2E6D6F6E61636F2D776F726B62656E63682E7265647563652D6D6F74696F6E202E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C61797320';
wwv_flow_imp.g_varchar2_table(1591) := '2E636F6469636F6E2D666F6C64696E672D636F6C6C6170736564207B5C6E5C747472616E736974696F6E3A20696E697469616C3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C6179733A686F7665';
wwv_flow_imp.g_varchar2_table(1592) := '72202E636F6469636F6E2C5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E636F6469636F6E2E636F6469636F6E2D666F6C64696E672D636F6C6C61707365642C5C6E2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1593) := '72202E6D617267696E2D766965772D6F7665726C617973202E636F6469636F6E2E636F6469636F6E2D666F6C64696E672D6D616E75616C2D636F6C6C61707365642C5C6E2E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F766572';
wwv_flow_imp.g_varchar2_table(1594) := '6C617973202E636F6469636F6E2E616C7761797353686F77466F6C6449636F6E73207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D666F6C6465643A6166746572207B5C6E5C74636F';
wwv_flow_imp.g_varchar2_table(1595) := '6C6F723A20677265793B5C6E5C746D617267696E3A20302E31656D20302E32656D203020302E32656D3B5C6E5C74636F6E74656E743A20225C5C32324546223B202F2A20656C6C697073657320756E69636F646520636861726163746572202A2F5C6E5C';
wwv_flow_imp.g_varchar2_table(1596) := '74646973706C61793A20696E6C696E653B5C6E5C746C696E652D6865696768743A2031656D3B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E666F6C6465642D6261636B67726F756E64207B';
wwv_flow_imp.g_varchar2_table(1597) := '5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D666F6C644261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E636C64722E636F6469636F6E2E636F6469636F';
wwv_flow_imp.g_varchar2_table(1598) := '6E2D666F6C64696E672D657870616E6465642C5C6E2E6D6F6E61636F2D656469746F72202E636C64722E636F6469636F6E2E636F6469636F6E2D666F6C64696E672D636F6C6C61707365642C5C6E2E6D6F6E61636F2D656469746F72202E636C64722E63';
wwv_flow_imp.g_varchar2_table(1599) := '6F6469636F6E2E636F6469636F6E2D666F6C64696E672D6D616E75616C2D657870616E6465642C5C6E2E6D6F6E61636F2D656469746F72202E636C64722E636F6469636F6E2E636F6469636F6E2D666F6C64696E672D6D616E75616C2D636F6C6C617073';
wwv_flow_imp.g_varchar2_table(1600) := '6564207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724775747465722D666F6C64696E67436F6E74726F6C466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E5C6E272C22225D293B636F6E737420613D';
wwv_flow_imp.g_varchar2_table(1601) := '727D2C313738383A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70';
wwv_flow_imp.g_varchar2_table(1602) := '757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1603) := '2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C69';
wwv_flow_imp.g_varchar2_table(1604) := '63656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1605) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A206D61726B6572207A6F6E65202A2F5C6E5C6E2E6D6F6E61636F2D6564';
wwv_flow_imp.g_varchar2_table(1606) := '69746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D7469746C65202E73657665726974792D69636F6E207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74766572746963616C2D61';
wwv_flow_imp.g_varchar2_table(1607) := '6C69676E3A20746578742D746F703B5C6E5C746D617267696E2D72696768743A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574207B5C6E5C74746578742D6F766572666C6F773A20656C6C697073';
wwv_flow_imp.g_varchar2_table(1608) := '69733B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574203E202E7374616C65207B5C6E5C746F7061636974793A20302E363B5C6E5C74666F6E742D';
wwv_flow_imp.g_varchar2_table(1609) := '7374796C653A206974616C69633B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E7469746C65207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C7470616464696E672D726967';
wwv_flow_imp.g_varchar2_table(1610) := '68743A203570783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747768697465';
wwv_flow_imp.g_varchar2_table(1611) := '2D73706163653A207072653B5C6E5C74757365722D73656C6563743A20746578743B5C6E5C742D7765626B69742D757365722D73656C6563743A20746578743B5C6E5C7470616464696E673A203870782031327078203020323070783B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1612) := '2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D657373616765207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20';
wwv_flow_imp.g_varchar2_table(1613) := '636F6C756D6E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D657373616765202E64657461696C73207B5C6E5C7470616464696E672D6C6566';
wwv_flow_imp.g_varchar2_table(1614) := '743A203670783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D657373616765202E736F757263652C5C6E2E6D6F6E61636F2D656469746F7220';
wwv_flow_imp.g_varchar2_table(1615) := '2E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D657373616765207370616E2E636F6465207B5C6E5C746F7061636974793A20302E363B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6172';
wwv_flow_imp.g_varchar2_table(1616) := '6B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D65737361676520612E636F64652D6C696E6B207B5C6E5C746F7061636974793A20302E363B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1617) := '6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D65737361676520612E636F64652D6C696E6B3A6265666F7265207B5C6E5C74636F6E74656E743A202728273B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1618) := '6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D65737361676520612E636F64652D6C696E6B3A6166746572207B5C6E5C74636F6E74656E743A202729273B';
wwv_flow_imp.g_varchar2_table(1619) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E6D65737361676520612E636F64652D6C696E6B203E207370616E207B5C6E5C74746578742D646563';
wwv_flow_imp.g_varchar2_table(1620) := '6F726174696F6E3A20756E6465726C696E653B5C6E5C742F2A2A204861636B20746F20666F72636520756E6465726C696E6520746F2073686F77202A2A2F5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C6964207472616E7370617265';
wwv_flow_imp.g_varchar2_table(1621) := '6E743B5C6E5C74746578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(1622) := '61636F2D656469746F72202E6D61726B65722D776964676574202E6465736372697074696F6E636F6E7461696E6572202E66696C656E616D65207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74636F6C6F723A20766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(1623) := '64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313530333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B7661';
wwv_flow_imp.g_varchar2_table(1624) := '7220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1625) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E2041';
wwv_flow_imp.g_varchar2_table(1626) := '6C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963';
wwv_flow_imp.g_varchar2_table(1627) := '656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1628) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E676F746F2D646566696E6974696F6E2D6C696E6B207B5C6E5C74746578742D6465636F726174696F6E3A20756E6465726C696E653B5C6E5C74637572736F723A20';
wwv_flow_imp.g_varchar2_table(1629) := '706F696E7465723B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E6B2D616374697665466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C363337383A';
wwv_flow_imp.g_varchar2_table(1630) := '28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69';
wwv_flow_imp.g_varchar2_table(1631) := '642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E';
wwv_flow_imp.g_varchar2_table(1632) := '202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E2053';
wwv_flow_imp.g_varchar2_table(1633) := '6565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1634) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A202D2D207A6F6E6520776964676574202A2F5C6E2E6D6F6E61636F2D656469746F72202E7A';
wwv_flow_imp.g_varchar2_table(1635) := '6F6E652D776964676574202E7A6F6E652D7769646765742D636F6E7461696E65722E7265666572656E63652D7A6F6E652D776964676574207B5C6E5C74626F726465722D746F702D77696474683A203170783B5C6E5C74626F726465722D626F74746F6D';
wwv_flow_imp.g_varchar2_table(1636) := '2D77696474683A203170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E696E6C696E65207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C7476657274';
wwv_flow_imp.g_varchar2_table(1637) := '6963616C2D616C69676E3A20746F703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E6D65737361676573207B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A20';
wwv_flow_imp.g_varchar2_table(1638) := '313030253B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C7470616464696E673A2033656D20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E7265662D747265';
wwv_flow_imp.g_varchar2_table(1639) := '65207B5C6E5C746C696E652D6865696768743A20323370783B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D7065656B56696577526573756C742D6261636B67726F756E64293B5C6E5C74636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(1640) := '72282D2D7673636F64652D7065656B56696577526573756C742D6C696E65466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E7265';
wwv_flow_imp.g_varchar2_table(1641) := '666572656E6365207B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D77696467';
wwv_flow_imp.g_varchar2_table(1642) := '6574202E7265662D74726565202E7265666572656E63652D66696C65207B5C6E5C74646973706C61793A20696E6C696E652D666C65783B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C74636F6C6F723A2076';
wwv_flow_imp.g_varchar2_table(1643) := '6172282D2D7673636F64652D7065656B56696577526573756C742D66696C65466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E6D';
wwv_flow_imp.g_varchar2_table(1644) := '6F6E61636F2D6C6973743A666F637573202E73656C6563746564202E7265666572656E63652D66696C65207B5C6E5C74636F6C6F723A20696E68657269742021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E726566';
wwv_flow_imp.g_varchar2_table(1645) := '6572656E63652D7A6F6E652D776964676574202E7265662D74726565202E6D6F6E61636F2D6C6973743A666F637573202E6D6F6E61636F2D6C6973742D726F7773203E202E6D6F6E61636F2D6C6973742D726F772E73656C65637465643A6E6F74282E68';
wwv_flow_imp.g_varchar2_table(1646) := '6967686C69676874656429207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D7065656B56696577526573756C742D73656C656374696F6E4261636B67726F756E64293B5C6E5C74636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(1647) := '2D7673636F64652D7065656B56696577526573756C742D73656C656374696F6E466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D77696467657420';
wwv_flow_imp.g_varchar2_table(1648) := '2E7265662D74726565202E7265666572656E63652D66696C65202E636F756E74207B5C6E5C746D617267696E2D72696768743A20313270783B5C6E5C746D617267696E2D6C6566743A206175746F3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1649) := '202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E7265666572656E63654D61746368202E686967686C69676874207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D706565';
wwv_flow_imp.g_varchar2_table(1650) := '6B56696577526573756C742D6D61746368486967686C696768744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E70726576696577202E7265666572656E';
wwv_flow_imp.g_varchar2_table(1651) := '63652D6465636F726174696F6E207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D7065656B56696577456469746F722D6D61746368486967686C696768744261636B67726F756E64293B5C6E5C74626F726465';
wwv_flow_imp.g_varchar2_table(1652) := '723A2032707820736F6C696420766172282D2D7673636F64652D7065656B56696577456469746F722D6D61746368486967686C69676874426F72646572293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1653) := '6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E70726576696577202E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6261636B67726F756E642C5C6E2E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1654) := '72202E7265666572656E63652D7A6F6E652D776964676574202E70726576696577202E6D6F6E61636F2D656469746F72202E696E707574617265612E696D652D696E707574207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D76';
wwv_flow_imp.g_varchar2_table(1655) := '73636F64652D7065656B56696577456469746F722D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7265666572656E63652D7A6F6E652D776964676574202E70726576696577202E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(1656) := '72202E6D617267696E207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D7065656B56696577456469746F724775747465722D6261636B67726F756E64293B5C6E7D5C6E5C6E2F2A204869676820436F6E747261';
wwv_flow_imp.g_varchar2_table(1657) := '7374205468656D696E67202A2F5C6E5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E7265666572656E63652D66696C652C5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(1658) := '656469746F722E68632D6C69676874202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E7265666572656E63652D66696C65207B5C6E5C74666F6E742D7765696768743A20626F6C643B5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1659) := '636F2D656469746F722E68632D626C61636B202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E7265666572656E63654D61746368202E686967686C696768742C5C6E2E6D6F6E61636F2D656469746F722E68632D6C';
wwv_flow_imp.g_varchar2_table(1660) := '69676874202E7265666572656E63652D7A6F6E652D776964676574202E7265662D74726565202E7265666572656E63654D61746368202E686967686C69676874207B5C6E5C74626F726465723A2031707820646F7474656420766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(1661) := '652D636F6E7472617374416374697665426F726465722C207472616E73706172656E74293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C3234353A28652C742C6E293D3E';
wwv_flow_imp.g_varchar2_table(1662) := '7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1663) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F707972';
wwv_flow_imp.g_varchar2_table(1664) := '6967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73';
wwv_flow_imp.g_varchar2_table(1665) := '652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1666) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E686F766572486967686C69676874207B5C6E5C746261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(1667) := '6F6C6F723A20766172282D2D7673636F64652D656469746F722D686F766572486967686C696768744261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572207B5C6E5C74636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(1668) := '766172282D2D7673636F64652D656469746F72486F7665725769646765742D666F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B';
wwv_flow_imp.g_varchar2_table(1669) := '67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E5C74626F726465722D7261646975733A203370783B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(1670) := '6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F7665722061207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D';
wwv_flow_imp.g_varchar2_table(1671) := '6F6E61636F2D686F76657220613A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1672) := '6F2D686F766572202E686F7665722D726F77207B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572202E686F7665722D726F77202E686F7665722D726F772D636F6E74';
wwv_flow_imp.g_varchar2_table(1673) := '656E7473207B5C6E5C746D696E2D77696474683A303B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F76';
wwv_flow_imp.g_varchar2_table(1674) := '6572202E686F7665722D726F77202E766572626F736974792D616374696F6E73207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C7470616464696E672D6C6566743A20357078';
wwv_flow_imp.g_varchar2_table(1675) := '3B5C6E5C7470616464696E672D72696768743A203570783B5C6E5C746A7573746966792D636F6E74656E743A20656E643B5C6E5C74626F726465722D72696768743A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665';
wwv_flow_imp.g_varchar2_table(1676) := '725769646765742D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572202E686F7665722D726F77202E766572626F736974792D616374696F6E73202E636F6469636F6E207B5C6E5C7463757273';
wwv_flow_imp.g_varchar2_table(1677) := '6F723A20706F696E7465723B5C6E5C74666F6E742D73697A653A20313170783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572202E686F7665722D726F77202E766572626F736974792D616374696F6E73202E63';
wwv_flow_imp.g_varchar2_table(1678) := '6F6469636F6E2E656E61626C6564207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572202E686F';
wwv_flow_imp.g_varchar2_table(1679) := '7665722D726F77202E766572626F736974792D616374696F6E73202E636F6469636F6E2E64697361626C6564207B5C6E5C746F7061636974793A20302E363B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572202E';
wwv_flow_imp.g_varchar2_table(1680) := '686F7665722D726F77202E616374696F6E73207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D7374617475734261724261636B67726F756E64293B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(1681) := '6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F76657220636F6465207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D74657874436F6465426C6F636B2D6261636B67726F756E64293B5C6E7D';
wwv_flow_imp.g_varchar2_table(1682) := '5C6E5C6E5C6E222C22225D293B636F6E737420613D727D2C363433373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134';
wwv_flow_imp.g_varchar2_table(1683) := '292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1684) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C696365';
wwv_flow_imp.g_varchar2_table(1685) := '6E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1686) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(1687) := '656469746F722E7673202E76616C75655365745265706C6163656D656E74207B5C6E5C746F75746C696E653A20736F6C69642032707820766172282D2D7673636F64652D656469746F72427261636B65744D617463682D626F72646572293B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1688) := '222C22225D293B636F6E737420613D727D2C383136393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E';
wwv_flow_imp.g_varchar2_table(1689) := '6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1690) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E7365642075';
wwv_flow_imp.g_varchar2_table(1691) := '6E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1692) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E';
wwv_flow_imp.g_varchar2_table(1693) := '737567676573742D707265766965772D6164646974696F6E616C2D776964676574207B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D707265766965772D6164';
wwv_flow_imp.g_varchar2_table(1694) := '646974696F6E616C2D776964676574202E636F6E74656E742D737061636572207B5C6E5C74636F6C6F723A207472616E73706172656E743B5C6E5C7477686974652D73706163653A207072653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E';
wwv_flow_imp.g_varchar2_table(1695) := '737567676573742D707265766965772D6164646974696F6E616C2D776964676574202E627574746F6E207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74746578742D6465';
wwv_flow_imp.g_varchar2_table(1696) := '636F726174696F6E3A20756E6465726C696E653B5C6E5C74746578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E67686F73742D746578742D68696464656E207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1697) := '746F7061636974793A20303B5C6E5C74666F6E742D73697A653A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E67686F73742D746578742D6465636F726174696F6E2C202E6D6F6E61636F2D656469746F72202E737567676573742D70';
wwv_flow_imp.g_varchar2_table(1698) := '7265766965772D74657874202E67686F73742D74657874207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D636F6D706C6574696F6E2D746578742D746F2D726570';
wwv_flow_imp.g_varchar2_table(1699) := '6C616365207B5C6E5C74746578742D6465636F726174696F6E3A20756E6465726C696E653B5C6E5C74746578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E67686F7374';
wwv_flow_imp.g_varchar2_table(1700) := '2D746578742D6465636F726174696F6E2C5C6E2E6D6F6E61636F2D656469746F72202E67686F73742D746578742D6465636F726174696F6E2D707265766965772C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D707265766965772D74';
wwv_flow_imp.g_varchar2_table(1701) := '657874202E67686F73742D74657874207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F7247686F7374546578742D666F726567726F756E64292021696D706F7274616E743B5C6E5C746261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1702) := '3A20766172282D2D7673636F64652D656469746F7247686F7374546578742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F7247686F7374546578742D626F72646572';
wwv_flow_imp.g_varchar2_table(1703) := '293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C353431353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E28363331';
wwv_flow_imp.g_varchar2_table(1704) := '34292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1705) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963';
wwv_flow_imp.g_varchar2_table(1706) := '656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1707) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(1708) := '6469746F72202E696E6C696E6553756767657374696F6E7348696E74732E77697468426F72646572207B5C6E5C747A2D696E6465783A2033393B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D';
wwv_flow_imp.g_varchar2_table(1709) := '666F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C69642076';
wwv_flow_imp.g_varchar2_table(1710) := '6172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E6553756767657374696F6E7348696E74732061207B5C6E5C74636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(1711) := '72282D2D7673636F64652D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E6553756767657374696F6E7348696E747320613A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(1712) := '652D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E6553756767657374696F6E7348696E7473202E6B657962696E64696E67207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D61726769';
wwv_flow_imp.g_varchar2_table(1713) := '6E2D6C6566743A203470783B5C6E5C746F7061636974793A20302E363B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E6553756767657374696F6E7348696E7473202E6B657962696E64696E67202E6D6F6E61636F2D6B65796269';
wwv_flow_imp.g_varchar2_table(1714) := '6E64696E672D6B6579207B5C6E5C74666F6E742D73697A653A203870783B5C6E5C7470616464696E673A20327078203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E6553756767657374696F6E7348696E7473202E6176';
wwv_flow_imp.g_varchar2_table(1715) := '61696C61626C6553756767657374696F6E436F756E742061207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D696E2D77696474683A20313970783B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(1716) := '6D6F6E61636F2D656469746F72202E696E6C696E6553756767657374696F6E5374617475734261724974656D4C6162656C207B5C6E5C746D617267696E2D72696768743A203270783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C31393335';
wwv_flow_imp.g_varchar2_table(1717) := '3A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E';
wwv_flow_imp.g_varchar2_table(1718) := '69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C';
wwv_flow_imp.g_varchar2_table(1719) := '6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20';
wwv_flow_imp.g_varchar2_table(1720) := '536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1721) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D72656D6F7665207B5C6E';
wwv_flow_imp.g_varchar2_table(1722) := '5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F7247686F7374546578742D6261636B67726F756E64293B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E5C74746578742D6465636F726174';
wwv_flow_imp.g_varchar2_table(1723) := '696F6E3A206C696E652D7468726F7567683B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D72656D6F76652E6261636B67726F756E64436F6C6F72696E67207B5C6E5C746261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1724) := '3A20766172282D2D7673636F64652D64696666456469746F722D72656D6F7665644C696E654261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D68696464656E207B5C6E5C746F706163';
wwv_flow_imp.g_varchar2_table(1725) := '6974793A20303B5C6E5C74666F6E742D73697A653A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D6465636F726174696F6E2C202E6D6F6E61636F2D656469746F72202E737567676573742D7072657669';
wwv_flow_imp.g_varchar2_table(1726) := '65772D74657874202E696E6C696E652D65646974207B5C6E5C74666F6E742D7374796C653A206974616C69633B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D636F6D706C6574696F6E2D746578742D746F2D7265706C6163';
wwv_flow_imp.g_varchar2_table(1727) := '65207B5C6E5C74746578742D6465636F726174696F6E3A20756E6465726C696E653B5C6E5C74746578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D65';
wwv_flow_imp.g_varchar2_table(1728) := '6469742D6465636F726174696F6E2C5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D6465636F726174696F6E2D707265766965772C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D707265766965772D7465';
wwv_flow_imp.g_varchar2_table(1729) := '7874202E696E6C696E652D65646974207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F7247686F7374546578742D666F726567726F756E64292021696D706F7274616E743B5C6E5C746261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(1730) := '3A20766172282D2D7673636F64652D656469746F7247686F7374546578742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F7247686F7374546578742D626F72646572';
wwv_flow_imp.g_varchar2_table(1731) := '293B5C6E7D5C6E5C6E5C6E222C22225D293B636F6E737420613D727D2C353236393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E';
wwv_flow_imp.g_varchar2_table(1732) := '2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1733) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20';
wwv_flow_imp.g_varchar2_table(1734) := '204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D';
wwv_flow_imp.g_varchar2_table(1735) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1736) := '636F2D656469746F72202E696E6C696E654564697448696E74732E77697468426F72646572207B5C6E5C747A2D696E6465783A2033393B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D666F72';
wwv_flow_imp.g_varchar2_table(1737) := '6567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C69642076617228';
wwv_flow_imp.g_varchar2_table(1738) := '2D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E654564697448696E74732061207B5C6E5C74636F6C6F723A20766172282D2D7673636F6465';
wwv_flow_imp.g_varchar2_table(1739) := '2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E654564697448696E747320613A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D666F726567726F756E64293B5C6E7D';
wwv_flow_imp.g_varchar2_table(1740) := '5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E654564697448696E7473202E6B657962696E64696E67207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D617267696E2D6C6566743A203470783B5C6E5C746F7061636974793A';
wwv_flow_imp.g_varchar2_table(1741) := '20302E363B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E654564697448696E7473202E6B657962696E64696E67202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C74666F6E742D73697A653A203870783B5C';
wwv_flow_imp.g_varchar2_table(1742) := '6E5C7470616464696E673A20327078203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E65456469745374617475734261724974656D4C6162656C207B5C6E5C746D617267696E2D72696768743A203270783B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(1743) := '222C22225D293B636F6E737420613D727D2C383132393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E';
wwv_flow_imp.g_varchar2_table(1744) := '6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1745) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E7365642075';
wwv_flow_imp.g_varchar2_table(1746) := '6E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1747) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E696E6C696E652D656469746F722D70';
wwv_flow_imp.g_varchar2_table(1748) := '726F67726573732D6465636F726174696F6E207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C7477696474683A2031656D3B5C6E5C746865696768743A2031656D3B5C6E7D5C6E5C6E2E696E6C696E652D70726F6772657373';
wwv_flow_imp.g_varchar2_table(1749) := '2D77696467657420207B5C6E5C74646973706C61793A20666C65782021696D706F7274616E743B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E69';
wwv_flow_imp.g_varchar2_table(1750) := '6E6C696E652D70726F67726573732D776964676574202E69636F6E207B5C6E5C74666F6E742D73697A653A203830252021696D706F7274616E743B5C6E7D5C6E5C6E2E696E6C696E652D70726F67726573732D7769646765743A686F766572202E69636F';
wwv_flow_imp.g_varchar2_table(1751) := '6E207B5C6E5C74666F6E742D73697A653A203930252021696D706F7274616E743B5C6E5C74616E696D6174696F6E3A206E6F6E653B5C6E7D5C6E5C6E2E696E6C696E652D70726F67726573732D7769646765743A686F766572202E69636F6E3A3A626566';
wwv_flow_imp.g_varchar2_table(1752) := '6F7265207B5C6E5C74636F6E74656E743A20766172282D2D7673636F64652D69636F6E2D782D636F6E74656E74293B5C6E5C74666F6E742D66616D696C793A20766172282D2D7673636F64652D69636F6E2D782D666F6E742D66616D696C79293B5C6E7D';
wwv_flow_imp.g_varchar2_table(1753) := '5C6E222C22225D293B636F6E737420613D727D2C333239333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D';
wwv_flow_imp.g_varchar2_table(1754) := '6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1755) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E736564';
wwv_flow_imp.g_varchar2_table(1756) := '20756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1757) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1758) := '202E6C696E6B65642D65646974696E672D6465636F726174696F6E207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D6C696E6B656445646974696E674261636B67726F756E64293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1759) := '5C742F2A20456E73757265206465636F726174696F6E2069732076697369626C65206576656E2069662072616E676520697320656D707479202A2F5C6E5C746D696E2D77696474683A203170783B5C6E7D5C6E222C22225D293B636F6E737420613D727D';
wwv_flow_imp.g_varchar2_table(1760) := '2C313137373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E707573';
wwv_flow_imp.g_varchar2_table(1761) := '68285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1762) := '2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C696365';
wwv_flow_imp.g_varchar2_table(1763) := '6E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1764) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2E6D6F6E61636F2D656469746F72202E64657465637465642D6C696E6B2C5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1765) := '6E61636F2D656469746F72202E64657465637465642D6C696E6B2D616374697665207B5C6E5C74746578742D6465636F726174696F6E3A20756E6465726C696E653B5C6E5C74746578742D756E6465726C696E652D706F736974696F6E3A20756E646572';
wwv_flow_imp.g_varchar2_table(1766) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E64657465637465642D6C696E6B2D616374697665207B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F724C696E6B';
wwv_flow_imp.g_varchar2_table(1767) := '2D616374697665466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C373230313A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B7661';
wwv_flow_imp.g_varchar2_table(1768) := '7220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1769) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E2041';
wwv_flow_imp.g_varchar2_table(1770) := '6C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963';
wwv_flow_imp.g_varchar2_table(1771) := '656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1772) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765207B5C6E5C7470616464696E672D626F74746F6D3A203870783B5C6E5C747A2D696E646578';
wwv_flow_imp.g_varchar2_table(1773) := '3A2031303030303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D6573736167652E62656C6F77207B5C6E5C7470616464696E672D626F74746F6D3A20303B5C6E5C7470616464696E67';
wwv_flow_imp.g_varchar2_table(1774) := '2D746F703A203870783B5C6E5C747A2D696E6465783A2031303030303B5C6E7D5C6E5C6E406B65796672616D65732066616465496E207B5C6E5C7466726F6D207B206F7061636974793A20303B207D5C6E5C74746F207B206F7061636974793A20313B20';
wwv_flow_imp.g_varchar2_table(1775) := '7D5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D6573736167652E66616465496E207B5C6E5C74616E696D6174696F6E3A2066616465496E203135306D7320656173652D6F75743B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1776) := '6E5C6E406B65796672616D657320666164654F7574207B5C6E5C7466726F6D207B206F7061636974793A20313B207D5C6E5C74746F207B206F7061636974793A20303B207D5C6E7D5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469';
wwv_flow_imp.g_varchar2_table(1777) := '746F722D6F7665726C61796D6573736167652E666164654F7574207B5C6E5C74616E696D6174696F6E3A20666164654F7574203130306D7320656173652D6F75743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D65646974';
wwv_flow_imp.g_varchar2_table(1778) := '6F722D6F7665726C61796D657373616765202E6D657373616765207B5C6E5C7470616464696E673A20327078203470783B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D666F726567726F756E';
wwv_flow_imp.g_varchar2_table(1779) := '64293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(1780) := '64652D696E70757456616C69646174696F6E2D696E666F426F72646572293B5C6E5C74626F726465722D7261646975733A203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D65';
wwv_flow_imp.g_varchar2_table(1781) := '7373616765202E6D6573736167652070207B5C6E5C746D617267696E2D626C6F636B3A203070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765202E6D657373616765';
wwv_flow_imp.g_varchar2_table(1782) := '2061207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765';
wwv_flow_imp.g_varchar2_table(1783) := '202E6D65737361676520613A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B';
wwv_flow_imp.g_varchar2_table(1784) := '202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765202E6D6573736167652C5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765202E6D6573';
wwv_flow_imp.g_varchar2_table(1785) := '73616765207B5C6E5C74626F726465722D77696474683A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765202E616E63686F72207B5C6E5C7477696474683A20';
wwv_flow_imp.g_varchar2_table(1786) := '302021696D706F7274616E743B5C6E5C746865696768743A20302021696D706F7274616E743B5C6E5C74626F726465722D636F6C6F723A207472616E73706172656E743B5C6E5C74626F726465722D7374796C653A20736F6C69643B5C6E5C747A2D696E';
wwv_flow_imp.g_varchar2_table(1787) := '6465783A20313030303B5C6E5C74626F726465722D77696474683A203870783B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(1788) := '6469746F722D6F7665726C61796D657373616765202E616E63686F722E746F70207B5C6E5C74626F726465722D626F74746F6D2D636F6C6F723A20766172282D2D7673636F64652D696E70757456616C69646174696F6E2D696E666F426F72646572293B';
wwv_flow_imp.g_varchar2_table(1789) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D657373616765202E616E63686F722E62656C6F77207B5C6E5C74626F726465722D746F702D636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(1790) := '652D696E70757456616C69646174696F6E2D696E666F426F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D6573736167653A6E6F74282E62656C6F7729202E616E63686F';
wwv_flow_imp.g_varchar2_table(1791) := '722E746F702C5C6E2E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D6573736167652E62656C6F77202E616E63686F722E62656C6F77207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(1792) := '6D6F6E61636F2D656469746F72202E6D6F6E61636F2D656469746F722D6F7665726C61796D6573736167652E62656C6F77202E616E63686F722E746F70207B5C6E5C74646973706C61793A20696E68657269743B5C6E5C74746F703A202D3870783B5C6E';
wwv_flow_imp.g_varchar2_table(1793) := '7D5C6E222C22225D293B636F6E737420613D727D2C3939313A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D';
wwv_flow_imp.g_varchar2_table(1794) := '6E2E6E2873292829286F2829293B722E70757368285B652E69642C272F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1795) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E736564';
wwv_flow_imp.g_varchar2_table(1796) := '20756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1797) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1798) := '202E706172616D657465722D68696E74732D776964676574207B5C6E5C742F2A204D75737420626520686967686572207468616E2074686520736173685C2773207A2D696E64657820616E64207465726D696E616C2063616E766173657320627574206C';
wwv_flow_imp.g_varchar2_table(1799) := '6F776572207468616E20746865207375676765737420776964676574202A2F5C6E5C747A2D696E6465783A2033393B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C746C696E65';
wwv_flow_imp.g_varchar2_table(1800) := '2D6865696768743A20312E35656D3B5C6E5C74637572736F723A2064656661756C743B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D666F726567726F756E64293B5C6E5C746261636B67726F';
wwv_flow_imp.g_varchar2_table(1801) := '756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F766572';
wwv_flow_imp.g_varchar2_table(1802) := '5769646765742D626F72646572293B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D7769646765742C5C6E2E68632D6C69676874202E6D6F6E61636F2D656469746F72202E70';
wwv_flow_imp.g_varchar2_table(1803) := '6172616D657465722D68696E74732D776964676574207B5C6E5C74626F726465722D77696474683A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574203E202E706877726170';
wwv_flow_imp.g_varchar2_table(1804) := '706572207B5C6E5C746D61782D77696474683A2034343070783B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20726F773B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D65746572';
wwv_flow_imp.g_varchar2_table(1805) := '2D68696E74732D7769646765742E6D756C7469706C65207B5C6E5C746D696E2D6865696768743A20332E33656D3B5C6E5C7470616464696E673A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D';
wwv_flow_imp.g_varchar2_table(1806) := '7769646765742E6D756C7469706C65202E626F64793A3A6265666F7265207B5C6E5C74636F6E74656E743A2022223B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C746865696768743A20313030253B5C6E5C74706F736974696F6E3A20616273';
wwv_flow_imp.g_varchar2_table(1807) := '6F6C7574653B5C6E5C746F7061636974793A20302E353B5C6E5C74626F726465722D6C6566743A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(1808) := '61636F2D656469746F72202E706172616D657465722D68696E74732D77696467657420702C5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D77696467657420756C207B5C6E5C746D617267696E3A2038707820303B';
wwv_flow_imp.g_varchar2_table(1809) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E742C5C6E2E6D6F6E61636F2D656469746F72202E706172616D65746572';
wwv_flow_imp.g_varchar2_table(1810) := '2D68696E74732D776964676574202E626F6479207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65783A20313B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C746D696E2D6865696768743A20313030253B5C';
wwv_flow_imp.g_varchar2_table(1811) := '6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E7369676E6174757265207B5C6E5C7470616464696E673A20347078203570783B5C6E5C74706F736974696F6E3A2072656C6174697665';
wwv_flow_imp.g_varchar2_table(1812) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E7369676E61747572652E6861732D646F63733A3A6166746572207B5C6E5C74636F6E74656E743A2022223B5C6E5C74646973706C';
wwv_flow_imp.g_varchar2_table(1813) := '61793A20626C6F636B3B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A20303B5C6E5C7477696474683A20313030253B5C6E5C7470616464696E672D746F703A203470783B5C6E5C746F7061636974793A20302E353B5C';
wwv_flow_imp.g_varchar2_table(1814) := '6E5C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D';
wwv_flow_imp.g_varchar2_table(1815) := '68696E74732D776964676574202E646F6373207B5C6E5C7470616464696E673A203020313070782030203570783B5C6E5C7477686974652D73706163653A207072652D777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D';
wwv_flow_imp.g_varchar2_table(1816) := '657465722D68696E74732D776964676574202E646F63732E656D707479207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E646F6373';
wwv_flow_imp.g_varchar2_table(1817) := '2061207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E646F6373';
wwv_flow_imp.g_varchar2_table(1818) := '20613A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D65646974';
wwv_flow_imp.g_varchar2_table(1819) := '6F72202E706172616D657465722D68696E74732D776964676574202E646F6373202E6D61726B646F776E2D646F6373207B5C6E5C7477686974652D73706163653A20696E697469616C3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172';
wwv_flow_imp.g_varchar2_table(1820) := '616D657465722D68696E74732D776964676574202E646F637320636F6465207B5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F6E6F73706163652D666F6E74293B5C6E5C74626F726465722D7261646975733A20337078';
wwv_flow_imp.g_varchar2_table(1821) := '3B5C6E5C7470616464696E673A203020302E34656D3B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D74657874436F6465426C6F636B2D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D6564';
wwv_flow_imp.g_varchar2_table(1822) := '69746F72202E706172616D657465722D68696E74732D776964676574202E646F6373202E6D6F6E61636F2D746F6B656E697A65642D736F757263652C5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574';
wwv_flow_imp.g_varchar2_table(1823) := '202E646F6373202E636F6465207B5C6E5C7477686974652D73706163653A207072652D777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E636F6E74726F6C73207B5C6E5C';
wwv_flow_imp.g_varchar2_table(1824) := '74646973706C61793A206E6F6E653B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746D696E2D77696474683A20323270783B5C6E5C746A7573746966792D636F';
wwv_flow_imp.g_varchar2_table(1825) := '6E74656E743A20666C65782D656E643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D7769646765742E6D756C7469706C65202E636F6E74726F6C73207B5C6E5C74646973706C61793A20666C65783B';
wwv_flow_imp.g_varchar2_table(1826) := '5C6E5C7470616464696E673A2030203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D7769646765742E6D756C7469706C65202E627574746F6E207B5C6E5C7477696474683A20313670783B5C';
wwv_flow_imp.g_varchar2_table(1827) := '6E5C746865696768743A20313670783B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465';
wwv_flow_imp.g_varchar2_table(1828) := '722D68696E74732D776964676574202E627574746F6E2E70726576696F7573207B5C6E5C74626F74746F6D3A20323470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E6F7665';
wwv_flow_imp.g_varchar2_table(1829) := '726C6F616473207B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C746865696768743A20313270783B5C6E5C746C696E652D6865696768743A20313270783B5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(1830) := '6D6F6E6F73706163652D666F6E74293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706172616D657465722D68696E74732D776964676574202E7369676E6174757265202E706172616D657465722E616374697665207B5C6E5C74636F6C6F';
wwv_flow_imp.g_varchar2_table(1831) := '723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D686967686C69676874466F726567726F756E64293B5C6E5C74666F6E742D7765696768743A20626F6C643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E';
wwv_flow_imp.g_varchar2_table(1832) := '706172616D657465722D68696E74732D776964676574202E646F63756D656E746174696F6E2D706172616D65746572203E202E706172616D65746572207B5C6E5C74666F6E742D7765696768743A20626F6C643B5C6E5C746D617267696E2D7269676874';
wwv_flow_imp.g_varchar2_table(1833) := '3A20302E35656D3B5C6E7D5C6E272C22225D293B636F6E737420613D727D2C393733343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C73';
wwv_flow_imp.g_varchar2_table(1834) := '3D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1835) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E20';
wwv_flow_imp.g_varchar2_table(1836) := '2A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D';
wwv_flow_imp.g_varchar2_table(1837) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(1838) := '6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164207B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74646973706C61793A20666C65783B5C6E5C746A7573746966792D636F6E74656E74';
wwv_flow_imp.g_varchar2_table(1839) := '3A2073706163652D6265747765656E3B5C6E5C74666C65782D777261703A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D7469746C65207B';
wwv_flow_imp.g_varchar2_table(1840) := '5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A20626173656C696E653B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C746D617267696E2D6C6566743A20323070783B5C6E5C746D696E2D77696474683A';
wwv_flow_imp.g_varchar2_table(1841) := '20303B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065';
wwv_flow_imp.g_varchar2_table(1842) := '656B766965772D7469746C652E636C69636B61626C65207B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D74';
wwv_flow_imp.g_varchar2_table(1843) := '69746C65202E6469726E616D653A6E6F74283A656D70747929207B5C6E5C74666F6E742D73697A653A20302E39656D3B5C6E5C746D617267696E2D6C6566743A20302E35656D3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B7669';
wwv_flow_imp.g_varchar2_table(1844) := '65772D776964676574202E68656164202E7065656B766965772D7469746C65202E6D657461207B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F';
wwv_flow_imp.g_varchar2_table(1845) := '773A20656C6C69707369733B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D7469746C65202E6469726E616D65207B5C6E5C746F766572666C6F773A20686964';
wwv_flow_imp.g_varchar2_table(1846) := '64656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164';
wwv_flow_imp.g_varchar2_table(1847) := '202E7065656B766965772D7469746C65202E66696C656E616D65207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C7477686974652D73706163653A206E6F77726170';
wwv_flow_imp.g_varchar2_table(1848) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D7469746C65202E6D6574613A6E6F74283A656D707479293A3A6265666F7265207B5C6E5C74636F6E74656E74';
wwv_flow_imp.g_varchar2_table(1849) := '3A20272D273B5C6E5C7470616464696E673A203020302E33656D3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D616374696F6E73207B5C6E5C74666C65783A';
wwv_flow_imp.g_varchar2_table(1850) := '20313B5C6E5C74746578742D616C69676E3A2072696768743B5C6E5C7470616464696E672D72696768743A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B7669';
wwv_flow_imp.g_varchar2_table(1851) := '65772D616374696F6E73203E202E6D6F6E61636F2D616374696F6E2D626172207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68';
wwv_flow_imp.g_varchar2_table(1852) := '656164202E7065656B766965772D616374696F6E73203E202E6D6F6E61636F2D616374696F6E2D6261722C5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E68656164202E7065656B766965772D616374696F6E73';
wwv_flow_imp.g_varchar2_table(1853) := '203E202E6D6F6E61636F2D616374696F6E2D626172203E202E616374696F6E732D636F6E7461696E6572207B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D77696467657420';
wwv_flow_imp.g_varchar2_table(1854) := '3E202E626F6479207B5C6E5C74626F726465722D746F703A2031707820736F6C69643B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7065656B766965772D776964676574202E6865';
wwv_flow_imp.g_varchar2_table(1855) := '6164202E7065656B766965772D7469746C65202E636F6469636F6E207B5C6E5C746D617267696E2D72696768743A203470783B5C6E5C74616C69676E2D73656C663A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E706565';
wwv_flow_imp.g_varchar2_table(1856) := '6B766965772D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E636F6469636F6E207B5C6E5C74636F6C6F723A20696E68657269742021696D706F7274616E743B5C6E7D5C6E222C2222';
wwv_flow_imp.g_varchar2_table(1857) := '5D293B636F6E737420613D727D2C383033333A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E287329';
wwv_flow_imp.g_varchar2_table(1858) := '2829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1859) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E646572';
wwv_flow_imp.g_varchar2_table(1860) := '20746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1861) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E61';
wwv_flow_imp.g_varchar2_table(1862) := '6D652D626F78207B5C6E5C747A2D696E6465783A203130303B5C6E5C74636F6C6F723A20696E68657269743B5C6E5C74626F726465722D7261646975733A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78';
wwv_flow_imp.g_varchar2_table(1863) := '2E70726576696577207B5C6E5C7470616464696E673A20347078203470782030203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D696E7075742D776974682D627574746F6E207B5C6E';
wwv_flow_imp.g_varchar2_table(1864) := '5C7470616464696E673A203370783B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C7477696474683A2063616C632831303025202D20387078293B202F2A203470782070616464696E67206F6E20656163682073696465202A2F5C6E7D';
wwv_flow_imp.g_varchar2_table(1865) := '5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D696E707574207B5C6E5C7477696474683A2063616C632831303025202D20387078293B202F2A203470782070616464696E67206F6E2065616368207369';
wwv_flow_imp.g_varchar2_table(1866) := '6465202A2F5C6E5C7470616464696E673A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D696E7075743A666F637573207B5C6E5C746F75746C696E653A206E6F6E653B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1867) := '2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D73756767657374696F6E732D627574746F6E207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C';
wwv_flow_imp.g_varchar2_table(1868) := '7470616464696E673A203370783B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73706172656E743B5C6E5C74626F726465723A206E6F6E653B5C6E5C74626F726465722D7261646975733A203570783B5C6E5C74637572736F723A20';
wwv_flow_imp.g_varchar2_table(1869) := '706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D73756767657374696F6E732D627574746F6E3A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(1870) := '72282D2D7673636F64652D746F6F6C6261722D686F7665724261636B67726F756E64295C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D63616E6469646174652D6C6973742D636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(1871) := '72202E6D6F6E61636F2D6C6973742D726F77207B5C6E5C74626F726465722D7261646975733A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F78202E72656E616D652D6C6162656C207B5C6E5C7464697370';
wwv_flow_imp.g_varchar2_table(1872) := '6C61793A206E6F6E653B5C6E5C746F7061636974793A202E383B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E72656E616D652D626F782E70726576696577202E72656E616D652D6C6162656C207B5C6E5C74646973706C61793A20696E6865';
wwv_flow_imp.g_varchar2_table(1873) := '7269743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C36393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E28363331';
wwv_flow_imp.g_varchar2_table(1874) := '34292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1875) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963';
wwv_flow_imp.g_varchar2_table(1876) := '656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1877) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(1878) := '6469746F72202E736E69707065742D706C616365686F6C646572207B5C6E5C746D696E2D77696474683A203270783B5C6E5C746F75746C696E652D7374796C653A20736F6C69643B5C6E5C746F75746C696E652D77696474683A203170783B5C6E5C7462';
wwv_flow_imp.g_varchar2_table(1879) := '61636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D736E697070657454616273746F70486967686C696768744261636B67726F756E642C207472616E73706172656E74293B5C6E5C746F75746C696E652D636F6C';
wwv_flow_imp.g_varchar2_table(1880) := '6F723A20766172282D2D7673636F64652D656469746F722D736E697070657454616273746F70486967686C69676874426F726465722C207472616E73706172656E74293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E66696E6973682D736E';
wwv_flow_imp.g_varchar2_table(1881) := '69707065742D706C616365686F6C646572207B5C6E5C746F75746C696E652D7374796C653A20736F6C69643B5C6E5C746F75746C696E652D77696474683A203170783B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(1882) := '652D656469746F722D736E697070657446696E616C54616273746F70486967686C696768744261636B67726F756E642C207472616E73706172656E74293B5C6E5C746F75746C696E652D636F6C6F723A20766172282D2D7673636F64652D656469746F72';
wwv_flow_imp.g_varchar2_table(1883) := '2D736E697070657446696E616C54616273746F70486967686C69676874426F726465722C207472616E73706172656E74293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C373638393A28652C742C6E293D3E7B227573652073747269637422';
wwv_flow_imp.g_varchar2_table(1884) := '3B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1885) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D696372';
wwv_flow_imp.g_varchar2_table(1886) := '6F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E2074686520';
wwv_flow_imp.g_varchar2_table(1887) := '70726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1888) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D776964676574207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1889) := '6F6E61636F2D656469746F72202E737469636B792D7769646765742D6C696E652D6E756D62657273207B5C6E5C74666C6F61743A206C6566743B5C6E5C746261636B67726F756E642D636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1890) := '636F2D656469746F72202E737469636B792D7769646765742D6C696E65732D7363726F6C6C61626C65207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746F766572';
wwv_flow_imp.g_varchar2_table(1891) := '666C6F773A2068696464656E3B5C6E5C7477696474683A20766172282D2D7673636F64652D656469746F72537469636B795363726F6C6C2D7363726F6C6C61626C655769647468293B5C6E5C746261636B67726F756E642D636F6C6F723A20696E686572';
wwv_flow_imp.g_varchar2_table(1892) := '69743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D7769646765742D6C696E6573207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746261636B67726F756E642D636F6C6F723A20696E68657269743B';
wwv_flow_imp.g_varchar2_table(1893) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D6E756D6265722C202E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D636F6E74656E74207B5C6E5C74636F6C6F723A20766172282D2D767363';
wwv_flow_imp.g_varchar2_table(1894) := '6F64652D656469746F724C696E654E756D6265722D666F726567726F756E64293B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74706F736974696F6E3A20616273';
wwv_flow_imp.g_varchar2_table(1895) := '6F6C7574653B5C6E5C746261636B67726F756E642D636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D6E756D626572202E636F6469636F6E2D666F6C64696E672D657870616E';
wwv_flow_imp.g_varchar2_table(1896) := '6465642C5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D6E756D626572202E636F6469636F6E2D666F6C64696E672D636F6C6C6170736564207B5C6E5C74666C6F61743A2072696768743B5C6E5C747472616E736974696F6E';
wwv_flow_imp.g_varchar2_table(1897) := '3A20766172282D2D7673636F64652D656469746F72537469636B795363726F6C6C2D666F6C64696E674F7061636974795472616E736974696F6E293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D636F6E7465';
wwv_flow_imp.g_varchar2_table(1898) := '6E74207B5C6E5C7477696474683A20766172282D2D7673636F64652D656469746F72537469636B795363726F6C6C2D7363726F6C6C61626C655769647468293B5C6E5C746261636B67726F756E642D636F6C6F723A20696E68657269743B5C6E5C747768';
wwv_flow_imp.g_varchar2_table(1899) := '6974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D6E756D6265722D696E6E6572207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74746578';
wwv_flow_imp.g_varchar2_table(1900) := '742D616C69676E3A2072696768743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D776964676574207B5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D7673636F64652D656469746F';
wwv_flow_imp.g_varchar2_table(1901) := '72537469636B795363726F6C6C2D626F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D6C696E652D636F6E74656E743A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(1902) := '7673636F64652D656469746F72537469636B795363726F6C6C486F7665722D6261636B67726F756E64293B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D77696467657420';
wwv_flow_imp.g_varchar2_table(1903) := '7B5C6E5C7477696474683A20313030253B5C6E5C74626F782D736861646F773A20766172282D2D7673636F64652D656469746F72537469636B795363726F6C6C2D736861646F772920302033707820327078202D3270783B5C6E5C747A2D696E6465783A';
wwv_flow_imp.g_varchar2_table(1904) := '20343B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72537469636B795363726F6C6C2D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737469636B792D77';
wwv_flow_imp.g_varchar2_table(1905) := '69646765742E7065656B207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D7065656B56696577456469746F72537469636B795363726F6C6C2D6261636B67726F756E64293B5C6E7D5C6E222C22225D293B636F';
wwv_flow_imp.g_varchar2_table(1906) := '6E737420613D727D2C373136303A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F28';
wwv_flow_imp.g_varchar2_table(1907) := '29293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1908) := '2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E6465722074686520';
wwv_flow_imp.g_varchar2_table(1909) := '4D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1910) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2F2A2053756767657374207769646765742A2F5C6E5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1911) := '6F6E61636F2D656469746F72202E737567676573742D776964676574207B5C6E5C7477696474683A2034333070783B5C6E5C747A2D696E6465783A2034303B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A';
wwv_flow_imp.g_varchar2_table(1912) := '20636F6C756D6E3B5C6E5C74626F726465722D7261646975733A203370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E6D657373616765207B5C6E5C74666C65782D646972656374696F6E3A20726F';
wwv_flow_imp.g_varchar2_table(1913) := '773B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73207B5C';
wwv_flow_imp.g_varchar2_table(1914) := '6E5C74666C65783A20302031206175746F3B5C6E5C7477696474683A20313030253B5C6E5C74626F726465722D7374796C653A20736F6C69643B5C6E5C74626F726465722D77696474683A203170783B5C6E5C74626F726465722D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(1915) := '72282D2D7673636F64652D656469746F72537567676573745769646765742D626F72646572293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72537567676573745769646765742D6261636B6772';
wwv_flow_imp.g_varchar2_table(1916) := '6F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E737567676573742D7769646765742C5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E737567676573742D64657461696C732C5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1917) := '6F6E61636F2D656469746F722E68632D6C69676874202E737567676573742D7769646765742C5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E737567676573742D64657461696C73207B5C6E5C74626F726465722D77696474683A20';
wwv_flow_imp.g_varchar2_table(1918) := '3270783B5C6E7D5C6E5C6E2F2A205374796C657320666F7220737461747573206261722070617274202A2F5C6E5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E737567676573742D7374617475732D62617220';
wwv_flow_imp.g_varchar2_table(1919) := '7B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74646973706C61793A206E6F6E653B5C6E5C74666C65782D666C6F773A20726F77206E6F777261703B5C6E5C746A7573746966792D636F6E74656E743A2073706163652D62';
wwv_flow_imp.g_varchar2_table(1920) := '65747765656E3B5C6E5C7477696474683A20313030253B5C6E5C74666F6E742D73697A653A203830253B5C6E5C7470616464696E673A2030203470782030203470783B5C6E5C74626F726465722D746F703A2031707820736F6C696420766172282D2D76';
wwv_flow_imp.g_varchar2_table(1921) := '73636F64652D656469746F72537567676573745769646765742D626F72646572293B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E776974682D7374';
wwv_flow_imp.g_varchar2_table(1922) := '617475732D626172202E737567676573742D7374617475732D626172207B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E737567676573742D7374617475';
wwv_flow_imp.g_varchar2_table(1923) := '732D626172202E6C656674207B5C6E5C7470616464696E672D72696768743A203870783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E776974682D7374617475732D626172202E737567676573742D73';
wwv_flow_imp.g_varchar2_table(1924) := '74617475732D626172202E616374696F6E2D6C6162656C207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72537567676573745769646765745374617475732D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1925) := '6F2D656469746F72202E737567676573742D7769646765742E776974682D7374617475732D626172202E737567676573742D7374617475732D626172202E616374696F6E2D6974656D3A6E6F74283A6C6173742D6F662D7479706529202E616374696F6E';
wwv_flow_imp.g_varchar2_table(1926) := '2D6C6162656C207B5C6E5C746D617267696E2D72696768743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E776974682D7374617475732D626172202E737567676573742D7374617475732D6261';
wwv_flow_imp.g_varchar2_table(1927) := '72202E616374696F6E2D6974656D3A6E6F74283A6C6173742D6F662D7479706529202E616374696F6E2D6C6162656C3A3A6166746572207B5C6E5C74636F6E74656E743A20272C20273B5C6E5C746D617267696E2D72696768743A20302E33656D3B5C6E';
wwv_flow_imp.g_varchar2_table(1928) := '7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E776974682D7374617475732D626172202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D6169';
wwv_flow_imp.g_varchar2_table(1929) := '6E203E202E7269676874203E202E726561644D6F72652C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E776974682D7374617475732D626172202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F';
wwv_flow_imp.g_varchar2_table(1930) := '772E666F63757365642E737472696E672D6C6162656C203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F7265207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6564';
wwv_flow_imp.g_varchar2_table(1931) := '69746F72202E737567676573742D7769646765742E776974682D7374617475732D6261723A6E6F74282E646F63732D7369646529202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A686F766572203E202E636F6E74656E7473';
wwv_flow_imp.g_varchar2_table(1932) := '203E202E6D61696E203E202E72696768742E63616E2D657870616E642D64657461696C73203E202E64657461696C732D6C6162656C207B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2F2A205374796C657320666F72204D65737361676520';
wwv_flow_imp.g_varchar2_table(1933) := '656C656D656E7420666F72207768656E20776964676574206973206C6F6164696E67206F7220697320656D707479202A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574203E202E6D657373616765207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1934) := '70616464696E672D6C6566743A20323270783B5C6E7D5C6E5C6E2F2A2A205374796C657320666F7220746865206C69737420656C656D656E74202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574203E202E74';
wwv_flow_imp.g_varchar2_table(1935) := '726565207B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374207B5C6E5C74757365722D73';
wwv_flow_imp.g_varchar2_table(1936) := '656C6563743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E7D5C6E5C6E2F2A2A205374796C657320666F72206561636820726F7720696E20746865206C69737420656C656D656E74202A2A2F5C6E5C6E';
wwv_flow_imp.g_varchar2_table(1937) := '2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77207B5C6E5C74646973706C61793A20666C65783B5C6E5C742D6D6F782D626F782D73697A696E673A';
wwv_flow_imp.g_varchar2_table(1938) := '20626F726465722D626F783B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C7470616464696E672D72696768743A20313070783B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1939) := '6261636B67726F756E642D706F736974696F6E3A20327078203270783B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74637572736F723A20706F696E7465723B5C6E5C74746F7563682D616374696F6E3A206E6F6E653B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(1940) := '6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469';
wwv_flow_imp.g_varchar2_table(1941) := '746F72537567676573745769646765742D73656C6563746564466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C697374';
wwv_flow_imp.g_varchar2_table(1942) := '2D726F772E666F6375736564202E636F6469636F6E207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72537567676573745769646765742D73656C656374656449636F6E466F726567726F756E64293B5C6E7D5C6E5C6E2E6D';
wwv_flow_imp.g_varchar2_table(1943) := '6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473207B5C6E5C74666C65783A20313B5C6E5C746865696768743A2031303025';
wwv_flow_imp.g_varchar2_table(1944) := '3B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C7470616464696E672D6C6566743A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(1945) := '636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E207B5C6E5C74646973706C61793A20666C65783B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B';
wwv_flow_imp.g_varchar2_table(1946) := '5C6E5C7477686974652D73706163653A207072653B5C6E5C746A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1947) := '6F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E6C6566742C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D';
wwv_flow_imp.g_varchar2_table(1948) := '6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874207B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574';
wwv_flow_imp.g_varchar2_table(1949) := '202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A6E6F74282E666F637573656429203E202E636F6E74656E7473203E202E6D61696E202E6D6F6E61636F2D69636F6E2D6C6162656C207B5C6E5C74636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(1950) := '2D2D7673636F64652D656469746F72537567676573745769646765742D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765743A6E6F74282E66726F7A656E29202E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(1951) := '686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74666F6E742D7765696768743A20626F6C643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C69';
wwv_flow_imp.g_varchar2_table(1952) := '7374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(1953) := '652D656469746F72537567676573745769646765742D686967686C69676874466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(1954) := '6F2D6C6973742D726F772E666F6375736564203E202E636F6E74656E7473203E202E6D61696E202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C6F723A20766172282D2D7673636F6465';
wwv_flow_imp.g_varchar2_table(1955) := '2D656469746F72537567676573745769646765742D666F637573486967686C69676874466F726567726F756E64293B5C6E7D5C6E5C6E2F2A2A20526561644D6F72652049636F6E207374796C6573202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1956) := '202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E686561646572203E202E636F6469636F6E2D636C6F73652C5C6E2E6D6F6E61636F2D656469746F72202E';
wwv_flow_imp.g_varchar2_table(1957) := '737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F72653A3A6265666F7265207B5C6E5C7463';
wwv_flow_imp.g_varchar2_table(1958) := '6F6C6F723A20696E68657269743B5C6E5C746F7061636974793A20313B5C6E5C74666F6E742D73697A653A20313470783B5C6E5C74637572736F723A20706F696E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D';
wwv_flow_imp.g_varchar2_table(1959) := '64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E686561646572203E202E636F6469636F6E2D636C6F7365207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1960) := '746F703A203670783B5C6E5C7472696768743A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F647920';
wwv_flow_imp.g_varchar2_table(1961) := '3E202E686561646572203E202E636F6469636F6E2D636C6F73653A686F7665722C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E63';
wwv_flow_imp.g_varchar2_table(1962) := '6F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F72653A686F766572207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2F2A2A207369676E61747572652C207175616C69666965722C20747970652F646574';
wwv_flow_imp.g_varchar2_table(1963) := '61696C73206F706163697479202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E';
wwv_flow_imp.g_varchar2_table(1964) := '203E202E7269676874203E202E64657461696C732D6C6162656C207B5C6E5C746F7061636974793A20302E373B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E';
wwv_flow_imp.g_varchar2_table(1965) := '61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E6C656674203E202E7369676E61747572652D6C6162656C207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A';
wwv_flow_imp.g_varchar2_table(1966) := '20656C6C69707369733B5C6E5C746F7061636974793A20302E363B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F';
wwv_flow_imp.g_varchar2_table(1967) := '6E74656E7473203E202E6D61696E203E202E6C656674203E202E7175616C69666965722D6C6162656C207B5C6E5C746D617267696E2D6C6566743A20313270783B5C6E5C746F7061636974793A20302E343B5C6E5C74666F6E742D73697A653A20383525';
wwv_flow_imp.g_varchar2_table(1968) := '3B5C6E5C746C696E652D6865696768743A20696E697469616C3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74616C69676E2D73656C663A2063656E7465723B5C6E';
wwv_flow_imp.g_varchar2_table(1969) := '7D5C6E5C6E2F2A2A205479706520496E666F20616E642069636F6E206E65787420746F20746865206C6162656C20696E2074686520666F637573656420636F6D706C6574696F6E206974656D202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E';
wwv_flow_imp.g_varchar2_table(1970) := '737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E64657461696C732D6C6162656C207B5C6E5C74666F6E74';
wwv_flow_imp.g_varchar2_table(1971) := '2D73697A653A203835253B5C6E5C746D617267696E2D6C6566743A20312E31656D3B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C7477686974652D73706163653A20';
wwv_flow_imp.g_varchar2_table(1972) := '6E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269';
wwv_flow_imp.g_varchar2_table(1973) := '676874203E202E64657461696C732D6C6162656C203E202E6D6F6E61636F2D746F6B656E697A65642D736F75726365207B5C6E5C74646973706C61793A20696E6C696E653B5C6E7D5C6E5C6E2F2A2A2044657461696C733A206966207573696E6720436F';
wwv_flow_imp.g_varchar2_table(1974) := '6D706C6574696F6E4974656D2364657461696C732C2073686F77206F6E20666F637573202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D';
wwv_flow_imp.g_varchar2_table(1975) := '726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E64657461696C732D6C6162656C207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D';
wwv_flow_imp.g_varchar2_table(1976) := '7769646765743A6E6F74282E73686F77732D64657461696C7329202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E646574';
wwv_flow_imp.g_varchar2_table(1977) := '61696C732D6C6162656C207B5C6E5C74646973706C61793A20696E6C696E653B5C6E7D5C6E5C6E2F2A2A2044657461696C733A206966207573696E6720436F6D706C6574696F6E4974656D4C6162656C2364657461696C732C20616C776179732073686F';
wwv_flow_imp.g_varchar2_table(1978) := '77202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A6E6F74282E737472696E672D6C6162656C29203E202E636F6E74656E7473';
wwv_flow_imp.g_varchar2_table(1979) := '203E202E6D61696E203E202E7269676874203E202E64657461696C732D6C6162656C2C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E646F63732D73696465202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C';
wwv_flow_imp.g_varchar2_table(1980) := '6973742D726F772E666F63757365643A6E6F74282E737472696E672D6C6162656C29203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E64657461696C732D6C6162656C207B5C6E5C74646973706C61793A20696E6C696E';
wwv_flow_imp.g_varchar2_table(1981) := '653B5C6E7D5C6E5C6E2F2A2A20456C6C6970736973206F6E20686F766572202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765743A6E6F74282E646F63732D7369646529202E6D6F6E61636F2D6C697374202E6D';
wwv_flow_imp.g_varchar2_table(1982) := '6F6E61636F2D6C6973742D726F772E666F63757365643A686F766572203E202E636F6E74656E7473203E202E6D61696E203E202E72696768742E63616E2D657870616E642D64657461696C73203E202E64657461696C732D6C6162656C207B5C6E5C7477';
wwv_flow_imp.g_varchar2_table(1983) := '696474683A2063616C632831303025202D2032367078293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E7465';
wwv_flow_imp.g_varchar2_table(1984) := '6E7473203E202E6D61696E203E202E6C656674207B5C6E5C74666C65782D736872696E6B3A20313B5C6E5C74666C65782D67726F773A20313B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F7220';
wwv_flow_imp.g_varchar2_table(1985) := '2E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E6C656674203E202E6D6F6E61636F2D69636F6E2D6C6162656C207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(1986) := '666C65782D736872696E6B3A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A6E6F74282E737472696E672D6C6162656C';
wwv_flow_imp.g_varchar2_table(1987) := '29203E202E636F6E74656E7473203E202E6D61696E203E202E6C656674203E202E6D6F6E61636F2D69636F6E2D6C6162656C207B5C6E5C746D61782D77696474683A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7375676765';
wwv_flow_imp.g_varchar2_table(1988) := '73742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E737472696E672D6C6162656C203E202E636F6E74656E7473203E202E6D61696E203E202E6C656674203E202E6D6F6E61636F2D69636F6E2D6C616265';
wwv_flow_imp.g_varchar2_table(1989) := '6C207B5C6E5C74666C65782D736872696E6B3A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E74';
wwv_flow_imp.g_varchar2_table(1990) := '73203E202E6D61696E203E202E7269676874207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74666C65782D736872696E6B3A20343B5C6E5C746D61782D77696474683A203730253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72';
wwv_flow_imp.g_varchar2_table(1991) := '202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F7265207B5C6E5C74646973706C6179';
wwv_flow_imp.g_varchar2_table(1992) := '3A20696E6C696E652D626C6F636B3B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7472696768743A20313070783B5C6E5C7477696474683A20313870783B5C6E5C746865696768743A20313870783B5C6E5C747669736962696C6974';
wwv_flow_imp.g_varchar2_table(1993) := '793A2068696464656E3B5C6E7D5C6E5C6E2F2A2A20446F204E4F5420646973706C617920526561644D6F7265207768656E20646F637320697320736964652F62656C6F77202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D';
wwv_flow_imp.g_varchar2_table(1994) := '7769646765742E646F63732D73696465202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F7265207B5C6E5C74646973706C6179';
wwv_flow_imp.g_varchar2_table(1995) := '3A206E6F6E652021696D706F7274616E743B5C6E7D5C6E5C6E2F2A2A20446F204E4F5420646973706C617920526561644D6F7265207768656E207573696E6720706C61696E20436F6D706C6574696F6E4974656D4C6162656C202864657461696C732F64';
wwv_flow_imp.g_varchar2_table(1996) := '6F63756D656E746174696F6E206D69676874206E6F74206265207265736F6C76656429202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D';
wwv_flow_imp.g_varchar2_table(1997) := '726F772E737472696E672D6C6162656C203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F7265207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2F2A2A20466F6375736564206974656D';
wwv_flow_imp.g_varchar2_table(1998) := '2063616E2073686F7720526561644D6F72652C206275742063616E2774207768656E20646F637320697320736964652F62656C6F77202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(1999) := '6C697374202E6D6F6E61636F2D6C6973742D726F772E666F63757365642E737472696E672D6C6162656C203E202E636F6E74656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F7265207B5C6E5C74646973706C61793A20696E';
wwv_flow_imp.g_varchar2_table(2000) := '6C696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F63757365643A686F766572203E202E636F6E74';
wwv_flow_imp.g_varchar2_table(2001) := '656E7473203E202E6D61696E203E202E7269676874203E202E726561644D6F7265207B5C6E5C747669736962696C6974793A2076697369626C653B5C6E7D5C6E5C6E2F2A2A205374796C657320666F72206561636820726F7720696E20746865206C6973';
wwv_flow_imp.g_varchar2_table(2002) := '74202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77202E6D6F6E61636F2D69636F6E2D6C6162656C2E6465707265636174656420';
wwv_flow_imp.g_varchar2_table(2003) := '7B5C6E5C746F7061636974793A20302E36363B5C6E5C74746578742D6465636F726174696F6E3A20756E7365743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F';
wwv_flow_imp.g_varchar2_table(2004) := '6E61636F2D6C6973742D726F77202E6D6F6E61636F2D69636F6E2D6C6162656C2E64657072656361746564203E202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E61636F2D69636F6E2D6E616D652D636F6E7461';
wwv_flow_imp.g_varchar2_table(2005) := '696E6572207B5C6E5C74746578742D6465636F726174696F6E3A206C696E652D7468726F7567683B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C';
wwv_flow_imp.g_varchar2_table(2006) := '6973742D726F77202E6D6F6E61636F2D69636F6E2D6C6162656C3A3A6265666F7265207B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C';
wwv_flow_imp.g_varchar2_table(2007) := '697374202E6D6F6E61636F2D6C6973742D726F77202E69636F6E207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C746865696768743A20313670783B5C6E5C7477696474683A20313670783B5C6E5C746D617267696E2D6C6566743A20327078';
wwv_flow_imp.g_varchar2_table(2008) := '3B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C746261636B67726F756E642D73697A653A203830253B5C6E5C746261636B67726F756E642D706F736974696F6E3A2063656E7465723B5C6E7D5C6E5C6E2E6D';
wwv_flow_imp.g_varchar2_table(2009) := '6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77202E69636F6E2E68696465207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(2010) := '61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77202E737567676573742D69636F6E207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D';
wwv_flow_imp.g_varchar2_table(2011) := '6974656D733A2063656E7465723B5C6E5C746D617267696E2D72696768743A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E6E6F2D69636F6E73202E6D6F6E61636F2D6C697374202E6D6F6E';
wwv_flow_imp.g_varchar2_table(2012) := '61636F2D6C6973742D726F77202E69636F6E2C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D7769646765742E6E6F2D69636F6E73202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77202E737567676573742D';
wwv_flow_imp.g_varchar2_table(2013) := '69636F6E3A3A6265666F7265207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F7720';
wwv_flow_imp.g_varchar2_table(2014) := '2E69636F6E2E637573746F6D636F6C6F72202E636F6C6F727370616E207B5C6E5C746D617267696E3A20302030203020302E33656D3B5C6E5C74626F726465723A20302E31656D20736F6C696420233030303B5C6E5C7477696474683A20302E37656D3B';
wwv_flow_imp.g_varchar2_table(2015) := '5C6E5C746865696768743A20302E37656D3B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E2F2A2A205374796C657320666F722074686520646F6373206F662074686520636F6D706C6574696F6E206974656D20696E';
wwv_flow_imp.g_varchar2_table(2016) := '20666F637573202A2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C732D636F6E7461696E6572207B5C6E5C747A2D696E6465783A2034313B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E73756767';
wwv_flow_imp.g_varchar2_table(2017) := '6573742D64657461696C73207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C74637572736F723A2064656661756C743B5C6E5C74636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(2018) := '652D656469746F72537567676573745769646765742D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C732E666F6375736564207B5C6E5C74626F726465722D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(2019) := '766172282D2D7673636F64652D666F637573426F72646572293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C732061207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B';
wwv_flow_imp.g_varchar2_table(2020) := '2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C7320613A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D616374697665';
wwv_flow_imp.g_varchar2_table(2021) := '466F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C7320636F6465207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D74657874436F6465';
wwv_flow_imp.g_varchar2_table(2022) := '426C6F636B2D6261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C732E6E6F2D646F6373207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(2023) := '6469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74207B5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461';
wwv_flow_imp.g_varchar2_table(2024) := '696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479207B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746865696768743A20313030253B5C6E5C7477696474683A20313030';
wwv_flow_imp.g_varchar2_table(2025) := '253B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E686561646572203E202E74797065207B5C6E5C';
wwv_flow_imp.g_varchar2_table(2026) := '74666C65783A20323B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F7061636974793A20302E373B5C6E5C7477686974652D73706163653A207072653B5C6E5C74';
wwv_flow_imp.g_varchar2_table(2027) := '6D617267696E3A20302032347078203020303B5C6E5C7470616464696E673A2034707820302031327078203570783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F';
wwv_flow_imp.g_varchar2_table(2028) := '6C6C61626C652D656C656D656E74203E202E626F6479203E202E686561646572203E202E747970652E6175746F2D77726170207B5C6E5C7477686974652D73706163653A206E6F726D616C3B5C6E5C74776F72642D627265616B3A20627265616B2D616C';
wwv_flow_imp.g_varchar2_table(2029) := '6C3B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F6373207B5C6E5C746D617267696E3A2030';
wwv_flow_imp.g_varchar2_table(2030) := '3B5C6E5C7470616464696E673A20347078203570783B5C6E5C7477686974652D73706163653A207072652D777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C732E6E6F2D74797065203E202E6D6F';
wwv_flow_imp.g_varchar2_table(2031) := '6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F6373207B5C6E5C746D617267696E2D72696768743A20323470783B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(2032) := '656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373207B5C6E5C7470616464696E673A20303B5C';
wwv_flow_imp.g_varchar2_table(2033) := '6E5C7477686974652D73706163653A20696E697469616C3B5C6E5C746D696E2D6865696768743A2063616C63283172656D202B20387078293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D';
wwv_flow_imp.g_varchar2_table(2034) := '6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373203E206469762C5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F';
wwv_flow_imp.g_varchar2_table(2035) := '6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373203E207370616E3A6E6F74283A656D70747929207B5C6E5C7470616464696E673A20347078203570783B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(2036) := '5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373203E20646976203E';
wwv_flow_imp.g_varchar2_table(2037) := '20703A66697273742D6368696C64207B5C6E5C746D617267696E2D746F703A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E';
wwv_flow_imp.g_varchar2_table(2038) := '74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373203E20646976203E20703A6C6173742D6368696C64207B5C6E5C746D617267696E2D626F74746F6D3A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7375';
wwv_flow_imp.g_varchar2_table(2039) := '67676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373202E6D6F6E61636F2D746F6B656E697A65642D736F75726365207B5C';
wwv_flow_imp.g_varchar2_table(2040) := '6E5C7477686974652D73706163653A207072653B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E64';
wwv_flow_imp.g_varchar2_table(2041) := '6F6373202E636F6465207B5C6E5C7477686974652D73706163653A207072652D777261703B5C6E5C74776F72642D777261703A20627265616B2D776F72643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C';
wwv_flow_imp.g_varchar2_table(2042) := '73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E202E646F63732E6D61726B646F776E2D646F6373202E636F6469636F6E207B5C6E5C74766572746963616C2D616C69676E3A207375623B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(2043) := '5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73203E202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E626F6479203E20703A656D707479207B5C6E5C74646973706C61793A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(2044) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C7320636F6465207B5C6E5C74626F726465722D7261646975733A203370783B5C6E5C7470616464696E673A203020302E34656D3B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(2045) := '61636F2D656469746F72202E737567676573742D64657461696C7320756C207B5C6E5C7470616464696E672D6C6566743A20323070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73206F6C207B5C6E';
wwv_flow_imp.g_varchar2_table(2046) := '5C7470616464696E672D6C6566743A20323070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E737567676573742D64657461696C73207020636F6465207B5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F';
wwv_flow_imp.g_varchar2_table(2047) := '6E6F73706163652D666F6E74293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313032393A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E';
wwv_flow_imp.g_varchar2_table(2048) := '6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2049) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C2072696768747320726573657276';
wwv_flow_imp.g_varchar2_table(2050) := '65642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E';
wwv_flow_imp.g_varchar2_table(2051) := '2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C';
wwv_flow_imp.g_varchar2_table(2052) := '6E5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D61727261792C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6172726179207B20';
wwv_flow_imp.g_varchar2_table(2053) := '636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6172726179466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D626F6F6C65616E2C5C';
wwv_flow_imp.g_varchar2_table(2054) := '6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D626F6F6C65616E207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D626F6F6C65616E466F726567726F756E';
wwv_flow_imp.g_varchar2_table(2055) := '64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636C6173732C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636C6173';
wwv_flow_imp.g_varchar2_table(2056) := '73207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D636C617373466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6D6574686F';
wwv_flow_imp.g_varchar2_table(2057) := '642C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6D6574686F64207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6D6574686F64466F726567726F75';
wwv_flow_imp.g_varchar2_table(2058) := '6E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636F6C6F722C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636F6C';
wwv_flow_imp.g_varchar2_table(2059) := '6F72207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D636F6C6F72466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636F6E73';
wwv_flow_imp.g_varchar2_table(2060) := '74616E742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636F6E7374616E74207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D636F6E7374616E7446';
wwv_flow_imp.g_varchar2_table(2061) := '6F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D636F6E7374727563746F722C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F646963';
wwv_flow_imp.g_varchar2_table(2062) := '6F6E2D73796D626F6C2D636F6E7374727563746F72207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D636F6E7374727563746F72466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F';
wwv_flow_imp.g_varchar2_table(2063) := '6469636F6E2E636F6469636F6E2D73796D626F6C2D76616C75652C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D76616C75652C5C6E2E6D6F6E61636F2D656469746F72202E636F646963';
wwv_flow_imp.g_varchar2_table(2064) := '6F6E2E636F6469636F6E2D73796D626F6C2D656E756D2C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D656E756D207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C';
wwv_flow_imp.g_varchar2_table(2065) := '49636F6E2D656E756D657261746F72466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D656E756D2D6D656D6265722C5C6E2E6D6F6E61636F2D776F726B62656E63';
wwv_flow_imp.g_varchar2_table(2066) := '68202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D656E756D2D6D656D626572207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D656E756D657261746F724D656D626572466F726567726F756E64293B20';
wwv_flow_imp.g_varchar2_table(2067) := '7D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6576656E742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6576656E74207B20';
wwv_flow_imp.g_varchar2_table(2068) := '636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6576656E74466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6669656C642C5C6E2E';
wwv_flow_imp.g_varchar2_table(2069) := '6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6669656C64207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6669656C64466F726567726F756E64293B207D5C';
wwv_flow_imp.g_varchar2_table(2070) := '6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D66696C652C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D66696C65207B20636F6C6F';
wwv_flow_imp.g_varchar2_table(2071) := '723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D66696C65466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D666F6C6465722C5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(2072) := '636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D666F6C646572207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D666F6C646572466F726567726F756E64293B207D5C6E2E';
wwv_flow_imp.g_varchar2_table(2073) := '6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D66756E6374696F6E2C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(2074) := '7B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D66756E6374696F6E466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D696E7465';
wwv_flow_imp.g_varchar2_table(2075) := '72666163652C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D696E74657266616365207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D696E7465726661';
wwv_flow_imp.g_varchar2_table(2076) := '6365466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6B65792C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D7379';
wwv_flow_imp.g_varchar2_table(2077) := '6D626F6C2D6B6579207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6B6579466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D';
wwv_flow_imp.g_varchar2_table(2078) := '6B6579776F72642C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6B6579776F7264207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6B6579776F7264';
wwv_flow_imp.g_varchar2_table(2079) := '466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6D6F64756C652C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73';
wwv_flow_imp.g_varchar2_table(2080) := '796D626F6C2D6D6F64756C65207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6D6F64756C65466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D';
wwv_flow_imp.g_varchar2_table(2081) := '73796D626F6C2D6E616D6573706163652C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6E616D657370616365207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49';
wwv_flow_imp.g_varchar2_table(2082) := '636F6E2D6E616D657370616365466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6E756C6C2C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F';
wwv_flow_imp.g_varchar2_table(2083) := '6E2E636F6469636F6E2D73796D626F6C2D6E756C6C207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6E756C6C466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E63';
wwv_flow_imp.g_varchar2_table(2084) := '6F6469636F6E2D73796D626F6C2D6E756D6265722C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6E756D626572207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C';
wwv_flow_imp.g_varchar2_table(2085) := '49636F6E2D6E756D626572466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6F626A6563742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F';
wwv_flow_imp.g_varchar2_table(2086) := '6E2E636F6469636F6E2D73796D626F6C2D6F626A656374207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D6F626A656374466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F646963';
wwv_flow_imp.g_varchar2_table(2087) := '6F6E2E636F6469636F6E2D73796D626F6C2D6F70657261746F722C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D6F70657261746F72207B20636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(2088) := '652D73796D626F6C49636F6E2D6F70657261746F72466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7061636B6167652C5C6E2E6D6F6E61636F2D776F726B6265';
wwv_flow_imp.g_varchar2_table(2089) := '6E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7061636B616765207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D7061636B616765466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(2090) := '656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D70726F70657274792C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D70726F7065727479207B20636F6C6F72';
wwv_flow_imp.g_varchar2_table(2091) := '3A20766172282D2D7673636F64652D73796D626F6C49636F6E2D70726F7065727479466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7265666572656E63652C5C';
wwv_flow_imp.g_varchar2_table(2092) := '6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7265666572656E6365207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D7265666572656E6365466F726567';
wwv_flow_imp.g_varchar2_table(2093) := '726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D736E69707065742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F';
wwv_flow_imp.g_varchar2_table(2094) := '6C2D736E6970706574207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D736E6970706574466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D7379';
wwv_flow_imp.g_varchar2_table(2095) := '6D626F6C2D737472696E672C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D737472696E67207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D73747269';
wwv_flow_imp.g_varchar2_table(2096) := '6E67466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7374727563742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E';
wwv_flow_imp.g_varchar2_table(2097) := '2D73796D626F6C2D737472756374207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D737472756374466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F';
wwv_flow_imp.g_varchar2_table(2098) := '6E2D73796D626F6C2D746578742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D74657874207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D74657874';
wwv_flow_imp.g_varchar2_table(2099) := '466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D747970652D706172616D657465722C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E63';
wwv_flow_imp.g_varchar2_table(2100) := '6F6469636F6E2D73796D626F6C2D747970652D706172616D65746572207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D74797065506172616D65746572466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(2101) := '6469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D756E69742C5C6E2E6D6F6E61636F2D776F726B62656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D756E6974207B20636F6C6F723A20766172282D2D76';
wwv_flow_imp.g_varchar2_table(2102) := '73636F64652D73796D626F6C49636F6E2D756E6974466F726567726F756E64293B207D5C6E2E6D6F6E61636F2D656469746F72202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7661726961626C652C5C6E2E6D6F6E61636F2D776F726B62';
wwv_flow_imp.g_varchar2_table(2103) := '656E6368202E636F6469636F6E2E636F6469636F6E2D73796D626F6C2D7661726961626C65207B20636F6C6F723A20766172282D2D7673636F64652D73796D626F6C49636F6E2D7661726961626C65466F726567726F756E64293B207D5C6E222C22225D';
wwv_flow_imp.g_varchar2_table(2104) := '293B636F6E737420613D727D2C363036353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E28732928';
wwv_flow_imp.g_varchar2_table(2105) := '29286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2106) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220';
wwv_flow_imp.g_varchar2_table(2107) := '746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2108) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E656469746F722D62616E6E6572207B5C6E5C7462';
wwv_flow_imp.g_varchar2_table(2109) := '6F782D73697A696E673A20626F726465722D626F783B5C6E5C74637572736F723A2064656661756C743B5C6E5C7477696474683A20313030253B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C74646973706C61793A20666C65783B5C6E5C74';
wwv_flow_imp.g_varchar2_table(2110) := '6F766572666C6F773A2076697369626C653B5C6E5C6E5C746865696768743A20323670783B5C6E5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D62616E6E65722D6261636B67726F756E64293B5C6E7D5C6E5C6E5C6E2E656469';
wwv_flow_imp.g_varchar2_table(2111) := '746F722D62616E6E6572202E69636F6E2D636F6E7461696E6572207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D736872696E6B3A20303B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C7470616464696E67';
wwv_flow_imp.g_varchar2_table(2112) := '3A203020367078203020313070783B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572202E69636F6E2D636F6E7461696E65722E637573746F6D2D69636F6E207B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C';
wwv_flow_imp.g_varchar2_table(2113) := '6E5C746261636B67726F756E642D706F736974696F6E3A2063656E7465722063656E7465723B5C6E5C746261636B67726F756E642D73697A653A20313670783B5C6E5C7477696474683A20313670783B5C6E5C7470616464696E673A20303B5C6E5C746D';
wwv_flow_imp.g_varchar2_table(2114) := '617267696E3A203020367078203020313070783B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572202E6D6573736167652D636F6E7461696E6572207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E';
wwv_flow_imp.g_varchar2_table(2115) := '7465723B5C6E5C746C696E652D6865696768743A20323670783B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C746F766572666C6F773A2068696464656E3B5C';
wwv_flow_imp.g_varchar2_table(2116) := '6E7D5C6E5C6E2E656469746F722D62616E6E6572202E6D6573736167652D636F6E7461696E65722070207B5C6E5C746D617267696E2D626C6F636B2D73746172743A20303B5C6E5C746D617267696E2D626C6F636B2D656E643A20303B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(2117) := '2E656469746F722D62616E6E6572202E6D6573736167652D616374696F6E732D636F6E7461696E6572207B5C6E5C74666C65782D67726F773A20313B5C6E5C74666C65782D736872696E6B3A20303B5C6E5C746C696E652D6865696768743A2032367078';
wwv_flow_imp.g_varchar2_table(2118) := '3B5C6E5C746D617267696E3A2030203470783B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572202E6D6573736167652D616374696F6E732D636F6E7461696E657220612E6D6F6E61636F2D627574746F6E207B5C6E5C7477696474683A20696E6865';
wwv_flow_imp.g_varchar2_table(2119) := '7269743B5C6E5C746D617267696E3A20327078203870783B5C6E5C7470616464696E673A2030707820313270783B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572202E6D6573736167652D616374696F6E732D636F6E7461696E65722061207B5C6E';
wwv_flow_imp.g_varchar2_table(2120) := '5C7470616464696E673A203370783B5C6E5C746D617267696E2D6C6566743A20313270783B5C6E5C74746578742D6465636F726174696F6E3A20756E6465726C696E653B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572202E616374696F6E2D636F';
wwv_flow_imp.g_varchar2_table(2121) := '6E7461696E6572207B5C6E5C7470616464696E673A203020313070782030203670783B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D62616E6E65722D';
wwv_flow_imp.g_varchar2_table(2122) := '6261636B67726F756E64293B5C6E7D5C6E5C6E2E656469746F722D62616E6E65722C5C6E2E656469746F722D62616E6E6572202E616374696F6E2D636F6E7461696E6572202E636F6469636F6E2C5C6E2E656469746F722D62616E6E6572202E6D657373';
wwv_flow_imp.g_varchar2_table(2123) := '6167652D616374696F6E732D636F6E7461696E6572202E6D6F6E61636F2D6C696E6B207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D62616E6E65722D666F726567726F756E64293B5C6E7D5C6E5C6E2E656469746F722D62616E6E6572';
wwv_flow_imp.g_varchar2_table(2124) := '202E69636F6E2D636F6E7461696E6572202E636F6469636F6E207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D62616E6E65722D69636F6E466F726567726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C383234';
wwv_flow_imp.g_varchar2_table(2125) := '353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B65';
wwv_flow_imp.g_varchar2_table(2126) := '2E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2127) := '5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E';
wwv_flow_imp.g_varchar2_table(2128) := '20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2129) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E756E69636F64652D686967686C69676874207B5C6E';
wwv_flow_imp.g_varchar2_table(2130) := '5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72556E69636F6465486967686C696768742D626F72646572293B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D65';
wwv_flow_imp.g_varchar2_table(2131) := '6469746F72556E69636F6465486967686C696768742D6261636B67726F756E64293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C393830333A28652C742C6E293D3E7B22';
wwv_flow_imp.g_varchar2_table(2132) := '75736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2133) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967';
wwv_flow_imp.g_varchar2_table(2134) := '687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E';
wwv_flow_imp.g_varchar2_table(2135) := '74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2136) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D656469746F72202E666F6375736564202E73656C656374696F6E486967686C69676874207B5C6E5C7462';
wwv_flow_imp.g_varchar2_table(2137) := '61636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D73656C656374696F6E486967686C696768744261636B67726F756E64293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F';
wwv_flow_imp.g_varchar2_table(2138) := '726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F722D73656C656374696F6E486967686C69676874426F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E666F637573656420';
wwv_flow_imp.g_varchar2_table(2139) := '2E73656C656374696F6E486967686C696768742C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E666F6375736564202E73656C656374696F6E486967686C69676874207B5C6E5C74626F726465722D7374796C653A20646F747465643B';
wwv_flow_imp.g_varchar2_table(2140) := '5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E776F7264486967686C69676874207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D776F7264486967686C696768744261636B67726F';
wwv_flow_imp.g_varchar2_table(2141) := '756E64293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F722D776F7264486967686C69676874426F72646572293B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(2142) := '2E6D6F6E61636F2D656469746F722E68632D626C61636B202E776F7264486967686C696768742C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E776F7264486967686C69676874207B5C6E5C74626F726465722D7374796C653A20646F';
wwv_flow_imp.g_varchar2_table(2143) := '747465643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E776F7264486967686C696768745374726F6E67207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F722D776F7264486967686C';
wwv_flow_imp.g_varchar2_table(2144) := '696768745374726F6E674261636B67726F756E64293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F722D776F7264486967686C';
wwv_flow_imp.g_varchar2_table(2145) := '696768745374726F6E67426F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E776F7264486967686C696768745374726F6E672C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E776F72644869';
wwv_flow_imp.g_varchar2_table(2146) := '67686C696768745374726F6E67207B5C6E5C74626F726465722D7374796C653A20646F747465643B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E776F7264486967686C6967687454657874207B5C6E5C746261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(2147) := '6F723A20766172282D2D7673636F64652D656469746F722D776F7264486967686C69676874546578744261636B67726F756E64293B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C74626F726465723A2031707820736F6C69';
wwv_flow_imp.g_varchar2_table(2148) := '6420766172282D2D7673636F64652D656469746F722D776F7264486967686C6967687454657874426F72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E776F7264486967686C69676874546578742C202E6D6F6E';
wwv_flow_imp.g_varchar2_table(2149) := '61636F2D656469746F722E68632D6C69676874202E776F7264486967686C6967687454657874207B5C6E5C74626F726465722D7374796C653A20646F747465643B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C323838393A28652C742C6E29';
wwv_flow_imp.g_varchar2_table(2150) := '3D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D';
wwv_flow_imp.g_varchar2_table(2151) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F70';
wwv_flow_imp.g_varchar2_table(2152) := '79726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C696365';
wwv_flow_imp.g_varchar2_table(2153) := '6E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2154) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E2E6D6F6E61636F2D656469746F72202E7A6F6E652D776964676574207B5C6E5C74706F736974696F6E3A206162736F6C';
wwv_flow_imp.g_varchar2_table(2155) := '7574653B5C6E5C747A2D696E6465783A2031303B5C6E7D5C6E5C6E5C6E2E6D6F6E61636F2D656469746F72202E7A6F6E652D776964676574202E7A6F6E652D7769646765742D636F6E7461696E6572207B5C6E5C74626F726465722D746F702D7374796C';
wwv_flow_imp.g_varchar2_table(2156) := '653A20736F6C69643B5C6E5C74626F726465722D626F74746F6D2D7374796C653A20736F6C69643B5C6E5C74626F726465722D746F702D77696474683A20303B5C6E5C74626F726465722D626F74746F6D2D77696474683A20303B5C6E5C74706F736974';
wwv_flow_imp.g_varchar2_table(2157) := '696F6E3A2072656C61746976653B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C393333373A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E677D293B76617220693D6E2831363031292C6F3D6E2E';
wwv_flow_imp.g_varchar2_table(2158) := '6E2869292C733D6E2836333134292C723D6E2E6E2873292C613D6E2834343137292C6C3D6E2E6E2861292C633D6E65772055524C286E2837353834292C6E2E62292C643D6E65772055524C286E2836303630292C6E2E62292C683D722829286F2829292C';
wwv_flow_imp.g_varchar2_table(2159) := '753D6C28292863292C703D6C28292864293B682E70757368285B652E69642C602F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2160) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C696365';
wwv_flow_imp.g_varchar2_table(2161) := '6E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2162) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D6564';
wwv_flow_imp.g_varchar2_table(2163) := '69746F72202E6950616453686F774B6579626F617264207B5C6E5C7477696474683A20353870783B5C6E5C746D696E2D77696474683A20303B5C6E5C746865696768743A20333670783B5C6E5C746D696E2D6865696768743A20303B5C6E5C746D617267';
wwv_flow_imp.g_varchar2_table(2164) := '696E3A20303B5C6E5C7470616464696E673A20303B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C74726573697A653A206E6F6E653B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C746261636B67726F756E643A207572';
wwv_flow_imp.g_varchar2_table(2165) := '6C28247B757D292063656E7465722063656E746572206E6F2D7265706561743B5C6E5C74626F726465723A2034707820736F6C696420234636463646363B5C6E5C74626F726465722D7261646975733A203470783B5C6E7D5C6E5C6E2E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(2166) := '656469746F722E76732D6461726B202E6950616453686F774B6579626F617264207B5C6E5C746261636B67726F756E643A2075726C28247B707D292063656E7465722063656E746572206E6F2D7265706561743B5C6E5C74626F726465723A2034707820';
wwv_flow_imp.g_varchar2_table(2167) := '736F6C696420233235323532363B5C6E7D602C22225D293B636F6E737420673D687D2C323933313A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E28';
wwv_flow_imp.g_varchar2_table(2168) := '69292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2169) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C20726967687473207265736572766564';
wwv_flow_imp.g_varchar2_table(2170) := '2E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C';
wwv_flow_imp.g_varchar2_table(2171) := '6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C';
wwv_flow_imp.g_varchar2_table(2172) := '6E2E6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574207B5C6E5C747A2D696E6465783A2035303B5C6E5C74757365722D73656C6563743A20746578743B5C6E5C742D7765626B69742D757365722D73656C6563';
wwv_flow_imp.g_varchar2_table(2173) := '743A20746578743B5C6E5C7470616464696E673A20313070783B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D666F726567726F756E64293B5C6E5C746261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(2174) := '3A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D6261636B67726F756E64293B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F';
wwv_flow_imp.g_varchar2_table(2175) := '72646572293B5C6E7D5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E746F6B656E732D696E73706563742D7769646765742C202E6D6F6E61636F2D656469746F722E68632D6C69676874202E746F6B656E732D696E73706563742D77';
wwv_flow_imp.g_varchar2_table(2176) := '6964676574207B5C6E5C74626F726465722D77696474683A203270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574202E746F6B656E732D696E73706563742D736570617261746F7220';
wwv_flow_imp.g_varchar2_table(2177) := '7B5C6E5C746865696768743A203170783B5C6E5C74626F726465723A20303B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(2178) := '6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574202E746D2D746F6B656E207B5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F6E6F73706163652D666F6E74293B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(2179) := '6E2E6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574202E746D2D746F6B656E2D6C656E677468207B5C6E5C74666F6E742D7765696768743A206E6F726D616C3B5C6E5C74666F6E742D73697A653A203630253B';
wwv_flow_imp.g_varchar2_table(2180) := '5C6E5C74666C6F61743A2072696768743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574202E746D2D6D657461646174612D7461626C65207B5C6E5C7477696474683A20313030253B5C6E';
wwv_flow_imp.g_varchar2_table(2181) := '7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574202E746D2D6D657461646174612D76616C7565207B5C6E5C74666F6E742D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F6E6F737061';
wwv_flow_imp.g_varchar2_table(2182) := '63652D666F6E74293B5C6E5C74746578742D616C69676E3A2072696768743B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E746F6B656E732D696E73706563742D776964676574202E746D2D746F6B656E2D74797065207B5C6E5C74666F6E74';
wwv_flow_imp.g_varchar2_table(2183) := '2D66616D696C793A20766172282D2D6D6F6E61636F2D6D6F6E6F73706163652D666F6E74293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C313434363A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A2829';
wwv_flow_imp.g_varchar2_table(2184) := '3D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2185) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F72';
wwv_flow_imp.g_varchar2_table(2186) := '6174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F74';
wwv_flow_imp.g_varchar2_table(2187) := '20666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2188) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E717569636B2D696E7075742D776964676574207B5C6E5C74666F6E742D73697A653A20313370783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D776964676574202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(2189) := '636F2D686967686C6967687465642D6C6162656C202E686967686C696768742C5C6E2E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C6F';
wwv_flow_imp.g_varchar2_table(2190) := '723A20233030363642463B5C6E7D5C6E5C6E2E7673202E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69';
wwv_flow_imp.g_varchar2_table(2191) := '6768742C5C6E2E7673202E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C';
wwv_flow_imp.g_varchar2_table(2192) := '6F723A20233944444446463B5C6E7D5C6E5C6E2E76732D6461726B202E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C696768742C5C6E2E76732D6461726B202E717569';
wwv_flow_imp.g_varchar2_table(2193) := '636B2D696E7075742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C6F723A20233030393766623B5C6E7D5C6E5C6E2E68632D626C61636B202E717569636B2D696E70';
wwv_flow_imp.g_varchar2_table(2194) := '75742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C696768742C5C6E2E68632D626C61636B202E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C';
wwv_flow_imp.g_varchar2_table(2195) := '6162656C202E686967686C69676874207B5C6E5C74636F6C6F723A20234633383531383B5C6E7D5C6E5C6E2E68632D6C69676874202E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E';
wwv_flow_imp.g_varchar2_table(2196) := '686967686C696768742C5C6E2E68632D6C69676874202E717569636B2D696E7075742D776964676574202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C6F723A20233046344138353B5C';
wwv_flow_imp.g_varchar2_table(2197) := '6E7D5C6E5C6E2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C746261636B67726F756E642D636F6C6F723A2072676261283232312C203232312C203232312C20302E34293B5C6E';
wwv_flow_imp.g_varchar2_table(2198) := '5C74626F726465723A20736F6C6964203170782072676261283230342C203230342C203230342C20302E34293B5C6E5C74626F726465722D626F74746F6D2D636F6C6F723A2072676261283138372C203138372C203138372C20302E34293B5C6E5C7462';
wwv_flow_imp.g_varchar2_table(2199) := '6F782D736861646F773A20696E7365742030202D31707820302072676261283138372C203138372C203138372C20302E34293B5C6E5C74636F6C6F723A20233535353B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D6B657962696E6469';
wwv_flow_imp.g_varchar2_table(2200) := '6E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73706172656E743B5C6E5C74626F726465723A20736F6C69642031707820726762283131312C203139352C2032';
wwv_flow_imp.g_varchar2_table(2201) := '3233293B5C6E5C74626F782D736861646F773A206E6F6E653B5C6E5C74636F6C6F723A20236666663B5C6E7D5C6E5C6E2E68632D6C69676874202E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B65';
wwv_flow_imp.g_varchar2_table(2202) := '79207B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73706172656E743B5C6E5C74626F726465723A20736F6C69642031707820233046344138353B5C6E5C74626F782D736861646F773A206E6F6E653B5C6E5C74636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(2203) := '3239323932393B5C6E7D5C6E5C6E2E76732D6461726B202E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C746261636B67726F756E642D636F6C6F723A2072676261283132382C20';
wwv_flow_imp.g_varchar2_table(2204) := '3132382C203132382C20302E3137293B5C6E5C74626F726465723A20736F6C69642031707820726762612835312C2035312C2035312C20302E36293B5C6E5C74626F726465722D626F74746F6D2D636F6C6F723A20726762612836382C2036382C203638';
wwv_flow_imp.g_varchar2_table(2205) := '2C20302E36293B5C6E5C74626F782D736861646F773A20696E7365742030202D317078203020726762612836382C2036382C2036382C20302E36293B5C6E5C74636F6C6F723A20236363633B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C33';
wwv_flow_imp.g_varchar2_table(2206) := '3631343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E7075736828';
wwv_flow_imp.g_varchar2_table(2207) := '5B652E69642C272F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2208) := '2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73';
wwv_flow_imp.g_varchar2_table(2209) := '652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2210) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E5C6E2F2A2044656661756C74207374616E64616C6F6E6520656469746F7220666F6E74';
wwv_flow_imp.g_varchar2_table(2211) := '73202A2F5C6E2E6D6F6E61636F2D656469746F72207B5C6E5C74666F6E742D66616D696C793A202D6170706C652D73797374656D2C20426C696E6B4D616353797374656D466F6E742C20225365676F6520575043222C20225365676F65205549222C2022';
wwv_flow_imp.g_varchar2_table(2212) := '48656C7665746963614E6575652D4C69676874222C2073797374656D2D75692C20225562756E7475222C202244726F69642053616E73222C2073616E732D73657269663B5C6E5C742D2D6D6F6E61636F2D6D6F6E6F73706163652D666F6E743A20225346';
wwv_flow_imp.g_varchar2_table(2213) := '204D6F6E6F222C204D6F6E61636F2C204D656E6C6F2C20436F6E736F6C61732C20225562756E7475204D6F6E6F222C20224C696265726174696F6E204D6F6E6F222C202244656A6156752053616E73204D6F6E6F222C2022436F7572696572204E657722';
wwv_flow_imp.g_varchar2_table(2214) := '2C206D6F6E6F73706163653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D202E616374696F6E2D6D656E752D6974656D3A666F637573202E6163';
wwv_flow_imp.g_varchar2_table(2215) := '74696F6E2D6C6162656C207B5C6E5C747374726F6B652D77696474683A20312E3270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F722E76732D6461726B202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E7665';
wwv_flow_imp.g_varchar2_table(2216) := '72746963616C202E616374696F6E2D6D656E752D6974656D3A666F637573202E616374696F6E2D6C6162656C2C5C6E2E6D6F6E61636F2D656469746F722E68632D626C61636B202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D62';
wwv_flow_imp.g_varchar2_table(2217) := '61722E766572746963616C202E616374696F6E2D6D656E752D6974656D3A666F637573202E616374696F6E2D6C6162656C2C5C6E2E6D6F6E61636F2D656469746F722E68632D6C69676874202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374';
wwv_flow_imp.g_varchar2_table(2218) := '696F6E2D6261722E766572746963616C202E616374696F6E2D6D656E752D6974656D3A666F637573202E616374696F6E2D6C6162656C207B5C6E5C747374726F6B652D77696474683A20312E3270783B5C6E7D5C6E5C6E2E6D6F6E61636F2D686F766572';
wwv_flow_imp.g_varchar2_table(2219) := '2070207B5C6E5C746D617267696E3A20303B5C6E7D5C6E5C6E2F2A205365652068747470733A2F2F6769746875622E636F6D2F6D6963726F736F66742F6D6F6E61636F2D656469746F722F6973737565732F32313638236973737565636F6D6D656E742D';
wwv_flow_imp.g_varchar2_table(2220) := '373830303738363030202A2F5C6E2E6D6F6E61636F2D617269612D636F6E7461696E6572207B5C6E5C74706F736974696F6E3A206162736F6C7574652021696D706F7274616E743B5C6E5C74746F703A20303B202F2A2061766F6964206265696E672070';
wwv_flow_imp.g_varchar2_table(2221) := '6C6163656420756E6465726E656174682061207369626C696E6720656C656D656E74202A2F5C6E5C746865696768743A203170783B5C6E5C7477696474683A203170783B5C6E5C746D617267696E3A202D3170783B5C6E5C746F766572666C6F773A2068';
wwv_flow_imp.g_varchar2_table(2222) := '696464656E3B5C6E5C7470616464696E673A20303B5C6E5C74636C69703A2072656374283170782C203170782C203170782C20317078293B5C6E5C74636C69702D706174683A20696E73657428353025293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469';
wwv_flow_imp.g_varchar2_table(2223) := '746F722C202E6D6F6E61636F2D646966662D656469746F72202E73796E7468657469632D666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F72205B746162696E6465783D2230225D3A666F637573';
wwv_flow_imp.g_varchar2_table(2224) := '2C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F72205B746162696E6465783D222D31225D3A666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F722062';
wwv_flow_imp.g_varchar2_table(2225) := '7574746F6E3A666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F7220696E7075745B747970653D627574746F6E5D3A666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(2226) := '2D646966662D656469746F7220696E7075745B747970653D636865636B626F785D3A666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F7220696E7075745B747970653D7365617263685D3A666F63';
wwv_flow_imp.g_varchar2_table(2227) := '75732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F7220696E7075745B747970653D746578745D3A666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F';
wwv_flow_imp.g_varchar2_table(2228) := '722073656C6563743A666F6375732C5C6E2E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D646966662D656469746F722074657874617265613A666F637573207B5C6E5C746F75746C696E652D77696474683A203170783B5C6E5C746F75746C';
wwv_flow_imp.g_varchar2_table(2229) := '696E652D7374796C653A20736F6C69643B5C6E5C746F75746C696E652D6F66667365743A202D3170783B5C6E5C746F75746C696E652D636F6C6F723A20766172282D2D7673636F64652D666F637573426F72646572293B5C6E5C746F7061636974793A20';
wwv_flow_imp.g_varchar2_table(2230) := '315C6E7D5C6E272C22225D293B636F6E737420613D727D2C363734353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134';
wwv_flow_imp.g_varchar2_table(2231) := '292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C272F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2232) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C696365';
wwv_flow_imp.g_varchar2_table(2233) := '6E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2234) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E616374696F6E2D7769';
wwv_flow_imp.g_varchar2_table(2235) := '64676574207B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C74626F726465722D7261646975733A20303B5C6E5C746D696E2D77696474683A2031363070783B5C6E5C746D61782D77696474683A20383076773B5C6E5C747A2D696E6465783A';
wwv_flow_imp.g_varchar2_table(2236) := '2034303B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C7477696474683A20313030253B5C6E5C74626F726465723A2031707820736F6C696420766172282D2D7673636F64652D656469746F725769646765742D626F72646572292021696D706F';
wwv_flow_imp.g_varchar2_table(2237) := '7274616E743B5C6E5C74626F726465722D7261646975733A203270783B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F725769646765742D6261636B67726F756E64293B5C6E5C74636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(2238) := '766172282D2D7673636F64652D656469746F725769646765742D666F726567726F756E64293B5C6E7D5C6E5C6E2E636F6E746578742D766965772D626C6F636B207B5C6E5C74706F736974696F6E3A2066697865643B5C6E5C74637572736F723A20696E';
wwv_flow_imp.g_varchar2_table(2239) := '697469616C3B5C6E5C746C6566743A20303B5C6E5C74746F703A20303B5C6E5C7477696474683A20313030253B5C6E5C746865696768743A20313030253B5C6E5C747A2D696E6465783A202D313B5C6E7D5C6E5C6E2E636F6E746578742D766965772D70';
wwv_flow_imp.g_varchar2_table(2240) := '6F696E746572426C6F636B207B5C6E5C74706F736974696F6E3A2066697865643B5C6E5C74637572736F723A20696E697469616C3B5C6E5C746C6566743A20303B5C6E5C74746F703A20303B5C6E5C7477696474683A20313030253B5C6E5C7468656967';
wwv_flow_imp.g_varchar2_table(2241) := '68743A20313030253B5C6E5C747A2D696E6465783A20323B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C697374207B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73';
wwv_flow_imp.g_varchar2_table(2242) := '656C6563743A206E6F6E653B5C6E5C74626F726465723A206E6F6E652021696D706F7274616E743B5C6E5C74626F726465722D77696474683A20302021696D706F7274616E743B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(2243) := '2D6C6973743A666F6375733A6265666F7265207B5C6E5C746F75746C696E653A20302021696D706F7274616E743B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D';
wwv_flow_imp.g_varchar2_table(2244) := '656C656D656E74207B5C6E5C746F766572666C6F773A2076697369626C653B5C6E7D5C6E5C6E2F2A2A205374796C657320666F72206561636820726F7720696E20746865206C69737420656C656D656E74202A2A2F5C6E2E616374696F6E2D7769646765';
wwv_flow_imp.g_varchar2_table(2245) := '74202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77207B5C6E5C7470616464696E673A203020313070783B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E5C74637572736F723A20706F696E7465723B5C6E5C';
wwv_flow_imp.g_varchar2_table(2246) := '74746F7563682D616374696F6E3A206E6F6E653B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E616374696F6E2E666F637573';
wwv_flow_imp.g_varchar2_table(2247) := '65643A6E6F74282E6F7074696F6E2D64697361626C656429207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D717569636B496E7075744C6973742D666F6375734261636B67726F756E64292021696D706F7274';
wwv_flow_imp.g_varchar2_table(2248) := '616E743B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D717569636B496E7075744C6973742D666F637573466F726567726F756E64293B5C6E5C746F75746C696E653A2031707820736F6C696420766172282D2D7673636F64652D6D656E75';
wwv_flow_imp.g_varchar2_table(2249) := '2D73656C656374696F6E426F726465722C207472616E73706172656E74293B5C6E5C746F75746C696E652D6F66667365743A202D3170783B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E67726F7570';
wwv_flow_imp.g_varchar2_table(2250) := '2D686561646572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D6465736372697074696F6E466F726567726F756E64292021696D706F7274616E743B5C6E5C74666F6E742D7765696768743A203630303B5C6E7D5C6E5C6E2E61637469';
wwv_flow_imp.g_varchar2_table(2251) := '6F6E2D776964676574202E6D6F6E61636F2D6C697374202E67726F75702D6865616465722C5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C697374202E6F7074696F6E2D64697361626C65642C5C6E2E616374696F6E2D776964676574';
wwv_flow_imp.g_varchar2_table(2252) := '202E6D6F6E61636F2D6C697374202E6F7074696F6E2D64697361626C65643A6265666F72652C5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C697374202E6F7074696F6E2D64697361626C6564202E666F63757365642C5C6E2E616374';
wwv_flow_imp.g_varchar2_table(2253) := '696F6E2D776964676574202E6D6F6E61636F2D6C697374202E6F7074696F6E2D64697361626C6564202E666F63757365643A6265666F7265207B5C6E5C74637572736F723A2064656661756C742021696D706F7274616E743B5C6E5C742D7765626B6974';
wwv_flow_imp.g_varchar2_table(2254) := '2D746F7563682D63616C6C6F75743A206E6F6E653B5C6E5C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E5C74757365722D73656C6563743A206E6F6E653B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73';
wwv_flow_imp.g_varchar2_table(2255) := '706172656E742021696D706F7274616E743B5C6E5C746F75746C696E653A203020736F6C69642021696D706F7274616E743B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E616374696F6E207B5C6E5C';
wwv_flow_imp.g_varchar2_table(2256) := '74646973706C61793A20666C65783B5C6E5C746761703A203670783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E616374696F6E2E6F70';
wwv_flow_imp.g_varchar2_table(2257) := '74696F6E2D64697361626C65642C5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973743A666F637573202E6D6F6E61636F2D6C6973742D726F772E666F63757365642E616374696F6E2E6F7074696F6E2D64697361626C65642C5C6E';
wwv_flow_imp.g_varchar2_table(2258) := '2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E616374696F6E2E6F7074696F6E2D64697361626C6564202E636F6469636F6E2C5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973743A6E6F74282E64';
wwv_flow_imp.g_varchar2_table(2259) := '726F702D746172676574293A6E6F74282E6472616767696E6729202E6D6F6E61636F2D6C6973742D726F773A686F7665723A6E6F74282E73656C6563746564293A6E6F74282E666F6375736564292E6F7074696F6E2D64697361626C6564207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(2260) := '636F6C6F723A20766172282D2D7673636F64652D64697361626C6564466F726567726F756E64293B5C6E7D5C6E5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E616374696F6E3A6E6F74282E6F7074696F6E2D';
wwv_flow_imp.g_varchar2_table(2261) := '64697361626C656429202E636F6469636F6E207B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E616374696F6E202E7469746C65207B5C6E5C74666C65';
wwv_flow_imp.g_varchar2_table(2262) := '783A20313B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E6D6F6E61636F2D6C6973742D726F772E616374696F6E20';
wwv_flow_imp.g_varchar2_table(2263) := '2E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C745C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D6261';
wwv_flow_imp.g_varchar2_table(2264) := '636B67726F756E64293B5C6E5C745C74636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D666F726567726F756E64293B5C6E5C745C74626F726465722D7374796C653A20736F6C69643B5C6E5C745C74626F7264';
wwv_flow_imp.g_varchar2_table(2265) := '65722D77696474683A203170783B5C6E5C745C74626F726465722D7261646975733A203370783B5C6E5C745C74626F726465722D636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D626F72646572293B5C6E5C74';
wwv_flow_imp.g_varchar2_table(2266) := '5C74626F726465722D626F74746F6D2D636F6C6F723A20766172282D2D7673636F64652D6B657962696E64696E674C6162656C2D626F74746F6D426F72646572293B5C6E5C745C74626F782D736861646F773A20696E7365742030202D31707820302076';
wwv_flow_imp.g_varchar2_table(2267) := '6172282D2D7673636F64652D7769646765742D736861646F77293B5C6E7D5C6E5C6E2F2A20416374696F6E20626172202A2F5C6E5C6E2E616374696F6E2D776964676574202E616374696F6E2D7769646765742D616374696F6E2D626172207B5C6E5C74';
wwv_flow_imp.g_varchar2_table(2268) := '6261636B67726F756E642D636F6C6F723A20766172282D2D7673636F64652D656469746F72486F7665725769646765742D7374617475734261724261636B67726F756E64293B5C6E5C74626F726465722D746F703A2031707820736F6C69642076617228';
wwv_flow_imp.g_varchar2_table(2269) := '2D2D7673636F64652D656469746F72486F7665725769646765742D626F72646572293B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E616374696F6E2D7769646765742D616374696F6E2D6261723A3A6265666F7265207B5C6E5C7464697370';
wwv_flow_imp.g_varchar2_table(2270) := '6C61793A20626C6F636B3B5C6E5C74636F6E74656E743A2022223B5C6E5C7477696474683A20313030253B5C6E7D5C6E5C6E2E616374696F6E2D776964676574202E616374696F6E2D7769646765742D616374696F6E2D626172202E616374696F6E732D';
wwv_flow_imp.g_varchar2_table(2271) := '636F6E7461696E6572207B5C6E5C7470616464696E673A2030203870783B5C6E7D5C6E5C6E2E616374696F6E2D7769646765742D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C74636F6C6F723A20766172282D2D7673636F64';
wwv_flow_imp.g_varchar2_table(2272) := '652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C746C696E652D6865696768743A20323270783B5C6E5C7470616464696E673A20303B5C6E5C74706F696E7465722D6576';
wwv_flow_imp.g_varchar2_table(2273) := '656E74733A20616C6C3B5C6E7D5C6E5C6E2E616374696F6E2D7769646765742D616374696F6E2D626172202E616374696F6E2D6974656D207B5C6E5C746D617267696E2D72696768743A20313670783B5C6E5C74706F696E7465722D6576656E74733A20';
wwv_flow_imp.g_varchar2_table(2274) := '6E6F6E653B5C6E7D5C6E5C6E2E616374696F6E2D7769646765742D616374696F6E2D626172202E616374696F6E2D6C6162656C3A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274';
wwv_flow_imp.g_varchar2_table(2275) := '616E743B5C6E7D5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E732D636F6E7461696E65722E686967686C696768742D746F67676C6564202E616374696F6E2D6C6162656C2E636865636B6564207B5C6E5C742F2A20546865';
wwv_flow_imp.g_varchar2_table(2276) := '20696D706F7274616E7420676976657320746869732072756C6520707265636564656E6365206F7665722074686520686F7665722072756C652E202A2F5C6E5C746261636B67726F756E643A20766172282D2D7673636F64652D616374696F6E4261722D';
wwv_flow_imp.g_varchar2_table(2277) := '746F67676C65644261636B67726F756E64292021696D706F7274616E743B5C6E7D5C6E272C22225D293B636F6E737420613D727D2C393035353A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B7661';
wwv_flow_imp.g_varchar2_table(2278) := '7220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2279) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E2041';
wwv_flow_imp.g_varchar2_table(2280) := '6C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963';
wwv_flow_imp.g_varchar2_table(2281) := '656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2282) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E6D656E752D656E747279202E616374696F6E2D6C6162656C2E69636F6E207B5C6E5C7477696474683A20313670783B5C6E';
wwv_flow_imp.g_varchar2_table(2283) := '5C746865696768743A20313670783B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C746261636B67726F756E642D706F736974696F6E3A203530253B5C6E5C746261636B67726F756E642D73697A653A203136';
wwv_flow_imp.g_varchar2_table(2284) := '70783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D64656661756C74207B5C6E5C74646973706C61793A20666C65782021696D706F7274616E743B5C6E5C74666C65782D646972656374696F6E3A20726F773B5C6E5C74626F';
wwv_flow_imp.g_varchar2_table(2285) := '726465722D7261646975733A203570783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D64656661756C74203E202E616374696F6E2D636F6E7461696E6572203E202E616374696F6E2D6C6162656C207B5C6E5C746D61726769';
wwv_flow_imp.g_varchar2_table(2286) := '6E2D72696768743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D64656661756C74203E202E616374696F6E2D636F6E7461696E65722E6D656E752D656E747279203E202E616374696F6E2D6C6162656C2E69636F6E20';
wwv_flow_imp.g_varchar2_table(2287) := '7B5C6E5C7477696474683A20313670783B5C6E5C746865696768743A20313670783B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C746261636B67726F756E642D706F736974696F6E3A203530253B5C6E5C74';
wwv_flow_imp.g_varchar2_table(2288) := '6261636B67726F756E642D73697A653A20313670783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D64656661756C743A686F766572207B5C6E5C746261636B67726F756E642D636F6C6F723A20766172282D2D7673636F6465';
wwv_flow_imp.g_varchar2_table(2289) := '2D746F6F6C6261722D686F7665724261636B67726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D64656661756C74203E202E64726F70646F776E2D616374696F6E2D636F6E7461696E6572203E202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(2290) := '6F2D64726F70646F776E203E202E64726F70646F776E2D6C6162656C202E636F6469636F6E5B636C6173732A3D27636F6469636F6E2D275D207B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C7470616464696E672D6C6566743A203070783B';
wwv_flow_imp.g_varchar2_table(2291) := '5C6E5C7470616464696E672D72696768743A203070783B5C6E5C746C696E652D6865696768743A20313670783B5C6E5C746D617267696E2D6C6566743A202D3370783B5C6E7D5C6E5C6E2E6D6F6E61636F2D64726F70646F776E2D776974682D64656661';
wwv_flow_imp.g_varchar2_table(2292) := '756C74203E202E64726F70646F776E2D616374696F6E2D636F6E7461696E6572203E202E6D6F6E61636F2D64726F70646F776E203E202E64726F70646F776E2D6C6162656C203E202E616374696F6E2D6C6162656C207B5C6E5C74646973706C61793A20';
wwv_flow_imp.g_varchar2_table(2293) := '626C6F636B3B5C6E5C746261636B67726F756E642D73697A653A20313670783B5C6E5C746261636B67726F756E642D706F736974696F6E3A2063656E7465722063656E7465723B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D726570';
wwv_flow_imp.g_varchar2_table(2294) := '6561743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C343634363A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836';
wwv_flow_imp.g_varchar2_table(2295) := '333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2296) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C207269676874732072657365727665642E5C6E202A20204C';
wwv_flow_imp.g_varchar2_table(2297) := '6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2298) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E6D6F6E61636F';
wwv_flow_imp.g_varchar2_table(2299) := '2D6C696E6B207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D746578744C696E6B2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D6C696E6B3A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(2300) := '64652D746578744C696E6B2D616374697665466F726567726F756E64293B5C6E7D5C6E5C6E222C22225D293B636F6E737420613D727D2C373439323A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B';
wwv_flow_imp.g_varchar2_table(2301) := '76617220693D6E2831363031292C6F3D6E2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2302) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E';
wwv_flow_imp.g_varchar2_table(2303) := '20416C6C207269676874732072657365727665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C';
wwv_flow_imp.g_varchar2_table(2304) := '6963656E736520696E666F726D6174696F6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2305) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F5C6E5C6E2E717569636B2D696E7075742D776964676574207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7477696474683A2036303070783B5C6E5C747A2D696E6465783A20323535303B';
wwv_flow_imp.g_varchar2_table(2306) := '5C6E5C746C6566743A203530253B5C6E5C746D617267696E2D6C6566743A202D33303070783B5C6E5C742D7765626B69742D6170702D726567696F6E3A206E6F2D647261673B5C6E5C74626F726465722D7261646975733A203670783B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(2307) := '2E717569636B2D696E7075742D7469746C65626172207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C74626F726465722D7261646975733A20696E68657269743B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(2308) := '717569636B2D696E7075742D6C6566742D616374696F6E2D626172207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D617267696E2D6C6566743A203470783B5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E717569636B2D696E7075742D';
wwv_flow_imp.g_varchar2_table(2309) := '7469746C65207B5C6E5C7470616464696E673A20337078203070783B5C6E5C74746578742D616C69676E3A2063656E7465723B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B';
wwv_flow_imp.g_varchar2_table(2310) := '5C6E7D5C6E5C6E2E717569636B2D696E7075742D72696768742D616374696F6E2D626172207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D617267696E2D72696768743A203470783B5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E7175';
wwv_flow_imp.g_varchar2_table(2311) := '69636B2D696E7075742D72696768742D616374696F6E2D626172203E202E616374696F6E732D636F6E7461696E6572207B5C6E5C746A7573746966792D636F6E74656E743A20666C65782D656E643B5C6E7D5C6E5C6E2E717569636B2D696E7075742D74';
wwv_flow_imp.g_varchar2_table(2312) := '69746C65626172202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6C6162656C2E636F6469636F6E207B5C6E5C746261636B67726F756E642D706F736974696F6E3A2063656E7465723B5C6E5C746261636B67726F756E642D726570';
wwv_flow_imp.g_varchar2_table(2313) := '6561743A206E6F2D7265706561743B5C6E5C7470616464696E673A203270783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6465736372697074696F6E207B5C6E5C746D617267696E3A20367078203670782036707820313170783B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(2314) := '6E2E717569636B2D696E7075742D686561646572202E717569636B2D696E7075742D6465736372697074696F6E207B5C6E5C746D617267696E3A20347078203270783B5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E717569636B2D696E7075742D68';
wwv_flow_imp.g_varchar2_table(2315) := '6561646572207B5C6E5C74646973706C61793A20666C65783B5C6E5C7470616464696E673A203870782036707820327078203670783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D7769646765742E68696464656E2D696E707574202E717569636B';
wwv_flow_imp.g_varchar2_table(2316) := '2D696E7075742D686561646572207B5C6E5C742F2A20726564756365206D617267696E7320616E642070616464696E6773207768656E20696E70757420626F782068696464656E202A2F5C6E5C7470616464696E673A20303B5C6E5C746D617267696E2D';
wwv_flow_imp.g_varchar2_table(2317) := '626F74746F6D3A20303B5C6E7D5C6E5C6E2E717569636B2D696E7075742D616E642D6D657373616765207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D646972656374696F6E3A20636F6C756D6E3B5C6E5C74666C65782D67726F';
wwv_flow_imp.g_varchar2_table(2318) := '773A20313B5C6E5C746D696E2D77696474683A20303B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E7D5C6E5C6E2E717569636B2D696E7075742D636865636B2D616C6C207B5C6E5C74616C69676E2D73656C663A2063656E7465723B5C';
wwv_flow_imp.g_varchar2_table(2319) := '6E5C746D617267696E3A20303B5C6E7D5C6E5C6E2E717569636B2D696E7075742D66696C746572207B5C6E5C74666C65782D67726F773A20313B5C6E5C74646973706C61793A20666C65783B5C6E5C74706F736974696F6E3A2072656C61746976653B5C';
wwv_flow_imp.g_varchar2_table(2320) := '6E7D5C6E5C6E2E717569636B2D696E7075742D626F78207B5C6E5C74666C65782D67726F773A20313B5C6E7D5C6E5C6E2E717569636B2D696E7075742D7769646765742E73686F772D636865636B626F786573202E717569636B2D696E7075742D626F78';
wwv_flow_imp.g_varchar2_table(2321) := '2C5C6E2E717569636B2D696E7075742D7769646765742E73686F772D636865636B626F786573202E717569636B2D696E7075742D6D657373616765207B5C6E5C746D617267696E2D6C6566743A203570783B5C6E7D5C6E5C6E2E717569636B2D696E7075';
wwv_flow_imp.g_varchar2_table(2322) := '742D76697369626C652D636F756E74207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C746C6566743A202D313030303070783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D636F756E74207B5C6E5C74616C69676E2D73656C66';
wwv_flow_imp.g_varchar2_table(2323) := '3A2063656E7465723B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C7472696768743A203470783B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E717569';
wwv_flow_imp.g_varchar2_table(2324) := '636B2D696E7075742D636F756E74202E6D6F6E61636F2D636F756E742D6261646765207B5C6E5C74766572746963616C2D616C69676E3A206D6964646C653B5C6E5C7470616464696E673A20327078203470783B5C6E5C74626F726465722D7261646975';
wwv_flow_imp.g_varchar2_table(2325) := '733A203270783B5C6E5C746D696E2D6865696768743A206175746F3B5C6E5C746C696E652D6865696768743A206E6F726D616C3B5C6E7D5C6E5C6E2E717569636B2D696E7075742D616374696F6E207B5C6E5C746D617267696E2D6C6566743A20367078';
wwv_flow_imp.g_varchar2_table(2326) := '3B5C6E7D5C6E5C6E2E717569636B2D696E7075742D616374696F6E202E6D6F6E61636F2D746578742D627574746F6E207B5C6E5C74666F6E742D73697A653A20313170783B5C6E5C7470616464696E673A2030203670783B5C6E5C74646973706C61793A';
wwv_flow_imp.g_varchar2_table(2327) := '20666C65783B5C6E5C746865696768743A20323570783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6D657373616765207B5C6E5C746D617267696E2D746F703A202D3170783B5C6E5C';
wwv_flow_imp.g_varchar2_table(2328) := '7470616464696E673A203570783B5C6E5C746F766572666C6F772D777261703A20627265616B2D776F72643B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6D657373616765203E202E636F6469636F6E207B5C6E5C746D617267696E3A203020302E';
wwv_flow_imp.g_varchar2_table(2329) := '32656D3B5C6E5C74766572746963616C2D616C69676E3A20746578742D626F74746F6D3B5C6E7D5C6E5C6E2F2A204C696E6B7320696E206465736372697074696F6E7320262076616C69646174696F6E73202A2F5C6E2E717569636B2D696E7075742D6D';
wwv_flow_imp.g_varchar2_table(2330) := '6573736167652061207B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E717569636B2D696E7075742D70726F67726573732E6D6F6E61636F2D70726F67726573732D636F6E7461696E6572207B5C6E5C74706F736974696F6E3A2072';
wwv_flow_imp.g_varchar2_table(2331) := '656C61746976653B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374207B5C6E5C746C696E652D6865696768743A20323270783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D7769646765742E68696464656E2D696E707574202E717569';
wwv_flow_imp.g_varchar2_table(2332) := '636B2D696E7075742D6C697374207B5C6E5C746D617267696E2D746F703A203470783B202F2A20726564756365206D617267696E73207768656E20696E70757420626F782068696464656E202A2F5C6E5C7470616464696E672D626F74746F6D3A203470';
wwv_flow_imp.g_varchar2_table(2333) := '783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C697374207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C746D61782D6865696768743A2063616C63283230202A2032327078293B5C6E5C747061';
wwv_flow_imp.g_varchar2_table(2334) := '6464696E672D626F74746F6D3A203570783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74207B5C6E5C7470616464696E673A20307078203570783B5C6E7D5C6E5C6E2E';
wwv_flow_imp.g_varchar2_table(2335) := '717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E747279207B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74646973706C61';
wwv_flow_imp.g_varchar2_table(2336) := '793A20666C65783B5C6E5C746865696768743A20313030253B5C6E5C7470616464696E673A2030203670783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472792E717569636B2D69';
wwv_flow_imp.g_varchar2_table(2337) := '6E7075742D6C6973742D736570617261746F722D626F72646572207B5C6E5C74626F726465722D746F702D77696474683A203170783B5C6E5C74626F726465722D746F702D7374796C653A20736F6C69643B5C6E7D5C6E5C6E2E717569636B2D696E7075';
wwv_flow_imp.g_varchar2_table(2338) := '742D6C697374202E6D6F6E61636F2D6C6973742D726F77207B5C6E5C74626F726465722D7261646975733A203370783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C6973742D726F775B646174612D696E646578';
wwv_flow_imp.g_varchar2_table(2339) := '3D5C22305C225D202E717569636B2D696E7075742D6C6973742D656E7472792E717569636B2D696E7075742D6C6973742D736570617261746F722D626F72646572207B5C6E5C74626F726465722D746F702D7374796C653A206E6F6E653B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(2340) := '6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D6C6162656C207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74646973706C61793A20666C65783B5C6E5C746865696768743A20313030253B';
wwv_flow_imp.g_varchar2_table(2341) := '5C6E5C74666C65783A20313B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D636865636B626F78207B5C6E5C74616C69676E2D73656C663A2063656E7465723B5C6E5C746D617267696E3A20';
wwv_flow_imp.g_varchar2_table(2342) := '303B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D69636F6E207B5C6E5C746261636B67726F756E642D73697A653A20313670783B5C6E5C746261636B67726F756E642D706F736974696F6E';
wwv_flow_imp.g_varchar2_table(2343) := '3A206C6566742063656E7465723B5C6E5C746261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E5C7470616464696E672D72696768743A203670783B5C6E5C7477696474683A20313670783B5C6E5C746865696768743A203232';
wwv_flow_imp.g_varchar2_table(2344) := '70783B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E71';
wwv_flow_imp.g_varchar2_table(2345) := '7569636B2D696E7075742D6C6973742D726F7773207B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C74746578742D6F766572666C6F773A20656C6C69707369733B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65782D6469';
wwv_flow_imp.g_varchar2_table(2346) := '72656374696F6E3A20636F6C756D6E3B5C6E5C746865696768743A20313030253B5C6E5C74666C65783A20313B5C6E5C746D617267696E2D6C6566743A203570783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D7769646765742E73686F772D6368';
wwv_flow_imp.g_varchar2_table(2347) := '65636B626F786573202E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D726F7773207B5C6E5C746D617267696E2D6C6566743A20313070783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D77696467657420';
wwv_flow_imp.g_varchar2_table(2348) := '2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D636865636B626F78207B5C6E5C74646973706C61793A206E6F6E653B5C6E7D5C6E2E717569636B2D696E7075742D7769646765742E73686F772D636865636B62';
wwv_flow_imp.g_varchar2_table(2349) := '6F786573202E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D636865636B626F78207B5C6E5C74646973706C61793A20696E6C696E653B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569';
wwv_flow_imp.g_varchar2_table(2350) := '636B2D696E7075742D6C6973742D726F7773203E202E717569636B2D696E7075742D6C6973742D726F77207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E717569636B2D';
wwv_flow_imp.g_varchar2_table(2351) := '696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D726F7773203E202E717569636B2D696E7075742D6C6973742D726F77202E6D6F6E61636F2D69636F6E2D6C6162656C2C5C6E2E717569636B2D696E7075742D6C697374202E7175';
wwv_flow_imp.g_varchar2_table(2352) := '69636B2D696E7075742D6C6973742D726F7773203E202E717569636B2D696E7075742D6C6973742D726F77202E6D6F6E61636F2D69636F6E2D6C6162656C202E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572203E202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(2353) := '6F2D69636F6E2D6E616D652D636F6E7461696E6572207B5C6E5C74666C65783A20313B202F2A206D616B652073757265207468652069636F6E206C6162656C2067726F77732077697468696E2074686520726F77202A2F5C6E7D5C6E5C6E2E717569636B';
wwv_flow_imp.g_varchar2_table(2354) := '2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D726F7773203E202E717569636B2D696E7075742D6C6973742D726F77202E636F6469636F6E5B636C6173732A3D27636F6469636F6E2D275D207B5C6E5C74766572746963616C';
wwv_flow_imp.g_varchar2_table(2355) := '2D616C69676E3A20746578742D626F74746F6D3B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D726F7773202E6D6F6E61636F2D686967686C6967687465642D6C6162656C203E207370616E';
wwv_flow_imp.g_varchar2_table(2356) := '207B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E747279202E717569636B2D696E7075742D6C6973742D656E7472792D6B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(2357) := '207B5C6E5C746D617267696E2D72696768743A203870783B202F2A2073657061726174652066726F6D2074686520736570617261746F72206C6162656C206F72207363726F6C6C62617220696620616E79202A2F5C6E7D5C6E5C6E2E717569636B2D696E';
wwv_flow_imp.g_varchar2_table(2358) := '7075742D6C697374202E717569636B2D696E7075742D6C6973742D6C6162656C2D6D657461207B5C6E5C746F7061636974793A20302E373B5C6E5C746C696E652D6865696768743A206E6F726D616C3B5C6E5C74746578742D6F766572666C6F773A2065';
wwv_flow_imp.g_varchar2_table(2359) := '6C6C69707369733B5C6E5C746F766572666C6F773A2068696464656E3B5C6E7D5C6E5C6E2F2A207072657365727665206C6973742D6C696B65207374796C696E6720696E7374656164206F6620747265652D6C696B65207374796C696E67202A2F5C6E2E';
wwv_flow_imp.g_varchar2_table(2360) := '717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F77202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74666F6E742D776569676874';
wwv_flow_imp.g_varchar2_table(2361) := '3A20626F6C643B5C6E5C746261636B67726F756E642D636F6C6F723A20756E7365743B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D6C6973742D686967686C69676874466F726567726F756E64292021696D706F7274616E743B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(2362) := '6E5C6E2F2A207072657365727665206C6973742D6C696B65207374796C696E6720696E7374656164206F6620747265652D6C696B65207374796C696E67202A2F5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C697374202E6D6F';
wwv_flow_imp.g_varchar2_table(2363) := '6E61636F2D6C6973742D726F772E666F6375736564202E6D6F6E61636F2D686967686C6967687465642D6C6162656C202E686967686C69676874207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D6C6973742D666F637573486967686C69';
wwv_flow_imp.g_varchar2_table(2364) := '676874466F726567726F756E64292021696D706F7274616E743B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E747279202E717569636B2D696E7075742D6C6973742D73657061726174';
wwv_flow_imp.g_varchar2_table(2365) := '6F72207B5C6E5C746D617267696E2D72696768743A203470783B202F2A2073657061726174652066726F6D206B657962696E64696E6773206F7220616374696F6E73202A2F5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B';
wwv_flow_imp.g_varchar2_table(2366) := '2D696E7075742D6C6973742D656E7472792D616374696F6E2D626172207B5C6E5C74646973706C61793A20666C65783B5C6E5C74666C65783A20303B5C6E5C746F766572666C6F773A2076697369626C653B5C6E7D5C6E5C6E2E717569636B2D696E7075';
wwv_flow_imp.g_varchar2_table(2367) := '742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472792D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C742F2A5C6E5C74202A2042792064656661756C742C20616374696F6E7320696E2074686520717569';
wwv_flow_imp.g_varchar2_table(2368) := '636B20696E70757420616374696F6E20626172206172652068696464656E5C6E5C74202A20756E74696C20686F7665726564206F766572207468656D206F722073656C65637465642E5C6E5C74202A2F5C6E5C74646973706C61793A206E6F6E653B5C6E';
wwv_flow_imp.g_varchar2_table(2369) := '7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472792D616374696F6E2D626172202E616374696F6E2D6C6162656C2E636F6469636F6E207B5C6E5C746D617267696E2D72696768743A2034';
wwv_flow_imp.g_varchar2_table(2370) := '70783B5C6E5C7470616464696E673A203070782032707820327078203270783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472792D616374696F6E2D626172207B5C6E5C746D6172';
wwv_flow_imp.g_varchar2_table(2371) := '67696E2D746F703A203170783B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472792D616374696F6E2D626172207B5C6E5C746D617267696E2D72696768743A203470783B202F2A20';
wwv_flow_imp.g_varchar2_table(2372) := '73657061726174652066726F6D207363726F6C6C626172202A2F5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E747279202E717569636B2D696E7075742D6C6973742D656E7472792D61';
wwv_flow_imp.g_varchar2_table(2373) := '6374696F6E2D626172202E616374696F6E2D6C6162656C2E616C776179732D76697369626C652C5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472793A686F766572202E717569636B2D696E7075';
wwv_flow_imp.g_varchar2_table(2374) := '742D6C6973742D656E7472792D616374696F6E2D626172202E616374696F6E2D6C6162656C2C5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E7472792E666F6375732D696E73696465202E71756963';
wwv_flow_imp.g_varchar2_table(2375) := '6B2D696E7075742D6C6973742D656E7472792D616374696F6E2D626172202E616374696F6E2D6C6162656C2C5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E717569636B2D696E7075';
wwv_flow_imp.g_varchar2_table(2376) := '742D6C6973742D656E7472792D616374696F6E2D626172202E616374696F6E2D6C6162656C2C5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C6973742D726F772E706173736976652D666F6375736564202E717569636B2D696E';
wwv_flow_imp.g_varchar2_table(2377) := '7075742D6C6973742D656E7472792D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C74646973706C61793A20666C65783B5C6E7D5C6E5C6E2F2A20666F6375736564206974656D7320696E20717569636B207069636B202A2F5C';
wwv_flow_imp.g_varchar2_table(2378) := '6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E6D6F6E61636F2D6B657962696E64696E672D6B65792C5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6C6973742D';
wwv_flow_imp.g_varchar2_table(2379) := '726F772E666F6375736564202E717569636B2D696E7075742D6C6973742D656E747279202E717569636B2D696E7075742D6C6973742D736570617261746F72207B5C6E5C74636F6C6F723A20696E68657269745C6E7D5C6E2E717569636B2D696E707574';
wwv_flow_imp.g_varchar2_table(2380) := '2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374';
wwv_flow_imp.g_varchar2_table(2381) := '202E717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D207B5C6E5C7470616464696E673A20347078203670783B5C6E5C74666F6E742D73697A653A20313270783B5C6E7D5C6E5C6E2F2A20517569636B20696E707574';
wwv_flow_imp.g_varchar2_table(2382) := '20736570617261746F72732061732066756C6C2D726F77206974656D202A2F5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D202E6C6162656C2D6E616D65207B';
wwv_flow_imp.g_varchar2_table(2383) := '5C6E5C74666F6E742D7765696768743A203630303B5C6E7D5C6E5C6E2E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D202E6C6162656C2D6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(2384) := '207B5C6E5C742F2A204F766572726964652064656661756C74206465736372697074696F6E206F70616369747920736F20776520646F6E27742068617665206120636F6E747261737420726174696F2069737375652E202A2F5C6E5C746F706163697479';
wwv_flow_imp.g_varchar2_table(2385) := '3A20312021696D706F7274616E743B5C6E7D5C6E5C6E2F2A204869646520626F72646572207768656E20746865206974656D206265636F6D65732074686520737469636B79206F6E65202A2F5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E';
wwv_flow_imp.g_varchar2_table(2386) := '61636F2D747265652D737469636B792D726F77202E717569636B2D696E7075742D6C6973742D656E7472792E717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D2E717569636B2D696E7075742D6C6973742D73657061';
wwv_flow_imp.g_varchar2_table(2387) := '7261746F722D626F72646572207B5C6E5C74626F726465722D746F702D7374796C653A206E6F6E653B5C6E7D5C6E5C6E2F2A204769766520737469636B7920726F77207468652073616D652070616464696E6720617320746865207363726F6C6C61626C';
wwv_flow_imp.g_varchar2_table(2388) := '65206C697374202A2F5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D747265652D737469636B792D726F77207B5C6E5C7470616464696E673A2030203570783B5C6E7D5C6E5C6E2F2A204869646520746865207477697374696520';
wwv_flow_imp.g_varchar2_table(2389) := '636F6E7461696E65727320736F20746861742074686572652069736E277420626C616E6B20696E64656E74202A2F5C6E2E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D746C2D74776973746965207B5C6E5C74646973706C61793A206E';
wwv_flow_imp.g_varchar2_table(2390) := '6F6E652021696D706F7274616E743B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C333737343A28652C742C6E293D3E7B2275736520737472696374223B6E2E6428742C7B413A28293D3E617D293B76617220693D6E2831363031292C6F3D6E';
wwv_flow_imp.g_varchar2_table(2391) := '2E6E2869292C733D6E2836333134292C723D6E2E6E2873292829286F2829293B722E70757368285B652E69642C222F2A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(2392) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D5C6E202A2020436F7079726967687420286329204D6963726F736F667420436F72706F726174696F6E2E20416C6C20726967687473207265736572';
wwv_flow_imp.g_varchar2_table(2393) := '7665642E5C6E202A20204C6963656E73656420756E64657220746865204D4954204C6963656E73652E20536565204C6963656E73652E74787420696E207468652070726F6A65637420726F6F7420666F72206C6963656E736520696E666F726D6174696F';
wwv_flow_imp.g_varchar2_table(2394) := '6E2E5C6E202A2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2A2F';
wwv_flow_imp.g_varchar2_table(2395) := '5C6E5C6E2E6D6F6E61636F2D656469746F72202E7A6F6E652D776964676574202E636F6469636F6E2E636F6469636F6E2D6572726F722C5C6E2E6D61726B6572732D70616E656C202E6D61726B65722D69636F6E2E6572726F722C202E6D61726B657273';
wwv_flow_imp.g_varchar2_table(2396) := '2D70616E656C202E6D61726B65722D69636F6E202E636F6469636F6E2E636F6469636F6E2D6572726F722C5C6E2E746578742D7365617263682D70726F76696465722D6D65737361676573202E70726F76696465724D657373616765202E636F6469636F';
wwv_flow_imp.g_varchar2_table(2397) := '6E2E636F6469636F6E2D6572726F722C5C6E2E657874656E73696F6E732D766965776C6574203E202E657874656E73696F6E73202E636F6469636F6E2E636F6469636F6E2D6572726F722C5C6E2E657874656E73696F6E2D656469746F72202E636F6469';
wwv_flow_imp.g_varchar2_table(2398) := '636F6E2E636F6469636F6E2D6572726F722C5C6E2E707265666572656E6365732D656469746F72202E636F6469636F6E2E636F6469636F6E2D6572726F72207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D70726F626C656D734572726F';
wwv_flow_imp.g_varchar2_table(2399) := '7249636F6E2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7A6F6E652D776964676574202E636F6469636F6E2E636F6469636F6E2D7761726E696E672C5C6E2E6D61726B6572732D70616E656C202E6D61726B';
wwv_flow_imp.g_varchar2_table(2400) := '65722D69636F6E2E7761726E696E672C202E6D61726B6572732D70616E656C202E6D61726B65722D69636F6E202E636F6469636F6E2E636F6469636F6E2D7761726E696E672C5C6E2E746578742D7365617263682D70726F76696465722D6D6573736167';
wwv_flow_imp.g_varchar2_table(2401) := '6573202E70726F76696465724D657373616765202E636F6469636F6E2E636F6469636F6E2D7761726E696E672C5C6E2E657874656E73696F6E732D766965776C6574203E202E657874656E73696F6E73202E636F6469636F6E2E636F6469636F6E2D7761';
wwv_flow_imp.g_varchar2_table(2402) := '726E696E672C5C6E2E657874656E73696F6E2D656469746F72202E636F6469636F6E2E636F6469636F6E2D7761726E696E672C5C6E2E707265666572656E6365732D656469746F72202E636F6469636F6E2E636F6469636F6E2D7761726E696E67207B5C';
wwv_flow_imp.g_varchar2_table(2403) := '6E5C74636F6C6F723A20766172282D2D7673636F64652D70726F626C656D735761726E696E6749636F6E2D666F726567726F756E64293B5C6E7D5C6E5C6E2E6D6F6E61636F2D656469746F72202E7A6F6E652D776964676574202E636F6469636F6E2E63';
wwv_flow_imp.g_varchar2_table(2404) := '6F6469636F6E2D696E666F2C5C6E2E6D61726B6572732D70616E656C202E6D61726B65722D69636F6E2E696E666F2C202E6D61726B6572732D70616E656C202E6D61726B65722D69636F6E202E636F6469636F6E2E636F6469636F6E2D696E666F2C5C6E';
wwv_flow_imp.g_varchar2_table(2405) := '2E746578742D7365617263682D70726F76696465722D6D65737361676573202E70726F76696465724D657373616765202E636F6469636F6E2E636F6469636F6E2D696E666F2C5C6E2E657874656E73696F6E732D766965776C6574203E202E657874656E';
wwv_flow_imp.g_varchar2_table(2406) := '73696F6E73202E636F6469636F6E2E636F6469636F6E2D696E666F2C5C6E2E657874656E73696F6E2D656469746F72202E636F6469636F6E2E636F6469636F6E2D696E666F2C5C6E2E707265666572656E6365732D656469746F72202E636F6469636F6E';
wwv_flow_imp.g_varchar2_table(2407) := '2E636F6469636F6E2D696E666F207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D70726F626C656D73496E666F49636F6E2D666F726567726F756E64293B5C6E7D5C6E222C22225D293B636F6E737420613D727D2C363331343A653D3E7B';
wwv_flow_imp.g_varchar2_table(2408) := '2275736520737472696374223B652E6578706F7274733D66756E6374696F6E2865297B76617220743D5B5D3B72657475726E20742E746F537472696E673D66756E6374696F6E28297B72657475726E20746869732E6D6170282866756E6374696F6E2874';
wwv_flow_imp.g_varchar2_table(2409) := '297B766172206E3D22222C693D766F69642030213D3D745B355D3B72657475726E20745B345D2626286E2B3D2240737570706F7274732028222E636F6E63617428745B345D2C2229207B2229292C745B325D2626286E2B3D22406D6564696120222E636F';
wwv_flow_imp.g_varchar2_table(2410) := '6E63617428745B325D2C22207B2229292C692626286E2B3D22406C61796572222E636F6E63617428745B355D2E6C656E6774683E303F2220222E636F6E63617428745B355D293A22222C22207B2229292C6E2B3D652874292C692626286E2B3D227D2229';
wwv_flow_imp.g_varchar2_table(2411) := '2C745B325D2626286E2B3D227D22292C745B345D2626286E2B3D227D22292C6E7D29292E6A6F696E282222297D2C742E693D66756E6374696F6E28652C6E2C692C6F2C73297B22737472696E67223D3D747970656F662065262628653D5B5B6E756C6C2C';
wwv_flow_imp.g_varchar2_table(2412) := '652C766F696420305D5D293B76617220723D7B7D3B6966286929666F722876617220613D303B613C746869732E6C656E6774683B612B2B297B766172206C3D746869735B615D5B305D3B6E756C6C213D6C262628725B6C5D3D2130297D666F7228766172';
wwv_flow_imp.g_varchar2_table(2413) := '20633D303B633C652E6C656E6774683B632B2B297B76617220643D5B5D2E636F6E63617428655B635D293B692626725B645B305D5D7C7C28766F69642030213D3D73262628766F696420303D3D3D645B355D7C7C28645B315D3D22406C61796572222E63';
wwv_flow_imp.g_varchar2_table(2414) := '6F6E63617428645B355D2E6C656E6774683E303F2220222E636F6E63617428645B355D293A22222C22207B22292E636F6E63617428645B315D2C227D2229292C645B355D3D73292C6E262628645B325D3F28645B315D3D22406D6564696120222E636F6E';
wwv_flow_imp.g_varchar2_table(2415) := '63617428645B325D2C22207B22292E636F6E63617428645B315D2C227D22292C645B325D3D6E293A645B325D3D6E292C6F262628645B345D3F28645B315D3D2240737570706F7274732028222E636F6E63617428645B345D2C2229207B22292E636F6E63';
wwv_flow_imp.g_varchar2_table(2416) := '617428645B315D2C227D22292C645B345D3D6F293A645B345D3D22222E636F6E636174286F29292C742E70757368286429297D7D2C747D7D2C343431373A653D3E7B2275736520737472696374223B652E6578706F7274733D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(2417) := '74297B72657475726E20747C7C28743D7B7D292C653F28653D537472696E6728652E5F5F65734D6F64756C653F652E64656661756C743A65292C2F5E5B27225D2E2A5B27225D242F2E74657374286529262628653D652E736C69636528312C2D3129292C';
wwv_flow_imp.g_varchar2_table(2418) := '742E68617368262628652B3D742E68617368292C2F5B22272829205C745C6E5D7C28253230292F2E746573742865297C7C742E6E65656451756F7465733F2722272E636F6E63617428652E7265706C616365282F222F672C275C5C2227292E7265706C61';
wwv_flow_imp.g_varchar2_table(2419) := '6365282F5C6E2F672C225C5C6E22292C272227293A65293A657D7D2C313630313A653D3E7B2275736520737472696374223B652E6578706F7274733D66756E6374696F6E2865297B72657475726E20655B315D7D7D2C393532303A28652C742C6E293D3E';
wwv_flow_imp.g_varchar2_table(2420) := '7B2275736520737472696374223B6E2E722874292C6E2E6428742C7B43616E63656C6C6174696F6E546F6B656E536F757263653A28293D3E6961652C456D69747465723A28293D3E6F61652C4B6579436F64653A28293D3E7361652C4B65794D6F643A28';
wwv_flow_imp.g_varchar2_table(2421) := '293D3E7261652C4D61726B657253657665726974793A28293D3E6861652C4D61726B65725461673A28293D3E7561652C506F736974696F6E3A28293D3E6161652C52616E67653A28293D3E6C61652C53656C656374696F6E3A28293D3E6361652C53656C';
wwv_flow_imp.g_varchar2_table(2422) := '656374696F6E446972656374696F6E3A28293D3E6461652C546F6B656E3A28293D3E6761652C5572693A28293D3E7061652C64656661756C743A28293D3E5961652C656469746F723A28293D3E6D61652C6C616E6775616765733A28293D3E6661657D29';
wwv_flow_imp.g_varchar2_table(2423) := '3B76617220693D7B7D3B6E2E722869292C6E2E6428692C7B43616E63656C6C6174696F6E546F6B656E536F757263653A28293D3E6961652C456D69747465723A28293D3E6F61652C4B6579436F64653A28293D3E7361652C4B65794D6F643A28293D3E72';
wwv_flow_imp.g_varchar2_table(2424) := '61652C4D61726B657253657665726974793A28293D3E6861652C4D61726B65725461673A28293D3E7561652C506F736974696F6E3A28293D3E6161652C52616E67653A28293D3E6C61652C53656C656374696F6E3A28293D3E6361652C53656C65637469';
wwv_flow_imp.g_varchar2_table(2425) := '6F6E446972656374696F6E3A28293D3E6461652C546F6B656E3A28293D3E6761652C5572693A28293D3E7061652C656469746F723A28293D3E6D61652C6C616E6775616765733A28293D3E6661657D293B766172206F3D7B7D3B6E2E72286F292C6E2E64';
wwv_flow_imp.g_varchar2_table(2426) := '286F2C7B43616E63656C6C6174696F6E546F6B656E536F757263653A28293D3E6961652C456D69747465723A28293D3E6F61652C4B6579436F64653A28293D3E7361652C4B65794D6F643A28293D3E7261652C4D61726B657253657665726974793A2829';
wwv_flow_imp.g_varchar2_table(2427) := '3D3E6861652C4D61726B65725461673A28293D3E7561652C506F736974696F6E3A28293D3E6161652C52616E67653A28293D3E6C61652C53656C656374696F6E3A28293D3E6361652C53656C656374696F6E446972656374696F6E3A28293D3E6461652C';
wwv_flow_imp.g_varchar2_table(2428) := '546F6B656E3A28293D3E6761652C5572693A28293D3E7061652C64656661756C743A28293D3E5961652C656469746F723A28293D3E6D61652C6C616E6775616765733A28293D3E6661657D293B636F6E737420733D77696E646F773B636C61737320727B';
wwv_flow_imp.g_varchar2_table(2429) := '636F6E7374727563746F7228297B746869732E6D617057696E646F774964546F5A6F6F6D466163746F723D6E6577204D61707D6765745A6F6F6D466163746F722865297B76617220743B72657475726E206E756C6C213D3D28743D746869732E6D617057';
wwv_flow_imp.g_varchar2_table(2430) := '696E646F774964546F5A6F6F6D466163746F722E67657428746869732E67657457696E646F77496428652929292626766F69642030213D3D743F743A317D67657457696E646F7749642865297B72657475726E20652E7673636F646557696E646F774964';
wwv_flow_imp.g_varchar2_table(2431) := '7D7D66756E6374696F6E206128652C742C6E297B22737472696E67223D3D747970656F662074262628743D652E6D617463684D65646961287429292C742E6164644576656E744C697374656E657228226368616E6765222C6E297D722E494E5354414E43';
wwv_flow_imp.g_varchar2_table(2432) := '453D6E657720723B636F6E7374206C3D6E6176696761746F722E757365724167656E742C633D6C2E696E6465784F66282246697265666F7822293E3D302C643D6C2E696E6465784F6628224170706C655765624B697422293E3D302C683D6C2E696E6465';
wwv_flow_imp.g_varchar2_table(2433) := '784F6628224368726F6D6522293E3D302C753D216826266C2E696E6465784F66282253616661726922293E3D302C703D2168262621752626642C673D286C2E696E6465784F662822456C656374726F6E2F22292C6C2E696E6465784F662822416E64726F';
wwv_flow_imp.g_varchar2_table(2434) := '696422293E3D30293B6C6574206D3D21313B6966282266756E6374696F6E223D3D747970656F6620732E6D617463684D65646961297B636F6E737420653D732E6D617463684D65646961282228646973706C61792D6D6F64653A207374616E64616C6F6E';
wwv_flow_imp.g_varchar2_table(2435) := '6529206F722028646973706C61792D6D6F64653A2077696E646F772D636F6E74726F6C732D6F7665726C61792922292C743D732E6D617463684D65646961282228646973706C61792D6D6F64653A2066756C6C73637265656E2922293B6D3D652E6D6174';
wwv_flow_imp.g_varchar2_table(2436) := '636865732C6128732C652C28287B6D6174636865733A657D293D3E7B6D2626742E6D6174636865737C7C286D3D65297D29297D6C657420663D22756E646566696E656422213D747970656F6620646F63756D656E742626646F63756D656E742E6C6F6361';
wwv_flow_imp.g_varchar2_table(2437) := '74696F6E2626646F63756D656E742E6C6F636174696F6E2E686173682E696E6465784F66282270736575646F3D7472756522293E3D303B66756E6374696F6E207628652C74297B6C6574206E3B72657475726E206E3D303D3D3D742E6C656E6774683F65';
wwv_flow_imp.g_varchar2_table(2438) := '3A652E7265706C616365282F5C7B285C642B295C7D2F672C2828652C6E293D3E7B636F6E737420693D6E5B305D2C6F3D745B695D3B6C657420733D653B72657475726E22737472696E67223D3D747970656F66206F3F733D6F3A226E756D62657222213D';
wwv_flow_imp.g_varchar2_table(2439) := '747970656F66206F262622626F6F6C65616E22213D747970656F66206F26266E756C6C213D6F7C7C28733D537472696E67286F29292C737D29292C662626286E3D22EFBCBB222B6E2E7265706C616365282F5B616F7565695D2F672C222426242622292B';
wwv_flow_imp.g_varchar2_table(2440) := '22EFBCBD22292C6E7D66756E6374696F6E206228652C742C2E2E2E6E297B72657475726E207628742C6E297D66756E6374696F6E205F28652C742C2E2E2E6E297B636F6E737420693D7628742C6E293B72657475726E7B76616C75653A692C6F72696769';
wwv_flow_imp.g_varchar2_table(2441) := '6E616C3A697D7D76617220792C773B636F6E737420433D22656E223B6C657420532C782C6B3D21312C453D21312C4C3D21312C443D21312C543D21312C493D21312C4D3D21312C413D21312C4E3D21312C503D21312C4F3D432C523D6E756C6C2C463D6E';
wwv_flow_imp.g_varchar2_table(2442) := '756C6C3B636F6E737420423D676C6F62616C546869733B6C657420563B766F69642030213D3D422E7673636F64652626766F69642030213D3D422E7673636F64652E70726F636573733F563D422E7673636F64652E70726F636573733A22756E64656669';
wwv_flow_imp.g_varchar2_table(2443) := '6E656422213D747970656F662070726F63657373262622737472696E67223D3D747970656F66286E756C6C3D3D3D28793D6E756C6C3D3D3D70726F636573737C7C766F696420303D3D3D70726F636573733F766F696420303A70726F636573732E766572';
wwv_flow_imp.g_varchar2_table(2444) := '73696F6E73297C7C766F696420303D3D3D793F766F696420303A792E6E6F646529262628563D70726F63657373293B636F6E7374207A3D22737472696E67223D3D747970656F66286E756C6C3D3D3D28773D6E756C6C3D3D563F766F696420303A562E76';
wwv_flow_imp.g_varchar2_table(2445) := '657273696F6E73297C7C766F696420303D3D3D773F766F696420303A772E656C656374726F6E292C483D7A26262272656E6465726572223D3D3D286E756C6C3D3D563F766F696420303A562E74797065293B696628226F626A656374223D3D747970656F';
wwv_flow_imp.g_varchar2_table(2446) := '662056297B6B3D2277696E3332223D3D3D562E706C6174666F726D2C453D2264617277696E223D3D3D562E706C6174666F726D2C4C3D226C696E7578223D3D3D562E706C6174666F726D2C443D4C26262121562E656E762E534E415026262121562E656E';
wwv_flow_imp.g_varchar2_table(2447) := '762E534E41505F5245564953494F4E2C4D3D7A2C4E3D2121562E656E762E43497C7C2121562E656E762E4255494C445F415254494641435453544147494E474449524543544F52592C533D432C4F3D433B636F6E737420653D562E656E762E5653434F44';
wwv_flow_imp.g_varchar2_table(2448) := '455F4E4C535F434F4E4649473B69662865297472797B636F6E737420743D4A534F4E2E70617273652865292C6E3D742E617661696C61626C654C616E6775616765735B222A225D3B533D742E6C6F63616C652C523D742E6F734C6F63616C652C4F3D6E7C';
wwv_flow_imp.g_varchar2_table(2449) := '7C432C463D742E5F7472616E736C6174696F6E73436F6E66696746696C657D63617463682865297B7D543D21307D656C7365226F626A65637422213D747970656F66206E6176696761746F727C7C483F636F6E736F6C652E6572726F722822556E61626C';
wwv_flow_imp.g_varchar2_table(2450) := '6520746F207265736F6C766520706C6174666F726D2E22293A28783D6E6176696761746F722E757365724167656E742C6B3D782E696E6465784F66282257696E646F777322293E3D302C453D782E696E6465784F6628224D6163696E746F736822293E3D';
wwv_flow_imp.g_varchar2_table(2451) := '302C413D28782E696E6465784F6628224D6163696E746F736822293E3D307C7C782E696E6465784F6628226950616422293E3D307C7C782E696E6465784F6628226950686F6E6522293E3D3029262621216E6176696761746F722E6D6178546F75636850';
wwv_flow_imp.g_varchar2_table(2452) := '6F696E747326266E6176696761746F722E6D6178546F756368506F696E74733E302C4C3D782E696E6465784F6628224C696E757822293E3D302C503D286E756C6C3D3D783F766F696420303A782E696E6465784F6628224D6F62692229293E3D302C493D';
wwv_flow_imp.g_varchar2_table(2453) := '21302C533D766F6964206228302C225F22297C7C432C4F3D532C523D6E6176696761746F722E6C616E6775616765293B6C657420573D303B453F573D313A6B3F573D333A4C262628573D32293B636F6E7374206A3D6B2C713D452C243D4C2C553D542C4B';
wwv_flow_imp.g_varchar2_table(2454) := '3D492C473D4926262266756E6374696F6E223D3D747970656F6620422E696D706F7274536372697074733F422E6F726967696E3A766F696420302C513D412C593D502C5A3D782C583D4F2C4A3D2266756E6374696F6E223D3D747970656F6620422E706F';
wwv_flow_imp.g_varchar2_table(2455) := '73744D657373616765262621422E696D706F7274536372697074732C65653D2828293D3E7B6966284A297B636F6E737420653D5B5D3B422E6164644576656E744C697374656E657228226D657373616765222C28743D3E7B696628742E64617461262674';
wwv_flow_imp.g_varchar2_table(2456) := '2E646174612E7673636F64655363686564756C654173796E63576F726B29666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B696628692E69643D3D3D742E646174612E7673636F64655363';
wwv_flow_imp.g_varchar2_table(2457) := '686564756C654173796E63576F726B2972657475726E20652E73706C696365286E2C31292C766F696420692E63616C6C6261636B28297D7D29293B6C657420743D303B72657475726E206E3D3E7B636F6E737420693D2B2B743B652E70757368287B6964';
wwv_flow_imp.g_varchar2_table(2458) := '3A692C63616C6C6261636B3A6E7D292C422E706F73744D657373616765287B7673636F64655363686564756C654173796E63576F726B3A697D2C222A22297D7D72657475726E20653D3E73657454696D656F75742865297D2928292C74653D457C7C413F';
wwv_flow_imp.g_varchar2_table(2459) := '323A6B3F313A333B6C6574206E653D21302C69653D21313B66756E6374696F6E206F6528297B696628216965297B69653D21303B636F6E737420653D6E65772055696E743841727261792832293B655B305D3D312C655B315D3D323B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(2460) := '6E65772055696E743136417272617928652E627566666572293B6E653D3531333D3D3D745B305D7D72657475726E206E657D636F6E73742073653D2121285A26265A2E696E6465784F6628224368726F6D6522293E3D30292C72653D2121285A26265A2E';
wwv_flow_imp.g_varchar2_table(2461) := '696E6465784F66282246697265666F7822293E3D30292C61653D21212821736526265A26265A2E696E6465784F66282253616661726922293E3D30292C6C653D2121285A26265A2E696E6465784F6628224564672F22293E3D30292C63653D2121285A26';
wwv_flow_imp.g_varchar2_table(2462) := '265A2E696E6465784F662822416E64726F696422293E3D30292C64653D28557C7C646F63756D656E742E7175657279436F6D6D616E64537570706F727465642626646F63756D656E742E7175657279436F6D6D616E64537570706F727465642822636F70';
wwv_flow_imp.g_varchar2_table(2463) := '7922297C7C6E6176696761746F7226266E6176696761746F722E636C6970626F61726426266E6176696761746F722E636C6970626F6172642E7772697465546578742C557C7C6E6176696761746F7226266E6176696761746F722E636C6970626F617264';
wwv_flow_imp.g_varchar2_table(2464) := '26266E6176696761746F722E636C6970626F6172642E72656164546578742C557C7C6D7C7C6E6176696761746F722E6B6579626F6172642C226F6E746F756368737461727422696E20737C7C6E6176696761746F722E6D6178546F756368506F696E7473';
wwv_flow_imp.g_varchar2_table(2465) := '2C732E506F696E7465724576656E74262628226F6E746F756368737461727422696E20737C7C6E6176696761746F722E6D6178546F756368506F696E74733E3029293B636C6173732068657B636F6E7374727563746F7228297B746869732E5F6B657943';
wwv_flow_imp.g_varchar2_table(2466) := '6F6465546F5374723D5B5D2C746869732E5F737472546F4B6579436F64653D4F626A6563742E637265617465286E756C6C297D646566696E6528652C74297B746869732E5F6B6579436F6465546F5374725B655D3D742C746869732E5F737472546F4B65';
wwv_flow_imp.g_varchar2_table(2467) := '79436F64655B742E746F4C6F7765724361736528295D3D657D6B6579436F6465546F5374722865297B72657475726E20746869732E5F6B6579436F6465546F5374725B655D7D737472546F4B6579436F64652865297B72657475726E20746869732E5F73';
wwv_flow_imp.g_varchar2_table(2468) := '7472546F4B6579436F64655B652E746F4C6F7765724361736528295D7C7C307D7D636F6E73742075653D6E65772068652C70653D6E65772068652C67653D6E65772068652C6D653D6E657720417272617928323330292C66653D7B7D2C76653D5B5D2C62';
wwv_flow_imp.g_varchar2_table(2469) := '653D4F626A6563742E637265617465286E756C6C292C5F653D4F626A6563742E637265617465286E756C6C292C79653D5B5D2C77653D5B5D3B666F72286C657420653D303B653C3D3139333B652B2B2979655B655D3D2D313B666F72286C657420653D30';
wwv_flow_imp.g_varchar2_table(2470) := '3B653C3D3133323B652B2B2977655B655D3D2D313B7661722043653B66756E6374696F6E20536528652C74297B72657475726E28657C2836353533352674293C3C31363E3E3E30293E3E3E307D2166756E6374696F6E28297B636F6E737420653D22222C';
wwv_flow_imp.g_varchar2_table(2471) := '743D5B5B312C302C224E6F6E65222C302C22756E6B6E6F776E222C302C22564B5F554E4B4E4F574E222C652C655D2C5B312C312C224879706572222C302C652C302C652C652C655D2C5B312C322C225375706572222C302C652C302C652C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(2472) := '312C332C22466E222C302C652C302C652C652C655D2C5B312C342C22466E4C6F636B222C302C652C302C652C652C655D2C5B312C352C2253757370656E64222C302C652C302C652C652C655D2C5B312C362C22526573756D65222C302C652C302C652C65';
wwv_flow_imp.g_varchar2_table(2473) := '2C655D2C5B312C372C22547572626F222C302C652C302C652C652C655D2C5B312C382C22536C656570222C302C652C302C22564B5F534C454550222C652C655D2C5B312C392C2257616B655570222C302C652C302C652C652C655D2C5B302C31302C224B';
wwv_flow_imp.g_varchar2_table(2474) := '657941222C33312C2241222C36352C22564B5F41222C652C655D2C5B302C31312C224B657942222C33322C2242222C36362C22564B5F42222C652C655D2C5B302C31322C224B657943222C33332C2243222C36372C22564B5F43222C652C655D2C5B302C';
wwv_flow_imp.g_varchar2_table(2475) := '31332C224B657944222C33342C2244222C36382C22564B5F44222C652C655D2C5B302C31342C224B657945222C33352C2245222C36392C22564B5F45222C652C655D2C5B302C31352C224B657946222C33362C2246222C37302C22564B5F46222C652C65';
wwv_flow_imp.g_varchar2_table(2476) := '5D2C5B302C31362C224B657947222C33372C2247222C37312C22564B5F47222C652C655D2C5B302C31372C224B657948222C33382C2248222C37322C22564B5F48222C652C655D2C5B302C31382C224B657949222C33392C2249222C37332C22564B5F49';
wwv_flow_imp.g_varchar2_table(2477) := '222C652C655D2C5B302C31392C224B65794A222C34302C224A222C37342C22564B5F4A222C652C655D2C5B302C32302C224B65794B222C34312C224B222C37352C22564B5F4B222C652C655D2C5B302C32312C224B65794C222C34322C224C222C37362C';
wwv_flow_imp.g_varchar2_table(2478) := '22564B5F4C222C652C655D2C5B302C32322C224B65794D222C34332C224D222C37372C22564B5F4D222C652C655D2C5B302C32332C224B65794E222C34342C224E222C37382C22564B5F4E222C652C655D2C5B302C32342C224B65794F222C34352C224F';
wwv_flow_imp.g_varchar2_table(2479) := '222C37392C22564B5F4F222C652C655D2C5B302C32352C224B657950222C34362C2250222C38302C22564B5F50222C652C655D2C5B302C32362C224B657951222C34372C2251222C38312C22564B5F51222C652C655D2C5B302C32372C224B657952222C';
wwv_flow_imp.g_varchar2_table(2480) := '34382C2252222C38322C22564B5F52222C652C655D2C5B302C32382C224B657953222C34392C2253222C38332C22564B5F53222C652C655D2C5B302C32392C224B657954222C35302C2254222C38342C22564B5F54222C652C655D2C5B302C33302C224B';
wwv_flow_imp.g_varchar2_table(2481) := '657955222C35312C2255222C38352C22564B5F55222C652C655D2C5B302C33312C224B657956222C35322C2256222C38362C22564B5F56222C652C655D2C5B302C33322C224B657957222C35332C2257222C38372C22564B5F57222C652C655D2C5B302C';
wwv_flow_imp.g_varchar2_table(2482) := '33332C224B657958222C35342C2258222C38382C22564B5F58222C652C655D2C5B302C33342C224B657959222C35352C2259222C38392C22564B5F59222C652C655D2C5B302C33352C224B65795A222C35362C225A222C39302C22564B5F5A222C652C65';
wwv_flow_imp.g_varchar2_table(2483) := '5D2C5B302C33362C22446967697431222C32322C2231222C34392C22564B5F31222C652C655D2C5B302C33372C22446967697432222C32332C2232222C35302C22564B5F32222C652C655D2C5B302C33382C22446967697433222C32342C2233222C3531';
wwv_flow_imp.g_varchar2_table(2484) := '2C22564B5F33222C652C655D2C5B302C33392C22446967697434222C32352C2234222C35322C22564B5F34222C652C655D2C5B302C34302C22446967697435222C32362C2235222C35332C22564B5F35222C652C655D2C5B302C34312C22446967697436';
wwv_flow_imp.g_varchar2_table(2485) := '222C32372C2236222C35342C22564B5F36222C652C655D2C5B302C34322C22446967697437222C32382C2237222C35352C22564B5F37222C652C655D2C5B302C34332C22446967697438222C32392C2238222C35362C22564B5F38222C652C655D2C5B30';
wwv_flow_imp.g_varchar2_table(2486) := '2C34342C22446967697439222C33302C2239222C35372C22564B5F39222C652C655D2C5B302C34352C22446967697430222C32312C2230222C34382C22564B5F30222C652C655D2C5B312C34362C22456E746572222C332C22456E746572222C31332C22';
wwv_flow_imp.g_varchar2_table(2487) := '564B5F52455455524E222C652C655D2C5B312C34372C22457363617065222C392C22457363617065222C32372C22564B5F455343415045222C652C655D2C5B312C34382C224261636B7370616365222C312C224261636B7370616365222C382C22564B5F';
wwv_flow_imp.g_varchar2_table(2488) := '4241434B222C652C655D2C5B312C34392C22546162222C322C22546162222C392C22564B5F544142222C652C655D2C5B312C35302C225370616365222C31302C225370616365222C33322C22564B5F5350414345222C652C655D2C5B302C35312C224D69';
wwv_flow_imp.g_varchar2_table(2489) := '6E7573222C38382C222D222C3138392C22564B5F4F454D5F4D494E5553222C222D222C224F454D5F4D494E5553225D2C5B302C35322C22457175616C222C38362C223D222C3138372C22564B5F4F454D5F504C5553222C223D222C224F454D5F504C5553';
wwv_flow_imp.g_varchar2_table(2490) := '225D2C5B302C35332C22427261636B65744C656674222C39322C225B222C3231392C22564B5F4F454D5F34222C225B222C224F454D5F34225D2C5B302C35342C22427261636B65745269676874222C39342C225D222C3232312C22564B5F4F454D5F3622';
wwv_flow_imp.g_varchar2_table(2491) := '2C225D222C224F454D5F36225D2C5B302C35352C224261636B736C617368222C39332C225C5C222C3232302C22564B5F4F454D5F35222C225C5C222C224F454D5F35225D2C5B302C35362C22496E746C48617368222C302C652C302C652C652C655D2C5B';
wwv_flow_imp.g_varchar2_table(2492) := '302C35372C2253656D69636F6C6F6E222C38352C223B222C3138362C22564B5F4F454D5F31222C223B222C224F454D5F31225D2C5B302C35382C2251756F7465222C39352C2227222C3232322C22564B5F4F454D5F37222C2227222C224F454D5F37225D';
wwv_flow_imp.g_varchar2_table(2493) := '2C5B302C35392C224261636B71756F7465222C39312C2260222C3139322C22564B5F4F454D5F33222C2260222C224F454D5F33225D2C5B302C36302C22436F6D6D61222C38372C222C222C3138382C22564B5F4F454D5F434F4D4D41222C222C222C224F';
wwv_flow_imp.g_varchar2_table(2494) := '454D5F434F4D4D41225D2C5B302C36312C22506572696F64222C38392C222E222C3139302C22564B5F4F454D5F504552494F44222C222E222C224F454D5F504552494F44225D2C5B302C36322C22536C617368222C39302C222F222C3139312C22564B5F';
wwv_flow_imp.g_varchar2_table(2495) := '4F454D5F32222C222F222C224F454D5F32225D2C5B312C36332C22436170734C6F636B222C382C22436170734C6F636B222C32302C22564B5F4341504954414C222C652C655D2C5B312C36342C224631222C35392C224631222C3131322C22564B5F4631';
wwv_flow_imp.g_varchar2_table(2496) := '222C652C655D2C5B312C36352C224632222C36302C224632222C3131332C22564B5F4632222C652C655D2C5B312C36362C224633222C36312C224633222C3131342C22564B5F4633222C652C655D2C5B312C36372C224634222C36322C224634222C3131';
wwv_flow_imp.g_varchar2_table(2497) := '352C22564B5F4634222C652C655D2C5B312C36382C224635222C36332C224635222C3131362C22564B5F4635222C652C655D2C5B312C36392C224636222C36342C224636222C3131372C22564B5F4636222C652C655D2C5B312C37302C224637222C3635';
wwv_flow_imp.g_varchar2_table(2498) := '2C224637222C3131382C22564B5F4637222C652C655D2C5B312C37312C224638222C36362C224638222C3131392C22564B5F4638222C652C655D2C5B312C37322C224639222C36372C224639222C3132302C22564B5F4639222C652C655D2C5B312C3733';
wwv_flow_imp.g_varchar2_table(2499) := '2C22463130222C36382C22463130222C3132312C22564B5F463130222C652C655D2C5B312C37342C22463131222C36392C22463131222C3132322C22564B5F463131222C652C655D2C5B312C37352C22463132222C37302C22463132222C3132332C2256';
wwv_flow_imp.g_varchar2_table(2500) := '4B5F463132222C652C655D2C5B312C37362C225072696E7453637265656E222C302C652C302C652C652C655D2C5B312C37372C225363726F6C6C4C6F636B222C38342C225363726F6C6C4C6F636B222C3134352C22564B5F5343524F4C4C222C652C655D';
wwv_flow_imp.g_varchar2_table(2501) := '2C5B312C37382C225061757365222C372C225061757365427265616B222C31392C22564B5F5041555345222C652C655D2C5B312C37392C22496E73657274222C31392C22496E73657274222C34352C22564B5F494E53455254222C652C655D2C5B312C38';
wwv_flow_imp.g_varchar2_table(2502) := '302C22486F6D65222C31342C22486F6D65222C33362C22564B5F484F4D45222C652C655D2C5B312C38312C22506167655570222C31312C22506167655570222C33332C22564B5F5052494F52222C652C655D2C5B312C38322C2244656C657465222C3230';
wwv_flow_imp.g_varchar2_table(2503) := '2C2244656C657465222C34362C22564B5F44454C455445222C652C655D2C5B312C38332C22456E64222C31332C22456E64222C33352C22564B5F454E44222C652C655D2C5B312C38342C2250616765446F776E222C31322C2250616765446F776E222C33';
wwv_flow_imp.g_varchar2_table(2504) := '342C22564B5F4E455854222C652C655D2C5B312C38352C224172726F775269676874222C31372C2252696768744172726F77222C33392C22564B5F5249474854222C225269676874222C655D2C5B312C38362C224172726F774C656674222C31352C224C';
wwv_flow_imp.g_varchar2_table(2505) := '6566744172726F77222C33372C22564B5F4C454654222C224C656674222C655D2C5B312C38372C224172726F77446F776E222C31382C22446F776E4172726F77222C34302C22564B5F444F574E222C22446F776E222C655D2C5B312C38382C224172726F';
wwv_flow_imp.g_varchar2_table(2506) := '775570222C31362C2255704172726F77222C33382C22564B5F5550222C225570222C655D2C5B312C38392C224E756D4C6F636B222C38332C224E756D4C6F636B222C3134342C22564B5F4E554D4C4F434B222C652C655D2C5B312C39302C224E756D7061';
wwv_flow_imp.g_varchar2_table(2507) := '64446976696465222C3131332C224E756D5061645F446976696465222C3131312C22564B5F444956494445222C652C655D2C5B312C39312C224E756D7061644D756C7469706C79222C3130382C224E756D5061645F4D756C7469706C79222C3130362C22';
wwv_flow_imp.g_varchar2_table(2508) := '564B5F4D554C5449504C59222C652C655D2C5B312C39322C224E756D7061645375627472616374222C3131312C224E756D5061645F5375627472616374222C3130392C22564B5F5355425452414354222C652C655D2C5B312C39332C224E756D70616441';
wwv_flow_imp.g_varchar2_table(2509) := '6464222C3130392C224E756D5061645F416464222C3130372C22564B5F414444222C652C655D2C5B312C39342C224E756D706164456E746572222C332C652C302C652C652C655D2C5B312C39352C224E756D70616431222C39392C224E756D5061643122';
wwv_flow_imp.g_varchar2_table(2510) := '2C39372C22564B5F4E554D50414431222C652C655D2C5B312C39362C224E756D70616432222C3130302C224E756D50616432222C39382C22564B5F4E554D50414432222C652C655D2C5B312C39372C224E756D70616433222C3130312C224E756D506164';
wwv_flow_imp.g_varchar2_table(2511) := '33222C39392C22564B5F4E554D50414433222C652C655D2C5B312C39382C224E756D70616434222C3130322C224E756D50616434222C3130302C22564B5F4E554D50414434222C652C655D2C5B312C39392C224E756D70616435222C3130332C224E756D';
wwv_flow_imp.g_varchar2_table(2512) := '50616435222C3130312C22564B5F4E554D50414435222C652C655D2C5B312C3130302C224E756D70616436222C3130342C224E756D50616436222C3130322C22564B5F4E554D50414436222C652C655D2C5B312C3130312C224E756D70616437222C3130';
wwv_flow_imp.g_varchar2_table(2513) := '352C224E756D50616437222C3130332C22564B5F4E554D50414437222C652C655D2C5B312C3130322C224E756D70616438222C3130362C224E756D50616438222C3130342C22564B5F4E554D50414438222C652C655D2C5B312C3130332C224E756D7061';
wwv_flow_imp.g_varchar2_table(2514) := '6439222C3130372C224E756D50616439222C3130352C22564B5F4E554D50414439222C652C655D2C5B312C3130342C224E756D70616430222C39382C224E756D50616430222C39362C22564B5F4E554D50414430222C652C655D2C5B312C3130352C224E';
wwv_flow_imp.g_varchar2_table(2515) := '756D706164446563696D616C222C3131322C224E756D5061645F446563696D616C222C3131302C22564B5F444543494D414C222C652C655D2C5B302C3130362C22496E746C4261636B736C617368222C39372C224F454D5F313032222C3232362C22564B';
wwv_flow_imp.g_varchar2_table(2516) := '5F4F454D5F313032222C652C655D2C5B312C3130372C22436F6E746578744D656E75222C35382C22436F6E746578744D656E75222C39332C652C652C655D2C5B312C3130382C22506F776572222C302C652C302C652C652C655D2C5B312C3130392C224E';
wwv_flow_imp.g_varchar2_table(2517) := '756D706164457175616C222C302C652C302C652C652C655D2C5B312C3131302C22463133222C37312C22463133222C3132342C22564B5F463133222C652C655D2C5B312C3131312C22463134222C37322C22463134222C3132352C22564B5F463134222C';
wwv_flow_imp.g_varchar2_table(2518) := '652C655D2C5B312C3131322C22463135222C37332C22463135222C3132362C22564B5F463135222C652C655D2C5B312C3131332C22463136222C37342C22463136222C3132372C22564B5F463136222C652C655D2C5B312C3131342C22463137222C3735';
wwv_flow_imp.g_varchar2_table(2519) := '2C22463137222C3132382C22564B5F463137222C652C655D2C5B312C3131352C22463138222C37362C22463138222C3132392C22564B5F463138222C652C655D2C5B312C3131362C22463139222C37372C22463139222C3133302C22564B5F463139222C';
wwv_flow_imp.g_varchar2_table(2520) := '652C655D2C5B312C3131372C22463230222C37382C22463230222C3133312C22564B5F463230222C652C655D2C5B312C3131382C22463231222C37392C22463231222C3133322C22564B5F463231222C652C655D2C5B312C3131392C22463232222C3830';
wwv_flow_imp.g_varchar2_table(2521) := '2C22463232222C3133332C22564B5F463232222C652C655D2C5B312C3132302C22463233222C38312C22463233222C3133342C22564B5F463233222C652C655D2C5B312C3132312C22463234222C38322C22463234222C3133352C22564B5F463234222C';
wwv_flow_imp.g_varchar2_table(2522) := '652C655D2C5B312C3132322C224F70656E222C302C652C302C652C652C655D2C5B312C3132332C2248656C70222C302C652C302C652C652C655D2C5B312C3132342C2253656C656374222C302C652C302C652C652C655D2C5B312C3132352C2241676169';
wwv_flow_imp.g_varchar2_table(2523) := '6E222C302C652C302C652C652C655D2C5B312C3132362C22556E646F222C302C652C302C652C652C655D2C5B312C3132372C22437574222C302C652C302C652C652C655D2C5B312C3132382C22436F7079222C302C652C302C652C652C655D2C5B312C31';
wwv_flow_imp.g_varchar2_table(2524) := '32392C225061737465222C302C652C302C652C652C655D2C5B312C3133302C2246696E64222C302C652C302C652C652C655D2C5B312C3133312C22417564696F566F6C756D654D757465222C3131372C22417564696F566F6C756D654D757465222C3137';
wwv_flow_imp.g_varchar2_table(2525) := '332C22564B5F564F4C554D455F4D555445222C652C655D2C5B312C3133322C22417564696F566F6C756D655570222C3131382C22417564696F566F6C756D655570222C3137352C22564B5F564F4C554D455F5550222C652C655D2C5B312C3133332C2241';
wwv_flow_imp.g_varchar2_table(2526) := '7564696F566F6C756D65446F776E222C3131392C22417564696F566F6C756D65446F776E222C3137342C22564B5F564F4C554D455F444F574E222C652C655D2C5B312C3133342C224E756D706164436F6D6D61222C3131302C224E756D5061645F536570';
wwv_flow_imp.g_varchar2_table(2527) := '617261746F72222C3130382C22564B5F534550415241544F52222C652C655D2C5B302C3133352C22496E746C526F222C3131352C2241424E545F4331222C3139332C22564B5F41424E545F4331222C652C655D2C5B312C3133362C224B616E614D6F6465';
wwv_flow_imp.g_varchar2_table(2528) := '222C302C652C302C652C652C655D2C5B302C3133372C22496E746C59656E222C302C652C302C652C652C655D2C5B312C3133382C22436F6E76657274222C302C652C302C652C652C655D2C5B312C3133392C224E6F6E436F6E76657274222C302C652C30';
wwv_flow_imp.g_varchar2_table(2529) := '2C652C652C655D2C5B312C3134302C224C616E6731222C302C652C302C652C652C655D2C5B312C3134312C224C616E6732222C302C652C302C652C652C655D2C5B312C3134322C224C616E6733222C302C652C302C652C652C655D2C5B312C3134332C22';
wwv_flow_imp.g_varchar2_table(2530) := '4C616E6734222C302C652C302C652C652C655D2C5B312C3134342C224C616E6735222C302C652C302C652C652C655D2C5B312C3134352C2241626F7274222C302C652C302C652C652C655D2C5B312C3134362C2250726F7073222C302C652C302C652C65';
wwv_flow_imp.g_varchar2_table(2531) := '2C655D2C5B312C3134372C224E756D706164506172656E4C656674222C302C652C302C652C652C655D2C5B312C3134382C224E756D706164506172656E5269676874222C302C652C302C652C652C655D2C5B312C3134392C224E756D7061644261636B73';
wwv_flow_imp.g_varchar2_table(2532) := '70616365222C302C652C302C652C652C655D2C5B312C3135302C224E756D7061644D656D6F727953746F7265222C302C652C302C652C652C655D2C5B312C3135312C224E756D7061644D656D6F7279526563616C6C222C302C652C302C652C652C655D2C';
wwv_flow_imp.g_varchar2_table(2533) := '5B312C3135322C224E756D7061644D656D6F7279436C656172222C302C652C302C652C652C655D2C5B312C3135332C224E756D7061644D656D6F7279416464222C302C652C302C652C652C655D2C5B312C3135342C224E756D7061644D656D6F72795375';
wwv_flow_imp.g_varchar2_table(2534) := '627472616374222C302C652C302C652C652C655D2C5B312C3135352C224E756D706164436C656172222C3133312C22436C656172222C31322C22564B5F434C454152222C652C655D2C5B312C3135362C224E756D706164436C656172456E747279222C30';
wwv_flow_imp.g_varchar2_table(2535) := '2C652C302C652C652C655D2C5B312C302C652C352C224374726C222C31372C22564B5F434F4E54524F4C222C652C655D2C5B312C302C652C342C225368696674222C31362C22564B5F5348494654222C652C655D2C5B312C302C652C362C22416C74222C';
wwv_flow_imp.g_varchar2_table(2536) := '31382C22564B5F4D454E55222C652C655D2C5B312C302C652C35372C224D657461222C39312C22564B5F434F4D4D414E44222C652C655D2C5B312C3135372C22436F6E74726F6C4C656674222C352C652C302C22564B5F4C434F4E54524F4C222C652C65';
wwv_flow_imp.g_varchar2_table(2537) := '5D2C5B312C3135382C2253686966744C656674222C342C652C302C22564B5F4C5348494654222C652C655D2C5B312C3135392C22416C744C656674222C362C652C302C22564B5F4C4D454E55222C652C655D2C5B312C3136302C224D6574614C65667422';
wwv_flow_imp.g_varchar2_table(2538) := '2C35372C652C302C22564B5F4C57494E222C652C655D2C5B312C3136312C22436F6E74726F6C5269676874222C352C652C302C22564B5F52434F4E54524F4C222C652C655D2C5B312C3136322C2253686966745269676874222C342C652C302C22564B5F';
wwv_flow_imp.g_varchar2_table(2539) := '525348494654222C652C655D2C5B312C3136332C22416C745269676874222C362C652C302C22564B5F524D454E55222C652C655D2C5B312C3136342C224D6574615269676874222C35372C652C302C22564B5F5257494E222C652C655D2C5B312C313635';
wwv_flow_imp.g_varchar2_table(2540) := '2C224272696768746E6573735570222C302C652C302C652C652C655D2C5B312C3136362C224272696768746E657373446F776E222C302C652C302C652C652C655D2C5B312C3136372C224D65646961506C6179222C302C652C302C652C652C655D2C5B31';
wwv_flow_imp.g_varchar2_table(2541) := '2C3136382C224D656469615265636F7264222C302C652C302C652C652C655D2C5B312C3136392C224D6564696146617374466F7277617264222C302C652C302C652C652C655D2C5B312C3137302C224D65646961526577696E64222C302C652C302C652C';
wwv_flow_imp.g_varchar2_table(2542) := '652C655D2C5B312C3137312C224D65646961547261636B4E657874222C3132342C224D65646961547261636B4E657874222C3137362C22564B5F4D454449415F4E4558545F545241434B222C652C655D2C5B312C3137322C224D65646961547261636B50';
wwv_flow_imp.g_varchar2_table(2543) := '726576696F7573222C3132352C224D65646961547261636B50726576696F7573222C3137372C22564B5F4D454449415F505245565F545241434B222C652C655D2C5B312C3137332C224D6564696153746F70222C3132362C224D6564696153746F70222C';
wwv_flow_imp.g_varchar2_table(2544) := '3137382C22564B5F4D454449415F53544F50222C652C655D2C5B312C3137342C22456A656374222C302C652C302C652C652C655D2C5B312C3137352C224D65646961506C61795061757365222C3132372C224D65646961506C61795061757365222C3137';
wwv_flow_imp.g_varchar2_table(2545) := '392C22564B5F4D454449415F504C41595F5041555345222C652C655D2C5B312C3137362C224D6564696153656C656374222C3132382C224C61756E63684D65646961506C61796572222C3138312C22564B5F4D454449415F4C41554E43485F4D45444941';
wwv_flow_imp.g_varchar2_table(2546) := '5F53454C454354222C652C655D2C5B312C3137372C224C61756E63684D61696C222C3132392C224C61756E63684D61696C222C3138302C22564B5F4D454449415F4C41554E43485F4D41494C222C652C655D2C5B312C3137382C224C61756E6368417070';
wwv_flow_imp.g_varchar2_table(2547) := '32222C3133302C224C61756E636841707032222C3138332C22564B5F4D454449415F4C41554E43485F41505032222C652C655D2C5B312C3137392C224C61756E636841707031222C302C652C302C22564B5F4D454449415F4C41554E43485F4150503122';
wwv_flow_imp.g_varchar2_table(2548) := '2C652C655D2C5B312C3138302C2253656C6563745461736B222C302C652C302C652C652C655D2C5B312C3138312C224C61756E636853637265656E5361766572222C302C652C302C652C652C655D2C5B312C3138322C2242726F77736572536561726368';
wwv_flow_imp.g_varchar2_table(2549) := '222C3132302C2242726F77736572536561726368222C3137302C22564B5F42524F575345525F534541524348222C652C655D2C5B312C3138332C2242726F77736572486F6D65222C3132312C2242726F77736572486F6D65222C3137322C22564B5F4252';
wwv_flow_imp.g_varchar2_table(2550) := '4F575345525F484F4D45222C652C655D2C5B312C3138342C2242726F777365724261636B222C3132322C2242726F777365724261636B222C3136362C22564B5F42524F575345525F4241434B222C652C655D2C5B312C3138352C2242726F77736572466F';
wwv_flow_imp.g_varchar2_table(2551) := '7277617264222C3132332C2242726F77736572466F7277617264222C3136372C22564B5F42524F575345525F464F5257415244222C652C655D2C5B312C3138362C2242726F7773657253746F70222C302C652C302C22564B5F42524F575345525F53544F';
wwv_flow_imp.g_varchar2_table(2552) := '50222C652C655D2C5B312C3138372C2242726F7773657252656672657368222C302C652C302C22564B5F42524F575345525F52454652455348222C652C655D2C5B312C3138382C2242726F777365724661766F7269746573222C302C652C302C22564B5F';
wwv_flow_imp.g_varchar2_table(2553) := '42524F575345525F4641564F5249544553222C652C655D2C5B312C3138392C225A6F6F6D546F67676C65222C302C652C302C652C652C655D2C5B312C3139302C224D61696C5265706C79222C302C652C302C652C652C655D2C5B312C3139312C224D6169';
wwv_flow_imp.g_varchar2_table(2554) := '6C466F7277617264222C302C652C302C652C652C655D2C5B312C3139322C224D61696C53656E64222C302C652C302C652C652C655D2C5B312C302C652C3131342C224B6579496E436F6D706F736974696F6E222C3232392C652C652C655D2C5B312C302C';
wwv_flow_imp.g_varchar2_table(2555) := '652C3131362C2241424E545F4332222C3139342C22564B5F41424E545F4332222C652C655D2C5B312C302C652C39362C224F454D5F38222C3232332C22564B5F4F454D5F38222C652C655D2C5B312C302C652C302C652C302C22564B5F4B414E41222C65';
wwv_flow_imp.g_varchar2_table(2556) := '2C655D2C5B312C302C652C302C652C302C22564B5F48414E47554C222C652C655D2C5B312C302C652C302C652C302C22564B5F4A554E4A41222C652C655D2C5B312C302C652C302C652C302C22564B5F46494E414C222C652C655D2C5B312C302C652C30';
wwv_flow_imp.g_varchar2_table(2557) := '2C652C302C22564B5F48414E4A41222C652C655D2C5B312C302C652C302C652C302C22564B5F4B414E4A49222C652C655D2C5B312C302C652C302C652C302C22564B5F434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F';
wwv_flow_imp.g_varchar2_table(2558) := '4E434F4E56455254222C652C655D2C5B312C302C652C302C652C302C22564B5F414343455054222C652C655D2C5B312C302C652C302C652C302C22564B5F4D4F44454348414E4745222C652C655D2C5B312C302C652C302C652C302C22564B5F53454C45';
wwv_flow_imp.g_varchar2_table(2559) := '4354222C652C655D2C5B312C302C652C302C652C302C22564B5F5052494E54222C652C655D2C5B312C302C652C302C652C302C22564B5F45584543555445222C652C655D2C5B312C302C652C302C652C302C22564B5F534E415053484F54222C652C655D';
wwv_flow_imp.g_varchar2_table(2560) := '2C5B312C302C652C302C652C302C22564B5F48454C50222C652C655D2C5B312C302C652C302C652C302C22564B5F41505053222C652C655D2C5B312C302C652C302C652C302C22564B5F50524F434553534B4559222C652C655D2C5B312C302C652C302C';
wwv_flow_imp.g_varchar2_table(2561) := '652C302C22564B5F5041434B4554222C652C655D2C5B312C302C652C302C652C302C22564B5F4442455F5342435343484152222C652C655D2C5B312C302C652C302C652C302C22564B5F4442455F4442435343484152222C652C655D2C5B312C302C652C';
wwv_flow_imp.g_varchar2_table(2562) := '302C652C302C22564B5F4154544E222C652C655D2C5B312C302C652C302C652C302C22564B5F435253454C222C652C655D2C5B312C302C652C302C652C302C22564B5F455853454C222C652C655D2C5B312C302C652C302C652C302C22564B5F4552454F';
wwv_flow_imp.g_varchar2_table(2563) := '46222C652C655D2C5B312C302C652C302C652C302C22564B5F504C4159222C652C655D2C5B312C302C652C302C652C302C22564B5F5A4F4F4D222C652C655D2C5B312C302C652C302C652C302C22564B5F4E4F4E414D45222C652C655D2C5B312C302C65';
wwv_flow_imp.g_varchar2_table(2564) := '2C302C652C302C22564B5F504131222C652C655D2C5B312C302C652C302C652C302C22564B5F4F454D5F434C454152222C652C655D5D2C6E3D5B5D2C693D5B5D3B666F7228636F6E73742065206F662074297B636F6E73745B742C6F2C732C722C612C6C';
wwv_flow_imp.g_varchar2_table(2565) := '2C632C642C685D3D653B696628695B6F5D7C7C28695B6F5D3D21302C76655B6F5D3D732C62655B735D3D6F2C5F655B732E746F4C6F7765724361736528295D3D6F2C7426262879655B6F5D3D722C30213D3D72262633213D3D72262635213D3D72262634';
wwv_flow_imp.g_varchar2_table(2566) := '213D3D72262636213D3D7226263537213D3D7226262877655B725D3D6F2929292C216E5B725D297B6966286E5B725D3D21302C2161297468726F77206E6577204572726F722860537472696E6720726570726573656E746174696F6E206D697373696E67';
wwv_flow_imp.g_varchar2_table(2567) := '20666F72206B657920636F646520247B727D2061726F756E64207363616E20636F646520247B737D60293B75652E646566696E6528722C61292C70652E646566696E6528722C647C7C61292C67652E646566696E6528722C687C7C647C7C61297D6C2626';
wwv_flow_imp.g_varchar2_table(2568) := '286D655B6C5D3D72292C6326262866655B635D3D72297D77655B335D3D34367D28292C66756E6374696F6E2865297B652E746F537472696E673D66756E6374696F6E2865297B72657475726E2075652E6B6579436F6465546F5374722865297D2C652E66';
wwv_flow_imp.g_varchar2_table(2569) := '726F6D537472696E673D66756E6374696F6E2865297B72657475726E2075652E737472546F4B6579436F64652865297D2C652E746F5573657253657474696E677355533D66756E6374696F6E2865297B72657475726E2070652E6B6579436F6465546F53';
wwv_flow_imp.g_varchar2_table(2570) := '74722865297D2C652E746F5573657253657474696E677347656E6572616C3D66756E6374696F6E2865297B72657475726E2067652E6B6579436F6465546F5374722865297D2C652E66726F6D5573657253657474696E67733D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(2571) := '7B72657475726E2070652E737472546F4B6579436F64652865297C7C67652E737472546F4B6579436F64652865297D2C652E746F456C656374726F6E416363656C657261746F723D66756E6374696F6E2865297B696628653E3D39382626653C3D313133';
wwv_flow_imp.g_varchar2_table(2572) := '2972657475726E206E756C6C3B7377697463682865297B636173652031363A72657475726E225570223B636173652031383A72657475726E22446F776E223B636173652031353A72657475726E224C656674223B636173652031373A72657475726E2252';
wwv_flow_imp.g_varchar2_table(2573) := '69676874227D72657475726E2075652E6B6579436F6465546F5374722865297D7D2843657C7C2843653D7B7D29293B636F6E73742078653D6E657720636C6173737B636F6E7374727563746F7228297B746869732E6C697374656E6572733D5B5D2C7468';
wwv_flow_imp.g_varchar2_table(2574) := '69732E756E65787065637465644572726F7248616E646C65723D66756E6374696F6E2865297B73657454696D656F7574282828293D3E7B696628652E737461636B297B69662850652E69734572726F724E6F54656C656D65747279286529297468726F77';
wwv_flow_imp.g_varchar2_table(2575) := '206E657720506528652E6D6573736167652B225C6E5C6E222B652E737461636B293B7468726F77206E6577204572726F7228652E6D6573736167652B225C6E5C6E222B652E737461636B297D7468726F7720657D292C30297D7D656D69742865297B7468';
wwv_flow_imp.g_varchar2_table(2576) := '69732E6C697374656E6572732E666F72456163682828743D3E7B742865297D29297D6F6E556E65787065637465644572726F722865297B746869732E756E65787065637465644572726F7248616E646C65722865292C746869732E656D69742865297D6F';
wwv_flow_imp.g_varchar2_table(2577) := '6E556E657870656374656445787465726E616C4572726F722865297B746869732E756E65787065637465644572726F7248616E646C65722865297D7D3B66756E6374696F6E206B652865297B54652865297C7C78652E6F6E556E65787065637465644572';
wwv_flow_imp.g_varchar2_table(2578) := '726F722865297D66756E6374696F6E2045652865297B54652865297C7C78652E6F6E556E657870656374656445787465726E616C4572726F722865297D66756E6374696F6E204C652865297B6966286520696E7374616E63656F66204572726F72297B63';
wwv_flow_imp.g_varchar2_table(2579) := '6F6E73747B6E616D653A742C6D6573736167653A6E7D3D653B72657475726E7B2469734572726F723A21302C6E616D653A742C6D6573736167653A6E2C737461636B3A652E737461636B74726163657C7C652E737461636B2C6E6F54656C656D65747279';
wwv_flow_imp.g_varchar2_table(2580) := '3A50652E69734572726F724E6F54656C656D657472792865297D7D72657475726E20657D636F6E73742044653D2243616E63656C6564223B66756E6374696F6E2054652865297B72657475726E206520696E7374616E63656F662049657C7C6520696E73';
wwv_flow_imp.g_varchar2_table(2581) := '74616E63656F66204572726F722626652E6E616D653D3D3D44652626652E6D6573736167653D3D3D44657D636C61737320496520657874656E6473204572726F727B636F6E7374727563746F7228297B7375706572284465292C746869732E6E616D653D';
wwv_flow_imp.g_varchar2_table(2582) := '746869732E6D6573736167657D7D66756E6374696F6E204D652865297B72657475726E20653F6E6577204572726F722860496C6C6567616C20617267756D656E743A20247B657D60293A6E6577204572726F722822496C6C6567616C20617267756D656E';
wwv_flow_imp.g_varchar2_table(2583) := '7422297D66756E6374696F6E2041652865297B72657475726E20653F6E6577204572726F722860496C6C6567616C2073746174653A20247B657D60293A6E6577204572726F722822496C6C6567616C20737461746522297D636C617373204E6520657874';
wwv_flow_imp.g_varchar2_table(2584) := '656E6473204572726F727B636F6E7374727563746F722865297B737570657228224E6F74537570706F7274656422292C65262628746869732E6D6573736167653D65297D7D636C61737320506520657874656E6473204572726F727B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(2585) := '746F722865297B73757065722865292C746869732E6E616D653D22436F646545787065637465644572726F72227D7374617469632066726F6D4572726F722865297B6966286520696E7374616E63656F662050652972657475726E20653B636F6E737420';
wwv_flow_imp.g_varchar2_table(2586) := '743D6E65772050653B72657475726E20742E6D6573736167653D652E6D6573736167652C742E737461636B3D652E737461636B2C747D7374617469632069734572726F724E6F54656C656D657472792865297B72657475726E22436F6465457870656374';
wwv_flow_imp.g_varchar2_table(2587) := '65644572726F72223D3D3D652E6E616D657D7D636C617373204F6520657874656E6473204572726F727B636F6E7374727563746F722865297B737570657228657C7C22416E20756E657870656374656420627567206F636375727265642E22292C4F626A';
wwv_flow_imp.g_varchar2_table(2588) := '6563742E73657450726F746F747970654F6628746869732C4F652E70726F746F74797065297D7D66756E6374696F6E20526528652C74297B696628226E756D626572223D3D747970656F662065297B696628303D3D3D652972657475726E206E756C6C3B';
wwv_flow_imp.g_varchar2_table(2589) := '636F6E7374206E3D2836353533352665293E3E3E302C693D28343239343930313736302665293E3E3E31363B72657475726E206E65772056652830213D3D693F5B4665286E2C74292C466528692C74295D3A5B4665286E2C74295D297D7B636F6E737420';
wwv_flow_imp.g_varchar2_table(2590) := '6E3D5B5D3B666F72286C657420693D303B693C652E6C656E6774683B692B2B296E2E7075736828466528655B695D2C7429293B72657475726E206E6577205665286E297D7D66756E6374696F6E20466528652C74297B636F6E7374206E3D212128323034';
wwv_flow_imp.g_varchar2_table(2591) := '382665292C693D2121283235362665293B72657475726E206E657720426528323D3D3D743F693A6E2C212128313032342665292C2121283531322665292C323D3D3D743F6E3A692C3235352665297D636C6173732042657B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(2592) := '652C742C6E2C692C6F297B746869732E6374726C4B65793D652C746869732E73686966744B65793D742C746869732E616C744B65793D6E2C746869732E6D6574614B65793D692C746869732E6B6579436F64653D6F7D657175616C732865297B72657475';
wwv_flow_imp.g_varchar2_table(2593) := '726E206520696E7374616E63656F662042652626746869732E6374726C4B65793D3D3D652E6374726C4B65792626746869732E73686966744B65793D3D3D652E73686966744B65792626746869732E616C744B65793D3D3D652E616C744B657926267468';
wwv_flow_imp.g_varchar2_table(2594) := '69732E6D6574614B65793D3D3D652E6D6574614B65792626746869732E6B6579436F64653D3D3D652E6B6579436F64657D69734D6F6469666965724B657928297B72657475726E20303D3D3D746869732E6B6579436F64657C7C353D3D3D746869732E6B';
wwv_flow_imp.g_varchar2_table(2595) := '6579436F64657C7C35373D3D3D746869732E6B6579436F64657C7C363D3D3D746869732E6B6579436F64657C7C343D3D3D746869732E6B6579436F64657D69734475706C69636174654D6F6469666965724361736528297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(2596) := '6374726C4B65792626353D3D3D746869732E6B6579436F64657C7C746869732E73686966744B65792626343D3D3D746869732E6B6579436F64657C7C746869732E616C744B65792626363D3D3D746869732E6B6579436F64657C7C746869732E6D657461';
wwv_flow_imp.g_varchar2_table(2597) := '4B6579262635373D3D3D746869732E6B6579436F64657D7D636C6173732056657B636F6E7374727563746F722865297B696628303D3D3D652E6C656E677468297468726F77204D65282263686F72647322293B746869732E63686F7264733D657D7D636C';
wwv_flow_imp.g_varchar2_table(2598) := '617373207A657B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E6374726C4B65793D652C746869732E73686966744B65793D742C746869732E616C744B65793D6E2C746869732E6D6574614B65793D692C746869732E6B6579';
wwv_flow_imp.g_varchar2_table(2599) := '4C6162656C3D6F2C746869732E6B6579417269614C6162656C3D737D7D636C6173732048657B7D636F6E73742057653D713F3235363A323034382C6A653D713F323034383A3235363B636C6173732071657B636F6E7374727563746F722865297B766172';
wwv_flow_imp.g_varchar2_table(2600) := '20743B746869732E5F7374616E646172644B6579626F6172644576656E744272616E643D21303B636F6E7374206E3D653B746869732E62726F777365724576656E743D6E2C746869732E7461726765743D6E2E7461726765742C746869732E6374726C4B';
wwv_flow_imp.g_varchar2_table(2601) := '65793D6E2E6374726C4B65792C746869732E73686966744B65793D6E2E73686966744B65792C746869732E616C744B65793D6E2E616C744B65792C746869732E6D6574614B65793D6E2E6D6574614B65792C746869732E616C7447726170684B65793D6E';
wwv_flow_imp.g_varchar2_table(2602) := '756C6C3D3D3D28743D6E2E6765744D6F6469666965725374617465297C7C766F696420303D3D3D743F766F696420303A742E63616C6C286E2C22416C74477261706822292C746869732E6B6579436F64653D66756E6374696F6E2865297B696628652E63';
wwv_flow_imp.g_varchar2_table(2603) := '686172436F6465297B636F6E737420743D537472696E672E66726F6D43686172436F646528652E63686172436F6465292E746F55707065724361736528293B72657475726E2043652E66726F6D537472696E672874297D636F6E737420743D652E6B6579';
wwv_flow_imp.g_varchar2_table(2604) := '436F64653B696628333D3D3D742972657475726E20373B69662863297377697463682874297B636173652035393A72657475726E2038353B636173652036303A696628242972657475726E2039373B627265616B3B636173652036313A72657475726E20';
wwv_flow_imp.g_varchar2_table(2605) := '38363B63617365203130373A72657475726E203130393B63617365203130393A72657475726E203131313B63617365203137333A72657475726E2038383B63617365203232343A696628712972657475726E2035377D656C73652069662864297B696628';
wwv_flow_imp.g_varchar2_table(2606) := '71262639333D3D3D742972657475726E2035373B6966282171262639323D3D3D742972657475726E2035377D72657475726E206D655B745D7C7C307D286E292C746869732E636F64653D6E2E636F64652C746869732E6374726C4B65793D746869732E63';
wwv_flow_imp.g_varchar2_table(2607) := '74726C4B65797C7C353D3D3D746869732E6B6579436F64652C746869732E616C744B65793D746869732E616C744B65797C7C363D3D3D746869732E6B6579436F64652C746869732E73686966744B65793D746869732E73686966744B65797C7C343D3D3D';
wwv_flow_imp.g_varchar2_table(2608) := '746869732E6B6579436F64652C746869732E6D6574614B65793D746869732E6D6574614B65797C7C35373D3D3D746869732E6B6579436F64652C746869732E5F61734B657962696E64696E673D746869732E5F636F6D707574654B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(2609) := '28292C746869732E5F61734B6579436F646543686F72643D746869732E5F636F6D707574654B6579436F646543686F726428297D70726576656E7444656661756C7428297B746869732E62726F777365724576656E742626746869732E62726F77736572';
wwv_flow_imp.g_varchar2_table(2610) := '4576656E742E70726576656E7444656661756C742626746869732E62726F777365724576656E742E70726576656E7444656661756C7428297D73746F7050726F7061676174696F6E28297B746869732E62726F777365724576656E742626746869732E62';
wwv_flow_imp.g_varchar2_table(2611) := '726F777365724576656E742E73746F7050726F7061676174696F6E2626746869732E62726F777365724576656E742E73746F7050726F7061676174696F6E28297D746F4B6579436F646543686F726428297B72657475726E20746869732E5F61734B6579';
wwv_flow_imp.g_varchar2_table(2612) := '436F646543686F72647D657175616C732865297B72657475726E20746869732E5F61734B657962696E64696E673D3D3D657D5F636F6D707574654B657962696E64696E6728297B6C657420653D303B35213D3D746869732E6B6579436F6465262634213D';
wwv_flow_imp.g_varchar2_table(2613) := '3D746869732E6B6579436F6465262636213D3D746869732E6B6579436F646526263537213D3D746869732E6B6579436F6465262628653D746869732E6B6579436F6465293B6C657420743D303B72657475726E20746869732E6374726C4B657926262874';
wwv_flow_imp.g_varchar2_table(2614) := '7C3D5765292C746869732E616C744B6579262628747C3D353132292C746869732E73686966744B6579262628747C3D31303234292C746869732E6D6574614B6579262628747C3D6A65292C747C3D652C747D5F636F6D707574654B6579436F646543686F';
wwv_flow_imp.g_varchar2_table(2615) := '726428297B6C657420653D303B72657475726E2035213D3D746869732E6B6579436F6465262634213D3D746869732E6B6579436F6465262636213D3D746869732E6B6579436F646526263537213D3D746869732E6B6579436F6465262628653D74686973';
wwv_flow_imp.g_varchar2_table(2616) := '2E6B6579436F6465292C6E657720426528746869732E6374726C4B65792C746869732E73686966744B65792C746869732E616C744B65792C746869732E6D6574614B65792C65297D7D636F6E73742024653D6E6577205765616B4D61703B66756E637469';
wwv_flow_imp.g_varchar2_table(2617) := '6F6E2055652865297B69662821652E706172656E747C7C652E706172656E743D3D3D652972657475726E206E756C6C3B7472797B636F6E737420743D652E6C6F636174696F6E2C6E3D652E706172656E742E6C6F636174696F6E3B696628226E756C6C22';
wwv_flow_imp.g_varchar2_table(2618) := '213D3D742E6F726967696E2626226E756C6C22213D3D6E2E6F726967696E2626742E6F726967696E213D3D6E2E6F726967696E2972657475726E206E756C6C7D63617463682865297B72657475726E206E756C6C7D72657475726E20652E706172656E74';
wwv_flow_imp.g_varchar2_table(2619) := '7D636C617373204B657B7374617469632067657453616D654F726967696E57696E646F77436861696E2865297B6C657420743D24652E6765742865293B6966282174297B743D5B5D2C24652E73657428652C74293B6C6574206E2C693D653B646F7B6E3D';
wwv_flow_imp.g_varchar2_table(2620) := '55652869292C6E3F742E70757368287B77696E646F773A6E6577205765616B5265662869292C696672616D65456C656D656E743A692E6672616D65456C656D656E747C7C6E756C6C7D293A742E70757368287B77696E646F773A6E6577205765616B5265';
wwv_flow_imp.g_varchar2_table(2621) := '662869292C696672616D65456C656D656E743A6E756C6C7D292C693D6E7D7768696C652869297D72657475726E20742E736C6963652830297D73746174696320676574506F736974696F6E4F664368696C6457696E646F7752656C6174697665546F416E';
wwv_flow_imp.g_varchar2_table(2622) := '636573746F7257696E646F7728652C74297B766172206E2C693B69662821747C7C653D3D3D742972657475726E7B746F703A302C6C6566743A307D3B6C6574206F3D302C733D303B636F6E737420723D746869732E67657453616D654F726967696E5769';
wwv_flow_imp.g_varchar2_table(2623) := '6E646F77436861696E2865293B666F7228636F6E73742065206F662072297B636F6E737420723D652E77696E646F772E646572656628293B6966286F2B3D6E756C6C213D3D286E3D6E756C6C3D3D723F766F696420303A722E7363726F6C6C5929262676';
wwv_flow_imp.g_varchar2_table(2624) := '6F69642030213D3D6E3F6E3A302C732B3D6E756C6C213D3D28693D6E756C6C3D3D723F766F696420303A722E7363726F6C6C58292626766F69642030213D3D693F693A302C723D3D3D7429627265616B3B69662821652E696672616D65456C656D656E74';
wwv_flow_imp.g_varchar2_table(2625) := '29627265616B3B636F6E737420613D652E696672616D65456C656D656E742E676574426F756E64696E67436C69656E745265637428293B6F2B3D612E746F702C732B3D612E6C6566747D72657475726E7B746F703A6F2C6C6566743A737D7D7D636C6173';
wwv_flow_imp.g_varchar2_table(2626) := '732047657B636F6E7374727563746F7228652C74297B746869732E74696D657374616D703D446174652E6E6F7728292C746869732E62726F777365724576656E743D742C746869732E6C656674427574746F6E3D303D3D3D742E627574746F6E2C746869';
wwv_flow_imp.g_varchar2_table(2627) := '732E6D6964646C65427574746F6E3D313D3D3D742E627574746F6E2C746869732E7269676874427574746F6E3D323D3D3D742E627574746F6E2C746869732E627574746F6E733D742E627574746F6E732C746869732E7461726765743D742E7461726765';
wwv_flow_imp.g_varchar2_table(2628) := '742C746869732E64657461696C3D742E64657461696C7C7C312C2264626C636C69636B223D3D3D742E74797065262628746869732E64657461696C3D32292C746869732E6374726C4B65793D742E6374726C4B65792C746869732E73686966744B65793D';
wwv_flow_imp.g_varchar2_table(2629) := '742E73686966744B65792C746869732E616C744B65793D742E616C744B65792C746869732E6D6574614B65793D742E6D6574614B65792C226E756D626572223D3D747970656F6620742E70616765583F28746869732E706F73783D742E70616765582C74';
wwv_flow_imp.g_varchar2_table(2630) := '6869732E706F73793D742E7061676559293A28746869732E706F73783D742E636C69656E74582B746869732E7461726765742E6F776E6572446F63756D656E742E626F64792E7363726F6C6C4C6566742B746869732E7461726765742E6F776E6572446F';
wwv_flow_imp.g_varchar2_table(2631) := '63756D656E742E646F63756D656E74456C656D656E742E7363726F6C6C4C6566742C746869732E706F73793D742E636C69656E74592B746869732E7461726765742E6F776E6572446F63756D656E742E626F64792E7363726F6C6C546F702B746869732E';
wwv_flow_imp.g_varchar2_table(2632) := '7461726765742E6F776E6572446F63756D656E742E646F63756D656E74456C656D656E742E7363726F6C6C546F70293B636F6E7374206E3D4B652E676574506F736974696F6E4F664368696C6457696E646F7752656C6174697665546F416E636573746F';
wwv_flow_imp.g_varchar2_table(2633) := '7257696E646F7728652C742E76696577293B746869732E706F73782D3D6E2E6C6566742C746869732E706F73792D3D6E2E746F707D70726576656E7444656661756C7428297B746869732E62726F777365724576656E742E70726576656E744465666175';
wwv_flow_imp.g_varchar2_table(2634) := '6C7428297D73746F7050726F7061676174696F6E28297B746869732E62726F777365724576656E742E73746F7050726F7061676174696F6E28297D7D636C6173732051657B636F6E7374727563746F7228652C743D302C6E3D30297B76617220693B7468';
wwv_flow_imp.g_varchar2_table(2635) := '69732E62726F777365724576656E743D657C7C6E756C6C2C746869732E7461726765743D653F652E7461726765747C7C652E7461726765744E6F64657C7C652E737263456C656D656E743A6E756C6C2C746869732E64656C7461593D6E2C746869732E64';
wwv_flow_imp.g_varchar2_table(2636) := '656C7461583D743B6C6574206F3D21313B69662868297B636F6E737420653D6E6176696761746F722E757365724167656E742E6D61746368282F4368726F6D655C2F285C642B292F293B6F3D28653F7061727365496E7428655B315D293A313233293C3D';
wwv_flow_imp.g_varchar2_table(2637) := '3132327D69662865297B636F6E737420743D652C6E3D652C733D286E756C6C3D3D3D28693D652E76696577297C7C766F696420303D3D3D693F766F696420303A692E646576696365506978656C526174696F297C7C313B696628766F69642030213D3D74';
wwv_flow_imp.g_varchar2_table(2638) := '2E776865656C44656C74615929746869732E64656C7461593D6F3F742E776865656C44656C7461592F283132302A73293A742E776865656C44656C7461592F3132303B656C736520696628766F69642030213D3D6E2E564552544943414C5F4158495326';
wwv_flow_imp.g_varchar2_table(2639) := '266E2E617869733D3D3D6E2E564552544943414C5F4158495329746869732E64656C7461593D2D6E2E64657461696C2F333B656C73652069662822776865656C223D3D3D652E74797065297B636F6E737420743D653B742E64656C74614D6F64653D3D3D';
wwv_flow_imp.g_varchar2_table(2640) := '742E444F4D5F44454C54415F4C494E453F746869732E64656C7461593D63262621713F2D652E64656C7461592F333A2D652E64656C7461593A746869732E64656C7461593D2D652E64656C7461592F34307D696628766F69642030213D3D742E77686565';
wwv_flow_imp.g_varchar2_table(2641) := '6C44656C74615829746869732E64656C7461583D7526266A3F2D742E776865656C44656C7461582F3132303A6F3F742E776865656C44656C7461582F283132302A73293A742E776865656C44656C7461582F3132303B656C736520696628766F69642030';
wwv_flow_imp.g_varchar2_table(2642) := '213D3D6E2E484F52495A4F4E54414C5F4158495326266E2E617869733D3D3D6E2E484F52495A4F4E54414C5F4158495329746869732E64656C7461583D2D652E64657461696C2F333B656C73652069662822776865656C223D3D3D652E74797065297B63';
wwv_flow_imp.g_varchar2_table(2643) := '6F6E737420743D653B742E64656C74614D6F64653D3D3D742E444F4D5F44454C54415F4C494E453F746869732E64656C7461583D63262621713F2D652E64656C7461582F333A2D652E64656C7461583A746869732E64656C7461583D2D652E64656C7461';
wwv_flow_imp.g_varchar2_table(2644) := '582F34307D303D3D3D746869732E64656C7461592626303D3D3D746869732E64656C7461582626652E776865656C44656C7461262628746869732E64656C7461593D6F3F652E776865656C44656C74612F283132302A73293A652E776865656C44656C74';
wwv_flow_imp.g_varchar2_table(2645) := '612F313230297D7D70726576656E7444656661756C7428297B76617220653B6E756C6C3D3D3D28653D746869732E62726F777365724576656E74297C7C766F696420303D3D3D657C7C652E70726576656E7444656661756C7428297D73746F7050726F70';
wwv_flow_imp.g_varchar2_table(2646) := '61676174696F6E28297B76617220653B6E756C6C3D3D3D28653D746869732E62726F777365724576656E74297C7C766F696420303D3D3D657C7C652E73746F7050726F7061676174696F6E28297D7D66756E6374696F6E20596528652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(2647) := '74206E3D746869733B6C657420692C6F3D21313B72657475726E2066756E6374696F6E28297B6966286F2972657475726E20693B6966286F3D21302C74297472797B693D652E6170706C79286E2C617267756D656E7473297D66696E616C6C797B742829';
wwv_flow_imp.g_varchar2_table(2648) := '7D656C736520693D652E6170706C79286E2C617267756D656E7473293B72657475726E20697D7D766172205A653B2166756E6374696F6E2865297B66756E6374696F6E20742865297B72657475726E20652626226F626A656374223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(2649) := '6526262266756E6374696F6E223D3D747970656F6620655B53796D626F6C2E6974657261746F725D7D652E69733D743B636F6E7374206E3D4F626A6563742E667265657A65285B5D293B66756E6374696F6E2A692865297B7969656C6420657D652E656D';
wwv_flow_imp.g_varchar2_table(2650) := '7074793D66756E6374696F6E28297B72657475726E206E7D2C652E73696E676C653D692C652E777261703D66756E6374696F6E2865297B72657475726E20742865293F653A692865297D2C652E66726F6D3D66756E6374696F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(2651) := '20657C7C6E7D2C652E726576657273653D66756E6374696F6E2A2865297B666F72286C657420743D652E6C656E6774682D313B743E3D303B742D2D297969656C6420655B745D7D2C652E6973456D7074793D66756E6374696F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(2652) := '21657C7C21303D3D3D655B53796D626F6C2E6974657261746F725D28292E6E65787428292E646F6E657D2C652E66697273743D66756E6374696F6E2865297B72657475726E20655B53796D626F6C2E6974657261746F725D28292E6E65787428292E7661';
wwv_flow_imp.g_varchar2_table(2653) := '6C75657D2C652E736F6D653D66756E6374696F6E28652C74297B666F7228636F6E7374206E206F6620652969662874286E292972657475726E21303B72657475726E21317D2C652E66696E643D66756E6374696F6E28652C74297B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(2654) := '206E206F6620652969662874286E292972657475726E206E7D2C652E66696C7465723D66756E6374696F6E2A28652C74297B666F7228636F6E7374206E206F6620652974286E292626287969656C64206E297D2C652E6D61703D66756E6374696F6E2A28';
wwv_flow_imp.g_varchar2_table(2655) := '652C74297B6C6574206E3D303B666F7228636F6E73742069206F662065297969656C64207428692C6E2B2B297D2C652E636F6E6361743D66756E6374696F6E2A282E2E2E65297B666F7228636F6E73742074206F662065297969656C642A747D2C652E72';
wwv_flow_imp.g_varchar2_table(2656) := '65647563653D66756E6374696F6E28652C742C6E297B6C657420693D6E3B666F7228636F6E7374206E206F66206529693D7428692C6E293B72657475726E20697D2C652E736C6963653D66756E6374696F6E2A28652C742C6E3D652E6C656E677468297B';
wwv_flow_imp.g_varchar2_table(2657) := '666F7228743C30262628742B3D652E6C656E677468292C6E3C303F6E2B3D652E6C656E6774683A6E3E652E6C656E6774682626286E3D652E6C656E677468293B743C6E3B742B2B297969656C6420655B745D7D2C652E636F6E73756D653D66756E637469';
wwv_flow_imp.g_varchar2_table(2658) := '6F6E28742C6E3D4E756D6265722E504F5349544956455F494E46494E495459297B636F6E737420693D5B5D3B696628303D3D3D6E2972657475726E5B692C745D3B636F6E7374206F3D745B53796D626F6C2E6974657261746F725D28293B666F72286C65';
wwv_flow_imp.g_varchar2_table(2659) := '7420743D303B743C6E3B742B2B297B636F6E737420743D6F2E6E65787428293B696628742E646F6E652972657475726E5B692C652E656D70747928295D3B692E7075736828742E76616C7565297D72657475726E5B692C7B5B53796D626F6C2E69746572';
wwv_flow_imp.g_varchar2_table(2660) := '61746F725D3A28293D3E6F7D5D7D2C652E6173796E63546F41727261793D6173796E632066756E6374696F6E2865297B636F6E737420743D5B5D3B666F7220617761697428636F6E7374206E206F66206529742E70757368286E293B72657475726E2050';
wwv_flow_imp.g_varchar2_table(2661) := '726F6D6973652E7265736F6C76652874297D7D285A657C7C285A653D7B7D29293B6C65742058653D6E756C6C3B66756E6374696F6E204A652865297B72657475726E206E756C6C3D3D58657C7C58652E747261636B446973706F7361626C652865292C65';
wwv_flow_imp.g_varchar2_table(2662) := '7D66756E6374696F6E2065742865297B6E756C6C3D3D58657C7C58652E6D61726B4173446973706F7365642865297D66756E6374696F6E20747428652C74297B6E756C6C3D3D58657C7C58652E736574506172656E7428652C74297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2663) := '206E742865297B72657475726E206E756C6C3D3D58657C7C58652E6D61726B417353696E676C65746F6E2865292C657D66756E6374696F6E2069742865297B72657475726E226F626A656374223D3D747970656F66206526266E756C6C213D3D65262622';
wwv_flow_imp.g_varchar2_table(2664) := '66756E6374696F6E223D3D747970656F6620652E646973706F73652626303D3D3D652E646973706F73652E6C656E6774687D66756E6374696F6E206F742865297B6966285A652E6973286529297B636F6E737420743D5B5D3B666F7228636F6E7374206E';
wwv_flow_imp.g_varchar2_table(2665) := '206F662065296966286E297472797B6E2E646973706F736528297D63617463682865297B742E707573682865297D696628313D3D3D742E6C656E677468297468726F7720745B305D3B696628742E6C656E6774683E31297468726F77206E657720416767';
wwv_flow_imp.g_varchar2_table(2666) := '7265676174654572726F7228742C22456E636F756E7465726564206572726F7273207768696C6520646973706F73696E67206F662073746F726522293B72657475726E2041727261792E697341727261792865293F5B5D3A657D69662865297265747572';
wwv_flow_imp.g_varchar2_table(2667) := '6E20652E646973706F736528292C657D66756E6374696F6E207374282E2E2E65297B636F6E737420743D7274282828293D3E6F7428652929293B72657475726E2066756E6374696F6E28652C74297B696628586529666F7228636F6E7374206E206F6620';
wwv_flow_imp.g_varchar2_table(2668) := '652958652E736574506172656E74286E2C74297D28652C74292C747D66756E6374696F6E2072742865297B636F6E737420743D4A65287B646973706F73653A5965282828293D3E7B65742874292C6528297D29297D293B72657475726E20747D636C6173';
wwv_flow_imp.g_varchar2_table(2669) := '732061747B636F6E7374727563746F7228297B746869732E5F746F446973706F73653D6E6577205365742C746869732E5F6973446973706F7365643D21312C4A652874686973297D646973706F736528297B746869732E5F6973446973706F7365647C7C';
wwv_flow_imp.g_varchar2_table(2670) := '2865742874686973292C746869732E5F6973446973706F7365643D21302C746869732E636C6561722829297D676574206973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D636C65617228297B69662830213D3D';
wwv_flow_imp.g_varchar2_table(2671) := '746869732E5F746F446973706F73652E73697A65297472797B6F7428746869732E5F746F446973706F7365297D66696E616C6C797B746869732E5F746F446973706F73652E636C65617228297D7D6164642865297B69662821652972657475726E20653B';
wwv_flow_imp.g_varchar2_table(2672) := '696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E6F74207265676973746572206120646973706F7361626C65206F6E20697473656C662122293B72657475726E20747428652C74686973292C746869732E5F6973446973';
wwv_flow_imp.g_varchar2_table(2673) := '706F7365643F61742E44495341424C455F444953504F5345445F5741524E494E477C7C636F6E736F6C652E7761726E286E6577204572726F722822547279696E6720746F20616464206120646973706F7361626C6520746F206120446973706F7361626C';
wwv_flow_imp.g_varchar2_table(2674) := '6553746F726520746861742068617320616C7265616479206265656E20646973706F736564206F662E20546865206164646564206F626A6563742077696C6C206265206C65616B65642122292E737461636B293A746869732E5F746F446973706F73652E';
wwv_flow_imp.g_varchar2_table(2675) := '6164642865292C657D64656C657465416E644C65616B2865297B652626746869732E5F746F446973706F73652E686173286529262628746869732E5F746F446973706F73652E64656C6574652865292C747428652C6E756C6C29297D7D61742E44495341';
wwv_flow_imp.g_varchar2_table(2676) := '424C455F444953504F5345445F5741524E494E473D21313B636C617373206C747B636F6E7374727563746F7228297B746869732E5F73746F72653D6E65772061742C4A652874686973292C747428746869732E5F73746F72652C74686973297D64697370';
wwv_flow_imp.g_varchar2_table(2677) := '6F736528297B65742874686973292C746869732E5F73746F72652E646973706F736528297D5F72656769737465722865297B696628653D3D3D74686973297468726F77206E6577204572726F72282243616E6E6F74207265676973746572206120646973';
wwv_flow_imp.g_varchar2_table(2678) := '706F7361626C65206F6E20697473656C662122293B72657475726E20746869732E5F73746F72652E6164642865297D7D6C742E4E6F6E653D4F626A6563742E667265657A65287B646973706F736528297B7D7D293B636C6173732063747B636F6E737472';
wwv_flow_imp.g_varchar2_table(2679) := '7563746F7228297B746869732E5F6973446973706F7365643D21312C4A652874686973297D6765742076616C756528297B72657475726E20746869732E5F6973446973706F7365643F766F696420303A746869732E5F76616C75657D7365742076616C75';
wwv_flow_imp.g_varchar2_table(2680) := '652865297B76617220743B746869732E5F6973446973706F7365647C7C653D3D3D746869732E5F76616C75657C7C286E756C6C3D3D3D28743D746869732E5F76616C7565297C7C766F696420303D3D3D747C7C742E646973706F736528292C6526267474';
wwv_flow_imp.g_varchar2_table(2681) := '28652C74686973292C746869732E5F76616C75653D65297D636C65617228297B746869732E76616C75653D766F696420307D646973706F736528297B76617220653B746869732E5F6973446973706F7365643D21302C65742874686973292C6E756C6C3D';
wwv_flow_imp.g_varchar2_table(2682) := '3D3D28653D746869732E5F76616C7565297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F76616C75653D766F696420307D7D636C6173732064747B636F6E7374727563746F722865297B746869732E5F646973706F7361';
wwv_flow_imp.g_varchar2_table(2683) := '626C653D652C746869732E5F636F756E7465723D317D6163717569726528297B72657475726E20746869732E5F636F756E7465722B2B2C746869737D72656C6561736528297B72657475726E20303D3D2D2D746869732E5F636F756E7465722626746869';
wwv_flow_imp.g_varchar2_table(2684) := '732E5F646973706F7361626C652E646973706F736528292C746869737D7D636C6173732068747B636F6E7374727563746F722865297B746869732E6F626A6563743D657D646973706F736528297B7D7D636C6173732075747B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(2685) := '28297B746869732E5F73746F72653D6E6577204D61702C746869732E5F6973446973706F7365643D21312C4A652874686973297D646973706F736528297B65742874686973292C746869732E5F6973446973706F7365643D21302C746869732E636C6561';
wwv_flow_imp.g_varchar2_table(2686) := '72416E64446973706F7365416C6C28297D636C656172416E64446973706F7365416C6C28297B696628746869732E5F73746F72652E73697A65297472797B6F7428746869732E5F73746F72652E76616C7565732829297D66696E616C6C797B746869732E';
wwv_flow_imp.g_varchar2_table(2687) := '5F73746F72652E636C65617228297D7D6765742865297B72657475726E20746869732E5F73746F72652E6765742865297D73657428652C742C6E3D2131297B76617220693B746869732E5F6973446973706F7365642626636F6E736F6C652E7761726E28';
wwv_flow_imp.g_varchar2_table(2688) := '6E6577204572726F722822547279696E6720746F20616464206120646973706F7361626C6520746F206120446973706F7361626C654D617020746861742068617320616C7265616479206265656E20646973706F736564206F662E205468652061646465';
wwv_flow_imp.g_varchar2_table(2689) := '64206F626A6563742077696C6C206265206C65616B65642122292E737461636B292C6E7C7C6E756C6C3D3D3D28693D746869732E5F73746F72652E676574286529297C7C766F696420303D3D3D697C7C692E646973706F736528292C746869732E5F7374';
wwv_flow_imp.g_varchar2_table(2690) := '6F72652E73657428652C74297D64656C657465416E64446973706F73652865297B76617220743B6E756C6C3D3D3D28743D746869732E5F73746F72652E676574286529297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E5F';
wwv_flow_imp.g_varchar2_table(2691) := '73746F72652E64656C6574652865297D5B53796D626F6C2E6974657261746F725D28297B72657475726E20746869732E5F73746F72655B53796D626F6C2E6974657261746F725D28297D7D636C6173732070747B636F6E7374727563746F722865297B74';
wwv_flow_imp.g_varchar2_table(2692) := '6869732E656C656D656E743D652C746869732E6E6578743D70742E556E646566696E65642C746869732E707265763D70742E556E646566696E65647D7D70742E556E646566696E65643D6E657720707428766F69642030293B636C6173732067747B636F';
wwv_flow_imp.g_varchar2_table(2693) := '6E7374727563746F7228297B746869732E5F66697273743D70742E556E646566696E65642C746869732E5F6C6173743D70742E556E646566696E65642C746869732E5F73697A653D307D6765742073697A6528297B72657475726E20746869732E5F7369';
wwv_flow_imp.g_varchar2_table(2694) := '7A657D6973456D70747928297B72657475726E20746869732E5F66697273743D3D3D70742E556E646566696E65647D636C65617228297B6C657420653D746869732E5F66697273743B666F72283B65213D3D70742E556E646566696E65643B297B636F6E';
wwv_flow_imp.g_varchar2_table(2695) := '737420743D652E6E6578743B652E707265763D70742E556E646566696E65642C652E6E6578743D70742E556E646566696E65642C653D747D746869732E5F66697273743D70742E556E646566696E65642C746869732E5F6C6173743D70742E556E646566';
wwv_flow_imp.g_varchar2_table(2696) := '696E65642C746869732E5F73697A653D307D756E73686966742865297B72657475726E20746869732E5F696E7365727428652C2131297D707573682865297B72657475726E20746869732E5F696E7365727428652C2130297D5F696E7365727428652C74';
wwv_flow_imp.g_varchar2_table(2697) := '297B636F6E7374206E3D6E65772070742865293B696628746869732E5F66697273743D3D3D70742E556E646566696E656429746869732E5F66697273743D6E2C746869732E5F6C6173743D6E3B656C73652069662874297B636F6E737420653D74686973';
wwv_flow_imp.g_varchar2_table(2698) := '2E5F6C6173743B746869732E5F6C6173743D6E2C6E2E707265763D652C652E6E6578743D6E7D656C73657B636F6E737420653D746869732E5F66697273743B746869732E5F66697273743D6E2C6E2E6E6578743D652C652E707265763D6E7D746869732E';
wwv_flow_imp.g_varchar2_table(2699) := '5F73697A652B3D313B6C657420693D21313B72657475726E28293D3E7B697C7C28693D21302C746869732E5F72656D6F7665286E29297D7D736869667428297B696628746869732E5F6669727374213D3D70742E556E646566696E6564297B636F6E7374';
wwv_flow_imp.g_varchar2_table(2700) := '20653D746869732E5F66697273742E656C656D656E743B72657475726E20746869732E5F72656D6F766528746869732E5F6669727374292C657D7D706F7028297B696628746869732E5F6C617374213D3D70742E556E646566696E6564297B636F6E7374';
wwv_flow_imp.g_varchar2_table(2701) := '20653D746869732E5F6C6173742E656C656D656E743B72657475726E20746869732E5F72656D6F766528746869732E5F6C617374292C657D7D5F72656D6F76652865297B696628652E70726576213D3D70742E556E646566696E65642626652E6E657874';
wwv_flow_imp.g_varchar2_table(2702) := '213D3D70742E556E646566696E6564297B636F6E737420743D652E707265763B742E6E6578743D652E6E6578742C652E6E6578742E707265763D747D656C736520652E707265763D3D3D70742E556E646566696E65642626652E6E6578743D3D3D70742E';
wwv_flow_imp.g_varchar2_table(2703) := '556E646566696E65643F28746869732E5F66697273743D70742E556E646566696E65642C746869732E5F6C6173743D70742E556E646566696E6564293A652E6E6578743D3D3D70742E556E646566696E65643F28746869732E5F6C6173743D746869732E';
wwv_flow_imp.g_varchar2_table(2704) := '5F6C6173742E707265762C746869732E5F6C6173742E6E6578743D70742E556E646566696E6564293A652E707265763D3D3D70742E556E646566696E6564262628746869732E5F66697273743D746869732E5F66697273742E6E6578742C746869732E5F';
wwv_flow_imp.g_varchar2_table(2705) := '66697273742E707265763D70742E556E646566696E6564293B746869732E5F73697A652D3D317D2A5B53796D626F6C2E6974657261746F725D28297B6C657420653D746869732E5F66697273743B666F72283B65213D3D70742E556E646566696E65643B';
wwv_flow_imp.g_varchar2_table(2706) := '297969656C6420652E656C656D656E742C653D652E6E6578747D7D636F6E7374206D743D676C6F62616C546869732E706572666F726D616E636526262266756E6374696F6E223D3D747970656F6620676C6F62616C546869732E706572666F726D616E63';
wwv_flow_imp.g_varchar2_table(2707) := '652E6E6F773B636C6173732066747B737461746963206372656174652865297B72657475726E206E65772066742865297D636F6E7374727563746F722865297B746869732E5F6E6F773D6D74262621313D3D3D653F446174652E6E6F773A676C6F62616C';
wwv_flow_imp.g_varchar2_table(2708) := '546869732E706572666F726D616E63652E6E6F772E62696E6428676C6F62616C546869732E706572666F726D616E6365292C746869732E5F737461727454696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D73746F70';
wwv_flow_imp.g_varchar2_table(2709) := '28297B746869732E5F73746F7054696D653D746869732E5F6E6F7728297D726573657428297B746869732E5F737461727454696D653D746869732E5F6E6F7728292C746869732E5F73746F7054696D653D2D317D656C617073656428297B72657475726E';
wwv_flow_imp.g_varchar2_table(2710) := '2D31213D3D746869732E5F73746F7054696D653F746869732E5F73746F7054696D652D746869732E5F737461727454696D653A746869732E5F6E6F7728292D746869732E5F737461727454696D657D7D7661722076743B2166756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(2711) := '66756E6374696F6E20742865297B72657475726E28742C6E3D6E756C6C2C69293D3E7B6C6574206F2C733D21313B72657475726E206F3D652828653D3E7B69662821732972657475726E206F3F6F2E646973706F736528293A733D21302C742E63616C6C';
wwv_flow_imp.g_varchar2_table(2712) := '286E2C65297D292C6E756C6C2C69292C7326266F2E646973706F736528292C6F7D7D66756E6374696F6E206E28652C742C6E297B72657475726E206F2828286E2C693D6E756C6C2C6F293D3E652828653D3E6E2E63616C6C28692C7428652929292C6E75';
wwv_flow_imp.g_varchar2_table(2713) := '6C6C2C6F29292C6E297D66756E6374696F6E206928652C742C6E297B72657475726E206F2828286E2C693D6E756C6C2C6F293D3E652828653D3E7428652926266E2E63616C6C28692C6529292C6E756C6C2C6F29292C6E297D66756E6374696F6E206F28';
wwv_flow_imp.g_varchar2_table(2714) := '652C74297B6C6574206E3B636F6E737420693D6E6577204374287B6F6E57696C6C41646446697273744C697374656E657228297B6E3D6528692E666972652C69297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B6E756C6C3D3D6E';
wwv_flow_imp.g_varchar2_table(2715) := '7C7C6E2E646973706F736528297D7D293B72657475726E206E756C6C3D3D747C7C742E6164642869292C692E6576656E747D66756E6374696F6E207328652C742C6E3D3130302C693D21312C6F3D21312C732C72297B6C657420612C6C2C632C642C683D';
wwv_flow_imp.g_varchar2_table(2716) := '303B636F6E737420753D6E6577204374287B6C65616B5761726E696E675468726573686F6C643A732C6F6E57696C6C41646446697273744C697374656E657228297B613D652828653D3E7B682B2B2C6C3D74286C2C65292C6926262163262628752E6669';
wwv_flow_imp.g_varchar2_table(2717) := '7265286C292C6C3D766F69642030292C643D28293D3E7B636F6E737420653D6C3B6C3D766F696420302C633D766F696420302C2821697C7C683E31292626752E666972652865292C683D307D2C226E756D626572223D3D747970656F66206E3F28636C65';
wwv_flow_imp.g_varchar2_table(2718) := '617254696D656F75742863292C633D73657454696D656F757428642C6E29293A766F696420303D3D3D63262628633D302C71756575654D6963726F7461736B286429297D29297D2C6F6E57696C6C52656D6F76654C697374656E657228297B6F2626683E';
wwv_flow_imp.g_varchar2_table(2719) := '302626286E756C6C3D3D647C7C642829297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B643D766F696420302C612E646973706F736528297D7D293B72657475726E206E756C6C3D3D727C7C722E6164642875292C752E6576656E';
wwv_flow_imp.g_varchar2_table(2720) := '747D652E4E6F6E653D28293D3E6C742E4E6F6E652C652E64656665723D66756E6374696F6E28652C74297B72657475726E207328652C2828293D3E7B7D292C302C766F696420302C21302C766F696420302C74297D2C652E6F6E63653D742C652E6D6170';
wwv_flow_imp.g_varchar2_table(2721) := '3D6E2C652E666F72456163683D66756E6374696F6E28652C742C6E297B72657475726E206F2828286E2C693D6E756C6C2C6F293D3E652828653D3E7B742865292C6E2E63616C6C28692C65297D292C6E756C6C2C6F29292C6E297D2C652E66696C746572';
wwv_flow_imp.g_varchar2_table(2722) := '3D692C652E7369676E616C3D66756E6374696F6E2865297B72657475726E20657D2C652E616E793D66756E6374696F6E282E2E2E65297B72657475726E28742C6E3D6E756C6C2C69293D3E7B72657475726E206F3D7374282E2E2E652E6D61702828653D';
wwv_flow_imp.g_varchar2_table(2723) := '3E652828653D3E742E63616C6C286E2C652929292929292C28733D6929696E7374616E63656F662041727261793F732E70757368286F293A732626732E616464286F292C6F3B766172206F2C737D7D2C652E7265647563653D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(2724) := '742C692C6F297B6C657420733D693B72657475726E206E28652C28653D3E28733D7428732C65292C7329292C6F297D2C652E6465626F756E63653D732C652E616363756D756C6174653D66756E6374696F6E28742C6E3D302C69297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(2725) := '2E6465626F756E636528742C2828652C74293D3E653F28652E707573682874292C65293A5B745D292C6E2C766F696420302C21302C766F696420302C69297D2C652E6C617463683D66756E6374696F6E28652C743D28652C74293D3E653D3D3D742C6E29';
wwv_flow_imp.g_varchar2_table(2726) := '7B6C6574206F2C733D21303B72657475726E206928652C28653D3E7B636F6E7374206E3D737C7C217428652C6F293B72657475726E20733D21312C6F3D652C6E7D292C6E297D2C652E73706C69743D66756E6374696F6E28742C6E2C69297B7265747572';
wwv_flow_imp.g_varchar2_table(2727) := '6E5B652E66696C74657228742C6E2C69292C652E66696C74657228742C28653D3E216E286529292C69295D7D2C652E6275666665723D66756E6374696F6E28652C743D21312C6E3D5B5D2C69297B6C6574206F3D6E2E736C69636528292C733D65282865';
wwv_flow_imp.g_varchar2_table(2728) := '3D3E7B6F3F6F2E707573682865293A612E666972652865297D29293B692626692E6164642873293B636F6E737420723D28293D3E7B6E756C6C3D3D6F7C7C6F2E666F72456163682828653D3E612E6669726528652929292C6F3D6E756C6C7D2C613D6E65';
wwv_flow_imp.g_varchar2_table(2729) := '77204374287B6F6E57696C6C41646446697273744C697374656E657228297B737C7C28733D652828653D3E612E6669726528652929292C692626692E616464287329297D2C6F6E44696441646446697273744C697374656E657228297B6F262628743F73';
wwv_flow_imp.g_varchar2_table(2730) := '657454696D656F75742872293A722829297D2C6F6E44696452656D6F76654C6173744C697374656E657228297B732626732E646973706F736528292C733D6E756C6C7D7D293B72657475726E20692626692E6164642861292C612E6576656E747D2C652E';
wwv_flow_imp.g_varchar2_table(2731) := '636861696E3D66756E6374696F6E28652C74297B72657475726E286E2C692C6F293D3E7B636F6E737420733D74286E65772061293B72657475726E2065282866756E6374696F6E2865297B636F6E737420743D732E6576616C756174652865293B74213D';
wwv_flow_imp.g_varchar2_table(2732) := '3D7226266E2E63616C6C28692C74297D292C766F696420302C6F297D7D3B636F6E737420723D53796D626F6C282248616C74436861696E61626C6522293B636C61737320617B636F6E7374727563746F7228297B746869732E73746570733D5B5D7D6D61';
wwv_flow_imp.g_varchar2_table(2733) := '702865297B72657475726E20746869732E73746570732E707573682865292C746869737D666F72456163682865297B72657475726E20746869732E73746570732E707573682828743D3E28652874292C742929292C746869737D66696C7465722865297B';
wwv_flow_imp.g_varchar2_table(2734) := '72657475726E20746869732E73746570732E707573682828743D3E652874293F743A7229292C746869737D72656475636528652C74297B6C6574206E3D743B72657475726E20746869732E73746570732E707573682828743D3E286E3D65286E2C74292C';
wwv_flow_imp.g_varchar2_table(2735) := '6E2929292C746869737D6C6174636828653D28652C74293D3E653D3D3D74297B6C657420742C6E3D21303B72657475726E20746869732E73746570732E707573682828693D3E7B636F6E7374206F3D6E7C7C216528692C74293B72657475726E206E3D21';
wwv_flow_imp.g_varchar2_table(2736) := '312C743D692C6F3F693A727D29292C746869737D6576616C756174652865297B666F7228636F6E73742074206F6620746869732E73746570732969662828653D74286529293D3D3D7229627265616B3B72657475726E20657D7D652E66726F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(2737) := '4576656E74456D69747465723D66756E6374696F6E28652C742C6E3D653D3E65297B636F6E737420693D282E2E2E65293D3E6F2E66697265286E282E2E2E6529292C6F3D6E6577204374287B6F6E57696C6C41646446697273744C697374656E65723A28';
wwv_flow_imp.g_varchar2_table(2738) := '293D3E652E6F6E28742C69292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F76654C697374656E657228742C69297D293B72657475726E206F2E6576656E747D2C652E66726F6D444F4D4576656E74456D697474';
wwv_flow_imp.g_varchar2_table(2739) := '65723D66756E6374696F6E28652C742C6E3D653D3E65297B636F6E737420693D282E2E2E65293D3E6F2E66697265286E282E2E2E6529292C6F3D6E6577204374287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6164644576';
wwv_flow_imp.g_varchar2_table(2740) := '656E744C697374656E657228742C69292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F76654576656E744C697374656E657228742C69297D293B72657475726E206F2E6576656E747D2C652E746F50726F6D6973';
wwv_flow_imp.g_varchar2_table(2741) := '653D66756E6374696F6E2865297B72657475726E206E65772050726F6D69736528286E3D3E74286529286E2929297D2C652E66726F6D50726F6D6973653D66756E6374696F6E2865297B636F6E737420743D6E65772043743B72657475726E20652E7468';
wwv_flow_imp.g_varchar2_table(2742) := '656E2828653D3E7B742E666972652865297D292C2828293D3E7B742E6669726528766F69642030297D29292E66696E616C6C79282828293D3E7B742E646973706F736528297D29292C742E6576656E747D2C652E72756E416E645375627363726962653D';
wwv_flow_imp.g_varchar2_table(2743) := '66756E6374696F6E28652C742C6E297B72657475726E2074286E292C652828653D3E7428652929297D3B636C617373206C7B636F6E7374727563746F7228652C74297B746869732E5F6F627365727661626C653D652C746869732E5F636F756E7465723D';
wwv_flow_imp.g_varchar2_table(2744) := '302C746869732E5F6861734368616E6765643D21313B636F6E7374206E3D7B6F6E57696C6C41646446697273744C697374656E65723A28293D3E7B652E6164644F627365727665722874686973297D2C6F6E44696452656D6F76654C6173744C69737465';
wwv_flow_imp.g_varchar2_table(2745) := '6E65723A28293D3E7B652E72656D6F76654F627365727665722874686973297D7D3B746869732E656D69747465723D6E6577204374286E292C742626742E61646428746869732E656D6974746572297D626567696E5570646174652865297B746869732E';
wwv_flow_imp.g_varchar2_table(2746) := '5F636F756E7465722B2B7D68616E646C65506F737369626C654368616E67652865297B7D68616E646C654368616E676528652C74297B746869732E5F6861734368616E6765643D21307D656E645570646174652865297B746869732E5F636F756E746572';
wwv_flow_imp.g_varchar2_table(2747) := '2D2D2C303D3D3D746869732E5F636F756E746572262628746869732E5F6F627365727661626C652E7265706F72744368616E67657328292C746869732E5F6861734368616E676564262628746869732E5F6861734368616E6765643D21312C746869732E';
wwv_flow_imp.g_varchar2_table(2748) := '656D69747465722E6669726528746869732E5F6F627365727661626C652E67657428292929297D7D652E66726F6D4F627365727661626C653D66756E6374696F6E28652C74297B72657475726E206E6577206C28652C74292E656D69747465722E657665';
wwv_flow_imp.g_varchar2_table(2749) := '6E747D2C652E66726F6D4F627365727661626C654C696768743D66756E6374696F6E2865297B72657475726E28742C6E2C69293D3E7B6C6574206F3D302C733D21313B636F6E737420723D7B626567696E55706461746528297B6F2B2B7D2C656E645570';
wwv_flow_imp.g_varchar2_table(2750) := '6461746528297B6F2D2D2C303D3D3D6F262628652E7265706F72744368616E67657328292C73262628733D21312C742E63616C6C286E2929297D2C68616E646C65506F737369626C654368616E676528297B7D2C68616E646C654368616E676528297B73';
wwv_flow_imp.g_varchar2_table(2751) := '3D21307D7D3B652E6164644F627365727665722872292C652E7265706F72744368616E67657328293B636F6E737420613D7B646973706F736528297B652E72656D6F76654F627365727665722872297D7D3B72657475726E206920696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(2752) := '662061743F692E6164642861293A41727261792E697341727261792869292626692E707573682861292C617D7D7D2876747C7C2876743D7B7D29293B636C6173732062747B636F6E7374727563746F722865297B746869732E6C697374656E6572436F75';
wwv_flow_imp.g_varchar2_table(2753) := '6E743D302C746869732E696E766F636174696F6E436F756E743D302C746869732E656C61707365644F766572616C6C3D302C746869732E6475726174696F6E733D5B5D2C746869732E6E616D653D60247B657D5F247B62742E5F6964506F6F6C2B2B7D60';
wwv_flow_imp.g_varchar2_table(2754) := '2C62742E616C6C2E6164642874686973297D73746172742865297B746869732E5F73746F7057617463683D6E65772066742C746869732E6C697374656E6572436F756E743D657D73746F7028297B696628746869732E5F73746F705761746368297B636F';
wwv_flow_imp.g_varchar2_table(2755) := '6E737420653D746869732E5F73746F7057617463682E656C617073656428293B746869732E6475726174696F6E732E707573682865292C746869732E656C61707365644F766572616C6C2B3D652C746869732E696E766F636174696F6E436F756E742B3D';
wwv_flow_imp.g_varchar2_table(2756) := '312C746869732E5F73746F7057617463683D766F696420307D7D7D62742E616C6C3D6E6577205365742C62742E5F6964506F6F6C3D303B636C617373205F747B636F6E7374727563746F7228652C743D4D6174682E72616E646F6D28292E746F53747269';
wwv_flow_imp.g_varchar2_table(2757) := '6E67283138292E736C69636528322C3529297B746869732E7468726573686F6C643D652C746869732E6E616D653D742C746869732E5F7761726E436F756E74646F776E3D307D646973706F736528297B76617220653B6E756C6C3D3D3D28653D74686973';
wwv_flow_imp.g_varchar2_table(2758) := '2E5F737461636B73297C7C766F696420303D3D3D657C7C652E636C65617228297D636865636B28652C74297B636F6E7374206E3D746869732E7468726573686F6C643B6966286E3C3D307C7C743C6E2972657475726E3B746869732E5F737461636B737C';
wwv_flow_imp.g_varchar2_table(2759) := '7C28746869732E5F737461636B733D6E6577204D6170293B636F6E737420693D746869732E5F737461636B732E67657428652E76616C7565297C7C303B696628746869732E5F737461636B732E73657428652E76616C75652C692B31292C746869732E5F';
wwv_flow_imp.g_varchar2_table(2760) := '7761726E436F756E74646F776E2D3D312C746869732E5F7761726E436F756E74646F776E3C3D30297B6C657420653B746869732E5F7761726E436F756E74646F776E3D2E352A6E3B6C657420693D303B666F7228636F6E73745B742C6E5D6F6620746869';
wwv_flow_imp.g_varchar2_table(2761) := '732E5F737461636B73292821657C7C693C6E29262628653D742C693D6E293B636F6E736F6C652E7761726E28605B247B746869732E6E616D657D5D20706F74656E7469616C206C697374656E6572204C45414B2064657465637465642C20686176696E67';
wwv_flow_imp.g_varchar2_table(2762) := '20247B747D206C697374656E65727320616C72656164792E204D4F5354206672657175656E74206C697374656E65722028247B697D293A60292C636F6E736F6C652E7761726E2865297D72657475726E28293D3E7B636F6E737420743D746869732E5F73';
wwv_flow_imp.g_varchar2_table(2763) := '7461636B732E67657428652E76616C7565297C7C303B746869732E5F737461636B732E73657428652E76616C75652C742D31297D7D7D636C6173732079747B7374617469632063726561746528297B76617220653B72657475726E206E6577207974286E';
wwv_flow_imp.g_varchar2_table(2764) := '756C6C213D3D28653D286E6577204572726F72292E737461636B292626766F69642030213D3D653F653A2222297D636F6E7374727563746F722865297B746869732E76616C75653D657D7072696E7428297B636F6E736F6C652E7761726E28746869732E';
wwv_flow_imp.g_varchar2_table(2765) := '76616C75652E73706C697428225C6E22292E736C6963652832292E6A6F696E28225C6E2229297D7D636C6173732077747B636F6E7374727563746F722865297B746869732E76616C75653D657D7D636C6173732043747B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(2766) := '297B76617220742C6E2C692C6F2C733B746869732E5F73697A653D302C746869732E5F6F7074696F6E733D652C746869732E5F6C65616B6167654D6F6E3D286E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F';
wwv_flow_imp.g_varchar2_table(2767) := '766F696420303A742E6C65616B5761726E696E675468726573686F6C64293F6E6577205F74286E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C65616B5761';
wwv_flow_imp.g_varchar2_table(2768) := '726E696E675468726573686F6C64292626766F69642030213D3D693F693A2D31293A766F696420302C746869732E5F706572664D6F6E3D286E756C6C3D3D3D286F3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A';
wwv_flow_imp.g_varchar2_table(2769) := '6F2E5F70726F664E616D65293F6E657720627428746869732E5F6F7074696F6E732E5F70726F664E616D65293A766F696420302C746869732E5F64656C697665727951756575653D6E756C6C3D3D3D28733D746869732E5F6F7074696F6E73297C7C766F';
wwv_flow_imp.g_varchar2_table(2770) := '696420303D3D3D733F766F696420303A732E64656C697665727951756575657D646973706F736528297B76617220652C742C6E2C693B746869732E5F646973706F7365647C7C28746869732E5F646973706F7365643D21302C286E756C6C3D3D3D28653D';
wwv_flow_imp.g_varchar2_table(2771) := '746869732E5F64656C69766572795175657565297C7C766F696420303D3D3D653F766F696420303A652E63757272656E74293D3D3D746869732626746869732E5F64656C697665727951756575652E726573657428292C746869732E5F6C697374656E65';
wwv_flow_imp.g_varchar2_table(2772) := '7273262628746869732E5F6C697374656E6572733D766F696420302C746869732E5F73697A653D30292C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E';
wwv_flow_imp.g_varchar2_table(2773) := '44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D6E7C7C6E2E63616C6C2874292C6E756C6C3D3D3D28693D746869732E5F6C65616B6167654D6F6E297C7C766F696420303D3D3D697C7C692E646973706F73652829297D';
wwv_flow_imp.g_varchar2_table(2774) := '676574206576656E7428297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F6576656E74292626766F69642030213D3D657C7C28746869732E5F6576656E743D28652C742C6E293D3E7B76617220692C6F2C732C722C613B6966';
wwv_flow_imp.g_varchar2_table(2775) := '28746869732E5F6C65616B6167654D6F6E2626746869732E5F73697A653E332A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C642972657475726E20636F6E736F6C652E7761726E28605B247B746869732E5F6C65616B6167654D6F6E2E';
wwv_flow_imp.g_varchar2_table(2776) := '6E616D657D5D205245465553455320746F20616363657074206E6577206C697374656E657273206265636175736520697420657863656564656420697473207468726573686F6C642062792066617260292C6C742E4E6F6E653B696628746869732E5F64';
wwv_flow_imp.g_varchar2_table(2777) := '6973706F7365642972657475726E206C742E4E6F6E653B74262628653D652E62696E64287429293B636F6E7374206C3D6E65772077742865293B6C657420633B746869732E5F6C65616B6167654D6F6E2626746869732E5F73697A653E3D4D6174682E63';
wwv_flow_imp.g_varchar2_table(2778) := '65696C282E322A746869732E5F6C65616B6167654D6F6E2E7468726573686F6C64292626286C2E737461636B3D79742E63726561746528292C633D746869732E5F6C65616B6167654D6F6E2E636865636B286C2E737461636B2C746869732E5F73697A65';
wwv_flow_imp.g_varchar2_table(2779) := '2B3129292C746869732E5F6C697374656E6572733F746869732E5F6C697374656E65727320696E7374616E63656F662077743F286E756C6C213D3D28613D746869732E5F64656C69766572795175657565292626766F69642030213D3D617C7C28746869';
wwv_flow_imp.g_varchar2_table(2780) := '732E5F64656C697665727951756575653D6E6577205374292C746869732E5F6C697374656E6572733D5B746869732E5F6C697374656E6572732C6C5D293A746869732E5F6C697374656E6572732E70757368286C293A286E756C6C3D3D3D286F3D6E756C';
wwv_flow_imp.g_varchar2_table(2781) := '6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E57696C6C41646446697273744C697374656E6572297C7C766F696420303D3D3D6F7C7C6F2E63616C6C28692C74686973292C746869732E';
wwv_flow_imp.g_varchar2_table(2782) := '5F6C697374656E6572733D6C2C6E756C6C3D3D3D28723D6E756C6C3D3D3D28733D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D733F766F696420303A732E6F6E44696441646446697273744C697374656E6572297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(2783) := '3D3D727C7C722E63616C6C28732C7468697329292C746869732E5F73697A652B2B3B636F6E737420643D7274282828293D3E7B6E756C6C3D3D637C7C6328292C746869732E5F72656D6F76654C697374656E6572286C297D29293B72657475726E206E20';
wwv_flow_imp.g_varchar2_table(2784) := '696E7374616E63656F662061743F6E2E6164642864293A41727261792E69734172726179286E2926266E2E707573682864292C647D292C746869732E5F6576656E747D5F72656D6F76654C697374656E65722865297B76617220742C6E2C692C6F3B6966';
wwv_flow_imp.g_varchar2_table(2785) := '286E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6F6E57696C6C52656D6F76654C697374656E6572297C7C766F696420303D3D3D6E7C7C6E2E63616C6C2874';
wwv_flow_imp.g_varchar2_table(2786) := '2C74686973292C21746869732E5F6C697374656E6572732972657475726E3B696628313D3D3D746869732E5F73697A652972657475726E20746869732E5F6C697374656E6572733D766F696420302C6E756C6C3D3D3D286F3D6E756C6C3D3D3D28693D74';
wwv_flow_imp.g_varchar2_table(2787) := '6869732E5F6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6F6E44696452656D6F76654C6173744C697374656E6572297C7C766F696420303D3D3D6F7C7C6F2E63616C6C28692C74686973292C766F696428746869732E5F73';
wwv_flow_imp.g_varchar2_table(2788) := '697A653D30293B636F6E737420733D746869732E5F6C697374656E6572732C723D732E696E6465784F662865293B6966282D313D3D3D72297468726F7720636F6E736F6C652E6C6F672822646973706F7365643F222C746869732E5F646973706F736564';
wwv_flow_imp.g_varchar2_table(2789) := '292C636F6E736F6C652E6C6F67282273697A653F222C746869732E5F73697A65292C636F6E736F6C652E6C6F6728226172723F222C4A534F4E2E737472696E6769667928746869732E5F6C697374656E65727329292C6E6577204572726F722822417474';
wwv_flow_imp.g_varchar2_table(2790) := '656D7074656420746F20646973706F736520756E6B6E6F776E206C697374656E657222293B746869732E5F73697A652D2D2C735B725D3D766F696420303B636F6E737420613D746869732E5F64656C697665727951756575652E63757272656E743D3D3D';
wwv_flow_imp.g_varchar2_table(2791) := '746869733B696628322A746869732E5F73697A653C3D732E6C656E677468297B6C657420653D303B666F72286C657420743D303B743C732E6C656E6774683B742B2B29735B745D3F735B652B2B5D3D735B745D3A61262628746869732E5F64656C697665';
wwv_flow_imp.g_varchar2_table(2792) := '727951756575652E656E642D2D2C653C746869732E5F64656C697665727951756575652E692626746869732E5F64656C697665727951756575652E692D2D293B732E6C656E6774683D657D7D5F64656C6976657228652C74297B766172206E3B69662821';
wwv_flow_imp.g_varchar2_table(2793) := '652972657475726E3B636F6E737420693D286E756C6C3D3D3D286E3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E6F6E4C697374656E65724572726F72297C7C6B653B69662869297472797B652E76616C75';
wwv_flow_imp.g_varchar2_table(2794) := '652874297D63617463682865297B692865297D656C736520652E76616C75652874297D5F64656C6976657251756575652865297B636F6E737420743D652E63757272656E742E5F6C697374656E6572733B666F72283B652E693C652E656E643B29746869';
wwv_flow_imp.g_varchar2_table(2795) := '732E5F64656C6976657228745B652E692B2B5D2C652E76616C7565293B652E726573657428297D666972652865297B76617220742C6E2C692C6F3B696628286E756C6C3D3D3D28743D746869732E5F64656C69766572795175657565297C7C766F696420';
wwv_flow_imp.g_varchar2_table(2796) := '303D3D3D743F766F696420303A742E63757272656E7429262628746869732E5F64656C69766572517565756528746869732E5F64656C69766572795175657565292C6E756C6C3D3D3D286E3D746869732E5F706572664D6F6E297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(2797) := '3D6E7C7C6E2E73746F702829292C6E756C6C3D3D3D28693D746869732E5F706572664D6F6E297C7C766F696420303D3D3D697C7C692E737461727428746869732E5F73697A65292C746869732E5F6C697374656E65727329696628746869732E5F6C6973';
wwv_flow_imp.g_varchar2_table(2798) := '74656E65727320696E7374616E63656F6620777429746869732E5F64656C6976657228746869732E5F6C697374656E6572732C65293B656C73657B636F6E737420743D746869732E5F64656C697665727951756575653B742E656E717565756528746869';
wwv_flow_imp.g_varchar2_table(2799) := '732C652C746869732E5F6C697374656E6572732E6C656E677468292C746869732E5F64656C6976657251756575652874297D6E756C6C3D3D3D286F3D746869732E5F706572664D6F6E297C7C766F696420303D3D3D6F7C7C6F2E73746F7028297D686173';
wwv_flow_imp.g_varchar2_table(2800) := '4C697374656E65727328297B72657475726E20746869732E5F73697A653E307D7D636C6173732053747B636F6E7374727563746F7228297B746869732E693D2D312C746869732E656E643D307D656E717565756528652C742C6E297B746869732E693D30';
wwv_flow_imp.g_varchar2_table(2801) := '2C746869732E656E643D6E2C746869732E63757272656E743D652C746869732E76616C75653D747D726573657428297B746869732E693D746869732E656E642C746869732E63757272656E743D766F696420302C746869732E76616C75653D766F696420';
wwv_flow_imp.g_varchar2_table(2802) := '307D7D636C61737320787420657874656E64732043747B636F6E7374727563746F722865297B73757065722865292C746869732E5F69735061757365643D302C746869732E5F6576656E7451756575653D6E65772067742C746869732E5F6D6572676546';
wwv_flow_imp.g_varchar2_table(2803) := '6E3D6E756C6C3D3D653F766F696420303A652E6D657267657D706175736528297B746869732E5F69735061757365642B2B7D726573756D6528297B69662830213D3D746869732E5F69735061757365642626303D3D2D2D746869732E5F69735061757365';
wwv_flow_imp.g_varchar2_table(2804) := '6429696628746869732E5F6D65726765466E297B696628746869732E5F6576656E7451756575652E73697A653E30297B636F6E737420653D41727261792E66726F6D28746869732E5F6576656E745175657565293B746869732E5F6576656E7451756575';
wwv_flow_imp.g_varchar2_table(2805) := '652E636C65617228292C73757065722E6669726528746869732E5F6D65726765466E286529297D7D656C736520666F72283B21746869732E5F6973506175736564262630213D3D746869732E5F6576656E7451756575652E73697A653B2973757065722E';
wwv_flow_imp.g_varchar2_table(2806) := '6669726528746869732E5F6576656E7451756575652E73686966742829297D666972652865297B746869732E5F73697A6526262830213D3D746869732E5F69735061757365643F746869732E5F6576656E7451756575652E707573682865293A73757065';
wwv_flow_imp.g_varchar2_table(2807) := '722E66697265286529297D7D636C617373206B7420657874656E64732078747B636F6E7374727563746F722865297B76617220743B73757065722865292C746869732E5F64656C61793D6E756C6C213D3D28743D652E64656C6179292626766F69642030';
wwv_flow_imp.g_varchar2_table(2808) := '213D3D743F743A3130307D666972652865297B746869732E5F68616E646C657C7C28746869732E706175736528292C746869732E5F68616E646C653D73657454696D656F7574282828293D3E7B746869732E5F68616E646C653D766F696420302C746869';
wwv_flow_imp.g_varchar2_table(2809) := '732E726573756D6528297D292C746869732E5F64656C617929292C73757065722E666972652865297D7D636C61737320457420657874656E64732043747B636F6E7374727563746F722865297B73757065722865292C746869732E5F7175657565644576';
wwv_flow_imp.g_varchar2_table(2810) := '656E74733D5B5D2C746869732E5F6D65726765466E3D6E756C6C3D3D653F766F696420303A652E6D657267657D666972652865297B746869732E6861734C697374656E6572732829262628746869732E5F7175657565644576656E74732E707573682865';
wwv_flow_imp.g_varchar2_table(2811) := '292C313D3D3D746869732E5F7175657565644576656E74732E6C656E677468262671756575654D6963726F7461736B282828293D3E7B746869732E5F6D65726765466E3F73757065722E6669726528746869732E5F6D65726765466E28746869732E5F71';
wwv_flow_imp.g_varchar2_table(2812) := '75657565644576656E747329293A746869732E5F7175657565644576656E74732E666F72456163682828653D3E73757065722E6669726528652929292C746869732E5F7175657565644576656E74733D5B5D7D2929297D7D636C617373204C747B636F6E';
wwv_flow_imp.g_varchar2_table(2813) := '7374727563746F7228297B746869732E6861734C697374656E6572733D21312C746869732E6576656E74733D5B5D2C746869732E656D69747465723D6E6577204374287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E746869732E';
wwv_flow_imp.g_varchar2_table(2814) := '6F6E46697273744C697374656E657241646428292C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E746869732E6F6E4C6173744C697374656E657252656D6F766528297D297D676574206576656E7428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(2815) := '69732E656D69747465722E6576656E747D6164642865297B636F6E737420743D7B6576656E743A652C6C697374656E65723A6E756C6C7D3B72657475726E20746869732E6576656E74732E707573682874292C746869732E6861734C697374656E657273';
wwv_flow_imp.g_varchar2_table(2816) := '2626746869732E686F6F6B2874292C7274285965282828293D3E7B746869732E6861734C697374656E6572732626746869732E756E686F6F6B2874293B636F6E737420653D746869732E6576656E74732E696E6465784F662874293B746869732E657665';
wwv_flow_imp.g_varchar2_table(2817) := '6E74732E73706C69636528652C31297D2929297D6F6E46697273744C697374656E657241646428297B746869732E6861734C697374656E6572733D21302C746869732E6576656E74732E666F72456163682828653D3E746869732E686F6F6B2865292929';
wwv_flow_imp.g_varchar2_table(2818) := '7D6F6E4C6173744C697374656E657252656D6F766528297B746869732E6861734C697374656E6572733D21312C746869732E6576656E74732E666F72456163682828653D3E746869732E756E686F6F6B28652929297D686F6F6B2865297B652E6C697374';
wwv_flow_imp.g_varchar2_table(2819) := '656E65723D652E6576656E742828653D3E746869732E656D69747465722E6669726528652929297D756E686F6F6B2865297B76617220743B6E756C6C3D3D3D28743D652E6C697374656E6572297C7C766F696420303D3D3D747C7C742E646973706F7365';
wwv_flow_imp.g_varchar2_table(2820) := '28292C652E6C697374656E65723D6E756C6C7D646973706F736528297B76617220653B746869732E656D69747465722E646973706F736528293B666F7228636F6E73742074206F6620746869732E6576656E7473296E756C6C3D3D3D28653D742E6C6973';
wwv_flow_imp.g_varchar2_table(2821) := '74656E6572297C7C766F696420303D3D3D657C7C652E646973706F736528293B746869732E6576656E74733D5B5D7D7D636C6173732044747B636F6E7374727563746F7228297B746869732E627566666572733D5B5D7D777261704576656E742865297B';
wwv_flow_imp.g_varchar2_table(2822) := '72657475726E28742C6E2C69293D3E652828653D3E7B636F6E737420693D746869732E627566666572735B746869732E627566666572732E6C656E6774682D315D3B693F692E70757368282828293D3E742E63616C6C286E2C652929293A742E63616C6C';
wwv_flow_imp.g_varchar2_table(2823) := '286E2C65297D292C766F696420302C69297D6275666665724576656E74732865297B636F6E737420743D5B5D3B746869732E627566666572732E707573682874293B636F6E7374206E3D6528293B72657475726E20746869732E627566666572732E706F';
wwv_flow_imp.g_varchar2_table(2824) := '7028292C742E666F72456163682828653D3E65282929292C6E7D7D636C6173732054747B636F6E7374727563746F7228297B746869732E6C697374656E696E673D21312C746869732E696E7075744576656E743D76742E4E6F6E652C746869732E696E70';
wwv_flow_imp.g_varchar2_table(2825) := '75744576656E744C697374656E65723D6C742E4E6F6E652C746869732E656D69747465723D6E6577204374287B6F6E44696441646446697273744C697374656E65723A28293D3E7B746869732E6C697374656E696E673D21302C746869732E696E707574';
wwv_flow_imp.g_varchar2_table(2826) := '4576656E744C697374656E65723D746869732E696E7075744576656E7428746869732E656D69747465722E666972652C746869732E656D6974746572297D2C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E7B746869732E6C6973';
wwv_flow_imp.g_varchar2_table(2827) := '74656E696E673D21312C746869732E696E7075744576656E744C697374656E65722E646973706F736528297D7D292C746869732E6576656E743D746869732E656D69747465722E6576656E747D73657420696E7075742865297B746869732E696E707574';
wwv_flow_imp.g_varchar2_table(2828) := '4576656E743D652C746869732E6C697374656E696E67262628746869732E696E7075744576656E744C697374656E65722E646973706F736528292C746869732E696E7075744576656E744C697374656E65723D6528746869732E656D69747465722E6669';
wwv_flow_imp.g_varchar2_table(2829) := '72652C746869732E656D697474657229297D646973706F736528297B746869732E696E7075744576656E744C697374656E65722E646973706F736528292C746869732E656D69747465722E646973706F736528297D7D636F6E73742049743D4F626A6563';
wwv_flow_imp.g_varchar2_table(2830) := '742E667265657A65282866756E6374696F6E28652C74297B636F6E7374206E3D73657454696D656F757428652E62696E642874292C30293B72657475726E7B646973706F736528297B636C65617254696D656F7574286E297D7D7D29293B766172204D74';
wwv_flow_imp.g_varchar2_table(2831) := '3B2166756E6374696F6E2865297B652E697343616E63656C6C6174696F6E546F6B656E3D66756E6374696F6E2874297B72657475726E20743D3D3D652E4E6F6E657C7C743D3D3D652E43616E63656C6C65647C7C7420696E7374616E63656F662041747C';
wwv_flow_imp.g_varchar2_table(2832) := '7C212821747C7C226F626A65637422213D747970656F66207429262622626F6F6C65616E223D3D747970656F6620742E697343616E63656C6C6174696F6E52657175657374656426262266756E6374696F6E223D3D747970656F6620742E6F6E43616E63';
wwv_flow_imp.g_varchar2_table(2833) := '656C6C6174696F6E5265717565737465647D2C652E4E6F6E653D4F626A6563742E667265657A65287B697343616E63656C6C6174696F6E5265717565737465643A21312C6F6E43616E63656C6C6174696F6E5265717565737465643A76742E4E6F6E657D';
wwv_flow_imp.g_varchar2_table(2834) := '292C652E43616E63656C6C65643D4F626A6563742E667265657A65287B697343616E63656C6C6174696F6E5265717565737465643A21302C6F6E43616E63656C6C6174696F6E5265717565737465643A49747D297D284D747C7C284D743D7B7D29293B63';
wwv_flow_imp.g_varchar2_table(2835) := '6C6173732041747B636F6E7374727563746F7228297B746869732E5F697343616E63656C6C65643D21312C746869732E5F656D69747465723D6E756C6C7D63616E63656C28297B746869732E5F697343616E63656C6C65647C7C28746869732E5F697343';
wwv_flow_imp.g_varchar2_table(2836) := '616E63656C6C65643D21302C746869732E5F656D6974746572262628746869732E5F656D69747465722E6669726528766F69642030292C746869732E646973706F7365282929297D67657420697343616E63656C6C6174696F6E52657175657374656428';
wwv_flow_imp.g_varchar2_table(2837) := '297B72657475726E20746869732E5F697343616E63656C6C65647D676574206F6E43616E63656C6C6174696F6E52657175657374656428297B72657475726E20746869732E5F697343616E63656C6C65643F49743A28746869732E5F656D69747465727C';
wwv_flow_imp.g_varchar2_table(2838) := '7C28746869732E5F656D69747465723D6E6577204374292C746869732E5F656D69747465722E6576656E74297D646973706F736528297B746869732E5F656D6974746572262628746869732E5F656D69747465722E646973706F736528292C746869732E';
wwv_flow_imp.g_varchar2_table(2839) := '5F656D69747465723D6E756C6C297D7D636C617373204E747B636F6E7374727563746F722865297B746869732E5F746F6B656E3D766F696420302C746869732E5F706172656E744C697374656E65723D766F696420302C746869732E5F706172656E744C';
wwv_flow_imp.g_varchar2_table(2840) := '697374656E65723D652626652E6F6E43616E63656C6C6174696F6E52657175657374656428746869732E63616E63656C2C74686973297D67657420746F6B656E28297B72657475726E20746869732E5F746F6B656E7C7C28746869732E5F746F6B656E3D';
wwv_flow_imp.g_varchar2_table(2841) := '6E6577204174292C746869732E5F746F6B656E7D63616E63656C28297B746869732E5F746F6B656E3F746869732E5F746F6B656E20696E7374616E63656F662041742626746869732E5F746F6B656E2E63616E63656C28293A746869732E5F746F6B656E';
wwv_flow_imp.g_varchar2_table(2842) := '3D4D742E43616E63656C6C65647D646973706F736528653D2131297B76617220743B652626746869732E63616E63656C28292C6E756C6C3D3D3D28743D746869732E5F706172656E744C697374656E6572297C7C766F696420303D3D3D747C7C742E6469';
wwv_flow_imp.g_varchar2_table(2843) := '73706F736528292C746869732E5F746F6B656E3F746869732E5F746F6B656E20696E7374616E63656F662041742626746869732E5F746F6B656E2E646973706F736528293A746869732E5F746F6B656E3D4D742E4E6F6E657D7D66756E6374696F6E2050';
wwv_flow_imp.g_varchar2_table(2844) := '742865297B636F6E737420743D6E6577204E743B72657475726E20652E616464287B646973706F736528297B742E63616E63656C28297D7D292C742E746F6B656E7D636F6E7374204F743D53796D626F6C28224D6963726F7461736B44656C617922293B';
wwv_flow_imp.g_varchar2_table(2845) := '66756E6374696F6E2052742865297B72657475726E21216526262266756E6374696F6E223D3D747970656F6620652E7468656E7D66756E6374696F6E2046742865297B636F6E737420743D6E6577204E742C6E3D6528742E746F6B656E292C693D6E6577';
wwv_flow_imp.g_varchar2_table(2846) := '2050726F6D697365282828652C69293D3E7B636F6E7374206F3D742E746F6B656E2E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B6F2E646973706F736528292C69286E6577204965297D29293B50726F6D6973652E726573';
wwv_flow_imp.g_varchar2_table(2847) := '6F6C7665286E292E7468656E28286E3D3E7B6F2E646973706F736528292C742E646973706F736528292C65286E297D292C28653D3E7B6F2E646973706F736528292C742E646973706F736528292C692865297D29297D29293B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(2848) := '636C6173737B63616E63656C28297B742E63616E63656C28292C742E646973706F736528297D7468656E28652C74297B72657475726E20692E7468656E28652C74297D63617463682865297B72657475726E20746869732E7468656E28766F696420302C';
wwv_flow_imp.g_varchar2_table(2849) := '65297D66696E616C6C792865297B72657475726E20692E66696E616C6C792865297D7D7D66756E6374696F6E20427428652C742C6E297B72657475726E206E65772050726F6D697365282828692C6F293D3E7B636F6E737420733D742E6F6E43616E6365';
wwv_flow_imp.g_varchar2_table(2850) := '6C6C6174696F6E526571756573746564282828293D3E7B732E646973706F736528292C69286E297D29293B652E7468656E28692C6F292E66696E616C6C79282828293D3E732E646973706F7365282929297D29297D636C6173732056747B636F6E737472';
wwv_flow_imp.g_varchar2_table(2851) := '7563746F7228297B746869732E6973446973706F7365643D21312C746869732E61637469766550726F6D6973653D6E756C6C2C746869732E71756575656450726F6D6973653D6E756C6C2C746869732E71756575656450726F6D697365466163746F7279';
wwv_flow_imp.g_varchar2_table(2852) := '3D6E756C6C7D71756575652865297B696628746869732E6973446973706F7365642972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228225468726F74746C657220697320646973706F7365642229293B696628746869732E';
wwv_flow_imp.g_varchar2_table(2853) := '61637469766550726F6D697365297B696628746869732E71756575656450726F6D697365466163746F72793D652C21746869732E71756575656450726F6D697365297B636F6E737420653D28293D3E7B696628746869732E71756575656450726F6D6973';
wwv_flow_imp.g_varchar2_table(2854) := '653D6E756C6C2C746869732E6973446973706F7365642972657475726E3B636F6E737420653D746869732E717565756528746869732E71756575656450726F6D697365466163746F7279293B72657475726E20746869732E71756575656450726F6D6973';
wwv_flow_imp.g_varchar2_table(2855) := '65466163746F72793D6E756C6C2C657D3B746869732E71756575656450726F6D6973653D6E65772050726F6D6973652828743D3E7B746869732E61637469766550726F6D6973652E7468656E28652C65292E7468656E2874297D29297D72657475726E20';
wwv_flow_imp.g_varchar2_table(2856) := '6E65772050726F6D697365282828652C74293D3E7B746869732E71756575656450726F6D6973652E7468656E28652C74297D29297D72657475726E20746869732E61637469766550726F6D6973653D6528292C6E65772050726F6D697365282828652C74';
wwv_flow_imp.g_varchar2_table(2857) := '293D3E7B746869732E61637469766550726F6D6973652E7468656E2828743D3E7B746869732E61637469766550726F6D6973653D6E756C6C2C652874297D292C28653D3E7B746869732E61637469766550726F6D6973653D6E756C6C2C742865297D2929';
wwv_flow_imp.g_varchar2_table(2858) := '7D29297D646973706F736528297B746869732E6973446973706F7365643D21307D7D636C617373207A747B636F6E7374727563746F722865297B746869732E64656661756C7444656C61793D652C746869732E64656665727265643D6E756C6C2C746869';
wwv_flow_imp.g_varchar2_table(2859) := '732E636F6D706C6574696F6E50726F6D6973653D6E756C6C2C746869732E646F5265736F6C76653D6E756C6C2C746869732E646F52656A6563743D6E756C6C2C746869732E7461736B3D6E756C6C7D7472696767657228652C743D746869732E64656661';
wwv_flow_imp.g_varchar2_table(2860) := '756C7444656C6179297B746869732E7461736B3D652C746869732E63616E63656C54696D656F757428292C746869732E636F6D706C6574696F6E50726F6D6973657C7C28746869732E636F6D706C6574696F6E50726F6D6973653D6E65772050726F6D69';
wwv_flow_imp.g_varchar2_table(2861) := '7365282828652C74293D3E7B746869732E646F5265736F6C76653D652C746869732E646F52656A6563743D747D29292E7468656E282828293D3E7B696628746869732E636F6D706C6574696F6E50726F6D6973653D6E756C6C2C746869732E646F526573';
wwv_flow_imp.g_varchar2_table(2862) := '6F6C76653D6E756C6C2C746869732E7461736B297B636F6E737420653D746869732E7461736B3B72657475726E20746869732E7461736B3D6E756C6C2C6528297D7D2929293B636F6E7374206E3D28293D3E7B76617220653B746869732E646566657272';
wwv_flow_imp.g_varchar2_table(2863) := '65643D6E756C6C2C6E756C6C3D3D3D28653D746869732E646F5265736F6C7665297C7C766F696420303D3D3D657C7C652E63616C6C28746869732C6E756C6C297D3B72657475726E20746869732E64656665727265643D743D3D3D4F743F28653D3E7B6C';
wwv_flow_imp.g_varchar2_table(2864) := '657420743D21303B72657475726E2071756575654D6963726F7461736B282828293D3E7B74262628743D21312C652829297D29292C7B69735472696767657265643A28293D3E742C646973706F73653A28293D3E7B743D21317D7D7D29286E293A282865';
wwv_flow_imp.g_varchar2_table(2865) := '2C74293D3E7B6C6574206E3D21303B636F6E737420693D73657454696D656F7574282828293D3E7B6E3D21312C7428297D292C65293B72657475726E7B69735472696767657265643A28293D3E6E2C646973706F73653A28293D3E7B636C65617254696D';
wwv_flow_imp.g_varchar2_table(2866) := '656F75742869292C6E3D21317D7D7D2928742C6E292C746869732E636F6D706C6574696F6E50726F6D6973657D697354726967676572656428297B76617220653B72657475726E2121286E756C6C3D3D3D28653D746869732E6465666572726564297C7C';
wwv_flow_imp.g_varchar2_table(2867) := '766F696420303D3D3D653F766F696420303A652E69735472696767657265642829297D63616E63656C28297B76617220653B746869732E63616E63656C54696D656F757428292C746869732E636F6D706C6574696F6E50726F6D6973652626286E756C6C';
wwv_flow_imp.g_varchar2_table(2868) := '3D3D3D28653D746869732E646F52656A656374297C7C766F696420303D3D3D657C7C652E63616C6C28746869732C6E6577204965292C746869732E636F6D706C6574696F6E50726F6D6973653D6E756C6C297D63616E63656C54696D656F757428297B76';
wwv_flow_imp.g_varchar2_table(2869) := '617220653B6E756C6C3D3D3D28653D746869732E6465666572726564297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E64656665727265643D6E756C6C7D646973706F736528297B746869732E63616E63656C28297D7D63';
wwv_flow_imp.g_varchar2_table(2870) := '6C6173732048747B636F6E7374727563746F722865297B746869732E64656C617965723D6E6577207A742865292C746869732E7468726F74746C65723D6E65772056747D7472696767657228652C74297B72657475726E20746869732E64656C61796572';
wwv_flow_imp.g_varchar2_table(2871) := '2E74726967676572282828293D3E746869732E7468726F74746C65722E7175657565286529292C74297D63616E63656C28297B746869732E64656C617965722E63616E63656C28297D646973706F736528297B746869732E64656C617965722E64697370';
wwv_flow_imp.g_varchar2_table(2872) := '6F736528292C746869732E7468726F74746C65722E646973706F736528297D7D66756E6374696F6E20577428652C74297B72657475726E20743F6E65772050726F6D6973652828286E2C69293D3E7B636F6E7374206F3D73657454696D656F7574282828';
wwv_flow_imp.g_varchar2_table(2873) := '293D3E7B732E646973706F736528292C6E28297D292C65292C733D742E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B636C65617254696D656F7574286F292C732E646973706F736528292C69286E6577204965297D29297D';
wwv_flow_imp.g_varchar2_table(2874) := '29293A46742828743D3E577428652C742929297D66756E6374696F6E206A7428652C743D302C6E297B636F6E737420693D73657454696D656F7574282828293D3E7B6528292C6E26266F2E646973706F736528297D292C74292C6F3D7274282828293D3E';
wwv_flow_imp.g_varchar2_table(2875) := '7B636C65617254696D656F75742869292C6E756C6C3D3D6E7C7C6E2E64656C657465416E644C65616B286F297D29293B72657475726E206E756C6C3D3D6E7C7C6E2E616464286F292C6F7D66756E6374696F6E20717428652C743D653D3E2121652C6E3D';
wwv_flow_imp.g_varchar2_table(2876) := '6E756C6C297B6C657420693D303B636F6E7374206F3D652E6C656E6774682C733D28293D3E7B696628693E3D6F2972657475726E2050726F6D6973652E7265736F6C7665286E293B636F6E737420723D655B692B2B5D3B72657475726E2050726F6D6973';
wwv_flow_imp.g_varchar2_table(2877) := '652E7265736F6C766528722829292E7468656E2828653D3E742865293F50726F6D6973652E7265736F6C76652865293A73282929297D3B72657475726E207328297D636C6173732024747B636F6E7374727563746F7228652C74297B746869732E5F746F';
wwv_flow_imp.g_varchar2_table(2878) := '6B656E3D2D312C2266756E6374696F6E223D3D747970656F6620652626226E756D626572223D3D747970656F6620742626746869732E73657449664E6F7453657428652C74297D646973706F736528297B746869732E63616E63656C28297D63616E6365';
wwv_flow_imp.g_varchar2_table(2879) := '6C28297B2D31213D3D746869732E5F746F6B656E262628636C65617254696D656F757428746869732E5F746F6B656E292C746869732E5F746F6B656E3D2D31297D63616E63656C416E6453657428652C74297B746869732E63616E63656C28292C746869';
wwv_flow_imp.g_varchar2_table(2880) := '732E5F746F6B656E3D73657454696D656F7574282828293D3E7B746869732E5F746F6B656E3D2D312C6528297D292C74297D73657449664E6F7453657428652C74297B2D313D3D3D746869732E5F746F6B656E262628746869732E5F746F6B656E3D7365';
wwv_flow_imp.g_varchar2_table(2881) := '7454696D656F7574282828293D3E7B746869732E5F746F6B656E3D2D312C6528297D292C7429297D7D636C6173732055747B636F6E7374727563746F7228297B746869732E646973706F7361626C653D766F696420307D63616E63656C28297B76617220';
wwv_flow_imp.g_varchar2_table(2882) := '653B6E756C6C3D3D3D28653D746869732E646973706F7361626C65297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E646973706F7361626C653D766F696420307D63616E63656C416E6453657428652C742C6E3D676C6F62';
wwv_flow_imp.g_varchar2_table(2883) := '616C54686973297B746869732E63616E63656C28293B636F6E737420693D6E2E736574496E74657276616C282828293D3E7B6528297D292C74293B746869732E646973706F7361626C653D7274282828293D3E7B6E2E636C656172496E74657276616C28';
wwv_flow_imp.g_varchar2_table(2884) := '69292C746869732E646973706F7361626C653D766F696420307D29297D646973706F736528297B746869732E63616E63656C28297D7D636C617373204B747B636F6E7374727563746F7228652C74297B746869732E74696D656F7574546F6B656E3D2D31';
wwv_flow_imp.g_varchar2_table(2885) := '2C746869732E72756E6E65723D652C746869732E74696D656F75743D742C746869732E74696D656F757448616E646C65723D746869732E6F6E54696D656F75742E62696E642874686973297D646973706F736528297B746869732E63616E63656C28292C';
wwv_flow_imp.g_varchar2_table(2886) := '746869732E72756E6E65723D6E756C6C7D63616E63656C28297B746869732E69735363686564756C65642829262628636C65617254696D656F757428746869732E74696D656F7574546F6B656E292C746869732E74696D656F7574546F6B656E3D2D3129';
wwv_flow_imp.g_varchar2_table(2887) := '7D7363686564756C6528653D746869732E74696D656F7574297B746869732E63616E63656C28292C746869732E74696D656F7574546F6B656E3D73657454696D656F757428746869732E74696D656F757448616E646C65722C65297D6765742064656C61';
wwv_flow_imp.g_varchar2_table(2888) := '7928297B72657475726E20746869732E74696D656F75747D7365742064656C61792865297B746869732E74696D656F75743D657D69735363686564756C656428297B72657475726E2D31213D3D746869732E74696D656F7574546F6B656E7D6F6E54696D';
wwv_flow_imp.g_varchar2_table(2889) := '656F757428297B746869732E74696D656F7574546F6B656E3D2D312C746869732E72756E6E65722626746869732E646F52756E28297D646F52756E28297B76617220653B6E756C6C3D3D3D28653D746869732E72756E6E6572297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(2890) := '3D657C7C652E63616C6C2874686973297D7D6C65742047742C51743B51743D2266756E6374696F6E22213D747970656F6620676C6F62616C546869732E7265717565737449646C6543616C6C6261636B7C7C2266756E6374696F6E22213D747970656F66';
wwv_flow_imp.g_varchar2_table(2891) := '20676C6F62616C546869732E63616E63656C49646C6543616C6C6261636B3F28652C74293D3E7B6565282828293D3E7B6966286E2972657475726E3B636F6E737420653D446174652E6E6F7728292B31352C693D7B64696454696D656F75743A21302C74';
wwv_flow_imp.g_varchar2_table(2892) := '696D6552656D61696E696E673A28293D3E4D6174682E6D617828302C652D446174652E6E6F772829297D3B74284F626A6563742E667265657A65286929297D29293B6C6574206E3D21313B72657475726E7B646973706F736528297B6E7C7C286E3D2130';
wwv_flow_imp.g_varchar2_table(2893) := '297D7D7D3A28652C742C6E293D3E7B636F6E737420693D652E7265717565737449646C6543616C6C6261636B28742C226E756D626572223D3D747970656F66206E3F7B74696D656F75743A6E7D3A766F69642030293B6C6574206F3D21313B7265747572';
wwv_flow_imp.g_varchar2_table(2894) := '6E7B646973706F736528297B6F7C7C286F3D21302C652E63616E63656C49646C6543616C6C6261636B286929297D7D7D2C47743D653D3E517428676C6F62616C546869732C65293B636C6173732059747B636F6E7374727563746F7228652C74297B7468';
wwv_flow_imp.g_varchar2_table(2895) := '69732E5F64696452756E3D21312C746869732E5F6578656375746F723D28293D3E7B7472797B746869732E5F76616C75653D7428297D63617463682865297B746869732E5F6572726F723D657D66696E616C6C797B746869732E5F64696452756E3D2130';
wwv_flow_imp.g_varchar2_table(2896) := '7D7D2C746869732E5F68616E646C653D517428652C2828293D3E746869732E5F6578656375746F72282929297D646973706F736528297B746869732E5F68616E646C652E646973706F736528297D6765742076616C756528297B696628746869732E5F64';
wwv_flow_imp.g_varchar2_table(2897) := '696452756E7C7C28746869732E5F68616E646C652E646973706F736528292C746869732E5F6578656375746F722829292C746869732E5F6572726F72297468726F7720746869732E5F6572726F723B72657475726E20746869732E5F76616C75657D6765';
wwv_flow_imp.g_varchar2_table(2898) := '74206973496E697469616C697A656428297B72657475726E20746869732E5F64696452756E7D7D636C617373205A7420657874656E64732059747B636F6E7374727563746F722865297B737570657228676C6F62616C546869732C65297D7D636C617373';
wwv_flow_imp.g_varchar2_table(2899) := '2058747B67657420697352656A656374656428297B76617220653B72657475726E20313D3D3D286E756C6C3D3D3D28653D746869732E6F7574636F6D65297C7C766F696420303D3D3D653F766F696420303A652E6F7574636F6D65297D67657420697353';
wwv_flow_imp.g_varchar2_table(2900) := '6574746C656428297B72657475726E2121746869732E6F7574636F6D657D636F6E7374727563746F7228297B746869732E703D6E65772050726F6D697365282828652C74293D3E7B746869732E636F6D706C65746543616C6C6261636B3D652C74686973';
wwv_flow_imp.g_varchar2_table(2901) := '2E6572726F7243616C6C6261636B3D747D29297D636F6D706C6574652865297B72657475726E206E65772050726F6D6973652828743D3E7B746869732E636F6D706C65746543616C6C6261636B2865292C746869732E6F7574636F6D653D7B6F7574636F';
wwv_flow_imp.g_varchar2_table(2902) := '6D653A302C76616C75653A657D2C7428297D29297D6572726F722865297B72657475726E206E65772050726F6D6973652828743D3E7B746869732E6572726F7243616C6C6261636B2865292C746869732E6F7574636F6D653D7B6F7574636F6D653A312C';
wwv_flow_imp.g_varchar2_table(2903) := '76616C75653A657D2C7428297D29297D63616E63656C28297B72657475726E20746869732E6572726F72286E6577204965297D7D766172204A743B2166756E6374696F6E2865297B652E736574746C65643D6173796E632066756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(2904) := '6C657420743B636F6E7374206E3D61776169742050726F6D6973652E616C6C28652E6D61702828653D3E652E7468656E2828653D3E65292C28653D3E7B747C7C28743D65297D29292929293B696628766F69642030213D3D74297468726F7720743B7265';
wwv_flow_imp.g_varchar2_table(2905) := '7475726E206E7D2C652E776974684173796E63426F64793D66756E6374696F6E2865297B72657475726E206E65772050726F6D69736528286173796E6328742C6E293D3E7B7472797B6177616974206528742C6E297D63617463682865297B6E2865297D';
wwv_flow_imp.g_varchar2_table(2906) := '7D29297D7D284A747C7C284A743D7B7D29293B636C61737320656E7B7374617469632066726F6D41727261792865297B72657475726E206E657720656E2828743D3E7B742E656D69744D616E792865297D29297D7374617469632066726F6D50726F6D69';
wwv_flow_imp.g_varchar2_table(2907) := '73652865297B72657475726E206E657720656E28286173796E6320743D3E7B742E656D69744D616E792861776169742065297D29297D7374617469632066726F6D50726F6D697365732865297B72657475726E206E657720656E28286173796E6320743D';
wwv_flow_imp.g_varchar2_table(2908) := '3E7B61776169742050726F6D6973652E616C6C28652E6D617028286173796E6320653D3E742E656D69744F6E652861776169742065292929297D29297D737461746963206D657267652865297B72657475726E206E657720656E28286173796E6320743D';
wwv_flow_imp.g_varchar2_table(2909) := '3E7B61776169742050726F6D6973652E616C6C28652E6D617028286173796E6320653D3E7B666F7220617761697428636F6E7374206E206F66206529742E656D69744F6E65286E297D2929297D29297D636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(2910) := '732E5F73746174653D302C746869732E5F726573756C74733D5B5D2C746869732E5F6572726F723D6E756C6C2C746869732E5F6F6E52657475726E3D742C746869732E5F6F6E53746174654368616E6765643D6E65772043742C71756575654D6963726F';
wwv_flow_imp.g_varchar2_table(2911) := '7461736B28286173796E6328293D3E7B636F6E737420743D7B656D69744F6E653A653D3E746869732E656D69744F6E652865292C656D69744D616E793A653D3E746869732E656D69744D616E792865292C72656A6563743A653D3E746869732E72656A65';
wwv_flow_imp.g_varchar2_table(2912) := '63742865297D3B7472797B61776169742050726F6D6973652E7265736F6C76652865287429292C746869732E7265736F6C766528297D63617463682865297B746869732E72656A6563742865297D66696E616C6C797B742E656D69744F6E653D766F6964';
wwv_flow_imp.g_varchar2_table(2913) := '20302C742E656D69744D616E793D766F696420302C742E72656A6563743D766F696420307D7D29297D5B53796D626F6C2E6173796E634974657261746F725D28297B6C657420653D303B72657475726E7B6E6578743A6173796E6328293D3E7B666F7228';
wwv_flow_imp.g_varchar2_table(2914) := '3B3B297B696628323D3D3D746869732E5F7374617465297468726F7720746869732E5F6572726F723B696628653C746869732E5F726573756C74732E6C656E6774682972657475726E7B646F6E653A21312C76616C75653A746869732E5F726573756C74';
wwv_flow_imp.g_varchar2_table(2915) := '735B652B2B5D7D3B696628313D3D3D746869732E5F73746174652972657475726E7B646F6E653A21302C76616C75653A766F696420307D3B61776169742076742E746F50726F6D69736528746869732E5F6F6E53746174654368616E6765642E6576656E';
wwv_flow_imp.g_varchar2_table(2916) := '74297D7D2C72657475726E3A6173796E6328293D3E7B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F6F6E52657475726E297C7C766F696420303D3D3D657C7C652E63616C6C2874686973292C7B646F6E653A21302C76616C75';
wwv_flow_imp.g_varchar2_table(2917) := '653A766F696420307D7D7D7D737461746963206D617028652C74297B72657475726E206E657720656E28286173796E63206E3D3E7B666F7220617761697428636F6E73742069206F662065296E2E656D69744F6E652874286929297D29297D6D61702865';
wwv_flow_imp.g_varchar2_table(2918) := '297B72657475726E20656E2E6D617028746869732C65297D7374617469632066696C74657228652C74297B72657475726E206E657720656E28286173796E63206E3D3E7B666F7220617761697428636F6E73742069206F662065297428692926266E2E65';
wwv_flow_imp.g_varchar2_table(2919) := '6D69744F6E652869297D29297D66696C7465722865297B72657475726E20656E2E66696C74657228746869732C65297D73746174696320636F616C657363652865297B72657475726E20656E2E66696C74657228652C28653D3E21216529297D636F616C';
wwv_flow_imp.g_varchar2_table(2920) := '6573636528297B72657475726E20656E2E636F616C657363652874686973297D737461746963206173796E6320746F50726F6D6973652865297B636F6E737420743D5B5D3B666F7220617761697428636F6E7374206E206F66206529742E70757368286E';
wwv_flow_imp.g_varchar2_table(2921) := '293B72657475726E20747D746F50726F6D69736528297B72657475726E20656E2E746F50726F6D6973652874686973297D656D69744F6E652865297B303D3D3D746869732E5F7374617465262628746869732E5F726573756C74732E707573682865292C';
wwv_flow_imp.g_varchar2_table(2922) := '746869732E5F6F6E53746174654368616E6765642E666972652829297D656D69744D616E792865297B303D3D3D746869732E5F7374617465262628746869732E5F726573756C74733D746869732E5F726573756C74732E636F6E6361742865292C746869';
wwv_flow_imp.g_varchar2_table(2923) := '732E5F6F6E53746174654368616E6765642E666972652829297D7265736F6C766528297B303D3D3D746869732E5F7374617465262628746869732E5F73746174653D312C746869732E5F6F6E53746174654368616E6765642E666972652829297D72656A';
wwv_flow_imp.g_varchar2_table(2924) := '6563742865297B303D3D3D746869732E5F7374617465262628746869732E5F73746174653D322C746869732E5F6572726F723D652C746869732E5F6F6E53746174654368616E6765642E666972652829297D7D656E2E454D5054593D656E2E66726F6D41';
wwv_flow_imp.g_varchar2_table(2925) := '72726179285B5D293B636C61737320746E20657874656E647320656E7B636F6E7374727563746F7228652C74297B73757065722874292C746869732E5F736F757263653D657D63616E63656C28297B746869732E5F736F757263652E63616E63656C2829';
wwv_flow_imp.g_varchar2_table(2926) := '7D7D636F6E73747B656E74726965733A6E6E2C73657450726F746F747970654F663A6F6E2C697346726F7A656E3A736E2C67657450726F746F747970654F663A726E2C6765744F776E50726F706572747944657363726970746F723A616E7D3D4F626A65';
wwv_flow_imp.g_varchar2_table(2927) := '63743B6C65747B667265657A653A6C6E2C7365616C3A636E2C6372656174653A646E7D3D4F626A6563742C7B6170706C793A686E2C636F6E7374727563743A756E7D3D22756E646566696E656422213D747970656F66205265666C65637426265265666C';
wwv_flow_imp.g_varchar2_table(2928) := '6563743B686E7C7C28686E3D66756E6374696F6E28652C742C6E297B72657475726E20652E6170706C7928742C6E297D292C6C6E7C7C286C6E3D66756E6374696F6E2865297B72657475726E20657D292C636E7C7C28636E3D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(2929) := '7B72657475726E20657D292C756E7C7C28756E3D66756E6374696F6E28652C74297B72657475726E206E65772065282E2E2E74297D293B636F6E737420706E3D6B6E2841727261792E70726F746F747970652E666F7245616368292C676E3D6B6E284172';
wwv_flow_imp.g_varchar2_table(2930) := '7261792E70726F746F747970652E706F70292C6D6E3D6B6E2841727261792E70726F746F747970652E70757368292C666E3D6B6E28537472696E672E70726F746F747970652E746F4C6F77657243617365292C766E3D6B6E28537472696E672E70726F74';
wwv_flow_imp.g_varchar2_table(2931) := '6F747970652E746F537472696E67292C626E3D6B6E28537472696E672E70726F746F747970652E6D61746368292C5F6E3D6B6E28537472696E672E70726F746F747970652E7265706C616365292C796E3D6B6E28537472696E672E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(2932) := '2E696E6465784F66292C776E3D6B6E28537472696E672E70726F746F747970652E7472696D292C436E3D6B6E285265674578702E70726F746F747970652E74657374292C536E3D28786E3D547970654572726F722C66756E6374696F6E28297B666F7228';
wwv_flow_imp.g_varchar2_table(2933) := '76617220653D617267756D656E74732E6C656E6774682C743D6E65772041727261792865292C6E3D303B6E3C653B6E2B2B29745B6E5D3D617267756D656E74735B6E5D3B72657475726E20756E28786E2C74297D293B76617220786E3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(2934) := '6E206B6E2865297B72657475726E2066756E6374696F6E2874297B666F7228766172206E3D617267756D656E74732E6C656E6774682C693D6E6577204172726179286E3E313F6E2D313A30292C6F3D313B6F3C6E3B6F2B2B29695B6F2D315D3D61726775';
wwv_flow_imp.g_varchar2_table(2935) := '6D656E74735B6F5D3B72657475726E20686E28652C742C69297D7D66756E6374696F6E20456E28652C742C6E297B76617220693B6E3D6E756C6C213D3D28693D6E292626766F69642030213D3D693F693A666E2C6F6E26266F6E28652C6E756C6C293B6C';
wwv_flow_imp.g_varchar2_table(2936) := '6574206F3D742E6C656E6774683B666F72283B6F2D2D3B297B6C657420693D745B6F5D3B69662822737472696E67223D3D747970656F662069297B636F6E737420653D6E2869293B65213D3D69262628736E2874297C7C28745B6F5D3D65292C693D6529';
wwv_flow_imp.g_varchar2_table(2937) := '7D655B695D3D21307D72657475726E20657D66756E6374696F6E204C6E2865297B636F6E737420743D646E286E756C6C293B666F7228636F6E73745B6E2C695D6F66206E6E28652929745B6E5D3D693B72657475726E20747D66756E6374696F6E20446E';
wwv_flow_imp.g_varchar2_table(2938) := '28652C74297B666F72283B6E756C6C213D3D653B297B636F6E7374206E3D616E28652C74293B6966286E297B6966286E2E6765742972657475726E206B6E286E2E676574293B6966282266756E6374696F6E223D3D747970656F66206E2E76616C756529';
wwv_flow_imp.g_varchar2_table(2939) := '72657475726E206B6E286E2E76616C7565297D653D726E2865297D72657475726E2066756E6374696F6E2865297B72657475726E20636F6E736F6C652E7761726E282266616C6C6261636B2076616C756520666F72222C65292C6E756C6C7D7D636F6E73';
wwv_flow_imp.g_varchar2_table(2940) := '7420546E3D6C6E285B2261222C2261626272222C226163726F6E796D222C2261646472657373222C2261726561222C2261727469636C65222C226173696465222C22617564696F222C2262222C22626469222C2262646F222C22626967222C22626C696E';
wwv_flow_imp.g_varchar2_table(2941) := '6B222C22626C6F636B71756F7465222C22626F6479222C226272222C22627574746F6E222C2263616E766173222C2263617074696F6E222C2263656E746572222C2263697465222C22636F6465222C22636F6C222C22636F6C67726F7570222C22636F6E';
wwv_flow_imp.g_varchar2_table(2942) := '74656E74222C2264617461222C22646174616C697374222C226464222C226465636F7261746F72222C2264656C222C2264657461696C73222C2264666E222C226469616C6F67222C22646972222C22646976222C22646C222C226474222C22656C656D65';
wwv_flow_imp.g_varchar2_table(2943) := '6E74222C22656D222C226669656C64736574222C2266696763617074696F6E222C22666967757265222C22666F6E74222C22666F6F746572222C22666F726D222C226831222C226832222C226833222C226834222C226835222C226836222C2268656164';
wwv_flow_imp.g_varchar2_table(2944) := '222C22686561646572222C226867726F7570222C226872222C2268746D6C222C2269222C22696D67222C22696E707574222C22696E73222C226B6264222C226C6162656C222C226C6567656E64222C226C69222C226D61696E222C226D6170222C226D61';
wwv_flow_imp.g_varchar2_table(2945) := '726B222C226D617271756565222C226D656E75222C226D656E756974656D222C226D65746572222C226E6176222C226E6F6272222C226F6C222C226F707467726F7570222C226F7074696F6E222C226F7574707574222C2270222C227069637475726522';
wwv_flow_imp.g_varchar2_table(2946) := '2C22707265222C2270726F6772657373222C2271222C227270222C227274222C2272756279222C2273222C2273616D70222C2273656374696F6E222C2273656C656374222C22736861646F77222C22736D616C6C222C22736F75726365222C2273706163';
wwv_flow_imp.g_varchar2_table(2947) := '6572222C227370616E222C22737472696B65222C227374726F6E67222C227374796C65222C22737562222C2273756D6D617279222C22737570222C227461626C65222C2274626F6479222C227464222C2274656D706C617465222C227465787461726561';
wwv_flow_imp.g_varchar2_table(2948) := '222C2274666F6F74222C227468222C227468656164222C2274696D65222C227472222C22747261636B222C227474222C2275222C22756C222C22766172222C22766964656F222C22776272225D292C496E3D6C6E285B22737667222C2261222C22616C74';
wwv_flow_imp.g_varchar2_table(2949) := '676C797068222C22616C74676C797068646566222C22616C74676C7970686974656D222C22616E696D617465636F6C6F72222C22616E696D6174656D6F74696F6E222C22616E696D6174657472616E73666F726D222C22636972636C65222C22636C6970';
wwv_flow_imp.g_varchar2_table(2950) := '70617468222C2264656673222C2264657363222C22656C6C69707365222C2266696C746572222C22666F6E74222C2267222C22676C797068222C22676C797068726566222C22686B65726E222C22696D616765222C226C696E65222C226C696E65617267';
wwv_flow_imp.g_varchar2_table(2951) := '72616469656E74222C226D61726B6572222C226D61736B222C226D65746164617461222C226D70617468222C2270617468222C227061747465726E222C22706F6C79676F6E222C22706F6C796C696E65222C2272616469616C6772616469656E74222C22';
wwv_flow_imp.g_varchar2_table(2952) := '72656374222C2273746F70222C227374796C65222C22737769746368222C2273796D626F6C222C2274657874222C227465787470617468222C227469746C65222C2274726566222C22747370616E222C2276696577222C22766B65726E225D292C4D6E3D';
wwv_flow_imp.g_varchar2_table(2953) := '6C6E285B226665426C656E64222C226665436F6C6F724D6174726978222C226665436F6D706F6E656E745472616E73666572222C226665436F6D706F73697465222C226665436F6E766F6C76654D6174726978222C226665446966667573654C69676874';
wwv_flow_imp.g_varchar2_table(2954) := '696E67222C226665446973706C6163656D656E744D6170222C22666544697374616E744C69676874222C22666544726F70536861646F77222C226665466C6F6F64222C22666546756E6341222C22666546756E6342222C22666546756E6347222C226665';
wwv_flow_imp.g_varchar2_table(2955) := '46756E6352222C226665476175737369616E426C7572222C226665496D616765222C2266654D65726765222C2266654D657267654E6F6465222C2266654D6F7270686F6C6F6779222C2266654F6666736574222C226665506F696E744C69676874222C22';
wwv_flow_imp.g_varchar2_table(2956) := '666553706563756C61724C69676874696E67222C22666553706F744C69676874222C22666554696C65222C22666554757262756C656E6365225D292C416E3D6C6E285B22616E696D617465222C22636F6C6F722D70726F66696C65222C22637572736F72';
wwv_flow_imp.g_varchar2_table(2957) := '222C2264697363617264222C22666F6E742D66616365222C22666F6E742D666163652D666F726D6174222C22666F6E742D666163652D6E616D65222C22666F6E742D666163652D737263222C22666F6E742D666163652D757269222C22666F726569676E';
wwv_flow_imp.g_varchar2_table(2958) := '6F626A656374222C226861746368222C22686174636870617468222C226D657368222C226D6573686772616469656E74222C226D6573687061746368222C226D657368726F77222C226D697373696E672D676C797068222C22736372697074222C227365';
wwv_flow_imp.g_varchar2_table(2959) := '74222C22736F6C6964636F6C6F72222C22756E6B6E6F776E222C22757365225D292C4E6E3D6C6E285B226D617468222C226D656E636C6F7365222C226D6572726F72222C226D66656E636564222C226D66726163222C226D676C797068222C226D69222C';
wwv_flow_imp.g_varchar2_table(2960) := '226D6C6162656C65647472222C226D6D756C746973637269707473222C226D6E222C226D6F222C226D6F766572222C226D706164646564222C226D7068616E746F6D222C226D726F6F74222C226D726F77222C226D73222C226D7370616365222C226D73';
wwv_flow_imp.g_varchar2_table(2961) := '717274222C226D7374796C65222C226D737562222C226D737570222C226D737562737570222C226D7461626C65222C226D7464222C226D74657874222C226D7472222C226D756E646572222C226D756E6465726F766572222C226D707265736372697074';
wwv_flow_imp.g_varchar2_table(2962) := '73225D292C506E3D6C6E285B226D616374696F6E222C226D616C69676E67726F7570222C226D616C69676E6D61726B222C226D6C6F6E67646976222C226D7363617272696573222C226D736361727279222C226D7367726F7570222C226D737461636B22';
wwv_flow_imp.g_varchar2_table(2963) := '2C226D736C696E65222C226D73726F77222C2273656D616E74696373222C22616E6E6F746174696F6E222C22616E6E6F746174696F6E2D786D6C222C226D70726573637269707473222C226E6F6E65225D292C4F6E3D6C6E285B222374657874225D292C';
wwv_flow_imp.g_varchar2_table(2964) := '526E3D6C6E285B22616363657074222C22616374696F6E222C22616C69676E222C22616C74222C226175746F6361706974616C697A65222C226175746F636F6D706C657465222C226175746F70696374757265696E70696374757265222C226175746F70';
wwv_flow_imp.g_varchar2_table(2965) := '6C6179222C226261636B67726F756E64222C226267636F6C6F72222C22626F72646572222C2263617074757265222C2263656C6C70616464696E67222C2263656C6C73706163696E67222C22636865636B6564222C2263697465222C22636C617373222C';
wwv_flow_imp.g_varchar2_table(2966) := '22636C656172222C22636F6C6F72222C22636F6C73222C22636F6C7370616E222C22636F6E74726F6C73222C22636F6E74726F6C736C697374222C22636F6F726473222C2263726F73736F726967696E222C226461746574696D65222C226465636F6469';
wwv_flow_imp.g_varchar2_table(2967) := '6E67222C2264656661756C74222C22646972222C2264697361626C6564222C2264697361626C6570696374757265696E70696374757265222C2264697361626C6572656D6F7465706C61796261636B222C22646F776E6C6F6164222C2264726167676162';
wwv_flow_imp.g_varchar2_table(2968) := '6C65222C22656E6374797065222C22656E7465726B657968696E74222C2266616365222C22666F72222C2268656164657273222C22686569676874222C2268696464656E222C2268696768222C2268726566222C22687265666C616E67222C226964222C';
wwv_flow_imp.g_varchar2_table(2969) := '22696E7075746D6F6465222C22696E74656772697479222C2269736D6170222C226B696E64222C226C6162656C222C226C616E67222C226C697374222C226C6F6164696E67222C226C6F6F70222C226C6F77222C226D6178222C226D61786C656E677468';
wwv_flow_imp.g_varchar2_table(2970) := '222C226D65646961222C226D6574686F64222C226D696E222C226D696E6C656E677468222C226D756C7469706C65222C226D75746564222C226E616D65222C226E6F6E6365222C226E6F7368616465222C226E6F76616C6964617465222C226E6F777261';
wwv_flow_imp.g_varchar2_table(2971) := '70222C226F70656E222C226F7074696D756D222C227061747465726E222C22706C616365686F6C646572222C22706C617973696E6C696E65222C22706F73746572222C227072656C6F6164222C2270756264617465222C22726164696F67726F7570222C';
wwv_flow_imp.g_varchar2_table(2972) := '22726561646F6E6C79222C2272656C222C227265717569726564222C22726576222C227265766572736564222C22726F6C65222C22726F7773222C22726F777370616E222C227370656C6C636865636B222C2273636F7065222C2273656C656374656422';
wwv_flow_imp.g_varchar2_table(2973) := '2C227368617065222C2273697A65222C2273697A6573222C227370616E222C227372636C616E67222C227374617274222C22737263222C22737263736574222C2273746570222C227374796C65222C2273756D6D617279222C22746162696E646578222C';
wwv_flow_imp.g_varchar2_table(2974) := '227469746C65222C227472616E736C617465222C2274797065222C227573656D6170222C2276616C69676E222C2276616C7565222C227769647468222C22786D6C6E73222C22736C6F74225D292C466E3D6C6E285B22616363656E742D68656967687422';
wwv_flow_imp.g_varchar2_table(2975) := '2C22616363756D756C617465222C226164646974697665222C22616C69676E6D656E742D626173656C696E65222C22617363656E74222C226174747269627574656E616D65222C2261747472696275746574797065222C22617A696D757468222C226261';
wwv_flow_imp.g_varchar2_table(2976) := '73656672657175656E6379222C22626173656C696E652D7368696674222C22626567696E222C2262696173222C226279222C22636C617373222C22636C6970222C22636C697070617468756E697473222C22636C69702D70617468222C22636C69702D72';
wwv_flow_imp.g_varchar2_table(2977) := '756C65222C22636F6C6F72222C22636F6C6F722D696E746572706F6C6174696F6E222C22636F6C6F722D696E746572706F6C6174696F6E2D66696C74657273222C22636F6C6F722D70726F66696C65222C22636F6C6F722D72656E646572696E67222C22';
wwv_flow_imp.g_varchar2_table(2978) := '6378222C226379222C2264222C226478222C226479222C2264696666757365636F6E7374616E74222C22646972656374696F6E222C22646973706C6179222C2264697669736F72222C22647572222C22656467656D6F6465222C22656C65766174696F6E';
wwv_flow_imp.g_varchar2_table(2979) := '222C22656E64222C2266696C6C222C2266696C6C2D6F706163697479222C2266696C6C2D72756C65222C2266696C746572222C2266696C746572756E697473222C22666C6F6F642D636F6C6F72222C22666C6F6F642D6F706163697479222C22666F6E74';
wwv_flow_imp.g_varchar2_table(2980) := '2D66616D696C79222C22666F6E742D73697A65222C22666F6E742D73697A652D61646A757374222C22666F6E742D73747265746368222C22666F6E742D7374796C65222C22666F6E742D76617269616E74222C22666F6E742D776569676874222C226678';
wwv_flow_imp.g_varchar2_table(2981) := '222C226679222C226731222C226732222C22676C7970682D6E616D65222C22676C797068726566222C226772616469656E74756E697473222C226772616469656E747472616E73666F726D222C22686569676874222C2268726566222C226964222C2269';
wwv_flow_imp.g_varchar2_table(2982) := '6D6167652D72656E646572696E67222C22696E222C22696E32222C226B222C226B31222C226B32222C226B33222C226B34222C226B65726E696E67222C226B6579706F696E7473222C226B657973706C696E6573222C226B657974696D6573222C226C61';
wwv_flow_imp.g_varchar2_table(2983) := '6E67222C226C656E67746861646A757374222C226C65747465722D73706163696E67222C226B65726E656C6D6174726978222C226B65726E656C756E69746C656E677468222C226C69676874696E672D636F6C6F72222C226C6F63616C222C226D61726B';
wwv_flow_imp.g_varchar2_table(2984) := '65722D656E64222C226D61726B65722D6D6964222C226D61726B65722D7374617274222C226D61726B6572686569676874222C226D61726B6572756E697473222C226D61726B65727769647468222C226D61736B636F6E74656E74756E697473222C226D';
wwv_flow_imp.g_varchar2_table(2985) := '61736B756E697473222C226D6178222C226D61736B222C226D65646961222C226D6574686F64222C226D6F6465222C226D696E222C226E616D65222C226E756D6F637461766573222C226F6666736574222C226F70657261746F72222C226F7061636974';
wwv_flow_imp.g_varchar2_table(2986) := '79222C226F72646572222C226F7269656E74222C226F7269656E746174696F6E222C226F726967696E222C226F766572666C6F77222C227061696E742D6F72646572222C2270617468222C22706174686C656E677468222C227061747465726E636F6E74';
wwv_flow_imp.g_varchar2_table(2987) := '656E74756E697473222C227061747465726E7472616E73666F726D222C227061747465726E756E697473222C22706F696E7473222C227072657365727665616C706861222C227072657365727665617370656374726174696F222C227072696D69746976';
wwv_flow_imp.g_varchar2_table(2988) := '65756E697473222C2272222C227278222C227279222C22726164697573222C2272656678222C2272656679222C22726570656174636F756E74222C22726570656174647572222C2272657374617274222C22726573756C74222C22726F74617465222C22';
wwv_flow_imp.g_varchar2_table(2989) := '7363616C65222C2273656564222C2273686170652D72656E646572696E67222C2273706563756C6172636F6E7374616E74222C2273706563756C61726578706F6E656E74222C227370726561646D6574686F64222C2273746172746F6666736574222C22';
wwv_flow_imp.g_varchar2_table(2990) := '737464646576696174696F6E222C2273746974636874696C6573222C2273746F702D636F6C6F72222C2273746F702D6F706163697479222C227374726F6B652D646173686172726179222C227374726F6B652D646173686F6666736574222C227374726F';
wwv_flow_imp.g_varchar2_table(2991) := '6B652D6C696E65636170222C227374726F6B652D6C696E656A6F696E222C227374726F6B652D6D697465726C696D6974222C227374726F6B652D6F706163697479222C227374726F6B65222C227374726F6B652D7769647468222C227374796C65222C22';
wwv_flow_imp.g_varchar2_table(2992) := '737572666163657363616C65222C2273797374656D6C616E6775616765222C22746162696E646578222C2274617267657478222C2274617267657479222C227472616E73666F726D222C227472616E73666F726D2D6F726967696E222C22746578742D61';
wwv_flow_imp.g_varchar2_table(2993) := '6E63686F72222C22746578742D6465636F726174696F6E222C22746578742D72656E646572696E67222C22746578746C656E677468222C2274797065222C227531222C227532222C22756E69636F6465222C2276616C756573222C2276696577626F7822';
wwv_flow_imp.g_varchar2_table(2994) := '2C227669736962696C697479222C2276657273696F6E222C22766572742D6164762D79222C22766572742D6F726967696E2D78222C22766572742D6F726967696E2D79222C227769647468222C22776F72642D73706163696E67222C2277726170222C22';
wwv_flow_imp.g_varchar2_table(2995) := '77726974696E672D6D6F6465222C22786368616E6E656C73656C6563746F72222C22796368616E6E656C73656C6563746F72222C2278222C227831222C227832222C22786D6C6E73222C2279222C227931222C227932222C227A222C227A6F6F6D616E64';
wwv_flow_imp.g_varchar2_table(2996) := '70616E225D292C426E3D6C6E285B22616363656E74222C22616363656E74756E646572222C22616C69676E222C22626576656C6C6564222C22636C6F7365222C22636F6C756D6E73616C69676E222C22636F6C756D6E6C696E6573222C22636F6C756D6E';
wwv_flow_imp.g_varchar2_table(2997) := '7370616E222C2264656E6F6D616C69676E222C226465707468222C22646972222C22646973706C6179222C22646973706C61797374796C65222C22656E636F64696E67222C2266656E6365222C226672616D65222C22686569676874222C226872656622';
wwv_flow_imp.g_varchar2_table(2998) := '2C226964222C226C617267656F70222C226C656E677468222C226C696E65746869636B6E657373222C226C7370616365222C226C71756F7465222C226D6174686261636B67726F756E64222C226D617468636F6C6F72222C226D61746873697A65222C22';
wwv_flow_imp.g_varchar2_table(2999) := '6D61746876617269616E74222C226D617873697A65222C226D696E73697A65222C226D6F7661626C656C696D697473222C226E6F746174696F6E222C226E756D616C69676E222C226F70656E222C22726F77616C69676E222C22726F776C696E6573222C';
wwv_flow_imp.g_varchar2_table(3000) := '22726F7773706163696E67222C22726F777370616E222C22727370616365222C227271756F7465222C227363726970746C6576656C222C227363726970746D696E73697A65222C2273637269707473697A656D756C7469706C696572222C2273656C6563';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(3001) := '74696F6E222C22736570617261746F72222C22736570617261746F7273222C227374726574636879222C227375627363726970747368696674222C227375707363726970747368696674222C2273796D6D6574726963222C22766F6666736574222C2277';
wwv_flow_imp.g_varchar2_table(3002) := '69647468222C22786D6C6E73225D292C566E3D6C6E285B22786C696E6B3A68726566222C22786D6C3A6964222C22786C696E6B3A7469746C65222C22786D6C3A7370616365222C22786D6C6E733A786C696E6B225D292C7A6E3D636E282F5C7B5C7B5B5C';
wwv_flow_imp.g_varchar2_table(3003) := '775C575D2A7C5B5C775C575D2A5C7D5C7D2F676D292C486E3D636E282F3C255B5C775C575D2A7C5B5C775C575D2A253E2F676D292C576E3D636E282F5C247B5B5C775C575D2A7D2F676D292C6A6E3D636E282F5E646174612D5B5C2D5C772E5C75303042';
wwv_flow_imp.g_varchar2_table(3004) := '372D5C75464646465D2F292C716E3D636E282F5E617269612D5B5C2D5C775D2B242F292C246E3D636E282F5E283F3A283F3A283F3A667C6874297470733F7C6D61696C746F7C74656C7C63616C6C746F7C736D737C6369647C786D7070293A7C5B5E612D';
wwv_flow_imp.g_varchar2_table(3005) := '7A5D7C5B612D7A2B2E5C2D5D2B283F3A5B5E612D7A2B2E5C2D3A5D7C2429292F69292C556E3D636E282F5E283F3A5C772B7363726970747C64617461293A2F69292C4B6E3D636E282F5B5C75303030302D5C75303032305C75303041305C75313638305C';
wwv_flow_imp.g_varchar2_table(3006) := '75313830455C75323030302D5C75323032395C75323035465C75333030305D2F67292C476E3D636E282F5E68746D6C242F69293B76617220516E3D4F626A6563742E667265657A65287B5F5F70726F746F5F5F3A6E756C6C2C4D555354414348455F4558';
wwv_flow_imp.g_varchar2_table(3007) := '50523A7A6E2C4552425F455850523A486E2C544D504C49545F455850523A576E2C444154415F415454523A6A6E2C415249415F415454523A716E2C49535F414C4C4F5745445F5552493A246E2C49535F5343524950545F4F525F444154413A556E2C4154';
wwv_flow_imp.g_varchar2_table(3008) := '54525F574849544553504143453A4B6E2C444F43545950455F4E414D453A476E7D293B636F6E737420596E3D28293D3E22756E646566696E6564223D3D747970656F662077696E646F773F6E756C6C3A77696E646F773B766172205A6E3D66756E637469';
wwv_flow_imp.g_varchar2_table(3009) := '6F6E206528297B6C657420743D617267756D656E74732E6C656E6774683E302626766F69642030213D3D617267756D656E74735B305D3F617267756D656E74735B305D3A596E28293B636F6E7374206E3D743D3E652874293B6966286E2E76657273696F';
wwv_flow_imp.g_varchar2_table(3010) := '6E3D22332E302E35222C6E2E72656D6F7665643D5B5D2C21747C7C21742E646F63756D656E747C7C39213D3D742E646F63756D656E742E6E6F6465547970652972657475726E206E2E6973537570706F727465643D21312C6E3B636F6E737420693D742E';
wwv_flow_imp.g_varchar2_table(3011) := '646F63756D656E742C6F3D692E63757272656E745363726970743B6C65747B646F63756D656E743A737D3D743B636F6E73747B446F63756D656E74467261676D656E743A722C48544D4C54656D706C617465456C656D656E743A612C4E6F64653A6C2C45';
wwv_flow_imp.g_varchar2_table(3012) := '6C656D656E743A632C4E6F646546696C7465723A642C4E616D65644E6F64654D61703A683D742E4E616D65644E6F64654D61707C7C742E4D6F7A4E616D6564417474724D61702C48544D4C466F726D456C656D656E743A752C444F4D5061727365723A70';
wwv_flow_imp.g_varchar2_table(3013) := '2C7472757374656454797065733A677D3D742C6D3D632E70726F746F747970652C663D446E286D2C22636C6F6E654E6F646522292C763D446E286D2C226E6578745369626C696E6722292C623D446E286D2C226368696C644E6F64657322292C5F3D446E';
wwv_flow_imp.g_varchar2_table(3014) := '286D2C22706172656E744E6F646522293B6966282266756E6374696F6E223D3D747970656F662061297B636F6E737420653D732E637265617465456C656D656E74282274656D706C61746522293B652E636F6E74656E742626652E636F6E74656E742E6F';
wwv_flow_imp.g_varchar2_table(3015) := '776E6572446F63756D656E74262628733D652E636F6E74656E742E6F776E6572446F63756D656E74297D6C657420792C773D22223B636F6E73747B696D706C656D656E746174696F6E3A432C6372656174654E6F64654974657261746F723A532C637265';
wwv_flow_imp.g_varchar2_table(3016) := '617465446F63756D656E74467261676D656E743A782C676574456C656D656E747342795461674E616D653A6B7D3D732C7B696D706F72744E6F64653A457D3D693B6C6574204C3D7B7D3B6E2E6973537570706F727465643D2266756E6374696F6E223D3D';
wwv_flow_imp.g_varchar2_table(3017) := '747970656F66206E6E26262266756E6374696F6E223D3D747970656F66205F2626432626766F69642030213D3D432E63726561746548544D4C446F63756D656E743B636F6E73747B4D555354414348455F455850523A442C4552425F455850523A542C54';
wwv_flow_imp.g_varchar2_table(3018) := '4D504C49545F455850523A492C444154415F415454523A4D2C415249415F415454523A412C49535F5343524950545F4F525F444154413A4E2C415454525F574849544553504143453A507D3D516E3B6C65747B49535F414C4C4F5745445F5552493A4F7D';
wwv_flow_imp.g_varchar2_table(3019) := '3D516E2C523D6E756C6C3B636F6E737420463D456E287B7D2C5B2E2E2E546E2C2E2E2E496E2C2E2E2E4D6E2C2E2E2E4E6E2C2E2E2E4F6E5D293B6C657420423D6E756C6C3B636F6E737420563D456E287B7D2C5B2E2E2E526E2C2E2E2E466E2C2E2E2E42';
wwv_flow_imp.g_varchar2_table(3020) := '6E2C2E2E2E566E5D293B6C6574207A3D4F626A6563742E7365616C284F626A6563742E637265617465286E756C6C2C7B7461674E616D65436865636B3A7B7772697461626C653A21302C636F6E666967757261626C653A21312C656E756D657261626C65';
wwv_flow_imp.g_varchar2_table(3021) := '3A21302C76616C75653A6E756C6C7D2C6174747269627574654E616D65436865636B3A7B7772697461626C653A21302C636F6E666967757261626C653A21312C656E756D657261626C653A21302C76616C75653A6E756C6C7D2C616C6C6F77437573746F';
wwv_flow_imp.g_varchar2_table(3022) := '6D697A65644275696C74496E456C656D656E74733A7B7772697461626C653A21302C636F6E666967757261626C653A21312C656E756D657261626C653A21302C76616C75653A21317D7D29292C483D6E756C6C2C573D6E756C6C2C6A3D21302C713D2130';
wwv_flow_imp.g_varchar2_table(3023) := '2C243D21312C553D21302C4B3D21312C473D21312C513D21312C593D21312C5A3D21312C583D21312C4A3D21312C65653D21302C74653D21312C6E653D21302C69653D21312C6F653D7B7D2C73653D6E756C6C3B636F6E73742072653D456E287B7D2C5B';
wwv_flow_imp.g_varchar2_table(3024) := '22616E6E6F746174696F6E2D786D6C222C22617564696F222C22636F6C67726F7570222C2264657363222C22666F726569676E6F626A656374222C2268656164222C22696672616D65222C226D617468222C226D69222C226D6E222C226D6F222C226D73';
wwv_flow_imp.g_varchar2_table(3025) := '222C226D74657874222C226E6F656D626564222C226E6F6672616D6573222C226E6F736372697074222C22706C61696E74657874222C22736372697074222C227374796C65222C22737667222C2274656D706C617465222C227468656164222C22746974';
wwv_flow_imp.g_varchar2_table(3026) := '6C65222C22766964656F222C22786D70225D293B6C65742061653D6E756C6C3B636F6E7374206C653D456E287B7D2C5B22617564696F222C22766964656F222C22696D67222C22736F75726365222C22696D616765222C22747261636B225D293B6C6574';
wwv_flow_imp.g_varchar2_table(3027) := '2063653D6E756C6C3B636F6E73742064653D456E287B7D2C5B22616C74222C22636C617373222C22666F72222C226964222C226C6162656C222C226E616D65222C227061747465726E222C22706C616365686F6C646572222C22726F6C65222C2273756D';
wwv_flow_imp.g_varchar2_table(3028) := '6D617279222C227469746C65222C2276616C7565222C227374796C65222C22786D6C6E73225D292C68653D22687474703A2F2F7777772E77332E6F72672F313939382F4D6174682F4D6174684D4C222C75653D22687474703A2F2F7777772E77332E6F72';
wwv_flow_imp.g_varchar2_table(3029) := '672F323030302F737667222C70653D22687474703A2F2F7777772E77332E6F72672F313939392F7868746D6C223B6C65742067653D70652C6D653D21312C66653D6E756C6C3B636F6E73742076653D456E287B7D2C5B68652C75652C70655D2C766E293B';
wwv_flow_imp.g_varchar2_table(3030) := '6C65742062653B636F6E7374205F653D5B226170706C69636174696F6E2F7868746D6C2B786D6C222C22746578742F68746D6C225D3B6C65742079652C77653D6E756C6C3B636F6E73742043653D732E637265617465456C656D656E742822666F726D22';
wwv_flow_imp.g_varchar2_table(3031) := '292C53653D66756E6374696F6E2865297B72657475726E206520696E7374616E63656F66205265674578707C7C6520696E7374616E63656F662046756E6374696F6E7D2C78653D66756E6374696F6E2865297B6966282177657C7C7765213D3D65297B69';
wwv_flow_imp.g_varchar2_table(3032) := '6628652626226F626A656374223D3D747970656F6620657C7C28653D7B7D292C653D4C6E2865292C62653D62653D2D313D3D3D5F652E696E6465784F6628652E5041525345525F4D454449415F54595045293F22746578742F68746D6C223A652E504152';
wwv_flow_imp.g_varchar2_table(3033) := '5345525F4D454449415F545950452C79653D226170706C69636174696F6E2F7868746D6C2B786D6C223D3D3D62653F766E3A666E2C523D22414C4C4F5745445F5441475322696E20653F456E287B7D2C652E414C4C4F5745445F544147532C7965293A46';
wwv_flow_imp.g_varchar2_table(3034) := '2C423D22414C4C4F5745445F4154545222696E20653F456E287B7D2C652E414C4C4F5745445F415454522C7965293A562C66653D22414C4C4F5745445F4E414D4553504143455322696E20653F456E287B7D2C652E414C4C4F5745445F4E414D45535041';
wwv_flow_imp.g_varchar2_table(3035) := '4345532C766E293A76652C63653D224144445F5552495F534146455F4154545222696E20653F456E284C6E286465292C652E4144445F5552495F534146455F415454522C7965293A64652C61653D224144445F444154415F5552495F5441475322696E20';
wwv_flow_imp.g_varchar2_table(3036) := '653F456E284C6E286C65292C652E4144445F444154415F5552495F544147532C7965293A6C652C73653D22464F524249445F434F4E54454E545322696E20653F456E287B7D2C652E464F524249445F434F4E54454E54532C7965293A72652C483D22464F';
wwv_flow_imp.g_varchar2_table(3037) := '524249445F5441475322696E20653F456E287B7D2C652E464F524249445F544147532C7965293A7B7D2C573D22464F524249445F4154545222696E20653F456E287B7D2C652E464F524249445F415454522C7965293A7B7D2C6F653D225553455F50524F';
wwv_flow_imp.g_varchar2_table(3038) := '46494C455322696E20652626652E5553455F50524F46494C45532C6A3D2131213D3D652E414C4C4F575F415249415F415454522C713D2131213D3D652E414C4C4F575F444154415F415454522C243D652E414C4C4F575F554E4B4E4F574E5F50524F544F';
wwv_flow_imp.g_varchar2_table(3039) := '434F4C537C7C21312C553D2131213D3D652E414C4C4F575F53454C465F434C4F53455F494E5F415454522C4B3D652E534146455F464F525F54454D504C415445537C7C21312C473D652E57484F4C455F444F43554D454E547C7C21312C5A3D652E524554';
wwv_flow_imp.g_varchar2_table(3040) := '55524E5F444F4D7C7C21312C583D652E52455455524E5F444F4D5F465241474D454E547C7C21312C4A3D652E52455455524E5F545255535445445F545950457C7C21312C593D652E464F5243455F424F44597C7C21312C65653D2131213D3D652E53414E';
wwv_flow_imp.g_varchar2_table(3041) := '4954495A455F444F4D2C74653D652E53414E4954495A455F4E414D45445F50524F50537C7C21312C6E653D2131213D3D652E4B4545505F434F4E54454E542C69653D652E494E5F504C4143457C7C21312C4F3D652E414C4C4F5745445F5552495F524547';
wwv_flow_imp.g_varchar2_table(3042) := '4558507C7C246E2C67653D652E4E414D4553504143457C7C70652C7A3D652E435553544F4D5F454C454D454E545F48414E444C494E477C7C7B7D2C652E435553544F4D5F454C454D454E545F48414E444C494E472626536528652E435553544F4D5F454C';
wwv_flow_imp.g_varchar2_table(3043) := '454D454E545F48414E444C494E472E7461674E616D65436865636B292626287A2E7461674E616D65436865636B3D652E435553544F4D5F454C454D454E545F48414E444C494E472E7461674E616D65436865636B292C652E435553544F4D5F454C454D45';
wwv_flow_imp.g_varchar2_table(3044) := '4E545F48414E444C494E472626536528652E435553544F4D5F454C454D454E545F48414E444C494E472E6174747269627574654E616D65436865636B292626287A2E6174747269627574654E616D65436865636B3D652E435553544F4D5F454C454D454E';
wwv_flow_imp.g_varchar2_table(3045) := '545F48414E444C494E472E6174747269627574654E616D65436865636B292C652E435553544F4D5F454C454D454E545F48414E444C494E47262622626F6F6C65616E223D3D747970656F6620652E435553544F4D5F454C454D454E545F48414E444C494E';
wwv_flow_imp.g_varchar2_table(3046) := '472E616C6C6F77437573746F6D697A65644275696C74496E456C656D656E74732626287A2E616C6C6F77437573746F6D697A65644275696C74496E456C656D656E74733D652E435553544F4D5F454C454D454E545F48414E444C494E472E616C6C6F7743';
wwv_flow_imp.g_varchar2_table(3047) := '7573746F6D697A65644275696C74496E456C656D656E7473292C4B262628713D2131292C582626285A3D2130292C6F65262628523D456E287B7D2C5B2E2E2E4F6E5D292C423D5B5D2C21303D3D3D6F652E68746D6C262628456E28522C546E292C456E28';
wwv_flow_imp.g_varchar2_table(3048) := '422C526E29292C21303D3D3D6F652E737667262628456E28522C496E292C456E28422C466E292C456E28422C566E29292C21303D3D3D6F652E73766746696C74657273262628456E28522C4D6E292C456E28422C466E292C456E28422C566E29292C2130';
wwv_flow_imp.g_varchar2_table(3049) := '3D3D3D6F652E6D6174684D6C262628456E28522C4E6E292C456E28422C426E292C456E28422C566E2929292C652E4144445F54414753262628523D3D3D46262628523D4C6E285229292C456E28522C652E4144445F544147532C796529292C652E414444';
wwv_flow_imp.g_varchar2_table(3050) := '5F41545452262628423D3D3D56262628423D4C6E284229292C456E28422C652E4144445F415454522C796529292C652E4144445F5552495F534146455F415454522626456E2863652C652E4144445F5552495F534146455F415454522C7965292C652E46';
wwv_flow_imp.g_varchar2_table(3051) := '4F524249445F434F4E54454E545326262873653D3D3D726526262873653D4C6E28736529292C456E2873652C652E464F524249445F434F4E54454E54532C796529292C6E65262628525B222374657874225D3D2130292C472626456E28522C5B2268746D';
wwv_flow_imp.g_varchar2_table(3052) := '6C222C2268656164222C22626F6479225D292C522E7461626C65262628456E28522C5B2274626F6479225D292C64656C65746520482E74626F6479292C652E545255535445445F54595045535F504F4C494359297B6966282266756E6374696F6E22213D';
wwv_flow_imp.g_varchar2_table(3053) := '747970656F6620652E545255535445445F54595045535F504F4C4943592E63726561746548544D4C297468726F7720536E2827545255535445445F54595045535F504F4C49435920636F6E66696775726174696F6E206F7074696F6E206D757374207072';
wwv_flow_imp.g_varchar2_table(3054) := '6F766964652061202263726561746548544D4C2220686F6F6B2E27293B6966282266756E6374696F6E22213D747970656F6620652E545255535445445F54595045535F504F4C4943592E63726561746553637269707455524C297468726F7720536E2827';
wwv_flow_imp.g_varchar2_table(3055) := '545255535445445F54595045535F504F4C49435920636F6E66696775726174696F6E206F7074696F6E206D7573742070726F766964652061202263726561746553637269707455524C2220686F6F6B2E27293B793D652E545255535445445F5459504553';
wwv_flow_imp.g_varchar2_table(3056) := '5F504F4C4943592C773D792E63726561746548544D4C282222297D656C736520766F696420303D3D3D79262628793D66756E6374696F6E28652C74297B696628226F626A65637422213D747970656F6620657C7C2266756E6374696F6E22213D74797065';
wwv_flow_imp.g_varchar2_table(3057) := '6F6620652E637265617465506F6C6963792972657475726E206E756C6C3B6C6574206E3D6E756C6C3B636F6E737420693D22646174612D74742D706F6C6963792D737566666978223B742626742E6861734174747269627574652869292626286E3D742E';
wwv_flow_imp.g_varchar2_table(3058) := '676574417474726962757465286929293B636F6E7374206F3D22646F6D707572696679222B286E3F2223222B6E3A2222293B7472797B72657475726E20652E637265617465506F6C696379286F2C7B63726561746548544D4C3A653D3E652C6372656174';
wwv_flow_imp.g_varchar2_table(3059) := '6553637269707455524C3A653D3E657D297D63617463682865297B72657475726E20636F6E736F6C652E7761726E282254727573746564547970657320706F6C69637920222B6F2B2220636F756C64206E6F7420626520637265617465642E22292C6E75';
wwv_flow_imp.g_varchar2_table(3060) := '6C6C7D7D28672C6F29292C6E756C6C213D3D79262622737472696E67223D3D747970656F662077262628773D792E63726561746548544D4C28222229293B6C6E26266C6E2865292C77653D657D7D2C6B653D456E287B7D2C5B226D69222C226D6F222C22';
wwv_flow_imp.g_varchar2_table(3061) := '6D6E222C226D73222C226D74657874225D292C45653D456E287B7D2C5B22666F726569676E6F626A656374222C2264657363222C227469746C65222C22616E6E6F746174696F6E2D786D6C225D292C4C653D456E287B7D2C5B227469746C65222C227374';
wwv_flow_imp.g_varchar2_table(3062) := '796C65222C22666F6E74222C2261222C22736372697074225D292C44653D456E287B7D2C496E293B456E2844652C4D6E292C456E2844652C416E293B636F6E73742054653D456E287B7D2C4E6E293B456E2854652C506E293B636F6E73742049653D6675';
wwv_flow_imp.g_varchar2_table(3063) := '6E6374696F6E2865297B6D6E286E2E72656D6F7665642C7B656C656D656E743A657D293B7472797B652E706172656E744E6F64652E72656D6F76654368696C642865297D63617463682874297B652E72656D6F766528297D7D2C4D653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(3064) := '6E28652C74297B7472797B6D6E286E2E72656D6F7665642C7B6174747269627574653A742E6765744174747269627574654E6F64652865292C66726F6D3A747D297D63617463682865297B6D6E286E2E72656D6F7665642C7B6174747269627574653A6E';
wwv_flow_imp.g_varchar2_table(3065) := '756C6C2C66726F6D3A747D297D696628742E72656D6F76654174747269627574652865292C226973223D3D3D65262621425B655D296966285A7C7C58297472797B49652874297D63617463682865297B7D656C7365207472797B742E7365744174747269';
wwv_flow_imp.g_varchar2_table(3066) := '6275746528652C2222297D63617463682865297B7D7D2C41653D66756E6374696F6E2865297B6C657420742C6E3B6966285929653D223C72656D6F76653E3C2F72656D6F76653E222B653B656C73657B636F6E737420743D626E28652C2F5E5B5C725C6E';
wwv_flow_imp.g_varchar2_table(3067) := '5C74205D2B2F293B6E3D742626745B305D7D226170706C69636174696F6E2F7868746D6C2B786D6C223D3D3D6265262667653D3D3D7065262628653D273C68746D6C20786D6C6E733D22687474703A2F2F7777772E77332E6F72672F313939392F786874';
wwv_flow_imp.g_varchar2_table(3068) := '6D6C223E3C686561643E3C2F686561643E3C626F64793E272B652B223C2F626F64793E3C2F68746D6C3E22293B636F6E737420693D793F792E63726561746548544D4C2865293A653B69662867653D3D3D7065297472797B743D286E65772070292E7061';
wwv_flow_imp.g_varchar2_table(3069) := '72736546726F6D537472696E6728692C6265297D63617463682865297B7D69662821747C7C21742E646F63756D656E74456C656D656E74297B743D432E637265617465446F63756D656E742867652C2274656D706C617465222C6E756C6C293B7472797B';
wwv_flow_imp.g_varchar2_table(3070) := '742E646F63756D656E74456C656D656E742E696E6E657248544D4C3D6D653F773A697D63617463682865297B7D7D636F6E7374206F3D742E626F64797C7C742E646F63756D656E74456C656D656E743B72657475726E206526266E26266F2E696E736572';
wwv_flow_imp.g_varchar2_table(3071) := '744265666F726528732E637265617465546578744E6F6465286E292C6F2E6368696C644E6F6465735B305D7C7C6E756C6C292C67653D3D3D70653F6B2E63616C6C28742C473F2268746D6C223A22626F647922295B305D3A473F742E646F63756D656E74';
wwv_flow_imp.g_varchar2_table(3072) := '456C656D656E743A6F7D2C4E653D66756E6374696F6E2865297B72657475726E20532E63616C6C28652E6F776E6572446F63756D656E747C7C652C652C642E53484F575F454C454D454E547C642E53484F575F434F4D4D454E547C642E53484F575F5445';
wwv_flow_imp.g_varchar2_table(3073) := '58542C6E756C6C2C2131297D2C50653D66756E6374696F6E2865297B72657475726E226F626A656374223D3D747970656F66206C3F6520696E7374616E63656F66206C3A652626226F626A656374223D3D747970656F6620652626226E756D626572223D';
wwv_flow_imp.g_varchar2_table(3074) := '3D747970656F6620652E6E6F646554797065262622737472696E67223D3D747970656F6620652E6E6F64654E616D657D2C4F653D66756E6374696F6E28652C742C69297B4C5B655D2626706E284C5B655D2C28653D3E7B652E63616C6C286E2C742C692C';
wwv_flow_imp.g_varchar2_table(3075) := '7765297D29297D2C52653D66756E6374696F6E2865297B6C657420743B6966284F6528226265666F726553616E6974697A65456C656D656E7473222C652C6E756C6C292C28693D6529696E7374616E63656F66207526262822737472696E6722213D7479';
wwv_flow_imp.g_varchar2_table(3076) := '70656F6620692E6E6F64654E616D657C7C22737472696E6722213D747970656F6620692E74657874436F6E74656E747C7C2266756E6374696F6E22213D747970656F6620692E72656D6F76654368696C647C7C2128692E6174747269627574657320696E';
wwv_flow_imp.g_varchar2_table(3077) := '7374616E63656F662068297C7C2266756E6374696F6E22213D747970656F6620692E72656D6F76654174747269627574657C7C2266756E6374696F6E22213D747970656F6620692E7365744174747269627574657C7C22737472696E6722213D74797065';
wwv_flow_imp.g_varchar2_table(3078) := '6F6620692E6E616D6573706163655552497C7C2266756E6374696F6E22213D747970656F6620692E696E736572744265666F72657C7C2266756E6374696F6E22213D747970656F6620692E6861734368696C644E6F646573292972657475726E20496528';
wwv_flow_imp.g_varchar2_table(3079) := '65292C21303B76617220693B636F6E7374206F3D796528652E6E6F64654E616D65293B6966284F65282275706F6E53616E6974697A65456C656D656E74222C652C7B7461674E616D653A6F2C616C6C6F776564546167733A527D292C652E686173436869';
wwv_flow_imp.g_varchar2_table(3080) := '6C644E6F6465732829262621506528652E6669727374456C656D656E744368696C642926262821506528652E636F6E74656E74297C7C21506528652E636F6E74656E742E6669727374456C656D656E744368696C6429292626436E282F3C5B2F5C775D2F';
wwv_flow_imp.g_varchar2_table(3081) := '672C652E696E6E657248544D4C292626436E282F3C5B2F5C775D2F672C652E74657874436F6E74656E74292972657475726E2049652865292C21303B69662821525B6F5D7C7C485B6F5D297B69662821485B6F5D26264265286F29297B6966287A2E7461';
wwv_flow_imp.g_varchar2_table(3082) := '674E616D65436865636B20696E7374616E63656F66205265674578702626436E287A2E7461674E616D65436865636B2C6F292972657475726E21313B6966287A2E7461674E616D65436865636B20696E7374616E63656F662046756E6374696F6E26267A';
wwv_flow_imp.g_varchar2_table(3083) := '2E7461674E616D65436865636B286F292972657475726E21317D6966286E6526262173655B6F5D297B636F6E737420743D5F2865297C7C652E706172656E744E6F64652C6E3D622865297C7C652E6368696C644E6F6465733B6966286E26267429666F72';
wwv_flow_imp.g_varchar2_table(3084) := '286C657420693D6E2E6C656E6774682D313B693E3D303B2D2D6929742E696E736572744265666F72652866286E5B695D2C2130292C76286529297D72657475726E2049652865292C21307D72657475726E206520696E7374616E63656F66206326262166';
wwv_flow_imp.g_varchar2_table(3085) := '756E6374696F6E2865297B6C657420743D5F2865293B742626742E7461674E616D657C7C28743D7B6E616D6573706163655552493A67652C7461674E616D653A2274656D706C617465227D293B636F6E7374206E3D666E28652E7461674E616D65292C69';
wwv_flow_imp.g_varchar2_table(3086) := '3D666E28742E7461674E616D65293B72657475726E212166655B652E6E616D6573706163655552495D262628652E6E616D6573706163655552493D3D3D75653F742E6E616D6573706163655552493D3D3D70653F22737667223D3D3D6E3A742E6E616D65';
wwv_flow_imp.g_varchar2_table(3087) := '73706163655552493D3D3D68653F22737667223D3D3D6E26262822616E6E6F746174696F6E2D786D6C223D3D3D697C7C6B655B695D293A426F6F6C65616E2844655B6E5D293A652E6E616D6573706163655552493D3D3D68653F742E6E616D6573706163';
wwv_flow_imp.g_varchar2_table(3088) := '655552493D3D3D70653F226D617468223D3D3D6E3A742E6E616D6573706163655552493D3D3D75653F226D617468223D3D3D6E262645655B695D3A426F6F6C65616E2854655B6E5D293A652E6E616D6573706163655552493D3D3D70653F2128742E6E61';
wwv_flow_imp.g_varchar2_table(3089) := '6D6573706163655552493D3D3D756526262145655B695D2926262128742E6E616D6573706163655552493D3D3D68652626216B655B695D2926262154655B6E5D2626284C655B6E5D7C7C2144655B6E5D293A2128226170706C69636174696F6E2F786874';
wwv_flow_imp.g_varchar2_table(3090) := '6D6C2B786D6C22213D3D62657C7C2166655B652E6E616D6573706163655552495D29297D2865293F2849652865292C2130293A226E6F73637269707422213D3D6F2626226E6F656D62656422213D3D6F2626226E6F6672616D657322213D3D6F7C7C2143';
wwv_flow_imp.g_varchar2_table(3091) := '6E282F3C5C2F6E6F287363726970747C656D6265647C6672616D6573292F692C652E696E6E657248544D4C293F284B2626333D3D3D652E6E6F646554797065262628743D652E74657874436F6E74656E742C743D5F6E28742C442C222022292C743D5F6E';
wwv_flow_imp.g_varchar2_table(3092) := '28742C542C222022292C743D5F6E28742C492C222022292C652E74657874436F6E74656E74213D3D742626286D6E286E2E72656D6F7665642C7B656C656D656E743A652E636C6F6E654E6F646528297D292C652E74657874436F6E74656E743D7429292C';
wwv_flow_imp.g_varchar2_table(3093) := '4F652822616674657253616E6974697A65456C656D656E7473222C652C6E756C6C292C2131293A2849652865292C2130297D2C46653D66756E6374696F6E28652C742C6E297B6966286565262628226964223D3D3D747C7C226E616D65223D3D3D742926';
wwv_flow_imp.g_varchar2_table(3094) := '26286E20696E20737C7C6E20696E204365292972657475726E21313B69662871262621575B745D2626436E284D2C7429293B656C7365206966286A2626436E28412C7429293B656C73652069662821425B745D7C7C575B745D297B696628212842652865';
wwv_flow_imp.g_varchar2_table(3095) := '292626287A2E7461674E616D65436865636B20696E7374616E63656F66205265674578702626436E287A2E7461674E616D65436865636B2C65297C7C7A2E7461674E616D65436865636B20696E7374616E63656F662046756E6374696F6E26267A2E7461';
wwv_flow_imp.g_varchar2_table(3096) := '674E616D65436865636B286529292626287A2E6174747269627574654E616D65436865636B20696E7374616E63656F66205265674578702626436E287A2E6174747269627574654E616D65436865636B2C74297C7C7A2E6174747269627574654E616D65';
wwv_flow_imp.g_varchar2_table(3097) := '436865636B20696E7374616E63656F662046756E6374696F6E26267A2E6174747269627574654E616D65436865636B287429297C7C226973223D3D3D7426267A2E616C6C6F77437573746F6D697A65644275696C74496E456C656D656E74732626287A2E';
wwv_flow_imp.g_varchar2_table(3098) := '7461674E616D65436865636B20696E7374616E63656F66205265674578702626436E287A2E7461674E616D65436865636B2C6E297C7C7A2E7461674E616D65436865636B20696E7374616E63656F662046756E6374696F6E26267A2E7461674E616D6543';
wwv_flow_imp.g_varchar2_table(3099) := '6865636B286E2929292972657475726E21317D656C73652069662863655B745D293B656C736520696628436E284F2C5F6E286E2C502C22222929293B656C7365206966282273726322213D3D74262622786C696E6B3A6872656622213D3D742626226872';
wwv_flow_imp.g_varchar2_table(3100) := '656622213D3D747C7C22736372697074223D3D3D657C7C30213D3D796E286E2C22646174613A22297C7C2161655B655D2969662824262621436E284E2C5F6E286E2C502C22222929293B656C7365206966286E2972657475726E21313B72657475726E21';
wwv_flow_imp.g_varchar2_table(3101) := '307D2C42653D66756E6374696F6E2865297B72657475726E20652E696E6465784F6628222D22293E307D2C56653D66756E6374696F6E2865297B6C657420742C692C6F2C733B4F6528226265666F726553616E6974697A6541747472696275746573222C';
wwv_flow_imp.g_varchar2_table(3102) := '652C6E756C6C293B636F6E73747B617474726962757465733A727D3D653B69662821722972657475726E3B636F6E737420613D7B617474724E616D653A22222C6174747256616C75653A22222C6B656570417474723A21302C616C6C6F77656441747472';
wwv_flow_imp.g_varchar2_table(3103) := '6962757465733A427D3B666F7228733D722E6C656E6774683B732D2D3B297B743D725B735D3B636F6E73747B6E616D653A6C2C6E616D6573706163655552493A637D3D743B696628693D2276616C7565223D3D3D6C3F742E76616C75653A776E28742E76';
wwv_flow_imp.g_varchar2_table(3104) := '616C7565292C6F3D7965286C292C612E617474724E616D653D6F2C612E6174747256616C75653D692C612E6B656570417474723D21302C612E666F7263654B656570417474723D766F696420302C4F65282275706F6E53616E6974697A65417474726962';
wwv_flow_imp.g_varchar2_table(3105) := '757465222C652C61292C693D612E6174747256616C75652C612E666F7263654B6565704174747229636F6E74696E75653B6966284D65286C2C65292C21612E6B6565704174747229636F6E74696E75653B69662821552626436E282F5C2F3E2F692C6929';
wwv_flow_imp.g_varchar2_table(3106) := '297B4D65286C2C65293B636F6E74696E75657D4B262628693D5F6E28692C442C222022292C693D5F6E28692C542C222022292C693D5F6E28692C492C22202229293B636F6E737420643D796528652E6E6F64654E616D65293B696628466528642C6F2C69';
wwv_flow_imp.g_varchar2_table(3107) := '29297B6966282174657C7C22696422213D3D6F2626226E616D6522213D3D6F7C7C284D65286C2C65292C693D22757365722D636F6E74656E742D222B69292C792626226F626A656374223D3D747970656F66206726262266756E6374696F6E223D3D7479';
wwv_flow_imp.g_varchar2_table(3108) := '70656F6620672E676574417474726962757465547970652969662863293B656C73652073776974636828672E6765744174747269627574655479706528642C6F29297B63617365225472757374656448544D4C223A693D792E63726561746548544D4C28';
wwv_flow_imp.g_varchar2_table(3109) := '69293B627265616B3B63617365225472757374656453637269707455524C223A693D792E63726561746553637269707455524C2869297D7472797B633F652E7365744174747269627574654E5328632C6C2C69293A652E73657441747472696275746528';
wwv_flow_imp.g_varchar2_table(3110) := '6C2C69292C676E286E2E72656D6F766564297D63617463682865297B7D7D7D4F652822616674657253616E6974697A6541747472696275746573222C652C6E756C6C297D2C7A653D66756E6374696F6E20652874297B6C6574206E3B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(3111) := '4E652874293B666F72284F6528226265666F726553616E6974697A65536861646F77444F4D222C742C6E756C6C293B6E3D692E6E6578744E6F646528293B294F65282275706F6E53616E6974697A65536861646F774E6F6465222C6E2C6E756C6C292C52';
wwv_flow_imp.g_varchar2_table(3112) := '65286E297C7C286E2E636F6E74656E7420696E7374616E63656F662072262665286E2E636F6E74656E74292C5665286E29293B4F652822616674657253616E6974697A65536861646F77444F4D222C742C6E756C6C297D3B72657475726E206E2E73616E';
wwv_flow_imp.g_varchar2_table(3113) := '6974697A653D66756E6374696F6E2865297B6C657420742C6F2C732C612C633D617267756D656E74732E6C656E6774683E312626766F69642030213D3D617267756D656E74735B315D3F617267756D656E74735B315D3A7B7D3B6966286D653D21652C6D';
wwv_flow_imp.g_varchar2_table(3114) := '65262628653D225C783363212D2D5C78336522292C22737472696E6722213D747970656F6620652626215065286529297B6966282266756E6374696F6E22213D747970656F6620652E746F537472696E67297468726F7720536E2822746F537472696E67';
wwv_flow_imp.g_varchar2_table(3115) := '206973206E6F7420612066756E6374696F6E22293B69662822737472696E6722213D747970656F6628653D652E746F537472696E67282929297468726F7720536E28226469727479206973206E6F74206120737472696E672C2061626F7274696E672229';
wwv_flow_imp.g_varchar2_table(3116) := '7D696628216E2E6973537570706F727465642972657475726E20653B696628517C7C78652863292C6E2E72656D6F7665643D5B5D2C22737472696E67223D3D747970656F66206526262869653D2131292C6965297B696628652E6E6F64654E616D65297B';
wwv_flow_imp.g_varchar2_table(3117) := '636F6E737420743D796528652E6E6F64654E616D65293B69662821525B745D7C7C485B745D297468726F7720536E2822726F6F74206E6F646520697320666F7262696464656E20616E642063616E6E6F742062652073616E6974697A656420696E2D706C';
wwv_flow_imp.g_varchar2_table(3118) := '61636522297D7D656C7365206966286520696E7374616E63656F66206C29743D416528225C783363212D2D2D2D5C78336522292C6F3D742E6F776E6572446F63756D656E742E696D706F72744E6F646528652C2130292C313D3D3D6F2E6E6F6465547970';
wwv_flow_imp.g_varchar2_table(3119) := '65262622424F4459223D3D3D6F2E6E6F64654E616D657C7C2248544D4C223D3D3D6F2E6E6F64654E616D653F743D6F3A742E617070656E644368696C64286F293B656C73657B696628215A2626214B2626214726262D313D3D3D652E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(3120) := '223C22292972657475726E207926264A3F792E63726561746548544D4C2865293A653B696628743D41652865292C21742972657475726E205A3F6E756C6C3A4A3F773A22227D742626592626496528742E66697273744368696C64293B636F6E73742064';
wwv_flow_imp.g_varchar2_table(3121) := '3D4E652869653F653A74293B666F72283B733D642E6E6578744E6F646528293B2952652873297C7C28732E636F6E74656E7420696E7374616E63656F66207226267A6528732E636F6E74656E74292C5665287329293B69662869652972657475726E2065';
wwv_flow_imp.g_varchar2_table(3122) := '3B6966285A297B6966285829666F7228613D782E63616C6C28742E6F776E6572446F63756D656E74293B742E66697273744368696C643B29612E617070656E644368696C6428742E66697273744368696C64293B656C736520613D743B72657475726E28';
wwv_flow_imp.g_varchar2_table(3123) := '422E736861646F77726F6F747C7C422E736861646F77726F6F746D6F646529262628613D452E63616C6C28692C612C213029292C617D6C657420683D473F742E6F7574657248544D4C3A742E696E6E657248544D4C3B72657475726E20472626525B2221';
wwv_flow_imp.g_varchar2_table(3124) := '646F6374797065225D2626742E6F776E6572446F63756D656E742626742E6F776E6572446F63756D656E742E646F63747970652626742E6F776E6572446F63756D656E742E646F63747970652E6E616D652626436E28476E2C742E6F776E6572446F6375';
wwv_flow_imp.g_varchar2_table(3125) := '6D656E742E646F63747970652E6E616D6529262628683D223C21444F435459504520222B742E6F776E6572446F63756D656E742E646F63747970652E6E616D652B223E5C6E222B68292C4B262628683D5F6E28682C442C222022292C683D5F6E28682C54';
wwv_flow_imp.g_varchar2_table(3126) := '2C222022292C683D5F6E28682C492C22202229292C7926264A3F792E63726561746548544D4C2868293A687D2C6E2E736574436F6E6669673D66756E6374696F6E2865297B78652865292C513D21307D2C6E2E636C656172436F6E6669673D66756E6374';
wwv_flow_imp.g_varchar2_table(3127) := '696F6E28297B77653D6E756C6C2C513D21317D2C6E2E697356616C69644174747269627574653D66756E6374696F6E28652C742C6E297B77657C7C7865287B7D293B636F6E737420693D79652865292C6F3D79652874293B72657475726E20466528692C';
wwv_flow_imp.g_varchar2_table(3128) := '6F2C6E297D2C6E2E616464486F6F6B3D66756E6374696F6E28652C74297B2266756E6374696F6E223D3D747970656F6620742626284C5B655D3D4C5B655D7C7C5B5D2C6D6E284C5B655D2C7429297D2C6E2E72656D6F7665486F6F6B3D66756E6374696F';
wwv_flow_imp.g_varchar2_table(3129) := '6E2865297B6966284C5B655D2972657475726E20676E284C5B655D297D2C6E2E72656D6F7665486F6F6B733D66756E6374696F6E2865297B4C5B655D2626284C5B655D3D5B5D297D2C6E2E72656D6F7665416C6C486F6F6B733D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(3130) := '7B4C3D7B7D7D2C6E7D28293B5A6E2E76657273696F6E2C5A6E2E6973537570706F727465643B636F6E737420586E3D5A6E2E73616E6974697A652C4A6E3D285A6E2E736574436F6E6669672C5A6E2E636C656172436F6E6669672C5A6E2E697356616C69';
wwv_flow_imp.g_varchar2_table(3131) := '644174747269627574652C5A6E2E616464486F6F6B292C65693D5A6E2E72656D6F7665486F6F6B3B66756E6374696F6E2074692865297B72657475726E20657D5A6E2E72656D6F7665486F6F6B732C5A6E2E72656D6F7665416C6C486F6F6B733B636C61';
wwv_flow_imp.g_varchar2_table(3132) := '7373206E697B6765742063616368656456616C75657328297B72657475726E20746869732E5F6D61707D636F6E7374727563746F7228652C74297B746869732E5F6D61703D6E6577204D61702C746869732E5F6D6170323D6E6577204D61702C2266756E';
wwv_flow_imp.g_varchar2_table(3133) := '6374696F6E223D3D747970656F6620653F28746869732E5F666E3D652C746869732E5F636F6D707574654B65793D7469293A28746869732E5F666E3D742C746869732E5F636F6D707574654B65793D652E67657443616368654B6579297D676574286529';
wwv_flow_imp.g_varchar2_table(3134) := '7B636F6E737420743D746869732E5F636F6D707574654B65792865293B696628746869732E5F6D6170322E6861732874292972657475726E20746869732E5F6D6170322E6765742874293B636F6E7374206E3D746869732E5F666E2865293B7265747572';
wwv_flow_imp.g_varchar2_table(3135) := '6E20746869732E5F6D61702E73657428652C6E292C746869732E5F6D6170322E73657428742C6E292C6E7D7D636C6173732069697B636F6E7374727563746F722865297B746869732E6578656375746F723D652C746869732E5F64696452756E3D21317D';
wwv_flow_imp.g_varchar2_table(3136) := '6765742076616C756528297B69662821746869732E5F64696452756E297472797B746869732E5F76616C75653D746869732E6578656375746F7228297D63617463682865297B746869732E5F6572726F723D657D66696E616C6C797B746869732E5F6469';
wwv_flow_imp.g_varchar2_table(3137) := '6452756E3D21307D696628746869732E5F6572726F72297468726F7720746869732E5F6572726F723B72657475726E20746869732E5F76616C75657D6765742072617756616C756528297B72657475726E20746869732E5F76616C75657D7D766172206F';
wwv_flow_imp.g_varchar2_table(3138) := '693B66756E6374696F6E2073692865297B72657475726E21657C7C22737472696E6722213D747970656F6620657C7C303D3D3D652E7472696D28292E6C656E6774687D636F6E73742072693D2F7B285C642B297D2F673B66756E6374696F6E2061692865';
wwv_flow_imp.g_varchar2_table(3139) := '2C2E2E2E74297B72657475726E20303D3D3D742E6C656E6774683F653A652E7265706C6163652872692C2866756E6374696F6E28652C6E297B636F6E737420693D7061727365496E74286E2C3130293B72657475726E2069734E614E2869297C7C693C30';
wwv_flow_imp.g_varchar2_table(3140) := '7C7C693E3D742E6C656E6774683F653A745B695D7D29297D66756E6374696F6E206C692865297B72657475726E20652E7265706C616365282F5B3C3E265D2F672C2866756E6374696F6E2865297B7377697463682865297B63617365223C223A72657475';
wwv_flow_imp.g_varchar2_table(3141) := '726E22266C743B223B63617365223E223A72657475726E222667743B223B636173652226223A72657475726E2226616D703B223B64656661756C743A72657475726E20657D7D29297D66756E6374696F6E2063692865297B72657475726E20652E726570';
wwv_flow_imp.g_varchar2_table(3142) := '6C616365282F5B5C5C5C7B5C7D5C2A5C2B5C3F5C7C5C5E5C245C2E5C5B5C5D5C285C295D2F672C225C5C242622297D66756E6374696F6E20646928652C743D222022297B72657475726E20756928686928652C74292C74297D66756E6374696F6E206869';
wwv_flow_imp.g_varchar2_table(3143) := '28652C74297B69662821657C7C21742972657475726E20653B636F6E7374206E3D742E6C656E6774683B696628303D3D3D6E7C7C303D3D3D652E6C656E6774682972657475726E20653B6C657420693D303B666F72283B652E696E6465784F6628742C69';
wwv_flow_imp.g_varchar2_table(3144) := '293D3D3D693B29692B3D6E3B72657475726E20652E737562737472696E672869297D66756E6374696F6E20756928652C74297B69662821657C7C21742972657475726E20653B636F6E7374206E3D742E6C656E6774682C693D652E6C656E6774683B6966';
wwv_flow_imp.g_varchar2_table(3145) := '28303D3D3D6E7C7C303D3D3D692972657475726E20653B6C6574206F3D692C733D2D313B666F72283B733D652E6C617374496E6465784F6628742C6F2D31292C2D31213D3D732626732B6E3D3D3D6F3B297B696628303D3D3D732972657475726E22223B';
wwv_flow_imp.g_varchar2_table(3146) := '6F3D737D72657475726E20652E737562737472696E6728302C6F297D66756E6374696F6E20706928652C742C6E3D7B7D297B6966282165297468726F77206E6577204572726F72282243616E6E6F74206372656174652072656765782066726F6D20656D';
wwv_flow_imp.g_varchar2_table(3147) := '70747920737472696E6722293B747C7C28653D6369286529292C6E2E77686F6C65576F72642626282F5C422F2E7465737428652E636861724174283029297C7C28653D225C5C62222B65292C2F5C422F2E7465737428652E63686172417428652E6C656E';
wwv_flow_imp.g_varchar2_table(3148) := '6774682D3129297C7C28652B3D225C5C622229293B6C657420693D22223B72657475726E206E2E676C6F62616C262628692B3D226722292C6E2E6D61746368436173657C7C28692B3D226922292C6E2E6D756C74696C696E65262628692B3D226D22292C';
wwv_flow_imp.g_varchar2_table(3149) := '6E2E756E69636F6465262628692B3D227522292C6E65772052656745787028652C69297D66756E6374696F6E2067692865297B72657475726E20652E73706C6974282F5C725C6E7C5C727C5C6E2F297D66756E6374696F6E206D692865297B666F72286C';
wwv_flow_imp.g_varchar2_table(3150) := '657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D652E63686172436F646541742874293B6966283332213D3D6E262639213D3D6E2972657475726E20747D72657475726E2D317D66756E6374696F6E20666928652C';
wwv_flow_imp.g_varchar2_table(3151) := '743D302C6E3D652E6C656E677468297B666F72286C657420693D743B693C6E3B692B2B297B636F6E7374206E3D652E63686172436F646541742869293B6966283332213D3D6E262639213D3D6E2972657475726E20652E737562737472696E6728742C69';
wwv_flow_imp.g_varchar2_table(3152) := '297D72657475726E20652E737562737472696E6728742C6E297D66756E6374696F6E20766928652C743D652E6C656E6774682D31297B666F72286C6574206E3D743B6E3E3D303B6E2D2D297B636F6E737420743D652E63686172436F64654174286E293B';
wwv_flow_imp.g_varchar2_table(3153) := '6966283332213D3D74262639213D3D742972657475726E206E7D72657475726E2D317D66756E6374696F6E20626928652C74297B72657475726E20653C743F2D313A653E743F313A307D66756E6374696F6E205F6928652C742C6E3D302C693D652E6C65';
wwv_flow_imp.g_varchar2_table(3154) := '6E6774682C6F3D302C733D742E6C656E677468297B666F72283B6E3C6926266F3C733B6E2B2B2C6F2B2B297B636F6E737420693D652E63686172436F64654174286E292C733D742E63686172436F64654174286F293B696628693C732972657475726E2D';
wwv_flow_imp.g_varchar2_table(3155) := '313B696628693E732972657475726E20317D636F6E737420723D692D6E2C613D732D6F3B72657475726E20723C613F2D313A723E613F313A307D66756E6374696F6E20796928652C74297B72657475726E20776928652C742C302C652E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(3156) := '302C742E6C656E677468297D66756E6374696F6E20776928652C742C6E3D302C693D652E6C656E6774682C6F3D302C733D742E6C656E677468297B666F72283B6E3C6926266F3C733B6E2B2B2C6F2B2B297B6C657420723D652E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(3157) := '286E292C613D742E63686172436F64654174286F293B696628723D3D3D6129636F6E74696E75653B696628723E3D3132387C7C613E3D3132382972657475726E205F6928652E746F4C6F7765724361736528292C742E746F4C6F7765724361736528292C';
wwv_flow_imp.g_varchar2_table(3158) := '6E2C692C6F2C73293B5369287229262628722D3D3332292C5369286129262628612D3D3332293B636F6E7374206C3D722D613B69662830213D3D6C2972657475726E206C7D636F6E737420723D692D6E2C613D732D6F3B72657475726E20723C613F2D31';
wwv_flow_imp.g_varchar2_table(3159) := '3A723E613F313A307D66756E6374696F6E2043692865297B72657475726E20653E3D34382626653C3D35377D66756E6374696F6E2053692865297B72657475726E20653E3D39372626653C3D3132327D66756E6374696F6E2078692865297B7265747572';
wwv_flow_imp.g_varchar2_table(3160) := '6E20653E3D36352626653C3D39307D66756E6374696F6E206B6928652C74297B72657475726E20652E6C656E6774683D3D3D742E6C656E6774682626303D3D3D776928652C74297D66756E6374696F6E20456928652C74297B636F6E7374206E3D742E6C';
wwv_flow_imp.g_varchar2_table(3161) := '656E6774683B72657475726E2128742E6C656E6774683E652E6C656E677468292626303D3D3D776928652C742C302C6E297D66756E6374696F6E204C6928652C74297B636F6E7374206E3D4D6174682E6D696E28652E6C656E6774682C742E6C656E6774';
wwv_flow_imp.g_varchar2_table(3162) := '68293B6C657420693B666F7228693D303B693C6E3B692B2B29696628652E63686172436F64654174286929213D3D742E63686172436F646541742869292972657475726E20693B72657475726E206E7D66756E6374696F6E20446928652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(3163) := '7374206E3D4D6174682E6D696E28652E6C656E6774682C742E6C656E677468293B6C657420693B636F6E7374206F3D652E6C656E6774682D312C733D742E6C656E6774682D313B666F7228693D303B693C6E3B692B2B29696628652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(3164) := '4174286F2D6929213D3D742E63686172436F6465417428732D69292972657475726E20693B72657475726E206E7D66756E6374696F6E2054692865297B72657475726E2035353239363C3D652626653C3D35363331397D66756E6374696F6E2049692865';
wwv_flow_imp.g_varchar2_table(3165) := '297B72657475726E2035363332303C3D652626653C3D35373334337D66756E6374696F6E204D6928652C74297B72657475726E20742D35363332302B28652D35353239363C3C3130292B36353533367D66756E6374696F6E20416928652C742C6E297B63';
wwv_flow_imp.g_varchar2_table(3166) := '6F6E737420693D652E63686172436F64654174286E293B696628546928692926266E2B313C74297B636F6E737420743D652E63686172436F64654174286E2B31293B69662849692874292972657475726E204D6928692C74297D72657475726E20697D63';
wwv_flow_imp.g_varchar2_table(3167) := '6C617373204E697B676574206F666673657428297B72657475726E20746869732E5F6F66667365747D636F6E7374727563746F7228652C743D30297B746869732E5F7374723D652C746869732E5F6C656E3D652E6C656E6774682C746869732E5F6F6666';
wwv_flow_imp.g_varchar2_table(3168) := '7365743D747D7365744F66667365742865297B746869732E5F6F66667365743D657D70726576436F6465506F696E7428297B636F6E737420653D66756E6374696F6E28652C74297B636F6E7374206E3D652E63686172436F6465417428742D31293B6966';
wwv_flow_imp.g_varchar2_table(3169) := '284969286E292626743E31297B636F6E737420693D652E63686172436F6465417428742D32293B69662854692869292972657475726E204D6928692C6E297D72657475726E206E7D28746869732E5F7374722C746869732E5F6F6666736574293B726574';
wwv_flow_imp.g_varchar2_table(3170) := '75726E20746869732E5F6F66667365742D3D653E3D36353533363F323A312C657D6E657874436F6465506F696E7428297B636F6E737420653D416928746869732E5F7374722C746869732E5F6C656E2C746869732E5F6F6666736574293B72657475726E';
wwv_flow_imp.g_varchar2_table(3171) := '20746869732E5F6F66667365742B3D653E3D36353533363F323A312C657D656F6C28297B72657475726E20746869732E5F6F66667365743E3D746869732E5F6C656E7D7D636C6173732050697B676574206F666673657428297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(3172) := '732E5F6974657261746F722E6F66667365747D636F6E7374727563746F7228652C743D30297B746869732E5F6974657261746F723D6E6577204E6928652C74297D6E6578744772617068656D654C656E67746828297B636F6E737420653D51692E676574';
wwv_flow_imp.g_varchar2_table(3173) := '496E7374616E636528292C743D746869732E5F6974657261746F722C6E3D742E6F66667365743B6C657420693D652E6765744772617068656D65427265616B5479706528742E6E657874436F6465506F696E742829293B666F72283B21742E656F6C2829';
wwv_flow_imp.g_varchar2_table(3174) := '3B297B636F6E7374206E3D742E6F66667365742C6F3D652E6765744772617068656D65427265616B5479706528742E6E657874436F6465506F696E742829293B696628476928692C6F29297B742E7365744F6666736574286E293B627265616B7D693D6F';
wwv_flow_imp.g_varchar2_table(3175) := '7D72657475726E20742E6F66667365742D6E7D707265764772617068656D654C656E67746828297B636F6E737420653D51692E676574496E7374616E636528292C743D746869732E5F6974657261746F722C6E3D742E6F66667365743B6C657420693D65';
wwv_flow_imp.g_varchar2_table(3176) := '2E6765744772617068656D65427265616B5479706528742E70726576436F6465506F696E742829293B666F72283B742E6F66667365743E303B297B636F6E7374206E3D742E6F66667365742C6F3D652E6765744772617068656D65427265616B54797065';
wwv_flow_imp.g_varchar2_table(3177) := '28742E70726576436F6465506F696E742829293B6966284769286F2C6929297B742E7365744F6666736574286E293B627265616B7D693D6F7D72657475726E206E2D742E6F66667365747D656F6C28297B72657475726E20746869732E5F697465726174';
wwv_flow_imp.g_varchar2_table(3178) := '6F722E656F6C28297D7D66756E6374696F6E204F6928652C74297B72657475726E206E657720506928652C74292E6E6578744772617068656D654C656E67746828297D66756E6374696F6E20526928652C74297B72657475726E206E657720506928652C';
wwv_flow_imp.g_varchar2_table(3179) := '74292E707265764772617068656D654C656E67746828297D6C65742046693B66756E6374696F6E2042692865297B72657475726E2046697C7C2846693D2F283F3A5B5C75303542455C75303543305C75303543335C75303543365C75303544302D5C7530';
wwv_flow_imp.g_varchar2_table(3180) := '3546345C75303630385C75303630425C75303630445C75303631422D5C75303634415C75303636442D5C75303636465C75303637312D5C75303644355C75303645355C75303645365C75303645455C75303645465C75303646412D5C75303731305C7530';
wwv_flow_imp.g_varchar2_table(3181) := '3731322D5C75303732465C75303734442D5C75303741355C75303742312D5C75303745415C75303746345C75303746355C75303746415C75303746452D5C75303831355C75303831415C75303832345C75303832385C75303833302D5C75303835385C75';
wwv_flow_imp.g_varchar2_table(3182) := '303835452D5C75303838455C75303841302D5C75303843395C75323030465C75464231445C75464231462D5C75464232385C75464232412D5C75464433445C75464435302D5C75464443375C75464446302D5C75464446435C75464537302D5C75464546';
wwv_flow_imp.g_varchar2_table(3183) := '435D7C5C75443830325B5C75444330302D5C75444431425C75444432302D5C75444530305C75444531302D5C75444533355C75444534302D5C75444545345C75444545422D5C75444633355C75444634302D5C75444646465D7C5C75443830335B5C7544';
wwv_flow_imp.g_varchar2_table(3184) := '4330302D5C75444432335C75444538302D5C75444541395C75444541442D5C75444634355C75444635312D5C75444638315C75444638362D5C75444646365D7C5C75443833415B5C75444330302D5C75444343465C75444430302D5C75444434335C7544';
wwv_flow_imp.g_varchar2_table(3185) := '4434422D5C75444646465D7C5C75443833425B5C75444330302D5C75444542425D292F292C46692E746573742865297D636F6E73742056693D2F5E5B5C745C6E5C725C7832302D5C7837455D2A242F3B66756E6374696F6E207A692865297B7265747572';
wwv_flow_imp.g_varchar2_table(3186) := '6E2056692E746573742865297D636F6E73742048693D2F5B5C75323032385C75323032395D2F3B66756E6374696F6E2057692865297B72657475726E2048692E746573742865297D66756E6374696F6E206A692865297B72657475726E20653E3D313139';
wwv_flow_imp.g_varchar2_table(3187) := '30342626653C3D35353231357C7C653E3D36333734342626653C3D36343235357C7C653E3D36353238312626653C3D36353337347D66756E6374696F6E2071692865297B72657475726E20653E3D3132373436322626653C3D3132373438377C7C383938';
wwv_flow_imp.g_varchar2_table(3188) := '363D3D3D657C7C383938373D3D3D657C7C393230303D3D3D657C7C393230333D3D3D657C7C653E3D393732382626653C3D31303137357C7C31313038383D3D3D657C7C31313039333D3D3D657C7C653E3D3132373734342626653C3D3132383539317C7C';
wwv_flow_imp.g_varchar2_table(3189) := '653E3D3132383634302626653C3D3132383736347C7C653E3D3132383939322626653C3D3132393030387C7C653E3D3132393238302626653C3D3132393533357C7C653E3D3132393634382626653C3D3132393738327D636F6E73742024693D53747269';
wwv_flow_imp.g_varchar2_table(3190) := '6E672E66726F6D43686172436F6465283635323739293B66756E6374696F6E2055692865297B72657475726E212128652626652E6C656E6774683E30262636353237393D3D3D652E63686172436F64654174283029297D66756E6374696F6E204B692865';
wwv_flow_imp.g_varchar2_table(3191) := '297B72657475726E2865253D3532293C32363F537472696E672E66726F6D43686172436F64652839372B65293A537472696E672E66726F6D43686172436F64652836352B652D3236297D66756E6374696F6E20476928652C74297B72657475726E20303D';
wwv_flow_imp.g_varchar2_table(3192) := '3D3D653F35213D3D74262637213D3D743A2128323D3D3D652626333D3D3D747C7C34213D3D65262632213D3D65262633213D3D65262634213D3D74262632213D3D74262633213D3D74262628383D3D3D65262628383D3D3D747C7C393D3D3D747C7C3131';
wwv_flow_imp.g_varchar2_table(3193) := '3D3D3D747C7C31323D3D3D74297C7C21283131213D3D65262639213D3D657C7C39213D3D7426263130213D3D74297C7C2831323D3D3D657C7C31303D3D3D6529262631303D3D3D747C7C353D3D3D747C7C31333D3D3D747C7C373D3D3D747C7C313D3D3D';
wwv_flow_imp.g_varchar2_table(3194) := '657C7C31333D3D3D65262631343D3D3D747C7C363D3D3D652626363D3D3D7429297D636C6173732051697B73746174696320676574496E7374616E636528297B72657475726E2051692E5F494E5354414E43457C7C2851692E5F494E5354414E43453D6E';
wwv_flow_imp.g_varchar2_table(3195) := '6577205169292C51692E5F494E5354414E43457D636F6E7374727563746F7228297B746869732E5F646174613D4A534F4E2E706172736528225B302C302C302C35313232392C35313235352C31322C34343036312C34343038372C31322C313237343632';
wwv_flow_imp.g_varchar2_table(3196) := '2C3132373438372C362C373038332C373038352C352C34373634352C34373637312C31322C35343831332C35343833392C31322C3132383637382C3132383637382C31342C333237302C333237302C352C393931392C393932332C31342C34353835332C';
wwv_flow_imp.g_varchar2_table(3197) := '34353837392C31322C34393433372C34393436332C31322C35333032312C35333034372C31322C37313231362C37313231382C372C3132383339382C3132383339392C31342C3132393336302C3132393337342C31342C323531392C323531392C352C34';
wwv_flow_imp.g_varchar2_table(3198) := '3434382C343531392C392C393734322C393734322C31342C31323333362C31323333362C31342C34343935372C34343938332C31322C34363734392C34363737352C31322C34383534312C34383536372C31322C35303333332C35303335392C31322C35';
wwv_flow_imp.g_varchar2_table(3199) := '323132352C35323135312C31322C35333931372C35333934332C31322C36393838382C36393839302C352C37333031382C37333031382C352C3132373939302C3132373939302C31342C3132383535382C3132383535392C31342C3132383735392C3132';
wwv_flow_imp.g_varchar2_table(3200) := '383736302C31342C3132393635332C3132393635352C31342C323032372C323033352C352C323839312C323839322C372C333736312C333736312C352C363638332C363638332C352C383239332C383239332C342C393832352C393832362C31342C3939';
wwv_flow_imp.g_varchar2_table(3201) := '39392C393939392C31342C34333435322C34333435332C352C34343530392C34343533352C31322C34353430352C34353433312C31322C34363330312C34363332372C31322C34373139372C34373232332C31322C34383039332C34383131392C31322C';
wwv_flow_imp.g_varchar2_table(3202) := '34383938392C34393031352C31322C34393838352C34393931312C31322C35303738312C35303830372C31322C35313637372C35313730332C31322C35323537332C35323539392C31322C35333436392C35333439352C31322C35343336352C35343339';
wwv_flow_imp.g_varchar2_table(3203) := '312C31322C36353237392C36353237392C342C37303437312C37303437322C372C37323134352C37323134372C372C3131393137332C3131393137392C352C3132373739392C3132373831382C31342C3132383234302C3132383234342C31342C313238';
wwv_flow_imp.g_varchar2_table(3204) := '3531322C3132383531322C31342C3132383635322C3132383635322C31342C3132383732312C3132383732322C31342C3132393239322C3132393239322C31342C3132393434352C3132393435302C31342C3132393733342C3132393734332C31342C31';
wwv_flow_imp.g_varchar2_table(3205) := '3437362C313437372C352C323336362C323336382C372C323735302C323735322C372C333037362C333037362C352C333431352C333431352C352C343134312C343134342C352C363130392C363130392C352C363936342C363936342C352C373339342C';
wwv_flow_imp.g_varchar2_table(3206) := '373430302C352C393139372C393139382C31342C393737302C393737302C31342C393837372C393837372C31342C393936382C393936392C31342C31303038342C31303038342C31342C34333035322C34333035322C352C34333731332C34333731332C';
wwv_flow_imp.g_varchar2_table(3207) := '352C34343238352C34343331312C31322C34343733332C34343735392C31322C34353138312C34353230372C31322C34353632392C34353635352C31322C34363037372C34363130332C31322C34363532352C34363535312C31322C34363937332C3436';
wwv_flow_imp.g_varchar2_table(3208) := '3939392C31322C34373432312C34373434372C31322C34373836392C34373839352C31322C34383331372C34383334332C31322C34383736352C34383739312C31322C34393231332C34393233392C31322C34393636312C34393638372C31322C353031';
wwv_flow_imp.g_varchar2_table(3209) := '30392C35303133352C31322C35303535372C35303538332C31322C35313030352C35313033312C31322C35313435332C35313437392C31322C35313930312C35313932372C31322C35323334392C35323337352C31322C35323739372C35323832332C31';
wwv_flow_imp.g_varchar2_table(3210) := '322C35333234352C35333237312C31322C35333639332C35333731392C31322C35343134312C35343136372C31322C35343538392C35343631352C31322C35353033372C35353036332C31322C36393530362C36393530392C352C37303139312C373031';
wwv_flow_imp.g_varchar2_table(3211) := '39332C352C37303834312C37303834312C372C37313436332C37313436372C352C37323333302C37323334322C352C39343033312C39343033312C352C3132333632382C3132333633312C352C3132373736332C3132373736352C31342C313237393431';
wwv_flow_imp.g_varchar2_table(3212) := '2C3132373934312C31342C3132383034332C3132383036322C31342C3132383330322C3132383331372C31342C3132383436352C3132383436372C31342C3132383533392C3132383533392C31342C3132383634302C3132383634302C31342C31323836';
wwv_flow_imp.g_varchar2_table(3213) := '36322C3132383636322C31342C3132383730332C3132383730332C31342C3132383734352C3132383734352C31342C3132393030342C3132393030372C31342C3132393332392C3132393333302C31342C3132393430322C3132393430322C31342C3132';
wwv_flow_imp.g_varchar2_table(3214) := '393438332C3132393438332C31342C3132393638362C3132393730342C31342C3133303034382C3133313036392C31342C3137332C3137332C342C313735372C313735372C312C323230302C323230372C352C323433342C323433352C372C323633312C';
wwv_flow_imp.g_varchar2_table(3215) := '323633322C352C323831372C323831372C352C333030382C333030382C352C333230312C333230312C352C333338372C333338382C352C333534322C333534322C352C333930322C333930332C372C343139302C343139322C352C363030322C36303033';
wwv_flow_imp.g_varchar2_table(3216) := '2C352C363433392C363434302C352C363736352C363737302C372C373031392C373032372C352C373135342C373135352C372C383230352C383230352C31332C383530352C383530352C31342C393635342C393635342C31342C393735372C393735372C';
wwv_flow_imp.g_varchar2_table(3217) := '31342C393739322C393739322C31342C393835322C393835332C31342C393839302C393839342C31342C393933372C393933372C31342C393938312C393938312C31342C31303033352C31303033362C31342C31313033352C31313033362C31342C3432';
wwv_flow_imp.g_varchar2_table(3218) := '3635342C34323635352C352C34333334362C34333334372C372C34333538372C34333538372C352C34343030362C34343030372C372C34343137332C34343139392C31322C34343339372C34343432332C31322C34343632312C34343634372C31322C34';
wwv_flow_imp.g_varchar2_table(3219) := '343834352C34343837312C31322C34353036392C34353039352C31322C34353239332C34353331392C31322C34353531372C34353534332C31322C34353734312C34353736372C31322C34353936352C34353939312C31322C34363138392C3436323135';
wwv_flow_imp.g_varchar2_table(3220) := '2C31322C34363431332C34363433392C31322C34363633372C34363636332C31322C34363836312C34363838372C31322C34373038352C34373131312C31322C34373330392C34373333352C31322C34373533332C34373535392C31322C34373735372C';
wwv_flow_imp.g_varchar2_table(3221) := '34373738332C31322C34373938312C34383030372C31322C34383230352C34383233312C31322C34383432392C34383435352C31322C34383635332C34383637392C31322C34383837372C34383930332C31322C34393130312C34393132372C31322C34';
wwv_flow_imp.g_varchar2_table(3222) := '393332352C34393335312C31322C34393534392C34393537352C31322C34393737332C34393739392C31322C34393939372C35303032332C31322C35303232312C35303234372C31322C35303434352C35303437312C31322C35303636392C3530363935';
wwv_flow_imp.g_varchar2_table(3223) := '2C31322C35303839332C35303931392C31322C35313131372C35313134332C31322C35313334312C35313336372C31322C35313536352C35313539312C31322C35313738392C35313831352C31322C35323031332C35323033392C31322C35323233372C';
wwv_flow_imp.g_varchar2_table(3224) := '35323236332C31322C35323436312C35323438372C31322C35323638352C35323731312C31322C35323930392C35323933352C31322C35333133332C35333135392C31322C35333335372C35333338332C31322C35333538312C35333630372C31322C35';
wwv_flow_imp.g_varchar2_table(3225) := '333830352C35333833312C31322C35343032392C35343035352C31322C35343235332C35343237392C31322C35343437372C35343530332C31322C35343730312C35343732372C31322C35343932352C35343935312C31322C35353134392C3535313735';
wwv_flow_imp.g_varchar2_table(3226) := '2C31322C36383130312C36383130322C352C36393736322C36393736322C372C37303036372C37303036392C372C37303337312C37303337382C352C37303732302C37303732312C372C37313038372C37313038372C352C37313334312C37313334312C';
wwv_flow_imp.g_varchar2_table(3227) := '352C37313939352C37313939362C352C37323234392C37323234392C372C37323835302C37323837312C352C37333130392C37333130392C352C3131383537362C3131383539382C352C3132313530352C3132313531392C352C3132373234352C313237';
wwv_flow_imp.g_varchar2_table(3228) := '3234372C31342C3132373536382C3132373536392C31342C3132373737372C3132373737372C31342C3132373837322C3132373839312C31342C3132373935362C3132373936372C31342C3132383031352C3132383031362C31342C3132383131302C31';
wwv_flow_imp.g_varchar2_table(3229) := '32383137322C31342C3132383235392C3132383235392C31342C3132383336372C3132383336382C31342C3132383432342C3132383432342C31342C3132383438382C3132383438382C31342C3132383533302C3132383533322C31342C313238353530';
wwv_flow_imp.g_varchar2_table(3230) := '2C3132383535312C31342C3132383536362C3132383536362C31342C3132383634372C3132383634372C31342C3132383635362C3132383635362C31342C3132383636372C3132383637332C31342C3132383639312C3132383639332C31342C31323837';
wwv_flow_imp.g_varchar2_table(3231) := '31352C3132383731352C31342C3132383732382C3132383733322C31342C3132383735322C3132383735322C31342C3132383736352C3132383736372C31342C3132393039362C3132393130332C31342C3132393331312C3132393331312C31342C3132';
wwv_flow_imp.g_varchar2_table(3232) := '393334342C3132393334392C31342C3132393339342C3132393339342C31342C3132393431332C3132393432352C31342C3132393436362C3132393437312C31342C3132393531312C3132393533352C31342C3132393636342C3132393636362C31342C';
wwv_flow_imp.g_varchar2_table(3233) := '3132393731392C3132393732322C31342C3132393736302C3132393736372C31342C3931373533362C3931373633312C352C31332C31332C322C313136302C313136312C352C313536342C313536342C342C313830372C313830372C312C323038352C32';
wwv_flow_imp.g_varchar2_table(3234) := '3038372C352C323330372C323330372C372C323338322C323338332C372C323439372C323530302C352C323536332C323536332C372C323637372C323637372C352C323736332C323736342C372C323837392C323837392C352C323931342C323931352C';
wwv_flow_imp.g_varchar2_table(3235) := '352C333032312C333032312C352C333134322C333134342C352C333236332C333236332C352C333238352C333238362C352C333339382C333430302C372C333533302C333533302C352C333633332C333633332C352C333836342C333836352C352C3339';
wwv_flow_imp.g_varchar2_table(3236) := '37342C333937352C352C343135352C343135362C372C343232392C343233302C352C353930392C353930392C372C363037382C363038352C372C363237372C363237382C352C363435312C363435362C372C363734342C363735302C352C363834362C36';
wwv_flow_imp.g_varchar2_table(3237) := '3834362C352C363937322C363937322C352C373037342C373037372C352C373134362C373134382C372C373232322C373232332C352C373431362C373431372C352C383233342C383233382C342C383431372C383431372C352C393030302C393030302C';
wwv_flow_imp.g_varchar2_table(3238) := '31342C393230332C393230332C31342C393733302C393733312C31342C393734382C393734392C31342C393736322C393736332C31342C393737362C393738332C31342C393830302C393831312C31342C393833312C393833312C31342C393837322C39';
wwv_flow_imp.g_varchar2_table(3239) := '3837332C31342C393838322C393838322C31342C393930302C393930332C31342C393932392C393933332C31342C393934312C393936302C31342C393937342C393937342C31342C393938392C393938392C31342C31303030362C31303030362C31342C';
wwv_flow_imp.g_varchar2_table(3240) := '31303036322C31303036322C31342C31303136302C31303136302C31342C31313634372C31313634372C352C31323935332C31323935332C31342C34333031392C34333031392C352C34333233322C34333234392C352C34333434332C34333434332C35';
wwv_flow_imp.g_varchar2_table(3241) := '2C34333536372C34333536382C372C34333639362C34333639362C352C34333736352C34333736352C372C34343031332C34343031332C352C34343131372C34343134332C31322C34343232392C34343235352C31322C34343334312C34343336372C31';
wwv_flow_imp.g_varchar2_table(3242) := '322C34343435332C34343437392C31322C34343536352C34343539312C31322C34343637372C34343730332C31322C34343738392C34343831352C31322C34343930312C34343932372C31322C34353031332C34353033392C31322C34353132352C3435';
wwv_flow_imp.g_varchar2_table(3243) := '3135312C31322C34353233372C34353236332C31322C34353334392C34353337352C31322C34353436312C34353438372C31322C34353537332C34353539392C31322C34353638352C34353731312C31322C34353739372C34353832332C31322C343539';
wwv_flow_imp.g_varchar2_table(3244) := '30392C34353933352C31322C34363032312C34363034372C31322C34363133332C34363135392C31322C34363234352C34363237312C31322C34363335372C34363338332C31322C34363436392C34363439352C31322C34363538312C34363630372C31';
wwv_flow_imp.g_varchar2_table(3245) := '322C34363639332C34363731392C31322C34363830352C34363833312C31322C34363931372C34363934332C31322C34373032392C34373035352C31322C34373134312C34373136372C31322C34373235332C34373237392C31322C34373336352C3437';
wwv_flow_imp.g_varchar2_table(3246) := '3339312C31322C34373437372C34373530332C31322C34373538392C34373631352C31322C34373730312C34373732372C31322C34373831332C34373833392C31322C34373932352C34373935312C31322C34383033372C34383036332C31322C343831';
wwv_flow_imp.g_varchar2_table(3247) := '34392C34383137352C31322C34383236312C34383238372C31322C34383337332C34383339392C31322C34383438352C34383531312C31322C34383539372C34383632332C31322C34383730392C34383733352C31322C34383832312C34383834372C31';
wwv_flow_imp.g_varchar2_table(3248) := '322C34383933332C34383935392C31322C34393034352C34393037312C31322C34393135372C34393138332C31322C34393236392C34393239352C31322C34393338312C34393430372C31322C34393439332C34393531392C31322C34393630352C3439';
wwv_flow_imp.g_varchar2_table(3249) := '3633312C31322C34393731372C34393734332C31322C34393832392C34393835352C31322C34393934312C34393936372C31322C35303035332C35303037392C31322C35303136352C35303139312C31322C35303237372C35303330332C31322C353033';
wwv_flow_imp.g_varchar2_table(3250) := '38392C35303431352C31322C35303530312C35303532372C31322C35303631332C35303633392C31322C35303732352C35303735312C31322C35303833372C35303836332C31322C35303934392C35303937352C31322C35313036312C35313038372C31';
wwv_flow_imp.g_varchar2_table(3251) := '322C35313137332C35313139392C31322C35313238352C35313331312C31322C35313339372C35313432332C31322C35313530392C35313533352C31322C35313632312C35313634372C31322C35313733332C35313735392C31322C35313834352C3531';
wwv_flow_imp.g_varchar2_table(3252) := '3837312C31322C35313935372C35313938332C31322C35323036392C35323039352C31322C35323138312C35323230372C31322C35323239332C35323331392C31322C35323430352C35323433312C31322C35323531372C35323534332C31322C353236';
wwv_flow_imp.g_varchar2_table(3253) := '32392C35323635352C31322C35323734312C35323736372C31322C35323835332C35323837392C31322C35323936352C35323939312C31322C35333037372C35333130332C31322C35333138392C35333231352C31322C35333330312C35333332372C31';
wwv_flow_imp.g_varchar2_table(3254) := '322C35333431332C35333433392C31322C35333532352C35333535312C31322C35333633372C35333636332C31322C35333734392C35333737352C31322C35333836312C35333838372C31322C35333937332C35333939392C31322C35343038352C3534';
wwv_flow_imp.g_varchar2_table(3255) := '3131312C31322C35343139372C35343232332C31322C35343330392C35343333352C31322C35343432312C35343434372C31322C35343533332C35343535392C31322C35343634352C35343637312C31322C35343735372C35343738332C31322C353438';
wwv_flow_imp.g_varchar2_table(3256) := '36392C35343839352C31322C35343938312C35353030372C31322C35353039332C35353131392C31322C35353234332C35353239312C31302C36363034352C36363034352C352C36383332352C36383332362C352C36393638382C36393730322C352C36';
wwv_flow_imp.g_varchar2_table(3257) := '393831372C36393831382C352C36393935372C36393935382C372C37303038392C37303039322C352C37303139382C37303139392C352C37303436322C37303436322C352C37303530322C37303530382C352C37303735302C37303735302C352C373038';
wwv_flow_imp.g_varchar2_table(3258) := '34362C37303834362C372C37313130302C37313130312C352C37313233302C37313233302C372C37313335312C37313335312C352C37313733372C37313733382C352C37323030302C37323030302C372C37323136302C37323136302C352C3732323733';
wwv_flow_imp.g_varchar2_table(3259) := '2C37323237382C352C37323735322C37323735382C352C37323838322C37323838332C352C37333033312C37333033312C352C37333436312C37333436322C372C39343139322C39343139332C372C3131393134392C3131393134392C372C3132313430';
wwv_flow_imp.g_varchar2_table(3260) := '332C3132313435322C352C3132323931352C3132323931362C352C3132363938302C3132363938302C31342C3132373335382C3132373335392C31342C3132373533352C3132373533352C31342C3132373735392C3132373735392C31342C3132373737';
wwv_flow_imp.g_varchar2_table(3261) := '312C3132373737312C31342C3132373739322C3132373739332C31342C3132373832352C3132373836372C31342C3132373839372C3132373839392C31342C3132373934352C3132373934352C31342C3132373938352C3132373938362C31342C313238';
wwv_flow_imp.g_varchar2_table(3262) := '3030302C3132383030372C31342C3132383032312C3132383032312C31342C3132383036362C3132383130302C31342C3132383138342C3132383233352C31342C3132383234392C3132383235322C31342C3132383236362C3132383237362C31342C31';
wwv_flow_imp.g_varchar2_table(3263) := '32383333352C3132383333352C31342C3132383337392C3132383339302C31342C3132383430372C3132383431392C31342C3132383434342C3132383434342C31342C3132383438312C3132383438312C31342C3132383439392C3132383439392C3134';
wwv_flow_imp.g_varchar2_table(3264) := '2C3132383532362C3132383532362C31342C3132383533362C3132383533362C31342C3132383534332C3132383534332C31342C3132383535362C3132383535362C31342C3132383536342C3132383536342C31342C3132383537372C3132383538302C';
wwv_flow_imp.g_varchar2_table(3265) := '31342C3132383634332C3132383634352C31342C3132383634392C3132383634392C31342C3132383635342C3132383635342C31342C3132383636302C3132383636302C31342C3132383636342C3132383636342C31342C3132383637352C3132383637';
wwv_flow_imp.g_varchar2_table(3266) := '352C31342C3132383638362C3132383638392C31342C3132383639352C3132383639362C31342C3132383730352C3132383730392C31342C3132383731372C3132383731392C31342C3132383732352C3132383732352C31342C3132383733362C313238';
wwv_flow_imp.g_varchar2_table(3267) := '3734312C31342C3132383734372C3132383734382C31342C3132383735352C3132383735352C31342C3132383736322C3132383736322C31342C3132383938312C3132383939312C31342C3132393030392C3132393032332C31342C3132393136302C31';
wwv_flow_imp.g_varchar2_table(3268) := '32393136372C31342C3132393239362C3132393330342C31342C3132393332302C3132393332372C31342C3132393334302C3132393334322C31342C3132393335362C3132393335362C31342C3132393338382C3132393339322C31342C313239333939';
wwv_flow_imp.g_varchar2_table(3269) := '2C3132393430302C31342C3132393430342C3132393430372C31342C3132393433322C3132393434322C31342C3132393435342C3132393435352C31342C3132393437332C3132393437342C31342C3132393438352C3132393438372C31342C31323936';
wwv_flow_imp.g_varchar2_table(3270) := '34382C3132393635312C31342C3132393635392C3132393636302C31342C3132393637312C3132393637392C31342C3132393730392C3132393731312C31342C3132393732382C3132393733302C31342C3132393735312C3132393735332C31342C3132';
wwv_flow_imp.g_varchar2_table(3271) := '393737362C3132393738322C31342C3931373530352C3931373530352C342C3931373736302C3931373939392C352C31302C31302C332C3132372C3135392C342C3736382C3837392C352C313437312C313437312C352C313533362C313534312C312C31';
wwv_flow_imp.g_varchar2_table(3272) := '3634382C313634382C352C313736372C313736382C352C313834302C313836362C352C323037302C323037332C352C323133372C323133392C352C323237342C323237342C312C323336332C323336332C372C323337372C323338302C372C323430322C';
wwv_flow_imp.g_varchar2_table(3273) := '323430332C352C323439342C323439342C352C323530372C323530382C372C323535382C323535382C352C323632322C323632342C372C323634312C323634312C352C323639312C323639312C372C323735392C323736302C352C323738362C32373837';
wwv_flow_imp.g_varchar2_table(3274) := '2C352C323837362C323837362C352C323838312C323838342C352C323930312C323930322C352C333030362C333030362C352C333031342C333031362C372C333037322C333037322C352C333133342C333133362C352C333135372C333135382C352C33';
wwv_flow_imp.g_varchar2_table(3275) := '3236302C333236302C352C333236362C333236362C352C333237342C333237352C372C333332382C333332392C352C333339312C333339322C372C333430352C333430352C352C333435372C333435372C352C333533362C333533372C372C333535312C';
wwv_flow_imp.g_varchar2_table(3276) := '333535312C352C333633362C333634322C352C333736342C333737322C352C333839352C333839352C352C333936372C333936372C372C333939332C343032382C352C343134362C343135312C352C343138322C343138332C372C343232362C34323236';
wwv_flow_imp.g_varchar2_table(3277) := '2C352C343235332C343235332C352C343935372C343935392C352C353934302C353934302C372C363037302C363037302C372C363038372C363038382C372C363135382C363135382C342C363433322C363433342C352C363434382C363434392C372C36';
wwv_flow_imp.g_varchar2_table(3278) := '3637392C363638302C352C363734322C363734322C352C363735342C363735342C352C363738332C363738332C352C363931322C363931352C352C363936362C363937302C352C363937382C363937382C352C373034322C373034322C372C373038302C';
wwv_flow_imp.g_varchar2_table(3279) := '373038312C352C373134332C373134332C372C373135302C373135302C372C373231322C373231392C352C373338302C373339322C352C373431322C373431322C352C383230332C383230332C342C383233322C383233322C342C383236352C38323635';
wwv_flow_imp.g_varchar2_table(3280) := '2C31342C383430302C383431322C352C383432312C383433322C352C383631372C383631382C31342C393136372C393136372C31342C393230302C393230302C31342C393431302C393431302C31342C393732332C393732362C31342C393733332C3937';
wwv_flow_imp.g_varchar2_table(3281) := '33332C31342C393734352C393734352C31342C393735322C393735322C31342C393736302C393736302C31342C393736362C393736362C31342C393737342C393737342C31342C393738362C393738362C31342C393739342C393739342C31342C393832';
wwv_flow_imp.g_varchar2_table(3282) := '332C393832332C31342C393832382C393832382C31342C393833332C393835302C31342C393835352C393835352C31342C393837352C393837352C31342C393838302C393838302C31342C393838352C393838372C31342C393839362C393839372C3134';
wwv_flow_imp.g_varchar2_table(3283) := '2C393930362C393931362C31342C393932362C393932372C31342C393933352C393933352C31342C393933392C393933392C31342C393936322C393936322C31342C393937322C393937322C31342C393937382C393937382C31342C393938362C393938';
wwv_flow_imp.g_varchar2_table(3284) := '362C31342C393939372C393939372C31342C31303030322C31303030322C31342C31303031372C31303031372C31342C31303035352C31303035352C31342C31303037312C31303037312C31342C31303133332C31303133352C31342C31303534382C31';
wwv_flow_imp.g_varchar2_table(3285) := '303534392C31342C31313039332C31313039332C31342C31323333302C31323333332C352C31323434312C31323434322C352C34323630382C34323631302C352C34333031302C34333031302C352C34333034352C34333034362C352C34333138382C34';
wwv_flow_imp.g_varchar2_table(3286) := '333230332C372C34333330322C34333330392C352C34333339322C34333339342C352C34333434362C34333434392C352C34333439332C34333439332C352C34333537312C34333537322C372C34333539372C34333539372C372C34333730332C343337';
wwv_flow_imp.g_varchar2_table(3287) := '30342C352C34333735362C34333735372C352C34343030332C34343030342C372C34343030392C34343031302C372C34343033332C34343035392C31322C34343038392C34343131352C31322C34343134352C34343137312C31322C34343230312C3434';
wwv_flow_imp.g_varchar2_table(3288) := '3232372C31322C34343235372C34343238332C31322C34343331332C34343333392C31322C34343336392C34343339352C31322C34343432352C34343435312C31322C34343438312C34343530372C31322C34343533372C34343536332C31322C343435';
wwv_flow_imp.g_varchar2_table(3289) := '39332C34343631392C31322C34343634392C34343637352C31322C34343730352C34343733312C31322C34343736312C34343738372C31322C34343831372C34343834332C31322C34343837332C34343839392C31322C34343932392C34343935352C31';
wwv_flow_imp.g_varchar2_table(3290) := '322C34343938352C34353031312C31322C34353034312C34353036372C31322C34353039372C34353132332C31322C34353135332C34353137392C31322C34353230392C34353233352C31322C34353236352C34353239312C31322C34353332312C3435';
wwv_flow_imp.g_varchar2_table(3291) := '3334372C31322C34353337372C34353430332C31322C34353433332C34353435392C31322C34353438392C34353531352C31322C34353534352C34353537312C31322C34353630312C34353632372C31322C34353635372C34353638332C31322C343537';
wwv_flow_imp.g_varchar2_table(3292) := '31332C34353733392C31322C34353736392C34353739352C31322C34353832352C34353835312C31322C34353838312C34353930372C31322C34353933372C34353936332C31322C34353939332C34363031392C31322C34363034392C34363037352C31';
wwv_flow_imp.g_varchar2_table(3293) := '322C34363130352C34363133312C31322C34363136312C34363138372C31322C34363231372C34363234332C31322C34363237332C34363239392C31322C34363332392C34363335352C31322C34363338352C34363431312C31322C34363434312C3436';
wwv_flow_imp.g_varchar2_table(3294) := '3436372C31322C34363439372C34363532332C31322C34363535332C34363537392C31322C34363630392C34363633352C31322C34363636352C34363639312C31322C34363732312C34363734372C31322C34363737372C34363830332C31322C343638';
wwv_flow_imp.g_varchar2_table(3295) := '33332C34363835392C31322C34363838392C34363931352C31322C34363934352C34363937312C31322C34373030312C34373032372C31322C34373035372C34373038332C31322C34373131332C34373133392C31322C34373136392C34373139352C31';
wwv_flow_imp.g_varchar2_table(3296) := '322C34373232352C34373235312C31322C34373238312C34373330372C31322C34373333372C34373336332C31322C34373339332C34373431392C31322C34373434392C34373437352C31322C34373530352C34373533312C31322C34373536312C3437';
wwv_flow_imp.g_varchar2_table(3297) := '3538372C31322C34373631372C34373634332C31322C34373637332C34373639392C31322C34373732392C34373735352C31322C34373738352C34373831312C31322C34373834312C34373836372C31322C34373839372C34373932332C31322C343739';
wwv_flow_imp.g_varchar2_table(3298) := '35332C34373937392C31322C34383030392C34383033352C31322C34383036352C34383039312C31322C34383132312C34383134372C31322C34383137372C34383230332C31322C34383233332C34383235392C31322C34383238392C34383331352C31';
wwv_flow_imp.g_varchar2_table(3299) := '322C34383334352C34383337312C31322C34383430312C34383432372C31322C34383435372C34383438332C31322C34383531332C34383533392C31322C34383536392C34383539352C31322C34383632352C34383635312C31322C34383638312C3438';
wwv_flow_imp.g_varchar2_table(3300) := '3730372C31322C34383733372C34383736332C31322C34383739332C34383831392C31322C34383834392C34383837352C31322C34383930352C34383933312C31322C34383936312C34383938372C31322C34393031372C34393034332C31322C343930';
wwv_flow_imp.g_varchar2_table(3301) := '37332C34393039392C31322C34393132392C34393135352C31322C34393138352C34393231312C31322C34393234312C34393236372C31322C34393239372C34393332332C31322C34393335332C34393337392C31322C34393430392C34393433352C31';
wwv_flow_imp.g_varchar2_table(3302) := '322C34393436352C34393439312C31322C34393532312C34393534372C31322C34393537372C34393630332C31322C34393633332C34393635392C31322C34393638392C34393731352C31322C34393734352C34393737312C31322C34393830312C3439';
wwv_flow_imp.g_varchar2_table(3303) := '3832372C31322C34393835372C34393838332C31322C34393931332C34393933392C31322C34393936392C34393939352C31322C35303032352C35303035312C31322C35303038312C35303130372C31322C35303133372C35303136332C31322C353031';
wwv_flow_imp.g_varchar2_table(3304) := '39332C35303231392C31322C35303234392C35303237352C31322C35303330352C35303333312C31322C35303336312C35303338372C31322C35303431372C35303434332C31322C35303437332C35303439392C31322C35303532392C35303535352C31';
wwv_flow_imp.g_varchar2_table(3305) := '322C35303538352C35303631312C31322C35303634312C35303636372C31322C35303639372C35303732332C31322C35303735332C35303737392C31322C35303830392C35303833352C31322C35303836352C35303839312C31322C35303932312C3530';
wwv_flow_imp.g_varchar2_table(3306) := '3934372C31322C35303937372C35313030332C31322C35313033332C35313035392C31322C35313038392C35313131352C31322C35313134352C35313137312C31322C35313230312C35313232372C31322C35313235372C35313238332C31322C353133';
wwv_flow_imp.g_varchar2_table(3307) := '31332C35313333392C31322C35313336392C35313339352C31322C35313432352C35313435312C31322C35313438312C35313530372C31322C35313533372C35313536332C31322C35313539332C35313631392C31322C35313634392C35313637352C31';
wwv_flow_imp.g_varchar2_table(3308) := '322C35313730352C35313733312C31322C35313736312C35313738372C31322C35313831372C35313834332C31322C35313837332C35313839392C31322C35313932392C35313935352C31322C35313938352C35323031312C31322C35323034312C3532';
wwv_flow_imp.g_varchar2_table(3309) := '3036372C31322C35323039372C35323132332C31322C35323135332C35323137392C31322C35323230392C35323233352C31322C35323236352C35323239312C31322C35323332312C35323334372C31322C35323337372C35323430332C31322C353234';
wwv_flow_imp.g_varchar2_table(3310) := '33332C35323435392C31322C35323438392C35323531352C31322C35323534352C35323537312C31322C35323630312C35323632372C31322C35323635372C35323638332C31322C35323731332C35323733392C31322C35323736392C35323739352C31';
wwv_flow_imp.g_varchar2_table(3311) := '322C35323832352C35323835312C31322C35323838312C35323930372C31322C35323933372C35323936332C31322C35323939332C35333031392C31322C35333034392C35333037352C31322C35333130352C35333133312C31322C35333136312C3533';
wwv_flow_imp.g_varchar2_table(3312) := '3138372C31322C35333231372C35333234332C31322C35333237332C35333239392C31322C35333332392C35333335352C31322C35333338352C35333431312C31322C35333434312C35333436372C31322C35333439372C35333532332C31322C353335';
wwv_flow_imp.g_varchar2_table(3313) := '35332C35333537392C31322C35333630392C35333633352C31322C35333636352C35333639312C31322C35333732312C35333734372C31322C35333737372C35333830332C31322C35333833332C35333835392C31322C35333838392C35333931352C31';
wwv_flow_imp.g_varchar2_table(3314) := '322C35333934352C35333937312C31322C35343030312C35343032372C31322C35343035372C35343038332C31322C35343131332C35343133392C31322C35343136392C35343139352C31322C35343232352C35343235312C31322C35343238312C3534';
wwv_flow_imp.g_varchar2_table(3315) := '3330372C31322C35343333372C35343336332C31322C35343339332C35343431392C31322C35343434392C35343437352C31322C35343530352C35343533312C31322C35343536312C35343538372C31322C35343631372C35343634332C31322C353436';
wwv_flow_imp.g_varchar2_table(3316) := '37332C35343639392C31322C35343732392C35343735352C31322C35343738352C35343831312C31322C35343834312C35343836372C31322C35343839372C35343932332C31322C35343935332C35343937392C31322C35353030392C35353033352C31';
wwv_flow_imp.g_varchar2_table(3317) := '322C35353036352C35353039312C31322C35353132312C35353134372C31322C35353137372C35353230332C31322C36353032342C36353033392C352C36353532302C36353532382C342C36363432322C36363432362C352C36383135322C3638313534';
wwv_flow_imp.g_varchar2_table(3318) := '2C352C36393239312C36393239322C352C36393633332C36393633332C352C36393734372C36393734382C352C36393831312C36393831342C352C36393832362C36393832362C352C36393933322C36393933322C372C37303031362C37303031372C35';
wwv_flow_imp.g_varchar2_table(3319) := '2C37303037392C37303038302C372C37303039352C37303039352C352C37303139362C37303139362C352C37303336372C37303336372C352C37303430322C37303430332C372C37303436342C37303436342C352C37303438372C37303438372C352C37';
wwv_flow_imp.g_varchar2_table(3320) := '303730392C37303731312C372C37303732352C37303732352C372C37303833332C37303833342C372C37303834332C37303834342C372C37303834392C37303834392C372C37313039302C37313039332C352C37313130332C37313130342C352C373132';
wwv_flow_imp.g_varchar2_table(3321) := '32372C37313232382C372C37313333392C37313333392C352C37313334342C37313334392C352C37313435382C37313436312C352C37313732372C37313733352C352C37313938352C37313938392C372C37313939382C37313939382C352C3732303032';
wwv_flow_imp.g_varchar2_table(3322) := '2C37323030322C372C37323135342C37323135352C352C37323139332C37323230322C352C37323235312C37323235342C352C37323238312C37323238332C352C37323334342C37323334352C352C37323736362C37323736362C372C37323837342C37';
wwv_flow_imp.g_varchar2_table(3323) := '323838302C352C37323838352C37323838362C352C37333032332C37333032392C352C37333130342C37333130352C352C37333131312C37333131312C352C39323931322C39323931362C352C39343039352C39343039382C352C3131333832342C3131';
wwv_flow_imp.g_varchar2_table(3324) := '333832372C342C3131393134322C3131393134322C372C3131393135352C3131393136322C342C3131393336322C3131393336342C352C3132313437362C3132313437362C352C3132323838382C3132323930342C352C3132333138342C313233313930';
wwv_flow_imp.g_varchar2_table(3325) := '2C352C3132353235322C3132353235382C352C3132373138332C3132373138332C31342C3132373334302C3132373334332C31342C3132373337372C3132373338362C31342C3132373439312C3132373530332C31342C3132373534382C313237353531';
wwv_flow_imp.g_varchar2_table(3326) := '2C31342C3132373734342C3132373735362C31342C3132373736312C3132373736312C31342C3132373736392C3132373736392C31342C3132373737332C3132373737342C31342C3132373738302C3132373738382C31342C3132373739362C31323737';
wwv_flow_imp.g_varchar2_table(3327) := '39372C31342C3132373832302C3132373832332C31342C3132373836392C3132373836392C31342C3132373839342C3132373839352C31342C3132373930322C3132373930332C31342C3132373934332C3132373934332C31342C3132373934372C3132';
wwv_flow_imp.g_varchar2_table(3328) := '373935302C31342C3132373937322C3132373937322C31342C3132373938382C3132373938382C31342C3132373939322C3132373939342C31342C3132383030392C3132383031312C31342C3132383031392C3132383031392C31342C3132383032332C';
wwv_flow_imp.g_varchar2_table(3329) := '3132383034312C31342C3132383036342C3132383036342C31342C3132383130322C3132383130372C31342C3132383137342C3132383138312C31342C3132383233382C3132383233382C31342C3132383234362C3132383234372C31342C3132383235';
wwv_flow_imp.g_varchar2_table(3330) := '342C3132383235342C31342C3132383236342C3132383236342C31342C3132383237382C3132383239392C31342C3132383332392C3132383333302C31342C3132383334382C3132383335392C31342C3132383337312C3132383337372C31342C313238';
wwv_flow_imp.g_varchar2_table(3331) := '3339322C3132383339332C31342C3132383430312C3132383430342C31342C3132383432312C3132383432312C31342C3132383433332C3132383433342C31342C3132383435302C3132383435322C31342C3132383437362C3132383437382C31342C31';
wwv_flow_imp.g_varchar2_table(3332) := '32383438332C3132383438332C31342C3132383439352C3132383439352C31342C3132383530362C3132383530362C31342C3132383531392C3132383532302C31342C3132383532382C3132383532382C31342C3132383533342C3132383533342C3134';
wwv_flow_imp.g_varchar2_table(3333) := '2C3132383533382C3132383533382C31342C3132383534302C3132383534322C31342C3132383534342C3132383534392C31342C3132383535322C3132383535352C31342C3132383535372C3132383535372C31342C3132383536302C3132383536332C';
wwv_flow_imp.g_varchar2_table(3334) := '31342C3132383536352C3132383536352C31342C3132383536372C3132383537362C31342C3132383538312C3132383539312C31342C3132383634312C3132383634322C31342C3132383634362C3132383634362C31342C3132383634382C3132383634';
wwv_flow_imp.g_varchar2_table(3335) := '382C31342C3132383635302C3132383635312C31342C3132383635332C3132383635332C31342C3132383635352C3132383635352C31342C3132383635372C3132383635392C31342C3132383636312C3132383636312C31342C3132383636332C313238';
wwv_flow_imp.g_varchar2_table(3336) := '3636332C31342C3132383636352C3132383636362C31342C3132383637342C3132383637342C31342C3132383637362C3132383637372C31342C3132383637392C3132383638352C31342C3132383639302C3132383639302C31342C3132383639342C31';
wwv_flow_imp.g_varchar2_table(3337) := '32383639342C31342C3132383639372C3132383730322C31342C3132383730342C3132383730342C31342C3132383731302C3132383731342C31342C3132383731362C3132383731362C31342C3132383732302C3132383732302C31342C313238373233';
wwv_flow_imp.g_varchar2_table(3338) := '2C3132383732342C31342C3132383732362C3132383732372C31342C3132383733332C3132383733352C31342C3132383734322C3132383734342C31342C3132383734362C3132383734362C31342C3132383734392C3132383735312C31342C31323837';
wwv_flow_imp.g_varchar2_table(3339) := '35332C3132383735342C31342C3132383735362C3132383735382C31342C3132383736312C3132383736312C31342C3132383736332C3132383736342C31342C3132383838342C3132383839352C31342C3132383939322C3132393030332C31342C3132';
wwv_flow_imp.g_varchar2_table(3340) := '393030382C3132393030382C31342C3132393033362C3132393033392C31342C3132393131342C3132393131392C31342C3132393139382C3132393237392C31342C3132393239332C3132393239352C31342C3132393330352C3132393331302C31342C';
wwv_flow_imp.g_varchar2_table(3341) := '3132393331322C3132393331392C31342C3132393332382C3132393332382C31342C3132393333312C3132393333382C31342C3132393334332C3132393334332C31342C3132393335312C3132393335352C31342C3132393335372C3132393335392C31';
wwv_flow_imp.g_varchar2_table(3342) := '342C3132393337352C3132393338372C31342C3132393339332C3132393339332C31342C3132393339352C3132393339382C31342C3132393430312C3132393430312C31342C3132393430332C3132393430332C31342C3132393430382C313239343132';
wwv_flow_imp.g_varchar2_table(3343) := '2C31342C3132393432362C3132393433312C31342C3132393434332C3132393434342C31342C3132393435312C3132393435332C31342C3132393435362C3132393436352C31342C3132393437322C3132393437322C31342C3132393437352C31323934';
wwv_flow_imp.g_varchar2_table(3344) := '38322C31342C3132393438342C3132393438342C31342C3132393438382C3132393531302C31342C3132393533362C3132393634372C31342C3132393635322C3132393635322C31342C3132393635362C3132393635382C31342C3132393636312C3132';
wwv_flow_imp.g_varchar2_table(3345) := '393636332C31342C3132393636372C3132393637302C31342C3132393638302C3132393638352C31342C3132393730352C3132393730382C31342C3132393731322C3132393731382C31342C3132393732332C3132393732372C31342C3132393733312C';
wwv_flow_imp.g_varchar2_table(3346) := '3132393733332C31342C3132393734342C3132393735302C31342C3132393735342C3132393735392C31342C3132393736382C3132393737352C31342C3132393738332C3132393739312C31342C3931373530342C3931373530342C342C393137353036';
wwv_flow_imp.g_varchar2_table(3347) := '2C3931373533352C342C3931373633322C3931373735392C342C3931383030302C3932313539392C342C302C392C342C31312C31322C342C31342C33312C342C3136392C3136392C31342C3137342C3137342C31342C313135352C313135392C352C3134';
wwv_flow_imp.g_varchar2_table(3348) := '32352C313436392C352C313437332C313437342C352C313437392C313437392C352C313535322C313536322C352C313631312C313633312C352C313735302C313735362C352C313735392C313736342C352C313737302C313737332C352C313830392C31';
wwv_flow_imp.g_varchar2_table(3349) := '3830392C352C313935382C313936382C352C323034352C323034352C352C323037352C323038332C352C323038392C323039332C352C323139322C323139332C312C323235302C323237332C352C323237352C323330362C352C323336322C323336322C';
wwv_flow_imp.g_varchar2_table(3350) := '352C323336342C323336342C352C323336392C323337362C352C323338312C323338312C352C323338352C323339312C352C323433332C323433332C352C323439322C323439322C352C323439352C323439362C372C323530332C323530342C372C3235';
wwv_flow_imp.g_varchar2_table(3351) := '30392C323530392C352C323533302C323533312C352C323536312C323536322C352C323632302C323632302C352C323632352C323632362C352C323633352C323633372C352C323637322C323637332C352C323638392C323639302C352C323734382C32';
wwv_flow_imp.g_varchar2_table(3352) := '3734382C352C323735332C323735372C352C323736312C323736312C372C323736352C323736352C352C323831302C323831352C352C323831382C323831392C372C323837382C323837382C352C323838302C323838302C372C323838372C323838382C';
wwv_flow_imp.g_varchar2_table(3353) := '372C323839332C323839332C352C323930332C323930332C352C323934362C323934362C352C333030372C333030372C372C333030392C333031302C372C333031382C333032302C372C333033312C333033312C352C333037332C333037352C372C3331';
wwv_flow_imp.g_varchar2_table(3354) := '33322C333133322C352C333133372C333134302C372C333134362C333134392C352C333137302C333137312C352C333230322C333230332C372C333236322C333236322C372C333236342C333236352C372C333236372C333236382C372C333237312C33';
wwv_flow_imp.g_varchar2_table(3355) := '3237322C372C333237362C333237372C352C333239382C333239392C352C333333302C333333312C372C333339302C333339302C352C333339332C333339362C352C333430322C333430342C372C333430362C333430362C312C333432362C333432372C';
wwv_flow_imp.g_varchar2_table(3356) := '352C333435382C333435392C372C333533352C333533352C352C333533382C333534302C352C333534342C333535302C372C333537302C333537312C372C333633352C333633352C372C333635352C333636322C352C333736332C333736332C372C3337';
wwv_flow_imp.g_varchar2_table(3357) := '38342C333738392C352C333839332C333839332C352C333839372C333839372C352C333935332C333936362C352C333936382C333937322C352C333938312C333939312C352C343033382C343033382C352C343134352C343134352C372C343135332C34';
wwv_flow_imp.g_varchar2_table(3358) := '3135342C352C343135372C343135382C352C343138342C343138352C352C343230392C343231322C352C343232382C343232382C372C343233372C343233372C352C343335322C343434372C382C343532302C343630372C31302C353930362C35393038';
wwv_flow_imp.g_varchar2_table(3359) := '2C352C353933382C353933392C352C353937302C353937312C352C363036382C363036392C352C363037312C363037372C352C363038362C363038362C352C363038392C363039392C352C363135352C363135372C352C363135392C363135392C352C36';
wwv_flow_imp.g_varchar2_table(3360) := '3331332C363331332C352C363433352C363433382C372C363434312C363434332C372C363435302C363435302C352C363435372C363435392C352C363638312C363638322C372C363734312C363734312C372C363734332C363734332C372C363735322C';
wwv_flow_imp.g_varchar2_table(3361) := '363735322C352C363735372C363736342C352C363737312C363738302C352C363833322C363834352C352C363834372C363836322C352C363931362C363931362C372C363936352C363936352C352C363937312C363937312C372C363937332C36393737';
wwv_flow_imp.g_varchar2_table(3362) := '2C372C363937392C363938302C372C373034302C373034312C352C373037332C373037332C372C373037382C373037392C372C373038322C373038322C372C373134322C373134322C352C373134342C373134352C352C373134392C373134392C352C37';
wwv_flow_imp.g_varchar2_table(3363) := '3135312C373135332C352C373230342C373231312C372C373232302C373232312C372C373337362C373337382C352C373339332C373339332C372C373430352C373430352C352C373431352C373431352C372C373631362C373637392C352C383230342C';
wwv_flow_imp.g_varchar2_table(3364) := '383230342C352C383230362C383230372C342C383233332C383233332C342C383235322C383235322C31342C383238382C383239322C342C383239342C383330332C342C383431332C383431362C352C383431382C383432302C352C383438322C383438';
wwv_flow_imp.g_varchar2_table(3365) := '322C31342C383539362C383630312C31342C383938362C383938372C31342C393039362C393039362C31342C393139332C393139362C31342C393139392C393139392C31342C393230312C393230322C31342C393230382C393231302C31342C39363432';
wwv_flow_imp.g_varchar2_table(3366) := '2C393634332C31342C393636342C393636342C31342C393732382C393732392C31342C393733322C393733322C31342C393733352C393734312C31342C393734332C393734342C31342C393734362C393734362C31342C393735302C393735312C31342C';
wwv_flow_imp.g_varchar2_table(3367) := '393735332C393735362C31342C393735382C393735392C31342C393736312C393736312C31342C393736342C393736352C31342C393736372C393736392C31342C393737312C393737332C31342C393737352C393737352C31342C393738342C39373835';
wwv_flow_imp.g_varchar2_table(3368) := '2C31342C393738372C393739312C31342C393739332C393739332C31342C393739352C393739392C31342C393831322C393832322C31342C393832342C393832342C31342C393832372C393832372C31342C393832392C393833302C31342C393833322C';
wwv_flow_imp.g_varchar2_table(3369) := '393833322C31342C393835312C393835312C31342C393835342C393835342C31342C393835362C393836312C31342C393837342C393837342C31342C393837362C393837362C31342C393837382C393837392C31342C393838312C393838312C31342C39';
wwv_flow_imp.g_varchar2_table(3370) := '3838332C393838342C31342C393838382C393838392C31342C393839352C393839352C31342C393839382C393839392C31342C393930342C393930352C31342C393931372C393931382C31342C393932342C393932352C31342C393932382C393932382C';
wwv_flow_imp.g_varchar2_table(3371) := '31342C393933342C393933342C31342C393933362C393933362C31342C393933382C393933382C31342C393934302C393934302C31342C393936312C393936312C31342C393936332C393936372C31342C393937302C393937312C31342C393937332C39';
wwv_flow_imp.g_varchar2_table(3372) := '3937332C31342C393937352C393937372C31342C393937392C393938302C31342C393938322C393938352C31342C393938372C393938382C31342C393939322C393939362C31342C393939382C393939382C31342C31303030302C31303030312C31342C';
wwv_flow_imp.g_varchar2_table(3373) := '31303030342C31303030342C31342C31303031332C31303031332C31342C31303032342C31303032342C31342C31303035322C31303035322C31342C31303036302C31303036302C31342C31303036372C31303036392C31342C31303038332C31303038';
wwv_flow_imp.g_varchar2_table(3374) := '332C31342C31303038352C31303038372C31342C31303134352C31303134352C31342C31303137352C31303137352C31342C31313031332C31313031352C31342C31313038382C31313038382C31342C31313530332C31313530352C352C31313734342C';
wwv_flow_imp.g_varchar2_table(3375) := '31313737352C352C31323333342C31323333352C352C31323334392C31323334392C31342C31323935312C31323935312C31342C34323630372C34323630372C352C34323631322C34323632312C352C34323733362C34323733372C352C34333031342C';
wwv_flow_imp.g_varchar2_table(3376) := '34333031342C352C34333034332C34333034342C372C34333034372C34333034372C372C34333133362C34333133372C372C34333230342C34333230352C352C34333236332C34333236332C352C34333333352C34333334352C352C34333336302C3433';
wwv_flow_imp.g_varchar2_table(3377) := '3338382C382C34333339352C34333339352C372C34333434342C34333434352C372C34333435302C34333435312C372C34333435342C34333435362C372C34333536312C34333536362C352C34333536392C34333537302C352C34333537332C34333537';
wwv_flow_imp.g_varchar2_table(3378) := '342C352C34333539362C34333539362C352C34333634342C34333634342C352C34333639382C34333730302C352C34333731302C34333731312C352C34333735352C34333735352C372C34333735382C34333735392C372C34333736362C34333736362C';
wwv_flow_imp.g_varchar2_table(3379) := '352C34343030352C34343030352C352C34343030382C34343030382C352C34343031322C34343031322C372C34343033322C34343033322C31312C34343036302C34343036302C31312C34343038382C34343038382C31312C34343131362C3434313136';
wwv_flow_imp.g_varchar2_table(3380) := '2C31312C34343134342C34343134342C31312C34343137322C34343137322C31312C34343230302C34343230302C31312C34343232382C34343232382C31312C34343235362C34343235362C31312C34343238342C34343238342C31312C34343331322C';
wwv_flow_imp.g_varchar2_table(3381) := '34343331322C31312C34343334302C34343334302C31312C34343336382C34343336382C31312C34343339362C34343339362C31312C34343432342C34343432342C31312C34343435322C34343435322C31312C34343438302C34343438302C31312C34';
wwv_flow_imp.g_varchar2_table(3382) := '343530382C34343530382C31312C34343533362C34343533362C31312C34343536342C34343536342C31312C34343539322C34343539322C31312C34343632302C34343632302C31312C34343634382C34343634382C31312C34343637362C3434363736';
wwv_flow_imp.g_varchar2_table(3383) := '2C31312C34343730342C34343730342C31312C34343733322C34343733322C31312C34343736302C34343736302C31312C34343738382C34343738382C31312C34343831362C34343831362C31312C34343834342C34343834342C31312C34343837322C';
wwv_flow_imp.g_varchar2_table(3384) := '34343837322C31312C34343930302C34343930302C31312C34343932382C34343932382C31312C34343935362C34343935362C31312C34343938342C34343938342C31312C34353031322C34353031322C31312C34353034302C34353034302C31312C34';
wwv_flow_imp.g_varchar2_table(3385) := '353036382C34353036382C31312C34353039362C34353039362C31312C34353132342C34353132342C31312C34353135322C34353135322C31312C34353138302C34353138302C31312C34353230382C34353230382C31312C34353233362C3435323336';
wwv_flow_imp.g_varchar2_table(3386) := '2C31312C34353236342C34353236342C31312C34353239322C34353239322C31312C34353332302C34353332302C31312C34353334382C34353334382C31312C34353337362C34353337362C31312C34353430342C34353430342C31312C34353433322C';
wwv_flow_imp.g_varchar2_table(3387) := '34353433322C31312C34353436302C34353436302C31312C34353438382C34353438382C31312C34353531362C34353531362C31312C34353534342C34353534342C31312C34353537322C34353537322C31312C34353630302C34353630302C31312C34';
wwv_flow_imp.g_varchar2_table(3388) := '353632382C34353632382C31312C34353635362C34353635362C31312C34353638342C34353638342C31312C34353731322C34353731322C31312C34353734302C34353734302C31312C34353736382C34353736382C31312C34353739362C3435373936';
wwv_flow_imp.g_varchar2_table(3389) := '2C31312C34353832342C34353832342C31312C34353835322C34353835322C31312C34353838302C34353838302C31312C34353930382C34353930382C31312C34353933362C34353933362C31312C34353936342C34353936342C31312C34353939322C';
wwv_flow_imp.g_varchar2_table(3390) := '34353939322C31312C34363032302C34363032302C31312C34363034382C34363034382C31312C34363037362C34363037362C31312C34363130342C34363130342C31312C34363133322C34363133322C31312C34363136302C34363136302C31312C34';
wwv_flow_imp.g_varchar2_table(3391) := '363138382C34363138382C31312C34363231362C34363231362C31312C34363234342C34363234342C31312C34363237322C34363237322C31312C34363330302C34363330302C31312C34363332382C34363332382C31312C34363335362C3436333536';
wwv_flow_imp.g_varchar2_table(3392) := '2C31312C34363338342C34363338342C31312C34363431322C34363431322C31312C34363434302C34363434302C31312C34363436382C34363436382C31312C34363439362C34363439362C31312C34363532342C34363532342C31312C34363535322C';
wwv_flow_imp.g_varchar2_table(3393) := '34363535322C31312C34363538302C34363538302C31312C34363630382C34363630382C31312C34363633362C34363633362C31312C34363636342C34363636342C31312C34363639322C34363639322C31312C34363732302C34363732302C31312C34';
wwv_flow_imp.g_varchar2_table(3394) := '363734382C34363734382C31312C34363737362C34363737362C31312C34363830342C34363830342C31312C34363833322C34363833322C31312C34363836302C34363836302C31312C34363838382C34363838382C31312C34363931362C3436393136';
wwv_flow_imp.g_varchar2_table(3395) := '2C31312C34363934342C34363934342C31312C34363937322C34363937322C31312C34373030302C34373030302C31312C34373032382C34373032382C31312C34373035362C34373035362C31312C34373038342C34373038342C31312C34373131322C';
wwv_flow_imp.g_varchar2_table(3396) := '34373131322C31312C34373134302C34373134302C31312C34373136382C34373136382C31312C34373139362C34373139362C31312C34373232342C34373232342C31312C34373235322C34373235322C31312C34373238302C34373238302C31312C34';
wwv_flow_imp.g_varchar2_table(3397) := '373330382C34373330382C31312C34373333362C34373333362C31312C34373336342C34373336342C31312C34373339322C34373339322C31312C34373432302C34373432302C31312C34373434382C34373434382C31312C34373437362C3437343736';
wwv_flow_imp.g_varchar2_table(3398) := '2C31312C34373530342C34373530342C31312C34373533322C34373533322C31312C34373536302C34373536302C31312C34373538382C34373538382C31312C34373631362C34373631362C31312C34373634342C34373634342C31312C34373637322C';
wwv_flow_imp.g_varchar2_table(3399) := '34373637322C31312C34373730302C34373730302C31312C34373732382C34373732382C31312C34373735362C34373735362C31312C34373738342C34373738342C31312C34373831322C34373831322C31312C34373834302C34373834302C31312C34';
wwv_flow_imp.g_varchar2_table(3400) := '373836382C34373836382C31312C34373839362C34373839362C31312C34373932342C34373932342C31312C34373935322C34373935322C31312C34373938302C34373938302C31312C34383030382C34383030382C31312C34383033362C3438303336';
wwv_flow_imp.g_varchar2_table(3401) := '2C31312C34383036342C34383036342C31312C34383039322C34383039322C31312C34383132302C34383132302C31312C34383134382C34383134382C31312C34383137362C34383137362C31312C34383230342C34383230342C31312C34383233322C';
wwv_flow_imp.g_varchar2_table(3402) := '34383233322C31312C34383236302C34383236302C31312C34383238382C34383238382C31312C34383331362C34383331362C31312C34383334342C34383334342C31312C34383337322C34383337322C31312C34383430302C34383430302C31312C34';
wwv_flow_imp.g_varchar2_table(3403) := '383432382C34383432382C31312C34383435362C34383435362C31312C34383438342C34383438342C31312C34383531322C34383531322C31312C34383534302C34383534302C31312C34383536382C34383536382C31312C34383539362C3438353936';
wwv_flow_imp.g_varchar2_table(3404) := '2C31312C34383632342C34383632342C31312C34383635322C34383635322C31312C34383638302C34383638302C31312C34383730382C34383730382C31312C34383733362C34383733362C31312C34383736342C34383736342C31312C34383739322C';
wwv_flow_imp.g_varchar2_table(3405) := '34383739322C31312C34383832302C34383832302C31312C34383834382C34383834382C31312C34383837362C34383837362C31312C34383930342C34383930342C31312C34383933322C34383933322C31312C34383936302C34383936302C31312C34';
wwv_flow_imp.g_varchar2_table(3406) := '383938382C34383938382C31312C34393031362C34393031362C31312C34393034342C34393034342C31312C34393037322C34393037322C31312C34393130302C34393130302C31312C34393132382C34393132382C31312C34393135362C3439313536';
wwv_flow_imp.g_varchar2_table(3407) := '2C31312C34393138342C34393138342C31312C34393231322C34393231322C31312C34393234302C34393234302C31312C34393236382C34393236382C31312C34393239362C34393239362C31312C34393332342C34393332342C31312C34393335322C';
wwv_flow_imp.g_varchar2_table(3408) := '34393335322C31312C34393338302C34393338302C31312C34393430382C34393430382C31312C34393433362C34393433362C31312C34393436342C34393436342C31312C34393439322C34393439322C31312C34393532302C34393532302C31312C34';
wwv_flow_imp.g_varchar2_table(3409) := '393534382C34393534382C31312C34393537362C34393537362C31312C34393630342C34393630342C31312C34393633322C34393633322C31312C34393636302C34393636302C31312C34393638382C34393638382C31312C34393731362C3439373136';
wwv_flow_imp.g_varchar2_table(3410) := '2C31312C34393734342C34393734342C31312C34393737322C34393737322C31312C34393830302C34393830302C31312C34393832382C34393832382C31312C34393835362C34393835362C31312C34393838342C34393838342C31312C34393931322C';
wwv_flow_imp.g_varchar2_table(3411) := '34393931322C31312C34393934302C34393934302C31312C34393936382C34393936382C31312C34393939362C34393939362C31312C35303032342C35303032342C31312C35303035322C35303035322C31312C35303038302C35303038302C31312C35';
wwv_flow_imp.g_varchar2_table(3412) := '303130382C35303130382C31312C35303133362C35303133362C31312C35303136342C35303136342C31312C35303139322C35303139322C31312C35303232302C35303232302C31312C35303234382C35303234382C31312C35303237362C3530323736';
wwv_flow_imp.g_varchar2_table(3413) := '2C31312C35303330342C35303330342C31312C35303333322C35303333322C31312C35303336302C35303336302C31312C35303338382C35303338382C31312C35303431362C35303431362C31312C35303434342C35303434342C31312C35303437322C';
wwv_flow_imp.g_varchar2_table(3414) := '35303437322C31312C35303530302C35303530302C31312C35303532382C35303532382C31312C35303535362C35303535362C31312C35303538342C35303538342C31312C35303631322C35303631322C31312C35303634302C35303634302C31312C35';
wwv_flow_imp.g_varchar2_table(3415) := '303636382C35303636382C31312C35303639362C35303639362C31312C35303732342C35303732342C31312C35303735322C35303735322C31312C35303738302C35303738302C31312C35303830382C35303830382C31312C35303833362C3530383336';
wwv_flow_imp.g_varchar2_table(3416) := '2C31312C35303836342C35303836342C31312C35303839322C35303839322C31312C35303932302C35303932302C31312C35303934382C35303934382C31312C35303937362C35303937362C31312C35313030342C35313030342C31312C35313033322C';
wwv_flow_imp.g_varchar2_table(3417) := '35313033322C31312C35313036302C35313036302C31312C35313038382C35313038382C31312C35313131362C35313131362C31312C35313134342C35313134342C31312C35313137322C35313137322C31312C35313230302C35313230302C31312C35';
wwv_flow_imp.g_varchar2_table(3418) := '313232382C35313232382C31312C35313235362C35313235362C31312C35313238342C35313238342C31312C35313331322C35313331322C31312C35313334302C35313334302C31312C35313336382C35313336382C31312C35313339362C3531333936';
wwv_flow_imp.g_varchar2_table(3419) := '2C31312C35313432342C35313432342C31312C35313435322C35313435322C31312C35313438302C35313438302C31312C35313530382C35313530382C31312C35313533362C35313533362C31312C35313536342C35313536342C31312C35313539322C';
wwv_flow_imp.g_varchar2_table(3420) := '35313539322C31312C35313632302C35313632302C31312C35313634382C35313634382C31312C35313637362C35313637362C31312C35313730342C35313730342C31312C35313733322C35313733322C31312C35313736302C35313736302C31312C35';
wwv_flow_imp.g_varchar2_table(3421) := '313738382C35313738382C31312C35313831362C35313831362C31312C35313834342C35313834342C31312C35313837322C35313837322C31312C35313930302C35313930302C31312C35313932382C35313932382C31312C35313935362C3531393536';
wwv_flow_imp.g_varchar2_table(3422) := '2C31312C35313938342C35313938342C31312C35323031322C35323031322C31312C35323034302C35323034302C31312C35323036382C35323036382C31312C35323039362C35323039362C31312C35323132342C35323132342C31312C35323135322C';
wwv_flow_imp.g_varchar2_table(3423) := '35323135322C31312C35323138302C35323138302C31312C35323230382C35323230382C31312C35323233362C35323233362C31312C35323236342C35323236342C31312C35323239322C35323239322C31312C35323332302C35323332302C31312C35';
wwv_flow_imp.g_varchar2_table(3424) := '323334382C35323334382C31312C35323337362C35323337362C31312C35323430342C35323430342C31312C35323433322C35323433322C31312C35323436302C35323436302C31312C35323438382C35323438382C31312C35323531362C3532353136';
wwv_flow_imp.g_varchar2_table(3425) := '2C31312C35323534342C35323534342C31312C35323537322C35323537322C31312C35323630302C35323630302C31312C35323632382C35323632382C31312C35323635362C35323635362C31312C35323638342C35323638342C31312C35323731322C';
wwv_flow_imp.g_varchar2_table(3426) := '35323731322C31312C35323734302C35323734302C31312C35323736382C35323736382C31312C35323739362C35323739362C31312C35323832342C35323832342C31312C35323835322C35323835322C31312C35323838302C35323838302C31312C35';
wwv_flow_imp.g_varchar2_table(3427) := '323930382C35323930382C31312C35323933362C35323933362C31312C35323936342C35323936342C31312C35323939322C35323939322C31312C35333032302C35333032302C31312C35333034382C35333034382C31312C35333037362C3533303736';
wwv_flow_imp.g_varchar2_table(3428) := '2C31312C35333130342C35333130342C31312C35333133322C35333133322C31312C35333136302C35333136302C31312C35333138382C35333138382C31312C35333231362C35333231362C31312C35333234342C35333234342C31312C35333237322C';
wwv_flow_imp.g_varchar2_table(3429) := '35333237322C31312C35333330302C35333330302C31312C35333332382C35333332382C31312C35333335362C35333335362C31312C35333338342C35333338342C31312C35333431322C35333431322C31312C35333434302C35333434302C31312C35';
wwv_flow_imp.g_varchar2_table(3430) := '333436382C35333436382C31312C35333439362C35333439362C31312C35333532342C35333532342C31312C35333535322C35333535322C31312C35333538302C35333538302C31312C35333630382C35333630382C31312C35333633362C3533363336';
wwv_flow_imp.g_varchar2_table(3431) := '2C31312C35333636342C35333636342C31312C35333639322C35333639322C31312C35333732302C35333732302C31312C35333734382C35333734382C31312C35333737362C35333737362C31312C35333830342C35333830342C31312C35333833322C';
wwv_flow_imp.g_varchar2_table(3432) := '35333833322C31312C35333836302C35333836302C31312C35333838382C35333838382C31312C35333931362C35333931362C31312C35333934342C35333934342C31312C35333937322C35333937322C31312C35343030302C35343030302C31312C35';
wwv_flow_imp.g_varchar2_table(3433) := '343032382C35343032382C31312C35343035362C35343035362C31312C35343038342C35343038342C31312C35343131322C35343131322C31312C35343134302C35343134302C31312C35343136382C35343136382C31312C35343139362C3534313936';
wwv_flow_imp.g_varchar2_table(3434) := '2C31312C35343232342C35343232342C31312C35343235322C35343235322C31312C35343238302C35343238302C31312C35343330382C35343330382C31312C35343333362C35343333362C31312C35343336342C35343336342C31312C35343339322C';
wwv_flow_imp.g_varchar2_table(3435) := '35343339322C31312C35343432302C35343432302C31312C35343434382C35343434382C31312C35343437362C35343437362C31312C35343530342C35343530342C31312C35343533322C35343533322C31312C35343536302C35343536302C31312C35';
wwv_flow_imp.g_varchar2_table(3436) := '343538382C35343538382C31312C35343631362C35343631362C31312C35343634342C35343634342C31312C35343637322C35343637322C31312C35343730302C35343730302C31312C35343732382C35343732382C31312C35343735362C3534373536';
wwv_flow_imp.g_varchar2_table(3437) := '2C31312C35343738342C35343738342C31312C35343831322C35343831322C31312C35343834302C35343834302C31312C35343836382C35343836382C31312C35343839362C35343839362C31312C35343932342C35343932342C31312C35343935322C';
wwv_flow_imp.g_varchar2_table(3438) := '35343935322C31312C35343938302C35343938302C31312C35353030382C35353030382C31312C35353033362C35353033362C31312C35353036342C35353036342C31312C35353039322C35353039322C31312C35353132302C35353132302C31312C35';
wwv_flow_imp.g_varchar2_table(3439) := '353134382C35353134382C31312C35353137362C35353137362C31312C35353231362C35353233382C392C36343238362C36343238362C352C36353035362C36353037312C352C36353433382C36353433392C352C36353532392C36353533312C342C36';
wwv_flow_imp.g_varchar2_table(3440) := '363237322C36363237322C352C36383039372C36383039392C352C36383130382C36383131312C352C36383135392C36383135392C352C36383930302C36383930332C352C36393434362C36393435362C352C36393633322C36393633322C372C363936';
wwv_flow_imp.g_varchar2_table(3441) := '33342C36393633342C372C36393734342C36393734342C352C36393735392C36393736312C352C36393830382C36393831302C372C36393831352C36393831362C372C36393832312C36393832312C312C36393833372C36393833372C312C3639393237';
wwv_flow_imp.g_varchar2_table(3442) := '2C36393933312C352C36393933332C36393934302C352C37303030332C37303030332C352C37303031382C37303031382C372C37303037302C37303037382C352C37303038322C37303038332C312C37303039342C37303039342C372C37303138382C37';
wwv_flow_imp.g_varchar2_table(3443) := '303139302C372C37303139342C37303139352C372C37303139372C37303139372C372C37303230362C37303230362C352C37303336382C37303337302C372C37303430302C37303430312C352C37303435392C37303436302C352C37303436332C373034';
wwv_flow_imp.g_varchar2_table(3444) := '36332C372C37303436352C37303436382C372C37303437352C37303437372C372C37303439382C37303439392C372C37303531322C37303531362C352C37303731322C37303731392C352C37303732322C37303732342C352C37303732362C3730373236';
wwv_flow_imp.g_varchar2_table(3445) := '2C352C37303833322C37303833322C352C37303833352C37303834302C352C37303834322C37303834322C352C37303834352C37303834352C352C37303834372C37303834382C352C37303835302C37303835312C352C37313038382C37313038392C37';
wwv_flow_imp.g_varchar2_table(3446) := '2C37313039362C37313039392C372C37313130322C37313130322C372C37313133322C37313133332C352C37313231392C37313232362C352C37313232392C37313232392C352C37313233312C37313233322C352C37313334302C37313334302C372C37';
wwv_flow_imp.g_varchar2_table(3447) := '313334322C37313334332C372C37313335302C37313335302C372C37313435332C37313435352C352C37313436322C37313436322C372C37313732342C37313732362C372C37313733362C37313733362C372C37313938342C37313938342C352C373139';
wwv_flow_imp.g_varchar2_table(3448) := '39312C37313939322C372C37313939372C37313939372C372C37313939392C37313939392C312C37323030312C37323030312C312C37323030332C37323030332C352C37323134382C37323135312C352C37323135362C37323135392C372C3732313634';
wwv_flow_imp.g_varchar2_table(3449) := '2C37323136342C372C37323234332C37323234382C352C37323235302C37323235302C312C37323236332C37323236332C352C37323237392C37323238302C372C37323332342C37323332392C312C37323334332C37323334332C372C37323735312C37';
wwv_flow_imp.g_varchar2_table(3450) := '323735312C372C37323736302C37323736352C352C37323736372C37323736372C352C37323837332C37323837332C372C37323838312C37323838312C372C37323838342C37323838342C372C37333030392C37333031342C352C37333032302C373330';
wwv_flow_imp.g_varchar2_table(3451) := '32312C352C37333033302C37333033302C312C37333039382C37333130322C372C37333130372C37333130382C372C37333131302C37333131302C372C37333435392C37333436302C352C37383839362C37383930342C342C39323937362C3932393832';
wwv_flow_imp.g_varchar2_table(3452) := '2C352C39343033332C39343038372C372C39343138302C39343138302C352C3131333832312C3131333832322C352C3131383532382C3131383537332C352C3131393134312C3131393134312C352C3131393134332C3131393134352C352C3131393135';
wwv_flow_imp.g_varchar2_table(3453) := '302C3131393135342C352C3131393136332C3131393137302C352C3131393231302C3131393231332C352C3132313334342C3132313339382C352C3132313436312C3132313436312C352C3132313439392C3132313530332C352C3132323838302C3132';
wwv_flow_imp.g_varchar2_table(3454) := '323838362C352C3132323930372C3132323931332C352C3132323931382C3132323932322C352C3132333536362C3132333536362C352C3132353133362C3132353134322C352C3132363937362C3132363937392C31342C3132363938312C3132373138';
wwv_flow_imp.g_varchar2_table(3455) := '322C31342C3132373138342C3132373233312C31342C3132373237392C3132373237392C31342C3132373334342C3132373334352C31342C3132373337342C3132373337342C31342C3132373430352C3132373436312C31342C3132373438392C313237';
wwv_flow_imp.g_varchar2_table(3456) := '3439302C31342C3132373531342C3132373531342C31342C3132373533382C3132373534362C31342C3132373536312C3132373536372C31342C3132373537302C3132373734332C31342C3132373735372C3132373735382C31342C3132373736302C31';
wwv_flow_imp.g_varchar2_table(3457) := '32373736302C31342C3132373736322C3132373736322C31342C3132373736362C3132373736382C31342C3132373737302C3132373737302C31342C3132373737322C3132373737322C31342C3132373737352C3132373737362C31342C313237373738';
wwv_flow_imp.g_varchar2_table(3458) := '2C3132373737392C31342C3132373738392C3132373739312C31342C3132373739342C3132373739352C31342C3132373739382C3132373739382C31342C3132373831392C3132373831392C31342C3132373832342C3132373832342C31342C31323738';
wwv_flow_imp.g_varchar2_table(3459) := '36382C3132373836382C31342C3132373837302C3132373837312C31342C3132373839322C3132373839332C31342C3132373839362C3132373839362C31342C3132373930302C3132373930312C31342C3132373930342C3132373934302C31342C3132';
wwv_flow_imp.g_varchar2_table(3460) := '373934322C3132373934322C31342C3132373934342C3132373934342C31342C3132373934362C3132373934362C31342C3132373935312C3132373935352C31342C3132373936382C3132373937312C31342C3132373937332C3132373938342C31342C';
wwv_flow_imp.g_varchar2_table(3461) := '3132373938372C3132373938372C31342C3132373938392C3132373938392C31342C3132373939312C3132373939312C31342C3132373939352C3132373939392C352C3132383030382C3132383030382C31342C3132383031322C3132383031342C3134';
wwv_flow_imp.g_varchar2_table(3462) := '2C3132383031372C3132383031382C31342C3132383032302C3132383032302C31342C3132383032322C3132383032322C31342C3132383034322C3132383034322C31342C3132383036332C3132383036332C31342C3132383036352C3132383036352C';
wwv_flow_imp.g_varchar2_table(3463) := '31342C3132383130312C3132383130312C31342C3132383130382C3132383130392C31342C3132383137332C3132383137332C31342C3132383138322C3132383138332C31342C3132383233362C3132383233372C31342C3132383233392C3132383233';
wwv_flow_imp.g_varchar2_table(3464) := '392C31342C3132383234352C3132383234352C31342C3132383234382C3132383234382C31342C3132383235332C3132383235332C31342C3132383235352C3132383235382C31342C3132383236302C3132383236332C31342C3132383236352C313238';
wwv_flow_imp.g_varchar2_table(3465) := '3236352C31342C3132383237372C3132383237372C31342C3132383330302C3132383330312C31342C3132383332362C3132383332382C31342C3132383333312C3132383333342C31342C3132383333362C3132383334372C31342C3132383336302C31';
wwv_flow_imp.g_varchar2_table(3466) := '32383336362C31342C3132383336392C3132383337302C31342C3132383337382C3132383337382C31342C3132383339312C3132383339312C31342C3132383339342C3132383339372C31342C3132383430302C3132383430302C31342C313238343035';
wwv_flow_imp.g_varchar2_table(3467) := '2C3132383430362C31342C3132383432302C3132383432302C31342C3132383432322C3132383432332C31342C3132383432352C3132383433322C31342C3132383433352C3132383434332C31342C3132383434352C3132383434392C31342C31323834';
wwv_flow_imp.g_varchar2_table(3468) := '35332C3132383436342C31342C3132383436382C3132383437352C31342C3132383437392C3132383438302C31342C3132383438322C3132383438322C31342C3132383438342C3132383438372C31342C3132383438392C3132383439342C31342C3132';
wwv_flow_imp.g_varchar2_table(3469) := '383439362C3132383439382C31342C3132383530302C3132383530352C31342C3132383530372C3132383531312C31342C3132383531332C3132383531382C31342C3132383532312C3132383532352C31342C3132383532372C3132383532372C31342C';
wwv_flow_imp.g_varchar2_table(3470) := '3132383532392C3132383532392C31342C3132383533332C3132383533332C31342C3132383533352C3132383533352C31342C3132383533372C3132383533372C31345D22297D6765744772617068656D65427265616B547970652865297B696628653C';
wwv_flow_imp.g_varchar2_table(3471) := '33322972657475726E2031303D3D3D653F333A31333D3D3D653F323A343B696628653C3132372972657475726E20303B636F6E737420743D746869732E5F646174612C6E3D742E6C656E6774682F333B6C657420693D313B666F72283B693C3D6E3B2969';
wwv_flow_imp.g_varchar2_table(3472) := '6628653C745B332A695D29692A3D323B656C73657B6966282128653E745B332A692B315D292972657475726E20745B332A692B325D3B693D322A692B317D72657475726E20307D7D66756E6374696F6E2059692865297B72657475726E20313237393935';
wwv_flow_imp.g_varchar2_table(3473) := '3C3D652626653C3D3132373939397D51692E5F494E5354414E43453D6E756C6C3B636C617373205A697B73746174696320676574496E7374616E63652865297B72657475726E206F692E63616368652E6765742841727261792E66726F6D286529297D73';
wwv_flow_imp.g_varchar2_table(3474) := '7461746963206765744C6F63616C657328297B72657475726E206F692E5F6C6F63616C65732E76616C75657D636F6E7374727563746F722865297B746869732E636F6E66757361626C6544696374696F6E6172793D657D6973416D626967756F75732865';
wwv_flow_imp.g_varchar2_table(3475) := '297B72657475726E20746869732E636F6E66757361626C6544696374696F6E6172792E6861732865297D6765745072696D617279436F6E66757361626C652865297B72657475726E20746869732E636F6E66757361626C6544696374696F6E6172792E67';
wwv_flow_imp.g_varchar2_table(3476) := '65742865297D676574436F6E66757361626C65436F6465506F696E747328297B72657475726E206E65772053657428746869732E636F6E66757361626C6544696374696F6E6172792E6B6579732829297D7D6F693D5A692C5A692E616D626967756F7573';
wwv_flow_imp.g_varchar2_table(3477) := '436861726163746572446174613D6E6577206969282828293D3E4A534F4E2E706172736528277B225F636F6D6D6F6E223A5B383233322C33322C383233332C33322C353736302C33322C383139322C33322C383139332C33322C383139342C33322C3831';
wwv_flow_imp.g_varchar2_table(3478) := '39352C33322C383139362C33322C383139372C33322C383139382C33322C383230302C33322C383230312C33322C383230322C33322C383238372C33322C383139392C33322C383233392C33322C323034322C39352C36353130312C39352C3635313032';
wwv_flow_imp.g_varchar2_table(3479) := '2C39352C36353130332C39352C383230382C34352C383230392C34352C383231302C34352C36353131322C34352C313734382C34352C383235392C34352C3732372C34352C383732322C34352C31303133342C34352C31313435302C34352C313534392C';
wwv_flow_imp.g_varchar2_table(3480) := '34342C313634332C34342C383231382C34342C3138342C34342C34323233332C34342C3839342C35392C323330372C35382C323639312C35382C313431372C35382C313739352C35382C313739362C35382C353836382C35382C36353037322C35382C36';
wwv_flow_imp.g_varchar2_table(3481) := '3134372C35382C363135332C35382C383238322C35382C313437352C35382C3736302C35382C34323838392C35382C383735382C35382C3732302C35382C34323233372C35382C3435312C33332C31313630312C33332C3636302C36332C3537372C3633';
wwv_flow_imp.g_varchar2_table(3482) := '2C323432392C36332C353033382C36332C34323733312C36332C3131393134392C34362C383232382C34362C313739332C34362C313739342C34362C34323531302C34362C36383137362C34362C313633322C34362C313737362C34362C34323233322C';
wwv_flow_imp.g_varchar2_table(3483) := '34362C313337332C39362C36353238372C39362C383231392C39362C383234322C39362C313337302C39362C313532332C39362C383137352C39362C36353334342C39362C3930302C39362C383138392C39362C383132352C39362C383132372C39362C';
wwv_flow_imp.g_varchar2_table(3484) := '383139302C39362C3639372C39362C3838342C39362C3731322C39362C3731342C39362C3731352C39362C3735362C39362C3639392C39362C3730312C39362C3730302C39362C3730322C39362C34323839322C39362C313439372C39362C323033362C';
wwv_flow_imp.g_varchar2_table(3485) := '39362C323033372C39362C353139342C39362C353833362C39362C39343033332C39362C39343033342C39362C36353333392C39312C31303038382C34302C31303039382C34302C31323330382C34302C36343833302C34302C36353334312C39332C31';
wwv_flow_imp.g_varchar2_table(3486) := '303038392C34312C31303039392C34312C31323330392C34312C36343833312C34312C31303130302C3132332C3131393036302C3132332C31303130312C3132352C36353334322C39342C383237302C34322C313634352C34322C383732372C34322C36';
wwv_flow_imp.g_varchar2_table(3487) := '363333352C34322C353934312C34372C383235372C34372C383732352C34372C383236302C34372C393538352C34372C31303138372C34372C31303734342C34372C3131393335342C34372C31323735352C34372C31323333392C34372C31313436322C';
wwv_flow_imp.g_varchar2_table(3488) := '34372C32303033312C34372C31323033352C34372C36353334302C39322C36353132382C39322C383732362C39322C31303138392C39322C31303734312C39322C31303734352C39322C3131393331312C39322C3131393335352C39322C31323735362C';
wwv_flow_imp.g_varchar2_table(3489) := '39322C32303032322C39322C31323033342C39322C34323837322C33382C3730382C39342C3731302C39342C353836392C34332C31303133332C34332C36363230332C34332C383234392C36302C31303039342C36302C3730362C36302C313139333530';
wwv_flow_imp.g_varchar2_table(3490) := '2C36302C353137362C36302C353831302C36302C353132302C36312C31313834302C36312C31323434382C36312C34323233392C36312C383235302C36322C31303039352C36322C3730372C36322C3131393335312C36322C353137312C36322C393430';
wwv_flow_imp.g_varchar2_table(3491) := '31352C36322C383237352C3132362C3733322C3132362C383132382C3132362C383736342C3132362C36353337322C3132342C36353239332C34352C3132303738342C35302C3132303739342C35302C3132303830342C35302C3132303831342C35302C';
wwv_flow_imp.g_varchar2_table(3492) := '3132303832342C35302C3133303033342C35302C34323834322C35302C3432332C35302C313030302C35302C34323536342C35302C353331312C35302C34323733352C35302C3131393330322C35312C3132303738352C35312C3132303739352C35312C';
wwv_flow_imp.g_varchar2_table(3493) := '3132303830352C35312C3132303831352C35312C3132303832352C35312C3133303033352C35312C34323932332C35312C3534302C35312C3433392C35312C34323835382C35312C31313436382C35312C313234382C35312C39343031312C35312C3731';
wwv_flow_imp.g_varchar2_table(3494) := '3838322C35312C3132303738362C35322C3132303739362C35322C3132303830362C35322C3132303831362C35322C3132303832362C35322C3133303033362C35322C353037302C35322C37313835352C35322C3132303738372C35332C313230373937';
wwv_flow_imp.g_varchar2_table(3495) := '2C35332C3132303830372C35332C3132303831372C35332C3132303832372C35332C3133303033372C35332C3434342C35332C37313836372C35332C3132303738382C35342C3132303739382C35342C3132303830382C35342C3132303831382C35342C';
wwv_flow_imp.g_varchar2_table(3496) := '3132303832382C35342C3133303033382C35342C31313437342C35342C353130322C35342C37313839332C35342C3131393331342C35352C3132303738392C35352C3132303739392C35352C3132303830392C35352C3132303831392C35352C31323038';
wwv_flow_imp.g_varchar2_table(3497) := '32392C35352C3133303033392C35352C36363737302C35352C37313837382C35352C323831392C35362C323533382C35362C323636362C35362C3132353133312C35362C3132303739302C35362C3132303830302C35362C3132303831302C35362C3132';
wwv_flow_imp.g_varchar2_table(3498) := '303832302C35362C3132303833302C35362C3133303034302C35362C3534372C35362C3534362C35362C36363333302C35362C323636332C35372C323932302C35372C323534312C35372C333433372C35372C3132303739312C35372C3132303830312C';
wwv_flow_imp.g_varchar2_table(3499) := '35372C3132303831312C35372C3132303832312C35372C3132303833312C35372C3133303034312C35372C34323836322C35372C31313436362C35372C37313838342C35372C37313835322C35372C37313839342C35372C393038322C39372C36353334';
wwv_flow_imp.g_varchar2_table(3500) := '352C39372C3131393833342C39372C3131393838362C39372C3131393933382C39372C3131393939302C39372C3132303034322C39372C3132303039342C39372C3132303134362C39372C3132303139382C39372C3132303235302C39372C3132303330';
wwv_flow_imp.g_varchar2_table(3501) := '322C39372C3132303335342C39372C3132303430362C39372C3132303435382C39372C3539332C39372C3934352C39372C3132303531342C39372C3132303537322C39372C3132303633302C39372C3132303638382C39372C3132303734362C39372C36';
wwv_flow_imp.g_varchar2_table(3502) := '353331332C36352C3131393830382C36352C3131393836302C36352C3131393931322C36352C3131393936342C36352C3132303031362C36352C3132303036382C36352C3132303132302C36352C3132303137322C36352C3132303232342C36352C3132';
wwv_flow_imp.g_varchar2_table(3503) := '303237362C36352C3132303332382C36352C3132303338302C36352C3132303433322C36352C3931332C36352C3132303438382C36352C3132303534362C36352C3132303630342C36352C3132303636322C36352C3132303732302C36352C353033342C';
wwv_flow_imp.g_varchar2_table(3504) := '36352C353537332C36352C34323232322C36352C39343031362C36352C36363230382C36352C3131393833352C39382C3131393838372C39382C3131393933392C39382C3131393939312C39382C3132303034332C39382C3132303039352C39382C3132';
wwv_flow_imp.g_varchar2_table(3505) := '303134372C39382C3132303139392C39382C3132303235312C39382C3132303330332C39382C3132303335352C39382C3132303430372C39382C3132303435392C39382C3338382C39382C353037312C39382C353233342C39382C353535312C39382C36';
wwv_flow_imp.g_varchar2_table(3506) := '353331342C36362C383439322C36362C3131393830392C36362C3131393836312C36362C3131393931332C36362C3132303031372C36362C3132303036392C36362C3132303132312C36362C3132303137332C36362C3132303232352C36362C31323032';
wwv_flow_imp.g_varchar2_table(3507) := '37372C36362C3132303332392C36362C3132303338312C36362C3132303433332C36362C34323933322C36362C3931342C36362C3132303438392C36362C3132303534372C36362C3132303630352C36362C3132303636332C36362C3132303732312C36';
wwv_flow_imp.g_varchar2_table(3508) := '362C353130382C36362C353632332C36362C34323139322C36362C36363137382C36362C36363230392C36362C36363330352C36362C36353334372C39392C383537332C39392C3131393833362C39392C3131393838382C39392C3131393934302C3939';
wwv_flow_imp.g_varchar2_table(3509) := '2C3131393939322C39392C3132303034342C39392C3132303039362C39392C3132303134382C39392C3132303230302C39392C3132303235322C39392C3132303330342C39392C3132303335362C39392C3132303430382C39392C3132303436302C3939';
wwv_flow_imp.g_varchar2_table(3510) := '2C373432382C39392C313031302C39392C31313432392C39392C34333935312C39392C36363632312C39392C3132383834342C36372C37313932322C36372C37313931332C36372C36353331352C36372C383535372C36372C383435302C36372C383439';
wwv_flow_imp.g_varchar2_table(3511) := '332C36372C3131393831302C36372C3131393836322C36372C3131393931342C36372C3131393936362C36372C3132303031382C36372C3132303137342C36372C3132303232362C36372C3132303237382C36372C3132303333302C36372C3132303338';
wwv_flow_imp.g_varchar2_table(3512) := '322C36372C3132303433342C36372C313031372C36372C31313432382C36372C353038372C36372C34323230322C36372C36363231302C36372C36363330362C36372C36363538312C36372C36363834342C36372C383537342C3130302C383531382C31';
wwv_flow_imp.g_varchar2_table(3513) := '30302C3131393833372C3130302C3131393838392C3130302C3131393934312C3130302C3131393939332C3130302C3132303034352C3130302C3132303039372C3130302C3132303134392C3130302C3132303230312C3130302C3132303235332C3130';
wwv_flow_imp.g_varchar2_table(3514) := '302C3132303330352C3130302C3132303335372C3130302C3132303430392C3130302C3132303436312C3130302C313238312C3130302C353039352C3130302C353233312C3130302C34323139342C3130302C383535382C36382C383531372C36382C31';
wwv_flow_imp.g_varchar2_table(3515) := '31393831312C36382C3131393836332C36382C3131393931352C36382C3131393936372C36382C3132303031392C36382C3132303037312C36382C3132303132332C36382C3132303137352C36382C3132303232372C36382C3132303237392C36382C31';
wwv_flow_imp.g_varchar2_table(3516) := '32303333312C36382C3132303338332C36382C3132303433352C36382C353032342C36382C353539382C36382C353631302C36382C34323139352C36382C383439342C3130312C36353334392C3130312C383439352C3130312C383531392C3130312C31';
wwv_flow_imp.g_varchar2_table(3517) := '31393833382C3130312C3131393839302C3130312C3131393934322C3130312C3132303034362C3130312C3132303039382C3130312C3132303135302C3130312C3132303230322C3130312C3132303235342C3130312C3132303330362C3130312C3132';
wwv_flow_imp.g_varchar2_table(3518) := '303335382C3130312C3132303431302C3130312C3132303436322C3130312C34333832362C3130312C313231332C3130312C383935392C36392C36353331372C36392C383439362C36392C3131393831322C36392C3131393836342C36392C3131393931';
wwv_flow_imp.g_varchar2_table(3519) := '362C36392C3132303032302C36392C3132303037322C36392C3132303132342C36392C3132303137362C36392C3132303232382C36392C3132303238302C36392C3132303333322C36392C3132303338342C36392C3132303433362C36392C3931372C36';
wwv_flow_imp.g_varchar2_table(3520) := '392C3132303439322C36392C3132303535302C36392C3132303630382C36392C3132303636362C36392C3132303732342C36392C31313537372C36392C353033362C36392C34323232342C36392C37313834362C36392C37313835342C36392C36363138';
wwv_flow_imp.g_varchar2_table(3521) := '322C36392C3131393833392C3130322C3131393839312C3130322C3131393934332C3130322C3131393939352C3130322C3132303034372C3130322C3132303039392C3130322C3132303135312C3130322C3132303230332C3130322C3132303235352C';
wwv_flow_imp.g_varchar2_table(3522) := '3130322C3132303330372C3130322C3132303335392C3130322C3132303431312C3130322C3132303436332C3130322C34333832392C3130322C34323930352C3130322C3338332C3130322C373833372C3130322C313431322C3130322C313139333135';
wwv_flow_imp.g_varchar2_table(3523) := '2C37302C383439372C37302C3131393831332C37302C3131393836352C37302C3131393931372C37302C3132303032312C37302C3132303037332C37302C3132303132352C37302C3132303137372C37302C3132303232392C37302C3132303238312C37';
wwv_flow_imp.g_varchar2_table(3524) := '302C3132303333332C37302C3132303338352C37302C3132303433372C37302C34323930342C37302C3938382C37302C3132303737382C37302C353535362C37302C34323230352C37302C37313837342C37302C37313834322C37302C36363138332C37';
wwv_flow_imp.g_varchar2_table(3525) := '302C36363231332C37302C36363835332C37302C36353335312C3130332C383435382C3130332C3131393834302C3130332C3131393839322C3130332C3131393934342C3130332C3132303034382C3130332C3132303130302C3130332C313230313532';
wwv_flow_imp.g_varchar2_table(3526) := '2C3130332C3132303230342C3130332C3132303235362C3130332C3132303330382C3130332C3132303336302C3130332C3132303431322C3130332C3132303436342C3130332C3630392C3130332C373535352C3130332C3339372C3130332C31343039';
wwv_flow_imp.g_varchar2_table(3527) := '2C3130332C3131393831342C37312C3131393836362C37312C3131393931382C37312C3131393937302C37312C3132303032322C37312C3132303037342C37312C3132303132362C37312C3132303137382C37312C3132303233302C37312C3132303238';
wwv_flow_imp.g_varchar2_table(3528) := '322C37312C3132303333342C37312C3132303338362C37312C3132303433382C37312C313239322C37312C353035362C37312C353130372C37312C34323139382C37312C36353335322C3130342C383436322C3130342C3131393834312C3130342C3131';
wwv_flow_imp.g_varchar2_table(3529) := '393934352C3130342C3131393939372C3130342C3132303034392C3130342C3132303130312C3130342C3132303135332C3130342C3132303230352C3130342C3132303235372C3130342C3132303330392C3130342C3132303336312C3130342C313230';
wwv_flow_imp.g_varchar2_table(3530) := '3431332C3130342C3132303436352C3130342C313231312C3130342C313339322C3130342C353035382C3130342C36353332302C37322C383435392C37322C383436302C37322C383436312C37322C3131393831352C37322C3131393836372C37322C31';
wwv_flow_imp.g_varchar2_table(3531) := '31393931392C37322C3132303032332C37322C3132303137392C37322C3132303233312C37322C3132303238332C37322C3132303333352C37322C3132303338372C37322C3132303433392C37322C3931392C37322C3132303439342C37322C31323035';
wwv_flow_imp.g_varchar2_table(3532) := '35322C37322C3132303631302C37322C3132303636382C37322C3132303732362C37322C31313430362C37322C353035312C37322C353530302C37322C34323231352C37322C36363235352C37322C3733312C3130352C393037352C3130352C36353335';
wwv_flow_imp.g_varchar2_table(3533) := '332C3130352C383536302C3130352C383530352C3130352C383532302C3130352C3131393834322C3130352C3131393839342C3130352C3131393934362C3130352C3131393939382C3130352C3132303035302C3130352C3132303130322C3130352C31';
wwv_flow_imp.g_varchar2_table(3534) := '32303135342C3130352C3132303230362C3130352C3132303235382C3130352C3132303331302C3130352C3132303336322C3130352C3132303431342C3130352C3132303436362C3130352C3132303438342C3130352C3631382C3130352C3631372C31';
wwv_flow_imp.g_varchar2_table(3535) := '30352C3935332C3130352C383132362C3130352C3839302C3130352C3132303532322C3130352C3132303538302C3130352C3132303633382C3130352C3132303639362C3130352C3132303735342C3130352C313131302C3130352C34323536372C3130';
wwv_flow_imp.g_varchar2_table(3536) := '352C313233312C3130352C34333839332C3130352C353032392C3130352C37313837352C3130352C36353335342C3130362C383532312C3130362C3131393834332C3130362C3131393839352C3130362C3131393934372C3130362C3131393939392C31';
wwv_flow_imp.g_varchar2_table(3537) := '30362C3132303035312C3130362C3132303130332C3130362C3132303135352C3130362C3132303230372C3130362C3132303235392C3130362C3132303331312C3130362C3132303336332C3130362C3132303431352C3130362C3132303436372C3130';
wwv_flow_imp.g_varchar2_table(3538) := '362C313031312C3130362C313131322C3130362C36353332322C37342C3131393831372C37342C3131393836392C37342C3131393932312C37342C3131393937332C37342C3132303032352C37342C3132303037372C37342C3132303132392C37342C31';
wwv_flow_imp.g_varchar2_table(3539) := '32303138312C37342C3132303233332C37342C3132303238352C37342C3132303333372C37342C3132303338392C37342C3132303434312C37342C34323933302C37342C3839352C37342C313033322C37342C353033352C37342C353236312C37342C34';
wwv_flow_imp.g_varchar2_table(3540) := '323230312C37342C3131393834342C3130372C3131393839362C3130372C3131393934382C3130372C3132303030302C3130372C3132303035322C3130372C3132303130342C3130372C3132303135362C3130372C3132303230382C3130372C31323032';
wwv_flow_imp.g_varchar2_table(3541) := '36302C3130372C3132303331322C3130372C3132303336342C3130372C3132303431362C3130372C3132303436382C3130372C383439302C37352C36353332332C37352C3131393831382C37352C3131393837302C37352C3131393932322C37352C3131';
wwv_flow_imp.g_varchar2_table(3542) := '393937342C37352C3132303032362C37352C3132303037382C37352C3132303133302C37352C3132303138322C37352C3132303233342C37352C3132303238362C37352C3132303333382C37352C3132303339302C37352C3132303434322C37352C3932';
wwv_flow_imp.g_varchar2_table(3543) := '322C37352C3132303439372C37352C3132303535352C37352C3132303631332C37352C3132303637312C37352C3132303732392C37352C31313431322C37352C353039342C37352C353834352C37352C34323139392C37352C36363834302C37352C3134';
wwv_flow_imp.g_varchar2_table(3544) := '37322C3130382C383733392C37332C393231332C37332C36353531322C37332C313633332C3130382C313737372C37332C36363333362C3130382C3132353132372C3130382C3132303738332C37332C3132303739332C37332C3132303830332C37332C';
wwv_flow_imp.g_varchar2_table(3545) := '3132303831332C37332C3132303832332C37332C3133303033332C37332C36353332312C37332C383534342C37332C383436342C37332C383436352C37332C3131393831362C37332C3131393836382C37332C3131393932302C37332C3132303032342C';
wwv_flow_imp.g_varchar2_table(3546) := '37332C3132303132382C37332C3132303138302C37332C3132303233322C37332C3132303238342C37332C3132303333362C37332C3132303338382C37332C3132303434302C37332C36353335362C3130382C383537322C37332C383436372C3130382C';
wwv_flow_imp.g_varchar2_table(3547) := '3131393834352C3130382C3131393839372C3130382C3131393934392C3130382C3132303030312C3130382C3132303035332C3130382C3132303130352C37332C3132303135372C37332C3132303230392C37332C3132303236312C37332C3132303331';
wwv_flow_imp.g_varchar2_table(3548) := '332C37332C3132303336352C37332C3132303431372C37332C3132303436392C37332C3434382C37332C3132303439362C37332C3132303535342C37332C3132303631322C37332C3132303637302C37332C3132303732382C37332C31313431302C3733';
wwv_flow_imp.g_varchar2_table(3549) := '2C313033302C37332C313231362C37332C313439332C3130382C313530332C3130382C313537352C3130382C3132363436342C3130382C3132363539322C3130382C36353136362C3130382C36353136352C3130382C313939342C3130382C3131353939';
wwv_flow_imp.g_varchar2_table(3550) := '2C37332C353832352C37332C34323232362C37332C39333939322C37332C36363138362C3132342C36363331332C3132342C3131393333382C37362C383535362C37362C383436362C37362C3131393831392C37362C3131393837312C37362C31313939';
wwv_flow_imp.g_varchar2_table(3551) := '32332C37362C3132303032372C37362C3132303037392C37362C3132303133312C37362C3132303138332C37362C3132303233352C37362C3132303238372C37362C3132303333392C37362C3132303339312C37362C3132303434332C37362C31313437';
wwv_flow_imp.g_varchar2_table(3552) := '322C37362C353038362C37362C353239302C37362C34323230392C37362C39333937342C37362C37313834332C37362C37313835382C37362C36363538372C37362C36363835342C37362C36353332352C37372C383535392C37372C383439392C37372C';
wwv_flow_imp.g_varchar2_table(3553) := '3131393832302C37372C3131393837322C37372C3131393932342C37372C3132303032382C37372C3132303038302C37372C3132303133322C37372C3132303138342C37372C3132303233362C37372C3132303238382C37372C3132303334302C37372C';
wwv_flow_imp.g_varchar2_table(3554) := '3132303339322C37372C3132303434342C37372C3932342C37372C3132303439392C37372C3132303535372C37372C3132303631352C37372C3132303637332C37372C3132303733312C37372C313031382C37372C31313431362C37372C353034372C37';
wwv_flow_imp.g_varchar2_table(3555) := '372C353631362C37372C353834362C37372C34323230372C37372C36363232342C37372C36363332312C37372C3131393834372C3131302C3131393839392C3131302C3131393935312C3131302C3132303030332C3131302C3132303035352C3131302C';
wwv_flow_imp.g_varchar2_table(3556) := '3132303130372C3131302C3132303135392C3131302C3132303231312C3131302C3132303236332C3131302C3132303331352C3131302C3132303336372C3131302C3132303431392C3131302C3132303437312C3131302C313430302C3131302C313430';
wwv_flow_imp.g_varchar2_table(3557) := '342C3131302C36353332362C37382C383436392C37382C3131393832312C37382C3131393837332C37382C3131393932352C37382C3131393937372C37382C3132303032392C37382C3132303038312C37382C3132303138352C37382C3132303233372C';
wwv_flow_imp.g_varchar2_table(3558) := '37382C3132303238392C37382C3132303334312C37382C3132303339332C37382C3132303434352C37382C3932352C37382C3132303530302C37382C3132303535382C37382C3132303631362C37382C3132303637342C37382C3132303733322C37382C';
wwv_flow_imp.g_varchar2_table(3559) := '31313431382C37382C34323230382C37382C36363833352C37382C333037342C3131312C333230322C3131312C333333302C3131312C333435382C3131312C323430362C3131312C323636322C3131312C323739302C3131312C333034362C3131312C33';
wwv_flow_imp.g_varchar2_table(3560) := '3137342C3131312C333330322C3131312C333433302C3131312C333636342C3131312C333739322C3131312C343136302C3131312C313633372C3131312C313738312C3131312C36353335392C3131312C383530302C3131312C3131393834382C313131';
wwv_flow_imp.g_varchar2_table(3561) := '2C3131393930302C3131312C3131393935322C3131312C3132303035362C3131312C3132303130382C3131312C3132303136302C3131312C3132303231322C3131312C3132303236342C3131312C3132303331362C3131312C3132303336382C3131312C';
wwv_flow_imp.g_varchar2_table(3562) := '3132303432302C3131312C3132303437322C3131312C373433392C3131312C373434312C3131312C34333833372C3131312C3935392C3131312C3132303532382C3131312C3132303538362C3131312C3132303634342C3131312C3132303730322C3131';
wwv_flow_imp.g_varchar2_table(3563) := '312C3132303736302C3131312C3936332C3131312C3132303533322C3131312C3132303539302C3131312C3132303634382C3131312C3132303730362C3131312C3132303736342C3131312C31313432332C3131312C343335312C3131312C313431332C';
wwv_flow_imp.g_varchar2_table(3564) := '3131312C313530352C3131312C313630372C3131312C3132363530302C3131312C3132363536342C3131312C3132363539362C3131312C36353235392C3131312C36353236302C3131312C36353235382C3131312C36353235372C3131312C313732362C';
wwv_flow_imp.g_varchar2_table(3565) := '3131312C36343432382C3131312C36343432392C3131312C36343432372C3131312C36343432362C3131312C313732392C3131312C36343432342C3131312C36343432352C3131312C36343432332C3131312C36343432322C3131312C313734392C3131';
wwv_flow_imp.g_varchar2_table(3566) := '312C333336302C3131312C343132352C3131312C36363739342C3131312C37313838302C3131312C37313839352C3131312C36363630342C3131312C313938342C37392C323533342C37392C323931382C37392C31323239352C37392C37303836342C37';
wwv_flow_imp.g_varchar2_table(3567) := '392C37313930342C37392C3132303738322C37392C3132303739322C37392C3132303830322C37392C3132303831322C37392C3132303832322C37392C3133303033322C37392C36353332372C37392C3131393832322C37392C3131393837342C37392C';
wwv_flow_imp.g_varchar2_table(3568) := '3131393932362C37392C3131393937382C37392C3132303033302C37392C3132303038322C37392C3132303133342C37392C3132303138362C37392C3132303233382C37392C3132303239302C37392C3132303334322C37392C3132303339342C37392C';
wwv_flow_imp.g_varchar2_table(3569) := '3132303434362C37392C3932372C37392C3132303530322C37392C3132303536302C37392C3132303631382C37392C3132303637362C37392C3132303733342C37392C31313432322C37392C313336352C37392C31313630342C37392C343831362C3739';
wwv_flow_imp.g_varchar2_table(3570) := '2C323834382C37392C36363735342C37392C34323232372C37392C37313836312C37392C36363139342C37392C36363231392C37392C36363536342C37392C36363833382C37392C393037362C3131322C36353336302C3131322C3131393834392C3131';
wwv_flow_imp.g_varchar2_table(3571) := '322C3131393930312C3131322C3131393935332C3131322C3132303030352C3131322C3132303035372C3131322C3132303130392C3131322C3132303136312C3131322C3132303231332C3131322C3132303236352C3131322C3132303331372C313132';
wwv_flow_imp.g_varchar2_table(3572) := '2C3132303336392C3131322C3132303432312C3131322C3132303437332C3131322C3936312C3131322C3132303533302C3131322C3132303534342C3131322C3132303538382C3131322C3132303630322C3131322C3132303634362C3131322C313230';
wwv_flow_imp.g_varchar2_table(3573) := '3636302C3131322C3132303730342C3131322C3132303731382C3131322C3132303736322C3131322C3132303737362C3131322C31313432372C3131322C36353332382C38302C383437332C38302C3131393832332C38302C3131393837352C38302C31';
wwv_flow_imp.g_varchar2_table(3574) := '31393932372C38302C3131393937392C38302C3132303033312C38302C3132303038332C38302C3132303138372C38302C3132303233392C38302C3132303239312C38302C3132303334332C38302C3132303339352C38302C3132303434372C38302C39';
wwv_flow_imp.g_varchar2_table(3575) := '32392C38302C3132303530342C38302C3132303536322C38302C3132303632302C38302C3132303637382C38302C3132303733362C38302C31313432362C38302C353039302C38302C353232392C38302C34323139332C38302C36363139372C38302C31';
wwv_flow_imp.g_varchar2_table(3576) := '31393835302C3131332C3131393930322C3131332C3131393935342C3131332C3132303030362C3131332C3132303035382C3131332C3132303131302C3131332C3132303136322C3131332C3132303231342C3131332C3132303236362C3131332C3132';
wwv_flow_imp.g_varchar2_table(3577) := '303331382C3131332C3132303337302C3131332C3132303432322C3131332C3132303437342C3131332C313330372C3131332C313337392C3131332C313338322C3131332C383437342C38312C3131393832342C38312C3131393837362C38312C313139';
wwv_flow_imp.g_varchar2_table(3578) := '3932382C38312C3131393938302C38312C3132303033322C38312C3132303038342C38312C3132303138382C38312C3132303234302C38312C3132303239322C38312C3132303334342C38312C3132303339362C38312C3132303434382C38312C313136';
wwv_flow_imp.g_varchar2_table(3579) := '30352C38312C3131393835312C3131342C3131393930332C3131342C3131393935352C3131342C3132303030372C3131342C3132303035392C3131342C3132303131312C3131342C3132303136332C3131342C3132303231352C3131342C313230323637';
wwv_flow_imp.g_varchar2_table(3580) := '2C3131342C3132303331392C3131342C3132303337312C3131342C3132303432332C3131342C3132303437352C3131342C34333834372C3131342C34333834382C3131342C373436322C3131342C31313339372C3131342C34333930352C3131342C3131';
wwv_flow_imp.g_varchar2_table(3581) := '393331382C38322C383437352C38322C383437362C38322C383437372C38322C3131393832352C38322C3131393837372C38322C3131393932392C38322C3132303033332C38322C3132303138392C38322C3132303234312C38322C3132303239332C38';
wwv_flow_imp.g_varchar2_table(3582) := '322C3132303334352C38322C3132303339372C38322C3132303434392C38322C3432322C38322C353032352C38322C353037342C38322C36363734302C38322C353531312C38322C34323231312C38322C39343030352C38322C36353336332C3131352C';
wwv_flow_imp.g_varchar2_table(3583) := '3131393835322C3131352C3131393930342C3131352C3131393935362C3131352C3132303030382C3131352C3132303036302C3131352C3132303131322C3131352C3132303136342C3131352C3132303231362C3131352C3132303236382C3131352C31';
wwv_flow_imp.g_varchar2_table(3584) := '32303332302C3131352C3132303337322C3131352C3132303432342C3131352C3132303437362C3131352C34323830312C3131352C3434352C3131352C313130392C3131352C34333934362C3131352C37313837332C3131352C36363633322C3131352C';
wwv_flow_imp.g_varchar2_table(3585) := '36353333312C38332C3131393832362C38332C3131393837382C38332C3131393933302C38332C3131393938322C38332C3132303033342C38332C3132303038362C38332C3132303133382C38332C3132303139302C38332C3132303234322C38332C31';
wwv_flow_imp.g_varchar2_table(3586) := '32303239342C38332C3132303334362C38332C3132303339382C38332C3132303435302C38332C313032392C38332C313335392C38332C353037372C38332C353038322C38332C34323231302C38332C39343031302C38332C36363139382C38332C3636';
wwv_flow_imp.g_varchar2_table(3587) := '3539322C38332C3131393835332C3131362C3131393930352C3131362C3131393935372C3131362C3132303030392C3131362C3132303036312C3131362C3132303131332C3131362C3132303136352C3131362C3132303231372C3131362C3132303236';
wwv_flow_imp.g_varchar2_table(3588) := '392C3131362C3132303332312C3131362C3132303337332C3131362C3132303432352C3131362C3132303437372C3131362C383836382C38342C31303230312C38342C3132383837322C38342C36353333322C38342C3131393832372C38342C31313938';
wwv_flow_imp.g_varchar2_table(3589) := '37392C38342C3131393933312C38342C3131393938332C38342C3132303033352C38342C3132303038372C38342C3132303133392C38342C3132303139312C38342C3132303234332C38342C3132303239352C38342C3132303334372C38342C31323033';
wwv_flow_imp.g_varchar2_table(3590) := '39392C38342C3132303435312C38342C3933322C38342C3132303530372C38342C3132303536352C38342C3132303632332C38342C3132303638312C38342C3132303733392C38342C31313433302C38342C353032362C38342C34323139362C38342C39';
wwv_flow_imp.g_varchar2_table(3591) := '333936322C38342C37313836382C38342C36363139392C38342C36363232352C38342C36363332352C38342C3131393835342C3131372C3131393930362C3131372C3131393935382C3131372C3132303031302C3131372C3132303036322C3131372C31';
wwv_flow_imp.g_varchar2_table(3592) := '32303131342C3131372C3132303136362C3131372C3132303231382C3131372C3132303237302C3131372C3132303332322C3131372C3132303337342C3131372C3132303432362C3131372C3132303437382C3131372C34323931312C3131372C373435';
wwv_flow_imp.g_varchar2_table(3593) := '322C3131372C34333835342C3131372C34333835382C3131372C3635312C3131372C3936352C3131372C3132303533342C3131372C3132303539322C3131372C3132303635302C3131372C3132303730382C3131372C3132303736362C3131372C313430';
wwv_flow_imp.g_varchar2_table(3594) := '352C3131372C36363830362C3131372C37313839362C3131372C383734362C38352C383839392C38352C3131393832382C38352C3131393838302C38352C3131393933322C38352C3131393938342C38352C3132303033362C38352C3132303038382C38';
wwv_flow_imp.g_varchar2_table(3595) := '352C3132303134302C38352C3132303139322C38352C3132303234342C38352C3132303239362C38352C3132303334382C38352C3132303430302C38352C3132303435322C38352C313335372C38352C343630382C38352C36363736362C38352C353139';
wwv_flow_imp.g_varchar2_table(3596) := '362C38352C34323232382C38352C39343031382C38352C37313836342C38352C383734342C3131382C383839372C3131382C36353336362C3131382C383536342C3131382C3131393835352C3131382C3131393930372C3131382C3131393935392C3131';
wwv_flow_imp.g_varchar2_table(3597) := '382C3132303031312C3131382C3132303036332C3131382C3132303131352C3131382C3132303136372C3131382C3132303231392C3131382C3132303237312C3131382C3132303332332C3131382C3132303337352C3131382C3132303432372C313138';
wwv_flow_imp.g_varchar2_table(3598) := '2C3132303437392C3131382C373435362C3131382C3935372C3131382C3132303532362C3131382C3132303538342C3131382C3132303634322C3131382C3132303730302C3131382C3132303735382C3131382C313134312C3131382C313439362C3131';
wwv_flow_imp.g_varchar2_table(3599) := '382C37313433302C3131382C34333934352C3131382C37313837322C3131382C3131393330392C38362C313633392C38362C313738332C38362C383534382C38362C3131393832392C38362C3131393838312C38362C3131393933332C38362C31313939';
wwv_flow_imp.g_varchar2_table(3600) := '38352C38362C3132303033372C38362C3132303038392C38362C3132303134312C38362C3132303139332C38362C3132303234352C38362C3132303239372C38362C3132303334392C38362C3132303430312C38362C3132303435332C38362C31313430';
wwv_flow_imp.g_varchar2_table(3601) := '2C38362C31313537362C38362C353038312C38362C353136372C38362C34323731392C38362C34323231342C38362C39333936302C38362C37313834302C38362C36363834352C38362C3632332C3131392C3131393835362C3131392C3131393930382C';
wwv_flow_imp.g_varchar2_table(3602) := '3131392C3131393936302C3131392C3132303031322C3131392C3132303036342C3131392C3132303131362C3131392C3132303136382C3131392C3132303232302C3131392C3132303237322C3131392C3132303332342C3131392C3132303337362C31';
wwv_flow_imp.g_varchar2_table(3603) := '31392C3132303432382C3131392C3132303438302C3131392C373435372C3131392C313132312C3131392C313330392C3131392C313337372C3131392C37313433342C3131392C37313433382C3131392C37313433392C3131392C34333930372C313139';
wwv_flow_imp.g_varchar2_table(3604) := '2C37313931392C38372C37313931302C38372C3131393833302C38372C3131393838322C38372C3131393933342C38372C3131393938362C38372C3132303033382C38372C3132303039302C38372C3132303134322C38372C3132303139342C38372C31';
wwv_flow_imp.g_varchar2_table(3605) := '32303234362C38372C3132303239382C38372C3132303335302C38372C3132303430322C38372C3132303435342C38372C313330382C38372C353034332C38372C353037362C38372C34323231382C38372C353734322C3132302C31303533392C313230';
wwv_flow_imp.g_varchar2_table(3606) := '2C31303534302C3132302C31303739392C3132302C36353336382C3132302C383536392C3132302C3131393835372C3132302C3131393930392C3132302C3131393936312C3132302C3132303031332C3132302C3132303036352C3132302C3132303131';
wwv_flow_imp.g_varchar2_table(3607) := '372C3132302C3132303136392C3132302C3132303232312C3132302C3132303237332C3132302C3132303332352C3132302C3132303337372C3132302C3132303432392C3132302C3132303438312C3132302C353434312C3132302C353530312C313230';
wwv_flow_imp.g_varchar2_table(3608) := '2C353734312C38382C393538372C38382C36363333382C38382C37313931362C38382C36353333362C38382C383535332C38382C3131393833312C38382C3131393838332C38382C3131393933352C38382C3131393938372C38382C3132303033392C38';
wwv_flow_imp.g_varchar2_table(3609) := '382C3132303039312C38382C3132303134332C38382C3132303139352C38382C3132303234372C38382C3132303239392C38382C3132303335312C38382C3132303430332C38382C3132303435352C38382C34323933312C38382C3933352C38382C3132';
wwv_flow_imp.g_varchar2_table(3610) := '303531302C38382C3132303536382C38382C3132303632362C38382C3132303638342C38382C3132303734322C38382C31313433362C38382C31313631332C38382C353831352C38382C34323231392C38382C36363139322C38382C36363232382C3838';
wwv_flow_imp.g_varchar2_table(3611) := '2C36363332372C38382C36363835352C38382C3631312C3132312C373536342C3132312C36353336392C3132312C3131393835382C3132312C3131393931302C3132312C3131393936322C3132312C3132303031342C3132312C3132303036362C313231';
wwv_flow_imp.g_varchar2_table(3612) := '2C3132303131382C3132312C3132303137302C3132312C3132303232322C3132312C3132303237342C3132312C3132303332362C3132312C3132303337382C3132312C3132303433302C3132312C3132303438322C3132312C3635352C3132312C373933';
wwv_flow_imp.g_varchar2_table(3613) := '352C3132312C34333836362C3132312C3934372C3132312C383530392C3132312C3132303531362C3132312C3132303537342C3132312C3132303633322C3132312C3132303639302C3132312C3132303734382C3132312C313139392C3132312C343332';
wwv_flow_imp.g_varchar2_table(3614) := '372C3132312C37313930302C3132312C36353333372C38392C3131393833322C38392C3131393838342C38392C3131393933362C38392C3131393938382C38392C3132303034302C38392C3132303039322C38392C3132303134342C38392C3132303139';
wwv_flow_imp.g_varchar2_table(3615) := '362C38392C3132303234382C38392C3132303330302C38392C3132303335322C38392C3132303430342C38392C3132303435362C38392C3933332C38392C3937382C38392C3132303530382C38392C3132303536362C38392C3132303632342C38392C31';
wwv_flow_imp.g_varchar2_table(3616) := '32303638322C38392C3132303734302C38392C31313433322C38392C313139382C38392C353033332C38392C353035332C38392C34323232302C38392C39343031392C38392C37313834342C38392C36363232362C38392C3131393835392C3132322C31';
wwv_flow_imp.g_varchar2_table(3617) := '31393931312C3132322C3131393936332C3132322C3132303031352C3132322C3132303036372C3132322C3132303131392C3132322C3132303137312C3132322C3132303232332C3132322C3132303237352C3132322C3132303332372C3132322C3132';
wwv_flow_imp.g_varchar2_table(3618) := '303337392C3132322C3132303433312C3132322C3132303438332C3132322C373435382C3132322C34333932332C3132322C37313837362C3132322C36363239332C39302C37313930392C39302C36353333382C39302C383438342C39302C383438382C';
wwv_flow_imp.g_varchar2_table(3619) := '39302C3131393833332C39302C3131393838352C39302C3131393933372C39302C3131393938392C39302C3132303034312C39302C3132303139372C39302C3132303234392C39302C3132303330312C39302C3132303335332C39302C3132303430352C';
wwv_flow_imp.g_varchar2_table(3620) := '39302C3132303435372C39302C3931382C39302C3132303439332C39302C3132303535312C39302C3132303630392C39302C3132303636372C39302C3132303732352C39302C353035392C39302C34323230342C39302C37313834392C39302C36353238';
wwv_flow_imp.g_varchar2_table(3621) := '322C33342C36353238342C33362C36353238352C33372C36353238362C33382C36353239302C34322C36353239312C34332C36353239342C34362C36353239352C34372C36353239362C34382C36353239372C34392C36353239382C35302C3635323939';
wwv_flow_imp.g_varchar2_table(3622) := '2C35312C36353330302C35322C36353330312C35332C36353330322C35342C36353330332C35352C36353330342C35362C36353330352C35372C36353330382C36302C36353330392C36312C36353331302C36322C36353331322C36342C36353331362C';
wwv_flow_imp.g_varchar2_table(3623) := '36382C36353331382C37302C36353331392C37312C36353332342C37362C36353332392C38312C36353333302C38322C36353333332C38352C36353333342C38362C36353333352C38372C36353334332C39352C36353334362C39382C36353334382C31';
wwv_flow_imp.g_varchar2_table(3624) := '30302C36353335302C3130322C36353335352C3130372C36353335372C3130392C36353335382C3131302C36353336312C3131332C36353336322C3131342C36353336342C3131362C36353336352C3131372C36353336372C3131392C36353337302C31';
wwv_flow_imp.g_varchar2_table(3625) := '32322C36353337312C3132332C36353337332C3132352C3131393834362C3130395D2C225F64656661756C74223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C3832';
wwv_flow_imp.g_varchar2_table(3626) := '31372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C31';
wwv_flow_imp.g_varchar2_table(3627) := '30312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131';
wwv_flow_imp.g_varchar2_table(3628) := '342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C363533';
wwv_flow_imp.g_varchar2_table(3629) := '31312C36335D2C226373223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037';
wwv_flow_imp.g_varchar2_table(3630) := '322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C3737';
wwv_flow_imp.g_varchar2_table(3631) := '2C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C3635323833';
wwv_flow_imp.g_varchar2_table(3632) := '2C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226465223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C';
wwv_flow_imp.g_varchar2_table(3633) := '383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034';
wwv_flow_imp.g_varchar2_table(3634) := '352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C31303538';
wwv_flow_imp.g_varchar2_table(3635) := '2C38342C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226573223A5B38';
wwv_flow_imp.g_varchar2_table(3636) := '3231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C31';
wwv_flow_imp.g_varchar2_table(3637) := '3034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C3130';
wwv_flow_imp.g_varchar2_table(3638) := '38382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C3431';
wwv_flow_imp.g_varchar2_table(3639) := '2C36353239322C34342C36353330372C35392C36353331312C36335D2C226672223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383234352C39362C31323439342C34372C313034372C35312C31303733';
wwv_flow_imp.g_varchar2_table(3640) := '2C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C';
wwv_flow_imp.g_varchar2_table(3641) := '313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132';
wwv_flow_imp.g_varchar2_table(3642) := '312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C226974223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330';
wwv_flow_imp.g_varchar2_table(3643) := '362C35382C36353238312C33332C383231362C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39';
wwv_flow_imp.g_varchar2_table(3644) := '392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C313132';
wwv_flow_imp.g_varchar2_table(3645) := '2C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C3635323932';
wwv_flow_imp.g_varchar2_table(3646) := '2C34342C36353330372C35392C36353331312C36335D2C226A61223A5B383231312C34352C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C313034372C35312C313037332C35';
wwv_flow_imp.g_varchar2_table(3647) := '342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C3130';
wwv_flow_imp.g_varchar2_table(3648) := '35322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C';
wwv_flow_imp.g_varchar2_table(3649) := '313035392C38392C36353238332C33352C36353239322C34342C36353330372C35395D2C226B6F223A5B383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34';
wwv_flow_imp.g_varchar2_table(3650) := '372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C31';
wwv_flow_imp.g_varchar2_table(3651) := '3035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C31';
wwv_flow_imp.g_varchar2_table(3652) := '3036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C22706C223A5B36353337342C3132362C3635333036';
wwv_flow_imp.g_varchar2_table(3653) := '2C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C3636';
wwv_flow_imp.g_varchar2_table(3654) := '2C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C31';
wwv_flow_imp.g_varchar2_table(3655) := '3038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34';
wwv_flow_imp.g_varchar2_table(3656) := '312C36353239322C34342C36353330372C35392C36353331312C36335D2C2270742D4252223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C3132';
wwv_flow_imp.g_varchar2_table(3657) := '3439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C';
wwv_flow_imp.g_varchar2_table(3658) := '3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C';
wwv_flow_imp.g_varchar2_table(3659) := '3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227170732D706C6F63223A5B3136302C';
wwv_flow_imp.g_varchar2_table(3660) := '33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C';
wwv_flow_imp.g_varchar2_table(3661) := '39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C31';
wwv_flow_imp.g_varchar2_table(3662) := '3038362C3131312C313035342C37392C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238332C3335';
wwv_flow_imp.g_varchar2_table(3663) := '2C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227275223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383231362C39362C383231372C39362C383234';
wwv_flow_imp.g_varchar2_table(3664) := '352C39362C3138302C39362C31323439342C34372C3330352C3130352C3932312C37332C313030392C3131322C3231352C3132302C36353238332C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C3635';
wwv_flow_imp.g_varchar2_table(3665) := '3331312C36335D2C227472223A5B3136302C33322C383231312C34352C36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C3138302C39362C31323439342C34372C313034372C35312C313037332C35342C313037';
wwv_flow_imp.g_varchar2_table(3666) := '322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C313035302C37352C3932312C37332C313035322C37372C313038362C3131';
wwv_flow_imp.g_varchar2_table(3667) := '312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C3635323833';
wwv_flow_imp.g_varchar2_table(3668) := '2C33352C36353238382C34302C36353238392C34312C36353239322C34342C36353330372C35392C36353331312C36335D2C227A682D68616E73223A5B36353337342C3132362C36353330362C35382C36353238312C33332C383234352C39362C313830';
wwv_flow_imp.g_varchar2_table(3669) := '2C39362C31323439342C34372C313034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37';
wwv_flow_imp.g_varchar2_table(3670) := '322C3330352C3130352C313035302C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C313230';
wwv_flow_imp.g_varchar2_table(3671) := '2C313039332C3132302C313036312C38382C313039312C3132312C313035392C38392C36353238382C34302C36353238392C34315D2C227A682D68616E74223A5B383231312C34352C36353337342C3132362C3138302C39362C31323439342C34372C31';
wwv_flow_imp.g_varchar2_table(3672) := '3034372C35312C313037332C35342C313037322C39372C313034302C36352C313036382C39382C313034322C36362C313038392C39392C313035372C36372C313037372C3130312C313034352C36392C313035332C37322C3330352C3130352C31303530';
wwv_flow_imp.g_varchar2_table(3673) := '2C37352C3932312C37332C313035322C37372C313038362C3131312C313035342C37392C313030392C3131322C313038382C3131322C313035362C38302C313037352C3131342C313035382C38342C3231352C3132302C313039332C3132302C31303631';
wwv_flow_imp.g_varchar2_table(3674) := '2C38382C313039312C3132312C313035392C38392C36353238332C33352C36353330372C35395D7D272929292C5A692E63616368653D6E657720636C6173737B636F6E7374727563746F7228652C74297B746869732E6C61737443616368653D766F6964';
wwv_flow_imp.g_varchar2_table(3675) := '20302C746869732E6C6173744172674B65793D766F696420302C2266756E6374696F6E223D3D747970656F6620653F28746869732E5F666E3D652C746869732E5F636F6D707574654B65793D7469293A28746869732E5F666E3D742C746869732E5F636F';
wwv_flow_imp.g_varchar2_table(3676) := '6D707574654B65793D652E67657443616368654B6579297D6765742865297B636F6E737420743D746869732E5F636F6D707574654B65792865293B72657475726E20746869732E6C6173744172674B6579213D3D74262628746869732E6C617374417267';
wwv_flow_imp.g_varchar2_table(3677) := '4B65793D742C746869732E6C61737443616368653D746869732E5F666E286529292C746869732E6C61737443616368657D7D287B67657443616368654B65793A4A534F4E2E737472696E676966797D2C28653D3E7B66756E6374696F6E20742865297B63';
wwv_flow_imp.g_varchar2_table(3678) := '6F6E737420743D6E6577204D61703B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B3D3229742E73657428655B6E5D2C655B6E2B315D293B72657475726E20747D66756E6374696F6E206E28652C74297B69662821652972657475726E20';
wwv_flow_imp.g_varchar2_table(3679) := '743B636F6E7374206E3D6E6577204D61703B666F7228636F6E73745B692C6F5D6F66206529742E68617328692926266E2E73657428692C6F293B72657475726E206E7D636F6E737420693D6F692E616D626967756F757343686172616374657244617461';
wwv_flow_imp.g_varchar2_table(3680) := '2E76616C75653B6C6574206F2C733D652E66696C7465722828653D3E21652E7374617274735769746828225F222926266520696E206929293B303D3D3D732E6C656E677468262628733D5B225F64656661756C74225D293B666F7228636F6E7374206520';
wwv_flow_imp.g_varchar2_table(3681) := '6F662073296F3D6E286F2C7428695B655D29293B636F6E737420723D66756E6374696F6E28652C74297B636F6E7374206E3D6E6577204D61702865293B666F7228636F6E73745B652C695D6F662074296E2E73657428652C69293B72657475726E206E7D';
wwv_flow_imp.g_varchar2_table(3682) := '287428692E5F636F6D6D6F6E292C6F293B72657475726E206E6577206F692872297D29292C5A692E5F6C6F63616C65733D6E6577206969282828293D3E4F626A6563742E6B657973286F692E616D626967756F7573436861726163746572446174612E76';
wwv_flow_imp.g_varchar2_table(3683) := '616C7565292E66696C7465722828653D3E21652E7374617274735769746828225F2229292929293B636C6173732058697B737461746963206765745261774461746128297B72657475726E204A534F4E2E706172736528225B392C31302C31312C31322C';
wwv_flow_imp.g_varchar2_table(3684) := '31332C33322C3132372C3136302C3137332C3834372C313536342C343434372C343434382C363036382C363036392C363135352C363135362C363135372C363135382C373335352C373335362C383139322C383139332C383139342C383139352C383139';
wwv_flow_imp.g_varchar2_table(3685) := '362C383139372C383139382C383139392C383230302C383230312C383230322C383230332C383230342C383230352C383230362C383230372C383233342C383233352C383233362C383233372C383233382C383233392C383238372C383238382C383238';
wwv_flow_imp.g_varchar2_table(3686) := '392C383239302C383239312C383239322C383239332C383239342C383239352C383239362C383239372C383239382C383239392C383330302C383330312C383330322C383330332C31303234302C31323238382C31323634342C36353032342C36353032';
wwv_flow_imp.g_varchar2_table(3687) := '352C36353032362C36353032372C36353032382C36353032392C36353033302C36353033312C36353033322C36353033332C36353033342C36353033352C36353033362C36353033372C36353033382C36353033392C36353237392C36353434302C3635';
wwv_flow_imp.g_varchar2_table(3688) := '3532302C36353532312C36353532322C36353532332C36353532342C36353532352C36353532362C36353532372C36353532382C36353533322C37383834342C3131393135352C3131393135362C3131393135372C3131393135382C3131393135392C31';
wwv_flow_imp.g_varchar2_table(3689) := '31393136302C3131393136312C3131393136322C3931373530342C3931373530352C3931373530362C3931373530372C3931373530382C3931373530392C3931373531302C3931373531312C3931373531322C3931373531332C3931373531342C393137';
wwv_flow_imp.g_varchar2_table(3690) := '3531352C3931373531362C3931373531372C3931373531382C3931373531392C3931373532302C3931373532312C3931373532322C3931373532332C3931373532342C3931373532352C3931373532362C3931373532372C3931373532382C3931373532';
wwv_flow_imp.g_varchar2_table(3691) := '392C3931373533302C3931373533312C3931373533322C3931373533332C3931373533342C3931373533352C3931373533362C3931373533372C3931373533382C3931373533392C3931373534302C3931373534312C3931373534322C3931373534332C';
wwv_flow_imp.g_varchar2_table(3692) := '3931373534342C3931373534352C3931373534362C3931373534372C3931373534382C3931373534392C3931373535302C3931373535312C3931373535322C3931373535332C3931373535342C3931373535352C3931373535362C3931373535372C3931';
wwv_flow_imp.g_varchar2_table(3693) := '373535382C3931373535392C3931373536302C3931373536312C3931373536322C3931373536332C3931373536342C3931373536352C3931373536362C3931373536372C3931373536382C3931373536392C3931373537302C3931373537312C39313735';
wwv_flow_imp.g_varchar2_table(3694) := '37322C3931373537332C3931373537342C3931373537352C3931373537362C3931373537372C3931373537382C3931373537392C3931373538302C3931373538312C3931373538322C3931373538332C3931373538342C3931373538352C393137353836';
wwv_flow_imp.g_varchar2_table(3695) := '2C3931373538372C3931373538382C3931373538392C3931373539302C3931373539312C3931373539322C3931373539332C3931373539342C3931373539352C3931373539362C3931373539372C3931373539382C3931373539392C3931373630302C39';
wwv_flow_imp.g_varchar2_table(3696) := '31373630312C3931373630322C3931373630332C3931373630342C3931373630352C3931373630362C3931373630372C3931373630382C3931373630392C3931373631302C3931373631312C3931373631322C3931373631332C3931373631342C393137';
wwv_flow_imp.g_varchar2_table(3697) := '3631352C3931373631362C3931373631372C3931373631382C3931373631392C3931373632302C3931373632312C3931373632322C3931373632332C3931373632342C3931373632352C3931373632362C3931373632372C3931373632382C3931373632';
wwv_flow_imp.g_varchar2_table(3698) := '392C3931373633302C3931373633312C3931373736302C3931373736312C3931373736322C3931373736332C3931373736342C3931373736352C3931373736362C3931373736372C3931373736382C3931373736392C3931373737302C3931373737312C';
wwv_flow_imp.g_varchar2_table(3699) := '3931373737322C3931373737332C3931373737342C3931373737352C3931373737362C3931373737372C3931373737382C3931373737392C3931373738302C3931373738312C3931373738322C3931373738332C3931373738342C3931373738352C3931';
wwv_flow_imp.g_varchar2_table(3700) := '373738362C3931373738372C3931373738382C3931373738392C3931373739302C3931373739312C3931373739322C3931373739332C3931373739342C3931373739352C3931373739362C3931373739372C3931373739382C3931373739392C39313738';
wwv_flow_imp.g_varchar2_table(3701) := '30302C3931373830312C3931373830322C3931373830332C3931373830342C3931373830352C3931373830362C3931373830372C3931373830382C3931373830392C3931373831302C3931373831312C3931373831322C3931373831332C393137383134';
wwv_flow_imp.g_varchar2_table(3702) := '2C3931373831352C3931373831362C3931373831372C3931373831382C3931373831392C3931373832302C3931373832312C3931373832322C3931373832332C3931373832342C3931373832352C3931373832362C3931373832372C3931373832382C39';
wwv_flow_imp.g_varchar2_table(3703) := '31373832392C3931373833302C3931373833312C3931373833322C3931373833332C3931373833342C3931373833352C3931373833362C3931373833372C3931373833382C3931373833392C3931373834302C3931373834312C3931373834322C393137';
wwv_flow_imp.g_varchar2_table(3704) := '3834332C3931373834342C3931373834352C3931373834362C3931373834372C3931373834382C3931373834392C3931373835302C3931373835312C3931373835322C3931373835332C3931373835342C3931373835352C3931373835362C3931373835';
wwv_flow_imp.g_varchar2_table(3705) := '372C3931373835382C3931373835392C3931373836302C3931373836312C3931373836322C3931373836332C3931373836342C3931373836352C3931373836362C3931373836372C3931373836382C3931373836392C3931373837302C3931373837312C';
wwv_flow_imp.g_varchar2_table(3706) := '3931373837322C3931373837332C3931373837342C3931373837352C3931373837362C3931373837372C3931373837382C3931373837392C3931373838302C3931373838312C3931373838322C3931373838332C3931373838342C3931373838352C3931';
wwv_flow_imp.g_varchar2_table(3707) := '373838362C3931373838372C3931373838382C3931373838392C3931373839302C3931373839312C3931373839322C3931373839332C3931373839342C3931373839352C3931373839362C3931373839372C3931373839382C3931373839392C39313739';
wwv_flow_imp.g_varchar2_table(3708) := '30302C3931373930312C3931373930322C3931373930332C3931373930342C3931373930352C3931373930362C3931373930372C3931373930382C3931373930392C3931373931302C3931373931312C3931373931322C3931373931332C393137393134';
wwv_flow_imp.g_varchar2_table(3709) := '2C3931373931352C3931373931362C3931373931372C3931373931382C3931373931392C3931373932302C3931373932312C3931373932322C3931373932332C3931373932342C3931373932352C3931373932362C3931373932372C3931373932382C39';
wwv_flow_imp.g_varchar2_table(3710) := '31373932392C3931373933302C3931373933312C3931373933322C3931373933332C3931373933342C3931373933352C3931373933362C3931373933372C3931373933382C3931373933392C3931373934302C3931373934312C3931373934322C393137';
wwv_flow_imp.g_varchar2_table(3711) := '3934332C3931373934342C3931373934352C3931373934362C3931373934372C3931373934382C3931373934392C3931373935302C3931373935312C3931373935322C3931373935332C3931373935342C3931373935352C3931373935362C3931373935';
wwv_flow_imp.g_varchar2_table(3712) := '372C3931373935382C3931373935392C3931373936302C3931373936312C3931373936322C3931373936332C3931373936342C3931373936352C3931373936362C3931373936372C3931373936382C3931373936392C3931373937302C3931373937312C';
wwv_flow_imp.g_varchar2_table(3713) := '3931373937322C3931373937332C3931373937342C3931373937352C3931373937362C3931373937372C3931373937382C3931373937392C3931373938302C3931373938312C3931373938322C3931373938332C3931373938342C3931373938352C3931';
wwv_flow_imp.g_varchar2_table(3714) := '373938362C3931373938372C3931373938382C3931373938392C3931373939302C3931373939312C3931373939322C3931373939332C3931373939342C3931373939352C3931373939362C3931373939372C3931373939382C3931373939395D22297D73';
wwv_flow_imp.g_varchar2_table(3715) := '7461746963206765744461746128297B72657475726E20746869732E5F646174617C7C28746869732E5F646174613D6E6577205365742858692E67657452617744617461282929292C746869732E5F646174617D737461746963206973496E7669736962';
wwv_flow_imp.g_varchar2_table(3716) := '6C654368617261637465722865297B72657475726E2058692E6765744461746128292E6861732865297D7374617469632067657420636F6465506F696E747328297B72657475726E2058692E6765744461746128297D7D6C6574204A693B58692E5F6461';
wwv_flow_imp.g_varchar2_table(3717) := '74613D766F696420303B636F6E737420656F3D676C6F62616C546869732E7673636F64653B696628766F69642030213D3D656F2626766F69642030213D3D656F2E70726F63657373297B636F6E737420653D656F2E70726F636573733B4A693D7B676574';
wwv_flow_imp.g_varchar2_table(3718) := '20706C6174666F726D28297B72657475726E20652E706C6174666F726D7D2C676574206172636828297B72657475726E20652E617263687D2C67657420656E7628297B72657475726E20652E656E767D2C6377643A28293D3E652E63776428297D7D656C';
wwv_flow_imp.g_varchar2_table(3719) := '7365204A693D22756E646566696E656422213D747970656F662070726F636573733F7B67657420706C6174666F726D28297B72657475726E2070726F636573732E706C6174666F726D7D2C676574206172636828297B72657475726E2070726F63657373';
wwv_flow_imp.g_varchar2_table(3720) := '2E617263687D2C67657420656E7628297B72657475726E2070726F636573732E656E767D2C6377643A28293D3E70726F636573732E656E762E5653434F44455F4357447C7C70726F636573732E63776428297D3A7B67657420706C6174666F726D28297B';
wwv_flow_imp.g_varchar2_table(3721) := '72657475726E206A3F2277696E3332223A713F2264617277696E223A226C696E7578227D2C676574206172636828297B7D2C67657420656E7628297B72657475726E7B7D7D2C6377643A28293D3E222F227D3B636F6E737420746F3D4A692E6377642C6E';
wwv_flow_imp.g_varchar2_table(3722) := '6F3D4A692E656E762C696F3D4A692E706C6174666F726D2C6F6F3D34362C736F3D34372C726F3D39322C616F3D35383B636C617373206C6F20657874656E6473204572726F727B636F6E7374727563746F7228652C742C6E297B6C657420693B22737472';
wwv_flow_imp.g_varchar2_table(3723) := '696E67223D3D747970656F6620742626303D3D3D742E696E6465784F6628226E6F742022293F28693D226D757374206E6F74206265222C743D742E7265706C616365282F5E6E6F74202F2C222229293A693D226D757374206265223B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(3724) := '2D31213D3D652E696E6465784F6628222E22293F2270726F7065727479223A22617267756D656E74223B6C657420733D605468652022247B657D2220247B6F7D20247B697D206F66207479706520247B747D603B732B3D222E2052656365697665642074';
wwv_flow_imp.g_varchar2_table(3725) := '79706520222B747970656F66206E2C73757065722873292C746869732E636F64653D224552525F494E56414C49445F4152475F54595045227D7D66756E6374696F6E20636F28652C74297B69662822737472696E6722213D747970656F66206529746872';
wwv_flow_imp.g_varchar2_table(3726) := '6F77206E6577206C6F28742C22737472696E67222C65297D636F6E737420686F3D2277696E3332223D3D3D696F3B66756E6374696F6E20756F2865297B72657475726E20653D3D3D736F7C7C653D3D3D726F7D66756E6374696F6E20706F2865297B7265';
wwv_flow_imp.g_varchar2_table(3727) := '7475726E20653D3D3D736F7D66756E6374696F6E20676F2865297B72657475726E20653E3D36352626653C3D39307C7C653E3D39372626653C3D3132327D66756E6374696F6E206D6F28652C742C6E2C69297B6C6574206F3D22222C733D302C723D2D31';
wwv_flow_imp.g_varchar2_table(3728) := '2C613D302C6C3D303B666F72286C657420633D303B633C3D652E6C656E6774683B2B2B63297B696628633C652E6C656E677468296C3D652E63686172436F646541742863293B656C73657B69662869286C2929627265616B3B6C3D736F7D69662869286C';
wwv_flow_imp.g_varchar2_table(3729) := '29297B696628723D3D3D632D317C7C313D3D3D61293B656C736520696628323D3D3D61297B6966286F2E6C656E6774683C327C7C32213D3D737C7C6F2E63686172436F64654174286F2E6C656E6774682D3129213D3D6F6F7C7C6F2E63686172436F6465';
wwv_flow_imp.g_varchar2_table(3730) := '4174286F2E6C656E6774682D3229213D3D6F6F297B6966286F2E6C656E6774683E32297B636F6E737420653D6F2E6C617374496E6465784F66286E293B2D313D3D3D653F286F3D22222C733D30293A286F3D6F2E736C69636528302C65292C733D6F2E6C';
wwv_flow_imp.g_varchar2_table(3731) := '656E6774682D312D6F2E6C617374496E6465784F66286E29292C723D632C613D303B636F6E74696E75657D69662830213D3D6F2E6C656E677468297B6F3D22222C733D302C723D632C613D303B636F6E74696E75657D7D742626286F2B3D6F2E6C656E67';
wwv_flow_imp.g_varchar2_table(3732) := '74683E303F60247B6E7D2E2E603A222E2E222C733D32297D656C7365206F2E6C656E6774683E303F6F2B3D60247B6E7D247B652E736C69636528722B312C63297D603A6F3D652E736C69636528722B312C63292C733D632D722D313B723D632C613D307D';
wwv_flow_imp.g_varchar2_table(3733) := '656C7365206C3D3D3D6F6F26262D31213D3D613F2B2B613A613D2D317D72657475726E206F7D66756E6374696F6E20666F28652C74297B2166756E6374696F6E2865297B6966286E756C6C3D3D3D657C7C226F626A65637422213D747970656F66206529';
wwv_flow_imp.g_varchar2_table(3734) := '7468726F77206E6577206C6F2822706174684F626A656374222C224F626A656374222C65297D2874293B636F6E7374206E3D742E6469727C7C742E726F6F742C693D742E626173657C7C60247B742E6E616D657C7C22227D247B742E6578747C7C22227D';
wwv_flow_imp.g_varchar2_table(3735) := '603B72657475726E206E3F6E3D3D3D742E726F6F743F60247B6E7D247B697D603A60247B6E7D247B657D247B697D603A697D636F6E737420766F3D7B7265736F6C7665282E2E2E65297B6C657420743D22222C6E3D22222C693D21313B666F72286C6574';
wwv_flow_imp.g_varchar2_table(3736) := '206F3D652E6C656E6774682D313B6F3E3D2D313B6F2D2D297B6C657420733B6966286F3E3D30297B696628733D655B6F5D2C636F28732C227061746822292C303D3D3D732E6C656E67746829636F6E74696E75657D656C736520303D3D3D742E6C656E67';
wwv_flow_imp.g_varchar2_table(3737) := '74683F733D746F28293A28733D6E6F5B603D247B747D605D7C7C746F28292C28766F696420303D3D3D737C7C732E736C69636528302C32292E746F4C6F776572436173652829213D3D742E746F4C6F7765724361736528292626732E63686172436F6465';
wwv_flow_imp.g_varchar2_table(3738) := '41742832293D3D3D726F29262628733D60247B747D5C5C6029293B636F6E737420723D732E6C656E6774683B6C657420613D302C6C3D22222C633D21313B636F6E737420643D732E63686172436F646541742830293B696628313D3D3D7229756F286429';
wwv_flow_imp.g_varchar2_table(3739) := '262628613D312C633D2130293B656C736520696628756F28642929696628633D21302C756F28732E63686172436F6465417428312929297B6C657420653D322C743D653B666F72283B653C72262621756F28732E63686172436F64654174286529293B29';
wwv_flow_imp.g_varchar2_table(3740) := '652B2B3B696628653C72262665213D3D74297B636F6E7374206E3D732E736C69636528742C65293B666F7228743D653B653C722626756F28732E63686172436F64654174286529293B29652B2B3B696628653C72262665213D3D74297B666F7228743D65';
wwv_flow_imp.g_varchar2_table(3741) := '3B653C72262621756F28732E63686172436F64654174286529293B29652B2B3B65213D3D722626653D3D3D747C7C286C3D605C5C5C5C247B6E7D5C5C247B732E736C69636528742C65297D602C613D65297D7D7D656C736520613D313B656C736520676F';
wwv_flow_imp.g_varchar2_table(3742) := '2864292626732E63686172436F646541742831293D3D3D616F2626286C3D732E736C69636528302C32292C613D322C723E322626756F28732E63686172436F6465417428322929262628633D21302C613D3329293B6966286C2E6C656E6774683E302969';
wwv_flow_imp.g_varchar2_table(3743) := '6628742E6C656E6774683E30297B6966286C2E746F4C6F776572436173652829213D3D742E746F4C6F77657243617365282929636F6E74696E75657D656C736520743D6C3B69662869297B696628742E6C656E6774683E3029627265616B7D656C736520';
wwv_flow_imp.g_varchar2_table(3744) := '6966286E3D60247B732E736C6963652861297D5C5C247B6E7D602C693D632C632626742E6C656E6774683E3029627265616B7D72657475726E206E3D6D6F286E2C21692C225C5C222C756F292C693F60247B747D5C5C247B6E7D603A60247B747D247B6E';
wwv_flow_imp.g_varchar2_table(3745) := '7D607C7C222E227D2C6E6F726D616C697A652865297B636F28652C227061746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E222E223B6C6574206E2C693D302C6F3D21313B636F6E737420733D652E63686172';
wwv_flow_imp.g_varchar2_table(3746) := '436F646541742830293B696628313D3D3D742972657475726E20706F2873293F225C5C223A653B696628756F287329296966286F3D21302C756F28652E63686172436F6465417428312929297B6C6574206F3D322C733D6F3B666F72283B6F3C74262621';
wwv_flow_imp.g_varchar2_table(3747) := '756F28652E63686172436F64654174286F29293B296F2B2B3B6966286F3C7426266F213D3D73297B636F6E737420723D652E736C69636528732C6F293B666F7228733D6F3B6F3C742626756F28652E63686172436F64654174286F29293B296F2B2B3B69';
wwv_flow_imp.g_varchar2_table(3748) := '66286F3C7426266F213D3D73297B666F7228733D6F3B6F3C74262621756F28652E63686172436F64654174286F29293B296F2B2B3B6966286F3D3D3D742972657475726E605C5C5C5C247B727D5C5C247B652E736C6963652873297D5C5C603B6F213D3D';
wwv_flow_imp.g_varchar2_table(3749) := '732626286E3D605C5C5C5C247B727D5C5C247B652E736C69636528732C6F297D602C693D6F297D7D7D656C736520693D313B656C736520676F2873292626652E63686172436F646541742831293D3D3D616F2626286E3D652E736C69636528302C32292C';
wwv_flow_imp.g_varchar2_table(3750) := '693D322C743E322626756F28652E63686172436F64654174283229292626286F3D21302C693D3329293B6C657420723D693C743F6D6F28652E736C6963652869292C216F2C225C5C222C756F293A22223B72657475726E2030213D3D722E6C656E677468';
wwv_flow_imp.g_varchar2_table(3751) := '7C7C6F7C7C28723D222E22292C722E6C656E6774683E302626756F28652E63686172436F6465417428742D312929262628722B3D225C5C22292C766F696420303D3D3D6E3F6F3F605C5C247B727D603A723A6F3F60247B6E7D5C5C247B727D603A60247B';
wwv_flow_imp.g_varchar2_table(3752) := '6E7D247B727D607D2C69734162736F6C7574652865297B636F28652C227061746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E21313B636F6E7374206E3D652E63686172436F646541742830293B7265747572';
wwv_flow_imp.g_varchar2_table(3753) := '6E20756F286E297C7C743E322626676F286E292626652E63686172436F646541742831293D3D3D616F2626756F28652E63686172436F64654174283229297D2C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E22';
wwv_flow_imp.g_varchar2_table(3754) := '3B6C657420742C6E3B666F72286C657420693D303B693C652E6C656E6774683B2B2B69297B636F6E7374206F3D655B695D3B636F286F2C227061746822292C6F2E6C656E6774683E30262628766F696420303D3D3D743F743D6E3D6F3A742B3D605C5C24';
wwv_flow_imp.g_varchar2_table(3755) := '7B6F7D60297D696628766F696420303D3D3D742972657475726E222E223B6C657420693D21302C6F3D303B69662822737472696E67223D3D747970656F66206E2626756F286E2E63686172436F6465417428302929297B2B2B6F3B636F6E737420653D6E';
wwv_flow_imp.g_varchar2_table(3756) := '2E6C656E6774683B653E312626756F286E2E63686172436F64654174283129292626282B2B6F2C653E32262628756F286E2E63686172436F64654174283229293F2B2B6F3A693D213129297D69662869297B666F72283B6F3C742E6C656E677468262675';
wwv_flow_imp.g_varchar2_table(3757) := '6F28742E63686172436F64654174286F29293B296F2B2B3B6F3E3D32262628743D605C5C247B742E736C696365286F297D60297D72657475726E20766F2E6E6F726D616C697A652874297D2C72656C617469766528652C74297B696628636F28652C2266';
wwv_flow_imp.g_varchar2_table(3758) := '726F6D22292C636F28742C22746F22292C653D3D3D742972657475726E22223B636F6E7374206E3D766F2E7265736F6C76652865292C693D766F2E7265736F6C76652874293B6966286E3D3D3D692972657475726E22223B69662828653D6E2E746F4C6F';
wwv_flow_imp.g_varchar2_table(3759) := '776572436173652829293D3D3D28743D692E746F4C6F776572436173652829292972657475726E22223B6C6574206F3D303B666F72283B6F3C652E6C656E6774682626652E63686172436F64654174286F293D3D3D726F3B296F2B2B3B6C657420733D65';
wwv_flow_imp.g_varchar2_table(3760) := '2E6C656E6774683B666F72283B732D313E6F2626652E63686172436F6465417428732D31293D3D3D726F3B29732D2D3B636F6E737420723D732D6F3B6C657420613D303B666F72283B613C742E6C656E6774682626742E63686172436F64654174286129';
wwv_flow_imp.g_varchar2_table(3761) := '3D3D3D726F3B29612B2B3B6C6574206C3D742E6C656E6774683B666F72283B6C2D313E612626742E63686172436F64654174286C2D31293D3D3D726F3B296C2D2D3B636F6E737420633D6C2D612C643D723C633F723A633B6C657420683D2D312C753D30';
wwv_flow_imp.g_varchar2_table(3762) := '3B666F72283B753C643B752B2B297B636F6E7374206E3D652E63686172436F64654174286F2B75293B6966286E213D3D742E63686172436F6465417428612B752929627265616B3B6E3D3D3D726F262628683D75297D69662875213D3D64297B6966282D';
wwv_flow_imp.g_varchar2_table(3763) := '313D3D3D682972657475726E20697D656C73657B696628633E64297B696628742E63686172436F6465417428612B75293D3D3D726F2972657475726E20692E736C69636528612B752B31293B696628323D3D3D752972657475726E20692E736C69636528';
wwv_flow_imp.g_varchar2_table(3764) := '612B75297D723E64262628652E63686172436F64654174286F2B75293D3D3D726F3F683D753A323D3D3D75262628683D3329292C2D313D3D3D68262628683D30297D6C657420703D22223B666F7228753D6F2B682B313B753C3D733B2B2B752975213D3D';
wwv_flow_imp.g_varchar2_table(3765) := '732626652E63686172436F64654174287529213D3D726F7C7C28702B3D303D3D3D702E6C656E6774683F222E2E223A225C5C2E2E22293B72657475726E20612B3D682C702E6C656E6774683E303F60247B707D247B692E736C69636528612C6C297D603A';
wwv_flow_imp.g_varchar2_table(3766) := '28692E63686172436F646541742861293D3D3D726F26262B2B612C692E736C69636528612C6C29297D2C746F4E616D65737061636564506174682865297B69662822737472696E6722213D747970656F6620657C7C303D3D3D652E6C656E677468297265';
wwv_flow_imp.g_varchar2_table(3767) := '7475726E20653B636F6E737420743D766F2E7265736F6C76652865293B696628742E6C656E6774683C3D322972657475726E20653B696628742E63686172436F646541742830293D3D3D726F297B696628742E63686172436F646541742831293D3D3D72';
wwv_flow_imp.g_varchar2_table(3768) := '6F297B636F6E737420653D742E63686172436F646541742832293B6966283633213D3D65262665213D3D6F6F2972657475726E605C5C5C5C3F5C5C554E435C5C247B742E736C6963652832297D607D7D656C736520696628676F28742E63686172436F64';
wwv_flow_imp.g_varchar2_table(3769) := '654174283029292626742E63686172436F646541742831293D3D3D616F2626742E63686172436F646541742832293D3D3D726F2972657475726E605C5C5C5C3F5C5C247B747D603B72657475726E20657D2C6469726E616D652865297B636F28652C2270';
wwv_flow_imp.g_varchar2_table(3770) := '61746822293B636F6E737420743D652E6C656E6774683B696628303D3D3D742972657475726E222E223B6C6574206E3D2D312C693D303B636F6E7374206F3D652E63686172436F646541742830293B696628313D3D3D742972657475726E20756F286F29';
wwv_flow_imp.g_varchar2_table(3771) := '3F653A222E223B696628756F286F29297B6966286E3D693D312C756F28652E63686172436F6465417428312929297B6C6574206F3D322C733D6F3B666F72283B6F3C74262621756F28652E63686172436F64654174286F29293B296F2B2B3B6966286F3C';
wwv_flow_imp.g_varchar2_table(3772) := '7426266F213D3D73297B666F7228733D6F3B6F3C742626756F28652E63686172436F64654174286F29293B296F2B2B3B6966286F3C7426266F213D3D73297B666F7228733D6F3B6F3C74262621756F28652E63686172436F64654174286F29293B296F2B';
wwv_flow_imp.g_varchar2_table(3773) := '2B3B6966286F3D3D3D742972657475726E20653B6F213D3D732626286E3D693D6F2B31297D7D7D7D656C736520676F286F292626652E63686172436F646541742831293D3D3D616F2626286E3D743E322626756F28652E63686172436F64654174283229';
wwv_flow_imp.g_varchar2_table(3774) := '293F333A322C693D6E293B6C657420733D2D312C723D21303B666F72286C6574206E3D742D313B6E3E3D693B2D2D6E29696628756F28652E63686172436F64654174286E2929297B6966282172297B733D6E3B627265616B7D7D656C736520723D21313B';
wwv_flow_imp.g_varchar2_table(3775) := '6966282D313D3D3D73297B6966282D313D3D3D6E2972657475726E222E223B733D6E7D72657475726E20652E736C69636528302C73297D2C626173656E616D6528652C74297B766F69642030213D3D742626636F28742C2265787422292C636F28652C22';
wwv_flow_imp.g_varchar2_table(3776) := '7061746822293B6C6574206E2C693D302C6F3D2D312C733D21303B696628652E6C656E6774683E3D322626676F28652E63686172436F64654174283029292626652E63686172436F646541742831293D3D3D616F262628693D32292C766F69642030213D';
wwv_flow_imp.g_varchar2_table(3777) := '3D742626742E6C656E6774683E302626742E6C656E6774683C3D652E6C656E677468297B696628743D3D3D652972657475726E22223B6C657420723D742E6C656E6774682D312C613D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D693B2D2D';
wwv_flow_imp.g_varchar2_table(3778) := '6E297B636F6E7374206C3D652E63686172436F64654174286E293B696628756F286C29297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D61262628733D21312C613D6E2B31292C723E3D302626286C3D3D3D742E6368617243';
wwv_flow_imp.g_varchar2_table(3779) := '6F646541742872293F2D313D3D2D2D722626286F3D6E293A28723D2D312C6F3D6129297D72657475726E20693D3D3D6F3F6F3D613A2D313D3D3D6F2626286F3D652E6C656E677468292C652E736C69636528692C6F297D666F72286E3D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(3780) := '682D313B6E3E3D693B2D2D6E29696628756F28652E63686172436F64654174286E2929297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D6F262628733D21312C6F3D6E2B31293B72657475726E2D313D3D3D6F3F22223A652E';
wwv_flow_imp.g_varchar2_table(3781) := '736C69636528692C6F297D2C6578746E616D652865297B636F28652C227061746822293B6C657420743D302C6E3D2D312C693D302C6F3D2D312C733D21302C723D303B652E6C656E6774683E3D322626652E63686172436F646541742831293D3D3D616F';
wwv_flow_imp.g_varchar2_table(3782) := '2626676F28652E63686172436F6465417428302929262628743D693D32293B666F72286C657420613D652E6C656E6774682D313B613E3D743B2D2D61297B636F6E737420743D652E63686172436F646541742861293B696628756F287429297B69662821';
wwv_flow_imp.g_varchar2_table(3783) := '73297B693D612B313B627265616B7D7D656C73652D313D3D3D6F262628733D21312C6F3D612B31292C743D3D3D6F6F3F2D313D3D3D6E3F6E3D613A31213D3D72262628723D31293A2D31213D3D6E262628723D2D31297D72657475726E2D313D3D3D6E7C';
wwv_flow_imp.g_varchar2_table(3784) := '7C2D313D3D3D6F7C7C303D3D3D727C7C313D3D3D7226266E3D3D3D6F2D3126266E3D3D3D692B313F22223A652E736C696365286E2C6F297D2C666F726D61743A666F2E62696E64286E756C6C2C225C5C22292C70617273652865297B636F28652C227061';
wwv_flow_imp.g_varchar2_table(3785) := '746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E6C656E6774683B6C65742069';
wwv_flow_imp.g_varchar2_table(3786) := '3D302C6F3D652E63686172436F646541742830293B696628313D3D3D6E2972657475726E20756F286F293F28742E726F6F743D742E6469723D652C74293A28742E626173653D742E6E616D653D652C74293B696628756F286F29297B696628693D312C75';
wwv_flow_imp.g_varchar2_table(3787) := '6F28652E63686172436F6465417428312929297B6C657420743D322C6F3D743B666F72283B743C6E262621756F28652E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D6F297B666F72286F3D743B743C6E2626756F2865';
wwv_flow_imp.g_varchar2_table(3788) := '2E63686172436F64654174287429293B29742B2B3B696628743C6E262674213D3D6F297B666F72286F3D743B743C6E262621756F28652E63686172436F64654174287429293B29742B2B3B743D3D3D6E3F693D743A74213D3D6F262628693D742B31297D';
wwv_flow_imp.g_varchar2_table(3789) := '7D7D7D656C736520696628676F286F292626652E63686172436F646541742831293D3D3D616F297B6966286E3C3D322972657475726E20742E726F6F743D742E6469723D652C743B696628693D322C756F28652E63686172436F6465417428322929297B';
wwv_flow_imp.g_varchar2_table(3790) := '696628333D3D3D6E2972657475726E20742E726F6F743D742E6469723D652C743B693D337D7D693E30262628742E726F6F743D652E736C69636528302C6929293B6C657420733D2D312C723D692C613D2D312C6C3D21302C633D652E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(3791) := '2C643D303B666F72283B633E3D693B2D2D63296966286F3D652E63686172436F646541742863292C756F286F29297B696628216C297B723D632B313B627265616B7D7D656C73652D313D3D3D612626286C3D21312C613D632B31292C6F3D3D3D6F6F3F2D';
wwv_flow_imp.g_varchar2_table(3792) := '313D3D3D733F733D633A31213D3D64262628643D31293A2D31213D3D73262628643D2D31293B72657475726E2D31213D3D612626282D313D3D3D737C7C303D3D3D647C7C313D3D3D642626733D3D3D612D312626733D3D3D722B313F742E626173653D74';
wwv_flow_imp.g_varchar2_table(3793) := '2E6E616D653D652E736C69636528722C61293A28742E6E616D653D652E736C69636528722C73292C742E626173653D652E736C69636528722C61292C742E6578743D652E736C69636528732C612929292C742E6469723D723E30262672213D3D693F652E';
wwv_flow_imp.g_varchar2_table(3794) := '736C69636528302C722D31293A742E726F6F742C747D2C7365703A225C5C222C64656C696D697465723A223B222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D2C626F3D2828293D3E7B696628686F297B636F6E737420653D2F5C5C2F673B72';
wwv_flow_imp.g_varchar2_table(3795) := '657475726E28293D3E7B636F6E737420743D746F28292E7265706C61636528652C222F22293B72657475726E20742E736C69636528742E696E6465784F6628222F2229297D7D72657475726E28293D3E746F28297D2928292C5F6F3D7B7265736F6C7665';
wwv_flow_imp.g_varchar2_table(3796) := '282E2E2E65297B6C657420743D22222C6E3D21313B666F72286C657420693D652E6C656E6774682D313B693E3D2D312626216E3B692D2D297B636F6E7374206F3D693E3D303F655B695D3A626F28293B636F286F2C227061746822292C30213D3D6F2E6C';
wwv_flow_imp.g_varchar2_table(3797) := '656E677468262628743D60247B6F7D2F247B747D602C6E3D6F2E63686172436F646541742830293D3D3D736F297D72657475726E20743D6D6F28742C216E2C222F222C706F292C6E3F602F247B747D603A742E6C656E6774683E303F743A222E227D2C6E';
wwv_flow_imp.g_varchar2_table(3798) := '6F726D616C697A652865297B696628636F28652C227061746822292C303D3D3D652E6C656E6774682972657475726E222E223B636F6E737420743D652E63686172436F646541742830293D3D3D736F2C6E3D652E63686172436F6465417428652E6C656E';
wwv_flow_imp.g_varchar2_table(3799) := '6774682D31293D3D3D736F3B72657475726E20303D3D3D28653D6D6F28652C21742C222F222C706F29292E6C656E6774683F743F222F223A6E3F222E2F223A222E223A286E262628652B3D222F22292C743F602F247B657D603A65297D2C69734162736F';
wwv_flow_imp.g_varchar2_table(3800) := '6C7574653A653D3E28636F28652C227061746822292C652E6C656E6774683E302626652E63686172436F646541742830293D3D3D736F292C6A6F696E282E2E2E65297B696628303D3D3D652E6C656E6774682972657475726E222E223B6C657420743B66';
wwv_flow_imp.g_varchar2_table(3801) := '6F72286C6574206E3D303B6E3C652E6C656E6774683B2B2B6E297B636F6E737420693D655B6E5D3B636F28692C227061746822292C692E6C656E6774683E30262628766F696420303D3D3D743F743D693A742B3D602F247B697D60297D72657475726E20';
wwv_flow_imp.g_varchar2_table(3802) := '766F696420303D3D3D743F222E223A5F6F2E6E6F726D616C697A652874297D2C72656C617469766528652C74297B696628636F28652C2266726F6D22292C636F28742C22746F22292C653D3D3D742972657475726E22223B69662828653D5F6F2E726573';
wwv_flow_imp.g_varchar2_table(3803) := '6F6C7665286529293D3D3D28743D5F6F2E7265736F6C7665287429292972657475726E22223B636F6E7374206E3D652E6C656E6774682C693D6E2D312C6F3D742E6C656E6774682D312C733D693C6F3F693A6F3B6C657420723D2D312C613D303B666F72';
wwv_flow_imp.g_varchar2_table(3804) := '283B613C733B612B2B297B636F6E7374206E3D652E63686172436F6465417428312B61293B6966286E213D3D742E63686172436F6465417428312B612929627265616B3B6E3D3D3D736F262628723D61297D696628613D3D3D73296966286F3E73297B69';
wwv_flow_imp.g_varchar2_table(3805) := '6628742E63686172436F6465417428312B61293D3D3D736F2972657475726E20742E736C69636528312B612B31293B696628303D3D3D612972657475726E20742E736C69636528312B61297D656C736520693E73262628652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(3806) := '312B61293D3D3D736F3F723D613A303D3D3D61262628723D3029293B6C6574206C3D22223B666F7228613D312B722B313B613C3D6E3B2B2B612961213D3D6E2626652E63686172436F64654174286129213D3D736F7C7C286C2B3D303D3D3D6C2E6C656E';
wwv_flow_imp.g_varchar2_table(3807) := '6774683F222E2E223A222F2E2E22293B72657475726E60247B6C7D247B742E736C69636528312B72297D607D2C746F4E616D65737061636564506174683A653D3E652C6469726E616D652865297B696628636F28652C227061746822292C303D3D3D652E';
wwv_flow_imp.g_varchar2_table(3808) := '6C656E6774682972657475726E222E223B636F6E737420743D652E63686172436F646541742830293D3D3D736F3B6C6574206E3D2D312C693D21303B666F72286C657420743D652E6C656E6774682D313B743E3D313B2D2D7429696628652E6368617243';
wwv_flow_imp.g_varchar2_table(3809) := '6F646541742874293D3D3D736F297B6966282169297B6E3D743B627265616B7D7D656C736520693D21313B72657475726E2D313D3D3D6E3F743F222F223A222E223A742626313D3D3D6E3F222F2F223A652E736C69636528302C6E297D2C626173656E61';
wwv_flow_imp.g_varchar2_table(3810) := '6D6528652C74297B766F69642030213D3D742626636F28742C2265787422292C636F28652C227061746822293B6C6574206E2C693D302C6F3D2D312C733D21303B696628766F69642030213D3D742626742E6C656E6774683E302626742E6C656E677468';
wwv_flow_imp.g_varchar2_table(3811) := '3C3D652E6C656E677468297B696628743D3D3D652972657475726E22223B6C657420723D742E6C656E6774682D312C613D2D313B666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E297B636F6E7374206C3D652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(3812) := '6E293B6966286C3D3D3D736F297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D61262628733D21312C613D6E2B31292C723E3D302626286C3D3D3D742E63686172436F646541742872293F2D313D3D2D2D722626286F3D6E29';
wwv_flow_imp.g_varchar2_table(3813) := '3A28723D2D312C6F3D6129297D72657475726E20693D3D3D6F3F6F3D613A2D313D3D3D6F2626286F3D652E6C656E677468292C652E736C69636528692C6F297D666F72286E3D652E6C656E6774682D313B6E3E3D303B2D2D6E29696628652E6368617243';
wwv_flow_imp.g_varchar2_table(3814) := '6F64654174286E293D3D3D736F297B6966282173297B693D6E2B313B627265616B7D7D656C73652D313D3D3D6F262628733D21312C6F3D6E2B31293B72657475726E2D313D3D3D6F3F22223A652E736C69636528692C6F297D2C6578746E616D65286529';
wwv_flow_imp.g_varchar2_table(3815) := '7B636F28652C227061746822293B6C657420743D2D312C6E3D302C693D2D312C6F3D21302C733D303B666F72286C657420723D652E6C656E6774682D313B723E3D303B2D2D72297B636F6E737420613D652E63686172436F646541742872293B69662861';
wwv_flow_imp.g_varchar2_table(3816) := '213D3D736F292D313D3D3D692626286F3D21312C693D722B31292C613D3D3D6F6F3F2D313D3D3D743F743D723A31213D3D73262628733D31293A2D31213D3D74262628733D2D31293B656C736520696628216F297B6E3D722B313B627265616B7D7D7265';
wwv_flow_imp.g_varchar2_table(3817) := '7475726E2D313D3D3D747C7C2D313D3D3D697C7C303D3D3D737C7C313D3D3D732626743D3D3D692D312626743D3D3D6E2B313F22223A652E736C69636528742C69297D2C666F726D61743A666F2E62696E64286E756C6C2C222F22292C70617273652865';
wwv_flow_imp.g_varchar2_table(3818) := '297B636F28652C227061746822293B636F6E737420743D7B726F6F743A22222C6469723A22222C626173653A22222C6578743A22222C6E616D653A22227D3B696628303D3D3D652E6C656E6774682972657475726E20743B636F6E7374206E3D652E6368';
wwv_flow_imp.g_varchar2_table(3819) := '6172436F646541742830293D3D3D736F3B6C657420693B6E3F28742E726F6F743D222F222C693D31293A693D303B6C6574206F3D2D312C733D302C723D2D312C613D21302C6C3D652E6C656E6774682D312C633D303B666F72283B6C3E3D693B2D2D6C29';
wwv_flow_imp.g_varchar2_table(3820) := '7B636F6E737420743D652E63686172436F64654174286C293B69662874213D3D736F292D313D3D3D72262628613D21312C723D6C2B31292C743D3D3D6F6F3F2D313D3D3D6F3F6F3D6C3A31213D3D63262628633D31293A2D31213D3D6F262628633D2D31';
wwv_flow_imp.g_varchar2_table(3821) := '293B656C7365206966282161297B733D6C2B313B627265616B7D7D6966282D31213D3D72297B636F6E737420693D303D3D3D7326266E3F313A733B2D313D3D3D6F7C7C303D3D3D637C7C313D3D3D6326266F3D3D3D722D3126266F3D3D3D732B313F742E';
wwv_flow_imp.g_varchar2_table(3822) := '626173653D742E6E616D653D652E736C69636528692C72293A28742E6E616D653D652E736C69636528692C6F292C742E626173653D652E736C69636528692C72292C742E6578743D652E736C696365286F2C7229297D72657475726E20733E303F742E64';
wwv_flow_imp.g_varchar2_table(3823) := '69723D652E736C69636528302C732D31293A6E262628742E6469723D222F22292C747D2C7365703A222F222C64656C696D697465723A223A222C77696E33323A6E756C6C2C706F7369783A6E756C6C7D3B5F6F2E77696E33323D766F2E77696E33323D76';
wwv_flow_imp.g_varchar2_table(3824) := '6F2C5F6F2E706F7369783D766F2E706F7369783D5F6F3B636F6E737420796F3D686F3F766F2E6E6F726D616C697A653A5F6F2E6E6F726D616C697A652C776F3D686F3F766F2E7265736F6C76653A5F6F2E7265736F6C76652C436F3D686F3F766F2E7265';
wwv_flow_imp.g_varchar2_table(3825) := '6C61746976653A5F6F2E72656C61746976652C536F3D686F3F766F2E6469726E616D653A5F6F2E6469726E616D652C786F3D686F3F766F2E626173656E616D653A5F6F2E626173656E616D652C6B6F3D686F3F766F2E6578746E616D653A5F6F2E657874';
wwv_flow_imp.g_varchar2_table(3826) := '6E616D652C456F3D686F3F766F2E7365703A5F6F2E7365702C4C6F3D2F5E5C775B5C775C642B2E2D5D2A242F2C446F3D2F5E5C2F2F2C546F3D2F5E5C2F5C2F2F2C496F3D22222C4D6F3D222F222C416F3D2F5E28285B5E3A2F3F235D2B3F293A293F285C';
wwv_flow_imp.g_varchar2_table(3827) := '2F5C2F285B5E2F3F235D2A29293F285B5E3F235D2A29285C3F285B5E235D2A29293F2823282E2A29293F2F3B636C617373204E6F7B7374617469632069735572692865297B72657475726E206520696E7374616E63656F66204E6F7C7C21216526262273';
wwv_flow_imp.g_varchar2_table(3828) := '7472696E67223D3D747970656F6620652E617574686F72697479262622737472696E67223D3D747970656F6620652E667261676D656E74262622737472696E67223D3D747970656F6620652E70617468262622737472696E67223D3D747970656F662065';
wwv_flow_imp.g_varchar2_table(3829) := '2E7175657279262622737472696E67223D3D747970656F6620652E736368656D65262622737472696E67223D3D747970656F6620652E66735061746826262266756E6374696F6E223D3D747970656F6620652E7769746826262266756E6374696F6E223D';
wwv_flow_imp.g_varchar2_table(3830) := '3D747970656F6620652E746F537472696E677D636F6E7374727563746F7228652C742C6E2C692C6F2C733D2131297B226F626A656374223D3D747970656F6620653F28746869732E736368656D653D652E736368656D657C7C496F2C746869732E617574';
wwv_flow_imp.g_varchar2_table(3831) := '686F726974793D652E617574686F726974797C7C496F2C746869732E706174683D652E706174687C7C496F2C746869732E71756572793D652E71756572797C7C496F2C746869732E667261676D656E743D652E667261676D656E747C7C496F293A287468';
wwv_flow_imp.g_varchar2_table(3832) := '69732E736368656D653D66756E6374696F6E28652C74297B72657475726E20657C7C743F653A2266696C65227D28652C73292C746869732E617574686F726974793D747C7C496F2C746869732E706174683D66756E6374696F6E28652C74297B73776974';
wwv_flow_imp.g_varchar2_table(3833) := '63682865297B63617365226874747073223A636173652268747470223A636173652266696C65223A743F745B305D213D3D4D6F262628743D4D6F2B74293A743D4D6F7D72657475726E20747D28746869732E736368656D652C6E7C7C496F292C74686973';
wwv_flow_imp.g_varchar2_table(3834) := '2E71756572793D697C7C496F2C746869732E667261676D656E743D6F7C7C496F2C66756E6374696F6E28652C74297B69662821652E736368656D65262674297468726F77206E6577204572726F7228605B5572694572726F725D3A20536368656D652069';
wwv_flow_imp.g_varchar2_table(3835) := '73206D697373696E673A207B736368656D653A2022222C20617574686F726974793A2022247B652E617574686F726974797D222C20706174683A2022247B652E706174687D222C2071756572793A2022247B652E71756572797D222C20667261676D656E';
wwv_flow_imp.g_varchar2_table(3836) := '743A2022247B652E667261676D656E747D227D60293B696628652E736368656D652626214C6F2E7465737428652E736368656D6529297468726F77206E6577204572726F7228225B5572694572726F725D3A20536368656D6520636F6E7461696E732069';
wwv_flow_imp.g_varchar2_table(3837) := '6C6C6567616C20636861726163746572732E22293B696628652E7061746829696628652E617574686F72697479297B69662821446F2E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A2049662061';
wwv_flow_imp.g_varchar2_table(3838) := '2055524920636F6E7461696E7320616E20617574686F7269747920636F6D706F6E656E742C207468656E20746865207061746820636F6D706F6E656E74206D7573742065697468657220626520656D707479206F7220626567696E207769746820612073';
wwv_flow_imp.g_varchar2_table(3839) := '6C6173682028222F22292063686172616374657227297D656C736520696628546F2E7465737428652E7061746829297468726F77206E6577204572726F7228275B5572694572726F725D3A20496620612055524920646F6573206E6F7420636F6E746169';
wwv_flow_imp.g_varchar2_table(3840) := '6E20616E20617574686F7269747920636F6D706F6E656E742C207468656E2074686520706174682063616E6E6F7420626567696E20776974682074776F20736C61736820636861726163746572732028222F2F222927297D28746869732C7329297D6765';
wwv_flow_imp.g_varchar2_table(3841) := '742066735061746828297B72657475726E20566F28746869732C2131297D776974682865297B69662821652972657475726E20746869733B6C65747B736368656D653A742C617574686F726974793A6E2C706174683A692C71756572793A6F2C66726167';
wwv_flow_imp.g_varchar2_table(3842) := '6D656E743A737D3D653B72657475726E20766F696420303D3D3D743F743D746869732E736368656D653A6E756C6C3D3D3D74262628743D496F292C766F696420303D3D3D6E3F6E3D746869732E617574686F726974793A6E756C6C3D3D3D6E2626286E3D';
wwv_flow_imp.g_varchar2_table(3843) := '496F292C766F696420303D3D3D693F693D746869732E706174683A6E756C6C3D3D3D69262628693D496F292C766F696420303D3D3D6F3F6F3D746869732E71756572793A6E756C6C3D3D3D6F2626286F3D496F292C766F696420303D3D3D733F733D7468';
wwv_flow_imp.g_varchar2_table(3844) := '69732E667261676D656E743A6E756C6C3D3D3D73262628733D496F292C743D3D3D746869732E736368656D6526266E3D3D3D746869732E617574686F726974792626693D3D3D746869732E7061746826266F3D3D3D746869732E71756572792626733D3D';
wwv_flow_imp.g_varchar2_table(3845) := '3D746869732E667261676D656E743F746869733A6E6577204F6F28742C6E2C692C6F2C73297D73746174696320706172736528652C743D2131297B636F6E7374206E3D416F2E657865632865293B72657475726E206E3F6E6577204F6F286E5B325D7C7C';
wwv_flow_imp.g_varchar2_table(3846) := '496F2C6A6F286E5B345D7C7C496F292C6A6F286E5B355D7C7C496F292C6A6F286E5B375D7C7C496F292C6A6F286E5B395D7C7C496F292C74293A6E6577204F6F28496F2C496F2C496F2C496F2C496F297D7374617469632066696C652865297B6C657420';
wwv_flow_imp.g_varchar2_table(3847) := '743D496F3B6966286A262628653D652E7265706C616365282F5C5C2F672C4D6F29292C655B305D3D3D3D4D6F2626655B315D3D3D3D4D6F297B636F6E7374206E3D652E696E6465784F66284D6F2C32293B2D313D3D3D6E3F28743D652E73756273747269';
wwv_flow_imp.g_varchar2_table(3848) := '6E672832292C653D4D6F293A28743D652E737562737472696E6728322C6E292C653D652E737562737472696E67286E297C7C4D6F297D72657475726E206E6577204F6F282266696C65222C742C652C496F2C496F297D7374617469632066726F6D28652C';
wwv_flow_imp.g_varchar2_table(3849) := '74297B72657475726E206E6577204F6F28652E736368656D652C652E617574686F726974792C652E706174682C652E71756572792C652E667261676D656E742C74297D737461746963206A6F696E5061746828652C2E2E2E74297B69662821652E706174';
wwv_flow_imp.g_varchar2_table(3850) := '68297468726F77206E6577204572726F7228225B5572694572726F725D3A2063616E6E6F742063616C6C206A6F696E50617468206F6E2055524920776974686F7574207061746822293B6C6574206E3B72657475726E206E3D6A26262266696C65223D3D';
wwv_flow_imp.g_varchar2_table(3851) := '3D652E736368656D653F4E6F2E66696C6528766F2E6A6F696E28566F28652C2130292C2E2E2E7429292E706174683A5F6F2E6A6F696E28652E706174682C2E2E2E74292C652E77697468287B706174683A6E7D297D746F537472696E6728653D2131297B';
wwv_flow_imp.g_varchar2_table(3852) := '72657475726E207A6F28746869732C65297D746F4A534F4E28297B72657475726E20746869737D737461746963207265766976652865297B76617220742C6E3B69662865297B6966286520696E7374616E63656F66204E6F2972657475726E20653B7B63';
wwv_flow_imp.g_varchar2_table(3853) := '6F6E737420693D6E6577204F6F2865293B72657475726E20692E5F666F726D61747465643D6E756C6C213D3D28743D652E65787465726E616C292626766F69642030213D3D743F743A6E756C6C2C692E5F6673506174683D652E5F7365703D3D3D506F26';
wwv_flow_imp.g_varchar2_table(3854) := '266E756C6C213D3D286E3D652E667350617468292626766F69642030213D3D6E3F6E3A6E756C6C2C697D7D72657475726E20657D7D636F6E737420506F3D6A3F313A766F696420303B636C617373204F6F20657874656E6473204E6F7B636F6E73747275';
wwv_flow_imp.g_varchar2_table(3855) := '63746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F666F726D61747465643D6E756C6C2C746869732E5F6673506174683D6E756C6C7D6765742066735061746828297B72657475726E20746869732E5F6673506174687C7C';
wwv_flow_imp.g_varchar2_table(3856) := '28746869732E5F6673506174683D566F28746869732C213129292C746869732E5F6673506174687D746F537472696E6728653D2131297B72657475726E20653F7A6F28746869732C2130293A28746869732E5F666F726D61747465647C7C28746869732E';
wwv_flow_imp.g_varchar2_table(3857) := '5F666F726D61747465643D7A6F28746869732C213129292C746869732E5F666F726D6174746564297D746F4A534F4E28297B636F6E737420653D7B246D69643A317D3B72657475726E20746869732E5F667350617468262628652E6673506174683D7468';
wwv_flow_imp.g_varchar2_table(3858) := '69732E5F6673506174682C652E5F7365703D506F292C746869732E5F666F726D6174746564262628652E65787465726E616C3D746869732E5F666F726D6174746564292C746869732E70617468262628652E706174683D746869732E70617468292C7468';
wwv_flow_imp.g_varchar2_table(3859) := '69732E736368656D65262628652E736368656D653D746869732E736368656D65292C746869732E617574686F72697479262628652E617574686F726974793D746869732E617574686F72697479292C746869732E7175657279262628652E71756572793D';
wwv_flow_imp.g_varchar2_table(3860) := '746869732E7175657279292C746869732E667261676D656E74262628652E667261676D656E743D746869732E667261676D656E74292C657D7D636F6E737420526F3D7B35383A22253341222C34373A22253246222C36333A22253346222C33353A222532';
wwv_flow_imp.g_varchar2_table(3861) := '33222C39313A22253542222C39333A22253544222C36343A22253430222C33333A22253231222C33363A22253234222C33383A22253236222C33393A22253237222C34303A22253238222C34313A22253239222C34323A22253241222C34333A22253242';
wwv_flow_imp.g_varchar2_table(3862) := '222C34343A22253243222C35393A22253342222C36313A22253344222C33323A22253230227D3B66756E6374696F6E20466F28652C742C6E297B6C657420692C6F3D2D313B666F72286C657420733D303B733C652E6C656E6774683B732B2B297B636F6E';
wwv_flow_imp.g_varchar2_table(3863) := '737420723D652E63686172436F646541742873293B696628723E3D39372626723C3D3132327C7C723E3D36352626723C3D39307C7C723E3D34382626723C3D35377C7C34353D3D3D727C7C34363D3D3D727C7C39353D3D3D727C7C3132363D3D3D727C7C';
wwv_flow_imp.g_varchar2_table(3864) := '74262634373D3D3D727C7C6E262639313D3D3D727C7C6E262639333D3D3D727C7C6E262635383D3D3D72292D31213D3D6F262628692B3D656E636F6465555249436F6D706F6E656E7428652E737562737472696E67286F2C7329292C6F3D2D31292C766F';
wwv_flow_imp.g_varchar2_table(3865) := '69642030213D3D69262628692B3D652E636861724174287329293B656C73657B766F696420303D3D3D69262628693D652E73756273747228302C7329293B636F6E737420743D526F5B725D3B766F69642030213D3D743F282D31213D3D6F262628692B3D';
wwv_flow_imp.g_varchar2_table(3866) := '656E636F6465555249436F6D706F6E656E7428652E737562737472696E67286F2C7329292C6F3D2D31292C692B3D74293A2D313D3D3D6F2626286F3D73297D7D72657475726E2D31213D3D6F262628692B3D656E636F6465555249436F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(3867) := '28652E737562737472696E67286F2929292C766F69642030213D3D693F693A657D66756E6374696F6E20426F2865297B6C657420743B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(3868) := '4174286E293B33353D3D3D697C7C36333D3D3D693F28766F696420303D3D3D74262628743D652E73756273747228302C6E29292C742B3D526F5B695D293A766F69642030213D3D74262628742B3D655B6E5D297D72657475726E20766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(3869) := '743F743A657D66756E6374696F6E20566F28652C74297B6C6574206E3B72657475726E206E3D652E617574686F726974792626652E706174682E6C656E6774683E3126262266696C65223D3D3D652E736368656D653F602F2F247B652E617574686F7269';
wwv_flow_imp.g_varchar2_table(3870) := '74797D247B652E706174687D603A34373D3D3D652E706174682E63686172436F64654174283029262628652E706174682E63686172436F646541742831293E3D36352626652E706174682E63686172436F646541742831293C3D39307C7C652E70617468';
wwv_flow_imp.g_varchar2_table(3871) := '2E63686172436F646541742831293E3D39372626652E706174682E63686172436F646541742831293C3D31323229262635383D3D3D652E706174682E63686172436F646541742832293F743F652E706174682E7375627374722831293A652E706174685B';
wwv_flow_imp.g_varchar2_table(3872) := '315D2E746F4C6F7765724361736528292B652E706174682E7375627374722832293A652E706174682C6A2626286E3D6E2E7265706C616365282F5C2F2F672C225C5C2229292C6E7D66756E6374696F6E207A6F28652C74297B636F6E7374206E3D743F42';
wwv_flow_imp.g_varchar2_table(3873) := '6F3A466F3B6C657420693D22222C7B736368656D653A6F2C617574686F726974793A732C706174683A722C71756572793A612C667261676D656E743A6C7D3D653B6966286F262628692B3D6F2C692B3D223A22292C28737C7C2266696C65223D3D3D6F29';
wwv_flow_imp.g_varchar2_table(3874) := '262628692B3D4D6F2C692B3D4D6F292C73297B6C657420653D732E696E6465784F6628224022293B6966282D31213D3D65297B636F6E737420743D732E73756273747228302C65293B733D732E73756273747228652B31292C653D742E6C617374496E64';
wwv_flow_imp.g_varchar2_table(3875) := '65784F6628223A22292C2D313D3D3D653F692B3D6E28742C21312C2131293A28692B3D6E28742E73756273747228302C65292C21312C2131292C692B3D223A222C692B3D6E28742E73756273747228652B31292C21312C213029292C692B3D2240227D73';
wwv_flow_imp.g_varchar2_table(3876) := '3D732E746F4C6F7765724361736528292C653D732E6C617374496E6465784F6628223A22292C2D313D3D3D653F692B3D6E28732C21312C2130293A28692B3D6E28732E73756273747228302C65292C21312C2130292C692B3D732E737562737472286529';
wwv_flow_imp.g_varchar2_table(3877) := '297D69662872297B696628722E6C656E6774683E3D33262634373D3D3D722E63686172436F64654174283029262635383D3D3D722E63686172436F64654174283229297B636F6E737420653D722E63686172436F646541742831293B653E3D3635262665';
wwv_flow_imp.g_varchar2_table(3878) := '3C3D3930262628723D602F247B537472696E672E66726F6D43686172436F646528652B3332297D3A247B722E7375627374722833297D60297D656C736520696628722E6C656E6774683E3D32262635383D3D3D722E63686172436F64654174283129297B';
wwv_flow_imp.g_varchar2_table(3879) := '636F6E737420653D722E63686172436F646541742830293B653E3D36352626653C3D3930262628723D60247B537472696E672E66726F6D43686172436F646528652B3332297D3A247B722E7375627374722832297D60297D692B3D6E28722C21302C2131';
wwv_flow_imp.g_varchar2_table(3880) := '297D72657475726E2061262628692B3D223F222C692B3D6E28612C21312C213129292C6C262628692B3D2223222C692B3D743F6C3A466F286C2C21312C213129292C697D66756E6374696F6E20486F2865297B7472797B72657475726E206465636F6465';
wwv_flow_imp.g_varchar2_table(3881) := '555249436F6D706F6E656E742865297D63617463682874297B72657475726E20652E6C656E6774683E333F652E73756273747228302C33292B486F28652E737562737472283329293A657D7D636F6E737420576F3D2F28255B302D39412D5A612D7A5D5B';
wwv_flow_imp.g_varchar2_table(3882) := '302D39412D5A612D7A5D292B2F673B66756E6374696F6E206A6F2865297B72657475726E20652E6D6174636828576F293F652E7265706C61636528576F2C28653D3E486F28652929293A657D76617220716F3B66756E6374696F6E20246F28652C74297B';
wwv_flow_imp.g_varchar2_table(3883) := '72657475726E204E6F2E69735572692865293F6B6928652E736368656D652C74293A456928652C742B223A22297D66756E6374696F6E20556F28652C2E2E2E74297B72657475726E20742E736F6D652828743D3E246F28652C742929297D2166756E6374';
wwv_flow_imp.g_varchar2_table(3884) := '696F6E2865297B652E696E4D656D6F72793D22696E6D656D6F7279222C652E7673636F64653D227673636F6465222C652E696E7465726E616C3D2270726976617465222C652E77616C6B5468726F7567683D2277616C6B5468726F756768222C652E7761';
wwv_flow_imp.g_varchar2_table(3885) := '6C6B5468726F756768536E69707065743D2277616C6B5468726F756768536E6970706574222C652E687474703D2268747470222C652E68747470733D226874747073222C652E66696C653D2266696C65222C652E6D61696C746F3D226D61696C746F222C';
wwv_flow_imp.g_varchar2_table(3886) := '652E756E7469746C65643D22756E7469746C6564222C652E646174613D2264617461222C652E636F6D6D616E643D22636F6D6D616E64222C652E7673636F646552656D6F74653D227673636F64652D72656D6F7465222C652E7673636F646552656D6F74';
wwv_flow_imp.g_varchar2_table(3887) := '655265736F757263653D227673636F64652D72656D6F74652D7265736F75726365222C652E7673636F64654D616E6167656452656D6F74655265736F757263653D227673636F64652D6D616E616765642D72656D6F74652D7265736F75726365222C652E';
wwv_flow_imp.g_varchar2_table(3888) := '7673636F646555736572446174613D227673636F64652D7573657264617461222C652E7673636F6465437573746F6D456469746F723D227673636F64652D637573746F6D2D656469746F72222C652E7673636F64654E6F7465626F6F6B43656C6C3D2276';
wwv_flow_imp.g_varchar2_table(3889) := '73636F64652D6E6F7465626F6F6B2D63656C6C222C652E7673636F64654E6F7465626F6F6B43656C6C4D657461646174613D227673636F64652D6E6F7465626F6F6B2D63656C6C2D6D65746164617461222C652E7673636F64654E6F7465626F6F6B4365';
wwv_flow_imp.g_varchar2_table(3890) := '6C6C4F75747075743D227673636F64652D6E6F7465626F6F6B2D63656C6C2D6F7574707574222C652E7673636F6465496E746572616374697665496E7075743D227673636F64652D696E7465726163746976652D696E707574222C652E7673636F646553';
wwv_flow_imp.g_varchar2_table(3891) := '657474696E67733D227673636F64652D73657474696E6773222C652E7673636F6465576F726B737061636554727573743D227673636F64652D776F726B73706163652D7472757374222C652E7673636F64655465726D696E616C3D227673636F64652D74';
wwv_flow_imp.g_varchar2_table(3892) := '65726D696E616C222C652E7673636F646543686174436F6465426C6F636B3D227673636F64652D636861742D636F64652D626C6F636B222C652E7673636F646543686174436F6465436F6D707265426C6F636B3D227673636F64652D636861742D636F64';
wwv_flow_imp.g_varchar2_table(3893) := '652D636F6D706172652D626C6F636B222C652E7673636F6465436861745365737373696F6E3D227673636F64652D636861742D656469746F72222C652E7765627669657750616E656C3D22776562766965772D70616E656C222C652E7673636F64655765';
wwv_flow_imp.g_varchar2_table(3894) := '62766965773D227673636F64652D77656276696577222C652E657874656E73696F6E3D22657874656E73696F6E222C652E7673636F646546696C655265736F757263653D227673636F64652D66696C65222C652E746D703D22746D70222C652E76736C73';
wwv_flow_imp.g_varchar2_table(3895) := '3D2276736C73222C652E7673636F6465536F75726365436F6E74726F6C3D227673636F64652D73636D222C652E636F6D6D656E7473496E7075743D22636F6D6D656E74222C652E636F646553657474696E673D22636F64652D73657474696E67227D2871';
wwv_flow_imp.g_varchar2_table(3896) := '6F7C7C28716F3D7B7D29293B636F6E7374204B6F3D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F686F7374733D4F626A6563742E637265617465286E756C6C292C746869732E5F706F7274733D4F626A6563742E63726561';
wwv_flow_imp.g_varchar2_table(3897) := '7465286E756C6C292C746869732E5F636F6E6E656374696F6E546F6B656E733D4F626A6563742E637265617465286E756C6C292C746869732E5F707265666572726564576562536368656D613D2268747470222C746869732E5F64656C65676174653D6E';
wwv_flow_imp.g_varchar2_table(3898) := '756C6C2C746869732E5F736572766572526F6F74506174683D222F227D736574507265666572726564576562536368656D612865297B746869732E5F707265666572726564576562536368656D613D657D676574205F72656D6F74655265736F75726365';
wwv_flow_imp.g_varchar2_table(3899) := '735061746828297B72657475726E205F6F2E6A6F696E28746869732E5F736572766572526F6F74506174682C716F2E7673636F646552656D6F74655265736F75726365297D726577726974652865297B696628746869732E5F64656C6567617465297472';
wwv_flow_imp.g_varchar2_table(3900) := '797B72657475726E20746869732E5F64656C65676174652865297D63617463682874297B72657475726E206B652874292C657D636F6E737420743D652E617574686F726974793B6C6574206E3D746869732E5F686F7374735B745D3B6E26262D31213D3D';
wwv_flow_imp.g_varchar2_table(3901) := '6E2E696E6465784F6628223A222926262D313D3D3D6E2E696E6465784F6628225B22292626286E3D605B247B6E7D5D60293B636F6E737420693D746869732E5F706F7274735B745D2C6F3D746869732E5F636F6E6E656374696F6E546F6B656E735B745D';
wwv_flow_imp.g_varchar2_table(3902) := '3B6C657420733D60706174683D247B656E636F6465555249436F6D706F6E656E7428652E70617468297D603B72657475726E22737472696E67223D3D747970656F66206F262628732B3D6026746B6E3D247B656E636F6465555249436F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(3903) := '286F297D60292C4E6F2E66726F6D287B736368656D653A4B3F746869732E5F707265666572726564576562536368656D613A716F2E7673636F646552656D6F74655265736F757263652C617574686F726974793A60247B6E7D3A247B697D602C70617468';
wwv_flow_imp.g_varchar2_table(3904) := '3A746869732E5F72656D6F74655265736F7572636573506174682C71756572793A737D297D7D3B636C61737320476F7B757269546F42726F777365725572692865297B72657475726E20652E736368656D653D3D3D716F2E7673636F646552656D6F7465';
wwv_flow_imp.g_varchar2_table(3905) := '3F4B6F2E726577726974652865293A652E736368656D65213D3D716F2E66696C657C7C2155262647213D3D60247B716F2E7673636F646546696C655265736F757263657D3A2F2F247B476F2E46414C4C4241434B5F415554484F524954597D603F653A65';
wwv_flow_imp.g_varchar2_table(3906) := '2E77697468287B736368656D653A716F2E7673636F646546696C655265736F757263652C617574686F726974793A652E617574686F726974797C7C476F2E46414C4C4241434B5F415554484F524954592C71756572793A6E756C6C2C667261676D656E74';
wwv_flow_imp.g_varchar2_table(3907) := '3A6E756C6C7D297D7D476F2E46414C4C4241434B5F415554484F524954593D227673636F64652D617070223B636F6E737420516F3D6E657720476F3B76617220596F3B66756E6374696F6E205A6F2865297B72657475726E20586F28652C30297D66756E';
wwv_flow_imp.g_varchar2_table(3908) := '6374696F6E20586F28652C74297B73776974636828747970656F662065297B63617365226F626A656374223A72657475726E206E756C6C3D3D3D653F4A6F283334392C74293A41727261792E697341727261792865293F286E3D652C693D4A6F28313034';
wwv_flow_imp.g_varchar2_table(3909) := '3537392C693D74292C6E2E726564756365282828652C74293D3E586F28742C6529292C6929293A66756E6374696F6E28652C74297B72657475726E20743D4A6F283138313338372C74292C4F626A6563742E6B6579732865292E736F727428292E726564';
wwv_flow_imp.g_varchar2_table(3910) := '756365282828742C6E293D3E28743D6573286E2C74292C586F28655B6E5D2C742929292C74297D28652C74293B6361736522737472696E67223A72657475726E20657328652C74293B6361736522626F6F6C65616E223A72657475726E2066756E637469';
wwv_flow_imp.g_varchar2_table(3911) := '6F6E28652C74297B72657475726E204A6F28653F3433333A3836332C74297D28652C74293B63617365226E756D626572223A72657475726E204A6F28652C74293B6361736522756E646566696E6564223A72657475726E204A6F283933372C74293B6465';
wwv_flow_imp.g_varchar2_table(3912) := '6661756C743A72657475726E204A6F283631372C74297D766172206E2C697D66756E6374696F6E204A6F28652C74297B72657475726E28743C3C35292D742B657C307D66756E6374696F6E20657328652C74297B743D4A6F283134393431372C74293B66';
wwv_flow_imp.g_varchar2_table(3913) := '6F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29743D4A6F28652E63686172436F64654174286E292C74293B72657475726E20747D66756E6374696F6E20747328652C742C6E3D3332297B636F6E737420693D6E2D743B726574';
wwv_flow_imp.g_varchar2_table(3914) := '75726E28653C3C747C287E2828313C3C69292D31292665293E3E3E69293E3E3E307D66756E6374696F6E206E7328652C743D302C6E3D652E627974654C656E6774682C693D30297B666F72286C6574206F3D303B6F3C6E3B6F2B2B29655B742B6F5D3D69';
wwv_flow_imp.g_varchar2_table(3915) := '7D66756E6374696F6E20697328652C743D3332297B72657475726E206520696E7374616E63656F662041727261794275666665723F41727261792E66726F6D286E65772055696E74384172726179286529292E6D61702828653D3E652E746F537472696E';
wwv_flow_imp.g_varchar2_table(3916) := '67283136292E706164537461727428322C2230222929292E6A6F696E282222293A66756E6374696F6E28652C742C6E3D223022297B666F72283B652E6C656E6774683C743B29653D6E2B653B72657475726E20657D2828653E3E3E30292E746F53747269';
wwv_flow_imp.g_varchar2_table(3917) := '6E67283136292C742F34297D2166756E6374696F6E2865297B636F6E737420743D6E6577204D6170285B5B2231222C7B2243726F73732D4F726967696E2D4F70656E65722D506F6C696379223A2273616D652D6F726967696E227D5D2C5B2232222C7B22';
wwv_flow_imp.g_varchar2_table(3918) := '43726F73732D4F726967696E2D456D6265646465722D506F6C696379223A22726571756972652D636F7270227D5D2C5B2233222C7B2243726F73732D4F726967696E2D4F70656E65722D506F6C696379223A2273616D652D6F726967696E222C2243726F';
wwv_flow_imp.g_varchar2_table(3919) := '73732D4F726967696E2D456D6265646465722D506F6C696379223A22726571756972652D636F7270227D5D5D293B652E436F6F70416E64436F65703D4F626A6563742E667265657A6528742E6765742822332229293B636F6E7374206E3D227673636F64';
wwv_flow_imp.g_varchar2_table(3920) := '652D636F69223B652E6765744865616465727346726F6D51756572793D66756E6374696F6E2865297B6C657420693B22737472696E67223D3D747970656F6620653F693D6E65772055524C2865292E736561726368506172616D733A6520696E7374616E';
wwv_flow_imp.g_varchar2_table(3921) := '63656F662055524C3F693D652E736561726368506172616D733A4E6F2E6973557269286529262628693D6E65772055524C28652E746F537472696E6728213029292E736561726368506172616D73293B636F6E7374206F3D6E756C6C3D3D693F766F6964';
wwv_flow_imp.g_varchar2_table(3922) := '20303A692E676574286E293B6966286F2972657475726E20742E676574286F297D2C652E616464536561726368506172616D3D66756E6374696F6E28652C742C69297B69662821676C6F62616C546869732E63726F73734F726967696E49736F6C617465';
wwv_flow_imp.g_varchar2_table(3923) := '642972657475726E3B636F6E7374206F3D742626693F2233223A693F2232223A2231223B6520696E7374616E63656F662055524C536561726368506172616D733F652E736574286E2C6F293A655B6E5D3D6F7D7D28596F7C7C28596F3D7B7D29293B636C';
wwv_flow_imp.g_varchar2_table(3924) := '617373206F737B636F6E7374727563746F7228297B746869732E5F68303D313733323538343139332C746869732E5F68313D343032333233333431372C746869732E5F68323D323536323338333130322C746869732E5F68333D3237313733333837382C';
wwv_flow_imp.g_varchar2_table(3925) := '746869732E5F68343D333238353337373532302C746869732E5F627566663D6E65772055696E74384172726179283637292C746869732E5F6275666644563D6E657720446174615669657728746869732E5F627566662E627566666572292C746869732E';
wwv_flow_imp.g_varchar2_table(3926) := '5F627566664C656E3D302C746869732E5F746F74616C4C656E3D302C746869732E5F6C6566746F76657248696768537572726F676174653D302C746869732E5F66696E69736865643D21317D7570646174652865297B636F6E737420743D652E6C656E67';
wwv_flow_imp.g_varchar2_table(3927) := '74683B696628303D3D3D742972657475726E3B636F6E7374206E3D746869732E5F627566663B6C657420692C6F2C733D746869732E5F627566664C656E2C723D746869732E5F6C6566746F76657248696768537572726F676174653B666F722830213D3D';
wwv_flow_imp.g_varchar2_table(3928) := '723F28693D722C6F3D2D312C723D30293A28693D652E63686172436F646541742830292C6F3D30293B3B297B6C657420613D693B6966285469286929297B69662821286F2B313C7429297B723D693B627265616B7D7B636F6E737420743D652E63686172';
wwv_flow_imp.g_varchar2_table(3929) := '436F64654174286F2B31293B49692874293F286F2B2B2C613D4D6928692C7429293A613D36353533337D7D656C7365204969286929262628613D3635353333293B696628733D746869732E5F70757368286E2C732C61292C6F2B2B2C21286F3C74292962';
wwv_flow_imp.g_varchar2_table(3930) := '7265616B3B693D652E63686172436F64654174286F297D746869732E5F627566664C656E3D732C746869732E5F6C6566746F76657248696768537572726F676174653D727D5F7075736828652C742C6E297B72657475726E206E3C3132383F655B742B2B';
wwv_flow_imp.g_varchar2_table(3931) := '5D3D6E3A6E3C323034383F28655B742B2B5D3D3139327C2831393834266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30293A6E3C36353533363F28655B742B2B5D3D3232347C283631343430266E293E3E3E31322C655B742B2B5D';
wwv_flow_imp.g_varchar2_table(3932) := '3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30293A28655B742B2B5D3D3234307C2831383335303038266E293E3E3E31382C655B742B2B5D3D3132387C28323538303438266E293E3E3E31322C655B74';
wwv_flow_imp.g_varchar2_table(3933) := '2B2B5D3D3132387C2834303332266E293E3E3E362C655B742B2B5D3D3132387C283633266E293E3E3E30292C743E3D3634262628746869732E5F7374657028292C742D3D36342C746869732E5F746F74616C4C656E2B3D36342C655B305D3D655B36345D';
wwv_flow_imp.g_varchar2_table(3934) := '2C655B315D3D655B36355D2C655B325D3D655B36365D292C747D64696765737428297B72657475726E20746869732E5F66696E69736865647C7C28746869732E5F66696E69736865643D21302C746869732E5F6C6566746F76657248696768537572726F';
wwv_flow_imp.g_varchar2_table(3935) := '67617465262628746869732E5F6C6566746F76657248696768537572726F676174653D302C746869732E5F627566664C656E3D746869732E5F7075736828746869732E5F627566662C746869732E5F627566664C656E2C363535333329292C746869732E';
wwv_flow_imp.g_varchar2_table(3936) := '5F746F74616C4C656E2B3D746869732E5F627566664C656E2C746869732E5F7772617055702829292C697328746869732E5F6830292B697328746869732E5F6831292B697328746869732E5F6832292B697328746869732E5F6833292B69732874686973';
wwv_flow_imp.g_varchar2_table(3937) := '2E5F6834297D5F77726170557028297B746869732E5F627566665B746869732E5F627566664C656E2B2B5D3D3132382C6E7328746869732E5F627566662C746869732E5F627566664C656E292C746869732E5F627566664C656E3E353626262874686973';
wwv_flow_imp.g_varchar2_table(3938) := '2E5F7374657028292C6E7328746869732E5F6275666629293B636F6E737420653D382A746869732E5F746F74616C4C656E3B746869732E5F6275666644562E73657455696E7433322835362C4D6174682E666C6F6F7228652F3432393439363732393629';
wwv_flow_imp.g_varchar2_table(3939) := '2C2131292C746869732E5F6275666644562E73657455696E7433322836302C6525343239343936373239362C2131292C746869732E5F7374657028297D5F7374657028297B636F6E737420653D6F732E5F626967426C6F636B33322C743D746869732E5F';
wwv_flow_imp.g_varchar2_table(3940) := '6275666644563B666F72286C6574206E3D303B6E3C36343B6E2B3D3429652E73657455696E743332286E2C742E67657455696E743332286E2C2131292C2131293B666F72286C657420743D36343B743C3332303B742B3D3429652E73657455696E743332';
wwv_flow_imp.g_varchar2_table(3941) := '28742C747328652E67657455696E74333228742D31322C2131295E652E67657455696E74333228742D33322C2131295E652E67657455696E74333228742D35362C2131295E652E67657455696E74333228742D36342C2131292C31292C2131293B6C6574';
wwv_flow_imp.g_varchar2_table(3942) := '206E2C692C6F2C733D746869732E5F68302C723D746869732E5F68312C613D746869732E5F68322C6C3D746869732E5F68332C633D746869732E5F68343B666F72286C657420743D303B743C38303B742B2B29743C32303F286E3D7226617C7E72266C2C';
wwv_flow_imp.g_varchar2_table(3943) := '693D31353138353030323439293A743C34303F286E3D725E615E6C2C693D31383539373735333933293A743C36303F286E3D7226617C72266C7C61266C2C693D32343030393539373038293A286E3D725E615E6C2C693D33333935343639373832292C6F';
wwv_flow_imp.g_varchar2_table(3944) := '3D747328732C35292B6E2B632B692B652E67657455696E74333228342A742C21312926343239343936373239352C633D6C2C6C3D612C613D747328722C3330292C723D732C733D6F3B746869732E5F68303D746869732E5F68302B732634323934393637';
wwv_flow_imp.g_varchar2_table(3945) := '3239352C746869732E5F68313D746869732E5F68312B7226343239343936373239352C746869732E5F68323D746869732E5F68322B6126343239343936373239352C746869732E5F68333D746869732E5F68332B6C26343239343936373239352C746869';
wwv_flow_imp.g_varchar2_table(3946) := '732E5F68343D746869732E5F68342B6326343239343936373239357D7D6F732E5F626967426C6F636B33323D6E6577204461746156696577286E65772041727261794275666665722833323029293B636F6E73747B726567697374657257696E646F773A';
wwv_flow_imp.g_varchar2_table(3947) := '73732C67657457696E646F773A72732C676574446F63756D656E743A61732C67657457696E646F77733A6C732C67657457696E646F7773436F756E743A63732C67657457696E646F7749643A64732C67657457696E646F77427949643A68732C68617357';
wwv_flow_imp.g_varchar2_table(3948) := '696E646F773A75732C6F6E446964526567697374657257696E646F773A70732C6F6E57696C6C556E726567697374657257696E646F773A67732C6F6E446964556E726567697374657257696E646F773A6D737D3D66756E6374696F6E28297B636F6E7374';
wwv_flow_imp.g_varchar2_table(3949) := '20653D6E6577204D61703B2166756E6374696F6E2865297B636F6E737420743D653B226E756D62657222213D747970656F6620742E7673636F646557696E646F77496426264F626A6563742E646566696E6550726F706572747928742C227673636F6465';
wwv_flow_imp.g_varchar2_table(3950) := '57696E646F774964222C7B6765743A28293D3E317D297D2873293B636F6E737420743D7B77696E646F773A732C646973706F7361626C65733A6E65772061747D3B652E73657428732E7673636F646557696E646F7749642C74293B636F6E7374206E3D6E';
wwv_flow_imp.g_varchar2_table(3951) := '65772043742C693D6E65772043742C6F3D6E65772043743B72657475726E7B6F6E446964526567697374657257696E646F773A6E2E6576656E742C6F6E57696C6C556E726567697374657257696E646F773A6F2E6576656E742C6F6E446964556E726567';
wwv_flow_imp.g_varchar2_table(3952) := '697374657257696E646F773A692E6576656E742C726567697374657257696E646F772874297B696628652E68617328742E7673636F646557696E646F774964292972657475726E206C742E4E6F6E653B636F6E737420733D6E65772061742C723D7B7769';
wwv_flow_imp.g_varchar2_table(3953) := '6E646F773A742C646973706F7361626C65733A732E616464286E6577206174297D3B72657475726E20652E73657428742E7673636F646557696E646F7749642C72292C732E616464287274282828293D3E7B652E64656C65746528742E7673636F646557';
wwv_flow_imp.g_varchar2_table(3954) := '696E646F774964292C692E666972652874297D2929292C732E61646428627328742C61722E4245464F52455F554E4C4F41442C2828293D3E7B6F2E666972652874297D2929292C6E2E666972652872292C737D2C67657457696E646F77733A28293D3E65';
wwv_flow_imp.g_varchar2_table(3955) := '2E76616C75657328292C67657457696E646F7773436F756E743A28293D3E652E73697A652C67657457696E646F7749643A653D3E652E7673636F646557696E646F7749642C68617357696E646F773A743D3E652E6861732874292C67657457696E646F77';
wwv_flow_imp.g_varchar2_table(3956) := '427949643A66756E6374696F6E286E2C69297B636F6E7374206F3D226E756D626572223D3D747970656F66206E3F652E676574286E293A766F696420303B72657475726E206E756C6C213D6F3F6F3A693F743A766F696420307D2C67657457696E646F77';
wwv_flow_imp.g_varchar2_table(3957) := '2865297B76617220743B636F6E7374206E3D653B6966286E756C6C3D3D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E6F776E6572446F63756D656E74297C7C766F696420303D3D3D743F766F696420303A742E64656661756C7456696577297265';
wwv_flow_imp.g_varchar2_table(3958) := '7475726E206E2E6F776E6572446F63756D656E742E64656661756C74566965772E77696E646F773B636F6E737420693D653B72657475726E286E756C6C3D3D693F766F696420303A692E76696577293F692E766965772E77696E646F773A737D2C676574';
wwv_flow_imp.g_varchar2_table(3959) := '446F63756D656E743A653D3E72732865292E646F63756D656E747D7D28293B66756E6374696F6E2066732865297B666F72283B652E66697273744368696C643B29652E66697273744368696C642E72656D6F766528297D636C6173732076737B636F6E73';
wwv_flow_imp.g_varchar2_table(3960) := '74727563746F7228652C742C6E2C69297B746869732E5F6E6F64653D652C746869732E5F747970653D742C746869732E5F68616E646C65723D6E2C746869732E5F6F7074696F6E733D697C7C21312C746869732E5F6E6F64652E6164644576656E744C69';
wwv_flow_imp.g_varchar2_table(3961) := '7374656E657228746869732E5F747970652C746869732E5F68616E646C65722C746869732E5F6F7074696F6E73297D646973706F736528297B746869732E5F68616E646C6572262628746869732E5F6E6F64652E72656D6F76654576656E744C69737465';
wwv_flow_imp.g_varchar2_table(3962) := '6E657228746869732E5F747970652C746869732E5F68616E646C65722C746869732E5F6F7074696F6E73292C746869732E5F6E6F64653D6E756C6C2C746869732E5F68616E646C65723D6E756C6C297D7D66756E6374696F6E20627328652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(3963) := '297B72657475726E206E657720767328652C742C6E2C69297D66756E6374696F6E205F7328652C74297B72657475726E2066756E6374696F6E286E297B72657475726E2074286E657720476528652C6E29297D7D636F6E73742079733D66756E6374696F';
wwv_flow_imp.g_varchar2_table(3964) := '6E28652C742C6E2C69297B6C6574206F3D6E3B72657475726E22636C69636B223D3D3D747C7C226D6F757365646F776E223D3D3D743F6F3D5F732872732865292C6E293A226B6579646F776E22213D3D742626226B6579707265737322213D3D74262622';
wwv_flow_imp.g_varchar2_table(3965) := '6B6579757022213D3D747C7C286F3D66756E6374696F6E2865297B72657475726E2066756E6374696F6E2874297B72657475726E2065286E6577207165287429297D7D286E29292C627328652C742C6F2C69297D3B66756E6374696F6E20777328652C74';
wwv_flow_imp.g_varchar2_table(3966) := '2C6E297B72657475726E20517428652C742C6E297D636C61737320437320657874656E64732059747B636F6E7374727563746F7228652C74297B737570657228652C74297D7D6C65742053732C78733B636C617373206B7320657874656E64732055747B';
wwv_flow_imp.g_varchar2_table(3967) := '636F6E7374727563746F722865297B737570657228292C746869732E64656661756C745461726765743D65262672732865297D63616E63656C416E6453657428652C742C6E297B72657475726E2073757065722E63616E63656C416E6453657428652C74';
wwv_flow_imp.g_varchar2_table(3968) := '2C6E756C6C213D6E3F6E3A746869732E64656661756C74546172676574297D7D636C6173732045737B636F6E7374727563746F7228652C743D30297B746869732E5F72756E6E65723D652C746869732E7072696F726974793D742C746869732E5F63616E';
wwv_flow_imp.g_varchar2_table(3969) := '63656C65643D21317D646973706F736528297B746869732E5F63616E63656C65643D21307D6578656375746528297B69662821746869732E5F63616E63656C6564297472797B746869732E5F72756E6E657228297D63617463682865297B6B652865297D';
wwv_flow_imp.g_varchar2_table(3970) := '7D73746174696320736F727428652C74297B72657475726E20742E7072696F726974792D652E7072696F726974797D7D66756E6374696F6E204C732865297B72657475726E2072732865292E676574436F6D70757465645374796C6528652C6E756C6C29';
wwv_flow_imp.g_varchar2_table(3971) := '7D66756E6374696F6E20447328652C74297B636F6E7374206E3D72732865292C693D6E2E646F63756D656E743B69662865213D3D692E626F64792972657475726E206E657720497328652E636C69656E7457696474682C652E636C69656E744865696768';
wwv_flow_imp.g_varchar2_table(3972) := '74293B696628512626286E756C6C3D3D6E3F766F696420303A6E2E76697375616C56696577706F7274292972657475726E206E6577204973286E2E76697375616C56696577706F72742E77696474682C6E2E76697375616C56696577706F72742E686569';
wwv_flow_imp.g_varchar2_table(3973) := '676874293B696628286E756C6C3D3D6E3F766F696420303A6E2E696E6E657257696474682926266E2E696E6E65724865696768742972657475726E206E6577204973286E2E696E6E657257696474682C6E2E696E6E6572486569676874293B696628692E';
wwv_flow_imp.g_varchar2_table(3974) := '626F64792626692E626F64792E636C69656E7457696474682626692E626F64792E636C69656E744865696768742972657475726E206E657720497328692E626F64792E636C69656E7457696474682C692E626F64792E636C69656E74486569676874293B';
wwv_flow_imp.g_varchar2_table(3975) := '696628692E646F63756D656E74456C656D656E742626692E646F63756D656E74456C656D656E742E636C69656E7457696474682626692E646F63756D656E74456C656D656E742E636C69656E744865696768742972657475726E206E657720497328692E';
wwv_flow_imp.g_varchar2_table(3976) := '646F63756D656E74456C656D656E742E636C69656E7457696474682C692E646F63756D656E74456C656D656E742E636C69656E74486569676874293B696628742972657475726E2044732874293B7468726F77206E6577204572726F722822556E61626C';
wwv_flow_imp.g_varchar2_table(3977) := '6520746F20666967757265206F75742062726F7773657220776964746820616E642068656967687422297D2166756E6374696F6E28297B636F6E737420653D6E6577204D61702C743D6E6577204D61702C6E3D6E6577204D61702C693D6E6577204D6170';
wwv_flow_imp.g_varchar2_table(3978) := '3B78733D286F2C732C723D30293D3E7B636F6E737420613D6473286F292C6C3D6E657720457328732C72293B6C657420633D652E6765742861293B72657475726E20637C7C28633D5B5D2C652E73657428612C6329292C632E70757368286C292C6E2E67';
wwv_flow_imp.g_varchar2_table(3979) := '65742861297C7C286E2E73657428612C2130292C6F2E72657175657374416E696D6174696F6E4672616D65282828293D3E286F3D3E7B76617220733B6E2E736574286F2C2131293B636F6E737420723D6E756C6C213D3D28733D652E676574286F292926';
wwv_flow_imp.g_varchar2_table(3980) := '26766F69642030213D3D733F733A5B5D3B666F7228742E736574286F2C72292C652E736574286F2C5B5D292C692E736574286F2C2130293B722E6C656E6774683E303B29722E736F72742845732E736F7274292C722E736869667428292E657865637574';
wwv_flow_imp.g_varchar2_table(3981) := '6528293B692E736574286F2C2131297D292861292929292C6C7D2C53733D28652C6E2C6F293D3E7B636F6E737420733D64732865293B696628692E676574287329297B636F6E737420653D6E6577204573286E2C6F293B6C657420693D742E6765742873';
wwv_flow_imp.g_varchar2_table(3982) := '293B72657475726E20697C7C28693D5B5D2C742E73657428732C6929292C692E707573682865292C657D72657475726E20787328652C6E2C6F297D7D28293B636C6173732054737B73746174696320636F6E76657274546F506978656C7328652C74297B';
wwv_flow_imp.g_varchar2_table(3983) := '72657475726E207061727365466C6F61742874297C7C307D7374617469632067657444696D656E73696F6E28652C742C6E297B636F6E737420693D4C732865292C6F3D693F692E67657450726F706572747956616C75652874293A2230223B7265747572';
wwv_flow_imp.g_varchar2_table(3984) := '6E2054732E636F6E76657274546F506978656C7328652C6F297D73746174696320676574426F726465724C65667457696474682865297B72657475726E2054732E67657444696D656E73696F6E28652C22626F726465722D6C6566742D7769647468222C';
wwv_flow_imp.g_varchar2_table(3985) := '22626F726465724C656674576964746822297D73746174696320676574426F72646572526967687457696474682865297B72657475726E2054732E67657444696D656E73696F6E28652C22626F726465722D72696768742D7769647468222C22626F7264';
wwv_flow_imp.g_varchar2_table(3986) := '65725269676874576964746822297D73746174696320676574426F72646572546F7057696474682865297B72657475726E2054732E67657444696D656E73696F6E28652C22626F726465722D746F702D7769647468222C22626F72646572546F70576964';
wwv_flow_imp.g_varchar2_table(3987) := '746822297D73746174696320676574426F72646572426F74746F6D57696474682865297B72657475726E2054732E67657444696D656E73696F6E28652C22626F726465722D626F74746F6D2D7769647468222C22626F72646572426F74746F6D57696474';
wwv_flow_imp.g_varchar2_table(3988) := '6822297D7374617469632067657450616464696E674C6566742865297B72657475726E2054732E67657444696D656E73696F6E28652C2270616464696E672D6C656674222C2270616464696E674C65667422297D7374617469632067657450616464696E';
wwv_flow_imp.g_varchar2_table(3989) := '6752696768742865297B72657475726E2054732E67657444696D656E73696F6E28652C2270616464696E672D7269676874222C2270616464696E67526967687422297D7374617469632067657450616464696E67546F702865297B72657475726E205473';
wwv_flow_imp.g_varchar2_table(3990) := '2E67657444696D656E73696F6E28652C2270616464696E672D746F70222C2270616464696E67546F7022297D7374617469632067657450616464696E67426F74746F6D2865297B72657475726E2054732E67657444696D656E73696F6E28652C22706164';
wwv_flow_imp.g_varchar2_table(3991) := '64696E672D626F74746F6D222C2270616464696E67426F74746F6D22297D737461746963206765744D617267696E4C6566742865297B72657475726E2054732E67657444696D656E73696F6E28652C226D617267696E2D6C656674222C226D617267696E';
wwv_flow_imp.g_varchar2_table(3992) := '4C65667422297D737461746963206765744D617267696E546F702865297B72657475726E2054732E67657444696D656E73696F6E28652C226D617267696E2D746F70222C226D617267696E546F7022297D737461746963206765744D617267696E526967';
wwv_flow_imp.g_varchar2_table(3993) := '68742865297B72657475726E2054732E67657444696D656E73696F6E28652C226D617267696E2D7269676874222C226D617267696E526967687422297D737461746963206765744D617267696E426F74746F6D2865297B72657475726E2054732E676574';
wwv_flow_imp.g_varchar2_table(3994) := '44696D656E73696F6E28652C226D617267696E2D626F74746F6D222C226D617267696E426F74746F6D22297D7D636C6173732049737B636F6E7374727563746F7228652C74297B746869732E77696474683D652C746869732E6865696768743D747D7769';
wwv_flow_imp.g_varchar2_table(3995) := '746828653D746869732E77696474682C743D746869732E686569676874297B72657475726E2065213D3D746869732E77696474687C7C74213D3D746869732E6865696768743F6E657720497328652C74293A746869737D7374617469632069732865297B';
wwv_flow_imp.g_varchar2_table(3996) := '72657475726E226F626A656374223D3D747970656F6620652626226E756D626572223D3D747970656F6620652E6865696768742626226E756D626572223D3D747970656F6620652E77696474687D737461746963206C6966742865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(3997) := '6520696E7374616E63656F662049733F653A6E657720497328652E77696474682C652E686569676874297D73746174696320657175616C7328652C74297B72657475726E20653D3D3D747C7C212821657C7C2174292626652E77696474683D3D3D742E77';
wwv_flow_imp.g_varchar2_table(3998) := '696474682626652E6865696768743D3D3D742E6865696768747D7D66756E6374696F6E204D732865297B6C657420743D652E6F6666736574506172656E742C6E3D652E6F6666736574546F702C693D652E6F66667365744C6566743B666F72283B6E756C';
wwv_flow_imp.g_varchar2_table(3999) := '6C213D3D28653D652E706172656E744E6F646529262665213D3D652E6F776E6572446F63756D656E742E626F6479262665213D3D652E6F776E6572446F63756D656E742E646F63756D656E74456C656D656E743B297B6E2D3D652E7363726F6C6C546F70';
wwv_flow_imp.g_varchar2_table(4000) := '3B636F6E7374206F3D7A732865293F6E756C6C3A4C732865293B6F262628692D3D2272746C22213D3D6F2E646972656374696F6E3F652E7363726F6C6C4C6566743A2D652E7363726F6C6C4C656674292C653D3D3D74262628692B3D54732E676574426F';
wwv_flow_imp.g_varchar2_table(4001) := '726465724C65667457696474682865292C6E2B3D54732E676574426F72646572546F7057696474682865292C6E2B3D652E6F6666736574546F702C692B3D652E6F66667365744C6566742C743D652E6F6666736574506172656E74297D72657475726E7B';
wwv_flow_imp.g_varchar2_table(4002) := '6C6566743A692C746F703A6E7D7D66756E6374696F6E2041732865297B636F6E737420743D652E676574426F756E64696E67436C69656E745265637428292C6E3D72732865293B72657475726E7B6C6566743A742E6C6566742B6E2E7363726F6C6C582C';
wwv_flow_imp.g_varchar2_table(4003) := '746F703A742E746F702B6E2E7363726F6C6C592C77696474683A742E77696474682C6865696768743A742E6865696768747D7D66756E6374696F6E204E732865297B6C657420743D652C6E3D313B646F7B636F6E737420653D4C732874292E7A6F6F6D3B';
wwv_flow_imp.g_varchar2_table(4004) := '6E756C6C213D652626223122213D3D652626286E2A3D65292C743D742E706172656E74456C656D656E747D7768696C65286E756C6C213D3D74262674213D3D742E6F776E6572446F63756D656E742E646F63756D656E74456C656D656E74293B72657475';
wwv_flow_imp.g_varchar2_table(4005) := '726E206E7D66756E6374696F6E2050732865297B636F6E737420743D54732E6765744D617267696E4C6566742865292B54732E6765744D617267696E52696768742865293B72657475726E20652E6F666673657457696474682B747D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4006) := '204F732865297B636F6E737420743D54732E676574426F726465724C65667457696474682865292B54732E676574426F72646572526967687457696474682865292C6E3D54732E67657450616464696E674C6566742865292B54732E6765745061646469';
wwv_flow_imp.g_varchar2_table(4007) := '6E6752696768742865293B72657475726E20652E6F666673657457696474682D742D6E7D66756E6374696F6E2052732865297B636F6E737420743D54732E676574426F72646572546F7057696474682865292B54732E676574426F72646572426F74746F';
wwv_flow_imp.g_varchar2_table(4008) := '6D57696474682865292C6E3D54732E67657450616464696E67546F702865292B54732E67657450616464696E67426F74746F6D2865293B72657475726E20652E6F66667365744865696768742D742D6E7D66756E6374696F6E2046732865297B636F6E73';
wwv_flow_imp.g_varchar2_table(4009) := '7420743D54732E6765744D617267696E546F702865292B54732E6765744D617267696E426F74746F6D2865293B72657475726E20652E6F66667365744865696768742B747D66756E6374696F6E20427328652C74297B72657475726E20426F6F6C65616E';
wwv_flow_imp.g_varchar2_table(4010) := '286E756C6C3D3D743F766F696420303A742E636F6E7461696E73286529297D66756E6374696F6E20567328652C742C6E297B72657475726E212166756E6374696F6E28652C742C6E297B666F72283B652626652E6E6F6465547970653D3D3D652E454C45';
wwv_flow_imp.g_varchar2_table(4011) := '4D454E545F4E4F44453B297B696628652E636C6173734C6973742E636F6E7461696E732874292972657475726E20653B6966286E2969662822737472696E67223D3D747970656F66206E297B696628652E636C6173734C6973742E636F6E7461696E7328';
wwv_flow_imp.g_varchar2_table(4012) := '6E292972657475726E206E756C6C7D656C736520696628653D3D3D6E2972657475726E206E756C6C3B653D652E706172656E744E6F64657D72657475726E206E756C6C7D28652C742C6E297D66756E6374696F6E207A732865297B72657475726E206526';
wwv_flow_imp.g_varchar2_table(4013) := '262121652E686F737426262121652E6D6F64657D66756E6374696F6E2048732865297B72657475726E212157732865297D66756E6374696F6E2057732865297B666F722876617220743B652E706172656E744E6F64653B297B696628653D3D3D286E756C';
wwv_flow_imp.g_varchar2_table(4014) := '6C3D3D3D28743D652E6F776E6572446F63756D656E74297C7C766F696420303D3D3D743F766F696420303A742E626F6479292972657475726E206E756C6C3B653D652E706172656E744E6F64657D72657475726E207A732865293F653A6E756C6C7D6675';
wwv_flow_imp.g_varchar2_table(4015) := '6E6374696F6E206A7328297B6C657420653D557328292E616374697665456C656D656E743B666F72283B6E756C6C3D3D653F766F696420303A652E736861646F77526F6F743B29653D652E736861646F77526F6F742E616374697665456C656D656E743B';
wwv_flow_imp.g_varchar2_table(4016) := '72657475726E20657D66756E6374696F6E2071732865297B72657475726E206A7328293D3D3D657D66756E6374696F6E2024732865297B72657475726E204273286A7328292C65297D66756E6374696F6E20557328297B76617220653B72657475726E20';
wwv_flow_imp.g_varchar2_table(4017) := '637328293C3D313F732E646F63756D656E743A6E756C6C213D3D28653D41727261792E66726F6D286C732829292E6D61702828287B77696E646F773A657D293D3E652E646F63756D656E7429292E66696E642828653D3E652E686173466F637573282929';
wwv_flow_imp.g_varchar2_table(4018) := '29292626766F69642030213D3D653F653A732E646F63756D656E747D49732E4E6F6E653D6E657720497328302C30293B636F6E7374204B733D6E6577204D61703B66756E6374696F6E20477328297B72657475726E206E65772051737D636C6173732051';
wwv_flow_imp.g_varchar2_table(4019) := '737B636F6E7374727563746F7228297B746869732E5F63757272656E744373735374796C653D22222C746869732E5F7374796C6553686565743D766F696420307D7365745374796C652865297B65213D3D746869732E5F63757272656E74437373537479';
wwv_flow_imp.g_varchar2_table(4020) := '6C65262628746869732E5F63757272656E744373735374796C653D652C746869732E5F7374796C6553686565743F746869732E5F7374796C6553686565742E696E6E6572546578743D653A746869732E5F7374796C6553686565743D597328732E646F63';
wwv_flow_imp.g_varchar2_table(4021) := '756D656E742E686561642C28743D3E742E696E6E6572546578743D652929297D646973706F736528297B746869732E5F7374796C655368656574262628746869732E5F7374796C6553686565742E72656D6F766528292C746869732E5F7374796C655368';
wwv_flow_imp.g_varchar2_table(4022) := '6565743D766F69642030297D7D66756E6374696F6E20597328653D732E646F63756D656E742E686561642C742C6E297B636F6E737420693D646F63756D656E742E637265617465456C656D656E7428227374796C6522293B696628692E747970653D2274';
wwv_flow_imp.g_varchar2_table(4023) := '6578742F637373222C692E6D656469613D2273637265656E222C6E756C6C3D3D747C7C742869292C652E617070656E644368696C642869292C6E26266E2E616464287274282828293D3E652E72656D6F76654368696C642869292929292C653D3D3D732E';
wwv_flow_imp.g_varchar2_table(4024) := '646F63756D656E742E68656164297B636F6E737420653D6E6577205365743B4B732E73657428692C65293B666F7228636F6E73747B77696E646F773A742C646973706F7361626C65733A6F7D6F66206C732829297B696628743D3D3D7329636F6E74696E';
wwv_flow_imp.g_varchar2_table(4025) := '75653B636F6E737420723D6F2E616464285A7328692C652C7429293B6E756C6C3D3D6E7C7C6E2E6164642872297D7D72657475726E20697D66756E6374696F6E205A7328652C742C6E297B76617220692C6F3B636F6E737420733D6E65772061742C723D';
wwv_flow_imp.g_varchar2_table(4026) := '652E636C6F6E654E6F6465282130293B6E2E646F63756D656E742E686561642E617070656E644368696C642872292C732E616464287274282828293D3E6E2E646F63756D656E742E686561642E72656D6F76654368696C642872292929293B666F722863';
wwv_flow_imp.g_varchar2_table(4027) := '6F6E73742074206F66207472286529296E756C6C3D3D3D28693D722E7368656574297C7C766F696420303D3D3D697C7C692E696E7365727452756C6528742E637373546578742C6E756C6C3D3D3D286F3D722E7368656574297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(4028) := '6F3F766F696420303A6F2E63737352756C65732E6C656E677468293B72657475726E20732E6164642858732E6F62736572766528652C732C7B6368696C644C6973743A21307D29282828293D3E7B722E74657874436F6E74656E743D652E74657874436F';
wwv_flow_imp.g_varchar2_table(4029) := '6E74656E747D2929292C742E6164642872292C732E616464287274282828293D3E742E64656C6574652872292929292C737D636F6E73742058733D6E657720636C6173737B636F6E7374727563746F7228297B746869732E6D75746174696F6E4F627365';
wwv_flow_imp.g_varchar2_table(4030) := '72766572733D6E6577204D61707D6F62736572766528652C742C6E297B6C657420693D746869732E6D75746174696F6E4F62736572766572732E6765742865293B697C7C28693D6E6577204D61702C746869732E6D75746174696F6E4F62736572766572';
wwv_flow_imp.g_varchar2_table(4031) := '732E73657428652C6929293B636F6E7374206F3D5A6F286E293B6C657420733D692E676574286F293B6966287329732E75736572732B3D313B656C73657B636F6E737420723D6E65772043742C613D6E6577204D75746174696F6E4F6273657276657228';
wwv_flow_imp.g_varchar2_table(4032) := '28653D3E722E6669726528652929293B612E6F62736572766528652C6E293B636F6E7374206C3D733D7B75736572733A312C6F627365727665723A612C6F6E4469644D75746174653A722E6576656E747D3B742E616464287274282828293D3E7B6C2E75';
wwv_flow_imp.g_varchar2_table(4033) := '736572732D3D312C303D3D3D6C2E7573657273262628722E646973706F736528292C612E646973636F6E6E65637428292C6E756C6C3D3D697C7C692E64656C657465286F292C303D3D3D286E756C6C3D3D693F766F696420303A692E73697A6529262674';
wwv_flow_imp.g_varchar2_table(4034) := '6869732E6D75746174696F6E4F62736572766572732E64656C657465286529297D2929292C692E736574286F2C73297D72657475726E20732E6F6E4469644D75746174657D7D3B6C6574204A733D6E756C6C3B66756E6374696F6E20657228297B726574';
wwv_flow_imp.g_varchar2_table(4035) := '75726E204A737C7C284A733D59732829292C4A737D66756E6374696F6E2074722865297B76617220742C6E3B72657475726E286E756C6C3D3D3D28743D6E756C6C3D3D653F766F696420303A652E7368656574297C7C766F696420303D3D3D743F766F69';
wwv_flow_imp.g_varchar2_table(4036) := '6420303A742E72756C6573293F652E73686565742E72756C65733A286E756C6C3D3D3D286E3D6E756C6C3D3D653F766F696420303A652E7368656574297C7C766F696420303D3D3D6E3F766F696420303A6E2E63737352756C6573293F652E7368656574';
wwv_flow_imp.g_varchar2_table(4037) := '2E63737352756C65733A5B5D7D66756E6374696F6E206E7228652C742C6E3D65722829297B76617220692C6F3B6966286E262674297B6E756C6C3D3D3D28693D6E2E7368656574297C7C766F696420303D3D3D697C7C692E696E7365727452756C652860';
wwv_flow_imp.g_varchar2_table(4038) := '247B657D207B247B747D7D602C30293B666F7228636F6E73742069206F66206E756C6C213D3D286F3D4B732E676574286E29292626766F69642030213D3D6F3F6F3A5B5D296E7228652C742C69297D7D66756E6374696F6E20697228652C743D65722829';
wwv_flow_imp.g_varchar2_table(4039) := '297B766172206E2C693B69662821742972657475726E3B636F6E7374206F3D74722874292C733D5B5D3B666F72286C657420743D303B743C6F2E6C656E6774683B742B2B297B636F6E7374206E3D6F5B745D3B6F72286E2926262D31213D3D6E2E73656C';
wwv_flow_imp.g_varchar2_table(4040) := '6563746F72546578742E696E6465784F662865292626732E707573682874297D666F72286C657420653D732E6C656E6774682D313B653E3D303B652D2D296E756C6C3D3D3D286E3D742E7368656574297C7C766F696420303D3D3D6E7C7C6E2E64656C65';
wwv_flow_imp.g_varchar2_table(4041) := '746552756C6528735B655D293B666F7228636F6E7374206E206F66206E756C6C213D3D28693D4B732E676574287429292626766F69642030213D3D693F693A5B5D29697228652C6E297D66756E6374696F6E206F722865297B72657475726E2273747269';
wwv_flow_imp.g_varchar2_table(4042) := '6E67223D3D747970656F6620652E73656C6563746F72546578747D66756E6374696F6E2073722865297B72657475726E206520696E7374616E63656F66204D6F7573654576656E747C7C6520696E7374616E63656F662072732865292E4D6F7573654576';
wwv_flow_imp.g_varchar2_table(4043) := '656E747D66756E6374696F6E2072722865297B72657475726E206520696E7374616E63656F66204B6579626F6172644576656E747C7C6520696E7374616E63656F662072732865292E4B6579626F6172644576656E747D636F6E73742061723D7B434C49';
wwv_flow_imp.g_varchar2_table(4044) := '434B3A22636C69636B222C415558434C49434B3A22617578636C69636B222C44424C434C49434B3A2264626C636C69636B222C4D4F5553455F55503A226D6F7573657570222C4D4F5553455F444F574E3A226D6F757365646F776E222C4D4F5553455F4F';
wwv_flow_imp.g_varchar2_table(4045) := '5645523A226D6F7573656F766572222C4D4F5553455F4D4F56453A226D6F7573656D6F7665222C4D4F5553455F4F55543A226D6F7573656F7574222C4D4F5553455F454E5445523A226D6F757365656E746572222C4D4F5553455F4C454156453A226D6F';
wwv_flow_imp.g_varchar2_table(4046) := '7573656C65617665222C4D4F5553455F574845454C3A22776865656C222C504F494E5445525F55503A22706F696E7465727570222C504F494E5445525F444F574E3A22706F696E746572646F776E222C504F494E5445525F4D4F56453A22706F696E7465';
wwv_flow_imp.g_varchar2_table(4047) := '726D6F7665222C504F494E5445525F4C454156453A22706F696E7465726C65617665222C434F4E544558545F4D454E553A22636F6E746578746D656E75222C574845454C3A22776865656C222C4B45595F444F574E3A226B6579646F776E222C4B45595F';
wwv_flow_imp.g_varchar2_table(4048) := '50524553533A226B65797072657373222C4B45595F55503A226B65797570222C4C4F41443A226C6F6164222C4245464F52455F554E4C4F41443A226265666F7265756E6C6F6164222C554E4C4F41443A22756E6C6F6164222C504147455F53484F573A22';
wwv_flow_imp.g_varchar2_table(4049) := '7061676573686F77222C504147455F484944453A227061676568696465222C50415354453A227061737465222C41424F52543A2261626F7274222C4552524F523A226572726F72222C524553495A453A22726573697A65222C5343524F4C4C3A22736372';
wwv_flow_imp.g_varchar2_table(4050) := '6F6C6C222C46554C4C53435245454E5F4348414E47453A2266756C6C73637265656E6368616E6765222C574B5F46554C4C53435245454E5F4348414E47453A227765626B697466756C6C73637265656E6368616E6765222C53454C4543543A2273656C65';
wwv_flow_imp.g_varchar2_table(4051) := '6374222C4348414E47453A226368616E6765222C5355424D49543A227375626D6974222C52455345543A227265736574222C464F4355533A22666F637573222C464F4355535F494E3A22666F637573696E222C464F4355535F4F55543A22666F6375736F';
wwv_flow_imp.g_varchar2_table(4052) := '7574222C424C55523A22626C7572222C494E5055543A22696E707574222C53544F524147453A2273746F72616765222C445241475F53544152543A22647261677374617274222C445241473A2264726167222C445241475F454E5445523A226472616765';
wwv_flow_imp.g_varchar2_table(4053) := '6E746572222C445241475F4C454156453A22647261676C65617665222C445241475F4F5645523A22647261676F766572222C44524F503A2264726F70222C445241475F454E443A2264726167656E64222C414E494D4154494F4E5F53544152543A643F22';
wwv_flow_imp.g_varchar2_table(4054) := '7765626B6974416E696D6174696F6E5374617274223A22616E696D6174696F6E7374617274222C414E494D4154494F4E5F454E443A643F227765626B6974416E696D6174696F6E456E64223A22616E696D6174696F6E656E64222C414E494D4154494F4E';
wwv_flow_imp.g_varchar2_table(4055) := '5F495445524154494F4E3A643F227765626B6974416E696D6174696F6E497465726174696F6E223A22616E696D6174696F6E697465726174696F6E227D3B66756E6374696F6E206C722865297B636F6E737420743D653B72657475726E212821747C7C22';
wwv_flow_imp.g_varchar2_table(4056) := '66756E6374696F6E22213D747970656F6620742E70726576656E7444656661756C747C7C2266756E6374696F6E22213D747970656F6620742E73746F7050726F7061676174696F6E297D636F6E73742063723D28652C74293D3E28652E70726576656E74';
wwv_flow_imp.g_varchar2_table(4057) := '44656661756C7428292C742626652E73746F7050726F7061676174696F6E28292C65293B636C61737320647220657874656E6473206C747B73746174696320686173466F63757357697468696E2865297B6966286520696E7374616E63656F662048544D';
wwv_flow_imp.g_varchar2_table(4058) := '4C456C656D656E74297B636F6E737420743D57732865293B72657475726E20427328743F742E616374697665456C656D656E743A652E6F776E6572446F63756D656E742E616374697665456C656D656E742C65297D7B636F6E737420743D653B72657475';
wwv_flow_imp.g_varchar2_table(4059) := '726E20427328742E646F63756D656E742E616374697665456C656D656E742C742E646F63756D656E74297D7D636F6E7374727563746F722865297B737570657228292C746869732E5F6F6E446964466F6375733D746869732E5F7265676973746572286E';
wwv_flow_imp.g_varchar2_table(4060) := '6577204374292C746869732E6F6E446964466F6375733D746869732E5F6F6E446964466F6375732E6576656E742C746869732E5F6F6E446964426C75723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964426C75723D';
wwv_flow_imp.g_varchar2_table(4061) := '746869732E5F6F6E446964426C75722E6576656E743B6C657420743D64722E686173466F63757357697468696E2865292C6E3D21313B636F6E737420693D28293D3E7B6E3D21312C747C7C28743D21302C746869732E5F6F6E446964466F6375732E6669';
wwv_flow_imp.g_varchar2_table(4062) := '72652829297D2C6F3D28293D3E7B742626286E3D21302C286520696E7374616E63656F662048544D4C456C656D656E743F72732865293A65292E73657454696D656F7574282828293D3E7B6E2626286E3D21312C743D21312C746869732E5F6F6E446964';
wwv_flow_imp.g_varchar2_table(4063) := '426C75722E666972652829297D292C3029297D3B746869732E5F72656672657368537461746548616E646C65723D28293D3E7B64722E686173466F63757357697468696E286529213D3D74262628743F6F28293A692829297D2C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(4064) := '7374657228627328652C61722E464F4355532C692C213029292C746869732E5F726567697374657228627328652C61722E424C55522C6F2C213029292C6520696E7374616E63656F662048544D4C456C656D656E74262628746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(4065) := '657228627328652C61722E464F4355535F494E2C2828293D3E746869732E5F72656672657368537461746548616E646C657228292929292C746869732E5F726567697374657228627328652C61722E464F4355535F4F55542C2828293D3E746869732E5F';
wwv_flow_imp.g_varchar2_table(4066) := '72656672657368537461746548616E646C65722829292929297D7D66756E6374696F6E2068722865297B72657475726E206E65772064722865297D66756E6374696F6E20757228652C2E2E2E74297B696628652E617070656E64282E2E2E74292C313D3D';
wwv_flow_imp.g_varchar2_table(4067) := '3D742E6C656E677468262622737472696E6722213D747970656F6620745B305D2972657475726E20745B305D7D66756E6374696F6E20707228652C74297B72657475726E20652E696E736572744265666F726528742C652E66697273744368696C64292C';
wwv_flow_imp.g_varchar2_table(4068) := '747D66756E6374696F6E20677228652C2E2E2E74297B652E696E6E6572546578743D22222C757228652C2E2E2E74297D636F6E7374206D723D2F285B5C775C2D5D2B293F2823285B5C775C2D5D2B29293F28285C2E285B5C775C2D5D2B29292A292F3B76';
wwv_flow_imp.g_varchar2_table(4069) := '61722066723B66756E6374696F6E20767228652C742C6E2C2E2E2E69297B636F6E7374206F3D6D722E657865632874293B696628216F297468726F77206E6577204572726F72282242616420757365206F6620656D6D657422293B636F6E737420733D6F';
wwv_flow_imp.g_varchar2_table(4070) := '5B315D7C7C22646976223B6C657420723B72657475726E20723D65213D3D66722E48544D4C3F646F63756D656E742E637265617465456C656D656E744E5328652C73293A646F63756D656E742E637265617465456C656D656E742873292C6F5B335D2626';
wwv_flow_imp.g_varchar2_table(4071) := '28722E69643D6F5B335D292C6F5B345D262628722E636C6173734E616D653D6F5B345D2E7265706C616365282F5C2E2F672C222022292E7472696D2829292C6E26264F626A6563742E656E7472696573286E292E666F72456163682828285B652C745D29';
wwv_flow_imp.g_varchar2_table(4072) := '3D3E7B766F69642030213D3D742626282F5E6F6E5C772B242F2E746573742865293F725B655D3D743A2273656C6563746564223D3D3D653F742626722E73657441747472696275746528652C227472756522293A722E7365744174747269627574652865';
wwv_flow_imp.g_varchar2_table(4073) := '2C7429297D29292C722E617070656E64282E2E2E69292C727D66756E6374696F6E20627228652C742C2E2E2E6E297B72657475726E2076722866722E48544D4C2C652C742C2E2E2E6E297D66756E6374696F6E205F72282E2E2E65297B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(4074) := '73742074206F66206529742E7374796C652E646973706C61793D22222C742E72656D6F76654174747269627574652822617269612D68696464656E22297D66756E6374696F6E207972282E2E2E65297B666F7228636F6E73742074206F66206529742E73';
wwv_flow_imp.g_varchar2_table(4075) := '74796C652E646973706C61793D226E6F6E65222C742E7365744174747269627574652822617269612D68696464656E222C227472756522297D66756E6374696F6E20777228652C74297B636F6E7374206E3D652E646576696365506978656C526174696F';
wwv_flow_imp.g_varchar2_table(4076) := '2A743B72657475726E204D6174682E6D617828312C4D6174682E666C6F6F72286E29292F652E646576696365506978656C526174696F7D66756E6374696F6E2043722865297B732E6F70656E28652C225F626C616E6B222C226E6F6F70656E657222297D';
wwv_flow_imp.g_varchar2_table(4077) := '66756E6374696F6E2053722865297B72657475726E20653F6075726C2827247B516F2E757269546F42726F777365725572692865292E746F537472696E67282130292E7265706C616365282F272F672C2225323722297D2729603A2275726C2827272922';
wwv_flow_imp.g_varchar2_table(4078) := '7D66756E6374696F6E2078722865297B72657475726E6027247B652E7265706C616365282F272F672C2225323722297D27607D66756E6374696F6E206B7228652C74297B696628766F69642030213D3D65297B636F6E7374206E3D652E6D61746368282F';
wwv_flow_imp.g_varchar2_table(4079) := '5E5C732A7661725C28282E2B295C29242F293B6966286E297B636F6E737420653D6E5B315D2E73706C697428222C222C32293B72657475726E20323D3D3D652E6C656E677468262628743D6B7228655B315D2E7472696D28292C7429292C607661722824';
wwv_flow_imp.g_varchar2_table(4080) := '7B655B305D7D2C20247B747D29607D72657475726E20657D72657475726E20747D2166756E6374696F6E2865297B652E48544D4C3D22687474703A2F2F7777772E77332E6F72672F313939392F7868746D6C222C652E5356473D22687474703A2F2F7777';
wwv_flow_imp.g_varchar2_table(4081) := '772E77332E6F72672F323030302F737667227D2866727C7C2866723D7B7D29292C62722E5356473D66756E6374696F6E28652C742C2E2E2E6E297B72657475726E2076722866722E5356472C652C742C2E2E2E6E297D2C4B6F2E73657450726566657272';
wwv_flow_imp.g_varchar2_table(4082) := '6564576562536368656D61282F5E68747470733A2F2E7465737428732E6C6F636174696F6E2E68726566293F226874747073223A226874747022293B636F6E73742045723D4F626A6563742E667265657A65285B2261222C2261626272222C2262222C22';
wwv_flow_imp.g_varchar2_table(4083) := '62646F222C22626C6F636B71756F7465222C226272222C2263617074696F6E222C2263697465222C22636F6465222C22636F6C222C22636F6C67726F7570222C226464222C2264656C222C2264657461696C73222C2264666E222C22646976222C22646C';
wwv_flow_imp.g_varchar2_table(4084) := '222C226474222C22656D222C2266696763617074696F6E222C22666967757265222C226831222C226832222C226833222C226834222C226835222C226836222C226872222C2269222C22696D67222C22696E707574222C22696E73222C226B6264222C22';
wwv_flow_imp.g_varchar2_table(4085) := '6C6162656C222C226C69222C226D61726B222C226F6C222C2270222C22707265222C2271222C227270222C227274222C2272756279222C2273616D70222C22736D616C6C222C22736D616C6C222C22736F75726365222C227370616E222C22737472696B';
wwv_flow_imp.g_varchar2_table(4086) := '65222C227374726F6E67222C22737562222C2273756D6D617279222C22737570222C227461626C65222C2274626F6479222C227464222C2274666F6F74222C227468222C227468656164222C2274696D65222C227472222C227474222C2275222C22756C';
wwv_flow_imp.g_varchar2_table(4087) := '222C22766172222C22766964656F222C22776272225D293B4F626A6563742E667265657A65287B414C4C4F5745445F544147533A5B2261222C22627574746F6E222C22626C6F636B71756F7465222C22636F6465222C22646976222C226831222C226832';
wwv_flow_imp.g_varchar2_table(4088) := '222C226833222C226834222C226835222C226836222C226872222C22696E707574222C226C6162656C222C226C69222C2270222C22707265222C2273656C656374222C22736D616C6C222C227370616E222C227374726F6E67222C227465787461726561';
wwv_flow_imp.g_varchar2_table(4089) := '222C22756C222C226F6C225D2C414C4C4F5745445F415454523A5B2268726566222C22646174612D68726566222C22646174612D636F6D6D616E64222C22746172676574222C227469746C65222C226E616D65222C22737263222C22616C74222C22636C';
wwv_flow_imp.g_varchar2_table(4090) := '617373222C226964222C22726F6C65222C22746162696E646578222C227374796C65222C22646174612D636F6465222C227769647468222C22686569676874222C22616C69676E222C22782D6469737061746368222C227265717569726564222C226368';
wwv_flow_imp.g_varchar2_table(4091) := '65636B6564222C22706C616365686F6C646572222C2274797065222C227374617274225D2C52455455524E5F444F4D3A21312C52455455524E5F444F4D5F465241474D454E543A21312C52455455524E5F545255535445445F545950453A21307D293B63';
wwv_flow_imp.g_varchar2_table(4092) := '6C617373204C7220657874656E64732043747B636F6E7374727563746F7228297B737570657228292C746869732E5F737562736372697074696F6E733D6E65772061742C746869732E5F6B65795374617475733D7B616C744B65793A21312C7368696674';
wwv_flow_imp.g_varchar2_table(4093) := '4B65793A21312C6374726C4B65793A21312C6D6574614B65793A21317D2C746869732E5F737562736372697074696F6E732E6164642876742E72756E416E645375627363726962652870732C28287B77696E646F773A652C646973706F7361626C65733A';
wwv_flow_imp.g_varchar2_table(4094) := '747D293D3E746869732E72656769737465724C697374656E65727328652C7429292C7B77696E646F773A732C646973706F7361626C65733A746869732E5F737562736372697074696F6E737D29297D72656769737465724C697374656E65727328652C74';
wwv_flow_imp.g_varchar2_table(4095) := '297B742E61646428627328652C226B6579646F776E222C28653D3E7B696628652E64656661756C7450726576656E7465642972657475726E3B636F6E737420743D6E65772071652865293B69662836213D3D742E6B6579436F64657C7C21652E72657065';
wwv_flow_imp.g_varchar2_table(4096) := '6174297B696628652E616C744B6579262621746869732E5F6B65795374617475732E616C744B657929746869732E5F6B65795374617475732E6C6173744B6579507265737365643D22616C74223B656C736520696628652E6374726C4B65792626217468';
wwv_flow_imp.g_varchar2_table(4097) := '69732E5F6B65795374617475732E6374726C4B657929746869732E5F6B65795374617475732E6C6173744B6579507265737365643D226374726C223B656C736520696628652E6D6574614B6579262621746869732E5F6B65795374617475732E6D657461';
wwv_flow_imp.g_varchar2_table(4098) := '4B657929746869732E5F6B65795374617475732E6C6173744B6579507265737365643D226D657461223B656C736520696628652E73686966744B6579262621746869732E5F6B65795374617475732E73686966744B657929746869732E5F6B6579537461';
wwv_flow_imp.g_varchar2_table(4099) := '7475732E6C6173744B6579507265737365643D227368696674223B656C73657B696628363D3D3D742E6B6579436F64652972657475726E3B746869732E5F6B65795374617475732E6C6173744B6579507265737365643D766F696420307D746869732E5F';
wwv_flow_imp.g_varchar2_table(4100) := '6B65795374617475732E616C744B65793D652E616C744B65792C746869732E5F6B65795374617475732E6374726C4B65793D652E6374726C4B65792C746869732E5F6B65795374617475732E6D6574614B65793D652E6D6574614B65792C746869732E5F';
wwv_flow_imp.g_varchar2_table(4101) := '6B65795374617475732E73686966744B65793D652E73686966744B65792C746869732E5F6B65795374617475732E6C6173744B657950726573736564262628746869732E5F6B65795374617475732E6576656E743D652C746869732E6669726528746869';
wwv_flow_imp.g_varchar2_table(4102) := '732E5F6B657953746174757329297D7D292C213029292C742E61646428627328652C226B65797570222C28653D3E7B652E64656661756C7450726576656E7465647C7C2821652E616C744B65792626746869732E5F6B65795374617475732E616C744B65';
wwv_flow_imp.g_varchar2_table(4103) := '793F746869732E5F6B65795374617475732E6C6173744B657952656C65617365643D22616C74223A21652E6374726C4B65792626746869732E5F6B65795374617475732E6374726C4B65793F746869732E5F6B65795374617475732E6C6173744B657952';
wwv_flow_imp.g_varchar2_table(4104) := '656C65617365643D226374726C223A21652E6D6574614B65792626746869732E5F6B65795374617475732E6D6574614B65793F746869732E5F6B65795374617475732E6C6173744B657952656C65617365643D226D657461223A21652E73686966744B65';
wwv_flow_imp.g_varchar2_table(4105) := '792626746869732E5F6B65795374617475732E73686966744B65793F746869732E5F6B65795374617475732E6C6173744B657952656C65617365643D227368696674223A746869732E5F6B65795374617475732E6C6173744B657952656C65617365643D';
wwv_flow_imp.g_varchar2_table(4106) := '766F696420302C746869732E5F6B65795374617475732E6C6173744B657950726573736564213D3D746869732E5F6B65795374617475732E6C6173744B657952656C6561736564262628746869732E5F6B65795374617475732E6C6173744B6579507265';
wwv_flow_imp.g_varchar2_table(4107) := '737365643D766F69642030292C746869732E5F6B65795374617475732E616C744B65793D652E616C744B65792C746869732E5F6B65795374617475732E6374726C4B65793D652E6374726C4B65792C746869732E5F6B65795374617475732E6D6574614B';
wwv_flow_imp.g_varchar2_table(4108) := '65793D652E6D6574614B65792C746869732E5F6B65795374617475732E73686966744B65793D652E73686966744B65792C746869732E5F6B65795374617475732E6C6173744B657952656C6561736564262628746869732E5F6B65795374617475732E65';
wwv_flow_imp.g_varchar2_table(4109) := '76656E743D652C746869732E6669726528746869732E5F6B65795374617475732929297D292C213029292C742E61646428627328652E646F63756D656E742E626F64792C226D6F757365646F776E222C2828293D3E7B746869732E5F6B65795374617475';
wwv_flow_imp.g_varchar2_table(4110) := '732E6C6173744B6579507265737365643D766F696420307D292C213029292C742E61646428627328652E646F63756D656E742E626F64792C226D6F7573657570222C2828293D3E7B746869732E5F6B65795374617475732E6C6173744B65795072657373';
wwv_flow_imp.g_varchar2_table(4111) := '65643D766F696420307D292C213029292C742E61646428627328652E646F63756D656E742E626F64792C226D6F7573656D6F7665222C28653D3E7B652E627574746F6E73262628746869732E5F6B65795374617475732E6C6173744B6579507265737365';
wwv_flow_imp.g_varchar2_table(4112) := '643D766F69642030297D292C213029292C742E61646428627328652C22626C7572222C2828293D3E7B746869732E72657365744B657953746174757328297D2929297D676574206B657953746174757328297B72657475726E20746869732E5F6B657953';
wwv_flow_imp.g_varchar2_table(4113) := '74617475737D72657365744B657953746174757328297B746869732E646F52657365744B657953746174757328292C746869732E6669726528746869732E5F6B6579537461747573297D646F52657365744B657953746174757328297B746869732E5F6B';
wwv_flow_imp.g_varchar2_table(4114) := '65795374617475733D7B616C744B65793A21312C73686966744B65793A21312C6374726C4B65793A21312C6D6574614B65793A21317D7D73746174696320676574496E7374616E636528297B72657475726E204C722E696E7374616E63657C7C284C722E';
wwv_flow_imp.g_varchar2_table(4115) := '696E7374616E63653D6E6577204C72292C4C722E696E7374616E63657D646973706F736528297B73757065722E646973706F736528292C746869732E5F737562736372697074696F6E732E646973706F736528297D7D636C61737320447220657874656E';
wwv_flow_imp.g_varchar2_table(4116) := '6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E656C656D656E743D652C746869732E63616C6C6261636B733D742C746869732E636F756E7465723D302C746869732E64726167537461727454696D653D302C74';
wwv_flow_imp.g_varchar2_table(4117) := '6869732E72656769737465724C697374656E65727328297D72656769737465724C697374656E65727328297B746869732E63616C6C6261636B732E6F6E4472616753746172742626746869732E5F726567697374657228627328746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(4118) := '6E742C61722E445241475F53544152542C28653D3E7B76617220742C6E3B6E756C6C3D3D3D286E3D28743D746869732E63616C6C6261636B73292E6F6E447261675374617274297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D292929';
wwv_flow_imp.g_varchar2_table(4119) := '2C746869732E63616C6C6261636B732E6F6E447261672626746869732E5F726567697374657228627328746869732E656C656D656E742C61722E445241472C28653D3E7B76617220742C6E3B6E756C6C3D3D3D286E3D28743D746869732E63616C6C6261';
wwv_flow_imp.g_varchar2_table(4120) := '636B73292E6F6E44726167297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D2929292C746869732E5F726567697374657228627328746869732E656C656D656E742C61722E445241475F454E5445522C28653D3E7B76617220742C6E3B';
wwv_flow_imp.g_varchar2_table(4121) := '746869732E636F756E7465722B2B2C746869732E64726167537461727454696D653D652E74696D655374616D702C6E756C6C3D3D3D286E3D28743D746869732E63616C6C6261636B73292E6F6E44726167456E746572297C7C766F696420303D3D3D6E7C';
wwv_flow_imp.g_varchar2_table(4122) := '7C6E2E63616C6C28742C65297D2929292C746869732E5F726567697374657228627328746869732E656C656D656E742C61722E445241475F4F5645522C28653D3E7B76617220742C6E3B652E70726576656E7444656661756C7428292C6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(4123) := '286E3D28743D746869732E63616C6C6261636B73292E6F6E447261674F766572297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C652C652E74696D655374616D702D746869732E64726167537461727454696D65297D2929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(4124) := '726567697374657228627328746869732E656C656D656E742C61722E445241475F4C454156452C28653D3E7B76617220742C6E3B746869732E636F756E7465722D2D2C303D3D3D746869732E636F756E746572262628746869732E647261675374617274';
wwv_flow_imp.g_varchar2_table(4125) := '54696D653D302C6E756C6C3D3D3D286E3D28743D746869732E63616C6C6261636B73292E6F6E447261674C65617665297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C6529297D2929292C746869732E5F726567697374657228627328746869';
wwv_flow_imp.g_varchar2_table(4126) := '732E656C656D656E742C61722E445241475F454E442C28653D3E7B76617220742C6E3B746869732E636F756E7465723D302C746869732E64726167537461727454696D653D302C6E756C6C3D3D3D286E3D28743D746869732E63616C6C6261636B73292E';
wwv_flow_imp.g_varchar2_table(4127) := '6F6E44726167456E64297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D2929292C746869732E5F726567697374657228627328746869732E656C656D656E742C61722E44524F502C28653D3E7B76617220742C6E3B746869732E636F75';
wwv_flow_imp.g_varchar2_table(4128) := '6E7465723D302C746869732E64726167537461727454696D653D302C6E756C6C3D3D3D286E3D28743D746869732E63616C6C6261636B73292E6F6E44726F70297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D2929297D7D636F6E7374';
wwv_flow_imp.g_varchar2_table(4129) := '2054723D2F283F3C7461673E5B5C775C2D5D2B293F283F3A23283F3C69643E5B5C775C2D5D2B29293F283F3C636C6173733E283F3A5C2E283F3A5B5C775C2D5D2B29292A29283F3A40283F3C6E616D653E283F3A5B5C775C5F5D292B29293F2F3B66756E';
wwv_flow_imp.g_varchar2_table(4130) := '6374696F6E20497228652C2E2E2E74297B6C6574206E2C693B41727261792E6973417272617928745B305D293F286E3D7B7D2C693D745B305D293A286E3D745B305D7C7C7B7D2C693D745B315D293B636F6E7374206F3D54722E657865632865293B6966';
wwv_flow_imp.g_varchar2_table(4131) := '28216F7C7C216F2E67726F757073297468726F77206E6577204572726F72282242616420757365206F66206822293B636F6E737420733D6F2E67726F7570732E7461677C7C22646976222C723D646F63756D656E742E637265617465456C656D656E7428';
wwv_flow_imp.g_varchar2_table(4132) := '73293B6F2E67726F7570732E6964262628722E69643D6F2E67726F7570732E6964293B636F6E737420613D5B5D3B6966286F2E67726F7570732E636C61737329666F7228636F6E73742065206F66206F2E67726F7570732E636C6173732E73706C697428';
wwv_flow_imp.g_varchar2_table(4133) := '222E2229292222213D3D652626612E707573682865293B696628766F69642030213D3D6E2E636C6173734E616D6529666F7228636F6E73742065206F66206E2E636C6173734E616D652E73706C697428222E2229292222213D3D652626612E7075736828';
wwv_flow_imp.g_varchar2_table(4134) := '65293B612E6C656E6774683E30262628722E636C6173734E616D653D612E6A6F696E2822202229293B636F6E7374206C3D7B7D3B6966286F2E67726F7570732E6E616D652626286C5B6F2E67726F7570732E6E616D655D3D72292C6929666F7228636F6E';
wwv_flow_imp.g_varchar2_table(4135) := '73742065206F662069296520696E7374616E63656F662048544D4C456C656D656E743F722E617070656E644368696C642865293A22737472696E67223D3D747970656F6620653F722E617070656E642865293A22726F6F7422696E20652626284F626A65';
wwv_flow_imp.g_varchar2_table(4136) := '63742E61737369676E286C2C65292C722E617070656E644368696C6428652E726F6F7429293B666F7228636F6E73745B652C745D6F66204F626A6563742E656E7472696573286E292969662822636C6173734E616D6522213D3D6529696628227374796C';
wwv_flow_imp.g_varchar2_table(4137) := '65223D3D3D6529666F7228636F6E73745B652C6E5D6F66204F626A6563742E656E747269657328742929722E7374796C652E73657450726F7065727479284D722865292C226E756D626572223D3D747970656F66206E3F6E2B227078223A22222B6E293B';
wwv_flow_imp.g_varchar2_table(4138) := '656C736522746162496E646578223D3D3D653F722E746162496E6465783D743A722E736574417474726962757465284D722865292C742E746F537472696E672829293B72657475726E206C2E726F6F743D722C6C7D66756E6374696F6E204D722865297B';
wwv_flow_imp.g_varchar2_table(4139) := '72657475726E20652E7265706C616365282F285B612D7A5D29285B412D5A5D292F672C2224312D243222292E746F4C6F7765724361736528297D7661722041723D6E2835303732292C4E723D6E2E6E284172292C50723D6E2837383235292C4F723D6E2E';
wwv_flow_imp.g_varchar2_table(4140) := '6E285072292C52723D6E2837363539292C46723D6E2E6E285272292C42723D6E2835303536292C56723D6E2E6E284272292C7A723D6E28353430292C48723D6E2E6E287A72292C57723D6E2831313133292C6A723D6E2E6E285772292C71723D6E283530';
wwv_flow_imp.g_varchar2_table(4141) := '3338292C24723D7B7D3B24722E7374796C655461675472616E73666F726D3D6A7228292C24722E736574417474726962757465733D567228292C24722E696E736572743D467228292E62696E64286E756C6C2C226865616422292C24722E646F6D415049';
wwv_flow_imp.g_varchar2_table(4142) := '3D4F7228292C24722E696E736572745374796C65456C656D656E743D487228292C4E7228292871722E412C2472292C71722E41262671722E412E6C6F63616C73262671722E412E6C6F63616C733B636F6E73742055723D3265343B6C6574204B722C4772';
wwv_flow_imp.g_varchar2_table(4143) := '2C51722C59722C5A723B66756E6374696F6E2058722865297B4B7226262847722E74657874436F6E74656E74213D3D653F286673285172292C65612847722C6529293A286673284772292C65612851722C652929297D66756E6374696F6E204A72286529';
wwv_flow_imp.g_varchar2_table(4144) := '7B4B7226262859722E74657874436F6E74656E74213D3D653F286673285A72292C65612859722C6529293A286673285972292C6561285A722C652929297D66756E6374696F6E20656128652C74297B66732865292C742E6C656E6774683E557226262874';
wwv_flow_imp.g_varchar2_table(4145) := '3D742E73756273747228302C557229292C652E74657874436F6E74656E743D742C652E7374796C652E7669736962696C6974793D2268696464656E222C652E7374796C652E7669736962696C6974793D2276697369626C65227D7661722074612C6E613B';
wwv_flow_imp.g_varchar2_table(4146) := '636C6173732069617B636F6E7374727563746F7228652C74297B746869732E7572693D652C746869732E76616C75653D747D7D636C617373206F617B636F6E7374727563746F7228652C74297B696628746869735B74615D3D225265736F757263654D61';
wwv_flow_imp.g_varchar2_table(4147) := '70222C6520696E7374616E63656F66206F6129746869732E6D61703D6E6577204D617028652E6D6170292C746869732E746F4B65793D6E756C6C213D743F743A6F612E64656661756C74546F4B65793B656C73652069662866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(4148) := '72657475726E2041727261792E697341727261792865297D286529297B746869732E6D61703D6E6577204D61702C746869732E746F4B65793D6E756C6C213D743F743A6F612E64656661756C74546F4B65793B666F7228636F6E73745B742C6E5D6F6620';
wwv_flow_imp.g_varchar2_table(4149) := '6529746869732E73657428742C6E297D656C736520746869732E6D61703D6E6577204D61702C746869732E746F4B65793D6E756C6C213D653F653A6F612E64656661756C74546F4B65797D73657428652C74297B72657475726E20746869732E6D61702E';
wwv_flow_imp.g_varchar2_table(4150) := '73657428746869732E746F4B65792865292C6E657720696128652C7429292C746869737D6765742865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E6D61702E67657428746869732E746F4B657928652929297C7C766F6964';
wwv_flow_imp.g_varchar2_table(4151) := '20303D3D3D743F766F696420303A742E76616C75657D6861732865297B72657475726E20746869732E6D61702E68617328746869732E746F4B6579286529297D6765742073697A6528297B72657475726E20746869732E6D61702E73697A657D636C6561';
wwv_flow_imp.g_varchar2_table(4152) := '7228297B746869732E6D61702E636C65617228297D64656C6574652865297B72657475726E20746869732E6D61702E64656C65746528746869732E746F4B6579286529297D666F724561636828652C74297B766F69642030213D3D74262628653D652E62';
wwv_flow_imp.g_varchar2_table(4153) := '696E64287429293B666F7228636F6E73745B742C6E5D6F6620746869732E6D61702965286E2E76616C75652C6E2E7572692C74686973297D2A76616C75657328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C75657328292979';
wwv_flow_imp.g_varchar2_table(4154) := '69656C6420652E76616C75657D2A6B65797328297B666F7228636F6E73742065206F6620746869732E6D61702E76616C7565732829297969656C6420652E7572697D2A656E747269657328297B666F7228636F6E73742065206F6620746869732E6D6170';
wwv_flow_imp.g_varchar2_table(4155) := '2E76616C7565732829297969656C645B652E7572692C652E76616C75655D7D2A5B2874613D53796D626F6C2E746F537472696E675461672C53796D626F6C2E6974657261746F72295D28297B666F7228636F6E73745B2C655D6F6620746869732E6D6170';
wwv_flow_imp.g_varchar2_table(4156) := '297969656C645B652E7572692C652E76616C75655D7D7D6F612E64656661756C74546F4B65793D653D3E652E746F537472696E6728293B636C6173732073617B636F6E7374727563746F7228297B746869735B6E615D3D224C696E6B65644D6170222C74';
wwv_flow_imp.g_varchar2_table(4157) := '6869732E5F6D61703D6E6577204D61702C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F73697A653D302C746869732E5F73746174653D307D636C65617228297B746869732E5F6D61702E636C';
wwv_flow_imp.g_varchar2_table(4158) := '65617228292C746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F696420302C746869732E5F73697A653D302C746869732E5F73746174652B2B7D6973456D70747928297B72657475726E21746869732E5F6865616426262174';
wwv_flow_imp.g_varchar2_table(4159) := '6869732E5F7461696C7D6765742073697A6528297B72657475726E20746869732E5F73697A657D67657420666972737428297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F68656164297C7C766F696420303D3D3D653F766F';
wwv_flow_imp.g_varchar2_table(4160) := '696420303A652E76616C75657D676574206C61737428297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F7461696C297C7C766F696420303D3D3D653F766F696420303A652E76616C75657D6861732865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(4161) := '746869732E5F6D61702E6861732865297D67657428652C743D30297B636F6E7374206E3D746869732E5F6D61702E6765742865293B6966286E2972657475726E2030213D3D742626746869732E746F756368286E2C74292C6E2E76616C75657D73657428';
wwv_flow_imp.g_varchar2_table(4162) := '652C742C6E3D30297B6C657420693D746869732E5F6D61702E6765742865293B6966286929692E76616C75653D742C30213D3D6E2626746869732E746F75636828692C6E293B656C73657B73776974636828693D7B6B65793A652C76616C75653A742C6E';
wwv_flow_imp.g_varchar2_table(4163) := '6578743A766F696420302C70726576696F75733A766F696420307D2C6E297B6361736520303A6361736520323A64656661756C743A746869732E6164644974656D4C6173742869293B627265616B3B6361736520313A746869732E6164644974656D4669';
wwv_flow_imp.g_varchar2_table(4164) := '7273742869297D746869732E5F6D61702E73657428652C69292C746869732E5F73697A652B2B7D72657475726E20746869737D64656C6574652865297B72657475726E2121746869732E72656D6F76652865297D72656D6F76652865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(4165) := '743D746869732E5F6D61702E6765742865293B696628742972657475726E20746869732E5F6D61702E64656C6574652865292C746869732E72656D6F76654974656D2874292C746869732E5F73697A652D2D2C742E76616C75657D736869667428297B69';
wwv_flow_imp.g_varchar2_table(4166) := '662821746869732E5F68656164262621746869732E5F7461696C2972657475726E3B69662821746869732E5F686561647C7C21746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B636F6E737420';
wwv_flow_imp.g_varchar2_table(4167) := '653D746869732E5F686561643B72657475726E20746869732E5F6D61702E64656C65746528652E6B6579292C746869732E72656D6F76654974656D2865292C746869732E5F73697A652D2D2C652E76616C75657D666F724561636828652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(4168) := '7374206E3D746869732E5F73746174653B6C657420693D746869732E5F686561643B666F72283B693B297B696628743F652E62696E6428742928692E76616C75652C692E6B65792C74686973293A6528692E76616C75652C692E6B65792C74686973292C';
wwv_flow_imp.g_varchar2_table(4169) := '746869732E5F7374617465213D3D6E297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B693D692E6E6578747D7D6B65797328297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(4170) := '3D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E';
wwv_flow_imp.g_varchar2_table(4171) := '6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E6B65792C646F6E653A21317D3B72657475726E206E3D6E2E';
wwv_flow_imp.g_varchar2_table(4172) := '6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D76616C75657328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B';
wwv_flow_imp.g_varchar2_table(4173) := '636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F6469666965642064757269';
wwv_flow_imp.g_varchar2_table(4174) := '6E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C75653A6E2E76616C75652C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D';
wwv_flow_imp.g_varchar2_table(4175) := '7D7D3B72657475726E20697D656E747269657328297B636F6E737420653D746869732C743D746869732E5F73746174653B6C6574206E3D746869732E5F686561643B636F6E737420693D7B5B53796D626F6C2E6974657261746F725D3A28293D3E692C6E';
wwv_flow_imp.g_varchar2_table(4176) := '65787428297B696628652E5F7374617465213D3D74297468726F77206E6577204572726F7228224C696E6B65644D617020676F74206D6F64696669656420647572696E6720697465726174696F6E2E22293B6966286E297B636F6E737420653D7B76616C';
wwv_flow_imp.g_varchar2_table(4177) := '75653A5B6E2E6B65792C6E2E76616C75655D2C646F6E653A21317D3B72657475726E206E3D6E2E6E6578742C657D72657475726E7B76616C75653A766F696420302C646F6E653A21307D7D7D3B72657475726E20697D5B286E613D53796D626F6C2E746F';
wwv_flow_imp.g_varchar2_table(4178) := '537472696E675461672C53796D626F6C2E6974657261746F72295D28297B72657475726E20746869732E656E747269657328297D7472696D4F6C642865297B696628653E3D746869732E73697A652972657475726E3B696628303D3D3D65297265747572';
wwv_flow_imp.g_varchar2_table(4179) := '6E20766F696420746869732E636C65617228293B6C657420743D746869732E5F686561642C6E3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D61702E64656C65746528742E6B6579292C743D742E6E6578742C6E2D2D3B74';
wwv_flow_imp.g_varchar2_table(4180) := '6869732E5F686561643D742C746869732E5F73697A653D6E2C74262628742E70726576696F75733D766F69642030292C746869732E5F73746174652B2B7D7472696D4E65772865297B696628653E3D746869732E73697A652972657475726E3B69662830';
wwv_flow_imp.g_varchar2_table(4181) := '3D3D3D652972657475726E20766F696420746869732E636C65617228293B6C657420743D746869732E5F7461696C2C6E3D746869732E73697A653B666F72283B7426266E3E653B29746869732E5F6D61702E64656C65746528742E6B6579292C743D742E';
wwv_flow_imp.g_varchar2_table(4182) := '70726576696F75732C6E2D2D3B746869732E5F7461696C3D742C746869732E5F73697A653D6E2C74262628742E6E6578743D766F69642030292C746869732E5F73746174652B2B7D6164644974656D46697273742865297B696628746869732E5F686561';
wwv_flow_imp.g_varchar2_table(4183) := '647C7C746869732E5F7461696C297B69662821746869732E5F68656164297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E6E6578743D746869732E5F686561642C746869732E5F686561642E70726576696F75733D';
wwv_flow_imp.g_varchar2_table(4184) := '657D656C736520746869732E5F7461696C3D653B746869732E5F686561643D652C746869732E5F73746174652B2B7D6164644974656D4C6173742865297B696628746869732E5F686561647C7C746869732E5F7461696C297B69662821746869732E5F74';
wwv_flow_imp.g_varchar2_table(4185) := '61696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E70726576696F75733D746869732E5F7461696C2C746869732E5F7461696C2E6E6578743D657D656C736520746869732E5F686561643D653B746869732E5F';
wwv_flow_imp.g_varchar2_table(4186) := '7461696C3D652C746869732E5F73746174652B2B7D72656D6F76654974656D2865297B696628653D3D3D746869732E5F686561642626653D3D3D746869732E5F7461696C29746869732E5F686561643D766F696420302C746869732E5F7461696C3D766F';
wwv_flow_imp.g_varchar2_table(4187) := '696420303B656C736520696628653D3D3D746869732E5F68656164297B69662821652E6E657874297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E6E6578742E70726576696F75733D766F696420302C746869732E';
wwv_flow_imp.g_varchar2_table(4188) := '5F686561643D652E6E6578747D656C736520696628653D3D3D746869732E5F7461696C297B69662821652E70726576696F7573297468726F77206E6577204572726F722822496E76616C6964206C69737422293B652E70726576696F75732E6E6578743D';
wwv_flow_imp.g_varchar2_table(4189) := '766F696420302C746869732E5F7461696C3D652E70726576696F75737D656C73657B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B69662821747C7C216E297468726F77206E6577204572726F722822496E76616C6964206C6973';
wwv_flow_imp.g_varchar2_table(4190) := '7422293B742E70726576696F75733D6E2C6E2E6E6578743D747D652E6E6578743D766F696420302C652E70726576696F75733D766F696420302C746869732E5F73746174652B2B7D746F75636828652C74297B69662821746869732E5F686561647C7C21';
wwv_flow_imp.g_varchar2_table(4191) := '746869732E5F7461696C297468726F77206E6577204572726F722822496E76616C6964206C69737422293B696628313D3D3D747C7C323D3D3D7429696628313D3D3D74297B696628653D3D3D746869732E5F686561642972657475726E3B636F6E737420';
wwv_flow_imp.g_varchar2_table(4192) := '743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F7461696C3F286E2E6E6578743D766F696420302C746869732E5F7461696C3D6E293A28742E70726576696F75733D6E2C6E2E6E6578743D74292C652E70726576696F7573';
wwv_flow_imp.g_varchar2_table(4193) := '3D766F696420302C652E6E6578743D746869732E5F686561642C746869732E5F686561642E70726576696F75733D652C746869732E5F686561643D652C746869732E5F73746174652B2B7D656C736520696628323D3D3D74297B696628653D3D3D746869';
wwv_flow_imp.g_varchar2_table(4194) := '732E5F7461696C2972657475726E3B636F6E737420743D652E6E6578742C6E3D652E70726576696F75733B653D3D3D746869732E5F686561643F28742E70726576696F75733D766F696420302C746869732E5F686561643D74293A28742E70726576696F';
wwv_flow_imp.g_varchar2_table(4195) := '75733D6E2C6E2E6E6578743D74292C652E6E6578743D766F696420302C652E70726576696F75733D746869732E5F7461696C2C746869732E5F7461696C2E6E6578743D652C746869732E5F7461696C3D652C746869732E5F73746174652B2B7D7D746F4A';
wwv_flow_imp.g_varchar2_table(4196) := '534F4E28297B636F6E737420653D5B5D3B72657475726E20746869732E666F7245616368282828742C6E293D3E7B652E70757368285B6E2C745D297D29292C657D66726F6D4A534F4E2865297B746869732E636C65617228293B666F7228636F6E73745B';
wwv_flow_imp.g_varchar2_table(4197) := '742C6E5D6F66206529746869732E73657428742C6E297D7D636C61737320726120657874656E64732073617B636F6E7374727563746F7228652C743D31297B737570657228292C746869732E5F6C696D69743D652C746869732E5F726174696F3D4D6174';
wwv_flow_imp.g_varchar2_table(4198) := '682E6D696E284D6174682E6D617828302C74292C31297D676574206C696D697428297B72657475726E20746869732E5F6C696D69747D736574206C696D69742865297B746869732E5F6C696D69743D652C746869732E636865636B5472696D28297D6765';
wwv_flow_imp.g_varchar2_table(4199) := '7428652C743D32297B72657475726E2073757065722E67657428652C74297D7065656B2865297B72657475726E2073757065722E67657428652C30297D73657428652C74297B72657475726E2073757065722E73657428652C742C32292C746869737D63';
wwv_flow_imp.g_varchar2_table(4200) := '6865636B5472696D28297B746869732E73697A653E746869732E5F6C696D69742626746869732E7472696D284D6174682E726F756E6428746869732E5F6C696D69742A746869732E5F726174696F29297D7D636C61737320616120657874656E64732072';
wwv_flow_imp.g_varchar2_table(4201) := '617B636F6E7374727563746F7228652C743D31297B737570657228652C74297D7472696D2865297B746869732E7472696D4F6C642865297D73657428652C74297B72657475726E2073757065722E73657428652C74292C746869732E636865636B547269';
wwv_flow_imp.g_varchar2_table(4202) := '6D28292C746869737D7D636C617373206C617B636F6E7374727563746F722865297B696628746869732E5F6D313D6E6577204D61702C746869732E5F6D323D6E6577204D61702C6529666F7228636F6E73745B742C6E5D6F66206529746869732E736574';
wwv_flow_imp.g_varchar2_table(4203) := '28742C6E297D636C65617228297B746869732E5F6D312E636C65617228292C746869732E5F6D322E636C65617228297D73657428652C74297B746869732E5F6D312E73657428652C74292C746869732E5F6D322E73657428742C65297D6765742865297B';
wwv_flow_imp.g_varchar2_table(4204) := '72657475726E20746869732E5F6D312E6765742865297D6765744B65792865297B72657475726E20746869732E5F6D322E6765742865297D64656C6574652865297B636F6E737420743D746869732E5F6D312E6765742865293B72657475726E20766F69';
wwv_flow_imp.g_varchar2_table(4205) := '642030213D3D74262628746869732E5F6D312E64656C6574652865292C746869732E5F6D322E64656C6574652874292C2130297D6B65797328297B72657475726E20746869732E5F6D312E6B65797328297D76616C75657328297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(4206) := '69732E5F6D312E76616C75657328297D7D636C6173732063617B636F6E7374727563746F7228297B746869732E6D61703D6E6577204D61707D61646428652C74297B6C6574206E3D746869732E6D61702E6765742865293B6E7C7C286E3D6E6577205365';
wwv_flow_imp.g_varchar2_table(4207) := '742C746869732E6D61702E73657428652C6E29292C6E2E6164642874297D64656C65746528652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E2626286E2E64656C6574652874292C303D3D3D6E2E73697A652626746869732E6D';
wwv_flow_imp.g_varchar2_table(4208) := '61702E64656C657465286529297D666F724561636828652C74297B636F6E7374206E3D746869732E6D61702E6765742865293B6E26266E2E666F72456163682874297D6765742865297B72657475726E20746869732E6D61702E6765742865297C7C6E65';
wwv_flow_imp.g_varchar2_table(4209) := '77205365747D7D6C65742064613D303B636F6E73742068613D6E65772055696E7433324172726179283130293B66756E6374696F6E20756128652C742C6E297B76617220693B653E3D6E2626653C6E2B742E6C656E67746826262830213D3D28693D745B';
wwv_flow_imp.g_varchar2_table(4210) := '652D6E5D2926262868615B64612B2B5D3D32353526692C693E3E3826262868615B64612B2B5D3D693E3E3826323535292C693E3E313626262868615B64612B2B5D3D693E3E3136263235352929297D636F6E73742070613D6E65772055696E7438417272';
wwv_flow_imp.g_varchar2_table(4211) := '6179285B3131342C38322C3131352C3130312C36392C3130322C39372C3131332C38312C3131362C38342C3130302C3131392C38372C39392C3132322C3132302C3131382C3130335D292C67613D6E65772055696E7431364172726179285B3130372C31';
wwv_flow_imp.g_varchar2_table(4212) := '31312C3130352C37392C3130362C3131322C3131372C38302C3130342C32373439362C32383532302C32373735322C3132312C3131302C32373234362C32383738322C32373735382C39382C3130392C32373735372C3130385D292C6D613D6E65772055';
wwv_flow_imp.g_varchar2_table(4213) := '696E7431364172726179285B3131342C38322C32393831302C3131352C33303537392C32363438332C3130312C3130322C32393238362C32343933342C32393033302C32393739382C33303832322C33303331302C32363437302C39372C3131332C3239';
wwv_flow_imp.g_varchar2_table(4214) := '3830392C3131362C38342C3130302C3131392C39392C3132322C3132302C3131382C3130335D292C66613D6E65772055696E7431364172726179285B3131342C38322C32393831302C3131352C33303537392C32363438332C3130312C36392C3130322C';
wwv_flow_imp.g_varchar2_table(4215) := '32393238362C32343933342C32393033302C32393739382C33303832322C33303331302C32363437302C39372C3131332C38312C32393830392C3131362C38342C3130302C3131392C38372C39392C3132322C3132302C3131382C3130332C3130372C31';
wwv_flow_imp.g_varchar2_table(4216) := '31312C3130352C37392C3130362C3131322C3131372C38302C3130342C32373439362C32383532302C32373735322C3132312C3131302C32373234362C32383738322C32373735382C39382C3130392C32373735372C3130385D293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4217) := '207661282E2E2E65297B72657475726E2066756E6374696F6E28742C6E297B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D655B695D28742C6E293B6966286F2972657475726E206F7D7265747572';
wwv_flow_imp.g_varchar2_table(4218) := '6E206E756C6C7D7D5F612E62696E6428766F696420302C2131293B636F6E73742062613D5F612E62696E6428766F696420302C2130293B66756E6374696F6E205F6128652C742C6E297B696628216E7C7C6E2E6C656E6774683C742E6C656E6774682972';
wwv_flow_imp.g_varchar2_table(4219) := '657475726E206E756C6C3B6C657420693B72657475726E20693D653F4569286E2C74293A303D3D3D6E2E696E6465784F662874292C693F742E6C656E6774683E303F5B7B73746172743A302C656E643A742E6C656E6774687D5D3A5B5D3A6E756C6C7D66';
wwv_flow_imp.g_varchar2_table(4220) := '756E6374696F6E20796128652C74297B636F6E7374206E3D742E746F4C6F7765724361736528292E696E6465784F6628652E746F4C6F776572436173652829293B72657475726E2D313D3D3D6E3F6E756C6C3A5B7B73746172743A6E2C656E643A6E2B65';
wwv_flow_imp.g_varchar2_table(4221) := '2E6C656E6774687D5D7D66756E6374696F6E20776128652C74297B72657475726E20436128652E746F4C6F7765724361736528292C742E746F4C6F7765724361736528292C302C30297D66756E6374696F6E20436128652C742C6E2C69297B6966286E3D';
wwv_flow_imp.g_varchar2_table(4222) := '3D3D652E6C656E6774682972657475726E5B5D3B696628693D3D3D742E6C656E6774682972657475726E206E756C6C3B696628655B6E5D3D3D3D745B695D297B6C6574206F3D6E756C6C3B72657475726E286F3D436128652C742C6E2B312C692B312929';
wwv_flow_imp.g_varchar2_table(4223) := '3F4E61287B73746172743A692C656E643A692B317D2C6F293A6E756C6C7D72657475726E20436128652C742C6E2C692B31297D66756E6374696F6E2053612865297B72657475726E2039373C3D652626653C3D3132327D66756E6374696F6E2078612865';
wwv_flow_imp.g_varchar2_table(4224) := '297B72657475726E2036353C3D652626653C3D39307D66756E6374696F6E206B612865297B72657475726E2034383C3D652626653C3D35377D66756E6374696F6E2045612865297B72657475726E2033323D3D3D657C7C393D3D3D657C7C31303D3D3D65';
wwv_flow_imp.g_varchar2_table(4225) := '7C7C31333D3D3D657D636F6E7374204C613D6E6577205365743B66756E6374696F6E2044612865297B72657475726E2045612865297C7C4C612E6861732865297D66756E6374696F6E20546128652C74297B72657475726E20653D3D3D747C7C44612865';
wwv_flow_imp.g_varchar2_table(4226) := '29262644612874297D2228295B5D7B7D3C3E60275C222D2F3B3A2C2E3F21222E73706C6974282222292E666F72456163682828653D3E4C612E61646428652E63686172436F646541742830292929293B636F6E73742049613D6E6577204D61703B66756E';
wwv_flow_imp.g_varchar2_table(4227) := '6374696F6E204D612865297B69662849612E6861732865292972657475726E2049612E6765742865293B6C657420743B636F6E7374206E3D66756E6374696F6E2865297B636F6E737420743D66756E6374696F6E2865297B69662864613D302C75612865';
wwv_flow_imp.g_varchar2_table(4228) := '2C70612C34333532292C64613E302972657475726E2068612E737562617272617928302C6461293B696628756128652C67612C34343439292C64613E302972657475726E2068612E737562617272617928302C6461293B696628756128652C6D612C3435';
wwv_flow_imp.g_varchar2_table(4229) := '3230292C64613E302972657475726E2068612E737562617272617928302C6461293B696628756128652C66612C3132353933292C64612972657475726E2068612E737562617272617928302C6461293B696628653E3D34343033322626653C3D35353230';
wwv_flow_imp.g_varchar2_table(4230) := '33297B636F6E737420743D652D34343033322C6E3D74253538382C693D4D6174682E666C6F6F7228742F353838292C6F3D4D6174682E666C6F6F72286E2F3238292C733D6E2532382D313B696628693C70612E6C656E6774683F756128692C70612C3029';
wwv_flow_imp.g_varchar2_table(4231) := '3A343335322B692D31323539333C66612E6C656E6774682626756128343335322B692C66612C3132353933292C6F3C67612E6C656E6774683F7561286F2C67612C30293A343434392B6F2D31323539333C66612E6C656E6774682626756128343434392B';
wwv_flow_imp.g_varchar2_table(4232) := '6F2D31323539332C66612C3132353933292C733E3D30262628733C6D612E6C656E6774683F756128732C6D612C30293A343532302B732D31323539333C66612E6C656E6774682626756128343532302B732D31323539332C66612C313235393329292C64';
wwv_flow_imp.g_varchar2_table(4233) := '613E302972657475726E2068612E737562617272617928302C6461297D7D2865293B696628742626742E6C656E6774683E302972657475726E206E65772055696E74333241727261792874297D2865293B72657475726E206E262628743D6E292C49612E';
wwv_flow_imp.g_varchar2_table(4234) := '73657428652C74292C747D66756E6374696F6E2041612865297B72657475726E2053612865297C7C78612865297C7C6B612865297D66756E6374696F6E204E6128652C74297B72657475726E20303D3D3D742E6C656E6774683F743D5B655D3A652E656E';
wwv_flow_imp.g_varchar2_table(4235) := '643D3D3D745B305D2E73746172743F745B305D2E73746172743D652E73746172743A742E756E73686966742865292C747D66756E6374696F6E20506128652C74297B666F72286C6574206E3D743B6E3C652E6C656E6774683B6E2B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(4236) := '743D652E63686172436F64654174286E293B69662878612874297C7C6B612874297C7C6E3E30262621416128652E63686172436F64654174286E2D3129292972657475726E206E7D72657475726E20652E6C656E6774687D66756E6374696F6E204F6128';
wwv_flow_imp.g_varchar2_table(4237) := '652C742C6E2C69297B6966286E3D3D3D652E6C656E6774682972657475726E5B5D3B696628693D3D3D742E6C656E6774682972657475726E206E756C6C3B696628655B6E5D213D3D745B695D2E746F4C6F7765724361736528292972657475726E206E75';
wwv_flow_imp.g_varchar2_table(4238) := '6C6C3B7B6C6574206F3D6E756C6C2C733D692B313B666F72286F3D4F6128652C742C6E2B312C692B31293B216F262628733D506128742C7329293C742E6C656E6774683B296F3D4F6128652C742C6E2B312C73292C732B2B3B72657475726E206E756C6C';
wwv_flow_imp.g_varchar2_table(4239) := '3D3D3D6F3F6E756C6C3A4E61287B73746172743A692C656E643A692B317D2C6F297D7D66756E6374696F6E20526128652C74297B69662821742972657475726E206E756C6C3B696628303D3D3D28743D742E7472696D2829292E6C656E67746829726574';
wwv_flow_imp.g_varchar2_table(4240) := '75726E206E756C6C3B6966282166756E6374696F6E2865297B6C657420743D302C6E3D302C693D302C6F3D303B666F72286C657420733D303B733C652E6C656E6774683B732B2B29693D652E63686172436F646541742873292C78612869292626742B2B';
wwv_flow_imp.g_varchar2_table(4241) := '2C536128692926266E2B2B2C456128692926266F2B2B3B72657475726E2030213D3D74262630213D3D6E7C7C30213D3D6F3F743C3D353A652E6C656E6774683C3D33307D2865292972657475726E206E756C6C3B742E6C656E6774683E3630262628743D';
wwv_flow_imp.g_varchar2_table(4242) := '742E737562737472696E6728302C363029293B636F6E7374206E3D66756E6374696F6E2865297B6C657420743D302C6E3D302C693D302C6F3D302C733D303B666F72286C657420723D303B723C652E6C656E6774683B722B2B29733D652E63686172436F';
wwv_flow_imp.g_varchar2_table(4243) := '646541742872292C78612873292626742B2B2C536128732926266E2B2B2C41612873292626692B2B2C6B6128732926266F2B2B3B72657475726E7B757070657250657263656E743A742F652E6C656E6774682C6C6F77657250657263656E743A6E2F652E';
wwv_flow_imp.g_varchar2_table(4244) := '6C656E6774682C616C70686150657263656E743A692F652E6C656E6774682C6E756D6572696350657263656E743A6F2F652E6C656E6774687D7D2874293B6966282166756E6374696F6E2865297B636F6E73747B757070657250657263656E743A742C6C';
wwv_flow_imp.g_varchar2_table(4245) := '6F77657250657263656E743A6E2C616C70686150657263656E743A692C6E756D6572696350657263656E743A6F7D3D653B72657475726E206E3E2E322626743C2E382626693E2E3626266F3C2E327D286E29297B6966282166756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(4246) := '636F6E73747B757070657250657263656E743A742C6C6F77657250657263656E743A6E7D3D653B72657475726E20303D3D3D6E2626743E2E367D286E292972657475726E206E756C6C3B743D742E746F4C6F7765724361736528297D6C657420693D6E75';
wwv_flow_imp.g_varchar2_table(4247) := '6C6C2C6F3D303B666F7228653D652E746F4C6F7765724361736528293B6F3C742E6C656E67746826266E756C6C3D3D3D28693D4F6128652C742C302C6F29293B296F3D506128742C6F2B31293B72657475726E20697D66756E6374696F6E20466128652C';
wwv_flow_imp.g_varchar2_table(4248) := '742C6E2C692C6F297B6C657420733D303B6966286E3D3D3D652E6C656E6774682972657475726E5B5D3B696628693D3D3D742E6C656E6774682972657475726E206E756C6C3B69662821546128652E63686172436F64654174286E292C742E6368617243';
wwv_flow_imp.g_varchar2_table(4249) := '6F6465417428692929297B636F6E7374206F3D4D6128652E63686172436F64654174286E29293B696628216F2972657475726E206E756C6C3B666F72286C657420653D303B653C6F2E6C656E6774683B652B2B29696628215461286F5B655D2C742E6368';
wwv_flow_imp.g_varchar2_table(4250) := '6172436F6465417428692B6529292972657475726E206E756C6C3B732B3D6F2E6C656E6774682D317D6C657420723D6E756C6C2C613D692B732B313B696628723D466128652C742C6E2B312C612C6F292C216F29666F72283B2172262628613D42612874';
wwv_flow_imp.g_varchar2_table(4251) := '2C6129293C742E6C656E6774683B29723D466128652C742C6E2B312C612C6F292C612B2B3B69662821722972657475726E206E756C6C3B696628652E63686172436F64654174286E29213D3D742E63686172436F64654174286929297B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(4252) := '3D4D6128652E63686172436F64654174286E29293B696628216F2972657475726E20723B666F72286C657420653D303B653C6F2E6C656E6774683B652B2B296966286F5B655D213D3D742E63686172436F6465417428692B65292972657475726E20727D';
wwv_flow_imp.g_varchar2_table(4253) := '72657475726E204E61287B73746172743A692C656E643A692B732B317D2C72297D66756E6374696F6E20426128652C74297B666F72286C6574206E3D743B6E3C652E6C656E6774683B6E2B2B29696628446128652E63686172436F64654174286E29297C';
wwv_flow_imp.g_varchar2_table(4254) := '7C6E3E302626446128652E63686172436F64654174286E2D3129292972657475726E206E3B72657475726E20652E6C656E6774687D636F6E73742056613D76612862612C52612C7961292C7A613D76612862612C52612C7761292C48613D6E6577206161';
wwv_flow_imp.g_varchar2_table(4255) := '28316534293B66756E6374696F6E20576128652C742C6E3D2131297B69662822737472696E6722213D747970656F6620657C7C22737472696E6722213D747970656F6620742972657475726E206E756C6C3B6C657420693D48612E6765742865293B697C';
wwv_flow_imp.g_varchar2_table(4256) := '7C28693D6E65772052656745787028652E7265706C616365282F5B5C2D5C5C5C7B5C7D5C2B5C3F5C7C5C5E5C245C2E5C2C5C5B5C5D5C285C295C235C735D2F672C225C5C242622292E7265706C616365282F5B5C2A5D2F672C222E2A22292C226922292C';
wwv_flow_imp.g_varchar2_table(4257) := '48612E73657428652C6929293B636F6E7374206F3D692E657865632874293B72657475726E206F3F5B7B73746172743A6F2E696E6465782C656E643A6F2E696E6465782B6F5B305D2E6C656E6774687D5D3A6E3F7A6128652C74293A566128652C74297D';
wwv_flow_imp.g_varchar2_table(4258) := '66756E6374696F6E206A6128652C74297B636F6E7374206E3D616C28652C652E746F4C6F7765724361736528292C302C742C742E746F4C6F7765724361736528292C302C7B66697273744D6174636843616E42655765616B3A21302C626F6F737446756C';
wwv_flow_imp.g_varchar2_table(4259) := '6C4D617463683A21307D293B72657475726E206E3F2461286E293A6E756C6C7D66756E6374696F6E20716128652C742C6E2C692C6F2C73297B636F6E737420723D4D6174682E6D696E2831332C652E6C656E677468293B666F72283B6E3C723B6E2B2B29';
wwv_flow_imp.g_varchar2_table(4260) := '7B636F6E737420723D616C28652C742C6E2C692C6F2C732C7B66697273744D6174636843616E42655765616B3A21302C626F6F737446756C6C4D617463683A21307D293B696628722972657475726E20727D72657475726E5B302C735D7D66756E637469';
wwv_flow_imp.g_varchar2_table(4261) := '6F6E2024612865297B696628766F696420303D3D3D652972657475726E5B5D3B636F6E737420743D5B5D2C6E3D655B315D3B666F72286C657420693D652E6C656E6774682D313B693E313B692D2D297B636F6E7374206F3D655B695D2B6E2C733D745B74';
wwv_flow_imp.g_varchar2_table(4262) := '2E6C656E6774682D315D3B732626732E656E643D3D3D6F3F732E656E643D6F2B313A742E70757368287B73746172743A6F2C656E643A6F2B317D297D72657475726E20747D636F6E73742055613D3132383B66756E6374696F6E204B6128297B636F6E73';
wwv_flow_imp.g_varchar2_table(4263) := '7420653D5B5D2C743D5B5D3B666F72286C657420653D303B653C3D55613B652B2B29745B655D3D303B666F72286C6574206E3D303B6E3C3D55613B6E2B2B29652E7075736828742E736C696365283029293B72657475726E20657D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(4264) := '47612865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C3D653B6E2B2B29745B6E5D3D303B72657475726E20747D636F6E73742051613D476128322A5561292C59613D476128322A5561292C5A613D4B6128292C58613D4B6128292C';
wwv_flow_imp.g_varchar2_table(4265) := '4A613D4B6128292C656C3D21313B66756E6374696F6E20746C28652C742C6E2C692C6F297B66756E6374696F6E207328652C742C6E3D222022297B666F72283B652E6C656E6774683C743B29653D6E2B653B72657475726E20657D6C657420723D60207C';
wwv_flow_imp.g_varchar2_table(4266) := '2020207C247B692E73706C6974282222292E6D61702828653D3E7328652C332929292E6A6F696E28227C22297D5C6E603B666F72286C657420693D303B693C3D6E3B692B2B29722B3D303D3D3D693F22207C223A60247B745B692D315D7D7C602C722B3D';
wwv_flow_imp.g_varchar2_table(4267) := '655B695D2E736C69636528302C6F2B31292E6D61702828653D3E7328652E746F537472696E6728292C332929292E6A6F696E28227C22292B225C6E223B72657475726E20727D66756E6374696F6E206E6C28652C74297B696628743C307C7C743E3D652E';
wwv_flow_imp.g_varchar2_table(4268) := '6C656E6774682972657475726E21313B636F6E7374206E3D652E636F6465506F696E7441742874293B737769746368286E297B636173652039353A636173652034353A636173652034363A636173652033323A636173652034373A636173652039323A63';
wwv_flow_imp.g_varchar2_table(4269) := '6173652033393A636173652033343A636173652035383A636173652033363A636173652036303A636173652036323A636173652034303A636173652034313A636173652039313A636173652039333A63617365203132333A63617365203132353A726574';
wwv_flow_imp.g_varchar2_table(4270) := '75726E21303B6361736520766F696420303A72657475726E21313B64656661756C743A72657475726E21217169286E297D7D66756E6374696F6E20696C28652C74297B696628743C307C7C743E3D652E6C656E6774682972657475726E21313B73776974';
wwv_flow_imp.g_varchar2_table(4271) := '636828652E63686172436F64654174287429297B636173652033323A6361736520393A72657475726E21303B64656661756C743A72657475726E21317D7D66756E6374696F6E206F6C28652C742C6E297B72657475726E20745B655D213D3D6E5B655D7D';
wwv_flow_imp.g_varchar2_table(4272) := '76617220736C3B2166756E6374696F6E2865297B652E44656661756C743D5B2D3130302C305D2C652E697344656661756C743D66756E6374696F6E2865297B72657475726E21657C7C323D3D3D652E6C656E67746826262D3130303D3D3D655B305D2626';
wwv_flow_imp.g_varchar2_table(4273) := '303D3D3D655B315D7D7D28736C7C7C28736C3D7B7D29293B636C61737320726C7B636F6E7374727563746F7228652C74297B746869732E66697273744D6174636843616E42655765616B3D652C746869732E626F6F737446756C6C4D617463683D747D7D';
wwv_flow_imp.g_varchar2_table(4274) := '66756E6374696F6E20616C28652C742C6E2C692C6F2C732C723D726C2E64656661756C74297B636F6E737420613D652E6C656E6774683E55613F55613A652E6C656E6774682C6C3D692E6C656E6774683E55613F55613A692E6C656E6774683B6966286E';
wwv_flow_imp.g_varchar2_table(4275) := '3E3D617C7C733E3D6C7C7C612D6E3E6C2D732972657475726E3B6966282166756E6374696F6E28652C742C6E2C692C6F2C732C723D2131297B666F72283B743C6E26266F3C733B29655B745D3D3D3D695B6F5D2626287226262851615B745D3D6F292C74';
wwv_flow_imp.g_varchar2_table(4276) := '2B3D31292C6F2B3D313B72657475726E20743D3D3D6E7D28742C6E2C612C6F2C732C6C2C2130292972657475726E3B2166756E6374696F6E28652C742C6E2C692C6F2C73297B6C657420723D652D312C613D742D313B666F72283B723E3D6E2626613E3D';
wwv_flow_imp.g_varchar2_table(4277) := '693B296F5B725D3D3D3D735B615D26262859615B725D3D612C722D2D292C612D2D7D28612C6C2C6E2C732C742C6F293B6C657420633D312C643D312C683D6E2C753D733B636F6E737420703D5B21315D3B666F7228633D312C683D6E3B683C613B632B2B';
wwv_flow_imp.g_varchar2_table(4278) := '2C682B2B297B636F6E737420723D51615B685D2C673D59615B685D2C6D3D682B313C613F59615B682B315D3A6C3B666F7228643D722D732B312C753D723B753C6D3B642B2B2C752B2B297B6C657420613D4E756D6265722E4D494E5F534146455F494E54';
wwv_flow_imp.g_varchar2_table(4279) := '454745522C6D3D21313B753C3D67262628613D6C6C28652C742C682C6E2C692C6F2C752C6C2C732C303D3D3D5A615B632D315D5B642D315D2C7029293B6C657420663D303B61213D3D4E756D6265722E4D41585F534146455F494E54454745522626286D';
wwv_flow_imp.g_varchar2_table(4280) := '3D21302C663D612B58615B632D315D5B642D315D293B636F6E737420763D753E722C623D763F58615B635D5B642D315D2B285A615B635D5B642D315D3E303F2D353A30293A302C5F3D753E722B3126265A615B635D5B642D315D3E302C793D5F3F58615B';
wwv_flow_imp.g_varchar2_table(4281) := '635D5B642D325D2B285A615B635D5B642D325D3E303F2D353A30293A303B6966285F26262821767C7C793E3D6229262628216D7C7C793E3D66292958615B635D5B645D3D792C4A615B635D5B645D3D332C5A615B635D5B645D3D303B656C736520696628';
wwv_flow_imp.g_varchar2_table(4282) := '76262628216D7C7C623E3D66292958615B635D5B645D3D622C4A615B635D5B645D3D322C5A615B635D5B645D3D303B656C73657B696628216D297468726F77206E6577204572726F7228226E6F7420706F737369626C6522293B58615B635D5B645D3D66';
wwv_flow_imp.g_varchar2_table(4283) := '2C4A615B635D5B645D3D312C5A615B635D5B645D3D5A615B632D315D5B642D315D2B317D7D7D696628656C262666756E6374696F6E28652C742C6E2C69297B653D652E7375627374722874292C6E3D6E2E7375627374722869292C636F6E736F6C652E6C';
wwv_flow_imp.g_varchar2_table(4284) := '6F6728746C2858612C652C652E6C656E6774682C6E2C6E2E6C656E67746829292C636F6E736F6C652E6C6F6728746C284A612C652C652E6C656E6774682C6E2C6E2E6C656E67746829292C636F6E736F6C652E6C6F6728746C285A612C652C652E6C656E';
wwv_flow_imp.g_varchar2_table(4285) := '6774682C6E2C6E2E6C656E67746829297D28652C6E2C692C73292C21705B305D262621722E66697273744D6174636843616E42655765616B2972657475726E3B632D2D2C642D2D3B636F6E737420673D5B58615B635D5B645D2C735D3B6C6574206D3D30';
wwv_flow_imp.g_varchar2_table(4286) := '2C663D303B666F72283B633E3D313B297B6C657420653D643B646F7B636F6E737420743D4A615B635D5B655D3B696628333D3D3D7429652D3D323B656C73657B69662832213D3D7429627265616B3B652D3D317D7D7768696C6528653E3D31293B6D3E31';
wwv_flow_imp.g_varchar2_table(4287) := '2626745B6E2B632D315D3D3D3D6F5B732B642D315D2626216F6C28652B732D312C692C6F2926266D2B313E5A615B635D5B655D262628653D64292C653D3D3D643F6D2B2B3A6D3D312C667C7C28663D65292C632D2D2C643D652D312C672E707573682864';
wwv_flow_imp.g_varchar2_table(4288) := '297D6C3D3D3D612626722E626F6F737446756C6C4D61746368262628675B305D2B3D32293B636F6E737420763D662D613B72657475726E20675B305D2D3D762C677D66756E6374696F6E206C6C28652C742C6E2C692C6F2C732C722C612C6C2C632C6429';
wwv_flow_imp.g_varchar2_table(4289) := '7B696628745B6E5D213D3D735B725D2972657475726E204E756D6265722E4D494E5F534146455F494E54454745523B6C657420683D312C753D21313B72657475726E20723D3D3D6E2D693F683D655B6E5D3D3D3D6F5B725D3F373A353A216F6C28722C6F';
wwv_flow_imp.g_varchar2_table(4290) := '2C73297C7C30213D3D7226266F6C28722D312C6F2C73293F216E6C28732C72297C7C30213D3D7226266E6C28732C722D31293F286E6C28732C722D31297C7C696C28732C722D312929262628683D352C753D2130293A683D353A28683D655B6E5D3D3D3D';
wwv_flow_imp.g_varchar2_table(4291) := '6F5B725D3F373A352C753D2130292C683E3126266E3D3D3D69262628645B305D3D2130292C757C7C28753D6F6C28722C6F2C73297C7C6E6C28732C722D31297C7C696C28732C722D3129292C6E3D3D3D693F723E6C262628682D3D753F333A35293A682B';
wwv_flow_imp.g_varchar2_table(4292) := '3D633F753F323A303A753F303A312C722B313D3D3D61262628682D3D753F333A35292C687D66756E6374696F6E20636C28652C742C6E2C692C6F2C732C72297B72657475726E2066756E6374696F6E28652C742C6E2C692C6F2C732C722C61297B6C6574';
wwv_flow_imp.g_varchar2_table(4293) := '206C3D616C28652C742C6E2C692C6F2C732C61293B696628652E6C656E6774683E3D33297B636F6E737420743D4D6174682E6D696E28372C652E6C656E6774682D31293B666F72286C657420723D6E2B313B723C743B722B2B297B636F6E737420743D64';
wwv_flow_imp.g_varchar2_table(4294) := '6C28652C72293B69662874297B636F6E737420653D616C28742C742E746F4C6F7765724361736528292C6E2C692C6F2C732C61293B65262628655B305D2D3D332C28216C7C7C655B305D3E6C5B305D292626286C3D6529297D7D7D72657475726E206C7D';
wwv_flow_imp.g_varchar2_table(4295) := '28652C742C6E2C692C6F2C732C302C72297D66756E6374696F6E20646C28652C74297B696628742B313E3D652E6C656E6774682972657475726E3B636F6E7374206E3D655B745D2C693D655B742B315D3B72657475726E206E213D3D693F652E736C6963';
wwv_flow_imp.g_varchar2_table(4296) := '6528302C74292B692B6E2B652E736C69636528742B32293A766F696420307D66756E6374696F6E20686C2865297B72657475726E22737472696E67223D3D747970656F6620657D66756E6374696F6E20756C2865297B72657475726E2128226F626A6563';
wwv_flow_imp.g_varchar2_table(4297) := '7422213D747970656F6620657C7C6E756C6C3D3D3D657C7C41727261792E697341727261792865297C7C6520696E7374616E63656F66205265674578707C7C6520696E7374616E63656F662044617465297D66756E6374696F6E20706C2865297B636F6E';
wwv_flow_imp.g_varchar2_table(4298) := '737420743D4F626A6563742E67657450726F746F747970654F662855696E74384172726179293B72657475726E226F626A656374223D3D747970656F66206526266520696E7374616E63656F6620747D66756E6374696F6E20676C2865297B7265747572';
wwv_flow_imp.g_varchar2_table(4299) := '6E226E756D626572223D3D747970656F66206526262169734E614E2865297D66756E6374696F6E206D6C2865297B72657475726E21216526262266756E6374696F6E223D3D747970656F6620655B53796D626F6C2E6974657261746F725D7D66756E6374';
wwv_flow_imp.g_varchar2_table(4300) := '696F6E20666C2865297B72657475726E21303D3D3D657C7C21313D3D3D657D66756E6374696F6E20766C2865297B72657475726E20766F696420303D3D3D657D66756E6374696F6E20626C2865297B72657475726E215F6C2865297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4301) := '205F6C2865297B72657475726E20766C2865297C7C6E756C6C3D3D3D657D66756E6374696F6E20796C28652C74297B6966282165297468726F77206E6577204572726F7228743F60556E657870656374656420747970652C206578706563746564202724';
wwv_flow_imp.g_varchar2_table(4302) := '7B747D27603A22556E6578706563746564207479706522297D66756E6374696F6E20776C2865297B6966285F6C286529297468726F77206E6577204572726F722822417373657274696F6E204661696C65643A20617267756D656E7420697320756E6465';
wwv_flow_imp.g_varchar2_table(4303) := '66696E6564206F72206E756C6C22293B72657475726E20657D66756E6374696F6E20436C2865297B72657475726E2266756E6374696F6E223D3D747970656F6620657D66756E6374696F6E20536C28652C74297B696628686C287429297B696628747970';
wwv_flow_imp.g_varchar2_table(4304) := '656F662065213D3D74297468726F77206E6577204572726F722860617267756D656E7420646F6573206E6F74206D6174636820636F6E73747261696E743A20747970656F6620247B747D60297D656C736520696628436C287429297B7472797B69662865';
wwv_flow_imp.g_varchar2_table(4305) := '20696E7374616E63656F6620742972657475726E7D63617463682865297B7D696628215F6C2865292626652E636F6E7374727563746F723D3D3D742972657475726E3B696628313D3D3D742E6C656E677468262621303D3D3D742E63616C6C28766F6964';
wwv_flow_imp.g_varchar2_table(4306) := '20302C65292972657475726E3B7468726F77206E6577204572726F722822617267756D656E7420646F6573206E6F74206D61746368206F6E65206F6620746865736520636F6E73747261696E74733A2061726720696E7374616E63656F6620636F6E7374';
wwv_flow_imp.g_varchar2_table(4307) := '7261696E742C206172672E636F6E7374727563746F72203D3D3D20636F6E73747261696E742C206E6F7220636F6E73747261696E742861726729203D3D3D207472756522297D7D726C2E64656661756C743D7B626F6F737446756C6C4D617463683A2130';
wwv_flow_imp.g_varchar2_table(4308) := '2C66697273744D6174636843616E42655765616B3A21317D3B636F6E737420786C3D4F626A6563742E637265617465286E756C6C293B66756E6374696F6E206B6C28652C74297B696628686C287429297B636F6E7374206E3D786C5B745D3B696628766F';
wwv_flow_imp.g_varchar2_table(4309) := '696420303D3D3D6E297468726F77206E6577204572726F722860247B657D207265666572656E63657320616E20756E6B6E6F776E20636F6469636F6E3A20247B747D60293B743D6E7D72657475726E20786C5B655D3D742C7B69643A657D7D66756E6374';
wwv_flow_imp.g_varchar2_table(4310) := '696F6E20456C28297B72657475726E20786C7D636F6E7374204C6C3D7B6164643A6B6C2822616464222C366534292C706C75733A6B6C2822706C7573222C366534292C676973744E65773A6B6C2822676973742D6E6577222C366534292C7265706F4372';
wwv_flow_imp.g_varchar2_table(4311) := '656174653A6B6C28227265706F2D637265617465222C366534292C6C6967687462756C623A6B6C28226C6967687462756C62222C3630303031292C6C6967687442756C623A6B6C28226C696768742D62756C62222C3630303031292C7265706F3A6B6C28';
wwv_flow_imp.g_varchar2_table(4312) := '227265706F222C3630303032292C7265706F44656C6574653A6B6C28227265706F2D64656C657465222C3630303032292C67697374466F726B3A6B6C2822676973742D666F726B222C3630303033292C7265706F466F726B65643A6B6C28227265706F2D';
wwv_flow_imp.g_varchar2_table(4313) := '666F726B6564222C3630303033292C67697450756C6C526571756573743A6B6C28226769742D70756C6C2D72657175657374222C3630303034292C67697450756C6C526571756573744162616E646F6E65643A6B6C28226769742D70756C6C2D72657175';
wwv_flow_imp.g_varchar2_table(4314) := '6573742D6162616E646F6E6564222C3630303034292C7265636F72644B6579733A6B6C28227265636F72642D6B657973222C3630303035292C6B6579626F6172643A6B6C28226B6579626F617264222C3630303035292C7461673A6B6C2822746167222C';
wwv_flow_imp.g_varchar2_table(4315) := '3630303036292C67697450756C6C526571756573744C6162656C3A6B6C28226769742D70756C6C2D726571756573742D6C6162656C222C3630303036292C7461674164643A6B6C28227461672D616464222C3630303036292C74616752656D6F76653A6B';
wwv_flow_imp.g_varchar2_table(4316) := '6C28227461672D72656D6F7665222C3630303036292C706572736F6E3A6B6C2822706572736F6E222C3630303037292C706572736F6E466F6C6C6F773A6B6C2822706572736F6E2D666F6C6C6F77222C3630303037292C706572736F6E4F75746C696E65';
wwv_flow_imp.g_varchar2_table(4317) := '3A6B6C2822706572736F6E2D6F75746C696E65222C3630303037292C706572736F6E46696C6C65643A6B6C2822706572736F6E2D66696C6C6564222C3630303037292C6769744272616E63683A6B6C28226769742D6272616E6368222C3630303038292C';
wwv_flow_imp.g_varchar2_table(4318) := '6769744272616E63684372656174653A6B6C28226769742D6272616E63682D637265617465222C3630303038292C6769744272616E636844656C6574653A6B6C28226769742D6272616E63682D64656C657465222C3630303038292C736F75726365436F';
wwv_flow_imp.g_varchar2_table(4319) := '6E74726F6C3A6B6C2822736F757263652D636F6E74726F6C222C3630303038292C6D6972726F723A6B6C28226D6972726F72222C3630303039292C6D6972726F725075626C69633A6B6C28226D6972726F722D7075626C6963222C3630303039292C7374';
wwv_flow_imp.g_varchar2_table(4320) := '61723A6B6C282273746172222C3630303130292C737461724164643A6B6C2822737461722D616464222C3630303130292C7374617244656C6574653A6B6C2822737461722D64656C657465222C3630303130292C73746172456D7074793A6B6C28227374';
wwv_flow_imp.g_varchar2_table(4321) := '61722D656D707479222C3630303130292C636F6D6D656E743A6B6C2822636F6D6D656E74222C3630303131292C636F6D6D656E744164643A6B6C2822636F6D6D656E742D616464222C3630303131292C616C6572743A6B6C2822616C657274222C363030';
wwv_flow_imp.g_varchar2_table(4322) := '3132292C7761726E696E673A6B6C28227761726E696E67222C3630303132292C7365617263683A6B6C2822736561726368222C3630303133292C736561726368536176653A6B6C28227365617263682D73617665222C3630303133292C6C6F674F75743A';
wwv_flow_imp.g_varchar2_table(4323) := '6B6C28226C6F672D6F7574222C3630303134292C7369676E4F75743A6B6C28227369676E2D6F7574222C3630303134292C6C6F67496E3A6B6C28226C6F672D696E222C3630303135292C7369676E496E3A6B6C28227369676E2D696E222C363030313529';
wwv_flow_imp.g_varchar2_table(4324) := '2C6579653A6B6C2822657965222C3630303136292C657965556E77617463683A6B6C28226579652D756E7761746368222C3630303136292C65796557617463683A6B6C28226579652D7761746368222C3630303136292C636972636C6546696C6C65643A';
wwv_flow_imp.g_varchar2_table(4325) := '6B6C2822636972636C652D66696C6C6564222C3630303137292C7072696D6974697665446F743A6B6C28227072696D69746976652D646F74222C3630303137292C636C6F736544697274793A6B6C2822636C6F73652D6469727479222C3630303137292C';
wwv_flow_imp.g_varchar2_table(4326) := '6465627567427265616B706F696E743A6B6C282264656275672D627265616B706F696E74222C3630303137292C6465627567427265616B706F696E7444697361626C65643A6B6C282264656275672D627265616B706F696E742D64697361626C6564222C';
wwv_flow_imp.g_varchar2_table(4327) := '3630303137292C646562756748696E743A6B6C282264656275672D68696E74222C3630303137292C7465726D696E616C4465636F726174696F6E537563636573733A6B6C28227465726D696E616C2D6465636F726174696F6E2D73756363657373222C36';
wwv_flow_imp.g_varchar2_table(4328) := '30303137292C7072696D69746976655371756172653A6B6C28227072696D69746976652D737175617265222C3630303138292C656469743A6B6C282265646974222C3630303139292C70656E63696C3A6B6C282270656E63696C222C3630303139292C69';
wwv_flow_imp.g_varchar2_table(4329) := '6E666F3A6B6C2822696E666F222C3630303230292C69737375654F70656E65643A6B6C282269737375652D6F70656E6564222C3630303230292C67697374507269766174653A6B6C2822676973742D70726976617465222C3630303231292C676974466F';
wwv_flow_imp.g_varchar2_table(4330) := '726B507269766174653A6B6C28226769742D666F726B2D70726976617465222C3630303231292C6C6F636B3A6B6C28226C6F636B222C3630303231292C6D6972726F72507269766174653A6B6C28226D6972726F722D70726976617465222C3630303231';
wwv_flow_imp.g_varchar2_table(4331) := '292C636C6F73653A6B6C2822636C6F7365222C3630303232292C72656D6F7665436C6F73653A6B6C282272656D6F76652D636C6F7365222C3630303232292C783A6B6C282278222C3630303232292C7265706F53796E633A6B6C28227265706F2D73796E';
wwv_flow_imp.g_varchar2_table(4332) := '63222C3630303233292C73796E633A6B6C282273796E63222C3630303233292C636C6F6E653A6B6C2822636C6F6E65222C3630303234292C6465736B746F70446F776E6C6F61643A6B6C28226465736B746F702D646F776E6C6F6164222C363030323429';
wwv_flow_imp.g_varchar2_table(4333) := '2C6265616B65723A6B6C28226265616B6572222C3630303235292C6D6963726F73636F70653A6B6C28226D6963726F73636F7065222C3630303235292C766D3A6B6C2822766D222C3630303236292C6465766963654465736B746F703A6B6C2822646576';
wwv_flow_imp.g_varchar2_table(4334) := '6963652D6465736B746F70222C3630303236292C66696C653A6B6C282266696C65222C3630303237292C66696C65546578743A6B6C282266696C652D74657874222C3630303237292C6D6F72653A6B6C28226D6F7265222C3630303238292C656C6C6970';
wwv_flow_imp.g_varchar2_table(4335) := '7369733A6B6C2822656C6C6970736973222C3630303238292C6B65626162486F72697A6F6E74616C3A6B6C28226B656261622D686F72697A6F6E74616C222C3630303238292C6D61696C5265706C793A6B6C28226D61696C2D7265706C79222C36303032';
wwv_flow_imp.g_varchar2_table(4336) := '39292C7265706C793A6B6C28227265706C79222C3630303239292C6F7267616E697A6174696F6E3A6B6C28226F7267616E697A6174696F6E222C3630303330292C6F7267616E697A6174696F6E46696C6C65643A6B6C28226F7267616E697A6174696F6E';
wwv_flow_imp.g_varchar2_table(4337) := '2D66696C6C6564222C3630303330292C6F7267616E697A6174696F6E4F75746C696E653A6B6C28226F7267616E697A6174696F6E2D6F75746C696E65222C3630303330292C6E657746696C653A6B6C28226E65772D66696C65222C3630303331292C6669';
wwv_flow_imp.g_varchar2_table(4338) := '6C654164643A6B6C282266696C652D616464222C3630303331292C6E6577466F6C6465723A6B6C28226E65772D666F6C646572222C3630303332292C66696C654469726563746F72794372656174653A6B6C282266696C652D6469726563746F72792D63';
wwv_flow_imp.g_varchar2_table(4339) := '7265617465222C3630303332292C74726173683A6B6C28227472617368222C3630303333292C747261736863616E3A6B6C2822747261736863616E222C3630303333292C686973746F72793A6B6C2822686973746F7279222C3630303334292C636C6F63';
wwv_flow_imp.g_varchar2_table(4340) := '6B3A6B6C2822636C6F636B222C3630303334292C666F6C6465723A6B6C2822666F6C646572222C3630303335292C66696C654469726563746F72793A6B6C282266696C652D6469726563746F7279222C3630303335292C73796D626F6C466F6C6465723A';
wwv_flow_imp.g_varchar2_table(4341) := '6B6C282273796D626F6C2D666F6C646572222C3630303335292C6C6F676F4769746875623A6B6C28226C6F676F2D676974687562222C3630303336292C6D61726B4769746875623A6B6C28226D61726B2D676974687562222C3630303336292C67697468';
wwv_flow_imp.g_varchar2_table(4342) := '75623A6B6C2822676974687562222C3630303336292C7465726D696E616C3A6B6C28227465726D696E616C222C3630303337292C636F6E736F6C653A6B6C2822636F6E736F6C65222C3630303337292C7265706C3A6B6C28227265706C222C3630303337';
wwv_flow_imp.g_varchar2_table(4343) := '292C7A61703A6B6C28227A6170222C3630303338292C73796D626F6C4576656E743A6B6C282273796D626F6C2D6576656E74222C3630303338292C6572726F723A6B6C28226572726F72222C3630303339292C73746F703A6B6C282273746F70222C3630';
wwv_flow_imp.g_varchar2_table(4344) := '303339292C7661726961626C653A6B6C28227661726961626C65222C3630303430292C73796D626F6C5661726961626C653A6B6C282273796D626F6C2D7661726961626C65222C3630303430292C61727261793A6B6C28226172726179222C3630303432';
wwv_flow_imp.g_varchar2_table(4345) := '292C73796D626F6C41727261793A6B6C282273796D626F6C2D6172726179222C3630303432292C73796D626F6C4D6F64756C653A6B6C282273796D626F6C2D6D6F64756C65222C3630303433292C73796D626F6C5061636B6167653A6B6C282273796D62';
wwv_flow_imp.g_varchar2_table(4346) := '6F6C2D7061636B616765222C3630303433292C73796D626F6C4E616D6573706163653A6B6C282273796D626F6C2D6E616D657370616365222C3630303433292C73796D626F6C4F626A6563743A6B6C282273796D626F6C2D6F626A656374222C36303034';
wwv_flow_imp.g_varchar2_table(4347) := '33292C73796D626F6C4D6574686F643A6B6C282273796D626F6C2D6D6574686F64222C3630303434292C73796D626F6C46756E6374696F6E3A6B6C282273796D626F6C2D66756E6374696F6E222C3630303434292C73796D626F6C436F6E737472756374';
wwv_flow_imp.g_varchar2_table(4348) := '6F723A6B6C282273796D626F6C2D636F6E7374727563746F72222C3630303434292C73796D626F6C426F6F6C65616E3A6B6C282273796D626F6C2D626F6F6C65616E222C3630303437292C73796D626F6C4E756C6C3A6B6C282273796D626F6C2D6E756C';
wwv_flow_imp.g_varchar2_table(4349) := '6C222C3630303437292C73796D626F6C4E756D657269633A6B6C282273796D626F6C2D6E756D65726963222C3630303438292C73796D626F6C4E756D6265723A6B6C282273796D626F6C2D6E756D626572222C3630303438292C73796D626F6C53747275';
wwv_flow_imp.g_varchar2_table(4350) := '63747572653A6B6C282273796D626F6C2D737472756374757265222C3630303439292C73796D626F6C5374727563743A6B6C282273796D626F6C2D737472756374222C3630303439292C73796D626F6C506172616D657465723A6B6C282273796D626F6C';
wwv_flow_imp.g_varchar2_table(4351) := '2D706172616D65746572222C3630303530292C73796D626F6C54797065506172616D657465723A6B6C282273796D626F6C2D747970652D706172616D65746572222C3630303530292C73796D626F6C4B65793A6B6C282273796D626F6C2D6B6579222C36';
wwv_flow_imp.g_varchar2_table(4352) := '30303531292C73796D626F6C546578743A6B6C282273796D626F6C2D74657874222C3630303531292C73796D626F6C5265666572656E63653A6B6C282273796D626F6C2D7265666572656E6365222C3630303532292C676F546F46696C653A6B6C282267';
wwv_flow_imp.g_varchar2_table(4353) := '6F2D746F2D66696C65222C3630303532292C73796D626F6C456E756D3A6B6C282273796D626F6C2D656E756D222C3630303533292C73796D626F6C56616C75653A6B6C282273796D626F6C2D76616C7565222C3630303533292C73796D626F6C52756C65';
wwv_flow_imp.g_varchar2_table(4354) := '723A6B6C282273796D626F6C2D72756C6572222C3630303534292C73796D626F6C556E69743A6B6C282273796D626F6C2D756E6974222C3630303534292C6163746976617465427265616B706F696E74733A6B6C282261637469766174652D627265616B';
wwv_flow_imp.g_varchar2_table(4355) := '706F696E7473222C3630303535292C617263686976653A6B6C282261726368697665222C3630303536292C6172726F77426F74683A6B6C28226172726F772D626F7468222C3630303537292C6172726F77446F776E3A6B6C28226172726F772D646F776E';
wwv_flow_imp.g_varchar2_table(4356) := '222C3630303538292C6172726F774C6566743A6B6C28226172726F772D6C656674222C3630303539292C6172726F7752696768743A6B6C28226172726F772D7269676874222C3630303630292C6172726F77536D616C6C446F776E3A6B6C28226172726F';
wwv_flow_imp.g_varchar2_table(4357) := '772D736D616C6C2D646F776E222C3630303631292C6172726F77536D616C6C4C6566743A6B6C28226172726F772D736D616C6C2D6C656674222C3630303632292C6172726F77536D616C6C52696768743A6B6C28226172726F772D736D616C6C2D726967';
wwv_flow_imp.g_varchar2_table(4358) := '6874222C3630303633292C6172726F77536D616C6C55703A6B6C28226172726F772D736D616C6C2D7570222C3630303634292C6172726F7755703A6B6C28226172726F772D7570222C3630303635292C62656C6C3A6B6C282262656C6C222C3630303636';
wwv_flow_imp.g_varchar2_table(4359) := '292C626F6C643A6B6C2822626F6C64222C3630303637292C626F6F6B3A6B6C2822626F6F6B222C3630303638292C626F6F6B6D61726B3A6B6C2822626F6F6B6D61726B222C3630303639292C6465627567427265616B706F696E74436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(4360) := '616C556E76657269666965643A6B6C282264656275672D627265616B706F696E742D636F6E646974696F6E616C2D756E7665726966696564222C3630303730292C6465627567427265616B706F696E74436F6E646974696F6E616C3A6B6C282264656275';
wwv_flow_imp.g_varchar2_table(4361) := '672D627265616B706F696E742D636F6E646974696F6E616C222C3630303731292C6465627567427265616B706F696E74436F6E646974696F6E616C44697361626C65643A6B6C282264656275672D627265616B706F696E742D636F6E646974696F6E616C';
wwv_flow_imp.g_varchar2_table(4362) := '2D64697361626C6564222C3630303731292C6465627567427265616B706F696E7444617461556E76657269666965643A6B6C282264656275672D627265616B706F696E742D646174612D756E7665726966696564222C3630303732292C64656275674272';
wwv_flow_imp.g_varchar2_table(4363) := '65616B706F696E74446174613A6B6C282264656275672D627265616B706F696E742D64617461222C3630303733292C6465627567427265616B706F696E744461746144697361626C65643A6B6C282264656275672D627265616B706F696E742D64617461';
wwv_flow_imp.g_varchar2_table(4364) := '2D64697361626C6564222C3630303733292C6465627567427265616B706F696E744C6F67556E76657269666965643A6B6C282264656275672D627265616B706F696E742D6C6F672D756E7665726966696564222C3630303734292C646562756742726561';
wwv_flow_imp.g_varchar2_table(4365) := '6B706F696E744C6F673A6B6C282264656275672D627265616B706F696E742D6C6F67222C3630303735292C6465627567427265616B706F696E744C6F6744697361626C65643A6B6C282264656275672D627265616B706F696E742D6C6F672D6469736162';
wwv_flow_imp.g_varchar2_table(4366) := '6C6564222C3630303735292C6272696566636173653A6B6C2822627269656663617365222C3630303736292C62726F6164636173743A6B6C282262726F616463617374222C3630303737292C62726F777365723A6B6C282262726F77736572222C363030';
wwv_flow_imp.g_varchar2_table(4367) := '3738292C6275673A6B6C2822627567222C3630303739292C63616C656E6461723A6B6C282263616C656E646172222C3630303830292C6361736553656E7369746976653A6B6C2822636173652D73656E736974697665222C3630303831292C636865636B';
wwv_flow_imp.g_varchar2_table(4368) := '3A6B6C2822636865636B222C3630303832292C636865636B6C6973743A6B6C2822636865636B6C697374222C3630303833292C63686576726F6E446F776E3A6B6C282263686576726F6E2D646F776E222C3630303834292C63686576726F6E4C6566743A';
wwv_flow_imp.g_varchar2_table(4369) := '6B6C282263686576726F6E2D6C656674222C3630303835292C63686576726F6E52696768743A6B6C282263686576726F6E2D7269676874222C3630303836292C63686576726F6E55703A6B6C282263686576726F6E2D7570222C3630303837292C636872';
wwv_flow_imp.g_varchar2_table(4370) := '6F6D65436C6F73653A6B6C28226368726F6D652D636C6F7365222C3630303838292C6368726F6D654D6178696D697A653A6B6C28226368726F6D652D6D6178696D697A65222C3630303839292C6368726F6D654D696E696D697A653A6B6C28226368726F';
wwv_flow_imp.g_varchar2_table(4371) := '6D652D6D696E696D697A65222C3630303930292C6368726F6D65526573746F72653A6B6C28226368726F6D652D726573746F7265222C3630303931292C636972636C654F75746C696E653A6B6C2822636972636C652D6F75746C696E65222C3630303932';
wwv_flow_imp.g_varchar2_table(4372) := '292C636972636C653A6B6C2822636972636C65222C3630303932292C6465627567427265616B706F696E74556E76657269666965643A6B6C282264656275672D627265616B706F696E742D756E7665726966696564222C3630303932292C7465726D696E';
wwv_flow_imp.g_varchar2_table(4373) := '616C4465636F726174696F6E496E636F6D706C6574653A6B6C28227465726D696E616C2D6465636F726174696F6E2D696E636F6D706C657465222C3630303932292C636972636C65536C6173683A6B6C2822636972636C652D736C617368222C36303039';
wwv_flow_imp.g_varchar2_table(4374) := '33292C63697263756974426F6172643A6B6C2822636972637569742D626F617264222C3630303934292C636C656172416C6C3A6B6C2822636C6561722D616C6C222C3630303935292C636C697070793A6B6C2822636C69707079222C3630303936292C63';
wwv_flow_imp.g_varchar2_table(4375) := '6C6F7365416C6C3A6B6C2822636C6F73652D616C6C222C3630303937292C636C6F7564446F776E6C6F61643A6B6C2822636C6F75642D646F776E6C6F6164222C3630303938292C636C6F756455706C6F61643A6B6C2822636C6F75642D75706C6F616422';
wwv_flow_imp.g_varchar2_table(4376) := '2C3630303939292C636F64653A6B6C2822636F6465222C3630313030292C636F6C6C61707365416C6C3A6B6C2822636F6C6C617073652D616C6C222C3630313031292C636F6C6F724D6F64653A6B6C2822636F6C6F722D6D6F6465222C3630313032292C';
wwv_flow_imp.g_varchar2_table(4377) := '636F6D6D656E7444697363757373696F6E3A6B6C2822636F6D6D656E742D64697363757373696F6E222C3630313033292C637265646974436172643A6B6C28226372656469742D63617264222C3630313035292C646173683A6B6C282264617368222C36';
wwv_flow_imp.g_varchar2_table(4378) := '30313038292C64617368626F6172643A6B6C282264617368626F617264222C3630313039292C64617461626173653A6B6C28226461746162617365222C3630313130292C6465627567436F6E74696E75653A6B6C282264656275672D636F6E74696E7565';
wwv_flow_imp.g_varchar2_table(4379) := '222C3630313131292C6465627567446973636F6E6E6563743A6B6C282264656275672D646973636F6E6E656374222C3630313132292C646562756750617573653A6B6C282264656275672D7061757365222C3630313133292C6465627567526573746172';
wwv_flow_imp.g_varchar2_table(4380) := '743A6B6C282264656275672D72657374617274222C3630313134292C646562756753746172743A6B6C282264656275672D7374617274222C3630313135292C646562756753746570496E746F3A6B6C282264656275672D737465702D696E746F222C3630';
wwv_flow_imp.g_varchar2_table(4381) := '313136292C6465627567537465704F75743A6B6C282264656275672D737465702D6F7574222C3630313137292C6465627567537465704F7665723A6B6C282264656275672D737465702D6F766572222C3630313138292C646562756753746F703A6B6C28';
wwv_flow_imp.g_varchar2_table(4382) := '2264656275672D73746F70222C3630313139292C64656275673A6B6C28226465627567222C3630313230292C64657669636543616D657261566964656F3A6B6C28226465766963652D63616D6572612D766964656F222C3630313231292C646576696365';
wwv_flow_imp.g_varchar2_table(4383) := '43616D6572613A6B6C28226465766963652D63616D657261222C3630313232292C6465766963654D6F62696C653A6B6C28226465766963652D6D6F62696C65222C3630313233292C6469666641646465643A6B6C2822646966662D6164646564222C3630';
wwv_flow_imp.g_varchar2_table(4384) := '313234292C6469666649676E6F7265643A6B6C2822646966662D69676E6F726564222C3630313235292C646966664D6F6469666965643A6B6C2822646966662D6D6F646966696564222C3630313236292C6469666652656D6F7665643A6B6C2822646966';
wwv_flow_imp.g_varchar2_table(4385) := '662D72656D6F766564222C3630313237292C6469666652656E616D65643A6B6C2822646966662D72656E616D6564222C3630313238292C646966663A6B6C282264696666222C3630313239292C64696666536964656279736964653A6B6C282264696666';
wwv_flow_imp.g_varchar2_table(4386) := '2D73696465627973696465222C3630313239292C646973636172643A6B6C282264697363617264222C3630313330292C656469746F724C61796F75743A6B6C2822656469746F722D6C61796F7574222C3630313331292C656D70747957696E646F773A6B';
wwv_flow_imp.g_varchar2_table(4387) := '6C2822656D7074792D77696E646F77222C3630313332292C6578636C7564653A6B6C28226578636C756465222C3630313333292C657874656E73696F6E733A6B6C2822657874656E73696F6E73222C3630313334292C657965436C6F7365643A6B6C2822';
wwv_flow_imp.g_varchar2_table(4388) := '6579652D636C6F736564222C3630313335292C66696C6542696E6172793A6B6C282266696C652D62696E617279222C3630313336292C66696C65436F64653A6B6C282266696C652D636F6465222C3630313337292C66696C654D656469613A6B6C282266';
wwv_flow_imp.g_varchar2_table(4389) := '696C652D6D65646961222C3630313338292C66696C655064663A6B6C282266696C652D706466222C3630313339292C66696C655375626D6F64756C653A6B6C282266696C652D7375626D6F64756C65222C3630313430292C66696C6553796D6C696E6B44';
wwv_flow_imp.g_varchar2_table(4390) := '69726563746F72793A6B6C282266696C652D73796D6C696E6B2D6469726563746F7279222C3630313431292C66696C6553796D6C696E6B46696C653A6B6C282266696C652D73796D6C696E6B2D66696C65222C3630313432292C66696C655A69703A6B6C';
wwv_flow_imp.g_varchar2_table(4391) := '282266696C652D7A6970222C3630313433292C66696C65733A6B6C282266696C6573222C3630313434292C66696C7465723A6B6C282266696C746572222C3630313435292C666C616D653A6B6C2822666C616D65222C3630313436292C666F6C64446F77';
wwv_flow_imp.g_varchar2_table(4392) := '6E3A6B6C2822666F6C642D646F776E222C3630313437292C666F6C6455703A6B6C2822666F6C642D7570222C3630313438292C666F6C643A6B6C2822666F6C64222C3630313439292C666F6C6465724163746976653A6B6C2822666F6C6465722D616374';
wwv_flow_imp.g_varchar2_table(4393) := '697665222C3630313530292C666F6C6465724F70656E65643A6B6C2822666F6C6465722D6F70656E6564222C3630313531292C676561723A6B6C282267656172222C3630313532292C676966743A6B6C282267696674222C3630313533292C6769737453';
wwv_flow_imp.g_varchar2_table(4394) := '65637265743A6B6C2822676973742D736563726574222C3630313534292C676973743A6B6C282267697374222C3630313535292C676974436F6D6D69743A6B6C28226769742D636F6D6D6974222C3630313536292C676974436F6D706172653A6B6C2822';
wwv_flow_imp.g_varchar2_table(4395) := '6769742D636F6D70617265222C3630313537292C636F6D706172654368616E6765733A6B6C2822636F6D706172652D6368616E676573222C3630313537292C6769744D657267653A6B6C28226769742D6D65726765222C3630313538292C676974687562';
wwv_flow_imp.g_varchar2_table(4396) := '416374696F6E3A6B6C28226769746875622D616374696F6E222C3630313539292C676974687562416C743A6B6C28226769746875622D616C74222C3630313630292C676C6F62653A6B6C2822676C6F6265222C3630313631292C677261626265723A6B6C';
wwv_flow_imp.g_varchar2_table(4397) := '282267726162626572222C3630313632292C67726170683A6B6C28226772617068222C3630313633292C677269707065723A6B6C282267726970706572222C3630313634292C68656172743A6B6C28226865617274222C3630313635292C686F6D653A6B';
wwv_flow_imp.g_varchar2_table(4398) := '6C2822686F6D65222C3630313636292C686F72697A6F6E74616C52756C653A6B6C2822686F72697A6F6E74616C2D72756C65222C3630313637292C6875626F743A6B6C28226875626F74222C3630313638292C696E626F783A6B6C2822696E626F78222C';
wwv_flow_imp.g_varchar2_table(4399) := '3630313639292C697373756552656F70656E65643A6B6C282269737375652D72656F70656E6564222C3630313731292C6973737565733A6B6C2822697373756573222C3630313732292C6974616C69633A6B6C28226974616C6963222C3630313733292C';
wwv_flow_imp.g_varchar2_table(4400) := '6A65727365793A6B6C28226A6572736579222C3630313734292C6A736F6E3A6B6C28226A736F6E222C3630313735292C6B65626162566572746963616C3A6B6C28226B656261622D766572746963616C222C3630313736292C6B65793A6B6C28226B6579';
wwv_flow_imp.g_varchar2_table(4401) := '222C3630313737292C6C61773A6B6C28226C6177222C3630313738292C6C6967687462756C624175746F6669783A6B6C28226C6967687462756C622D6175746F666978222C3630313739292C6C696E6B45787465726E616C3A6B6C28226C696E6B2D6578';
wwv_flow_imp.g_varchar2_table(4402) := '7465726E616C222C3630313830292C6C696E6B3A6B6C28226C696E6B222C3630313831292C6C6973744F7264657265643A6B6C28226C6973742D6F726465726564222C3630313832292C6C697374556E6F7264657265643A6B6C28226C6973742D756E6F';
wwv_flow_imp.g_varchar2_table(4403) := '726465726564222C3630313833292C6C69766553686172653A6B6C28226C6976652D7368617265222C3630313834292C6C6F6164696E673A6B6C28226C6F6164696E67222C3630313835292C6C6F636174696F6E3A6B6C28226C6F636174696F6E222C36';
wwv_flow_imp.g_varchar2_table(4404) := '30313836292C6D61696C526561643A6B6C28226D61696C2D72656164222C3630313837292C6D61696C3A6B6C28226D61696C222C3630313838292C6D61726B646F776E3A6B6C28226D61726B646F776E222C3630313839292C6D65676170686F6E653A6B';
wwv_flow_imp.g_varchar2_table(4405) := '6C28226D65676170686F6E65222C3630313930292C6D656E74696F6E3A6B6C28226D656E74696F6E222C3630313931292C6D696C6573746F6E653A6B6C28226D696C6573746F6E65222C3630313932292C67697450756C6C526571756573744D696C6573';
wwv_flow_imp.g_varchar2_table(4406) := '746F6E653A6B6C28226769742D70756C6C2D726571756573742D6D696C6573746F6E65222C3630313932292C6D6F72746172426F6172643A6B6C28226D6F727461722D626F617264222C3630313933292C6D6F76653A6B6C28226D6F7665222C36303139';
wwv_flow_imp.g_varchar2_table(4407) := '34292C6D756C7469706C6557696E646F77733A6B6C28226D756C7469706C652D77696E646F7773222C3630313935292C6D7574653A6B6C28226D757465222C3630313936292C6E6F4E65776C696E653A6B6C28226E6F2D6E65776C696E65222C36303139';
wwv_flow_imp.g_varchar2_table(4408) := '37292C6E6F74653A6B6C28226E6F7465222C3630313938292C6F63746F666163653A6B6C28226F63746F66616365222C3630313939292C6F70656E507265766965773A6B6C28226F70656E2D70726576696577222C3630323030292C7061636B6167653A';
wwv_flow_imp.g_varchar2_table(4409) := '6B6C28227061636B616765222C3630323031292C7061696E7463616E3A6B6C28227061696E7463616E222C3630323032292C70696E3A6B6C282270696E222C3630323033292C706C61793A6B6C2822706C6179222C3630323034292C72756E3A6B6C2822';
wwv_flow_imp.g_varchar2_table(4410) := '72756E222C3630323034292C706C75673A6B6C2822706C7567222C3630323035292C7072657365727665436173653A6B6C282270726573657276652D63617365222C3630323036292C707265766965773A6B6C282270726576696577222C363032303729';
wwv_flow_imp.g_varchar2_table(4411) := '2C70726F6A6563743A6B6C282270726F6A656374222C3630323038292C70756C73653A6B6C282270756C7365222C3630323039292C7175657374696F6E3A6B6C28227175657374696F6E222C3630323130292C71756F74653A6B6C282271756F7465222C';
wwv_flow_imp.g_varchar2_table(4412) := '3630323131292C726164696F546F7765723A6B6C2822726164696F2D746F776572222C3630323132292C7265616374696F6E733A6B6C28227265616374696F6E73222C3630323133292C7265666572656E6365733A6B6C28227265666572656E63657322';
wwv_flow_imp.g_varchar2_table(4413) := '2C3630323134292C726566726573683A6B6C282272656672657368222C3630323135292C72656765783A6B6C28227265676578222C3630323136292C72656D6F74654578706C6F7265723A6B6C282272656D6F74652D6578706C6F726572222C36303231';
wwv_flow_imp.g_varchar2_table(4414) := '37292C72656D6F74653A6B6C282272656D6F7465222C3630323138292C72656D6F76653A6B6C282272656D6F7665222C3630323139292C7265706C616365416C6C3A6B6C28227265706C6163652D616C6C222C3630323230292C7265706C6163653A6B6C';
wwv_flow_imp.g_varchar2_table(4415) := '28227265706C616365222C3630323231292C7265706F436C6F6E653A6B6C28227265706F2D636C6F6E65222C3630323232292C7265706F466F726365507573683A6B6C28227265706F2D666F7263652D70757368222C3630323233292C7265706F50756C';
wwv_flow_imp.g_varchar2_table(4416) := '6C3A6B6C28227265706F2D70756C6C222C3630323234292C7265706F507573683A6B6C28227265706F2D70757368222C3630323235292C7265706F72743A6B6C28227265706F7274222C3630323236292C726571756573744368616E6765733A6B6C2822';
wwv_flow_imp.g_varchar2_table(4417) := '726571756573742D6368616E676573222C3630323237292C726F636B65743A6B6C2822726F636B6574222C3630323238292C726F6F74466F6C6465724F70656E65643A6B6C2822726F6F742D666F6C6465722D6F70656E6564222C3630323239292C726F';
wwv_flow_imp.g_varchar2_table(4418) := '6F74466F6C6465723A6B6C2822726F6F742D666F6C646572222C3630323330292C7273733A6B6C2822727373222C3630323331292C727562793A6B6C282272756279222C3630323332292C73617665416C6C3A6B6C2822736176652D616C6C222C363032';
wwv_flow_imp.g_varchar2_table(4419) := '3333292C7361766541733A6B6C2822736176652D6173222C3630323334292C736176653A6B6C282273617665222C3630323335292C73637265656E46756C6C3A6B6C282273637265656E2D66756C6C222C3630323336292C73637265656E4E6F726D616C';
wwv_flow_imp.g_varchar2_table(4420) := '3A6B6C282273637265656E2D6E6F726D616C222C3630323337292C73656172636853746F703A6B6C28227365617263682D73746F70222C3630323338292C7365727665723A6B6C2822736572766572222C3630323430292C73657474696E677347656172';
wwv_flow_imp.g_varchar2_table(4421) := '3A6B6C282273657474696E67732D67656172222C3630323431292C73657474696E67733A6B6C282273657474696E6773222C3630323432292C736869656C643A6B6C2822736869656C64222C3630323433292C736D696C65793A6B6C2822736D696C6579';
wwv_flow_imp.g_varchar2_table(4422) := '222C3630323434292C736F7274507265636564656E63653A6B6C2822736F72742D707265636564656E6365222C3630323435292C73706C6974486F72697A6F6E74616C3A6B6C282273706C69742D686F72697A6F6E74616C222C3630323436292C73706C';
wwv_flow_imp.g_varchar2_table(4423) := '6974566572746963616C3A6B6C282273706C69742D766572746963616C222C3630323437292C737175697272656C3A6B6C2822737175697272656C222C3630323438292C7374617246756C6C3A6B6C2822737461722D66756C6C222C3630323439292C73';
wwv_flow_imp.g_varchar2_table(4424) := '74617248616C663A6B6C2822737461722D68616C66222C3630323530292C73796D626F6C436C6173733A6B6C282273796D626F6C2D636C617373222C3630323531292C73796D626F6C436F6C6F723A6B6C282273796D626F6C2D636F6C6F72222C363032';
wwv_flow_imp.g_varchar2_table(4425) := '3532292C73796D626F6C436F6E7374616E743A6B6C282273796D626F6C2D636F6E7374616E74222C3630323533292C73796D626F6C456E756D4D656D6265723A6B6C282273796D626F6C2D656E756D2D6D656D626572222C3630323534292C73796D626F';
wwv_flow_imp.g_varchar2_table(4426) := '6C4669656C643A6B6C282273796D626F6C2D6669656C64222C3630323535292C73796D626F6C46696C653A6B6C282273796D626F6C2D66696C65222C3630323536292C73796D626F6C496E746572666163653A6B6C282273796D626F6C2D696E74657266';
wwv_flow_imp.g_varchar2_table(4427) := '616365222C3630323537292C73796D626F6C4B6579776F72643A6B6C282273796D626F6C2D6B6579776F7264222C3630323538292C73796D626F6C4D6973633A6B6C282273796D626F6C2D6D697363222C3630323539292C73796D626F6C4F7065726174';
wwv_flow_imp.g_varchar2_table(4428) := '6F723A6B6C282273796D626F6C2D6F70657261746F72222C3630323630292C73796D626F6C50726F70657274793A6B6C282273796D626F6C2D70726F7065727479222C3630323631292C7772656E63683A6B6C28227772656E6368222C3630323631292C';
wwv_flow_imp.g_varchar2_table(4429) := '7772656E6368537562616374696F6E3A6B6C28227772656E63682D737562616374696F6E222C3630323631292C73796D626F6C536E69707065743A6B6C282273796D626F6C2D736E6970706574222C3630323632292C7461736B6C6973743A6B6C282274';
wwv_flow_imp.g_varchar2_table(4430) := '61736B6C697374222C3630323633292C74656C6573636F70653A6B6C282274656C6573636F7065222C3630323634292C7465787453697A653A6B6C2822746578742D73697A65222C3630323635292C7468726565426172733A6B6C282274687265652D62';
wwv_flow_imp.g_varchar2_table(4431) := '617273222C3630323636292C7468756D6273646F776E3A6B6C28227468756D6273646F776E222C3630323637292C7468756D627375703A6B6C28227468756D62737570222C3630323638292C746F6F6C733A6B6C2822746F6F6C73222C3630323639292C';
wwv_flow_imp.g_varchar2_table(4432) := '747269616E676C65446F776E3A6B6C2822747269616E676C652D646F776E222C3630323730292C747269616E676C654C6566743A6B6C2822747269616E676C652D6C656674222C3630323731292C747269616E676C6552696768743A6B6C282274726961';
wwv_flow_imp.g_varchar2_table(4433) := '6E676C652D7269676874222C3630323732292C747269616E676C6555703A6B6C2822747269616E676C652D7570222C3630323733292C747769747465723A6B6C282274776974746572222C3630323734292C756E666F6C643A6B6C2822756E666F6C6422';
wwv_flow_imp.g_varchar2_table(4434) := '2C3630323735292C756E6C6F636B3A6B6C2822756E6C6F636B222C3630323736292C756E6D7574653A6B6C2822756E6D757465222C3630323737292C756E76657269666965643A6B6C2822756E7665726966696564222C3630323738292C766572696669';
wwv_flow_imp.g_varchar2_table(4435) := '65643A6B6C28227665726966696564222C3630323739292C76657273696F6E733A6B6C282276657273696F6E73222C3630323830292C766D4163746976653A6B6C2822766D2D616374697665222C3630323831292C766D4F75746C696E653A6B6C282276';
wwv_flow_imp.g_varchar2_table(4436) := '6D2D6F75746C696E65222C3630323832292C766D52756E6E696E673A6B6C2822766D2D72756E6E696E67222C3630323833292C77617463683A6B6C28227761746368222C3630323834292C776869746573706163653A6B6C282277686974657370616365';
wwv_flow_imp.g_varchar2_table(4437) := '222C3630323835292C77686F6C65576F72643A6B6C282277686F6C652D776F7264222C3630323836292C77696E646F773A6B6C282277696E646F77222C3630323837292C776F7264577261703A6B6C2822776F72642D77726170222C3630323838292C7A';
wwv_flow_imp.g_varchar2_table(4438) := '6F6F6D496E3A6B6C28227A6F6F6D2D696E222C3630323839292C7A6F6F6D4F75743A6B6C28227A6F6F6D2D6F7574222C3630323930292C6C69737446696C7465723A6B6C28226C6973742D66696C746572222C3630323931292C6C697374466C61743A6B';
wwv_flow_imp.g_varchar2_table(4439) := '6C28226C6973742D666C6174222C3630323932292C6C69737453656C656374696F6E3A6B6C28226C6973742D73656C656374696F6E222C3630323933292C73656C656374696F6E3A6B6C282273656C656374696F6E222C3630323933292C6C6973745472';
wwv_flow_imp.g_varchar2_table(4440) := '65653A6B6C28226C6973742D74726565222C3630323934292C6465627567427265616B706F696E7446756E6374696F6E556E76657269666965643A6B6C282264656275672D627265616B706F696E742D66756E6374696F6E2D756E766572696669656422';
wwv_flow_imp.g_varchar2_table(4441) := '2C3630323935292C6465627567427265616B706F696E7446756E6374696F6E3A6B6C282264656275672D627265616B706F696E742D66756E6374696F6E222C3630323936292C6465627567427265616B706F696E7446756E6374696F6E44697361626C65';
wwv_flow_imp.g_varchar2_table(4442) := '643A6B6C282264656275672D627265616B706F696E742D66756E6374696F6E2D64697361626C6564222C3630323936292C6465627567537461636B6672616D654163746976653A6B6C282264656275672D737461636B6672616D652D616374697665222C';
wwv_flow_imp.g_varchar2_table(4443) := '3630323937292C636972636C65536D616C6C46696C6C65643A6B6C2822636972636C652D736D616C6C2D66696C6C6564222C3630323938292C6465627567537461636B6672616D65446F743A6B6C282264656275672D737461636B6672616D652D646F74';
wwv_flow_imp.g_varchar2_table(4444) := '222C3630323938292C7465726D696E616C4465636F726174696F6E4D61726B3A6B6C28227465726D696E616C2D6465636F726174696F6E2D6D61726B222C3630323938292C6465627567537461636B6672616D653A6B6C282264656275672D737461636B';
wwv_flow_imp.g_varchar2_table(4445) := '6672616D65222C3630323939292C6465627567537461636B6672616D65466F63757365643A6B6C282264656275672D737461636B6672616D652D666F6375736564222C3630323939292C6465627567427265616B706F696E74556E737570706F72746564';
wwv_flow_imp.g_varchar2_table(4446) := '3A6B6C282264656275672D627265616B706F696E742D756E737570706F72746564222C3630333030292C73796D626F6C537472696E673A6B6C282273796D626F6C2D737472696E67222C3630333031292C646562756752657665727365436F6E74696E75';
wwv_flow_imp.g_varchar2_table(4447) := '653A6B6C282264656275672D726576657273652D636F6E74696E7565222C3630333032292C6465627567537465704261636B3A6B6C282264656275672D737465702D6261636B222C3630333033292C6465627567526573746172744672616D653A6B6C28';
wwv_flow_imp.g_varchar2_table(4448) := '2264656275672D726573746172742D6672616D65222C3630333034292C6465627567416C743A6B6C282264656275672D616C74222C3630333035292C63616C6C496E636F6D696E673A6B6C282263616C6C2D696E636F6D696E67222C3630333036292C63';
wwv_flow_imp.g_varchar2_table(4449) := '616C6C4F7574676F696E673A6B6C282263616C6C2D6F7574676F696E67222C3630333037292C6D656E753A6B6C28226D656E75222C3630333038292C657870616E64416C6C3A6B6C2822657870616E642D616C6C222C3630333039292C66656564626163';
wwv_flow_imp.g_varchar2_table(4450) := '6B3A6B6C2822666565646261636B222C3630333130292C67697450756C6C5265717565737452657669657765723A6B6C28226769742D70756C6C2D726571756573742D7265766965776572222C3630333130292C67726F75704279526566547970653A6B';
wwv_flow_imp.g_varchar2_table(4451) := '6C282267726F75702D62792D7265662D74797065222C3630333131292C756E67726F75704279526566547970653A6B6C2822756E67726F75702D62792D7265662D74797065222C3630333132292C6163636F756E743A6B6C28226163636F756E74222C36';
wwv_flow_imp.g_varchar2_table(4452) := '30333133292C67697450756C6C5265717565737441737369676E65653A6B6C28226769742D70756C6C2D726571756573742D61737369676E6565222C3630333133292C62656C6C446F743A6B6C282262656C6C2D646F74222C3630333134292C64656275';
wwv_flow_imp.g_varchar2_table(4453) := '67436F6E736F6C653A6B6C282264656275672D636F6E736F6C65222C3630333135292C6C6962726172793A6B6C28226C696272617279222C3630333136292C6F75747075743A6B6C28226F7574707574222C3630333137292C72756E416C6C3A6B6C2822';
wwv_flow_imp.g_varchar2_table(4454) := '72756E2D616C6C222C3630333138292C73796E6349676E6F7265643A6B6C282273796E632D69676E6F726564222C3630333139292C70696E6E65643A6B6C282270696E6E6564222C3630333230292C676974687562496E7665727465643A6B6C28226769';
wwv_flow_imp.g_varchar2_table(4455) := '746875622D696E766572746564222C3630333231292C73657276657250726F636573733A6B6C28227365727665722D70726F63657373222C3630333232292C736572766572456E7669726F6E6D656E743A6B6C28227365727665722D656E7669726F6E6D';
wwv_flow_imp.g_varchar2_table(4456) := '656E74222C3630333233292C706173733A6B6C282270617373222C3630333234292C6973737565436C6F7365643A6B6C282269737375652D636C6F736564222C3630333234292C73746F70436972636C653A6B6C282273746F702D636972636C65222C36';
wwv_flow_imp.g_varchar2_table(4457) := '30333235292C706C6179436972636C653A6B6C2822706C61792D636972636C65222C3630333236292C7265636F72643A6B6C28227265636F7264222C3630333237292C6465627567416C74536D616C6C3A6B6C282264656275672D616C742D736D616C6C';
wwv_flow_imp.g_varchar2_table(4458) := '222C3630333238292C766D436F6E6E6563743A6B6C2822766D2D636F6E6E656374222C3630333239292C636C6F75643A6B6C2822636C6F7564222C3630333330292C6D657267653A6B6C28226D65726765222C3630333331292C6578706F72743A6B6C28';
wwv_flow_imp.g_varchar2_table(4459) := '226578706F7274222C3630333332292C67726170684C6566743A6B6C282267726170682D6C656674222C3630333333292C6D61676E65743A6B6C28226D61676E6574222C3630333334292C6E6F7465626F6F6B3A6B6C28226E6F7465626F6F6B222C3630';
wwv_flow_imp.g_varchar2_table(4460) := '333335292C7265646F3A6B6C28227265646F222C3630333336292C636865636B416C6C3A6B6C2822636865636B2D616C6C222C3630333337292C70696E6E656444697274793A6B6C282270696E6E65642D6469727479222C3630333338292C7061737346';
wwv_flow_imp.g_varchar2_table(4461) := '696C6C65643A6B6C2822706173732D66696C6C6564222C3630333339292C636972636C654C6172676546696C6C65643A6B6C2822636972636C652D6C617267652D66696C6C6564222C3630333430292C636972636C654C617267653A6B6C282263697263';
wwv_flow_imp.g_varchar2_table(4462) := '6C652D6C61726765222C3630333431292C636972636C654C617267654F75746C696E653A6B6C2822636972636C652D6C617267652D6F75746C696E65222C3630333431292C636F6D62696E653A6B6C2822636F6D62696E65222C3630333432292C676174';
wwv_flow_imp.g_varchar2_table(4463) := '6865723A6B6C2822676174686572222C3630333432292C7461626C653A6B6C28227461626C65222C3630333433292C7661726961626C6547726F75703A6B6C28227661726961626C652D67726F7570222C3630333434292C747970654869657261726368';
wwv_flow_imp.g_varchar2_table(4464) := '793A6B6C2822747970652D686965726172636879222C3630333435292C747970654869657261726368795375623A6B6C2822747970652D6869657261726368792D737562222C3630333436292C7479706548696572617263687953757065723A6B6C2822';
wwv_flow_imp.g_varchar2_table(4465) := '747970652D6869657261726368792D7375706572222C3630333437292C67697450756C6C526571756573744372656174653A6B6C28226769742D70756C6C2D726571756573742D637265617465222C3630333438292C72756E41626F76653A6B6C282272';
wwv_flow_imp.g_varchar2_table(4466) := '756E2D61626F7665222C3630333439292C72756E42656C6F773A6B6C282272756E2D62656C6F77222C3630333530292C6E6F7465626F6F6B54656D706C6174653A6B6C28226E6F7465626F6F6B2D74656D706C617465222C3630333531292C6465627567';
wwv_flow_imp.g_varchar2_table(4467) := '526572756E3A6B6C282264656275672D726572756E222C3630333532292C776F726B7370616365547275737465643A6B6C2822776F726B73706163652D74727573746564222C3630333533292C776F726B7370616365556E747275737465643A6B6C2822';
wwv_flow_imp.g_varchar2_table(4468) := '776F726B73706163652D756E74727573746564222C3630333534292C776F726B7370616365556E6B6E6F776E3A6B6C2822776F726B73706163652D756E6B6E6F776E222C3630333535292C7465726D696E616C436D643A6B6C28227465726D696E616C2D';
wwv_flow_imp.g_varchar2_table(4469) := '636D64222C3630333536292C7465726D696E616C44656269616E3A6B6C28227465726D696E616C2D64656269616E222C3630333537292C7465726D696E616C4C696E75783A6B6C28227465726D696E616C2D6C696E7578222C3630333538292C7465726D';
wwv_flow_imp.g_varchar2_table(4470) := '696E616C506F7765727368656C6C3A6B6C28227465726D696E616C2D706F7765727368656C6C222C3630333539292C7465726D696E616C546D75783A6B6C28227465726D696E616C2D746D7578222C3630333630292C7465726D696E616C5562756E7475';
wwv_flow_imp.g_varchar2_table(4471) := '3A6B6C28227465726D696E616C2D7562756E7475222C3630333631292C7465726D696E616C426173683A6B6C28227465726D696E616C2D62617368222C3630333632292C6172726F77537761703A6B6C28226172726F772D73776170222C363033363329';
wwv_flow_imp.g_varchar2_table(4472) := '2C636F70793A6B6C2822636F7079222C3630333634292C706572736F6E4164643A6B6C2822706572736F6E2D616464222C3630333635292C66696C74657246696C6C65643A6B6C282266696C7465722D66696C6C6564222C3630333636292C77616E643A';
wwv_flow_imp.g_varchar2_table(4473) := '6B6C282277616E64222C3630333637292C64656275674C696E6542794C696E653A6B6C282264656275672D6C696E652D62792D6C696E65222C3630333638292C696E73706563743A6B6C2822696E7370656374222C3630333639292C6C61796572733A6B';
wwv_flow_imp.g_varchar2_table(4474) := '6C28226C6179657273222C3630333730292C6C6179657273446F743A6B6C28226C61796572732D646F74222C3630333731292C6C61796572734163746976653A6B6C28226C61796572732D616374697665222C3630333732292C636F6D706173733A6B6C';
wwv_flow_imp.g_varchar2_table(4475) := '2822636F6D70617373222C3630333733292C636F6D70617373446F743A6B6C2822636F6D706173732D646F74222C3630333734292C636F6D706173734163746976653A6B6C2822636F6D706173732D616374697665222C3630333735292C617A7572653A';
wwv_flow_imp.g_varchar2_table(4476) := '6B6C2822617A757265222C3630333736292C697373756544726166743A6B6C282269737375652D6472616674222C3630333737292C67697450756C6C52657175657374436C6F7365643A6B6C28226769742D70756C6C2D726571756573742D636C6F7365';
wwv_flow_imp.g_varchar2_table(4477) := '64222C3630333738292C67697450756C6C5265717565737444726166743A6B6C28226769742D70756C6C2D726571756573742D6472616674222C3630333739292C6465627567416C6C3A6B6C282264656275672D616C6C222C3630333830292C64656275';
wwv_flow_imp.g_varchar2_table(4478) := '67436F7665726167653A6B6C282264656275672D636F766572616765222C3630333831292C72756E4572726F72733A6B6C282272756E2D6572726F7273222C3630333832292C666F6C6465724C6962726172793A6B6C2822666F6C6465722D6C69627261';
wwv_flow_imp.g_varchar2_table(4479) := '7279222C3630333833292C6465627567436F6E74696E7565536D616C6C3A6B6C282264656275672D636F6E74696E75652D736D616C6C222C3630333834292C6265616B657253746F703A6B6C28226265616B65722D73746F70222C3630333835292C6772';
wwv_flow_imp.g_varchar2_table(4480) := '6170684C696E653A6B6C282267726170682D6C696E65222C3630333836292C6772617068536361747465723A6B6C282267726170682D73636174746572222C3630333837292C70696543686172743A6B6C28227069652D6368617274222C363033383829';
wwv_flow_imp.g_varchar2_table(4481) := '2C627261636B65743A6B6C2822627261636B6574222C3630313735292C627261636B6574446F743A6B6C2822627261636B65742D646F74222C3630333839292C627261636B65744572726F723A6B6C2822627261636B65742D6572726F72222C36303339';
wwv_flow_imp.g_varchar2_table(4482) := '30292C6C6F636B536D616C6C3A6B6C28226C6F636B2D736D616C6C222C3630333931292C617A7572654465766F70733A6B6C2822617A7572652D6465766F7073222C3630333932292C766572696669656446696C6C65643A6B6C28227665726966696564';
wwv_flow_imp.g_varchar2_table(4483) := '2D66696C6C6564222C3630333933292C6E65776C696E653A6B6C28226E65776C696E65222C3630333934292C6C61796F75743A6B6C28226C61796F7574222C3630333935292C6C61796F757441637469766974796261724C6566743A6B6C28226C61796F';
wwv_flow_imp.g_varchar2_table(4484) := '75742D61637469766974796261722D6C656674222C3630333936292C6C61796F7574416374697669747962617252696768743A6B6C28226C61796F75742D61637469766974796261722D7269676874222C3630333937292C6C61796F757450616E656C4C';
wwv_flow_imp.g_varchar2_table(4485) := '6566743A6B6C28226C61796F75742D70616E656C2D6C656674222C3630333938292C6C61796F757450616E656C43656E7465723A6B6C28226C61796F75742D70616E656C2D63656E746572222C3630333939292C6C61796F757450616E656C4A75737469';
wwv_flow_imp.g_varchar2_table(4486) := '66793A6B6C28226C61796F75742D70616E656C2D6A757374696679222C3630343030292C6C61796F757450616E656C52696768743A6B6C28226C61796F75742D70616E656C2D7269676874222C3630343031292C6C61796F757450616E656C3A6B6C2822';
wwv_flow_imp.g_varchar2_table(4487) := '6C61796F75742D70616E656C222C3630343032292C6C61796F7574536964656261724C6566743A6B6C28226C61796F75742D736964656261722D6C656674222C3630343033292C6C61796F75745369646562617252696768743A6B6C28226C61796F7574';
wwv_flow_imp.g_varchar2_table(4488) := '2D736964656261722D7269676874222C3630343034292C6C61796F75745374617475736261723A6B6C28226C61796F75742D737461747573626172222C3630343035292C6C61796F75744D656E756261723A6B6C28226C61796F75742D6D656E75626172';
wwv_flow_imp.g_varchar2_table(4489) := '222C3630343036292C6C61796F757443656E74657265643A6B6C28226C61796F75742D63656E7465726564222C3630343037292C7461726765743A6B6C2822746172676574222C3630343038292C696E64656E743A6B6C2822696E64656E74222C363034';
wwv_flow_imp.g_varchar2_table(4490) := '3039292C7265636F7264536D616C6C3A6B6C28227265636F72642D736D616C6C222C3630343130292C6572726F72536D616C6C3A6B6C28226572726F722D736D616C6C222C3630343131292C7465726D696E616C4465636F726174696F6E4572726F723A';
wwv_flow_imp.g_varchar2_table(4491) := '6B6C28227465726D696E616C2D6465636F726174696F6E2D6572726F72222C3630343131292C6172726F77436972636C65446F776E3A6B6C28226172726F772D636972636C652D646F776E222C3630343132292C6172726F77436972636C654C6566743A';
wwv_flow_imp.g_varchar2_table(4492) := '6B6C28226172726F772D636972636C652D6C656674222C3630343133292C6172726F77436972636C6552696768743A6B6C28226172726F772D636972636C652D7269676874222C3630343134292C6172726F77436972636C6555703A6B6C28226172726F';
wwv_flow_imp.g_varchar2_table(4493) := '772D636972636C652D7570222C3630343135292C6C61796F75745369646562617252696768744F66663A6B6C28226C61796F75742D736964656261722D72696768742D6F6666222C3630343136292C6C61796F757450616E656C4F66663A6B6C28226C61';
wwv_flow_imp.g_varchar2_table(4494) := '796F75742D70616E656C2D6F6666222C3630343137292C6C61796F7574536964656261724C6566744F66663A6B6C28226C61796F75742D736964656261722D6C6566742D6F6666222C3630343138292C626C616E6B3A6B6C2822626C616E6B222C363034';
wwv_flow_imp.g_varchar2_table(4495) := '3139292C686561727446696C6C65643A6B6C282268656172742D66696C6C6564222C3630343230292C6D61703A6B6C28226D6170222C3630343231292C6D6170486F72697A6F6E74616C3A6B6C28226D61702D686F72697A6F6E74616C222C3630343231';
wwv_flow_imp.g_varchar2_table(4496) := '292C666F6C64486F72697A6F6E74616C3A6B6C2822666F6C642D686F72697A6F6E74616C222C3630343231292C6D617046696C6C65643A6B6C28226D61702D66696C6C6564222C3630343232292C6D6170486F72697A6F6E74616C46696C6C65643A6B6C';
wwv_flow_imp.g_varchar2_table(4497) := '28226D61702D686F72697A6F6E74616C2D66696C6C6564222C3630343232292C666F6C64486F72697A6F6E74616C46696C6C65643A6B6C2822666F6C642D686F72697A6F6E74616C2D66696C6C6564222C3630343232292C636972636C65536D616C6C3A';
wwv_flow_imp.g_varchar2_table(4498) := '6B6C2822636972636C652D736D616C6C222C3630343233292C62656C6C536C6173683A6B6C282262656C6C2D736C617368222C3630343234292C62656C6C536C617368446F743A6B6C282262656C6C2D736C6173682D646F74222C3630343235292C636F';
wwv_flow_imp.g_varchar2_table(4499) := '6D6D656E74556E7265736F6C7665643A6B6C2822636F6D6D656E742D756E7265736F6C766564222C3630343236292C67697450756C6C52657175657374476F546F4368616E6765733A6B6C28226769742D70756C6C2D726571756573742D676F2D746F2D';
wwv_flow_imp.g_varchar2_table(4500) := '6368616E676573222C3630343237292C67697450756C6C526571756573744E65774368616E6765733A6B6C28226769742D70756C6C2D726571756573742D6E65772D6368616E676573222C3630343238292C73656172636846757A7A793A6B6C28227365';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(4501) := '617263682D66757A7A79222C3630343239292C636F6D6D656E7444726166743A6B6C2822636F6D6D656E742D6472616674222C3630343330292C73656E643A6B6C282273656E64222C3630343331292C737061726B6C653A6B6C2822737061726B6C6522';
wwv_flow_imp.g_varchar2_table(4502) := '2C3630343332292C696E736572743A6B6C2822696E73657274222C3630343333292C6D69633A6B6C28226D6963222C3630343334292C7468756D6273646F776E46696C6C65643A6B6C28227468756D6273646F776E2D66696C6C6564222C363034333529';
wwv_flow_imp.g_varchar2_table(4503) := '2C7468756D6273757046696C6C65643A6B6C28227468756D627375702D66696C6C6564222C3630343336292C636F666665653A6B6C2822636F66666565222C3630343337292C736E616B653A6B6C2822736E616B65222C3630343338292C67616D653A6B';
wwv_flow_imp.g_varchar2_table(4504) := '6C282267616D65222C3630343339292C76723A6B6C28227672222C3630343430292C636869703A6B6C282263686970222C3630343431292C7069616E6F3A6B6C28227069616E6F222C3630343432292C6D757369633A6B6C28226D75736963222C363034';
wwv_flow_imp.g_varchar2_table(4505) := '3433292C6D696346696C6C65643A6B6C28226D69632D66696C6C6564222C3630343434292C7265706F46657463683A6B6C28227265706F2D6665746368222C3630343435292C636F70696C6F743A6B6C2822636F70696C6F74222C3630343436292C6C69';
wwv_flow_imp.g_varchar2_table(4506) := '67687462756C62537061726B6C653A6B6C28226C6967687462756C622D737061726B6C65222C3630343437292C726F626F743A6B6C2822726F626F74222C3630343438292C737061726B6C6546696C6C65643A6B6C2822737061726B6C652D66696C6C65';
wwv_flow_imp.g_varchar2_table(4507) := '64222C3630343439292C6469666653696E676C653A6B6C2822646966662D73696E676C65222C3630343530292C646966664D756C7469706C653A6B6C2822646966662D6D756C7469706C65222C3630343531292C737572726F756E64576974683A6B6C28';
wwv_flow_imp.g_varchar2_table(4508) := '22737572726F756E642D77697468222C3630343532292C73686172653A6B6C28227368617265222C3630343533292C67697453746173683A6B6C28226769742D7374617368222C3630343534292C67697453746173684170706C793A6B6C28226769742D';
wwv_flow_imp.g_varchar2_table(4509) := '73746173682D6170706C79222C3630343535292C6769745374617368506F703A6B6C28226769742D73746173682D706F70222C3630343536292C7673636F64653A6B6C28227673636F6465222C3630343537292C7673636F6465496E7369646572733A6B';
wwv_flow_imp.g_varchar2_table(4510) := '6C28227673636F64652D696E736964657273222C3630343538292C636F64654F73733A6B6C2822636F64652D6F7373222C3630343539292C72756E436F7665726167653A6B6C282272756E2D636F766572616765222C3630343630292C72756E416C6C43';
wwv_flow_imp.g_varchar2_table(4511) := '6F7665726167653A6B6C282272756E2D616C6C2D636F766572616765222C3630343631292C636F7665726167653A6B6C2822636F766572616765222C3630343632292C67697468756250726F6A6563743A6B6C28226769746875622D70726F6A65637422';
wwv_flow_imp.g_varchar2_table(4512) := '2C3630343633292C6D6170566572746963616C3A6B6C28226D61702D766572746963616C222C3630343634292C666F6C64566572746963616C3A6B6C2822666F6C642D766572746963616C222C3630343634292C6D6170566572746963616C46696C6C65';
wwv_flow_imp.g_varchar2_table(4513) := '643A6B6C28226D61702D766572746963616C2D66696C6C6564222C3630343635292C666F6C64566572746963616C46696C6C65643A6B6C2822666F6C642D766572746963616C2D66696C6C6564222C3630343635292C676F546F5365617263683A6B6C28';
wwv_flow_imp.g_varchar2_table(4514) := '22676F2D746F2D736561726368222C3630343636292C70657263656E746167653A6B6C282270657263656E74616765222C3630343637292C736F727450657263656E746167653A6B6C2822736F72742D70657263656E74616765222C3630343637292C64';
wwv_flow_imp.g_varchar2_table(4515) := '69616C6F674572726F723A6B6C28226469616C6F672D6572726F72222C226572726F7222292C6469616C6F675761726E696E673A6B6C28226469616C6F672D7761726E696E67222C227761726E696E6722292C6469616C6F67496E666F3A6B6C28226469';
wwv_flow_imp.g_varchar2_table(4516) := '616C6F672D696E666F222C22696E666F22292C6469616C6F67436C6F73653A6B6C28226469616C6F672D636C6F7365222C22636C6F736522292C747265654974656D457870616E6465643A6B6C2822747265652D6974656D2D657870616E646564222C22';
wwv_flow_imp.g_varchar2_table(4517) := '63686576726F6E2D646F776E22292C7472656546696C7465724F6E547970654F6E3A6B6C2822747265652D66696C7465722D6F6E2D747970652D6F6E222C226C6973742D66696C74657222292C7472656546696C7465724F6E547970654F66663A6B6C28';
wwv_flow_imp.g_varchar2_table(4518) := '22747265652D66696C7465722D6F6E2D747970652D6F6666222C226C6973742D73656C656374696F6E22292C7472656546696C746572436C6561723A6B6C2822747265652D66696C7465722D636C656172222C22636C6F736522292C747265654974656D';
wwv_flow_imp.g_varchar2_table(4519) := '4C6F6164696E673A6B6C2822747265652D6974656D2D6C6F6164696E67222C226C6F6164696E6722292C6D656E7553656C656374696F6E3A6B6C28226D656E752D73656C656374696F6E222C22636865636B22292C6D656E755375626D656E753A6B6C28';
wwv_flow_imp.g_varchar2_table(4520) := '226D656E752D7375626D656E75222C2263686576726F6E2D726967687422292C6D656E754261724D6F72653A6B6C28226D656E756261722D6D6F7265222C226D6F726522292C7363726F6C6C626172427574746F6E4C6566743A6B6C28227363726F6C6C';
wwv_flow_imp.g_varchar2_table(4521) := '6261722D627574746F6E2D6C656674222C22747269616E676C652D6C65667422292C7363726F6C6C626172427574746F6E52696768743A6B6C28227363726F6C6C6261722D627574746F6E2D7269676874222C22747269616E676C652D72696768742229';
wwv_flow_imp.g_varchar2_table(4522) := '2C7363726F6C6C626172427574746F6E55703A6B6C28227363726F6C6C6261722D627574746F6E2D7570222C22747269616E676C652D757022292C7363726F6C6C626172427574746F6E446F776E3A6B6C28227363726F6C6C6261722D627574746F6E2D';
wwv_flow_imp.g_varchar2_table(4523) := '646F776E222C22747269616E676C652D646F776E22292C746F6F6C4261724D6F72653A6B6C2822746F6F6C6261722D6D6F7265222C226D6F726522292C717569636B496E7075744261636B3A6B6C2822717569636B2D696E7075742D6261636B222C2261';
wwv_flow_imp.g_varchar2_table(4524) := '72726F772D6C65667422292C64726F70446F776E427574746F6E3A6B6C282264726F702D646F776E2D627574746F6E222C3630303834292C73796D626F6C437573746F6D436F6C6F723A6B6C282273796D626F6C2D637573746F6D636F6C6F72222C3630';
wwv_flow_imp.g_varchar2_table(4525) := '323532292C6578706F727449636F6E3A6B6C28226578706F7274222C3630333332292C776F726B7370616365556E7370656369666965643A6B6C2822776F726B73706163652D756E737065636966696564222C3630333535292C6E65774C696E653A6B6C';
wwv_flow_imp.g_varchar2_table(4526) := '28226E65776C696E65222C3630333934292C7468756D6273446F776E46696C6C65643A6B6C28227468756D6273646F776E2D66696C6C6564222C3630343335292C7468756D6273557046696C6C65643A6B6C28227468756D627375702D66696C6C656422';
wwv_flow_imp.g_varchar2_table(4527) := '2C3630343336292C67697446657463683A6B6C28226769742D6665746368222C3630343435292C6C6967687462756C62537061726B6C654175746F6669783A6B6C28226C6967687462756C622D737061726B6C652D6175746F666978222C363034343729';
wwv_flow_imp.g_varchar2_table(4528) := '2C6465627567427265616B706F696E7450656E64696E673A6B6C282264656275672D627265616B706F696E742D70656E64696E67222C3630333737297D3B76617220446C2C546C3B2166756E6374696F6E2865297B652E69735468656D65436F6C6F723D';
wwv_flow_imp.g_varchar2_table(4529) := '66756E6374696F6E2865297B72657475726E20652626226F626A656374223D3D747970656F662065262622737472696E67223D3D747970656F6620652E69647D7D28446C7C7C28446C3D7B7D29292C66756E6374696F6E2865297B652E69636F6E4E616D';
wwv_flow_imp.g_varchar2_table(4530) := '655365676D656E743D225B412D5A612D7A302D395D2B222C652E69636F6E4E616D6545787072657373696F6E3D225B412D5A612D7A302D392D5D2B222C652E69636F6E4D6F64696669657245787072657373696F6E3D227E5B412D5A612D7A5D2B222C65';
wwv_flow_imp.g_varchar2_table(4531) := '2E69636F6E4E616D654368617261637465723D225B412D5A612D7A302D397E2D5D223B636F6E737420743D6E65772052656745787028605E28247B652E69636F6E4E616D6545787072657373696F6E7D2928247B652E69636F6E4D6F6469666965724578';
wwv_flow_imp.g_varchar2_table(4532) := '7072657373696F6E7D293F2460293B66756E6374696F6E206E2865297B636F6E737420693D742E6578656328652E6964293B69662821692972657475726E206E284C6C2E6572726F72293B636F6E73745B2C6F2C735D3D692C723D5B22636F6469636F6E';
wwv_flow_imp.g_varchar2_table(4533) := '222C22636F6469636F6E2D222B6F5D3B72657475726E20732626722E707573682822636F6469636F6E2D6D6F6469666965722D222B732E737562737472696E67283129292C727D652E6173436C6173734E616D6541727261793D6E2C652E6173436C6173';
wwv_flow_imp.g_varchar2_table(4534) := '734E616D653D66756E6374696F6E2865297B72657475726E206E2865292E6A6F696E28222022297D2C652E617343535353656C6563746F723D66756E6374696F6E2865297B72657475726E222E222B6E2865292E6A6F696E28222E22297D2C652E697354';
wwv_flow_imp.g_varchar2_table(4535) := '68656D6549636F6E3D66756E6374696F6E2865297B72657475726E20652626226F626A656374223D3D747970656F662065262622737472696E67223D3D747970656F6620652E6964262628766F696420303D3D3D652E636F6C6F727C7C446C2E69735468';
wwv_flow_imp.g_varchar2_table(4536) := '656D65436F6C6F7228652E636F6C6F7229297D3B636F6E737420693D6E65772052656745787028605E5C5C245C5C2828247B652E69636F6E4E616D6545787072657373696F6E7D283F3A247B652E69636F6E4D6F64696669657245787072657373696F6E';
wwv_flow_imp.g_varchar2_table(4537) := '7D293F295C5C292460293B652E66726F6D537472696E673D66756E6374696F6E2865297B636F6E737420743D692E657865632865293B69662821742972657475726E3B636F6E73745B2C6E5D3D743B72657475726E7B69643A6E7D7D2C652E66726F6D49';
wwv_flow_imp.g_varchar2_table(4538) := '643D66756E6374696F6E2865297B72657475726E7B69643A657D7D2C652E6D6F646966793D66756E6374696F6E28652C74297B6C6574206E3D652E69643B636F6E737420693D6E2E6C617374496E6465784F6628227E22293B72657475726E2D31213D3D';
wwv_flow_imp.g_varchar2_table(4539) := '692626286E3D6E2E737562737472696E6728302C6929292C742626286E3D60247B6E7D7E247B747D60292C7B69643A6E7D7D2C652E6765744D6F6469666965723D66756E6374696F6E2865297B636F6E737420743D652E69642E6C617374496E6465784F';
wwv_flow_imp.g_varchar2_table(4540) := '6628227E22293B6966282D31213D3D742972657475726E20652E69642E737562737472696E6728742B31297D2C652E6973457175616C3D66756E6374696F6E28652C74297B766172206E2C693B72657475726E20652E69643D3D3D742E69642626286E75';
wwv_flow_imp.g_varchar2_table(4541) := '6C6C3D3D3D286E3D652E636F6C6F72297C7C766F696420303D3D3D6E3F766F696420303A6E2E6964293D3D3D286E756C6C3D3D3D28693D742E636F6C6F72297C7C766F696420303D3D3D693F766F696420303A692E6964297D7D28546C7C7C28546C3D7B';
wwv_flow_imp.g_varchar2_table(4542) := '7D29293B636F6E737420496C3D6E65772052656745787028605C5C245C5C28247B546C2E69636F6E4E616D6545787072657373696F6E7D283F3A247B546C2E69636F6E4D6F64696669657245787072657373696F6E7D293F5C5C29602C226722292C4D6C';
wwv_flow_imp.g_varchar2_table(4543) := '3D6E6577205265674578702860285C5C5C5C293F247B496C2E736F757263657D602C226722292C416C3D6E65772052656745787028605C5C5C5C247B496C2E736F757263657D602C226722292C4E6C3D6E6577205265674578702860285C5C73293F285C';
wwv_flow_imp.g_varchar2_table(4544) := '5C5C5C293F247B496C2E736F757263657D285C5C73293F602C226722293B66756E6374696F6E20506C2865297B72657475726E2D313D3D3D652E696E6465784F662822242822293F653A652E7265706C616365284E6C2C2828652C742C6E2C69293D3E6E';
wwv_flow_imp.g_varchar2_table(4545) := '3F653A747C7C697C7C222229297D636F6E7374204F6C3D6E65772052656745787028605C5C245C5C28247B546C2E69636F6E4E616D654368617261637465727D2B5C5C29602C226722293B66756E6374696F6E20526C2865297B4F6C2E6C617374496E64';
wwv_flow_imp.g_varchar2_table(4546) := '65783D303B6C657420743D22223B636F6E7374206E3D5B5D3B6C657420693D303B666F72283B3B297B636F6E7374206F3D4F6C2E6C617374496E6465782C733D4F6C2E657865632865292C723D652E737562737472696E67286F2C6E756C6C3D3D733F76';
wwv_flow_imp.g_varchar2_table(4547) := '6F696420303A732E696E646578293B696628722E6C656E6774683E30297B742B3D723B666F72286C657420653D303B653C722E6C656E6774683B652B2B296E2E707573682869297D696628217329627265616B3B692B3D735B305D2E6C656E6774687D72';
wwv_flow_imp.g_varchar2_table(4548) := '657475726E7B746578743A742C69636F6E4F6666736574733A6E7D7D66756E6374696F6E20466C28652C742C6E3D2131297B636F6E73747B746578743A692C69636F6E4F6666736574733A6F7D3D743B696628216F7C7C303D3D3D6F2E6C656E67746829';
wwv_flow_imp.g_varchar2_table(4549) := '72657475726E20576128652C692C6E293B636F6E737420733D686928692C222022292C723D692E6C656E6774682D732E6C656E6774682C613D576128652C732C6E293B6966286129666F7228636F6E73742065206F662061297B636F6E737420743D6F5B';
wwv_flow_imp.g_varchar2_table(4550) := '652E73746172742B725D2B723B652E73746172742B3D742C652E656E642B3D747D72657475726E20617D66756E6374696F6E20426C2865297B72657475726E2034373D3D3D657C7C39323D3D3D657D66756E6374696F6E20566C2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(4551) := '20652E7265706C616365282F5B5C5C2F5D2F672C5F6F2E736570297D66756E6374696F6E207A6C28652C743D5F6F2E736570297B69662821652972657475726E22223B636F6E7374206E3D652E6C656E6774682C693D652E63686172436F646541742830';
wwv_flow_imp.g_varchar2_table(4552) := '293B696628426C286929297B696628426C28652E63686172436F6465417428312929262621426C28652E63686172436F6465417428322929297B6C657420693D333B636F6E7374206F3D693B666F72283B693C6E262621426C28652E63686172436F6465';
wwv_flow_imp.g_varchar2_table(4553) := '4174286929293B692B2B293B6966286F213D3D69262621426C28652E63686172436F6465417428692B31292929666F7228692B3D313B693C6E3B692B2B29696628426C28652E63686172436F64654174286929292972657475726E20652E736C69636528';
wwv_flow_imp.g_varchar2_table(4554) := '302C692B31292E7265706C616365282F5B5C5C2F5D2F672C74297D72657475726E20747D696628576C286929262635383D3D3D652E63686172436F646541742831292972657475726E20426C28652E63686172436F64654174283229293F652E736C6963';
wwv_flow_imp.g_varchar2_table(4555) := '6528302C32292B743A652E736C69636528302C32293B6C6574206F3D652E696E6465784F6628223A2F2F22293B6966282D31213D3D6F29666F72286F2B3D333B6F3C6E3B6F2B2B29696628426C28652E63686172436F64654174286F2929297265747572';
wwv_flow_imp.g_varchar2_table(4556) := '6E20652E736C69636528302C6F2B31293B72657475726E22227D66756E6374696F6E20486C28652C742C6E2C693D456F297B696628653D3D3D742972657475726E21303B69662821657C7C21742972657475726E21313B696628742E6C656E6774683E65';
wwv_flow_imp.g_varchar2_table(4557) := '2E6C656E6774682972657475726E21313B6966286E297B69662821456928652C74292972657475726E21313B696628742E6C656E6774683D3D3D652E6C656E6774682972657475726E21303B6C6574206E3D742E6C656E6774683B72657475726E20742E';
wwv_flow_imp.g_varchar2_table(4558) := '63686172417428742E6C656E6774682D31293D3D3D6926266E2D2D2C652E636861724174286E293D3D3D697D72657475726E20742E63686172417428742E6C656E6774682D3129213D3D69262628742B3D69292C303D3D3D652E696E6465784F66287429';
wwv_flow_imp.g_varchar2_table(4559) := '7D66756E6374696F6E20576C2865297B72657475726E20653E3D36352626653C3D39307C7C653E3D39372626653C3D3132327D66756E6374696F6E206A6C2865297B72657475726E20566F28652C2130297D636C61737320716C7B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(4560) := '6F722865297B746869732E5F69676E6F726550617468436173696E673D657D636F6D7061726528652C742C6E3D2131297B72657475726E20653D3D3D743F303A626928746869732E676574436F6D70617269736F6E4B657928652C6E292C746869732E67';
wwv_flow_imp.g_varchar2_table(4561) := '6574436F6D70617269736F6E4B657928742C6E29297D6973457175616C28652C742C6E3D2131297B72657475726E20653D3D3D747C7C212821657C7C2174292626746869732E676574436F6D70617269736F6E4B657928652C6E293D3D3D746869732E67';
wwv_flow_imp.g_varchar2_table(4562) := '6574436F6D70617269736F6E4B657928742C6E297D676574436F6D70617269736F6E4B657928652C743D2131297B72657475726E20652E77697468287B706174683A746869732E5F69676E6F726550617468436173696E672865293F652E706174682E74';
wwv_flow_imp.g_varchar2_table(4563) := '6F4C6F7765724361736528293A766F696420302C667261676D656E743A743F6E756C6C3A766F696420307D292E746F537472696E6728297D6973457175616C4F72506172656E7428652C742C6E3D2131297B696628652E736368656D653D3D3D742E7363';
wwv_flow_imp.g_varchar2_table(4564) := '68656D65297B696628652E736368656D653D3D3D716F2E66696C652972657475726E20486C286A6C2865292C6A6C2874292C746869732E5F69676E6F726550617468436173696E67286529292626652E71756572793D3D3D742E71756572792626286E7C';
wwv_flow_imp.g_varchar2_table(4565) := '7C652E667261676D656E743D3D3D742E667261676D656E74293B696628746328652E617574686F726974792C742E617574686F72697479292972657475726E20486C28652E706174682C742E706174682C746869732E5F69676E6F726550617468436173';
wwv_flow_imp.g_varchar2_table(4566) := '696E672865292C222F22292626652E71756572793D3D3D742E71756572792626286E7C7C652E667261676D656E743D3D3D742E667261676D656E74297D72657475726E21317D6A6F696E5061746828652C2E2E2E74297B72657475726E204E6F2E6A6F69';
wwv_flow_imp.g_varchar2_table(4567) := '6E5061746828652C2E2E2E74297D626173656E616D654F72417574686F726974792865297B72657475726E20476C2865297C7C652E617574686F726974797D626173656E616D652865297B72657475726E205F6F2E626173656E616D6528652E70617468';
wwv_flow_imp.g_varchar2_table(4568) := '297D6578746E616D652865297B72657475726E205F6F2E6578746E616D6528652E70617468297D6469726E616D652865297B696628303D3D3D652E706174682E6C656E6774682972657475726E20653B6C657420743B72657475726E20652E736368656D';
wwv_flow_imp.g_varchar2_table(4569) := '653D3D3D716F2E66696C653F743D4E6F2E66696C6528536F286A6C28652929292E706174683A28743D5F6F2E6469726E616D6528652E70617468292C652E617574686F726974792626742E6C656E67746826263437213D3D742E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(4570) := '283029262628636F6E736F6C652E6572726F7228606469726E616D652822247B652E746F537472696E677D292920726573756C74656420696E20612072656C6174697665207061746860292C743D222F2229292C652E77697468287B706174683A747D29';
wwv_flow_imp.g_varchar2_table(4571) := '7D6E6F726D616C697A65506174682865297B69662821652E706174682E6C656E6774682972657475726E20653B6C657420743B72657475726E20743D652E736368656D653D3D3D716F2E66696C653F4E6F2E66696C6528796F286A6C28652929292E7061';
wwv_flow_imp.g_varchar2_table(4572) := '74683A5F6F2E6E6F726D616C697A6528652E70617468292C652E77697468287B706174683A747D297D72656C61746976655061746828652C74297B696628652E736368656D65213D3D742E736368656D657C7C21746328652E617574686F726974792C74';
wwv_flow_imp.g_varchar2_table(4573) := '2E617574686F72697479292972657475726E3B696628652E736368656D653D3D3D716F2E66696C65297B636F6E7374206E3D436F286A6C2865292C6A6C287429293B72657475726E206A3F566C286E293A6E7D6C6574206E3D652E706174687C7C222F22';
wwv_flow_imp.g_varchar2_table(4574) := '3B636F6E737420693D742E706174687C7C222F223B696628746869732E5F69676E6F726550617468436173696E67286529297B6C657420653D303B666F7228636F6E737420743D4D6174682E6D696E286E2E6C656E6774682C692E6C656E677468293B65';
wwv_flow_imp.g_varchar2_table(4575) := '3C742626286E2E63686172436F646541742865293D3D3D692E63686172436F646541742865297C7C6E2E6368617241742865292E746F4C6F7765724361736528293D3D3D692E6368617241742865292E746F4C6F776572436173652829293B652B2B293B';
wwv_flow_imp.g_varchar2_table(4576) := '6E3D692E73756273747228302C65292B6E2E7375627374722865297D72657475726E205F6F2E72656C6174697665286E2C69297D7265736F6C76655061746828652C74297B696628652E736368656D653D3D3D716F2E66696C65297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(4577) := '4E6F2E66696C6528776F286A6C2865292C7429293B72657475726E20652E77697468287B617574686F726974793A6E2E617574686F726974792C706174683A6E2E706174687D297D766172206E3B72657475726E2D313D3D3D286E3D74292E696E646578';
wwv_flow_imp.g_varchar2_table(4578) := '4F6628222F22292626286E3D566C286E29292C2F5E5B612D7A412D5A5D3A285C2F7C24292F2E74657374286E292626286E3D222F222B6E292C743D6E2C652E77697468287B706174683A5F6F2E7265736F6C766528652E706174682C74297D297D697341';
wwv_flow_imp.g_varchar2_table(4579) := '62736F6C757465506174682865297B72657475726E2121652E706174682626222F223D3D3D652E706174685B305D7D6973457175616C417574686F7269747928652C74297B72657475726E20653D3D3D747C7C766F69642030213D3D652626766F696420';
wwv_flow_imp.g_varchar2_table(4580) := '30213D3D7426266B6928652C74297D686173547261696C696E6750617468536570617261746F7228652C743D456F297B696628652E736368656D653D3D3D716F2E66696C65297B636F6E7374206E3D6A6C2865293B72657475726E206E2E6C656E677468';
wwv_flow_imp.g_varchar2_table(4581) := '3E7A6C286E292E6C656E67746826266E5B6E2E6C656E6774682D315D3D3D3D747D7B636F6E737420743D652E706174683B72657475726E20742E6C656E6774683E31262634373D3D3D742E63686172436F6465417428742E6C656E6774682D3129262621';
wwv_flow_imp.g_varchar2_table(4582) := '2F5E5B612D7A412D5A5D3A285C2F247C5C5C24292F2E7465737428652E667350617468297D7D72656D6F7665547261696C696E6750617468536570617261746F7228652C743D456F297B72657475726E206E6328652C74293F652E77697468287B706174';
wwv_flow_imp.g_varchar2_table(4583) := '683A652E706174682E73756273747228302C652E706174682E6C656E6774682D31297D293A657D616464547261696C696E6750617468536570617261746F7228652C743D456F297B6C6574206E3D21313B696628652E736368656D653D3D3D716F2E6669';
wwv_flow_imp.g_varchar2_table(4584) := '6C65297B636F6E737420693D6A6C2865293B6E3D766F69642030213D3D692626692E6C656E6774683D3D3D7A6C2869292E6C656E6774682626695B692E6C656E6774682D315D3D3D3D747D656C73657B743D222F223B636F6E737420693D652E70617468';
wwv_flow_imp.g_varchar2_table(4585) := '3B6E3D313D3D3D692E6C656E677468262634373D3D3D692E63686172436F6465417428692E6C656E6774682D31297D72657475726E206E7C7C6E6328652C74293F653A652E77697468287B706174683A652E706174682B222F227D297D7D636F6E737420';
wwv_flow_imp.g_varchar2_table(4586) := '246C3D6E657720716C282828293D3E213129292C556C3D286E657720716C2828653D3E652E736368656D65213D3D716F2E66696C657C7C212429292C6E657720716C2828653D3E213029292C246C2E6973457175616C2E62696E6428246C29292C4B6C3D';
wwv_flow_imp.g_varchar2_table(4587) := '28246C2E6973457175616C4F72506172656E742E62696E6428246C292C246C2E676574436F6D70617269736F6E4B65792E62696E6428246C292C246C2E626173656E616D654F72417574686F726974792E62696E6428246C29292C476C3D246C2E626173';
wwv_flow_imp.g_varchar2_table(4588) := '656E616D652E62696E6428246C292C516C3D246C2E6578746E616D652E62696E6428246C292C596C3D246C2E6469726E616D652E62696E6428246C292C5A6C3D246C2E6A6F696E506174682E62696E6428246C292C586C3D246C2E6E6F726D616C697A65';
wwv_flow_imp.g_varchar2_table(4589) := '506174682E62696E6428246C292C4A6C3D246C2E72656C6174697665506174682E62696E6428246C292C65633D246C2E7265736F6C7665506174682E62696E6428246C292C74633D28246C2E69734162736F6C757465506174682E62696E6428246C292C';
wwv_flow_imp.g_varchar2_table(4590) := '246C2E6973457175616C417574686F726974792E62696E6428246C29292C6E633D246C2E686173547261696C696E6750617468536570617261746F722E62696E6428246C293B7661722069633B246C2E72656D6F7665547261696C696E67506174685365';
wwv_flow_imp.g_varchar2_table(4591) := '70617261746F722E62696E6428246C292C246C2E616464547261696C696E6750617468536570617261746F722E62696E6428246C292C66756E6374696F6E2865297B652E4D4554415F444154415F4C4142454C3D226C6162656C222C652E4D4554415F44';
wwv_flow_imp.g_varchar2_table(4592) := '4154415F4445534352495054494F4E3D226465736372697074696F6E222C652E4D4554415F444154415F53495A453D2273697A65222C652E4D4554415F444154415F4D494D453D226D696D65222C652E70617273654D657461446174613D66756E637469';
wwv_flow_imp.g_varchar2_table(4593) := '6F6E2874297B636F6E7374206E3D6E6577204D61703B742E706174682E737562737472696E6728742E706174682E696E6465784F6628223B22292B312C742E706174682E6C617374496E6465784F6628223B2229292E73706C697428223B22292E666F72';
wwv_flow_imp.g_varchar2_table(4594) := '456163682828653D3E7B636F6E73745B742C695D3D652E73706C697428223A22293B7426266926266E2E73657428742C69297D29293B636F6E737420693D742E706174682E737562737472696E6728302C742E706174682E696E6465784F6628223B2229';
wwv_flow_imp.g_varchar2_table(4595) := '293B72657475726E206926266E2E73657428652E4D4554415F444154415F4D494D452C69292C6E7D7D2869637C7C2869633D7B7D29293B636C617373206F637B636F6E7374727563746F7228653D22222C743D2131297B766172206E2C692C6F3B696628';
wwv_flow_imp.g_varchar2_table(4596) := '746869732E76616C75653D652C22737472696E6722213D747970656F6620746869732E76616C7565297468726F77204D65282276616C756522293B22626F6F6C65616E223D3D747970656F6620743F28746869732E6973547275737465643D742C746869';
wwv_flow_imp.g_varchar2_table(4597) := '732E737570706F72745468656D6549636F6E733D21312C746869732E737570706F727448746D6C3D2131293A28746869732E6973547275737465643D6E756C6C213D3D286E3D742E697354727573746564292626766F69642030213D3D6E3F6E3A766F69';
wwv_flow_imp.g_varchar2_table(4598) := '6420302C746869732E737570706F72745468656D6549636F6E733D6E756C6C213D3D28693D742E737570706F72745468656D6549636F6E73292626766F69642030213D3D692626692C746869732E737570706F727448746D6C3D6E756C6C213D3D286F3D';
wwv_flow_imp.g_varchar2_table(4599) := '742E737570706F727448746D6C292626766F69642030213D3D6F26266F297D617070656E645465787428652C743D30297B766172206E3B72657475726E20746869732E76616C75652B3D66756E6374696F6E2865297B72657475726E20652E7265706C61';
wwv_flow_imp.g_varchar2_table(4600) := '6365282F5B5C5C602A5F7B7D5B5C5D2829232B5C2D217E5D2F672C225C5C242622297D28746869732E737570706F72745468656D6549636F6E733F286E3D652C6E2E7265706C616365284D6C2C2828652C74293D3E743F653A605C5C247B657D60292929';
wwv_flow_imp.g_varchar2_table(4601) := '3A65292E7265706C616365282F285B205C745D2B292F672C2828652C74293D3E22266E6273703B222E72657065617428742E6C656E6774682929292E7265706C616365282F5C3E2F676D2C225C5C3E22292E7265706C616365282F5C6E2F672C313D3D3D';
wwv_flow_imp.g_varchar2_table(4602) := '743F225C5C5C6E223A225C6E5C6E22292C746869737D617070656E644D61726B646F776E2865297B72657475726E20746869732E76616C75652B3D652C746869737D617070656E64436F6465626C6F636B28652C74297B72657475726E20746869732E76';
wwv_flow_imp.g_varchar2_table(4603) := '616C75652B3D605C6E247B66756E6374696F6E28652C74297B766172206E2C693B636F6E7374206F3D6E756C6C213D3D28693D6E756C6C3D3D3D286E3D652E6D61746368282F5E602B2F676D29297C7C766F696420303D3D3D6E3F766F696420303A6E2E';
wwv_flow_imp.g_varchar2_table(4604) := '726564756365282828652C74293D3E652E6C656E6774683E742E6C656E6774683F653A7429292E6C656E677468292626766F69642030213D3D693F693A302C733D6F3E3D333F6F2B313A333B72657475726E5B60247B2260222E7265706561742873297D';
wwv_flow_imp.g_varchar2_table(4605) := '247B747D602C652C60247B2260222E7265706561742873297D605D2E6A6F696E28225C6E22297D28742C65297D5C6E602C746869737D617070656E644C696E6B28652C742C6E297B72657475726E20746869732E76616C75652B3D225B222C746869732E';
wwv_flow_imp.g_varchar2_table(4606) := '76616C75652B3D746869732E5F65736361706528742C225D22292C746869732E76616C75652B3D225D28222C746869732E76616C75652B3D746869732E5F65736361706528537472696E672865292C222922292C6E262628746869732E76616C75652B3D';
wwv_flow_imp.g_varchar2_table(4607) := '602022247B746869732E5F65736361706528746869732E5F657363617065286E2C272227292C222922297D2260292C746869732E76616C75652B3D2229222C746869737D5F65736361706528652C74297B636F6E7374206E3D6E65772052656745787028';
wwv_flow_imp.g_varchar2_table(4608) := '63692874292C226722293B72657475726E20652E7265706C616365286E2C2828742C6E293D3E225C5C22213D3D652E636861724174286E2D31293F605C5C247B747D603A7429297D7D66756E6374696F6E2073632865297B72657475726E207263286529';
wwv_flow_imp.g_varchar2_table(4609) := '3F21652E76616C75653A2141727261792E697341727261792865297C7C652E6576657279287363297D66756E6374696F6E2072632865297B72657475726E206520696E7374616E63656F66206F637C7C212821657C7C226F626A65637422213D74797065';
wwv_flow_imp.g_varchar2_table(4610) := '6F662065292626212822737472696E6722213D747970656F6620652E76616C75657C7C22626F6F6C65616E22213D747970656F6620652E6973547275737465642626226F626A65637422213D747970656F6620652E6973547275737465642626766F6964';
wwv_flow_imp.g_varchar2_table(4611) := '2030213D3D652E6973547275737465647C7C22626F6F6C65616E22213D747970656F6620652E737570706F72745468656D6549636F6E732626766F69642030213D3D652E737570706F72745468656D6549636F6E73297D66756E6374696F6E2061632865';
wwv_flow_imp.g_varchar2_table(4612) := '297B72657475726E20652E7265706C616365282F222F672C222671756F743B22297D66756E6374696F6E206C632865297B72657475726E20653F652E7265706C616365282F5C5C285B5C5C602A5F7B7D5B5C5D2829232B5C2D2E217E5D292F672C222431';
wwv_flow_imp.g_varchar2_table(4613) := '22293A657D7661722063632C64633D6E2832373535292C68633D7B7D3B68632E7374796C655461675472616E73666F726D3D6A7228292C68632E736574417474726962757465733D567228292C68632E696E736572743D467228292E62696E64286E756C';
wwv_flow_imp.g_varchar2_table(4614) := '6C2C226865616422292C68632E646F6D4150493D4F7228292C68632E696E736572745374796C65456C656D656E743D487228292C4E7228292864632E412C6863292C64632E41262664632E412E6C6F63616C73262664632E412E6C6F63616C732C66756E';
wwv_flow_imp.g_varchar2_table(4615) := '6374696F6E2865297B652E736572766963654964733D6E6577204D61702C652E44495F5441524745543D2224646924746172676574222C652E44495F444550454E44454E434945533D2224646924646570656E64656E63696573222C652E676574536572';
wwv_flow_imp.g_varchar2_table(4616) := '76696365446570656E64656E636965733D66756E6374696F6E2874297B72657475726E20745B652E44495F444550454E44454E434945535D7C7C5B5D7D7D2863637C7C2863633D7B7D29293B636F6E73742075633D70632822696E7374616E7469617469';
wwv_flow_imp.g_varchar2_table(4617) := '6F6E5365727669636522293B66756E6374696F6E2070632865297B69662863632E736572766963654964732E6861732865292972657475726E2063632E736572766963654964732E6765742865293B636F6E737420743D66756E6374696F6E28652C6E2C';
wwv_flow_imp.g_varchar2_table(4618) := '69297B69662833213D3D617267756D656E74732E6C656E677468297468726F77206E6577204572726F7228224049536572766963654E616D652D6465636F7261746F722063616E206F6E6C79206265207573656420746F206465636F7261746520612070';
wwv_flow_imp.g_varchar2_table(4619) := '6172616D6574657222293B2166756E6374696F6E28652C742C6E297B745B63632E44495F5441524745545D3D3D3D743F745B63632E44495F444550454E44454E434945535D2E70757368287B69643A652C696E6465783A6E7D293A28745B63632E44495F';
wwv_flow_imp.g_varchar2_table(4620) := '444550454E44454E434945535D3D5B7B69643A652C696E6465783A6E7D5D2C745B63632E44495F5441524745545D3D74297D28742C652C69297D3B72657475726E20742E746F537472696E673D28293D3E652C63632E736572766963654964732E736574';
wwv_flow_imp.g_varchar2_table(4621) := '28652C74292C747D636F6E73742067633D70632822636F6465456469746F725365727669636522293B636C617373206D637B636F6E7374727563746F7228652C74297B746869732E6C696E654E756D6265723D652C746869732E636F6C756D6E3D747D77';
wwv_flow_imp.g_varchar2_table(4622) := '69746828653D746869732E6C696E654E756D6265722C743D746869732E636F6C756D6E297B72657475726E20653D3D3D746869732E6C696E654E756D6265722626743D3D3D746869732E636F6C756D6E3F746869733A6E6577206D6328652C74297D6465';
wwv_flow_imp.g_varchar2_table(4623) := '6C746128653D302C743D30297B72657475726E20746869732E7769746828746869732E6C696E654E756D6265722B652C746869732E636F6C756D6E2B74297D657175616C732865297B72657475726E206D632E657175616C7328746869732C65297D7374';
wwv_flow_imp.g_varchar2_table(4624) := '6174696320657175616C7328652C74297B72657475726E2165262621747C7C21216526262121742626652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265722626652E636F6C756D6E3D3D3D742E636F6C756D6E7D69734265666F72652865';
wwv_flow_imp.g_varchar2_table(4625) := '297B72657475726E206D632E69734265666F726528746869732C65297D7374617469632069734265666F726528652C74297B72657475726E20652E6C696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C65';
wwv_flow_imp.g_varchar2_table(4626) := '2E6C696E654E756D626572292626652E636F6C756D6E3C742E636F6C756D6E7D69734265666F72654F72457175616C2865297B72657475726E206D632E69734265666F72654F72457175616C28746869732C65297D7374617469632069734265666F7265';
wwv_flow_imp.g_varchar2_table(4627) := '4F72457175616C28652C74297B72657475726E20652E6C696E654E756D6265723C742E6C696E654E756D6265727C7C2128742E6C696E654E756D6265723C652E6C696E654E756D626572292626652E636F6C756D6E3C3D742E636F6C756D6E7D73746174';
wwv_flow_imp.g_varchar2_table(4628) := '696320636F6D7061726528652C74297B636F6E7374206E3D307C652E6C696E654E756D6265722C693D307C742E6C696E654E756D6265723B72657475726E206E3D3D3D693F28307C652E636F6C756D6E292D28307C742E636F6C756D6E293A6E2D697D63';
wwv_flow_imp.g_varchar2_table(4629) := '6C6F6E6528297B72657475726E206E6577206D6328746869732E6C696E654E756D6265722C746869732E636F6C756D6E297D746F537472696E6728297B72657475726E2228222B746869732E6C696E654E756D6265722B222C222B746869732E636F6C75';
wwv_flow_imp.g_varchar2_table(4630) := '6D6E2B2229227D737461746963206C6966742865297B72657475726E206E6577206D6328652E6C696E654E756D6265722C652E636F6C756D6E297D73746174696320697349506F736974696F6E2865297B72657475726E20652626226E756D626572223D';
wwv_flow_imp.g_varchar2_table(4631) := '3D747970656F6620652E6C696E654E756D6265722626226E756D626572223D3D747970656F6620652E636F6C756D6E7D746F4A534F4E28297B72657475726E7B6C696E654E756D6265723A746869732E6C696E654E756D6265722C636F6C756D6E3A7468';
wwv_flow_imp.g_varchar2_table(4632) := '69732E636F6C756D6E7D7D7D636F6E73742066633D706328226D6F64656C5365727669636522292C76633D70632822746578744D6F64656C5365727669636522293B636C61737320626320657874656E6473206C747B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(4633) := '743D22222C6E3D22222C693D21302C6F297B737570657228292C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(4634) := '652E6576656E742C746869732E5F656E61626C65643D21302C746869732E5F69643D652C746869732E5F6C6162656C3D742C746869732E5F637373436C6173733D6E2C746869732E5F656E61626C65643D692C746869732E5F616374696F6E43616C6C62';
wwv_flow_imp.g_varchar2_table(4635) := '61636B3D6F7D67657420696428297B72657475726E20746869732E5F69647D676574206C6162656C28297B72657475726E20746869732E5F6C6162656C7D736574206C6162656C2865297B746869732E5F7365744C6162656C2865297D5F7365744C6162';
wwv_flow_imp.g_varchar2_table(4636) := '656C2865297B746869732E5F6C6162656C213D3D65262628746869732E5F6C6162656C3D652C746869732E5F6F6E4469644368616E67652E66697265287B6C6162656C3A657D29297D67657420746F6F6C74697028297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(4637) := '746F6F6C7469707C7C22227D73657420746F6F6C7469702865297B746869732E5F736574546F6F6C7469702865297D5F736574546F6F6C7469702865297B746869732E5F746F6F6C746970213D3D65262628746869732E5F746F6F6C7469703D652C7468';
wwv_flow_imp.g_varchar2_table(4638) := '69732E5F6F6E4469644368616E67652E66697265287B746F6F6C7469703A657D29297D67657420636C61737328297B72657475726E20746869732E5F637373436C6173737D73657420636C6173732865297B746869732E5F736574436C6173732865297D';
wwv_flow_imp.g_varchar2_table(4639) := '5F736574436C6173732865297B746869732E5F637373436C617373213D3D65262628746869732E5F637373436C6173733D652C746869732E5F6F6E4469644368616E67652E66697265287B636C6173733A657D29297D67657420656E61626C656428297B';
wwv_flow_imp.g_varchar2_table(4640) := '72657475726E20746869732E5F656E61626C65647D73657420656E61626C65642865297B746869732E5F736574456E61626C65642865297D5F736574456E61626C65642865297B746869732E5F656E61626C6564213D3D65262628746869732E5F656E61';
wwv_flow_imp.g_varchar2_table(4641) := '626C65643D652C746869732E5F6F6E4469644368616E67652E66697265287B656E61626C65643A657D29297D67657420636865636B656428297B72657475726E20746869732E5F636865636B65647D73657420636865636B65642865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(4642) := '736574436865636B65642865297D5F736574436865636B65642865297B746869732E5F636865636B6564213D3D65262628746869732E5F636865636B65643D652C746869732E5F6F6E4469644368616E67652E66697265287B636865636B65643A657D29';
wwv_flow_imp.g_varchar2_table(4643) := '297D6173796E632072756E28652C74297B746869732E5F616374696F6E43616C6C6261636B2626617761697420746869732E5F616374696F6E43616C6C6261636B2865297D7D636C617373205F6320657874656E6473206C747B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(4644) := '7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F6F6E57696C6C52756E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E57696C6C52756E3D746869732E5F6F6E57696C6C52756E2E6576656E742C';
wwv_flow_imp.g_varchar2_table(4645) := '746869732E5F6F6E44696452756E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696452756E3D746869732E5F6F6E44696452756E2E6576656E747D6173796E632072756E28652C74297B69662821652E656E61626C65';
wwv_flow_imp.g_varchar2_table(4646) := '642972657475726E3B6C6574206E3B746869732E5F6F6E57696C6C52756E2E66697265287B616374696F6E3A657D293B7472797B617761697420746869732E72756E416374696F6E28652C74297D63617463682865297B6E3D657D746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(4647) := '696452756E2E66697265287B616374696F6E3A652C6572726F723A6E7D297D6173796E632072756E416374696F6E28652C74297B617761697420652E72756E2874297D7D636C6173732079637B636F6E7374727563746F7228297B746869732E69643D79';
wwv_flow_imp.g_varchar2_table(4648) := '632E49442C746869732E6C6162656C3D22222C746869732E746F6F6C7469703D22222C746869732E636C6173733D22736570617261746F72222C746869732E656E61626C65643D21312C746869732E636865636B65643D21317D737461746963206A6F69';
wwv_flow_imp.g_varchar2_table(4649) := '6E282E2E2E65297B6C657420743D5B5D3B666F7228636F6E7374206E206F662065296E2E6C656E677468262628743D742E6C656E6774683F5B2E2E2E742C6E65772079632C2E2E2E6E5D3A6E293B72657475726E20747D6173796E632072756E28297B7D';
wwv_flow_imp.g_varchar2_table(4650) := '7D79632E49443D2276732E616374696F6E732E736570617261746F72223B636C6173732077637B67657420616374696F6E7328297B72657475726E20746869732E5F616374696F6E737D636F6E7374727563746F7228652C742C6E2C69297B746869732E';
wwv_flow_imp.g_varchar2_table(4651) := '746F6F6C7469703D22222C746869732E656E61626C65643D21302C746869732E636865636B65643D766F696420302C746869732E69643D652C746869732E6C6162656C3D742C746869732E636C6173733D692C746869732E5F616374696F6E733D6E7D61';
wwv_flow_imp.g_varchar2_table(4652) := '73796E632072756E28297B7D7D636C61737320436320657874656E64732062637B636F6E7374727563746F7228297B73757065722843632E49442C6228302C2228656D7074792922292C766F696420302C2131297D7D66756E6374696F6E205363286529';
wwv_flow_imp.g_varchar2_table(4653) := '7B76617220743B72657475726E7B69643A652E69642C6C6162656C3A652E6C6162656C2C636C6173733A652E636C6173732C656E61626C65643A6E756C6C3D3D3D28743D652E656E61626C6564297C7C766F696420303D3D3D747C7C742C636865636B65';
wwv_flow_imp.g_varchar2_table(4654) := '643A652E636865636B65642C72756E3A6173796E63282E2E2E74293D3E652E72756E282E2E2E74292C746F6F6C7469703A652E6C6162656C7D7D43632E49443D2276732E616374696F6E732E656D707479223B636F6E73742078633D70632822636F6D6D';
wwv_flow_imp.g_varchar2_table(4655) := '616E645365727669636522292C6B633D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F636F6D6D616E64733D6E6577204D61702C746869732E5F6F6E4469645265676973746572436F6D6D616E643D6E65772043742C746869';
wwv_flow_imp.g_varchar2_table(4656) := '732E6F6E4469645265676973746572436F6D6D616E643D746869732E5F6F6E4469645265676973746572436F6D6D616E642E6576656E747D7265676973746572436F6D6D616E6428652C74297B6966282165297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(4657) := '696E76616C696420636F6D6D616E6422293B69662822737472696E67223D3D747970656F662065297B6966282174297468726F77206E6577204572726F722822696E76616C696420636F6D6D616E6422293B72657475726E20746869732E726567697374';
wwv_flow_imp.g_varchar2_table(4658) := '6572436F6D6D616E64287B69643A652C68616E646C65723A747D297D696628652E6D65746164617461262641727261792E6973417272617928652E6D657461646174612E6172677329297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F66';
wwv_flow_imp.g_varchar2_table(4659) := '20652E6D657461646174612E6172677329742E70757368286E2E636F6E73747261696E74293B636F6E7374206E3D652E68616E646C65723B652E68616E646C65723D66756E6374696F6E28652C2E2E2E69297B72657475726E2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(4660) := '2C74297B636F6E7374206E3D4D6174682E6D696E28652E6C656E6774682C742E6C656E677468293B666F72286C657420693D303B693C6E3B692B2B29536C28655B695D2C745B695D297D28692C74292C6E28652C2E2E2E69297D7D636F6E73747B69643A';
wwv_flow_imp.g_varchar2_table(4661) := '6E7D3D653B6C657420693D746869732E5F636F6D6D616E64732E676574286E293B697C7C28693D6E65772067742C746869732E5F636F6D6D616E64732E736574286E2C6929293B636F6E7374206F3D692E756E73686966742865292C733D727428282829';
wwv_flow_imp.g_varchar2_table(4662) := '3D3E7B6F28293B636F6E737420653D746869732E5F636F6D6D616E64732E676574286E293B286E756C6C3D3D653F766F696420303A652E6973456D7074792829292626746869732E5F636F6D6D616E64732E64656C657465286E297D29293B7265747572';
wwv_flow_imp.g_varchar2_table(4663) := '6E20746869732E5F6F6E4469645265676973746572436F6D6D616E642E66697265286E292C737D7265676973746572436F6D6D616E64416C69617328652C74297B72657475726E206B632E7265676973746572436F6D6D616E6428652C2828652C2E2E2E';
wwv_flow_imp.g_varchar2_table(4664) := '6E293D3E652E676574287863292E65786563757465436F6D6D616E6428742C2E2E2E6E2929297D676574436F6D6D616E642865297B636F6E737420743D746869732E5F636F6D6D616E64732E6765742865293B69662874262621742E6973456D70747928';
wwv_flow_imp.g_varchar2_table(4665) := '292972657475726E205A652E66697273742874297D676574436F6D6D616E647328297B636F6E737420653D6E6577204D61703B666F7228636F6E73742074206F6620746869732E5F636F6D6D616E64732E6B6579732829297B636F6E7374206E3D746869';
wwv_flow_imp.g_varchar2_table(4666) := '732E676574436F6D6D616E642874293B6E2626652E73657428742C6E297D72657475726E20657D7D3B66756E6374696F6E204563282E2E2E65297B73776974636828652E6C656E677468297B6361736520313A72657475726E206228302C224469642079';
wwv_flow_imp.g_varchar2_table(4667) := '6F75206D65616E207B307D3F222C655B305D293B6361736520323A72657475726E206228302C2244696420796F75206D65616E207B307D206F72207B317D3F222C655B305D2C655B315D293B6361736520333A72657475726E206228302C224469642079';
wwv_flow_imp.g_varchar2_table(4668) := '6F75206D65616E207B307D2C207B317D206F72207B327D3F222C655B305D2C655B315D2C655B325D293B64656661756C743A72657475726E7D7D6B632E7265676973746572436F6D6D616E6428226E6F6F70222C2828293D3E7B7D29293B636F6E737420';
wwv_flow_imp.g_varchar2_table(4669) := '4C633D6228302C2244696420796F7520666F7267657420746F206F70656E206F7220636C6F7365207468652071756F74653F22292C44633D6228302C2244696420796F7520666F7267657420746F206573636170652074686520272F272028736C617368';
wwv_flow_imp.g_varchar2_table(4670) := '29206368617261637465723F205075742074776F206261636B736C6173686573206265666F726520697420746F206573636170652C20652E672E2C20275C5C5C5C2F272E22293B636C6173732054637B636F6E7374727563746F7228297B746869732E5F';
wwv_flow_imp.g_varchar2_table(4671) := '696E7075743D22222C746869732E5F73746172743D302C746869732E5F63757272656E743D302C746869732E5F746F6B656E733D5B5D2C746869732E5F6572726F72733D5B5D2C746869732E737472696E6752653D2F5B612D7A412D5A302D395F3C3E5C';
wwv_flow_imp.g_varchar2_table(4672) := '2D5C2E2F5C5C3A5C2A5C3F5C2B5C5B5C5D5C5E2C23403B22255C245C707B4C7D2D5D2B2F75797D737461746963206765744C6578656D652865297B73776974636828652E74797065297B6361736520303A72657475726E2228223B6361736520313A7265';
wwv_flow_imp.g_varchar2_table(4673) := '7475726E2229223B6361736520323A72657475726E2221223B6361736520333A72657475726E20652E6973547269706C6545713F223D3D3D223A223D3D223B6361736520343A72657475726E20652E6973547269706C6545713F22213D3D223A22213D22';
wwv_flow_imp.g_varchar2_table(4674) := '3B6361736520353A72657475726E223C223B6361736520363A72657475726E223C3D223B6361736520373A6361736520383A72657475726E223E3D223B6361736520393A72657475726E223D7E223B636173652031303A636173652031373A6361736520';
wwv_flow_imp.g_varchar2_table(4675) := '31383A636173652031393A72657475726E20652E6C6578656D653B636173652031313A72657475726E2274727565223B636173652031323A72657475726E2266616C7365223B636173652031333A72657475726E22696E223B636173652031343A726574';
wwv_flow_imp.g_varchar2_table(4676) := '75726E226E6F74223B636173652031353A72657475726E222626223B636173652031363A72657475726E227C7C223B636173652032303A72657475726E22454F46223B64656661756C743A7468726F772041652860756E68616E646C656420746F6B656E';
wwv_flow_imp.g_varchar2_table(4677) := '20747970653A20247B4A534F4E2E737472696E676966792865297D3B206861766520796F7520666F72676F7474656E20746F20616464206120636173653F60297D7D72657365742865297B72657475726E20746869732E5F696E7075743D652C74686973';
wwv_flow_imp.g_varchar2_table(4678) := '2E5F73746172743D302C746869732E5F63757272656E743D302C746869732E5F746F6B656E733D5B5D2C746869732E5F6572726F72733D5B5D2C746869737D7363616E28297B666F72283B21746869732E5F69734174456E6428293B2973776974636828';
wwv_flow_imp.g_varchar2_table(4679) := '746869732E5F73746172743D746869732E5F63757272656E742C746869732E5F616476616E63652829297B636173652034303A746869732E5F616464546F6B656E2830293B627265616B3B636173652034313A746869732E5F616464546F6B656E283129';
wwv_flow_imp.g_varchar2_table(4680) := '3B627265616B3B636173652033333A696628746869732E5F6D6174636828363129297B636F6E737420653D746869732E5F6D61746368283631293B746869732E5F746F6B656E732E70757368287B747970653A342C6F66667365743A746869732E5F7374';
wwv_flow_imp.g_varchar2_table(4681) := '6172742C6973547269706C6545713A657D297D656C736520746869732E5F616464546F6B656E2832293B627265616B3B636173652033393A746869732E5F71756F746564537472696E6728293B627265616B3B636173652034373A746869732E5F726567';
wwv_flow_imp.g_varchar2_table(4682) := '657828293B627265616B3B636173652036313A696628746869732E5F6D6174636828363129297B636F6E737420653D746869732E5F6D61746368283631293B746869732E5F746F6B656E732E70757368287B747970653A332C6F66667365743A74686973';
wwv_flow_imp.g_varchar2_table(4683) := '2E5F73746172742C6973547269706C6545713A657D297D656C736520746869732E5F6D6174636828313236293F746869732E5F616464546F6B656E2839293A746869732E5F6572726F7228456328223D3D222C223D7E2229293B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(4684) := '2036303A746869732E5F616464546F6B656E28746869732E5F6D61746368283631293F363A35293B627265616B3B636173652036323A746869732E5F616464546F6B656E28746869732E5F6D61746368283631293F383A37293B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(4685) := '2033383A746869732E5F6D61746368283338293F746869732E5F616464546F6B656E283135293A746869732E5F6572726F72284563282226262229293B627265616B3B63617365203132343A746869732E5F6D6174636828313234293F746869732E5F61';
wwv_flow_imp.g_varchar2_table(4686) := '6464546F6B656E283136293A746869732E5F6572726F7228456328227C7C2229293B627265616B3B636173652033323A636173652031333A6361736520393A636173652031303A63617365203136303A627265616B3B64656661756C743A746869732E5F';
wwv_flow_imp.g_varchar2_table(4687) := '737472696E6728297D72657475726E20746869732E5F73746172743D746869732E5F63757272656E742C746869732E5F616464546F6B656E283230292C41727261792E66726F6D28746869732E5F746F6B656E73297D5F6D617463682865297B72657475';
wwv_flow_imp.g_varchar2_table(4688) := '726E21746869732E5F69734174456E6428292626746869732E5F696E7075742E63686172436F6465417428746869732E5F63757272656E74293D3D3D65262628746869732E5F63757272656E742B2B2C2130297D5F616476616E636528297B7265747572';
wwv_flow_imp.g_varchar2_table(4689) := '6E20746869732E5F696E7075742E63686172436F6465417428746869732E5F63757272656E742B2B297D5F7065656B28297B72657475726E20746869732E5F69734174456E6428293F303A746869732E5F696E7075742E63686172436F64654174287468';
wwv_flow_imp.g_varchar2_table(4690) := '69732E5F63757272656E74297D5F616464546F6B656E2865297B746869732E5F746F6B656E732E70757368287B747970653A652C6F66667365743A746869732E5F73746172747D297D5F6572726F722865297B636F6E737420743D746869732E5F737461';
wwv_flow_imp.g_varchar2_table(4691) := '72742C6E3D746869732E5F696E7075742E737562737472696E6728746869732E5F73746172742C746869732E5F63757272656E74292C693D7B747970653A31392C6F66667365743A746869732E5F73746172742C6C6578656D653A6E7D3B746869732E5F';
wwv_flow_imp.g_varchar2_table(4692) := '6572726F72732E70757368287B6F66667365743A742C6C6578656D653A6E2C6164646974696F6E616C496E666F3A657D292C746869732E5F746F6B656E732E707573682869297D5F737472696E6728297B746869732E737472696E6752652E6C61737449';
wwv_flow_imp.g_varchar2_table(4693) := '6E6465783D746869732E5F73746172743B636F6E737420653D746869732E737472696E6752652E6578656328746869732E5F696E707574293B69662865297B746869732E5F63757272656E743D746869732E5F73746172742B655B305D2E6C656E677468';
wwv_flow_imp.g_varchar2_table(4694) := '3B636F6E737420743D746869732E5F696E7075742E737562737472696E6728746869732E5F73746172742C746869732E5F63757272656E74292C6E3D54632E5F6B6579776F7264732E6765742874293B6E3F746869732E5F616464546F6B656E286E293A';
wwv_flow_imp.g_varchar2_table(4695) := '746869732E5F746F6B656E732E70757368287B747970653A31372C6C6578656D653A742C6F66667365743A746869732E5F73746172747D297D7D5F71756F746564537472696E6728297B666F72283B3339213D3D746869732E5F7065656B282926262174';
wwv_flow_imp.g_varchar2_table(4696) := '6869732E5F69734174456E6428293B29746869732E5F616476616E636528293B746869732E5F69734174456E6428293F746869732E5F6572726F72284C63293A28746869732E5F616476616E636528292C746869732E5F746F6B656E732E70757368287B';
wwv_flow_imp.g_varchar2_table(4697) := '747970653A31382C6C6578656D653A746869732E5F696E7075742E737562737472696E6728746869732E5F73746172742B312C746869732E5F63757272656E742D31292C6F66667365743A746869732E5F73746172742B317D29297D5F72656765782829';
wwv_flow_imp.g_varchar2_table(4698) := '7B6C657420653D746869732E5F63757272656E742C743D21312C6E3D21313B666F72283B3B297B696628653E3D746869732E5F696E7075742E6C656E6774682972657475726E20746869732E5F63757272656E743D652C766F696420746869732E5F6572';
wwv_flow_imp.g_varchar2_table(4699) := '726F72284463293B636F6E737420693D746869732E5F696E7075742E63686172436F646541742865293B6966287429743D21313B656C73657B69662834373D3D3D692626216E297B652B2B3B627265616B7D39313D3D3D693F6E3D21303A39323D3D3D69';
wwv_flow_imp.g_varchar2_table(4700) := '3F743D21303A39333D3D3D692626286E3D2131297D652B2B7D666F72283B653C746869732E5F696E7075742E6C656E677468262654632E5F7265676578466C6167732E68617328746869732E5F696E7075742E63686172436F64654174286529293B2965';
wwv_flow_imp.g_varchar2_table(4701) := '2B2B3B746869732E5F63757272656E743D653B636F6E737420693D746869732E5F696E7075742E737562737472696E6728746869732E5F73746172742C746869732E5F63757272656E74293B746869732E5F746F6B656E732E70757368287B747970653A';
wwv_flow_imp.g_varchar2_table(4702) := '31302C6C6578656D653A692C6F66667365743A746869732E5F73746172747D297D5F69734174456E6428297B72657475726E20746869732E5F63757272656E743E3D746869732E5F696E7075742E6C656E6774687D7D54632E5F7265676578466C616773';
wwv_flow_imp.g_varchar2_table(4703) := '3D6E657720536574285B2269222C2267222C2273222C226D222C2279222C2275225D2E6D61702828653D3E652E63686172436F646541742830292929292C54632E5F6B6579776F7264733D6E6577204D6170285B5B226E6F74222C31345D2C5B22696E22';
wwv_flow_imp.g_varchar2_table(4704) := '2C31335D2C5B2266616C7365222C31325D2C5B2274727565222C31315D5D293B636F6E73742049633D6E6577204D61703B49632E736574282266616C7365222C2131292C49632E736574282274727565222C2130292C49632E736574282269734D616322';
wwv_flow_imp.g_varchar2_table(4705) := '2C71292C49632E736574282269734C696E7578222C24292C49632E7365742822697357696E646F7773222C6A292C49632E73657428226973576562222C4B292C49632E736574282269734D61634E6174697665222C712626214B292C49632E7365742822';
wwv_flow_imp.g_varchar2_table(4706) := '697345646765222C6C65292C49632E7365742822697346697265666F78222C7265292C49632E736574282269734368726F6D65222C7365292C49632E73657428226973536166617269222C6165293B636F6E7374204D633D4F626A6563742E70726F746F';
wwv_flow_imp.g_varchar2_table(4707) := '747970652E6861734F776E50726F70657274792C41633D7B726567657850617273696E67576974684572726F725265636F766572793A21307D2C4E633D6228302C22456D70747920636F6E74657874206B65792065787072657373696F6E22292C50633D';
wwv_flow_imp.g_varchar2_table(4708) := '6228302C2244696420796F7520666F7267657420746F20777269746520616E2065787072657373696F6E3F20596F752063616E20616C736F20707574202766616C736527206F722027747275652720746F20616C77617973206576616C7561746520746F';
wwv_flow_imp.g_varchar2_table(4709) := '2066616C7365206F7220747275652C20726573706563746976656C792E22292C4F633D6228302C2227696E2720616674657220276E6F74272E22292C52633D6228302C22636C6F73696E6720706172656E7468657369732027292722292C46633D622830';
wwv_flow_imp.g_varchar2_table(4710) := '2C22556E657870656374656420746F6B656E22292C42633D6228302C2244696420796F7520666F7267657420746F20707574202626206F72207C7C206265666F72652074686520746F6B656E3F22292C56633D6228302C22556E65787065637465642065';
wwv_flow_imp.g_varchar2_table(4711) := '6E64206F662065787072657373696F6E22292C7A633D6228302C2244696420796F7520666F7267657420746F20707574206120636F6E74657874206B65793F22293B636C6173732048637B636F6E7374727563746F7228653D4163297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(4712) := '6F6E6669673D652C746869732E5F7363616E6E65723D6E65772054632C746869732E5F746F6B656E733D5B5D2C746869732E5F63757272656E743D302C746869732E5F70617273696E674572726F72733D5B5D2C746869732E5F666C616773475952653D';
wwv_flow_imp.g_varchar2_table(4713) := '2F677C792F677D70617273652865297B6966282222213D3D65297B746869732E5F746F6B656E733D746869732E5F7363616E6E65722E72657365742865292E7363616E28292C746869732E5F63757272656E743D302C746869732E5F70617273696E6745';
wwv_flow_imp.g_varchar2_table(4714) := '72726F72733D5B5D3B7472797B636F6E737420653D746869732E5F6578707228293B69662821746869732E5F69734174456E642829297B636F6E737420653D746869732E5F7065656B28292C743D31373D3D3D652E747970653F42633A766F696420303B';
wwv_flow_imp.g_varchar2_table(4715) := '7468726F7720746869732E5F70617273696E674572726F72732E70757368287B6D6573736167653A46632C6F66667365743A652E6F66667365742C6C6578656D653A54632E6765744C6578656D652865292C6164646974696F6E616C496E666F3A747D29';
wwv_flow_imp.g_varchar2_table(4716) := '2C48632E5F70617273654572726F727D72657475726E20657D63617463682865297B69662865213D3D48632E5F70617273654572726F72297468726F7720653B72657475726E7D7D656C736520746869732E5F70617273696E674572726F72732E707573';
wwv_flow_imp.g_varchar2_table(4717) := '68287B6D6573736167653A4E632C6F66667365743A302C6C6578656D653A22222C6164646974696F6E616C496E666F3A50637D297D5F6578707228297B72657475726E20746869732E5F6F7228297D5F6F7228297B636F6E737420653D5B746869732E5F';
wwv_flow_imp.g_varchar2_table(4718) := '616E6428295D3B666F72283B746869732E5F6D617463684F6E65283136293B297B636F6E737420743D746869732E5F616E6428293B652E707573682874297D72657475726E20313D3D3D652E6C656E6774683F655B305D3A57632E6F72282E2E2E65297D';
wwv_flow_imp.g_varchar2_table(4719) := '5F616E6428297B636F6E737420653D5B746869732E5F7465726D28295D3B666F72283B746869732E5F6D617463684F6E65283135293B297B636F6E737420743D746869732E5F7465726D28293B652E707573682874297D72657475726E20313D3D3D652E';
wwv_flow_imp.g_varchar2_table(4720) := '6C656E6774683F655B305D3A57632E616E64282E2E2E65297D5F7465726D28297B696628746869732E5F6D617463684F6E65283229297B636F6E737420653D746869732E5F7065656B28293B73776974636828652E74797065297B636173652031313A72';
wwv_flow_imp.g_varchar2_table(4721) := '657475726E20746869732E5F616476616E636528292C71632E494E5354414E43453B636173652031323A72657475726E20746869732E5F616476616E636528292C24632E494E5354414E43453B6361736520303A7B746869732E5F616476616E63652829';
wwv_flow_imp.g_varchar2_table(4722) := '3B636F6E737420653D746869732E5F6578707228293B72657475726E20746869732E5F636F6E73756D6528312C5263292C6E756C6C3D3D653F766F696420303A652E6E656761746528297D636173652031373A72657475726E20746869732E5F61647661';
wwv_flow_imp.g_varchar2_table(4723) := '6E636528292C5A632E63726561746528652E6C6578656D65293B64656661756C743A7468726F7720746869732E5F6572724578706563746564427574476F7428224B4559207C2074727565207C2066616C7365207C202728272065787072657373696F6E';
wwv_flow_imp.g_varchar2_table(4724) := '20272927222C65297D7D72657475726E20746869732E5F7072696D61727928297D5F7072696D61727928297B636F6E737420653D746869732E5F7065656B28293B73776974636828652E74797065297B636173652031313A72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(4725) := '5F616476616E636528292C57632E7472756528293B636173652031323A72657475726E20746869732E5F616476616E636528292C57632E66616C736528293B6361736520303A7B746869732E5F616476616E636528293B636F6E737420653D746869732E';
wwv_flow_imp.g_varchar2_table(4726) := '5F6578707228293B72657475726E20746869732E5F636F6E73756D6528312C5263292C657D636173652031373A7B636F6E737420743D652E6C6578656D653B696628746869732E5F616476616E636528292C746869732E5F6D617463684F6E6528392929';
wwv_flow_imp.g_varchar2_table(4727) := '7B636F6E737420653D746869732E5F7065656B28293B69662821746869732E5F636F6E6669672E726567657850617273696E67576974684572726F725265636F76657279297B696628746869732E5F616476616E636528292C3130213D3D652E74797065';
wwv_flow_imp.g_varchar2_table(4728) := '297468726F7720746869732E5F6572724578706563746564427574476F7428225245474558222C65293B636F6E7374206E3D652E6C6578656D652C693D6E2E6C617374496E6465784F6628222F22292C6F3D693D3D3D6E2E6C656E6774682D313F766F69';
wwv_flow_imp.g_varchar2_table(4729) := '6420303A746869732E5F72656D6F7665466C6167734759286E2E737562737472696E6728692B3129293B6C657420733B7472797B733D6E657720526567457870286E2E737562737472696E6728312C69292C6F297D63617463682874297B7468726F7720';
wwv_flow_imp.g_varchar2_table(4730) := '746869732E5F6572724578706563746564427574476F7428225245474558222C65297D72657475726E2069642E63726561746528742C73297D73776974636828652E74797065297B636173652031303A636173652031393A7B636F6E7374206E3D5B652E';
wwv_flow_imp.g_varchar2_table(4731) := '6C6578656D655D3B746869732E5F616476616E636528293B6C657420693D746869732E5F7065656B28292C6F3D303B666F72286C657420743D303B743C652E6C6578656D652E6C656E6774683B742B2B2934303D3D3D652E6C6578656D652E6368617243';
wwv_flow_imp.g_varchar2_table(4732) := '6F646541742874293F6F2B2B3A34313D3D3D652E6C6578656D652E63686172436F6465417428742926266F2D2D3B666F72283B21746869732E5F69734174456E64282926263135213D3D692E7479706526263136213D3D692E747970653B297B73776974';
wwv_flow_imp.g_varchar2_table(4733) := '636828692E74797065297B6361736520303A6F2B2B3B627265616B3B6361736520313A6F2D2D3B627265616B3B636173652031303A636173652031383A666F72286C657420743D303B743C692E6C6578656D652E6C656E6774683B742B2B2934303D3D3D';
wwv_flow_imp.g_varchar2_table(4734) := '692E6C6578656D652E63686172436F646541742874293F6F2B2B3A34313D3D3D652E6C6578656D652E63686172436F6465417428742926266F2D2D7D6966286F3C3029627265616B3B6E2E707573682854632E6765744C6578656D65286929292C746869';
wwv_flow_imp.g_varchar2_table(4735) := '732E5F616476616E636528292C693D746869732E5F7065656B28297D636F6E737420733D6E2E6A6F696E282222292C723D732E6C617374496E6465784F6628222F22292C613D723D3D3D732E6C656E6774682D313F766F696420303A746869732E5F7265';
wwv_flow_imp.g_varchar2_table(4736) := '6D6F7665466C616773475928732E737562737472696E6728722B3129293B6C6574206C3B7472797B6C3D6E65772052656745787028732E737562737472696E6728312C72292C61297D63617463682874297B7468726F7720746869732E5F657272457870';
wwv_flow_imp.g_varchar2_table(4737) := '6563746564427574476F7428225245474558222C65297D72657475726E2057632E726567657828742C6C297D636173652031383A7B636F6E7374206E3D652E6C6578656D653B746869732E5F616476616E636528293B6C657420693D6E756C6C3B696628';
wwv_flow_imp.g_varchar2_table(4738) := '217369286E29297B636F6E737420743D6E2E696E6465784F6628222F22292C6F3D6E2E6C617374496E6465784F6628222F22293B69662874213D3D6F2626743E3D30297B636F6E737420733D6E2E736C69636528742B312C6F292C723D2269223D3D3D6E';
wwv_flow_imp.g_varchar2_table(4739) := '5B6F2B315D3F2269223A22223B7472797B693D6E65772052656745787028732C72297D63617463682874297B7468726F7720746869732E5F6572724578706563746564427574476F7428225245474558222C65297D7D7D6966286E756C6C3D3D3D692974';
wwv_flow_imp.g_varchar2_table(4740) := '68726F7720746869732E5F6572724578706563746564427574476F7428225245474558222C65293B72657475726E2069642E63726561746528742C69297D64656661756C743A7468726F7720746869732E5F6572724578706563746564427574476F7428';
wwv_flow_imp.g_varchar2_table(4741) := '225245474558222C746869732E5F7065656B2829297D7D696628746869732E5F6D617463684F6E6528313429297B746869732E5F636F6E73756D652831332C4F63293B636F6E737420653D746869732E5F76616C756528293B72657475726E2057632E6E';
wwv_flow_imp.g_varchar2_table(4742) := '6F74496E28742C65297D73776974636828746869732E5F7065656B28292E74797065297B6361736520333A7B746869732E5F616476616E636528293B636F6E737420653D746869732E5F76616C756528293B69662831383D3D3D746869732E5F70726576';
wwv_flow_imp.g_varchar2_table(4743) := '696F757328292E747970652972657475726E2057632E657175616C7328742C65293B7377697463682865297B636173652274727565223A72657475726E2057632E6861732874293B636173652266616C7365223A72657475726E2057632E6E6F74287429';
wwv_flow_imp.g_varchar2_table(4744) := '3B64656661756C743A72657475726E2057632E657175616C7328742C65297D7D6361736520343A7B746869732E5F616476616E636528293B636F6E737420653D746869732E5F76616C756528293B69662831383D3D3D746869732E5F70726576696F7573';
wwv_flow_imp.g_varchar2_table(4745) := '28292E747970652972657475726E2057632E6E6F74457175616C7328742C65293B7377697463682865297B636173652274727565223A72657475726E2057632E6E6F742874293B636173652266616C7365223A72657475726E2057632E6861732874293B';
wwv_flow_imp.g_varchar2_table(4746) := '64656661756C743A72657475726E2057632E6E6F74457175616C7328742C65297D7D6361736520353A72657475726E20746869732E5F616476616E636528292C74642E63726561746528742C746869732E5F76616C75652829293B6361736520363A7265';
wwv_flow_imp.g_varchar2_table(4747) := '7475726E20746869732E5F616476616E636528292C6E642E63726561746528742C746869732E5F76616C75652829293B6361736520373A72657475726E20746869732E5F616476616E636528292C4A632E63726561746528742C746869732E5F76616C75';
wwv_flow_imp.g_varchar2_table(4748) := '652829293B6361736520383A72657475726E20746869732E5F616476616E636528292C65642E63726561746528742C746869732E5F76616C75652829293B636173652031333A72657475726E20746869732E5F616476616E636528292C57632E696E2874';
wwv_flow_imp.g_varchar2_table(4749) := '2C746869732E5F76616C75652829293B64656661756C743A72657475726E2057632E6861732874297D7D636173652032303A7468726F7720746869732E5F70617273696E674572726F72732E70757368287B6D6573736167653A56632C6F66667365743A';
wwv_flow_imp.g_varchar2_table(4750) := '652E6F66667365742C6C6578656D653A22222C6164646974696F6E616C496E666F3A7A637D292C48632E5F70617273654572726F723B64656661756C743A7468726F7720746869732E5F6572724578706563746564427574476F74282274727565207C20';
wwv_flow_imp.g_varchar2_table(4751) := '66616C7365207C204B4559205C6E5C747C204B455920273D7E27205245474558205C6E5C747C204B45592028273D3D27207C2027213D27207C20273C27207C20273C3D27207C20273E27207C20273E3D27207C2027696E27207C20276E6F74272027696E';
wwv_flow_imp.g_varchar2_table(4752) := '27292076616C7565222C746869732E5F7065656B2829297D7D5F76616C756528297B636F6E737420653D746869732E5F7065656B28293B73776974636828652E74797065297B636173652031373A636173652031383A72657475726E20746869732E5F61';
wwv_flow_imp.g_varchar2_table(4753) := '6476616E636528292C652E6C6578656D653B636173652031313A72657475726E20746869732E5F616476616E636528292C2274727565223B636173652031323A72657475726E20746869732E5F616476616E636528292C2266616C7365223B6361736520';
wwv_flow_imp.g_varchar2_table(4754) := '31333A72657475726E20746869732E5F616476616E636528292C22696E223B64656661756C743A72657475726E22227D7D5F72656D6F7665466C61677347592865297B72657475726E20652E7265706C616365416C6C28746869732E5F666C6167734759';
wwv_flow_imp.g_varchar2_table(4755) := '52652C2222297D5F70726576696F757328297B72657475726E20746869732E5F746F6B656E735B746869732E5F63757272656E742D315D7D5F6D617463684F6E652865297B72657475726E2121746869732E5F636865636B286529262628746869732E5F';
wwv_flow_imp.g_varchar2_table(4756) := '616476616E636528292C2130297D5F616476616E636528297B72657475726E20746869732E5F69734174456E6428297C7C746869732E5F63757272656E742B2B2C746869732E5F70726576696F757328297D5F636F6E73756D6528652C74297B69662874';
wwv_flow_imp.g_varchar2_table(4757) := '6869732E5F636865636B2865292972657475726E20746869732E5F616476616E636528293B7468726F7720746869732E5F6572724578706563746564427574476F7428742C746869732E5F7065656B2829297D5F6572724578706563746564427574476F';
wwv_flow_imp.g_varchar2_table(4758) := '7428652C742C6E297B636F6E737420693D6228302C2245787065637465643A207B307D5C6E52656365697665643A20277B317D272E222C652C54632E6765744C6578656D65287429292C6F3D742E6F66667365742C733D54632E6765744C6578656D6528';
wwv_flow_imp.g_varchar2_table(4759) := '74293B72657475726E20746869732E5F70617273696E674572726F72732E70757368287B6D6573736167653A692C6F66667365743A6F2C6C6578656D653A732C6164646974696F6E616C496E666F3A6E7D292C48632E5F70617273654572726F727D5F63';
wwv_flow_imp.g_varchar2_table(4760) := '6865636B2865297B72657475726E20746869732E5F7065656B28292E747970653D3D3D657D5F7065656B28297B72657475726E20746869732E5F746F6B656E735B746869732E5F63757272656E745D7D5F69734174456E6428297B72657475726E203230';
wwv_flow_imp.g_varchar2_table(4761) := '3D3D3D746869732E5F7065656B28292E747970657D7D48632E5F70617273654572726F723D6E6577204572726F723B636C6173732057637B7374617469632066616C736528297B72657475726E2071632E494E5354414E43457D73746174696320747275';
wwv_flow_imp.g_varchar2_table(4762) := '6528297B72657475726E2024632E494E5354414E43457D737461746963206861732865297B72657475726E2055632E6372656174652865297D73746174696320657175616C7328652C74297B72657475726E204B632E63726561746528652C74297D7374';
wwv_flow_imp.g_varchar2_table(4763) := '61746963206E6F74457175616C7328652C74297B72657475726E2059632E63726561746528652C74297D73746174696320726567657828652C74297B72657475726E2069642E63726561746528652C74297D73746174696320696E28652C74297B726574';
wwv_flow_imp.g_varchar2_table(4764) := '75726E2047632E63726561746528652C74297D737461746963206E6F74496E28652C74297B72657475726E2051632E63726561746528652C74297D737461746963206E6F742865297B72657475726E205A632E6372656174652865297D73746174696320';
wwv_flow_imp.g_varchar2_table(4765) := '616E64282E2E2E65297B72657475726E2072642E63726561746528652C6E756C6C2C2130297D737461746963206F72282E2E2E65297B72657475726E2061642E63726561746528652C6E756C6C2C2130297D73746174696320646573657269616C697A65';
wwv_flow_imp.g_varchar2_table(4766) := '2865297B6966286E756C6C213D652972657475726E20746869732E5F7061727365722E70617273652865297D7D66756E6374696F6E206A6328652C74297B72657475726E20652E636D702874297D57632E5F7061727365723D6E6577204863287B726567';
wwv_flow_imp.g_varchar2_table(4767) := '657850617273696E67576974684572726F725265636F766572793A21317D293B636C6173732071637B636F6E7374727563746F7228297B746869732E747970653D307D636D702865297B72657475726E20746869732E747970652D652E747970657D6571';
wwv_flow_imp.g_varchar2_table(4768) := '75616C732865297B72657475726E20652E747970653D3D3D746869732E747970657D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B72657475726E21317D73657269616C697A652829';
wwv_flow_imp.g_varchar2_table(4769) := '7B72657475726E2266616C7365227D6B65797328297B72657475726E5B5D7D6E656761746528297B72657475726E2024632E494E5354414E43457D7D71632E494E5354414E43453D6E65772071633B636C6173732024637B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(4770) := '297B746869732E747970653D317D636D702865297B72657475726E20746869732E747970652D652E747970657D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970657D73756273746974757465436F6E7374616E7473';
wwv_flow_imp.g_varchar2_table(4771) := '28297B72657475726E20746869737D6576616C756174652865297B72657475726E21307D73657269616C697A6528297B72657475726E2274727565227D6B65797328297B72657475726E5B5D7D6E656761746528297B72657475726E2071632E494E5354';
wwv_flow_imp.g_varchar2_table(4772) := '414E43457D7D24632E494E5354414E43453D6E65772024633B636C6173732055637B7374617469632063726561746528652C743D6E756C6C297B636F6E7374206E3D49632E6765742865293B72657475726E22626F6F6C65616E223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(4773) := '6E3F6E3F24632E494E5354414E43453A71632E494E5354414E43453A6E657720556328652C74297D636F6E7374727563746F7228652C74297B746869732E6B65793D652C746869732E6E6567617465643D742C746869732E747970653D327D636D702865';
wwv_flow_imp.g_varchar2_table(4774) := '297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970653A646428746869732E6B65792C652E6B6579297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E7479706526';
wwv_flow_imp.g_varchar2_table(4775) := '26746869732E6B65793D3D3D652E6B65797D73756273746974757465436F6E7374616E747328297B636F6E737420653D49632E67657428746869732E6B6579293B72657475726E22626F6F6C65616E223D3D747970656F6620653F653F24632E494E5354';
wwv_flow_imp.g_varchar2_table(4776) := '414E43453A71632E494E5354414E43453A746869737D6576616C756174652865297B72657475726E2121652E67657456616C756528746869732E6B6579297D73657269616C697A6528297B72657475726E20746869732E6B65797D6B65797328297B7265';
wwv_flow_imp.g_varchar2_table(4777) := '7475726E5B746869732E6B65795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D5A632E63726561746528746869732E6B65792C7468697329292C746869732E6E6567617465647D7D63';
wwv_flow_imp.g_varchar2_table(4778) := '6C617373204B637B7374617469632063726561746528652C742C6E3D6E756C6C297B69662822626F6F6C65616E223D3D747970656F6620742972657475726E20743F55632E63726561746528652C6E293A5A632E63726561746528652C6E293B636F6E73';
wwv_flow_imp.g_varchar2_table(4779) := '7420693D49632E6765742865293B72657475726E22626F6F6C65616E223D3D747970656F6620693F743D3D3D28693F2274727565223A2266616C736522293F24632E494E5354414E43453A71632E494E5354414E43453A6E6577204B6328652C742C6E29';
wwv_flow_imp.g_varchar2_table(4780) := '7D636F6E7374727563746F7228652C742C6E297B746869732E6B65793D652C746869732E76616C75653D742C746869732E6E6567617465643D6E2C746869732E747970653D347D636D702865297B72657475726E20652E74797065213D3D746869732E74';
wwv_flow_imp.g_varchar2_table(4781) := '7970653F746869732E747970652D652E747970653A686428746869732E6B65792C746869732E76616C75652C652E6B65792C652E76616C7565297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E74797065262674686973';
wwv_flow_imp.g_varchar2_table(4782) := '2E6B65793D3D3D652E6B65792626746869732E76616C75653D3D3D652E76616C75657D73756273746974757465436F6E7374616E747328297B636F6E737420653D49632E67657428746869732E6B6579293B69662822626F6F6C65616E223D3D74797065';
wwv_flow_imp.g_varchar2_table(4783) := '6F662065297B636F6E737420743D653F2274727565223A2266616C7365223B72657475726E20746869732E76616C75653D3D3D743F24632E494E5354414E43453A71632E494E5354414E43457D72657475726E20746869737D6576616C75617465286529';
wwv_flow_imp.g_varchar2_table(4784) := '7B72657475726E20652E67657456616C756528746869732E6B6579293D3D746869732E76616C75657D73657269616C697A6528297B72657475726E60247B746869732E6B65797D203D3D2027247B746869732E76616C75657D27607D6B65797328297B72';
wwv_flow_imp.g_varchar2_table(4785) := '657475726E5B746869732E6B65795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D59632E63726561746528746869732E6B65792C746869732E76616C75652C7468697329292C746869';
wwv_flow_imp.g_varchar2_table(4786) := '732E6E6567617465647D7D636C6173732047637B7374617469632063726561746528652C74297B72657475726E206E657720476328652C74297D636F6E7374727563746F7228652C74297B746869732E6B65793D652C746869732E76616C75654B65793D';
wwv_flow_imp.g_varchar2_table(4787) := '742C746869732E747970653D31302C746869732E6E6567617465643D6E756C6C7D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970653A686428746869732E6B65792C746869732E';
wwv_flow_imp.g_varchar2_table(4788) := '76616C75654B65792C652E6B65792C652E76616C75654B6579297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B65792626746869732E76616C75654B65793D3D3D652E';
wwv_flow_imp.g_varchar2_table(4789) := '76616C75654B65797D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B636F6E737420743D652E67657456616C756528746869732E76616C75654B6579292C6E3D652E67657456616C75';
wwv_flow_imp.g_varchar2_table(4790) := '6528746869732E6B6579293B72657475726E2041727261792E697341727261792874293F742E696E636C75646573286E293A22737472696E67223D3D747970656F66206E2626226F626A656374223D3D747970656F66207426266E756C6C213D3D742626';
wwv_flow_imp.g_varchar2_table(4791) := '4D632E63616C6C28742C6E297D73657269616C697A6528297B72657475726E60247B746869732E6B65797D20696E2027247B746869732E76616C75654B65797D27607D6B65797328297B72657475726E5B746869732E6B65792C746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(4792) := '4B65795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D51632E63726561746528746869732E6B65792C746869732E76616C75654B657929292C746869732E6E6567617465647D7D636C';
wwv_flow_imp.g_varchar2_table(4793) := '6173732051637B7374617469632063726561746528652C74297B72657475726E206E657720516328652C74297D636F6E7374727563746F7228652C74297B746869732E6B65793D652C746869732E76616C75654B65793D742C746869732E747970653D31';
wwv_flow_imp.g_varchar2_table(4794) := '312C746869732E5F6E6567617465643D47632E63726561746528652C74297D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970653A746869732E5F6E6567617465642E636D702865';
wwv_flow_imp.g_varchar2_table(4795) := '2E5F6E656761746564297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E5F6E6567617465642E657175616C7328652E5F6E656761746564297D73756273746974757465436F6E7374616E7473';
wwv_flow_imp.g_varchar2_table(4796) := '28297B72657475726E20746869737D6576616C756174652865297B72657475726E21746869732E5F6E6567617465642E6576616C756174652865297D73657269616C697A6528297B72657475726E60247B746869732E6B65797D206E6F7420696E202724';
wwv_flow_imp.g_varchar2_table(4797) := '7B746869732E76616C75654B65797D27607D6B65797328297B72657475726E20746869732E5F6E6567617465642E6B65797328297D6E656761746528297B72657475726E20746869732E5F6E6567617465647D7D636C6173732059637B73746174696320';
wwv_flow_imp.g_varchar2_table(4798) := '63726561746528652C742C6E3D6E756C6C297B69662822626F6F6C65616E223D3D747970656F6620742972657475726E20743F5A632E63726561746528652C6E293A55632E63726561746528652C6E293B636F6E737420693D49632E6765742865293B72';
wwv_flow_imp.g_varchar2_table(4799) := '657475726E22626F6F6C65616E223D3D747970656F6620693F743D3D3D28693F2274727565223A2266616C736522293F71632E494E5354414E43453A24632E494E5354414E43453A6E657720596328652C742C6E297D636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(4800) := '742C6E297B746869732E6B65793D652C746869732E76616C75653D742C746869732E6E6567617465643D6E2C746869732E747970653D357D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D65';
wwv_flow_imp.g_varchar2_table(4801) := '2E747970653A686428746869732E6B65792C746869732E76616C75652C652E6B65792C652E76616C7565297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B6579262674';
wwv_flow_imp.g_varchar2_table(4802) := '6869732E76616C75653D3D3D652E76616C75657D73756273746974757465436F6E7374616E747328297B636F6E737420653D49632E67657428746869732E6B6579293B69662822626F6F6C65616E223D3D747970656F662065297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(4803) := '3F2274727565223A2266616C7365223B72657475726E20746869732E76616C75653D3D3D743F71632E494E5354414E43453A24632E494E5354414E43457D72657475726E20746869737D6576616C756174652865297B72657475726E20652E6765745661';
wwv_flow_imp.g_varchar2_table(4804) := '6C756528746869732E6B657929213D746869732E76616C75657D73657269616C697A6528297B72657475726E60247B746869732E6B65797D20213D2027247B746869732E76616C75657D27607D6B65797328297B72657475726E5B746869732E6B65795D';
wwv_flow_imp.g_varchar2_table(4805) := '7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D4B632E63726561746528746869732E6B65792C746869732E76616C75652C7468697329292C746869732E6E6567617465647D7D636C6173';
wwv_flow_imp.g_varchar2_table(4806) := '73205A637B7374617469632063726561746528652C743D6E756C6C297B636F6E7374206E3D49632E6765742865293B72657475726E22626F6F6C65616E223D3D747970656F66206E3F6E3F71632E494E5354414E43453A24632E494E5354414E43453A6E';
wwv_flow_imp.g_varchar2_table(4807) := '6577205A6328652C74297D636F6E7374727563746F7228652C74297B746869732E6B65793D652C746869732E6E6567617465643D742C746869732E747970653D337D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F74';
wwv_flow_imp.g_varchar2_table(4808) := '6869732E747970652D652E747970653A646428746869732E6B65792C652E6B6579297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B65797D7375627374697475746543';
wwv_flow_imp.g_varchar2_table(4809) := '6F6E7374616E747328297B636F6E737420653D49632E67657428746869732E6B6579293B72657475726E22626F6F6C65616E223D3D747970656F6620653F653F71632E494E5354414E43453A24632E494E5354414E43453A746869737D6576616C756174';
wwv_flow_imp.g_varchar2_table(4810) := '652865297B72657475726E21652E67657456616C756528746869732E6B6579297D73657269616C697A6528297B72657475726E6021247B746869732E6B65797D607D6B65797328297B72657475726E5B746869732E6B65795D7D6E656761746528297B72';
wwv_flow_imp.g_varchar2_table(4811) := '657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D55632E63726561746528746869732E6B65792C7468697329292C746869732E6E6567617465647D7D66756E6374696F6E20586328652C74297B69662822737472696E';
wwv_flow_imp.g_varchar2_table(4812) := '67223D3D747970656F662065297B636F6E737420743D7061727365466C6F61742865293B69734E614E2874297C7C28653D74297D72657475726E22737472696E67223D3D747970656F6620657C7C226E756D626572223D3D747970656F6620653F742865';
wwv_flow_imp.g_varchar2_table(4813) := '293A71632E494E5354414E43457D636C617373204A637B7374617469632063726561746528652C742C6E3D6E756C6C297B72657475726E20586328742C28743D3E6E6577204A6328652C742C6E2929297D636F6E7374727563746F7228652C742C6E297B';
wwv_flow_imp.g_varchar2_table(4814) := '746869732E6B65793D652C746869732E76616C75653D742C746869732E6E6567617465643D6E2C746869732E747970653D31327D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970';
wwv_flow_imp.g_varchar2_table(4815) := '653A686428746869732E6B65792C746869732E76616C75652C652E6B65792C652E76616C7565297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B65792626746869732E';
wwv_flow_imp.g_varchar2_table(4816) := '76616C75653D3D3D652E76616C75657D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B72657475726E22737472696E6722213D747970656F6620746869732E76616C75652626706172';
wwv_flow_imp.g_varchar2_table(4817) := '7365466C6F617428652E67657456616C756528746869732E6B657929293E746869732E76616C75657D73657269616C697A6528297B72657475726E60247B746869732E6B65797D203E20247B746869732E76616C75657D607D6B65797328297B72657475';
wwv_flow_imp.g_varchar2_table(4818) := '726E5B746869732E6B65795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D6E642E63726561746528746869732E6B65792C746869732E76616C75652C7468697329292C746869732E6E';
wwv_flow_imp.g_varchar2_table(4819) := '6567617465647D7D636C6173732065647B7374617469632063726561746528652C742C6E3D6E756C6C297B72657475726E20586328742C28743D3E6E657720656428652C742C6E2929297D636F6E7374727563746F7228652C742C6E297B746869732E6B';
wwv_flow_imp.g_varchar2_table(4820) := '65793D652C746869732E76616C75653D742C746869732E6E6567617465643D6E2C746869732E747970653D31337D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970653A68642874';
wwv_flow_imp.g_varchar2_table(4821) := '6869732E6B65792C746869732E76616C75652C652E6B65792C652E76616C7565297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B65792626746869732E76616C75653D';
wwv_flow_imp.g_varchar2_table(4822) := '3D3D652E76616C75657D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B72657475726E22737472696E6722213D747970656F6620746869732E76616C756526267061727365466C6F61';
wwv_flow_imp.g_varchar2_table(4823) := '7428652E67657456616C756528746869732E6B657929293E3D746869732E76616C75657D73657269616C697A6528297B72657475726E60247B746869732E6B65797D203E3D20247B746869732E76616C75657D607D6B65797328297B72657475726E5B74';
wwv_flow_imp.g_varchar2_table(4824) := '6869732E6B65795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D74642E63726561746528746869732E6B65792C746869732E76616C75652C7468697329292C746869732E6E65676174';
wwv_flow_imp.g_varchar2_table(4825) := '65647D7D636C6173732074647B7374617469632063726561746528652C742C6E3D6E756C6C297B72657475726E20586328742C28743D3E6E657720746428652C742C6E2929297D636F6E7374727563746F7228652C742C6E297B746869732E6B65793D65';
wwv_flow_imp.g_varchar2_table(4826) := '2C746869732E76616C75653D742C746869732E6E6567617465643D6E2C746869732E747970653D31347D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970653A686428746869732E';
wwv_flow_imp.g_varchar2_table(4827) := '6B65792C746869732E76616C75652C652E6B65792C652E76616C7565297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B65792626746869732E76616C75653D3D3D652E';
wwv_flow_imp.g_varchar2_table(4828) := '76616C75657D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B72657475726E22737472696E6722213D747970656F6620746869732E76616C756526267061727365466C6F617428652E';
wwv_flow_imp.g_varchar2_table(4829) := '67657456616C756528746869732E6B657929293C746869732E76616C75657D73657269616C697A6528297B72657475726E60247B746869732E6B65797D203C20247B746869732E76616C75657D607D6B65797328297B72657475726E5B746869732E6B65';
wwv_flow_imp.g_varchar2_table(4830) := '795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D65642E63726561746528746869732E6B65792C746869732E76616C75652C7468697329292C746869732E6E6567617465647D7D636C';
wwv_flow_imp.g_varchar2_table(4831) := '617373206E647B7374617469632063726561746528652C742C6E3D6E756C6C297B72657475726E20586328742C28743D3E6E6577206E6428652C742C6E2929297D636F6E7374727563746F7228652C742C6E297B746869732E6B65793D652C746869732E';
wwv_flow_imp.g_varchar2_table(4832) := '76616C75653D742C746869732E6E6567617465643D6E2C746869732E747970653D31357D636D702865297B72657475726E20652E74797065213D3D746869732E747970653F746869732E747970652D652E747970653A686428746869732E6B65792C7468';
wwv_flow_imp.g_varchar2_table(4833) := '69732E76616C75652C652E6B65792C652E76616C7565297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E6B65793D3D3D652E6B65792626746869732E76616C75653D3D3D652E76616C75657D';
wwv_flow_imp.g_varchar2_table(4834) := '73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B72657475726E22737472696E6722213D747970656F6620746869732E76616C756526267061727365466C6F617428652E67657456616C';
wwv_flow_imp.g_varchar2_table(4835) := '756528746869732E6B657929293C3D746869732E76616C75657D73657269616C697A6528297B72657475726E60247B746869732E6B65797D203C3D20247B746869732E76616C75657D607D6B65797328297B72657475726E5B746869732E6B65795D7D6E';
wwv_flow_imp.g_varchar2_table(4836) := '656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D4A632E63726561746528746869732E6B65792C746869732E76616C75652C7468697329292C746869732E6E6567617465647D7D636C61737320';
wwv_flow_imp.g_varchar2_table(4837) := '69647B7374617469632063726561746528652C74297B72657475726E206E657720696428652C74297D636F6E7374727563746F7228652C74297B746869732E6B65793D652C746869732E7265676578703D742C746869732E747970653D372C746869732E';
wwv_flow_imp.g_varchar2_table(4838) := '6E6567617465643D6E756C6C7D636D702865297B696628652E74797065213D3D746869732E747970652972657475726E20746869732E747970652D652E747970653B696628746869732E6B65793C652E6B65792972657475726E2D313B69662874686973';
wwv_flow_imp.g_varchar2_table(4839) := '2E6B65793E652E6B65792972657475726E20313B636F6E737420743D746869732E7265676578703F746869732E7265676578702E736F757263653A22222C6E3D652E7265676578703F652E7265676578702E736F757263653A22223B72657475726E2074';
wwv_flow_imp.g_varchar2_table(4840) := '3C6E3F2D313A743E6E3F313A307D657175616C732865297B696628652E747970653D3D3D746869732E74797065297B636F6E737420743D746869732E7265676578703F746869732E7265676578702E736F757263653A22222C6E3D652E7265676578703F';
wwv_flow_imp.g_varchar2_table(4841) := '652E7265676578702E736F757263653A22223B72657475726E20746869732E6B65793D3D3D652E6B65792626743D3D3D6E7D72657475726E21317D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174';
wwv_flow_imp.g_varchar2_table(4842) := '652865297B636F6E737420743D652E67657456616C756528746869732E6B6579293B72657475726E2121746869732E7265676578702626746869732E7265676578702E746573742874297D73657269616C697A6528297B636F6E737420653D746869732E';
wwv_flow_imp.g_varchar2_table(4843) := '7265676578703F602F247B746869732E7265676578702E736F757263657D2F247B746869732E7265676578702E666C6167737D603A222F696E76616C69642F223B72657475726E60247B746869732E6B65797D203D7E20247B657D607D6B65797328297B';
wwv_flow_imp.g_varchar2_table(4844) := '72657475726E5B746869732E6B65795D7D6E656761746528297B72657475726E20746869732E6E6567617465647C7C28746869732E6E6567617465643D6F642E637265617465287468697329292C746869732E6E6567617465647D7D636C617373206F64';
wwv_flow_imp.g_varchar2_table(4845) := '7B737461746963206372656174652865297B72657475726E206E6577206F642865297D636F6E7374727563746F722865297B746869732E5F61637475616C3D652C746869732E747970653D387D636D702865297B72657475726E20652E74797065213D3D';
wwv_flow_imp.g_varchar2_table(4846) := '746869732E747970653F746869732E747970652D652E747970653A746869732E5F61637475616C2E636D7028652E5F61637475616C297D657175616C732865297B72657475726E20652E747970653D3D3D746869732E747970652626746869732E5F6163';
wwv_flow_imp.g_varchar2_table(4847) := '7475616C2E657175616C7328652E5F61637475616C297D73756273746974757465436F6E7374616E747328297B72657475726E20746869737D6576616C756174652865297B72657475726E21746869732E5F61637475616C2E6576616C75617465286529';
wwv_flow_imp.g_varchar2_table(4848) := '7D73657269616C697A6528297B72657475726E602128247B746869732E5F61637475616C2E73657269616C697A6528297D29607D6B65797328297B72657475726E20746869732E5F61637475616C2E6B65797328297D6E656761746528297B7265747572';
wwv_flow_imp.g_varchar2_table(4849) := '6E20746869732E5F61637475616C7D7D66756E6374696F6E2073642865297B6C657420743D6E756C6C3B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D2E73756273746974757465436F6E';
wwv_flow_imp.g_varchar2_table(4850) := '7374616E747328293B696628655B6E5D213D3D6926266E756C6C3D3D3D74297B743D5B5D3B666F72286C657420693D303B693C6E3B692B2B29745B695D3D655B695D7D6E756C6C213D3D74262628745B6E5D3D69297D72657475726E206E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(4851) := '743F653A747D636C6173732072647B7374617469632063726561746528652C742C6E297B72657475726E2072642E5F6E6F726D616C697A6541727228652C742C6E297D636F6E7374727563746F7228652C74297B746869732E657870723D652C74686973';
wwv_flow_imp.g_varchar2_table(4852) := '2E6E6567617465643D742C746869732E747970653D367D636D702865297B696628652E74797065213D3D746869732E747970652972657475726E20746869732E747970652D652E747970653B696628746869732E657870722E6C656E6774683C652E6578';
wwv_flow_imp.g_varchar2_table(4853) := '70722E6C656E6774682972657475726E2D313B696628746869732E657870722E6C656E6774683E652E657870722E6C656E6774682972657475726E20313B666F72286C657420743D302C6E3D746869732E657870722E6C656E6774683B743C6E3B742B2B';
wwv_flow_imp.g_varchar2_table(4854) := '297B636F6E7374206E3D6A6328746869732E657870725B745D2C652E657870725B745D293B69662830213D3D6E2972657475726E206E7D72657475726E20307D657175616C732865297B696628652E747970653D3D3D746869732E74797065297B696628';
wwv_flow_imp.g_varchar2_table(4855) := '746869732E657870722E6C656E677468213D3D652E657870722E6C656E6774682972657475726E21313B666F72286C657420743D302C6E3D746869732E657870722E6C656E6774683B743C6E3B742B2B2969662821746869732E657870725B745D2E6571';
wwv_flow_imp.g_varchar2_table(4856) := '75616C7328652E657870725B745D292972657475726E21313B72657475726E21307D72657475726E21317D73756273746974757465436F6E7374616E747328297B636F6E737420653D736428746869732E65787072293B72657475726E20653D3D3D7468';
wwv_flow_imp.g_varchar2_table(4857) := '69732E657870723F746869733A72642E63726561746528652C746869732E6E6567617465642C2131297D6576616C756174652865297B666F72286C657420743D302C6E3D746869732E657870722E6C656E6774683B743C6E3B742B2B2969662821746869';
wwv_flow_imp.g_varchar2_table(4858) := '732E657870725B745D2E6576616C756174652865292972657475726E21313B72657475726E21307D737461746963205F6E6F726D616C697A6541727228652C742C6E297B636F6E737420693D5B5D3B6C6574206F3D21313B666F7228636F6E7374207420';
wwv_flow_imp.g_varchar2_table(4859) := '6F66206529696628742969662831213D3D742E74797065297B696628303D3D3D742E747970652972657475726E2071632E494E5354414E43453B36213D3D742E747970653F692E707573682874293A692E70757368282E2E2E742E65787072297D656C73';
wwv_flow_imp.g_varchar2_table(4860) := '65206F3D21303B696628303D3D3D692E6C656E67746826266F2972657475726E2024632E494E5354414E43453B69662830213D3D692E6C656E677468297B696628313D3D3D692E6C656E6774682972657475726E20695B305D3B692E736F7274286A6329';
wwv_flow_imp.g_varchar2_table(4861) := '3B666F72286C657420653D313B653C692E6C656E6774683B652B2B29695B652D315D2E657175616C7328695B655D29262628692E73706C69636528652C31292C652D2D293B696628313D3D3D692E6C656E6774682972657475726E20695B305D3B666F72';
wwv_flow_imp.g_varchar2_table(4862) := '283B692E6C656E6774683E313B297B636F6E737420653D695B692E6C656E6774682D315D3B69662839213D3D652E7479706529627265616B3B692E706F7028293B636F6E737420743D692E706F7028292C6F3D303D3D3D692E6C656E6774682C733D6164';
wwv_flow_imp.g_varchar2_table(4863) := '2E63726561746528652E657870722E6D61702828653D3E72642E637265617465285B652C745D2C6E756C6C2C6E2929292C6E756C6C2C6F293B73262628692E707573682873292C692E736F7274286A6329297D696628313D3D3D692E6C656E6774682972';
wwv_flow_imp.g_varchar2_table(4864) := '657475726E20695B305D3B6966286E297B666F72286C657420653D303B653C692E6C656E6774683B652B2B29666F72286C657420743D652B313B743C692E6C656E6774683B742B2B29696628695B655D2E6E656761746528292E657175616C7328695B74';
wwv_flow_imp.g_varchar2_table(4865) := '5D292972657475726E2071632E494E5354414E43453B696628313D3D3D692E6C656E6774682972657475726E20695B305D7D72657475726E206E657720726428692C74297D7D73657269616C697A6528297B72657475726E20746869732E657870722E6D';
wwv_flow_imp.g_varchar2_table(4866) := '61702828653D3E652E73657269616C697A65282929292E6A6F696E28222026262022297D6B65797328297B636F6E737420653D5B5D3B666F7228636F6E73742074206F6620746869732E6578707229652E70757368282E2E2E742E6B6579732829293B72';
wwv_flow_imp.g_varchar2_table(4867) := '657475726E20657D6E656761746528297B69662821746869732E6E656761746564297B636F6E737420653D5B5D3B666F7228636F6E73742074206F6620746869732E6578707229652E7075736828742E6E65676174652829293B746869732E6E65676174';
wwv_flow_imp.g_varchar2_table(4868) := '65643D61642E63726561746528652C746869732C2130297D72657475726E20746869732E6E6567617465647D7D636C6173732061647B7374617469632063726561746528652C742C6E297B72657475726E2061642E5F6E6F726D616C697A654172722865';
wwv_flow_imp.g_varchar2_table(4869) := '2C742C6E297D636F6E7374727563746F7228652C74297B746869732E657870723D652C746869732E6E6567617465643D742C746869732E747970653D397D636D702865297B696628652E74797065213D3D746869732E747970652972657475726E207468';
wwv_flow_imp.g_varchar2_table(4870) := '69732E747970652D652E747970653B696628746869732E657870722E6C656E6774683C652E657870722E6C656E6774682972657475726E2D313B696628746869732E657870722E6C656E6774683E652E657870722E6C656E6774682972657475726E2031';
wwv_flow_imp.g_varchar2_table(4871) := '3B666F72286C657420743D302C6E3D746869732E657870722E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D6A6328746869732E657870725B745D2C652E657870725B745D293B69662830213D3D6E2972657475726E206E7D72657475726E';
wwv_flow_imp.g_varchar2_table(4872) := '20307D657175616C732865297B696628652E747970653D3D3D746869732E74797065297B696628746869732E657870722E6C656E677468213D3D652E657870722E6C656E6774682972657475726E21313B666F72286C657420743D302C6E3D746869732E';
wwv_flow_imp.g_varchar2_table(4873) := '657870722E6C656E6774683B743C6E3B742B2B2969662821746869732E657870725B745D2E657175616C7328652E657870725B745D292972657475726E21313B72657475726E21307D72657475726E21317D73756273746974757465436F6E7374616E74';
wwv_flow_imp.g_varchar2_table(4874) := '7328297B636F6E737420653D736428746869732E65787072293B72657475726E20653D3D3D746869732E657870723F746869733A61642E63726561746528652C746869732E6E6567617465642C2131297D6576616C756174652865297B666F72286C6574';
wwv_flow_imp.g_varchar2_table(4875) := '20743D302C6E3D746869732E657870722E6C656E6774683B743C6E3B742B2B29696628746869732E657870725B745D2E6576616C756174652865292972657475726E21303B72657475726E21317D737461746963205F6E6F726D616C697A654172722865';
wwv_flow_imp.g_varchar2_table(4876) := '2C742C6E297B6C657420693D5B5D2C6F3D21313B69662865297B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B745D3B6966286E2969662830213D3D6E2E74797065297B696628313D3D3D6E2E';
wwv_flow_imp.g_varchar2_table(4877) := '747970652972657475726E2024632E494E5354414E43453B39213D3D6E2E747970653F692E70757368286E293A693D692E636F6E636174286E2E65787072297D656C7365206F3D21307D696628303D3D3D692E6C656E67746826266F2972657475726E20';
wwv_flow_imp.g_varchar2_table(4878) := '71632E494E5354414E43453B692E736F7274286A63297D69662830213D3D692E6C656E677468297B696628313D3D3D692E6C656E6774682972657475726E20695B305D3B666F72286C657420653D313B653C692E6C656E6774683B652B2B29695B652D31';
wwv_flow_imp.g_varchar2_table(4879) := '5D2E657175616C7328695B655D29262628692E73706C69636528652C31292C652D2D293B696628313D3D3D692E6C656E6774682972657475726E20695B305D3B6966286E297B666F72286C657420653D303B653C692E6C656E6774683B652B2B29666F72';
wwv_flow_imp.g_varchar2_table(4880) := '286C657420743D652B313B743C692E6C656E6774683B742B2B29696628695B655D2E6E656761746528292E657175616C7328695B745D292972657475726E2024632E494E5354414E43453B696628313D3D3D692E6C656E6774682972657475726E20695B';
wwv_flow_imp.g_varchar2_table(4881) := '305D7D72657475726E206E657720616428692C74297D7D73657269616C697A6528297B72657475726E20746869732E657870722E6D61702828653D3E652E73657269616C697A65282929292E6A6F696E2822207C7C2022297D6B65797328297B636F6E73';
wwv_flow_imp.g_varchar2_table(4882) := '7420653D5B5D3B666F7228636F6E73742074206F6620746869732E6578707229652E70757368282E2E2E742E6B6579732829293B72657475726E20657D6E656761746528297B69662821746869732E6E656761746564297B636F6E737420653D5B5D3B66';
wwv_flow_imp.g_varchar2_table(4883) := '6F7228636F6E73742074206F6620746869732E6578707229652E7075736828742E6E65676174652829293B666F72283B652E6C656E6774683E313B297B636F6E737420743D652E736869667428292C6E3D652E736869667428292C693D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(4884) := '636F6E73742065206F6620676428742929666F7228636F6E73742074206F66206764286E2929692E707573682872642E637265617465285B652C745D2C6E756C6C2C213129293B652E756E73686966742861642E63726561746528692C6E756C6C2C2131';
wwv_flow_imp.g_varchar2_table(4885) := '29297D746869732E6E6567617465643D61642E63726561746528652C746869732C2130297D72657475726E20746869732E6E6567617465647D7D636C617373206C6420657874656E64732055637B73746174696320616C6C28297B72657475726E206C64';
wwv_flow_imp.g_varchar2_table(4886) := '2E5F696E666F2E76616C75657328297D636F6E7374727563746F7228652C742C6E297B737570657228652C6E756C6C292C746869732E5F64656661756C7456616C75653D742C226F626A656374223D3D747970656F66206E3F6C642E5F696E666F2E7075';
wwv_flow_imp.g_varchar2_table(4887) := '7368287B2E2E2E6E2C6B65793A657D293A2130213D3D6E26266C642E5F696E666F2E70757368287B6B65793A652C6465736372697074696F6E3A6E2C747970653A6E756C6C213D743F747970656F6620743A766F696420307D297D62696E64546F286529';
wwv_flow_imp.g_varchar2_table(4888) := '7B72657475726E20652E6372656174654B657928746869732E6B65792C746869732E5F64656661756C7456616C7565297D67657456616C75652865297B72657475726E20652E676574436F6E746578744B657956616C756528746869732E6B6579297D74';
wwv_flow_imp.g_varchar2_table(4889) := '6F4E65676174656428297B72657475726E20746869732E6E656761746528297D6973457175616C546F2865297B72657475726E204B632E63726561746528746869732E6B65792C65297D7D6C642E5F696E666F3D5B5D3B636F6E73742063643D70632822';
wwv_flow_imp.g_varchar2_table(4890) := '636F6E746578744B65795365727669636522293B66756E6374696F6E20646428652C74297B72657475726E20653C743F2D313A653E743F313A307D66756E6374696F6E20686428652C742C6E2C69297B72657475726E20653C6E3F2D313A653E6E3F313A';
wwv_flow_imp.g_varchar2_table(4891) := '743C693F2D313A743E693F313A307D66756E6374696F6E20756428652C74297B696628303D3D3D652E747970657C7C313D3D3D742E747970652972657475726E21303B696628393D3D3D652E747970652972657475726E20393D3D3D742E747970652626';
wwv_flow_imp.g_varchar2_table(4892) := '706428652E657870722C742E65787072293B696628393D3D3D742E74797065297B666F7228636F6E7374206E206F6620742E6578707229696628756428652C6E292972657475726E21303B72657475726E21317D696628363D3D3D652E74797065297B69';
wwv_flow_imp.g_varchar2_table(4893) := '6628363D3D3D742E747970652972657475726E20706428742E657870722C652E65787072293B666F7228636F6E7374206E206F6620652E65787072296966287564286E2C74292972657475726E21303B72657475726E21317D72657475726E20652E6571';
wwv_flow_imp.g_varchar2_table(4894) := '75616C732874297D66756E6374696F6E20706428652C74297B6C6574206E3D302C693D303B666F72283B6E3C652E6C656E6774682626693C742E6C656E6774683B297B636F6E7374206F3D655B6E5D2E636D7028745B695D293B6966286F3C3029726574';
wwv_flow_imp.g_varchar2_table(4895) := '75726E21313B303D3D3D6F3F286E2B2B2C692B2B293A692B2B7D72657475726E206E3D3D3D652E6C656E6774687D66756E6374696F6E2067642865297B72657475726E20393D3D3D652E747970653F652E657870723A5B655D7D66756E6374696F6E206D';
wwv_flow_imp.g_varchar2_table(4896) := '6428652C74297B6966282165297468726F77206E6577204572726F7228743F60417373657274696F6E206661696C65642028247B747D29603A22417373657274696F6E204661696C656422297D66756E6374696F6E20666428652C743D22556E72656163';
wwv_flow_imp.g_varchar2_table(4897) := '6861626C6522297B7468726F77206E6577204572726F722874297D66756E6374696F6E2076642865297B657C7C6B65286E6577204F652822536F667420417373657274696F6E204661696C65642229297D66756E6374696F6E2062642865297B6528297C';
wwv_flow_imp.g_varchar2_table(4898) := '7C286528292C6B65286E6577204F652822417373657274696F6E204661696C6564222929297D66756E6374696F6E205F6428652C74297B6C6574206E3D303B666F72283B6E3C652E6C656E6774682D313B297B696628217428655B6E5D2C655B6E2B315D';
wwv_flow_imp.g_varchar2_table(4899) := '292972657475726E21313B6E2B2B7D72657475726E21307D636F6E73742079643D6E657720636C6173737B636F6E7374727563746F7228297B746869732E646174613D6E6577204D61707D61646428652C74297B6D6428686C286529292C6D6428756C28';
wwv_flow_imp.g_varchar2_table(4900) := '7429292C6D642821746869732E646174612E6861732865292C22546865726520697320616C726561647920616E20657874656E73696F6E2077697468207468697320696422292C746869732E646174612E73657428652C74297D61732865297B72657475';
wwv_flow_imp.g_varchar2_table(4901) := '726E20746869732E646174612E6765742865297C7C6E756C6C7D7D3B636C6173732077647B636F6E7374727563746F7228297B746869732E5F636F72654B657962696E64696E67733D6E65772067742C746869732E5F657874656E73696F6E4B65796269';
wwv_flow_imp.g_varchar2_table(4902) := '6E64696E67733D5B5D2C746869732E5F6361636865644D65726765644B657962696E64696E67733D6E756C6C7D7374617469632062696E64546F43757272656E74506C6174666F726D2865297B696628313D3D3D7465297B696628652626652E77696E29';
wwv_flow_imp.g_varchar2_table(4903) := '72657475726E20652E77696E7D656C736520696628323D3D3D7465297B696628652626652E6D61632972657475726E20652E6D61637D656C736520696628652626652E6C696E75782972657475726E20652E6C696E75783B72657475726E20657D726567';
wwv_flow_imp.g_varchar2_table(4904) := '69737465724B657962696E64696E6752756C652865297B636F6E737420743D77642E62696E64546F43757272656E74506C6174666F726D2865292C6E3D6E65772061743B696628742626742E7072696D617279297B636F6E737420693D526528742E7072';
wwv_flow_imp.g_varchar2_table(4905) := '696D6172792C7465293B6926266E2E61646428746869732E5F726567697374657244656661756C744B657962696E64696E6728692C652E69642C652E617267732C652E7765696768742C302C652E7768656E29297D69662874262641727261792E697341';
wwv_flow_imp.g_varchar2_table(4906) := '7272617928742E7365636F6E646172792929666F72286C657420693D302C6F3D742E7365636F6E646172792E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D526528742E7365636F6E646172795B695D2C7465293B6F26266E2E6164642874';
wwv_flow_imp.g_varchar2_table(4907) := '6869732E5F726567697374657244656661756C744B657962696E64696E67286F2C652E69642C652E617267732C652E7765696768742C2D692D312C652E7768656E29297D72657475726E206E7D7265676973746572436F6D6D616E64416E644B65796269';
wwv_flow_imp.g_varchar2_table(4908) := '6E64696E6752756C652865297B72657475726E20737428746869732E72656769737465724B657962696E64696E6752756C652865292C6B632E7265676973746572436F6D6D616E64286529297D5F726567697374657244656661756C744B657962696E64';
wwv_flow_imp.g_varchar2_table(4909) := '696E6728652C742C6E2C692C6F2C73297B636F6E737420723D746869732E5F636F72654B657962696E64696E67732E70757368287B6B657962696E64696E673A652C636F6D6D616E643A742C636F6D6D616E64417267733A6E2C7768656E3A732C776569';
wwv_flow_imp.g_varchar2_table(4910) := '676874313A692C776569676874323A6F2C657874656E73696F6E49643A6E756C6C2C69734275696C74696E457874656E73696F6E3A21317D293B72657475726E20746869732E5F6361636865644D65726765644B657962696E64696E67733D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(4911) := '7274282828293D3E7B7228292C746869732E5F6361636865644D65726765644B657962696E64696E67733D6E756C6C7D29297D67657444656661756C744B657962696E64696E677328297B72657475726E20746869732E5F6361636865644D6572676564';
wwv_flow_imp.g_varchar2_table(4912) := '4B657962696E64696E67737C7C28746869732E5F6361636865644D65726765644B657962696E64696E67733D41727261792E66726F6D28746869732E5F636F72654B657962696E64696E6773292E636F6E63617428746869732E5F657874656E73696F6E';
wwv_flow_imp.g_varchar2_table(4913) := '4B657962696E64696E6773292C746869732E5F6361636865644D65726765644B657962696E64696E67732E736F727428536429292C746869732E5F6361636865644D65726765644B657962696E64696E67732E736C6963652830297D7D636F6E73742043';
wwv_flow_imp.g_varchar2_table(4914) := '643D6E65772077643B66756E6374696F6E20536428652C74297B696628652E77656967687431213D3D742E776569676874312972657475726E20652E776569676874312D742E776569676874313B696628652E636F6D6D616E642626742E636F6D6D616E';
wwv_flow_imp.g_varchar2_table(4915) := '64297B696628652E636F6D6D616E643C742E636F6D6D616E642972657475726E2D313B696628652E636F6D6D616E643E742E636F6D6D616E642972657475726E20317D72657475726E20652E776569676874322D742E776569676874327D79642E616464';
wwv_flow_imp.g_varchar2_table(4916) := '2822706C6174666F726D2E6B657962696E64696E67735265676973747279222C4364293B7661722078642C6B643D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4917) := '2045642865297B72657475726E20766F69642030213D3D652E636F6D6D616E647D636C617373204C647B636F6E7374727563746F722865297B6966284C642E5F696E7374616E6365732E686173286529297468726F77206E657720547970654572726F72';
wwv_flow_imp.g_varchar2_table(4918) := '28604D656E7549642077697468206964656E7469666965722027247B657D2720616C7265616479206578697374732E20557365204D656E7549642E666F72286964656E7429206F72206120756E69717565206964656E74696669657260293B4C642E5F69';
wwv_flow_imp.g_varchar2_table(4919) := '6E7374616E6365732E73657428652C74686973292C746869732E69643D657D7D4C642E5F696E7374616E6365733D6E6577204D61702C4C642E436F6D6D616E6450616C657474653D6E6577204C642822436F6D6D616E6450616C6574746522292C4C642E';
wwv_flow_imp.g_varchar2_table(4920) := '4465627567427265616B706F696E7473436F6E746578743D6E6577204C6428224465627567427265616B706F696E7473436F6E7465787422292C4C642E446562756743616C6C537461636B436F6E746578743D6E6577204C642822446562756743616C6C';
wwv_flow_imp.g_varchar2_table(4921) := '537461636B436F6E7465787422292C4C642E4465627567436F6E736F6C65436F6E746578743D6E6577204C6428224465627567436F6E736F6C65436F6E7465787422292C4C642E44656275675661726961626C6573436F6E746578743D6E6577204C6428';
wwv_flow_imp.g_varchar2_table(4922) := '2244656275675661726961626C6573436F6E7465787422292C4C642E4E6F7465626F6F6B5661726961626C6573436F6E746578743D6E6577204C6428224E6F7465626F6F6B5661726961626C6573436F6E7465787422292C4C642E4465627567486F7665';
wwv_flow_imp.g_varchar2_table(4923) := '72436F6E746578743D6E6577204C6428224465627567486F766572436F6E7465787422292C4C642E44656275675761746368436F6E746578743D6E6577204C64282244656275675761746368436F6E7465787422292C4C642E4465627567546F6F6C4261';
wwv_flow_imp.g_varchar2_table(4924) := '723D6E6577204C6428224465627567546F6F6C42617222292C4C642E4465627567546F6F6C42617253746F703D6E6577204C6428224465627567546F6F6C42617253746F7022292C4C642E456469746F72436F6E746578743D6E6577204C642822456469';
wwv_flow_imp.g_varchar2_table(4925) := '746F72436F6E7465787422292C4C642E53696D706C65456469746F72436F6E746578743D6E6577204C64282253696D706C65456469746F72436F6E7465787422292C4C642E456469746F72436F6E74656E743D6E6577204C642822456469746F72436F6E';
wwv_flow_imp.g_varchar2_table(4926) := '74656E7422292C4C642E456469746F724C696E654E756D626572436F6E746578743D6E6577204C642822456469746F724C696E654E756D626572436F6E7465787422292C4C642E456469746F72436F6E74657874436F70793D6E6577204C642822456469';
wwv_flow_imp.g_varchar2_table(4927) := '746F72436F6E74657874436F707922292C4C642E456469746F72436F6E746578745065656B3D6E6577204C642822456469746F72436F6E746578745065656B22292C4C642E456469746F72436F6E7465787453686172653D6E6577204C64282245646974';
wwv_flow_imp.g_varchar2_table(4928) := '6F72436F6E74657874536861726522292C4C642E456469746F725469746C653D6E6577204C642822456469746F725469746C6522292C4C642E456469746F725469746C6552756E3D6E6577204C642822456469746F725469746C6552756E22292C4C642E';
wwv_flow_imp.g_varchar2_table(4929) := '456469746F725469746C65436F6E746578743D6E6577204C642822456469746F725469746C65436F6E7465787422292C4C642E456469746F725469746C65436F6E7465787453686172653D6E6577204C642822456469746F725469746C65436F6E746578';
wwv_flow_imp.g_varchar2_table(4930) := '74536861726522292C4C642E456D707479456469746F7247726F75703D6E6577204C642822456D707479456469746F7247726F757022292C4C642E456D707479456469746F7247726F7570436F6E746578743D6E6577204C642822456D70747945646974';
wwv_flow_imp.g_varchar2_table(4931) := '6F7247726F7570436F6E7465787422292C4C642E456469746F7254616273426172436F6E746578743D6E6577204C642822456469746F7254616273426172436F6E7465787422292C4C642E456469746F725461627342617253686F77546162735375626D';
wwv_flow_imp.g_varchar2_table(4932) := '656E753D6E6577204C642822456469746F725461627342617253686F77546162735375626D656E7522292C4C642E456469746F725461627342617253686F77546162735A656E4D6F64655375626D656E753D6E6577204C642822456469746F7254616273';
wwv_flow_imp.g_varchar2_table(4933) := '42617253686F77546162735A656E4D6F64655375626D656E7522292C4C642E456469746F72416374696F6E73506F736974696F6E5375626D656E753D6E6577204C642822456469746F72416374696F6E73506F736974696F6E5375626D656E7522292C4C';
wwv_flow_imp.g_varchar2_table(4934) := '642E4578706C6F726572436F6E746578743D6E6577204C6428224578706C6F726572436F6E7465787422292C4C642E4578706C6F726572436F6E7465787453686172653D6E6577204C6428224578706C6F726572436F6E74657874536861726522292C4C';
wwv_flow_imp.g_varchar2_table(4935) := '642E457874656E73696F6E436F6E746578743D6E6577204C642822457874656E73696F6E436F6E7465787422292C4C642E476C6F62616C41637469766974793D6E6577204C642822476C6F62616C416374697669747922292C4C642E436F6D6D616E6443';
wwv_flow_imp.g_varchar2_table(4936) := '656E7465723D6E6577204C642822436F6D6D616E6443656E74657222292C4C642E436F6D6D616E6443656E74657243656E7465723D6E6577204C642822436F6D6D616E6443656E74657243656E74657222292C4C642E4C61796F7574436F6E74726F6C4D';
wwv_flow_imp.g_varchar2_table(4937) := '656E755375626D656E753D6E6577204C6428224C61796F7574436F6E74726F6C4D656E755375626D656E7522292C4C642E4C61796F7574436F6E74726F6C4D656E753D6E6577204C6428224C61796F7574436F6E74726F6C4D656E7522292C4C642E4D65';
wwv_flow_imp.g_varchar2_table(4938) := '6E756261724D61696E4D656E753D6E6577204C6428224D656E756261724D61696E4D656E7522292C4C642E4D656E75626172417070656172616E63654D656E753D6E6577204C6428224D656E75626172417070656172616E63654D656E7522292C4C642E';
wwv_flow_imp.g_varchar2_table(4939) := '4D656E7562617244656275674D656E753D6E6577204C6428224D656E7562617244656275674D656E7522292C4C642E4D656E75626172456469744D656E753D6E6577204C6428224D656E75626172456469744D656E7522292C4C642E4D656E7562617243';
wwv_flow_imp.g_varchar2_table(4940) := '6F70793D6E6577204C6428224D656E75626172436F707922292C4C642E4D656E7562617246696C654D656E753D6E6577204C6428224D656E7562617246696C654D656E7522292C4C642E4D656E75626172476F4D656E753D6E6577204C6428224D656E75';
wwv_flow_imp.g_varchar2_table(4941) := '626172476F4D656E7522292C4C642E4D656E7562617248656C704D656E753D6E6577204C6428224D656E7562617248656C704D656E7522292C4C642E4D656E756261724C61796F75744D656E753D6E6577204C6428224D656E756261724C61796F75744D';
wwv_flow_imp.g_varchar2_table(4942) := '656E7522292C4C642E4D656E756261724E6577427265616B706F696E744D656E753D6E6577204C6428224D656E756261724E6577427265616B706F696E744D656E7522292C4C642E50616E656C416C69676E6D656E744D656E753D6E6577204C64282250';
wwv_flow_imp.g_varchar2_table(4943) := '616E656C416C69676E6D656E744D656E7522292C4C642E50616E656C506F736974696F6E4D656E753D6E6577204C64282250616E656C506F736974696F6E4D656E7522292C4C642E4163746976697479426172506F736974696F6E4D656E753D6E657720';
wwv_flow_imp.g_varchar2_table(4944) := '4C6428224163746976697479426172506F736974696F6E4D656E7522292C4C642E4D656E75626172507265666572656E6365734D656E753D6E6577204C6428224D656E75626172507265666572656E6365734D656E7522292C4C642E4D656E7562617252';
wwv_flow_imp.g_varchar2_table(4945) := '6563656E744D656E753D6E6577204C6428224D656E75626172526563656E744D656E7522292C4C642E4D656E7562617253656C656374696F6E4D656E753D6E6577204C6428224D656E7562617253656C656374696F6E4D656E7522292C4C642E4D656E75';
wwv_flow_imp.g_varchar2_table(4946) := '62617253686172653D6E6577204C6428224D656E75626172536861726522292C4C642E4D656E75626172537769746368456469746F724D656E753D6E6577204C6428224D656E75626172537769746368456469746F724D656E7522292C4C642E4D656E75';
wwv_flow_imp.g_varchar2_table(4947) := '62617253776974636847726F75704D656E753D6E6577204C6428224D656E7562617253776974636847726F75704D656E7522292C4C642E4D656E756261725465726D696E616C4D656E753D6E6577204C6428224D656E756261725465726D696E616C4D65';
wwv_flow_imp.g_varchar2_table(4948) := '6E7522292C4C642E4D656E75626172566965774D656E753D6E6577204C6428224D656E75626172566965774D656E7522292C4C642E4D656E75626172486F6D654D656E753D6E6577204C6428224D656E75626172486F6D654D656E7522292C4C642E4F70';
wwv_flow_imp.g_varchar2_table(4949) := '656E456469746F7273436F6E746578743D6E6577204C6428224F70656E456469746F7273436F6E7465787422292C4C642E4F70656E456469746F7273436F6E7465787453686172653D6E6577204C6428224F70656E456469746F7273436F6E7465787453';
wwv_flow_imp.g_varchar2_table(4950) := '6861726522292C4C642E50726F626C656D7350616E656C436F6E746578743D6E6577204C64282250726F626C656D7350616E656C436F6E7465787422292C4C642E53434D496E707574426F783D6E6577204C64282253434D496E707574426F7822292C4C';
wwv_flow_imp.g_varchar2_table(4951) := '642E53434D4368616E676573536570617261746F723D6E6577204C64282253434D4368616E676573536570617261746F7222292C4C642E53434D496E636F6D696E674368616E6765733D6E6577204C64282253434D496E636F6D696E674368616E676573';
wwv_flow_imp.g_varchar2_table(4952) := '22292C4C642E53434D496E636F6D696E674368616E676573436F6E746578743D6E6577204C64282253434D496E636F6D696E674368616E676573436F6E7465787422292C4C642E53434D496E636F6D696E674368616E67657353657474696E673D6E6577';
wwv_flow_imp.g_varchar2_table(4953) := '204C64282253434D496E636F6D696E674368616E67657353657474696E6722292C4C642E53434D4F7574676F696E674368616E6765733D6E6577204C64282253434D4F7574676F696E674368616E67657322292C4C642E53434D4F7574676F696E674368';
wwv_flow_imp.g_varchar2_table(4954) := '616E676573436F6E746578743D6E6577204C64282253434D4F7574676F696E674368616E676573436F6E7465787422292C4C642E53434D4F7574676F696E674368616E67657353657474696E673D6E6577204C64282253434D4F7574676F696E67436861';
wwv_flow_imp.g_varchar2_table(4955) := '6E67657353657474696E6722292C4C642E53434D496E636F6D696E674368616E676573416C6C4368616E676573436F6E746578743D6E6577204C64282253434D496E636F6D696E674368616E676573416C6C4368616E676573436F6E7465787422292C4C';
wwv_flow_imp.g_varchar2_table(4956) := '642E53434D496E636F6D696E674368616E676573486973746F72794974656D436F6E746578743D6E6577204C64282253434D496E636F6D696E674368616E676573486973746F72794974656D436F6E7465787422292C4C642E53434D4F7574676F696E67';
wwv_flow_imp.g_varchar2_table(4957) := '4368616E676573416C6C4368616E676573436F6E746578743D6E6577204C64282253434D4F7574676F696E674368616E676573416C6C4368616E676573436F6E7465787422292C4C642E53434D4F7574676F696E674368616E676573486973746F727949';
wwv_flow_imp.g_varchar2_table(4958) := '74656D436F6E746578743D6E6577204C64282253434D4F7574676F696E674368616E676573486973746F72794974656D436F6E7465787422292C4C642E53434D4368616E6765436F6E746578743D6E6577204C64282253434D4368616E6765436F6E7465';
wwv_flow_imp.g_varchar2_table(4959) := '787422292C4C642E53434D5265736F75726365436F6E746578743D6E6577204C64282253434D5265736F75726365436F6E7465787422292C4C642E53434D5265736F75726365436F6E7465787453686172653D6E6577204C64282253434D5265736F7572';
wwv_flow_imp.g_varchar2_table(4960) := '6365436F6E74657874536861726522292C4C642E53434D5265736F75726365466F6C646572436F6E746578743D6E6577204C64282253434D5265736F75726365466F6C646572436F6E7465787422292C4C642E53434D5265736F7572636547726F757043';
wwv_flow_imp.g_varchar2_table(4961) := '6F6E746578743D6E6577204C64282253434D5265736F7572636547726F7570436F6E7465787422292C4C642E53434D536F75726365436F6E74726F6C3D6E6577204C64282253434D536F75726365436F6E74726F6C22292C4C642E53434D536F75726365';
wwv_flow_imp.g_varchar2_table(4962) := '436F6E74726F6C496E6C696E653D6E6577204C64282253434D536F75726365436F6E74726F6C496E6C696E6522292C4C642E53434D536F75726365436F6E74726F6C5469746C653D6E6577204C64282253434D536F75726365436F6E74726F6C5469746C';
wwv_flow_imp.g_varchar2_table(4963) := '6522292C4C642E53434D5469746C653D6E6577204C64282253434D5469746C6522292C4C642E536561726368436F6E746578743D6E6577204C642822536561726368436F6E7465787422292C4C642E536561726368416374696F6E4D656E753D6E657720';
wwv_flow_imp.g_varchar2_table(4964) := '4C642822536561726368416374696F6E436F6E7465787422292C4C642E53746174757342617257696E646F77496E64696361746F724D656E753D6E6577204C64282253746174757342617257696E646F77496E64696361746F724D656E7522292C4C642E';
wwv_flow_imp.g_varchar2_table(4965) := '53746174757342617252656D6F7465496E64696361746F724D656E753D6E6577204C64282253746174757342617252656D6F7465496E64696361746F724D656E7522292C4C642E537469636B795363726F6C6C436F6E746578743D6E6577204C64282253';
wwv_flow_imp.g_varchar2_table(4966) := '7469636B795363726F6C6C436F6E7465787422292C4C642E546573744974656D3D6E6577204C642822546573744974656D22292C4C642E546573744974656D4775747465723D6E6577204C642822546573744974656D47757474657222292C4C642E5465';
wwv_flow_imp.g_varchar2_table(4967) := '73744D657373616765436F6E746578743D6E6577204C642822546573744D657373616765436F6E7465787422292C4C642E546573744D657373616765436F6E74656E743D6E6577204C642822546573744D657373616765436F6E74656E7422292C4C642E';
wwv_flow_imp.g_varchar2_table(4968) := '546573745065656B456C656D656E743D6E6577204C642822546573745065656B456C656D656E7422292C4C642E546573745065656B5469746C653D6E6577204C642822546573745065656B5469746C6522292C4C642E546F756368426172436F6E746578';
wwv_flow_imp.g_varchar2_table(4969) := '743D6E6577204C642822546F756368426172436F6E7465787422292C4C642E5469746C65426172436F6E746578743D6E6577204C6428225469746C65426172436F6E7465787422292C4C642E5469746C654261725469746C65436F6E746578743D6E6577';
wwv_flow_imp.g_varchar2_table(4970) := '204C6428225469746C654261725469746C65436F6E7465787422292C4C642E54756E6E656C436F6E746578743D6E6577204C64282254756E6E656C436F6E7465787422292C4C642E54756E6E656C507269766163793D6E6577204C64282254756E6E656C';
wwv_flow_imp.g_varchar2_table(4971) := '5072697661637922292C4C642E54756E6E656C50726F746F636F6C3D6E6577204C64282254756E6E656C50726F746F636F6C22292C4C642E54756E6E656C506F7274496E6C696E653D6E6577204C64282254756E6E656C496E6C696E6522292C4C642E54';
wwv_flow_imp.g_varchar2_table(4972) := '756E6E656C5469746C653D6E6577204C64282254756E6E656C5469746C6522292C4C642E54756E6E656C4C6F63616C41646472657373496E6C696E653D6E6577204C64282254756E6E656C4C6F63616C41646472657373496E6C696E6522292C4C642E54';
wwv_flow_imp.g_varchar2_table(4973) := '756E6E656C4F726967696E496E6C696E653D6E6577204C64282254756E6E656C4F726967696E496E6C696E6522292C4C642E566965774974656D436F6E746578743D6E6577204C642822566965774974656D436F6E7465787422292C4C642E5669657743';
wwv_flow_imp.g_varchar2_table(4974) := '6F6E7461696E65725469746C653D6E6577204C64282256696577436F6E7461696E65725469746C6522292C4C642E56696577436F6E7461696E65725469746C65436F6E746578743D6E6577204C64282256696577436F6E7461696E65725469746C65436F';
wwv_flow_imp.g_varchar2_table(4975) := '6E7465787422292C4C642E566965775469746C653D6E6577204C642822566965775469746C6522292C4C642E566965775469746C65436F6E746578743D6E6577204C642822566965775469746C65436F6E7465787422292C4C642E436F6D6D656E744564';
wwv_flow_imp.g_varchar2_table(4976) := '69746F72416374696F6E733D6E6577204C642822436F6D6D656E74456469746F72416374696F6E7322292C4C642E436F6D6D656E745468726561645469746C653D6E6577204C642822436F6D6D656E745468726561645469746C6522292C4C642E436F6D';
wwv_flow_imp.g_varchar2_table(4977) := '6D656E74546872656164416374696F6E733D6E6577204C642822436F6D6D656E74546872656164416374696F6E7322292C4C642E436F6D6D656E745468726561644164646974696F6E616C416374696F6E733D6E6577204C642822436F6D6D656E745468';
wwv_flow_imp.g_varchar2_table(4978) := '726561644164646974696F6E616C416374696F6E7322292C4C642E436F6D6D656E745468726561645469746C65436F6E746578743D6E6577204C642822436F6D6D656E745468726561645469746C65436F6E7465787422292C4C642E436F6D6D656E7454';
wwv_flow_imp.g_varchar2_table(4979) := '6872656164436F6D6D656E74436F6E746578743D6E6577204C642822436F6D6D656E74546872656164436F6D6D656E74436F6E7465787422292C4C642E436F6D6D656E745469746C653D6E6577204C642822436F6D6D656E745469746C6522292C4C642E';
wwv_flow_imp.g_varchar2_table(4980) := '436F6D6D656E74416374696F6E733D6E6577204C642822436F6D6D656E74416374696F6E7322292C4C642E436F6D6D656E747356696577546872656164416374696F6E733D6E6577204C642822436F6D6D656E747356696577546872656164416374696F';
wwv_flow_imp.g_varchar2_table(4981) := '6E7322292C4C642E496E746572616374697665546F6F6C6261723D6E6577204C642822496E746572616374697665546F6F6C62617222292C4C642E496E74657261637469766543656C6C5469746C653D6E6577204C642822496E74657261637469766543';
wwv_flow_imp.g_varchar2_table(4982) := '656C6C5469746C6522292C4C642E496E74657261637469766543656C6C44656C6574653D6E6577204C642822496E74657261637469766543656C6C44656C65746522292C4C642E496E74657261637469766543656C6C457865637574653D6E6577204C64';
wwv_flow_imp.g_varchar2_table(4983) := '2822496E74657261637469766543656C6C4578656375746522292C4C642E496E746572616374697665496E707574457865637574653D6E6577204C642822496E746572616374697665496E7075744578656375746522292C4C642E49737375655265706F';
wwv_flow_imp.g_varchar2_table(4984) := '727465723D6E6577204C64282249737375655265706F7274657222292C4C642E4E6F7465626F6F6B546F6F6C6261723D6E6577204C6428224E6F7465626F6F6B546F6F6C62617222292C4C642E4E6F7465626F6F6B537469636B795363726F6C6C436F6E';
wwv_flow_imp.g_varchar2_table(4985) := '746578743D6E6577204C6428224E6F7465626F6F6B537469636B795363726F6C6C436F6E7465787422292C4C642E4E6F7465626F6F6B43656C6C5469746C653D6E6577204C6428224E6F7465626F6F6B43656C6C5469746C6522292C4C642E4E6F746562';
wwv_flow_imp.g_varchar2_table(4986) := '6F6F6B43656C6C44656C6574653D6E6577204C6428224E6F7465626F6F6B43656C6C44656C65746522292C4C642E4E6F7465626F6F6B43656C6C496E736572743D6E6577204C6428224E6F7465626F6F6B43656C6C496E7365727422292C4C642E4E6F74';
wwv_flow_imp.g_varchar2_table(4987) := '65626F6F6B43656C6C4265747765656E3D6E6577204C6428224E6F7465626F6F6B43656C6C4265747765656E22292C4C642E4E6F7465626F6F6B43656C6C4C697374546F703D6E6577204C6428224E6F7465626F6F6B43656C6C546F7022292C4C642E4E';
wwv_flow_imp.g_varchar2_table(4988) := '6F7465626F6F6B43656C6C457865637574653D6E6577204C6428224E6F7465626F6F6B43656C6C4578656375746522292C4C642E4E6F7465626F6F6B43656C6C45786563757465476F546F3D6E6577204C6428224E6F7465626F6F6B43656C6C45786563';
wwv_flow_imp.g_varchar2_table(4989) := '757465476F546F22292C4C642E4E6F7465626F6F6B43656C6C457865637574655072696D6172793D6E6577204C6428224E6F7465626F6F6B43656C6C457865637574655072696D61727922292C4C642E4E6F7465626F6F6B4469666643656C6C496E7075';
wwv_flow_imp.g_varchar2_table(4990) := '745469746C653D6E6577204C6428224E6F7465626F6F6B4469666643656C6C496E7075745469746C6522292C4C642E4E6F7465626F6F6B4469666643656C6C4D657461646174615469746C653D6E6577204C6428224E6F7465626F6F6B4469666643656C';
wwv_flow_imp.g_varchar2_table(4991) := '6C4D657461646174615469746C6522292C4C642E4E6F7465626F6F6B4469666643656C6C4F7574707574735469746C653D6E6577204C6428224E6F7465626F6F6B4469666643656C6C4F7574707574735469746C6522292C4C642E4E6F7465626F6F6B4F';
wwv_flow_imp.g_varchar2_table(4992) := '7574707574546F6F6C6261723D6E6577204C6428224E6F7465626F6F6B4F7574707574546F6F6C62617222292C4C642E4E6F7465626F6F6B4F75746C696E6546696C7465723D6E6577204C6428224E6F7465626F6F6B4F75746C696E6546696C74657222';
wwv_flow_imp.g_varchar2_table(4993) := '292C4C642E4E6F7465626F6F6B4F75746C696E65416374696F6E4D656E753D6E6577204C6428224E6F7465626F6F6B4F75746C696E65416374696F6E4D656E7522292C4C642E4E6F7465626F6F6B456469746F724C61796F7574436F6E6669677572653D';
wwv_flow_imp.g_varchar2_table(4994) := '6E6577204C6428224E6F7465626F6F6B456469746F724C61796F7574436F6E66696775726522292C4C642E4E6F7465626F6F6B4B65726E656C536F757263653D6E6577204C6428224E6F7465626F6F6B4B65726E656C536F7572636522292C4C642E4275';
wwv_flow_imp.g_varchar2_table(4995) := '6C6B456469745469746C653D6E6577204C64282242756C6B456469745469746C6522292C4C642E42756C6B45646974436F6E746578743D6E6577204C64282242756C6B45646974436F6E7465787422292C4C642E54696D656C696E654974656D436F6E74';
wwv_flow_imp.g_varchar2_table(4996) := '6578743D6E6577204C64282254696D656C696E654974656D436F6E7465787422292C4C642E54696D656C696E655469746C653D6E6577204C64282254696D656C696E655469746C6522292C4C642E54696D656C696E655469746C65436F6E746578743D6E';
wwv_flow_imp.g_varchar2_table(4997) := '6577204C64282254696D656C696E655469746C65436F6E7465787422292C4C642E54696D656C696E6546696C7465725375624D656E753D6E6577204C64282254696D656C696E6546696C7465725375624D656E7522292C4C642E4163636F756E7473436F';
wwv_flow_imp.g_varchar2_table(4998) := '6E746578743D6E6577204C6428224163636F756E7473436F6E7465787422292C4C642E536964656261725469746C653D6E6577204C642822536964656261725469746C6522292C4C642E50616E656C5469746C653D6E6577204C64282250616E656C5469';
wwv_flow_imp.g_varchar2_table(4999) := '746C6522292C4C642E417578696C696172794261725469746C653D6E6577204C642822417578696C696172794261725469746C6522292C4C642E417578696C696172794261724865616465723D6E6577204C642822417578696C69617279426172486561';
wwv_flow_imp.g_varchar2_table(5000) := '64657222292C4C642E5465726D696E616C496E7374616E6365436F6E746578743D6E6577204C6428225465726D696E616C496E7374616E6365436F6E7465787422292C4C642E5465726D696E616C456469746F72496E7374616E6365436F6E746578743D';
wwv_flow_imp.g_varchar2_table(5001) := '6E6577204C6428225465726D696E616C456469746F72496E7374616E6365436F6E7465787422292C4C642E5465726D696E616C4E657744726F70646F776E436F6E746578743D6E6577204C6428225465726D696E616C4E657744726F70646F776E436F6E';
wwv_flow_imp.g_varchar2_table(5002) := '7465787422292C4C642E5465726D696E616C546162436F6E746578743D6E6577204C6428225465726D696E616C546162436F6E7465787422292C4C642E5465726D696E616C546162456D70747941726561436F6E746578743D6E6577204C642822546572';
wwv_flow_imp.g_varchar2_table(5003) := '6D696E616C546162456D70747941726561436F6E7465787422292C4C642E5465726D696E616C537469636B795363726F6C6C436F6E746578743D6E6577204C6428225465726D696E616C537469636B795363726F6C6C436F6E7465787422292C4C642E57';
wwv_flow_imp.g_varchar2_table(5004) := '656276696577436F6E746578743D6E6577204C64282257656276696577436F6E7465787422292C4C642E496E6C696E65436F6D706C6574696F6E73416374696F6E733D6E6577204C642822496E6C696E65436F6D706C6574696F6E73416374696F6E7322';
wwv_flow_imp.g_varchar2_table(5005) := '292C4C642E496E6C696E6545646974416374696F6E733D6E6577204C642822496E6C696E6545646974416374696F6E7322292C4C642E4E657746696C653D6E6577204C6428224E657746696C6522292C4C642E4D65726765496E70757431546F6F6C6261';
wwv_flow_imp.g_varchar2_table(5006) := '723D6E6577204C6428224D65726765546F6F6C62617231546F6F6C62617222292C4C642E4D65726765496E70757432546F6F6C6261723D6E6577204C6428224D65726765546F6F6C62617232546F6F6C62617222292C4C642E4D6572676542617365546F';
wwv_flow_imp.g_varchar2_table(5007) := '6F6C6261723D6E6577204C6428224D6572676542617365546F6F6C62617222292C4C642E4D65726765496E707574526573756C74546F6F6C6261723D6E6577204C6428224D65726765546F6F6C626172526573756C74546F6F6C62617222292C4C642E49';
wwv_flow_imp.g_varchar2_table(5008) := '6E6C696E6553756767657374696F6E546F6F6C6261723D6E6577204C642822496E6C696E6553756767657374696F6E546F6F6C62617222292C4C642E496E6C696E6545646974546F6F6C6261723D6E6577204C642822496E6C696E6545646974546F6F6C';
wwv_flow_imp.g_varchar2_table(5009) := '62617222292C4C642E43686174436F6E746578743D6E6577204C64282243686174436F6E7465787422292C4C642E43686174436F6465426C6F636B3D6E6577204C64282243686174436F6465626C6F636B22292C4C642E43686174436F6D70617265426C';
wwv_flow_imp.g_varchar2_table(5010) := '6F636B3D6E6577204C64282243686174436F6D70617265426C6F636B22292C4C642E436861744D6573736167655469746C653D6E6577204C642822436861744D6573736167655469746C6522292C4C642E43686174457865637574653D6E6577204C6428';
wwv_flow_imp.g_varchar2_table(5011) := '22436861744578656375746522292C4C642E43686174457865637574655365636F6E646172793D6E6577204C64282243686174457865637574655365636F6E6461727922292C4C642E43686174496E707574536964653D6E6577204C6428224368617449';
wwv_flow_imp.g_varchar2_table(5012) := '6E7075745369646522292C4C642E41636365737369626C65566965773D6E6577204C64282241636365737369626C655669657722292C4C642E4D756C746944696666456469746F7246696C65546F6F6C6261723D6E6577204C6428224D756C7469446966';
wwv_flow_imp.g_varchar2_table(5013) := '66456469746F7246696C65546F6F6C62617222292C4C642E44696666456469746F7248756E6B546F6F6C6261723D6E6577204C64282244696666456469746F7248756E6B546F6F6C62617222292C4C642E44696666456469746F7253656C656374696F6E';
wwv_flow_imp.g_varchar2_table(5014) := '546F6F6C6261723D6E6577204C64282244696666456469746F7253656C656374696F6E546F6F6C62617222293B636F6E73742044643D706328226D656E755365727669636522293B636C6173732054647B73746174696320666F722865297B6C65742074';
wwv_flow_imp.g_varchar2_table(5015) := '3D746869732E5F616C6C2E6765742865293B72657475726E20747C7C28743D6E65772054642865292C746869732E5F616C6C2E73657428652C7429292C747D737461746963206D657267652865297B636F6E737420743D6E6577205365743B666F722863';
wwv_flow_imp.g_varchar2_table(5016) := '6F6E7374206E206F662065296E20696E7374616E63656F662054642626742E616464286E2E6964293B72657475726E20747D636F6E7374727563746F722865297B746869732E69643D652C746869732E6861733D743D3E743D3D3D657D7D54642E5F616C';
wwv_flow_imp.g_varchar2_table(5017) := '6C3D6E6577204D61703B636F6E73742049643D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F636F6D6D616E64733D6E6577204D61702C746869732E5F6D656E754974656D733D6E6577204D61702C746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(5018) := '644368616E67654D656E753D6E6577204574287B6D657267653A54642E6D657267657D292C746869732E6F6E4469644368616E67654D656E753D746869732E5F6F6E4469644368616E67654D656E752E6576656E747D616464436F6D6D616E642865297B';
wwv_flow_imp.g_varchar2_table(5019) := '72657475726E20746869732E5F636F6D6D616E64732E73657428652E69642C65292C746869732E5F6F6E4469644368616E67654D656E752E666972652854642E666F72284C642E436F6D6D616E6450616C6574746529292C7274282828293D3E7B746869';
wwv_flow_imp.g_varchar2_table(5020) := '732E5F636F6D6D616E64732E64656C65746528652E6964292626746869732E5F6F6E4469644368616E67654D656E752E666972652854642E666F72284C642E436F6D6D616E6450616C6574746529297D29297D676574436F6D6D616E642865297B726574';
wwv_flow_imp.g_varchar2_table(5021) := '75726E20746869732E5F636F6D6D616E64732E6765742865297D676574436F6D6D616E647328297B636F6E737420653D6E6577204D61703B72657475726E20746869732E5F636F6D6D616E64732E666F7245616368282828742C6E293D3E652E73657428';
wwv_flow_imp.g_varchar2_table(5022) := '6E2C742929292C657D617070656E644D656E754974656D28652C74297B6C6574206E3D746869732E5F6D656E754974656D732E6765742865293B6E7C7C286E3D6E65772067742C746869732E5F6D656E754974656D732E73657428652C6E29293B636F6E';
wwv_flow_imp.g_varchar2_table(5023) := '737420693D6E2E707573682874293B72657475726E20746869732E5F6F6E4469644368616E67654D656E752E666972652854642E666F72286529292C7274282828293D3E7B6928292C746869732E5F6F6E4469644368616E67654D656E752E6669726528';
wwv_flow_imp.g_varchar2_table(5024) := '54642E666F72286529297D29297D617070656E644D656E754974656D732865297B636F6E737420743D6E65772061743B666F7228636F6E73747B69643A6E2C6974656D3A697D6F66206529742E61646428746869732E617070656E644D656E754974656D';
wwv_flow_imp.g_varchar2_table(5025) := '286E2C6929293B72657475726E20747D6765744D656E754974656D732865297B6C657420743B72657475726E20743D746869732E5F6D656E754974656D732E6861732865293F5B2E2E2E746869732E5F6D656E754974656D732E6765742865295D3A5B5D';
wwv_flow_imp.g_varchar2_table(5026) := '2C653D3D3D4C642E436F6D6D616E6450616C657474652626746869732E5F617070656E64496D706C696369744974656D732874292C747D5F617070656E64496D706C696369744974656D732865297B636F6E737420743D6E6577205365743B666F722863';
wwv_flow_imp.g_varchar2_table(5027) := '6F6E7374206E206F662065294564286E29262628742E616464286E2E636F6D6D616E642E6964292C6E2E616C742626742E616464286E2E616C742E696429293B746869732E5F636F6D6D616E64732E666F72456163682828286E2C69293D3E7B742E6861';
wwv_flow_imp.g_varchar2_table(5028) := '732869297C7C652E70757368287B636F6D6D616E643A6E7D297D29297D7D3B636C617373204D6420657874656E64732077637B636F6E7374727563746F7228652C742C6E297B737570657228607375626D656E756974656D2E247B652E7375626D656E75';
wwv_flow_imp.g_varchar2_table(5029) := '2E69647D602C22737472696E67223D3D747970656F6620652E7469746C653F652E7469746C653A652E7469746C652E76616C75652C6E2C227375626D656E7522292C746869732E6974656D3D652C746869732E68696465416374696F6E733D747D7D6C65';
wwv_flow_imp.g_varchar2_table(5030) := '742041643D78643D636C6173737B737461746963206C6162656C28652C74297B72657475726E286E756C6C3D3D743F766F696420303A742E72656E64657253686F72745469746C65292626652E73686F72745469746C653F22737472696E67223D3D7479';
wwv_flow_imp.g_varchar2_table(5031) := '70656F6620652E73686F72745469746C653F652E73686F72745469746C653A652E73686F72745469746C652E76616C75653A22737472696E67223D3D747970656F6620652E7469746C653F652E7469746C653A652E7469746C652E76616C75657D636F6E';
wwv_flow_imp.g_varchar2_table(5032) := '7374727563746F7228652C742C6E2C692C6F2C732C72297B76617220612C6C3B6C657420633B696628746869732E68696465416374696F6E733D692C746869732E6D656E754B657962696E64696E673D6F2C746869732E5F636F6D6D616E645365727669';
wwv_flow_imp.g_varchar2_table(5033) := '63653D722C746869732E69643D652E69642C746869732E6C6162656C3D78642E6C6162656C28652C6E292C746869732E746F6F6C7469703D6E756C6C213D3D286C3D22737472696E67223D3D747970656F6620652E746F6F6C7469703F652E746F6F6C74';
wwv_flow_imp.g_varchar2_table(5034) := '69703A6E756C6C3D3D3D28613D652E746F6F6C746970297C7C766F696420303D3D3D613F766F696420303A612E76616C7565292626766F69642030213D3D6C3F6C3A22222C746869732E656E61626C65643D21652E707265636F6E646974696F6E7C7C73';
wwv_flow_imp.g_varchar2_table(5035) := '2E636F6E746578744D61746368657352756C657328652E707265636F6E646974696F6E292C746869732E636865636B65643D766F696420302C652E746F67676C6564297B636F6E737420743D652E746F67676C65642E636F6E646974696F6E3F652E746F';
wwv_flow_imp.g_varchar2_table(5036) := '67676C65643A7B636F6E646974696F6E3A652E746F67676C65647D3B746869732E636865636B65643D732E636F6E746578744D61746368657352756C657328742E636F6E646974696F6E292C746869732E636865636B65642626742E746F6F6C74697026';
wwv_flow_imp.g_varchar2_table(5037) := '2628746869732E746F6F6C7469703D22737472696E67223D3D747970656F6620742E746F6F6C7469703F742E746F6F6C7469703A742E746F6F6C7469702E76616C7565292C746869732E636865636B65642626546C2E69735468656D6549636F6E28742E';
wwv_flow_imp.g_varchar2_table(5038) := '69636F6E29262628633D742E69636F6E292C746869732E636865636B65642626742E7469746C65262628746869732E6C6162656C3D22737472696E67223D3D747970656F6620742E7469746C653F742E7469746C653A742E7469746C652E76616C756529';
wwv_flow_imp.g_varchar2_table(5039) := '7D637C7C28633D546C2E69735468656D6549636F6E28652E69636F6E293F652E69636F6E3A766F69642030292C746869732E6974656D3D652C746869732E616C743D743F6E657720786428742C766F696420302C6E2C692C766F696420302C732C72293A';
wwv_flow_imp.g_varchar2_table(5040) := '766F696420302C746869732E5F6F7074696F6E733D6E2C746869732E636C6173733D632626546C2E6173436C6173734E616D652863297D72756E282E2E2E65297B76617220742C6E3B6C657420693D5B5D3B72657475726E286E756C6C3D3D3D28743D74';
wwv_flow_imp.g_varchar2_table(5041) := '6869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E61726729262628693D5B2E2E2E692C746869732E5F6F7074696F6E732E6172675D292C286E756C6C3D3D3D286E3D746869732E5F6F7074696F6E73297C7C766F69';
wwv_flow_imp.g_varchar2_table(5042) := '6420303D3D3D6E3F766F696420303A6E2E73686F756C64466F72776172644172677329262628693D5B2E2E2E692C2E2E2E655D292C746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428746869732E69642C2E2E2E';
wwv_flow_imp.g_varchar2_table(5043) := '69297D7D3B41643D78643D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F7065727479446573637269';
wwv_flow_imp.g_varchar2_table(5044) := '70746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C';
wwv_flow_imp.g_varchar2_table(5045) := '6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626';
wwv_flow_imp.g_varchar2_table(5046) := '7226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6B6428352C6364292C6B6428362C7863295D2C4164293B636C617373204E647B636F6E7374727563746F722865297B746869732E646573633D657D7D66756E63';
wwv_flow_imp.g_varchar2_table(5047) := '74696F6E2050642865297B636F6E737420743D6E65772061742C6E3D6E657720652C7B66313A692C6D656E753A6F2C6B657962696E64696E673A732C2E2E2E727D3D6E2E646573633B6966286B632E676574436F6D6D616E6428722E696429297468726F';
wwv_flow_imp.g_varchar2_table(5048) := '77206E6577204572726F72286043616E6E6F742072656769737465722074776F20636F6D6D616E64732077697468207468652073616D652069643A20247B722E69647D60293B696628742E616464286B632E7265676973746572436F6D6D616E64287B69';
wwv_flow_imp.g_varchar2_table(5049) := '643A722E69642C68616E646C65723A28652C2E2E2E74293D3E6E2E72756E28652C2E2E2E74292C6D657461646174613A722E6D657461646174617D29292C41727261792E69734172726179286F2929666F7228636F6E73742065206F66206F29742E6164';
wwv_flow_imp.g_varchar2_table(5050) := '642849642E617070656E644D656E754974656D28652E69642C7B636F6D6D616E643A7B2E2E2E722C707265636F6E646974696F6E3A6E756C6C3D3D3D652E707265636F6E646974696F6E3F766F696420303A722E707265636F6E646974696F6E7D2C2E2E';
wwv_flow_imp.g_varchar2_table(5051) := '2E657D29293B656C7365206F2626742E6164642849642E617070656E644D656E754974656D286F2E69642C7B636F6D6D616E643A7B2E2E2E722C707265636F6E646974696F6E3A6E756C6C3D3D3D6F2E707265636F6E646974696F6E3F766F696420303A';
wwv_flow_imp.g_varchar2_table(5052) := '722E707265636F6E646974696F6E7D2C2E2E2E6F7D29293B69662869262628742E6164642849642E617070656E644D656E754974656D284C642E436F6D6D616E6450616C657474652C7B636F6D6D616E643A722C7768656E3A722E707265636F6E646974';
wwv_flow_imp.g_varchar2_table(5053) := '696F6E7D29292C742E6164642849642E616464436F6D6D616E6428722929292C41727261792E6973417272617928732929666F7228636F6E73742065206F66207329742E6164642843642E72656769737465724B657962696E64696E6752756C65287B2E';
wwv_flow_imp.g_varchar2_table(5054) := '2E2E652C69643A722E69642C7768656E3A722E707265636F6E646974696F6E3F57632E616E6428722E707265636F6E646974696F6E2C652E7768656E293A652E7768656E7D29293B656C736520732626742E6164642843642E72656769737465724B6579';
wwv_flow_imp.g_varchar2_table(5055) := '62696E64696E6752756C65287B2E2E2E732C69643A722E69642C7768656E3A722E707265636F6E646974696F6E3F57632E616E6428722E707265636F6E646974696F6E2C732E7768656E293A732E7768656E7D29293B72657475726E20747D636F6E7374';
wwv_flow_imp.g_varchar2_table(5056) := '204F643D7063282274656C656D657472795365727669636522292C52643D706328226C6F675365727669636522293B7661722046643B2166756E6374696F6E2865297B655B652E4F66663D305D3D224F6666222C655B652E54726163653D315D3D225472';
wwv_flow_imp.g_varchar2_table(5057) := '616365222C655B652E44656275673D325D3D224465627567222C655B652E496E666F3D335D3D22496E666F222C655B652E5761726E696E673D345D3D225761726E696E67222C655B652E4572726F723D355D3D224572726F72227D2846647C7C2846643D';
wwv_flow_imp.g_varchar2_table(5058) := '7B7D29293B636F6E73742042643D46642E496E666F3B636C61737320566420657874656E6473206C747B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E6C6576656C3D42642C746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(5059) := '644368616E67654C6F674C6576656C3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67654C6F674C6576656C3D746869732E5F6F6E4469644368616E67654C6F674C6576656C2E6576656E747D7365744C';
wwv_flow_imp.g_varchar2_table(5060) := '6576656C2865297B746869732E6C6576656C213D3D65262628746869732E6C6576656C3D652C746869732E5F6F6E4469644368616E67654C6F674C6576656C2E6669726528746869732E6C6576656C29297D6765744C6576656C28297B72657475726E20';
wwv_flow_imp.g_varchar2_table(5061) := '746869732E6C6576656C7D636865636B4C6F674C6576656C2865297B72657475726E20746869732E6C6576656C213D3D46642E4F66662626746869732E6C6576656C3C3D657D7D636C617373207A6420657874656E64732056647B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(5062) := '6F7228653D42642C743D2130297B737570657228292C746869732E757365436F6C6F72733D742C746869732E7365744C6576656C2865297D747261636528652C2E2E2E74297B746869732E636865636B4C6F674C6576656C2846642E5472616365292626';
wwv_flow_imp.g_varchar2_table(5063) := '28746869732E757365436F6C6F72733F636F6E736F6C652E6C6F67282225635452414345222C22636F6C6F723A2023383838222C652C2E2E2E74293A636F6E736F6C652E6C6F6728652C2E2E2E7429297D646562756728652C2E2E2E74297B746869732E';
wwv_flow_imp.g_varchar2_table(5064) := '636865636B4C6F674C6576656C2846642E446562756729262628746869732E757365436F6C6F72733F636F6E736F6C652E6C6F67282225634445425547222C226261636B67726F756E643A20236565653B20636F6C6F723A2023383838222C652C2E2E2E';
wwv_flow_imp.g_varchar2_table(5065) := '74293A636F6E736F6C652E6C6F6728652C2E2E2E7429297D696E666F28652C2E2E2E74297B746869732E636865636B4C6F674C6576656C2846642E496E666F29262628746869732E757365436F6C6F72733F636F6E736F6C652E6C6F672822256320494E';
wwv_flow_imp.g_varchar2_table(5066) := '464F222C22636F6C6F723A2023333366222C652C2E2E2E74293A636F6E736F6C652E6C6F6728652C2E2E2E7429297D7761726E28652C2E2E2E74297B746869732E636865636B4C6F674C6576656C2846642E5761726E696E6729262628746869732E7573';
wwv_flow_imp.g_varchar2_table(5067) := '65436F6C6F72733F636F6E736F6C652E6C6F6728222563205741524E222C22636F6C6F723A2023393933222C652C2E2E2E74293A636F6E736F6C652E6C6F6728652C2E2E2E7429297D6572726F7228652C2E2E2E74297B746869732E636865636B4C6F67';
wwv_flow_imp.g_varchar2_table(5068) := '4C6576656C2846642E4572726F7229262628746869732E757365436F6C6F72733F636F6E736F6C652E6C6F67282225632020455252222C22636F6C6F723A2023663333222C652C2E2E2E74293A636F6E736F6C652E6572726F7228652C2E2E2E7429297D';
wwv_flow_imp.g_varchar2_table(5069) := '7D636C61737320486420657874656E64732056647B636F6E7374727563746F722865297B737570657228292C746869732E6C6F67676572733D652C652E6C656E6774682626746869732E7365744C6576656C28655B305D2E6765744C6576656C2829297D';
wwv_flow_imp.g_varchar2_table(5070) := '7365744C6576656C2865297B666F7228636F6E73742074206F6620746869732E6C6F676765727329742E7365744C6576656C2865293B73757065722E7365744C6576656C2865297D747261636528652C2E2E2E74297B666F7228636F6E7374206E206F66';
wwv_flow_imp.g_varchar2_table(5071) := '20746869732E6C6F6767657273296E2E747261636528652C2E2E2E74297D646562756728652C2E2E2E74297B666F7228636F6E7374206E206F6620746869732E6C6F6767657273296E2E646562756728652C2E2E2E74297D696E666F28652C2E2E2E7429';
wwv_flow_imp.g_varchar2_table(5072) := '7B666F7228636F6E7374206E206F6620746869732E6C6F6767657273296E2E696E666F28652C2E2E2E74297D7761726E28652C2E2E2E74297B666F7228636F6E7374206E206F6620746869732E6C6F6767657273296E2E7761726E28652C2E2E2E74297D';
wwv_flow_imp.g_varchar2_table(5073) := '6572726F7228652C2E2E2E74297B666F7228636F6E7374206E206F6620746869732E6C6F6767657273296E2E6572726F7228652C2E2E2E74297D646973706F736528297B666F7228636F6E73742065206F6620746869732E6C6F676765727329652E6469';
wwv_flow_imp.g_varchar2_table(5074) := '73706F736528293B73757065722E646973706F736528297D7D6E6577206C6428226C6F674C6576656C222C66756E6374696F6E2865297B7377697463682865297B636173652046642E54726163653A72657475726E227472616365223B63617365204664';
wwv_flow_imp.g_varchar2_table(5075) := '2E44656275673A72657475726E226465627567223B636173652046642E496E666F3A72657475726E22696E666F223B636173652046642E5761726E696E673A72657475726E227761726E223B636173652046642E4572726F723A72657475726E22657272';
wwv_flow_imp.g_varchar2_table(5076) := '6F72223B636173652046642E4F66663A72657475726E226F6666227D7D2846642E496E666F29293B636C6173732057647B636F6E7374727563746F722865297B746869732E69643D652E69642C746869732E707265636F6E646974696F6E3D652E707265';
wwv_flow_imp.g_varchar2_table(5077) := '636F6E646974696F6E2C746869732E5F6B624F7074733D652E6B624F7074732C746869732E5F6D656E754F7074733D652E6D656E754F7074732C746869732E6D657461646174613D652E6D657461646174617D726567697374657228297B696628417272';
wwv_flow_imp.g_varchar2_table(5078) := '61792E6973417272617928746869732E5F6D656E754F707473293F746869732E5F6D656E754F7074732E666F724561636828746869732E5F72656769737465724D656E754974656D2C74686973293A746869732E5F6D656E754F7074732626746869732E';
wwv_flow_imp.g_varchar2_table(5079) := '5F72656769737465724D656E754974656D28746869732E5F6D656E754F707473292C746869732E5F6B624F707473297B636F6E737420653D41727261792E6973417272617928746869732E5F6B624F707473293F746869732E5F6B624F7074733A5B7468';
wwv_flow_imp.g_varchar2_table(5080) := '69732E5F6B624F7074735D3B666F7228636F6E73742074206F662065297B6C657420653D742E6B62457870723B746869732E707265636F6E646974696F6E262628653D653F57632E616E6428652C746869732E707265636F6E646974696F6E293A746869';
wwv_flow_imp.g_varchar2_table(5081) := '732E707265636F6E646974696F6E293B636F6E7374206E3D7B69643A746869732E69642C7765696768743A742E7765696768742C617267733A742E617267732C7768656E3A652C7072696D6172793A742E7072696D6172792C7365636F6E646172793A74';
wwv_flow_imp.g_varchar2_table(5082) := '2E7365636F6E646172792C77696E3A742E77696E2C6C696E75783A742E6C696E75782C6D61633A742E6D61637D3B43642E72656769737465724B657962696E64696E6752756C65286E297D7D6B632E7265676973746572436F6D6D616E64287B69643A74';
wwv_flow_imp.g_varchar2_table(5083) := '6869732E69642C68616E646C65723A28652C74293D3E746869732E72756E436F6D6D616E6428652C74292C6D657461646174613A746869732E6D657461646174617D297D5F72656769737465724D656E754974656D2865297B49642E617070656E644D65';
wwv_flow_imp.g_varchar2_table(5084) := '6E754974656D28652E6D656E7549642C7B67726F75703A652E67726F75702C636F6D6D616E643A7B69643A746869732E69642C7469746C653A652E7469746C652C69636F6E3A652E69636F6E2C707265636F6E646974696F6E3A746869732E707265636F';
wwv_flow_imp.g_varchar2_table(5085) := '6E646974696F6E7D2C7768656E3A652E7768656E2C6F726465723A652E6F726465727D297D7D636C617373206A6420657874656E64732057647B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F696D';
wwv_flow_imp.g_varchar2_table(5086) := '706C656D656E746174696F6E733D5B5D7D616464496D706C656D656E746174696F6E28652C742C6E2C69297B72657475726E20746869732E5F696D706C656D656E746174696F6E732E70757368287B7072696F726974793A652C6E616D653A742C696D70';
wwv_flow_imp.g_varchar2_table(5087) := '6C656D656E746174696F6E3A6E2C7768656E3A697D292C746869732E5F696D706C656D656E746174696F6E732E736F7274282828652C74293D3E742E7072696F726974792D652E7072696F7269747929292C7B646973706F73653A28293D3E7B666F7228';
wwv_flow_imp.g_varchar2_table(5088) := '6C657420653D303B653C746869732E5F696D706C656D656E746174696F6E732E6C656E6774683B652B2B29696628746869732E5F696D706C656D656E746174696F6E735B655D2E696D706C656D656E746174696F6E3D3D3D6E2972657475726E20766F69';
wwv_flow_imp.g_varchar2_table(5089) := '6420746869732E5F696D706C656D656E746174696F6E732E73706C69636528652C31297D7D7D72756E436F6D6D616E6428652C74297B636F6E7374206E3D652E676574285264292C693D652E676574286364293B6E2E7472616365286045786563757469';
wwv_flow_imp.g_varchar2_table(5090) := '6E6720436F6D6D616E642027247B746869732E69647D272077686963682068617320247B746869732E5F696D706C656D656E746174696F6E732E6C656E6774687D20626F756E642E60293B666F7228636F6E7374206F206F6620746869732E5F696D706C';
wwv_flow_imp.g_varchar2_table(5091) := '656D656E746174696F6E73297B6966286F2E7768656E297B636F6E737420653D692E676574436F6E74657874286A732829293B696628216F2E7768656E2E6576616C7561746528652929636F6E74696E75657D636F6E737420733D6F2E696D706C656D65';
wwv_flow_imp.g_varchar2_table(5092) := '6E746174696F6E28652C74293B69662873297B6966286E2E74726163652860436F6D6D616E642027247B746869732E69647D27207761732068616E646C65642062792027247B6F2E6E616D657D272E60292C22626F6F6C65616E223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(5093) := '732972657475726E3B72657475726E20737D7D6E2E7472616365286054686520436F6D6D616E642027247B746869732E69647D2720776173206E6F742068616E646C656420627920616E7920696D706C656D656E746174696F6E2E60297D7D636C617373';
wwv_flow_imp.g_varchar2_table(5094) := '20716420657874656E64732057647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E636F6D6D616E643D657D72756E436F6D6D616E6428652C74297B72657475726E20746869732E636F6D6D616E642E72756E436F6D6D61';
wwv_flow_imp.g_varchar2_table(5095) := '6E6428652C74297D7D636C61737320246420657874656E64732057647B7374617469632062696E64546F436F6E747269627574696F6E2865297B72657475726E20636C61737320657874656E64732024647B636F6E7374727563746F722865297B737570';
wwv_flow_imp.g_varchar2_table(5096) := '65722865292C746869732E5F63616C6C6261636B3D652E68616E646C65727D72756E456469746F72436F6D6D616E6428742C6E2C69297B636F6E7374206F3D65286E293B6F2626746869732E5F63616C6C6261636B286F2C69297D7D7D73746174696320';
wwv_flow_imp.g_varchar2_table(5097) := '72756E456469746F72436F6D6D616E6428652C742C6E2C69297B636F6E7374206F3D652E676574286763292C733D6F2E676574466F6375736564436F6465456469746F7228297C7C6F2E676574416374697665436F6465456469746F7228293B69662873';
wwv_flow_imp.g_varchar2_table(5098) := '2972657475726E20732E696E766F6B6557697468696E436F6E746578742828653D3E7B696628652E676574286364292E636F6E746578744D61746368657352756C6573286E756C6C213D6E3F6E3A766F69642030292972657475726E206928652C732C74';
wwv_flow_imp.g_varchar2_table(5099) := '297D29297D72756E436F6D6D616E6428652C74297B72657475726E2024642E72756E456469746F72436F6D6D616E6428652C742C746869732E707265636F6E646974696F6E2C2828652C742C6E293D3E746869732E72756E456469746F72436F6D6D616E';
wwv_flow_imp.g_varchar2_table(5100) := '6428652C742C6E2929297D7D636C61737320556420657874656E64732024647B73746174696320636F6E766572744F7074696F6E732865297B6C657420743B66756E6374696F6E206E2874297B72657475726E20742E6D656E7549647C7C28742E6D656E';
wwv_flow_imp.g_varchar2_table(5101) := '7549643D4C642E456469746F72436F6E74657874292C742E7469746C657C7C28742E7469746C653D652E6C6162656C292C742E7768656E3D57632E616E6428652E707265636F6E646974696F6E2C742E7768656E292C747D72657475726E20743D417272';
wwv_flow_imp.g_varchar2_table(5102) := '61792E6973417272617928652E6D656E754F707473293F652E6D656E754F7074733A652E6D656E754F7074733F5B652E6D656E754F7074735D3A5B5D2C41727261792E6973417272617928652E636F6E746578744D656E754F707473293F742E70757368';
wwv_flow_imp.g_varchar2_table(5103) := '282E2E2E652E636F6E746578744D656E754F7074732E6D6170286E29293A652E636F6E746578744D656E754F7074732626742E70757368286E28652E636F6E746578744D656E754F70747329292C652E6D656E754F7074733D742C657D636F6E73747275';
wwv_flow_imp.g_varchar2_table(5104) := '63746F722865297B73757065722855642E636F6E766572744F7074696F6E73286529292C746869732E6C6162656C3D652E6C6162656C2C746869732E616C6961733D652E616C6961737D72756E456469746F72436F6D6D616E6428652C742C6E297B7265';
wwv_flow_imp.g_varchar2_table(5105) := '7475726E20746869732E7265706F727454656C656D6574727928652C74292C746869732E72756E28652C742C6E7C7C7B7D297D7265706F727454656C656D6574727928652C74297B652E676574284F64292E7075626C69634C6F67322822656469746F72';
wwv_flow_imp.g_varchar2_table(5106) := '416374696F6E496E766F6B6564222C7B6E616D653A746869732E6C6162656C2C69643A746869732E69647D297D7D636C617373204B6420657874656E64732055647B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C';
wwv_flow_imp.g_varchar2_table(5107) := '746869732E5F696D706C656D656E746174696F6E733D5B5D7D616464496D706C656D656E746174696F6E28652C74297B72657475726E20746869732E5F696D706C656D656E746174696F6E732E70757368285B652C745D292C746869732E5F696D706C65';
wwv_flow_imp.g_varchar2_table(5108) := '6D656E746174696F6E732E736F7274282828652C74293D3E745B305D2D655B305D29292C7B646973706F73653A28293D3E7B666F72286C657420653D303B653C746869732E5F696D706C656D656E746174696F6E732E6C656E6774683B652B2B29696628';
wwv_flow_imp.g_varchar2_table(5109) := '746869732E5F696D706C656D656E746174696F6E735B655D5B315D3D3D3D742972657475726E20766F696420746869732E5F696D706C656D656E746174696F6E732E73706C69636528652C31297D7D7D72756E28652C742C6E297B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(5110) := '2069206F6620746869732E5F696D706C656D656E746174696F6E73297B636F6E7374206F3D695B315D28652C742C6E293B6966286F297B69662822626F6F6C65616E223D3D747970656F66206F2972657475726E3B72657475726E206F7D7D7D7D636C61';
wwv_flow_imp.g_varchar2_table(5111) := '737320476420657874656E6473204E647B72756E28652C2E2E2E74297B636F6E7374206E3D652E676574286763292C693D6E2E676574466F6375736564436F6465456469746F7228297C7C6E2E676574416374697665436F6465456469746F7228293B69';
wwv_flow_imp.g_varchar2_table(5112) := '6628692972657475726E20692E696E766F6B6557697468696E436F6E746578742828653D3E7B766172206E2C6F3B636F6E737420733D652E676574286364292C723D652E676574285264293B696628732E636F6E746578744D61746368657352756C6573';
wwv_flow_imp.g_varchar2_table(5113) := '286E756C6C213D3D286E3D746869732E646573632E707265636F6E646974696F6E292626766F69642030213D3D6E3F6E3A766F69642030292972657475726E20746869732E72756E456469746F72436F6D6D616E6428652C692C2E2E2E74293B722E6465';
wwv_flow_imp.g_varchar2_table(5114) := '62756728225B456469746F72416374696F6E325D204E4F542072756E6E696E6720636F6D6D616E6420626563617573652069747320707265636F6E646974696F6E2069732046414C5345222C746869732E646573632E69642C6E756C6C3D3D3D286F3D74';
wwv_flow_imp.g_varchar2_table(5115) := '6869732E646573632E707265636F6E646974696F6E297C7C766F696420303D3D3D6F3F766F696420303A6F2E73657269616C697A652829297D29297D7D66756E6374696F6E20516428652C74297B6B632E7265676973746572436F6D6D616E6428652C28';
wwv_flow_imp.g_varchar2_table(5116) := '66756E6374696F6E28652C2E2E2E6E297B636F6E737420693D652E676574287563292C5B6F2C735D3D6E3B796C284E6F2E6973557269286F29292C796C286D632E697349506F736974696F6E287329293B636F6E737420723D652E676574286663292E67';
wwv_flow_imp.g_varchar2_table(5117) := '65744D6F64656C286F293B69662872297B636F6E737420653D6D632E6C6966742873293B72657475726E20692E696E766F6B6546756E6374696F6E28742C722C652C2E2E2E6E2E736C696365283229297D72657475726E20652E676574287663292E6372';
wwv_flow_imp.g_varchar2_table(5118) := '656174654D6F64656C5265666572656E6365286F292E7468656E2828653D3E6E65772050726F6D6973652828286F2C72293D3E7B7472797B6F28692E696E766F6B6546756E6374696F6E28742C652E6F626A6563742E74657874456469746F724D6F6465';
wwv_flow_imp.g_varchar2_table(5119) := '6C2C6D632E6C6966742873292C6E2E736C69636528322929297D63617463682865297B722865297D7D29292E66696E616C6C79282828293D3E7B652E646973706F736528297D292929297D29297D66756E6374696F6E2059642865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(5120) := '74682E494E5354414E43452E7265676973746572456469746F72436F6D6D616E642865292C657D66756E6374696F6E205A642865297B636F6E737420743D6E657720653B72657475726E2074682E494E5354414E43452E7265676973746572456469746F';
wwv_flow_imp.g_varchar2_table(5121) := '72416374696F6E2874292C747D66756E6374696F6E2058642865297B72657475726E2074682E494E5354414E43452E7265676973746572456469746F72416374696F6E2865292C657D66756E6374696F6E204A6428652C742C6E297B74682E494E535441';
wwv_flow_imp.g_varchar2_table(5122) := '4E43452E7265676973746572456469746F72436F6E747269627574696F6E28652C742C6E297D7661722065683B2166756E6374696F6E2865297B652E676574456469746F72436F6D6D616E643D66756E6374696F6E2865297B72657475726E2074682E49';
wwv_flow_imp.g_varchar2_table(5123) := '4E5354414E43452E676574456469746F72436F6D6D616E642865297D2C652E676574456469746F72416374696F6E733D66756E6374696F6E28297B72657475726E2074682E494E5354414E43452E676574456469746F72416374696F6E7328297D2C652E';
wwv_flow_imp.g_varchar2_table(5124) := '676574456469746F72436F6E747269627574696F6E733D66756E6374696F6E28297B72657475726E2074682E494E5354414E43452E676574456469746F72436F6E747269627574696F6E7328297D2C652E676574536F6D65456469746F72436F6E747269';
wwv_flow_imp.g_varchar2_table(5125) := '627574696F6E733D66756E6374696F6E2865297B72657475726E2074682E494E5354414E43452E676574456469746F72436F6E747269627574696F6E7328292E66696C7465722828743D3E652E696E6465784F6628742E6964293E3D3029297D2C652E67';
wwv_flow_imp.g_varchar2_table(5126) := '657444696666456469746F72436F6E747269627574696F6E733D66756E6374696F6E28297B72657475726E2074682E494E5354414E43452E67657444696666456469746F72436F6E747269627574696F6E7328297D7D2865687C7C2865683D7B7D29293B';
wwv_flow_imp.g_varchar2_table(5127) := '636C6173732074687B636F6E7374727563746F7228297B746869732E656469746F72436F6E747269627574696F6E733D5B5D2C746869732E64696666456469746F72436F6E747269627574696F6E733D5B5D2C746869732E656469746F72416374696F6E';
wwv_flow_imp.g_varchar2_table(5128) := '733D5B5D2C746869732E656469746F72436F6D6D616E64733D4F626A6563742E637265617465286E756C6C297D7265676973746572456469746F72436F6E747269627574696F6E28652C742C6E297B746869732E656469746F72436F6E74726962757469';
wwv_flow_imp.g_varchar2_table(5129) := '6F6E732E70757368287B69643A652C63746F723A742C696E7374616E74696174696F6E3A6E7D297D676574456469746F72436F6E747269627574696F6E7328297B72657475726E20746869732E656469746F72436F6E747269627574696F6E732E736C69';
wwv_flow_imp.g_varchar2_table(5130) := '63652830297D67657444696666456469746F72436F6E747269627574696F6E7328297B72657475726E20746869732E64696666456469746F72436F6E747269627574696F6E732E736C6963652830297D7265676973746572456469746F72416374696F6E';
wwv_flow_imp.g_varchar2_table(5131) := '2865297B652E726567697374657228292C746869732E656469746F72416374696F6E732E707573682865297D676574456469746F72416374696F6E7328297B72657475726E20746869732E656469746F72416374696F6E737D7265676973746572456469';
wwv_flow_imp.g_varchar2_table(5132) := '746F72436F6D6D616E642865297B652E726567697374657228292C746869732E656469746F72436F6D6D616E64735B652E69645D3D657D676574456469746F72436F6D6D616E642865297B72657475726E20746869732E656469746F72436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(5133) := '735B655D7C7C6E756C6C7D7D66756E6374696F6E206E682865297B72657475726E20652E726567697374657228292C657D74682E494E5354414E43453D6E65772074682C79642E6164642822656469746F722E636F6E747269627574696F6E73222C7468';
wwv_flow_imp.g_varchar2_table(5134) := '2E494E5354414E4345293B636F6E73742069683D6E68286E6577206A64287B69643A22756E646F222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C7072696D6172793A323130347D2C6D656E754F707473';
wwv_flow_imp.g_varchar2_table(5135) := '3A5B7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F75703A22315F646F222C7469746C653A6228302C222626556E646F22292C6F726465723A317D2C7B6D656E7549643A4C642E436F6D6D616E6450616C657474652C67726F';
wwv_flow_imp.g_varchar2_table(5136) := '75703A22222C7469746C653A6228302C22556E646F22292C6F726465723A317D5D7D29293B6E68286E65772071642869682C7B69643A2264656661756C743A756E646F222C707265636F6E646974696F6E3A766F696420307D29293B636F6E7374206F68';
wwv_flow_imp.g_varchar2_table(5137) := '3D6E68286E6577206A64287B69643A227265646F222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C7072696D6172793A323130332C7365636F6E646172793A5B333132385D2C6D61633A7B7072696D6172';
wwv_flow_imp.g_varchar2_table(5138) := '793A333132387D7D2C6D656E754F7074733A5B7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F75703A22315F646F222C7469746C653A6228302C2226265265646F22292C6F726465723A327D2C7B6D656E7549643A4C642E43';
wwv_flow_imp.g_varchar2_table(5139) := '6F6D6D616E6450616C657474652C67726F75703A22222C7469746C653A6228302C225265646F22292C6F726465723A317D5D7D29293B6E68286E6577207164286F682C7B69643A2264656661756C743A7265646F222C707265636F6E646974696F6E3A76';
wwv_flow_imp.g_varchar2_table(5140) := '6F696420307D29293B636F6E73742073683D6E68286E6577206A64287B69643A22656469746F722E616374696F6E2E73656C656374416C6C222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870';
wwv_flow_imp.g_varchar2_table(5141) := '723A6E756C6C2C7072696D6172793A323037397D2C6D656E754F7074733A5B7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22315F6261736963222C7469746C653A6228302C22262653656C6563742041';
wwv_flow_imp.g_varchar2_table(5142) := '6C6C22292C6F726465723A317D2C7B6D656E7549643A4C642E436F6D6D616E6450616C657474652C67726F75703A22222C7469746C653A6228302C2253656C65637420416C6C22292C6F726465723A317D5D7D29293B636C6173732072687B636F6E7374';
wwv_flow_imp.g_varchar2_table(5143) := '727563746F7228652C742C6E2C69297B653E6E7C7C653D3D3D6E2626743E693F28746869732E73746172744C696E654E756D6265723D6E2C746869732E7374617274436F6C756D6E3D692C746869732E656E644C696E654E756D6265723D652C74686973';
wwv_flow_imp.g_varchar2_table(5144) := '2E656E64436F6C756D6E3D74293A28746869732E73746172744C696E654E756D6265723D652C746869732E7374617274436F6C756D6E3D742C746869732E656E644C696E654E756D6265723D6E2C746869732E656E64436F6C756D6E3D69297D6973456D';
wwv_flow_imp.g_varchar2_table(5145) := '70747928297B72657475726E2072682E6973456D7074792874686973297D737461746963206973456D7074792865297B72657475726E20652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626652E737461727443';
wwv_flow_imp.g_varchar2_table(5146) := '6F6C756D6E3D3D3D652E656E64436F6C756D6E7D636F6E7461696E73506F736974696F6E2865297B72657475726E2072682E636F6E7461696E73506F736974696F6E28746869732C65297D73746174696320636F6E7461696E73506F736974696F6E2865';
wwv_flow_imp.g_varchar2_table(5147) := '2C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E654E756D6265723D3D3D652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(5148) := '4E756D6265722626742E636F6C756D6E3C652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E636F6C756D6E3E652E656E64436F6C756D6E297D7374617469632073747269637443';
wwv_flow_imp.g_varchar2_table(5149) := '6F6E7461696E73506F736974696F6E28652C74297B72657475726E2128742E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(5150) := '6265723D3D3D652E73746172744C696E654E756D6265722626742E636F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E6C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E636F6C756D6E3E3D652E656E64436F6C';
wwv_flow_imp.g_varchar2_table(5151) := '756D6E297D636F6E7461696E7352616E67652865297B72657475726E2072682E636F6E7461696E7352616E676528746869732C65297D73746174696320636F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(5152) := '756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E656E64';
wwv_flow_imp.g_varchar2_table(5153) := '4C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C652E7374617274436F6C756D6E7C7C742E656E';
wwv_flow_imp.g_varchar2_table(5154) := '644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626742E656E64436F6C756D6E3E652E656E64436F6C756D6E297D737472696374436F6E7461696E7352616E67652865297B72657475726E2072682E737472696374436F6E7461';
wwv_flow_imp.g_varchar2_table(5155) := '696E7352616E676528746869732C65297D73746174696320737472696374436F6E7461696E7352616E676528652C74297B72657475726E2128742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C';
wwv_flow_imp.g_varchar2_table(5156) := '696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265727C7C742E73';
wwv_flow_imp.g_varchar2_table(5157) := '746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3C3D652E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D62657226';
wwv_flow_imp.g_varchar2_table(5158) := '26742E656E64436F6C756D6E3E3D652E656E64436F6C756D6E297D706C757352616E67652865297B72657475726E2072682E706C757352616E676528746869732C65297D73746174696320706C757352616E676528652C74297B6C6574206E2C692C6F2C';
wwv_flow_imp.g_varchar2_table(5159) := '733B72657475726E20742E73746172744C696E654E756D6265723C652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C693D742E7374617274436F6C756D6E293A742E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(5160) := '3D3D3D652E73746172744C696E654E756D6265723F286E3D742E73746172744C696E654E756D6265722C693D4D6174682E6D696E28742E7374617274436F6C756D6E2C652E7374617274436F6C756D6E29293A286E3D652E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(5161) := '6265722C693D652E7374617274436F6C756D6E292C742E656E644C696E654E756D6265723E652E656E644C696E654E756D6265723F286F3D742E656E644C696E654E756D6265722C733D742E656E64436F6C756D6E293A742E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(5162) := '65723D3D3D652E656E644C696E654E756D6265723F286F3D742E656E644C696E654E756D6265722C733D4D6174682E6D617828742E656E64436F6C756D6E2C652E656E64436F6C756D6E29293A286F3D652E656E644C696E654E756D6265722C733D652E';
wwv_flow_imp.g_varchar2_table(5163) := '656E64436F6C756D6E292C6E6577207268286E2C692C6F2C73297D696E7465727365637452616E6765732865297B72657475726E2072682E696E7465727365637452616E67657328746869732C65297D73746174696320696E7465727365637452616E67';
wwv_flow_imp.g_varchar2_table(5164) := '657328652C74297B6C6574206E3D652E73746172744C696E654E756D6265722C693D652E7374617274436F6C756D6E2C6F3D652E656E644C696E654E756D6265722C733D652E656E64436F6C756D6E3B636F6E737420723D742E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(5165) := '756D6265722C613D742E7374617274436F6C756D6E2C6C3D742E656E644C696E654E756D6265722C633D742E656E64436F6C756D6E3B72657475726E206E3C723F286E3D722C693D61293A6E3D3D3D72262628693D4D6174682E6D617828692C6129292C';
wwv_flow_imp.g_varchar2_table(5166) := '6F3E6C3F286F3D6C2C733D63293A6F3D3D3D6C262628733D4D6174682E6D696E28732C6329292C6E3E6F7C7C6E3D3D3D6F2626693E733F6E756C6C3A6E6577207268286E2C692C6F2C73297D657175616C7352616E67652865297B72657475726E207268';
wwv_flow_imp.g_varchar2_table(5167) := '2E657175616C7352616E676528746869732C65297D73746174696320657175616C7352616E676528652C74297B72657475726E2165262621747C7C21216526262121742626652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(5168) := '4E756D6265722626652E7374617274436F6C756D6E3D3D3D742E7374617274436F6C756D6E2626652E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265722626652E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E7D';
wwv_flow_imp.g_varchar2_table(5169) := '676574456E64506F736974696F6E28297B72657475726E2072682E676574456E64506F736974696F6E2874686973297D73746174696320676574456E64506F736974696F6E2865297B72657475726E206E6577206D6328652E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(5170) := '65722C652E656E64436F6C756D6E297D6765745374617274506F736974696F6E28297B72657475726E2072682E6765745374617274506F736974696F6E2874686973297D737461746963206765745374617274506F736974696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(5171) := '6E206E6577206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D746F537472696E6728297B72657475726E225B222B746869732E73746172744C696E654E756D6265722B222C222B746869732E7374617274436F';
wwv_flow_imp.g_varchar2_table(5172) := '6C756D6E2B22202D3E20222B746869732E656E644C696E654E756D6265722B222C222B746869732E656E64436F6C756D6E2B225D227D736574456E64506F736974696F6E28652C74297B72657475726E206E657720726828746869732E73746172744C69';
wwv_flow_imp.g_varchar2_table(5173) := '6E654E756D6265722C746869732E7374617274436F6C756D6E2C652C74297D7365745374617274506F736974696F6E28652C74297B72657475726E206E657720726828652C742C746869732E656E644C696E654E756D6265722C746869732E656E64436F';
wwv_flow_imp.g_varchar2_table(5174) := '6C756D6E297D636F6C6C61707365546F537461727428297B72657475726E2072682E636F6C6C61707365546F53746172742874686973297D73746174696320636F6C6C61707365546F53746172742865297B72657475726E206E657720726828652E7374';
wwv_flow_imp.g_varchar2_table(5175) := '6172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D636F6C6C61707365546F456E6428297B72657475726E2072682E636F6C6C61707365546F456E64';
wwv_flow_imp.g_varchar2_table(5176) := '2874686973297D73746174696320636F6C6C61707365546F456E642865297B72657475726E206E657720726828652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E';
wwv_flow_imp.g_varchar2_table(5177) := '297D64656C74612865297B72657475726E206E657720726828746869732E73746172744C696E654E756D6265722B652C746869732E7374617274436F6C756D6E2C746869732E656E644C696E654E756D6265722B652C746869732E656E64436F6C756D6E';
wwv_flow_imp.g_varchar2_table(5178) := '297D7374617469632066726F6D506F736974696F6E7328652C743D65297B72657475726E206E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D737461746963206C696674';
wwv_flow_imp.g_varchar2_table(5179) := '2865297B72657475726E20653F6E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E756C6C7D7374617469632069734952616E67';
wwv_flow_imp.g_varchar2_table(5180) := '652865297B72657475726E20652626226E756D626572223D3D747970656F6620652E73746172744C696E654E756D6265722626226E756D626572223D3D747970656F6620652E7374617274436F6C756D6E2626226E756D626572223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(5181) := '652E656E644C696E654E756D6265722626226E756D626572223D3D747970656F6620652E656E64436F6C756D6E7D73746174696320617265496E74657273656374696E674F72546F756368696E6728652C74297B72657475726E2128652E656E644C696E';
wwv_flow_imp.g_varchar2_table(5182) := '654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E656E64436F6C756D6E3C742E7374617274436F6C756D6E7C7C742E656E644C696E65';
wwv_flow_imp.g_varchar2_table(5183) := '4E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E656E64436F6C756D6E3C652E7374617274436F6C756D6E297D73746174696320617265';
wwv_flow_imp.g_varchar2_table(5184) := '496E74657273656374696E6728652C74297B72657475726E2128652E656E644C696E654E756D6265723C742E73746172744C696E654E756D6265727C7C652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265722626652E';
wwv_flow_imp.g_varchar2_table(5185) := '656E64436F6C756D6E3C3D742E7374617274436F6C756D6E7C7C742E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C742E656E644C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626742E';
wwv_flow_imp.g_varchar2_table(5186) := '656E64436F6C756D6E3C3D652E7374617274436F6C756D6E297D73746174696320636F6D7061726552616E6765735573696E6753746172747328652C74297B69662865262674297B636F6E7374206E3D307C652E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(5187) := '693D307C742E73746172744C696E654E756D6265723B6966286E3D3D3D69297B636F6E7374206E3D307C652E7374617274436F6C756D6E2C693D307C742E7374617274436F6C756D6E3B6966286E3D3D3D69297B636F6E7374206E3D307C652E656E644C';
wwv_flow_imp.g_varchar2_table(5188) := '696E654E756D6265722C693D307C742E656E644C696E654E756D6265723B72657475726E206E3D3D3D693F28307C652E656E64436F6C756D6E292D28307C742E656E64436F6C756D6E293A6E2D697D72657475726E206E2D697D72657475726E206E2D69';
wwv_flow_imp.g_varchar2_table(5189) := '7D72657475726E28653F313A30292D28743F313A30297D73746174696320636F6D7061726552616E6765735573696E67456E647328652C74297B72657475726E20652E656E644C696E654E756D6265723D3D3D742E656E644C696E654E756D6265723F65';
wwv_flow_imp.g_varchar2_table(5190) := '2E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E3F652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E2D742E7374617274436F6C756D6E3A652E73746172744C69';
wwv_flow_imp.g_varchar2_table(5191) := '6E654E756D6265722D742E73746172744C696E654E756D6265723A652E656E64436F6C756D6E2D742E656E64436F6C756D6E3A652E656E644C696E654E756D6265722D742E656E644C696E654E756D6265727D737461746963207370616E734D756C7469';
wwv_flow_imp.g_varchar2_table(5192) := '706C654C696E65732865297B72657475726E20652E656E644C696E654E756D6265723E652E73746172744C696E654E756D6265727D746F4A534F4E28297B72657475726E20746869737D7D636C61737320616820657874656E64732072687B636F6E7374';
wwv_flow_imp.g_varchar2_table(5193) := '727563746F7228652C742C6E2C69297B737570657228652C742C6E2C69292C746869732E73656C656374696F6E53746172744C696E654E756D6265723D652C746869732E73656C656374696F6E5374617274436F6C756D6E3D742C746869732E706F7369';
wwv_flow_imp.g_varchar2_table(5194) := '74696F6E4C696E654E756D6265723D6E2C746869732E706F736974696F6E436F6C756D6E3D697D746F537472696E6728297B72657475726E225B222B746869732E73656C656374696F6E53746172744C696E654E756D6265722B222C222B746869732E73';
wwv_flow_imp.g_varchar2_table(5195) := '656C656374696F6E5374617274436F6C756D6E2B22202D3E20222B746869732E706F736974696F6E4C696E654E756D6265722B222C222B746869732E706F736974696F6E436F6C756D6E2B225D227D657175616C7353656C656374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(5196) := '7475726E2061682E73656C656374696F6E73457175616C28746869732C65297D7374617469632073656C656374696F6E73457175616C28652C74297B72657475726E20652E73656C656374696F6E53746172744C696E654E756D6265723D3D3D742E7365';
wwv_flow_imp.g_varchar2_table(5197) := '6C656374696F6E53746172744C696E654E756D6265722626652E73656C656374696F6E5374617274436F6C756D6E3D3D3D742E73656C656374696F6E5374617274436F6C756D6E2626652E706F736974696F6E4C696E654E756D6265723D3D3D742E706F';
wwv_flow_imp.g_varchar2_table(5198) := '736974696F6E4C696E654E756D6265722626652E706F736974696F6E436F6C756D6E3D3D3D742E706F736974696F6E436F6C756D6E7D676574446972656374696F6E28297B72657475726E20746869732E73656C656374696F6E53746172744C696E654E';
wwv_flow_imp.g_varchar2_table(5199) := '756D6265723D3D3D746869732E73746172744C696E654E756D6265722626746869732E73656C656374696F6E5374617274436F6C756D6E3D3D3D746869732E7374617274436F6C756D6E3F303A317D736574456E64506F736974696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(5200) := '657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E657720616828746869732E73746172744C696E654E756D6265722C746869732E7374617274436F6C756D6E2C652C74293A6E657720616828652C742C746869732E73746172';
wwv_flow_imp.g_varchar2_table(5201) := '744C696E654E756D6265722C746869732E7374617274436F6C756D6E297D676574506F736974696F6E28297B72657475726E206E6577206D6328746869732E706F736974696F6E4C696E654E756D6265722C746869732E706F736974696F6E436F6C756D';
wwv_flow_imp.g_varchar2_table(5202) := '6E297D67657453656C656374696F6E537461727428297B72657475726E206E6577206D6328746869732E73656C656374696F6E53746172744C696E654E756D6265722C746869732E73656C656374696F6E5374617274436F6C756D6E297D736574537461';
wwv_flow_imp.g_varchar2_table(5203) := '7274506F736974696F6E28652C74297B72657475726E20303D3D3D746869732E676574446972656374696F6E28293F6E657720616828652C742C746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E293A6E657720616828';
wwv_flow_imp.g_varchar2_table(5204) := '746869732E656E644C696E654E756D6265722C746869732E656E64436F6C756D6E2C652C74297D7374617469632066726F6D506F736974696F6E7328652C743D65297B72657475726E206E657720616828652E6C696E654E756D6265722C652E636F6C75';
wwv_flow_imp.g_varchar2_table(5205) := '6D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D7374617469632066726F6D52616E676528652C74297B72657475726E20303D3D3D743F6E657720616828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(5206) := '652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A6E657720616828652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D737461';
wwv_flow_imp.g_varchar2_table(5207) := '746963206C69667453656C656374696F6E2865297B72657475726E206E657720616828652E73656C656374696F6E53746172744C696E654E756D6265722C652E73656C656374696F6E5374617274436F6C756D6E2C652E706F736974696F6E4C696E654E';
wwv_flow_imp.g_varchar2_table(5208) := '756D6265722C652E706F736974696F6E436F6C756D6E297D7374617469632073656C656374696F6E73417272457175616C28652C74297B69662865262621747C7C21652626742972657475726E21313B6966282165262621742972657475726E21303B69';
wwv_flow_imp.g_varchar2_table(5209) := '6628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B2969662821746869732E73656C656374696F6E73457175616C28655B6E5D2C745B6E5D29297265';
wwv_flow_imp.g_varchar2_table(5210) := '7475726E21313B72657475726E21307D7374617469632069734953656C656374696F6E2865297B72657475726E20652626226E756D626572223D3D747970656F6620652E73656C656374696F6E53746172744C696E654E756D6265722626226E756D6265';
wwv_flow_imp.g_varchar2_table(5211) := '72223D3D747970656F6620652E73656C656374696F6E5374617274436F6C756D6E2626226E756D626572223D3D747970656F6620652E706F736974696F6E4C696E654E756D6265722626226E756D626572223D3D747970656F6620652E706F736974696F';
wwv_flow_imp.g_varchar2_table(5212) := '6E436F6C756D6E7D7374617469632063726561746557697468446972656374696F6E28652C742C6E2C692C6F297B72657475726E20303D3D3D6F3F6E657720616828652C742C6E2C69293A6E6577206168286E2C692C652C74297D7D766172206C683B21';
wwv_flow_imp.g_varchar2_table(5213) := '66756E6374696F6E2865297B652E656469746F7253696D706C65496E7075743D6E6577206C642822656469746F7253696D706C65496E707574222C21312C2130292C652E656469746F7254657874466F6375733D6E6577206C642822656469746F725465';
wwv_flow_imp.g_varchar2_table(5214) := '7874466F637573222C21312C6228302C22576865746865722074686520656469746F7220746578742068617320666F6375732028637572736F7220697320626C696E6B696E67292229292C652E666F6375733D6E6577206C642822656469746F72466F63';
wwv_flow_imp.g_varchar2_table(5215) := '7573222C21312C6228302C22576865746865722074686520656469746F72206F7220616E20656469746F72207769646765742068617320666F6375732028652E672E20666F63757320697320696E207468652066696E6420776964676574292229292C65';
wwv_flow_imp.g_varchar2_table(5216) := '2E74657874496E707574466F6375733D6E6577206C64282274657874496E707574466F637573222C21312C6228302C225768657468657220616E20656469746F72206F7220612072696368207465787420696E7075742068617320666F63757320286375';
wwv_flow_imp.g_varchar2_table(5217) := '72736F7220697320626C696E6B696E67292229292C652E726561644F6E6C793D6E6577206C642822656469746F72526561646F6E6C79222C21312C6228302C22576865746865722074686520656469746F7220697320726561642D6F6E6C792229292C65';
wwv_flow_imp.g_varchar2_table(5218) := '2E696E44696666456469746F723D6E6577206C642822696E44696666456469746F72222C21312C6228302C22576865746865722074686520636F6E746578742069732061206469666620656469746F722229292C652E6973456D62656464656444696666';
wwv_flow_imp.g_varchar2_table(5219) := '456469746F723D6E6577206C6428226973456D62656464656444696666456469746F72222C21312C6228302C22576865746865722074686520636F6E7465787420697320616E20656D626564646564206469666620656469746F722229292C652E696E4D';
wwv_flow_imp.g_varchar2_table(5220) := '756C746944696666456469746F723D6E6577206C642822696E4D756C746944696666456469746F72222C21312C6228302C22576865746865722074686520636F6E746578742069732061206D756C7469206469666620656469746F722229292C652E6D75';
wwv_flow_imp.g_varchar2_table(5221) := '6C746944696666456469746F72416C6C436F6C6C61707365643D6E6577206C6428226D756C746944696666456469746F72416C6C436F6C6C6170736564222C766F696420302C6228302C225768657468657220616C6C2066696C657320696E206D756C74';
wwv_flow_imp.g_varchar2_table(5222) := '69206469666620656469746F722061726520636F6C6C61707365642229292C652E6861734368616E6765733D6E6577206C64282264696666456469746F724861734368616E676573222C21312C6228302C22576865746865722074686520646966662065';
wwv_flow_imp.g_varchar2_table(5223) := '6469746F7220686173206368616E6765732229292C652E636F6D706172696E674D6F766564436F64653D6E6577206C642822636F6D706172696E674D6F766564436F6465222C21312C6228302C22576865746865722061206D6F76656420636F64652062';
wwv_flow_imp.g_varchar2_table(5224) := '6C6F636B2069732073656C656374656420666F7220636F6D70617269736F6E2229292C652E61636365737369626C654469666656696577657256697369626C653D6E6577206C64282261636365737369626C654469666656696577657256697369626C65';
wwv_flow_imp.g_varchar2_table(5225) := '222C21312C6228302C2257686574686572207468652061636365737369626C652064696666207669657765722069732076697369626C652229292C652E64696666456469746F7252656E64657253696465427953696465496E6C696E65427265616B706F';
wwv_flow_imp.g_varchar2_table(5226) := '696E74526561636865643D6E6577206C64282264696666456469746F7252656E64657253696465427953696465496E6C696E65427265616B706F696E7452656163686564222C21312C6228302C225768657468657220746865206469666620656469746F';
wwv_flow_imp.g_varchar2_table(5227) := '722072656E6465722073696465206279207369646520696E6C696E6520627265616B706F696E7420697320726561636865642229292C652E64696666456469746F72496E6C696E654D6F64653D6E6577206C64282264696666456469746F72496E6C696E';
wwv_flow_imp.g_varchar2_table(5228) := '654D6F6465222C21312C6228302C225768657468657220696E6C696E65206D6F6465206973206163746976652229292C652E64696666456469746F724F726967696E616C5772697461626C653D6E6577206C64282264696666456469746F724F72696769';
wwv_flow_imp.g_varchar2_table(5229) := '6E616C5772697461626C65222C21312C6228302C2257686574686572206D6F646966696564206973207772697461626C6520696E20746865206469666620656469746F722229292C652E64696666456469746F724D6F6469666965645772697461626C65';
wwv_flow_imp.g_varchar2_table(5230) := '3D6E6577206C64282264696666456469746F724D6F6469666965645772697461626C65222C21312C6228302C2257686574686572206D6F646966696564206973207772697461626C6520696E20746865206469666620656469746F722229292C652E6469';
wwv_flow_imp.g_varchar2_table(5231) := '6666456469746F724F726967696E616C5572693D6E6577206C64282264696666456469746F724F726967696E616C557269222C22222C6228302C2254686520757269206F6620746865206F726967696E616C20646F63756D656E742229292C652E646966';
wwv_flow_imp.g_varchar2_table(5232) := '66456469746F724D6F6469666965645572693D6E6577206C64282264696666456469746F724D6F646966696564557269222C22222C6228302C2254686520757269206F6620746865206D6F64696669656420646F63756D656E742229292C652E636F6C75';
wwv_flow_imp.g_varchar2_table(5233) := '6D6E53656C656374696F6E3D6E6577206C642822656469746F72436F6C756D6E53656C656374696F6E222C21312C6228302C22576865746865722060656469746F722E636F6C756D6E53656C656374696F6E6020697320656E61626C65642229292C652E';
wwv_flow_imp.g_varchar2_table(5234) := '7772697461626C653D652E726561644F6E6C792E746F4E65676174656428292C652E6861734E6F6E456D70747953656C656374696F6E3D6E6577206C642822656469746F7248617353656C656374696F6E222C21312C6228302C22576865746865722074';
wwv_flow_imp.g_varchar2_table(5235) := '686520656469746F722068617320746578742073656C65637465642229292C652E6861734F6E6C79456D70747953656C656374696F6E3D652E6861734E6F6E456D70747953656C656374696F6E2E746F4E65676174656428292C652E6861734D756C7469';
wwv_flow_imp.g_varchar2_table(5236) := '706C6553656C656374696F6E733D6E6577206C642822656469746F724861734D756C7469706C6553656C656374696F6E73222C21312C6228302C22576865746865722074686520656469746F7220686173206D756C7469706C652073656C656374696F6E';
wwv_flow_imp.g_varchar2_table(5237) := '732229292C652E68617353696E676C6553656C656374696F6E3D652E6861734D756C7469706C6553656C656374696F6E732E746F4E65676174656428292C652E7461624D6F766573466F6375733D6E6577206C642822656469746F725461624D6F766573';
wwv_flow_imp.g_varchar2_table(5238) := '466F637573222C21312C6228302C22576865746865722060546162602077696C6C206D6F766520666F637573206F7574206F662074686520656469746F722229292C652E746162446F65734E6F744D6F7665466F6375733D652E7461624D6F766573466F';
wwv_flow_imp.g_varchar2_table(5239) := '6375732E746F4E65676174656428292C652E6973496E456D626564646564456469746F723D6E6577206C6428226973496E456D626564646564456469746F72222C21312C2130292C652E63616E556E646F3D6E6577206C64282263616E556E646F222C21';
wwv_flow_imp.g_varchar2_table(5240) := '312C2130292C652E63616E5265646F3D6E6577206C64282263616E5265646F222C21312C2130292C652E686F76657256697369626C653D6E6577206C642822656469746F72486F76657256697369626C65222C21312C6228302C22576865746865722074';
wwv_flow_imp.g_varchar2_table(5241) := '686520656469746F7220686F7665722069732076697369626C652229292C652E686F766572466F63757365643D6E6577206C642822656469746F72486F766572466F6375736564222C21312C6228302C22576865746865722074686520656469746F7220';
wwv_flow_imp.g_varchar2_table(5242) := '686F76657220697320666F63757365642229292C652E737469636B795363726F6C6C466F63757365643D6E6577206C642822737469636B795363726F6C6C466F6375736564222C21312C6228302C22576865746865722074686520737469636B79207363';
wwv_flow_imp.g_varchar2_table(5243) := '726F6C6C20697320666F63757365642229292C652E737469636B795363726F6C6C56697369626C653D6E6577206C642822737469636B795363726F6C6C56697369626C65222C21312C6228302C22576865746865722074686520737469636B7920736372';
wwv_flow_imp.g_varchar2_table(5244) := '6F6C6C2069732076697369626C652229292C652E7374616E64616C6F6E65436F6C6F725069636B657256697369626C653D6E6577206C6428227374616E64616C6F6E65436F6C6F725069636B657256697369626C65222C21312C6228302C225768657468';
wwv_flow_imp.g_varchar2_table(5245) := '657220746865207374616E64616C6F6E6520636F6C6F72207069636B65722069732076697369626C652229292C652E7374616E64616C6F6E65436F6C6F725069636B6572466F63757365643D6E6577206C6428227374616E64616C6F6E65436F6C6F7250';
wwv_flow_imp.g_varchar2_table(5246) := '69636B6572466F6375736564222C21312C6228302C225768657468657220746865207374616E64616C6F6E6520636F6C6F72207069636B657220697320666F63757365642229292C652E696E436F6D706F73697465456469746F723D6E6577206C642822';
wwv_flow_imp.g_varchar2_table(5247) := '696E436F6D706F73697465456469746F72222C766F696420302C6228302C22576865746865722074686520656469746F722069732070617274206F662061206C617267657220656469746F722028652E672E206E6F7465626F6F6B73292229292C652E6E';
wwv_flow_imp.g_varchar2_table(5248) := '6F74496E436F6D706F73697465456469746F723D652E696E436F6D706F73697465456469746F722E746F4E65676174656428292C652E6C616E677561676549643D6E6577206C642822656469746F724C616E674964222C22222C6228302C22546865206C';
wwv_flow_imp.g_varchar2_table(5249) := '616E6775616765206964656E746966696572206F662074686520656469746F722229292C652E686173436F6D706C6574696F6E4974656D50726F76696465723D6E6577206C642822656469746F72486173436F6D706C6574696F6E4974656D50726F7669';
wwv_flow_imp.g_varchar2_table(5250) := '646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120636F6D706C6574696F6E206974656D2070726F76696465722229292C652E686173436F6465416374696F6E7350726F76696465723D6E6577206C64282265';
wwv_flow_imp.g_varchar2_table(5251) := '6469746F72486173436F6465416374696F6E7350726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120636F646520616374696F6E732070726F76696465722229292C652E686173436F64654C656E73';
wwv_flow_imp.g_varchar2_table(5252) := '50726F76696465723D6E6577206C642822656469746F72486173436F64654C656E7350726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120636F6465206C656E732070726F76696465722229292C65';
wwv_flow_imp.g_varchar2_table(5253) := '2E686173446566696E6974696F6E50726F76696465723D6E6577206C642822656469746F72486173446566696E6974696F6E50726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120646566696E6974';
wwv_flow_imp.g_varchar2_table(5254) := '696F6E2070726F76696465722229292C652E6861734465636C61726174696F6E50726F76696465723D6E6577206C642822656469746F724861734465636C61726174696F6E50726F7669646572222C21312C6228302C2257686574686572207468652065';
wwv_flow_imp.g_varchar2_table(5255) := '6469746F72206861732061206465636C61726174696F6E2070726F76696465722229292C652E686173496D706C656D656E746174696F6E50726F76696465723D6E6577206C642822656469746F72486173496D706C656D656E746174696F6E50726F7669';
wwv_flow_imp.g_varchar2_table(5256) := '646572222C21312C6228302C22576865746865722074686520656469746F722068617320616E20696D706C656D656E746174696F6E2070726F76696465722229292C652E68617354797065446566696E6974696F6E50726F76696465723D6E6577206C64';
wwv_flow_imp.g_varchar2_table(5257) := '2822656469746F7248617354797065446566696E6974696F6E50726F7669646572222C21312C6228302C22576865746865722074686520656469746F72206861732061207479706520646566696E6974696F6E2070726F76696465722229292C652E6861';
wwv_flow_imp.g_varchar2_table(5258) := '73486F76657250726F76696465723D6E6577206C642822656469746F72486173486F76657250726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120686F7665722070726F76696465722229292C652E';
wwv_flow_imp.g_varchar2_table(5259) := '686173446F63756D656E74486967686C6967687450726F76696465723D6E6577206C642822656469746F72486173446F63756D656E74486967686C6967687450726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220';
wwv_flow_imp.g_varchar2_table(5260) := '686173206120646F63756D656E7420686967686C696768742070726F76696465722229292C652E686173446F63756D656E7453796D626F6C50726F76696465723D6E6577206C642822656469746F72486173446F63756D656E7453796D626F6C50726F76';
wwv_flow_imp.g_varchar2_table(5261) := '69646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120646F63756D656E742073796D626F6C2070726F76696465722229292C652E6861735265666572656E636550726F76696465723D6E6577206C6428226564';
wwv_flow_imp.g_varchar2_table(5262) := '69746F724861735265666572656E636550726F7669646572222C21312C6228302C22576865746865722074686520656469746F72206861732061207265666572656E63652070726F76696465722229292C652E68617352656E616D6550726F7669646572';
wwv_flow_imp.g_varchar2_table(5263) := '3D6E6577206C642822656469746F7248617352656E616D6550726F7669646572222C21312C6228302C22576865746865722074686520656469746F722068617320612072656E616D652070726F76696465722229292C652E6861735369676E6174757265';
wwv_flow_imp.g_varchar2_table(5264) := '48656C7050726F76696465723D6E6577206C642822656469746F724861735369676E617475726548656C7050726F7669646572222C21312C6228302C22576865746865722074686520656469746F72206861732061207369676E61747572652068656C70';
wwv_flow_imp.g_varchar2_table(5265) := '2070726F76696465722229292C652E686173496E6C617948696E747350726F76696465723D6E6577206C642822656469746F72486173496E6C617948696E747350726F7669646572222C21312C6228302C22576865746865722074686520656469746F72';
wwv_flow_imp.g_varchar2_table(5266) := '2068617320616E20696E6C696E652068696E74732070726F76696465722229292C652E686173446F63756D656E74466F726D617474696E6750726F76696465723D6E6577206C642822656469746F72486173446F63756D656E74466F726D617474696E67';
wwv_flow_imp.g_varchar2_table(5267) := '50726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206120646F63756D656E7420666F726D617474696E672070726F76696465722229292C652E686173446F63756D656E7453656C656374696F6E466F72';
wwv_flow_imp.g_varchar2_table(5268) := '6D617474696E6750726F76696465723D6E6577206C642822656469746F72486173446F63756D656E7453656C656374696F6E466F726D617474696E6750726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173';
wwv_flow_imp.g_varchar2_table(5269) := '206120646F63756D656E742073656C656374696F6E20666F726D617474696E672070726F76696465722229292C652E6861734D756C7469706C65446F63756D656E74466F726D617474696E6750726F76696465723D6E6577206C642822656469746F7248';
wwv_flow_imp.g_varchar2_table(5270) := '61734D756C7469706C65446F63756D656E74466F726D617474696E6750726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206D756C7469706C6520646F63756D656E7420666F726D617474696E67207072';
wwv_flow_imp.g_varchar2_table(5271) := '6F7669646572732229292C652E6861734D756C7469706C65446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465723D6E6577206C642822656469746F724861734D756C7469706C65446F63756D656E7453656C65637469';
wwv_flow_imp.g_varchar2_table(5272) := '6F6E466F726D617474696E6750726F7669646572222C21312C6228302C22576865746865722074686520656469746F7220686173206D756C7469706C6520646F63756D656E742073656C656374696F6E20666F726D617474696E672070726F7669646572';
wwv_flow_imp.g_varchar2_table(5273) := '732229297D286C687C7C286C683D7B7D29293B7661722063683B636F6E73742064683D6E6577206C64282273656C656374696F6E416E63686F72536574222C2131293B6C65742068683D63683D636C6173737B737461746963206765742865297B726574';
wwv_flow_imp.g_varchar2_table(5274) := '75726E20652E676574436F6E747269627574696F6E2863682E4944297D636F6E7374727563746F7228652C74297B746869732E656469746F723D652C746869732E73656C656374696F6E416E63686F72536574436F6E746578744B65793D64682E62696E';
wwv_flow_imp.g_varchar2_table(5275) := '64546F2874292C746869732E6D6F64656C4368616E67654C697374656E65723D652E6F6E4469644368616E67654D6F64656C282828293D3E746869732E73656C656374696F6E416E63686F72536574436F6E746578744B65792E7265736574282929297D';
wwv_flow_imp.g_varchar2_table(5276) := '73657453656C656374696F6E416E63686F7228297B696628746869732E656469746F722E6861734D6F64656C2829297B636F6E737420653D746869732E656469746F722E676574506F736974696F6E28293B746869732E656469746F722E6368616E6765';
wwv_flow_imp.g_varchar2_table(5277) := '4465636F726174696F6E732828743D3E7B746869732E6465636F726174696F6E49642626742E72656D6F76654465636F726174696F6E28746869732E6465636F726174696F6E4964292C746869732E6465636F726174696F6E49643D742E616464446563';
wwv_flow_imp.g_varchar2_table(5278) := '6F726174696F6E2861682E66726F6D506F736974696F6E7328652C65292C7B6465736372697074696F6E3A2273656C656374696F6E2D616E63686F72222C737469636B696E6573733A312C686F7665724D6573736167653A286E6577206F63292E617070';
wwv_flow_imp.g_varchar2_table(5279) := '656E6454657874286228302C2253656C656374696F6E20416E63686F722229292C636C6173734E616D653A2273656C656374696F6E2D616E63686F72227D297D29292C746869732E73656C656374696F6E416E63686F72536574436F6E746578744B6579';
wwv_flow_imp.g_varchar2_table(5280) := '2E736574282121746869732E6465636F726174696F6E4964292C5872286228302C22416E63686F7220736574206174207B307D3A7B317D222C652E6C696E654E756D6265722C652E636F6C756D6E29297D7D676F546F53656C656374696F6E416E63686F';
wwv_flow_imp.g_varchar2_table(5281) := '7228297B696628746869732E656469746F722E6861734D6F64656C28292626746869732E6465636F726174696F6E4964297B636F6E737420653D746869732E656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528';
wwv_flow_imp.g_varchar2_table(5282) := '746869732E6465636F726174696F6E4964293B652626746869732E656469746F722E736574506F736974696F6E28652E6765745374617274506F736974696F6E2829297D7D73656C65637446726F6D416E63686F72546F437572736F7228297B69662874';
wwv_flow_imp.g_varchar2_table(5283) := '6869732E656469746F722E6861734D6F64656C28292626746869732E6465636F726174696F6E4964297B636F6E737420653D746869732E656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528746869732E646563';
wwv_flow_imp.g_varchar2_table(5284) := '6F726174696F6E4964293B69662865297B636F6E737420743D746869732E656469746F722E676574506F736974696F6E28293B746869732E656469746F722E73657453656C656374696F6E2861682E66726F6D506F736974696F6E7328652E6765745374';
wwv_flow_imp.g_varchar2_table(5285) := '617274506F736974696F6E28292C7429292C746869732E63616E63656C53656C656374696F6E416E63686F7228297D7D7D63616E63656C53656C656374696F6E416E63686F7228297B696628746869732E6465636F726174696F6E4964297B636F6E7374';
wwv_flow_imp.g_varchar2_table(5286) := '20653D746869732E6465636F726174696F6E49643B746869732E656469746F722E6368616E67654465636F726174696F6E732828743D3E7B742E72656D6F76654465636F726174696F6E2865292C746869732E6465636F726174696F6E49643D766F6964';
wwv_flow_imp.g_varchar2_table(5287) := '20307D29292C746869732E73656C656374696F6E416E63686F72536574436F6E746578744B65792E736574282131297D7D646973706F736528297B746869732E63616E63656C53656C656374696F6E416E63686F7228292C746869732E6D6F64656C4368';
wwv_flow_imp.g_varchar2_table(5288) := '616E67654C697374656E65722E646973706F736528297D7D3B7661722075682C70683B68682E49443D22656469746F722E636F6E747269622E73656C656374696F6E416E63686F72436F6E74726F6C6C6572222C68683D63683D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(5289) := '2C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A6563';
wwv_flow_imp.g_varchar2_table(5290) := '74223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D65';
wwv_flow_imp.g_varchar2_table(5291) := '2E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(5292) := '72747928742C6E2C72292C727D285B2875683D312C70683D63642C66756E6374696F6E28652C74297B706828652C742C7568297D295D2C6868292C4A642868682E49442C68682C34292C5A6428636C61737320657874656E64732055647B636F6E737472';
wwv_flow_imp.g_varchar2_table(5293) := '7563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73657453656C656374696F6E416E63686F72222C6C6162656C3A6228302C225365742053656C656374696F6E20416E63686F7222292C616C6961733A22536574205365';
wwv_flow_imp.g_varchar2_table(5294) := '6C656374696F6E20416E63686F72222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303830292C7765696768743A31';
wwv_flow_imp.g_varchar2_table(5295) := '30307D7D297D6173796E632072756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D68682E676574287429297C7C766F696420303D3D3D6E7C7C6E2E73657453656C656374696F6E416E63686F7228297D7D292C5A6428636C6173732065787465';
wwv_flow_imp.g_varchar2_table(5296) := '6E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E676F546F53656C656374696F6E416E63686F72222C6C6162656C3A6228302C22476F20746F2053656C656374696F6E20416E63686F72';
wwv_flow_imp.g_varchar2_table(5297) := '22292C616C6961733A22476F20746F2053656C656374696F6E20416E63686F72222C707265636F6E646974696F6E3A64687D297D6173796E632072756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D68682E676574287429297C7C766F696420';
wwv_flow_imp.g_varchar2_table(5298) := '303D3D3D6E7C7C6E2E676F546F53656C656374696F6E416E63686F7228297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73656C65637446';
wwv_flow_imp.g_varchar2_table(5299) := '726F6D416E63686F72546F437572736F72222C6C6162656C3A6228302C2253656C6563742066726F6D20416E63686F7220746F20437572736F7222292C616C6961733A2253656C6563742066726F6D20416E63686F7220746F20437572736F72222C7072';
wwv_flow_imp.g_varchar2_table(5300) := '65636F6E646974696F6E3A64682C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303839292C7765696768743A3130307D7D297D6173796E632072756E28652C74297B76';
wwv_flow_imp.g_varchar2_table(5301) := '6172206E3B6E756C6C3D3D3D286E3D68682E676574287429297C7C766F696420303D3D3D6E7C7C6E2E73656C65637446726F6D416E63686F72546F437572736F7228297D7D292C5A6428636C61737320657874656E64732055647B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(5302) := '6F7228297B7375706572287B69643A22656469746F722E616374696F6E2E63616E63656C53656C656374696F6E416E63686F72222C6C6162656C3A6228302C2243616E63656C2053656C656374696F6E20416E63686F7222292C616C6961733A2243616E';
wwv_flow_imp.g_varchar2_table(5303) := '63656C2053656C656374696F6E20416E63686F72222C707265636F6E646974696F6E3A64682C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A392C7765696768743A3130307D7D297D6173796E';
wwv_flow_imp.g_varchar2_table(5304) := '632072756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D68682E676574287429297C7C766F696420303D3D3D6E7C7C6E2E63616E63656C53656C656374696F6E416E63686F7228297D7D293B7661722067683D6E2837393937292C6D683D7B7D';
wwv_flow_imp.g_varchar2_table(5305) := '3B66756E6374696F6E2066682865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20653B6966286520696E7374616E63656F66205265674578702972657475726E20653B636F6E737420743D41727261792E697341';
wwv_flow_imp.g_varchar2_table(5306) := '727261792865293F5B5D3A7B7D3B72657475726E204F626A6563742E656E74726965732865292E666F72456163682828285B652C6E5D293D3E7B745B655D3D6E2626226F626A656374223D3D747970656F66206E3F6668286E293A6E7D29292C747D6D68';
wwv_flow_imp.g_varchar2_table(5307) := '2E7374796C655461675472616E73666F726D3D6A7228292C6D682E736574417474726962757465733D567228292C6D682E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6D682E646F6D4150493D4F7228292C6D682E696E73';
wwv_flow_imp.g_varchar2_table(5308) := '6572745374796C65456C656D656E743D487228292C4E7228292867682E412C6D68292C67682E41262667682E412E6C6F63616C73262667682E412E6C6F63616C733B636F6E73742076683D4F626A6563742E70726F746F747970652E6861734F776E5072';
wwv_flow_imp.g_varchar2_table(5309) := '6F70657274793B66756E6374696F6E20626828652C74297B72657475726E205F6828652C742C6E657720536574297D66756E6374696F6E205F6828652C742C6E297B6966285F6C2865292972657475726E20653B636F6E737420693D742865293B696628';
wwv_flow_imp.g_varchar2_table(5310) := '766F69642030213D3D692972657475726E20693B69662841727261792E69734172726179286529297B636F6E737420693D5B5D3B666F7228636F6E7374206F206F66206529692E70757368285F68286F2C742C6E29293B72657475726E20697D69662875';
wwv_flow_imp.g_varchar2_table(5311) := '6C286529297B6966286E2E686173286529297468726F77206E6577204572726F72282243616E6E6F7420636C6F6E652072656375727369766520646174612D73747275637475726522293B6E2E6164642865293B636F6E737420693D7B7D3B666F722863';
wwv_flow_imp.g_varchar2_table(5312) := '6F6E7374206F20696E20652976682E63616C6C28652C6F29262628695B6F5D3D5F6828655B6F5D2C742C6E29293B72657475726E206E2E64656C6574652865292C697D72657475726E20657D66756E6374696F6E20796828652C742C6E3D2130297B7265';
wwv_flow_imp.g_varchar2_table(5313) := '7475726E20756C2865293F28756C28742926264F626A6563742E6B6579732874292E666F72456163682828693D3E7B6920696E20653F6E262628756C28655B695D292626756C28745B695D293F796828655B695D2C745B695D2C6E293A655B695D3D745B';
wwv_flow_imp.g_varchar2_table(5314) := '695D293A655B695D3D745B695D7D29292C65293A747D66756E6374696F6E20776828652C74297B696628653D3D3D742972657475726E21303B6966286E756C6C3D3D657C7C6E756C6C3D3D742972657475726E21313B696628747970656F662065213D74';
wwv_flow_imp.g_varchar2_table(5315) := '7970656F6620742972657475726E21313B696628226F626A65637422213D747970656F6620652972657475726E21313B69662841727261792E69734172726179286529213D3D41727261792E697341727261792874292972657475726E21313B6C657420';
wwv_flow_imp.g_varchar2_table(5316) := '6E2C693B69662841727261792E69734172726179286529297B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286E3D303B6E3C652E6C656E6774683B6E2B2B2969662821776828655B6E5D2C745B6E5D29297265';
wwv_flow_imp.g_varchar2_table(5317) := '7475726E21317D656C73657B636F6E7374206F3D5B5D3B666F72286920696E2065296F2E707573682869293B6F2E736F727428293B636F6E737420733D5B5D3B666F72286920696E207429732E707573682869293B696628732E736F727428292C217768';
wwv_flow_imp.g_varchar2_table(5318) := '286F2C73292972657475726E21313B666F72286E3D303B6E3C6F2E6C656E6774683B6E2B2B2969662821776828655B6F5B6E5D5D2C745B6F5B6E5D5D292972657475726E21317D72657475726E21307D66756E6374696F6E2043682865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(5319) := '20743D5B5D3B666F7228636F6E7374206E206F662066756E6374696F6E2865297B6C657420743D5B5D3B666F72283B4F626A6563742E70726F746F74797065213D3D653B29743D742E636F6E636174284F626A6563742E6765744F776E50726F70657274';
wwv_flow_imp.g_varchar2_table(5320) := '794E616D6573286529292C653D4F626A6563742E67657450726F746F747970654F662865293B72657475726E20747D286529292266756E6374696F6E223D3D747970656F6620655B6E5D2626742E70757368286E293B72657475726E20747D7661722053';
wwv_flow_imp.g_varchar2_table(5321) := '682C78682C6B682C45683B2166756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D22';
wwv_flow_imp.g_varchar2_table(5322) := '46756C6C227D2853687C7C2853683D7B7D29292C66756E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D2878687C7C';
wwv_flow_imp.g_varchar2_table(5323) := '2878683D7B7D29292C66756E6374696F6E2865297B655B652E426F74683D305D3D22426F7468222C655B652E52696768743D315D3D225269676874222C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D28';
wwv_flow_imp.g_varchar2_table(5324) := '6B687C7C286B683D7B7D29293B636C617373204C687B676574206F726967696E616C496E64656E7453697A6528297B72657475726E20746869732E5F696E64656E7453697A65497354616253697A653F2274616253697A65223A746869732E696E64656E';
wwv_flow_imp.g_varchar2_table(5325) := '7453697A657D636F6E7374727563746F722865297B746869732E5F746578744D6F64656C5265736F6C7665644F7074696F6E734272616E643D766F696420302C746869732E74616253697A653D4D6174682E6D617828312C307C652E74616253697A6529';
wwv_flow_imp.g_varchar2_table(5326) := '2C2274616253697A65223D3D3D652E696E64656E7453697A653F28746869732E696E64656E7453697A653D746869732E74616253697A652C746869732E5F696E64656E7453697A65497354616253697A653D2130293A28746869732E696E64656E745369';
wwv_flow_imp.g_varchar2_table(5327) := '7A653D4D6174682E6D617828312C307C652E696E64656E7453697A65292C746869732E5F696E64656E7453697A65497354616253697A653D2131292C746869732E696E736572745370616365733D426F6F6C65616E28652E696E73657274537061636573';
wwv_flow_imp.g_varchar2_table(5328) := '292C746869732E64656661756C74454F4C3D307C652E64656661756C74454F4C2C746869732E7472696D4175746F576869746573706163653D426F6F6C65616E28652E7472696D4175746F57686974657370616365292C746869732E627261636B657450';
wwv_flow_imp.g_varchar2_table(5329) := '616972436F6C6F72697A6174696F6E4F7074696F6E733D652E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E737D657175616C732865297B72657475726E20746869732E74616253697A653D3D3D652E74616253697A65262674';
wwv_flow_imp.g_varchar2_table(5330) := '6869732E5F696E64656E7453697A65497354616253697A653D3D3D652E5F696E64656E7453697A65497354616253697A652626746869732E696E64656E7453697A653D3D3D652E696E64656E7453697A652626746869732E696E73657274537061636573';
wwv_flow_imp.g_varchar2_table(5331) := '3D3D3D652E696E736572745370616365732626746869732E64656661756C74454F4C3D3D3D652E64656661756C74454F4C2626746869732E7472696D4175746F576869746573706163653D3D3D652E7472696D4175746F57686974657370616365262677';
wwv_flow_imp.g_varchar2_table(5332) := '6828746869732E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732C652E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E73297D6372656174654368616E67654576656E742865297B72657475726E7B';
wwv_flow_imp.g_varchar2_table(5333) := '74616253697A653A746869732E74616253697A65213D3D652E74616253697A652C696E64656E7453697A653A746869732E696E64656E7453697A65213D3D652E696E64656E7453697A652C696E736572745370616365733A746869732E696E7365727453';
wwv_flow_imp.g_varchar2_table(5334) := '7061636573213D3D652E696E736572745370616365732C7472696D4175746F576869746573706163653A746869732E7472696D4175746F57686974657370616365213D3D652E7472696D4175746F576869746573706163657D7D7D636C6173732044687B';
wwv_flow_imp.g_varchar2_table(5335) := '636F6E7374727563746F7228652C74297B746869732E5F66696E644D617463684272616E643D766F696420302C746869732E72616E67653D652C746869732E6D6174636865733D747D7D636C6173732054687B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(5336) := '2C692C6F2C73297B746869732E6964656E7469666965723D652C746869732E72616E67653D742C746869732E746578743D6E2C746869732E666F7263654D6F76654D61726B6572733D692C746869732E69734175746F5768697465737061636545646974';
wwv_flow_imp.g_varchar2_table(5337) := '3D6F2C746869732E5F6973547261636B65643D737D7D636C6173732049687B636F6E7374727563746F7228652C742C6E297B746869732E72656765783D652C746869732E776F7264536570617261746F72733D742C746869732E73696D706C6553656172';
wwv_flow_imp.g_varchar2_table(5338) := '63683D6E7D7D636C617373204D687B636F6E7374727563746F7228652C742C6E297B746869732E7265766572736545646974733D652C746869732E6368616E6765733D742C746869732E7472696D4175746F576869746573706163654C696E654E756D62';
wwv_flow_imp.g_varchar2_table(5339) := '6572733D6E7D7D66756E6374696F6E2041682865297B72657475726E21652E6973546F6F4C61726765466F7253796E63696E672829262621652E6973466F7253696D706C655769646765747D66756E6374696F6E204E6828652C743D30297B7265747572';
wwv_flow_imp.g_varchar2_table(5340) := '6E20655B652E6C656E6774682D28312B74295D7D66756E6374696F6E20506828652C742C6E3D28652C74293D3E653D3D3D74297B696628653D3D3D742972657475726E21303B69662821657C7C21742972657475726E21313B696628652E6C656E677468';
wwv_flow_imp.g_varchar2_table(5341) := '213D3D742E6C656E6774682972657475726E21313B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B29696628216E28655B695D2C745B695D292972657475726E21313B72657475726E21307D66756E6374696F6E204F682865';
wwv_flow_imp.g_varchar2_table(5342) := '2C742C6E297B72657475726E2066756E6374696F6E2869297B6C6574206F3D302C733D692D313B666F72283B6F3C3D733B297B636F6E737420693D286F2B73292F327C302C723D6E28655B695D2C74293B696628723C30296F3D692B313B656C73657B69';
wwv_flow_imp.g_varchar2_table(5343) := '66282128723E30292972657475726E20693B733D692D317D7D72657475726E2D286F2B31297D28652E6C656E677468297D66756E6374696F6E20526828652C742C6E297B69662828657C3D30293E3D742E6C656E677468297468726F77206E6577205479';
wwv_flow_imp.g_varchar2_table(5344) := '70654572726F722822696E76616C696420696E64657822293B636F6E737420693D745B4D6174682E666C6F6F7228742E6C656E6774682A4D6174682E72616E646F6D2829295D2C6F3D5B5D2C733D5B5D2C723D5B5D3B666F7228636F6E73742065206F66';
wwv_flow_imp.g_varchar2_table(5345) := '2074297B636F6E737420743D6E28652C69293B743C303F6F2E707573682865293A743E303F732E707573682865293A722E707573682865297D72657475726E20653C6F2E6C656E6774683F526828652C6F2C6E293A653C6F2E6C656E6774682B722E6C65';
wwv_flow_imp.g_varchar2_table(5346) := '6E6774683F725B305D3A526828652D286F2E6C656E6774682B722E6C656E677468292C732C6E297D66756E6374696F6E20466828652C74297B636F6E7374206E3D5B5D3B6C657420693B666F7228636F6E7374206F206F6620652E736C6963652830292E';
wwv_flow_imp.g_varchar2_table(5347) := '736F727428742929692626303D3D3D7428695B305D2C6F293F692E70757368286F293A28693D5B6F5D2C6E2E70757368286929293B72657475726E206E7D66756E6374696F6E2A426828652C74297B6C6574206E2C693B666F7228636F6E7374206F206F';
wwv_flow_imp.g_varchar2_table(5348) := '66206529766F69642030213D3D6926267428692C6F293F6E2E70757368286F293A286E2626287969656C64206E292C6E3D5B6F5D292C693D6F3B6E2626287969656C64206E297D66756E6374696F6E20566828652C74297B666F72286C6574206E3D303B';
wwv_flow_imp.g_varchar2_table(5349) := '6E3C3D652E6C656E6774683B6E2B2B297428303D3D3D6E3F766F696420303A655B6E2D315D2C6E3D3D3D652E6C656E6774683F766F696420303A655B6E5D297D66756E6374696F6E207A682865297B72657475726E20652E66696C7465722828653D3E21';
wwv_flow_imp.g_varchar2_table(5350) := '216529297D66756E6374696F6E2048682865297B6C657420743D303B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B29655B6E5D262628655B745D3D655B6E5D2C742B3D31293B652E6C656E6774683D747D66756E6374696F6E205768';
wwv_flow_imp.g_varchar2_table(5351) := '2865297B72657475726E2141727261792E697341727261792865297C7C303D3D3D652E6C656E6774687D66756E6374696F6E206A682865297B72657475726E2041727261792E697341727261792865292626652E6C656E6774683E307D66756E6374696F';
wwv_flow_imp.g_varchar2_table(5352) := '6E20716828652C743D653D3E65297B636F6E7374206E3D6E6577205365743B72657475726E20652E66696C7465722828653D3E7B636F6E737420693D742865293B72657475726E216E2E6861732869292626286E2E6164642869292C2130297D29297D66';
wwv_flow_imp.g_varchar2_table(5353) := '756E6374696F6E20246828652C74297B72657475726E20652E6C656E6774683E303F655B305D3A747D66756E6374696F6E20556828652C74297B6C6574206E3D226E756D626572223D3D747970656F6620743F653A303B226E756D626572223D3D747970';
wwv_flow_imp.g_varchar2_table(5354) := '656F6620743F6E3D653A286E3D302C743D65293B636F6E737420693D5B5D3B6966286E3C3D7429666F72286C657420653D6E3B653C743B652B2B29692E707573682865293B656C736520666F72286C657420653D6E3B653E743B652D2D29692E70757368';
wwv_flow_imp.g_varchar2_table(5355) := '2865293B72657475726E20697D66756E6374696F6E204B6828652C742C6E297B636F6E737420693D652E736C69636528302C74292C6F3D652E736C6963652874293B72657475726E20692E636F6E636174286E2C6F297D66756E6374696F6E2047682865';
wwv_flow_imp.g_varchar2_table(5356) := '2C74297B636F6E7374206E3D652E696E6465784F662874293B6E3E2D31262628652E73706C696365286E2C31292C652E756E7368696674287429297D66756E6374696F6E20516828652C74297B636F6E7374206E3D652E696E6465784F662874293B6E3E';
wwv_flow_imp.g_varchar2_table(5357) := '2D31262628652E73706C696365286E2C31292C652E70757368287429297D66756E6374696F6E20596828652C74297B666F7228636F6E7374206E206F66207429652E70757368286E297D66756E6374696F6E205A682865297B72657475726E2041727261';
wwv_flow_imp.g_varchar2_table(5358) := '792E697341727261792865293F653A5B655D7D66756E6374696F6E20586828652C742C6E2C69297B636F6E7374206F3D4A6828652C74293B6C657420733D652E73706C696365286F2C6E293B72657475726E20766F696420303D3D3D73262628733D5B5D';
wwv_flow_imp.g_varchar2_table(5359) := '292C66756E6374696F6E28652C742C6E297B636F6E737420693D4A6828652C74292C6F3D652E6C656E6774682C733D6E2E6C656E6774683B652E6C656E6774683D6F2B733B666F72286C657420743D6F2D313B743E3D693B742D2D29655B742B735D3D65';
wwv_flow_imp.g_varchar2_table(5360) := '5B745D3B666F72286C657420743D303B743C733B742B2B29655B742B695D3D6E5B745D7D28652C6F2C69292C737D66756E6374696F6E204A6828652C74297B72657475726E20743C303F4D6174682E6D617828742B652E6C656E6774682C30293A4D6174';
wwv_flow_imp.g_varchar2_table(5361) := '682E6D696E28742C652E6C656E677468297D66756E6374696F6E20657528652C74297B72657475726E286E2C69293D3E742865286E292C65286929297D2166756E6374696F6E2865297B652E69734C6573735468616E3D66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(5362) := '657475726E20653C307D2C652E69734C6573735468616E4F72457175616C3D66756E6374696F6E2865297B72657475726E20653C3D307D2C652E6973477265617465725468616E3D66756E6374696F6E2865297B72657475726E20653E307D2C652E6973';
wwv_flow_imp.g_varchar2_table(5363) := '4E6569746865724C6573734F72477265617465725468616E3D66756E6374696F6E2865297B72657475726E20303D3D3D657D2C652E677265617465725468616E3D312C652E6C6573735468616E3D2D312C652E6E6569746865724C6573734F7247726561';
wwv_flow_imp.g_varchar2_table(5364) := '7465725468616E3D307D2845687C7C2845683D7B7D29293B636F6E73742074753D28652C74293D3E652D742C6E753D28652C74293D3E747528653F313A302C743F313A30293B66756E6374696F6E2069752865297B72657475726E28742C6E293D3E2D65';
wwv_flow_imp.g_varchar2_table(5365) := '28742C6E297D636C617373206F757B636F6E7374727563746F722865297B746869732E6974656D733D652C746869732E66697273744964783D302C746869732E6C6173744964783D746869732E6974656D732E6C656E6774682D317D676574206C656E67';
wwv_flow_imp.g_varchar2_table(5366) := '746828297B72657475726E20746869732E6C6173744964782D746869732E66697273744964782B317D74616B655768696C652865297B6C657420743D746869732E66697273744964783B666F72283B743C746869732E6974656D732E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(5367) := '6528746869732E6974656D735B745D293B29742B2B3B636F6E7374206E3D743D3D3D746869732E66697273744964783F6E756C6C3A746869732E6974656D732E736C69636528746869732E66697273744964782C74293B72657475726E20746869732E66';
wwv_flow_imp.g_varchar2_table(5368) := '697273744964783D742C6E7D74616B6546726F6D456E645768696C652865297B6C657420743D746869732E6C6173744964783B666F72283B743E3D3026266528746869732E6974656D735B745D293B29742D2D3B636F6E7374206E3D743D3D3D74686973';
wwv_flow_imp.g_varchar2_table(5369) := '2E6C6173744964783F6E756C6C3A746869732E6974656D732E736C69636528742B312C746869732E6C6173744964782B31293B72657475726E20746869732E6C6173744964783D742C6E7D7065656B28297B69662830213D3D746869732E6C656E677468';
wwv_flow_imp.g_varchar2_table(5370) := '2972657475726E20746869732E6974656D735B746869732E66697273744964785D7D6465717565756528297B636F6E737420653D746869732E6974656D735B746869732E66697273744964785D3B72657475726E20746869732E66697273744964782B2B';
wwv_flow_imp.g_varchar2_table(5371) := '2C657D74616B65436F756E742865297B636F6E737420743D746869732E6974656D732E736C69636528746869732E66697273744964782C746869732E66697273744964782B65293B72657475726E20746869732E66697273744964782B3D652C747D7D63';
wwv_flow_imp.g_varchar2_table(5372) := '6C6173732073757B636F6E7374727563746F722865297B746869732E697465726174653D657D746F417272617928297B636F6E737420653D5B5D3B72657475726E20746869732E697465726174652828743D3E28652E707573682874292C21302929292C';
wwv_flow_imp.g_varchar2_table(5373) := '657D66696C7465722865297B72657475726E206E65772073752828743D3E746869732E6974657261746528286E3D3E2165286E297C7C74286E29292929297D6D61702865297B72657475726E206E65772073752828743D3E746869732E69746572617465';
wwv_flow_imp.g_varchar2_table(5374) := '28286E3D3E742865286E2929292929297D66696E644C6173742865297B6C657420743B72657475726E20746869732E6974657261746528286E3D3E2865286E29262628743D6E292C21302929292C747D66696E644C6173744D617842792865297B6C6574';
wwv_flow_imp.g_varchar2_table(5375) := '20742C6E3D21303B72657475726E20746869732E697465726174652828693D3E28286E7C7C45682E6973477265617465725468616E286528692C742929292626286E3D21312C743D69292C21302929292C747D7D73752E656D7074793D6E657720737528';
wwv_flow_imp.g_varchar2_table(5376) := '28653D3E7B7D29293B636C6173732072757B636F6E7374727563746F722865297B746869732E5F696E6465784D61703D657D73746174696320637265617465536F72745065726D75746174696F6E28652C74297B636F6E7374206E3D41727261792E6672';
wwv_flow_imp.g_varchar2_table(5377) := '6F6D28652E6B6579732829292E736F72742828286E2C69293D3E7428655B6E5D2C655B695D2929293B72657475726E206E6577207275286E297D6170706C792865297B72657475726E20652E6D6170282828742C6E293D3E655B746869732E5F696E6465';
wwv_flow_imp.g_varchar2_table(5378) := '784D61705B6E5D5D29297D696E766572736528297B636F6E737420653D746869732E5F696E6465784D61702E736C69636528293B666F72286C657420743D303B743C746869732E5F696E6465784D61702E6C656E6774683B742B2B29655B746869732E5F';
wwv_flow_imp.g_varchar2_table(5379) := '696E6465784D61705B745D5D3D743B72657475726E206E65772072752865297D7D66756E6374696F6E20617528652C74297B636F6E7374206E3D4D6174682E706F772831302C74293B72657475726E204D6174682E726F756E6428652A6E292F6E7D636C';
wwv_flow_imp.g_varchar2_table(5380) := '617373206C757B636F6E7374727563746F7228652C742C6E2C693D31297B746869732E5F726762614272616E643D766F696420302C746869732E723D307C4D6174682E6D696E283235352C4D6174682E6D617828302C6529292C746869732E673D307C4D';
wwv_flow_imp.g_varchar2_table(5381) := '6174682E6D696E283235352C4D6174682E6D617828302C7429292C746869732E623D307C4D6174682E6D696E283235352C4D6174682E6D617828302C6E29292C746869732E613D6175284D6174682E6D6178284D6174682E6D696E28312C69292C30292C';
wwv_flow_imp.g_varchar2_table(5382) := '33297D73746174696320657175616C7328652C74297B72657475726E20652E723D3D3D742E722626652E673D3D3D742E672626652E623D3D3D742E622626652E613D3D3D742E617D7D636C6173732063757B636F6E7374727563746F7228652C742C6E2C';
wwv_flow_imp.g_varchar2_table(5383) := '69297B746869732E5F68736C614272616E643D766F696420302C746869732E683D307C4D6174682E6D6178284D6174682E6D696E283336302C65292C30292C746869732E733D6175284D6174682E6D6178284D6174682E6D696E28312C74292C30292C33';
wwv_flow_imp.g_varchar2_table(5384) := '292C746869732E6C3D6175284D6174682E6D6178284D6174682E6D696E28312C6E292C30292C33292C746869732E613D6175284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B72';
wwv_flow_imp.g_varchar2_table(5385) := '657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E6C3D3D3D742E6C2626652E613D3D3D742E617D7374617469632066726F6D524742412865297B636F6E737420743D652E722F3235352C6E3D652E672F3235352C693D652E622F';
wwv_flow_imp.g_varchar2_table(5386) := '3235352C6F3D652E612C733D4D6174682E6D617828742C6E2C69292C723D4D6174682E6D696E28742C6E2C69293B6C657420613D302C6C3D303B636F6E737420633D28722B73292F322C643D732D723B696628643E30297B737769746368286C3D4D6174';
wwv_flow_imp.g_varchar2_table(5387) := '682E6D696E28633C3D2E353F642F28322A63293A642F28322D322A63292C31292C73297B6361736520743A613D286E2D69292F642B286E3C693F363A30293B627265616B3B63617365206E3A613D28692D74292F642B323B627265616B3B636173652069';
wwv_flow_imp.g_varchar2_table(5388) := '3A613D28742D6E292F642B347D612A3D36302C613D4D6174682E726F756E642861297D72657475726E206E657720637528612C6C2C632C6F297D737461746963205F6875653272676228652C742C6E297B72657475726E206E3C302626286E2B3D31292C';
wwv_flow_imp.g_varchar2_table(5389) := '6E3E312626286E2D3D31292C6E3C312F363F652B362A28742D65292A6E3A6E3C2E353F743A6E3C322F333F652B28742D65292A28322F332D6E292A363A657D73746174696320746F524742412865297B636F6E737420743D652E682F3336302C7B733A6E';
wwv_flow_imp.g_varchar2_table(5390) := '2C6C3A692C613A6F7D3D653B6C657420732C722C613B696628303D3D3D6E29733D723D613D693B656C73657B636F6E737420653D693C2E353F692A28312B6E293A692B6E2D692A6E2C6F3D322A692D653B733D63752E5F68756532726762286F2C652C74';
wwv_flow_imp.g_varchar2_table(5391) := '2B312F33292C723D63752E5F68756532726762286F2C652C74292C613D63752E5F68756532726762286F2C652C742D312F33297D72657475726E206E6577206C75284D6174682E726F756E64283235352A73292C4D6174682E726F756E64283235352A72';
wwv_flow_imp.g_varchar2_table(5392) := '292C4D6174682E726F756E64283235352A61292C6F297D7D636C6173732064757B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F687376614272616E643D766F696420302C746869732E683D307C4D6174682E6D6178284D6174682E';
wwv_flow_imp.g_varchar2_table(5393) := '6D696E283336302C65292C30292C746869732E733D6175284D6174682E6D6178284D6174682E6D696E28312C74292C30292C33292C746869732E763D6175284D6174682E6D6178284D6174682E6D696E28312C6E292C30292C33292C746869732E613D61';
wwv_flow_imp.g_varchar2_table(5394) := '75284D6174682E6D6178284D6174682E6D696E28312C69292C30292C33297D73746174696320657175616C7328652C74297B72657475726E20652E683D3D3D742E682626652E733D3D3D742E732626652E763D3D3D742E762626652E613D3D3D742E617D';
wwv_flow_imp.g_varchar2_table(5395) := '7374617469632066726F6D524742412865297B636F6E737420743D652E722F3235352C6E3D652E672F3235352C693D652E622F3235352C6F3D4D6174682E6D617828742C6E2C69292C733D6F2D4D6174682E6D696E28742C6E2C69292C723D303D3D3D6F';
wwv_flow_imp.g_varchar2_table(5396) := '3F303A732F6F3B6C657420613B72657475726E20613D303D3D3D733F303A6F3D3D3D743F28286E2D69292F7325362B362925363A6F3D3D3D6E3F28692D74292F732B323A28742D6E292F732B342C6E6577206475284D6174682E726F756E642836302A61';
wwv_flow_imp.g_varchar2_table(5397) := '292C722C6F2C652E61297D73746174696320746F524742412865297B636F6E73747B683A742C733A6E2C763A692C613A6F7D3D652C733D692A6E2C723D732A28312D4D6174682E61627328742F363025322D3129292C613D692D733B6C65745B6C2C632C';
wwv_flow_imp.g_varchar2_table(5398) := '645D3D5B302C302C305D3B72657475726E20743C36303F286C3D732C633D72293A743C3132303F286C3D722C633D73293A743C3138303F28633D732C643D72293A743C3234303F28633D722C643D73293A743C3330303F286C3D722C643D73293A743C3D';
wwv_flow_imp.g_varchar2_table(5399) := '3336302626286C3D732C643D72292C6C3D4D6174682E726F756E64283235352A286C2B6129292C633D4D6174682E726F756E64283235352A28632B6129292C643D4D6174682E726F756E64283235352A28642B6129292C6E6577206C75286C2C632C642C';
wwv_flow_imp.g_varchar2_table(5400) := '6F297D7D636C6173732068757B7374617469632066726F6D4865782865297B72657475726E2068752E466F726D61742E4353532E70617273654865782865297C7C68752E7265647D73746174696320657175616C7328652C74297B72657475726E216526';
wwv_flow_imp.g_varchar2_table(5401) := '2621747C7C212821657C7C2174292626652E657175616C732874297D6765742068736C6128297B72657475726E20746869732E5F68736C613F746869732E5F68736C613A63752E66726F6D5247424128746869732E72676261297D676574206873766128';
wwv_flow_imp.g_varchar2_table(5402) := '297B72657475726E20746869732E5F687376613F746869732E5F687376613A64752E66726F6D5247424128746869732E72676261297D636F6E7374727563746F722865297B6966282165297468726F77206E6577204572726F722822436F6C6F72206E65';
wwv_flow_imp.g_varchar2_table(5403) := '65647320612076616C756522293B6966286520696E7374616E63656F66206C7529746869732E726762613D653B656C7365206966286520696E7374616E63656F6620637529746869732E5F68736C613D652C746869732E726762613D63752E746F524742';
wwv_flow_imp.g_varchar2_table(5404) := '412865293B656C73657B69662821286520696E7374616E63656F6620647529297468726F77206E6577204572726F722822496E76616C696420636F6C6F722063746F7220617267756D656E7422293B746869732E5F687376613D652C746869732E726762';
wwv_flow_imp.g_varchar2_table(5405) := '613D64752E746F524742412865297D7D657175616C732865297B72657475726E21216526266C752E657175616C7328746869732E726762612C652E7267626129262663752E657175616C7328746869732E68736C612C652E68736C6129262664752E6571';
wwv_flow_imp.g_varchar2_table(5406) := '75616C7328746869732E687376612C652E68737661297D67657452656C61746976654C756D696E616E636528297B72657475726E206175282E323132362A68752E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E742874686973';
wwv_flow_imp.g_varchar2_table(5407) := '2E726762612E72292B2E373135322A68752E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E7428746869732E726762612E67292B2E303732322A68752E5F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E';
wwv_flow_imp.g_varchar2_table(5408) := '7428746869732E726762612E62292C34297D737461746963205F72656C61746976654C756D696E616E6365466F72436F6D706F6E656E742865297B636F6E737420743D652F3235353B72657475726E20743C3D2E30333932383F742F31322E39323A4D61';
wwv_flow_imp.g_varchar2_table(5409) := '74682E706F772828742B2E303535292F312E3035352C322E34297D69734C69676874657228297B72657475726E283239392A746869732E726762612E722B3538372A746869732E726762612E672B3131342A746869732E726762612E62292F3165333E3D';
wwv_flow_imp.g_varchar2_table(5410) := '3132387D69734C6967687465725468616E2865297B72657475726E20746869732E67657452656C61746976654C756D696E616E636528293E652E67657452656C61746976654C756D696E616E636528297D69734461726B65725468616E2865297B726574';
wwv_flow_imp.g_varchar2_table(5411) := '75726E20746869732E67657452656C61746976654C756D696E616E636528293C652E67657452656C61746976654C756D696E616E636528297D6C69676874656E2865297B72657475726E206E6577206875286E657720637528746869732E68736C612E68';
wwv_flow_imp.g_varchar2_table(5412) := '2C746869732E68736C612E732C746869732E68736C612E6C2B746869732E68736C612E6C2A652C746869732E68736C612E6129297D6461726B656E2865297B72657475726E206E6577206875286E657720637528746869732E68736C612E682C74686973';
wwv_flow_imp.g_varchar2_table(5413) := '2E68736C612E732C746869732E68736C612E6C2D746869732E68736C612E6C2A652C746869732E68736C612E6129297D7472616E73706172656E742865297B636F6E73747B723A742C673A6E2C623A692C613A6F7D3D746869732E726762613B72657475';
wwv_flow_imp.g_varchar2_table(5414) := '726E206E6577206875286E6577206C7528742C6E2C692C6F2A6529297D69735472616E73706172656E7428297B72657475726E20303D3D3D746869732E726762612E617D69734F706171756528297B72657475726E20313D3D3D746869732E726762612E';
wwv_flow_imp.g_varchar2_table(5415) := '617D6F70706F7369746528297B72657475726E206E6577206875286E6577206C75283235352D746869732E726762612E722C3235352D746869732E726762612E672C3235352D746869732E726762612E622C746869732E726762612E6129297D6D616B65';
wwv_flow_imp.g_varchar2_table(5416) := '4F70617175652865297B696628746869732E69734F706171756528297C7C31213D3D652E726762612E612972657475726E20746869733B636F6E73747B723A742C673A6E2C623A692C613A6F7D3D746869732E726762613B72657475726E206E65772068';
wwv_flow_imp.g_varchar2_table(5417) := '75286E6577206C7528652E726762612E722D6F2A28652E726762612E722D74292C652E726762612E672D6F2A28652E726762612E672D6E292C652E726762612E622D6F2A28652E726762612E622D69292C3129297D746F537472696E6728297B72657475';
wwv_flow_imp.g_varchar2_table(5418) := '726E20746869732E5F746F537472696E677C7C28746869732E5F746F537472696E673D68752E466F726D61742E4353532E666F726D6174287468697329292C746869732E5F746F537472696E677D737461746963206765744C696768746572436F6C6F72';
wwv_flow_imp.g_varchar2_table(5419) := '28652C742C6E297B696628652E69734C6967687465725468616E2874292972657475726E20653B6E3D6E7C7C2E353B636F6E737420693D652E67657452656C61746976654C756D696E616E636528292C6F3D742E67657452656C61746976654C756D696E';
wwv_flow_imp.g_varchar2_table(5420) := '616E636528293B72657475726E206E3D6E2A286F2D69292F6F2C652E6C69676874656E286E297D737461746963206765744461726B6572436F6C6F7228652C742C6E297B696628652E69734461726B65725468616E2874292972657475726E20653B6E3D';
wwv_flow_imp.g_varchar2_table(5421) := '6E7C7C2E353B636F6E737420693D652E67657452656C61746976654C756D696E616E636528293B72657475726E206E3D6E2A28692D742E67657452656C61746976654C756D696E616E63652829292F692C652E6461726B656E286E297D7D66756E637469';
wwv_flow_imp.g_varchar2_table(5422) := '6F6E2075752865297B6C657420743D302C6E3D302C693D302C6F3D303B666F72286C657420733D302C723D652E6C656E6774683B733C723B732B2B297B636F6E737420613D652E63686172436F646541742873293B31333D3D3D613F28303D3D3D742626';
wwv_flow_imp.g_varchar2_table(5423) := '286E3D73292C742B2B2C732B313C72262631303D3D3D652E63686172436F6465417428732B31293F286F7C3D322C732B2B293A6F7C3D332C693D732B31293A31303D3D3D612626286F7C3D312C303D3D3D742626286E3D73292C742B2B2C693D732B3129';
wwv_flow_imp.g_varchar2_table(5424) := '7D72657475726E20303D3D3D742626286E3D652E6C656E677468292C5B742C6E2C652E6C656E6774682D692C6F5D7D68752E77686974653D6E6577206875286E6577206C75283235352C3235352C3235352C3129292C68752E626C61636B3D6E65772068';
wwv_flow_imp.g_varchar2_table(5425) := '75286E6577206C7528302C302C302C3129292C68752E7265643D6E6577206875286E6577206C75283235352C302C302C3129292C68752E626C75653D6E6577206875286E6577206C7528302C302C3235352C3129292C68752E677265656E3D6E65772068';
wwv_flow_imp.g_varchar2_table(5426) := '75286E6577206C7528302C3235352C302C3129292C68752E6379616E3D6E6577206875286E6577206C7528302C3235352C3235352C3129292C68752E6C69676874677265793D6E6577206875286E6577206C75283231312C3231312C3231312C3129292C';
wwv_flow_imp.g_varchar2_table(5427) := '68752E7472616E73706172656E743D6E6577206875286E6577206C7528302C302C302C3029292C66756E6374696F6E2865297B6C657420743B2166756E6374696F6E2874297B6C6574206E3B2166756E6374696F6E2874297B66756E6374696F6E206E28';
wwv_flow_imp.g_varchar2_table(5428) := '65297B636F6E737420743D652E746F537472696E67283136293B72657475726E2032213D3D742E6C656E6774683F2230222B743A747D66756E6374696F6E20692865297B7377697463682865297B636173652034383A72657475726E20303B6361736520';
wwv_flow_imp.g_varchar2_table(5429) := '34393A72657475726E20313B636173652035303A72657475726E20323B636173652035313A72657475726E20333B636173652035323A72657475726E20343B636173652035333A72657475726E20353B636173652035343A72657475726E20363B636173';
wwv_flow_imp.g_varchar2_table(5430) := '652035353A72657475726E20373B636173652035363A72657475726E20383B636173652035373A72657475726E20393B636173652039373A636173652036353A72657475726E2031303B636173652039383A636173652036363A72657475726E2031313B';
wwv_flow_imp.g_varchar2_table(5431) := '636173652039393A636173652036373A72657475726E2031323B63617365203130303A636173652036383A72657475726E2031333B63617365203130313A636173652036393A72657475726E2031343B63617365203130323A636173652037303A726574';
wwv_flow_imp.g_varchar2_table(5432) := '75726E2031357D72657475726E20307D742E666F726D61745247423D66756E6374696F6E2874297B72657475726E20313D3D3D742E726762612E613F6072676228247B742E726762612E727D2C20247B742E726762612E677D2C20247B742E726762612E';
wwv_flow_imp.g_varchar2_table(5433) := '627D29603A652E466F726D61742E4353532E666F726D6174524742412874297D2C742E666F726D6174524742413D66756E6374696F6E2865297B72657475726E607267626128247B652E726762612E727D2C20247B652E726762612E677D2C20247B652E';
wwv_flow_imp.g_varchar2_table(5434) := '726762612E627D2C20247B2B652E726762612E612E746F46697865642832297D29607D2C742E666F726D617448534C3D66756E6374696F6E2874297B72657475726E20313D3D3D742E68736C612E613F6068736C28247B742E68736C612E687D2C20247B';
wwv_flow_imp.g_varchar2_table(5435) := '283130302A742E68736C612E73292E746F46697865642832297D252C20247B283130302A742E68736C612E6C292E746F46697865642832297D2529603A652E466F726D61742E4353532E666F726D617448534C412874297D2C742E666F726D617448534C';
wwv_flow_imp.g_varchar2_table(5436) := '413D66756E6374696F6E2865297B72657475726E6068736C6128247B652E68736C612E687D2C20247B283130302A652E68736C612E73292E746F46697865642832297D252C20247B283130302A652E68736C612E6C292E746F46697865642832297D252C';
wwv_flow_imp.g_varchar2_table(5437) := '20247B652E68736C612E612E746F46697865642832297D29607D2C742E666F726D61744865783D66756E6374696F6E2865297B72657475726E6023247B6E28652E726762612E72297D247B6E28652E726762612E67297D247B6E28652E726762612E6229';
wwv_flow_imp.g_varchar2_table(5438) := '7D607D2C742E666F726D6174486578413D66756E6374696F6E28742C693D2131297B72657475726E20692626313D3D3D742E726762612E613F652E466F726D61742E4353532E666F726D61744865782874293A6023247B6E28742E726762612E72297D24';
wwv_flow_imp.g_varchar2_table(5439) := '7B6E28742E726762612E67297D247B6E28742E726762612E62297D247B6E284D6174682E726F756E64283235352A742E726762612E6129297D607D2C742E666F726D61743D66756E6374696F6E2874297B72657475726E20742E69734F70617175652829';
wwv_flow_imp.g_varchar2_table(5440) := '3F652E466F726D61742E4353532E666F726D61744865782874293A652E466F726D61742E4353532E666F726D6174524742412874297D2C742E70617273654865783D66756E6374696F6E2874297B636F6E7374206E3D742E6C656E6774683B696628303D';
wwv_flow_imp.g_varchar2_table(5441) := '3D3D6E2972657475726E206E756C6C3B6966283335213D3D742E63686172436F646541742830292972657475726E206E756C6C3B696628373D3D3D6E297B636F6E7374206E3D31362A6928742E63686172436F64654174283129292B6928742E63686172';
wwv_flow_imp.g_varchar2_table(5442) := '436F64654174283229292C6F3D31362A6928742E63686172436F64654174283329292B6928742E63686172436F64654174283429292C733D31362A6928742E63686172436F64654174283529292B6928742E63686172436F64654174283629293B726574';
wwv_flow_imp.g_varchar2_table(5443) := '75726E206E65772065286E6577206C75286E2C6F2C732C3129297D696628393D3D3D6E297B636F6E7374206E3D31362A6928742E63686172436F64654174283129292B6928742E63686172436F64654174283229292C6F3D31362A6928742E6368617243';
wwv_flow_imp.g_varchar2_table(5444) := '6F64654174283329292B6928742E63686172436F64654174283429292C733D31362A6928742E63686172436F64654174283529292B6928742E63686172436F64654174283629292C723D31362A6928742E63686172436F64654174283729292B6928742E';
wwv_flow_imp.g_varchar2_table(5445) := '63686172436F64654174283829293B72657475726E206E65772065286E6577206C75286E2C6F2C732C722F32353529297D696628343D3D3D6E297B636F6E7374206E3D6928742E63686172436F64654174283129292C6F3D6928742E63686172436F6465';
wwv_flow_imp.g_varchar2_table(5446) := '4174283229292C733D6928742E63686172436F64654174283329293B72657475726E206E65772065286E6577206C752831362A6E2B6E2C31362A6F2B6F2C31362A732B7329297D696628353D3D3D6E297B636F6E7374206E3D6928742E63686172436F64';
wwv_flow_imp.g_varchar2_table(5447) := '654174283129292C6F3D6928742E63686172436F64654174283229292C733D6928742E63686172436F64654174283329292C723D6928742E63686172436F64654174283429293B72657475726E206E65772065286E6577206C752831362A6E2B6E2C3136';
wwv_flow_imp.g_varchar2_table(5448) := '2A6F2B6F2C31362A732B732C2831362A722B72292F32353529297D72657475726E206E756C6C7D7D286E3D742E4353537C7C28742E4353533D7B7D29297D28743D652E466F726D61747C7C28652E466F726D61743D7B7D29297D2868757C7C2868753D7B';
wwv_flow_imp.g_varchar2_table(5449) := '7D29293B636C6173732070757B737461746963205F6E65787456697369626C65436F6C756D6E28652C742C6E297B72657475726E20393D3D3D653F70752E6E65787452656E64657254616253746F7028742C6E293A6A692865297C7C71692865293F742B';
wwv_flow_imp.g_varchar2_table(5450) := '323A742B317D7374617469632076697369626C65436F6C756D6E46726F6D436F6C756D6E28652C742C6E297B636F6E737420693D4D6174682E6D696E28742D312C652E6C656E677468292C6F3D652E737562737472696E6728302C69292C733D6E657720';
wwv_flow_imp.g_varchar2_table(5451) := '5069286F293B6C657420723D303B666F72283B21732E656F6C28293B297B636F6E737420653D4169286F2C692C732E6F6666736574293B732E6E6578744772617068656D654C656E67746828292C723D746869732E5F6E65787456697369626C65436F6C';
wwv_flow_imp.g_varchar2_table(5452) := '756D6E28652C722C6E297D72657475726E20727D73746174696320636F6C756D6E46726F6D56697369626C65436F6C756D6E28652C742C6E297B696628743C3D302972657475726E20313B636F6E737420693D652E6C656E6774682C6F3D6E6577205069';
wwv_flow_imp.g_varchar2_table(5453) := '2865293B6C657420733D302C723D313B666F72283B216F2E656F6C28293B297B636F6E737420613D416928652C692C6F2E6F6666736574293B6F2E6E6578744772617068656D654C656E67746828293B636F6E7374206C3D746869732E5F6E6578745669';
wwv_flow_imp.g_varchar2_table(5454) := '7369626C65436F6C756D6E28612C732C6E292C633D6F2E6F66667365742B313B6966286C3E3D742972657475726E206C2D743C742D733F633A723B733D6C2C723D637D72657475726E20692B317D737461746963206E65787452656E6465725461625374';
wwv_flow_imp.g_varchar2_table(5455) := '6F7028652C74297B72657475726E20652B742D6525747D737461746963206E657874496E64656E7454616253746F7028652C74297B72657475726E20652B742D6525747D737461746963207072657652656E64657254616253746F7028652C74297B7265';
wwv_flow_imp.g_varchar2_table(5456) := '7475726E204D6174682E6D617828302C652D312D28652D31292574297D7374617469632070726576496E64656E7454616253746F7028652C74297B72657475726E204D6174682E6D617828302C652D312D28652D31292574297D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5457) := '677528652C742C6E297B6C657420693D6D692865293B72657475726E2D313D3D3D69262628693D652E6C656E677468292C66756E6374696F6E28652C742C6E297B6C657420693D303B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B29';
wwv_flow_imp.g_varchar2_table(5458) := '225C74223D3D3D652E636861724174286E293F693D70752E6E657874496E64656E7454616253746F7028692C74293A692B2B3B6C6574206F3D22223B696628216E297B636F6E737420653D4D6174682E666C6F6F7228692F74293B69253D743B666F7228';
wwv_flow_imp.g_varchar2_table(5459) := '6C657420743D303B743C653B742B2B296F2B3D225C74227D666F72286C657420653D303B653C693B652B2B296F2B3D2220223B72657475726E206F7D28652E737562737472696E6728302C69292C742C6E292B652E737562737472696E672869297D636C';
wwv_flow_imp.g_varchar2_table(5460) := '617373206D757B7374617469632061646452616E676528652C74297B6C6574206E3D303B666F72283B6E3C742E6C656E6774682626745B6E5D2E656E644578636C75736976653C652E73746172743B296E2B2B3B6C657420693D6E3B666F72283B693C74';
wwv_flow_imp.g_varchar2_table(5461) := '2E6C656E6774682626745B695D2E73746172743C3D652E656E644578636C75736976653B29692B2B3B6966286E3D3D3D6929742E73706C696365286E2C302C65293B656C73657B636F6E7374206F3D4D6174682E6D696E28652E73746172742C745B6E5D';
wwv_flow_imp.g_varchar2_table(5462) := '2E7374617274292C733D4D6174682E6D617828652E656E644578636C75736976652C745B692D315D2E656E644578636C7573697665293B742E73706C696365286E2C692D6E2C6E6577206D75286F2C7329297D7D73746174696320747279437265617465';
wwv_flow_imp.g_varchar2_table(5463) := '28652C74297B6966282128653E74292972657475726E206E6577206D7528652C74297D737461746963206F664C656E6774682865297B72657475726E206E6577206D7528302C65297D737461746963206F665374617274416E644C656E67746828652C74';
wwv_flow_imp.g_varchar2_table(5464) := '297B72657475726E206E6577206D7528652C652B74297D636F6E7374727563746F7228652C74297B696628746869732E73746172743D652C746869732E656E644578636C75736976653D742C653E74297468726F77206E6577204F652860496E76616C69';
wwv_flow_imp.g_varchar2_table(5465) := '642072616E67653A20247B746869732E746F537472696E6728297D60297D676574206973456D70747928297B72657475726E20746869732E73746172743D3D3D746869732E656E644578636C75736976657D64656C74612865297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(5466) := '77206D7528746869732E73746172742B652C746869732E656E644578636C75736976652B65297D64656C746153746172742865297B72657475726E206E6577206D7528746869732E73746172742B652C746869732E656E644578636C7573697665297D64';
wwv_flow_imp.g_varchar2_table(5467) := '656C7461456E642865297B72657475726E206E6577206D7528746869732E73746172742C746869732E656E644578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644578636C75736976652D746869732E';
wwv_flow_imp.g_varchar2_table(5468) := '73746172747D746F537472696E6728297B72657475726E605B247B746869732E73746172747D2C20247B746869732E656E644578636C75736976657D29607D636F6E7461696E732865297B72657475726E20746869732E73746172743C3D652626653C74';
wwv_flow_imp.g_varchar2_table(5469) := '6869732E656E644578636C75736976657D6A6F696E2865297B72657475726E206E6577206D75284D6174682E6D696E28746869732E73746172742C652E7374617274292C4D6174682E6D617828746869732E656E644578636C75736976652C652E656E64';
wwv_flow_imp.g_varchar2_table(5470) := '4578636C757369766529297D696E746572736563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172742C652E7374617274292C6E3D4D6174682E6D696E28746869732E656E644578636C75736976652C652E656E644578636C';
wwv_flow_imp.g_varchar2_table(5471) := '7573697665293B696628743C3D6E2972657475726E206E6577206D7528742C6E297D696E74657273656374732865297B72657475726E204D6174682E6D617828746869732E73746172742C652E7374617274293C4D6174682E6D696E28746869732E656E';
wwv_flow_imp.g_varchar2_table(5472) := '644578636C75736976652C652E656E644578636C7573697665297D69734265666F72652865297B72657475726E20746869732E656E644578636C75736976653C3D652E73746172747D697341667465722865297B72657475726E20746869732E73746172';
wwv_flow_imp.g_varchar2_table(5473) := '743E3D652E656E644578636C75736976657D736C6963652865297B72657475726E20652E736C69636528746869732E73746172742C746869732E656E644578636C7573697665297D737562737472696E672865297B72657475726E20652E737562737472';
wwv_flow_imp.g_varchar2_table(5474) := '696E6728746869732E73746172742C746869732E656E644578636C7573697665297D636C69702865297B696628746869732E6973456D707479297468726F77206E6577204F652860496E76616C696420636C697070696E672072616E67653A20247B7468';
wwv_flow_imp.g_varchar2_table(5475) := '69732E746F537472696E6728297D60293B72657475726E204D6174682E6D617828746869732E73746172742C4D6174682E6D696E28746869732E656E644578636C75736976652D312C6529297D636C69704379636C69632865297B696628746869732E69';
wwv_flow_imp.g_varchar2_table(5476) := '73456D707479297468726F77206E6577204F652860496E76616C696420636C697070696E672072616E67653A20247B746869732E746F537472696E6728297D60293B72657475726E20653C746869732E73746172743F746869732E656E644578636C7573';
wwv_flow_imp.g_varchar2_table(5477) := '6976652D28746869732E73746172742D652925746869732E6C656E6774683A653E3D746869732E656E644578636C75736976653F746869732E73746172742B28652D746869732E73746172742925746869732E6C656E6774683A657D666F724561636828';
wwv_flow_imp.g_varchar2_table(5478) := '65297B666F72286C657420743D746869732E73746172743B743C746869732E656E644578636C75736976653B742B2B29652874297D7D636C6173732066757B636F6E7374727563746F7228297B746869732E5F736F7274656452616E6765733D5B5D7D61';
wwv_flow_imp.g_varchar2_table(5479) := '646452616E67652865297B6C657420743D303B666F72283B743C746869732E5F736F7274656452616E6765732E6C656E6774682626746869732E5F736F7274656452616E6765735B745D2E656E644578636C75736976653C652E73746172743B29742B2B';
wwv_flow_imp.g_varchar2_table(5480) := '3B6C6574206E3D743B666F72283B6E3C746869732E5F736F7274656452616E6765732E6C656E6774682626746869732E5F736F7274656452616E6765735B6E5D2E73746172743C3D652E656E644578636C75736976653B296E2B2B3B696628743D3D3D6E';
wwv_flow_imp.g_varchar2_table(5481) := '29746869732E5F736F7274656452616E6765732E73706C69636528742C302C65293B656C73657B636F6E737420693D4D6174682E6D696E28652E73746172742C746869732E5F736F7274656452616E6765735B745D2E7374617274292C6F3D4D6174682E';
wwv_flow_imp.g_varchar2_table(5482) := '6D617828652E656E644578636C75736976652C746869732E5F736F7274656452616E6765735B6E2D315D2E656E644578636C7573697665293B746869732E5F736F7274656452616E6765732E73706C69636528742C6E2D742C6E6577206D7528692C6F29';
wwv_flow_imp.g_varchar2_table(5483) := '297D7D746F537472696E6728297B72657475726E20746869732E5F736F7274656452616E6765732E6D61702828653D3E652E746F537472696E67282929292E6A6F696E28222C2022297D696E74657273656374735374726963742865297B6C657420743D';
wwv_flow_imp.g_varchar2_table(5484) := '303B666F72283B743C746869732E5F736F7274656452616E6765732E6C656E6774682626746869732E5F736F7274656452616E6765735B745D2E656E644578636C75736976653C3D652E73746172743B29742B2B3B72657475726E20743C746869732E5F';
wwv_flow_imp.g_varchar2_table(5485) := '736F7274656452616E6765732E6C656E6774682626746869732E5F736F7274656452616E6765735B745D2E73746172743C652E656E644578636C75736976657D696E746572736563745769746852616E67652865297B636F6E737420743D6E6577206675';
wwv_flow_imp.g_varchar2_table(5486) := '3B666F7228636F6E7374206E206F6620746869732E5F736F7274656452616E676573297B636F6E737420693D6E2E696E746572736563742865293B692626742E61646452616E67652869297D72657475726E20747D696E74657273656374576974685261';
wwv_flow_imp.g_varchar2_table(5487) := '6E67654C656E6774682865297B72657475726E20746869732E696E746572736563745769746852616E67652865292E6C656E6774687D676574206C656E67746828297B72657475726E20746869732E5F736F7274656452616E6765732E72656475636528';
wwv_flow_imp.g_varchar2_table(5488) := '2828652C74293D3E652B742E6C656E677468292C30297D7D66756E6374696F6E20767528652C74297B636F6E7374206E3D66756E6374696F6E28652C742C6E3D652E6C656E6774682D31297B666F72286C657420693D6E3B693E3D303B692D2D29696628';
wwv_flow_imp.g_varchar2_table(5489) := '7428655B695D292972657475726E20693B72657475726E2D317D28652C74293B6966282D31213D3D6E2972657475726E20655B6E5D7D66756E6374696F6E20627528652C74297B636F6E7374206E3D5F7528652C74293B72657475726E2D313D3D3D6E3F';
wwv_flow_imp.g_varchar2_table(5490) := '766F696420303A655B6E5D7D66756E6374696F6E205F7528652C742C6E3D302C693D652E6C656E677468297B6C6574206F3D6E2C733D693B666F72283B6F3C733B297B636F6E7374206E3D4D6174682E666C6F6F7228286F2B73292F32293B7428655B6E';
wwv_flow_imp.g_varchar2_table(5491) := '5D293F6F3D6E2B313A733D6E7D72657475726E206F2D317D66756E6374696F6E20797528652C742C6E3D302C693D652E6C656E677468297B6C6574206F3D6E2C733D693B666F72283B6F3C733B297B636F6E7374206E3D4D6174682E666C6F6F7228286F';
wwv_flow_imp.g_varchar2_table(5492) := '2B73292F32293B7428655B6E5D293F733D6E3A6F3D6E2B317D72657475726E206F7D636C6173732077757B636F6E7374727563746F722865297B746869732E5F61727261793D652C746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C617374';
wwv_flow_imp.g_varchar2_table(5493) := '4964783D307D66696E644C6173744D6F6E6F746F6E6F75732865297B69662877752E617373657274496E76617269616E7473297B696628746869732E5F7072657646696E644C61737450726564696361746529666F7228636F6E73742074206F66207468';
wwv_flow_imp.g_varchar2_table(5494) := '69732E5F617272617929696628746869732E5F7072657646696E644C61737450726564696361746528742926262165287429297468726F77206E6577204572726F7228224D6F6E6F746F6E6F757341727261793A2063757272656E742070726564696361';
wwv_flow_imp.g_varchar2_table(5495) := '7465206D757374206265207765616B6572207468616E20286F7220657175616C20746F29207468652070726576696F7573207072656469636174652E22293B746869732E5F7072657646696E644C6173745072656469636174653D657D636F6E73742074';
wwv_flow_imp.g_varchar2_table(5496) := '3D5F7528746869732E5F61727261792C652C746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C617374496478293B72657475726E20746869732E5F66696E644C6173744D6F6E6F746F6E6F75734C6173744964783D742B312C2D313D3D3D74';
wwv_flow_imp.g_varchar2_table(5497) := '3F766F696420303A746869732E5F61727261795B745D7D7D66756E6374696F6E20437528652C74297B696628303D3D3D652E6C656E6774682972657475726E3B6C6574206E3D655B305D3B666F72286C657420693D313B693C652E6C656E6774683B692B';
wwv_flow_imp.g_varchar2_table(5498) := '2B297B636F6E7374206F3D655B695D3B74286F2C6E293E302626286E3D6F297D72657475726E206E7D66756E6374696F6E20537528652C74297B696628303D3D3D652E6C656E6774682972657475726E2D313B6C6574206E3D303B666F72286C65742069';
wwv_flow_imp.g_varchar2_table(5499) := '3D313B693C652E6C656E6774683B692B2B297428655B695D2C655B6E5D293E302626286E3D69293B72657475726E206E7D77752E617373657274496E76617269616E74733D21313B636C6173732078757B7374617469632066726F6D52616E6765496E63';
wwv_flow_imp.g_varchar2_table(5500) := '6C75736976652865297B72657475726E206E657720787528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722B31297D737461746963206A6F696E4D616E792865297B696628303D3D3D652E6C656E6774682972657475';
wwv_flow_imp.g_varchar2_table(5501) := '726E5B5D3B6C657420743D6E6577206B7528655B305D2E736C6963652829293B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B29743D742E676574556E696F6E286E6577206B7528655B6E5D2E736C696365282929293B72657475726E';
wwv_flow_imp.g_varchar2_table(5502) := '20742E72616E6765737D737461746963206A6F696E2865297B696628303D3D3D652E6C656E677468297468726F77206E6577204F6528226C696E6552616E6765732063616E6E6F7420626520656D70747922293B6C657420743D655B305D2E7374617274';
wwv_flow_imp.g_varchar2_table(5503) := '4C696E654E756D6265722C6E3D655B305D2E656E644C696E654E756D6265724578636C75736976653B666F72286C657420693D313B693C652E6C656E6774683B692B2B29743D4D6174682E6D696E28742C655B695D2E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(5504) := '72292C6E3D4D6174682E6D6178286E2C655B695D2E656E644C696E654E756D6265724578636C7573697665293B72657475726E206E657720787528742C6E297D737461746963206F664C656E67746828652C74297B72657475726E206E65772078752865';
wwv_flow_imp.g_varchar2_table(5505) := '2C652B74297D73746174696320646573657269616C697A652865297B72657475726E206E657720787528655B305D2C655B315D297D636F6E7374727563746F7228652C74297B696628653E74297468726F77206E6577204F65286073746172744C696E65';
wwv_flow_imp.g_varchar2_table(5506) := '4E756D62657220247B657D2063616E6E6F7420626520616674657220656E644C696E654E756D6265724578636C757369766520247B747D60293B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D62657245';
wwv_flow_imp.g_varchar2_table(5507) := '78636C75736976653D747D636F6E7461696E732865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652626653C746869732E656E644C696E654E756D6265724578636C75736976657D676574206973456D70747928297B72';
wwv_flow_imp.g_varchar2_table(5508) := '657475726E20746869732E73746172744C696E654E756D6265723D3D3D746869732E656E644C696E654E756D6265724578636C75736976657D64656C74612865297B72657475726E206E657720787528746869732E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(5509) := '2B652C746869732E656E644C696E654E756D6265724578636C75736976652B65297D64656C74614C656E6774682865297B72657475726E206E657720787528746869732E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(5510) := '65724578636C75736976652B65297D676574206C656E67746828297B72657475726E20746869732E656E644C696E654E756D6265724578636C75736976652D746869732E73746172744C696E654E756D6265727D6A6F696E2865297B72657475726E206E';
wwv_flow_imp.g_varchar2_table(5511) := '6577207875284D6174682E6D696E28746869732E73746172744C696E654E756D6265722C652E73746172744C696E654E756D626572292C4D6174682E6D617828746869732E656E644C696E654E756D6265724578636C75736976652C652E656E644C696E';
wwv_flow_imp.g_varchar2_table(5512) := '654E756D6265724578636C757369766529297D746F537472696E6728297B72657475726E605B247B746869732E73746172744C696E654E756D6265727D2C247B746869732E656E644C696E654E756D6265724578636C75736976657D29607D696E746572';
wwv_flow_imp.g_varchar2_table(5513) := '736563742865297B636F6E737420743D4D6174682E6D617828746869732E73746172744C696E654E756D6265722C652E73746172744C696E654E756D626572292C6E3D4D6174682E6D696E28746869732E656E644C696E654E756D6265724578636C7573';
wwv_flow_imp.g_varchar2_table(5514) := '6976652C652E656E644C696E654E756D6265724578636C7573697665293B696628743C3D6E2972657475726E206E657720787528742C6E297D696E74657273656374735374726963742865297B72657475726E20746869732E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(5515) := '6D6265723C652E656E644C696E654E756D6265724578636C75736976652626652E73746172744C696E654E756D6265723C746869732E656E644C696E654E756D6265724578636C75736976657D6F7665726C61704F72546F7563682865297B7265747572';
wwv_flow_imp.g_varchar2_table(5516) := '6E20746869732E73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C75736976652626652E73746172744C696E654E756D6265723C3D746869732E656E644C696E654E756D6265724578636C75736976657D657175';
wwv_flow_imp.g_varchar2_table(5517) := '616C732865297B72657475726E20746869732E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626746869732E656E644C696E654E756D6265724578636C75736976653D3D3D652E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(5518) := '724578636C75736976657D746F496E636C757369766552616E676528297B72657475726E20746869732E6973456D7074793F6E756C6C3A6E657720726828746869732E73746172744C696E654E756D6265722C312C746869732E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(5519) := '6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445474552297D746F4578636C757369766552616E676528297B72657475726E206E657720726828746869732E73746172744C696E654E756D6265722C312C74686973';
wwv_flow_imp.g_varchar2_table(5520) := '2E656E644C696E654E756D6265724578636C75736976652C31297D6D6170546F4C696E6541727261792865297B636F6E737420743D5B5D3B666F72286C6574206E3D746869732E73746172744C696E654E756D6265723B6E3C746869732E656E644C696E';
wwv_flow_imp.g_varchar2_table(5521) := '654E756D6265724578636C75736976653B6E2B2B29742E707573682865286E29293B72657475726E20747D666F72456163682865297B666F72286C657420743D746869732E73746172744C696E654E756D6265723B743C746869732E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(5522) := '756D6265724578636C75736976653B742B2B29652874297D73657269616C697A6528297B72657475726E5B746869732E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265724578636C75736976655D7D696E636C756465';
wwv_flow_imp.g_varchar2_table(5523) := '732865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652626653C746869732E656E644C696E654E756D6265724578636C75736976657D746F4F666673657452616E676528297B72657475726E206E6577206D7528746869';
wwv_flow_imp.g_varchar2_table(5524) := '732E73746172744C696E654E756D6265722D312C746869732E656E644C696E654E756D6265724578636C75736976652D31297D7D636C617373206B757B636F6E7374727563746F7228653D5B5D297B746869732E5F6E6F726D616C697A656452616E6765';
wwv_flow_imp.g_varchar2_table(5525) := '733D657D6765742072616E67657328297B72657475726E20746869732E5F6E6F726D616C697A656452616E6765737D61646452616E67652865297B696628303D3D3D652E6C656E6774682972657475726E3B636F6E737420743D797528746869732E5F6E';
wwv_flow_imp.g_varchar2_table(5526) := '6F726D616C697A656452616E6765732C28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D652E73746172744C696E654E756D62657229292C6E3D5F7528746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E';
wwv_flow_imp.g_varchar2_table(5527) := '73746172744C696E654E756D6265723C3D652E656E644C696E654E756D6265724578636C757369766529292B313B696628743D3D3D6E29746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C302C65293B656C736520696628';
wwv_flow_imp.g_varchar2_table(5528) := '743D3D3D6E2D31297B636F6E7374206E3D746869732E5F6E6F726D616C697A656452616E6765735B745D3B746869732E5F6E6F726D616C697A656452616E6765735B745D3D6E2E6A6F696E2865297D656C73657B636F6E737420693D746869732E5F6E6F';
wwv_flow_imp.g_varchar2_table(5529) := '726D616C697A656452616E6765735B745D2E6A6F696E28746869732E5F6E6F726D616C697A656452616E6765735B6E2D315D292E6A6F696E2865293B746869732E5F6E6F726D616C697A656452616E6765732E73706C69636528742C6E2D742C69297D7D';
wwv_flow_imp.g_varchar2_table(5530) := '636F6E7461696E732865297B636F6E737420743D627528746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C3D6529293B72657475726E2121742626742E656E644C696E654E756D62657245';
wwv_flow_imp.g_varchar2_table(5531) := '78636C75736976653E657D696E74657273656374732865297B636F6E737420743D627528746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E654E756D6265723C652E656E644C696E654E756D6265724578636C';
wwv_flow_imp.g_varchar2_table(5532) := '757369766529293B72657475726E2121742626742E656E644C696E654E756D6265724578636C75736976653E652E73746172744C696E654E756D6265727D676574556E696F6E2865297B696628303D3D3D746869732E5F6E6F726D616C697A656452616E';
wwv_flow_imp.g_varchar2_table(5533) := '6765732E6C656E6774682972657475726E20653B696628303D3D3D652E5F6E6F726D616C697A656452616E6765732E6C656E6774682972657475726E20746869733B636F6E737420743D5B5D3B6C6574206E3D302C693D302C6F3D6E756C6C3B666F7228';
wwv_flow_imp.g_varchar2_table(5534) := '3B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774687C7C693C652E5F6E6F726D616C697A656452616E6765732E6C656E6774683B297B6C657420733D6E756C6C3B6966286E3C746869732E5F6E6F726D616C697A656452616E';
wwv_flow_imp.g_varchar2_table(5535) := '6765732E6C656E6774682626693C652E5F6E6F726D616C697A656452616E6765732E6C656E677468297B636F6E737420743D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C6F3D652E5F6E6F726D616C697A656452616E6765735B695D';
wwv_flow_imp.g_varchar2_table(5536) := '3B742E73746172744C696E654E756D6265723C6F2E73746172744C696E654E756D6265723F28733D742C6E2B2B293A28733D6F2C692B2B297D656C7365206E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774683F28733D746869';
wwv_flow_imp.g_varchar2_table(5537) := '732E5F6E6F726D616C697A656452616E6765735B6E5D2C6E2B2B293A28733D652E5F6E6F726D616C697A656452616E6765735B695D2C692B2B293B6E756C6C3D3D3D6F3F6F3D733A6F2E656E644C696E654E756D6265724578636C75736976653E3D732E';
wwv_flow_imp.g_varchar2_table(5538) := '73746172744C696E654E756D6265723F6F3D6E6577207875286F2E73746172744C696E654E756D6265722C4D6174682E6D6178286F2E656E644C696E654E756D6265724578636C75736976652C732E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(5539) := '6529293A28742E70757368286F292C6F3D73297D72657475726E206E756C6C213D3D6F2626742E70757368286F292C6E6577206B752874297D737562747261637446726F6D2865297B636F6E737420743D797528746869732E5F6E6F726D616C697A6564';
wwv_flow_imp.g_varchar2_table(5540) := '52616E6765732C28743D3E742E656E644C696E654E756D6265724578636C75736976653E3D652E73746172744C696E654E756D62657229292C6E3D5F7528746869732E5F6E6F726D616C697A656452616E6765732C28743D3E742E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(5541) := '4E756D6265723C3D652E656E644C696E654E756D6265724578636C757369766529292B313B696628743D3D3D6E2972657475726E206E6577206B75285B655D293B636F6E737420693D5B5D3B6C6574206F3D652E73746172744C696E654E756D6265723B';
wwv_flow_imp.g_varchar2_table(5542) := '666F72286C657420653D743B653C6E3B652B2B297B636F6E737420743D746869732E5F6E6F726D616C697A656452616E6765735B655D3B742E73746172744C696E654E756D6265723E6F2626692E70757368286E6577207875286F2C742E73746172744C';
wwv_flow_imp.g_varchar2_table(5543) := '696E654E756D62657229292C6F3D742E656E644C696E654E756D6265724578636C75736976657D72657475726E206F3C652E656E644C696E654E756D6265724578636C75736976652626692E70757368286E6577207875286F2C652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(5544) := '756D6265724578636C757369766529292C6E6577206B752869297D746F537472696E6728297B72657475726E20746869732E5F6E6F726D616C697A656452616E6765732E6D61702828653D3E652E746F537472696E67282929292E6A6F696E28222C2022';
wwv_flow_imp.g_varchar2_table(5545) := '297D676574496E74657273656374696F6E2865297B636F6E737420743D5B5D3B6C6574206E3D302C693D303B666F72283B6E3C746869732E5F6E6F726D616C697A656452616E6765732E6C656E6774682626693C652E5F6E6F726D616C697A656452616E';
wwv_flow_imp.g_varchar2_table(5546) := '6765732E6C656E6774683B297B636F6E7374206F3D746869732E5F6E6F726D616C697A656452616E6765735B6E5D2C733D652E5F6E6F726D616C697A656452616E6765735B695D2C723D6F2E696E746572736563742873293B72262621722E6973456D70';
wwv_flow_imp.g_varchar2_table(5547) := '74792626742E707573682872292C6F2E656E644C696E654E756D6265724578636C75736976653C732E656E644C696E654E756D6265724578636C75736976653F6E2B2B3A692B2B7D72657475726E206E6577206B752874297D6765745769746844656C74';
wwv_flow_imp.g_varchar2_table(5548) := '612865297B72657475726E206E6577206B7528746869732E5F6E6F726D616C697A656452616E6765732E6D61702828743D3E742E64656C74612865292929297D7D636F6E73742045753D7B74616253697A653A342C696E64656E7453697A653A342C696E';
wwv_flow_imp.g_varchar2_table(5549) := '736572745370616365733A21302C646574656374496E64656E746174696F6E3A21302C7472696D4175746F576869746573706163653A21302C6C6172676546696C654F7074696D697A6174696F6E733A21302C627261636B657450616972436F6C6F7269';
wwv_flow_imp.g_varchar2_table(5550) := '7A6174696F6E4F7074696F6E733A7B656E61626C65643A21302C696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970653A21317D7D2C4C753D706328226C616E67756167655365727669636522292C44753D22607E214023';
wwv_flow_imp.g_varchar2_table(5551) := '24255E262A28292D3D2B5B7B5D7D5C5C7C3B3A275C222C2E3C3E2F3F222C54753D66756E6374696F6E28653D2222297B6C657420743D22282D3F5C5C642A5C5C2E5C5C645C5C772A297C285B5E223B666F7228636F6E7374206E206F6620447529652E69';
wwv_flow_imp.g_varchar2_table(5552) := '6E6465784F66286E293E3D307C7C28742B3D225C5C222B6E293B72657475726E20742B3D225C5C735D2B29222C6E65772052656745787028742C226722297D28293B66756E6374696F6E2049752865297B6C657420743D54753B6966286526266520696E';
wwv_flow_imp.g_varchar2_table(5553) := '7374616E63656F662052656745787029696628652E676C6F62616C29743D653B656C73657B6C6574206E3D2267223B652E69676E6F7265436173652626286E2B3D226922292C652E6D756C74696C696E652626286E2B3D226D22292C652E756E69636F64';
wwv_flow_imp.g_varchar2_table(5554) := '652626286E2B3D227522292C743D6E65772052656745787028652E736F757263652C6E297D72657475726E20742E6C617374496E6465783D302C747D636F6E7374204D753D6E65772067743B66756E6374696F6E20417528652C742C6E2C692C6F297B69';
wwv_flow_imp.g_varchar2_table(5555) := '6628743D49752874292C6F7C7C286F3D5A652E6669727374284D7529292C6E2E6C656E6774683E6F2E6D61784C656E297B6C657420733D652D6F2E6D61784C656E2F323B72657475726E20733C303F733D303A692B3D732C417528652C742C6E3D6E2E73';
wwv_flow_imp.g_varchar2_table(5556) := '7562737472696E6728732C652B6F2E6D61784C656E2F32292C692C6F297D636F6E737420733D446174652E6E6F7728292C723D652D312D693B6C657420613D2D312C6C3D6E756C6C3B666F72286C657420653D313B2128446174652E6E6F7728292D733E';
wwv_flow_imp.g_varchar2_table(5557) := '3D6F2E74696D65427564676574293B652B2B297B636F6E737420693D722D6F2E77696E646F7753697A652A653B742E6C617374496E6465783D4D6174682E6D617828302C69293B636F6E737420733D4E7528742C6E2C722C61293B696628217326266C29';
wwv_flow_imp.g_varchar2_table(5558) := '627265616B3B6966286C3D732C693C3D3029627265616B3B613D697D6966286C297B636F6E737420653D7B776F72643A6C5B305D2C7374617274436F6C756D6E3A692B312B6C2E696E6465782C656E64436F6C756D6E3A692B312B6C2E696E6465782B6C';
wwv_flow_imp.g_varchar2_table(5559) := '5B305D2E6C656E6774687D3B72657475726E20742E6C617374496E6465783D302C657D72657475726E206E756C6C7D66756E6374696F6E204E7528652C742C6E2C69297B6C6574206F3B666F72283B6F3D652E657865632874293B297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(5560) := '3D6F2E696E6465787C7C303B696628743C3D6E2626652E6C617374496E6465783E3D6E2972657475726E206F3B696628693E302626743E692972657475726E206E756C6C7D72657475726E206E756C6C7D7661722050753B4D752E756E7368696674287B';
wwv_flow_imp.g_varchar2_table(5561) := '6D61784C656E3A3165332C77696E646F7753697A653A31352C74696D654275646765743A3135307D292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E496E64656E743D315D3D22496E64656E74222C655B652E';
wwv_flow_imp.g_varchar2_table(5562) := '496E64656E744F757464656E743D325D3D22496E64656E744F757464656E74222C655B652E4F757464656E743D335D3D224F757464656E74227D2850757C7C2850753D7B7D29293B636C617373204F757B636F6E7374727563746F722865297B69662874';
wwv_flow_imp.g_varchar2_table(5563) := '6869732E5F6E65757472616C4368617261637465723D6E756C6C2C746869732E5F6E65757472616C43686172616374657253656172636865643D21312C746869732E6F70656E3D652E6F70656E2C746869732E636C6F73653D652E636C6F73652C746869';
wwv_flow_imp.g_varchar2_table(5564) := '732E5F696E537472696E673D21302C746869732E5F696E436F6D6D656E743D21302C746869732E5F696E52656745783D21302C41727261792E6973417272617928652E6E6F74496E2929666F72286C657420743D302C6E3D652E6E6F74496E2E6C656E67';
wwv_flow_imp.g_varchar2_table(5565) := '74683B743C6E3B742B2B2973776974636828652E6E6F74496E5B745D297B6361736522737472696E67223A746869732E5F696E537472696E673D21313B627265616B3B6361736522636F6D6D656E74223A746869732E5F696E436F6D6D656E743D21313B';
wwv_flow_imp.g_varchar2_table(5566) := '627265616B3B63617365227265676578223A746869732E5F696E52656745783D21317D7D69734F4B2865297B7377697463682865297B6361736520303A72657475726E21303B6361736520313A72657475726E20746869732E5F696E436F6D6D656E743B';
wwv_flow_imp.g_varchar2_table(5567) := '6361736520323A72657475726E20746869732E5F696E537472696E673B6361736520333A72657475726E20746869732E5F696E52656745787D7D73686F756C644175746F436C6F736528652C74297B696628303D3D3D652E676574546F6B656E436F756E';
wwv_flow_imp.g_varchar2_table(5568) := '7428292972657475726E21303B636F6E7374206E3D652E66696E64546F6B656E496E64657841744F666673657428742D32292C693D652E6765745374616E64617264546F6B656E54797065286E293B72657475726E20746869732E69734F4B2869297D5F';
wwv_flow_imp.g_varchar2_table(5569) := '66696E644E65757472616C436861726163746572496E52616E676528652C74297B666F72286C6574206E3D653B6E3C3D743B6E2B2B297B636F6E737420653D537472696E672E66726F6D43686172436F6465286E293B69662821746869732E6F70656E2E';
wwv_flow_imp.g_varchar2_table(5570) := '696E636C75646573286529262621746869732E636C6F73652E696E636C756465732865292972657475726E20657D72657475726E206E756C6C7D66696E644E65757472616C43686172616374657228297B72657475726E20746869732E5F6E6575747261';
wwv_flow_imp.g_varchar2_table(5571) := '6C43686172616374657253656172636865647C7C28746869732E5F6E65757472616C43686172616374657253656172636865643D21302C746869732E5F6E65757472616C4368617261637465727C7C28746869732E5F6E65757472616C43686172616374';
wwv_flow_imp.g_varchar2_table(5572) := '65723D746869732E5F66696E644E65757472616C436861726163746572496E52616E67652834382C353729292C746869732E5F6E65757472616C4368617261637465727C7C28746869732E5F6E65757472616C4368617261637465723D746869732E5F66';
wwv_flow_imp.g_varchar2_table(5573) := '696E644E65757472616C436861726163746572496E52616E67652839372C31323229292C746869732E5F6E65757472616C4368617261637465727C7C28746869732E5F6E65757472616C4368617261637465723D746869732E5F66696E644E6575747261';
wwv_flow_imp.g_varchar2_table(5574) := '6C436861726163746572496E52616E67652836352C39302929292C746869732E5F6E65757472616C4368617261637465727D7D636C6173732052757B636F6E7374727563746F722865297B746869732E6175746F436C6F73696E6750616972734F70656E';
wwv_flow_imp.g_varchar2_table(5575) := '427953746172743D6E6577204D61702C746869732E6175746F436C6F73696E6750616972734F70656E4279456E643D6E6577204D61702C746869732E6175746F436C6F73696E675061697273436C6F7365427953746172743D6E6577204D61702C746869';
wwv_flow_imp.g_varchar2_table(5576) := '732E6175746F436C6F73696E675061697273436C6F73654279456E643D6E6577204D61702C746869732E6175746F436C6F73696E675061697273436C6F736553696E676C65436861723D6E6577204D61703B666F7228636F6E73742074206F6620652946';
wwv_flow_imp.g_varchar2_table(5577) := '7528746869732E6175746F436C6F73696E6750616972734F70656E427953746172742C742E6F70656E2E6368617241742830292C74292C467528746869732E6175746F436C6F73696E6750616972734F70656E4279456E642C742E6F70656E2E63686172';
wwv_flow_imp.g_varchar2_table(5578) := '417428742E6F70656E2E6C656E6774682D31292C74292C467528746869732E6175746F436C6F73696E675061697273436C6F7365427953746172742C742E636C6F73652E6368617241742830292C74292C467528746869732E6175746F436C6F73696E67';
wwv_flow_imp.g_varchar2_table(5579) := '5061697273436C6F73654279456E642C742E636C6F73652E63686172417428742E636C6F73652E6C656E6774682D31292C74292C313D3D3D742E636C6F73652E6C656E6774682626313D3D3D742E6F70656E2E6C656E6774682626467528746869732E61';
wwv_flow_imp.g_varchar2_table(5580) := '75746F436C6F73696E675061697273436C6F736553696E676C65436861722C742E636C6F73652C74297D7D66756E6374696F6E20467528652C742C6E297B652E6861732874293F652E6765742874292E70757368286E293A652E73657428742C5B6E5D29';
wwv_flow_imp.g_varchar2_table(5581) := '7D66756E6374696F6E20427528652C74297B636F6E7374206E3D652E676574436F756E7428292C693D652E66696E64546F6B656E496E64657841744F66667365742874292C6F3D652E6765744C616E677561676549642869293B6C657420733D693B666F';
wwv_flow_imp.g_varchar2_table(5582) := '72283B732B313C6E2626652E6765744C616E6775616765496428732B31293D3D3D6F3B29732B2B3B6C657420723D693B666F72283B723E302626652E6765744C616E6775616765496428722D31293D3D3D6F3B29722D2D3B72657475726E206E65772056';
wwv_flow_imp.g_varchar2_table(5583) := '7528652C6F2C722C732B312C652E67657453746172744F66667365742872292C652E676574456E644F6666736574287329297D636C6173732056757B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E5F73636F7065644C696E';
wwv_flow_imp.g_varchar2_table(5584) := '65546F6B656E734272616E643D766F696420302C746869732E5F61637475616C3D652C746869732E6C616E677561676549643D742C746869732E5F6669727374546F6B656E496E6465783D6E2C746869732E5F6C617374546F6B656E496E6465783D692C';
wwv_flow_imp.g_varchar2_table(5585) := '746869732E6669727374436861724F66667365743D6F2C746869732E5F6C617374436861724F66667365743D737D6765744C696E65436F6E74656E7428297B72657475726E20746869732E5F61637475616C2E6765744C696E65436F6E74656E7428292E';
wwv_flow_imp.g_varchar2_table(5586) := '737562737472696E6728746869732E6669727374436861724F66667365742C746869732E5F6C617374436861724F6666736574297D67657441637475616C4C696E65436F6E74656E744265666F72652865297B72657475726E20746869732E5F61637475';
wwv_flow_imp.g_varchar2_table(5587) := '616C2E6765744C696E65436F6E74656E7428292E737562737472696E6728302C746869732E6669727374436861724F66667365742B65297D676574546F6B656E436F756E7428297B72657475726E20746869732E5F6C617374546F6B656E496E6465782D';
wwv_flow_imp.g_varchar2_table(5588) := '746869732E5F6669727374546F6B656E496E6465787D66696E64546F6B656E496E64657841744F66667365742865297B72657475726E20746869732E5F61637475616C2E66696E64546F6B656E496E64657841744F666673657428652B746869732E6669';
wwv_flow_imp.g_varchar2_table(5589) := '727374436861724F6666736574292D746869732E5F6669727374546F6B656E496E6465787D6765745374616E64617264546F6B656E547970652865297B72657475726E20746869732E5F61637475616C2E6765745374616E64617264546F6B656E547970';
wwv_flow_imp.g_varchar2_table(5590) := '6528652B746869732E5F6669727374546F6B656E496E646578297D7D66756E6374696F6E207A752865297B72657475726E212128332665297D636C6173732048757B636F6E7374727563746F722865297B696628652E6175746F436C6F73696E67506169';
wwv_flow_imp.g_varchar2_table(5591) := '72733F746869732E5F6175746F436C6F73696E6750616972733D652E6175746F436C6F73696E6750616972732E6D61702828653D3E6E6577204F7528652929293A652E627261636B6574733F746869732E5F6175746F436C6F73696E6750616972733D65';
wwv_flow_imp.g_varchar2_table(5592) := '2E627261636B6574732E6D61702828653D3E6E6577204F75287B6F70656E3A655B305D2C636C6F73653A655B315D7D2929293A746869732E5F6175746F436C6F73696E6750616972733D5B5D2C652E5F5F656C6563747269634368617261637465725375';
wwv_flow_imp.g_varchar2_table(5593) := '70706F72742626652E5F5F656C656374726963436861726163746572537570706F72742E646F63436F6D6D656E74297B636F6E737420743D652E5F5F656C656374726963436861726163746572537570706F72742E646F63436F6D6D656E743B74686973';
wwv_flow_imp.g_varchar2_table(5594) := '2E5F6175746F436C6F73696E6750616972732E70757368286E6577204F75287B6F70656E3A742E6F70656E2C636C6F73653A742E636C6F73657C7C22227D29297D746869732E5F6175746F436C6F73654265666F7265466F7251756F7465733D22737472';
wwv_flow_imp.g_varchar2_table(5595) := '696E67223D3D747970656F6620652E6175746F436C6F73654265666F72653F652E6175746F436C6F73654265666F72653A48752E44454641554C545F4155544F434C4F53455F4245464F52455F4C414E47554147455F444546494E45445F51554F544553';
wwv_flow_imp.g_varchar2_table(5596) := '2C746869732E5F6175746F436C6F73654265666F7265466F72427261636B6574733D22737472696E67223D3D747970656F6620652E6175746F436C6F73654265666F72653F652E6175746F436C6F73654265666F72653A48752E44454641554C545F4155';
wwv_flow_imp.g_varchar2_table(5597) := '544F434C4F53455F4245464F52455F4C414E47554147455F444546494E45445F425241434B4554532C746869732E5F737572726F756E64696E6750616972733D652E737572726F756E64696E6750616972737C7C746869732E5F6175746F436C6F73696E';
wwv_flow_imp.g_varchar2_table(5598) := '6750616972737D6765744175746F436C6F73696E67506169727328297B72657475726E20746869732E5F6175746F436C6F73696E6750616972737D6765744175746F436C6F73654265666F72655365742865297B72657475726E20653F746869732E5F61';
wwv_flow_imp.g_varchar2_table(5599) := '75746F436C6F73654265666F7265466F7251756F7465733A746869732E5F6175746F436C6F73654265666F7265466F72427261636B6574737D676574537572726F756E64696E67506169727328297B72657475726E20746869732E5F737572726F756E64';
wwv_flow_imp.g_varchar2_table(5600) := '696E6750616972737D7D48752E44454641554C545F4155544F434C4F53455F4245464F52455F4C414E47554147455F444546494E45445F51554F5445533D223B3A2E2C3D7D5D293E205C6E5C74222C48752E44454641554C545F4155544F434C4F53455F';
wwv_flow_imp.g_varchar2_table(5601) := '4245464F52455F4C414E47554147455F444546494E45445F425241434B4554533D22275C22603B3A2E2C3D7D5D293E205C6E5C74223B636F6E73742057753D22756E646566696E656422213D747970656F66204275666665723B6C6574206A752C71752C';
wwv_flow_imp.g_varchar2_table(5602) := '24752C55753B6E6577206969282828293D3E6E65772055696E74384172726179283235362929293B636C617373204B757B73746174696320777261702865297B72657475726E2057752626214275666665722E6973427566666572286529262628653D42';
wwv_flow_imp.g_varchar2_table(5603) := '75666665722E66726F6D28652E6275666665722C652E627974654F66667365742C652E627974654C656E67746829292C6E6577204B752865297D636F6E7374727563746F722865297B746869732E6275666665723D652C746869732E627974654C656E67';
wwv_flow_imp.g_varchar2_table(5604) := '74683D746869732E6275666665722E627974654C656E6774687D746F537472696E6728297B72657475726E2057753F746869732E6275666665722E746F537472696E6728293A286A757C7C286A753D6E657720546578744465636F646572292C6A752E64';
wwv_flow_imp.g_varchar2_table(5605) := '65636F646528746869732E62756666657229297D7D66756E6374696F6E20477528652C74297B72657475726E28307C655B742B305D293E3E3E307C655B742B315D3C3C383E3E3E307D66756E6374696F6E20517528652C742C6E297B655B6E2B305D3D32';
wwv_flow_imp.g_varchar2_table(5606) := '353526742C743E3E3E3D382C655B6E2B315D3D32353526747D66756E6374696F6E20597528652C74297B72657475726E20655B745D2A322A2A32342B36353533362A655B742B315D2B3235362A655B742B325D2B655B742B335D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5607) := '5A7528652C742C6E297B655B6E2B335D3D742C743E3E3E3D382C655B6E2B325D3D742C743E3E3E3D382C655B6E2B315D3D742C743E3E3E3D382C655B6E5D3D747D66756E6374696F6E20587528652C74297B72657475726E20655B745D7D66756E637469';
wwv_flow_imp.g_varchar2_table(5608) := '6F6E204A7528652C742C6E297B655B6E5D3D747D66756E6374696F6E20657028297B72657475726E2071757C7C2871753D6E657720546578744465636F64657228225554462D31364C452229292C71757D66756E6374696F6E20747028297B7265747572';
wwv_flow_imp.g_varchar2_table(5609) := '6E2055757C7C2855753D6F6528293F657028293A2824757C7C2824753D6E657720546578744465636F64657228225554462D313642452229292C247529292C55757D636C617373206E707B636F6E7374727563746F722865297B746869732E5F63617061';
wwv_flow_imp.g_varchar2_table(5610) := '636974793D307C652C746869732E5F6275666665723D6E65772055696E743136417272617928746869732E5F6361706163697479292C746869732E5F636F6D706C65746564537472696E67733D6E756C6C2C746869732E5F6275666665724C656E677468';
wwv_flow_imp.g_varchar2_table(5611) := '3D307D726573657428297B746869732E5F636F6D706C65746564537472696E67733D6E756C6C2C746869732E5F6275666665724C656E6774683D307D6275696C6428297B72657475726E206E756C6C213D3D746869732E5F636F6D706C65746564537472';
wwv_flow_imp.g_varchar2_table(5612) := '696E67733F28746869732E5F666C75736842756666657228292C746869732E5F636F6D706C65746564537472696E67732E6A6F696E28222229293A746869732E5F6275696C6442756666657228297D5F6275696C6442756666657228297B696628303D3D';
wwv_flow_imp.g_varchar2_table(5613) := '3D746869732E5F6275666665724C656E6774682972657475726E22223B636F6E737420653D6E65772055696E743136417272617928746869732E5F6275666665722E6275666665722C302C746869732E5F6275666665724C656E677468293B7265747572';
wwv_flow_imp.g_varchar2_table(5614) := '6E20747028292E6465636F64652865297D5F666C75736842756666657228297B636F6E737420653D746869732E5F6275696C6442756666657228293B746869732E5F6275666665724C656E6774683D302C6E756C6C3D3D3D746869732E5F636F6D706C65';
wwv_flow_imp.g_varchar2_table(5615) := '746564537472696E67733F746869732E5F636F6D706C65746564537472696E67733D5B655D3A746869732E5F636F6D706C65746564537472696E67735B746869732E5F636F6D706C65746564537472696E67732E6C656E6774685D3D657D617070656E64';
wwv_flow_imp.g_varchar2_table(5616) := '43686172436F64652865297B636F6E737420743D746869732E5F63617061636974792D746869732E5F6275666665724C656E6774683B743C3D31262628303D3D3D747C7C5469286529292626746869732E5F666C75736842756666657228292C74686973';
wwv_flow_imp.g_varchar2_table(5617) := '2E5F6275666665725B746869732E5F6275666665724C656E6774682B2B5D3D657D617070656E64415343494943686172436F64652865297B746869732E5F6275666665724C656E6774683D3D3D746869732E5F63617061636974792626746869732E5F66';
wwv_flow_imp.g_varchar2_table(5618) := '6C75736842756666657228292C746869732E5F6275666665725B746869732E5F6275666665724C656E6774682B2B5D3D657D617070656E64537472696E672865297B636F6E737420743D652E6C656E6774683B696628746869732E5F6275666665724C65';
wwv_flow_imp.g_varchar2_table(5619) := '6E6774682B743E3D746869732E5F63617061636974792972657475726E20746869732E5F666C75736842756666657228292C766F696428746869732E5F636F6D706C65746564537472696E67735B746869732E5F636F6D706C65746564537472696E6773';
wwv_flow_imp.g_varchar2_table(5620) := '2E6C656E6774685D3D65293B666F72286C6574206E3D303B6E3C743B6E2B2B29746869732E5F6275666665725B746869732E5F6275666665724C656E6774682B2B5D3D652E63686172436F64654174286E297D7D636C6173732069707B636F6E73747275';
wwv_flow_imp.g_varchar2_table(5621) := '63746F7228652C742C6E2C692C6F2C73297B746869732E5F7269636845646974427261636B65744272616E643D766F696420302C746869732E6C616E677561676549643D652C746869732E696E6465783D742C746869732E6F70656E3D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(5622) := '636C6F73653D692C746869732E666F727761726452656765783D6F2C746869732E726576657273656452656765783D732C746869732E5F6F70656E5365743D69702E5F746F53657428746869732E6F70656E292C746869732E5F636C6F73655365743D69';
wwv_flow_imp.g_varchar2_table(5623) := '702E5F746F53657428746869732E636C6F7365297D69734F70656E2865297B72657475726E20746869732E5F6F70656E5365742E6861732865297D6973436C6F73652865297B72657475726E20746869732E5F636C6F73655365742E6861732865297D73';
wwv_flow_imp.g_varchar2_table(5624) := '7461746963205F746F5365742865297B636F6E737420743D6E6577205365743B666F7228636F6E7374206E206F66206529742E616464286E293B72657475726E20747D7D636C617373206F707B636F6E7374727563746F7228652C74297B746869732E5F';
wwv_flow_imp.g_varchar2_table(5625) := '7269636845646974427261636B6574734272616E643D766F696420303B636F6E7374206E3D66756E6374696F6E2865297B636F6E737420743D652E6C656E6774683B653D652E6D61702828653D3E5B655B305D2E746F4C6F7765724361736528292C655B';
wwv_flow_imp.g_varchar2_table(5626) := '315D2E746F4C6F7765724361736528295D29293B636F6E7374206E3D5B5D3B666F72286C657420653D303B653C743B652B2B296E5B655D3D653B636F6E737420693D28652C74293D3E7B636F6E73745B6E2C695D3D652C5B6F2C735D3D743B7265747572';
wwv_flow_imp.g_varchar2_table(5627) := '6E206E3D3D3D6F7C7C6E3D3D3D737C7C693D3D3D6F7C7C693D3D3D737D2C6F3D28652C69293D3E7B636F6E7374206F3D4D6174682E6D696E28652C69292C733D4D6174682E6D617828652C69293B666F72286C657420653D303B653C743B652B2B296E5B';
wwv_flow_imp.g_varchar2_table(5628) := '655D3D3D3D732626286E5B655D3D6F297D3B666F72286C657420733D303B733C743B732B2B297B636F6E737420723D655B735D3B666F72286C657420613D732B313B613C743B612B2B296928722C655B615D2926266F286E5B735D2C6E5B615D297D636F';
wwv_flow_imp.g_varchar2_table(5629) := '6E737420733D5B5D3B666F72286C657420693D303B693C743B692B2B297B636F6E7374206F3D5B5D2C723D5B5D3B666F72286C657420733D303B733C743B732B2B296966286E5B735D3D3D3D69297B636F6E73745B742C6E5D3D655B735D3B6F2E707573';
wwv_flow_imp.g_varchar2_table(5630) := '682874292C722E70757368286E297D6F2E6C656E6774683E302626732E70757368287B6F70656E3A6F2C636C6F73653A727D297D72657475726E20737D2874293B746869732E627261636B6574733D6E2E6D6170282828742C69293D3E6E657720697028';
wwv_flow_imp.g_varchar2_table(5631) := '652C692C742E6F70656E2C742E636C6F73652C66756E6374696F6E28652C742C6E2C69297B6C6574206F3D5B5D3B6F3D6F2E636F6E6361742865292C6F3D6F2E636F6E6361742874293B666F72286C657420653D302C743D6F2E6C656E6774683B653C74';
wwv_flow_imp.g_varchar2_table(5632) := '3B652B2B297370286F5B655D2C6E2C692C6F293B72657475726E206F3D6170286F292C6F2E736F7274287270292C6F2E7265766572736528292C6370286F297D28742E6F70656E2C742E636C6F73652C6E2C69292C66756E6374696F6E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(5633) := '69297B6C6574206F3D5B5D3B6F3D6F2E636F6E6361742865292C6F3D6F2E636F6E6361742874293B666F72286C657420653D302C743D6F2E6C656E6774683B653C743B652B2B297370286F5B655D2C6E2C692C6F293B72657475726E206F3D6170286F29';
wwv_flow_imp.g_varchar2_table(5634) := '2C6F2E736F7274287270292C6F2E7265766572736528292C6370286F2E6D617028647029297D28742E6F70656E2C742E636C6F73652C6E2C69292929292C746869732E666F727761726452656765783D66756E6374696F6E2865297B6C657420743D5B5D';
wwv_flow_imp.g_varchar2_table(5635) := '3B666F7228636F6E7374206E206F662065297B666F7228636F6E73742065206F66206E2E6F70656E29742E707573682865293B666F7228636F6E73742065206F66206E2E636C6F736529742E707573682865297D72657475726E20743D61702874292C63';
wwv_flow_imp.g_varchar2_table(5636) := '702874297D28746869732E627261636B657473292C746869732E726576657273656452656765783D66756E6374696F6E2865297B6C657420743D5B5D3B666F7228636F6E7374206E206F662065297B666F7228636F6E73742065206F66206E2E6F70656E';
wwv_flow_imp.g_varchar2_table(5637) := '29742E707573682865293B666F7228636F6E73742065206F66206E2E636C6F736529742E707573682865297D72657475726E20743D61702874292C637028742E6D617028647029297D28746869732E627261636B657473292C746869732E746578744973';
wwv_flow_imp.g_varchar2_table(5638) := '427261636B65743D7B7D2C746869732E7465787449734F70656E427261636B65743D7B7D2C746869732E6D6178427261636B65744C656E6774683D303B666F7228636F6E73742065206F6620746869732E627261636B657473297B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(5639) := '2074206F6620652E6F70656E29746869732E746578744973427261636B65745B745D3D652C746869732E7465787449734F70656E427261636B65745B745D3D21302C746869732E6D6178427261636B65744C656E6774683D4D6174682E6D617828746869';
wwv_flow_imp.g_varchar2_table(5640) := '732E6D6178427261636B65744C656E6774682C742E6C656E677468293B666F7228636F6E73742074206F6620652E636C6F736529746869732E746578744973427261636B65745B745D3D652C746869732E7465787449734F70656E427261636B65745B74';
wwv_flow_imp.g_varchar2_table(5641) := '5D3D21312C746869732E6D6178427261636B65744C656E6774683D4D6174682E6D617828746869732E6D6178427261636B65744C656E6774682C742E6C656E677468297D7D7D66756E6374696F6E20737028652C742C6E2C69297B666F72286C6574206F';
wwv_flow_imp.g_varchar2_table(5642) := '3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B6966286F3D3D3D6E29636F6E74696E75653B636F6E737420733D745B6F5D3B666F7228636F6E73742074206F6620732E6F70656E29742E696E6465784F662865293E3D302626692E7075736828';
wwv_flow_imp.g_varchar2_table(5643) := '74293B666F7228636F6E73742074206F6620732E636C6F736529742E696E6465784F662865293E3D302626692E707573682874297D7D66756E6374696F6E20727028652C74297B72657475726E20652E6C656E6774682D742E6C656E6774687D66756E63';
wwv_flow_imp.g_varchar2_table(5644) := '74696F6E2061702865297B696628652E6C656E6774683C3D312972657475726E20653B636F6E737420743D5B5D2C6E3D6E6577205365743B666F7228636F6E73742069206F662065296E2E6861732869297C7C28742E707573682869292C6E2E61646428';
wwv_flow_imp.g_varchar2_table(5645) := '6929293B72657475726E20747D66756E6374696F6E206C702865297B636F6E737420743D2F5E5B5C77205D2B242F2E746573742865293B72657475726E20653D63692865292C743F605C5C62247B657D5C5C62603A657D66756E6374696F6E2063702865';
wwv_flow_imp.g_varchar2_table(5646) := '297B72657475726E207069286028247B652E6D6170286C70292E6A6F696E2822297C2822297D29602C2130297D636F6E73742064703D66756E6374696F6E28297B6C657420653D6E756C6C2C743D6E756C6C3B72657475726E2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(5647) := '297B72657475726E2065213D3D6E262628653D6E2C743D66756E6374696F6E2865297B636F6E737420743D6E65772055696E743136417272617928652E6C656E677468293B6C6574206E3D303B666F72286C657420693D652E6C656E6774682D313B693E';
wwv_flow_imp.g_varchar2_table(5648) := '3D303B692D2D29745B6E2B2B5D3D652E63686172436F646541742869293B72657475726E20747028292E6465636F64652874297D286529292C747D7D28293B636C6173732068707B737461746963205F66696E6450726576427261636B6574496E546578';
wwv_flow_imp.g_varchar2_table(5649) := '7428652C742C6E2C69297B636F6E7374206F3D6E2E6D617463682865293B696628216F2972657475726E206E756C6C3B636F6E737420733D6E2E6C656E6774682D286F2E696E6465787C7C30292C723D6F5B305D2E6C656E6774682C613D692B733B7265';
wwv_flow_imp.g_varchar2_table(5650) := '7475726E206E657720726828742C612D722B312C742C612B31297D7374617469632066696E6450726576427261636B6574496E52616E676528652C742C6E2C692C6F297B636F6E737420733D6470286E292E737562737472696E67286E2E6C656E677468';
wwv_flow_imp.g_varchar2_table(5651) := '2D6F2C6E2E6C656E6774682D69293B72657475726E20746869732E5F66696E6450726576427261636B6574496E5465787428652C742C732C69297D7374617469632066696E644E657874427261636B6574496E5465787428652C742C6E2C69297B636F6E';
wwv_flow_imp.g_varchar2_table(5652) := '7374206F3D6E2E6D617463682865293B696628216F2972657475726E206E756C6C3B636F6E737420733D6F2E696E6465787C7C302C723D6F5B305D2E6C656E6774683B696628303D3D3D722972657475726E206E756C6C3B636F6E737420613D692B733B';
wwv_flow_imp.g_varchar2_table(5653) := '72657475726E206E657720726828742C612B312C742C612B312B72297D7374617469632066696E644E657874427261636B6574496E52616E676528652C742C6E2C692C6F297B636F6E737420733D6E2E737562737472696E6728692C6F293B7265747572';
wwv_flow_imp.g_varchar2_table(5654) := '6E20746869732E66696E644E657874427261636B6574496E5465787428652C742C732C69297D7D636C6173732075707B636F6E7374727563746F722865297B746869732E5F7269636845646974427261636B6574733D657D676574456C65637472696343';
wwv_flow_imp.g_varchar2_table(5655) := '68617261637465727328297B636F6E737420653D5B5D3B696628746869732E5F7269636845646974427261636B65747329666F7228636F6E73742074206F6620746869732E5F7269636845646974427261636B6574732E627261636B65747329666F7228';
wwv_flow_imp.g_varchar2_table(5656) := '636F6E7374206E206F6620742E636C6F7365297B636F6E737420743D6E2E636861724174286E2E6C656E6774682D31293B652E707573682874297D72657475726E2071682865297D6F6E456C65637472696343686172616374657228652C742C6E297B69';
wwv_flow_imp.g_varchar2_table(5657) := '662821746869732E5F7269636845646974427261636B6574737C7C303D3D3D746869732E5F7269636845646974427261636B6574732E627261636B6574732E6C656E6774682972657475726E206E756C6C3B636F6E737420693D742E66696E64546F6B65';
wwv_flow_imp.g_varchar2_table(5658) := '6E496E64657841744F6666736574286E2D31293B6966287A7528742E6765745374616E64617264546F6B656E54797065286929292972657475726E206E756C6C3B636F6E7374206F3D746869732E5F7269636845646974427261636B6574732E72657665';
wwv_flow_imp.g_varchar2_table(5659) := '7273656452656765782C733D742E6765744C696E65436F6E74656E7428292E737562737472696E6728302C6E2D31292B652C723D68702E66696E6450726576427261636B6574496E52616E6765286F2C312C732C302C732E6C656E677468293B69662821';
wwv_flow_imp.g_varchar2_table(5660) := '722972657475726E206E756C6C3B636F6E737420613D732E737562737472696E6728722E7374617274436F6C756D6E2D312C722E656E64436F6C756D6E2D31292E746F4C6F7765724361736528293B696628746869732E5F726963684564697442726163';
wwv_flow_imp.g_varchar2_table(5661) := '6B6574732E7465787449734F70656E427261636B65745B615D2972657475726E206E756C6C3B636F6E7374206C3D742E67657441637475616C4C696E65436F6E74656E744265666F726528722E7374617274436F6C756D6E2D31293B72657475726E2F5E';
wwv_flow_imp.g_varchar2_table(5662) := '5C732A242F2E74657374286C293F7B6D617463684F70656E427261636B65743A617D3A6E756C6C7D7D66756E6374696F6E2070702865297B72657475726E20652E676C6F62616C262628652E6C617374496E6465783D30292C21307D636C617373206770';
wwv_flow_imp.g_varchar2_table(5663) := '7B636F6E7374727563746F722865297B746869732E5F696E64656E746174696F6E52756C65733D657D73686F756C64496E6372656173652865297B72657475726E212128746869732E5F696E64656E746174696F6E52756C65732626746869732E5F696E';
wwv_flow_imp.g_varchar2_table(5664) := '64656E746174696F6E52756C65732E696E637265617365496E64656E745061747465726E2626707028746869732E5F696E64656E746174696F6E52756C65732E696E637265617365496E64656E745061747465726E292626746869732E5F696E64656E74';
wwv_flow_imp.g_varchar2_table(5665) := '6174696F6E52756C65732E696E637265617365496E64656E745061747465726E2E74657374286529297D73686F756C6444656372656173652865297B72657475726E212128746869732E5F696E64656E746174696F6E52756C65732626746869732E5F69';
wwv_flow_imp.g_varchar2_table(5666) := '6E64656E746174696F6E52756C65732E6465637265617365496E64656E745061747465726E2626707028746869732E5F696E64656E746174696F6E52756C65732E6465637265617365496E64656E745061747465726E292626746869732E5F696E64656E';
wwv_flow_imp.g_varchar2_table(5667) := '746174696F6E52756C65732E6465637265617365496E64656E745061747465726E2E74657374286529297D73686F756C64496E64656E744E6578744C696E652865297B72657475726E212128746869732E5F696E64656E746174696F6E52756C65732626';
wwv_flow_imp.g_varchar2_table(5668) := '746869732E5F696E64656E746174696F6E52756C65732E696E64656E744E6578744C696E655061747465726E2626707028746869732E5F696E64656E746174696F6E52756C65732E696E64656E744E6578744C696E655061747465726E29262674686973';
wwv_flow_imp.g_varchar2_table(5669) := '2E5F696E64656E746174696F6E52756C65732E696E64656E744E6578744C696E655061747465726E2E74657374286529297D73686F756C6449676E6F72652865297B72657475726E212128746869732E5F696E64656E746174696F6E52756C6573262674';
wwv_flow_imp.g_varchar2_table(5670) := '6869732E5F696E64656E746174696F6E52756C65732E756E496E64656E7465644C696E655061747465726E2626707028746869732E5F696E64656E746174696F6E52756C65732E756E496E64656E7465644C696E655061747465726E292626746869732E';
wwv_flow_imp.g_varchar2_table(5671) := '5F696E64656E746174696F6E52756C65732E756E496E64656E7465644C696E655061747465726E2E74657374286529297D676574496E64656E744D657461646174612865297B6C657420743D303B72657475726E20746869732E73686F756C64496E6372';
wwv_flow_imp.g_varchar2_table(5672) := '65617365286529262628742B3D31292C746869732E73686F756C644465637265617365286529262628742B3D32292C746869732E73686F756C64496E64656E744E6578744C696E65286529262628742B3D34292C746869732E73686F756C6449676E6F72';
wwv_flow_imp.g_varchar2_table(5673) := '65286529262628742B3D38292C747D7D636C617373206D707B636F6E7374727563746F722865297B28653D657C7C7B7D292E627261636B6574733D652E627261636B6574737C7C5B5B2228222C2229225D2C5B227B222C227D225D2C5B225B222C225D22';
wwv_flow_imp.g_varchar2_table(5674) := '5D5D2C746869732E5F627261636B6574733D5B5D2C652E627261636B6574732E666F72456163682828653D3E7B636F6E737420743D6D702E5F6372656174654F70656E427261636B657452656745787028655B305D292C6E3D6D702E5F63726561746543';
wwv_flow_imp.g_varchar2_table(5675) := '6C6F7365427261636B657452656745787028655B315D293B7426266E2626746869732E5F627261636B6574732E70757368287B6F70656E3A655B305D2C6F70656E5265674578703A742C636C6F73653A655B315D2C636C6F73655265674578703A6E7D29';
wwv_flow_imp.g_varchar2_table(5676) := '7D29292C746869732E5F72656745787052756C65733D652E6F6E456E74657252756C65737C7C5B5D7D6F6E456E74657228652C742C6E2C69297B696628653E3D3329666F72286C657420653D302C6F3D746869732E5F72656745787052756C65732E6C65';
wwv_flow_imp.g_varchar2_table(5677) := '6E6774683B653C6F3B652B2B297B636F6E7374206F3D746869732E5F72656745787052756C65735B655D3B6966285B7B7265673A6F2E6265666F7265546578742C746578743A6E7D2C7B7265673A6F2E6166746572546578742C746578743A697D2C7B72';
wwv_flow_imp.g_varchar2_table(5678) := '65673A6F2E70726576696F75734C696E65546578742C746578743A747D5D2E65766572792828653D3E21652E7265677C7C28652E7265672E6C617374496E6465783D302C652E7265672E7465737428652E74657874292929292972657475726E206F2E61';
wwv_flow_imp.g_varchar2_table(5679) := '6374696F6E7D696628653E3D3226266E2E6C656E6774683E302626692E6C656E6774683E3029666F72286C657420653D302C743D746869732E5F627261636B6574732E6C656E6774683B653C743B652B2B297B636F6E737420743D746869732E5F627261';
wwv_flow_imp.g_varchar2_table(5680) := '636B6574735B655D3B696628742E6F70656E5265674578702E74657374286E292626742E636C6F73655265674578702E746573742869292972657475726E7B696E64656E74416374696F6E3A50752E496E64656E744F757464656E747D7D696628653E3D';
wwv_flow_imp.g_varchar2_table(5681) := '3226266E2E6C656E6774683E3029666F72286C657420653D302C743D746869732E5F627261636B6574732E6C656E6774683B653C743B652B2B29696628746869732E5F627261636B6574735B655D2E6F70656E5265674578702E74657374286E29297265';
wwv_flow_imp.g_varchar2_table(5682) := '7475726E7B696E64656E74416374696F6E3A50752E496E64656E747D3B72657475726E206E756C6C7D737461746963205F6372656174654F70656E427261636B65745265674578702865297B6C657420743D63692865293B72657475726E2F5C422F2E74';
wwv_flow_imp.g_varchar2_table(5683) := '65737428742E636861724174283029297C7C28743D225C5C62222B74292C742B3D225C5C732A24222C6D702E5F736166655265674578702874297D737461746963205F637265617465436C6F7365427261636B65745265674578702865297B6C65742074';
wwv_flow_imp.g_varchar2_table(5684) := '3D63692865293B72657475726E2F5C422F2E7465737428742E63686172417428742E6C656E6774682D3129297C7C28742B3D225C5C6222292C743D225E5C5C732A222B742C6D702E5F736166655265674578702874297D737461746963205F7361666552';
wwv_flow_imp.g_varchar2_table(5685) := '65674578702865297B7472797B72657475726E206E6577205265674578702865297D63617463682865297B72657475726E206B652865292C6E756C6C7D7D7D636F6E73742066703D70632822636F6E66696775726174696F6E5365727669636522293B66';
wwv_flow_imp.g_varchar2_table(5686) := '756E6374696F6E20767028652C74297B636F6E7374206E3D4F626A6563742E637265617465286E756C6C293B666F7228636F6E7374206920696E2065296270286E2C692C655B695D2C74293B72657475726E206E7D66756E6374696F6E20627028652C74';
wwv_flow_imp.g_varchar2_table(5687) := '2C6E2C69297B636F6E7374206F3D742E73706C697428222E22292C733D6F2E706F7028293B6C657420723D653B666F72286C657420653D303B653C6F2E6C656E6774683B652B2B297B636F6E7374206E3D6F5B655D3B6C657420733D725B6E5D3B737769';
wwv_flow_imp.g_varchar2_table(5688) := '74636828747970656F662073297B6361736522756E646566696E6564223A733D725B6E5D3D4F626A6563742E637265617465286E756C6C293B627265616B3B63617365226F626A656374223A6966286E756C6C3D3D3D732972657475726E20766F696420';
wwv_flow_imp.g_varchar2_table(5689) := '69286049676E6F72696E6720247B747D20617320247B6F2E736C69636528302C652B31292E6A6F696E28222E22297D206973206E756C6C60293B627265616B3B64656661756C743A72657475726E20766F69642069286049676E6F72696E6720247B747D';
wwv_flow_imp.g_varchar2_table(5690) := '20617320247B6F2E736C69636528302C652B31292E6A6F696E28222E22297D20697320247B4A534F4E2E737472696E676966792873297D60297D723D737D696628226F626A656374223D3D747970656F66207226266E756C6C213D3D72297472797B725B';
wwv_flow_imp.g_varchar2_table(5691) := '735D3D6E7D63617463682865297B69286049676E6F72696E6720247B747D20617320247B6F2E6A6F696E28222E22297D20697320247B4A534F4E2E737472696E676966792872297D60297D656C73652069286049676E6F72696E6720247B747D20617320';
wwv_flow_imp.g_varchar2_table(5692) := '247B6F2E6A6F696E28222E22297D20697320247B4A534F4E2E737472696E676966792872297D60297D66756E6374696F6E205F7028652C74297B797028652C742E73706C697428222E2229297D66756E6374696F6E20797028652C74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(5693) := '6E3D742E736869667428293B69662830213D3D742E6C656E677468297B6966282D31213D3D4F626A6563742E6B6579732865292E696E6465784F66286E29297B636F6E737420693D655B6E5D3B226F626A65637422213D747970656F6620697C7C417272';
wwv_flow_imp.g_varchar2_table(5694) := '61792E697341727261792869297C7C28797028692C74292C303D3D3D4F626A6563742E6B6579732869292E6C656E677468262664656C65746520655B6E5D297D7D656C73652064656C65746520655B6E5D7D66756E6374696F6E20777028652C742C6E29';
wwv_flow_imp.g_varchar2_table(5695) := '7B636F6E737420693D66756E6374696F6E28652C74297B6C6574206E3D653B666F7228636F6E73742065206F662074297B696628226F626A65637422213D747970656F66206E7C7C6E756C6C3D3D3D6E2972657475726E3B6E3D6E5B655D7D7265747572';
wwv_flow_imp.g_varchar2_table(5696) := '6E206E7D28652C742E73706C697428222E2229293B72657475726E20766F696420303D3D3D693F6E3A697D636C6173732043707B636F6E7374727563746F7228652C743D5B5D2C6E3D2131297B746869732E63746F723D652C746869732E737461746963';
wwv_flow_imp.g_varchar2_table(5697) := '417267756D656E74733D742C746869732E737570706F72747344656C61796564496E7374616E74696174696F6E3D6E7D7D636F6E73742053703D5B5D3B66756E6374696F6E20787028652C742C6E297B7420696E7374616E63656F662043707C7C28743D';
wwv_flow_imp.g_varchar2_table(5698) := '6E657720437028742C5B5D2C426F6F6C65616E286E2929292C53702E70757368285B652C745D297D66756E6374696F6E206B7028297B72657475726E2053707D636F6E73742045703D4F626A6563742E667265657A65287B746578743A22746578742F70';
wwv_flow_imp.g_varchar2_table(5699) := '6C61696E222C62696E6172793A226170706C69636174696F6E2F6F637465742D73747265616D222C756E6B6E6F776E3A226170706C69636174696F6E2F756E6B6E6F776E222C6D61726B646F776E3A22746578742F6D61726B646F776E222C6C61746578';
wwv_flow_imp.g_varchar2_table(5700) := '3A22746578742F6C61746578222C7572694C6973743A22746578742F7572692D6C697374227D292C4C703D22626173652E636F6E747269627574696F6E732E6A736F6E222C44703D6E657720636C6173737B636F6E7374727563746F7228297B74686973';
wwv_flow_imp.g_varchar2_table(5701) := '2E5F6F6E4469644368616E6765536368656D613D6E65772043742C746869732E736368656D6173427949643D7B7D7D7265676973746572536368656D6128652C74297B766172206E3B746869732E736368656D6173427949645B286E3D652C6E2E6C656E';
wwv_flow_imp.g_varchar2_table(5702) := '6774683E3026262223223D3D3D6E2E636861724174286E2E6C656E6774682D31293F6E2E737562737472696E6728302C6E2E6C656E6774682D31293A6E295D3D742C746869732E5F6F6E4469644368616E6765536368656D612E666972652865297D6E6F';
wwv_flow_imp.g_varchar2_table(5703) := '74696679536368656D614368616E6765642865297B746869732E5F6F6E4469644368616E6765536368656D612E666972652865297D7D3B79642E616464284C702C4470293B636F6E73742054703D22626173652E636F6E747269627574696F6E732E636F';
wwv_flow_imp.g_varchar2_table(5704) := '6E66696775726174696F6E222C49703D7B70726F706572746965733A7B7D2C7061747465726E50726F706572746965733A7B7D7D2C4D703D7B70726F706572746965733A7B7D2C7061747465726E50726F706572746965733A7B7D7D2C41703D7B70726F';
wwv_flow_imp.g_varchar2_table(5705) := '706572746965733A7B7D2C7061747465726E50726F706572746965733A7B7D7D2C4E703D7B70726F706572746965733A7B7D2C7061747465726E50726F706572746965733A7B7D7D2C50703D7B70726F706572746965733A7B7D2C7061747465726E5072';
wwv_flow_imp.g_varchar2_table(5706) := '6F706572746965733A7B7D7D2C4F703D7B70726F706572746965733A7B7D2C7061747465726E50726F706572746965733A7B7D7D2C52703D227673636F64653A2F2F736368656D61732F73657474696E67732F7265736F757263654C616E677561676522';
wwv_flow_imp.g_varchar2_table(5707) := '2C46703D79642E6173284C70292C42703D225C5C5B285B5E5C5C5D5D2B295C5C5D222C56703D6E6577205265674578702842702C226722292C7A703D605E28247B42707D292B24602C48703D6E657720526567457870287A70293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5708) := '57702865297B636F6E737420743D5B5D3B69662848702E74657374286529297B6C6574206E3D56702E657865632865293B666F72283B6E756C6C3D3D6E3F766F696420303A6E2E6C656E6774683B297B636F6E737420693D6E5B315D2E7472696D28293B';
wwv_flow_imp.g_varchar2_table(5709) := '692626742E707573682869292C6E3D56702E657865632865297D7D72657475726E2071682874297D636F6E7374206A703D6E657720636C6173737B636F6E7374727563746F7228297B746869732E6F766572726964654964656E746966696572733D6E65';
wwv_flow_imp.g_varchar2_table(5710) := '77205365742C746869732E5F6F6E446964536368656D614368616E67653D6E65772043742C746869732E5F6F6E446964557064617465436F6E66696775726174696F6E3D6E65772043742C746869732E636F6E66696775726174696F6E44656661756C74';
wwv_flow_imp.g_varchar2_table(5711) := '734F76657272696465733D6E6577204D61702C746869732E64656661756C744C616E6775616765436F6E66696775726174696F6E4F76657272696465734E6F64653D7B69643A2264656661756C744F7665727269646573222C7469746C653A6228302C22';
wwv_flow_imp.g_varchar2_table(5712) := '44656661756C74204C616E677561676520436F6E66696775726174696F6E204F766572726964657322292C70726F706572746965733A7B7D7D2C746869732E636F6E66696775726174696F6E436F6E7472696275746F72733D5B746869732E6465666175';
wwv_flow_imp.g_varchar2_table(5713) := '6C744C616E6775616765436F6E66696775726174696F6E4F76657272696465734E6F64655D2C746869732E7265736F757263654C616E677561676553657474696E6773536368656D613D7B70726F706572746965733A7B7D2C7061747465726E50726F70';
wwv_flow_imp.g_varchar2_table(5714) := '6572746965733A7B7D2C6164646974696F6E616C50726F706572746965733A21302C616C6C6F77547261696C696E67436F6D6D61733A21302C616C6C6F77436F6D6D656E74733A21307D2C746869732E636F6E66696775726174696F6E50726F70657274';
wwv_flow_imp.g_varchar2_table(5715) := '6965733D7B7D2C746869732E706F6C696379436F6E66696775726174696F6E733D6E6577204D61702C746869732E6578636C75646564436F6E66696775726174696F6E50726F706572746965733D7B7D2C46702E7265676973746572536368656D612852';
wwv_flow_imp.g_varchar2_table(5716) := '702C746869732E7265736F757263654C616E677561676553657474696E6773536368656D61292C746869732E72656769737465724F7665727269646550726F70657274795061747465726E4B657928297D7265676973746572436F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(5717) := '6F6E28652C743D2130297B746869732E7265676973746572436F6E66696775726174696F6E73285B655D2C74297D7265676973746572436F6E66696775726174696F6E7328652C743D2130297B636F6E7374206E3D6E6577205365743B746869732E646F';
wwv_flow_imp.g_varchar2_table(5718) := '5265676973746572436F6E66696775726174696F6E7328652C742C6E292C46702E7265676973746572536368656D612852702C746869732E7265736F757263654C616E677561676553657474696E6773536368656D61292C746869732E5F6F6E44696453';
wwv_flow_imp.g_varchar2_table(5719) := '6368656D614368616E67652E6669726528292C746869732E5F6F6E446964557064617465436F6E66696775726174696F6E2E66697265287B70726F706572746965733A6E7D297D726567697374657244656661756C74436F6E66696775726174696F6E73';
wwv_flow_imp.g_varchar2_table(5720) := '2865297B636F6E737420743D6E6577205365743B746869732E646F526567697374657244656661756C74436F6E66696775726174696F6E7328652C74292C746869732E5F6F6E446964536368656D614368616E67652E6669726528292C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(5721) := '6E446964557064617465436F6E66696775726174696F6E2E66697265287B70726F706572746965733A742C64656661756C74734F76657272696465733A21307D297D646F526567697374657244656661756C74436F6E66696775726174696F6E7328652C';
wwv_flow_imp.g_varchar2_table(5722) := '74297B766172206E3B636F6E737420693D5B5D3B666F7228636F6E73747B6F76657272696465733A6F2C736F757263653A737D6F66206529666F7228636F6E7374206520696E206F29696628742E6164642865292C48702E74657374286529297B636F6E';
wwv_flow_imp.g_varchar2_table(5723) := '737420743D746869732E636F6E66696775726174696F6E44656661756C74734F76657272696465732E6765742865292C723D6E756C6C213D3D286E3D6E756C6C3D3D743F766F696420303A742E76616C756573536F7572636573292626766F6964203021';
wwv_flow_imp.g_varchar2_table(5724) := '3D3D6E3F6E3A6E6577204D61703B6966287329666F7228636F6E73742074206F66204F626A6563742E6B657973286F5B655D2929722E73657428742C73293B636F6E737420613D7B2E2E2E286E756C6C3D3D743F766F696420303A742E76616C7565297C';
wwv_flow_imp.g_varchar2_table(5725) := '7C7B7D2C2E2E2E6F5B655D7D3B746869732E636F6E66696775726174696F6E44656661756C74734F76657272696465732E73657428652C7B736F757263653A732C76616C75653A612C76616C756573536F75726365733A727D293B636F6E7374206C3D7B';
wwv_flow_imp.g_varchar2_table(5726) := '747970653A226F626A656374222C64656661756C743A612C6465736372697074696F6E3A6228302C22436F6E6669677572652073657474696E677320746F206265206F76657272696464656E20666F7220746865207B307D206C616E67756167652E222C';
wwv_flow_imp.g_varchar2_table(5727) := '652E7265706C616365282F5B5C5B5C5D5D2F672C222229292C247265663A52702C64656661756C7444656661756C7456616C75653A612C736F757263653A686C2873293F766F696420303A732C64656661756C7456616C7565536F757263653A737D3B69';
wwv_flow_imp.g_varchar2_table(5728) := '2E70757368282E2E2E5770286529292C746869732E636F6E66696775726174696F6E50726F706572746965735B655D3D6C2C746869732E64656661756C744C616E6775616765436F6E66696775726174696F6E4F76657272696465734E6F64652E70726F';
wwv_flow_imp.g_varchar2_table(5729) := '706572746965735B655D3D6C7D656C73657B746869732E636F6E66696775726174696F6E44656661756C74734F76657272696465732E73657428652C7B76616C75653A6F5B655D2C736F757263653A737D293B636F6E737420743D746869732E636F6E66';
wwv_flow_imp.g_varchar2_table(5730) := '696775726174696F6E50726F706572746965735B655D3B74262628746869732E75706461746550726F706572747944656661756C7456616C756528652C74292C746869732E757064617465536368656D6128652C7429297D746869732E646F5265676973';
wwv_flow_imp.g_varchar2_table(5731) := '7465724F766572726964654964656E746966696572732869297D72656769737465724F766572726964654964656E746966696572732865297B746869732E646F52656769737465724F766572726964654964656E746966696572732865292C746869732E';
wwv_flow_imp.g_varchar2_table(5732) := '5F6F6E446964536368656D614368616E67652E6669726528297D646F52656769737465724F766572726964654964656E746966696572732865297B666F7228636F6E73742074206F66206529746869732E6F766572726964654964656E74696669657273';
wwv_flow_imp.g_varchar2_table(5733) := '2E6164642874293B746869732E7570646174654F7665727269646550726F70657274795061747465726E4B657928297D646F5265676973746572436F6E66696775726174696F6E7328652C742C6E297B652E666F72456163682828653D3E7B746869732E';
wwv_flow_imp.g_varchar2_table(5734) := '76616C6964617465416E64526567697374657250726F7065727469657328652C742C652E657874656E73696F6E496E666F2C652E7265737472696374656450726F706572746965732C766F696420302C6E292C746869732E636F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(5735) := '6E436F6E7472696275746F72732E707573682865292C746869732E72656769737465724A534F4E436F6E66696775726174696F6E2865297D29297D76616C6964617465416E64526567697374657250726F7065727469657328652C743D21302C6E2C692C';
wwv_flow_imp.g_varchar2_table(5736) := '6F3D332C73297B76617220723B6F3D5F6C28652E73636F7065293F6F3A652E73636F70653B636F6E737420613D652E70726F706572746965733B6966286129666F7228636F6E7374206520696E2061297B636F6E7374206C3D615B655D3B742626717028';
wwv_flow_imp.g_varchar2_table(5737) := '652C6C293F64656C65746520615B655D3A286C2E736F757263653D6E2C6C2E64656661756C7444656661756C7456616C75653D615B655D2E64656661756C742C746869732E75706461746550726F706572747944656661756C7456616C756528652C6C29';
wwv_flow_imp.g_varchar2_table(5738) := '2C48702E746573742865293F6C2E73636F70653D766F696420303A286C2E73636F70653D5F6C286C2E73636F7065293F6F3A6C2E73636F70652C6C2E726573747269637465643D5F6C286C2E72657374726963746564293F2121286E756C6C3D3D693F76';
wwv_flow_imp.g_varchar2_table(5739) := '6F696420303A692E696E636C75646573286529293A6C2E72657374726963746564292C21615B655D2E6861734F776E50726F70657274792822696E636C7564656422297C7C615B655D2E696E636C756465643F28746869732E636F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(5740) := '6F6E50726F706572746965735B655D3D615B655D2C286E756C6C3D3D3D28723D615B655D2E706F6C696379297C7C766F696420303D3D3D723F766F696420303A722E6E616D65292626746869732E706F6C696379436F6E66696775726174696F6E732E73';
wwv_flow_imp.g_varchar2_table(5741) := '657428615B655D2E706F6C6963792E6E616D652C65292C21615B655D2E6465707265636174696F6E4D6573736167652626615B655D2E6D61726B646F776E4465707265636174696F6E4D657373616765262628615B655D2E6465707265636174696F6E4D';
wwv_flow_imp.g_varchar2_table(5742) := '6573736167653D615B655D2E6D61726B646F776E4465707265636174696F6E4D657373616765292C732E616464286529293A28746869732E6578636C75646564436F6E66696775726174696F6E50726F706572746965735B655D3D615B655D2C64656C65';
wwv_flow_imp.g_varchar2_table(5743) := '746520615B655D29297D636F6E7374206C3D652E616C6C4F663B6966286C29666F7228636F6E73742065206F66206C29746869732E76616C6964617465416E64526567697374657250726F7065727469657328652C742C6E2C692C6F2C73297D67657443';
wwv_flow_imp.g_varchar2_table(5744) := '6F6E66696775726174696F6E50726F7065727469657328297B72657475726E20746869732E636F6E66696775726174696F6E50726F706572746965737D676574506F6C696379436F6E66696775726174696F6E7328297B72657475726E20746869732E70';
wwv_flow_imp.g_varchar2_table(5745) := '6F6C696379436F6E66696775726174696F6E737D72656769737465724A534F4E436F6E66696775726174696F6E2865297B636F6E737420743D653D3E7B636F6E7374206E3D652E70726F706572746965733B6966286E29666F7228636F6E737420652069';
wwv_flow_imp.g_varchar2_table(5746) := '6E206E29746869732E757064617465536368656D6128652C6E5B655D293B636F6E737420693D652E616C6C4F663B6E756C6C3D3D697C7C692E666F72456163682874297D3B742865297D757064617465536368656D6128652C74297B7377697463682849';
wwv_flow_imp.g_varchar2_table(5747) := '702E70726F706572746965735B655D3D742C742E73636F7065297B6361736520313A4D702E70726F706572746965735B655D3D743B627265616B3B6361736520323A41702E70726F706572746965735B655D3D743B627265616B3B6361736520363A4E70';
wwv_flow_imp.g_varchar2_table(5748) := '2E70726F706572746965735B655D3D743B627265616B3B6361736520333A50702E70726F706572746965735B655D3D743B627265616B3B6361736520343A4F702E70726F706572746965735B655D3D743B627265616B3B6361736520353A4F702E70726F';
wwv_flow_imp.g_varchar2_table(5749) := '706572746965735B655D3D742C746869732E7265736F757263654C616E677561676553657474696E6773536368656D612E70726F706572746965735B655D3D747D7D7570646174654F7665727269646550726F70657274795061747465726E4B65792829';
wwv_flow_imp.g_varchar2_table(5750) := '7B666F7228636F6E73742065206F6620746869732E6F766572726964654964656E746966696572732E76616C7565732829297B636F6E737420743D605B247B657D5D602C6E3D7B747970653A226F626A656374222C6465736372697074696F6E3A622830';
wwv_flow_imp.g_varchar2_table(5751) := '2C22436F6E66696775726520656469746F722073657474696E677320746F206265206F76657272696464656E20666F722061206C616E67756167652E22292C6572726F724D6573736167653A6228302C22546869732073657474696E6720646F6573206E';
wwv_flow_imp.g_varchar2_table(5752) := '6F7420737570706F7274207065722D6C616E677561676520636F6E66696775726174696F6E2E22292C247265663A52707D3B746869732E75706461746550726F706572747944656661756C7456616C756528742C6E292C49702E70726F70657274696573';
wwv_flow_imp.g_varchar2_table(5753) := '5B745D3D6E2C4D702E70726F706572746965735B745D3D6E2C41702E70726F706572746965735B745D3D6E2C4E702E70726F706572746965735B745D3D6E2C50702E70726F706572746965735B745D3D6E2C4F702E70726F706572746965735B745D3D6E';
wwv_flow_imp.g_varchar2_table(5754) := '7D7D72656769737465724F7665727269646550726F70657274795061747465726E4B657928297B636F6E737420653D7B747970653A226F626A656374222C6465736372697074696F6E3A6228302C22436F6E66696775726520656469746F722073657474';
wwv_flow_imp.g_varchar2_table(5755) := '696E677320746F206265206F76657272696464656E20666F722061206C616E67756167652E22292C6572726F724D6573736167653A6228302C22546869732073657474696E6720646F6573206E6F7420737570706F7274207065722D6C616E6775616765';
wwv_flow_imp.g_varchar2_table(5756) := '20636F6E66696775726174696F6E2E22292C247265663A52707D3B49702E7061747465726E50726F706572746965735B7A705D3D652C4D702E7061747465726E50726F706572746965735B7A705D3D652C41702E7061747465726E50726F706572746965';
wwv_flow_imp.g_varchar2_table(5757) := '735B7A705D3D652C4E702E7061747465726E50726F706572746965735B7A705D3D652C50702E7061747465726E50726F706572746965735B7A705D3D652C4F702E7061747465726E50726F706572746965735B7A705D3D652C746869732E5F6F6E446964';
wwv_flow_imp.g_varchar2_table(5758) := '536368656D614368616E67652E6669726528297D75706461746550726F706572747944656661756C7456616C756528652C74297B636F6E7374206E3D746869732E636F6E66696775726174696F6E44656661756C74734F76657272696465732E67657428';
wwv_flow_imp.g_varchar2_table(5759) := '65293B6C657420693D6E756C6C3D3D6E3F766F696420303A6E2E76616C75652C6F3D6E756C6C3D3D6E3F766F696420303A6E2E736F757263653B766C286929262628693D742E64656661756C7444656661756C7456616C75652C6F3D766F69642030292C';
wwv_flow_imp.g_varchar2_table(5760) := '766C286929262628693D66756E6374696F6E2865297B7377697463682841727261792E697341727261792865293F655B305D3A65297B6361736522626F6F6C65616E223A72657475726E21313B6361736522696E7465676572223A63617365226E756D62';
wwv_flow_imp.g_varchar2_table(5761) := '6572223A72657475726E20303B6361736522737472696E67223A72657475726E22223B63617365226172726179223A72657475726E5B5D3B63617365226F626A656374223A72657475726E7B7D3B64656661756C743A72657475726E206E756C6C7D7D28';
wwv_flow_imp.g_varchar2_table(5762) := '742E7479706529292C742E64656661756C743D692C742E64656661756C7456616C7565536F757263653D6F7D7D3B66756E6374696F6E20717028652C74297B766172206E2C692C6F2C733B72657475726E20652E7472696D28293F48702E746573742865';
wwv_flow_imp.g_varchar2_table(5763) := '293F6228302C2243616E6E6F7420726567697374657220277B307D272E2054686973206D6174636865732070726F7065727479207061747465726E20275C5C5C5C5B2E2A5C5C5C5C5D242720666F722064657363726962696E67206C616E677561676520';
wwv_flow_imp.g_varchar2_table(5764) := '737065636966696320656469746F722073657474696E67732E205573652027636F6E66696775726174696F6E44656661756C74732720636F6E747269627574696F6E2E222C65293A766F69642030213D3D6A702E676574436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(5765) := '50726F7065727469657328295B655D3F6228302C2243616E6E6F7420726567697374657220277B307D272E20546869732070726F706572747920697320616C726561647920726567697374657265642E222C65293A286E756C6C3D3D3D286E3D742E706F';
wwv_flow_imp.g_varchar2_table(5766) := '6C696379297C7C766F696420303D3D3D6E3F766F696420303A6E2E6E616D65292626766F69642030213D3D6A702E676574506F6C696379436F6E66696775726174696F6E7328292E676574286E756C6C3D3D3D28693D742E706F6C696379297C7C766F69';
wwv_flow_imp.g_varchar2_table(5767) := '6420303D3D3D693F766F696420303A692E6E616D65293F6228302C2243616E6E6F7420726567697374657220277B307D272E20546865206173736F63696174656420706F6C696379207B317D20697320616C726561647920726567697374657265642077';
wwv_flow_imp.g_varchar2_table(5768) := '697468207B327D2E222C652C6E756C6C3D3D3D286F3D742E706F6C696379297C7C766F696420303D3D3D6F3F766F696420303A6F2E6E616D652C6A702E676574506F6C696379436F6E66696775726174696F6E7328292E676574286E756C6C3D3D3D2873';
wwv_flow_imp.g_varchar2_table(5769) := '3D742E706F6C696379297C7C766F696420303D3D3D733F766F696420303A732E6E616D6529293A6E756C6C3A6228302C2243616E6E6F7420726567697374657220616E20656D7074792070726F706572747922297D79642E6164642854702C6A70293B63';
wwv_flow_imp.g_varchar2_table(5770) := '6F6E73742024703D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F6F6E4469644368616E67654C616E6775616765733D6E65772043742C746869732E6F6E4469644368616E67654C616E6775616765733D746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(5771) := '4469644368616E67654C616E6775616765732E6576656E742C746869732E5F6C616E6775616765733D5B5D7D72656769737465724C616E67756167652865297B72657475726E20746869732E5F6C616E6775616765732E707573682865292C746869732E';
wwv_flow_imp.g_varchar2_table(5772) := '5F6F6E4469644368616E67654C616E6775616765732E6669726528766F69642030292C7B646973706F73653A28293D3E7B666F72286C657420743D302C6E3D746869732E5F6C616E6775616765732E6C656E6774683B743C6E3B742B2B29696628746869';
wwv_flow_imp.g_varchar2_table(5773) := '732E5F6C616E6775616765735B745D3D3D3D652972657475726E20766F696420746869732E5F6C616E6775616765732E73706C69636528742C31297D7D7D6765744C616E67756167657328297B72657475726E20746869732E5F6C616E6775616765737D';
wwv_flow_imp.g_varchar2_table(5774) := '7D3B79642E6164642822656469746F722E6D6F6465735265676973747279222C2470293B636F6E73742055703D22706C61696E74657874223B24702E72656769737465724C616E6775616765287B69643A55702C657874656E73696F6E733A5B222E7478';
wwv_flow_imp.g_varchar2_table(5775) := '74225D2C616C69617365733A5B6228302C22506C61696E205465787422292C2274657874225D2C6D696D6574797065733A5B45702E746578745D7D292C79642E6173285470292E726567697374657244656661756C74436F6E66696775726174696F6E73';
wwv_flow_imp.g_varchar2_table(5776) := '285B7B6F76657272696465733A7B225B706C61696E746578745D223A7B22656469746F722E756E69636F6465486967686C696768742E616D626967756F757343686172616374657273223A21312C22656469746F722E756E69636F6465486967686C6967';
wwv_flow_imp.g_varchar2_table(5777) := '68742E696E76697369626C6543686172616374657273223A21317D7D7D5D293B636C617373204B707B636F6E7374727563746F7228652C74297B746869732E6C616E677561676549643D653B636F6E7374206E3D742E627261636B6574733F477028742E';
wwv_flow_imp.g_varchar2_table(5778) := '627261636B657473293A5B5D2C693D6E6577206E692828653D3E7B636F6E737420743D6E6577205365743B72657475726E7B696E666F3A6E657720597028746869732C652C74292C636C6F73696E673A747D7D29292C6F3D6E6577206E692828653D3E7B';
wwv_flow_imp.g_varchar2_table(5779) := '636F6E737420743D6E6577205365742C6E3D6E6577205365743B72657475726E7B696E666F3A6E6577205A7028746869732C652C742C6E292C6F70656E696E673A742C6F70656E696E67436F6C6F72697A65643A6E7D7D29293B666F7228636F6E73745B';
wwv_flow_imp.g_varchar2_table(5780) := '652C745D6F66206E297B636F6E7374206E3D692E6765742865292C733D6F2E6765742874293B6E2E636C6F73696E672E61646428732E696E666F292C732E6F70656E696E672E616464286E2E696E666F297D636F6E737420733D742E636F6C6F72697A65';
wwv_flow_imp.g_varchar2_table(5781) := '64427261636B657450616972733F477028742E636F6C6F72697A6564427261636B65745061697273293A6E2E66696C7465722828653D3E2128223C223D3D3D655B305D2626223E223D3D3D655B315D2929293B666F7228636F6E73745B652C745D6F6620';
wwv_flow_imp.g_varchar2_table(5782) := '73297B636F6E7374206E3D692E6765742865292C733D6F2E6765742874293B6E2E636C6F73696E672E61646428732E696E666F292C732E6F70656E696E67436F6C6F72697A65642E616464286E2E696E666F292C732E6F70656E696E672E616464286E2E';
wwv_flow_imp.g_varchar2_table(5783) := '696E666F297D746869732E5F6F70656E696E67427261636B6574733D6E6577204D6170285B2E2E2E692E63616368656456616C7565735D2E6D61702828285B652C745D293D3E5B652C742E696E666F5D2929292C746869732E5F636C6F73696E67427261';
wwv_flow_imp.g_varchar2_table(5784) := '636B6574733D6E6577204D6170285B2E2E2E6F2E63616368656456616C7565735D2E6D61702828285B652C745D293D3E5B652C742E696E666F5D2929297D676574206F70656E696E67427261636B65747328297B72657475726E5B2E2E2E746869732E5F';
wwv_flow_imp.g_varchar2_table(5785) := '6F70656E696E67427261636B6574732E76616C75657328295D7D67657420636C6F73696E67427261636B65747328297B72657475726E5B2E2E2E746869732E5F636C6F73696E67427261636B6574732E76616C75657328295D7D6765744F70656E696E67';
wwv_flow_imp.g_varchar2_table(5786) := '427261636B6574496E666F2865297B72657475726E20746869732E5F6F70656E696E67427261636B6574732E6765742865297D676574436C6F73696E67427261636B6574496E666F2865297B72657475726E20746869732E5F636C6F73696E6742726163';
wwv_flow_imp.g_varchar2_table(5787) := '6B6574732E6765742865297D676574427261636B6574496E666F2865297B72657475726E20746869732E6765744F70656E696E67427261636B6574496E666F2865297C7C746869732E676574436C6F73696E67427261636B6574496E666F2865297D7D66';
wwv_flow_imp.g_varchar2_table(5788) := '756E6374696F6E2047702865297B72657475726E20652E66696C7465722828285B652C745D293D3E2222213D3D6526262222213D3D7429297D636C6173732051707B636F6E7374727563746F7228652C74297B746869732E636F6E6669673D652C746869';
wwv_flow_imp.g_varchar2_table(5789) := '732E627261636B6574546578743D747D676574206C616E6775616765496428297B72657475726E20746869732E636F6E6669672E6C616E677561676549647D7D636C61737320597020657874656E64732051707B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(5790) := '6E297B737570657228652C74292C746869732E6F70656E6564427261636B6574733D6E2C746869732E69734F70656E696E67427261636B65743D21307D7D636C617373205A7020657874656E64732051707B636F6E7374727563746F7228652C742C6E2C';
wwv_flow_imp.g_varchar2_table(5791) := '69297B737570657228652C74292C746869732E6F70656E696E67427261636B6574733D6E2C746869732E6F70656E696E67436F6C6F72697A6564427261636B6574733D692C746869732E69734F70656E696E67427261636B65743D21317D636C6F736573';
wwv_flow_imp.g_varchar2_table(5792) := '2865297B72657475726E20652E636F6E6669673D3D3D746869732E636F6E6669672626746869732E6F70656E696E67427261636B6574732E6861732865297D636C6F736573436F6C6F72697A65642865297B72657475726E20652E636F6E6669673D3D3D';
wwv_flow_imp.g_varchar2_table(5793) := '746869732E636F6E6669672626746869732E6F70656E696E67436F6C6F72697A6564427261636B6574732E6861732865297D6765744F70656E696E67427261636B65747328297B72657475726E5B2E2E2E746869732E6F70656E696E67427261636B6574';
wwv_flow_imp.g_varchar2_table(5794) := '735D7D7D7661722058703D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C617373204A707B636F6E7374727563746F722865297B746869732E6C616E677561676549643D657D61';
wwv_flow_imp.g_varchar2_table(5795) := '6666656374732865297B72657475726E21746869732E6C616E677561676549647C7C746869732E6C616E677561676549643D3D3D657D7D636F6E73742065673D706328226C616E6775616765436F6E66696775726174696F6E5365727669636522293B6C';
wwv_flow_imp.g_varchar2_table(5796) := '65742074673D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E636F6E66696775726174696F6E536572766963653D652C746869732E6C616E6775616765536572766963653D742C74';
wwv_flow_imp.g_varchar2_table(5797) := '6869732E5F72656769737472793D746869732E5F7265676973746572286E6577206467292C746869732E6F6E4469644368616E6765456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(5798) := '3D746869732E6F6E4469644368616E6765456D69747465722E6576656E742C746869732E636F6E66696775726174696F6E733D6E6577204D61703B636F6E7374206E3D6E657720536574284F626A6563742E76616C756573286E6729293B746869732E5F';
wwv_flow_imp.g_varchar2_table(5799) := '726567697374657228746869732E636F6E66696775726174696F6E536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B636F6E737420743D652E6368616E67652E6B6579732E736F6D652828653D3E6E2E6861';
wwv_flow_imp.g_varchar2_table(5800) := '7328652929292C693D652E6368616E67652E6F76657272696465732E66696C7465722828285B652C745D293D3E742E736F6D652828653D3E6E2E686173286529292929292E6D61702828285B655D293D3E6529293B6966287429746869732E636F6E6669';
wwv_flow_imp.g_varchar2_table(5801) := '6775726174696F6E732E636C65617228292C746869732E6F6E4469644368616E6765456D69747465722E66697265286E6577204A7028766F6964203029293B656C736520666F7228636F6E73742065206F66206929746869732E6C616E67756167655365';
wwv_flow_imp.g_varchar2_table(5802) := '72766963652E6973526567697374657265644C616E67756167654964286529262628746869732E636F6E66696775726174696F6E732E64656C6574652865292C746869732E6F6E4469644368616E6765456D69747465722E66697265286E6577204A7028';
wwv_flow_imp.g_varchar2_table(5803) := '652929297D2929292C746869732E5F726567697374657228746869732E5F72656769737472792E6F6E4469644368616E67652828653D3E7B746869732E636F6E66696775726174696F6E732E64656C65746528652E6C616E67756167654964292C746869';
wwv_flow_imp.g_varchar2_table(5804) := '732E6F6E4469644368616E6765456D69747465722E66697265286E6577204A7028652E6C616E6775616765496429297D2929297D726567697374657228652C742C6E297B72657475726E20746869732E5F72656769737472792E72656769737465722865';
wwv_flow_imp.g_varchar2_table(5805) := '2C742C6E297D6765744C616E6775616765436F6E66696775726174696F6E2865297B6C657420743D746869732E636F6E66696775726174696F6E732E6765742865293B72657475726E20747C7C28743D66756E6374696F6E28652C742C6E2C69297B6C65';
wwv_flow_imp.g_varchar2_table(5806) := '74206F3D742E6765744C616E6775616765436F6E66696775726174696F6E2865293B696628216F297B69662821692E6973526567697374657265644C616E677561676549642865292972657475726E206E657720686728652C7B7D293B6F3D6E65772068';
wwv_flow_imp.g_varchar2_table(5807) := '6728652C7B7D297D636F6E737420733D66756E6374696F6E28652C74297B636F6E7374206E3D742E67657456616C7565286E672E627261636B6574732C7B6F766572726964654964656E7469666965723A657D292C693D742E67657456616C7565286E67';
wwv_flow_imp.g_varchar2_table(5808) := '2E636F6C6F72697A6564427261636B657450616972732C7B6F766572726964654964656E7469666965723A657D293B72657475726E7B627261636B6574733A6967286E292C636F6C6F72697A6564427261636B657450616972733A69672869297D7D286F';
wwv_flow_imp.g_varchar2_table(5809) := '2E6C616E677561676549642C6E292C723D6167285B6F2E756E6465726C79696E67436F6E6669672C735D293B72657475726E206E6577206867286F2E6C616E677561676549642C72297D28652C746869732E5F72656769737472792C746869732E636F6E';
wwv_flow_imp.g_varchar2_table(5810) := '66696775726174696F6E536572766963652C746869732E6C616E677561676553657276696365292C746869732E636F6E66696775726174696F6E732E73657428652C7429292C747D7D3B74673D66756E6374696F6E28652C742C6E2C69297B766172206F';
wwv_flow_imp.g_varchar2_table(5811) := '2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265';
wwv_flow_imp.g_varchar2_table(5812) := '666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D';
wwv_flow_imp.g_varchar2_table(5813) := '303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D';
wwv_flow_imp.g_varchar2_table(5814) := '285B587028302C6670292C587028312C4C75295D2C7467293B636F6E7374206E673D7B627261636B6574733A22656469746F722E6C616E67756167652E627261636B657473222C636F6C6F72697A6564427261636B657450616972733A22656469746F72';
wwv_flow_imp.g_varchar2_table(5815) := '2E6C616E67756167652E636F6C6F72697A6564427261636B65745061697273227D3B66756E6374696F6E2069672865297B69662841727261792E697341727261792865292972657475726E20652E6D61702828653D3E7B69662841727261792E69734172';
wwv_flow_imp.g_varchar2_table(5816) := '7261792865292626323D3D3D652E6C656E6774682972657475726E5B655B305D2C655B315D5D7D29292E66696C7465722828653D3E21216529297D66756E6374696F6E206F6728652C742C6E297B6C657420693D666928652E6765744C696E65436F6E74';
wwv_flow_imp.g_varchar2_table(5817) := '656E74287429293B72657475726E20692E6C656E6774683E6E2D31262628693D692E737562737472696E6728302C6E2D3129292C697D66756E6374696F6E20736728652C742C6E297B72657475726E20652E746F6B656E697A6174696F6E2E666F726365';
wwv_flow_imp.g_varchar2_table(5818) := '546F6B656E697A6174696F6E2874292C427528652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732874292C766F696420303D3D3D6E3F652E6765744C696E654D6178436F6C756D6E2874292D313A6E2D31297D636C6173732072677B';
wwv_flow_imp.g_varchar2_table(5819) := '636F6E7374727563746F722865297B746869732E6C616E677561676549643D652C746869732E5F7265736F6C7665643D6E756C6C2C746869732E5F656E74726965733D5B5D2C746869732E5F6F726465723D302C746869732E5F7265736F6C7665643D6E';
wwv_flow_imp.g_varchar2_table(5820) := '756C6C7D726567697374657228652C74297B636F6E7374206E3D6E6577206C6728652C742C2B2B746869732E5F6F72646572293B72657475726E20746869732E5F656E74726965732E70757368286E292C746869732E5F7265736F6C7665643D6E756C6C';
wwv_flow_imp.g_varchar2_table(5821) := '2C7274282828293D3E7B666F72286C657420653D303B653C746869732E5F656E74726965732E6C656E6774683B652B2B29696628746869732E5F656E74726965735B655D3D3D3D6E297B746869732E5F656E74726965732E73706C69636528652C31292C';
wwv_flow_imp.g_varchar2_table(5822) := '746869732E5F7265736F6C7665643D6E756C6C3B627265616B7D7D29297D6765745265736F6C766564436F6E66696775726174696F6E28297B69662821746869732E5F7265736F6C766564297B636F6E737420653D746869732E5F7265736F6C76652829';
wwv_flow_imp.g_varchar2_table(5823) := '3B65262628746869732E5F7265736F6C7665643D6E657720686728746869732E6C616E677561676549642C6529297D72657475726E20746869732E5F7265736F6C7665647D5F7265736F6C766528297B72657475726E20303D3D3D746869732E5F656E74';
wwv_flow_imp.g_varchar2_table(5824) := '726965732E6C656E6774683F6E756C6C3A28746869732E5F656E74726965732E736F7274286C672E636D70292C616728746869732E5F656E74726965732E6D61702828653D3E652E636F6E66696775726174696F6E292929297D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5825) := '61672865297B6C657420743D7B636F6D6D656E74733A766F696420302C627261636B6574733A766F696420302C776F72645061747465726E3A766F696420302C696E64656E746174696F6E52756C65733A766F696420302C6F6E456E74657252756C6573';
wwv_flow_imp.g_varchar2_table(5826) := '3A766F696420302C6175746F436C6F73696E6750616972733A766F696420302C737572726F756E64696E6750616972733A766F696420302C6175746F436C6F73654265666F72653A766F696420302C666F6C64696E673A766F696420302C636F6C6F7269';
wwv_flow_imp.g_varchar2_table(5827) := '7A6564427261636B657450616972733A766F696420302C5F5F656C656374726963436861726163746572537570706F72743A766F696420307D3B666F7228636F6E7374206E206F66206529743D7B636F6D6D656E74733A6E2E636F6D6D656E74737C7C74';
wwv_flow_imp.g_varchar2_table(5828) := '2E636F6D6D656E74732C627261636B6574733A6E2E627261636B6574737C7C742E627261636B6574732C776F72645061747465726E3A6E2E776F72645061747465726E7C7C742E776F72645061747465726E2C696E64656E746174696F6E52756C65733A';
wwv_flow_imp.g_varchar2_table(5829) := '6E2E696E64656E746174696F6E52756C65737C7C742E696E64656E746174696F6E52756C65732C6F6E456E74657252756C65733A6E2E6F6E456E74657252756C65737C7C742E6F6E456E74657252756C65732C6175746F436C6F73696E6750616972733A';
wwv_flow_imp.g_varchar2_table(5830) := '6E2E6175746F436C6F73696E6750616972737C7C742E6175746F436C6F73696E6750616972732C737572726F756E64696E6750616972733A6E2E737572726F756E64696E6750616972737C7C742E737572726F756E64696E6750616972732C6175746F43';
wwv_flow_imp.g_varchar2_table(5831) := '6C6F73654265666F72653A6E2E6175746F436C6F73654265666F72657C7C742E6175746F436C6F73654265666F72652C666F6C64696E673A6E2E666F6C64696E677C7C742E666F6C64696E672C636F6C6F72697A6564427261636B657450616972733A6E';
wwv_flow_imp.g_varchar2_table(5832) := '2E636F6C6F72697A6564427261636B657450616972737C7C742E636F6C6F72697A6564427261636B657450616972732C5F5F656C656374726963436861726163746572537570706F72743A6E2E5F5F656C65637472696343686172616374657253757070';
wwv_flow_imp.g_varchar2_table(5833) := '6F72747C7C742E5F5F656C656374726963436861726163746572537570706F72747D3B72657475726E20747D636C617373206C677B636F6E7374727563746F7228652C742C6E297B746869732E636F6E66696775726174696F6E3D652C746869732E7072';
wwv_flow_imp.g_varchar2_table(5834) := '696F726974793D742C746869732E6F726465723D6E7D73746174696320636D7028652C74297B72657475726E20652E7072696F726974793D3D3D742E7072696F726974793F652E6F726465722D742E6F726465723A652E7072696F726974792D742E7072';
wwv_flow_imp.g_varchar2_table(5835) := '696F726974797D7D636C6173732063677B636F6E7374727563746F722865297B746869732E6C616E677561676549643D657D7D636C61737320646720657874656E6473206C747B636F6E7374727563746F7228297B737570657228292C746869732E5F65';
wwv_flow_imp.g_varchar2_table(5836) := '6E74726965733D6E6577204D61702C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869';
wwv_flow_imp.g_varchar2_table(5837) := '732E5F726567697374657228746869732E72656769737465722855702C7B627261636B6574733A5B5B2228222C2229225D2C5B225B222C225D225D2C5B227B222C227D225D5D2C737572726F756E64696E6750616972733A5B7B6F70656E3A227B222C63';
wwv_flow_imp.g_varchar2_table(5838) := '6C6F73653A227D227D2C7B6F70656E3A225B222C636C6F73653A225D227D2C7B6F70656E3A2228222C636C6F73653A2229227D2C7B6F70656E3A223C222C636C6F73653A223E227D2C7B6F70656E3A2722272C636C6F73653A2722277D2C7B6F70656E3A';
wwv_flow_imp.g_varchar2_table(5839) := '2227222C636C6F73653A2227227D2C7B6F70656E3A2260222C636C6F73653A2260227D5D2C636F6C6F72697A6564427261636B657450616972733A5B5D2C666F6C64696E673A7B6F6666536964653A21307D7D2C3029297D726567697374657228652C74';
wwv_flow_imp.g_varchar2_table(5840) := '2C6E3D30297B6C657420693D746869732E5F656E74726965732E6765742865293B697C7C28693D6E65772072672865292C746869732E5F656E74726965732E73657428652C6929293B636F6E7374206F3D692E726567697374657228742C6E293B726574';
wwv_flow_imp.g_varchar2_table(5841) := '75726E20746869732E5F6F6E4469644368616E67652E66697265286E6577206367286529292C7274282828293D3E7B6F2E646973706F736528292C746869732E5F6F6E4469644368616E67652E66697265286E6577206367286529297D29297D6765744C';
wwv_flow_imp.g_varchar2_table(5842) := '616E6775616765436F6E66696775726174696F6E2865297B636F6E737420743D746869732E5F656E74726965732E6765742865293B72657475726E286E756C6C3D3D743F766F696420303A742E6765745265736F6C766564436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(5843) := '6E2829297C7C6E756C6C7D7D636C6173732068677B636F6E7374727563746F7228652C74297B746869732E6C616E677561676549643D652C746869732E756E6465726C79696E67436F6E6669673D742C746869732E5F627261636B6574733D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(5844) := '746869732E5F656C6563747269634368617261637465723D6E756C6C2C746869732E5F6F6E456E746572537570706F72743D746869732E756E6465726C79696E67436F6E6669672E627261636B6574737C7C746869732E756E6465726C79696E67436F6E';
wwv_flow_imp.g_varchar2_table(5845) := '6669672E696E64656E746174696F6E52756C65737C7C746869732E756E6465726C79696E67436F6E6669672E6F6E456E74657252756C65733F6E6577206D7028746869732E756E6465726C79696E67436F6E666967293A6E756C6C2C746869732E636F6D';
wwv_flow_imp.g_varchar2_table(5846) := '6D656E74733D68672E5F68616E646C65436F6D6D656E747328746869732E756E6465726C79696E67436F6E666967292C746869732E636861726163746572506169723D6E657720487528746869732E756E6465726C79696E67436F6E666967292C746869';
wwv_flow_imp.g_varchar2_table(5847) := '732E776F7264446566696E6974696F6E3D746869732E756E6465726C79696E67436F6E6669672E776F72645061747465726E7C7C54752C746869732E696E64656E746174696F6E52756C65733D746869732E756E6465726C79696E67436F6E6669672E69';
wwv_flow_imp.g_varchar2_table(5848) := '6E64656E746174696F6E52756C65732C746869732E756E6465726C79696E67436F6E6669672E696E64656E746174696F6E52756C65733F746869732E696E64656E7452756C6573537570706F72743D6E657720677028746869732E756E6465726C79696E';
wwv_flow_imp.g_varchar2_table(5849) := '67436F6E6669672E696E64656E746174696F6E52756C6573293A746869732E696E64656E7452756C6573537570706F72743D6E756C6C2C746869732E666F6C64696E6752756C65733D746869732E756E6465726C79696E67436F6E6669672E666F6C6469';
wwv_flow_imp.g_varchar2_table(5850) := '6E677C7C7B7D2C746869732E627261636B6574734E65773D6E6577204B7028652C746869732E756E6465726C79696E67436F6E666967297D676574576F7264446566696E6974696F6E28297B72657475726E20497528746869732E776F7264446566696E';
wwv_flow_imp.g_varchar2_table(5851) := '6974696F6E297D67657420627261636B65747328297B72657475726E21746869732E5F627261636B6574732626746869732E756E6465726C79696E67436F6E6669672E627261636B657473262628746869732E5F627261636B6574733D6E6577206F7028';
wwv_flow_imp.g_varchar2_table(5852) := '746869732E6C616E677561676549642C746869732E756E6465726C79696E67436F6E6669672E627261636B65747329292C746869732E5F627261636B6574737D67657420656C65637472696343686172616374657228297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(5853) := '5F656C6563747269634368617261637465727C7C28746869732E5F656C6563747269634368617261637465723D6E657720757028746869732E627261636B65747329292C746869732E5F656C6563747269634368617261637465727D6F6E456E74657228';
wwv_flow_imp.g_varchar2_table(5854) := '652C742C6E2C69297B72657475726E20746869732E5F6F6E456E746572537570706F72743F746869732E5F6F6E456E746572537570706F72742E6F6E456E74657228652C742C6E2C69293A6E756C6C7D6765744175746F436C6F73696E67506169727328';
wwv_flow_imp.g_varchar2_table(5855) := '297B72657475726E206E657720527528746869732E636861726163746572506169722E6765744175746F436C6F73696E6750616972732829297D6765744175746F436C6F73654265666F72655365742865297B72657475726E20746869732E6368617261';
wwv_flow_imp.g_varchar2_table(5856) := '63746572506169722E6765744175746F436C6F73654265666F72655365742865297D676574537572726F756E64696E67506169727328297B72657475726E20746869732E636861726163746572506169722E676574537572726F756E64696E6750616972';
wwv_flow_imp.g_varchar2_table(5857) := '7328297D737461746963205F68616E646C65436F6D6D656E74732865297B636F6E737420743D652E636F6D6D656E74733B69662821742972657475726E206E756C6C3B636F6E7374206E3D7B7D3B696628742E6C696E65436F6D6D656E742626286E2E6C';
wwv_flow_imp.g_varchar2_table(5858) := '696E65436F6D6D656E74546F6B656E3D742E6C696E65436F6D6D656E74292C742E626C6F636B436F6D6D656E74297B636F6E73745B652C695D3D742E626C6F636B436F6D6D656E743B6E2E626C6F636B436F6D6D656E745374617274546F6B656E3D652C';
wwv_flow_imp.g_varchar2_table(5859) := '6E2E626C6F636B436F6D6D656E74456E64546F6B656E3D697D72657475726E206E7D7D78702865672C74672C31293B636C6173732075677B636F6E7374727563746F7228652C742C6E2C69297B746869732E72616E67653D652C746869732E6E65737469';
wwv_flow_imp.g_varchar2_table(5860) := '6E674C6576656C3D742C746869732E6E657374696E674C6576656C4F66457175616C427261636B6574547970653D6E2C746869732E6973496E76616C69643D697D7D636C6173732070677B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B';
wwv_flow_imp.g_varchar2_table(5861) := '746869732E72616E67653D652C746869732E6F70656E696E67427261636B657452616E67653D742C746869732E636C6F73696E67427261636B657452616E67653D6E2C746869732E6E657374696E674C6576656C3D692C746869732E6E657374696E674C';
wwv_flow_imp.g_varchar2_table(5862) := '6576656C4F66457175616C427261636B6574547970653D6F2C746869732E627261636B6574506169724E6F64653D737D676574206F70656E696E67427261636B6574496E666F28297B72657475726E20746869732E627261636B6574506169724E6F6465';
wwv_flow_imp.g_varchar2_table(5863) := '2E6F70656E696E67427261636B65742E627261636B6574496E666F7D7D636C61737320676720657874656E64732070677B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228652C742C6E2C692C6F2C73292C746869732E';
wwv_flow_imp.g_varchar2_table(5864) := '6D696E56697369626C65436F6C756D6E496E64656E746174696F6E3D727D7D636C617373206D677B737461746963206265747765656E506F736974696F6E7328652C74297B72657475726E20652E6C696E654E756D6265723D3D3D742E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(5865) := '6265723F6E6577206D6728302C742E636F6C756D6E2D652E636F6C756D6E293A6E6577206D6728742E6C696E654E756D6265722D652E6C696E654E756D6265722C742E636F6C756D6E2D31297D737461746963206F6652616E67652865297B7265747572';
wwv_flow_imp.g_varchar2_table(5866) := '6E206D672E6265747765656E506F736974696F6E7328652E6765745374617274506F736974696F6E28292C652E676574456E64506F736974696F6E2829297D737461746963206F66546578742865297B6C657420743D302C6E3D303B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(5867) := '742069206F66206529225C6E223D3D3D693F28742B2B2C6E3D30293A6E2B2B3B72657475726E206E6577206D6728742C6E297D636F6E7374727563746F7228652C74297B746869732E6C696E65436F756E743D652C746869732E636F6C756D6E436F756E';
wwv_flow_imp.g_varchar2_table(5868) := '743D747D6973477265617465725468616E4F72457175616C546F2865297B72657475726E20746869732E6C696E65436F756E74213D3D652E6C696E65436F756E743F746869732E6C696E65436F756E743E652E6C696E65436F756E743A746869732E636F';
wwv_flow_imp.g_varchar2_table(5869) := '6C756D6E436F756E743E3D652E636F6C756D6E436F756E747D63726561746552616E67652865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E';
wwv_flow_imp.g_varchar2_table(5870) := '654E756D6265722C652E636F6C756D6E2B746869732E636F6C756D6E436F756E74293A6E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C';
wwv_flow_imp.g_varchar2_table(5871) := '756D6E436F756E742B31297D616464546F506F736974696F6E2865297B72657475726E20303D3D3D746869732E6C696E65436F756E743F6E6577206D6328652E6C696E654E756D6265722C652E636F6C756D6E2B746869732E636F6C756D6E436F756E74';
wwv_flow_imp.g_varchar2_table(5872) := '293A6E6577206D6328652E6C696E654E756D6265722B746869732E6C696E65436F756E742C746869732E636F6C756D6E436F756E742B31297D746F537472696E6728297B72657475726E60247B746869732E6C696E65436F756E747D2C247B746869732E';
wwv_flow_imp.g_varchar2_table(5873) := '636F6C756D6E436F756E747D607D7D6D672E7A65726F3D6E6577206D6728302C30293B636F6E73742066673D303B66756E6374696F6E2076672865297B72657475726E20303D3D3D657D636F6E73742062673D322A2A32363B66756E6374696F6E205F67';
wwv_flow_imp.g_varchar2_table(5874) := '28652C74297B72657475726E20652A62672B747D66756E6374696F6E2079672865297B636F6E737420743D652C6E3D4D6174682E666C6F6F7228742F6267293B72657475726E206E6577206D67286E2C742D6E2A6267297D66756E6374696F6E20776728';
wwv_flow_imp.g_varchar2_table(5875) := '652C74297B6C6574206E3D652B743B72657475726E20743E3D62672626286E2D3D65256267292C6E7D66756E6374696F6E20436728652C74297B72657475726E20652E726564756365282828652C6E293D3E776728652C74286E2929292C6667297D6675';
wwv_flow_imp.g_varchar2_table(5876) := '6E6374696F6E20536728652C74297B72657475726E20653D3D3D747D66756E6374696F6E20786728652C74297B636F6E7374206E3D652C693D743B696628692D6E3C3D302972657475726E2066673B636F6E7374206F3D4D6174682E666C6F6F72286E2F';
wwv_flow_imp.g_varchar2_table(5877) := '6267292C733D4D6174682E666C6F6F7228692F6267292C723D692D732A62673B72657475726E206F3D3D3D733F5F6728302C722D286E2D6F2A626729293A5F6728732D6F2C72297D66756E6374696F6E206B6728652C74297B72657475726E20653C747D';
wwv_flow_imp.g_varchar2_table(5878) := '66756E6374696F6E20456728652C74297B72657475726E20653C3D747D66756E6374696F6E204C6728652C74297B72657475726E20653E3D747D66756E6374696F6E2044672865297B72657475726E205F6728652E6C696E654E756D6265722D312C652E';
wwv_flow_imp.g_varchar2_table(5879) := '636F6C756D6E2D31297D66756E6374696F6E20546728652C74297B636F6E7374206E3D652C693D4D6174682E666C6F6F72286E2F6267292C6F3D6E2D692A62672C733D742C723D4D6174682E666C6F6F7228732F6267293B72657475726E206E65772072';
wwv_flow_imp.g_varchar2_table(5880) := '6828692B312C6F2B312C722B312C732D722A62672B31297D636C6173732049677B7374617469632066726F6D4D6F64656C436F6E74656E744368616E6765732865297B636F6E737420743D652E6D61702828653D3E7B636F6E737420743D72682E6C6966';
wwv_flow_imp.g_varchar2_table(5881) := '7428652E72616E6765293B72657475726E206E657720496728446728742E6765745374617274506F736974696F6E2829292C446728742E676574456E64506F736974696F6E2829292C66756E6374696F6E2865297B636F6E737420743D67692865293B72';
wwv_flow_imp.g_varchar2_table(5882) := '657475726E205F6728742E6C656E6774682D312C745B742E6C656E6774682D315D2E6C656E677468297D28652E7465787429297D29292E7265766572736528293B72657475726E20747D636F6E7374727563746F7228652C742C6E297B746869732E7374';
wwv_flow_imp.g_varchar2_table(5883) := '6172744F66667365743D652C746869732E656E644F66667365743D742C746869732E6E65774C656E6774683D6E7D746F537472696E6728297B72657475726E605B247B796728746869732E73746172744F6666736574297D2E2E2E247B79672874686973';
wwv_flow_imp.g_varchar2_table(5884) := '2E656E644F6666736574297D29202D3E20247B796728746869732E6E65774C656E677468297D607D7D636C617373204D677B636F6E7374727563746F722865297B746869732E6E657874456469744964783D302C746869732E64656C74614F6C64546F4E';
wwv_flow_imp.g_varchar2_table(5885) := '65774C696E65436F756E743D302C746869732E64656C74614F6C64546F4E6577436F6C756D6E436F756E743D302C746869732E64656C74614C696E65496478496E4F6C643D2D312C746869732E65646974733D652E6D61702828653D3E41672E66726F6D';
wwv_flow_imp.g_varchar2_table(5886) := '28652929297D6765744F66667365744265666F72654368616E67652865297B72657475726E20746869732E61646A7573744E657874456469742865292C746869732E7472616E736C617465437572546F4F6C642865297D67657444697374616E6365546F';
wwv_flow_imp.g_varchar2_table(5887) := '4E6578744368616E67652865297B746869732E61646A7573744E657874456469742865293B636F6E737420743D746869732E65646974735B746869732E6E657874456469744964785D2C6E3D743F746869732E7472616E736C6174654F6C64546F437572';
wwv_flow_imp.g_varchar2_table(5888) := '28742E6F66667365744F626A293A6E756C6C3B72657475726E206E756C6C3D3D3D6E3F6E756C6C3A786728652C6E297D7472616E736C6174654F6C64546F4375722865297B72657475726E20652E6C696E65436F756E743D3D3D746869732E64656C7461';
wwv_flow_imp.g_varchar2_table(5889) := '4C696E65496478496E4F6C643F5F6728652E6C696E65436F756E742B746869732E64656C74614F6C64546F4E65774C696E65436F756E742C652E636F6C756D6E436F756E742B746869732E64656C74614F6C64546F4E6577436F6C756D6E436F756E7429';
wwv_flow_imp.g_varchar2_table(5890) := '3A5F6728652E6C696E65436F756E742B746869732E64656C74614F6C64546F4E65774C696E65436F756E742C652E636F6C756D6E436F756E74297D7472616E736C617465437572546F4F6C642865297B636F6E737420743D79672865293B72657475726E';
wwv_flow_imp.g_varchar2_table(5891) := '20742E6C696E65436F756E742D746869732E64656C74614F6C64546F4E65774C696E65436F756E743D3D3D746869732E64656C74614C696E65496478496E4F6C643F5F6728742E6C696E65436F756E742D746869732E64656C74614F6C64546F4E65774C';
wwv_flow_imp.g_varchar2_table(5892) := '696E65436F756E742C742E636F6C756D6E436F756E742D746869732E64656C74614F6C64546F4E6577436F6C756D6E436F756E74293A5F6728742E6C696E65436F756E742D746869732E64656C74614F6C64546F4E65774C696E65436F756E742C742E63';
wwv_flow_imp.g_varchar2_table(5893) := '6F6C756D6E436F756E74297D61646A7573744E657874456469742865297B666F72283B746869732E6E657874456469744964783C746869732E65646974732E6C656E6774683B297B636F6E737420743D746869732E65646974735B746869732E6E657874';
wwv_flow_imp.g_varchar2_table(5894) := '456469744964785D2C6E3D746869732E7472616E736C6174654F6C64546F43757228742E656E644F666673657441667465724F626A293B696628214567286E2C652929627265616B3B7B746869732E6E657874456469744964782B2B3B636F6E73742065';
wwv_flow_imp.g_varchar2_table(5895) := '3D7967286E292C693D796728746869732E7472616E736C6174654F6C64546F43757228742E656E644F66667365744265666F72654F626A29292C6F3D652E6C696E65436F756E742D692E6C696E65436F756E743B746869732E64656C74614F6C64546F4E';
wwv_flow_imp.g_varchar2_table(5896) := '65774C696E65436F756E742B3D6F3B636F6E737420733D746869732E64656C74614C696E65496478496E4F6C643D3D3D742E656E644F66667365744265666F72654F626A2E6C696E65436F756E743F746869732E64656C74614F6C64546F4E6577436F6C';
wwv_flow_imp.g_varchar2_table(5897) := '756D6E436F756E743A302C723D652E636F6C756D6E436F756E742D692E636F6C756D6E436F756E743B746869732E64656C74614F6C64546F4E6577436F6C756D6E436F756E743D732B722C746869732E64656C74614C696E65496478496E4F6C643D742E';
wwv_flow_imp.g_varchar2_table(5898) := '656E644F66667365744265666F72654F626A2E6C696E65436F756E747D7D7D7D636C6173732041677B7374617469632066726F6D2865297B72657475726E206E657720416728652E73746172744F66667365742C652E656E644F66667365742C652E6E65';
wwv_flow_imp.g_varchar2_table(5899) := '774C656E677468297D636F6E7374727563746F7228652C742C6E297B746869732E656E644F66667365744265666F72654F626A3D79672874292C746869732E656E644F666673657441667465724F626A3D796728776728652C6E29292C746869732E6F66';
wwv_flow_imp.g_varchar2_table(5900) := '667365744F626A3D79672865297D7D636F6E7374204E673D5B5D3B636C6173732050677B7374617469632063726561746528652C74297B696628653C3D3132382626303D3D3D742E6C656E677468297B6C6574206E3D50672E63616368655B655D3B7265';
wwv_flow_imp.g_varchar2_table(5901) := '7475726E206E7C7C286E3D6E657720506728652C74292C50672E63616368655B655D3D6E292C6E7D72657475726E206E657720506728652C74297D73746174696320676574456D70747928297B72657475726E20746869732E656D7074797D636F6E7374';
wwv_flow_imp.g_varchar2_table(5902) := '727563746F7228652C74297B746869732E6974656D733D652C746869732E6164646974696F6E616C4974656D733D747D61646428652C74297B636F6E7374206E3D742E6765744B65792865293B6C657420693D6E3E3E353B696628303D3D3D69297B636F';
wwv_flow_imp.g_varchar2_table(5903) := '6E737420653D313C3C6E7C746869732E6974656D733B72657475726E20653D3D3D746869732E6974656D733F746869733A50672E63726561746528652C746869732E6164646974696F6E616C4974656D73297D692D2D3B636F6E7374206F3D746869732E';
wwv_flow_imp.g_varchar2_table(5904) := '6164646974696F6E616C4974656D732E736C6963652830293B666F72283B6F2E6C656E6774683C693B296F2E707573682830293B72657475726E206F5B695D7C3D313C3C283331266E292C50672E63726561746528746869732E6974656D732C6F297D6D';
wwv_flow_imp.g_varchar2_table(5905) := '657267652865297B636F6E737420743D746869732E6974656D737C652E6974656D733B696628746869732E6164646974696F6E616C4974656D733D3D3D4E672626652E6164646974696F6E616C4974656D733D3D3D4E672972657475726E20743D3D3D74';
wwv_flow_imp.g_varchar2_table(5906) := '6869732E6974656D733F746869733A743D3D3D652E6974656D733F653A50672E63726561746528742C4E67293B636F6E7374206E3D5B5D3B666F72286C657420743D303B743C4D6174682E6D617828746869732E6164646974696F6E616C4974656D732E';
wwv_flow_imp.g_varchar2_table(5907) := '6C656E6774682C652E6164646974696F6E616C4974656D732E6C656E677468293B742B2B297B636F6E737420693D746869732E6164646974696F6E616C4974656D735B745D7C7C302C6F3D652E6164646974696F6E616C4974656D735B745D7C7C303B6E';
wwv_flow_imp.g_varchar2_table(5908) := '2E7075736828697C6F297D72657475726E2050672E63726561746528742C6E297D696E74657273656374732865297B696628746869732E6974656D7326652E6974656D732972657475726E21303B666F72286C657420743D303B743C4D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(5909) := '28746869732E6164646974696F6E616C4974656D732E6C656E6774682C652E6164646974696F6E616C4974656D732E6C656E677468293B742B2B29696628746869732E6164646974696F6E616C4974656D735B745D26652E6164646974696F6E616C4974';
wwv_flow_imp.g_varchar2_table(5910) := '656D735B745D2972657475726E21303B72657475726E21317D7D50672E63616368653D6E657720417272617928313239292C50672E656D7074793D50672E63726561746528302C4E67293B636F6E7374204F673D7B6765744B65793A653D3E657D3B636C';
wwv_flow_imp.g_varchar2_table(5911) := '6173732052677B636F6E7374727563746F7228297B746869732E6974656D733D6E6577204D61707D6765744B65792865297B6C657420743D746869732E6974656D732E6765742865293B72657475726E20766F696420303D3D3D74262628743D74686973';
wwv_flow_imp.g_varchar2_table(5912) := '2E6974656D732E73697A652C746869732E6974656D732E73657428652C7429292C747D7D636C6173732046677B676574206C656E67746828297B72657475726E20746869732E5F6C656E6774687D636F6E7374727563746F722865297B746869732E5F6C';
wwv_flow_imp.g_varchar2_table(5913) := '656E6774683D657D7D636C61737320426720657874656E64732046677B7374617469632063726561746528652C742C6E297B6C657420693D652E6C656E6774683B72657475726E2074262628693D776728692C742E6C656E67746829292C6E262628693D';
wwv_flow_imp.g_varchar2_table(5914) := '776728692C6E2E6C656E67746829292C6E657720426728692C652C742C6E2C743F742E6D697373696E674F70656E696E67427261636B65744964733A50672E676574456D7074792829297D676574206B696E6428297B72657475726E20327D676574206C';
wwv_flow_imp.g_varchar2_table(5915) := '69737448656967687428297B72657475726E20307D676574206368696C6472656E4C656E67746828297B72657475726E20337D6765744368696C642865297B7377697463682865297B6361736520303A72657475726E20746869732E6F70656E696E6742';
wwv_flow_imp.g_varchar2_table(5916) := '7261636B65743B6361736520313A72657475726E20746869732E6368696C643B6361736520323A72657475726E20746869732E636C6F73696E67427261636B65747D7468726F77206E6577204572726F722822496E76616C6964206368696C6420696E64';
wwv_flow_imp.g_varchar2_table(5917) := '657822297D676574206368696C6472656E28297B636F6E737420653D5B5D3B72657475726E20652E7075736828746869732E6F70656E696E67427261636B6574292C746869732E6368696C642626652E7075736828746869732E6368696C64292C746869';
wwv_flow_imp.g_varchar2_table(5918) := '732E636C6F73696E67427261636B65742626652E7075736828746869732E636C6F73696E67427261636B6574292C657D636F6E7374727563746F7228652C742C6E2C692C6F297B73757065722865292C746869732E6F70656E696E67427261636B65743D';
wwv_flow_imp.g_varchar2_table(5919) := '742C746869732E6368696C643D6E2C746869732E636C6F73696E67427261636B65743D692C746869732E6D697373696E674F70656E696E67427261636B65744964733D6F7D63616E42655265757365642865297B72657475726E206E756C6C213D3D7468';
wwv_flow_imp.g_varchar2_table(5920) := '69732E636C6F73696E67427261636B6574262621652E696E746572736563747328746869732E6D697373696E674F70656E696E67427261636B6574496473297D64656570436C6F6E6528297B72657475726E206E657720426728746869732E6C656E6774';
wwv_flow_imp.g_varchar2_table(5921) := '682C746869732E6F70656E696E67427261636B65742E64656570436C6F6E6528292C746869732E6368696C642626746869732E6368696C642E64656570436C6F6E6528292C746869732E636C6F73696E67427261636B65742626746869732E636C6F7369';
wwv_flow_imp.g_varchar2_table(5922) := '6E67427261636B65742E64656570436C6F6E6528292C746869732E6D697373696E674F70656E696E67427261636B6574496473297D636F6D707574654D696E496E64656E746174696F6E28652C74297B72657475726E20746869732E6368696C643F7468';
wwv_flow_imp.g_varchar2_table(5923) := '69732E6368696C642E636F6D707574654D696E496E64656E746174696F6E28776728652C746869732E6F70656E696E67427261636B65742E6C656E677468292C74293A4E756D6265722E4D41585F534146455F494E54454745527D7D636C617373205667';
wwv_flow_imp.g_varchar2_table(5924) := '20657874656E64732046677B73746174696320637265617465323328652C742C6E2C693D2131297B6C6574206F3D652E6C656E6774682C733D652E6D697373696E674F70656E696E67427261636B65744964733B696628652E6C69737448656967687421';
wwv_flow_imp.g_varchar2_table(5925) := '3D3D742E6C697374486569676874297468726F77206E6577204572726F722822496E76616C6964206C697374206865696768747322293B6966286F3D7767286F2C742E6C656E677468292C733D732E6D6572676528742E6D697373696E674F70656E696E';
wwv_flow_imp.g_varchar2_table(5926) := '67427261636B6574496473292C6E297B696628652E6C697374486569676874213D3D6E2E6C697374486569676874297468726F77206E6577204572726F722822496E76616C6964206C697374206865696768747322293B6F3D7767286F2C6E2E6C656E67';
wwv_flow_imp.g_varchar2_table(5927) := '7468292C733D732E6D65726765286E2E6D697373696E674F70656E696E67427261636B6574496473297D72657475726E20693F6E6577204867286F2C652E6C6973744865696768742B312C652C742C6E2C73293A6E6577207A67286F2C652E6C69737448';
wwv_flow_imp.g_varchar2_table(5928) := '65696768742B312C652C742C6E2C73297D73746174696320676574456D70747928297B72657475726E206E6577206A672866672C302C5B5D2C50672E676574456D7074792829297D676574206B696E6428297B72657475726E20347D676574206D697373';
wwv_flow_imp.g_varchar2_table(5929) := '696E674F70656E696E67427261636B657449647328297B72657475726E20746869732E5F6D697373696E674F70656E696E67427261636B65744964737D636F6E7374727563746F7228652C742C6E297B73757065722865292C746869732E6C6973744865';
wwv_flow_imp.g_varchar2_table(5930) := '696768743D742C746869732E5F6D697373696E674F70656E696E67427261636B65744964733D6E2C746869732E6361636865644D696E496E64656E746174696F6E3D2D317D7468726F774966496D6D757461626C6528297B7D6D616B654C617374456C65';
wwv_flow_imp.g_varchar2_table(5931) := '6D656E744D757461626C6528297B746869732E7468726F774966496D6D757461626C6528293B636F6E737420653D746869732E6368696C6472656E4C656E6774683B696628303D3D3D652972657475726E3B636F6E737420743D746869732E6765744368';
wwv_flow_imp.g_varchar2_table(5932) := '696C6428652D31292C6E3D343D3D3D742E6B696E643F742E746F4D757461626C6528293A743B72657475726E2074213D3D6E2626746869732E7365744368696C6428652D312C6E292C6E7D6D616B654669727374456C656D656E744D757461626C652829';
wwv_flow_imp.g_varchar2_table(5933) := '7B696628746869732E7468726F774966496D6D757461626C6528292C303D3D3D746869732E6368696C6472656E4C656E6774682972657475726E3B636F6E737420653D746869732E6765744368696C642830292C743D343D3D3D652E6B696E643F652E74';
wwv_flow_imp.g_varchar2_table(5934) := '6F4D757461626C6528293A653B72657475726E2065213D3D742626746869732E7365744368696C6428302C74292C747D63616E42655265757365642865297B696628652E696E746572736563747328746869732E6D697373696E674F70656E696E674272';
wwv_flow_imp.g_varchar2_table(5935) := '61636B6574496473292972657475726E21313B696628303D3D3D746869732E6368696C6472656E4C656E6774682972657475726E21313B6C657420743D746869733B666F72283B343D3D3D742E6B696E643B297B636F6E737420653D742E6368696C6472';
wwv_flow_imp.g_varchar2_table(5936) := '656E4C656E6774683B696628303D3D3D65297468726F77206E6577204F653B743D742E6765744368696C6428652D31297D72657475726E20742E63616E42655265757365642865297D68616E646C654368696C6472656E4368616E67656428297B746869';
wwv_flow_imp.g_varchar2_table(5937) := '732E7468726F774966496D6D757461626C6528293B636F6E737420653D746869732E6368696C6472656E4C656E6774683B6C657420743D746869732E6765744368696C642830292E6C656E6774682C6E3D746869732E6765744368696C642830292E6D69';
wwv_flow_imp.g_varchar2_table(5938) := '7373696E674F70656E696E67427261636B65744964733B666F72286C657420693D313B693C653B692B2B297B636F6E737420653D746869732E6765744368696C642869293B743D776728742C652E6C656E677468292C6E3D6E2E6D6572676528652E6D69';
wwv_flow_imp.g_varchar2_table(5939) := '7373696E674F70656E696E67427261636B6574496473297D746869732E5F6C656E6774683D742C746869732E5F6D697373696E674F70656E696E67427261636B65744964733D6E2C746869732E6361636865644D696E496E64656E746174696F6E3D2D31';
wwv_flow_imp.g_varchar2_table(5940) := '7D636F6D707574654D696E496E64656E746174696F6E28652C74297B6966282D31213D3D746869732E6361636865644D696E496E64656E746174696F6E2972657475726E20746869732E6361636865644D696E496E64656E746174696F6E3B6C6574206E';
wwv_flow_imp.g_varchar2_table(5941) := '3D4E756D6265722E4D41585F534146455F494E54454745522C693D653B666F72286C657420653D303B653C746869732E6368696C6472656E4C656E6774683B652B2B297B636F6E7374206F3D746869732E6765744368696C642865293B6F2626286E3D4D';
wwv_flow_imp.g_varchar2_table(5942) := '6174682E6D696E286E2C6F2E636F6D707574654D696E496E64656E746174696F6E28692C7429292C693D776728692C6F2E6C656E67746829297D72657475726E20746869732E6361636865644D696E496E64656E746174696F6E3D6E2C6E7D7D636C6173';
wwv_flow_imp.g_varchar2_table(5943) := '73207A6720657874656E64732056677B676574206368696C6472656E4C656E67746828297B72657475726E206E756C6C213D3D746869732E5F6974656D333F333A327D6765744368696C642865297B7377697463682865297B6361736520303A72657475';
wwv_flow_imp.g_varchar2_table(5944) := '726E20746869732E5F6974656D313B6361736520313A72657475726E20746869732E5F6974656D323B6361736520323A72657475726E20746869732E5F6974656D337D7468726F77206E6577204572726F722822496E76616C6964206368696C6420696E';
wwv_flow_imp.g_varchar2_table(5945) := '64657822297D7365744368696C6428652C74297B7377697463682865297B6361736520303A72657475726E20766F696428746869732E5F6974656D313D74293B6361736520313A72657475726E20766F696428746869732E5F6974656D323D74293B6361';
wwv_flow_imp.g_varchar2_table(5946) := '736520323A72657475726E20766F696428746869732E5F6974656D333D74297D7468726F77206E6577204572726F722822496E76616C6964206368696C6420696E64657822297D676574206368696C6472656E28297B72657475726E20746869732E5F69';
wwv_flow_imp.g_varchar2_table(5947) := '74656D333F5B746869732E5F6974656D312C746869732E5F6974656D322C746869732E5F6974656D335D3A5B746869732E5F6974656D312C746869732E5F6974656D325D7D676574206974656D3128297B72657475726E20746869732E5F6974656D317D';
wwv_flow_imp.g_varchar2_table(5948) := '676574206974656D3228297B72657475726E20746869732E5F6974656D327D676574206974656D3328297B72657475726E20746869732E5F6974656D337D636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228652C742C73292C';
wwv_flow_imp.g_varchar2_table(5949) := '746869732E5F6974656D313D6E2C746869732E5F6974656D323D692C746869732E5F6974656D333D6F7D64656570436C6F6E6528297B72657475726E206E6577207A6728746869732E6C656E6774682C746869732E6C6973744865696768742C74686973';
wwv_flow_imp.g_varchar2_table(5950) := '2E5F6974656D312E64656570436C6F6E6528292C746869732E5F6974656D322E64656570436C6F6E6528292C746869732E5F6974656D333F746869732E5F6974656D332E64656570436C6F6E6528293A6E756C6C2C746869732E6D697373696E674F7065';
wwv_flow_imp.g_varchar2_table(5951) := '6E696E67427261636B6574496473297D617070656E644368696C644F6653616D654865696768742865297B696628746869732E5F6974656D33297468726F77206E6577204572726F72282243616E6E6F7420617070656E6420746F20612066756C6C2028';
wwv_flow_imp.g_varchar2_table(5952) := '322C33292074726565206E6F646522293B746869732E7468726F774966496D6D757461626C6528292C746869732E5F6974656D333D652C746869732E68616E646C654368696C6472656E4368616E67656428297D756E617070656E644368696C6428297B';
wwv_flow_imp.g_varchar2_table(5953) := '69662821746869732E5F6974656D33297468726F77206E6577204572726F72282243616E6E6F742072656D6F76652066726F6D2061206E6F6E2D66756C6C2028322C33292074726565206E6F646522293B746869732E7468726F774966496D6D75746162';
wwv_flow_imp.g_varchar2_table(5954) := '6C6528293B636F6E737420653D746869732E5F6974656D333B72657475726E20746869732E5F6974656D333D6E756C6C2C746869732E68616E646C654368696C6472656E4368616E67656428292C657D70726570656E644368696C644F6653616D654865';
wwv_flow_imp.g_varchar2_table(5955) := '696768742865297B696628746869732E5F6974656D33297468726F77206E6577204572726F72282243616E6E6F742070726570656E6420746F20612066756C6C2028322C33292074726565206E6F646522293B746869732E7468726F774966496D6D7574';
wwv_flow_imp.g_varchar2_table(5956) := '61626C6528292C746869732E5F6974656D333D746869732E5F6974656D322C746869732E5F6974656D323D746869732E5F6974656D312C746869732E5F6974656D313D652C746869732E68616E646C654368696C6472656E4368616E67656428297D756E';
wwv_flow_imp.g_varchar2_table(5957) := '70726570656E644368696C6428297B69662821746869732E5F6974656D33297468726F77206E6577204572726F72282243616E6E6F742072656D6F76652066726F6D2061206E6F6E2D66756C6C2028322C33292074726565206E6F646522293B74686973';
wwv_flow_imp.g_varchar2_table(5958) := '2E7468726F774966496D6D757461626C6528293B636F6E737420653D746869732E5F6974656D313B72657475726E20746869732E5F6974656D313D746869732E5F6974656D322C746869732E5F6974656D323D746869732E5F6974656D332C746869732E';
wwv_flow_imp.g_varchar2_table(5959) := '5F6974656D333D6E756C6C2C746869732E68616E646C654368696C6472656E4368616E67656428292C657D746F4D757461626C6528297B72657475726E20746869737D7D636C61737320486720657874656E6473207A677B746F4D757461626C6528297B';
wwv_flow_imp.g_varchar2_table(5960) := '72657475726E206E6577207A6728746869732E6C656E6774682C746869732E6C6973744865696768742C746869732E6974656D312C746869732E6974656D322C746869732E6974656D332C746869732E6D697373696E674F70656E696E67427261636B65';
wwv_flow_imp.g_varchar2_table(5961) := '74496473297D7468726F774966496D6D757461626C6528297B7468726F77206E6577204572726F7228227468697320696E7374616E636520697320696D6D757461626C6522297D7D636C61737320576720657874656E64732056677B676574206368696C';
wwv_flow_imp.g_varchar2_table(5962) := '6472656E4C656E67746828297B72657475726E20746869732E5F6368696C6472656E2E6C656E6774687D6765744368696C642865297B72657475726E20746869732E5F6368696C6472656E5B655D7D7365744368696C6428652C74297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(5963) := '68696C6472656E5B655D3D747D676574206368696C6472656E28297B72657475726E20746869732E5F6368696C6472656E7D636F6E7374727563746F7228652C742C6E2C69297B737570657228652C742C69292C746869732E5F6368696C6472656E3D6E';
wwv_flow_imp.g_varchar2_table(5964) := '7D64656570436C6F6E6528297B636F6E737420653D6E657720417272617928746869732E5F6368696C6472656E2E6C656E677468293B666F72286C657420743D303B743C746869732E5F6368696C6472656E2E6C656E6774683B742B2B29655B745D3D74';
wwv_flow_imp.g_varchar2_table(5965) := '6869732E5F6368696C6472656E5B745D2E64656570436C6F6E6528293B72657475726E206E657720576728746869732E6C656E6774682C746869732E6C6973744865696768742C652C746869732E6D697373696E674F70656E696E67427261636B657449';
wwv_flow_imp.g_varchar2_table(5966) := '6473297D617070656E644368696C644F6653616D654865696768742865297B746869732E7468726F774966496D6D757461626C6528292C746869732E5F6368696C6472656E2E707573682865292C746869732E68616E646C654368696C6472656E436861';
wwv_flow_imp.g_varchar2_table(5967) := '6E67656428297D756E617070656E644368696C6428297B746869732E7468726F774966496D6D757461626C6528293B636F6E737420653D746869732E5F6368696C6472656E2E706F7028293B72657475726E20746869732E68616E646C654368696C6472';
wwv_flow_imp.g_varchar2_table(5968) := '656E4368616E67656428292C657D70726570656E644368696C644F6653616D654865696768742865297B746869732E7468726F774966496D6D757461626C6528292C746869732E5F6368696C6472656E2E756E73686966742865292C746869732E68616E';
wwv_flow_imp.g_varchar2_table(5969) := '646C654368696C6472656E4368616E67656428297D756E70726570656E644368696C6428297B746869732E7468726F774966496D6D757461626C6528293B636F6E737420653D746869732E5F6368696C6472656E2E736869667428293B72657475726E20';
wwv_flow_imp.g_varchar2_table(5970) := '746869732E68616E646C654368696C6472656E4368616E67656428292C657D746F4D757461626C6528297B72657475726E20746869737D7D636C617373206A6720657874656E64732057677B746F4D757461626C6528297B72657475726E206E65772057';
wwv_flow_imp.g_varchar2_table(5971) := '6728746869732E6C656E6774682C746869732E6C6973744865696768742C5B2E2E2E746869732E6368696C6472656E5D2C746869732E6D697373696E674F70656E696E67427261636B6574496473297D7468726F774966496D6D757461626C6528297B74';
wwv_flow_imp.g_varchar2_table(5972) := '68726F77206E6577204572726F7228227468697320696E7374616E636520697320696D6D757461626C6522297D7D636F6E73742071673D5B5D3B636C61737320246720657874656E64732046677B676574206C69737448656967687428297B7265747572';
wwv_flow_imp.g_varchar2_table(5973) := '6E20307D676574206368696C6472656E4C656E67746828297B72657475726E20307D6765744368696C642865297B72657475726E206E756C6C7D676574206368696C6472656E28297B72657475726E2071677D64656570436C6F6E6528297B7265747572';
wwv_flow_imp.g_varchar2_table(5974) := '6E20746869737D7D636C61737320556720657874656E64732024677B676574206B696E6428297B72657475726E20307D676574206D697373696E674F70656E696E67427261636B657449647328297B72657475726E2050672E676574456D70747928297D';
wwv_flow_imp.g_varchar2_table(5975) := '63616E42655265757365642865297B72657475726E21307D636F6D707574654D696E496E64656E746174696F6E28652C74297B636F6E7374206E3D79672865292C693D28303D3D3D6E2E636F6C756D6E436F756E743F6E2E6C696E65436F756E743A6E2E';
wwv_flow_imp.g_varchar2_table(5976) := '6C696E65436F756E742B31292B312C6F3D28733D776728652C746869732E6C656E677468292C4D6174682E666C6F6F7228732F6267292B31293B76617220733B6C657420723D4E756D6265722E4D41585F534146455F494E54454745523B666F72286C65';
wwv_flow_imp.g_varchar2_table(5977) := '7420653D693B653C3D6F3B652B2B297B636F6E7374206E3D742E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2865292C693D742E6765744C696E65436F6E74656E742865293B696628303D3D3D6E29636F6E74696E7565';
wwv_flow_imp.g_varchar2_table(5978) := '3B636F6E7374206F3D70752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28692C6E2C742E6765744F7074696F6E7328292E74616253697A65293B723D4D6174682E6D696E28722C6F297D72657475726E20727D7D636C617373204B672065';
wwv_flow_imp.g_varchar2_table(5979) := '7874656E64732024677B7374617469632063726561746528652C742C6E297B72657475726E206E6577204B6728652C742C6E297D676574206B696E6428297B72657475726E20317D676574206D697373696E674F70656E696E67427261636B6574496473';
wwv_flow_imp.g_varchar2_table(5980) := '28297B72657475726E2050672E676574456D70747928297D636F6E7374727563746F7228652C742C6E297B73757065722865292C746869732E627261636B6574496E666F3D742C746869732E627261636B65744964733D6E7D676574207465787428297B';
wwv_flow_imp.g_varchar2_table(5981) := '72657475726E20746869732E627261636B6574496E666F2E627261636B6574546578747D676574206C616E6775616765496428297B72657475726E20746869732E627261636B6574496E666F2E6C616E677561676549647D63616E426552657573656428';
wwv_flow_imp.g_varchar2_table(5982) := '65297B72657475726E21317D636F6D707574654D696E496E64656E746174696F6E28652C74297B72657475726E204E756D6265722E4D41585F534146455F494E54454745527D7D636C61737320476720657874656E64732024677B676574206B696E6428';
wwv_flow_imp.g_varchar2_table(5983) := '297B72657475726E20337D636F6E7374727563746F7228652C74297B73757065722874292C746869732E6D697373696E674F70656E696E67427261636B65744964733D657D63616E42655265757365642865297B72657475726E21652E696E7465727365';
wwv_flow_imp.g_varchar2_table(5984) := '63747328746869732E6D697373696E674F70656E696E67427261636B6574496473297D636F6D707574654D696E496E64656E746174696F6E28652C74297B72657475726E204E756D6265722E4D41585F534146455F494E54454745527D7D636C61737320';
wwv_flow_imp.g_varchar2_table(5985) := '51677B737461746963206765744C616E677561676549642865297B72657475726E283235352665293E3E3E307D73746174696320676574546F6B656E547970652865297B72657475726E283736382665293E3E3E387D73746174696320636F6E7461696E';
wwv_flow_imp.g_varchar2_table(5986) := '7342616C616E636564427261636B6574732865297B72657475726E212128313032342665297D73746174696320676574466F6E745374796C652865297B72657475726E2833303732302665293E3E3E31317D73746174696320676574466F726567726F75';
wwv_flow_imp.g_varchar2_table(5987) := '6E642865297B72657475726E2831363734343434382665293E3E3E31357D737461746963206765744261636B67726F756E642865297B72657475726E28343237383139303038302665293E3E3E32347D73746174696320676574436C6173734E616D6546';
wwv_flow_imp.g_varchar2_table(5988) := '726F6D4D657461646174612865297B6C657420743D226D746B222B746869732E676574466F726567726F756E642865293B636F6E7374206E3D746869732E676574466F6E745374796C652865293B72657475726E2031266E262628742B3D22206D746B69';
wwv_flow_imp.g_varchar2_table(5989) := '22292C32266E262628742B3D22206D746B6222292C34266E262628742B3D22206D746B7522292C38266E262628742B3D22206D746B7322292C747D73746174696320676574496E6C696E655374796C6546726F6D4D6574616461746128652C74297B636F';
wwv_flow_imp.g_varchar2_table(5990) := '6E7374206E3D746869732E676574466F726567726F756E642865292C693D746869732E676574466F6E745374796C652865293B6C6574206F3D60636F6C6F723A20247B745B6E5D7D3B603B3126692626286F2B3D22666F6E742D7374796C653A20697461';
wwv_flow_imp.g_varchar2_table(5991) := '6C69633B22292C3226692626286F2B3D22666F6E742D7765696768743A20626F6C643B22293B6C657420733D22223B72657475726E20342669262628732B3D2220756E6465726C696E6522292C382669262628732B3D22206C696E652D7468726F756768';
wwv_flow_imp.g_varchar2_table(5992) := '22292C732626286F2B3D60746578742D6465636F726174696F6E3A247B737D3B60292C6F7D7374617469632067657450726573656E746174696F6E46726F6D4D657461646174612865297B636F6E737420743D746869732E676574466F726567726F756E';
wwv_flow_imp.g_varchar2_table(5993) := '642865292C6E3D746869732E676574466F6E745374796C652865293B72657475726E7B666F726567726F756E643A742C6974616C69633A426F6F6C65616E2831266E292C626F6C643A426F6F6C65616E2832266E292C756E6465726C696E653A426F6F6C';
wwv_flow_imp.g_varchar2_table(5994) := '65616E2834266E292C737472696B657468726F7567683A426F6F6C65616E2838266E297D7D7D636C6173732059677B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6C656E6774683D652C746869732E6B696E643D742C74686973';
wwv_flow_imp.g_varchar2_table(5995) := '2E627261636B657449643D6E2C746869732E627261636B65744964733D692C746869732E6173744E6F64653D6F7D7D636C617373205A677B636F6E7374727563746F7228652C74297B746869732E746578744D6F64656C3D652C746869732E627261636B';
wwv_flow_imp.g_varchar2_table(5996) := '6574546F6B656E733D742C746869732E7265616465723D6E657720586728746869732E746578744D6F64656C2C746869732E627261636B6574546F6B656E73292C746869732E5F6F66667365743D66672C746869732E6469645065656B3D21312C746869';
wwv_flow_imp.g_varchar2_table(5997) := '732E7065656B65643D6E756C6C2C746869732E746578744275666665724C696E65436F756E743D652E6765744C696E65436F756E7428292C746869732E746578744275666665724C6173744C696E654C656E6774683D652E6765744C696E654C656E6774';
wwv_flow_imp.g_varchar2_table(5998) := '6828746869732E746578744275666665724C696E65436F756E74297D676574206F666673657428297B72657475726E20746869732E5F6F66667365747D676574206C656E67746828297B72657475726E205F6728746869732E746578744275666665724C';
wwv_flow_imp.g_varchar2_table(5999) := '696E65436F756E742D312C746869732E746578744275666665724C6173744C696E654C656E677468297D736B69702865297B746869732E6469645065656B3D21312C746869732E5F6F66667365743D776728746869732E5F6F66667365742C65293B636F';
wwv_flow_imp.g_varchar2_table(6000) := '6E737420743D796728746869732E5F6F6666736574293B746869732E7265616465722E736574506F736974696F6E28742E6C696E65436F756E742C742E636F6C756D6E436F756E74297D7265616428297B6C657420653B72657475726E20746869732E70';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(6001) := '65656B65643F28746869732E6469645065656B3D21312C653D746869732E7065656B6564293A653D746869732E7265616465722E7265616428292C65262628746869732E5F6F66667365743D776728746869732E5F6F66667365742C652E6C656E677468';
wwv_flow_imp.g_varchar2_table(6002) := '29292C657D7065656B28297B72657475726E20746869732E6469645065656B7C7C28746869732E7065656B65643D746869732E7265616465722E7265616428292C746869732E6469645065656B3D2130292C746869732E7065656B65647D7D636C617373';
wwv_flow_imp.g_varchar2_table(6003) := '2058677B636F6E7374727563746F7228652C74297B746869732E746578744D6F64656C3D652C746869732E627261636B6574546F6B656E733D742C746869732E6C696E654964783D302C746869732E6C696E653D6E756C6C2C746869732E6C696E654368';
wwv_flow_imp.g_varchar2_table(6004) := '61724F66667365743D302C746869732E6C696E65546F6B656E733D6E756C6C2C746869732E6C696E65546F6B656E4F66667365743D302C746869732E7065656B6564546F6B656E3D6E756C6C2C746869732E746578744275666665724C696E65436F756E';
wwv_flow_imp.g_varchar2_table(6005) := '743D652E6765744C696E65436F756E7428292C746869732E746578744275666665724C6173744C696E654C656E6774683D652E6765744C696E654C656E67746828746869732E746578744275666665724C696E65436F756E74297D736574506F73697469';
wwv_flow_imp.g_varchar2_table(6006) := '6F6E28652C74297B653D3D3D746869732E6C696E654964783F28746869732E6C696E65436861724F66667365743D742C6E756C6C213D3D746869732E6C696E65262628746869732E6C696E65546F6B656E4F66667365743D303D3D3D746869732E6C696E';
wwv_flow_imp.g_varchar2_table(6007) := '65436861724F66667365743F303A746869732E6C696E65546F6B656E732E66696E64546F6B656E496E64657841744F666673657428746869732E6C696E65436861724F66667365742929293A28746869732E6C696E654964783D652C746869732E6C696E';
wwv_flow_imp.g_varchar2_table(6008) := '65436861724F66667365743D742C746869732E6C696E653D6E756C6C292C746869732E7065656B6564546F6B656E3D6E756C6C7D7265616428297B696628746869732E7065656B6564546F6B656E297B636F6E737420653D746869732E7065656B656454';
wwv_flow_imp.g_varchar2_table(6009) := '6F6B656E3B72657475726E20746869732E7065656B6564546F6B656E3D6E756C6C2C746869732E6C696E65436861724F66667365742B3D652E6C656E6774682C657D696628746869732E6C696E654964783E746869732E746578744275666665724C696E';
wwv_flow_imp.g_varchar2_table(6010) := '65436F756E742D317C7C746869732E6C696E654964783D3D3D746869732E746578744275666665724C696E65436F756E742D312626746869732E6C696E65436861724F66667365743E3D746869732E746578744275666665724C6173744C696E654C656E';
wwv_flow_imp.g_varchar2_table(6011) := '6774682972657475726E206E756C6C3B6E756C6C3D3D3D746869732E6C696E65262628746869732E6C696E65546F6B656E733D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E7328746869732E6C69';
wwv_flow_imp.g_varchar2_table(6012) := '6E654964782B31292C746869732E6C696E653D746869732E6C696E65546F6B656E732E6765744C696E65436F6E74656E7428292C746869732E6C696E65546F6B656E4F66667365743D303D3D3D746869732E6C696E65436861724F66667365743F303A74';
wwv_flow_imp.g_varchar2_table(6013) := '6869732E6C696E65546F6B656E732E66696E64546F6B656E496E64657841744F666673657428746869732E6C696E65436861724F666673657429293B636F6E737420653D746869732E6C696E654964782C743D746869732E6C696E65436861724F666673';
wwv_flow_imp.g_varchar2_table(6014) := '65743B6C6574206E3D303B666F72283B3B297B636F6E737420693D746869732E6C696E65546F6B656E732C6F3D692E676574436F756E7428293B6C657420733D6E756C6C3B696628746869732E6C696E65546F6B656E4F66667365743C6F297B636F6E73';
wwv_flow_imp.g_varchar2_table(6015) := '7420723D692E6765744D6574616461746128746869732E6C696E65546F6B656E4F6666736574293B666F72283B746869732E6C696E65546F6B656E4F66667365742B313C6F2626723D3D3D692E6765744D6574616461746128746869732E6C696E65546F';
wwv_flow_imp.g_varchar2_table(6016) := '6B656E4F66667365742B31293B29746869732E6C696E65546F6B656E4F66667365742B2B3B636F6E737420613D303D3D3D51672E676574546F6B656E547970652872292C6C3D51672E636F6E7461696E7342616C616E636564427261636B657473287229';
wwv_flow_imp.g_varchar2_table(6017) := '2C633D692E676574456E644F666673657428746869732E6C696E65546F6B656E4F6666736574293B6966286C2626612626746869732E6C696E65436861724F66667365743C63297B636F6E737420653D692E6765744C616E677561676549642874686973';
wwv_flow_imp.g_varchar2_table(6018) := '2E6C696E65546F6B656E4F6666736574292C743D746869732E6C696E652E737562737472696E6728746869732E6C696E65436861724F66667365742C63292C6E3D746869732E627261636B6574546F6B656E732E67657453696E676C654C616E67756167';
wwv_flow_imp.g_varchar2_table(6019) := '65427261636B6574546F6B656E732865292C6F3D6E2E726567457870476C6F62616C3B6966286F297B6F2E6C617374496E6465783D303B636F6E737420653D6F2E657865632874293B65262628733D6E2E676574546F6B656E28655B305D292C73262628';
wwv_flow_imp.g_varchar2_table(6020) := '746869732E6C696E65436861724F66667365742B3D652E696E64657829297D7D6966286E2B3D632D746869732E6C696E65436861724F66667365742C73297B69662865213D3D746869732E6C696E654964787C7C74213D3D746869732E6C696E65436861';
wwv_flow_imp.g_varchar2_table(6021) := '724F6666736574297B746869732E7065656B6564546F6B656E3D733B627265616B7D72657475726E20746869732E6C696E65436861724F66667365742B3D732E6C656E6774682C737D746869732E6C696E65546F6B656E4F66667365742B2B2C74686973';
wwv_flow_imp.g_varchar2_table(6022) := '2E6C696E65436861724F66667365743D637D656C73657B696628746869732E6C696E654964783D3D3D746869732E746578744275666665724C696E65436F756E742D3129627265616B3B696628746869732E6C696E654964782B2B2C746869732E6C696E';
wwv_flow_imp.g_varchar2_table(6023) := '65546F6B656E733D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E7328746869732E6C696E654964782B31292C746869732E6C696E65546F6B656E4F66667365743D302C746869732E6C696E653D74';
wwv_flow_imp.g_varchar2_table(6024) := '6869732E6C696E65546F6B656E732E6765744C696E65436F6E74656E7428292C746869732E6C696E65436861724F66667365743D302C6E2B3D33332C6E3E31653329627265616B7D6966286E3E3135303029627265616B7D636F6E737420693D286F3D65';
wwv_flow_imp.g_varchar2_table(6025) := '2C733D742C723D746869732E6C696E654964782C613D746869732E6C696E65436861724F66667365742C6F213D3D723F5F6728722D6F2C61293A5F6728302C612D7329293B766172206F2C732C722C613B72657475726E206E657720596728692C302C2D';
wwv_flow_imp.g_varchar2_table(6026) := '312C50672E676574456D70747928292C6E6577205567286929297D7D636C617373204A677B636F6E7374727563746F7228652C74297B746869732E746578743D652C746869732E5F6F66667365743D66672C746869732E6964783D303B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(6027) := '3D742E67657452656745787053747228292C693D6E3F6E657720526567457870286E2B227C5C6E222C22676922293A6E756C6C2C6F3D5B5D3B6C657420732C723D302C613D302C6C3D302C633D303B636F6E737420643D5B5D3B666F72286C657420653D';
wwv_flow_imp.g_varchar2_table(6028) := '303B653C36303B652B2B29642E70757368286E6577205967285F6728302C65292C302C2D312C50672E676574456D70747928292C6E6577205567285F6728302C65292929293B636F6E737420683D5B5D3B666F72286C657420653D303B653C36303B652B';
wwv_flow_imp.g_varchar2_table(6029) := '2B29682E70757368286E6577205967285F6728312C65292C302C2D312C50672E676574456D70747928292C6E6577205567285F6728312C65292929293B6966286929666F7228692E6C617374496E6465783D303B6E756C6C213D3D28733D692E65786563';
wwv_flow_imp.g_varchar2_table(6030) := '286529293B297B636F6E737420653D732E696E6465782C6E3D735B305D3B696628225C6E223D3D3D6E29722B2B2C613D652B313B656C73657B6966286C213D3D65297B6C657420743B696628633D3D3D72297B636F6E7374206E3D652D6C3B6966286E3C';
wwv_flow_imp.g_varchar2_table(6031) := '642E6C656E67746829743D645B6E5D3B656C73657B636F6E737420653D5F6728302C6E293B743D6E657720596728652C302C2D312C50672E676574456D70747928292C6E6577205567286529297D7D656C73657B636F6E7374206E3D722D632C693D652D';
wwv_flow_imp.g_varchar2_table(6032) := '613B696628313D3D3D6E2626693C682E6C656E67746829743D685B695D3B656C73657B636F6E737420653D5F67286E2C69293B743D6E657720596728652C302C2D312C50672E676574456D70747928292C6E6577205567286529297D7D6F2E7075736828';
wwv_flow_imp.g_varchar2_table(6033) := '74297D6F2E7075736828742E676574546F6B656E286E29292C6C3D652B6E2E6C656E6774682C633D727D7D636F6E737420753D652E6C656E6774683B6966286C213D3D75297B636F6E737420653D633D3D3D723F5F6728302C752D6C293A5F6728722D63';
wwv_flow_imp.g_varchar2_table(6034) := '2C752D61293B6F2E70757368286E657720596728652C302C2D312C50672E676574456D70747928292C6E657720556728652929297D746869732E6C656E6774683D5F6728722C752D61292C746869732E746F6B656E733D6F7D676574206F666673657428';
wwv_flow_imp.g_varchar2_table(6035) := '297B72657475726E20746869732E5F6F66667365747D7265616428297B72657475726E20746869732E746F6B656E735B746869732E6964782B2B5D7C7C6E756C6C7D7065656B28297B72657475726E20746869732E746F6B656E735B746869732E696478';
wwv_flow_imp.g_varchar2_table(6036) := '5D7C7C6E756C6C7D736B69702865297B7468726F77206E6577204E657D7D636C61737320656D7B7374617469632063726561746546726F6D4C616E677561676528652C74297B66756E6374696F6E206E2865297B72657475726E20742E6765744B657928';
wwv_flow_imp.g_varchar2_table(6037) := '60247B652E6C616E677561676549647D3A3A3A247B652E627261636B6574546578747D60297D636F6E737420693D6E6577204D61703B666F7228636F6E73742074206F6620652E627261636B6574734E65772E6F70656E696E67427261636B657473297B';
wwv_flow_imp.g_varchar2_table(6038) := '636F6E737420653D5F6728302C742E627261636B6574546578742E6C656E677468292C6F3D6E2874292C733D50672E676574456D70747928292E616464286F2C4F67293B692E73657428742E627261636B6574546578742C6E657720596728652C312C6F';
wwv_flow_imp.g_varchar2_table(6039) := '2C732C4B672E63726561746528652C742C732929297D666F7228636F6E73742074206F6620652E627261636B6574734E65772E636C6F73696E67427261636B657473297B636F6E737420653D5F6728302C742E627261636B6574546578742E6C656E6774';
wwv_flow_imp.g_varchar2_table(6040) := '68293B6C6574206F3D50672E676574456D70747928293B636F6E737420733D742E6765744F70656E696E67427261636B65747328293B666F7228636F6E73742065206F662073296F3D6F2E616464286E2865292C4F67293B692E73657428742E62726163';
wwv_flow_imp.g_varchar2_table(6041) := '6B6574546578742C6E657720596728652C322C6E28735B305D292C6F2C4B672E63726561746528652C742C6F2929297D72657475726E206E657720656D2869297D636F6E7374727563746F722865297B746869732E6D61703D652C746869732E68617352';
wwv_flow_imp.g_varchar2_table(6042) := '65674578703D21312C746869732E5F726567457870476C6F62616C3D6E756C6C7D67657452656745787053747228297B696628746869732E6973456D7074792972657475726E206E756C6C3B7B636F6E737420653D5B2E2E2E746869732E6D61702E6B65';
wwv_flow_imp.g_varchar2_table(6043) := '797328295D3B72657475726E20652E736F727428292C652E7265766572736528292C652E6D61702828653D3E66756E6374696F6E2865297B6C657420743D63692865293B72657475726E2F5E5B5C77205D2B2F2E74657374286529262628743D605C5C62';
wwv_flow_imp.g_varchar2_table(6044) := '247B747D60292C2F5B5C77205D2B242F2E74657374286529262628743D60247B747D5C5C6260292C747D28652929292E6A6F696E28227C22297D7D67657420726567457870476C6F62616C28297B69662821746869732E686173526567457870297B636F';
wwv_flow_imp.g_varchar2_table(6045) := '6E737420653D746869732E67657452656745787053747228293B746869732E5F726567457870476C6F62616C3D653F6E65772052656745787028652C22676922293A6E756C6C2C746869732E6861735265674578703D21307D72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(6046) := '2E5F726567457870476C6F62616C7D676574546F6B656E2865297B72657475726E20746869732E6D61702E67657428652E746F4C6F776572436173652829297D66696E64436C6F73696E67546F6B656E546578742865297B666F7228636F6E73745B742C';
wwv_flow_imp.g_varchar2_table(6047) := '6E5D6F6620746869732E6D617029696628323D3D3D6E2E6B696E6426266E2E627261636B65744964732E696E74657273656374732865292972657475726E20747D676574206973456D70747928297B72657475726E20303D3D3D746869732E6D61702E73';
wwv_flow_imp.g_varchar2_table(6048) := '697A657D7D636C61737320746D7B636F6E7374727563746F7228652C74297B746869732E64656E73654B657950726F76696465723D652C746869732E6765744C616E6775616765436F6E66696775726174696F6E3D742C746869732E6C616E6775616765';
wwv_flow_imp.g_varchar2_table(6049) := '4964546F427261636B6574546F6B656E733D6E6577204D61707D6469644C616E67756167654368616E67652865297B72657475726E20746869732E6C616E67756167654964546F427261636B6574546F6B656E732E6861732865297D67657453696E676C';
wwv_flow_imp.g_varchar2_table(6050) := '654C616E6775616765427261636B6574546F6B656E732865297B6C657420743D746869732E6C616E67756167654964546F427261636B6574546F6B656E732E6765742865293B72657475726E20747C7C28743D656D2E63726561746546726F6D4C616E67';
wwv_flow_imp.g_varchar2_table(6051) := '7561676528746869732E6765744C616E6775616765436F6E66696775726174696F6E2865292C746869732E64656E73654B657950726F7669646572292C746869732E6C616E67756167654964546F427261636B6574546F6B656E732E73657428652C7429';
wwv_flow_imp.g_varchar2_table(6052) := '292C747D7D66756E6374696F6E206E6D28652C743D2131297B696628303D3D3D652E6C656E6774682972657475726E206E756C6C3B696628313D3D3D652E6C656E6774682972657475726E20655B305D3B6C6574206E3D652E6C656E6774683B666F7228';
wwv_flow_imp.g_varchar2_table(6053) := '3B6E3E333B297B636F6E737420693D6E3E3E313B666F72286C6574206F3D303B6F3C693B6F2B2B297B636F6E737420693D6F3C3C313B655B6F5D3D56672E637265617465323328655B695D2C655B692B315D2C692B333D3D3D6E3F655B692B325D3A6E75';
wwv_flow_imp.g_varchar2_table(6054) := '6C6C2C74297D6E3D697D72657475726E2056672E637265617465323328655B305D2C655B315D2C6E3E3D333F655B325D3A6E756C6C2C74297D66756E6374696F6E20696D28652C74297B72657475726E204D6174682E61627328652E6C69737448656967';
wwv_flow_imp.g_varchar2_table(6055) := '68742D742E6C697374486569676874297D66756E6374696F6E206F6D28652C74297B72657475726E20652E6C6973744865696768743D3D3D742E6C6973744865696768743F56672E637265617465323328652C742C6E756C6C2C2131293A652E6C697374';
wwv_flow_imp.g_varchar2_table(6056) := '4865696768743E742E6C6973744865696768743F66756E6374696F6E28652C74297B6C6574206E3D653D652E746F4D757461626C6528293B636F6E737420693D5B5D3B6C6574206F3B666F72283B3B297B696628742E6C6973744865696768743D3D3D6E';
wwv_flow_imp.g_varchar2_table(6057) := '2E6C697374486569676874297B6F3D743B627265616B7D69662834213D3D6E2E6B696E64297468726F77206E6577204572726F722822756E657870656374656422293B692E70757368286E292C6E3D6E2E6D616B654C617374456C656D656E744D757461';
wwv_flow_imp.g_varchar2_table(6058) := '626C6528297D666F72286C657420653D692E6C656E6774682D313B653E3D303B652D2D297B636F6E737420743D695B655D3B6F3F742E6368696C6472656E4C656E6774683E3D333F6F3D56672E637265617465323328742E756E617070656E644368696C';
wwv_flow_imp.g_varchar2_table(6059) := '6428292C6F2C6E756C6C2C2131293A28742E617070656E644368696C644F6653616D65486569676874286F292C6F3D766F69642030293A742E68616E646C654368696C6472656E4368616E67656428297D72657475726E206F3F56672E63726561746532';
wwv_flow_imp.g_varchar2_table(6060) := '3328652C6F2C6E756C6C2C2131293A657D28652C74293A66756E6374696F6E28652C74297B6C6574206E3D653D652E746F4D757461626C6528293B636F6E737420693D5B5D3B666F72283B742E6C697374486569676874213D3D6E2E6C69737448656967';
wwv_flow_imp.g_varchar2_table(6061) := '68743B297B69662834213D3D6E2E6B696E64297468726F77206E6577204572726F722822756E657870656374656422293B692E70757368286E292C6E3D6E2E6D616B654669727374456C656D656E744D757461626C6528297D6C6574206F3D743B666F72';
wwv_flow_imp.g_varchar2_table(6062) := '286C657420653D692E6C656E6774682D313B653E3D303B652D2D297B636F6E737420743D695B655D3B6F3F742E6368696C6472656E4C656E6774683E3D333F6F3D56672E6372656174653233286F2C742E756E70726570656E644368696C6428292C6E75';
wwv_flow_imp.g_varchar2_table(6063) := '6C6C2C2131293A28742E70726570656E644368696C644F6653616D65486569676874286F292C6F3D766F69642030293A742E68616E646C654368696C6472656E4368616E67656428297D72657475726E206F3F56672E6372656174653233286F2C652C6E';
wwv_flow_imp.g_varchar2_table(6064) := '756C6C2C2131293A657D28742C65297D636C61737320736D7B636F6E7374727563746F722865297B746869732E6C6173744F66667365743D66672C746869732E6E6578744E6F6465733D5B655D2C746869732E6F6666736574733D5B66675D2C74686973';
wwv_flow_imp.g_varchar2_table(6065) := '2E696478733D5B5D7D726561644C6F6E676573744E6F6465417428652C74297B6966286B6728652C746869732E6C6173744F666673657429297468726F77206E6577204572726F722822496E76616C6964206F666673657422293B666F7228746869732E';
wwv_flow_imp.g_varchar2_table(6066) := '6C6173744F66667365743D653B3B297B636F6E7374206E3D616D28746869732E6E6578744E6F646573293B696628216E2972657475726E3B636F6E737420693D616D28746869732E6F666673657473293B6966286B6728652C69292972657475726E3B69';
wwv_flow_imp.g_varchar2_table(6067) := '66286B6728692C652929696628776728692C6E2E6C656E677468293C3D6529746869732E6E6578744E6F6465416674657243757272656E7428293B656C73657B636F6E737420653D726D286E293B2D31213D3D653F28746869732E6E6578744E6F646573';
wwv_flow_imp.g_varchar2_table(6068) := '2E70757368286E2E6765744368696C64286529292C746869732E6F6666736574732E707573682869292C746869732E696478732E70757368286529293A746869732E6E6578744E6F6465416674657243757272656E7428297D656C73657B69662874286E';
wwv_flow_imp.g_varchar2_table(6069) := '292972657475726E20746869732E6E6578744E6F6465416674657243757272656E7428292C6E3B7B636F6E737420653D726D286E293B6966282D313D3D3D652972657475726E20766F696420746869732E6E6578744E6F6465416674657243757272656E';
wwv_flow_imp.g_varchar2_table(6070) := '7428293B746869732E6E6578744E6F6465732E70757368286E2E6765744368696C64286529292C746869732E6F6666736574732E707573682869292C746869732E696478732E707573682865297D7D7D7D6E6578744E6F6465416674657243757272656E';
wwv_flow_imp.g_varchar2_table(6071) := '7428297B666F72283B3B297B636F6E737420653D616D28746869732E6F666673657473292C743D616D28746869732E6E6578744E6F646573293B696628746869732E6E6578744E6F6465732E706F7028292C746869732E6F6666736574732E706F702829';
wwv_flow_imp.g_varchar2_table(6072) := '2C303D3D3D746869732E696478732E6C656E67746829627265616B3B636F6E7374206E3D616D28746869732E6E6578744E6F646573292C693D726D286E2C746869732E696478735B746869732E696478732E6C656E6774682D315D293B6966282D31213D';
wwv_flow_imp.g_varchar2_table(6073) := '3D69297B746869732E6E6578744E6F6465732E70757368286E2E6765744368696C64286929292C746869732E6F6666736574732E7075736828776728652C742E6C656E67746829292C746869732E696478735B746869732E696478732E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(6074) := '315D3D693B627265616B7D746869732E696478732E706F7028297D7D7D66756E6374696F6E20726D28652C743D2D31297B666F72283B3B297B6966282B2B743E3D652E6368696C6472656E4C656E6774682972657475726E2D313B696628652E67657443';
wwv_flow_imp.g_varchar2_table(6075) := '68696C642874292972657475726E20747D7D66756E6374696F6E20616D2865297B72657475726E20652E6C656E6774683E303F655B652E6C656E6774682D315D3A766F696420307D66756E6374696F6E206C6D28652C742C6E2C69297B72657475726E20';
wwv_flow_imp.g_varchar2_table(6076) := '6E657720636D28652C742C6E2C69292E7061727365446F63756D656E7428297D636C61737320636D7B636F6E7374727563746F7228652C742C6E2C69297B696628746869732E746F6B656E697A65723D652C746869732E637265617465496D6D75746162';
wwv_flow_imp.g_varchar2_table(6077) := '6C654C697374733D692C746869732E5F6974656D73436F6E73747275637465643D302C746869732E5F6974656D7346726F6D43616368653D302C6E262669297468726F77206E6577204572726F7228224E6F7420737570706F7274656422293B74686973';
wwv_flow_imp.g_varchar2_table(6078) := '2E6F6C644E6F64655265616465723D6E3F6E657720736D286E293A766F696420302C746869732E706F736974696F6E4D61707065723D6E6577204D672874297D7061727365446F63756D656E7428297B746869732E5F6974656D73436F6E737472756374';
wwv_flow_imp.g_varchar2_table(6079) := '65643D302C746869732E5F6974656D7346726F6D43616368653D303B6C657420653D746869732E70617273654C6973742850672E676574456D70747928292C30293B72657475726E20657C7C28653D56672E676574456D7074792829292C657D70617273';
wwv_flow_imp.g_varchar2_table(6080) := '654C69737428652C74297B636F6E7374206E3D5B5D3B666F72283B3B297B6C657420693D746869732E747279526561644368696C6446726F6D43616368652865293B6966282169297B636F6E7374206E3D746869732E746F6B656E697A65722E7065656B';
wwv_flow_imp.g_varchar2_table(6081) := '28293B696628216E7C7C323D3D3D6E2E6B696E6426266E2E627261636B65744964732E696E746572736563747328652929627265616B3B693D746869732E70617273654368696C6428652C742B31297D343D3D3D692E6B696E642626303D3D3D692E6368';
wwv_flow_imp.g_varchar2_table(6082) := '696C6472656E4C656E6774687C7C6E2E707573682869297D636F6E737420693D746869732E6F6C644E6F64655265616465723F66756E6374696F6E2865297B696628303D3D3D652E6C656E6774682972657475726E206E756C6C3B696628313D3D3D652E';
wwv_flow_imp.g_varchar2_table(6083) := '6C656E6774682972657475726E20655B305D3B6C657420743D303B66756E6374696F6E206E28297B696628743E3D652E6C656E6774682972657475726E206E756C6C3B636F6E7374206E3D742C693D655B6E5D2E6C6973744865696768743B666F722874';
wwv_flow_imp.g_varchar2_table(6084) := '2B2B3B743C652E6C656E6774682626655B745D2E6C6973744865696768743D3D3D693B29742B2B3B72657475726E20742D6E3E3D323F6E6D28303D3D3D6E2626743D3D3D652E6C656E6774683F653A652E736C696365286E2C74292C2131293A655B6E5D';
wwv_flow_imp.g_varchar2_table(6085) := '7D6C657420693D6E28292C6F3D6E28293B696628216F2972657475726E20693B666F72286C657420653D6E28293B653B653D6E282929696D28692C6F293C3D696D286F2C65293F28693D6F6D28692C6F292C6F3D65293A6F3D6F6D286F2C65293B726574';
wwv_flow_imp.g_varchar2_table(6086) := '75726E206F6D28692C6F297D286E293A6E6D286E2C746869732E637265617465496D6D757461626C654C69737473293B72657475726E20697D747279526561644368696C6446726F6D43616368652865297B696628746869732E6F6C644E6F6465526561';
wwv_flow_imp.g_varchar2_table(6087) := '646572297B636F6E737420743D746869732E706F736974696F6E4D61707065722E67657444697374616E6365546F4E6578744368616E676528746869732E746F6B656E697A65722E6F6666736574293B6966286E756C6C3D3D3D747C7C21766728742929';
wwv_flow_imp.g_varchar2_table(6088) := '7B636F6E7374206E3D746869732E6F6C644E6F64655265616465722E726561644C6F6E676573744E6F6465417428746869732E706F736974696F6E4D61707065722E6765744F66667365744265666F72654368616E676528746869732E746F6B656E697A';
wwv_flow_imp.g_varchar2_table(6089) := '65722E6F6666736574292C286E3D3E21286E756C6C213D3D742626216B67286E2E6C656E6774682C74292926266E2E63616E426552657573656428652929293B6966286E2972657475726E20746869732E5F6974656D7346726F6D43616368652B2B2C74';
wwv_flow_imp.g_varchar2_table(6090) := '6869732E746F6B656E697A65722E736B6970286E2E6C656E677468292C6E7D7D7D70617273654368696C6428652C74297B746869732E5F6974656D73436F6E73747275637465642B2B3B636F6E7374206E3D746869732E746F6B656E697A65722E726561';
wwv_flow_imp.g_varchar2_table(6091) := '6428293B737769746368286E2E6B696E64297B6361736520323A72657475726E206E6577204767286E2E627261636B65744964732C6E2E6C656E677468293B6361736520303A72657475726E206E2E6173744E6F64653B6361736520313A7B696628743E';
wwv_flow_imp.g_varchar2_table(6092) := '3330302972657475726E206E6577205567286E2E6C656E677468293B636F6E737420693D652E6D65726765286E2E627261636B6574496473292C6F3D746869732E70617273654C69737428692C742B31292C733D746869732E746F6B656E697A65722E70';
wwv_flow_imp.g_varchar2_table(6093) := '65656B28293B72657475726E20732626323D3D3D732E6B696E64262628732E627261636B657449643D3D3D6E2E627261636B657449647C7C732E627261636B65744964732E696E7465727365637473286E2E627261636B657449647329293F2874686973';
wwv_flow_imp.g_varchar2_table(6094) := '2E746F6B656E697A65722E7265616428292C42672E637265617465286E2E6173744E6F64652C6F2C732E6173744E6F646529293A42672E637265617465286E2E6173744E6F64652C6F2C6E756C6C297D64656661756C743A7468726F77206E6577204572';
wwv_flow_imp.g_varchar2_table(6095) := '726F722822756E657870656374656422297D7D7D66756E6374696F6E20646D28652C74297B696628303D3D3D652E6C656E6774682972657475726E20743B696628303D3D3D742E6C656E6774682972657475726E20653B636F6E7374206E3D6E6577206F';
wwv_flow_imp.g_varchar2_table(6096) := '7528756D286529292C693D756D2874293B692E70757368287B6D6F6469666965643A21312C6C656E6774684265666F72653A766F696420302C6C656E67746841667465723A766F696420307D293B6C6574206F3D6E2E6465717565756528293B66756E63';
wwv_flow_imp.g_varchar2_table(6097) := '74696F6E20732865297B696628766F696420303D3D3D65297B636F6E737420653D6E2E74616B655768696C652828653D3E213029297C7C5B5D3B72657475726E206F2626652E756E7368696674286F292C657D636F6E737420743D5B5D3B666F72283B6F';
wwv_flow_imp.g_varchar2_table(6098) := '26262176672865293B297B636F6E73745B692C735D3D6F2E73706C697441742865293B742E707573682869292C653D786728692E6C656E67746841667465722C65292C6F3D6E756C6C213D733F733A6E2E6465717565756528297D72657475726E207667';
wwv_flow_imp.g_varchar2_table(6099) := '2865297C7C742E70757368286E657720686D2821312C652C6529292C747D636F6E737420723D5B5D3B66756E6374696F6E206128652C742C6E297B696628722E6C656E6774683E302626536728725B722E6C656E6774682D315D2E656E644F6666736574';
wwv_flow_imp.g_varchar2_table(6100) := '2C6529297B636F6E737420653D725B722E6C656E6774682D315D3B725B722E6C656E6774682D315D3D6E657720496728652E73746172744F66667365742C742C776728652E6E65774C656E6774682C6E29297D656C736520722E70757368287B73746172';
wwv_flow_imp.g_varchar2_table(6101) := '744F66667365743A652C656E644F66667365743A742C6E65774C656E6774683A6E7D297D6C6574206C3D66673B666F7228636F6E73742065206F662069297B636F6E737420743D7328652E6C656E6774684265666F7265293B696628652E6D6F64696669';
wwv_flow_imp.g_varchar2_table(6102) := '6564297B636F6E7374206E3D7767286C2C436728742C28653D3E652E6C656E6774684265666F72652929293B61286C2C6E2C652E6C656E6774684166746572292C6C3D6E7D656C736520666F7228636F6E73742065206F662074297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(6103) := '6C3B6C3D7767286C2C652E6C656E6774684265666F7265292C652E6D6F64696669656426266128742C6C2C652E6C656E6774684166746572297D7D72657475726E20727D636C61737320686D7B636F6E7374727563746F7228652C742C6E297B74686973';
wwv_flow_imp.g_varchar2_table(6104) := '2E6D6F6469666965643D652C746869732E6C656E6774684265666F72653D742C746869732E6C656E67746841667465723D6E7D73706C697441742865297B636F6E737420743D786728652C746869732E6C656E6774684166746572293B72657475726E20';
wwv_flow_imp.g_varchar2_table(6105) := '536728742C6667293F5B746869732C766F696420305D3A746869732E6D6F6469666965643F5B6E657720686D28746869732E6D6F6469666965642C746869732E6C656E6774684265666F72652C65292C6E657720686D28746869732E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(6106) := '2C66672C74295D3A5B6E657720686D28746869732E6D6F6469666965642C652C65292C6E657720686D28746869732E6D6F6469666965642C742C74295D7D746F537472696E6728297B72657475726E60247B746869732E6D6F6469666965643F224D223A';
wwv_flow_imp.g_varchar2_table(6107) := '2255227D3A247B796728746869732E6C656E6774684265666F7265297D202D3E20247B796728746869732E6C656E6774684166746572297D607D7D66756E6374696F6E20756D2865297B636F6E737420743D5B5D3B6C6574206E3D66673B666F7228636F';
wwv_flow_imp.g_varchar2_table(6108) := '6E73742069206F662065297B636F6E737420653D7867286E2C692E73746172744F6666736574293B76672865297C7C742E70757368286E657720686D2821312C652C6529293B636F6E7374206F3D786728692E73746172744F66667365742C692E656E64';
wwv_flow_imp.g_varchar2_table(6109) := '4F6666736574293B742E70757368286E657720686D2821302C6F2C692E6E65774C656E67746829292C6E3D692E656E644F66667365747D72657475726E20747D636C61737320706D20657874656E6473206C747B6469644C616E67756167654368616E67';
wwv_flow_imp.g_varchar2_table(6110) := '652865297B72657475726E20746869732E627261636B6574732E6469644C616E67756167654368616E67652865297D636F6E7374727563746F7228652C74297B696628737570657228292C746869732E746578744D6F64656C3D652C746869732E676574';
wwv_flow_imp.g_varchar2_table(6111) := '4C616E6775616765436F6E66696775726174696F6E3D742C746869732E6469644368616E6765456D69747465723D6E65772043742C746869732E64656E73654B657950726F76696465723D6E65772052672C746869732E627261636B6574733D6E657720';
wwv_flow_imp.g_varchar2_table(6112) := '746D28746869732E64656E73654B657950726F76696465722C746869732E6765744C616E6775616765436F6E66696775726174696F6E292C746869732E6F6E4469644368616E67653D746869732E6469644368616E6765456D69747465722E6576656E74';
wwv_flow_imp.g_varchar2_table(6113) := '2C746869732E717565756564546578744564697473466F72496E697469616C417374576974686F7574546F6B656E733D5B5D2C746869732E7175657565645465787445646974733D5B5D2C652E746F6B656E697A6174696F6E2E686173546F6B656E7329';
wwv_flow_imp.g_varchar2_table(6114) := '323D3D3D652E746F6B656E697A6174696F6E2E6261636B67726F756E64546F6B656E697A6174696F6E53746174653F28746869732E696E697469616C417374576974686F7574546F6B656E733D766F696420302C746869732E61737457697468546F6B65';
wwv_flow_imp.g_varchar2_table(6115) := '6E733D746869732E7061727365446F63756D656E7446726F6D54657874427566666572285B5D2C766F696420302C213129293A28746869732E696E697469616C417374576974686F7574546F6B656E733D746869732E7061727365446F63756D656E7446';
wwv_flow_imp.g_varchar2_table(6116) := '726F6D54657874427566666572285B5D2C766F696420302C2130292C746869732E61737457697468546F6B656E733D746869732E696E697469616C417374576974686F7574546F6B656E73293B656C73657B636F6E737420653D746869732E627261636B';
wwv_flow_imp.g_varchar2_table(6117) := '6574732E67657453696E676C654C616E6775616765427261636B6574546F6B656E7328746869732E746578744D6F64656C2E6765744C616E677561676549642829292C743D6E6577204A6728746869732E746578744D6F64656C2E67657456616C756528';
wwv_flow_imp.g_varchar2_table(6118) := '292C65293B746869732E696E697469616C417374576974686F7574546F6B656E733D6C6D28742C5B5D2C766F696420302C2130292C746869732E61737457697468546F6B656E733D746869732E696E697469616C417374576974686F7574546F6B656E73';
wwv_flow_imp.g_varchar2_table(6119) := '7D7D68616E646C654469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E537461746528297B696628323D3D3D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6261636B67726F756E64546F6B656E697A61';
wwv_flow_imp.g_varchar2_table(6120) := '74696F6E5374617465297B636F6E737420653D766F696420303D3D3D746869732E696E697469616C417374576974686F7574546F6B656E733B746869732E696E697469616C417374576974686F7574546F6B656E733D766F696420302C657C7C74686973';
wwv_flow_imp.g_varchar2_table(6121) := '2E6469644368616E6765456D69747465722E6669726528297D7D68616E646C654469644368616E6765546F6B656E73287B72616E6765733A657D297B636F6E737420743D652E6D61702828653D3E6E6577204967285F6728652E66726F6D4C696E654E75';
wwv_flow_imp.g_varchar2_table(6122) := '6D6265722D312C30292C5F6728652E746F4C696E654E756D6265722C30292C5F6728652E746F4C696E654E756D6265722D652E66726F6D4C696E654E756D6265722B312C30292929293B746869732E68616E646C65456469747328742C2130292C746869';
wwv_flow_imp.g_varchar2_table(6123) := '732E696E697469616C417374576974686F7574546F6B656E737C7C746869732E6469644368616E6765456D69747465722E6669726528297D68616E646C65436F6E74656E744368616E6765642865297B636F6E737420743D49672E66726F6D4D6F64656C';
wwv_flow_imp.g_varchar2_table(6124) := '436F6E74656E744368616E67657328652E6368616E676573293B746869732E68616E646C65456469747328742C2131297D68616E646C65456469747328652C74297B636F6E7374206E3D646D28746869732E7175657565645465787445646974732C6529';
wwv_flow_imp.g_varchar2_table(6125) := '3B746869732E7175657565645465787445646974733D6E2C746869732E696E697469616C417374576974686F7574546F6B656E7326262174262628746869732E717565756564546578744564697473466F72496E697469616C417374576974686F757454';
wwv_flow_imp.g_varchar2_table(6126) := '6F6B656E733D646D28746869732E717565756564546578744564697473466F72496E697469616C417374576974686F7574546F6B656E732C6529297D666C757368517565756528297B746869732E7175657565645465787445646974732E6C656E677468';
wwv_flow_imp.g_varchar2_table(6127) := '3E30262628746869732E61737457697468546F6B656E733D746869732E7061727365446F63756D656E7446726F6D5465787442756666657228746869732E7175657565645465787445646974732C746869732E61737457697468546F6B656E732C213129';
wwv_flow_imp.g_varchar2_table(6128) := '2C746869732E7175657565645465787445646974733D5B5D292C746869732E717565756564546578744564697473466F72496E697469616C417374576974686F7574546F6B656E732E6C656E6774683E30262628746869732E696E697469616C41737457';
wwv_flow_imp.g_varchar2_table(6129) := '6974686F7574546F6B656E73262628746869732E696E697469616C417374576974686F7574546F6B656E733D746869732E7061727365446F63756D656E7446726F6D5465787442756666657228746869732E717565756564546578744564697473466F72';
wwv_flow_imp.g_varchar2_table(6130) := '496E697469616C417374576974686F7574546F6B656E732C746869732E696E697469616C417374576974686F7574546F6B656E732C213129292C746869732E717565756564546578744564697473466F72496E697469616C417374576974686F7574546F';
wwv_flow_imp.g_varchar2_table(6131) := '6B656E733D5B5D297D7061727365446F63756D656E7446726F6D5465787442756666657228652C742C6E297B636F6E737420693D743B72657475726E206C6D286E6577205A6728746869732E746578744D6F64656C2C746869732E627261636B65747329';
wwv_flow_imp.g_varchar2_table(6132) := '2C652C692C6E297D676574427261636B657473496E52616E676528652C74297B746869732E666C757368517565756528293B636F6E7374206E3D5F6728652E73746172744C696E654E756D6265722D312C652E7374617274436F6C756D6E2D31292C693D';
wwv_flow_imp.g_varchar2_table(6133) := '5F6728652E656E644C696E654E756D6265722D312C652E656E64436F6C756D6E2D31293B72657475726E206E65772073752828653D3E7B636F6E7374206F3D746869732E696E697469616C417374576974686F7574546F6B656E737C7C746869732E6173';
wwv_flow_imp.g_varchar2_table(6134) := '7457697468546F6B656E733B666D286F2C66672C6F2E6C656E6774682C6E2C692C652C302C302C6E6577204D61702C74297D29297D676574427261636B65745061697273496E52616E676528652C74297B746869732E666C757368517565756528293B63';
wwv_flow_imp.g_varchar2_table(6135) := '6F6E7374206E3D446728652E6765745374617274506F736974696F6E2829292C693D446728652E676574456E64506F736974696F6E2829293B72657475726E206E65772073752828653D3E7B636F6E7374206F3D746869732E696E697469616C41737457';
wwv_flow_imp.g_varchar2_table(6136) := '6974686F7574546F6B656E737C7C746869732E61737457697468546F6B656E732C733D6E657720766D28652C742C746869732E746578744D6F64656C293B626D286F2C66672C6F2E6C656E6774682C6E2C692C732C302C6E6577204D6170297D29297D67';
wwv_flow_imp.g_varchar2_table(6137) := '65744669727374427261636B657441667465722865297B746869732E666C757368517565756528293B636F6E737420743D746869732E696E697469616C417374576974686F7574546F6B656E737C7C746869732E61737457697468546F6B656E733B7265';
wwv_flow_imp.g_varchar2_table(6138) := '7475726E206D6D28742C66672C742E6C656E6774682C4467286529297D6765744669727374427261636B65744265666F72652865297B746869732E666C757368517565756528293B636F6E737420743D746869732E696E697469616C417374576974686F';
wwv_flow_imp.g_varchar2_table(6139) := '7574546F6B656E737C7C746869732E61737457697468546F6B656E733B72657475726E20676D28742C66672C742E6C656E6774682C4467286529297D7D66756E6374696F6E20676D28652C742C6E2C69297B696628343D3D3D652E6B696E647C7C323D3D';
wwv_flow_imp.g_varchar2_table(6140) := '3D652E6B696E64297B636F6E7374206F3D5B5D3B666F7228636F6E73742069206F6620652E6368696C6472656E296E3D776728742C692E6C656E677468292C6F2E70757368287B6E6F64654F666673657453746172743A742C6E6F64654F666673657445';
wwv_flow_imp.g_varchar2_table(6141) := '6E643A6E7D292C743D6E3B666F72286C657420743D6F2E6C656E6774682D313B743E3D303B742D2D297B636F6E73747B6E6F64654F666673657453746172743A6E2C6E6F64654F6666736574456E643A737D3D6F5B745D3B6966286B67286E2C6929297B';
wwv_flow_imp.g_varchar2_table(6142) := '636F6E7374206F3D676D28652E6368696C6472656E5B745D2C6E2C732C69293B6966286F2972657475726E206F7D7D72657475726E206E756C6C7D696628333D3D3D652E6B696E642972657475726E206E756C6C3B696628313D3D3D652E6B696E64297B';
wwv_flow_imp.g_varchar2_table(6143) := '636F6E737420693D546728742C6E293B72657475726E7B627261636B6574496E666F3A652E627261636B6574496E666F2C72616E67653A697D7D72657475726E206E756C6C7D66756E6374696F6E206D6D28652C742C6E2C69297B696628343D3D3D652E';
wwv_flow_imp.g_varchar2_table(6144) := '6B696E647C7C323D3D3D652E6B696E64297B666F7228636F6E7374206F206F6620652E6368696C6472656E297B6966286B6728692C6E3D776728742C6F2E6C656E6774682929297B636F6E737420653D6D6D286F2C742C6E2C69293B6966286529726574';
wwv_flow_imp.g_varchar2_table(6145) := '75726E20657D743D6E7D72657475726E206E756C6C7D696628333D3D3D652E6B696E642972657475726E206E756C6C3B696628313D3D3D652E6B696E64297B636F6E737420693D546728742C6E293B72657475726E7B627261636B6574496E666F3A652E';
wwv_flow_imp.g_varchar2_table(6146) := '627261636B6574496E666F2C72616E67653A697D7D72657475726E206E756C6C7D66756E6374696F6E20666D28652C742C6E2C692C6F2C732C722C612C6C2C632C643D2131297B696628723E3230302972657475726E21303B653A666F72283B3B297377';
wwv_flow_imp.g_varchar2_table(6147) := '6974636828652E6B696E64297B6361736520343A7B636F6E737420613D652E6368696C6472656E4C656E6774683B666F72286C657420643D303B643C613B642B2B297B636F6E737420613D652E6765744368696C642864293B69662861297B6966286E3D';
wwv_flow_imp.g_varchar2_table(6148) := '776728742C612E6C656E677468292C456728742C6F2926264C67286E2C6929297B6966284C67286E2C6F29297B653D613B636F6E74696E756520657D69662821666D28612C742C6E2C692C6F2C732C722C302C6C2C63292972657475726E21317D743D6E';
wwv_flow_imp.g_varchar2_table(6149) := '7D7D72657475726E21307D6361736520323A7B636F6E737420643D21637C7C21652E636C6F73696E67427261636B65747C7C652E636C6F73696E67427261636B65742E627261636B6574496E666F2E636C6F736573436F6C6F72697A656428652E6F7065';
wwv_flow_imp.g_varchar2_table(6150) := '6E696E67427261636B65742E627261636B6574496E666F293B6C657420683D303B6966286C297B6C657420743D6C2E67657428652E6F70656E696E67427261636B65742E74657874293B766F696420303D3D3D74262628743D30292C683D742C64262628';
wwv_flow_imp.g_varchar2_table(6151) := '742B2B2C6C2E73657428652E6F70656E696E67427261636B65742E746578742C7429297D636F6E737420753D652E6368696C6472656E4C656E6774683B666F72286C657420703D303B703C753B702B2B297B636F6E737420753D652E6765744368696C64';
wwv_flow_imp.g_varchar2_table(6152) := '2870293B69662875297B6966286E3D776728742C752E6C656E677468292C456728742C6F2926264C67286E2C6929297B6966284C67286E2C6F29262631213D3D752E6B696E64297B653D752C643F28722B2B2C613D682B31293A613D683B636F6E74696E';
wwv_flow_imp.g_varchar2_table(6153) := '756520657D69662828647C7C31213D3D752E6B696E647C7C21652E636C6F73696E67427261636B657429262621666D28752C742C6E2C692C6F2C732C643F722B313A722C643F682B313A682C6C2C632C21652E636C6F73696E67427261636B6574292972';
wwv_flow_imp.g_varchar2_table(6154) := '657475726E21317D743D6E7D7D72657475726E206E756C6C3D3D6C7C7C6C2E73657428652E6F70656E696E67427261636B65742E746578742C68292C21307D6361736520333A7B636F6E737420653D546728742C6E293B72657475726E2073286E657720';
wwv_flow_imp.g_varchar2_table(6155) := '756728652C722D312C302C213029297D6361736520313A7B636F6E737420653D546728742C6E293B72657475726E2073286E657720756728652C722D312C612D312C6429297D6361736520303A72657475726E21307D7D636C61737320766D7B636F6E73';
wwv_flow_imp.g_varchar2_table(6156) := '74727563746F7228652C742C6E297B746869732E707573683D652C746869732E696E636C7564654D696E496E64656E746174696F6E3D742C746869732E746578744D6F64656C3D6E7D7D66756E6374696F6E20626D28652C742C6E2C692C6F2C732C722C';
wwv_flow_imp.g_varchar2_table(6157) := '61297B766172206C3B696628723E3230302972657475726E21303B6C657420633D21303B696628323D3D3D652E6B696E64297B6C657420643D303B69662861297B6C657420743D612E67657428652E6F70656E696E67427261636B65742E74657874293B';
wwv_flow_imp.g_varchar2_table(6158) := '766F696420303D3D3D74262628743D30292C643D742C742B2B2C612E73657428652E6F70656E696E67427261636B65742E746578742C74297D636F6E737420683D776728742C652E6F70656E696E67427261636B65742E6C656E677468293B6C65742075';
wwv_flow_imp.g_varchar2_table(6159) := '3D2D313B696628732E696E636C7564654D696E496E64656E746174696F6E262628753D652E636F6D707574654D696E496E64656E746174696F6E28742C732E746578744D6F64656C29292C633D732E70757368286E657720676728546728742C6E292C54';
wwv_flow_imp.g_varchar2_table(6160) := '6728742C68292C652E636C6F73696E67427261636B65743F546728776728682C286E756C6C3D3D3D286C3D652E6368696C64297C7C766F696420303D3D3D6C3F766F696420303A6C2E6C656E677468297C7C6667292C6E293A766F696420302C722C642C';
wwv_flow_imp.g_varchar2_table(6161) := '652C7529292C743D682C632626652E6368696C64297B636F6E7374206C3D652E6368696C643B6966286E3D776728742C6C2E6C656E677468292C456728742C6F2926264C67286E2C6929262628633D626D286C2C742C6E2C692C6F2C732C722B312C6129';
wwv_flow_imp.g_varchar2_table(6162) := '2C2163292972657475726E21317D6E756C6C3D3D617C7C612E73657428652E6F70656E696E67427261636B65742E746578742C64297D656C73657B6C6574206E3D743B666F7228636F6E73742074206F6620652E6368696C6472656E297B636F6E737420';
wwv_flow_imp.g_varchar2_table(6163) := '653D6E3B6966286E3D7767286E2C742E6C656E677468292C456728652C6F292626456728692C6E29262628633D626D28742C652C6E2C692C6F2C732C722C61292C2163292972657475726E21317D7D72657475726E20637D636C617373205F6D20657874';
wwv_flow_imp.g_varchar2_table(6164) := '656E6473206C747B6765742063616E4275696C6441535428297B72657475726E20746869732E746578744D6F64656C2E67657456616C75654C656E67746828293C3D3565367D636F6E7374727563746F7228652C74297B737570657228292C746869732E';
wwv_flow_imp.g_varchar2_table(6165) := '746578744D6F64656C3D652C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E627261636B65745061697273547265653D746869732E5F7265676973746572286E6577206374292C746869732E6F6E';
wwv_flow_imp.g_varchar2_table(6166) := '4469644368616E6765456D69747465723D6E65772043742C746869732E6F6E4469644368616E67653D746869732E6F6E4469644368616E6765456D69747465722E6576656E742C746869732E627261636B6574735265717565737465643D21312C746869';
wwv_flow_imp.g_varchar2_table(6167) := '732E5F726567697374657228746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6F6E4469644368616E67652828653D3E7B76617220743B652E6C616E67756167654964262621286E756C6C3D3D3D28743D746869732E';
wwv_flow_imp.g_varchar2_table(6168) := '627261636B65745061697273547265652E76616C7565297C7C766F696420303D3D3D743F766F696420303A742E6F626A6563742E6469644C616E67756167654368616E676528652E6C616E6775616765496429297C7C28746869732E627261636B657450';
wwv_flow_imp.g_varchar2_table(6169) := '61697273547265652E636C65617228292C746869732E757064617465427261636B65745061697273547265652829297D2929297D68616E646C654469644368616E67654F7074696F6E732865297B746869732E627261636B65745061697273547265652E';
wwv_flow_imp.g_varchar2_table(6170) := '636C65617228292C746869732E757064617465427261636B657450616972735472656528297D68616E646C654469644368616E67654C616E67756167652865297B746869732E627261636B65745061697273547265652E636C65617228292C746869732E';
wwv_flow_imp.g_varchar2_table(6171) := '757064617465427261636B657450616972735472656528297D68616E646C654469644368616E6765436F6E74656E742865297B76617220743B6E756C6C3D3D3D28743D746869732E627261636B65745061697273547265652E76616C7565297C7C766F69';
wwv_flow_imp.g_varchar2_table(6172) := '6420303D3D3D747C7C742E6F626A6563742E68616E646C65436F6E74656E744368616E6765642865297D68616E646C654469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E537461746528297B76617220653B6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(6173) := '28653D746869732E627261636B65745061697273547265652E76616C7565297C7C766F696420303D3D3D657C7C652E6F626A6563742E68616E646C654469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E537461746528297D68';
wwv_flow_imp.g_varchar2_table(6174) := '616E646C654469644368616E6765546F6B656E732865297B76617220743B6E756C6C3D3D3D28743D746869732E627261636B65745061697273547265652E76616C7565297C7C766F696420303D3D3D747C7C742E6F626A6563742E68616E646C65446964';
wwv_flow_imp.g_varchar2_table(6175) := '4368616E6765546F6B656E732865297D757064617465427261636B657450616972735472656528297B696628746869732E627261636B6574735265717565737465642626746869732E63616E4275696C64415354297B69662821746869732E627261636B';
wwv_flow_imp.g_varchar2_table(6176) := '65745061697273547265652E76616C7565297B636F6E7374206E3D6E65772061743B746869732E627261636B65745061697273547265652E76616C75653D28653D6E2E616464286E657720706D28746869732E746578744D6F64656C2C28653D3E746869';
wwv_flow_imp.g_varchar2_table(6177) := '732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2865292929292C743D6E2C7B6F626A6563743A652C646973706F73653A28293D3E6E756C6C3D3D743F766F6964';
wwv_flow_imp.g_varchar2_table(6178) := '20303A742E646973706F736528297D292C6E2E61646428746869732E627261636B65745061697273547265652E76616C75652E6F626A6563742E6F6E4469644368616E67652828653D3E746869732E6F6E4469644368616E6765456D69747465722E6669';
wwv_flow_imp.g_varchar2_table(6179) := '72652865292929292C746869732E6F6E4469644368616E6765456D69747465722E6669726528297D7D656C736520746869732E627261636B65745061697273547265652E76616C7565262628746869732E627261636B65745061697273547265652E636C';
wwv_flow_imp.g_varchar2_table(6180) := '65617228292C746869732E6F6E4469644368616E6765456D69747465722E666972652829293B76617220652C747D676574427261636B65745061697273496E52616E67652865297B76617220743B72657475726E20746869732E627261636B6574735265';
wwv_flow_imp.g_varchar2_table(6181) := '717565737465643D21302C746869732E757064617465427261636B657450616972735472656528292C286E756C6C3D3D3D28743D746869732E627261636B65745061697273547265652E76616C7565297C7C766F696420303D3D3D743F766F696420303A';
wwv_flow_imp.g_varchar2_table(6182) := '742E6F626A6563742E676574427261636B65745061697273496E52616E676528652C213129297C7C73752E656D7074797D676574427261636B65745061697273496E52616E6765576974684D696E496E64656E746174696F6E2865297B76617220743B72';
wwv_flow_imp.g_varchar2_table(6183) := '657475726E20746869732E627261636B6574735265717565737465643D21302C746869732E757064617465427261636B657450616972735472656528292C286E756C6C3D3D3D28743D746869732E627261636B65745061697273547265652E76616C7565';
wwv_flow_imp.g_varchar2_table(6184) := '297C7C766F696420303D3D3D743F766F696420303A742E6F626A6563742E676574427261636B65745061697273496E52616E676528652C213029297C7C73752E656D7074797D676574427261636B657473496E52616E676528652C743D2131297B766172';
wwv_flow_imp.g_varchar2_table(6185) := '206E3B72657475726E20746869732E627261636B6574735265717565737465643D21302C746869732E757064617465427261636B657450616972735472656528292C286E756C6C3D3D3D286E3D746869732E627261636B65745061697273547265652E76';
wwv_flow_imp.g_varchar2_table(6186) := '616C7565297C7C766F696420303D3D3D6E3F766F696420303A6E2E6F626A6563742E676574427261636B657473496E52616E676528652C7429297C7C73752E656D7074797D66696E644D61746368696E67427261636B6574557028652C742C6E297B636F';
wwv_flow_imp.g_varchar2_table(6187) := '6E737420693D746869732E746578744D6F64656C2E76616C6964617465506F736974696F6E2874292C6F3D746869732E746578744D6F64656C2E6765744C616E677561676549644174506F736974696F6E28692E6C696E654E756D6265722C692E636F6C';
wwv_flow_imp.g_varchar2_table(6188) := '756D6E293B696628746869732E63616E4275696C64415354297B636F6E7374206E3D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F292E62726163';
wwv_flow_imp.g_varchar2_table(6189) := '6B6574734E65772E676574436C6F73696E67427261636B6574496E666F2865293B696628216E2972657475726E206E756C6C3B636F6E737420693D746869732E676574427261636B65745061697273496E52616E67652872682E66726F6D506F73697469';
wwv_flow_imp.g_varchar2_table(6190) := '6F6E7328742C7429292E66696E644C6173742828653D3E6E2E636C6F73657328652E6F70656E696E67427261636B6574496E666F2929293B72657475726E20693F692E6F70656E696E67427261636B657452616E67653A6E756C6C7D7B636F6E73742074';
wwv_flow_imp.g_varchar2_table(6191) := '3D652E746F4C6F7765724361736528292C733D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F292E627261636B6574733B69662821732972657475';
wwv_flow_imp.g_varchar2_table(6192) := '726E206E756C6C3B636F6E737420723D732E746578744973427261636B65745B745D3B72657475726E20723F436D28746869732E5F66696E644D61746368696E67427261636B6574557028722C692C796D286E2929293A6E756C6C7D7D6D617463684272';
wwv_flow_imp.g_varchar2_table(6193) := '61636B657428652C74297B696628746869732E63616E4275696C64415354297B636F6E737420743D746869732E676574427261636B65745061697273496E52616E67652872682E66726F6D506F736974696F6E7328652C6529292E66696C746572282874';
wwv_flow_imp.g_varchar2_table(6194) := '3D3E766F69642030213D3D742E636C6F73696E67427261636B657452616E6765262628742E6F70656E696E67427261636B657452616E67652E636F6E7461696E73506F736974696F6E2865297C7C742E636C6F73696E67427261636B657452616E67652E';
wwv_flow_imp.g_varchar2_table(6195) := '636F6E7461696E73506F736974696F6E2865292929292E66696E644C6173744D617842792865752828743D3E742E6F70656E696E67427261636B657452616E67652E636F6E7461696E73506F736974696F6E2865293F742E6F70656E696E67427261636B';
wwv_flow_imp.g_varchar2_table(6196) := '657452616E67653A742E636C6F73696E67427261636B657452616E6765292C72682E636F6D7061726552616E6765735573696E6753746172747329293B72657475726E20743F5B742E6F70656E696E67427261636B657452616E67652C742E636C6F7369';
wwv_flow_imp.g_varchar2_table(6197) := '6E67427261636B657452616E67655D3A6E756C6C7D7B636F6E7374206E3D796D2874293B72657475726E20746869732E5F6D61746368427261636B657428746869732E746578744D6F64656C2E76616C6964617465506F736974696F6E2865292C6E297D';
wwv_flow_imp.g_varchar2_table(6198) := '7D5F65737461626C697368427261636B65745365617263684F66667365747328652C742C6E2C69297B636F6E7374206F3D742E676574436F756E7428292C733D742E6765744C616E677561676549642869293B6C657420723D4D6174682E6D617828302C';
wwv_flow_imp.g_varchar2_table(6199) := '652E636F6C756D6E2D312D6E2E6D6178427261636B65744C656E677468293B666F72286C657420653D692D313B653E3D303B652D2D297B636F6E7374206E3D742E676574456E644F66667365742865293B6966286E3C3D7229627265616B3B6966287A75';
wwv_flow_imp.g_varchar2_table(6200) := '28742E6765745374616E64617264546F6B656E54797065286529297C7C742E6765744C616E67756167654964286529213D3D73297B723D6E3B627265616B7D7D6C657420613D4D6174682E6D696E28742E6765744C696E65436F6E74656E7428292E6C65';
wwv_flow_imp.g_varchar2_table(6201) := '6E6774682C652E636F6C756D6E2D312B6E2E6D6178427261636B65744C656E677468293B666F72286C657420653D692B313B653C6F3B652B2B297B636F6E7374206E3D742E67657453746172744F66667365742865293B6966286E3E3D6129627265616B';
wwv_flow_imp.g_varchar2_table(6202) := '3B6966287A7528742E6765745374616E64617264546F6B656E54797065286529297C7C742E6765744C616E67756167654964286529213D3D73297B613D6E3B627265616B7D7D72657475726E7B73656172636853746172744F66667365743A722C736561';
wwv_flow_imp.g_varchar2_table(6203) := '726368456E644F66667365743A617D7D5F6D61746368427261636B657428652C74297B636F6E7374206E3D652E6C696E654E756D6265722C693D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E7328';
wwv_flow_imp.g_varchar2_table(6204) := '6E292C6F3D746869732E746578744D6F64656C2E6765744C696E65436F6E74656E74286E292C733D692E66696E64546F6B656E496E64657841744F666673657428652E636F6C756D6E2D31293B696628733C302972657475726E206E756C6C3B636F6E73';
wwv_flow_imp.g_varchar2_table(6205) := '7420723D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28692E6765744C616E67756167654964287329292E627261636B6574733B696628722626217A';
wwv_flow_imp.g_varchar2_table(6206) := '7528692E6765745374616E64617264546F6B656E5479706528732929297B6C65747B73656172636853746172744F66667365743A612C736561726368456E644F66667365743A6C7D3D746869732E5F65737461626C697368427261636B65745365617263';
wwv_flow_imp.g_varchar2_table(6207) := '684F66667365747328652C692C722C73292C633D6E756C6C3B666F72283B3B297B636F6E737420693D68702E66696E644E657874427261636B6574496E52616E676528722E666F727761726452656765782C6E2C6F2C612C6C293B696628216929627265';
wwv_flow_imp.g_varchar2_table(6208) := '616B3B696628692E7374617274436F6C756D6E3C3D652E636F6C756D6E2626652E636F6C756D6E3C3D692E656E64436F6C756D6E297B636F6E737420653D6F2E737562737472696E6728692E7374617274436F6C756D6E2D312C692E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(6209) := '6E2D31292E746F4C6F7765724361736528292C6E3D746869732E5F6D61746368466F756E64427261636B657428692C722E746578744973427261636B65745B655D2C722E7465787449734F70656E427261636B65745B655D2C74293B6966286E297B6966';
wwv_flow_imp.g_varchar2_table(6210) := '286E20696E7374616E63656F6620776D2972657475726E206E756C6C3B633D6E7D7D613D692E656E64436F6C756D6E2D317D696628632972657475726E20637D696628733E302626692E67657453746172744F66667365742873293D3D3D652E636F6C75';
wwv_flow_imp.g_varchar2_table(6211) := '6D6E2D31297B636F6E737420723D732D312C613D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28692E6765744C616E67756167654964287229292E62';
wwv_flow_imp.g_varchar2_table(6212) := '7261636B6574733B696628612626217A7528692E6765745374616E64617264546F6B656E5479706528722929297B636F6E73747B73656172636853746172744F66667365743A732C736561726368456E644F66667365743A6C7D3D746869732E5F657374';
wwv_flow_imp.g_varchar2_table(6213) := '61626C697368427261636B65745365617263684F66667365747328652C692C612C72292C633D68702E66696E6450726576427261636B6574496E52616E676528612E726576657273656452656765782C6E2C6F2C732C6C293B696628632626632E737461';
wwv_flow_imp.g_varchar2_table(6214) := '7274436F6C756D6E3C3D652E636F6C756D6E2626652E636F6C756D6E3C3D632E656E64436F6C756D6E297B636F6E737420653D6F2E737562737472696E6728632E7374617274436F6C756D6E2D312C632E656E64436F6C756D6E2D31292E746F4C6F7765';
wwv_flow_imp.g_varchar2_table(6215) := '724361736528292C6E3D746869732E5F6D61746368466F756E64427261636B657428632C612E746578744973427261636B65745B655D2C612E7465787449734F70656E427261636B65745B655D2C74293B6966286E2972657475726E206E20696E737461';
wwv_flow_imp.g_varchar2_table(6216) := '6E63656F6620776D3F6E756C6C3A6E7D7D7D72657475726E206E756C6C7D5F6D61746368466F756E64427261636B657428652C742C6E2C69297B69662821742972657475726E206E756C6C3B636F6E7374206F3D6E3F746869732E5F66696E644D617463';
wwv_flow_imp.g_varchar2_table(6217) := '68696E67427261636B6574446F776E28742C652E676574456E64506F736974696F6E28292C69293A746869732E5F66696E644D61746368696E67427261636B6574557028742C652E6765745374617274506F736974696F6E28292C69293B72657475726E';
wwv_flow_imp.g_varchar2_table(6218) := '206F3F6F20696E7374616E63656F6620776D3F6F3A5B652C6F5D3A6E756C6C7D5F66696E644D61746368696E67427261636B6574557028652C742C6E297B636F6E737420693D652E6C616E677561676549642C6F3D652E72657665727365645265676578';
wwv_flow_imp.g_varchar2_table(6219) := '3B6C657420733D2D312C723D303B636F6E737420613D28742C692C612C6C293D3E7B666F72283B3B297B6966286E26262B2B72253130303D3D302626216E28292972657475726E20776D2E494E5354414E43453B636F6E737420633D68702E66696E6450';
wwv_flow_imp.g_varchar2_table(6220) := '726576427261636B6574496E52616E6765286F2C742C692C612C6C293B696628216329627265616B3B636F6E737420643D692E737562737472696E6728632E7374617274436F6C756D6E2D312C632E656E64436F6C756D6E2D31292E746F4C6F77657243';
wwv_flow_imp.g_varchar2_table(6221) := '61736528293B696628652E69734F70656E2864293F732B2B3A652E6973436C6F73652864292626732D2D2C303D3D3D732972657475726E20633B6C3D632E7374617274436F6C756D6E2D317D72657475726E206E756C6C7D3B666F72286C657420653D74';
wwv_flow_imp.g_varchar2_table(6222) := '2E6C696E654E756D6265723B653E3D313B652D2D297B636F6E7374206E3D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732865292C6F3D6E2E676574436F756E7428292C733D746869732E746578';
wwv_flow_imp.g_varchar2_table(6223) := '744D6F64656C2E6765744C696E65436F6E74656E742865293B6C657420723D6F2D312C6C3D732E6C656E6774682C633D732E6C656E6774683B653D3D3D742E6C696E654E756D626572262628723D6E2E66696E64546F6B656E496E64657841744F666673';
wwv_flow_imp.g_varchar2_table(6224) := '657428742E636F6C756D6E2D31292C6C3D742E636F6C756D6E2D312C633D742E636F6C756D6E2D31293B6C657420643D21303B666F72283B723E3D303B722D2D297B636F6E737420743D6E2E6765744C616E677561676549642872293D3D3D692626217A';
wwv_flow_imp.g_varchar2_table(6225) := '75286E2E6765745374616E64617264546F6B656E54797065287229293B6966287429643F6C3D6E2E67657453746172744F66667365742872293A286C3D6E2E67657453746172744F66667365742872292C633D6E2E676574456E644F6666736574287229';
wwv_flow_imp.g_varchar2_table(6226) := '293B656C7365206966286426266C213D3D63297B636F6E737420743D6128652C732C6C2C63293B696628742972657475726E20747D643D747D6966286426266C213D3D63297B636F6E737420743D6128652C732C6C2C63293B696628742972657475726E';
wwv_flow_imp.g_varchar2_table(6227) := '20747D7D72657475726E206E756C6C7D5F66696E644D61746368696E67427261636B6574446F776E28652C742C6E297B636F6E737420693D652E6C616E677561676549642C6F3D652E666F727761726452656765783B6C657420733D312C723D303B636F';
wwv_flow_imp.g_varchar2_table(6228) := '6E737420613D28742C692C612C6C293D3E7B666F72283B3B297B6966286E26262B2B72253130303D3D302626216E28292972657475726E20776D2E494E5354414E43453B636F6E737420633D68702E66696E644E657874427261636B6574496E52616E67';
wwv_flow_imp.g_varchar2_table(6229) := '65286F2C742C692C612C6C293B696628216329627265616B3B636F6E737420643D692E737562737472696E6728632E7374617274436F6C756D6E2D312C632E656E64436F6C756D6E2D31292E746F4C6F7765724361736528293B696628652E69734F7065';
wwv_flow_imp.g_varchar2_table(6230) := '6E2864293F732B2B3A652E6973436C6F73652864292626732D2D2C303D3D3D732972657475726E20633B613D632E656E64436F6C756D6E2D317D72657475726E206E756C6C7D2C6C3D746869732E746578744D6F64656C2E6765744C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(6231) := '28293B666F72286C657420653D742E6C696E654E756D6265723B653C3D6C3B652B2B297B636F6E7374206E3D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732865292C6F3D6E2E676574436F756E';
wwv_flow_imp.g_varchar2_table(6232) := '7428292C733D746869732E746578744D6F64656C2E6765744C696E65436F6E74656E742865293B6C657420723D302C6C3D302C633D303B653D3D3D742E6C696E654E756D626572262628723D6E2E66696E64546F6B656E496E64657841744F6666736574';
wwv_flow_imp.g_varchar2_table(6233) := '28742E636F6C756D6E2D31292C6C3D742E636F6C756D6E2D312C633D742E636F6C756D6E2D31293B6C657420643D21303B666F72283B723C6F3B722B2B297B636F6E737420743D6E2E6765744C616E677561676549642872293D3D3D692626217A75286E';
wwv_flow_imp.g_varchar2_table(6234) := '2E6765745374616E64617264546F6B656E54797065287229293B6966287429647C7C286C3D6E2E67657453746172744F6666736574287229292C633D6E2E676574456E644F66667365742872293B656C7365206966286426266C213D3D63297B636F6E73';
wwv_flow_imp.g_varchar2_table(6235) := '7420743D6128652C732C6C2C63293B696628742972657475726E20747D643D747D6966286426266C213D3D63297B636F6E737420743D6128652C732C6C2C63293B696628742972657475726E20747D7D72657475726E206E756C6C7D66696E6450726576';
wwv_flow_imp.g_varchar2_table(6236) := '427261636B65742865297B76617220743B636F6E7374206E3D746869732E746578744D6F64656C2E76616C6964617465506F736974696F6E2865293B696628746869732E63616E4275696C644153542972657475726E20746869732E627261636B657473';
wwv_flow_imp.g_varchar2_table(6237) := '5265717565737465643D21302C746869732E757064617465427261636B657450616972735472656528292C286E756C6C3D3D3D28743D746869732E627261636B65745061697273547265652E76616C7565297C7C766F696420303D3D3D743F766F696420';
wwv_flow_imp.g_varchar2_table(6238) := '303A742E6F626A6563742E6765744669727374427261636B65744265666F7265286E29297C7C6E756C6C3B6C657420693D6E756C6C2C6F3D6E756C6C2C733D6E756C6C3B666F72286C657420653D6E2E6C696E654E756D6265723B653E3D313B652D2D29';
wwv_flow_imp.g_varchar2_table(6239) := '7B636F6E737420743D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732865292C723D742E676574436F756E7428292C613D746869732E746578744D6F64656C2E6765744C696E65436F6E74656E74';
wwv_flow_imp.g_varchar2_table(6240) := '2865293B6C6574206C3D722D312C633D612E6C656E6774682C643D612E6C656E6774683B696628653D3D3D6E2E6C696E654E756D626572297B6C3D742E66696E64546F6B656E496E64657841744F6666736574286E2E636F6C756D6E2D31292C633D6E2E';
wwv_flow_imp.g_varchar2_table(6241) := '636F6C756D6E2D312C643D6E2E636F6C756D6E2D313B636F6E737420653D742E6765744C616E67756167654964286C293B69213D3D65262628693D652C6F3D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E676574';
wwv_flow_imp.g_varchar2_table(6242) := '4C616E6775616765436F6E66696775726174696F6E2869292E627261636B6574732C733D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2869292E6272';
wwv_flow_imp.g_varchar2_table(6243) := '61636B6574734E6577297D6C657420683D21303B666F72283B6C3E3D303B6C2D2D297B636F6E7374206E3D742E6765744C616E67756167654964286C293B69662869213D3D6E297B6966286F262673262668262663213D3D64297B636F6E737420743D68';
wwv_flow_imp.g_varchar2_table(6244) := '702E66696E6450726576427261636B6574496E52616E6765286F2E726576657273656452656765782C652C612C632C64293B696628742972657475726E20746869732E5F746F466F756E64427261636B657428732C74293B683D21317D693D6E2C6F3D74';
wwv_flow_imp.g_varchar2_table(6245) := '6869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2869292E627261636B6574732C733D746869732E6C616E6775616765436F6E66696775726174696F6E5365';
wwv_flow_imp.g_varchar2_table(6246) := '72766963652E6765744C616E6775616765436F6E66696775726174696F6E2869292E627261636B6574734E65777D636F6E737420723D21216F2626217A7528742E6765745374616E64617264546F6B656E54797065286C29293B6966287229683F633D74';
wwv_flow_imp.g_varchar2_table(6247) := '2E67657453746172744F6666736574286C293A28633D742E67657453746172744F6666736574286C292C643D742E676574456E644F6666736574286C29293B656C7365206966287326266F262668262663213D3D64297B636F6E737420743D68702E6669';
wwv_flow_imp.g_varchar2_table(6248) := '6E6450726576427261636B6574496E52616E6765286F2E726576657273656452656765782C652C612C632C64293B696628742972657475726E20746869732E5F746F466F756E64427261636B657428732C74297D683D727D6966287326266F2626682626';
wwv_flow_imp.g_varchar2_table(6249) := '63213D3D64297B636F6E737420743D68702E66696E6450726576427261636B6574496E52616E6765286F2E726576657273656452656765782C652C612C632C64293B696628742972657475726E20746869732E5F746F466F756E64427261636B65742873';
wwv_flow_imp.g_varchar2_table(6250) := '2C74297D7D72657475726E206E756C6C7D66696E644E657874427261636B65742865297B76617220743B636F6E7374206E3D746869732E746578744D6F64656C2E76616C6964617465506F736974696F6E2865293B696628746869732E63616E4275696C';
wwv_flow_imp.g_varchar2_table(6251) := '644153542972657475726E20746869732E627261636B6574735265717565737465643D21302C746869732E757064617465427261636B657450616972735472656528292C286E756C6C3D3D3D28743D746869732E627261636B6574506169727354726565';
wwv_flow_imp.g_varchar2_table(6252) := '2E76616C7565297C7C766F696420303D3D3D743F766F696420303A742E6F626A6563742E6765744669727374427261636B65744166746572286E29297C7C6E756C6C3B636F6E737420693D746869732E746578744D6F64656C2E6765744C696E65436F75';
wwv_flow_imp.g_varchar2_table(6253) := '6E7428293B6C6574206F3D6E756C6C2C733D6E756C6C2C723D6E756C6C3B666F72286C657420653D6E2E6C696E654E756D6265723B653C3D693B652B2B297B636F6E737420743D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E67';
wwv_flow_imp.g_varchar2_table(6254) := '65744C696E65546F6B656E732865292C693D742E676574436F756E7428292C613D746869732E746578744D6F64656C2E6765744C696E65436F6E74656E742865293B6C6574206C3D302C633D302C643D303B696628653D3D3D6E2E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(6255) := '72297B6C3D742E66696E64546F6B656E496E64657841744F6666736574286E2E636F6C756D6E2D31292C633D6E2E636F6C756D6E2D312C643D6E2E636F6C756D6E2D313B636F6E737420653D742E6765744C616E67756167654964286C293B6F213D3D65';
wwv_flow_imp.g_varchar2_table(6256) := '2626286F3D652C733D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F292E627261636B6574732C723D746869732E6C616E6775616765436F6E6669';
wwv_flow_imp.g_varchar2_table(6257) := '6775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F292E627261636B6574734E6577297D6C657420683D21303B666F72283B6C3C693B6C2B2B297B636F6E7374206E3D742E6765744C616E67756167';
wwv_flow_imp.g_varchar2_table(6258) := '654964286C293B6966286F213D3D6E297B69662872262673262668262663213D3D64297B636F6E737420743D68702E66696E644E657874427261636B6574496E52616E676528732E666F727761726452656765782C652C612C632C64293B696628742972';
wwv_flow_imp.g_varchar2_table(6259) := '657475726E20746869732E5F746F466F756E64427261636B657428722C74293B683D21317D6F3D6E2C733D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(6260) := '6E286F292E627261636B6574732C723D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F292E627261636B6574734E65777D636F6E737420693D2121';
wwv_flow_imp.g_varchar2_table(6261) := '732626217A7528742E6765745374616E64617264546F6B656E54797065286C29293B6966286929687C7C28633D742E67657453746172744F6666736574286C29292C643D742E676574456E644F6666736574286C293B656C736520696628722626732626';
wwv_flow_imp.g_varchar2_table(6262) := '68262663213D3D64297B636F6E737420743D68702E66696E644E657874427261636B6574496E52616E676528732E666F727761726452656765782C652C612C632C64293B696628742972657475726E20746869732E5F746F466F756E64427261636B6574';
wwv_flow_imp.g_varchar2_table(6263) := '28722C74297D683D697D69662872262673262668262663213D3D64297B636F6E737420743D68702E66696E644E657874427261636B6574496E52616E676528732E666F727761726452656765782C652C612C632C64293B696628742972657475726E2074';
wwv_flow_imp.g_varchar2_table(6264) := '6869732E5F746F466F756E64427261636B657428722C74297D7D72657475726E206E756C6C7D66696E64456E636C6F73696E67427261636B65747328652C74297B636F6E7374206E3D746869732E746578744D6F64656C2E76616C6964617465506F7369';
wwv_flow_imp.g_varchar2_table(6265) := '74696F6E2865293B696628746869732E63616E4275696C64415354297B636F6E737420653D72682E66726F6D506F736974696F6E73286E292C743D746869732E676574427261636B65745061697273496E52616E67652872682E66726F6D506F73697469';
wwv_flow_imp.g_varchar2_table(6266) := '6F6E73286E2C6E29292E66696E644C6173742828743D3E766F69642030213D3D742E636C6F73696E67427261636B657452616E67652626742E72616E67652E737472696374436F6E7461696E7352616E676528652929293B72657475726E20743F5B742E';
wwv_flow_imp.g_varchar2_table(6267) := '6F70656E696E67427261636B657452616E67652C742E636C6F73696E67427261636B657452616E67655D3A6E756C6C7D636F6E737420693D796D2874292C6F3D746869732E746578744D6F64656C2E6765744C696E65436F756E7428292C733D6E657720';
wwv_flow_imp.g_varchar2_table(6268) := '4D61703B6C657420723D5B5D3B636F6E737420613D28652C74293D3E7B69662821732E686173286529297B636F6E7374206E3D5B5D3B666F72286C657420653D302C693D743F742E627261636B6574732E6C656E6774683A303B653C693B652B2B296E5B';
wwv_flow_imp.g_varchar2_table(6269) := '655D3D303B732E73657428652C6E297D723D732E6765742865297D3B6C6574206C3D303B636F6E737420633D28652C742C6E2C6F2C73293D3E7B666F72283B3B297B6966286926262B2B6C253130303D3D302626216928292972657475726E20776D2E49';
wwv_flow_imp.g_varchar2_table(6270) := '4E5354414E43453B636F6E737420613D68702E66696E644E657874427261636B6574496E52616E676528652E666F727761726452656765782C742C6E2C6F2C73293B696628216129627265616B3B636F6E737420633D6E2E737562737472696E6728612E';
wwv_flow_imp.g_varchar2_table(6271) := '7374617274436F6C756D6E2D312C612E656E64436F6C756D6E2D31292E746F4C6F7765724361736528292C643D652E746578744973427261636B65745B635D3B69662864262628642E69734F70656E2863293F725B642E696E6465785D2B2B3A642E6973';
wwv_flow_imp.g_varchar2_table(6272) := '436C6F73652863292626725B642E696E6465785D2D2D2C2D313D3D3D725B642E696E6465785D292972657475726E20746869732E5F6D61746368466F756E64427261636B657428612C642C21312C69293B6F3D612E656E64436F6C756D6E2D317D726574';
wwv_flow_imp.g_varchar2_table(6273) := '75726E206E756C6C7D3B6C657420643D6E756C6C2C683D6E756C6C3B666F72286C657420653D6E2E6C696E654E756D6265723B653C3D6F3B652B2B297B636F6E737420743D746869732E746578744D6F64656C2E746F6B656E697A6174696F6E2E676574';
wwv_flow_imp.g_varchar2_table(6274) := '4C696E65546F6B656E732865292C693D742E676574436F756E7428292C6F3D746869732E746578744D6F64656C2E6765744C696E65436F6E74656E742865293B6C657420733D302C723D302C6C3D303B696628653D3D3D6E2E6C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(6275) := '7B733D742E66696E64546F6B656E496E64657841744F6666736574286E2E636F6C756D6E2D31292C723D6E2E636F6C756D6E2D312C6C3D6E2E636F6C756D6E2D313B636F6E737420653D742E6765744C616E677561676549642873293B64213D3D652626';
wwv_flow_imp.g_varchar2_table(6276) := '28643D652C683D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2864292E627261636B6574732C6128642C6829297D6C657420753D21303B666F72283B';
wwv_flow_imp.g_varchar2_table(6277) := '733C693B732B2B297B636F6E7374206E3D742E6765744C616E677561676549642873293B69662864213D3D6E297B69662868262675262672213D3D6C297B636F6E737420743D6328682C652C6F2C722C6C293B696628742972657475726E20436D287429';
wwv_flow_imp.g_varchar2_table(6278) := '3B753D21317D643D6E2C683D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2864292E627261636B6574732C6128642C68297D636F6E737420693D2121';
wwv_flow_imp.g_varchar2_table(6279) := '682626217A7528742E6765745374616E64617264546F6B656E54797065287329293B6966286929757C7C28723D742E67657453746172744F6666736574287329292C6C3D742E676574456E644F66667365742873293B656C736520696628682626752626';
wwv_flow_imp.g_varchar2_table(6280) := '72213D3D6C297B636F6E737420743D6328682C652C6F2C722C6C293B696628742972657475726E20436D2874297D753D697D69662868262675262672213D3D6C297B636F6E737420743D6328682C652C6F2C722C6C293B696628742972657475726E2043';
wwv_flow_imp.g_varchar2_table(6281) := '6D2874297D7D72657475726E206E756C6C7D5F746F466F756E64427261636B657428652C74297B69662821742972657475726E206E756C6C3B6C6574206E3D746869732E746578744D6F64656C2E67657456616C7565496E52616E67652874293B6E3D6E';
wwv_flow_imp.g_varchar2_table(6282) := '2E746F4C6F7765724361736528293B636F6E737420693D652E676574427261636B6574496E666F286E293B72657475726E20693F7B72616E67653A742C627261636B6574496E666F3A697D3A6E756C6C7D7D66756E6374696F6E20796D2865297B696628';
wwv_flow_imp.g_varchar2_table(6283) := '766F696420303D3D3D652972657475726E28293D3E21303B7B636F6E737420743D446174652E6E6F7728293B72657475726E28293D3E446174652E6E6F7728292D743C3D657D7D636C61737320776D7B636F6E7374727563746F7228297B746869732E5F';
wwv_flow_imp.g_varchar2_table(6284) := '73656172636843616E63656C65644272616E643D766F696420307D7D66756E6374696F6E20436D2865297B72657475726E206520696E7374616E63656F6620776D3F6E756C6C3A657D66756E6374696F6E20536D2865297B72657475726E602D2D767363';
wwv_flow_imp.g_varchar2_table(6285) := '6F64652D247B652E7265706C616365282F5C2E2F672C222D22297D607D66756E6374696F6E20786D2865297B72657475726E6076617228247B536D2865297D29607D776D2E494E5354414E43453D6E657720776D3B636F6E7374206B6D3D22626173652E';
wwv_flow_imp.g_varchar2_table(6286) := '636F6E747269627574696F6E732E636F6C6F7273222C456D3D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F6F6E4469644368616E6765536368656D613D6E65772043742C746869732E6F6E4469644368616E676553636865';
wwv_flow_imp.g_varchar2_table(6287) := '6D613D746869732E5F6F6E4469644368616E6765536368656D612E6576656E742C746869732E636F6C6F72536368656D613D7B747970653A226F626A656374222C70726F706572746965733A7B7D7D2C746869732E636F6C6F725265666572656E636553';
wwv_flow_imp.g_varchar2_table(6288) := '6368656D613D7B747970653A22737472696E67222C656E756D3A5B5D2C656E756D4465736372697074696F6E733A5B5D7D2C746869732E636F6C6F7273427949643D7B7D7D7265676973746572436F6C6F7228652C742C6E2C693D21312C6F297B636F6E';
wwv_flow_imp.g_varchar2_table(6289) := '737420733D7B69643A652C6465736372697074696F6E3A6E2C64656661756C74733A742C6E656564735472616E73706172656E63793A692C6465707265636174696F6E4D6573736167653A6F7D3B746869732E636F6C6F7273427949645B655D3D733B63';
wwv_flow_imp.g_varchar2_table(6290) := '6F6E737420723D7B747970653A22737472696E67222C6465736372697074696F6E3A6E2C666F726D61743A22636F6C6F722D686578222C64656661756C74536E6970706574733A5B7B626F64793A22247B313A236666303030307D227D5D7D3B72657475';
wwv_flow_imp.g_varchar2_table(6291) := '726E206F262628722E6465707265636174696F6E4D6573736167653D6F292C69262628722E7061747465726E3D225E23283F3A283F3C726762613E5B302D39612D66412D665D7B337D5B302D39612D65412D455D297C283F3A5B302D39612D66412D465D';
wwv_flow_imp.g_varchar2_table(6292) := '7B367D283F3A283F215B66465D7B327D29283F3A5B302D39612D66412D465D7B327D292929293F24222C722E7061747465726E4572726F724D6573736167653D225468697320636F6C6F72206D757374206265207472616E73706172656E74206F722069';
wwv_flow_imp.g_varchar2_table(6293) := '742077696C6C206F62736375726520636F6E74656E7422292C746869732E636F6C6F72536368656D612E70726F706572746965735B655D3D722C746869732E636F6C6F725265666572656E6365536368656D612E656E756D2E707573682865292C746869';
wwv_flow_imp.g_varchar2_table(6294) := '732E636F6C6F725265666572656E6365536368656D612E656E756D4465736372697074696F6E732E70757368286E292C746869732E5F6F6E4469644368616E6765536368656D612E6669726528292C657D676574436F6C6F727328297B72657475726E20';
wwv_flow_imp.g_varchar2_table(6295) := '4F626A6563742E6B65797328746869732E636F6C6F727342794964292E6D61702828653D3E746869732E636F6C6F7273427949645B655D29297D7265736F6C766544656661756C74436F6C6F7228652C74297B636F6E7374206E3D746869732E636F6C6F';
wwv_flow_imp.g_varchar2_table(6296) := '7273427949645B655D3B6966286E26266E2E64656661756C74732972657475726E204E6D286E2E64656661756C74735B742E747970655D2C74297D676574436F6C6F72536368656D6128297B72657475726E20746869732E636F6C6F72536368656D617D';
wwv_flow_imp.g_varchar2_table(6297) := '746F537472696E6728297B72657475726E204F626A6563742E6B65797328746869732E636F6C6F727342794964292E736F7274282828652C74293D3E7B636F6E7374206E3D2D313D3D3D652E696E6465784F6628222E22293F303A312C693D2D313D3D3D';
wwv_flow_imp.g_varchar2_table(6298) := '742E696E6465784F6628222E22293F303A313B72657475726E206E213D3D693F6E2D693A652E6C6F63616C65436F6D706172652874297D29292E6D61702828653D3E602D205C60247B657D5C603A20247B746869732E636F6C6F7273427949645B655D2E';
wwv_flow_imp.g_varchar2_table(6299) := '6465736372697074696F6E7D6029292E6A6F696E28225C6E22297D7D3B66756E6374696F6E204C6D28652C742C6E2C692C6F297B72657475726E20456D2E7265676973746572436F6C6F7228652C742C6E2C692C6F297D66756E6374696F6E20446D2865';
wwv_flow_imp.g_varchar2_table(6300) := '2C74297B72657475726E7B6F703A302C76616C75653A652C666163746F723A747D7D66756E6374696F6E20546D28652C74297B72657475726E7B6F703A312C76616C75653A652C666163746F723A747D7D66756E6374696F6E20496D28652C74297B7265';
wwv_flow_imp.g_varchar2_table(6301) := '7475726E7B6F703A322C76616C75653A652C666163746F723A747D7D66756E6374696F6E204D6D282E2E2E65297B72657475726E7B6F703A342C76616C7565733A657D7D66756E6374696F6E20416D28652C742C6E2C69297B72657475726E7B6F703A35';
wwv_flow_imp.g_varchar2_table(6302) := '2C76616C75653A652C6261636B67726F756E643A742C666163746F723A6E2C7472616E73706172656E63793A697D7D66756E6374696F6E204E6D28652C74297B6966286E756C6C213D3D652972657475726E22737472696E67223D3D747970656F662065';
wwv_flow_imp.g_varchar2_table(6303) := '3F2223223D3D3D655B305D3F68752E66726F6D4865782865293A742E676574436F6C6F722865293A6520696E7374616E63656F662068753F653A226F626A656374223D3D747970656F6620653F66756E6374696F6E28652C74297B766172206E2C692C6F';
wwv_flow_imp.g_varchar2_table(6304) := '2C733B73776974636828652E6F70297B6361736520303A72657475726E206E756C6C3D3D3D286E3D4E6D28652E76616C75652C7429297C7C766F696420303D3D3D6E3F766F696420303A6E2E6461726B656E28652E666163746F72293B6361736520313A';
wwv_flow_imp.g_varchar2_table(6305) := '72657475726E206E756C6C3D3D3D28693D4E6D28652E76616C75652C7429297C7C766F696420303D3D3D693F766F696420303A692E6C69676874656E28652E666163746F72293B6361736520323A72657475726E206E756C6C3D3D3D286F3D4E6D28652E';
wwv_flow_imp.g_varchar2_table(6306) := '76616C75652C7429297C7C766F696420303D3D3D6F3F766F696420303A6F2E7472616E73706172656E7428652E666163746F72293B6361736520333A7B636F6E7374206E3D4E6D28652E6261636B67726F756E642C74293B72657475726E206E3F6E756C';
wwv_flow_imp.g_varchar2_table(6307) := '6C3D3D3D28733D4E6D28652E76616C75652C7429297C7C766F696420303D3D3D733F766F696420303A732E6D616B654F7061717565286E293A4E6D28652E76616C75652C74297D6361736520343A666F7228636F6E7374206E206F6620652E76616C7565';
wwv_flow_imp.g_varchar2_table(6308) := '73297B636F6E737420653D4E6D286E2C74293B696628652972657475726E20657D72657475726E3B6361736520363A72657475726E204E6D28742E646566696E657328652E6966293F652E7468656E3A652E656C73652C74293B6361736520353A7B636F';
wwv_flow_imp.g_varchar2_table(6309) := '6E7374206E3D4E6D28652E76616C75652C74293B696628216E2972657475726E3B636F6E737420693D4E6D28652E6261636B67726F756E642C74293B72657475726E20693F6E2E69734461726B65725468616E2869293F68752E6765744C696768746572';
wwv_flow_imp.g_varchar2_table(6310) := '436F6C6F72286E2C692C652E666163746F72292E7472616E73706172656E7428652E7472616E73706172656E6379293A68752E6765744461726B6572436F6C6F72286E2C692C652E666163746F72292E7472616E73706172656E7428652E7472616E7370';
wwv_flow_imp.g_varchar2_table(6311) := '6172656E6379293A6E2E7472616E73706172656E7428652E666163746F722A652E7472616E73706172656E6379297D64656661756C743A7468726F7720666428297D7D28652C74293A766F696420307D79642E616464286B6D2C456D293B636F6E737420';
wwv_flow_imp.g_varchar2_table(6312) := '506D3D227673636F64653A2F2F736368656D61732F776F726B62656E63682D636F6C6F7273222C4F6D3D79642E6173284C70293B4F6D2E7265676973746572536368656D6128506D2C456D2E676574436F6C6F72536368656D612829293B636F6E737420';
wwv_flow_imp.g_varchar2_table(6313) := '526D3D6E6577204B74282828293D3E4F6D2E6E6F74696679536368656D614368616E67656428506D29292C323030293B456D2E6F6E4469644368616E6765536368656D61282828293D3E7B526D2E69735363686564756C656428297C7C526D2E73636865';
wwv_flow_imp.g_varchar2_table(6314) := '64756C6528297D29293B636F6E737420466D3D4C6D2822666F726567726F756E64222C7B6461726B3A2223434343434343222C6C696768743A2223363136313631222C68634461726B3A2223464646464646222C68634C696768743A2223323932393239';
wwv_flow_imp.g_varchar2_table(6315) := '227D2C6228302C224F766572616C6C20666F726567726F756E6420636F6C6F722E205468697320636F6C6F72206973206F6E6C792075736564206966206E6F74206F76657272696464656E206279206120636F6D706F6E656E742E2229292C426D3D284C';
wwv_flow_imp.g_varchar2_table(6316) := '6D282264697361626C6564466F726567726F756E64222C7B6461726B3A22234343434343433830222C6C696768743A22233631363136313830222C68634461726B3A2223413541354135222C68634C696768743A2223374637463746227D2C6228302C22';
wwv_flow_imp.g_varchar2_table(6317) := '4F766572616C6C20666F726567726F756E6420666F722064697361626C656420656C656D656E74732E205468697320636F6C6F72206973206F6E6C792075736564206966206E6F74206F76657272696464656E206279206120636F6D706F6E656E742E22';
wwv_flow_imp.g_varchar2_table(6318) := '29292C4C6D28226572726F72466F726567726F756E64222C7B6461726B3A2223463438373731222C6C696768743A2223413132363044222C68634461726B3A2223463438373731222C68634C696768743A2223423532303044227D2C6228302C224F7665';
wwv_flow_imp.g_varchar2_table(6319) := '72616C6C20666F726567726F756E6420636F6C6F7220666F72206572726F72206D657373616765732E205468697320636F6C6F72206973206F6E6C792075736564206966206E6F74206F76657272696464656E206279206120636F6D706F6E656E742E22';
wwv_flow_imp.g_varchar2_table(6320) := '29292C4C6D28226465736372697074696F6E466F726567726F756E64222C7B6C696768743A2223373137313731222C6461726B3A496D28466D2C2E37292C68634461726B3A496D28466D2C2E37292C68634C696768743A496D28466D2C2E37297D2C6228';
wwv_flow_imp.g_varchar2_table(6321) := '302C22466F726567726F756E6420636F6C6F7220666F72206465736372697074696F6E20746578742070726F766964696E67206164646974696F6E616C20696E666F726D6174696F6E2C20666F72206578616D706C6520666F722061206C6162656C2E22';
wwv_flow_imp.g_varchar2_table(6322) := '29292C4C6D282269636F6E2E666F726567726F756E64222C7B6461726B3A2223433543354335222C6C696768743A2223343234323432222C68634461726B3A2223464646464646222C68634C696768743A2223323932393239227D2C6228302C22546865';
wwv_flow_imp.g_varchar2_table(6323) := '2064656661756C7420636F6C6F7220666F722069636F6E7320696E2074686520776F726B62656E63682E222929292C566D3D4C6D2822666F637573426F72646572222C7B6461726B3A2223303037464434222C6C696768743A2223303039304631222C68';
wwv_flow_imp.g_varchar2_table(6324) := '634461726B3A2223463338353138222C68634C696768743A2223303036424244227D2C6228302C224F766572616C6C20626F7264657220636F6C6F7220666F7220666F637573656420656C656D656E74732E205468697320636F6C6F72206973206F6E6C';
wwv_flow_imp.g_varchar2_table(6325) := '792075736564206966206E6F74206F76657272696464656E206279206120636F6D706F6E656E742E2229292C7A6D3D4C6D2822636F6E7472617374426F72646572222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A22233646';
wwv_flow_imp.g_varchar2_table(6326) := '43334446222C68634C696768743A2223304634413835227D2C6228302C22416E20657874726120626F726465722061726F756E6420656C656D656E747320746F207365706172617465207468656D2066726F6D206F746865727320666F72206772656174';
wwv_flow_imp.g_varchar2_table(6327) := '657220636F6E74726173742E2229292C486D3D4C6D2822636F6E7472617374416374697665426F72646572222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A566D2C68634C696768743A566D7D2C6228302C22416E20657874';
wwv_flow_imp.g_varchar2_table(6328) := '726120626F726465722061726F756E642061637469766520656C656D656E747320746F207365706172617465207468656D2066726F6D206F746865727320666F72206772656174657220636F6E74726173742E2229292C576D3D284C6D282273656C6563';
wwv_flow_imp.g_varchar2_table(6329) := '74696F6E2E6261636B67726F756E64222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22546865206261636B67726F756E6420636F6C6F72206F6620746578742073';
wwv_flow_imp.g_varchar2_table(6330) := '656C656374696F6E7320696E2074686520776F726B62656E63682028652E672E20666F7220696E707574206669656C6473206F722074657874206172656173292E204E6F74652074686174207468697320646F6573206E6F74206170706C7920746F2073';
wwv_flow_imp.g_varchar2_table(6331) := '656C656374696F6E732077697468696E2074686520656469746F722E2229292C4C6D2822746578744C696E6B2E666F726567726F756E64222C7B6C696768743A2223303036414231222C6461726B3A2223333739344646222C68634461726B3A22233231';
wwv_flow_imp.g_varchar2_table(6332) := '41364646222C68634C696768743A2223304634413835227D2C6228302C22466F726567726F756E6420636F6C6F7220666F72206C696E6B7320696E20746578742E222929292C6A6D3D284C6D2822746578744C696E6B2E616374697665466F726567726F';
wwv_flow_imp.g_varchar2_table(6333) := '756E64222C7B6C696768743A2223303036414231222C6461726B3A2223333739344646222C68634461726B3A2223323141364646222C68634C696768743A2223304634413835227D2C6228302C22466F726567726F756E6420636F6C6F7220666F72206C';
wwv_flow_imp.g_varchar2_table(6334) := '696E6B7320696E2074657874207768656E20636C69636B6564206F6E20616E64206F6E206D6F75736520686F7665722E2229292C4C6D282274657874536570617261746F722E666F726567726F756E64222C7B6C696768743A2223303030303030326522';
wwv_flow_imp.g_varchar2_table(6335) := '2C6461726B3A22236666666666663265222C68634461726B3A68752E626C61636B2C68634C696768743A2223323932393239227D2C6228302C22436F6C6F7220666F72207465787420736570617261746F72732E2229292C4C6D28227465787450726566';
wwv_flow_imp.g_varchar2_table(6336) := '6F726D61742E666F726567726F756E64222C7B6C696768743A2223413331353135222C6461726B3A2223443742413744222C68634461726B3A2223303030303030222C68634C696768743A2223464646464646227D2C6228302C22466F726567726F756E';
wwv_flow_imp.g_varchar2_table(6337) := '6420636F6C6F7220666F7220707265666F726D61747465642074657874207365676D656E74732E2229292C4C6D282274657874507265666F726D61742E6261636B67726F756E64222C7B6C696768743A22233030303030303141222C6461726B3A222346';
wwv_flow_imp.g_varchar2_table(6338) := '46464646463141222C68634461726B3A2223464646464646222C68634C696768743A2223303933343566227D2C6228302C224261636B67726F756E6420636F6C6F7220666F7220707265666F726D61747465642074657874207365676D656E74732E2229';
wwv_flow_imp.g_varchar2_table(6339) := '292C4C6D282274657874426C6F636B51756F74652E6261636B67726F756E64222C7B6C696768743A2223663266326632222C6461726B3A2223323232323232222C68634461726B3A6E756C6C2C68634C696768743A2223463246324632227D2C6228302C';
wwv_flow_imp.g_varchar2_table(6340) := '224261636B67726F756E6420636F6C6F7220666F7220626C6F636B2071756F74657320696E20746578742E2229292C4C6D282274657874426C6F636B51756F74652E626F72646572222C7B6C696768743A22233030376163633830222C6461726B3A2223';
wwv_flow_imp.g_varchar2_table(6341) := '3030376163633830222C68634461726B3A68752E77686974652C68634C696768743A2223323932393239227D2C6228302C22426F7264657220636F6C6F7220666F7220626C6F636B2071756F74657320696E20746578742E2229292C4C6D282274657874';
wwv_flow_imp.g_varchar2_table(6342) := '436F6465426C6F636B2E6261636B67726F756E64222C7B6C696768743A22236463646364633636222C6461726B3A22233061306130613636222C68634461726B3A68752E626C61636B2C68634C696768743A2223463246324632227D2C6228302C224261';
wwv_flow_imp.g_varchar2_table(6343) := '636B67726F756E6420636F6C6F7220666F7220636F646520626C6F636B7320696E20746578742E2229292C4C6D2822736173682E686F766572426F72646572222C7B6461726B3A566D2C6C696768743A566D2C68634461726B3A566D2C68634C69676874';
wwv_flow_imp.g_varchar2_table(6344) := '3A566D7D2C6228302C22426F7264657220636F6C6F72206F6620616374697665207361736865732E2229292C4C6D282262616467652E6261636B67726F756E64222C7B6461726B3A2223344434443444222C6C696768743A2223433443344334222C6863';
wwv_flow_imp.g_varchar2_table(6345) := '4461726B3A68752E626C61636B2C68634C696768743A2223304634413835227D2C6228302C224261646765206261636B67726F756E6420636F6C6F722E204261646765732061726520736D616C6C20696E666F726D6174696F6E206C6162656C732C2065';
wwv_flow_imp.g_varchar2_table(6346) := '2E672E20666F722073656172636820726573756C747320636F756E742E222929292C716D3D4C6D282262616467652E666F726567726F756E64222C7B6461726B3A68752E77686974652C6C696768743A2223333333222C68634461726B3A68752E776869';
wwv_flow_imp.g_varchar2_table(6347) := '74652C68634C696768743A68752E77686974657D2C6228302C22426164676520666F726567726F756E6420636F6C6F722E204261646765732061726520736D616C6C20696E666F726D6174696F6E206C6162656C732C20652E672E20666F722073656172';
wwv_flow_imp.g_varchar2_table(6348) := '636820726573756C747320636F756E742E2229292C246D3D4C6D28227363726F6C6C6261722E736861646F77222C7B6461726B3A2223303030303030222C6C696768743A2223444444444444222C68634461726B3A6E756C6C2C68634C696768743A6E75';
wwv_flow_imp.g_varchar2_table(6349) := '6C6C7D2C6228302C225363726F6C6C62617220736861646F7720746F20696E6469636174652074686174207468652076696577206973207363726F6C6C65642E2229292C556D3D4C6D28227363726F6C6C626172536C696465722E6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(6350) := '64222C7B6461726B3A68752E66726F6D48657828222337393739373922292E7472616E73706172656E74282E34292C6C696768743A68752E66726F6D48657828222336343634363422292E7472616E73706172656E74282E34292C68634461726B3A496D';
wwv_flow_imp.g_varchar2_table(6351) := '287A6D2C2E36292C68634C696768743A496D287A6D2C2E34297D2C6228302C225363726F6C6C62617220736C69646572206261636B67726F756E6420636F6C6F722E2229292C4B6D3D4C6D28227363726F6C6C626172536C696465722E686F7665724261';
wwv_flow_imp.g_varchar2_table(6352) := '636B67726F756E64222C7B6461726B3A68752E66726F6D48657828222336343634363422292E7472616E73706172656E74282E37292C6C696768743A68752E66726F6D48657828222336343634363422292E7472616E73706172656E74282E37292C6863';
wwv_flow_imp.g_varchar2_table(6353) := '4461726B3A496D287A6D2C2E38292C68634C696768743A496D287A6D2C2E38297D2C6228302C225363726F6C6C62617220736C69646572206261636B67726F756E6420636F6C6F72207768656E20686F766572696E672E2229292C476D3D4C6D28227363';
wwv_flow_imp.g_varchar2_table(6354) := '726F6C6C626172536C696465722E6163746976654261636B67726F756E64222C7B6461726B3A68752E66726F6D48657828222342464246424622292E7472616E73706172656E74282E34292C6C696768743A68752E66726F6D4865782822233030303030';
wwv_flow_imp.g_varchar2_table(6355) := '3022292E7472616E73706172656E74282E36292C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C225363726F6C6C62617220736C69646572206261636B67726F756E6420636F6C6F72207768656E20636C69636B6564206F6E2E222929';
wwv_flow_imp.g_varchar2_table(6356) := '2C516D3D4C6D282270726F67726573734261722E6261636B67726F756E64222C7B6461726B3A68752E66726F6D48657828222330453730433022292C6C696768743A68752E66726F6D48657828222330453730433022292C68634461726B3A7A6D2C6863';
wwv_flow_imp.g_varchar2_table(6357) := '4C696768743A7A6D7D2C6228302C224261636B67726F756E6420636F6C6F72206F66207468652070726F67726573732062617220746861742063616E2073686F7720666F72206C6F6E672072756E6E696E67206F7065726174696F6E732E2229292C596D';
wwv_flow_imp.g_varchar2_table(6358) := '3D4C6D2822656469746F722E6261636B67726F756E64222C7B6C696768743A2223666666666666222C6461726B3A2223314531453145222C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C22456469746F';
wwv_flow_imp.g_varchar2_table(6359) := '72206261636B67726F756E6420636F6C6F722E2229292C5A6D3D4C6D2822656469746F722E666F726567726F756E64222C7B6C696768743A2223333333333333222C6461726B3A2223424242424242222C68634461726B3A68752E77686974652C68634C';
wwv_flow_imp.g_varchar2_table(6360) := '696768743A466D7D2C6228302C22456469746F722064656661756C7420666F726567726F756E6420636F6C6F722E2229292C586D3D284C6D2822656469746F72537469636B795363726F6C6C2E6261636B67726F756E64222C7B6C696768743A596D2C64';
wwv_flow_imp.g_varchar2_table(6361) := '61726B3A596D2C68634461726B3A596D2C68634C696768743A596D7D2C6228302C224261636B67726F756E6420636F6C6F72206F6620737469636B79207363726F6C6C20696E2074686520656469746F722229292C4C6D2822656469746F72537469636B';
wwv_flow_imp.g_varchar2_table(6362) := '795363726F6C6C486F7665722E6261636B67726F756E64222C7B6461726B3A2223324132443245222C6C696768743A2223463046304630222C68634461726B3A6E756C6C2C68634C696768743A68752E66726F6D48657828222330463441383522292E74';
wwv_flow_imp.g_varchar2_table(6363) := '72616E73706172656E74282E31297D2C6228302C224261636B67726F756E6420636F6C6F72206F6620737469636B79207363726F6C6C206F6E20686F76657220696E2074686520656469746F722229292C4C6D2822656469746F72537469636B79536372';
wwv_flow_imp.g_varchar2_table(6364) := '6F6C6C2E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F72206F6620737469636B79207363726F6C6C20696E20746865206564';
wwv_flow_imp.g_varchar2_table(6365) := '69746F722229292C4C6D2822656469746F72537469636B795363726F6C6C2E736861646F77222C7B6461726B3A246D2C6C696768743A246D2C68634461726B3A246D2C68634C696768743A246D7D2C6228302C2220536861646F7720636F6C6F72206F66';
wwv_flow_imp.g_varchar2_table(6366) := '20737469636B79207363726F6C6C20696E2074686520656469746F722229292C4C6D2822656469746F725769646765742E6261636B67726F756E64222C7B6461726B3A2223323532353236222C6C696768743A2223463346334633222C68634461726B3A';
wwv_flow_imp.g_varchar2_table(6367) := '2223304331343146222C68634C696768743A68752E77686974657D2C6228302C224261636B67726F756E6420636F6C6F72206F6620656469746F7220776964676574732C20737563682061732066696E642F7265706C6163652E222929292C4A6D3D4C6D';
wwv_flow_imp.g_varchar2_table(6368) := '2822656469746F725769646765742E666F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C22466F726567726F756E6420636F6C6F72206F6620656469746F722077';
wwv_flow_imp.g_varchar2_table(6369) := '6964676574732C20737563682061732066696E642F7265706C6163652E2229292C65663D4C6D2822656469746F725769646765742E626F72646572222C7B6461726B3A2223343534353435222C6C696768743A2223433843384338222C68634461726B3A';
wwv_flow_imp.g_varchar2_table(6370) := '7A6D2C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F72206F6620656469746F7220776964676574732E2054686520636F6C6F72206973206F6E6C79207573656420696620746865207769646765742063686F6F73657320746F20';
wwv_flow_imp.g_varchar2_table(6371) := '68617665206120626F7264657220616E642069662074686520636F6C6F72206973206E6F74206F76657272696464656E2062792061207769646765742E2229292C74663D284C6D2822656469746F725769646765742E726573697A65426F72646572222C';
wwv_flow_imp.g_varchar2_table(6372) := '7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22426F7264657220636F6C6F72206F662074686520726573697A6520626172206F6620656469746F7220776964676574';
wwv_flow_imp.g_varchar2_table(6373) := '732E2054686520636F6C6F72206973206F6E6C79207573656420696620746865207769646765742063686F6F73657320746F2068617665206120726573697A6520626F7264657220616E642069662074686520636F6C6F72206973206E6F74206F766572';
wwv_flow_imp.g_varchar2_table(6374) := '72696464656E2062792061207769646765742E2229292C4C6D2822656469746F724572726F722E6261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C62';
wwv_flow_imp.g_varchar2_table(6375) := '28302C224261636B67726F756E6420636F6C6F72206F66206572726F72207465787420696E2074686520656469746F722E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E64';
wwv_flow_imp.g_varchar2_table(6376) := '65726C79696E67206465636F726174696F6E732E22292C2130292C4C6D2822656469746F724572726F722E666F726567726F756E64222C7B6461726B3A2223463134433443222C6C696768743A2223453531343030222C68634461726B3A222346343837';
wwv_flow_imp.g_varchar2_table(6377) := '3731222C68634C696768743A2223423532303044227D2C6228302C22466F726567726F756E6420636F6C6F72206F66206572726F72207371756967676C69657320696E2074686520656469746F722E222929292C6E663D4C6D2822656469746F72457272';
wwv_flow_imp.g_varchar2_table(6378) := '6F722E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A68752E66726F6D48657828222345343737373722292E7472616E73706172656E74282E38292C68634C696768743A2223423532303044227D2C622830';
wwv_flow_imp.g_varchar2_table(6379) := '2C224966207365742C20636F6C6F72206F6620646F75626C6520756E6465726C696E657320666F72206572726F727320696E2074686520656469746F722E2229292C6F663D4C6D2822656469746F725761726E696E672E6261636B67726F756E64222C7B';
wwv_flow_imp.g_varchar2_table(6380) := '6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F72206F66207761726E696E67207465787420696E2074686520656469746F722E20';
wwv_flow_imp.g_varchar2_table(6381) := '54686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C73663D4C6D2822656469746F725761726E696E672E666F';
wwv_flow_imp.g_varchar2_table(6382) := '726567726F756E64222C7B6461726B3A2223434341373030222C6C696768743A2223424638383033222C68634461726B3A2223464644333730222C68634C696768743A2223383935353033227D2C6228302C22466F726567726F756E6420636F6C6F7220';
wwv_flow_imp.g_varchar2_table(6383) := '6F66207761726E696E67207371756967676C69657320696E2074686520656469746F722E2229292C72663D4C6D2822656469746F725761726E696E672E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6875';
wwv_flow_imp.g_varchar2_table(6384) := '2E66726F6D48657828222346464343303022292E7472616E73706172656E74282E38292C68634C696768743A68752E66726F6D48657828222346464343303022292E7472616E73706172656E74282E38297D2C6228302C224966207365742C20636F6C6F';
wwv_flow_imp.g_varchar2_table(6385) := '72206F6620646F75626C6520756E6465726C696E657320666F72207761726E696E677320696E2074686520656469746F722E2229292C61663D284C6D2822656469746F72496E666F2E6261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768';
wwv_flow_imp.g_varchar2_table(6386) := '743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F72206F6620696E666F207465787420696E2074686520656469746F722E2054686520636F6C6F72206D757374206E6F';
wwv_flow_imp.g_varchar2_table(6387) := '74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D2822656469746F72496E666F2E666F726567726F756E64222C7B6461726B3A22233337393446';
wwv_flow_imp.g_varchar2_table(6388) := '46222C6C696768743A2223316138356666222C68634461726B3A2223333739344646222C68634C696768743A2223316138356666227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620696E666F207371756967676C69657320696E2074';
wwv_flow_imp.g_varchar2_table(6389) := '686520656469746F722E222929292C6C663D4C6D2822656469746F72496E666F2E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A68752E66726F6D48657828222333373934464622292E7472616E73706172';
wwv_flow_imp.g_varchar2_table(6390) := '656E74282E38292C68634C696768743A2223323932393239227D2C6228302C224966207365742C20636F6C6F72206F6620646F75626C6520756E6465726C696E657320666F7220696E666F7320696E2074686520656469746F722E2229292C63663D4C6D';
wwv_flow_imp.g_varchar2_table(6391) := '2822656469746F7248696E742E666F726567726F756E64222C7B6461726B3A68752E66726F6D48657828222365656565656522292E7472616E73706172656E74282E37292C6C696768743A2223366336633663222C68634461726B3A6E756C6C2C68634C';
wwv_flow_imp.g_varchar2_table(6392) := '696768743A6E756C6C7D2C6228302C22466F726567726F756E6420636F6C6F72206F662068696E74207371756967676C69657320696E2074686520656469746F722E2229292C64663D284C6D2822656469746F7248696E742E626F72646572222C7B6461';
wwv_flow_imp.g_varchar2_table(6393) := '726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A68752E66726F6D48657828222365656565656522292E7472616E73706172656E74282E38292C68634C696768743A2223323932393239227D2C6228302C224966207365742C20636F6C6F';
wwv_flow_imp.g_varchar2_table(6394) := '72206F6620646F75626C6520756E6465726C696E657320666F722068696E747320696E2074686520656469746F722E2229292C4C6D2822656469746F724C696E6B2E616374697665466F726567726F756E64222C7B6461726B3A2223344539344345222C';
wwv_flow_imp.g_varchar2_table(6395) := '6C696768743A68752E626C75652C68634461726B3A68752E6379616E2C68634C696768743A2223323932393239227D2C6228302C22436F6C6F72206F6620616374697665206C696E6B732E222929292C68663D4C6D2822656469746F722E73656C656374';
wwv_flow_imp.g_varchar2_table(6396) := '696F6E4261636B67726F756E64222C7B6C696768743A2223414444364646222C6461726B3A2223323634463738222C68634461726B3A2223663366353138222C68634C696768743A2223304634413835227D2C6228302C22436F6C6F72206F6620746865';
wwv_flow_imp.g_varchar2_table(6397) := '20656469746F722073656C656374696F6E2E2229292C75663D4C6D2822656469746F722E73656C656374696F6E466F726567726F756E64222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A2223303030303030222C68634C69';
wwv_flow_imp.g_varchar2_table(6398) := '6768743A68752E77686974657D2C6228302C22436F6C6F72206F66207468652073656C6563746564207465787420666F72206869676820636F6E74726173742E2229292C70663D4C6D2822656469746F722E696E61637469766553656C656374696F6E42';
wwv_flow_imp.g_varchar2_table(6399) := '61636B67726F756E64222C7B6C696768743A496D2868662C2E35292C6461726B3A496D2868662C2E35292C68634461726B3A496D2868662C2E37292C68634C696768743A496D2868662C2E35297D2C6228302C22436F6C6F72206F66207468652073656C';
wwv_flow_imp.g_varchar2_table(6400) := '656374696F6E20696E20616E20696E61637469766520656469746F722E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E';
wwv_flow_imp.g_varchar2_table(6401) := '22292C2130292C67663D4C6D2822656469746F722E73656C656374696F6E486967686C696768744261636B67726F756E64222C7B6C696768743A416D2868662C596D2C2E332C2E36292C6461726B3A416D2868662C596D2C2E332C2E36292C6863446172';
wwv_flow_imp.g_varchar2_table(6402) := '6B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22436F6C6F7220666F7220726567696F6E732077697468207468652073616D6520636F6E74656E74206173207468652073656C656374696F6E2E2054686520636F6C6F72206D757374206E';
wwv_flow_imp.g_varchar2_table(6403) := '6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C6D663D284C6D2822656469746F722E73656C656374696F6E486967686C69676874426F72646572';
wwv_flow_imp.g_varchar2_table(6404) := '222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C22426F7264657220636F6C6F7220666F7220726567696F6E732077697468207468652073616D6520636F6E74656E74206173';
wwv_flow_imp.g_varchar2_table(6405) := '207468652073656C656374696F6E2E2229292C4C6D2822656469746F722E66696E644D617463684261636B67726F756E64222C7B6C696768743A2223413841433934222C6461726B3A2223353135433641222C68634461726B3A6E756C6C2C68634C6967';
wwv_flow_imp.g_varchar2_table(6406) := '68743A6E756C6C7D2C6228302C22436F6C6F72206F66207468652063757272656E7420736561726368206D617463682E2229292C4C6D2822656469746F722E66696E644D61746368486967686C696768744261636B67726F756E64222C7B6C696768743A';
wwv_flow_imp.g_varchar2_table(6407) := '22234541354330303535222C6461726B3A22234541354330303535222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22436F6C6F72206F6620746865206F7468657220736561726368206D6174636865732E205468652063';
wwv_flow_imp.g_varchar2_table(6408) := '6F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C213029292C66663D284C6D2822656469746F722E66696E6452616E6765486967';
wwv_flow_imp.g_varchar2_table(6409) := '686C696768744261636B67726F756E64222C7B6461726B3A22233361336434313636222C6C696768743A22236234623462343464222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22436F6C6F72206F6620746865207261';
wwv_flow_imp.g_varchar2_table(6410) := '6E6765206C696D6974696E6720746865207365617263682E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130';
wwv_flow_imp.g_varchar2_table(6411) := '292C4C6D2822656469746F722E66696E644D61746368426F72646572222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C22426F7264657220636F6C6F72206F66207468652063';
wwv_flow_imp.g_varchar2_table(6412) := '757272656E7420736561726368206D617463682E2229292C4C6D2822656469746F722E66696E644D61746368486967686C69676874426F72646572222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A486D2C68634C69676874';
wwv_flow_imp.g_varchar2_table(6413) := '3A486D7D2C6228302C22426F7264657220636F6C6F72206F6620746865206F7468657220736561726368206D6174636865732E222929292C76663D4C6D2822656469746F722E66696E6452616E6765486967686C69676874426F72646572222C7B646172';
wwv_flow_imp.g_varchar2_table(6414) := '6B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A496D28486D2C2E34292C68634C696768743A496D28486D2C2E34297D2C6228302C22426F7264657220636F6C6F72206F66207468652072616E6765206C696D6974696E6720746865207365';
wwv_flow_imp.g_varchar2_table(6415) := '617263682E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C62663D284C6D2822656469746F722E686F';
wwv_flow_imp.g_varchar2_table(6416) := '766572486967686C696768744261636B67726F756E64222C7B6C696768743A22234144443646463236222C6461726B3A22233236346637383430222C68634461726B3A22234144443646463236222C68634C696768743A6E756C6C7D2C6228302C224869';
wwv_flow_imp.g_varchar2_table(6417) := '67686C696768742062656C6F772074686520776F726420666F72207768696368206120686F7665722069732073686F776E2E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E';
wwv_flow_imp.g_varchar2_table(6418) := '6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D2822656469746F72486F7665725769646765742E6261636B67726F756E64222C7B6C696768743A586D2C6461726B3A586D2C68634461726B3A586D2C68634C696768743A586D';
wwv_flow_imp.g_varchar2_table(6419) := '7D2C6228302C224261636B67726F756E6420636F6C6F72206F662074686520656469746F7220686F7665722E222929292C5F663D284C6D2822656469746F72486F7665725769646765742E666F726567726F756E64222C7B6C696768743A4A6D2C646172';
wwv_flow_imp.g_varchar2_table(6420) := '6B3A4A6D2C68634461726B3A4A6D2C68634C696768743A4A6D7D2C6228302C22466F726567726F756E6420636F6C6F72206F662074686520656469746F7220686F7665722E2229292C4C6D2822656469746F72486F7665725769646765742E626F726465';
wwv_flow_imp.g_varchar2_table(6421) := '72222C7B6C696768743A65662C6461726B3A65662C68634461726B3A65662C68634C696768743A65667D2C6228302C22426F7264657220636F6C6F72206F662074686520656469746F7220686F7665722E222929292C79663D284C6D2822656469746F72';
wwv_flow_imp.g_varchar2_table(6422) := '486F7665725769646765742E7374617475734261724261636B67726F756E64222C7B6461726B3A546D2862662C2E32292C6C696768743A446D2862662C2E3035292C68634461726B3A586D2C68634C696768743A586D7D2C6228302C224261636B67726F';
wwv_flow_imp.g_varchar2_table(6423) := '756E6420636F6C6F72206F662074686520656469746F7220686F76657220737461747573206261722E2229292C4C6D2822656469746F72496E6C617948696E742E666F726567726F756E64222C7B6461726B3A2223393639363936222C6C696768743A22';
wwv_flow_imp.g_varchar2_table(6424) := '23393639363936222C68634461726B3A68752E77686974652C68634C696768743A68752E626C61636B7D2C6228302C22466F726567726F756E6420636F6C6F72206F6620696E6C696E652068696E7473222929292C77663D4C6D2822656469746F72496E';
wwv_flow_imp.g_varchar2_table(6425) := '6C617948696E742E6261636B67726F756E64222C7B6461726B3A496D286A6D2C2E31292C6C696768743A496D286A6D2C2E31292C68634461726B3A496D2868752E77686974652C2E31292C68634C696768743A496D286A6D2C2E31297D2C6228302C2242';
wwv_flow_imp.g_varchar2_table(6426) := '61636B67726F756E6420636F6C6F72206F6620696E6C696E652068696E74732229292C43663D4C6D2822656469746F72496E6C617948696E742E74797065466F726567726F756E64222C7B6461726B3A79662C6C696768743A79662C68634461726B3A79';
wwv_flow_imp.g_varchar2_table(6427) := '662C68634C696768743A79667D2C6228302C22466F726567726F756E6420636F6C6F72206F6620696E6C696E652068696E747320666F722074797065732229292C53663D4C6D2822656469746F72496E6C617948696E742E747970654261636B67726F75';
wwv_flow_imp.g_varchar2_table(6428) := '6E64222C7B6461726B3A77662C6C696768743A77662C68634461726B3A77662C68634C696768743A77667D2C6228302C224261636B67726F756E6420636F6C6F72206F6620696E6C696E652068696E747320666F722074797065732229292C78663D4C6D';
wwv_flow_imp.g_varchar2_table(6429) := '2822656469746F72496E6C617948696E742E706172616D65746572466F726567726F756E64222C7B6461726B3A79662C6C696768743A79662C68634461726B3A79662C68634C696768743A79667D2C6228302C22466F726567726F756E6420636F6C6F72';
wwv_flow_imp.g_varchar2_table(6430) := '206F6620696E6C696E652068696E747320666F7220706172616D65746572732229292C6B663D4C6D2822656469746F72496E6C617948696E742E706172616D657465724261636B67726F756E64222C7B6461726B3A77662C6C696768743A77662C686344';
wwv_flow_imp.g_varchar2_table(6431) := '61726B3A77662C68634C696768743A77667D2C6228302C224261636B67726F756E6420636F6C6F72206F6620696E6C696E652068696E747320666F7220706172616D65746572732229292C45663D4C6D2822656469746F724C6967687442756C622E666F';
wwv_flow_imp.g_varchar2_table(6432) := '726567726F756E64222C7B6461726B3A2223464643433030222C6C696768743A2223444442313030222C68634461726B3A2223464643433030222C68634C696768743A2223303037414343227D2C6228302C2254686520636F6C6F72207573656420666F';
wwv_flow_imp.g_varchar2_table(6433) := '7220746865206C6967687462756C6220616374696F6E732069636F6E2E2229292C4C663D284C6D2822656469746F724C6967687442756C624175746F4669782E666F726567726F756E64222C7B6461726B3A2223373542454646222C6C696768743A2223';
wwv_flow_imp.g_varchar2_table(6434) := '303037414343222C68634461726B3A2223373542454646222C68634C696768743A2223303037414343227D2C6228302C2254686520636F6C6F72207573656420666F7220746865206C6967687462756C62206175746F2066697820616374696F6E732069';
wwv_flow_imp.g_varchar2_table(6435) := '636F6E2E2229292C4C6D2822656469746F724C6967687442756C6241692E666F726567726F756E64222C7B6461726B3A45662C6C696768743A45662C68634461726B3A45662C68634C696768743A45667D2C6228302C2254686520636F6C6F7220757365';
wwv_flow_imp.g_varchar2_table(6436) := '6420666F7220746865206C6967687462756C622041492069636F6E2E2229292C4C6D2822656469746F722E736E697070657454616273746F70486967686C696768744261636B67726F756E64222C7B6461726B3A6E6577206875286E6577206C75283132';
wwv_flow_imp.g_varchar2_table(6437) := '342C3132342C3132342C2E3329292C6C696768743A6E6577206875286E6577206C752831302C35302C3130302C2E3229292C68634461726B3A6E6577206875286E6577206C75283132342C3132342C3132342C2E3329292C68634C696768743A6E657720';
wwv_flow_imp.g_varchar2_table(6438) := '6875286E6577206C752831302C35302C3130302C2E3229297D2C6228302C22486967686C69676874206261636B67726F756E6420636F6C6F72206F66206120736E69707065742074616273746F702E2229292C4C6D2822656469746F722E736E69707065';
wwv_flow_imp.g_varchar2_table(6439) := '7454616273746F70486967686C69676874426F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22486967686C6967687420626F7264657220636F6C6F72';
wwv_flow_imp.g_varchar2_table(6440) := '206F66206120736E69707065742074616273746F702E2229292C4C6D2822656469746F722E736E697070657446696E616C54616273746F70486967686C696768744261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68';
wwv_flow_imp.g_varchar2_table(6441) := '634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22486967686C69676874206261636B67726F756E6420636F6C6F72206F66207468652066696E616C2074616273746F70206F66206120736E69707065742E2229292C4C6D282265';
wwv_flow_imp.g_varchar2_table(6442) := '6469746F722E736E697070657446696E616C54616273746F70486967686C69676874426F72646572222C7B6461726B3A2223353235323532222C6C696768743A6E6577206875286E6577206C752831302C35302C3130302C2E3529292C68634461726B3A';
wwv_flow_imp.g_varchar2_table(6443) := '2223353235323532222C68634C696768743A2223323932393239227D2C6228302C22486967686C6967687420626F7264657220636F6C6F72206F66207468652066696E616C2074616273746F70206F66206120736E69707065742E2229292C6E65772068';
wwv_flow_imp.g_varchar2_table(6444) := '75286E6577206C75283135352C3138352C38352C2E322929292C44663D6E6577206875286E6577206C75283235352C302C302C2E3229292C54663D4C6D282264696666456469746F722E696E736572746564546578744261636B67726F756E64222C7B64';
wwv_flow_imp.g_varchar2_table(6445) := '61726B3A22233963636332633333222C6C696768743A22233963636332633430222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F7220666F722074657874207468617420676F7420';
wwv_flow_imp.g_varchar2_table(6446) := '696E7365727465642E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C49663D4C6D2822646966664564';
wwv_flow_imp.g_varchar2_table(6447) := '69746F722E72656D6F766564546578744261636B67726F756E64222C7B6461726B3A22236666303030303333222C6C696768743A22236666303030303333222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67';
wwv_flow_imp.g_varchar2_table(6448) := '726F756E6420636F6C6F7220666F722074657874207468617420676F742072656D6F7665642E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E6720646563';
wwv_flow_imp.g_varchar2_table(6449) := '6F726174696F6E732E22292C2130292C4D663D284C6D282264696666456469746F722E696E7365727465644C696E654261636B67726F756E64222C7B6461726B3A4C662C6C696768743A4C662C68634461726B3A6E756C6C2C68634C696768743A6E756C';
wwv_flow_imp.g_varchar2_table(6450) := '6C7D2C6228302C224261636B67726F756E6420636F6C6F7220666F72206C696E6573207468617420676F7420696E7365727465642E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F2068696465';
wwv_flow_imp.g_varchar2_table(6451) := '20756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D282264696666456469746F722E72656D6F7665644C696E654261636B67726F756E64222C7B6461726B3A44662C6C696768743A44662C68634461726B3A6E756C6C2C68';
wwv_flow_imp.g_varchar2_table(6452) := '634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F7220666F72206C696E6573207468617420676F742072656D6F7665642E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F';
wwv_flow_imp.g_varchar2_table(6453) := '7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D282264696666456469746F724775747465722E696E7365727465644C696E654261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768';
wwv_flow_imp.g_varchar2_table(6454) := '743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F7220666F7220746865206D617267696E207768657265206C696E657320676F7420696E7365727465642E2229292C4C';
wwv_flow_imp.g_varchar2_table(6455) := '6D282264696666456469746F724775747465722E72656D6F7665644C696E654261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B';
wwv_flow_imp.g_varchar2_table(6456) := '67726F756E6420636F6C6F7220666F7220746865206D617267696E207768657265206C696E657320676F742072656D6F7665642E2229292C4C6D282264696666456469746F724F766572766965772E696E736572746564466F726567726F756E64222C7B';
wwv_flow_imp.g_varchar2_table(6457) := '6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C2244696666206F766572766965772072756C657220666F726567726F756E6420666F7220696E73657274656420636F6E74';
wwv_flow_imp.g_varchar2_table(6458) := '656E742E222929292C41663D4C6D282264696666456469746F724F766572766965772E72656D6F766564466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C';
wwv_flow_imp.g_varchar2_table(6459) := '7D2C6228302C2244696666206F766572766965772072756C657220666F726567726F756E6420666F722072656D6F76656420636F6E74656E742E2229292C4E663D284C6D282264696666456469746F722E696E73657274656454657874426F7264657222';
wwv_flow_imp.g_varchar2_table(6460) := '2C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A22233333666632656666222C68634C696768743A2223333734453036227D2C6228302C224F75746C696E6520636F6C6F7220666F72207468652074657874207468617420676F';
wwv_flow_imp.g_varchar2_table(6461) := '7420696E7365727465642E2229292C4C6D282264696666456469746F722E72656D6F76656454657874426F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A2223464630303846222C68634C696768743A22234144';
wwv_flow_imp.g_varchar2_table(6462) := '30373037227D2C6228302C224F75746C696E6520636F6C6F7220666F722074657874207468617420676F742072656D6F7665642E2229292C4C6D282264696666456469746F722E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C';
wwv_flow_imp.g_varchar2_table(6463) := '2C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F72206265747765656E207468652074776F207465787420656469746F72732E2229292C4C6D282264696666456469746F722E646961676F6E616C46696C';
wwv_flow_imp.g_varchar2_table(6464) := '6C222C7B6461726B3A22236363636363633333222C6C696768743A22233232323232323333222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22436F6C6F72206F6620746865206469666620656469746F72277320646961';
wwv_flow_imp.g_varchar2_table(6465) := '676F6E616C2066696C6C2E2054686520646961676F6E616C2066696C6C206973207573656420696E20736964652D62792D7369646520646966662076696577732E2229292C4C6D282264696666456469746F722E756E6368616E676564526567696F6E42';
wwv_flow_imp.g_varchar2_table(6466) := '61636B67726F756E64222C7B6461726B3A22736964654261722E6261636B67726F756E64222C6C696768743A22736964654261722E6261636B67726F756E64222C68634461726B3A22736964654261722E6261636B67726F756E64222C68634C69676874';
wwv_flow_imp.g_varchar2_table(6467) := '3A22736964654261722E6261636B67726F756E64227D2C6228302C22546865206261636B67726F756E6420636F6C6F72206F6620756E6368616E67656420626C6F636B7320696E20746865206469666620656469746F722E2229292C4C6D282264696666';
wwv_flow_imp.g_varchar2_table(6468) := '456469746F722E756E6368616E676564526567696F6E466F726567726F756E64222C7B6461726B3A22666F726567726F756E64222C6C696768743A22666F726567726F756E64222C68634461726B3A22666F726567726F756E64222C68634C696768743A';
wwv_flow_imp.g_varchar2_table(6469) := '22666F726567726F756E64227D2C6228302C2254686520666F726567726F756E6420636F6C6F72206F6620756E6368616E67656420626C6F636B7320696E20746865206469666620656469746F722E2229292C4C6D282264696666456469746F722E756E';
wwv_flow_imp.g_varchar2_table(6470) := '6368616E676564436F64654261636B67726F756E64222C7B6461726B3A22233734373437343239222C6C696768743A22236238623862383239222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22546865206261636B6772';
wwv_flow_imp.g_varchar2_table(6471) := '6F756E6420636F6C6F72206F6620756E6368616E67656420636F646520696E20746865206469666620656469746F722E2229292C4C6D28227769646765742E736861646F77222C7B6461726B3A496D2868752E626C61636B2C2E3336292C6C696768743A';
wwv_flow_imp.g_varchar2_table(6472) := '496D2868752E626C61636B2C2E3136292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22536861646F7720636F6C6F72206F66207769646765747320737563682061732066696E642F7265706C61636520696E7369646520';
wwv_flow_imp.g_varchar2_table(6473) := '74686520656469746F722E222929292C50663D4C6D28227769646765742E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F7220';
wwv_flow_imp.g_varchar2_table(6474) := '6F66207769646765747320737563682061732066696E642F7265706C61636520696E736964652074686520656469746F722E2229292C4F663D4C6D2822746F6F6C6261722E686F7665724261636B67726F756E64222C7B6461726B3A2223356135643565';
wwv_flow_imp.g_varchar2_table(6475) := '3530222C6C696768743A22236238623862383530222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22546F6F6C626172206261636B67726F756E64207768656E20686F766572696E67206F76657220616374696F6E732075';
wwv_flow_imp.g_varchar2_table(6476) := '73696E6720746865206D6F7573652229292C52663D284C6D2822746F6F6C6261722E686F7665724F75746C696E65222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C22546F6F';
wwv_flow_imp.g_varchar2_table(6477) := '6C626172206F75746C696E65207768656E20686F766572696E67206F76657220616374696F6E73207573696E6720746865206D6F7573652229292C4C6D2822746F6F6C6261722E6163746976654261636B67726F756E64222C7B6461726B3A546D284F66';
wwv_flow_imp.g_varchar2_table(6478) := '2C2E31292C6C696768743A446D284F662C2E31292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22546F6F6C626172206261636B67726F756E64207768656E20686F6C64696E6720746865206D6F757365206F7665722061';
wwv_flow_imp.g_varchar2_table(6479) := '6374696F6E732229292C4C6D282262726561646372756D622E666F726567726F756E64222C7B6C696768743A496D28466D2C2E38292C6461726B3A496D28466D2C2E38292C68634461726B3A496D28466D2C2E38292C68634C696768743A496D28466D2C';
wwv_flow_imp.g_varchar2_table(6480) := '2E38297D2C6228302C22436F6C6F72206F6620666F63757365642062726561646372756D62206974656D732E222929292C46663D4C6D282262726561646372756D622E6261636B67726F756E64222C7B6C696768743A596D2C6461726B3A596D2C686344';
wwv_flow_imp.g_varchar2_table(6481) := '61726B3A596D2C68634C696768743A596D7D2C6228302C224261636B67726F756E6420636F6C6F72206F662062726561646372756D62206974656D732E2229292C42663D4C6D282262726561646372756D622E666F637573466F726567726F756E64222C';
wwv_flow_imp.g_varchar2_table(6482) := '7B6C696768743A446D28466D2C2E32292C6461726B3A546D28466D2C2E31292C68634461726B3A546D28466D2C2E31292C68634C696768743A546D28466D2C2E31297D2C6228302C22436F6C6F72206F6620666F63757365642062726561646372756D62';
wwv_flow_imp.g_varchar2_table(6483) := '206974656D732E2229292C56663D4C6D282262726561646372756D622E61637469766553656C656374696F6E466F726567726F756E64222C7B6C696768743A446D28466D2C2E32292C6461726B3A546D28466D2C2E31292C68634461726B3A546D28466D';
wwv_flow_imp.g_varchar2_table(6484) := '2C2E31292C68634C696768743A546D28466D2C2E31297D2C6228302C22436F6C6F72206F662073656C65637465642062726561646372756D62206974656D732E2229292C7A663D284C6D282262726561646372756D625069636B65722E6261636B67726F';
wwv_flow_imp.g_varchar2_table(6485) := '756E64222C7B6C696768743A586D2C6461726B3A586D2C68634461726B3A586D2C68634C696768743A586D7D2C6228302C224261636B67726F756E6420636F6C6F72206F662062726561646372756D62206974656D207069636B65722E2229292C68752E';
wwv_flow_imp.g_varchar2_table(6486) := '66726F6D48657828222334304338414522292E7472616E73706172656E74282E3529292C48663D68752E66726F6D48657828222334304136464622292E7472616E73706172656E74282E35292C57663D68752E66726F6D48657828222336303630363022';
wwv_flow_imp.g_varchar2_table(6487) := '292E7472616E73706172656E74282E34292C6A663D2E342C71663D4C6D28226D657267652E63757272656E744865616465724261636B67726F756E64222C7B6461726B3A7A662C6C696768743A7A662C68634461726B3A6E756C6C2C68634C696768743A';
wwv_flow_imp.g_varchar2_table(6488) := '6E756C6C7D2C6228302C2243757272656E7420686561646572206261636B67726F756E6420696E20696E6C696E65206D657267652D636F6E666C696374732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E';
wwv_flow_imp.g_varchar2_table(6489) := '6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C24663D284C6D28226D657267652E63757272656E74436F6E74656E744261636B67726F756E64222C7B6461726B3A496D2871662C6A66292C6C6967';
wwv_flow_imp.g_varchar2_table(6490) := '68743A496D2871662C6A66292C68634461726B3A496D2871662C6A66292C68634C696768743A496D2871662C6A66297D2C6228302C2243757272656E7420636F6E74656E74206261636B67726F756E6420696E20696E6C696E65206D657267652D636F6E';
wwv_flow_imp.g_varchar2_table(6491) := '666C696374732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D28226D657267652E696E636F6D';
wwv_flow_imp.g_varchar2_table(6492) := '696E674865616465724261636B67726F756E64222C7B6461726B3A48662C6C696768743A48662C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22496E636F6D696E6720686561646572206261636B67726F756E6420696E20';
wwv_flow_imp.g_varchar2_table(6493) := '696E6C696E65206D657267652D636F6E666C696374732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C213029';
wwv_flow_imp.g_varchar2_table(6494) := '292C55663D284C6D28226D657267652E696E636F6D696E67436F6E74656E744261636B67726F756E64222C7B6461726B3A496D2824662C6A66292C6C696768743A496D2824662C6A66292C68634461726B3A496D2824662C6A66292C68634C696768743A';
wwv_flow_imp.g_varchar2_table(6495) := '496D2824662C6A66297D2C6228302C22496E636F6D696E6720636F6E74656E74206261636B67726F756E6420696E20696E6C696E65206D657267652D636F6E666C696374732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520';
wwv_flow_imp.g_varchar2_table(6496) := '736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D28226D657267652E636F6D6D6F6E4865616465724261636B67726F756E64222C7B6461726B3A57662C6C696768743A57662C';
wwv_flow_imp.g_varchar2_table(6497) := '68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22436F6D6D6F6E20616E636573746F7220686561646572206261636B67726F756E6420696E20696E6C696E65206D657267652D636F6E666C696374732E2054686520636F6C6F';
wwv_flow_imp.g_varchar2_table(6498) := '72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C213029292C4B663D284C6D28226D657267652E636F6D6D6F6E436F6E74656E74426163';
wwv_flow_imp.g_varchar2_table(6499) := '6B67726F756E64222C7B6461726B3A496D2855662C6A66292C6C696768743A496D2855662C6A66292C68634461726B3A496D2855662C6A66292C68634C696768743A496D2855662C6A66297D2C6228302C22436F6D6D6F6E20616E636573746F7220636F';
wwv_flow_imp.g_varchar2_table(6500) := '6E74656E74206261636B67726F756E6420696E20696E6C696E65206D657267652D636F6E666C696374732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E';
wwv_flow_imp.g_varchar2_table(6501) := '67206465636F726174696F6E732E22292C2130292C4C6D28226D657267652E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A2223433344463646222C68634C696768743A2223303037414343227D2C622830';
wwv_flow_imp.g_varchar2_table(6502) := '2C22426F7264657220636F6C6F72206F6E206865616465727320616E64207468652073706C697474657220696E20696E6C696E65206D657267652D636F6E666C696374732E222929292C47663D284C6D2822656469746F724F7665727669657752756C65';
wwv_flow_imp.g_varchar2_table(6503) := '722E63757272656E74436F6E74656E74466F726567726F756E64222C7B6461726B3A496D2871662C31292C6C696768743A496D2871662C31292C68634461726B3A4B662C68634C696768743A4B667D2C6228302C2243757272656E74206F766572766965';
wwv_flow_imp.g_varchar2_table(6504) := '772072756C657220666F726567726F756E6420666F7220696E6C696E65206D657267652D636F6E666C696374732E2229292C4C6D2822656469746F724F7665727669657752756C65722E696E636F6D696E67436F6E74656E74466F726567726F756E6422';
wwv_flow_imp.g_varchar2_table(6505) := '2C7B6461726B3A496D2824662C31292C6C696768743A496D2824662C31292C68634461726B3A4B662C68634C696768743A4B667D2C6228302C22496E636F6D696E67206F766572766965772072756C657220666F726567726F756E6420666F7220696E6C';
wwv_flow_imp.g_varchar2_table(6506) := '696E65206D657267652D636F6E666C696374732E2229292C4C6D2822656469746F724F7665727669657752756C65722E636F6D6D6F6E436F6E74656E74466F726567726F756E64222C7B6461726B3A496D2855662C31292C6C696768743A496D2855662C';
wwv_flow_imp.g_varchar2_table(6507) := '31292C68634461726B3A4B662C68634C696768743A4B667D2C6228302C22436F6D6D6F6E20616E636573746F72206F766572766965772072756C657220666F726567726F756E6420666F7220696E6C696E65206D657267652D636F6E666C696374732E22';
wwv_flow_imp.g_varchar2_table(6508) := '29292C4C6D2822656469746F724F7665727669657752756C65722E66696E644D61746368466F726567726F756E64222C7B6461726B3A22236431383631363765222C6C696768743A22236431383631363765222C68634461726B3A222341423541303022';
wwv_flow_imp.g_varchar2_table(6509) := '2C68634C696768743A22227D2C6228302C224F766572766965772072756C6572206D61726B657220636F6C6F7220666F722066696E64206D6174636865732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E';
wwv_flow_imp.g_varchar2_table(6510) := '6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C213029292C51663D4C6D2822656469746F724F7665727669657752756C65722E73656C656374696F6E486967686C69676874466F726567726F756E64222C7B';
wwv_flow_imp.g_varchar2_table(6511) := '6461726B3A22234130413041304343222C6C696768743A22234130413041304343222C68634461726B3A22234130413041304343222C68634C696768743A22234130413041304343227D2C6228302C224F766572766965772072756C6572206D61726B65';
wwv_flow_imp.g_varchar2_table(6512) := '7220636F6C6F7220666F722073656C656374696F6E20686967686C69676874732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F72617469';
wwv_flow_imp.g_varchar2_table(6513) := '6F6E732E22292C2130292C59663D4C6D282270726F626C656D734572726F7249636F6E2E666F726567726F756E64222C7B6461726B3A74662C6C696768743A74662C68634461726B3A74662C68634C696768743A74667D2C6228302C2254686520636F6C';
wwv_flow_imp.g_varchar2_table(6514) := '6F72207573656420666F72207468652070726F626C656D73206572726F722069636F6E2E2229292C5A663D4C6D282270726F626C656D735761726E696E6749636F6E2E666F726567726F756E64222C7B6461726B3A73662C6C696768743A73662C686344';
wwv_flow_imp.g_varchar2_table(6515) := '61726B3A73662C68634C696768743A73667D2C6228302C2254686520636F6C6F72207573656420666F72207468652070726F626C656D73207761726E696E672069636F6E2E2229292C58663D4C6D282270726F626C656D73496E666F49636F6E2E666F72';
wwv_flow_imp.g_varchar2_table(6516) := '6567726F756E64222C7B6461726B3A61662C6C696768743A61662C68634461726B3A61662C68634C696768743A61667D2C6228302C2254686520636F6C6F72207573656420666F72207468652070726F626C656D7320696E666F2069636F6E2E2229292C';
wwv_flow_imp.g_varchar2_table(6517) := '4A663D4C6D28226D696E696D61702E66696E644D61746368486967686C69676874222C7B6C696768743A2223643138363136222C6461726B3A2223643138363136222C68634461726B3A2223414235413030222C68634C696768743A2223304634413835';
wwv_flow_imp.g_varchar2_table(6518) := '227D2C6228302C224D696E696D6170206D61726B657220636F6C6F7220666F722066696E64206D6174636865732E22292C2130292C65763D4C6D28226D696E696D61702E73656C656374696F6E4F6363757272656E6365486967686C69676874222C7B6C';
wwv_flow_imp.g_varchar2_table(6519) := '696768743A2223633963396339222C6461726B3A2223363736373637222C68634461726B3A2223666666666666222C68634C696768743A2223304634413835227D2C6228302C224D696E696D6170206D61726B657220636F6C6F7220666F722072657065';
wwv_flow_imp.g_varchar2_table(6520) := '6174696E6720656469746F722073656C656374696F6E732E22292C2130292C74763D4C6D28226D696E696D61702E73656C656374696F6E486967686C69676874222C7B6C696768743A2223414444364646222C6461726B3A2223323634463738222C6863';
wwv_flow_imp.g_varchar2_table(6521) := '4461726B3A2223666666666666222C68634C696768743A2223304634413835227D2C6228302C224D696E696D6170206D61726B657220636F6C6F7220666F722074686520656469746F722073656C656374696F6E2E22292C2130292C6E763D4C6D28226D';
wwv_flow_imp.g_varchar2_table(6522) := '696E696D61702E696E666F486967686C69676874222C7B6461726B3A61662C6C696768743A61662C68634461726B3A6C662C68634C696768743A6C667D2C6228302C224D696E696D6170206D61726B657220636F6C6F7220666F7220696E666F732E2229';
wwv_flow_imp.g_varchar2_table(6523) := '292C69763D4C6D28226D696E696D61702E7761726E696E67486967686C69676874222C7B6461726B3A73662C6C696768743A73662C68634461726B3A72662C68634C696768743A72667D2C6228302C224D696E696D6170206D61726B657220636F6C6F72';
wwv_flow_imp.g_varchar2_table(6524) := '20666F72207761726E696E67732E2229292C6F763D4C6D28226D696E696D61702E6572726F72486967686C69676874222C7B6461726B3A6E6577206875286E6577206C75283235352C31382C31382C2E3729292C6C696768743A6E6577206875286E6577';
wwv_flow_imp.g_varchar2_table(6525) := '206C75283235352C31382C31382C2E3729292C68634461726B3A6E6577206875286E6577206C75283235352C35302C35302C3129292C68634C696768743A2223423532303044227D2C6228302C224D696E696D6170206D61726B657220636F6C6F722066';
wwv_flow_imp.g_varchar2_table(6526) := '6F72206572726F72732E2229292C73763D4C6D28226D696E696D61702E6261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224D696E696D61';
wwv_flow_imp.g_varchar2_table(6527) := '70206261636B67726F756E6420636F6C6F722E2229292C72763D4C6D28226D696E696D61702E666F726567726F756E644F706163697479222C7B6461726B3A68752E66726F6D4865782822233030306622292C6C696768743A68752E66726F6D48657828';
wwv_flow_imp.g_varchar2_table(6528) := '22233030306622292C68634461726B3A68752E66726F6D4865782822233030306622292C68634C696768743A68752E66726F6D4865782822233030306622297D2C6228302C274F706163697479206F6620666F726567726F756E6420656C656D656E7473';
wwv_flow_imp.g_varchar2_table(6529) := '2072656E646572656420696E20746865206D696E696D61702E20466F72206578616D706C652C2022233030303030306330222077696C6C2072656E6465722074686520656C656D656E7473207769746820373525206F7061636974792E2729292C61763D';
wwv_flow_imp.g_varchar2_table(6530) := '284C6D28226D696E696D6170536C696465722E6261636B67726F756E64222C7B6C696768743A496D28556D2C2E35292C6461726B3A496D28556D2C2E35292C68634461726B3A496D28556D2C2E35292C68634C696768743A496D28556D2C2E35297D2C62';
wwv_flow_imp.g_varchar2_table(6531) := '28302C224D696E696D617020736C69646572206261636B67726F756E6420636F6C6F722E2229292C4C6D28226D696E696D6170536C696465722E686F7665724261636B67726F756E64222C7B6C696768743A496D284B6D2C2E35292C6461726B3A496D28';
wwv_flow_imp.g_varchar2_table(6532) := '4B6D2C2E35292C68634461726B3A496D284B6D2C2E35292C68634C696768743A496D284B6D2C2E35297D2C6228302C224D696E696D617020736C69646572206261636B67726F756E6420636F6C6F72207768656E20686F766572696E672E2229292C4C6D';
wwv_flow_imp.g_varchar2_table(6533) := '28226D696E696D6170536C696465722E6163746976654261636B67726F756E64222C7B6C696768743A496D28476D2C2E35292C6461726B3A496D28476D2C2E35292C68634461726B3A496D28476D2C2E35292C68634C696768743A496D28476D2C2E3529';
wwv_flow_imp.g_varchar2_table(6534) := '7D2C6228302C224D696E696D617020736C69646572206261636B67726F756E6420636F6C6F72207768656E20636C69636B6564206F6E2E2229292C4C6D28226368617274732E666F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C';
wwv_flow_imp.g_varchar2_table(6535) := '68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F72207573656420696E206368617274732E2229292C4C6D28226368617274732E6C696E6573222C7B6461726B3A496D28466D2C2E3529';
wwv_flow_imp.g_varchar2_table(6536) := '2C6C696768743A496D28466D2C2E35292C68634461726B3A496D28466D2C2E35292C68634C696768743A496D28466D2C2E35297D2C6228302C2254686520636F6C6F72207573656420666F7220686F72697A6F6E74616C206C696E657320696E20636861';
wwv_flow_imp.g_varchar2_table(6537) := '7274732E2229292C4C6D28226368617274732E726564222C7B6461726B3A74662C6C696768743A74662C68634461726B3A74662C68634C696768743A74667D2C6228302C225468652072656420636F6C6F72207573656420696E20636861727420766973';
wwv_flow_imp.g_varchar2_table(6538) := '75616C697A6174696F6E732E2229292C4C6D28226368617274732E626C7565222C7B6461726B3A61662C6C696768743A61662C68634461726B3A61662C68634C696768743A61667D2C6228302C2254686520626C756520636F6C6F72207573656420696E';
wwv_flow_imp.g_varchar2_table(6539) := '2063686172742076697375616C697A6174696F6E732E2229292C4C6D28226368617274732E79656C6C6F77222C7B6461726B3A73662C6C696768743A73662C68634461726B3A73662C68634C696768743A73667D2C6228302C225468652079656C6C6F77';
wwv_flow_imp.g_varchar2_table(6540) := '20636F6C6F72207573656420696E2063686172742076697375616C697A6174696F6E732E2229292C4C6D28226368617274732E6F72616E6765222C7B6461726B3A4A662C6C696768743A4A662C68634461726B3A4A662C68634C696768743A4A667D2C62';
wwv_flow_imp.g_varchar2_table(6541) := '28302C22546865206F72616E676520636F6C6F72207573656420696E2063686172742076697375616C697A6174696F6E732E2229292C4C6D28226368617274732E677265656E222C7B6461726B3A2223383944313835222C6C696768743A222333383841';
wwv_flow_imp.g_varchar2_table(6542) := '3334222C68634461726B3A2223383944313835222C68634C696768743A2223333734653036227D2C6228302C2254686520677265656E20636F6C6F72207573656420696E2063686172742076697375616C697A6174696F6E732E2229292C4C6D28226368';
wwv_flow_imp.g_varchar2_table(6543) := '617274732E707572706C65222C7B6461726B3A2223423138304437222C6C696768743A2223363532443930222C68634461726B3A2223423138304437222C68634C696768743A2223363532443930227D2C6228302C2254686520707572706C6520636F6C';
wwv_flow_imp.g_varchar2_table(6544) := '6F72207573656420696E2063686172742076697375616C697A6174696F6E732E2229292C4C6D2822696E7075742E6261636B67726F756E64222C7B6461726B3A2223334333433343222C6C696768743A68752E77686974652C68634461726B3A68752E62';
wwv_flow_imp.g_varchar2_table(6545) := '6C61636B2C68634C696768743A68752E77686974657D2C6228302C22496E70757420626F78206261636B67726F756E642E222929292C6C763D4C6D2822696E7075742E666F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C686344';
wwv_flow_imp.g_varchar2_table(6546) := '61726B3A466D2C68634C696768743A466D7D2C6228302C22496E70757420626F7820666F726567726F756E642E2229292C63763D4C6D2822696E7075742E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A7A';
wwv_flow_imp.g_varchar2_table(6547) := '6D2C68634C696768743A7A6D7D2C6228302C22496E70757420626F7820626F726465722E2229292C64763D4C6D2822696E7075744F7074696F6E2E616374697665426F72646572222C7B6461726B3A2223303037414343222C6C696768743A2223303037';
wwv_flow_imp.g_varchar2_table(6548) := '414343222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F72206F6620616374697661746564206F7074696F6E7320696E20696E707574206669656C64732E2229292C68763D284C6D2822696E7075744F';
wwv_flow_imp.g_varchar2_table(6549) := '7074696F6E2E686F7665724261636B67726F756E64222C7B6461726B3A22233561356435653830222C6C696768743A22236238623862383530222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(6550) := '20636F6C6F72206F6620616374697661746564206F7074696F6E7320696E20696E707574206669656C64732E2229292C4C6D2822696E7075744F7074696F6E2E6163746976654261636B67726F756E64222C7B6461726B3A496D28566D2C2E34292C6C69';
wwv_flow_imp.g_varchar2_table(6551) := '6768743A496D28566D2C2E32292C68634461726B3A68752E7472616E73706172656E742C68634C696768743A68752E7472616E73706172656E747D2C6228302C224261636B67726F756E6420686F76657220636F6C6F72206F66206F7074696F6E732069';
wwv_flow_imp.g_varchar2_table(6552) := '6E20696E707574206669656C64732E222929292C75763D4C6D2822696E7075744F7074696F6E2E616374697665466F726567726F756E64222C7B6461726B3A68752E77686974652C6C696768743A68752E626C61636B2C68634461726B3A466D2C68634C';
wwv_flow_imp.g_varchar2_table(6553) := '696768743A466D7D2C6228302C22466F726567726F756E6420636F6C6F72206F6620616374697661746564206F7074696F6E7320696E20696E707574206669656C64732E2229292C70763D284C6D2822696E7075742E706C616365686F6C646572466F72';
wwv_flow_imp.g_varchar2_table(6554) := '6567726F756E64222C7B6C696768743A496D28466D2C2E35292C6461726B3A496D28466D2C2E35292C68634461726B3A496D28466D2C2E37292C68634C696768743A496D28466D2C2E37297D2C6228302C22496E70757420626F7820666F726567726F75';
wwv_flow_imp.g_varchar2_table(6555) := '6E6420636F6C6F7220666F7220706C616365686F6C64657220746578742E2229292C4C6D2822696E70757456616C69646174696F6E2E696E666F4261636B67726F756E64222C7B6461726B3A2223303633423439222C6C696768743A2223443645434632';
wwv_flow_imp.g_varchar2_table(6556) := '222C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C22496E7075742076616C69646174696F6E206261636B67726F756E6420636F6C6F7220666F7220696E666F726D6174696F6E2073657665726974792E';
wwv_flow_imp.g_varchar2_table(6557) := '222929292C67763D4C6D2822696E70757456616C69646174696F6E2E696E666F466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A466D7D2C6228302C22496E707574';
wwv_flow_imp.g_varchar2_table(6558) := '2076616C69646174696F6E20666F726567726F756E6420636F6C6F7220666F7220696E666F726D6174696F6E2073657665726974792E2229292C6D763D4C6D2822696E70757456616C69646174696F6E2E696E666F426F72646572222C7B6461726B3A22';
wwv_flow_imp.g_varchar2_table(6559) := '23303037616363222C6C696768743A2223303037616363222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22496E7075742076616C69646174696F6E20626F7264657220636F6C6F7220666F7220696E666F726D6174696F6E207365';
wwv_flow_imp.g_varchar2_table(6560) := '7665726974792E2229292C66763D4C6D2822696E70757456616C69646174696F6E2E7761726E696E674261636B67726F756E64222C7B6461726B3A2223333532413035222C6C696768743A2223463646354432222C68634461726B3A68752E626C61636B';
wwv_flow_imp.g_varchar2_table(6561) := '2C68634C696768743A68752E77686974657D2C6228302C22496E7075742076616C69646174696F6E206261636B67726F756E6420636F6C6F7220666F72207761726E696E672073657665726974792E2229292C76763D4C6D2822696E70757456616C6964';
wwv_flow_imp.g_varchar2_table(6562) := '6174696F6E2E7761726E696E67466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A466D7D2C6228302C22496E7075742076616C69646174696F6E20666F726567726F';
wwv_flow_imp.g_varchar2_table(6563) := '756E6420636F6C6F7220666F72207761726E696E672073657665726974792E2229292C62763D4C6D2822696E70757456616C69646174696F6E2E7761726E696E67426F72646572222C7B6461726B3A2223423839353030222C6C696768743A2223423839';
wwv_flow_imp.g_varchar2_table(6564) := '353030222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22496E7075742076616C69646174696F6E20626F7264657220636F6C6F7220666F72207761726E696E672073657665726974792E2229292C5F763D4C6D2822696E70757456';
wwv_flow_imp.g_varchar2_table(6565) := '616C69646174696F6E2E6572726F724261636B67726F756E64222C7B6461726B3A2223354131443144222C6C696768743A2223463244454445222C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C22496E';
wwv_flow_imp.g_varchar2_table(6566) := '7075742076616C69646174696F6E206261636B67726F756E6420636F6C6F7220666F72206572726F722073657665726974792E2229292C79763D4C6D2822696E70757456616C69646174696F6E2E6572726F72466F726567726F756E64222C7B6461726B';
wwv_flow_imp.g_varchar2_table(6567) := '3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A466D7D2C6228302C22496E7075742076616C69646174696F6E20666F726567726F756E6420636F6C6F7220666F72206572726F722073657665726974792E22';
wwv_flow_imp.g_varchar2_table(6568) := '29292C77763D4C6D2822696E70757456616C69646174696F6E2E6572726F72426F72646572222C7B6461726B3A2223424531313030222C6C696768743A2223424531313030222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22496E';
wwv_flow_imp.g_varchar2_table(6569) := '7075742076616C69646174696F6E20626F7264657220636F6C6F7220666F72206572726F722073657665726974792E2229292C43763D4C6D282264726F70646F776E2E6261636B67726F756E64222C7B6461726B3A2223334333433343222C6C69676874';
wwv_flow_imp.g_varchar2_table(6570) := '3A68752E77686974652C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C2244726F70646F776E206261636B67726F756E642E2229292C53763D4C6D282264726F70646F776E2E6C6973744261636B67726F';
wwv_flow_imp.g_varchar2_table(6571) := '756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C2244726F70646F776E206C697374206261636B67726F756E642E2229292C78763D4C6D';
wwv_flow_imp.g_varchar2_table(6572) := '282264726F70646F776E2E666F726567726F756E64222C7B6461726B3A2223463046304630222C6C696768743A466D2C68634461726B3A68752E77686974652C68634C696768743A466D7D2C6228302C2244726F70646F776E20666F726567726F756E64';
wwv_flow_imp.g_varchar2_table(6573) := '2E2229292C6B763D4C6D282264726F70646F776E2E626F72646572222C7B6461726B3A43762C6C696768743A2223434543454345222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C2244726F70646F776E20626F726465722E222929';
wwv_flow_imp.g_varchar2_table(6574) := '2C45763D4C6D2822627574746F6E2E666F726567726F756E64222C7B6461726B3A68752E77686974652C6C696768743A68752E77686974652C68634461726B3A68752E77686974652C68634C696768743A68752E77686974657D2C6228302C2242757474';
wwv_flow_imp.g_varchar2_table(6575) := '6F6E20666F726567726F756E6420636F6C6F722E2229292C4C763D4C6D2822627574746F6E2E736570617261746F72222C7B6461726B3A496D2845762C2E34292C6C696768743A496D2845762C2E34292C68634461726B3A496D2845762C2E34292C6863';
wwv_flow_imp.g_varchar2_table(6576) := '4C696768743A496D2845762C2E34297D2C6228302C22427574746F6E20736570617261746F7220636F6C6F722E2229292C44763D4C6D2822627574746F6E2E6261636B67726F756E64222C7B6461726B3A2223304536333943222C6C696768743A222330';
wwv_flow_imp.g_varchar2_table(6577) := '3037414343222C68634461726B3A6E756C6C2C68634C696768743A2223304634413835227D2C6228302C22427574746F6E206261636B67726F756E6420636F6C6F722E2229292C54763D4C6D2822627574746F6E2E686F7665724261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(6578) := '222C7B6461726B3A546D2844762C2E32292C6C696768743A446D2844762C2E32292C68634461726B3A44762C68634C696768743A44767D2C6228302C22427574746F6E206261636B67726F756E6420636F6C6F72207768656E20686F766572696E672E22';
wwv_flow_imp.g_varchar2_table(6579) := '29292C49763D4C6D2822627574746F6E2E626F72646572222C7B6461726B3A7A6D2C6C696768743A7A6D2C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22427574746F6E20626F7264657220636F6C6F722E2229292C4D763D4C6D28';
wwv_flow_imp.g_varchar2_table(6580) := '22627574746F6E2E7365636F6E64617279466F726567726F756E64222C7B6461726B3A68752E77686974652C6C696768743A68752E77686974652C68634461726B3A68752E77686974652C68634C696768743A466D7D2C6228302C225365636F6E646172';
wwv_flow_imp.g_varchar2_table(6581) := '7920627574746F6E20666F726567726F756E6420636F6C6F722E2229292C41763D4C6D2822627574746F6E2E7365636F6E646172794261636B67726F756E64222C7B6461726B3A2223334133443431222C6C696768743A2223354636413739222C686344';
wwv_flow_imp.g_varchar2_table(6582) := '61726B3A6E756C6C2C68634C696768743A68752E77686974657D2C6228302C225365636F6E6461727920627574746F6E206261636B67726F756E6420636F6C6F722E2229292C4E763D4C6D2822627574746F6E2E7365636F6E64617279486F7665724261';
wwv_flow_imp.g_varchar2_table(6583) := '636B67726F756E64222C7B6461726B3A546D2841762C2E32292C6C696768743A446D2841762C2E32292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C225365636F6E6461727920627574746F6E206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(6584) := '20636F6C6F72207768656E20686F766572696E672E2229292C50763D4C6D2822636865636B626F782E6261636B67726F756E64222C7B6461726B3A43762C6C696768743A43762C68634461726B3A43762C68634C696768743A43767D2C6228302C224261';
wwv_flow_imp.g_varchar2_table(6585) := '636B67726F756E6420636F6C6F72206F6620636865636B626F78207769646765742E2229292C4F763D284C6D2822636865636B626F782E73656C6563744261636B67726F756E64222C7B6461726B3A586D2C6C696768743A586D2C68634461726B3A586D';
wwv_flow_imp.g_varchar2_table(6586) := '2C68634C696768743A586D7D2C6228302C224261636B67726F756E6420636F6C6F72206F6620636865636B626F7820776964676574207768656E2074686520656C656D656E74206974277320696E2069732073656C65637465642E2229292C4C6D282263';
wwv_flow_imp.g_varchar2_table(6587) := '6865636B626F782E666F726567726F756E64222C7B6461726B3A78762C6C696768743A78762C68634461726B3A78762C68634C696768743A78767D2C6228302C22466F726567726F756E6420636F6C6F72206F6620636865636B626F7820776964676574';
wwv_flow_imp.g_varchar2_table(6588) := '2E222929292C52763D4C6D2822636865636B626F782E626F72646572222C7B6461726B3A6B762C6C696768743A6B762C68634461726B3A6B762C68634C696768743A6B767D2C6228302C22426F7264657220636F6C6F72206F6620636865636B626F7820';
wwv_flow_imp.g_varchar2_table(6589) := '7769646765742E2229292C46763D284C6D2822636865636B626F782E73656C656374426F72646572222C7B6461726B3A426D2C6C696768743A426D2C68634461726B3A426D2C68634C696768743A426D7D2C6228302C22426F7264657220636F6C6F7220';
wwv_flow_imp.g_varchar2_table(6590) := '6F6620636865636B626F7820776964676574207768656E2074686520656C656D656E74206974277320696E2069732073656C65637465642E2229292C4C6D28226B657962696E64696E674C6162656C2E6261636B67726F756E64222C7B6461726B3A6E65';
wwv_flow_imp.g_varchar2_table(6591) := '77206875286E6577206C75283132382C3132382C3132382C2E313729292C6C696768743A6E6577206875286E6577206C75283232312C3232312C3232312C2E3429292C68634461726B3A68752E7472616E73706172656E742C68634C696768743A68752E';
wwv_flow_imp.g_varchar2_table(6592) := '7472616E73706172656E747D2C6228302C224B657962696E64696E67206C6162656C206261636B67726F756E6420636F6C6F722E20546865206B657962696E64696E67206C6162656C206973207573656420746F20726570726573656E742061206B6579';
wwv_flow_imp.g_varchar2_table(6593) := '626F6172642073686F72746375742E222929292C42763D4C6D28226B657962696E64696E674C6162656C2E666F726567726F756E64222C7B6461726B3A68752E66726F6D48657828222343434343434322292C6C696768743A68752E66726F6D48657828';
wwv_flow_imp.g_varchar2_table(6594) := '222335353535353522292C68634461726B3A68752E77686974652C68634C696768743A466D7D2C6228302C224B657962696E64696E67206C6162656C20666F726567726F756E6420636F6C6F722E20546865206B657962696E64696E67206C6162656C20';
wwv_flow_imp.g_varchar2_table(6595) := '6973207573656420746F20726570726573656E742061206B6579626F6172642073686F72746375742E2229292C56763D4C6D28226B657962696E64696E674C6162656C2E626F72646572222C7B6461726B3A6E6577206875286E6577206C752835312C35';
wwv_flow_imp.g_varchar2_table(6596) := '312C35312C2E3629292C6C696768743A6E6577206875286E6577206C75283230342C3230342C3230342C2E3429292C68634461726B3A6E6577206875286E6577206C75283131312C3139352C32323329292C68634C696768743A7A6D7D2C6228302C224B';
wwv_flow_imp.g_varchar2_table(6597) := '657962696E64696E67206C6162656C20626F7264657220636F6C6F722E20546865206B657962696E64696E67206C6162656C206973207573656420746F20726570726573656E742061206B6579626F6172642073686F72746375742E2229292C7A763D4C';
wwv_flow_imp.g_varchar2_table(6598) := '6D28226B657962696E64696E674C6162656C2E626F74746F6D426F72646572222C7B6461726B3A6E6577206875286E6577206C752836382C36382C36382C2E3629292C6C696768743A6E6577206875286E6577206C75283138372C3138372C3138372C2E';
wwv_flow_imp.g_varchar2_table(6599) := '3429292C68634461726B3A6E6577206875286E6577206C75283131312C3139352C32323329292C68634C696768743A466D7D2C6228302C224B657962696E64696E67206C6162656C20626F7264657220626F74746F6D20636F6C6F722E20546865206B65';
wwv_flow_imp.g_varchar2_table(6600) := '7962696E64696E67206C6162656C206973207573656420746F20726570726573656E742061206B6579626F6172642073686F72746375742E2229292C48763D4C6D28226C6973742E666F6375734261636B67726F756E64222C7B6461726B3A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(6601) := '6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F54726565206261636B67726F756E6420636F6C6F7220666F722074686520666F6375736564206974656D207768656E20746865206C';
wwv_flow_imp.g_varchar2_table(6602) := '6973742F74726565206973206163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C57763D4C6D28226C6973742E666F63';
wwv_flow_imp.g_varchar2_table(6603) := '7573466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F5472656520666F726567726F756E6420636F6C6F7220666F72207468';
wwv_flow_imp.g_varchar2_table(6604) := '6520666F6375736564206974656D207768656E20746865206C6973742F74726565206973206163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F65';
wwv_flow_imp.g_varchar2_table(6605) := '73206E6F742E2229292C6A763D4C6D28226C6973742E666F6375734F75746C696E65222C7B6461726B3A566D2C6C696768743A566D2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C224C6973742F54726565206F75746C696E652063';
wwv_flow_imp.g_varchar2_table(6606) := '6F6C6F7220666F722074686520666F6375736564206974656D207768656E20746865206C6973742F74726565206973206163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E2069';
wwv_flow_imp.g_varchar2_table(6607) := '6E61637469766520646F6573206E6F742E2229292C71763D4C6D28226C6973742E666F637573416E6453656C656374696F6E4F75746C696E65222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C69676874';
wwv_flow_imp.g_varchar2_table(6608) := '3A6E756C6C7D2C6228302C224C6973742F54726565206F75746C696E6520636F6C6F7220666F722074686520666F6375736564206974656D207768656E20746865206C6973742F747265652069732061637469766520616E642073656C65637465642E20';
wwv_flow_imp.g_varchar2_table(6609) := '416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C24763D4C6D28226C6973742E61637469766553656C656374696F6E4261636B67726F75';
wwv_flow_imp.g_varchar2_table(6610) := '6E64222C7B6461726B3A2223303433393545222C6C696768743A2223303036304330222C68634461726B3A6E756C6C2C68634C696768743A68752E66726F6D48657828222330463441383522292E7472616E73706172656E74282E31297D2C6228302C22';
wwv_flow_imp.g_varchar2_table(6611) := '4C6973742F54726565206261636B67726F756E6420636F6C6F7220666F72207468652073656C6563746564206974656D207768656E20746865206C6973742F74726565206973206163746976652E20416E20616374697665206C6973742F747265652068';
wwv_flow_imp.g_varchar2_table(6612) := '6173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C55763D4C6D28226C6973742E61637469766553656C656374696F6E466F726567726F756E64222C7B6461726B3A68752E77686974652C6C69';
wwv_flow_imp.g_varchar2_table(6613) := '6768743A68752E77686974652C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F5472656520666F726567726F756E6420636F6C6F7220666F72207468652073656C6563746564206974656D207768656E207468';
wwv_flow_imp.g_varchar2_table(6614) := '65206C6973742F74726565206973206163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C4B763D4C6D28226C6973742E';
wwv_flow_imp.g_varchar2_table(6615) := '61637469766553656C656374696F6E49636F6E466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F547265652069636F6E2066';
wwv_flow_imp.g_varchar2_table(6616) := '6F726567726F756E6420636F6C6F7220666F72207468652073656C6563746564206974656D207768656E20746865206C6973742F74726565206973206163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F617264';
wwv_flow_imp.g_varchar2_table(6617) := '20666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C47763D4C6D28226C6973742E696E61637469766553656C656374696F6E4261636B67726F756E64222C7B6461726B3A2223333733373344222C6C696768743A22234534';
wwv_flow_imp.g_varchar2_table(6618) := '45364631222C68634461726B3A6E756C6C2C68634C696768743A68752E66726F6D48657828222330463441383522292E7472616E73706172656E74282E31297D2C6228302C224C6973742F54726565206261636B67726F756E6420636F6C6F7220666F72';
wwv_flow_imp.g_varchar2_table(6619) := '207468652073656C6563746564206974656D207768656E20746865206C6973742F7472656520697320696E6163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469';
wwv_flow_imp.g_varchar2_table(6620) := '766520646F6573206E6F742E2229292C51763D4C6D28226C6973742E696E61637469766553656C656374696F6E466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E';
wwv_flow_imp.g_varchar2_table(6621) := '756C6C7D2C6228302C224C6973742F5472656520666F726567726F756E6420636F6C6F7220666F72207468652073656C6563746564206974656D207768656E20746865206C6973742F7472656520697320696E6163746976652E20416E20616374697665';
wwv_flow_imp.g_varchar2_table(6622) := '206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C59763D4C6D28226C6973742E696E61637469766553656C656374696F6E49636F6E466F726567726F756E6422';
wwv_flow_imp.g_varchar2_table(6623) := '2C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F547265652069636F6E20666F726567726F756E6420636F6C6F7220666F72207468652073656C656374';
wwv_flow_imp.g_varchar2_table(6624) := '6564206974656D207768656E20746865206C6973742F7472656520697320696E6163746976652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F74';
wwv_flow_imp.g_varchar2_table(6625) := '2E2229292C5A763D4C6D28226C6973742E696E616374697665466F6375734261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F';
wwv_flow_imp.g_varchar2_table(6626) := '54726565206261636B67726F756E6420636F6C6F7220666F722074686520666F6375736564206974656D207768656E20746865206C6973742F7472656520697320696E6163746976652E20416E20616374697665206C6973742F7472656520686173206B';
wwv_flow_imp.g_varchar2_table(6627) := '6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C58763D4C6D28226C6973742E696E616374697665466F6375734F75746C696E65222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461';
wwv_flow_imp.g_varchar2_table(6628) := '726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F54726565206F75746C696E6520636F6C6F7220666F722074686520666F6375736564206974656D207768656E20746865206C6973742F7472656520697320696E61637469';
wwv_flow_imp.g_varchar2_table(6629) := '76652E20416E20616374697665206C6973742F7472656520686173206B6579626F61726420666F6375732C20616E20696E61637469766520646F6573206E6F742E2229292C4A763D4C6D28226C6973742E686F7665724261636B67726F756E64222C7B64';
wwv_flow_imp.g_varchar2_table(6630) := '61726B3A2223324132443245222C6C696768743A2223463046304630222C68634461726B3A68752E77686974652E7472616E73706172656E74282E31292C68634C696768743A68752E66726F6D48657828222330463441383522292E7472616E73706172';
wwv_flow_imp.g_varchar2_table(6631) := '656E74282E31297D2C6228302C224C6973742F54726565206261636B67726F756E64207768656E20686F766572696E67206F766572206974656D73207573696E6720746865206D6F7573652E2229292C65623D4C6D28226C6973742E686F766572466F72';
wwv_flow_imp.g_varchar2_table(6632) := '6567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C6973742F5472656520666F726567726F756E64207768656E20686F766572696E67206F7665';
wwv_flow_imp.g_varchar2_table(6633) := '72206974656D73207573696E6720746865206D6F7573652E2229292C74623D4C6D28226C6973742E64726F704261636B67726F756E64222C7B6461726B3A2223303632463441222C6C696768743A2223443645424646222C68634461726B3A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(6634) := '68634C696768743A6E756C6C7D2C6228302C224C6973742F54726565206472616720616E642064726F70206261636B67726F756E64207768656E206D6F76696E67206974656D73206F766572206F74686572206974656D73207768656E207573696E6720';
wwv_flow_imp.g_varchar2_table(6635) := '746865206D6F7573652E2229292C6E623D4C6D28226C6973742E64726F704265747765656E4261636B67726F756E64222C7B6461726B3A426D2C6C696768743A426D2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224C69';
wwv_flow_imp.g_varchar2_table(6636) := '73742F54726565206472616720616E642064726F7020626F7264657220636F6C6F72207768656E206D6F76696E67206974656D73206265747765656E206974656D73207768656E207573696E6720746865206D6F7573652E2229292C69623D4C6D28226C';
wwv_flow_imp.g_varchar2_table(6637) := '6973742E686967686C69676874466F726567726F756E64222C7B6461726B3A2223324141414646222C6C696768743A2223303036364246222C68634461726B3A566D2C68634C696768743A566D7D2C6228302C224C6973742F5472656520666F72656772';
wwv_flow_imp.g_varchar2_table(6638) := '6F756E6420636F6C6F72206F6620746865206D6174636820686967686C6967687473207768656E20736561726368696E6720696E7369646520746865206C6973742F747265652E2229292C6F623D4C6D28226C6973742E666F637573486967686C696768';
wwv_flow_imp.g_varchar2_table(6639) := '74466F726567726F756E64222C7B6461726B3A69622C6C696768743A2873623D24762C72623D69622C7B6F703A362C69663A73622C7468656E3A72622C656C73653A2223424245374646227D292C68634461726B3A69622C68634C696768743A69627D2C';
wwv_flow_imp.g_varchar2_table(6640) := '6228302C224C6973742F5472656520666F726567726F756E6420636F6C6F72206F6620746865206D6174636820686967686C6967687473206F6E206163746976656C7920666F6375736564206974656D73207768656E20736561726368696E6720696E73';
wwv_flow_imp.g_varchar2_table(6641) := '69646520746865206C6973742F747265652E2229293B7661722073622C72623B4C6D28226C6973742E696E76616C69644974656D466F726567726F756E64222C7B6461726B3A2223423839353030222C6C696768743A2223423839353030222C68634461';
wwv_flow_imp.g_varchar2_table(6642) := '726B3A2223423839353030222C68634C696768743A2223423532303044227D2C6228302C224C6973742F5472656520666F726567726F756E6420636F6C6F7220666F7220696E76616C6964206974656D732C20666F72206578616D706C6520616E20756E';
wwv_flow_imp.g_varchar2_table(6643) := '7265736F6C76656420726F6F7420696E206578706C6F7265722E2229292C4C6D28226C6973742E6572726F72466F726567726F756E64222C7B6461726B3A2223463838303730222C6C696768743A2223423031303131222C68634461726B3A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(6644) := '68634C696768743A6E756C6C7D2C6228302C22466F726567726F756E6420636F6C6F72206F66206C697374206974656D7320636F6E7461696E696E67206572726F72732E2229292C4C6D28226C6973742E7761726E696E67466F726567726F756E64222C';
wwv_flow_imp.g_varchar2_table(6645) := '7B6461726B3A2223434341373030222C6C696768743A2223383535463030222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22466F726567726F756E6420636F6C6F72206F66206C697374206974656D7320636F6E746169';
wwv_flow_imp.g_varchar2_table(6646) := '6E696E67207761726E696E67732E2229293B636F6E73742061623D4C6D28226C69737446696C7465725769646765742E6261636B67726F756E64222C7B6C696768743A446D28586D2C30292C6461726B3A546D28586D2C30292C68634461726B3A586D2C';
wwv_flow_imp.g_varchar2_table(6647) := '68634C696768743A586D7D2C6228302C224261636B67726F756E6420636F6C6F72206F662074686520747970652066696C7465722077696467657420696E206C6973747320616E642074726565732E2229292C6C623D4C6D28226C69737446696C746572';
wwv_flow_imp.g_varchar2_table(6648) := '5769646765742E6F75746C696E65222C7B6461726B3A68752E7472616E73706172656E742C6C696768743A68752E7472616E73706172656E742C68634461726B3A2223663338353138222C68634C696768743A2223303037414343227D2C6228302C224F';
wwv_flow_imp.g_varchar2_table(6649) := '75746C696E6520636F6C6F72206F662074686520747970652066696C7465722077696467657420696E206C6973747320616E642074726565732E2229292C63623D4C6D28226C69737446696C7465725769646765742E6E6F4D6174636865734F75746C69';
wwv_flow_imp.g_varchar2_table(6650) := '6E65222C7B6461726B3A2223424531313030222C6C696768743A2223424531313030222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C224F75746C696E6520636F6C6F72206F662074686520747970652066696C7465722077696467';
wwv_flow_imp.g_varchar2_table(6651) := '657420696E206C6973747320616E642074726565732C207768656E20746865726520617265206E6F206D6174636865732E2229292C64623D4C6D28226C69737446696C7465725769646765742E736861646F77222C7B6461726B3A4E662C6C696768743A';
wwv_flow_imp.g_varchar2_table(6652) := '4E662C68634461726B3A4E662C68634C696768743A4E667D2C6228302C22536861646F7720636F6C6F72206F662074686520747970652066696C7465722077696467657420696E206C6973747320616E642074726565732E2229292C68623D284C6D2822';
wwv_flow_imp.g_varchar2_table(6653) := '6C6973742E66696C7465724D617463684261636B67726F756E64222C7B6461726B3A6D662C6C696768743A6D662C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F72206F6620746865';
wwv_flow_imp.g_varchar2_table(6654) := '2066696C7465726564206D617463682E2229292C4C6D28226C6973742E66696C7465724D61746368426F72646572222C7B6461726B3A66662C6C696768743A66662C68634461726B3A7A6D2C68634C696768743A486D7D2C6228302C22426F7264657220';
wwv_flow_imp.g_varchar2_table(6655) := '636F6C6F72206F66207468652066696C7465726564206D617463682E2229292C4C6D28226C6973742E6465656D70686173697A6564466F726567726F756E64222C7B6461726B3A2223384338433843222C6C696768743A2223384538453930222C686344';
wwv_flow_imp.g_varchar2_table(6656) := '61726B3A2223413741384139222C68634C696768743A2223363636363636227D2C6228302C224C6973742F5472656520666F726567726F756E6420636F6C6F7220666F72206974656D73207468617420617265206465656D70686173697A65642E222929';
wwv_flow_imp.g_varchar2_table(6657) := '2C4C6D2822747265652E696E64656E744775696465735374726F6B65222C7B6461726B3A2223353835383538222C6C696768743A2223613961396139222C68634461726B3A2223613961396139222C68634C696768743A2223613561356135227D2C6228';
wwv_flow_imp.g_varchar2_table(6658) := '302C2254726565207374726F6B6520636F6C6F7220666F722074686520696E64656E746174696F6E206775696465732E222929292C75623D4C6D2822747265652E696E616374697665496E64656E744775696465735374726F6B65222C7B6461726B3A49';
wwv_flow_imp.g_varchar2_table(6659) := '6D2868622C2E34292C6C696768743A496D2868622C2E34292C68634461726B3A496D2868622C2E34292C68634C696768743A496D2868622C2E34297D2C6228302C2254726565207374726F6B6520636F6C6F7220666F722074686520696E64656E746174';
wwv_flow_imp.g_varchar2_table(6660) := '696F6E20677569646573207468617420617265206E6F74206163746976652E2229292C70623D4C6D2822747265652E7461626C65436F6C756D6E73426F72646572222C7B6461726B3A22234343434343433230222C6C696768743A222336313631363132';
wwv_flow_imp.g_varchar2_table(6661) := '30222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C225461626C6520626F7264657220636F6C6F72206265747765656E20636F6C756D6E732E2229292C67623D4C6D2822747265652E7461626C654F6464526F7773426163';
wwv_flow_imp.g_varchar2_table(6662) := '6B67726F756E64222C7B6461726B3A496D28466D2C2E3034292C6C696768743A496D28466D2C2E3034292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F7220666F72206F64642074';
wwv_flow_imp.g_varchar2_table(6663) := '61626C6520726F77732E2229292C6D623D4C6D28226D656E752E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F72206F66206D';
wwv_flow_imp.g_varchar2_table(6664) := '656E75732E2229292C66623D4C6D28226D656E752E666F726567726F756E64222C7B6461726B3A78762C6C696768743A78762C68634461726B3A78762C68634C696768743A78767D2C6228302C22466F726567726F756E6420636F6C6F72206F66206D65';
wwv_flow_imp.g_varchar2_table(6665) := '6E75206974656D732E2229292C76623D4C6D28226D656E752E6261636B67726F756E64222C7B6461726B3A43762C6C696768743A43762C68634461726B3A43762C68634C696768743A43767D2C6228302C224261636B67726F756E6420636F6C6F72206F';
wwv_flow_imp.g_varchar2_table(6666) := '66206D656E75206974656D732E2229292C62623D4C6D28226D656E752E73656C656374696F6E466F726567726F756E64222C7B6461726B3A55762C6C696768743A55762C68634461726B3A55762C68634C696768743A55767D2C6228302C22466F726567';
wwv_flow_imp.g_varchar2_table(6667) := '726F756E6420636F6C6F72206F66207468652073656C6563746564206D656E75206974656D20696E206D656E75732E2229292C5F623D4C6D28226D656E752E73656C656374696F6E4261636B67726F756E64222C7B6461726B3A24762C6C696768743A24';
wwv_flow_imp.g_varchar2_table(6668) := '762C68634461726B3A24762C68634C696768743A24767D2C6228302C224261636B67726F756E6420636F6C6F72206F66207468652073656C6563746564206D656E75206974656D20696E206D656E75732E2229292C79623D4C6D28226D656E752E73656C';
wwv_flow_imp.g_varchar2_table(6669) := '656374696F6E426F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C22426F7264657220636F6C6F72206F66207468652073656C6563746564206D656E7520697465';
wwv_flow_imp.g_varchar2_table(6670) := '6D20696E206D656E75732E2229292C77623D4C6D28226D656E752E736570617261746F724261636B67726F756E64222C7B6461726B3A2223363036303630222C6C696768743A2223443444344434222C68634461726B3A7A6D2C68634C696768743A7A6D';
wwv_flow_imp.g_varchar2_table(6671) := '7D2C6228302C22436F6C6F72206F66206120736570617261746F72206D656E75206974656D20696E206D656E75732E2229292C43623D4C6D2822717569636B496E7075742E6261636B67726F756E64222C7B6461726B3A586D2C6C696768743A586D2C68';
wwv_flow_imp.g_varchar2_table(6672) := '634461726B3A586D2C68634C696768743A586D7D2C6228302C22517569636B207069636B6572206261636B67726F756E6420636F6C6F722E2054686520717569636B207069636B6572207769646765742069732074686520636F6E7461696E657220666F';
wwv_flow_imp.g_varchar2_table(6673) := '72207069636B657273206C696B652074686520636F6D6D616E642070616C657474652E2229292C53623D4C6D2822717569636B496E7075742E666F726567726F756E64222C7B6461726B3A4A6D2C6C696768743A4A6D2C68634461726B3A4A6D2C68634C';
wwv_flow_imp.g_varchar2_table(6674) := '696768743A4A6D7D2C6228302C22517569636B207069636B657220666F726567726F756E6420636F6C6F722E2054686520717569636B207069636B6572207769646765742069732074686520636F6E7461696E657220666F72207069636B657273206C69';
wwv_flow_imp.g_varchar2_table(6675) := '6B652074686520636F6D6D616E642070616C657474652E2229292C78623D4C6D2822717569636B496E7075745469746C652E6261636B67726F756E64222C7B6461726B3A6E6577206875286E6577206C75283235352C3235352C3235352C2E3130352929';
wwv_flow_imp.g_varchar2_table(6676) := '2C6C696768743A6E6577206875286E6577206C7528302C302C302C2E303629292C68634461726B3A2223303030303030222C68634C696768743A68752E77686974657D2C6228302C22517569636B207069636B6572207469746C65206261636B67726F75';
wwv_flow_imp.g_varchar2_table(6677) := '6E6420636F6C6F722E2054686520717569636B207069636B6572207769646765742069732074686520636F6E7461696E657220666F72207069636B657273206C696B652074686520636F6D6D616E642070616C657474652E2229292C6B623D4C6D282270';
wwv_flow_imp.g_varchar2_table(6678) := '69636B657247726F75702E666F726567726F756E64222C7B6461726B3A2223333739344646222C6C696768743A2223303036364246222C68634461726B3A68752E77686974652C68634C696768743A2223304634413835227D2C6228302C22517569636B';
wwv_flow_imp.g_varchar2_table(6679) := '207069636B657220636F6C6F7220666F722067726F7570696E67206C6162656C732E2229292C45623D4C6D28227069636B657247726F75702E626F72646572222C7B6461726B3A2223334633463436222C6C696768743A2223434343454442222C686344';
wwv_flow_imp.g_varchar2_table(6680) := '61726B3A68752E77686974652C68634C696768743A2223304634413835227D2C6228302C22517569636B207069636B657220636F6C6F7220666F722067726F7570696E6720626F72646572732E2229292C4C623D4C6D2822717569636B496E7075742E6C';
wwv_flow_imp.g_varchar2_table(6681) := '6973742E666F6375734261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C22222C766F696420302C6228302C22506C656173652075736520717569636B';
wwv_flow_imp.g_varchar2_table(6682) := '496E7075744C6973742E666F6375734261636B67726F756E6420696E73746561642229292C44623D4C6D2822717569636B496E7075744C6973742E666F637573466F726567726F756E64222C7B6461726B3A55762C6C696768743A55762C68634461726B';
wwv_flow_imp.g_varchar2_table(6683) := '3A55762C68634C696768743A55767D2C6228302C22517569636B207069636B657220666F726567726F756E6420636F6C6F7220666F722074686520666F6375736564206974656D2E2229292C54623D4C6D2822717569636B496E7075744C6973742E666F';
wwv_flow_imp.g_varchar2_table(6684) := '63757349636F6E466F726567726F756E64222C7B6461726B3A4B762C6C696768743A4B762C68634461726B3A4B762C68634C696768743A4B767D2C6228302C22517569636B207069636B65722069636F6E20666F726567726F756E6420636F6C6F722066';
wwv_flow_imp.g_varchar2_table(6685) := '6F722074686520666F6375736564206974656D2E2229292C49623D4C6D2822717569636B496E7075744C6973742E666F6375734261636B67726F756E64222C7B6461726B3A4D6D284C622C2476292C6C696768743A4D6D284C622C2476292C6863446172';
wwv_flow_imp.g_varchar2_table(6686) := '6B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22517569636B207069636B6572206261636B67726F756E6420636F6C6F7220666F722074686520666F6375736564206974656D2E2229293B766172204D623B66756E6374696F6E20416228';
wwv_flow_imp.g_varchar2_table(6687) := '65297B72657475726E20653D3D3D4D622E484947485F434F4E54524153545F4441524B7C7C653D3D3D4D622E484947485F434F4E54524153545F4C494748547D66756E6374696F6E204E622865297B72657475726E20653D3D3D4D622E4441524B7C7C65';
wwv_flow_imp.g_varchar2_table(6688) := '3D3D3D4D622E484947485F434F4E54524153545F4441524B7D4C6D28227365617263682E726573756C7473496E666F466F726567726F756E64222C7B6C696768743A466D2C6461726B3A496D28466D2C2E3635292C68634461726B3A466D2C68634C6967';
wwv_flow_imp.g_varchar2_table(6689) := '68743A466D7D2C6228302C22436F6C6F72206F6620746865207465787420696E207468652073656172636820766965776C6574277320636F6D706C6574696F6E206D6573736167652E2229292C4C6D2822736561726368456469746F722E66696E644D61';
wwv_flow_imp.g_varchar2_table(6690) := '7463684261636B67726F756E64222C7B6C696768743A496D286D662C2E3636292C6461726B3A496D286D662C2E3636292C68634461726B3A6D662C68634C696768743A6D667D2C6228302C22436F6C6F72206F6620746865205365617263682045646974';
wwv_flow_imp.g_varchar2_table(6691) := '6F72207175657279206D6174636865732E2229292C4C6D2822736561726368456469746F722E66696E644D61746368426F72646572222C7B6C696768743A496D2866662C2E3636292C6461726B3A496D2866662C2E3636292C68634461726B3A66662C68';
wwv_flow_imp.g_varchar2_table(6692) := '634C696768743A66667D2C6228302C22426F7264657220636F6C6F72206F66207468652053656172636820456469746F72207175657279206D6174636865732E2229292C66756E6374696F6E2865297B652E4441524B3D226461726B222C652E4C494748';
wwv_flow_imp.g_varchar2_table(6693) := '543D226C69676874222C652E484947485F434F4E54524153545F4441524B3D2268634461726B222C652E484947485F434F4E54524153545F4C494748543D2268634C69676874227D284D627C7C284D623D7B7D29293B636F6E73742050623D7063282274';
wwv_flow_imp.g_varchar2_table(6694) := '68656D655365727669636522293B66756E6374696F6E204F622865297B72657475726E7B69643A657D7D66756E6374696F6E2052622865297B7377697463682865297B63617365204D622E4441524B3A72657475726E2276732D6461726B223B63617365';
wwv_flow_imp.g_varchar2_table(6695) := '204D622E484947485F434F4E54524153545F4441524B3A72657475726E2268632D626C61636B223B63617365204D622E484947485F434F4E54524153545F4C494748543A72657475726E2268632D6C69676874223B64656661756C743A72657475726E22';
wwv_flow_imp.g_varchar2_table(6696) := '7673227D7D636F6E73742046623D22626173652E636F6E747269627574696F6E732E7468656D696E67222C42623D6E657720636C6173737B636F6E7374727563746F7228297B746869732E7468656D696E675061727469636970616E74733D5B5D2C7468';
wwv_flow_imp.g_varchar2_table(6697) := '69732E7468656D696E675061727469636970616E74733D5B5D2C746869732E6F6E5468656D696E675061727469636970616E744164646564456D69747465723D6E65772043747D6F6E436F6C6F725468656D654368616E67652865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(6698) := '746869732E7468656D696E675061727469636970616E74732E707573682865292C746869732E6F6E5468656D696E675061727469636970616E744164646564456D69747465722E666972652865292C7274282828293D3E7B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(6699) := '2E7468656D696E675061727469636970616E74732E696E6465784F662865293B746869732E7468656D696E675061727469636970616E74732E73706C69636528742C31297D29297D6765745468656D696E675061727469636970616E747328297B726574';
wwv_flow_imp.g_varchar2_table(6700) := '75726E20746869732E7468656D696E675061727469636970616E74737D7D3B66756E6374696F6E2056622865297B72657475726E2042622E6F6E436F6C6F725468656D654368616E67652865297D79642E6164642846622C4262293B636C617373207A62';
wwv_flow_imp.g_varchar2_table(6701) := '20657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E7468656D65536572766963653D652C746869732E7468656D653D652E676574436F6C6F725468656D6528292C746869732E5F72656769737465722874';
wwv_flow_imp.g_varchar2_table(6702) := '6869732E7468656D65536572766963652E6F6E446964436F6C6F725468656D654368616E67652828653D3E746869732E6F6E5468656D654368616E67652865292929297D6F6E5468656D654368616E67652865297B746869732E7468656D653D652C7468';
wwv_flow_imp.g_varchar2_table(6703) := '69732E7570646174655374796C657328297D7570646174655374796C657328297B7D7D636F6E73742048623D4C6D2822656469746F722E6C696E65486967686C696768744261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C';
wwv_flow_imp.g_varchar2_table(6704) := '6C2C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F7220666F722074686520686967686C69676874206F66206C696E652061742074686520637572736F7220706F736974696F6E2E22';
wwv_flow_imp.g_varchar2_table(6705) := '29292C57623D4C6D2822656469746F722E6C696E65486967686C69676874426F72646572222C7B6461726B3A2223323832383238222C6C696768743A2223656565656565222C68634461726B3A2223663338353138222C68634C696768743A7A6D7D2C62';
wwv_flow_imp.g_varchar2_table(6706) := '28302C224261636B67726F756E6420636F6C6F7220666F722074686520626F726465722061726F756E6420746865206C696E652061742074686520637572736F7220706F736974696F6E2E2229292C6A623D284C6D2822656469746F722E72616E676548';
wwv_flow_imp.g_varchar2_table(6707) := '6967686C696768744261636B67726F756E64222C7B6461726B3A22236666666666663062222C6C696768743A22236664666630303333222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F';
wwv_flow_imp.g_varchar2_table(6708) := '6C6F72206F6620686967686C6967687465642072616E6765732C206C696B6520627920717569636B206F70656E20616E642066696E642066656174757265732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F20617320';
wwv_flow_imp.g_varchar2_table(6709) := '6E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D2822656469746F722E72616E6765486967686C69676874426F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C686344';
wwv_flow_imp.g_varchar2_table(6710) := '61726B3A486D2C68634C696768743A486D7D2C6228302C224261636B67726F756E6420636F6C6F72206F662074686520626F726465722061726F756E6420686967686C6967687465642072616E6765732E2229292C4C6D2822656469746F722E73796D62';
wwv_flow_imp.g_varchar2_table(6711) := '6F6C486967686C696768744261636B67726F756E64222C7B6461726B3A6D662C6C696768743A6D662C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F72206F6620686967686C696768';
wwv_flow_imp.g_varchar2_table(6712) := '7465642073796D626F6C2C206C696B6520666F7220676F20746F20646566696E6974696F6E206F7220676F206E6578742F70726576696F75732073796D626F6C2E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173';
wwv_flow_imp.g_varchar2_table(6713) := '206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D2822656469746F722E73796D626F6C486967686C69676874426F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68';
wwv_flow_imp.g_varchar2_table(6714) := '634461726B3A486D2C68634C696768743A486D7D2C6228302C224261636B67726F756E6420636F6C6F72206F662074686520626F726465722061726F756E6420686967686C6967687465642073796D626F6C732E2229292C4C6D2822656469746F724375';
wwv_flow_imp.g_varchar2_table(6715) := '72736F722E666F726567726F756E64222C7B6461726B3A2223414541464144222C6C696768743A68752E626C61636B2C68634461726B3A68752E77686974652C68634C696768743A2223304634413835227D2C6228302C22436F6C6F72206F6620746865';
wwv_flow_imp.g_varchar2_table(6716) := '20656469746F7220637572736F722E222929292C71623D4C6D2822656469746F72437572736F722E6261636B67726F756E64222C6E756C6C2C6228302C22546865206261636B67726F756E6420636F6C6F72206F662074686520656469746F7220637572';
wwv_flow_imp.g_varchar2_table(6717) := '736F722E20416C6C6F777320637573746F6D697A696E672074686520636F6C6F72206F66206120636861726163746572206F7665726C6170706564206279206120626C6F636B20637572736F722E2229292C24623D4C6D2822656469746F724D756C7469';
wwv_flow_imp.g_varchar2_table(6718) := '437572736F722E7072696D6172792E666F726567726F756E64222C7B6461726B3A6A622C6C696768743A6A622C68634461726B3A6A622C68634C696768743A6A627D2C6228302C22436F6C6F72206F6620746865207072696D61727920656469746F7220';
wwv_flow_imp.g_varchar2_table(6719) := '637572736F72207768656E206D756C7469706C6520637572736F7273206172652070726573656E742E2229292C55623D4C6D2822656469746F724D756C7469437572736F722E7072696D6172792E6261636B67726F756E64222C7B6461726B3A71622C6C';
wwv_flow_imp.g_varchar2_table(6720) := '696768743A71622C68634461726B3A71622C68634C696768743A71627D2C6228302C22546865206261636B67726F756E6420636F6C6F72206F6620746865207072696D61727920656469746F7220637572736F72207768656E206D756C7469706C652063';
wwv_flow_imp.g_varchar2_table(6721) := '7572736F7273206172652070726573656E742E20416C6C6F777320637573746F6D697A696E672074686520636F6C6F72206F66206120636861726163746572206F7665726C6170706564206279206120626C6F636B20637572736F722E2229292C4B623D';
wwv_flow_imp.g_varchar2_table(6722) := '4C6D2822656469746F724D756C7469437572736F722E7365636F6E646172792E666F726567726F756E64222C7B6461726B3A6A622C6C696768743A6A622C68634461726B3A6A622C68634C696768743A6A627D2C6228302C22436F6C6F72206F66207365';
wwv_flow_imp.g_varchar2_table(6723) := '636F6E6461727920656469746F7220637572736F7273207768656E206D756C7469706C6520637572736F7273206172652070726573656E742E2229292C47623D4C6D2822656469746F724D756C7469437572736F722E7365636F6E646172792E6261636B';
wwv_flow_imp.g_varchar2_table(6724) := '67726F756E64222C7B6461726B3A71622C6C696768743A71622C68634461726B3A71622C68634C696768743A71627D2C6228302C22546865206261636B67726F756E6420636F6C6F72206F66207365636F6E6461727920656469746F7220637572736F72';
wwv_flow_imp.g_varchar2_table(6725) := '73207768656E206D756C7469706C6520637572736F7273206172652070726573656E742E20416C6C6F777320637573746F6D697A696E672074686520636F6C6F72206F66206120636861726163746572206F7665726C6170706564206279206120626C6F';
wwv_flow_imp.g_varchar2_table(6726) := '636B20637572736F722E2229292C51623D4C6D2822656469746F72576869746573706163652E666F726567726F756E64222C7B6461726B3A22236533653465323239222C6C696768743A22233333333333333333222C68634461726B3A22236533653465';
wwv_flow_imp.g_varchar2_table(6727) := '323239222C68634C696768743A2223434343434343227D2C6228302C22436F6C6F72206F662077686974657370616365206368617261637465727320696E2074686520656469746F722E2229292C59623D4C6D2822656469746F724C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(6728) := '722E666F726567726F756E64222C7B6461726B3A2223383538353835222C6C696768743A2223323337383933222C68634461726B3A68752E77686974652C68634C696768743A2223323932393239227D2C6228302C22436F6C6F72206F6620656469746F';
wwv_flow_imp.g_varchar2_table(6729) := '72206C696E65206E756D626572732E2229292C5A623D4C6D2822656469746F72496E64656E7447756964652E6261636B67726F756E64222C7B6461726B3A51622C6C696768743A51622C68634461726B3A51622C68634C696768743A51627D2C6228302C';
wwv_flow_imp.g_varchar2_table(6730) := '22436F6C6F72206F662074686520656469746F7220696E64656E746174696F6E206775696465732E22292C21312C6228302C2227656469746F72496E64656E7447756964652E6261636B67726F756E642720697320646570726563617465642E20557365';
wwv_flow_imp.g_varchar2_table(6731) := '2027656469746F72496E64656E7447756964652E6261636B67726F756E64312720696E73746561642E2229292C58623D4C6D2822656469746F72496E64656E7447756964652E6163746976654261636B67726F756E64222C7B6461726B3A51622C6C6967';
wwv_flow_imp.g_varchar2_table(6732) := '68743A51622C68634461726B3A51622C68634C696768743A51627D2C6228302C22436F6C6F72206F66207468652061637469766520656469746F7220696E64656E746174696F6E206775696465732E22292C21312C6228302C2227656469746F72496E64';
wwv_flow_imp.g_varchar2_table(6733) := '656E7447756964652E6163746976654261636B67726F756E642720697320646570726563617465642E205573652027656469746F72496E64656E7447756964652E6163746976654261636B67726F756E64312720696E73746561642E2229292C4A623D4C';
wwv_flow_imp.g_varchar2_table(6734) := '6D2822656469746F72496E64656E7447756964652E6261636B67726F756E6431222C7B6461726B3A5A622C6C696768743A5A622C68634461726B3A5A622C68634C696768743A5A627D2C6228302C22436F6C6F72206F662074686520656469746F722069';
wwv_flow_imp.g_varchar2_table(6735) := '6E64656E746174696F6E20677569646573202831292E2229292C655F3D4C6D2822656469746F72496E64656E7447756964652E6261636B67726F756E6432222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C';
wwv_flow_imp.g_varchar2_table(6736) := '68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F662074686520656469746F7220696E64656E746174696F6E20677569646573202832292E2229292C745F3D4C6D282265';
wwv_flow_imp.g_varchar2_table(6737) := '6469746F72496E64656E7447756964652E6261636B67726F756E6433222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030';
wwv_flow_imp.g_varchar2_table(6738) := '303030227D2C6228302C22436F6C6F72206F662074686520656469746F7220696E64656E746174696F6E20677569646573202833292E2229292C6E5F3D4C6D2822656469746F72496E64656E7447756964652E6261636B67726F756E6434222C7B646172';
wwv_flow_imp.g_varchar2_table(6739) := '6B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F662074686520656469746F7220696E64';
wwv_flow_imp.g_varchar2_table(6740) := '656E746174696F6E20677569646573202834292E2229292C695F3D4C6D2822656469746F72496E64656E7447756964652E6261636B67726F756E6435222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C6863';
wwv_flow_imp.g_varchar2_table(6741) := '4461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F662074686520656469746F7220696E64656E746174696F6E20677569646573202835292E2229292C6F5F3D4C6D2822656469';
wwv_flow_imp.g_varchar2_table(6742) := '746F72496E64656E7447756964652E6261636B67726F756E6436222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A222330303030303030';
wwv_flow_imp.g_varchar2_table(6743) := '30227D2C6228302C22436F6C6F72206F662074686520656469746F7220696E64656E746174696F6E20677569646573202836292E2229292C735F3D4C6D2822656469746F72496E64656E7447756964652E6163746976654261636B67726F756E6431222C';
wwv_flow_imp.g_varchar2_table(6744) := '7B6461726B3A58622C6C696768743A58622C68634461726B3A58622C68634C696768743A58627D2C6228302C22436F6C6F72206F66207468652061637469766520656469746F7220696E64656E746174696F6E20677569646573202831292E2229292C72';
wwv_flow_imp.g_varchar2_table(6745) := '5F3D4C6D2822656469746F72496E64656E7447756964652E6163746976654261636B67726F756E6432222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C6863';
wwv_flow_imp.g_varchar2_table(6746) := '4C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F66207468652061637469766520656469746F7220696E64656E746174696F6E20677569646573202832292E2229292C615F3D4C6D2822656469746F72496E64656E74477569';
wwv_flow_imp.g_varchar2_table(6747) := '64652E6163746976654261636B67726F756E6433222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228';
wwv_flow_imp.g_varchar2_table(6748) := '302C22436F6C6F72206F66207468652061637469766520656469746F7220696E64656E746174696F6E20677569646573202833292E2229292C6C5F3D4C6D2822656469746F72496E64656E7447756964652E6163746976654261636B67726F756E643422';
wwv_flow_imp.g_varchar2_table(6749) := '2C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F6620746865206163746976';
wwv_flow_imp.g_varchar2_table(6750) := '6520656469746F7220696E64656E746174696F6E20677569646573202834292E2229292C635F3D4C6D2822656469746F72496E64656E7447756964652E6163746976654261636B67726F756E6435222C7B6461726B3A22233030303030303030222C6C69';
wwv_flow_imp.g_varchar2_table(6751) := '6768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F66207468652061637469766520656469746F7220696E64656E746174696F6E20';
wwv_flow_imp.g_varchar2_table(6752) := '677569646573202835292E2229292C645F3D4C6D2822656469746F72496E64656E7447756964652E6163746976654261636B67726F756E6436222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C6863446172';
wwv_flow_imp.g_varchar2_table(6753) := '6B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22436F6C6F72206F66207468652061637469766520656469746F7220696E64656E746174696F6E20677569646573202836292E2229292C685F3D4C6D28';
wwv_flow_imp.g_varchar2_table(6754) := '22656469746F724163746976654C696E654E756D6265722E666F726567726F756E64222C7B6461726B3A2223633663366336222C6C696768743A2223304232313646222C68634461726B3A486D2C68634C696768743A486D7D2C6228302C22436F6C6F72';
wwv_flow_imp.g_varchar2_table(6755) := '206F6620656469746F7220616374697665206C696E65206E756D62657222292C21312C6228302C22496420697320646570726563617465642E205573652027656469746F724C696E654E756D6265722E616374697665466F726567726F756E642720696E';
wwv_flow_imp.g_varchar2_table(6756) := '73746561642E2229292C755F3D284C6D2822656469746F724C696E654E756D6265722E616374697665466F726567726F756E64222C7B6461726B3A685F2C6C696768743A685F2C68634461726B3A685F2C68634C696768743A685F7D2C6228302C22436F';
wwv_flow_imp.g_varchar2_table(6757) := '6C6F72206F6620656469746F7220616374697665206C696E65206E756D6265722229292C4C6D2822656469746F724C696E654E756D6265722E64696D6D6564466F726567726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C686344';
wwv_flow_imp.g_varchar2_table(6758) := '61726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22436F6C6F72206F66207468652066696E616C20656469746F72206C696E65207768656E20656469746F722E72656E64657246696E616C4E65776C696E652069732073657420746F20';
wwv_flow_imp.g_varchar2_table(6759) := '64696D6D65642E222929292C705F3D284C6D2822656469746F7252756C65722E666F726567726F756E64222C7B6461726B3A2223354135413541222C6C696768743A68752E6C69676874677265792C68634461726B3A68752E77686974652C68634C6967';
wwv_flow_imp.g_varchar2_table(6760) := '68743A2223323932393239227D2C6228302C22436F6C6F72206F662074686520656469746F722072756C6572732E2229292C4C6D2822656469746F72436F64654C656E732E666F726567726F756E64222C7B6461726B3A2223393939393939222C6C6967';
wwv_flow_imp.g_varchar2_table(6761) := '68743A2223393139313931222C68634461726B3A2223393939393939222C68634C696768743A2223323932393239227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620656469746F7220436F64654C656E732229292C4C6D2822656469';
wwv_flow_imp.g_varchar2_table(6762) := '746F72427261636B65744D617463682E6261636B67726F756E64222C7B6461726B3A22233030363430303161222C6C696768743A22233030363430303161222C68634461726B3A22233030363430303161222C68634C696768743A222330303030227D2C';
wwv_flow_imp.g_varchar2_table(6763) := '6228302C224261636B67726F756E6420636F6C6F7220626568696E64206D61746368696E6720627261636B6574732229292C4C6D2822656469746F72427261636B65744D617463682E626F72646572222C7B6461726B3A2223383838222C6C696768743A';
wwv_flow_imp.g_varchar2_table(6764) := '2223423942394239222C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22436F6C6F7220666F72206D61746368696E6720627261636B65747320626F7865732229292C4C6D2822656469746F724F7665727669657752756C65722E626F';
wwv_flow_imp.g_varchar2_table(6765) := '72646572222C7B6461726B3A22233766376637663464222C6C696768743A22233766376637663464222C68634461726B3A22233766376637663464222C68634C696768743A2223363636363636227D2C6228302C22436F6C6F72206F6620746865206F76';
wwv_flow_imp.g_varchar2_table(6766) := '6572766965772072756C657220626F726465722E222929292C675F3D4C6D2822656469746F724F7665727669657752756C65722E6261636B67726F756E64222C6E756C6C2C6228302C224261636B67726F756E6420636F6C6F72206F6620746865206564';
wwv_flow_imp.g_varchar2_table(6767) := '69746F72206F766572766965772072756C65722E2229292C6D5F3D284C6D2822656469746F724775747465722E6261636B67726F756E64222C7B6461726B3A596D2C6C696768743A596D2C68634461726B3A596D2C68634C696768743A596D7D2C622830';
wwv_flow_imp.g_varchar2_table(6768) := '2C224261636B67726F756E6420636F6C6F72206F662074686520656469746F72206775747465722E205468652067757474657220636F6E7461696E732074686520676C797068206D617267696E7320616E6420746865206C696E65206E756D626572732E';
wwv_flow_imp.g_varchar2_table(6769) := '2229292C4C6D2822656469746F72556E6E6563657373617279436F64652E626F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A68752E66726F6D48657828222366666622292E7472616E73706172656E74282E38';
wwv_flow_imp.g_varchar2_table(6770) := '292C68634C696768743A7A6D7D2C6228302C22426F7264657220636F6C6F72206F6620756E6E65636573736172792028756E757365642920736F7572636520636F646520696E2074686520656469746F722E2229292C4C6D2822656469746F72556E6E65';
wwv_flow_imp.g_varchar2_table(6771) := '63657373617279436F64652E6F706163697479222C7B6461726B3A68752E66726F6D4865782822233030306122292C6C696768743A68752E66726F6D4865782822233030303722292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C62';
wwv_flow_imp.g_varchar2_table(6772) := '28302C224F706163697479206F6620756E6E65636573736172792028756E757365642920736F7572636520636F646520696E2074686520656469746F722E20466F72206578616D706C652C205C222330303030303063305C222077696C6C2072656E6465';
wwv_flow_imp.g_varchar2_table(6773) := '722074686520636F6465207769746820373525206F7061636974792E20466F72206869676820636F6E7472617374207468656D65732C2075736520746865202027656469746F72556E6E6563657373617279436F64652E626F7264657227207468656D65';
wwv_flow_imp.g_varchar2_table(6774) := '20636F6C6F7220746F20756E6465726C696E6520756E6E656365737361727920636F646520696E7374656164206F6620666164696E67206974206F75742E222929292C665F3D284C6D2822656469746F7247686F7374546578742E626F72646572222C7B';
wwv_flow_imp.g_varchar2_table(6775) := '6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A68752E66726F6D48657828222366666622292E7472616E73706172656E74282E38292C68634C696768743A68752E66726F6D48657828222332393239323922292E7472616E737061';
wwv_flow_imp.g_varchar2_table(6776) := '72656E74282E38297D2C6228302C22426F7264657220636F6C6F72206F662067686F7374207465787420696E2074686520656469746F722E2229292C4C6D2822656469746F7247686F7374546578742E666F726567726F756E64222C7B6461726B3A6875';
wwv_flow_imp.g_varchar2_table(6777) := '2E66726F6D486578282223666666666666353622292C6C696768743A68752E66726F6D4865782822233030303722292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22466F726567726F756E6420636F6C6F72206F662074';
wwv_flow_imp.g_varchar2_table(6778) := '68652067686F7374207465787420696E2074686520656469746F722E2229292C4C6D2822656469746F7247686F7374546578742E6261636B67726F756E64222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A6E756C6C2C6863';
wwv_flow_imp.g_varchar2_table(6779) := '4C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F72206F66207468652067686F7374207465787420696E2074686520656469746F722E2229292C6E6577206875286E6577206C7528302C3132322C3230342C2E362929292C';
wwv_flow_imp.g_varchar2_table(6780) := '765F3D4C6D2822656469746F724F7665727669657752756C65722E72616E6765486967686C69676874466F726567726F756E64222C7B6461726B3A665F2C6C696768743A665F2C68634461726B3A665F2C68634C696768743A665F7D2C6228302C224F76';
wwv_flow_imp.g_varchar2_table(6781) := '6572766965772072756C6572206D61726B657220636F6C6F7220666F722072616E676520686967686C69676874732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E646572';
wwv_flow_imp.g_varchar2_table(6782) := '6C79696E67206465636F726174696F6E732E22292C2130292C625F3D4C6D2822656469746F724F7665727669657752756C65722E6572726F72466F726567726F756E64222C7B6461726B3A6E6577206875286E6577206C75283235352C31382C31382C2E';
wwv_flow_imp.g_varchar2_table(6783) := '3729292C6C696768743A6E6577206875286E6577206C75283235352C31382C31382C2E3729292C68634461726B3A6E6577206875286E6577206C75283235352C35302C35302C3129292C68634C696768743A2223423532303044227D2C6228302C224F76';
wwv_flow_imp.g_varchar2_table(6784) := '6572766965772072756C6572206D61726B657220636F6C6F7220666F72206572726F72732E2229292C5F5F3D4C6D2822656469746F724F7665727669657752756C65722E7761726E696E67466F726567726F756E64222C7B6461726B3A73662C6C696768';
wwv_flow_imp.g_varchar2_table(6785) := '743A73662C68634461726B3A72662C68634C696768743A72667D2C6228302C224F766572766965772072756C6572206D61726B657220636F6C6F7220666F72207761726E696E67732E2229292C795F3D4C6D2822656469746F724F766572766965775275';
wwv_flow_imp.g_varchar2_table(6786) := '6C65722E696E666F466F726567726F756E64222C7B6461726B3A61662C6C696768743A61662C68634461726B3A6C662C68634C696768743A6C667D2C6228302C224F766572766965772072756C6572206D61726B657220636F6C6F7220666F7220696E66';
wwv_flow_imp.g_varchar2_table(6787) := '6F732E2229292C775F3D4C6D2822656469746F72427261636B6574486967686C696768742E666F726567726F756E6431222C7B6461726B3A2223464644373030222C6C696768743A22233034333146414646222C68634461726B3A222346464437303022';
wwv_flow_imp.g_varchar2_table(6788) := '2C68634C696768743A22233034333146414646227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620627261636B657473202831292E20526571756972657320656E61626C696E6720627261636B6574207061697220636F6C6F72697A61';
wwv_flow_imp.g_varchar2_table(6789) := '74696F6E2E2229292C435F3D4C6D2822656469746F72427261636B6574486967686C696768742E666F726567726F756E6432222C7B6461726B3A2223444137304436222C6C696768743A22233331393333314646222C68634461726B3A22234441373044';
wwv_flow_imp.g_varchar2_table(6790) := '36222C68634C696768743A22233331393333314646227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620627261636B657473202832292E20526571756972657320656E61626C696E6720627261636B6574207061697220636F6C6F7269';
wwv_flow_imp.g_varchar2_table(6791) := '7A6174696F6E2E2229292C535F3D4C6D2822656469746F72427261636B6574486967686C696768742E666F726567726F756E6433222C7B6461726B3A2223313739464646222C6C696768743A22233742333831344646222C68634461726B3A2223383743';
wwv_flow_imp.g_varchar2_table(6792) := '454641222C68634C696768743A22233742333831344646227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620627261636B657473202833292E20526571756972657320656E61626C696E6720627261636B6574207061697220636F6C6F';
wwv_flow_imp.g_varchar2_table(6793) := '72697A6174696F6E2E2229292C785F3D4C6D2822656469746F72427261636B6574486967686C696768742E666F726567726F756E6434222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22';
wwv_flow_imp.g_varchar2_table(6794) := '233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620627261636B657473202834292E20526571756972657320656E61626C696E6720627261636B657420706169';
wwv_flow_imp.g_varchar2_table(6795) := '7220636F6C6F72697A6174696F6E2E2229292C6B5F3D4C6D2822656469746F72427261636B6574486967686C696768742E666F726567726F756E6435222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C6863';
wwv_flow_imp.g_varchar2_table(6796) := '4461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620627261636B657473202835292E20526571756972657320656E61626C696E6720627261636B';
wwv_flow_imp.g_varchar2_table(6797) := '6574207061697220636F6C6F72697A6174696F6E2E2229292C455F3D4C6D2822656469746F72427261636B6574486967686C696768742E666F726567726F756E6436222C7B6461726B3A22233030303030303030222C6C696768743A2223303030303030';
wwv_flow_imp.g_varchar2_table(6798) := '3030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620627261636B657473202836292E20526571756972657320656E61626C696E67';
wwv_flow_imp.g_varchar2_table(6799) := '20627261636B6574207061697220636F6C6F72697A6174696F6E2E2229292C4C5F3D4C6D2822656469746F72427261636B6574486967686C696768742E756E6578706563746564427261636B65742E666F726567726F756E64222C7B6461726B3A6E6577';
wwv_flow_imp.g_varchar2_table(6800) := '206875286E6577206C75283235352C31382C31382C2E3829292C6C696768743A6E6577206875286E6577206C75283235352C31382C31382C2E3829292C68634461726B3A6E6577206875286E6577206C75283235352C35302C35302C3129292C68634C69';
wwv_flow_imp.g_varchar2_table(6801) := '6768743A22227D2C6228302C22466F726567726F756E6420636F6C6F72206F6620756E657870656374656420627261636B6574732E2229292C445F3D4C6D2822656469746F72427261636B65745061697247756964652E6261636B67726F756E6431222C';
wwv_flow_imp.g_varchar2_table(6802) := '7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F66';
wwv_flow_imp.g_varchar2_table(6803) := '20696E61637469766520627261636B6574207061697220677569646573202831292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C545F3D4C6D2822656469746F72427261636B6574506169';
wwv_flow_imp.g_varchar2_table(6804) := '7247756964652E6261636B67726F756E6432222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C';
wwv_flow_imp.g_varchar2_table(6805) := '224261636B67726F756E6420636F6C6F72206F6620696E61637469766520627261636B6574207061697220677569646573202832292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C495F3D';
wwv_flow_imp.g_varchar2_table(6806) := '4C6D2822656469746F72427261636B65745061697247756964652E6261636B67726F756E6433222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C6967';
wwv_flow_imp.g_varchar2_table(6807) := '68743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F6620696E61637469766520627261636B6574207061697220677569646573202833292E20526571756972657320656E61626C696E6720627261636B6574';
wwv_flow_imp.g_varchar2_table(6808) := '2070616972206775696465732E2229292C4D5F3D4C6D2822656469746F72427261636B65745061697247756964652E6261636B67726F756E6434222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461';
wwv_flow_imp.g_varchar2_table(6809) := '726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F6620696E61637469766520627261636B6574207061697220677569646573202834292E205265717569';
wwv_flow_imp.g_varchar2_table(6810) := '72657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C415F3D4C6D2822656469746F72427261636B65745061697247756964652E6261636B67726F756E6435222C7B6461726B3A22233030303030303030222C6C69';
wwv_flow_imp.g_varchar2_table(6811) := '6768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F6620696E61637469766520627261636B6574207061';
wwv_flow_imp.g_varchar2_table(6812) := '697220677569646573202835292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C4E5F3D4C6D2822656469746F72427261636B65745061697247756964652E6261636B67726F756E6436222C';
wwv_flow_imp.g_varchar2_table(6813) := '7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F66';
wwv_flow_imp.g_varchar2_table(6814) := '20696E61637469766520627261636B6574207061697220677569646573202836292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C505F3D4C6D2822656469746F72427261636B6574506169';
wwv_flow_imp.g_varchar2_table(6815) := '7247756964652E6163746976654261636B67726F756E6431222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A2223303030303030303022';
wwv_flow_imp.g_varchar2_table(6816) := '7D2C6228302C224261636B67726F756E6420636F6C6F72206F662061637469766520627261636B6574207061697220677569646573202831292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E222929';
wwv_flow_imp.g_varchar2_table(6817) := '2C4F5F3D4C6D2822656469746F72427261636B65745061697247756964652E6163746976654261636B67726F756E6432222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030';
wwv_flow_imp.g_varchar2_table(6818) := '303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F662061637469766520627261636B6574207061697220677569646573202832292E20526571756972657320656E61626C696E67';
wwv_flow_imp.g_varchar2_table(6819) := '20627261636B65742070616972206775696465732E2229292C525F3D4C6D2822656469746F72427261636B65745061697247756964652E6163746976654261636B67726F756E6433222C7B6461726B3A22233030303030303030222C6C696768743A2223';
wwv_flow_imp.g_varchar2_table(6820) := '3030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F662061637469766520627261636B65742070616972206775696465';
wwv_flow_imp.g_varchar2_table(6821) := '73202833292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C465F3D4C6D2822656469746F72427261636B65745061697247756964652E6163746976654261636B67726F756E6434222C7B64';
wwv_flow_imp.g_varchar2_table(6822) := '61726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F662061';
wwv_flow_imp.g_varchar2_table(6823) := '637469766520627261636B6574207061697220677569646573202834292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C425F3D4C6D2822656469746F72427261636B657450616972477569';
wwv_flow_imp.g_varchar2_table(6824) := '64652E6163746976654261636B67726F756E6435222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A22233030303030303030222C68634C696768743A22233030303030303030227D2C6228';
wwv_flow_imp.g_varchar2_table(6825) := '302C224261636B67726F756E6420636F6C6F72206F662061637469766520627261636B6574207061697220677569646573202835292E20526571756972657320656E61626C696E6720627261636B65742070616972206775696465732E2229292C565F3D';
wwv_flow_imp.g_varchar2_table(6826) := '4C6D2822656469746F72427261636B65745061697247756964652E6163746976654261636B67726F756E6436222C7B6461726B3A22233030303030303030222C6C696768743A22233030303030303030222C68634461726B3A2223303030303030303022';
wwv_flow_imp.g_varchar2_table(6827) := '2C68634C696768743A22233030303030303030227D2C6228302C224261636B67726F756E6420636F6C6F72206F662061637469766520627261636B6574207061697220677569646573202836292E20526571756972657320656E61626C696E6720627261';
wwv_flow_imp.g_varchar2_table(6828) := '636B65742070616972206775696465732E2229293B4C6D2822656469746F72556E69636F6465486967686C696768742E626F72646572222C7B6461726B3A73662C6C696768743A73662C68634461726B3A73662C68634C696768743A73667D2C6228302C';
wwv_flow_imp.g_varchar2_table(6829) := '22426F7264657220636F6C6F72207573656420746F20686967686C6967687420756E69636F646520636861726163746572732E2229292C4C6D2822656469746F72556E69636F6465486967686C696768742E6261636B67726F756E64222C7B6461726B3A';
wwv_flow_imp.g_varchar2_table(6830) := '6F662C6C696768743A6F662C68634461726B3A6F662C68634C696768743A6F667D2C6228302C224261636B67726F756E6420636F6C6F72207573656420746F20686967686C6967687420756E69636F646520636861726163746572732E2229292C566228';
wwv_flow_imp.g_varchar2_table(6831) := '2828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F7228596D292C693D652E676574436F6C6F72284862292C6F3D69262621692E69735472616E73706172656E7428293F693A6E3B6F2626742E61646452756C6528602E6D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(6832) := '6469746F72202E696E707574617265612E696D652D696E707574207B206261636B67726F756E642D636F6C6F723A20247B6F7D3B207D60297D29293B636C617373207A5F20657874656E6473206C747B636F6E7374727563746F722865297B7375706572';
wwv_flow_imp.g_varchar2_table(6833) := '28292C746869732E746578744D6F64656C3D652C746869732E636F6C6F7250726F76696465723D6E657720485F2C746869732E6F6E4469644368616E6765456D69747465723D6E65772043742C746869732E6F6E4469644368616E67653D746869732E6F';
wwv_flow_imp.g_varchar2_table(6834) := '6E4469644368616E6765456D69747465722E6576656E742C746869732E636F6C6F72697A6174696F6E4F7074696F6E733D652E6765744F7074696F6E7328292E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732C746869732E';
wwv_flow_imp.g_varchar2_table(6835) := '5F726567697374657228652E627261636B657450616972732E6F6E4469644368616E67652828653D3E7B746869732E6F6E4469644368616E6765456D69747465722E6669726528297D2929297D68616E646C654469644368616E67654F7074696F6E7328';
wwv_flow_imp.g_varchar2_table(6836) := '65297B746869732E636F6C6F72697A6174696F6E4F7074696F6E733D746869732E746578744D6F64656C2E6765744F7074696F6E7328292E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E737D6765744465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(6837) := '73496E52616E676528652C742C6E2C69297B72657475726E20697C7C766F696420303D3D3D743F5B5D3A746869732E636F6C6F72697A6174696F6E4F7074696F6E732E656E61626C65643F746869732E746578744D6F64656C2E627261636B6574506169';
wwv_flow_imp.g_varchar2_table(6838) := '72732E676574427261636B657473496E52616E676528652C2130292E6D61702828653D3E287B69643A60627261636B6574247B652E72616E67652E746F537472696E6728297D2D247B652E6E657374696E674C6576656C7D602C6F7074696F6E733A7B64';
wwv_flow_imp.g_varchar2_table(6839) := '65736372697074696F6E3A22427261636B657450616972436F6C6F72697A6174696F6E222C696E6C696E65436C6173734E616D653A746869732E636F6C6F7250726F76696465722E676574496E6C696E65436C6173734E616D6528652C746869732E636F';
wwv_flow_imp.g_varchar2_table(6840) := '6C6F72697A6174696F6E4F7074696F6E732E696E646570656E64656E74436F6C6F72506F6F6C506572427261636B657454797065297D2C6F776E657249643A302C72616E67653A652E72616E67657D2929292E746F417272617928293A5B5D7D67657441';
wwv_flow_imp.g_varchar2_table(6841) := '6C6C4465636F726174696F6E7328652C74297B72657475726E20766F696420303D3D3D653F5B5D3A746869732E636F6C6F72697A6174696F6E4F7074696F6E732E656E61626C65643F746869732E6765744465636F726174696F6E73496E52616E676528';
wwv_flow_imp.g_varchar2_table(6842) := '6E657720726828312C312C746869732E746578744D6F64656C2E6765744C696E65436F756E7428292C31292C652C74293A5B5D7D7D636C61737320485F7B636F6E7374727563746F7228297B746869732E756E6578706563746564436C6F73696E674272';
wwv_flow_imp.g_varchar2_table(6843) := '61636B6574436C6173734E616D653D22756E65787065637465642D636C6F73696E672D627261636B6574227D676574496E6C696E65436C6173734E616D6528652C74297B72657475726E20652E6973496E76616C69643F746869732E756E657870656374';
wwv_flow_imp.g_varchar2_table(6844) := '6564436C6F73696E67427261636B6574436C6173734E616D653A746869732E676574496E6C696E65436C6173734E616D654F664C6576656C28743F652E6E657374696E674C6576656C4F66457175616C427261636B6574547970653A652E6E657374696E';
wwv_flow_imp.g_varchar2_table(6845) := '674C6576656C297D676574496E6C696E65436C6173734E616D654F664C6576656C2865297B72657475726E22627261636B65742D686967686C69676874696E672D222B652533307D7D66756E6374696F6E20575F2865297B72657475726E20652E726570';
wwv_flow_imp.g_varchar2_table(6846) := '6C616365282F5C6E2F672C225C5C6E22292E7265706C616365282F5C722F672C225C5C7222297D5662282828652C74293D3E7B636F6E7374206E3D5B775F2C435F2C535F2C785F2C6B5F2C455F5D2C693D6E657720485F3B742E61646452756C6528602E';
wwv_flow_imp.g_varchar2_table(6847) := '6D6F6E61636F2D656469746F72202E247B692E756E6578706563746564436C6F73696E67427261636B6574436C6173734E616D657D207B20636F6C6F723A20247B652E676574436F6C6F72284C5F297D3B207D60293B636F6E7374206F3D6E2E6D617028';
wwv_flow_imp.g_varchar2_table(6848) := '28743D3E652E676574436F6C6F7228742929292E66696C7465722828653D3E21216529292E66696C7465722828653D3E21652E69735472616E73706172656E74282929293B666F72286C657420653D303B653C33303B652B2B297B636F6E7374206E3D6F';
wwv_flow_imp.g_varchar2_table(6849) := '5B65256F2E6C656E6774685D3B742E61646452756C6528602E6D6F6E61636F2D656469746F72202E247B692E676574496E6C696E65436C6173734E616D654F664C6576656C2865297D207B20636F6C6F723A20247B6E7D3B207D60297D7D29293B636C61';
wwv_flow_imp.g_varchar2_table(6850) := '7373206A5F7B676574206F6C644C656E67746828297B72657475726E20746869732E6F6C64546578742E6C656E6774687D676574206F6C64456E6428297B72657475726E20746869732E6F6C64506F736974696F6E2B746869732E6F6C64546578742E6C';
wwv_flow_imp.g_varchar2_table(6851) := '656E6774687D676574206E65774C656E67746828297B72657475726E20746869732E6E6577546578742E6C656E6774687D676574206E6577456E6428297B72657475726E20746869732E6E6577506F736974696F6E2B746869732E6E6577546578742E6C';
wwv_flow_imp.g_varchar2_table(6852) := '656E6774687D636F6E7374727563746F7228652C742C6E2C69297B746869732E6F6C64506F736974696F6E3D652C746869732E6F6C64546578743D742C746869732E6E6577506F736974696F6E3D6E2C746869732E6E6577546578743D697D746F537472';
wwv_flow_imp.g_varchar2_table(6853) := '696E6728297B72657475726E20303D3D3D746869732E6F6C64546578742E6C656E6774683F6028696E7365727440247B746869732E6F6C64506F736974696F6E7D2022247B575F28746869732E6E657754657874297D2229603A303D3D3D746869732E6E';
wwv_flow_imp.g_varchar2_table(6854) := '6577546578742E6C656E6774683F602864656C65746540247B746869732E6F6C64506F736974696F6E7D2022247B575F28746869732E6F6C6454657874297D2229603A60287265706C61636540247B746869732E6F6C64506F736974696F6E7D2022247B';
wwv_flow_imp.g_varchar2_table(6855) := '575F28746869732E6F6C6454657874297D2220776974682022247B575F28746869732E6E657754657874297D2229607D737461746963205F7772697465537472696E6753697A652865297B72657475726E20342B322A652E6C656E6774687D7374617469';
wwv_flow_imp.g_varchar2_table(6856) := '63205F7772697465537472696E6728652C742C6E297B636F6E737420693D742E6C656E6774683B5A7528652C692C6E292C6E2B3D343B666F72286C6574206F3D303B6F3C693B6F2B2B29517528652C742E63686172436F64654174286F292C6E292C6E2B';
wwv_flow_imp.g_varchar2_table(6857) := '3D323B72657475726E206E7D737461746963205F72656164537472696E6728652C74297B636F6E7374206E3D597528652C74293B72657475726E2066756E6374696F6E28652C742C6E297B636F6E737420693D6E65772055696E74313641727261792865';
wwv_flow_imp.g_varchar2_table(6858) := '2E6275666665722C742C6E293B72657475726E206E3E3026262836353237393D3D3D695B305D7C7C36353533343D3D3D695B305D293F66756E6374696F6E28652C742C6E297B636F6E737420693D5B5D3B6C6574206F3D303B666F72286C657420733D30';
wwv_flow_imp.g_varchar2_table(6859) := '3B733C6E3B732B2B297B636F6E7374206E3D477528652C74293B742B3D322C695B6F2B2B5D3D537472696E672E66726F6D43686172436F6465286E297D72657475726E20692E6A6F696E282222297D28652C742C6E293A657028292E6465636F64652869';
wwv_flow_imp.g_varchar2_table(6860) := '297D28652C742B3D342C6E297D777269746553697A6528297B72657475726E20382B6A5F2E5F7772697465537472696E6753697A6528746869732E6F6C6454657874292B6A5F2E5F7772697465537472696E6753697A6528746869732E6E657754657874';
wwv_flow_imp.g_varchar2_table(6861) := '297D777269746528652C74297B72657475726E205A7528652C746869732E6F6C64506F736974696F6E2C74292C742B3D342C5A7528652C746869732E6E6577506F736974696F6E2C74292C742B3D342C743D6A5F2E5F7772697465537472696E6728652C';
wwv_flow_imp.g_varchar2_table(6862) := '746869732E6F6C64546578742C74292C6A5F2E5F7772697465537472696E6728652C746869732E6E6577546578742C74297D737461746963207265616428652C742C6E297B636F6E737420693D597528652C74292C6F3D597528652C742B3D34293B742B';
wwv_flow_imp.g_varchar2_table(6863) := '3D343B636F6E737420733D6A5F2E5F72656164537472696E6728652C74293B742B3D6A5F2E5F7772697465537472696E6753697A652873293B636F6E737420723D6A5F2E5F72656164537472696E6728652C74293B72657475726E20742B3D6A5F2E5F77';
wwv_flow_imp.g_varchar2_table(6864) := '72697465537472696E6753697A652872292C6E2E70757368286E6577206A5F28692C732C6F2C7229292C747D7D636C61737320715F7B636F6E7374727563746F7228652C74297B746869732E5F7072657645646974733D652C746869732E5F6375727245';
wwv_flow_imp.g_varchar2_table(6865) := '646974733D742C746869732E5F726573756C743D5B5D2C746869732E5F726573756C744C656E3D302C746869732E5F707265764C656E3D746869732E5F7072657645646974732E6C656E6774682C746869732E5F7072657644656C74614F66667365743D';
wwv_flow_imp.g_varchar2_table(6866) := '302C746869732E5F637572724C656E3D746869732E5F6375727245646974732E6C656E6774682C746869732E5F6375727244656C74614F66667365743D307D636F6D707265737328297B6C657420653D302C743D302C6E3D746869732E5F676574507265';
wwv_flow_imp.g_varchar2_table(6867) := '762865292C693D746869732E5F676574437572722874293B666F72283B653C746869732E5F707265764C656E7C7C743C746869732E5F637572724C656E3B297B6966286E756C6C3D3D3D6E297B746869732E5F616363657074437572722869292C693D74';
wwv_flow_imp.g_varchar2_table(6868) := '6869732E5F67657443757272282B2B74293B636F6E74696E75657D6966286E756C6C3D3D3D69297B746869732E5F61636365707450726576286E292C6E3D746869732E5F67657450726576282B2B65293B636F6E74696E75657D696628692E6F6C64456E';
wwv_flow_imp.g_varchar2_table(6869) := '643C3D6E2E6E6577506F736974696F6E297B746869732E5F616363657074437572722869292C693D746869732E5F67657443757272282B2B74293B636F6E74696E75657D6966286E2E6E6577456E643C3D692E6F6C64506F736974696F6E297B74686973';
wwv_flow_imp.g_varchar2_table(6870) := '2E5F61636365707450726576286E292C6E3D746869732E5F67657450726576282B2B65293B636F6E74696E75657D696628692E6F6C64506F736974696F6E3C6E2E6E6577506F736974696F6E297B636F6E73745B652C745D3D715F2E5F73706C69744375';
wwv_flow_imp.g_varchar2_table(6871) := '727228692C6E2E6E6577506F736974696F6E2D692E6F6C64506F736974696F6E293B746869732E5F616363657074437572722865292C693D743B636F6E74696E75657D6966286E2E6E6577506F736974696F6E3C692E6F6C64506F736974696F6E297B63';
wwv_flow_imp.g_varchar2_table(6872) := '6F6E73745B652C745D3D715F2E5F73706C697450726576286E2C692E6F6C64506F736974696F6E2D6E2E6E6577506F736974696F6E293B746869732E5F616363657074507265762865292C6E3D743B636F6E74696E75657D6C6574206F2C733B69662869';
wwv_flow_imp.g_varchar2_table(6873) := '2E6F6C64456E643D3D3D6E2E6E6577456E64296F3D6E2C733D692C6E3D746869732E5F67657450726576282B2B65292C693D746869732E5F67657443757272282B2B74293B656C736520696628692E6F6C64456E643C6E2E6E6577456E64297B636F6E73';
wwv_flow_imp.g_varchar2_table(6874) := '745B652C725D3D715F2E5F73706C697450726576286E2C692E6F6C644C656E677468293B6F3D652C733D692C6E3D722C693D746869732E5F67657443757272282B2B74297D656C73657B636F6E73745B742C725D3D715F2E5F73706C6974437572722869';
wwv_flow_imp.g_varchar2_table(6875) := '2C6E2E6E65774C656E677468293B6F3D6E2C733D742C6E3D746869732E5F67657450726576282B2B65292C693D727D746869732E5F726573756C745B746869732E5F726573756C744C656E2B2B5D3D6E6577206A5F286F2E6F6C64506F736974696F6E2C';
wwv_flow_imp.g_varchar2_table(6876) := '6F2E6F6C64546578742C732E6E6577506F736974696F6E2C732E6E657754657874292C746869732E5F7072657644656C74614F66667365742B3D6F2E6E65774C656E6774682D6F2E6F6C644C656E6774682C746869732E5F6375727244656C74614F6666';
wwv_flow_imp.g_varchar2_table(6877) := '7365742B3D732E6E65774C656E6774682D732E6F6C644C656E6774687D636F6E7374206F3D715F2E5F6D6572676528746869732E5F726573756C74293B72657475726E20715F2E5F72656D6F76654E6F4F7073286F297D5F616363657074437572722865';
wwv_flow_imp.g_varchar2_table(6878) := '297B746869732E5F726573756C745B746869732E5F726573756C744C656E2B2B5D3D715F2E5F7265626173654375727228746869732E5F7072657644656C74614F66667365742C65292C746869732E5F6375727244656C74614F66667365742B3D652E6E';
wwv_flow_imp.g_varchar2_table(6879) := '65774C656E6774682D652E6F6C644C656E6774687D5F676574437572722865297B72657475726E20653C746869732E5F637572724C656E3F746869732E5F6375727245646974735B655D3A6E756C6C7D5F616363657074507265762865297B746869732E';
wwv_flow_imp.g_varchar2_table(6880) := '5F726573756C745B746869732E5F726573756C744C656E2B2B5D3D715F2E5F7265626173655072657628746869732E5F6375727244656C74614F66667365742C65292C746869732E5F7072657644656C74614F66667365742B3D652E6E65774C656E6774';
wwv_flow_imp.g_varchar2_table(6881) := '682D652E6F6C644C656E6774687D5F676574507265762865297B72657475726E20653C746869732E5F707265764C656E3F746869732E5F7072657645646974735B655D3A6E756C6C7D737461746963205F7265626173654375727228652C74297B726574';
wwv_flow_imp.g_varchar2_table(6882) := '75726E206E6577206A5F28742E6F6C64506F736974696F6E2D652C742E6F6C64546578742C742E6E6577506F736974696F6E2C742E6E657754657874297D737461746963205F7265626173655072657628652C74297B72657475726E206E6577206A5F28';
wwv_flow_imp.g_varchar2_table(6883) := '742E6F6C64506F736974696F6E2C742E6F6C64546578742C742E6E6577506F736974696F6E2B652C742E6E657754657874297D737461746963205F73706C69745072657628652C74297B636F6E7374206E3D652E6E6577546578742E7375627374722830';
wwv_flow_imp.g_varchar2_table(6884) := '2C74292C693D652E6E6577546578742E7375627374722874293B72657475726E5B6E6577206A5F28652E6F6C64506F736974696F6E2C652E6F6C64546578742C652E6E6577506F736974696F6E2C6E292C6E6577206A5F28652E6F6C64456E642C22222C';
wwv_flow_imp.g_varchar2_table(6885) := '652E6E6577506F736974696F6E2B742C69295D7D737461746963205F73706C69744375727228652C74297B636F6E7374206E3D652E6F6C64546578742E73756273747228302C74292C693D652E6F6C64546578742E7375627374722874293B7265747572';
wwv_flow_imp.g_varchar2_table(6886) := '6E5B6E6577206A5F28652E6F6C64506F736974696F6E2C6E2C652E6E6577506F736974696F6E2C652E6E657754657874292C6E6577206A5F28652E6F6C64506F736974696F6E2B742C692C652E6E6577456E642C2222295D7D737461746963205F6D6572';
wwv_flow_imp.g_varchar2_table(6887) := '67652865297B696628303D3D3D652E6C656E6774682972657475726E20653B636F6E737420743D5B5D3B6C6574206E3D302C693D655B305D3B666F72286C6574206F3D313B6F3C652E6C656E6774683B6F2B2B297B636F6E737420733D655B6F5D3B692E';
wwv_flow_imp.g_varchar2_table(6888) := '6F6C64456E643D3D3D732E6F6C64506F736974696F6E3F693D6E6577206A5F28692E6F6C64506F736974696F6E2C692E6F6C64546578742B732E6F6C64546578742C692E6E6577506F736974696F6E2C692E6E6577546578742B732E6E65775465787429';
wwv_flow_imp.g_varchar2_table(6889) := '3A28745B6E2B2B5D3D692C693D73297D72657475726E20745B6E2B2B5D3D692C747D737461746963205F72656D6F76654E6F4F70732865297B696628303D3D3D652E6C656E6774682972657475726E20653B636F6E737420743D5B5D3B6C6574206E3D30';
wwv_flow_imp.g_varchar2_table(6890) := '3B666F72286C657420693D303B693C652E6C656E6774683B692B2B297B636F6E7374206F3D655B695D3B6F2E6F6C6454657874213D3D6F2E6E657754657874262628745B6E2B2B5D3D6F297D72657475726E20747D7D66756E6374696F6E20245F286529';
wwv_flow_imp.g_varchar2_table(6891) := '7B72657475726E20652E746F537472696E6728297D636C61737320555F7B7374617469632063726561746528652C74297B636F6E7374206E3D652E676574416C7465726E617469766556657273696F6E496428292C693D515F2865293B72657475726E20';
wwv_flow_imp.g_varchar2_table(6892) := '6E657720555F286E2C6E2C692C692C742C742C5B5D297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E6265666F726556657273696F6E49643D652C746869732E616674657256657273696F6E49643D742C746869732E';
wwv_flow_imp.g_varchar2_table(6893) := '6265666F7265454F4C3D6E2C746869732E6166746572454F4C3D692C746869732E6265666F7265437572736F7253746174653D6F2C746869732E6166746572437572736F7253746174653D732C746869732E6368616E6765733D727D617070656E642865';
wwv_flow_imp.g_varchar2_table(6894) := '2C742C6E2C692C6F297B76617220732C723B742E6C656E6774683E30262628746869732E6368616E6765733D28723D742C6E756C6C3D3D3D28733D746869732E6368616E676573297C7C303D3D3D732E6C656E6774683F723A6E657720715F28732C7229';
wwv_flow_imp.g_varchar2_table(6895) := '2E636F6D7072657373282929292C746869732E6166746572454F4C3D6E2C746869732E616674657256657273696F6E49643D692C746869732E6166746572437572736F7253746174653D6F7D737461746963205F777269746553656C656374696F6E7353';
wwv_flow_imp.g_varchar2_table(6896) := '697A652865297B72657475726E20342B31362A28653F652E6C656E6774683A30297D737461746963205F777269746553656C656374696F6E7328652C742C6E297B6966285A7528652C743F742E6C656E6774683A302C6E292C6E2B3D342C7429666F7228';
wwv_flow_imp.g_varchar2_table(6897) := '636F6E73742069206F662074295A7528652C692E73656C656374696F6E53746172744C696E654E756D6265722C6E292C6E2B3D342C5A7528652C692E73656C656374696F6E5374617274436F6C756D6E2C6E292C6E2B3D342C5A7528652C692E706F7369';
wwv_flow_imp.g_varchar2_table(6898) := '74696F6E4C696E654E756D6265722C6E292C6E2B3D342C5A7528652C692E706F736974696F6E436F6C756D6E2C6E292C6E2B3D343B72657475726E206E7D737461746963205F7265616453656C656374696F6E7328652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(6899) := '597528652C74293B742B3D343B666F72286C6574206F3D303B6F3C693B6F2B2B297B636F6E737420693D597528652C74292C6F3D597528652C742B3D34292C733D597528652C742B3D34292C723D597528652C742B3D34293B742B3D342C6E2E70757368';
wwv_flow_imp.g_varchar2_table(6900) := '286E657720616828692C6F2C732C7229297D72657475726E20747D73657269616C697A6528297B6C657420653D31302B555F2E5F777269746553656C656374696F6E7353697A6528746869732E6265666F7265437572736F725374617465292B555F2E5F';
wwv_flow_imp.g_varchar2_table(6901) := '777269746553656C656374696F6E7353697A6528746869732E6166746572437572736F725374617465292B343B666F7228636F6E73742074206F6620746869732E6368616E67657329652B3D742E777269746553697A6528293B636F6E737420743D6E65';
wwv_flow_imp.g_varchar2_table(6902) := '772055696E743841727261792865293B6C6574206E3D303B5A7528742C746869732E6265666F726556657273696F6E49642C6E292C6E2B3D342C5A7528742C746869732E616674657256657273696F6E49642C6E292C6E2B3D342C4A7528742C74686973';
wwv_flow_imp.g_varchar2_table(6903) := '2E6265666F7265454F4C2C6E292C6E2B3D312C4A7528742C746869732E6166746572454F4C2C6E292C6E2B3D312C6E3D555F2E5F777269746553656C656374696F6E7328742C746869732E6265666F7265437572736F7253746174652C6E292C6E3D555F';
wwv_flow_imp.g_varchar2_table(6904) := '2E5F777269746553656C656374696F6E7328742C746869732E6166746572437572736F7253746174652C6E292C5A7528742C746869732E6368616E6765732E6C656E6774682C6E292C6E2B3D343B666F7228636F6E73742065206F6620746869732E6368';
wwv_flow_imp.g_varchar2_table(6905) := '616E676573296E3D652E777269746528742C6E293B72657475726E20742E6275666665727D73746174696320646573657269616C697A652865297B636F6E737420743D6E65772055696E743841727261792865293B6C6574206E3D303B636F6E73742069';
wwv_flow_imp.g_varchar2_table(6906) := '3D597528742C6E293B6E2B3D343B636F6E7374206F3D597528742C6E293B6E2B3D343B636F6E737420733D587528742C6E293B6E2B3D313B636F6E737420723D587528742C6E293B6E2B3D313B636F6E737420613D5B5D3B6E3D555F2E5F726561645365';
wwv_flow_imp.g_varchar2_table(6907) := '6C656374696F6E7328742C6E2C61293B636F6E7374206C3D5B5D3B6E3D555F2E5F7265616453656C656374696F6E7328742C6E2C6C293B636F6E737420633D597528742C6E293B6E2B3D343B636F6E737420643D5B5D3B666F72286C657420653D303B65';
wwv_flow_imp.g_varchar2_table(6908) := '3C633B652B2B296E3D6A5F2E7265616428742C6E2C64293B72657475726E206E657720555F28692C6F2C732C722C612C6C2C64297D7D636C617373204B5F7B676574207479706528297B72657475726E20307D676574207265736F7572636528297B7265';
wwv_flow_imp.g_varchar2_table(6909) := '7475726E204E6F2E697355726928746869732E6D6F64656C293F746869732E6D6F64656C3A746869732E6D6F64656C2E7572697D636F6E7374727563746F7228652C742C6E2C69297B746869732E6C6162656C3D652C746869732E636F64653D742C7468';
wwv_flow_imp.g_varchar2_table(6910) := '69732E6D6F64656C3D6E2C746869732E5F646174613D555F2E637265617465286E2C69297D746F537472696E6728297B72657475726E28746869732E5F6461746120696E7374616E63656F6620555F3F746869732E5F646174613A555F2E646573657269';
wwv_flow_imp.g_varchar2_table(6911) := '616C697A6528746869732E5F6461746129292E6368616E6765732E6D61702828653D3E652E746F537472696E67282929292E6A6F696E28222C2022297D6D6174636865735265736F757263652865297B72657475726E284E6F2E69735572692874686973';
wwv_flow_imp.g_varchar2_table(6912) := '2E6D6F64656C293F746869732E6D6F64656C3A746869732E6D6F64656C2E757269292E746F537472696E6728293D3D3D652E746F537472696E6728297D7365744D6F64656C2865297B746869732E6D6F64656C3D657D63616E417070656E642865297B72';
wwv_flow_imp.g_varchar2_table(6913) := '657475726E20746869732E6D6F64656C3D3D3D652626746869732E5F6461746120696E7374616E63656F6620555F7D617070656E6428652C742C6E2C692C6F297B746869732E5F6461746120696E7374616E63656F6620555F2626746869732E5F646174';
wwv_flow_imp.g_varchar2_table(6914) := '612E617070656E6428652C742C6E2C692C6F297D636C6F736528297B746869732E5F6461746120696E7374616E63656F6620555F262628746869732E5F646174613D746869732E5F646174612E73657269616C697A652829297D6F70656E28297B746869';
wwv_flow_imp.g_varchar2_table(6915) := '732E5F6461746120696E7374616E63656F6620555F7C7C28746869732E5F646174613D555F2E646573657269616C697A6528746869732E5F6461746129297D756E646F28297B6966284E6F2E697355726928746869732E6D6F64656C29297468726F7720';
wwv_flow_imp.g_varchar2_table(6916) := '6E6577204572726F722822496E76616C69642053696E676C654D6F64656C45646974537461636B456C656D656E7422293B746869732E5F6461746120696E7374616E63656F6620555F262628746869732E5F646174613D746869732E5F646174612E7365';
wwv_flow_imp.g_varchar2_table(6917) := '7269616C697A652829293B636F6E737420653D555F2E646573657269616C697A6528746869732E5F64617461293B746869732E6D6F64656C2E5F6170706C79556E646F28652E6368616E6765732C652E6265666F7265454F4C2C652E6265666F72655665';
wwv_flow_imp.g_varchar2_table(6918) := '7273696F6E49642C652E6265666F7265437572736F725374617465297D7265646F28297B6966284E6F2E697355726928746869732E6D6F64656C29297468726F77206E6577204572726F722822496E76616C69642053696E676C654D6F64656C45646974';
wwv_flow_imp.g_varchar2_table(6919) := '537461636B456C656D656E7422293B746869732E5F6461746120696E7374616E63656F6620555F262628746869732E5F646174613D746869732E5F646174612E73657269616C697A652829293B636F6E737420653D555F2E646573657269616C697A6528';
wwv_flow_imp.g_varchar2_table(6920) := '746869732E5F64617461293B746869732E6D6F64656C2E5F6170706C795265646F28652E6368616E6765732C652E6166746572454F4C2C652E616674657256657273696F6E49642C652E6166746572437572736F725374617465297D6865617053697A65';
wwv_flow_imp.g_varchar2_table(6921) := '28297B72657475726E20746869732E5F6461746120696E7374616E63656F6620555F262628746869732E5F646174613D746869732E5F646174612E73657269616C697A652829292C746869732E5F646174612E627974654C656E6774682B3136387D7D63';
wwv_flow_imp.g_varchar2_table(6922) := '6C61737320475F7B676574207265736F757263657328297B72657475726E20746869732E5F65646974537461636B456C656D656E74734172722E6D61702828653D3E652E7265736F7572636529297D636F6E7374727563746F7228652C742C6E297B7468';
wwv_flow_imp.g_varchar2_table(6923) := '69732E6C6162656C3D652C746869732E636F64653D742C746869732E747970653D312C746869732E5F69734F70656E3D21302C746869732E5F65646974537461636B456C656D656E74734172723D6E2E736C6963652830292C746869732E5F6564697453';
wwv_flow_imp.g_varchar2_table(6924) := '7461636B456C656D656E74734D61703D6E6577204D61703B666F7228636F6E73742065206F6620746869732E5F65646974537461636B456C656D656E7473417272297B636F6E737420743D245F28652E7265736F75726365293B746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(6925) := '537461636B456C656D656E74734D61702E73657428742C65297D746869732E5F64656C65676174653D6E756C6C7D70726570617265556E646F5265646F28297B696628746869732E5F64656C65676174652972657475726E20746869732E5F64656C6567';
wwv_flow_imp.g_varchar2_table(6926) := '6174652E70726570617265556E646F5265646F2874686973297D6D6174636865735265736F757263652865297B636F6E737420743D245F2865293B72657475726E20746869732E5F65646974537461636B456C656D656E74734D61702E6861732874297D';
wwv_flow_imp.g_varchar2_table(6927) := '7365744D6F64656C2865297B636F6E737420743D245F284E6F2E69735572692865293F653A652E757269293B746869732E5F65646974537461636B456C656D656E74734D61702E6861732874292626746869732E5F65646974537461636B456C656D656E';
wwv_flow_imp.g_varchar2_table(6928) := '74734D61702E6765742874292E7365744D6F64656C2865297D63616E417070656E642865297B69662821746869732E5F69734F70656E2972657475726E21313B636F6E737420743D245F28652E757269293B72657475726E2121746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(6929) := '537461636B456C656D656E74734D61702E6861732874292626746869732E5F65646974537461636B456C656D656E74734D61702E6765742874292E63616E417070656E642865297D617070656E6428652C742C6E2C692C6F297B636F6E737420733D245F';
wwv_flow_imp.g_varchar2_table(6930) := '28652E757269293B746869732E5F65646974537461636B456C656D656E74734D61702E6765742873292E617070656E6428652C742C6E2C692C6F297D636C6F736528297B746869732E5F69734F70656E3D21317D6F70656E28297B7D756E646F28297B74';
wwv_flow_imp.g_varchar2_table(6931) := '6869732E5F69734F70656E3D21313B666F7228636F6E73742065206F6620746869732E5F65646974537461636B456C656D656E747341727229652E756E646F28297D7265646F28297B666F7228636F6E73742065206F6620746869732E5F656469745374';
wwv_flow_imp.g_varchar2_table(6932) := '61636B456C656D656E747341727229652E7265646F28297D6865617053697A652865297B636F6E737420743D245F2865293B72657475726E20746869732E5F65646974537461636B456C656D656E74734D61702E6861732874293F746869732E5F656469';
wwv_flow_imp.g_varchar2_table(6933) := '74537461636B456C656D656E74734D61702E6765742874292E6865617053697A6528293A307D73706C697428297B72657475726E20746869732E5F65646974537461636B456C656D656E74734172727D746F537472696E6728297B636F6E737420653D5B';
wwv_flow_imp.g_varchar2_table(6934) := '5D3B666F7228636F6E73742074206F6620746869732E5F65646974537461636B456C656D656E747341727229652E707573682860247B476C28742E7265736F75726365297D3A20247B747D60293B72657475726E607B247B652E6A6F696E28222C202229';
wwv_flow_imp.g_varchar2_table(6935) := '7D7D607D7D66756E6374696F6E20515F2865297B72657475726E225C6E223D3D3D652E676574454F4C28293F303A317D66756E6374696F6E20595F2865297B72657475726E2121652626286520696E7374616E63656F66204B5F7C7C6520696E7374616E';
wwv_flow_imp.g_varchar2_table(6936) := '63656F6620475F297D636C617373205A5F7B636F6E7374727563746F7228652C74297B746869732E5F6D6F64656C3D652C746869732E5F756E646F5265646F536572766963653D747D70757368537461636B456C656D656E7428297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(6937) := '746869732E5F756E646F5265646F536572766963652E6765744C617374456C656D656E7428746869732E5F6D6F64656C2E757269293B595F2865292626652E636C6F736528297D706F70537461636B456C656D656E7428297B636F6E737420653D746869';
wwv_flow_imp.g_varchar2_table(6938) := '732E5F756E646F5265646F536572766963652E6765744C617374456C656D656E7428746869732E5F6D6F64656C2E757269293B595F2865292626652E6F70656E28297D636C65617228297B746869732E5F756E646F5265646F536572766963652E72656D';
wwv_flow_imp.g_varchar2_table(6939) := '6F7665456C656D656E747328746869732E5F6D6F64656C2E757269297D5F6765744F7243726561746545646974537461636B456C656D656E7428652C74297B636F6E7374206E3D746869732E5F756E646F5265646F536572766963652E6765744C617374';
wwv_flow_imp.g_varchar2_table(6940) := '456C656D656E7428746869732E5F6D6F64656C2E757269293B696628595F286E2926266E2E63616E417070656E6428746869732E5F6D6F64656C292972657475726E206E3B636F6E737420693D6E6577204B5F286228302C22547970696E6722292C2275';
wwv_flow_imp.g_varchar2_table(6941) := '6E646F7265646F2E7465787442756666657245646974222C746869732E5F6D6F64656C2C65293B72657475726E20746869732E5F756E646F5265646F536572766963652E70757368456C656D656E7428692C74292C697D70757368454F4C2865297B636F';
wwv_flow_imp.g_varchar2_table(6942) := '6E737420743D746869732E5F6765744F7243726561746545646974537461636B456C656D656E74286E756C6C2C766F69642030293B746869732E5F6D6F64656C2E736574454F4C2865292C742E617070656E6428746869732E5F6D6F64656C2C5B5D2C51';
wwv_flow_imp.g_varchar2_table(6943) := '5F28746869732E5F6D6F64656C292C746869732E5F6D6F64656C2E676574416C7465726E617469766556657273696F6E496428292C6E756C6C297D70757368456469744F7065726174696F6E28652C742C6E2C69297B636F6E7374206F3D746869732E5F';
wwv_flow_imp.g_varchar2_table(6944) := '6765744F7243726561746545646974537461636B456C656D656E7428652C69292C733D746869732E5F6D6F64656C2E6170706C79456469747328742C2130292C723D5A5F2E5F636F6D70757465437572736F725374617465286E2C73292C613D732E6D61';
wwv_flow_imp.g_varchar2_table(6945) := '70282828652C74293D3E287B696E6465783A742C746578744368616E67653A652E746578744368616E67657D2929293B72657475726E20612E736F7274282828652C74293D3E652E746578744368616E67652E6F6C64506F736974696F6E3D3D3D742E74';
wwv_flow_imp.g_varchar2_table(6946) := '6578744368616E67652E6F6C64506F736974696F6E3F652E696E6465782D742E696E6465783A652E746578744368616E67652E6F6C64506F736974696F6E2D742E746578744368616E67652E6F6C64506F736974696F6E29292C6F2E617070656E642874';
wwv_flow_imp.g_varchar2_table(6947) := '6869732E5F6D6F64656C2C612E6D61702828653D3E652E746578744368616E676529292C515F28746869732E5F6D6F64656C292C746869732E5F6D6F64656C2E676574416C7465726E617469766556657273696F6E496428292C72292C727D7374617469';
wwv_flow_imp.g_varchar2_table(6948) := '63205F636F6D70757465437572736F72537461746528652C74297B7472797B72657475726E20653F652874293A6E756C6C7D63617463682865297B72657475726E206B652865292C6E756C6C7D7D7D636C61737320585F20657874656E6473206C747B63';
wwv_flow_imp.g_varchar2_table(6949) := '6F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F6973446973706F7365643D21317D646973706F736528297B73757065722E646973706F736528292C746869732E5F6973446973706F7365643D21307D61';
wwv_flow_imp.g_varchar2_table(6950) := '73736572744E6F74446973706F73656428297B696628746869732E5F6973446973706F736564297468726F77206E6577204572726F722822546578744D6F64656C5061727420697320646973706F7365642122297D7D66756E6374696F6E204A5F28652C';
wwv_flow_imp.g_varchar2_table(6951) := '74297B6C6574206E3D302C693D303B636F6E7374206F3D652E6C656E6774683B666F72283B693C6F3B297B636F6E7374206F3D652E63686172436F646541742869293B69662833323D3D3D6F296E2B2B3B656C73657B69662839213D3D6F29627265616B';
wwv_flow_imp.g_varchar2_table(6952) := '3B6E3D6E2D6E25742B747D692B2B7D72657475726E20693D3D3D6F3F2D313A6E7D7661722065793B2166756E6374696F6E2865297B655B652E44697361626C65643D305D3D2244697361626C6564222C655B652E456E61626C6564466F72416374697665';
wwv_flow_imp.g_varchar2_table(6953) := '3D315D3D22456E61626C6564466F72416374697665222C655B652E456E61626C65643D325D3D22456E61626C6564227D2865797C7C2865793D7B7D29293B636C6173732074797B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B69662874';
wwv_flow_imp.g_varchar2_table(6954) := '6869732E76697369626C65436F6C756D6E3D652C746869732E636F6C756D6E3D742C746869732E636C6173734E616D653D6E2C746869732E686F72697A6F6E74616C4C696E653D692C746869732E666F72577261707065644C696E65734166746572436F';
wwv_flow_imp.g_varchar2_table(6955) := '6C756D6E3D6F2C746869732E666F72577261707065644C696E65734265666F72654F724174436F6C756D6E3D732C2D31213D3D653D3D282D31213D3D7429297468726F77206E6577204572726F727D7D636C617373206E797B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(6956) := '28652C74297B746869732E746F703D652C746869732E656E64436F6C756D6E3D747D7D636C61737320697920657874656E647320585F7B636F6E7374727563746F7228652C74297B737570657228292C746869732E746578744D6F64656C3D652C746869';
wwv_flow_imp.g_varchar2_table(6957) := '732E6C616E6775616765436F6E66696775726174696F6E536572766963653D747D6765744C616E6775616765436F6E66696775726174696F6E2865297B72657475726E20746869732E6C616E6775616765436F6E66696775726174696F6E536572766963';
wwv_flow_imp.g_varchar2_table(6958) := '652E6765744C616E6775616765436F6E66696775726174696F6E2865297D5F636F6D70757465496E64656E744C6576656C2865297B72657475726E204A5F28746869732E746578744D6F64656C2E6765744C696E65436F6E74656E7428652B31292C7468';
wwv_flow_imp.g_varchar2_table(6959) := '69732E746578744D6F64656C2E6765744F7074696F6E7328292E74616253697A65297D676574416374697665496E64656E74477569646528652C742C6E297B746869732E6173736572744E6F74446973706F73656428293B636F6E737420693D74686973';
wwv_flow_imp.g_varchar2_table(6960) := '2E746578744D6F64656C2E6765744C696E65436F756E7428293B696628653C317C7C653E69297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B636F6E7374206F3D746869732E6765744C';
wwv_flow_imp.g_varchar2_table(6961) := '616E6775616765436F6E66696775726174696F6E28746869732E746578744D6F64656C2E6765744C616E677561676549642829292E666F6C64696E6752756C65732C733D426F6F6C65616E286F26266F2E6F666653696465293B6C657420723D2D322C61';
wwv_flow_imp.g_varchar2_table(6962) := '3D2D312C6C3D2D322C633D2D313B636F6E737420643D653D3E7B6966282D31213D3D722626282D323D3D3D727C7C723E652D3129297B723D2D312C613D2D313B666F72286C657420743D652D323B743E3D303B742D2D297B636F6E737420653D74686973';
wwv_flow_imp.g_varchar2_table(6963) := '2E5F636F6D70757465496E64656E744C6576656C2874293B696628653E3D30297B723D742C613D653B627265616B7D7D7D6966282D323D3D3D6C297B6C3D2D312C633D2D313B666F72286C657420743D653B743C693B742B2B297B636F6E737420653D74';
wwv_flow_imp.g_varchar2_table(6964) := '6869732E5F636F6D70757465496E64656E744C6576656C2874293B696628653E3D30297B6C3D742C633D653B627265616B7D7D7D7D3B6C657420683D2D322C753D2D312C703D2D322C673D2D313B636F6E7374206D3D653D3E7B6966282D323D3D3D6829';
wwv_flow_imp.g_varchar2_table(6965) := '7B683D2D312C753D2D313B666F72286C657420743D652D323B743E3D303B742D2D297B636F6E737420653D746869732E5F636F6D70757465496E64656E744C6576656C2874293B696628653E3D30297B683D742C753D653B627265616B7D7D7D6966282D';
wwv_flow_imp.g_varchar2_table(6966) := '31213D3D702626282D323D3D3D707C7C703C652D3129297B703D2D312C673D2D313B666F72286C657420743D653B743C693B742B2B297B636F6E737420653D746869732E5F636F6D70757465496E64656E744C6576656C2874293B696628653E3D30297B';
wwv_flow_imp.g_varchar2_table(6967) := '703D742C673D653B627265616B7D7D7D7D3B6C657420663D302C763D21302C623D302C5F3D21302C793D302C773D303B666F72286C6574206F3D303B767C7C5F3B6F2B2B297B636F6E737420723D652D6F2C703D652B6F3B6F3E31262628723C317C7C72';
wwv_flow_imp.g_varchar2_table(6968) := '3C7429262628763D2131292C6F3E31262628703E697C7C703E6E292626285F3D2131292C6F3E356534262628763D21312C5F3D2131293B6C657420433D2D313B696628762626723E3D31297B636F6E737420653D746869732E5F636F6D70757465496E64';
wwv_flow_imp.g_varchar2_table(6969) := '656E744C6576656C28722D31293B653E3D303F286C3D722D312C633D652C433D4D6174682E6365696C28652F746869732E746578744D6F64656C2E6765744F7074696F6E7328292E696E64656E7453697A6529293A28642872292C433D746869732E5F67';
wwv_flow_imp.g_varchar2_table(6970) := '6574496E64656E744C6576656C466F72576869746573706163654C696E6528732C612C6329297D6C657420533D2D313B6966285F2626703C3D69297B636F6E737420653D746869732E5F636F6D70757465496E64656E744C6576656C28702D31293B653E';
wwv_flow_imp.g_varchar2_table(6971) := '3D303F28683D702D312C753D652C533D4D6174682E6365696C28652F746869732E746578744D6F64656C2E6765744F7074696F6E7328292E696E64656E7453697A6529293A286D2870292C533D746869732E5F676574496E64656E744C6576656C466F72';
wwv_flow_imp.g_varchar2_table(6972) := '576869746573706163654C696E6528732C752C6729297D69662830213D3D6F297B696628313D3D3D6F297B696628703C3D692626533E3D302626772B313D3D3D53297B763D21312C663D702C623D702C793D533B636F6E74696E75657D696628723E3D31';
wwv_flow_imp.g_varchar2_table(6973) := '2626433E3D302626432D313D3D3D77297B5F3D21312C663D722C623D722C793D433B636F6E74696E75657D696628663D652C623D652C793D772C303D3D3D792972657475726E7B73746172744C696E654E756D6265723A662C656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(6974) := '65723A622C696E64656E743A797D7D76262628433E3D793F663D723A763D2131292C5F262628533E3D793F623D703A5F3D2131297D656C736520773D437D72657475726E7B73746172744C696E654E756D6265723A662C656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(6975) := '3A622C696E64656E743A797D7D6765744C696E6573427261636B657447756964657328652C742C6E2C69297B766172206F3B636F6E737420733D5B5D3B666F72286C6574206E3D653B6E3C3D743B6E2B2B29732E70757368285B5D293B636F6E73742072';
wwv_flow_imp.g_varchar2_table(6976) := '3D746869732E746578744D6F64656C2E627261636B657450616972732E676574427261636B65745061697273496E52616E6765576974684D696E496E64656E746174696F6E286E657720726828652C312C742C746869732E746578744D6F64656C2E6765';
wwv_flow_imp.g_varchar2_table(6977) := '744C696E654D6178436F6C756D6E28742929292E746F417272617928293B6C657420613B6E2626722E6C656E6774683E30262628613D6E756C6C3D3D3D286F3D76752828653C3D6E2E6C696E654E756D62657226266E2E6C696E654E756D6265723C3D74';
wwv_flow_imp.g_varchar2_table(6978) := '3F723A746869732E746578744D6F64656C2E627261636B657450616972732E676574427261636B65745061697273496E52616E67652872682E66726F6D506F736974696F6E73286E29292E746F41727261792829292E66696C7465722828653D3E72682E';
wwv_flow_imp.g_varchar2_table(6979) := '737472696374436F6E7461696E73506F736974696F6E28652E72616E67652C6E2929292C28653D3E747275652929297C7C766F696420303D3D3D6F3F766F696420303A6F2E72616E6765293B636F6E7374206C3D746869732E746578744D6F64656C2E67';
wwv_flow_imp.g_varchar2_table(6980) := '65744F7074696F6E7328292E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732E696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970652C633D6E6577206F793B666F7228636F6E7374206E206F';
wwv_flow_imp.g_varchar2_table(6981) := '662072297B696628216E2E636C6F73696E67427261636B657452616E676529636F6E74696E75653B636F6E7374206F3D6126266E2E72616E67652E657175616C7352616E67652861293B696628216F262621692E696E636C756465496E61637469766529';
wwv_flow_imp.g_varchar2_table(6982) := '636F6E74696E75653B636F6E737420723D632E676574496E6C696E65436C6173734E616D65286E2E6E657374696E674C6576656C2C6E2E6E657374696E674C6576656C4F66457175616C427261636B6574547970652C6C292B28692E686967686C696768';
wwv_flow_imp.g_varchar2_table(6983) := '7441637469766526266F3F2220222B632E616374697665436C6173734E616D653A2222292C643D6E2E6F70656E696E67427261636B657452616E67652E6765745374617274506F736974696F6E28292C683D6E2E636C6F73696E67427261636B65745261';
wwv_flow_imp.g_varchar2_table(6984) := '6E67652E6765745374617274506F736974696F6E28292C753D692E686F72697A6F6E74616C4775696465733D3D3D65792E456E61626C65647C7C692E686F72697A6F6E74616C4775696465733D3D3D65792E456E61626C6564466F724163746976652626';
wwv_flow_imp.g_varchar2_table(6985) := '6F3B6966286E2E72616E67652E73746172744C696E654E756D6265723D3D3D6E2E72616E67652E656E644C696E654E756D626572297B752626735B6E2E72616E67652E73746172744C696E654E756D6265722D655D2E70757368286E6577207479282D31';
wwv_flow_imp.g_varchar2_table(6986) := '2C6E2E6F70656E696E67427261636B657452616E67652E676574456E64506F736974696F6E28292E636F6C756D6E2C722C6E6577206E792821312C682E636F6C756D6E292C2D312C2D3129293B636F6E74696E75657D636F6E737420703D746869732E67';
wwv_flow_imp.g_varchar2_table(6987) := '657456697369626C65436F6C756D6E46726F6D506F736974696F6E2868292C673D746869732E67657456697369626C65436F6C756D6E46726F6D506F736974696F6E286E2E6F70656E696E67427261636B657452616E67652E6765745374617274506F73';
wwv_flow_imp.g_varchar2_table(6988) := '6974696F6E2829292C6D3D4D6174682E6D696E28672C702C6E2E6D696E56697369626C65436F6C756D6E496E64656E746174696F6E2B31293B6C657420663D21313B6D6928746869732E746578744D6F64656C2E6765744C696E65436F6E74656E74286E';
wwv_flow_imp.g_varchar2_table(6989) := '2E636C6F73696E67427261636B657452616E67652E73746172744C696E654E756D62657229293C6E2E636C6F73696E67427261636B657452616E67652E7374617274436F6C756D6E2D31262628663D2130293B636F6E737420763D4D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(6990) := '642E6C696E654E756D6265722C65292C623D4D6174682E6D696E28682E6C696E654E756D6265722C74292C5F3D663F313A303B666F72286C657420743D763B743C622B5F3B742B2B29735B742D655D2E70757368286E6577207479286D2C2D312C722C6E';
wwv_flow_imp.g_varchar2_table(6991) := '756C6C2C743D3D3D642E6C696E654E756D6265723F642E636F6C756D6E3A2D312C743D3D3D682E6C696E654E756D6265723F682E636F6C756D6E3A2D3129293B75262628642E6C696E654E756D6265723E3D652626673E6D2626735B642E6C696E654E75';
wwv_flow_imp.g_varchar2_table(6992) := '6D6265722D655D2E70757368286E6577207479286D2C2D312C722C6E6577206E792821312C642E636F6C756D6E292C2D312C2D3129292C682E6C696E654E756D6265723C3D742626703E6D2626735B682E6C696E654E756D6265722D655D2E7075736828';
wwv_flow_imp.g_varchar2_table(6993) := '6E6577207479286D2C2D312C722C6E6577206E792821662C682E636F6C756D6E292C2D312C2D312929297D666F7228636F6E73742065206F66207329652E736F7274282828652C74293D3E652E76697369626C65436F6C756D6E2D742E76697369626C65';
wwv_flow_imp.g_varchar2_table(6994) := '436F6C756D6E29293B72657475726E20737D67657456697369626C65436F6C756D6E46726F6D506F736974696F6E2865297B72657475726E2070752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28746869732E746578744D6F64656C2E67';
wwv_flow_imp.g_varchar2_table(6995) := '65744C696E65436F6E74656E7428652E6C696E654E756D626572292C652E636F6C756D6E2C746869732E746578744D6F64656C2E6765744F7074696F6E7328292E74616253697A65292B317D6765744C696E6573496E64656E7447756964657328652C74';
wwv_flow_imp.g_varchar2_table(6996) := '297B746869732E6173736572744E6F74446973706F73656428293B636F6E7374206E3D746869732E746578744D6F64656C2E6765744C696E65436F756E7428293B696628653C317C7C653E6E297468726F77206E6577204572726F722822496C6C656761';
wwv_flow_imp.g_varchar2_table(6997) := '6C2076616C756520666F722073746172744C696E654E756D62657222293B696628743C317C7C743E6E297468726F77206E6577204572726F722822496C6C6567616C2076616C756520666F7220656E644C696E654E756D62657222293B636F6E73742069';
wwv_flow_imp.g_varchar2_table(6998) := '3D746869732E746578744D6F64656C2E6765744F7074696F6E7328292C6F3D746869732E6765744C616E6775616765436F6E66696775726174696F6E28746869732E746578744D6F64656C2E6765744C616E677561676549642829292E666F6C64696E67';
wwv_flow_imp.g_varchar2_table(6999) := '52756C65732C733D426F6F6C65616E286F26266F2E6F666653696465292C723D6E657720417272617928742D652B31293B6C657420613D2D322C6C3D2D312C633D2D322C643D2D313B666F72286C6574206F3D653B6F3C3D743B6F2B2B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(7000) := '20743D6F2D652C683D746869732E5F636F6D70757465496E64656E744C6576656C286F2D31293B696628683E3D3029613D6F2D312C6C3D682C725B745D3D4D6174682E6365696C28682F692E696E64656E7453697A65293B656C73657B6966282D323D3D';
wwv_flow_imp.g_varchar2_table(7001) := '3D61297B613D2D312C6C3D2D313B666F72286C657420653D6F2D323B653E3D303B652D2D297B636F6E737420743D746869732E5F636F6D70757465496E64656E744C6576656C2865293B696628743E3D30297B613D652C6C3D743B627265616B7D7D7D69';
wwv_flow_imp.g_varchar2_table(7002) := '66282D31213D3D632626282D323D3D3D637C7C633C6F2D3129297B633D2D312C643D2D313B666F72286C657420653D6F3B653C6E3B652B2B297B636F6E737420743D746869732E5F636F6D70757465496E64656E744C6576656C2865293B696628743E3D';
wwv_flow_imp.g_varchar2_table(7003) := '30297B633D652C643D743B627265616B7D7D7D725B745D3D746869732E5F676574496E64656E744C6576656C466F72576869746573706163654C696E6528732C6C2C64297D7D72657475726E20727D5F676574496E64656E744C6576656C466F72576869';
wwv_flow_imp.g_varchar2_table(7004) := '746573706163654C696E6528652C742C6E297B636F6E737420693D746869732E746578744D6F64656C2E6765744F7074696F6E7328293B72657475726E2D313D3D3D747C7C2D313D3D3D6E3F303A743C6E3F312B4D6174682E666C6F6F7228742F692E69';
wwv_flow_imp.g_varchar2_table(7005) := '6E64656E7453697A65293A743D3D3D6E7C7C653F4D6174682E6365696C286E2F692E696E64656E7453697A65293A312B4D6174682E666C6F6F72286E2F692E696E64656E7453697A65297D7D636C617373206F797B636F6E7374727563746F7228297B74';
wwv_flow_imp.g_varchar2_table(7006) := '6869732E616374697665436C6173734E616D653D22696E64656E742D616374697665227D676574496E6C696E65436C6173734E616D6528652C742C6E297B72657475726E20746869732E676574496E6C696E65436C6173734E616D654F664C6576656C28';
wwv_flow_imp.g_varchar2_table(7007) := '6E3F743A65297D676574496E6C696E65436C6173734E616D654F664C6576656C2865297B72657475726E22627261636B65742D696E64656E742D6775696465206C766C2D222B652533307D7D636C6173732073797B636F6E7374727563746F7228297B74';
wwv_flow_imp.g_varchar2_table(7008) := '6869732E737061636573446966663D302C746869732E6C6F6F6B734C696B65416C69676E6D656E743D21317D7D66756E6374696F6E20727928652C742C6E2C692C6F297B6C657420733B666F72286F2E737061636573446966663D302C6F2E6C6F6F6B73';
wwv_flow_imp.g_varchar2_table(7009) := '4C696B65416C69676E6D656E743D21312C733D303B733C742626733C692626652E63686172436F646541742873293D3D3D6E2E63686172436F646541742873293B732B2B293B6C657420723D302C613D303B666F72286C6574206E3D733B6E3C743B6E2B';
wwv_flow_imp.g_varchar2_table(7010) := '2B2933323D3D3D652E63686172436F64654174286E293F722B2B3A612B2B3B6C6574206C3D302C633D303B666F72286C657420653D733B653C693B652B2B2933323D3D3D6E2E63686172436F646541742865293F6C2B2B3A632B2B3B696628723E302626';
wwv_flow_imp.g_varchar2_table(7011) := '613E302972657475726E3B6966286C3E302626633E302972657475726E3B636F6E737420643D4D6174682E61627328612D63292C683D4D6174682E61627328722D6C293B696628303D3D3D642972657475726E206F2E737061636573446966663D682C76';
wwv_flow_imp.g_varchar2_table(7012) := '6F696428683E302626303C3D6C2D3126266C2D313C652E6C656E67746826266C3C6E2E6C656E67746826263332213D3D6E2E63686172436F64654174286C29262633323D3D3D652E63686172436F64654174286C2D3129262634343D3D3D652E63686172';
wwv_flow_imp.g_varchar2_table(7013) := '436F6465417428652E6C656E6774682D31292626286F2E6C6F6F6B734C696B65416C69676E6D656E743D213029293B682564213D307C7C286F2E737061636573446966663D682F64297D66756E6374696F6E20617928652C742C6E297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(7014) := '3D4D6174682E6D696E28652E6765744C696E65436F756E7428292C316534293B6C6574206F3D302C733D302C723D22222C613D303B636F6E7374206C3D5B322C342C362C382C332C352C375D2C633D5B302C302C302C302C302C302C302C302C305D2C64';
wwv_flow_imp.g_varchar2_table(7015) := '3D6E65772073793B666F72286C6574206C3D313B6C3C3D693B6C2B2B297B636F6E737420693D652E6765744C696E654C656E677468286C292C683D652E6765744C696E65436F6E74656E74286C292C753D693C3D36353533363B6C657420703D21312C67';
wwv_flow_imp.g_varchar2_table(7016) := '3D302C6D3D302C663D303B666F72286C657420743D302C6E3D693B743C6E3B742B2B297B636F6E7374206E3D753F682E63686172436F646541742874293A652E6765744C696E6543686172436F6465286C2C74293B696628393D3D3D6E29662B2B3B656C';
wwv_flow_imp.g_varchar2_table(7017) := '73657B6966283332213D3D6E297B703D21302C673D743B627265616B7D6D2B2B7D7D696628217029636F6E74696E75653B696628663E303F6F2B2B3A6D3E312626732B2B2C727928722C612C682C672C64292C642E6C6F6F6B734C696B65416C69676E6D';
wwv_flow_imp.g_varchar2_table(7018) := '656E74262628216E7C7C74213D3D642E737061636573446966662929636F6E74696E75653B636F6E737420763D642E737061636573446966663B763C3D382626635B765D2B2B2C723D682C613D677D6C657420683D6E3B6F213D3D73262628683D6F3C73';
wwv_flow_imp.g_varchar2_table(7019) := '293B6C657420753D743B69662868297B6C657420653D683F303A2E312A693B6C2E666F72456163682828743D3E7B636F6E7374206E3D635B745D3B6E3E65262628653D6E2C753D74297D29292C343D3D3D752626635B345D3E302626635B325D3E302626';
wwv_flow_imp.g_varchar2_table(7020) := '635B325D3E3D635B345D2F32262628753D32297D72657475726E7B696E736572745370616365733A682C74616253697A653A757D7D66756E6374696F6E206C792865297B72657475726E283126652E6D65746164617461293E3E3E307D66756E6374696F';
wwv_flow_imp.g_varchar2_table(7021) := '6E20637928652C74297B652E6D657461646174613D32353426652E6D657461646174617C747D66756E6374696F6E2064792865297B72657475726E283226652E6D65746164617461293E3E3E313D3D317D66756E6374696F6E20687928652C74297B652E';
wwv_flow_imp.g_varchar2_table(7022) := '6D657461646174613D32353326652E6D657461646174617C28743F313A30293C3C317D66756E6374696F6E2075792865297B72657475726E283426652E6D65746164617461293E3E3E323D3D317D66756E6374696F6E20707928652C74297B652E6D6574';
wwv_flow_imp.g_varchar2_table(7023) := '61646174613D32353126652E6D657461646174617C28743F313A30293C3C327D66756E6374696F6E2067792865297B72657475726E28363426652E6D65746164617461293E3E3E363D3D317D66756E6374696F6E206D7928652C74297B652E6D65746164';
wwv_flow_imp.g_varchar2_table(7024) := '6174613D31393126652E6D657461646174617C28743F313A30293C3C367D66756E6374696F6E20667928652C74297B652E6D657461646174613D32333126652E6D657461646174617C743C3C337D66756E6374696F6E20767928652C74297B652E6D6574';
wwv_flow_imp.g_varchar2_table(7025) := '61646174613D32323326652E6D657461646174617C28743F313A30293C3C357D636C6173732062797B636F6E7374727563746F7228652C742C6E297B746869732E6D657461646174613D302C746869732E706172656E743D746869732C746869732E6C65';
wwv_flow_imp.g_varchar2_table(7026) := '66743D746869732C746869732E72696768743D746869732C637928746869732C31292C746869732E73746172743D742C746869732E656E643D6E2C746869732E64656C74613D302C746869732E6D6178456E643D6E2C746869732E69643D652C74686973';
wwv_flow_imp.g_varchar2_table(7027) := '2E6F776E657249643D302C746869732E6F7074696F6E733D6E756C6C2C707928746869732C2131292C6D7928746869732C2131292C667928746869732C31292C767928746869732C2131292C746869732E63616368656456657273696F6E49643D302C74';
wwv_flow_imp.g_varchar2_table(7028) := '6869732E6361636865644162736F6C75746553746172743D742C746869732E6361636865644162736F6C757465456E643D6E2C746869732E72616E67653D6E756C6C2C687928746869732C2131297D726573657428652C742C6E2C69297B746869732E73';
wwv_flow_imp.g_varchar2_table(7029) := '746172743D742C746869732E656E643D6E2C746869732E6D6178456E643D6E2C746869732E63616368656456657273696F6E49643D652C746869732E6361636865644162736F6C75746553746172743D742C746869732E6361636865644162736F6C7574';
wwv_flow_imp.g_varchar2_table(7030) := '65456E643D6E2C746869732E72616E67653D697D7365744F7074696F6E732865297B746869732E6F7074696F6E733D653B636F6E737420743D746869732E6F7074696F6E732E636C6173734E616D653B707928746869732C227371756967676C792D6572';
wwv_flow_imp.g_varchar2_table(7031) := '726F72223D3D3D747C7C227371756967676C792D7761726E696E67223D3D3D747C7C227371756967676C792D696E666F223D3D3D74292C6D7928746869732C6E756C6C213D3D746869732E6F7074696F6E732E676C7970684D617267696E436C6173734E';
wwv_flow_imp.g_varchar2_table(7032) := '616D65292C667928746869732C746869732E6F7074696F6E732E737469636B696E657373292C767928746869732C746869732E6F7074696F6E732E636F6C6C617073654F6E5265706C61636545646974297D7365744361636865644F6666736574732865';
wwv_flow_imp.g_varchar2_table(7033) := '2C742C6E297B746869732E63616368656456657273696F6E4964213D3D6E262628746869732E72616E67653D6E756C6C292C746869732E63616368656456657273696F6E49643D6E2C746869732E6361636865644162736F6C75746553746172743D652C';
wwv_flow_imp.g_varchar2_table(7034) := '746869732E6361636865644162736F6C757465456E643D747D64657461636828297B746869732E706172656E743D6E756C6C2C746869732E6C6566743D6E756C6C2C746869732E72696768743D6E756C6C7D7D636F6E7374205F793D6E6577206279286E';
wwv_flow_imp.g_varchar2_table(7035) := '756C6C2C302C30293B5F792E706172656E743D5F792C5F792E6C6566743D5F792C5F792E72696768743D5F792C6379285F792C30293B636C6173732079797B636F6E7374727563746F7228297B746869732E726F6F743D5F792C746869732E7265717565';
wwv_flow_imp.g_varchar2_table(7036) := '73744E6F726D616C697A6544656C74613D21317D696E74657276616C53656172636828652C742C6E2C692C6F2C73297B72657475726E20746869732E726F6F743D3D3D5F793F5B5D3A66756E6374696F6E28652C742C6E2C692C6F2C732C72297B6C6574';
wwv_flow_imp.g_varchar2_table(7037) := '20613D652E726F6F742C6C3D302C633D302C643D302C683D303B636F6E737420753D5B5D3B6C657420703D303B666F72283B61213D3D5F793B29696628647928612929687928612E6C6566742C2131292C687928612E72696768742C2131292C613D3D3D';
wwv_flow_imp.g_varchar2_table(7038) := '612E706172656E742E72696768742626286C2D3D612E706172656E742E64656C7461292C613D612E706172656E743B656C73657B69662821647928612E6C65667429297B696628633D6C2B612E6D6178456E642C633C74297B687928612C2130293B636F';
wwv_flow_imp.g_varchar2_table(7039) := '6E74696E75657D696628612E6C656674213D3D5F79297B613D612E6C6566743B636F6E74696E75657D7D696628643D6C2B612E73746172742C643E6E29687928612C2130293B656C73657B696628683D6C2B612E656E642C683E3D74297B612E73657443';
wwv_flow_imp.g_varchar2_table(7040) := '61636865644F66667365747328642C682C73293B6C657420653D21303B692626612E6F776E657249642626612E6F776E65724964213D3D69262628653D2131292C6F26267579286129262628653D2131292C722626216779286129262628653D2131292C';
wwv_flow_imp.g_varchar2_table(7041) := '65262628755B702B2B5D3D61297D687928612C2130292C612E72696768743D3D3D5F797C7C647928612E7269676874297C7C286C2B3D612E64656C74612C613D612E7269676874297D7D72657475726E20687928652E726F6F742C2131292C757D287468';
wwv_flow_imp.g_varchar2_table(7042) := '69732C652C742C6E2C692C6F2C73297D73656172636828652C742C6E2C69297B72657475726E20746869732E726F6F743D3D3D5F793F5B5D3A66756E6374696F6E28652C742C6E2C692C6F297B6C657420733D652E726F6F742C723D302C613D302C6C3D';
wwv_flow_imp.g_varchar2_table(7043) := '303B636F6E737420633D5B5D3B6C657420643D303B666F72283B73213D3D5F793B297B6966286479287329297B687928732E6C6566742C2131292C687928732E72696768742C2131292C733D3D3D732E706172656E742E7269676874262628722D3D732E';
wwv_flow_imp.g_varchar2_table(7044) := '706172656E742E64656C7461292C733D732E706172656E743B636F6E74696E75657D696628732E6C656674213D3D5F79262621647928732E6C65667429297B733D732E6C6566743B636F6E74696E75657D613D722B732E73746172742C6C3D722B732E65';
wwv_flow_imp.g_varchar2_table(7045) := '6E642C732E7365744361636865644F66667365747328612C6C2C69293B6C657420653D21303B742626732E6F776E657249642626732E6F776E65724964213D3D74262628653D2131292C6E26267579287329262628653D2131292C6F2626216779287329';
wwv_flow_imp.g_varchar2_table(7046) := '262628653D2131292C65262628635B642B2B5D3D73292C687928732C2130292C732E72696768743D3D3D5F797C7C647928732E7269676874297C7C28722B3D732E64656C74612C733D732E7269676874297D72657475726E20687928652E726F6F742C21';
wwv_flow_imp.g_varchar2_table(7047) := '31292C637D28746869732C652C742C6E2C69297D636F6C6C6563744E6F64657346726F6D4F776E65722865297B72657475726E2066756E6374696F6E28652C74297B6C6574206E3D652E726F6F743B636F6E737420693D5B5D3B6C6574206F3D303B666F';
wwv_flow_imp.g_varchar2_table(7048) := '72283B6E213D3D5F793B296479286E293F286879286E2E6C6566742C2131292C6879286E2E72696768742C2131292C6E3D6E2E706172656E74293A6E2E6C6566743D3D3D5F797C7C6479286E2E6C656674293F286E2E6F776E657249643D3D3D74262628';
wwv_flow_imp.g_varchar2_table(7049) := '695B6F2B2B5D3D6E292C6879286E2C2130292C6E2E72696768743D3D3D5F797C7C6479286E2E7269676874297C7C286E3D6E2E726967687429293A6E3D6E2E6C6566743B72657475726E20687928652E726F6F742C2131292C697D28746869732C65297D';
wwv_flow_imp.g_varchar2_table(7050) := '636F6C6C6563744E6F646573506F73744F7264657228297B72657475726E2066756E6374696F6E2865297B6C657420743D652E726F6F743B636F6E7374206E3D5B5D3B6C657420693D303B666F72283B74213D3D5F793B2964792874293F28687928742E';
wwv_flow_imp.g_varchar2_table(7051) := '6C6566742C2131292C687928742E72696768742C2131292C743D742E706172656E74293A742E6C6566743D3D3D5F797C7C647928742E6C656674293F742E72696768743D3D3D5F797C7C647928742E7269676874293F286E5B692B2B5D3D742C68792874';
wwv_flow_imp.g_varchar2_table(7052) := '2C213029293A743D742E72696768743A743D742E6C6566743B72657475726E20687928652E726F6F742C2131292C6E7D2874686973297D696E736572742865297B537928746869732C65292C746869732E5F6E6F726D616C697A6544656C746149664E65';
wwv_flow_imp.g_varchar2_table(7053) := '6365737361727928297D64656C6574652865297B787928746869732C65292C746869732E5F6E6F726D616C697A6544656C746149664E656365737361727928297D7265736F6C76654E6F646528652C74297B636F6E7374206E3D653B6C657420693D303B';
wwv_flow_imp.g_varchar2_table(7054) := '666F72283B65213D3D746869732E726F6F743B29653D3D3D652E706172656E742E7269676874262628692B3D652E706172656E742E64656C7461292C653D652E706172656E743B636F6E7374206F3D6E2E73746172742B692C733D6E2E656E642B693B6E';
wwv_flow_imp.g_varchar2_table(7055) := '2E7365744361636865644F666673657473286F2C732C74297D6163636570745265706C61636528652C742C6E2C69297B636F6E7374206F3D66756E6374696F6E28652C742C6E297B6C657420693D652E726F6F742C6F3D302C733D302C723D302C613D30';
wwv_flow_imp.g_varchar2_table(7056) := '3B636F6E7374206C3D5B5D3B6C657420633D303B666F72283B69213D3D5F793B29696628647928692929687928692E6C6566742C2131292C687928692E72696768742C2131292C693D3D3D692E706172656E742E72696768742626286F2D3D692E706172';
wwv_flow_imp.g_varchar2_table(7057) := '656E742E64656C7461292C693D692E706172656E743B656C73657B69662821647928692E6C65667429297B696628733D6F2B692E6D6178456E642C733C74297B687928692C2130293B636F6E74696E75657D696628692E6C656674213D3D5F79297B693D';
wwv_flow_imp.g_varchar2_table(7058) := '692E6C6566743B636F6E74696E75657D7D723D6F2B692E73746172742C723E6E3F687928692C2130293A28613D6F2B692E656E642C613E3D74262628692E7365744361636865644F66667365747328722C612C30292C6C5B632B2B5D3D69292C68792869';
wwv_flow_imp.g_varchar2_table(7059) := '2C2130292C692E72696768743D3D3D5F797C7C647928692E7269676874297C7C286F2B3D692E64656C74612C693D692E726967687429297D72657475726E20687928652E726F6F742C2131292C6C7D28746869732C652C652B74293B666F72286C657420';
wwv_flow_imp.g_varchar2_table(7060) := '653D302C743D6F2E6C656E6774683B653C743B652B2B29787928746869732C6F5B655D293B746869732E5F6E6F726D616C697A6544656C746149664E656365737361727928292C66756E6374696F6E28652C742C6E2C69297B6C6574206F3D652E726F6F';
wwv_flow_imp.g_varchar2_table(7061) := '742C733D302C723D302C613D303B636F6E7374206C3D692D286E2D74293B666F72283B6F213D3D5F793B296966286479286F29296879286F2E6C6566742C2131292C6879286F2E72696768742C2131292C6F3D3D3D6F2E706172656E742E726967687426';
wwv_flow_imp.g_varchar2_table(7062) := '2628732D3D6F2E706172656E742E64656C7461292C5479286F292C6F3D6F2E706172656E743B656C73657B696628216479286F2E6C65667429297B696628723D732B6F2E6D6178456E642C723C74297B6879286F2C2130293B636F6E74696E75657D6966';
wwv_flow_imp.g_varchar2_table(7063) := '286F2E6C656674213D3D5F79297B6F3D6F2E6C6566743B636F6E74696E75657D7D613D732B6F2E73746172742C613E6E3F286F2E73746172742B3D6C2C6F2E656E642B3D6C2C6F2E64656C74612B3D6C2C286F2E64656C74613C2D313037333734313832';
wwv_flow_imp.g_varchar2_table(7064) := '347C7C6F2E64656C74613E3130373337343138323429262628652E726571756573744E6F726D616C697A6544656C74613D2130292C6879286F2C213029293A286879286F2C2130292C6F2E72696768743D3D3D5F797C7C6479286F2E7269676874297C7C';
wwv_flow_imp.g_varchar2_table(7065) := '28732B3D6F2E64656C74612C6F3D6F2E726967687429297D687928652E726F6F742C2131297D28746869732C652C652B742C6E292C746869732E5F6E6F726D616C697A6544656C746149664E656365737361727928293B666F72286C657420733D302C72';
wwv_flow_imp.g_varchar2_table(7066) := '3D6F2E6C656E6774683B733C723B732B2B297B636F6E737420723D6F5B735D3B722E73746172743D722E6361636865644162736F6C75746553746172742C722E656E643D722E6361636865644162736F6C757465456E642C437928722C652C652B742C6E';
wwv_flow_imp.g_varchar2_table(7067) := '2C69292C722E6D6178456E643D722E656E642C537928746869732C72297D746869732E5F6E6F726D616C697A6544656C746149664E656365737361727928297D5F6E6F726D616C697A6544656C746149664E656365737361727928297B746869732E7265';
wwv_flow_imp.g_varchar2_table(7068) := '71756573744E6F726D616C697A6544656C7461262628746869732E726571756573744E6F726D616C697A6544656C74613D21312C66756E6374696F6E2865297B6C657420743D652E726F6F742C6E3D303B666F72283B74213D3D5F793B29742E6C656674';
wwv_flow_imp.g_varchar2_table(7069) := '3D3D3D5F797C7C647928742E6C656674293F742E72696768743D3D3D5F797C7C647928742E7269676874293F28742E73746172743D6E2B742E73746172742C742E656E643D6E2B742E656E642C742E64656C74613D302C54792874292C687928742C2130';
wwv_flow_imp.g_varchar2_table(7070) := '292C687928742E6C6566742C2131292C687928742E72696768742C2131292C743D3D3D742E706172656E742E72696768742626286E2D3D742E706172656E742E64656C7461292C743D742E706172656E74293A286E2B3D742E64656C74612C743D742E72';
wwv_flow_imp.g_varchar2_table(7071) := '69676874293A743D742E6C6566743B687928652E726F6F742C2131297D287468697329297D7D66756E6374696F6E20777928652C742C6E2C69297B72657475726E20653C6E7C7C2128653E6E29262631213D3D69262628323D3D3D697C7C74297D66756E';
wwv_flow_imp.g_varchar2_table(7072) := '6374696F6E20437928652C742C6E2C692C6F297B636F6E737420733D66756E6374696F6E2865297B72657475726E28323426652E6D65746164617461293E3E3E337D2865292C723D303D3D3D737C7C323D3D3D732C613D313D3D3D737C7C323D3D3D732C';
wwv_flow_imp.g_varchar2_table(7073) := '6C3D6E2D742C633D692C643D4D6174682E6D696E286C2C63292C683D652E73746172743B6C657420753D21313B636F6E737420703D652E656E643B6C657420673D21313B743C3D682626703C3D6E262666756E6374696F6E2865297B72657475726E2833';
wwv_flow_imp.g_varchar2_table(7074) := '3226652E6D65746164617461293E3E3E353D3D317D286529262628652E73746172743D742C753D21302C652E656E643D742C673D2130293B7B636F6E737420653D6F3F313A6C3E303F323A303B21752626777928682C722C742C6529262628753D213029';
wwv_flow_imp.g_varchar2_table(7075) := '2C21672626777928702C612C742C6529262628673D2130297D696628643E302626216F297B636F6E737420653D6C3E633F323A303B21752626777928682C722C742B642C6529262628753D2130292C21672626777928702C612C742B642C652926262867';
wwv_flow_imp.g_varchar2_table(7076) := '3D2130297D7B636F6E737420693D6F3F313A303B21752626777928682C722C6E2C6929262628652E73746172743D742B632C753D2130292C21672626777928702C612C6E2C6929262628652E656E643D742B632C673D2130297D636F6E7374206D3D632D';
wwv_flow_imp.g_varchar2_table(7077) := '6C3B757C7C28652E73746172743D4D6174682E6D617828302C682B6D29292C677C7C28652E656E643D4D6174682E6D617828302C702B6D29292C652E73746172743E652E656E64262628652E656E643D652E7374617274297D66756E6374696F6E205379';
wwv_flow_imp.g_varchar2_table(7078) := '28652C74297B696628652E726F6F743D3D3D5F792972657475726E20742E706172656E743D5F792C742E6C6566743D5F792C742E72696768743D5F792C637928742C30292C652E726F6F743D742C652E726F6F743B2166756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(7079) := '6C6574206E3D302C693D652E726F6F743B636F6E7374206F3D742E73746172742C733D742E656E643B666F72283B3B29696628723D6F2C613D732C6C3D692E73746172742B6E2C633D692E656E642B6E2C28723D3D3D6C3F612D633A722D6C293C30297B';
wwv_flow_imp.g_varchar2_table(7080) := '696628692E6C6566743D3D3D5F79297B742E73746172742D3D6E2C742E656E642D3D6E2C742E6D6178456E642D3D6E2C692E6C6566743D743B627265616B7D693D692E6C6566747D656C73657B696628692E72696768743D3D3D5F79297B742E73746172';
wwv_flow_imp.g_varchar2_table(7081) := '742D3D6E2B692E64656C74612C742E656E642D3D6E2B692E64656C74612C742E6D6178456E642D3D6E2B692E64656C74612C692E72696768743D743B627265616B7D6E2B3D692E64656C74612C693D692E72696768747D76617220722C612C6C2C633B74';
wwv_flow_imp.g_varchar2_table(7082) := '2E706172656E743D692C742E6C6566743D5F792C742E72696768743D5F792C637928742C31297D28652C74292C497928742E706172656E74293B6C6574206E3D743B666F72283B6E213D3D652E726F6F742626313D3D3D6C79286E2E706172656E74293B';
wwv_flow_imp.g_varchar2_table(7083) := '296966286E2E706172656E743D3D3D6E2E706172656E742E706172656E742E6C656674297B636F6E737420743D6E2E706172656E742E706172656E742E72696768743B313D3D3D6C792874293F286379286E2E706172656E742C30292C637928742C3029';
wwv_flow_imp.g_varchar2_table(7084) := '2C6379286E2E706172656E742E706172656E742C31292C6E3D6E2E706172656E742E706172656E74293A286E3D3D3D6E2E706172656E742E72696768742626286E3D6E2E706172656E742C457928652C6E29292C6379286E2E706172656E742C30292C63';
wwv_flow_imp.g_varchar2_table(7085) := '79286E2E706172656E742E706172656E742C31292C4C7928652C6E2E706172656E742E706172656E7429297D656C73657B636F6E737420743D6E2E706172656E742E706172656E742E6C6566743B313D3D3D6C792874293F286379286E2E706172656E74';
wwv_flow_imp.g_varchar2_table(7086) := '2C30292C637928742C30292C6379286E2E706172656E742E706172656E742C31292C6E3D6E2E706172656E742E706172656E74293A286E3D3D3D6E2E706172656E742E6C6566742626286E3D6E2E706172656E742C4C7928652C6E29292C6379286E2E70';
wwv_flow_imp.g_varchar2_table(7087) := '6172656E742C30292C6379286E2E706172656E742E706172656E742C31292C457928652C6E2E706172656E742E706172656E7429297D72657475726E20637928652E726F6F742C30292C747D66756E6374696F6E20787928652C74297B6C6574206E2C69';
wwv_flow_imp.g_varchar2_table(7088) := '3B696628742E6C6566743D3D3D5F793F286E3D742E72696768742C693D742C6E2E64656C74612B3D742E64656C74612C286E2E64656C74613C2D313037333734313832347C7C6E2E64656C74613E3130373337343138323429262628652E726571756573';
wwv_flow_imp.g_varchar2_table(7089) := '744E6F726D616C697A6544656C74613D2130292C6E2E73746172742B3D742E64656C74612C6E2E656E642B3D742E64656C7461293A742E72696768743D3D3D5F793F286E3D742E6C6566742C693D74293A28693D66756E6374696F6E2865297B666F7228';
wwv_flow_imp.g_varchar2_table(7090) := '3B652E6C656674213D3D5F793B29653D652E6C6566743B72657475726E20657D28742E7269676874292C6E3D692E72696768742C6E2E73746172742B3D692E64656C74612C6E2E656E642B3D692E64656C74612C6E2E64656C74612B3D692E64656C7461';
wwv_flow_imp.g_varchar2_table(7091) := '2C286E2E64656C74613C2D313037333734313832347C7C6E2E64656C74613E3130373337343138323429262628652E726571756573744E6F726D616C697A6544656C74613D2130292C692E73746172742B3D742E64656C74612C692E656E642B3D742E64';
wwv_flow_imp.g_varchar2_table(7092) := '656C74612C692E64656C74613D742E64656C74612C28692E64656C74613C2D313037333734313832347C7C692E64656C74613E3130373337343138323429262628652E726571756573744E6F726D616C697A6544656C74613D213029292C693D3D3D652E';
wwv_flow_imp.g_varchar2_table(7093) := '726F6F742972657475726E20652E726F6F743D6E2C6379286E2C30292C742E64657461636828292C6B7928292C5479286E292C766F696428652E726F6F742E706172656E743D5F79293B636F6E7374206F3D313D3D3D6C792869293B696628693D3D3D69';
wwv_flow_imp.g_varchar2_table(7094) := '2E706172656E742E6C6566743F692E706172656E742E6C6566743D6E3A692E706172656E742E72696768743D6E2C693D3D3D743F6E2E706172656E743D692E706172656E743A28692E706172656E743D3D3D743F6E2E706172656E743D693A6E2E706172';
wwv_flow_imp.g_varchar2_table(7095) := '656E743D692E706172656E742C692E6C6566743D742E6C6566742C692E72696768743D742E72696768742C692E706172656E743D742E706172656E742C637928692C6C79287429292C743D3D3D652E726F6F743F652E726F6F743D693A743D3D3D742E70';
wwv_flow_imp.g_varchar2_table(7096) := '6172656E742E6C6566743F742E706172656E742E6C6566743D693A742E706172656E742E72696768743D692C692E6C656674213D3D5F79262628692E6C6566742E706172656E743D69292C692E7269676874213D3D5F79262628692E72696768742E7061';
wwv_flow_imp.g_varchar2_table(7097) := '72656E743D6929292C742E64657461636828292C6F2972657475726E204979286E2E706172656E74292C69213D3D7426262849792869292C497928692E706172656E7429292C766F6964206B7928293B6C657420733B666F72284979286E292C4979286E';
wwv_flow_imp.g_varchar2_table(7098) := '2E706172656E74292C69213D3D7426262849792869292C497928692E706172656E7429293B6E213D3D652E726F6F742626303D3D3D6C79286E293B296E3D3D3D6E2E706172656E742E6C6566743F28733D6E2E706172656E742E72696768742C313D3D3D';
wwv_flow_imp.g_varchar2_table(7099) := '6C79287329262628637928732C30292C6379286E2E706172656E742C31292C457928652C6E2E706172656E74292C733D6E2E706172656E742E7269676874292C303D3D3D6C7928732E6C656674292626303D3D3D6C7928732E7269676874293F28637928';
wwv_flow_imp.g_varchar2_table(7100) := '732C31292C6E3D6E2E706172656E74293A28303D3D3D6C7928732E726967687429262628637928732E6C6566742C30292C637928732C31292C4C7928652C73292C733D6E2E706172656E742E7269676874292C637928732C6C79286E2E706172656E7429';
wwv_flow_imp.g_varchar2_table(7101) := '292C6379286E2E706172656E742C30292C637928732E72696768742C30292C457928652C6E2E706172656E74292C6E3D652E726F6F7429293A28733D6E2E706172656E742E6C6566742C313D3D3D6C79287329262628637928732C30292C6379286E2E70';
wwv_flow_imp.g_varchar2_table(7102) := '6172656E742C31292C4C7928652C6E2E706172656E74292C733D6E2E706172656E742E6C656674292C303D3D3D6C7928732E6C656674292626303D3D3D6C7928732E7269676874293F28637928732C31292C6E3D6E2E706172656E74293A28303D3D3D6C';
wwv_flow_imp.g_varchar2_table(7103) := '7928732E6C65667429262628637928732E72696768742C30292C637928732C31292C457928652C73292C733D6E2E706172656E742E6C656674292C637928732C6C79286E2E706172656E7429292C6379286E2E706172656E742C30292C637928732E6C65';
wwv_flow_imp.g_varchar2_table(7104) := '66742C30292C4C7928652C6E2E706172656E74292C6E3D652E726F6F7429293B6379286E2C30292C6B7928297D66756E6374696F6E206B7928297B5F792E706172656E743D5F792C5F792E64656C74613D302C5F792E73746172743D302C5F792E656E64';
wwv_flow_imp.g_varchar2_table(7105) := '3D307D66756E6374696F6E20457928652C74297B636F6E7374206E3D742E72696768743B6E2E64656C74612B3D742E64656C74612C286E2E64656C74613C2D313037333734313832347C7C6E2E64656C74613E3130373337343138323429262628652E72';
wwv_flow_imp.g_varchar2_table(7106) := '6571756573744E6F726D616C697A6544656C74613D2130292C6E2E73746172742B3D742E64656C74612C6E2E656E642B3D742E64656C74612C742E72696768743D6E2E6C6566742C6E2E6C656674213D3D5F792626286E2E6C6566742E706172656E743D';
wwv_flow_imp.g_varchar2_table(7107) := '74292C6E2E706172656E743D742E706172656E742C742E706172656E743D3D3D5F793F652E726F6F743D6E3A743D3D3D742E706172656E742E6C6566743F742E706172656E742E6C6566743D6E3A742E706172656E742E72696768743D6E2C6E2E6C6566';
wwv_flow_imp.g_varchar2_table(7108) := '743D742C742E706172656E743D6E2C54792874292C5479286E297D66756E6374696F6E204C7928652C74297B636F6E7374206E3D742E6C6566743B742E64656C74612D3D6E2E64656C74612C28742E64656C74613C2D313037333734313832347C7C742E';
wwv_flow_imp.g_varchar2_table(7109) := '64656C74613E3130373337343138323429262628652E726571756573744E6F726D616C697A6544656C74613D2130292C742E73746172742D3D6E2E64656C74612C742E656E642D3D6E2E64656C74612C742E6C6566743D6E2E72696768742C6E2E726967';
wwv_flow_imp.g_varchar2_table(7110) := '6874213D3D5F792626286E2E72696768742E706172656E743D74292C6E2E706172656E743D742E706172656E742C742E706172656E743D3D3D5F793F652E726F6F743D6E3A743D3D3D742E706172656E742E72696768743F742E706172656E742E726967';
wwv_flow_imp.g_varchar2_table(7111) := '68743D6E3A742E706172656E742E6C6566743D6E2C6E2E72696768743D742C742E706172656E743D6E2C54792874292C5479286E297D66756E6374696F6E2044792865297B6C657420743D652E656E643B696628652E6C656674213D3D5F79297B636F6E';
wwv_flow_imp.g_varchar2_table(7112) := '7374206E3D652E6C6566742E6D6178456E643B6E3E74262628743D6E297D696628652E7269676874213D3D5F79297B636F6E7374206E3D652E72696768742E6D6178456E642B652E64656C74613B6E3E74262628743D6E297D72657475726E20747D6675';
wwv_flow_imp.g_varchar2_table(7113) := '6E6374696F6E2054792865297B652E6D6178456E643D44792865297D66756E6374696F6E2049792865297B666F72283B65213D3D5F793B297B636F6E737420743D44792865293B696628652E6D6178456E643D3D3D742972657475726E3B652E6D617845';
wwv_flow_imp.g_varchar2_table(7114) := '6E643D742C653D652E706172656E747D7D636C617373204D797B636F6E7374727563746F7228652C74297B746869732E70696563653D652C746869732E636F6C6F723D742C746869732E73697A655F6C6566743D302C746869732E6C665F6C6566743D30';
wwv_flow_imp.g_varchar2_table(7115) := '2C746869732E706172656E743D746869732C746869732E6C6566743D746869732C746869732E72696768743D746869737D6E65787428297B696628746869732E7269676874213D3D41792972657475726E204E7928746869732E7269676874293B6C6574';
wwv_flow_imp.g_varchar2_table(7116) := '20653D746869733B666F72283B652E706172656E74213D3D41792626652E706172656E742E6C656674213D3D653B29653D652E706172656E743B72657475726E20652E706172656E743D3D3D41793F41793A652E706172656E747D7072657628297B6966';
wwv_flow_imp.g_varchar2_table(7117) := '28746869732E6C656674213D3D41792972657475726E20507928746869732E6C656674293B6C657420653D746869733B666F72283B652E706172656E74213D3D41792626652E706172656E742E7269676874213D3D653B29653D652E706172656E743B72';
wwv_flow_imp.g_varchar2_table(7118) := '657475726E20652E706172656E743D3D3D41793F41793A652E706172656E747D64657461636828297B746869732E706172656E743D6E756C6C2C746869732E6C6566743D6E756C6C2C746869732E72696768743D6E756C6C7D7D636F6E73742041793D6E';
wwv_flow_imp.g_varchar2_table(7119) := '6577204D79286E756C6C2C30293B66756E6374696F6E204E792865297B666F72283B652E6C656674213D3D41793B29653D652E6C6566743B72657475726E20657D66756E6374696F6E2050792865297B666F72283B652E7269676874213D3D41793B2965';
wwv_flow_imp.g_varchar2_table(7120) := '3D652E72696768743B72657475726E20657D66756E6374696F6E204F792865297B72657475726E20653D3D3D41793F303A652E73697A655F6C6566742B652E70696563652E6C656E6774682B4F7928652E7269676874297D66756E6374696F6E20527928';
wwv_flow_imp.g_varchar2_table(7121) := '65297B72657475726E20653D3D3D41793F303A652E6C665F6C6566742B652E70696563652E6C696E6546656564436E742B527928652E7269676874297D66756E6374696F6E20467928297B41792E706172656E743D41797D66756E6374696F6E20427928';
wwv_flow_imp.g_varchar2_table(7122) := '652C74297B636F6E7374206E3D742E72696768743B6E2E73697A655F6C6566742B3D742E73697A655F6C6566742B28742E70696563653F742E70696563652E6C656E6774683A30292C6E2E6C665F6C6566742B3D742E6C665F6C6566742B28742E706965';
wwv_flow_imp.g_varchar2_table(7123) := '63653F742E70696563652E6C696E6546656564436E743A30292C742E72696768743D6E2E6C6566742C6E2E6C656674213D3D41792626286E2E6C6566742E706172656E743D74292C6E2E706172656E743D742E706172656E742C742E706172656E743D3D';
wwv_flow_imp.g_varchar2_table(7124) := '3D41793F652E726F6F743D6E3A742E706172656E742E6C6566743D3D3D743F742E706172656E742E6C6566743D6E3A742E706172656E742E72696768743D6E2C6E2E6C6566743D742C742E706172656E743D6E7D66756E6374696F6E20567928652C7429';
wwv_flow_imp.g_varchar2_table(7125) := '7B636F6E7374206E3D742E6C6566743B742E6C6566743D6E2E72696768742C6E2E7269676874213D3D41792626286E2E72696768742E706172656E743D74292C6E2E706172656E743D742E706172656E742C742E73697A655F6C6566742D3D6E2E73697A';
wwv_flow_imp.g_varchar2_table(7126) := '655F6C6566742B286E2E70696563653F6E2E70696563652E6C656E6774683A30292C742E6C665F6C6566742D3D6E2E6C665F6C6566742B286E2E70696563653F6E2E70696563652E6C696E6546656564436E743A30292C742E706172656E743D3D3D4179';
wwv_flow_imp.g_varchar2_table(7127) := '3F652E726F6F743D6E3A743D3D3D742E706172656E742E72696768743F742E706172656E742E72696768743D6E3A742E706172656E742E6C6566743D6E2C6E2E72696768743D742C742E706172656E743D6E7D66756E6374696F6E207A7928652C74297B';
wwv_flow_imp.g_varchar2_table(7128) := '6C6574206E2C693B696628742E6C6566743D3D3D41793F28693D742C6E3D692E7269676874293A742E72696768743D3D3D41793F28693D742C6E3D692E6C656674293A28693D4E7928742E7269676874292C6E3D692E7269676874292C693D3D3D652E72';
wwv_flow_imp.g_varchar2_table(7129) := '6F6F742972657475726E20652E726F6F743D6E2C6E2E636F6C6F723D302C742E64657461636828292C467928292C766F696428652E726F6F742E706172656E743D4179293B636F6E7374206F3D313D3D3D692E636F6C6F723B696628693D3D3D692E7061';
wwv_flow_imp.g_varchar2_table(7130) := '72656E742E6C6566743F692E706172656E742E6C6566743D6E3A692E706172656E742E72696768743D6E2C693D3D3D743F286E2E706172656E743D692E706172656E742C6A7928652C6E29293A28692E706172656E743D3D3D743F6E2E706172656E743D';
wwv_flow_imp.g_varchar2_table(7131) := '693A6E2E706172656E743D692E706172656E742C6A7928652C6E292C692E6C6566743D742E6C6566742C692E72696768743D742E72696768742C692E706172656E743D742E706172656E742C692E636F6C6F723D742E636F6C6F722C743D3D3D652E726F';
wwv_flow_imp.g_varchar2_table(7132) := '6F743F652E726F6F743D693A743D3D3D742E706172656E742E6C6566743F742E706172656E742E6C6566743D693A742E706172656E742E72696768743D692C692E6C656674213D3D4179262628692E6C6566742E706172656E743D69292C692E72696768';
wwv_flow_imp.g_varchar2_table(7133) := '74213D3D4179262628692E72696768742E706172656E743D69292C692E73697A655F6C6566743D742E73697A655F6C6566742C692E6C665F6C6566743D742E6C665F6C6566742C6A7928652C6929292C742E64657461636828292C6E2E706172656E742E';
wwv_flow_imp.g_varchar2_table(7134) := '6C6566743D3D3D6E297B636F6E737420743D4F79286E292C693D5279286E293B69662874213D3D6E2E706172656E742E73697A655F6C6566747C7C69213D3D6E2E706172656E742E6C665F6C656674297B636F6E7374206F3D742D6E2E706172656E742E';
wwv_flow_imp.g_varchar2_table(7135) := '73697A655F6C6566742C733D692D6E2E706172656E742E6C665F6C6566743B6E2E706172656E742E73697A655F6C6566743D742C6E2E706172656E742E6C665F6C6566743D692C577928652C6E2E706172656E742C6F2C73297D7D6966286A7928652C6E';
wwv_flow_imp.g_varchar2_table(7136) := '2E706172656E74292C6F2972657475726E20766F696420467928293B6C657420733B666F72283B6E213D3D652E726F6F742626303D3D3D6E2E636F6C6F723B296E3D3D3D6E2E706172656E742E6C6566743F28733D6E2E706172656E742E72696768742C';
wwv_flow_imp.g_varchar2_table(7137) := '313D3D3D732E636F6C6F72262628732E636F6C6F723D302C6E2E706172656E742E636F6C6F723D312C427928652C6E2E706172656E74292C733D6E2E706172656E742E7269676874292C303D3D3D732E6C6566742E636F6C6F722626303D3D3D732E7269';
wwv_flow_imp.g_varchar2_table(7138) := '6768742E636F6C6F723F28732E636F6C6F723D312C6E3D6E2E706172656E74293A28303D3D3D732E72696768742E636F6C6F72262628732E6C6566742E636F6C6F723D302C732E636F6C6F723D312C567928652C73292C733D6E2E706172656E742E7269';
wwv_flow_imp.g_varchar2_table(7139) := '676874292C732E636F6C6F723D6E2E706172656E742E636F6C6F722C6E2E706172656E742E636F6C6F723D302C732E72696768742E636F6C6F723D302C427928652C6E2E706172656E74292C6E3D652E726F6F7429293A28733D6E2E706172656E742E6C';
wwv_flow_imp.g_varchar2_table(7140) := '6566742C313D3D3D732E636F6C6F72262628732E636F6C6F723D302C6E2E706172656E742E636F6C6F723D312C567928652C6E2E706172656E74292C733D6E2E706172656E742E6C656674292C303D3D3D732E6C6566742E636F6C6F722626303D3D3D73';
wwv_flow_imp.g_varchar2_table(7141) := '2E72696768742E636F6C6F723F28732E636F6C6F723D312C6E3D6E2E706172656E74293A28303D3D3D732E6C6566742E636F6C6F72262628732E72696768742E636F6C6F723D302C732E636F6C6F723D312C427928652C73292C733D6E2E706172656E74';
wwv_flow_imp.g_varchar2_table(7142) := '2E6C656674292C732E636F6C6F723D6E2E706172656E742E636F6C6F722C6E2E706172656E742E636F6C6F723D302C732E6C6566742E636F6C6F723D302C567928652C6E2E706172656E74292C6E3D652E726F6F7429293B6E2E636F6C6F723D302C4679';
wwv_flow_imp.g_varchar2_table(7143) := '28297D66756E6374696F6E20487928652C74297B666F72286A7928652C74293B74213D3D652E726F6F742626313D3D3D742E706172656E742E636F6C6F723B29696628742E706172656E743D3D3D742E706172656E742E706172656E742E6C656674297B';
wwv_flow_imp.g_varchar2_table(7144) := '636F6E7374206E3D742E706172656E742E706172656E742E72696768743B313D3D3D6E2E636F6C6F723F28742E706172656E742E636F6C6F723D302C6E2E636F6C6F723D302C742E706172656E742E706172656E742E636F6C6F723D312C743D742E7061';
wwv_flow_imp.g_varchar2_table(7145) := '72656E742E706172656E74293A28743D3D3D742E706172656E742E72696768742626427928652C743D742E706172656E74292C742E706172656E742E636F6C6F723D302C742E706172656E742E706172656E742E636F6C6F723D312C567928652C742E70';
wwv_flow_imp.g_varchar2_table(7146) := '6172656E742E706172656E7429297D656C73657B636F6E7374206E3D742E706172656E742E706172656E742E6C6566743B313D3D3D6E2E636F6C6F723F28742E706172656E742E636F6C6F723D302C6E2E636F6C6F723D302C742E706172656E742E7061';
wwv_flow_imp.g_varchar2_table(7147) := '72656E742E636F6C6F723D312C743D742E706172656E742E706172656E74293A28743D3D3D742E706172656E742E6C6566742626567928652C743D742E706172656E74292C742E706172656E742E636F6C6F723D302C742E706172656E742E706172656E';
wwv_flow_imp.g_varchar2_table(7148) := '742E636F6C6F723D312C427928652C742E706172656E742E706172656E7429297D652E726F6F742E636F6C6F723D307D66756E6374696F6E20577928652C742C6E2C69297B666F72283B74213D3D652E726F6F74262674213D3D41793B29742E70617265';
wwv_flow_imp.g_varchar2_table(7149) := '6E742E6C6566743D3D3D74262628742E706172656E742E73697A655F6C6566742B3D6E2C742E706172656E742E6C665F6C6566742B3D69292C743D742E706172656E747D66756E6374696F6E206A7928652C74297B6C6574206E3D302C693D303B696628';
wwv_flow_imp.g_varchar2_table(7150) := '74213D3D652E726F6F74297B666F72283B74213D3D652E726F6F742626743D3D3D742E706172656E742E72696768743B29743D742E706172656E743B69662874213D3D652E726F6F7429666F72286E3D4F792828743D742E706172656E74292E6C656674';
wwv_flow_imp.g_varchar2_table(7151) := '292D742E73697A655F6C6566742C693D527928742E6C656674292D742E6C665F6C6566742C742E73697A655F6C6566742B3D6E2C742E6C665F6C6566742B3D693B74213D3D652E726F6F7426262830213D3D6E7C7C30213D3D69293B29742E706172656E';
wwv_flow_imp.g_varchar2_table(7152) := '742E6C6566743D3D3D74262628742E706172656E742E73697A655F6C6566742B3D6E2C742E706172656E742E6C665F6C6566742B3D69292C743D742E706172656E747D7D66756E6374696F6E2071792865297B72657475726E20653C303F303A653E3235';
wwv_flow_imp.g_varchar2_table(7153) := '353F3235353A307C657D66756E6374696F6E2024792865297B72657475726E20653C303F303A653E343239343936373239353F343239343936373239353A307C657D41792E706172656E743D41792C41792E6C6566743D41792C41792E72696768743D41';
wwv_flow_imp.g_varchar2_table(7154) := '792C41792E636F6C6F723D303B636C6173732055797B636F6E7374727563746F722865297B636F6E737420743D71792865293B746869732E5F64656661756C7456616C75653D742C746869732E5F61736369694D61703D55792E5F637265617465417363';
wwv_flow_imp.g_varchar2_table(7155) := '69694D61702874292C746869732E5F6D61703D6E6577204D61707D737461746963205F63726561746541736369694D61702865297B636F6E737420743D6E65772055696E7438417272617928323536293B72657475726E20742E66696C6C2865292C747D';
wwv_flow_imp.g_varchar2_table(7156) := '73657428652C74297B636F6E7374206E3D71792874293B653E3D302626653C3235363F746869732E5F61736369694D61705B655D3D6E3A746869732E5F6D61702E73657428652C6E297D6765742865297B72657475726E20653E3D302626653C3235363F';
wwv_flow_imp.g_varchar2_table(7157) := '746869732E5F61736369694D61705B655D3A746869732E5F6D61702E6765742865297C7C746869732E5F64656661756C7456616C75657D636C65617228297B746869732E5F61736369694D61702E66696C6C28746869732E5F64656661756C7456616C75';
wwv_flow_imp.g_varchar2_table(7158) := '65292C746869732E5F6D61702E636C65617228297D7D636C617373204B797B636F6E7374727563746F7228297B746869732E5F61637475616C3D6E65772055792830297D6164642865297B746869732E5F61637475616C2E73657428652C31297D686173';
wwv_flow_imp.g_varchar2_table(7159) := '2865297B72657475726E20313D3D3D746869732E5F61637475616C2E6765742865297D636C65617228297B72657475726E20746869732E5F61637475616C2E636C65617228297D7D636C61737320477920657874656E64732055797B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(7160) := '746F7228652C74297B73757065722830292C746869732E5F7365676D656E7465723D6E756C6C2C746869732E5F6361636865644C696E653D6E756C6C2C746869732E5F6361636865645365676D656E74733D5B5D2C746869732E696E746C5365676D656E';
wwv_flow_imp.g_varchar2_table(7161) := '7465724C6F63616C65733D742C746869732E696E746C5365676D656E7465724C6F63616C65732E6C656E6774683E303F746869732E5F7365676D656E7465723D6E657720496E746C2E5365676D656E74657228746869732E696E746C5365676D656E7465';
wwv_flow_imp.g_varchar2_table(7162) := '724C6F63616C65732C7B6772616E756C61726974793A22776F7264227D293A746869732E5F7365676D656E7465723D6E756C6C3B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B29746869732E73657428652E63686172436F';
wwv_flow_imp.g_varchar2_table(7163) := '646541742874292C32293B746869732E7365742833322C31292C746869732E73657428392C31297D66696E6450726576496E746C576F72644265666F72654F7241744F666673657428652C74297B6C6574206E3D6E756C6C3B666F7228636F6E73742069';
wwv_flow_imp.g_varchar2_table(7164) := '206F6620746869732E5F676574496E746C5365676D656E746572576F7264734F6E4C696E65286529297B696628692E696E6465783E7429627265616B3B6E3D697D72657475726E206E7D66696E644E657874496E746C576F726441744F7241667465724F';
wwv_flow_imp.g_varchar2_table(7165) := '666673657428652C74297B666F7228636F6E7374206E206F6620746869732E5F676574496E746C5365676D656E746572576F7264734F6E4C696E652865292969662821286E2E696E6465783C74292972657475726E206E3B72657475726E206E756C6C7D';
wwv_flow_imp.g_varchar2_table(7166) := '5F676574496E746C5365676D656E746572576F7264734F6E4C696E652865297B72657475726E20746869732E5F7365676D656E7465723F28746869732E5F6361636865644C696E653D3D3D657C7C28746869732E5F6361636865644C696E653D652C7468';
wwv_flow_imp.g_varchar2_table(7167) := '69732E5F6361636865645365676D656E74733D746869732E5F66696C746572576F72645365676D656E747328746869732E5F7365676D656E7465722E7365676D656E7428652929292C746869732E5F6361636865645365676D656E7473293A5B5D7D5F66';
wwv_flow_imp.g_varchar2_table(7168) := '696C746572576F72645365676D656E74732865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F66206529746869732E5F6973576F72644C696B65286E292626742E70757368286E293B72657475726E20747D5F6973576F72644C696B65';
wwv_flow_imp.g_varchar2_table(7169) := '2865297B72657475726E2121652E6973576F72644C696B657D7D636F6E73742051793D6E6577206161283130293B66756E6374696F6E20597928652C74297B636F6E7374206E3D60247B657D2F247B742E6A6F696E28222C22297D603B6C657420693D51';
wwv_flow_imp.g_varchar2_table(7170) := '792E676574286E293B72657475726E20697C7C28693D6E657720477928652C74292C51792E736574286E2C6929292C697D636C617373205A797B636F6E7374727563746F7228652C742C6E2C69297B746869732E736561726368537472696E673D652C74';
wwv_flow_imp.g_varchar2_table(7171) := '6869732E697352656765783D742C746869732E6D61746368436173653D6E2C746869732E776F7264536570617261746F72733D697D70617273655365617263685265717565737428297B69662822223D3D3D746869732E736561726368537472696E6729';
wwv_flow_imp.g_varchar2_table(7172) := '72657475726E206E756C6C3B6C657420653B653D746869732E697352656765783F66756E6374696F6E2865297B69662821657C7C303D3D3D652E6C656E6774682972657475726E21313B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E';
wwv_flow_imp.g_varchar2_table(7173) := '3B742B2B297B636F6E737420693D652E63686172436F646541742874293B69662831303D3D3D692972657475726E21303B69662839323D3D3D69297B696628742B2B2C743E3D6E29627265616B3B636F6E737420693D652E63686172436F646541742874';
wwv_flow_imp.g_varchar2_table(7174) := '293B6966283131303D3D3D697C7C3131343D3D3D697C7C38373D3D3D692972657475726E21307D7D72657475726E21317D28746869732E736561726368537472696E67293A746869732E736561726368537472696E672E696E6465784F6628225C6E2229';
wwv_flow_imp.g_varchar2_table(7175) := '3E3D303B6C657420743D6E756C6C3B7472797B743D706928746869732E736561726368537472696E672C746869732E697352656765782C7B6D61746368436173653A746869732E6D61746368436173652C77686F6C65576F72643A21312C6D756C74696C';
wwv_flow_imp.g_varchar2_table(7176) := '696E653A652C676C6F62616C3A21302C756E69636F64653A21307D297D63617463682865297B72657475726E206E756C6C7D69662821742972657475726E206E756C6C3B6C6574206E3D21746869732E69735265676578262621653B72657475726E206E';
wwv_flow_imp.g_varchar2_table(7177) := '2626746869732E736561726368537472696E672E746F4C6F776572436173652829213D3D746869732E736561726368537472696E672E746F55707065724361736528292626286E3D746869732E6D6174636843617365292C6E657720496828742C746869';
wwv_flow_imp.g_varchar2_table(7178) := '732E776F7264536570617261746F72733F597928746869732E776F7264536570617261746F72732C5B5D293A6E756C6C2C6E3F746869732E736561726368537472696E673A6E756C6C297D7D66756E6374696F6E20587928652C742C6E297B696628216E';
wwv_flow_imp.g_varchar2_table(7179) := '2972657475726E206E657720446828652C6E756C6C293B636F6E737420693D5B5D3B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B29695B655D3D745B655D3B72657475726E206E657720446828652C69297D636C61737320';
wwv_flow_imp.g_varchar2_table(7180) := '4A797B636F6E7374727563746F722865297B636F6E737420743D5B5D3B6C6574206E3D303B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B2931303D3D3D652E63686172436F64654174286929262628745B6E2B2B5D3D6929';
wwv_flow_imp.g_varchar2_table(7181) := '3B746869732E5F6C696E6546656564734F6666736574733D747D66696E644C696E6546656564436F756E744265666F72654F66667365742865297B636F6E737420743D746869732E5F6C696E6546656564734F6666736574733B6C6574206E3D302C693D';
wwv_flow_imp.g_varchar2_table(7182) := '742E6C656E6774682D313B6966282D313D3D3D692972657475726E20303B696628653C3D745B305D2972657475726E20303B666F72283B6E3C693B297B636F6E7374206F3D6E2B2828692D6E292F327C30293B745B6F5D3E3D653F693D6F2D313A745B6F';
wwv_flow_imp.g_varchar2_table(7183) := '2B315D3E3D653F286E3D6F2C693D6F293A6E3D6F2B317D72657475726E206E2B317D7D636C6173732065777B7374617469632066696E644D61746368657328652C742C6E2C692C6F297B636F6E737420733D742E70617273655365617263685265717565';
wwv_flow_imp.g_varchar2_table(7184) := '737428293B72657475726E20733F732E72656765782E6D756C74696C696E653F746869732E5F646F46696E644D6174636865734D756C74696C696E6528652C6E2C6E6577206E7728732E776F7264536570617261746F72732C732E7265676578292C692C';
wwv_flow_imp.g_varchar2_table(7185) := '6F293A746869732E5F646F46696E644D6174636865734C696E6542794C696E6528652C6E2C732C692C6F293A5B5D7D737461746963205F6765744D756C74696C696E654D6174636852616E676528652C742C6E2C692C6F2C73297B6C657420722C612C6C';
wwv_flow_imp.g_varchar2_table(7186) := '3D303B696628693F286C3D692E66696E644C696E6546656564436F756E744265666F72654F6666736574286F292C723D742B6F2B6C293A723D742B6F2C69297B636F6E737420653D692E66696E644C696E6546656564436F756E744265666F72654F6666';
wwv_flow_imp.g_varchar2_table(7187) := '736574286F2B732E6C656E677468292D6C3B613D722B732E6C656E6774682B657D656C736520613D722B732E6C656E6774683B636F6E737420633D652E676574506F736974696F6E41742872292C643D652E676574506F736974696F6E41742861293B72';
wwv_flow_imp.g_varchar2_table(7188) := '657475726E206E657720726828632E6C696E654E756D6265722C632E636F6C756D6E2C642E6C696E654E756D6265722C642E636F6C756D6E297D737461746963205F646F46696E644D6174636865734D756C74696C696E6528652C742C6E2C692C6F297B';
wwv_flow_imp.g_varchar2_table(7189) := '636F6E737420733D652E6765744F6666736574417428742E6765745374617274506F736974696F6E2829292C723D652E67657456616C7565496E52616E676528742C31292C613D225C725C6E223D3D3D652E676574454F4C28293F6E6577204A79287229';
wwv_flow_imp.g_varchar2_table(7190) := '3A6E756C6C2C6C3D5B5D3B6C657420632C643D303B666F72286E2E72657365742830293B633D6E2E6E6578742872293B296966286C5B642B2B5D3D587928746869732E5F6765744D756C74696C696E654D6174636852616E676528652C732C722C612C63';
wwv_flow_imp.g_varchar2_table(7191) := '2E696E6465782C635B305D292C632C69292C643E3D6F2972657475726E206C3B72657475726E206C7D737461746963205F646F46696E644D6174636865734C696E6542794C696E6528652C742C6E2C692C6F297B636F6E737420733D5B5D3B6C65742072';
wwv_flow_imp.g_varchar2_table(7192) := '3D303B696628742E73746172744C696E654E756D6265723D3D3D742E656E644C696E654E756D626572297B636F6E737420613D652E6765744C696E65436F6E74656E7428742E73746172744C696E654E756D626572292E737562737472696E6728742E73';
wwv_flow_imp.g_varchar2_table(7193) := '74617274436F6C756D6E2D312C742E656E64436F6C756D6E2D31293B72657475726E20723D746869732E5F66696E644D617463686573496E4C696E65286E2C612C742E73746172744C696E654E756D6265722C742E7374617274436F6C756D6E2D312C72';
wwv_flow_imp.g_varchar2_table(7194) := '2C732C692C6F292C737D636F6E737420613D652E6765744C696E65436F6E74656E7428742E73746172744C696E654E756D626572292E737562737472696E6728742E7374617274436F6C756D6E2D31293B723D746869732E5F66696E644D617463686573';
wwv_flow_imp.g_varchar2_table(7195) := '496E4C696E65286E2C612C742E73746172744C696E654E756D6265722C742E7374617274436F6C756D6E2D312C722C732C692C6F293B666F72286C657420613D742E73746172744C696E654E756D6265722B313B613C742E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(7196) := '722626723C6F3B612B2B29723D746869732E5F66696E644D617463686573496E4C696E65286E2C652E6765744C696E65436F6E74656E742861292C612C302C722C732C692C6F293B696628723C6F297B636F6E737420613D652E6765744C696E65436F6E';
wwv_flow_imp.g_varchar2_table(7197) := '74656E7428742E656E644C696E654E756D626572292E737562737472696E6728302C742E656E64436F6C756D6E2D31293B723D746869732E5F66696E644D617463686573496E4C696E65286E2C612C742E656E644C696E654E756D6265722C302C722C73';
wwv_flow_imp.g_varchar2_table(7198) := '2C692C6F297D72657475726E20737D737461746963205F66696E644D617463686573496E4C696E6528652C742C6E2C692C6F2C732C722C61297B636F6E7374206C3D652E776F7264536570617261746F72733B69662821722626652E73696D706C655365';
wwv_flow_imp.g_varchar2_table(7199) := '61726368297B636F6E737420723D652E73696D706C655365617263682C633D722E6C656E6774682C643D742E6C656E6774683B6C657420683D2D633B666F72283B2D31213D3D28683D742E696E6465784F6628722C682B6329293B2969662828216C7C7C';
wwv_flow_imp.g_varchar2_table(7200) := '7477286C2C742C642C682C632929262628735B6F2B2B5D3D6E6577204468286E6577207268286E2C682B312B692C6E2C682B312B632B69292C6E756C6C292C6F3E3D61292972657475726E206F3B72657475726E206F7D636F6E737420633D6E6577206E';
wwv_flow_imp.g_varchar2_table(7201) := '7728652E776F7264536570617261746F72732C652E7265676578293B6C657420643B632E72657365742830293B646F7B696628643D632E6E6578742874292C64262628735B6F2B2B5D3D5879286E6577207268286E2C642E696E6465782B312B692C6E2C';
wwv_flow_imp.g_varchar2_table(7202) := '642E696E6465782B312B645B305D2E6C656E6774682B69292C642C72292C6F3E3D61292972657475726E206F7D7768696C652864293B72657475726E206F7D7374617469632066696E644E6578744D6174636828652C742C6E2C69297B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(7203) := '3D742E70617273655365617263685265717565737428293B696628216F2972657475726E206E756C6C3B636F6E737420733D6E6577206E77286F2E776F7264536570617261746F72732C6F2E7265676578293B72657475726E206F2E72656765782E6D75';
wwv_flow_imp.g_varchar2_table(7204) := '6C74696C696E653F746869732E5F646F46696E644E6578744D617463684D756C74696C696E6528652C6E2C732C69293A746869732E5F646F46696E644E6578744D617463684C696E6542794C696E6528652C6E2C732C69297D737461746963205F646F46';
wwv_flow_imp.g_varchar2_table(7205) := '696E644E6578744D617463684D756C74696C696E6528652C742C6E2C69297B636F6E7374206F3D6E6577206D6328742E6C696E654E756D6265722C31292C733D652E6765744F66667365744174286F292C723D652E6765744C696E65436F756E7428292C';
wwv_flow_imp.g_varchar2_table(7206) := '613D652E67657456616C7565496E52616E6765286E6577207268286F2E6C696E654E756D6265722C6F2E636F6C756D6E2C722C652E6765744C696E654D6178436F6C756D6E287229292C31292C6C3D225C725C6E223D3D3D652E676574454F4C28293F6E';
wwv_flow_imp.g_varchar2_table(7207) := '6577204A792861293A6E756C6C3B6E2E726573657428742E636F6C756D6E2D31293B636F6E737420633D6E2E6E6578742861293B72657475726E20633F587928746869732E5F6765744D756C74696C696E654D6174636852616E676528652C732C612C6C';
wwv_flow_imp.g_varchar2_table(7208) := '2C632E696E6465782C635B305D292C632C69293A31213D3D742E6C696E654E756D6265727C7C31213D3D742E636F6C756D6E3F746869732E5F646F46696E644E6578744D617463684D756C74696C696E6528652C6E6577206D6328312C31292C6E2C6929';
wwv_flow_imp.g_varchar2_table(7209) := '3A6E756C6C7D737461746963205F646F46696E644E6578744D617463684C696E6542794C696E6528652C742C6E2C69297B636F6E7374206F3D652E6765744C696E65436F756E7428292C733D742E6C696E654E756D6265722C723D652E6765744C696E65';
wwv_flow_imp.g_varchar2_table(7210) := '436F6E74656E742873292C613D746869732E5F66696E6446697273744D61746368496E4C696E65286E2C722C732C742E636F6C756D6E2C69293B696628612972657475726E20613B666F72286C657420743D313B743C3D6F3B742B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(7211) := '723D28732B742D3129256F2C613D652E6765744C696E65436F6E74656E7428722B31292C6C3D746869732E5F66696E6446697273744D61746368496E4C696E65286E2C612C722B312C312C69293B6966286C2972657475726E206C7D72657475726E206E';
wwv_flow_imp.g_varchar2_table(7212) := '756C6C7D737461746963205F66696E6446697273744D61746368496E4C696E6528652C742C6E2C692C6F297B652E726573657428692D31293B636F6E737420733D652E6E6578742874293B72657475726E20733F5879286E6577207268286E2C732E696E';
wwv_flow_imp.g_varchar2_table(7213) := '6465782B312C6E2C732E696E6465782B312B735B305D2E6C656E677468292C732C6F293A6E756C6C7D7374617469632066696E6450726576696F75734D6174636828652C742C6E2C69297B636F6E7374206F3D742E706172736553656172636852657175';
wwv_flow_imp.g_varchar2_table(7214) := '65737428293B696628216F2972657475726E206E756C6C3B636F6E737420733D6E6577206E77286F2E776F7264536570617261746F72732C6F2E7265676578293B72657475726E206F2E72656765782E6D756C74696C696E653F746869732E5F646F4669';
wwv_flow_imp.g_varchar2_table(7215) := '6E6450726576696F75734D617463684D756C74696C696E6528652C6E2C732C69293A746869732E5F646F46696E6450726576696F75734D617463684C696E6542794C696E6528652C6E2C732C69297D737461746963205F646F46696E6450726576696F75';
wwv_flow_imp.g_varchar2_table(7216) := '734D617463684D756C74696C696E6528652C742C6E2C69297B636F6E7374206F3D746869732E5F646F46696E644D6174636865734D756C74696C696E6528652C6E657720726828312C312C742E6C696E654E756D6265722C742E636F6C756D6E292C6E2C';
wwv_flow_imp.g_varchar2_table(7217) := '692C39393930293B6966286F2E6C656E6774683E302972657475726E206F5B6F2E6C656E6774682D315D3B636F6E737420733D652E6765744C696E65436F756E7428293B72657475726E20742E6C696E654E756D626572213D3D737C7C742E636F6C756D';
wwv_flow_imp.g_varchar2_table(7218) := '6E213D3D652E6765744C696E654D6178436F6C756D6E2873293F746869732E5F646F46696E6450726576696F75734D617463684D756C74696C696E6528652C6E6577206D6328732C652E6765744C696E654D6178436F6C756D6E287329292C6E2C69293A';
wwv_flow_imp.g_varchar2_table(7219) := '6E756C6C7D737461746963205F646F46696E6450726576696F75734D617463684C696E6542794C696E6528652C742C6E2C69297B636F6E7374206F3D652E6765744C696E65436F756E7428292C733D742E6C696E654E756D6265722C723D652E6765744C';
wwv_flow_imp.g_varchar2_table(7220) := '696E65436F6E74656E742873292E737562737472696E6728302C742E636F6C756D6E2D31292C613D746869732E5F66696E644C6173744D61746368496E4C696E65286E2C722C732C69293B696628612972657475726E20613B666F72286C657420743D31';
wwv_flow_imp.g_varchar2_table(7221) := '3B743C3D6F3B742B2B297B636F6E737420723D286F2B732D742D3129256F2C613D652E6765744C696E65436F6E74656E7428722B31292C6C3D746869732E5F66696E644C6173744D61746368496E4C696E65286E2C612C722B312C69293B6966286C2972';
wwv_flow_imp.g_varchar2_table(7222) := '657475726E206C7D72657475726E206E756C6C7D737461746963205F66696E644C6173744D61746368496E4C696E6528652C742C6E2C69297B6C6574206F2C733D6E756C6C3B666F7228652E72657365742830293B6F3D652E6E6578742874293B29733D';
wwv_flow_imp.g_varchar2_table(7223) := '5879286E6577207268286E2C6F2E696E6465782B312C6E2C6F2E696E6465782B312B6F5B305D2E6C656E677468292C6F2C69293B72657475726E20737D7D66756E6374696F6E20747728652C742C6E2C692C6F297B72657475726E2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7224) := '28652C742C6E2C692C6F297B696628303D3D3D692972657475726E21303B636F6E737420733D742E63686172436F6465417428692D31293B69662830213D3D652E6765742873292972657475726E21303B69662831333D3D3D737C7C31303D3D3D732972';
wwv_flow_imp.g_varchar2_table(7225) := '657475726E21303B6966286F3E30297B636F6E7374206E3D742E63686172436F646541742869293B69662830213D3D652E676574286E292972657475726E21307D72657475726E21317D28652C742C302C692C6F29262666756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(7226) := '6E2C692C6F297B696628692B6F3D3D3D6E2972657475726E21303B636F6E737420733D742E63686172436F6465417428692B6F293B69662830213D3D652E6765742873292972657475726E21303B69662831333D3D3D737C7C31303D3D3D732972657475';
wwv_flow_imp.g_varchar2_table(7227) := '726E21303B6966286F3E30297B636F6E7374206E3D742E63686172436F6465417428692B6F2D31293B69662830213D3D652E676574286E292972657475726E21307D72657475726E21317D28652C742C6E2C692C6F297D636C617373206E777B636F6E73';
wwv_flow_imp.g_varchar2_table(7228) := '74727563746F7228652C74297B746869732E5F776F7264536570617261746F72733D652C746869732E5F73656172636852656765783D742C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D61746368';
wwv_flow_imp.g_varchar2_table(7229) := '4C656E6774683D307D72657365742865297B746869732E5F73656172636852656765782E6C617374496E6465783D652C746869732E5F707265764D617463685374617274496E6465783D2D312C746869732E5F707265764D617463684C656E6774683D30';
wwv_flow_imp.g_varchar2_table(7230) := '7D6E6578742865297B636F6E737420743D652E6C656E6774683B6C6574206E3B646F7B696628746869732E5F707265764D617463685374617274496E6465782B746869732E5F707265764D617463684C656E6774683D3D3D742972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(7231) := '6C3B6966286E3D746869732E5F73656172636852656765782E657865632865292C216E2972657475726E206E756C6C3B636F6E737420693D6E2E696E6465782C6F3D6E5B305D2E6C656E6774683B696628693D3D3D746869732E5F707265764D61746368';
wwv_flow_imp.g_varchar2_table(7232) := '5374617274496E64657826266F3D3D3D746869732E5F707265764D617463684C656E677468297B696628303D3D3D6F297B416928652C742C746869732E5F73656172636852656765782E6C617374496E646578293E36353533353F746869732E5F736561';
wwv_flow_imp.g_varchar2_table(7233) := '72636852656765782E6C617374496E6465782B3D323A746869732E5F73656172636852656765782E6C617374496E6465782B3D313B636F6E74696E75657D72657475726E206E756C6C7D696628746869732E5F707265764D617463685374617274496E64';
wwv_flow_imp.g_varchar2_table(7234) := '65783D692C746869732E5F707265764D617463684C656E6774683D6F2C21746869732E5F776F7264536570617261746F72737C7C747728746869732E5F776F7264536570617261746F72732C652C742C692C6F292972657475726E206E7D7768696C6528';
wwv_flow_imp.g_varchar2_table(7235) := '6E293B72657475726E206E756C6C7D7D636F6E73742069773D36353533353B66756E6374696F6E206F772865297B6C657420743B72657475726E20743D655B652E6C656E6774682D315D3C36353533363F6E65772055696E743136417272617928652E6C';
wwv_flow_imp.g_varchar2_table(7236) := '656E677468293A6E65772055696E743332417272617928652E6C656E677468292C742E73657428652C30292C747D636C6173732073777B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6C696E655374617274733D652C74686973';
wwv_flow_imp.g_varchar2_table(7237) := '2E63723D742C746869732E6C663D6E2C746869732E63726C663D692C746869732E6973426173696341534349493D6F7D7D66756E6374696F6E20727728652C743D2130297B636F6E7374206E3D5B305D3B6C657420693D313B666F72286C657420743D30';
wwv_flow_imp.g_varchar2_table(7238) := '2C6F3D652E6C656E6774683B743C6F3B742B2B297B636F6E737420733D652E63686172436F646541742874293B31333D3D3D733F742B313C6F262631303D3D3D652E63686172436F6465417428742B31293F286E5B692B2B5D3D742B322C742B2B293A6E';
wwv_flow_imp.g_varchar2_table(7239) := '5B692B2B5D3D742B313A31303D3D3D732626286E5B692B2B5D3D742B31297D72657475726E20743F6F77286E293A6E7D636C6173732061777B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E627566666572496E6465783D652C74';
wwv_flow_imp.g_varchar2_table(7240) := '6869732E73746172743D742C746869732E656E643D6E2C746869732E6C696E6546656564436E743D692C746869732E6C656E6774683D6F7D7D636C617373206C777B636F6E7374727563746F7228652C74297B746869732E6275666665723D652C746869';
wwv_flow_imp.g_varchar2_table(7241) := '732E6C696E655374617274733D747D7D636C6173732063777B636F6E7374727563746F7228652C74297B746869732E5F7069656365733D5B5D2C746869732E5F747265653D652C746869732E5F424F4D3D742C746869732E5F696E6465783D302C652E72';
wwv_flow_imp.g_varchar2_table(7242) := '6F6F74213D3D41792626652E6974657261746528652E726F6F742C28653D3E2865213D3D41792626746869732E5F7069656365732E7075736828652E7069656365292C21302929297D7265616428297B72657475726E20303D3D3D746869732E5F706965';
wwv_flow_imp.g_varchar2_table(7243) := '6365732E6C656E6774683F303D3D3D746869732E5F696E6465783F28746869732E5F696E6465782B2B2C746869732E5F424F4D293A6E756C6C3A746869732E5F696E6465783E746869732E5F7069656365732E6C656E6774682D313F6E756C6C3A303D3D';
wwv_flow_imp.g_varchar2_table(7244) := '3D746869732E5F696E6465783F746869732E5F424F4D2B746869732E5F747265652E6765745069656365436F6E74656E7428746869732E5F7069656365735B746869732E5F696E6465782B2B5D293A746869732E5F747265652E6765745069656365436F';
wwv_flow_imp.g_varchar2_table(7245) := '6E74656E7428746869732E5F7069656365735B746869732E5F696E6465782B2B5D297D7D636C6173732064777B636F6E7374727563746F722865297B746869732E5F6C696D69743D652C746869732E5F63616368653D5B5D7D6765742865297B666F7228';
wwv_flow_imp.g_varchar2_table(7246) := '6C657420743D746869732E5F63616368652E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D746869732E5F63616368655B745D3B6966286E2E6E6F646553746172744F66667365743C3D6526266E2E6E6F646553746172744F666673';
wwv_flow_imp.g_varchar2_table(7247) := '65742B6E2E6E6F64652E70696563652E6C656E6774683E3D652972657475726E206E7D72657475726E206E756C6C7D676574322865297B666F72286C657420743D746869732E5F63616368652E6C656E6774682D313B743E3D303B742D2D297B636F6E73';
wwv_flow_imp.g_varchar2_table(7248) := '74206E3D746869732E5F63616368655B745D3B6966286E2E6E6F646553746172744C696E654E756D62657226266E2E6E6F646553746172744C696E654E756D6265723C6526266E2E6E6F646553746172744C696E654E756D6265722B6E2E6E6F64652E70';
wwv_flow_imp.g_varchar2_table(7249) := '696563652E6C696E6546656564436E743E3D652972657475726E206E7D72657475726E206E756C6C7D7365742865297B746869732E5F63616368652E6C656E6774683E3D746869732E5F6C696D69742626746869732E5F63616368652E73686966742829';
wwv_flow_imp.g_varchar2_table(7250) := '2C746869732E5F63616368652E707573682865297D76616C69646174652865297B6C657420743D21313B636F6E7374206E3D746869732E5F63616368653B666F72286C657420693D303B693C6E2E6C656E6774683B692B2B297B636F6E7374206F3D6E5B';
wwv_flow_imp.g_varchar2_table(7251) := '695D3B286E756C6C3D3D3D6F2E6E6F64652E706172656E747C7C6F2E6E6F646553746172744F66667365743E3D65292626286E5B695D3D6E756C6C2C743D2130297D69662874297B636F6E737420653D5B5D3B666F7228636F6E73742074206F66206E29';
wwv_flow_imp.g_varchar2_table(7252) := '6E756C6C213D3D742626652E707573682874293B746869732E5F63616368653D657D7D7D636C6173732068777B636F6E7374727563746F7228652C742C6E297B746869732E63726561746528652C742C6E297D63726561746528652C742C6E297B746869';
wwv_flow_imp.g_varchar2_table(7253) := '732E5F627566666572733D5B6E6577206C772822222C5B305D295D2C746869732E5F6C6173744368616E6765427566666572506F733D7B6C696E653A302C636F6C756D6E3A307D2C746869732E726F6F743D41792C746869732E5F6C696E65436E743D31';
wwv_flow_imp.g_varchar2_table(7254) := '2C746869732E5F6C656E6774683D302C746869732E5F454F4C3D742C746869732E5F454F4C4C656E6774683D742E6C656E6774682C746869732E5F454F4C4E6F726D616C697A65643D6E3B6C657420693D6E756C6C3B666F72286C657420743D302C6E3D';
wwv_flow_imp.g_varchar2_table(7255) := '652E6C656E6774683B743C6E3B742B2B29696628655B745D2E6275666665722E6C656E6774683E30297B655B745D2E6C696E655374617274737C7C28655B745D2E6C696E655374617274733D727728655B745D2E62756666657229293B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(7256) := '3D6E657720617728742B312C7B6C696E653A302C636F6C756D6E3A307D2C7B6C696E653A655B745D2E6C696E655374617274732E6C656E6774682D312C636F6C756D6E3A655B745D2E6275666665722E6C656E6774682D655B745D2E6C696E6553746172';
wwv_flow_imp.g_varchar2_table(7257) := '74735B655B745D2E6C696E655374617274732E6C656E6774682D315D7D2C655B745D2E6C696E655374617274732E6C656E6774682D312C655B745D2E6275666665722E6C656E677468293B746869732E5F627566666572732E7075736828655B745D292C';
wwv_flow_imp.g_varchar2_table(7258) := '693D746869732E7262496E73657274526967687428692C6E297D746869732E5F73656172636843616368653D6E65772064772831292C746869732E5F6C617374566973697465644C696E653D7B6C696E654E756D6265723A302C76616C75653A22227D2C';
wwv_flow_imp.g_varchar2_table(7259) := '746869732E636F6D707574654275666665724D6574616461746128297D6E6F726D616C697A65454F4C2865297B636F6E737420743D36353533352D4D6174682E666C6F6F72283231383435292C6E3D322A743B6C657420693D22222C6F3D303B636F6E73';
wwv_flow_imp.g_varchar2_table(7260) := '7420733D5B5D3B696628746869732E6974657261746528746869732E726F6F742C28723D3E7B636F6E737420613D746869732E6765744E6F6465436F6E74656E742872292C6C3D612E6C656E6774683B6966286F3C3D747C7C6F2B6C3C6E297265747572';
wwv_flow_imp.g_varchar2_table(7261) := '6E20692B3D612C6F2B3D6C2C21303B636F6E737420633D692E7265706C616365282F5C725C6E7C5C727C5C6E2F672C65293B72657475726E20732E70757368286E6577206C7728632C727728632929292C693D612C6F3D6C2C21307D29292C6F3E30297B';
wwv_flow_imp.g_varchar2_table(7262) := '636F6E737420743D692E7265706C616365282F5C725C6E7C5C727C5C6E2F672C65293B732E70757368286E6577206C7728742C727728742929297D746869732E63726561746528732C652C2130297D676574454F4C28297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(7263) := '5F454F4C7D736574454F4C2865297B746869732E5F454F4C3D652C746869732E5F454F4C4C656E6774683D746869732E5F454F4C2E6C656E6774682C746869732E6E6F726D616C697A65454F4C2865297D637265617465536E617073686F742865297B72';
wwv_flow_imp.g_varchar2_table(7264) := '657475726E206E657720637728746869732C65297D6765744F6666736574417428652C74297B6C6574206E3D302C693D746869732E726F6F743B666F72283B69213D3D41793B29696628692E6C656674213D3D41792626692E6C665F6C6566742B313E3D';
wwv_flow_imp.g_varchar2_table(7265) := '6529693D692E6C6566743B656C73657B696628692E6C665F6C6566742B692E70696563652E6C696E6546656564436E742B313E3D652972657475726E206E2B3D692E73697A655F6C6566742C6E2B28746869732E676574416363756D756C617465645661';
wwv_flow_imp.g_varchar2_table(7266) := '6C756528692C652D692E6C665F6C6566742D32292B742D31293B652D3D692E6C665F6C6566742B692E70696563652E6C696E6546656564436E742C6E2B3D692E73697A655F6C6566742B692E70696563652E6C656E6774682C693D692E72696768747D72';
wwv_flow_imp.g_varchar2_table(7267) := '657475726E206E7D676574506F736974696F6E41742865297B653D4D6174682E666C6F6F722865292C653D4D6174682E6D617828302C65293B6C657420743D746869732E726F6F742C6E3D303B636F6E737420693D653B666F72283B74213D3D41793B29';
wwv_flow_imp.g_varchar2_table(7268) := '69662830213D3D742E73697A655F6C6566742626742E73697A655F6C6566743E3D6529743D742E6C6566743B656C73657B696628742E73697A655F6C6566742B742E70696563652E6C656E6774683E3D65297B636F6E7374206F3D746869732E67657449';
wwv_flow_imp.g_varchar2_table(7269) := '6E6465784F6628742C652D742E73697A655F6C656674293B6966286E2B3D742E6C665F6C6566742B6F2E696E6465782C303D3D3D6F2E696E646578297B636F6E737420653D746869732E6765744F66667365744174286E2B312C31293B72657475726E20';
wwv_flow_imp.g_varchar2_table(7270) := '6E6577206D63286E2B312C692D652B31297D72657475726E206E6577206D63286E2B312C6F2E72656D61696E6465722B31297D696628652D3D742E73697A655F6C6566742B742E70696563652E6C656E6774682C6E2B3D742E6C665F6C6566742B742E70';
wwv_flow_imp.g_varchar2_table(7271) := '696563652E6C696E6546656564436E742C742E72696768743D3D3D4179297B636F6E737420743D746869732E6765744F66667365744174286E2B312C31293B72657475726E206E6577206D63286E2B312C692D652D742B31297D743D742E72696768747D';
wwv_flow_imp.g_varchar2_table(7272) := '72657475726E206E6577206D6328312C31297D67657456616C7565496E52616E676528652C74297B696628652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626652E7374617274436F6C756D6E3D3D3D652E656E';
wwv_flow_imp.g_varchar2_table(7273) := '64436F6C756D6E2972657475726E22223B636F6E7374206E3D746869732E6E6F646541743228652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C693D746869732E6E6F646541743228652E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(7274) := '722C652E656E64436F6C756D6E292C6F3D746869732E67657456616C7565496E52616E676532286E2C69293B72657475726E20743F743D3D3D746869732E5F454F4C2626746869732E5F454F4C4E6F726D616C697A65642626743D3D3D746869732E6765';
wwv_flow_imp.g_varchar2_table(7275) := '74454F4C28292626746869732E5F454F4C4E6F726D616C697A65643F6F3A6F2E7265706C616365282F5C725C6E7C5C727C5C6E2F672C74293A6F7D67657456616C7565496E52616E67653228652C74297B696628652E6E6F64653D3D3D742E6E6F646529';
wwv_flow_imp.g_varchar2_table(7276) := '7B636F6E7374206E3D652E6E6F64652C693D746869732E5F627566666572735B6E2E70696563652E627566666572496E6465785D2E6275666665722C6F3D746869732E6F6666736574496E427566666572286E2E70696563652E627566666572496E6465';
wwv_flow_imp.g_varchar2_table(7277) := '782C6E2E70696563652E7374617274293B72657475726E20692E737562737472696E67286F2B652E72656D61696E6465722C6F2B742E72656D61696E646572297D6C6574206E3D652E6E6F64653B636F6E737420693D746869732E5F627566666572735B';
wwv_flow_imp.g_varchar2_table(7278) := '6E2E70696563652E627566666572496E6465785D2E6275666665722C6F3D746869732E6F6666736574496E427566666572286E2E70696563652E627566666572496E6465782C6E2E70696563652E7374617274293B6C657420733D692E73756273747269';
wwv_flow_imp.g_varchar2_table(7279) := '6E67286F2B652E72656D61696E6465722C6F2B6E2E70696563652E6C656E677468293B666F72286E3D6E2E6E65787428293B6E213D3D41793B297B636F6E737420653D746869732E5F627566666572735B6E2E70696563652E627566666572496E646578';
wwv_flow_imp.g_varchar2_table(7280) := '5D2E6275666665722C693D746869732E6F6666736574496E427566666572286E2E70696563652E627566666572496E6465782C6E2E70696563652E7374617274293B6966286E3D3D3D742E6E6F6465297B732B3D652E737562737472696E6728692C692B';
wwv_flow_imp.g_varchar2_table(7281) := '742E72656D61696E646572293B627265616B7D732B3D652E73756273747228692C6E2E70696563652E6C656E677468292C6E3D6E2E6E65787428297D72657475726E20737D6765744C696E6573436F6E74656E7428297B636F6E737420653D5B5D3B6C65';
wwv_flow_imp.g_varchar2_table(7282) := '7420743D302C6E3D22222C693D21313B72657475726E20746869732E6974657261746528746869732E726F6F742C286F3D3E7B6966286F3D3D3D41792972657475726E21303B636F6E737420733D6F2E70696563653B6C657420723D732E6C656E677468';
wwv_flow_imp.g_varchar2_table(7283) := '3B696628303D3D3D722972657475726E21303B636F6E737420613D746869732E5F627566666572735B732E627566666572496E6465785D2E6275666665722C6C3D746869732E5F627566666572735B732E627566666572496E6465785D2E6C696E655374';
wwv_flow_imp.g_varchar2_table(7284) := '617274732C633D732E73746172742E6C696E652C643D732E656E642E6C696E653B6C657420683D6C5B635D2B732E73746172742E636F6C756D6E3B6966286926262831303D3D3D612E63686172436F64654174286829262628682B2B2C722D2D292C655B';
wwv_flow_imp.g_varchar2_table(7285) := '742B2B5D3D6E2C6E3D22222C693D21312C303D3D3D72292972657475726E21303B696628633D3D3D642972657475726E20746869732E5F454F4C4E6F726D616C697A65647C7C3133213D3D612E63686172436F6465417428682B722D31293F6E2B3D612E';
wwv_flow_imp.g_varchar2_table(7286) := '73756273747228682C72293A28693D21302C6E2B3D612E73756273747228682C722D3129292C21303B6E2B3D746869732E5F454F4C4E6F726D616C697A65643F612E737562737472696E6728682C4D6174682E6D617828682C6C5B632B315D2D74686973';
wwv_flow_imp.g_varchar2_table(7287) := '2E5F454F4C4C656E67746829293A612E737562737472696E6728682C6C5B632B315D292E7265706C616365282F285C725C6E7C5C727C5C6E29242F2C2222292C655B742B2B5D3D6E3B666F72286C657420693D632B313B693C643B692B2B296E3D746869';
wwv_flow_imp.g_varchar2_table(7288) := '732E5F454F4C4E6F726D616C697A65643F612E737562737472696E67286C5B695D2C6C5B692B315D2D746869732E5F454F4C4C656E677468293A612E737562737472696E67286C5B695D2C6C5B692B315D292E7265706C616365282F285C725C6E7C5C72';
wwv_flow_imp.g_varchar2_table(7289) := '7C5C6E29242F2C2222292C655B742B2B5D3D6E3B72657475726E20746869732E5F454F4C4E6F726D616C697A65647C7C3133213D3D612E63686172436F64654174286C5B645D2B732E656E642E636F6C756D6E2D31293F6E3D612E737562737472286C5B';
wwv_flow_imp.g_varchar2_table(7290) := '645D2C732E656E642E636F6C756D6E293A28693D21302C303D3D3D732E656E642E636F6C756D6E3F742D2D3A6E3D612E737562737472286C5B645D2C732E656E642E636F6C756D6E2D3129292C21307D29292C69262628655B742B2B5D3D6E2C6E3D2222';
wwv_flow_imp.g_varchar2_table(7291) := '292C655B742B2B5D3D6E2C657D6765744C656E67746828297B72657475726E20746869732E5F6C656E6774687D6765744C696E65436F756E7428297B72657475726E20746869732E5F6C696E65436E747D6765744C696E65436F6E74656E742865297B72';
wwv_flow_imp.g_varchar2_table(7292) := '657475726E20746869732E5F6C617374566973697465644C696E652E6C696E654E756D6265723D3D3D657C7C28746869732E5F6C617374566973697465644C696E652E6C696E654E756D6265723D652C653D3D3D746869732E5F6C696E65436E743F7468';
wwv_flow_imp.g_varchar2_table(7293) := '69732E5F6C617374566973697465644C696E652E76616C75653D746869732E6765744C696E65526177436F6E74656E742865293A746869732E5F454F4C4E6F726D616C697A65643F746869732E5F6C617374566973697465644C696E652E76616C75653D';
wwv_flow_imp.g_varchar2_table(7294) := '746869732E6765744C696E65526177436F6E74656E7428652C746869732E5F454F4C4C656E677468293A746869732E5F6C617374566973697465644C696E652E76616C75653D746869732E6765744C696E65526177436F6E74656E742865292E7265706C';
wwv_flow_imp.g_varchar2_table(7295) := '616365282F285C725C6E7C5C727C5C6E29242F2C222229292C746869732E5F6C617374566973697465644C696E652E76616C75657D5F67657443686172436F64652865297B696628652E72656D61696E6465723D3D3D652E6E6F64652E70696563652E6C';
wwv_flow_imp.g_varchar2_table(7296) := '656E677468297B636F6E737420743D652E6E6F64652E6E65787428293B69662821742972657475726E20303B636F6E7374206E3D746869732E5F627566666572735B742E70696563652E627566666572496E6465785D2C693D746869732E6F6666736574';
wwv_flow_imp.g_varchar2_table(7297) := '496E42756666657228742E70696563652E627566666572496E6465782C742E70696563652E7374617274293B72657475726E206E2E6275666665722E63686172436F646541742869297D7B636F6E737420743D746869732E5F627566666572735B652E6E';
wwv_flow_imp.g_varchar2_table(7298) := '6F64652E70696563652E627566666572496E6465785D2C6E3D746869732E6F6666736574496E42756666657228652E6E6F64652E70696563652E627566666572496E6465782C652E6E6F64652E70696563652E7374617274292B652E72656D61696E6465';
wwv_flow_imp.g_varchar2_table(7299) := '723B72657475726E20742E6275666665722E63686172436F64654174286E297D7D6765744C696E6543686172436F646528652C74297B636F6E7374206E3D746869732E6E6F646541743228652C742B31293B72657475726E20746869732E5F6765744368';
wwv_flow_imp.g_varchar2_table(7300) := '6172436F6465286E297D6765744C696E654C656E6774682865297B696628653D3D3D746869732E6765744C696E65436F756E742829297B636F6E737420743D746869732E6765744F6666736574417428652C31293B72657475726E20746869732E676574';
wwv_flow_imp.g_varchar2_table(7301) := '4C656E67746828292D747D72657475726E20746869732E6765744F6666736574417428652B312C31292D746869732E6765744F6666736574417428652C31292D746869732E5F454F4C4C656E6774687D66696E644D617463686573496E4E6F646528652C';
wwv_flow_imp.g_varchar2_table(7302) := '742C6E2C692C6F2C732C722C612C6C2C632C64297B636F6E737420683D746869732E5F627566666572735B652E70696563652E627566666572496E6465785D2C753D746869732E6F6666736574496E42756666657228652E70696563652E627566666572';
wwv_flow_imp.g_varchar2_table(7303) := '496E6465782C652E70696563652E7374617274292C703D746869732E6F6666736574496E42756666657228652E70696563652E627566666572496E6465782C6F292C673D746869732E6F6666736574496E42756666657228652E70696563652E62756666';
wwv_flow_imp.g_varchar2_table(7304) := '6572496E6465782C73293B6C6574206D3B636F6E737420663D7B6C696E653A302C636F6C756D6E3A307D3B6C657420762C623B742E5F776F7264536570617261746F72733F28763D682E6275666665722E737562737472696E6728702C67292C623D653D';
wwv_flow_imp.g_varchar2_table(7305) := '3E652B702C742E7265736574283029293A28763D682E6275666665722C623D653D3E652C742E7265736574287029293B646F7B6966286D3D742E6E6578742876292C6D297B69662862286D2E696E646578293E3D672972657475726E20633B746869732E';
wwv_flow_imp.g_varchar2_table(7306) := '706F736974696F6E496E42756666657228652C62286D2E696E646578292D752C66293B636F6E737420743D746869732E6765744C696E6546656564436E7428652E70696563652E627566666572496E6465782C6F2C66292C733D662E6C696E653D3D3D6F';
wwv_flow_imp.g_varchar2_table(7307) := '2E6C696E653F662E636F6C756D6E2D6F2E636F6C756D6E2B693A662E636F6C756D6E2B312C723D732B6D5B305D2E6C656E6774683B696628645B632B2B5D3D5879286E6577207268286E2B742C732C6E2B742C72292C6D2C61292C62286D2E696E646578';
wwv_flow_imp.g_varchar2_table(7308) := '292B6D5B305D2E6C656E6774683E3D672972657475726E20633B696628633E3D6C2972657475726E20637D7D7768696C65286D293B72657475726E20637D66696E644D6174636865734C696E6542794C696E6528652C742C6E2C69297B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(7309) := '3D5B5D3B6C657420733D303B636F6E737420723D6E6577206E7728742E776F7264536570617261746F72732C742E7265676578293B6C657420613D746869732E6E6F646541743228652E73746172744C696E654E756D6265722C652E7374617274436F6C';
wwv_flow_imp.g_varchar2_table(7310) := '756D6E293B6966286E756C6C3D3D3D612972657475726E5B5D3B636F6E7374206C3D746869732E6E6F646541743228652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293B6966286E756C6C3D3D3D6C2972657475726E5B5D3B6C6574';
wwv_flow_imp.g_varchar2_table(7311) := '20633D746869732E706F736974696F6E496E42756666657228612E6E6F64652C612E72656D61696E646572293B636F6E737420643D746869732E706F736974696F6E496E427566666572286C2E6E6F64652C6C2E72656D61696E646572293B696628612E';
wwv_flow_imp.g_varchar2_table(7312) := '6E6F64653D3D3D6C2E6E6F64652972657475726E20746869732E66696E644D617463686573496E4E6F646528612E6E6F64652C722C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C632C642C742C6E2C692C732C6F292C';
wwv_flow_imp.g_varchar2_table(7313) := '6F3B6C657420683D652E73746172744C696E654E756D6265722C753D612E6E6F64653B666F72283B75213D3D6C2E6E6F64653B297B636F6E7374206C3D746869732E6765744C696E6546656564436E7428752E70696563652E627566666572496E646578';
wwv_flow_imp.g_varchar2_table(7314) := '2C632C752E70696563652E656E64293B6966286C3E3D31297B636F6E737420613D746869732E5F627566666572735B752E70696563652E627566666572496E6465785D2E6C696E655374617274732C643D746869732E6F6666736574496E427566666572';
wwv_flow_imp.g_varchar2_table(7315) := '28752E70696563652E627566666572496E6465782C752E70696563652E7374617274292C703D615B632E6C696E652B6C5D2C673D683D3D3D652E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E3A313B696628733D746869732E';
wwv_flow_imp.g_varchar2_table(7316) := '66696E644D617463686573496E4E6F646528752C722C682C672C632C746869732E706F736974696F6E496E42756666657228752C702D64292C742C6E2C692C732C6F292C733E3D692972657475726E206F3B682B3D6C7D636F6E737420643D683D3D3D65';
wwv_flow_imp.g_varchar2_table(7317) := '2E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E2D313A303B696628683D3D3D652E656E644C696E654E756D626572297B636F6E737420613D746869732E6765744C696E65436F6E74656E742868292E737562737472696E6728';
wwv_flow_imp.g_varchar2_table(7318) := '642C652E656E64436F6C756D6E2D31293B72657475726E20733D746869732E5F66696E644D617463686573496E4C696E6528742C722C612C652E656E644C696E654E756D6265722C642C732C6F2C6E2C69292C6F7D696628733D746869732E5F66696E64';
wwv_flow_imp.g_varchar2_table(7319) := '4D617463686573496E4C696E6528742C722C746869732E6765744C696E65436F6E74656E742868292E7375627374722864292C682C642C732C6F2C6E2C69292C733E3D692972657475726E206F3B682B2B2C613D746869732E6E6F646541743228682C31';
wwv_flow_imp.g_varchar2_table(7320) := '292C753D612E6E6F64652C633D746869732E706F736974696F6E496E42756666657228612E6E6F64652C612E72656D61696E646572297D696628683D3D3D652E656E644C696E654E756D626572297B636F6E737420613D683D3D3D652E73746172744C69';
wwv_flow_imp.g_varchar2_table(7321) := '6E654E756D6265723F652E7374617274436F6C756D6E2D313A302C6C3D746869732E6765744C696E65436F6E74656E742868292E737562737472696E6728612C652E656E64436F6C756D6E2D31293B72657475726E20733D746869732E5F66696E644D61';
wwv_flow_imp.g_varchar2_table(7322) := '7463686573496E4C696E6528742C722C6C2C652E656E644C696E654E756D6265722C612C732C6F2C6E2C69292C6F7D636F6E737420703D683D3D3D652E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E3A313B72657475726E20';
wwv_flow_imp.g_varchar2_table(7323) := '733D746869732E66696E644D617463686573496E4E6F6465286C2E6E6F64652C722C682C702C632C642C742C6E2C692C732C6F292C6F7D5F66696E644D617463686573496E4C696E6528652C742C6E2C692C6F2C732C722C612C6C297B636F6E73742063';
wwv_flow_imp.g_varchar2_table(7324) := '3D652E776F7264536570617261746F72733B69662821612626652E73696D706C65536561726368297B636F6E737420743D652E73696D706C655365617263682C613D742E6C656E6774682C643D6E2E6C656E6774683B6C657420683D2D613B666F72283B';
wwv_flow_imp.g_varchar2_table(7325) := '2D31213D3D28683D6E2E696E6465784F6628742C682B6129293B296966282821637C7C747728632C6E2C642C682C612929262628725B732B2B5D3D6E6577204468286E657720726828692C682B312B6F2C692C682B312B612B6F292C6E756C6C292C733E';
wwv_flow_imp.g_varchar2_table(7326) := '3D6C292972657475726E20733B72657475726E20737D6C657420643B742E72657365742830293B646F7B696628643D742E6E657874286E292C64262628725B732B2B5D3D5879286E657720726828692C642E696E6465782B312B6F2C692C642E696E6465';
wwv_flow_imp.g_varchar2_table(7327) := '782B312B645B305D2E6C656E6774682B6F292C642C61292C733E3D6C292972657475726E20737D7768696C652864293B72657475726E20737D696E7365727428652C742C6E3D2131297B696628746869732E5F454F4C4E6F726D616C697A65643D746869';
wwv_flow_imp.g_varchar2_table(7328) := '732E5F454F4C4E6F726D616C697A656426266E2C746869732E5F6C617374566973697465644C696E652E6C696E654E756D6265723D302C746869732E5F6C617374566973697465644C696E652E76616C75653D22222C746869732E726F6F74213D3D4179';
wwv_flow_imp.g_varchar2_table(7329) := '297B636F6E73747B6E6F64653A6E2C72656D61696E6465723A692C6E6F646553746172744F66667365743A6F7D3D746869732E6E6F646541742865292C733D6E2E70696563652C723D732E627566666572496E6465782C613D746869732E706F73697469';
wwv_flow_imp.g_varchar2_table(7330) := '6F6E496E427566666572286E2C69293B696628303D3D3D6E2E70696563652E627566666572496E6465782626732E656E642E6C696E653D3D3D746869732E5F6C6173744368616E6765427566666572506F732E6C696E652626732E656E642E636F6C756D';
wwv_flow_imp.g_varchar2_table(7331) := '6E3D3D3D746869732E5F6C6173744368616E6765427566666572506F732E636F6C756D6E26266F2B732E6C656E6774683D3D3D652626742E6C656E6774683C69772972657475726E20746869732E617070656E64546F4E6F6465286E2C74292C766F6964';
wwv_flow_imp.g_varchar2_table(7332) := '20746869732E636F6D707574654275666665724D6574616461746128293B6966286F3D3D3D6529746869732E696E73657274436F6E74656E74546F4E6F64654C65667428742C6E292C746869732E5F73656172636843616368652E76616C696461746528';
wwv_flow_imp.g_varchar2_table(7333) := '65293B656C7365206966286F2B6E2E70696563652E6C656E6774683E65297B636F6E737420653D5B5D3B6C6574206F3D6E657720617728732E627566666572496E6465782C612C732E656E642C746869732E6765744C696E6546656564436E7428732E62';
wwv_flow_imp.g_varchar2_table(7334) := '7566666572496E6465782C612C732E656E64292C746869732E6F6666736574496E42756666657228722C732E656E64292D746869732E6F6666736574496E42756666657228722C6129293B696628746869732E73686F756C64436865636B43524C462829';
wwv_flow_imp.g_varchar2_table(7335) := '2626746869732E656E64576974684352287429262631303D3D3D746869732E6E6F646543686172436F64654174286E2C6929297B636F6E737420653D7B6C696E653A6F2E73746172742E6C696E652B312C636F6C756D6E3A307D3B6F3D6E657720617728';
wwv_flow_imp.g_varchar2_table(7336) := '6F2E627566666572496E6465782C652C6F2E656E642C746869732E6765744C696E6546656564436E74286F2E627566666572496E6465782C652C6F2E656E64292C6F2E6C656E6774682D31292C742B3D225C6E227D696628746869732E73686F756C6443';
wwv_flow_imp.g_varchar2_table(7337) := '6865636B43524C4628292626746869732E7374617274576974684C462874292969662831333D3D3D746869732E6E6F646543686172436F64654174286E2C692D3129297B636F6E7374206F3D746869732E706F736974696F6E496E427566666572286E2C';
wwv_flow_imp.g_varchar2_table(7338) := '692D31293B746869732E64656C6574654E6F64655461696C286E2C6F292C743D225C72222B742C303D3D3D6E2E70696563652E6C656E6774682626652E70757368286E297D656C736520746869732E64656C6574654E6F64655461696C286E2C61293B65';
wwv_flow_imp.g_varchar2_table(7339) := '6C736520746869732E64656C6574654E6F64655461696C286E2C61293B636F6E7374206C3D746869732E6372656174654E65775069656365732874293B6F2E6C656E6774683E302626746869732E7262496E736572745269676874286E2C6F293B6C6574';
wwv_flow_imp.g_varchar2_table(7340) := '20633D6E3B666F72286C657420653D303B653C6C2E6C656E6774683B652B2B29633D746869732E7262496E73657274526967687428632C6C5B655D293B746869732E64656C6574654E6F6465732865297D656C736520746869732E696E73657274436F6E';
wwv_flow_imp.g_varchar2_table(7341) := '74656E74546F4E6F6465526967687428742C6E297D656C73657B636F6E737420653D746869732E6372656174654E65775069656365732874293B6C6574206E3D746869732E7262496E736572744C656674286E756C6C2C655B305D293B666F72286C6574';
wwv_flow_imp.g_varchar2_table(7342) := '20743D313B743C652E6C656E6774683B742B2B296E3D746869732E7262496E736572745269676874286E2C655B745D297D746869732E636F6D707574654275666665724D6574616461746128297D64656C65746528652C74297B696628746869732E5F6C';
wwv_flow_imp.g_varchar2_table(7343) := '617374566973697465644C696E652E6C696E654E756D6265723D302C746869732E5F6C617374566973697465644C696E652E76616C75653D22222C743C3D307C7C746869732E726F6F743D3D3D41792972657475726E3B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(7344) := '6E6F646541742865292C693D746869732E6E6F6465417428652B74292C6F3D6E2E6E6F64652C733D692E6E6F64653B6966286F3D3D3D73297B636F6E737420733D746869732E706F736974696F6E496E427566666572286F2C6E2E72656D61696E646572';
wwv_flow_imp.g_varchar2_table(7345) := '292C723D746869732E706F736974696F6E496E427566666572286F2C692E72656D61696E646572293B6966286E2E6E6F646553746172744F66667365743D3D3D65297B696628743D3D3D6F2E70696563652E6C656E677468297B636F6E737420653D6F2E';
wwv_flow_imp.g_varchar2_table(7346) := '6E65787428293B72657475726E207A7928746869732C6F292C746869732E76616C696461746543524C4657697468507265764E6F64652865292C766F696420746869732E636F6D707574654275666665724D6574616461746128297D72657475726E2074';
wwv_flow_imp.g_varchar2_table(7347) := '6869732E64656C6574654E6F646548656164286F2C72292C746869732E5F73656172636843616368652E76616C69646174652865292C746869732E76616C696461746543524C4657697468507265764E6F6465286F292C766F696420746869732E636F6D';
wwv_flow_imp.g_varchar2_table(7348) := '707574654275666665724D6574616461746128297D72657475726E206E2E6E6F646553746172744F66667365742B6F2E70696563652E6C656E6774683D3D3D652B743F28746869732E64656C6574654E6F64655461696C286F2C73292C746869732E7661';
wwv_flow_imp.g_varchar2_table(7349) := '6C696461746543524C46576974684E6578744E6F6465286F292C766F696420746869732E636F6D707574654275666665724D657461646174612829293A28746869732E736872696E6B4E6F6465286F2C732C72292C766F696420746869732E636F6D7075';
wwv_flow_imp.g_varchar2_table(7350) := '74654275666665724D657461646174612829297D636F6E737420723D5B5D2C613D746869732E706F736974696F6E496E427566666572286F2C6E2E72656D61696E646572293B746869732E64656C6574654E6F64655461696C286F2C61292C746869732E';
wwv_flow_imp.g_varchar2_table(7351) := '5F73656172636843616368652E76616C69646174652865292C303D3D3D6F2E70696563652E6C656E6774682626722E70757368286F293B636F6E7374206C3D746869732E706F736974696F6E496E42756666657228732C692E72656D61696E646572293B';
wwv_flow_imp.g_varchar2_table(7352) := '746869732E64656C6574654E6F64654865616428732C6C292C303D3D3D732E70696563652E6C656E6774682626722E707573682873293B666F72286C657420653D6F2E6E65787428293B65213D3D4179262665213D3D733B653D652E6E65787428292972';
wwv_flow_imp.g_varchar2_table(7353) := '2E707573682865293B636F6E737420633D303D3D3D6F2E70696563652E6C656E6774683F6F2E7072657628293A6F3B746869732E64656C6574654E6F6465732872292C746869732E76616C696461746543524C46576974684E6578744E6F64652863292C';
wwv_flow_imp.g_varchar2_table(7354) := '746869732E636F6D707574654275666665724D6574616461746128297D696E73657274436F6E74656E74546F4E6F64654C65667428652C74297B636F6E7374206E3D5B5D3B696628746869732E73686F756C64436865636B43524C462829262674686973';
wwv_flow_imp.g_varchar2_table(7355) := '2E656E645769746843522865292626746869732E7374617274576974684C46287429297B636F6E737420693D742E70696563652C6F3D7B6C696E653A692E73746172742E6C696E652B312C636F6C756D6E3A307D2C733D6E657720617728692E62756666';
wwv_flow_imp.g_varchar2_table(7356) := '6572496E6465782C6F2C692E656E642C746869732E6765744C696E6546656564436E7428692E627566666572496E6465782C6F2C692E656E64292C692E6C656E6774682D31293B742E70696563653D732C652B3D225C6E222C577928746869732C742C2D';
wwv_flow_imp.g_varchar2_table(7357) := '312C2D31292C303D3D3D742E70696563652E6C656E67746826266E2E707573682874297D636F6E737420693D746869732E6372656174654E65775069656365732865293B6C6574206F3D746869732E7262496E736572744C65667428742C695B692E6C65';
wwv_flow_imp.g_varchar2_table(7358) := '6E6774682D315D293B666F72286C657420653D692E6C656E6774682D323B653E3D303B652D2D296F3D746869732E7262496E736572744C656674286F2C695B655D293B746869732E76616C696461746543524C4657697468507265764E6F6465286F292C';
wwv_flow_imp.g_varchar2_table(7359) := '746869732E64656C6574654E6F646573286E297D696E73657274436F6E74656E74546F4E6F6465526967687428652C74297B746869732E61646A757374436172726961676552657475726E46726F6D4E65787428652C7429262628652B3D225C6E22293B';
wwv_flow_imp.g_varchar2_table(7360) := '636F6E7374206E3D746869732E6372656174654E65775069656365732865292C693D746869732E7262496E73657274526967687428742C6E5B305D293B6C6574206F3D693B666F72286C657420653D313B653C6E2E6C656E6774683B652B2B296F3D7468';
wwv_flow_imp.g_varchar2_table(7361) := '69732E7262496E736572745269676874286F2C6E5B655D293B746869732E76616C696461746543524C4657697468507265764E6F64652869297D706F736974696F6E496E42756666657228652C742C6E297B636F6E737420693D652E70696563652C6F3D';
wwv_flow_imp.g_varchar2_table(7362) := '652E70696563652E627566666572496E6465782C733D746869732E5F627566666572735B6F5D2E6C696E655374617274732C723D735B692E73746172742E6C696E655D2B692E73746172742E636F6C756D6E2B743B6C657420613D692E73746172742E6C';
wwv_flow_imp.g_varchar2_table(7363) := '696E652C6C3D692E656E642E6C696E652C633D302C643D302C683D303B666F72283B613C3D6C262628633D612B286C2D61292F327C302C683D735B635D2C63213D3D6C293B29696628643D735B632B315D2C723C68296C3D632D313B656C73657B696628';
wwv_flow_imp.g_varchar2_table(7364) := '2128723E3D642929627265616B3B613D632B317D72657475726E206E3F286E2E6C696E653D632C6E2E636F6C756D6E3D722D682C6E756C6C293A7B6C696E653A632C636F6C756D6E3A722D687D7D6765744C696E6546656564436E7428652C742C6E297B';
wwv_flow_imp.g_varchar2_table(7365) := '696628303D3D3D6E2E636F6C756D6E2972657475726E206E2E6C696E652D742E6C696E653B636F6E737420693D746869732E5F627566666572735B655D2E6C696E655374617274733B6966286E2E6C696E653D3D3D692E6C656E6774682D312972657475';
wwv_flow_imp.g_varchar2_table(7366) := '726E206E2E6C696E652D742E6C696E653B636F6E7374206F3D695B6E2E6C696E652B315D2C733D695B6E2E6C696E655D2B6E2E636F6C756D6E3B6966286F3E732B312972657475726E206E2E6C696E652D742E6C696E653B636F6E737420723D732D313B';
wwv_flow_imp.g_varchar2_table(7367) := '72657475726E2031333D3D3D746869732E5F627566666572735B655D2E6275666665722E63686172436F646541742872293F6E2E6C696E652D742E6C696E652B313A6E2E6C696E652D742E6C696E657D6F6666736574496E42756666657228652C74297B';
wwv_flow_imp.g_varchar2_table(7368) := '72657475726E20746869732E5F627566666572735B655D2E6C696E655374617274735B742E6C696E655D2B742E636F6C756D6E7D64656C6574654E6F6465732865297B666F72286C657420743D303B743C652E6C656E6774683B742B2B297A7928746869';
wwv_flow_imp.g_varchar2_table(7369) := '732C655B745D297D6372656174654E65775069656365732865297B696628652E6C656E6774683E6977297B636F6E737420743D5B5D3B666F72283B652E6C656E6774683E69773B297B636F6E7374206E3D652E63686172436F6465417428363535333429';
wwv_flow_imp.g_varchar2_table(7370) := '3B6C657420693B31333D3D3D6E7C7C6E3E3D353532393626266E3C3D35363331393F28693D652E737562737472696E6728302C3635353334292C653D652E737562737472696E6728363535333429293A28693D652E737562737472696E6728302C697729';
wwv_flow_imp.g_varchar2_table(7371) := '2C653D652E737562737472696E6728697729293B636F6E7374206F3D72772869293B742E70757368286E657720617728746869732E5F627566666572732E6C656E6774682C7B6C696E653A302C636F6C756D6E3A307D2C7B6C696E653A6F2E6C656E6774';
wwv_flow_imp.g_varchar2_table(7372) := '682D312C636F6C756D6E3A692E6C656E6774682D6F5B6F2E6C656E6774682D315D7D2C6F2E6C656E6774682D312C692E6C656E67746829292C746869732E5F627566666572732E70757368286E6577206C7728692C6F29297D636F6E7374206E3D727728';
wwv_flow_imp.g_varchar2_table(7373) := '65293B72657475726E20742E70757368286E657720617728746869732E5F627566666572732E6C656E6774682C7B6C696E653A302C636F6C756D6E3A307D2C7B6C696E653A6E2E6C656E6774682D312C636F6C756D6E3A652E6C656E6774682D6E5B6E2E';
wwv_flow_imp.g_varchar2_table(7374) := '6C656E6774682D315D7D2C6E2E6C656E6774682D312C652E6C656E67746829292C746869732E5F627566666572732E70757368286E6577206C7728652C6E29292C747D6C657420743D746869732E5F627566666572735B305D2E6275666665722E6C656E';
wwv_flow_imp.g_varchar2_table(7375) := '6774683B636F6E7374206E3D727728652C2131293B6C657420693D746869732E5F6C6173744368616E6765427566666572506F733B696628746869732E5F627566666572735B305D2E6C696E655374617274735B746869732E5F627566666572735B305D';
wwv_flow_imp.g_varchar2_table(7376) := '2E6C696E655374617274732E6C656E6774682D315D3D3D3D74262630213D3D742626746869732E7374617274576974684C462865292626746869732E656E6457697468435228746869732E5F627566666572735B305D2E62756666657229297B74686973';
wwv_flow_imp.g_varchar2_table(7377) := '2E5F6C6173744368616E6765427566666572506F733D7B6C696E653A746869732E5F6C6173744368616E6765427566666572506F732E6C696E652C636F6C756D6E3A746869732E5F6C6173744368616E6765427566666572506F732E636F6C756D6E2B31';
wwv_flow_imp.g_varchar2_table(7378) := '7D2C693D746869732E5F6C6173744368616E6765427566666572506F733B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B296E5B655D2B3D742B313B746869732E5F627566666572735B305D2E6C696E655374617274733D746869732E';
wwv_flow_imp.g_varchar2_table(7379) := '5F627566666572735B305D2E6C696E655374617274732E636F6E636174286E2E736C696365283129292C746869732E5F627566666572735B305D2E6275666665722B3D225F222B652C742B3D317D656C73657B69662830213D3D7429666F72286C657420';
wwv_flow_imp.g_varchar2_table(7380) := '653D303B653C6E2E6C656E6774683B652B2B296E5B655D2B3D743B746869732E5F627566666572735B305D2E6C696E655374617274733D746869732E5F627566666572735B305D2E6C696E655374617274732E636F6E636174286E2E736C696365283129';
wwv_flow_imp.g_varchar2_table(7381) := '292C746869732E5F627566666572735B305D2E6275666665722B3D657D636F6E7374206F3D746869732E5F627566666572735B305D2E6275666665722E6C656E6774682C733D746869732E5F627566666572735B305D2E6C696E655374617274732E6C65';
wwv_flow_imp.g_varchar2_table(7382) := '6E6774682D312C723D7B6C696E653A732C636F6C756D6E3A6F2D746869732E5F627566666572735B305D2E6C696E655374617274735B735D7D2C613D6E657720617728302C692C722C746869732E6765744C696E6546656564436E7428302C692C72292C';
wwv_flow_imp.g_varchar2_table(7383) := '6F2D74293B72657475726E20746869732E5F6C6173744368616E6765427566666572506F733D722C5B615D7D6765744C696E65526177436F6E74656E7428652C743D30297B6C6574206E3D746869732E726F6F742C693D22223B636F6E7374206F3D7468';
wwv_flow_imp.g_varchar2_table(7384) := '69732E5F73656172636843616368652E676574322865293B6966286F297B6E3D6F2E6E6F64653B636F6E737420733D746869732E676574416363756D756C6174656456616C7565286E2C652D6F2E6E6F646553746172744C696E654E756D6265722D3129';
wwv_flow_imp.g_varchar2_table(7385) := '2C723D746869732E5F627566666572735B6E2E70696563652E627566666572496E6465785D2E6275666665722C613D746869732E6F6666736574496E427566666572286E2E70696563652E627566666572496E6465782C6E2E70696563652E7374617274';
wwv_flow_imp.g_varchar2_table(7386) := '293B6966286F2E6E6F646553746172744C696E654E756D6265722B6E2E70696563652E6C696E6546656564436E74213D3D65297B636F6E737420693D746869732E676574416363756D756C6174656456616C7565286E2C652D6F2E6E6F64655374617274';
wwv_flow_imp.g_varchar2_table(7387) := '4C696E654E756D626572293B72657475726E20722E737562737472696E6728612B732C612B692D74297D693D722E737562737472696E6728612B732C612B6E2E70696563652E6C656E677468297D656C73657B6C6574206F3D303B636F6E737420733D65';
wwv_flow_imp.g_varchar2_table(7388) := '3B666F72283B6E213D3D41793B296966286E2E6C656674213D3D417926266E2E6C665F6C6566743E3D652D31296E3D6E2E6C6566743B656C73657B6966286E2E6C665F6C6566742B6E2E70696563652E6C696E6546656564436E743E652D31297B636F6E';
wwv_flow_imp.g_varchar2_table(7389) := '737420693D746869732E676574416363756D756C6174656456616C7565286E2C652D6E2E6C665F6C6566742D32292C723D746869732E676574416363756D756C6174656456616C7565286E2C652D6E2E6C665F6C6566742D31292C613D746869732E5F62';
wwv_flow_imp.g_varchar2_table(7390) := '7566666572735B6E2E70696563652E627566666572496E6465785D2E6275666665722C6C3D746869732E6F6666736574496E427566666572286E2E70696563652E627566666572496E6465782C6E2E70696563652E7374617274293B72657475726E206F';
wwv_flow_imp.g_varchar2_table(7391) := '2B3D6E2E73697A655F6C6566742C746869732E5F73656172636843616368652E736574287B6E6F64653A6E2C6E6F646553746172744F66667365743A6F2C6E6F646553746172744C696E654E756D6265723A732D28652D312D6E2E6C665F6C656674297D';
wwv_flow_imp.g_varchar2_table(7392) := '292C612E737562737472696E67286C2B692C6C2B722D74297D6966286E2E6C665F6C6566742B6E2E70696563652E6C696E6546656564436E743D3D3D652D31297B636F6E737420743D746869732E676574416363756D756C6174656456616C7565286E2C';
wwv_flow_imp.g_varchar2_table(7393) := '652D6E2E6C665F6C6566742D32292C6F3D746869732E5F627566666572735B6E2E70696563652E627566666572496E6465785D2E6275666665722C733D746869732E6F6666736574496E427566666572286E2E70696563652E627566666572496E646578';
wwv_flow_imp.g_varchar2_table(7394) := '2C6E2E70696563652E7374617274293B693D6F2E737562737472696E6728732B742C732B6E2E70696563652E6C656E677468293B627265616B7D652D3D6E2E6C665F6C6566742B6E2E70696563652E6C696E6546656564436E742C6F2B3D6E2E73697A65';
wwv_flow_imp.g_varchar2_table(7395) := '5F6C6566742B6E2E70696563652E6C656E6774682C6E3D6E2E72696768747D7D666F72286E3D6E2E6E65787428293B6E213D3D41793B297B636F6E737420653D746869732E5F627566666572735B6E2E70696563652E627566666572496E6465785D2E62';
wwv_flow_imp.g_varchar2_table(7396) := '75666665723B6966286E2E70696563652E6C696E6546656564436E743E30297B636F6E7374206F3D746869732E676574416363756D756C6174656456616C7565286E2C30292C733D746869732E6F6666736574496E427566666572286E2E70696563652E';
wwv_flow_imp.g_varchar2_table(7397) := '627566666572496E6465782C6E2E70696563652E7374617274293B72657475726E20692B3D652E737562737472696E6728732C732B6F2D74292C697D7B636F6E737420743D746869732E6F6666736574496E427566666572286E2E70696563652E627566';
wwv_flow_imp.g_varchar2_table(7398) := '666572496E6465782C6E2E70696563652E7374617274293B692B3D652E73756273747228742C6E2E70696563652E6C656E677468297D6E3D6E2E6E65787428297D72657475726E20697D636F6D707574654275666665724D6574616461746128297B6C65';
wwv_flow_imp.g_varchar2_table(7399) := '7420653D746869732E726F6F742C743D312C6E3D303B666F72283B65213D3D41793B29742B3D652E6C665F6C6566742B652E70696563652E6C696E6546656564436E742C6E2B3D652E73697A655F6C6566742B652E70696563652E6C656E6774682C653D';
wwv_flow_imp.g_varchar2_table(7400) := '652E72696768743B746869732E5F6C696E65436E743D742C746869732E5F6C656E6774683D6E2C746869732E5F73656172636843616368652E76616C696461746528746869732E5F6C656E677468297D676574496E6465784F6628652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(7401) := '74206E3D652E70696563652C693D746869732E706F736974696F6E496E42756666657228652C74292C6F3D692E6C696E652D6E2E73746172742E6C696E653B696628746869732E6F6666736574496E427566666572286E2E627566666572496E6465782C';
wwv_flow_imp.g_varchar2_table(7402) := '6E2E656E64292D746869732E6F6666736574496E427566666572286E2E627566666572496E6465782C6E2E7374617274293D3D3D74297B636F6E737420743D746869732E6765744C696E6546656564436E7428652E70696563652E627566666572496E64';
wwv_flow_imp.g_varchar2_table(7403) := '65782C6E2E73746172742C69293B69662874213D3D6F2972657475726E7B696E6465783A742C72656D61696E6465723A307D7D72657475726E7B696E6465783A6F2C72656D61696E6465723A692E636F6C756D6E7D7D676574416363756D756C61746564';
wwv_flow_imp.g_varchar2_table(7404) := '56616C756528652C74297B696628743C302972657475726E20303B636F6E7374206E3D652E70696563652C693D746869732E5F627566666572735B6E2E627566666572496E6465785D2E6C696E655374617274732C6F3D6E2E73746172742E6C696E652B';
wwv_flow_imp.g_varchar2_table(7405) := '742B313B72657475726E206F3E6E2E656E642E6C696E653F695B6E2E656E642E6C696E655D2B6E2E656E642E636F6C756D6E2D695B6E2E73746172742E6C696E655D2D6E2E73746172742E636F6C756D6E3A695B6F5D2D695B6E2E73746172742E6C696E';
wwv_flow_imp.g_varchar2_table(7406) := '655D2D6E2E73746172742E636F6C756D6E7D64656C6574654E6F64655461696C28652C74297B636F6E7374206E3D652E70696563652C693D6E2E6C696E6546656564436E742C6F3D746869732E6F6666736574496E427566666572286E2E627566666572';
wwv_flow_imp.g_varchar2_table(7407) := '496E6465782C6E2E656E64292C733D742C723D746869732E6F6666736574496E427566666572286E2E627566666572496E6465782C73292C613D746869732E6765744C696E6546656564436E74286E2E627566666572496E6465782C6E2E73746172742C';
wwv_flow_imp.g_varchar2_table(7408) := '73292C6C3D612D692C633D722D6F2C643D6E2E6C656E6774682B633B652E70696563653D6E6577206177286E2E627566666572496E6465782C6E2E73746172742C732C612C64292C577928746869732C652C632C6C297D64656C6574654E6F6465486561';
wwv_flow_imp.g_varchar2_table(7409) := '6428652C74297B636F6E7374206E3D652E70696563652C693D6E2E6C696E6546656564436E742C6F3D746869732E6F6666736574496E427566666572286E2E627566666572496E6465782C6E2E7374617274292C733D742C723D746869732E6765744C69';
wwv_flow_imp.g_varchar2_table(7410) := '6E6546656564436E74286E2E627566666572496E6465782C732C6E2E656E64292C613D722D692C6C3D6F2D746869732E6F6666736574496E427566666572286E2E627566666572496E6465782C73292C633D6E2E6C656E6774682B6C3B652E7069656365';
wwv_flow_imp.g_varchar2_table(7411) := '3D6E6577206177286E2E627566666572496E6465782C732C6E2E656E642C722C63292C577928746869732C652C6C2C61297D736872696E6B4E6F646528652C742C6E297B636F6E737420693D652E70696563652C6F3D692E73746172742C733D692E656E';
wwv_flow_imp.g_varchar2_table(7412) := '642C723D692E6C656E6774682C613D692E6C696E6546656564436E742C6C3D742C633D746869732E6765744C696E6546656564436E7428692E627566666572496E6465782C692E73746172742C6C292C643D746869732E6F6666736574496E4275666665';
wwv_flow_imp.g_varchar2_table(7413) := '7228692E627566666572496E6465782C74292D746869732E6F6666736574496E42756666657228692E627566666572496E6465782C6F293B652E70696563653D6E657720617728692E627566666572496E6465782C692E73746172742C6C2C632C64292C';
wwv_flow_imp.g_varchar2_table(7414) := '577928746869732C652C642D722C632D61293B636F6E737420683D6E657720617728692E627566666572496E6465782C6E2C732C746869732E6765744C696E6546656564436E7428692E627566666572496E6465782C6E2C73292C746869732E6F666673';
wwv_flow_imp.g_varchar2_table(7415) := '6574496E42756666657228692E627566666572496E6465782C73292D746869732E6F6666736574496E42756666657228692E627566666572496E6465782C6E29292C753D746869732E7262496E73657274526967687428652C68293B746869732E76616C';
wwv_flow_imp.g_varchar2_table(7416) := '696461746543524C4657697468507265764E6F64652875297D617070656E64546F4E6F646528652C74297B746869732E61646A757374436172726961676552657475726E46726F6D4E65787428742C6529262628742B3D225C6E22293B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(7417) := '3D746869732E73686F756C64436865636B43524C4628292626746869732E7374617274576974684C462874292626746869732E656E645769746843522865292C693D746869732E5F627566666572735B305D2E6275666665722E6C656E6774683B746869';
wwv_flow_imp.g_varchar2_table(7418) := '732E5F627566666572735B305D2E6275666665722B3D743B636F6E7374206F3D727728742C2131293B666F72286C657420653D303B653C6F2E6C656E6774683B652B2B296F5B655D2B3D693B6966286E297B636F6E737420653D746869732E5F62756666';
wwv_flow_imp.g_varchar2_table(7419) := '6572735B305D2E6C696E655374617274735B746869732E5F627566666572735B305D2E6C696E655374617274732E6C656E6774682D325D3B746869732E5F627566666572735B305D2E6C696E655374617274732E706F7028292C746869732E5F6C617374';
wwv_flow_imp.g_varchar2_table(7420) := '4368616E6765427566666572506F733D7B6C696E653A746869732E5F6C6173744368616E6765427566666572506F732E6C696E652D312C636F6C756D6E3A692D657D7D746869732E5F627566666572735B305D2E6C696E655374617274733D746869732E';
wwv_flow_imp.g_varchar2_table(7421) := '5F627566666572735B305D2E6C696E655374617274732E636F6E636174286F2E736C696365283129293B636F6E737420733D746869732E5F627566666572735B305D2E6C696E655374617274732E6C656E6774682D312C723D7B6C696E653A732C636F6C';
wwv_flow_imp.g_varchar2_table(7422) := '756D6E3A746869732E5F627566666572735B305D2E6275666665722E6C656E6774682D746869732E5F627566666572735B305D2E6C696E655374617274735B735D7D2C613D652E70696563652E6C656E6774682B742E6C656E6774682C6C3D652E706965';
wwv_flow_imp.g_varchar2_table(7423) := '63652E6C696E6546656564436E742C633D746869732E6765744C696E6546656564436E7428302C652E70696563652E73746172742C72292C643D632D6C3B652E70696563653D6E657720617728652E70696563652E627566666572496E6465782C652E70';
wwv_flow_imp.g_varchar2_table(7424) := '696563652E73746172742C722C632C61292C746869732E5F6C6173744368616E6765427566666572506F733D722C577928746869732C652C742E6C656E6774682C64297D6E6F646541742865297B6C657420743D746869732E726F6F743B636F6E737420';
wwv_flow_imp.g_varchar2_table(7425) := '6E3D746869732E5F73656172636843616368652E6765742865293B6966286E2972657475726E7B6E6F64653A6E2E6E6F64652C6E6F646553746172744F66667365743A6E2E6E6F646553746172744F66667365742C72656D61696E6465723A652D6E2E6E';
wwv_flow_imp.g_varchar2_table(7426) := '6F646553746172744F66667365747D3B6C657420693D303B666F72283B74213D3D41793B29696628742E73697A655F6C6566743E6529743D742E6C6566743B656C73657B696628742E73697A655F6C6566742B742E70696563652E6C656E6774683E3D65';
wwv_flow_imp.g_varchar2_table(7427) := '297B692B3D742E73697A655F6C6566743B636F6E7374206E3D7B6E6F64653A742C72656D61696E6465723A652D742E73697A655F6C6566742C6E6F646553746172744F66667365743A697D3B72657475726E20746869732E5F7365617263684361636865';
wwv_flow_imp.g_varchar2_table(7428) := '2E736574286E292C6E7D652D3D742E73697A655F6C6566742B742E70696563652E6C656E6774682C692B3D742E73697A655F6C6566742B742E70696563652E6C656E6774682C743D742E72696768747D72657475726E206E756C6C7D6E6F646541743228';
wwv_flow_imp.g_varchar2_table(7429) := '652C74297B6C6574206E3D746869732E726F6F742C693D303B666F72283B6E213D3D41793B296966286E2E6C656674213D3D417926266E2E6C665F6C6566743E3D652D31296E3D6E2E6C6566743B656C73657B6966286E2E6C665F6C6566742B6E2E7069';
wwv_flow_imp.g_varchar2_table(7430) := '6563652E6C696E6546656564436E743E652D31297B636F6E7374206F3D746869732E676574416363756D756C6174656456616C7565286E2C652D6E2E6C665F6C6566742D32292C733D746869732E676574416363756D756C6174656456616C7565286E2C';
wwv_flow_imp.g_varchar2_table(7431) := '652D6E2E6C665F6C6566742D31293B72657475726E20692B3D6E2E73697A655F6C6566742C7B6E6F64653A6E2C72656D61696E6465723A4D6174682E6D696E286F2B742D312C73292C6E6F646553746172744F66667365743A697D7D6966286E2E6C665F';
wwv_flow_imp.g_varchar2_table(7432) := '6C6566742B6E2E70696563652E6C696E6546656564436E743D3D3D652D31297B636F6E7374206F3D746869732E676574416363756D756C6174656456616C7565286E2C652D6E2E6C665F6C6566742D32293B6966286F2B742D313C3D6E2E70696563652E';
wwv_flow_imp.g_varchar2_table(7433) := '6C656E6774682972657475726E7B6E6F64653A6E2C72656D61696E6465723A6F2B742D312C6E6F646553746172744F66667365743A697D3B742D3D6E2E70696563652E6C656E6774682D6F3B627265616B7D652D3D6E2E6C665F6C6566742B6E2E706965';
wwv_flow_imp.g_varchar2_table(7434) := '63652E6C696E6546656564436E742C692B3D6E2E73697A655F6C6566742B6E2E70696563652E6C656E6774682C6E3D6E2E72696768747D666F72286E3D6E2E6E65787428293B6E213D3D41793B297B6966286E2E70696563652E6C696E6546656564436E';
wwv_flow_imp.g_varchar2_table(7435) := '743E30297B636F6E737420653D746869732E676574416363756D756C6174656456616C7565286E2C30292C693D746869732E6F66667365744F664E6F6465286E293B72657475726E7B6E6F64653A6E2C72656D61696E6465723A4D6174682E6D696E2874';
wwv_flow_imp.g_varchar2_table(7436) := '2D312C65292C6E6F646553746172744F66667365743A697D7D6966286E2E70696563652E6C656E6774683E3D742D312972657475726E7B6E6F64653A6E2C72656D61696E6465723A742D312C6E6F646553746172744F66667365743A746869732E6F6666';
wwv_flow_imp.g_varchar2_table(7437) := '7365744F664E6F6465286E297D3B742D3D6E2E70696563652E6C656E6774682C6E3D6E2E6E65787428297D72657475726E206E756C6C7D6E6F646543686172436F6465417428652C74297B696628652E70696563652E6C696E6546656564436E743C3129';
wwv_flow_imp.g_varchar2_table(7438) := '72657475726E2D313B636F6E7374206E3D746869732E5F627566666572735B652E70696563652E627566666572496E6465785D2C693D746869732E6F6666736574496E42756666657228652E70696563652E627566666572496E6465782C652E70696563';
wwv_flow_imp.g_varchar2_table(7439) := '652E7374617274292B743B72657475726E206E2E6275666665722E63686172436F646541742869297D6F66667365744F664E6F64652865297B69662821652972657475726E20303B6C657420743D652E73697A655F6C6566743B666F72283B65213D3D74';
wwv_flow_imp.g_varchar2_table(7440) := '6869732E726F6F743B29652E706172656E742E72696768743D3D3D65262628742B3D652E706172656E742E73697A655F6C6566742B652E706172656E742E70696563652E6C656E677468292C653D652E706172656E743B72657475726E20747D73686F75';
wwv_flow_imp.g_varchar2_table(7441) := '6C64436865636B43524C4628297B72657475726E2128746869732E5F454F4C4E6F726D616C697A65642626225C6E223D3D3D746869732E5F454F4C297D7374617274576974684C462865297B69662822737472696E67223D3D747970656F662065297265';
wwv_flow_imp.g_varchar2_table(7442) := '7475726E2031303D3D3D652E63686172436F646541742830293B696628653D3D3D41797C7C303D3D3D652E70696563652E6C696E6546656564436E742972657475726E21313B636F6E737420743D652E70696563652C6E3D746869732E5F627566666572';
wwv_flow_imp.g_varchar2_table(7443) := '735B742E627566666572496E6465785D2E6C696E655374617274732C693D742E73746172742E6C696E652C6F3D6E5B695D2B742E73746172742E636F6C756D6E3B72657475726E2069213D3D6E2E6C656E6774682D3126262821286E5B692B315D3E6F2B';
wwv_flow_imp.g_varchar2_table(7444) := '3129262631303D3D3D746869732E5F627566666572735B742E627566666572496E6465785D2E6275666665722E63686172436F64654174286F29297D656E645769746843522865297B72657475726E22737472696E67223D3D747970656F6620653F3133';
wwv_flow_imp.g_varchar2_table(7445) := '3D3D3D652E63686172436F6465417428652E6C656E6774682D31293A65213D3D4179262630213D3D652E70696563652E6C696E6546656564436E74262631333D3D3D746869732E6E6F646543686172436F6465417428652C652E70696563652E6C656E67';
wwv_flow_imp.g_varchar2_table(7446) := '74682D31297D76616C696461746543524C4657697468507265764E6F64652865297B696628746869732E73686F756C64436865636B43524C4628292626746869732E7374617274576974684C46286529297B636F6E737420743D652E7072657628293B74';
wwv_flow_imp.g_varchar2_table(7447) := '6869732E656E645769746843522874292626746869732E66697843524C4628742C65297D7D76616C696461746543524C46576974684E6578744E6F64652865297B696628746869732E73686F756C64436865636B43524C4628292626746869732E656E64';
wwv_flow_imp.g_varchar2_table(7448) := '576974684352286529297B636F6E737420743D652E6E65787428293B746869732E7374617274576974684C462874292626746869732E66697843524C4628652C74297D7D66697843524C4628652C74297B636F6E7374206E3D5B5D2C693D746869732E5F';
wwv_flow_imp.g_varchar2_table(7449) := '627566666572735B652E70696563652E627566666572496E6465785D2E6C696E655374617274733B6C6574206F3B6F3D303D3D3D652E70696563652E656E642E636F6C756D6E3F7B6C696E653A652E70696563652E656E642E6C696E652D312C636F6C75';
wwv_flow_imp.g_varchar2_table(7450) := '6D6E3A695B652E70696563652E656E642E6C696E655D2D695B652E70696563652E656E642E6C696E652D315D2D317D3A7B6C696E653A652E70696563652E656E642E6C696E652C636F6C756D6E3A652E70696563652E656E642E636F6C756D6E2D317D3B';
wwv_flow_imp.g_varchar2_table(7451) := '636F6E737420733D652E70696563652E6C656E6774682D312C723D652E70696563652E6C696E6546656564436E742D313B652E70696563653D6E657720617728652E70696563652E627566666572496E6465782C652E70696563652E73746172742C6F2C';
wwv_flow_imp.g_varchar2_table(7452) := '722C73292C577928746869732C652C2D312C2D31292C303D3D3D652E70696563652E6C656E67746826266E2E707573682865293B636F6E737420613D7B6C696E653A742E70696563652E73746172742E6C696E652B312C636F6C756D6E3A307D2C6C3D74';
wwv_flow_imp.g_varchar2_table(7453) := '2E70696563652E6C656E6774682D312C633D746869732E6765744C696E6546656564436E7428742E70696563652E627566666572496E6465782C612C742E70696563652E656E64293B742E70696563653D6E657720617728742E70696563652E62756666';
wwv_flow_imp.g_varchar2_table(7454) := '6572496E6465782C612C742E70696563652E656E642C632C6C292C577928746869732C742C2D312C2D31292C303D3D3D742E70696563652E6C656E67746826266E2E707573682874293B636F6E737420643D746869732E6372656174654E657750696563';
wwv_flow_imp.g_varchar2_table(7455) := '657328225C725C6E22293B746869732E7262496E73657274526967687428652C645B305D293B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B297A7928746869732C6E5B655D297D61646A757374436172726961676552657475726E46';
wwv_flow_imp.g_varchar2_table(7456) := '726F6D4E65787428652C74297B696628746869732E73686F756C64436865636B43524C4628292626746869732E656E64576974684352286529297B636F6E7374206E3D742E6E65787428293B696628746869732E7374617274576974684C46286E29297B';
wwv_flow_imp.g_varchar2_table(7457) := '696628652B3D225C6E222C313D3D3D6E2E70696563652E6C656E677468297A7928746869732C6E293B656C73657B636F6E737420653D6E2E70696563652C743D7B6C696E653A652E73746172742E6C696E652B312C636F6C756D6E3A307D2C693D652E6C';
wwv_flow_imp.g_varchar2_table(7458) := '656E6774682D312C6F3D746869732E6765744C696E6546656564436E7428652E627566666572496E6465782C742C652E656E64293B6E2E70696563653D6E657720617728652E627566666572496E6465782C742C652E656E642C6F2C69292C5779287468';
wwv_flow_imp.g_varchar2_table(7459) := '69732C6E2C2D312C2D31297D72657475726E21307D7D72657475726E21317D6974657261746528652C74297B696628653D3D3D41792972657475726E2074284179293B636F6E7374206E3D746869732E6974657261746528652E6C6566742C74293B7265';
wwv_flow_imp.g_varchar2_table(7460) := '7475726E206E3F742865292626746869732E6974657261746528652E72696768742C74293A6E7D6765744E6F6465436F6E74656E742865297B696628653D3D3D41792972657475726E22223B636F6E737420743D746869732E5F627566666572735B652E';
wwv_flow_imp.g_varchar2_table(7461) := '70696563652E627566666572496E6465785D2C6E3D652E70696563652C693D746869732E6F6666736574496E427566666572286E2E627566666572496E6465782C6E2E7374617274292C6F3D746869732E6F6666736574496E427566666572286E2E6275';
wwv_flow_imp.g_varchar2_table(7462) := '66666572496E6465782C6E2E656E64293B72657475726E20742E6275666665722E737562737472696E6728692C6F297D6765745069656365436F6E74656E742865297B636F6E737420743D746869732E5F627566666572735B652E627566666572496E64';
wwv_flow_imp.g_varchar2_table(7463) := '65785D2C6E3D746869732E6F6666736574496E42756666657228652E627566666572496E6465782C652E7374617274292C693D746869732E6F6666736574496E42756666657228652E627566666572496E6465782C652E656E64293B72657475726E2074';
wwv_flow_imp.g_varchar2_table(7464) := '2E6275666665722E737562737472696E67286E2C69297D7262496E73657274526967687428652C74297B636F6E7374206E3D6E6577204D7928742C31293B6966286E2E6C6566743D41792C6E2E72696768743D41792C6E2E706172656E743D41792C6E2E';
wwv_flow_imp.g_varchar2_table(7465) := '73697A655F6C6566743D302C6E2E6C665F6C6566743D302C746869732E726F6F743D3D3D417929746869732E726F6F743D6E2C6E2E636F6C6F723D303B656C736520696628652E72696768743D3D3D417929652E72696768743D6E2C6E2E706172656E74';
wwv_flow_imp.g_varchar2_table(7466) := '3D653B656C73657B636F6E737420743D4E7928652E7269676874293B742E6C6566743D6E2C6E2E706172656E743D747D72657475726E20487928746869732C6E292C6E7D7262496E736572744C65667428652C74297B636F6E7374206E3D6E6577204D79';
wwv_flow_imp.g_varchar2_table(7467) := '28742C31293B6966286E2E6C6566743D41792C6E2E72696768743D41792C6E2E706172656E743D41792C6E2E73697A655F6C6566743D302C6E2E6C665F6C6566743D302C746869732E726F6F743D3D3D417929746869732E726F6F743D6E2C6E2E636F6C';
wwv_flow_imp.g_varchar2_table(7468) := '6F723D303B656C736520696628652E6C6566743D3D3D417929652E6C6566743D6E2C6E2E706172656E743D653B656C73657B636F6E737420743D507928652E6C656674293B742E72696768743D6E2C6E2E706172656E743D747D72657475726E20487928';
wwv_flow_imp.g_varchar2_table(7469) := '746869732C6E292C6E7D7D636C61737320757720657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228292C746869732E5F6F6E4469644368616E6765436F6E74656E743D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(7470) := '6973746572286E6577204374292C746869732E5F424F4D3D742C746869732E5F6D69676874436F6E7461696E4E6F6E426173696341534349493D21732C746869732E5F6D69676874436F6E7461696E52544C3D692C746869732E5F6D69676874436F6E74';
wwv_flow_imp.g_varchar2_table(7471) := '61696E556E757375616C4C696E655465726D696E61746F72733D6F2C746869732E5F7069656365547265653D6E657720687728652C6E2C72297D6D69676874436F6E7461696E52544C28297B72657475726E20746869732E5F6D69676874436F6E746169';
wwv_flow_imp.g_varchar2_table(7472) := '6E52544C7D6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F727328297B72657475726E20746869732E5F6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F72737D72657365744D69676874';
wwv_flow_imp.g_varchar2_table(7473) := '436F6E7461696E556E757375616C4C696E655465726D696E61746F727328297B746869732E5F6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F72733D21317D6D69676874436F6E7461696E4E6F6E426173696341534349';
wwv_flow_imp.g_varchar2_table(7474) := '4928297B72657475726E20746869732E5F6D69676874436F6E7461696E4E6F6E426173696341534349497D676574424F4D28297B72657475726E20746869732E5F424F4D7D676574454F4C28297B72657475726E20746869732E5F706965636554726565';
wwv_flow_imp.g_varchar2_table(7475) := '2E676574454F4C28297D637265617465536E617073686F742865297B72657475726E20746869732E5F7069656365547265652E637265617465536E617073686F7428653F746869732E5F424F4D3A2222297D6765744F6666736574417428652C74297B72';
wwv_flow_imp.g_varchar2_table(7476) := '657475726E20746869732E5F7069656365547265652E6765744F6666736574417428652C74297D676574506F736974696F6E41742865297B72657475726E20746869732E5F7069656365547265652E676574506F736974696F6E41742865297D67657452';
wwv_flow_imp.g_varchar2_table(7477) := '616E6765417428652C74297B636F6E7374206E3D652B742C693D746869732E676574506F736974696F6E41742865292C6F3D746869732E676574506F736974696F6E4174286E293B72657475726E206E657720726828692E6C696E654E756D6265722C69';
wwv_flow_imp.g_varchar2_table(7478) := '2E636F6C756D6E2C6F2E6C696E654E756D6265722C6F2E636F6C756D6E297D67657456616C7565496E52616E676528652C743D30297B696628652E6973456D70747928292972657475726E22223B636F6E7374206E3D746869732E5F676574456E644F66';
wwv_flow_imp.g_varchar2_table(7479) := '4C696E652874293B72657475726E20746869732E5F7069656365547265652E67657456616C7565496E52616E676528652C6E297D67657456616C75654C656E677468496E52616E676528652C743D30297B696628652E6973456D70747928292972657475';
wwv_flow_imp.g_varchar2_table(7480) := '726E20303B696628652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722972657475726E20652E656E64436F6C756D6E2D652E7374617274436F6C756D6E3B636F6E7374206E3D746869732E6765744F666673657441';
wwv_flow_imp.g_varchar2_table(7481) := '7428652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C693D746869732E6765744F6666736574417428652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293B6C6574206F3D303B636F6E737420733D74';
wwv_flow_imp.g_varchar2_table(7482) := '6869732E5F676574456E644F664C696E652874292C723D746869732E676574454F4C28293B72657475726E20732E6C656E677468213D3D722E6C656E6774682626286F3D28732E6C656E6774682D722E6C656E677468292A28652E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(7483) := '6D6265722D652E73746172744C696E654E756D62657229292C692D6E2B6F7D676574436861726163746572436F756E74496E52616E676528652C743D30297B696628746869732E5F6D69676874436F6E7461696E4E6F6E42617369634153434949297B6C';
wwv_flow_imp.g_varchar2_table(7484) := '6574206E3D303B636F6E737420693D652E73746172744C696E654E756D6265722C6F3D652E656E644C696E654E756D6265723B666F72286C657420743D693B743C3D6F3B742B2B297B636F6E737420733D746869732E6765744C696E65436F6E74656E74';
wwv_flow_imp.g_varchar2_table(7485) := '2874292C723D743D3D3D693F652E7374617274436F6C756D6E2D313A302C613D743D3D3D6F3F652E656E64436F6C756D6E2D313A732E6C656E6774683B666F72286C657420653D723B653C613B652B2B29546928732E63686172436F6465417428652929';
wwv_flow_imp.g_varchar2_table(7486) := '3F286E2B3D312C652B3D31293A6E2B3D317D72657475726E206E2B3D746869732E5F676574456E644F664C696E652874292E6C656E6774682A286F2D69292C6E7D72657475726E20746869732E67657456616C75654C656E677468496E52616E67652865';
wwv_flow_imp.g_varchar2_table(7487) := '2C74297D6765744C656E67746828297B72657475726E20746869732E5F7069656365547265652E6765744C656E67746828297D6765744C696E65436F756E7428297B72657475726E20746869732E5F7069656365547265652E6765744C696E65436F756E';
wwv_flow_imp.g_varchar2_table(7488) := '7428297D6765744C696E6573436F6E74656E7428297B72657475726E20746869732E5F7069656365547265652E6765744C696E6573436F6E74656E7428297D6765744C696E65436F6E74656E742865297B72657475726E20746869732E5F706965636554';
wwv_flow_imp.g_varchar2_table(7489) := '7265652E6765744C696E65436F6E74656E742865297D6765744C696E6543686172436F646528652C74297B72657475726E20746869732E5F7069656365547265652E6765744C696E6543686172436F646528652C74297D6765744C696E654C656E677468';
wwv_flow_imp.g_varchar2_table(7490) := '2865297B72657475726E20746869732E5F7069656365547265652E6765744C696E654C656E6774682865297D6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2865297B636F6E737420743D6D6928746869732E6765744C69';
wwv_flow_imp.g_varchar2_table(7491) := '6E65436F6E74656E74286529293B72657475726E2D313D3D3D743F303A742B317D6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E2865297B636F6E737420743D766928746869732E6765744C696E65436F6E74656E74286529';
wwv_flow_imp.g_varchar2_table(7492) := '293B72657475726E2D313D3D3D743F303A742B327D5F676574456E644F664C696E652865297B7377697463682865297B6361736520313A72657475726E225C6E223B6361736520323A72657475726E225C725C6E223B6361736520303A72657475726E20';
wwv_flow_imp.g_varchar2_table(7493) := '746869732E676574454F4C28293B64656661756C743A7468726F77206E6577204572726F722822556E6B6E6F776E20454F4C20707265666572656E636522297D7D736574454F4C2865297B746869732E5F7069656365547265652E736574454F4C286529';
wwv_flow_imp.g_varchar2_table(7494) := '7D6170706C79456469747328652C742C6E297B6C657420693D746869732E5F6D69676874436F6E7461696E52544C2C6F3D746869732E5F6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F72732C733D746869732E5F6D69';
wwv_flow_imp.g_varchar2_table(7495) := '676874436F6E7461696E4E6F6E426173696341534349492C723D21302C613D5B5D3B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B636F6E7374206E3D655B745D3B7226266E2E5F6973547261636B6564262628723D2131293B63';
wwv_flow_imp.g_varchar2_table(7496) := '6F6E7374206C3D6E2E72616E67653B6966286E2E74657874297B6C657420653D21303B737C7C28653D217A69286E2E74657874292C733D65292C2169262665262628693D4269286E2E7465787429292C216F2626652626286F3D5769286E2E7465787429';
wwv_flow_imp.g_varchar2_table(7497) := '297D6C657420633D22222C643D302C683D302C753D303B6966286E2E74657874297B6C657420653B5B642C682C752C655D3D7575286E2E74657874293B636F6E737420743D746869732E676574454F4C28293B633D303D3D3D657C7C653D3D3D28225C72';
wwv_flow_imp.g_varchar2_table(7498) := '5C6E223D3D3D743F323A31293F6E2E746578743A6E2E746578742E7265706C616365282F5C725C6E7C5C727C5C6E2F672C74297D615B745D3D7B736F7274496E6465783A742C6964656E7469666965723A6E2E6964656E7469666965727C7C6E756C6C2C';
wwv_flow_imp.g_varchar2_table(7499) := '72616E67653A6C2C72616E67654F66667365743A746869732E6765744F66667365744174286C2E73746172744C696E654E756D6265722C6C2E7374617274436F6C756D6E292C72616E67654C656E6774683A746869732E67657456616C75654C656E6774';
wwv_flow_imp.g_varchar2_table(7500) := '68496E52616E6765286C292C746578743A632C656F6C436F756E743A642C66697273744C696E654C656E6774683A682C6C6173744C696E654C656E6774683A752C666F7263654D6F76654D61726B6572733A426F6F6C65616E286E2E666F7263654D6F76';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(7501) := '654D61726B657273292C69734175746F57686974657370616365456469743A6E2E69734175746F57686974657370616365456469747C7C21317D7D612E736F72742875772E5F736F72744F7073417363656E64696E67293B6C6574206C3D21313B666F72';
wwv_flow_imp.g_varchar2_table(7502) := '286C657420653D302C743D612E6C656E6774682D313B653C743B652B2B297B636F6E737420743D615B655D2E72616E67652E676574456E64506F736974696F6E28292C6E3D615B652B315D2E72616E67652E6765745374617274506F736974696F6E2829';
wwv_flow_imp.g_varchar2_table(7503) := '3B6966286E2E69734265666F72654F72457175616C287429297B6966286E2E69734265666F7265287429297468726F77206E6577204572726F7228224F7665726C617070696E672072616E67657320617265206E6F7420616C6C6F7765642122293B6C3D';
wwv_flow_imp.g_varchar2_table(7504) := '21307D7D72262628613D746869732E5F7265647563654F7065726174696F6E73286129293B636F6E737420633D6E7C7C743F75772E5F676574496E76657273654564697452616E6765732861293A5B5D2C643D5B5D3B6966287429666F72286C65742065';
wwv_flow_imp.g_varchar2_table(7505) := '3D303B653C612E6C656E6774683B652B2B297B636F6E737420743D615B655D2C6E3D635B655D3B696628742E69734175746F57686974657370616365456469742626742E72616E67652E6973456D707479282929666F72286C657420653D6E2E73746172';
wwv_flow_imp.g_varchar2_table(7506) := '744C696E654E756D6265723B653C3D6E2E656E644C696E654E756D6265723B652B2B297B6C657420693D22223B653D3D3D6E2E73746172744C696E654E756D626572262628693D746869732E6765744C696E65436F6E74656E7428742E72616E67652E73';
wwv_flow_imp.g_varchar2_table(7507) := '746172744C696E654E756D626572292C2D31213D3D6D69286929297C7C642E70757368287B6C696E654E756D6265723A652C6F6C64436F6E74656E743A697D297D7D6C657420683D6E756C6C3B6966286E297B6C657420653D303B683D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(7508) := '6C657420743D303B743C612E6C656E6774683B742B2B297B636F6E7374206E3D615B745D2C693D635B745D2C6F3D746869732E67657456616C7565496E52616E6765286E2E72616E6765292C733D6E2E72616E67654F66667365742B653B652B3D6E2E74';
wwv_flow_imp.g_varchar2_table(7509) := '6578742E6C656E6774682D6F2E6C656E6774682C685B745D3D7B736F7274496E6465783A6E2E736F7274496E6465782C6964656E7469666965723A6E2E6964656E7469666965722C72616E67653A692C746578743A6F2C746578744368616E67653A6E65';
wwv_flow_imp.g_varchar2_table(7510) := '77206A5F286E2E72616E67654F66667365742C6F2C732C6E2E74657874297D7D6C7C7C682E736F7274282828652C74293D3E652E736F7274496E6465782D742E736F7274496E64657829297D746869732E5F6D69676874436F6E7461696E52544C3D692C';
wwv_flow_imp.g_varchar2_table(7511) := '746869732E5F6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F72733D6F2C746869732E5F6D69676874436F6E7461696E4E6F6E426173696341534349493D733B636F6E737420753D746869732E5F646F4170706C794564';
wwv_flow_imp.g_varchar2_table(7512) := '6974732861293B6C657420703D6E756C6C3B696628742626642E6C656E6774683E30297B642E736F7274282828652C74293D3E742E6C696E654E756D6265722D652E6C696E654E756D62657229292C703D5B5D3B666F72286C657420653D302C743D642E';
wwv_flow_imp.g_varchar2_table(7513) := '6C656E6774683B653C743B652B2B297B636F6E737420743D645B655D2E6C696E654E756D6265723B696628653E302626645B652D315D2E6C696E654E756D6265723D3D3D7429636F6E74696E75653B636F6E7374206E3D645B655D2E6F6C64436F6E7465';
wwv_flow_imp.g_varchar2_table(7514) := '6E742C693D746869732E6765744C696E65436F6E74656E742874293B30213D3D692E6C656E677468262669213D3D6E26262D313D3D3D6D692869292626702E707573682874297D7D72657475726E20746869732E5F6F6E4469644368616E6765436F6E74';
wwv_flow_imp.g_varchar2_table(7515) := '656E742E6669726528292C6E6577204D6828682C752C70297D5F7265647563654F7065726174696F6E732865297B72657475726E20652E6C656E6774683C3165333F653A5B746869732E5F746F53696E676C65456469744F7065726174696F6E2865295D';
wwv_flow_imp.g_varchar2_table(7516) := '7D5F746F53696E676C65456469744F7065726174696F6E2865297B6C657420743D21313B636F6E7374206E3D655B305D2E72616E67652C693D655B652E6C656E6774682D315D2E72616E67652C6F3D6E6577207268286E2E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(7517) := '6265722C6E2E7374617274436F6C756D6E2C692E656E644C696E654E756D6265722C692E656E64436F6C756D6E293B6C657420733D6E2E73746172744C696E654E756D6265722C723D6E2E7374617274436F6C756D6E3B636F6E737420613D5B5D3B666F';
wwv_flow_imp.g_varchar2_table(7518) := '72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D2C6F3D692E72616E67653B743D747C7C692E666F7263654D6F76654D61726B6572732C612E7075736828746869732E67657456616C7565496E52';
wwv_flow_imp.g_varchar2_table(7519) := '616E6765286E657720726828732C722C6F2E73746172744C696E654E756D6265722C6F2E7374617274436F6C756D6E2929292C692E746578742E6C656E6774683E302626612E7075736828692E74657874292C733D6F2E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(7520) := '2C723D6F2E656E64436F6C756D6E7D636F6E7374206C3D612E6A6F696E282222292C5B632C642C685D3D7575286C293B72657475726E7B736F7274496E6465783A302C6964656E7469666965723A655B305D2E6964656E7469666965722C72616E67653A';
wwv_flow_imp.g_varchar2_table(7521) := '6F2C72616E67654F66667365743A746869732E6765744F66667365744174286F2E73746172744C696E654E756D6265722C6F2E7374617274436F6C756D6E292C72616E67654C656E6774683A746869732E67657456616C75654C656E677468496E52616E';
wwv_flow_imp.g_varchar2_table(7522) := '6765286F2C30292C746578743A6C2C656F6C436F756E743A632C66697273744C696E654C656E6774683A642C6C6173744C696E654C656E6774683A682C666F7263654D6F76654D61726B6572733A742C69734175746F5768697465737061636545646974';
wwv_flow_imp.g_varchar2_table(7523) := '3A21317D7D5F646F4170706C7945646974732865297B652E736F72742875772E5F736F72744F707344657363656E64696E67293B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D65';
wwv_flow_imp.g_varchar2_table(7524) := '5B6E5D2C6F3D692E72616E67652E73746172744C696E654E756D6265722C733D692E72616E67652E7374617274436F6C756D6E2C723D692E72616E67652E656E644C696E654E756D6265722C613D692E72616E67652E656E64436F6C756D6E3B6966286F';
wwv_flow_imp.g_varchar2_table(7525) := '3D3D3D722626733D3D3D612626303D3D3D692E746578742E6C656E67746829636F6E74696E75653B692E746578743F28746869732E5F7069656365547265652E64656C65746528692E72616E67654F66667365742C692E72616E67654C656E677468292C';
wwv_flow_imp.g_varchar2_table(7526) := '746869732E5F7069656365547265652E696E7365727428692E72616E67654F66667365742C692E746578742C213029293A746869732E5F7069656365547265652E64656C65746528692E72616E67654F66667365742C692E72616E67654C656E67746829';
wwv_flow_imp.g_varchar2_table(7527) := '3B636F6E7374206C3D6E6577207268286F2C732C722C61293B742E70757368287B72616E67653A6C2C72616E67654C656E6774683A692E72616E67654C656E6774682C746578743A692E746578742C72616E67654F66667365743A692E72616E67654F66';
wwv_flow_imp.g_varchar2_table(7528) := '667365742C666F7263654D6F76654D61726B6572733A692E666F7263654D6F76654D61726B6572737D297D72657475726E20747D66696E644D6174636865734C696E6542794C696E6528652C742C6E2C69297B72657475726E20746869732E5F70696563';
wwv_flow_imp.g_varchar2_table(7529) := '65547265652E66696E644D6174636865734C696E6542794C696E6528652C742C6E2C69297D737461746963205F676574496E76657273654564697452616E6765732865297B636F6E737420743D5B5D3B6C6574206E3D302C693D302C6F3D6E756C6C3B66';
wwv_flow_imp.g_varchar2_table(7530) := '6F72286C657420733D302C723D652E6C656E6774683B733C723B732B2B297B636F6E737420723D655B735D3B6C657420612C6C2C633B6966286F3F6F2E72616E67652E656E644C696E654E756D6265723D3D3D722E72616E67652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(7531) := '4E756D6265723F28613D6E2C6C3D692B28722E72616E67652E7374617274436F6C756D6E2D6F2E72616E67652E656E64436F6C756D6E29293A28613D6E2B28722E72616E67652E73746172744C696E654E756D6265722D6F2E72616E67652E656E644C69';
wwv_flow_imp.g_varchar2_table(7532) := '6E654E756D626572292C6C3D722E72616E67652E7374617274436F6C756D6E293A28613D722E72616E67652E73746172744C696E654E756D6265722C6C3D722E72616E67652E7374617274436F6C756D6E292C722E746578742E6C656E6774683E30297B';
wwv_flow_imp.g_varchar2_table(7533) := '636F6E737420653D722E656F6C436F756E742B313B633D313D3D3D653F6E657720726828612C6C2C612C6C2B722E66697273744C696E654C656E677468293A6E657720726828612C6C2C612B652D312C722E6C6173744C696E654C656E6774682B31297D';
wwv_flow_imp.g_varchar2_table(7534) := '656C736520633D6E657720726828612C6C2C612C6C293B6E3D632E656E644C696E654E756D6265722C693D632E656E64436F6C756D6E2C742E707573682863292C6F3D727D72657475726E20747D737461746963205F736F72744F7073417363656E6469';
wwv_flow_imp.g_varchar2_table(7535) := '6E6728652C74297B636F6E7374206E3D72682E636F6D7061726552616E6765735573696E67456E647328652E72616E67652C742E72616E6765293B72657475726E20303D3D3D6E3F652E736F7274496E6465782D742E736F7274496E6465783A6E7D7374';
wwv_flow_imp.g_varchar2_table(7536) := '61746963205F736F72744F707344657363656E64696E6728652C74297B636F6E7374206E3D72682E636F6D7061726552616E6765735573696E67456E647328652E72616E67652C742E72616E6765293B72657475726E20303D3D3D6E3F742E736F727449';
wwv_flow_imp.g_varchar2_table(7537) := '6E6465782D652E736F7274496E6465783A2D6E7D7D636C6173732070777B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B746869732E5F6368756E6B733D652C746869732E5F626F6D3D742C746869732E5F63723D6E2C74';
wwv_flow_imp.g_varchar2_table(7538) := '6869732E5F6C663D692C746869732E5F63726C663D6F2C746869732E5F636F6E7461696E7352544C3D732C746869732E5F636F6E7461696E73556E757375616C4C696E655465726D696E61746F72733D722C746869732E5F697342617369634153434949';
wwv_flow_imp.g_varchar2_table(7539) := '3D612C746869732E5F6E6F726D616C697A65454F4C3D6C7D5F676574454F4C2865297B636F6E737420743D746869732E5F63722B746869732E5F6C662B746869732E5F63726C662C6E3D746869732E5F63722B746869732E5F63726C663B72657475726E';
wwv_flow_imp.g_varchar2_table(7540) := '20303D3D3D743F313D3D3D653F225C6E223A225C725C6E223A6E3E742F323F225C725C6E223A225C6E227D6372656174652865297B636F6E737420743D746869732E5F676574454F4C2865292C6E3D746869732E5F6368756E6B733B696628746869732E';
wwv_flow_imp.g_varchar2_table(7541) := '5F6E6F726D616C697A65454F4C262628225C725C6E223D3D3D74262628746869732E5F63723E307C7C746869732E5F6C663E30297C7C225C6E223D3D3D74262628746869732E5F63723E307C7C746869732E5F63726C663E30292929666F72286C657420';
wwv_flow_imp.g_varchar2_table(7542) := '653D302C693D6E2E6C656E6774683B653C693B652B2B297B636F6E737420693D6E5B655D2E6275666665722E7265706C616365282F5C725C6E7C5C727C5C6E2F672C74292C6F3D72772869293B6E5B655D3D6E6577206C7728692C6F297D636F6E737420';
wwv_flow_imp.g_varchar2_table(7543) := '693D6E6577207577286E2C746869732E5F626F6D2C742C746869732E5F636F6E7461696E7352544C2C746869732E5F636F6E7461696E73556E757375616C4C696E655465726D696E61746F72732C746869732E5F6973426173696341534349492C746869';
wwv_flow_imp.g_varchar2_table(7544) := '732E5F6E6F726D616C697A65454F4C293B72657475726E7B746578744275666665723A692C646973706F7361626C653A697D7D7D636C6173732067777B636F6E7374727563746F7228297B746869732E6368756E6B733D5B5D2C746869732E424F4D3D22';
wwv_flow_imp.g_varchar2_table(7545) := '222C746869732E5F68617350726576696F7573436861723D21312C746869732E5F70726576696F7573436861723D302C746869732E5F746D704C696E655374617274733D5B5D2C746869732E63723D302C746869732E6C663D302C746869732E63726C66';
wwv_flow_imp.g_varchar2_table(7546) := '3D302C746869732E636F6E7461696E7352544C3D21312C746869732E636F6E7461696E73556E757375616C4C696E655465726D696E61746F72733D21312C746869732E6973426173696341534349493D21307D6163636570744368756E6B2865297B6966';
wwv_flow_imp.g_varchar2_table(7547) := '28303D3D3D652E6C656E6774682972657475726E3B303D3D3D746869732E6368756E6B732E6C656E67746826265569286529262628746869732E424F4D3D24692C653D652E737562737472283129293B636F6E737420743D652E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(7548) := '28652E6C656E6774682D31293B31333D3D3D747C7C743E3D35353239362626743C3D35363331393F28746869732E5F6163636570744368756E6B3128652E73756273747228302C652E6C656E6774682D31292C2131292C746869732E5F68617350726576';
wwv_flow_imp.g_varchar2_table(7549) := '696F7573436861723D21302C746869732E5F70726576696F7573436861723D74293A28746869732E5F6163636570744368756E6B3128652C2131292C746869732E5F68617350726576696F7573436861723D21312C746869732E5F70726576696F757343';
wwv_flow_imp.g_varchar2_table(7550) := '6861723D74297D5F6163636570744368756E6B3128652C74297B28747C7C30213D3D652E6C656E67746829262628746869732E5F68617350726576696F7573436861723F746869732E5F6163636570744368756E6B3228537472696E672E66726F6D4368';
wwv_flow_imp.g_varchar2_table(7551) := '6172436F646528746869732E5F70726576696F757343686172292B65293A746869732E5F6163636570744368756E6B32286529297D5F6163636570744368756E6B322865297B636F6E737420743D66756E6374696F6E28652C74297B652E6C656E677468';
wwv_flow_imp.g_varchar2_table(7552) := '3D302C655B305D3D303B6C6574206E3D312C693D302C6F3D302C733D302C723D21303B666F72286C657420613D302C6C3D742E6C656E6774683B613C6C3B612B2B297B636F6E737420633D742E63686172436F646541742861293B31333D3D3D633F612B';
wwv_flow_imp.g_varchar2_table(7553) := '313C6C262631303D3D3D742E63686172436F6465417428612B31293F28732B2B2C655B6E2B2B5D3D612B322C612B2B293A28692B2B2C655B6E2B2B5D3D612B31293A31303D3D3D633F286F2B2B2C655B6E2B2B5D3D612B31293A72262639213D3D632626';
wwv_flow_imp.g_varchar2_table(7554) := '28633C33327C7C633E31323629262628723D2131297D636F6E737420613D6E6577207377286F772865292C692C6F2C732C72293B72657475726E20652E6C656E6774683D302C617D28746869732E5F746D704C696E655374617274732C65293B74686973';
wwv_flow_imp.g_varchar2_table(7555) := '2E6368756E6B732E70757368286E6577206C7728652C742E6C696E6553746172747329292C746869732E63722B3D742E63722C746869732E6C662B3D742E6C662C746869732E63726C662B3D742E63726C662C742E6973426173696341534349497C7C28';
wwv_flow_imp.g_varchar2_table(7556) := '746869732E6973426173696341534349493D21312C746869732E636F6E7461696E7352544C7C7C28746869732E636F6E7461696E7352544C3D4269286529292C746869732E636F6E7461696E73556E757375616C4C696E655465726D696E61746F72737C';
wwv_flow_imp.g_varchar2_table(7557) := '7C28746869732E636F6E7461696E73556E757375616C4C696E655465726D696E61746F72733D576928652929297D66696E69736828653D2130297B72657475726E20746869732E5F66696E69736828292C6E657720707728746869732E6368756E6B732C';
wwv_flow_imp.g_varchar2_table(7558) := '746869732E424F4D2C746869732E63722C746869732E6C662C746869732E63726C662C746869732E636F6E7461696E7352544C2C746869732E636F6E7461696E73556E757375616C4C696E655465726D696E61746F72732C746869732E69734261736963';
wwv_flow_imp.g_varchar2_table(7559) := '41534349492C65297D5F66696E69736828297B696628303D3D3D746869732E6368756E6B732E6C656E6774682626746869732E5F6163636570744368756E6B312822222C2130292C746869732E5F68617350726576696F757343686172297B746869732E';
wwv_flow_imp.g_varchar2_table(7560) := '5F68617350726576696F7573436861723D21313B636F6E737420653D746869732E6368756E6B735B746869732E6368756E6B732E6C656E6774682D315D3B652E6275666665722B3D537472696E672E66726F6D43686172436F646528746869732E5F7072';
wwv_flow_imp.g_varchar2_table(7561) := '6576696F757343686172293B636F6E737420743D727728652E627566666572293B652E6C696E655374617274733D742C31333D3D3D746869732E5F70726576696F7573436861722626746869732E63722B2B7D7D7D636C617373206D7720657874656E64';
wwv_flow_imp.g_varchar2_table(7562) := '73206C747B6765742069735265736F6C76656428297B72657475726E20746869732E5F69735265736F6C7665647D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F72656769737472793D652C746869732E5F6C616E67';
wwv_flow_imp.g_varchar2_table(7563) := '7561676549643D742C746869732E5F666163746F72793D6E2C746869732E5F6973446973706F7365643D21312C746869732E5F7265736F6C766550726F6D6973653D6E756C6C2C746869732E5F69735265736F6C7665643D21317D646973706F73652829';
wwv_flow_imp.g_varchar2_table(7564) := '7B746869732E5F6973446973706F7365643D21302C73757065722E646973706F736528297D6173796E63207265736F6C766528297B72657475726E20746869732E5F7265736F6C766550726F6D6973657C7C28746869732E5F7265736F6C766550726F6D';
wwv_flow_imp.g_varchar2_table(7565) := '6973653D746869732E5F6372656174652829292C746869732E5F7265736F6C766550726F6D6973657D6173796E63205F63726561746528297B636F6E737420653D617761697420746869732E5F666163746F72792E746F6B656E697A6174696F6E537570';
wwv_flow_imp.g_varchar2_table(7566) := '706F72743B746869732E5F69735265736F6C7665643D21302C65262621746869732E5F6973446973706F7365642626746869732E5F726567697374657228746869732E5F72656769737472792E726567697374657228746869732E5F6C616E6775616765';
wwv_flow_imp.g_varchar2_table(7567) := '49642C6529297D7D636C6173732066777B636F6E7374727563746F7228652C742C6E297B746869732E6F66667365743D652C746869732E747970653D742C746869732E6C616E67756167653D6E2C746869732E5F746F6B656E4272616E643D766F696420';
wwv_flow_imp.g_varchar2_table(7568) := '307D746F537472696E6728297B72657475726E2228222B746869732E6F66667365742B222C20222B746869732E747970652B2229227D7D636C6173732076777B636F6E7374727563746F7228652C74297B746869732E746F6B656E733D652C746869732E';
wwv_flow_imp.g_varchar2_table(7569) := '656E6453746174653D742C746869732E5F746F6B656E697A6174696F6E526573756C744272616E643D766F696420307D7D636C6173732062777B636F6E7374727563746F7228652C74297B746869732E746F6B656E733D652C746869732E656E64537461';
wwv_flow_imp.g_varchar2_table(7570) := '74653D742C746869732E5F656E636F646564546F6B656E697A6174696F6E526573756C744272616E643D766F696420307D7D766172205F772C79772C77772C43772C53772C78773B2166756E6374696F6E2865297B655B652E496E6372656173653D305D';
wwv_flow_imp.g_varchar2_table(7571) := '3D22496E637265617365222C655B652E44656372656173653D315D3D224465637265617365227D285F777C7C285F773D7B7D29292C66756E6374696F6E2865297B636F6E737420743D6E6577204D61703B742E73657428302C4C6C2E73796D626F6C4D65';
wwv_flow_imp.g_varchar2_table(7572) := '74686F64292C742E73657428312C4C6C2E73796D626F6C46756E6374696F6E292C742E73657428322C4C6C2E73796D626F6C436F6E7374727563746F72292C742E73657428332C4C6C2E73796D626F6C4669656C64292C742E73657428342C4C6C2E7379';
wwv_flow_imp.g_varchar2_table(7573) := '6D626F6C5661726961626C65292C742E73657428352C4C6C2E73796D626F6C436C617373292C742E73657428362C4C6C2E73796D626F6C537472756374292C742E73657428372C4C6C2E73796D626F6C496E74657266616365292C742E73657428382C4C';
wwv_flow_imp.g_varchar2_table(7574) := '6C2E73796D626F6C4D6F64756C65292C742E73657428392C4C6C2E73796D626F6C50726F7065727479292C742E7365742831302C4C6C2E73796D626F6C4576656E74292C742E7365742831312C4C6C2E73796D626F6C4F70657261746F72292C742E7365';
wwv_flow_imp.g_varchar2_table(7575) := '742831322C4C6C2E73796D626F6C556E6974292C742E7365742831332C4C6C2E73796D626F6C56616C7565292C742E7365742831352C4C6C2E73796D626F6C456E756D292C742E7365742831342C4C6C2E73796D626F6C436F6E7374616E74292C742E73';
wwv_flow_imp.g_varchar2_table(7576) := '65742831352C4C6C2E73796D626F6C456E756D292C742E7365742831362C4C6C2E73796D626F6C456E756D4D656D626572292C742E7365742831372C4C6C2E73796D626F6C4B6579776F7264292C742E7365742832372C4C6C2E73796D626F6C536E6970';
wwv_flow_imp.g_varchar2_table(7577) := '706574292C742E7365742831382C4C6C2E73796D626F6C54657874292C742E7365742831392C4C6C2E73796D626F6C436F6C6F72292C742E7365742832302C4C6C2E73796D626F6C46696C65292C742E7365742832312C4C6C2E73796D626F6C52656665';
wwv_flow_imp.g_varchar2_table(7578) := '72656E6365292C742E7365742832322C4C6C2E73796D626F6C437573746F6D436F6C6F72292C742E7365742832332C4C6C2E73796D626F6C466F6C646572292C742E7365742832342C4C6C2E73796D626F6C54797065506172616D65746572292C742E73';
wwv_flow_imp.g_varchar2_table(7579) := '65742832352C4C6C2E6163636F756E74292C742E7365742832362C4C6C2E697373756573292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865293B72657475726E206E7C7C28636F6E736F6C652E696E666F28224E';
wwv_flow_imp.g_varchar2_table(7580) := '6F20636F6469636F6E20666F756E6420666F7220436F6D706C6574696F6E4974656D4B696E6420222B65292C6E3D4C6C2E73796D626F6C50726F7065727479292C6E7D3B636F6E7374206E3D6E6577204D61703B6E2E73657428226D6574686F64222C30';
wwv_flow_imp.g_varchar2_table(7581) := '292C6E2E736574282266756E6374696F6E222C31292C6E2E7365742822636F6E7374727563746F72222C32292C6E2E73657428226669656C64222C33292C6E2E73657428227661726961626C65222C34292C6E2E7365742822636C617373222C35292C6E';
wwv_flow_imp.g_varchar2_table(7582) := '2E7365742822737472756374222C36292C6E2E7365742822696E74657266616365222C37292C6E2E73657428226D6F64756C65222C38292C6E2E736574282270726F7065727479222C39292C6E2E73657428226576656E74222C3130292C6E2E73657428';
wwv_flow_imp.g_varchar2_table(7583) := '226F70657261746F72222C3131292C6E2E7365742822756E6974222C3132292C6E2E736574282276616C7565222C3133292C6E2E7365742822636F6E7374616E74222C3134292C6E2E7365742822656E756D222C3135292C6E2E7365742822656E756D2D';
wwv_flow_imp.g_varchar2_table(7584) := '6D656D626572222C3136292C6E2E7365742822656E756D4D656D626572222C3136292C6E2E73657428226B6579776F7264222C3137292C6E2E7365742822736E6970706574222C3237292C6E2E736574282274657874222C3138292C6E2E736574282263';
wwv_flow_imp.g_varchar2_table(7585) := '6F6C6F72222C3139292C6E2E736574282266696C65222C3230292C6E2E73657428227265666572656E6365222C3231292C6E2E7365742822637573746F6D636F6C6F72222C3232292C6E2E7365742822666F6C646572222C3233292C6E2E736574282274';
wwv_flow_imp.g_varchar2_table(7586) := '7970652D706172616D65746572222C3234292C6E2E736574282274797065506172616D65746572222C3234292C6E2E73657428226163636F756E74222C3235292C6E2E73657428226973737565222C3236292C652E66726F6D537472696E673D66756E63';
wwv_flow_imp.g_varchar2_table(7587) := '74696F6E28652C74297B6C657420693D6E2E6765742865293B72657475726E20766F69642030213D3D697C7C747C7C28693D39292C697D7D2879777C7C2879773D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D22';
wwv_flow_imp.g_varchar2_table(7588) := '4175746F6D61746963222C655B652E4578706C696369743D315D3D224578706C69636974227D2877777C7C2877773D7B7D29293B636C617373206B777B636F6E7374727563746F7228652C742C6E2C69297B746869732E72616E67653D652C746869732E';
wwv_flow_imp.g_varchar2_table(7589) := '746578743D742C746869732E636F6D706C6574696F6E4B696E643D6E2C746869732E6973536E6970706574546578743D697D657175616C732865297B72657475726E2072682E6C69667428746869732E72616E6765292E657175616C7352616E67652865';
wwv_flow_imp.g_varchar2_table(7590) := '2E72616E6765292626746869732E746578743D3D3D652E746578742626746869732E636F6D706C6574696F6E4B696E643D3D3D652E636F6D706C6574696F6E4B696E642626746869732E6973536E6970706574546578743D3D3D652E6973536E69707065';
wwv_flow_imp.g_varchar2_table(7591) := '74546578747D7D2166756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B652E506173746541733D315D3D2250617374654173227D2843777C7C2843773D7B7D29292C66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(7592) := '655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E547269676765724368617261637465723D325D3D2254726967676572436861726163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E67';
wwv_flow_imp.g_varchar2_table(7593) := '65227D2853777C7C2853773D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E526561643D315D3D2252656164222C655B652E57726974653D325D3D225772697465227D2878777C7C2878773D7B7D29';
wwv_flow_imp.g_varchar2_table(7594) := '293B636F6E73742045773D7B31373A6228302C22617272617922292C31363A6228302C22626F6F6C65616E22292C343A6228302C22636C61737322292C31333A6228302C22636F6E7374616E7422292C383A6228302C22636F6E7374727563746F722229';
wwv_flow_imp.g_varchar2_table(7595) := '2C393A6228302C22656E756D65726174696F6E22292C32313A6228302C22656E756D65726174696F6E206D656D62657222292C32333A6228302C226576656E7422292C373A6228302C226669656C6422292C303A6228302C2266696C6522292C31313A62';
wwv_flow_imp.g_varchar2_table(7596) := '28302C2266756E6374696F6E22292C31303A6228302C22696E7465726661636522292C31393A6228302C226B657922292C353A6228302C226D6574686F6422292C313A6228302C226D6F64756C6522292C323A6228302C226E616D65737061636522292C';
wwv_flow_imp.g_varchar2_table(7597) := '32303A6228302C226E756C6C22292C31353A6228302C226E756D62657222292C31383A6228302C226F626A65637422292C32343A6228302C226F70657261746F7222292C333A6228302C227061636B61676522292C363A6228302C2270726F7065727479';
wwv_flow_imp.g_varchar2_table(7598) := '22292C31343A6228302C22737472696E6722292C32323A6228302C2273747275637422292C32353A6228302C227479706520706172616D6574657222292C31323A6228302C227661726961626C6522297D3B766172204C772C44772C54772C49772C4D77';
wwv_flow_imp.g_varchar2_table(7599) := '3B2166756E6374696F6E2865297B636F6E737420743D6E6577204D61703B742E73657428302C4C6C2E73796D626F6C46696C65292C742E73657428312C4C6C2E73796D626F6C4D6F64756C65292C742E73657428322C4C6C2E73796D626F6C4E616D6573';
wwv_flow_imp.g_varchar2_table(7600) := '70616365292C742E73657428332C4C6C2E73796D626F6C5061636B616765292C742E73657428342C4C6C2E73796D626F6C436C617373292C742E73657428352C4C6C2E73796D626F6C4D6574686F64292C742E73657428362C4C6C2E73796D626F6C5072';
wwv_flow_imp.g_varchar2_table(7601) := '6F7065727479292C742E73657428372C4C6C2E73796D626F6C4669656C64292C742E73657428382C4C6C2E73796D626F6C436F6E7374727563746F72292C742E73657428392C4C6C2E73796D626F6C456E756D292C742E7365742831302C4C6C2E73796D';
wwv_flow_imp.g_varchar2_table(7602) := '626F6C496E74657266616365292C742E7365742831312C4C6C2E73796D626F6C46756E6374696F6E292C742E7365742831322C4C6C2E73796D626F6C5661726961626C65292C742E7365742831332C4C6C2E73796D626F6C436F6E7374616E74292C742E';
wwv_flow_imp.g_varchar2_table(7603) := '7365742831342C4C6C2E73796D626F6C537472696E67292C742E7365742831352C4C6C2E73796D626F6C4E756D626572292C742E7365742831362C4C6C2E73796D626F6C426F6F6C65616E292C742E7365742831372C4C6C2E73796D626F6C4172726179';
wwv_flow_imp.g_varchar2_table(7604) := '292C742E7365742831382C4C6C2E73796D626F6C4F626A656374292C742E7365742831392C4C6C2E73796D626F6C4B6579292C742E7365742832302C4C6C2E73796D626F6C4E756C6C292C742E7365742832312C4C6C2E73796D626F6C456E756D4D656D';
wwv_flow_imp.g_varchar2_table(7605) := '626572292C742E7365742832322C4C6C2E73796D626F6C537472756374292C742E7365742832332C4C6C2E73796D626F6C4576656E74292C742E7365742832342C4C6C2E73796D626F6C4F70657261746F72292C742E7365742832352C4C6C2E73796D62';
wwv_flow_imp.g_varchar2_table(7606) := '6F6C54797065506172616D65746572292C652E746F49636F6E3D66756E6374696F6E2865297B6C6574206E3D742E6765742865293B72657475726E206E7C7C28636F6E736F6C652E696E666F28224E6F20636F6469636F6E20666F756E6420666F722053';
wwv_flow_imp.g_varchar2_table(7607) := '796D626F6C4B696E6420222B65292C6E3D4C6C2E73796D626F6C50726F7065727479292C6E7D7D284C777C7C284C773D7B7D29293B636C6173732041777B7374617469632066726F6D56616C75652865297B7377697463682865297B6361736522636F6D';
wwv_flow_imp.g_varchar2_table(7608) := '6D656E74223A72657475726E2041772E436F6D6D656E743B6361736522696D706F727473223A72657475726E2041772E496D706F7274733B6361736522726567696F6E223A72657475726E2041772E526567696F6E7D72657475726E206E657720417728';
wwv_flow_imp.g_varchar2_table(7609) := '65297D636F6E7374727563746F722865297B746869732E76616C75653D657D7D41772E436F6D6D656E743D6E65772041772822636F6D6D656E7422292C41772E496D706F7274733D6E65772041772822696D706F72747322292C41772E526567696F6E3D';
wwv_flow_imp.g_varchar2_table(7610) := '6E65772041772822726567696F6E22292C66756E6374696F6E2865297B655B652E414947656E6572617465643D315D3D22414947656E657261746564227D2844777C7C2844773D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D30';
wwv_flow_imp.g_varchar2_table(7611) := '5D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D2854777C7C2854773D7B7D29292C66756E6374696F6E2865297B652E69733D66756E6374696F6E2865297B72657475726E212821657C7C226F626A65';
wwv_flow_imp.g_varchar2_table(7612) := '637422213D747970656F66206529262622737472696E67223D3D747970656F6620652E6964262622737472696E67223D3D747970656F6620652E7469746C657D7D2849777C7C2849773D7B7D29292C66756E6374696F6E2865297B655B652E547970653D';
wwv_flow_imp.g_varchar2_table(7613) := '315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D284D777C7C284D773D7B7D29293B636C617373204E777B636F6E7374727563746F722865297B746869732E637265617465537570706F72743D652C7468';
wwv_flow_imp.g_varchar2_table(7614) := '69732E5F746F6B656E697A6174696F6E537570706F72743D6E756C6C7D646973706F736528297B746869732E5F746F6B656E697A6174696F6E537570706F72742626746869732E5F746F6B656E697A6174696F6E537570706F72742E7468656E2828653D';
wwv_flow_imp.g_varchar2_table(7615) := '3E7B652626652E646973706F736528297D29297D67657420746F6B656E697A6174696F6E537570706F727428297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F72747C7C28746869732E5F746F6B656E697A6174696F6E53';
wwv_flow_imp.g_varchar2_table(7616) := '7570706F72743D746869732E637265617465537570706F72742829292C746869732E5F746F6B656E697A6174696F6E537570706F72747D7D636F6E73742050773D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F746F6B656E';
wwv_flow_imp.g_varchar2_table(7617) := '697A6174696F6E537570706F7274733D6E6577204D61702C746869732E5F666163746F726965733D6E6577204D61702C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(7618) := '644368616E67652E6576656E742C746869732E5F636F6C6F724D61703D6E756C6C7D68616E646C654368616E67652865297B746869732E5F6F6E4469644368616E67652E66697265287B6368616E6765644C616E6775616765733A652C6368616E676564';
wwv_flow_imp.g_varchar2_table(7619) := '436F6C6F724D61703A21317D297D726567697374657228652C74297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F7274732E73657428652C74292C746869732E68616E646C654368616E6765285B655D292C727428282829';
wwv_flow_imp.g_varchar2_table(7620) := '3D3E7B746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865293D3D3D74262628746869732E5F746F6B656E697A6174696F6E537570706F7274732E64656C6574652865292C746869732E68616E646C654368616E6765285B65';
wwv_flow_imp.g_varchar2_table(7621) := '5D29297D29297D6765742865297B72657475726E20746869732E5F746F6B656E697A6174696F6E537570706F7274732E6765742865297C7C6E756C6C7D7265676973746572466163746F727928652C74297B766172206E3B6E756C6C3D3D3D286E3D7468';
wwv_flow_imp.g_varchar2_table(7622) := '69732E5F666163746F726965732E676574286529297C7C766F696420303D3D3D6E7C7C6E2E646973706F736528293B636F6E737420693D6E6577206D7728746869732C652C74293B72657475726E20746869732E5F666163746F726965732E7365742865';
wwv_flow_imp.g_varchar2_table(7623) := '2C69292C7274282828293D3E7B636F6E737420743D746869732E5F666163746F726965732E6765742865293B742626743D3D3D69262628746869732E5F666163746F726965732E64656C6574652865292C742E646973706F73652829297D29297D617379';
wwv_flow_imp.g_varchar2_table(7624) := '6E63206765744F724372656174652865297B636F6E737420743D746869732E6765742865293B696628742972657475726E20743B636F6E7374206E3D746869732E5F666163746F726965732E6765742865293B72657475726E216E7C7C6E2E6973526573';
wwv_flow_imp.g_varchar2_table(7625) := '6F6C7665643F6E756C6C3A286177616974206E2E7265736F6C766528292C746869732E676574286529297D69735265736F6C7665642865297B696628746869732E6765742865292972657475726E21303B636F6E737420743D746869732E5F666163746F';
wwv_flow_imp.g_varchar2_table(7626) := '726965732E6765742865293B72657475726E212874262621742E69735265736F6C766564297D736574436F6C6F724D61702865297B746869732E5F636F6C6F724D61703D652C746869732E5F6F6E4469644368616E67652E66697265287B6368616E6765';
wwv_flow_imp.g_varchar2_table(7627) := '644C616E6775616765733A41727261792E66726F6D28746869732E5F746F6B656E697A6174696F6E537570706F7274732E6B6579732829292C6368616E676564436F6C6F724D61703A21307D297D676574436F6C6F724D617028297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(7628) := '6869732E5F636F6C6F724D61707D67657444656661756C744261636B67726F756E6428297B72657475726E20746869732E5F636F6C6F724D61702626746869732E5F636F6C6F724D61702E6C656E6774683E323F746869732E5F636F6C6F724D61705B32';
wwv_flow_imp.g_varchar2_table(7629) := '5D3A6E756C6C7D7D3B766172204F773B2166756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F6D617469633D315D3D224175746F6D61746963227D284F777C7C284F773D7B7D29293B636F6E7374';
wwv_flow_imp.g_varchar2_table(7630) := '2052773D6E657720636C6173737B636C6F6E6528297B72657475726E20746869737D657175616C732865297B72657475726E20746869733D3D3D657D7D3B66756E6374696F6E20467728652C74297B72657475726E206E6577207677285B6E6577206677';
wwv_flow_imp.g_varchar2_table(7631) := '28302C22222C65295D2C74297D66756E6374696F6E20427728652C74297B636F6E7374206E3D6E65772055696E74333241727261792832293B72657475726E206E5B305D3D302C6E5B315D3D2833323736387C657C323C3C3234293E3E3E302C6E657720';
wwv_flow_imp.g_varchar2_table(7632) := '6277286E2C6E756C6C3D3D3D743F52773A74297D636C6173732056777B636F6E7374727563746F722865297B746869732E5F64656661756C743D652C746869732E5F73746F72653D5B5D7D6765742865297B72657475726E20653C746869732E5F73746F';
wwv_flow_imp.g_varchar2_table(7633) := '72652E6C656E6774683F746869732E5F73746F72655B655D3A746869732E5F64656661756C747D73657428652C74297B666F72283B653E3D746869732E5F73746F72652E6C656E6774683B29746869732E5F73746F72655B746869732E5F73746F72652E';
wwv_flow_imp.g_varchar2_table(7634) := '6C656E6774685D3D746869732E5F64656661756C743B746869732E5F73746F72655B655D3D747D7265706C61636528652C742C6E297B696628653E3D746869732E5F73746F72652E6C656E6774682972657475726E3B696628303D3D3D74297265747572';
wwv_flow_imp.g_varchar2_table(7635) := '6E20766F696420746869732E696E7365727428652C6E293B696628303D3D3D6E2972657475726E20766F696420746869732E64656C65746528652C74293B636F6E737420693D746869732E5F73746F72652E736C69636528302C65292C6F3D746869732E';
wwv_flow_imp.g_varchar2_table(7636) := '5F73746F72652E736C69636528652B74292C733D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D3B666F72286C657420693D303B693C653B692B2B296E5B695D3D743B72657475726E206E7D286E2C746869732E5F64656661756C74293B74';
wwv_flow_imp.g_varchar2_table(7637) := '6869732E5F73746F72653D692E636F6E63617428732C6F297D64656C65746528652C74297B303D3D3D747C7C653E3D746869732E5F73746F72652E6C656E6774687C7C746869732E5F73746F72652E73706C69636528652C74297D696E7365727428652C';
wwv_flow_imp.g_varchar2_table(7638) := '74297B696628303D3D3D747C7C653E3D746869732E5F73746F72652E6C656E6774682972657475726E3B636F6E7374206E3D5B5D3B666F72286C657420653D303B653C743B652B2B296E5B655D3D746869732E5F64656661756C743B746869732E5F7374';
wwv_flow_imp.g_varchar2_table(7639) := '6F72653D4B6828746869732E5F73746F72652C652C6E297D7D636C617373207A777B6765742073746172744C696E654E756D62657228297B72657475726E20746869732E5F73746172744C696E654E756D6265727D67657420656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(7640) := '657228297B72657475726E20746869732E5F73746172744C696E654E756D6265722B746869732E5F746F6B656E732E6C656E6774682D317D636F6E7374727563746F7228652C74297B746869732E5F73746172744C696E654E756D6265723D652C746869';
wwv_flow_imp.g_varchar2_table(7641) := '732E5F746F6B656E733D747D6765744C696E65546F6B656E732865297B72657475726E20746869732E5F746F6B656E735B652D746869732E5F73746172744C696E654E756D6265725D7D617070656E644C696E65546F6B656E732865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(7642) := '746F6B656E732E707573682865297D7D636C6173732048777B636F6E7374727563746F7228297B746869732E5F746F6B656E733D5B5D7D61646428652C74297B696628746869732E5F746F6B656E732E6C656E6774683E30297B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(7643) := '69732E5F746F6B656E735B746869732E5F746F6B656E732E6C656E6774682D315D3B6966286E2E656E644C696E654E756D6265722B313D3D3D652972657475726E20766F6964206E2E617070656E644C696E65546F6B656E732874297D746869732E5F74';
wwv_flow_imp.g_varchar2_table(7644) := '6F6B656E732E70757368286E6577207A7728652C5B745D29297D66696E616C697A6528297B72657475726E20746869732E5F746F6B656E737D7D636C6173732057777B73746174696320637265617465456D70747928652C74297B636F6E7374206E3D57';
wwv_flow_imp.g_varchar2_table(7645) := '772E64656661756C74546F6B656E4D657461646174612C693D6E65772055696E74333241727261792832293B72657475726E20695B305D3D652E6C656E6774682C695B315D3D6E2C6E657720577728692C652C74297D636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(7646) := '742C6E297B746869732E5F6C696E65546F6B656E734272616E643D766F696420302C746869732E5F746F6B656E733D652C746869732E5F746F6B656E73436F756E743D746869732E5F746F6B656E732E6C656E6774683E3E3E312C746869732E5F746578';
wwv_flow_imp.g_varchar2_table(7647) := '743D742C746869732E5F6C616E67756167654964436F6465633D6E7D657175616C732865297B72657475726E206520696E7374616E63656F662057772626746869732E736C69636564457175616C7328652C302C746869732E5F746F6B656E73436F756E';
wwv_flow_imp.g_varchar2_table(7648) := '74297D736C69636564457175616C7328652C742C6E297B696628746869732E5F74657874213D3D652E5F746578742972657475726E21313B696628746869732E5F746F6B656E73436F756E74213D3D652E5F746F6B656E73436F756E742972657475726E';
wwv_flow_imp.g_varchar2_table(7649) := '21313B636F6E737420693D743C3C312C6F3D692B286E3C3C31293B666F72286C657420743D693B743C6F3B742B2B29696628746869732E5F746F6B656E735B745D213D3D652E5F746F6B656E735B745D2972657475726E21313B72657475726E21307D67';
wwv_flow_imp.g_varchar2_table(7650) := '65744C696E65436F6E74656E7428297B72657475726E20746869732E5F746578747D676574436F756E7428297B72657475726E20746869732E5F746F6B656E73436F756E747D67657453746172744F66667365742865297B72657475726E20653E303F74';
wwv_flow_imp.g_varchar2_table(7651) := '6869732E5F746F6B656E735B652D313C3C315D3A307D6765744D657461646174612865297B72657475726E20746869732E5F746F6B656E735B312B28653C3C31295D7D6765744C616E677561676549642865297B636F6E737420743D746869732E5F746F';
wwv_flow_imp.g_varchar2_table(7652) := '6B656E735B312B28653C3C31295D2C6E3D51672E6765744C616E677561676549642874293B72657475726E20746869732E5F6C616E67756167654964436F6465632E6465636F64654C616E67756167654964286E297D6765745374616E64617264546F6B';
wwv_flow_imp.g_varchar2_table(7653) := '656E547970652865297B636F6E737420743D746869732E5F746F6B656E735B312B28653C3C31295D3B72657475726E2051672E676574546F6B656E547970652874297D676574466F726567726F756E642865297B636F6E737420743D746869732E5F746F';
wwv_flow_imp.g_varchar2_table(7654) := '6B656E735B312B28653C3C31295D3B72657475726E2051672E676574466F726567726F756E642874297D676574436C6173734E616D652865297B636F6E737420743D746869732E5F746F6B656E735B312B28653C3C31295D3B72657475726E2051672E67';
wwv_flow_imp.g_varchar2_table(7655) := '6574436C6173734E616D6546726F6D4D657461646174612874297D676574496E6C696E655374796C6528652C74297B636F6E7374206E3D746869732E5F746F6B656E735B312B28653C3C31295D3B72657475726E2051672E676574496E6C696E65537479';
wwv_flow_imp.g_varchar2_table(7656) := '6C6546726F6D4D65746164617461286E2C74297D67657450726573656E746174696F6E2865297B636F6E737420743D746869732E5F746F6B656E735B312B28653C3C31295D3B72657475726E2051672E67657450726573656E746174696F6E46726F6D4D';
wwv_flow_imp.g_varchar2_table(7657) := '657461646174612874297D676574456E644F66667365742865297B72657475726E20746869732E5F746F6B656E735B653C3C315D7D66696E64546F6B656E496E64657841744F66667365742865297B72657475726E2057772E66696E64496E646578496E';
wwv_flow_imp.g_varchar2_table(7658) := '546F6B656E73417272617928746869732E5F746F6B656E732C65297D696E666C61746528297B72657475726E20746869737D736C696365416E64496E666C61746528652C742C6E297B72657475726E206E6577206A7728746869732C652C742C6E297D73';
wwv_flow_imp.g_varchar2_table(7659) := '746174696320636F6E76657274546F456E644F666673657428652C74297B636F6E7374206E3D28652E6C656E6774683E3E3E31292D313B666F72286C657420743D303B743C6E3B742B2B29655B743C3C315D3D655B742B313C3C315D3B655B6E3C3C315D';
wwv_flow_imp.g_varchar2_table(7660) := '3D747D7374617469632066696E64496E646578496E546F6B656E73417272617928652C74297B696628652E6C656E6774683C3D322972657475726E20303B6C6574206E3D302C693D28652E6C656E6774683E3E3E31292D313B666F72283B6E3C693B297B';
wwv_flow_imp.g_varchar2_table(7661) := '636F6E7374206F3D6E2B4D6174682E666C6F6F722828692D6E292F32292C733D655B6F3C3C315D3B696628733D3D3D742972657475726E206F2B313B733C743F6E3D6F2B313A733E74262628693D6F297D72657475726E206E7D77697468496E73657274';
wwv_flow_imp.g_varchar2_table(7662) := '65642865297B696628303D3D3D652E6C656E6774682972657475726E20746869733B6C657420743D302C6E3D302C693D22223B636F6E7374206F3D6E65772041727261793B6C657420733D303B666F72283B3B297B636F6E737420723D743C746869732E';
wwv_flow_imp.g_varchar2_table(7663) := '5F746F6B656E73436F756E743F746869732E5F746F6B656E735B743C3C315D3A2D312C613D6E3C652E6C656E6774683F655B6E5D3A6E756C6C3B6966282D31213D3D722626286E756C6C3D3D3D617C7C723C3D612E6F666673657429297B692B3D746869';
wwv_flow_imp.g_varchar2_table(7664) := '732E5F746578742E737562737472696E6728732C72293B636F6E737420653D746869732E5F746F6B656E735B312B28743C3C31295D3B6F2E7075736828692E6C656E6774682C65292C742B2B2C733D727D656C73657B696628216129627265616B3B6966';
wwv_flow_imp.g_varchar2_table(7665) := '28612E6F66667365743E73297B692B3D746869732E5F746578742E737562737472696E6728732C612E6F6666736574293B636F6E737420653D746869732E5F746F6B656E735B312B28743C3C31295D3B6F2E7075736828692E6C656E6774682C65292C73';
wwv_flow_imp.g_varchar2_table(7666) := '3D612E6F66667365747D692B3D612E746578742C6F2E7075736828692E6C656E6774682C612E746F6B656E4D65746164617461292C6E2B2B7D7D72657475726E206E6577205777286E65772055696E7433324172726179286F292C692C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(7667) := '616E67756167654964436F646563297D7D57772E64656661756C74546F6B656E4D657461646174613D33333538373230303B636C617373206A777B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F736F757263653D652C746869732E';
wwv_flow_imp.g_varchar2_table(7668) := '5F73746172744F66667365743D742C746869732E5F656E644F66667365743D6E2C746869732E5F64656C74614F66667365743D692C746869732E5F6669727374546F6B656E496E6465783D652E66696E64546F6B656E496E64657841744F666673657428';
wwv_flow_imp.g_varchar2_table(7669) := '74292C746869732E5F746F6B656E73436F756E743D303B666F72286C657420743D746869732E5F6669727374546F6B656E496E6465782C693D652E676574436F756E7428293B743C6926262128652E67657453746172744F66667365742874293E3D6E29';
wwv_flow_imp.g_varchar2_table(7670) := '3B742B2B29746869732E5F746F6B656E73436F756E742B2B7D6765744D657461646174612865297B72657475726E20746869732E5F736F757263652E6765744D6574616461746128746869732E5F6669727374546F6B656E496E6465782B65297D676574';
wwv_flow_imp.g_varchar2_table(7671) := '4C616E677561676549642865297B72657475726E20746869732E5F736F757263652E6765744C616E6775616765496428746869732E5F6669727374546F6B656E496E6465782B65297D6765744C696E65436F6E74656E7428297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(7672) := '732E5F736F757263652E6765744C696E65436F6E74656E7428292E737562737472696E6728746869732E5F73746172744F66667365742C746869732E5F656E644F6666736574297D657175616C732865297B72657475726E206520696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(7673) := '66206A772626746869732E5F73746172744F66667365743D3D3D652E5F73746172744F66667365742626746869732E5F656E644F66667365743D3D3D652E5F656E644F66667365742626746869732E5F64656C74614F66667365743D3D3D652E5F64656C';
wwv_flow_imp.g_varchar2_table(7674) := '74614F66667365742626746869732E5F736F757263652E736C69636564457175616C7328652E5F736F757263652C746869732E5F6669727374546F6B656E496E6465782C746869732E5F746F6B656E73436F756E74297D676574436F756E7428297B7265';
wwv_flow_imp.g_varchar2_table(7675) := '7475726E20746869732E5F746F6B656E73436F756E747D676574466F726567726F756E642865297B72657475726E20746869732E5F736F757263652E676574466F726567726F756E6428746869732E5F6669727374546F6B656E496E6465782B65297D67';
wwv_flow_imp.g_varchar2_table(7676) := '6574456E644F66667365742865297B636F6E737420743D746869732E5F736F757263652E676574456E644F666673657428746869732E5F6669727374546F6B656E496E6465782B65293B72657475726E204D6174682E6D696E28746869732E5F656E644F';
wwv_flow_imp.g_varchar2_table(7677) := '66667365742C74292D746869732E5F73746172744F66667365742B746869732E5F64656C74614F66667365747D676574436C6173734E616D652865297B72657475726E20746869732E5F736F757263652E676574436C6173734E616D6528746869732E5F';
wwv_flow_imp.g_varchar2_table(7678) := '6669727374546F6B656E496E6465782B65297D676574496E6C696E655374796C6528652C74297B72657475726E20746869732E5F736F757263652E676574496E6C696E655374796C6528746869732E5F6669727374546F6B656E496E6465782B652C7429';
wwv_flow_imp.g_varchar2_table(7679) := '7D67657450726573656E746174696F6E2865297B72657475726E20746869732E5F736F757263652E67657450726573656E746174696F6E28746869732E5F6669727374546F6B656E496E6465782B65297D66696E64546F6B656E496E64657841744F6666';
wwv_flow_imp.g_varchar2_table(7680) := '7365742865297B72657475726E20746869732E5F736F757263652E66696E64546F6B656E496E64657841744F666673657428652B746869732E5F73746172744F66667365742D746869732E5F64656C74614F6666736574292D746869732E5F6669727374';
wwv_flow_imp.g_varchar2_table(7681) := '546F6B656E496E6465787D7D636C6173732071777B636F6E7374727563746F7228652C74297B746869732E746F6B656E697A6174696F6E537570706F72743D742C746869732E696E697469616C53746174653D746869732E746F6B656E697A6174696F6E';
wwv_flow_imp.g_varchar2_table(7682) := '537570706F72742E676574496E697469616C537461746528292C746869732E73746F72653D6E65772055772865297D676574537461727453746174652865297B72657475726E20746869732E73746F72652E6765745374617274537461746528652C7468';
wwv_flow_imp.g_varchar2_table(7683) := '69732E696E697469616C5374617465297D6765744669727374496E76616C69644C696E6528297B72657475726E20746869732E73746F72652E6765744669727374496E76616C69644C696E6528746869732E696E697469616C5374617465297D7D636C61';
wwv_flow_imp.g_varchar2_table(7684) := '737320247720657874656E64732071777B636F6E7374727563746F7228652C742C6E2C69297B737570657228652C74292C746869732E5F746578744D6F64656C3D6E2C746869732E5F6C616E67756167654964436F6465633D697D757064617465546F6B';
wwv_flow_imp.g_varchar2_table(7685) := '656E73556E74696C4C696E6528652C74297B636F6E7374206E3D746869732E5F746578744D6F64656C2E6765744C616E6775616765496428293B666F72283B3B297B636F6E737420693D746869732E6765744669727374496E76616C69644C696E652829';
wwv_flow_imp.g_varchar2_table(7686) := '3B69662821697C7C692E6C696E654E756D6265723E7429627265616B3B636F6E7374206F3D746869732E5F746578744D6F64656C2E6765744C696E65436F6E74656E7428692E6C696E654E756D626572292C733D517728746869732E5F6C616E67756167';
wwv_flow_imp.g_varchar2_table(7687) := '654964436F6465632C6E2C746869732E746F6B656E697A6174696F6E537570706F72742C6F2C21302C692E73746172745374617465293B652E61646428692E6C696E654E756D6265722C732E746F6B656E73292C746869732E73746F72652E736574456E';
wwv_flow_imp.g_varchar2_table(7688) := '64537461746528692E6C696E654E756D6265722C732E656E645374617465297D7D676574546F6B656E547970654966496E73657274696E6743686172616374657228652C74297B636F6E7374206E3D746869732E6765745374617274537461746528652E';
wwv_flow_imp.g_varchar2_table(7689) := '6C696E654E756D626572293B696628216E2972657475726E20303B636F6E737420693D746869732E5F746578744D6F64656C2E6765744C616E6775616765496428292C6F3D746869732E5F746578744D6F64656C2E6765744C696E65436F6E74656E7428';
wwv_flow_imp.g_varchar2_table(7690) := '652E6C696E654E756D626572292C733D6F2E737562737472696E6728302C652E636F6C756D6E2D31292B742B6F2E737562737472696E6728652E636F6C756D6E2D31292C723D517728746869732E5F6C616E67756167654964436F6465632C692C746869';
wwv_flow_imp.g_varchar2_table(7691) := '732E746F6B656E697A6174696F6E537570706F72742C732C21302C6E292C613D6E657720577728722E746F6B656E732C732C746869732E5F6C616E67756167654964436F646563293B696628303D3D3D612E676574436F756E7428292972657475726E20';
wwv_flow_imp.g_varchar2_table(7692) := '303B636F6E7374206C3D612E66696E64546F6B656E496E64657841744F666673657428652E636F6C756D6E2D31293B72657475726E20612E6765745374616E64617264546F6B656E54797065286C297D746F6B656E697A654C696E655769746845646974';
wwv_flow_imp.g_varchar2_table(7693) := '28652C742C6E297B636F6E737420693D652E6C696E654E756D6265722C6F3D652E636F6C756D6E2C733D746869732E676574537461727453746174652869293B69662821732972657475726E206E756C6C3B636F6E737420723D746869732E5F74657874';
wwv_flow_imp.g_varchar2_table(7694) := '4D6F64656C2E6765744C696E65436F6E74656E742869292C613D722E737562737472696E6728302C6F2D31292B6E2B722E737562737472696E67286F2D312B74292C6C3D746869732E5F746578744D6F64656C2E6765744C616E67756167654964417450';
wwv_flow_imp.g_varchar2_table(7695) := '6F736974696F6E28692C30292C633D517728746869732E5F6C616E67756167654964436F6465632C6C2C746869732E746F6B656E697A6174696F6E537570706F72742C612C21302C73293B72657475726E206E657720577728632E746F6B656E732C612C';
wwv_flow_imp.g_varchar2_table(7696) := '746869732E5F6C616E67756167654964436F646563297D6861734163637572617465546F6B656E73466F724C696E652865297B72657475726E20653C746869732E73746F72652E6765744669727374496E76616C6964456E6453746174654C696E654E75';
wwv_flow_imp.g_varchar2_table(7697) := '6D6265724F724D617828297D69734368656170546F546F6B656E697A652865297B636F6E737420743D746869732E73746F72652E6765744669727374496E76616C6964456E6453746174654C696E654E756D6265724F724D617828293B72657475726E20';
wwv_flow_imp.g_varchar2_table(7698) := '653C747C7C653D3D3D742626746869732E5F746578744D6F64656C2E6765744C696E654C656E6774682865293C323034387D746F6B656E697A65486575726973746963616C6C7928652C742C6E297B6966286E3C3D746869732E73746F72652E67657446';
wwv_flow_imp.g_varchar2_table(7699) := '69727374496E76616C6964456E6453746174654C696E654E756D6265724F724D617828292972657475726E7B686575726973746963546F6B656E733A21317D3B696628743C3D746869732E73746F72652E6765744669727374496E76616C6964456E6453';
wwv_flow_imp.g_varchar2_table(7700) := '746174654C696E654E756D6265724F724D617828292972657475726E20746869732E757064617465546F6B656E73556E74696C4C696E6528652C6E292C7B686575726973746963546F6B656E733A21317D3B6C657420693D746869732E67756573735374';
wwv_flow_imp.g_varchar2_table(7701) := '61727453746174652874293B636F6E7374206F3D746869732E5F746578744D6F64656C2E6765744C616E6775616765496428293B666F72286C657420733D743B733C3D6E3B732B2B297B636F6E737420743D746869732E5F746578744D6F64656C2E6765';
wwv_flow_imp.g_varchar2_table(7702) := '744C696E65436F6E74656E742873292C6E3D517728746869732E5F6C616E67756167654964436F6465632C6F2C746869732E746F6B656E697A6174696F6E537570706F72742C742C21302C69293B652E61646428732C6E2E746F6B656E73292C693D6E2E';
wwv_flow_imp.g_varchar2_table(7703) := '656E6453746174657D72657475726E7B686575726973746963546F6B656E733A21307D7D6775657373537461727453746174652865297B6C657420743D746869732E5F746578744D6F64656C2E6765744C696E6546697273744E6F6E5768697465737061';
wwv_flow_imp.g_varchar2_table(7704) := '6365436F6C756D6E2865293B636F6E7374206E3D5B5D3B6C657420693D6E756C6C3B666F72286C6574206F3D652D313B743E3126266F3E3D313B6F2D2D297B636F6E737420653D746869732E5F746578744D6F64656C2E6765744C696E6546697273744E';
wwv_flow_imp.g_varchar2_table(7705) := '6F6E57686974657370616365436F6C756D6E286F293B69662830213D3D652626653C742626286E2E7075736828746869732E5F746578744D6F64656C2E6765744C696E65436F6E74656E74286F29292C743D652C693D746869732E676574537461727453';
wwv_flow_imp.g_varchar2_table(7706) := '74617465286F292C692929627265616B7D697C7C28693D746869732E746F6B656E697A6174696F6E537570706F72742E676574496E697469616C53746174652829292C6E2E7265766572736528293B636F6E7374206F3D746869732E5F746578744D6F64';
wwv_flow_imp.g_varchar2_table(7707) := '656C2E6765744C616E6775616765496428293B6C657420733D693B666F7228636F6E73742065206F66206E29733D517728746869732E5F6C616E67756167654964436F6465632C6F2C746869732E746F6B656E697A6174696F6E537570706F72742C652C';
wwv_flow_imp.g_varchar2_table(7708) := '21312C73292E656E6453746174653B72657475726E20737D7D636C6173732055777B636F6E7374727563746F722865297B746869732E6C696E65436F756E743D652C746869732E5F746F6B656E697A6174696F6E537461746553746F72653D6E6577204B';
wwv_flow_imp.g_varchar2_table(7709) := '772C746869732E5F696E76616C6964456E645374617465734C696E654E756D626572733D6E65772047772C746869732E5F696E76616C6964456E645374617465734C696E654E756D626572732E61646452616E6765286E6577206D7528312C652B312929';
wwv_flow_imp.g_varchar2_table(7710) := '7D676574456E6453746174652865297B72657475726E20746869732E5F746F6B656E697A6174696F6E537461746553746F72652E676574456E6453746174652865297D736574456E64537461746528652C74297B6966282174297468726F77206E657720';
wwv_flow_imp.g_varchar2_table(7711) := '4F65282243616E6E6F7420736574206E756C6C2F756E646566696E656420737461746522293B746869732E5F696E76616C6964456E645374617465734C696E654E756D626572732E64656C6574652865293B636F6E7374206E3D746869732E5F746F6B65';
wwv_flow_imp.g_varchar2_table(7712) := '6E697A6174696F6E537461746553746F72652E736574456E64537461746528652C74293B72657475726E206E2626653C746869732E6C696E65436F756E742626746869732E5F696E76616C6964456E645374617465734C696E654E756D626572732E6164';
wwv_flow_imp.g_varchar2_table(7713) := '6452616E6765286E6577206D7528652B312C652B3229292C6E7D6163636570744368616E676528652C74297B746869732E6C696E65436F756E742B3D742D652E6C656E6774682C746869732E5F746F6B656E697A6174696F6E537461746553746F72652E';
wwv_flow_imp.g_varchar2_table(7714) := '6163636570744368616E676528652C74292C746869732E5F696E76616C6964456E645374617465734C696E654E756D626572732E61646452616E6765416E64526573697A65286E6577206D7528652E73746172744C696E654E756D6265722C652E656E64';
wwv_flow_imp.g_varchar2_table(7715) := '4C696E654E756D6265724578636C7573697665292C74297D6163636570744368616E6765732865297B666F7228636F6E73742074206F662065297B636F6E73745B655D3D757528742E74657874293B746869732E6163636570744368616E6765286E6577';
wwv_flow_imp.g_varchar2_table(7716) := '20787528742E72616E67652E73746172744C696E654E756D6265722C742E72616E67652E656E644C696E654E756D6265722B31292C652B31297D7D696E76616C6964617465456E64537461746552616E67652865297B746869732E5F696E76616C696445';
wwv_flow_imp.g_varchar2_table(7717) := '6E645374617465734C696E654E756D626572732E61646452616E6765286E6577206D7528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265724578636C757369766529297D6765744669727374496E76616C6964456E6453';
wwv_flow_imp.g_varchar2_table(7718) := '746174654C696E654E756D62657228297B72657475726E20746869732E5F696E76616C6964456E645374617465734C696E654E756D626572732E6D696E7D6765744669727374496E76616C6964456E6453746174654C696E654E756D6265724F724D6178';
wwv_flow_imp.g_varchar2_table(7719) := '28297B72657475726E20746869732E6765744669727374496E76616C6964456E6453746174654C696E654E756D62657228297C7C4E756D6265722E4D41585F534146455F494E54454745527D616C6C53746174657356616C696428297B72657475726E20';
wwv_flow_imp.g_varchar2_table(7720) := '6E756C6C3D3D3D746869732E5F696E76616C6964456E645374617465734C696E654E756D626572732E6D696E7D6765745374617274537461746528652C74297B72657475726E20313D3D3D653F743A746869732E676574456E64537461746528652D3129';
wwv_flow_imp.g_varchar2_table(7721) := '7D6765744669727374496E76616C69644C696E652865297B636F6E737420743D746869732E6765744669727374496E76616C6964456E6453746174654C696E654E756D62657228293B6966286E756C6C3D3D3D742972657475726E206E756C6C3B636F6E';
wwv_flow_imp.g_varchar2_table(7722) := '7374206E3D746869732E6765745374617274537461746528742C65293B696628216E297468726F77206E6577204F6528225374617274207374617465206D75737420626520646566696E656422293B72657475726E7B6C696E654E756D6265723A742C73';
wwv_flow_imp.g_varchar2_table(7723) := '7461727453746174653A6E7D7D7D636C617373204B777B636F6E7374727563746F7228297B746869732E5F6C696E65456E645374617465733D6E6577205677286E756C6C297D676574456E6453746174652865297B72657475726E20746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(7724) := '6E65456E645374617465732E6765742865297D736574456E64537461746528652C74297B636F6E7374206E3D746869732E5F6C696E65456E645374617465732E6765742865293B72657475726E21286E26266E2E657175616C732874297C7C2874686973';
wwv_flow_imp.g_varchar2_table(7725) := '2E5F6C696E65456E645374617465732E73657428652C74292C3029297D6163636570744368616E676528652C74297B6C6574206E3D652E6C656E6774683B743E3026266E3E302626286E2D2D2C742D2D292C746869732E5F6C696E65456E645374617465';
wwv_flow_imp.g_varchar2_table(7726) := '732E7265706C61636528652E73746172744C696E654E756D6265722C6E2C74297D7D636C6173732047777B636F6E7374727563746F7228297B746869732E5F72616E6765733D5B5D7D676574206D696E28297B72657475726E20303D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(7727) := '72616E6765732E6C656E6774683F6E756C6C3A746869732E5F72616E6765735B305D2E73746172747D64656C6574652865297B636F6E737420743D746869732E5F72616E6765732E66696E64496E6465782828743D3E742E636F6E7461696E7328652929';
wwv_flow_imp.g_varchar2_table(7728) := '293B6966282D31213D3D74297B636F6E7374206E3D746869732E5F72616E6765735B745D3B6E2E73746172743D3D3D653F6E2E656E644578636C75736976653D3D3D652B313F746869732E5F72616E6765732E73706C69636528742C31293A746869732E';
wwv_flow_imp.g_varchar2_table(7729) := '5F72616E6765735B745D3D6E6577206D7528652B312C6E2E656E644578636C7573697665293A6E2E656E644578636C75736976653D3D3D652B313F746869732E5F72616E6765735B745D3D6E6577206D75286E2E73746172742C65293A746869732E5F72';
wwv_flow_imp.g_varchar2_table(7730) := '616E6765732E73706C69636528742C312C6E6577206D75286E2E73746172742C65292C6E6577206D7528652B312C6E2E656E644578636C757369766529297D7D61646452616E67652865297B6D752E61646452616E676528652C746869732E5F72616E67';
wwv_flow_imp.g_varchar2_table(7731) := '6573297D61646452616E6765416E64526573697A6528652C74297B6C6574206E3D303B666F72283B21286E3E3D746869732E5F72616E6765732E6C656E6774687C7C652E73746172743C3D746869732E5F72616E6765735B6E5D2E656E644578636C7573';
wwv_flow_imp.g_varchar2_table(7732) := '697665293B296E2B2B3B6C657420693D6E3B666F72283B2128693E3D746869732E5F72616E6765732E6C656E6774687C7C652E656E644578636C75736976653C746869732E5F72616E6765735B695D2E7374617274293B29692B2B3B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(7733) := '742D652E6C656E6774683B666F72286C657420653D693B653C746869732E5F72616E6765732E6C656E6774683B652B2B29746869732E5F72616E6765735B655D3D746869732E5F72616E6765735B655D2E64656C7461286F293B6966286E3D3D3D69297B';
wwv_flow_imp.g_varchar2_table(7734) := '636F6E737420693D6E6577206D7528652E73746172742C652E73746172742B74293B692E6973456D7074797C7C746869732E5F72616E6765732E73706C696365286E2C302C69297D656C73657B636F6E737420743D4D6174682E6D696E28652E73746172';
wwv_flow_imp.g_varchar2_table(7735) := '742C746869732E5F72616E6765735B6E5D2E7374617274292C733D4D6174682E6D617828652E656E644578636C75736976652C746869732E5F72616E6765735B692D315D2E656E644578636C7573697665292C723D6E6577206D7528742C732B6F293B72';
wwv_flow_imp.g_varchar2_table(7736) := '2E6973456D7074793F746869732E5F72616E6765732E73706C696365286E2C692D6E293A746869732E5F72616E6765732E73706C696365286E2C692D6E2C72297D7D746F537472696E6728297B72657475726E20746869732E5F72616E6765732E6D6170';
wwv_flow_imp.g_varchar2_table(7737) := '2828653D3E652E746F537472696E67282929292E6A6F696E2822202B2022297D7D66756E6374696F6E20517728652C742C6E2C692C6F2C73297B6C657420723D6E756C6C3B6966286E297472797B723D6E2E746F6B656E697A65456E636F64656428692C';
wwv_flow_imp.g_varchar2_table(7738) := '6F2C732E636C6F6E652829297D63617463682865297B6B652865297D72657475726E20727C7C28723D427728652E656E636F64654C616E677561676549642874292C7329292C57772E636F6E76657274546F456E644F666673657428722E746F6B656E73';
wwv_flow_imp.g_varchar2_table(7739) := '2C692E6C656E677468292C727D636C6173732059777B636F6E7374727563746F7228652C74297B746869732E5F746F6B656E697A657257697468537461746553746F72653D652C746869732E5F6261636B67726F756E64546F6B656E53746F72653D742C';
wwv_flow_imp.g_varchar2_table(7740) := '746869732E5F6973446973706F7365643D21312C746869732E5F69735363686564756C65643D21317D646973706F736528297B746869732E5F6973446973706F7365643D21307D68616E646C654368616E67657328297B746869732E5F626567696E4261';
wwv_flow_imp.g_varchar2_table(7741) := '636B67726F756E64546F6B656E697A6174696F6E28297D5F626567696E4261636B67726F756E64546F6B656E697A6174696F6E28297B21746869732E5F69735363686564756C65642626746869732E5F746F6B656E697A65725769746853746174655374';
wwv_flow_imp.g_varchar2_table(7742) := '6F72652E5F746578744D6F64656C2E69734174746163686564546F456469746F7228292626746869732E5F6861734C696E6573546F546F6B656E697A652829262628746869732E5F69735363686564756C65643D21302C47742828653D3E7B746869732E';
wwv_flow_imp.g_varchar2_table(7743) := '5F69735363686564756C65643D21312C746869732E5F6261636B67726F756E64546F6B656E697A6557697468446561646C696E652865297D2929297D5F6261636B67726F756E64546F6B656E697A6557697468446561646C696E652865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(7744) := '20743D446174652E6E6F7728292B652E74696D6552656D61696E696E6728292C6E3D28293D3E7B21746869732E5F6973446973706F7365642626746869732E5F746F6B656E697A657257697468537461746553746F72652E5F746578744D6F64656C2E69';
wwv_flow_imp.g_varchar2_table(7745) := '734174746163686564546F456469746F7228292626746869732E5F6861734C696E6573546F546F6B656E697A652829262628746869732E5F6261636B67726F756E64546F6B656E697A65466F7241744C65617374316D7328292C446174652E6E6F772829';
wwv_flow_imp.g_varchar2_table(7746) := '3C743F6565286E293A746869732E5F626567696E4261636B67726F756E64546F6B656E697A6174696F6E2829297D3B6E28297D5F6261636B67726F756E64546F6B656E697A65466F7241744C65617374316D7328297B636F6E737420653D746869732E5F';
wwv_flow_imp.g_varchar2_table(7747) := '746F6B656E697A657257697468537461746553746F72652E5F746578744D6F64656C2E6765744C696E65436F756E7428292C743D6E65772048772C6E3D66742E637265617465282131293B646F7B6966286E2E656C617073656428293E3129627265616B';
wwv_flow_imp.g_varchar2_table(7748) := '3B696628746869732E5F746F6B656E697A654F6E65496E76616C69644C696E652874293E3D6529627265616B7D7768696C6528746869732E5F6861734C696E6573546F546F6B656E697A652829293B746869732E5F6261636B67726F756E64546F6B656E';
wwv_flow_imp.g_varchar2_table(7749) := '53746F72652E736574546F6B656E7328742E66696E616C697A652829292C746869732E636865636B46696E697368656428297D5F6861734C696E6573546F546F6B656E697A6528297B72657475726E2121746869732E5F746F6B656E697A657257697468';
wwv_flow_imp.g_varchar2_table(7750) := '537461746553746F7265262621746869732E5F746F6B656E697A657257697468537461746553746F72652E73746F72652E616C6C53746174657356616C696428297D5F746F6B656E697A654F6E65496E76616C69644C696E652865297B76617220743B63';
wwv_flow_imp.g_varchar2_table(7751) := '6F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F746F6B656E697A657257697468537461746553746F7265297C7C766F696420303D3D3D743F766F696420303A742E6765744669727374496E76616C69644C696E6528293B72657475726E206E3F';
wwv_flow_imp.g_varchar2_table(7752) := '28746869732E5F746F6B656E697A657257697468537461746553746F72652E757064617465546F6B656E73556E74696C4C696E6528652C6E2E6C696E654E756D626572292C6E2E6C696E654E756D626572293A746869732E5F746F6B656E697A65725769';
wwv_flow_imp.g_varchar2_table(7753) := '7468537461746553746F72652E5F746578744D6F64656C2E6765744C696E65436F756E7428292B317D636865636B46696E697368656428297B746869732E5F6973446973706F7365647C7C746869732E5F746F6B656E697A657257697468537461746553';
wwv_flow_imp.g_varchar2_table(7754) := '746F72652E73746F72652E616C6C53746174657356616C696428292626746869732E5F6261636B67726F756E64546F6B656E53746F72652E6261636B67726F756E64546F6B656E697A6174696F6E46696E697368656428297D72657175657374546F6B65';
wwv_flow_imp.g_varchar2_table(7755) := '6E7328652C74297B746869732E5F746F6B656E697A657257697468537461746553746F72652E73746F72652E696E76616C6964617465456E64537461746552616E6765286E657720787528652C7429297D7D636F6E7374205A773D6E65772055696E7433';
wwv_flow_imp.g_varchar2_table(7756) := '3241727261792830292E6275666665723B636C6173732058777B7374617469632064656C657465426567696E6E696E6728652C74297B72657475726E206E756C6C3D3D3D657C7C653D3D3D5A773F653A58772E64656C65746528652C302C74297D737461';
wwv_flow_imp.g_varchar2_table(7757) := '7469632064656C657465456E64696E6728652C74297B6966286E756C6C3D3D3D657C7C653D3D3D5A772972657475726E20653B636F6E7374206E3D4A772865292C693D6E5B6E2E6C656E6774682D325D3B72657475726E2058772E64656C65746528652C';
wwv_flow_imp.g_varchar2_table(7758) := '742C69297D7374617469632064656C65746528652C742C6E297B6966286E756C6C3D3D3D657C7C653D3D3D5A777C7C743D3D3D6E2972657475726E20653B636F6E737420693D4A772865292C6F3D692E6C656E6774683E3E3E313B696628303D3D3D7426';
wwv_flow_imp.g_varchar2_table(7759) := '26695B692E6C656E6774682D325D3D3D3D6E2972657475726E205A773B636F6E737420733D57772E66696E64496E646578496E546F6B656E73417272617928692C74292C723D733E303F695B732D313C3C315D3A303B6966286E3C695B733C3C315D297B';
wwv_flow_imp.g_varchar2_table(7760) := '636F6E737420723D6E2D743B666F72286C657420653D733B653C6F3B652B2B29695B653C3C315D2D3D723B72657475726E20657D6C657420612C6C3B72213D3D743F28695B733C3C315D3D742C613D732B313C3C312C6C3D74293A28613D733C3C312C6C';
wwv_flow_imp.g_varchar2_table(7761) := '3D72293B636F6E737420633D6E2D743B666F72286C657420653D732B313B653C6F3B652B2B297B636F6E737420743D695B653C3C315D2D633B743E6C262628695B612B2B5D3D742C695B612B2B5D3D695B312B28653C3C31295D2C6C3D74297D69662861';
wwv_flow_imp.g_varchar2_table(7762) := '3D3D3D692E6C656E6774682972657475726E20653B636F6E737420643D6E65772055696E74333241727261792861293B72657475726E20642E73657428692E737562617272617928302C61292C30292C642E6275666665727D7374617469632061707065';
wwv_flow_imp.g_varchar2_table(7763) := '6E6428652C74297B696628743D3D3D5A772972657475726E20653B696628653D3D3D5A772972657475726E20743B6966286E756C6C3D3D3D652972657475726E20653B6966286E756C6C3D3D3D742972657475726E206E756C6C3B636F6E7374206E3D4A';
wwv_flow_imp.g_varchar2_table(7764) := '772865292C693D4A772874292C6F3D692E6C656E6774683E3E3E312C733D6E65772055696E7433324172726179286E2E6C656E6774682B692E6C656E677468293B732E736574286E2C30293B6C657420723D6E2E6C656E6774683B636F6E737420613D6E';
wwv_flow_imp.g_varchar2_table(7765) := '5B6E2E6C656E6774682D325D3B666F72286C657420653D303B653C6F3B652B2B29735B722B2B5D3D695B653C3C315D2B612C735B722B2B5D3D695B312B28653C3C31295D3B72657475726E20732E6275666665727D73746174696320696E736572742865';
wwv_flow_imp.g_varchar2_table(7766) := '2C742C6E297B6966286E756C6C3D3D3D657C7C653D3D3D5A772972657475726E20653B636F6E737420693D4A772865292C6F3D692E6C656E6774683E3E3E313B6C657420733D57772E66696E64496E646578496E546F6B656E73417272617928692C7429';
wwv_flow_imp.g_varchar2_table(7767) := '3B733E302626695B732D313C3C315D3D3D3D742626732D2D3B666F72286C657420653D733B653C6F3B652B2B29695B653C3C315D2B3D6E3B72657475726E20657D7D66756E6374696F6E204A772865297B72657475726E206520696E7374616E63656F66';
wwv_flow_imp.g_varchar2_table(7768) := '2055696E74333241727261793F653A6E65772055696E74333241727261792865297D636C6173732065437B636F6E7374727563746F722865297B746869732E5F6C696E65546F6B656E733D5B5D2C746869732E5F6C656E3D302C746869732E5F6C616E67';
wwv_flow_imp.g_varchar2_table(7769) := '756167654964436F6465633D657D666C75736828297B746869732E5F6C696E65546F6B656E733D5B5D2C746869732E5F6C656E3D307D67657420686173546F6B656E7328297B72657475726E20746869732E5F6C696E65546F6B656E732E6C656E677468';
wwv_flow_imp.g_varchar2_table(7770) := '3E307D676574546F6B656E7328652C742C6E297B6C657420693D6E756C6C3B696628743C746869732E5F6C656E262628693D746869732E5F6C696E65546F6B656E735B745D292C6E756C6C213D3D69262669213D3D5A772972657475726E206E65772057';
wwv_flow_imp.g_varchar2_table(7771) := '77284A772869292C6E2C746869732E5F6C616E67756167654964436F646563293B636F6E7374206F3D6E65772055696E74333241727261792832293B72657475726E206F5B305D3D6E2E6C656E6774682C6F5B315D3D744328746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(7772) := '6167654964436F6465632E656E636F64654C616E67756167654964286529292C6E6577205777286F2C6E2C746869732E5F6C616E67756167654964436F646563297D737461746963205F6D617373616765546F6B656E7328652C742C6E297B636F6E7374';
wwv_flow_imp.g_varchar2_table(7773) := '20693D6E3F4A77286E293A6E756C6C3B696628303D3D3D74297B6C657420743D21313B696628692626692E6C656E6774683E31262628743D51672E6765744C616E6775616765496428695B315D29213D3D65292C21742972657475726E205A777D696628';
wwv_flow_imp.g_varchar2_table(7774) := '21697C7C303D3D3D692E6C656E677468297B636F6E7374206E3D6E65772055696E74333241727261792832293B72657475726E206E5B305D3D742C6E5B315D3D74432865292C6E2E6275666665727D72657475726E20695B692E6C656E6774682D325D3D';
wwv_flow_imp.g_varchar2_table(7775) := '742C303D3D3D692E627974654F66667365742626692E627974654C656E6774683D3D3D692E6275666665722E627974654C656E6774683F692E6275666665723A697D5F656E737572654C696E652865297B666F72283B653E3D746869732E5F6C656E3B29';
wwv_flow_imp.g_varchar2_table(7776) := '746869732E5F6C696E65546F6B656E735B746869732E5F6C656E5D3D6E756C6C2C746869732E5F6C656E2B2B7D5F64656C6574654C696E657328652C74297B30213D3D74262628652B743E746869732E5F6C656E262628743D746869732E5F6C656E2D65';
wwv_flow_imp.g_varchar2_table(7777) := '292C746869732E5F6C696E65546F6B656E732E73706C69636528652C74292C746869732E5F6C656E2D3D74297D5F696E736572744C696E657328652C74297B696628303D3D3D742972657475726E3B636F6E7374206E3D5B5D3B666F72286C657420653D';
wwv_flow_imp.g_varchar2_table(7778) := '303B653C743B652B2B296E5B655D3D6E756C6C3B746869732E5F6C696E65546F6B656E733D4B6828746869732E5F6C696E65546F6B656E732C652C6E292C746869732E5F6C656E2B3D747D736574546F6B656E7328652C742C6E2C692C6F297B636F6E73';
wwv_flow_imp.g_varchar2_table(7779) := '7420733D65432E5F6D617373616765546F6B656E7328746869732E5F6C616E67756167654964436F6465632E656E636F64654C616E677561676549642865292C6E2C69293B746869732E5F656E737572654C696E652874293B636F6E737420723D746869';
wwv_flow_imp.g_varchar2_table(7780) := '732E5F6C696E65546F6B656E735B745D3B72657475726E20746869732E5F6C696E65546F6B656E735B745D3D732C21216F26262165432E5F657175616C7328722C73297D737461746963205F657175616C7328652C74297B69662821657C7C2174297265';
wwv_flow_imp.g_varchar2_table(7781) := '7475726E2165262621743B636F6E7374206E3D4A772865292C693D4A772874293B6966286E2E6C656E677468213D3D692E6C656E6774682972657475726E21313B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B296966286E';
wwv_flow_imp.g_varchar2_table(7782) := '5B655D213D3D695B655D2972657475726E21313B72657475726E21307D6163636570744564697428652C742C6E297B746869732E5F61636365707444656C65746552616E67652865292C746869732E5F616363657074496E7365727454657874286E6577';
wwv_flow_imp.g_varchar2_table(7783) := '206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C742C6E297D5F61636365707444656C65746552616E67652865297B636F6E737420743D652E73746172744C696E654E756D6265722D313B696628743E3D7468';
wwv_flow_imp.g_varchar2_table(7784) := '69732E5F6C656E2972657475726E3B696628652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D626572297B696628652E7374617274436F6C756D6E3D3D3D652E656E64436F6C756D6E2972657475726E3B72657475726E20';
wwv_flow_imp.g_varchar2_table(7785) := '766F696428746869732E5F6C696E65546F6B656E735B745D3D58772E64656C65746528746869732E5F6C696E65546F6B656E735B745D2C652E7374617274436F6C756D6E2D312C652E656E64436F6C756D6E2D3129297D746869732E5F6C696E65546F6B';
wwv_flow_imp.g_varchar2_table(7786) := '656E735B745D3D58772E64656C657465456E64696E6728746869732E5F6C696E65546F6B656E735B745D2C652E7374617274436F6C756D6E2D31293B636F6E7374206E3D652E656E644C696E654E756D6265722D313B6C657420693D6E756C6C3B6E3C74';
wwv_flow_imp.g_varchar2_table(7787) := '6869732E5F6C656E262628693D58772E64656C657465426567696E6E696E6728746869732E5F6C696E65546F6B656E735B6E5D2C652E656E64436F6C756D6E2D3129292C746869732E5F6C696E65546F6B656E735B745D3D58772E617070656E64287468';
wwv_flow_imp.g_varchar2_table(7788) := '69732E5F6C696E65546F6B656E735B745D2C69292C746869732E5F64656C6574654C696E657328652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D626572297D5F61636365707449';
wwv_flow_imp.g_varchar2_table(7789) := '6E736572745465787428652C742C6E297B696628303D3D3D742626303D3D3D6E2972657475726E3B636F6E737420693D652E6C696E654E756D6265722D313B693E3D746869732E5F6C656E7C7C2830213D3D743F28746869732E5F6C696E65546F6B656E';
wwv_flow_imp.g_varchar2_table(7790) := '735B695D3D58772E64656C657465456E64696E6728746869732E5F6C696E65546F6B656E735B695D2C652E636F6C756D6E2D31292C746869732E5F6C696E65546F6B656E735B695D3D58772E696E7365727428746869732E5F6C696E65546F6B656E735B';
wwv_flow_imp.g_varchar2_table(7791) := '695D2C652E636F6C756D6E2D312C6E292C746869732E5F696E736572744C696E657328652E6C696E654E756D6265722C7429293A746869732E5F6C696E65546F6B656E735B695D3D58772E696E7365727428746869732E5F6C696E65546F6B656E735B69';
wwv_flow_imp.g_varchar2_table(7792) := '5D2C652E636F6C756D6E2D312C6E29297D7365744D756C74696C696E65546F6B656E7328652C74297B696628303D3D3D652E6C656E6774682972657475726E7B6368616E6765733A5B5D7D3B636F6E7374206E3D5B5D3B666F72286C657420693D302C6F';
wwv_flow_imp.g_varchar2_table(7793) := '3D652E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D655B695D3B6C657420733D302C723D302C613D21313B666F72286C657420653D6F2E73746172744C696E654E756D6265723B653C3D6F2E656E644C696E654E756D6265723B652B2B29';
wwv_flow_imp.g_varchar2_table(7794) := '613F28746869732E736574546F6B656E7328742E6765744C616E6775616765496428292C652D312C742E6765744C696E654C656E6774682865292C6F2E6765744C696E65546F6B656E732865292C2131292C723D65293A746869732E736574546F6B656E';
wwv_flow_imp.g_varchar2_table(7795) := '7328742E6765744C616E6775616765496428292C652D312C742E6765744C696E654C656E6774682865292C6F2E6765744C696E65546F6B656E732865292C213029262628613D21302C733D652C723D65293B6126266E2E70757368287B66726F6D4C696E';
wwv_flow_imp.g_varchar2_table(7796) := '654E756D6265723A732C746F4C696E654E756D6265723A727D297D72657475726E7B6368616E6765733A6E7D7D7D66756E6374696F6E2074432865297B72657475726E2833323736387C657C323C3C32347C31303234293E3E3E307D636C617373206E43';
wwv_flow_imp.g_varchar2_table(7797) := '7B636F6E7374727563746F722865297B746869732E5F7069656365733D5B5D2C746869732E5F6973436F6D706C6574653D21312C746869732E5F6C616E67756167654964436F6465633D657D666C75736828297B746869732E5F7069656365733D5B5D2C';
wwv_flow_imp.g_varchar2_table(7798) := '746869732E5F6973436F6D706C6574653D21317D6973456D70747928297B72657475726E20303D3D3D746869732E5F7069656365732E6C656E6774687D73657428652C74297B746869732E5F7069656365733D657C7C5B5D2C746869732E5F6973436F6D';
wwv_flow_imp.g_varchar2_table(7799) := '706C6574653D747D7365745061727469616C28652C74297B6C6574206E3D653B696628742E6C656E6774683E30297B636F6E737420693D745B305D2E67657452616E676528292C6F3D745B742E6C656E6774682D315D2E67657452616E676528293B6966';
wwv_flow_imp.g_varchar2_table(7800) := '2821697C7C216F2972657475726E20653B6E3D652E706C757352616E67652869292E706C757352616E6765286F297D6C657420693D6E756C6C3B666F72286C657420653D302C743D746869732E5F7069656365732E6C656E6774683B653C743B652B2B29';
wwv_flow_imp.g_varchar2_table(7801) := '7B636F6E7374206F3D746869732E5F7069656365735B655D3B6966286F2E656E644C696E654E756D6265723C6E2E73746172744C696E654E756D62657229636F6E74696E75653B6966286F2E73746172744C696E654E756D6265723E6E2E656E644C696E';
wwv_flow_imp.g_varchar2_table(7802) := '654E756D626572297B693D697C7C7B696E6465783A657D3B627265616B7D6966286F2E72656D6F7665546F6B656E73286E292C6F2E6973456D7074792829297B746869732E5F7069656365732E73706C69636528652C31292C652D2D2C742D2D3B636F6E';
wwv_flow_imp.g_varchar2_table(7803) := '74696E75657D6966286F2E656E644C696E654E756D6265723C6E2E73746172744C696E654E756D62657229636F6E74696E75653B6966286F2E73746172744C696E654E756D6265723E6E2E656E644C696E654E756D626572297B693D697C7C7B696E6465';
wwv_flow_imp.g_varchar2_table(7804) := '783A657D3B636F6E74696E75657D636F6E73745B732C725D3D6F2E73706C6974286E293B732E6973456D70747928293F693D697C7C7B696E6465783A657D3A722E6973456D70747928297C7C28746869732E5F7069656365732E73706C69636528652C31';
wwv_flow_imp.g_varchar2_table(7805) := '2C732C72292C652B2B2C742B2B2C693D697C7C7B696E6465783A657D297D72657475726E20693D697C7C7B696E6465783A746869732E5F7069656365732E6C656E6774687D2C742E6C656E6774683E30262628746869732E5F7069656365733D4B682874';
wwv_flow_imp.g_varchar2_table(7806) := '6869732E5F7069656365732C692E696E6465782C7429292C6E7D6973436F6D706C65746528297B72657475726E20746869732E5F6973436F6D706C6574657D616464537061727365546F6B656E7328652C74297B696628303D3D3D742E6765744C696E65';
wwv_flow_imp.g_varchar2_table(7807) := '436F6E74656E7428292E6C656E6774682972657475726E20743B636F6E7374206E3D746869732E5F7069656365733B696628303D3D3D6E2E6C656E6774682972657475726E20743B636F6E737420693D6E5B6E432E5F66696E6446697273745069656365';
wwv_flow_imp.g_varchar2_table(7808) := '576974684C696E65286E2C65295D2E6765744C696E65546F6B656E732865293B69662821692972657475726E20743B636F6E7374206F3D742E676574436F756E7428292C733D692E676574436F756E7428293B6C657420723D303B636F6E737420613D5B';
wwv_flow_imp.g_varchar2_table(7809) := '5D3B6C6574206C3D302C633D303B636F6E737420643D28652C74293D3E7B65213D3D63262628633D652C615B6C2B2B5D3D652C615B6C2B2B5D3D74297D3B666F72286C657420653D303B653C733B652B2B297B636F6E7374206E3D692E67657453746172';
wwv_flow_imp.g_varchar2_table(7810) := '744368617261637465722865292C733D692E676574456E644368617261637465722865292C613D692E6765744D657461646174612865292C6C3D28283126613F323034383A30297C283226613F343039363A30297C283426613F383139323A30297C2838';
wwv_flow_imp.g_varchar2_table(7811) := '26613F31363338343A30297C28313626613F31363734343434383A30297C28333226613F343237383139303038303A3029293E3E3E302C633D7E6C3E3E3E303B666F72283B723C6F2626742E676574456E644F66667365742872293C3D6E3B296428742E';
wwv_flow_imp.g_varchar2_table(7812) := '676574456E644F66667365742872292C742E6765744D65746164617461287229292C722B2B3B666F7228723C6F2626742E67657453746172744F66667365742872293C6E262664286E2C742E6765744D65746164617461287229293B723C6F2626742E67';
wwv_flow_imp.g_varchar2_table(7813) := '6574456E644F66667365742872293C733B296428742E676574456E644F66667365742872292C742E6765744D6574616461746128722926637C61266C292C722B2B3B696628723C6F296428732C742E6765744D6574616461746128722926637C61266C29';
wwv_flow_imp.g_varchar2_table(7814) := '2C742E676574456E644F66667365742872293D3D3D732626722B2B3B656C73657B636F6E737420653D4D6174682E6D696E284D6174682E6D617828302C722D31292C6F2D31293B6428732C742E6765744D6574616461746128652926637C61266C297D7D';
wwv_flow_imp.g_varchar2_table(7815) := '666F72283B723C6F3B296428742E676574456E644F66667365742872292C742E6765744D65746164617461287229292C722B2B3B72657475726E206E6577205777286E65772055696E74333241727261792861292C742E6765744C696E65436F6E74656E';
wwv_flow_imp.g_varchar2_table(7816) := '7428292C746869732E5F6C616E67756167654964436F646563297D737461746963205F66696E6446697273745069656365576974684C696E6528652C74297B6C6574206E3D302C693D652E6C656E6774682D313B666F72283B6E3C693B297B6C6574206F';
wwv_flow_imp.g_varchar2_table(7817) := '3D6E2B4D6174682E666C6F6F722828692D6E292F32293B696628655B6F5D2E656E644C696E654E756D6265723C74296E3D6F2B313B656C73657B6966282128655B6F5D2E73746172744C696E654E756D6265723E7429297B666F72283B6F3E6E2626655B';
wwv_flow_imp.g_varchar2_table(7818) := '6F2D315D2E73746172744C696E654E756D6265723C3D742626743C3D655B6F2D315D2E656E644C696E654E756D6265723B296F2D2D3B72657475726E206F7D693D6F2D317D7D72657475726E206E7D6163636570744564697428652C742C6E2C692C6F29';
wwv_flow_imp.g_varchar2_table(7819) := '7B666F7228636F6E73742073206F6620746869732E5F70696563657329732E6163636570744564697428652C742C6E2C692C6F297D7D636C61737320694320657874656E647320585F7B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B73';
wwv_flow_imp.g_varchar2_table(7820) := '7570657228292C746869732E5F6C616E6775616765536572766963653D652C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E5F746578744D6F64656C3D6E2C746869732E5F627261636B657450';
wwv_flow_imp.g_varchar2_table(7821) := '61697273546578744D6F64656C506172743D692C746869732E5F6C616E677561676549643D6F2C746869732E5F617474616368656456696577733D732C746869732E5F73656D616E746963546F6B656E733D6E6577206E4328746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(7822) := '616765536572766963652E6C616E67756167654964436F646563292C746869732E5F6F6E4469644368616E67654C616E67756167653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67654C616E67756167';
wwv_flow_imp.g_varchar2_table(7823) := '653D746869732E5F6F6E4469644368616E67654C616E67756167652E6576656E742C746869732E5F6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E3D746869732E5F7265676973746572286E6577204374292C74686973';
wwv_flow_imp.g_varchar2_table(7824) := '2E6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E3D746869732E5F6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E2E6576656E742C746869732E5F6F6E4469644368616E6765546F6B65';
wwv_flow_imp.g_varchar2_table(7825) := '6E733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E6765546F6B656E733D746869732E5F6F6E4469644368616E6765546F6B656E732E6576656E742C746869732E6772616D6D6172546F6B656E733D7468';
wwv_flow_imp.g_varchar2_table(7826) := '69732E5F7265676973746572286E6577206F4328746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632C746869732E5F746578744D6F64656C2C2828293D3E746869732E5F6C616E67756167654964292C746869';
wwv_flow_imp.g_varchar2_table(7827) := '732E5F6174746163686564566965777329292C746869732E5F726567697374657228746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963652E6F6E4469644368616E67652828653D3E7B652E616666656374732874686973';
wwv_flow_imp.g_varchar2_table(7828) := '2E5F6C616E67756167654964292626746869732E5F6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E2E66697265287B7D297D2929292C746869732E5F726567697374657228746869732E6772616D6D6172546F6B656E73';
wwv_flow_imp.g_varchar2_table(7829) := '2E6F6E4469644368616E6765546F6B656E732828653D3E7B746869732E5F656D69744D6F64656C546F6B656E734368616E6765644576656E742865297D2929292C746869732E5F726567697374657228746869732E6772616D6D6172546F6B656E732E6F';
wwv_flow_imp.g_varchar2_table(7830) := '6E4469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E53746174652828653D3E7B746869732E5F627261636B65745061697273546578744D6F64656C506172742E68616E646C654469644368616E67654261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(7831) := '546F6B656E697A6174696F6E537461746528297D2929297D68616E646C654469644368616E6765436F6E74656E742865297B696628652E6973466C75736829746869732E5F73656D616E746963546F6B656E732E666C75736828293B656C736520696628';
wwv_flow_imp.g_varchar2_table(7832) := '21652E6973456F6C4368616E676529666F7228636F6E73742074206F6620652E6368616E676573297B636F6E73745B652C6E2C695D3D757528742E74657874293B746869732E5F73656D616E746963546F6B656E732E6163636570744564697428742E72';
wwv_flow_imp.g_varchar2_table(7833) := '616E67652C652C6E2C692C742E746578742E6C656E6774683E303F742E746578742E63686172436F646541742830293A30297D746869732E6772616D6D6172546F6B656E732E68616E646C654469644368616E6765436F6E74656E742865297D68616E64';
wwv_flow_imp.g_varchar2_table(7834) := '6C654469644368616E6765417474616368656428297B746869732E6772616D6D6172546F6B656E732E68616E646C654469644368616E6765417474616368656428297D6765744C696E65546F6B656E732865297B746869732E76616C69646174654C696E';
wwv_flow_imp.g_varchar2_table(7835) := '654E756D6265722865293B636F6E737420743D746869732E6772616D6D6172546F6B656E732E6765744C696E65546F6B656E732865293B72657475726E20746869732E5F73656D616E746963546F6B656E732E616464537061727365546F6B656E732865';
wwv_flow_imp.g_varchar2_table(7836) := '2C74297D5F656D69744D6F64656C546F6B656E734368616E6765644576656E742865297B746869732E5F746578744D6F64656C2E5F6973446973706F73696E6728297C7C28746869732E5F627261636B65745061697273546578744D6F64656C50617274';
wwv_flow_imp.g_varchar2_table(7837) := '2E68616E646C654469644368616E6765546F6B656E732865292C746869732E5F6F6E4469644368616E6765546F6B656E732E66697265286529297D76616C69646174654C696E654E756D6265722865297B696628653C317C7C653E746869732E5F746578';
wwv_flow_imp.g_varchar2_table(7838) := '744D6F64656C2E6765744C696E65436F756E742829297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222297D67657420686173546F6B656E7328297B72657475726E20746869732E6772616D6D';
wwv_flow_imp.g_varchar2_table(7839) := '6172546F6B656E732E686173546F6B656E737D7265736574546F6B656E697A6174696F6E28297B746869732E6772616D6D6172546F6B656E732E7265736574546F6B656E697A6174696F6E28297D676574206261636B67726F756E64546F6B656E697A61';
wwv_flow_imp.g_varchar2_table(7840) := '74696F6E537461746528297B72657475726E20746869732E6772616D6D6172546F6B656E732E6261636B67726F756E64546F6B656E697A6174696F6E53746174657D666F726365546F6B656E697A6174696F6E2865297B746869732E76616C6964617465';
wwv_flow_imp.g_varchar2_table(7841) := '4C696E654E756D6265722865292C746869732E6772616D6D6172546F6B656E732E666F726365546F6B656E697A6174696F6E2865297D6861734163637572617465546F6B656E73466F724C696E652865297B72657475726E20746869732E76616C696461';
wwv_flow_imp.g_varchar2_table(7842) := '74654C696E654E756D6265722865292C746869732E6772616D6D6172546F6B656E732E6861734163637572617465546F6B656E73466F724C696E652865297D69734368656170546F546F6B656E697A652865297B72657475726E20746869732E76616C69';
wwv_flow_imp.g_varchar2_table(7843) := '646174654C696E654E756D6265722865292C746869732E6772616D6D6172546F6B656E732E69734368656170546F546F6B656E697A652865297D746F6B656E697A65496643686561702865297B746869732E76616C69646174654C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(7844) := '2865292C746869732E6772616D6D6172546F6B656E732E746F6B656E697A65496643686561702865297D676574546F6B656E547970654966496E73657274696E6743686172616374657228652C742C6E297B72657475726E20746869732E6772616D6D61';
wwv_flow_imp.g_varchar2_table(7845) := '72546F6B656E732E676574546F6B656E547970654966496E73657274696E6743686172616374657228652C742C6E297D746F6B656E697A654C696E65576974684564697428652C742C6E297B72657475726E20746869732E6772616D6D6172546F6B656E';
wwv_flow_imp.g_varchar2_table(7846) := '732E746F6B656E697A654C696E65576974684564697428652C742C6E297D73657453656D616E746963546F6B656E7328652C74297B746869732E5F73656D616E746963546F6B656E732E73657428652C74292C746869732E5F656D69744D6F64656C546F';
wwv_flow_imp.g_varchar2_table(7847) := '6B656E734368616E6765644576656E74287B73656D616E746963546F6B656E734170706C6965643A6E756C6C213D3D652C72616E6765733A5B7B66726F6D4C696E654E756D6265723A312C746F4C696E654E756D6265723A746869732E5F746578744D6F';
wwv_flow_imp.g_varchar2_table(7848) := '64656C2E6765744C696E65436F756E7428297D5D7D297D686173436F6D706C65746553656D616E746963546F6B656E7328297B72657475726E20746869732E5F73656D616E746963546F6B656E732E6973436F6D706C65746528297D686173536F6D6553';
wwv_flow_imp.g_varchar2_table(7849) := '656D616E746963546F6B656E7328297B72657475726E21746869732E5F73656D616E746963546F6B656E732E6973456D70747928297D7365745061727469616C53656D616E746963546F6B656E7328652C74297B696628746869732E686173436F6D706C';
wwv_flow_imp.g_varchar2_table(7850) := '65746553656D616E746963546F6B656E7328292972657475726E3B636F6E7374206E3D746869732E5F746578744D6F64656C2E76616C696461746552616E676528746869732E5F73656D616E746963546F6B656E732E7365745061727469616C28652C74';
wwv_flow_imp.g_varchar2_table(7851) := '29293B746869732E5F656D69744D6F64656C546F6B656E734368616E6765644576656E74287B73656D616E746963546F6B656E734170706C6965643A21302C72616E6765733A5B7B66726F6D4C696E654E756D6265723A6E2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(7852) := '6D6265722C746F4C696E654E756D6265723A6E2E656E644C696E654E756D6265727D5D7D297D676574576F72644174506F736974696F6E2865297B746869732E6173736572744E6F74446973706F73656428293B636F6E737420743D746869732E5F7465';
wwv_flow_imp.g_varchar2_table(7853) := '78744D6F64656C2E76616C6964617465506F736974696F6E2865292C6E3D746869732E5F746578744D6F64656C2E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C693D746869732E6765744C696E65546F6B656E7328742E6C69';
wwv_flow_imp.g_varchar2_table(7854) := '6E654E756D626572292C6F3D692E66696E64546F6B656E496E64657841744F666673657428742E636F6C756D6E2D31292C5B732C725D3D69432E5F66696E644C616E6775616765426F756E64617269657328692C6F292C613D417528742E636F6C756D6E';
wwv_flow_imp.g_varchar2_table(7855) := '2C746869732E6765744C616E6775616765436F6E66696775726174696F6E28692E6765744C616E67756167654964286F29292E676574576F7264446566696E6974696F6E28292C6E2E737562737472696E6728732C72292C73293B696628612626612E73';
wwv_flow_imp.g_varchar2_table(7856) := '74617274436F6C756D6E3C3D652E636F6C756D6E2626652E636F6C756D6E3C3D612E656E64436F6C756D6E2972657475726E20613B6966286F3E302626733D3D3D742E636F6C756D6E2D31297B636F6E73745B732C725D3D69432E5F66696E644C616E67';
wwv_flow_imp.g_varchar2_table(7857) := '75616765426F756E64617269657328692C6F2D31292C613D417528742E636F6C756D6E2C746869732E6765744C616E6775616765436F6E66696775726174696F6E28692E6765744C616E67756167654964286F2D3129292E676574576F7264446566696E';
wwv_flow_imp.g_varchar2_table(7858) := '6974696F6E28292C6E2E737562737472696E6728732C72292C73293B696628612626612E7374617274436F6C756D6E3C3D652E636F6C756D6E2626652E636F6C756D6E3C3D612E656E64436F6C756D6E2972657475726E20617D72657475726E206E756C';
wwv_flow_imp.g_varchar2_table(7859) := '6C7D6765744C616E6775616765436F6E66696775726174696F6E2865297B72657475726E20746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2865297D';
wwv_flow_imp.g_varchar2_table(7860) := '737461746963205F66696E644C616E6775616765426F756E64617269657328652C74297B636F6E7374206E3D652E6765744C616E677561676549642874293B6C657420693D303B666F72286C6574206F3D743B6F3E3D302626652E6765744C616E677561';
wwv_flow_imp.g_varchar2_table(7861) := '67654964286F293D3D3D6E3B6F2D2D29693D652E67657453746172744F6666736574286F293B6C6574206F3D652E6765744C696E65436F6E74656E7428292E6C656E6774683B666F72286C657420693D742C733D652E676574436F756E7428293B693C73';
wwv_flow_imp.g_varchar2_table(7862) := '2626652E6765744C616E677561676549642869293D3D3D6E3B692B2B296F3D652E676574456E644F66667365742869293B72657475726E5B692C6F5D7D676574576F7264556E74696C506F736974696F6E2865297B636F6E737420743D746869732E6765';
wwv_flow_imp.g_varchar2_table(7863) := '74576F72644174506F736974696F6E2865293B72657475726E20743F7B776F72643A742E776F72642E73756273747228302C652E636F6C756D6E2D742E7374617274436F6C756D6E292C7374617274436F6C756D6E3A742E7374617274436F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(7864) := '656E64436F6C756D6E3A652E636F6C756D6E7D3A7B776F72643A22222C7374617274436F6C756D6E3A652E636F6C756D6E2C656E64436F6C756D6E3A652E636F6C756D6E7D7D6765744C616E6775616765496428297B72657475726E20746869732E5F6C';
wwv_flow_imp.g_varchar2_table(7865) := '616E677561676549647D6765744C616E677561676549644174506F736974696F6E28652C74297B636F6E7374206E3D746869732E5F746578744D6F64656C2E76616C6964617465506F736974696F6E286E6577206D6328652C7429292C693D746869732E';
wwv_flow_imp.g_varchar2_table(7866) := '6765744C696E65546F6B656E73286E2E6C696E654E756D626572293B72657475726E20692E6765744C616E6775616765496428692E66696E64546F6B656E496E64657841744F6666736574286E2E636F6C756D6E2D3129297D7365744C616E6775616765';
wwv_flow_imp.g_varchar2_table(7867) := '496428652C743D2261706922297B696628746869732E5F6C616E677561676549643D3D3D652972657475726E3B636F6E7374206E3D7B6F6C644C616E67756167653A746869732E5F6C616E677561676549642C6E65774C616E67756167653A652C736F75';
wwv_flow_imp.g_varchar2_table(7868) := '7263653A747D3B746869732E5F6C616E677561676549643D652C746869732E5F627261636B65745061697273546578744D6F64656C506172742E68616E646C654469644368616E67654C616E6775616765286E292C746869732E6772616D6D6172546F6B';
wwv_flow_imp.g_varchar2_table(7869) := '656E732E7265736574546F6B656E697A6174696F6E28292C746869732E5F6F6E4469644368616E67654C616E67756167652E66697265286E292C746869732E5F6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E2E666972';
wwv_flow_imp.g_varchar2_table(7870) := '65287B7D297D7D636C617373206F4320657874656E6473206C747B676574206261636B67726F756E64546F6B656E697A6174696F6E537461746528297B72657475726E20746869732E5F6261636B67726F756E64546F6B656E697A6174696F6E53746174';
wwv_flow_imp.g_varchar2_table(7871) := '657D636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F6C616E67756167654964436F6465633D652C746869732E5F746578744D6F64656C3D742C746869732E6765744C616E677561676549643D6E2C746869732E5F';
wwv_flow_imp.g_varchar2_table(7872) := '746F6B656E697A65723D6E756C6C2C746869732E5F64656661756C744261636B67726F756E64546F6B656E697A65723D6E756C6C2C746869732E5F6261636B67726F756E64546F6B656E697A65723D746869732E5F7265676973746572286E6577206374';
wwv_flow_imp.g_varchar2_table(7873) := '292C746869732E5F746F6B656E733D6E657720654328746869732E5F6C616E67756167654964436F646563292C746869732E5F64656275674261636B67726F756E64546F6B656E697A65723D746869732E5F7265676973746572286E6577206374292C74';
wwv_flow_imp.g_varchar2_table(7874) := '6869732E5F6261636B67726F756E64546F6B656E697A6174696F6E53746174653D312C746869732E5F6F6E4469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E53746174653D746869732E5F7265676973746572286E65772043';
wwv_flow_imp.g_varchar2_table(7875) := '74292C746869732E6F6E4469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E53746174653D746869732E5F6F6E4469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E53746174652E6576656E742C7468';
wwv_flow_imp.g_varchar2_table(7876) := '69732E5F6F6E4469644368616E6765546F6B656E733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E6765546F6B656E733D746869732E5F6F6E4469644368616E6765546F6B656E732E6576656E742C7468';
wwv_flow_imp.g_varchar2_table(7877) := '69732E5F6174746163686564566965775374617465733D746869732E5F7265676973746572286E6577207574292C746869732E5F72656769737465722850772E6F6E4469644368616E67652828653D3E7B636F6E737420743D746869732E6765744C616E';
wwv_flow_imp.g_varchar2_table(7878) := '6775616765496428293B2D31213D3D652E6368616E6765644C616E6775616765732E696E6465784F662874292626746869732E7265736574546F6B656E697A6174696F6E28297D2929292C746869732E7265736574546F6B656E697A6174696F6E28292C';
wwv_flow_imp.g_varchar2_table(7879) := '746869732E5F726567697374657228692E6F6E4469644368616E676556697369626C6552616E6765732828287B766965773A652C73746174653A747D293D3E7B69662874297B6C6574206E3D746869732E5F617474616368656456696577537461746573';
wwv_flow_imp.g_varchar2_table(7880) := '2E6765742865293B6E7C7C286E3D6E6577207343282828293D3E746869732E7265667265736852616E676573286E2E6C696E6552616E6765732929292C746869732E5F6174746163686564566965775374617465732E73657428652C6E29292C6E2E6861';
wwv_flow_imp.g_varchar2_table(7881) := '6E646C6553746174654368616E67652874297D656C736520746869732E5F6174746163686564566965775374617465732E64656C657465416E64446973706F73652865297D2929297D7265736574546F6B656E697A6174696F6E28653D2130297B766172';
wwv_flow_imp.g_varchar2_table(7882) := '20743B746869732E5F746F6B656E732E666C75736828292C6E756C6C3D3D3D28743D746869732E5F64656275674261636B67726F756E64546F6B656E73297C7C766F696420303D3D3D747C7C742E666C75736828292C746869732E5F6465627567426163';
wwv_flow_imp.g_varchar2_table(7883) := '6B67726F756E64537461746573262628746869732E5F64656275674261636B67726F756E645374617465733D6E657720557728746869732E5F746578744D6F64656C2E6765744C696E65436F756E74282929292C652626746869732E5F6F6E4469644368';
wwv_flow_imp.g_varchar2_table(7884) := '616E6765546F6B656E732E66697265287B73656D616E746963546F6B656E734170706C6965643A21312C72616E6765733A5B7B66726F6D4C696E654E756D6265723A312C746F4C696E654E756D6265723A746869732E5F746578744D6F64656C2E676574';
wwv_flow_imp.g_varchar2_table(7885) := '4C696E65436F756E7428297D5D7D293B636F6E73745B6E2C695D3D2828293D3E7B696628746869732E5F746578744D6F64656C2E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28292972657475726E5B6E756C6C2C6E756C6C5D3B636F';
wwv_flow_imp.g_varchar2_table(7886) := '6E737420653D50772E67657428746869732E6765744C616E677561676549642829293B69662821652972657475726E5B6E756C6C2C6E756C6C5D3B6C657420743B7472797B743D652E676574496E697469616C537461746528297D63617463682865297B';
wwv_flow_imp.g_varchar2_table(7887) := '72657475726E206B652865292C5B6E756C6C2C6E756C6C5D7D72657475726E5B652C745D7D2928293B696628746869732E5F746F6B656E697A65723D6E2626693F6E657720247728746869732E5F746578744D6F64656C2E6765744C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(7888) := '28292C6E2C746869732E5F746578744D6F64656C2C746869732E5F6C616E67756167654964436F646563293A6E756C6C2C746869732E5F6261636B67726F756E64546F6B656E697A65722E636C65617228292C746869732E5F64656661756C744261636B';
wwv_flow_imp.g_varchar2_table(7889) := '67726F756E64546F6B656E697A65723D6E756C6C2C746869732E5F746F6B656E697A6572297B636F6E737420653D7B736574546F6B656E733A653D3E7B746869732E736574546F6B656E732865297D2C6261636B67726F756E64546F6B656E697A617469';
wwv_flow_imp.g_varchar2_table(7890) := '6F6E46696E69736865643A28293D3E7B32213D3D746869732E5F6261636B67726F756E64546F6B656E697A6174696F6E5374617465262628746869732E5F6261636B67726F756E64546F6B656E697A6174696F6E53746174653D322C746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(7891) := '4469644368616E67654261636B67726F756E64546F6B656E697A6174696F6E53746174652E666972652829297D2C736574456E6453746174653A28652C74293D3E7B766172206E3B69662821746869732E5F746F6B656E697A65722972657475726E3B63';
wwv_flow_imp.g_varchar2_table(7892) := '6F6E737420693D746869732E5F746F6B656E697A65722E73746F72652E6765744669727374496E76616C6964456E6453746174654C696E654E756D62657228293B6E756C6C213D3D692626653E3D692626286E756C6C3D3D3D286E3D746869732E5F746F';
wwv_flow_imp.g_varchar2_table(7893) := '6B656E697A6572297C7C766F696420303D3D3D6E7C7C6E2E73746F72652E736574456E64537461746528652C7429297D7D3B6E26266E2E6372656174654261636B67726F756E64546F6B656E697A65722626216E2E6261636B67726F756E64546F6B656E';
wwv_flow_imp.g_varchar2_table(7894) := '697A657253686F756C644F6E6C79566572696679546F6B656E73262628746869732E5F6261636B67726F756E64546F6B656E697A65722E76616C75653D6E2E6372656174654261636B67726F756E64546F6B656E697A657228746869732E5F746578744D';
wwv_flow_imp.g_varchar2_table(7895) := '6F64656C2C6529292C746869732E5F6261636B67726F756E64546F6B656E697A65722E76616C75657C7C746869732E5F746578744D6F64656C2E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28297C7C28746869732E5F6261636B6772';
wwv_flow_imp.g_varchar2_table(7896) := '6F756E64546F6B656E697A65722E76616C75653D746869732E5F64656661756C744261636B67726F756E64546F6B656E697A65723D6E657720597728746869732E5F746F6B656E697A65722C65292C746869732E5F64656661756C744261636B67726F75';
wwv_flow_imp.g_varchar2_table(7897) := '6E64546F6B656E697A65722E68616E646C654368616E6765732829292C286E756C6C3D3D6E3F766F696420303A6E2E6261636B67726F756E64546F6B656E697A657253686F756C644F6E6C79566572696679546F6B656E732926266E2E63726561746542';
wwv_flow_imp.g_varchar2_table(7898) := '61636B67726F756E64546F6B656E697A65723F28746869732E5F64656275674261636B67726F756E64546F6B656E733D6E657720654328746869732E5F6C616E67756167654964436F646563292C746869732E5F64656275674261636B67726F756E6453';
wwv_flow_imp.g_varchar2_table(7899) := '74617465733D6E657720557728746869732E5F746578744D6F64656C2E6765744C696E65436F756E742829292C746869732E5F64656275674261636B67726F756E64546F6B656E697A65722E636C65617228292C746869732E5F64656275674261636B67';
wwv_flow_imp.g_varchar2_table(7900) := '726F756E64546F6B656E697A65722E76616C75653D6E2E6372656174654261636B67726F756E64546F6B656E697A657228746869732E5F746578744D6F64656C2C7B736574546F6B656E733A653D3E7B76617220743B6E756C6C3D3D3D28743D74686973';
wwv_flow_imp.g_varchar2_table(7901) := '2E5F64656275674261636B67726F756E64546F6B656E73297C7C766F696420303D3D3D747C7C742E7365744D756C74696C696E65546F6B656E7328652C746869732E5F746578744D6F64656C297D2C6261636B67726F756E64546F6B656E697A6174696F';
wwv_flow_imp.g_varchar2_table(7902) := '6E46696E697368656428297B7D2C736574456E6453746174653A28652C74293D3E7B766172206E3B6E756C6C3D3D3D286E3D746869732E5F64656275674261636B67726F756E64537461746573297C7C766F696420303D3D3D6E7C7C6E2E736574456E64';
wwv_flow_imp.g_varchar2_table(7903) := '537461746528652C74297D7D29293A28746869732E5F64656275674261636B67726F756E64546F6B656E733D766F696420302C746869732E5F64656275674261636B67726F756E645374617465733D766F696420302C746869732E5F6465627567426163';
wwv_flow_imp.g_varchar2_table(7904) := '6B67726F756E64546F6B656E697A65722E76616C75653D766F69642030297D746869732E72656672657368416C6C56697369626C654C696E65546F6B656E7328297D68616E646C654469644368616E6765417474616368656428297B76617220653B6E75';
wwv_flow_imp.g_varchar2_table(7905) := '6C6C3D3D3D28653D746869732E5F64656661756C744261636B67726F756E64546F6B656E697A6572297C7C766F696420303D3D3D657C7C652E68616E646C654368616E67657328297D68616E646C654469644368616E6765436F6E74656E742865297B76';
wwv_flow_imp.g_varchar2_table(7906) := '617220742C6E2C693B696628652E6973466C75736829746869732E7265736574546F6B656E697A6174696F6E282131293B656C73652069662821652E6973456F6C4368616E6765297B666F7228636F6E7374206E206F6620652E6368616E676573297B63';
wwv_flow_imp.g_varchar2_table(7907) := '6F6E73745B652C695D3D7575286E2E74657874293B746869732E5F746F6B656E732E61636365707445646974286E2E72616E67652C652C69292C6E756C6C3D3D3D28743D746869732E5F64656275674261636B67726F756E64546F6B656E73297C7C766F';
wwv_flow_imp.g_varchar2_table(7908) := '696420303D3D3D747C7C742E61636365707445646974286E2E72616E67652C652C69297D6E756C6C3D3D3D286E3D746869732E5F64656275674261636B67726F756E64537461746573297C7C766F696420303D3D3D6E7C7C6E2E6163636570744368616E';
wwv_flow_imp.g_varchar2_table(7909) := '67657328652E6368616E676573292C746869732E5F746F6B656E697A65722626746869732E5F746F6B656E697A65722E73746F72652E6163636570744368616E67657328652E6368616E676573292C6E756C6C3D3D3D28693D746869732E5F6465666175';
wwv_flow_imp.g_varchar2_table(7910) := '6C744261636B67726F756E64546F6B656E697A6572297C7C766F696420303D3D3D697C7C692E68616E646C654368616E67657328297D7D736574546F6B656E732865297B636F6E73747B6368616E6765733A747D3D746869732E5F746F6B656E732E7365';
wwv_flow_imp.g_varchar2_table(7911) := '744D756C74696C696E65546F6B656E7328652C746869732E5F746578744D6F64656C293B72657475726E20742E6C656E6774683E302626746869732E5F6F6E4469644368616E6765546F6B656E732E66697265287B73656D616E746963546F6B656E7341';
wwv_flow_imp.g_varchar2_table(7912) := '70706C6965643A21312C72616E6765733A747D292C7B6368616E6765733A747D7D72656672657368416C6C56697369626C654C696E65546F6B656E7328297B636F6E737420653D78752E6A6F696E4D616E79285B2E2E2E746869732E5F61747461636865';
wwv_flow_imp.g_varchar2_table(7913) := '64566965775374617465735D2E6D61702828285B652C745D293D3E742E6C696E6552616E6765732929293B746869732E7265667265736852616E6765732865297D7265667265736852616E6765732865297B666F7228636F6E73742074206F6620652974';
wwv_flow_imp.g_varchar2_table(7914) := '6869732E7265667265736852616E676528742E73746172744C696E654E756D6265722C742E656E644C696E654E756D6265724578636C75736976652D31297D7265667265736852616E676528652C74297B766172206E2C693B69662821746869732E5F74';
wwv_flow_imp.g_varchar2_table(7915) := '6F6B656E697A65722972657475726E3B653D4D6174682E6D617828312C4D6174682E6D696E28746869732E5F746578744D6F64656C2E6765744C696E65436F756E7428292C6529292C743D4D6174682E6D696E28746869732E5F746578744D6F64656C2E';
wwv_flow_imp.g_varchar2_table(7916) := '6765744C696E65436F756E7428292C74293B636F6E7374206F3D6E65772048772C7B686575726973746963546F6B656E733A737D3D746869732E5F746F6B656E697A65722E746F6B656E697A65486575726973746963616C6C79286F2C652C74292C723D';
wwv_flow_imp.g_varchar2_table(7917) := '746869732E736574546F6B656E73286F2E66696E616C697A652829293B6966287329666F7228636F6E73742065206F6620722E6368616E676573296E756C6C3D3D3D286E3D746869732E5F6261636B67726F756E64546F6B656E697A65722E76616C7565';
wwv_flow_imp.g_varchar2_table(7918) := '297C7C766F696420303D3D3D6E7C7C6E2E72657175657374546F6B656E7328652E66726F6D4C696E654E756D6265722C652E746F4C696E654E756D6265722B31293B6E756C6C3D3D3D28693D746869732E5F64656661756C744261636B67726F756E6454';
wwv_flow_imp.g_varchar2_table(7919) := '6F6B656E697A6572297C7C766F696420303D3D3D697C7C692E636865636B46696E697368656428297D666F726365546F6B656E697A6174696F6E2865297B76617220742C6E3B636F6E737420693D6E65772048773B6E756C6C3D3D3D28743D746869732E';
wwv_flow_imp.g_varchar2_table(7920) := '5F746F6B656E697A6572297C7C766F696420303D3D3D747C7C742E757064617465546F6B656E73556E74696C4C696E6528692C65292C746869732E736574546F6B656E7328692E66696E616C697A652829292C6E756C6C3D3D3D286E3D746869732E5F64';
wwv_flow_imp.g_varchar2_table(7921) := '656661756C744261636B67726F756E64546F6B656E697A6572297C7C766F696420303D3D3D6E7C7C6E2E636865636B46696E697368656428297D6861734163637572617465546F6B656E73466F724C696E652865297B72657475726E21746869732E5F74';
wwv_flow_imp.g_varchar2_table(7922) := '6F6B656E697A65727C7C746869732E5F746F6B656E697A65722E6861734163637572617465546F6B656E73466F724C696E652865297D69734368656170546F546F6B656E697A652865297B72657475726E21746869732E5F746F6B656E697A65727C7C74';
wwv_flow_imp.g_varchar2_table(7923) := '6869732E5F746F6B656E697A65722E69734368656170546F546F6B656E697A652865297D746F6B656E697A65496643686561702865297B746869732E69734368656170546F546F6B656E697A652865292626746869732E666F726365546F6B656E697A61';
wwv_flow_imp.g_varchar2_table(7924) := '74696F6E2865297D6765744C696E65546F6B656E732865297B76617220743B636F6E7374206E3D746869732E5F746578744D6F64656C2E6765744C696E65436F6E74656E742865292C693D746869732E5F746F6B656E732E676574546F6B656E73287468';
wwv_flow_imp.g_varchar2_table(7925) := '69732E5F746578744D6F64656C2E6765744C616E6775616765496428292C652D312C6E293B696628746869732E5F64656275674261636B67726F756E64546F6B656E732626746869732E5F64656275674261636B67726F756E6453746174657326267468';
wwv_flow_imp.g_varchar2_table(7926) := '69732E5F746F6B656E697A65722626746869732E5F64656275674261636B67726F756E645374617465732E6765744669727374496E76616C6964456E6453746174654C696E654E756D6265724F724D617828293E652626746869732E5F746F6B656E697A';
wwv_flow_imp.g_varchar2_table(7927) := '65722E73746F72652E6765744669727374496E76616C6964456E6453746174654C696E654E756D6265724F724D617828293E65297B636F6E7374206F3D746869732E5F64656275674261636B67726F756E64546F6B656E732E676574546F6B656E732874';
wwv_flow_imp.g_varchar2_table(7928) := '6869732E5F746578744D6F64656C2E6765744C616E6775616765496428292C652D312C6E293B21692E657175616C73286F292626286E756C6C3D3D3D28743D746869732E5F64656275674261636B67726F756E64546F6B656E697A65722E76616C756529';
wwv_flow_imp.g_varchar2_table(7929) := '7C7C766F696420303D3D3D743F766F696420303A742E7265706F72744D69736D61746368696E67546F6B656E73292626746869732E5F64656275674261636B67726F756E64546F6B656E697A65722E76616C75652E7265706F72744D69736D6174636869';
wwv_flow_imp.g_varchar2_table(7930) := '6E67546F6B656E732865297D72657475726E20697D676574546F6B656E547970654966496E73657274696E6743686172616374657228652C742C6E297B69662821746869732E5F746F6B656E697A65722972657475726E20303B636F6E737420693D7468';
wwv_flow_imp.g_varchar2_table(7931) := '69732E5F746578744D6F64656C2E76616C6964617465506F736974696F6E286E6577206D6328652C7429293B72657475726E20746869732E666F726365546F6B656E697A6174696F6E28692E6C696E654E756D626572292C746869732E5F746F6B656E69';
wwv_flow_imp.g_varchar2_table(7932) := '7A65722E676574546F6B656E547970654966496E73657274696E6743686172616374657228692C6E297D746F6B656E697A654C696E65576974684564697428652C742C6E297B69662821746869732E5F746F6B656E697A65722972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(7933) := '6C3B636F6E737420693D746869732E5F746578744D6F64656C2E76616C6964617465506F736974696F6E2865293B72657475726E20746869732E666F726365546F6B656E697A6174696F6E28692E6C696E654E756D626572292C746869732E5F746F6B65';
wwv_flow_imp.g_varchar2_table(7934) := '6E697A65722E746F6B656E697A654C696E65576974684564697428692C742C6E297D67657420686173546F6B656E7328297B72657475726E20746869732E5F746F6B656E732E686173546F6B656E737D7D636C61737320734320657874656E6473206C74';
wwv_flow_imp.g_varchar2_table(7935) := '7B676574206C696E6552616E67657328297B72657475726E20746869732E5F6C696E6552616E6765737D636F6E7374727563746F722865297B737570657228292C746869732E5F72656672657368546F6B656E733D652C746869732E72756E6E65723D74';
wwv_flow_imp.g_varchar2_table(7936) := '6869732E5F7265676973746572286E6577204B74282828293D3E746869732E7570646174652829292C353029292C746869732E5F636F6D70757465644C696E6552616E6765733D5B5D2C746869732E5F6C696E6552616E6765733D5B5D7D757064617465';
wwv_flow_imp.g_varchar2_table(7937) := '28297B506828746869732E5F636F6D70757465644C696E6552616E6765732C746869732E5F6C696E6552616E6765732C2828652C74293D3E652E657175616C7328742929297C7C28746869732E5F636F6D70757465644C696E6552616E6765733D746869';
wwv_flow_imp.g_varchar2_table(7938) := '732E5F6C696E6552616E6765732C746869732E5F72656672657368546F6B656E732829297D68616E646C6553746174654368616E67652865297B746869732E5F6C696E6552616E6765733D652E76697369626C654C696E6552616E6765732C652E737461';
wwv_flow_imp.g_varchar2_table(7939) := '62696C697A65643F28746869732E72756E6E65722E63616E63656C28292C746869732E7570646174652829293A746869732E72756E6E65722E7363686564756C6528297D7D636C6173732072437B636F6E7374727563746F7228297B746869732E636861';
wwv_flow_imp.g_varchar2_table(7940) := '6E6765547970653D317D7D636C6173732061437B737461746963206170706C79496E6A65637465645465787428652C74297B69662821747C7C303D3D3D742E6C656E6774682972657475726E20653B6C6574206E3D22222C693D303B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(7941) := '74206F206F662074296E2B3D652E737562737472696E6728692C6F2E636F6C756D6E2D31292C693D6F2E636F6C756D6E2D312C6E2B3D6F2E6F7074696F6E732E636F6E74656E743B72657475726E206E2B3D652E737562737472696E672869292C6E7D73';
wwv_flow_imp.g_varchar2_table(7942) := '74617469632066726F6D4465636F726174696F6E732865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065296E2E6F7074696F6E732E6265666F726526266E2E6F7074696F6E732E6265666F72652E636F6E74656E742E6C656E67';
wwv_flow_imp.g_varchar2_table(7943) := '74683E302626742E70757368286E6577206143286E2E6F776E657249642C6E2E72616E67652E73746172744C696E654E756D6265722C6E2E72616E67652E7374617274436F6C756D6E2C6E2E6F7074696F6E732E6265666F72652C3029292C6E2E6F7074';
wwv_flow_imp.g_varchar2_table(7944) := '696F6E732E616674657226266E2E6F7074696F6E732E61667465722E636F6E74656E742E6C656E6774683E302626742E70757368286E6577206143286E2E6F776E657249642C6E2E72616E67652E656E644C696E654E756D6265722C6E2E72616E67652E';
wwv_flow_imp.g_varchar2_table(7945) := '656E64436F6C756D6E2C6E2E6F7074696F6E732E61667465722C3129293B72657475726E20742E736F7274282828652C74293D3E652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265723F652E636F6C756D6E3D3D3D742E636F6C756D6E3F';
wwv_flow_imp.g_varchar2_table(7946) := '652E6F726465722D742E6F726465723A652E636F6C756D6E2D742E636F6C756D6E3A652E6C696E654E756D6265722D742E6C696E654E756D62657229292C747D636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6F776E657249643D';
wwv_flow_imp.g_varchar2_table(7947) := '652C746869732E6C696E654E756D6265723D742C746869732E636F6C756D6E3D6E2C746869732E6F7074696F6E733D692C746869732E6F726465723D6F7D7D636C617373206C437B636F6E7374727563746F7228652C742C6E297B746869732E6368616E';
wwv_flow_imp.g_varchar2_table(7948) := '6765547970653D322C746869732E6C696E654E756D6265723D652C746869732E64657461696C3D742C746869732E696E6A6563746564546578743D6E7D7D636C6173732063437B636F6E7374727563746F7228652C74297B746869732E6368616E676554';
wwv_flow_imp.g_varchar2_table(7949) := '7970653D332C746869732E66726F6D4C696E654E756D6265723D652C746869732E746F4C696E654E756D6265723D747D7D636C6173732064437B636F6E7374727563746F7228652C742C6E2C69297B746869732E6368616E6765547970653D342C746869';
wwv_flow_imp.g_varchar2_table(7950) := '732E696E6A656374656454657874733D692C746869732E66726F6D4C696E654E756D6265723D652C746869732E746F4C696E654E756D6265723D742C746869732E64657461696C3D6E7D7D636C6173732068437B636F6E7374727563746F7228297B7468';
wwv_flow_imp.g_varchar2_table(7951) := '69732E6368616E6765547970653D357D7D636C6173732075437B636F6E7374727563746F7228652C742C6E2C69297B746869732E6368616E6765733D652C746869732E76657273696F6E49643D742C746869732E6973556E646F696E673D6E2C74686973';
wwv_flow_imp.g_varchar2_table(7952) := '2E69735265646F696E673D692C746869732E726573756C74696E6753656C656374696F6E3D6E756C6C7D636F6E7461696E734576656E742865297B666F72286C657420743D302C6E3D746869732E6368616E6765732E6C656E6774683B743C6E3B742B2B';
wwv_flow_imp.g_varchar2_table(7953) := '29696628746869732E6368616E6765735B745D2E6368616E6765547970653D3D3D652972657475726E21303B72657475726E21317D737461746963206D6572676528652C74297B636F6E7374206E3D5B5D2E636F6E63617428652E6368616E676573292E';
wwv_flow_imp.g_varchar2_table(7954) := '636F6E63617428742E6368616E676573292C693D742E76657273696F6E49642C6F3D652E6973556E646F696E677C7C742E6973556E646F696E672C733D652E69735265646F696E677C7C742E69735265646F696E673B72657475726E206E657720754328';
wwv_flow_imp.g_varchar2_table(7955) := '6E2C692C6F2C73297D7D636C6173732070437B636F6E7374727563746F722865297B746869732E6368616E6765733D657D7D636C6173732067437B636F6E7374727563746F7228652C74297B746869732E726177436F6E74656E744368616E6765644576';
wwv_flow_imp.g_varchar2_table(7956) := '656E743D652C746869732E636F6E74656E744368616E6765644576656E743D747D6D657267652865297B636F6E737420743D75432E6D6572676528746869732E726177436F6E74656E744368616E6765644576656E742C652E726177436F6E74656E7443';
wwv_flow_imp.g_varchar2_table(7957) := '68616E6765644576656E74292C6E3D67432E5F6D657267654368616E67654576656E747328746869732E636F6E74656E744368616E6765644576656E742C652E636F6E74656E744368616E6765644576656E74293B72657475726E206E65772067432874';
wwv_flow_imp.g_varchar2_table(7958) := '2C6E297D737461746963205F6D657267654368616E67654576656E747328652C74297B636F6E7374206E3D5B5D2E636F6E63617428652E6368616E676573292E636F6E63617428742E6368616E676573292C693D742E656F6C2C6F3D742E76657273696F';
wwv_flow_imp.g_varchar2_table(7959) := '6E49642C733D652E6973556E646F696E677C7C742E6973556E646F696E672C723D652E69735265646F696E677C7C742E69735265646F696E672C613D652E6973466C7573687C7C742E6973466C7573683B72657475726E7B6368616E6765733A6E2C656F';
wwv_flow_imp.g_varchar2_table(7960) := '6C3A692C6973456F6C4368616E67653A652E6973456F6C4368616E67652626742E6973456F6C4368616E67652C76657273696F6E49643A6F2C6973556E646F696E673A732C69735265646F696E673A722C6973466C7573683A617D7D7D636F6E7374206D';
wwv_flow_imp.g_varchar2_table(7961) := '433D70632822756E646F5265646F5365727669636522293B636C6173732066437B636F6E7374727563746F7228652C74297B746869732E7265736F757263653D652C746869732E656C656D656E74733D747D7D636C6173732076437B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(7962) := '746F7228297B746869732E69643D76432E5F49442B2B2C746869732E6F726465723D317D6E6578744F7264657228297B72657475726E20303D3D3D746869732E69643F303A746869732E6F726465722B2B7D7D76432E5F49443D302C76432E4E6F6E653D';
wwv_flow_imp.g_varchar2_table(7963) := '6E65772076433B636C6173732062437B636F6E7374727563746F7228297B746869732E69643D62432E5F49442B2B2C746869732E6F726465723D317D6E6578744F7264657228297B72657475726E20303D3D3D746869732E69643F303A746869732E6F72';
wwv_flow_imp.g_varchar2_table(7964) := '6465722B2B7D7D62432E5F49443D302C62432E4E6F6E653D6E65772062433B766172205F432C79433D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E2077432865';
wwv_flow_imp.g_varchar2_table(7965) := '2C74297B6C6574206E3B76617220693B72657475726E206E3D22737472696E67223D3D747970656F6620653F66756E6374696F6E2865297B636F6E737420743D6E65772067773B72657475726E20742E6163636570744368756E6B2865292C742E66696E';
wwv_flow_imp.g_varchar2_table(7966) := '69736828297D2865293A28693D652926262266756E6374696F6E223D3D747970656F6620692E726561643F66756E6374696F6E2865297B636F6E737420743D6E65772067773B6C6574206E3B666F72283B22737472696E67223D3D747970656F66286E3D';
wwv_flow_imp.g_varchar2_table(7967) := '652E726561642829293B29742E6163636570744368756E6B286E293B72657475726E20742E66696E69736828297D2865293A652C6E2E6372656174652874297D6C65742043433D303B636C6173732053437B636F6E7374727563746F722865297B746869';
wwv_flow_imp.g_varchar2_table(7968) := '732E5F736F757263653D652C746869732E5F656F733D21317D7265616428297B696628746869732E5F656F732972657475726E206E756C6C3B636F6E737420653D5B5D3B6C657420743D302C6E3D303B666F72283B3B297B636F6E737420693D74686973';
wwv_flow_imp.g_varchar2_table(7969) := '2E5F736F757263652E7265616428293B6966286E756C6C3D3D3D692972657475726E20746869732E5F656F733D21302C303D3D3D743F6E756C6C3A652E6A6F696E282222293B696628692E6C656E6774683E30262628655B742B2B5D3D692C6E2B3D692E';
wwv_flow_imp.g_varchar2_table(7970) := '6C656E677468292C6E3E3D36353533362972657475726E20652E6A6F696E282222297D7D7D636F6E73742078433D28293D3E7B7468726F77206E6577204572726F722822496E76616C6964206368616E6765206163636573736F7222297D3B6C6574206B';
wwv_flow_imp.g_varchar2_table(7971) := '433D5F433D636C61737320657874656E6473206C747B737461746963207265736F6C76654F7074696F6E7328652C74297B696628742E646574656374496E64656E746174696F6E297B636F6E7374206E3D617928652C742E74616253697A652C742E696E';
wwv_flow_imp.g_varchar2_table(7972) := '73657274537061636573293B72657475726E206E6577204C68287B74616253697A653A6E2E74616253697A652C696E64656E7453697A653A2274616253697A65222C696E736572745370616365733A6E2E696E736572745370616365732C7472696D4175';
wwv_flow_imp.g_varchar2_table(7973) := '746F576869746573706163653A742E7472696D4175746F576869746573706163652C64656661756C74454F4C3A742E64656661756C74454F4C2C627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E733A742E627261636B65745061';
wwv_flow_imp.g_varchar2_table(7974) := '6972436F6C6F72697A6174696F6E4F7074696F6E737D297D72657475726E206E6577204C682874297D676574206F6E4469644368616E67654C616E677561676528297B72657475726E20746869732E5F746F6B656E697A6174696F6E546578744D6F6465';
wwv_flow_imp.g_varchar2_table(7975) := '6C506172742E6F6E4469644368616E67654C616E67756167657D676574206F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E28297B72657475726E20746869732E5F746F6B656E697A6174696F6E546578744D6F64656C50';
wwv_flow_imp.g_varchar2_table(7976) := '6172742E6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E7D676574206F6E4469644368616E6765546F6B656E7328297B72657475726E20746869732E5F746F6B656E697A6174696F6E546578744D6F64656C506172742E';
wwv_flow_imp.g_varchar2_table(7977) := '6F6E4469644368616E6765546F6B656E737D6F6E4469644368616E6765436F6E74656E742865297B72657475726E20746869732E5F6576656E74456D69747465722E736C6F774576656E742828743D3E6528742E636F6E74656E744368616E6765644576';
wwv_flow_imp.g_varchar2_table(7978) := '656E742929297D6F6E4469644368616E6765436F6E74656E744F72496E6A6563746564546578742865297B72657475726E20737428746869732E5F6576656E74456D69747465722E666173744576656E742828743D3E6528742929292C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(7979) := '6E4469644368616E6765496E6A6563746564546578742E6576656E742828743D3E652874292929297D5F6973446973706F73696E6728297B72657475726E20746869732E5F5F6973446973706F73696E677D67657420746F6B656E697A6174696F6E2829';
wwv_flow_imp.g_varchar2_table(7980) := '7B72657475726E20746869732E5F746F6B656E697A6174696F6E546578744D6F64656C506172747D67657420627261636B6574506169727328297B72657475726E20746869732E5F627261636B657450616972737D6765742067756964657328297B7265';
wwv_flow_imp.g_varchar2_table(7981) := '7475726E20746869732E5F677569646573546578744D6F64656C506172747D636F6E7374727563746F7228652C742C6E2C693D6E756C6C2C6F2C732C72297B737570657228292C746869732E5F756E646F5265646F536572766963653D6F2C746869732E';
wwv_flow_imp.g_varchar2_table(7982) := '5F6C616E6775616765536572766963653D732C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D722C746869732E5F6F6E57696C6C446973706F73653D746869732E5F7265676973746572286E6577204374292C74';
wwv_flow_imp.g_varchar2_table(7983) := '6869732E6F6E57696C6C446973706F73653D746869732E5F6F6E57696C6C446973706F73652E6576656E742C746869732E5F6F6E4469644368616E67654465636F726174696F6E733D746869732E5F7265676973746572286E65772042432828653D3E74';
wwv_flow_imp.g_varchar2_table(7984) := '6869732E68616E646C654265666F7265466972654465636F726174696F6E734368616E6765644576656E742865292929292C746869732E6F6E4469644368616E67654465636F726174696F6E733D746869732E5F6F6E4469644368616E67654465636F72';
wwv_flow_imp.g_varchar2_table(7985) := '6174696F6E732E6576656E742C746869732E5F6F6E4469644368616E67654F7074696F6E733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67654F7074696F6E733D746869732E5F6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(7986) := '67654F7074696F6E732E6576656E742C746869732E5F6F6E4469644368616E676541747461636865643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E676541747461636865643D746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(7987) := '644368616E676541747461636865642E6576656E742C746869732E5F6F6E4469644368616E6765496E6A6563746564546578743D746869732E5F7265676973746572286E6577204374292C746869732E5F6576656E74456D69747465723D746869732E5F';
wwv_flow_imp.g_varchar2_table(7988) := '7265676973746572286E6577205643292C746869732E5F6C616E677561676553656C656374696F6E4C697374656E65723D746869732E5F7265676973746572286E6577206374292C746869732E5F64656C74614465636F726174696F6E43616C6C436E74';
wwv_flow_imp.g_varchar2_table(7989) := '3D302C746869732E5F617474616368656456696577733D6E6577207A432C43432B2B2C746869732E69643D22246D6F64656C222B43432C746869732E6973466F7253696D706C655769646765743D6E2E6973466F7253696D706C655769646765742C7468';
wwv_flow_imp.g_varchar2_table(7990) := '69732E5F6173736F6369617465645265736F757263653D6E756C6C3D3D693F4E6F2E70617273652822696E6D656D6F72793A2F2F6D6F64656C2F222B4343293A692C746869732E5F6174746163686564456469746F72436F756E743D303B636F6E73747B';
wwv_flow_imp.g_varchar2_table(7991) := '746578744275666665723A612C646973706F7361626C653A6C7D3D774328652C6E2E64656661756C74454F4C293B746869732E5F6275666665723D612C746869732E5F627566666572446973706F7361626C653D6C2C746869732E5F6F7074696F6E733D';
wwv_flow_imp.g_varchar2_table(7992) := '5F432E7265736F6C76654F7074696F6E7328746869732E5F6275666665722C6E293B636F6E737420633D22737472696E67223D3D747970656F6620743F743A742E6C616E677561676549643B22737472696E6722213D747970656F662074262628746869';
wwv_flow_imp.g_varchar2_table(7993) := '732E5F6C616E677561676553656C656374696F6E4C697374656E65722E76616C75653D742E6F6E4469644368616E6765282828293D3E746869732E5F7365744C616E677561676528742E6C616E67756167654964292929292C746869732E5F627261636B';
wwv_flow_imp.g_varchar2_table(7994) := '657450616972733D746869732E5F7265676973746572286E6577205F6D28746869732C746869732E5F6C616E6775616765436F6E66696775726174696F6E5365727669636529292C746869732E5F677569646573546578744D6F64656C506172743D7468';
wwv_flow_imp.g_varchar2_table(7995) := '69732E5F7265676973746572286E657720697928746869732C746869732E5F6C616E6775616765436F6E66696775726174696F6E5365727669636529292C746869732E5F6465636F726174696F6E50726F76696465723D746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(7996) := '72286E6577207A5F287468697329292C746869732E5F746F6B656E697A6174696F6E546578744D6F64656C506172743D6E657720694328746869732E5F6C616E6775616765536572766963652C746869732E5F6C616E6775616765436F6E666967757261';
wwv_flow_imp.g_varchar2_table(7997) := '74696F6E536572766963652C746869732C746869732E5F627261636B657450616972732C632C746869732E5F61747461636865645669657773293B636F6E737420643D746869732E5F6275666665722E6765744C696E65436F756E7428292C683D746869';
wwv_flow_imp.g_varchar2_table(7998) := '732E5F6275666665722E67657456616C75654C656E677468496E52616E6765286E657720726828312C312C642C746869732E5F6275666665722E6765744C696E654C656E6774682864292B31292C30293B6E2E6C6172676546696C654F7074696D697A61';
wwv_flow_imp.g_varchar2_table(7999) := '74696F6E733F28746869732E5F6973546F6F4C61726765466F72546F6B656E697A6174696F6E3D683E5F432E4C415247455F46494C455F53495A455F5448524553484F4C447C7C643E5F432E4C415247455F46494C455F4C494E455F434F554E545F5448';
wwv_flow_imp.g_varchar2_table(8000) := '524553484F4C442C746869732E5F6973546F6F4C61726765466F72486561704F7065726174696F6E3D683E5F432E4C415247455F46494C455F484541505F4F5045524154494F4E5F5448524553484F4C44293A28746869732E5F6973546F6F4C61726765';
wwv_flow_imp.g_varchar2_table(8001) := '466F72546F6B656E697A6174696F6E3D21312C746869732E5F6973546F6F4C61726765466F72486561704F7065726174696F6E3D2131292C746869732E5F6973546F6F4C61726765466F7253796E63696E673D683E5F432E5F4D4F44454C5F53594E435F';
wwv_flow_imp.g_varchar2_table(8002) := '4C494D49542C746869732E5F76657273696F6E49643D312C746869732E5F616C7465726E617469766556657273696F6E49643D312C746869732E5F696E697469616C556E646F5265646F536E617073686F743D6E756C6C2C746869732E5F697344697370';
wwv_flow_imp.g_varchar2_table(8003) := '6F7365643D21312C746869732E5F5F6973446973706F73696E673D21312C746869732E5F696E7374616E636549643D4B69284343292C746869732E5F6C6173744465636F726174696F6E49643D302C746869732E5F6465636F726174696F6E733D4F626A';
wwv_flow_imp.g_varchar2_table(8004) := '6563742E637265617465286E756C6C292C746869732E5F6465636F726174696F6E73547265653D6E65772044432C746869732E5F636F6D6D616E644D616E616765723D6E6577205A5F28746869732C746869732E5F756E646F5265646F53657276696365';
wwv_flow_imp.g_varchar2_table(8005) := '292C746869732E5F6973556E646F696E673D21312C746869732E5F69735265646F696E673D21312C746869732E5F7472696D4175746F576869746573706163654C696E65733D6E756C6C2C746869732E5F726567697374657228746869732E5F6465636F';
wwv_flow_imp.g_varchar2_table(8006) := '726174696F6E50726F76696465722E6F6E4469644368616E6765282828293D3E7B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E4465666572726564456D697428292C746869732E5F6F6E4469644368616E676544';
wwv_flow_imp.g_varchar2_table(8007) := '65636F726174696F6E732E6669726528292C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E656E644465666572726564456D697428297D2929292C746869732E5F6C616E6775616765536572766963652E726571756573745269';
wwv_flow_imp.g_varchar2_table(8008) := '63684C616E677561676546656174757265732863297D646973706F736528297B746869732E5F5F6973446973706F73696E673D21302C746869732E5F6F6E57696C6C446973706F73652E6669726528292C746869732E5F746F6B656E697A6174696F6E54';
wwv_flow_imp.g_varchar2_table(8009) := '6578744D6F64656C506172742E646973706F736528292C746869732E5F6973446973706F7365643D21302C73757065722E646973706F736528292C746869732E5F627566666572446973706F7361626C652E646973706F736528292C746869732E5F5F69';
wwv_flow_imp.g_varchar2_table(8010) := '73446973706F73696E673D21313B636F6E737420653D6E6577207577285B5D2C22222C225C6E222C21312C21312C21302C2130293B652E646973706F736528292C746869732E5F6275666665723D652C746869732E5F627566666572446973706F736162';
wwv_flow_imp.g_varchar2_table(8011) := '6C653D6C742E4E6F6E657D5F6173736572744E6F74446973706F73656428297B696628746869732E5F6973446973706F736564297468726F77206E6577204572726F7228224D6F64656C20697320646973706F7365642122297D5F656D6974436F6E7465';
wwv_flow_imp.g_varchar2_table(8012) := '6E744368616E6765644576656E7428652C74297B746869732E5F5F6973446973706F73696E677C7C28746869732E5F746F6B656E697A6174696F6E546578744D6F64656C506172742E68616E646C654469644368616E6765436F6E74656E742874292C74';
wwv_flow_imp.g_varchar2_table(8013) := '6869732E5F627261636B657450616972732E68616E646C654469644368616E6765436F6E74656E742874292C746869732E5F6576656E74456D69747465722E66697265286E657720674328652C742929297D73657456616C75652865297B696628746869';
wwv_flow_imp.g_varchar2_table(8014) := '732E5F6173736572744E6F74446973706F73656428292C6E756C6C3D3D65297468726F77204D6528293B636F6E73747B746578744275666665723A742C646973706F7361626C653A6E7D3D774328652C746869732E5F6F7074696F6E732E64656661756C';
wwv_flow_imp.g_varchar2_table(8015) := '74454F4C293B746869732E5F73657456616C756546726F6D5465787442756666657228742C6E297D5F637265617465436F6E74656E744368616E6765643228652C742C6E2C692C6F2C732C722C61297B72657475726E7B6368616E6765733A5B7B72616E';
wwv_flow_imp.g_varchar2_table(8016) := '67653A652C72616E67654F66667365743A742C72616E67654C656E6774683A6E2C746578743A697D5D2C656F6C3A746869732E5F6275666665722E676574454F4C28292C6973456F6C4368616E67653A612C76657273696F6E49643A746869732E676574';
wwv_flow_imp.g_varchar2_table(8017) := '56657273696F6E496428292C6973556E646F696E673A6F2C69735265646F696E673A732C6973466C7573683A727D7D5F73657456616C756546726F6D5465787442756666657228652C74297B746869732E5F6173736572744E6F74446973706F73656428';
wwv_flow_imp.g_varchar2_table(8018) := '293B636F6E7374206E3D746869732E67657446756C6C4D6F64656C52616E676528292C693D746869732E67657456616C75654C656E677468496E52616E6765286E292C6F3D746869732E6765744C696E65436F756E7428292C733D746869732E6765744C';
wwv_flow_imp.g_varchar2_table(8019) := '696E654D6178436F6C756D6E286F293B746869732E5F6275666665723D652C746869732E5F627566666572446973706F7361626C652E646973706F736528292C746869732E5F627566666572446973706F7361626C653D742C746869732E5F696E637265';
wwv_flow_imp.g_varchar2_table(8020) := '61736556657273696F6E496428292C746869732E5F6465636F726174696F6E733D4F626A6563742E637265617465286E756C6C292C746869732E5F6465636F726174696F6E73547265653D6E65772044432C746869732E5F636F6D6D616E644D616E6167';
wwv_flow_imp.g_varchar2_table(8021) := '65722E636C65617228292C746869732E5F7472696D4175746F576869746573706163654C696E65733D6E756C6C2C746869732E5F656D6974436F6E74656E744368616E6765644576656E74286E6577207543285B6E65772072435D2C746869732E5F7665';
wwv_flow_imp.g_varchar2_table(8022) := '7273696F6E49642C21312C2131292C746869732E5F637265617465436F6E74656E744368616E67656432286E657720726828312C312C6F2C73292C302C692C746869732E67657456616C756528292C21312C21312C21302C213129297D736574454F4C28';
wwv_flow_imp.g_varchar2_table(8023) := '65297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E737420743D313D3D3D653F225C725C6E223A225C6E223B696628746869732E5F6275666665722E676574454F4C28293D3D3D742972657475726E3B636F6E7374206E3D74';
wwv_flow_imp.g_varchar2_table(8024) := '6869732E67657446756C6C4D6F64656C52616E676528292C693D746869732E67657456616C75654C656E677468496E52616E6765286E292C6F3D746869732E6765744C696E65436F756E7428292C733D746869732E6765744C696E654D6178436F6C756D';
wwv_flow_imp.g_varchar2_table(8025) := '6E286F293B746869732E5F6F6E4265666F7265454F4C4368616E676528292C746869732E5F6275666665722E736574454F4C2874292C746869732E5F696E63726561736556657273696F6E496428292C746869732E5F6F6E4166746572454F4C4368616E';
wwv_flow_imp.g_varchar2_table(8026) := '676528292C746869732E5F656D6974436F6E74656E744368616E6765644576656E74286E6577207543285B6E65772068435D2C746869732E5F76657273696F6E49642C21312C2131292C746869732E5F637265617465436F6E74656E744368616E676564';
wwv_flow_imp.g_varchar2_table(8027) := '32286E657720726828312C312C6F2C73292C302C692C746869732E67657456616C756528292C21312C21312C21312C213029297D5F6F6E4265666F7265454F4C4368616E676528297B746869732E5F6465636F726174696F6E73547265652E656E737572';
wwv_flow_imp.g_varchar2_table(8028) := '65416C6C4E6F6465734861766552616E6765732874686973297D5F6F6E4166746572454F4C4368616E676528297B636F6E737420653D746869732E67657456657273696F6E496428292C743D746869732E5F6465636F726174696F6E73547265652E636F';
wwv_flow_imp.g_varchar2_table(8029) := '6C6C6563744E6F646573506F73744F7264657228293B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D745B6E5D2C6F3D692E72616E67652C733D692E6361636865644162736F6C7574655374617274';
wwv_flow_imp.g_varchar2_table(8030) := '2D692E73746172742C723D746869732E5F6275666665722E6765744F66667365744174286F2E73746172744C696E654E756D6265722C6F2E7374617274436F6C756D6E292C613D746869732E5F6275666665722E6765744F66667365744174286F2E656E';
wwv_flow_imp.g_varchar2_table(8031) := '644C696E654E756D6265722C6F2E656E64436F6C756D6E293B692E6361636865644162736F6C75746553746172743D722C692E6361636865644162736F6C757465456E643D612C692E63616368656456657273696F6E49643D652C692E73746172743D72';
wwv_flow_imp.g_varchar2_table(8032) := '2D732C692E656E643D612D732C54792869297D7D6F6E4265666F7265417474616368656428297B72657475726E20746869732E5F6174746163686564456469746F72436F756E742B2B2C313D3D3D746869732E5F6174746163686564456469746F72436F';
wwv_flow_imp.g_varchar2_table(8033) := '756E74262628746869732E5F746F6B656E697A6174696F6E546578744D6F64656C506172742E68616E646C654469644368616E6765417474616368656428292C746869732E5F6F6E4469644368616E676541747461636865642E6669726528766F696420';
wwv_flow_imp.g_varchar2_table(8034) := '3029292C746869732E5F617474616368656456696577732E6174746163685669657728297D6F6E4265666F726544657461636865642865297B746869732E5F6174746163686564456469746F72436F756E742D2D2C303D3D3D746869732E5F6174746163';
wwv_flow_imp.g_varchar2_table(8035) := '686564456469746F72436F756E74262628746869732E5F746F6B656E697A6174696F6E546578744D6F64656C506172742E68616E646C654469644368616E6765417474616368656428292C746869732E5F6F6E4469644368616E67654174746163686564';
wwv_flow_imp.g_varchar2_table(8036) := '2E6669726528766F6964203029292C746869732E5F617474616368656456696577732E646574616368566965772865297D69734174746163686564546F456469746F7228297B72657475726E20746869732E5F6174746163686564456469746F72436F75';
wwv_flow_imp.g_varchar2_table(8037) := '6E743E307D6765744174746163686564456469746F72436F756E7428297B72657475726E20746869732E5F6174746163686564456469746F72436F756E747D6973546F6F4C61726765466F7253796E63696E6728297B72657475726E20746869732E5F69';
wwv_flow_imp.g_varchar2_table(8038) := '73546F6F4C61726765466F7253796E63696E677D6973546F6F4C61726765466F72546F6B656E697A6174696F6E28297B72657475726E20746869732E5F6973546F6F4C61726765466F72546F6B656E697A6174696F6E7D6973546F6F4C61726765466F72';
wwv_flow_imp.g_varchar2_table(8039) := '486561704F7065726174696F6E28297B72657475726E20746869732E5F6973546F6F4C61726765466F72486561704F7065726174696F6E7D6973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D6973446F6D696E';
wwv_flow_imp.g_varchar2_table(8040) := '6174656442794C6F6E674C696E657328297B696628746869732E5F6173736572744E6F74446973706F73656428292C746869732E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28292972657475726E21313B6C657420653D302C743D30';
wwv_flow_imp.g_varchar2_table(8041) := '3B636F6E7374206E3D746869732E5F6275666665722E6765744C696E65436F756E7428293B666F72286C657420693D313B693C3D6E3B692B2B297B636F6E7374206E3D746869732E5F6275666665722E6765744C696E654C656E6774682869293B6E3E3D';
wwv_flow_imp.g_varchar2_table(8042) := '3165343F742B3D6E3A652B3D6E7D72657475726E20743E657D6765742075726928297B72657475726E20746869732E5F6173736F6369617465645265736F757263657D6765744F7074696F6E7328297B72657475726E20746869732E5F6173736572744E';
wwv_flow_imp.g_varchar2_table(8043) := '6F74446973706F73656428292C746869732E5F6F7074696F6E737D676574466F726D617474696E674F7074696F6E7328297B72657475726E7B74616253697A653A746869732E5F6F7074696F6E732E696E64656E7453697A652C696E7365727453706163';
wwv_flow_imp.g_varchar2_table(8044) := '65733A746869732E5F6F7074696F6E732E696E736572745370616365737D7D7570646174654F7074696F6E732865297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E737420743D766F69642030213D3D652E74616253697A65';
wwv_flow_imp.g_varchar2_table(8045) := '3F652E74616253697A653A746869732E5F6F7074696F6E732E74616253697A652C6E3D766F69642030213D3D652E696E64656E7453697A653F652E696E64656E7453697A653A746869732E5F6F7074696F6E732E6F726967696E616C496E64656E745369';
wwv_flow_imp.g_varchar2_table(8046) := '7A652C693D766F69642030213D3D652E696E736572745370616365733F652E696E736572745370616365733A746869732E5F6F7074696F6E732E696E736572745370616365732C6F3D766F69642030213D3D652E7472696D4175746F5768697465737061';
wwv_flow_imp.g_varchar2_table(8047) := '63653F652E7472696D4175746F576869746573706163653A746869732E5F6F7074696F6E732E7472696D4175746F576869746573706163652C733D766F69642030213D3D652E627261636B6574436F6C6F72697A6174696F6E4F7074696F6E733F652E62';
wwv_flow_imp.g_varchar2_table(8048) := '7261636B6574436F6C6F72697A6174696F6E4F7074696F6E733A746869732E5F6F7074696F6E732E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732C723D6E6577204C68287B74616253697A653A742C696E64656E7453697A';
wwv_flow_imp.g_varchar2_table(8049) := '653A6E2C696E736572745370616365733A692C64656661756C74454F4C3A746869732E5F6F7074696F6E732E64656661756C74454F4C2C7472696D4175746F576869746573706163653A6F2C627261636B657450616972436F6C6F72697A6174696F6E4F';
wwv_flow_imp.g_varchar2_table(8050) := '7074696F6E733A737D293B696628746869732E5F6F7074696F6E732E657175616C732872292972657475726E3B636F6E737420613D746869732E5F6F7074696F6E732E6372656174654368616E67654576656E742872293B746869732E5F6F7074696F6E';
wwv_flow_imp.g_varchar2_table(8051) := '733D722C746869732E5F627261636B657450616972732E68616E646C654469644368616E67654F7074696F6E732861292C746869732E5F6465636F726174696F6E50726F76696465722E68616E646C654469644368616E67654F7074696F6E732861292C';
wwv_flow_imp.g_varchar2_table(8052) := '746869732E5F6F6E4469644368616E67654F7074696F6E732E666972652861297D646574656374496E64656E746174696F6E28652C74297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E7374206E3D617928746869732E5F62';
wwv_flow_imp.g_varchar2_table(8053) := '75666665722C742C65293B746869732E7570646174654F7074696F6E73287B696E736572745370616365733A6E2E696E736572745370616365732C74616253697A653A6E2E74616253697A652C696E64656E7453697A653A6E2E74616253697A657D297D';
wwv_flow_imp.g_varchar2_table(8054) := '6E6F726D616C697A65496E64656E746174696F6E2865297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C677528652C746869732E5F6F7074696F6E732E696E64656E7453697A652C746869732E5F6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(8055) := '2E696E73657274537061636573297D67657456657273696F6E496428297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C746869732E5F76657273696F6E49647D6D69676874436F6E7461696E52544C28297B726574';
wwv_flow_imp.g_varchar2_table(8056) := '75726E20746869732E5F6275666665722E6D69676874436F6E7461696E52544C28297D6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F727328297B72657475726E20746869732E5F6275666665722E6D69676874436F6E';
wwv_flow_imp.g_varchar2_table(8057) := '7461696E556E757375616C4C696E655465726D696E61746F727328297D72656D6F7665556E757375616C4C696E655465726D696E61746F727328653D6E756C6C297B636F6E737420743D746869732E66696E644D6174636865732848692E736F75726365';
wwv_flow_imp.g_varchar2_table(8058) := '2C21312C21302C21312C6E756C6C2C21312C31303733373431383234293B746869732E5F6275666665722E72657365744D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F727328292C746869732E70757368456469744F70';
wwv_flow_imp.g_varchar2_table(8059) := '65726174696F6E7328652C742E6D61702828653D3E287B72616E67653A652E72616E67652C746578743A6E756C6C7D2929292C2828293D3E6E756C6C29297D6D69676874436F6E7461696E4E6F6E4261736963415343494928297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(8060) := '69732E5F6275666665722E6D69676874436F6E7461696E4E6F6E4261736963415343494928297D676574416C7465726E617469766556657273696F6E496428297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C7468';
wwv_flow_imp.g_varchar2_table(8061) := '69732E5F616C7465726E617469766556657273696F6E49647D676574496E697469616C556E646F5265646F536E617073686F7428297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C746869732E5F696E697469616C';
wwv_flow_imp.g_varchar2_table(8062) := '556E646F5265646F536E617073686F747D6765744F666673657441742865297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E737420743D746869732E5F76616C6964617465506F736974696F6E28652E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(8063) := '722C652E636F6C756D6E2C30293B72657475726E20746869732E5F6275666665722E6765744F6666736574417428742E6C696E654E756D6265722C742E636F6C756D6E297D676574506F736974696F6E41742865297B746869732E5F6173736572744E6F';
wwv_flow_imp.g_varchar2_table(8064) := '74446973706F73656428293B636F6E737420743D4D6174682E6D696E28746869732E5F6275666665722E6765744C656E67746828292C4D6174682E6D617828302C6529293B72657475726E20746869732E5F6275666665722E676574506F736974696F6E';
wwv_flow_imp.g_varchar2_table(8065) := '41742874297D5F696E63726561736556657273696F6E496428297B746869732E5F76657273696F6E49643D746869732E5F76657273696F6E49642B312C746869732E5F616C7465726E617469766556657273696F6E49643D746869732E5F76657273696F';
wwv_flow_imp.g_varchar2_table(8066) := '6E49647D5F6F766572777269746556657273696F6E49642865297B746869732E5F76657273696F6E49643D657D5F6F7665727772697465416C7465726E617469766556657273696F6E49642865297B746869732E5F616C7465726E617469766556657273';
wwv_flow_imp.g_varchar2_table(8067) := '696F6E49643D657D5F6F7665727772697465496E697469616C556E646F5265646F536E617073686F742865297B746869732E5F696E697469616C556E646F5265646F536E617073686F743D657D67657456616C756528652C743D2131297B696628746869';
wwv_flow_imp.g_varchar2_table(8068) := '732E5F6173736572744E6F74446973706F73656428292C746869732E6973546F6F4C61726765466F72486561704F7065726174696F6E2829297468726F77206E6577204F6528224F7065726174696F6E20776F756C64206578636565642068656170206D';
wwv_flow_imp.g_varchar2_table(8069) := '656D6F7279206C696D69747322293B636F6E7374206E3D746869732E67657446756C6C4D6F64656C52616E676528292C693D746869732E67657456616C7565496E52616E6765286E2C65293B72657475726E20743F746869732E5F6275666665722E6765';
wwv_flow_imp.g_varchar2_table(8070) := '74424F4D28292B693A697D637265617465536E617073686F7428653D2131297B72657475726E206E657720534328746869732E5F6275666665722E637265617465536E617073686F74286529297D67657456616C75654C656E67746828652C743D213129';
wwv_flow_imp.g_varchar2_table(8071) := '7B746869732E5F6173736572744E6F74446973706F73656428293B636F6E7374206E3D746869732E67657446756C6C4D6F64656C52616E676528292C693D746869732E67657456616C75654C656E677468496E52616E6765286E2C65293B72657475726E';
wwv_flow_imp.g_varchar2_table(8072) := '20743F746869732E5F6275666665722E676574424F4D28292E6C656E6774682B693A697D67657456616C7565496E52616E676528652C743D30297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C746869732E5F6275';
wwv_flow_imp.g_varchar2_table(8073) := '666665722E67657456616C7565496E52616E676528746869732E76616C696461746552616E67652865292C74297D67657456616C75654C656E677468496E52616E676528652C743D30297B72657475726E20746869732E5F6173736572744E6F74446973';
wwv_flow_imp.g_varchar2_table(8074) := '706F73656428292C746869732E5F6275666665722E67657456616C75654C656E677468496E52616E676528746869732E76616C696461746552616E67652865292C74297D676574436861726163746572436F756E74496E52616E676528652C743D30297B';
wwv_flow_imp.g_varchar2_table(8075) := '72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C746869732E5F6275666665722E676574436861726163746572436F756E74496E52616E676528746869732E76616C696461746552616E67652865292C74297D6765744C';
wwv_flow_imp.g_varchar2_table(8076) := '696E65436F756E7428297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C746869732E5F6275666665722E6765744C696E65436F756E7428297D6765744C696E65436F6E74656E742865297B696628746869732E5F61';
wwv_flow_imp.g_varchar2_table(8077) := '73736572744E6F74446973706F73656428292C653C317C7C653E746869732E6765744C696E65436F756E742829297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B72657475726E207468';
wwv_flow_imp.g_varchar2_table(8078) := '69732E5F6275666665722E6765744C696E65436F6E74656E742865297D6765744C696E654C656E6774682865297B696628746869732E5F6173736572744E6F74446973706F73656428292C653C317C7C653E746869732E6765744C696E65436F756E7428';
wwv_flow_imp.g_varchar2_table(8079) := '29297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B72657475726E20746869732E5F6275666665722E6765744C696E654C656E6774682865297D6765744C696E6573436F6E74656E7428';
wwv_flow_imp.g_varchar2_table(8080) := '297B696628746869732E5F6173736572744E6F74446973706F73656428292C746869732E6973546F6F4C61726765466F72486561704F7065726174696F6E2829297468726F77206E6577204F6528224F7065726174696F6E20776F756C64206578636565';
wwv_flow_imp.g_varchar2_table(8081) := '642068656170206D656D6F7279206C696D69747322293B72657475726E20746869732E5F6275666665722E6765744C696E6573436F6E74656E7428297D676574454F4C28297B72657475726E20746869732E5F6173736572744E6F74446973706F736564';
wwv_flow_imp.g_varchar2_table(8082) := '28292C746869732E5F6275666665722E676574454F4C28297D676574456E644F664C696E6553657175656E636528297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C225C6E223D3D3D746869732E5F627566666572';
wwv_flow_imp.g_varchar2_table(8083) := '2E676574454F4C28293F303A317D6765744C696E654D696E436F6C756D6E2865297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C317D6765744C696E654D6178436F6C756D6E2865297B696628746869732E5F6173';
wwv_flow_imp.g_varchar2_table(8084) := '736572744E6F74446973706F73656428292C653C317C7C653E746869732E6765744C696E65436F756E742829297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(8085) := '732E5F6275666665722E6765744C696E654C656E6774682865292B317D6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2865297B696628746869732E5F6173736572744E6F74446973706F73656428292C653C317C7C653E';
wwv_flow_imp.g_varchar2_table(8086) := '746869732E6765744C696E65436F756E742829297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B72657475726E20746869732E5F6275666665722E6765744C696E6546697273744E6F6E';
wwv_flow_imp.g_varchar2_table(8087) := '57686974657370616365436F6C756D6E2865297D6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E2865297B696628746869732E5F6173736572744E6F74446973706F73656428292C653C317C7C653E746869732E6765744C69';
wwv_flow_imp.g_varchar2_table(8088) := '6E65436F756E742829297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B72657475726E20746869732E5F6275666665722E6765744C696E654C6173744E6F6E5768697465737061636543';
wwv_flow_imp.g_varchar2_table(8089) := '6F6C756D6E2865297D5F76616C696461746552616E676552656C617865644E6F416C6C6F636174696F6E732865297B636F6E737420743D746869732E5F6275666665722E6765744C696E65436F756E7428292C6E3D652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(8090) := '65722C693D652E7374617274436F6C756D6E3B6C6574206F3D4D6174682E666C6F6F7228226E756D62657222213D747970656F66206E7C7C69734E614E286E293F313A6E292C733D4D6174682E666C6F6F7228226E756D62657222213D747970656F6620';
wwv_flow_imp.g_varchar2_table(8091) := '697C7C69734E614E2869293F313A69293B6966286F3C31296F3D312C733D313B656C7365206966286F3E74296F3D742C733D746869732E6765744C696E654D6178436F6C756D6E286F293B656C736520696628733C3D3129733D313B656C73657B636F6E';
wwv_flow_imp.g_varchar2_table(8092) := '737420653D746869732E6765744C696E654D6178436F6C756D6E286F293B733E3D65262628733D65297D636F6E737420723D652E656E644C696E654E756D6265722C613D652E656E64436F6C756D6E3B6C6574206C3D4D6174682E666C6F6F7228226E75';
wwv_flow_imp.g_varchar2_table(8093) := '6D62657222213D747970656F6620727C7C69734E614E2872293F313A72292C633D4D6174682E666C6F6F7228226E756D62657222213D747970656F6620617C7C69734E614E2861293F313A61293B6966286C3C31296C3D312C633D313B656C7365206966';
wwv_flow_imp.g_varchar2_table(8094) := '286C3E74296C3D742C633D746869732E6765744C696E654D6178436F6C756D6E286C293B656C736520696628633C3D3129633D313B656C73657B636F6E737420653D746869732E6765744C696E654D6178436F6C756D6E286C293B633E3D65262628633D';
wwv_flow_imp.g_varchar2_table(8095) := '65297D72657475726E206E3D3D3D6F2626693D3D3D732626723D3D3D6C2626613D3D3D6326266520696E7374616E63656F66207268262621286520696E7374616E63656F66206168293F653A6E6577207268286F2C732C6C2C63297D5F697356616C6964';
wwv_flow_imp.g_varchar2_table(8096) := '506F736974696F6E28652C742C6E297B72657475726E226E756D626572223D3D747970656F6620652626226E756D626572223D3D747970656F6620742626282169734E614E28652926262169734E614E2874292626282128653C317C7C743C3129262628';
wwv_flow_imp.g_varchar2_table(8097) := '28307C65293D3D3D65262628307C74293D3D3D742626282128653E746869732E5F6275666665722E6765744C696E65436F756E74282929262628313D3D3D747C7C2128743E746869732E6765744C696E654D6178436F6C756D6E2865292926262831213D';
wwv_flow_imp.g_varchar2_table(8098) := '3D6E7C7C21546928746869732E5F6275666665722E6765744C696E6543686172436F646528652C742D3229292929292929297D5F76616C6964617465506F736974696F6E28652C742C6E297B636F6E737420693D4D6174682E666C6F6F7228226E756D62';
wwv_flow_imp.g_varchar2_table(8099) := '657222213D747970656F6620657C7C69734E614E2865293F313A65292C6F3D4D6174682E666C6F6F7228226E756D62657222213D747970656F6620747C7C69734E614E2874293F313A74292C733D746869732E5F6275666665722E6765744C696E65436F';
wwv_flow_imp.g_varchar2_table(8100) := '756E7428293B696628693C312972657475726E206E6577206D6328312C31293B696628693E732972657475726E206E6577206D6328732C746869732E6765744C696E654D6178436F6C756D6E287329293B6966286F3C3D312972657475726E206E657720';
wwv_flow_imp.g_varchar2_table(8101) := '6D6328692C31293B636F6E737420723D746869732E6765744C696E654D6178436F6C756D6E2869293B72657475726E206F3E3D723F6E6577206D6328692C72293A313D3D3D6E2626546928746869732E5F6275666665722E6765744C696E654368617243';
wwv_flow_imp.g_varchar2_table(8102) := '6F646528692C6F2D3229293F6E6577206D6328692C6F2D31293A6E6577206D6328692C6F297D76616C6964617465506F736974696F6E2865297B72657475726E20746869732E5F6173736572744E6F74446973706F73656428292C6520696E7374616E63';
wwv_flow_imp.g_varchar2_table(8103) := '656F66206D632626746869732E5F697356616C6964506F736974696F6E28652E6C696E654E756D6265722C652E636F6C756D6E2C31293F653A746869732E5F76616C6964617465506F736974696F6E28652E6C696E654E756D6265722C652E636F6C756D';
wwv_flow_imp.g_varchar2_table(8104) := '6E2C31297D5F697356616C696452616E676528652C74297B636F6E7374206E3D652E73746172744C696E654E756D6265722C693D652E7374617274436F6C756D6E2C6F3D652E656E644C696E654E756D6265722C733D652E656E64436F6C756D6E3B6966';
wwv_flow_imp.g_varchar2_table(8105) := '2821746869732E5F697356616C6964506F736974696F6E286E2C692C30292972657475726E21313B69662821746869732E5F697356616C6964506F736974696F6E286F2C732C30292972657475726E21313B696628313D3D3D74297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(8106) := '693E313F746869732E5F6275666665722E6765744C696E6543686172436F6465286E2C692D32293A302C743D733E312626733C3D746869732E5F6275666665722E6765744C696E654C656E677468286F293F746869732E5F6275666665722E6765744C69';
wwv_flow_imp.g_varchar2_table(8107) := '6E6543686172436F6465286F2C732D32293A302C723D54692865292C613D54692874293B72657475726E2172262621617D72657475726E21307D76616C696461746552616E67652865297B696628746869732E5F6173736572744E6F74446973706F7365';
wwv_flow_imp.g_varchar2_table(8108) := '6428292C6520696E7374616E63656F66207268262621286520696E7374616E63656F66206168292626746869732E5F697356616C696452616E676528652C31292972657475726E20653B636F6E737420743D746869732E5F76616C6964617465506F7369';
wwv_flow_imp.g_varchar2_table(8109) := '74696F6E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C30292C6E3D746869732E5F76616C6964617465506F736974696F6E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C30292C693D742E';
wwv_flow_imp.g_varchar2_table(8110) := '6C696E654E756D6265722C6F3D742E636F6C756D6E2C733D6E2E6C696E654E756D6265722C723D6E2E636F6C756D6E3B7B636F6E737420653D6F3E313F746869732E5F6275666665722E6765744C696E6543686172436F646528692C6F2D32293A302C74';
wwv_flow_imp.g_varchar2_table(8111) := '3D723E312626723C3D746869732E5F6275666665722E6765744C696E654C656E6774682873293F746869732E5F6275666665722E6765744C696E6543686172436F646528732C722D32293A302C6E3D54692865292C613D54692874293B72657475726E20';
wwv_flow_imp.g_varchar2_table(8112) := '6E7C7C613F693D3D3D7326266F3D3D3D723F6E657720726828692C6F2D312C732C722D31293A6E2626613F6E657720726828692C6F2D312C732C722B31293A6E3F6E657720726828692C6F2D312C732C72293A6E657720726828692C6F2C732C722B3129';
wwv_flow_imp.g_varchar2_table(8113) := '3A6E657720726828692C6F2C732C72297D7D6D6F64696679506F736974696F6E28652C74297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E7374206E3D746869732E6765744F666673657441742865292B743B72657475726E';
wwv_flow_imp.g_varchar2_table(8114) := '20746869732E676574506F736974696F6E4174284D6174682E6D696E28746869732E5F6275666665722E6765744C656E67746828292C4D6174682E6D617828302C6E2929297D67657446756C6C4D6F64656C52616E676528297B746869732E5F61737365';
wwv_flow_imp.g_varchar2_table(8115) := '72744E6F74446973706F73656428293B636F6E737420653D746869732E6765744C696E65436F756E7428293B72657475726E206E657720726828312C312C652C746869732E6765744C696E654D6178436F6C756D6E286529297D66696E644D6174636865';
wwv_flow_imp.g_varchar2_table(8116) := '734C696E6542794C696E6528652C742C6E2C69297B72657475726E20746869732E5F6275666665722E66696E644D6174636865734C696E6542794C696E6528652C742C6E2C69297D66696E644D61746368657328652C742C6E2C692C6F2C732C723D3939';
wwv_flow_imp.g_varchar2_table(8117) := '39297B746869732E5F6173736572744E6F74446973706F73656428293B6C657420613D6E756C6C3B6E756C6C213D3D7426262841727261792E697341727261792874297C7C28743D5B745D292C742E65766572792828653D3E72682E69734952616E6765';
wwv_flow_imp.g_varchar2_table(8118) := '2865292929262628613D742E6D61702828653D3E746869732E76616C696461746552616E6765286529292929292C6E756C6C3D3D3D61262628613D5B746869732E67657446756C6C4D6F64656C52616E676528295D292C613D612E736F7274282828652C';
wwv_flow_imp.g_varchar2_table(8119) := '74293D3E652E73746172744C696E654E756D6265722D742E73746172744C696E654E756D6265727C7C652E7374617274436F6C756D6E2D742E7374617274436F6C756D6E29293B636F6E7374206C3D5B5D3B6C657420633B6966286C2E7075736828612E';
wwv_flow_imp.g_varchar2_table(8120) := '726564756365282828652C74293D3E72682E617265496E74657273656374696E6728652C74293F652E706C757352616E67652874293A286C2E707573682865292C74292929292C216E2626652E696E6465784F6628225C6E22293C30297B636F6E737420';
wwv_flow_imp.g_varchar2_table(8121) := '743D6E6577205A7928652C6E2C692C6F292E70617273655365617263685265717565737428293B69662821742972657475726E5B5D3B633D653D3E746869732E66696E644D6174636865734C696E6542794C696E6528652C742C732C72297D656C736520';
wwv_flow_imp.g_varchar2_table(8122) := '633D743D3E65772E66696E644D61746368657328746869732C6E6577205A7928652C6E2C692C6F292C742C732C72293B72657475726E206C2E6D61702863292E726564756365282828652C74293D3E652E636F6E636174287429292C5B5D297D66696E64';
wwv_flow_imp.g_varchar2_table(8123) := '4E6578744D6174636828652C742C6E2C692C6F2C73297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E737420723D746869732E76616C6964617465506F736974696F6E2874293B696628216E2626652E696E6465784F662822';
wwv_flow_imp.g_varchar2_table(8124) := '5C6E22293C30297B636F6E737420743D6E6577205A7928652C6E2C692C6F292E70617273655365617263685265717565737428293B69662821742972657475726E206E756C6C3B636F6E737420613D746869732E6765744C696E65436F756E7428293B6C';
wwv_flow_imp.g_varchar2_table(8125) := '6574206C3D6E657720726828722E6C696E654E756D6265722C722E636F6C756D6E2C612C746869732E6765744C696E654D6178436F6C756D6E286129292C633D746869732E66696E644D6174636865734C696E6542794C696E65286C2C742C732C31293B';
wwv_flow_imp.g_varchar2_table(8126) := '72657475726E2065772E66696E644E6578744D6174636828746869732C6E6577205A7928652C6E2C692C6F292C722C73292C632E6C656E6774683E303F635B305D3A286C3D6E657720726828312C312C722E6C696E654E756D6265722C746869732E6765';
wwv_flow_imp.g_varchar2_table(8127) := '744C696E654D6178436F6C756D6E28722E6C696E654E756D62657229292C633D746869732E66696E644D6174636865734C696E6542794C696E65286C2C742C732C31292C632E6C656E6774683E303F635B305D3A6E756C6C297D72657475726E2065772E';
wwv_flow_imp.g_varchar2_table(8128) := '66696E644E6578744D6174636828746869732C6E6577205A7928652C6E2C692C6F292C722C73297D66696E6450726576696F75734D6174636828652C742C6E2C692C6F2C73297B746869732E5F6173736572744E6F74446973706F73656428293B636F6E';
wwv_flow_imp.g_varchar2_table(8129) := '737420723D746869732E76616C6964617465506F736974696F6E2874293B72657475726E2065772E66696E6450726576696F75734D6174636828746869732C6E6577205A7928652C6E2C692C6F292C722C73297D70757368537461636B456C656D656E74';
wwv_flow_imp.g_varchar2_table(8130) := '28297B746869732E5F636F6D6D616E644D616E616765722E70757368537461636B456C656D656E7428297D706F70537461636B456C656D656E7428297B746869732E5F636F6D6D616E644D616E616765722E706F70537461636B456C656D656E7428297D';
wwv_flow_imp.g_varchar2_table(8131) := '70757368454F4C2865297B69662828225C6E223D3D3D746869732E676574454F4C28293F303A3129213D3D65297472797B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E4465666572726564456D697428292C7468';
wwv_flow_imp.g_varchar2_table(8132) := '69732E5F6576656E74456D69747465722E626567696E4465666572726564456D697428292C6E756C6C3D3D3D746869732E5F696E697469616C556E646F5265646F536E617073686F74262628746869732E5F696E697469616C556E646F5265646F536E61';
wwv_flow_imp.g_varchar2_table(8133) := '7073686F743D746869732E5F756E646F5265646F536572766963652E637265617465536E617073686F7428746869732E75726929292C746869732E5F636F6D6D616E644D616E616765722E70757368454F4C2865297D66696E616C6C797B746869732E5F';
wwv_flow_imp.g_varchar2_table(8134) := '6576656E74456D69747465722E656E644465666572726564456D697428292C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E656E644465666572726564456D697428297D7D5F76616C6964617465456469744F7065726174696F';
wwv_flow_imp.g_varchar2_table(8135) := '6E2865297B72657475726E206520696E7374616E63656F662054683F653A6E657720546828652E6964656E7469666965727C7C6E756C6C2C746869732E76616C696461746552616E676528652E72616E6765292C652E746578742C652E666F7263654D6F';
wwv_flow_imp.g_varchar2_table(8136) := '76654D61726B6572737C7C21312C652E69734175746F57686974657370616365456469747C7C21312C652E5F6973547261636B65647C7C2131297D5F76616C6964617465456469744F7065726174696F6E732865297B636F6E737420743D5B5D3B666F72';
wwv_flow_imp.g_varchar2_table(8137) := '286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D746869732E5F76616C6964617465456469744F7065726174696F6E28655B6E5D293B72657475726E20747D70757368456469744F7065726174696F6E7328652C742C6E';
wwv_flow_imp.g_varchar2_table(8138) := '2C69297B7472797B72657475726E20746869732E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E4465666572726564456D697428292C746869732E5F6576656E74456D69747465722E626567696E4465666572726564456D6974';
wwv_flow_imp.g_varchar2_table(8139) := '28292C746869732E5F70757368456469744F7065726174696F6E7328652C746869732E5F76616C6964617465456469744F7065726174696F6E732874292C6E2C69297D66696E616C6C797B746869732E5F6576656E74456D69747465722E656E64446566';
wwv_flow_imp.g_varchar2_table(8140) := '6572726564456D697428292C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E656E644465666572726564456D697428297D7D5F70757368456469744F7065726174696F6E7328652C742C6E2C69297B696628746869732E5F6F70';
wwv_flow_imp.g_varchar2_table(8141) := '74696F6E732E7472696D4175746F576869746573706163652626746869732E5F7472696D4175746F576869746573706163654C696E6573297B636F6E7374206E3D742E6D61702828653D3E287B72616E67653A746869732E76616C696461746552616E67';
wwv_flow_imp.g_varchar2_table(8142) := '6528652E72616E6765292C746578743A652E746578747D2929293B6C657420693D21303B6966286529666F72286C657420743D302C6F3D652E6C656E6774683B743C6F3B742B2B297B636F6E7374206F3D655B745D3B6C657420733D21313B666F72286C';
wwv_flow_imp.g_varchar2_table(8143) := '657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D2E72616E67652C693D742E73746172744C696E654E756D6265723E6F2E656E644C696E654E756D6265722C723D6F2E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(8144) := '723E742E656E644C696E654E756D6265723B696628216926262172297B733D21303B627265616B7D7D6966282173297B693D21313B627265616B7D7D6966286929666F72286C657420653D302C693D746869732E5F7472696D4175746F57686974657370';
wwv_flow_imp.g_varchar2_table(8145) := '6163654C696E65732E6C656E6774683B653C693B652B2B297B636F6E737420693D746869732E5F7472696D4175746F576869746573706163654C696E65735B655D2C6F3D746869732E6765744C696E654D6178436F6C756D6E2869293B6C657420733D21';
wwv_flow_imp.g_varchar2_table(8146) := '303B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D2E72616E67652C723D6E5B655D2E746578743B6966282128693C742E73746172744C696E654E756D6265727C7C693E742E656E644C69';
wwv_flow_imp.g_varchar2_table(8147) := '6E654E756D6265727C7C693D3D3D742E73746172744C696E654E756D6265722626742E7374617274436F6C756D6E3D3D3D6F2626742E6973456D70747928292626722626722E6C656E6774683E302626225C6E223D3D3D722E6368617241742830297C7C';
wwv_flow_imp.g_varchar2_table(8148) := '693D3D3D742E73746172744C696E654E756D6265722626313D3D3D742E7374617274436F6C756D6E2626742E6973456D70747928292626722626722E6C656E6774683E302626225C6E223D3D3D722E63686172417428722E6C656E6774682D312929297B';
wwv_flow_imp.g_varchar2_table(8149) := '733D21313B627265616B7D7D69662873297B636F6E737420653D6E657720726828692C312C692C6F293B742E70757368286E6577205468286E756C6C2C652C6E756C6C2C21312C21312C213129297D7D746869732E5F7472696D4175746F576869746573';
wwv_flow_imp.g_varchar2_table(8150) := '706163654C696E65733D6E756C6C7D72657475726E206E756C6C3D3D3D746869732E5F696E697469616C556E646F5265646F536E617073686F74262628746869732E5F696E697469616C556E646F5265646F536E617073686F743D746869732E5F756E64';
wwv_flow_imp.g_varchar2_table(8151) := '6F5265646F536572766963652E637265617465536E617073686F7428746869732E75726929292C746869732E5F636F6D6D616E644D616E616765722E70757368456469744F7065726174696F6E28652C742C6E2C69297D5F6170706C79556E646F28652C';
wwv_flow_imp.g_varchar2_table(8152) := '742C6E2C69297B636F6E7374206F3D652E6D61702828653D3E7B636F6E737420743D746869732E676574506F736974696F6E417428652E6E6577506F736974696F6E292C6E3D746869732E676574506F736974696F6E417428652E6E6577456E64293B72';
wwv_flow_imp.g_varchar2_table(8153) := '657475726E7B72616E67653A6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E292C746578743A652E6F6C64546578747D7D29293B746869732E5F6170706C79556E646F5265';
wwv_flow_imp.g_varchar2_table(8154) := '646F4564697473286F2C742C21302C21312C6E2C69297D5F6170706C795265646F28652C742C6E2C69297B636F6E7374206F3D652E6D61702828653D3E7B636F6E737420743D746869732E676574506F736974696F6E417428652E6F6C64506F73697469';
wwv_flow_imp.g_varchar2_table(8155) := '6F6E292C6E3D746869732E676574506F736974696F6E417428652E6F6C64456E64293B72657475726E7B72616E67653A6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E292C';
wwv_flow_imp.g_varchar2_table(8156) := '746578743A652E6E6577546578747D7D29293B746869732E5F6170706C79556E646F5265646F4564697473286F2C742C21312C21302C6E2C69297D5F6170706C79556E646F5265646F456469747328652C742C6E2C692C6F2C73297B7472797B74686973';
wwv_flow_imp.g_varchar2_table(8157) := '2E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E4465666572726564456D697428292C746869732E5F6576656E74456D69747465722E626567696E4465666572726564456D697428292C746869732E5F6973556E646F696E673D';
wwv_flow_imp.g_varchar2_table(8158) := '6E2C746869732E5F69735265646F696E673D692C746869732E6170706C79456469747328652C2131292C746869732E736574454F4C2874292C746869732E5F6F7665727772697465416C7465726E617469766556657273696F6E4964286F297D66696E61';
wwv_flow_imp.g_varchar2_table(8159) := '6C6C797B746869732E5F6973556E646F696E673D21312C746869732E5F69735265646F696E673D21312C746869732E5F6576656E74456D69747465722E656E644465666572726564456D69742873292C746869732E5F6F6E4469644368616E6765446563';
wwv_flow_imp.g_varchar2_table(8160) := '6F726174696F6E732E656E644465666572726564456D697428297D7D6170706C79456469747328652C743D2131297B7472797B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E4465666572726564456D697428292C';
wwv_flow_imp.g_varchar2_table(8161) := '746869732E5F6576656E74456D69747465722E626567696E4465666572726564456D697428293B636F6E7374206E3D746869732E5F76616C6964617465456469744F7065726174696F6E732865293B72657475726E20746869732E5F646F4170706C7945';
wwv_flow_imp.g_varchar2_table(8162) := '64697473286E2C74297D66696E616C6C797B746869732E5F6576656E74456D69747465722E656E644465666572726564456D697428292C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E656E644465666572726564456D697428';
wwv_flow_imp.g_varchar2_table(8163) := '297D7D5F646F4170706C79456469747328652C74297B636F6E7374206E3D746869732E5F6275666665722E6765744C696E65436F756E7428292C693D746869732E5F6275666665722E6170706C79456469747328652C746869732E5F6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(8164) := '7472696D4175746F576869746573706163652C74292C6F3D746869732E5F6275666665722E6765744C696E65436F756E7428292C733D692E6368616E6765733B696628746869732E5F7472696D4175746F576869746573706163654C696E65733D692E74';
wwv_flow_imp.g_varchar2_table(8165) := '72696D4175746F576869746573706163654C696E654E756D626572732C30213D3D732E6C656E677468297B666F72286C657420653D302C743D732E6C656E6774683B653C743B652B2B297B636F6E737420743D735B655D3B746869732E5F6465636F7261';
wwv_flow_imp.g_varchar2_table(8166) := '74696F6E73547265652E6163636570745265706C61636528742E72616E67654F66667365742C742E72616E67654C656E6774682C742E746578742E6C656E6774682C742E666F7263654D6F76654D61726B657273297D636F6E737420653D5B5D3B746869';
wwv_flow_imp.g_varchar2_table(8167) := '732E5F696E63726561736556657273696F6E496428293B6C657420743D6E3B666F72286C6574206E3D302C693D732E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D735B6E5D2C5B725D3D757528692E74657874293B746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(8168) := '69644368616E67654465636F726174696F6E732E6669726528293B636F6E737420613D692E72616E67652E73746172744C696E654E756D6265722C6C3D692E72616E67652E656E644C696E654E756D6265722C633D6C2D612C643D722C683D4D6174682E';
wwv_flow_imp.g_varchar2_table(8169) := '6D696E28632C64292C753D642D632C703D6F2D742D752B612C673D702C6D3D702B642C663D746869732E5F6465636F726174696F6E73547265652E676574496E6A656374656454657874496E496E74657276616C28746869732C746869732E6765744F66';
wwv_flow_imp.g_varchar2_table(8170) := '667365744174286E6577206D6328672C3129292C746869732E6765744F66667365744174286E6577206D63286D2C746869732E6765744C696E654D6178436F6C756D6E286D2929292C30292C763D61432E66726F6D4465636F726174696F6E732866292C';
wwv_flow_imp.g_varchar2_table(8171) := '623D6E6577206F752876293B666F72286C657420743D683B743E3D303B742D2D297B636F6E7374206E3D612B742C693D702B743B622E74616B6546726F6D456E645768696C652828653D3E652E6C696E654E756D6265723E6929293B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(8172) := '622E74616B6546726F6D456E645768696C652828653D3E652E6C696E654E756D6265723D3D3D6929293B652E70757368286E6577206C43286E2C746869732E6765744C696E65436F6E74656E742869292C6F29297D696628683C63297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(8173) := '3D612B683B652E70757368286E657720634328742B312C6C29297D696628683C64297B636F6E7374206E3D6E6577206F752876292C693D612B682C733D642D682C723D6F2D742D732B692B312C6C3D5B5D2C633D5B5D3B666F72286C657420653D303B65';
wwv_flow_imp.g_varchar2_table(8174) := '3C733B652B2B297B636F6E737420743D722B653B635B655D3D746869732E6765744C696E65436F6E74656E742874292C6E2E74616B655768696C652828653D3E652E6C696E654E756D6265723C7429292C6C5B655D3D6E2E74616B655768696C65282865';
wwv_flow_imp.g_varchar2_table(8175) := '3D3E652E6C696E654E756D6265723D3D3D7429297D652E70757368286E657720644328692B312C612B642C632C6C29297D742B3D757D746869732E5F656D6974436F6E74656E744368616E6765644576656E74286E657720754328652C746869732E6765';
wwv_flow_imp.g_varchar2_table(8176) := '7456657273696F6E496428292C746869732E5F6973556E646F696E672C746869732E5F69735265646F696E67292C7B6368616E6765733A732C656F6C3A746869732E5F6275666665722E676574454F4C28292C6973456F6C4368616E67653A21312C7665';
wwv_flow_imp.g_varchar2_table(8177) := '7273696F6E49643A746869732E67657456657273696F6E496428292C6973556E646F696E673A746869732E5F6973556E646F696E672C69735265646F696E673A746869732E5F69735265646F696E672C6973466C7573683A21317D297D72657475726E20';
wwv_flow_imp.g_varchar2_table(8178) := '6E756C6C3D3D3D692E7265766572736545646974733F766F696420303A692E7265766572736545646974737D756E646F28297B72657475726E20746869732E5F756E646F5265646F536572766963652E756E646F28746869732E757269297D63616E556E';
wwv_flow_imp.g_varchar2_table(8179) := '646F28297B72657475726E20746869732E5F756E646F5265646F536572766963652E63616E556E646F28746869732E757269297D7265646F28297B72657475726E20746869732E5F756E646F5265646F536572766963652E7265646F28746869732E7572';
wwv_flow_imp.g_varchar2_table(8180) := '69297D63616E5265646F28297B72657475726E20746869732E5F756E646F5265646F536572766963652E63616E5265646F28746869732E757269297D68616E646C654265666F7265466972654465636F726174696F6E734368616E6765644576656E7428';
wwv_flow_imp.g_varchar2_table(8181) := '65297B6966286E756C6C3D3D3D657C7C303D3D3D652E73697A652972657475726E3B636F6E737420743D41727261792E66726F6D2865292E6D61702828653D3E6E6577206C4328652C746869732E6765744C696E65436F6E74656E742865292C74686973';
wwv_flow_imp.g_varchar2_table(8182) := '2E5F676574496E6A656374656454657874496E4C696E652865292929293B746869732E5F6F6E4469644368616E6765496E6A6563746564546578742E66697265286E6577207043287429297D6368616E67654465636F726174696F6E7328652C743D3029';
wwv_flow_imp.g_varchar2_table(8183) := '7B746869732E5F6173736572744E6F74446973706F73656428293B7472797B72657475726E20746869732E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E4465666572726564456D697428292C746869732E5F6368616E676544';
wwv_flow_imp.g_varchar2_table(8184) := '65636F726174696F6E7328742C65297D66696E616C6C797B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E656E644465666572726564456D697428297D7D5F6368616E67654465636F726174696F6E7328652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(8185) := '74206E3D7B6164644465636F726174696F6E3A28742C6E293D3E746869732E5F64656C74614465636F726174696F6E73496D706C28652C5B5D2C5B7B72616E67653A742C6F7074696F6E733A6E7D5D295B305D2C6368616E67654465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(8186) := '3A28652C74293D3E7B746869732E5F6368616E67654465636F726174696F6E496D706C28652C74297D2C6368616E67654465636F726174696F6E4F7074696F6E733A28652C74293D3E7B746869732E5F6368616E67654465636F726174696F6E4F707469';
wwv_flow_imp.g_varchar2_table(8187) := '6F6E73496D706C28652C4643287429297D2C72656D6F76654465636F726174696F6E3A743D3E7B746869732E5F64656C74614465636F726174696F6E73496D706C28652C5B745D2C5B5D297D2C64656C74614465636F726174696F6E733A28742C6E293D';
wwv_flow_imp.g_varchar2_table(8188) := '3E303D3D3D742E6C656E6774682626303D3D3D6E2E6C656E6774683F5B5D3A746869732E5F64656C74614465636F726174696F6E73496D706C28652C742C6E297D3B6C657420693D6E756C6C3B7472797B693D74286E297D63617463682865297B6B6528';
wwv_flow_imp.g_varchar2_table(8189) := '65297D72657475726E206E2E6164644465636F726174696F6E3D78432C6E2E6368616E67654465636F726174696F6E3D78432C6E2E6368616E67654465636F726174696F6E4F7074696F6E733D78432C6E2E72656D6F76654465636F726174696F6E3D78';
wwv_flow_imp.g_varchar2_table(8190) := '432C6E2E64656C74614465636F726174696F6E733D78432C697D64656C74614465636F726174696F6E7328652C742C6E3D30297B696628746869732E5F6173736572744E6F74446973706F73656428292C657C7C28653D5B5D292C303D3D3D652E6C656E';
wwv_flow_imp.g_varchar2_table(8191) := '6774682626303D3D3D742E6C656E6774682972657475726E5B5D3B7472797B72657475726E20746869732E5F64656C74614465636F726174696F6E43616C6C436E742B2B2C746869732E5F64656C74614465636F726174696F6E43616C6C436E743E3126';
wwv_flow_imp.g_varchar2_table(8192) := '2628636F6E736F6C652E7761726E2822496E766F6B696E672064656C74614465636F726174696F6E73207265637572736976656C7920636F756C64206C65616420746F206C65616B696E67206465636F726174696F6E732E22292C6B65286E6577204572';
wwv_flow_imp.g_varchar2_table(8193) := '726F722822496E766F6B696E672064656C74614465636F726174696F6E73207265637572736976656C7920636F756C64206C65616420746F206C65616B696E67206465636F726174696F6E732E222929292C746869732E5F6F6E4469644368616E676544';
wwv_flow_imp.g_varchar2_table(8194) := '65636F726174696F6E732E626567696E4465666572726564456D697428292C746869732E5F64656C74614465636F726174696F6E73496D706C286E2C652C74297D66696E616C6C797B746869732E5F6F6E4469644368616E67654465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(8195) := '732E656E644465666572726564456D697428292C746869732E5F64656C74614465636F726174696F6E43616C6C436E742D2D7D7D5F676574547261636B656452616E67652865297B72657475726E20746869732E6765744465636F726174696F6E52616E';
wwv_flow_imp.g_varchar2_table(8196) := '67652865297D5F736574547261636B656452616E676528652C742C6E297B636F6E737420693D653F746869732E5F6465636F726174696F6E735B655D3A6E756C6C3B69662821692972657475726E20743F746869732E5F64656C74614465636F72617469';
wwv_flow_imp.g_varchar2_table(8197) := '6F6E73496D706C28302C5B5D2C5B7B72616E67653A742C6F7074696F6E733A52435B6E5D7D5D2C2130295B305D3A6E756C6C3B69662821742972657475726E20746869732E5F6465636F726174696F6E73547265652E64656C6574652869292C64656C65';
wwv_flow_imp.g_varchar2_table(8198) := '746520746869732E5F6465636F726174696F6E735B692E69645D2C6E756C6C3B636F6E7374206F3D746869732E5F76616C696461746552616E676552656C617865644E6F416C6C6F636174696F6E732874292C733D746869732E5F6275666665722E6765';
wwv_flow_imp.g_varchar2_table(8199) := '744F66667365744174286F2E73746172744C696E654E756D6265722C6F2E7374617274436F6C756D6E292C723D746869732E5F6275666665722E6765744F66667365744174286F2E656E644C696E654E756D6265722C6F2E656E64436F6C756D6E293B72';
wwv_flow_imp.g_varchar2_table(8200) := '657475726E20746869732E5F6465636F726174696F6E73547265652E64656C6574652869292C692E726573657428746869732E67657456657273696F6E496428292C732C722C6F292C692E7365744F7074696F6E732852435B6E5D292C746869732E5F64';
wwv_flow_imp.g_varchar2_table(8201) := '65636F726174696F6E73547265652E696E736572742869292C692E69647D72656D6F7665416C6C4465636F726174696F6E73576974684F776E657249642865297B696628746869732E5F6973446973706F7365642972657475726E3B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(8202) := '746869732E5F6465636F726174696F6E73547265652E636F6C6C6563744E6F64657346726F6D4F776E65722865293B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D3B746869732E5F6465';
wwv_flow_imp.g_varchar2_table(8203) := '636F726174696F6E73547265652E64656C657465286E292C64656C65746520746869732E5F6465636F726174696F6E735B6E2E69645D7D7D6765744465636F726174696F6E4F7074696F6E732865297B636F6E737420743D746869732E5F6465636F7261';
wwv_flow_imp.g_varchar2_table(8204) := '74696F6E735B655D3B72657475726E20743F742E6F7074696F6E733A6E756C6C7D6765744465636F726174696F6E52616E67652865297B636F6E737420743D746869732E5F6465636F726174696F6E735B655D3B72657475726E20743F746869732E5F64';
wwv_flow_imp.g_varchar2_table(8205) := '65636F726174696F6E73547265652E6765744E6F646552616E676528746869732C74293A6E756C6C7D6765744C696E654465636F726174696F6E7328652C743D302C6E3D2131297B72657475726E20653C317C7C653E746869732E6765744C696E65436F';
wwv_flow_imp.g_varchar2_table(8206) := '756E7428293F5B5D3A746869732E6765744C696E65734465636F726174696F6E7328652C652C742C6E297D6765744C696E65734465636F726174696F6E7328652C742C6E3D302C693D21312C6F3D2131297B636F6E737420733D746869732E6765744C69';
wwv_flow_imp.g_varchar2_table(8207) := '6E65436F756E7428292C723D4D6174682E6D696E28732C4D6174682E6D617828312C6529292C613D4D6174682E6D696E28732C4D6174682E6D617828312C7429292C6C3D746869732E6765744C696E654D6178436F6C756D6E2861292C633D6E65772072';
wwv_flow_imp.g_varchar2_table(8208) := '6828722C312C612C6C292C643D746869732E5F6765744465636F726174696F6E73496E52616E676528632C6E2C692C6F293B72657475726E20596828642C746869732E5F6465636F726174696F6E50726F76696465722E6765744465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(8209) := '73496E52616E676528632C6E2C6929292C647D6765744465636F726174696F6E73496E52616E676528652C743D302C6E3D21312C693D21312C6F3D2131297B636F6E737420733D746869732E76616C696461746552616E67652865292C723D746869732E';
wwv_flow_imp.g_varchar2_table(8210) := '5F6765744465636F726174696F6E73496E52616E676528732C742C6E2C6F293B72657475726E20596828722C746869732E5F6465636F726174696F6E50726F76696465722E6765744465636F726174696F6E73496E52616E676528732C742C6E2C692929';
wwv_flow_imp.g_varchar2_table(8211) := '2C727D6765744F7665727669657752756C65724465636F726174696F6E7328653D302C743D2131297B72657475726E20746869732E5F6465636F726174696F6E73547265652E676574416C6C28746869732C652C742C21302C2131297D676574496E6A65';
wwv_flow_imp.g_varchar2_table(8212) := '63746564546578744465636F726174696F6E7328653D30297B72657475726E20746869732E5F6465636F726174696F6E73547265652E676574416C6C496E6A65637465645465787428746869732C65297D5F676574496E6A656374656454657874496E4C';
wwv_flow_imp.g_varchar2_table(8213) := '696E652865297B636F6E737420743D746869732E5F6275666665722E6765744F6666736574417428652C31292C6E3D742B746869732E5F6275666665722E6765744C696E654C656E6774682865292C693D746869732E5F6465636F726174696F6E735472';
wwv_flow_imp.g_varchar2_table(8214) := '65652E676574496E6A656374656454657874496E496E74657276616C28746869732C742C6E2C30293B72657475726E2061432E66726F6D4465636F726174696F6E732869292E66696C7465722828743D3E742E6C696E654E756D6265723D3D3D6529297D';
wwv_flow_imp.g_varchar2_table(8215) := '676574416C6C4465636F726174696F6E7328653D302C743D2131297B6C6574206E3D746869732E5F6465636F726174696F6E73547265652E676574416C6C28746869732C652C742C21312C2131293B72657475726E206E3D6E2E636F6E63617428746869';
wwv_flow_imp.g_varchar2_table(8216) := '732E5F6465636F726174696F6E50726F76696465722E676574416C6C4465636F726174696F6E7328652C7429292C6E7D676574416C6C4D617267696E4465636F726174696F6E7328653D30297B72657475726E20746869732E5F6465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(8217) := '73547265652E676574416C6C28746869732C652C21312C21312C2130297D5F6765744465636F726174696F6E73496E52616E676528652C742C6E2C69297B636F6E7374206F3D746869732E5F6275666665722E6765744F6666736574417428652E737461';
wwv_flow_imp.g_varchar2_table(8218) := '72744C696E654E756D6265722C652E7374617274436F6C756D6E292C733D746869732E5F6275666665722E6765744F6666736574417428652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293B72657475726E20746869732E5F646563';
wwv_flow_imp.g_varchar2_table(8219) := '6F726174696F6E73547265652E676574416C6C496E496E74657276616C28746869732C6F2C732C742C6E2C69297D67657452616E6765417428652C74297B72657475726E20746869732E5F6275666665722E67657452616E6765417428652C742D65297D';
wwv_flow_imp.g_varchar2_table(8220) := '5F6368616E67654465636F726174696F6E496D706C28652C74297B636F6E7374206E3D746869732E5F6465636F726174696F6E735B655D3B696628216E2972657475726E3B6966286E2E6F7074696F6E732E6166746572297B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(8221) := '732E6765744465636F726174696F6E52616E67652865293B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428742E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(8222) := '72297D6966286E2E6F7074696F6E732E6265666F7265297B636F6E737420743D746869732E6765744465636F726174696F6E52616E67652865293B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E654166';
wwv_flow_imp.g_varchar2_table(8223) := '6665637465644279496E6A65637465645465787428742E73746172744C696E654E756D626572297D636F6E737420693D746869732E5F76616C696461746552616E676552656C617865644E6F416C6C6F636174696F6E732874292C6F3D746869732E5F62';
wwv_flow_imp.g_varchar2_table(8224) := '75666665722E6765744F6666736574417428692E73746172744C696E654E756D6265722C692E7374617274436F6C756D6E292C733D746869732E5F6275666665722E6765744F6666736574417428692E656E644C696E654E756D6265722C692E656E6443';
wwv_flow_imp.g_varchar2_table(8225) := '6F6C756D6E293B746869732E5F6465636F726174696F6E73547265652E64656C657465286E292C6E2E726573657428746869732E67657456657273696F6E496428292C6F2C732C69292C746869732E5F6465636F726174696F6E73547265652E696E7365';
wwv_flow_imp.g_varchar2_table(8226) := '7274286E292C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E636865636B4166666563746564416E6446697265286E2E6F7074696F6E73292C6E2E6F7074696F6E732E61667465722626746869732E5F6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(8227) := '654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428692E656E644C696E654E756D626572292C6E2E6F7074696F6E732E6265666F72652626746869732E5F6F6E4469644368616E67654465';
wwv_flow_imp.g_varchar2_table(8228) := '636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428692E73746172744C696E654E756D626572297D5F6368616E67654465636F726174696F6E4F7074696F6E73496D706C28652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(8229) := '74206E3D746869732E5F6465636F726174696F6E735B655D3B696628216E2972657475726E3B636F6E737420693D2128216E2E6F7074696F6E732E6F7665727669657752756C65727C7C216E2E6F7074696F6E732E6F7665727669657752756C65722E63';
wwv_flow_imp.g_varchar2_table(8230) := '6F6C6F72292C6F3D212821742E6F7665727669657752756C65727C7C21742E6F7665727669657752756C65722E636F6C6F72293B696628746869732E5F6F6E4469644368616E67654465636F726174696F6E732E636865636B4166666563746564416E64';
wwv_flow_imp.g_varchar2_table(8231) := '46697265286E2E6F7074696F6E73292C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E636865636B4166666563746564416E64466972652874292C6E2E6F7074696F6E732E61667465727C7C742E6166746572297B636F6E7374';
wwv_flow_imp.g_varchar2_table(8232) := '20653D746869732E5F6465636F726174696F6E73547265652E6765744E6F646552616E676528746869732C6E293B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A6563';
wwv_flow_imp.g_varchar2_table(8233) := '7465645465787428652E656E644C696E654E756D626572297D6966286E2E6F7074696F6E732E6265666F72657C7C742E6265666F7265297B636F6E737420653D746869732E5F6465636F726174696F6E73547265652E6765744E6F646552616E67652874';
wwv_flow_imp.g_varchar2_table(8234) := '6869732C6E293B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428652E73746172744C696E654E756D626572297D636F6E737420733D69213D3D';
wwv_flow_imp.g_varchar2_table(8235) := '6F2C723D66756E6374696F6E2865297B72657475726E2121652E61667465727C7C2121652E6265666F72657D287429213D3D4C43286E293B737C7C723F28746869732E5F6465636F726174696F6E73547265652E64656C657465286E292C6E2E7365744F';
wwv_flow_imp.g_varchar2_table(8236) := '7074696F6E732874292C746869732E5F6465636F726174696F6E73547265652E696E73657274286E29293A6E2E7365744F7074696F6E732874297D5F64656C74614465636F726174696F6E73496D706C28652C742C6E2C693D2131297B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(8237) := '3D746869732E67657456657273696F6E496428292C733D742E6C656E6774683B6C657420723D303B636F6E737420613D6E2E6C656E6774683B6C6574206C3D303B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E626567696E44';
wwv_flow_imp.g_varchar2_table(8238) := '65666572726564456D697428293B7472797B636F6E737420633D6E65772041727261792861293B666F72283B723C737C7C6C3C613B297B6C657420643D6E756C6C3B696628723C73297B646F7B643D746869732E5F6465636F726174696F6E735B745B72';
wwv_flow_imp.g_varchar2_table(8239) := '2B2B5D5D7D7768696C652821642626723C73293B69662864297B696628642E6F7074696F6E732E6166746572297B636F6E737420653D746869732E5F6465636F726174696F6E73547265652E6765744E6F646552616E676528746869732C64293B746869';
wwv_flow_imp.g_varchar2_table(8240) := '732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428652E656E644C696E654E756D626572297D696628642E6F7074696F6E732E6265666F7265297B636F6E';
wwv_flow_imp.g_varchar2_table(8241) := '737420653D746869732E5F6465636F726174696F6E73547265652E6765744E6F646552616E676528746869732C64293B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A';
wwv_flow_imp.g_varchar2_table(8242) := '65637465645465787428652E73746172744C696E654E756D626572297D746869732E5F6465636F726174696F6E73547265652E64656C6574652864292C697C7C746869732E5F6F6E4469644368616E67654465636F726174696F6E732E636865636B4166';
wwv_flow_imp.g_varchar2_table(8243) := '666563746564416E644669726528642E6F7074696F6E73297D7D6966286C3C61297B6966282164297B636F6E737420653D2B2B746869732E5F6C6173744465636F726174696F6E49642C743D60247B746869732E5F696E7374616E636549647D3B247B65';
wwv_flow_imp.g_varchar2_table(8244) := '7D603B643D6E657720627928742C302C30292C746869732E5F6465636F726174696F6E735B745D3D647D636F6E737420743D6E5B6C5D2C733D746869732E5F76616C696461746552616E676552656C617865644E6F416C6C6F636174696F6E7328742E72';
wwv_flow_imp.g_varchar2_table(8245) := '616E6765292C723D464328742E6F7074696F6E73292C613D746869732E5F6275666665722E6765744F6666736574417428732E73746172744C696E654E756D6265722C732E7374617274436F6C756D6E292C683D746869732E5F6275666665722E676574';
wwv_flow_imp.g_varchar2_table(8246) := '4F6666736574417428732E656E644C696E654E756D6265722C732E656E64436F6C756D6E293B642E6F776E657249643D652C642E7265736574286F2C612C682C73292C642E7365744F7074696F6E732872292C642E6F7074696F6E732E61667465722626';
wwv_flow_imp.g_varchar2_table(8247) := '746869732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428732E656E644C696E654E756D626572292C642E6F7074696F6E732E6265666F72652626746869';
wwv_flow_imp.g_varchar2_table(8248) := '732E5F6F6E4469644368616E67654465636F726174696F6E732E7265636F72644C696E6541666665637465644279496E6A65637465645465787428732E73746172744C696E654E756D626572292C697C7C746869732E5F6F6E4469644368616E67654465';
wwv_flow_imp.g_varchar2_table(8249) := '636F726174696F6E732E636865636B4166666563746564416E64466972652872292C746869732E5F6465636F726174696F6E73547265652E696E736572742864292C635B6C5D3D642E69642C6C2B2B7D656C73652064262664656C65746520746869732E';
wwv_flow_imp.g_varchar2_table(8250) := '5F6465636F726174696F6E735B642E69645D7D72657475726E20637D66696E616C6C797B746869732E5F6F6E4469644368616E67654465636F726174696F6E732E656E644465666572726564456D697428297D7D6765744C616E6775616765496428297B';
wwv_flow_imp.g_varchar2_table(8251) := '72657475726E20746869732E746F6B656E697A6174696F6E2E6765744C616E6775616765496428297D7365744C616E677561676528652C74297B22737472696E67223D3D747970656F6620653F28746869732E5F6C616E677561676553656C656374696F';
wwv_flow_imp.g_varchar2_table(8252) := '6E4C697374656E65722E636C65617228292C746869732E5F7365744C616E677561676528652C7429293A28746869732E5F6C616E677561676553656C656374696F6E4C697374656E65722E76616C75653D652E6F6E4469644368616E6765282828293D3E';
wwv_flow_imp.g_varchar2_table(8253) := '746869732E5F7365744C616E677561676528652E6C616E677561676549642C742929292C746869732E5F7365744C616E677561676528652E6C616E677561676549642C7429297D5F7365744C616E677561676528652C74297B746869732E746F6B656E69';
wwv_flow_imp.g_varchar2_table(8254) := '7A6174696F6E2E7365744C616E6775616765496428652C74292C746869732E5F6C616E6775616765536572766963652E72657175657374526963684C616E677561676546656174757265732865297D6765744C616E677561676549644174506F73697469';
wwv_flow_imp.g_varchar2_table(8255) := '6F6E28652C74297B72657475726E20746869732E746F6B656E697A6174696F6E2E6765744C616E677561676549644174506F736974696F6E28652C74297D676574576F72644174506F736974696F6E2865297B72657475726E20746869732E5F746F6B65';
wwv_flow_imp.g_varchar2_table(8256) := '6E697A6174696F6E546578744D6F64656C506172742E676574576F72644174506F736974696F6E2865297D676574576F7264556E74696C506F736974696F6E2865297B72657475726E20746869732E5F746F6B656E697A6174696F6E546578744D6F6465';
wwv_flow_imp.g_varchar2_table(8257) := '6C506172742E676574576F7264556E74696C506F736974696F6E2865297D6E6F726D616C697A65506F736974696F6E28652C74297B72657475726E20657D6765744C696E65496E64656E74436F6C756D6E2865297B72657475726E2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(8258) := '2865297B6C657420743D303B666F7228636F6E7374206E206F662065297B696628222022213D3D6E2626225C7422213D3D6E29627265616B3B742B2B7D72657475726E20747D28746869732E6765744C696E65436F6E74656E74286529292B317D7D3B66';
wwv_flow_imp.g_varchar2_table(8259) := '756E6374696F6E2045432865297B72657475726E212821652E6F7074696F6E732E6F7665727669657752756C65727C7C21652E6F7074696F6E732E6F7665727669657752756C65722E636F6C6F72297D66756E6374696F6E204C432865297B7265747572';
wwv_flow_imp.g_varchar2_table(8260) := '6E2121652E6F7074696F6E732E61667465727C7C2121652E6F7074696F6E732E6265666F72657D6B432E5F4D4F44454C5F53594E435F4C494D49543D35323432383830302C6B432E4C415247455F46494C455F53495A455F5448524553484F4C443D3230';
wwv_flow_imp.g_varchar2_table(8261) := '3937313532302C6B432E4C415247455F46494C455F4C494E455F434F554E545F5448524553484F4C443D3365352C6B432E4C415247455F46494C455F484541505F4F5045524154494F4E5F5448524553484F4C443D3236383433353435362C6B432E4445';
wwv_flow_imp.g_varchar2_table(8262) := '4641554C545F4352454154494F4E5F4F5054494F4E533D7B6973466F7253696D706C655769646765743A21312C74616253697A653A45752E74616253697A652C696E64656E7453697A653A45752E696E64656E7453697A652C696E736572745370616365';
wwv_flow_imp.g_varchar2_table(8263) := '733A45752E696E736572745370616365732C646574656374496E64656E746174696F6E3A21312C64656661756C74454F4C3A312C7472696D4175746F576869746573706163653A45752E7472696D4175746F576869746573706163652C6C617267654669';
wwv_flow_imp.g_varchar2_table(8264) := '6C654F7074696D697A6174696F6E733A45752E6C6172676546696C654F7074696D697A6174696F6E732C627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E733A45752E627261636B657450616972436F6C6F72697A6174696F6E4F';
wwv_flow_imp.g_varchar2_table(8265) := '7074696F6E737D2C6B433D5F433D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F7065727479446573';
wwv_flow_imp.g_varchar2_table(8266) := '63726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F726174652865';
wwv_flow_imp.g_varchar2_table(8267) := '2C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E';
wwv_flow_imp.g_varchar2_table(8268) := '3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B794328342C6D43292C794328352C4C75292C794328362C6567295D2C6B43293B636C6173732044437B636F6E7374727563746F7228297B746869732E5F';
wwv_flow_imp.g_varchar2_table(8269) := '6465636F726174696F6E7354726565303D6E65772079792C746869732E5F6465636F726174696F6E7354726565313D6E65772079792C746869732E5F696E6A6563746564546578744465636F726174696F6E73547265653D6E65772079797D656E737572';
wwv_flow_imp.g_varchar2_table(8270) := '65416C6C4E6F6465734861766552616E6765732865297B746869732E676574416C6C28652C302C21312C21312C2131297D5F656E737572654E6F6465734861766552616E67657328652C74297B666F7228636F6E7374206E206F662074296E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(8271) := '3D6E2E72616E67652626286E2E72616E67653D652E67657452616E67654174286E2E6361636865644162736F6C75746553746172742C6E2E6361636865644162736F6C757465456E6429293B72657475726E20747D676574416C6C496E496E7465727661';
wwv_flow_imp.g_varchar2_table(8272) := '6C28652C742C6E2C692C6F2C73297B636F6E737420723D652E67657456657273696F6E496428292C613D746869732E5F696E74657276616C53656172636828742C6E2C692C6F2C722C73293B72657475726E20746869732E5F656E737572654E6F646573';
wwv_flow_imp.g_varchar2_table(8273) := '4861766552616E67657328652C61297D5F696E74657276616C53656172636828652C742C6E2C692C6F2C73297B636F6E737420723D746869732E5F6465636F726174696F6E7354726565302E696E74657276616C53656172636828652C742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(8274) := '2C73292C613D746869732E5F6465636F726174696F6E7354726565312E696E74657276616C53656172636828652C742C6E2C692C6F2C73292C6C3D746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E696E7465727661';
wwv_flow_imp.g_varchar2_table(8275) := '6C53656172636828652C742C6E2C692C6F2C73293B72657475726E20722E636F6E6361742861292E636F6E636174286C297D676574496E6A656374656454657874496E496E74657276616C28652C742C6E2C69297B636F6E7374206F3D652E6765745665';
wwv_flow_imp.g_varchar2_table(8276) := '7273696F6E496428292C733D746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E696E74657276616C53656172636828742C6E2C692C21312C6F2C2131293B72657475726E20746869732E5F656E737572654E6F646573';
wwv_flow_imp.g_varchar2_table(8277) := '4861766552616E67657328652C73292E66696C7465722828653D3E652E6F7074696F6E732E73686F774966436F6C6C61707365647C7C21652E72616E67652E6973456D707479282929297D676574416C6C496E6A65637465645465787428652C74297B63';
wwv_flow_imp.g_varchar2_table(8278) := '6F6E7374206E3D652E67657456657273696F6E496428292C693D746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E73656172636828742C21312C6E2C2131293B72657475726E20746869732E5F656E737572654E6F64';
wwv_flow_imp.g_varchar2_table(8279) := '65734861766552616E67657328652C69292E66696C7465722828653D3E652E6F7074696F6E732E73686F774966436F6C6C61707365647C7C21652E72616E67652E6973456D707479282929297D676574416C6C28652C742C6E2C692C6F297B636F6E7374';
wwv_flow_imp.g_varchar2_table(8280) := '20733D652E67657456657273696F6E496428292C723D746869732E5F73656172636828742C6E2C692C732C6F293B72657475726E20746869732E5F656E737572654E6F6465734861766552616E67657328652C72297D5F73656172636828652C742C6E2C';
wwv_flow_imp.g_varchar2_table(8281) := '692C6F297B6966286E2972657475726E20746869732E5F6465636F726174696F6E7354726565312E73656172636828652C742C692C6F293B7B636F6E7374206E3D746869732E5F6465636F726174696F6E7354726565302E73656172636828652C742C69';
wwv_flow_imp.g_varchar2_table(8282) := '2C6F292C733D746869732E5F6465636F726174696F6E7354726565312E73656172636828652C742C692C6F292C723D746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E73656172636828652C742C692C6F293B726574';
wwv_flow_imp.g_varchar2_table(8283) := '75726E206E2E636F6E6361742873292E636F6E6361742872297D7D636F6C6C6563744E6F64657346726F6D4F776E65722865297B636F6E737420743D746869732E5F6465636F726174696F6E7354726565302E636F6C6C6563744E6F64657346726F6D4F';
wwv_flow_imp.g_varchar2_table(8284) := '776E65722865292C6E3D746869732E5F6465636F726174696F6E7354726565312E636F6C6C6563744E6F64657346726F6D4F776E65722865292C693D746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E636F6C6C6563';
wwv_flow_imp.g_varchar2_table(8285) := '744E6F64657346726F6D4F776E65722865293B72657475726E20742E636F6E636174286E292E636F6E6361742869297D636F6C6C6563744E6F646573506F73744F7264657228297B636F6E737420653D746869732E5F6465636F726174696F6E73547265';
wwv_flow_imp.g_varchar2_table(8286) := '65302E636F6C6C6563744E6F646573506F73744F7264657228292C743D746869732E5F6465636F726174696F6E7354726565312E636F6C6C6563744E6F646573506F73744F7264657228292C6E3D746869732E5F696E6A6563746564546578744465636F';
wwv_flow_imp.g_varchar2_table(8287) := '726174696F6E73547265652E636F6C6C6563744E6F646573506F73744F7264657228293B72657475726E20652E636F6E6361742874292E636F6E636174286E297D696E736572742865297B4C432865293F746869732E5F696E6A65637465645465787444';
wwv_flow_imp.g_varchar2_table(8288) := '65636F726174696F6E73547265652E696E736572742865293A45432865293F746869732E5F6465636F726174696F6E7354726565312E696E736572742865293A746869732E5F6465636F726174696F6E7354726565302E696E736572742865297D64656C';
wwv_flow_imp.g_varchar2_table(8289) := '6574652865297B4C432865293F746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E64656C6574652865293A45432865293F746869732E5F6465636F726174696F6E7354726565312E64656C6574652865293A74686973';
wwv_flow_imp.g_varchar2_table(8290) := '2E5F6465636F726174696F6E7354726565302E64656C6574652865297D6765744E6F646552616E676528652C74297B636F6E7374206E3D652E67657456657273696F6E496428293B72657475726E20742E63616368656456657273696F6E4964213D3D6E';
wwv_flow_imp.g_varchar2_table(8291) := '2626746869732E5F7265736F6C76654E6F646528742C6E292C6E756C6C3D3D3D742E72616E6765262628742E72616E67653D652E67657452616E6765417428742E6361636865644162736F6C75746553746172742C742E6361636865644162736F6C7574';
wwv_flow_imp.g_varchar2_table(8292) := '65456E6429292C742E72616E67657D5F7265736F6C76654E6F646528652C74297B4C432865293F746869732E5F696E6A6563746564546578744465636F726174696F6E73547265652E7265736F6C76654E6F646528652C74293A45432865293F74686973';
wwv_flow_imp.g_varchar2_table(8293) := '2E5F6465636F726174696F6E7354726565312E7265736F6C76654E6F646528652C74293A746869732E5F6465636F726174696F6E7354726565302E7265736F6C76654E6F646528652C74297D6163636570745265706C61636528652C742C6E2C69297B74';
wwv_flow_imp.g_varchar2_table(8294) := '6869732E5F6465636F726174696F6E7354726565302E6163636570745265706C61636528652C742C6E2C69292C746869732E5F6465636F726174696F6E7354726565312E6163636570745265706C61636528652C742C6E2C69292C746869732E5F696E6A';
wwv_flow_imp.g_varchar2_table(8295) := '6563746564546578744465636F726174696F6E73547265652E6163636570745265706C61636528652C742C6E2C69297D7D66756E6374696F6E2054432865297B72657475726E20652E7265706C616365282F5B5E612D7A302D395C2D5F5D2F67692C2220';
wwv_flow_imp.g_varchar2_table(8296) := '22297D636C6173732049437B636F6E7374727563746F722865297B746869732E636F6C6F723D652E636F6C6F727C7C22222C746869732E6461726B436F6C6F723D652E6461726B436F6C6F727C7C22227D7D636C617373204D4320657874656E64732049';
wwv_flow_imp.g_varchar2_table(8297) := '437B636F6E7374727563746F722865297B73757065722865292C746869732E5F7265736F6C766564436F6C6F723D6E756C6C2C746869732E706F736974696F6E3D226E756D626572223D3D747970656F6620652E706F736974696F6E3F652E706F736974';
wwv_flow_imp.g_varchar2_table(8298) := '696F6E3A53682E43656E7465727D676574436F6C6F722865297B72657475726E20746869732E5F7265736F6C766564436F6C6F727C7C28226C6967687422213D3D652E747970652626746869732E6461726B436F6C6F723F746869732E5F7265736F6C76';
wwv_flow_imp.g_varchar2_table(8299) := '6564436F6C6F723D746869732E5F7265736F6C7665436F6C6F7228746869732E6461726B436F6C6F722C65293A746869732E5F7265736F6C766564436F6C6F723D746869732E5F7265736F6C7665436F6C6F7228746869732E636F6C6F722C6529292C74';
wwv_flow_imp.g_varchar2_table(8300) := '6869732E5F7265736F6C766564436F6C6F727D696E76616C6964617465436163686564436F6C6F7228297B746869732E5F7265736F6C766564436F6C6F723D6E756C6C7D5F7265736F6C7665436F6C6F7228652C74297B69662822737472696E67223D3D';
wwv_flow_imp.g_varchar2_table(8301) := '747970656F6620652972657475726E20653B636F6E7374206E3D653F742E676574436F6C6F7228652E6964293A6E756C6C3B72657475726E206E3F6E2E746F537472696E6728293A22227D7D636C6173732041437B636F6E7374727563746F722865297B';
wwv_flow_imp.g_varchar2_table(8302) := '76617220743B746869732E706F736974696F6E3D6E756C6C213D3D28743D6E756C6C3D3D653F766F696420303A652E706F736974696F6E292626766F69642030213D3D743F743A78682E43656E7465722C746869732E706572736973744C616E653D6E75';
wwv_flow_imp.g_varchar2_table(8303) := '6C6C3D3D653F766F696420303A652E706572736973744C616E657D7D636C617373204E4320657874656E64732049437B636F6E7374727563746F722865297B76617220742C6E3B73757065722865292C746869732E706F736974696F6E3D652E706F7369';
wwv_flow_imp.g_varchar2_table(8304) := '74696F6E2C746869732E73656374696F6E4865616465725374796C653D6E756C6C213D3D28743D652E73656374696F6E4865616465725374796C65292626766F69642030213D3D743F743A6E756C6C2C746869732E73656374696F6E4865616465725465';
wwv_flow_imp.g_varchar2_table(8305) := '78743D6E756C6C213D3D286E3D652E73656374696F6E48656164657254657874292626766F69642030213D3D6E3F6E3A6E756C6C7D676574436F6C6F722865297B72657475726E20746869732E5F7265736F6C766564436F6C6F727C7C28226C69676874';
wwv_flow_imp.g_varchar2_table(8306) := '22213D3D652E747970652626746869732E6461726B436F6C6F723F746869732E5F7265736F6C766564436F6C6F723D746869732E5F7265736F6C7665436F6C6F7228746869732E6461726B436F6C6F722C65293A746869732E5F7265736F6C766564436F';
wwv_flow_imp.g_varchar2_table(8307) := '6C6F723D746869732E5F7265736F6C7665436F6C6F7228746869732E636F6C6F722C6529292C746869732E5F7265736F6C766564436F6C6F727D696E76616C6964617465436163686564436F6C6F7228297B746869732E5F7265736F6C766564436F6C6F';
wwv_flow_imp.g_varchar2_table(8308) := '723D766F696420307D5F7265736F6C7665436F6C6F7228652C74297B72657475726E22737472696E67223D3D747970656F6620653F68752E66726F6D4865782865293A742E676574436F6C6F7228652E6964297D7D636C6173732050437B737461746963';
wwv_flow_imp.g_varchar2_table(8309) := '2066726F6D2865297B72657475726E206520696E7374616E63656F662050433F653A6E65772050432865297D636F6E7374727563746F722865297B746869732E636F6E74656E743D652E636F6E74656E747C7C22222C746869732E696E6C696E65436C61';
wwv_flow_imp.g_varchar2_table(8310) := '73734E616D653D652E696E6C696E65436C6173734E616D657C7C6E756C6C2C746869732E696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673D652E696E6C696E65436C6173734E616D65416666656374734C657474';
wwv_flow_imp.g_varchar2_table(8311) := '657253706163696E677C7C21312C746869732E6174746163686564446174613D652E6174746163686564446174617C7C6E756C6C2C746869732E637572736F7253746F70733D652E637572736F7253746F70737C7C6E756C6C7D7D636C617373204F437B';
wwv_flow_imp.g_varchar2_table(8312) := '7374617469632072656769737465722865297B72657475726E206E6577204F432865297D7374617469632063726561746544796E616D69632865297B72657475726E206E6577204F432865297D636F6E7374727563746F722865297B76617220742C6E2C';
wwv_flow_imp.g_varchar2_table(8313) := '692C6F2C732C723B746869732E6465736372697074696F6E3D652E6465736372697074696F6E2C746869732E626C6F636B436C6173734E616D653D652E626C6F636B436C6173734E616D653F544328652E626C6F636B436C6173734E616D65293A6E756C';
wwv_flow_imp.g_varchar2_table(8314) := '6C2C746869732E626C6F636B446F65734E6F74436F6C6C617073653D6E756C6C213D3D28743D652E626C6F636B446F65734E6F74436F6C6C61707365292626766F69642030213D3D743F743A6E756C6C2C746869732E626C6F636B49734166746572456E';
wwv_flow_imp.g_varchar2_table(8315) := '643D6E756C6C213D3D286E3D652E626C6F636B49734166746572456E64292626766F69642030213D3D6E3F6E3A6E756C6C2C746869732E626C6F636B50616464696E673D6E756C6C213D3D28693D652E626C6F636B50616464696E67292626766F696420';
wwv_flow_imp.g_varchar2_table(8316) := '30213D3D693F693A6E756C6C2C746869732E737469636B696E6573733D652E737469636B696E6573737C7C302C746869732E7A496E6465783D652E7A496E6465787C7C302C746869732E636C6173734E616D653D652E636C6173734E616D653F54432865';
wwv_flow_imp.g_varchar2_table(8317) := '2E636C6173734E616D65293A6E756C6C2C746869732E73686F756C6446696C6C4C696E654F6E4C696E65427265616B3D6E756C6C213D3D286F3D652E73686F756C6446696C6C4C696E654F6E4C696E65427265616B292626766F69642030213D3D6F3F6F';
wwv_flow_imp.g_varchar2_table(8318) := '3A6E756C6C2C746869732E686F7665724D6573736167653D652E686F7665724D6573736167657C7C6E756C6C2C746869732E676C7970684D617267696E486F7665724D6573736167653D652E676C7970684D617267696E486F7665724D6573736167657C';
wwv_flow_imp.g_varchar2_table(8319) := '7C6E756C6C2C746869732E6C696E654E756D626572486F7665724D6573736167653D652E6C696E654E756D626572486F7665724D6573736167657C7C6E756C6C2C746869732E697357686F6C654C696E653D652E697357686F6C654C696E657C7C21312C';
wwv_flow_imp.g_varchar2_table(8320) := '746869732E73686F774966436F6C6C61707365643D652E73686F774966436F6C6C61707365647C7C21312C746869732E636F6C6C617073654F6E5265706C616365456469743D652E636F6C6C617073654F6E5265706C616365456469747C7C21312C7468';
wwv_flow_imp.g_varchar2_table(8321) := '69732E6F7665727669657752756C65723D652E6F7665727669657752756C65723F6E6577204D4328652E6F7665727669657752756C6572293A6E756C6C2C746869732E6D696E696D61703D652E6D696E696D61703F6E6577204E4328652E6D696E696D61';
wwv_flow_imp.g_varchar2_table(8322) := '70293A6E756C6C2C746869732E676C7970684D617267696E3D652E676C7970684D617267696E436C6173734E616D653F6E657720414328652E676C7970684D617267696E293A6E756C6C2C746869732E676C7970684D617267696E436C6173734E616D65';
wwv_flow_imp.g_varchar2_table(8323) := '3D652E676C7970684D617267696E436C6173734E616D653F544328652E676C7970684D617267696E436C6173734E616D65293A6E756C6C2C746869732E6C696E65734465636F726174696F6E73436C6173734E616D653D652E6C696E65734465636F7261';
wwv_flow_imp.g_varchar2_table(8324) := '74696F6E73436C6173734E616D653F544328652E6C696E65734465636F726174696F6E73436C6173734E616D65293A6E756C6C2C746869732E6C696E654E756D626572436C6173734E616D653D652E6C696E654E756D626572436C6173734E616D653F54';
wwv_flow_imp.g_varchar2_table(8325) := '4328652E6C696E654E756D626572436C6173734E616D65293A6E756C6C2C746869732E6C696E65734465636F726174696F6E73546F6F6C7469703D652E6C696E65734465636F726174696F6E73546F6F6C7469703F652E6C696E65734465636F72617469';
wwv_flow_imp.g_varchar2_table(8326) := '6F6E73546F6F6C7469702E7265706C616365282F5B3C3E2227265D2F672C28653D3E7B7377697463682865297B63617365223C223A72657475726E22266C743B223B63617365223E223A72657475726E222667743B223B636173652722273A7265747572';
wwv_flow_imp.g_varchar2_table(8327) := '6E222671756F743B223B636173652227223A72657475726E222661706F733B223B636173652226223A72657475726E2226616D703B227D72657475726E20657D29293A6E756C6C2C746869732E66697273744C696E654465636F726174696F6E436C6173';
wwv_flow_imp.g_varchar2_table(8328) := '734E616D653D652E66697273744C696E654465636F726174696F6E436C6173734E616D653F544328652E66697273744C696E654465636F726174696F6E436C6173734E616D65293A6E756C6C2C746869732E6D617267696E436C6173734E616D653D652E';
wwv_flow_imp.g_varchar2_table(8329) := '6D617267696E436C6173734E616D653F544328652E6D617267696E436C6173734E616D65293A6E756C6C2C746869732E696E6C696E65436C6173734E616D653D652E696E6C696E65436C6173734E616D653F544328652E696E6C696E65436C6173734E61';
wwv_flow_imp.g_varchar2_table(8330) := '6D65293A6E756C6C2C746869732E696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673D652E696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E677C7C21312C746869732E626566';
wwv_flow_imp.g_varchar2_table(8331) := '6F7265436F6E74656E74436C6173734E616D653D652E6265666F7265436F6E74656E74436C6173734E616D653F544328652E6265666F7265436F6E74656E74436C6173734E616D65293A6E756C6C2C746869732E6166746572436F6E74656E74436C6173';
wwv_flow_imp.g_varchar2_table(8332) := '734E616D653D652E6166746572436F6E74656E74436C6173734E616D653F544328652E6166746572436F6E74656E74436C6173734E616D65293A6E756C6C2C746869732E61667465723D652E61667465723F50432E66726F6D28652E6166746572293A6E';
wwv_flow_imp.g_varchar2_table(8333) := '756C6C2C746869732E6265666F72653D652E6265666F72653F50432E66726F6D28652E6265666F7265293A6E756C6C2C746869732E68696465496E436F6D6D656E74546F6B656E733D6E756C6C213D3D28733D652E68696465496E436F6D6D656E74546F';
wwv_flow_imp.g_varchar2_table(8334) := '6B656E73292626766F69642030213D3D732626732C746869732E68696465496E537472696E67546F6B656E733D6E756C6C213D3D28723D652E68696465496E537472696E67546F6B656E73292626766F69642030213D3D722626727D7D4F432E454D5054';
wwv_flow_imp.g_varchar2_table(8335) := '593D4F432E7265676973746572287B6465736372697074696F6E3A22656D707479227D293B636F6E73742052433D5B4F432E7265676973746572287B6465736372697074696F6E3A22747261636B65642D72616E67652D616C776179732D67726F77732D';
wwv_flow_imp.g_varchar2_table(8336) := '7768656E2D747970696E672D61742D6564676573222C737469636B696E6573733A307D292C4F432E7265676973746572287B6465736372697074696F6E3A22747261636B65642D72616E67652D6E657665722D67726F77732D7768656E2D747970696E67';
wwv_flow_imp.g_varchar2_table(8337) := '2D61742D6564676573222C737469636B696E6573733A317D292C4F432E7265676973746572287B6465736372697074696F6E3A22747261636B65642D72616E67652D67726F77732D6F6E6C792D7768656E2D747970696E672D6265666F7265222C737469';
wwv_flow_imp.g_varchar2_table(8338) := '636B696E6573733A327D292C4F432E7265676973746572287B6465736372697074696F6E3A22747261636B65642D72616E67652D67726F77732D6F6E6C792D7768656E2D747970696E672D6166746572222C737469636B696E6573733A337D295D3B6675';
wwv_flow_imp.g_varchar2_table(8339) := '6E6374696F6E2046432865297B72657475726E206520696E7374616E63656F66204F433F653A4F432E63726561746544796E616D69632865297D636C61737320424320657874656E6473206C747B636F6E7374727563746F722865297B73757065722829';
wwv_flow_imp.g_varchar2_table(8340) := '2C746869732E68616E646C654265666F7265466972653D652C746869732E5F61637475616C3D746869732E5F7265676973746572286E6577204374292C746869732E6576656E743D746869732E5F61637475616C2E6576656E742C746869732E5F616666';
wwv_flow_imp.g_varchar2_table(8341) := '6563746564496E6A6563746564546578744C696E65733D6E756C6C2C746869732E5F6465666572726564436E743D302C746869732E5F73686F756C644669726544656665727265643D21312C746869732E5F616666656374734D696E696D61703D21312C';
wwv_flow_imp.g_varchar2_table(8342) := '746869732E5F616666656374734F7665727669657752756C65723D21312C746869732E5F61666665637473476C7970684D617267696E3D21312C746869732E5F616666656374734C696E654E756D6265723D21317D626567696E4465666572726564456D';
wwv_flow_imp.g_varchar2_table(8343) := '697428297B746869732E5F6465666572726564436E742B2B7D656E644465666572726564456D697428297B76617220653B746869732E5F6465666572726564436E742D2D2C303D3D3D746869732E5F6465666572726564436E74262628746869732E5F73';
wwv_flow_imp.g_varchar2_table(8344) := '686F756C644669726544656665727265642626746869732E646F4669726528292C6E756C6C3D3D3D28653D746869732E5F6166666563746564496E6A6563746564546578744C696E6573297C7C766F696420303D3D3D657C7C652E636C65617228292C74';
wwv_flow_imp.g_varchar2_table(8345) := '6869732E5F6166666563746564496E6A6563746564546578744C696E65733D6E756C6C297D7265636F72644C696E6541666665637465644279496E6A6563746564546578742865297B746869732E5F6166666563746564496E6A6563746564546578744C';
wwv_flow_imp.g_varchar2_table(8346) := '696E65737C7C28746869732E5F6166666563746564496E6A6563746564546578744C696E65733D6E657720536574292C746869732E5F6166666563746564496E6A6563746564546578744C696E65732E6164642865297D636865636B4166666563746564';
wwv_flow_imp.g_varchar2_table(8347) := '416E64466972652865297B76617220742C6E3B746869732E5F616666656374734D696E696D61707C7C28746869732E5F616666656374734D696E696D61703D2121286E756C6C3D3D3D28743D652E6D696E696D6170297C7C766F696420303D3D3D743F76';
wwv_flow_imp.g_varchar2_table(8348) := '6F696420303A742E706F736974696F6E29292C746869732E5F616666656374734F7665727669657752756C65727C7C28746869732E5F616666656374734F7665727669657752756C65723D2121286E756C6C3D3D3D286E3D652E6F766572766965775275';
wwv_flow_imp.g_varchar2_table(8349) := '6C6572297C7C766F696420303D3D3D6E3F766F696420303A6E2E636F6C6F7229292C746869732E5F61666665637473476C7970684D617267696E7C7C28746869732E5F61666665637473476C7970684D617267696E3D2121652E676C7970684D61726769';
wwv_flow_imp.g_varchar2_table(8350) := '6E436C6173734E616D65292C746869732E5F616666656374734C696E654E756D6265727C7C28746869732E5F616666656374734C696E654E756D6265723D2121652E6C696E654E756D626572436C6173734E616D65292C746869732E7472794669726528';
wwv_flow_imp.g_varchar2_table(8351) := '297D6669726528297B746869732E5F616666656374734D696E696D61703D21302C746869732E5F616666656374734F7665727669657752756C65723D21302C746869732E5F61666665637473476C7970684D617267696E3D21302C746869732E74727946';
wwv_flow_imp.g_varchar2_table(8352) := '69726528297D7472794669726528297B303D3D3D746869732E5F6465666572726564436E743F746869732E646F4669726528293A746869732E5F73686F756C644669726544656665727265643D21307D646F4669726528297B746869732E68616E646C65';
wwv_flow_imp.g_varchar2_table(8353) := '4265666F72654669726528746869732E5F6166666563746564496E6A6563746564546578744C696E6573293B636F6E737420653D7B616666656374734D696E696D61703A746869732E5F616666656374734D696E696D61702C616666656374734F766572';
wwv_flow_imp.g_varchar2_table(8354) := '7669657752756C65723A746869732E5F616666656374734F7665727669657752756C65722C61666665637473476C7970684D617267696E3A746869732E5F61666665637473476C7970684D617267696E2C616666656374734C696E654E756D6265723A74';
wwv_flow_imp.g_varchar2_table(8355) := '6869732E5F616666656374734C696E654E756D6265727D3B746869732E5F73686F756C644669726544656665727265643D21312C746869732E5F616666656374734D696E696D61703D21312C746869732E5F616666656374734F7665727669657752756C';
wwv_flow_imp.g_varchar2_table(8356) := '65723D21312C746869732E5F61666665637473476C7970684D617267696E3D21312C746869732E5F61637475616C2E666972652865297D7D636C61737320564320657874656E6473206C747B636F6E7374727563746F7228297B737570657228292C7468';
wwv_flow_imp.g_varchar2_table(8357) := '69732E5F66617374456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E666173744576656E743D746869732E5F66617374456D69747465722E6576656E742C746869732E5F736C6F77456D69747465723D74686973';
wwv_flow_imp.g_varchar2_table(8358) := '2E5F7265676973746572286E6577204374292C746869732E736C6F774576656E743D746869732E5F736C6F77456D69747465722E6576656E742C746869732E5F6465666572726564436E743D302C746869732E5F64656665727265644576656E743D6E75';
wwv_flow_imp.g_varchar2_table(8359) := '6C6C7D626567696E4465666572726564456D697428297B746869732E5F6465666572726564436E742B2B7D656E644465666572726564456D697428653D6E756C6C297B696628746869732E5F6465666572726564436E742D2D2C303D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(8360) := '6465666572726564436E7426266E756C6C213D3D746869732E5F64656665727265644576656E74297B746869732E5F64656665727265644576656E742E726177436F6E74656E744368616E6765644576656E742E726573756C74696E6753656C65637469';
wwv_flow_imp.g_varchar2_table(8361) := '6F6E3D653B636F6E737420743D746869732E5F64656665727265644576656E743B746869732E5F64656665727265644576656E743D6E756C6C2C746869732E5F66617374456D69747465722E666972652874292C746869732E5F736C6F77456D69747465';
wwv_flow_imp.g_varchar2_table(8362) := '722E666972652874297D7D666972652865297B746869732E5F6465666572726564436E743E303F746869732E5F64656665727265644576656E743F746869732E5F64656665727265644576656E743D746869732E5F64656665727265644576656E742E6D';
wwv_flow_imp.g_varchar2_table(8363) := '657267652865293A746869732E5F64656665727265644576656E743D653A28746869732E5F66617374456D69747465722E666972652865292C746869732E5F736C6F77456D69747465722E66697265286529297D7D636C617373207A437B636F6E737472';
wwv_flow_imp.g_varchar2_table(8364) := '7563746F7228297B746869732E5F6F6E4469644368616E676556697369626C6552616E6765733D6E65772043742C746869732E6F6E4469644368616E676556697369626C6552616E6765733D746869732E5F6F6E4469644368616E676556697369626C65';
wwv_flow_imp.g_varchar2_table(8365) := '52616E6765732E6576656E742C746869732E5F76696577733D6E6577205365747D6174746163685669657728297B636F6E737420653D6E65772048432828743D3E7B746869732E5F6F6E4469644368616E676556697369626C6552616E6765732E666972';
wwv_flow_imp.g_varchar2_table(8366) := '65287B766965773A652C73746174653A747D297D29293B72657475726E20746869732E5F76696577732E6164642865292C657D646574616368566965772865297B746869732E5F76696577732E64656C6574652865292C746869732E5F6F6E4469644368';
wwv_flow_imp.g_varchar2_table(8367) := '616E676556697369626C6552616E6765732E66697265287B766965773A652C73746174653A766F696420307D297D7D636C6173732048437B636F6E7374727563746F722865297B746869732E68616E646C6553746174654368616E67653D657D73657456';
wwv_flow_imp.g_varchar2_table(8368) := '697369626C654C696E657328652C74297B636F6E7374206E3D652E6D61702828653D3E6E657720787528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722B312929293B746869732E68616E646C655374617465436861';
wwv_flow_imp.g_varchar2_table(8369) := '6E6765287B76697369626C654C696E6552616E6765733A6E2C73746162696C697A65643A747D297D7D636F6E73742057433D4C6D2822656469746F724F7665727669657752756C65722E627261636B65744D61746368466F726567726F756E64222C7B64';
wwv_flow_imp.g_varchar2_table(8370) := '61726B3A2223413041304130222C6C696768743A2223413041304130222C68634461726B3A2223413041304130222C68634C696768743A2223413041304130227D2C6228302C224F766572766965772072756C6572206D61726B657220636F6C6F722066';
wwv_flow_imp.g_varchar2_table(8371) := '6F72206D61746368696E6720627261636B6574732E2229293B636C617373206A437B636F6E7374727563746F7228652C742C6E297B746869732E706F736974696F6E3D652C746869732E627261636B6574733D742C746869732E6F7074696F6E733D6E7D';
wwv_flow_imp.g_varchar2_table(8372) := '7D636C61737320714320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2871432E4944297D636F6E7374727563746F722865297B737570657228292C746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(8373) := '6F723D652C746869732E5F6C617374427261636B657473446174613D5B5D2C746869732E5F6C61737456657273696F6E49643D302C746869732E5F6465636F726174696F6E733D746869732E5F656469746F722E6372656174654465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(8374) := '73436F6C6C656374696F6E28292C746869732E5F757064617465427261636B657473536F6F6E3D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F757064617465427261636B6574732829292C353029292C746869732E';
wwv_flow_imp.g_varchar2_table(8375) := '5F6D61746368427261636B6574733D746869732E5F656469746F722E6765744F7074696F6E283732292C746869732E5F757064617465427261636B657473536F6F6E2E7363686564756C6528292C746869732E5F726567697374657228652E6F6E446964';
wwv_flow_imp.g_varchar2_table(8376) := '4368616E6765437572736F72506F736974696F6E2828653D3E7B226E6576657222213D3D746869732E5F6D61746368427261636B6574732626746869732E5F757064617465427261636B657473536F6F6E2E7363686564756C6528297D2929292C746869';
wwv_flow_imp.g_varchar2_table(8377) := '732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E5F757064617465427261636B657473536F6F6E2E7363686564756C6528297D2929292C746869732E5F726567697374657228652E';
wwv_flow_imp.g_varchar2_table(8378) := '6F6E4469644368616E67654D6F64656C2828653D3E7B746869732E5F6C617374427261636B657473446174613D5B5D2C746869732E5F757064617465427261636B657473536F6F6E2E7363686564756C6528297D2929292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(8379) := '657228652E6F6E4469644368616E67654D6F64656C4C616E6775616765436F6E66696775726174696F6E2828653D3E7B746869732E5F6C617374427261636B657473446174613D5B5D2C746869732E5F757064617465427261636B657473536F6F6E2E73';
wwv_flow_imp.g_varchar2_table(8380) := '63686564756C6528297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E67656428373229262628746869732E5F6D61746368427261636B6574733D';
wwv_flow_imp.g_varchar2_table(8381) := '746869732E5F656469746F722E6765744F7074696F6E283732292C746869732E5F6465636F726174696F6E732E636C65617228292C746869732E5F6C617374427261636B657473446174613D5B5D2C746869732E5F6C61737456657273696F6E49643D30';
wwv_flow_imp.g_varchar2_table(8382) := '2C746869732E5F757064617465427261636B657473536F6F6E2E7363686564756C652829297D2929292C746869732E5F726567697374657228652E6F6E446964426C7572456469746F72576964676574282828293D3E7B746869732E5F75706461746542';
wwv_flow_imp.g_varchar2_table(8383) := '7261636B657473536F6F6E2E7363686564756C6528297D2929292C746869732E5F726567697374657228652E6F6E446964466F637573456469746F72576964676574282828293D3E7B746869732E5F757064617465427261636B657473536F6F6E2E7363';
wwv_flow_imp.g_varchar2_table(8384) := '686564756C6528297D2929297D6A756D70546F427261636B657428297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C743D7468';
wwv_flow_imp.g_varchar2_table(8385) := '69732E5F656469746F722E67657453656C656374696F6E7328292E6D61702828743D3E7B636F6E7374206E3D742E6765745374617274506F736974696F6E28292C693D652E627261636B657450616972732E6D61746368427261636B6574286E293B6C65';
wwv_flow_imp.g_varchar2_table(8386) := '74206F3D6E756C6C3B6966286929695B305D2E636F6E7461696E73506F736974696F6E286E29262621695B315D2E636F6E7461696E73506F736974696F6E286E293F6F3D695B315D2E6765745374617274506F736974696F6E28293A695B315D2E636F6E';
wwv_flow_imp.g_varchar2_table(8387) := '7461696E73506F736974696F6E286E292626286F3D695B305D2E6765745374617274506F736974696F6E2829293B656C73657B636F6E737420743D652E627261636B657450616972732E66696E64456E636C6F73696E67427261636B657473286E293B69';
wwv_flow_imp.g_varchar2_table(8388) := '662874296F3D745B315D2E6765745374617274506F736974696F6E28293B656C73657B636F6E737420743D652E627261636B657450616972732E66696E644E657874427261636B6574286E293B742626742E72616E67652626286F3D742E72616E67652E';
wwv_flow_imp.g_varchar2_table(8389) := '6765745374617274506F736974696F6E2829297D7D72657475726E206F3F6E6577206168286F2E6C696E654E756D6265722C6F2E636F6C756D6E2C6F2E6C696E654E756D6265722C6F2E636F6C756D6E293A6E6577206168286E2E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(8390) := '722C6E2E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E297D29293B746869732E5F656469746F722E73657453656C656374696F6E732874292C746869732E5F656469746F722E72657665616C52616E676528745B305D297D7365';
wwv_flow_imp.g_varchar2_table(8391) := '6C656374546F427261636B65742865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292C6E3D5B5D3B746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(8392) := '722E67657453656C656374696F6E7328292E666F72456163682828693D3E7B636F6E7374206F3D692E6765745374617274506F736974696F6E28293B6C657420733D742E627261636B657450616972732E6D61746368427261636B6574286F293B696628';
wwv_flow_imp.g_varchar2_table(8393) := '2173262628733D742E627261636B657450616972732E66696E64456E636C6F73696E67427261636B657473286F292C217329297B636F6E737420653D742E627261636B657450616972732E66696E644E657874427261636B6574286F293B652626652E72';
wwv_flow_imp.g_varchar2_table(8394) := '616E6765262628733D742E627261636B657450616972732E6D61746368427261636B657428652E72616E67652E6765745374617274506F736974696F6E282929297D6C657420723D6E756C6C2C613D6E756C6C3B69662873297B732E736F72742872682E';
wwv_flow_imp.g_varchar2_table(8395) := '636F6D7061726552616E6765735573696E67537461727473293B636F6E73745B742C6E5D3D733B696628723D653F742E6765745374617274506F736974696F6E28293A742E676574456E64506F736974696F6E28292C613D653F6E2E676574456E64506F';
wwv_flow_imp.g_varchar2_table(8396) := '736974696F6E28293A6E2E6765745374617274506F736974696F6E28292C6E2E636F6E7461696E73506F736974696F6E286F29297B636F6E737420653D723B723D612C613D657D7D7226266126266E2E70757368286E657720616828722E6C696E654E75';
wwv_flow_imp.g_varchar2_table(8397) := '6D6265722C722E636F6C756D6E2C612E6C696E654E756D6265722C612E636F6C756D6E29297D29292C6E2E6C656E6774683E30262628746869732E5F656469746F722E73657453656C656374696F6E73286E292C746869732E5F656469746F722E726576';
wwv_flow_imp.g_varchar2_table(8398) := '65616C52616E6765286E5B305D29297D72656D6F7665427261636B6574732865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C2829';
wwv_flow_imp.g_varchar2_table(8399) := '3B746869732E5F656469746F722E67657453656C656374696F6E7328292E666F724561636828286E3D3E7B636F6E737420693D6E2E676574506F736974696F6E28293B6C6574206F3D742E627261636B657450616972732E6D61746368427261636B6574';
wwv_flow_imp.g_varchar2_table(8400) := '2869293B6F7C7C286F3D742E627261636B657450616972732E66696E64456E636C6F73696E67427261636B657473286929292C6F262628746869732E5F656469746F722E70757368556E646F53746F7028292C746869732E5F656469746F722E65786563';
wwv_flow_imp.g_varchar2_table(8401) := '757465456469747328652C5B7B72616E67653A6F5B305D2C746578743A22227D2C7B72616E67653A6F5B315D2C746578743A22227D5D292C746869732E5F656469746F722E70757368556E646F53746F702829297D29297D5F757064617465427261636B';
wwv_flow_imp.g_varchar2_table(8402) := '65747328297B696628226E65766572223D3D3D746869732E5F6D61746368427261636B6574732972657475726E3B746869732E5F7265636F6D70757465427261636B65747328293B636F6E737420653D5B5D3B6C657420743D303B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(8403) := '206E206F6620746869732E5F6C617374427261636B65747344617461297B636F6E737420693D6E2E627261636B6574733B69262628655B742B2B5D3D7B72616E67653A695B305D2C6F7074696F6E733A6E2E6F7074696F6E737D2C655B742B2B5D3D7B72';
wwv_flow_imp.g_varchar2_table(8404) := '616E67653A695B315D2C6F7074696F6E733A6E2E6F7074696F6E737D297D746869732E5F6465636F726174696F6E732E7365742865297D5F7265636F6D70757465427261636B65747328297B69662821746869732E5F656469746F722E6861734D6F6465';
wwv_flow_imp.g_varchar2_table(8405) := '6C28297C7C21746869732E5F656469746F722E686173576964676574466F63757328292972657475726E20746869732E5F6C617374427261636B657473446174613D5B5D2C766F696428746869732E5F6C61737456657273696F6E49643D30293B636F6E';
wwv_flow_imp.g_varchar2_table(8406) := '737420653D746869732E5F656469746F722E67657453656C656374696F6E7328293B696628652E6C656E6774683E3130302972657475726E20746869732E5F6C617374427261636B657473446174613D5B5D2C766F696428746869732E5F6C6173745665';
wwv_flow_imp.g_varchar2_table(8407) := '7273696F6E49643D30293B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292C6E3D742E67657456657273696F6E496428293B6C657420693D5B5D3B746869732E5F6C61737456657273696F6E49643D3D3D6E262628693D74';
wwv_flow_imp.g_varchar2_table(8408) := '6869732E5F6C617374427261636B65747344617461293B636F6E7374206F3D5B5D3B6C657420733D303B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B745D3B6E2E6973456D70747928292626';
wwv_flow_imp.g_varchar2_table(8409) := '286F5B732B2B5D3D6E2E6765745374617274506F736974696F6E2829297D6F2E6C656E6774683E3126266F2E736F7274286D632E636F6D70617265293B636F6E737420723D5B5D3B6C657420613D302C6C3D303B636F6E737420633D692E6C656E677468';
wwv_flow_imp.g_varchar2_table(8410) := '3B666F72286C657420653D302C6E3D6F2E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D6F5B655D3B666F72283B6C3C632626695B6C5D2E706F736974696F6E2E69734265666F7265286E293B296C2B2B3B6966286C3C632626695B6C5D2E';
wwv_flow_imp.g_varchar2_table(8411) := '706F736974696F6E2E657175616C73286E2929725B612B2B5D3D695B6C5D3B656C73657B6C657420653D742E627261636B657450616972732E6D61746368427261636B6574286E2C3230292C693D71432E5F4445434F524154494F4E5F4F5054494F4E53';
wwv_flow_imp.g_varchar2_table(8412) := '5F574954485F4F564552564945575F52554C45523B657C7C22616C7761797322213D3D746869732E5F6D61746368427261636B6574737C7C28653D742E627261636B657450616972732E66696E64456E636C6F73696E67427261636B657473286E2C3230';
wwv_flow_imp.g_varchar2_table(8413) := '292C693D71432E5F4445434F524154494F4E5F4F5054494F4E535F574954484F55545F4F564552564945575F52554C4552292C725B612B2B5D3D6E6577206A43286E2C652C69297D7D746869732E5F6C617374427261636B657473446174613D722C7468';
wwv_flow_imp.g_varchar2_table(8414) := '69732E5F6C61737456657273696F6E49643D6E7D7D71432E49443D22656469746F722E636F6E747269622E627261636B65744D61746368696E67436F6E74726F6C6C6572222C71432E5F4445434F524154494F4E5F4F5054494F4E535F574954485F4F56';
wwv_flow_imp.g_varchar2_table(8415) := '4552564945575F52554C45523D4F432E7265676973746572287B6465736372697074696F6E3A22627261636B65742D6D617463682D6F76657276696577222C737469636B696E6573733A312C636C6173734E616D653A22627261636B65742D6D61746368';
wwv_flow_imp.g_varchar2_table(8416) := '222C6F7665727669657752756C65723A7B636F6C6F723A4F62285743292C706F736974696F6E3A53682E43656E7465727D7D292C71432E5F4445434F524154494F4E5F4F5054494F4E535F574954484F55545F4F564552564945575F52554C45523D4F43';
wwv_flow_imp.g_varchar2_table(8417) := '2E7265676973746572287B6465736372697074696F6E3A22627261636B65742D6D617463682D6E6F2D6F76657276696577222C737469636B696E6573733A312C636C6173734E616D653A22627261636B65742D6D61746368227D292C4A642871432E4944';
wwv_flow_imp.g_varchar2_table(8418) := '2C71432C31292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73656C656374546F427261636B6574222C6C6162656C3A6228302C2253656C656374';
wwv_flow_imp.g_varchar2_table(8419) := '20746F20427261636B657422292C616C6961733A2253656C65637420746F20427261636B6574222C707265636F6E646974696F6E3A766F696420302C6D657461646174613A7B6465736372697074696F6E3A5F28302C2253656C65637420746865207465';
wwv_flow_imp.g_varchar2_table(8420) := '787420696E7369646520616E6420696E636C7564696E672074686520627261636B657473206F72206375726C792062726163657322292C617267733A5B7B6E616D653A2261726773222C736368656D613A7B747970653A226F626A656374222C70726F70';
wwv_flow_imp.g_varchar2_table(8421) := '6572746965733A7B73656C656374427261636B6574733A7B747970653A22626F6F6C65616E222C64656661756C743A21307D7D7D7D5D7D7D297D72756E28652C742C6E297B76617220693B6C6574206F3D21303B6E262621313D3D3D6E2E73656C656374';
wwv_flow_imp.g_varchar2_table(8422) := '427261636B6574732626286F3D2131292C6E756C6C3D3D3D28693D71432E676574287429297C7C766F696420303D3D3D697C7C692E73656C656374546F427261636B6574286F297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374';
wwv_flow_imp.g_varchar2_table(8423) := '727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6A756D70546F427261636B6574222C6C6162656C3A6228302C22476F20746F20427261636B657422292C616C6961733A22476F20746F20427261636B6574222C7072';
wwv_flow_imp.g_varchar2_table(8424) := '65636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A333136352C7765696768743A3130307D7D297D72756E28652C74297B766172206E3B6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(8425) := '3D286E3D71432E676574287429297C7C766F696420303D3D3D6E7C7C6E2E6A756D70546F427261636B657428297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F72';
wwv_flow_imp.g_varchar2_table(8426) := '2E616374696F6E2E72656D6F7665427261636B657473222C6C6162656C3A6228302C2252656D6F766520427261636B65747322292C616C6961733A2252656D6F766520427261636B657473222C707265636F6E646974696F6E3A766F696420302C6B624F';
wwv_flow_imp.g_varchar2_table(8427) := '7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A323536312C7765696768743A3130307D7D297D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D71432E676574287429297C7C766F696420';
wwv_flow_imp.g_varchar2_table(8428) := '303D3D3D6E7C7C6E2E72656D6F7665427261636B65747328746869732E6964297D7D292C49642E617070656E644D656E754974656D284C642E4D656E75626172476F4D656E752C7B67726F75703A22355F696E66696C655F6E6176222C636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(8429) := '3A7B69643A22656469746F722E616374696F6E2E6A756D70546F427261636B6574222C7469746C653A6228302C22476F20746F202626427261636B657422297D2C6F726465723A327D293B636F6E73742024433D28293D3E21302C55433D28293D3E2131';
wwv_flow_imp.g_varchar2_table(8430) := '2C4B433D653D3E2220223D3D3D657C7C225C74223D3D3D653B636C6173732047437B7374617469632073686F756C6452656372656174652865297B72657475726E20652E6861734368616E67656428313435297C7C652E6861734368616E676564283133';
wwv_flow_imp.g_varchar2_table(8431) := '31297C7C652E6861734368616E676564283337297C7C652E6861734368616E676564283737297C7C652E6861734368616E676564283739297C7C652E6861734368616E676564283830297C7C652E6861734368616E6765642836297C7C652E6861734368';
wwv_flow_imp.g_varchar2_table(8432) := '616E6765642837297C7C652E6861734368616E676564283131297C7C652E6861734368616E6765642839297C7C652E6861734368616E676564283130297C7C652E6861734368616E676564283134297C7C652E6861734368616E67656428313238297C7C';
wwv_flow_imp.g_varchar2_table(8433) := '652E6861734368616E676564283530297C7C652E6861734368616E676564283931297C7C652E6861734368616E67656428313330297D636F6E7374727563746F7228652C742C6E2C69297B766172206F3B746869732E6C616E6775616765436F6E666967';
wwv_flow_imp.g_varchar2_table(8434) := '75726174696F6E536572766963653D692C746869732E5F637572736F724D6F7665436F6E66696775726174696F6E4272616E643D766F696420302C746869732E5F6C616E677561676549643D653B636F6E737420733D6E2E6F7074696F6E732C723D732E';
wwv_flow_imp.g_varchar2_table(8435) := '67657428313435292C613D732E676574283530293B746869732E726561644F6E6C793D732E676574283931292C746869732E74616253697A653D742E74616253697A652C746869732E696E64656E7453697A653D742E696E64656E7453697A652C746869';
wwv_flow_imp.g_varchar2_table(8436) := '732E696E736572745370616365733D742E696E736572745370616365732C746869732E737469636B7954616253746F70733D732E67657428313136292C746869732E6C696E654865696768743D612E6C696E654865696768742C746869732E7479706963';
wwv_flow_imp.g_varchar2_table(8437) := '616C48616C66776964746843686172616374657257696474683D612E7479706963616C48616C66776964746843686172616374657257696474682C746869732E7061676553697A653D4D6174682E6D617828312C4D6174682E666C6F6F7228722E686569';
wwv_flow_imp.g_varchar2_table(8438) := '6768742F746869732E6C696E65486569676874292D32292C746869732E75736554616253746F70733D732E67657428313238292C746869732E776F7264536570617261746F72733D732E67657428313331292C746869732E656D70747953656C65637469';
wwv_flow_imp.g_varchar2_table(8439) := '6F6E436C6970626F6172643D732E676574283337292C746869732E636F70795769746853796E746178486967686C69676874696E673D732E676574283235292C746869732E6D756C7469437572736F724D657267654F7665726C617070696E673D732E67';
wwv_flow_imp.g_varchar2_table(8440) := '6574283737292C746869732E6D756C7469437572736F7250617374653D732E676574283739292C746869732E6D756C7469437572736F724C696D69743D732E676574283830292C746869732E6175746F436C6F73696E67427261636B6574733D732E6765';
wwv_flow_imp.g_varchar2_table(8441) := '742836292C746869732E6175746F436C6F73696E67436F6D6D656E74733D732E6765742837292C746869732E6175746F436C6F73696E6751756F7465733D732E676574283131292C746869732E6175746F436C6F73696E6744656C6574653D732E676574';
wwv_flow_imp.g_varchar2_table(8442) := '2839292C746869732E6175746F436C6F73696E674F766572747970653D732E676574283130292C746869732E6175746F537572726F756E643D732E676574283134292C746869732E6175746F496E64656E743D732E676574283132292C746869732E776F';
wwv_flow_imp.g_varchar2_table(8443) := '72645365676D656E7465724C6F63616C65733D732E67657428313330292C746869732E737572726F756E64696E6750616972733D7B7D2C746869732E5F656C65637472696343686172733D6E756C6C2C746869732E73686F756C644175746F436C6F7365';
wwv_flow_imp.g_varchar2_table(8444) := '4265666F72653D7B71756F74653A746869732E5F67657453686F756C644175746F436C6F736528652C746869732E6175746F436C6F73696E6751756F7465732C2130292C636F6D6D656E743A746869732E5F67657453686F756C644175746F436C6F7365';
wwv_flow_imp.g_varchar2_table(8445) := '28652C746869732E6175746F436C6F73696E67436F6D6D656E74732C2131292C627261636B65743A746869732E5F67657453686F756C644175746F436C6F736528652C746869732E6175746F436C6F73696E67427261636B6574732C2131297D2C746869';
wwv_flow_imp.g_varchar2_table(8446) := '732E6175746F436C6F73696E6750616972733D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2865292E6765744175746F436C6F73696E675061697273';
wwv_flow_imp.g_varchar2_table(8447) := '28293B636F6E7374206C3D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2865292E676574537572726F756E64696E67506169727328293B6966286C29';
wwv_flow_imp.g_varchar2_table(8448) := '666F7228636F6E73742065206F66206C29746869732E737572726F756E64696E6750616972735B652E6F70656E5D3D652E636C6F73653B636F6E737420633D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E676574';
wwv_flow_imp.g_varchar2_table(8449) := '4C616E6775616765436F6E66696775726174696F6E2865292E636F6D6D656E74733B746869732E626C6F636B436F6D6D656E745374617274546F6B656E3D6E756C6C213D3D286F3D6E756C6C3D3D633F766F696420303A632E626C6F636B436F6D6D656E';
wwv_flow_imp.g_varchar2_table(8450) := '745374617274546F6B656E292626766F69642030213D3D6F3F6F3A6E756C6C7D67657420656C656374726963436861727328297B76617220653B69662821746869732E5F656C6563747269634368617273297B746869732E5F656C656374726963436861';
wwv_flow_imp.g_varchar2_table(8451) := '72733D7B7D3B636F6E737420743D6E756C6C3D3D3D28653D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28746869732E5F6C616E6775616765496429';
wwv_flow_imp.g_varchar2_table(8452) := '2E656C656374726963436861726163746572297C7C766F696420303D3D3D653F766F696420303A652E676574456C6563747269634368617261637465727328293B6966287429666F7228636F6E73742065206F66207429746869732E5F656C6563747269';
wwv_flow_imp.g_varchar2_table(8453) := '6343686172735B655D3D21307D72657475726E20746869732E5F656C65637472696343686172737D6F6E456C65637472696343686172616374657228652C742C6E297B636F6E737420693D427528742C6E2D31292C6F3D746869732E6C616E6775616765';
wwv_flow_imp.g_varchar2_table(8454) := '436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28692E6C616E67756167654964292E656C6563747269634368617261637465723B72657475726E206F3F6F2E6F6E456C65637472696343';
wwv_flow_imp.g_varchar2_table(8455) := '686172616374657228652C692C6E2D692E6669727374436861724F6666736574293A6E756C6C7D6E6F726D616C697A65496E64656E746174696F6E2865297B72657475726E20677528652C746869732E696E64656E7453697A652C746869732E696E7365';
wwv_flow_imp.g_varchar2_table(8456) := '7274537061636573297D5F67657453686F756C644175746F436C6F736528652C742C6E297B7377697463682874297B63617365226265666F726557686974657370616365223A72657475726E204B433B63617365226C616E6775616765446566696E6564';
wwv_flow_imp.g_varchar2_table(8457) := '223A72657475726E20746869732E5F6765744C616E6775616765446566696E656453686F756C644175746F436C6F736528652C6E293B6361736522616C77617973223A72657475726E2024433B63617365226E65766572223A72657475726E2055437D7D';
wwv_flow_imp.g_varchar2_table(8458) := '5F6765744C616E6775616765446566696E656453686F756C644175746F436C6F736528652C74297B636F6E7374206E3D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775';
wwv_flow_imp.g_varchar2_table(8459) := '726174696F6E2865292E6765744175746F436C6F73654265666F72655365742874293B72657475726E20653D3E2D31213D3D6E2E696E6465784F662865297D76697369626C65436F6C756D6E46726F6D436F6C756D6E28652C74297B72657475726E2070';
wwv_flow_imp.g_varchar2_table(8460) := '752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C742E636F6C756D6E2C746869732E74616253697A65297D636F6C756D6E46726F6D56697369626C65436F6C';
wwv_flow_imp.g_varchar2_table(8461) := '756D6E28652C742C6E297B636F6E737420693D70752E636F6C756D6E46726F6D56697369626C65436F6C756D6E28652E6765744C696E65436F6E74656E742874292C6E2C746869732E74616253697A65292C6F3D652E6765744C696E654D696E436F6C75';
wwv_flow_imp.g_varchar2_table(8462) := '6D6E2874293B696628693C6F2972657475726E206F3B636F6E737420733D652E6765744C696E654D6178436F6C756D6E2874293B72657475726E20693E733F733A697D7D636C6173732051437B7374617469632066726F6D4D6F64656C53746174652865';
wwv_flow_imp.g_varchar2_table(8463) := '297B72657475726E206E65772059432865297D7374617469632066726F6D5669657753746174652865297B72657475726E206E6577205A432865297D7374617469632066726F6D4D6F64656C53656C656374696F6E2865297B636F6E737420743D61682E';
wwv_flow_imp.g_varchar2_table(8464) := '6C69667453656C656374696F6E2865292C6E3D6E65772058432872682E66726F6D506F736974696F6E7328742E67657453656C656374696F6E53746172742829292C302C302C742E676574506F736974696F6E28292C30293B72657475726E2051432E66';
wwv_flow_imp.g_varchar2_table(8465) := '726F6D4D6F64656C5374617465286E297D7374617469632066726F6D4D6F64656C53656C656374696F6E732865297B636F6E737420743D5B5D3B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D746869732E66';
wwv_flow_imp.g_varchar2_table(8466) := '726F6D4D6F64656C53656C656374696F6E28655B6E5D293B72657475726E20747D636F6E7374727563746F7228652C74297B746869732E5F637572736F7253746174654272616E643D766F696420302C746869732E6D6F64656C53746174653D652C7468';
wwv_flow_imp.g_varchar2_table(8467) := '69732E7669657753746174653D747D657175616C732865297B72657475726E20746869732E7669657753746174652E657175616C7328652E766965775374617465292626746869732E6D6F64656C53746174652E657175616C7328652E6D6F64656C5374';
wwv_flow_imp.g_varchar2_table(8468) := '617465297D7D636C6173732059437B636F6E7374727563746F722865297B746869732E6D6F64656C53746174653D652C746869732E7669657753746174653D6E756C6C7D7D636C617373205A437B636F6E7374727563746F722865297B746869732E6D6F';
wwv_flow_imp.g_varchar2_table(8469) := '64656C53746174653D6E756C6C2C746869732E7669657753746174653D657D7D636C6173732058437B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E73656C656374696F6E53746172743D652C746869732E73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(8470) := '53746172744B696E643D742C746869732E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E733D6E2C746869732E706F736974696F6E3D692C746869732E6C6566746F76657256697369626C65436F6C756D6E733D';
wwv_flow_imp.g_varchar2_table(8471) := '6F2C746869732E5F73696E676C65437572736F7253746174654272616E643D766F696420302C746869732E73656C656374696F6E3D58432E5F636F6D7075746553656C656374696F6E28746869732E73656C656374696F6E53746172742C746869732E70';
wwv_flow_imp.g_varchar2_table(8472) := '6F736974696F6E297D657175616C732865297B72657475726E20746869732E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E733D3D3D652E73656C656374696F6E53746172744C6566746F76657256697369626C';
wwv_flow_imp.g_varchar2_table(8473) := '65436F6C756D6E732626746869732E6C6566746F76657256697369626C65436F6C756D6E733D3D3D652E6C6566746F76657256697369626C65436F6C756D6E732626746869732E73656C656374696F6E53746172744B696E643D3D3D652E73656C656374';
wwv_flow_imp.g_varchar2_table(8474) := '696F6E53746172744B696E642626746869732E706F736974696F6E2E657175616C7328652E706F736974696F6E292626746869732E73656C656374696F6E53746172742E657175616C7352616E676528652E73656C656374696F6E5374617274297D6861';
wwv_flow_imp.g_varchar2_table(8475) := '7353656C656374696F6E28297B72657475726E21746869732E73656C656374696F6E2E6973456D70747928297C7C21746869732E73656C656374696F6E53746172742E6973456D70747928297D6D6F766528652C742C6E2C69297B72657475726E20653F';
wwv_flow_imp.g_varchar2_table(8476) := '6E657720584328746869732E73656C656374696F6E53746172742C746869732E73656C656374696F6E53746172744B696E642C746869732E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E732C6E6577206D6328';
wwv_flow_imp.g_varchar2_table(8477) := '742C6E292C69293A6E6577205843286E657720726828742C6E2C742C6E292C302C692C6E6577206D6328742C6E292C69297D737461746963205F636F6D7075746553656C656374696F6E28652C74297B72657475726E20652E6973456D70747928297C7C';
wwv_flow_imp.g_varchar2_table(8478) := '21742E69734265666F72654F72457175616C28652E6765745374617274506F736974696F6E2829293F61682E66726F6D506F736974696F6E7328652E6765745374617274506F736974696F6E28292C74293A61682E66726F6D506F736974696F6E732865';
wwv_flow_imp.g_varchar2_table(8479) := '2E676574456E64506F736974696F6E28292C74297D7D636C617373204A437B636F6E7374727563746F7228652C742C6E297B746869732E5F656469744F7065726174696F6E526573756C744272616E643D766F696420302C746869732E747970653D652C';
wwv_flow_imp.g_varchar2_table(8480) := '746869732E636F6D6D616E64733D742C746869732E73686F756C6450757368537461636B456C656D656E744265666F72653D6E2E73686F756C6450757368537461636B456C656D656E744265666F72652C746869732E73686F756C645075736853746163';
wwv_flow_imp.g_varchar2_table(8481) := '6B456C656D656E7441667465723D6E2E73686F756C6450757368537461636B456C656D656E7441667465727D7D66756E6374696F6E2065532865297B72657475726E2227223D3D3D657C7C2722273D3D3D657C7C2260223D3D3D657D636C617373207453';
wwv_flow_imp.g_varchar2_table(8482) := '7B73746174696320636F6C756D6E53656C65637428652C742C6E2C692C6F2C73297B636F6E737420723D4D6174682E616273286F2D6E292B312C613D6E3E6F2C6C3D693E732C633D693C732C643D5B5D3B666F72286C6574206F3D303B6F3C723B6F2B2B';
wwv_flow_imp.g_varchar2_table(8483) := '297B636F6E737420723D6E2B28613F2D6F3A6F292C683D652E636F6C756D6E46726F6D56697369626C65436F6C756D6E28742C722C69292C753D652E636F6C756D6E46726F6D56697369626C65436F6C756D6E28742C722C73292C703D652E7669736962';
wwv_flow_imp.g_varchar2_table(8484) := '6C65436F6C756D6E46726F6D436F6C756D6E28742C6E6577206D6328722C6829292C673D652E76697369626C65436F6C756D6E46726F6D436F6C756D6E28742C6E6577206D6328722C7529293B69662863297B696628703E7329636F6E74696E75653B69';
wwv_flow_imp.g_varchar2_table(8485) := '6628673C6929636F6E74696E75657D6966286C297B696628673E6929636F6E74696E75653B696628703C7329636F6E74696E75657D642E70757368286E6577205843286E657720726828722C682C722C68292C302C302C6E6577206D6328722C75292C30';
wwv_flow_imp.g_varchar2_table(8486) := '29297D696628303D3D3D642E6C656E67746829666F72286C657420653D303B653C723B652B2B297B636F6E737420693D6E2B28613F2D653A65292C6F3D742E6765744C696E654D6178436F6C756D6E2869293B642E70757368286E6577205843286E6577';
wwv_flow_imp.g_varchar2_table(8487) := '20726828692C6F2C692C6F292C302C302C6E6577206D6328692C6F292C3029297D72657475726E7B766965775374617465733A642C72657665727365643A612C66726F6D4C696E654E756D6265723A6E2C66726F6D56697375616C436F6C756D6E3A692C';
wwv_flow_imp.g_varchar2_table(8488) := '746F4C696E654E756D6265723A6F2C746F56697375616C436F6C756D6E3A737D7D73746174696320636F6C756D6E53656C6563744C65667428652C742C6E297B6C657420693D6E2E746F5669657756697375616C436F6C756D6E3B72657475726E20693E';
wwv_flow_imp.g_varchar2_table(8489) := '302626692D2D2C74532E636F6C756D6E53656C65637428652C742C6E2E66726F6D566965774C696E654E756D6265722C6E2E66726F6D5669657756697375616C436F6C756D6E2C6E2E746F566965774C696E654E756D6265722C69297D73746174696320';
wwv_flow_imp.g_varchar2_table(8490) := '636F6C756D6E53656C656374526967687428652C742C6E297B6C657420693D303B636F6E7374206F3D4D6174682E6D696E286E2E66726F6D566965774C696E654E756D6265722C6E2E746F566965774C696E654E756D626572292C733D4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(8491) := '78286E2E66726F6D566965774C696E654E756D6265722C6E2E746F566965774C696E654E756D626572293B666F72286C6574206E3D6F3B6E3C3D733B6E2B2B297B636F6E7374206F3D742E6765744C696E654D6178436F6C756D6E286E292C733D652E76';
wwv_flow_imp.g_varchar2_table(8492) := '697369626C65436F6C756D6E46726F6D436F6C756D6E28742C6E6577206D63286E2C6F29293B693D4D6174682E6D617828692C73297D6C657420723D6E2E746F5669657756697375616C436F6C756D6E3B72657475726E20723C692626722B2B2C746869';
wwv_flow_imp.g_varchar2_table(8493) := '732E636F6C756D6E53656C65637428652C742C6E2E66726F6D566965774C696E654E756D6265722C6E2E66726F6D5669657756697375616C436F6C756D6E2C6E2E746F566965774C696E654E756D6265722C72297D73746174696320636F6C756D6E5365';
wwv_flow_imp.g_varchar2_table(8494) := '6C656374557028652C742C6E2C69297B636F6E7374206F3D693F652E7061676553697A653A312C733D4D6174682E6D617828312C6E2E746F566965774C696E654E756D6265722D6F293B72657475726E20746869732E636F6C756D6E53656C6563742865';
wwv_flow_imp.g_varchar2_table(8495) := '2C742C6E2E66726F6D566965774C696E654E756D6265722C6E2E66726F6D5669657756697375616C436F6C756D6E2C732C6E2E746F5669657756697375616C436F6C756D6E297D73746174696320636F6C756D6E53656C656374446F776E28652C742C6E';
wwv_flow_imp.g_varchar2_table(8496) := '2C69297B636F6E7374206F3D693F652E7061676553697A653A312C733D4D6174682E6D696E28742E6765744C696E65436F756E7428292C6E2E746F566965774C696E654E756D6265722B6F293B72657475726E20746869732E636F6C756D6E53656C6563';
wwv_flow_imp.g_varchar2_table(8497) := '7428652C742C6E2E66726F6D566965774C696E654E756D6265722C6E2E66726F6D5669657756697375616C436F6C756D6E2C732C6E2E746F5669657756697375616C436F6C756D6E297D7D636C617373206E537B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(8498) := '6E3D2131297B746869732E5F72616E67653D652C746869732E5F746578743D742C746869732E696E73657274734175746F576869746573706163653D6E7D676574456469744F7065726174696F6E7328652C74297B742E616464547261636B6564456469';
wwv_flow_imp.g_varchar2_table(8499) := '744F7065726174696F6E28746869732E5F72616E67652C746869732E5F74657874297D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E3D742E676574496E7665727365456469744F7065726174696F6E7328295B305D2E72';
wwv_flow_imp.g_varchar2_table(8500) := '616E67653B72657475726E2061682E66726F6D506F736974696F6E73286E2E676574456E64506F736974696F6E2829297D7D636C6173732069537B636F6E7374727563746F7228652C74297B746869732E5F72616E67653D652C746869732E5F74657874';
wwv_flow_imp.g_varchar2_table(8501) := '3D747D676574456469744F7065726174696F6E7328652C74297B742E616464547261636B6564456469744F7065726174696F6E28746869732E5F72616E67652C746869732E5F74657874297D636F6D70757465437572736F72537461746528652C74297B';
wwv_flow_imp.g_varchar2_table(8502) := '636F6E7374206E3D742E676574496E7665727365456469744F7065726174696F6E7328295B305D2E72616E67653B72657475726E2061682E66726F6D52616E6765286E2C30297D7D636C617373206F537B636F6E7374727563746F7228652C742C6E3D21';
wwv_flow_imp.g_varchar2_table(8503) := '31297B746869732E5F72616E67653D652C746869732E5F746578743D742C746869732E696E73657274734175746F576869746573706163653D6E7D676574456469744F7065726174696F6E7328652C74297B742E616464547261636B6564456469744F70';
wwv_flow_imp.g_varchar2_table(8504) := '65726174696F6E28746869732E5F72616E67652C746869732E5F74657874297D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E3D742E676574496E7665727365456469744F7065726174696F6E7328295B305D2E72616E67';
wwv_flow_imp.g_varchar2_table(8505) := '653B72657475726E2061682E66726F6D506F736974696F6E73286E2E6765745374617274506F736974696F6E2829297D7D636C6173732073537B636F6E7374727563746F7228652C742C6E2C692C6F3D2131297B746869732E5F72616E67653D652C7468';
wwv_flow_imp.g_varchar2_table(8506) := '69732E5F746578743D742C746869732E5F636F6C756D6E44656C74614F66667365743D692C746869732E5F6C696E654E756D62657244656C74614F66667365743D6E2C746869732E696E73657274734175746F576869746573706163653D6F7D67657445';
wwv_flow_imp.g_varchar2_table(8507) := '6469744F7065726174696F6E7328652C74297B742E616464547261636B6564456469744F7065726174696F6E28746869732E5F72616E67652C746869732E5F74657874297D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(8508) := '3D742E676574496E7665727365456469744F7065726174696F6E7328295B305D2E72616E67653B72657475726E2061682E66726F6D506F736974696F6E73286E2E676574456E64506F736974696F6E28292E64656C746128746869732E5F6C696E654E75';
wwv_flow_imp.g_varchar2_table(8509) := '6D62657244656C74614F66667365742C746869732E5F636F6C756D6E44656C74614F666673657429297D7D636C6173732072537B636F6E7374727563746F7228652C742C6E2C693D2131297B746869732E5F72616E67653D652C746869732E5F74657874';
wwv_flow_imp.g_varchar2_table(8510) := '3D742C746869732E5F696E697469616C53656C656374696F6E3D6E2C746869732E5F666F7263654D6F76654D61726B6572733D692C746869732E5F73656C656374696F6E49643D6E756C6C7D676574456469744F7065726174696F6E7328652C74297B74';
wwv_flow_imp.g_varchar2_table(8511) := '2E616464547261636B6564456469744F7065726174696F6E28746869732E5F72616E67652C746869732E5F746578742C746869732E5F666F7263654D6F76654D61726B657273292C746869732E5F73656C656374696F6E49643D742E747261636B53656C';
wwv_flow_imp.g_varchar2_table(8512) := '656374696F6E28746869732E5F696E697469616C53656C656374696F6E297D636F6D70757465437572736F72537461746528652C74297B72657475726E20742E676574547261636B656453656C656374696F6E28746869732E5F73656C656374696F6E49';
wwv_flow_imp.g_varchar2_table(8513) := '64297D7D636C6173732061537B737461746963207768697465737061636556697369626C65436F6C756D6E28652C742C6E297B636F6E737420693D652E6C656E6774683B6C6574206F3D302C733D2D312C723D2D313B666F72286C657420613D303B613C';
wwv_flow_imp.g_varchar2_table(8514) := '693B612B2B297B696628613D3D3D742972657475726E5B732C722C6F5D3B737769746368286F256E3D3D30262628733D612C723D6F292C652E63686172436F64654174286129297B636173652033323A6F2B3D313B627265616B3B6361736520393A6F3D';
wwv_flow_imp.g_varchar2_table(8515) := '70752E6E65787452656E64657254616253746F70286F2C6E293B627265616B3B64656661756C743A72657475726E5B2D312C2D312C2D315D7D7D72657475726E20743D3D3D693F5B732C722C6F5D3A5B2D312C2D312C2D315D7D7374617469632061746F';
wwv_flow_imp.g_varchar2_table(8516) := '6D6963506F736974696F6E28652C742C6E2C69297B636F6E7374206F3D652E6C656E6774682C5B732C722C615D3D61532E7768697465737061636556697369626C65436F6C756D6E28652C742C6E293B6966282D313D3D3D612972657475726E2D313B6C';
wwv_flow_imp.g_varchar2_table(8517) := '6574206C3B7377697463682869297B6361736520303A6C3D21303B627265616B3B6361736520313A6C3D21313B627265616B3B6361736520323A69662861256E3D3D302972657475726E20743B6C3D61256E3C3D6E2F327D6966286C297B6966282D313D';
wwv_flow_imp.g_varchar2_table(8518) := '3D3D732972657475726E2D313B6C657420743D723B666F72286C657420693D733B693C6F3B2B2B69297B696628743D3D3D722B6E2972657475726E20733B73776974636828652E63686172436F64654174286929297B636173652033323A742B3D313B62';
wwv_flow_imp.g_varchar2_table(8519) := '7265616B3B6361736520393A743D70752E6E65787452656E64657254616253746F7028742C6E293B627265616B3B64656661756C743A72657475726E2D317D7D72657475726E20743D3D3D722B6E3F733A2D317D636F6E737420633D70752E6E65787452';
wwv_flow_imp.g_varchar2_table(8520) := '656E64657254616253746F7028612C6E293B6C657420643D613B666F72286C657420693D743B693C6F3B692B2B297B696628643D3D3D632972657475726E20693B73776974636828652E63686172436F64654174286929297B636173652033323A642B3D';
wwv_flow_imp.g_varchar2_table(8521) := '313B627265616B3B6361736520393A643D70752E6E65787452656E64657254616253746F7028642C6E293B627265616B3B64656661756C743A72657475726E2D317D7D72657475726E20643D3D3D633F6F3A2D317D7D636C617373206C537B636F6E7374';
wwv_flow_imp.g_varchar2_table(8522) := '727563746F7228652C742C6E297B746869732E5F637572736F72506F736974696F6E4272616E643D766F696420302C746869732E6C696E654E756D6265723D652C746869732E636F6C756D6E3D742C746869732E6C6566746F76657256697369626C6543';
wwv_flow_imp.g_varchar2_table(8523) := '6F6C756D6E733D6E7D7D636C6173732063537B737461746963206C656674506F736974696F6E28652C74297B696628742E636F6C756D6E3E652E6765744C696E654D696E436F6C756D6E28742E6C696E654E756D626572292972657475726E20742E6465';
wwv_flow_imp.g_varchar2_table(8524) := '6C746128766F696420302C2D526928652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C742E636F6C756D6E2D3129293B696628742E6C696E654E756D6265723E31297B636F6E7374206E3D742E6C696E654E756D6265722D31';
wwv_flow_imp.g_varchar2_table(8525) := '3B72657475726E206E6577206D63286E2C652E6765744C696E654D6178436F6C756D6E286E29297D72657475726E20747D737461746963206C656674506F736974696F6E41746F6D6963536F66745461627328652C742C6E297B696628742E636F6C756D';
wwv_flow_imp.g_varchar2_table(8526) := '6E3C3D652E6765744C696E65496E64656E74436F6C756D6E28742E6C696E654E756D62657229297B636F6E737420693D652E6765744C696E654D696E436F6C756D6E28742E6C696E654E756D626572292C6F3D652E6765744C696E65436F6E74656E7428';
wwv_flow_imp.g_varchar2_table(8527) := '742E6C696E654E756D626572292C733D61532E61746F6D6963506F736974696F6E286F2C742E636F6C756D6E2D312C6E2C30293B6966282D31213D3D732626732B313E3D692972657475726E206E6577206D6328742E6C696E654E756D6265722C732B31';
wwv_flow_imp.g_varchar2_table(8528) := '297D72657475726E20746869732E6C656674506F736974696F6E28652C74297D737461746963206C65667428652C742C6E297B636F6E737420693D652E737469636B7954616253746F70733F63532E6C656674506F736974696F6E41746F6D6963536F66';
wwv_flow_imp.g_varchar2_table(8529) := '745461627328742C6E2C652E74616253697A65293A63532E6C656674506F736974696F6E28742C6E293B72657475726E206E6577206C5328692E6C696E654E756D6265722C692E636F6C756D6E2C30297D737461746963206D6F76654C65667428652C74';
wwv_flow_imp.g_varchar2_table(8530) := '2C6E2C692C6F297B6C657420732C723B6966286E2E68617353656C656374696F6E28292626216929733D6E2E73656C656374696F6E2E73746172744C696E654E756D6265722C723D6E2E73656C656374696F6E2E7374617274436F6C756D6E3B656C7365';
wwv_flow_imp.g_varchar2_table(8531) := '7B636F6E737420693D6E2E706F736974696F6E2E64656C746128766F696420302C2D286F2D3129292C613D742E6E6F726D616C697A65506F736974696F6E2863532E636C6970506F736974696F6E436F6C756D6E28692C74292C30292C6C3D63532E6C65';
wwv_flow_imp.g_varchar2_table(8532) := '667428652C742C61293B733D6C2E6C696E654E756D6265722C723D6C2E636F6C756D6E7D72657475726E206E2E6D6F766528692C732C722C30297D73746174696320636C6970506F736974696F6E436F6C756D6E28652C74297B72657475726E206E6577';
wwv_flow_imp.g_varchar2_table(8533) := '206D6328652E6C696E654E756D6265722C63532E636C697052616E676528652E636F6C756D6E2C742E6765744C696E654D696E436F6C756D6E28652E6C696E654E756D626572292C742E6765744C696E654D6178436F6C756D6E28652E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(8534) := '6265722929297D73746174696320636C697052616E676528652C742C6E297B72657475726E20653C743F743A653E6E3F6E3A657D737461746963207269676874506F736974696F6E28652C742C6E297B72657475726E206E3C652E6765744C696E654D61';
wwv_flow_imp.g_varchar2_table(8535) := '78436F6C756D6E2874293F6E2B3D4F6928652E6765744C696E65436F6E74656E742874292C6E2D31293A743C652E6765744C696E65436F756E742829262628742B3D312C6E3D652E6765744C696E654D696E436F6C756D6E287429292C6E6577206D6328';
wwv_flow_imp.g_varchar2_table(8536) := '742C6E297D737461746963207269676874506F736974696F6E41746F6D6963536F66745461627328652C742C6E2C692C6F297B6966286E3C652E6765744C696E65496E64656E74436F6C756D6E287429297B636F6E7374206F3D652E6765744C696E6543';
wwv_flow_imp.g_varchar2_table(8537) := '6F6E74656E742874292C733D61532E61746F6D6963506F736974696F6E286F2C6E2D312C692C31293B6966282D31213D3D732972657475726E206E6577206D6328742C732B31297D72657475726E20746869732E7269676874506F736974696F6E28652C';
wwv_flow_imp.g_varchar2_table(8538) := '742C6E297D73746174696320726967687428652C742C6E297B636F6E737420693D652E737469636B7954616253746F70733F63532E7269676874506F736974696F6E41746F6D6963536F66745461627328742C6E2E6C696E654E756D6265722C6E2E636F';
wwv_flow_imp.g_varchar2_table(8539) := '6C756D6E2C652E74616253697A652C652E696E64656E7453697A65293A63532E7269676874506F736974696F6E28742C6E2E6C696E654E756D6265722C6E2E636F6C756D6E293B72657475726E206E6577206C5328692E6C696E654E756D6265722C692E';
wwv_flow_imp.g_varchar2_table(8540) := '636F6C756D6E2C30297D737461746963206D6F7665526967687428652C742C6E2C692C6F297B6C657420732C723B6966286E2E68617353656C656374696F6E28292626216929733D6E2E73656C656374696F6E2E656E644C696E654E756D6265722C723D';
wwv_flow_imp.g_varchar2_table(8541) := '6E2E73656C656374696F6E2E656E64436F6C756D6E3B656C73657B636F6E737420693D6E2E706F736974696F6E2E64656C746128766F696420302C6F2D31292C613D742E6E6F726D616C697A65506F736974696F6E2863532E636C6970506F736974696F';
wwv_flow_imp.g_varchar2_table(8542) := '6E436F6C756D6E28692C74292C31292C6C3D63532E726967687428652C742C61293B733D6C2E6C696E654E756D6265722C723D6C2E636F6C756D6E7D72657475726E206E2E6D6F766528692C732C722C30297D73746174696320766572746963616C2865';
wwv_flow_imp.g_varchar2_table(8543) := '2C742C6E2C692C6F2C732C722C61297B636F6E7374206C3D70752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28742E6765744C696E65436F6E74656E74286E292C692C652E74616253697A65292B6F2C633D742E6765744C696E65436F75';
wwv_flow_imp.g_varchar2_table(8544) := '6E7428292C643D313D3D3D6E2626313D3D3D692C683D6E3D3D3D632626693D3D3D742E6765744C696E654D6178436F6C756D6E286E292C753D733C6E3F643A683B696628286E3D73293C313F286E3D312C693D723F742E6765744C696E654D696E436F6C';
wwv_flow_imp.g_varchar2_table(8545) := '756D6E286E293A4D6174682E6D696E28742E6765744C696E654D6178436F6C756D6E286E292C6929293A6E3E633F286E3D632C693D723F742E6765744C696E654D6178436F6C756D6E286E293A4D6174682E6D696E28742E6765744C696E654D6178436F';
wwv_flow_imp.g_varchar2_table(8546) := '6C756D6E286E292C6929293A693D652E636F6C756D6E46726F6D56697369626C65436F6C756D6E28742C6E2C6C292C6F3D753F303A6C2D70752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28742E6765744C696E65436F6E74656E74286E';
wwv_flow_imp.g_varchar2_table(8547) := '292C692C652E74616253697A65292C766F69642030213D3D61297B636F6E737420653D6E6577206D63286E2C69292C733D742E6E6F726D616C697A65506F736974696F6E28652C61293B6F2B3D692D732E636F6C756D6E2C6E3D732E6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(8548) := '65722C693D732E636F6C756D6E7D72657475726E206E6577206C53286E2C692C6F297D73746174696320646F776E28652C742C6E2C692C6F2C732C72297B72657475726E20746869732E766572746963616C28652C742C6E2C692C6F2C6E2B732C722C34';
wwv_flow_imp.g_varchar2_table(8549) := '297D737461746963206D6F7665446F776E28652C742C6E2C692C6F297B6C657420732C723B6E2E68617353656C656374696F6E2829262621693F28733D6E2E73656C656374696F6E2E656E644C696E654E756D6265722C723D6E2E73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(8550) := '2E656E64436F6C756D6E293A28733D6E2E706F736974696F6E2E6C696E654E756D6265722C723D6E2E706F736974696F6E2E636F6C756D6E293B6C657420612C6C3D303B646F7B696628613D63532E646F776E28652C742C732B6C2C722C6E2E6C656674';
wwv_flow_imp.g_varchar2_table(8551) := '6F76657256697369626C65436F6C756D6E732C6F2C2130292C742E6E6F726D616C697A65506F736974696F6E286E6577206D6328612E6C696E654E756D6265722C612E636F6C756D6E292C32292E6C696E654E756D6265723E7329627265616B7D776869';
wwv_flow_imp.g_varchar2_table(8552) := '6C65286C2B2B3C31302626732B6C3C742E6765744C696E65436F756E742829293B72657475726E206E2E6D6F766528692C612E6C696E654E756D6265722C612E636F6C756D6E2C612E6C6566746F76657256697369626C65436F6C756D6E73297D737461';
wwv_flow_imp.g_varchar2_table(8553) := '746963207472616E736C617465446F776E28652C742C6E297B636F6E737420693D6E2E73656C656374696F6E2C6F3D63532E646F776E28652C742C692E73656C656374696F6E53746172744C696E654E756D6265722C692E73656C656374696F6E537461';
wwv_flow_imp.g_varchar2_table(8554) := '7274436F6C756D6E2C6E2E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E732C312C2131292C733D63532E646F776E28652C742C692E706F736974696F6E4C696E654E756D6265722C692E706F736974696F6E43';
wwv_flow_imp.g_varchar2_table(8555) := '6F6C756D6E2C6E2E6C6566746F76657256697369626C65436F6C756D6E732C312C2131293B72657475726E206E6577205843286E6577207268286F2E6C696E654E756D6265722C6F2E636F6C756D6E2C6F2E6C696E654E756D6265722C6F2E636F6C756D';
wwv_flow_imp.g_varchar2_table(8556) := '6E292C302C6F2E6C6566746F76657256697369626C65436F6C756D6E732C6E6577206D6328732E6C696E654E756D6265722C732E636F6C756D6E292C732E6C6566746F76657256697369626C65436F6C756D6E73297D73746174696320757028652C742C';
wwv_flow_imp.g_varchar2_table(8557) := '6E2C692C6F2C732C72297B72657475726E20746869732E766572746963616C28652C742C6E2C692C6F2C6E2D732C722C33297D737461746963206D6F7665557028652C742C6E2C692C6F297B6C657420732C723B6E2E68617353656C656374696F6E2829';
wwv_flow_imp.g_varchar2_table(8558) := '262621693F28733D6E2E73656C656374696F6E2E73746172744C696E654E756D6265722C723D6E2E73656C656374696F6E2E7374617274436F6C756D6E293A28733D6E2E706F736974696F6E2E6C696E654E756D6265722C723D6E2E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(8559) := '2E636F6C756D6E293B636F6E737420613D63532E757028652C742C732C722C6E2E6C6566746F76657256697369626C65436F6C756D6E732C6F2C2130293B72657475726E206E2E6D6F766528692C612E6C696E654E756D6265722C612E636F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(8560) := '612E6C6566746F76657256697369626C65436F6C756D6E73297D737461746963207472616E736C617465557028652C742C6E297B636F6E737420693D6E2E73656C656374696F6E2C6F3D63532E757028652C742C692E73656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(8561) := '4C696E654E756D6265722C692E73656C656374696F6E5374617274436F6C756D6E2C6E2E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E732C312C2131292C733D63532E757028652C742C692E706F736974696F';
wwv_flow_imp.g_varchar2_table(8562) := '6E4C696E654E756D6265722C692E706F736974696F6E436F6C756D6E2C6E2E6C6566746F76657256697369626C65436F6C756D6E732C312C2131293B72657475726E206E6577205843286E6577207268286F2E6C696E654E756D6265722C6F2E636F6C75';
wwv_flow_imp.g_varchar2_table(8563) := '6D6E2C6F2E6C696E654E756D6265722C6F2E636F6C756D6E292C302C6F2E6C6566746F76657256697369626C65436F6C756D6E732C6E6577206D6328732E6C696E654E756D6265722C732E636F6C756D6E292C732E6C6566746F76657256697369626C65';
wwv_flow_imp.g_varchar2_table(8564) := '436F6C756D6E73297D737461746963205F6973426C616E6B4C696E6528652C74297B72657475726E20303D3D3D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2874297D737461746963206D6F7665546F5072657642';
wwv_flow_imp.g_varchar2_table(8565) := '6C616E6B4C696E6528652C742C6E2C69297B6C6574206F3D6E2E706F736974696F6E2E6C696E654E756D6265723B666F72283B6F3E312626746869732E5F6973426C616E6B4C696E6528742C6F293B296F2D2D3B666F72283B6F3E31262621746869732E';
wwv_flow_imp.g_varchar2_table(8566) := '5F6973426C616E6B4C696E6528742C6F293B296F2D2D3B72657475726E206E2E6D6F766528692C6F2C742E6765744C696E654D696E436F6C756D6E286F292C30297D737461746963206D6F7665546F4E657874426C616E6B4C696E6528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(8567) := '297B636F6E7374206F3D742E6765744C696E65436F756E7428293B6C657420733D6E2E706F736974696F6E2E6C696E654E756D6265723B666F72283B733C6F2626746869732E5F6973426C616E6B4C696E6528742C73293B29732B2B3B666F72283B733C';
wwv_flow_imp.g_varchar2_table(8568) := '6F262621746869732E5F6973426C616E6B4C696E6528742C73293B29732B2B3B72657475726E206E2E6D6F766528692C732C742E6765744C696E654D696E436F6C756D6E2873292C30297D737461746963206D6F7665546F426567696E6E696E674F664C';
wwv_flow_imp.g_varchar2_table(8569) := '696E6528652C742C6E2C69297B636F6E7374206F3D6E2E706F736974696F6E2E6C696E654E756D6265722C733D742E6765744C696E654D696E436F6C756D6E286F292C723D742E6765744C696E6546697273744E6F6E57686974657370616365436F6C75';
wwv_flow_imp.g_varchar2_table(8570) := '6D6E286F297C7C733B6C657420613B72657475726E20613D6E2E706F736974696F6E2E636F6C756D6E3D3D3D723F733A722C6E2E6D6F766528692C6F2C612C30297D737461746963206D6F7665546F456E644F664C696E6528652C742C6E2C692C6F297B';
wwv_flow_imp.g_varchar2_table(8571) := '636F6E737420733D6E2E706F736974696F6E2E6C696E654E756D6265722C723D742E6765744C696E654D6178436F6C756D6E2873293B72657475726E206E2E6D6F766528692C732C722C6F3F313037333734313832342D723A30297D737461746963206D';
wwv_flow_imp.g_varchar2_table(8572) := '6F7665546F426567696E6E696E674F6642756666657228652C742C6E2C69297B72657475726E206E2E6D6F766528692C312C312C30297D737461746963206D6F7665546F456E644F6642756666657228652C742C6E2C69297B636F6E7374206F3D742E67';
wwv_flow_imp.g_varchar2_table(8573) := '65744C696E65436F756E7428292C733D742E6765744C696E654D6178436F6C756D6E286F293B72657475726E206E2E6D6F766528692C6F2C732C30297D7D636C6173732064537B7374617469632064656C657465526967687428652C742C6E2C69297B63';
wwv_flow_imp.g_varchar2_table(8574) := '6F6E7374206F3D5B5D3B6C657420733D33213D3D653B666F72286C657420653D302C723D692E6C656E6774683B653C723B652B2B297B636F6E737420723D695B655D3B6C657420613D723B696628612E6973456D7074792829297B636F6E737420653D72';
wwv_flow_imp.g_varchar2_table(8575) := '2E676574506F736974696F6E28292C693D63532E726967687428742C6E2C65293B613D6E657720726828692E6C696E654E756D6265722C692E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C756D6E297D612E6973456D70747928293F6F';
wwv_flow_imp.g_varchar2_table(8576) := '5B655D3D6E756C6C3A28612E73746172744C696E654E756D626572213D3D612E656E644C696E654E756D626572262628733D2130292C6F5B655D3D6E6577206E5328612C222229297D72657475726E5B732C6F5D7D7374617469632069734175746F436C';
wwv_flow_imp.g_varchar2_table(8577) := '6F73696E675061697244656C65746528652C742C6E2C692C6F2C732C72297B696628226E65766572223D3D3D742626226E65766572223D3D3D6E2972657475726E21313B696628226E65766572223D3D3D652972657475726E21313B666F72286C657420';
wwv_flow_imp.g_varchar2_table(8578) := '613D302C6C3D732E6C656E6774683B613C6C3B612B2B297B636F6E7374206C3D735B615D2C633D6C2E676574506F736974696F6E28293B696628216C2E6973456D70747928292972657475726E21313B636F6E737420643D6F2E6765744C696E65436F6E';
wwv_flow_imp.g_varchar2_table(8579) := '74656E7428632E6C696E654E756D626572293B696628632E636F6C756D6E3C327C7C632E636F6C756D6E3E3D642E6C656E6774682B312972657475726E21313B636F6E737420683D642E63686172417428632E636F6C756D6E2D32292C753D692E676574';
wwv_flow_imp.g_varchar2_table(8580) := '2868293B69662821752972657475726E21313B6966286553286829297B696628226E65766572223D3D3D6E2972657475726E21317D656C736520696628226E65766572223D3D3D742972657475726E21313B636F6E737420703D642E6368617241742863';
wwv_flow_imp.g_varchar2_table(8581) := '2E636F6C756D6E2D31293B6C657420673D21313B666F7228636F6E73742065206F66207529652E6F70656E3D3D3D682626652E636C6F73653D3D3D70262628673D2130293B69662821672972657475726E21313B696628226175746F223D3D3D65297B6C';
wwv_flow_imp.g_varchar2_table(8582) := '657420653D21313B666F72286C657420743D302C6E3D722E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D725B745D3B696628632E6C696E654E756D6265723D3D3D6E2E73746172744C696E654E756D6265722626632E636F6C756D6E3D3D';
wwv_flow_imp.g_varchar2_table(8583) := '3D6E2E7374617274436F6C756D6E297B653D21303B627265616B7D7D69662821652972657475726E21317D7D72657475726E21307D737461746963205F72756E4175746F436C6F73696E675061697244656C65746528652C742C6E297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(8584) := '3D5B5D3B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D2E676574506F736974696F6E28292C6F3D6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2D312C742E6C69';
wwv_flow_imp.g_varchar2_table(8585) := '6E654E756D6265722C742E636F6C756D6E2B31293B695B655D3D6E6577206E53286F2C2222297D72657475726E5B21302C695D7D7374617469632064656C6574654C65667428652C742C6E2C692C6F297B696628746869732E69734175746F436C6F7369';
wwv_flow_imp.g_varchar2_table(8586) := '6E675061697244656C65746528742E6175746F436C6F73696E6744656C6574652C742E6175746F436C6F73696E67427261636B6574732C742E6175746F436C6F73696E6751756F7465732C742E6175746F436C6F73696E6750616972732E6175746F436C';
wwv_flow_imp.g_varchar2_table(8587) := '6F73696E6750616972734F70656E4279456E642C6E2C692C6F292972657475726E20746869732E5F72756E4175746F436C6F73696E675061697244656C65746528742C6E2C69293B636F6E737420733D5B5D3B6C657420723D32213D3D653B666F72286C';
wwv_flow_imp.g_varchar2_table(8588) := '657420653D302C6F3D692E6C656E6774683B653C6F3B652B2B297B636F6E7374206F3D64532E67657444656C65746552616E676528695B655D2C6E2C74293B6F2E6973456D70747928293F735B655D3D6E756C6C3A286F2E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(8589) := '626572213D3D6F2E656E644C696E654E756D626572262628723D2130292C735B655D3D6E6577206E53286F2C222229297D72657475726E5B722C735D7D7374617469632067657444656C65746552616E676528652C742C6E297B69662821652E6973456D';
wwv_flow_imp.g_varchar2_table(8590) := '70747928292972657475726E20653B636F6E737420693D652E676574506F736974696F6E28293B6966286E2E75736554616253746F70732626692E636F6C756D6E3E31297B636F6E737420653D742E6765744C696E65436F6E74656E7428692E6C696E65';
wwv_flow_imp.g_varchar2_table(8591) := '4E756D626572292C6F3D6D692865292C733D2D313D3D3D6F3F652E6C656E6774682B313A6F2B313B696628692E636F6C756D6E3C3D73297B636F6E737420653D6E2E76697369626C65436F6C756D6E46726F6D436F6C756D6E28742C69292C6F3D70752E';
wwv_flow_imp.g_varchar2_table(8592) := '70726576496E64656E7454616253746F7028652C6E2E696E64656E7453697A65292C733D6E2E636F6C756D6E46726F6D56697369626C65436F6C756D6E28742C692E6C696E654E756D6265722C6F293B72657475726E206E657720726828692E6C696E65';
wwv_flow_imp.g_varchar2_table(8593) := '4E756D6265722C732C692E6C696E654E756D6265722C692E636F6C756D6E297D7D72657475726E2072682E66726F6D506F736974696F6E732864532E676574506F736974696F6E416674657244656C6574654C65667428692C74292C69297D7374617469';
wwv_flow_imp.g_varchar2_table(8594) := '6320676574506F736974696F6E416674657244656C6574654C65667428652C74297B696628652E636F6C756D6E3E31297B636F6E7374206E3D66756E6374696F6E28652C74297B696628303D3D3D652972657475726E20303B636F6E7374206E3D66756E';
wwv_flow_imp.g_varchar2_table(8595) := '6374696F6E28652C74297B636F6E7374206E3D6E6577204E6928742C65293B6C657420693D6E2E70726576436F6465506F696E7428293B666F72283B59692869297C7C36353033393D3D3D697C7C383431393D3D3D693B297B696628303D3D3D6E2E6F66';
wwv_flow_imp.g_varchar2_table(8596) := '667365742972657475726E3B693D6E2E70726576436F6465506F696E7428297D6966282171692869292972657475726E3B6C6574206F3D6E2E6F66667365743B72657475726E206F3E302626383230353D3D3D6E2E70726576436F6465506F696E742829';
wwv_flow_imp.g_varchar2_table(8597) := '2626286F3D6E2E6F6666736574292C6F7D28652C74293B696628766F69642030213D3D6E2972657475726E206E3B636F6E737420693D6E6577204E6928742C65293B72657475726E20692E70726576436F6465506F696E7428292C692E6F66667365747D';
wwv_flow_imp.g_varchar2_table(8598) := '28652E636F6C756D6E2D312C742E6765744C696E65436F6E74656E7428652E6C696E654E756D62657229293B72657475726E20652E7769746828766F696420302C6E2B31297D696628652E6C696E654E756D6265723E31297B636F6E7374206E3D652E6C';
wwv_flow_imp.g_varchar2_table(8599) := '696E654E756D6265722D313B72657475726E206E6577206D63286E2C742E6765744C696E654D6178436F6C756D6E286E29297D72657475726E20657D7374617469632063757428652C742C6E297B636F6E737420693D5B5D3B6C6574206F3D6E756C6C3B';
wwv_flow_imp.g_varchar2_table(8600) := '6E2E736F7274282828652C74293D3E6D632E636F6D7061726528652E6765745374617274506F736974696F6E28292C742E676574456E64506F736974696F6E28292929293B666F72286C657420733D302C723D6E2E6C656E6774683B733C723B732B2B29';
wwv_flow_imp.g_varchar2_table(8601) := '7B636F6E737420723D6E5B735D3B696628722E6973456D707479282929696628652E656D70747953656C656374696F6E436C6970626F617264297B636F6E737420653D722E676574506F736974696F6E28293B6C6574206E2C612C6C2C633B652E6C696E';
wwv_flow_imp.g_varchar2_table(8602) := '654E756D6265723C742E6765744C696E65436F756E7428293F286E3D652E6C696E654E756D6265722C613D312C6C3D652E6C696E654E756D6265722B312C633D31293A652E6C696E654E756D6265723E312626286E756C6C3D3D6F3F766F696420303A6F';
wwv_flow_imp.g_varchar2_table(8603) := '2E656E644C696E654E756D62657229213D3D652E6C696E654E756D6265723F286E3D652E6C696E654E756D6265722D312C613D742E6765744C696E654D6178436F6C756D6E28652E6C696E654E756D6265722D31292C6C3D652E6C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(8604) := '2C633D742E6765744C696E654D6178436F6C756D6E28652E6C696E654E756D62657229293A286E3D652E6C696E654E756D6265722C613D312C6C3D652E6C696E654E756D6265722C633D742E6765744C696E654D6178436F6C756D6E28652E6C696E654E';
wwv_flow_imp.g_varchar2_table(8605) := '756D62657229293B636F6E737420643D6E6577207268286E2C612C6C2C63293B6F3D642C642E6973456D70747928293F695B735D3D6E756C6C3A695B735D3D6E6577206E5328642C2222297D656C736520695B735D3D6E756C6C3B656C736520695B735D';
wwv_flow_imp.g_varchar2_table(8606) := '3D6E6577206E5328722C2222297D72657475726E206E6577204A4328302C692C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E7441667465723A21307D297D7D63';
wwv_flow_imp.g_varchar2_table(8607) := '6C6173732068537B737461746963205F637265617465576F726428652C742C6E2C692C6F297B72657475726E7B73746172743A692C656E643A6F2C776F7264547970653A742C6E65787443686172436C6173733A6E7D7D737461746963205F6372656174';
wwv_flow_imp.g_varchar2_table(8608) := '65496E746C576F726428652C74297B72657475726E7B73746172743A652E696E6465782C656E643A652E696E6465782B652E7365676D656E742E6C656E6774682C776F7264547970653A312C6E65787443686172436C6173733A747D7D73746174696320';
wwv_flow_imp.g_varchar2_table(8609) := '5F66696E6450726576696F7573576F72644F6E4C696E6528652C742C6E297B636F6E737420693D742E6765744C696E65436F6E74656E74286E2E6C696E654E756D626572293B72657475726E20746869732E5F646F46696E6450726576696F7573576F72';
wwv_flow_imp.g_varchar2_table(8610) := '644F6E4C696E6528692C652C6E297D737461746963205F646F46696E6450726576696F7573576F72644F6E4C696E6528652C742C6E297B6C657420693D303B636F6E7374206F3D742E66696E6450726576496E746C576F72644265666F72654F7241744F';
wwv_flow_imp.g_varchar2_table(8611) := '666673657428652C6E2E636F6C756D6E2D32293B666F72286C657420733D6E2E636F6C756D6E2D323B733E3D303B732D2D297B636F6E7374206E3D652E63686172436F646541742873292C723D742E676574286E293B6966286F2626733D3D3D6F2E696E';
wwv_flow_imp.g_varchar2_table(8612) := '6465782972657475726E20746869732E5F637265617465496E746C576F7264286F2C72293B696628303D3D3D72297B696628323D3D3D692972657475726E20746869732E5F637265617465576F726428652C692C722C732B312C746869732E5F66696E64';
wwv_flow_imp.g_varchar2_table(8613) := '456E644F66576F726428652C742C692C732B3129293B693D317D656C736520696628323D3D3D72297B696628313D3D3D692972657475726E20746869732E5F637265617465576F726428652C692C722C732B312C746869732E5F66696E64456E644F6657';
wwv_flow_imp.g_varchar2_table(8614) := '6F726428652C742C692C732B3129293B693D327D656C736520696628313D3D3D72262630213D3D692972657475726E20746869732E5F637265617465576F726428652C692C722C732B312C746869732E5F66696E64456E644F66576F726428652C742C69';
wwv_flow_imp.g_varchar2_table(8615) := '2C732B3129297D72657475726E2030213D3D693F746869732E5F637265617465576F726428652C692C312C302C746869732E5F66696E64456E644F66576F726428652C742C692C3029293A6E756C6C7D737461746963205F66696E64456E644F66576F72';
wwv_flow_imp.g_varchar2_table(8616) := '6428652C742C6E2C69297B636F6E7374206F3D742E66696E644E657874496E746C576F726441744F7241667465724F666673657428652C69292C733D652E6C656E6774683B666F72286C657420723D693B723C733B722B2B297B636F6E737420693D652E';
wwv_flow_imp.g_varchar2_table(8617) := '63686172436F646541742872292C733D742E6765742869293B6966286F2626723D3D3D6F2E696E6465782B6F2E7365676D656E742E6C656E6774682972657475726E20723B696628313D3D3D732972657475726E20723B696628313D3D3D6E2626323D3D';
wwv_flow_imp.g_varchar2_table(8618) := '3D732972657475726E20723B696628323D3D3D6E2626303D3D3D732972657475726E20727D72657475726E20737D737461746963205F66696E644E657874576F72644F6E4C696E6528652C742C6E297B636F6E737420693D742E6765744C696E65436F6E';
wwv_flow_imp.g_varchar2_table(8619) := '74656E74286E2E6C696E654E756D626572293B72657475726E20746869732E5F646F46696E644E657874576F72644F6E4C696E6528692C652C6E297D737461746963205F646F46696E644E657874576F72644F6E4C696E6528652C742C6E297B6C657420';
wwv_flow_imp.g_varchar2_table(8620) := '693D303B636F6E7374206F3D652E6C656E6774682C733D742E66696E644E657874496E746C576F726441744F7241667465724F666673657428652C6E2E636F6C756D6E2D31293B666F72286C657420723D6E2E636F6C756D6E2D313B723C6F3B722B2B29';
wwv_flow_imp.g_varchar2_table(8621) := '7B636F6E7374206E3D652E63686172436F646541742872292C6F3D742E676574286E293B696628732626723D3D3D732E696E6465782972657475726E20746869732E5F637265617465496E746C576F726428732C6F293B696628303D3D3D6F297B696628';
wwv_flow_imp.g_varchar2_table(8622) := '323D3D3D692972657475726E20746869732E5F637265617465576F726428652C692C6F2C746869732E5F66696E6453746172744F66576F726428652C742C692C722D31292C72293B693D317D656C736520696628323D3D3D6F297B696628313D3D3D6929';
wwv_flow_imp.g_varchar2_table(8623) := '72657475726E20746869732E5F637265617465576F726428652C692C6F2C746869732E5F66696E6453746172744F66576F726428652C742C692C722D31292C72293B693D327D656C736520696628313D3D3D6F262630213D3D692972657475726E207468';
wwv_flow_imp.g_varchar2_table(8624) := '69732E5F637265617465576F726428652C692C6F2C746869732E5F66696E6453746172744F66576F726428652C742C692C722D31292C72297D72657475726E2030213D3D693F746869732E5F637265617465576F726428652C692C312C746869732E5F66';
wwv_flow_imp.g_varchar2_table(8625) := '696E6453746172744F66576F726428652C742C692C6F2D31292C6F293A6E756C6C7D737461746963205F66696E6453746172744F66576F726428652C742C6E2C69297B636F6E7374206F3D742E66696E6450726576496E746C576F72644265666F72654F';
wwv_flow_imp.g_varchar2_table(8626) := '7241744F666673657428652C69293B666F72286C657420733D693B733E3D303B732D2D297B636F6E737420693D652E63686172436F646541742873292C723D742E6765742869293B6966286F2626733D3D3D6F2E696E6465782972657475726E20733B69';
wwv_flow_imp.g_varchar2_table(8627) := '6628313D3D3D722972657475726E20732B313B696628313D3D3D6E2626323D3D3D722972657475726E20732B313B696628323D3D3D6E2626303D3D3D722972657475726E20732B317D72657475726E20307D737461746963206D6F7665576F72644C6566';
wwv_flow_imp.g_varchar2_table(8628) := '7428652C742C6E2C69297B6C6574206F3D6E2E6C696E654E756D6265722C733D6E2E636F6C756D6E3B313D3D3D7326266F3E312626286F2D3D312C733D742E6765744C696E654D6178436F6C756D6E286F29293B6C657420723D68532E5F66696E645072';
wwv_flow_imp.g_varchar2_table(8629) := '6576696F7573576F72644F6E4C696E6528652C742C6E6577206D63286F2C7329293B696628303D3D3D692972657475726E206E6577206D63286F2C723F722E73746172742B313A31293B696628313D3D3D692972657475726E20722626323D3D3D722E77';
wwv_flow_imp.g_varchar2_table(8630) := '6F7264547970652626722E656E642D722E73746172743D3D312626303D3D3D722E6E65787443686172436C617373262628723D68532E5F66696E6450726576696F7573576F72644F6E4C696E6528652C742C6E6577206D63286F2C722E73746172742B31';
wwv_flow_imp.g_varchar2_table(8631) := '2929292C6E6577206D63286F2C723F722E73746172742B313A31293B696628333D3D3D69297B666F72283B722626323D3D3D722E776F7264547970653B29723D68532E5F66696E6450726576696F7573576F72644F6E4C696E6528652C742C6E6577206D';
wwv_flow_imp.g_varchar2_table(8632) := '63286F2C722E73746172742B3129293B72657475726E206E6577206D63286F2C723F722E73746172742B313A31297D72657475726E20722626733C3D722E656E642B31262628723D68532E5F66696E6450726576696F7573576F72644F6E4C696E652865';
wwv_flow_imp.g_varchar2_table(8633) := '2C742C6E6577206D63286F2C722E73746172742B312929292C6E6577206D63286F2C723F722E656E642B313A31297D737461746963205F6D6F7665576F7264506172744C65667428652C74297B636F6E7374206E3D742E6C696E654E756D6265722C693D';
wwv_flow_imp.g_varchar2_table(8634) := '652E6765744C696E654D6178436F6C756D6E286E293B696628313D3D3D742E636F6C756D6E2972657475726E206E3E313F6E6577206D63286E2D312C652E6765744C696E654D6178436F6C756D6E286E2D3129293A743B636F6E7374206F3D652E676574';
wwv_flow_imp.g_varchar2_table(8635) := '4C696E65436F6E74656E74286E293B666F72286C657420653D742E636F6C756D6E2D313B653E313B652D2D297B636F6E737420743D6F2E63686172436F6465417428652D32292C733D6F2E63686172436F6465417428652D31293B69662839353D3D3D74';
wwv_flow_imp.g_varchar2_table(8636) := '26263935213D3D732972657475726E206E6577206D63286E2C65293B69662834353D3D3D7426263435213D3D732972657475726E206E6577206D63286E2C65293B6966282853692874297C7C436928742929262678692873292972657475726E206E6577';
wwv_flow_imp.g_varchar2_table(8637) := '206D63286E2C65293B6966287869287429262678692873292626652B313C69297B636F6E737420743D6F2E63686172436F646541742865293B69662853692874297C7C43692874292972657475726E206E6577206D63286E2C65297D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(8638) := '6E6577206D63286E2C31297D737461746963206D6F7665576F7264526967687428652C742C6E2C69297B6C6574206F3D6E2E6C696E654E756D6265722C733D6E2E636F6C756D6E2C723D21313B733D3D3D742E6765744C696E654D6178436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(8639) := '6F2926266F3C742E6765744C696E65436F756E742829262628723D21302C6F2B3D312C733D31293B6C657420613D68532E5F66696E644E657874576F72644F6E4C696E6528652C742C6E6577206D63286F2C7329293B696628323D3D3D6929612626323D';
wwv_flow_imp.g_varchar2_table(8640) := '3D3D612E776F7264547970652626612E656E642D612E73746172743D3D312626303D3D3D612E6E65787443686172436C617373262628613D68532E5F66696E644E657874576F72644F6E4C696E6528652C742C6E6577206D63286F2C612E656E642B3129';
wwv_flow_imp.g_varchar2_table(8641) := '29292C733D613F612E656E642B313A742E6765744C696E654D6178436F6C756D6E286F293B656C736520696628333D3D3D69297B666F722872262628733D30293B61262628323D3D3D612E776F7264547970657C7C612E73746172742B313C3D73293B29';
wwv_flow_imp.g_varchar2_table(8642) := '613D68532E5F66696E644E657874576F72644F6E4C696E6528652C742C6E6577206D63286F2C612E656E642B3129293B733D613F612E73746172742B313A742E6765744C696E654D6178436F6C756D6E286F297D656C73652061262621722626733E3D61';
wwv_flow_imp.g_varchar2_table(8643) := '2E73746172742B31262628613D68532E5F66696E644E657874576F72644F6E4C696E6528652C742C6E6577206D63286F2C612E656E642B312929292C733D613F612E73746172742B313A742E6765744C696E654D6178436F6C756D6E286F293B72657475';
wwv_flow_imp.g_varchar2_table(8644) := '726E206E6577206D63286F2C73297D737461746963205F6D6F7665576F726450617274526967687428652C74297B636F6E7374206E3D742E6C696E654E756D6265722C693D652E6765744C696E654D6178436F6C756D6E286E293B696628742E636F6C75';
wwv_flow_imp.g_varchar2_table(8645) := '6D6E3D3D3D692972657475726E206E3C652E6765744C696E65436F756E7428293F6E6577206D63286E2B312C31293A743B636F6E7374206F3D652E6765744C696E65436F6E74656E74286E293B666F72286C657420653D742E636F6C756D6E2B313B653C';
wwv_flow_imp.g_varchar2_table(8646) := '693B652B2B297B636F6E737420743D6F2E63686172436F6465417428652D32292C733D6F2E63686172436F6465417428652D31293B6966283935213D3D74262639353D3D3D732972657475726E206E6577206D63286E2C65293B6966283435213D3D7426';
wwv_flow_imp.g_varchar2_table(8647) := '2634353D3D3D732972657475726E206E6577206D63286E2C65293B6966282853692874297C7C436928742929262678692873292972657475726E206E6577206D63286E2C65293B6966287869287429262678692873292626652B313C69297B636F6E7374';
wwv_flow_imp.g_varchar2_table(8648) := '20743D6F2E63686172436F646541742865293B69662853692874297C7C43692874292972657475726E206E6577206D63286E2C65297D7D72657475726E206E6577206D63286E2C69297D737461746963205F64656C657465576F72644C65667457686974';
wwv_flow_imp.g_varchar2_table(8649) := '65737061636528652C74297B636F6E7374206E3D652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C693D742E636F6C756D6E2D322C6F3D7669286E2C69293B72657475726E206F2B313C693F6E657720726828742E6C696E65';
wwv_flow_imp.g_varchar2_table(8650) := '4E756D6265722C6F2B322C742E6C696E654E756D6265722C742E636F6C756D6E293A6E756C6C7D7374617469632064656C657465576F72644C65667428652C74297B636F6E7374206E3D652E776F7264536570617261746F72732C693D652E6D6F64656C';
wwv_flow_imp.g_varchar2_table(8651) := '2C6F3D652E73656C656374696F6E2C733D652E77686974657370616365486575726973746963733B696628216F2E6973456D70747928292972657475726E206F3B69662864532E69734175746F436C6F73696E675061697244656C65746528652E617574';
wwv_flow_imp.g_varchar2_table(8652) := '6F436C6F73696E6744656C6574652C652E6175746F436C6F73696E67427261636B6574732C652E6175746F436C6F73696E6751756F7465732C652E6175746F436C6F73696E6750616972732E6175746F436C6F73696E6750616972734F70656E4279456E';
wwv_flow_imp.g_varchar2_table(8653) := '642C652E6D6F64656C2C5B652E73656C656374696F6E5D2C652E6175746F436C6F7365644368617261637465727329297B636F6E737420743D652E73656C656374696F6E2E676574506F736974696F6E28293B72657475726E206E657720726828742E6C';
wwv_flow_imp.g_varchar2_table(8654) := '696E654E756D6265722C742E636F6C756D6E2D312C742E6C696E654E756D6265722C742E636F6C756D6E2B31297D636F6E737420723D6E6577206D63286F2E706F736974696F6E4C696E654E756D6265722C6F2E706F736974696F6E436F6C756D6E293B';
wwv_flow_imp.g_varchar2_table(8655) := '6C657420613D722E6C696E654E756D6265722C6C3D722E636F6C756D6E3B696628313D3D3D612626313D3D3D6C2972657475726E206E756C6C3B69662873297B636F6E737420653D746869732E5F64656C657465576F72644C6566745768697465737061';
wwv_flow_imp.g_varchar2_table(8656) := '636528692C72293B696628652972657475726E20657D6C657420633D68532E5F66696E6450726576696F7573576F72644F6E4C696E65286E2C692C72293B72657475726E20303D3D3D743F633F6C3D632E73746172742B313A6C3E313F6C3D313A28612D';
wwv_flow_imp.g_varchar2_table(8657) := '2D2C6C3D692E6765744C696E654D6178436F6C756D6E286129293A286326266C3C3D632E656E642B31262628633D68532E5F66696E6450726576696F7573576F72644F6E4C696E65286E2C692C6E6577206D6328612C632E73746172742B312929292C63';
wwv_flow_imp.g_varchar2_table(8658) := '3F6C3D632E656E642B313A6C3E313F6C3D313A28612D2D2C6C3D692E6765744C696E654D6178436F6C756D6E28612929292C6E657720726828612C6C2C722E6C696E654E756D6265722C722E636F6C756D6E297D7374617469632064656C657465496E73';
wwv_flow_imp.g_varchar2_table(8659) := '696465576F726428652C742C6E297B696628216E2E6973456D70747928292972657475726E206E3B636F6E737420693D6E6577206D63286E2E706F736974696F6E4C696E654E756D6265722C6E2E706F736974696F6E436F6C756D6E293B72657475726E';
wwv_flow_imp.g_varchar2_table(8660) := '20746869732E5F64656C657465496E73696465576F72645768697465737061636528742C69297C7C746869732E5F64656C657465496E73696465576F726444657465726D696E6544656C65746552616E676528652C742C69297D737461746963205F6368';
wwv_flow_imp.g_varchar2_table(8661) := '6172417449735768697465737061636528652C74297B636F6E7374206E3D652E63686172436F646541742874293B72657475726E2033323D3D3D6E7C7C393D3D3D6E7D737461746963205F64656C657465496E73696465576F7264576869746573706163';
wwv_flow_imp.g_varchar2_table(8662) := '6528652C74297B636F6E7374206E3D652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C693D6E2E6C656E6774683B696628303D3D3D692972657475726E206E756C6C3B6C6574206F3D4D6174682E6D617828742E636F6C756D';
wwv_flow_imp.g_varchar2_table(8663) := '6E2D322C30293B69662821746869732E5F636861724174497357686974657370616365286E2C6F292972657475726E206E756C6C3B6C657420733D4D6174682E6D696E28742E636F6C756D6E2D312C692D31293B69662821746869732E5F636861724174';
wwv_flow_imp.g_varchar2_table(8664) := '497357686974657370616365286E2C73292972657475726E206E756C6C3B666F72283B6F3E302626746869732E5F636861724174497357686974657370616365286E2C6F2D31293B296F2D2D3B666F72283B732B313C692626746869732E5F6368617241';
wwv_flow_imp.g_varchar2_table(8665) := '74497357686974657370616365286E2C732B31293B29732B2B3B72657475726E206E657720726828742E6C696E654E756D6265722C6F2B312C742E6C696E654E756D6265722C732B32297D737461746963205F64656C657465496E73696465576F726444';
wwv_flow_imp.g_varchar2_table(8666) := '657465726D696E6544656C65746552616E676528652C742C6E297B636F6E737420693D742E6765744C696E65436F6E74656E74286E2E6C696E654E756D626572292C6F3D692E6C656E6774683B696628303D3D3D6F2972657475726E206E2E6C696E654E';
wwv_flow_imp.g_varchar2_table(8667) := '756D6265723E313F6E6577207268286E2E6C696E654E756D6265722D312C742E6765744C696E654D6178436F6C756D6E286E2E6C696E654E756D6265722D31292C6E2E6C696E654E756D6265722C31293A6E2E6C696E654E756D6265723C742E6765744C';
wwv_flow_imp.g_varchar2_table(8668) := '696E65436F756E7428293F6E6577207268286E2E6C696E654E756D6265722C312C6E2E6C696E654E756D6265722B312C31293A6E6577207268286E2E6C696E654E756D6265722C312C6E2E6C696E654E756D6265722C31293B636F6E737420733D653D3E';
wwv_flow_imp.g_varchar2_table(8669) := '652E73746172742B313C3D6E2E636F6C756D6E26266E2E636F6C756D6E3C3D652E656E642B312C723D28652C74293D3E28653D4D6174682E6D696E28652C6E2E636F6C756D6E292C743D4D6174682E6D617828742C6E2E636F6C756D6E292C6E65772072';
wwv_flow_imp.g_varchar2_table(8670) := '68286E2E6C696E654E756D6265722C652C6E2E6C696E654E756D6265722C7429292C613D653D3E7B6C657420743D652E73746172742B312C6E3D652E656E642B312C733D21313B666F72283B6E2D313C6F2626746869732E5F6368617241744973576869';
wwv_flow_imp.g_varchar2_table(8671) := '7465737061636528692C6E2D31293B29733D21302C6E2B2B3B696628217329666F72283B743E312626746869732E5F63686172417449735768697465737061636528692C742D32293B29742D2D3B72657475726E207228742C6E297D2C6C3D68532E5F66';
wwv_flow_imp.g_varchar2_table(8672) := '696E6450726576696F7573576F72644F6E4C696E6528652C742C6E293B6966286C262673286C292972657475726E2061286C293B636F6E737420633D68532E5F66696E644E657874576F72644F6E4C696E6528652C742C6E293B72657475726E20632626';
wwv_flow_imp.g_varchar2_table(8673) := '732863293F612863293A6C2626633F72286C2E656E642B312C632E73746172742B31293A6C3F72286C2E73746172742B312C6C2E656E642B31293A633F7228632E73746172742B312C632E656E642B31293A7228312C6F2B31297D737461746963205F64';
wwv_flow_imp.g_varchar2_table(8674) := '656C657465576F7264506172744C65667428652C74297B69662821742E6973456D70747928292972657475726E20743B636F6E7374206E3D742E676574506F736974696F6E28292C693D68532E5F6D6F7665576F7264506172744C65667428652C6E293B';
wwv_flow_imp.g_varchar2_table(8675) := '72657475726E206E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C692E6C696E654E756D6265722C692E636F6C756D6E297D737461746963205F66696E6446697273744E6F6E576869746573706163654368617228652C74297B63';
wwv_flow_imp.g_varchar2_table(8676) := '6F6E7374206E3D652E6C656E6774683B666F72286C657420693D743B693C6E3B692B2B297B636F6E737420743D652E6368617241742869293B696628222022213D3D742626225C7422213D3D742972657475726E20697D72657475726E206E7D73746174';
wwv_flow_imp.g_varchar2_table(8677) := '6963205F64656C657465576F726452696768745768697465737061636528652C74297B636F6E7374206E3D652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C693D742E636F6C756D6E2D312C6F3D746869732E5F66696E6446';
wwv_flow_imp.g_varchar2_table(8678) := '697273744E6F6E5768697465737061636543686172286E2C69293B72657475726E20692B313C6F3F6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C742E6C696E654E756D6265722C6F2B31293A6E756C6C7D7374617469632064';
wwv_flow_imp.g_varchar2_table(8679) := '656C657465576F7264526967687428652C74297B636F6E7374206E3D652E776F7264536570617261746F72732C693D652E6D6F64656C2C6F3D652E73656C656374696F6E2C733D652E77686974657370616365486575726973746963733B696628216F2E';
wwv_flow_imp.g_varchar2_table(8680) := '6973456D70747928292972657475726E206F3B636F6E737420723D6E6577206D63286F2E706F736974696F6E4C696E654E756D6265722C6F2E706F736974696F6E436F6C756D6E293B6C657420613D722E6C696E654E756D6265722C6C3D722E636F6C75';
wwv_flow_imp.g_varchar2_table(8681) := '6D6E3B636F6E737420633D692E6765744C696E65436F756E7428292C643D692E6765744C696E654D6178436F6C756D6E2861293B696628613D3D3D6326266C3D3D3D642972657475726E206E756C6C3B69662873297B636F6E737420653D746869732E5F';
wwv_flow_imp.g_varchar2_table(8682) := '64656C657465576F726452696768745768697465737061636528692C72293B696628652972657475726E20657D6C657420683D68532E5F66696E644E657874576F72644F6E4C696E65286E2C692C72293B72657475726E20323D3D3D743F683F6C3D682E';
wwv_flow_imp.g_varchar2_table(8683) := '656E642B313A6C3C647C7C613D3D3D633F6C3D643A28612B2B2C683D68532E5F66696E644E657874576F72644F6E4C696E65286E2C692C6E6577206D6328612C3129292C6C3D683F682E73746172742B313A692E6765744C696E654D6178436F6C756D6E';
wwv_flow_imp.g_varchar2_table(8684) := '286129293A286826266C3E3D682E73746172742B31262628683D68532E5F66696E644E657874576F72644F6E4C696E65286E2C692C6E6577206D6328612C682E656E642B312929292C683F6C3D682E73746172742B313A6C3C647C7C613D3D3D633F6C3D';
wwv_flow_imp.g_varchar2_table(8685) := '643A28612B2B2C683D68532E5F66696E644E657874576F72644F6E4C696E65286E2C692C6E6577206D6328612C3129292C6C3D683F682E73746172742B313A692E6765744C696E654D6178436F6C756D6E28612929292C6E657720726828612C6C2C722E';
wwv_flow_imp.g_varchar2_table(8686) := '6C696E654E756D6265722C722E636F6C756D6E297D737461746963205F64656C657465576F726450617274526967687428652C74297B69662821742E6973456D70747928292972657475726E20743B636F6E7374206E3D742E676574506F736974696F6E';
wwv_flow_imp.g_varchar2_table(8687) := '28292C693D68532E5F6D6F7665576F726450617274526967687428652C6E293B72657475726E206E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C692E6C696E654E756D6265722C692E636F6C756D6E297D737461746963205F63';
wwv_flow_imp.g_varchar2_table(8688) := '7265617465576F72644174506F736974696F6E28652C742C6E297B636F6E737420693D6E657720726828742C6E2E73746172742B312C742C6E2E656E642B31293B72657475726E7B776F72643A652E67657456616C7565496E52616E67652869292C7374';
wwv_flow_imp.g_varchar2_table(8689) := '617274436F6C756D6E3A692E7374617274436F6C756D6E2C656E64436F6C756D6E3A692E656E64436F6C756D6E7D7D73746174696320676574576F72644174506F736974696F6E28652C742C6E2C69297B636F6E7374206F3D597928742C6E292C733D68';
wwv_flow_imp.g_varchar2_table(8690) := '532E5F66696E6450726576696F7573576F72644F6E4C696E65286F2C652C69293B696628732626313D3D3D732E776F7264547970652626732E73746172743C3D692E636F6C756D6E2D312626692E636F6C756D6E2D313C3D732E656E642972657475726E';
wwv_flow_imp.g_varchar2_table(8691) := '2068532E5F637265617465576F72644174506F736974696F6E28652C692E6C696E654E756D6265722C73293B636F6E737420723D68532E5F66696E644E657874576F72644F6E4C696E65286F2C652C69293B72657475726E20722626313D3D3D722E776F';
wwv_flow_imp.g_varchar2_table(8692) := '7264547970652626722E73746172743C3D692E636F6C756D6E2D312626692E636F6C756D6E2D313C3D722E656E643F68532E5F637265617465576F72644174506F736974696F6E28652C692E6C696E654E756D6265722C72293A6E756C6C7D7374617469';
wwv_flow_imp.g_varchar2_table(8693) := '6320776F726428652C742C6E2C692C6F297B636F6E737420733D597928652E776F7264536570617261746F72732C652E776F72645365676D656E7465724C6F63616C6573292C723D68532E5F66696E6450726576696F7573576F72644F6E4C696E652873';
wwv_flow_imp.g_varchar2_table(8694) := '2C742C6F292C613D68532E5F66696E644E657874576F72644F6E4C696E6528732C742C6F293B6966282169297B6C657420652C6E3B72657475726E20722626313D3D3D722E776F7264547970652626722E73746172743C3D6F2E636F6C756D6E2D312626';
wwv_flow_imp.g_varchar2_table(8695) := '6F2E636F6C756D6E2D313C3D722E656E643F28653D722E73746172742B312C6E3D722E656E642B31293A612626313D3D3D612E776F7264547970652626612E73746172743C3D6F2E636F6C756D6E2D3126266F2E636F6C756D6E2D313C3D612E656E643F';
wwv_flow_imp.g_varchar2_table(8696) := '28653D612E73746172742B312C6E3D612E656E642B31293A28653D723F722E656E642B313A312C6E3D613F612E73746172742B313A742E6765744C696E654D6178436F6C756D6E286F2E6C696E654E756D62657229292C6E6577205843286E6577207268';
wwv_flow_imp.g_varchar2_table(8697) := '286F2E6C696E654E756D6265722C652C6F2E6C696E654E756D6265722C6E292C312C302C6E6577206D63286F2E6C696E654E756D6265722C6E292C30297D6C6574206C2C633B722626313D3D3D722E776F7264547970652626722E73746172743C6F2E63';
wwv_flow_imp.g_varchar2_table(8698) := '6F6C756D6E2D3126266F2E636F6C756D6E2D313C722E656E643F286C3D722E73746172742B312C633D722E656E642B31293A612626313D3D3D612E776F7264547970652626612E73746172743C6F2E636F6C756D6E2D3126266F2E636F6C756D6E2D313C';
wwv_flow_imp.g_varchar2_table(8699) := '612E656E643F286C3D612E73746172742B312C633D612E656E642B31293A286C3D6F2E636F6C756D6E2C633D6F2E636F6C756D6E293B636F6E737420643D6F2E6C696E654E756D6265723B6C657420683B6966286E2E73656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(8700) := '2E636F6E7461696E73506F736974696F6E286F2929683D6E2E73656C656374696F6E53746172742E656E64436F6C756D6E3B656C7365206966286F2E69734265666F72654F72457175616C286E2E73656C656374696F6E53746172742E67657453746172';
wwv_flow_imp.g_varchar2_table(8701) := '74506F736974696F6E282929297B683D6C3B636F6E737420653D6E6577206D6328642C68293B6E2E73656C656374696F6E53746172742E636F6E7461696E73506F736974696F6E286529262628683D6E2E73656C656374696F6E53746172742E656E6443';
wwv_flow_imp.g_varchar2_table(8702) := '6F6C756D6E297D656C73657B683D633B636F6E737420653D6E6577206D6328642C68293B6E2E73656C656374696F6E53746172742E636F6E7461696E73506F736974696F6E286529262628683D6E2E73656C656374696F6E53746172742E737461727443';
wwv_flow_imp.g_varchar2_table(8703) := '6F6C756D6E297D72657475726E206E2E6D6F76652821302C642C682C30297D7D636C61737320755320657874656E64732068537B7374617469632064656C657465576F7264506172744C6566742865297B636F6E737420743D7053285B68532E64656C65';
wwv_flow_imp.g_varchar2_table(8704) := '7465576F72644C65667428652C30292C68532E64656C657465576F72644C65667428652C32292C68532E5F64656C657465576F7264506172744C65667428652E6D6F64656C2C652E73656C656374696F6E295D293B72657475726E20742E736F72742872';
wwv_flow_imp.g_varchar2_table(8705) := '682E636F6D7061726552616E6765735573696E67456E6473292C745B325D7D7374617469632064656C657465576F72645061727452696768742865297B636F6E737420743D7053285B68532E64656C657465576F7264526967687428652C30292C68532E';
wwv_flow_imp.g_varchar2_table(8706) := '64656C657465576F7264526967687428652C32292C68532E5F64656C657465576F726450617274526967687428652E6D6F64656C2C652E73656C656374696F6E295D293B72657475726E20742E736F72742872682E636F6D7061726552616E6765735573';
wwv_flow_imp.g_varchar2_table(8707) := '696E67537461727473292C745B305D7D737461746963206D6F7665576F7264506172744C65667428652C742C6E297B636F6E737420693D7053285B68532E6D6F7665576F72644C65667428652C742C6E2C30292C68532E6D6F7665576F72644C65667428';
wwv_flow_imp.g_varchar2_table(8708) := '652C742C6E2C32292C68532E5F6D6F7665576F7264506172744C65667428742C6E295D293B72657475726E20692E736F7274286D632E636F6D70617265292C695B325D7D737461746963206D6F7665576F726450617274526967687428652C742C6E297B';
wwv_flow_imp.g_varchar2_table(8709) := '636F6E737420693D7053285B68532E6D6F7665576F7264526967687428652C742C6E2C30292C68532E6D6F7665576F7264526967687428652C742C6E2C32292C68532E5F6D6F7665576F726450617274526967687428742C6E295D293B72657475726E20';
wwv_flow_imp.g_varchar2_table(8710) := '692E736F7274286D632E636F6D70617265292C695B305D7D7D66756E6374696F6E2070532865297B72657475726E20652E66696C7465722828653D3E426F6F6C65616E28652929297D636C6173732067537B73746174696320616464437572736F72446F';
wwv_flow_imp.g_varchar2_table(8711) := '776E28652C742C6E297B636F6E737420693D5B5D3B6C6574206F3D303B666F72286C657420733D302C723D742E6C656E6774683B733C723B732B2B297B636F6E737420723D745B735D3B695B6F2B2B5D3D6E657720514328722E6D6F64656C5374617465';
wwv_flow_imp.g_varchar2_table(8712) := '2C722E766965775374617465292C695B6F2B2B5D3D6E3F51432E66726F6D4D6F64656C53746174652863532E7472616E736C617465446F776E28652E637572736F72436F6E6669672C652E6D6F64656C2C722E6D6F64656C537461746529293A51432E66';
wwv_flow_imp.g_varchar2_table(8713) := '726F6D5669657753746174652863532E7472616E736C617465446F776E28652E637572736F72436F6E6669672C652C722E76696577537461746529297D72657475726E20697D73746174696320616464437572736F72557028652C742C6E297B636F6E73';
wwv_flow_imp.g_varchar2_table(8714) := '7420693D5B5D3B6C6574206F3D303B666F72286C657420733D302C723D742E6C656E6774683B733C723B732B2B297B636F6E737420723D745B735D3B695B6F2B2B5D3D6E657720514328722E6D6F64656C53746174652C722E766965775374617465292C';
wwv_flow_imp.g_varchar2_table(8715) := '695B6F2B2B5D3D6E3F51432E66726F6D4D6F64656C53746174652863532E7472616E736C617465557028652E637572736F72436F6E6669672C652E6D6F64656C2C722E6D6F64656C537461746529293A51432E66726F6D5669657753746174652863532E';
wwv_flow_imp.g_varchar2_table(8716) := '7472616E736C617465557028652E637572736F72436F6E6669672C652C722E76696577537461746529297D72657475726E20697D737461746963206D6F7665546F426567696E6E696E674F664C696E6528652C742C6E297B636F6E737420693D5B5D3B66';
wwv_flow_imp.g_varchar2_table(8717) := '6F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D3B695B6F5D3D746869732E5F6D6F7665546F4C696E65537461727428652C732C6E297D72657475726E20697D737461746963205F6D6F766554';
wwv_flow_imp.g_varchar2_table(8718) := '6F4C696E65537461727428652C742C6E297B636F6E737420693D742E7669657753746174652E706F736974696F6E2E636F6C756D6E2C6F3D693D3D3D742E6D6F64656C53746174652E706F736974696F6E2E636F6C756D6E2C733D742E76696577537461';
wwv_flow_imp.g_varchar2_table(8719) := '74652E706F736974696F6E2E6C696E654E756D6265722C723D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2873293B72657475726E206F7C7C693D3D3D723F746869732E5F6D6F7665546F4C696E65537461727442';
wwv_flow_imp.g_varchar2_table(8720) := '794D6F64656C28652C742C6E293A746869732E5F6D6F7665546F4C696E65537461727442795669657728652C742C6E297D737461746963205F6D6F7665546F4C696E65537461727442795669657728652C742C6E297B72657475726E2051432E66726F6D';
wwv_flow_imp.g_varchar2_table(8721) := '5669657753746174652863532E6D6F7665546F426567696E6E696E674F664C696E6528652E637572736F72436F6E6669672C652C742E7669657753746174652C6E29297D737461746963205F6D6F7665546F4C696E65537461727442794D6F64656C2865';
wwv_flow_imp.g_varchar2_table(8722) := '2C742C6E297B72657475726E2051432E66726F6D4D6F64656C53746174652863532E6D6F7665546F426567696E6E696E674F664C696E6528652E637572736F72436F6E6669672C652E6D6F64656C2C742E6D6F64656C53746174652C6E29297D73746174';
wwv_flow_imp.g_varchar2_table(8723) := '6963206D6F7665546F456E644F664C696E6528652C742C6E2C69297B636F6E7374206F3D5B5D3B666F72286C657420733D302C723D742E6C656E6774683B733C723B732B2B297B636F6E737420723D745B735D3B6F5B735D3D746869732E5F6D6F766554';
wwv_flow_imp.g_varchar2_table(8724) := '6F4C696E65456E6428652C722C6E2C69297D72657475726E206F7D737461746963205F6D6F7665546F4C696E65456E6428652C742C6E2C69297B636F6E7374206F3D742E7669657753746174652E706F736974696F6E2C733D652E6765744C696E654D61';
wwv_flow_imp.g_varchar2_table(8725) := '78436F6C756D6E286F2E6C696E654E756D626572292C723D6F2E636F6C756D6E3D3D3D732C613D742E6D6F64656C53746174652E706F736974696F6E2C6C3D652E6D6F64656C2E6765744C696E654D6178436F6C756D6E28612E6C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(8726) := '292C633D732D6F2E636F6C756D6E3D3D6C2D612E636F6C756D6E3B72657475726E20727C7C633F746869732E5F6D6F7665546F4C696E65456E6442794D6F64656C28652C742C6E2C69293A746869732E5F6D6F7665546F4C696E65456E64427956696577';
wwv_flow_imp.g_varchar2_table(8727) := '28652C742C6E2C69297D737461746963205F6D6F7665546F4C696E65456E6442795669657728652C742C6E2C69297B72657475726E2051432E66726F6D5669657753746174652863532E6D6F7665546F456E644F664C696E6528652E637572736F72436F';
wwv_flow_imp.g_varchar2_table(8728) := '6E6669672C652C742E7669657753746174652C6E2C6929297D737461746963205F6D6F7665546F4C696E65456E6442794D6F64656C28652C742C6E2C69297B72657475726E2051432E66726F6D4D6F64656C53746174652863532E6D6F7665546F456E64';
wwv_flow_imp.g_varchar2_table(8729) := '4F664C696E6528652E637572736F72436F6E6669672C652E6D6F64656C2C742E6D6F64656C53746174652C6E2C6929297D73746174696320657870616E644C696E6553656C656374696F6E28652C74297B636F6E7374206E3D5B5D3B666F72286C657420';
wwv_flow_imp.g_varchar2_table(8730) := '693D302C6F3D742E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D745B695D2C733D6F2E6D6F64656C53746174652E73656C656374696F6E2E73746172744C696E654E756D6265722C723D652E6D6F64656C2E6765744C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(8731) := '28293B6C657420612C6C3D6F2E6D6F64656C53746174652E73656C656374696F6E2E656E644C696E654E756D6265723B6C3D3D3D723F613D652E6D6F64656C2E6765744C696E654D6178436F6C756D6E2872293A286C2B2B2C613D31292C6E5B695D3D51';
wwv_flow_imp.g_varchar2_table(8732) := '432E66726F6D4D6F64656C5374617465286E6577205843286E657720726828732C312C732C31292C302C302C6E6577206D63286C2C61292C3029297D72657475726E206E7D737461746963206D6F7665546F426567696E6E696E674F6642756666657228';
wwv_flow_imp.g_varchar2_table(8733) := '652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D3B695B6F5D3D51432E66726F6D4D6F64656C53746174652863532E6D6F7665546F426567696E';
wwv_flow_imp.g_varchar2_table(8734) := '6E696E674F6642756666657228652E637572736F72436F6E6669672C652E6D6F64656C2C732E6D6F64656C53746174652C6E29297D72657475726E20697D737461746963206D6F7665546F456E644F6642756666657228652C742C6E297B636F6E737420';
wwv_flow_imp.g_varchar2_table(8735) := '693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D3B695B6F5D3D51432E66726F6D4D6F64656C53746174652863532E6D6F7665546F456E644F6642756666657228652E63757273';
wwv_flow_imp.g_varchar2_table(8736) := '6F72436F6E6669672C652E6D6F64656C2C732E6D6F64656C53746174652C6E29297D72657475726E20697D7374617469632073656C656374416C6C28652C74297B636F6E7374206E3D652E6D6F64656C2E6765744C696E65436F756E7428292C693D652E';
wwv_flow_imp.g_varchar2_table(8737) := '6D6F64656C2E6765744C696E654D6178436F6C756D6E286E293B72657475726E2051432E66726F6D4D6F64656C5374617465286E6577205843286E657720726828312C312C312C31292C302C302C6E6577206D63286E2C69292C3029297D737461746963';
wwv_flow_imp.g_varchar2_table(8738) := '206C696E6528652C742C6E2C692C6F297B636F6E737420733D652E6D6F64656C2E76616C6964617465506F736974696F6E2869292C723D6F3F652E636F6F7264696E61746573436F6E7665727465722E76616C696461746556696577506F736974696F6E';
wwv_flow_imp.g_varchar2_table(8739) := '286E6577206D63286F2E6C696E654E756D6265722C6F2E636F6C756D6E292C73293A652E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E2873293B696628216E';
wwv_flow_imp.g_varchar2_table(8740) := '297B636F6E737420743D652E6D6F64656C2E6765744C696E65436F756E7428293B6C6574206E3D732E6C696E654E756D6265722B312C693D313B72657475726E206E3E742626286E3D742C693D652E6D6F64656C2E6765744C696E654D6178436F6C756D';
wwv_flow_imp.g_varchar2_table(8741) := '6E286E29292C51432E66726F6D4D6F64656C5374617465286E6577205843286E657720726828732E6C696E654E756D6265722C312C6E2C69292C322C302C6E6577206D63286E2C69292C3029297D636F6E737420613D742E6D6F64656C53746174652E73';
wwv_flow_imp.g_varchar2_table(8742) := '656C656374696F6E53746172742E6765745374617274506F736974696F6E28292E6C696E654E756D6265723B696628732E6C696E654E756D6265723C612972657475726E2051432E66726F6D56696577537461746528742E7669657753746174652E6D6F';
wwv_flow_imp.g_varchar2_table(8743) := '76652821302C722E6C696E654E756D6265722C312C3029293B696628732E6C696E654E756D6265723E61297B636F6E7374206E3D652E6765744C696E65436F756E7428293B6C657420693D722E6C696E654E756D6265722B312C6F3D313B72657475726E';
wwv_flow_imp.g_varchar2_table(8744) := '20693E6E262628693D6E2C6F3D652E6765744C696E654D6178436F6C756D6E286929292C51432E66726F6D56696577537461746528742E7669657753746174652E6D6F76652821302C692C6F2C3029297D7B636F6E737420653D742E6D6F64656C537461';
wwv_flow_imp.g_varchar2_table(8745) := '74652E73656C656374696F6E53746172742E676574456E64506F736974696F6E28293B72657475726E2051432E66726F6D4D6F64656C537461746528742E6D6F64656C53746174652E6D6F76652821302C652E6C696E654E756D6265722C652E636F6C75';
wwv_flow_imp.g_varchar2_table(8746) := '6D6E2C3029297D7D73746174696320776F726428652C742C6E2C69297B636F6E7374206F3D652E6D6F64656C2E76616C6964617465506F736974696F6E2869293B72657475726E2051432E66726F6D4D6F64656C53746174652868532E776F726428652E';
wwv_flow_imp.g_varchar2_table(8747) := '637572736F72436F6E6669672C652E6D6F64656C2C742E6D6F64656C53746174652C6E2C6F29297D7374617469632063616E63656C53656C656374696F6E28652C74297B69662821742E6D6F64656C53746174652E68617353656C656374696F6E282929';
wwv_flow_imp.g_varchar2_table(8748) := '72657475726E206E657720514328742E6D6F64656C53746174652C742E766965775374617465293B636F6E7374206E3D742E7669657753746174652E706F736974696F6E2E6C696E654E756D6265722C693D742E7669657753746174652E706F73697469';
wwv_flow_imp.g_varchar2_table(8749) := '6F6E2E636F6C756D6E3B72657475726E2051432E66726F6D566965775374617465286E6577205843286E6577207268286E2C692C6E2C69292C302C302C6E6577206D63286E2C69292C3029297D737461746963206D6F7665546F28652C742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(8750) := '297B6966286E297B696628313D3D3D742E6D6F64656C53746174652E73656C656374696F6E53746172744B696E642972657475726E20746869732E776F726428652C742C6E2C69293B696628323D3D3D742E6D6F64656C53746174652E73656C65637469';
wwv_flow_imp.g_varchar2_table(8751) := '6F6E53746172744B696E642972657475726E20746869732E6C696E6528652C742C6E2C692C6F297D636F6E737420733D652E6D6F64656C2E76616C6964617465506F736974696F6E2869292C723D6F3F652E636F6F7264696E61746573436F6E76657274';
wwv_flow_imp.g_varchar2_table(8752) := '65722E76616C696461746556696577506F736974696F6E286E6577206D63286F2E6C696E654E756D6265722C6F2E636F6C756D6E292C73293A652E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E';
wwv_flow_imp.g_varchar2_table(8753) := '546F56696577506F736974696F6E2873293B72657475726E2051432E66726F6D56696577537461746528742E7669657753746174652E6D6F7665286E2C722E6C696E654E756D6265722C722E636F6C756D6E2C3029297D7374617469632073696D706C65';
wwv_flow_imp.g_varchar2_table(8754) := '4D6F766528652C742C6E2C692C6F2C73297B737769746368286E297B6361736520303A72657475726E20343D3D3D733F746869732E5F6D6F766548616C664C696E654C65667428652C742C69293A746869732E5F6D6F76654C65667428652C742C692C6F';
wwv_flow_imp.g_varchar2_table(8755) := '293B6361736520313A72657475726E20343D3D3D733F746869732E5F6D6F766548616C664C696E65526967687428652C742C69293A746869732E5F6D6F7665526967687428652C742C692C6F293B6361736520323A72657475726E20323D3D3D733F7468';
wwv_flow_imp.g_varchar2_table(8756) := '69732E5F6D6F766555704279566965774C696E657328652C742C692C6F293A746869732E5F6D6F7665557042794D6F64656C4C696E657328652C742C692C6F293B6361736520333A72657475726E20323D3D3D733F746869732E5F6D6F7665446F776E42';
wwv_flow_imp.g_varchar2_table(8757) := '79566965774C696E657328652C742C692C6F293A746869732E5F6D6F7665446F776E42794D6F64656C4C696E657328652C742C692C6F293B6361736520343A72657475726E20323D3D3D733F742E6D61702828743D3E51432E66726F6D56696577537461';
wwv_flow_imp.g_varchar2_table(8758) := '74652863532E6D6F7665546F50726576426C616E6B4C696E6528652E637572736F72436F6E6669672C652C742E7669657753746174652C69292929293A742E6D61702828743D3E51432E66726F6D4D6F64656C53746174652863532E6D6F7665546F5072';
wwv_flow_imp.g_varchar2_table(8759) := '6576426C616E6B4C696E6528652E637572736F72436F6E6669672C652E6D6F64656C2C742E6D6F64656C53746174652C69292929293B6361736520353A72657475726E20323D3D3D733F742E6D61702828743D3E51432E66726F6D566965775374617465';
wwv_flow_imp.g_varchar2_table(8760) := '2863532E6D6F7665546F4E657874426C616E6B4C696E6528652E637572736F72436F6E6669672C652C742E7669657753746174652C69292929293A742E6D61702828743D3E51432E66726F6D4D6F64656C53746174652863532E6D6F7665546F4E657874';
wwv_flow_imp.g_varchar2_table(8761) := '426C616E6B4C696E6528652E637572736F72436F6E6669672C652E6D6F64656C2C742E6D6F64656C53746174652C69292929293B6361736520363A72657475726E20746869732E5F6D6F7665546F566965774D696E436F6C756D6E28652C742C69293B63';
wwv_flow_imp.g_varchar2_table(8762) := '61736520373A72657475726E20746869732E5F6D6F7665546F5669657746697273744E6F6E57686974657370616365436F6C756D6E28652C742C69293B6361736520383A72657475726E20746869732E5F6D6F7665546F5669657743656E746572436F6C';
wwv_flow_imp.g_varchar2_table(8763) := '756D6E28652C742C69293B6361736520393A72657475726E20746869732E5F6D6F7665546F566965774D6178436F6C756D6E28652C742C69293B636173652031303A72657475726E20746869732E5F6D6F7665546F566965774C6173744E6F6E57686974';
wwv_flow_imp.g_varchar2_table(8764) := '657370616365436F6C756D6E28652C742C69293B64656661756C743A72657475726E206E756C6C7D7D7374617469632076696577706F72744D6F766528652C742C6E2C692C6F297B636F6E737420733D652E676574436F6D706C6574656C795669736962';
wwv_flow_imp.g_varchar2_table(8765) := '6C655669657752616E676528292C723D652E636F6F7264696E61746573436F6E7665727465722E636F6E766572745669657752616E6765546F4D6F64656C52616E67652873293B737769746368286E297B636173652031313A7B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(8766) := '69732E5F66697273744C696E654E756D626572496E52616E676528652E6D6F64656C2C722C6F292C733D652E6D6F64656C2E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E286E293B72657475726E5B746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(8767) := '7665546F4D6F64656C506F736974696F6E28652C745B305D2C692C6E2C73295D7D636173652031333A7B636F6E7374206E3D746869732E5F6C6173744C696E654E756D626572496E52616E676528652E6D6F64656C2C722C6F292C733D652E6D6F64656C';
wwv_flow_imp.g_varchar2_table(8768) := '2E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E286E293B72657475726E5B746869732E5F6D6F7665546F4D6F64656C506F736974696F6E28652C745B305D2C692C6E2C73295D7D636173652031323A7B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(8769) := '3D4D6174682E726F756E642828722E73746172744C696E654E756D6265722B722E656E644C696E654E756D626572292F32292C6F3D652E6D6F64656C2E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E286E293B72657475';
wwv_flow_imp.g_varchar2_table(8770) := '726E5B746869732E5F6D6F7665546F4D6F64656C506F736974696F6E28652C745B305D2C692C6E2C6F295D7D636173652031343A7B636F6E7374206E3D5B5D3B666F72286C6574206F3D302C723D742E6C656E6774683B6F3C723B6F2B2B297B636F6E73';
wwv_flow_imp.g_varchar2_table(8771) := '7420723D745B6F5D3B6E5B6F5D3D746869732E66696E64506F736974696F6E496E56696577706F727449664F75747369646528652C722C732C69297D72657475726E206E7D64656661756C743A72657475726E206E756C6C7D7D7374617469632066696E';
wwv_flow_imp.g_varchar2_table(8772) := '64506F736974696F6E496E56696577706F727449664F75747369646528652C742C6E2C69297B636F6E7374206F3D742E7669657753746174652E706F736974696F6E2E6C696E654E756D6265723B6966286E2E73746172744C696E654E756D6265723C3D';
wwv_flow_imp.g_varchar2_table(8773) := '6F26266F3C3D6E2E656E644C696E654E756D6265722D312972657475726E206E657720514328742E6D6F64656C53746174652C742E766965775374617465293B7B6C657420733B733D6F3E6E2E656E644C696E654E756D6265722D313F6E2E656E644C69';
wwv_flow_imp.g_varchar2_table(8774) := '6E654E756D6265722D313A6F3C6E2E73746172744C696E654E756D6265723F6E2E73746172744C696E654E756D6265723A6F3B636F6E737420723D63532E766572746963616C28652E637572736F72436F6E6669672C652C6F2C742E7669657753746174';
wwv_flow_imp.g_varchar2_table(8775) := '652E706F736974696F6E2E636F6C756D6E2C742E7669657753746174652E6C6566746F76657256697369626C65436F6C756D6E732C732C2131293B72657475726E2051432E66726F6D56696577537461746528742E7669657753746174652E6D6F766528';
wwv_flow_imp.g_varchar2_table(8776) := '692C722E6C696E654E756D6265722C722E636F6C756D6E2C722E6C6566746F76657256697369626C65436F6C756D6E7329297D7D737461746963205F66697273744C696E654E756D626572496E52616E676528652C742C6E297B6C657420693D742E7374';
wwv_flow_imp.g_varchar2_table(8777) := '6172744C696E654E756D6265723B72657475726E20742E7374617274436F6C756D6E213D3D652E6765744C696E654D696E436F6C756D6E2869292626692B2B2C4D6174682E6D696E28742E656E644C696E654E756D6265722C692B6E2D31297D73746174';
wwv_flow_imp.g_varchar2_table(8778) := '6963205F6C6173744C696E654E756D626572496E52616E676528652C742C6E297B6C657420693D742E73746172744C696E654E756D6265723B72657475726E20742E7374617274436F6C756D6E213D3D652E6765744C696E654D696E436F6C756D6E2869';
wwv_flow_imp.g_varchar2_table(8779) := '292626692B2B2C4D6174682E6D617828692C742E656E644C696E654E756D6265722D6E2B31297D737461746963205F6D6F76654C65667428652C742C6E2C69297B72657475726E20742E6D61702828743D3E51432E66726F6D5669657753746174652863';
wwv_flow_imp.g_varchar2_table(8780) := '532E6D6F76654C65667428652E637572736F72436F6E6669672C652C742E7669657753746174652C6E2C69292929297D737461746963205F6D6F766548616C664C696E654C65667428652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F';
wwv_flow_imp.g_varchar2_table(8781) := '3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D732E7669657753746174652E706F736974696F6E2E6C696E654E756D6265722C613D4D6174682E726F756E6428652E6765744C696E654C656E6774682872';
wwv_flow_imp.g_varchar2_table(8782) := '292F32293B695B6F5D3D51432E66726F6D5669657753746174652863532E6D6F76654C65667428652E637572736F72436F6E6669672C652C732E7669657753746174652C6E2C6129297D72657475726E20697D737461746963205F6D6F76655269676874';
wwv_flow_imp.g_varchar2_table(8783) := '28652C742C6E2C69297B72657475726E20742E6D61702828743D3E51432E66726F6D5669657753746174652863532E6D6F7665526967687428652E637572736F72436F6E6669672C652C742E7669657753746174652C6E2C69292929297D737461746963';
wwv_flow_imp.g_varchar2_table(8784) := '205F6D6F766548616C664C696E65526967687428652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D732E7669657753746174652E706F73';
wwv_flow_imp.g_varchar2_table(8785) := '6974696F6E2E6C696E654E756D6265722C613D4D6174682E726F756E6428652E6765744C696E654C656E6774682872292F32293B695B6F5D3D51432E66726F6D5669657753746174652863532E6D6F7665526967687428652E637572736F72436F6E6669';
wwv_flow_imp.g_varchar2_table(8786) := '672C652C732E7669657753746174652C6E2C6129297D72657475726E20697D737461746963205F6D6F7665446F776E4279566965774C696E657328652C742C6E2C69297B636F6E7374206F3D5B5D3B666F72286C657420733D302C723D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(8787) := '683B733C723B732B2B297B636F6E737420723D745B735D3B6F5B735D3D51432E66726F6D5669657753746174652863532E6D6F7665446F776E28652E637572736F72436F6E6669672C652C722E7669657753746174652C6E2C6929297D72657475726E20';
wwv_flow_imp.g_varchar2_table(8788) := '6F7D737461746963205F6D6F7665446F776E42794D6F64656C4C696E657328652C742C6E2C69297B636F6E7374206F3D5B5D3B666F72286C657420733D302C723D742E6C656E6774683B733C723B732B2B297B636F6E737420723D745B735D3B6F5B735D';
wwv_flow_imp.g_varchar2_table(8789) := '3D51432E66726F6D4D6F64656C53746174652863532E6D6F7665446F776E28652E637572736F72436F6E6669672C652E6D6F64656C2C722E6D6F64656C53746174652C6E2C6929297D72657475726E206F7D737461746963205F6D6F7665557042795669';
wwv_flow_imp.g_varchar2_table(8790) := '65774C696E657328652C742C6E2C69297B636F6E7374206F3D5B5D3B666F72286C657420733D302C723D742E6C656E6774683B733C723B732B2B297B636F6E737420723D745B735D3B6F5B735D3D51432E66726F6D5669657753746174652863532E6D6F';
wwv_flow_imp.g_varchar2_table(8791) := '7665557028652E637572736F72436F6E6669672C652C722E7669657753746174652C6E2C6929297D72657475726E206F7D737461746963205F6D6F7665557042794D6F64656C4C696E657328652C742C6E2C69297B636F6E7374206F3D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(8792) := '6C657420733D302C723D742E6C656E6774683B733C723B732B2B297B636F6E737420723D745B735D3B6F5B735D3D51432E66726F6D4D6F64656C53746174652863532E6D6F7665557028652E637572736F72436F6E6669672C652E6D6F64656C2C722E6D';
wwv_flow_imp.g_varchar2_table(8793) := '6F64656C53746174652C6E2C6929297D72657475726E206F7D737461746963205F6D6F7665546F56696577506F736974696F6E28652C742C6E2C692C6F297B72657475726E2051432E66726F6D56696577537461746528742E7669657753746174652E6D';
wwv_flow_imp.g_varchar2_table(8794) := '6F7665286E2C692C6F2C3029297D737461746963205F6D6F7665546F4D6F64656C506F736974696F6E28652C742C6E2C692C6F297B72657475726E2051432E66726F6D4D6F64656C537461746528742E6D6F64656C53746174652E6D6F7665286E2C692C';
wwv_flow_imp.g_varchar2_table(8795) := '6F2C3029297D737461746963205F6D6F7665546F566965774D696E436F6C756D6E28652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D73';
wwv_flow_imp.g_varchar2_table(8796) := '2E7669657753746174652E706F736974696F6E2E6C696E654E756D6265722C613D652E6765744C696E654D696E436F6C756D6E2872293B695B6F5D3D746869732E5F6D6F7665546F56696577506F736974696F6E28652C732C6E2C722C61297D72657475';
wwv_flow_imp.g_varchar2_table(8797) := '726E20697D737461746963205F6D6F7665546F5669657746697273744E6F6E57686974657370616365436F6C756D6E28652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F';
wwv_flow_imp.g_varchar2_table(8798) := '6E737420733D745B6F5D2C723D732E7669657753746174652E706F736974696F6E2E6C696E654E756D6265722C613D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2872293B695B6F5D3D746869732E5F6D6F766554';
wwv_flow_imp.g_varchar2_table(8799) := '6F56696577506F736974696F6E28652C732C6E2C722C61297D72657475726E20697D737461746963205F6D6F7665546F5669657743656E746572436F6C756D6E28652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C';
wwv_flow_imp.g_varchar2_table(8800) := '656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D732E7669657753746174652E706F736974696F6E2E6C696E654E756D6265722C613D4D6174682E726F756E642828652E6765744C696E654D6178436F6C756D6E2872292B652E';
wwv_flow_imp.g_varchar2_table(8801) := '6765744C696E654D696E436F6C756D6E287229292F32293B695B6F5D3D746869732E5F6D6F7665546F56696577506F736974696F6E28652C732C6E2C722C61297D72657475726E20697D737461746963205F6D6F7665546F566965774D6178436F6C756D';
wwv_flow_imp.g_varchar2_table(8802) := '6E28652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D732E7669657753746174652E706F736974696F6E2E6C696E654E756D6265722C61';
wwv_flow_imp.g_varchar2_table(8803) := '3D652E6765744C696E654D6178436F6C756D6E2872293B695B6F5D3D746869732E5F6D6F7665546F56696577506F736974696F6E28652C732C6E2C722C61297D72657475726E20697D737461746963205F6D6F7665546F566965774C6173744E6F6E5768';
wwv_flow_imp.g_varchar2_table(8804) := '6974657370616365436F6C756D6E28652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D732E7669657753746174652E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(8805) := '2E6C696E654E756D6265722C613D652E6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E2872293B695B6F5D3D746869732E5F6D6F7665546F56696577506F736974696F6E28652C732C6E2C722C61297D72657475726E20697D';
wwv_flow_imp.g_varchar2_table(8806) := '7D766172206D533B66756E6374696F6E20665328652C742C6E2C69297B636F6E7374206F3D736728742C6E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E292C733D692E6765744C616E6775616765436F6E66696775726174';
wwv_flow_imp.g_varchar2_table(8807) := '696F6E286F2E6C616E67756167654964293B69662821732972657475726E206E756C6C3B636F6E737420723D6F2E6765744C696E65436F6E74656E7428292C613D722E73756273747228302C6E2E7374617274436F6C756D6E2D312D6F2E666972737443';
wwv_flow_imp.g_varchar2_table(8808) := '6861724F6666736574293B6C6574206C3B6C3D6E2E6973456D70747928293F722E737562737472286E2E7374617274436F6C756D6E2D312D6F2E6669727374436861724F6666736574293A736728742C6E2E656E644C696E654E756D6265722C6E2E656E';
wwv_flow_imp.g_varchar2_table(8809) := '64436F6C756D6E292E6765744C696E65436F6E74656E7428292E737562737472286E2E656E64436F6C756D6E2D312D6F2E6669727374436861724F6666736574293B6C657420633D22223B6966286E2E73746172744C696E654E756D6265723E31262630';
wwv_flow_imp.g_varchar2_table(8810) := '3D3D3D6F2E6669727374436861724F6666736574297B636F6E737420653D736728742C6E2E73746172744C696E654E756D6265722D31293B652E6C616E677561676549643D3D3D6F2E6C616E67756167654964262628633D652E6765744C696E65436F6E';
wwv_flow_imp.g_varchar2_table(8811) := '74656E742829297D636F6E737420643D732E6F6E456E74657228652C632C612C6C293B69662821642972657475726E206E756C6C3B636F6E737420683D642E696E64656E74416374696F6E3B6C657420753D642E617070656E64546578743B636F6E7374';
wwv_flow_imp.g_varchar2_table(8812) := '20703D642E72656D6F7665546578747C7C303B753F683D3D3D50752E496E64656E74262628753D225C74222B75293A753D683D3D3D50752E496E64656E747C7C683D3D3D50752E496E64656E744F757464656E743F225C74223A22223B6C657420673D6F';
wwv_flow_imp.g_varchar2_table(8813) := '6728742C6E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E293B72657475726E2070262628673D672E737562737472696E6728302C672E6C656E6774682D7029292C7B696E64656E74416374696F6E3A682C617070656E6454';
wwv_flow_imp.g_varchar2_table(8814) := '6578743A752C72656D6F7665546578743A702C696E64656E746174696F6E3A677D7D2166756E6374696F6E2865297B652E6D657461646174613D7B6465736372697074696F6E3A224D6F766520637572736F7220746F2061206C6F676963616C20706F73';
wwv_flow_imp.g_varchar2_table(8815) := '6974696F6E20696E207468652076696577222C617267733A5B7B6E616D653A22437572736F72206D6F766520617267756D656E74206F626A656374222C6465736372697074696F6E3A2250726F70657274792D76616C7565207061697273207468617420';
wwv_flow_imp.g_varchar2_table(8816) := '63616E20626520706173736564207468726F756768207468697320617267756D656E743A5C6E5C745C745C745C745C742A2027746F273A2041206D616E6461746F7279206C6F676963616C20706F736974696F6E2076616C75652070726F766964696E67';
wwv_flow_imp.g_varchar2_table(8817) := '20776865726520746F206D6F76652074686520637572736F722E5C6E5C745C745C745C745C745C746060605C6E5C745C745C745C745C745C74276C656674272C20277269676874272C20277570272C2027646F776E272C202770726576426C616E6B4C69';
wwv_flow_imp.g_varchar2_table(8818) := '6E65272C20276E657874426C616E6B4C696E65272C5C6E5C745C745C745C745C745C7427777261707065644C696E655374617274272C2027777261707065644C696E65456E64272C2027777261707065644C696E65436F6C756D6E43656E746572275C6E';
wwv_flow_imp.g_varchar2_table(8819) := '5C745C745C745C745C745C7427777261707065644C696E6546697273744E6F6E57686974657370616365436861726163746572272C2027777261707065644C696E654C6173744E6F6E57686974657370616365436861726163746572275C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(8820) := '745C745C745C742776696577506F7274546F70272C202776696577506F727443656E746572272C202776696577506F7274426F74746F6D272C202776696577506F727449664F757473696465275C6E5C745C745C745C745C745C746060605C6E5C745C74';
wwv_flow_imp.g_varchar2_table(8821) := '5C745C745C742A20276279273A20556E697420746F206D6F76652E2044656661756C7420697320636F6D7075746564206261736564206F6E2027746F272076616C75652E5C6E5C745C745C745C745C745C746060605C6E5C745C745C745C745C745C7427';
wwv_flow_imp.g_varchar2_table(8822) := '6C696E65272C2027777261707065644C696E65272C2027636861726163746572272C202768616C664C696E65275C6E5C745C745C745C745C745C746060605C6E5C745C745C745C745C742A202776616C7565273A204E756D626572206F6620756E697473';
wwv_flow_imp.g_varchar2_table(8823) := '20746F206D6F76652E2044656661756C74206973202731272E5C6E5C745C745C745C745C742A202773656C656374273A20496620277472756527206D616B6573207468652073656C656374696F6E2E2044656661756C74206973202766616C7365272E5C';
wwv_flow_imp.g_varchar2_table(8824) := '6E5C745C745C745C74222C636F6E73747261696E743A66756E6374696F6E2865297B69662821756C2865292972657475726E21313B636F6E737420743D653B72657475726E212821686C28742E746F297C7C21766C28742E73656C65637429262621666C';
wwv_flow_imp.g_varchar2_table(8825) := '28742E73656C656374297C7C21766C28742E627929262621686C28742E6279297C7C21766C28742E76616C756529262621676C28742E76616C756529297D2C736368656D613A7B747970653A226F626A656374222C72657175697265643A5B22746F225D';
wwv_flow_imp.g_varchar2_table(8826) := '2C70726F706572746965733A7B746F3A7B747970653A22737472696E67222C656E756D3A5B226C656674222C227269676874222C227570222C22646F776E222C2270726576426C616E6B4C696E65222C226E657874426C616E6B4C696E65222C22777261';
wwv_flow_imp.g_varchar2_table(8827) := '707065644C696E655374617274222C22777261707065644C696E65456E64222C22777261707065644C696E65436F6C756D6E43656E746572222C22777261707065644C696E6546697273744E6F6E57686974657370616365436861726163746572222C22';
wwv_flow_imp.g_varchar2_table(8828) := '777261707065644C696E654C6173744E6F6E57686974657370616365436861726163746572222C2276696577506F7274546F70222C2276696577506F727443656E746572222C2276696577506F7274426F74746F6D222C2276696577506F727449664F75';
wwv_flow_imp.g_varchar2_table(8829) := '7473696465225D7D2C62793A7B747970653A22737472696E67222C656E756D3A5B226C696E65222C22777261707065644C696E65222C22636861726163746572222C2268616C664C696E65225D7D2C76616C75653A7B747970653A226E756D626572222C';
wwv_flow_imp.g_varchar2_table(8830) := '64656661756C743A317D2C73656C6563743A7B747970653A22626F6F6C65616E222C64656661756C743A21317D7D7D7D5D7D2C652E526177446972656374696F6E3D7B4C6566743A226C656674222C52696768743A227269676874222C55703A22757022';
wwv_flow_imp.g_varchar2_table(8831) := '2C446F776E3A22646F776E222C50726576426C616E6B4C696E653A2270726576426C616E6B4C696E65222C4E657874426C616E6B4C696E653A226E657874426C616E6B4C696E65222C577261707065644C696E6553746172743A22777261707065644C69';
wwv_flow_imp.g_varchar2_table(8832) := '6E655374617274222C577261707065644C696E6546697273744E6F6E576869746573706163654368617261637465723A22777261707065644C696E6546697273744E6F6E57686974657370616365436861726163746572222C577261707065644C696E65';
wwv_flow_imp.g_varchar2_table(8833) := '436F6C756D6E43656E7465723A22777261707065644C696E65436F6C756D6E43656E746572222C577261707065644C696E65456E643A22777261707065644C696E65456E64222C577261707065644C696E654C6173744E6F6E5768697465737061636543';
wwv_flow_imp.g_varchar2_table(8834) := '68617261637465723A22777261707065644C696E654C6173744E6F6E57686974657370616365436861726163746572222C56696577506F7274546F703A2276696577506F7274546F70222C56696577506F727443656E7465723A2276696577506F727443';
wwv_flow_imp.g_varchar2_table(8835) := '656E746572222C56696577506F7274426F74746F6D3A2276696577506F7274426F74746F6D222C56696577506F727449664F7574736964653A2276696577506F727449664F757473696465227D2C652E526177556E69743D7B4C696E653A226C696E6522';
wwv_flow_imp.g_varchar2_table(8836) := '2C577261707065644C696E653A22777261707065644C696E65222C4368617261637465723A22636861726163746572222C48616C664C696E653A2268616C664C696E65227D2C652E70617273653D66756E6374696F6E2874297B69662821742E746F2972';
wwv_flow_imp.g_varchar2_table(8837) := '657475726E206E756C6C3B6C6574206E3B73776974636828742E746F297B6361736520652E526177446972656374696F6E2E4C6566743A6E3D303B627265616B3B6361736520652E526177446972656374696F6E2E52696768743A6E3D313B627265616B';
wwv_flow_imp.g_varchar2_table(8838) := '3B6361736520652E526177446972656374696F6E2E55703A6E3D323B627265616B3B6361736520652E526177446972656374696F6E2E446F776E3A6E3D333B627265616B3B6361736520652E526177446972656374696F6E2E50726576426C616E6B4C69';
wwv_flow_imp.g_varchar2_table(8839) := '6E653A6E3D343B627265616B3B6361736520652E526177446972656374696F6E2E4E657874426C616E6B4C696E653A6E3D353B627265616B3B6361736520652E526177446972656374696F6E2E577261707065644C696E6553746172743A6E3D363B6272';
wwv_flow_imp.g_varchar2_table(8840) := '65616B3B6361736520652E526177446972656374696F6E2E577261707065644C696E6546697273744E6F6E576869746573706163654368617261637465723A6E3D373B627265616B3B6361736520652E526177446972656374696F6E2E57726170706564';
wwv_flow_imp.g_varchar2_table(8841) := '4C696E65436F6C756D6E43656E7465723A6E3D383B627265616B3B6361736520652E526177446972656374696F6E2E577261707065644C696E65456E643A6E3D393B627265616B3B6361736520652E526177446972656374696F6E2E577261707065644C';
wwv_flow_imp.g_varchar2_table(8842) := '696E654C6173744E6F6E576869746573706163654368617261637465723A6E3D31303B627265616B3B6361736520652E526177446972656374696F6E2E56696577506F7274546F703A6E3D31313B627265616B3B6361736520652E526177446972656374';
wwv_flow_imp.g_varchar2_table(8843) := '696F6E2E56696577506F7274426F74746F6D3A6E3D31333B627265616B3B6361736520652E526177446972656374696F6E2E56696577506F727443656E7465723A6E3D31323B627265616B3B6361736520652E526177446972656374696F6E2E56696577';
wwv_flow_imp.g_varchar2_table(8844) := '506F727449664F7574736964653A6E3D31343B627265616B3B64656661756C743A72657475726E206E756C6C7D6C657420693D303B73776974636828742E6279297B6361736520652E526177556E69742E4C696E653A693D313B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(8845) := '20652E526177556E69742E577261707065644C696E653A693D323B627265616B3B6361736520652E526177556E69742E4368617261637465723A693D333B627265616B3B6361736520652E526177556E69742E48616C664C696E653A693D347D72657475';
wwv_flow_imp.g_varchar2_table(8846) := '726E7B646972656374696F6E3A6E2C756E69743A692C73656C6563743A2121742E73656C6563742C76616C75653A742E76616C75657C7C317D7D7D286D537C7C286D533D7B7D29293B7661722076533B636F6E73742062533D4F626A6563742E63726561';
wwv_flow_imp.g_varchar2_table(8847) := '7465286E756C6C293B66756E6374696F6E205F5328652C74297B696628743C3D302972657475726E22223B62535B655D7C7C2862535B655D3D5B22222C655D293B636F6E7374206E3D62535B655D3B666F72286C657420693D6E2E6C656E6774683B693C';
wwv_flow_imp.g_varchar2_table(8848) := '3D743B692B2B296E5B695D3D6E5B692D315D2B653B72657475726E206E5B745D7D6C65742079533D76533D636C6173737B73746174696320756E7368696674496E64656E7428652C742C6E2C692C6F297B636F6E737420733D70752E76697369626C6543';
wwv_flow_imp.g_varchar2_table(8849) := '6F6C756D6E46726F6D436F6C756D6E28652C742C6E293B6966286F297B636F6E737420653D5F53282220222C69293B72657475726E205F5328652C70752E70726576496E64656E7454616253746F7028732C69292F69297D72657475726E205F5328225C';
wwv_flow_imp.g_varchar2_table(8850) := '74222C70752E7072657652656E64657254616253746F7028732C6E292F6E297D737461746963207368696674496E64656E7428652C742C6E2C692C6F297B636F6E737420733D70752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28652C74';
wwv_flow_imp.g_varchar2_table(8851) := '2C6E293B6966286F297B636F6E737420653D5F53282220222C69293B72657475726E205F5328652C70752E6E657874496E64656E7454616253746F7028732C69292F69297D72657475726E205F5328225C74222C70752E6E65787452656E646572546162';
wwv_flow_imp.g_varchar2_table(8852) := '53746F7028732C6E292F6E297D636F6E7374727563746F7228652C742C6E297B746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D6E2C746869732E5F6F7074733D742C746869732E5F73656C656374696F6E3D652C';
wwv_flow_imp.g_varchar2_table(8853) := '746869732E5F73656C656374696F6E49643D6E756C6C2C746869732E5F7573654C6173744564697452616E6765466F72437572736F72456E64506F736974696F6E3D21312C746869732E5F73656C656374696F6E5374617274436F6C756D6E5374617973';
wwv_flow_imp.g_varchar2_table(8854) := '5075743D21317D5F616464456469744F7065726174696F6E28652C742C6E297B746869732E5F7573654C6173744564697452616E6765466F72437572736F72456E64506F736974696F6E3F652E616464547261636B6564456469744F7065726174696F6E';
wwv_flow_imp.g_varchar2_table(8855) := '28742C6E293A652E616464456469744F7065726174696F6E28742C6E297D676574456469744F7065726174696F6E7328652C74297B636F6E7374206E3D746869732E5F73656C656374696F6E2E73746172744C696E654E756D6265723B6C657420693D74';
wwv_flow_imp.g_varchar2_table(8856) := '6869732E5F73656C656374696F6E2E656E644C696E654E756D6265723B313D3D3D746869732E5F73656C656374696F6E2E656E64436F6C756D6E26266E213D3D69262628692D3D31293B636F6E73747B74616253697A653A6F2C696E64656E7453697A65';
wwv_flow_imp.g_varchar2_table(8857) := '3A732C696E736572745370616365733A727D3D746869732E5F6F7074732C613D6E3D3D3D693B696628746869732E5F6F7074732E75736554616253746F7073297B746869732E5F73656C656374696F6E2E6973456D707479282926262F5E5C732A242F2E';
wwv_flow_imp.g_varchar2_table(8858) := '7465737428652E6765744C696E65436F6E74656E74286E2929262628746869732E5F7573654C6173744564697452616E6765466F72437572736F72456E64506F736974696F6E3D2130293B6C6574206C3D302C633D303B666F72286C657420643D6E3B64';
wwv_flow_imp.g_varchar2_table(8859) := '3C3D693B642B2B2C6C3D63297B633D303B636F6E737420693D652E6765744C696E65436F6E74656E742864293B6C657420682C753D6D692869293B6966282821746869732E5F6F7074732E6973556E73686966747C7C30213D3D692E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(8860) := '30213D3D7529262628617C7C746869732E5F6F7074732E6973556E73686966747C7C30213D3D692E6C656E67746829297B6966282D313D3D3D75262628753D692E6C656E677468292C643E31262670752E76697369626C65436F6C756D6E46726F6D436F';
wwv_flow_imp.g_varchar2_table(8861) := '6C756D6E28692C752B312C6F292573213D302626652E746F6B656E697A6174696F6E2E69734368656170546F546F6B656E697A6528642D3129297B636F6E737420743D665328746869732E5F6F7074732E6175746F496E64656E742C652C6E6577207268';
wwv_flow_imp.g_varchar2_table(8862) := '28642D312C652E6765744C696E654D6178436F6C756D6E28642D31292C642D312C652E6765744C696E654D6178436F6C756D6E28642D3129292C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B69662874297B';
wwv_flow_imp.g_varchar2_table(8863) := '696628633D6C2C742E617070656E645465787429666F72286C657420653D302C6E3D742E617070656E64546578742E6C656E6774683B653C6E2626633C73262633323D3D3D742E617070656E64546578742E63686172436F646541742865293B652B2B29';
wwv_flow_imp.g_varchar2_table(8864) := '632B2B3B742E72656D6F766554657874262628633D4D6174682E6D617828302C632D742E72656D6F76655465787429293B666F72286C657420653D303B653C63262630213D3D75262633323D3D3D692E63686172436F6465417428752D31293B652B2B29';
wwv_flow_imp.g_varchar2_table(8865) := '752D2D7D7D746869732E5F6F7074732E6973556E73686966742626303D3D3D757C7C28683D746869732E5F6F7074732E6973556E73686966743F76532E756E7368696674496E64656E7428692C752B312C6F2C732C72293A76532E7368696674496E6465';
wwv_flow_imp.g_varchar2_table(8866) := '6E7428692C752B312C6F2C732C72292C746869732E5F616464456469744F7065726174696F6E28742C6E657720726828642C312C642C752B31292C68292C64213D3D6E7C7C746869732E5F73656C656374696F6E2E6973456D70747928297C7C28746869';
wwv_flow_imp.g_varchar2_table(8867) := '732E5F73656C656374696F6E5374617274436F6C756D6E53746179735075743D746869732E5F73656C656374696F6E2E7374617274436F6C756D6E3C3D752B3129297D7D7D656C73657B21746869732E5F6F7074732E6973556E73686966742626746869';
wwv_flow_imp.g_varchar2_table(8868) := '732E5F73656C656374696F6E2E6973456D70747928292626303D3D3D652E6765744C696E654C656E677468286E29262628746869732E5F7573654C6173744564697452616E6765466F72437572736F72456E64506F736974696F6E3D2130293B636F6E73';
wwv_flow_imp.g_varchar2_table(8869) := '74206F3D723F5F53282220222C73293A225C74223B666F72286C657420723D6E3B723C3D693B722B2B297B636F6E737420693D652E6765744C696E65436F6E74656E742872293B6C6574206C3D6D692869293B6966282821746869732E5F6F7074732E69';
wwv_flow_imp.g_varchar2_table(8870) := '73556E73686966747C7C30213D3D692E6C656E677468262630213D3D6C29262628617C7C746869732E5F6F7074732E6973556E73686966747C7C30213D3D692E6C656E677468292626282D313D3D3D6C2626286C3D692E6C656E677468292C2174686973';
wwv_flow_imp.g_varchar2_table(8871) := '2E5F6F7074732E6973556E73686966747C7C30213D3D6C2929696628746869732E5F6F7074732E6973556E7368696674297B6C3D4D6174682E6D696E286C2C73293B666F72286C657420653D303B653C6C3B652B2B29696628393D3D3D692E6368617243';
wwv_flow_imp.g_varchar2_table(8872) := '6F64654174286529297B6C3D652B313B627265616B7D746869732E5F616464456469744F7065726174696F6E28742C6E657720726828722C312C722C6C2B31292C2222297D656C736520746869732E5F616464456469744F7065726174696F6E28742C6E';
wwv_flow_imp.g_varchar2_table(8873) := '657720726828722C312C722C31292C6F292C72213D3D6E7C7C746869732E5F73656C656374696F6E2E6973456D70747928297C7C28746869732E5F73656C656374696F6E5374617274436F6C756D6E53746179735075743D313D3D3D746869732E5F7365';
wwv_flow_imp.g_varchar2_table(8874) := '6C656374696F6E2E7374617274436F6C756D6E297D7D746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F73656C656374696F6E297D636F6D70757465437572736F72537461746528652C74297B6966';
wwv_flow_imp.g_varchar2_table(8875) := '28746869732E5F7573654C6173744564697452616E6765466F72437572736F72456E64506F736974696F6E297B636F6E737420653D742E676574496E7665727365456469744F7065726174696F6E7328295B305D3B72657475726E206E65772061682865';
wwv_flow_imp.g_varchar2_table(8876) := '2E72616E67652E656E644C696E654E756D6265722C652E72616E67652E656E64436F6C756D6E2C652E72616E67652E656E644C696E654E756D6265722C652E72616E67652E656E64436F6C756D6E297D636F6E7374206E3D742E676574547261636B6564';
wwv_flow_imp.g_varchar2_table(8877) := '53656C656374696F6E28746869732E5F73656C656374696F6E4964293B696628746869732E5F73656C656374696F6E5374617274436F6C756D6E5374617973507574297B636F6E737420653D746869732E5F73656C656374696F6E2E7374617274436F6C';
wwv_flow_imp.g_varchar2_table(8878) := '756D6E3B72657475726E206E2E7374617274436F6C756D6E3C3D653F6E3A303D3D3D6E2E676574446972656374696F6E28293F6E6577206168286E2E73746172744C696E654E756D6265722C652C6E2E656E644C696E654E756D6265722C6E2E656E6443';
wwv_flow_imp.g_varchar2_table(8879) := '6F6C756D6E293A6E6577206168286E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E2C6E2E73746172744C696E654E756D6265722C65297D72657475726E206E7D7D3B79533D76533D66756E6374696F6E28652C742C6E2C69297B7661';
wwv_flow_imp.g_varchar2_table(8880) := '72206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(8881) := '205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B';
wwv_flow_imp.g_varchar2_table(8882) := '613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C7229';
wwv_flow_imp.g_varchar2_table(8883) := '2C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28322C6567295D2C7953293B636C6173732077537B636F6E7374727563746F7228652C742C6E297B746869732E5F72616E67';
wwv_flow_imp.g_varchar2_table(8884) := '653D652C746869732E5F636861724265666F726553656C656374696F6E3D742C746869732E5F63686172416674657253656C656374696F6E3D6E7D676574456469744F7065726174696F6E7328652C74297B742E616464547261636B6564456469744F70';
wwv_flow_imp.g_varchar2_table(8885) := '65726174696F6E286E657720726828746869732E5F72616E67652E73746172744C696E654E756D6265722C746869732E5F72616E67652E7374617274436F6C756D6E2C746869732E5F72616E67652E73746172744C696E654E756D6265722C746869732E';
wwv_flow_imp.g_varchar2_table(8886) := '5F72616E67652E7374617274436F6C756D6E292C746869732E5F636861724265666F726553656C656374696F6E292C742E616464547261636B6564456469744F7065726174696F6E286E657720726828746869732E5F72616E67652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(8887) := '756D6265722C746869732E5F72616E67652E656E64436F6C756D6E2C746869732E5F72616E67652E656E644C696E654E756D6265722C746869732E5F72616E67652E656E64436F6C756D6E292C746869732E5F63686172416674657253656C656374696F';
wwv_flow_imp.g_varchar2_table(8888) := '6E297D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E3D742E676574496E7665727365456469744F7065726174696F6E7328292C693D6E5B305D2E72616E67652C6F3D6E5B315D2E72616E67653B72657475726E206E6577';
wwv_flow_imp.g_varchar2_table(8889) := '20616828692E656E644C696E654E756D6265722C692E656E64436F6C756D6E2C6F2E656E644C696E654E756D6265722C6F2E656E64436F6C756D6E2D746869732E5F63686172416674657253656C656374696F6E2E6C656E677468297D7D636C61737320';
wwv_flow_imp.g_varchar2_table(8890) := '43537B636F6E7374727563746F7228652C742C6E297B746869732E5F706F736974696F6E3D652C746869732E5F746578743D742C746869732E5F6368617241667465723D6E7D676574456469744F7065726174696F6E7328652C74297B742E6164645472';
wwv_flow_imp.g_varchar2_table(8891) := '61636B6564456469744F7065726174696F6E286E657720726828746869732E5F706F736974696F6E2E6C696E654E756D6265722C746869732E5F706F736974696F6E2E636F6C756D6E2C746869732E5F706F736974696F6E2E6C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(8892) := '746869732E5F706F736974696F6E2E636F6C756D6E292C746869732E5F746578742B746869732E5F636861724166746572297D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E3D742E676574496E7665727365456469744F';
wwv_flow_imp.g_varchar2_table(8893) := '7065726174696F6E7328295B305D2E72616E67653B72657475726E206E6577206168286E2E656E644C696E654E756D6265722C6E2E7374617274436F6C756D6E2C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E2D746869732E5F63';
wwv_flow_imp.g_varchar2_table(8894) := '68617241667465722E6C656E677468297D7D66756E6374696F6E20535328652C742C6E2C693D21302C6F297B696628653C342972657475726E206E756C6C3B636F6E737420733D6F2E6765744C616E6775616765436F6E66696775726174696F6E28742E';
wwv_flow_imp.g_varchar2_table(8895) := '746F6B656E697A6174696F6E2E6765744C616E677561676549642829292E696E64656E7452756C6573537570706F72743B69662821732972657475726E206E756C6C3B6966286E3C3D312972657475726E7B696E64656E746174696F6E3A22222C616374';
wwv_flow_imp.g_varchar2_table(8896) := '696F6E3A6E756C6C7D3B666F72286C657420653D6E2D313B653E30262622223D3D3D742E6765744C696E65436F6E74656E742865293B652D2D29696628313D3D3D652972657475726E7B696E64656E746174696F6E3A22222C616374696F6E3A6E756C6C';
wwv_flow_imp.g_varchar2_table(8897) := '7D3B636F6E737420723D66756E6374696F6E28652C742C6E297B636F6E737420693D652E746F6B656E697A6174696F6E2E6765744C616E677561676549644174506F736974696F6E28742C30293B696628743E31297B6C6574206F2C733D2D313B666F72';
wwv_flow_imp.g_varchar2_table(8898) := '286F3D742D313B6F3E3D313B6F2D2D297B696628652E746F6B656E697A6174696F6E2E6765744C616E677561676549644174506F736974696F6E286F2C3029213D3D692972657475726E20733B636F6E737420743D652E6765744C696E65436F6E74656E';
wwv_flow_imp.g_varchar2_table(8899) := '74286F293B696628216E2E73686F756C6449676E6F72652874292626212F5E5C732B242F2E7465737428742926262222213D3D742972657475726E206F3B733D6F7D7D72657475726E2D317D28742C6E2C73293B696628723C302972657475726E206E75';
wwv_flow_imp.g_varchar2_table(8900) := '6C6C3B696628723C312972657475726E7B696E64656E746174696F6E3A22222C616374696F6E3A6E756C6C7D3B636F6E737420613D742E6765744C696E65436F6E74656E742872293B696628732E73686F756C64496E6372656173652861297C7C732E73';
wwv_flow_imp.g_varchar2_table(8901) := '686F756C64496E64656E744E6578744C696E652861292972657475726E7B696E64656E746174696F6E3A66692861292C616374696F6E3A50752E496E64656E742C6C696E653A727D3B696628732E73686F756C6444656372656173652861292972657475';
wwv_flow_imp.g_varchar2_table(8902) := '726E7B696E64656E746174696F6E3A66692861292C616374696F6E3A6E756C6C2C6C696E653A727D3B7B696628313D3D3D722972657475726E7B696E64656E746174696F6E3A666928742E6765744C696E65436F6E74656E74287229292C616374696F6E';
wwv_flow_imp.g_varchar2_table(8903) := '3A6E756C6C2C6C696E653A727D3B636F6E737420653D722D312C6E3D732E676574496E64656E744D6574616461746128742E6765744C696E65436F6E74656E74286529293B696628212833266E29262634266E297B6C6574206E3D303B666F72286C6574';
wwv_flow_imp.g_varchar2_table(8904) := '20693D652D313B693E303B692D2D2969662821732E73686F756C64496E64656E744E6578744C696E6528742E6765744C696E65436F6E74656E7428692929297B6E3D693B627265616B7D72657475726E7B696E64656E746174696F6E3A666928742E6765';
wwv_flow_imp.g_varchar2_table(8905) := '744C696E65436F6E74656E74286E2B3129292C616374696F6E3A6E756C6C2C6C696E653A6E2B317D7D696628692972657475726E7B696E64656E746174696F6E3A666928742E6765744C696E65436F6E74656E74287229292C616374696F6E3A6E756C6C';
wwv_flow_imp.g_varchar2_table(8906) := '2C6C696E653A727D3B666F72286C657420653D723B653E303B652D2D297B636F6E7374206E3D742E6765744C696E65436F6E74656E742865293B696628732E73686F756C64496E637265617365286E292972657475726E7B696E64656E746174696F6E3A';
wwv_flow_imp.g_varchar2_table(8907) := '6669286E292C616374696F6E3A50752E496E64656E742C6C696E653A657D3B696628732E73686F756C64496E64656E744E6578744C696E65286E29297B6C6574206E3D303B666F72286C657420693D652D313B693E303B692D2D2969662821732E73686F';
wwv_flow_imp.g_varchar2_table(8908) := '756C64496E64656E744E6578744C696E6528742E6765744C696E65436F6E74656E7428652929297B6E3D693B627265616B7D72657475726E7B696E64656E746174696F6E3A666928742E6765744C696E65436F6E74656E74286E2B3129292C616374696F';
wwv_flow_imp.g_varchar2_table(8909) := '6E3A6E756C6C2C6C696E653A6E2B317D7D696628732E73686F756C644465637265617365286E292972657475726E7B696E64656E746174696F6E3A6669286E292C616374696F6E3A6E756C6C2C6C696E653A657D7D72657475726E7B696E64656E746174';
wwv_flow_imp.g_varchar2_table(8910) := '696F6E3A666928742E6765744C696E65436F6E74656E74283129292C616374696F6E3A6E756C6C2C6C696E653A317D7D7D66756E6374696F6E20785328652C742C6E2C692C6F2C73297B696628653C342972657475726E206E756C6C3B636F6E73742072';
wwv_flow_imp.g_varchar2_table(8911) := '3D732E6765744C616E6775616765436F6E66696775726174696F6E286E293B69662821722972657475726E206E756C6C3B636F6E737420613D732E6765744C616E6775616765436F6E66696775726174696F6E286E292E696E64656E7452756C65735375';
wwv_flow_imp.g_varchar2_table(8912) := '70706F72743B69662821612972657475726E206E756C6C3B636F6E7374206C3D535328652C742C692C766F696420302C73292C633D742E6765744C696E65436F6E74656E742869293B6966286C297B636F6E7374206E3D6C2E6C696E653B696628766F69';
wwv_flow_imp.g_varchar2_table(8913) := '642030213D3D6E297B6C657420733D21303B666F72286C657420653D6E3B653C692D313B652B2B29696628212F5E5C732A242F2E7465737428742E6765744C696E65436F6E74656E7428652929297B733D21313B627265616B7D69662873297B636F6E73';
wwv_flow_imp.g_varchar2_table(8914) := '7420693D722E6F6E456E74657228652C22222C742E6765744C696E65436F6E74656E74286E292C2222293B69662869297B6C657420653D666928742E6765744C696E65436F6E74656E74286E29293B72657475726E20692E72656D6F7665546578742626';
wwv_flow_imp.g_varchar2_table(8915) := '28653D652E737562737472696E6728302C652E6C656E6774682D692E72656D6F76655465787429292C692E696E64656E74416374696F6E3D3D3D50752E496E64656E747C7C692E696E64656E74416374696F6E3D3D3D50752E496E64656E744F75746465';
wwv_flow_imp.g_varchar2_table(8916) := '6E743F653D6F2E7368696674496E64656E742865293A692E696E64656E74416374696F6E3D3D3D50752E4F757464656E74262628653D6F2E756E7368696674496E64656E74286529292C612E73686F756C644465637265617365286329262628653D6F2E';
wwv_flow_imp.g_varchar2_table(8917) := '756E7368696674496E64656E74286529292C692E617070656E6454657874262628652B3D692E617070656E6454657874292C66692865297D7D7D72657475726E20612E73686F756C6444656372656173652863293F6C2E616374696F6E3D3D3D50752E49';
wwv_flow_imp.g_varchar2_table(8918) := '6E64656E743F6C2E696E64656E746174696F6E3A6F2E756E7368696674496E64656E74286C2E696E64656E746174696F6E293A6C2E616374696F6E3D3D3D50752E496E64656E743F6F2E7368696674496E64656E74286C2E696E64656E746174696F6E29';
wwv_flow_imp.g_varchar2_table(8919) := '3A6C2E696E64656E746174696F6E7D72657475726E206E756C6C7D66756E6374696F6E206B5328652C742C6E297B636F6E737420693D6E2E6765744C616E6775616765436F6E66696775726174696F6E28652E6765744C616E677561676549642829292E';
wwv_flow_imp.g_varchar2_table(8920) := '696E64656E7452756C6573537570706F72743B72657475726E20693F743C317C7C743E652E6765744C696E65436F756E7428293F6E756C6C3A692E676574496E64656E744D6574616461746128652E6765744C696E65436F6E74656E74287429293A6E75';
wwv_flow_imp.g_varchar2_table(8921) := '6C6C7D636C6173732045537B73746174696320696E64656E7428652C742C6E297B6966286E756C6C3D3D3D747C7C6E756C6C3D3D3D6E2972657475726E5B5D3B636F6E737420693D5B5D3B666F72286C657420743D302C6F3D6E2E6C656E6774683B743C';
wwv_flow_imp.g_varchar2_table(8922) := '6F3B742B2B29695B745D3D6E6577207953286E5B745D2C7B6973556E73686966743A21312C74616253697A653A652E74616253697A652C696E64656E7453697A653A652E696E64656E7453697A652C696E736572745370616365733A652E696E73657274';
wwv_flow_imp.g_varchar2_table(8923) := '5370616365732C75736554616253746F70733A652E75736554616253746F70732C6175746F496E64656E743A652E6175746F496E64656E747D2C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B72657475726E20697D73';
wwv_flow_imp.g_varchar2_table(8924) := '7461746963206F757464656E7428652C742C6E297B636F6E737420693D5B5D3B666F72286C657420743D302C6F3D6E2E6C656E6774683B743C6F3B742B2B29695B745D3D6E6577207953286E5B745D2C7B6973556E73686966743A21302C74616253697A';
wwv_flow_imp.g_varchar2_table(8925) := '653A652E74616253697A652C696E64656E7453697A653A652E696E64656E7453697A652C696E736572745370616365733A652E696E736572745370616365732C75736554616253746F70733A652E75736554616253746F70732C6175746F496E64656E74';
wwv_flow_imp.g_varchar2_table(8926) := '3A652E6175746F496E64656E747D2C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B72657475726E20697D737461746963207368696674496E64656E7428652C742C6E297B72657475726E206E3D6E7C7C312C79532E73';
wwv_flow_imp.g_varchar2_table(8927) := '68696674496E64656E7428742C742E6C656E6774682B6E2C652E74616253697A652C652E696E64656E7453697A652C652E696E73657274537061636573297D73746174696320756E7368696674496E64656E7428652C742C6E297B72657475726E206E3D';
wwv_flow_imp.g_varchar2_table(8928) := '6E7C7C312C79532E756E7368696674496E64656E7428742C742E6C656E6774682B6E2C652E74616253697A652C652E696E64656E7453697A652C652E696E73657274537061636573297D737461746963205F646973747269627574656450617374652865';
wwv_flow_imp.g_varchar2_table(8929) := '2C742C6E2C69297B636F6E7374206F3D5B5D3B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B296F5B655D3D6E6577206E53286E5B655D2C695B655D293B72657475726E206E6577204A4328302C6F2C7B73686F756C645075';
wwv_flow_imp.g_varchar2_table(8930) := '7368537461636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E7441667465723A21307D297D737461746963205F73696D706C65506173746528652C742C6E2C692C6F297B636F6E737420733D5B5D3B66';
wwv_flow_imp.g_varchar2_table(8931) := '6F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D2C723D742E676574506F736974696F6E28293B6966286F262621742E6973456D70747928292626286F3D2131292C6F2626692E696E6465784F';
wwv_flow_imp.g_varchar2_table(8932) := '6628225C6E2229213D3D692E6C656E6774682D312626286F3D2131292C6F297B636F6E7374206E3D6E657720726828722E6C696E654E756D6265722C312C722E6C696E654E756D6265722C31293B735B655D3D6E6577207253286E2C692C742C2130297D';
wwv_flow_imp.g_varchar2_table(8933) := '656C736520735B655D3D6E6577206E5328742C69297D72657475726E206E6577204A4328302C732C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E744166746572';
wwv_flow_imp.g_varchar2_table(8934) := '3A21307D297D737461746963205F646973747269627574655061737465546F437572736F727328652C742C6E2C692C6F297B696628692972657475726E206E756C6C3B696628313D3D3D742E6C656E6774682972657475726E206E756C6C3B6966286F26';
wwv_flow_imp.g_varchar2_table(8935) := '266F2E6C656E6774683D3D3D742E6C656E6774682972657475726E206F3B69662822737072656164223D3D3D652E6D756C7469437572736F725061737465297B31303D3D3D6E2E63686172436F64654174286E2E6C656E6774682D31292626286E3D6E2E';
wwv_flow_imp.g_varchar2_table(8936) := '73756273747228302C6E2E6C656E6774682D3129292C31333D3D3D6E2E63686172436F64654174286E2E6C656E6774682D31292626286E3D6E2E73756273747228302C6E2E6C656E6774682D3129293B636F6E737420653D6769286E293B696628652E6C';
wwv_flow_imp.g_varchar2_table(8937) := '656E6774683D3D3D742E6C656E6774682972657475726E20657D72657475726E206E756C6C7D73746174696320706173746528652C742C6E2C692C6F2C73297B636F6E737420723D746869732E5F646973747269627574655061737465546F437572736F';
wwv_flow_imp.g_varchar2_table(8938) := '727328652C6E2C692C6F2C73293B72657475726E20723F286E3D6E2E736F72742872682E636F6D7061726552616E6765735573696E67537461727473292C746869732E5F6469737472696275746564506173746528652C742C6E2C7229293A746869732E';
wwv_flow_imp.g_varchar2_table(8939) := '5F73696D706C65506173746528652C742C6E2C692C6F297D737461746963205F676F6F64496E64656E74466F724C696E6528652C742C6E297B6C657420693D6E756C6C2C6F3D22223B636F6E737420733D535328652E6175746F496E64656E742C742C6E';
wwv_flow_imp.g_varchar2_table(8940) := '2C21312C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966287329693D732E616374696F6E2C6F3D732E696E64656E746174696F6E3B656C7365206966286E3E31297B6C657420693B666F7228693D6E2D313B693E3D';
wwv_flow_imp.g_varchar2_table(8941) := '3126262128766928742E6765744C696E65436F6E74656E74286929293E3D30293B692D2D293B696628693C312972657475726E206E756C6C3B636F6E737420733D742E6765744C696E654D6178436F6C756D6E2869292C723D665328652E6175746F496E';
wwv_flow_imp.g_varchar2_table(8942) := '64656E742C742C6E657720726828692C732C692C73292C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B722626286F3D722E696E64656E746174696F6E2B722E617070656E6454657874297D72657475726E2069262628';
wwv_flow_imp.g_varchar2_table(8943) := '693D3D3D50752E496E64656E742626286F3D45532E7368696674496E64656E7428652C6F29292C693D3D3D50752E4F757464656E742626286F3D45532E756E7368696674496E64656E7428652C6F29292C6F3D652E6E6F726D616C697A65496E64656E74';
wwv_flow_imp.g_varchar2_table(8944) := '6174696F6E286F29292C6F7C7C6E756C6C7D737461746963205F7265706C6163654A756D70546F4E657874496E64656E7428652C742C6E2C69297B6C6574206F3D22223B636F6E737420733D6E2E6765745374617274506F736974696F6E28293B696628';
wwv_flow_imp.g_varchar2_table(8945) := '652E696E73657274537061636573297B636F6E7374206E3D652E76697369626C65436F6C756D6E46726F6D436F6C756D6E28742C73292C693D652E696E64656E7453697A652C723D692D6E25693B666F72286C657420653D303B653C723B652B2B296F2B';
wwv_flow_imp.g_varchar2_table(8946) := '3D2220227D656C7365206F3D225C74223B72657475726E206E6577206E53286E2C6F2C69297D7374617469632074616228652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D6E2E6C656E6774683B6F3C733B6F2B2B297B63';
wwv_flow_imp.g_varchar2_table(8947) := '6F6E737420733D6E5B6F5D3B696628732E6973456D7074792829297B636F6E7374206E3D742E6765744C696E65436F6E74656E7428732E73746172744C696E654E756D626572293B6966282F5E5C732A242F2E74657374286E292626742E746F6B656E69';
wwv_flow_imp.g_varchar2_table(8948) := '7A6174696F6E2E69734368656170546F546F6B656E697A6528732E73746172744C696E654E756D62657229297B6C657420723D746869732E5F676F6F64496E64656E74466F724C696E6528652C742C732E73746172744C696E654E756D626572293B723D';
wwv_flow_imp.g_varchar2_table(8949) := '727C7C225C74223B636F6E737420613D652E6E6F726D616C697A65496E64656E746174696F6E2872293B696628216E2E73746172747357697468286129297B695B6F5D3D6E6577206E53286E657720726828732E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(8950) := '312C732E73746172744C696E654E756D6265722C6E2E6C656E6774682B31292C612C2130293B636F6E74696E75657D7D695B6F5D3D746869732E5F7265706C6163654A756D70546F4E657874496E64656E7428652C742C732C2130297D656C73657B6966';
wwv_flow_imp.g_varchar2_table(8951) := '28732E73746172744C696E654E756D6265723D3D3D732E656E644C696E654E756D626572297B636F6E7374206E3D742E6765744C696E654D6178436F6C756D6E28732E73746172744C696E654E756D626572293B69662831213D3D732E7374617274436F';
wwv_flow_imp.g_varchar2_table(8952) := '6C756D6E7C7C732E656E64436F6C756D6E213D3D6E297B695B6F5D3D746869732E5F7265706C6163654A756D70546F4E657874496E64656E7428652C742C732C2131293B636F6E74696E75657D7D695B6F5D3D6E657720795328732C7B6973556E736869';
wwv_flow_imp.g_varchar2_table(8953) := '66743A21312C74616253697A653A652E74616253697A652C696E64656E7453697A653A652E696E64656E7453697A652C696E736572745370616365733A652E696E736572745370616365732C75736554616253746F70733A652E75736554616253746F70';
wwv_flow_imp.g_varchar2_table(8954) := '732C6175746F496E64656E743A652E6175746F496E64656E747D2C652E6C616E6775616765436F6E66696775726174696F6E53657276696365297D7D72657475726E20697D73746174696320636F6D706F736974696F6E5479706528652C742C6E2C692C';
wwv_flow_imp.g_varchar2_table(8955) := '6F2C732C722C61297B636F6E7374206C3D692E6D61702828653D3E746869732E5F636F6D706F736974696F6E54797065286E2C652C6F2C732C722C612929293B72657475726E206E6577204A4328342C6C2C7B73686F756C6450757368537461636B456C';
wwv_flow_imp.g_varchar2_table(8956) := '656D656E744265666F72653A495328652C34292C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D737461746963205F636F6D706F736974696F6E5479706528652C742C6E2C692C6F2C73297B69662821742E6973456D';
wwv_flow_imp.g_varchar2_table(8957) := '70747928292972657475726E206E756C6C3B636F6E737420723D742E676574506F736974696F6E28292C613D4D6174682E6D617828312C722E636F6C756D6E2D69292C6C3D4D6174682E6D696E28652E6765744C696E654D6178436F6C756D6E28722E6C';
wwv_flow_imp.g_varchar2_table(8958) := '696E654E756D626572292C722E636F6C756D6E2B6F292C633D6E657720726828722E6C696E654E756D6265722C612C722E6C696E654E756D6265722C6C293B72657475726E20652E67657456616C7565496E52616E67652863293D3D3D6E2626303D3D3D';
wwv_flow_imp.g_varchar2_table(8959) := '733F6E756C6C3A6E657720735328632C6E2C302C73297D737461746963205F74797065436F6D6D616E6428652C742C6E297B72657475726E206E3F6E6577206F5328652C742C2130293A6E6577206E5328652C742C2130297D737461746963205F656E74';
wwv_flow_imp.g_varchar2_table(8960) := '657228652C742C6E2C69297B696628303D3D3D652E6175746F496E64656E742972657475726E2045532E5F74797065436F6D6D616E6428692C225C6E222C6E293B69662821742E746F6B656E697A6174696F6E2E69734368656170546F546F6B656E697A';
wwv_flow_imp.g_varchar2_table(8961) := '6528692E6765745374617274506F736974696F6E28292E6C696E654E756D626572297C7C313D3D3D652E6175746F496E64656E74297B636F6E7374206F3D666928742E6765744C696E65436F6E74656E7428692E73746172744C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(8962) := '292E737562737472696E6728302C692E7374617274436F6C756D6E2D31293B72657475726E2045532E5F74797065436F6D6D616E6428692C225C6E222B652E6E6F726D616C697A65496E64656E746174696F6E286F292C6E297D636F6E7374206F3D6653';
wwv_flow_imp.g_varchar2_table(8963) := '28652E6175746F496E64656E742C742C692C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286F297B6966286F2E696E64656E74416374696F6E3D3D3D50752E4E6F6E652972657475726E2045532E5F7479706543';
wwv_flow_imp.g_varchar2_table(8964) := '6F6D6D616E6428692C225C6E222B652E6E6F726D616C697A65496E64656E746174696F6E286F2E696E64656E746174696F6E2B6F2E617070656E6454657874292C6E293B6966286F2E696E64656E74416374696F6E3D3D3D50752E496E64656E74297265';
wwv_flow_imp.g_varchar2_table(8965) := '7475726E2045532E5F74797065436F6D6D616E6428692C225C6E222B652E6E6F726D616C697A65496E64656E746174696F6E286F2E696E64656E746174696F6E2B6F2E617070656E6454657874292C6E293B6966286F2E696E64656E74416374696F6E3D';
wwv_flow_imp.g_varchar2_table(8966) := '3D3D50752E496E64656E744F757464656E74297B636F6E737420743D652E6E6F726D616C697A65496E64656E746174696F6E286F2E696E64656E746174696F6E292C733D652E6E6F726D616C697A65496E64656E746174696F6E286F2E696E64656E7461';
wwv_flow_imp.g_varchar2_table(8967) := '74696F6E2B6F2E617070656E6454657874292C723D225C6E222B732B225C6E222B743B72657475726E206E3F6E6577206F5328692C722C2130293A6E657720735328692C722C2D312C732E6C656E6774682D742E6C656E6774682C2130297D6966286F2E';
wwv_flow_imp.g_varchar2_table(8968) := '696E64656E74416374696F6E3D3D3D50752E4F757464656E74297B636F6E737420743D45532E756E7368696674496E64656E7428652C6F2E696E64656E746174696F6E293B72657475726E2045532E5F74797065436F6D6D616E6428692C225C6E222B65';
wwv_flow_imp.g_varchar2_table(8969) := '2E6E6F726D616C697A65496E64656E746174696F6E28742B6F2E617070656E6454657874292C6E297D7D636F6E737420733D666928742E6765744C696E65436F6E74656E7428692E73746172744C696E654E756D62657229292E737562737472696E6728';
wwv_flow_imp.g_varchar2_table(8970) := '302C692E7374617274436F6C756D6E2D31293B696628652E6175746F496E64656E743E3D34297B636F6E7374206F3D66756E6374696F6E28652C742C6E2C692C6F297B696628653C342972657475726E206E756C6C3B742E746F6B656E697A6174696F6E';
wwv_flow_imp.g_varchar2_table(8971) := '2E666F726365546F6B656E697A6174696F6E286E2E73746172744C696E654E756D626572293B636F6E737420733D742E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E73286E2E73746172744C696E654E756D626572292C723D42752873';
wwv_flow_imp.g_varchar2_table(8972) := '2C6E2E7374617274436F6C756D6E2D31292C613D722E6765744C696E65436F6E74656E7428293B6C6574206C2C632C643D21313B722E6669727374436861724F66667365743E302626732E6765744C616E67756167654964283029213D3D722E6C616E67';
wwv_flow_imp.g_varchar2_table(8973) := '7561676549643F28643D21302C6C3D612E73756273747228302C6E2E7374617274436F6C756D6E2D312D722E6669727374436861724F666673657429293A6C3D732E6765744C696E65436F6E74656E7428292E737562737472696E6728302C6E2E737461';
wwv_flow_imp.g_varchar2_table(8974) := '7274436F6C756D6E2D31292C633D6E2E6973456D70747928293F612E737562737472286E2E7374617274436F6C756D6E2D312D722E6669727374436861724F6666736574293A736728742C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C75';
wwv_flow_imp.g_varchar2_table(8975) := '6D6E292E6765744C696E65436F6E74656E7428292E737562737472286E2E656E64436F6C756D6E2D312D722E6669727374436861724F6666736574293B636F6E737420683D6F2E6765744C616E6775616765436F6E66696775726174696F6E28722E6C61';
wwv_flow_imp.g_varchar2_table(8976) := '6E67756167654964292E696E64656E7452756C6573537570706F72743B69662821682972657475726E206E756C6C3B636F6E737420753D6C2C703D6669286C292C673D7B746F6B656E697A6174696F6E3A7B6765744C696E65546F6B656E733A653D3E74';
wwv_flow_imp.g_varchar2_table(8977) := '2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732865292C6765744C616E677561676549643A28293D3E742E6765744C616E6775616765496428292C6765744C616E677561676549644174506F736974696F6E3A28652C6E293D3E742E';
wwv_flow_imp.g_varchar2_table(8978) := '6765744C616E677561676549644174506F736974696F6E28652C6E297D2C6765744C696E65436F6E74656E743A653D3E653D3D3D6E2E73746172744C696E654E756D6265723F753A742E6765744C696E65436F6E74656E742865297D2C6D3D666928732E';
wwv_flow_imp.g_varchar2_table(8979) := '6765744C696E65436F6E74656E742829292C663D535328652C672C6E2E73746172744C696E654E756D6265722B312C766F696420302C6F293B6966282166297B636F6E737420653D643F6D3A703B72657475726E7B6265666F7265456E7465723A652C61';
wwv_flow_imp.g_varchar2_table(8980) := '66746572456E7465723A657D7D6C657420763D643F6D3A662E696E64656E746174696F6E3B72657475726E20662E616374696F6E3D3D3D50752E496E64656E74262628763D692E7368696674496E64656E74287629292C682E73686F756C644465637265';
wwv_flow_imp.g_varchar2_table(8981) := '617365286329262628763D692E756E7368696674496E64656E74287629292C7B6265666F7265456E7465723A643F6D3A702C6166746572456E7465723A767D7D28652E6175746F496E64656E742C742C692C7B756E7368696674496E64656E743A743D3E';
wwv_flow_imp.g_varchar2_table(8982) := '45532E756E7368696674496E64656E7428652C74292C7368696674496E64656E743A743D3E45532E7368696674496E64656E7428652C74292C6E6F726D616C697A65496E64656E746174696F6E3A743D3E652E6E6F726D616C697A65496E64656E746174';
wwv_flow_imp.g_varchar2_table(8983) := '696F6E2874297D2C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286F297B6C657420733D652E76697369626C65436F6C756D6E46726F6D436F6C756D6E28742C692E676574456E64506F736974696F6E2829293B';
wwv_flow_imp.g_varchar2_table(8984) := '636F6E737420723D692E656E64436F6C756D6E2C613D6D6928742E6765744C696E65436F6E74656E7428692E656E644C696E654E756D62657229293B696628693D613E3D303F692E736574456E64506F736974696F6E28692E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(8985) := '65722C4D6174682E6D617828692E656E64436F6C756D6E2C612B3129293A692E736574456E64506F736974696F6E28692E656E644C696E654E756D6265722C742E6765744C696E654D6178436F6C756D6E28692E656E644C696E654E756D62657229292C';
wwv_flow_imp.g_varchar2_table(8986) := '6E2972657475726E206E6577206F5328692C225C6E222B652E6E6F726D616C697A65496E64656E746174696F6E286F2E6166746572456E746572292C2130293B7B6C657420743D303B72657475726E20723C3D612B31262628652E696E73657274537061';
wwv_flow_imp.g_varchar2_table(8987) := '6365737C7C28733D4D6174682E6365696C28732F652E696E64656E7453697A6529292C743D4D6174682E6D696E28732B312D652E6E6F726D616C697A65496E64656E746174696F6E286F2E6166746572456E746572292E6C656E6774682D312C3029292C';
wwv_flow_imp.g_varchar2_table(8988) := '6E657720735328692C225C6E222B652E6E6F726D616C697A65496E64656E746174696F6E286F2E6166746572456E746572292C302C742C2130297D7D7D72657475726E2045532E5F74797065436F6D6D616E6428692C225C6E222B652E6E6F726D616C69';
wwv_flow_imp.g_varchar2_table(8989) := '7A65496E64656E746174696F6E2873292C6E297D737461746963205F69734175746F496E64656E745479706528652C742C6E297B696628652E6175746F496E64656E743C342972657475726E21313B666F72286C657420653D302C693D6E2E6C656E6774';
wwv_flow_imp.g_varchar2_table(8990) := '683B653C693B652B2B2969662821742E746F6B656E697A6174696F6E2E69734368656170546F546F6B656E697A65286E5B655D2E676574456E64506F736974696F6E28292E6C696E654E756D626572292972657475726E21313B72657475726E21307D73';
wwv_flow_imp.g_varchar2_table(8991) := '7461746963205F72756E4175746F496E64656E745479706528652C742C6E2C69297B636F6E7374206F3D6F6728742C6E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E292C733D66756E6374696F6E28652C742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(8992) := '2C73297B696628653C342972657475726E206E756C6C3B636F6E737420723D736728742C6E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E293B696628722E6669727374436861724F66667365742972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(8993) := '6C3B636F6E737420613D732E6765744C616E6775616765436F6E66696775726174696F6E28722E6C616E67756167654964292E696E64656E7452756C6573537570706F72743B69662821612972657475726E206E756C6C3B636F6E7374206C3D722E6765';
wwv_flow_imp.g_varchar2_table(8994) := '744C696E65436F6E74656E7428292C633D6C2E73756273747228302C6E2E7374617274436F6C756D6E2D312D722E6669727374436861724F6666736574293B6C657420643B696628643D6E2E6973456D70747928293F6C2E737562737472286E2E737461';
wwv_flow_imp.g_varchar2_table(8995) := '7274436F6C756D6E2D312D722E6669727374436861724F6666736574293A736728742C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E292E6765744C696E65436F6E74656E7428292E737562737472286E2E656E64436F6C756D6E2D';
wwv_flow_imp.g_varchar2_table(8996) := '312D722E6669727374436861724F6666736574292C21612E73686F756C64446563726561736528632B64292626612E73686F756C64446563726561736528632B692B6429297B636F6E737420693D535328652C742C6E2E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(8997) := '65722C21312C73293B69662821692972657475726E206E756C6C3B6C657420723D692E696E64656E746174696F6E3B72657475726E20692E616374696F6E213D3D50752E496E64656E74262628723D6F2E756E7368696674496E64656E74287229292C72';
wwv_flow_imp.g_varchar2_table(8998) := '7D72657475726E206E756C6C7D28652E6175746F496E64656E742C742C6E2C692C7B7368696674496E64656E743A743D3E45532E7368696674496E64656E7428652C74292C756E7368696674496E64656E743A743D3E45532E756E7368696674496E6465';
wwv_flow_imp.g_varchar2_table(8999) := '6E7428652C74297D2C652E6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286E756C6C3D3D3D732972657475726E206E756C6C3B69662873213D3D652E6E6F726D616C697A65496E64656E746174696F6E286F29297B63';
wwv_flow_imp.g_varchar2_table(9000) := '6F6E7374206F3D742E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E286E2E73746172744C696E654E756D626572293B72657475726E20303D3D3D6F3F45532E5F74797065436F6D6D616E64286E6577207268286E2E7374';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(9001) := '6172744C696E654E756D6265722C312C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E292C652E6E6F726D616C697A65496E64656E746174696F6E2873292B692C2131293A45532E5F74797065436F6D6D616E64286E657720726828';
wwv_flow_imp.g_varchar2_table(9002) := '6E2E73746172744C696E654E756D6265722C312C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E292C652E6E6F726D616C697A65496E64656E746174696F6E2873292B742E6765744C696E65436F6E74656E74286E2E73746172744C';
wwv_flow_imp.g_varchar2_table(9003) := '696E654E756D626572292E737562737472696E67286F2D312C6E2E7374617274436F6C756D6E2D31292B692C2131297D72657475726E206E756C6C7D737461746963205F69734175746F436C6F73696E674F7665727479706528652C742C6E2C692C6F29';
wwv_flow_imp.g_varchar2_table(9004) := '7B696628226E65766572223D3D3D652E6175746F436C6F73696E674F766572747970652972657475726E21313B69662821652E6175746F436C6F73696E6750616972732E6175746F436C6F73696E675061697273436C6F736553696E676C65436861722E';
wwv_flow_imp.g_varchar2_table(9005) := '686173286F292972657475726E21313B666F72286C657420733D302C723D6E2E6C656E6774683B733C723B732B2B297B636F6E737420723D6E5B735D3B69662821722E6973456D70747928292972657475726E21313B636F6E737420613D722E67657450';
wwv_flow_imp.g_varchar2_table(9006) := '6F736974696F6E28292C6C3D742E6765744C696E65436F6E74656E7428612E6C696E654E756D626572293B6966286C2E63686172417428612E636F6C756D6E2D3129213D3D6F2972657475726E21313B636F6E737420633D6553286F293B69662839323D';
wwv_flow_imp.g_varchar2_table(9007) := '3D3D28612E636F6C756D6E3E323F6C2E63686172436F6465417428612E636F6C756D6E2D32293A30292626632972657475726E21313B696628226175746F223D3D3D652E6175746F436C6F73696E674F76657274797065297B6C657420653D21313B666F';
wwv_flow_imp.g_varchar2_table(9008) := '72286C657420743D302C6E3D692E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D695B745D3B696628612E6C696E654E756D6265723D3D3D6E2E73746172744C696E654E756D6265722626612E636F6C756D6E3D3D3D6E2E7374617274436F';
wwv_flow_imp.g_varchar2_table(9009) := '6C756D6E297B653D21303B627265616B7D7D69662821652972657475726E21317D7D72657475726E21307D737461746963205F72756E4175746F436C6F73696E674F7665727479706528652C742C6E2C692C6F297B636F6E737420733D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(9010) := '6C657420653D302C743D692E6C656E6774683B653C743B652B2B297B636F6E737420743D695B655D2E676574506F736974696F6E28292C6E3D6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C742E6C696E654E756D6265722C74';
wwv_flow_imp.g_varchar2_table(9011) := '2E636F6C756D6E2B31293B735B655D3D6E6577206E53286E2C6F297D72657475726E206E6577204A4328342C732C7B73686F756C6450757368537461636B456C656D656E744265666F72653A495328652C34292C73686F756C6450757368537461636B45';
wwv_flow_imp.g_varchar2_table(9012) := '6C656D656E7441667465723A21317D297D737461746963205F69734265666F7265436C6F73696E67427261636528652C74297B636F6E7374206E3D742E6368617241742830292C693D652E6175746F436C6F73696E6750616972732E6175746F436C6F73';
wwv_flow_imp.g_varchar2_table(9013) := '696E6750616972734F70656E427953746172742E676574286E297C7C5B5D2C6F3D652E6175746F436C6F73696E6750616972732E6175746F436C6F73696E675061697273436C6F7365427953746172742E676574286E297C7C5B5D2C733D692E736F6D65';
wwv_flow_imp.g_varchar2_table(9014) := '2828653D3E742E7374617274735769746828652E6F70656E2929292C723D6F2E736F6D652828653D3E742E7374617274735769746828652E636C6F73652929293B72657475726E21732626727D737461746963205F66696E644175746F436C6F73696E67';
wwv_flow_imp.g_varchar2_table(9015) := '506169724F70656E28652C742C6E2C69297B636F6E7374206F3D652E6175746F436C6F73696E6750616972732E6175746F436C6F73696E6750616972734F70656E4279456E642E6765742869293B696628216F2972657475726E206E756C6C3B6C657420';
wwv_flow_imp.g_varchar2_table(9016) := '733D6E756C6C3B666F7228636F6E73742065206F66206F296966286E756C6C3D3D3D737C7C652E6F70656E2E6C656E6774683E732E6F70656E2E6C656E677468297B6C6574206F3D21303B666F7228636F6E73742073206F66206E29696628742E676574';
wwv_flow_imp.g_varchar2_table(9017) := '56616C7565496E52616E6765286E657720726828732E6C696E654E756D6265722C732E636F6C756D6E2D652E6F70656E2E6C656E6774682B312C732E6C696E654E756D6265722C732E636F6C756D6E29292B69213D3D652E6F70656E297B6F3D21313B62';
wwv_flow_imp.g_varchar2_table(9018) := '7265616B7D6F262628733D65297D72657475726E20737D737461746963205F66696E64436F6E7461696E65644175746F436C6F73696E675061697228652C74297B696628742E6F70656E2E6C656E6774683C3D312972657475726E206E756C6C3B636F6E';
wwv_flow_imp.g_varchar2_table(9019) := '7374206E3D742E636C6F73652E63686172417428742E636C6F73652E6C656E6774682D31292C693D652E6175746F436C6F73696E6750616972732E6175746F436C6F73696E675061697273436C6F73654279456E642E676574286E297C7C5B5D3B6C6574';
wwv_flow_imp.g_varchar2_table(9020) := '206F3D6E756C6C3B666F7228636F6E73742065206F66206929652E6F70656E213D3D742E6F70656E2626742E6F70656E2E696E636C7564657328652E6F70656E292626742E636C6F73652E656E64735769746828652E636C6F736529262628216F7C7C65';
wwv_flow_imp.g_varchar2_table(9021) := '2E6F70656E2E6C656E6774683E6F2E6F70656E2E6C656E677468292626286F3D65293B72657475726E206F7D737461746963205F6765744175746F436C6F73696E6750616972436C6F736528652C742C6E2C692C6F297B666F7228636F6E73742065206F';
wwv_flow_imp.g_varchar2_table(9022) := '66206E2969662821652E6973456D70747928292972657475726E206E756C6C3B636F6E737420733D6E2E6D61702828653D3E7B636F6E737420743D652E676574506F736974696F6E28293B72657475726E206F3F7B6C696E654E756D6265723A742E6C69';
wwv_flow_imp.g_varchar2_table(9023) := '6E654E756D6265722C6265666F7265436F6C756D6E3A742E636F6C756D6E2D692E6C656E6774682C6166746572436F6C756D6E3A742E636F6C756D6E7D3A7B6C696E654E756D6265723A742E6C696E654E756D6265722C6265666F7265436F6C756D6E3A';
wwv_flow_imp.g_varchar2_table(9024) := '742E636F6C756D6E2C6166746572436F6C756D6E3A742E636F6C756D6E7D7D29292C723D746869732E5F66696E644175746F436C6F73696E67506169724F70656E28652C742C732E6D61702828653D3E6E6577206D6328652E6C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(9025) := '652E6265666F7265436F6C756D6E2929292C69293B69662821722972657475726E206E756C6C3B6C657420612C6C3B69662865532869293F28613D652E6175746F436C6F73696E6751756F7465732C6C3D652E73686F756C644175746F436C6F73654265';
wwv_flow_imp.g_varchar2_table(9026) := '666F72652E71756F7465293A652E626C6F636B436F6D6D656E745374617274546F6B656E2626722E6F70656E2E696E636C7564657328652E626C6F636B436F6D6D656E745374617274546F6B656E293F28613D652E6175746F436C6F73696E67436F6D6D';
wwv_flow_imp.g_varchar2_table(9027) := '656E74732C6C3D652E73686F756C644175746F436C6F73654265666F72652E636F6D6D656E74293A28613D652E6175746F436C6F73696E67427261636B6574732C6C3D652E73686F756C644175746F436C6F73654265666F72652E627261636B6574292C';
wwv_flow_imp.g_varchar2_table(9028) := '226E65766572223D3D3D612972657475726E206E756C6C3B636F6E737420633D746869732E5F66696E64436F6E7461696E65644175746F436C6F73696E675061697228652C72292C643D633F632E636C6F73653A22223B6C657420683D21303B666F7228';
wwv_flow_imp.g_varchar2_table(9029) := '636F6E7374206E206F662073297B636F6E73747B6C696E654E756D6265723A6F2C6265666F7265436F6C756D6E3A732C6166746572436F6C756D6E3A637D3D6E2C753D742E6765744C696E65436F6E74656E74286F292C703D752E737562737472696E67';
wwv_flow_imp.g_varchar2_table(9030) := '28302C732D31292C673D752E737562737472696E6728632D31293B696628672E737461727473576974682864297C7C28683D2131292C672E6C656E6774683E30297B636F6E737420743D672E6368617241742830293B6966282145532E5F69734265666F';
wwv_flow_imp.g_varchar2_table(9031) := '7265436C6F73696E67427261636528652C67292626216C2874292972657475726E206E756C6C7D696628313D3D3D722E6F70656E2E6C656E6774682626282227223D3D3D697C7C2722273D3D3D6929262622616C7761797322213D3D61297B636F6E7374';
wwv_flow_imp.g_varchar2_table(9032) := '20743D597928652E776F7264536570617261746F72732C5B5D293B696628702E6C656E6774683E30297B636F6E737420653D702E63686172436F6465417428702E6C656E6774682D31293B696628303D3D3D742E6765742865292972657475726E206E75';
wwv_flow_imp.g_varchar2_table(9033) := '6C6C7D7D69662821742E746F6B656E697A6174696F6E2E69734368656170546F546F6B656E697A65286F292972657475726E206E756C6C3B742E746F6B656E697A6174696F6E2E666F726365546F6B656E697A6174696F6E286F293B636F6E7374206D3D';
wwv_flow_imp.g_varchar2_table(9034) := '427528742E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E73286F292C732D31293B69662821722E73686F756C644175746F436C6F7365286D2C732D6D2E6669727374436861724F6666736574292972657475726E206E756C6C3B636F6E';
wwv_flow_imp.g_varchar2_table(9035) := '737420663D722E66696E644E65757472616C43686172616374657228293B69662866297B636F6E737420653D742E746F6B656E697A6174696F6E2E676574546F6B656E547970654966496E73657274696E67436861726163746572286F2C732C66293B69';
wwv_flow_imp.g_varchar2_table(9036) := '662821722E69734F4B2865292972657475726E206E756C6C7D7D72657475726E20683F722E636C6F73652E737562737472696E6728302C722E636C6F73652E6C656E6774682D642E6C656E677468293A722E636C6F73657D737461746963205F72756E41';
wwv_flow_imp.g_varchar2_table(9037) := '75746F436C6F73696E674F70656E436861725479706528652C742C6E2C692C6F2C732C72297B636F6E737420613D5B5D3B666F72286C657420653D302C743D692E6C656E6774683B653C743B652B2B297B636F6E737420743D695B655D3B615B655D3D6E';
wwv_flow_imp.g_varchar2_table(9038) := '6577204C5328742C6F2C21732C72297D72657475726E206E6577204A4328342C612C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D';
wwv_flow_imp.g_varchar2_table(9039) := '737461746963205F73686F756C64537572726F756E644368617228652C74297B72657475726E2065532874293F2271756F746573223D3D3D652E6175746F537572726F756E647C7C226C616E6775616765446566696E6564223D3D3D652E6175746F5375';
wwv_flow_imp.g_varchar2_table(9040) := '72726F756E643A22627261636B657473223D3D3D652E6175746F537572726F756E647C7C226C616E6775616765446566696E6564223D3D3D652E6175746F537572726F756E647D737461746963205F6973537572726F756E6453656C656374696F6E5479';
wwv_flow_imp.g_varchar2_table(9041) := '706528652C742C6E2C69297B6966282145532E5F73686F756C64537572726F756E644368617228652C69297C7C21652E737572726F756E64696E6750616972732E6861734F776E50726F70657274792869292972657475726E21313B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(9042) := '65532869293B666F7228636F6E73742065206F66206E297B696628652E6973456D70747928292972657475726E21313B6C6574206E3D21303B666F72286C657420693D652E73746172744C696E654E756D6265723B693C3D652E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(9043) := '6265723B692B2B297B636F6E7374206F3D742E6765744C696E65436F6E74656E742869292C733D693D3D3D652E73746172744C696E654E756D6265723F652E7374617274436F6C756D6E2D313A302C723D693D3D3D652E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(9044) := '3F652E656E64436F6C756D6E2D313A6F2E6C656E6774682C613D6F2E737562737472696E6728732C72293B6966282F5B5E205C745D2F2E74657374286129297B6E3D21313B627265616B7D7D6966286E2972657475726E21313B6966286F2626652E7374';
wwv_flow_imp.g_varchar2_table(9045) := '6172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626652E7374617274436F6C756D6E2B313D3D3D652E656E64436F6C756D6E2626655328742E67657456616C7565496E52616E6765286529292972657475726E21317D7265';
wwv_flow_imp.g_varchar2_table(9046) := '7475726E21307D737461746963205F72756E537572726F756E6453656C656374696F6E5479706528652C742C6E2C692C6F297B636F6E737420733D5B5D3B666F72286C657420653D302C6E3D692E6C656E6774683B653C6E3B652B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(9047) := '6E3D695B655D2C723D742E737572726F756E64696E6750616972735B6F5D3B735B655D3D6E6577207753286E2C6F2C72297D72657475726E206E6577204A4328302C732C7B73686F756C6450757368537461636B456C656D656E744265666F72653A2130';
wwv_flow_imp.g_varchar2_table(9048) := '2C73686F756C6450757368537461636B456C656D656E7441667465723A21307D297D737461746963205F697354797065496E746572636570746F72456C6563747269634368617228652C742C6E297B72657475726E212831213D3D6E2E6C656E6774687C';
wwv_flow_imp.g_varchar2_table(9049) := '7C21742E746F6B656E697A6174696F6E2E69734368656170546F546F6B656E697A65286E5B305D2E676574456E64506F736974696F6E28292E6C696E654E756D62657229297D737461746963205F74797065496E746572636570746F72456C6563747269';
wwv_flow_imp.g_varchar2_table(9050) := '634368617228652C742C6E2C692C6F297B69662821742E656C65637472696343686172732E6861734F776E50726F7065727479286F297C7C21692E6973456D70747928292972657475726E206E756C6C3B636F6E737420733D692E676574506F73697469';
wwv_flow_imp.g_varchar2_table(9051) := '6F6E28293B6E2E746F6B656E697A6174696F6E2E666F726365546F6B656E697A6174696F6E28732E6C696E654E756D626572293B636F6E737420723D6E2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E7328732E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(9052) := '72293B6C657420613B7472797B613D742E6F6E456C656374726963436861726163746572286F2C722C732E636F6C756D6E297D63617463682865297B72657475726E206B652865292C6E756C6C7D69662821612972657475726E206E756C6C3B69662861';
wwv_flow_imp.g_varchar2_table(9053) := '2E6D617463684F70656E427261636B6574297B636F6E737420693D28722E6765744C696E65436F6E74656E7428292B6F292E6C617374496E6465784F6628612E6D617463684F70656E427261636B6574292B312C6C3D6E2E627261636B65745061697273';
wwv_flow_imp.g_varchar2_table(9054) := '2E66696E644D61746368696E67427261636B6574557028612E6D617463684F70656E427261636B65742C7B6C696E654E756D6265723A732E6C696E654E756D6265722C636F6C756D6E3A697D2C353030293B6966286C297B6966286C2E73746172744C69';
wwv_flow_imp.g_varchar2_table(9055) := '6E654E756D6265723D3D3D732E6C696E654E756D6265722972657475726E206E756C6C3B636F6E737420693D6669286E2E6765744C696E65436F6E74656E74286C2E73746172744C696E654E756D62657229292C723D742E6E6F726D616C697A65496E64';
wwv_flow_imp.g_varchar2_table(9056) := '656E746174696F6E2869292C613D6E2E6765744C696E65436F6E74656E7428732E6C696E654E756D626572292C633D6E2E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E28732E6C696E654E756D626572297C7C732E636F';
wwv_flow_imp.g_varchar2_table(9057) := '6C756D6E2C643D722B612E737562737472696E6728632D312C732E636F6C756D6E2D31292B6F2C683D6E657720726828732E6C696E654E756D6265722C312C732E6C696E654E756D6265722C732E636F6C756D6E292C753D6E6577206E5328682C64293B';
wwv_flow_imp.g_varchar2_table(9058) := '72657475726E206E6577204A4328545328642C65292C5B755D2C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21312C73686F756C6450757368537461636B456C656D656E7441667465723A21307D297D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(9059) := '6E756C6C7D73746174696320636F6D706F736974696F6E456E6457697468496E746572636570746F727328652C742C6E2C692C6F2C73297B69662821692972657475726E206E756C6C3B6C657420723D6E756C6C3B666F7228636F6E73742065206F6620';
wwv_flow_imp.g_varchar2_table(9060) := '69296966286E756C6C3D3D3D7229723D652E696E736572746564546578743B656C73652069662872213D3D652E696E736572746564546578742972657475726E206E756C6C3B69662821727C7C31213D3D722E6C656E6774682972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(9061) := '6C3B636F6E737420613D723B6C6574206C3D21313B666F7228636F6E73742065206F6620692969662830213D3D652E64656C65746564546578742E6C656E677468297B6C3D21303B627265616B7D6966286C297B6966282145532E5F73686F756C645375';
wwv_flow_imp.g_varchar2_table(9062) := '72726F756E644368617228742C61297C7C21742E737572726F756E64696E6750616972732E6861734F776E50726F70657274792861292972657475726E206E756C6C3B636F6E737420653D65532861293B666F7228636F6E73742074206F662069297B69';
wwv_flow_imp.g_varchar2_table(9063) := '662830213D3D742E64656C6574656453656C656374696F6E53746172747C7C742E64656C6574656453656C656374696F6E456E64213D3D742E64656C65746564546578742E6C656E6774682972657475726E206E756C6C3B6966282F5E5B205C745D2B24';
wwv_flow_imp.g_varchar2_table(9064) := '2F2E7465737428742E64656C6574656454657874292972657475726E206E756C6C3B696628652626655328742E64656C6574656454657874292972657475726E206E756C6C7D636F6E7374206E3D5B5D3B666F7228636F6E73742065206F66206F297B69';
wwv_flow_imp.g_varchar2_table(9065) := '662821652E6973456D70747928292972657475726E206E756C6C3B6E2E7075736828652E676574506F736974696F6E2829297D6966286E2E6C656E677468213D3D692E6C656E6774682972657475726E206E756C6C3B636F6E737420733D5B5D3B666F72';
wwv_flow_imp.g_varchar2_table(9066) := '286C657420653D302C6F3D6E2E6C656E6774683B653C6F3B652B2B29732E70757368286E6577204353286E5B655D2C695B655D2E64656C65746564546578742C742E737572726F756E64696E6750616972735B615D29293B72657475726E206E6577204A';
wwv_flow_imp.g_varchar2_table(9067) := '4328342C732C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D696628746869732E5F69734175746F436C6F73696E674F7665727479';
wwv_flow_imp.g_varchar2_table(9068) := '706528742C6E2C6F2C732C6129297B636F6E737420653D6F2E6D61702828653D3E6E6577206E53286E657720726828652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E2C652E706F736974696F6E4C696E654E';
wwv_flow_imp.g_varchar2_table(9069) := '756D6265722C652E706F736974696F6E436F6C756D6E2B31292C22222C21312929293B72657475726E206E6577204A4328342C652C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21302C73686F756C645075736853746163';
wwv_flow_imp.g_varchar2_table(9070) := '6B456C656D656E7441667465723A21317D297D636F6E737420633D746869732E5F6765744175746F436C6F73696E6750616972436C6F736528742C6E2C6F2C612C2130293B72657475726E206E756C6C213D3D633F746869732E5F72756E4175746F436C';
wwv_flow_imp.g_varchar2_table(9071) := '6F73696E674F70656E436861725479706528652C742C6E2C6F2C612C21302C63293A6E756C6C7D737461746963207479706557697468496E746572636570746F727328652C742C6E2C692C6F2C732C72297B69662821652626225C6E223D3D3D72297B63';
wwv_flow_imp.g_varchar2_table(9072) := '6F6E737420653D5B5D3B666F72286C657420743D302C733D6F2E6C656E6774683B743C733B742B2B29655B745D3D45532E5F656E746572286E2C692C21312C6F5B745D293B72657475726E206E6577204A4328342C652C7B73686F756C64507573685374';
wwv_flow_imp.g_varchar2_table(9073) := '61636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D69662821652626746869732E5F69734175746F496E64656E7454797065286E2C692C6F29297B636F6E737420653D5B';
wwv_flow_imp.g_varchar2_table(9074) := '5D3B6C657420743D21313B666F72286C657420733D302C613D6F2E6C656E6774683B733C613B732B2B29696628655B735D3D746869732E5F72756E4175746F496E64656E7454797065286E2C692C6F5B735D2C72292C21655B735D297B743D21303B6272';
wwv_flow_imp.g_varchar2_table(9075) := '65616B7D69662821742972657475726E206E6577204A4328342C652C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21302C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D696628746869';
wwv_flow_imp.g_varchar2_table(9076) := '732E5F69734175746F436C6F73696E674F76657274797065286E2C692C6F2C732C72292972657475726E20746869732E5F72756E4175746F436C6F73696E674F7665727479706528742C6E2C692C6F2C72293B6966282165297B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(9077) := '69732E5F6765744175746F436C6F73696E6750616972436C6F7365286E2C692C6F2C722C2131293B696628652972657475726E20746869732E5F72756E4175746F436C6F73696E674F70656E436861725479706528742C6E2C692C6F2C722C21312C6529';
wwv_flow_imp.g_varchar2_table(9078) := '7D69662821652626746869732E5F6973537572726F756E6453656C656374696F6E54797065286E2C692C6F2C72292972657475726E20746869732E5F72756E537572726F756E6453656C656374696F6E5479706528742C6E2C692C6F2C72293B69662821';
wwv_flow_imp.g_varchar2_table(9079) := '652626746869732E5F697354797065496E746572636570746F72456C65637472696343686172286E2C692C6F29297B636F6E737420653D746869732E5F74797065496E746572636570746F72456C6563747269634368617228742C6E2C692C6F5B305D2C';
wwv_flow_imp.g_varchar2_table(9080) := '72293B696628652972657475726E20657D636F6E737420613D5B5D3B666F72286C657420653D302C743D6F2E6C656E6774683B653C743B652B2B29615B655D3D6E6577206E53286F5B655D2C72293B636F6E7374206C3D545328722C74293B7265747572';
wwv_flow_imp.g_varchar2_table(9081) := '6E206E6577204A43286C2C612C7B73686F756C6450757368537461636B456C656D656E744265666F72653A495328742C6C292C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D7374617469632074797065576974686F';
wwv_flow_imp.g_varchar2_table(9082) := '7574496E746572636570746F727328652C742C6E2C692C6F297B636F6E737420733D5B5D3B666F72286C657420653D302C743D692E6C656E6774683B653C743B652B2B29735B655D3D6E6577206E5328695B655D2C6F293B636F6E737420723D5453286F';
wwv_flow_imp.g_varchar2_table(9083) := '2C65293B72657475726E206E6577204A4328722C732C7B73686F756C6450757368537461636B456C656D656E744265666F72653A495328652C72292C73686F756C6450757368537461636B456C656D656E7441667465723A21317D297D73746174696320';
wwv_flow_imp.g_varchar2_table(9084) := '6C696E65496E736572744265666F726528652C742C6E297B6966286E756C6C3D3D3D747C7C6E756C6C3D3D3D6E2972657475726E5B5D3B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D6E2E6C656E6774683B6F3C733B6F2B2B297B6C65';
wwv_flow_imp.g_varchar2_table(9085) := '7420733D6E5B6F5D2E706F736974696F6E4C696E654E756D6265723B696628313D3D3D7329695B6F5D3D6E6577206F53286E657720726828312C312C312C31292C225C6E22293B656C73657B732D2D3B636F6E7374206E3D742E6765744C696E654D6178';
wwv_flow_imp.g_varchar2_table(9086) := '436F6C756D6E2873293B695B6F5D3D746869732E5F656E74657228652C742C21312C6E657720726828732C6E2C732C6E29297D7D72657475726E20697D737461746963206C696E65496E73657274416674657228652C742C6E297B6966286E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(9087) := '3D747C7C6E756C6C3D3D3D6E2972657475726E5B5D3B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D6E2E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D6E5B6F5D2E706F736974696F6E4C696E654E756D6265722C723D74';
wwv_flow_imp.g_varchar2_table(9088) := '2E6765744C696E654D6178436F6C756D6E2873293B695B6F5D3D746869732E5F656E74657228652C742C21312C6E657720726828732C722C732C7229297D72657475726E20697D737461746963206C696E65427265616B496E7365727428652C742C6E29';
wwv_flow_imp.g_varchar2_table(9089) := '7B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D6E2E6C656E6774683B6F3C733B6F2B2B29695B6F5D3D746869732E5F656E74657228652C742C21302C6E5B6F5D293B72657475726E20697D7D636C617373204C5320657874656E647320';
wwv_flow_imp.g_varchar2_table(9090) := '73537B636F6E7374727563746F7228652C742C6E2C69297B737570657228652C286E3F743A2222292B692C302C2D692E6C656E677468292C746869732E5F6F70656E4368617261637465723D742C746869732E5F636C6F73654368617261637465723D69';
wwv_flow_imp.g_varchar2_table(9091) := '2C746869732E636C6F736543686172616374657252616E67653D6E756C6C2C746869732E656E636C6F73696E6752616E67653D6E756C6C7D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E3D742E676574496E7665727365';
wwv_flow_imp.g_varchar2_table(9092) := '456469744F7065726174696F6E7328295B305D2E72616E67653B72657475726E20746869732E636C6F736543686172616374657252616E67653D6E6577207268286E2E73746172744C696E654E756D6265722C6E2E656E64436F6C756D6E2D746869732E';
wwv_flow_imp.g_varchar2_table(9093) := '5F636C6F73654368617261637465722E6C656E6774682C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E292C746869732E656E636C6F73696E6752616E67653D6E6577207268286E2E73746172744C696E654E756D6265722C6E2E65';
wwv_flow_imp.g_varchar2_table(9094) := '6E64436F6C756D6E2D746869732E5F6F70656E4368617261637465722E6C656E6774682D746869732E5F636C6F73654368617261637465722E6C656E6774682C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E292C73757065722E63';
wwv_flow_imp.g_varchar2_table(9095) := '6F6D70757465437572736F72537461746528652C74297D7D636C6173732044537B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E64656C65746564546578743D652C746869732E64656C6574656453656C656374696F6E5374';
wwv_flow_imp.g_varchar2_table(9096) := '6172743D742C746869732E64656C6574656453656C656374696F6E456E643D6E2C746869732E696E736572746564546578743D692C746869732E696E73657274656453656C656374696F6E53746172743D6F2C746869732E696E73657274656453656C65';
wwv_flow_imp.g_varchar2_table(9097) := '6374696F6E456E643D737D7D66756E6374696F6E20545328652C74297B72657475726E2220223D3D3D653F353D3D3D747C7C363D3D3D743F363A353A347D66756E6374696F6E20495328652C74297B72657475726E21282141532865297C7C4153287429';
wwv_flow_imp.g_varchar2_table(9098) := '297C7C35213D3D6526264D53286529213D3D4D532874297D66756E6374696F6E204D532865297B72657475726E20363D3D3D657C7C353D3D3D653F227370616365223A657D66756E6374696F6E2041532865297B72657475726E20343D3D3D657C7C353D';
wwv_flow_imp.g_varchar2_table(9099) := '3D3D657C7C363D3D3D657D636C617373204E5320657874656E64732024647B72756E456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D742E5F676574566965774D6F64656C28293B692626746869732E72756E436F726545646974';
wwv_flow_imp.g_varchar2_table(9100) := '6F72436F6D6D616E6428692C6E7C7C7B7D297D7D7661722050532C4F532C52533B2166756E6374696F6E2865297B652E6D657461646174613D7B6465736372697074696F6E3A225363726F6C6C20656469746F7220696E2074686520676976656E206469';
wwv_flow_imp.g_varchar2_table(9101) := '72656374696F6E222C617267733A5B7B6E616D653A22456469746F72207363726F6C6C20617267756D656E74206F626A656374222C6465736372697074696F6E3A2250726F70657274792D76616C756520706169727320746861742063616E2062652070';
wwv_flow_imp.g_varchar2_table(9102) := '6173736564207468726F756768207468697320617267756D656E743A5C6E5C745C745C745C745C742A2027746F273A2041206D616E6461746F727920646972656374696F6E2076616C75652E5C6E5C745C745C745C745C745C746060605C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(9103) := '745C745C745C74277570272C2027646F776E275C6E5C745C745C745C745C745C746060605C6E5C745C745C745C745C742A20276279273A20556E697420746F206D6F76652E2044656661756C7420697320636F6D7075746564206261736564206F6E2027';
wwv_flow_imp.g_varchar2_table(9104) := '746F272076616C75652E5C6E5C745C745C745C745C745C746060605C6E5C745C745C745C745C745C74276C696E65272C2027777261707065644C696E65272C202770616765272C202768616C6650616765272C2027656469746F72275C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(9105) := '5C745C745C746060605C6E5C745C745C745C745C742A202776616C7565273A204E756D626572206F6620756E69747320746F206D6F76652E2044656661756C74206973202731272E5C6E5C745C745C745C745C742A202772657665616C437572736F7227';
wwv_flow_imp.g_varchar2_table(9106) := '3A204966202774727565272072657665616C732074686520637572736F72206966206974206973206F757473696465207669657720706F72742E5C6E5C745C745C745C74222C636F6E73747261696E743A66756E6374696F6E2865297B69662821756C28';
wwv_flow_imp.g_varchar2_table(9107) := '65292972657475726E21313B636F6E737420743D653B72657475726E212821686C28742E746F297C7C21766C28742E627929262621686C28742E6279297C7C21766C28742E76616C756529262621676C28742E76616C7565297C7C21766C28742E726576';
wwv_flow_imp.g_varchar2_table(9108) := '65616C437572736F7229262621666C28742E72657665616C437572736F7229297D2C736368656D613A7B747970653A226F626A656374222C72657175697265643A5B22746F225D2C70726F706572746965733A7B746F3A7B747970653A22737472696E67';
wwv_flow_imp.g_varchar2_table(9109) := '222C656E756D3A5B227570222C22646F776E225D7D2C62793A7B747970653A22737472696E67222C656E756D3A5B226C696E65222C22777261707065644C696E65222C2270616765222C2268616C6650616765222C22656469746F72225D7D2C76616C75';
wwv_flow_imp.g_varchar2_table(9110) := '653A7B747970653A226E756D626572222C64656661756C743A317D2C72657665616C437572736F723A7B747970653A22626F6F6C65616E227D7D7D7D5D7D2C652E526177446972656374696F6E3D7B55703A227570222C52696768743A22726967687422';
wwv_flow_imp.g_varchar2_table(9111) := '2C446F776E3A22646F776E222C4C6566743A226C656674227D2C652E526177556E69743D7B4C696E653A226C696E65222C577261707065644C696E653A22777261707065644C696E65222C506167653A2270616765222C48616C66506167653A2268616C';
wwv_flow_imp.g_varchar2_table(9112) := '6650616765222C456469746F723A22656469746F72222C436F6C756D6E3A22636F6C756D6E227D2C652E70617273653D66756E6374696F6E2874297B6C6574206E2C693B73776974636828742E746F297B6361736520652E526177446972656374696F6E';
wwv_flow_imp.g_varchar2_table(9113) := '2E55703A6E3D313B627265616B3B6361736520652E526177446972656374696F6E2E52696768743A6E3D323B627265616B3B6361736520652E526177446972656374696F6E2E446F776E3A6E3D333B627265616B3B6361736520652E5261774469726563';
wwv_flow_imp.g_varchar2_table(9114) := '74696F6E2E4C6566743A6E3D343B627265616B3B64656661756C743A72657475726E206E756C6C7D73776974636828742E6279297B6361736520652E526177556E69742E4C696E653A693D313B627265616B3B6361736520652E526177556E69742E5772';
wwv_flow_imp.g_varchar2_table(9115) := '61707065644C696E653A693D323B627265616B3B6361736520652E526177556E69742E506167653A693D333B627265616B3B6361736520652E526177556E69742E48616C66506167653A693D343B627265616B3B6361736520652E526177556E69742E45';
wwv_flow_imp.g_varchar2_table(9116) := '6469746F723A693D353B627265616B3B6361736520652E526177556E69742E436F6C756D6E3A693D363B627265616B3B64656661756C743A693D327D72657475726E7B646972656374696F6E3A6E2C756E69743A692C76616C75653A4D6174682E666C6F';
wwv_flow_imp.g_varchar2_table(9117) := '6F7228742E76616C75657C7C31292C72657665616C437572736F723A2121742E72657665616C437572736F722C73656C6563743A2121742E73656C6563747D7D7D2850537C7C2850533D7B7D29292C66756E6374696F6E2865297B652E6D657461646174';
wwv_flow_imp.g_varchar2_table(9118) := '613D7B6465736372697074696F6E3A2252657665616C2074686520676976656E206C696E652061742074686520676976656E206C6F676963616C20706F736974696F6E222C617267733A5B7B6E616D653A2252657665616C206C696E6520617267756D65';
wwv_flow_imp.g_varchar2_table(9119) := '6E74206F626A656374222C6465736372697074696F6E3A2250726F70657274792D76616C756520706169727320746861742063616E20626520706173736564207468726F756768207468697320617267756D656E743A5C6E5C745C745C745C745C742A20';
wwv_flow_imp.g_varchar2_table(9120) := '276C696E654E756D626572273A2041206D616E6461746F7279206C696E65206E756D6265722076616C75652E5C6E5C745C745C745C745C742A20276174273A204C6F676963616C20706F736974696F6E206174207768696368206C696E65206861732074';
wwv_flow_imp.g_varchar2_table(9121) := '6F2062652072657665616C65642E5C6E5C745C745C745C745C745C746060605C6E5C745C745C745C745C745C7427746F70272C202763656E746572272C2027626F74746F6D275C6E5C745C745C745C745C745C746060605C6E5C745C745C745C74222C63';
wwv_flow_imp.g_varchar2_table(9122) := '6F6E73747261696E743A66756E6374696F6E2865297B69662821756C2865292972657475726E21313B636F6E737420743D653B72657475726E212821676C28742E6C696E654E756D62657229262621686C28742E6C696E654E756D626572297C7C21766C';
wwv_flow_imp.g_varchar2_table(9123) := '28742E617429262621686C28742E617429297D2C736368656D613A7B747970653A226F626A656374222C72657175697265643A5B226C696E654E756D626572225D2C70726F706572746965733A7B6C696E654E756D6265723A7B747970653A5B226E756D';
wwv_flow_imp.g_varchar2_table(9124) := '626572222C22737472696E67225D7D2C61743A7B747970653A22737472696E67222C656E756D3A5B22746F70222C2263656E746572222C22626F74746F6D225D7D7D7D7D5D7D2C652E5261774174417267756D656E743D7B546F703A22746F70222C4365';
wwv_flow_imp.g_varchar2_table(9125) := '6E7465723A2263656E746572222C426F74746F6D3A22626F74746F6D227D7D284F537C7C284F533D7B7D29293B636C6173732046537B636F6E7374727563746F722865297B652E616464496D706C656D656E746174696F6E283165342C22636F64652D65';
wwv_flow_imp.g_varchar2_table(9126) := '6469746F72222C2828652C74293D3E7B636F6E7374206E3D652E676574286763292E676574466F6375736564436F6465456469746F7228293B72657475726E2128216E7C7C216E2E68617354657874466F6375732829292626746869732E5F72756E4564';
wwv_flow_imp.g_varchar2_table(9127) := '69746F72436F6D6D616E6428652C6E2C74297D29292C652E616464496D706C656D656E746174696F6E283165332C2267656E657269632D646F6D2D696E7075742D7465787461726561222C2828652C74293D3E7B636F6E7374206E3D6A7328293B726574';
wwv_flow_imp.g_varchar2_table(9128) := '75726E2121286E26265B22696E707574222C227465787461726561225D2E696E6465784F66286E2E7461674E616D652E746F4C6F776572436173652829293E3D3029262628746869732E72756E444F4D436F6D6D616E64286E292C2130297D29292C652E';
wwv_flow_imp.g_varchar2_table(9129) := '616464496D706C656D656E746174696F6E28302C2267656E657269632D646F6D222C2828652C74293D3E7B636F6E7374206E3D652E676574286763292E676574416374697665436F6465456469746F7228293B72657475726E21216E2626286E2E666F63';
wwv_flow_imp.g_varchar2_table(9130) := '757328292C746869732E5F72756E456469746F72436F6D6D616E6428652C6E2C7429297D29297D5F72756E456469746F72436F6D6D616E6428652C742C6E297B72657475726E20746869732E72756E456469746F72436F6D6D616E6428652C742C6E297C';
wwv_flow_imp.g_varchar2_table(9131) := '7C21307D7D2166756E6374696F6E2865297B636C617373207420657874656E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F6465';
wwv_flow_imp.g_varchar2_table(9132) := '7D72756E436F7265456469746F72436F6D6D616E6428652C74297B742E706F736974696F6E262628652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C5B67532E';
wwv_flow_imp.g_varchar2_table(9133) := '6D6F7665546F28652C652E6765745072696D617279437572736F72537461746528292C746869732E5F696E53656C656374696F6E4D6F64652C742E706F736974696F6E2C742E76696577506F736974696F6E295D29262632213D3D742E72657665616C54';
wwv_flow_imp.g_varchar2_table(9134) := '7970652626652E72657665616C416C6C437572736F727328742E736F757263652C21302C213029297D7D652E4D6F7665546F3D5964286E65772074287B69643A225F6D6F7665546F222C696E53656C656374696F6E4D6F64653A21312C707265636F6E64';
wwv_flow_imp.g_varchar2_table(9135) := '6974696F6E3A766F696420307D29292C652E4D6F7665546F53656C6563743D5964286E65772074287B69643A225F6D6F7665546F53656C656374222C696E53656C656374696F6E4D6F64653A21302C707265636F6E646974696F6E3A766F696420307D29';
wwv_flow_imp.g_varchar2_table(9136) := '293B636C617373206E20657874656E6473204E537B72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428293B636F6E7374206E3D746869732E5F676574436F6C756D6E53656C';
wwv_flow_imp.g_varchar2_table(9137) := '656374526573756C7428652C652E6765745072696D617279437572736F72537461746528292C652E676574437572736F72436F6C756D6E53656C6563744461746128292C74293B6E756C6C213D3D6E262628652E736574437572736F7253746174657328';
wwv_flow_imp.g_varchar2_table(9138) := '742E736F757263652C332C6E2E766965775374617465732E6D61702828653D3E51432E66726F6D5669657753746174652865292929292C652E736574437572736F72436F6C756D6E53656C65637444617461287B69735265616C3A21302C66726F6D5669';
wwv_flow_imp.g_varchar2_table(9139) := '65774C696E654E756D6265723A6E2E66726F6D4C696E654E756D6265722C66726F6D5669657756697375616C436F6C756D6E3A6E2E66726F6D56697375616C436F6C756D6E2C746F566965774C696E654E756D6265723A6E2E746F4C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(9140) := '722C746F5669657756697375616C436F6C756D6E3A6E2E746F56697375616C436F6C756D6E7D292C6E2E72657665727365643F652E72657665616C546F704D6F7374437572736F7228742E736F75726365293A652E72657665616C426F74746F6D4D6F73';
wwv_flow_imp.g_varchar2_table(9141) := '74437572736F7228742E736F7572636529297D7D652E436F6C756D6E53656C6563743D5964286E657720636C61737320657874656E6473206E7B636F6E7374727563746F7228297B7375706572287B69643A22636F6C756D6E53656C656374222C707265';
wwv_flow_imp.g_varchar2_table(9142) := '636F6E646974696F6E3A766F696420307D297D5F676574436F6C756D6E53656C656374526573756C7428652C742C6E2C69297B696628766F696420303D3D3D692E706F736974696F6E7C7C766F696420303D3D3D692E76696577506F736974696F6E7C7C';
wwv_flow_imp.g_varchar2_table(9143) := '766F696420303D3D3D692E6D6F757365436F6C756D6E2972657475726E206E756C6C3B636F6E7374206F3D652E6D6F64656C2E76616C6964617465506F736974696F6E28692E706F736974696F6E292C733D652E636F6F7264696E61746573436F6E7665';
wwv_flow_imp.g_varchar2_table(9144) := '727465722E76616C696461746556696577506F736974696F6E286E6577206D6328692E76696577506F736974696F6E2E6C696E654E756D6265722C692E76696577506F736974696F6E2E636F6C756D6E292C6F292C723D692E646F436F6C756D6E53656C';
wwv_flow_imp.g_varchar2_table(9145) := '6563743F6E2E66726F6D566965774C696E654E756D6265723A732E6C696E654E756D6265722C613D692E646F436F6C756D6E53656C6563743F6E2E66726F6D5669657756697375616C436F6C756D6E3A692E6D6F757365436F6C756D6E2D313B72657475';
wwv_flow_imp.g_varchar2_table(9146) := '726E2074532E636F6C756D6E53656C65637428652E637572736F72436F6E6669672C652C722C612C732E6C696E654E756D6265722C692E6D6F757365436F6C756D6E2D31297D7D292C652E437572736F72436F6C756D6E53656C6563744C6566743D5964';
wwv_flow_imp.g_varchar2_table(9147) := '286E657720636C61737320657874656E6473206E7B636F6E7374727563746F7228297B7375706572287B69643A22637572736F72436F6C756D6E53656C6563744C656674222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765';
wwv_flow_imp.g_varchar2_table(9148) := '696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A333539392C6C696E75783A7B7072696D6172793A307D7D7D297D5F676574436F6C756D6E53656C656374526573756C7428652C742C6E2C69297B7265';
wwv_flow_imp.g_varchar2_table(9149) := '7475726E2074532E636F6C756D6E53656C6563744C65667428652E637572736F72436F6E6669672C652C6E297D7D292C652E437572736F72436F6C756D6E53656C65637452696768743D5964286E657720636C61737320657874656E6473206E7B636F6E';
wwv_flow_imp.g_varchar2_table(9150) := '7374727563746F7228297B7375706572287B69643A22637572736F72436F6C756D6E53656C6563745269676874222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E';
wwv_flow_imp.g_varchar2_table(9151) := '707574466F6375732C7072696D6172793A333630312C6C696E75783A7B7072696D6172793A307D7D7D297D5F676574436F6C756D6E53656C656374526573756C7428652C742C6E2C69297B72657475726E2074532E636F6C756D6E53656C656374526967';
wwv_flow_imp.g_varchar2_table(9152) := '687428652E637572736F72436F6E6669672C652C6E297D7D293B636C617373206920657874656E6473206E7B636F6E7374727563746F722865297B73757065722865292C746869732E5F697350616765643D652E697350616765647D5F676574436F6C75';
wwv_flow_imp.g_varchar2_table(9153) := '6D6E53656C656374526573756C7428652C742C6E2C69297B72657475726E2074532E636F6C756D6E53656C656374557028652E637572736F72436F6E6669672C652C6E2C746869732E5F69735061676564297D7D652E437572736F72436F6C756D6E5365';
wwv_flow_imp.g_varchar2_table(9154) := '6C65637455703D5964286E65772069287B697350616765643A21312C69643A22637572736F72436F6C756D6E53656C6563745570222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C68';
wwv_flow_imp.g_varchar2_table(9155) := '2E74657874496E707574466F6375732C7072696D6172793A333630302C6C696E75783A7B7072696D6172793A307D7D7D29292C652E437572736F72436F6C756D6E53656C6563745061676555703D5964286E65772069287B697350616765643A21302C69';
wwv_flow_imp.g_varchar2_table(9156) := '643A22637572736F72436F6C756D6E53656C656374506167655570222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A33';
wwv_flow_imp.g_varchar2_table(9157) := '3539352C6C696E75783A7B7072696D6172793A307D7D7D29293B636C617373206F20657874656E6473206E7B636F6E7374727563746F722865297B73757065722865292C746869732E5F697350616765643D652E697350616765647D5F676574436F6C75';
wwv_flow_imp.g_varchar2_table(9158) := '6D6E53656C656374526573756C7428652C742C6E2C69297B72657475726E2074532E636F6C756D6E53656C656374446F776E28652E637572736F72436F6E6669672C652C6E2C746869732E5F69735061676564297D7D652E437572736F72436F6C756D6E';
wwv_flow_imp.g_varchar2_table(9159) := '53656C656374446F776E3D5964286E6577206F287B697350616765643A21312C69643A22637572736F72436F6C756D6E53656C656374446F776E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B6245';
wwv_flow_imp.g_varchar2_table(9160) := '7870723A6C682E74657874496E707574466F6375732C7072696D6172793A333630322C6C696E75783A7B7072696D6172793A307D7D7D29292C652E437572736F72436F6C756D6E53656C65637450616765446F776E3D5964286E6577206F287B69735061';
wwv_flow_imp.g_varchar2_table(9161) := '6765643A21302C69643A22637572736F72436F6C756D6E53656C65637450616765446F776E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F637573';
wwv_flow_imp.g_varchar2_table(9162) := '2C7072696D6172793A333539362C6C696E75783A7B7072696D6172793A307D7D7D29293B636C617373207320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A22637572736F724D6F7665222C707265636F6E6469';
wwv_flow_imp.g_varchar2_table(9163) := '74696F6E3A766F696420302C6D657461646174613A6D532E6D657461646174617D297D72756E436F7265456469746F72436F6D6D616E6428652C74297B636F6E7374206E3D6D532E70617273652874293B6E2626746869732E5F72756E437572736F724D';
wwv_flow_imp.g_varchar2_table(9164) := '6F766528652C742E736F757263652C6E297D5F72756E437572736F724D6F766528652C742C6E297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742C332C732E5F6D6F766528652C65';
wwv_flow_imp.g_varchar2_table(9165) := '2E676574437572736F7253746174657328292C6E29292C652E72657665616C416C6C437572736F727328742C2130297D737461746963205F6D6F766528652C742C6E297B636F6E737420693D6E2E73656C6563742C6F3D6E2E76616C75653B7377697463';
wwv_flow_imp.g_varchar2_table(9166) := '68286E2E646972656374696F6E297B6361736520303A6361736520313A6361736520323A6361736520333A6361736520343A6361736520353A6361736520363A6361736520373A6361736520383A6361736520393A636173652031303A72657475726E20';
wwv_flow_imp.g_varchar2_table(9167) := '67532E73696D706C654D6F766528652C742C6E2E646972656374696F6E2C692C6F2C6E2E756E6974293B636173652031313A636173652031333A636173652031323A636173652031343A72657475726E2067532E76696577706F72744D6F766528652C74';
wwv_flow_imp.g_varchar2_table(9168) := '2C6E2E646972656374696F6E2C692C6F293B64656661756C743A72657475726E206E756C6C7D7D7D652E437572736F724D6F7665496D706C3D732C652E437572736F724D6F76653D5964286E65772073293B636C617373207220657874656E6473204E53';
wwv_flow_imp.g_varchar2_table(9169) := '7B636F6E7374727563746F722865297B73757065722865292C746869732E5F737461746963417267733D652E617267737D72756E436F7265456469746F72436F6D6D616E6428652C74297B6C6574206E3D746869732E5F737461746963417267733B2D31';
wwv_flow_imp.g_varchar2_table(9170) := '3D3D3D746869732E5F737461746963417267732E76616C75652626286E3D7B646972656374696F6E3A746869732E5F737461746963417267732E646972656374696F6E2C756E69743A746869732E5F737461746963417267732E756E69742C73656C6563';
wwv_flow_imp.g_varchar2_table(9171) := '743A746869732E5F737461746963417267732E73656C6563742C76616C75653A742E7061676553697A657C7C652E637572736F72436F6E6669672E7061676553697A657D292C652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E73';
wwv_flow_imp.g_varchar2_table(9172) := '6574437572736F7253746174657328742E736F757263652C332C67532E73696D706C654D6F766528652C652E676574437572736F7253746174657328292C6E2E646972656374696F6E2C6E2E73656C6563742C6E2E76616C75652C6E2E756E697429292C';
wwv_flow_imp.g_varchar2_table(9173) := '652E72657665616C416C6C437572736F727328742E736F757263652C2130297D7D652E437572736F724C6566743D5964286E65772072287B617267733A7B646972656374696F6E3A302C756E69743A302C73656C6563743A21312C76616C75653A317D2C';
wwv_flow_imp.g_varchar2_table(9174) := '69643A22637572736F724C656674222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31352C6D61633A7B7072696D6172';
wwv_flow_imp.g_varchar2_table(9175) := '793A31352C7365636F6E646172793A5B3238385D7D7D7D29292C652E437572736F724C65667453656C6563743D5964286E65772072287B617267733A7B646972656374696F6E3A302C756E69743A302C73656C6563743A21302C76616C75653A317D2C69';
wwv_flow_imp.g_varchar2_table(9176) := '643A22637572736F724C65667453656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313033397D7D29292C';
wwv_flow_imp.g_varchar2_table(9177) := '652E437572736F7252696768743D5964286E65772072287B617267733A7B646972656374696F6E3A312C756E69743A302C73656C6563743A21312C76616C75653A317D2C69643A22637572736F725269676874222C707265636F6E646974696F6E3A766F';
wwv_flow_imp.g_varchar2_table(9178) := '696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31372C6D61633A7B7072696D6172793A31372C7365636F6E646172793A5B3239325D7D7D7D29292C652E437572';
wwv_flow_imp.g_varchar2_table(9179) := '736F72526967687453656C6563743D5964286E65772072287B617267733A7B646972656374696F6E3A312C756E69743A302C73656C6563743A21302C76616C75653A317D2C69643A22637572736F72526967687453656C656374222C707265636F6E6469';
wwv_flow_imp.g_varchar2_table(9180) := '74696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313034317D7D29292C652E437572736F7255703D5964286E65772072287B617267733A7B6469';
wwv_flow_imp.g_varchar2_table(9181) := '72656374696F6E3A322C756E69743A322C73656C6563743A21312C76616C75653A317D2C69643A22637572736F725570222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E746578';
wwv_flow_imp.g_varchar2_table(9182) := '74496E707574466F6375732C7072696D6172793A31362C6D61633A7B7072696D6172793A31362C7365636F6E646172793A5B3330325D7D7D7D29292C652E437572736F72557053656C6563743D5964286E65772072287B617267733A7B64697265637469';
wwv_flow_imp.g_varchar2_table(9183) := '6F6E3A322C756E69743A322C73656C6563743A21302C76616C75653A317D2C69643A22637572736F72557053656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E7465';
wwv_flow_imp.g_varchar2_table(9184) := '7874496E707574466F6375732C7072696D6172793A313034302C7365636F6E646172793A5B333038385D2C6D61633A7B7072696D6172793A313034307D2C6C696E75783A7B7072696D6172793A313034307D7D7D29292C652E437572736F725061676555';
wwv_flow_imp.g_varchar2_table(9185) := '703D5964286E65772072287B617267733A7B646972656374696F6E3A322C756E69743A322C73656C6563743A21312C76616C75653A2D317D2C69643A22637572736F72506167655570222C707265636F6E646974696F6E3A766F696420302C6B624F7074';
wwv_flow_imp.g_varchar2_table(9186) := '733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31317D7D29292C652E437572736F7250616765557053656C6563743D5964286E65772072287B617267733A7B646972656374696F6E3A32';
wwv_flow_imp.g_varchar2_table(9187) := '2C756E69743A322C73656C6563743A21302C76616C75653A2D317D2C69643A22637572736F7250616765557053656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74';
wwv_flow_imp.g_varchar2_table(9188) := '657874496E707574466F6375732C7072696D6172793A313033357D7D29292C652E437572736F72446F776E3D5964286E65772072287B617267733A7B646972656374696F6E3A332C756E69743A322C73656C6563743A21312C76616C75653A317D2C6964';
wwv_flow_imp.g_varchar2_table(9189) := '3A22637572736F72446F776E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31382C6D61633A7B7072696D6172793A';
wwv_flow_imp.g_varchar2_table(9190) := '31382C7365636F6E646172793A5B3330305D7D7D7D29292C652E437572736F72446F776E53656C6563743D5964286E65772072287B617267733A7B646972656374696F6E3A332C756E69743A322C73656C6563743A21302C76616C75653A317D2C69643A';
wwv_flow_imp.g_varchar2_table(9191) := '22637572736F72446F776E53656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313034322C7365636F6E64';
wwv_flow_imp.g_varchar2_table(9192) := '6172793A5B333039305D2C6D61633A7B7072696D6172793A313034327D2C6C696E75783A7B7072696D6172793A313034327D7D7D29292C652E437572736F7250616765446F776E3D5964286E65772072287B617267733A7B646972656374696F6E3A332C';
wwv_flow_imp.g_varchar2_table(9193) := '756E69743A322C73656C6563743A21312C76616C75653A2D317D2C69643A22637572736F7250616765446F776E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E';
wwv_flow_imp.g_varchar2_table(9194) := '707574466F6375732C7072696D6172793A31327D7D29292C652E437572736F7250616765446F776E53656C6563743D5964286E65772072287B617267733A7B646972656374696F6E3A332C756E69743A322C73656C6563743A21302C76616C75653A2D31';
wwv_flow_imp.g_varchar2_table(9195) := '7D2C69643A22637572736F7250616765446F776E53656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A3130';
wwv_flow_imp.g_varchar2_table(9196) := '33367D7D29292C652E437265617465437572736F723D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A22637265617465437572736F72222C707265636F6E646974696F6E3A766F';
wwv_flow_imp.g_varchar2_table(9197) := '696420307D297D72756E436F7265456469746F72436F6D6D616E6428652C74297B69662821742E706F736974696F6E2972657475726E3B6C6574206E3B6E3D742E77686F6C654C696E653F67532E6C696E6528652C652E6765745072696D617279437572';
wwv_flow_imp.g_varchar2_table(9198) := '736F72537461746528292C21312C742E706F736974696F6E2C742E76696577506F736974696F6E293A67532E6D6F7665546F28652C652E6765745072696D617279437572736F72537461746528292C21312C742E706F736974696F6E2C742E7669657750';
wwv_flow_imp.g_varchar2_table(9199) := '6F736974696F6E293B636F6E737420693D652E676574437572736F7253746174657328293B696628692E6C656E6774683E31297B636F6E7374206F3D6E2E6D6F64656C53746174653F6E2E6D6F64656C53746174652E706F736974696F6E3A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(9200) := '733D6E2E7669657753746174653F6E2E7669657753746174652E706F736974696F6E3A6E756C6C3B666F72286C6574206E3D302C723D692E6C656E6774683B6E3C723B6E2B2B297B636F6E737420723D695B6E5D3B69662828216F7C7C722E6D6F64656C';
wwv_flow_imp.g_varchar2_table(9201) := '53746174652E73656C656374696F6E2E636F6E7461696E73506F736974696F6E286F292926262821737C7C722E7669657753746174652E73656C656374696F6E2E636F6E7461696E73506F736974696F6E287329292972657475726E20692E73706C6963';
wwv_flow_imp.g_varchar2_table(9202) := '65286E2C31292C652E6D6F64656C2E70757368537461636B456C656D656E7428292C766F696420652E736574437572736F7253746174657328742E736F757263652C332C69297D7D692E70757368286E292C652E6D6F64656C2E70757368537461636B45';
wwv_flow_imp.g_varchar2_table(9203) := '6C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C69297D7D292C652E4C617374437572736F724D6F7665546F53656C6563743D5964286E657720636C61737320657874656E6473204E537B636F6E73747275';
wwv_flow_imp.g_varchar2_table(9204) := '63746F7228297B7375706572287B69643A225F6C617374437572736F724D6F7665546F53656C656374222C707265636F6E646974696F6E3A766F696420307D297D72756E436F7265456469746F72436F6D6D616E6428652C74297B69662821742E706F73';
wwv_flow_imp.g_varchar2_table(9205) := '6974696F6E2972657475726E3B636F6E7374206E3D652E6765744C6173744164646564437572736F72496E64657828292C693D652E676574437572736F7253746174657328292C6F3D692E736C6963652830293B6F5B6E5D3D67532E6D6F7665546F2865';
wwv_flow_imp.g_varchar2_table(9206) := '2C695B6E5D2C21302C742E706F736974696F6E2C742E76696577506F736974696F6E292C652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C6F297D7D293B636C';
wwv_flow_imp.g_varchar2_table(9207) := '617373206120657874656E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E';
wwv_flow_imp.g_varchar2_table(9208) := '6428652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C67532E6D6F7665546F426567696E6E696E674F664C696E6528652C652E676574437572736F';
wwv_flow_imp.g_varchar2_table(9209) := '7253746174657328292C746869732E5F696E53656C656374696F6E4D6F646529292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D7D652E437572736F72486F6D653D5964286E65772061287B696E53656C656374696F';
wwv_flow_imp.g_varchar2_table(9210) := '6E4D6F64653A21312C69643A22637572736F72486F6D65222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31342C6D61';
wwv_flow_imp.g_varchar2_table(9211) := '633A7B7072696D6172793A31342C7365636F6E646172793A5B323036335D7D7D7D29292C652E437572736F72486F6D6553656C6563743D5964286E65772061287B696E53656C656374696F6E4D6F64653A21302C69643A22637572736F72486F6D655365';
wwv_flow_imp.g_varchar2_table(9212) := '6C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313033382C6D61633A7B7072696D6172793A313033382C73';
wwv_flow_imp.g_varchar2_table(9213) := '65636F6E646172793A5B333038375D7D7D7D29293B636C617373206C20657874656E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D';
wwv_flow_imp.g_varchar2_table(9214) := '6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C746869732E5F6578656328652E67';
wwv_flow_imp.g_varchar2_table(9215) := '6574437572736F72537461746573282929292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D5F657865632865297B636F6E737420743D5B5D3B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B';
wwv_flow_imp.g_varchar2_table(9216) := '2B297B636F6E737420693D655B6E5D2C6F3D692E6D6F64656C53746174652E706F736974696F6E2E6C696E654E756D6265723B745B6E5D3D51432E66726F6D4D6F64656C537461746528692E6D6F64656C53746174652E6D6F766528746869732E5F696E';
wwv_flow_imp.g_varchar2_table(9217) := '53656C656374696F6E4D6F64652C6F2C312C3029297D72657475726E20747D7D652E437572736F724C696E6553746172743D5964286E6577206C287B696E53656C656374696F6E4D6F64653A21312C69643A22637572736F724C696E655374617274222C';
wwv_flow_imp.g_varchar2_table(9218) := '707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3238377D7D7D29292C652E43757273';
wwv_flow_imp.g_varchar2_table(9219) := '6F724C696E65537461727453656C6563743D5964286E6577206C287B696E53656C656374696F6E4D6F64653A21302C69643A22637572736F724C696E65537461727453656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F707473';
wwv_flow_imp.g_varchar2_table(9220) := '3A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A313331317D7D7D29293B636C617373206420657874656E6473204E537B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(9221) := '65297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D6F64656C2E70757368537461636B456C656D65';
wwv_flow_imp.g_varchar2_table(9222) := '6E7428292C652E736574437572736F7253746174657328742E736F757263652C332C67532E6D6F7665546F456E644F664C696E6528652C652E676574437572736F7253746174657328292C746869732E5F696E53656C656374696F6E4D6F64652C742E73';
wwv_flow_imp.g_varchar2_table(9223) := '7469636B797C7C213129292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D7D652E437572736F72456E643D5964286E65772064287B696E53656C656374696F6E4D6F64653A21312C69643A22637572736F72456E6422';
wwv_flow_imp.g_varchar2_table(9224) := '2C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B617267733A7B737469636B793A21317D2C7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31332C6D61633A7B7072696D';
wwv_flow_imp.g_varchar2_table(9225) := '6172793A31332C7365636F6E646172793A5B323036355D7D7D2C6D657461646174613A7B6465736372697074696F6E3A22476F20746F20456E64222C617267733A5B7B6E616D653A2261726773222C736368656D613A7B747970653A226F626A65637422';
wwv_flow_imp.g_varchar2_table(9226) := '2C70726F706572746965733A7B737469636B793A7B6465736372697074696F6E3A6228302C22537469636B20746F2074686520656E64206576656E207768656E20676F696E6720746F206C6F6E676572206C696E657322292C747970653A22626F6F6C65';
wwv_flow_imp.g_varchar2_table(9227) := '616E222C64656661756C743A21317D7D7D7D5D7D7D29292C652E437572736F72456E6453656C6563743D5964286E65772064287B696E53656C656374696F6E4D6F64653A21302C69643A22637572736F72456E6453656C656374222C707265636F6E6469';
wwv_flow_imp.g_varchar2_table(9228) := '74696F6E3A766F696420302C6B624F7074733A7B617267733A7B737469636B793A21317D2C7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313033372C6D61633A7B7072696D6172793A313033';
wwv_flow_imp.g_varchar2_table(9229) := '372C7365636F6E646172793A5B333038395D7D7D2C6D657461646174613A7B6465736372697074696F6E3A2253656C65637420746F20456E64222C617267733A5B7B6E616D653A2261726773222C736368656D613A7B747970653A226F626A656374222C';
wwv_flow_imp.g_varchar2_table(9230) := '70726F706572746965733A7B737469636B793A7B6465736372697074696F6E3A6228302C22537469636B20746F2074686520656E64206576656E207768656E20676F696E6720746F206C6F6E676572206C696E657322292C747970653A22626F6F6C6561';
wwv_flow_imp.g_varchar2_table(9231) := '6E222C64656661756C743A21317D7D7D7D5D7D7D29293B636C617373206820657874656E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F';
wwv_flow_imp.g_varchar2_table(9232) := '6E4D6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C746869732E5F657865632865';
wwv_flow_imp.g_varchar2_table(9233) := '2C652E676574437572736F72537461746573282929292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D5F6578656328652C74297B636F6E7374206E3D5B5D3B666F72286C657420693D302C6F3D742E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(9234) := '693C6F3B692B2B297B636F6E7374206F3D745B695D2C733D6F2E6D6F64656C53746174652E706F736974696F6E2E6C696E654E756D6265722C723D652E6D6F64656C2E6765744C696E654D6178436F6C756D6E2873293B6E5B695D3D51432E66726F6D4D';
wwv_flow_imp.g_varchar2_table(9235) := '6F64656C5374617465286F2E6D6F64656C53746174652E6D6F766528746869732E5F696E53656C656374696F6E4D6F64652C732C722C3029297D72657475726E206E7D7D652E437572736F724C696E65456E643D5964286E65772068287B696E53656C65';
wwv_flow_imp.g_varchar2_table(9236) := '6374696F6E4D6F64653A21312C69643A22637572736F724C696E65456E64222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172';
wwv_flow_imp.g_varchar2_table(9237) := '793A302C6D61633A7B7072696D6172793A3239317D7D7D29292C652E437572736F724C696E65456E6453656C6563743D5964286E65772068287B696E53656C656374696F6E4D6F64653A21302C69643A22637572736F724C696E65456E6453656C656374';
wwv_flow_imp.g_varchar2_table(9238) := '222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A313331357D7D7D29293B636C61';
wwv_flow_imp.g_varchar2_table(9239) := '7373207520657874656E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(9240) := '28652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C67532E6D6F7665546F426567696E6E696E674F6642756666657228652C652E67657443757273';
wwv_flow_imp.g_varchar2_table(9241) := '6F7253746174657328292C746869732E5F696E53656C656374696F6E4D6F646529292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D7D652E437572736F72546F703D5964286E65772075287B696E53656C656374696F';
wwv_flow_imp.g_varchar2_table(9242) := '6E4D6F64653A21312C69643A22637572736F72546F70222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323036322C6D';
wwv_flow_imp.g_varchar2_table(9243) := '61633A7B7072696D6172793A323036347D7D7D29292C652E437572736F72546F7053656C6563743D5964286E65772075287B696E53656C656374696F6E4D6F64653A21302C69643A22637572736F72546F7053656C656374222C707265636F6E64697469';
wwv_flow_imp.g_varchar2_table(9244) := '6F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A333038362C6D61633A7B7072696D6172793A333038387D7D7D29293B636C61737320702065787465';
wwv_flow_imp.g_varchar2_table(9245) := '6E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D';
wwv_flow_imp.g_varchar2_table(9246) := '6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C67532E6D6F7665546F456E644F6642756666657228652C652E676574437572736F7253746174657328292C74686973';
wwv_flow_imp.g_varchar2_table(9247) := '2E5F696E53656C656374696F6E4D6F646529292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D7D652E437572736F72426F74746F6D3D5964286E65772070287B696E53656C656374696F6E4D6F64653A21312C69643A';
wwv_flow_imp.g_varchar2_table(9248) := '22637572736F72426F74746F6D222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323036312C6D61633A7B7072696D61';
wwv_flow_imp.g_varchar2_table(9249) := '72793A323036367D7D7D29292C652E437572736F72426F74746F6D53656C6563743D5964286E65772070287B696E53656C656374696F6E4D6F64653A21302C69643A22637572736F72426F74746F6D53656C656374222C707265636F6E646974696F6E3A';
wwv_flow_imp.g_varchar2_table(9250) := '766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A333038352C6D61633A7B7072696D6172793A333039307D7D7D29293B636C617373206720657874656E6473';
wwv_flow_imp.g_varchar2_table(9251) := '204E537B636F6E7374727563746F7228297B7375706572287B69643A22656469746F725363726F6C6C222C707265636F6E646974696F6E3A766F696420302C6D657461646174613A50532E6D657461646174617D297D64657465726D696E655363726F6C';
wwv_flow_imp.g_varchar2_table(9252) := '6C4D6574686F642865297B72657475726E5B365D2E696E636C7564657328652E756E69742926265B342C325D2E696E636C7564657328652E646972656374696F6E293F746869732E5F72756E486F72697A6F6E74616C456469746F725363726F6C6C2E62';
wwv_flow_imp.g_varchar2_table(9253) := '696E642874686973293A5B312C322C332C342C352C365D2E696E636C7564657328652E756E69742926265B312C335D2E696E636C7564657328652E646972656374696F6E293F746869732E5F72756E566572746963616C456469746F725363726F6C6C2E';
wwv_flow_imp.g_varchar2_table(9254) := '62696E642874686973293A6E756C6C7D72756E436F7265456469746F72436F6D6D616E6428652C74297B636F6E7374206E3D50532E70617273652874293B696628216E2972657475726E3B636F6E737420693D746869732E64657465726D696E65536372';
wwv_flow_imp.g_varchar2_table(9255) := '6F6C6C4D6574686F64286E293B6926266928652C742E736F757263652C6E297D5F72756E566572746963616C456469746F725363726F6C6C28652C742C6E297B636F6E737420693D746869732E5F636F6D70757465446573697265645363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(9256) := '7028652C6E293B6966286E2E72657665616C437572736F72297B636F6E7374206F3D652E676574436F6D706C6574656C7956697369626C655669657752616E676541745363726F6C6C546F702869293B652E736574437572736F7253746174657328742C';
wwv_flow_imp.g_varchar2_table(9257) := '332C5B67532E66696E64506F736974696F6E496E56696577706F727449664F75747369646528652C652E6765745072696D617279437572736F72537461746528292C6F2C6E2E73656C656374295D297D652E766965774C61796F75742E7365745363726F';
wwv_flow_imp.g_varchar2_table(9258) := '6C6C506F736974696F6E287B7363726F6C6C546F703A697D2C30297D5F636F6D70757465446573697265645363726F6C6C546F7028652C74297B696628313D3D3D742E756E6974297B636F6E7374206E3D652E766965774C61796F75742E676574467574';
wwv_flow_imp.g_varchar2_table(9259) := '75726556696577706F727428292C693D652E676574436F6D706C6574656C7956697369626C655669657752616E676541745363726F6C6C546F70286E2E746F70292C6F3D652E636F6F7264696E61746573436F6E7665727465722E636F6E766572745669';
wwv_flow_imp.g_varchar2_table(9260) := '657752616E6765546F4D6F64656C52616E67652869293B6C657420733B733D313D3D3D742E646972656374696F6E3F4D6174682E6D617828312C6F2E73746172744C696E654E756D6265722D742E76616C7565293A4D6174682E6D696E28652E6D6F6465';
wwv_flow_imp.g_varchar2_table(9261) := '6C2E6765744C696E65436F756E7428292C6F2E73746172744C696E654E756D6265722B742E76616C7565293B636F6E737420723D652E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F566965';
wwv_flow_imp.g_varchar2_table(9262) := '77506F736974696F6E286E6577206D6328732C3129293B72657475726E20652E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228722E6C696E654E756D626572297D696628353D3D3D742E756E69';
wwv_flow_imp.g_varchar2_table(9263) := '74297B6C6574206E3D303B72657475726E20333D3D3D742E646972656374696F6E2626286E3D652E6D6F64656C2E6765744C696E65436F756E7428292D652E637572736F72436F6E6669672E7061676553697A65292C652E766965774C61796F75742E67';
wwv_flow_imp.g_varchar2_table(9264) := '6574566572746963616C4F6666736574466F724C696E654E756D626572286E297D6C6574206E3B6E3D333D3D3D742E756E69743F652E637572736F72436F6E6669672E7061676553697A652A742E76616C75653A343D3D3D742E756E69743F4D6174682E';
wwv_flow_imp.g_varchar2_table(9265) := '726F756E6428652E637572736F72436F6E6669672E7061676553697A652F32292A742E76616C75653A742E76616C75653B636F6E737420693D28313D3D3D742E646972656374696F6E3F2D313A31292A6E3B72657475726E20652E766965774C61796F75';
wwv_flow_imp.g_varchar2_table(9266) := '742E67657443757272656E745363726F6C6C546F7028292B692A652E637572736F72436F6E6669672E6C696E654865696768747D5F72756E486F72697A6F6E74616C456469746F725363726F6C6C28652C742C6E297B636F6E737420693D746869732E5F';
wwv_flow_imp.g_varchar2_table(9267) := '636F6D70757465446573697265645363726F6C6C4C65667428652C6E293B652E766965774C61796F75742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C4C6566743A697D2C30297D5F636F6D70757465446573697265645363726F6C6C';
wwv_flow_imp.g_varchar2_table(9268) := '4C65667428652C74297B636F6E7374206E3D28343D3D3D742E646972656374696F6E3F2D313A31292A742E76616C75653B72657475726E20652E766965774C61796F75742E67657443757272656E745363726F6C6C4C65667428292B6E2A652E63757273';
wwv_flow_imp.g_varchar2_table(9269) := '6F72436F6E6669672E7479706963616C48616C66776964746843686172616374657257696474687D7D652E456469746F725363726F6C6C496D706C3D672C652E456469746F725363726F6C6C3D5964286E65772067292C652E5363726F6C6C4C696E6555';
wwv_flow_imp.g_varchar2_table(9270) := '703D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C4C696E655570222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A';
wwv_flow_imp.g_varchar2_table(9271) := '302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323036342C6D61633A7B7072696D6172793A3236377D7D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E456469746F725363726F6C';
wwv_flow_imp.g_varchar2_table(9272) := '6C2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F3A50532E526177446972656374696F6E2E55702C62793A50532E526177556E69742E577261707065644C696E652C76616C75653A312C72657665616C437572736F723A21312C7365';
wwv_flow_imp.g_varchar2_table(9273) := '6C6563743A21312C736F757263653A6E2E736F757263657D297D7D292C652E5363726F6C6C5061676555703D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C50';
wwv_flow_imp.g_varchar2_table(9274) := '6167655570222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323035392C77696E3A7B7072696D6172793A3532337D2C';
wwv_flow_imp.g_varchar2_table(9275) := '6C696E75783A7B7072696D6172793A3532337D7D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E456469746F725363726F6C6C2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F3A50532E526177446972';
wwv_flow_imp.g_varchar2_table(9276) := '656374696F6E2E55702C62793A50532E526177556E69742E506167652C76616C75653A312C72657665616C437572736F723A21312C73656C6563743A21312C736F757263653A6E2E736F757263657D297D7D292C652E5363726F6C6C456469746F72546F';
wwv_flow_imp.g_varchar2_table(9277) := '703D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C456469746F72546F70222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B77656967';
wwv_flow_imp.g_varchar2_table(9278) := '68743A302C6B62457870723A6C682E74657874496E707574466F6375737D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E456469746F725363726F6C6C2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F';
wwv_flow_imp.g_varchar2_table(9279) := '3A50532E526177446972656374696F6E2E55702C62793A50532E526177556E69742E456469746F722C76616C75653A312C72657665616C437572736F723A21312C73656C6563743A21312C736F757263653A6E2E736F757263657D297D7D292C652E5363';
wwv_flow_imp.g_varchar2_table(9280) := '726F6C6C4C696E65446F776E3D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C4C696E65446F776E222C707265636F6E646974696F6E3A766F696420302C6B62';
wwv_flow_imp.g_varchar2_table(9281) := '4F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323036362C6D61633A7B7072696D6172793A3236387D7D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B';
wwv_flow_imp.g_varchar2_table(9282) := '652E456469746F725363726F6C6C2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F3A50532E526177446972656374696F6E2E446F776E2C62793A50532E526177556E69742E577261707065644C696E652C76616C75653A312C726576';
wwv_flow_imp.g_varchar2_table(9283) := '65616C437572736F723A21312C73656C6563743A21312C736F757263653A6E2E736F757263657D297D7D292C652E5363726F6C6C50616765446F776E3D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B73';
wwv_flow_imp.g_varchar2_table(9284) := '75706572287B69643A227363726F6C6C50616765446F776E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A32303630';
wwv_flow_imp.g_varchar2_table(9285) := '2C77696E3A7B7072696D6172793A3532347D2C6C696E75783A7B7072696D6172793A3532347D7D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E456469746F725363726F6C6C2E72756E436F7265456469746F72436F6D6D';
wwv_flow_imp.g_varchar2_table(9286) := '616E6428742C7B746F3A50532E526177446972656374696F6E2E446F776E2C62793A50532E526177556E69742E506167652C76616C75653A312C72657665616C437572736F723A21312C73656C6563743A21312C736F757263653A6E2E736F757263657D';
wwv_flow_imp.g_varchar2_table(9287) := '297D7D292C652E5363726F6C6C456469746F72426F74746F6D3D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C456469746F72426F74746F6D222C707265636F';
wwv_flow_imp.g_varchar2_table(9288) := '6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375737D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E456469746F725363726F6C6C';
wwv_flow_imp.g_varchar2_table(9289) := '2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F3A50532E526177446972656374696F6E2E446F776E2C62793A50532E526177556E69742E456469746F722C76616C75653A312C72657665616C437572736F723A21312C73656C656374';
wwv_flow_imp.g_varchar2_table(9290) := '3A21312C736F757263653A6E2E736F757263657D297D7D292C652E5363726F6C6C4C6566743D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C4C656674222C70';
wwv_flow_imp.g_varchar2_table(9291) := '7265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375737D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E456469746F725363';
wwv_flow_imp.g_varchar2_table(9292) := '726F6C6C2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F3A50532E526177446972656374696F6E2E4C6566742C62793A50532E526177556E69742E436F6C756D6E2C76616C75653A322C72657665616C437572736F723A21312C7365';
wwv_flow_imp.g_varchar2_table(9293) := '6C6563743A21312C736F757263653A6E2E736F757263657D297D7D292C652E5363726F6C6C52696768743D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A227363726F6C6C5269';
wwv_flow_imp.g_varchar2_table(9294) := '676874222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375737D7D297D72756E436F7265456469746F72436F6D6D616E6428742C6E297B652E4564';
wwv_flow_imp.g_varchar2_table(9295) := '69746F725363726F6C6C2E72756E436F7265456469746F72436F6D6D616E6428742C7B746F3A50532E526177446972656374696F6E2E52696768742C62793A50532E526177556E69742E436F6C756D6E2C76616C75653A322C72657665616C437572736F';
wwv_flow_imp.g_varchar2_table(9296) := '723A21312C73656C6563743A21312C736F757263653A6E2E736F757263657D297D7D293B636C617373206D20657874656E6473204E537B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F6465';
wwv_flow_imp.g_varchar2_table(9297) := '3D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B742E706F736974696F6E262628652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174';
wwv_flow_imp.g_varchar2_table(9298) := '657328742E736F757263652C332C5B67532E776F726428652C652E6765745072696D617279437572736F72537461746528292C746869732E5F696E53656C656374696F6E4D6F64652C742E706F736974696F6E295D292C32213D3D742E72657665616C54';
wwv_flow_imp.g_varchar2_table(9299) := '7970652626652E72657665616C416C6C437572736F727328742E736F757263652C21302C213029297D7D652E576F726453656C6563743D5964286E6577206D287B696E53656C656374696F6E4D6F64653A21312C69643A225F776F726453656C65637422';
wwv_flow_imp.g_varchar2_table(9300) := '2C707265636F6E646974696F6E3A766F696420307D29292C652E576F726453656C656374447261673D5964286E6577206D287B696E53656C656374696F6E4D6F64653A21302C69643A225F776F726453656C65637444726167222C707265636F6E646974';
wwv_flow_imp.g_varchar2_table(9301) := '696F6E3A766F696420307D29292C652E4C617374437572736F72576F726453656C6563743D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A226C617374437572736F72576F7264';
wwv_flow_imp.g_varchar2_table(9302) := '53656C656374222C707265636F6E646974696F6E3A766F696420307D297D72756E436F7265456469746F72436F6D6D616E6428652C74297B69662821742E706F736974696F6E2972657475726E3B636F6E7374206E3D652E6765744C6173744164646564';
wwv_flow_imp.g_varchar2_table(9303) := '437572736F72496E64657828292C693D652E676574437572736F7253746174657328292C6F3D692E736C6963652830292C733D695B6E5D3B6F5B6E5D3D67532E776F726428652C732C732E6D6F64656C53746174652E68617353656C656374696F6E2829';
wwv_flow_imp.g_varchar2_table(9304) := '2C742E706F736974696F6E292C652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C6F297D7D293B636C617373206620657874656E6473204E537B636F6E737472';
wwv_flow_imp.g_varchar2_table(9305) := '7563746F722865297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B742E706F736974696F6E262628652E6D';
wwv_flow_imp.g_varchar2_table(9306) := '6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C5B67532E6C696E6528652C652E6765745072696D617279437572736F72537461746528292C746869732E5F696E5365';
wwv_flow_imp.g_varchar2_table(9307) := '6C656374696F6E4D6F64652C742E706F736974696F6E2C742E76696577506F736974696F6E295D292C32213D3D742E72657665616C547970652626652E72657665616C416C6C437572736F727328742E736F757263652C21312C213029297D7D652E4C69';
wwv_flow_imp.g_varchar2_table(9308) := '6E6553656C6563743D5964286E65772066287B696E53656C656374696F6E4D6F64653A21312C69643A225F6C696E6553656C656374222C707265636F6E646974696F6E3A766F696420307D29292C652E4C696E6553656C656374447261673D5964286E65';
wwv_flow_imp.g_varchar2_table(9309) := '772066287B696E53656C656374696F6E4D6F64653A21302C69643A225F6C696E6553656C65637444726167222C707265636F6E646974696F6E3A766F696420307D29293B636C617373207620657874656E6473204E537B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(9310) := '297B73757065722865292C746869732E5F696E53656C656374696F6E4D6F64653D652E696E53656C656374696F6E4D6F64657D72756E436F7265456469746F72436F6D6D616E6428652C74297B69662821742E706F736974696F6E2972657475726E3B63';
wwv_flow_imp.g_varchar2_table(9311) := '6F6E7374206E3D652E6765744C6173744164646564437572736F72496E64657828292C693D652E676574437572736F7253746174657328292C6F3D692E736C6963652830293B6F5B6E5D3D67532E6C696E6528652C695B6E5D2C746869732E5F696E5365';
wwv_flow_imp.g_varchar2_table(9312) := '6C656374696F6E4D6F64652C742E706F736974696F6E2C742E76696577506F736974696F6E292C652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C6F297D7D65';
wwv_flow_imp.g_varchar2_table(9313) := '2E4C617374437572736F724C696E6553656C6563743D5964286E65772076287B696E53656C656374696F6E4D6F64653A21312C69643A226C617374437572736F724C696E6553656C656374222C707265636F6E646974696F6E3A766F696420307D29292C';
wwv_flow_imp.g_varchar2_table(9314) := '652E4C617374437572736F724C696E6553656C656374447261673D5964286E65772076287B696E53656C656374696F6E4D6F64653A21302C69643A226C617374437572736F724C696E6553656C65637444726167222C707265636F6E646974696F6E3A76';
wwv_flow_imp.g_varchar2_table(9315) := '6F696420307D29292C652E43616E63656C53656C656374696F6E3D5964286E657720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A2263616E63656C53656C656374696F6E222C707265636F6E64';
wwv_flow_imp.g_varchar2_table(9316) := '6974696F6E3A6C682E6861734E6F6E456D70747953656C656374696F6E2C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D';
wwv_flow_imp.g_varchar2_table(9317) := '297D72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C5B67532E63616E63656C53656C656374';
wwv_flow_imp.g_varchar2_table(9318) := '696F6E28652C652E6765745072696D617279437572736F7253746174652829295D292C652E72657665616C416C6C437572736F727328742E736F757263652C2130297D7D292C652E52656D6F76655365636F6E64617279437572736F72733D5964286E65';
wwv_flow_imp.g_varchar2_table(9319) := '7720636C61737320657874656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A2272656D6F76655365636F6E64617279437572736F7273222C707265636F6E646974696F6E3A6C682E6861734D756C7469706C6553656C6563';
wwv_flow_imp.g_varchar2_table(9320) := '74696F6E732C6B624F7074733A7B7765696768743A312C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D297D72756E436F7265456469746F72436F6D6D616E642865';
wwv_flow_imp.g_varchar2_table(9321) := '2C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C5B652E6765745072696D617279437572736F72537461746528295D292C652E72657665616C416C6C';
wwv_flow_imp.g_varchar2_table(9322) := '437572736F727328742E736F757263652C2130292C4A72286228302C2252656D6F766564207365636F6E6461727920637572736F72732229297D7D292C652E52657665616C4C696E653D5964286E657720636C61737320657874656E6473204E537B636F';
wwv_flow_imp.g_varchar2_table(9323) := '6E7374727563746F7228297B7375706572287B69643A2272657665616C4C696E65222C707265636F6E646974696F6E3A766F696420302C6D657461646174613A4F532E6D657461646174617D297D72756E436F7265456469746F72436F6D6D616E642865';
wwv_flow_imp.g_varchar2_table(9324) := '2C74297B636F6E7374206E3D742C693D6E2E6C696E654E756D6265727C7C303B6C6574206F3D226E756D626572223D3D747970656F6620693F692B313A7061727365496E742869292B313B6F3C312626286F3D31293B636F6E737420733D652E6D6F6465';
wwv_flow_imp.g_varchar2_table(9325) := '6C2E6765744C696E65436F756E7428293B6F3E732626286F3D73293B636F6E737420723D6E6577207268286F2C312C6F2C652E6D6F64656C2E6765744C696E654D6178436F6C756D6E286F29293B6C657420613D303B6966286E2E617429737769746368';
wwv_flow_imp.g_varchar2_table(9326) := '286E2E6174297B63617365204F532E5261774174417267756D656E742E546F703A613D333B627265616B3B63617365204F532E5261774174417267756D656E742E43656E7465723A613D313B627265616B3B63617365204F532E5261774174417267756D';
wwv_flow_imp.g_varchar2_table(9327) := '656E742E426F74746F6D3A613D347D636F6E7374206C3D652E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C52616E6765546F5669657752616E67652872293B652E72657665616C52616E676528742E736F75726365';
wwv_flow_imp.g_varchar2_table(9328) := '2C21312C6C2C612C30297D7D292C652E53656C656374416C6C3D6E657720636C61737320657874656E64732046537B636F6E7374727563746F7228297B7375706572287368297D72756E444F4D436F6D6D616E642865297B63262628652E666F63757328';
wwv_flow_imp.g_varchar2_table(9329) := '292C652E73656C6563742829292C652E6F776E6572446F63756D656E742E65786563436F6D6D616E64282273656C656374416C6C22297D72756E456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D742E5F676574566965774D6F64';
wwv_flow_imp.g_varchar2_table(9330) := '656C28293B692626746869732E72756E436F7265456469746F72436F6D6D616E6428692C6E297D72756E436F7265456469746F72436F6D6D616E6428652C74297B652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572';
wwv_flow_imp.g_varchar2_table(9331) := '736F7253746174657328226B6579626F617264222C332C5B67532E73656C656374416C6C28652C652E6765745072696D617279437572736F7253746174652829295D297D7D2C652E53657453656C656374696F6E3D5964286E657720636C617373206578';
wwv_flow_imp.g_varchar2_table(9332) := '74656E6473204E537B636F6E7374727563746F7228297B7375706572287B69643A2273657453656C656374696F6E222C707265636F6E646974696F6E3A766F696420307D297D72756E436F7265456469746F72436F6D6D616E6428652C74297B742E7365';
wwv_flow_imp.g_varchar2_table(9333) := '6C656374696F6E262628652E6D6F64656C2E70757368537461636B456C656D656E7428292C652E736574437572736F7253746174657328742E736F757263652C332C5B51432E66726F6D4D6F64656C53656C656374696F6E28742E73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(9334) := '295D29297D7D297D2852537C7C2852533D7B7D29293B636F6E73742042533D57632E616E64286C682E74657874496E707574466F6375732C6C682E636F6C756D6E53656C656374696F6E293B66756E6374696F6E20565328652C74297B43642E72656769';
wwv_flow_imp.g_varchar2_table(9335) := '737465724B657962696E64696E6752756C65287B69643A652C7072696D6172793A742C7768656E3A42532C7765696768743A317D297D66756E6374696F6E207A532865297B72657475726E20652E726567697374657228292C657D7661722048532C5753';
wwv_flow_imp.g_varchar2_table(9336) := '3B56532852532E437572736F72436F6C756D6E53656C6563744C6566742E69642C31303339292C56532852532E437572736F72436F6C756D6E53656C65637452696768742E69642C31303431292C56532852532E437572736F72436F6C756D6E53656C65';
wwv_flow_imp.g_varchar2_table(9337) := '637455702E69642C31303430292C56532852532E437572736F72436F6C756D6E53656C6563745061676555702E69642C31303335292C56532852532E437572736F72436F6C756D6E53656C656374446F776E2E69642C31303432292C56532852532E4375';
wwv_flow_imp.g_varchar2_table(9338) := '72736F72436F6C756D6E53656C65637450616765446F776E2E69642C31303336292C66756E6374696F6E2865297B636C617373207420657874656E64732024647B72756E456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D742E5F';
wwv_flow_imp.g_varchar2_table(9339) := '676574566965774D6F64656C28293B692626746869732E72756E436F726545646974696E67436F6D6D616E6428742C692C6E7C7C7B7D297D7D652E436F726545646974696E67436F6D6D616E643D742C652E4C696E65427265616B496E736572743D5964';
wwv_flow_imp.g_varchar2_table(9340) := '286E657720636C61737320657874656E647320747B636F6E7374727563746F7228297B7375706572287B69643A226C696E65427265616B496E73657274222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B77656967';
wwv_flow_imp.g_varchar2_table(9341) := '68743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3330317D7D7D297D72756E436F726545646974696E67436F6D6D616E6428652C742C6E297B652E70757368556E646F';
wwv_flow_imp.g_varchar2_table(9342) := '53746F7028292C652E65786563757465436F6D6D616E647328746869732E69642C45532E6C696E65427265616B496E7365727428742E637572736F72436F6E6669672C742E6D6F64656C2C742E676574437572736F7253746174657328292E6D61702828';
wwv_flow_imp.g_varchar2_table(9343) := '653D3E652E6D6F64656C53746174652E73656C656374696F6E292929297D7D292C652E4F757464656E743D5964286E657720636C61737320657874656E647320747B636F6E7374727563746F7228297B7375706572287B69643A226F757464656E74222C';
wwv_flow_imp.g_varchar2_table(9344) := '707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B7765696768743A302C6B62457870723A57632E616E64286C682E656469746F7254657874466F6375732C6C682E746162446F65734E6F744D6F7665466F637573292C70';
wwv_flow_imp.g_varchar2_table(9345) := '72696D6172793A313032367D7D297D72756E436F726545646974696E67436F6D6D616E6428652C742C6E297B652E70757368556E646F53746F7028292C652E65786563757465436F6D6D616E647328746869732E69642C45532E6F757464656E7428742E';
wwv_flow_imp.g_varchar2_table(9346) := '637572736F72436F6E6669672C742E6D6F64656C2C742E676574437572736F7253746174657328292E6D61702828653D3E652E6D6F64656C53746174652E73656C656374696F6E292929292C652E70757368556E646F53746F7028297D7D292C652E5461';
wwv_flow_imp.g_varchar2_table(9347) := '623D5964286E657720636C61737320657874656E647320747B636F6E7374727563746F7228297B7375706572287B69643A22746162222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B7765696768743A302C6B6245';
wwv_flow_imp.g_varchar2_table(9348) := '7870723A57632E616E64286C682E656469746F7254657874466F6375732C6C682E746162446F65734E6F744D6F7665466F637573292C7072696D6172793A327D7D297D72756E436F726545646974696E67436F6D6D616E6428652C742C6E297B652E7075';
wwv_flow_imp.g_varchar2_table(9349) := '7368556E646F53746F7028292C652E65786563757465436F6D6D616E647328746869732E69642C45532E74616228742E637572736F72436F6E6669672C742E6D6F64656C2C742E676574437572736F7253746174657328292E6D61702828653D3E652E6D';
wwv_flow_imp.g_varchar2_table(9350) := '6F64656C53746174652E73656C656374696F6E292929292C652E70757368556E646F53746F7028297D7D292C652E44656C6574654C6566743D5964286E657720636C61737320657874656E647320747B636F6E7374727563746F7228297B737570657228';
wwv_flow_imp.g_varchar2_table(9351) := '7B69643A2264656C6574654C656674222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A312C7365636F6E646172793A5B';
wwv_flow_imp.g_varchar2_table(9352) := '313032355D2C6D61633A7B7072696D6172793A312C7365636F6E646172793A5B313032352C3239342C3235375D7D7D7D297D72756E436F726545646974696E67436F6D6D616E6428652C742C6E297B636F6E73745B692C6F5D3D64532E64656C6574654C';
wwv_flow_imp.g_varchar2_table(9353) := '65667428742E67657450726576456469744F7065726174696F6E5479706528292C742E637572736F72436F6E6669672C742E6D6F64656C2C742E676574437572736F7253746174657328292E6D61702828653D3E652E6D6F64656C53746174652E73656C';
wwv_flow_imp.g_varchar2_table(9354) := '656374696F6E29292C742E676574437572736F724175746F436C6F736564436861726163746572732829293B692626652E70757368556E646F53746F7028292C652E65786563757465436F6D6D616E647328746869732E69642C6F292C742E7365745072';
wwv_flow_imp.g_varchar2_table(9355) := '6576456469744F7065726174696F6E547970652832297D7D292C652E44656C65746552696768743D5964286E657720636C61737320657874656E647320747B636F6E7374727563746F7228297B7375706572287B69643A2264656C657465526967687422';
wwv_flow_imp.g_varchar2_table(9356) := '2C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A32302C6D61633A7B7072696D6172793A32302C7365636F6E646172793A';
wwv_flow_imp.g_varchar2_table(9357) := '5B3239302C3237365D7D7D7D297D72756E436F726545646974696E67436F6D6D616E6428652C742C6E297B636F6E73745B692C6F5D3D64532E64656C657465526967687428742E67657450726576456469744F7065726174696F6E5479706528292C742E';
wwv_flow_imp.g_varchar2_table(9358) := '637572736F72436F6E6669672C742E6D6F64656C2C742E676574437572736F7253746174657328292E6D61702828653D3E652E6D6F64656C53746174652E73656C656374696F6E2929293B692626652E70757368556E646F53746F7028292C652E657865';
wwv_flow_imp.g_varchar2_table(9359) := '63757465436F6D6D616E647328746869732E69642C6F292C742E73657450726576456469744F7065726174696F6E547970652833297D7D292C652E556E646F3D6E657720636C61737320657874656E64732046537B636F6E7374727563746F7228297B73';
wwv_flow_imp.g_varchar2_table(9360) := '75706572286968297D72756E444F4D436F6D6D616E642865297B652E6F776E6572446F63756D656E742E65786563436F6D6D616E642822756E646F22297D72756E456469746F72436F6D6D616E6428652C742C6E297B696628742E6861734D6F64656C28';
wwv_flow_imp.g_varchar2_table(9361) := '2926262130213D3D742E6765744F7074696F6E283931292972657475726E20742E6765744D6F64656C28292E756E646F28297D7D2C652E5265646F3D6E657720636C61737320657874656E64732046537B636F6E7374727563746F7228297B7375706572';
wwv_flow_imp.g_varchar2_table(9362) := '286F68297D72756E444F4D436F6D6D616E642865297B652E6F776E6572446F63756D656E742E65786563436F6D6D616E6428227265646F22297D72756E456469746F72436F6D6D616E6428652C742C6E297B696628742E6861734D6F64656C2829262621';
wwv_flow_imp.g_varchar2_table(9363) := '30213D3D742E6765744F7074696F6E283931292972657475726E20742E6765744D6F64656C28292E7265646F28297D7D7D2848537C7C2848533D7B7D29293B636C617373206A5320657874656E64732057647B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(9364) := '297B7375706572287B69643A652C707265636F6E646974696F6E3A766F696420302C6D657461646174613A6E7D292C746869732E5F68616E646C657249643D747D72756E436F6D6D616E6428652C74297B636F6E7374206E3D652E676574286763292E67';
wwv_flow_imp.g_varchar2_table(9365) := '6574466F6375736564436F6465456469746F7228293B6E26266E2E7472696767657228226B6579626F617264222C746869732E5F68616E646C657249642C74297D7D66756E6374696F6E20715328652C74297B7A53286E6577206A53282264656661756C';
wwv_flow_imp.g_varchar2_table(9366) := '743A222B652C6529292C7A53286E6577206A5328652C652C7429297D7153282274797065222C7B6465736372697074696F6E3A2254797065222C617267733A5B7B6E616D653A2261726773222C736368656D613A7B747970653A226F626A656374222C72';
wwv_flow_imp.g_varchar2_table(9367) := '657175697265643A5B2274657874225D2C70726F706572746965733A7B746578743A7B747970653A22737472696E67227D7D7D7D5D7D292C715328227265706C61636550726576696F75734368617222292C71532822636F6D706F736974696F6E547970';
wwv_flow_imp.g_varchar2_table(9368) := '6522292C71532822636F6D706F736974696F6E537461727422292C71532822636F6D706F736974696F6E456E6422292C71532822706173746522292C7153282263757422293B636C6173732024537B636F6E7374727563746F7228652C74297B74686973';
wwv_flow_imp.g_varchar2_table(9369) := '2E5F73656C656374696F6E3D652C746869732E5F69734D6F76696E674C6566743D747D676574456469744F7065726174696F6E7328652C74297B696628746869732E5F73656C656374696F6E2E73746172744C696E654E756D626572213D3D746869732E';
wwv_flow_imp.g_varchar2_table(9370) := '5F73656C656374696F6E2E656E644C696E654E756D6265727C7C746869732E5F73656C656374696F6E2E6973456D70747928292972657475726E3B636F6E7374206E3D746869732E5F73656C656374696F6E2E73746172744C696E654E756D6265722C69';
wwv_flow_imp.g_varchar2_table(9371) := '3D746869732E5F73656C656374696F6E2E7374617274436F6C756D6E2C6F3D746869732E5F73656C656374696F6E2E656E64436F6C756D6E3B6966282821746869732E5F69734D6F76696E674C6566747C7C31213D3D6929262628746869732E5F69734D';
wwv_flow_imp.g_varchar2_table(9372) := '6F76696E674C6566747C7C6F213D3D652E6765744C696E654D6178436F6C756D6E286E292929696628746869732E5F69734D6F76696E674C656674297B636F6E737420733D6E6577207268286E2C692D312C6E2C69292C723D652E67657456616C756549';
wwv_flow_imp.g_varchar2_table(9373) := '6E52616E67652873293B742E616464456469744F7065726174696F6E28732C6E756C6C292C742E616464456469744F7065726174696F6E286E6577207268286E2C6F2C6E2C6F292C72297D656C73657B636F6E737420733D6E6577207268286E2C6F2C6E';
wwv_flow_imp.g_varchar2_table(9374) := '2C6F2B31292C723D652E67657456616C7565496E52616E67652873293B742E616464456469744F7065726174696F6E28732C6E756C6C292C742E616464456469744F7065726174696F6E286E6577207268286E2C692C6E2C69292C72297D7D636F6D7075';
wwv_flow_imp.g_varchar2_table(9375) := '7465437572736F72537461746528652C74297B72657475726E20746869732E5F69734D6F76696E674C6566743F6E657720616828746869732E5F73656C656374696F6E2E73746172744C696E654E756D6265722C746869732E5F73656C656374696F6E2E';
wwv_flow_imp.g_varchar2_table(9376) := '7374617274436F6C756D6E2D312C746869732E5F73656C656374696F6E2E656E644C696E654E756D6265722C746869732E5F73656C656374696F6E2E656E64436F6C756D6E2D31293A6E657720616828746869732E5F73656C656374696F6E2E73746172';
wwv_flow_imp.g_varchar2_table(9377) := '744C696E654E756D6265722C746869732E5F73656C656374696F6E2E7374617274436F6C756D6E2B312C746869732E5F73656C656374696F6E2E656E644C696E654E756D6265722C746869732E5F73656C656374696F6E2E656E64436F6C756D6E2B3129';
wwv_flow_imp.g_varchar2_table(9378) := '7D7D636C61737320555320657874656E64732055647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E6C6566743D657D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(9379) := '3D5B5D2C693D742E67657453656C656374696F6E7328293B666F7228636F6E73742065206F662069296E2E70757368286E657720245328652C746869732E6C65667429293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D61';
wwv_flow_imp.g_varchar2_table(9380) := '6E647328746869732E69642C6E292C742E70757368556E646F53746F7028297D7D5A6428636C61737320657874656E64732055537B636F6E7374727563746F7228297B73757065722821302C7B69643A22656469746F722E616374696F6E2E6D6F766543';
wwv_flow_imp.g_varchar2_table(9381) := '61727265744C656674416374696F6E222C6C6162656C3A6228302C224D6F76652053656C65637465642054657874204C65667422292C616C6961733A224D6F76652053656C65637465642054657874204C656674222C707265636F6E646974696F6E3A6C';
wwv_flow_imp.g_varchar2_table(9382) := '682E7772697461626C657D297D7D292C5A6428636C61737320657874656E64732055537B636F6E7374727563746F7228297B73757065722821312C7B69643A22656469746F722E616374696F6E2E6D6F76654361727265745269676874416374696F6E22';
wwv_flow_imp.g_varchar2_table(9383) := '2C6C6162656C3A6228302C224D6F76652053656C6563746564205465787420526967687422292C616C6961733A224D6F76652053656C65637465642054657874205269676874222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D7D';
wwv_flow_imp.g_varchar2_table(9384) := '292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7472616E73706F73654C657474657273222C6C6162656C3A6228302C225472616E73706F736520';
wwv_flow_imp.g_varchar2_table(9385) := '4C65747465727322292C616C6961733A225472616E73706F7365204C657474657273222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172';
wwv_flow_imp.g_varchar2_table(9386) := '793A302C6D61633A7B7072696D6172793A3330367D2C7765696768743A3130307D7D297D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E3D742E6765744D6F64656C28292C693D5B5D2C6F3D742E67';
wwv_flow_imp.g_varchar2_table(9387) := '657453656C656374696F6E7328293B666F7228636F6E73742065206F66206F297B69662821652E6973456D707479282929636F6E74696E75653B636F6E737420743D652E73746172744C696E654E756D6265722C6F3D652E7374617274436F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(9388) := '733D6E2E6765744C696E654D6178436F6C756D6E2874293B696628313D3D3D74262628313D3D3D6F7C7C323D3D3D6F2626323D3D3D732929636F6E74696E75653B636F6E737420723D6F3D3D3D733F652E676574506F736974696F6E28293A63532E7269';
wwv_flow_imp.g_varchar2_table(9389) := '676874506F736974696F6E286E2C652E676574506F736974696F6E28292E6C696E654E756D6265722C652E676574506F736974696F6E28292E636F6C756D6E292C613D63532E6C656674506F736974696F6E286E2C72292C6C3D63532E6C656674506F73';
wwv_flow_imp.g_varchar2_table(9390) := '6974696F6E286E2C61292C633D6E2E67657456616C7565496E52616E67652872682E66726F6D506F736974696F6E73286C2C6129292C643D6E2E67657456616C7565496E52616E67652872682E66726F6D506F736974696F6E7328612C7229292C683D72';
wwv_flow_imp.g_varchar2_table(9391) := '682E66726F6D506F736974696F6E73286C2C72293B692E70757368286E6577206E5328682C642B6329297D692E6C656E6774683E30262628742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C69';
wwv_flow_imp.g_varchar2_table(9392) := '292C742E70757368556E646F53746F702829297D7D293B636C617373204B537B676574206576656E7428297B72657475726E20746869732E656D69747465722E6576656E747D636F6E7374727563746F7228652C742C6E297B636F6E737420693D653D3E';
wwv_flow_imp.g_varchar2_table(9393) := '746869732E656D69747465722E666972652865293B746869732E656D69747465723D6E6577204374287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E652E6164644576656E744C697374656E657228742C692C6E292C6F6E446964';
wwv_flow_imp.g_varchar2_table(9394) := '52656D6F76654C6173744C697374656E65723A28293D3E652E72656D6F76654576656E744C697374656E657228742C692C6E297D297D646973706F736528297B746869732E656D69747465722E646973706F736528297D7D2166756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(9395) := '7B636F6E737420743D7B746F74616C3A302C6D696E3A4E756D6265722E4D41585F56414C55452C6D61783A307D2C6E3D7B2E2E2E747D2C693D7B2E2E2E747D2C6F3D7B2E2E2E747D3B6C657420733D303B636F6E737420723D7B6B6579646F776E3A302C';
wwv_flow_imp.g_varchar2_table(9396) := '696E7075743A302C72656E6465723A307D3B66756E6374696F6E206128297B313D3D3D722E6B6579646F776E262628706572666F726D616E63652E6D61726B28226B6579646F776E2F656E6422292C722E6B6579646F776E3D32297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(9397) := '206C28297B706572666F726D616E63652E6D61726B2822696E7075742F737461727422292C722E696E7075743D312C6828297D66756E6374696F6E206328297B313D3D3D722E696E707574262628706572666F726D616E63652E6D61726B2822696E7075';
wwv_flow_imp.g_varchar2_table(9398) := '742F656E6422292C722E696E7075743D32297D66756E6374696F6E206428297B313D3D3D722E72656E646572262628706572666F726D616E63652E6D61726B282272656E6465722F656E6422292C722E72656E6465723D32297D66756E6374696F6E2068';
wwv_flow_imp.g_varchar2_table(9399) := '28297B73657454696D656F75742875297D66756E6374696F6E207528297B323D3D3D722E6B6579646F776E2626323D3D3D722E696E7075742626323D3D3D722E72656E646572262628706572666F726D616E63652E6D61726B2822696E7075746C617465';
wwv_flow_imp.g_varchar2_table(9400) := '6E63792F656E6422292C706572666F726D616E63652E6D65617375726528226B6579646F776E222C226B6579646F776E2F7374617274222C226B6579646F776E2F656E6422292C706572666F726D616E63652E6D6561737572652822696E707574222C22';
wwv_flow_imp.g_varchar2_table(9401) := '696E7075742F7374617274222C22696E7075742F656E6422292C706572666F726D616E63652E6D656173757265282272656E646572222C2272656E6465722F7374617274222C2272656E6465722F656E6422292C706572666F726D616E63652E6D656173';
wwv_flow_imp.g_varchar2_table(9402) := '7572652822696E7075746C6174656E6379222C22696E7075746C6174656E63792F7374617274222C22696E7075746C6174656E63792F656E6422292C7028226B6579646F776E222C74292C702822696E707574222C6E292C70282272656E646572222C69';
wwv_flow_imp.g_varchar2_table(9403) := '292C702822696E7075746C6174656E6379222C6F292C732B2B2C706572666F726D616E63652E636C6561724D61726B7328226B6579646F776E2F737461727422292C706572666F726D616E63652E636C6561724D61726B7328226B6579646F776E2F656E';
wwv_flow_imp.g_varchar2_table(9404) := '6422292C706572666F726D616E63652E636C6561724D61726B732822696E7075742F737461727422292C706572666F726D616E63652E636C6561724D61726B732822696E7075742F656E6422292C706572666F726D616E63652E636C6561724D61726B73';
wwv_flow_imp.g_varchar2_table(9405) := '282272656E6465722F737461727422292C706572666F726D616E63652E636C6561724D61726B73282272656E6465722F656E6422292C706572666F726D616E63652E636C6561724D61726B732822696E7075746C6174656E63792F737461727422292C70';
wwv_flow_imp.g_varchar2_table(9406) := '6572666F726D616E63652E636C6561724D61726B732822696E7075746C6174656E63792F656E6422292C706572666F726D616E63652E636C6561724D6561737572657328226B6579646F776E22292C706572666F726D616E63652E636C6561724D656173';
wwv_flow_imp.g_varchar2_table(9407) := '757265732822696E70757422292C706572666F726D616E63652E636C6561724D65617375726573282272656E64657222292C706572666F726D616E63652E636C6561724D656173757265732822696E7075746C6174656E637922292C722E6B6579646F77';
wwv_flow_imp.g_varchar2_table(9408) := '6E3D302C722E696E7075743D302C722E72656E6465723D30297D66756E6374696F6E207028652C74297B636F6E7374206E3D706572666F726D616E63652E676574456E747269657342794E616D652865295B305D2E6475726174696F6E3B742E746F7461';
wwv_flow_imp.g_varchar2_table(9409) := '6C2B3D6E2C742E6D696E3D4D6174682E6D696E28742E6D696E2C6E292C742E6D61783D4D6174682E6D617828742E6D61782C6E297D66756E6374696F6E20672865297B72657475726E7B617665726167653A652E746F74616C2F732C6D61783A652E6D61';
wwv_flow_imp.g_varchar2_table(9410) := '782C6D696E3A652E6D696E7D7D66756E6374696F6E206D2865297B652E746F74616C3D302C652E6D696E3D4E756D6265722E4D41585F56414C55452C652E6D61783D307D652E6F6E4B6579446F776E3D66756E6374696F6E28297B7528292C706572666F';
wwv_flow_imp.g_varchar2_table(9411) := '726D616E63652E6D61726B2822696E7075746C6174656E63792F737461727422292C706572666F726D616E63652E6D61726B28226B6579646F776E2F737461727422292C722E6B6579646F776E3D312C71756575654D6963726F7461736B2861297D2C65';
wwv_flow_imp.g_varchar2_table(9412) := '2E6F6E4265666F7265496E7075743D6C2C652E6F6E496E7075743D66756E6374696F6E28297B303D3D3D722E696E70757426266C28292C71756575654D6963726F7461736B2863297D2C652E6F6E4B657955703D66756E6374696F6E28297B7528297D2C';
wwv_flow_imp.g_varchar2_table(9413) := '652E6F6E53656C656374696F6E4368616E67653D66756E6374696F6E28297B7528297D2C652E6F6E52656E64657253746172743D66756E6374696F6E28297B323D3D3D722E6B6579646F776E2626323D3D3D722E696E7075742626303D3D3D722E72656E';
wwv_flow_imp.g_varchar2_table(9414) := '646572262628706572666F726D616E63652E6D61726B282272656E6465722F737461727422292C722E72656E6465723D312C71756575654D6963726F7461736B2864292C682829297D2C652E676574416E64436C6561724D6561737572656D656E74733D';
wwv_flow_imp.g_varchar2_table(9415) := '66756E6374696F6E28297B696628303D3D3D732972657475726E3B636F6E737420653D7B6B6579646F776E3A672874292C696E7075743A67286E292C72656E6465723A672869292C746F74616C3A67286F292C73616D706C65436F756E743A737D3B7265';
wwv_flow_imp.g_varchar2_table(9416) := '7475726E206D2874292C6D286E292C6D2869292C6D286F292C733D302C657D7D2857537C7C2857533D7B7D29293B636C6173732047537B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E76616C75653D652C746869732E73656C65';
wwv_flow_imp.g_varchar2_table(9417) := '6374696F6E53746172743D742C746869732E73656C656374696F6E456E643D6E2C746869732E73656C656374696F6E3D692C746869732E6E65776C696E65436F756E744265666F726553656C656374696F6E3D6F7D746F537472696E6728297B72657475';
wwv_flow_imp.g_varchar2_table(9418) := '726E605B203C247B746869732E76616C75657D3E2C2073656C656374696F6E53746172743A20247B746869732E73656C656374696F6E53746172747D2C2073656C656374696F6E456E643A20247B746869732E73656C656374696F6E456E647D5D607D73';
wwv_flow_imp.g_varchar2_table(9419) := '7461746963207265616446726F6D546578744172656128652C74297B636F6E7374206E3D652E67657456616C756528292C693D652E67657453656C656374696F6E537461727428292C6F3D652E67657453656C656374696F6E456E6428293B6C65742073';
wwv_flow_imp.g_varchar2_table(9420) := '3B72657475726E207426266E2E737562737472696E6728302C69293D3D3D742E76616C75652E737562737472696E6728302C742E73656C656374696F6E537461727429262628733D742E6E65776C696E65436F756E744265666F726553656C656374696F';
wwv_flow_imp.g_varchar2_table(9421) := '6E292C6E6577204753286E2C692C6F2C6E756C6C2C73297D636F6C6C6170736553656C656374696F6E28297B72657475726E20746869732E73656C656374696F6E53746172743D3D3D746869732E76616C75652E6C656E6774683F746869733A6E657720';
wwv_flow_imp.g_varchar2_table(9422) := '475328746869732E76616C75652C746869732E76616C75652E6C656E6774682C746869732E76616C75652E6C656E6774682C6E756C6C2C766F69642030297D7772697465546F546578744172656128652C742C6E297B742E73657456616C756528652C74';
wwv_flow_imp.g_varchar2_table(9423) := '6869732E76616C7565292C6E2626742E73657453656C656374696F6E52616E676528652C746869732E73656C656374696F6E53746172742C746869732E73656C656374696F6E456E64297D646564756365456469746F72506F736974696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(9424) := '617220742C6E2C692C6F2C732C722C612C6C3B696628653C3D746869732E73656C656374696F6E5374617274297B636F6E737420693D746869732E76616C75652E737562737472696E6728652C746869732E73656C656374696F6E5374617274293B7265';
wwv_flow_imp.g_varchar2_table(9425) := '7475726E20746869732E5F66696E697368446564756365456469746F72506F736974696F6E286E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E73656C656374696F6E297C7C766F696420303D3D3D743F766F696420303A742E6765745374';
wwv_flow_imp.g_varchar2_table(9426) := '617274506F736974696F6E2829292626766F69642030213D3D6E3F6E3A6E756C6C2C692C2D31297D696628653E3D746869732E73656C656374696F6E456E64297B636F6E737420743D746869732E76616C75652E737562737472696E6728746869732E73';
wwv_flow_imp.g_varchar2_table(9427) := '656C656374696F6E456E642C65293B72657475726E20746869732E5F66696E697368446564756365456469746F72506F736974696F6E286E756C6C213D3D286F3D6E756C6C3D3D3D28693D746869732E73656C656374696F6E297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(9428) := '3D693F766F696420303A692E676574456E64506F736974696F6E2829292626766F69642030213D3D6F3F6F3A6E756C6C2C742C31297D636F6E737420633D746869732E76616C75652E737562737472696E6728746869732E73656C656374696F6E537461';
wwv_flow_imp.g_varchar2_table(9429) := '72742C65293B6966282D313D3D3D632E696E6465784F6628537472696E672E66726F6D43686172436F6465283832333029292972657475726E20746869732E5F66696E697368446564756365456469746F72506F736974696F6E286E756C6C213D3D2872';
wwv_flow_imp.g_varchar2_table(9430) := '3D6E756C6C3D3D3D28733D746869732E73656C656374696F6E297C7C766F696420303D3D3D733F766F696420303A732E6765745374617274506F736974696F6E2829292626766F69642030213D3D723F723A6E756C6C2C632C31293B636F6E737420643D';
wwv_flow_imp.g_varchar2_table(9431) := '746869732E76616C75652E737562737472696E6728652C746869732E73656C656374696F6E456E64293B72657475726E20746869732E5F66696E697368446564756365456469746F72506F736974696F6E286E756C6C213D3D286C3D6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(9432) := '613D746869732E73656C656374696F6E297C7C766F696420303D3D3D613F766F696420303A612E676574456E64506F736974696F6E2829292626766F69642030213D3D6C3F6C3A6E756C6C2C642C2D31297D5F66696E697368446564756365456469746F';
wwv_flow_imp.g_varchar2_table(9433) := '72506F736974696F6E28652C742C6E297B6C657420693D302C6F3D2D313B666F72283B2D31213D3D286F3D742E696E6465784F6628225C6E222C6F2B3129293B29692B2B3B72657475726E5B652C6E2A742E6C656E6774682C695D7D7374617469632064';
wwv_flow_imp.g_varchar2_table(9434) := '6564756365496E70757428652C742C6E297B69662821652972657475726E7B746578743A22222C7265706C6163655072657643686172436E743A302C7265706C6163654E65787443686172436E743A302C706F736974696F6E44656C74613A307D3B636F';
wwv_flow_imp.g_varchar2_table(9435) := '6E737420693D4D6174682E6D696E284C6928652E76616C75652C742E76616C7565292C652E73656C656374696F6E53746172742C742E73656C656374696F6E5374617274292C6F3D4D6174682E6D696E28446928652E76616C75652C742E76616C756529';
wwv_flow_imp.g_varchar2_table(9436) := '2C652E76616C75652E6C656E6774682D652E73656C656374696F6E456E642C742E76616C75652E6C656E6774682D742E73656C656374696F6E456E64292C733D28652E76616C75652E737562737472696E6728692C652E76616C75652E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(9437) := '6F292C742E76616C75652E737562737472696E6728692C742E76616C75652E6C656E6774682D6F29292C723D652E73656C656374696F6E53746172742D692C613D652E73656C656374696F6E456E642D693B696628742E73656C656374696F6E53746172';
wwv_flow_imp.g_varchar2_table(9438) := '742D693D3D3D742E73656C656374696F6E456E642D69297B72657475726E7B746578743A732C7265706C6163655072657643686172436E743A652E73656C656374696F6E53746172742D692C7265706C6163654E65787443686172436E743A302C706F73';
wwv_flow_imp.g_varchar2_table(9439) := '6974696F6E44656C74613A307D7D72657475726E7B746578743A732C7265706C6163655072657643686172436E743A612D722C7265706C6163654E65787443686172436E743A302C706F736974696F6E44656C74613A307D7D7374617469632064656475';
wwv_flow_imp.g_varchar2_table(9440) := '6365416E64726F6964436F6D706F736974696F6E496E70757428652C74297B69662821652972657475726E7B746578743A22222C7265706C6163655072657643686172436E743A302C7265706C6163654E65787443686172436E743A302C706F73697469';
wwv_flow_imp.g_varchar2_table(9441) := '6F6E44656C74613A307D3B696628652E76616C75653D3D3D742E76616C75652972657475726E7B746578743A22222C7265706C6163655072657643686172436E743A302C7265706C6163654E65787443686172436E743A302C706F736974696F6E44656C';
wwv_flow_imp.g_varchar2_table(9442) := '74613A742E73656C656374696F6E456E642D652E73656C656374696F6E456E647D3B636F6E7374206E3D4D6174682E6D696E284C6928652E76616C75652C742E76616C7565292C652E73656C656374696F6E456E64292C693D4D6174682E6D696E284469';
wwv_flow_imp.g_varchar2_table(9443) := '28652E76616C75652C742E76616C7565292C652E76616C75652E6C656E6774682D652E73656C656374696F6E456E64292C6F3D652E76616C75652E737562737472696E67286E2C652E76616C75652E6C656E6774682D69292C733D742E76616C75652E73';
wwv_flow_imp.g_varchar2_table(9444) := '7562737472696E67286E2C742E76616C75652E6C656E6774682D69292C723D28652E73656C656374696F6E53746172742C652E73656C656374696F6E456E642D6E292C613D28742E73656C656374696F6E53746172742C742E73656C656374696F6E456E';
wwv_flow_imp.g_varchar2_table(9445) := '642D6E293B72657475726E7B746578743A732C7265706C6163655072657643686172436E743A722C7265706C6163654E65787443686172436E743A6F2E6C656E6774682D722C706F736974696F6E44656C74613A612D732E6C656E6774687D7D7D47532E';
wwv_flow_imp.g_varchar2_table(9446) := '454D5054593D6E65772047532822222C302C302C6E756C6C2C766F69642030293B636C6173732051537B737461746963205F676574506167654F664C696E6528652C74297B72657475726E204D6174682E666C6F6F722828652D31292F74297D73746174';
wwv_flow_imp.g_varchar2_table(9447) := '6963205F67657452616E6765466F725061676528652C74297B636F6E7374206E3D652A743B72657475726E206E6577207268286E2B312C312C6E2B742B312C31297D7374617469632066726F6D456469746F7253656C656374696F6E28652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(9448) := '297B636F6E7374206F3D3530302C733D51532E5F676574506167654F664C696E6528742E73746172744C696E654E756D6265722C6E292C723D51532E5F67657452616E6765466F725061676528732C6E292C613D51532E5F676574506167654F664C696E';
wwv_flow_imp.g_varchar2_table(9449) := '6528742E656E644C696E654E756D6265722C6E292C6C3D51532E5F67657452616E6765466F725061676528612C6E293B6C657420633D722E696E7465727365637452616E676573286E657720726828312C312C742E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(9450) := '2C742E7374617274436F6C756D6E29293B696628692626652E67657456616C75654C656E677468496E52616E676528632C31293E6F297B636F6E737420743D652E6D6F64696679506F736974696F6E28632E676574456E64506F736974696F6E28292C2D';
wwv_flow_imp.g_varchar2_table(9451) := '353030293B633D72682E66726F6D506F736974696F6E7328742C632E676574456E64506F736974696F6E2829297D636F6E737420643D652E67657456616C7565496E52616E676528632C31292C683D652E6765744C696E65436F756E7428292C753D652E';
wwv_flow_imp.g_varchar2_table(9452) := '6765744C696E654D6178436F6C756D6E2868293B6C657420703D6C2E696E7465727365637452616E676573286E657720726828742E656E644C696E654E756D6265722C742E656E64436F6C756D6E2C682C7529293B696628692626652E67657456616C75';
wwv_flow_imp.g_varchar2_table(9453) := '654C656E677468496E52616E676528702C31293E6F297B636F6E737420743D652E6D6F64696679506F736974696F6E28702E6765745374617274506F736974696F6E28292C6F293B703D72682E66726F6D506F736974696F6E7328702E67657453746172';
wwv_flow_imp.g_varchar2_table(9454) := '74506F736974696F6E28292C74297D636F6E737420673D652E67657456616C7565496E52616E676528702C31293B6C6574206D3B696628733D3D3D617C7C732B313D3D3D61296D3D652E67657456616C7565496E52616E676528742C31293B656C73657B';
wwv_flow_imp.g_varchar2_table(9455) := '636F6E7374206E3D722E696E7465727365637452616E6765732874292C693D6C2E696E7465727365637452616E6765732874293B6D3D652E67657456616C7565496E52616E6765286E2C31292B537472696E672E66726F6D43686172436F646528383233';
wwv_flow_imp.g_varchar2_table(9456) := '30292B652E67657456616C7565496E52616E676528692C31297D72657475726E206926266D2E6C656E6774683E3165332626286D3D6D2E737562737472696E6728302C6F292B537472696E672E66726F6D43686172436F64652838323330292B6D2E7375';
wwv_flow_imp.g_varchar2_table(9457) := '62737472696E67286D2E6C656E6774682D6F2C6D2E6C656E67746829292C6E657720475328642B6D2B672C642E6C656E6774682C642E6C656E6774682B6D2E6C656E6774682C742C632E656E644C696E654E756D6265722D632E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(9458) := '756D626572297D7D636F6E73742059533D706328226163636573736962696C6974795365727669636522292C5A533D6E6577206C6428226163636573736962696C6974794D6F6465456E61626C6564222C2131293B7661722058532C4A533D66756E6374';
wwv_flow_imp.g_varchar2_table(9459) := '696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B2166756E6374696F6E2865297B652E5461703D222D6D6F6E61636F2D74657874617265612D73796E7468657469632D746170227D2858537C7C2858';
wwv_flow_imp.g_varchar2_table(9460) := '533D7B7D29293B636F6E73742065783D7B666F726365436F70795769746853796E746178486967686C69676874696E673A21317D3B636C6173732074787B636F6E7374727563746F7228297B746869732E5F6C61737453746174653D6E756C6C7D736574';
wwv_flow_imp.g_varchar2_table(9461) := '28652C74297B746869732E5F6C61737453746174653D7B6C617374436F7069656456616C75653A652C646174613A747D7D6765742865297B72657475726E20746869732E5F6C61737453746174652626746869732E5F6C61737453746174652E6C617374';
wwv_flow_imp.g_varchar2_table(9462) := '436F7069656456616C75653D3D3D653F746869732E5F6C61737453746174652E646174613A28746869732E5F6C61737453746174653D6E756C6C2C6E756C6C297D7D74782E494E5354414E43453D6E65772074783B636C617373206E787B636F6E737472';
wwv_flow_imp.g_varchar2_table(9463) := '7563746F7228297B746869732E5F6C61737454797065546578744C656E6774683D307D68616E646C65436F6D706F736974696F6E5570646174652865297B636F6E737420743D7B746578743A653D657C7C22222C7265706C616365507265764368617243';
wwv_flow_imp.g_varchar2_table(9464) := '6E743A746869732E5F6C61737454797065546578744C656E6774682C7265706C6163654E65787443686172436E743A302C706F736974696F6E44656C74613A307D3B72657475726E20746869732E5F6C61737454797065546578744C656E6774683D652E';
wwv_flow_imp.g_varchar2_table(9465) := '6C656E6774682C747D7D6C65742069783D636C61737320657874656E6473206C747B676574207465787441726561537461746528297B72657475726E20746869732E5F746578744172656153746174657D636F6E7374727563746F7228652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(9466) := '2C6F2C73297B737570657228292C746869732E5F686F73743D652C746869732E5F74657874417265613D742C746869732E5F4F533D6E2C746869732E5F62726F777365723D692C746869732E5F6163636573736962696C697479536572766963653D6F2C';
wwv_flow_imp.g_varchar2_table(9467) := '746869732E5F6C6F67536572766963653D732C746869732E5F6F6E466F6375733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E466F6375733D746869732E5F6F6E466F6375732E6576656E742C746869732E5F6F6E426C75';
wwv_flow_imp.g_varchar2_table(9468) := '723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E426C75723D746869732E5F6F6E426C75722E6576656E742C746869732E5F6F6E4B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E';
wwv_flow_imp.g_varchar2_table(9469) := '6F6E4B6579446F776E3D746869732E5F6F6E4B6579446F776E2E6576656E742C746869732E5F6F6E4B657955703D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4B657955703D746869732E5F6F6E4B657955702E6576656E';
wwv_flow_imp.g_varchar2_table(9470) := '742C746869732E5F6F6E4375743D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4375743D746869732E5F6F6E4375742E6576656E742C746869732E5F6F6E50617374653D746869732E5F7265676973746572286E65772043';
wwv_flow_imp.g_varchar2_table(9471) := '74292C746869732E6F6E50617374653D746869732E5F6F6E50617374652E6576656E742C746869732E5F6F6E547970653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E547970653D746869732E5F6F6E547970652E657665';
wwv_flow_imp.g_varchar2_table(9472) := '6E742C746869732E5F6F6E436F6D706F736974696F6E53746172743D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436F6D706F736974696F6E53746172743D746869732E5F6F6E436F6D706F736974696F6E53746172742E';
wwv_flow_imp.g_varchar2_table(9473) := '6576656E742C746869732E5F6F6E436F6D706F736974696F6E5570646174653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436F6D706F736974696F6E5570646174653D746869732E5F6F6E436F6D706F736974696F6E55';
wwv_flow_imp.g_varchar2_table(9474) := '70646174652E6576656E742C746869732E5F6F6E436F6D706F736974696F6E456E643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436F6D706F736974696F6E456E643D746869732E5F6F6E436F6D706F736974696F6E45';
wwv_flow_imp.g_varchar2_table(9475) := '6E642E6576656E742C746869732E5F6F6E53656C656374696F6E4368616E6765526571756573743D746869732E5F7265676973746572286E6577204374292C746869732E6F6E53656C656374696F6E4368616E6765526571756573743D746869732E5F6F';
wwv_flow_imp.g_varchar2_table(9476) := '6E53656C656374696F6E4368616E6765526571756573742E6576656E742C746869732E5F6173796E63466F6375734761696E577269746553637265656E526561646572436F6E74656E743D746869732E5F7265676973746572286E6577206374292C7468';
wwv_flow_imp.g_varchar2_table(9477) := '69732E5F6173796E63547269676765724375743D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F6F6E4375742E666972652829292C3029292C746869732E5F746578744172656153746174653D47532E454D5054592C';
wwv_flow_imp.g_varchar2_table(9478) := '746869732E5F73656C656374696F6E4368616E67654C697374656E65723D6E756C6C2C746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A656428292626746869732E77726974654E';
wwv_flow_imp.g_varchar2_table(9479) := '61746976655465787441726561436F6E74656E74282263746F7222292C746869732E5F72656769737465722876742E72756E416E6453756273637269626528746869732E5F6163636573736962696C697479536572766963652E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(9480) := '6553637265656E5265616465724F7074696D697A65642C2828293D3E7B746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A65642829262621746869732E5F6173796E63466F637573';
wwv_flow_imp.g_varchar2_table(9481) := '4761696E577269746553637265656E526561646572436F6E74656E742E76616C75653F746869732E5F6173796E63466F6375734761696E577269746553637265656E526561646572436F6E74656E742E76616C75653D746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(9482) := '286E6577204B74282828293D3E746869732E77726974654E61746976655465787441726561436F6E74656E7428226173796E63466F6375734761696E2229292C3029293A746869732E5F6173796E63466F6375734761696E577269746553637265656E52';
wwv_flow_imp.g_varchar2_table(9483) := '6561646572436F6E74656E742E636C65617228297D2929292C746869732E5F686173466F6375733D21312C746869732E5F63757272656E74436F6D706F736974696F6E3D6E756C6C3B6C657420723D6E756C6C3B746869732E5F72656769737465722874';
wwv_flow_imp.g_varchar2_table(9484) := '6869732E5F74657874417265612E6F6E4B6579446F776E2828653D3E7B636F6E737420743D6E65772071652865293B283131343D3D3D742E6B6579436F64657C7C746869732E5F63757272656E74436F6D706F736974696F6E2626313D3D3D742E6B6579';
wwv_flow_imp.g_varchar2_table(9485) := '436F6465292626742E73746F7050726F7061676174696F6E28292C742E657175616C732839292626742E70726576656E7444656661756C7428292C723D742C746869732E5F6F6E4B6579446F776E2E666972652874297D2929292C746869732E5F726567';
wwv_flow_imp.g_varchar2_table(9486) := '697374657228746869732E5F74657874417265612E6F6E4B657955702828653D3E7B636F6E737420743D6E65772071652865293B746869732E5F6F6E4B657955702E666972652874297D2929292C746869732E5F726567697374657228746869732E5F74';
wwv_flow_imp.g_varchar2_table(9487) := '657874417265612E6F6E436F6D706F736974696F6E53746172742828653D3E7B636F6E737420743D6E6577206E783B696628746869732E5F63757272656E74436F6D706F736974696F6E29746869732E5F63757272656E74436F6D706F736974696F6E3D';
wwv_flow_imp.g_varchar2_table(9488) := '743B656C73657B696628746869732E5F63757272656E74436F6D706F736974696F6E3D742C323D3D3D746869732E5F4F532626722626722E657175616C7328313134292626746869732E5F746578744172656153746174652E73656C656374696F6E5374';
wwv_flow_imp.g_varchar2_table(9489) := '6172743D3D3D746869732E5F746578744172656153746174652E73656C656374696F6E456E642626746869732E5F746578744172656153746174652E73656C656374696F6E53746172743E302626746869732E5F746578744172656153746174652E7661';
wwv_flow_imp.g_varchar2_table(9490) := '6C75652E73756273747228746869732E5F746578744172656153746174652E73656C656374696F6E53746172742D312C31293D3D3D652E64617461262628224172726F775269676874223D3D3D722E636F64657C7C224172726F774C656674223D3D3D72';
wwv_flow_imp.g_varchar2_table(9491) := '2E636F6465292972657475726E20742E68616E646C65436F6D706F736974696F6E55706461746528227822292C766F696420746869732E5F6F6E436F6D706F736974696F6E53746172742E66697265287B646174613A652E646174617D293B746869732E';
wwv_flow_imp.g_varchar2_table(9492) := '5F62726F777365722E6973416E64726F69642C746869732E5F6F6E436F6D706F736974696F6E53746172742E66697265287B646174613A652E646174617D297D7D2929292C746869732E5F726567697374657228746869732E5F74657874417265612E6F';
wwv_flow_imp.g_varchar2_table(9493) := '6E436F6D706F736974696F6E5570646174652828653D3E7B636F6E737420743D746869732E5F63757272656E74436F6D706F736974696F6E3B69662821742972657475726E3B696628746869732E5F62726F777365722E6973416E64726F6964297B636F';
wwv_flow_imp.g_varchar2_table(9494) := '6E737420743D47532E7265616446726F6D546578744172656128746869732E5F74657874417265612C746869732E5F74657874417265615374617465292C6E3D47532E646564756365416E64726F6964436F6D706F736974696F6E496E70757428746869';
wwv_flow_imp.g_varchar2_table(9495) := '732E5F746578744172656153746174652C74293B72657475726E20746869732E5F746578744172656153746174653D742C746869732E5F6F6E547970652E66697265286E292C766F696420746869732E5F6F6E436F6D706F736974696F6E557064617465';
wwv_flow_imp.g_varchar2_table(9496) := '2E666972652865297D636F6E7374206E3D742E68616E646C65436F6D706F736974696F6E55706461746528652E64617461293B746869732E5F746578744172656153746174653D47532E7265616446726F6D546578744172656128746869732E5F746578';
wwv_flow_imp.g_varchar2_table(9497) := '74417265612C746869732E5F74657874417265615374617465292C746869732E5F6F6E547970652E66697265286E292C746869732E5F6F6E436F6D706F736974696F6E5570646174652E666972652865297D2929292C746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(9498) := '28746869732E5F74657874417265612E6F6E436F6D706F736974696F6E456E642828653D3E7B636F6E737420743D746869732E5F63757272656E74436F6D706F736974696F6E3B69662821742972657475726E3B696628746869732E5F63757272656E74';
wwv_flow_imp.g_varchar2_table(9499) := '436F6D706F736974696F6E3D6E756C6C2C746869732E5F62726F777365722E6973416E64726F6964297B636F6E737420653D47532E7265616446726F6D546578744172656128746869732E5F74657874417265612C746869732E5F746578744172656153';
wwv_flow_imp.g_varchar2_table(9500) := '74617465292C743D47532E646564756365416E64726F6964436F6D706F736974696F6E496E70757428746869732E5F746578744172656153746174652C65293B72657475726E20746869732E5F746578744172656153746174653D652C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(9501) := '6E547970652E666972652874292C766F696420746869732E5F6F6E436F6D706F736974696F6E456E642E6669726528297D636F6E7374206E3D742E68616E646C65436F6D706F736974696F6E55706461746528652E64617461293B746869732E5F746578';
wwv_flow_imp.g_varchar2_table(9502) := '744172656153746174653D47532E7265616446726F6D546578744172656128746869732E5F74657874417265612C746869732E5F74657874417265615374617465292C746869732E5F6F6E547970652E66697265286E292C746869732E5F6F6E436F6D70';
wwv_flow_imp.g_varchar2_table(9503) := '6F736974696F6E456E642E6669726528297D2929292C746869732E5F726567697374657228746869732E5F74657874417265612E6F6E496E7075742828653D3E7B696628746869732E5F74657874417265612E73657449676E6F726553656C656374696F';
wwv_flow_imp.g_varchar2_table(9504) := '6E4368616E676554696D652822726563656976656420696E707574206576656E7422292C746869732E5F63757272656E74436F6D706F736974696F6E2972657475726E3B636F6E737420743D47532E7265616446726F6D54657874417265612874686973';
wwv_flow_imp.g_varchar2_table(9505) := '2E5F74657874417265612C746869732E5F74657874417265615374617465292C6E3D47532E646564756365496E70757428746869732E5F746578744172656153746174652C742C323D3D3D746869732E5F4F53293B2830213D3D6E2E7265706C61636550';
wwv_flow_imp.g_varchar2_table(9506) := '72657643686172436E747C7C31213D3D6E2E746578742E6C656E6774687C7C215469286E2E746578742E63686172436F64654174283029292626313237213D3D6E2E746578742E63686172436F6465417428302929262628746869732E5F746578744172';
wwv_flow_imp.g_varchar2_table(9507) := '656153746174653D742C22223D3D3D6E2E746578742626303D3D3D6E2E7265706C6163655072657643686172436E742626303D3D3D6E2E7265706C6163654E65787443686172436E742626303D3D3D6E2E706F736974696F6E44656C74617C7C74686973';
wwv_flow_imp.g_varchar2_table(9508) := '2E5F6F6E547970652E66697265286E29297D2929292C746869732E5F726567697374657228746869732E5F74657874417265612E6F6E4375742828653D3E7B746869732E5F74657874417265612E73657449676E6F726553656C656374696F6E4368616E';
wwv_flow_imp.g_varchar2_table(9509) := '676554696D652822726563656976656420637574206576656E7422292C746869732E5F656E73757265436C6970626F61726447657473456469746F7253656C656374696F6E2865292C746869732E5F6173796E63547269676765724375742E7363686564';
wwv_flow_imp.g_varchar2_table(9510) := '756C6528297D2929292C746869732E5F726567697374657228746869732E5F74657874417265612E6F6E436F70792828653D3E7B746869732E5F656E73757265436C6970626F61726447657473456469746F7253656C656374696F6E2865297D2929292C';
wwv_flow_imp.g_varchar2_table(9511) := '746869732E5F726567697374657228746869732E5F74657874417265612E6F6E50617374652828653D3E7B696628746869732E5F74657874417265612E73657449676E6F726553656C656374696F6E4368616E676554696D652822726563656976656420';
wwv_flow_imp.g_varchar2_table(9512) := '7061737465206576656E7422292C652E70726576656E7444656661756C7428292C21652E636C6970626F617264446174612972657475726E3B6C65745B742C6E5D3D6F782E676574546578744461746128652E636C6970626F61726444617461293B7426';
wwv_flow_imp.g_varchar2_table(9513) := '26286E3D6E7C7C74782E494E5354414E43452E6765742874292C746869732E5F6F6E50617374652E66697265287B746578743A742C6D657461646174613A6E7D29297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561';
wwv_flow_imp.g_varchar2_table(9514) := '2E6F6E466F637573282828293D3E7B636F6E737420653D746869732E5F686173466F6375733B746869732E5F736574486173466F637573282130292C746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465';
wwv_flow_imp.g_varchar2_table(9515) := '724F7074696D697A656428292626746869732E5F62726F777365722E6973536166617269262621652626746869732E5F686173466F637573262628746869732E5F6173796E63466F6375734761696E577269746553637265656E526561646572436F6E74';
wwv_flow_imp.g_varchar2_table(9516) := '656E742E76616C75657C7C28746869732E5F6173796E63466F6375734761696E577269746553637265656E526561646572436F6E74656E742E76616C75653D6E6577204B74282828293D3E746869732E77726974654E6174697665546578744172656143';
wwv_flow_imp.g_varchar2_table(9517) := '6F6E74656E7428226173796E63466F6375734761696E2229292C3029292C746869732E5F6173796E63466F6375734761696E577269746553637265656E526561646572436F6E74656E742E76616C75652E7363686564756C652829297D2929292C746869';
wwv_flow_imp.g_varchar2_table(9518) := '732E5F726567697374657228746869732E5F74657874417265612E6F6E426C7572282828293D3E7B746869732E5F63757272656E74436F6D706F736974696F6E262628746869732E5F63757272656E74436F6D706F736974696F6E3D6E756C6C2C746869';
wwv_flow_imp.g_varchar2_table(9519) := '732E77726974654E61746976655465787441726561436F6E74656E742822626C7572576974686F7574436F6D706F736974696F6E456E6422292C746869732E5F6F6E436F6D706F736974696F6E456E642E666972652829292C746869732E5F7365744861';
wwv_flow_imp.g_varchar2_table(9520) := '73466F637573282131297D2929292C746869732E5F726567697374657228746869732E5F74657874417265612E6F6E53796E746865746963546170282828293D3E7B746869732E5F62726F777365722E6973416E64726F69642626746869732E5F637572';
wwv_flow_imp.g_varchar2_table(9521) := '72656E74436F6D706F736974696F6E262628746869732E5F63757272656E74436F6D706F736974696F6E3D6E756C6C2C746869732E77726974654E61746976655465787441726561436F6E74656E742822746170576974686F7574436F6D706F73697469';
wwv_flow_imp.g_varchar2_table(9522) := '6F6E456E6422292C746869732E5F6F6E436F6D706F736974696F6E456E642E666972652829297D2929297D5F696E7374616C6C53656C656374696F6E4368616E67654C697374656E657228297B6C657420653D303B72657475726E20627328746869732E';
wwv_flow_imp.g_varchar2_table(9523) := '5F74657874417265612E6F776E6572446F63756D656E742C2273656C656374696F6E6368616E6765222C28743D3E7B69662857532E6F6E53656C656374696F6E4368616E676528292C21746869732E5F686173466F6375732972657475726E3B69662874';
wwv_flow_imp.g_varchar2_table(9524) := '6869732E5F63757272656E74436F6D706F736974696F6E2972657475726E3B69662821746869732E5F62726F777365722E69734368726F6D652972657475726E3B636F6E7374206E3D446174652E6E6F7728292C693D6E2D653B696628653D6E2C693C35';
wwv_flow_imp.g_varchar2_table(9525) := '2972657475726E3B636F6E7374206F3D6E2D746869732E5F74657874417265612E67657449676E6F726553656C656374696F6E4368616E676554696D6528293B696628746869732E5F74657874417265612E726573657453656C656374696F6E4368616E';
wwv_flow_imp.g_varchar2_table(9526) := '676554696D6528292C6F3C3130302972657475726E3B69662821746869732E5F746578744172656153746174652E73656C656374696F6E2972657475726E3B636F6E737420733D746869732E5F74657874417265612E67657456616C756528293B696628';
wwv_flow_imp.g_varchar2_table(9527) := '746869732E5F746578744172656153746174652E76616C7565213D3D732972657475726E3B636F6E737420723D746869732E5F74657874417265612E67657453656C656374696F6E537461727428292C613D746869732E5F74657874417265612E676574';
wwv_flow_imp.g_varchar2_table(9528) := '53656C656374696F6E456E6428293B696628746869732E5F746578744172656153746174652E73656C656374696F6E53746172743D3D3D722626746869732E5F746578744172656153746174652E73656C656374696F6E456E643D3D3D61297265747572';
wwv_flow_imp.g_varchar2_table(9529) := '6E3B636F6E7374206C3D746869732E5F746578744172656153746174652E646564756365456469746F72506F736974696F6E2872292C633D746869732E5F686F73742E6465647563654D6F64656C506F736974696F6E286C5B305D2C6C5B315D2C6C5B32';
wwv_flow_imp.g_varchar2_table(9530) := '5D292C643D746869732E5F746578744172656153746174652E646564756365456469746F72506F736974696F6E2861292C683D746869732E5F686F73742E6465647563654D6F64656C506F736974696F6E28645B305D2C645B315D2C645B325D292C753D';
wwv_flow_imp.g_varchar2_table(9531) := '6E657720616828632E6C696E654E756D6265722C632E636F6C756D6E2C682E6C696E654E756D6265722C682E636F6C756D6E293B746869732E5F6F6E53656C656374696F6E4368616E6765526571756573742E666972652875297D29297D646973706F73';
wwv_flow_imp.g_varchar2_table(9532) := '6528297B73757065722E646973706F736528292C746869732E5F73656C656374696F6E4368616E67654C697374656E6572262628746869732E5F73656C656374696F6E4368616E67654C697374656E65722E646973706F736528292C746869732E5F7365';
wwv_flow_imp.g_varchar2_table(9533) := '6C656374696F6E4368616E67654C697374656E65723D6E756C6C297D666F637573546578744172656128297B746869732E5F736574486173466F637573282130292C746869732E72656672657368466F637573537461746528297D6973466F6375736564';
wwv_flow_imp.g_varchar2_table(9534) := '28297B72657475726E20746869732E5F686173466F6375737D72656672657368466F637573537461746528297B746869732E5F736574486173466F63757328746869732E5F74657874417265612E686173466F6375732829297D5F736574486173466F63';
wwv_flow_imp.g_varchar2_table(9535) := '75732865297B746869732E5F686173466F637573213D3D65262628746869732E5F686173466F6375733D652C746869732E5F73656C656374696F6E4368616E67654C697374656E6572262628746869732E5F73656C656374696F6E4368616E67654C6973';
wwv_flow_imp.g_varchar2_table(9536) := '74656E65722E646973706F736528292C746869732E5F73656C656374696F6E4368616E67654C697374656E65723D6E756C6C292C746869732E5F686173466F637573262628746869732E5F73656C656374696F6E4368616E67654C697374656E65723D74';
wwv_flow_imp.g_varchar2_table(9537) := '6869732E5F696E7374616C6C53656C656374696F6E4368616E67654C697374656E65722829292C746869732E5F686173466F6375732626746869732E77726974654E61746976655465787441726561436F6E74656E742822666F6375736761696E22292C';
wwv_flow_imp.g_varchar2_table(9538) := '746869732E5F686173466F6375733F746869732E5F6F6E466F6375732E6669726528293A746869732E5F6F6E426C75722E666972652829297D5F736574416E6457726974655465787441726561537461746528652C74297B746869732E5F686173466F63';
wwv_flow_imp.g_varchar2_table(9539) := '75737C7C28743D742E636F6C6C6170736553656C656374696F6E2829292C742E7772697465546F546578744172656128652C746869732E5F74657874417265612C746869732E5F686173466F637573292C746869732E5F74657874417265615374617465';
wwv_flow_imp.g_varchar2_table(9540) := '3D747D77726974654E61746976655465787441726561436F6E74656E742865297B21746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A6564282926262272656E646572223D3D3D65';
wwv_flow_imp.g_varchar2_table(9541) := '7C7C746869732E5F63757272656E74436F6D706F736974696F6E7C7C28746869732E5F6C6F67536572766963652E7472616365286077726974655465787441726561537461746528726561736F6E3A20247B657D2960292C746869732E5F736574416E64';
wwv_flow_imp.g_varchar2_table(9542) := '57726974655465787441726561537461746528652C746869732E5F686F73742E67657453637265656E526561646572436F6E74656E74282929297D5F656E73757265436C6970626F61726447657473456469746F7253656C656374696F6E2865297B636F';
wwv_flow_imp.g_varchar2_table(9543) := '6E737420743D746869732E5F686F73742E67657444617461546F436F707928292C6E3D7B76657273696F6E3A312C697346726F6D456D70747953656C656374696F6E3A742E697346726F6D456D70747953656C656374696F6E2C6D756C7469637572736F';
wwv_flow_imp.g_varchar2_table(9544) := '72546578743A742E6D756C7469637572736F72546578742C6D6F64653A742E6D6F64657D3B74782E494E5354414E43452E73657428746869732E5F62726F777365722E697346697265666F783F742E746578742E7265706C616365282F5C725C6E2F672C';
wwv_flow_imp.g_varchar2_table(9545) := '225C6E22293A742E746578742C6E292C652E70726576656E7444656661756C7428292C652E636C6970626F6172644461746126266F782E736574546578744461746128652E636C6970626F617264446174612C742E746578742C742E68746D6C2C6E297D';
wwv_flow_imp.g_varchar2_table(9546) := '7D3B69783D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F722874';
wwv_flow_imp.g_varchar2_table(9547) := '2C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B65';
wwv_flow_imp.g_varchar2_table(9548) := '6C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A';
wwv_flow_imp.g_varchar2_table(9549) := '6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4A5328342C5953292C4A5328352C5264295D2C6978293B636F6E7374206F783D7B67657454657874446174612865297B636F6E737420743D652E676574446174612845702E74';
wwv_flow_imp.g_varchar2_table(9550) := '657874293B6C6574206E3D6E756C6C3B636F6E737420693D652E6765744461746128227673636F64652D656469746F722D6461746122293B69662822737472696E67223D3D747970656F662069297472797B6E3D4A534F4E2E70617273652869292C3121';
wwv_flow_imp.g_varchar2_table(9551) := '3D3D6E2E76657273696F6E2626286E3D6E756C6C297D63617463682865297B7D72657475726E20303D3D3D742E6C656E67746826266E756C6C3D3D3D6E2626652E66696C65732E6C656E6774683E303F5B41727261792E70726F746F747970652E736C69';
wwv_flow_imp.g_varchar2_table(9552) := '63652E63616C6C28652E66696C65732C30292E6D61702828653D3E652E6E616D6529292E6A6F696E28225C6E22292C6E756C6C5D3A5B742C6E5D7D2C736574546578744461746128652C742C6E2C69297B652E736574446174612845702E746578742C74';
wwv_flow_imp.g_varchar2_table(9553) := '292C22737472696E67223D3D747970656F66206E2626652E736574446174612822746578742F68746D6C222C6E292C652E7365744461746128227673636F64652D656469746F722D64617461222C4A534F4E2E737472696E67696679286929297D7D3B63';
wwv_flow_imp.g_varchar2_table(9554) := '6C61737320737820657874656E6473206C747B676574206F776E6572446F63756D656E7428297B72657475726E20746869732E5F61637475616C2E6F776E6572446F63756D656E747D636F6E7374727563746F722865297B737570657228292C74686973';
wwv_flow_imp.g_varchar2_table(9555) := '2E5F61637475616C3D652C746869732E6F6E4B6579446F776E3D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C226B6579646F776E2229292E6576656E742C746869732E6F6E4B657955703D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(9556) := '676973746572286E6577204B5328746869732E5F61637475616C2C226B657975702229292E6576656E742C746869732E6F6E436F6D706F736974696F6E53746172743D746869732E5F7265676973746572286E6577204B5328746869732E5F6163747561';
wwv_flow_imp.g_varchar2_table(9557) := '6C2C22636F6D706F736974696F6E73746172742229292E6576656E742C746869732E6F6E436F6D706F736974696F6E5570646174653D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C22636F6D706F736974696F';
wwv_flow_imp.g_varchar2_table(9558) := '6E7570646174652229292E6576656E742C746869732E6F6E436F6D706F736974696F6E456E643D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C22636F6D706F736974696F6E656E642229292E6576656E742C74';
wwv_flow_imp.g_varchar2_table(9559) := '6869732E6F6E4265666F7265496E7075743D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C226265666F7265696E7075742229292E6576656E742C746869732E6F6E496E7075743D746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(9560) := '6572286E6577204B5328746869732E5F61637475616C2C22696E7075742229292E6576656E742C746869732E6F6E4375743D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C226375742229292E6576656E742C74';
wwv_flow_imp.g_varchar2_table(9561) := '6869732E6F6E436F70793D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C22636F70792229292E6576656E742C746869732E6F6E50617374653D746869732E5F7265676973746572286E6577204B532874686973';
wwv_flow_imp.g_varchar2_table(9562) := '2E5F61637475616C2C2270617374652229292E6576656E742C746869732E6F6E466F6375733D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C22666F6375732229292E6576656E742C746869732E6F6E426C7572';
wwv_flow_imp.g_varchar2_table(9563) := '3D746869732E5F7265676973746572286E6577204B5328746869732E5F61637475616C2C22626C75722229292E6576656E742C746869732E5F6F6E53796E7468657469635461703D746869732E5F7265676973746572286E6577204374292C746869732E';
wwv_flow_imp.g_varchar2_table(9564) := '6F6E53796E7468657469635461703D746869732E5F6F6E53796E7468657469635461702E6576656E742C746869732E5F69676E6F726553656C656374696F6E4368616E676554696D653D302C746869732E5F726567697374657228746869732E6F6E4B65';
wwv_flow_imp.g_varchar2_table(9565) := '79446F776E282828293D3E57532E6F6E4B6579446F776E28292929292C746869732E5F726567697374657228746869732E6F6E4265666F7265496E707574282828293D3E57532E6F6E4265666F7265496E70757428292929292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(9566) := '7374657228746869732E6F6E496E707574282828293D3E57532E6F6E496E70757428292929292C746869732E5F726567697374657228746869732E6F6E4B65795570282828293D3E57532E6F6E4B6579557028292929292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(9567) := '657228627328746869732E5F61637475616C2C58532E5461702C2828293D3E746869732E5F6F6E53796E7468657469635461702E6669726528292929297D686173466F63757328297B636F6E737420653D577328746869732E5F61637475616C293B7265';
wwv_flow_imp.g_varchar2_table(9568) := '7475726E20653F652E616374697665456C656D656E743D3D3D746869732E5F61637475616C3A2121746869732E5F61637475616C2E6973436F6E6E656374656426266A7328293D3D3D746869732E5F61637475616C7D73657449676E6F726553656C6563';
wwv_flow_imp.g_varchar2_table(9569) := '74696F6E4368616E676554696D652865297B746869732E5F69676E6F726553656C656374696F6E4368616E676554696D653D446174652E6E6F7728297D67657449676E6F726553656C656374696F6E4368616E676554696D6528297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(9570) := '6869732E5F69676E6F726553656C656374696F6E4368616E676554696D657D726573657453656C656374696F6E4368616E676554696D6528297B746869732E5F69676E6F726553656C656374696F6E4368616E676554696D653D307D67657456616C7565';
wwv_flow_imp.g_varchar2_table(9571) := '28297B72657475726E20746869732E5F61637475616C2E76616C75657D73657456616C756528652C74297B636F6E7374206E3D746869732E5F61637475616C3B6E2E76616C7565213D3D74262628746869732E73657449676E6F726553656C656374696F';
wwv_flow_imp.g_varchar2_table(9572) := '6E4368616E676554696D65282273657456616C756522292C6E2E76616C75653D74297D67657453656C656374696F6E537461727428297B72657475726E226261636B77617264223D3D3D746869732E5F61637475616C2E73656C656374696F6E44697265';
wwv_flow_imp.g_varchar2_table(9573) := '6374696F6E3F746869732E5F61637475616C2E73656C656374696F6E456E643A746869732E5F61637475616C2E73656C656374696F6E53746172747D67657453656C656374696F6E456E6428297B72657475726E226261636B77617264223D3D3D746869';
wwv_flow_imp.g_varchar2_table(9574) := '732E5F61637475616C2E73656C656374696F6E446972656374696F6E3F746869732E5F61637475616C2E73656C656374696F6E53746172743A746869732E5F61637475616C2E73656C656374696F6E456E647D73657453656C656374696F6E52616E6765';
wwv_flow_imp.g_varchar2_table(9575) := '28652C742C6E297B636F6E737420693D746869732E5F61637475616C3B6C6574206F3D6E756C6C3B636F6E737420733D57732869293B6F3D733F732E616374697665456C656D656E743A6A7328293B636F6E737420723D7273286F292C613D6F3D3D3D69';
wwv_flow_imp.g_varchar2_table(9576) := '2C6C3D692E73656C656374696F6E53746172742C643D692E73656C656374696F6E456E643B6966286126266C3D3D3D742626643D3D3D6E29632626722E706172656E74213D3D722626692E666F63757328293B656C73657B696628612972657475726E20';
wwv_flow_imp.g_varchar2_table(9577) := '746869732E73657449676E6F726553656C656374696F6E4368616E676554696D65282273657453656C656374696F6E52616E676522292C692E73657453656C656374696F6E52616E676528742C6E292C766F696428632626722E706172656E74213D3D72';
wwv_flow_imp.g_varchar2_table(9578) := '2626692E666F6375732829293B7472797B636F6E737420653D66756E6374696F6E2865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B652626652E6E6F6465547970653D3D3D652E454C454D454E545F4E4F44453B6E2B2B29745B6E5D3D';
wwv_flow_imp.g_varchar2_table(9579) := '652E7363726F6C6C546F702C653D652E706172656E744E6F64653B72657475726E20747D2869293B746869732E73657449676E6F726553656C656374696F6E4368616E676554696D65282273657453656C656374696F6E52616E676522292C692E666F63';
wwv_flow_imp.g_varchar2_table(9580) := '757328292C692E73657453656C656374696F6E52616E676528742C6E292C66756E6374696F6E28652C74297B666F72286C6574206E3D303B652626652E6E6F6465547970653D3D3D652E454C454D454E545F4E4F44453B6E2B2B29652E7363726F6C6C54';
wwv_flow_imp.g_varchar2_table(9581) := '6F70213D3D745B6E5D262628652E7363726F6C6C546F703D745B6E5D292C653D652E706172656E744E6F64657D28692C65297D63617463682865297B7D7D7D7D636F6E73742072783D66756E6374696F6E28297B696628226F626A656374223D3D747970';
wwv_flow_imp.g_varchar2_table(9582) := '656F662063727970746F26262266756E6374696F6E223D3D747970656F662063727970746F2E72616E646F6D555549442972657475726E2063727970746F2E72616E646F6D555549442E62696E642863727970746F293B6C657420653B653D226F626A65';
wwv_flow_imp.g_varchar2_table(9583) := '6374223D3D747970656F662063727970746F26262266756E6374696F6E223D3D747970656F662063727970746F2E67657452616E646F6D56616C7565733F63727970746F2E67657452616E646F6D56616C7565732E62696E642863727970746F293A6675';
wwv_flow_imp.g_varchar2_table(9584) := '6E6374696F6E2865297B666F72286C657420743D303B743C652E6C656E6774683B742B2B29655B745D3D4D6174682E666C6F6F72283235362A4D6174682E72616E646F6D2829293B72657475726E20657D3B636F6E737420743D6E65772055696E743841';
wwv_flow_imp.g_varchar2_table(9585) := '72726179283136292C6E3D5B5D3B666F72286C657420653D303B653C3235363B652B2B296E2E7075736828652E746F537472696E67283136292E706164537461727428322C22302229293B72657475726E2066756E6374696F6E28297B652874292C745B';
wwv_flow_imp.g_varchar2_table(9586) := '365D3D313526745B365D7C36342C745B385D3D363326745B385D7C3132383B6C657420693D302C6F3D22223B72657475726E206F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B';
wwv_flow_imp.g_varchar2_table(9587) := '5D5D2C6F2B3D222D222C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D222D222C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D222D222C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D';
wwv_flow_imp.g_varchar2_table(9588) := '5D2C6F2B3D222D222C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F2B3D6E5B745B692B2B5D5D2C6F7D7D28293B66756E6374696F';
wwv_flow_imp.g_varchar2_table(9589) := '6E2061782865297B72657475726E7B6173537472696E673A6173796E6328293D3E652C617346696C653A28293D3E7B7D2C76616C75653A22737472696E67223D3D747970656F6620653F653A766F696420307D7D636C617373206C787B636F6E73747275';
wwv_flow_imp.g_varchar2_table(9590) := '63746F7228297B746869732E5F656E74726965733D6E6577204D61707D6765742073697A6528297B6C657420653D303B666F7228636F6E73742074206F6620746869732E5F656E747269657329652B2B3B72657475726E20657D6861732865297B726574';
wwv_flow_imp.g_varchar2_table(9591) := '75726E20746869732E5F656E74726965732E68617328746869732E746F4B6579286529297D6D6174636865732865297B636F6E737420743D5B2E2E2E746869732E5F656E74726965732E6B65797328295D3B72657475726E205A652E736F6D6528746869';
wwv_flow_imp.g_varchar2_table(9592) := '732C28285B652C745D293D3E742E617346696C65282929292626742E70757368282266696C657322292C68782863782865292C74297D6765742865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E5F656E74726965732E6765';
wwv_flow_imp.g_varchar2_table(9593) := '7428746869732E746F4B657928652929297C7C766F696420303D3D3D743F766F696420303A745B305D7D617070656E6428652C74297B636F6E7374206E3D746869732E5F656E74726965732E6765742865293B6E3F6E2E707573682874293A746869732E';
wwv_flow_imp.g_varchar2_table(9594) := '5F656E74726965732E73657428746869732E746F4B65792865292C5B745D297D7265706C61636528652C74297B746869732E5F656E74726965732E73657428746869732E746F4B65792865292C5B745D297D64656C6574652865297B746869732E5F656E';
wwv_flow_imp.g_varchar2_table(9595) := '74726965732E64656C65746528746869732E746F4B6579286529297D2A5B53796D626F6C2E6974657261746F725D28297B666F7228636F6E73745B652C745D6F6620746869732E5F656E747269657329666F7228636F6E7374206E206F66207429796965';
wwv_flow_imp.g_varchar2_table(9596) := '6C645B652C6E5D7D746F4B65792865297B72657475726E2063782865297D7D66756E6374696F6E2063782865297B72657475726E20652E746F4C6F7765724361736528297D66756E6374696F6E20647828652C74297B72657475726E2068782863782865';
wwv_flow_imp.g_varchar2_table(9597) := '292C742E6D617028637829297D66756E6374696F6E20687828652C74297B696628222A2F2A223D3D3D652972657475726E20742E6C656E6774683E303B696628742E696E636C756465732865292972657475726E21303B636F6E7374206E3D652E6D6174';
wwv_flow_imp.g_varchar2_table(9598) := '6368282F5E285B612D7A5D2B295C2F285B612D7A5D2B7C5C2A29242F69293B696628216E2972657475726E21313B636F6E73745B692C6F2C735D3D6E3B72657475726E222A223D3D3D732626742E736F6D652828653D3E652E7374617274735769746828';
wwv_flow_imp.g_varchar2_table(9599) := '6F2B222F222929297D636F6E73742075783D4F626A6563742E667265657A65287B6372656174653A653D3E716828652E6D61702828653D3E652E746F537472696E6728292929292E6A6F696E28225C725C6E22292C73706C69743A653D3E652E73706C69';
wwv_flow_imp.g_varchar2_table(9600) := '7428225C725C6E22292C70617273653A653D3E75782E73706C69742865292E66696C7465722828653D3E21652E73746172747357697468282223222929297D293B636C6173732070787B636F6E7374727563746F722865297B746869732E76616C75653D';
wwv_flow_imp.g_varchar2_table(9601) := '657D657175616C732865297B72657475726E20746869732E76616C75653D3D3D652E76616C75657D636F6E7461696E732865297B72657475726E20746869732E657175616C732865297C7C22223D3D3D746869732E76616C75657C7C652E76616C75652E';
wwv_flow_imp.g_varchar2_table(9602) := '7374617274735769746828746869732E76616C75652B70782E736570297D696E74657273656374732865297B72657475726E20746869732E636F6E7461696E732865297C7C652E636F6E7461696E732874686973297D617070656E64282E2E2E65297B72';
wwv_flow_imp.g_varchar2_table(9603) := '657475726E206E65772070782828746869732E76616C75653F5B746869732E76616C75652C2E2E2E655D3A65292E6A6F696E2870782E73657029297D7D70782E7365703D222E222C70782E4E6F6E653D6E6577207078282240406E6F6E65404022292C70';
wwv_flow_imp.g_varchar2_table(9604) := '782E456D7074793D6E6577207078282222293B636F6E73742067783D7B5245534F55524345533A225265736F7572636555524C73222C444F574E4C4F41445F55524C3A22446F776E6C6F616455524C222C46494C45533A2246696C6573222C544558543A';
wwv_flow_imp.g_varchar2_table(9605) := '45702E746578742C494E5445524E414C5F5552495F4C4953543A226170706C69636174696F6E2F766E642E636F64652E7572692D6C697374227D3B79642E6164642822776F726B62656E63682E636F6E747269627574696F6E732E64726167416E644472';
wwv_flow_imp.g_varchar2_table(9606) := '6F70222C6E657720636C6173737B7D293B636C617373206D787B636F6E7374727563746F7228297B7D73746174696320676574496E7374616E636528297B72657475726E206D782E494E5354414E43457D686173446174612865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(9607) := '2626653D3D3D746869732E70726F746F7D676574446174612865297B696628746869732E686173446174612865292972657475726E20746869732E646174617D7D66756E6374696F6E2066782865297B636F6E737420743D6E6577206C783B666F722863';
wwv_flow_imp.g_varchar2_table(9608) := '6F6E7374206E206F6620652E6974656D73297B636F6E737420653D6E2E747970653B69662822737472696E67223D3D3D6E2E6B696E64297B636F6E737420693D6E65772050726F6D6973652828653D3E6E2E6765744173537472696E6728652929293B74';
wwv_flow_imp.g_varchar2_table(9609) := '2E617070656E6428652C6178286929297D656C7365206966282266696C65223D3D3D6E2E6B696E64297B636F6E737420693D6E2E676574417346696C6528293B692626742E617070656E6428652C7678286929297D7D72657475726E20747D66756E6374';
wwv_flow_imp.g_varchar2_table(9610) := '696F6E2076782865297B636F6E737420743D652E706174683F4E6F2E706172736528652E70617468293A766F696420303B72657475726E2066756E6374696F6E28652C742C6E297B636F6E737420693D7B69643A727828292C6E616D653A652C7572693A';
wwv_flow_imp.g_varchar2_table(9611) := '742C646174613A6E7D3B72657475726E7B6173537472696E673A6173796E6328293D3E22222C617346696C653A28293D3E692C76616C75653A766F696420307D7D28652E6E616D652C742C286173796E6328293D3E6E65772055696E7438417272617928';
wwv_flow_imp.g_varchar2_table(9612) := '617761697420652E617272617942756666657228292929297D6D782E494E5354414E43453D6E6577206D783B636F6E73742062783D4F626A6563742E667265657A65285B22436F6465456469746F7273222C22436F646546696C6573222C67782E524553';
wwv_flow_imp.g_varchar2_table(9613) := '4F55524345532C67782E494E5445524E414C5F5552495F4C4953545D293B66756E6374696F6E205F7828652C743D2131297B636F6E7374206E3D66782865292C693D6E2E6765742867782E494E5445524E414C5F5552495F4C495354293B69662869296E';
wwv_flow_imp.g_varchar2_table(9614) := '2E7265706C6163652845702E7572694C6973742C69293B656C736520696628747C7C216E2E6861732845702E7572694C69737429297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620652E6974656D73297B636F6E737420653D6E2E67';
wwv_flow_imp.g_varchar2_table(9615) := '6574417346696C6528293B69662865297B636F6E7374206E3D652E706174683B7472797B6E3F742E70757368284E6F2E66696C65286E292E746F537472696E672829293A742E70757368284E6F2E706172736528652E6E616D652C2130292E746F537472';
wwv_flow_imp.g_varchar2_table(9616) := '696E672829297D63617463682865297B7D7D7D742E6C656E67746826266E2E7265706C6163652845702E7572694C6973742C61782875782E63726561746528742929297D666F7228636F6E73742065206F66206278296E2E64656C6574652865293B7265';
wwv_flow_imp.g_varchar2_table(9617) := '7475726E206E7D636F6E73742079783D7063282249576F726B7370616365456469745365727669636522293B636C6173732077787B636F6E7374727563746F722865297B746869732E6D657461646174613D657D73746174696320636F6E766572742865';
wwv_flow_imp.g_varchar2_table(9618) := '297B72657475726E20652E65646974732E6D61702828653D3E7B69662843782E69732865292972657475726E2043782E6C6966742865293B69662853782E69732865292972657475726E2053782E6C6966742865293B7468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(9619) := '722822556E737570706F72746564206564697422297D29297D7D636C61737320437820657874656E64732077787B7374617469632069732865297B72657475726E206520696E7374616E63656F662043787C7C756C28652926264E6F2E69735572692865';
wwv_flow_imp.g_varchar2_table(9620) := '2E7265736F75726365292626756C28652E7465787445646974297D737461746963206C6966742865297B72657475726E206520696E7374616E63656F662043783F653A6E657720437828652E7265736F757263652C652E74657874456469742C652E7665';
wwv_flow_imp.g_varchar2_table(9621) := '7273696F6E49642C652E6D65746164617461297D636F6E7374727563746F7228652C742C6E3D766F696420302C69297B73757065722869292C746869732E7265736F757263653D652C746869732E74657874456469743D742C746869732E76657273696F';
wwv_flow_imp.g_varchar2_table(9622) := '6E49643D6E7D7D636C61737320537820657874656E64732077787B7374617469632069732865297B72657475726E206520696E7374616E63656F662053787C7C756C286529262628426F6F6C65616E28652E6E65775265736F75726365297C7C426F6F6C';
wwv_flow_imp.g_varchar2_table(9623) := '65616E28652E6F6C645265736F7572636529297D737461746963206C6966742865297B72657475726E206520696E7374616E63656F662053783F653A6E657720537828652E6F6C645265736F757263652C652E6E65775265736F757263652C652E6F7074';
wwv_flow_imp.g_varchar2_table(9624) := '696F6E732C652E6D65746164617461297D636F6E7374727563746F7228652C742C6E3D7B7D2C69297B73757065722869292C746869732E6F6C645265736F757263653D652C746869732E6E65775265736F757263653D742C746869732E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(9625) := '3D6E7D7D636F6E73742078783D70632822494C616E677561676546656174757265735365727669636522293B636C617373206B787B636F6E7374727563746F7228297B746869732E5F76616C75653D22222C746869732E5F706F733D307D726573657428';
wwv_flow_imp.g_varchar2_table(9626) := '65297B72657475726E20746869732E5F76616C75653D652C746869732E5F706F733D302C746869737D6E65787428297B72657475726E20746869732E5F706F732B3D312C746869737D6861734E65787428297B72657475726E20746869732E5F706F733C';
wwv_flow_imp.g_varchar2_table(9627) := '746869732E5F76616C75652E6C656E6774682D317D636D702865297B72657475726E20652E63686172436F646541742830292D746869732E5F76616C75652E63686172436F6465417428746869732E5F706F73297D76616C756528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(9628) := '746869732E5F76616C75655B746869732E5F706F735D7D7D636C6173732045787B636F6E7374727563746F7228653D2130297B746869732E5F6361736553656E7369746976653D657D72657365742865297B72657475726E20746869732E5F76616C7565';
wwv_flow_imp.g_varchar2_table(9629) := '3D652C746869732E5F66726F6D3D302C746869732E5F746F3D302C746869732E6E65787428297D6861734E65787428297B72657475726E20746869732E5F746F3C746869732E5F76616C75652E6C656E6774687D6E65787428297B746869732E5F66726F';
wwv_flow_imp.g_varchar2_table(9630) := '6D3D746869732E5F746F3B6C657420653D21303B666F72283B746869732E5F746F3C746869732E5F76616C75652E6C656E6774683B746869732E5F746F2B2B2969662834363D3D3D746869732E5F76616C75652E63686172436F6465417428746869732E';
wwv_flow_imp.g_varchar2_table(9631) := '5F746F29297B696628216529627265616B3B746869732E5F66726F6D2B2B7D656C736520653D21313B72657475726E20746869737D636D702865297B72657475726E20746869732E5F6361736553656E7369746976653F5F6928652C746869732E5F7661';
wwv_flow_imp.g_varchar2_table(9632) := '6C75652C302C652E6C656E6774682C746869732E5F66726F6D2C746869732E5F746F293A776928652C746869732E5F76616C75652C302C652E6C656E6774682C746869732E5F66726F6D2C746869732E5F746F297D76616C756528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(9633) := '746869732E5F76616C75652E737562737472696E6728746869732E5F66726F6D2C746869732E5F746F297D7D636C617373204C787B636F6E7374727563746F7228653D21302C743D2130297B746869732E5F73706C69744F6E4261636B736C6173683D65';
wwv_flow_imp.g_varchar2_table(9634) := '2C746869732E5F6361736553656E7369746976653D747D72657365742865297B746869732E5F66726F6D3D302C746869732E5F746F3D302C746869732E5F76616C75653D652C746869732E5F76616C75654C656E3D652E6C656E6774683B666F72286C65';
wwv_flow_imp.g_varchar2_table(9635) := '7420743D652E6C656E6774682D313B743E3D303B742D2D2C746869732E5F76616C75654C656E2D2D297B636F6E737420653D746869732E5F76616C75652E63686172436F646541742874293B696628212834373D3D3D657C7C746869732E5F73706C6974';
wwv_flow_imp.g_varchar2_table(9636) := '4F6E4261636B736C617368262639323D3D3D652929627265616B7D72657475726E20746869732E6E65787428297D6861734E65787428297B72657475726E20746869732E5F746F3C746869732E5F76616C75654C656E7D6E65787428297B746869732E5F';
wwv_flow_imp.g_varchar2_table(9637) := '66726F6D3D746869732E5F746F3B6C657420653D21303B666F72283B746869732E5F746F3C746869732E5F76616C75654C656E3B746869732E5F746F2B2B297B636F6E737420743D746869732E5F76616C75652E63686172436F6465417428746869732E';
wwv_flow_imp.g_varchar2_table(9638) := '5F746F293B69662834373D3D3D747C7C746869732E5F73706C69744F6E4261636B736C617368262639323D3D3D74297B696628216529627265616B3B746869732E5F66726F6D2B2B7D656C736520653D21317D72657475726E20746869737D636D702865';
wwv_flow_imp.g_varchar2_table(9639) := '297B72657475726E20746869732E5F6361736553656E7369746976653F5F6928652C746869732E5F76616C75652C302C652E6C656E6774682C746869732E5F66726F6D2C746869732E5F746F293A776928652C746869732E5F76616C75652C302C652E6C';
wwv_flow_imp.g_varchar2_table(9640) := '656E6774682C746869732E5F66726F6D2C746869732E5F746F297D76616C756528297B72657475726E20746869732E5F76616C75652E737562737472696E6728746869732E5F66726F6D2C746869732E5F746F297D7D636C6173732044787B636F6E7374';
wwv_flow_imp.g_varchar2_table(9641) := '727563746F7228652C74297B746869732E5F69676E6F726550617468436173696E673D652C746869732E5F69676E6F72655175657279416E64467261676D656E743D742C746869732E5F7374617465733D5B5D2C746869732E5F73746174654964783D30';
wwv_flow_imp.g_varchar2_table(9642) := '7D72657365742865297B72657475726E20746869732E5F76616C75653D652C746869732E5F7374617465733D5B5D2C746869732E5F76616C75652E736368656D652626746869732E5F7374617465732E707573682831292C746869732E5F76616C75652E';
wwv_flow_imp.g_varchar2_table(9643) := '617574686F726974792626746869732E5F7374617465732E707573682832292C746869732E5F76616C75652E70617468262628746869732E5F706174684974657261746F723D6E6577204C782821312C21746869732E5F69676E6F726550617468436173';
wwv_flow_imp.g_varchar2_table(9644) := '696E67286529292C746869732E5F706174684974657261746F722E726573657428652E70617468292C746869732E5F706174684974657261746F722E76616C756528292626746869732E5F7374617465732E70757368283329292C746869732E5F69676E';
wwv_flow_imp.g_varchar2_table(9645) := '6F72655175657279416E64467261676D656E742865297C7C28746869732E5F76616C75652E71756572792626746869732E5F7374617465732E707573682834292C746869732E5F76616C75652E667261676D656E742626746869732E5F7374617465732E';
wwv_flow_imp.g_varchar2_table(9646) := '70757368283529292C746869732E5F73746174654964783D302C746869737D6E65787428297B72657475726E20333D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2626746869732E5F706174684974657261746F722E6861';
wwv_flow_imp.g_varchar2_table(9647) := '734E65787428293F746869732E5F706174684974657261746F722E6E65787428293A746869732E5F73746174654964782B3D312C746869737D6861734E65787428297B72657475726E20333D3D3D746869732E5F7374617465735B746869732E5F737461';
wwv_flow_imp.g_varchar2_table(9648) := '74654964785D2626746869732E5F706174684974657261746F722E6861734E65787428297C7C746869732E5F73746174654964783C746869732E5F7374617465732E6C656E6774682D317D636D702865297B696628313D3D3D746869732E5F7374617465';
wwv_flow_imp.g_varchar2_table(9649) := '735B746869732E5F73746174654964785D2972657475726E20796928652C746869732E5F76616C75652E736368656D65293B696628323D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20796928652C7468';
wwv_flow_imp.g_varchar2_table(9650) := '69732E5F76616C75652E617574686F72697479293B696628333D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20746869732E5F706174684974657261746F722E636D702865293B696628343D3D3D746869';
wwv_flow_imp.g_varchar2_table(9651) := '732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20626928652C746869732E5F76616C75652E7175657279293B696628353D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20';
wwv_flow_imp.g_varchar2_table(9652) := '626928652C746869732E5F76616C75652E667261676D656E74293B7468726F77206E6577204572726F727D76616C756528297B696628313D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(9653) := '76616C75652E736368656D653B696628323D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20746869732E5F76616C75652E617574686F726974793B696628333D3D3D746869732E5F7374617465735B7468';
wwv_flow_imp.g_varchar2_table(9654) := '69732E5F73746174654964785D2972657475726E20746869732E5F706174684974657261746F722E76616C756528293B696628343D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20746869732E5F76616C';
wwv_flow_imp.g_varchar2_table(9655) := '75652E71756572793B696628353D3D3D746869732E5F7374617465735B746869732E5F73746174654964785D2972657475726E20746869732E5F76616C75652E667261676D656E743B7468726F77206E6577204572726F727D7D636C6173732054787B63';
wwv_flow_imp.g_varchar2_table(9656) := '6F6E7374727563746F7228297B746869732E6865696768743D317D726F746174654C65667428297B636F6E737420653D746869732E72696768743B72657475726E20746869732E72696768743D652E6C6566742C652E6C6566743D746869732C74686973';
wwv_flow_imp.g_varchar2_table(9657) := '2E75706461746548656967687428292C652E75706461746548656967687428292C657D726F74617465526967687428297B636F6E737420653D746869732E6C6566743B72657475726E20746869732E6C6566743D652E72696768742C652E72696768743D';
wwv_flow_imp.g_varchar2_table(9658) := '746869732C746869732E75706461746548656967687428292C652E75706461746548656967687428292C657D75706461746548656967687428297B746869732E6865696768743D312B4D6174682E6D617828746869732E6865696768744C6566742C7468';
wwv_flow_imp.g_varchar2_table(9659) := '69732E6865696768745269676874297D62616C616E6365466163746F7228297B72657475726E20746869732E68656967687452696768742D746869732E6865696768744C6566747D676574206865696768744C65667428297B76617220652C743B726574';
wwv_flow_imp.g_varchar2_table(9660) := '75726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E6C656674297C7C766F696420303D3D3D653F766F696420303A652E686569676874292626766F69642030213D3D743F743A307D67657420686569676874526967687428297B7661';
wwv_flow_imp.g_varchar2_table(9661) := '7220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E7269676874297C7C766F696420303D3D3D653F766F696420303A652E686569676874292626766F69642030213D3D743F743A307D7D636C6173732049787B';
wwv_flow_imp.g_varchar2_table(9662) := '73746174696320666F725572697328653D28293D3E21312C743D28293D3E2131297B72657475726E206E6577204978286E657720447828652C7429297D73746174696320666F72537472696E677328297B72657475726E206E6577204978286E6577206B';
wwv_flow_imp.g_varchar2_table(9663) := '78297D73746174696320666F72436F6E6669674B65797328297B72657475726E206E6577204978286E6577204578297D636F6E7374727563746F722865297B746869732E5F697465723D657D636C65617228297B746869732E5F726F6F743D766F696420';
wwv_flow_imp.g_varchar2_table(9664) := '307D73657428652C74297B636F6E7374206E3D746869732E5F697465722E72657365742865293B6C657420693B746869732E5F726F6F747C7C28746869732E5F726F6F743D6E65772054782C746869732E5F726F6F742E7365676D656E743D6E2E76616C';
wwv_flow_imp.g_varchar2_table(9665) := '75652829293B636F6E7374206F3D5B5D3B666F7228693D746869732E5F726F6F743B3B297B636F6E737420653D6E2E636D7028692E7365676D656E74293B696628653E3029692E6C6566747C7C28692E6C6566743D6E65772054782C692E6C6566742E73';
wwv_flow_imp.g_varchar2_table(9666) := '65676D656E743D6E2E76616C75652829292C6F2E70757368285B2D312C695D292C693D692E6C6566743B656C736520696628653C3029692E72696768747C7C28692E72696768743D6E65772054782C692E72696768742E7365676D656E743D6E2E76616C';
wwv_flow_imp.g_varchar2_table(9667) := '75652829292C6F2E70757368285B312C695D292C693D692E72696768743B656C73657B696628216E2E6861734E657874282929627265616B3B6E2E6E65787428292C692E6D69647C7C28692E6D69643D6E65772054782C692E6D69642E7365676D656E74';
wwv_flow_imp.g_varchar2_table(9668) := '3D6E2E76616C75652829292C6F2E70757368285B302C695D292C693D692E6D69647D7D636F6E737420733D692E76616C75653B692E76616C75653D742C692E6B65793D653B666F72286C657420653D6F2E6C656E6774682D313B653E3D303B652D2D297B';
wwv_flow_imp.g_varchar2_table(9669) := '636F6E737420743D6F5B655D5B315D3B742E75706461746548656967687428293B636F6E7374206E3D742E62616C616E6365466163746F7228293B6966286E3C2D317C7C6E3E31297B636F6E7374206E3D6F5B655D5B305D2C693D6F5B652B315D5B305D';
wwv_flow_imp.g_varchar2_table(9670) := '3B696628313D3D3D6E2626313D3D3D69296F5B655D5B315D3D742E726F746174654C65667428293B656C7365206966282D313D3D3D6E26262D313D3D3D69296F5B655D5B315D3D742E726F74617465526967687428293B656C736520696628313D3D3D6E';
wwv_flow_imp.g_varchar2_table(9671) := '26262D313D3D3D6929742E72696768743D6F5B652B315D5B315D3D6F5B652B315D5B315D2E726F74617465526967687428292C6F5B655D5B315D3D742E726F746174654C65667428293B656C73657B6966282D31213D3D6E7C7C31213D3D69297468726F';
wwv_flow_imp.g_varchar2_table(9672) := '77206E6577204572726F723B742E6C6566743D6F5B652B315D5B315D3D6F5B652B315D5B315D2E726F746174654C65667428292C6F5B655D5B315D3D742E726F74617465526967687428297D696628653E3029737769746368286F5B652D315D5B305D29';
wwv_flow_imp.g_varchar2_table(9673) := '7B636173652D313A6F5B652D315D5B315D2E6C6566743D6F5B655D5B315D3B627265616B3B6361736520313A6F5B652D315D5B315D2E72696768743D6F5B655D5B315D3B627265616B3B6361736520303A6F5B652D315D5B315D2E6D69643D6F5B655D5B';
wwv_flow_imp.g_varchar2_table(9674) := '315D7D656C736520746869732E5F726F6F743D6F5B305D5B315D7D7D72657475726E20737D6765742865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E5F6765744E6F6465286529297C7C766F696420303D3D3D743F766F69';
wwv_flow_imp.g_varchar2_table(9675) := '6420303A742E76616C75657D5F6765744E6F64652865297B636F6E737420743D746869732E5F697465722E72657365742865293B6C6574206E3D746869732E5F726F6F743B666F72283B6E3B297B636F6E737420653D742E636D70286E2E7365676D656E';
wwv_flow_imp.g_varchar2_table(9676) := '74293B696628653E30296E3D6E2E6C6566743B656C736520696628653C30296E3D6E2E72696768743B656C73657B69662821742E6861734E657874282929627265616B3B742E6E65787428292C6E3D6E2E6D69647D7D72657475726E206E7D6861732865';
wwv_flow_imp.g_varchar2_table(9677) := '297B636F6E737420743D746869732E5F6765744E6F64652865293B72657475726E2128766F696420303D3D3D286E756C6C3D3D743F766F696420303A742E76616C7565292626766F696420303D3D3D286E756C6C3D3D743F766F696420303A742E6D6964';
wwv_flow_imp.g_varchar2_table(9678) := '29297D64656C6574652865297B72657475726E20746869732E5F64656C65746528652C2131297D64656C65746553757065727374722865297B72657475726E20746869732E5F64656C65746528652C2130297D5F64656C65746528652C74297B76617220';
wwv_flow_imp.g_varchar2_table(9679) := '6E3B636F6E737420693D746869732E5F697465722E72657365742865292C6F3D5B5D3B6C657420733D746869732E5F726F6F743B666F72283B733B297B636F6E737420653D692E636D7028732E7365676D656E74293B696628653E30296F2E7075736828';
wwv_flow_imp.g_varchar2_table(9680) := '5B2D312C735D292C733D732E6C6566743B656C736520696628653C30296F2E70757368285B312C735D292C733D732E72696768743B656C73657B69662821692E6861734E657874282929627265616B3B692E6E65787428292C6F2E70757368285B302C73';
wwv_flow_imp.g_varchar2_table(9681) := '5D292C733D732E6D69647D7D69662873297B696628743F28732E6C6566743D766F696420302C732E6D69643D766F696420302C732E72696768743D766F696420302C732E6865696768743D31293A28732E6B65793D766F696420302C732E76616C75653D';
wwv_flow_imp.g_varchar2_table(9682) := '766F69642030292C21732E6D6964262621732E76616C756529696628732E6C6566742626732E7269676874297B636F6E737420653D746869732E5F6D696E28732E7269676874293B696628652E6B6579297B636F6E73747B6B65793A742C76616C75653A';
wwv_flow_imp.g_varchar2_table(9683) := '6E2C7365676D656E743A697D3D653B746869732E5F64656C65746528652E6B65792C2131292C732E6B65793D742C732E76616C75653D6E2C732E7365676D656E743D697D7D656C73657B636F6E737420653D6E756C6C213D3D286E3D732E6C6566742926';
wwv_flow_imp.g_varchar2_table(9684) := '26766F69642030213D3D6E3F6E3A732E72696768743B6966286F2E6C656E6774683E30297B636F6E73745B742C6E5D3D6F5B6F2E6C656E6774682D315D3B7377697463682874297B636173652D313A6E2E6C6566743D653B627265616B3B636173652030';
wwv_flow_imp.g_varchar2_table(9685) := '3A6E2E6D69643D653B627265616B3B6361736520313A6E2E72696768743D657D7D656C736520746869732E5F726F6F743D657D666F72286C657420653D6F2E6C656E6774682D313B653E3D303B652D2D297B636F6E737420743D6F5B655D5B315D3B742E';
wwv_flow_imp.g_varchar2_table(9686) := '75706461746548656967687428293B636F6E7374206E3D742E62616C616E6365466163746F7228293B6966286E3E313F28742E72696768742E62616C616E6365466163746F7228293E3D307C7C28742E72696768743D742E72696768742E726F74617465';
wwv_flow_imp.g_varchar2_table(9687) := '52696768742829292C6F5B655D5B315D3D742E726F746174654C6566742829293A6E3C2D31262628742E6C6566742E62616C616E6365466163746F7228293C3D307C7C28742E6C6566743D742E6C6566742E726F746174654C6566742829292C6F5B655D';
wwv_flow_imp.g_varchar2_table(9688) := '5B315D3D742E726F7461746552696768742829292C653E3029737769746368286F5B652D315D5B305D297B636173652D313A6F5B652D315D5B315D2E6C6566743D6F5B655D5B315D3B627265616B3B6361736520313A6F5B652D315D5B315D2E72696768';
wwv_flow_imp.g_varchar2_table(9689) := '743D6F5B655D5B315D3B627265616B3B6361736520303A6F5B652D315D5B315D2E6D69643D6F5B655D5B315D7D656C736520746869732E5F726F6F743D6F5B305D5B315D7D7D7D5F6D696E2865297B666F72283B652E6C6566743B29653D652E6C656674';
wwv_flow_imp.g_varchar2_table(9690) := '3B72657475726E20657D66696E645375627374722865297B636F6E737420743D746869732E5F697465722E72657365742865293B6C6574206E2C693D746869732E5F726F6F743B666F72283B693B297B636F6E737420653D742E636D7028692E7365676D';
wwv_flow_imp.g_varchar2_table(9691) := '656E74293B696628653E3029693D692E6C6566743B656C736520696628653C3029693D692E72696768743B656C73657B69662821742E6861734E657874282929627265616B3B742E6E65787428292C6E3D692E76616C75657C7C6E2C693D692E6D69647D';
wwv_flow_imp.g_varchar2_table(9692) := '7D72657475726E20692626692E76616C75657C7C6E7D66696E6453757065727374722865297B72657475726E20746869732E5F66696E6453757065727374724F72456C656D656E7428652C2131297D5F66696E6453757065727374724F72456C656D656E';
wwv_flow_imp.g_varchar2_table(9693) := '7428652C74297B636F6E7374206E3D746869732E5F697465722E72657365742865293B6C657420693D746869732E5F726F6F743B666F72283B693B297B636F6E737420653D6E2E636D7028692E7365676D656E74293B696628653E3029693D692E6C6566';
wwv_flow_imp.g_varchar2_table(9694) := '743B656C736520696628653C3029693D692E72696768743B656C73657B696628216E2E6861734E65787428292972657475726E20692E6D69643F746869732E5F656E747269657328692E6D6964293A743F692E76616C75653A766F696420303B6E2E6E65';
wwv_flow_imp.g_varchar2_table(9695) := '787428292C693D692E6D69647D7D7D666F72456163682865297B666F7228636F6E73745B742C6E5D6F6620746869732965286E2C74297D2A5B53796D626F6C2E6974657261746F725D28297B7969656C642A746869732E5F656E74726965732874686973';
wwv_flow_imp.g_varchar2_table(9696) := '2E5F726F6F74297D5F656E74726965732865297B636F6E737420743D5B5D3B72657475726E20746869732E5F646673456E747269657328652C74292C745B53796D626F6C2E6974657261746F725D28297D5F646673456E747269657328652C74297B6526';
wwv_flow_imp.g_varchar2_table(9697) := '2628652E6C6566742626746869732E5F646673456E747269657328652E6C6566742C74292C652E76616C75652626742E70757368285B652E6B65792C652E76616C75655D292C652E6D69642626746869732E5F646673456E747269657328652E6D69642C';
wwv_flow_imp.g_varchar2_table(9698) := '74292C652E72696768742626746869732E5F646673456E747269657328652E72696768742C7429297D7D636F6E7374204D783D70632822636F6E746578745365727669636522293B66756E6374696F6E2041782865297B636F6E737420743D653B726574';
wwv_flow_imp.g_varchar2_table(9699) := '75726E22737472696E67223D3D747970656F66286E756C6C3D3D743F766F696420303A742E69642926264E6F2E697355726928742E757269297D636F6E7374204E783D7B69643A22656D7074792D77696E646F77227D3B636C6173732050787B636F6E73';
wwv_flow_imp.g_varchar2_table(9700) := '74727563746F7228652C74297B746869732E7261773D742C746869732E7572693D652E7572692C746869732E696E6465783D652E696E6465782C746869732E6E616D653D652E6E616D657D746F4A534F4E28297B72657475726E7B7572693A746869732E';
wwv_flow_imp.g_varchar2_table(9701) := '7572692C6E616D653A746869732E6E616D652C696E6465783A746869732E696E6465787D7D7D636F6E7374204F783D286228302C22436F646520576F726B737061636522292C2234303634663665632D636233382D346164302D616636342D6565363436';
wwv_flow_imp.g_varchar2_table(9702) := '3765363363383222293B7661722052783D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F7065727479';
wwv_flow_imp.g_varchar2_table(9703) := '44657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F726174';
wwv_flow_imp.g_varchar2_table(9704) := '6528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E';
wwv_flow_imp.g_varchar2_table(9705) := '20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C46783D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732042787B61';
wwv_flow_imp.g_varchar2_table(9706) := '73796E632070726F76696465446F63756D656E745061737465456469747328652C742C6E2C692C6F297B636F6E737420733D617761697420746869732E67657445646974286E2C6F293B696628732972657475726E7B646973706F736528297B7D2C6564';
wwv_flow_imp.g_varchar2_table(9707) := '6974733A5B7B696E73657274546578743A732E696E73657274546578742C7469746C653A732E7469746C652C6B696E643A732E6B696E642C68616E646C65644D696D65547970653A732E68616E646C65644D696D65547970652C7969656C64546F3A732E';
wwv_flow_imp.g_varchar2_table(9708) := '7969656C64546F7D5D7D7D6173796E632070726F76696465446F63756D656E7444726F70456469747328652C742C6E2C69297B636F6E7374206F3D617761697420746869732E67657445646974286E2C69293B72657475726E206F3F5B7B696E73657274';
wwv_flow_imp.g_varchar2_table(9709) := '546578743A6F2E696E73657274546578742C7469746C653A6F2E7469746C652C6B696E643A6F2E6B696E642C68616E646C65644D696D65547970653A6F2E68616E646C65644D696D65547970652C7969656C64546F3A6F2E7969656C64546F7D5D3A766F';
wwv_flow_imp.g_varchar2_table(9710) := '696420307D7D636C61737320567820657874656E64732042787B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E6B696E643D56782E6B696E642C746869732E64726F704D696D6554797065733D5B4570';
wwv_flow_imp.g_varchar2_table(9711) := '2E746578745D2C746869732E70617374654D696D6554797065733D5B45702E746578745D7D6173796E63206765744564697428652C74297B636F6E7374206E3D652E6765742845702E74657874293B696628216E2972657475726E3B696628652E686173';
wwv_flow_imp.g_varchar2_table(9712) := '2845702E7572694C697374292972657475726E3B636F6E737420693D6177616974206E2E6173537472696E6728293B72657475726E7B68616E646C65644D696D65547970653A45702E746578742C7469746C653A6228302C22496E7365727420506C6169';
wwv_flow_imp.g_varchar2_table(9713) := '6E205465787422292C696E73657274546578743A692C6B696E643A746869732E6B696E647D7D7D56782E69643D2274657874222C56782E6B696E643D6E65772070782822746578742E706C61696E22293B636C617373207A7820657874656E6473204278';
wwv_flow_imp.g_varchar2_table(9714) := '7B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E6B696E643D6E657720707828227572692E6162736F6C75746522292C746869732E64726F704D696D6554797065733D5B45702E7572694C6973745D2C';
wwv_flow_imp.g_varchar2_table(9715) := '746869732E70617374654D696D6554797065733D5B45702E7572694C6973745D7D6173796E63206765744564697428652C74297B636F6E7374206E3D6177616974206A782865293B696628216E2E6C656E6774687C7C742E697343616E63656C6C617469';
wwv_flow_imp.g_varchar2_table(9716) := '6F6E5265717565737465642972657475726E3B6C657420693D303B636F6E7374206F3D6E2E6D61702828287B7572693A652C6F726967696E616C546578743A747D293D3E652E736368656D653D3D3D716F2E66696C653F652E6673506174683A28692B2B';
wwv_flow_imp.g_varchar2_table(9717) := '2C742929292E6A6F696E28222022293B6C657420733B72657475726E20733D693E303F6E2E6C656E6774683E313F6228302C22496E73657274205572697322293A6228302C22496E736572742055726922293A6E2E6C656E6774683E313F6228302C2249';
wwv_flow_imp.g_varchar2_table(9718) := '6E7365727420506174687322293A6228302C22496E73657274205061746822292C7B68616E646C65644D696D65547970653A45702E7572694C6973742C696E73657274546578743A6F2C7469746C653A732C6B696E643A746869732E6B696E647D7D7D6C';
wwv_flow_imp.g_varchar2_table(9719) := '65742048783D636C61737320657874656E64732042787B636F6E7374727563746F722865297B737570657228292C746869732E5F776F726B7370616365436F6E74657874536572766963653D652C746869732E6B696E643D6E657720707828227572692E';
wwv_flow_imp.g_varchar2_table(9720) := '72656C617469766522292C746869732E64726F704D696D6554797065733D5B45702E7572694C6973745D2C746869732E70617374654D696D6554797065733D5B45702E7572694C6973745D7D6173796E63206765744564697428652C74297B636F6E7374';
wwv_flow_imp.g_varchar2_table(9721) := '206E3D6177616974206A782865293B696628216E2E6C656E6774687C7C742E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B636F6E737420693D7A68286E2E6D61702828287B7572693A657D293D3E7B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(9722) := '746869732E5F776F726B7370616365436F6E74657874536572766963652E676574576F726B7370616365466F6C6465722865293B72657475726E20743F4A6C28742E7572692C65293A766F696420307D2929293B72657475726E20692E6C656E6774683F';
wwv_flow_imp.g_varchar2_table(9723) := '7B68616E646C65644D696D65547970653A45702E7572694C6973742C696E73657274546578743A692E6A6F696E28222022292C7469746C653A6E2E6C656E6774683E313F6228302C22496E736572742052656C617469766520506174687322293A622830';
wwv_flow_imp.g_varchar2_table(9724) := '2C22496E736572742052656C6174697665205061746822292C6B696E643A746869732E6B696E647D3A766F696420307D7D3B48783D5278285B467828302C4D78295D2C4878293B636C6173732057787B636F6E7374727563746F7228297B746869732E6B';
wwv_flow_imp.g_varchar2_table(9725) := '696E643D6E6577207078282268746D6C22292C746869732E70617374654D696D6554797065733D5B22746578742F68746D6C225D2C746869732E5F7969656C64546F3D5B7B6D696D65547970653A45702E746578747D5D7D6173796E632070726F766964';
wwv_flow_imp.g_varchar2_table(9726) := '65446F63756D656E745061737465456469747328652C742C6E2C692C6F297B76617220733B696628692E747269676765724B696E64213D3D43772E50617374654173262621286E756C6C3D3D3D28733D692E6F6E6C79297C7C766F696420303D3D3D733F';
wwv_flow_imp.g_varchar2_table(9727) := '766F696420303A732E636F6E7461696E7328746869732E6B696E6429292972657475726E3B636F6E737420723D6E2E6765742822746578742F68746D6C22292C613D6177616974286E756C6C3D3D723F766F696420303A722E6173537472696E67282929';
wwv_flow_imp.g_varchar2_table(9728) := '3B72657475726E20612626216F2E697343616E63656C6C6174696F6E5265717565737465643F7B646973706F736528297B7D2C65646974733A5B7B696E73657274546578743A612C7969656C64546F3A746869732E5F7969656C64546F2C7469746C653A';
wwv_flow_imp.g_varchar2_table(9729) := '6228302C22496E736572742048544D4C22292C6B696E643A746869732E6B696E647D5D7D3A766F696420307D7D6173796E632066756E6374696F6E206A782865297B636F6E737420743D652E6765742845702E7572694C697374293B6966282174297265';
wwv_flow_imp.g_varchar2_table(9730) := '7475726E5B5D3B636F6E7374206E3D617761697420742E6173537472696E6728292C693D5B5D3B666F7228636F6E73742065206F662075782E7061727365286E29297472797B692E70757368287B7572693A4E6F2E70617273652865292C6F726967696E';
wwv_flow_imp.g_varchar2_table(9731) := '616C546578743A657D297D63617463682865297B7D72657475726E20697D6C65742071783D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F726567697374657228652E646F6375';
wwv_flow_imp.g_varchar2_table(9732) := '6D656E7444726F704564697450726F76696465722E726567697374657228222A222C6E657720567829292C746869732E5F726567697374657228652E646F63756D656E7444726F704564697450726F76696465722E726567697374657228222A222C6E65';
wwv_flow_imp.g_varchar2_table(9733) := '77207A7829292C746869732E5F726567697374657228652E646F63756D656E7444726F704564697450726F76696465722E726567697374657228222A222C6E657720487828742929297D7D3B71783D5278285B467828302C7878292C467828312C4D7829';
wwv_flow_imp.g_varchar2_table(9734) := '5D2C7178293B6C65742024783D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F726567697374657228652E646F63756D656E7450617374654564697450726F76696465722E7265';
wwv_flow_imp.g_varchar2_table(9735) := '67697374657228222A222C6E657720567829292C746869732E5F726567697374657228652E646F63756D656E7450617374654564697450726F76696465722E726567697374657228222A222C6E6577207A7829292C746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(9736) := '652E646F63756D656E7450617374654564697450726F76696465722E726567697374657228222A222C6E657720487828742929292C746869732E5F726567697374657228652E646F63756D656E7450617374654564697450726F76696465722E72656769';
wwv_flow_imp.g_varchar2_table(9737) := '7374657228222A222C6E657720577829297D7D3B24783D5278285B467828302C7878292C467828312C4D78295D2C2478293B636C6173732055787B636F6E7374727563746F7228297B746869732E76616C75653D22222C746869732E706F733D307D7374';
wwv_flow_imp.g_varchar2_table(9738) := '6174696320697344696769744368617261637465722865297B72657475726E20653E3D34382626653C3D35377D7374617469632069735661726961626C654368617261637465722865297B72657475726E2039353D3D3D657C7C653E3D39372626653C3D';
wwv_flow_imp.g_varchar2_table(9739) := '3132327C7C653E3D36352626653C3D39307D746578742865297B746869732E76616C75653D652C746869732E706F733D307D746F6B656E546578742865297B72657475726E20746869732E76616C75652E73756273747228652E706F732C652E6C656E29';
wwv_flow_imp.g_varchar2_table(9740) := '7D6E65787428297B696628746869732E706F733E3D746869732E76616C75652E6C656E6774682972657475726E7B747970653A31342C706F733A746869732E706F732C6C656E3A307D3B636F6E737420653D746869732E706F733B6C657420742C6E3D30';
wwv_flow_imp.g_varchar2_table(9741) := '2C693D746869732E76616C75652E63686172436F646541742865293B696628743D55782E5F7461626C655B695D2C226E756D626572223D3D747970656F6620742972657475726E20746869732E706F732B3D312C7B747970653A742C706F733A652C6C65';
wwv_flow_imp.g_varchar2_table(9742) := '6E3A317D3B69662855782E69734469676974436861726163746572286929297B743D383B646F7B6E2B3D312C693D746869732E76616C75652E63686172436F6465417428652B6E297D7768696C652855782E697344696769744368617261637465722869';
wwv_flow_imp.g_varchar2_table(9743) := '29293B72657475726E20746869732E706F732B3D6E2C7B747970653A742C706F733A652C6C656E3A6E7D7D69662855782E69735661726961626C65436861726163746572286929297B743D393B646F7B693D746869732E76616C75652E63686172436F64';
wwv_flow_imp.g_varchar2_table(9744) := '65417428652B202B2B6E297D7768696C652855782E69735661726961626C654368617261637465722869297C7C55782E69734469676974436861726163746572286929293B72657475726E20746869732E706F732B3D6E2C7B747970653A742C706F733A';
wwv_flow_imp.g_varchar2_table(9745) := '652C6C656E3A6E7D7D743D31303B646F7B6E2B3D312C693D746869732E76616C75652E63686172436F6465417428652B6E297D7768696C65282169734E614E2869292626766F696420303D3D3D55782E5F7461626C655B695D26262155782E6973446967';
wwv_flow_imp.g_varchar2_table(9746) := '697443686172616374657228692926262155782E69735661726961626C65436861726163746572286929293B72657475726E20746869732E706F732B3D6E2C7B747970653A742C706F733A652C6C656E3A6E7D7D7D55782E5F7461626C653D7B33363A30';
wwv_flow_imp.g_varchar2_table(9747) := '2C35383A312C34343A322C3132333A332C3132353A342C39323A352C34373A362C3132343A372C34333A31312C34353A31322C36333A31337D3B636C617373204B787B636F6E7374727563746F7228297B746869732E5F6368696C6472656E3D5B5D7D61';
wwv_flow_imp.g_varchar2_table(9748) := '7070656E644368696C642865297B72657475726E206520696E7374616E63656F662047782626746869732E5F6368696C6472656E5B746869732E5F6368696C6472656E2E6C656E6774682D315D696E7374616E63656F662047783F746869732E5F636869';
wwv_flow_imp.g_varchar2_table(9749) := '6C6472656E5B746869732E5F6368696C6472656E2E6C656E6774682D315D2E76616C75652B3D652E76616C75653A28652E706172656E743D746869732C746869732E5F6368696C6472656E2E70757368286529292C746869737D7265706C61636528652C';
wwv_flow_imp.g_varchar2_table(9750) := '74297B636F6E73747B706172656E743A6E7D3D652C693D6E2E6368696C6472656E2E696E6465784F662865292C6F3D6E2E6368696C6472656E2E736C6963652830293B6F2E73706C69636528692C312C2E2E2E74292C6E2E5F6368696C6472656E3D6F2C';
wwv_flow_imp.g_varchar2_table(9751) := '66756E6374696F6E206528742C6E297B666F7228636F6E73742069206F66207429692E706172656E743D6E2C6528692E6368696C6472656E2C69297D28742C6E297D676574206368696C6472656E28297B72657475726E20746869732E5F6368696C6472';
wwv_flow_imp.g_varchar2_table(9752) := '656E7D6765742072696768744D6F737444657363656E64616E7428297B72657475726E20746869732E5F6368696C6472656E2E6C656E6774683E303F746869732E5F6368696C6472656E5B746869732E5F6368696C6472656E2E6C656E6774682D315D2E';
wwv_flow_imp.g_varchar2_table(9753) := '72696768744D6F737444657363656E64616E743A746869737D67657420736E697070657428297B6C657420653D746869733B666F72283B3B297B69662821652972657475726E3B6966286520696E7374616E63656F66206E6B2972657475726E20653B65';
wwv_flow_imp.g_varchar2_table(9754) := '3D652E706172656E747D7D746F537472696E6728297B72657475726E20746869732E6368696C6472656E2E726564756365282828652C74293D3E652B742E746F537472696E672829292C2222297D6C656E28297B72657475726E20307D7D636C61737320';
wwv_flow_imp.g_varchar2_table(9755) := '477820657874656E6473204B787B636F6E7374727563746F722865297B737570657228292C746869732E76616C75653D657D746F537472696E6728297B72657475726E20746869732E76616C75657D6C656E28297B72657475726E20746869732E76616C';
wwv_flow_imp.g_varchar2_table(9756) := '75652E6C656E6774687D636C6F6E6528297B72657475726E206E657720477828746869732E76616C7565297D7D636C61737320517820657874656E6473204B787B7D636C61737320597820657874656E64732051787B73746174696320636F6D70617265';
wwv_flow_imp.g_varchar2_table(9757) := '4279496E64657828652C74297B72657475726E20652E696E6465783D3D3D742E696E6465783F303A652E697346696E616C54616273746F703F313A742E697346696E616C54616273746F707C7C652E696E6465783C742E696E6465783F2D313A652E696E';
wwv_flow_imp.g_varchar2_table(9758) := '6465783E742E696E6465783F313A307D636F6E7374727563746F722865297B737570657228292C746869732E696E6465783D657D67657420697346696E616C54616273746F7028297B72657475726E20303D3D3D746869732E696E6465787D6765742063';
wwv_flow_imp.g_varchar2_table(9759) := '686F69636528297B72657475726E20313D3D3D746869732E5F6368696C6472656E2E6C656E6774682626746869732E5F6368696C6472656E5B305D696E7374616E63656F66205A783F746869732E5F6368696C6472656E5B305D3A766F696420307D636C';
wwv_flow_imp.g_varchar2_table(9760) := '6F6E6528297B636F6E737420653D6E657720597828746869732E696E646578293B72657475726E20746869732E7472616E73666F726D262628652E7472616E73666F726D3D746869732E7472616E73666F726D2E636C6F6E652829292C652E5F6368696C';
wwv_flow_imp.g_varchar2_table(9761) := '6472656E3D746869732E6368696C6472656E2E6D61702828653D3E652E636C6F6E65282929292C657D7D636C617373205A7820657874656E6473204B787B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C74686973';
wwv_flow_imp.g_varchar2_table(9762) := '2E6F7074696F6E733D5B5D7D617070656E644368696C642865297B72657475726E206520696E7374616E63656F66204778262628652E706172656E743D746869732C746869732E6F7074696F6E732E70757368286529292C746869737D746F537472696E';
wwv_flow_imp.g_varchar2_table(9763) := '6728297B72657475726E20746869732E6F7074696F6E735B305D2E76616C75657D6C656E28297B72657475726E20746869732E6F7074696F6E735B305D2E6C656E28297D636C6F6E6528297B636F6E737420653D6E6577205A783B72657475726E207468';
wwv_flow_imp.g_varchar2_table(9764) := '69732E6F7074696F6E732E666F724561636828652E617070656E644368696C642C65292C657D7D636C61737320587820657874656E6473204B787B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E7265';
wwv_flow_imp.g_varchar2_table(9765) := '676578703D6E657720526567457870282222297D7265736F6C76652865297B636F6E737420743D746869733B6C6574206E3D21312C693D652E7265706C61636528746869732E7265676578702C2866756E6374696F6E28297B72657475726E206E3D2130';
wwv_flow_imp.g_varchar2_table(9766) := '2C742E5F7265706C6163652841727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C302C2D3229297D29293B72657475726E216E2626746869732E5F6368696C6472656E2E736F6D652828653D3E6520696E737461';
wwv_flow_imp.g_varchar2_table(9767) := '6E63656F66204A782626426F6F6C65616E28652E656C736556616C7565292929262628693D746869732E5F7265706C616365285B5D29292C697D5F7265706C6163652865297B6C657420743D22223B666F7228636F6E7374206E206F6620746869732E5F';
wwv_flow_imp.g_varchar2_table(9768) := '6368696C6472656E296966286E20696E7374616E63656F66204A78297B6C657420693D655B6E2E696E6465785D7C7C22223B693D6E2E7265736F6C76652869292C742B3D697D656C736520742B3D6E2E746F537472696E6728293B72657475726E20747D';
wwv_flow_imp.g_varchar2_table(9769) := '746F537472696E6728297B72657475726E22227D636C6F6E6528297B636F6E737420653D6E65772058783B72657475726E20652E7265676578703D6E65772052656745787028746869732E7265676578702E736F757263652C28746869732E7265676578';
wwv_flow_imp.g_varchar2_table(9770) := '702E69676E6F7265436173653F2269223A2222292B28746869732E7265676578702E676C6F62616C3F2267223A222229292C652E5F6368696C6472656E3D746869732E6368696C6472656E2E6D61702828653D3E652E636C6F6E65282929292C657D7D63';
wwv_flow_imp.g_varchar2_table(9771) := '6C617373204A7820657874656E6473204B787B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E696E6465783D652C746869732E73686F727468616E644E616D653D742C746869732E696656616C75653D6E2C746869';
wwv_flow_imp.g_varchar2_table(9772) := '732E656C736556616C75653D697D7265736F6C76652865297B72657475726E22757063617365223D3D3D746869732E73686F727468616E644E616D653F653F652E746F4C6F63616C6555707065724361736528293A22223A22646F776E63617365223D3D';
wwv_flow_imp.g_varchar2_table(9773) := '3D746869732E73686F727468616E644E616D653F653F652E746F4C6F63616C654C6F7765724361736528293A22223A226361706974616C697A65223D3D3D746869732E73686F727468616E644E616D653F653F655B305D2E746F4C6F63616C6555707065';
wwv_flow_imp.g_varchar2_table(9774) := '724361736528292B652E7375627374722831293A22223A2270617363616C63617365223D3D3D746869732E73686F727468616E644E616D653F653F746869732E5F746F50617363616C436173652865293A22223A2263616D656C63617365223D3D3D7468';
wwv_flow_imp.g_varchar2_table(9775) := '69732E73686F727468616E644E616D653F653F746869732E5F746F43616D656C436173652865293A22223A426F6F6C65616E286529262622737472696E67223D3D747970656F6620746869732E696656616C75653F746869732E696656616C75653A426F';
wwv_flow_imp.g_varchar2_table(9776) := '6F6C65616E2865297C7C22737472696E6722213D747970656F6620746869732E656C736556616C75653F657C7C22223A746869732E656C736556616C75657D5F746F50617363616C436173652865297B636F6E737420743D652E6D61746368282F5B612D';
wwv_flow_imp.g_varchar2_table(9777) := '7A302D395D2B2F6769293B72657475726E20743F742E6D61702828653D3E652E6368617241742830292E746F55707065724361736528292B652E73756273747228312929292E6A6F696E282222293A657D5F746F43616D656C436173652865297B636F6E';
wwv_flow_imp.g_varchar2_table(9778) := '737420743D652E6D61746368282F5B612D7A302D395D2B2F6769293B72657475726E20743F742E6D6170282828652C74293D3E303D3D3D743F652E6368617241742830292E746F4C6F7765724361736528292B652E7375627374722831293A652E636861';
wwv_flow_imp.g_varchar2_table(9779) := '7241742830292E746F55707065724361736528292B652E73756273747228312929292E6A6F696E282222293A657D636C6F6E6528297B72657475726E206E6577204A7828746869732E696E6465782C746869732E73686F727468616E644E616D652C7468';
wwv_flow_imp.g_varchar2_table(9780) := '69732E696656616C75652C746869732E656C736556616C7565297D7D636C61737320656B20657874656E64732051787B636F6E7374727563746F722865297B737570657228292C746869732E6E616D653D657D7265736F6C76652865297B6C657420743D';
wwv_flow_imp.g_varchar2_table(9781) := '652E7265736F6C76652874686973293B72657475726E20746869732E7472616E73666F726D262628743D746869732E7472616E73666F726D2E7265736F6C766528747C7C222229292C766F69642030213D3D74262628746869732E5F6368696C6472656E';
wwv_flow_imp.g_varchar2_table(9782) := '3D5B6E65772047782874295D2C2130297D636C6F6E6528297B636F6E737420653D6E657720656B28746869732E6E616D65293B72657475726E20746869732E7472616E73666F726D262628652E7472616E73666F726D3D746869732E7472616E73666F72';
wwv_flow_imp.g_varchar2_table(9783) := '6D2E636C6F6E652829292C652E5F6368696C6472656E3D746869732E6368696C6472656E2E6D61702828653D3E652E636C6F6E65282929292C657D7D66756E6374696F6E20746B28652C74297B636F6E7374206E3D5B2E2E2E655D3B666F72283B6E2E6C';
wwv_flow_imp.g_varchar2_table(9784) := '656E6774683E303B297B636F6E737420653D6E2E736869667428293B696628217428652929627265616B3B6E2E756E7368696674282E2E2E652E6368696C6472656E297D7D636C617373206E6B20657874656E6473204B787B67657420706C616365686F';
wwv_flow_imp.g_varchar2_table(9785) := '6C646572496E666F28297B69662821746869732E5F706C616365686F6C64657273297B636F6E737420653D5B5D3B6C657420743B746869732E77616C6B282866756E6374696F6E286E297B72657475726E206E20696E7374616E63656F66205978262628';
wwv_flow_imp.g_varchar2_table(9786) := '652E70757368286E292C743D21747C7C742E696E6465783C6E2E696E6465783F6E3A74292C21307D29292C746869732E5F706C616365686F6C646572733D7B616C6C3A652C6C6173743A747D7D72657475726E20746869732E5F706C616365686F6C6465';
wwv_flow_imp.g_varchar2_table(9787) := '72737D67657420706C616365686F6C6465727328297B636F6E73747B616C6C3A657D3D746869732E706C616365686F6C646572496E666F3B72657475726E20657D6F66667365742865297B6C657420743D302C6E3D21313B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(9788) := '77616C6B2828693D3E693D3D3D653F286E3D21302C2131293A28742B3D692E6C656E28292C21302929292C6E3F743A2D317D66756C6C4C656E2865297B6C657420743D303B72657475726E20746B285B655D2C28653D3E28742B3D652E6C656E28292C21';
wwv_flow_imp.g_varchar2_table(9789) := '302929292C747D656E636C6F73696E67506C616365686F6C646572732865297B636F6E737420743D5B5D3B6C65747B706172656E743A6E7D3D653B666F72283B6E3B296E20696E7374616E63656F662059782626742E70757368286E292C6E3D6E2E7061';
wwv_flow_imp.g_varchar2_table(9790) := '72656E743B72657475726E20747D7265736F6C76655661726961626C65732865297B72657475726E20746869732E77616C6B2828743D3E287420696E7374616E63656F6620656B2626742E7265736F6C7665286529262628746869732E5F706C61636568';
wwv_flow_imp.g_varchar2_table(9791) := '6F6C646572733D766F69642030292C21302929292C746869737D617070656E644368696C642865297B72657475726E20746869732E5F706C616365686F6C646572733D766F696420302C73757065722E617070656E644368696C642865297D7265706C61';
wwv_flow_imp.g_varchar2_table(9792) := '636528652C74297B72657475726E20746869732E5F706C616365686F6C646572733D766F696420302C73757065722E7265706C61636528652C74297D636C6F6E6528297B636F6E737420653D6E6577206E6B3B72657475726E20746869732E5F6368696C';
wwv_flow_imp.g_varchar2_table(9793) := '6472656E3D746869732E6368696C6472656E2E6D61702828653D3E652E636C6F6E65282929292C657D77616C6B2865297B746B28746869732E6368696C6472656E2C65297D7D636C61737320696B7B636F6E7374727563746F7228297B746869732E5F73';
wwv_flow_imp.g_varchar2_table(9794) := '63616E6E65723D6E65772055782C746869732E5F746F6B656E3D7B747970653A31342C706F733A302C6C656E3A307D7D737461746963206573636170652865297B72657475726E20652E7265706C616365282F5C247C7D7C5C5C2F672C225C5C24262229';
wwv_flow_imp.g_varchar2_table(9795) := '7D7374617469632067756573734E65656473436C6970626F6172642865297B72657475726E2F5C247B3F434C4950424F4152442F2E746573742865297D706172736528652C742C6E297B636F6E737420693D6E6577206E6B3B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(9796) := '2E7061727365467261676D656E7428652C69292C746869732E656E7375726546696E616C54616273746F7028692C6E756C6C213D6E26266E2C6E756C6C213D74262674292C697D7061727365467261676D656E7428652C74297B636F6E7374206E3D742E';
wwv_flow_imp.g_varchar2_table(9797) := '6368696C6472656E2E6C656E6774683B666F7228746869732E5F7363616E6E65722E746578742865292C746869732E5F746F6B656E3D746869732E5F7363616E6E65722E6E65787428293B746869732E5F70617273652874293B293B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(9798) := '6E6577204D61702C6F3D5B5D3B742E77616C6B2828653D3E286520696E7374616E63656F66205978262628652E697346696E616C54616273746F703F692E73657428302C766F69642030293A21692E68617328652E696E646578292626652E6368696C64';
wwv_flow_imp.g_varchar2_table(9799) := '72656E2E6C656E6774683E303F692E73657428652E696E6465782C652E6368696C6472656E293A6F2E70757368286529292C21302929293B636F6E737420733D28652C6E293D3E7B636F6E7374206F3D692E67657428652E696E646578293B696628216F';
wwv_flow_imp.g_varchar2_table(9800) := '2972657475726E3B636F6E737420723D6E657720597828652E696E646578293B722E7472616E73666F726D3D652E7472616E73666F726D3B666F7228636F6E73742065206F66206F297B636F6E737420743D652E636C6F6E6528293B722E617070656E64';
wwv_flow_imp.g_varchar2_table(9801) := '4368696C642874292C7420696E7374616E63656F662059782626692E68617328742E696E646578292626216E2E68617328742E696E646578292626286E2E61646428742E696E646578292C7328742C6E292C6E2E64656C65746528742E696E6465782929';
wwv_flow_imp.g_varchar2_table(9802) := '7D742E7265706C61636528652C5B725D297D2C723D6E6577205365743B666F7228636F6E73742065206F66206F297328652C72293B72657475726E20742E6368696C6472656E2E736C696365286E297D656E7375726546696E616C54616273746F702865';
wwv_flow_imp.g_varchar2_table(9803) := '2C742C6E297B28747C7C6E2626652E706C616365686F6C646572732E6C656E6774683E3029262628652E706C616365686F6C646572732E66696E642828653D3E303D3D3D652E696E64657829297C7C652E617070656E644368696C64286E657720597828';
wwv_flow_imp.g_varchar2_table(9804) := '302929297D5F61636365707428652C74297B696628766F696420303D3D3D657C7C746869732E5F746F6B656E2E747970653D3D3D65297B636F6E737420653D21747C7C746869732E5F7363616E6E65722E746F6B656E5465787428746869732E5F746F6B';
wwv_flow_imp.g_varchar2_table(9805) := '656E293B72657475726E20746869732E5F746F6B656E3D746869732E5F7363616E6E65722E6E65787428292C657D72657475726E21317D5F6261636B546F2865297B72657475726E20746869732E5F7363616E6E65722E706F733D652E706F732B652E6C';
wwv_flow_imp.g_varchar2_table(9806) := '656E2C746869732E5F746F6B656E3D652C21317D5F756E74696C2865297B636F6E737420743D746869732E5F746F6B656E3B666F72283B746869732E5F746F6B656E2E74797065213D3D653B297B69662831343D3D3D746869732E5F746F6B656E2E7479';
wwv_flow_imp.g_varchar2_table(9807) := '70652972657475726E21313B696628353D3D3D746869732E5F746F6B656E2E74797065297B636F6E737420653D746869732E5F7363616E6E65722E6E65787428293B69662830213D3D652E74797065262634213D3D652E74797065262635213D3D652E74';
wwv_flow_imp.g_varchar2_table(9808) := '7970652972657475726E21317D746869732E5F746F6B656E3D746869732E5F7363616E6E65722E6E65787428297D636F6E7374206E3D746869732E5F7363616E6E65722E76616C75652E737562737472696E6728742E706F732C746869732E5F746F6B65';
wwv_flow_imp.g_varchar2_table(9809) := '6E2E706F73292E7265706C616365282F5C5C285C247C7D7C5C5C292F672C22243122293B72657475726E20746869732E5F746F6B656E3D746869732E5F7363616E6E65722E6E65787428292C6E7D5F70617273652865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(9810) := '5F7061727365457363617065642865297C7C746869732E5F706172736554616273746F704F725661726961626C654E616D652865297C7C746869732E5F7061727365436F6D706C6578506C616365686F6C6465722865297C7C746869732E5F7061727365';
wwv_flow_imp.g_varchar2_table(9811) := '436F6D706C65785661726961626C652865297C7C746869732E5F7061727365416E797468696E672865297D5F7061727365457363617065642865297B6C657420743B72657475726E212128743D746869732E5F61636365707428352C2130292926262874';
wwv_flow_imp.g_varchar2_table(9812) := '3D746869732E5F61636365707428302C2130297C7C746869732E5F61636365707428342C2130297C7C746869732E5F61636365707428352C2130297C7C742C652E617070656E644368696C64286E6577204778287429292C2130297D5F70617273655461';
wwv_flow_imp.g_varchar2_table(9813) := '6273746F704F725661726961626C654E616D652865297B6C657420743B636F6E7374206E3D746869732E5F746F6B656E3B72657475726E20746869732E5F616363657074283029262628743D746869732E5F61636365707428392C2130297C7C74686973';
wwv_flow_imp.g_varchar2_table(9814) := '2E5F61636365707428382C213029293F28652E617070656E644368696C64282F5E5C642B242F2E746573742874293F6E6577205978284E756D626572287429293A6E657720656B287429292C2130293A746869732E5F6261636B546F286E297D5F706172';
wwv_flow_imp.g_varchar2_table(9815) := '7365436F6D706C6578506C616365686F6C6465722865297B6C657420743B636F6E7374206E3D746869732E5F746F6B656E3B6966282128746869732E5F6163636570742830292626746869732E5F616363657074283329262628743D746869732E5F6163';
wwv_flow_imp.g_varchar2_table(9816) := '6365707428382C21302929292972657475726E20746869732E5F6261636B546F286E293B636F6E737420693D6E6577205978284E756D626572287429293B696628746869732E5F61636365707428312929666F72283B3B297B696628746869732E5F6163';
wwv_flow_imp.g_varchar2_table(9817) := '636570742834292972657475726E20652E617070656E644368696C642869292C21303B69662821746869732E5F70617273652869292972657475726E20652E617070656E644368696C64286E65772047782822247B222B742B223A2229292C692E636869';
wwv_flow_imp.g_varchar2_table(9818) := '6C6472656E2E666F724561636828652E617070656E644368696C642C65292C21307D656C73657B6966282128692E696E6465783E302626746869732E5F616363657074283729292972657475726E20746869732E5F6163636570742836293F746869732E';
wwv_flow_imp.g_varchar2_table(9819) := '5F70617273655472616E73666F726D2869293F28652E617070656E644368696C642869292C2130293A28746869732E5F6261636B546F286E292C2131293A746869732E5F6163636570742834293F28652E617070656E644368696C642869292C2130293A';
wwv_flow_imp.g_varchar2_table(9820) := '746869732E5F6261636B546F286E293B7B636F6E737420743D6E6577205A783B666F72283B3B297B696628746869732E5F706172736543686F696365456C656D656E74287429297B696628746869732E5F61636365707428322929636F6E74696E75653B';
wwv_flow_imp.g_varchar2_table(9821) := '696628746869732E5F616363657074283729262628692E617070656E644368696C642874292C746869732E5F616363657074283429292972657475726E20652E617070656E644368696C642869292C21307D72657475726E20746869732E5F6261636B54';
wwv_flow_imp.g_varchar2_table(9822) := '6F286E292C21317D7D7D7D5F706172736543686F696365456C656D656E742865297B636F6E737420743D746869732E5F746F6B656E2C6E3D5B5D3B666F72283B32213D3D746869732E5F746F6B656E2E74797065262637213D3D746869732E5F746F6B65';
wwv_flow_imp.g_varchar2_table(9823) := '6E2E747970653B297B6C657420653B696628653D28653D746869732E5F61636365707428352C213029293F746869732E5F61636365707428322C2130297C7C746869732E5F61636365707428372C2130297C7C746869732E5F61636365707428352C2130';
wwv_flow_imp.g_varchar2_table(9824) := '297C7C653A746869732E5F61636365707428766F696420302C2130292C21652972657475726E20746869732E5F6261636B546F2874292C21313B6E2E707573682865297D72657475726E20303D3D3D6E2E6C656E6774683F28746869732E5F6261636B54';
wwv_flow_imp.g_varchar2_table(9825) := '6F2874292C2131293A28652E617070656E644368696C64286E6577204778286E2E6A6F696E2822222929292C2130297D5F7061727365436F6D706C65785661726961626C652865297B6C657420743B636F6E7374206E3D746869732E5F746F6B656E3B69';
wwv_flow_imp.g_varchar2_table(9826) := '66282128746869732E5F6163636570742830292626746869732E5F616363657074283329262628743D746869732E5F61636365707428392C21302929292972657475726E20746869732E5F6261636B546F286E293B636F6E737420693D6E657720656B28';
wwv_flow_imp.g_varchar2_table(9827) := '74293B69662821746869732E5F6163636570742831292972657475726E20746869732E5F6163636570742836293F746869732E5F70617273655472616E73666F726D2869293F28652E617070656E644368696C642869292C2130293A28746869732E5F62';
wwv_flow_imp.g_varchar2_table(9828) := '61636B546F286E292C2131293A746869732E5F6163636570742834293F28652E617070656E644368696C642869292C2130293A746869732E5F6261636B546F286E293B666F72283B3B297B696628746869732E5F6163636570742834292972657475726E';
wwv_flow_imp.g_varchar2_table(9829) := '20652E617070656E644368696C642869292C21303B69662821746869732E5F70617273652869292972657475726E20652E617070656E644368696C64286E65772047782822247B222B742B223A2229292C692E6368696C6472656E2E666F724561636828';
wwv_flow_imp.g_varchar2_table(9830) := '652E617070656E644368696C642C65292C21307D7D5F70617273655472616E73666F726D2865297B636F6E737420743D6E65772058783B6C6574206E3D22222C693D22223B666F72283B21746869732E5F6163636570742836293B297B6C657420653B69';
wwv_flow_imp.g_varchar2_table(9831) := '6628653D746869732E5F61636365707428352C21302929653D746869732E5F61636365707428362C2130297C7C652C6E2B3D653B656C73657B69662831343D3D3D746869732E5F746F6B656E2E747970652972657475726E21313B6E2B3D746869732E5F';
wwv_flow_imp.g_varchar2_table(9832) := '61636365707428766F696420302C2130297D7D666F72283B21746869732E5F6163636570742836293B297B6C657420653B696628653D746869732E5F61636365707428352C21302929653D746869732E5F61636365707428352C2130297C7C746869732E';
wwv_flow_imp.g_varchar2_table(9833) := '5F61636365707428362C2130297C7C652C742E617070656E644368696C64286E6577204778286529293B656C73652069662821746869732E5F7061727365466F726D6174537472696E67287429262621746869732E5F7061727365416E797468696E6728';
wwv_flow_imp.g_varchar2_table(9834) := '74292972657475726E21317D666F72283B21746869732E5F6163636570742834293B297B69662831343D3D3D746869732E5F746F6B656E2E747970652972657475726E21313B692B3D746869732E5F61636365707428766F696420302C2130297D747279';
wwv_flow_imp.g_varchar2_table(9835) := '7B742E7265676578703D6E657720526567457870286E2C69297D63617463682865297B72657475726E21317D72657475726E20652E7472616E73666F726D3D742C21307D5F7061727365466F726D6174537472696E672865297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(9836) := '69732E5F746F6B656E3B69662821746869732E5F6163636570742830292972657475726E21313B6C6574206E3D21313B746869732E5F6163636570742833292626286E3D2130293B636F6E737420693D746869732E5F61636365707428382C2130293B69';
wwv_flow_imp.g_varchar2_table(9837) := '662821692972657475726E20746869732E5F6261636B546F2874292C21313B696628216E2972657475726E20652E617070656E644368696C64286E6577204A78284E756D62657228692929292C21303B696628746869732E5F6163636570742834292972';
wwv_flow_imp.g_varchar2_table(9838) := '657475726E20652E617070656E644368696C64286E6577204A78284E756D62657228692929292C21303B69662821746869732E5F6163636570742831292972657475726E20746869732E5F6261636B546F2874292C21313B696628746869732E5F616363';
wwv_flow_imp.g_varchar2_table(9839) := '657074283629297B636F6E7374206E3D746869732E5F61636365707428392C2130293B72657475726E206E2626746869732E5F6163636570742834293F28652E617070656E644368696C64286E6577204A78284E756D6265722869292C6E29292C213029';
wwv_flow_imp.g_varchar2_table(9840) := '3A28746869732E5F6261636B546F2874292C2131297D696628746869732E5F61636365707428313129297B636F6E737420743D746869732E5F756E74696C2834293B696628742972657475726E20652E617070656E644368696C64286E6577204A78284E';
wwv_flow_imp.g_varchar2_table(9841) := '756D6265722869292C766F696420302C742C766F6964203029292C21307D656C736520696628746869732E5F61636365707428313229297B636F6E737420743D746869732E5F756E74696C2834293B696628742972657475726E20652E617070656E6443';
wwv_flow_imp.g_varchar2_table(9842) := '68696C64286E6577204A78284E756D6265722869292C766F696420302C766F696420302C7429292C21307D656C736520696628746869732E5F61636365707428313329297B636F6E737420743D746869732E5F756E74696C2831293B69662874297B636F';
wwv_flow_imp.g_varchar2_table(9843) := '6E7374206E3D746869732E5F756E74696C2834293B6966286E2972657475726E20652E617070656E644368696C64286E6577204A78284E756D6265722869292C766F696420302C742C6E29292C21307D7D656C73657B636F6E737420743D746869732E5F';
wwv_flow_imp.g_varchar2_table(9844) := '756E74696C2834293B696628742972657475726E20652E617070656E644368696C64286E6577204A78284E756D6265722869292C766F696420302C766F696420302C7429292C21307D72657475726E20746869732E5F6261636B546F2874292C21317D5F';
wwv_flow_imp.g_varchar2_table(9845) := '7061727365416E797468696E672865297B72657475726E203134213D3D746869732E5F746F6B656E2E74797065262628652E617070656E644368696C64286E657720477828746869732E5F7363616E6E65722E746F6B656E5465787428746869732E5F74';
wwv_flow_imp.g_varchar2_table(9846) := '6F6B656E2929292C746869732E5F61636365707428766F69642030292C2130297D7D66756E6374696F6E206F6B28652C742C6E297B76617220692C6F2C732C723B72657475726E2822737472696E67223D3D747970656F66206E2E696E73657274546578';
wwv_flow_imp.g_varchar2_table(9847) := '743F22223D3D3D6E2E696E73657274546578743A22223D3D3D6E2E696E73657274546578742E736E6970706574293F7B65646974733A6E756C6C213D3D286F3D6E756C6C3D3D3D28693D6E2E6164646974696F6E616C45646974297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(9848) := '3D3D693F766F696420303A692E6564697473292626766F69642030213D3D6F3F6F3A5B5D7D3A7B65646974733A5B2E2E2E742E6D61702828743D3E6E657720437828652C7B72616E67653A742C746578743A22737472696E67223D3D747970656F66206E';
wwv_flow_imp.g_varchar2_table(9849) := '2E696E73657274546578743F696B2E657363617065286E2E696E7365727454657874292B222430223A6E2E696E73657274546578742E736E69707065742C696E736572744173536E69707065743A21307D2929292C2E2E2E6E756C6C213D3D28723D6E75';
wwv_flow_imp.g_varchar2_table(9850) := '6C6C3D3D3D28733D6E2E6164646974696F6E616C45646974297C7C766F696420303D3D3D733F766F696420303A732E6564697473292626766F69642030213D3D723F723A5B5D5D7D7D66756E6374696F6E20736B2865297B76617220743B66756E637469';
wwv_flow_imp.g_varchar2_table(9851) := '6F6E206E28652C74297B72657475726E226D696D655479706522696E20653F652E6D696D65547970653D3D3D742E68616E646C65644D696D65547970653A2121742E6B696E642626652E6B696E642E636F6E7461696E7328742E6B696E64297D636F6E73';
wwv_flow_imp.g_varchar2_table(9852) := '7420693D6E6577204D61703B666F7228636F6E7374206F206F66206529666F7228636F6E73742073206F66206E756C6C213D3D28743D6F2E7969656C64546F292626766F69642030213D3D743F743A5B5D29666F7228636F6E73742074206F6620652969';
wwv_flow_imp.g_varchar2_table(9853) := '662874213D3D6F26266E28732C7429297B6C657420653D692E676574286F293B657C7C28653D5B5D2C692E736574286F2C6529292C652E707573682874297D69662821692E73697A652972657475726E2041727261792E66726F6D2865293B636F6E7374';
wwv_flow_imp.g_varchar2_table(9854) := '206F3D6E6577205365742C733D5B5D3B72657475726E2066756E6374696F6E20652874297B69662821742E6C656E6774682972657475726E5B5D3B636F6E7374206E3D745B305D3B696628732E696E636C75646573286E292972657475726E20636F6E73';
wwv_flow_imp.g_varchar2_table(9855) := '6F6C652E7761726E28225969656C6420746F206379636C65206465746563746564222C6E292C743B6966286F2E686173286E292972657475726E206528742E736C696365283129293B6C657420723D5B5D3B636F6E737420613D692E676574286E293B72';
wwv_flow_imp.g_varchar2_table(9856) := '657475726E2061262628732E70757368286E292C723D652861292C732E706F702829292C6F2E616464286E292C5B2E2E2E722C6E2C2E2E2E6528742E736C696365283129295D7D2841727261792E66726F6D286529297D636F6E737420726B3D70632822';
wwv_flow_imp.g_varchar2_table(9857) := '49456469746F7243616E63656C5365727669636522292C616B3D6E6577206C64282263616E63656C6C61626C654F7065726174696F6E222C21312C6228302C22576865746865722074686520656469746F722072756E7320612063616E63656C6C61626C';
wwv_flow_imp.g_varchar2_table(9858) := '65206F7065726174696F6E2C20652E672E206C696B6520275065656B205265666572656E636573272229293B787028726B2C636C6173737B636F6E7374727563746F7228297B746869732E5F746F6B656E733D6E6577205765616B4D61707D6164642865';
wwv_flow_imp.g_varchar2_table(9859) := '2C74297B6C6574206E2C693D746869732E5F746F6B656E732E6765742865293B72657475726E20697C7C28693D652E696E766F6B6557697468696E436F6E746578742828653D3E287B6B65793A616B2E62696E64546F28652E67657428636429292C746F';
wwv_flow_imp.g_varchar2_table(9860) := '6B656E733A6E65772067747D2929292C746869732E5F746F6B656E732E73657428652C6929292C692E6B65792E736574282130292C6E3D692E746F6B656E732E707573682874292C28293D3E7B6E2626286E28292C692E6B65792E7365742821692E746F';
wwv_flow_imp.g_varchar2_table(9861) := '6B656E732E6973456D7074792829292C6E3D766F69642030297D7D63616E63656C2865297B636F6E737420743D746869732E5F746F6B656E732E6765742865293B69662821742972657475726E3B636F6E7374206E3D742E746F6B656E732E706F702829';
wwv_flow_imp.g_varchar2_table(9862) := '3B6E2626286E2E63616E63656C28292C742E6B65792E7365742821742E746F6B656E732E6973456D707479282929297D7D2C31293B636C617373206C6B20657874656E6473204E747B636F6E7374727563746F7228652C74297B73757065722874292C74';
wwv_flow_imp.g_varchar2_table(9863) := '6869732E656469746F723D652C746869732E5F756E72656769737465723D652E696E766F6B6557697468696E436F6E746578742828743D3E742E67657428726B292E61646428652C746869732929297D646973706F736528297B746869732E5F756E7265';
wwv_flow_imp.g_varchar2_table(9864) := '67697374657228292C73757065722E646973706F736528297D7D5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E63616E63656C4F7065726174696F6E222C6B';
wwv_flow_imp.g_varchar2_table(9865) := '624F7074733A7B7765696768743A3130302C7072696D6172793A397D2C707265636F6E646974696F6E3A616B7D297D72756E456469746F72436F6D6D616E6428652C74297B652E67657428726B292E63616E63656C2874297D7D293B636C61737320636B';
wwv_flow_imp.g_varchar2_table(9866) := '7B636F6E7374727563746F7228652C74297B696628746869732E666C6167733D742C3126746869732E666C616773297B636F6E737420743D652E6765744D6F64656C28293B746869732E6D6F64656C56657273696F6E49643D743F616928227B307D237B';
wwv_flow_imp.g_varchar2_table(9867) := '317D222C742E7572692E746F537472696E6728292C742E67657456657273696F6E49642829293A6E756C6C7D656C736520746869732E6D6F64656C56657273696F6E49643D6E756C6C3B3426746869732E666C6167733F746869732E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(9868) := '3D652E676574506F736974696F6E28293A746869732E706F736974696F6E3D6E756C6C2C3226746869732E666C6167733F746869732E73656C656374696F6E3D652E67657453656C656374696F6E28293A746869732E73656C656374696F6E3D6E756C6C';
wwv_flow_imp.g_varchar2_table(9869) := '2C3826746869732E666C6167733F28746869732E7363726F6C6C4C6566743D652E6765745363726F6C6C4C65667428292C746869732E7363726F6C6C546F703D652E6765745363726F6C6C546F702829293A28746869732E7363726F6C6C4C6566743D2D';
wwv_flow_imp.g_varchar2_table(9870) := '312C746869732E7363726F6C6C546F703D2D31297D5F657175616C732865297B69662821286520696E7374616E63656F6620636B292972657475726E21313B636F6E737420743D653B72657475726E20746869732E6D6F64656C56657273696F6E49643D';
wwv_flow_imp.g_varchar2_table(9871) := '3D3D742E6D6F64656C56657273696F6E49642626746869732E7363726F6C6C4C6566743D3D3D742E7363726F6C6C4C6566742626746869732E7363726F6C6C546F703D3D3D742E7363726F6C6C546F702626212821746869732E706F736974696F6E2626';
wwv_flow_imp.g_varchar2_table(9872) := '742E706F736974696F6E7C7C746869732E706F736974696F6E262621742E706F736974696F6E7C7C746869732E706F736974696F6E2626742E706F736974696F6E262621746869732E706F736974696F6E2E657175616C7328742E706F736974696F6E29';
wwv_flow_imp.g_varchar2_table(9873) := '292626212821746869732E73656C656374696F6E2626742E73656C656374696F6E7C7C746869732E73656C656374696F6E262621742E73656C656374696F6E7C7C746869732E73656C656374696F6E2626742E73656C656374696F6E262621746869732E';
wwv_flow_imp.g_varchar2_table(9874) := '73656C656374696F6E2E657175616C7352616E676528742E73656C656374696F6E29297D76616C69646174652865297B72657475726E20746869732E5F657175616C73286E657720636B28652C746869732E666C61677329297D7D636C61737320646B20';
wwv_flow_imp.g_varchar2_table(9875) := '657874656E6473206C6B7B636F6E7374727563746F7228652C742C6E2C69297B737570657228652C69292C746869732E5F6C697374656E65723D6E65772061742C3426742626746869732E5F6C697374656E65722E61646428652E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(9876) := '6765437572736F72506F736974696F6E2828653D3E7B6E262672682E636F6E7461696E73506F736974696F6E286E2C652E706F736974696F6E297C7C746869732E63616E63656C28297D2929292C3226742626746869732E5F6C697374656E65722E6164';
wwv_flow_imp.g_varchar2_table(9877) := '6428652E6F6E4469644368616E6765437572736F7253656C656374696F6E2828653D3E7B6E262672682E636F6E7461696E7352616E6765286E2C652E73656C656374696F6E297C7C746869732E63616E63656C28297D2929292C3826742626746869732E';
wwv_flow_imp.g_varchar2_table(9878) := '5F6C697374656E65722E61646428652E6F6E4469645363726F6C6C4368616E67652828653D3E746869732E63616E63656C28292929292C312674262628746869732E5F6C697374656E65722E61646428652E6F6E4469644368616E67654D6F64656C2828';
wwv_flow_imp.g_varchar2_table(9879) := '653D3E746869732E63616E63656C28292929292C746869732E5F6C697374656E65722E61646428652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E746869732E63616E63656C2829292929297D646973706F736528297B746869';
wwv_flow_imp.g_varchar2_table(9880) := '732E5F6C697374656E65722E646973706F736528292C73757065722E646973706F736528297D7D636C61737320686B20657874656E6473204E747B636F6E7374727563746F7228652C74297B73757065722874292C746869732E5F6C697374656E65723D';
wwv_flow_imp.g_varchar2_table(9881) := '652E6F6E4469644368616E6765436F6E74656E74282828293D3E746869732E63616E63656C282929297D646973706F736528297B746869732E5F6C697374656E65722E646973706F736528292C73757065722E646973706F736528297D7D76617220756B';
wwv_flow_imp.g_varchar2_table(9882) := '3D6E2838313239292C706B3D7B7D3B706B2E7374796C655461675472616E73666F726D3D6A7228292C706B2E736574417474726962757465733D567228292C706B2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C706B2E64';
wwv_flow_imp.g_varchar2_table(9883) := '6F6D4150493D4F7228292C706B2E696E736572745374796C65456C656D656E743D487228292C4E72282928756B2E412C706B292C756B2E412626756B2E412E6C6F63616C732626756B2E412E6C6F63616C733B636F6E737420676B3D4F432E7265676973';
wwv_flow_imp.g_varchar2_table(9884) := '746572287B6465736372697074696F6E3A22696E6C696E652D70726F67726573732D776964676574222C737469636B696E6573733A312C73686F774966436F6C6C61707365643A21302C61667465723A7B636F6E74656E743A22C2A0222C696E6C696E65';
wwv_flow_imp.g_varchar2_table(9885) := '436C6173734E616D653A22696E6C696E652D656469746F722D70726F67726573732D6465636F726174696F6E222C696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673A21307D7D293B636C617373206D6B20657874';
wwv_flow_imp.g_varchar2_table(9886) := '656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E7479706549643D652C746869732E656469746F723D742C746869732E72616E67653D6E2C746869732E64656C65676174653D6F2C74686973';
wwv_flow_imp.g_varchar2_table(9887) := '2E616C6C6F77456469746F724F766572666C6F773D21312C746869732E73757070726573734D6F757365446F776E3D21302C746869732E6372656174652869292C746869732E656469746F722E616464436F6E74656E745769646765742874686973292C';
wwv_flow_imp.g_varchar2_table(9888) := '746869732E656469746F722E6C61796F7574436F6E74656E745769646765742874686973297D6372656174652865297B746869732E646F6D4E6F64653D627228222E696E6C696E652D70726F67726573732D77696467657422292C746869732E646F6D4E';
wwv_flow_imp.g_varchar2_table(9889) := '6F64652E726F6C653D22627574746F6E222C746869732E646F6D4E6F64652E7469746C653D653B636F6E737420743D627228227370616E2E69636F6E22293B746869732E646F6D4E6F64652E617070656E642874292C742E636C6173734C6973742E6164';
wwv_flow_imp.g_varchar2_table(9890) := '64282E2E2E546C2E6173436C6173734E616D654172726179284C6C2E6C6F6164696E67292C22636F6469636F6E2D6D6F6469666965722D7370696E22293B636F6E7374206E3D28293D3E7B636F6E737420653D746869732E656469746F722E6765744F70';
wwv_flow_imp.g_varchar2_table(9891) := '74696F6E283637293B746869732E646F6D4E6F64652E7374796C652E6865696768743D60247B657D7078602C746869732E646F6D4E6F64652E7374796C652E77696474683D60247B4D6174682E6365696C282E382A65297D7078607D3B6E28292C746869';
wwv_flow_imp.g_varchar2_table(9892) := '732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B28652E6861734368616E676564283532297C7C652E6861734368616E676564283637292926266E28297D2929292C';
wwv_flow_imp.g_varchar2_table(9893) := '746869732E5F726567697374657228627328746869732E646F6D4E6F64652C61722E434C49434B2C28653D3E7B746869732E64656C65676174652E63616E63656C28297D2929297D676574496428297B72657475726E206D6B2E6261736549642B222E22';
wwv_flow_imp.g_varchar2_table(9894) := '2B746869732E7479706549647D676574446F6D4E6F646528297B72657475726E20746869732E646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B706F736974696F6E3A7B6C696E654E756D6265723A746869732E72616E67652E73';
wwv_flow_imp.g_varchar2_table(9895) := '746172744C696E654E756D6265722C636F6C756D6E3A746869732E72616E67652E7374617274436F6C756D6E7D2C707265666572656E63653A5B305D7D7D646973706F736528297B73757065722E646973706F736528292C746869732E656469746F722E';
wwv_flow_imp.g_varchar2_table(9896) := '72656D6F7665436F6E74656E745769646765742874686973297D7D6D6B2E6261736549643D22656469746F722E7769646765742E696E6C696E6550726F6772657373576964676574223B6C657420666B3D636C61737320657874656E6473206C747B636F';
wwv_flow_imp.g_varchar2_table(9897) := '6E7374727563746F7228652C742C6E297B737570657228292C746869732E69643D652C746869732E5F656469746F723D742C746869732E5F696E7374616E74696174696F6E536572766963653D6E2C746869732E5F73686F7744656C61793D3530302C74';
wwv_flow_imp.g_varchar2_table(9898) := '6869732E5F73686F7750726F6D6973653D746869732E5F7265676973746572286E6577206374292C746869732E5F63757272656E745769646765743D6E65772063742C746869732E5F6F7065726174696F6E4964506F6F6C3D302C746869732E5F637572';
wwv_flow_imp.g_varchar2_table(9899) := '72656E744465636F726174696F6E733D742E6372656174654465636F726174696F6E73436F6C6C656374696F6E28297D6173796E632073686F775768696C6528652C742C6E297B636F6E737420693D746869732E5F6F7065726174696F6E4964506F6F6C';
wwv_flow_imp.g_varchar2_table(9900) := '2B2B3B746869732E5F63757272656E744F7065726174696F6E3D692C746869732E636C65617228292C746869732E5F73686F7750726F6D6973652E76616C75653D6A74282828293D3E7B636F6E737420693D72682E66726F6D506F736974696F6E732865';
wwv_flow_imp.g_varchar2_table(9901) := '293B746869732E5F63757272656E744465636F726174696F6E732E736574285B7B72616E67653A692C6F7074696F6E733A676B7D5D292E6C656E6774683E30262628746869732E5F63757272656E745769646765742E76616C75653D746869732E5F696E';
wwv_flow_imp.g_varchar2_table(9902) := '7374616E74696174696F6E536572766963652E637265617465496E7374616E6365286D6B2C746869732E69642C746869732E5F656469746F722C692C742C6E29297D292C746869732E5F73686F7744656C6179293B7472797B72657475726E2061776169';
wwv_flow_imp.g_varchar2_table(9903) := '74206E7D66696E616C6C797B746869732E5F63757272656E744F7065726174696F6E3D3D3D69262628746869732E636C65617228292C746869732E5F63757272656E744F7065726174696F6E3D766F69642030297D7D636C65617228297B746869732E5F';
wwv_flow_imp.g_varchar2_table(9904) := '73686F7750726F6D6973652E636C65617228292C746869732E5F63757272656E744465636F726174696F6E732E636C65617228292C746869732E5F63757272656E745769646765742E636C65617228297D7D3B66756E6374696F6E20766B28652C743D7B';
wwv_flow_imp.g_varchar2_table(9905) := '7D297B636F6E7374206E3D626B2874293B72657475726E20796B286E2C66756E6374696F6E28652C74297B636F6E7374206E3D7B747970653A312C6368696C6472656E3A5B5D7D3B6C657420693D302C6F3D6E3B636F6E737420733D5B5D2C723D6E6577';
wwv_flow_imp.g_varchar2_table(9906) := '205F6B2865293B666F72283B21722E656F7328293B297B6C657420653D722E6E65787428293B636F6E7374206E3D225C5C223D3D3D65262630213D3D776B28722E7065656B28292C74293B6966286E262628653D722E6E6578742829292C6E7C7C303D3D';
wwv_flow_imp.g_varchar2_table(9907) := '3D776B28652C74297C7C65213D3D722E7065656B282929696628225C6E223D3D3D6529323D3D3D6F2E747970652626286F3D732E706F702829292C6F2E6368696C6472656E2E70757368287B747970653A387D293B656C73652069662832213D3D6F2E74';
wwv_flow_imp.g_varchar2_table(9908) := '797065297B636F6E737420743D7B747970653A322C636F6E74656E743A657D3B6F2E6368696C6472656E2E707573682874292C732E70757368286F292C6F3D747D656C7365206F2E636F6E74656E742B3D653B656C73657B722E616476616E636528292C';
wwv_flow_imp.g_varchar2_table(9909) := '323D3D3D6F2E747970652626286F3D732E706F702829293B636F6E7374206E3D776B28652C74293B6966286F2E747970653D3D3D6E7C7C353D3D3D6F2E747970652626363D3D3D6E296F3D732E706F7028293B656C73657B636F6E737420653D7B747970';
wwv_flow_imp.g_varchar2_table(9910) := '653A6E2C6368696C6472656E3A5B5D7D3B353D3D3D6E262628652E696E6465783D692C692B2B292C6F2E6368696C6472656E2E707573682865292C732E70757368286F292C6F3D657D7D7D72657475726E20323D3D3D6F2E747970652626286F3D732E70';
wwv_flow_imp.g_varchar2_table(9911) := '6F702829292C732E6C656E6774682C6E7D28652C2121742E72656E646572436F64655365676D656E7473292C742E616374696F6E48616E646C65722C742E72656E646572436F64655365676D656E7473292C6E7D66756E6374696F6E20626B2865297B63';
wwv_flow_imp.g_varchar2_table(9912) := '6F6E737420743D652E696E6C696E653F227370616E223A22646976222C6E3D646F63756D656E742E637265617465456C656D656E742874293B72657475726E20652E636C6173734E616D652626286E2E636C6173734E616D653D652E636C6173734E616D';
wwv_flow_imp.g_varchar2_table(9913) := '65292C6E7D666B3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F';
wwv_flow_imp.g_varchar2_table(9914) := '7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(9915) := '293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626722626';
wwv_flow_imp.g_varchar2_table(9916) := '4F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28322C7563295D2C666B293B636C617373205F6B7B63';
wwv_flow_imp.g_varchar2_table(9917) := '6F6E7374727563746F722865297B746869732E736F757263653D652C746869732E696E6465783D307D656F7328297B72657475726E20746869732E696E6465783E3D746869732E736F757263652E6C656E6774687D6E65787428297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(9918) := '746869732E7065656B28293B72657475726E20746869732E616476616E636528292C657D7065656B28297B72657475726E20746869732E736F757263655B746869732E696E6465785D7D616476616E636528297B746869732E696E6465782B2B7D7D6675';
wwv_flow_imp.g_varchar2_table(9919) := '6E6374696F6E20796B28652C742C6E2C69297B6C6574206F3B696628323D3D3D742E74797065296F3D646F63756D656E742E637265617465546578744E6F646528742E636F6E74656E747C7C2222293B656C736520696628333D3D3D742E74797065296F';
wwv_flow_imp.g_varchar2_table(9920) := '3D646F63756D656E742E637265617465456C656D656E7428226222293B656C736520696628343D3D3D742E74797065296F3D646F63756D656E742E637265617465456C656D656E7428226922293B656C736520696628373D3D3D742E7479706526266929';
wwv_flow_imp.g_varchar2_table(9921) := '6F3D646F63756D656E742E637265617465456C656D656E742822636F646522293B656C736520696628353D3D3D742E7479706526266E297B636F6E737420653D646F63756D656E742E637265617465456C656D656E7428226122293B6E2E646973706F73';
wwv_flow_imp.g_varchar2_table(9922) := '61626C65732E61646428797328652C22636C69636B222C28653D3E7B6E2E63616C6C6261636B28537472696E6728742E696E646578292C65297D2929292C6F3D657D656C736520383D3D3D742E747970653F6F3D646F63756D656E742E63726561746545';
wwv_flow_imp.g_varchar2_table(9923) := '6C656D656E742822627222293A313D3D3D742E747970652626286F3D65293B6F262665213D3D6F2626652E617070656E644368696C64286F292C6F262641727261792E6973417272617928742E6368696C6472656E292626742E6368696C6472656E2E66';
wwv_flow_imp.g_varchar2_table(9924) := '6F72456163682828653D3E7B796B286F2C652C6E2C69297D29297D66756E6374696F6E20776B28652C74297B7377697463682865297B63617365222A223A72657475726E20333B63617365225F223A72657475726E20343B63617365225B223A72657475';
wwv_flow_imp.g_varchar2_table(9925) := '726E20353B63617365225D223A72657475726E20363B636173652260223A72657475726E20743F373A303B64656661756C743A72657475726E20307D7D636F6E737420436B3D6E6577205265674578702860285C5C5C5C293F5C5C245C5C2828247B546C';
wwv_flow_imp.g_varchar2_table(9926) := '2E69636F6E4E616D6545787072657373696F6E7D283F3A247B546C2E69636F6E4D6F64696669657245787072657373696F6E7D293F295C5C29602C226722293B66756E6374696F6E20536B2865297B636F6E737420743D6E65772041727261793B6C6574';
wwv_flow_imp.g_varchar2_table(9927) := '206E2C693D302C6F3D303B666F72283B6E756C6C213D3D286E3D436B2E65786563286529293B297B6F3D6E2E696E6465787C7C302C693C6F2626742E7075736828652E737562737472696E6728692C6F29292C693D286E2E696E6465787C7C30292B6E5B';
wwv_flow_imp.g_varchar2_table(9928) := '305D2E6C656E6774683B636F6E73745B2C732C725D3D6E3B742E7075736828733F602428247B727D29603A786B287B69643A727D29297D72657475726E20693C652E6C656E6774682626742E7075736828652E737562737472696E67286929292C747D66';
wwv_flow_imp.g_varchar2_table(9929) := '756E6374696F6E20786B2865297B636F6E737420743D627228227370616E22293B72657475726E20742E636C6173734C6973742E616464282E2E2E546C2E6173436C6173734E616D654172726179286529292C747D636C617373206B6B7B636F6E737472';
wwv_flow_imp.g_varchar2_table(9930) := '7563746F722865297B746869732E5F7072656669783D652C746869732E5F6C61737449643D307D6E657874496428297B72657475726E20746869732E5F7072656669782B202B2B746869732E5F6C61737449647D7D636F6E737420456B3D6E6577206B6B';
wwv_flow_imp.g_varchar2_table(9931) := '282269642322293B6C6574204C6B3D7B7D3B2166756E6374696F6E28297B66756E6374696F6E206528652C74297B74284C6B297D76617220742C6E3B652E616D643D21302C743D746869732C6E3D66756E6374696F6E2865297B66756E6374696F6E2074';
wwv_flow_imp.g_varchar2_table(9932) := '28652C74297B666F7228766172206E3D303B6E3C742E6C656E6774683B6E2B2B297B76617220693D745B6E5D3B692E656E756D657261626C653D692E656E756D657261626C657C7C21312C692E636F6E666967757261626C653D21302C2276616C756522';
wwv_flow_imp.g_varchar2_table(9933) := '696E2069262628692E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928652C692E6B65792C69297D7D66756E6374696F6E206E28652C74297B286E756C6C3D3D747C7C743E652E6C656E67746829262628743D652E';
wwv_flow_imp.g_varchar2_table(9934) := '6C656E677468293B666F7228766172206E3D302C693D6E65772041727261792874293B6E3C743B6E2B2B29695B6E5D3D655B6E5D3B72657475726E20697D66756E6374696F6E206928652C74297B76617220693D22756E646566696E656422213D747970';
wwv_flow_imp.g_varchar2_table(9935) := '656F662053796D626F6C2626655B53796D626F6C2E6974657261746F725D7C7C655B2240406974657261746F72225D3B696628692972657475726E28693D692E63616C6C286529292E6E6578742E62696E642869293B69662841727261792E6973417272';
wwv_flow_imp.g_varchar2_table(9936) := '61792865297C7C28693D66756E6374696F6E28652C74297B69662865297B69662822737472696E67223D3D747970656F6620652972657475726E206E28652C74293B76617220693D4F626A6563742E70726F746F747970652E746F537472696E672E6361';
wwv_flow_imp.g_varchar2_table(9937) := '6C6C2865292E736C69636528382C2D31293B72657475726E224F626A656374223D3D3D692626652E636F6E7374727563746F72262628693D652E636F6E7374727563746F722E6E616D65292C224D6170223D3D3D697C7C22536574223D3D3D693F417272';
wwv_flow_imp.g_varchar2_table(9938) := '61792E66726F6D2865293A22417267756D656E7473223D3D3D697C7C2F5E283F3A55697C49296E74283F3A387C31367C333229283F3A436C616D706564293F4172726179242F2E746573742869293F6E28652C74293A766F696420307D7D286529297C7C';
wwv_flow_imp.g_varchar2_table(9939) := '742626652626226E756D626572223D3D747970656F6620652E6C656E677468297B69262628653D69293B766172206F3D303B72657475726E2066756E6374696F6E28297B72657475726E206F3E3D652E6C656E6774683F7B646F6E653A21307D3A7B646F';
wwv_flow_imp.g_varchar2_table(9940) := '6E653A21312C76616C75653A655B6F2B2B5D7D7D7D7468726F77206E657720547970654572726F722822496E76616C696420617474656D707420746F2069746572617465206E6F6E2D6974657261626C6520696E7374616E63652E5C6E496E206F726465';
wwv_flow_imp.g_varchar2_table(9941) := '7220746F206265206974657261626C652C206E6F6E2D6172726179206F626A65637473206D75737420686176652061205B53796D626F6C2E6974657261746F725D2829206D6574686F642E22297D66756E6374696F6E206F28297B72657475726E7B6173';
wwv_flow_imp.g_varchar2_table(9942) := '796E633A21312C6261736555726C3A6E756C6C2C627265616B733A21312C657874656E73696F6E733A6E756C6C2C67666D3A21302C6865616465724964733A21302C6865616465725072656669783A22222C686967686C696768743A6E756C6C2C6C616E';
wwv_flow_imp.g_varchar2_table(9943) := '675072656669783A226C616E67756167652D222C6D616E676C653A21302C706564616E7469633A21312C72656E64657265723A6E756C6C2C73616E6974697A653A21312C73616E6974697A65723A6E756C6C2C73696C656E743A21312C736D6172744C69';
wwv_flow_imp.g_varchar2_table(9944) := '7374733A21312C736D6172747970616E74733A21312C746F6B656E697A65723A6E756C6C2C77616C6B546F6B656E733A6E756C6C2C7868746D6C3A21317D7D652E64656661756C74733D7B6173796E633A21312C6261736555726C3A6E756C6C2C627265';
wwv_flow_imp.g_varchar2_table(9945) := '616B733A21312C657874656E73696F6E733A6E756C6C2C67666D3A21302C6865616465724964733A21302C6865616465725072656669783A22222C686967686C696768743A6E756C6C2C6C616E675072656669783A226C616E67756167652D222C6D616E';
wwv_flow_imp.g_varchar2_table(9946) := '676C653A21302C706564616E7469633A21312C72656E64657265723A6E756C6C2C73616E6974697A653A21312C73616E6974697A65723A6E756C6C2C73696C656E743A21312C736D6172744C697374733A21312C736D6172747970616E74733A21312C74';
wwv_flow_imp.g_varchar2_table(9947) := '6F6B656E697A65723A6E756C6C2C77616C6B546F6B656E733A6E756C6C2C7868746D6C3A21317D3B76617220733D2F5B263C3E22275D2F2C723D2F5B263C3E22275D2F672C613D2F5B3C3E22275D7C26283F21233F5C772B3B292F2C6C3D2F5B3C3E2227';
wwv_flow_imp.g_varchar2_table(9948) := '5D7C26283F21233F5C772B3B292F672C633D7B2226223A2226616D703B222C223C223A22266C743B222C223E223A222667743B222C2722273A222671756F743B222C2227223A22262333393B227D2C643D66756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(9949) := '635B655D7D3B66756E6374696F6E206828652C74297B69662874297B696628732E746573742865292972657475726E20652E7265706C61636528722C64297D656C736520696628612E746573742865292972657475726E20652E7265706C616365286C2C';
wwv_flow_imp.g_varchar2_table(9950) := '64293B72657475726E20657D76617220753D2F262823283F3A5C642B297C283F3A23785B302D39412D46612D665D2B297C283F3A5C772B29293B3F2F67693B66756E6374696F6E20702865297B72657475726E20652E7265706C61636528752C2866756E';
wwv_flow_imp.g_varchar2_table(9951) := '6374696F6E28652C74297B72657475726E22636F6C6F6E223D3D3D28743D742E746F4C6F776572436173652829293F223A223A2223223D3D3D742E6368617241742830293F2278223D3D3D742E6368617241742831293F537472696E672E66726F6D4368';
wwv_flow_imp.g_varchar2_table(9952) := '6172436F6465287061727365496E7428742E737562737472696E672832292C313629293A537472696E672E66726F6D43686172436F6465282B742E737562737472696E67283129293A22227D29297D76617220673D2F285E7C5B5E5C5B5D295C5E2F673B';
wwv_flow_imp.g_varchar2_table(9953) := '66756E6374696F6E206D28652C74297B653D22737472696E67223D3D747970656F6620653F653A652E736F757263652C743D747C7C22223B766172206E3D7B7265706C6163653A66756E6374696F6E28742C69297B72657475726E20693D28693D692E73';
wwv_flow_imp.g_varchar2_table(9954) := '6F757263657C7C69292E7265706C61636528672C22243122292C653D652E7265706C61636528742C69292C6E7D2C67657452656765783A66756E6374696F6E28297B72657475726E206E65772052656745787028652C74297D7D3B72657475726E206E7D';
wwv_flow_imp.g_varchar2_table(9955) := '76617220663D2F5B5E5C773A5D2F672C763D2F5E247C5E5B612D7A5D5B612D7A302D392B2E2D5D2A3A7C5E5B3F235D2F693B66756E6374696F6E206228652C742C6E297B69662865297B76617220693B7472797B693D6465636F6465555249436F6D706F';
wwv_flow_imp.g_varchar2_table(9956) := '6E656E742870286E29292E7265706C61636528662C2222292E746F4C6F7765724361736528297D63617463682865297B72657475726E206E756C6C7D696628303D3D3D692E696E6465784F6628226A6176617363726970743A22297C7C303D3D3D692E69';
wwv_flow_imp.g_varchar2_table(9957) := '6E6465784F66282276627363726970743A22297C7C303D3D3D692E696E6465784F662822646174613A22292972657475726E206E756C6C7D74262621762E74657374286E292626286E3D66756E6374696F6E28652C74297B5F5B2220222B655D7C7C2879';
wwv_flow_imp.g_varchar2_table(9958) := '2E746573742865293F5F5B2220222B655D3D652B222F223A5F5B2220222B655D3D4528652C222F222C213029293B766172206E3D2D313D3D3D28653D5F5B2220222B655D292E696E6465784F6628223A22293B72657475726E222F2F223D3D3D742E7375';
wwv_flow_imp.g_varchar2_table(9959) := '62737472696E6728302C32293F6E3F743A652E7265706C61636528772C22243122292B743A222F223D3D3D742E6368617241742830293F6E3F743A652E7265706C61636528432C22243122292B743A652B747D28742C6E29293B7472797B6E3D656E636F';
wwv_flow_imp.g_varchar2_table(9960) := '6465555249286E292E7265706C616365282F2532352F672C222522297D63617463682865297B72657475726E206E756C6C7D72657475726E206E7D766172205F3D7B7D2C793D2F5E5B5E3A5D2B3A5C2F2A5B5E2F5D2A242F2C773D2F5E285B5E3A5D2B3A';
wwv_flow_imp.g_varchar2_table(9961) := '295B5C735C535D2A242F2C433D2F5E285B5E3A5D2B3A5C2F2A5B5E2F5D2A295B5C735C535D2A242F2C533D7B657865633A66756E6374696F6E28297B7D7D3B66756E6374696F6E20782865297B666F722876617220742C6E2C693D313B693C617267756D';
wwv_flow_imp.g_varchar2_table(9962) := '656E74732E6C656E6774683B692B2B29666F72286E20696E20743D617267756D656E74735B695D294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C6E29262628655B6E5D3D745B6E5D293B7265747572';
wwv_flow_imp.g_varchar2_table(9963) := '6E20657D66756E6374696F6E206B28652C74297B766172206E3D652E7265706C616365282F5C7C2F672C2866756E6374696F6E28652C742C6E297B666F722876617220693D21312C6F3D743B2D2D6F3E3D302626225C5C223D3D3D6E5B6F5D3B29693D21';
wwv_flow_imp.g_varchar2_table(9964) := '693B72657475726E20693F227C223A22207C227D29292E73706C6974282F205C7C2F292C693D303B6966286E5B305D2E7472696D28297C7C6E2E736869667428292C6E2E6C656E6774683E302626216E5B6E2E6C656E6774682D315D2E7472696D282926';
wwv_flow_imp.g_varchar2_table(9965) := '266E2E706F7028292C6E2E6C656E6774683E74296E2E73706C6963652874293B656C736520666F72283B6E2E6C656E6774683C743B296E2E70757368282222293B666F72283B693C6E2E6C656E6774683B692B2B296E5B695D3D6E5B695D2E7472696D28';
wwv_flow_imp.g_varchar2_table(9966) := '292E7265706C616365282F5C5C5C7C2F672C227C22293B72657475726E206E7D66756E6374696F6E204528652C742C6E297B76617220693D652E6C656E6774683B696628303D3D3D692972657475726E22223B666F7228766172206F3D303B6F3C693B29';
wwv_flow_imp.g_varchar2_table(9967) := '7B76617220733D652E63686172417428692D6F2D31293B69662873213D3D747C7C6E297B696628733D3D3D747C7C216E29627265616B3B6F2B2B7D656C7365206F2B2B7D72657475726E20652E736C69636528302C692D6F297D66756E6374696F6E204C';
wwv_flow_imp.g_varchar2_table(9968) := '2865297B652626652E73616E6974697A65262621652E73696C656E742626636F6E736F6C652E7761726E28226D61726B656428293A2073616E6974697A6520616E642073616E6974697A657220706172616D657465727320617265206465707265636174';
wwv_flow_imp.g_varchar2_table(9969) := '65642073696E63652076657273696F6E20302E372E302C2073686F756C64206E6F74206265207573656420616E642077696C6C2062652072656D6F76656420696E20746865206675747572652E2052656164206D6F726520686572653A2068747470733A';
wwv_flow_imp.g_varchar2_table(9970) := '2F2F6D61726B65642E6A732E6F72672F232F5553494E475F414456414E4345442E6D64236F7074696F6E7322297D66756E6374696F6E204428652C74297B696628743C312972657475726E22223B666F7228766172206E3D22223B743E313B2931267426';
wwv_flow_imp.g_varchar2_table(9971) := '26286E2B3D65292C743E3E3D312C652B3D653B72657475726E206E2B657D66756E6374696F6E205428652C742C6E2C69297B766172206F3D742E687265662C733D742E7469746C653F6828742E7469746C65293A6E756C6C2C723D655B315D2E7265706C';
wwv_flow_imp.g_varchar2_table(9972) := '616365282F5C5C285B5C5B5C5D5D292F672C22243122293B696628222122213D3D655B305D2E636861724174283029297B692E73746174652E696E4C696E6B3D21303B76617220613D7B747970653A226C696E6B222C7261773A6E2C687265663A6F2C74';
wwv_flow_imp.g_varchar2_table(9973) := '69746C653A732C746578743A722C746F6B656E733A692E696E6C696E65546F6B656E732872297D3B72657475726E20692E73746174652E696E4C696E6B3D21312C617D72657475726E7B747970653A22696D616765222C7261773A6E2C687265663A6F2C';
wwv_flow_imp.g_varchar2_table(9974) := '7469746C653A732C746578743A682872297D7D76617220493D66756E6374696F6E28297B66756E6374696F6E20742874297B746869732E6F7074696F6E733D747C7C652E64656661756C74737D766172206E3D742E70726F746F747970653B7265747572';
wwv_flow_imp.g_varchar2_table(9975) := '6E206E2E73706163653D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E6E65776C696E652E657865632865293B696628742626745B305D2E6C656E6774683E302972657475726E7B747970653A22737061636522';
wwv_flow_imp.g_varchar2_table(9976) := '2C7261773A745B305D7D7D2C6E2E636F64653D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E636F64652E657865632865293B69662874297B766172206E3D745B305D2E7265706C616365282F5E207B312C347D';
wwv_flow_imp.g_varchar2_table(9977) := '2F676D2C2222293B72657475726E7B747970653A22636F6465222C7261773A745B305D2C636F6465426C6F636B5374796C653A22696E64656E746564222C746578743A746869732E6F7074696F6E732E706564616E7469633F6E3A45286E2C225C6E2229';
wwv_flow_imp.g_varchar2_table(9978) := '7D7D7D2C6E2E66656E6365733D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E66656E6365732E657865632865293B69662874297B766172206E3D745B305D2C693D66756E6374696F6E28652C74297B76617220';
wwv_flow_imp.g_varchar2_table(9979) := '6E3D652E6D61746368282F5E285C732B29283F3A606060292F293B6966286E756C6C3D3D3D6E2972657475726E20743B76617220693D6E5B315D3B72657475726E20742E73706C697428225C6E22292E6D6170282866756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(9980) := '20743D652E6D61746368282F5E5C732B2F293B72657475726E206E756C6C3D3D3D743F653A745B305D2E6C656E6774683E3D692E6C656E6774683F652E736C69636528692E6C656E677468293A657D29292E6A6F696E28225C6E22297D286E2C745B335D';
wwv_flow_imp.g_varchar2_table(9981) := '7C7C2222293B72657475726E7B747970653A22636F6465222C7261773A6E2C6C616E673A745B325D3F745B325D2E7472696D28293A745B325D2C746578743A697D7D7D2C6E2E68656164696E673D66756E6374696F6E2865297B76617220743D74686973';
wwv_flow_imp.g_varchar2_table(9982) := '2E72756C65732E626C6F636B2E68656164696E672E657865632865293B69662874297B766172206E3D745B325D2E7472696D28293B6966282F23242F2E74657374286E29297B76617220693D45286E2C222322293B746869732E6F7074696F6E732E7065';
wwv_flow_imp.g_varchar2_table(9983) := '64616E7469633F6E3D692E7472696D28293A692626212F20242F2E746573742869297C7C286E3D692E7472696D2829297D72657475726E7B747970653A2268656164696E67222C7261773A745B305D2C64657074683A745B315D2E6C656E6774682C7465';
wwv_flow_imp.g_varchar2_table(9984) := '78743A6E2C746F6B656E733A746869732E6C657865722E696E6C696E65286E297D7D7D2C6E2E68723D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E68722E657865632865293B696628742972657475726E7B74';
wwv_flow_imp.g_varchar2_table(9985) := '7970653A226872222C7261773A745B305D7D7D2C6E2E626C6F636B71756F74653D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E626C6F636B71756F74652E657865632865293B69662874297B766172206E3D74';
wwv_flow_imp.g_varchar2_table(9986) := '5B305D2E7265706C616365282F5E202A3E5B205C745D3F2F676D2C2222293B72657475726E7B747970653A22626C6F636B71756F7465222C7261773A745B305D2C746F6B656E733A746869732E6C657865722E626C6F636B546F6B656E73286E2C5B5D29';
wwv_flow_imp.g_varchar2_table(9987) := '2C746578743A6E7D7D7D2C6E2E6C6973743D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E6C6973742E657865632865293B69662874297B766172206E2C6F2C732C722C612C6C2C632C642C682C752C702C672C';
wwv_flow_imp.g_varchar2_table(9988) := '6D3D745B315D2E7472696D28292C663D6D2E6C656E6774683E312C763D7B747970653A226C697374222C7261773A22222C6F7264657265643A662C73746172743A663F2B6D2E736C69636528302C2D31293A22222C6C6F6F73653A21312C6974656D733A';
wwv_flow_imp.g_varchar2_table(9989) := '5B5D7D3B6D3D663F225C5C647B312C397D5C5C222B6D2E736C696365282D31293A225C5C222B6D2C746869732E6F7074696F6E732E706564616E7469632626286D3D663F6D3A225B2A2B2D5D22293B666F722876617220623D6E65772052656745787028';
wwv_flow_imp.g_varchar2_table(9990) := '225E28207B302C337D222B6D2B222928283F3A5B5C74205D5B5E5C5C6E5D2A293F283F3A5C5C6E7C24292922293B65262628673D21312C743D622E6578656328652929262621746869732E72756C65732E626C6F636B2E68722E746573742865293B297B';
wwv_flow_imp.g_varchar2_table(9991) := '6966286E3D745B305D2C653D652E737562737472696E67286E2E6C656E677468292C643D745B325D2E73706C697428225C6E222C31295B305D2C683D652E73706C697428225C6E222C31295B305D2C746869732E6F7074696F6E732E706564616E746963';
wwv_flow_imp.g_varchar2_table(9992) := '3F28723D322C703D642E7472696D4C6566742829293A28723D28723D745B325D2E736561726368282F5B5E205D2F29293E343F313A722C703D642E736C6963652872292C722B3D745B315D2E6C656E677468292C6C3D21312C216426262F5E202A242F2E';
wwv_flow_imp.g_varchar2_table(9993) := '746573742868292626286E2B3D682B225C6E222C653D652E737562737472696E6728682E6C656E6774682B31292C673D2130292C216729666F7228766172205F3D6E65772052656745787028225E207B302C222B4D6174682E6D696E28332C722D31292B';
wwv_flow_imp.g_varchar2_table(9994) := '227D283F3A5B2A2B2D5D7C5C5C647B312C397D5B2E295D2928283F3A205B5E5C5C6E5D2A293F283F3A5C5C6E7C24292922292C793D6E65772052656745787028225E207B302C222B4D6174682E6D696E28332C722D31292B227D28283F3A2D202A297B33';
wwv_flow_imp.g_varchar2_table(9995) := '2C7D7C283F3A5F202A297B332C7D7C283F3A5C5C2A202A297B332C7D29283F3A5C5C6E2B7C242922292C773D6E65772052656745787028225E207B302C222B4D6174682E6D696E28332C722D31292B227D283F3A6060607C7E7E7E2922292C433D6E6577';
wwv_flow_imp.g_varchar2_table(9996) := '2052656745787028225E207B302C222B4D6174682E6D696E28332C722D31292B227D2322293B65262628643D753D652E73706C697428225C6E222C31295B305D2C746869732E6F7074696F6E732E706564616E746963262628643D642E7265706C616365';
wwv_flow_imp.g_varchar2_table(9997) := '282F5E207B312C347D283F3D28207B347D292A5B5E205D292F672C2220202229292C21772E7465737428642929262621432E746573742864292626215F2E74657374286429262621792E746573742865293B297B696628642E736561726368282F5B5E20';
wwv_flow_imp.g_varchar2_table(9998) := '5D2F293E3D727C7C21642E7472696D282929702B3D225C6E222B642E736C6963652872293B656C73657B6966286C29627265616B3B702B3D225C6E222B647D6C7C7C642E7472696D28297C7C286C3D2130292C6E2B3D752B225C6E222C653D652E737562';
wwv_flow_imp.g_varchar2_table(9999) := '737472696E6728752E6C656E6774682B31297D762E6C6F6F73657C7C28633F762E6C6F6F73653D21303A2F5C6E202A5C6E202A242F2E74657374286E29262628633D213029292C746869732E6F7074696F6E732E67666D2626286F3D2F5E5C5B5B207858';
wwv_flow_imp.g_varchar2_table(10000) := '5D5C5D202F2E6578656328702929262628733D225B205D2022213D3D6F5B305D2C703D702E7265706C616365282F5E5C5B5B2078585D5C5D202B2F2C222229292C762E6974656D732E70757368287B747970653A226C6973745F6974656D222C7261773A';
wwv_flow_imp.g_varchar2_table(10001) := '6E2C7461736B3A21216F2C636865636B65643A732C6C6F6F73653A21312C746578743A707D292C762E7261772B3D6E7D762E6974656D735B762E6974656D732E6C656E6774682D315D2E7261773D6E2E7472696D526967687428292C762E6974656D735B';
wwv_flow_imp.g_varchar2_table(10002) := '762E6974656D732E6C656E6774682D315D2E746578743D702E7472696D526967687428292C762E7261773D762E7261772E7472696D526967687428293B76617220533D762E6974656D732E6C656E6774683B666F7228613D303B613C533B612B2B297B74';
wwv_flow_imp.g_varchar2_table(10003) := '6869732E6C657865722E73746174652E746F703D21312C762E6974656D735B615D2E746F6B656E733D746869732E6C657865722E626C6F636B546F6B656E7328762E6974656D735B615D2E746578742C5B5D293B76617220783D762E6974656D735B615D';
wwv_flow_imp.g_varchar2_table(10004) := '2E746F6B656E732E66696C746572282866756E6374696F6E2865297B72657475726E227370616365223D3D3D652E747970657D29292C6B3D782E6576657279282866756E6374696F6E2865297B666F722876617220742C6E3D302C6F3D6928652E726177';
wwv_flow_imp.g_varchar2_table(10005) := '2E73706C697428222229293B2128743D6F2829292E646F6E653B29696628225C6E223D3D3D742E76616C75652626286E2B3D31292C6E3E312972657475726E21303B72657475726E21317D29293B21762E6C6F6F73652626782E6C656E67746826266B26';
wwv_flow_imp.g_varchar2_table(10006) := '2628762E6C6F6F73653D21302C762E6974656D735B615D2E6C6F6F73653D2130297D72657475726E20767D7D2C6E2E68746D6C3D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E68746D6C2E657865632865293B';
wwv_flow_imp.g_varchar2_table(10007) := '69662874297B766172206E3D7B747970653A2268746D6C222C7261773A745B305D2C7072653A21746869732E6F7074696F6E732E73616E6974697A657226262822707265223D3D3D745B315D7C7C22736372697074223D3D3D745B315D7C7C227374796C';
wwv_flow_imp.g_varchar2_table(10008) := '65223D3D3D745B315D292C746578743A745B305D7D3B696628746869732E6F7074696F6E732E73616E6974697A65297B76617220693D746869732E6F7074696F6E732E73616E6974697A65723F746869732E6F7074696F6E732E73616E6974697A657228';
wwv_flow_imp.g_varchar2_table(10009) := '745B305D293A6828745B305D293B6E2E747970653D22706172616772617068222C6E2E746578743D692C6E2E746F6B656E733D746869732E6C657865722E696E6C696E652869297D72657475726E206E7D7D2C6E2E6465663D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(10010) := '7B76617220743D746869732E72756C65732E626C6F636B2E6465662E657865632865293B696628742972657475726E20745B335D262628745B335D3D745B335D2E737562737472696E6728312C745B335D2E6C656E6774682D3129292C7B747970653A22';
wwv_flow_imp.g_varchar2_table(10011) := '646566222C7461673A745B315D2E746F4C6F7765724361736528292E7265706C616365282F5C732B2F672C222022292C7261773A745B305D2C687265663A745B325D2C7469746C653A745B335D7D7D2C6E2E7461626C653D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(10012) := '76617220743D746869732E72756C65732E626C6F636B2E7461626C652E657865632865293B69662874297B766172206E3D7B747970653A227461626C65222C6865616465723A6B28745B315D292E6D6170282866756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(10013) := '6E7B746578743A657D7D29292C616C69676E3A745B325D2E7265706C616365282F5E202A7C5C7C202A242F672C2222292E73706C6974282F202A5C7C202A2F292C726F77733A745B335D2626745B335D2E7472696D28293F745B335D2E7265706C616365';
wwv_flow_imp.g_varchar2_table(10014) := '282F5C6E5B205C745D2A242F2C2222292E73706C697428225C6E22293A5B5D7D3B6966286E2E6865616465722E6C656E6774683D3D3D6E2E616C69676E2E6C656E677468297B6E2E7261773D745B305D3B76617220692C6F2C732C722C613D6E2E616C69';
wwv_flow_imp.g_varchar2_table(10015) := '676E2E6C656E6774683B666F7228693D303B693C613B692B2B292F5E202A2D2B3A202A242F2E74657374286E2E616C69676E5B695D293F6E2E616C69676E5B695D3D227269676874223A2F5E202A3A2D2B3A202A242F2E74657374286E2E616C69676E5B';
wwv_flow_imp.g_varchar2_table(10016) := '695D293F6E2E616C69676E5B695D3D2263656E746572223A2F5E202A3A2D2B202A242F2E74657374286E2E616C69676E5B695D293F6E2E616C69676E5B695D3D226C656674223A6E2E616C69676E5B695D3D6E756C6C3B666F7228613D6E2E726F77732E';
wwv_flow_imp.g_varchar2_table(10017) := '6C656E6774682C693D303B693C613B692B2B296E2E726F77735B695D3D6B286E2E726F77735B695D2C6E2E6865616465722E6C656E677468292E6D6170282866756E6374696F6E2865297B72657475726E7B746578743A657D7D29293B666F7228613D6E';
wwv_flow_imp.g_varchar2_table(10018) := '2E6865616465722E6C656E6774682C6F3D303B6F3C613B6F2B2B296E2E6865616465725B6F5D2E746F6B656E733D746869732E6C657865722E696E6C696E65286E2E6865616465725B6F5D2E74657874293B666F7228613D6E2E726F77732E6C656E6774';
wwv_flow_imp.g_varchar2_table(10019) := '682C6F3D303B6F3C613B6F2B2B29666F7228723D6E2E726F77735B6F5D2C733D303B733C722E6C656E6774683B732B2B29725B735D2E746F6B656E733D746869732E6C657865722E696E6C696E6528725B735D2E74657874293B72657475726E206E7D7D';
wwv_flow_imp.g_varchar2_table(10020) := '7D2C6E2E6C68656164696E673D66756E6374696F6E2865297B76617220743D746869732E72756C65732E626C6F636B2E6C68656164696E672E657865632865293B696628742972657475726E7B747970653A2268656164696E67222C7261773A745B305D';
wwv_flow_imp.g_varchar2_table(10021) := '2C64657074683A223D223D3D3D745B325D2E6368617241742830293F313A322C746578743A745B315D2C746F6B656E733A746869732E6C657865722E696E6C696E6528745B315D297D7D2C6E2E7061726167726170683D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(10022) := '617220743D746869732E72756C65732E626C6F636B2E7061726167726170682E657865632865293B69662874297B766172206E3D225C6E223D3D3D745B315D2E63686172417428745B315D2E6C656E6774682D31293F745B315D2E736C69636528302C2D';
wwv_flow_imp.g_varchar2_table(10023) := '31293A745B315D3B72657475726E7B747970653A22706172616772617068222C7261773A745B305D2C746578743A6E2C746F6B656E733A746869732E6C657865722E696E6C696E65286E297D7D7D2C6E2E746578743D66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(10024) := '7220743D746869732E72756C65732E626C6F636B2E746578742E657865632865293B696628742972657475726E7B747970653A2274657874222C7261773A745B305D2C746578743A745B305D2C746F6B656E733A746869732E6C657865722E696E6C696E';
wwv_flow_imp.g_varchar2_table(10025) := '6528745B305D297D7D2C6E2E6573636170653D66756E6374696F6E2865297B76617220743D746869732E72756C65732E696E6C696E652E6573636170652E657865632865293B696628742972657475726E7B747970653A22657363617065222C7261773A';
wwv_flow_imp.g_varchar2_table(10026) := '745B305D2C746578743A6828745B315D297D7D2C6E2E7461673D66756E6374696F6E2865297B76617220743D746869732E72756C65732E696E6C696E652E7461672E657865632865293B696628742972657475726E21746869732E6C657865722E737461';
wwv_flow_imp.g_varchar2_table(10027) := '74652E696E4C696E6B26262F5E3C61202F692E7465737428745B305D293F746869732E6C657865722E73746174652E696E4C696E6B3D21303A746869732E6C657865722E73746174652E696E4C696E6B26262F5E3C5C2F613E2F692E7465737428745B30';
wwv_flow_imp.g_varchar2_table(10028) := '5D29262628746869732E6C657865722E73746174652E696E4C696E6B3D2131292C21746869732E6C657865722E73746174652E696E526177426C6F636B26262F5E3C287072657C636F64657C6B62647C73637269707429285C737C3E292F692E74657374';
wwv_flow_imp.g_varchar2_table(10029) := '28745B305D293F746869732E6C657865722E73746174652E696E526177426C6F636B3D21303A746869732E6C657865722E73746174652E696E526177426C6F636B26262F5E3C5C2F287072657C636F64657C6B62647C73637269707429285C737C3E292F';
wwv_flow_imp.g_varchar2_table(10030) := '692E7465737428745B305D29262628746869732E6C657865722E73746174652E696E526177426C6F636B3D2131292C7B747970653A746869732E6F7074696F6E732E73616E6974697A653F2274657874223A2268746D6C222C7261773A745B305D2C696E';
wwv_flow_imp.g_varchar2_table(10031) := '4C696E6B3A746869732E6C657865722E73746174652E696E4C696E6B2C696E526177426C6F636B3A746869732E6C657865722E73746174652E696E526177426C6F636B2C746578743A746869732E6F7074696F6E732E73616E6974697A653F746869732E';
wwv_flow_imp.g_varchar2_table(10032) := '6F7074696F6E732E73616E6974697A65723F746869732E6F7074696F6E732E73616E6974697A657228745B305D293A6828745B305D293A745B305D7D7D2C6E2E6C696E6B3D66756E6374696F6E2865297B76617220743D746869732E72756C65732E696E';
wwv_flow_imp.g_varchar2_table(10033) := '6C696E652E6C696E6B2E657865632865293B69662874297B766172206E3D745B325D2E7472696D28293B69662821746869732E6F7074696F6E732E706564616E74696326262F5E3C2F2E74657374286E29297B696628212F3E242F2E74657374286E2929';
wwv_flow_imp.g_varchar2_table(10034) := '72657475726E3B76617220693D45286E2E736C69636528302C2D31292C225C5C22293B696628286E2E6C656E6774682D692E6C656E6774682925323D3D302972657475726E7D656C73657B766172206F3D66756E6374696F6E28652C74297B6966282D31';
wwv_flow_imp.g_varchar2_table(10035) := '3D3D3D652E696E6465784F6628745B315D292972657475726E2D313B666F7228766172206E3D652E6C656E6774682C693D302C6F3D303B6F3C6E3B6F2B2B29696628225C5C223D3D3D655B6F5D296F2B2B3B656C736520696628655B6F5D3D3D3D745B30';
wwv_flow_imp.g_varchar2_table(10036) := '5D29692B2B3B656C736520696628655B6F5D3D3D3D745B315D26262D2D693C302972657475726E206F3B72657475726E2D317D28745B325D2C22282922293B6966286F3E2D31297B76617220733D28303D3D3D745B305D2E696E6465784F662822212229';
wwv_flow_imp.g_varchar2_table(10037) := '3F353A34292B745B315D2E6C656E6774682B6F3B745B325D3D745B325D2E737562737472696E6728302C6F292C745B305D3D745B305D2E737562737472696E6728302C73292E7472696D28292C745B335D3D22227D7D76617220723D745B325D2C613D22';
wwv_flow_imp.g_varchar2_table(10038) := '223B696628746869732E6F7074696F6E732E706564616E746963297B766172206C3D2F5E285B5E27225D2A5B5E5C735D295C732B285B27225D29282E2A295C322F2E657865632872293B6C262628723D6C5B315D2C613D6C5B335D297D656C736520613D';
wwv_flow_imp.g_varchar2_table(10039) := '745B335D3F745B335D2E736C69636528312C2D31293A22223B72657475726E20723D722E7472696D28292C2F5E3C2F2E74657374287229262628723D746869732E6F7074696F6E732E706564616E7469632626212F3E242F2E74657374286E293F722E73';
wwv_flow_imp.g_varchar2_table(10040) := '6C6963652831293A722E736C69636528312C2D3129292C5428742C7B687265663A723F722E7265706C61636528746869732E72756C65732E696E6C696E652E5F657363617065732C22243122293A722C7469746C653A613F612E7265706C616365287468';
wwv_flow_imp.g_varchar2_table(10041) := '69732E72756C65732E696E6C696E652E5F657363617065732C22243122293A617D2C745B305D2C746869732E6C65786572297D7D2C6E2E7265666C696E6B3D66756E6374696F6E28652C74297B766172206E3B696628286E3D746869732E72756C65732E';
wwv_flow_imp.g_varchar2_table(10042) := '696E6C696E652E7265666C696E6B2E65786563286529297C7C286E3D746869732E72756C65732E696E6C696E652E6E6F6C696E6B2E6578656328652929297B76617220693D286E5B325D7C7C6E5B315D292E7265706C616365282F5C732B2F672C222022';
wwv_flow_imp.g_varchar2_table(10043) := '293B6966282128693D745B692E746F4C6F7765724361736528295D297C7C21692E68726566297B766172206F3D6E5B305D2E6368617241742830293B72657475726E7B747970653A2274657874222C7261773A6F2C746578743A6F7D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(10044) := '54286E2C692C6E5B305D2C746869732E6C65786572297D7D2C6E2E656D5374726F6E673D66756E6374696F6E28652C742C6E297B766F696420303D3D3D6E2626286E3D2222293B76617220693D746869732E72756C65732E696E6C696E652E656D537472';
wwv_flow_imp.g_varchar2_table(10045) := '6F6E672E6C44656C696D2E657865632865293B6966286926262821695B335D7C7C216E2E6D61746368282F283F3A5B302D39412D5A612D7A5C7841415C7842325C7842335C7842355C7842395C7842415C7842432D5C7842455C7843302D5C7844365C78';
wwv_flow_imp.g_varchar2_table(10046) := '44382D5C7846365C7846382D5C75303243315C75303243362D5C75303244315C75303245302D5C75303245345C75303245435C75303245455C75303337302D5C75303337345C75303337365C75303337375C75303337412D5C75303337445C7530333746';
wwv_flow_imp.g_varchar2_table(10047) := '5C75303338365C75303338382D5C75303338415C75303338435C75303338452D5C75303341315C75303341332D5C75303346355C75303346372D5C75303438315C75303438412D5C75303532465C75303533312D5C75303535365C75303535395C753035';
wwv_flow_imp.g_varchar2_table(10048) := '36302D5C75303538385C75303544302D5C75303545415C75303545462D5C75303546325C75303632302D5C75303634415C75303636302D5C75303636395C75303636455C75303636465C75303637312D5C75303644335C75303644355C75303645355C75';
wwv_flow_imp.g_varchar2_table(10049) := '303645365C75303645452D5C75303646435C75303646465C75303731305C75303731322D5C75303732465C75303734442D5C75303741355C75303742315C75303743302D5C75303745415C75303746345C75303746355C75303746415C75303830302D5C';
wwv_flow_imp.g_varchar2_table(10050) := '75303831355C75303831415C75303832345C75303832385C75303834302D5C75303835385C75303836302D5C75303836415C75303837302D5C75303838375C75303838392D5C75303838455C75303841302D5C75303843395C75303930342D5C75303933';
wwv_flow_imp.g_varchar2_table(10051) := '395C75303933445C75303935305C75303935382D5C75303936315C75303936362D5C75303936465C75303937312D5C75303938305C75303938352D5C75303938435C75303938465C75303939305C75303939332D5C75303941385C75303941412D5C7530';
wwv_flow_imp.g_varchar2_table(10052) := '3942305C75303942325C75303942362D5C75303942395C75303942445C75303943455C75303944435C75303944445C75303944462D5C75303945315C75303945362D5C75303946315C75303946342D5C75303946395C75303946435C75304130352D5C75';
wwv_flow_imp.g_varchar2_table(10053) := '304130415C75304130465C75304131305C75304131332D5C75304132385C75304132412D5C75304133305C75304133325C75304133335C75304133355C75304133365C75304133385C75304133395C75304135392D5C75304135435C75304135455C7530';
wwv_flow_imp.g_varchar2_table(10054) := '4136362D5C75304136465C75304137322D5C75304137345C75304138352D5C75304138445C75304138462D5C75304139315C75304139332D5C75304141385C75304141412D5C75304142305C75304142325C75304142335C75304142352D5C7530414239';
wwv_flow_imp.g_varchar2_table(10055) := '5C75304142445C75304144305C75304145305C75304145315C75304145362D5C75304145465C75304146395C75304230352D5C75304230435C75304230465C75304231305C75304231332D5C75304232385C75304232412D5C75304233305C7530423332';
wwv_flow_imp.g_varchar2_table(10056) := '5C75304233335C75304233352D5C75304233395C75304233445C75304235435C75304235445C75304235462D5C75304236315C75304236362D5C75304236465C75304237312D5C75304237375C75304238335C75304238352D5C75304238415C75304238';
wwv_flow_imp.g_varchar2_table(10057) := '452D5C75304239305C75304239322D5C75304239355C75304239395C75304239415C75304239435C75304239455C75304239465C75304241335C75304241345C75304241382D5C75304241415C75304241452D5C75304242395C75304244305C75304245';
wwv_flow_imp.g_varchar2_table(10058) := '362D5C75304246325C75304330352D5C75304330435C75304330452D5C75304331305C75304331322D5C75304332385C75304332412D5C75304333395C75304333445C75304335382D5C75304335415C75304335445C75304336305C75304336315C7530';
wwv_flow_imp.g_varchar2_table(10059) := '4336362D5C75304336465C75304337382D5C75304337455C75304338305C75304338352D5C75304338435C75304338452D5C75304339305C75304339322D5C75304341385C75304341412D5C75304342335C75304342352D5C75304342395C7530434244';
wwv_flow_imp.g_varchar2_table(10060) := '5C75304344445C75304344455C75304345305C75304345315C75304345362D5C75304345465C75304346315C75304346325C75304430342D5C75304430435C75304430452D5C75304431305C75304431322D5C75304433415C75304433445C7530443445';
wwv_flow_imp.g_varchar2_table(10061) := '5C75304435342D5C75304435365C75304435382D5C75304436315C75304436362D5C75304437385C75304437412D5C75304437465C75304438352D5C75304439365C75304439412D5C75304442315C75304442332D5C75304442425C75304442445C7530';
wwv_flow_imp.g_varchar2_table(10062) := '4443302D5C75304443365C75304445362D5C75304445465C75304530312D5C75304533305C75304533325C75304533335C75304534302D5C75304534365C75304535302D5C75304535395C75304538315C75304538325C75304538345C75304538362D5C';
wwv_flow_imp.g_varchar2_table(10063) := '75304538415C75304538432D5C75304541335C75304541355C75304541372D5C75304542305C75304542325C75304542335C75304542445C75304543302D5C75304543345C75304543365C75304544302D5C75304544395C75304544432D5C7530454446';
wwv_flow_imp.g_varchar2_table(10064) := '5C75304630305C75304632302D5C75304633335C75304634302D5C75304634375C75304634392D5C75304636435C75304638382D5C75304638435C75313030302D5C75313032415C75313033462D5C75313034395C75313035302D5C75313035355C7531';
wwv_flow_imp.g_varchar2_table(10065) := '3035412D5C75313035445C75313036315C75313036355C75313036365C75313036452D5C75313037305C75313037352D5C75313038315C75313038455C75313039302D5C75313039395C75313041302D5C75313043355C75313043375C75313043445C75';
wwv_flow_imp.g_varchar2_table(10066) := '313044302D5C75313046415C75313046432D5C75313234385C75313234412D5C75313234445C75313235302D5C75313235365C75313235385C75313235412D5C75313235445C75313236302D5C75313238385C75313238412D5C75313238445C75313239';
wwv_flow_imp.g_varchar2_table(10067) := '302D5C75313242305C75313242322D5C75313242355C75313242382D5C75313242455C75313243305C75313243322D5C75313243355C75313243382D5C75313244365C75313244382D5C75313331305C75313331322D5C75313331355C75313331382D5C';
wwv_flow_imp.g_varchar2_table(10068) := '75313335415C75313336392D5C75313337435C75313338302D5C75313338465C75313341302D5C75313346355C75313346382D5C75313346445C75313430312D5C75313636435C75313636462D5C75313637465C75313638312D5C75313639415C753136';
wwv_flow_imp.g_varchar2_table(10069) := '41302D5C75313645415C75313645452D5C75313646385C75313730302D5C75313731315C75313731462D5C75313733315C75313734302D5C75313735315C75313736302D5C75313736435C75313736452D5C75313737305C75313738302D5C7531374233';
wwv_flow_imp.g_varchar2_table(10070) := '5C75313744375C75313744435C75313745302D5C75313745395C75313746302D5C75313746395C75313831302D5C75313831395C75313832302D5C75313837385C75313838302D5C75313838345C75313838372D5C75313841385C75313841415C753138';
wwv_flow_imp.g_varchar2_table(10071) := '42302D5C75313846355C75313930302D5C75313931455C75313934362D5C75313936445C75313937302D5C75313937345C75313938302D5C75313941425C75313942302D5C75313943395C75313944302D5C75313944415C75314130302D5C7531413136';
wwv_flow_imp.g_varchar2_table(10072) := '5C75314132302D5C75314135345C75314138302D5C75314138395C75314139302D5C75314139395C75314141375C75314230352D5C75314233335C75314234352D5C75314234435C75314235302D5C75314235395C75314238332D5C75314241305C7531';
wwv_flow_imp.g_varchar2_table(10073) := '4241452D5C75314245355C75314330302D5C75314332335C75314334302D5C75314334395C75314334442D5C75314337445C75314338302D5C75314338385C75314339302D5C75314342415C75314342442D5C75314342465C75314345392D5C75314345';
wwv_flow_imp.g_varchar2_table(10074) := '435C75314345452D5C75314346335C75314346355C75314346365C75314346415C75314430302D5C75314442465C75314530302D5C75314631355C75314631382D5C75314631445C75314632302D5C75314634355C75314634382D5C75314634445C7531';
wwv_flow_imp.g_varchar2_table(10075) := '4635302D5C75314635375C75314635395C75314635425C75314635445C75314635462D5C75314637445C75314638302D5C75314642345C75314642362D5C75314642435C75314642455C75314643322D5C75314643345C75314643362D5C75314643435C';
wwv_flow_imp.g_varchar2_table(10076) := '75314644302D5C75314644335C75314644362D5C75314644425C75314645302D5C75314645435C75314646322D5C75314646345C75314646362D5C75314646435C75323037305C75323037315C75323037342D5C75323037395C75323037462D5C753230';
wwv_flow_imp.g_varchar2_table(10077) := '38395C75323039302D5C75323039435C75323130325C75323130375C75323130412D5C75323131335C75323131355C75323131392D5C75323131445C75323132345C75323132365C75323132385C75323132412D5C75323132445C75323132462D5C7532';
wwv_flow_imp.g_varchar2_table(10078) := '3133395C75323133432D5C75323133465C75323134352D5C75323134395C75323134455C75323135302D5C75323138395C75323436302D5C75323439425C75323445412D5C75323446465C75323737362D5C75323739335C75324330302D5C7532434534';
wwv_flow_imp.g_varchar2_table(10079) := '5C75324345422D5C75324345455C75324346325C75324346335C75324346445C75324430302D5C75324432355C75324432375C75324432445C75324433302D5C75324436375C75324436465C75324438302D5C75324439365C75324441302D5C75324441';
wwv_flow_imp.g_varchar2_table(10080) := '365C75324441382D5C75324441455C75324442302D5C75324442365C75324442382D5C75324442455C75324443302D5C75324443365C75324443382D5C75324443455C75324444302D5C75324444365C75324444382D5C75324444455C75324532465C75';
wwv_flow_imp.g_varchar2_table(10081) := '333030352D5C75333030375C75333032312D5C75333032395C75333033312D5C75333033355C75333033382D5C75333033435C75333034312D5C75333039365C75333039442D5C75333039465C75333041312D5C75333046415C75333046432D5C753330';
wwv_flow_imp.g_varchar2_table(10082) := '46465C75333130352D5C75333132465C75333133312D5C75333138455C75333139322D5C75333139355C75333141302D5C75333142465C75333146302D5C75333146465C75333232302D5C75333232395C75333234382D5C75333234465C75333235312D';
wwv_flow_imp.g_varchar2_table(10083) := '5C75333235465C75333238302D5C75333238395C75333242312D5C75333242465C75333430302D5C75344442465C75344530302D5C75413438435C75413444302D5C75413446445C75413530302D5C75413630435C75413631302D5C75413632425C7541';
wwv_flow_imp.g_varchar2_table(10084) := '3634302D5C75413636455C75413637462D5C75413639445C75413641302D5C75413645465C75413731372D5C75413731465C75413732322D5C75413738385C75413738422D5C75413743415C75413744305C75413744315C75413744335C75413744352D';
wwv_flow_imp.g_varchar2_table(10085) := '5C75413744395C75413746322D5C75413830315C75413830332D5C75413830355C75413830372D5C75413830415C75413830432D5C75413832325C75413833302D5C75413833355C75413834302D5C75413837335C75413838322D5C75413842335C7541';
wwv_flow_imp.g_varchar2_table(10086) := '3844302D5C75413844395C75413846322D5C75413846375C75413846425C75413846445C75413846455C75413930302D5C75413932355C75413933302D5C75413934365C75413936302D5C75413937435C75413938342D5C75413942325C75413943462D';
wwv_flow_imp.g_varchar2_table(10087) := '5C75413944395C75413945302D5C75413945345C75413945362D5C75413946455C75414130302D5C75414132385C75414134302D5C75414134325C75414134342D5C75414134425C75414135302D5C75414135395C75414136302D5C75414137365C7541';
wwv_flow_imp.g_varchar2_table(10088) := '4137415C75414137452D5C75414141465C75414142315C75414142355C75414142365C75414142392D5C75414142445C75414143305C75414143325C75414144422D5C75414144445C75414145302D5C75414145415C75414146322D5C75414146345C75';
wwv_flow_imp.g_varchar2_table(10089) := '414230312D5C75414230365C75414230392D5C75414230455C75414231312D5C75414231365C75414232302D5C75414232365C75414232382D5C75414232455C75414233302D5C75414235415C75414235432D5C75414236395C75414237302D5C754142';
wwv_flow_imp.g_varchar2_table(10090) := '45325C75414246302D5C75414246395C75414330302D5C75443741335C75443742302D5C75443743365C75443743422D5C75443746425C75463930302D5C75464136445C75464137302D5C75464144395C75464230302D5C75464230365C75464231332D';
wwv_flow_imp.g_varchar2_table(10091) := '5C75464231375C75464231445C75464231462D5C75464232385C75464232412D5C75464233365C75464233382D5C75464233435C75464233455C75464234305C75464234315C75464234335C75464234345C75464234362D5C75464242315C7546424433';
wwv_flow_imp.g_varchar2_table(10092) := '2D5C75464433445C75464435302D5C75464438465C75464439322D5C75464443375C75464446302D5C75464446425C75464537302D5C75464537345C75464537362D5C75464546435C75464631302D5C75464631395C75464632312D5C75464633415C75';
wwv_flow_imp.g_varchar2_table(10093) := '464634312D5C75464635415C75464636362D5C75464642455C75464643322D5C75464643375C75464643412D5C75464643465C75464644322D5C75464644375C75464644412D5C75464644435D7C5C75443830305B5C75444330302D5C75444330425C75';
wwv_flow_imp.g_varchar2_table(10094) := '444330442D5C75444332365C75444332382D5C75444333415C75444333435C75444333445C75444333462D5C75444334445C75444335302D5C75444335445C75444338302D5C75444346415C75444430372D5C75444433335C75444434302D5C75444437';
wwv_flow_imp.g_varchar2_table(10095) := '385C75444438415C75444438425C75444538302D5C75444539435C75444541302D5C75444544305C75444545312D5C75444546425C75444630302D5C75444632335C75444632442D5C75444634415C75444635302D5C75444637355C75444638302D5C75';
wwv_flow_imp.g_varchar2_table(10096) := '444639445C75444641302D5C75444643335C75444643382D5C75444643465C75444644312D5C75444644355D7C5C75443830315B5C75444330302D5C75444339445C75444341302D5C75444341395C75444342302D5C75444344335C75444344382D5C75';
wwv_flow_imp.g_varchar2_table(10097) := '444346425C75444430302D5C75444432375C75444433302D5C75444436335C75444437302D5C75444437415C75444437432D5C75444438415C75444438432D5C75444439325C75444439345C75444439355C75444439372D5C75444441315C7544444133';
wwv_flow_imp.g_varchar2_table(10098) := '2D5C75444442315C75444442332D5C75444442395C75444442425C75444442435C75444530302D5C75444633365C75444634302D5C75444635355C75444636302D5C75444636375C75444638302D5C75444638355C75444638372D5C75444642305C7544';
wwv_flow_imp.g_varchar2_table(10099) := '4642322D5C75444642415D7C5C75443830325B5C75444330302D5C75444330355C75444330385C75444330412D5C75444333355C75444333375C75444333385C75444333435C75444333462D5C75444335355C75444335382D5C75444337365C75444337';
wwv_flow_imp.g_varchar2_table(10100) := '392D5C75444339455C75444341372D5C75444341465C75444345302D5C75444346325C75444346345C75444346355C75444346422D5C75444431425C75444432302D5C75444433395C75444438302D5C75444442375C75444442432D5C75444443465C75';
wwv_flow_imp.g_varchar2_table(10101) := '444444322D5C75444530305C75444531302D5C75444531335C75444531352D5C75444531375C75444531392D5C75444533355C75444534302D5C75444534385C75444536302D5C75444537455C75444538302D5C75444539465C75444543302D5C754445';
wwv_flow_imp.g_varchar2_table(10102) := '43375C75444543392D5C75444545345C75444545422D5C75444545465C75444630302D5C75444633355C75444634302D5C75444635355C75444635382D5C75444637325C75444637382D5C75444639315C75444641392D5C75444641465D7C5C75443830';
wwv_flow_imp.g_varchar2_table(10103) := '335B5C75444330302D5C75444334385C75444338302D5C75444342325C75444343302D5C75444346325C75444346412D5C75444432335C75444433302D5C75444433395C75444536302D5C75444537455C75444538302D5C75444541395C75444542305C';
wwv_flow_imp.g_varchar2_table(10104) := '75444542315C75444630302D5C75444632375C75444633302D5C75444634355C75444635312D5C75444635345C75444637302D5C75444638315C75444642302D5C75444643425C75444645302D5C75444646365D7C5C75443830345B5C75444330332D5C';
wwv_flow_imp.g_varchar2_table(10105) := '75444333375C75444335322D5C75444336465C75444337315C75444337325C75444337355C75444338332D5C75444341465C75444344302D5C75444345385C75444346302D5C75444346395C75444430332D5C75444432365C75444433362D5C75444433';
wwv_flow_imp.g_varchar2_table(10106) := '465C75444434345C75444434375C75444435302D5C75444437325C75444437365C75444438332D5C75444442325C75444443312D5C75444443345C75444444302D5C75444444415C75444444435C75444445312D5C75444446345C75444530302D5C7544';
wwv_flow_imp.g_varchar2_table(10107) := '4531315C75444531332D5C75444532425C75444538302D5C75444538365C75444538385C75444538412D5C75444538445C75444538462D5C75444539445C75444539462D5C75444541385C75444542302D5C75444544455C75444546302D5C7544454639';
wwv_flow_imp.g_varchar2_table(10108) := '5C75444630352D5C75444630435C75444630465C75444631305C75444631332D5C75444632385C75444632412D5C75444633305C75444633325C75444633335C75444633352D5C75444633395C75444633445C75444635305C75444635442D5C75444636';
wwv_flow_imp.g_varchar2_table(10109) := '315D7C5C75443830355B5C75444330302D5C75444333345C75444334372D5C75444334415C75444335302D5C75444335395C75444335462D5C75444336315C75444338302D5C75444341465C75444343345C75444343355C75444343375C75444344302D';
wwv_flow_imp.g_varchar2_table(10110) := '5C75444344395C75444438302D5C75444441455C75444444382D5C75444444425C75444530302D5C75444532465C75444534345C75444535302D5C75444535395C75444538302D5C75444541415C75444542385C75444543302D5C75444543395C754446';
wwv_flow_imp.g_varchar2_table(10111) := '30302D5C75444631415C75444633302D5C75444633425C75444634302D5C75444634365D7C5C75443830365B5C75444330302D5C75444332425C75444341302D5C75444346325C75444346462D5C75444430365C75444430395C75444430432D5C754444';
wwv_flow_imp.g_varchar2_table(10112) := '31335C75444431355C75444431365C75444431382D5C75444432465C75444433465C75444434315C75444435302D5C75444435395C75444441302D5C75444441375C75444441412D5C75444444305C75444445315C75444445335C75444530305C754445';
wwv_flow_imp.g_varchar2_table(10113) := '30422D5C75444533325C75444533415C75444535305C75444535432D5C75444538395C75444539445C75444542302D5C75444546385D7C5C75443830375B5C75444330302D5C75444330385C75444330412D5C75444332455C75444334305C7544433530';
wwv_flow_imp.g_varchar2_table(10114) := '2D5C75444336435C75444337322D5C75444338465C75444430302D5C75444430365C75444430385C75444430395C75444430422D5C75444433305C75444434365C75444435302D5C75444435395C75444436302D5C75444436355C75444436375C754444';
wwv_flow_imp.g_varchar2_table(10115) := '36385C75444436412D5C75444438395C75444439385C75444441302D5C75444441395C75444545302D5C75444546325C75444642305C75444643302D5C75444644345D7C5C75443830385B5C75444330302D5C75444639395D7C5C75443830395B5C7544';
wwv_flow_imp.g_varchar2_table(10116) := '4330302D5C75444336455C75444338302D5C75444434335D7C5C75443830425B5C75444639302D5C75444646305D7C5B5C75443830435C75443831432D5C75443832305C75443832325C75443834302D5C75443836385C75443836412D5C75443836435C';
wwv_flow_imp.g_varchar2_table(10117) := '75443836462D5C75443837325C75443837342D5C75443837395C75443838302D5C75443838335D5B5C75444330302D5C75444646465D7C5C75443830445B5C75444330302D5C75444332455D7C5C75443831315B5C75444330302D5C75444534365D7C5C';
wwv_flow_imp.g_varchar2_table(10118) := '75443831415B5C75444330302D5C75444533385C75444534302D5C75444535455C75444536302D5C75444536395C75444537302D5C75444542455C75444543302D5C75444543395C75444544302D5C75444545445C75444630302D5C75444632465C7544';
wwv_flow_imp.g_varchar2_table(10119) := '4634302D5C75444634335C75444635302D5C75444635395C75444635422D5C75444636315C75444636332D5C75444637375C75444637442D5C75444638465D7C5C75443831425B5C75444534302D5C75444539365C75444630302D5C75444634415C7544';
wwv_flow_imp.g_varchar2_table(10120) := '4635305C75444639332D5C75444639465C75444645305C75444645315C75444645335D7C5C75443832315B5C75444330302D5C75444646375D7C5C75443832335B5C75444330302D5C75444344355C75444430302D5C75444430385D7C5C75443832425B';
wwv_flow_imp.g_varchar2_table(10121) := '5C75444646302D5C75444646335C75444646352D5C75444646425C75444646445C75444646455D7C5C75443832435B5C75444330302D5C75444432325C75444435302D5C75444435325C75444436342D5C75444436375C75444437302D5C75444546425D';
wwv_flow_imp.g_varchar2_table(10122) := '7C5C75443832465B5C75444330302D5C75444336415C75444337302D5C75444337435C75444338302D5C75444338385C75444339302D5C75444339395D7C5C75443833345B5C75444545302D5C75444546335C75444636302D5C75444637385D7C5C7544';
wwv_flow_imp.g_varchar2_table(10123) := '3833355B5C75444330302D5C75444335345C75444335362D5C75444339435C75444339455C75444339465C75444341325C75444341355C75444341365C75444341392D5C75444341435C75444341452D5C75444342395C75444342425C75444342442D5C';
wwv_flow_imp.g_varchar2_table(10124) := '75444343335C75444343352D5C75444430355C75444430372D5C75444430415C75444430442D5C75444431345C75444431362D5C75444431435C75444431452D5C75444433395C75444433422D5C75444433455C75444434302D5C75444434345C754444';
wwv_flow_imp.g_varchar2_table(10125) := '34365C75444434412D5C75444435305C75444435322D5C75444541355C75444541382D5C75444543305C75444543322D5C75444544415C75444544432D5C75444546415C75444546432D5C75444631345C75444631362D5C75444633345C75444633362D';
wwv_flow_imp.g_varchar2_table(10126) := '5C75444634455C75444635302D5C75444636455C75444637302D5C75444638385C75444638412D5C75444641385C75444641412D5C75444643325C75444643342D5C75444643425C75444643452D5C75444646465D7C5C75443833375B5C75444630302D';
wwv_flow_imp.g_varchar2_table(10127) := '5C75444631455D7C5C75443833385B5C75444430302D5C75444432435C75444433372D5C75444433445C75444434302D5C75444434395C75444434455C75444539302D5C75444541445C75444543302D5C75444545425C75444546302D5C75444546395D';
wwv_flow_imp.g_varchar2_table(10128) := '7C5C75443833395B5C75444645302D5C75444645365C75444645382D5C75444645425C75444645445C75444645455C75444646302D5C75444646455D7C5C75443833415B5C75444330302D5C75444343345C75444343372D5C75444343465C7544443030';
wwv_flow_imp.g_varchar2_table(10129) := '2D5C75444434335C75444434425C75444435302D5C75444435395D7C5C75443833425B5C75444337312D5C75444341425C75444341442D5C75444341465C75444342312D5C75444342345C75444430312D5C75444432445C75444432462D5C7544443344';
wwv_flow_imp.g_varchar2_table(10130) := '5C75444530302D5C75444530335C75444530352D5C75444531465C75444532315C75444532325C75444532345C75444532375C75444532392D5C75444533325C75444533342D5C75444533375C75444533395C75444533425C75444534325C7544453437';
wwv_flow_imp.g_varchar2_table(10131) := '5C75444534395C75444534425C75444534442D5C75444534465C75444535315C75444535325C75444535345C75444535375C75444535395C75444535425C75444535445C75444535465C75444536315C75444536325C75444536345C75444536372D5C75';
wwv_flow_imp.g_varchar2_table(10132) := '444536415C75444536432D5C75444537325C75444537342D5C75444537375C75444537392D5C75444537435C75444537455C75444538302D5C75444538395C75444538422D5C75444539425C75444541312D5C75444541335C75444541352D5C75444541';
wwv_flow_imp.g_varchar2_table(10133) := '395C75444541422D5C75444542425D7C5C75443833435B5C75444430302D5C75444430435D7C5C75443833455B5C75444646302D5C75444646395D7C5C75443836395B5C75444330302D5C75444544465C75444630302D5C75444646465D7C5C75443836';
wwv_flow_imp.g_varchar2_table(10134) := '445B5C75444330302D5C75444633385C75444634302D5C75444646465D7C5C75443836455B5C75444330302D5C75444331445C75444332302D5C75444646465D7C5C75443837335B5C75444330302D5C75444541315C75444542302D5C75444646465D7C';
wwv_flow_imp.g_varchar2_table(10135) := '5C75443837415B5C75444330302D5C75444645305D7C5C75443837455B5C75444330302D5C75444531445D7C5C75443838345B5C75444330302D5C75444634415D292F2929297B766172206F3D695B315D7C7C695B325D7C7C22223B696628216F7C7C6F';
wwv_flow_imp.g_varchar2_table(10136) := '26262822223D3D3D6E7C7C746869732E72756C65732E696E6C696E652E70756E6374756174696F6E2E65786563286E2929297B76617220732C722C613D695B305D2E6C656E6774682D312C6C3D612C633D302C643D222A223D3D3D695B305D5B305D3F74';
wwv_flow_imp.g_varchar2_table(10137) := '6869732E72756C65732E696E6C696E652E656D5374726F6E672E7244656C696D4173743A746869732E72756C65732E696E6C696E652E656D5374726F6E672E7244656C696D556E643B666F7228642E6C617374496E6465783D302C743D742E736C696365';
wwv_flow_imp.g_varchar2_table(10138) := '282D312A652E6C656E6774682B61293B6E756C6C213D28693D642E65786563287429293B29696628733D695B315D7C7C695B325D7C7C695B335D7C7C695B345D7C7C695B355D7C7C695B365D29696628723D732E6C656E6774682C695B335D7C7C695B34';
wwv_flow_imp.g_varchar2_table(10139) := '5D296C2B3D723B656C736520696628212828695B355D7C7C695B365D292626612533297C7C28612B72292533297B6966282128286C2D3D72293E3029297B696628723D4D6174682E6D696E28722C722B6C2B63292C4D6174682E6D696E28612C72292532';
wwv_flow_imp.g_varchar2_table(10140) := '297B76617220683D652E736C69636528312C612B692E696E6465782B72293B72657475726E7B747970653A22656D222C7261773A652E736C69636528302C612B692E696E6465782B722B31292C746578743A682C746F6B656E733A746869732E6C657865';
wwv_flow_imp.g_varchar2_table(10141) := '722E696E6C696E65546F6B656E732868297D7D76617220753D652E736C69636528322C612B692E696E6465782B722D31293B72657475726E7B747970653A227374726F6E67222C7261773A652E736C69636528302C612B692E696E6465782B722B31292C';
wwv_flow_imp.g_varchar2_table(10142) := '746578743A752C746F6B656E733A746869732E6C657865722E696E6C696E65546F6B656E732875297D7D7D656C736520632B3D727D7D7D2C6E2E636F64657370616E3D66756E6374696F6E2865297B76617220743D746869732E72756C65732E696E6C69';
wwv_flow_imp.g_varchar2_table(10143) := '6E652E636F64652E657865632865293B69662874297B766172206E3D745B325D2E7265706C616365282F5C6E2F672C222022292C693D2F5B5E205D2F2E74657374286E292C6F3D2F5E202F2E74657374286E2926262F20242F2E74657374286E293B7265';
wwv_flow_imp.g_varchar2_table(10144) := '7475726E206926266F2626286E3D6E2E737562737472696E6728312C6E2E6C656E6774682D3129292C6E3D68286E2C2130292C7B747970653A22636F64657370616E222C7261773A745B305D2C746578743A6E7D7D7D2C6E2E62723D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(10145) := '2865297B76617220743D746869732E72756C65732E696E6C696E652E62722E657865632865293B696628742972657475726E7B747970653A226272222C7261773A745B305D7D7D2C6E2E64656C3D66756E6374696F6E2865297B76617220743D74686973';
wwv_flow_imp.g_varchar2_table(10146) := '2E72756C65732E696E6C696E652E64656C2E657865632865293B696628742972657475726E7B747970653A2264656C222C7261773A745B305D2C746578743A745B325D2C746F6B656E733A746869732E6C657865722E696E6C696E65546F6B656E732874';
wwv_flow_imp.g_varchar2_table(10147) := '5B325D297D7D2C6E2E6175746F6C696E6B3D66756E6374696F6E28652C74297B766172206E2C692C6F3D746869732E72756C65732E696E6C696E652E6175746F6C696E6B2E657865632865293B6966286F2972657475726E20693D2240223D3D3D6F5B32';
wwv_flow_imp.g_varchar2_table(10148) := '5D3F226D61696C746F3A222B286E3D6828746869732E6F7074696F6E732E6D616E676C653F74286F5B315D293A6F5B315D29293A6E3D68286F5B315D292C7B747970653A226C696E6B222C7261773A6F5B305D2C746578743A6E2C687265663A692C746F';
wwv_flow_imp.g_varchar2_table(10149) := '6B656E733A5B7B747970653A2274657874222C7261773A6E2C746578743A6E7D5D7D7D2C6E2E75726C3D66756E6374696F6E28652C74297B766172206E3B6966286E3D746869732E72756C65732E696E6C696E652E75726C2E65786563286529297B7661';
wwv_flow_imp.g_varchar2_table(10150) := '7220692C6F3B6966282240223D3D3D6E5B325D296F3D226D61696C746F3A222B28693D6828746869732E6F7074696F6E732E6D616E676C653F74286E5B305D293A6E5B305D29293B656C73657B76617220733B646F7B733D6E5B305D2C6E5B305D3D7468';
wwv_flow_imp.g_varchar2_table(10151) := '69732E72756C65732E696E6C696E652E5F6261636B706564616C2E65786563286E5B305D295B305D7D7768696C652873213D3D6E5B305D293B693D68286E5B305D292C6F3D227777772E223D3D3D6E5B315D3F22687474703A2F2F222B693A697D726574';
wwv_flow_imp.g_varchar2_table(10152) := '75726E7B747970653A226C696E6B222C7261773A6E5B305D2C746578743A692C687265663A6F2C746F6B656E733A5B7B747970653A2274657874222C7261773A692C746578743A697D5D7D7D7D2C6E2E696E6C696E65546578743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(10153) := '652C74297B766172206E2C693D746869732E72756C65732E696E6C696E652E746578742E657865632865293B696628692972657475726E206E3D746869732E6C657865722E73746174652E696E526177426C6F636B3F746869732E6F7074696F6E732E73';
wwv_flow_imp.g_varchar2_table(10154) := '616E6974697A653F746869732E6F7074696F6E732E73616E6974697A65723F746869732E6F7074696F6E732E73616E6974697A657228695B305D293A6828695B305D293A695B305D3A6828746869732E6F7074696F6E732E736D6172747970616E74733F';
wwv_flow_imp.g_varchar2_table(10155) := '7428695B305D293A695B305D292C7B747970653A2274657874222C7261773A695B305D2C746578743A6E7D7D2C747D28292C4D3D7B6E65776C696E653A2F5E283F3A202A283F3A5C6E7C2429292B2F2C636F64653A2F5E28207B347D5B5E5C6E5D2B283F';
wwv_flow_imp.g_varchar2_table(10156) := '3A5C6E283F3A202A283F3A5C6E7C2429292A293F292B2F2C66656E6365733A2F5E207B302C337D28607B332C7D283F3D5B5E605C6E5D2A5C6E297C7E7B332C7D29285B5E5C6E5D2A295C6E283F3A7C285B5C735C535D2A3F295C6E29283F3A207B302C33';
wwv_flow_imp.g_varchar2_table(10157) := '7D5C315B7E605D2A202A283F3D5C6E7C24297C24292F2C68723A2F5E207B302C337D28283F3A2D5B5C74205D2A297B332C7D7C283F3A5F5B205C745D2A297B332C7D7C283F3A5C2A5B205C745D2A297B332C7D29283F3A5C6E2B7C24292F2C6865616469';
wwv_flow_imp.g_varchar2_table(10158) := '6E673A2F5E207B302C337D28237B312C367D29283F3D5C737C2429282E2A29283F3A5C6E2B7C24292F2C626C6F636B71756F74653A2F5E28207B302C337D3E203F287061726167726170687C5B5E5C6E5D2A29283F3A5C6E7C2429292B2F2C6C6973743A';
wwv_flow_imp.g_varchar2_table(10159) := '2F5E28207B302C337D62756C6C29285B205C745D5B5E5C6E5D2B3F293F283F3A5C6E7C24292F2C68746D6C3A225E207B302C337D283F3A3C287363726970747C7072657C7374796C657C7465787461726561295B5C5C733E5D5B5C5C735C5C535D2A3F28';
wwv_flow_imp.g_varchar2_table(10160) := '3F3A3C2F5C5C313E5B5E5C5C6E5D2A5C5C6E2B7C24297C636F6D6D656E745B5E5C5C6E5D2A285C5C6E2B7C24297C3C5C5C3F5B5C5C735C5C535D2A3F283F3A5C5C3F3E5C5C6E2A7C24297C3C215B412D5A5D5B5C5C735C5C535D2A3F283F3A3E5C5C6E2A';
wwv_flow_imp.g_varchar2_table(10161) := '7C24297C3C215C5C5B43444154415C5C5B5B5C5C735C5C535D2A3F283F3A5C5C5D5C5C5D3E5C5C6E2A7C24297C3C2F3F2874616729283F3A202B7C5C5C6E7C2F3F3E295B5C5C735C5C535D2A3F283F3A283F3A5C5C6E202A292B5C5C6E7C24297C3C283F';
wwv_flow_imp.g_varchar2_table(10162) := '217363726970747C7072657C7374796C657C746578746172656129285B612D7A5D5B5C5C772D5D2A29283F3A617474726962757465292A3F202A2F3F3E283F3D5B205C5C745D2A283F3A5C5C6E7C2429295B5C5C735C5C535D2A3F283F3A283F3A5C5C6E';
wwv_flow_imp.g_varchar2_table(10163) := '202A292B5C5C6E7C24297C3C2F283F217363726970747C7072657C7374796C657C7465787461726561295B612D7A5D5B5C5C772D5D2A5C5C732A3E283F3D5B205C5C745D2A283F3A5C5C6E7C2429295B5C5C735C5C535D2A3F283F3A283F3A5C5C6E202A';
wwv_flow_imp.g_varchar2_table(10164) := '292B5C5C6E7C242929222C6465663A2F5E207B302C337D5C5B286C6162656C295C5D3A202A283F3A5C6E202A293F3C3F285B5E5C733E5D2B293E3F283F3A283F3A202B283F3A5C6E202A293F7C202A5C6E202A29287469746C6529293F202A283F3A5C6E';
wwv_flow_imp.g_varchar2_table(10165) := '2B7C24292F2C7461626C653A532C6C68656164696E673A2F5E285B5E5C6E5D2B295C6E207B302C337D283D2B7C2D2B29202A283F3A5C6E2B7C24292F2C5F7061726167726170683A2F5E285B5E5C6E5D2B283F3A5C6E283F2168727C68656164696E677C';
wwv_flow_imp.g_varchar2_table(10166) := '6C68656164696E677C626C6F636B71756F74657C66656E6365737C6C6973747C68746D6C7C7461626C657C202B5C6E295B5E5C6E5D2B292A292F2C746578743A2F5E5B5E5C6E5D2B2F2C5F6C6162656C3A2F283F215C732A5C5D29283F3A5C5C2E7C5B5E';
wwv_flow_imp.g_varchar2_table(10167) := '5C5B5C5D5C5C5D292B2F2C5F7469746C653A2F283F3A22283F3A5C5C223F7C5B5E225C5C5D292A227C275B5E275C6E5D2A283F3A5C6E5B5E275C6E5D2B292A5C6E3F277C5C285B5E28295D2A5C29292F7D3B4D2E6465663D6D284D2E646566292E726570';
wwv_flow_imp.g_varchar2_table(10168) := '6C61636528226C6162656C222C4D2E5F6C6162656C292E7265706C61636528227469746C65222C4D2E5F7469746C65292E676574526567657828292C4D2E62756C6C65743D2F283F3A5B2A2B2D5D7C5C647B312C397D5B2E295D292F2C4D2E6C69737449';
wwv_flow_imp.g_varchar2_table(10169) := '74656D53746172743D6D282F5E28202A292862756C6C29202A2F292E7265706C616365282262756C6C222C4D2E62756C6C6574292E676574526567657828292C4D2E6C6973743D6D284D2E6C697374292E7265706C616365282F62756C6C2F672C4D2E62';
wwv_flow_imp.g_varchar2_table(10170) := '756C6C6574292E7265706C61636528226872222C225C5C6E2B283F3D5C5C313F283F3A283F3A2D202A297B332C7D7C283F3A5F202A297B332C7D7C283F3A5C5C2A202A297B332C7D29283F3A5C5C6E2B7C24292922292E7265706C616365282264656622';
wwv_flow_imp.g_varchar2_table(10171) := '2C225C5C6E2B283F3D222B4D2E6465662E736F757263652B222922292E676574526567657828292C4D2E5F7461673D22616464726573737C61727469636C657C61736964657C626173657C62617365666F6E747C626C6F636B71756F74657C626F64797C';
wwv_flow_imp.g_varchar2_table(10172) := '63617074696F6E7C63656E7465727C636F6C7C636F6C67726F75707C64647C64657461696C737C6469616C6F677C6469727C6469767C646C7C64747C6669656C647365747C66696763617074696F6E7C6669677572657C666F6F7465727C666F726D7C66';
wwv_flow_imp.g_varchar2_table(10173) := '72616D657C6672616D657365747C685B312D365D7C686561647C6865616465727C68727C68746D6C7C696672616D657C6C6567656E647C6C697C6C696E6B7C6D61696E7C6D656E757C6D656E756974656D7C6D6574617C6E61767C6E6F6672616D65737C';
wwv_flow_imp.g_varchar2_table(10174) := '6F6C7C6F707467726F75707C6F7074696F6E7C707C706172616D7C73656374696F6E7C736F757263657C73756D6D6172797C7461626C657C74626F64797C74647C74666F6F747C74687C74686561647C7469746C657C74727C747261636B7C756C222C4D';
wwv_flow_imp.g_varchar2_table(10175) := '2E5F636F6D6D656E743D2F3C212D2D283F212D3F3E295B5C735C535D2A3F283F3A2D2D3E7C24292F2C4D2E68746D6C3D6D284D2E68746D6C2C226922292E7265706C6163652822636F6D6D656E74222C4D2E5F636F6D6D656E74292E7265706C61636528';
wwv_flow_imp.g_varchar2_table(10176) := '22746167222C4D2E5F746167292E7265706C6163652822617474726962757465222C2F202B5B612D7A412D5A3A5F5D5B5C772E3A2D5D2A283F3A202A3D202A225B5E225C6E5D2A227C202A3D202A275B5E275C6E5D2A277C202A3D202A5B5E5C7322273D';
wwv_flow_imp.g_varchar2_table(10177) := '3C3E605D2B293F2F292E676574526567657828292C4D2E7061726167726170683D6D284D2E5F706172616772617068292E7265706C61636528226872222C4D2E6872292E7265706C616365282268656164696E67222C22207B302C337D237B312C367D20';
wwv_flow_imp.g_varchar2_table(10178) := '22292E7265706C61636528227C6C68656164696E67222C2222292E7265706C61636528227C7461626C65222C2222292E7265706C6163652822626C6F636B71756F7465222C22207B302C337D3E22292E7265706C616365282266656E636573222C22207B';
wwv_flow_imp.g_varchar2_table(10179) := '302C337D283F3A607B332C7D283F3D5B5E605C5C6E5D2A5C5C6E297C7E7B332C7D295B5E5C5C6E5D2A5C5C6E22292E7265706C61636528226C697374222C22207B302C337D283F3A5B2A2B2D5D7C315B2E295D292022292E7265706C616365282268746D';
wwv_flow_imp.g_varchar2_table(10180) := '6C222C223C2F3F283F3A74616729283F3A202B7C5C5C6E7C2F3F3E297C3C283F3A7363726970747C7072657C7374796C657C74657874617265617C212D2D2922292E7265706C6163652822746167222C4D2E5F746167292E676574526567657828292C4D';
wwv_flow_imp.g_varchar2_table(10181) := '2E626C6F636B71756F74653D6D284D2E626C6F636B71756F7465292E7265706C6163652822706172616772617068222C4D2E706172616772617068292E676574526567657828292C4D2E6E6F726D616C3D78287B7D2C4D292C4D2E67666D3D78287B7D2C';
wwv_flow_imp.g_varchar2_table(10182) := '4D2E6E6F726D616C2C7B7461626C653A225E202A285B5E5C5C6E205D2E2A5C5C7C2E2A295C5C6E207B302C337D283F3A5C5C7C202A293F283A3F2D2B3A3F202A283F3A5C5C7C202A3A3F2D2B3A3F202A292A29283F3A5C5C7C202A293F283F3A5C5C6E28';
wwv_flow_imp.g_varchar2_table(10183) := '283F3A283F21202A5C5C6E7C68727C68656164696E677C626C6F636B71756F74657C636F64657C66656E6365737C6C6973747C68746D6C292E2A283F3A5C5C6E7C2429292A295C5C6E2A7C2429227D292C4D2E67666D2E7461626C653D6D284D2E67666D';
wwv_flow_imp.g_varchar2_table(10184) := '2E7461626C65292E7265706C61636528226872222C4D2E6872292E7265706C616365282268656164696E67222C22207B302C337D237B312C367D2022292E7265706C6163652822626C6F636B71756F7465222C22207B302C337D3E22292E7265706C6163';
wwv_flow_imp.g_varchar2_table(10185) := '652822636F6465222C22207B347D5B5E5C5C6E5D22292E7265706C616365282266656E636573222C22207B302C337D283F3A607B332C7D283F3D5B5E605C5C6E5D2A5C5C6E297C7E7B332C7D295B5E5C5C6E5D2A5C5C6E22292E7265706C61636528226C';
wwv_flow_imp.g_varchar2_table(10186) := '697374222C22207B302C337D283F3A5B2A2B2D5D7C315B2E295D292022292E7265706C616365282268746D6C222C223C2F3F283F3A74616729283F3A202B7C5C5C6E7C2F3F3E297C3C283F3A7363726970747C7072657C7374796C657C74657874617265';
wwv_flow_imp.g_varchar2_table(10187) := '617C212D2D2922292E7265706C6163652822746167222C4D2E5F746167292E676574526567657828292C4D2E67666D2E7061726167726170683D6D284D2E5F706172616772617068292E7265706C61636528226872222C4D2E6872292E7265706C616365';
wwv_flow_imp.g_varchar2_table(10188) := '282268656164696E67222C22207B302C337D237B312C367D2022292E7265706C61636528227C6C68656164696E67222C2222292E7265706C61636528227461626C65222C4D2E67666D2E7461626C65292E7265706C6163652822626C6F636B71756F7465';
wwv_flow_imp.g_varchar2_table(10189) := '222C22207B302C337D3E22292E7265706C616365282266656E636573222C22207B302C337D283F3A607B332C7D283F3D5B5E605C5C6E5D2A5C5C6E297C7E7B332C7D295B5E5C5C6E5D2A5C5C6E22292E7265706C61636528226C697374222C22207B302C';
wwv_flow_imp.g_varchar2_table(10190) := '337D283F3A5B2A2B2D5D7C315B2E295D292022292E7265706C616365282268746D6C222C223C2F3F283F3A74616729283F3A202B7C5C5C6E7C2F3F3E297C3C283F3A7363726970747C7072657C7374796C657C74657874617265617C212D2D2922292E72';
wwv_flow_imp.g_varchar2_table(10191) := '65706C6163652822746167222C4D2E5F746167292E676574526567657828292C4D2E706564616E7469633D78287B7D2C4D2E6E6F726D616C2C7B68746D6C3A6D28225E202A283F3A636F6D6D656E74202A283F3A5C5C6E7C5C5C732A24297C3C28746167';
wwv_flow_imp.g_varchar2_table(10192) := '295B5C5C735C5C535D2B3F3C2F5C5C313E202A283F3A5C5C6E7B322C7D7C5C5C732A24297C3C746167283F3A5C225B5E5C225D2A5C227C275B5E275D2A277C5C5C735B5E275C222F3E5C5C735D2A292A3F2F3F3E202A283F3A5C5C6E7B322C7D7C5C5C73';
wwv_flow_imp.g_varchar2_table(10193) := '2A24292922292E7265706C6163652822636F6D6D656E74222C4D2E5F636F6D6D656E74292E7265706C616365282F7461672F672C22283F21283F3A617C656D7C7374726F6E677C736D616C6C7C737C636974657C717C64666E7C616262727C646174617C';
wwv_flow_imp.g_varchar2_table(10194) := '74696D657C636F64657C7661727C73616D707C6B62647C7375627C7375707C697C627C757C6D61726B7C727562797C72747C72707C6264697C62646F7C7370616E7C62727C7762727C696E737C64656C7C696D67295C5C62295C5C772B283F213A7C5B5E';
wwv_flow_imp.g_varchar2_table(10195) := '5C5C775C5C73405D2A40295C5C6222292E676574526567657828292C6465663A2F5E202A5C5B285B5E5C5D5D2B295C5D3A202A3C3F285B5E5C733E5D2B293E3F283F3A202B285B22285D5B5E5C6E5D2B5B22295D29293F202A283F3A5C6E2B7C24292F2C';
wwv_flow_imp.g_varchar2_table(10196) := '68656164696E673A2F5E28237B312C367D29282E2A29283F3A5C6E2B7C24292F2C66656E6365733A532C7061726167726170683A6D284D2E6E6F726D616C2E5F706172616772617068292E7265706C61636528226872222C4D2E6872292E7265706C6163';
wwv_flow_imp.g_varchar2_table(10197) := '65282268656164696E67222C22202A237B312C367D202A5B5E5C6E5D22292E7265706C61636528226C68656164696E67222C4D2E6C68656164696E67292E7265706C6163652822626C6F636B71756F7465222C22207B302C337D3E22292E7265706C6163';
wwv_flow_imp.g_varchar2_table(10198) := '6528227C66656E636573222C2222292E7265706C61636528227C6C697374222C2222292E7265706C61636528227C68746D6C222C2222292E676574526567657828297D293B76617220413D7B6573636170653A2F5E5C5C285B2122232425262728292A2B';
wwv_flow_imp.g_varchar2_table(10199) := '2C5C2D2E2F3A3B3C3D3E3F405C5B5C5D5C5C5E5F607B7C7D7E5D292F2C6175746F6C696E6B3A2F5E3C28736368656D653A5B5E5C735C7830302D5C7831663C3E5D2A7C656D61696C293E2F2C75726C3A532C7461673A225E636F6D6D656E747C5E3C2F5B';
wwv_flow_imp.g_varchar2_table(10200) := '612D7A412D5A5D5B5C5C773A2D5D2A5C5C732A3E7C5E3C5B612D7A412D5A5D5B5C5C772D5D2A283F3A617474726962757465292A3F5C5C732A2F3F3E7C5E3C5C5C3F5B5C5C735C5C535D2A3F5C5C3F3E7C5E3C215B612D7A412D5A5D2B5C5C735B5C5C73';
wwv_flow_imp.g_varchar2_table(10201) := '5C5C535D2A3F3E7C5E3C215C5C5B43444154415C5C5B5B5C5C735C5C535D2A3F5C5C5D5C5C5D3E222C6C696E6B3A2F5E213F5C5B286C6162656C295C5D5C285C732A286872656629283F3A5C732B287469746C6529293F5C732A5C292F2C7265666C696E';
wwv_flow_imp.g_varchar2_table(10202) := '6B3A2F5E213F5C5B286C6162656C295C5D5C5B28726566295C5D2F2C6E6F6C696E6B3A2F5E213F5C5B28726566295C5D283F3A5C5B5C5D293F2F2C7265666C696E6B5365617263683A227265666C696E6B7C6E6F6C696E6B283F215C5C2829222C656D53';
wwv_flow_imp.g_varchar2_table(10203) := '74726F6E673A7B6C44656C696D3A2F5E283F3A5C2A2B283F3A285B70756E63745F5D297C5B5E5C732A5D29297C5E5F2B283F3A285B70756E63742A5D297C285B5E5C735F5D29292F2C7244656C696D4173743A2F5E5B5E5F2A5D2A3F5C5F5C5F5B5E5F2A';
wwv_flow_imp.g_varchar2_table(10204) := '5D2A3F5C2A5B5E5F2A5D2A3F283F3D5C5F5C5F297C5B5E2A5D2B283F3D5B5E2A5D297C5B70756E63745F5D285C2A2B29283F3D5B5C735D7C24297C5B5E70756E63742A5F5C735D285C2A2B29283F3D5B70756E63745F5C735D7C24297C5B70756E63745F';
wwv_flow_imp.g_varchar2_table(10205) := '5C735D285C2A2B29283F3D5B5E70756E63742A5F5C735D297C5B5C735D285C2A2B29283F3D5B70756E63745F5D297C5B70756E63745F5D285C2A2B29283F3D5B70756E63745F5D297C5B5E70756E63742A5F5C735D285C2A2B29283F3D5B5E70756E6374';
wwv_flow_imp.g_varchar2_table(10206) := '2A5F5C735D292F2C7244656C696D556E643A2F5E5B5E5F2A5D2A3F5C2A5C2A5B5E5F2A5D2A3F5C5F5B5E5F2A5D2A3F283F3D5C2A5C2A297C5B5E5F5D2B283F3D5B5E5F5D297C5B70756E63742A5D285C5F2B29283F3D5B5C735D7C24297C5B5E70756E63';
wwv_flow_imp.g_varchar2_table(10207) := '742A5F5C735D285C5F2B29283F3D5B70756E63742A5C735D7C24297C5B70756E63742A5C735D285C5F2B29283F3D5B5E70756E63742A5F5C735D297C5B5C735D285C5F2B29283F3D5B70756E63742A5D297C5B70756E63742A5D285C5F2B29283F3D5B70';
wwv_flow_imp.g_varchar2_table(10208) := '756E63742A5D292F7D2C636F64653A2F5E28602B29285B5E605D7C5B5E605D5B5C735C535D2A3F5B5E605D295C31283F2160292F2C62723A2F5E28207B322C7D7C5C5C295C6E283F215C732A24292F2C64656C3A532C746578743A2F5E28602B7C5B5E60';
wwv_flow_imp.g_varchar2_table(10209) := '5D29283F3A283F3D207B322C7D5C6E297C5B5C735C535D2A3F283F3A283F3D5B5C5C3C215C5B602A5F5D7C5C625F7C24297C5B5E205D283F3D207B322C7D5C6E2929292F2C70756E6374756174696F6E3A2F5E285B5C7370756E6374756174696F6E5D29';
wwv_flow_imp.g_varchar2_table(10210) := '2F7D3B66756E6374696F6E204E2865297B72657475726E20652E7265706C616365282F2D2D2D2F672C22E2809422292E7265706C616365282F2D2D2F672C22E2809322292E7265706C616365282F285E7C5B2D5C75323031342F285C5B7B225C735D2927';
wwv_flow_imp.g_varchar2_table(10211) := '2F672C222431E2809822292E7265706C616365282F272F672C22E2809922292E7265706C616365282F285E7C5B2D5C75323031342F285C5B7B5C75323031385C735D29222F672C222431E2809C22292E7265706C616365282F222F672C22E2809D22292E';
wwv_flow_imp.g_varchar2_table(10212) := '7265706C616365282F5C2E7B337D2F672C22E280A622297D66756E6374696F6E20502865297B76617220742C6E2C693D22222C6F3D652E6C656E6774683B666F7228743D303B743C6F3B742B2B296E3D652E63686172436F646541742874292C4D617468';
wwv_flow_imp.g_varchar2_table(10213) := '2E72616E646F6D28293E2E352626286E3D2278222B6E2E746F537472696E6728313629292C692B3D222623222B6E2B223B223B72657475726E20697D412E5F70756E6374756174696F6E3D22215C22232425262728292B5C5C2D2E2C2F3A3B3C3D3E3F40';
wwv_flow_imp.g_varchar2_table(10214) := '5C5C5B5C5C5D605E7B7C7D7E222C412E70756E6374756174696F6E3D6D28412E70756E6374756174696F6E292E7265706C616365282F70756E6374756174696F6E2F672C412E5F70756E6374756174696F6E292E676574526567657828292C412E626C6F';
wwv_flow_imp.g_varchar2_table(10215) := '636B536B69703D2F5C5B5B5E5C5D5D2A3F5C5D5C285B5E5C295D2A3F5C297C605B5E605D2A3F607C3C5B5E3E5D2A3F3E2F672C412E65736361706564456D53743D2F5C5C5C2A7C5C5C5F2F672C412E5F636F6D6D656E743D6D284D2E5F636F6D6D656E74';
wwv_flow_imp.g_varchar2_table(10216) := '292E7265706C6163652822283F3A2D2D5C7833657C2429222C222D2D5C78336522292E676574526567657828292C412E656D5374726F6E672E6C44656C696D3D6D28412E656D5374726F6E672E6C44656C696D292E7265706C616365282F70756E63742F';
wwv_flow_imp.g_varchar2_table(10217) := '672C412E5F70756E6374756174696F6E292E676574526567657828292C412E656D5374726F6E672E7244656C696D4173743D6D28412E656D5374726F6E672E7244656C696D4173742C226722292E7265706C616365282F70756E63742F672C412E5F7075';
wwv_flow_imp.g_varchar2_table(10218) := '6E6374756174696F6E292E676574526567657828292C412E656D5374726F6E672E7244656C696D556E643D6D28412E656D5374726F6E672E7244656C696D556E642C226722292E7265706C616365282F70756E63742F672C412E5F70756E637475617469';
wwv_flow_imp.g_varchar2_table(10219) := '6F6E292E676574526567657828292C412E5F657363617065733D2F5C5C285B2122232425262728292A2B2C5C2D2E2F3A3B3C3D3E3F405C5B5C5D5C5C5E5F607B7C7D7E5D292F672C412E5F736368656D653D2F5B612D7A412D5A5D5B612D7A412D5A302D';
wwv_flow_imp.g_varchar2_table(10220) := '392B2E2D5D7B312C33317D2F2C412E5F656D61696C3D2F5B612D7A412D5A302D392E2123242526272A2B2F3D3F5E5F607B7C7D7E2D5D2B2840295B612D7A412D5A302D395D283F3A5B612D7A412D5A302D392D5D7B302C36317D5B612D7A412D5A302D39';
wwv_flow_imp.g_varchar2_table(10221) := '5D293F283F3A5C2E5B612D7A412D5A302D395D283F3A5B612D7A412D5A302D392D5D7B302C36317D5B612D7A412D5A302D395D293F292B283F215B2D5F5D292F2C412E6175746F6C696E6B3D6D28412E6175746F6C696E6B292E7265706C616365282273';
wwv_flow_imp.g_varchar2_table(10222) := '6368656D65222C412E5F736368656D65292E7265706C6163652822656D61696C222C412E5F656D61696C292E676574526567657828292C412E5F6174747269627574653D2F5C732B5B612D7A412D5A3A5F5D5B5C772E3A2D5D2A283F3A5C732A3D5C732A';
wwv_flow_imp.g_varchar2_table(10223) := '225B5E225D2A227C5C732A3D5C732A275B5E275D2A277C5C732A3D5C732A5B5E5C7322273D3C3E605D2B293F2F2C412E7461673D6D28412E746167292E7265706C6163652822636F6D6D656E74222C412E5F636F6D6D656E74292E7265706C6163652822';
wwv_flow_imp.g_varchar2_table(10224) := '617474726962757465222C412E5F617474726962757465292E676574526567657828292C412E5F6C6162656C3D2F283F3A5C5B283F3A5C5C2E7C5B5E5C5B5C5D5C5C5D292A5C5D7C5C5C2E7C605B5E605D2A607C5B5E5C5B5C5D5C5C605D292A3F2F2C41';
wwv_flow_imp.g_varchar2_table(10225) := '2E5F687265663D2F3C283F3A5C5C2E7C5B5E5C6E3C3E5C5C5D292B3E7C5B5E5C735C7830302D5C7831665D2A2F2C412E5F7469746C653D2F22283F3A5C5C223F7C5B5E225C5C5D292A227C27283F3A5C5C273F7C5B5E275C5C5D292A277C5C28283F3A5C';
wwv_flow_imp.g_varchar2_table(10226) := '5C5C293F7C5B5E295C5C5D292A5C292F2C412E6C696E6B3D6D28412E6C696E6B292E7265706C61636528226C6162656C222C412E5F6C6162656C292E7265706C616365282268726566222C412E5F68726566292E7265706C61636528227469746C65222C';
wwv_flow_imp.g_varchar2_table(10227) := '412E5F7469746C65292E676574526567657828292C412E7265666C696E6B3D6D28412E7265666C696E6B292E7265706C61636528226C6162656C222C412E5F6C6162656C292E7265706C6163652822726566222C4D2E5F6C6162656C292E676574526567';
wwv_flow_imp.g_varchar2_table(10228) := '657828292C412E6E6F6C696E6B3D6D28412E6E6F6C696E6B292E7265706C6163652822726566222C4D2E5F6C6162656C292E676574526567657828292C412E7265666C696E6B5365617263683D6D28412E7265666C696E6B5365617263682C226722292E';
wwv_flow_imp.g_varchar2_table(10229) := '7265706C61636528227265666C696E6B222C412E7265666C696E6B292E7265706C61636528226E6F6C696E6B222C412E6E6F6C696E6B292E676574526567657828292C412E6E6F726D616C3D78287B7D2C41292C412E706564616E7469633D78287B7D2C';
wwv_flow_imp.g_varchar2_table(10230) := '412E6E6F726D616C2C7B7374726F6E673A7B73746172743A2F5E5F5F7C5C2A5C2A2F2C6D6964646C653A2F5E5F5F283F3D5C5329285B5C735C535D2A3F5C53295F5F283F215F297C5E5C2A5C2A283F3D5C5329285B5C735C535D2A3F5C53295C2A5C2A28';
wwv_flow_imp.g_varchar2_table(10231) := '3F215C2A292F2C656E644173743A2F5C2A5C2A283F215C2A292F672C656E64556E643A2F5F5F283F215F292F677D2C656D3A7B73746172743A2F5E5F7C5C2A2F2C6D6964646C653A2F5E28295C2A283F3D5C5329285B5C735C535D2A3F5C53295C2A283F';
wwv_flow_imp.g_varchar2_table(10232) := '215C2A297C5E5F283F3D5C5329285B5C735C535D2A3F5C53295F283F215F292F2C656E644173743A2F5C2A283F215C2A292F672C656E64556E643A2F5F283F215F292F677D2C6C696E6B3A6D282F5E213F5C5B286C6162656C295C5D5C28282E2A3F295C';
wwv_flow_imp.g_varchar2_table(10233) := '292F292E7265706C61636528226C6162656C222C412E5F6C6162656C292E676574526567657828292C7265666C696E6B3A6D282F5E213F5C5B286C6162656C295C5D5C732A5C5B285B5E5C5D5D2A295C5D2F292E7265706C61636528226C6162656C222C';
wwv_flow_imp.g_varchar2_table(10234) := '412E5F6C6162656C292E676574526567657828297D292C412E67666D3D78287B7D2C412E6E6F726D616C2C7B6573636170653A6D28412E657363617065292E7265706C61636528225D29222C227E7C5D2922292E676574526567657828292C5F65787465';
wwv_flow_imp.g_varchar2_table(10235) := '6E6465645F656D61696C3A2F5B412D5A612D7A302D392E5F2B2D5D2B2840295B612D7A412D5A302D392D5F5D2B283F3A5C2E5B612D7A412D5A302D392D5F5D2A5B612D7A412D5A302D395D292B283F215B2D5F5D292F2C75726C3A2F5E28283F3A667470';
wwv_flow_imp.g_varchar2_table(10236) := '7C68747470733F293A5C2F5C2F7C7777775C2E29283F3A5B612D7A412D5A302D395C2D5D2B5C2E3F292B5B5E5C733C5D2A7C5E656D61696C2F2C5F6261636B706564616C3A2F283F3A5B5E3F212E2C3A3B2A5F7E2829265D2B7C5C285B5E295D2A5C297C';
wwv_flow_imp.g_varchar2_table(10237) := '26283F215B612D7A412D5A302D395D2B3B24297C5B3F212E2C3A3B2A5F7E295D2B283F212429292B2F2C64656C3A2F5E287E7E3F29283F3D5B5E5C737E5D29285B5C735C535D2A3F5B5E5C737E5D295C31283F3D5B5E7E5D7C24292F2C746578743A2F5E';
wwv_flow_imp.g_varchar2_table(10238) := '285B607E5D2B7C5B5E607E5D29283F3A283F3D207B322C7D5C6E297C283F3D5B612D7A412D5A302D392E2123242526272A2B5C2F3D3F5F607B5C7C7D7E2D5D2B40297C5B5C735C535D2A3F283F3A283F3D5B5C5C3C215C5B602A7E5F5D7C5C625F7C6874';
wwv_flow_imp.g_varchar2_table(10239) := '7470733F3A5C2F5C2F7C6674703A5C2F5C2F7C7777775C2E7C24297C5B5E205D283F3D207B322C7D5C6E297C5B5E612D7A412D5A302D392E2123242526272A2B5C2F3D3F5F607B5C7C7D7E2D5D283F3D5B612D7A412D5A302D392E2123242526272A2B5C';
wwv_flow_imp.g_varchar2_table(10240) := '2F3D3F5F607B5C7C7D7E2D5D2B402929292F7D292C412E67666D2E75726C3D6D28412E67666D2E75726C2C226922292E7265706C6163652822656D61696C222C412E67666D2E5F657874656E6465645F656D61696C292E676574526567657828292C412E';
wwv_flow_imp.g_varchar2_table(10241) := '627265616B733D78287B7D2C412E67666D2C7B62723A6D28412E6272292E7265706C61636528227B322C7D222C222A22292E676574526567657828292C746578743A6D28412E67666D2E74657874292E7265706C61636528225C5C625F222C225C5C625F';
wwv_flow_imp.g_varchar2_table(10242) := '7C207B322C7D5C5C6E22292E7265706C616365282F5C7B322C5C7D2F672C222A22292E676574526567657828297D293B766172204F3D66756E6374696F6E28297B66756E6374696F6E206E2874297B746869732E746F6B656E733D5B5D2C746869732E74';
wwv_flow_imp.g_varchar2_table(10243) := '6F6B656E732E6C696E6B733D4F626A6563742E637265617465286E756C6C292C746869732E6F7074696F6E733D747C7C652E64656661756C74732C746869732E6F7074696F6E732E746F6B656E697A65723D746869732E6F7074696F6E732E746F6B656E';
wwv_flow_imp.g_varchar2_table(10244) := '697A65727C7C6E657720492C746869732E746F6B656E697A65723D746869732E6F7074696F6E732E746F6B656E697A65722C746869732E746F6B656E697A65722E6F7074696F6E733D746869732E6F7074696F6E732C746869732E746F6B656E697A6572';
wwv_flow_imp.g_varchar2_table(10245) := '2E6C657865723D746869732C746869732E696E6C696E6551756575653D5B5D2C746869732E73746174653D7B696E4C696E6B3A21312C696E526177426C6F636B3A21312C746F703A21307D3B766172206E3D7B626C6F636B3A4D2E6E6F726D616C2C696E';
wwv_flow_imp.g_varchar2_table(10246) := '6C696E653A412E6E6F726D616C7D3B746869732E6F7074696F6E732E706564616E7469633F286E2E626C6F636B3D4D2E706564616E7469632C6E2E696E6C696E653D412E706564616E746963293A746869732E6F7074696F6E732E67666D2626286E2E62';
wwv_flow_imp.g_varchar2_table(10247) := '6C6F636B3D4D2E67666D2C746869732E6F7074696F6E732E627265616B733F6E2E696E6C696E653D412E627265616B733A6E2E696E6C696E653D412E67666D292C746869732E746F6B656E697A65722E72756C65733D6E7D6E2E6C65783D66756E637469';
wwv_flow_imp.g_varchar2_table(10248) := '6F6E28652C74297B72657475726E206E6577206E2874292E6C65782865297D2C6E2E6C6578496E6C696E653D66756E6374696F6E28652C74297B72657475726E206E6577206E2874292E696E6C696E65546F6B656E732865297D3B76617220692C6F2C73';
wwv_flow_imp.g_varchar2_table(10249) := '3D6E2E70726F746F747970653B72657475726E20732E6C65783D66756E6374696F6E2865297B76617220743B666F7228653D652E7265706C616365282F5C725C6E7C5C722F672C225C6E22292C746869732E626C6F636B546F6B656E7328652C74686973';
wwv_flow_imp.g_varchar2_table(10250) := '2E746F6B656E73293B743D746869732E696E6C696E6551756575652E736869667428293B29746869732E696E6C696E65546F6B656E7328742E7372632C742E746F6B656E73293B72657475726E20746869732E746F6B656E737D2C732E626C6F636B546F';
wwv_flow_imp.g_varchar2_table(10251) := '6B656E733D66756E6374696F6E28652C74297B766172206E2C692C6F2C732C723D746869733B666F7228766F696420303D3D3D74262628743D5B5D292C653D746869732E6F7074696F6E732E706564616E7469633F652E7265706C616365282F5C742F67';
wwv_flow_imp.g_varchar2_table(10252) := '2C222020202022292E7265706C616365282F5E202B242F676D2C2222293A652E7265706C616365282F5E28202A29285C742B292F676D2C2866756E6374696F6E28652C742C6E297B72657475726E20742B2220202020222E726570656174286E2E6C656E';
wwv_flow_imp.g_varchar2_table(10253) := '677468297D29293B653B296966282128746869732E6F7074696F6E732E657874656E73696F6E732626746869732E6F7074696F6E732E657874656E73696F6E732E626C6F636B2626746869732E6F7074696F6E732E657874656E73696F6E732E626C6F63';
wwv_flow_imp.g_varchar2_table(10254) := '6B2E736F6D65282866756E6374696F6E2869297B72657475726E2121286E3D692E63616C6C287B6C657865723A727D2C652C742929262628653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E292C2130297D2929';
wwv_flow_imp.g_varchar2_table(10255) := '29296966286E3D746869732E746F6B656E697A65722E737061636528652929653D652E737562737472696E67286E2E7261772E6C656E677468292C313D3D3D6E2E7261772E6C656E6774682626742E6C656E6774683E303F745B742E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(10256) := '5D2E7261772B3D225C6E223A742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E636F646528652929653D652E737562737472696E67286E2E7261772E6C656E677468292C2128693D745B742E6C656E6774682D315D';
wwv_flow_imp.g_varchar2_table(10257) := '297C7C2270617261677261706822213D3D692E747970652626227465787422213D3D692E747970653F742E70757368286E293A28692E7261772B3D225C6E222B6E2E7261772C692E746578742B3D225C6E222B6E2E746578742C746869732E696E6C696E';
wwv_flow_imp.g_varchar2_table(10258) := '6551756575655B746869732E696E6C696E6551756575652E6C656E6774682D315D2E7372633D692E74657874293B656C7365206966286E3D746869732E746F6B656E697A65722E66656E63657328652929653D652E737562737472696E67286E2E726177';
wwv_flow_imp.g_varchar2_table(10259) := '2E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E68656164696E6728652929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966';
wwv_flow_imp.g_varchar2_table(10260) := '286E3D746869732E746F6B656E697A65722E687228652929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E626C6F636B71756F7465286529';
wwv_flow_imp.g_varchar2_table(10261) := '29653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E6C69737428652929653D652E737562737472696E67286E2E7261772E6C656E677468292C';
wwv_flow_imp.g_varchar2_table(10262) := '742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E68746D6C28652929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B65';
wwv_flow_imp.g_varchar2_table(10263) := '6E697A65722E64656628652929653D652E737562737472696E67286E2E7261772E6C656E677468292C2128693D745B742E6C656E6774682D315D297C7C2270617261677261706822213D3D692E747970652626227465787422213D3D692E747970653F74';
wwv_flow_imp.g_varchar2_table(10264) := '6869732E746F6B656E732E6C696E6B735B6E2E7461675D7C7C28746869732E746F6B656E732E6C696E6B735B6E2E7461675D3D7B687265663A6E2E687265662C7469746C653A6E2E7469746C657D293A28692E7261772B3D225C6E222B6E2E7261772C69';
wwv_flow_imp.g_varchar2_table(10265) := '2E746578742B3D225C6E222B6E2E7261772C746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C656E6774682D315D2E7372633D692E74657874293B656C7365206966286E3D746869732E746F6B656E697A65722E74';
wwv_flow_imp.g_varchar2_table(10266) := '61626C6528652929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E6C68656164696E6728652929653D652E737562737472696E67286E2E72';
wwv_flow_imp.g_varchar2_table(10267) := '61772E6C656E677468292C742E70757368286E293B656C7365206966286F3D652C746869732E6F7074696F6E732E657874656E73696F6E732626746869732E6F7074696F6E732E657874656E73696F6E732E7374617274426C6F636B262666756E637469';
wwv_flow_imp.g_varchar2_table(10268) := '6F6E28297B76617220743D312F302C6E3D652E736C6963652831292C693D766F696420303B722E6F7074696F6E732E657874656E73696F6E732E7374617274426C6F636B2E666F7245616368282866756E6374696F6E2865297B226E756D626572223D3D';
wwv_flow_imp.g_varchar2_table(10269) := '747970656F6628693D652E63616C6C287B6C657865723A746869737D2C6E29292626693E3D30262628743D4D6174682E6D696E28742C6929297D29292C743C312F302626743E3D302626286F3D652E737562737472696E6728302C742B3129297D28292C';
wwv_flow_imp.g_varchar2_table(10270) := '746869732E73746174652E746F702626286E3D746869732E746F6B656E697A65722E706172616772617068286F292929693D745B742E6C656E6774682D315D2C73262622706172616772617068223D3D3D692E747970653F28692E7261772B3D225C6E22';
wwv_flow_imp.g_varchar2_table(10271) := '2B6E2E7261772C692E746578742B3D225C6E222B6E2E746578742C746869732E696E6C696E6551756575652E706F7028292C746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C656E6774682D315D2E7372633D692E';
wwv_flow_imp.g_varchar2_table(10272) := '74657874293A742E70757368286E292C733D6F2E6C656E677468213D3D652E6C656E6774682C653D652E737562737472696E67286E2E7261772E6C656E677468293B656C7365206966286E3D746869732E746F6B656E697A65722E746578742865292965';
wwv_flow_imp.g_varchar2_table(10273) := '3D652E737562737472696E67286E2E7261772E6C656E677468292C28693D745B742E6C656E6774682D315D2926262274657874223D3D3D692E747970653F28692E7261772B3D225C6E222B6E2E7261772C692E746578742B3D225C6E222B6E2E74657874';
wwv_flow_imp.g_varchar2_table(10274) := '2C746869732E696E6C696E6551756575652E706F7028292C746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C656E6774682D315D2E7372633D692E74657874293A742E70757368286E293B656C7365206966286529';
wwv_flow_imp.g_varchar2_table(10275) := '7B76617220613D22496E66696E697465206C6F6F70206F6E20627974653A20222B652E63686172436F646541742830293B696628746869732E6F7074696F6E732E73696C656E74297B636F6E736F6C652E6572726F722861293B627265616B7D7468726F';
wwv_flow_imp.g_varchar2_table(10276) := '77206E6577204572726F722861297D72657475726E20746869732E73746174652E746F703D21302C747D2C732E696E6C696E653D66756E6374696F6E28652C74297B72657475726E20766F696420303D3D3D74262628743D5B5D292C746869732E696E6C';
wwv_flow_imp.g_varchar2_table(10277) := '696E6551756575652E70757368287B7372633A652C746F6B656E733A747D292C747D2C732E696E6C696E65546F6B656E733D66756E6374696F6E28652C74297B766172206E2C692C6F2C733D746869733B766F696420303D3D3D74262628743D5B5D293B';
wwv_flow_imp.g_varchar2_table(10278) := '76617220722C612C6C2C633D653B696628746869732E746F6B656E732E6C696E6B73297B76617220643D4F626A6563742E6B65797328746869732E746F6B656E732E6C696E6B73293B696628642E6C656E6774683E3029666F72283B6E756C6C213D2872';
wwv_flow_imp.g_varchar2_table(10279) := '3D746869732E746F6B656E697A65722E72756C65732E696E6C696E652E7265666C696E6B5365617263682E65786563286329293B29642E696E636C7564657328725B305D2E736C69636528725B305D2E6C617374496E6465784F6628225B22292B312C2D';
wwv_flow_imp.g_varchar2_table(10280) := '312929262628633D632E736C69636528302C722E696E646578292B225B222B44282261222C725B305D2E6C656E6774682D32292B225D222B632E736C69636528746869732E746F6B656E697A65722E72756C65732E696E6C696E652E7265666C696E6B53';
wwv_flow_imp.g_varchar2_table(10281) := '65617263682E6C617374496E64657829297D666F72283B6E756C6C213D28723D746869732E746F6B656E697A65722E72756C65732E696E6C696E652E626C6F636B536B69702E65786563286329293B29633D632E736C69636528302C722E696E64657829';
wwv_flow_imp.g_varchar2_table(10282) := '2B225B222B44282261222C725B305D2E6C656E6774682D32292B225D222B632E736C69636528746869732E746F6B656E697A65722E72756C65732E696E6C696E652E626C6F636B536B69702E6C617374496E646578293B666F72283B6E756C6C213D2872';
wwv_flow_imp.g_varchar2_table(10283) := '3D746869732E746F6B656E697A65722E72756C65732E696E6C696E652E65736361706564456D53742E65786563286329293B29633D632E736C69636528302C722E696E646578292B222B2B222B632E736C69636528746869732E746F6B656E697A65722E';
wwv_flow_imp.g_varchar2_table(10284) := '72756C65732E696E6C696E652E65736361706564456D53742E6C617374496E646578293B666F72283B653B29696628617C7C286C3D2222292C613D21312C2128746869732E6F7074696F6E732E657874656E73696F6E732626746869732E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(10285) := '732E657874656E73696F6E732E696E6C696E652626746869732E6F7074696F6E732E657874656E73696F6E732E696E6C696E652E736F6D65282866756E6374696F6E2869297B72657475726E2121286E3D692E63616C6C287B6C657865723A737D2C652C';
wwv_flow_imp.g_varchar2_table(10286) := '742929262628653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E292C2130297D292929296966286E3D746869732E746F6B656E697A65722E65736361706528652929653D652E737562737472696E67286E2E7261';
wwv_flow_imp.g_varchar2_table(10287) := '772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E74616728652929653D652E737562737472696E67286E2E7261772E6C656E677468292C28693D745B742E6C656E6774682D315D29262622';
wwv_flow_imp.g_varchar2_table(10288) := '74657874223D3D3D6E2E7479706526262274657874223D3D3D692E747970653F28692E7261772B3D6E2E7261772C692E746578742B3D6E2E74657874293A742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E6C696E';
wwv_flow_imp.g_varchar2_table(10289) := '6B28652929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E7265666C696E6B28652C746869732E746F6B656E732E6C696E6B732929653D65';
wwv_flow_imp.g_varchar2_table(10290) := '2E737562737472696E67286E2E7261772E6C656E677468292C28693D745B742E6C656E6774682D315D2926262274657874223D3D3D6E2E7479706526262274657874223D3D3D692E747970653F28692E7261772B3D6E2E7261772C692E746578742B3D6E';
wwv_flow_imp.g_varchar2_table(10291) := '2E74657874293A742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E656D5374726F6E6728652C632C6C2929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365';
wwv_flow_imp.g_varchar2_table(10292) := '206966286E3D746869732E746F6B656E697A65722E636F64657370616E28652929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E62722865';
wwv_flow_imp.g_varchar2_table(10293) := '2929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E64656C28652929653D652E737562737472696E67286E2E7261772E6C656E677468292C';
wwv_flow_imp.g_varchar2_table(10294) := '742E70757368286E293B656C7365206966286E3D746869732E746F6B656E697A65722E6175746F6C696E6B28652C502929653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B656C736520696628746869732E';
wwv_flow_imp.g_varchar2_table(10295) := '73746174652E696E4C696E6B7C7C21286E3D746869732E746F6B656E697A65722E75726C28652C502929297B6966286F3D652C746869732E6F7074696F6E732E657874656E73696F6E732626746869732E6F7074696F6E732E657874656E73696F6E732E';
wwv_flow_imp.g_varchar2_table(10296) := '7374617274496E6C696E65262666756E6374696F6E28297B76617220743D312F302C6E3D652E736C6963652831292C693D766F696420303B732E6F7074696F6E732E657874656E73696F6E732E7374617274496E6C696E652E666F724561636828286675';
wwv_flow_imp.g_varchar2_table(10297) := '6E6374696F6E2865297B226E756D626572223D3D747970656F6628693D652E63616C6C287B6C657865723A746869737D2C6E29292626693E3D30262628743D4D6174682E6D696E28742C6929297D29292C743C312F302626743E3D302626286F3D652E73';
wwv_flow_imp.g_varchar2_table(10298) := '7562737472696E6728302C742B3129297D28292C6E3D746869732E746F6B656E697A65722E696E6C696E6554657874286F2C4E2929653D652E737562737472696E67286E2E7261772E6C656E677468292C225F22213D3D6E2E7261772E736C696365282D';
wwv_flow_imp.g_varchar2_table(10299) := '31292626286C3D6E2E7261772E736C696365282D3129292C613D21302C28693D745B742E6C656E6774682D315D2926262274657874223D3D3D692E747970653F28692E7261772B3D6E2E7261772C692E746578742B3D6E2E74657874293A742E70757368';
wwv_flow_imp.g_varchar2_table(10300) := '286E293B656C73652069662865297B76617220683D22496E66696E697465206C6F6F70206F6E20627974653A20222B652E63686172436F646541742830293B696628746869732E6F7074696F6E732E73696C656E74297B636F6E736F6C652E6572726F72';
wwv_flow_imp.g_varchar2_table(10301) := '2868293B627265616B7D7468726F77206E6577204572726F722868297D7D656C736520653D652E737562737472696E67286E2E7261772E6C656E677468292C742E70757368286E293B72657475726E20747D2C693D6E2C6F3D5B7B6B65793A2272756C65';
wwv_flow_imp.g_varchar2_table(10302) := '73222C6765743A66756E6374696F6E28297B72657475726E7B626C6F636B3A4D2C696E6C696E653A417D7D7D5D2C6E756C6C26267428692E70726F746F747970652C6E756C6C292C6F26267428692C6F292C4F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(10303) := '72747928692C2270726F746F74797065222C7B7772697461626C653A21317D292C6E7D28292C523D66756E6374696F6E28297B66756E6374696F6E20742874297B746869732E6F7074696F6E733D747C7C652E64656661756C74737D766172206E3D742E';
wwv_flow_imp.g_varchar2_table(10304) := '70726F746F747970653B72657475726E206E2E636F64653D66756E6374696F6E28652C742C6E297B76617220693D28747C7C2222292E6D61746368282F5C532A2F295B305D3B696628746869732E6F7074696F6E732E686967686C69676874297B766172';
wwv_flow_imp.g_varchar2_table(10305) := '206F3D746869732E6F7074696F6E732E686967686C6967687428652C69293B6E756C6C213D6F26266F213D3D652626286E3D21302C653D6F297D72657475726E20653D652E7265706C616365282F5C6E242F2C2222292B225C6E222C693F273C7072653E';
wwv_flow_imp.g_varchar2_table(10306) := '3C636F646520636C6173733D22272B746869732E6F7074696F6E732E6C616E675072656669782B6828692C2130292B27223E272B286E3F653A6828652C213029292B223C2F636F64653E3C2F7072653E5C6E223A223C7072653E3C636F64653E222B286E';
wwv_flow_imp.g_varchar2_table(10307) := '3F653A6828652C213029292B223C2F636F64653E3C2F7072653E5C6E227D2C6E2E626C6F636B71756F74653D66756E6374696F6E2865297B72657475726E223C626C6F636B71756F74653E5C6E222B652B223C2F626C6F636B71756F74653E5C6E227D2C';
wwv_flow_imp.g_varchar2_table(10308) := '6E2E68746D6C3D66756E6374696F6E2865297B72657475726E20657D2C6E2E68656164696E673D66756E6374696F6E28652C742C6E2C69297B72657475726E20746869732E6F7074696F6E732E6865616465724964733F223C68222B742B272069643D22';
wwv_flow_imp.g_varchar2_table(10309) := '272B28746869732E6F7074696F6E732E6865616465725072656669782B692E736C7567286E29292B27223E272B652B223C2F68222B742B223E5C6E223A223C68222B742B223E222B652B223C2F68222B742B223E5C6E227D2C6E2E68723D66756E637469';
wwv_flow_imp.g_varchar2_table(10310) := '6F6E28297B72657475726E20746869732E6F7074696F6E732E7868746D6C3F223C68722F3E5C6E223A223C68723E5C6E227D2C6E2E6C6973743D66756E6374696F6E28652C742C6E297B76617220693D743F226F6C223A22756C223B72657475726E223C';
wwv_flow_imp.g_varchar2_table(10311) := '222B692B2874262631213D3D6E3F272073746172743D22272B6E2B2722273A2222292B223E5C6E222B652B223C2F222B692B223E5C6E227D2C6E2E6C6973746974656D3D66756E6374696F6E2865297B72657475726E223C6C693E222B652B223C2F6C69';
wwv_flow_imp.g_varchar2_table(10312) := '3E5C6E227D2C6E2E636865636B626F783D66756E6374696F6E2865297B72657475726E223C696E70757420222B28653F27636865636B65643D222220273A2222292B2764697361626C65643D222220747970653D22636865636B626F7822272B28746869';
wwv_flow_imp.g_varchar2_table(10313) := '732E6F7074696F6E732E7868746D6C3F22202F223A2222292B223E20227D2C6E2E7061726167726170683D66756E6374696F6E2865297B72657475726E223C703E222B652B223C2F703E5C6E227D2C6E2E7461626C653D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(10314) := '7B72657475726E2074262628743D223C74626F64793E222B742B223C2F74626F64793E22292C223C7461626C653E5C6E3C74686561643E5C6E222B652B223C2F74686561643E5C6E222B742B223C2F7461626C653E5C6E227D2C6E2E7461626C65726F77';
wwv_flow_imp.g_varchar2_table(10315) := '3D66756E6374696F6E2865297B72657475726E223C74723E5C6E222B652B223C2F74723E5C6E227D2C6E2E7461626C6563656C6C3D66756E6374696F6E28652C74297B766172206E3D742E6865616465723F227468223A227464223B72657475726E2874';
wwv_flow_imp.g_varchar2_table(10316) := '2E616C69676E3F223C222B6E2B2720616C69676E3D22272B742E616C69676E2B27223E273A223C222B6E2B223E22292B652B223C2F222B6E2B223E5C6E227D2C6E2E7374726F6E673D66756E6374696F6E2865297B72657475726E223C7374726F6E673E';
wwv_flow_imp.g_varchar2_table(10317) := '222B652B223C2F7374726F6E673E227D2C6E2E656D3D66756E6374696F6E2865297B72657475726E223C656D3E222B652B223C2F656D3E227D2C6E2E636F64657370616E3D66756E6374696F6E2865297B72657475726E223C636F64653E222B652B223C';
wwv_flow_imp.g_varchar2_table(10318) := '2F636F64653E227D2C6E2E62723D66756E6374696F6E28297B72657475726E20746869732E6F7074696F6E732E7868746D6C3F223C62722F3E223A223C62723E227D2C6E2E64656C3D66756E6374696F6E2865297B72657475726E223C64656C3E222B65';
wwv_flow_imp.g_varchar2_table(10319) := '2B223C2F64656C3E227D2C6E2E6C696E6B3D66756E6374696F6E28652C742C6E297B6966286E756C6C3D3D3D28653D6228746869732E6F7074696F6E732E73616E6974697A652C746869732E6F7074696F6E732E6261736555726C2C6529292972657475';
wwv_flow_imp.g_varchar2_table(10320) := '726E206E3B76617220693D273C6120687265663D22272B682865292B2722273B72657475726E2074262628692B3D27207469746C653D22272B742B272227292C692B223E222B6E2B223C2F613E227D2C6E2E696D6167653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(10321) := '2C6E297B6966286E756C6C3D3D3D28653D6228746869732E6F7074696F6E732E73616E6974697A652C746869732E6F7074696F6E732E6261736555726C2C6529292972657475726E206E3B76617220693D273C696D67207372633D22272B652B27222061';
wwv_flow_imp.g_varchar2_table(10322) := '6C743D22272B6E2B2722273B72657475726E2074262628692B3D27207469746C653D22272B742B272227292C692B28746869732E6F7074696F6E732E7868746D6C3F222F3E223A223E22297D2C6E2E746578743D66756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(10323) := '726E20657D2C747D28292C463D66756E6374696F6E28297B66756E6374696F6E206528297B7D76617220743D652E70726F746F747970653B72657475726E20742E7374726F6E673D66756E6374696F6E2865297B72657475726E20657D2C742E656D3D66';
wwv_flow_imp.g_varchar2_table(10324) := '756E6374696F6E2865297B72657475726E20657D2C742E636F64657370616E3D66756E6374696F6E2865297B72657475726E20657D2C742E64656C3D66756E6374696F6E2865297B72657475726E20657D2C742E68746D6C3D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(10325) := '7B72657475726E20657D2C742E746578743D66756E6374696F6E2865297B72657475726E20657D2C742E6C696E6B3D66756E6374696F6E28652C742C6E297B72657475726E22222B6E7D2C742E696D6167653D66756E6374696F6E28652C742C6E297B72';
wwv_flow_imp.g_varchar2_table(10326) := '657475726E22222B6E7D2C742E62723D66756E6374696F6E28297B72657475726E22227D2C657D28292C423D66756E6374696F6E28297B66756E6374696F6E206528297B746869732E7365656E3D7B7D7D76617220743D652E70726F746F747970653B72';
wwv_flow_imp.g_varchar2_table(10327) := '657475726E20742E73657269616C697A653D66756E6374696F6E2865297B72657475726E20652E746F4C6F7765724361736528292E7472696D28292E7265706C616365282F3C5B215C2F612D7A5D2E2A3F3E2F67692C2222292E7265706C616365282F5B';
wwv_flow_imp.g_varchar2_table(10328) := '5C75323030302D5C75323036465C75324530302D5C75324537465C5C2721222324252628292A2B2C2E2F3A3B3C3D3E3F405B5C5D5E607B7C7D7E5D2F672C2222292E7265706C616365282F5C732F672C222D22297D2C742E6765744E6578745361666553';
wwv_flow_imp.g_varchar2_table(10329) := '6C75673D66756E6374696F6E28652C74297B766172206E3D652C693D303B696628746869732E7365656E2E6861734F776E50726F7065727479286E29297B693D746869732E7365656E5B655D3B646F7B6E3D652B222D222B202B2B697D7768696C652874';
wwv_flow_imp.g_varchar2_table(10330) := '6869732E7365656E2E6861734F776E50726F7065727479286E29297D72657475726E20747C7C28746869732E7365656E5B655D3D692C746869732E7365656E5B6E5D3D30292C6E7D2C742E736C75673D66756E6374696F6E28652C74297B766F69642030';
wwv_flow_imp.g_varchar2_table(10331) := '3D3D3D74262628743D7B7D293B766172206E3D746869732E73657269616C697A652865293B72657475726E20746869732E6765744E65787453616665536C7567286E2C742E64727972756E297D2C657D28292C563D66756E6374696F6E28297B66756E63';
wwv_flow_imp.g_varchar2_table(10332) := '74696F6E20742874297B746869732E6F7074696F6E733D747C7C652E64656661756C74732C746869732E6F7074696F6E732E72656E64657265723D746869732E6F7074696F6E732E72656E64657265727C7C6E657720522C746869732E72656E64657265';
wwv_flow_imp.g_varchar2_table(10333) := '723D746869732E6F7074696F6E732E72656E64657265722C746869732E72656E64657265722E6F7074696F6E733D746869732E6F7074696F6E732C746869732E7465787452656E64657265723D6E657720462C746869732E736C75676765723D6E657720';
wwv_flow_imp.g_varchar2_table(10334) := '427D742E70617273653D66756E6374696F6E28652C6E297B72657475726E206E65772074286E292E70617273652865297D2C742E7061727365496E6C696E653D66756E6374696F6E28652C6E297B72657475726E206E65772074286E292E706172736549';
wwv_flow_imp.g_varchar2_table(10335) := '6E6C696E652865297D3B766172206E3D742E70726F746F747970653B72657475726E206E2E70617273653D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D2130293B766172206E2C692C6F2C732C722C612C6C2C632C642C682C';
wwv_flow_imp.g_varchar2_table(10336) := '752C672C6D2C662C762C622C5F2C792C772C433D22222C533D652E6C656E6774683B666F72286E3D303B6E3C533B6E2B2B29696628683D655B6E5D2C2128746869732E6F7074696F6E732E657874656E73696F6E732626746869732E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(10337) := '657874656E73696F6E732E72656E6465726572732626746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465726572735B682E747970655D297C7C21313D3D3D28773D746869732E6F7074696F6E732E657874656E73696F6E732E7265';
wwv_flow_imp.g_varchar2_table(10338) := '6E6465726572735B682E747970655D2E63616C6C287B7061727365723A746869737D2C68292926265B227370616365222C226872222C2268656164696E67222C22636F6465222C227461626C65222C22626C6F636B71756F7465222C226C697374222C22';
wwv_flow_imp.g_varchar2_table(10339) := '68746D6C222C22706172616772617068222C2274657874225D2E696E636C7564657328682E74797065292973776974636828682E74797065297B63617365227370616365223A636F6E74696E75653B63617365226872223A432B3D746869732E72656E64';
wwv_flow_imp.g_varchar2_table(10340) := '657265722E687228293B636F6E74696E75653B636173652268656164696E67223A432B3D746869732E72656E64657265722E68656164696E6728746869732E7061727365496E6C696E6528682E746F6B656E73292C682E64657074682C7028746869732E';
wwv_flow_imp.g_varchar2_table(10341) := '7061727365496E6C696E6528682E746F6B656E732C746869732E7465787452656E646572657229292C746869732E736C7567676572293B636F6E74696E75653B6361736522636F6465223A432B3D746869732E72656E64657265722E636F646528682E74';
wwv_flow_imp.g_varchar2_table(10342) := '6578742C682E6C616E672C682E65736361706564293B636F6E74696E75653B63617365227461626C65223A666F7228633D22222C6C3D22222C733D682E6865616465722E6C656E6774682C693D303B693C733B692B2B296C2B3D746869732E72656E6465';
wwv_flow_imp.g_varchar2_table(10343) := '7265722E7461626C6563656C6C28746869732E7061727365496E6C696E6528682E6865616465725B695D2E746F6B656E73292C7B6865616465723A21302C616C69676E3A682E616C69676E5B695D7D293B666F7228632B3D746869732E72656E64657265';
wwv_flow_imp.g_varchar2_table(10344) := '722E7461626C65726F77286C292C643D22222C733D682E726F77732E6C656E6774682C693D303B693C733B692B2B297B666F72286C3D22222C723D28613D682E726F77735B695D292E6C656E6774682C6F3D303B6F3C723B6F2B2B296C2B3D746869732E';
wwv_flow_imp.g_varchar2_table(10345) := '72656E64657265722E7461626C6563656C6C28746869732E7061727365496E6C696E6528615B6F5D2E746F6B656E73292C7B6865616465723A21312C616C69676E3A682E616C69676E5B6F5D7D293B642B3D746869732E72656E64657265722E7461626C';
wwv_flow_imp.g_varchar2_table(10346) := '65726F77286C297D432B3D746869732E72656E64657265722E7461626C6528632C64293B636F6E74696E75653B6361736522626C6F636B71756F7465223A643D746869732E706172736528682E746F6B656E73292C432B3D746869732E72656E64657265';
wwv_flow_imp.g_varchar2_table(10347) := '722E626C6F636B71756F74652864293B636F6E74696E75653B63617365226C697374223A666F7228753D682E6F7264657265642C673D682E73746172742C6D3D682E6C6F6F73652C733D682E6974656D732E6C656E6774682C643D22222C693D303B693C';
wwv_flow_imp.g_varchar2_table(10348) := '733B692B2B29623D28763D682E6974656D735B695D292E636865636B65642C5F3D762E7461736B2C663D22222C762E7461736B262628793D746869732E72656E64657265722E636865636B626F782862292C6D3F762E746F6B656E732E6C656E6774683E';
wwv_flow_imp.g_varchar2_table(10349) := '30262622706172616772617068223D3D3D762E746F6B656E735B305D2E747970653F28762E746F6B656E735B305D2E746578743D792B2220222B762E746F6B656E735B305D2E746578742C762E746F6B656E735B305D2E746F6B656E732626762E746F6B';
wwv_flow_imp.g_varchar2_table(10350) := '656E735B305D2E746F6B656E732E6C656E6774683E3026262274657874223D3D3D762E746F6B656E735B305D2E746F6B656E735B305D2E74797065262628762E746F6B656E735B305D2E746F6B656E735B305D2E746578743D792B2220222B762E746F6B';
wwv_flow_imp.g_varchar2_table(10351) := '656E735B305D2E746F6B656E735B305D2E7465787429293A762E746F6B656E732E756E7368696674287B747970653A2274657874222C746578743A797D293A662B3D79292C662B3D746869732E706172736528762E746F6B656E732C6D292C642B3D7468';
wwv_flow_imp.g_varchar2_table(10352) := '69732E72656E64657265722E6C6973746974656D28662C5F2C62293B432B3D746869732E72656E64657265722E6C69737428642C752C67293B636F6E74696E75653B636173652268746D6C223A432B3D746869732E72656E64657265722E68746D6C2868';
wwv_flow_imp.g_varchar2_table(10353) := '2E74657874293B636F6E74696E75653B6361736522706172616772617068223A432B3D746869732E72656E64657265722E70617261677261706828746869732E7061727365496E6C696E6528682E746F6B656E7329293B636F6E74696E75653B63617365';
wwv_flow_imp.g_varchar2_table(10354) := '2274657874223A666F7228643D682E746F6B656E733F746869732E7061727365496E6C696E6528682E746F6B656E73293A682E746578743B6E2B313C5326262274657874223D3D3D655B6E2B315D2E747970653B29642B3D225C6E222B2828683D655B2B';
wwv_flow_imp.g_varchar2_table(10355) := '2B6E5D292E746F6B656E733F746869732E7061727365496E6C696E6528682E746F6B656E73293A682E74657874293B432B3D743F746869732E72656E64657265722E7061726167726170682864293A643B636F6E74696E75653B64656661756C743A7661';
wwv_flow_imp.g_varchar2_table(10356) := '7220783D27546F6B656E20776974682022272B682E747970652B2722207479706520776173206E6F7420666F756E642E273B696628746869732E6F7074696F6E732E73696C656E742972657475726E20766F696420636F6E736F6C652E6572726F722878';
wwv_flow_imp.g_varchar2_table(10357) := '293B7468726F77206E6577204572726F722878297D656C736520432B3D777C7C22223B72657475726E20437D2C6E2E7061727365496E6C696E653D66756E6374696F6E28652C74297B743D747C7C746869732E72656E64657265723B766172206E2C692C';
wwv_flow_imp.g_varchar2_table(10358) := '6F2C733D22222C723D652E6C656E6774683B666F72286E3D303B6E3C723B6E2B2B29696628693D655B6E5D2C2128746869732E6F7074696F6E732E657874656E73696F6E732626746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465';
wwv_flow_imp.g_varchar2_table(10359) := '726572732626746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465726572735B692E747970655D297C7C21313D3D3D286F3D746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465726572735B692E747970655D2E';
wwv_flow_imp.g_varchar2_table(10360) := '63616C6C287B7061727365723A746869737D2C69292926265B22657363617065222C2268746D6C222C226C696E6B222C22696D616765222C227374726F6E67222C22656D222C22636F64657370616E222C226272222C2264656C222C2274657874225D2E';
wwv_flow_imp.g_varchar2_table(10361) := '696E636C7564657328692E74797065292973776974636828692E74797065297B6361736522657363617065223A636173652274657874223A732B3D742E7465787428692E74657874293B627265616B3B636173652268746D6C223A732B3D742E68746D6C';
wwv_flow_imp.g_varchar2_table(10362) := '28692E74657874293B627265616B3B63617365226C696E6B223A732B3D742E6C696E6B28692E687265662C692E7469746C652C746869732E7061727365496E6C696E6528692E746F6B656E732C7429293B627265616B3B6361736522696D616765223A73';
wwv_flow_imp.g_varchar2_table(10363) := '2B3D742E696D61676528692E687265662C692E7469746C652C692E74657874293B627265616B3B63617365227374726F6E67223A732B3D742E7374726F6E6728746869732E7061727365496E6C696E6528692E746F6B656E732C7429293B627265616B3B';
wwv_flow_imp.g_varchar2_table(10364) := '6361736522656D223A732B3D742E656D28746869732E7061727365496E6C696E6528692E746F6B656E732C7429293B627265616B3B6361736522636F64657370616E223A732B3D742E636F64657370616E28692E74657874293B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(10365) := '226272223A732B3D742E627228293B627265616B3B636173652264656C223A732B3D742E64656C28746869732E7061727365496E6C696E6528692E746F6B656E732C7429293B627265616B3B64656661756C743A76617220613D27546F6B656E20776974';
wwv_flow_imp.g_varchar2_table(10366) := '682022272B692E747970652B2722207479706520776173206E6F7420666F756E642E273B696628746869732E6F7074696F6E732E73696C656E742972657475726E20766F696420636F6E736F6C652E6572726F722861293B7468726F77206E6577204572';
wwv_flow_imp.g_varchar2_table(10367) := '726F722861297D656C736520732B3D6F7C7C22223B72657475726E20737D2C747D28293B66756E6374696F6E207A28652C742C6E297B6966286E756C6C3D3D65297468726F77206E6577204572726F7228226D61726B656428293A20696E707574207061';
wwv_flow_imp.g_varchar2_table(10368) := '72616D6574657220697320756E646566696E6564206F72206E756C6C22293B69662822737472696E6722213D747970656F662065297468726F77206E6577204572726F7228226D61726B656428293A20696E70757420706172616D65746572206973206F';
wwv_flow_imp.g_varchar2_table(10369) := '66207479706520222B4F626A6563742E70726F746F747970652E746F537472696E672E63616C6C2865292B222C20737472696E6720657870656374656422293B6966282266756E6374696F6E223D3D747970656F6620742626286E3D742C743D6E756C6C';
wwv_flow_imp.g_varchar2_table(10370) := '292C4C28743D78287B7D2C7A2E64656661756C74732C747C7C7B7D29292C6E297B76617220692C6F3D742E686967686C696768743B7472797B693D4F2E6C657828652C74297D63617463682865297B72657475726E206E2865297D76617220733D66756E';
wwv_flow_imp.g_varchar2_table(10371) := '6374696F6E2865297B76617220733B6966282165297472797B742E77616C6B546F6B656E7326267A2E77616C6B546F6B656E7328692C742E77616C6B546F6B656E73292C733D562E706172736528692C74297D63617463682874297B653D747D72657475';
wwv_flow_imp.g_varchar2_table(10372) := '726E20742E686967686C696768743D6F2C653F6E2865293A6E286E756C6C2C73297D3B696628216F7C7C6F2E6C656E6774683C332972657475726E207328293B69662864656C65746520742E686967686C696768742C21692E6C656E6774682972657475';
wwv_flow_imp.g_varchar2_table(10373) := '726E207328293B76617220723D303B72657475726E207A2E77616C6B546F6B656E7328692C2866756E6374696F6E2865297B22636F6465223D3D3D652E74797065262628722B2B2C73657454696D656F7574282866756E6374696F6E28297B6F28652E74';
wwv_flow_imp.g_varchar2_table(10374) := '6578742C652E6C616E672C2866756E6374696F6E28742C6E297B696628742972657475726E20732874293B6E756C6C213D6E26266E213D3D652E74657874262628652E746578743D6E2C652E657363617065643D2130292C303D3D2D2D7226267328297D';
wwv_flow_imp.g_varchar2_table(10375) := '29297D292C3029297D29292C766F696428303D3D3D722626732829297D66756E6374696F6E20612865297B696628652E6D6573736167652B3D225C6E506C65617365207265706F7274207468697320746F2068747470733A2F2F6769746875622E636F6D';
wwv_flow_imp.g_varchar2_table(10376) := '2F6D61726B65646A732F6D61726B65642E222C742E73696C656E742972657475726E223C703E416E206572726F72206F636375727265643A3C2F703E3C7072653E222B6828652E6D6573736167652B22222C2130292B223C2F7072653E223B7468726F77';
wwv_flow_imp.g_varchar2_table(10377) := '20657D7472797B766172206C3D4F2E6C657828652C74293B696628742E77616C6B546F6B656E73297B696628742E6173796E632972657475726E2050726F6D6973652E616C6C287A2E77616C6B546F6B656E73286C2C742E77616C6B546F6B656E732929';
wwv_flow_imp.g_varchar2_table(10378) := '2E7468656E282866756E6374696F6E28297B72657475726E20562E7061727365286C2C74297D29292E63617463682861293B7A2E77616C6B546F6B656E73286C2C742E77616C6B546F6B656E73297D72657475726E20562E7061727365286C2C74297D63';
wwv_flow_imp.g_varchar2_table(10379) := '617463682865297B612865297D7D7A2E6F7074696F6E733D7A2E7365744F7074696F6E733D66756E6374696F6E2874297B766172206E3B72657475726E2078287A2E64656661756C74732C74292C6E3D7A2E64656661756C74732C652E64656661756C74';
wwv_flow_imp.g_varchar2_table(10380) := '733D6E2C7A7D2C7A2E67657444656661756C74733D6F2C7A2E64656661756C74733D652E64656661756C74732C7A2E7573653D66756E6374696F6E28297B666F722876617220653D617267756D656E74732E6C656E6774682C743D6E6577204172726179';
wwv_flow_imp.g_varchar2_table(10381) := '2865292C6E3D303B6E3C653B6E2B2B29745B6E5D3D617267756D656E74735B6E5D3B76617220692C6F3D782E6170706C7928766F696420302C5B7B7D5D2E636F6E636174287429292C733D7A2E64656661756C74732E657874656E73696F6E737C7C7B72';
wwv_flow_imp.g_varchar2_table(10382) := '656E6465726572733A7B7D2C6368696C64546F6B656E733A7B7D7D3B742E666F7245616368282866756E6374696F6E2865297B696628652E657874656E73696F6E73262628693D21302C652E657874656E73696F6E732E666F7245616368282866756E63';
wwv_flow_imp.g_varchar2_table(10383) := '74696F6E2865297B69662821652E6E616D65297468726F77206E6577204572726F722822657874656E73696F6E206E616D6520726571756972656422293B696628652E72656E6465726572297B76617220743D732E72656E6465726572733F732E72656E';
wwv_flow_imp.g_varchar2_table(10384) := '6465726572735B652E6E616D655D3A6E756C6C3B732E72656E6465726572735B652E6E616D655D3D743F66756E6374696F6E28297B666F7228766172206E3D617267756D656E74732E6C656E6774682C693D6E6577204172726179286E292C6F3D303B6F';
wwv_flow_imp.g_varchar2_table(10385) := '3C6E3B6F2B2B29695B6F5D3D617267756D656E74735B6F5D3B76617220733D652E72656E64657265722E6170706C7928746869732C69293B72657475726E21313D3D3D73262628733D742E6170706C7928746869732C6929292C737D3A652E72656E6465';
wwv_flow_imp.g_varchar2_table(10386) := '7265727D696628652E746F6B656E697A6572297B69662821652E6C6576656C7C7C22626C6F636B22213D3D652E6C6576656C262622696E6C696E6522213D3D652E6C6576656C297468726F77206E6577204572726F722822657874656E73696F6E206C65';
wwv_flow_imp.g_varchar2_table(10387) := '76656C206D7573742062652027626C6F636B27206F722027696E6C696E652722293B735B652E6C6576656C5D3F735B652E6C6576656C5D2E756E736869667428652E746F6B656E697A6572293A735B652E6C6576656C5D3D5B652E746F6B656E697A6572';
wwv_flow_imp.g_varchar2_table(10388) := '5D2C652E737461727426262822626C6F636B223D3D3D652E6C6576656C3F732E7374617274426C6F636B3F732E7374617274426C6F636B2E7075736828652E7374617274293A732E7374617274426C6F636B3D5B652E73746172745D3A22696E6C696E65';
wwv_flow_imp.g_varchar2_table(10389) := '223D3D3D652E6C6576656C262628732E7374617274496E6C696E653F732E7374617274496E6C696E652E7075736828652E7374617274293A732E7374617274496E6C696E653D5B652E73746172745D29297D652E6368696C64546F6B656E73262628732E';
wwv_flow_imp.g_varchar2_table(10390) := '6368696C64546F6B656E735B652E6E616D655D3D652E6368696C64546F6B656E73297D2929292C652E72656E6465726572262666756E6374696F6E28297B76617220743D7A2E64656661756C74732E72656E64657265727C7C6E657720522C6E3D66756E';
wwv_flow_imp.g_varchar2_table(10391) := '6374696F6E286E297B76617220693D745B6E5D3B745B6E5D3D66756E6374696F6E28297B666F7228766172206F3D617267756D656E74732E6C656E6774682C733D6E6577204172726179286F292C723D303B723C6F3B722B2B29735B725D3D617267756D';
wwv_flow_imp.g_varchar2_table(10392) := '656E74735B725D3B76617220613D652E72656E64657265725B6E5D2E6170706C7928742C73293B72657475726E21313D3D3D61262628613D692E6170706C7928742C7329292C617D7D3B666F7228766172206920696E20652E72656E6465726572296E28';
wwv_flow_imp.g_varchar2_table(10393) := '69293B6F2E72656E64657265723D747D28292C652E746F6B656E697A6572262666756E6374696F6E28297B76617220743D7A2E64656661756C74732E746F6B656E697A65727C7C6E657720492C6E3D66756E6374696F6E286E297B76617220693D745B6E';
wwv_flow_imp.g_varchar2_table(10394) := '5D3B745B6E5D3D66756E6374696F6E28297B666F7228766172206F3D617267756D656E74732E6C656E6774682C733D6E6577204172726179286F292C723D303B723C6F3B722B2B29735B725D3D617267756D656E74735B725D3B76617220613D652E746F';
wwv_flow_imp.g_varchar2_table(10395) := '6B656E697A65725B6E5D2E6170706C7928742C73293B72657475726E21313D3D3D61262628613D692E6170706C7928742C7329292C617D7D3B666F7228766172206920696E20652E746F6B656E697A6572296E2869293B6F2E746F6B656E697A65723D74';
wwv_flow_imp.g_varchar2_table(10396) := '7D28292C652E77616C6B546F6B656E73297B76617220743D7A2E64656661756C74732E77616C6B546F6B656E733B6F2E77616C6B546F6B656E733D66756E6374696F6E286E297B76617220693D5B5D3B72657475726E20692E7075736828652E77616C6B';
wwv_flow_imp.g_varchar2_table(10397) := '546F6B656E732E63616C6C28746869732C6E29292C74262628693D692E636F6E63617428742E63616C6C28746869732C6E2929292C697D7D692626286F2E657874656E73696F6E733D73292C7A2E7365744F7074696F6E73286F297D29297D2C7A2E7761';
wwv_flow_imp.g_varchar2_table(10398) := '6C6B546F6B656E733D66756E6374696F6E28652C74297B666F7228766172206E2C6F3D5B5D2C733D66756E6374696F6E28297B76617220653D6E2E76616C75653B737769746368286F3D6F2E636F6E63617428742E63616C6C287A2C6529292C652E7479';
wwv_flow_imp.g_varchar2_table(10399) := '7065297B63617365227461626C65223A666F722876617220732C723D6928652E686561646572293B2128733D722829292E646F6E653B297B76617220613D732E76616C75653B6F3D6F2E636F6E636174287A2E77616C6B546F6B656E7328612E746F6B65';
wwv_flow_imp.g_varchar2_table(10400) := '6E732C7429297D666F7228766172206C2C633D6928652E726F7773293B21286C3D632829292E646F6E653B29666F722876617220642C683D69286C2E76616C7565293B2128643D682829292E646F6E653B297B76617220753D642E76616C75653B6F3D6F';
wwv_flow_imp.g_varchar2_table(10401) := '2E636F6E636174287A2E77616C6B546F6B656E7328752E746F6B656E732C7429297D627265616B3B63617365226C697374223A6F3D6F2E636F6E636174287A2E77616C6B546F6B656E7328652E6974656D732C7429293B627265616B3B64656661756C74';
wwv_flow_imp.g_varchar2_table(10402) := '3A7A2E64656661756C74732E657874656E73696F6E7326267A2E64656661756C74732E657874656E73696F6E732E6368696C64546F6B656E7326267A2E64656661756C74732E657874656E73696F6E732E6368696C64546F6B656E735B652E747970655D';
wwv_flow_imp.g_varchar2_table(10403) := '3F7A2E64656661756C74732E657874656E73696F6E732E6368696C64546F6B656E735B652E747970655D2E666F7245616368282866756E6374696F6E286E297B6F3D6F2E636F6E636174287A2E77616C6B546F6B656E7328655B6E5D2C7429297D29293A';
wwv_flow_imp.g_varchar2_table(10404) := '652E746F6B656E732626286F3D6F2E636F6E636174287A2E77616C6B546F6B656E7328652E746F6B656E732C742929297D7D2C723D692865293B21286E3D722829292E646F6E653B297328293B72657475726E206F7D2C7A2E7061727365496E6C696E65';
wwv_flow_imp.g_varchar2_table(10405) := '3D66756E6374696F6E28652C74297B6966286E756C6C3D3D65297468726F77206E6577204572726F7228226D61726B65642E7061727365496E6C696E6528293A20696E70757420706172616D6574657220697320756E646566696E6564206F72206E756C';
wwv_flow_imp.g_varchar2_table(10406) := '6C22293B69662822737472696E6722213D747970656F662065297468726F77206E6577204572726F7228226D61726B65642E7061727365496E6C696E6528293A20696E70757420706172616D65746572206973206F66207479706520222B4F626A656374';
wwv_flow_imp.g_varchar2_table(10407) := '2E70726F746F747970652E746F537472696E672E63616C6C2865292B222C20737472696E6720657870656374656422293B4C28743D78287B7D2C7A2E64656661756C74732C747C7C7B7D29293B7472797B766172206E3D4F2E6C6578496E6C696E652865';
wwv_flow_imp.g_varchar2_table(10408) := '2C74293B72657475726E20742E77616C6B546F6B656E7326267A2E77616C6B546F6B656E73286E2C742E77616C6B546F6B656E73292C562E7061727365496E6C696E65286E2C74297D63617463682865297B696628652E6D6573736167652B3D225C6E50';
wwv_flow_imp.g_varchar2_table(10409) := '6C65617365207265706F7274207468697320746F2068747470733A2F2F6769746875622E636F6D2F6D61726B65646A732F6D61726B65642E222C742E73696C656E742972657475726E223C703E416E206572726F72206F636375727265643A3C2F703E3C';
wwv_flow_imp.g_varchar2_table(10410) := '7072653E222B6828652E6D6573736167652B22222C2130292B223C2F7072653E223B7468726F7720657D7D2C7A2E5061727365723D562C7A2E7061727365723D562E70617273652C7A2E52656E64657265723D522C7A2E5465787452656E64657265723D';
wwv_flow_imp.g_varchar2_table(10411) := '462C7A2E4C657865723D4F2C7A2E6C657865723D4F2E6C65782C7A2E546F6B656E697A65723D492C7A2E536C75676765723D422C7A2E70617273653D7A3B76617220483D7A2E6F7074696F6E732C573D7A2E7365744F7074696F6E732C6A3D7A2E757365';
wwv_flow_imp.g_varchar2_table(10412) := '2C713D7A2E77616C6B546F6B656E732C243D7A2E7061727365496E6C696E652C553D7A2C4B3D562E70617273652C473D4F2E6C65783B652E4C657865723D4F2C652E5061727365723D562C652E52656E64657265723D522C652E536C75676765723D422C';
wwv_flow_imp.g_varchar2_table(10413) := '652E5465787452656E64657265723D462C652E546F6B656E697A65723D492C652E67657444656661756C74733D6F2C652E6C657865723D472C652E6D61726B65643D7A2C652E6F7074696F6E733D482C652E70617273653D552C652E7061727365496E6C';
wwv_flow_imp.g_varchar2_table(10414) := '696E653D242C652E7061727365723D4B2C652E7365744F7074696F6E733D572C652E7573653D6A2C652E77616C6B546F6B656E733D712C4F626A6563742E646566696E6550726F706572747928652C225F5F65734D6F64756C65222C7B76616C75653A21';
wwv_flow_imp.g_varchar2_table(10415) := '307D297D2C652E616D643F6528302C6E293A226F626A656374223D3D747970656F66206578706F7274733F6E286578706F727473293A6E2828743D22756E646566696E656422213D747970656F6620676C6F62616C546869733F676C6F62616C54686973';
wwv_flow_imp.g_varchar2_table(10416) := '3A747C7C73656C66292E6D61726B65643D7B7D297D28292C4C6B2E4C657865727C7C6578706F7274732E4C657865722C4C6B2E5061727365727C7C6578706F7274732E5061727365722C4C6B2E52656E64657265727C7C6578706F7274732E52656E6465';
wwv_flow_imp.g_varchar2_table(10417) := '7265722C4C6B2E536C75676765727C7C6578706F7274732E536C75676765722C4C6B2E5465787452656E64657265727C7C6578706F7274732E5465787452656E64657265722C4C6B2E546F6B656E697A65727C7C6578706F7274732E546F6B656E697A65';
wwv_flow_imp.g_varchar2_table(10418) := '722C4C6B2E67657444656661756C74737C7C6578706F7274732E67657444656661756C74732C4C6B2E6C657865727C7C6578706F7274732E6C657865723B76617220446B3D4C6B2E6D61726B65647C7C6578706F7274732E6D61726B65643B66756E6374';
wwv_flow_imp.g_varchar2_table(10419) := '696F6E20546B2865297B6C657420743D4A534F4E2E70617273652865293B72657475726E20743D4D6B2874292C747D66756E6374696F6E20496B28652C74297B72657475726E207420696E7374616E63656F66205265674578703F7B246D69643A322C73';
wwv_flow_imp.g_varchar2_table(10420) := '6F757263653A742E736F757263652C666C6167733A742E666C6167737D3A747D66756E6374696F6E204D6B28652C743D30297B69662821657C7C743E3230302972657475726E20653B696628226F626A656374223D3D747970656F662065297B73776974';
wwv_flow_imp.g_varchar2_table(10421) := '636828652E246D6964297B6361736520313A72657475726E204E6F2E7265766976652865293B6361736520323A72657475726E206E65772052656745787028652E736F757263652C652E666C616773293B636173652031373A72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(10422) := '4461746528652E736F75726365297D6966286520696E7374616E63656F66204B757C7C6520696E7374616E63656F662055696E743841727261792972657475726E20653B69662841727261792E6973417272617928652929666F72286C6574206E3D303B';
wwv_flow_imp.g_varchar2_table(10423) := '6E3C652E6C656E6774683B2B2B6E29655B6E5D3D4D6B28655B6E5D2C742B31293B656C736520666F7228636F6E7374206E20696E2065294F626A6563742E6861734F776E50726F70657274792E63616C6C28652C6E29262628655B6E5D3D4D6B28655B6E';
wwv_flow_imp.g_varchar2_table(10424) := '5D2C742B3129297D72657475726E20657D4C6B2E6F7074696F6E737C7C6578706F7274732E6F7074696F6E732C4C6B2E70617273657C7C6578706F7274732E70617273652C4C6B2E7061727365496E6C696E657C7C6578706F7274732E7061727365496E';
wwv_flow_imp.g_varchar2_table(10425) := '6C696E652C4C6B2E7061727365727C7C6578706F7274732E7061727365722C4C6B2E7365744F7074696F6E737C7C6578706F7274732E7365744F7074696F6E732C4C6B2E7573657C7C6578706F7274732E7573652C4C6B2E77616C6B546F6B656E737C7C';
wwv_flow_imp.g_varchar2_table(10426) := '6578706F7274732E77616C6B546F6B656E733B636F6E737420416B3D4F626A6563742E667265657A65287B696D6167653A28652C742C6E293D3E7B6C657420693D5B5D2C6F3D5B5D3B72657475726E2065262628287B687265663A652C64696D656E7369';
wwv_flow_imp.g_varchar2_table(10427) := '6F6E733A697D3D66756E6374696F6E2865297B636F6E737420743D5B5D2C6E3D652E73706C697428227C22292E6D61702828653D3E652E7472696D282929293B653D6E5B305D3B636F6E737420693D6E5B315D3B69662869297B636F6E737420653D2F68';
wwv_flow_imp.g_varchar2_table(10428) := '65696768743D285C642B292F2E657865632869292C6E3D2F77696474683D285C642B292F2E657865632869292C6F3D653F655B315D3A22222C733D6E3F6E5B315D3A22222C723D697346696E697465287061727365496E74287329292C613D697346696E';
wwv_flow_imp.g_varchar2_table(10429) := '697465287061727365496E74286F29293B722626742E70757368286077696474683D22247B737D2260292C612626742E7075736828606865696768743D22247B6F7D2260297D72657475726E7B687265663A652C64696D656E73696F6E733A747D7D2865';
wwv_flow_imp.g_varchar2_table(10430) := '29292C6F2E7075736828607372633D22247B61632865297D226029292C6E26266F2E707573682860616C743D22247B6163286E297D2260292C7426266F2E7075736828607469746C653D22247B61632874297D2260292C692E6C656E6774682626286F3D';
wwv_flow_imp.g_varchar2_table(10431) := '6F2E636F6E636174286929292C223C696D6720222B6F2E6A6F696E28222022292B223E227D2C7061726167726170683A653D3E603C703E247B657D3C2F703E602C6C696E6B3A28652C742C6E293D3E22737472696E6722213D747970656F6620653F2222';
wwv_flow_imp.g_varchar2_table(10432) := '3A28653D3D3D6E2626286E3D6C63286E29292C743D22737472696E67223D3D747970656F6620743F6163286C63287429293A22222C603C6120687265663D22247B653D28653D6C63286529292E7265706C616365282F262F672C2226616D703B22292E72';
wwv_flow_imp.g_varchar2_table(10433) := '65706C616365282F3C2F672C22266C743B22292E7265706C616365282F3E2F672C222667743B22292E7265706C616365282F222F672C222671756F743B22292E7265706C616365282F272F672C22262333393B22297D22207469746C653D22247B747C7C';
wwv_flow_imp.g_varchar2_table(10434) := '657D2220647261676761626C653D2266616C7365223E247B6E7D3C2F613E60297D293B66756E6374696F6E204E6B28652C743D7B7D2C6E3D7B7D297B76617220692C6F3B636F6E737420733D6E65772061743B6C657420723D21313B636F6E737420613D';
wwv_flow_imp.g_varchar2_table(10435) := '626B2874292C6C3D66756E6374696F6E2874297B6C6574206E3B7472797B6E3D546B286465636F6465555249436F6D706F6E656E74287429297D63617463682865297B7D72657475726E206E3F286E3D6268286E2C28743D3E652E757269732626652E75';
wwv_flow_imp.g_varchar2_table(10436) := '7269735B745D3F4E6F2E72657669766528652E757269735B745D293A766F6964203029292C656E636F6465555249436F6D706F6E656E74284A534F4E2E737472696E67696679286E2929293A747D2C633D66756E6374696F6E28742C6E297B636F6E7374';
wwv_flow_imp.g_varchar2_table(10437) := '20693D652E757269732626652E757269735B745D3B6C6574206F3D4E6F2E7265766976652869293B72657475726E206E3F742E7374617274735769746828716F2E646174612B223A22293F743A286F7C7C286F3D4E6F2E7061727365287429292C516F2E';
wwv_flow_imp.g_varchar2_table(10438) := '757269546F42726F77736572557269286F292E746F537472696E6728213029293A6F3F4E6F2E70617273652874292E746F537472696E6728293D3D3D6F2E746F537472696E6728293F743A286F2E71756572792626286F3D6F2E77697468287B71756572';
wwv_flow_imp.g_varchar2_table(10439) := '793A6C286F2E7175657279297D29292C6F2E746F537472696E672829293A747D2C643D6E657720446B2E52656E64657265723B642E696D6167653D416B2E696D6167652C642E6C696E6B3D416B2E6C696E6B2C642E7061726167726170683D416B2E7061';
wwv_flow_imp.g_varchar2_table(10440) := '726167726170683B636F6E737420683D5B5D2C753D5B5D3B696628742E636F6465426C6F636B52656E646572657253796E633F642E636F64653D28652C6E293D3E7B636F6E737420693D456B2E6E657874496428292C6F3D742E636F6465426C6F636B52';
wwv_flow_imp.g_varchar2_table(10441) := '656E646572657253796E6328506B286E292C65293B72657475726E20752E70757368285B692C6F5D292C603C64697620636C6173733D22636F64652220646174612D636F64653D22247B697D223E247B6C692865297D3C2F6469763E607D3A742E636F64';
wwv_flow_imp.g_varchar2_table(10442) := '65426C6F636B52656E6465726572262628642E636F64653D28652C6E293D3E7B636F6E737420693D456B2E6E657874496428292C6F3D742E636F6465426C6F636B52656E646572657228506B286E292C65293B72657475726E20682E70757368286F2E74';
wwv_flow_imp.g_varchar2_table(10443) := '68656E2828653D3E5B692C655D2929292C603C64697620636C6173733D22636F64652220646174612D636F64653D22247B697D223E247B6C692865297D3C2F6469763E607D292C742E616374696F6E48616E646C6572297B636F6E7374206E3D66756E63';
wwv_flow_imp.g_varchar2_table(10444) := '74696F6E286E297B6C657420693D6E2E7461726765743B6966282241223D3D3D692E7461674E616D657C7C28693D692E706172656E74456C656D656E742C6926262241223D3D3D692E7461674E616D6529297472797B6C6574206F3D692E646174617365';
wwv_flow_imp.g_varchar2_table(10445) := '742E687265663B6F262628652E626173655572692626286F3D4F6B284E6F2E66726F6D28652E62617365557269292C6F29292C742E616374696F6E48616E646C65722E63616C6C6261636B286F2C6E29297D63617463682865297B6B652865297D66696E';
wwv_flow_imp.g_varchar2_table(10446) := '616C6C797B6E2E70726576656E7444656661756C7428297D7D2C693D742E616374696F6E48616E646C65722E646973706F7361626C65732E616464286E6577204B5328612C22636C69636B2229292C6F3D742E616374696F6E48616E646C65722E646973';
wwv_flow_imp.g_varchar2_table(10447) := '706F7361626C65732E616464286E6577204B5328612C22617578636C69636B2229293B742E616374696F6E48616E646C65722E646973706F7361626C65732E6164642876742E616E7928692E6576656E742C6F2E6576656E74292828653D3E7B636F6E73';
wwv_flow_imp.g_varchar2_table(10448) := '7420743D6E65772047652872732861292C65293B28742E6C656674427574746F6E7C7C742E6D6964646C65427574746F6E2926266E2874297D2929292C742E616374696F6E48616E646C65722E646973706F7361626C65732E61646428627328612C226B';
wwv_flow_imp.g_varchar2_table(10449) := '6579646F776E222C28653D3E7B636F6E737420743D6E65772071652865293B28742E657175616C73283130297C7C742E657175616C732833292926266E2874297D2929297D652E737570706F727448746D6C7C7C286E2E73616E6974697A65723D743D3E';
wwv_flow_imp.g_varchar2_table(10450) := '28652E6973547275737465643F742E6D61746368282F5E283C7370616E5B5E3E5D2B3E297C283C5C2F5C732A7370616E3E29242F293A766F69642030293F743A22222C6E2E73616E6974697A653D21302C6E2E73696C656E743D2130292C6E2E72656E64';
wwv_flow_imp.g_varchar2_table(10451) := '657265723D643B6C657420702C673D6E756C6C213D3D28693D652E76616C7565292626766F69642030213D3D693F693A22223B696628672E6C656E6774683E316535262628673D60247B672E73756273747228302C316535297DE280A660292C652E7375';
wwv_flow_imp.g_varchar2_table(10452) := '70706F72745468656D6549636F6E73262628673D672E7265706C61636528416C2C28653D3E605C5C247B657D602929292C742E66696C6C496E496E636F6D706C657465546F6B656E73297B636F6E737420653D7B2E2E2E446B2E64656661756C74732C2E';
wwv_flow_imp.g_varchar2_table(10453) := '2E2E6E7D2C743D66756E6374696F6E2865297B6C657420742C6E3B666F7228743D303B743C652E6C656E6774683B742B2B297B636F6E737420693D655B745D3B6C6574206F3B69662822706172616772617068223D3D3D692E747970652626286F3D692E';
wwv_flow_imp.g_varchar2_table(10454) := '7261772E6D61746368282F285C6E7C5E2928606060602A292F2929297B636F6E737420693D6F5B325D3B6E3D6A6B28652E736C6963652874292C69293B627265616B7D69662822706172616772617068223D3D3D692E747970652626692E7261772E6D61';
wwv_flow_imp.g_varchar2_table(10455) := '746368282F285C6E7C5E295C7C2F29297B6E3D5A6B28652E736C696365287429293B627265616B7D696628743D3D3D652E6C656E6774682D31262622706172616772617068223D3D3D692E74797065297B636F6E737420653D486B2869293B6966286529';
wwv_flow_imp.g_varchar2_table(10456) := '7B6E3D5B655D3B627265616B7D7D7D6966286E297B636F6E737420693D5B2E2E2E652E736C69636528302C74292C2E2E2E6E5D3B72657475726E20692E6C696E6B733D652E6C696E6B732C697D72657475726E20657D28446B2E6C6578657228672C6529';
wwv_flow_imp.g_varchar2_table(10457) := '293B703D446B2E70617273657228742C65297D656C736520703D446B2E706172736528672C6E293B652E737570706F72745468656D6549636F6E73262628703D536B2870292E6D61702828653D3E22737472696E67223D3D747970656F6620653F653A65';
wwv_flow_imp.g_varchar2_table(10458) := '2E6F7574657248544D4C29292E6A6F696E28222229293B636F6E7374206D3D286E657720444F4D506172736572292E706172736546726F6D537472696E6728526B28652C70292C22746578742F68746D6C22293B6966286D2E626F64792E717565727953';
wwv_flow_imp.g_varchar2_table(10459) := '656C6563746F72416C6C2822696D672C20617564696F2C20766964656F2C20736F7572636522292E666F724561636828286E3D3E7B636F6E737420693D6E2E676574417474726962757465282273726322293B69662869297B6C6574206F3D693B747279';
wwv_flow_imp.g_varchar2_table(10460) := '7B652E626173655572692626286F3D4F6B284E6F2E66726F6D28652E62617365557269292C6F29297D63617463682865297B7D6966286E2E7365744174747269627574652822737263222C63286F2C213029292C742E646973616C6C6F7752656D6F7465';
wwv_flow_imp.g_varchar2_table(10461) := '496D61676573297B636F6E737420653D4E6F2E7061727365286F292E736368656D653B65213D3D716F2E66696C65262665213D3D716F2E6461746126266E2E7265706C616365576974682862722822222C766F696420302C6E2E6F7574657248544D4C29';
wwv_flow_imp.g_varchar2_table(10462) := '297D7D7D29292C6D2E626F64792E717565727953656C6563746F72416C6C28226122292E666F72456163682828743D3E7B636F6E7374206E3D742E67657441747472696275746528226872656622293B696628742E736574417474726962757465282268';
wwv_flow_imp.g_varchar2_table(10463) := '726566222C2222292C216E7C7C2F5E646174613A7C6A6176617363726970743A2F692E74657374286E297C7C2F5E636F6D6D616E643A2F692E74657374286E29262621652E6973547275737465647C7C2F5E636F6D6D616E643A285C2F5C2F5C2F293F5F';
wwv_flow_imp.g_varchar2_table(10464) := '776F726B62656E63685C2E646F776E6C6F61645265736F757263652F692E74657374286E2929742E7265706C61636557697468282E2E2E742E6368696C644E6F646573293B656C73657B6C657420693D63286E2C2131293B652E62617365557269262628';
wwv_flow_imp.g_varchar2_table(10465) := '693D4F6B284E6F2E66726F6D28652E62617365557269292C6E29292C742E646174617365742E687265663D697D7D29292C612E696E6E657248544D4C3D526B28652C6D2E626F64792E696E6E657248544D4C292C682E6C656E6774683E302950726F6D69';
wwv_flow_imp.g_varchar2_table(10466) := '73652E616C6C2868292E7468656E2828653D3E7B766172206E2C693B696628722972657475726E3B636F6E7374206F3D6E6577204D61702865292C733D612E717565727953656C6563746F72416C6C28226469765B646174612D636F64655D22293B666F';
wwv_flow_imp.g_varchar2_table(10467) := '7228636F6E73742065206F662073297B636F6E737420743D6F2E676574286E756C6C213D3D286E3D652E646174617365742E636F6465292626766F69642030213D3D6E3F6E3A2222293B742626677228652C74297D6E756C6C3D3D3D28693D742E617379';
wwv_flow_imp.g_varchar2_table(10468) := '6E6352656E64657243616C6C6261636B297C7C766F696420303D3D3D697C7C692E63616C6C2874297D29293B656C736520696628752E6C656E6774683E30297B636F6E737420653D6E6577204D61702875292C743D612E717565727953656C6563746F72';
wwv_flow_imp.g_varchar2_table(10469) := '416C6C28226469765B646174612D636F64655D22293B666F7228636F6E7374206E206F662074297B636F6E737420743D652E676574286E756C6C213D3D286F3D6E2E646174617365742E636F6465292626766F69642030213D3D6F3F6F3A2222293B7426';
wwv_flow_imp.g_varchar2_table(10470) := '266772286E2C74297D7D696628742E6173796E6352656E64657243616C6C6261636B29666F7228636F6E73742065206F6620612E676574456C656D656E747342795461674E616D652822696D672229297B636F6E7374206E3D732E61646428627328652C';
wwv_flow_imp.g_varchar2_table(10471) := '226C6F6164222C2828293D3E7B6E2E646973706F736528292C742E6173796E6352656E64657243616C6C6261636B28297D2929297D72657475726E7B656C656D656E743A612C646973706F73653A28293D3E7B723D21302C732E646973706F736528297D';
wwv_flow_imp.g_varchar2_table(10472) := '7D7D66756E6374696F6E20506B2865297B69662821652972657475726E22223B636F6E737420743D652E73706C6974282F5B5C732B7C3A7C2C7C5C7B7C5C3F5D2F2C31293B72657475726E20742E6C656E6774683F745B305D3A657D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(10473) := '204F6B28652C74297B72657475726E2F5E5C775B5C775C642B2E2D5D2A3A2F2E746573742874293F743A652E706174682E656E64735769746828222F22293F656328652C74292E746F537472696E6728293A656328596C2865292C74292E746F53747269';
wwv_flow_imp.g_varchar2_table(10474) := '6E6728297D66756E6374696F6E20526B28652C74297B636F6E73747B636F6E6669673A6E2C616C6C6F776564536368656D65733A697D3D66756E6374696F6E2865297B636F6E737420743D5B716F2E687474702C716F2E68747470732C716F2E6D61696C';
wwv_flow_imp.g_varchar2_table(10475) := '746F2C716F2E646174612C716F2E66696C652C716F2E7673636F646546696C655265736F757263652C716F2E7673636F646552656D6F74652C716F2E7673636F646552656D6F74655265736F757263655D3B72657475726E20652E697354727573746564';
wwv_flow_imp.g_varchar2_table(10476) := '2626742E7075736828716F2E636F6D6D616E64292C7B636F6E6669673A7B414C4C4F5745445F544147533A5B2E2E2E45725D2C414C4C4F5745445F415454523A466B2C414C4C4F575F554E4B4E4F574E5F50524F544F434F4C533A21307D2C616C6C6F77';
wwv_flow_imp.g_varchar2_table(10477) := '6564536368656D65733A747D7D2865293B4A6E282275706F6E53616E6974697A65417474726962757465222C2828652C74293D3E7B766172206E3B696628227374796C6522213D3D742E617474724E616D65262622636C61737322213D3D742E61747472';
wwv_flow_imp.g_varchar2_table(10478) := '4E616D65297B69662822494E505554223D3D3D652E7461674E616D65262622636865636B626F78223D3D3D286E756C6C3D3D3D286E3D652E617474726962757465732E6765744E616D65644974656D2822747970652229297C7C766F696420303D3D3D6E';
wwv_flow_imp.g_varchar2_table(10479) := '3F766F696420303A6E2E76616C756529297B6966282274797065223D3D3D742E617474724E616D65262622636865636B626F78223D3D3D742E6174747256616C75657C7C2264697361626C6564223D3D3D742E617474724E616D657C7C22636865636B65';
wwv_flow_imp.g_varchar2_table(10480) := '64223D3D3D742E617474724E616D652972657475726E20766F696428742E6B656570417474723D2130293B742E6B656570417474723D21317D7D656C73657B696628225350414E223D3D3D652E7461674E616D65297B696628227374796C65223D3D3D74';
wwv_flow_imp.g_varchar2_table(10481) := '2E617474724E616D652972657475726E20766F696428742E6B656570417474723D2F5E28636F6C6F725C3A28235B302D39612D66412D465D2B7C7661725C282D2D7673636F6465282D5B612D7A412D5A5D2B292B5C29293B293F286261636B67726F756E';
wwv_flow_imp.g_varchar2_table(10482) := '642D636F6C6F725C3A28235B302D39612D66412D465D2B7C7661725C282D2D7673636F6465282D5B612D7A412D5A5D2B292B5C29293B293F242F2E7465737428742E6174747256616C756529293B69662822636C617373223D3D3D742E617474724E616D';
wwv_flow_imp.g_varchar2_table(10483) := '652972657475726E20766F696428742E6B656570417474723D2F5E636F6469636F6E20636F6469636F6E2D5B612D7A5C2D5D2B2820636F6469636F6E2D6D6F6469666965722D5B612D7A5C2D5D2B293F242F2E7465737428742E6174747256616C756529';
wwv_flow_imp.g_varchar2_table(10484) := '297D742E6B656570417474723D21317D7D29292C4A6E282275706F6E53616E6974697A65456C656D656E74222C2828652C74293D3E7B766172206E2C693B22696E707574223D3D3D742E7461674E616D6526262822636865636B626F78223D3D3D286E75';
wwv_flow_imp.g_varchar2_table(10485) := '6C6C3D3D3D286E3D652E617474726962757465732E6765744E616D65644974656D2822747970652229297C7C766F696420303D3D3D6E3F766F696420303A6E2E76616C7565293F652E736574417474726962757465282264697361626C6564222C222229';
wwv_flow_imp.g_varchar2_table(10486) := '3A6E756C6C3D3D3D28693D652E706172656E74456C656D656E74297C7C766F696420303D3D3D697C7C692E72656D6F76654368696C64286529297D29293B636F6E7374206F3D66756E6374696F6E28652C743D2131297B636F6E7374206E3D646F63756D';
wwv_flow_imp.g_varchar2_table(10487) := '656E742E637265617465456C656D656E7428226122293B72657475726E204A6E2822616674657253616E6974697A6541747472696275746573222C28693D3E7B666F7228636F6E7374206F206F665B2268726566222C22737263225D29696628692E6861';
wwv_flow_imp.g_varchar2_table(10488) := '73417474726962757465286F29297B636F6E737420733D692E676574417474726962757465286F293B6966282268726566223D3D3D6F2626732E73746172747357697468282223222929636F6E74696E75653B6966286E2E687265663D732C21652E696E';
wwv_flow_imp.g_varchar2_table(10489) := '636C75646573286E2E70726F746F636F6C2E7265706C616365282F3A242F2C22222929297B69662874262622737263223D3D3D6F26266E2E687265662E737461727473576974682822646174613A222929636F6E74696E75653B692E72656D6F76654174';
wwv_flow_imp.g_varchar2_table(10490) := '74726962757465286F297D7D7D29292C7274282828293D3E7B65692822616674657253616E6974697A654174747269627574657322297D29297D2869293B7472797B72657475726E20586E28742C7B2E2E2E6E2C52455455524E5F545255535445445F54';
wwv_flow_imp.g_varchar2_table(10491) := '5950453A21307D297D66696E616C6C797B6569282275706F6E53616E6974697A6541747472696275746522292C6F2E646973706F736528297D7D636F6E737420466B3D5B22616C69676E222C226175746F706C6179222C22616C74222C22636865636B65';
wwv_flow_imp.g_varchar2_table(10492) := '64222C22636C617373222C22636F6E74726F6C73222C22646174612D636F6465222C22646174612D68726566222C2264697361626C6564222C22647261676761626C65222C22686569676874222C2268726566222C226C6F6F70222C226D75746564222C';
wwv_flow_imp.g_varchar2_table(10493) := '22706C617973696E6C696E65222C22706F73746572222C22737263222C227374796C65222C22746172676574222C227469746C65222C2274797065222C227769647468222C227374617274225D3B636F6E737420426B3D6E6577204D6170285B5B222671';
wwv_flow_imp.g_varchar2_table(10494) := '756F743B222C2722275D2C5B22266E6273703B222C2220225D2C5B2226616D703B222C2226225D2C5B22262333393B222C2227225D2C5B22266C743B222C223C225D2C5B222667743B222C223E225D5D292C566B3D6E6577206969282828293D3E7B636F';
wwv_flow_imp.g_varchar2_table(10495) := '6E737420653D6E657720446B2E52656E64657265723B72657475726E20652E636F64653D653D3E652C652E626C6F636B71756F74653D653D3E652C652E68746D6C3D653D3E22222C652E68656164696E673D28652C742C6E293D3E652B225C6E222C652E';
wwv_flow_imp.g_varchar2_table(10496) := '68723D28293D3E22222C652E6C6973743D28652C74293D3E652C652E6C6973746974656D3D653D3E652B225C6E222C652E7061726167726170683D653D3E652B225C6E222C652E7461626C653D28652C74293D3E652B742B225C6E222C652E7461626C65';
wwv_flow_imp.g_varchar2_table(10497) := '726F773D653D3E652C652E7461626C6563656C6C3D28652C74293D3E652B2220222C652E7374726F6E673D653D3E652C652E656D3D653D3E652C652E636F64657370616E3D653D3E652C652E62723D28293D3E225C6E222C652E64656C3D653D3E652C65';
wwv_flow_imp.g_varchar2_table(10498) := '2E696D6167653D28652C742C6E293D3E22222C652E746578743D653D3E652C652E6C696E6B3D28652C742C6E293D3E6E2C657D29293B66756E6374696F6E207A6B2865297B6C657420743D22223B72657475726E20652E666F72456163682828653D3E7B';
wwv_flow_imp.g_varchar2_table(10499) := '742B3D652E7261777D29292C747D66756E6374696F6E20486B2865297B76617220742C6E3B666F72286C657420693D303B693C652E746F6B656E732E6C656E6774683B692B2B297B636F6E7374206F3D652E746F6B656E735B695D3B6966282274657874';
wwv_flow_imp.g_varchar2_table(10500) := '223D3D3D6F2E74797065297B636F6E737420733D6F2E7261772E73706C697428225C6E22292C723D735B732E6C656E6774682D315D3B696628722E696E636C7564657328226022292972657475726E20716B2865293B696628722E696E636C7564657328';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(10501) := '222A2A22292972657475726E20596B28652C222A2A22293B696628722E6D61746368282F5C2A5C772F292972657475726E20596B28652C222A22293B696628722E6D61746368282F285E7C5C73295F5F5C772F292972657475726E20516B2865293B6966';
wwv_flow_imp.g_varchar2_table(10502) := '28722E6D61746368282F285E7C5C73295F5C772F292972657475726E20246B2865293B696628722E6D61746368282F285E7C5C73295C5B2E2A5C5D5C285C772A2F29297B636F6E7374206F3D652E746F6B656E732E736C69636528692B31293B72657475';
wwv_flow_imp.g_varchar2_table(10503) := '726E226C696E6B223D3D3D286E756C6C3D3D3D28743D6F5B305D297C7C766F696420303D3D3D743F766F696420303A742E747970652926262274657874223D3D3D286E756C6C3D3D3D286E3D6F5B315D297C7C766F696420303D3D3D6E3F766F69642030';
wwv_flow_imp.g_varchar2_table(10504) := '3A6E2E747970652926266F5B315D2E7261772E6D61746368282F5E202A225B5E225D2A242F293F4B6B2865293A556B2865297D696628576B2872292972657475726E20556B2865293B696628722E6D61746368282F285E7C5C73295C5B5C772F29262621';
wwv_flow_imp.g_varchar2_table(10505) := '652E746F6B656E732E736C69636528692B31292E736F6D652828653D3E576B28652E7261772929292972657475726E20476B2865297D7D7D66756E6374696F6E20576B2865297B72657475726E2121652E6D61746368282F5E5B5E5C5B5D2A5C5D5C285B';
wwv_flow_imp.g_varchar2_table(10506) := '5E5C295D2A242F297D66756E6374696F6E206A6B28652C74297B636F6E7374206E3D7A6B2865293B72657475726E20446B2E6C65786572286E2B605C6E247B747D60297D66756E6374696F6E20716B2865297B72657475726E20596B28652C226022297D';
wwv_flow_imp.g_varchar2_table(10507) := '66756E6374696F6E20246B2865297B72657475726E20596B28652C225F22297D66756E6374696F6E20556B2865297B72657475726E20596B28652C222922297D66756E6374696F6E204B6B2865297B72657475726E20596B28652C27222927297D66756E';
wwv_flow_imp.g_varchar2_table(10508) := '6374696F6E20476B2865297B72657475726E20596B28652C225D2861626F75743A626C616E6B2922297D66756E6374696F6E20516B2865297B72657475726E20596B28652C225F5F22297D66756E6374696F6E20596B28652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(10509) := '7A6B2841727261792E697341727261792865293F653A5B655D293B72657475726E20446B2E6C65786572286E2B74295B305D7D66756E6374696F6E205A6B2865297B636F6E737420743D7A6B2865292C6E3D742E73706C697428225C6E22293B6C657420';
wwv_flow_imp.g_varchar2_table(10510) := '692C6F3D21313B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B297B636F6E737420743D6E5B655D2E7472696D28293B696628766F696420303D3D3D692626742E6D61746368282F5E5C732A5C7C2F29297B636F6E737420653D742E6D';
wwv_flow_imp.g_varchar2_table(10511) := '61746368282F285C7C5B5E5C7C5D2B29283F3D5C7C7C24292F67293B65262628693D652E6C656E677468297D656C736520696628226E756D626572223D3D747970656F662069297B69662821742E6D61746368282F5E5C732A5C7C2F292972657475726E';
wwv_flow_imp.g_varchar2_table(10512) := '3B69662865213D3D6E2E6C656E6774682D312972657475726E3B6F3D21307D7D696628226E756D626572223D3D747970656F6620692626693E30297B636F6E737420653D6F3F6E2E736C69636528302C2D31292E6A6F696E28225C6E22293A742C733D21';
wwv_flow_imp.g_varchar2_table(10513) := '21652E6D61746368282F5C7C5C732A242F292C723D652B28733F22223A227C22292B605C6E7C247B22202D2D2D207C222E7265706561742869297D603B72657475726E20446B2E6C657865722872297D7D76617220586B3D6E2837323031292C4A6B3D7B';
wwv_flow_imp.g_varchar2_table(10514) := '7D3B66756E6374696F6E20654528652C74297B766172206E3B636F6E737420693D676C6F62616C546869732E4D6F6E61636F456E7669726F6E6D656E743B6966286E756C6C3D3D693F766F696420303A692E637265617465547275737465645479706573';
wwv_flow_imp.g_varchar2_table(10515) := '506F6C696379297472797B72657475726E20692E637265617465547275737465645479706573506F6C69637928652C74297D63617463682865297B72657475726E20766F6964206B652865297D7472797B72657475726E206E756C6C3D3D3D286E3D732E';
wwv_flow_imp.g_varchar2_table(10516) := '747275737465645479706573297C7C766F696420303D3D3D6E3F766F696420303A6E2E637265617465506F6C69637928652C74297D63617463682865297B72657475726E20766F6964206B652865297D7D4A6B2E7374796C655461675472616E73666F72';
wwv_flow_imp.g_varchar2_table(10517) := '6D3D6A7228292C4A6B2E736574417474726962757465733D567228292C4A6B2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4A6B2E646F6D4150493D4F7228292C4A6B2E696E736572745374796C65456C656D656E743D48';
wwv_flow_imp.g_varchar2_table(10518) := '7228292C4E72282928586B2E412C4A6B292C586B2E412626586B2E412E6C6F63616C732626586B2E412E6C6F63616C733B7661722074453D6E2836383335292C6E453D7B7D3B6E452E7374796C655461675472616E73666F726D3D6A7228292C6E452E73';
wwv_flow_imp.g_varchar2_table(10519) := '6574417474726962757465733D567228292C6E452E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6E452E646F6D4150493D4F7228292C6E452E696E736572745374796C65456C656D656E743D487228292C4E722829287445';
wwv_flow_imp.g_varchar2_table(10520) := '2E412C6E45292C74452E41262674452E412E6C6F63616C73262674452E412E6C6F63616C733B636C6173732069457B636F6E7374727563746F722865297B746869732E646F6D4E6F64653D652C746869732E5F6D617857696474683D22222C746869732E';
wwv_flow_imp.g_varchar2_table(10521) := '5F77696474683D22222C746869732E5F6865696768743D22222C746869732E5F746F703D22222C746869732E5F6C6566743D22222C746869732E5F626F74746F6D3D22222C746869732E5F72696768743D22222C746869732E5F70616464696E674C6566';
wwv_flow_imp.g_varchar2_table(10522) := '743D22222C746869732E5F666F6E7446616D696C793D22222C746869732E5F666F6E745765696768743D22222C746869732E5F666F6E7453697A653D22222C746869732E5F666F6E745374796C653D22222C746869732E5F666F6E744665617475726553';
wwv_flow_imp.g_varchar2_table(10523) := '657474696E67733D22222C746869732E5F666F6E74566172696174696F6E53657474696E67733D22222C746869732E5F746578744465636F726174696F6E3D22222C746869732E5F6C696E654865696768743D22222C746869732E5F6C65747465725370';
wwv_flow_imp.g_varchar2_table(10524) := '6163696E673D22222C746869732E5F636C6173734E616D653D22222C746869732E5F646973706C61793D22222C746869732E5F706F736974696F6E3D22222C746869732E5F7669736962696C6974793D22222C746869732E5F636F6C6F723D22222C7468';
wwv_flow_imp.g_varchar2_table(10525) := '69732E5F6261636B67726F756E64436F6C6F723D22222C746869732E5F6C6179657248696E743D21312C746869732E5F636F6E7461696E3D226E6F6E65222C746869732E5F626F78536861646F773D22227D7365744D617857696474682865297B636F6E';
wwv_flow_imp.g_varchar2_table(10526) := '737420743D6F452865293B746869732E5F6D61785769647468213D3D74262628746869732E5F6D617857696474683D742C746869732E646F6D4E6F64652E7374796C652E6D617857696474683D746869732E5F6D61785769647468297D73657457696474';
wwv_flow_imp.g_varchar2_table(10527) := '682865297B636F6E737420743D6F452865293B746869732E5F7769647468213D3D74262628746869732E5F77696474683D742C746869732E646F6D4E6F64652E7374796C652E77696474683D746869732E5F7769647468297D7365744865696768742865';
wwv_flow_imp.g_varchar2_table(10528) := '297B636F6E737420743D6F452865293B746869732E5F686569676874213D3D74262628746869732E5F6865696768743D742C746869732E646F6D4E6F64652E7374796C652E6865696768743D746869732E5F686569676874297D736574546F702865297B';
wwv_flow_imp.g_varchar2_table(10529) := '636F6E737420743D6F452865293B746869732E5F746F70213D3D74262628746869732E5F746F703D742C746869732E646F6D4E6F64652E7374796C652E746F703D746869732E5F746F70297D7365744C6566742865297B636F6E737420743D6F45286529';
wwv_flow_imp.g_varchar2_table(10530) := '3B746869732E5F6C656674213D3D74262628746869732E5F6C6566743D742C746869732E646F6D4E6F64652E7374796C652E6C6566743D746869732E5F6C656674297D736574426F74746F6D2865297B636F6E737420743D6F452865293B746869732E5F';
wwv_flow_imp.g_varchar2_table(10531) := '626F74746F6D213D3D74262628746869732E5F626F74746F6D3D742C746869732E646F6D4E6F64652E7374796C652E626F74746F6D3D746869732E5F626F74746F6D297D73657452696768742865297B636F6E737420743D6F452865293B746869732E5F';
wwv_flow_imp.g_varchar2_table(10532) := '7269676874213D3D74262628746869732E5F72696768743D742C746869732E646F6D4E6F64652E7374796C652E72696768743D746869732E5F7269676874297D73657450616464696E674C6566742865297B636F6E737420743D6F452865293B74686973';
wwv_flow_imp.g_varchar2_table(10533) := '2E5F70616464696E674C656674213D3D74262628746869732E5F70616464696E674C6566743D742C746869732E646F6D4E6F64652E7374796C652E70616464696E674C6566743D746869732E5F70616464696E674C656674297D736574466F6E7446616D';
wwv_flow_imp.g_varchar2_table(10534) := '696C792865297B746869732E5F666F6E7446616D696C79213D3D65262628746869732E5F666F6E7446616D696C793D652C746869732E646F6D4E6F64652E7374796C652E666F6E7446616D696C793D746869732E5F666F6E7446616D696C79297D736574';
wwv_flow_imp.g_varchar2_table(10535) := '466F6E745765696768742865297B746869732E5F666F6E74576569676874213D3D65262628746869732E5F666F6E745765696768743D652C746869732E646F6D4E6F64652E7374796C652E666F6E745765696768743D746869732E5F666F6E7457656967';
wwv_flow_imp.g_varchar2_table(10536) := '6874297D736574466F6E7453697A652865297B636F6E737420743D6F452865293B746869732E5F666F6E7453697A65213D3D74262628746869732E5F666F6E7453697A653D742C746869732E646F6D4E6F64652E7374796C652E666F6E7453697A653D74';
wwv_flow_imp.g_varchar2_table(10537) := '6869732E5F666F6E7453697A65297D736574466F6E745374796C652865297B746869732E5F666F6E745374796C65213D3D65262628746869732E5F666F6E745374796C653D652C746869732E646F6D4E6F64652E7374796C652E666F6E745374796C653D';
wwv_flow_imp.g_varchar2_table(10538) := '746869732E5F666F6E745374796C65297D736574466F6E744665617475726553657474696E67732865297B746869732E5F666F6E744665617475726553657474696E6773213D3D65262628746869732E5F666F6E744665617475726553657474696E6773';
wwv_flow_imp.g_varchar2_table(10539) := '3D652C746869732E646F6D4E6F64652E7374796C652E666F6E744665617475726553657474696E67733D746869732E5F666F6E744665617475726553657474696E6773297D736574466F6E74566172696174696F6E53657474696E67732865297B746869';
wwv_flow_imp.g_varchar2_table(10540) := '732E5F666F6E74566172696174696F6E53657474696E6773213D3D65262628746869732E5F666F6E74566172696174696F6E53657474696E67733D652C746869732E646F6D4E6F64652E7374796C652E666F6E74566172696174696F6E53657474696E67';
wwv_flow_imp.g_varchar2_table(10541) := '733D746869732E5F666F6E74566172696174696F6E53657474696E6773297D736574546578744465636F726174696F6E2865297B746869732E5F746578744465636F726174696F6E213D3D65262628746869732E5F746578744465636F726174696F6E3D';
wwv_flow_imp.g_varchar2_table(10542) := '652C746869732E646F6D4E6F64652E7374796C652E746578744465636F726174696F6E3D746869732E5F746578744465636F726174696F6E297D7365744C696E654865696768742865297B636F6E737420743D6F452865293B746869732E5F6C696E6548';
wwv_flow_imp.g_varchar2_table(10543) := '6569676874213D3D74262628746869732E5F6C696E654865696768743D742C746869732E646F6D4E6F64652E7374796C652E6C696E654865696768743D746869732E5F6C696E65486569676874297D7365744C657474657253706163696E672865297B63';
wwv_flow_imp.g_varchar2_table(10544) := '6F6E737420743D6F452865293B746869732E5F6C657474657253706163696E67213D3D74262628746869732E5F6C657474657253706163696E673D742C746869732E646F6D4E6F64652E7374796C652E6C657474657253706163696E673D746869732E5F';
wwv_flow_imp.g_varchar2_table(10545) := '6C657474657253706163696E67297D736574436C6173734E616D652865297B746869732E5F636C6173734E616D65213D3D65262628746869732E5F636C6173734E616D653D652C746869732E646F6D4E6F64652E636C6173734E616D653D746869732E5F';
wwv_flow_imp.g_varchar2_table(10546) := '636C6173734E616D65297D746F67676C65436C6173734E616D6528652C74297B746869732E646F6D4E6F64652E636C6173734C6973742E746F67676C6528652C74292C746869732E5F636C6173734E616D653D746869732E646F6D4E6F64652E636C6173';
wwv_flow_imp.g_varchar2_table(10547) := '734E616D657D736574446973706C61792865297B746869732E5F646973706C6179213D3D65262628746869732E5F646973706C61793D652C746869732E646F6D4E6F64652E7374796C652E646973706C61793D746869732E5F646973706C6179297D7365';
wwv_flow_imp.g_varchar2_table(10548) := '74506F736974696F6E2865297B746869732E5F706F736974696F6E213D3D65262628746869732E5F706F736974696F6E3D652C746869732E646F6D4E6F64652E7374796C652E706F736974696F6E3D746869732E5F706F736974696F6E297D7365745669';
wwv_flow_imp.g_varchar2_table(10549) := '736962696C6974792865297B746869732E5F7669736962696C697479213D3D65262628746869732E5F7669736962696C6974793D652C746869732E646F6D4E6F64652E7374796C652E7669736962696C6974793D746869732E5F7669736962696C697479';
wwv_flow_imp.g_varchar2_table(10550) := '297D736574436F6C6F722865297B746869732E5F636F6C6F72213D3D65262628746869732E5F636F6C6F723D652C746869732E646F6D4E6F64652E7374796C652E636F6C6F723D746869732E5F636F6C6F72297D7365744261636B67726F756E64436F6C';
wwv_flow_imp.g_varchar2_table(10551) := '6F722865297B746869732E5F6261636B67726F756E64436F6C6F72213D3D65262628746869732E5F6261636B67726F756E64436F6C6F723D652C746869732E646F6D4E6F64652E7374796C652E6261636B67726F756E64436F6C6F723D746869732E5F62';
wwv_flow_imp.g_varchar2_table(10552) := '61636B67726F756E64436F6C6F72297D7365744C6179657248696E74696E672865297B746869732E5F6C6179657248696E74213D3D65262628746869732E5F6C6179657248696E743D652C746869732E646F6D4E6F64652E7374796C652E7472616E7366';
wwv_flow_imp.g_varchar2_table(10553) := '6F726D3D746869732E5F6C6179657248696E743F227472616E736C6174653364283070782C203070782C2030707829223A2222297D736574426F78536861646F772865297B746869732E5F626F78536861646F77213D3D65262628746869732E5F626F78';
wwv_flow_imp.g_varchar2_table(10554) := '536861646F773D652C746869732E646F6D4E6F64652E7374796C652E626F78536861646F773D65297D736574436F6E7461696E2865297B746869732E5F636F6E7461696E213D3D65262628746869732E5F636F6E7461696E3D652C746869732E646F6D4E';
wwv_flow_imp.g_varchar2_table(10555) := '6F64652E7374796C652E636F6E7461696E3D746869732E5F636F6E7461696E297D73657441747472696275746528652C74297B746869732E646F6D4E6F64652E73657441747472696275746528652C74297D72656D6F7665417474726962757465286529';
wwv_flow_imp.g_varchar2_table(10556) := '7B746869732E646F6D4E6F64652E72656D6F76654174747269627574652865297D617070656E644368696C642865297B746869732E646F6D4E6F64652E617070656E644368696C6428652E646F6D4E6F6465297D72656D6F76654368696C642865297B74';
wwv_flow_imp.g_varchar2_table(10557) := '6869732E646F6D4E6F64652E72656D6F76654368696C6428652E646F6D4E6F6465297D7D66756E6374696F6E206F452865297B72657475726E226E756D626572223D3D747970656F6620653F60247B657D7078603A657D66756E6374696F6E2073452865';
wwv_flow_imp.g_varchar2_table(10558) := '297B72657475726E206E65772069452865297D66756E6374696F6E20724528652C74297B6520696E7374616E63656F662069453F28652E736574466F6E7446616D696C7928742E6765744D61737361676564466F6E7446616D696C792829292C652E7365';
wwv_flow_imp.g_varchar2_table(10559) := '74466F6E7457656967687428742E666F6E74576569676874292C652E736574466F6E7453697A6528742E666F6E7453697A65292C652E736574466F6E744665617475726553657474696E677328742E666F6E744665617475726553657474696E6773292C';
wwv_flow_imp.g_varchar2_table(10560) := '652E736574466F6E74566172696174696F6E53657474696E677328742E666F6E74566172696174696F6E53657474696E6773292C652E7365744C696E6548656967687428742E6C696E65486569676874292C652E7365744C657474657253706163696E67';
wwv_flow_imp.g_varchar2_table(10561) := '28742E6C657474657253706163696E6729293A28652E7374796C652E666F6E7446616D696C793D742E6765744D61737361676564466F6E7446616D696C7928292C652E7374796C652E666F6E745765696768743D742E666F6E745765696768742C652E73';
wwv_flow_imp.g_varchar2_table(10562) := '74796C652E666F6E7453697A653D742E666F6E7453697A652B227078222C652E7374796C652E666F6E744665617475726553657474696E67733D742E666F6E744665617475726553657474696E67732C652E7374796C652E666F6E74566172696174696F';
wwv_flow_imp.g_varchar2_table(10563) := '6E53657474696E67733D742E666F6E74566172696174696F6E53657474696E67732C652E7374796C652E6C696E654865696768743D742E6C696E654865696768742B227078222C652E7374796C652E6C657474657253706163696E673D742E6C65747465';
wwv_flow_imp.g_varchar2_table(10564) := '7253706163696E672B22707822297D636F6E73742061453D7B676574496E697469616C53746174653A28293D3E52772C746F6B656E697A65456E636F6465643A28652C742C6E293D3E427728302C6E297D3B66756E6374696F6E206C4528652C742C6E2C';
wwv_flow_imp.g_varchar2_table(10565) := '692C6F2C732C72297B6C657420613D223C6469763E222C6C3D692C633D302C643D21303B666F72286C657420683D302C753D742E676574436F756E7428293B683C753B682B2B297B636F6E737420753D742E676574456E644F66667365742868293B6966';
wwv_flow_imp.g_varchar2_table(10566) := '28753C3D6929636F6E74696E75653B6C657420703D22223B666F72283B6C3C7526266C3C6F3B6C2B2B297B636F6E737420743D652E63686172436F64654174286C293B7377697463682874297B6361736520393A7B6C657420653D732D286C2B63292573';
wwv_flow_imp.g_varchar2_table(10567) := '3B666F7228632B3D652D313B653E303B29722626643F28702B3D2226233136303B222C643D2131293A28702B3D2220222C643D2130292C652D2D3B627265616B7D636173652036303A702B3D22266C743B222C643D21313B627265616B3B636173652036';
wwv_flow_imp.g_varchar2_table(10568) := '323A702B3D222667743B222C643D21313B627265616B3B636173652033383A702B3D2226616D703B222C643D21313B627265616B3B6361736520303A702B3D22262330303B222C643D21313B627265616B3B636173652036353237393A63617365203832';
wwv_flow_imp.g_varchar2_table(10569) := '33323A6361736520383233333A63617365203133333A702B3D22EFBFBD222C643D21313B627265616B3B636173652031333A702B3D22262338323033222C643D21313B627265616B3B636173652033323A722626643F28702B3D2226233136303B222C64';
wwv_flow_imp.g_varchar2_table(10570) := '3D2131293A28702B3D2220222C643D2130293B627265616B3B64656661756C743A702B3D537472696E672E66726F6D43686172436F64652874292C643D21317D7D696628612B3D603C7370616E207374796C653D22247B742E676574496E6C696E655374';
wwv_flow_imp.g_varchar2_table(10571) := '796C6528682C6E297D223E247B707D3C2F7370616E3E602C753E6F7C7C6C3E3D6F29627265616B7D72657475726E20612B3D223C2F6469763E222C617D66756E6374696F6E20634528652C742C6E297B6C657420693D273C64697620636C6173733D226D';
wwv_flow_imp.g_varchar2_table(10572) := '6F6E61636F2D746F6B656E697A65642D736F75726365223E273B636F6E7374206F3D67692865293B6C657420733D6E2E676574496E697469616C537461746528293B666F72286C657420653D302C723D6F2E6C656E6774683B653C723B652B2B297B636F';
wwv_flow_imp.g_varchar2_table(10573) := '6E737420723D6F5B655D3B653E30262628692B3D223C62722F3E22293B636F6E737420613D6E2E746F6B656E697A65456E636F64656428722C21302C73293B57772E636F6E76657274546F456E644F666673657428612E746F6B656E732C722E6C656E67';
wwv_flow_imp.g_varchar2_table(10574) := '7468293B636F6E7374206C3D6E657720577728612E746F6B656E732C722C74292E696E666C61746528293B6C657420633D303B666F72286C657420653D302C743D6C2E676574436F756E7428293B653C743B652B2B297B636F6E737420743D6C2E676574';
wwv_flow_imp.g_varchar2_table(10575) := '436C6173734E616D652865292C6E3D6C2E676574456E644F66667365742865293B692B3D603C7370616E20636C6173733D22247B747D223E247B6C6928722E737562737472696E6728632C6E29297D3C2F7370616E3E602C633D6E7D733D612E656E6453';
wwv_flow_imp.g_varchar2_table(10576) := '746174657D72657475726E20692B3D223C2F6469763E222C697D636F6E73742064453D706328226F70656E65725365727669636522293B7661722068452C75453D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B';
wwv_flow_imp.g_varchar2_table(10577) := '74286E2C692C65297D7D3B6C65742070453D68453D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F6F7074696F6E733D652C746869732E5F6C616E6775616765536572766963653D742C746869732E5F6F70656E65725365';
wwv_flow_imp.g_varchar2_table(10578) := '72766963653D6E2C746869732E5F6F6E44696452656E6465724173796E633D6E65772043742C746869732E6F6E44696452656E6465724173796E633D746869732E5F6F6E44696452656E6465724173796E632E6576656E747D646973706F736528297B74';
wwv_flow_imp.g_varchar2_table(10579) := '6869732E5F6F6E44696452656E6465724173796E632E646973706F736528297D72656E64657228652C742C6E297B69662821652972657475726E7B656C656D656E743A646F63756D656E742E637265617465456C656D656E7428227370616E22292C6469';
wwv_flow_imp.g_varchar2_table(10580) := '73706F73653A28293D3E7B7D7D3B636F6E737420693D6E65772061742C6F3D692E616464284E6B28652C7B2E2E2E746869732E5F67657452656E6465724F7074696F6E7328652C69292C2E2E2E747D2C6E29293B72657475726E206F2E656C656D656E74';
wwv_flow_imp.g_varchar2_table(10581) := '2E636C6173734C6973742E616464282272656E64657265642D6D61726B646F776E22292C7B656C656D656E743A6F2E656C656D656E742C646973706F73653A28293D3E692E646973706F736528297D7D5F67657452656E6465724F7074696F6E7328652C';
wwv_flow_imp.g_varchar2_table(10582) := '74297B72657475726E7B636F6465426C6F636B52656E64657265723A6173796E6328652C74293D3E7B766172206E2C692C6F3B6C657420733B653F733D746869732E5F6C616E6775616765536572766963652E6765744C616E6775616765496442794C61';
wwv_flow_imp.g_varchar2_table(10583) := '6E67756167654E616D652865293A746869732E5F6F7074696F6E732E656469746F72262628733D6E756C6C3D3D3D286E3D746869732E5F6F7074696F6E732E656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D6E3F766F69642030';
wwv_flow_imp.g_varchar2_table(10584) := '3A6E2E6765744C616E677561676549642829292C737C7C28733D5570293B636F6E737420723D6177616974206173796E632066756E6374696F6E28652C742C6E297B696628216E2972657475726E20634528742C652E6C616E67756167654964436F6465';
wwv_flow_imp.g_varchar2_table(10585) := '632C6145293B636F6E737420693D61776169742050772E6765744F72437265617465286E293B72657475726E20634528742C652E6C616E67756167654964436F6465632C697C7C6145297D28746869732E5F6C616E6775616765536572766963652C742C';
wwv_flow_imp.g_varchar2_table(10586) := '73292C613D646F63756D656E742E637265617465456C656D656E7428227370616E22293B72657475726E20612E696E6E657248544D4C3D6E756C6C213D3D286F3D6E756C6C3D3D3D28693D68452E5F747470546F6B656E697A6572297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(10587) := '3D3D3D693F766F696420303A692E63726561746548544D4C287229292626766F69642030213D3D6F3F6F3A722C746869732E5F6F7074696F6E732E656469746F723F724528612C746869732E5F6F7074696F6E732E656469746F722E6765744F7074696F';
wwv_flow_imp.g_varchar2_table(10588) := '6E28353029293A746869732E5F6F7074696F6E732E636F6465426C6F636B466F6E7446616D696C79262628612E7374796C652E666F6E7446616D696C793D746869732E5F6F7074696F6E732E636F6465426C6F636B466F6E7446616D696C79292C766F69';
wwv_flow_imp.g_varchar2_table(10589) := '642030213D3D746869732E5F6F7074696F6E732E636F6465426C6F636B466F6E7453697A65262628612E7374796C652E666F6E7453697A653D746869732E5F6F7074696F6E732E636F6465426C6F636B466F6E7453697A65292C617D2C6173796E635265';
wwv_flow_imp.g_varchar2_table(10590) := '6E64657243616C6C6261636B3A28293D3E746869732E5F6F6E44696452656E6465724173796E632E6669726528292C616374696F6E48616E646C65723A7B63616C6C6261636B3A743D3E674528746869732E5F6F70656E6572536572766963652C742C65';
wwv_flow_imp.g_varchar2_table(10591) := '2E697354727573746564292C646973706F7361626C65733A747D7D7D7D3B6173796E632066756E6374696F6E20674528652C742C6E297B7472797B72657475726E20617761697420652E6F70656E28742C7B66726F6D55736572476573747572653A2130';
wwv_flow_imp.g_varchar2_table(10592) := '2C616C6C6F77436F6E74726962757465644F70656E6572733A21302C616C6C6F77436F6D6D616E64733A6D45286E297D297D63617463682865297B72657475726E206B652865292C21317D7D66756E6374696F6E206D452865297B72657475726E21303D';
wwv_flow_imp.g_varchar2_table(10593) := '3D3D657C7C212821657C7C2141727261792E6973417272617928652E656E61626C6564436F6D6D616E647329292626652E656E61626C6564436F6D6D616E64737D70452E5F747470546F6B656E697A65723D65452822746F6B656E697A65546F53747269';
wwv_flow_imp.g_varchar2_table(10594) := '6E67222C7B63726561746548544D4C3A653D3E657D292C70453D68453D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765';
wwv_flow_imp.g_varchar2_table(10595) := '744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D526566';
wwv_flow_imp.g_varchar2_table(10596) := '6C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29';
wwv_flow_imp.g_varchar2_table(10597) := '297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B754528312C4C75292C754528322C6445295D2C7045293B7661722066452C76453D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(10598) := '7B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742062453D66453D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2866452E4944297D636F6E7374';
wwv_flow_imp.g_varchar2_table(10599) := '727563746F7228652C742C6E297B746869732E5F6F70656E6572536572766963653D6E2C746869732E5F6D6573736167655769646765743D6E65772063742C746869732E5F6D6573736167654C697374656E6572733D6E65772061742C746869732E5F6D';
wwv_flow_imp.g_varchar2_table(10600) := '6F7573654F7665724D6573736167653D21312C746869732E5F656469746F723D652C746869732E5F76697369626C653D66452E4D4553534147455F56495349424C452E62696E64546F2874297D646973706F736528297B76617220653B6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(10601) := '28653D746869732E5F6D657373616765297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F6D6573736167654C697374656E6572732E646973706F736528292C746869732E5F6D6573736167655769646765742E64697370';
wwv_flow_imp.g_varchar2_table(10602) := '6F736528292C746869732E5F76697369626C652E726573657428297D73686F774D65737361676528652C74297B6C6574206E3B58722872632865293F652E76616C75653A65292C746869732E5F76697369626C652E736574282130292C746869732E5F6D';
wwv_flow_imp.g_varchar2_table(10603) := '6573736167655769646765742E636C65617228292C746869732E5F6D6573736167654C697374656E6572732E636C65617228292C746869732E5F6D6573736167653D72632865293F4E6B28652C7B616374696F6E48616E646C65723A7B63616C6C626163';
wwv_flow_imp.g_varchar2_table(10604) := '6B3A743D3E7B746869732E636C6F73654D65737361676528292C674528746869732E5F6F70656E6572536572766963652C742C72632865293F652E6973547275737465643A766F69642030297D2C646973706F7361626C65733A746869732E5F6D657373';
wwv_flow_imp.g_varchar2_table(10605) := '6167654C697374656E6572737D7D293A766F696420302C746869732E5F6D6573736167655769646765742E76616C75653D6E6577205F4528746869732E5F656469746F722C742C22737472696E67223D3D747970656F6620653F653A746869732E5F6D65';
wwv_flow_imp.g_varchar2_table(10606) := '73736167652E656C656D656E74292C746869732E5F6D6573736167654C697374656E6572732E6164642876742E6465626F756E636528746869732E5F656469746F722E6F6E446964426C7572456469746F72546578742C2828652C74293D3E74292C3029';
wwv_flow_imp.g_varchar2_table(10607) := '282828293D3E7B746869732E5F6D6F7573654F7665724D6573736167657C7C746869732E5F6D6573736167655769646765742E76616C756526264273286A7328292C746869732E5F6D6573736167655769646765742E76616C75652E676574446F6D4E6F';
wwv_flow_imp.g_varchar2_table(10608) := '64652829297C7C746869732E636C6F73654D65737361676528297D2929292C746869732E5F6D6573736167654C697374656E6572732E61646428746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E28282829';
wwv_flow_imp.g_varchar2_table(10609) := '3D3E746869732E636C6F73654D65737361676528292929292C746869732E5F6D6573736167654C697374656E6572732E61646428746869732E5F656469746F722E6F6E446964446973706F7365282828293D3E746869732E636C6F73654D657373616765';
wwv_flow_imp.g_varchar2_table(10610) := '28292929292C746869732E5F6D6573736167654C697374656E6572732E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E636C6F73654D65737361676528292929292C746869732E5F6D6573';
wwv_flow_imp.g_varchar2_table(10611) := '736167654C697374656E6572732E61646428627328746869732E5F6D6573736167655769646765742E76616C75652E676574446F6D4E6F646528292C61722E4D4F5553455F454E5445522C2828293D3E746869732E5F6D6F7573654F7665724D65737361';
wwv_flow_imp.g_varchar2_table(10612) := '67653D2130292C213029292C746869732E5F6D6573736167654C697374656E6572732E61646428627328746869732E5F6D6573736167655769646765742E76616C75652E676574446F6D4E6F646528292C61722E4D4F5553455F4C454156452C2828293D';
wwv_flow_imp.g_varchar2_table(10613) := '3E746869732E5F6D6F7573654F7665724D6573736167653D2131292C213029292C746869732E5F6D6573736167654C697374656E6572732E61646428746869732E5F656469746F722E6F6E4D6F7573654D6F76652828653D3E7B652E7461726765742E70';
wwv_flow_imp.g_varchar2_table(10614) := '6F736974696F6E2626286E3F6E2E636F6E7461696E73506F736974696F6E28652E7461726765742E706F736974696F6E297C7C746869732E636C6F73654D65737361676528293A6E3D6E657720726828742E6C696E654E756D6265722D332C312C652E74';
wwv_flow_imp.g_varchar2_table(10615) := '61726765742E706F736974696F6E2E6C696E654E756D6265722B332C3129297D2929297D636C6F73654D65737361676528297B746869732E5F76697369626C652E726573657428292C746869732E5F6D6573736167654C697374656E6572732E636C6561';
wwv_flow_imp.g_varchar2_table(10616) := '7228292C746869732E5F6D6573736167655769646765742E76616C75652626746869732E5F6D6573736167654C697374656E6572732E616464285F452E666164654F757428746869732E5F6D6573736167655769646765742E76616C756529297D7D3B62';
wwv_flow_imp.g_varchar2_table(10617) := '452E49443D22656469746F722E636F6E747269622E6D657373616765436F6E74726F6C6C6572222C62452E4D4553534147455F56495349424C453D6E6577206C6428226D65737361676556697369626C65222C21312C6228302C22576865746865722074';
wwv_flow_imp.g_varchar2_table(10618) := '686520656469746F722069732063757272656E746C792073686F77696E6720616E20696E6C696E65206D6573736167652229292C62453D66453D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(10619) := '2C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D';
wwv_flow_imp.g_varchar2_table(10620) := '747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D';
wwv_flow_imp.g_varchar2_table(10621) := '28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B764528312C6364292C764528322C644529';
wwv_flow_imp.g_varchar2_table(10622) := '5D2C6245292C5964286E65772824642E62696E64546F436F6E747269627574696F6E2862452E6765742929287B69643A226C65617665456469746F724D657373616765222C707265636F6E646974696F6E3A62452E4D4553534147455F56495349424C45';
wwv_flow_imp.g_varchar2_table(10623) := '2C68616E646C65723A653D3E652E636C6F73654D65737361676528292C6B624F7074733A7B7765696768743A3133302C7072696D6172793A397D7D29293B636C617373205F457B73746174696320666164654F75742865297B636F6E737420743D28293D';
wwv_flow_imp.g_varchar2_table(10624) := '3E7B652E646973706F736528292C636C65617254696D656F7574286E292C652E676574446F6D4E6F646528292E72656D6F76654576656E744C697374656E65722822616E696D6174696F6E656E64222C74297D2C6E3D73657454696D656F757428742C31';
wwv_flow_imp.g_varchar2_table(10625) := '3130293B72657475726E20652E676574446F6D4E6F646528292E6164644576656E744C697374656E65722822616E696D6174696F6E656E64222C74292C652E676574446F6D4E6F646528292E636C6173734C6973742E6164642822666164654F75742229';
wwv_flow_imp.g_varchar2_table(10626) := '2C7B646973706F73653A747D7D636F6E7374727563746F7228652C7B6C696E654E756D6265723A742C636F6C756D6E3A6E7D2C69297B746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E73757070726573734D6F757365';
wwv_flow_imp.g_varchar2_table(10627) := '446F776E3D21312C746869732E5F656469746F723D652C746869732E5F656469746F722E72657665616C4C696E6573496E43656E74657249664F75747369646556696577706F727428742C742C30292C746869732E5F706F736974696F6E3D7B6C696E65';
wwv_flow_imp.g_varchar2_table(10628) := '4E756D6265723A742C636F6C756D6E3A6E7D2C746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734C6973742E61646428226D6F6E61636F2D65';
wwv_flow_imp.g_varchar2_table(10629) := '6469746F722D6F7665726C61796D65737361676522292C746869732E5F646F6D4E6F64652E7374796C652E6D617267696E4C6566743D222D367078223B636F6E7374206F3D646F63756D656E742E637265617465456C656D656E74282264697622293B6F';
wwv_flow_imp.g_varchar2_table(10630) := '2E636C6173734C6973742E6164642822616E63686F72222C22746F7022292C746869732E5F646F6D4E6F64652E617070656E644368696C64286F293B636F6E737420733D646F63756D656E742E637265617465456C656D656E74282264697622293B2273';
wwv_flow_imp.g_varchar2_table(10631) := '7472696E67223D3D747970656F6620693F28732E636C6173734C6973742E61646428226D65737361676522292C732E74657874436F6E74656E743D69293A28692E636C6173734C6973742E61646428226D65737361676522292C732E617070656E644368';
wwv_flow_imp.g_varchar2_table(10632) := '696C64286929292C746869732E5F646F6D4E6F64652E617070656E644368696C642873293B636F6E737420723D646F63756D656E742E637265617465456C656D656E74282264697622293B722E636C6173734C6973742E6164642822616E63686F72222C';
wwv_flow_imp.g_varchar2_table(10633) := '2262656C6F7722292C746869732E5F646F6D4E6F64652E617070656E644368696C642872292C746869732E5F656469746F722E616464436F6E74656E745769646765742874686973292C746869732E5F646F6D4E6F64652E636C6173734C6973742E6164';
wwv_flow_imp.g_varchar2_table(10634) := '64282266616465496E22297D646973706F736528297B746869732E5F656469746F722E72656D6F7665436F6E74656E745769646765742874686973297D676574496428297B72657475726E226D6573736167656F7665726C6179227D676574446F6D4E6F';
wwv_flow_imp.g_varchar2_table(10635) := '646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B706F736974696F6E3A746869732E5F706F736974696F6E2C707265666572656E63653A5B312C325D2C706F736974696F6E41666669';
wwv_flow_imp.g_varchar2_table(10636) := '6E6974793A317D7D616674657252656E6465722865297B746869732E5F646F6D4E6F64652E636C6173734C6973742E746F67676C65282262656C6F77222C323D3D3D65297D7D4A642862452E49442C62452C34293B636F6E73742079453D70632822636C';
wwv_flow_imp.g_varchar2_table(10637) := '6970626F6172645365727669636522292C77453D7063282270726F67726573735365727669636522293B4F626A6563742E667265657A65287B746F74616C28297B7D2C776F726B656428297B7D2C646F6E6528297B7D7D293B636C6173732043457B636F';
wwv_flow_imp.g_varchar2_table(10638) := '6E7374727563746F722865297B746869732E63616C6C6261636B3D657D7265706F72742865297B746869732E5F76616C75653D652C746869732E63616C6C6261636B28746869732E5F76616C7565297D7D43452E4E6F6E653D4F626A6563742E66726565';
wwv_flow_imp.g_varchar2_table(10639) := '7A65287B7265706F727428297B7D7D293B636F6E73742053453D70632822656469746F7250726F67726573735365727669636522292C78453D7B6374726C436D643A21312C616C743A21317D3B766172206B452C45453B2166756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(10640) := '655B652E426C75723D315D3D22426C7572222C655B652E476573747572653D325D3D2247657374757265222C655B652E4F746865723D335D3D224F74686572227D286B457C7C286B453D7B7D29292C66756E6374696F6E2865297B655B652E4E4F4E453D';
wwv_flow_imp.g_varchar2_table(10641) := '305D3D224E4F4E45222C655B652E46495253543D315D3D224649525354222C655B652E5345434F4E443D325D3D225345434F4E44222C655B652E4C4153543D335D3D224C415354227D2845457C7C2845453D7B7D29292C6E657720636C6173737B636F6E';
wwv_flow_imp.g_varchar2_table(10642) := '7374727563746F722865297B746869732E6F7074696F6E733D657D7D3B636F6E7374204C453D70632822717569636B496E7075745365727669636522293B66756E6374696F6E20444528652C742C6E297B6C657420693D6E756C6C2C6F3D6E756C6C3B69';
wwv_flow_imp.g_varchar2_table(10643) := '66282266756E6374696F6E223D3D747970656F66206E2E76616C75653F28693D2276616C7565222C6F3D6E2E76616C75652C30213D3D6F2E6C656E6774682626636F6E736F6C652E7761726E28224D656D6F697A652073686F756C64206F6E6C79206265';
wwv_flow_imp.g_varchar2_table(10644) := '207573656420696E2066756E6374696F6E732077697468207A65726F20706172616D65746572732229293A2266756E6374696F6E223D3D747970656F66206E2E676574262628693D22676574222C6F3D6E2E676574292C216F297468726F77206E657720';
wwv_flow_imp.g_varchar2_table(10645) := '4572726F7228226E6F7420737570706F7274656422293B636F6E737420733D60246D656D6F697A6524247B747D603B6E5B695D3D66756E6374696F6E282E2E2E65297B72657475726E20746869732E6861734F776E50726F70657274792873297C7C4F62';
wwv_flow_imp.g_varchar2_table(10646) := '6A6563742E646566696E6550726F706572747928746869732C732C7B636F6E666967757261626C653A21312C656E756D657261626C653A21312C7772697461626C653A21312C76616C75653A6F2E6170706C7928746869732C65297D292C746869735B73';
wwv_flow_imp.g_varchar2_table(10647) := '5D7D7D7661722054453B2166756E6374696F6E2865297B652E5461703D222D6D6F6E61636F2D67657374757265746170222C652E4368616E67653D222D6D6F6E61636F2D676573747572656368616E6765222C652E53746172743D222D6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(10648) := '676573747572657374617274222C652E456E643D222D6D6F6E61636F2D6765737475726573656E64222C652E436F6E746578746D656E753D222D6D6F6E61636F2D67657374757265636F6E746578746D656E75227D2854457C7C2854453D7B7D29293B63';
wwv_flow_imp.g_varchar2_table(10649) := '6C61737320494520657874656E6473206C747B636F6E7374727563746F7228297B737570657228292C746869732E646973706174636865643D21312C746869732E746172676574733D6E65772067742C746869732E69676E6F7265546172676574733D6E';
wwv_flow_imp.g_varchar2_table(10650) := '65772067742C746869732E616374697665546F75636865733D7B7D2C746869732E68616E646C653D6E756C6C2C746869732E5F6C617374536574546170436F756E7454696D653D302C746869732E5F72656769737465722876742E72756E416E64537562';
wwv_flow_imp.g_varchar2_table(10651) := '7363726962652870732C28287B77696E646F773A652C646973706F7361626C65733A747D293D3E7B742E61646428627328652E646F63756D656E742C22746F7563687374617274222C28653D3E746869732E6F6E546F7563685374617274286529292C7B';
wwv_flow_imp.g_varchar2_table(10652) := '706173736976653A21317D29292C742E61646428627328652E646F63756D656E742C22746F756368656E64222C28743D3E746869732E6F6E546F756368456E6428652C74292929292C742E61646428627328652E646F63756D656E742C22746F7563686D';
wwv_flow_imp.g_varchar2_table(10653) := '6F7665222C28653D3E746869732E6F6E546F7563684D6F7665286529292C7B706173736976653A21317D29297D292C7B77696E646F773A732C646973706F7361626C65733A746869732E5F73746F72657D29297D73746174696320616464546172676574';
wwv_flow_imp.g_varchar2_table(10654) := '2865297B72657475726E2049452E6973546F75636844657669636528293F2849452E494E5354414E43457C7C2849452E494E5354414E43453D6E74286E657720494529292C72742849452E494E5354414E43452E746172676574732E7075736828652929';
wwv_flow_imp.g_varchar2_table(10655) := '293A6C742E4E6F6E657D7374617469632069676E6F72655461726765742865297B72657475726E2049452E6973546F75636844657669636528293F2849452E494E5354414E43457C7C2849452E494E5354414E43453D6E74286E657720494529292C7274';
wwv_flow_imp.g_varchar2_table(10656) := '2849452E494E5354414E43452E69676E6F7265546172676574732E7075736828652929293A6C742E4E6F6E657D737461746963206973546F75636844657669636528297B72657475726E226F6E746F756368737461727422696E20737C7C6E6176696761';
wwv_flow_imp.g_varchar2_table(10657) := '746F722E6D6178546F756368506F696E74733E307D646973706F736528297B746869732E68616E646C65262628746869732E68616E646C652E646973706F736528292C746869732E68616E646C653D6E756C6C292C73757065722E646973706F73652829';
wwv_flow_imp.g_varchar2_table(10658) := '7D6F6E546F75636853746172742865297B636F6E737420743D446174652E6E6F7728293B746869732E68616E646C65262628746869732E68616E646C652E646973706F736528292C746869732E68616E646C653D6E756C6C293B666F72286C6574206E3D';
wwv_flow_imp.g_varchar2_table(10659) := '302C693D652E746172676574546F75636865732E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D652E746172676574546F75636865732E6974656D286E293B746869732E616374697665546F75636865735B692E6964656E7469666965725D';
wwv_flow_imp.g_varchar2_table(10660) := '3D7B69643A692E6964656E7469666965722C696E697469616C5461726765743A692E7461726765742C696E697469616C54696D655374616D703A742C696E697469616C50616765583A692E70616765582C696E697469616C50616765593A692E70616765';
wwv_flow_imp.g_varchar2_table(10661) := '592C726F6C6C696E6754696D657374616D70733A5B745D2C726F6C6C696E6750616765583A5B692E70616765585D2C726F6C6C696E6750616765593A5B692E70616765595D7D3B636F6E7374206F3D746869732E6E6577476573747572654576656E7428';
wwv_flow_imp.g_varchar2_table(10662) := '54452E53746172742C692E746172676574293B6F2E70616765583D692E70616765582C6F2E70616765593D692E70616765592C746869732E64697370617463684576656E74286F297D746869732E64697370617463686564262628652E70726576656E74';
wwv_flow_imp.g_varchar2_table(10663) := '44656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E646973706174636865643D2131297D6F6E546F756368456E6428652C74297B636F6E7374206E3D446174652E6E6F7728292C693D4F626A6563742E6B6579732874';
wwv_flow_imp.g_varchar2_table(10664) := '6869732E616374697665546F7563686573292E6C656E6774683B666F72286C6574206F3D302C733D742E6368616E676564546F75636865732E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D742E6368616E676564546F75636865732E6974';
wwv_flow_imp.g_varchar2_table(10665) := '656D286F293B69662821746869732E616374697665546F75636865732E6861734F776E50726F706572747928537472696E6728732E6964656E7469666965722929297B636F6E736F6C652E7761726E28226D6F7665206F6620616E20554E4B4E4F574E20';
wwv_flow_imp.g_varchar2_table(10666) := '746F756368222C73293B636F6E74696E75657D636F6E737420723D746869732E616374697665546F75636865735B732E6964656E7469666965725D2C613D446174652E6E6F7728292D722E696E697469616C54696D655374616D703B696628613C49452E';
wwv_flow_imp.g_varchar2_table(10667) := '484F4C445F44454C415926264D6174682E61627328722E696E697469616C50616765582D4E6828722E726F6C6C696E67506167655829293C333026264D6174682E61627328722E696E697469616C50616765592D4E6828722E726F6C6C696E6750616765';
wwv_flow_imp.g_varchar2_table(10668) := '5929293C3330297B636F6E737420653D746869732E6E6577476573747572654576656E742854452E5461702C722E696E697469616C546172676574293B652E70616765583D4E6828722E726F6C6C696E675061676558292C652E70616765593D4E682872';
wwv_flow_imp.g_varchar2_table(10669) := '2E726F6C6C696E675061676559292C746869732E64697370617463684576656E742865297D656C736520696628613E3D49452E484F4C445F44454C415926264D6174682E61627328722E696E697469616C50616765582D4E6828722E726F6C6C696E6750';
wwv_flow_imp.g_varchar2_table(10670) := '6167655829293C333026264D6174682E61627328722E696E697469616C50616765592D4E6828722E726F6C6C696E67506167655929293C3330297B636F6E737420653D746869732E6E6577476573747572654576656E742854452E436F6E746578746D65';
wwv_flow_imp.g_varchar2_table(10671) := '6E752C722E696E697469616C546172676574293B652E70616765583D4E6828722E726F6C6C696E675061676558292C652E70616765593D4E6828722E726F6C6C696E675061676559292C746869732E64697370617463684576656E742865297D656C7365';
wwv_flow_imp.g_varchar2_table(10672) := '20696628313D3D3D69297B636F6E737420743D4E6828722E726F6C6C696E675061676558292C693D4E6828722E726F6C6C696E675061676559292C6F3D4E6828722E726F6C6C696E6754696D657374616D7073292D722E726F6C6C696E6754696D657374';
wwv_flow_imp.g_varchar2_table(10673) := '616D70735B305D2C733D742D722E726F6C6C696E6750616765585B305D2C613D692D722E726F6C6C696E6750616765595B305D2C6C3D5B2E2E2E746869732E746172676574735D2E66696C7465722828653D3E722E696E697469616C5461726765742069';
wwv_flow_imp.g_varchar2_table(10674) := '6E7374616E63656F66204E6F64652626652E636F6E7461696E7328722E696E697469616C5461726765742929293B746869732E696E657274696128652C6C2C6E2C4D6174682E6162732873292F6F2C733E303F313A2D312C742C4D6174682E6162732861';
wwv_flow_imp.g_varchar2_table(10675) := '292F6F2C613E303F313A2D312C69297D746869732E64697370617463684576656E7428746869732E6E6577476573747572654576656E742854452E456E642C722E696E697469616C54617267657429292C64656C65746520746869732E61637469766554';
wwv_flow_imp.g_varchar2_table(10676) := '6F75636865735B732E6964656E7469666965725D7D746869732E64697370617463686564262628742E70726576656E7444656661756C7428292C742E73746F7050726F7061676174696F6E28292C746869732E646973706174636865643D2131297D6E65';
wwv_flow_imp.g_varchar2_table(10677) := '77476573747572654576656E7428652C74297B636F6E7374206E3D646F63756D656E742E6372656174654576656E742822437573746F6D4576656E7422293B72657475726E206E2E696E69744576656E7428652C21312C2130292C6E2E696E697469616C';
wwv_flow_imp.g_varchar2_table(10678) := '5461726765743D742C6E2E746170436F756E743D302C6E7D64697370617463684576656E742865297B696628652E747970653D3D3D54452E546170297B636F6E737420743D286E65772044617465292E67657454696D6528293B6C6574206E3D303B6E3D';
wwv_flow_imp.g_varchar2_table(10679) := '742D746869732E5F6C617374536574546170436F756E7454696D653E49452E434C4541525F5441505F434F554E545F54494D453F313A322C746869732E5F6C617374536574546170436F756E7454696D653D742C652E746170436F756E743D6E7D656C73';
wwv_flow_imp.g_varchar2_table(10680) := '6520652E74797065213D3D54452E4368616E67652626652E74797065213D3D54452E436F6E746578746D656E757C7C28746869732E5F6C617374536574546170436F756E7454696D653D30293B696628652E696E697469616C54617267657420696E7374';
wwv_flow_imp.g_varchar2_table(10681) := '616E63656F66204E6F6465297B666F7228636F6E73742074206F6620746869732E69676E6F72655461726765747329696628742E636F6E7461696E7328652E696E697469616C546172676574292972657475726E3B636F6E737420743D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(10682) := '636F6E7374206E206F6620746869732E74617267657473296966286E2E636F6E7461696E7328652E696E697469616C54617267657429297B6C657420693D302C6F3D652E696E697469616C5461726765743B666F72283B6F26266F213D3D6E3B29692B2B';
wwv_flow_imp.g_varchar2_table(10683) := '2C6F3D6F2E706172656E74456C656D656E743B742E70757368285B692C6E5D297D742E736F7274282828652C74293D3E655B305D2D745B305D29293B666F7228636F6E73745B6E2C695D6F66207429692E64697370617463684576656E742865292C7468';
wwv_flow_imp.g_varchar2_table(10684) := '69732E646973706174636865643D21307D7D696E657274696128652C742C6E2C692C6F2C732C722C612C6C297B746869732E68616E646C653D787328652C2828293D3E7B636F6E737420633D446174652E6E6F7728292C643D632D6E3B6C657420683D30';
wwv_flow_imp.g_varchar2_table(10685) := '2C753D302C703D21303B692B3D49452E5343524F4C4C5F4652494354494F4E2A642C722B3D49452E5343524F4C4C5F4652494354494F4E2A642C693E30262628703D21312C683D6F2A692A64292C723E30262628703D21312C753D612A722A64293B636F';
wwv_flow_imp.g_varchar2_table(10686) := '6E737420673D746869732E6E6577476573747572654576656E742854452E4368616E6765293B672E7472616E736C6174696F6E583D682C672E7472616E736C6174696F6E593D752C742E666F72456163682828653D3E652E64697370617463684576656E';
wwv_flow_imp.g_varchar2_table(10687) := '7428672929292C707C7C746869732E696E657274696128652C742C632C692C6F2C732B682C722C612C6C2B75297D29297D6F6E546F7563684D6F76652865297B636F6E737420743D446174652E6E6F7728293B666F72286C6574206E3D302C693D652E63';
wwv_flow_imp.g_varchar2_table(10688) := '68616E676564546F75636865732E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D652E6368616E676564546F75636865732E6974656D286E293B69662821746869732E616374697665546F75636865732E6861734F776E50726F7065727479';
wwv_flow_imp.g_varchar2_table(10689) := '28537472696E6728692E6964656E7469666965722929297B636F6E736F6C652E7761726E2822656E64206F6620616E20554E4B4E4F574E20746F756368222C69293B636F6E74696E75657D636F6E7374206F3D746869732E616374697665546F75636865';
wwv_flow_imp.g_varchar2_table(10690) := '735B692E6964656E7469666965725D2C733D746869732E6E6577476573747572654576656E742854452E4368616E67652C6F2E696E697469616C546172676574293B732E7472616E736C6174696F6E583D692E70616765582D4E68286F2E726F6C6C696E';
wwv_flow_imp.g_varchar2_table(10691) := '675061676558292C732E7472616E736C6174696F6E593D692E70616765592D4E68286F2E726F6C6C696E675061676559292C732E70616765583D692E70616765582C732E70616765593D692E70616765592C746869732E64697370617463684576656E74';
wwv_flow_imp.g_varchar2_table(10692) := '2873292C6F2E726F6C6C696E6750616765582E6C656E6774683E332626286F2E726F6C6C696E6750616765582E736869667428292C6F2E726F6C6C696E6750616765592E736869667428292C6F2E726F6C6C696E6754696D657374616D70732E73686966';
wwv_flow_imp.g_varchar2_table(10693) := '742829292C6F2E726F6C6C696E6750616765582E7075736828692E7061676558292C6F2E726F6C6C696E6750616765592E7075736828692E7061676559292C6F2E726F6C6C696E6754696D657374616D70732E707573682874297D746869732E64697370';
wwv_flow_imp.g_varchar2_table(10694) := '617463686564262628652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E646973706174636865643D2131297D7D49452E5343524F4C4C5F4652494354494F4E3D2D2E3030352C49452E484F4C';
wwv_flow_imp.g_varchar2_table(10695) := '445F44454C41593D3730302C49452E434C4541525F5441505F434F554E545F54494D453D3430302C66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F';
wwv_flow_imp.g_varchar2_table(10696) := '693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E646563';
wwv_flow_imp.g_varchar2_table(10697) := '6F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C';
wwv_flow_imp.g_varchar2_table(10698) := '6E2C72293A6F28742C6E29297C7C72293B733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72297D285B44455D2C49452C226973546F756368446576696365222C6E756C6C293B6C6574204D453D28293D3E287B6765';
wwv_flow_imp.g_varchar2_table(10699) := '742064656C617928297B72657475726E2D317D2C646973706F73653A28293D3E7B7D2C73686F77486F7665723A28293D3E7B7D7D293B636F6E73742041453D6E6577206969282828293D3E4D4528226D6F757365222C21312929292C4E453D6E65772069';
wwv_flow_imp.g_varchar2_table(10700) := '69282828293D3E4D452822656C656D656E74222C21312929293B66756E6374696F6E2050452865297B72657475726E22656C656D656E74223D3D3D653F4E452E76616C75653A41452E76616C75657D66756E6374696F6E204F4528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(10701) := '4D452822656C656D656E74222C2130297D7661722052453D6E2838383830292C46453D7B7D3B46452E7374796C655461675472616E73666F726D3D6A7228292C46452E736574417474726962757465733D567228292C46452E696E736572743D46722829';
wwv_flow_imp.g_varchar2_table(10702) := '2E62696E64286E756C6C2C226865616422292C46452E646F6D4150493D4F7228292C46452E696E736572745374796C65456C656D656E743D487228292C4E7228292852452E412C4645292C52452E41262652452E412E6C6F63616C73262652452E412E6C';
wwv_flow_imp.g_varchar2_table(10703) := '6F63616C733B6C65742042453D7B73686F77486F7665723A28293D3E7B7D2C68696465486F7665723A28293D3E7B7D2C73686F77416E64466F6375734C617374486F7665723A28293D3E7B7D2C7365747570557064617461626C65486F7665723A28293D';
wwv_flow_imp.g_varchar2_table(10704) := '3E6E756C6C7D3B66756E6374696F6E20564528297B72657475726E2042457D68752E77686974652E746F537472696E6728292C68752E77686974652E746F537472696E6728293B636C617373207A4520657874656E6473206C747B676574206F6E446964';
wwv_flow_imp.g_varchar2_table(10705) := '436C69636B28297B72657475726E20746869732E5F6F6E446964436C69636B2E6576656E747D636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6C6162656C3D22222C746869732E5F6F6E446964436C69636B3D746869732E';
wwv_flow_imp.g_varchar2_table(10706) := '5F7265676973746572286E6577204374292C746869732E5F6F6E4469644573636170653D746869732E5F7265676973746572286E6577204374292C746869732E6F7074696F6E733D742C746869732E5F656C656D656E743D646F63756D656E742E637265';
wwv_flow_imp.g_varchar2_table(10707) := '617465456C656D656E7428226122292C746869732E5F656C656D656E742E636C6173734C6973742E61646428226D6F6E61636F2D627574746F6E22292C746869732E5F656C656D656E742E746162496E6465783D302C746869732E5F656C656D656E742E';
wwv_flow_imp.g_varchar2_table(10708) := '7365744174747269627574652822726F6C65222C22627574746F6E22292C746869732E5F656C656D656E742E636C6173734C6973742E746F67676C6528227365636F6E64617279222C2121742E7365636F6E64617279293B636F6E7374206E3D742E7365';
wwv_flow_imp.g_varchar2_table(10709) := '636F6E646172793F742E627574746F6E5365636F6E646172794261636B67726F756E643A742E627574746F6E4261636B67726F756E642C693D742E7365636F6E646172793F742E627574746F6E5365636F6E64617279466F726567726F756E643A742E62';
wwv_flow_imp.g_varchar2_table(10710) := '7574746F6E466F726567726F756E643B746869732E5F656C656D656E742E7374796C652E636F6C6F723D697C7C22222C746869732E5F656C656D656E742E7374796C652E6261636B67726F756E64436F6C6F723D6E7C7C22222C742E737570706F727453';
wwv_flow_imp.g_varchar2_table(10711) := '686F72744C6162656C262628746869732E5F6C6162656C53686F7274456C656D656E743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6C6162656C53686F7274456C656D656E742E636C6173734C6973742E';
wwv_flow_imp.g_varchar2_table(10712) := '61646428226D6F6E61636F2D627574746F6E2D6C6162656C2D73686F727422292C746869732E5F656C656D656E742E617070656E644368696C6428746869732E5F6C6162656C53686F7274456C656D656E74292C746869732E5F6C6162656C456C656D65';
wwv_flow_imp.g_varchar2_table(10713) := '6E743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6C6162656C456C656D656E742E636C6173734C6973742E61646428226D6F6E61636F2D627574746F6E2D6C6162656C22292C746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(10714) := '6E742E617070656E644368696C6428746869732E5F6C6162656C456C656D656E74292C746869732E5F656C656D656E742E636C6173734C6973742E61646428226D6F6E61636F2D746578742D627574746F6E2D776974682D73686F72742D6C6162656C22';
wwv_flow_imp.g_varchar2_table(10715) := '29292C22737472696E67223D3D747970656F6620742E7469746C652626746869732E7365745469746C6528742E7469746C65292C22737472696E67223D3D747970656F6620742E617269614C6162656C2626746869732E5F656C656D656E742E73657441';
wwv_flow_imp.g_varchar2_table(10716) := '74747269627574652822617269612D6C6162656C222C742E617269614C6162656C292C652E617070656E644368696C6428746869732E5F656C656D656E74292C746869732E5F72656769737465722849452E61646454617267657428746869732E5F656C';
wwv_flow_imp.g_varchar2_table(10717) := '656D656E7429292C5B61722E434C49434B2C54452E5461705D2E666F72456163682828653D3E7B746869732E5F726567697374657228627328746869732E5F656C656D656E742C652C28653D3E7B746869732E656E61626C65643F746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(10718) := '6964436C69636B2E666972652865293A63722865297D2929297D29292C746869732E5F726567697374657228627328746869732E5F656C656D656E742C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B6C657420';
wwv_flow_imp.g_varchar2_table(10719) := '6E3D21313B746869732E656E61626C6564262628742E657175616C732833297C7C742E657175616C7328313029293F28746869732E5F6F6E446964436C69636B2E666972652865292C6E3D2130293A742E657175616C73283929262628746869732E5F6F';
wwv_flow_imp.g_varchar2_table(10720) := '6E4469644573636170652E666972652865292C746869732E5F656C656D656E742E626C757228292C6E3D2130292C6E2626637228742C2130297D2929292C746869732E5F726567697374657228627328746869732E5F656C656D656E742C61722E4D4F55';
wwv_flow_imp.g_varchar2_table(10721) := '53455F4F5645522C28653D3E7B746869732E5F656C656D656E742E636C6173734C6973742E636F6E7461696E73282264697361626C656422297C7C746869732E7570646174654261636B67726F756E64282130297D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(10722) := '74657228627328746869732E5F656C656D656E742C61722E4D4F5553455F4F55542C28653D3E7B746869732E7570646174654261636B67726F756E64282131297D2929292C746869732E666F637573547261636B65723D746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(10723) := '7228687228746869732E5F656C656D656E7429292C746869732E5F726567697374657228746869732E666F637573547261636B65722E6F6E446964466F637573282828293D3E7B746869732E656E61626C65642626746869732E7570646174654261636B';
wwv_flow_imp.g_varchar2_table(10724) := '67726F756E64282130297D2929292C746869732E5F726567697374657228746869732E666F637573547261636B65722E6F6E446964426C7572282828293D3E7B746869732E656E61626C65642626746869732E7570646174654261636B67726F756E6428';
wwv_flow_imp.g_varchar2_table(10725) := '2131297D2929297D646973706F736528297B73757065722E646973706F736528292C746869732E5F656C656D656E742E72656D6F766528297D676574436F6E74656E74456C656D656E74732865297B636F6E737420743D5B5D3B666F72286C6574206E20';
wwv_flow_imp.g_varchar2_table(10726) := '6F6620536B2865292969662822737472696E67223D3D747970656F66206E297B6966286E3D6E2E7472696D28292C22223D3D3D6E29636F6E74696E75653B636F6E737420653D646F63756D656E742E637265617465456C656D656E7428227370616E2229';
wwv_flow_imp.g_varchar2_table(10727) := '3B652E74657874436F6E74656E743D6E2C742E707573682865297D656C736520742E70757368286E293B72657475726E20747D7570646174654261636B67726F756E642865297B6C657420743B743D746869732E6F7074696F6E732E7365636F6E646172';
wwv_flow_imp.g_varchar2_table(10728) := '793F653F746869732E6F7074696F6E732E627574746F6E5365636F6E64617279486F7665724261636B67726F756E643A746869732E6F7074696F6E732E627574746F6E5365636F6E646172794261636B67726F756E643A653F746869732E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(10729) := '732E627574746F6E486F7665724261636B67726F756E643A746869732E6F7074696F6E732E627574746F6E4261636B67726F756E642C74262628746869732E5F656C656D656E742E7374796C652E6261636B67726F756E64436F6C6F723D74297D676574';
wwv_flow_imp.g_varchar2_table(10730) := '20656C656D656E7428297B72657475726E20746869732E5F656C656D656E747D736574206C6162656C2865297B76617220742C6E2C693B696628746869732E5F6C6162656C3D3D3D652972657475726E3B696628726328746869732E5F6C6162656C2926';
wwv_flow_imp.g_varchar2_table(10731) := '267263286529262628286E3D746869732E5F6C6162656C293D3D3D28693D65297C7C6E26266926266E2E76616C75653D3D3D692E76616C756526266E2E6973547275737465643D3D3D692E69735472757374656426266E2E737570706F72745468656D65';
wwv_flow_imp.g_varchar2_table(10732) := '49636F6E733D3D3D692E737570706F72745468656D6549636F6E7326266E2E737570706F727448746D6C3D3D3D692E737570706F727448746D6C2626286E2E626173655572693D3D3D692E626173655572697C7C6E2E626173655572692626692E626173';
wwv_flow_imp.g_varchar2_table(10733) := '655572692626556C284E6F2E66726F6D286E2E62617365557269292C4E6F2E66726F6D28692E62617365557269292929292972657475726E3B746869732E5F656C656D656E742E636C6173734C6973742E61646428226D6F6E61636F2D746578742D6275';
wwv_flow_imp.g_varchar2_table(10734) := '74746F6E22293B636F6E7374206F3D746869732E6F7074696F6E732E737570706F727453686F72744C6162656C3F746869732E5F6C6162656C456C656D656E743A746869732E5F656C656D656E743B6966287263286529297B636F6E7374206E3D4E6B28';
wwv_flow_imp.g_varchar2_table(10735) := '652C7B696E6C696E653A21307D293B6E2E646973706F736528293B636F6E737420693D6E756C6C3D3D3D28743D6E2E656C656D656E742E717565727953656C6563746F722822702229297C7C766F696420303D3D3D743F766F696420303A742E696E6E65';
wwv_flow_imp.g_varchar2_table(10736) := '7248544D4C3B69662869297B636F6E737420653D586E28692C7B4144445F544147533A5B2262222C2269222C2275222C22636F6465222C227370616E225D2C414C4C4F5745445F415454523A5B22636C617373225D2C52455455524E5F54525553544544';
wwv_flow_imp.g_varchar2_table(10737) := '5F545950453A21307D293B6F2E696E6E657248544D4C3D657D656C7365206772286F297D656C736520746869732E6F7074696F6E732E737570706F727449636F6E733F6772286F2C2E2E2E746869732E676574436F6E74656E74456C656D656E74732865';
wwv_flow_imp.g_varchar2_table(10738) := '29293A6F2E74657874436F6E74656E743D653B6C657420733D22223B22737472696E67223D3D747970656F6620746869732E6F7074696F6E732E7469746C653F733D746869732E6F7074696F6E732E7469746C653A746869732E6F7074696F6E732E7469';
wwv_flow_imp.g_varchar2_table(10739) := '746C65262628733D66756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620653F653A66756E6374696F6E2865297B76617220743B6C6574206E3D6E756C6C213D3D28743D652E76616C7565292626766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(10740) := '743F743A22223B6E2E6C656E6774683E3165352626286E3D60247B6E2E73756273747228302C316535297DE280A660293B636F6E737420693D446B2E7061727365286E2C7B72656E64657265723A566B2E76616C75657D292E7265706C616365282F2628';
wwv_flow_imp.g_varchar2_table(10741) := '235C642B7C5B612D7A412D5A5D2B293B2F672C28653D3E7B76617220743B72657475726E206E756C6C213D3D28743D426B2E676574286529292626766F69642030213D3D743F743A657D29293B72657475726E20526B287B6973547275737465643A2131';
wwv_flow_imp.g_varchar2_table(10742) := '7D2C69292E746F537472696E6728297D2865297D286529292C746869732E7365745469746C652873292C22737472696E67223D3D747970656F6620746869732E6F7074696F6E732E617269614C6162656C3F746869732E5F656C656D656E742E73657441';
wwv_flow_imp.g_varchar2_table(10743) := '74747269627574652822617269612D6C6162656C222C746869732E6F7074696F6E732E617269614C6162656C293A746869732E6F7074696F6E732E617269614C6162656C2626746869732E5F656C656D656E742E73657441747472696275746528226172';
wwv_flow_imp.g_varchar2_table(10744) := '69612D6C6162656C222C73292C746869732E5F6C6162656C3D657D676574206C6162656C28297B72657475726E20746869732E5F6C6162656C7D7365742069636F6E2865297B746869732E5F656C656D656E742E636C6173734C6973742E616464282E2E';
wwv_flow_imp.g_varchar2_table(10745) := '2E546C2E6173436C6173734E616D654172726179286529297D73657420656E61626C65642865297B653F28746869732E5F656C656D656E742E636C6173734C6973742E72656D6F7665282264697361626C656422292C746869732E5F656C656D656E742E';
wwv_flow_imp.g_varchar2_table(10746) := '7365744174747269627574652822617269612D64697361626C6564222C537472696E6728213129292C746869732E5F656C656D656E742E746162496E6465783D30293A28746869732E5F656C656D656E742E636C6173734C6973742E6164642822646973';
wwv_flow_imp.g_varchar2_table(10747) := '61626C656422292C746869732E5F656C656D656E742E7365744174747269627574652822617269612D64697361626C6564222C537472696E672821302929297D67657420656E61626C656428297B72657475726E21746869732E5F656C656D656E742E63';
wwv_flow_imp.g_varchar2_table(10748) := '6C6173734C6973742E636F6E7461696E73282264697361626C656422297D7365745469746C652865297B76617220743B746869732E5F686F7665727C7C22223D3D3D653F746869732E5F686F7665722626746869732E5F686F7665722E75706461746528';
wwv_flow_imp.g_varchar2_table(10749) := '65293A746869732E5F686F7665723D746869732E5F726567697374657228564528292E7365747570557064617461626C65486F766572286E756C6C213D3D28743D746869732E6F7074696F6E732E686F76657244656C6567617465292626766F69642030';
wwv_flow_imp.g_varchar2_table(10750) := '213D3D743F743A504528226D6F75736522292C746869732E5F656C656D656E742C6529297D7D7661722048453D6E2839393236292C57453D7B7D3B57452E7374796C655461675472616E73666F726D3D6A7228292C57452E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(10751) := '733D567228292C57452E696E736572743D467228292E62696E64286E756C6C2C226865616422292C57452E646F6D4150493D4F7228292C57452E696E736572745374796C65456C656D656E743D487228292C4E7228292848452E412C5745292C48452E41';
wwv_flow_imp.g_varchar2_table(10752) := '262648452E412E6C6F63616C73262648452E412E6C6F63616C733B636F6E7374206A453D70632822636F6E74657874566965775365727669636522292C71453D70632822636F6E746578744D656E755365727669636522292C24453D706328226B657962';
wwv_flow_imp.g_varchar2_table(10753) := '696E64696E675365727669636522293B7661722055452C4B453D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F77';
wwv_flow_imp.g_varchar2_table(10754) := '6E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563';
wwv_flow_imp.g_varchar2_table(10755) := '742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C';
wwv_flow_imp.g_varchar2_table(10756) := '72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C47453D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C';
wwv_flow_imp.g_varchar2_table(10757) := '65742051453D55453D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C63297B737570657228292C746869732E7479706549643D652C746869732E656469746F723D742C746869732E';
wwv_flow_imp.g_varchar2_table(10758) := '73686F77436F6D6D616E643D692C746869732E72616E67653D6F2C746869732E65646974733D732C746869732E6F6E53656C6563744E6577456469743D722C746869732E5F636F6E746578744D656E75536572766963653D612C746869732E5F6B657962';
wwv_flow_imp.g_varchar2_table(10759) := '696E64696E67536572766963653D632C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E73757070726573734D6F757365446F776E3D21302C746869732E63726561746528292C746869732E76697369626C65436F6E74';
wwv_flow_imp.g_varchar2_table(10760) := '6578743D6E2E62696E64546F286C292C746869732E76697369626C65436F6E746578742E736574282130292C746869732E5F7265676973746572287274282828293D3E746869732E76697369626C65436F6E746578742E726573657428292929292C7468';
wwv_flow_imp.g_varchar2_table(10761) := '69732E656469746F722E616464436F6E74656E745769646765742874686973292C746869732E656469746F722E6C61796F7574436F6E74656E745769646765742874686973292C746869732E5F7265676973746572287274282828293D3E746869732E65';
wwv_flow_imp.g_varchar2_table(10762) := '6469746F722E72656D6F7665436F6E74656E745769646765742874686973292929292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E2828653D3E7B6F2E636F6E7461';
wwv_flow_imp.g_varchar2_table(10763) := '696E73506F736974696F6E28652E706F736974696F6E297C7C746869732E646973706F736528297D2929292C746869732E5F72656769737465722876742E72756E416E6453756273637269626528632E6F6E4469645570646174654B657962696E64696E';
wwv_flow_imp.g_varchar2_table(10764) := '67732C2828293D3E7B746869732E5F757064617465427574746F6E5469746C6528297D2929297D5F757064617465427574746F6E5469746C6528297B76617220653B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F6B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(10765) := '536572766963652E6C6F6F6B75704B657962696E64696E6728746869732E73686F77436F6D6D616E642E696429297C7C766F696420303D3D3D653F766F696420303A652E6765744C6162656C28293B746869732E627574746F6E2E656C656D656E742E74';
wwv_flow_imp.g_varchar2_table(10766) := '69746C653D746869732E73686F77436F6D6D616E642E6C6162656C2B28743F602028247B747D29603A2222297D63726561746528297B746869732E646F6D4E6F64653D627228222E706F73742D656469742D77696467657422292C746869732E62757474';
wwv_flow_imp.g_varchar2_table(10767) := '6F6E3D746869732E5F7265676973746572286E6577207A4528746869732E646F6D4E6F64652C7B737570706F727449636F6E733A21307D29292C746869732E627574746F6E2E6C6162656C3D222428696E7365727429222C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(10768) := '657228627328746869732E646F6D4E6F64652C61722E434C49434B2C2828293D3E746869732E73686F7753656C6563746F7228292929297D676574496428297B72657475726E2055452E6261736549642B222E222B746869732E7479706549647D676574';
wwv_flow_imp.g_varchar2_table(10769) := '446F6D4E6F646528297B72657475726E20746869732E646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B706F736974696F6E3A746869732E72616E67652E676574456E64506F736974696F6E28292C707265666572656E63653A5B';
wwv_flow_imp.g_varchar2_table(10770) := '325D7D7D73686F7753656C6563746F7228297B746869732E5F636F6E746578744D656E75536572766963652E73686F77436F6E746578744D656E75287B676574416E63686F723A28293D3E7B636F6E737420653D417328746869732E627574746F6E2E65';
wwv_flow_imp.g_varchar2_table(10771) := '6C656D656E74293B72657475726E7B783A652E6C6566742B652E77696474682C793A652E746F702B652E6865696768747D7D2C676574416374696F6E733A28293D3E746869732E65646974732E616C6C45646974732E6D6170282828652C74293D3E5363';
wwv_flow_imp.g_varchar2_table(10772) := '287B69643A22222C6C6162656C3A652E7469746C652C636865636B65643A743D3D3D746869732E65646974732E61637469766545646974496E6465782C72756E3A28293D3E7B69662874213D3D746869732E65646974732E61637469766545646974496E';
wwv_flow_imp.g_varchar2_table(10773) := '6465782972657475726E20746869732E6F6E53656C6563744E6577456469742874297D7D2929297D297D7D3B51452E6261736549643D22656469746F722E7769646765742E706F737445646974576964676574222C51453D55453D4B45285B474528372C';
wwv_flow_imp.g_varchar2_table(10774) := '7145292C474528382C6364292C474528392C2445295D2C5145293B6C65742059453D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E5F69643D652C746869732E';
wwv_flow_imp.g_varchar2_table(10775) := '5F656469746F723D742C746869732E5F76697369626C65436F6E746578743D6E2C746869732E5F73686F77436F6D6D616E643D692C746869732E5F696E7374616E74696174696F6E536572766963653D6F2C746869732E5F62756C6B4564697453657276';
wwv_flow_imp.g_varchar2_table(10776) := '6963653D732C746869732E5F63757272656E745769646765743D746869732E5F7265676973746572286E6577206374292C746869732E5F72656769737465722876742E616E7928742E6F6E4469644368616E67654D6F64656C2C742E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(10777) := '6E67654D6F64656C436F6E74656E7429282828293D3E746869732E636C65617228292929297D6173796E63206170706C7945646974416E6453686F7749664E656564656428652C742C6E2C692C6F297B636F6E737420733D746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(10778) := '2E6765744D6F64656C28293B69662821737C7C21652E6C656E6774682972657475726E3B636F6E737420723D742E616C6C45646974732E617428742E61637469766545646974496E646578293B69662821722972657475726E3B636F6E737420613D6177';
wwv_flow_imp.g_varchar2_table(10779) := '616974206928722C6F293B6966286F2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B636F6E7374206C3D6F6B28732E7572692C652C61292C633D655B305D2C643D732E64656C74614465636F726174696F6E73285B5D2C';
wwv_flow_imp.g_varchar2_table(10780) := '5B7B72616E67653A632C6F7074696F6E733A7B6465736372697074696F6E3A2270617374652D6C696E652D737566666978222C737469636B696E6573733A307D7D5D293B6C657420682C753B746869732E5F656469746F722E666F63757328293B747279';
wwv_flow_imp.g_varchar2_table(10781) := '7B683D617761697420746869732E5F62756C6B45646974536572766963652E6170706C79286C2C7B656469746F723A746869732E5F656469746F722C746F6B656E3A6F7D292C753D732E6765744465636F726174696F6E52616E676528645B305D297D66';
wwv_flow_imp.g_varchar2_table(10782) := '696E616C6C797B732E64656C74614465636F726174696F6E7328642C5B5D297D6F2E697343616E63656C6C6174696F6E5265717565737465647C7C6E2626682E69734170706C6965642626742E616C6C45646974732E6C656E6774683E31262674686973';
wwv_flow_imp.g_varchar2_table(10783) := '2E73686F77286E756C6C213D753F753A632C742C286173796E6320733D3E7B636F6E737420723D746869732E5F656469746F722E6765744D6F64656C28293B72262628617761697420722E756E646F28292C746869732E6170706C7945646974416E6453';
wwv_flow_imp.g_varchar2_table(10784) := '686F7749664E656564656428652C7B61637469766545646974496E6465783A732C616C6C45646974733A742E616C6C45646974737D2C6E2C692C6F29297D29297D73686F7728652C742C6E297B746869732E636C65617228292C746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(10785) := '6F722E6861734D6F64656C2829262628746869732E5F63757272656E745769646765742E76616C75653D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652851452C746869732E5F69642C74686973';
wwv_flow_imp.g_varchar2_table(10786) := '2E5F656469746F722C746869732E5F76697369626C65436F6E746578742C746869732E5F73686F77436F6D6D616E642C652C742C6E29297D636C65617228297B746869732E5F63757272656E745769646765742E636C65617228297D74727953686F7753';
wwv_flow_imp.g_varchar2_table(10787) := '656C6563746F7228297B76617220653B6E756C6C3D3D3D28653D746869732E5F63757272656E745769646765742E76616C7565297C7C766F696420303D3D3D657C7C652E73686F7753656C6563746F7228297D7D3B59453D4B45285B474528342C756329';
wwv_flow_imp.g_varchar2_table(10788) := '2C474528352C7978295D2C5945293B766172205A452C58453D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374204A453D22656469746F722E6368616E6765506173746554';
wwv_flow_imp.g_varchar2_table(10789) := '797065222C654C3D6E6577206C642822706173746557696467657456697369626C65222C21312C6228302C225768657468657220746865207061737465207769646765742069732073686F77696E672229292C744C3D226170706C69636174696F6E2F76';
wwv_flow_imp.g_varchar2_table(10790) := '6E642E636F64652E636F70794D65746164617461223B6C6574206E4C3D5A453D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E285A452E4944297D636F6E7374';
wwv_flow_imp.g_varchar2_table(10791) := '727563746F7228652C742C6E2C692C6F2C732C72297B737570657228292C746869732E5F62756C6B45646974536572766963653D6E2C746869732E5F636C6970626F617264536572766963653D692C746869732E5F6C616E677561676546656174757265';
wwv_flow_imp.g_varchar2_table(10792) := '73536572766963653D6F2C746869732E5F717569636B496E707574536572766963653D732C746869732E5F70726F6772657373536572766963653D722C746869732E5F656469746F723D653B636F6E737420613D652E676574436F6E7461696E6572446F';
wwv_flow_imp.g_varchar2_table(10793) := '6D4E6F646528293B746869732E5F726567697374657228627328612C22636F7079222C28653D3E746869732E68616E646C65436F70792865292929292C746869732E5F726567697374657228627328612C22637574222C28653D3E746869732E68616E64';
wwv_flow_imp.g_varchar2_table(10794) := '6C65436F70792865292929292C746869732E5F726567697374657228627328612C227061737465222C28653D3E746869732E68616E646C655061737465286529292C213029292C746869732E5F706173746550726F67726573734D616E616765723D7468';
wwv_flow_imp.g_varchar2_table(10795) := '69732E5F7265676973746572286E657720666B28227061737465496E746F456469746F72222C652C7429292C746869732E5F706F737450617374655769646765744D616E616765723D746869732E5F726567697374657228742E637265617465496E7374';
wwv_flow_imp.g_varchar2_table(10796) := '616E63652859452C227061737465496E746F456469746F72222C652C654C2C7B69643A4A452C6C6162656C3A6228302C2253686F77207061737465206F7074696F6E732E2E2E22297D29297D6368616E676550617374655479706528297B746869732E5F';
wwv_flow_imp.g_varchar2_table(10797) := '706F737450617374655769646765744D616E616765722E74727953686F7753656C6563746F7228297D706173746541732865297B746869732E5F656469746F722E666F63757328293B7472797B746869732E5F70617374654173416374696F6E436F6E74';
wwv_flow_imp.g_varchar2_table(10798) := '6578743D7B7072656665727265643A657D2C557328292E65786563436F6D6D616E642822706173746522297D66696E616C6C797B746869732E5F70617374654173416374696F6E436F6E746578743D766F696420307D7D636C6561725769646765747328';
wwv_flow_imp.g_varchar2_table(10799) := '297B746869732E5F706F737450617374655769646765744D616E616765722E636C65617228297D697350617374654173456E61626C656428297B72657475726E20746869732E5F656469746F722E6765744F7074696F6E283835292E656E61626C656426';
wwv_flow_imp.g_varchar2_table(10800) := '2621746869732E5F656469746F722E6765744F7074696F6E283931297D6173796E632066696E6973686564506173746528297B617761697420746869732E5F63757272656E7450617374654F7065726174696F6E7D68616E646C65436F70792865297B76';
wwv_flow_imp.g_varchar2_table(10801) := '617220742C6E3B69662821746869732E5F656469746F722E68617354657874466F63757328292972657475726E3B6966284B2626746869732E5F636C6970626F617264536572766963652E77726974655265736F7572636573285B5D292C21652E636C69';
wwv_flow_imp.g_varchar2_table(10802) := '70626F617264446174617C7C21746869732E697350617374654173456E61626C656428292972657475726E3B636F6E737420693D746869732E5F656469746F722E6765744D6F64656C28292C6F3D746869732E5F656469746F722E67657453656C656374';
wwv_flow_imp.g_varchar2_table(10803) := '696F6E7328293B69662821697C7C21286E756C6C3D3D6F3F766F696420303A6F2E6C656E677468292972657475726E3B636F6E737420733D746869732E5F656469746F722E6765744F7074696F6E283337293B6C657420723D6F3B636F6E737420613D31';
wwv_flow_imp.g_varchar2_table(10804) := '3D3D3D6F2E6C656E67746826266F5B305D2E6973456D70747928293B69662861297B69662821732972657475726E3B723D5B6E657720726828725B305D2E73746172744C696E654E756D6265722C312C725B305D2E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(10805) := '2C312B692E6765744C696E654C656E67746828725B305D2E73746172744C696E654E756D62657229295D7D636F6E7374206C3D6E756C6C3D3D3D28743D746869732E5F656469746F722E5F676574566965774D6F64656C2829297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(10806) := '3D743F766F696420303A742E676574506C61696E54657874546F436F7079286F2C732C6A292C633D7B6D756C7469637572736F72546578743A41727261792E69734172726179286C293F6C3A6E756C6C2C70617374654F6E4E65774C696E653A612C6D6F';
wwv_flow_imp.g_varchar2_table(10807) := '64653A6E756C6C7D2C643D746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7450617374654564697450726F76696465722E6F7264657265642869292E66696C7465722828653D3E2121652E70726570617265';
wwv_flow_imp.g_varchar2_table(10808) := '446F63756D656E74506173746529293B69662821642E6C656E6774682972657475726E20766F696420746869732E736574436F70794D6574616461746128652E636C6970626F617264446174612C7B64656661756C7450617374655061796C6F61643A63';
wwv_flow_imp.g_varchar2_table(10809) := '7D293B636F6E737420683D667828652E636C6970626F61726444617461292C753D642E666C61744D61702828653D3E7B76617220743B72657475726E206E756C6C213D3D28743D652E636F70794D696D655479706573292626766F69642030213D3D743F';
wwv_flow_imp.g_varchar2_table(10810) := '743A5B5D7D29292C703D727828293B746869732E736574436F70794D6574616461746128652E636C6970626F617264446174612C7B69643A702C70726F7669646572436F70794D696D6554797065733A752C64656661756C7450617374655061796C6F61';
wwv_flow_imp.g_varchar2_table(10811) := '643A637D293B636F6E737420673D467428286173796E6320653D3E7B636F6E737420743D7A682861776169742050726F6D6973652E616C6C28642E6D617028286173796E6320743D3E7B7472797B72657475726E20617761697420742E70726570617265';
wwv_flow_imp.g_varchar2_table(10812) := '446F63756D656E74506173746528692C722C682C65297D63617463682865297B72657475726E20766F696420636F6E736F6C652E6572726F722865297D7D292929293B742E7265766572736528293B666F7228636F6E73742065206F66207429666F7228';
wwv_flow_imp.g_varchar2_table(10813) := '636F6E73745B742C6E5D6F66206529682E7265706C61636528742C6E293B72657475726E20687D29293B6E756C6C3D3D3D286E3D5A452E5F63757272656E74436F70794F7065726174696F6E297C7C766F696420303D3D3D6E7C7C6E2E64617461547261';
wwv_flow_imp.g_varchar2_table(10814) := '6E7366657250726F6D6973652E63616E63656C28292C5A452E5F63757272656E74436F70794F7065726174696F6E3D7B68616E646C653A702C646174615472616E7366657250726F6D6973653A677D7D6173796E632068616E646C655061737465286529';
wwv_flow_imp.g_varchar2_table(10815) := '7B76617220742C6E2C692C6F3B69662821652E636C6970626F617264446174617C7C21746869732E5F656469746F722E68617354657874466F63757328292972657475726E3B6E756C6C3D3D3D28743D62452E67657428746869732E5F656469746F7229';
wwv_flow_imp.g_varchar2_table(10816) := '297C7C766F696420303D3D3D747C7C742E636C6F73654D65737361676528292C6E756C6C3D3D3D286E3D746869732E5F63757272656E7450617374654F7065726174696F6E297C7C766F696420303D3D3D6E7C7C6E2E63616E63656C28292C746869732E';
wwv_flow_imp.g_varchar2_table(10817) := '5F63757272656E7450617374654F7065726174696F6E3D766F696420303B636F6E737420733D746869732E5F656469746F722E6765744D6F64656C28292C723D746869732E5F656469746F722E67657453656C656374696F6E7328293B69662821286E75';
wwv_flow_imp.g_varchar2_table(10818) := '6C6C3D3D723F766F696420303A722E6C656E677468297C7C21732972657475726E3B69662821746869732E697350617374654173456E61626C65642829262621746869732E5F70617374654173416374696F6E436F6E746578742972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(10819) := '6E737420613D746869732E6665746368436F70794D657461646174612865292C6C3D5F7828652E636C6970626F61726444617461293B6C2E64656C65746528744C293B636F6E737420633D5B2E2E2E652E636C6970626F617264446174612E7479706573';
wwv_flow_imp.g_varchar2_table(10820) := '2C2E2E2E6E756C6C213D3D28693D6E756C6C3D3D613F766F696420303A612E70726F7669646572436F70794D696D655479706573292626766F69642030213D3D693F693A5B5D2C45702E7572694C6973745D2C643D746869732E5F6C616E677561676546';
wwv_flow_imp.g_varchar2_table(10821) := '65617475726573536572766963652E646F63756D656E7450617374654564697450726F76696465722E6F7264657265642873292E66696C7465722828653D3E7B76617220742C6E3B636F6E737420693D6E756C6C3D3D3D28743D746869732E5F70617374';
wwv_flow_imp.g_varchar2_table(10822) := '654173416374696F6E436F6E74657874297C7C766F696420303D3D3D743F766F696420303A742E7072656665727265643B72657475726E2128692626652E70726F76696465645061737465456469744B696E6473262621746869732E70726F7669646572';
wwv_flow_imp.g_varchar2_table(10823) := '4D617463686573507265666572656E636528652C6929292626286E756C6C3D3D3D286E3D652E70617374654D696D655479706573297C7C766F696420303D3D3D6E3F766F696420303A6E2E736F6D652828653D3E647828652C63292929297D29293B642E';
wwv_flow_imp.g_varchar2_table(10824) := '6C656E6774683F28652E70726576656E7444656661756C7428292C652E73746F70496D6D65646961746550726F7061676174696F6E28292C746869732E5F70617374654173416374696F6E436F6E746578743F746869732E73686F775061737465417350';
wwv_flow_imp.g_varchar2_table(10825) := '69636B28746869732E5F70617374654173416374696F6E436F6E746578742E7072656665727265642C642C722C6C2C61293A746869732E646F5061737465496E6C696E6528642C722C6C2C612C6529293A286E756C6C3D3D3D286F3D746869732E5F7061';
wwv_flow_imp.g_varchar2_table(10826) := '7374654173416374696F6E436F6E74657874297C7C766F696420303D3D3D6F3F766F696420303A6F2E707265666572726564292626746869732E73686F77506173746541734E6F456469744D65737361676528722C746869732E5F706173746541734163';
wwv_flow_imp.g_varchar2_table(10827) := '74696F6E436F6E746578742E707265666572726564297D73686F77506173746541734E6F456469744D65737361676528652C74297B766172206E3B6E756C6C3D3D3D286E3D62452E67657428746869732E5F656469746F7229297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(10828) := '3D6E7C7C6E2E73686F774D657373616765286228302C224E6F20706173746520656469747320666F7220277B307D2720666F756E64222C7420696E7374616E63656F662070783F742E76616C75653A742E70726F76696465724964292C655B305D2E6765';
wwv_flow_imp.g_varchar2_table(10829) := '745374617274506F736974696F6E2829297D646F5061737465496E6C696E6528652C742C6E2C692C6F297B636F6E737420733D467428286173796E6320723D3E7B636F6E737420613D746869732E5F656469746F723B69662821612E6861734D6F64656C';
wwv_flow_imp.g_varchar2_table(10830) := '28292972657475726E3B636F6E7374206C3D612E6765744D6F64656C28292C633D6E657720646B28612C332C766F696420302C72293B7472797B696628617761697420746869732E6D65726765496E4461746146726F6D436F7079286E2C692C632E746F';
wwv_flow_imp.g_varchar2_table(10831) := '6B656E292C632E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B636F6E737420733D652E66696C7465722828653D3E746869732E6973537570706F72746564506173746550726F766964657228652C6E2929';
wwv_flow_imp.g_varchar2_table(10832) := '293B69662821732E6C656E6774687C7C313D3D3D732E6C656E6774682626735B305D696E7374616E63656F662056782972657475726E20746869732E6170706C7944656661756C74506173746548616E646C6572286E2C692C632E746F6B656E2C6F293B';
wwv_flow_imp.g_varchar2_table(10833) := '636F6E737420723D7B747269676765724B696E643A43772E4175746F6D617469637D2C643D617761697420746869732E6765745061737465456469747328732C6E2C6C2C742C722C632E746F6B656E293B696628632E746F6B656E2E697343616E63656C';
wwv_flow_imp.g_varchar2_table(10834) := '6C6174696F6E5265717565737465642972657475726E3B696628313D3D3D642E6C656E6774682626645B305D2E70726F766964657220696E7374616E63656F662056782972657475726E20746869732E6170706C7944656661756C74506173746548616E';
wwv_flow_imp.g_varchar2_table(10835) := '646C6572286E2C692C632E746F6B656E2C6F293B696628642E6C656E677468297B636F6E737420653D2261667465725061737465223D3D3D612E6765744F7074696F6E283835292E73686F77506173746553656C6563746F723B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(10836) := '732E5F706F737450617374655769646765744D616E616765722E6170706C7945646974416E6453686F7749664E656564656428742C7B61637469766545646974496E6465783A302C616C6C45646974733A647D2C652C286173796E6328652C74293D3E7B';
wwv_flow_imp.g_varchar2_table(10837) := '766172206E2C693B636F6E7374206F3D6177616974286E756C6C3D3D3D28693D286E3D652E70726F7669646572292E7265736F6C7665446F63756D656E74506173746545646974297C7C766F696420303D3D3D693F766F696420303A692E63616C6C286E';
wwv_flow_imp.g_varchar2_table(10838) := '2C652C7429293B72657475726E206F262628652E6164646974696F6E616C456469743D6F2E6164646974696F6E616C45646974292C657D292C632E746F6B656E297D617761697420746869732E6170706C7944656661756C74506173746548616E646C65';
wwv_flow_imp.g_varchar2_table(10839) := '72286E2C692C632E746F6B656E2C6F297D66696E616C6C797B632E646973706F736528292C746869732E5F63757272656E7450617374654F7065726174696F6E3D3D3D73262628746869732E5F63757272656E7450617374654F7065726174696F6E3D76';
wwv_flow_imp.g_varchar2_table(10840) := '6F69642030297D7D29293B746869732E5F706173746550726F67726573734D616E616765722E73686F775768696C6528745B305D2E676574456E64506F736974696F6E28292C6228302C2252756E6E696E672070617374652068616E646C6572732E2043';
wwv_flow_imp.g_varchar2_table(10841) := '6C69636B20746F2063616E63656C22292C73292C746869732E5F63757272656E7450617374654F7065726174696F6E3D737D73686F77506173746541735069636B28652C742C6E2C692C6F297B636F6E737420733D467428286173796E6320723D3E7B63';
wwv_flow_imp.g_varchar2_table(10842) := '6F6E737420613D746869732E5F656469746F723B69662821612E6861734D6F64656C28292972657475726E3B636F6E7374206C3D612E6765744D6F64656C28292C633D6E657720646B28612C332C766F696420302C72293B7472797B6966286177616974';
wwv_flow_imp.g_varchar2_table(10843) := '20746869732E6D65726765496E4461746146726F6D436F707928692C6F2C632E746F6B656E292C632E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6C657420733D742E66696C7465722828743D3E746869';
wwv_flow_imp.g_varchar2_table(10844) := '732E6973537570706F72746564506173746550726F766964657228742C692C652929293B65262628733D732E66696C7465722828743D3E746869732E70726F76696465724D617463686573507265666572656E636528742C65292929293B636F6E737420';
wwv_flow_imp.g_varchar2_table(10845) := '723D7B747269676765724B696E643A43772E506173746541732C6F6E6C793A6526266520696E7374616E63656F662070783F653A766F696420307D3B6C657420612C643D617761697420746869732E6765745061737465456469747328732C692C6C2C6E';
wwv_flow_imp.g_varchar2_table(10846) := '2C722C632E746F6B656E293B696628632E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B69662865262628643D642E66696C7465722828743D3E6520696E7374616E63656F662070783F652E636F6E746169';
wwv_flow_imp.g_varchar2_table(10847) := '6E7328742E6B696E64293A652E70726F766964657249643D3D3D742E70726F76696465722E69642929292C21642E6C656E6774682972657475726E20766F696428722E6F6E6C792626746869732E73686F77506173746541734E6F456469744D65737361';
wwv_flow_imp.g_varchar2_table(10848) := '6765286E2C722E6F6E6C7929293B6966286529613D642E61742830293B656C73657B636F6E737420653D617761697420746869732E5F717569636B496E707574536572766963652E7069636B28642E6D61702828653D3E7B76617220743B72657475726E';
wwv_flow_imp.g_varchar2_table(10849) := '7B6C6162656C3A652E7469746C652C6465736372697074696F6E3A6E756C6C3D3D3D28743D652E6B696E64297C7C766F696420303D3D3D743F766F696420303A742E76616C75652C656469743A657D7D29292C7B706C616365486F6C6465723A6228302C';
wwv_flow_imp.g_varchar2_table(10850) := '2253656C65637420506173746520416374696F6E22297D293B613D6E756C6C3D3D653F766F696420303A652E656469747D69662821612972657475726E3B636F6E737420683D6F6B286C2E7572692C6E2C61293B617761697420746869732E5F62756C6B';
wwv_flow_imp.g_varchar2_table(10851) := '45646974536572766963652E6170706C7928682C7B656469746F723A746869732E5F656469746F727D297D66696E616C6C797B632E646973706F736528292C746869732E5F63757272656E7450617374654F7065726174696F6E3D3D3D73262628746869';
wwv_flow_imp.g_varchar2_table(10852) := '732E5F63757272656E7450617374654F7065726174696F6E3D766F69642030297D7D29293B746869732E5F70726F6772657373536572766963652E7769746850726F6772657373287B6C6F636174696F6E3A31302C7469746C653A6228302C2252756E6E';
wwv_flow_imp.g_varchar2_table(10853) := '696E672070617374652068616E646C65727322297D2C2828293D3E7329297D736574436F70794D6574616461746128652C74297B652E7365744461746128744C2C4A534F4E2E737472696E67696679287429297D6665746368436F70794D657461646174';
wwv_flow_imp.g_varchar2_table(10854) := '612865297B76617220743B69662821652E636C6970626F617264446174612972657475726E3B636F6E7374206E3D652E636C6970626F617264446174612E6765744461746128744C293B6966286E297472797B72657475726E204A534F4E2E7061727365';
wwv_flow_imp.g_varchar2_table(10855) := '286E297D63617463682865297B72657475726E7D636F6E73745B692C6F5D3D6F782E676574546578744461746128652E636C6970626F61726444617461293B72657475726E206F3F7B64656661756C7450617374655061796C6F61643A7B6D6F64653A6F';
wwv_flow_imp.g_varchar2_table(10856) := '2E6D6F64652C6D756C7469637572736F72546578743A6E756C6C213D3D28743D6F2E6D756C7469637572736F7254657874292626766F69642030213D3D743F743A6E756C6C2C70617374654F6E4E65774C696E653A21216F2E697346726F6D456D707479';
wwv_flow_imp.g_varchar2_table(10857) := '53656C656374696F6E7D7D3A766F696420307D6173796E63206D65726765496E4461746146726F6D436F707928652C742C6E297B76617220693B696628286E756C6C3D3D743F766F696420303A742E6964292626286E756C6C3D3D3D28693D5A452E5F63';
wwv_flow_imp.g_varchar2_table(10858) := '757272656E74436F70794F7065726174696F6E297C7C766F696420303D3D3D693F766F696420303A692E68616E646C65293D3D3D742E6964297B636F6E737420743D6177616974205A452E5F63757272656E74436F70794F7065726174696F6E2E646174';
wwv_flow_imp.g_varchar2_table(10859) := '615472616E7366657250726F6D6973653B6966286E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B666F7228636F6E73745B6E2C695D6F66207429652E7265706C616365286E2C69297D69662821652E6861732845702E';
wwv_flow_imp.g_varchar2_table(10860) := '7572694C69737429297B636F6E737420743D617761697420746869732E5F636C6970626F617264536572766963652E726561645265736F757263657328293B6966286E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B74';
wwv_flow_imp.g_varchar2_table(10861) := '2E6C656E6774682626652E617070656E642845702E7572694C6973742C61782875782E63726561746528742929297D7D6173796E63206765745061737465456469747328652C742C6E2C692C6F2C73297B636F6E737420723D6177616974204274285072';
wwv_flow_imp.g_varchar2_table(10862) := '6F6D6973652E616C6C28652E6D617028286173796E6320653D3E7B76617220722C613B7472797B636F6E7374206C3D6177616974286E756C6C3D3D3D28723D652E70726F76696465446F63756D656E7450617374654564697473297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(10863) := '3D3D723F766F696420303A722E63616C6C28652C6E2C692C742C6F2C7329293B72657475726E206E756C6C3D3D3D28613D6E756C6C3D3D6C3F766F696420303A6C2E6564697473297C7C766F696420303D3D3D613F766F696420303A612E6D6170282874';
wwv_flow_imp.g_varchar2_table(10864) := '3D3E287B2E2E2E742C70726F76696465723A657D2929297D63617463682865297B636F6E736F6C652E6572726F722865297D7D2929292C73293B72657475726E20736B287A68286E756C6C213D723F723A5B5D292E666C617428292E66696C7465722828';
wwv_flow_imp.g_varchar2_table(10865) := '653D3E216F2E6F6E6C797C7C6F2E6F6E6C792E636F6E7461696E7328652E6B696E64292929297D6173796E63206170706C7944656661756C74506173746548616E646C657228652C742C6E2C69297B766172206F2C732C722C613B636F6E7374206C3D6E';
wwv_flow_imp.g_varchar2_table(10866) := '756C6C213D3D286F3D652E6765742845702E7465787429292626766F69642030213D3D6F3F6F3A652E67657428227465787422292C633D6E756C6C213D3D28733D6177616974286E756C6C3D3D6C3F766F696420303A6C2E6173537472696E6728292929';
wwv_flow_imp.g_varchar2_table(10867) := '2626766F69642030213D3D733F733A22223B6966286E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B636F6E737420643D7B636C6970626F6172644576656E743A692C746578743A632C70617374654F6E4E65774C696E';
wwv_flow_imp.g_varchar2_table(10868) := '653A6E756C6C213D3D28723D6E756C6C3D3D743F766F696420303A742E64656661756C7450617374655061796C6F61642E70617374654F6E4E65774C696E65292626766F69642030213D3D722626722C6D756C7469637572736F72546578743A6E756C6C';
wwv_flow_imp.g_varchar2_table(10869) := '213D3D28613D6E756C6C3D3D743F766F696420303A742E64656661756C7450617374655061796C6F61642E6D756C7469637572736F7254657874292626766F69642030213D3D613F613A6E756C6C2C6D6F64653A6E756C6C7D3B746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(10870) := '6F722E7472696767657228226B6579626F617264222C227061737465222C64297D6973537570706F72746564506173746550726F766964657228652C742C6E297B76617220693B72657475726E2121286E756C6C3D3D3D28693D652E70617374654D696D';
wwv_flow_imp.g_varchar2_table(10871) := '655479706573297C7C766F696420303D3D3D693F766F696420303A692E736F6D652828653D3E742E6D617463686573286529292929262628216E7C7C746869732E70726F76696465724D617463686573507265666572656E636528652C6E29297D70726F';
wwv_flow_imp.g_varchar2_table(10872) := '76696465724D617463686573507265666572656E636528652C74297B72657475726E207420696E7374616E63656F662070783F21652E70726F76696465645061737465456469744B696E64737C7C652E70726F76696465645061737465456469744B696E';
wwv_flow_imp.g_varchar2_table(10873) := '64732E736F6D652828653D3E742E636F6E7461696E7328652929293A652E69643D3D3D742E70726F766964657249647D7D3B6E4C2E49443D22656469746F722E636F6E747269622E636F70795061737465416374696F6E436F6E74726F6C6C6572222C6E';
wwv_flow_imp.g_varchar2_table(10874) := '4C3D5A453D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F722874';
wwv_flow_imp.g_varchar2_table(10875) := '2C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B65';
wwv_flow_imp.g_varchar2_table(10876) := '6C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A';
wwv_flow_imp.g_varchar2_table(10877) := '6563742E646566696E6550726F706572747928742C6E2C72292C727D285B584528312C7563292C584528322C7978292C584528332C7945292C584528342C7878292C584528352C4C45292C584528362C7745295D2C6E4C293B636F6E737420694C3D2239';
wwv_flow_imp.g_varchar2_table(10878) := '5F637574636F70797061737465222C6F4C3D557C7C646F63756D656E742E7175657279436F6D6D616E64537570706F72746564282263757422292C734C3D557C7C646F63756D656E742E7175657279436F6D6D616E64537570706F727465642822636F70';
wwv_flow_imp.g_varchar2_table(10879) := '7922292C724C3D766F69642030213D3D6E6176696761746F722E636C6970626F617264262621637C7C646F63756D656E742E7175657279436F6D6D616E64537570706F727465642822706173746522293B66756E6374696F6E20614C2865297B72657475';
wwv_flow_imp.g_varchar2_table(10880) := '726E20652E726567697374657228292C657D636F6E7374206C4C3D6F4C3F614C286E6577206A64287B69643A22656469746F722E616374696F6E2E636C6970626F617264437574416374696F6E222C707265636F6E646974696F6E3A766F696420302C6B';
wwv_flow_imp.g_varchar2_table(10881) := '624F7074733A553F7B7072696D6172793A323130322C77696E3A7B7072696D6172793A323130322C7365636F6E646172793A5B313034345D7D2C7765696768743A3130307D3A766F696420302C6D656E754F7074733A5B7B6D656E7549643A4C642E4D65';
wwv_flow_imp.g_varchar2_table(10882) := '6E75626172456469744D656E752C67726F75703A22325F636370222C7469746C653A6228302C22437526267422292C6F726465723A317D2C7B6D656E7549643A4C642E456469746F72436F6E746578742C67726F75703A694C2C7469746C653A6228302C';
wwv_flow_imp.g_varchar2_table(10883) := '2243757422292C7768656E3A6C682E7772697461626C652C6F726465723A317D2C7B6D656E7549643A4C642E436F6D6D616E6450616C657474652C67726F75703A22222C7469746C653A6228302C2243757422292C6F726465723A317D2C7B6D656E7549';
wwv_flow_imp.g_varchar2_table(10884) := '643A4C642E53696D706C65456469746F72436F6E746578742C67726F75703A694C2C7469746C653A6228302C2243757422292C7768656E3A6C682E7772697461626C652C6F726465723A317D5D7D29293A766F696420302C634C3D734C3F614C286E6577';
wwv_flow_imp.g_varchar2_table(10885) := '206A64287B69643A22656469746F722E616374696F6E2E636C6970626F617264436F7079416374696F6E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A553F7B7072696D6172793A323038312C77696E3A7B7072696D6172793A';
wwv_flow_imp.g_varchar2_table(10886) := '323038312C7365636F6E646172793A5B323036375D7D2C7765696768743A3130307D3A766F696420302C6D656E754F7074733A5B7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F75703A22325F636370222C7469746C653A62';
wwv_flow_imp.g_varchar2_table(10887) := '28302C222626436F707922292C6F726465723A327D2C7B6D656E7549643A4C642E456469746F72436F6E746578742C67726F75703A694C2C7469746C653A6228302C22436F707922292C6F726465723A327D2C7B6D656E7549643A4C642E436F6D6D616E';
wwv_flow_imp.g_varchar2_table(10888) := '6450616C657474652C67726F75703A22222C7469746C653A6228302C22436F707922292C6F726465723A317D2C7B6D656E7549643A4C642E53696D706C65456469746F72436F6E746578742C67726F75703A694C2C7469746C653A6228302C22436F7079';
wwv_flow_imp.g_varchar2_table(10889) := '22292C6F726465723A327D5D7D29293A766F696420303B49642E617070656E644D656E754974656D284C642E4D656E75626172456469744D656E752C7B7375626D656E753A4C642E4D656E75626172436F70792C7469746C653A5F28302C22436F707920';
wwv_flow_imp.g_varchar2_table(10890) := '417322292C67726F75703A22325F636370222C6F726465723A337D292C49642E617070656E644D656E754974656D284C642E456469746F72436F6E746578742C7B7375626D656E753A4C642E456469746F72436F6E74657874436F70792C7469746C653A';
wwv_flow_imp.g_varchar2_table(10891) := '5F28302C22436F707920417322292C67726F75703A694C2C6F726465723A337D292C49642E617070656E644D656E754974656D284C642E456469746F72436F6E746578742C7B7375626D656E753A4C642E456469746F72436F6E7465787453686172652C';
wwv_flow_imp.g_varchar2_table(10892) := '7469746C653A5F28302C22536861726522292C67726F75703A2231315F7368617265222C6F726465723A2D312C7768656E3A57632E616E642857632E6E6F74457175616C7328227265736F75726365536368656D65222C226F757470757422292C6C682E';
wwv_flow_imp.g_varchar2_table(10893) := '656469746F7254657874466F637573297D292C49642E617070656E644D656E754974656D284C642E456469746F725469746C65436F6E746578742C7B7375626D656E753A4C642E456469746F725469746C65436F6E7465787453686172652C7469746C65';
wwv_flow_imp.g_varchar2_table(10894) := '3A5F28302C22536861726522292C67726F75703A2231315F7368617265222C6F726465723A2D317D292C49642E617070656E644D656E754974656D284C642E4578706C6F726572436F6E746578742C7B7375626D656E753A4C642E4578706C6F72657243';
wwv_flow_imp.g_varchar2_table(10895) := '6F6E7465787453686172652C7469746C653A5F28302C22536861726522292C67726F75703A2231315F7368617265222C6F726465723A2D317D293B636F6E737420644C3D724C3F614C286E6577206A64287B69643A22656469746F722E616374696F6E2E';
wwv_flow_imp.g_varchar2_table(10896) := '636C6970626F6172645061737465416374696F6E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A553F7B7072696D6172793A323130302C77696E3A7B7072696D6172793A323130302C7365636F6E646172793A5B313034335D7D';
wwv_flow_imp.g_varchar2_table(10897) := '2C6C696E75783A7B7072696D6172793A323130302C7365636F6E646172793A5B313034335D7D2C7765696768743A3130307D3A766F696420302C6D656E754F7074733A5B7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F7570';
wwv_flow_imp.g_varchar2_table(10898) := '3A22325F636370222C7469746C653A6228302C222626506173746522292C6F726465723A347D2C7B6D656E7549643A4C642E456469746F72436F6E746578742C67726F75703A694C2C7469746C653A6228302C22506173746522292C7768656E3A6C682E';
wwv_flow_imp.g_varchar2_table(10899) := '7772697461626C652C6F726465723A347D2C7B6D656E7549643A4C642E436F6D6D616E6450616C657474652C67726F75703A22222C7469746C653A6228302C22506173746522292C6F726465723A317D2C7B6D656E7549643A4C642E53696D706C654564';
wwv_flow_imp.g_varchar2_table(10900) := '69746F72436F6E746578742C67726F75703A694C2C7469746C653A6228302C22506173746522292C7768656E3A6C682E7772697461626C652C6F726465723A347D5D7D29293A766F696420303B66756E6374696F6E20684C28652C74297B65262628652E';
wwv_flow_imp.g_varchar2_table(10901) := '616464496D706C656D656E746174696F6E283165342C22636F64652D656469746F72222C2828652C6E293D3E7B636F6E737420693D652E676574286763292E676574466F6375736564436F6465456469746F7228293B696628692626692E686173546578';
wwv_flow_imp.g_varchar2_table(10902) := '74466F6375732829297B636F6E737420653D692E6765744F7074696F6E283337292C6E3D692E67657453656C656374696F6E28293B72657475726E206E26266E2E6973456D7074792829262621657C7C692E676574436F6E7461696E6572446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(10903) := '6528292E6F776E6572446F63756D656E742E65786563436F6D6D616E642874292C21307D72657475726E21317D29292C652E616464496D706C656D656E746174696F6E28302C2267656E657269632D646F6D222C2828652C6E293D3E28557328292E6578';
wwv_flow_imp.g_varchar2_table(10904) := '6563436F6D6D616E642874292C2130292929297D684C286C4C2C2263757422292C684C28634C2C22636F707922292C644C262628644C2E616464496D706C656D656E746174696F6E283165342C22636F64652D656469746F72222C2828652C74293D3E7B';
wwv_flow_imp.g_varchar2_table(10905) := '766172206E2C693B636F6E7374206F3D652E676574286763292C733D652E676574287945292C723D6F2E676574466F6375736564436F6465456469746F7228293B72657475726E212821727C7C21722E68617354657874466F637573282929262628722E';
wwv_flow_imp.g_varchar2_table(10906) := '676574436F6E7461696E6572446F6D4E6F646528292E6F776E6572446F63756D656E742E65786563436F6D6D616E642822706173746522293F6E756C6C213D3D28693D6E756C6C3D3D3D286E3D6E4C2E676574287229297C7C766F696420303D3D3D6E3F';
wwv_flow_imp.g_varchar2_table(10907) := '766F696420303A6E2E66696E697368656450617374652829292626766F69642030213D3D693F693A50726F6D6973652E7265736F6C766528293A214B7C7C286173796E6328293D3E7B636F6E737420653D617761697420732E726561645465787428293B';
wwv_flow_imp.g_varchar2_table(10908) := '6966282222213D3D65297B636F6E737420743D74782E494E5354414E43452E6765742865293B6C6574206E3D21312C693D6E756C6C2C6F3D6E756C6C3B742626286E3D722E6765744F7074696F6E2833372926262121742E697346726F6D456D70747953';
wwv_flow_imp.g_varchar2_table(10909) := '656C656374696F6E2C693D766F69642030213D3D742E6D756C7469637572736F72546578743F742E6D756C7469637572736F72546578743A6E756C6C2C6F3D742E6D6F6465292C722E7472696767657228226B6579626F617264222C227061737465222C';
wwv_flow_imp.g_varchar2_table(10910) := '7B746578743A652C70617374654F6E4E65774C696E653A6E2C6D756C7469637572736F72546578743A692C6D6F64653A6F7D297D7D292829297D29292C644C2E616464496D706C656D656E746174696F6E28302C2267656E657269632D646F6D222C2828';
wwv_flow_imp.g_varchar2_table(10911) := '652C74293D3E28557328292E65786563436F6D6D616E642822706173746522292C2130292929292C734C26265A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E61637469';
wwv_flow_imp.g_varchar2_table(10912) := '6F6E2E636C6970626F617264436F70795769746853796E746178486967686C69676874696E67416374696F6E222C6C6162656C3A6228302C22436F707920576974682053796E74617820486967686C69676874696E6722292C616C6961733A22436F7079';
wwv_flow_imp.g_varchar2_table(10913) := '20576974682053796E74617820486967686C69676874696E67222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C7765696768743A313030';
wwv_flow_imp.g_varchar2_table(10914) := '7D7D297D72756E28652C74297B742E6861734D6F64656C282926262821742E6765744F7074696F6E283337292626742E67657453656C656374696F6E28292E6973456D70747928297C7C2865782E666F726365436F70795769746853796E746178486967';
wwv_flow_imp.g_varchar2_table(10915) := '686C69676874696E673D21302C742E666F63757328292C742E676574436F6E7461696E6572446F6D4E6F646528292E6F776E6572446F63756D656E742E65786563436F6D6D616E642822636F707922292C65782E666F726365436F70795769746853796E';
wwv_flow_imp.g_varchar2_table(10916) := '746178486967686C69676874696E673D213129297D7D293B636F6E737420754C3D7B656E61626C6553706C697456696577526573697A696E673A21302C73706C69745669657744656661756C74526174696F3A2E352C72656E6465725369646542795369';
wwv_flow_imp.g_varchar2_table(10917) := '64653A21302C72656E6465724D617267696E52657665727449636F6E3A21302C72656E6465724775747465724D656E753A21302C6D6178436F6D7075746174696F6E54696D653A3565332C6D617846696C6553697A653A35302C69676E6F72655472696D';
wwv_flow_imp.g_varchar2_table(10918) := '576869746573706163653A21302C72656E646572496E64696361746F72733A21302C6F726967696E616C4564697461626C653A21312C64696666436F64654C656E733A21312C72656E6465724F7665727669657752756C65723A21302C64696666576F72';
wwv_flow_imp.g_varchar2_table(10919) := '64577261703A22696E6865726974222C64696666416C676F726974686D3A22616476616E636564222C6163636573736962696C697479566572626F73653A21312C6578706572696D656E74616C3A7B73686F774D6F7665733A21312C73686F77456D7074';
wwv_flow_imp.g_varchar2_table(10920) := '794465636F726174696F6E733A21307D2C68696465556E6368616E676564526567696F6E733A7B656E61626C65643A21312C636F6E746578744C696E65436F756E743A332C6D696E696D756D4C696E65436F756E743A332C72657665616C4C696E65436F';
wwv_flow_imp.g_varchar2_table(10921) := '756E743A32307D2C6973496E456D626564646564456469746F723A21312C6F6E6C7953686F7741636365737369626C65446966665669657765723A21312C72656E64657253696465427953696465496E6C696E65427265616B706F696E743A3930302C75';
wwv_flow_imp.g_varchar2_table(10922) := '7365496E6C696E65566965775768656E537061636549734C696D697465643A21307D3B636C61737320704C7B636F6E7374727563746F722865297B746869732E5F76616C7565733D657D6861734368616E6765642865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(10923) := '5F76616C7565735B655D7D7D636C61737320674C7B636F6E7374727563746F7228297B746869732E737461626C654D696E696D61704C61796F7574496E7075743D6E756C6C2C746869732E737461626C654669744D61784D696E696D61705363616C653D';
wwv_flow_imp.g_varchar2_table(10924) := '302C746869732E737461626C6546697452656D61696E696E6757696474683D307D7D636C617373206D4C7B636F6E7374727563746F7228652C742C6E2C69297B746869732E69643D652C746869732E6E616D653D742C746869732E64656661756C745661';
wwv_flow_imp.g_varchar2_table(10925) := '6C75653D6E2C746869732E736368656D613D697D6170706C7955706461746528652C74297B72657475726E20764C28652C74297D636F6D7075746528652C742C6E297B72657475726E206E7D7D636C61737320664C7B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(10926) := '74297B746869732E6E657756616C75653D652C746869732E6469644368616E67653D747D7D66756E6374696F6E20764C28652C74297B696628226F626A65637422213D747970656F6620657C7C226F626A65637422213D747970656F6620747C7C21657C';
wwv_flow_imp.g_varchar2_table(10927) := '7C21742972657475726E206E657720664C28742C65213D3D74293B69662841727261792E697341727261792865297C7C41727261792E69734172726179287429297B636F6E7374206E3D41727261792E69734172726179286529262641727261792E6973';
wwv_flow_imp.g_varchar2_table(10928) := '41727261792874292626506828652C74293B72657475726E206E657720664C28742C216E297D6C6574206E3D21313B666F7228636F6E7374206920696E207429696628742E6861734F776E50726F7065727479286929297B636F6E7374206F3D764C2865';
wwv_flow_imp.g_varchar2_table(10929) := '5B695D2C745B695D293B6F2E6469644368616E6765262628655B695D3D6F2E6E657756616C75652C6E3D2130297D72657475726E206E657720664C28652C6E297D636C61737320624C7B636F6E7374727563746F722865297B746869732E736368656D61';
wwv_flow_imp.g_varchar2_table(10930) := '3D766F696420302C746869732E69643D652C746869732E6E616D653D225F6E657665725F222C746869732E64656661756C7456616C75653D766F696420307D6170706C7955706461746528652C74297B72657475726E20764C28652C74297D76616C6964';
wwv_flow_imp.g_varchar2_table(10931) := '6174652865297B72657475726E20746869732E64656661756C7456616C75657D7D636C617373205F4C7B636F6E7374727563746F7228652C742C6E2C69297B746869732E69643D652C746869732E6E616D653D742C746869732E64656661756C7456616C';
wwv_flow_imp.g_varchar2_table(10932) := '75653D6E2C746869732E736368656D613D697D6170706C7955706461746528652C74297B72657475726E20764C28652C74297D76616C69646174652865297B72657475726E20766F696420303D3D3D653F746869732E64656661756C7456616C75653A65';
wwv_flow_imp.g_varchar2_table(10933) := '7D636F6D7075746528652C742C6E297B72657475726E206E7D7D66756E6374696F6E20794C28652C74297B72657475726E20766F696420303D3D3D653F743A2266616C736522213D3D652626426F6F6C65616E2865297D636C61737320774C2065787465';
wwv_flow_imp.g_varchar2_table(10934) := '6E6473205F4C7B636F6E7374727563746F7228652C742C6E2C693D766F69642030297B766F69642030213D3D69262628692E747970653D22626F6F6C65616E222C692E64656661756C743D6E292C737570657228652C742C6E2C69297D76616C69646174';
wwv_flow_imp.g_varchar2_table(10935) := '652865297B72657475726E20794C28652C746869732E64656661756C7456616C7565297D7D66756E6374696F6E20434C28652C742C6E2C69297B696628766F696420303D3D3D652972657475726E20743B6C6574206F3D7061727365496E7428652C3130';
wwv_flow_imp.g_varchar2_table(10936) := '293B72657475726E2069734E614E286F293F743A286F3D4D6174682E6D6178286E2C6F292C6F3D4D6174682E6D696E28692C6F292C307C6F297D636C61737320534C20657874656E6473205F4C7B73746174696320636C616D706564496E7428652C742C';
wwv_flow_imp.g_varchar2_table(10937) := '6E2C69297B72657475726E20434C28652C742C6E2C69297D636F6E7374727563746F7228652C742C6E2C692C6F2C733D766F69642030297B766F69642030213D3D73262628732E747970653D22696E7465676572222C732E64656661756C743D6E2C732E';
wwv_flow_imp.g_varchar2_table(10938) := '6D696E696D756D3D692C732E6D6178696D756D3D6F292C737570657228652C742C6E2C73292C746869732E6D696E696D756D3D692C746869732E6D6178696D756D3D6F7D76616C69646174652865297B72657475726E20534C2E636C616D706564496E74';
wwv_flow_imp.g_varchar2_table(10939) := '28652C746869732E64656661756C7456616C75652C746869732E6D696E696D756D2C746869732E6D6178696D756D297D7D66756E6374696F6E20784C28652C742C6E2C69297B696628766F696420303D3D3D652972657475726E20743B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(10940) := '3D6B4C2E666C6F617428652C74293B72657475726E206B4C2E636C616D70286F2C6E2C69297D636C617373206B4C20657874656E6473205F4C7B73746174696320636C616D7028652C742C6E297B72657475726E20653C743F743A653E6E3F6E3A657D73';
wwv_flow_imp.g_varchar2_table(10941) := '746174696320666C6F617428652C74297B696628226E756D626572223D3D747970656F6620652972657475726E20653B696628766F696420303D3D3D652972657475726E20743B636F6E7374206E3D7061727365466C6F61742865293B72657475726E20';
wwv_flow_imp.g_varchar2_table(10942) := '69734E614E286E293F743A6E7D636F6E7374727563746F7228652C742C6E2C692C6F297B766F69642030213D3D6F2626286F2E747970653D226E756D626572222C6F2E64656661756C743D6E292C737570657228652C742C6E2C6F292C746869732E7661';
wwv_flow_imp.g_varchar2_table(10943) := '6C69646174696F6E466E3D697D76616C69646174652865297B72657475726E20746869732E76616C69646174696F6E466E286B4C2E666C6F617428652C746869732E64656661756C7456616C756529297D7D636C61737320454C20657874656E6473205F';
wwv_flow_imp.g_varchar2_table(10944) := '4C7B73746174696320737472696E6728652C74297B72657475726E22737472696E6722213D747970656F6620653F743A657D636F6E7374727563746F7228652C742C6E2C693D766F69642030297B766F69642030213D3D69262628692E747970653D2273';
wwv_flow_imp.g_varchar2_table(10945) := '7472696E67222C692E64656661756C743D6E292C737570657228652C742C6E2C69297D76616C69646174652865297B72657475726E20454C2E737472696E6728652C746869732E64656661756C7456616C7565297D7D66756E6374696F6E204C4C28652C';
wwv_flow_imp.g_varchar2_table(10946) := '742C6E2C69297B72657475726E22737472696E6722213D747970656F6620653F743A6926266520696E20693F695B655D3A2D313D3D3D6E2E696E6465784F662865293F743A657D636C61737320444C20657874656E6473205F4C7B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(10947) := '6F7228652C742C6E2C692C6F3D766F69642030297B766F69642030213D3D6F2626286F2E747970653D22737472696E67222C6F2E656E756D3D692C6F2E64656661756C743D6E292C737570657228652C742C6E2C6F292C746869732E5F616C6C6F776564';
wwv_flow_imp.g_varchar2_table(10948) := '56616C7565733D697D76616C69646174652865297B72657475726E204C4C28652C746869732E64656661756C7456616C75652C746869732E5F616C6C6F77656456616C756573297D7D636C61737320544C20657874656E6473206D4C7B636F6E73747275';
wwv_flow_imp.g_varchar2_table(10949) := '63746F7228652C742C6E2C692C6F2C732C723D766F69642030297B766F69642030213D3D72262628722E747970653D22737472696E67222C722E656E756D3D6F2C722E64656661756C743D69292C737570657228652C742C6E2C72292C746869732E5F61';
wwv_flow_imp.g_varchar2_table(10950) := '6C6C6F77656456616C7565733D6F2C746869732E5F636F6E766572743D737D76616C69646174652865297B72657475726E22737472696E6722213D747970656F6620657C7C2D313D3D3D746869732E5F616C6C6F77656456616C7565732E696E6465784F';
wwv_flow_imp.g_varchar2_table(10951) := '662865293F746869732E64656661756C7456616C75653A746869732E5F636F6E766572742865297D7D76617220494C2C4D4C3B2166756E6374696F6E2865297B655B652E4C696E653D315D3D224C696E65222C655B652E426C6F636B3D325D3D22426C6F';
wwv_flow_imp.g_varchar2_table(10952) := '636B222C655B652E556E6465726C696E653D335D3D22556E6465726C696E65222C655B652E4C696E655468696E3D345D3D224C696E655468696E222C655B652E426C6F636B4F75746C696E653D355D3D22426C6F636B4F75746C696E65222C655B652E55';
wwv_flow_imp.g_varchar2_table(10953) := '6E6465726C696E655468696E3D365D3D22556E6465726C696E655468696E227D28494C7C7C28494C3D7B7D29293B636C61737320414C20657874656E6473206D4C7B636F6E7374727563746F7228297B73757065722835312C22666F6E744C6967617475';
wwv_flow_imp.g_varchar2_table(10954) := '726573222C414C2E4F46462C7B616E794F663A5B7B747970653A22626F6F6C65616E222C6465736372697074696F6E3A6228302C22456E61626C65732F44697361626C657320666F6E74206C696761747572657320282763616C742720616E6420276C69';
wwv_flow_imp.g_varchar2_table(10955) := '67612720666F6E74206665617475726573292E204368616E6765207468697320746F206120737472696E6720666F722066696E652D677261696E656420636F6E74726F6C206F66207468652027666F6E742D666561747572652D73657474696E67732720';
wwv_flow_imp.g_varchar2_table(10956) := '4353532070726F70657274792E22297D2C7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C224578706C696369742027666F6E742D666561747572652D73657474696E677327204353532070726F70657274792E204120626F';
wwv_flow_imp.g_varchar2_table(10957) := '6F6C65616E2063616E2062652070617373656420696E7374656164206966206F6E65206F6E6C79206E6565647320746F207475726E206F6E2F6F6666206C69676174757265732E22297D5D2C6465736372697074696F6E3A6228302C22436F6E66696775';
wwv_flow_imp.g_varchar2_table(10958) := '72657320666F6E74206C6967617475726573206F7220666F6E742066656174757265732E2043616E20626520656974686572206120626F6F6C65616E20746F20656E61626C652F64697361626C65206C6967617475726573206F72206120737472696E67';
wwv_flow_imp.g_varchar2_table(10959) := '20666F72207468652076616C7565206F6620746865204353532027666F6E742D666561747572652D73657474696E6773272070726F70657274792E22292C64656661756C743A21317D297D76616C69646174652865297B72657475726E20766F69642030';
wwv_flow_imp.g_varchar2_table(10960) := '3D3D3D653F746869732E64656661756C7456616C75653A22737472696E67223D3D747970656F6620653F2266616C7365223D3D3D657C7C303D3D3D652E6C656E6774683F414C2E4F46463A2274727565223D3D3D653F414C2E4F4E3A653A426F6F6C6561';
wwv_flow_imp.g_varchar2_table(10961) := '6E2865293F414C2E4F4E3A414C2E4F46467D7D414C2E4F46463D27226C69676122206F66662C202263616C7422206F6666272C414C2E4F4E3D27226C69676122206F6E2C202263616C7422206F6E273B636C617373204E4C20657874656E6473206D4C7B';
wwv_flow_imp.g_varchar2_table(10962) := '636F6E7374727563746F7228297B73757065722835342C22666F6E74566172696174696F6E73222C4E4C2E4F46462C7B616E794F663A5B7B747970653A22626F6F6C65616E222C6465736372697074696F6E3A6228302C22456E61626C65732F44697361';
wwv_flow_imp.g_varchar2_table(10963) := '626C657320746865207472616E736C6174696F6E2066726F6D20666F6E742D77656967687420746F20666F6E742D766172696174696F6E2D73657474696E67732E204368616E6765207468697320746F206120737472696E6720666F722066696E652D67';
wwv_flow_imp.g_varchar2_table(10964) := '7261696E656420636F6E74726F6C206F66207468652027666F6E742D766172696174696F6E2D73657474696E677327204353532070726F70657274792E22297D2C7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C22457870';
wwv_flow_imp.g_varchar2_table(10965) := '6C696369742027666F6E742D766172696174696F6E2D73657474696E677327204353532070726F70657274792E204120626F6F6C65616E2063616E2062652070617373656420696E7374656164206966206F6E65206F6E6C79206E6565647320746F2074';
wwv_flow_imp.g_varchar2_table(10966) := '72616E736C61746520666F6E742D77656967687420746F20666F6E742D766172696174696F6E2D73657474696E67732E22297D5D2C6465736372697074696F6E3A6228302C22436F6E6669677572657320666F6E7420766172696174696F6E732E204361';
wwv_flow_imp.g_varchar2_table(10967) := '6E20626520656974686572206120626F6F6C65616E20746F20656E61626C652F64697361626C6520746865207472616E736C6174696F6E2066726F6D20666F6E742D77656967687420746F20666F6E742D766172696174696F6E2D73657474696E677320';
wwv_flow_imp.g_varchar2_table(10968) := '6F72206120737472696E6720666F72207468652076616C7565206F6620746865204353532027666F6E742D766172696174696F6E2D73657474696E6773272070726F70657274792E22292C64656661756C743A21317D297D76616C69646174652865297B';
wwv_flow_imp.g_varchar2_table(10969) := '72657475726E20766F696420303D3D3D653F746869732E64656661756C7456616C75653A22737472696E67223D3D747970656F6620653F2266616C7365223D3D3D653F4E4C2E4F46463A2274727565223D3D3D653F4E4C2E5452414E534C4154453A653A';
wwv_flow_imp.g_varchar2_table(10970) := '426F6F6C65616E2865293F4E4C2E5452414E534C4154453A4E4C2E4F46467D636F6D7075746528652C742C6E297B72657475726E20652E666F6E74496E666F2E666F6E74566172696174696F6E53657474696E67737D7D4E4C2E4F46463D226E6F726D61';
wwv_flow_imp.g_varchar2_table(10971) := '6C222C4E4C2E5452414E534C4154453D227472616E736C617465223B636C61737320504C20657874656E6473206D4C7B636F6E7374727563746F7228297B73757065722835332C22666F6E74576569676874222C4B4C2E666F6E745765696768742C7B61';
wwv_flow_imp.g_varchar2_table(10972) := '6E794F663A5B7B747970653A226E756D626572222C6D696E696D756D3A504C2E4D494E494D554D5F56414C55452C6D6178696D756D3A504C2E4D4158494D554D5F56414C55452C6572726F724D6573736167653A6228302C274F6E6C7920226E6F726D61';
wwv_flow_imp.g_varchar2_table(10973) := '6C2220616E642022626F6C6422206B6579776F726473206F72206E756D62657273206265747765656E203120616E6420313030302061726520616C6C6F7765642E27297D2C7B747970653A22737472696E67222C7061747465726E3A225E286E6F726D61';
wwv_flow_imp.g_varchar2_table(10974) := '6C7C626F6C647C313030307C5B312D395D5B302D395D7B302C327D2924227D2C7B656E756D3A504C2E53554747455354494F4E5F56414C5545537D5D2C64656661756C743A4B4C2E666F6E745765696768742C6465736372697074696F6E3A6228302C27';
wwv_flow_imp.g_varchar2_table(10975) := '436F6E74726F6C732074686520666F6E74207765696768742E204163636570747320226E6F726D616C2220616E642022626F6C6422206B6579776F726473206F72206E756D62657273206265747765656E203120616E6420313030302E27297D297D7661';
wwv_flow_imp.g_varchar2_table(10976) := '6C69646174652865297B72657475726E226E6F726D616C223D3D3D657C7C22626F6C64223D3D3D653F653A537472696E6728534C2E636C616D706564496E7428652C4B4C2E666F6E745765696768742C504C2E4D494E494D554D5F56414C55452C504C2E';
wwv_flow_imp.g_varchar2_table(10977) := '4D4158494D554D5F56414C554529297D7D504C2E53554747455354494F4E5F56414C5545533D5B226E6F726D616C222C22626F6C64222C22313030222C22323030222C22333030222C22343030222C22353030222C22363030222C22373030222C223830';
wwv_flow_imp.g_varchar2_table(10978) := '30222C22393030225D2C504C2E4D494E494D554D5F56414C55453D312C504C2E4D4158494D554D5F56414C55453D3165333B636C617373204F4C20657874656E647320624C7B636F6E7374727563746F7228297B737570657228313435297D636F6D7075';
wwv_flow_imp.g_varchar2_table(10979) := '746528652C742C6E297B72657475726E204F4C2E636F6D707574654C61796F757428742C7B6D656D6F72793A652E6D656D6F72792C6F7574657257696474683A652E6F7574657257696474682C6F757465724865696768743A652E6F7574657248656967';
wwv_flow_imp.g_varchar2_table(10980) := '68742C6973446F6D696E6174656442794C6F6E674C696E65733A652E6973446F6D696E6174656442794C6F6E674C696E65732C6C696E654865696768743A652E666F6E74496E666F2E6C696E654865696768742C766965774C696E65436F756E743A652E';
wwv_flow_imp.g_varchar2_table(10981) := '766965774C696E65436F756E742C6C696E654E756D626572734469676974436F756E743A652E6C696E654E756D626572734469676974436F756E742C7479706963616C48616C66776964746843686172616374657257696474683A652E666F6E74496E66';
wwv_flow_imp.g_varchar2_table(10982) := '6F2E7479706963616C48616C66776964746843686172616374657257696474682C6D6178446967697457696474683A652E666F6E74496E666F2E6D6178446967697457696474682C706978656C526174696F3A652E706978656C526174696F2C676C7970';
wwv_flow_imp.g_varchar2_table(10983) := '684D617267696E4465636F726174696F6E4C616E65436F756E743A652E676C7970684D617267696E4465636F726174696F6E4C616E65436F756E747D297D73746174696320636F6D70757465436F6E7461696E65644D696E696D61704C696E65436F756E';
wwv_flow_imp.g_varchar2_table(10984) := '742865297B636F6E737420743D652E6865696768742F652E6C696E654865696768742C6E3D4D6174682E666C6F6F7228652E70616464696E67546F702F652E6C696E65486569676874293B6C657420693D4D6174682E666C6F6F7228652E70616464696E';
wwv_flow_imp.g_varchar2_table(10985) := '67426F74746F6D2F652E6C696E65486569676874293B652E7363726F6C6C4265796F6E644C6173744C696E65262628693D4D6174682E6D617828692C742D3129293B636F6E7374206F3D286E2B652E766965774C696E65436F756E742B69292F28652E70';
wwv_flow_imp.g_varchar2_table(10986) := '6978656C526174696F2A652E686569676874293B72657475726E7B7479706963616C56696577706F72744C696E65436F756E743A742C65787472614C696E65734265666F726546697273744C696E653A6E2C65787472614C696E65734265796F6E644C61';
wwv_flow_imp.g_varchar2_table(10987) := '73744C696E653A692C64657369726564526174696F3A6F2C6D696E696D61704C696E65436F756E743A4D6174682E666C6F6F7228652E766965774C696E65436F756E742F6F297D7D737461746963205F636F6D707574654D696E696D61704C61796F7574';
wwv_flow_imp.g_varchar2_table(10988) := '28652C74297B636F6E7374206E3D652E6F7574657257696474682C693D652E6F757465724865696768742C6F3D652E706978656C526174696F3B69662821652E6D696E696D61702E656E61626C65642972657475726E7B72656E6465724D696E696D6170';
wwv_flow_imp.g_varchar2_table(10989) := '3A302C6D696E696D61704C6566743A302C6D696E696D617057696474683A302C6D696E696D61704865696768744973456469746F724865696768743A21312C6D696E696D6170497353616D706C696E673A21312C6D696E696D61705363616C653A312C6D';
wwv_flow_imp.g_varchar2_table(10990) := '696E696D61704C696E654865696768743A312C6D696E696D617043616E766173496E6E657257696474683A302C6D696E696D617043616E766173496E6E65724865696768743A4D6174682E666C6F6F72286F2A69292C6D696E696D617043616E7661734F';
wwv_flow_imp.g_varchar2_table(10991) := '7574657257696474683A302C6D696E696D617043616E7661734F757465724865696768743A697D3B636F6E737420733D742E737461626C654D696E696D61704C61796F7574496E7075742C723D732626652E6F757465724865696768743D3D3D732E6F75';
wwv_flow_imp.g_varchar2_table(10992) := '7465724865696768742626652E6C696E654865696768743D3D3D732E6C696E654865696768742626652E7479706963616C48616C66776964746843686172616374657257696474683D3D3D732E7479706963616C48616C66776964746843686172616374';
wwv_flow_imp.g_varchar2_table(10993) := '657257696474682626652E706978656C526174696F3D3D3D732E706978656C526174696F2626652E7363726F6C6C4265796F6E644C6173744C696E653D3D3D732E7363726F6C6C4265796F6E644C6173744C696E652626652E70616464696E67546F703D';
wwv_flow_imp.g_varchar2_table(10994) := '3D3D732E70616464696E67546F702626652E70616464696E67426F74746F6D3D3D3D732E70616464696E67426F74746F6D2626652E6D696E696D61702E656E61626C65643D3D3D732E6D696E696D61702E656E61626C65642626652E6D696E696D61702E';
wwv_flow_imp.g_varchar2_table(10995) := '736964653D3D3D732E6D696E696D61702E736964652626652E6D696E696D61702E73697A653D3D3D732E6D696E696D61702E73697A652626652E6D696E696D61702E73686F77536C696465723D3D3D732E6D696E696D61702E73686F77536C6964657226';
wwv_flow_imp.g_varchar2_table(10996) := '26652E6D696E696D61702E72656E646572436861726163746572733D3D3D732E6D696E696D61702E72656E646572436861726163746572732626652E6D696E696D61702E6D6178436F6C756D6E3D3D3D732E6D696E696D61702E6D6178436F6C756D6E26';
wwv_flow_imp.g_varchar2_table(10997) := '26652E6D696E696D61702E7363616C653D3D3D732E6D696E696D61702E7363616C652626652E766572746963616C5363726F6C6C62617257696474683D3D3D732E766572746963616C5363726F6C6C62617257696474682626652E697356696577706F72';
wwv_flow_imp.g_varchar2_table(10998) := '745772617070696E673D3D3D732E697356696577706F72745772617070696E672C613D652E6C696E654865696768742C6C3D652E7479706963616C48616C66776964746843686172616374657257696474682C633D652E7363726F6C6C4265796F6E644C';
wwv_flow_imp.g_varchar2_table(10999) := '6173744C696E652C643D652E6D696E696D61702E72656E646572436861726163746572733B6C657420683D6F3E3D323F4D6174682E726F756E6428322A652E6D696E696D61702E7363616C65293A652E6D696E696D61702E7363616C653B636F6E737420';
wwv_flow_imp.g_varchar2_table(11000) := '753D652E6D696E696D61702E6D6178436F6C756D6E2C703D652E6D696E696D61702E73697A652C673D652E6D696E696D61702E736964652C6D3D652E766572746963616C5363726F6C6C62617257696474682C663D652E766965774C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(11001) := '2C763D652E72656D61696E696E6757696474682C623D652E697356696577706F72745772617070696E672C5F3D643F323A333B6C657420793D4D6174682E666C6F6F72286F2A69293B636F6E737420773D792F6F3B6C657420433D21312C533D21312C78';
wwv_flow_imp.g_varchar2_table(11002) := '3D5F2A682C6B3D682F6F2C453D313B6966282266696C6C223D3D3D707C7C22666974223D3D3D70297B636F6E73747B7479706963616C56696577706F72744C696E65436F756E743A6E2C65787472614C696E65734265666F726546697273744C696E653A';
wwv_flow_imp.g_varchar2_table(11003) := '732C65787472614C696E65734265796F6E644C6173744C696E653A6C2C64657369726564526174696F3A642C6D696E696D61704C696E65436F756E743A757D3D4F4C2E636F6D70757465436F6E7461696E65644D696E696D61704C696E65436F756E7428';
wwv_flow_imp.g_varchar2_table(11004) := '7B766965774C696E65436F756E743A662C7363726F6C6C4265796F6E644C6173744C696E653A632C70616464696E67546F703A652E70616464696E67546F702C70616464696E67426F74746F6D3A652E70616464696E67426F74746F6D2C686569676874';
wwv_flow_imp.g_varchar2_table(11005) := '3A692C6C696E654865696768743A612C706978656C526174696F3A6F7D293B696628662F753E3129433D21302C533D21302C683D312C783D312C6B3D682F6F3B656C73657B6C657420693D21312C633D682B313B69662822666974223D3D3D70297B636F';
wwv_flow_imp.g_varchar2_table(11006) := '6E737420653D4D6174682E6365696C2828732B662B6C292A78293B622626722626763C3D742E737461626C6546697452656D61696E696E6757696474683F28693D21302C633D742E737461626C654669744D61784D696E696D61705363616C65293A693D';
wwv_flow_imp.g_varchar2_table(11007) := '653E797D6966282266696C6C223D3D3D707C7C69297B433D21303B636F6E737420693D683B783D4D6174682E6D696E28612A6F2C4D6174682E6D617828312C4D6174682E666C6F6F7228312F642929292C622626722626763C3D742E737461626C654669';
wwv_flow_imp.g_varchar2_table(11008) := '7452656D61696E696E675769647468262628633D742E737461626C654669744D61784D696E696D61705363616C65292C683D4D6174682E6D696E28632C4D6174682E6D617828312C4D6174682E666C6F6F7228782F5F2929292C683E69262628453D4D61';
wwv_flow_imp.g_varchar2_table(11009) := '74682E6D696E28322C682F6929292C6B3D682F6F2F452C793D4D6174682E6365696C284D6174682E6D6178286E2C732B662B6C292A78292C623F28742E737461626C654D696E696D61704C61796F7574496E7075743D652C742E737461626C6546697452';
wwv_flow_imp.g_varchar2_table(11010) := '656D61696E696E6757696474683D762C742E737461626C654669744D61784D696E696D61705363616C653D68293A28742E737461626C654D696E696D61704C61796F7574496E7075743D6E756C6C2C742E737461626C6546697452656D61696E696E6757';
wwv_flow_imp.g_varchar2_table(11011) := '696474683D30297D7D7D636F6E7374204C3D4D6174682E666C6F6F7228752A6B292C443D4D6174682E6D696E284C2C4D6174682E6D617828302C4D6174682E666C6F6F722828762D6D2D32292A6B2F286C2B6B2929292B38293B6C657420543D4D617468';
wwv_flow_imp.g_varchar2_table(11012) := '2E666C6F6F72286F2A44293B636F6E737420493D542F6F3B72657475726E20543D4D6174682E666C6F6F7228542A45292C7B72656E6465724D696E696D61703A643F313A322C6D696E696D61704C6566743A226C656674223D3D3D673F303A6E2D442D6D';
wwv_flow_imp.g_varchar2_table(11013) := '2C6D696E696D617057696474683A442C6D696E696D61704865696768744973456469746F724865696768743A432C6D696E696D6170497353616D706C696E673A532C6D696E696D61705363616C653A682C6D696E696D61704C696E654865696768743A78';
wwv_flow_imp.g_varchar2_table(11014) := '2C6D696E696D617043616E766173496E6E657257696474683A542C6D696E696D617043616E766173496E6E65724865696768743A792C6D696E696D617043616E7661734F7574657257696474683A492C6D696E696D617043616E7661734F757465724865';
wwv_flow_imp.g_varchar2_table(11015) := '696768743A777D7D73746174696320636F6D707574654C61796F757428652C74297B636F6E7374206E3D307C742E6F7574657257696474682C693D307C742E6F757465724865696768742C6F3D307C742E6C696E654865696768742C733D307C742E6C69';
wwv_flow_imp.g_varchar2_table(11016) := '6E654E756D626572734469676974436F756E742C723D742E7479706963616C48616C66776964746843686172616374657257696474682C613D742E6D6178446967697457696474682C6C3D742E706978656C526174696F2C633D742E766965774C696E65';
wwv_flow_imp.g_varchar2_table(11017) := '436F756E742C643D652E67657428313337292C683D22696E6865726974223D3D3D643F652E67657428313336293A642C753D22696E6865726974223D3D3D683F652E67657428313332293A682C703D652E67657428313335292C673D742E6973446F6D69';
wwv_flow_imp.g_varchar2_table(11018) := '6E6174656442794C6F6E674C696E65732C6D3D652E676574283537292C663D30213D3D652E676574283638292E72656E646572547970652C763D652E676574283639292C623D652E67657428313035292C5F3D652E676574283834292C793D652E676574';
wwv_flow_imp.g_varchar2_table(11019) := '283733292C773D652E67657428313033292C433D772E766572746963616C5363726F6C6C62617253697A652C533D772E766572746963616C4861734172726F77732C783D772E6172726F7753697A652C6B3D772E686F72697A6F6E74616C5363726F6C6C';
wwv_flow_imp.g_varchar2_table(11020) := '62617253697A652C453D652E676574283433292C4C3D226E6576657222213D3D652E67657428313130293B6C657420443D652E676574283636293B4526264C262628442B3D3136293B6C657420543D303B69662866297B636F6E737420653D4D6174682E';
wwv_flow_imp.g_varchar2_table(11021) := '6D617828732C76293B543D4D6174682E726F756E6428652A61297D6C657420493D303B6D262628493D6F2A742E676C7970684D617267696E4465636F726174696F6E4C616E65436F756E74293B6C6574204D3D302C413D4D2B492C4E3D412B542C503D4E';
wwv_flow_imp.g_varchar2_table(11022) := '2B443B636F6E7374204F3D6E2D492D542D443B6C657420523D21312C463D21312C423D2D313B22696E6865726974223D3D3D682626673F28523D21302C463D2130293A226F6E223D3D3D757C7C22626F756E646564223D3D3D753F463D21303A22776F72';
wwv_flow_imp.g_varchar2_table(11023) := '6457726170436F6C756D6E223D3D3D75262628423D70293B636F6E737420563D4F4C2E5F636F6D707574654D696E696D61704C61796F7574287B6F7574657257696474683A6E2C6F757465724865696768743A692C6C696E654865696768743A6F2C7479';
wwv_flow_imp.g_varchar2_table(11024) := '706963616C48616C66776964746843686172616374657257696474683A722C706978656C526174696F3A6C2C7363726F6C6C4265796F6E644C6173744C696E653A622C70616464696E67546F703A5F2E746F702C70616464696E67426F74746F6D3A5F2E';
wwv_flow_imp.g_varchar2_table(11025) := '626F74746F6D2C6D696E696D61703A792C766572746963616C5363726F6C6C62617257696474683A432C766965774C696E65436F756E743A632C72656D61696E696E6757696474683A4F2C697356696577706F72745772617070696E673A467D2C742E6D';
wwv_flow_imp.g_varchar2_table(11026) := '656D6F72797C7C6E657720674C293B30213D3D562E72656E6465724D696E696D61702626303D3D3D562E6D696E696D61704C6566742626284D2B3D562E6D696E696D617057696474682C412B3D562E6D696E696D617057696474682C4E2B3D562E6D696E';
wwv_flow_imp.g_varchar2_table(11027) := '696D617057696474682C502B3D562E6D696E696D61705769647468293B636F6E7374207A3D4F2D562E6D696E696D617057696474682C483D4D6174682E6D617828312C4D6174682E666C6F6F7228287A2D432D32292F7229292C573D533F783A303B7265';
wwv_flow_imp.g_varchar2_table(11028) := '7475726E2046262628423D4D6174682E6D617828312C48292C22626F756E646564223D3D3D75262628423D4D6174682E6D696E28422C702929292C7B77696474683A6E2C6865696768743A692C676C7970684D617267696E4C6566743A4D2C676C797068';
wwv_flow_imp.g_varchar2_table(11029) := '4D617267696E57696474683A492C676C7970684D617267696E4465636F726174696F6E4C616E65436F756E743A742E676C7970684D617267696E4465636F726174696F6E4C616E65436F756E742C6C696E654E756D626572734C6566743A412C6C696E65';
wwv_flow_imp.g_varchar2_table(11030) := '4E756D6265727357696474683A542C6465636F726174696F6E734C6566743A4E2C6465636F726174696F6E7357696474683A442C636F6E74656E744C6566743A502C636F6E74656E7457696474683A7A2C6D696E696D61703A562C76696577706F727443';
wwv_flow_imp.g_varchar2_table(11031) := '6F6C756D6E3A482C6973576F7264577261704D696E69666965643A522C697356696577706F72745772617070696E673A462C7772617070696E67436F6C756D6E3A422C766572746963616C5363726F6C6C62617257696474683A432C686F72697A6F6E74';
wwv_flow_imp.g_varchar2_table(11032) := '616C5363726F6C6C6261724865696768743A6B2C6F7665727669657752756C65723A7B746F703A572C77696474683A432C6865696768743A692D322A572C72696768743A307D7D7D7D66756E6374696F6E20524C2865297B636F6E737420743D652E6765';
wwv_flow_imp.g_varchar2_table(11033) := '74283938293B72657475726E226564697461626C65223D3D3D743F652E676574283931293A226F6E22213D3D747D66756E6374696F6E20464C28652C74297B69662822737472696E6722213D747970656F6620652972657475726E20743B737769746368';
wwv_flow_imp.g_varchar2_table(11034) := '2865297B636173652268696464656E223A72657475726E20323B636173652276697369626C65223A72657475726E20333B64656661756C743A72657475726E20317D7D2166756E6374696F6E2865297B652E4F66663D226F6666222C652E4F6E436F6465';
wwv_flow_imp.g_varchar2_table(11035) := '3D226F6E436F6465222C652E4F6E3D226F6E227D284D4C7C7C284D4C3D7B7D29293B636F6E737420424C3D22696E556E74727573746564576F726B7370616365222C564C3D22656469746F722E756E69636F6465486967686C696768742E616C6C6F7765';
wwv_flow_imp.g_varchar2_table(11036) := '6443686172616374657273222C7A4C3D22656469746F722E756E69636F6465486967686C696768742E696E76697369626C6543686172616374657273222C484C3D22656469746F722E756E69636F6465486967686C696768742E6E6F6E42617369634153';
wwv_flow_imp.g_varchar2_table(11037) := '434949222C574C3D22656469746F722E756E69636F6465486967686C696768742E616D626967756F757343686172616374657273222C6A4C3D22656469746F722E756E69636F6465486967686C696768742E696E636C756465436F6D6D656E7473222C71';
wwv_flow_imp.g_varchar2_table(11038) := '4C3D22656469746F722E756E69636F6465486967686C696768742E696E636C756465537472696E6773222C244C3D22656469746F722E756E69636F6465486967686C696768742E616C6C6F7765644C6F63616C6573223B66756E6374696F6E20554C2865';
wwv_flow_imp.g_varchar2_table(11039) := '2C742C6E297B636F6E737420693D6E2E696E6465784F662865293B72657475726E2D313D3D3D693F743A6E5B695D7D636F6E7374204B4C3D7B666F6E7446616D696C793A713F224D656E6C6F2C204D6F6E61636F2C2027436F7572696572204E6577272C';
wwv_flow_imp.g_varchar2_table(11040) := '206D6F6E6F7370616365223A243F222744726F69642053616E73204D6F6E6F272C20276D6F6E6F7370616365272C206D6F6E6F7370616365223A22436F6E736F6C61732C2027436F7572696572204E6577272C206D6F6E6F7370616365222C666F6E7457';
wwv_flow_imp.g_varchar2_table(11041) := '65696768743A226E6F726D616C222C666F6E7453697A653A713F31323A31342C6C696E654865696768743A302C6C657474657253706163696E673A307D2C474C3D5B5D3B66756E6374696F6E20514C2865297B72657475726E20474C5B652E69645D3D65';
wwv_flow_imp.g_varchar2_table(11042) := '2C657D636F6E737420594C3D7B61636365707453756767657374696F6E4F6E436F6D6D69744368617261637465723A514C286E657720774C28302C2261636365707453756767657374696F6E4F6E436F6D6D6974436861726163746572222C21302C7B6D';
wwv_flow_imp.g_varchar2_table(11043) := '61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722073756767657374696F6E732073686F756C64206265206163636570746564206F6E20636F6D6D697420636861726163746572732E20466F72206578';
wwv_flow_imp.g_varchar2_table(11044) := '616D706C652C20696E204A6176615363726970742C207468652073656D692D636F6C6F6E2028603B60292063616E206265206120636F6D6D6974206368617261637465722074686174206163636570747320612073756767657374696F6E20616E642074';
wwv_flow_imp.g_varchar2_table(11045) := '797065732074686174206368617261637465722E22297D29292C61636365707453756767657374696F6E4F6E456E7465723A514C286E657720444C28312C2261636365707453756767657374696F6E4F6E456E746572222C226F6E222C5B226F6E222C22';
wwv_flow_imp.g_varchar2_table(11046) := '736D617274222C226F6666225D2C7B6D61726B646F776E456E756D4465736372697074696F6E733A5B22222C6228302C224F6E6C792061636365707420612073756767657374696F6E20776974682060456E74657260207768656E206974206D616B6573';
wwv_flow_imp.g_varchar2_table(11047) := '2061207465787475616C206368616E67652E22292C22225D2C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722073756767657374696F6E732073686F756C64206265206163636570746564206F6E';
wwv_flow_imp.g_varchar2_table(11048) := '2060456E746572602C20696E206164646974696F6E20746F2060546162602E2048656C707320746F2061766F696420616D62696775697479206265747765656E20696E73657274696E67206E6577206C696E6573206F7220616363657074696E67207375';
wwv_flow_imp.g_varchar2_table(11049) := '6767657374696F6E732E22297D29292C6163636573736962696C697479537570706F72743A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B737570657228322C226163636573736962696C697479537570';
wwv_flow_imp.g_varchar2_table(11050) := '706F7274222C302C7B747970653A22737472696E67222C656E756D3A5B226175746F222C226F6E222C226F6666225D2C656E756D4465736372697074696F6E733A5B6228302C2255736520706C6174666F726D204150497320746F206465746563742077';
wwv_flow_imp.g_varchar2_table(11051) := '68656E20612053637265656E205265616465722069732061747461636865642E22292C6228302C224F7074696D697A6520666F72207573616765207769746820612053637265656E205265616465722E22292C6228302C22417373756D65206120736372';
wwv_flow_imp.g_varchar2_table(11052) := '65656E20726561646572206973206E6F742061747461636865642E22295D2C64656661756C743A226175746F222C746167733A5B226163636573736962696C697479225D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73206966207468';
wwv_flow_imp.g_varchar2_table(11053) := '652055492073686F756C642072756E20696E2061206D6F6465207768657265206974206973206F7074696D697A656420666F722073637265656E20726561646572732E22297D297D76616C69646174652865297B7377697463682865297B636173652261';
wwv_flow_imp.g_varchar2_table(11054) := '75746F223A72657475726E20303B63617365226F6666223A72657475726E20313B63617365226F6E223A72657475726E20327D72657475726E20746869732E64656661756C7456616C75657D636F6D7075746528652C742C6E297B72657475726E20303D';
wwv_flow_imp.g_varchar2_table(11055) := '3D3D6E3F652E6163636573736962696C697479537570706F72743A6E7D7D292C6163636573736962696C6974795061676553697A653A514C286E657720534C28332C226163636573736962696C6974795061676553697A65222C31302C312C3130373337';
wwv_flow_imp.g_varchar2_table(11056) := '34313832342C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206E756D626572206F66206C696E657320696E2074686520656469746F7220746861742063616E2062652072656164206F757420627920612073637265656E20';
wwv_flow_imp.g_varchar2_table(11057) := '726561646572206174206F6E63652E205768656E2077652064657465637420612073637265656E20726561646572207765206175746F6D61746963616C6C7920736574207468652064656661756C7420746F206265203530302E205761726E696E673A20';
wwv_flow_imp.g_varchar2_table(11058) := '7468697320686173206120706572666F726D616E636520696D706C69636174696F6E20666F72206E756D62657273206C6172676572207468616E207468652064656661756C742E22292C746167733A5B226163636573736962696C697479225D7D29292C';
wwv_flow_imp.g_varchar2_table(11059) := '617269614C6162656C3A514C286E657720454C28342C22617269614C6162656C222C6228302C22456469746F7220636F6E74656E74222929292C6172696152657175697265643A514C286E657720774C28352C22617269615265717569726564222C2131';
wwv_flow_imp.g_varchar2_table(11060) := '2C766F6964203029292C73637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E3A514C286E657720774C28382C2273637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E222C2130';
wwv_flow_imp.g_varchar2_table(11061) := '2C7B6465736372697074696F6E3A6228302C22436F6E74726F6C207768657468657220696E6C696E652073756767657374696F6E732061726520616E6E6F756E63656420627920612073637265656E207265616465722E22292C746167733A5B22616363';
wwv_flow_imp.g_varchar2_table(11062) := '6573736962696C697479225D7D29292C6175746F436C6F73696E67427261636B6574733A514C286E657720444C28362C226175746F436C6F73696E67427261636B657473222C226C616E6775616765446566696E6564222C5B22616C77617973222C226C';
wwv_flow_imp.g_varchar2_table(11063) := '616E6775616765446566696E6564222C226265666F726557686974657370616365222C226E65766572225D2C7B656E756D4465736372697074696F6E733A5B22222C6228302C22557365206C616E677561676520636F6E66696775726174696F6E732074';
wwv_flow_imp.g_varchar2_table(11064) := '6F2064657465726D696E65207768656E20746F206175746F636C6F736520627261636B6574732E22292C6228302C224175746F636C6F736520627261636B657473206F6E6C79207768656E2074686520637572736F7220697320746F20746865206C6566';
wwv_flow_imp.g_varchar2_table(11065) := '74206F6620776869746573706163652E22292C22225D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C64206175746F6D61746963616C6C7920636C6F736520627261636B';
wwv_flow_imp.g_varchar2_table(11066) := '657473206166746572207468652075736572206164647320616E206F70656E696E6720627261636B65742E22297D29292C6175746F436C6F73696E67436F6D6D656E74733A514C286E657720444C28372C226175746F436C6F73696E67436F6D6D656E74';
wwv_flow_imp.g_varchar2_table(11067) := '73222C226C616E6775616765446566696E6564222C5B22616C77617973222C226C616E6775616765446566696E6564222C226265666F726557686974657370616365222C226E65766572225D2C7B656E756D4465736372697074696F6E733A5B22222C62';
wwv_flow_imp.g_varchar2_table(11068) := '28302C22557365206C616E677561676520636F6E66696775726174696F6E7320746F2064657465726D696E65207768656E20746F206175746F636C6F736520636F6D6D656E74732E22292C6228302C224175746F636C6F736520636F6D6D656E7473206F';
wwv_flow_imp.g_varchar2_table(11069) := '6E6C79207768656E2074686520637572736F7220697320746F20746865206C656674206F6620776869746573706163652E22292C22225D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F72';
wwv_flow_imp.g_varchar2_table(11070) := '2073686F756C64206175746F6D61746963616C6C7920636C6F736520636F6D6D656E7473206166746572207468652075736572206164647320616E206F70656E696E6720636F6D6D656E742E22297D29292C6175746F436C6F73696E6744656C6574653A';
wwv_flow_imp.g_varchar2_table(11071) := '514C286E657720444C28392C226175746F436C6F73696E6744656C657465222C226175746F222C5B22616C77617973222C226175746F222C226E65766572225D2C7B656E756D4465736372697074696F6E733A5B22222C6228302C2252656D6F76652061';
wwv_flow_imp.g_varchar2_table(11072) := '646A6163656E7420636C6F73696E672071756F746573206F7220627261636B657473206F6E6C7920696620746865792077657265206175746F6D61746963616C6C7920696E7365727465642E22292C22225D2C6465736372697074696F6E3A6228302C22';
wwv_flow_imp.g_varchar2_table(11073) := '436F6E74726F6C7320776865746865722074686520656469746F722073686F756C642072656D6F76652061646A6163656E7420636C6F73696E672071756F746573206F7220627261636B657473207768656E2064656C6574696E672E22297D29292C6175';
wwv_flow_imp.g_varchar2_table(11074) := '746F436C6F73696E674F766572747970653A514C286E657720444C2831302C226175746F436C6F73696E674F76657274797065222C226175746F222C5B22616C77617973222C226175746F222C226E65766572225D2C7B656E756D446573637269707469';
wwv_flow_imp.g_varchar2_table(11075) := '6F6E733A5B22222C6228302C2254797065206F76657220636C6F73696E672071756F746573206F7220627261636B657473206F6E6C7920696620746865792077657265206175746F6D61746963616C6C7920696E7365727465642E22292C22225D2C6465';
wwv_flow_imp.g_varchar2_table(11076) := '736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C642074797065206F76657220636C6F73696E672071756F746573206F7220627261636B6574732E22297D29292C6175746F436C6F';
wwv_flow_imp.g_varchar2_table(11077) := '73696E6751756F7465733A514C286E657720444C2831312C226175746F436C6F73696E6751756F746573222C226C616E6775616765446566696E6564222C5B22616C77617973222C226C616E6775616765446566696E6564222C226265666F7265576869';
wwv_flow_imp.g_varchar2_table(11078) := '74657370616365222C226E65766572225D2C7B656E756D4465736372697074696F6E733A5B22222C6228302C22557365206C616E677561676520636F6E66696775726174696F6E7320746F2064657465726D696E65207768656E20746F206175746F636C';
wwv_flow_imp.g_varchar2_table(11079) := '6F73652071756F7465732E22292C6228302C224175746F636C6F73652071756F746573206F6E6C79207768656E2074686520637572736F7220697320746F20746865206C656674206F6620776869746573706163652E22292C22225D2C64657363726970';
wwv_flow_imp.g_varchar2_table(11080) := '74696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C64206175746F6D61746963616C6C7920636C6F73652071756F746573206166746572207468652075736572206164647320616E206F70656E69';
wwv_flow_imp.g_varchar2_table(11081) := '6E672071756F74652E22297D29292C6175746F496E64656E743A514C286E657720544C2831322C226175746F496E64656E74222C342C2266756C6C222C5B226E6F6E65222C226B656570222C22627261636B657473222C22616476616E636564222C2266';
wwv_flow_imp.g_varchar2_table(11082) := '756C6C225D2C2866756E6374696F6E2865297B7377697463682865297B63617365226E6F6E65223A72657475726E20303B63617365226B656570223A72657475726E20313B6361736522627261636B657473223A72657475726E20323B63617365226164';
wwv_flow_imp.g_varchar2_table(11083) := '76616E636564223A72657475726E20333B636173652266756C6C223A72657475726E20347D7D292C7B656E756D4465736372697074696F6E733A5B6228302C2254686520656469746F722077696C6C206E6F7420696E7365727420696E64656E74617469';
wwv_flow_imp.g_varchar2_table(11084) := '6F6E206175746F6D61746963616C6C792E22292C6228302C2254686520656469746F722077696C6C206B656570207468652063757272656E74206C696E65277320696E64656E746174696F6E2E22292C6228302C2254686520656469746F722077696C6C';
wwv_flow_imp.g_varchar2_table(11085) := '206B656570207468652063757272656E74206C696E65277320696E64656E746174696F6E20616E6420686F6E6F72206C616E677561676520646566696E656420627261636B6574732E22292C6228302C2254686520656469746F722077696C6C206B6565';
wwv_flow_imp.g_varchar2_table(11086) := '70207468652063757272656E74206C696E65277320696E64656E746174696F6E2C20686F6E6F72206C616E677561676520646566696E656420627261636B65747320616E6420696E766F6B65207370656369616C206F6E456E74657252756C6573206465';
wwv_flow_imp.g_varchar2_table(11087) := '66696E6564206279206C616E6775616765732E22292C6228302C2254686520656469746F722077696C6C206B656570207468652063757272656E74206C696E65277320696E64656E746174696F6E2C20686F6E6F72206C616E677561676520646566696E';
wwv_flow_imp.g_varchar2_table(11088) := '656420627261636B6574732C20696E766F6B65207370656369616C206F6E456E74657252756C657320646566696E6564206279206C616E6775616765732C20616E6420686F6E6F7220696E64656E746174696F6E52756C657320646566696E6564206279';
wwv_flow_imp.g_varchar2_table(11089) := '206C616E6775616765732E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C64206175746F6D61746963616C6C792061646A7573742074686520696E64656E746174';
wwv_flow_imp.g_varchar2_table(11090) := '696F6E207768656E20757365727320747970652C2070617374652C206D6F7665206F7220696E64656E74206C696E65732E22297D29292C6175746F6D617469634C61796F75743A514C286E657720774C2831332C226175746F6D617469634C61796F7574';
wwv_flow_imp.g_varchar2_table(11091) := '222C213129292C6175746F537572726F756E643A514C286E657720444C2831342C226175746F537572726F756E64222C226C616E6775616765446566696E6564222C5B226C616E6775616765446566696E6564222C2271756F746573222C22627261636B';
wwv_flow_imp.g_varchar2_table(11092) := '657473222C226E65766572225D2C7B656E756D4465736372697074696F6E733A5B6228302C22557365206C616E677561676520636F6E66696775726174696F6E7320746F2064657465726D696E65207768656E20746F206175746F6D61746963616C6C79';
wwv_flow_imp.g_varchar2_table(11093) := '20737572726F756E642073656C656374696F6E732E22292C6228302C22537572726F756E6420776974682071756F74657320627574206E6F7420627261636B6574732E22292C6228302C22537572726F756E64207769746820627261636B657473206275';
wwv_flow_imp.g_varchar2_table(11094) := '74206E6F742071756F7465732E22292C22225D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C64206175746F6D61746963616C6C7920737572726F756E642073656C6563';
wwv_flow_imp.g_varchar2_table(11095) := '74696F6E73207768656E20747970696E672071756F746573206F7220627261636B6574732E22297D29292C627261636B657450616972436F6C6F72697A6174696F6E3A514C286E657720636C61737320657874656E6473206D4C7B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(11096) := '6F7228297B636F6E737420653D7B656E61626C65643A45752E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732E656E61626C65642C696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970653A45';
wwv_flow_imp.g_varchar2_table(11097) := '752E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732E696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970657D3B73757065722831352C22627261636B657450616972436F6C6F72697A617469';
wwv_flow_imp.g_varchar2_table(11098) := '6F6E222C652C7B22656469746F722E627261636B657450616972436F6C6F72697A6174696F6E2E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6D61726B646F776E4465736372697074696F';
wwv_flow_imp.g_varchar2_table(11099) := '6E3A6228302C22436F6E74726F6C73207768657468657220627261636B6574207061697220636F6C6F72697A6174696F6E20697320656E61626C6564206F72206E6F742E20557365207B307D20746F206F766572726964652074686520627261636B6574';
wwv_flow_imp.g_varchar2_table(11100) := '20686967686C6967687420636F6C6F72732E222C226023776F726B62656E63682E636F6C6F72437573746F6D697A6174696F6E73236022297D2C22656469746F722E627261636B657450616972436F6C6F72697A6174696F6E2E696E646570656E64656E';
wwv_flow_imp.g_varchar2_table(11101) := '74436F6C6F72506F6F6C506572427261636B657454797065223A7B747970653A22626F6F6C65616E222C64656661756C743A652E696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970652C6465736372697074696F6E3A62';
wwv_flow_imp.g_varchar2_table(11102) := '28302C22436F6E74726F6C732077686574686572206561636820627261636B657420747970652068617320697473206F776E20696E646570656E64656E7420636F6C6F7220706F6F6C2E22297D7D297D76616C69646174652865297B69662821657C7C22';
wwv_flow_imp.g_varchar2_table(11103) := '6F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65642C746869732E64656661756C7456616C75652E65';
wwv_flow_imp.g_varchar2_table(11104) := '6E61626C6564292C696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970653A794C28742E696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970652C746869732E64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(11105) := '2E696E646570656E64656E74436F6C6F72506F6F6C506572427261636B657454797065297D7D7D292C627261636B6574506169724775696465733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E';
wwv_flow_imp.g_varchar2_table(11106) := '737420653D7B627261636B657450616972733A21312C627261636B65745061697273486F72697A6F6E74616C3A22616374697665222C686967686C69676874416374697665427261636B6574506169723A21302C696E64656E746174696F6E3A21302C68';
wwv_flow_imp.g_varchar2_table(11107) := '6967686C69676874416374697665496E64656E746174696F6E3A21307D3B73757065722831362C22677569646573222C652C7B22656469746F722E6775696465732E627261636B65745061697273223A7B747970653A5B22626F6F6C65616E222C227374';
wwv_flow_imp.g_varchar2_table(11108) := '72696E67225D2C656E756D3A5B21302C22616374697665222C21315D2C656E756D4465736372697074696F6E733A5B6228302C22456E61626C657320627261636B65742070616972206775696465732E22292C6228302C22456E61626C65732062726163';
wwv_flow_imp.g_varchar2_table(11109) := '6B6574207061697220677569646573206F6E6C7920666F72207468652061637469766520627261636B657420706169722E22292C6228302C2244697361626C657320627261636B65742070616972206775696465732E22295D2C64656661756C743A652E';
wwv_flow_imp.g_varchar2_table(11110) := '627261636B657450616972732C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220627261636B65742070616972206775696465732061726520656E61626C6564206F72206E6F742E22297D2C22656469746F722E6775';
wwv_flow_imp.g_varchar2_table(11111) := '696465732E627261636B65745061697273486F72697A6F6E74616C223A7B747970653A5B22626F6F6C65616E222C22737472696E67225D2C656E756D3A5B21302C22616374697665222C21315D2C656E756D4465736372697074696F6E733A5B6228302C';
wwv_flow_imp.g_varchar2_table(11112) := '22456E61626C657320686F72697A6F6E74616C20677569646573206173206164646974696F6E20746F20766572746963616C20627261636B65742070616972206775696465732E22292C6228302C22456E61626C657320686F72697A6F6E74616C206775';
wwv_flow_imp.g_varchar2_table(11113) := '69646573206F6E6C7920666F72207468652061637469766520627261636B657420706169722E22292C6228302C2244697361626C657320686F72697A6F6E74616C20627261636B65742070616972206775696465732E22295D2C64656661756C743A652E';
wwv_flow_imp.g_varchar2_table(11114) := '627261636B65745061697273486F72697A6F6E74616C2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220686F72697A6F6E74616C20627261636B65742070616972206775696465732061726520656E61626C656420';
wwv_flow_imp.g_varchar2_table(11115) := '6F72206E6F742E22297D2C22656469746F722E6775696465732E686967686C69676874416374697665427261636B657450616972223A7B747970653A22626F6F6C65616E222C64656661756C743A652E686967686C69676874416374697665427261636B';
wwv_flow_imp.g_varchar2_table(11116) := '6574506169722C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C6420686967686C69676874207468652061637469766520627261636B657420706169722E22297D2C226564';
wwv_flow_imp.g_varchar2_table(11117) := '69746F722E6775696465732E696E64656E746174696F6E223A7B747970653A22626F6F6C65616E222C64656661756C743A652E696E64656E746174696F6E2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746865';
wwv_flow_imp.g_varchar2_table(11118) := '20656469746F722073686F756C642072656E64657220696E64656E74206775696465732E22297D2C22656469746F722E6775696465732E686967686C69676874416374697665496E64656E746174696F6E223A7B747970653A5B22626F6F6C65616E222C';
wwv_flow_imp.g_varchar2_table(11119) := '22737472696E67225D2C656E756D3A5B21302C22616C77617973222C21315D2C656E756D4465736372697074696F6E733A5B6228302C22486967686C6967687473207468652061637469766520696E64656E742067756964652E22292C6228302C224869';
wwv_flow_imp.g_varchar2_table(11120) := '67686C6967687473207468652061637469766520696E64656E74206775696465206576656E20696620627261636B6574206775696465732061726520686967686C6967687465642E22292C6228302C22446F206E6F7420686967686C6967687420746865';
wwv_flow_imp.g_varchar2_table(11121) := '2061637469766520696E64656E742067756964652E22295D2C64656661756C743A652E686967686C69676874416374697665496E64656E746174696F6E2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520';
wwv_flow_imp.g_varchar2_table(11122) := '656469746F722073686F756C6420686967686C69676874207468652061637469766520696E64656E742067756964652E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E2074';
wwv_flow_imp.g_varchar2_table(11123) := '6869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B627261636B657450616972733A554C28742E627261636B657450616972732C746869732E64656661756C7456616C75652E627261636B657450616972732C5B21302C';
wwv_flow_imp.g_varchar2_table(11124) := '21312C22616374697665225D292C627261636B65745061697273486F72697A6F6E74616C3A554C28742E627261636B65745061697273486F72697A6F6E74616C2C746869732E64656661756C7456616C75652E627261636B65745061697273486F72697A';
wwv_flow_imp.g_varchar2_table(11125) := '6F6E74616C2C5B21302C21312C22616374697665225D292C686967686C69676874416374697665427261636B6574506169723A794C28742E686967686C69676874416374697665427261636B6574506169722C746869732E64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(11126) := '2E686967686C69676874416374697665427261636B657450616972292C696E64656E746174696F6E3A794C28742E696E64656E746174696F6E2C746869732E64656661756C7456616C75652E696E64656E746174696F6E292C686967686C696768744163';
wwv_flow_imp.g_varchar2_table(11127) := '74697665496E64656E746174696F6E3A554C28742E686967686C69676874416374697665496E64656E746174696F6E2C746869732E64656661756C7456616C75652E686967686C69676874416374697665496E64656E746174696F6E2C5B21302C21312C';
wwv_flow_imp.g_varchar2_table(11128) := '22616C77617973225D297D7D7D292C737469636B7954616253746F70733A514C286E657720774C283131362C22737469636B7954616253746F7073222C21312C7B6465736372697074696F6E3A6228302C22456D756C6174652073656C656374696F6E20';
wwv_flow_imp.g_varchar2_table(11129) := '6265686176696F72206F66207461622063686172616374657273207768656E207573696E672073706163657320666F7220696E64656E746174696F6E2E2053656C656374696F6E2077696C6C20737469636B20746F207461622073746F70732E22297D29';
wwv_flow_imp.g_varchar2_table(11130) := '292C636F64654C656E733A514C286E657720774C2831372C22636F64654C656E73222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F777320436F64654C656E732E22';
wwv_flow_imp.g_varchar2_table(11131) := '297D29292C636F64654C656E73466F6E7446616D696C793A514C286E657720454C2831382C22636F64654C656E73466F6E7446616D696C79222C22222C7B6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E742066616D';
wwv_flow_imp.g_varchar2_table(11132) := '696C7920666F7220436F64654C656E732E22297D29292C636F64654C656E73466F6E7453697A653A514C286E657720534C2831392C22636F64654C656E73466F6E7453697A65222C302C302C3130302C7B747970653A226E756D626572222C6465666175';
wwv_flow_imp.g_varchar2_table(11133) := '6C743A302C6D696E696D756D3A302C6D6178696D756D3A3130302C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E742073697A6520696E20706978656C7320666F7220436F64654C656E732E2057';
wwv_flow_imp.g_varchar2_table(11134) := '68656E2073657420746F20302C20393025206F66206023656469746F722E666F6E7453697A65236020697320757365642E22297D29292C636F6C6F724465636F7261746F72733A514C286E657720774C2832302C22636F6C6F724465636F7261746F7273';
wwv_flow_imp.g_varchar2_table(11135) := '222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C642072656E6465722074686520696E6C696E6520636F6C6F72206465636F7261746F727320616E6420636F6C';
wwv_flow_imp.g_varchar2_table(11136) := '6F72207069636B65722E22297D29292C636F6C6F724465636F7261746F724163746976617465644F6E3A514C286E657720444C283134382C22636F6C6F724465636F7261746F72734163746976617465644F6E222C22636C69636B416E64486F76657222';
wwv_flow_imp.g_varchar2_table(11137) := '2C5B22636C69636B416E64486F766572222C22686F766572222C22636C69636B225D2C7B656E756D4465736372697074696F6E733A5B6228302C224D616B652074686520636F6C6F72207069636B65722061707065617220626F7468206F6E20636C6963';
wwv_flow_imp.g_varchar2_table(11138) := '6B20616E6420686F766572206F662074686520636F6C6F72206465636F7261746F7222292C6228302C224D616B652074686520636F6C6F72207069636B657220617070656172206F6E20686F766572206F662074686520636F6C6F72206465636F726174';
wwv_flow_imp.g_varchar2_table(11139) := '6F7222292C6228302C224D616B652074686520636F6C6F72207069636B657220617070656172206F6E20636C69636B206F662074686520636F6C6F72206465636F7261746F7222295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320';
wwv_flow_imp.g_varchar2_table(11140) := '74686520636F6E646974696F6E20746F206D616B65206120636F6C6F72207069636B6572206170706561722066726F6D206120636F6C6F72206465636F7261746F7222297D29292C636F6C6F724465636F7261746F72734C696D69743A514C286E657720';
wwv_flow_imp.g_varchar2_table(11141) := '534C2832312C22636F6C6F724465636F7261746F72734C696D6974222C3530302C312C3165362C7B6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206D6178206E756D626572206F6620636F6C6F72206465';
wwv_flow_imp.g_varchar2_table(11142) := '636F7261746F727320746861742063616E2062652072656E646572656420696E20616E20656469746F72206174206F6E63652E22297D29292C636F6C756D6E53656C656374696F6E3A514C286E657720774C2832322C22636F6C756D6E53656C65637469';
wwv_flow_imp.g_varchar2_table(11143) := '6F6E222C21312C7B6465736372697074696F6E3A6228302C22456E61626C652074686174207468652073656C656374696F6E207769746820746865206D6F75736520616E64206B65797320697320646F696E6720636F6C756D6E2073656C656374696F6E';
wwv_flow_imp.g_varchar2_table(11144) := '2E22297D29292C636F6D6D656E74733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B696E7365727453706163653A21302C69676E6F7265456D7074794C696E65733A21307D3B73';
wwv_flow_imp.g_varchar2_table(11145) := '757065722832332C22636F6D6D656E7473222C652C7B22656469746F722E636F6D6D656E74732E696E736572745370616365223A7B747970653A22626F6F6C65616E222C64656661756C743A652E696E7365727453706163652C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(11146) := '6E3A6228302C22436F6E74726F6C73207768657468657220612073706163652063686172616374657220697320696E736572746564207768656E20636F6D6D656E74696E672E22297D2C22656469746F722E636F6D6D656E74732E69676E6F7265456D70';
wwv_flow_imp.g_varchar2_table(11147) := '74794C696E6573223A7B747970653A22626F6F6C65616E222C64656661756C743A652E69676E6F7265456D7074794C696E65732C6465736372697074696F6E3A6228302C22436F6E74726F6C7320696620656D707479206C696E65732073686F756C6420';
wwv_flow_imp.g_varchar2_table(11148) := '62652069676E6F726564207769746820746F67676C652C20616464206F722072656D6F766520616374696F6E7320666F72206C696E6520636F6D6D656E74732E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D74';
wwv_flow_imp.g_varchar2_table(11149) := '7970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B696E7365727453706163653A794C28742E696E7365727453706163652C746869732E64656661756C7456616C75652E696E73';
wwv_flow_imp.g_varchar2_table(11150) := '6572745370616365292C69676E6F7265456D7074794C696E65733A794C28742E69676E6F7265456D7074794C696E65732C746869732E64656661756C7456616C75652E69676E6F7265456D7074794C696E6573297D7D7D292C636F6E746578746D656E75';
wwv_flow_imp.g_varchar2_table(11151) := '3A514C286E657720774C2832342C22636F6E746578746D656E75222C213029292C636F70795769746853796E746178486967686C69676874696E673A514C286E657720774C2832352C22636F70795769746853796E746178486967686C69676874696E67';
wwv_flow_imp.g_varchar2_table(11152) := '222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722073796E74617820686967686C69676874696E672073686F756C6420626520636F7069656420696E746F2074686520636C6970626F6172642E22297D29';
wwv_flow_imp.g_varchar2_table(11153) := '292C637572736F72426C696E6B696E673A514C286E657720544C2832362C22637572736F72426C696E6B696E67222C312C22626C696E6B222C5B22626C696E6B222C22736D6F6F7468222C227068617365222C22657870616E64222C22736F6C6964225D';
wwv_flow_imp.g_varchar2_table(11154) := '2C2866756E6374696F6E2865297B7377697463682865297B6361736522626C696E6B223A72657475726E20313B6361736522736D6F6F7468223A72657475726E20323B63617365227068617365223A72657475726E20333B6361736522657870616E6422';
wwv_flow_imp.g_varchar2_table(11155) := '3A72657475726E20343B6361736522736F6C6964223A72657475726E20357D7D292C7B6465736372697074696F6E3A6228302C22436F6E74726F6C2074686520637572736F7220616E696D6174696F6E207374796C652E22297D29292C637572736F7253';
wwv_flow_imp.g_varchar2_table(11156) := '6D6F6F74684361726574416E696D6174696F6E3A514C286E657720444C2832372C22637572736F72536D6F6F74684361726574416E696D6174696F6E222C226F6666222C5B226F6666222C226578706C69636974222C226F6E225D2C7B656E756D446573';
wwv_flow_imp.g_varchar2_table(11157) := '6372697074696F6E733A5B6228302C22536D6F6F746820636172657420616E696D6174696F6E2069732064697361626C65642E22292C6228302C22536D6F6F746820636172657420616E696D6174696F6E20697320656E61626C6564206F6E6C79207768';
wwv_flow_imp.g_varchar2_table(11158) := '656E207468652075736572206D6F7665732074686520637572736F72207769746820616E206578706C6963697420676573747572652E22292C6228302C22536D6F6F746820636172657420616E696D6174696F6E20697320616C7761797320656E61626C';
wwv_flow_imp.g_varchar2_table(11159) := '65642E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520736D6F6F746820636172657420616E696D6174696F6E2073686F756C6420626520656E61626C65642E22297D29292C637572736F725374';
wwv_flow_imp.g_varchar2_table(11160) := '796C653A514C286E657720544C2832382C22637572736F725374796C65222C494C2E4C696E652C226C696E65222C5B226C696E65222C22626C6F636B222C22756E6465726C696E65222C226C696E652D7468696E222C22626C6F636B2D6F75746C696E65';
wwv_flow_imp.g_varchar2_table(11161) := '222C22756E6465726C696E652D7468696E225D2C2866756E6374696F6E2865297B7377697463682865297B63617365226C696E65223A72657475726E20494C2E4C696E653B6361736522626C6F636B223A72657475726E20494C2E426C6F636B3B636173';
wwv_flow_imp.g_varchar2_table(11162) := '6522756E6465726C696E65223A72657475726E20494C2E556E6465726C696E653B63617365226C696E652D7468696E223A72657475726E20494C2E4C696E655468696E3B6361736522626C6F636B2D6F75746C696E65223A72657475726E20494C2E426C';
wwv_flow_imp.g_varchar2_table(11163) := '6F636B4F75746C696E653B6361736522756E6465726C696E652D7468696E223A72657475726E20494C2E556E6465726C696E655468696E7D7D292C7B6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520637572736F7220737479';
wwv_flow_imp.g_varchar2_table(11164) := '6C652E22297D29292C637572736F72537572726F756E64696E674C696E65733A514C286E657720534C2832392C22637572736F72537572726F756E64696E674C696E6573222C302C302C313037333734313832342C7B6465736372697074696F6E3A6228';
wwv_flow_imp.g_varchar2_table(11165) := '302C22436F6E74726F6C7320746865206D696E696D616C206E756D626572206F662076697369626C65206C656164696E67206C696E657320286D696E696D756D20302920616E6420747261696C696E67206C696E657320286D696E696D756D2031292073';
wwv_flow_imp.g_varchar2_table(11166) := '7572726F756E64696E672074686520637572736F722E204B6E6F776E20617320277363726F6C6C4F666627206F7220277363726F6C6C4F66667365742720696E20736F6D65206F7468657220656469746F72732E22297D29292C637572736F7253757272';
wwv_flow_imp.g_varchar2_table(11167) := '6F756E64696E674C696E65735374796C653A514C286E657720444C2833302C22637572736F72537572726F756E64696E674C696E65735374796C65222C2264656661756C74222C5B2264656661756C74222C22616C6C225D2C7B656E756D446573637269';
wwv_flow_imp.g_varchar2_table(11168) := '7074696F6E733A5B6228302C2260637572736F72537572726F756E64696E674C696E65736020697320656E666F72636564206F6E6C79207768656E207472696767657265642076696120746865206B6579626F617264206F72204150492E22292C622830';
wwv_flow_imp.g_varchar2_table(11169) := '2C2260637572736F72537572726F756E64696E674C696E65736020697320656E666F7263656420616C776179732E22295D2C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C73207768656E206023656469746F722E6375';
wwv_flow_imp.g_varchar2_table(11170) := '72736F72537572726F756E64696E674C696E657323602073686F756C6420626520656E666F726365642E22297D29292C637572736F7257696474683A514C286E657720534C2833312C22637572736F725769647468222C302C302C313037333734313832';
wwv_flow_imp.g_varchar2_table(11171) := '342C7B6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320746865207769647468206F662074686520637572736F72207768656E206023656469746F722E637572736F725374796C6523602069732073657420746F2060';
wwv_flow_imp.g_varchar2_table(11172) := '6C696E65602E22297D29292C64697361626C654C6179657248696E74696E673A514C286E657720774C2833322C2264697361626C654C6179657248696E74696E67222C213129292C64697361626C654D6F6E6F73706163654F7074696D697A6174696F6E';
wwv_flow_imp.g_varchar2_table(11173) := '733A514C286E657720774C2833332C2264697361626C654D6F6E6F73706163654F7074696D697A6174696F6E73222C213129292C646F6D526561644F6E6C793A514C286E657720774C2833342C22646F6D526561644F6E6C79222C213129292C64726167';
wwv_flow_imp.g_varchar2_table(11174) := '416E6444726F703A514C286E657720774C2833352C2264726167416E6444726F70222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C6420616C6C6F77206D6F76';
wwv_flow_imp.g_varchar2_table(11175) := '696E672073656C656374696F6E7320766961206472616720616E642064726F702E22297D29292C656D70747953656C656374696F6E436C6970626F6172643A514C286E657720636C61737320657874656E647320774C7B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(11176) := '7B73757065722833372C22656D70747953656C656374696F6E436C6970626F617264222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220636F7079696E6720776974686F757420612073656C656374696F';
wwv_flow_imp.g_varchar2_table(11177) := '6E20636F70696573207468652063757272656E74206C696E652E22297D297D636F6D7075746528652C742C6E297B72657475726E206E2626652E656D70747953656C656374696F6E436C6970626F6172647D7D292C64726F70496E746F456469746F723A';
wwv_flow_imp.g_varchar2_table(11178) := '514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21302C73686F7744726F7053656C6563746F723A22616674657244726F70227D3B73757065722833362C226472';
wwv_flow_imp.g_varchar2_table(11179) := '6F70496E746F456469746F72222C652C7B22656469746F722E64726F70496E746F456469746F722E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6D61726B646F776E446573637269707469';
wwv_flow_imp.g_varchar2_table(11180) := '6F6E3A6228302C22436F6E74726F6C73207768657468657220796F752063616E206472616720616E642064726F7020612066696C6520696E746F2061207465787420656469746F7220627920686F6C64696E6720646F776E207468652060536869667460';
wwv_flow_imp.g_varchar2_table(11181) := '206B65792028696E7374656164206F66206F70656E696E67207468652066696C6520696E20616E20656469746F72292E22297D2C22656469746F722E64726F70496E746F456469746F722E73686F7744726F7053656C6563746F72223A7B747970653A22';
wwv_flow_imp.g_varchar2_table(11182) := '737472696E67222C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C732069662061207769646765742069732073686F776E207768656E2064726F7070696E672066696C657320696E746F2074686520656469746F722E20';
wwv_flow_imp.g_varchar2_table(11183) := '5468697320776964676574206C65747320796F7520636F6E74726F6C20686F77207468652066696C652069732064726F707065642E22292C656E756D3A5B22616674657244726F70222C226E65766572225D2C656E756D4465736372697074696F6E733A';
wwv_flow_imp.g_varchar2_table(11184) := '5B6228302C2253686F77207468652064726F702073656C6563746F722077696467657420616674657220612066696C652069732064726F7070656420696E746F2074686520656469746F722E22292C6228302C224E657665722073686F77207468652064';
wwv_flow_imp.g_varchar2_table(11185) := '726F702073656C6563746F72207769646765742E20496E7374656164207468652064656661756C742064726F702070726F766964657220697320616C7761797320757365642E22295D2C64656661756C743A22616674657244726F70227D7D297D76616C';
wwv_flow_imp.g_varchar2_table(11186) := '69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65642C7468';
wwv_flow_imp.g_varchar2_table(11187) := '69732E64656661756C7456616C75652E656E61626C6564292C73686F7744726F7053656C6563746F723A4C4C28742E73686F7744726F7053656C6563746F722C746869732E64656661756C7456616C75652E73686F7744726F7053656C6563746F722C5B';
wwv_flow_imp.g_varchar2_table(11188) := '22616674657244726F70222C226E65766572225D297D7D7D292C737469636B795363726F6C6C3A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21302C6D6178';
wwv_flow_imp.g_varchar2_table(11189) := '4C696E65436F756E743A352C64656661756C744D6F64656C3A226F75746C696E654D6F64656C222C7363726F6C6C57697468456469746F723A21307D3B7375706572283131352C22737469636B795363726F6C6C222C652C7B22656469746F722E737469';
wwv_flow_imp.g_varchar2_table(11190) := '636B795363726F6C6C2E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6465736372697074696F6E3A6228302C2253686F777320746865206E65737465642063757272656E742073636F7065';
wwv_flow_imp.g_varchar2_table(11191) := '7320647572696E6720746865207363726F6C6C2061742074686520746F70206F662074686520656469746F722E22292C746167733A5B226578706572696D656E74616C225D7D2C22656469746F722E737469636B795363726F6C6C2E6D61784C696E6543';
wwv_flow_imp.g_varchar2_table(11192) := '6F756E74223A7B747970653A226E756D626572222C64656661756C743A652E6D61784C696E65436F756E742C6D696E696D756D3A312C6D6178696D756D3A32302C6465736372697074696F6E3A6228302C22446566696E657320746865206D6178696D75';
wwv_flow_imp.g_varchar2_table(11193) := '6D206E756D626572206F6620737469636B79206C696E657320746F2073686F772E22297D2C22656469746F722E737469636B795363726F6C6C2E64656661756C744D6F64656C223A7B747970653A22737472696E67222C656E756D3A5B226F75746C696E';
wwv_flow_imp.g_varchar2_table(11194) := '654D6F64656C222C22666F6C64696E6750726F76696465724D6F64656C222C22696E64656E746174696F6E4D6F64656C225D2C64656661756C743A652E64656661756C744D6F64656C2C6465736372697074696F6E3A6228302C22446566696E65732074';
wwv_flow_imp.g_varchar2_table(11195) := '6865206D6F64656C20746F2075736520666F722064657465726D696E696E67207768696368206C696E657320746F20737469636B2E20496620746865206F75746C696E65206D6F64656C20646F6573206E6F742065786973742C2069742077696C6C2066';
wwv_flow_imp.g_varchar2_table(11196) := '616C6C206261636B206F6E2074686520666F6C64696E672070726F7669646572206D6F64656C2077686963682066616C6C73206261636B206F6E2074686520696E64656E746174696F6E206D6F64656C2E2054686973206F726465722069732072657370';
wwv_flow_imp.g_varchar2_table(11197) := '656374656420696E20616C6C2074687265652063617365732E22297D2C22656469746F722E737469636B795363726F6C6C2E7363726F6C6C57697468456469746F72223A7B747970653A22626F6F6C65616E222C64656661756C743A652E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(11198) := '57697468456469746F722C6465736372697074696F6E3A6228302C22456E61626C65207363726F6C6C696E67206F6620537469636B79205363726F6C6C20776974682074686520656469746F72277320686F72697A6F6E74616C207363726F6C6C626172';
wwv_flow_imp.g_varchar2_table(11199) := '2E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E';
wwv_flow_imp.g_varchar2_table(11200) := '656E61626C65642C746869732E64656661756C7456616C75652E656E61626C6564292C6D61784C696E65436F756E743A534C2E636C616D706564496E7428742E6D61784C696E65436F756E742C746869732E64656661756C7456616C75652E6D61784C69';
wwv_flow_imp.g_varchar2_table(11201) := '6E65436F756E742C312C3230292C64656661756C744D6F64656C3A4C4C28742E64656661756C744D6F64656C2C746869732E64656661756C7456616C75652E64656661756C744D6F64656C2C5B226F75746C696E654D6F64656C222C22666F6C64696E67';
wwv_flow_imp.g_varchar2_table(11202) := '50726F76696465724D6F64656C222C22696E64656E746174696F6E4D6F64656C225D292C7363726F6C6C57697468456469746F723A794C28742E7363726F6C6C57697468456469746F722C746869732E64656661756C7456616C75652E7363726F6C6C57';
wwv_flow_imp.g_varchar2_table(11203) := '697468456469746F72297D7D7D292C6578706572696D656E74616C5768697465737061636552656E646572696E673A514C286E657720444C2833382C226578706572696D656E74616C5768697465737061636552656E646572696E67222C22737667222C';
wwv_flow_imp.g_varchar2_table(11204) := '5B22737667222C22666F6E74222C226F6666225D2C7B656E756D4465736372697074696F6E733A5B6228302C225573652061206E65772072656E646572696E67206D6574686F64207769746820737667732E22292C6228302C225573652061206E657720';
wwv_flow_imp.g_varchar2_table(11205) := '72656E646572696E67206D6574686F64207769746820666F6E7420636861726163746572732E22292C6228302C225573652074686520737461626C652072656E646572696E67206D6574686F642E22295D2C6465736372697074696F6E3A6228302C2243';
wwv_flow_imp.g_varchar2_table(11206) := '6F6E74726F6C73207768657468657220776869746573706163652069732072656E646572656420776974682061206E65772C206578706572696D656E74616C206D6574686F642E22297D29292C6578747261456469746F72436C6173734E616D653A514C';
wwv_flow_imp.g_varchar2_table(11207) := '286E657720454C2833392C226578747261456469746F72436C6173734E616D65222C222229292C666173745363726F6C6C53656E73697469766974793A514C286E6577206B4C2834302C22666173745363726F6C6C53656E7369746976697479222C352C';
wwv_flow_imp.g_varchar2_table(11208) := '28653D3E653C3D303F353A65292C7B6D61726B646F776E4465736372697074696F6E3A6228302C225363726F6C6C696E67207370656564206D756C7469706C696572207768656E207072657373696E672060416C74602E22297D29292C66696E643A514C';
wwv_flow_imp.g_varchar2_table(11209) := '286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B637572736F724D6F76654F6E547970653A21302C73656564536561726368537472696E6746726F6D53656C656374696F6E3A22616C7761';
wwv_flow_imp.g_varchar2_table(11210) := '7973222C6175746F46696E64496E53656C656374696F6E3A226E65766572222C676C6F62616C46696E64436C6970626F6172643A21312C616464457874726153706163654F6E546F703A21302C6C6F6F703A21307D3B73757065722834312C2266696E64';
wwv_flow_imp.g_varchar2_table(11211) := '222C652C7B22656469746F722E66696E642E637572736F724D6F76654F6E54797065223A7B747970653A22626F6F6C65616E222C64656661756C743A652E637572736F724D6F76654F6E547970652C6465736372697074696F6E3A6228302C22436F6E74';
wwv_flow_imp.g_varchar2_table(11212) := '726F6C7320776865746865722074686520637572736F722073686F756C64206A756D7020746F2066696E64206D617463686573207768696C6520747970696E672E22297D2C22656469746F722E66696E642E73656564536561726368537472696E674672';
wwv_flow_imp.g_varchar2_table(11213) := '6F6D53656C656374696F6E223A7B747970653A22737472696E67222C656E756D3A5B226E65766572222C22616C77617973222C2273656C656374696F6E225D2C64656661756C743A652E73656564536561726368537472696E6746726F6D53656C656374';
wwv_flow_imp.g_varchar2_table(11214) := '696F6E2C656E756D4465736372697074696F6E733A5B6228302C224E6576657220736565642073656172636820737472696E672066726F6D2074686520656469746F722073656C656374696F6E2E22292C6228302C22416C776179732073656564207365';
wwv_flow_imp.g_varchar2_table(11215) := '6172636820737472696E672066726F6D2074686520656469746F722073656C656374696F6E2C20696E636C7564696E6720776F726420617420637572736F7220706F736974696F6E2E22292C6228302C224F6E6C79207365656420736561726368207374';
wwv_flow_imp.g_varchar2_table(11216) := '72696E672066726F6D2074686520656469746F722073656C656374696F6E2E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572207468652073656172636820737472696E6720696E207468652046696E642057';
wwv_flow_imp.g_varchar2_table(11217) := '6964676574206973207365656465642066726F6D2074686520656469746F722073656C656374696F6E2E22297D2C22656469746F722E66696E642E6175746F46696E64496E53656C656374696F6E223A7B747970653A22737472696E67222C656E756D3A';
wwv_flow_imp.g_varchar2_table(11218) := '5B226E65766572222C22616C77617973222C226D756C74696C696E65225D2C64656661756C743A652E6175746F46696E64496E53656C656374696F6E2C656E756D4465736372697074696F6E733A5B6228302C224E65766572207475726E206F6E204669';
wwv_flow_imp.g_varchar2_table(11219) := '6E6420696E2053656C656374696F6E206175746F6D61746963616C6C79202864656661756C74292E22292C6228302C22416C77617973207475726E206F6E2046696E6420696E2053656C656374696F6E206175746F6D61746963616C6C792E22292C6228';
wwv_flow_imp.g_varchar2_table(11220) := '302C225475726E206F6E2046696E6420696E2053656C656374696F6E206175746F6D61746963616C6C79207768656E206D756C7469706C65206C696E6573206F6620636F6E74656E74206172652073656C65637465642E22295D2C646573637269707469';
wwv_flow_imp.g_varchar2_table(11221) := '6F6E3A6228302C22436F6E74726F6C732074686520636F6E646974696F6E20666F72207475726E696E67206F6E2046696E6420696E2053656C656374696F6E206175746F6D61746963616C6C792E22297D2C22656469746F722E66696E642E676C6F6261';
wwv_flow_imp.g_varchar2_table(11222) := '6C46696E64436C6970626F617264223A7B747970653A22626F6F6C65616E222C64656661756C743A652E676C6F62616C46696E64436C6970626F6172642C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520';
wwv_flow_imp.g_varchar2_table(11223) := '46696E64205769646765742073686F756C642072656164206F72206D6F6469667920746865207368617265642066696E6420636C6970626F617264206F6E206D61634F532E22292C696E636C756465643A717D2C22656469746F722E66696E642E616464';
wwv_flow_imp.g_varchar2_table(11224) := '457874726153706163654F6E546F70223A7B747970653A22626F6F6C65616E222C64656661756C743A652E616464457874726153706163654F6E546F702C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520';
wwv_flow_imp.g_varchar2_table(11225) := '46696E64205769646765742073686F756C6420616464206578747261206C696E6573206F6E20746F70206F662074686520656469746F722E205768656E20747275652C20796F752063616E207363726F6C6C206265796F6E642074686520666972737420';
wwv_flow_imp.g_varchar2_table(11226) := '6C696E65207768656E207468652046696E64205769646765742069732076697369626C652E22297D2C22656469746F722E66696E642E6C6F6F70223A7B747970653A22626F6F6C65616E222C64656661756C743A652E6C6F6F702C646573637269707469';
wwv_flow_imp.g_varchar2_table(11227) := '6F6E3A6228302C22436F6E74726F6C7320776865746865722074686520736561726368206175746F6D61746963616C6C792072657374617274732066726F6D2074686520626567696E6E696E6720286F722074686520656E6429207768656E206E6F2066';
wwv_flow_imp.g_varchar2_table(11228) := '757274686572206D6174636865732063616E20626520666F756E642E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E';
wwv_flow_imp.g_varchar2_table(11229) := '737420743D653B72657475726E7B637572736F724D6F76654F6E547970653A794C28742E637572736F724D6F76654F6E547970652C746869732E64656661756C7456616C75652E637572736F724D6F76654F6E54797065292C7365656453656172636853';
wwv_flow_imp.g_varchar2_table(11230) := '7472696E6746726F6D53656C656374696F6E3A22626F6F6C65616E223D3D747970656F6620652E73656564536561726368537472696E6746726F6D53656C656374696F6E3F652E73656564536561726368537472696E6746726F6D53656C656374696F6E';
wwv_flow_imp.g_varchar2_table(11231) := '3F22616C77617973223A226E65766572223A4C4C28742E73656564536561726368537472696E6746726F6D53656C656374696F6E2C746869732E64656661756C7456616C75652E73656564536561726368537472696E6746726F6D53656C656374696F6E';
wwv_flow_imp.g_varchar2_table(11232) := '2C5B226E65766572222C22616C77617973222C2273656C656374696F6E225D292C6175746F46696E64496E53656C656374696F6E3A22626F6F6C65616E223D3D747970656F6620652E6175746F46696E64496E53656C656374696F6E3F652E6175746F46';
wwv_flow_imp.g_varchar2_table(11233) := '696E64496E53656C656374696F6E3F22616C77617973223A226E65766572223A4C4C28742E6175746F46696E64496E53656C656374696F6E2C746869732E64656661756C7456616C75652E6175746F46696E64496E53656C656374696F6E2C5B226E6576';
wwv_flow_imp.g_varchar2_table(11234) := '6572222C22616C77617973222C226D756C74696C696E65225D292C676C6F62616C46696E64436C6970626F6172643A794C28742E676C6F62616C46696E64436C6970626F6172642C746869732E64656661756C7456616C75652E676C6F62616C46696E64';
wwv_flow_imp.g_varchar2_table(11235) := '436C6970626F617264292C616464457874726153706163654F6E546F703A794C28742E616464457874726153706163654F6E546F702C746869732E64656661756C7456616C75652E616464457874726153706163654F6E546F70292C6C6F6F703A794C28';
wwv_flow_imp.g_varchar2_table(11236) := '742E6C6F6F702C746869732E64656661756C7456616C75652E6C6F6F70297D7D7D292C66697865644F766572666C6F77576964676574733A514C286E657720774C2834322C2266697865644F766572666C6F7757696467657473222C213129292C666F6C';
wwv_flow_imp.g_varchar2_table(11237) := '64696E673A514C286E657720774C2834332C22666F6C64696E67222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722068617320636F646520666F6C64696E6720656E61626C65';
wwv_flow_imp.g_varchar2_table(11238) := '642E22297D29292C666F6C64696E6753747261746567793A514C286E657720444C2834342C22666F6C64696E675374726174656779222C226175746F222C5B226175746F222C22696E64656E746174696F6E225D2C7B656E756D4465736372697074696F';
wwv_flow_imp.g_varchar2_table(11239) := '6E733A5B6228302C225573652061206C616E67756167652D737065636966696320666F6C64696E6720737472617465677920696620617661696C61626C652C20656C73652074686520696E64656E746174696F6E2D6261736564206F6E652E22292C6228';
wwv_flow_imp.g_varchar2_table(11240) := '302C225573652074686520696E64656E746174696F6E2D626173656420666F6C64696E672073747261746567792E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520737472617465677920666F7220636F6D70757469';
wwv_flow_imp.g_varchar2_table(11241) := '6E6720666F6C64696E672072616E6765732E22297D29292C666F6C64696E67486967686C696768743A514C286E657720774C2834352C22666F6C64696E67486967686C69676874222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F';
wwv_flow_imp.g_varchar2_table(11242) := '6C7320776865746865722074686520656469746F722073686F756C6420686967686C6967687420666F6C6465642072616E6765732E22297D29292C666F6C64696E67496D706F727473427944656661756C743A514C286E657720774C2834362C22666F6C';
wwv_flow_imp.g_varchar2_table(11243) := '64696E67496D706F727473427944656661756C74222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F72206175746F6D61746963616C6C7920636F6C6C617073657320696D706F72';
wwv_flow_imp.g_varchar2_table(11244) := '742072616E6765732E22297D29292C666F6C64696E674D6178696D756D526567696F6E733A514C286E657720534C2834372C22666F6C64696E674D6178696D756D526567696F6E73222C3565332C31302C363565332C7B6465736372697074696F6E3A62';
wwv_flow_imp.g_varchar2_table(11245) := '28302C22546865206D6178696D756D206E756D626572206F6620666F6C6461626C6520726567696F6E732E20496E6372656173696E6720746869732076616C7565206D617920726573756C7420696E2074686520656469746F72206265636F6D696E6720';
wwv_flow_imp.g_varchar2_table(11246) := '6C65737320726573706F6E73697665207768656E207468652063757272656E7420736F75726365206861732061206C61726765206E756D626572206F6620666F6C6461626C6520726567696F6E732E22297D29292C756E666F6C644F6E436C69636B4166';
wwv_flow_imp.g_varchar2_table(11247) := '746572456E644F664C696E653A514C286E657720774C2834382C22756E666F6C644F6E436C69636B4166746572456E644F664C696E65222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220636C69636B69';
wwv_flow_imp.g_varchar2_table(11248) := '6E67206F6E2074686520656D70747920636F6E74656E74206166746572206120666F6C646564206C696E652077696C6C20756E666F6C6420746865206C696E652E22297D29292C666F6E7446616D696C793A514C286E657720454C2834392C22666F6E74';
wwv_flow_imp.g_varchar2_table(11249) := '46616D696C79222C4B4C2E666F6E7446616D696C792C7B6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E742066616D696C792E22297D29292C666F6E74496E666F3A514C286E657720636C61737320657874656E6473';
wwv_flow_imp.g_varchar2_table(11250) := '20624C7B636F6E7374727563746F7228297B7375706572283530297D636F6D7075746528652C742C6E297B72657475726E20652E666F6E74496E666F7D7D292C666F6E744C6967617475726573323A514C286E657720414C292C666F6E7453697A653A51';
wwv_flow_imp.g_varchar2_table(11251) := '4C286E657720636C61737320657874656E6473205F4C7B636F6E7374727563746F7228297B73757065722835322C22666F6E7453697A65222C4B4C2E666F6E7453697A652C7B747970653A226E756D626572222C6D696E696D756D3A362C6D6178696D75';
wwv_flow_imp.g_varchar2_table(11252) := '6D3A3130302C64656661756C743A4B4C2E666F6E7453697A652C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E742073697A6520696E20706978656C732E22297D297D76616C69646174652865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(11253) := '3D6B4C2E666C6F617428652C746869732E64656661756C7456616C7565293B72657475726E20303D3D3D743F4B4C2E666F6E7453697A653A6B4C2E636C616D7028742C362C313030297D636F6D7075746528652C742C6E297B72657475726E20652E666F';
wwv_flow_imp.g_varchar2_table(11254) := '6E74496E666F2E666F6E7453697A657D7D292C666F6E745765696768743A514C286E657720504C292C666F6E74566172696174696F6E733A514C286E6577204E4C292C666F726D61744F6E50617374653A514C286E657720774C2835352C22666F726D61';
wwv_flow_imp.g_varchar2_table(11255) := '744F6E5061737465222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C64206175746F6D61746963616C6C7920666F726D6174207468652070617374656420636F';
wwv_flow_imp.g_varchar2_table(11256) := '6E74656E742E204120666F726D6174746572206D75737420626520617661696C61626C6520616E642074686520666F726D61747465722073686F756C642062652061626C6520746F20666F726D617420612072616E676520696E206120646F63756D656E';
wwv_flow_imp.g_varchar2_table(11257) := '742E22297D29292C666F726D61744F6E547970653A514C286E657720774C2835362C22666F726D61744F6E54797065222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F72207368';
wwv_flow_imp.g_varchar2_table(11258) := '6F756C64206175746F6D61746963616C6C7920666F726D617420746865206C696E6520616674657220747970696E672E22297D29292C676C7970684D617267696E3A514C286E657720774C2835372C22676C7970684D617267696E222C21302C7B646573';
wwv_flow_imp.g_varchar2_table(11259) := '6372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C642072656E6465722074686520766572746963616C20676C797068206D617267696E2E20476C797068206D617267696E206973206D';
wwv_flow_imp.g_varchar2_table(11260) := '6F73746C79207573656420666F7220646562756767696E672E22297D29292C676F746F4C6F636174696F6E3A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B6D756C7469706C653A';
wwv_flow_imp.g_varchar2_table(11261) := '227065656B222C6D756C7469706C65446566696E6974696F6E733A227065656B222C6D756C7469706C6554797065446566696E6974696F6E733A227065656B222C6D756C7469706C654465636C61726174696F6E733A227065656B222C6D756C7469706C';
wwv_flow_imp.g_varchar2_table(11262) := '65496D706C656D656E746174696F6E733A227065656B222C6D756C7469706C655265666572656E6365733A227065656B222C616C7465726E6174697665446566696E6974696F6E436F6D6D616E643A22656469746F722E616374696F6E2E676F546F5265';
wwv_flow_imp.g_varchar2_table(11263) := '666572656E636573222C616C7465726E617469766554797065446566696E6974696F6E436F6D6D616E643A22656469746F722E616374696F6E2E676F546F5265666572656E636573222C616C7465726E61746976654465636C61726174696F6E436F6D6D';
wwv_flow_imp.g_varchar2_table(11264) := '616E643A22656469746F722E616374696F6E2E676F546F5265666572656E636573222C616C7465726E6174697665496D706C656D656E746174696F6E436F6D6D616E643A22222C616C7465726E61746976655265666572656E6365436F6D6D616E643A22';
wwv_flow_imp.g_varchar2_table(11265) := '227D2C743D7B747970653A22737472696E67222C656E756D3A5B227065656B222C22676F746F416E645065656B222C22676F746F225D2C64656661756C743A652E6D756C7469706C652C656E756D4465736372697074696F6E733A5B6228302C2253686F';
wwv_flow_imp.g_varchar2_table(11266) := '77205065656B2076696577206F662074686520726573756C7473202864656661756C742922292C6228302C22476F20746F20746865207072696D61727920726573756C7420616E642073686F772061205065656B207669657722292C6228302C22476F20';
wwv_flow_imp.g_varchar2_table(11267) := '746F20746865207072696D61727920726573756C7420616E6420656E61626C65205065656B2D6C657373206E617669676174696F6E20746F206F746865727322295D7D2C6E3D5B22222C22656469746F722E616374696F6E2E7265666572656E63655365';
wwv_flow_imp.g_varchar2_table(11268) := '617263682E74726967676572222C22656469746F722E616374696F6E2E676F546F5265666572656E636573222C22656469746F722E616374696F6E2E7065656B496D706C656D656E746174696F6E222C22656469746F722E616374696F6E2E676F546F49';
wwv_flow_imp.g_varchar2_table(11269) := '6D706C656D656E746174696F6E222C22656469746F722E616374696F6E2E7065656B54797065446566696E6974696F6E222C22656469746F722E616374696F6E2E676F546F54797065446566696E6974696F6E222C22656469746F722E616374696F6E2E';
wwv_flow_imp.g_varchar2_table(11270) := '7065656B4465636C61726174696F6E222C22656469746F722E616374696F6E2E72657665616C4465636C61726174696F6E222C22656469746F722E616374696F6E2E7065656B446566696E6974696F6E222C22656469746F722E616374696F6E2E726576';
wwv_flow_imp.g_varchar2_table(11271) := '65616C446566696E6974696F6E4173696465222C22656469746F722E616374696F6E2E72657665616C446566696E6974696F6E225D3B73757065722835382C22676F746F4C6F636174696F6E222C652C7B22656469746F722E676F746F4C6F636174696F';
wwv_flow_imp.g_varchar2_table(11272) := '6E2E6D756C7469706C65223A7B6465707265636174696F6E4D6573736167653A6228302C22546869732073657474696E6720697320646570726563617465642C20706C65617365207573652073657061726174652073657474696E6773206C696B652027';
wwv_flow_imp.g_varchar2_table(11273) := '656469746F722E656469746F722E676F746F4C6F636174696F6E2E6D756C7469706C65446566696E6974696F6E7327206F722027656469746F722E656469746F722E676F746F4C6F636174696F6E2E6D756C7469706C65496D706C656D656E746174696F';
wwv_flow_imp.g_varchar2_table(11274) := '6E732720696E73746561642E22297D2C22656469746F722E676F746F4C6F636174696F6E2E6D756C7469706C65446566696E6974696F6E73223A7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206265686176696F72207468';
wwv_flow_imp.g_varchar2_table(11275) := '652027476F20746F20446566696E6974696F6E272D636F6D6D616E64207768656E206D756C7469706C6520746172676574206C6F636174696F6E732065786973742E22292C2E2E2E747D2C22656469746F722E676F746F4C6F636174696F6E2E6D756C74';
wwv_flow_imp.g_varchar2_table(11276) := '69706C6554797065446566696E6974696F6E73223A7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206265686176696F72207468652027476F20746F205479706520446566696E6974696F6E272D636F6D6D616E6420776865';
wwv_flow_imp.g_varchar2_table(11277) := '6E206D756C7469706C6520746172676574206C6F636174696F6E732065786973742E22292C2E2E2E747D2C22656469746F722E676F746F4C6F636174696F6E2E6D756C7469706C654465636C61726174696F6E73223A7B6465736372697074696F6E3A62';
wwv_flow_imp.g_varchar2_table(11278) := '28302C22436F6E74726F6C7320746865206265686176696F72207468652027476F20746F204465636C61726174696F6E272D636F6D6D616E64207768656E206D756C7469706C6520746172676574206C6F636174696F6E732065786973742E22292C2E2E';
wwv_flow_imp.g_varchar2_table(11279) := '2E747D2C22656469746F722E676F746F4C6F636174696F6E2E6D756C7469706C65496D706C656D656E746174696F6E73223A7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206265686176696F72207468652027476F20746F';
wwv_flow_imp.g_varchar2_table(11280) := '20496D706C656D656E746174696F6E73272D636F6D6D616E64207768656E206D756C7469706C6520746172676574206C6F636174696F6E732065786973742E22292C2E2E2E747D2C22656469746F722E676F746F4C6F636174696F6E2E6D756C7469706C';
wwv_flow_imp.g_varchar2_table(11281) := '655265666572656E636573223A7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206265686176696F72207468652027476F20746F205265666572656E636573272D636F6D6D616E64207768656E206D756C7469706C65207461';
wwv_flow_imp.g_varchar2_table(11282) := '72676574206C6F636174696F6E732065786973742E22292C2E2E2E747D2C22656469746F722E676F746F4C6F636174696F6E2E616C7465726E6174697665446566696E6974696F6E436F6D6D616E64223A7B747970653A22737472696E67222C64656661';
wwv_flow_imp.g_varchar2_table(11283) := '756C743A652E616C7465726E6174697665446566696E6974696F6E436F6D6D616E642C656E756D3A6E2C6465736372697074696F6E3A6228302C22416C7465726E617469766520636F6D6D616E642069642074686174206973206265696E672065786563';
wwv_flow_imp.g_varchar2_table(11284) := '75746564207768656E2074686520726573756C74206F662027476F20746F20446566696E6974696F6E27206973207468652063757272656E74206C6F636174696F6E2E22297D2C22656469746F722E676F746F4C6F636174696F6E2E616C7465726E6174';
wwv_flow_imp.g_varchar2_table(11285) := '69766554797065446566696E6974696F6E436F6D6D616E64223A7B747970653A22737472696E67222C64656661756C743A652E616C7465726E617469766554797065446566696E6974696F6E436F6D6D616E642C656E756D3A6E2C646573637269707469';
wwv_flow_imp.g_varchar2_table(11286) := '6F6E3A6228302C22416C7465726E617469766520636F6D6D616E642069642074686174206973206265696E67206578656375746564207768656E2074686520726573756C74206F662027476F20746F205479706520446566696E6974696F6E2720697320';
wwv_flow_imp.g_varchar2_table(11287) := '7468652063757272656E74206C6F636174696F6E2E22297D2C22656469746F722E676F746F4C6F636174696F6E2E616C7465726E61746976654465636C61726174696F6E436F6D6D616E64223A7B747970653A22737472696E67222C64656661756C743A';
wwv_flow_imp.g_varchar2_table(11288) := '652E616C7465726E61746976654465636C61726174696F6E436F6D6D616E642C656E756D3A6E2C6465736372697074696F6E3A6228302C22416C7465726E617469766520636F6D6D616E642069642074686174206973206265696E672065786563757465';
wwv_flow_imp.g_varchar2_table(11289) := '64207768656E2074686520726573756C74206F662027476F20746F204465636C61726174696F6E27206973207468652063757272656E74206C6F636174696F6E2E22297D2C22656469746F722E676F746F4C6F636174696F6E2E616C7465726E61746976';
wwv_flow_imp.g_varchar2_table(11290) := '65496D706C656D656E746174696F6E436F6D6D616E64223A7B747970653A22737472696E67222C64656661756C743A652E616C7465726E6174697665496D706C656D656E746174696F6E436F6D6D616E642C656E756D3A6E2C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(11291) := '3A6228302C22416C7465726E617469766520636F6D6D616E642069642074686174206973206265696E67206578656375746564207768656E2074686520726573756C74206F662027476F20746F20496D706C656D656E746174696F6E2720697320746865';
wwv_flow_imp.g_varchar2_table(11292) := '2063757272656E74206C6F636174696F6E2E22297D2C22656469746F722E676F746F4C6F636174696F6E2E616C7465726E61746976655265666572656E6365436F6D6D616E64223A7B747970653A22737472696E67222C64656661756C743A652E616C74';
wwv_flow_imp.g_varchar2_table(11293) := '65726E61746976655265666572656E6365436F6D6D616E642C656E756D3A6E2C6465736372697074696F6E3A6228302C22416C7465726E617469766520636F6D6D616E642069642074686174206973206265696E67206578656375746564207768656E20';
wwv_flow_imp.g_varchar2_table(11294) := '74686520726573756C74206F662027476F20746F205265666572656E636527206973207468652063757272656E74206C6F636174696F6E2E22297D7D297D76616C69646174652865297B76617220742C6E2C692C6F2C733B69662821657C7C226F626A65';
wwv_flow_imp.g_varchar2_table(11295) := '637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420723D653B72657475726E7B6D756C7469706C653A4C4C28722E6D756C7469706C652C746869732E64656661756C7456616C75652E6D756C';
wwv_flow_imp.g_varchar2_table(11296) := '7469706C652C5B227065656B222C22676F746F416E645065656B222C22676F746F225D292C6D756C7469706C65446566696E6974696F6E733A6E756C6C213D3D28743D722E6D756C7469706C65446566696E6974696F6E73292626766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(11297) := '743F743A4C4C28722E6D756C7469706C65446566696E6974696F6E732C227065656B222C5B227065656B222C22676F746F416E645065656B222C22676F746F225D292C6D756C7469706C6554797065446566696E6974696F6E733A6E756C6C213D3D286E';
wwv_flow_imp.g_varchar2_table(11298) := '3D722E6D756C7469706C6554797065446566696E6974696F6E73292626766F69642030213D3D6E3F6E3A4C4C28722E6D756C7469706C6554797065446566696E6974696F6E732C227065656B222C5B227065656B222C22676F746F416E645065656B222C';
wwv_flow_imp.g_varchar2_table(11299) := '22676F746F225D292C6D756C7469706C654465636C61726174696F6E733A6E756C6C213D3D28693D722E6D756C7469706C654465636C61726174696F6E73292626766F69642030213D3D693F693A4C4C28722E6D756C7469706C654465636C6172617469';
wwv_flow_imp.g_varchar2_table(11300) := '6F6E732C227065656B222C5B227065656B222C22676F746F416E645065656B222C22676F746F225D292C6D756C7469706C65496D706C656D656E746174696F6E733A6E756C6C213D3D286F3D722E6D756C7469706C65496D706C656D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(11301) := '73292626766F69642030213D3D6F3F6F3A4C4C28722E6D756C7469706C65496D706C656D656E746174696F6E732C227065656B222C5B227065656B222C22676F746F416E645065656B222C22676F746F225D292C6D756C7469706C655265666572656E63';
wwv_flow_imp.g_varchar2_table(11302) := '65733A6E756C6C213D3D28733D722E6D756C7469706C655265666572656E636573292626766F69642030213D3D733F733A4C4C28722E6D756C7469706C655265666572656E6365732C227065656B222C5B227065656B222C22676F746F416E645065656B';
wwv_flow_imp.g_varchar2_table(11303) := '222C22676F746F225D292C616C7465726E6174697665446566696E6974696F6E436F6D6D616E643A454C2E737472696E6728722E616C7465726E6174697665446566696E6974696F6E436F6D6D616E642C746869732E64656661756C7456616C75652E61';
wwv_flow_imp.g_varchar2_table(11304) := '6C7465726E6174697665446566696E6974696F6E436F6D6D616E64292C616C7465726E617469766554797065446566696E6974696F6E436F6D6D616E643A454C2E737472696E6728722E616C7465726E617469766554797065446566696E6974696F6E43';
wwv_flow_imp.g_varchar2_table(11305) := '6F6D6D616E642C746869732E64656661756C7456616C75652E616C7465726E617469766554797065446566696E6974696F6E436F6D6D616E64292C616C7465726E61746976654465636C61726174696F6E436F6D6D616E643A454C2E737472696E672872';
wwv_flow_imp.g_varchar2_table(11306) := '2E616C7465726E61746976654465636C61726174696F6E436F6D6D616E642C746869732E64656661756C7456616C75652E616C7465726E61746976654465636C61726174696F6E436F6D6D616E64292C616C7465726E6174697665496D706C656D656E74';
wwv_flow_imp.g_varchar2_table(11307) := '6174696F6E436F6D6D616E643A454C2E737472696E6728722E616C7465726E6174697665496D706C656D656E746174696F6E436F6D6D616E642C746869732E64656661756C7456616C75652E616C7465726E6174697665496D706C656D656E746174696F';
wwv_flow_imp.g_varchar2_table(11308) := '6E436F6D6D616E64292C616C7465726E61746976655265666572656E6365436F6D6D616E643A454C2E737472696E6728722E616C7465726E61746976655265666572656E6365436F6D6D616E642C746869732E64656661756C7456616C75652E616C7465';
wwv_flow_imp.g_varchar2_table(11309) := '726E61746976655265666572656E6365436F6D6D616E64297D7D7D292C68696465437572736F72496E4F7665727669657752756C65723A514C286E657720774C2835392C2268696465437572736F72496E4F7665727669657752756C6572222C21312C7B';
wwv_flow_imp.g_varchar2_table(11310) := '6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520637572736F722073686F756C642062652068696464656E20696E20746865206F766572766965772072756C65722E22297D29292C686F7665723A514C286E';
wwv_flow_imp.g_varchar2_table(11311) := '657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21302C64656C61793A3330302C686964696E6744656C61793A3330302C737469636B793A21302C61626F76653A21307D3B';
wwv_flow_imp.g_varchar2_table(11312) := '73757065722836302C22686F766572222C652C7B22656469746F722E686F7665722E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6465736372697074696F6E3A6228302C22436F6E74726F';
wwv_flow_imp.g_varchar2_table(11313) := '6C7320776865746865722074686520686F7665722069732073686F776E2E22297D2C22656469746F722E686F7665722E64656C6179223A7B747970653A226E756D626572222C64656661756C743A652E64656C61792C6D696E696D756D3A302C6D617869';
wwv_flow_imp.g_varchar2_table(11314) := '6D756D3A3165342C6465736372697074696F6E3A6228302C22436F6E74726F6C73207468652064656C617920696E206D696C6C697365636F6E64732061667465722077686963682074686520686F7665722069732073686F776E2E22297D2C2265646974';
wwv_flow_imp.g_varchar2_table(11315) := '6F722E686F7665722E737469636B79223A7B747970653A22626F6F6C65616E222C64656661756C743A652E737469636B792C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520686F7665722073686F756C64';
wwv_flow_imp.g_varchar2_table(11316) := '2072656D61696E2076697369626C65207768656E206D6F757365206973206D6F766564206F7665722069742E22297D2C22656469746F722E686F7665722E686964696E6744656C6179223A7B747970653A22696E7465676572222C6D696E696D756D3A30';
wwv_flow_imp.g_varchar2_table(11317) := '2C64656661756C743A652E686964696E6744656C61792C6465736372697074696F6E3A6228302C22436F6E74726F6C73207468652064656C617920696E206D696C6C697365636F6E64732061667465722077686963682074686520686F76657220697320';
wwv_flow_imp.g_varchar2_table(11318) := '68696464656E2E2052657175697265732060656469746F722E686F7665722E737469636B796020746F20626520656E61626C65642E22297D2C22656469746F722E686F7665722E61626F7665223A7B747970653A22626F6F6C65616E222C64656661756C';
wwv_flow_imp.g_varchar2_table(11319) := '743A652E61626F76652C6465736372697074696F6E3A6228302C225072656665722073686F77696E6720686F766572732061626F766520746865206C696E652C20696620746865726527732073706163652E22297D7D297D76616C69646174652865297B';
wwv_flow_imp.g_varchar2_table(11320) := '69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65642C746869732E64656661756C';
wwv_flow_imp.g_varchar2_table(11321) := '7456616C75652E656E61626C6564292C64656C61793A534C2E636C616D706564496E7428742E64656C61792C746869732E64656661756C7456616C75652E64656C61792C302C316534292C737469636B793A794C28742E737469636B792C746869732E64';
wwv_flow_imp.g_varchar2_table(11322) := '656661756C7456616C75652E737469636B79292C686964696E6744656C61793A534C2E636C616D706564496E7428742E686964696E6744656C61792C746869732E64656661756C7456616C75652E686964696E6744656C61792C302C366535292C61626F';
wwv_flow_imp.g_varchar2_table(11323) := '76653A794C28742E61626F76652C746869732E64656661756C7456616C75652E61626F7665297D7D7D292C696E44696666456469746F723A514C286E657720774C2836312C22696E44696666456469746F72222C213129292C6C65747465725370616369';
wwv_flow_imp.g_varchar2_table(11324) := '6E673A514C286E6577206B4C2836342C226C657474657253706163696E67222C4B4C2E6C657474657253706163696E672C28653D3E6B4C2E636C616D7028652C2D352C323029292C7B6465736372697074696F6E3A6228302C22436F6E74726F6C732074';
wwv_flow_imp.g_varchar2_table(11325) := '6865206C65747465722073706163696E6720696E20706978656C732E22297D29292C6C6967687462756C623A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A4D';
wwv_flow_imp.g_varchar2_table(11326) := '4C2E4F6E7D3B73757065722836352C226C6967687462756C62222C652C7B22656469746F722E6C6967687462756C622E656E61626C6564223A7B747970653A22737472696E67222C746167733A5B226578706572696D656E74616C225D2C656E756D3A5B';
wwv_flow_imp.g_varchar2_table(11327) := '4D4C2E4F66662C4D4C2E4F6E436F64652C4D4C2E4F6E5D2C64656661756C743A652E656E61626C65642C656E756D4465736372697074696F6E733A5B6228302C2244697361626C652074686520636F646520616374696F6E206D656E752E22292C622830';
wwv_flow_imp.g_varchar2_table(11328) := '2C2253686F772074686520636F646520616374696F6E206D656E75207768656E2074686520637572736F72206973206F6E206C696E6573207769746820636F64652E22292C6228302C2253686F772074686520636F646520616374696F6E206D656E7520';
wwv_flow_imp.g_varchar2_table(11329) := '7768656E2074686520637572736F72206973206F6E206C696E6573207769746820636F6465206F72206F6E20656D707479206C696E65732E22295D2C6465736372697074696F6E3A6228302C22456E61626C65732074686520436F646520416374696F6E';
wwv_flow_imp.g_varchar2_table(11330) := '206C6967687462756C6220696E2074686520656469746F722E22297D7D297D76616C69646174652865297B72657475726E20652626226F626A656374223D3D747970656F6620653F7B656E61626C65643A4C4C28652E656E61626C65642C746869732E64';
wwv_flow_imp.g_varchar2_table(11331) := '656661756C7456616C75652E656E61626C65642C5B4D4C2E4F66662C4D4C2E4F6E436F64652C4D4C2E4F6E5D297D3A746869732E64656661756C7456616C75657D7D292C6C696E654465636F726174696F6E7357696474683A514C286E657720636C6173';
wwv_flow_imp.g_varchar2_table(11332) := '7320657874656E6473206D4C7B636F6E7374727563746F7228297B73757065722836362C226C696E654465636F726174696F6E735769647468222C3130297D76616C69646174652865297B72657475726E22737472696E67223D3D747970656F66206526';
wwv_flow_imp.g_varchar2_table(11333) := '262F5E5C642B285C2E5C642B293F6368242F2E746573742865293F2D7061727365466C6F617428652E737562737472696E6728302C652E6C656E6774682D3229293A534C2E636C616D706564496E7428652C746869732E64656661756C7456616C75652C';
wwv_flow_imp.g_varchar2_table(11334) := '302C316533297D636F6D7075746528652C742C6E297B72657475726E206E3C303F534C2E636C616D706564496E74282D6E2A652E666F6E74496E666F2E7479706963616C48616C66776964746843686172616374657257696474682C746869732E646566';
wwv_flow_imp.g_varchar2_table(11335) := '61756C7456616C75652C302C316533293A6E7D7D292C6C696E654865696768743A514C286E657720636C61737320657874656E6473206B4C7B636F6E7374727563746F7228297B73757065722836372C226C696E65486569676874222C4B4C2E6C696E65';
wwv_flow_imp.g_varchar2_table(11336) := '4865696768742C28653D3E6B4C2E636C616D7028652C302C31353029292C7B6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206C696E65206865696768742E205C6E202D20557365203020746F206175746F';
wwv_flow_imp.g_varchar2_table(11337) := '6D61746963616C6C7920636F6D7075746520746865206C696E65206865696768742066726F6D2074686520666F6E742073697A652E5C6E202D2056616C756573206265747765656E203020616E6420382077696C6C20626520757365642061732061206D';
wwv_flow_imp.g_varchar2_table(11338) := '756C7469706C69657220776974682074686520666F6E742073697A652E5C6E202D2056616C7565732067726561746572207468616E206F7220657175616C20746F20382077696C6C2062652075736564206173206566666563746976652076616C756573';
wwv_flow_imp.g_varchar2_table(11339) := '2E22297D297D636F6D7075746528652C742C6E297B72657475726E20652E666F6E74496E666F2E6C696E654865696768747D7D292C6C696E654E756D626572733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(11340) := '28297B73757065722836382C226C696E654E756D62657273222C7B72656E646572547970653A312C72656E646572466E3A6E756C6C7D2C7B747970653A22737472696E67222C656E756D3A5B226F6666222C226F6E222C2272656C6174697665222C2269';
wwv_flow_imp.g_varchar2_table(11341) := '6E74657276616C225D2C656E756D4465736372697074696F6E733A5B6228302C224C696E65206E756D6265727320617265206E6F742072656E64657265642E22292C6228302C224C696E65206E756D62657273206172652072656E646572656420617320';
wwv_flow_imp.g_varchar2_table(11342) := '6162736F6C757465206E756D6265722E22292C6228302C224C696E65206E756D62657273206172652072656E64657265642061732064697374616E636520696E206C696E657320746F20637572736F7220706F736974696F6E2E22292C6228302C224C69';
wwv_flow_imp.g_varchar2_table(11343) := '6E65206E756D62657273206172652072656E6465726564206576657279203130206C696E65732E22295D2C64656661756C743A226F6E222C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520646973706C6179206F66206C696E';
wwv_flow_imp.g_varchar2_table(11344) := '65206E756D626572732E22297D297D76616C69646174652865297B6C657420743D746869732E64656661756C7456616C75652E72656E646572547970652C6E3D746869732E64656661756C7456616C75652E72656E646572466E3B72657475726E20766F';
wwv_flow_imp.g_varchar2_table(11345) := '69642030213D3D652626282266756E6374696F6E223D3D747970656F6620653F28743D342C6E3D65293A743D22696E74657276616C223D3D3D653F333A2272656C6174697665223D3D3D653F323A226F6E223D3D3D653F313A30292C7B72656E64657254';
wwv_flow_imp.g_varchar2_table(11346) := '7970653A742C72656E646572466E3A6E7D7D7D292C6C696E654E756D626572734D696E43686172733A514C286E657720534C2836392C226C696E654E756D626572734D696E4368617273222C352C312C33303029292C6C696E6B656445646974696E673A';
wwv_flow_imp.g_varchar2_table(11347) := '514C286E657720774C2837302C226C696E6B656445646974696E67222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F7220686173206C696E6B65642065646974696E6720656E61';
wwv_flow_imp.g_varchar2_table(11348) := '626C65642E20446570656E64696E67206F6E20746865206C616E67756167652C2072656C617465642073796D626F6C7320737563682061732048544D4C20746167732C206172652075706461746564207768696C652065646974696E672E22297D29292C';
wwv_flow_imp.g_varchar2_table(11349) := '6C696E6B733A514C286E657720774C2837312C226C696E6B73222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C6420646574656374206C696E6B7320616E6420';
wwv_flow_imp.g_varchar2_table(11350) := '6D616B65207468656D20636C69636B61626C652E22297D29292C6D61746368427261636B6574733A514C286E657720444C2837322C226D61746368427261636B657473222C22616C77617973222C5B22616C77617973222C226E656172222C226E657665';
wwv_flow_imp.g_varchar2_table(11351) := '72225D2C7B6465736372697074696F6E3A6228302C22486967686C69676874206D61746368696E6720627261636B6574732E22297D29292C6D696E696D61703A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(11352) := '297B636F6E737420653D7B656E61626C65643A21302C73697A653A2270726F706F7274696F6E616C222C736964653A227269676874222C73686F77536C696465723A226D6F7573656F766572222C6175746F686964653A21312C72656E64657243686172';
wwv_flow_imp.g_varchar2_table(11353) := '6163746572733A21302C6D6178436F6C756D6E3A3132302C7363616C653A312C73686F77526567696F6E53656374696F6E486561646572733A21302C73686F774D61726B53656374696F6E486561646572733A21302C73656374696F6E48656164657246';
wwv_flow_imp.g_varchar2_table(11354) := '6F6E7453697A653A397D3B73757065722837332C226D696E696D6170222C652C7B22656469746F722E6D696E696D61702E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6465736372697074';
wwv_flow_imp.g_varchar2_table(11355) := '696F6E3A6228302C22436F6E74726F6C73207768657468657220746865206D696E696D61702069732073686F776E2E22297D2C22656469746F722E6D696E696D61702E6175746F68696465223A7B747970653A22626F6F6C65616E222C64656661756C74';
wwv_flow_imp.g_varchar2_table(11356) := '3A652E6175746F686964652C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746865206D696E696D61702069732068696464656E206175746F6D61746963616C6C792E22297D2C22656469746F722E6D696E696D61';
wwv_flow_imp.g_varchar2_table(11357) := '702E73697A65223A7B747970653A22737472696E67222C656E756D3A5B2270726F706F7274696F6E616C222C2266696C6C222C22666974225D2C656E756D4465736372697074696F6E733A5B6228302C22546865206D696E696D61702068617320746865';
wwv_flow_imp.g_varchar2_table(11358) := '2073616D652073697A652061732074686520656469746F7220636F6E74656E74732028616E64206D69676874207363726F6C6C292E22292C6228302C22546865206D696E696D61702077696C6C2073747265746368206F7220736872696E6B206173206E';
wwv_flow_imp.g_varchar2_table(11359) := '656365737361727920746F2066696C6C2074686520686569676874206F662074686520656469746F7220286E6F207363726F6C6C696E67292E22292C6228302C22546865206D696E696D61702077696C6C20736872696E6B206173206E65636573736172';
wwv_flow_imp.g_varchar2_table(11360) := '7920746F206E65766572206265206C6172676572207468616E2074686520656469746F7220286E6F207363726F6C6C696E67292E22295D2C64656661756C743A652E73697A652C6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865';
wwv_flow_imp.g_varchar2_table(11361) := '2073697A65206F6620746865206D696E696D61702E22297D2C22656469746F722E6D696E696D61702E73696465223A7B747970653A22737472696E67222C656E756D3A5B226C656674222C227269676874225D2C64656661756C743A652E736964652C64';
wwv_flow_imp.g_varchar2_table(11362) := '65736372697074696F6E3A6228302C22436F6E74726F6C7320746865207369646520776865726520746F2072656E64657220746865206D696E696D61702E22297D2C22656469746F722E6D696E696D61702E73686F77536C69646572223A7B747970653A';
wwv_flow_imp.g_varchar2_table(11363) := '22737472696E67222C656E756D3A5B22616C77617973222C226D6F7573656F766572225D2C64656661756C743A652E73686F77536C696465722C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768656E20746865206D696E696D6170';
wwv_flow_imp.g_varchar2_table(11364) := '20736C696465722069732073686F776E2E22297D2C22656469746F722E6D696E696D61702E7363616C65223A7B747970653A226E756D626572222C64656661756C743A652E7363616C652C6D696E696D756D3A312C6D6178696D756D3A332C656E756D3A';
wwv_flow_imp.g_varchar2_table(11365) := '5B312C322C335D2C6465736372697074696F6E3A6228302C225363616C65206F6620636F6E74656E7420647261776E20696E20746865206D696E696D61703A20312C2032206F7220332E22297D2C22656469746F722E6D696E696D61702E72656E646572';
wwv_flow_imp.g_varchar2_table(11366) := '43686172616374657273223A7B747970653A22626F6F6C65616E222C64656661756C743A652E72656E646572436861726163746572732C6465736372697074696F6E3A6228302C2252656E646572207468652061637475616C2063686172616374657273';
wwv_flow_imp.g_varchar2_table(11367) := '206F6E2061206C696E65206173206F70706F73656420746F20636F6C6F7220626C6F636B732E22297D2C22656469746F722E6D696E696D61702E6D6178436F6C756D6E223A7B747970653A226E756D626572222C64656661756C743A652E6D6178436F6C';
wwv_flow_imp.g_varchar2_table(11368) := '756D6E2C6465736372697074696F6E3A6228302C224C696D697420746865207769647468206F6620746865206D696E696D617020746F2072656E646572206174206D6F73742061206365727461696E206E756D626572206F6620636F6C756D6E732E2229';
wwv_flow_imp.g_varchar2_table(11369) := '7D2C22656469746F722E6D696E696D61702E73686F77526567696F6E53656374696F6E48656164657273223A7B747970653A22626F6F6C65616E222C64656661756C743A652E73686F77526567696F6E53656374696F6E486561646572732C6465736372';
wwv_flow_imp.g_varchar2_table(11370) := '697074696F6E3A6228302C22436F6E74726F6C732077686574686572206E616D656420726567696F6E73206172652073686F776E2061732073656374696F6E206865616465727320696E20746865206D696E696D61702E22297D2C22656469746F722E6D';
wwv_flow_imp.g_varchar2_table(11371) := '696E696D61702E73686F774D61726B53656374696F6E48656164657273223A7B747970653A22626F6F6C65616E222C64656661756C743A652E73686F774D61726B53656374696F6E486561646572732C6465736372697074696F6E3A6228302C22436F6E';
wwv_flow_imp.g_varchar2_table(11372) := '74726F6C732077686574686572204D41524B3A20636F6D6D656E7473206172652073686F776E2061732073656374696F6E206865616465727320696E20746865206D696E696D61702E22297D2C22656469746F722E6D696E696D61702E73656374696F6E';
wwv_flow_imp.g_varchar2_table(11373) := '486561646572466F6E7453697A65223A7B747970653A226E756D626572222C64656661756C743A652E73656374696F6E486561646572466F6E7453697A652C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E74207369';
wwv_flow_imp.g_varchar2_table(11374) := '7A65206F662073656374696F6E206865616465727320696E20746865206D696E696D61702E22297D7D297D76616C69646174652865297B76617220743B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64';
wwv_flow_imp.g_varchar2_table(11375) := '656661756C7456616C75653B636F6E7374206E3D653B72657475726E7B656E61626C65643A794C286E2E656E61626C65642C746869732E64656661756C7456616C75652E656E61626C6564292C6175746F686964653A794C286E2E6175746F686964652C';
wwv_flow_imp.g_varchar2_table(11376) := '746869732E64656661756C7456616C75652E6175746F68696465292C73697A653A4C4C286E2E73697A652C746869732E64656661756C7456616C75652E73697A652C5B2270726F706F7274696F6E616C222C2266696C6C222C22666974225D292C736964';
wwv_flow_imp.g_varchar2_table(11377) := '653A4C4C286E2E736964652C746869732E64656661756C7456616C75652E736964652C5B227269676874222C226C656674225D292C73686F77536C696465723A4C4C286E2E73686F77536C696465722C746869732E64656661756C7456616C75652E7368';
wwv_flow_imp.g_varchar2_table(11378) := '6F77536C696465722C5B22616C77617973222C226D6F7573656F766572225D292C72656E646572436861726163746572733A794C286E2E72656E646572436861726163746572732C746869732E64656661756C7456616C75652E72656E64657243686172';
wwv_flow_imp.g_varchar2_table(11379) := '616374657273292C7363616C653A534C2E636C616D706564496E74286E2E7363616C652C312C312C33292C6D6178436F6C756D6E3A534C2E636C616D706564496E74286E2E6D6178436F6C756D6E2C746869732E64656661756C7456616C75652E6D6178';
wwv_flow_imp.g_varchar2_table(11380) := '436F6C756D6E2C312C316534292C73686F77526567696F6E53656374696F6E486561646572733A794C286E2E73686F77526567696F6E53656374696F6E486561646572732C746869732E64656661756C7456616C75652E73686F77526567696F6E536563';
wwv_flow_imp.g_varchar2_table(11381) := '74696F6E48656164657273292C73686F774D61726B53656374696F6E486561646572733A794C286E2E73686F774D61726B53656374696F6E486561646572732C746869732E64656661756C7456616C75652E73686F774D61726B53656374696F6E486561';
wwv_flow_imp.g_varchar2_table(11382) := '64657273292C73656374696F6E486561646572466F6E7453697A653A6B4C2E636C616D70286E756C6C213D3D28743D6E2E73656374696F6E486561646572466F6E7453697A65292626766F69642030213D3D743F743A746869732E64656661756C745661';
wwv_flow_imp.g_varchar2_table(11383) := '6C75652E73656374696F6E486561646572466F6E7453697A652C342C3332297D7D7D292C6D6F7573655374796C653A514C286E657720444C2837342C226D6F7573655374796C65222C2274657874222C5B2274657874222C2264656661756C74222C2263';
wwv_flow_imp.g_varchar2_table(11384) := '6F7079225D29292C6D6F757365576865656C5363726F6C6C53656E73697469766974793A514C286E6577206B4C2837352C226D6F757365576865656C5363726F6C6C53656E7369746976697479222C312C28653D3E303D3D3D653F313A65292C7B6D6172';
wwv_flow_imp.g_varchar2_table(11385) := '6B646F776E4465736372697074696F6E3A6228302C2241206D756C7469706C69657220746F2062652075736564206F6E20746865206064656C7461586020616E64206064656C74615960206F66206D6F75736520776865656C207363726F6C6C20657665';
wwv_flow_imp.g_varchar2_table(11386) := '6E74732E22297D29292C6D6F757365576865656C5A6F6F6D3A514C286E657720774C2837362C226D6F757365576865656C5A6F6F6D222C21312C7B6D61726B646F776E4465736372697074696F6E3A6228302C713F225A6F6F6D2074686520666F6E7420';
wwv_flow_imp.g_varchar2_table(11387) := '6F662074686520656469746F72207768656E207573696E67206D6F75736520776865656C20616E6420686F6C64696E672060436D64602E223A225A6F6F6D2074686520666F6E74206F662074686520656469746F72207768656E207573696E67206D6F75';
wwv_flow_imp.g_varchar2_table(11388) := '736520776865656C20616E6420686F6C64696E6720604374726C602E22297D29292C6D756C7469437572736F724D657267654F7665726C617070696E673A514C286E657720774C2837372C226D756C7469437572736F724D657267654F7665726C617070';
wwv_flow_imp.g_varchar2_table(11389) := '696E67222C21302C7B6465736372697074696F6E3A6228302C224D65726765206D756C7469706C6520637572736F7273207768656E207468657920617265206F7665726C617070696E672E22297D29292C6D756C7469437572736F724D6F646966696572';
wwv_flow_imp.g_varchar2_table(11390) := '3A514C286E657720544C2837382C226D756C7469437572736F724D6F646966696572222C22616C744B6579222C22616C74222C5B226374726C436D64222C22616C74225D2C2866756E6374696F6E2865297B72657475726E226374726C436D64223D3D3D';
wwv_flow_imp.g_varchar2_table(11391) := '653F713F226D6574614B6579223A226374726C4B6579223A22616C744B6579227D292C7B6D61726B646F776E456E756D4465736372697074696F6E733A5B6228302C224D61707320746F2060436F6E74726F6C60206F6E2057696E646F777320616E6420';
wwv_flow_imp.g_varchar2_table(11392) := '4C696E757820616E6420746F2060436F6D6D616E6460206F6E206D61634F532E22292C6228302C224D61707320746F2060416C7460206F6E2057696E646F777320616E64204C696E757820616E6420746F20604F7074696F6E60206F6E206D61634F532E';
wwv_flow_imp.g_varchar2_table(11393) := '22295D2C6D61726B646F776E4465736372697074696F6E3A6228302C22546865206D6F64696669657220746F206265207573656420746F20616464206D756C7469706C6520637572736F7273207769746820746865206D6F7573652E2054686520476F20';
wwv_flow_imp.g_varchar2_table(11394) := '746F20446566696E6974696F6E20616E64204F70656E204C696E6B206D6F7573652067657374757265732077696C6C20616461707420737563682074686174207468657920646F206E6F7420636F6E666C696374207769746820746865205B6D756C7469';
wwv_flow_imp.g_varchar2_table(11395) := '637572736F72206D6F6469666965725D2868747470733A2F2F636F64652E76697375616C73747564696F2E636F6D2F646F63732F656469746F722F636F6465626173696373235F6D756C7469637572736F722D6D6F646966696572292E22297D29292C6D';
wwv_flow_imp.g_varchar2_table(11396) := '756C7469437572736F7250617374653A514C286E657720444C2837392C226D756C7469437572736F725061737465222C22737072656164222C5B22737072656164222C2266756C6C225D2C7B6D61726B646F776E456E756D4465736372697074696F6E73';
wwv_flow_imp.g_varchar2_table(11397) := '3A5B6228302C224561636820637572736F722070617374657320612073696E676C65206C696E65206F662074686520746578742E22292C6228302C224561636820637572736F7220706173746573207468652066756C6C20746578742E22295D2C6D6172';
wwv_flow_imp.g_varchar2_table(11398) := '6B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C732070617374696E67207768656E20746865206C696E6520636F756E74206F6620746865207061737465642074657874206D6174636865732074686520637572736F7220636F75';
wwv_flow_imp.g_varchar2_table(11399) := '6E742E22297D29292C6D756C7469437572736F724C696D69743A514C286E657720534C2838302C226D756C7469437572736F724C696D6974222C3165342C312C3165352C7B6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F';
wwv_flow_imp.g_varchar2_table(11400) := '6C7320746865206D6178206E756D626572206F6620637572736F727320746861742063616E20626520696E20616E2061637469766520656469746F72206174206F6E63652E22297D29292C6F6363757272656E636573486967686C696768743A514C286E';
wwv_flow_imp.g_varchar2_table(11401) := '657720444C2838312C226F6363757272656E636573486967686C69676874222C2273696E676C6546696C65222C5B226F6666222C2273696E676C6546696C65222C226D756C746946696C65225D2C7B6D61726B646F776E456E756D446573637269707469';
wwv_flow_imp.g_varchar2_table(11402) := '6F6E733A5B6228302C22446F6573206E6F7420686967686C69676874206F6363757272656E6365732E22292C6228302C22486967686C6967687473206F6363757272656E636573206F6E6C7920696E207468652063757272656E742066696C652E22292C';
wwv_flow_imp.g_varchar2_table(11403) := '6228302C224578706572696D656E74616C3A20486967686C6967687473206F6363757272656E636573206163726F737320616C6C2076616C6964206F70656E2066696C65732E22295D2C6D61726B646F776E4465736372697074696F6E3A6228302C2243';
wwv_flow_imp.g_varchar2_table(11404) := '6F6E74726F6C732077686574686572206F6363757272656E6365732073686F756C6420626520686967686C696768746564206163726F7373206F70656E2066696C65732E22297D29292C6F7665727669657752756C6572426F726465723A514C286E6577';
wwv_flow_imp.g_varchar2_table(11405) := '20774C2838322C226F7665727669657752756C6572426F72646572222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206120626F726465722073686F756C6420626520647261776E2061726F756E642074';
wwv_flow_imp.g_varchar2_table(11406) := '6865206F766572766965772072756C65722E22297D29292C6F7665727669657752756C65724C616E65733A514C286E657720534C2838332C226F7665727669657752756C65724C616E6573222C332C302C3329292C70616464696E673A514C286E657720';
wwv_flow_imp.g_varchar2_table(11407) := '636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B73757065722838342C2270616464696E67222C7B746F703A302C626F74746F6D3A307D2C7B22656469746F722E70616464696E672E746F70223A7B747970653A226E756D62';
wwv_flow_imp.g_varchar2_table(11408) := '6572222C64656661756C743A302C6D696E696D756D3A302C6D6178696D756D3A3165332C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520616D6F756E74206F66207370616365206265747765656E2074686520746F70206564';
wwv_flow_imp.g_varchar2_table(11409) := '6765206F662074686520656469746F7220616E6420746865206669727374206C696E652E22297D2C22656469746F722E70616464696E672E626F74746F6D223A7B747970653A226E756D626572222C64656661756C743A302C6D696E696D756D3A302C6D';
wwv_flow_imp.g_varchar2_table(11410) := '6178696D756D3A3165332C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520616D6F756E74206F66207370616365206265747765656E2074686520626F74746F6D2065646765206F662074686520656469746F7220616E642074';
wwv_flow_imp.g_varchar2_table(11411) := '6865206C617374206C696E652E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B74';
wwv_flow_imp.g_varchar2_table(11412) := '6F703A534C2E636C616D706564496E7428742E746F702C302C302C316533292C626F74746F6D3A534C2E636C616D706564496E7428742E626F74746F6D2C302C302C316533297D7D7D292C706173746541733A514C286E657720636C6173732065787465';
wwv_flow_imp.g_varchar2_table(11413) := '6E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21302C73686F77506173746553656C6563746F723A2261667465725061737465227D3B73757065722838352C2270617374654173222C652C7B2265646974';
wwv_flow_imp.g_varchar2_table(11414) := '6F722E706173746541732E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220796F7520';
wwv_flow_imp.g_varchar2_table(11415) := '63616E20706173746520636F6E74656E7420696E20646966666572656E7420776179732E22297D2C22656469746F722E706173746541732E73686F77506173746553656C6563746F72223A7B747970653A22737472696E67222C6D61726B646F776E4465';
wwv_flow_imp.g_varchar2_table(11416) := '736372697074696F6E3A6228302C22436F6E74726F6C732069662061207769646765742069732073686F776E207768656E2070617374696E6720636F6E74656E7420696E20746F2074686520656469746F722E205468697320776964676574206C657473';
wwv_flow_imp.g_varchar2_table(11417) := '20796F7520636F6E74726F6C20686F77207468652066696C65206973207061737465642E22292C656E756D3A5B2261667465725061737465222C226E65766572225D2C656E756D4465736372697074696F6E733A5B6228302C2253686F77207468652070';
wwv_flow_imp.g_varchar2_table(11418) := '617374652073656C6563746F722077696467657420616674657220636F6E74656E742069732070617374656420696E746F2074686520656469746F722E22292C6228302C224E657665722073686F77207468652070617374652073656C6563746F722077';
wwv_flow_imp.g_varchar2_table(11419) := '69646765742E20496E7374656164207468652064656661756C742070617374696E67206265686176696F7220697320616C7761797320757365642E22295D2C64656661756C743A2261667465725061737465227D7D297D76616C69646174652865297B69';
wwv_flow_imp.g_varchar2_table(11420) := '662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65642C746869732E64656661756C74';
wwv_flow_imp.g_varchar2_table(11421) := '56616C75652E656E61626C6564292C73686F77506173746553656C6563746F723A4C4C28742E73686F77506173746553656C6563746F722C746869732E64656661756C7456616C75652E73686F77506173746553656C6563746F722C5B22616674657250';
wwv_flow_imp.g_varchar2_table(11422) := '61737465222C226E65766572225D297D7D7D292C706172616D6574657248696E74733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21302C6379636C653A21';
wwv_flow_imp.g_varchar2_table(11423) := '307D3B73757065722838362C22706172616D6574657248696E7473222C652C7B22656469746F722E706172616D6574657248696E74732E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6465';
wwv_flow_imp.g_varchar2_table(11424) := '736372697074696F6E3A6228302C22456E61626C6573206120706F702D757020746861742073686F777320706172616D6574657220646F63756D656E746174696F6E20616E64207479706520696E666F726D6174696F6E20617320796F7520747970652E';
wwv_flow_imp.g_varchar2_table(11425) := '22297D2C22656469746F722E706172616D6574657248696E74732E6379636C65223A7B747970653A22626F6F6C65616E222C64656661756C743A652E6379636C652C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220';
wwv_flow_imp.g_varchar2_table(11426) := '74686520706172616D657465722068696E7473206D656E75206379636C6573206F7220636C6F736573207768656E207265616368696E672074686520656E64206F6620746865206C6973742E22297D7D297D76616C69646174652865297B69662821657C';
wwv_flow_imp.g_varchar2_table(11427) := '7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65642C746869732E64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(11428) := '2E656E61626C6564292C6379636C653A794C28742E6379636C652C746869732E64656661756C7456616C75652E6379636C65297D7D7D292C7065656B57696467657444656661756C74466F6375733A514C286E657720444C2838372C227065656B576964';
wwv_flow_imp.g_varchar2_table(11429) := '67657444656661756C74466F637573222C2274726565222C5B2274726565222C22656469746F72225D2C7B656E756D4465736372697074696F6E733A5B6228302C22466F637573207468652074726565207768656E206F70656E696E67207065656B2229';
wwv_flow_imp.g_varchar2_table(11430) := '2C6228302C22466F6375732074686520656469746F72207768656E206F70656E696E67207065656B22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746F20666F6375732074686520696E6C696E65206564';
wwv_flow_imp.g_varchar2_table(11431) := '69746F72206F7220746865207472656520696E20746865207065656B207769646765742E22297D29292C646566696E6974696F6E4C696E6B4F70656E73496E5065656B3A514C286E657720774C2838382C22646566696E6974696F6E4C696E6B4F70656E';
wwv_flow_imp.g_varchar2_table(11432) := '73496E5065656B222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520476F20746F20446566696E6974696F6E206D6F757365206765737475726520616C77617973206F70656E73207468652070';
wwv_flow_imp.g_varchar2_table(11433) := '65656B207769646765742E22297D29292C717569636B53756767657374696F6E733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B6F746865723A226F6E222C636F6D6D656E7473';
wwv_flow_imp.g_varchar2_table(11434) := '3A226F6666222C737472696E67733A226F6666227D2C743D5B7B747970653A22626F6F6C65616E227D2C7B747970653A22737472696E67222C656E756D3A5B226F6E222C22696E6C696E65222C226F6666225D2C656E756D4465736372697074696F6E73';
wwv_flow_imp.g_varchar2_table(11435) := '3A5B6228302C22517569636B2073756767657374696F6E732073686F7720696E736964652074686520737567676573742077696467657422292C6228302C22517569636B2073756767657374696F6E732073686F772061732067686F7374207465787422';
wwv_flow_imp.g_varchar2_table(11436) := '292C6228302C22517569636B2073756767657374696F6E73206172652064697361626C656422295D7D5D3B73757065722838392C22717569636B53756767657374696F6E73222C652C7B747970653A226F626A656374222C6164646974696F6E616C5072';
wwv_flow_imp.g_varchar2_table(11437) := '6F706572746965733A21312C70726F706572746965733A7B737472696E67733A7B616E794F663A742C64656661756C743A652E737472696E67732C6465736372697074696F6E3A6228302C22456E61626C6520717569636B2073756767657374696F6E73';
wwv_flow_imp.g_varchar2_table(11438) := '20696E7369646520737472696E67732E22297D2C636F6D6D656E74733A7B616E794F663A742C64656661756C743A652E636F6D6D656E74732C6465736372697074696F6E3A6228302C22456E61626C6520717569636B2073756767657374696F6E732069';
wwv_flow_imp.g_varchar2_table(11439) := '6E7369646520636F6D6D656E74732E22297D2C6F746865723A7B616E794F663A742C64656661756C743A652E6F746865722C6465736372697074696F6E3A6228302C22456E61626C6520717569636B2073756767657374696F6E73206F75747369646520';
wwv_flow_imp.g_varchar2_table(11440) := '6F6620737472696E677320616E6420636F6D6D656E74732E22297D7D2C64656661756C743A652C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722073756767657374696F6E732073686F756C6420';
wwv_flow_imp.g_varchar2_table(11441) := '6175746F6D61746963616C6C792073686F77207570207768696C6520747970696E672E20546869732063616E20626520636F6E74726F6C6C656420666F7220747970696E6720696E20636F6D6D656E74732C20737472696E67732C20616E64206F746865';
wwv_flow_imp.g_varchar2_table(11442) := '7220636F64652E20517569636B2073756767657374696F6E2063616E20626520636F6E6669677572656420746F2073686F772061732067686F73742074657874206F722077697468207468652073756767657374207769646765742E20416C736F206265';
wwv_flow_imp.g_varchar2_table(11443) := '206177617265206F662074686520277B307D272D73657474696E6720776869636820636F6E74726F6C732069662073756767657374696F6E732061726520747269676765726564206279207370656369616C20636861726163746572732E222C22236564';
wwv_flow_imp.g_varchar2_table(11444) := '69746F722E737567676573744F6E54726967676572436861726163746572732322297D292C746869732E64656661756C7456616C75653D657D76616C69646174652865297B69662822626F6F6C65616E223D3D747970656F662065297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(11445) := '3D653F226F6E223A226F6666223B72657475726E7B636F6D6D656E74733A742C737472696E67733A742C6F746865723A747D7D69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75';
wwv_flow_imp.g_varchar2_table(11446) := '653B636F6E73747B6F746865723A742C636F6D6D656E74733A6E2C737472696E67733A697D3D652C6F3D5B226F6E222C22696E6C696E65222C226F6666225D3B6C657420732C722C613B72657475726E20733D22626F6F6C65616E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(11447) := '20743F743F226F6E223A226F6666223A4C4C28742C746869732E64656661756C7456616C75652E6F746865722C6F292C723D22626F6F6C65616E223D3D747970656F66206E3F6E3F226F6E223A226F6666223A4C4C286E2C746869732E64656661756C74';
wwv_flow_imp.g_varchar2_table(11448) := '56616C75652E636F6D6D656E74732C6F292C613D22626F6F6C65616E223D3D747970656F6620693F693F226F6E223A226F6666223A4C4C28692C746869732E64656661756C7456616C75652E737472696E67732C6F292C7B6F746865723A732C636F6D6D';
wwv_flow_imp.g_varchar2_table(11449) := '656E74733A722C737472696E67733A617D7D7D292C717569636B53756767657374696F6E7344656C61793A514C286E657720534C2839302C22717569636B53756767657374696F6E7344656C6179222C31302C302C313037333734313832342C7B646573';
wwv_flow_imp.g_varchar2_table(11450) := '6372697074696F6E3A6228302C22436F6E74726F6C73207468652064656C617920696E206D696C6C697365636F6E647320616674657220776869636820717569636B2073756767657374696F6E732077696C6C2073686F772075702E22297D29292C7265';
wwv_flow_imp.g_varchar2_table(11451) := '61644F6E6C793A514C286E657720774C2839312C22726561644F6E6C79222C213129292C726561644F6E6C794D6573736167653A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B73757065722839322C22';
wwv_flow_imp.g_varchar2_table(11452) := '726561644F6E6C794D657373616765222C766F69642030297D76616C69646174652865297B72657475726E20652626226F626A656374223D3D747970656F6620653F653A746869732E64656661756C7456616C75657D7D292C72656E616D654F6E547970';
wwv_flow_imp.g_varchar2_table(11453) := '653A514C286E657720774C2839332C2272656E616D654F6E54797065222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F72206175746F2072656E616D6573206F6E20747970652E';
wwv_flow_imp.g_varchar2_table(11454) := '22292C6D61726B646F776E4465707265636174696F6E4D6573736167653A6228302C22446570726563617465642C207573652060656469746F722E6C696E6B656445646974696E676020696E73746561642E22297D29292C72656E646572436F6E74726F';
wwv_flow_imp.g_varchar2_table(11455) := '6C436861726163746572733A514C286E657720774C2839342C2272656E646572436F6E74726F6C43686172616374657273222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F7220';
wwv_flow_imp.g_varchar2_table(11456) := '73686F756C642072656E64657220636F6E74726F6C20636861726163746572732E22292C726573747269637465643A21307D29292C72656E64657246696E616C4E65776C696E653A514C286E657720444C2839352C2272656E64657246696E616C4E6577';
wwv_flow_imp.g_varchar2_table(11457) := '6C696E65222C243F2264696D6D6564223A226F6E222C5B226F6666222C226F6E222C2264696D6D6564225D2C7B6465736372697074696F6E3A6228302C2252656E646572206C617374206C696E65206E756D626572207768656E207468652066696C6520';
wwv_flow_imp.g_varchar2_table(11458) := '656E647320776974682061206E65776C696E652E22297D29292C72656E6465724C696E65486967686C696768743A514C286E657720444C2839362C2272656E6465724C696E65486967686C69676874222C226C696E65222C5B226E6F6E65222C22677574';
wwv_flow_imp.g_varchar2_table(11459) := '746572222C226C696E65222C22616C6C225D2C7B656E756D4465736372697074696F6E733A5B22222C22222C22222C6228302C22486967686C696768747320626F7468207468652067757474657220616E64207468652063757272656E74206C696E652E';
wwv_flow_imp.g_varchar2_table(11460) := '22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320686F772074686520656469746F722073686F756C642072656E646572207468652063757272656E74206C696E6520686967686C696768742E22297D29292C72656E6465724C69';
wwv_flow_imp.g_varchar2_table(11461) := '6E65486967686C696768744F6E6C795768656E466F6375733A514C286E657720774C2839372C2272656E6465724C696E65486967686C696768744F6E6C795768656E466F637573222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F';
wwv_flow_imp.g_varchar2_table(11462) := '6C732069662074686520656469746F722073686F756C642072656E646572207468652063757272656E74206C696E6520686967686C69676874206F6E6C79207768656E2074686520656469746F7220697320666F63757365642E22297D29292C72656E64';
wwv_flow_imp.g_varchar2_table(11463) := '657256616C69646174696F6E4465636F726174696F6E733A514C286E657720444C2839382C2272656E64657256616C69646174696F6E4465636F726174696F6E73222C226564697461626C65222C5B226564697461626C65222C226F6E222C226F666622';
wwv_flow_imp.g_varchar2_table(11464) := '5D29292C72656E646572576869746573706163653A514C286E657720444C2839392C2272656E64657257686974657370616365222C2273656C656374696F6E222C5B226E6F6E65222C22626F756E64617279222C2273656C656374696F6E222C22747261';
wwv_flow_imp.g_varchar2_table(11465) := '696C696E67222C22616C6C225D2C7B656E756D4465736372697074696F6E733A5B22222C6228302C2252656E646572207768697465737061636520636861726163746572732065786365707420666F722073696E676C6520737061636573206265747765';
wwv_flow_imp.g_varchar2_table(11466) := '656E20776F7264732E22292C6228302C2252656E64657220776869746573706163652063686172616374657273206F6E6C79206F6E2073656C656374656420746578742E22292C6228302C2252656E646572206F6E6C7920747261696C696E6720776869';
wwv_flow_imp.g_varchar2_table(11467) := '7465737061636520636861726163746572732E22292C22225D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320686F772074686520656469746F722073686F756C642072656E6465722077686974657370616365206368617261637465';
wwv_flow_imp.g_varchar2_table(11468) := '72732E22297D29292C72657665616C486F72697A6F6E74616C526967687450616464696E673A514C286E657720534C283130302C2272657665616C486F72697A6F6E74616C526967687450616464696E67222C31352C302C31653329292C726F756E6465';
wwv_flow_imp.g_varchar2_table(11469) := '6453656C656374696F6E3A514C286E657720774C283130312C22726F756E64656453656C656374696F6E222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722073656C656374696F6E732073686F756C6420';
wwv_flow_imp.g_varchar2_table(11470) := '6861766520726F756E64656420636F726E6572732E22297D29292C72756C6572733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D5B5D2C743D7B747970653A226E756D626572222C';
wwv_flow_imp.g_varchar2_table(11471) := '6465736372697074696F6E3A6228302C224E756D626572206F66206D6F6E6F73706163652063686172616374657273206174207768696368207468697320656469746F722072756C65722077696C6C2072656E6465722E22297D3B737570657228313032';
wwv_flow_imp.g_varchar2_table(11472) := '2C2272756C657273222C652C7B747970653A226172726179222C6974656D733A7B616E794F663A5B742C7B747970653A5B226F626A656374225D2C70726F706572746965733A7B636F6C756D6E3A742C636F6C6F723A7B747970653A22737472696E6722';
wwv_flow_imp.g_varchar2_table(11473) := '2C6465736372697074696F6E3A6228302C22436F6C6F72206F66207468697320656469746F722072756C65722E22292C666F726D61743A22636F6C6F722D686578227D7D7D5D7D2C64656661756C743A652C6465736372697074696F6E3A6228302C2252';
wwv_flow_imp.g_varchar2_table(11474) := '656E64657220766572746963616C2072756C6572732061667465722061206365727461696E206E756D626572206F66206D6F6E6F737061636520636861726163746572732E20557365206D756C7469706C652076616C75657320666F72206D756C746970';
wwv_flow_imp.g_varchar2_table(11475) := '6C652072756C6572732E204E6F2072756C6572732061726520647261776E20696620617272617920697320656D7074792E22297D297D76616C69646174652865297B69662841727261792E69734172726179286529297B636F6E737420743D5B5D3B666F';
wwv_flow_imp.g_varchar2_table(11476) := '7228636F6E7374206E206F66206529696628226E756D626572223D3D747970656F66206E29742E70757368287B636F6C756D6E3A534C2E636C616D706564496E74286E2C302C302C316534292C636F6C6F723A6E756C6C7D293B656C7365206966286E26';
wwv_flow_imp.g_varchar2_table(11477) := '26226F626A656374223D3D747970656F66206E297B636F6E737420653D6E3B742E70757368287B636F6C756D6E3A534C2E636C616D706564496E7428652E636F6C756D6E2C302C302C316534292C636F6C6F723A652E636F6C6F727D297D72657475726E';
wwv_flow_imp.g_varchar2_table(11478) := '20742E736F7274282828652C74293D3E652E636F6C756D6E2D742E636F6C756D6E29292C747D72657475726E20746869732E64656661756C7456616C75657D7D292C7363726F6C6C6261723A514C286E657720636C61737320657874656E6473206D4C7B';
wwv_flow_imp.g_varchar2_table(11479) := '636F6E7374727563746F7228297B636F6E737420653D7B766572746963616C3A312C686F72697A6F6E74616C3A312C6172726F7753697A653A31312C757365536861646F77733A21302C766572746963616C4861734172726F77733A21312C686F72697A';
wwv_flow_imp.g_varchar2_table(11480) := '6F6E74616C4861734172726F77733A21312C686F72697A6F6E74616C5363726F6C6C62617253697A653A31322C686F72697A6F6E74616C536C6964657253697A653A31322C766572746963616C5363726F6C6C62617253697A653A31342C766572746963';
wwv_flow_imp.g_varchar2_table(11481) := '616C536C6964657253697A653A31342C68616E646C654D6F757365576865656C3A21302C616C77617973436F6E73756D654D6F757365576865656C3A21302C7363726F6C6C4279506167653A21312C69676E6F7265486F72697A6F6E74616C5363726F6C';
wwv_flow_imp.g_varchar2_table(11482) := '6C626172496E436F6E74656E744865696768743A21317D3B7375706572283130332C227363726F6C6C626172222C652C7B22656469746F722E7363726F6C6C6261722E766572746963616C223A7B747970653A22737472696E67222C656E756D3A5B2261';
wwv_flow_imp.g_varchar2_table(11483) := '75746F222C2276697369626C65222C2268696464656E225D2C656E756D4465736372697074696F6E733A5B6228302C2254686520766572746963616C207363726F6C6C6261722077696C6C2062652076697369626C65206F6E6C79207768656E206E6563';
wwv_flow_imp.g_varchar2_table(11484) := '6573736172792E22292C6228302C2254686520766572746963616C207363726F6C6C6261722077696C6C20616C776179732062652076697369626C652E22292C6228302C2254686520766572746963616C207363726F6C6C6261722077696C6C20616C77';
wwv_flow_imp.g_varchar2_table(11485) := '6179732062652068696464656E2E22295D2C64656661756C743A226175746F222C6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865207669736962696C697479206F662074686520766572746963616C207363726F6C6C6261722E';
wwv_flow_imp.g_varchar2_table(11486) := '22297D2C22656469746F722E7363726F6C6C6261722E686F72697A6F6E74616C223A7B747970653A22737472696E67222C656E756D3A5B226175746F222C2276697369626C65222C2268696464656E225D2C656E756D4465736372697074696F6E733A5B';
wwv_flow_imp.g_varchar2_table(11487) := '6228302C2254686520686F72697A6F6E74616C207363726F6C6C6261722077696C6C2062652076697369626C65206F6E6C79207768656E206E65636573736172792E22292C6228302C2254686520686F72697A6F6E74616C207363726F6C6C6261722077';
wwv_flow_imp.g_varchar2_table(11488) := '696C6C20616C776179732062652076697369626C652E22292C6228302C2254686520686F72697A6F6E74616C207363726F6C6C6261722077696C6C20616C776179732062652068696464656E2E22295D2C64656661756C743A226175746F222C64657363';
wwv_flow_imp.g_varchar2_table(11489) := '72697074696F6E3A6228302C22436F6E74726F6C7320746865207669736962696C697479206F662074686520686F72697A6F6E74616C207363726F6C6C6261722E22297D2C22656469746F722E7363726F6C6C6261722E766572746963616C5363726F6C';
wwv_flow_imp.g_varchar2_table(11490) := '6C62617253697A65223A7B747970653A226E756D626572222C64656661756C743A652E766572746963616C5363726F6C6C62617253697A652C6465736372697074696F6E3A6228302C22546865207769647468206F662074686520766572746963616C20';
wwv_flow_imp.g_varchar2_table(11491) := '7363726F6C6C6261722E22297D2C22656469746F722E7363726F6C6C6261722E686F72697A6F6E74616C5363726F6C6C62617253697A65223A7B747970653A226E756D626572222C64656661756C743A652E686F72697A6F6E74616C5363726F6C6C6261';
wwv_flow_imp.g_varchar2_table(11492) := '7253697A652C6465736372697074696F6E3A6228302C2254686520686569676874206F662074686520686F72697A6F6E74616C207363726F6C6C6261722E22297D2C22656469746F722E7363726F6C6C6261722E7363726F6C6C427950616765223A7B74';
wwv_flow_imp.g_varchar2_table(11493) := '7970653A22626F6F6C65616E222C64656661756C743A652E7363726F6C6C4279506167652C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220636C69636B73207363726F6C6C2062792070616765206F72206A756D70';
wwv_flow_imp.g_varchar2_table(11494) := '20746F20636C69636B20706F736974696F6E2E22297D2C22656469746F722E7363726F6C6C6261722E69676E6F7265486F72697A6F6E74616C5363726F6C6C626172496E436F6E74656E74486569676874223A7B747970653A22626F6F6C65616E222C64';
wwv_flow_imp.g_varchar2_table(11495) := '656661756C743A652E69676E6F7265486F72697A6F6E74616C5363726F6C6C626172496E436F6E74656E744865696768742C6465736372697074696F6E3A6228302C225768656E207365742C2074686520686F72697A6F6E74616C207363726F6C6C6261';
wwv_flow_imp.g_varchar2_table(11496) := '722077696C6C206E6F7420696E637265617365207468652073697A65206F662074686520656469746F72277320636F6E74656E742E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F66206529726574';
wwv_flow_imp.g_varchar2_table(11497) := '75726E20746869732E64656661756C7456616C75653B636F6E737420743D652C6E3D534C2E636C616D706564496E7428742E686F72697A6F6E74616C5363726F6C6C62617253697A652C746869732E64656661756C7456616C75652E686F72697A6F6E74';
wwv_flow_imp.g_varchar2_table(11498) := '616C5363726F6C6C62617253697A652C302C316533292C693D534C2E636C616D706564496E7428742E766572746963616C5363726F6C6C62617253697A652C746869732E64656661756C7456616C75652E766572746963616C5363726F6C6C6261725369';
wwv_flow_imp.g_varchar2_table(11499) := '7A652C302C316533293B72657475726E7B6172726F7753697A653A534C2E636C616D706564496E7428742E6172726F7753697A652C746869732E64656661756C7456616C75652E6172726F7753697A652C302C316533292C766572746963616C3A464C28';
wwv_flow_imp.g_varchar2_table(11500) := '742E766572746963616C2C746869732E64656661756C7456616C75652E766572746963616C292C686F72697A6F6E74616C3A464C28742E686F72697A6F6E74616C2C746869732E64656661756C7456616C75652E686F72697A6F6E74616C292C75736553';
wwv_flow_imp.g_varchar2_table(11501) := '6861646F77733A794C28742E757365536861646F77732C746869732E64656661756C7456616C75652E757365536861646F7773292C766572746963616C4861734172726F77733A794C28742E766572746963616C4861734172726F77732C746869732E64';
wwv_flow_imp.g_varchar2_table(11502) := '656661756C7456616C75652E766572746963616C4861734172726F7773292C686F72697A6F6E74616C4861734172726F77733A794C28742E686F72697A6F6E74616C4861734172726F77732C746869732E64656661756C7456616C75652E686F72697A6F';
wwv_flow_imp.g_varchar2_table(11503) := '6E74616C4861734172726F7773292C68616E646C654D6F757365576865656C3A794C28742E68616E646C654D6F757365576865656C2C746869732E64656661756C7456616C75652E68616E646C654D6F757365576865656C292C616C77617973436F6E73';
wwv_flow_imp.g_varchar2_table(11504) := '756D654D6F757365576865656C3A794C28742E616C77617973436F6E73756D654D6F757365576865656C2C746869732E64656661756C7456616C75652E616C77617973436F6E73756D654D6F757365576865656C292C686F72697A6F6E74616C5363726F';
wwv_flow_imp.g_varchar2_table(11505) := '6C6C62617253697A653A6E2C686F72697A6F6E74616C536C6964657253697A653A534C2E636C616D706564496E7428742E686F72697A6F6E74616C536C6964657253697A652C6E2C302C316533292C766572746963616C5363726F6C6C62617253697A65';
wwv_flow_imp.g_varchar2_table(11506) := '3A692C766572746963616C536C6964657253697A653A534C2E636C616D706564496E7428742E766572746963616C536C6964657253697A652C692C302C316533292C7363726F6C6C4279506167653A794C28742E7363726F6C6C4279506167652C746869';
wwv_flow_imp.g_varchar2_table(11507) := '732E64656661756C7456616C75652E7363726F6C6C427950616765292C69676E6F7265486F72697A6F6E74616C5363726F6C6C626172496E436F6E74656E744865696768743A794C28742E69676E6F7265486F72697A6F6E74616C5363726F6C6C626172';
wwv_flow_imp.g_varchar2_table(11508) := '496E436F6E74656E744865696768742C746869732E64656661756C7456616C75652E69676E6F7265486F72697A6F6E74616C5363726F6C6C626172496E436F6E74656E74486569676874297D7D7D292C7363726F6C6C4265796F6E644C617374436F6C75';
wwv_flow_imp.g_varchar2_table(11509) := '6D6E3A514C286E657720534C283130342C227363726F6C6C4265796F6E644C617374436F6C756D6E222C342C302C313037333734313832342C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206E756D626572206F66206578';
wwv_flow_imp.g_varchar2_table(11510) := '7472612063686172616374657273206265796F6E642077686963682074686520656469746F722077696C6C207363726F6C6C20686F72697A6F6E74616C6C792E22297D29292C7363726F6C6C4265796F6E644C6173744C696E653A514C286E657720774C';
wwv_flow_imp.g_varchar2_table(11511) := '283130352C227363726F6C6C4265796F6E644C6173744C696E65222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722077696C6C207363726F6C6C206265796F6E642074686520';
wwv_flow_imp.g_varchar2_table(11512) := '6C617374206C696E652E22297D29292C7363726F6C6C507265646F6D696E616E74417869733A514C286E657720774C283130362C227363726F6C6C507265646F6D696E616E7441786973222C21302C7B6465736372697074696F6E3A6228302C22536372';
wwv_flow_imp.g_varchar2_table(11513) := '6F6C6C206F6E6C7920616C6F6E672074686520707265646F6D696E616E742061786973207768656E207363726F6C6C696E6720626F746820766572746963616C6C7920616E6420686F72697A6F6E74616C6C79206174207468652073616D652074696D65';
wwv_flow_imp.g_varchar2_table(11514) := '2E2050726576656E747320686F72697A6F6E74616C206472696674207768656E207363726F6C6C696E6720766572746963616C6C79206F6E206120747261636B7061642E22297D29292C73656C656374696F6E436C6970626F6172643A514C286E657720';
wwv_flow_imp.g_varchar2_table(11515) := '774C283130372C2273656C656374696F6E436C6970626F617264222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746865204C696E7578207072696D61727920636C6970626F6172642073686F756C64';
wwv_flow_imp.g_varchar2_table(11516) := '20626520737570706F727465642E22292C696E636C756465643A247D29292C73656C656374696F6E486967686C696768743A514C286E657720774C283130382C2273656C656374696F6E486967686C69676874222C21302C7B6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(11517) := '3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F756C6420686967686C69676874206D6174636865732073696D696C617220746F207468652073656C656374696F6E2E22297D29292C73656C6563744F6E4C69';
wwv_flow_imp.g_varchar2_table(11518) := '6E654E756D626572733A514C286E657720774C283130392C2273656C6563744F6E4C696E654E756D62657273222C213029292C73686F77466F6C64696E67436F6E74726F6C733A514C286E657720444C283131302C2273686F77466F6C64696E67436F6E';
wwv_flow_imp.g_varchar2_table(11519) := '74726F6C73222C226D6F7573656F766572222C5B22616C77617973222C226E65766572222C226D6F7573656F766572225D2C7B656E756D4465736372697074696F6E733A5B6228302C22416C776179732073686F772074686520666F6C64696E6720636F';
wwv_flow_imp.g_varchar2_table(11520) := '6E74726F6C732E22292C6228302C224E657665722073686F772074686520666F6C64696E6720636F6E74726F6C7320616E642072656475636520746865206775747465722073697A652E22292C6228302C224F6E6C792073686F772074686520666F6C64';
wwv_flow_imp.g_varchar2_table(11521) := '696E6720636F6E74726F6C73207768656E20746865206D6F757365206973206F76657220746865206775747465722E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768656E2074686520666F6C64696E6720636F6E74726F';
wwv_flow_imp.g_varchar2_table(11522) := '6C73206F6E2074686520677574746572206172652073686F776E2E22297D29292C73686F77556E757365643A514C286E657720774C283131312C2273686F77556E75736564222C21302C7B6465736372697074696F6E3A6228302C22436F6E74726F6C73';
wwv_flow_imp.g_varchar2_table(11523) := '20666164696E67206F7574206F6620756E7573656420636F64652E22297D29292C73686F77446570726563617465643A514C286E657720774C283134302C2273686F7744657072656361746564222C21302C7B6465736372697074696F6E3A6228302C22';
wwv_flow_imp.g_varchar2_table(11524) := '436F6E74726F6C7320737472696B657468726F7567682064657072656361746564207661726961626C65732E22297D29292C696E6C617948696E74733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B63';
wwv_flow_imp.g_varchar2_table(11525) := '6F6E737420653D7B656E61626C65643A226F6E222C666F6E7453697A653A302C666F6E7446616D696C793A22222C70616464696E673A21317D3B7375706572283134312C22696E6C617948696E7473222C652C7B22656469746F722E696E6C617948696E';
wwv_flow_imp.g_varchar2_table(11526) := '74732E656E61626C6564223A7B747970653A22737472696E67222C64656661756C743A652E656E61626C65642C6465736372697074696F6E3A6228302C22456E61626C65732074686520696E6C61792068696E747320696E2074686520656469746F722E';
wwv_flow_imp.g_varchar2_table(11527) := '22292C656E756D3A5B226F6E222C226F6E556E6C65737350726573736564222C226F6666556E6C65737350726573736564222C226F6666225D2C6D61726B646F776E456E756D4465736372697074696F6E733A5B6228302C22496E6C61792068696E7473';
wwv_flow_imp.g_varchar2_table(11528) := '2061726520656E61626C656422292C6228302C22496E6C61792068696E7473206172652073686F77696E672062792064656661756C7420616E642068696465207768656E20686F6C64696E67207B307D222C713F224374726C2B4F7074696F6E223A2243';
wwv_flow_imp.g_varchar2_table(11529) := '74726C2B416C7422292C6228302C22496E6C61792068696E7473206172652068696464656E2062792064656661756C7420616E642073686F77207768656E20686F6C64696E67207B307D222C713F224374726C2B4F7074696F6E223A224374726C2B416C';
wwv_flow_imp.g_varchar2_table(11530) := '7422292C6228302C22496E6C61792068696E7473206172652064697361626C656422295D7D2C22656469746F722E696E6C617948696E74732E666F6E7453697A65223A7B747970653A226E756D626572222C64656661756C743A652E666F6E7453697A65';
wwv_flow_imp.g_varchar2_table(11531) := '2C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320666F6E742073697A65206F6620696E6C61792068696E747320696E2074686520656469746F722E2041732064656661756C7420746865207B307D20697320757365';
wwv_flow_imp.g_varchar2_table(11532) := '64207768656E2074686520636F6E666967757265642076616C7565206973206C657373207468616E207B317D206F722067726561746572207468616E2074686520656469746F7220666F6E742073697A652E222C226023656469746F722E666F6E745369';
wwv_flow_imp.g_varchar2_table(11533) := '7A652360222C2260356022297D2C22656469746F722E696E6C617948696E74732E666F6E7446616D696C79223A7B747970653A22737472696E67222C64656661756C743A652E666F6E7446616D696C792C6D61726B646F776E4465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(11534) := '3A6228302C22436F6E74726F6C7320666F6E742066616D696C79206F6620696E6C61792068696E747320696E2074686520656469746F722E205768656E2073657420746F20656D7074792C20746865207B307D20697320757365642E222C226023656469';
wwv_flow_imp.g_varchar2_table(11535) := '746F722E666F6E7446616D696C79236022297D2C22656469746F722E696E6C617948696E74732E70616464696E67223A7B747970653A22626F6F6C65616E222C64656661756C743A652E70616464696E672C6465736372697074696F6E3A6228302C2245';
wwv_flow_imp.g_varchar2_table(11536) := '6E61626C6573207468652070616464696E672061726F756E642074686520696E6C61792068696E747320696E2074686520656469746F722E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F66206529';
wwv_flow_imp.g_varchar2_table(11537) := '72657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E22626F6F6C65616E223D3D747970656F6620742E656E61626C6564262628742E656E61626C65643D742E656E61626C65643F226F6E223A226F6666';
wwv_flow_imp.g_varchar2_table(11538) := '22292C7B656E61626C65643A4C4C28742E656E61626C65642C746869732E64656661756C7456616C75652E656E61626C65642C5B226F6E222C226F6666222C226F6666556E6C65737350726573736564222C226F6E556E6C65737350726573736564225D';
wwv_flow_imp.g_varchar2_table(11539) := '292C666F6E7453697A653A534C2E636C616D706564496E7428742E666F6E7453697A652C746869732E64656661756C7456616C75652E666F6E7453697A652C302C313030292C666F6E7446616D696C793A454C2E737472696E6728742E666F6E7446616D';
wwv_flow_imp.g_varchar2_table(11540) := '696C792C746869732E64656661756C7456616C75652E666F6E7446616D696C79292C70616464696E673A794C28742E70616464696E672C746869732E64656661756C7456616C75652E70616464696E67297D7D7D292C736E697070657453756767657374';
wwv_flow_imp.g_varchar2_table(11541) := '696F6E733A514C286E657720444C283131322C22736E697070657453756767657374696F6E73222C22696E6C696E65222C5B22746F70222C22626F74746F6D222C22696E6C696E65222C226E6F6E65225D2C7B656E756D4465736372697074696F6E733A';
wwv_flow_imp.g_varchar2_table(11542) := '5B6228302C2253686F7720736E69707065742073756767657374696F6E73206F6E20746F70206F66206F746865722073756767657374696F6E732E22292C6228302C2253686F7720736E69707065742073756767657374696F6E732062656C6F77206F74';
wwv_flow_imp.g_varchar2_table(11543) := '6865722073756767657374696F6E732E22292C6228302C2253686F7720736E6970706574732073756767657374696F6E732077697468206F746865722073756767657374696F6E732E22292C6228302C22446F206E6F742073686F7720736E6970706574';
wwv_flow_imp.g_varchar2_table(11544) := '2073756767657374696F6E732E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220736E697070657473206172652073686F776E2077697468206F746865722073756767657374696F6E7320616E6420686F77';
wwv_flow_imp.g_varchar2_table(11545) := '20746865792061726520736F727465642E22297D29292C736D61727453656C6563743A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B7375706572283131332C22736D61727453656C656374222C7B7365';
wwv_flow_imp.g_varchar2_table(11546) := '6C6563744C656164696E67416E64547261696C696E67576869746573706163653A21302C73656C656374537562776F7264733A21307D2C7B22656469746F722E736D61727453656C6563742E73656C6563744C656164696E67416E64547261696C696E67';
wwv_flow_imp.g_varchar2_table(11547) := '57686974657370616365223A7B6465736372697074696F6E3A6228302C2257686574686572206C656164696E6720616E6420747261696C696E6720776869746573706163652073686F756C6420616C776179732062652073656C65637465642E22292C64';
wwv_flow_imp.g_varchar2_table(11548) := '656661756C743A21302C747970653A22626F6F6C65616E227D2C22656469746F722E736D61727453656C6563742E73656C656374537562776F726473223A7B6465736372697074696F6E3A6228302C225768657468657220737562776F72647320286C69';
wwv_flow_imp.g_varchar2_table(11549) := '6B652027666F6F2720696E2027666F6F42617227206F722027666F6F5F62617227292073686F756C642062652073656C65637465642E22292C64656661756C743A21302C747970653A22626F6F6C65616E227D7D297D76616C69646174652865297B7265';
wwv_flow_imp.g_varchar2_table(11550) := '7475726E20652626226F626A656374223D3D747970656F6620653F7B73656C6563744C656164696E67416E64547261696C696E67576869746573706163653A794C28652E73656C6563744C656164696E67416E64547261696C696E675768697465737061';
wwv_flow_imp.g_varchar2_table(11551) := '63652C746869732E64656661756C7456616C75652E73656C6563744C656164696E67416E64547261696C696E6757686974657370616365292C73656C656374537562776F7264733A794C28652E73656C656374537562776F7264732C746869732E646566';
wwv_flow_imp.g_varchar2_table(11552) := '61756C7456616C75652E73656C656374537562776F726473297D3A746869732E64656661756C7456616C75657D7D292C736D6F6F74685363726F6C6C696E673A514C286E657720774C283131342C22736D6F6F74685363726F6C6C696E67222C21312C7B';
wwv_flow_imp.g_varchar2_table(11553) := '6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722077696C6C207363726F6C6C207573696E6720616E20616E696D6174696F6E2E22297D29292C73746F7052656E646572696E674C696E6541';
wwv_flow_imp.g_varchar2_table(11554) := '667465723A514C286E657720534C283131372C2273746F7052656E646572696E674C696E654166746572222C3165342C2D312C3130373337343138323429292C737567676573743A514C286E657720636C61737320657874656E6473206D4C7B636F6E73';
wwv_flow_imp.g_varchar2_table(11555) := '74727563746F7228297B636F6E737420653D7B696E736572744D6F64653A22696E73657274222C66696C746572477261636566756C3A21302C736E69707065747350726576656E74517569636B53756767657374696F6E733A21312C6C6F63616C697479';
wwv_flow_imp.g_varchar2_table(11556) := '426F6E75733A21312C73686172655375676765737453656C656374696F6E733A21312C73656C656374696F6E4D6F64653A22616C77617973222C73686F7749636F6E733A21302C73686F775374617475734261723A21312C707265766965773A21312C70';
wwv_flow_imp.g_varchar2_table(11557) := '7265766965774D6F64653A22737562776F7264536D617274222C73686F77496E6C696E6544657461696C733A21302C73686F774D6574686F64733A21302C73686F7746756E6374696F6E733A21302C73686F77436F6E7374727563746F72733A21302C73';
wwv_flow_imp.g_varchar2_table(11558) := '686F77446570726563617465643A21302C6D617463684F6E576F726453746172744F6E6C793A21302C73686F774669656C64733A21302C73686F775661726961626C65733A21302C73686F77436C61737365733A21302C73686F77537472756374733A21';
wwv_flow_imp.g_varchar2_table(11559) := '302C73686F77496E74657266616365733A21302C73686F774D6F64756C65733A21302C73686F7750726F706572746965733A21302C73686F774576656E74733A21302C73686F774F70657261746F72733A21302C73686F77556E6974733A21302C73686F';
wwv_flow_imp.g_varchar2_table(11560) := '7756616C7565733A21302C73686F77436F6E7374616E74733A21302C73686F77456E756D733A21302C73686F77456E756D4D656D626572733A21302C73686F774B6579776F7264733A21302C73686F77576F7264733A21302C73686F77436F6C6F72733A';
wwv_flow_imp.g_varchar2_table(11561) := '21302C73686F7746696C65733A21302C73686F775265666572656E6365733A21302C73686F77466F6C646572733A21302C73686F7754797065506172616D65746572733A21302C73686F77536E6970706574733A21302C73686F7755736572733A21302C';
wwv_flow_imp.g_varchar2_table(11562) := '73686F774973737565733A21307D3B7375706572283131382C2273756767657374222C652C7B22656469746F722E737567676573742E696E736572744D6F6465223A7B747970653A22737472696E67222C656E756D3A5B22696E73657274222C22726570';
wwv_flow_imp.g_varchar2_table(11563) := '6C616365225D2C656E756D4465736372697074696F6E733A5B6228302C22496E736572742073756767657374696F6E20776974686F7574206F76657277726974696E672074657874207269676874206F662074686520637572736F722E22292C6228302C';
wwv_flow_imp.g_varchar2_table(11564) := '22496E736572742073756767657374696F6E20616E64206F76657277726974652074657874207269676874206F662074686520637572736F722E22295D2C64656661756C743A652E696E736572744D6F64652C6465736372697074696F6E3A6228302C22';
wwv_flow_imp.g_varchar2_table(11565) := '436F6E74726F6C73207768657468657220776F72647320617265206F7665727772697474656E207768656E20616363657074696E6720636F6D706C6574696F6E732E204E6F74652074686174207468697320646570656E6473206F6E20657874656E7369';
wwv_flow_imp.g_varchar2_table(11566) := '6F6E73206F7074696E6720696E746F207468697320666561747572652E22297D2C22656469746F722E737567676573742E66696C746572477261636566756C223A7B747970653A22626F6F6C65616E222C64656661756C743A652E66696C746572477261';
wwv_flow_imp.g_varchar2_table(11567) := '636566756C2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722066696C746572696E6720616E6420736F7274696E672073756767657374696F6E73206163636F756E747320666F7220736D616C6C207479706F732E22';
wwv_flow_imp.g_varchar2_table(11568) := '297D2C22656469746F722E737567676573742E6C6F63616C697479426F6E7573223A7B747970653A22626F6F6C65616E222C64656661756C743A652E6C6F63616C697479426F6E75732C6465736372697074696F6E3A6228302C22436F6E74726F6C7320';
wwv_flow_imp.g_varchar2_table(11569) := '7768657468657220736F7274696E67206661766F727320776F72647320746861742061707065617220636C6F736520746F2074686520637572736F722E22297D2C22656469746F722E737567676573742E73686172655375676765737453656C65637469';
wwv_flow_imp.g_varchar2_table(11570) := '6F6E73223A7B747970653A22626F6F6C65616E222C64656661756C743A652E73686172655375676765737453656C656374696F6E732C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722072656D65';
wwv_flow_imp.g_varchar2_table(11571) := '6D62657265642073756767657374696F6E2073656C656374696F6E732061726520736861726564206265747765656E206D756C7469706C6520776F726B73706163657320616E642077696E646F777320286E65656473206023656469746F722E73756767';
wwv_flow_imp.g_varchar2_table(11572) := '65737453656C656374696F6E2360292E22297D2C22656469746F722E737567676573742E73656C656374696F6E4D6F6465223A7B747970653A22737472696E67222C656E756D3A5B22616C77617973222C226E65766572222C227768656E547269676765';
wwv_flow_imp.g_varchar2_table(11573) := '72436861726163746572222C227768656E517569636B53756767657374696F6E225D2C656E756D4465736372697074696F6E733A5B6228302C22416C776179732073656C65637420612073756767657374696F6E207768656E206175746F6D6174696361';
wwv_flow_imp.g_varchar2_table(11574) := '6C6C792074726967676572696E6720496E74656C6C6953656E73652E22292C6228302C224E657665722073656C65637420612073756767657374696F6E207768656E206175746F6D61746963616C6C792074726967676572696E6720496E74656C6C6953';
wwv_flow_imp.g_varchar2_table(11575) := '656E73652E22292C6228302C2253656C65637420612073756767657374696F6E206F6E6C79207768656E2074726967676572696E6720496E74656C6C6953656E73652066726F6D20612074726967676572206368617261637465722E22292C6228302C22';
wwv_flow_imp.g_varchar2_table(11576) := '53656C65637420612073756767657374696F6E206F6E6C79207768656E2074726967676572696E6720496E74656C6C6953656E736520617320796F7520747970652E22295D2C64656661756C743A652E73656C656374696F6E4D6F64652C6D61726B646F';
wwv_flow_imp.g_varchar2_table(11577) := '776E4465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220612073756767657374696F6E2069732073656C6563746564207768656E20746865207769646765742073686F77732E204E6F746520746861742074686973206F';
wwv_flow_imp.g_varchar2_table(11578) := '6E6C79206170706C69657320746F206175746F6D61746963616C6C79207472696767657265642073756767657374696F6E7320286023656469746F722E717569636B53756767657374696F6E73236020616E64206023656469746F722E73756767657374';
wwv_flow_imp.g_varchar2_table(11579) := '4F6E547269676765724368617261637465727323602920616E64207468617420612073756767657374696F6E20697320616C776179732073656C6563746564207768656E206578706C696369746C7920696E766F6B65642C20652E672076696120604374';
wwv_flow_imp.g_varchar2_table(11580) := '726C2B5370616365602E22297D2C22656469746F722E737567676573742E736E69707065747350726576656E74517569636B53756767657374696F6E73223A7B747970653A22626F6F6C65616E222C64656661756C743A652E736E697070657473507265';
wwv_flow_imp.g_varchar2_table(11581) := '76656E74517569636B53756767657374696F6E732C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220616E2061637469766520736E69707065742070726576656E747320717569636B2073756767657374696F6E732E';
wwv_flow_imp.g_varchar2_table(11582) := '22297D2C22656469746F722E737567676573742E73686F7749636F6E73223A7B747970653A22626F6F6C65616E222C64656661756C743A652E73686F7749636F6E732C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572';
wwv_flow_imp.g_varchar2_table(11583) := '20746F2073686F77206F7220686964652069636F6E7320696E2073756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77537461747573426172223A7B747970653A22626F6F6C65616E222C64656661756C743A652E73';
wwv_flow_imp.g_varchar2_table(11584) := '686F775374617475734261722C6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865207669736962696C697479206F662074686520737461747573206261722061742074686520626F74746F6D206F66207468652073756767657374';
wwv_flow_imp.g_varchar2_table(11585) := '207769646765742E22297D2C22656469746F722E737567676573742E70726576696577223A7B747970653A22626F6F6C65616E222C64656661756C743A652E707265766965772C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865';
wwv_flow_imp.g_varchar2_table(11586) := '7468657220746F2070726576696577207468652073756767657374696F6E206F7574636F6D6520696E2074686520656469746F722E22297D2C22656469746F722E737567676573742E73686F77496E6C696E6544657461696C73223A7B747970653A2262';
wwv_flow_imp.g_varchar2_table(11587) := '6F6F6C65616E222C64656661756C743A652E73686F77496E6C696E6544657461696C732C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220737567676573742064657461696C732073686F7720696E6C696E65207769';
wwv_flow_imp.g_varchar2_table(11588) := '746820746865206C6162656C206F72206F6E6C7920696E207468652064657461696C73207769646765742E22297D2C22656469746F722E737567676573742E6D617856697369626C6553756767657374696F6E73223A7B747970653A226E756D62657222';
wwv_flow_imp.g_varchar2_table(11589) := '2C6465707265636174696F6E4D6573736167653A6228302C22546869732073657474696E6720697320646570726563617465642E205468652073756767657374207769646765742063616E206E6F7720626520726573697A65642E22297D2C2265646974';
wwv_flow_imp.g_varchar2_table(11590) := '6F722E737567676573742E66696C74657265645479706573223A7B747970653A226F626A656374222C6465707265636174696F6E4D6573736167653A6228302C22546869732073657474696E6720697320646570726563617465642C20706C6561736520';
wwv_flow_imp.g_varchar2_table(11591) := '7573652073657061726174652073657474696E6773206C696B652027656469746F722E737567676573742E73686F774B6579776F72647327206F722027656469746F722E737567676573742E73686F77536E6970706574732720696E73746561642E2229';
wwv_flow_imp.g_varchar2_table(11592) := '7D2C22656469746F722E737567676573742E73686F774D6574686F6473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E7465';
wwv_flow_imp.g_varchar2_table(11593) := '6C6C6953656E73652073686F777320606D6574686F64602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7746756E6374696F6E73223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61';
wwv_flow_imp.g_varchar2_table(11594) := '726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F7773206066756E6374696F6E602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E7368';
wwv_flow_imp.g_varchar2_table(11595) := '6F77436F6E7374727563746F7273223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320';
wwv_flow_imp.g_varchar2_table(11596) := '60636F6E7374727563746F72602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7744657072656361746564223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E446573';
wwv_flow_imp.g_varchar2_table(11597) := '6372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F7773206064657072656361746564602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E6D617463684F6E576F';
wwv_flow_imp.g_varchar2_table(11598) := '726453746172744F6E6C79223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652066696C746572696E67';
wwv_flow_imp.g_varchar2_table(11599) := '20726571756972657320746861742074686520666972737420636861726163746572206D617463686573206F6E206120776F72642073746172742E20466F72206578616D706C652C20606360206F6E2060436F6E736F6C6560206F722060576562436F6E';
wwv_flow_imp.g_varchar2_table(11600) := '746578746020627574205F6E6F745F206F6E20606465736372697074696F6E602E205768656E2064697361626C656420496E74656C6C6953656E73652077696C6C2073686F77206D6F726520726573756C747320627574207374696C6C20736F72747320';
wwv_flow_imp.g_varchar2_table(11601) := '7468656D206279206D61746368207175616C6974792E22297D2C22656469746F722E737567676573742E73686F774669656C6473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(11602) := '3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320606669656C64602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F775661726961626C6573223A7B747970653A22';
wwv_flow_imp.g_varchar2_table(11603) := '626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320607661726961626C65602D73756767657374696F6E732E';
wwv_flow_imp.g_varchar2_table(11604) := '22297D2C22656469746F722E737567676573742E73686F77436C6173736573223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E';
wwv_flow_imp.g_varchar2_table(11605) := '74656C6C6953656E73652073686F77732060636C617373602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7753747275637473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D6172';
wwv_flow_imp.g_varchar2_table(11606) := '6B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060737472756374602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7749';
wwv_flow_imp.g_varchar2_table(11607) := '6E7465726661636573223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060696E7465';
wwv_flow_imp.g_varchar2_table(11608) := '7266616365602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F774D6F64756C6573223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A62';
wwv_flow_imp.g_varchar2_table(11609) := '28302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320606D6F64756C65602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7750726F70657274696573223A7B747970653A22';
wwv_flow_imp.g_varchar2_table(11610) := '626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F7773206070726F7065727479602D73756767657374696F6E732E';
wwv_flow_imp.g_varchar2_table(11611) := '22297D2C22656469746F722E737567676573742E73686F774576656E7473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74';
wwv_flow_imp.g_varchar2_table(11612) := '656C6C6953656E73652073686F777320606576656E74602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F774F70657261746F7273223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61';
wwv_flow_imp.g_varchar2_table(11613) := '726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320606F70657261746F72602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E7368';
wwv_flow_imp.g_varchar2_table(11614) := '6F77556E697473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060756E6974602D';
wwv_flow_imp.g_varchar2_table(11615) := '73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7756616C756573223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E';
wwv_flow_imp.g_varchar2_table(11616) := '20656E61626C656420496E74656C6C6953656E73652073686F7773206076616C7565602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77436F6E7374616E7473223A7B747970653A22626F6F6C65616E222C64';
wwv_flow_imp.g_varchar2_table(11617) := '656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060636F6E7374616E74602D73756767657374696F6E732E22297D2C22656469746F';
wwv_flow_imp.g_varchar2_table(11618) := '722E737567676573742E73686F77456E756D73223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073';
wwv_flow_imp.g_varchar2_table(11619) := '686F77732060656E756D602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77456E756D4D656D62657273223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E44657363';
wwv_flow_imp.g_varchar2_table(11620) := '72697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060656E756D4D656D626572602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F774B6579776F72';
wwv_flow_imp.g_varchar2_table(11621) := '6473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320606B6579776F7264602D7375';
wwv_flow_imp.g_varchar2_table(11622) := '6767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77576F726473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E';
wwv_flow_imp.g_varchar2_table(11623) := '61626C656420496E74656C6C6953656E73652073686F7773206074657874602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77436F6C6F7273223A7B747970653A22626F6F6C65616E222C64656661756C743A';
wwv_flow_imp.g_varchar2_table(11624) := '21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060636F6C6F72602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E';
wwv_flow_imp.g_varchar2_table(11625) := '73686F7746696C6573223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F7773206066696C65';
wwv_flow_imp.g_varchar2_table(11626) := '602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F775265666572656E636573223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A622830';
wwv_flow_imp.g_varchar2_table(11627) := '2C225768656E20656E61626C656420496E74656C6C6953656E73652073686F777320607265666572656E6365602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77437573746F6D636F6C6F7273223A7B747970';
wwv_flow_imp.g_varchar2_table(11628) := '653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060637573746F6D636F6C6F72602D737567676573';
wwv_flow_imp.g_varchar2_table(11629) := '74696F6E732E22297D2C22656469746F722E737567676573742E73686F77466F6C64657273223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E6162';
wwv_flow_imp.g_varchar2_table(11630) := '6C656420496E74656C6C6953656E73652073686F77732060666F6C646572602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F7754797065506172616D6574657273223A7B747970653A22626F6F6C65616E222C';
wwv_flow_imp.g_varchar2_table(11631) := '64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F7773206074797065506172616D65746572602D73756767657374696F6E732E22297D2C';
wwv_flow_imp.g_varchar2_table(11632) := '22656469746F722E737567676573742E73686F77536E697070657473223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C';
wwv_flow_imp.g_varchar2_table(11633) := '6C6953656E73652073686F77732060736E6970706574602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F775573657273223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F';
wwv_flow_imp.g_varchar2_table(11634) := '776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F7773206075736572602D73756767657374696F6E732E22297D2C22656469746F722E737567676573742E73686F77497373756573';
wwv_flow_imp.g_varchar2_table(11635) := '223A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6D61726B646F776E4465736372697074696F6E3A6228302C225768656E20656E61626C656420496E74656C6C6953656E73652073686F77732060697373756573602D7375676765';
wwv_flow_imp.g_varchar2_table(11636) := '7374696F6E732E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B696E736572744D';
wwv_flow_imp.g_varchar2_table(11637) := '6F64653A4C4C28742E696E736572744D6F64652C746869732E64656661756C7456616C75652E696E736572744D6F64652C5B22696E73657274222C227265706C616365225D292C66696C746572477261636566756C3A794C28742E66696C746572477261';
wwv_flow_imp.g_varchar2_table(11638) := '636566756C2C746869732E64656661756C7456616C75652E66696C746572477261636566756C292C736E69707065747350726576656E74517569636B53756767657374696F6E733A794C28742E736E69707065747350726576656E74517569636B537567';
wwv_flow_imp.g_varchar2_table(11639) := '67657374696F6E732C746869732E64656661756C7456616C75652E66696C746572477261636566756C292C6C6F63616C697479426F6E75733A794C28742E6C6F63616C697479426F6E75732C746869732E64656661756C7456616C75652E6C6F63616C69';
wwv_flow_imp.g_varchar2_table(11640) := '7479426F6E7573292C73686172655375676765737453656C656374696F6E733A794C28742E73686172655375676765737453656C656374696F6E732C746869732E64656661756C7456616C75652E73686172655375676765737453656C656374696F6E73';
wwv_flow_imp.g_varchar2_table(11641) := '292C73656C656374696F6E4D6F64653A4C4C28742E73656C656374696F6E4D6F64652C746869732E64656661756C7456616C75652E73656C656374696F6E4D6F64652C5B22616C77617973222C226E65766572222C227768656E517569636B5375676765';
wwv_flow_imp.g_varchar2_table(11642) := '7374696F6E222C227768656E54726967676572436861726163746572225D292C73686F7749636F6E733A794C28742E73686F7749636F6E732C746869732E64656661756C7456616C75652E73686F7749636F6E73292C73686F775374617475734261723A';
wwv_flow_imp.g_varchar2_table(11643) := '794C28742E73686F775374617475734261722C746869732E64656661756C7456616C75652E73686F77537461747573426172292C707265766965773A794C28742E707265766965772C746869732E64656661756C7456616C75652E70726576696577292C';
wwv_flow_imp.g_varchar2_table(11644) := '707265766965774D6F64653A4C4C28742E707265766965774D6F64652C746869732E64656661756C7456616C75652E707265766965774D6F64652C5B22707265666978222C22737562776F7264222C22737562776F7264536D617274225D292C73686F77';
wwv_flow_imp.g_varchar2_table(11645) := '496E6C696E6544657461696C733A794C28742E73686F77496E6C696E6544657461696C732C746869732E64656661756C7456616C75652E73686F77496E6C696E6544657461696C73292C73686F774D6574686F64733A794C28742E73686F774D6574686F';
wwv_flow_imp.g_varchar2_table(11646) := '64732C746869732E64656661756C7456616C75652E73686F774D6574686F6473292C73686F7746756E6374696F6E733A794C28742E73686F7746756E6374696F6E732C746869732E64656661756C7456616C75652E73686F7746756E6374696F6E73292C';
wwv_flow_imp.g_varchar2_table(11647) := '73686F77436F6E7374727563746F72733A794C28742E73686F77436F6E7374727563746F72732C746869732E64656661756C7456616C75652E73686F77436F6E7374727563746F7273292C73686F77446570726563617465643A794C28742E73686F7744';
wwv_flow_imp.g_varchar2_table(11648) := '6570726563617465642C746869732E64656661756C7456616C75652E73686F7744657072656361746564292C6D617463684F6E576F726453746172744F6E6C793A794C28742E6D617463684F6E576F726453746172744F6E6C792C746869732E64656661';
wwv_flow_imp.g_varchar2_table(11649) := '756C7456616C75652E6D617463684F6E576F726453746172744F6E6C79292C73686F774669656C64733A794C28742E73686F774669656C64732C746869732E64656661756C7456616C75652E73686F774669656C6473292C73686F775661726961626C65';
wwv_flow_imp.g_varchar2_table(11650) := '733A794C28742E73686F775661726961626C65732C746869732E64656661756C7456616C75652E73686F775661726961626C6573292C73686F77436C61737365733A794C28742E73686F77436C61737365732C746869732E64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(11651) := '2E73686F77436C6173736573292C73686F77537472756374733A794C28742E73686F77537472756374732C746869732E64656661756C7456616C75652E73686F7753747275637473292C73686F77496E74657266616365733A794C28742E73686F77496E';
wwv_flow_imp.g_varchar2_table(11652) := '74657266616365732C746869732E64656661756C7456616C75652E73686F77496E7465726661636573292C73686F774D6F64756C65733A794C28742E73686F774D6F64756C65732C746869732E64656661756C7456616C75652E73686F774D6F64756C65';
wwv_flow_imp.g_varchar2_table(11653) := '73292C73686F7750726F706572746965733A794C28742E73686F7750726F706572746965732C746869732E64656661756C7456616C75652E73686F7750726F70657274696573292C73686F774576656E74733A794C28742E73686F774576656E74732C74';
wwv_flow_imp.g_varchar2_table(11654) := '6869732E64656661756C7456616C75652E73686F774576656E7473292C73686F774F70657261746F72733A794C28742E73686F774F70657261746F72732C746869732E64656661756C7456616C75652E73686F774F70657261746F7273292C73686F7755';
wwv_flow_imp.g_varchar2_table(11655) := '6E6974733A794C28742E73686F77556E6974732C746869732E64656661756C7456616C75652E73686F77556E697473292C73686F7756616C7565733A794C28742E73686F7756616C7565732C746869732E64656661756C7456616C75652E73686F775661';
wwv_flow_imp.g_varchar2_table(11656) := '6C756573292C73686F77436F6E7374616E74733A794C28742E73686F77436F6E7374616E74732C746869732E64656661756C7456616C75652E73686F77436F6E7374616E7473292C73686F77456E756D733A794C28742E73686F77456E756D732C746869';
wwv_flow_imp.g_varchar2_table(11657) := '732E64656661756C7456616C75652E73686F77456E756D73292C73686F77456E756D4D656D626572733A794C28742E73686F77456E756D4D656D626572732C746869732E64656661756C7456616C75652E73686F77456E756D4D656D62657273292C7368';
wwv_flow_imp.g_varchar2_table(11658) := '6F774B6579776F7264733A794C28742E73686F774B6579776F7264732C746869732E64656661756C7456616C75652E73686F774B6579776F726473292C73686F77576F7264733A794C28742E73686F77576F7264732C746869732E64656661756C745661';
wwv_flow_imp.g_varchar2_table(11659) := '6C75652E73686F77576F726473292C73686F77436F6C6F72733A794C28742E73686F77436F6C6F72732C746869732E64656661756C7456616C75652E73686F77436F6C6F7273292C73686F7746696C65733A794C28742E73686F7746696C65732C746869';
wwv_flow_imp.g_varchar2_table(11660) := '732E64656661756C7456616C75652E73686F7746696C6573292C73686F775265666572656E6365733A794C28742E73686F775265666572656E6365732C746869732E64656661756C7456616C75652E73686F775265666572656E636573292C73686F7746';
wwv_flow_imp.g_varchar2_table(11661) := '6F6C646572733A794C28742E73686F77466F6C646572732C746869732E64656661756C7456616C75652E73686F77466F6C64657273292C73686F7754797065506172616D65746572733A794C28742E73686F7754797065506172616D65746572732C7468';
wwv_flow_imp.g_varchar2_table(11662) := '69732E64656661756C7456616C75652E73686F7754797065506172616D6574657273292C73686F77536E6970706574733A794C28742E73686F77536E6970706574732C746869732E64656661756C7456616C75652E73686F77536E697070657473292C73';
wwv_flow_imp.g_varchar2_table(11663) := '686F7755736572733A794C28742E73686F7755736572732C746869732E64656661756C7456616C75652E73686F775573657273292C73686F774973737565733A794C28742E73686F774973737565732C746869732E64656661756C7456616C75652E7368';
wwv_flow_imp.g_varchar2_table(11664) := '6F77497373756573297D7D7D292C696E6C696E65537567676573743A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21302C6D6F64653A22737562776F726453';
wwv_flow_imp.g_varchar2_table(11665) := '6D617274222C73686F77546F6F6C6261723A226F6E486F766572222C737570707265737353756767657374696F6E733A21312C6B6565704F6E426C75723A21312C666F6E7446616D696C793A2264656661756C74227D3B73757065722836322C22696E6C';
wwv_flow_imp.g_varchar2_table(11666) := '696E6553756767657374222C652C7B22656469746F722E696E6C696E65537567676573742E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6465736372697074696F6E3A6228302C22436F6E';
wwv_flow_imp.g_varchar2_table(11667) := '74726F6C73207768657468657220746F206175746F6D61746963616C6C792073686F7720696E6C696E652073756767657374696F6E7320696E2074686520656469746F722E22297D2C22656469746F722E696E6C696E65537567676573742E73686F7754';
wwv_flow_imp.g_varchar2_table(11668) := '6F6F6C626172223A7B747970653A22737472696E67222C64656661756C743A652E73686F77546F6F6C6261722C656E756D3A5B22616C77617973222C226F6E486F766572222C226E65766572225D2C656E756D4465736372697074696F6E733A5B622830';
wwv_flow_imp.g_varchar2_table(11669) := '2C2253686F772074686520696E6C696E652073756767657374696F6E20746F6F6C626172207768656E6576657220616E20696E6C696E652073756767657374696F6E2069732073686F776E2E22292C6228302C2253686F772074686520696E6C696E6520';
wwv_flow_imp.g_varchar2_table(11670) := '73756767657374696F6E20746F6F6C626172207768656E20686F766572696E67206F76657220616E20696E6C696E652073756767657374696F6E2E22292C6228302C224E657665722073686F772074686520696E6C696E652073756767657374696F6E20';
wwv_flow_imp.g_varchar2_table(11671) := '746F6F6C6261722E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768656E20746F2073686F772074686520696E6C696E652073756767657374696F6E20746F6F6C6261722E22297D2C22656469746F722E696E6C696E6553';
wwv_flow_imp.g_varchar2_table(11672) := '7567676573742E737570707265737353756767657374696F6E73223A7B747970653A22626F6F6C65616E222C64656661756C743A652E737570707265737353756767657374696F6E732C6465736372697074696F6E3A6228302C22436F6E74726F6C7320';
wwv_flow_imp.g_varchar2_table(11673) := '686F7720696E6C696E652073756767657374696F6E7320696E7465726163742077697468207468652073756767657374207769646765742E20496620656E61626C65642C20746865207375676765737420776964676574206973206E6F742073686F776E';
wwv_flow_imp.g_varchar2_table(11674) := '206175746F6D61746963616C6C79207768656E20696E6C696E652073756767657374696F6E732061726520617661696C61626C652E22297D2C22656469746F722E696E6C696E65537567676573742E666F6E7446616D696C79223A7B747970653A227374';
wwv_flow_imp.g_varchar2_table(11675) := '72696E67222C64656661756C743A652E666F6E7446616D696C792C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E742066616D696C79206F662074686520696E6C696E652073756767657374696F6E732E22297D7D29';
wwv_flow_imp.g_varchar2_table(11676) := '7D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65';
wwv_flow_imp.g_varchar2_table(11677) := '642C746869732E64656661756C7456616C75652E656E61626C6564292C6D6F64653A4C4C28742E6D6F64652C746869732E64656661756C7456616C75652E6D6F64652C5B22707265666978222C22737562776F7264222C22737562776F7264536D617274';
wwv_flow_imp.g_varchar2_table(11678) := '225D292C73686F77546F6F6C6261723A4C4C28742E73686F77546F6F6C6261722C746869732E64656661756C7456616C75652E73686F77546F6F6C6261722C5B22616C77617973222C226F6E486F766572222C226E65766572225D292C73757070726573';
wwv_flow_imp.g_varchar2_table(11679) := '7353756767657374696F6E733A794C28742E737570707265737353756767657374696F6E732C746869732E64656661756C7456616C75652E737570707265737353756767657374696F6E73292C6B6565704F6E426C75723A794C28742E6B6565704F6E42';
wwv_flow_imp.g_varchar2_table(11680) := '6C75722C746869732E64656661756C7456616C75652E6B6565704F6E426C7572292C666F6E7446616D696C793A454C2E737472696E6728742E666F6E7446616D696C792C746869732E64656661756C7456616C75652E666F6E7446616D696C79297D7D7D';
wwv_flow_imp.g_varchar2_table(11681) := '292C696E6C696E65456469743A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B656E61626C65643A21312C73686F77546F6F6C6261723A226F6E486F766572222C666F6E7446616D';
wwv_flow_imp.g_varchar2_table(11682) := '696C793A2264656661756C74222C6B6565704F6E426C75723A21312C6261636B67726F756E64436F6C6F72696E673A21317D3B73757065722836332C226578706572696D656E74616C496E6C696E6545646974222C652C7B22656469746F722E65787065';
wwv_flow_imp.g_varchar2_table(11683) := '72696D656E74616C496E6C696E65456469742E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A652E656E61626C65642C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746F2073';
wwv_flow_imp.g_varchar2_table(11684) := '686F7720696E6C696E6520656469747320696E2074686520656469746F722E22297D2C22656469746F722E6578706572696D656E74616C496E6C696E65456469742E73686F77546F6F6C626172223A7B747970653A22737472696E67222C64656661756C';
wwv_flow_imp.g_varchar2_table(11685) := '743A652E73686F77546F6F6C6261722C656E756D3A5B22616C77617973222C226F6E486F766572222C226E65766572225D2C656E756D4465736372697074696F6E733A5B6228302C2253686F772074686520696E6C696E65206564697420746F6F6C6261';
wwv_flow_imp.g_varchar2_table(11686) := '72207768656E6576657220616E20696E6C696E652073756767657374696F6E2069732073686F776E2E22292C6228302C2253686F772074686520696E6C696E65206564697420746F6F6C626172207768656E20686F766572696E67206F76657220616E20';
wwv_flow_imp.g_varchar2_table(11687) := '696E6C696E652073756767657374696F6E2E22292C6228302C224E657665722073686F772074686520696E6C696E65206564697420746F6F6C6261722E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768656E20746F2073';
wwv_flow_imp.g_varchar2_table(11688) := '686F772074686520696E6C696E65206564697420746F6F6C6261722E22297D2C22656469746F722E6578706572696D656E74616C496E6C696E65456469742E666F6E7446616D696C79223A7B747970653A22737472696E67222C64656661756C743A652E';
wwv_flow_imp.g_varchar2_table(11689) := '666F6E7446616D696C792C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520666F6E742066616D696C79206F662074686520696E6C696E6520656469742E22297D2C22656469746F722E6578706572696D656E74616C496E6C69';
wwv_flow_imp.g_varchar2_table(11690) := '6E65456469742E6261636B67726F756E64436F6C6F72696E67223A7B747970653A22626F6F6C65616E222C64656661756C743A652E6261636B67726F756E64436F6C6F72696E672C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768';
wwv_flow_imp.g_varchar2_table(11691) := '657468657220746F20636F6C6F7220746865206261636B67726F756E64206F6620696E6C696E652065646974732E22297D7D297D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869';
wwv_flow_imp.g_varchar2_table(11692) := '732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B656E61626C65643A794C28742E656E61626C65642C746869732E64656661756C7456616C75652E656E61626C6564292C73686F77546F6F6C6261723A4C4C28742E73686F';
wwv_flow_imp.g_varchar2_table(11693) := '77546F6F6C6261722C746869732E64656661756C7456616C75652E73686F77546F6F6C6261722C5B22616C77617973222C226F6E486F766572222C226E65766572225D292C666F6E7446616D696C793A454C2E737472696E6728742E666F6E7446616D69';
wwv_flow_imp.g_varchar2_table(11694) := '6C792C746869732E64656661756C7456616C75652E666F6E7446616D696C79292C6B6565704F6E426C75723A794C28742E6B6565704F6E426C75722C746869732E64656661756C7456616C75652E6B6565704F6E426C7572292C6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(11695) := '436F6C6F72696E673A794C28742E6261636B67726F756E64436F6C6F72696E672C746869732E64656661756C7456616C75652E6261636B67726F756E64436F6C6F72696E67297D7D7D292C696E6C696E65436F6D706C6574696F6E734163636573736962';
wwv_flow_imp.g_varchar2_table(11696) := '696C697479566572626F73653A514C286E657720774C283134392C22696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F7365222C21312C7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865';
wwv_flow_imp.g_varchar2_table(11697) := '7468657220746865206163636573736962696C6974792068696E742073686F756C642062652070726F766964656420746F2073637265656E20726561646572207573657273207768656E20616E20696E6C696E6520636F6D706C6574696F6E2069732073';
wwv_flow_imp.g_varchar2_table(11698) := '686F776E2E22297D29292C73756767657374466F6E7453697A653A514C286E657720534C283131392C2273756767657374466F6E7453697A65222C302C302C3165332C7B6D61726B646F776E4465736372697074696F6E3A6228302C22466F6E74207369';
wwv_flow_imp.g_varchar2_table(11699) := '7A6520666F72207468652073756767657374207769646765742E205768656E2073657420746F207B307D2C207468652076616C7565206F66207B317D20697320757365642E222C22603060222C226023656469746F722E666F6E7453697A65236022297D';
wwv_flow_imp.g_varchar2_table(11700) := '29292C737567676573744C696E654865696768743A514C286E657720534C283132302C22737567676573744C696E65486569676874222C302C302C3165332C7B6D61726B646F776E4465736372697074696F6E3A6228302C224C696E6520686569676874';
wwv_flow_imp.g_varchar2_table(11701) := '20666F72207468652073756767657374207769646765742E205768656E2073657420746F207B307D2C207468652076616C7565206F66207B317D20697320757365642E20546865206D696E696D756D2076616C756520697320382E222C22603060222C22';
wwv_flow_imp.g_varchar2_table(11702) := '6023656469746F722E6C696E65486569676874236022297D29292C737567676573744F6E54726967676572436861726163746572733A514C286E657720774C283132312C22737567676573744F6E5472696767657243686172616374657273222C21302C';
wwv_flow_imp.g_varchar2_table(11703) := '7B6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722073756767657374696F6E732073686F756C64206175746F6D61746963616C6C792073686F77207570207768656E20747970696E6720747269676765722063686172';
wwv_flow_imp.g_varchar2_table(11704) := '6163746572732E22297D29292C7375676765737453656C656374696F6E3A514C286E657720444C283132322C227375676765737453656C656374696F6E222C226669727374222C5B226669727374222C22726563656E746C7955736564222C2272656365';
wwv_flow_imp.g_varchar2_table(11705) := '6E746C79557365644279507265666978225D2C7B6D61726B646F776E456E756D4465736372697074696F6E733A5B6228302C22416C776179732073656C656374207468652066697273742073756767657374696F6E2E22292C6228302C2253656C656374';
wwv_flow_imp.g_varchar2_table(11706) := '20726563656E742073756767657374696F6E7320756E6C657373206675727468657220747970696E672073656C65637473206F6E652C20652E672E2060636F6E736F6C652E7C202D3E20636F6E736F6C652E6C6F6760206265636175736520606C6F6760';
wwv_flow_imp.g_varchar2_table(11707) := '20686173206265656E20636F6D706C6574656420726563656E746C792E22292C6228302C2253656C6563742073756767657374696F6E73206261736564206F6E2070726576696F75732070726566697865732074686174206861766520636F6D706C6574';
wwv_flow_imp.g_varchar2_table(11708) := '65642074686F73652073756767657374696F6E732C20652E672E2060636F202D3E20636F6E736F6C656020616E642060636F6E202D3E20636F6E7374602E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320686F772073756767';
wwv_flow_imp.g_varchar2_table(11709) := '657374696F6E7320617265207072652D73656C6563746564207768656E2073686F77696E67207468652073756767657374206C6973742E22297D29292C746162436F6D706C6574696F6E3A514C286E657720444C283132332C22746162436F6D706C6574';
wwv_flow_imp.g_varchar2_table(11710) := '696F6E222C226F6666222C5B226F6E222C226F6666222C226F6E6C79536E697070657473225D2C7B656E756D4465736372697074696F6E733A5B6228302C2254616220636F6D706C6574652077696C6C20696E73657274207468652062657374206D6174';
wwv_flow_imp.g_varchar2_table(11711) := '6368696E672073756767657374696F6E207768656E207072657373696E67207461622E22292C6228302C2244697361626C652074616220636F6D706C6574696F6E732E22292C6228302C2254616220636F6D706C65746520736E69707065747320776865';
wwv_flow_imp.g_varchar2_table(11712) := '6E20746865697220707265666978206D617463682E20576F726B732062657374207768656E2027717569636B53756767657374696F6E7327206172656E277420656E61626C65642E22295D2C6465736372697074696F6E3A6228302C22456E61626C6573';
wwv_flow_imp.g_varchar2_table(11713) := '2074616220636F6D706C6574696F6E732E22297D29292C746162496E6465783A514C286E657720534C283132342C22746162496E646578222C302C2D312C3130373337343138323429292C756E69636F6465486967686C696768743A514C286E65772063';
wwv_flow_imp.g_varchar2_table(11714) := '6C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B636F6E737420653D7B6E6F6E426173696341534349493A424C2C696E76697369626C65436861726163746572733A21302C616D626967756F7573436861726163746572733A21';
wwv_flow_imp.g_varchar2_table(11715) := '302C696E636C756465436F6D6D656E74733A424C2C696E636C756465537472696E67733A21302C616C6C6F776564436861726163746572733A7B7D2C616C6C6F7765644C6F63616C65733A7B5F6F733A21302C5F7673636F64653A21307D7D3B73757065';
wwv_flow_imp.g_varchar2_table(11716) := '72283132352C22756E69636F6465486967686C69676874222C652C7B5B484C5D3A7B726573747269637465643A21302C747970653A5B22626F6F6C65616E222C22737472696E67225D2C656E756D3A5B21302C21312C424C5D2C64656661756C743A652E';
wwv_flow_imp.g_varchar2_table(11717) := '6E6F6E426173696341534349492C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220616C6C206E6F6E2D626173696320415343494920636861726163746572732061726520686967686C6967687465642E204F6E6C79';
wwv_flow_imp.g_varchar2_table(11718) := '2063686172616374657273206265747765656E20552B3030323020616E6420552B303037452C207461622C206C696E652D6665656420616E642063617272696167652D72657475726E2061726520636F6E73696465726564206261736963204153434949';
wwv_flow_imp.g_varchar2_table(11719) := '2E22297D2C5B7A4C5D3A7B726573747269637465643A21302C747970653A22626F6F6C65616E222C64656661756C743A652E696E76697369626C65436861726163746572732C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574';
wwv_flow_imp.g_varchar2_table(11720) := '68657220636861726163746572732074686174206A7573742072657365727665207370616365206F722068617665206E6F20776964746820617420616C6C2061726520686967686C6967687465642E22297D2C5B574C5D3A7B726573747269637465643A';
wwv_flow_imp.g_varchar2_table(11721) := '21302C747970653A22626F6F6C65616E222C64656661756C743A652E616D626967756F7573436861726163746572732C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220636861726163746572732061726520686967';
wwv_flow_imp.g_varchar2_table(11722) := '686C69676874656420746861742063616E20626520636F6E6675736564207769746820626173696320415343494920636861726163746572732C206578636570742074686F736520746861742061726520636F6D6D6F6E20696E20746865206375727265';
wwv_flow_imp.g_varchar2_table(11723) := '6E742075736572206C6F63616C652E22297D2C5B6A4C5D3A7B726573747269637465643A21302C747970653A5B22626F6F6C65616E222C22737472696E67225D2C656E756D3A5B21302C21312C424C5D2C64656661756C743A652E696E636C756465436F';
wwv_flow_imp.g_varchar2_table(11724) := '6D6D656E74732C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206368617261637465727320696E20636F6D6D656E74732073686F756C6420616C736F206265207375626A65637420746F20556E69636F6465206869';
wwv_flow_imp.g_varchar2_table(11725) := '67686C69676874696E672E22297D2C5B714C5D3A7B726573747269637465643A21302C747970653A5B22626F6F6C65616E222C22737472696E67225D2C656E756D3A5B21302C21312C424C5D2C64656661756C743A652E696E636C756465537472696E67';
wwv_flow_imp.g_varchar2_table(11726) := '732C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206368617261637465727320696E20737472696E67732073686F756C6420616C736F206265207375626A65637420746F20556E69636F646520686967686C696768';
wwv_flow_imp.g_varchar2_table(11727) := '74696E672E22297D2C5B564C5D3A7B726573747269637465643A21302C747970653A226F626A656374222C64656661756C743A652E616C6C6F776564436861726163746572732C6465736372697074696F6E3A6228302C22446566696E657320616C6C6F';
wwv_flow_imp.g_varchar2_table(11728) := '7765642063686172616374657273207468617420617265206E6F74206265696E6720686967686C6967687465642E22292C6164646974696F6E616C50726F706572746965733A7B747970653A22626F6F6C65616E227D7D2C5B244C5D3A7B726573747269';
wwv_flow_imp.g_varchar2_table(11729) := '637465643A21302C747970653A226F626A656374222C6164646974696F6E616C50726F706572746965733A7B747970653A22626F6F6C65616E227D2C64656661756C743A652E616C6C6F7765644C6F63616C65732C6465736372697074696F6E3A622830';
wwv_flow_imp.g_varchar2_table(11730) := '2C22556E69636F6465206368617261637465727320746861742061726520636F6D6D6F6E20696E20616C6C6F776564206C6F63616C657320617265206E6F74206265696E6720686967686C6967687465642E22297D7D297D6170706C7955706461746528';
wwv_flow_imp.g_varchar2_table(11731) := '652C74297B6C6574206E3D21313B742E616C6C6F77656443686172616374657273262665262628776828652E616C6C6F776564436861726163746572732C742E616C6C6F77656443686172616374657273297C7C28653D7B2E2E2E652C616C6C6F776564';
wwv_flow_imp.g_varchar2_table(11732) := '436861726163746572733A742E616C6C6F776564436861726163746572737D2C6E3D213029292C742E616C6C6F7765644C6F63616C6573262665262628776828652E616C6C6F7765644C6F63616C65732C742E616C6C6F7765644C6F63616C6573297C7C';
wwv_flow_imp.g_varchar2_table(11733) := '28653D7B2E2E2E652C616C6C6F7765644C6F63616C65733A742E616C6C6F7765644C6F63616C65737D2C6E3D213029293B636F6E737420693D73757065722E6170706C7955706461746528652C74293B72657475726E206E3F6E657720664C28692E6E65';
wwv_flow_imp.g_varchar2_table(11734) := '7756616C75652C2130293A697D76616C69646174652865297B69662821657C7C226F626A65637422213D747970656F6620652972657475726E20746869732E64656661756C7456616C75653B636F6E737420743D653B72657475726E7B6E6F6E42617369';
wwv_flow_imp.g_varchar2_table(11735) := '6341534349493A554C28742E6E6F6E426173696341534349492C424C2C5B21302C21312C424C5D292C696E76697369626C65436861726163746572733A794C28742E696E76697369626C65436861726163746572732C746869732E64656661756C745661';
wwv_flow_imp.g_varchar2_table(11736) := '6C75652E696E76697369626C6543686172616374657273292C616D626967756F7573436861726163746572733A794C28742E616D626967756F7573436861726163746572732C746869732E64656661756C7456616C75652E616D626967756F7573436861';
wwv_flow_imp.g_varchar2_table(11737) := '72616374657273292C696E636C756465436F6D6D656E74733A554C28742E696E636C756465436F6D6D656E74732C424C2C5B21302C21312C424C5D292C696E636C756465537472696E67733A554C28742E696E636C756465537472696E67732C424C2C5B';
wwv_flow_imp.g_varchar2_table(11738) := '21302C21312C424C5D292C616C6C6F776564436861726163746572733A746869732E76616C6964617465426F6F6C65616E4D617028652E616C6C6F776564436861726163746572732C746869732E64656661756C7456616C75652E616C6C6F7765644368';
wwv_flow_imp.g_varchar2_table(11739) := '6172616374657273292C616C6C6F7765644C6F63616C65733A746869732E76616C6964617465426F6F6C65616E4D617028652E616C6C6F7765644C6F63616C65732C746869732E64656661756C7456616C75652E616C6C6F7765644C6F63616C6573297D';
wwv_flow_imp.g_varchar2_table(11740) := '7D76616C6964617465426F6F6C65616E4D617028652C74297B696628226F626A65637422213D747970656F6620657C7C21652972657475726E20743B636F6E7374206E3D7B7D3B666F7228636F6E73745B742C695D6F66204F626A6563742E656E747269';
wwv_flow_imp.g_varchar2_table(11741) := '65732865292921303D3D3D692626286E5B745D3D2130293B72657475726E206E7D7D292C756E757375616C4C696E655465726D696E61746F72733A514C286E657720444C283132362C22756E757375616C4C696E655465726D696E61746F7273222C2270';
wwv_flow_imp.g_varchar2_table(11742) := '726F6D7074222C5B226175746F222C226F6666222C2270726F6D7074225D2C7B656E756D4465736372697074696F6E733A5B6228302C22556E757375616C206C696E65207465726D696E61746F727320617265206175746F6D61746963616C6C79207265';
wwv_flow_imp.g_varchar2_table(11743) := '6D6F7665642E22292C6228302C22556E757375616C206C696E65207465726D696E61746F7273206172652069676E6F7265642E22292C6228302C22556E757375616C206C696E65207465726D696E61746F72732070726F6D707420746F2062652072656D';
wwv_flow_imp.g_varchar2_table(11744) := '6F7665642E22295D2C6465736372697074696F6E3A6228302C2252656D6F766520756E757375616C206C696E65207465726D696E61746F72732074686174206D696768742063617573652070726F626C656D732E22297D29292C757365536861646F7744';
wwv_flow_imp.g_varchar2_table(11745) := '4F4D3A514C286E657720774C283132372C22757365536861646F77444F4D222C213029292C75736554616253746F70733A514C286E657720774C283132382C2275736554616253746F7073222C21302C7B6465736372697074696F6E3A6228302C225370';
wwv_flow_imp.g_varchar2_table(11746) := '6163657320616E6420746162732061726520696E73657274656420616E642064656C6574656420696E20616C69676E6D656E742077697468207461622073746F70732E22297D29292C776F7264427265616B3A514C286E657720444C283132392C22776F';
wwv_flow_imp.g_varchar2_table(11747) := '7264427265616B222C226E6F726D616C222C5B226E6F726D616C222C226B656570416C6C225D2C7B6D61726B646F776E456E756D4465736372697074696F6E733A5B6228302C22557365207468652064656661756C74206C696E6520627265616B207275';
wwv_flow_imp.g_varchar2_table(11748) := '6C652E22292C6228302C22576F726420627265616B732073686F756C64206E6F74206265207573656420666F72204368696E6573652F4A6170616E6573652F4B6F7265616E2028434A4B2920746578742E204E6F6E2D434A4B2074657874206265686176';
wwv_flow_imp.g_varchar2_table(11749) := '696F72206973207468652073616D6520617320666F72206E6F726D616C2E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C732074686520776F726420627265616B2072756C6573207573656420666F72204368696E6573652F4A61';
wwv_flow_imp.g_varchar2_table(11750) := '70616E6573652F4B6F7265616E2028434A4B2920746578742E22297D29292C776F72645365676D656E7465724C6F63616C65733A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B7375706572283133302C';
wwv_flow_imp.g_varchar2_table(11751) := '22776F72645365676D656E7465724C6F63616C6573222C5B5D2C7B616E794F663A5B7B6465736372697074696F6E3A6228302C224C6F63616C657320746F206265207573656420666F7220776F7264207365676D656E746174696F6E207768656E20646F';
wwv_flow_imp.g_varchar2_table(11752) := '696E6720776F72642072656C61746564206E617669676174696F6E73206F72206F7065726174696F6E732E20537065636966792074686520424350203437206C616E677561676520746167206F662074686520776F726420796F75207769736820746F20';
wwv_flow_imp.g_varchar2_table(11753) := '7265636F676E697A652028652E672E2C206A612C207A682D434E2C207A682D48616E742D54572C206574632E292E22292C747970653A22737472696E67227D2C7B6465736372697074696F6E3A6228302C224C6F63616C657320746F2062652075736564';
wwv_flow_imp.g_varchar2_table(11754) := '20666F7220776F7264207365676D656E746174696F6E207768656E20646F696E6720776F72642072656C61746564206E617669676174696F6E73206F72206F7065726174696F6E732E20537065636966792074686520424350203437206C616E67756167';
wwv_flow_imp.g_varchar2_table(11755) := '6520746167206F662074686520776F726420796F75207769736820746F207265636F676E697A652028652E672E2C206A612C207A682D434E2C207A682D48616E742D54572C206574632E292E22292C747970653A226172726179222C6974656D733A7B74';
wwv_flow_imp.g_varchar2_table(11756) := '7970653A22737472696E67227D7D5D7D297D76616C69646174652865297B69662822737472696E67223D3D747970656F662065262628653D5B655D292C41727261792E69734172726179286529297B636F6E737420743D5B5D3B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(11757) := '6E206F6620652969662822737472696E67223D3D747970656F66206E297472797B496E746C2E5365676D656E7465722E737570706F727465644C6F63616C65734F66286E292E6C656E6774683E302626742E70757368286E297D63617463682865297B7D';
wwv_flow_imp.g_varchar2_table(11758) := '72657475726E20747D72657475726E20746869732E64656661756C7456616C75657D7D292C776F7264536570617261746F72733A514C286E657720454C283133312C22776F7264536570617261746F7273222C44752C7B6465736372697074696F6E3A62';
wwv_flow_imp.g_varchar2_table(11759) := '28302C224368617261637465727320746861742077696C6C206265207573656420617320776F726420736570617261746F7273207768656E20646F696E6720776F72642072656C61746564206E617669676174696F6E73206F72206F7065726174696F6E';
wwv_flow_imp.g_varchar2_table(11760) := '732E22297D29292C776F7264577261703A514C286E657720444C283133322C22776F726457726170222C226F6666222C5B226F6666222C226F6E222C22776F726457726170436F6C756D6E222C22626F756E646564225D2C7B6D61726B646F776E456E75';
wwv_flow_imp.g_varchar2_table(11761) := '6D4465736372697074696F6E733A5B6228302C224C696E65732077696C6C206E6576657220777261702E22292C6228302C224C696E65732077696C6C2077726170206174207468652076696577706F72742077696474682E22292C6228302C224C696E65';
wwv_flow_imp.g_varchar2_table(11762) := '732077696C6C2077726170206174206023656469746F722E776F726457726170436F6C756D6E23602E22292C6228302C224C696E65732077696C6C207772617020617420746865206D696E696D756D206F662076696577706F727420616E642060236564';
wwv_flow_imp.g_varchar2_table(11763) := '69746F722E776F726457726170436F6C756D6E23602E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C7320686F77206C696E65732073686F756C6420777261702E22297D29292C776F726457726170427265616B41667465724368';
wwv_flow_imp.g_varchar2_table(11764) := '61726163746572733A514C286E657720454C283133332C22776F726457726170427265616B416674657243686172616374657273222C22205C747D295D3F7C2F262E2C3BC2A2C2B0E280B2E280B3E280B0E28483E38081E38082EFBDA1EFBDA4EFBFA0EF';
wwv_flow_imp.g_varchar2_table(11765) := 'BC8CEFBC8EEFBC9AEFBC9BEFBC9FEFBC81EFBC85E383BBEFBDA5E3829DE3829EE383BDE383BEE383BCE382A1E382A3E382A5E382A7E382A9E38383E383A3E383A5E383A7E383AEE383B5E383B6E38181E38183E38185E38187E38189E381A3E38283E382';
wwv_flow_imp.g_varchar2_table(11766) := '85E38287E3828EE38295E38296E387B0E387B1E387B2E387B3E387B4E387B5E387B6E387B7E387B8E387B9E387BAE387BBE387BCE387BDE387BEE387BFE38085E380BBEFBDA7EFBDA8EFBDA9EFBDAAEFBDABEFBDACEFBDADEFBDAEEFBDAFEFBDB0E2809D';
wwv_flow_imp.g_varchar2_table(11767) := 'E38089E3808BE3808DE3808FE38091E38095EFBC89EFBCBDEFBD9DEFBDA32229292C776F726457726170427265616B4265666F7265436861726163746572733A514C286E657720454C283133342C22776F726457726170427265616B4265666F72654368';
wwv_flow_imp.g_varchar2_table(11768) := '6172616374657273222C22285B7BE28098E2809CE38088E3808AE3808CE3808EE38090E38094EFBC88EFBCBBEFBD9BEFBDA2C2A3C2A5EFBC84EFBFA1EFBFA52BEFBC8B2229292C776F726457726170436F6C756D6E3A514C286E657720534C283133352C';
wwv_flow_imp.g_varchar2_table(11769) := '22776F726457726170436F6C756D6E222C38302C312C313037333734313832342C7B6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320746865207772617070696E6720636F6C756D6E206F662074686520656469746F';
wwv_flow_imp.g_varchar2_table(11770) := '72207768656E206023656469746F722E776F72645772617023602069732060776F726457726170436F6C756D6E60206F722060626F756E646564602E22297D29292C776F7264577261704F76657272696465313A514C286E657720444C283133362C2277';
wwv_flow_imp.g_varchar2_table(11771) := '6F7264577261704F7665727269646531222C22696E6865726974222C5B226F6666222C226F6E222C22696E6865726974225D29292C776F7264577261704F76657272696465323A514C286E657720444C283133372C22776F7264577261704F7665727269';
wwv_flow_imp.g_varchar2_table(11772) := '646532222C22696E6865726974222C5B226F6666222C226F6E222C22696E6865726974225D29292C656469746F72436C6173734E616D653A514C286E657720636C61737320657874656E647320624C7B636F6E7374727563746F7228297B737570657228';
wwv_flow_imp.g_varchar2_table(11773) := '313432297D636F6D7075746528652C742C6E297B636F6E737420693D5B226D6F6E61636F2D656469746F72225D3B72657475726E20742E676574283339292626692E7075736828742E67657428333929292C652E6578747261456469746F72436C617373';
wwv_flow_imp.g_varchar2_table(11774) := '4E616D652626692E7075736828652E6578747261456469746F72436C6173734E616D65292C2264656661756C74223D3D3D742E676574283734293F692E7075736828226D6F7573652D64656661756C7422293A22636F7079223D3D3D742E676574283734';
wwv_flow_imp.g_varchar2_table(11775) := '292626692E7075736828226D6F7573652D636F707922292C742E67657428313131292626692E70757368282273686F77556E7573656422292C742E67657428313430292626692E70757368282273686F774465707265636174656422292C692E6A6F696E';
wwv_flow_imp.g_varchar2_table(11776) := '28222022297D7D292C64656661756C74436F6C6F724465636F7261746F72733A514C286E657720774C283134372C2264656661756C74436F6C6F724465636F7261746F7273222C21312C7B6D61726B646F776E4465736372697074696F6E3A6228302C22';
wwv_flow_imp.g_varchar2_table(11777) := '436F6E74726F6C73207768657468657220696E6C696E6520636F6C6F72206465636F726174696F6E732073686F756C642062652073686F776E207573696E67207468652064656661756C7420646F63756D656E7420636F6C6F722070726F766964657222';
wwv_flow_imp.g_varchar2_table(11778) := '297D29292C706978656C526174696F3A514C286E657720636C61737320657874656E647320624C7B636F6E7374727563746F7228297B737570657228313433297D636F6D7075746528652C742C6E297B72657475726E20652E706978656C526174696F7D';
wwv_flow_imp.g_varchar2_table(11779) := '7D292C746162466F6375734D6F64653A514C286E657720774C283134342C22746162466F6375734D6F6465222C21312C7B6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F';
wwv_flow_imp.g_varchar2_table(11780) := '722072656365697665732074616273206F7220646566657273207468656D20746F2074686520776F726B62656E636820666F72206E617669676174696F6E2E22297D29292C6C61796F7574496E666F3A514C286E6577204F4C292C7772617070696E6749';
wwv_flow_imp.g_varchar2_table(11781) := '6E666F3A514C286E657720636C61737320657874656E647320624C7B636F6E7374727563746F7228297B737570657228313436297D636F6D7075746528652C742C6E297B636F6E737420693D742E67657428313435293B72657475726E7B6973446F6D69';
wwv_flow_imp.g_varchar2_table(11782) := '6E6174656442794C6F6E674C696E65733A652E6973446F6D696E6174656442794C6F6E674C696E65732C6973576F7264577261704D696E69666965643A692E6973576F7264577261704D696E69666965642C697356696577706F72745772617070696E67';
wwv_flow_imp.g_varchar2_table(11783) := '3A692E697356696577706F72745772617070696E672C7772617070696E67436F6C756D6E3A692E7772617070696E67436F6C756D6E7D7D7D292C7772617070696E67496E64656E743A514C286E657720636C61737320657874656E6473206D4C7B636F6E';
wwv_flow_imp.g_varchar2_table(11784) := '7374727563746F7228297B7375706572283133382C227772617070696E67496E64656E74222C312C7B22656469746F722E7772617070696E67496E64656E74223A7B747970653A22737472696E67222C656E756D3A5B226E6F6E65222C2273616D65222C';
wwv_flow_imp.g_varchar2_table(11785) := '22696E64656E74222C2264656570496E64656E74225D2C656E756D4465736372697074696F6E733A5B6228302C224E6F20696E64656E746174696F6E2E2057726170706564206C696E657320626567696E20617420636F6C756D6E20312E22292C622830';
wwv_flow_imp.g_varchar2_table(11786) := '2C2257726170706564206C696E657320676574207468652073616D6520696E64656E746174696F6E2061732074686520706172656E742E22292C6228302C2257726170706564206C696E657320676574202B3120696E64656E746174696F6E20746F7761';
wwv_flow_imp.g_varchar2_table(11787) := '72642074686520706172656E742E22292C6228302C2257726170706564206C696E657320676574202B3220696E64656E746174696F6E20746F776172642074686520706172656E742E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F';
wwv_flow_imp.g_varchar2_table(11788) := '6C732074686520696E64656E746174696F6E206F662077726170706564206C696E65732E22292C64656661756C743A2273616D65227D7D297D76616C69646174652865297B7377697463682865297B63617365226E6F6E65223A72657475726E20303B63';
wwv_flow_imp.g_varchar2_table(11789) := '6173652273616D65223A72657475726E20313B6361736522696E64656E74223A72657475726E20323B636173652264656570496E64656E74223A72657475726E20337D72657475726E20317D636F6D7075746528652C742C6E297B72657475726E20323D';
wwv_flow_imp.g_varchar2_table(11790) := '3D3D742E6765742832293F303A6E7D7D292C7772617070696E6753747261746567793A514C286E657720636C61737320657874656E6473206D4C7B636F6E7374727563746F7228297B7375706572283133392C227772617070696E675374726174656779';
wwv_flow_imp.g_varchar2_table(11791) := '222C2273696D706C65222C7B22656469746F722E7772617070696E675374726174656779223A7B656E756D4465736372697074696F6E733A5B6228302C22417373756D6573207468617420616C6C206368617261637465727320617265206F6620746865';
wwv_flow_imp.g_varchar2_table(11792) := '2073616D652077696474682E20546869732069732061206661737420616C676F726974686D207468617420776F726B7320636F72726563746C7920666F72206D6F6E6F737061636520666F6E747320616E64206365727461696E20736372697074732028';
wwv_flow_imp.g_varchar2_table(11793) := '6C696B65204C6174696E20636861726163746572732920776865726520676C7970687320617265206F6620657175616C2077696474682E22292C6228302C2244656C656761746573207772617070696E6720706F696E747320636F6D7075746174696F6E';
wwv_flow_imp.g_varchar2_table(11794) := '20746F207468652062726F777365722E2054686973206973206120736C6F7720616C676F726974686D2C2074686174206D6967687420636175736520667265657A657320666F72206C617267652066696C65732C2062757420697420776F726B7320636F';
wwv_flow_imp.g_varchar2_table(11795) := '72726563746C7920696E20616C6C2063617365732E22295D2C747970653A22737472696E67222C656E756D3A5B2273696D706C65222C22616476616E636564225D2C64656661756C743A2273696D706C65222C6465736372697074696F6E3A6228302C22';
wwv_flow_imp.g_varchar2_table(11796) := '436F6E74726F6C732074686520616C676F726974686D207468617420636F6D7075746573207772617070696E6720706F696E74732E204E6F74652074686174207768656E20696E206163636573736962696C697479206D6F64652C20616476616E636564';
wwv_flow_imp.g_varchar2_table(11797) := '2077696C6C206265207573656420666F7220746865206265737420657870657269656E63652E22297D7D297D76616C69646174652865297B72657475726E204C4C28652C2273696D706C65222C5B2273696D706C65222C22616476616E636564225D297D';
wwv_flow_imp.g_varchar2_table(11798) := '636F6D7075746528652C742C6E297B72657475726E20323D3D3D742E6765742832293F22616476616E636564223A6E7D7D297D2C5A4C3D4F626A6563742E667265657A65287B69643A22656469746F72222C6F726465723A352C747970653A226F626A65';
wwv_flow_imp.g_varchar2_table(11799) := '6374222C7469746C653A6228302C22456469746F7222292C73636F70653A357D292C584C3D7B2E2E2E5A4C2C70726F706572746965733A7B22656469746F722E74616253697A65223A7B747970653A226E756D626572222C64656661756C743A45752E74';
wwv_flow_imp.g_varchar2_table(11800) := '616253697A652C6D696E696D756D3A312C6D61726B646F776E4465736372697074696F6E3A6228302C22546865206E756D626572206F662073706163657320612074616220697320657175616C20746F2E20546869732073657474696E67206973206F76';
wwv_flow_imp.g_varchar2_table(11801) := '657272696464656E206261736564206F6E207468652066696C6520636F6E74656E7473207768656E207B307D206973206F6E2E222C226023656469746F722E646574656374496E64656E746174696F6E236022297D2C22656469746F722E696E64656E74';
wwv_flow_imp.g_varchar2_table(11802) := '53697A65223A7B616E794F663A5B7B747970653A22737472696E67222C656E756D3A5B2274616253697A65225D7D2C7B747970653A226E756D626572222C6D696E696D756D3A317D5D2C64656661756C743A2274616253697A65222C6D61726B646F776E';
wwv_flow_imp.g_varchar2_table(11803) := '4465736372697074696F6E3A6228302C27546865206E756D626572206F6620737061636573207573656420666F7220696E64656E746174696F6E206F7220602274616253697A65226020746F20757365207468652076616C75652066726F6D2060236564';
wwv_flow_imp.g_varchar2_table(11804) := '69746F722E74616253697A6523602E20546869732073657474696E67206973206F76657272696464656E206261736564206F6E207468652066696C6520636F6E74656E7473207768656E206023656469746F722E646574656374496E64656E746174696F';
wwv_flow_imp.g_varchar2_table(11805) := '6E2360206973206F6E2E27297D2C22656469746F722E696E73657274537061636573223A7B747970653A22626F6F6C65616E222C64656661756C743A45752E696E736572745370616365732C6D61726B646F776E4465736372697074696F6E3A6228302C';
wwv_flow_imp.g_varchar2_table(11806) := '22496E7365727420737061636573207768656E207072657373696E672060546162602E20546869732073657474696E67206973206F76657272696464656E206261736564206F6E207468652066696C6520636F6E74656E7473207768656E207B307D2069';
wwv_flow_imp.g_varchar2_table(11807) := '73206F6E2E222C226023656469746F722E646574656374496E64656E746174696F6E236022297D2C22656469746F722E646574656374496E64656E746174696F6E223A7B747970653A22626F6F6C65616E222C64656661756C743A45752E646574656374';
wwv_flow_imp.g_varchar2_table(11808) := '496E64656E746174696F6E2C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572207B307D20616E64207B317D2077696C6C206265206175746F6D61746963616C6C7920646574656374656420776865';
wwv_flow_imp.g_varchar2_table(11809) := '6E20612066696C65206973206F70656E6564206261736564206F6E207468652066696C6520636F6E74656E74732E222C226023656469746F722E74616253697A652360222C226023656469746F722E696E73657274537061636573236022297D2C226564';
wwv_flow_imp.g_varchar2_table(11810) := '69746F722E7472696D4175746F57686974657370616365223A7B747970653A22626F6F6C65616E222C64656661756C743A45752E7472696D4175746F576869746573706163652C6465736372697074696F6E3A6228302C2252656D6F766520747261696C';
wwv_flow_imp.g_varchar2_table(11811) := '696E67206175746F20696E73657274656420776869746573706163652E22297D2C22656469746F722E6C6172676546696C654F7074696D697A6174696F6E73223A7B747970653A22626F6F6C65616E222C64656661756C743A45752E6C6172676546696C';
wwv_flow_imp.g_varchar2_table(11812) := '654F7074696D697A6174696F6E732C6465736372697074696F6E3A6228302C225370656369616C2068616E646C696E6720666F72206C617267652066696C657320746F2064697361626C65206365727461696E206D656D6F727920696E74656E73697665';
wwv_flow_imp.g_varchar2_table(11813) := '2066656174757265732E22297D2C22656469746F722E776F7264426173656453756767657374696F6E73223A7B656E756D3A5B226F6666222C2263757272656E74446F63756D656E74222C226D61746368696E67446F63756D656E7473222C22616C6C44';
wwv_flow_imp.g_varchar2_table(11814) := '6F63756D656E7473225D2C64656661756C743A226D61746368696E67446F63756D656E7473222C656E756D4465736372697074696F6E733A5B6228302C225475726E206F666620576F72642042617365642053756767657374696F6E732E22292C622830';
wwv_flow_imp.g_varchar2_table(11815) := '2C224F6E6C79207375676765737420776F7264732066726F6D207468652061637469766520646F63756D656E742E22292C6228302C225375676765737420776F7264732066726F6D20616C6C206F70656E20646F63756D656E7473206F66207468652073';
wwv_flow_imp.g_varchar2_table(11816) := '616D65206C616E67756167652E22292C6228302C225375676765737420776F7264732066726F6D20616C6C206F70656E20646F63756D656E74732E22295D2C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220636F6D';
wwv_flow_imp.g_varchar2_table(11817) := '706C6574696F6E732073686F756C6420626520636F6D7075746564206261736564206F6E20776F72647320696E2074686520646F63756D656E7420616E642066726F6D20776869636820646F63756D656E747320746865792061726520636F6D70757465';
wwv_flow_imp.g_varchar2_table(11818) := '642E22297D2C22656469746F722E73656D616E746963486967686C69676874696E672E656E61626C6564223A7B656E756D3A5B21302C21312C22636F6E6669677572656442795468656D65225D2C656E756D4465736372697074696F6E733A5B6228302C';
wwv_flow_imp.g_varchar2_table(11819) := '2253656D616E74696320686967686C69676874696E6720656E61626C656420666F7220616C6C20636F6C6F72207468656D65732E22292C6228302C2253656D616E74696320686967686C69676874696E672064697361626C656420666F7220616C6C2063';
wwv_flow_imp.g_varchar2_table(11820) := '6F6C6F72207468656D65732E22292C6228302C2253656D616E74696320686967686C69676874696E6720697320636F6E66696775726564206279207468652063757272656E7420636F6C6F72207468656D652773206073656D616E746963486967686C69';
wwv_flow_imp.g_varchar2_table(11821) := '676874696E67602073657474696E672E22295D2C64656661756C743A22636F6E6669677572656442795468656D65222C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572207468652073656D616E746963486967686C69';
wwv_flow_imp.g_varchar2_table(11822) := '676874696E672069732073686F776E20666F7220746865206C616E677561676573207468617420737570706F72742069742E22297D2C22656469746F722E737461626C655065656B223A7B747970653A22626F6F6C65616E222C64656661756C743A2131';
wwv_flow_imp.g_varchar2_table(11823) := '2C6D61726B646F776E4465736372697074696F6E3A6228302C224B656570207065656B20656469746F7273206F70656E206576656E207768656E20646F75626C652D636C69636B696E6720746865697220636F6E74656E74206F72207768656E20686974';
wwv_flow_imp.g_varchar2_table(11824) := '74696E672060457363617065602E22297D2C22656469746F722E6D6178546F6B656E697A6174696F6E4C696E654C656E677468223A7B747970653A22696E7465676572222C64656661756C743A3265342C6465736372697074696F6E3A6228302C224C69';
wwv_flow_imp.g_varchar2_table(11825) := '6E65732061626F76652074686973206C656E6774682077696C6C206E6F7420626520746F6B656E697A656420666F7220706572666F726D616E636520726561736F6E7322297D2C22656469746F722E6578706572696D656E74616C2E6173796E63546F6B';
wwv_flow_imp.g_varchar2_table(11826) := '656E697A6174696F6E223A7B747970653A22626F6F6C65616E222C64656661756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520746F6B656E697A6174696F6E2073686F756C642068617070';
wwv_flow_imp.g_varchar2_table(11827) := '656E206173796E6368726F6E6F75736C79206F6E20612077656220776F726B65722E22292C746167733A5B226578706572696D656E74616C225D7D2C22656469746F722E6578706572696D656E74616C2E6173796E63546F6B656E697A6174696F6E4C6F';
wwv_flow_imp.g_varchar2_table(11828) := '6767696E67223A7B747970653A22626F6F6C65616E222C64656661756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206173796E6320746F6B656E697A6174696F6E2073686F756C64206265206C6F67';
wwv_flow_imp.g_varchar2_table(11829) := '6765642E20466F7220646562756767696E67206F6E6C792E22297D2C22656469746F722E6578706572696D656E74616C2E6173796E63546F6B656E697A6174696F6E566572696669636174696F6E223A7B747970653A22626F6F6C65616E222C64656661';
wwv_flow_imp.g_varchar2_table(11830) := '756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206173796E6320746F6B656E697A6174696F6E2073686F756C6420626520766572696669656420616761696E7374206C6567616379206261636B6772';
wwv_flow_imp.g_varchar2_table(11831) := '6F756E6420746F6B656E697A6174696F6E2E204D6967687420736C6F7720646F776E20746F6B656E697A6174696F6E2E20466F7220646562756767696E67206F6E6C792E22292C746167733A5B226578706572696D656E74616C225D7D2C22656469746F';
wwv_flow_imp.g_varchar2_table(11832) := '722E6C616E67756167652E627261636B657473223A7B747970653A5B226172726179222C226E756C6C225D2C64656661756C743A6E756C6C2C6465736372697074696F6E3A6228302C22446566696E65732074686520627261636B65742073796D626F6C';
wwv_flow_imp.g_varchar2_table(11833) := '73207468617420696E637265617365206F722064656372656173652074686520696E64656E746174696F6E2E22292C6974656D733A7B747970653A226172726179222C6974656D733A5B7B747970653A22737472696E67222C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(11834) := '3A6228302C22546865206F70656E696E6720627261636B657420636861726163746572206F7220737472696E672073657175656E63652E22297D2C7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C2254686520636C6F7369';
wwv_flow_imp.g_varchar2_table(11835) := '6E6720627261636B657420636861726163746572206F7220737472696E672073657175656E63652E22297D5D7D7D2C22656469746F722E6C616E67756167652E636F6C6F72697A6564427261636B65745061697273223A7B747970653A5B226172726179';
wwv_flow_imp.g_varchar2_table(11836) := '222C226E756C6C225D2C64656661756C743A6E756C6C2C6465736372697074696F6E3A6228302C22446566696E65732074686520627261636B657420706169727320746861742061726520636F6C6F72697A6564206279207468656972206E657374696E';
wwv_flow_imp.g_varchar2_table(11837) := '67206C6576656C20696620627261636B6574207061697220636F6C6F72697A6174696F6E20697320656E61626C65642E22292C6974656D733A7B747970653A226172726179222C6974656D733A5B7B747970653A22737472696E67222C64657363726970';
wwv_flow_imp.g_varchar2_table(11838) := '74696F6E3A6228302C22546865206F70656E696E6720627261636B657420636861726163746572206F7220737472696E672073657175656E63652E22297D2C7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C225468652063';
wwv_flow_imp.g_varchar2_table(11839) := '6C6F73696E6720627261636B657420636861726163746572206F7220737472696E672073657175656E63652E22297D5D7D7D2C2264696666456469746F722E6D6178436F6D7075746174696F6E54696D65223A7B747970653A226E756D626572222C6465';
wwv_flow_imp.g_varchar2_table(11840) := '6661756C743A754C2E6D6178436F6D7075746174696F6E54696D652C6465736372697074696F6E3A6228302C2254696D656F757420696E206D696C6C697365636F6E6473206166746572207768696368206469666620636F6D7075746174696F6E206973';
wwv_flow_imp.g_varchar2_table(11841) := '2063616E63656C6C65642E20557365203020666F72206E6F2074696D656F75742E22297D2C2264696666456469746F722E6D617846696C6553697A65223A7B747970653A226E756D626572222C64656661756C743A754C2E6D617846696C6553697A652C';
wwv_flow_imp.g_varchar2_table(11842) := '6465736372697074696F6E3A6228302C224D6178696D756D2066696C652073697A6520696E204D4220666F7220776869636820746F20636F6D707574652064696666732E20557365203020666F72206E6F206C696D69742E22297D2C2264696666456469';
wwv_flow_imp.g_varchar2_table(11843) := '746F722E72656E64657253696465427953696465223A7B747970653A22626F6F6C65616E222C64656661756C743A754C2E72656E646572536964654279536964652C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220';
wwv_flow_imp.g_varchar2_table(11844) := '746865206469666620656469746F722073686F777320746865206469666620736964652062792073696465206F7220696E6C696E652E22297D2C2264696666456469746F722E72656E64657253696465427953696465496E6C696E65427265616B706F69';
wwv_flow_imp.g_varchar2_table(11845) := '6E74223A7B747970653A226E756D626572222C64656661756C743A754C2E72656E64657253696465427953696465496E6C696E65427265616B706F696E742C6465736372697074696F6E3A6228302C22496620746865206469666620656469746F722077';
wwv_flow_imp.g_varchar2_table(11846) := '6964746820697320736D616C6C6572207468616E20746869732076616C75652C2074686520696E6C696E65207669657720697320757365642E22297D2C2264696666456469746F722E757365496E6C696E65566965775768656E537061636549734C696D';
wwv_flow_imp.g_varchar2_table(11847) := '69746564223A7B747970653A22626F6F6C65616E222C64656661756C743A754C2E757365496E6C696E65566965775768656E537061636549734C696D697465642C6465736372697074696F6E3A6228302C22496620656E61626C656420616E6420746865';
wwv_flow_imp.g_varchar2_table(11848) := '20656469746F7220776964746820697320746F6F20736D616C6C2C2074686520696E6C696E65207669657720697320757365642E22297D2C2264696666456469746F722E72656E6465724D617267696E52657665727449636F6E223A7B747970653A2262';
wwv_flow_imp.g_varchar2_table(11849) := '6F6F6C65616E222C64656661756C743A754C2E72656E6465724D617267696E52657665727449636F6E2C6465736372697074696F6E3A6228302C225768656E20656E61626C65642C20746865206469666620656469746F722073686F7773206172726F77';
wwv_flow_imp.g_varchar2_table(11850) := '7320696E2069747320676C797068206D617267696E20746F20726576657274206368616E6765732E22297D2C2264696666456469746F722E72656E6465724775747465724D656E75223A7B747970653A22626F6F6C65616E222C64656661756C743A754C';
wwv_flow_imp.g_varchar2_table(11851) := '2E72656E6465724775747465724D656E752C6465736372697074696F6E3A6228302C225768656E20656E61626C65642C20746865206469666620656469746F722073686F77732061207370656369616C2067757474657220666F72207265766572742061';
wwv_flow_imp.g_varchar2_table(11852) := '6E6420737461676520616374696F6E732E22297D2C2264696666456469746F722E69676E6F72655472696D57686974657370616365223A7B747970653A22626F6F6C65616E222C64656661756C743A754C2E69676E6F72655472696D5768697465737061';
wwv_flow_imp.g_varchar2_table(11853) := '63652C6465736372697074696F6E3A6228302C225768656E20656E61626C65642C20746865206469666620656469746F722069676E6F726573206368616E67657320696E206C656164696E67206F7220747261696C696E6720776869746573706163652E';
wwv_flow_imp.g_varchar2_table(11854) := '22297D2C2264696666456469746F722E72656E646572496E64696361746F7273223A7B747970653A22626F6F6C65616E222C64656661756C743A754C2E72656E646572496E64696361746F72732C6465736372697074696F6E3A6228302C22436F6E7472';
wwv_flow_imp.g_varchar2_table(11855) := '6F6C73207768657468657220746865206469666620656469746F722073686F7773202B2F2D20696E64696361746F727320666F722061646465642F72656D6F766564206368616E6765732E22297D2C2264696666456469746F722E636F64654C656E7322';
wwv_flow_imp.g_varchar2_table(11856) := '3A7B747970653A22626F6F6C65616E222C64656661756C743A754C2E64696666436F64654C656E732C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520656469746F722073686F777320436F64654C656E73';
wwv_flow_imp.g_varchar2_table(11857) := '2E22297D2C2264696666456469746F722E776F726457726170223A7B747970653A22737472696E67222C656E756D3A5B226F6666222C226F6E222C22696E6865726974225D2C64656661756C743A754C2E64696666576F7264577261702C6D61726B646F';
wwv_flow_imp.g_varchar2_table(11858) := '776E456E756D4465736372697074696F6E733A5B6228302C224C696E65732077696C6C206E6576657220777261702E22292C6228302C224C696E65732077696C6C2077726170206174207468652076696577706F72742077696474682E22292C6228302C';
wwv_flow_imp.g_varchar2_table(11859) := '224C696E65732077696C6C2077726170206163636F7264696E6720746F20746865207B307D2073657474696E672E222C226023656469746F722E776F726457726170236022295D7D2C2264696666456469746F722E64696666416C676F726974686D223A';
wwv_flow_imp.g_varchar2_table(11860) := '7B747970653A22737472696E67222C656E756D3A5B226C6567616379222C22616476616E636564225D2C64656661756C743A754C2E64696666416C676F726974686D2C6D61726B646F776E456E756D4465736372697074696F6E733A5B6228302C225573';
wwv_flow_imp.g_varchar2_table(11861) := '657320746865206C65676163792064696666696E6720616C676F726974686D2E22292C6228302C22557365732074686520616476616E6365642064696666696E6720616C676F726974686D2E22295D2C746167733A5B226578706572696D656E74616C22';
wwv_flow_imp.g_varchar2_table(11862) := '5D7D2C2264696666456469746F722E68696465556E6368616E676564526567696F6E732E656E61626C6564223A7B747970653A22626F6F6C65616E222C64656661756C743A754C2E68696465556E6368616E676564526567696F6E732E656E61626C6564';
wwv_flow_imp.g_varchar2_table(11863) := '2C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746865206469666620656469746F722073686F777320756E6368616E67656420726567696F6E732E22297D2C2264696666456469746F722E68';
wwv_flow_imp.g_varchar2_table(11864) := '696465556E6368616E676564526567696F6E732E72657665616C4C696E65436F756E74223A7B747970653A22696E7465676572222C64656661756C743A754C2E68696465556E6368616E676564526567696F6E732E72657665616C4C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(11865) := '2C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320686F77206D616E79206C696E657320617265207573656420666F7220756E6368616E67656420726567696F6E732E22292C6D696E696D756D3A317D2C2264696666';
wwv_flow_imp.g_varchar2_table(11866) := '456469746F722E68696465556E6368616E676564526567696F6E732E6D696E696D756D4C696E65436F756E74223A7B747970653A22696E7465676572222C64656661756C743A754C2E68696465556E6368616E676564526567696F6E732E6D696E696D75';
wwv_flow_imp.g_varchar2_table(11867) := '6D4C696E65436F756E742C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320686F77206D616E79206C696E65732061726520757365642061732061206D696E696D756D20666F7220756E6368616E6765642072656769';
wwv_flow_imp.g_varchar2_table(11868) := '6F6E732E22292C6D696E696D756D3A317D2C2264696666456469746F722E68696465556E6368616E676564526567696F6E732E636F6E746578744C696E65436F756E74223A7B747970653A22696E7465676572222C64656661756C743A754C2E68696465';
wwv_flow_imp.g_varchar2_table(11869) := '556E6368616E676564526567696F6E732E636F6E746578744C696E65436F756E742C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320686F77206D616E79206C696E657320617265207573656420617320636F6E7465';
wwv_flow_imp.g_varchar2_table(11870) := '7874207768656E20636F6D706172696E6720756E6368616E67656420726567696F6E732E22292C6D696E696D756D3A317D2C2264696666456469746F722E6578706572696D656E74616C2E73686F774D6F766573223A7B747970653A22626F6F6C65616E';
wwv_flow_imp.g_varchar2_table(11871) := '222C64656661756C743A754C2E6578706572696D656E74616C2E73686F774D6F7665732C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746865206469666620656469746F722073686F756C64';
wwv_flow_imp.g_varchar2_table(11872) := '2073686F7720646574656374656420636F6465206D6F7665732E22297D2C2264696666456469746F722E6578706572696D656E74616C2E73686F77456D7074794465636F726174696F6E73223A7B747970653A22626F6F6C65616E222C64656661756C74';
wwv_flow_imp.g_varchar2_table(11873) := '3A754C2E6578706572696D656E74616C2E73686F77456D7074794465636F726174696F6E732C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220746865206469666620656469746F722073686F777320656D70747920';
wwv_flow_imp.g_varchar2_table(11874) := '6465636F726174696F6E7320746F20736565207768657265206368617261637465727320676F7420696E736572746564206F722064656C657465642E22297D7D7D3B666F7228636F6E73742065206F6620474C297B636F6E737420743D652E736368656D';
wwv_flow_imp.g_varchar2_table(11875) := '613B696628766F69642030213D3D7429696628766F69642030213D3D284A4C3D74292E747970657C7C766F69642030213D3D4A4C2E616E794F6629584C2E70726F706572746965735B60656469746F722E247B652E6E616D657D605D3D743B656C736520';
wwv_flow_imp.g_varchar2_table(11876) := '666F7228636F6E7374206520696E2074294F626A6563742E6861734F776E50726F70657274792E63616C6C28742C6529262628584C2E70726F706572746965735B655D3D745B655D297D766172204A4C3B6C65742065443D6E756C6C3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(11877) := '6E20744428297B72657475726E206E756C6C3D3D3D654426262865443D4F626A6563742E637265617465286E756C6C292C4F626A6563742E6B65797328584C2E70726F70657274696573292E666F72456163682828653D3E7B65445B655D3D21307D2929';
wwv_flow_imp.g_varchar2_table(11878) := '292C65447D766172206E443B79642E6173285470292E7265676973746572436F6E66696775726174696F6E28584C292C66756E6374696F6E2865297B655B652E49676E6F72653D305D3D2249676E6F7265222C655B652E496E666F3D315D3D22496E666F';
wwv_flow_imp.g_varchar2_table(11879) := '222C655B652E5761726E696E673D325D3D225761726E696E67222C655B652E4572726F723D335D3D224572726F72227D286E447C7C286E443D7B7D29292C66756E6374696F6E2865297B636F6E737420743D226572726F72222C6E3D227761726E696E67';
wwv_flow_imp.g_varchar2_table(11880) := '222C693D22696E666F223B652E66726F6D56616C75653D66756E6374696F6E286F297B72657475726E206F3F6B6928742C6F293F652E4572726F723A6B69286E2C6F297C7C6B6928227761726E222C6F293F652E5761726E696E673A6B6928692C6F293F';
wwv_flow_imp.g_varchar2_table(11881) := '652E496E666F3A652E49676E6F72653A652E49676E6F72657D2C652E746F537472696E673D66756E6374696F6E286F297B737769746368286F297B6361736520652E4572726F723A72657475726E20743B6361736520652E5761726E696E673A72657475';
wwv_flow_imp.g_varchar2_table(11882) := '726E206E3B6361736520652E496E666F3A72657475726E20693B64656661756C743A72657475726E2269676E6F7265227D7D7D286E447C7C286E443D7B7D29293B636F6E73742069443D6E443B766172206F443D69443B636F6E73742073443D70632822';
wwv_flow_imp.g_varchar2_table(11883) := '6E6F74696669636174696F6E5365727669636522292C72443D6E657720636C6173737B636F6E7374727563746F7228297B746869732E517569636B4669783D6E65772070782822717569636B66697822292C746869732E5265666163746F723D6E657720';
wwv_flow_imp.g_varchar2_table(11884) := '707828227265666163746F7222292C746869732E5265666163746F72457874726163743D746869732E5265666163746F722E617070656E6428226578747261637422292C746869732E5265666163746F72496E6C696E653D746869732E5265666163746F';
wwv_flow_imp.g_varchar2_table(11885) := '722E617070656E642822696E6C696E6522292C746869732E5265666163746F724D6F76653D746869732E5265666163746F722E617070656E6428226D6F766522292C746869732E5265666163746F72526577726974653D746869732E5265666163746F72';
wwv_flow_imp.g_varchar2_table(11886) := '2E617070656E6428227265777269746522292C746869732E4E6F7465626F6F6B3D6E657720707828226E6F7465626F6F6B22292C746869732E536F757263653D6E65772070782822736F7572636522292C746869732E536F757263654F7267616E697A65';
wwv_flow_imp.g_varchar2_table(11887) := '496D706F7274733D746869732E536F757263652E617070656E6428226F7267616E697A65496D706F72747322292C746869732E536F75726365466978416C6C3D746869732E536F757263652E617070656E642822666978416C6C22292C746869732E5375';
wwv_flow_imp.g_varchar2_table(11888) := '72726F756E64576974683D746869732E5265666163746F722E617070656E642822737572726F756E6422297D7D3B7661722061443B66756E6374696F6E206C4428652C742C6E297B72657475726E212821742E636F6E7461696E732865297C7C6E262674';
wwv_flow_imp.g_varchar2_table(11889) := '2E636F6E7461696E73286E29297D2166756E6374696F6E2865297B652E5265666163746F723D227265666163746F72222C652E5265666163746F72507265766965773D227265666163746F722070726576696577222C652E4C6967687462756C623D226C';
wwv_flow_imp.g_varchar2_table(11890) := '6967687462756C62222C652E44656661756C743D226F74686572202864656661756C7429222C652E536F75726365416374696F6E3D22736F7572636520616374696F6E222C652E517569636B4669783D22717569636B2066697820616374696F6E222C65';
wwv_flow_imp.g_varchar2_table(11891) := '2E466978416C6C3D2266697820616C6C222C652E4F7267616E697A65496D706F7274733D226F7267616E697A6520696D706F727473222C652E4175746F4669783D226175746F20666978222C652E517569636B466978486F7665723D22717569636B2066';
wwv_flow_imp.g_varchar2_table(11892) := '697820686F7665722077696E646F77222C652E4F6E536176653D2273617665207061727469636970616E7473222C652E50726F626C656D73566965773D2270726F626C656D732076696577227D2861447C7C2861443D7B7D29293B636C6173732063447B';
wwv_flow_imp.g_varchar2_table(11893) := '7374617469632066726F6D5573657228652C74297B72657475726E20652626226F626A656374223D3D747970656F6620653F6E65772063442863442E6765744B696E6446726F6D5573657228652C742E6B696E64292C63442E6765744170706C7946726F';
wwv_flow_imp.g_varchar2_table(11894) := '6D5573657228652C742E6170706C79292C63442E67657450726566657272656455736572286529293A6E657720634428742E6B696E642C742E6170706C792C2131297D737461746963206765744170706C7946726F6D5573657228652C74297B73776974';
wwv_flow_imp.g_varchar2_table(11895) := '63682822737472696E67223D3D747970656F6620652E6170706C793F652E6170706C792E746F4C6F7765724361736528293A2222297B63617365226669727374223A72657475726E226669727374223B63617365226E65766572223A72657475726E226E';
wwv_flow_imp.g_varchar2_table(11896) := '65766572223B6361736522696673696E676C65223A72657475726E22696653696E676C65223B64656661756C743A72657475726E20747D7D737461746963206765744B696E6446726F6D5573657228652C74297B72657475726E22737472696E67223D3D';
wwv_flow_imp.g_varchar2_table(11897) := '747970656F6620652E6B696E643F6E657720707828652E6B696E64293A747D73746174696320676574507265666572726564557365722865297B72657475726E22626F6F6C65616E223D3D747970656F6620652E7072656665727265642626652E707265';
wwv_flow_imp.g_varchar2_table(11898) := '6665727265647D636F6E7374727563746F7228652C742C6E297B746869732E6B696E643D652C746869732E6170706C793D742C746869732E7072656665727265643D6E7D7D636C6173732064447B636F6E7374727563746F7228652C742C6E297B746869';
wwv_flow_imp.g_varchar2_table(11899) := '732E616374696F6E3D652C746869732E70726F76696465723D742C746869732E686967686C6967687452616E67653D6E7D6173796E63207265736F6C76652865297B76617220743B696628286E756C6C3D3D3D28743D746869732E70726F766964657229';
wwv_flow_imp.g_varchar2_table(11900) := '7C7C766F696420303D3D3D743F766F696420303A742E7265736F6C7665436F6465416374696F6E29262621746869732E616374696F6E2E65646974297B6C657420743B7472797B743D617761697420746869732E70726F76696465722E7265736F6C7665';
wwv_flow_imp.g_varchar2_table(11901) := '436F6465416374696F6E28746869732E616374696F6E2C65297D63617463682865297B45652865297D74262628746869732E616374696F6E2E656469743D742E65646974297D72657475726E20746869737D7D636F6E73742068443D22656469746F722E';
wwv_flow_imp.g_varchar2_table(11902) := '616374696F6E2E636F6465416374696F6E222C75443D22656469746F722E616374696F6E2E717569636B466978222C70443D22656469746F722E616374696F6E2E6175746F466978222C67443D22656469746F722E616374696F6E2E7265666163746F72';
wwv_flow_imp.g_varchar2_table(11903) := '222C6D443D22656469746F722E616374696F6E2E736F75726365416374696F6E222C66443D22656469746F722E616374696F6E2E6F7267616E697A65496D706F727473222C76443D22656469746F722E616374696F6E2E666978416C6C223B636C617373';
wwv_flow_imp.g_varchar2_table(11904) := '20624420657874656E6473206C747B73746174696320636F6465416374696F6E73507265666572726564436F6D70617261746F7228652C74297B72657475726E20652E6973507265666572726564262621742E69735072656665727265643F2D313A2165';
wwv_flow_imp.g_varchar2_table(11905) := '2E69735072656665727265642626742E69735072656665727265643F313A307D73746174696320636F6465416374696F6E73436F6D70617261746F72287B616374696F6E3A657D2C7B616374696F6E3A747D297B72657475726E20652E69734149262621';
wwv_flow_imp.g_varchar2_table(11906) := '742E697341493F313A21652E697341492626742E697341493F2D313A6A6828652E646961676E6F7374696373293F6A6828742E646961676E6F7374696373293F62442E636F6465416374696F6E73507265666572726564436F6D70617261746F7228652C';
wwv_flow_imp.g_varchar2_table(11907) := '74293A2D313A6A6828742E646961676E6F7374696373293F313A62442E636F6465416374696F6E73507265666572726564436F6D70617261746F7228652C74297D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E646F63';
wwv_flow_imp.g_varchar2_table(11908) := '756D656E746174696F6E3D742C746869732E5F7265676973746572286E292C746869732E616C6C416374696F6E733D5B2E2E2E655D2E736F72742862442E636F6465416374696F6E73436F6D70617261746F72292C746869732E76616C6964416374696F';
wwv_flow_imp.g_varchar2_table(11909) := '6E733D746869732E616C6C416374696F6E732E66696C7465722828287B616374696F6E3A657D293D3E21652E64697361626C656429297D676574206861734175746F46697828297B72657475726E20746869732E76616C6964416374696F6E732E736F6D';
wwv_flow_imp.g_varchar2_table(11910) := '652828287B616374696F6E3A657D293D3E2121652E6B696E64262672442E517569636B4669782E636F6E7461696E73286E657720707828652E6B696E64292926262121652E697350726566657272656429297D67657420686173414946697828297B7265';
wwv_flow_imp.g_varchar2_table(11911) := '7475726E20746869732E76616C6964416374696F6E732E736F6D652828287B616374696F6E3A657D293D3E2121652E6973414929297D67657420616C6C4149466978657328297B72657475726E20746869732E76616C6964416374696F6E732E65766572';
wwv_flow_imp.g_varchar2_table(11912) := '792828287B616374696F6E3A657D293D3E2121652E6973414929297D7D636F6E7374205F443D7B616374696F6E733A5B5D2C646F63756D656E746174696F6E3A766F696420307D3B6173796E632066756E6374696F6E20794428652C742C6E2C692C6F2C';
wwv_flow_imp.g_varchar2_table(11913) := '73297B76617220723B636F6E737420613D692E66696C7465727C7C7B7D2C6C3D7B2E2E2E612C6578636C756465733A5B2E2E2E612E6578636C756465737C7C5B5D2C72442E4E6F7465626F6F6B5D7D2C633D7B6F6E6C793A6E756C6C3D3D3D28723D612E';
wwv_flow_imp.g_varchar2_table(11914) := '696E636C756465297C7C766F696420303D3D3D723F766F696420303A722E76616C75652C747269676765723A692E747970657D2C643D6E657720686B28742C73292C683D323D3D3D692E747970652C753D66756E6374696F6E28652C742C6E297B726574';
wwv_flow_imp.g_varchar2_table(11915) := '75726E20652E616C6C2874292E66696C7465722828653D3E21652E70726F7669646564436F6465416374696F6E4B696E64737C7C652E70726F7669646564436F6465416374696F6E4B696E64732E736F6D652828653D3E66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(11916) := '7B72657475726E2128652E696E636C756465262621652E696E636C7564652E696E74657273656374732874297C7C652E6578636C756465732626652E6578636C756465732E736F6D6528286E3D3E6C4428742C6E2C652E696E636C7564652929297C7C21';
wwv_flow_imp.g_varchar2_table(11917) := '652E696E636C756465536F75726365416374696F6E73262672442E536F757263652E636F6E7461696E73287429297D286E2C6E657720707828652929292929297D28652C742C683F6C3A61292C703D6E65772061742C673D752E6D617028286173796E63';
wwv_flow_imp.g_varchar2_table(11918) := '20653D3E7B7472797B6F2E7265706F72742865293B636F6E737420693D617761697420652E70726F76696465436F6465416374696F6E7328742C6E2C632C642E746F6B656E293B696628692626702E6164642869292C642E746F6B656E2E697343616E63';
wwv_flow_imp.g_varchar2_table(11919) := '656C6C6174696F6E5265717565737465642972657475726E205F443B636F6E737420733D28286E756C6C3D3D693F766F696420303A692E616374696F6E73297C7C5B5D292E66696C7465722828653D3E65262666756E6374696F6E28652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(11920) := '7374206E3D742E6B696E643F6E657720707828742E6B696E64293A766F696420303B72657475726E2128212821652E696E636C7564657C7C6E2626652E696E636C7564652E636F6E7461696E73286E29297C7C652E6578636C7564657326266E2626652E';
wwv_flow_imp.g_varchar2_table(11921) := '6578636C756465732E736F6D652828743D3E6C44286E2C742C652E696E636C7564652929297C7C21652E696E636C756465536F75726365416374696F6E7326266E262672442E536F757263652E636F6E7461696E73286E297C7C652E6F6E6C79496E636C';
wwv_flow_imp.g_varchar2_table(11922) := '756465507265666572726564416374696F6E73262621742E6973507265666572726564297D28612C652929292C723D66756E6374696F6E28652C742C6E297B69662821652E646F63756D656E746174696F6E2972657475726E3B636F6E737420693D652E';
wwv_flow_imp.g_varchar2_table(11923) := '646F63756D656E746174696F6E2E6D61702828653D3E287B6B696E643A6E657720707828652E6B696E64292C636F6D6D616E643A652E636F6D6D616E647D2929293B6966286E297B6C657420653B666F7228636F6E73742074206F66206929742E6B696E';
wwv_flow_imp.g_varchar2_table(11924) := '642E636F6E7461696E73286E29262628653F652E6B696E642E636F6E7461696E7328742E6B696E6429262628653D74293A653D74293B696628652972657475726E206E756C6C3D3D653F766F696420303A652E636F6D6D616E647D666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(11925) := '2065206F66207429696628652E6B696E6429666F7228636F6E73742074206F66206929696628742E6B696E642E636F6E7461696E73286E657720707828652E6B696E6429292972657475726E20742E636F6D6D616E647D28652C732C612E696E636C7564';
wwv_flow_imp.g_varchar2_table(11926) := '65293B72657475726E7B616374696F6E733A732E6D61702828743D3E6E657720644428742C652929292C646F63756D656E746174696F6E3A727D7D63617463682865297B6966285465286529297468726F7720653B72657475726E2045652865292C5F44';
wwv_flow_imp.g_varchar2_table(11927) := '7D7D29292C6D3D652E6F6E4469644368616E6765282828293D3E7B506828652E616C6C2874292C75297C7C642E63616E63656C28297D29293B7472797B636F6E7374206E3D61776169742050726F6D6973652E616C6C2867292C6F3D6E2E6D6170282865';
wwv_flow_imp.g_varchar2_table(11928) := '3D3E652E616374696F6E7329292E666C617428292C733D5B2E2E2E7A68286E2E6D61702828653D3E652E646F63756D656E746174696F6E2929292C2E2E2E774428652C742C692C6F295D3B72657475726E206E6577206244286F2C732C70297D66696E61';
wwv_flow_imp.g_varchar2_table(11929) := '6C6C797B6D2E646973706F736528292C642E646973706F736528297D7D66756E6374696F6E2A774428652C742C6E2C69297B766172206F2C732C723B696628742626692E6C656E67746829666F7228636F6E73742061206F6620652E616C6C2874292961';
wwv_flow_imp.g_varchar2_table(11930) := '2E5F6765744164646974696F6E616C4D656E754974656D732626287969656C642A6E756C6C3D3D3D286F3D612E5F6765744164646974696F6E616C4D656E754974656D73297C7C766F696420303D3D3D6F3F766F696420303A6F2E63616C6C28612C7B74';
wwv_flow_imp.g_varchar2_table(11931) := '7269676765723A6E2E747970652C6F6E6C793A6E756C6C3D3D3D28723D6E756C6C3D3D3D28733D6E2E66696C746572297C7C766F696420303D3D3D733F766F696420303A732E696E636C756465297C7C766F696420303D3D3D723F766F696420303A722E';
wwv_flow_imp.g_varchar2_table(11932) := '76616C75657D2C692E6D61702828653D3E652E616374696F6E292929297D7661722043443B6173796E632066756E6374696F6E20534428652C742C6E2C692C6F3D4D742E4E6F6E65297B76617220733B636F6E737420723D652E676574287978292C613D';
wwv_flow_imp.g_varchar2_table(11933) := '652E676574287863292C6C3D652E676574284F64292C633D652E676574287344293B6966286C2E7075626C69634C6F67322822636F6465416374696F6E2E6170706C79436F6465416374696F6E222C7B636F6465416374696F6E5469746C653A742E6163';
wwv_flow_imp.g_varchar2_table(11934) := '74696F6E2E7469746C652C636F6465416374696F6E4B696E643A742E616374696F6E2E6B696E642C636F6465416374696F6E49735072656665727265643A2121742E616374696F6E2E69735072656665727265642C726561736F6E3A6E7D292C61776169';
wwv_flow_imp.g_varchar2_table(11935) := '7420742E7265736F6C7665286F292C216F2E697343616E63656C6C6174696F6E526571756573746564297B696628286E756C6C3D3D3D28733D742E616374696F6E2E65646974297C7C766F696420303D3D3D733F766F696420303A732E65646974732E6C';
wwv_flow_imp.g_varchar2_table(11936) := '656E6774682926262128617761697420722E6170706C7928742E616374696F6E2E656469742C7B656469746F723A6E756C6C3D3D693F766F696420303A692E656469746F722C6C6162656C3A742E616374696F6E2E7469746C652C71756F7461626C654C';
wwv_flow_imp.g_varchar2_table(11937) := '6162656C3A742E616374696F6E2E7469746C652C636F64653A22756E646F7265646F2E636F6465416374696F6E222C726573706563744175746F53617665436F6E6669673A6E213D3D43442E4F6E536176652C73686F77507265766965773A6E756C6C3D';
wwv_flow_imp.g_varchar2_table(11938) := '3D693F766F696420303A692E707265766965777D29292E69734170706C6965642972657475726E3B696628742E616374696F6E2E636F6D6D616E64297472797B617761697420612E65786563757465436F6D6D616E6428742E616374696F6E2E636F6D6D';
wwv_flow_imp.g_varchar2_table(11939) := '616E642E69642C2E2E2E742E616374696F6E2E636F6D6D616E642E617267756D656E74737C7C5B5D297D63617463682865297B636F6E737420743D66756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620653F653A6520';
wwv_flow_imp.g_varchar2_table(11940) := '696E7374616E63656F66204572726F72262622737472696E67223D3D747970656F6620652E6D6573736167653F652E6D6573736167653A766F696420307D2865293B632E6572726F722822737472696E67223D3D747970656F6620743F743A6228302C22';
wwv_flow_imp.g_varchar2_table(11941) := '416E20756E6B6E6F776E206572726F72206F63637572726564207768696C65206170706C79696E672074686520636F646520616374696F6E2229297D7D7D2166756E6374696F6E2865297B652E4F6E536176653D226F6E53617665222C652E46726F6D50';
wwv_flow_imp.g_varchar2_table(11942) := '726F626C656D73566965773D2266726F6D50726F626C656D7356696577222C652E46726F6D436F6465416374696F6E733D2266726F6D436F6465416374696F6E73222C652E46726F6D41494C6967687462756C623D2266726F6D41494C6967687462756C';
wwv_flow_imp.g_varchar2_table(11943) := '62227D2843447C7C2843443D7B7D29292C6B632E7265676973746572436F6D6D616E6428225F65786563757465436F6465416374696F6E50726F7669646572222C286173796E632066756E6374696F6E28652C742C6E2C692C6F297B6966282128742069';
wwv_flow_imp.g_varchar2_table(11944) := '6E7374616E63656F66204E6F29297468726F77204D6528293B636F6E73747B636F6465416374696F6E50726F76696465723A737D3D652E676574287878292C723D652E676574286663292E6765744D6F64656C2874293B6966282172297468726F77204D';
wwv_flow_imp.g_varchar2_table(11945) := '6528293B636F6E737420613D61682E69734953656C656374696F6E286E293F61682E6C69667453656C656374696F6E286E293A72682E69734952616E6765286E293F722E76616C696461746552616E6765286E293A766F696420303B6966282161297468';
wwv_flow_imp.g_varchar2_table(11946) := '726F77204D6528293B636F6E7374206C3D22737472696E67223D3D747970656F6620693F6E65772070782869293A766F696420302C633D617761697420794428732C722C612C7B747970653A312C74726967676572416374696F6E3A61442E4465666175';
wwv_flow_imp.g_varchar2_table(11947) := '6C742C66696C7465723A7B696E636C756465536F75726365416374696F6E733A21302C696E636C7564653A6C7D7D2C43452E4E6F6E652C4D742E4E6F6E65292C643D5B5D2C683D4D6174682E6D696E28632E76616C6964416374696F6E732E6C656E6774';
wwv_flow_imp.g_varchar2_table(11948) := '682C226E756D626572223D3D747970656F66206F3F6F3A30293B666F72286C657420653D303B653C683B652B2B29642E7075736828632E76616C6964416374696F6E735B655D2E7265736F6C7665284D742E4E6F6E6529293B7472797B72657475726E20';
wwv_flow_imp.g_varchar2_table(11949) := '61776169742050726F6D6973652E616C6C2864292C632E76616C6964416374696F6E732E6D61702828653D3E652E616374696F6E29297D66696E616C6C797B73657454696D656F7574282828293D3E632E646973706F73652829292C313030297D7D2929';
wwv_flow_imp.g_varchar2_table(11950) := '3B7661722078443B6C6574206B443D78443D636C6173737B636F6E7374727563746F722865297B746869732E6B657962696E64696E67536572766963653D657D6765745265736F6C76657228297B636F6E737420653D6E6577206969282828293D3E7468';
wwv_flow_imp.g_varchar2_table(11951) := '69732E6B657962696E64696E67536572766963652E6765744B657962696E64696E677328292E66696C7465722828653D3E78442E636F6465416374696F6E436F6D6D616E64732E696E6465784F6628652E636F6D6D616E64293E3D3029292E66696C7465';
wwv_flow_imp.g_varchar2_table(11952) := '722828653D3E652E7265736F6C7665644B657962696E64696E6729292E6D61702828653D3E7B6C657420743D652E636F6D6D616E64417267733B72657475726E20652E636F6D6D616E643D3D3D66443F743D7B6B696E643A72442E536F757263654F7267';
wwv_flow_imp.g_varchar2_table(11953) := '616E697A65496D706F7274732E76616C75657D3A652E636F6D6D616E643D3D3D7644262628743D7B6B696E643A72442E536F75726365466978416C6C2E76616C75657D292C7B7265736F6C7665644B657962696E64696E673A652E7265736F6C7665644B';
wwv_flow_imp.g_varchar2_table(11954) := '657962696E64696E672C2E2E2E63442E66726F6D5573657228742C7B6B696E643A70782E4E6F6E652C6170706C793A226E65766572227D297D7D292929293B72657475726E20743D3E7B696628742E6B696E64297B636F6E7374206E3D746869732E6265';
wwv_flow_imp.g_varchar2_table(11955) := '73744B657962696E64696E67466F72436F6465416374696F6E28742C652E76616C7565293B72657475726E206E756C6C3D3D6E3F766F696420303A6E2E7265736F6C7665644B657962696E64696E677D7D7D626573744B657962696E64696E67466F7243';
wwv_flow_imp.g_varchar2_table(11956) := '6F6465416374696F6E28652C74297B69662821652E6B696E642972657475726E3B636F6E7374206E3D6E657720707828652E6B696E64293B72657475726E20742E66696C7465722828653D3E652E6B696E642E636F6E7461696E73286E2929292E66696C';
wwv_flow_imp.g_varchar2_table(11957) := '7465722828743D3E21742E7072656665727265647C7C652E697350726566657272656429292E7265647563655269676874282828652C74293D3E653F652E6B696E642E636F6E7461696E7328742E6B696E64293F743A653A74292C766F69642030297D7D';
wwv_flow_imp.g_varchar2_table(11958) := '3B6B442E636F6465416374696F6E436F6D6D616E64733D5B67442C68442C6D442C66442C76445D2C6B443D78443D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C';
wwv_flow_imp.g_varchar2_table(11959) := '6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C65';
wwv_flow_imp.g_varchar2_table(11960) := '63742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E';
wwv_flow_imp.g_varchar2_table(11961) := '333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(11962) := '286E2C69297B74286E2C692C65297D7D28302C2445295D2C6B44293B7661722045443D6E2832313731292C4C443D7B7D3B4C442E7374796C655461675472616E73666F726D3D6A7228292C4C442E736574417474726962757465733D567228292C4C442E';
wwv_flow_imp.g_varchar2_table(11963) := '696E736572743D467228292E62696E64286E756C6C2C226865616422292C4C442E646F6D4150493D4F7228292C4C442E696E736572745374796C65456C656D656E743D487228292C4E7228292845442E412C4C44292C45442E41262645442E412E6C6F63';
wwv_flow_imp.g_varchar2_table(11964) := '616C73262645442E412E6C6F63616C733B7661722044443D6E2838333333292C54443D7B7D3B54442E7374796C655461675472616E73666F726D3D6A7228292C54442E736574417474726962757465733D567228292C54442E696E736572743D46722829';
wwv_flow_imp.g_varchar2_table(11965) := '2E62696E64286E756C6C2C226865616422292C54442E646F6D4150493D4F7228292C54442E696E736572745374796C65456C656D656E743D487228292C4E7228292844442E412C5444292C44442E41262644442E412E6C6F63616C73262644442E412E6C';
wwv_flow_imp.g_varchar2_table(11966) := '6F63616C733B7661722049443D6E2831303239292C4D443D7B7D3B4D442E7374796C655461675472616E73666F726D3D6A7228292C4D442E736574417474726962757465733D567228292C4D442E696E736572743D467228292E62696E64286E756C6C2C';
wwv_flow_imp.g_varchar2_table(11967) := '226865616422292C4D442E646F6D4150493D4F7228292C4D442E696E736572745374796C65456C656D656E743D487228292C4E7228292849442E412C4D44292C49442E41262649442E412E6C6F63616C73262649442E412E6C6F63616C732C4C6D282273';
wwv_flow_imp.g_varchar2_table(11968) := '796D626F6C49636F6E2E6172726179466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220617272';
wwv_flow_imp.g_varchar2_table(11969) := '61792073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E62';
wwv_flow_imp.g_varchar2_table(11970) := '6F6F6C65616E466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220626F6F6C65616E2073796D62';
wwv_flow_imp.g_varchar2_table(11971) := '6F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E636C617373466F72';
wwv_flow_imp.g_varchar2_table(11972) := '6567726F756E64222C7B6461726B3A2223454539443238222C6C696768743A2223443637453030222C68634461726B3A2223454539443238222C68634C696768743A2223443637453030227D2C6228302C2254686520666F726567726F756E6420636F6C';
wwv_flow_imp.g_varchar2_table(11973) := '6F7220666F7220636C6173732073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D28227379';
wwv_flow_imp.g_varchar2_table(11974) := '6D626F6C49636F6E2E636F6C6F72466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220636F6C6F';
wwv_flow_imp.g_varchar2_table(11975) := '722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E636F';
wwv_flow_imp.g_varchar2_table(11976) := '6E7374616E74466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220636F6E7374616E742073796D';
wwv_flow_imp.g_varchar2_table(11977) := '626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E636F6E73747275';
wwv_flow_imp.g_varchar2_table(11978) := '63746F72466F726567726F756E64222C7B6461726B3A2223423138304437222C6C696768743A2223363532443930222C68634461726B3A2223423138304437222C68634C696768743A2223363532443930227D2C6228302C2254686520666F726567726F';
wwv_flow_imp.g_varchar2_table(11979) := '756E6420636F6C6F7220666F7220636F6E7374727563746F722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E6420737567676573742077696467';
wwv_flow_imp.g_varchar2_table(11980) := '65742E2229292C4C6D282273796D626F6C49636F6E2E656E756D657261746F72466F726567726F756E64222C7B6461726B3A2223454539443238222C6C696768743A2223443637453030222C68634461726B3A2223454539443238222C68634C69676874';
wwv_flow_imp.g_varchar2_table(11981) := '3A2223443637453030227D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220656E756D657261746F722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062';
wwv_flow_imp.g_varchar2_table(11982) := '726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E656E756D657261746F724D656D626572466F726567726F756E64222C7B6461726B3A2223373542454646222C6C696768743A22';
wwv_flow_imp.g_varchar2_table(11983) := '23303037414343222C68634461726B3A2223373542454646222C68634C696768743A2223303037414343227D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220656E756D657261746F72206D656D6265722073796D626F6C73';
wwv_flow_imp.g_varchar2_table(11984) := '2E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6576656E74466F72656772';
wwv_flow_imp.g_varchar2_table(11985) := '6F756E64222C7B6461726B3A2223454539443238222C6C696768743A2223443637453030222C68634461726B3A2223454539443238222C68634C696768743A2223443637453030227D2C6228302C2254686520666F726567726F756E6420636F6C6F7220';
wwv_flow_imp.g_varchar2_table(11986) := '666F72206576656E742073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F';
wwv_flow_imp.g_varchar2_table(11987) := '6C49636F6E2E6669656C64466F726567726F756E64222C7B6461726B3A2223373542454646222C6C696768743A2223303037414343222C68634461726B3A2223373542454646222C68634C696768743A2223303037414343227D2C6228302C2254686520';
wwv_flow_imp.g_varchar2_table(11988) := '666F726567726F756E6420636F6C6F7220666F72206669656C642073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E64207375676765737420776964';
wwv_flow_imp.g_varchar2_table(11989) := '6765742E2229292C4C6D282273796D626F6C49636F6E2E66696C65466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E642063';
wwv_flow_imp.g_varchar2_table(11990) := '6F6C6F7220666F722066696C652073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273';
wwv_flow_imp.g_varchar2_table(11991) := '796D626F6C49636F6E2E666F6C646572466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220666F';
wwv_flow_imp.g_varchar2_table(11992) := '6C6465722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E';
wwv_flow_imp.g_varchar2_table(11993) := '2E66756E6374696F6E466F726567726F756E64222C7B6461726B3A2223423138304437222C6C696768743A2223363532443930222C68634461726B3A2223423138304437222C68634C696768743A2223363532443930227D2C6228302C2254686520666F';
wwv_flow_imp.g_varchar2_table(11994) := '726567726F756E6420636F6C6F7220666F722066756E6374696F6E2073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769';
wwv_flow_imp.g_varchar2_table(11995) := '646765742E2229292C4C6D282273796D626F6C49636F6E2E696E74657266616365466F726567726F756E64222C7B6461726B3A2223373542454646222C6C696768743A2223303037414343222C68634461726B3A2223373542454646222C68634C696768';
wwv_flow_imp.g_varchar2_table(11996) := '743A2223303037414343227D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220696E746572666163652073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062';
wwv_flow_imp.g_varchar2_table(11997) := '726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6B6579466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A';
wwv_flow_imp.g_varchar2_table(11998) := '466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72206B65792073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E6420';
wwv_flow_imp.g_varchar2_table(11999) := '73756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6B6579776F7264466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C225468';
wwv_flow_imp.g_varchar2_table(12000) := '6520666F726567726F756E6420636F6C6F7220666F72206B6579776F72642073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(12001) := '207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6D6574686F64466F726567726F756E64222C7B6461726B3A2223423138304437222C6C696768743A2223363532443930222C68634461726B3A2223423138304437222C68634C696768';
wwv_flow_imp.g_varchar2_table(12002) := '743A2223363532443930227D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72206D6574686F642073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561';
wwv_flow_imp.g_varchar2_table(12003) := '646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6D6F64756C65466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A';
wwv_flow_imp.g_varchar2_table(12004) := '466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72206D6F64756C652073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C2061';
wwv_flow_imp.g_varchar2_table(12005) := '6E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6E616D657370616365466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228';
wwv_flow_imp.g_varchar2_table(12006) := '302C2254686520666F726567726F756E6420636F6C6F7220666F72206E616D6573706163652073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E6420';
wwv_flow_imp.g_varchar2_table(12007) := '73756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E6E756C6C466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C225468652066';
wwv_flow_imp.g_varchar2_table(12008) := '6F726567726F756E6420636F6C6F7220666F72206E756C6C2073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765';
wwv_flow_imp.g_varchar2_table(12009) := '742E2229292C4C6D282273796D626F6C49636F6E2E6E756D626572466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E642063';
wwv_flow_imp.g_varchar2_table(12010) := '6F6C6F7220666F72206E756D6265722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D28';
wwv_flow_imp.g_varchar2_table(12011) := '2273796D626F6C49636F6E2E6F626A656374466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220';
wwv_flow_imp.g_varchar2_table(12012) := '6F626A6563742073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C4963';
wwv_flow_imp.g_varchar2_table(12013) := '6F6E2E6F70657261746F72466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72206F70657261746F';
wwv_flow_imp.g_varchar2_table(12014) := '722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E7061';
wwv_flow_imp.g_varchar2_table(12015) := '636B616765466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72207061636B6167652073796D626F';
wwv_flow_imp.g_varchar2_table(12016) := '6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E70726F706572747946';
wwv_flow_imp.g_varchar2_table(12017) := '6F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F722070726F70657274792073796D626F6C732E2054';
wwv_flow_imp.g_varchar2_table(12018) := '686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E7265666572656E6365466F726567';
wwv_flow_imp.g_varchar2_table(12019) := '726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72207265666572656E63652073796D626F6C732E2054686573';
wwv_flow_imp.g_varchar2_table(12020) := '652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E736E6970706574466F726567726F756E64';
wwv_flow_imp.g_varchar2_table(12021) := '222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220736E69707065742073796D626F6C732E2054686573652073796D626F';
wwv_flow_imp.g_varchar2_table(12022) := '6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E737472696E67466F726567726F756E64222C7B6461726B3A';
wwv_flow_imp.g_varchar2_table(12023) := '466D2C6C696768743A466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220737472696E672073796D626F6C732E2054686573652073796D626F6C7320617070656172';
wwv_flow_imp.g_varchar2_table(12024) := '20696E20746865206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E737472756374466F726567726F756E64222C7B6461726B3A466D2C6C696768743A';
wwv_flow_imp.g_varchar2_table(12025) := '466D2C68634461726B3A466D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72207374727563742073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F';
wwv_flow_imp.g_varchar2_table(12026) := '75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E74657874466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A46';
wwv_flow_imp.g_varchar2_table(12027) := '6D2C68634C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220746578742073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C206272656164';
wwv_flow_imp.g_varchar2_table(12028) := '6372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E74797065506172616D65746572466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C6863';
wwv_flow_imp.g_varchar2_table(12029) := '4C696768743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72207479706520706172616D657465722073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C';
wwv_flow_imp.g_varchar2_table(12030) := '2062726561646372756D622C20616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E756E6974466F726567726F756E64222C7B6461726B3A466D2C6C696768743A466D2C68634461726B3A466D2C68634C6967';
wwv_flow_imp.g_varchar2_table(12031) := '68743A466D7D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F7220756E69742073796D626F6C732E2054686573652073796D626F6C732061707065617220696E20746865206F75746C696E652C2062726561646372756D622C20';
wwv_flow_imp.g_varchar2_table(12032) := '616E642073756767657374207769646765742E2229292C4C6D282273796D626F6C49636F6E2E7661726961626C65466F726567726F756E64222C7B6461726B3A2223373542454646222C6C696768743A2223303037414343222C68634461726B3A222337';
wwv_flow_imp.g_varchar2_table(12033) := '3542454646222C68634C696768743A2223303037414343227D2C6228302C2254686520666F726567726F756E6420636F6C6F7220666F72207661726961626C652073796D626F6C732E2054686573652073796D626F6C732061707065617220696E207468';
wwv_flow_imp.g_varchar2_table(12034) := '65206F75746C696E652C2062726561646372756D622C20616E642073756767657374207769646765742E2229293B636F6E73742041443D4F626A6563742E667265657A65287B6B696E643A70782E456D7074792C7469746C653A6228302C224D6F726520';
wwv_flow_imp.g_varchar2_table(12035) := '416374696F6E732E2E2E22297D292C4E443D4F626A6563742E667265657A65285B7B6B696E643A72442E517569636B4669782C7469746C653A6228302C22517569636B2046697822297D2C7B6B696E643A72442E5265666163746F72457874726163742C';
wwv_flow_imp.g_varchar2_table(12036) := '7469746C653A6228302C224578747261637422292C69636F6E3A4C6C2E7772656E63687D2C7B6B696E643A72442E5265666163746F72496E6C696E652C7469746C653A6228302C22496E6C696E6522292C69636F6E3A4C6C2E7772656E63687D2C7B6B69';
wwv_flow_imp.g_varchar2_table(12037) := '6E643A72442E5265666163746F72526577726974652C7469746C653A6228302C225265777269746522292C69636F6E3A4C6C2E7772656E63687D2C7B6B696E643A72442E5265666163746F724D6F76652C7469746C653A6228302C224D6F766522292C69';
wwv_flow_imp.g_varchar2_table(12038) := '636F6E3A4C6C2E7772656E63687D2C7B6B696E643A72442E537572726F756E64576974682C7469746C653A6228302C22537572726F756E64205769746822292C69636F6E3A4C6C2E737572726F756E64576974687D2C7B6B696E643A72442E536F757263';
wwv_flow_imp.g_varchar2_table(12039) := '652C7469746C653A6228302C22536F7572636520416374696F6E22292C69636F6E3A4C6C2E73796D626F6C46696C657D2C41445D293B7661722050443D6E2834313639292C4F443D7B7D3B4F442E7374796C655461675472616E73666F726D3D6A722829';
wwv_flow_imp.g_varchar2_table(12040) := '2C4F442E736574417474726962757465733D567228292C4F442E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4F442E646F6D4150493D4F7228292C4F442E696E736572745374796C65456C656D656E743D487228292C4E72';
wwv_flow_imp.g_varchar2_table(12041) := '28292850442E412C4F44292C50442E41262650442E412E6C6F63616C73262650442E412E6C6F63616C733B7661722052442C46442C42443D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D';
wwv_flow_imp.g_varchar2_table(12042) := '7D3B2166756E6374696F6E2865297B652E48696464656E3D7B747970653A307D2C652E53686F77696E673D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E616374696F6E733D652C746869732E747269676765723D742C';
wwv_flow_imp.g_varchar2_table(12043) := '746869732E656469746F72506F736974696F6E3D6E2C746869732E776964676574506F736974696F6E3D692C746869732E747970653D317D7D7D2846447C7C2846443D7B7D29293B6C65742056443D52443D636C61737320657874656E6473206C747B63';
wwv_flow_imp.g_varchar2_table(12044) := '6F6E7374727563746F7228652C742C6E297B76617220692C6F2C733B737570657228292C746869732E5F656469746F723D652C746869732E5F6B657962696E64696E67536572766963653D742C746869732E5F6F6E436C69636B3D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(12045) := '6973746572286E6577204374292C746869732E6F6E436C69636B3D746869732E5F6F6E436C69636B2E6576656E742C746869732E5F73746174653D46442E48696464656E2C746869732E5F69636F6E436C61737365733D5B5D2C746869732E5F646F6D4E';
wwv_flow_imp.g_varchar2_table(12046) := '6F64653D627228226469762E6C6967687442756C6257696467657422292C746869732E5F646F6D4E6F64652E726F6C653D226C697374626F78222C746869732E5F72656769737465722849452E69676E6F726554617267657428746869732E5F646F6D4E';
wwv_flow_imp.g_varchar2_table(12047) := '6F646529292C746869732E5F656469746F722E616464436F6E74656E745769646765742874686973292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B63';
wwv_flow_imp.g_varchar2_table(12048) := '6F6E737420743D746869732E5F656469746F722E6765744D6F64656C28293B2831213D3D746869732E73746174652E747970657C7C21747C7C746869732E73746174652E656469746F72506F736974696F6E2E6C696E654E756D6265723E3D742E676574';
wwv_flow_imp.g_varchar2_table(12049) := '4C696E65436F756E742829292626746869732E6869646528297D2929292C746869732E5F72656769737465722828693D746869732E5F646F6D4E6F64652C6F3D653D3E7B69662831213D3D746869732E73746174652E747970652972657475726E3B7468';
wwv_flow_imp.g_varchar2_table(12050) := '69732E5F656469746F722E666F63757328292C652E70726576656E7444656661756C7428293B636F6E73747B746F703A742C6865696768743A6E7D3D417328746869732E5F646F6D4E6F6465292C693D746869732E5F656469746F722E6765744F707469';
wwv_flow_imp.g_varchar2_table(12051) := '6F6E283637293B6C6574206F3D4D6174682E666C6F6F7228692F33293B6E756C6C213D3D746869732E73746174652E776964676574506F736974696F6E2E706F736974696F6E2626746869732E73746174652E776964676574506F736974696F6E2E706F';
wwv_flow_imp.g_varchar2_table(12052) := '736974696F6E2E6C696E654E756D6265723C746869732E73746174652E656469746F72506F736974696F6E2E6C696E654E756D6265722626286F2B3D69292C746869732E5F6F6E436C69636B2E66697265287B783A652E706F73782C793A742B6E2B6F2C';
wwv_flow_imp.g_varchar2_table(12053) := '616374696F6E733A746869732E73746174652E616374696F6E732C747269676765723A746869732E73746174652E747269676765727D297D2C66756E6374696F6E28652C742C6E297B72657475726E20627328652C51262664653F61722E504F494E5445';
wwv_flow_imp.g_varchar2_table(12054) := '525F444F574E3A61722E4D4F5553455F444F574E2C742C6E297D28692C5F732872732869292C6F292C732929292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C226D6F757365656E746572222C28653D3E7B31267E65';
wwv_flow_imp.g_varchar2_table(12055) := '2E627574746F6E737C7C746869732E6869646528297D2929292C746869732E5F72656769737465722876742E72756E416E6453756273637269626528746869732E5F6B657962696E64696E67536572766963652E6F6E4469645570646174654B65796269';
wwv_flow_imp.g_varchar2_table(12056) := '6E64696E67732C2828293D3E7B76617220652C742C6E2C693B746869732E5F7072656665727265644B624C6162656C3D6E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B65';
wwv_flow_imp.g_varchar2_table(12057) := '7962696E64696E6728704429297C7C766F696420303D3D3D653F766F696420303A652E6765744C6162656C2829292626766F69642030213D3D743F743A766F696420302C746869732E5F717569636B4669784B624C6162656C3D6E756C6C213D3D28693D';
wwv_flow_imp.g_varchar2_table(12058) := '6E756C6C3D3D3D286E3D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728754429297C7C766F696420303D3D3D6E3F766F696420303A6E2E6765744C6162656C2829292626766F69642030213D3D69';
wwv_flow_imp.g_varchar2_table(12059) := '3F693A766F696420302C746869732E5F7570646174654C6967687442756C625469746C65416E6449636F6E28297D2929297D646973706F736528297B73757065722E646973706F736528292C746869732E5F656469746F722E72656D6F7665436F6E7465';
wwv_flow_imp.g_varchar2_table(12060) := '6E745769646765742874686973297D676574496428297B72657475726E224C6967687442756C62576964676574227D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B7265747572';
wwv_flow_imp.g_varchar2_table(12061) := '6E20313D3D3D746869732E5F73746174652E747970653F746869732E5F73746174652E776964676574506F736974696F6E3A6E756C6C7D75706461746528652C742C6E297B696628652E76616C6964416374696F6E732E6C656E6774683C3D3029726574';
wwv_flow_imp.g_varchar2_table(12062) := '75726E20746869732E6869646528293B69662821746869732E5F656469746F722E6765744F7074696F6E7328292E676574283635292E656E61626C65642972657475726E20746869732E6869646528293B636F6E737420693D746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(12063) := '722E6765744D6F64656C28293B69662821692972657475726E20746869732E6869646528293B636F6E73747B6C696E654E756D6265723A6F2C636F6C756D6E3A737D3D692E76616C6964617465506F736974696F6E286E292C723D692E6765744F707469';
wwv_flow_imp.g_varchar2_table(12064) := '6F6E7328292E74616253697A652C613D746869732E5F656469746F722E6765744F7074696F6E7328292E676574283530292C6C3D4A5F28692E6765744C696E65436F6E74656E74286F292C72292C633D653D3E653E322626746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(12065) := '2E676574546F70466F724C696E654E756D6265722865293D3D3D746869732E5F656469746F722E676574546F70466F724C696E654E756D62657228652D31293B6C657420643D6F2C683D313B6966282128612E737061636557696474682A6C3E32322929';
wwv_flow_imp.g_varchar2_table(12066) := '7B6966286F3E3126262163286F2D312929642D3D313B656C7365206966286F3C692E6765744C696E65436F756E74282926262163286F2B312929642B3D313B656C736520696628732A612E737061636557696474683C32322972657475726E2074686973';
wwv_flow_imp.g_varchar2_table(12067) := '2E6869646528293B683D2F5E5C535C732A242F2E7465737428692E6765744C696E65436F6E74656E74286429293F323A317D746869732E73746174653D6E65772046442E53686F77696E6728652C742C6E2C7B706F736974696F6E3A7B6C696E654E756D';
wwv_flow_imp.g_varchar2_table(12068) := '6265723A642C636F6C756D6E3A687D2C707265666572656E63653A52442E5F706F73507265667D292C746869732E5F656469746F722E6C61796F7574436F6E74656E745769646765742874686973297D6869646528297B746869732E7374617465213D3D';
wwv_flow_imp.g_varchar2_table(12069) := '46442E48696464656E262628746869732E73746174653D46442E48696464656E2C746869732E5F656469746F722E6C61796F7574436F6E74656E74576964676574287468697329297D67657420737461746528297B72657475726E20746869732E5F7374';
wwv_flow_imp.g_varchar2_table(12070) := '6174657D7365742073746174652865297B746869732E5F73746174653D652C746869732E5F7570646174654C6967687442756C625469746C65416E6449636F6E28297D5F7570646174654C6967687442756C625469746C65416E6449636F6E28297B6966';
wwv_flow_imp.g_varchar2_table(12071) := '28746869732E5F646F6D4E6F64652E636C6173734C6973742E72656D6F7665282E2E2E746869732E5F69636F6E436C6173736573292C746869732E5F69636F6E436C61737365733D5B5D2C31213D3D746869732E73746174652E74797065297265747572';
wwv_flow_imp.g_varchar2_table(12072) := '6E3B6C657420652C743D21313B746869732E73746174652E616374696F6E732E616C6C414946697865733F28653D4C6C2E737061726B6C6546696C6C65642C313D3D3D746869732E73746174652E616374696F6E732E76616C6964416374696F6E732E6C';
wwv_flow_imp.g_varchar2_table(12073) := '656E677468262628743D213029293A653D746869732E73746174652E616374696F6E732E6861734175746F4669783F746869732E73746174652E616374696F6E732E68617341494669783F4C6C2E6C6967687462756C62537061726B6C654175746F6669';
wwv_flow_imp.g_varchar2_table(12074) := '783A4C6C2E6C6967687462756C624175746F6669783A746869732E73746174652E616374696F6E732E68617341494669783F4C6C2E6C6967687462756C62537061726B6C653A4C6C2E6C6967687442756C622C746869732E5F7570646174654C69676874';
wwv_flow_imp.g_varchar2_table(12075) := '62756C625469746C6528746869732E73746174652E616374696F6E732E6861734175746F4669782C74292C746869732E5F69636F6E436C61737365733D546C2E6173436C6173734E616D6541727261792865292C746869732E5F646F6D4E6F64652E636C';
wwv_flow_imp.g_varchar2_table(12076) := '6173734C6973742E616464282E2E2E746869732E5F69636F6E436C6173736573297D5F7570646174654C6967687462756C625469746C6528652C74297B313D3D3D746869732E73746174652E74797065262628743F746869732E7469746C653D6228302C';
wwv_flow_imp.g_varchar2_table(12077) := '2252756E3A207B307D222C746869732E73746174652E616374696F6E732E76616C6964416374696F6E735B305D2E616374696F6E2E7469746C65293A652626746869732E5F7072656665727265644B624C6162656C3F746869732E7469746C653D622830';
wwv_flow_imp.g_varchar2_table(12078) := '2C2253686F7720436F646520416374696F6E732E2050726566657272656420517569636B2046697820417661696C61626C6520287B307D29222C746869732E5F7072656665727265644B624C6162656C293A21652626746869732E5F717569636B466978';
wwv_flow_imp.g_varchar2_table(12079) := '4B624C6162656C3F746869732E7469746C653D6228302C2253686F7720436F646520416374696F6E7320287B307D29222C746869732E5F717569636B4669784B624C6162656C293A657C7C28746869732E7469746C653D6228302C2253686F7720436F64';
wwv_flow_imp.g_varchar2_table(12080) := '6520416374696F6E73222929297D736574207469746C652865297B746869732E5F646F6D4E6F64652E7469746C653D657D7D3B56442E49443D22656469746F722E636F6E747269622E6C6967687462756C62576964676574222C56442E5F706F73507265';
wwv_flow_imp.g_varchar2_table(12081) := '663D5B305D2C56443D52443D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F70657274794465736372';
wwv_flow_imp.g_varchar2_table(12082) := '6970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C74';
wwv_flow_imp.g_varchar2_table(12083) := '2C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326';
wwv_flow_imp.g_varchar2_table(12084) := '267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B424428312C2445292C424428322C7863295D2C5644293B636C617373207A447B636F6E7374727563746F722865297B746869732E73706C69636561626C6573';
wwv_flow_imp.g_varchar2_table(12085) := '3D657D73706C69636528652C742C6E297B746869732E73706C69636561626C65732E666F72456163682828693D3E692E73706C69636528652C742C6E2929297D7D66756E6374696F6E20484428652C742C6E297B72657475726E204D6174682E6D696E28';
wwv_flow_imp.g_varchar2_table(12086) := '4D6174682E6D617828652C74292C6E297D636C6173732057447B636F6E7374727563746F7228297B746869732E5F6E3D312C746869732E5F76616C3D307D7570646174652865297B72657475726E20746869732E5F76616C3D746869732E5F76616C2B28';
wwv_flow_imp.g_varchar2_table(12087) := '652D746869732E5F76616C292F746869732E5F6E2C746869732E5F6E2B3D312C746869732E5F76616C7D6765742076616C756528297B72657475726E20746869732E5F76616C7D7D636C617373206A447B636F6E7374727563746F722865297B74686973';
wwv_flow_imp.g_varchar2_table(12088) := '2E5F6E3D302C746869732E5F76616C3D302C746869732E5F76616C7565733D5B5D2C746869732E5F696E6465783D302C746869732E5F73756D3D302C746869732E5F76616C7565733D6E65772041727261792865292C746869732E5F76616C7565732E66';
wwv_flow_imp.g_varchar2_table(12089) := '696C6C28302C302C65297D7570646174652865297B636F6E737420743D746869732E5F76616C7565735B746869732E5F696E6465785D3B72657475726E20746869732E5F76616C7565735B746869732E5F696E6465785D3D652C746869732E5F696E6465';
wwv_flow_imp.g_varchar2_table(12090) := '783D28746869732E5F696E6465782B312925746869732E5F76616C7565732E6C656E6774682C746869732E5F73756D2D3D742C746869732E5F73756D2B3D652C746869732E5F6E3C746869732E5F76616C7565732E6C656E677468262628746869732E5F';
wwv_flow_imp.g_varchar2_table(12091) := '6E2B3D31292C746869732E5F76616C3D746869732E5F73756D2F746869732E5F6E2C746869732E5F76616C7D6765742076616C756528297B72657475726E20746869732E5F76616C7D7D7661722071443D6E2837333430292C24443D7B7D3B24442E7374';
wwv_flow_imp.g_varchar2_table(12092) := '796C655461675472616E73666F726D3D6A7228292C24442E736574417474726962757465733D567228292C24442E696E736572743D467228292E62696E64286E756C6C2C226865616422292C24442E646F6D4150493D4F7228292C24442E696E73657274';
wwv_flow_imp.g_varchar2_table(12093) := '5374796C65456C656D656E743D487228292C4E7228292871442E412C2444292C71442E41262671442E412E6C6F63616C73262671442E412E6C6F63616C733B636C61737320554420657874656E6473204572726F727B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(12094) := '74297B737570657228604C6973744572726F72205B247B657D5D20247B747D60297D7D636C617373204B447B636F6E7374727563746F7228297B746869732E5F686F6F6B733D6E65772061742C746869732E5F706F696E7465724D6F766543616C6C6261';
wwv_flow_imp.g_varchar2_table(12095) := '636B3D6E756C6C2C746869732E5F6F6E53746F7043616C6C6261636B3D6E756C6C7D646973706F736528297B746869732E73746F704D6F6E69746F72696E67282131292C746869732E5F686F6F6B732E646973706F736528297D73746F704D6F6E69746F';
wwv_flow_imp.g_varchar2_table(12096) := '72696E6728652C74297B69662821746869732E69734D6F6E69746F72696E6728292972657475726E3B746869732E5F686F6F6B732E636C65617228292C746869732E5F706F696E7465724D6F766543616C6C6261636B3D6E756C6C3B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(12097) := '746869732E5F6F6E53746F7043616C6C6261636B3B746869732E5F6F6E53746F7043616C6C6261636B3D6E756C6C2C6526266E26266E2874297D69734D6F6E69746F72696E6728297B72657475726E2121746869732E5F706F696E7465724D6F76654361';
wwv_flow_imp.g_varchar2_table(12098) := '6C6C6261636B7D73746172744D6F6E69746F72696E6728652C742C6E2C692C6F297B746869732E69734D6F6E69746F72696E6728292626746869732E73746F704D6F6E69746F72696E67282131292C746869732E5F706F696E7465724D6F766543616C6C';
wwv_flow_imp.g_varchar2_table(12099) := '6261636B3D692C746869732E5F6F6E53746F7043616C6C6261636B3D6F3B6C657420733D653B7472797B652E736574506F696E746572436170747572652874292C746869732E5F686F6F6B732E616464287274282828293D3E7B7472797B652E72656C65';
wwv_flow_imp.g_varchar2_table(12100) := '617365506F696E746572436170747572652874297D63617463682865297B7D7D2929297D63617463682874297B733D72732865297D746869732E5F686F6F6B732E61646428627328732C61722E504F494E5445525F4D4F56452C28653D3E7B652E627574';
wwv_flow_imp.g_varchar2_table(12101) := '746F6E733D3D3D6E3F28652E70726576656E7444656661756C7428292C746869732E5F706F696E7465724D6F766543616C6C6261636B286529293A746869732E73746F704D6F6E69746F72696E67282130297D2929292C746869732E5F686F6F6B732E61';
wwv_flow_imp.g_varchar2_table(12102) := '646428627328732C61722E504F494E5445525F55502C28653D3E746869732E73746F704D6F6E69746F72696E67282130292929297D7D636C61737320474420657874656E6473206C747B6F6E636C69636B28652C74297B746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(12103) := '7228627328652C61722E434C49434B2C286E3D3E74286E65772047652872732865292C6E29292929297D6F6E6D6F757365646F776E28652C74297B746869732E5F726567697374657228627328652C61722E4D4F5553455F444F574E2C286E3D3E74286E';
wwv_flow_imp.g_varchar2_table(12104) := '65772047652872732865292C6E29292929297D6F6E6D6F7573656F76657228652C74297B746869732E5F726567697374657228627328652C61722E4D4F5553455F4F5645522C286E3D3E74286E65772047652872732865292C6E29292929297D6F6E6D6F';
wwv_flow_imp.g_varchar2_table(12105) := '7573656C6561766528652C74297B746869732E5F726567697374657228627328652C61722E4D4F5553455F4C454156452C286E3D3E74286E65772047652872732865292C6E29292929297D6F6E6B6579646F776E28652C74297B746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(12106) := '7374657228627328652C61722E4B45595F444F574E2C28653D3E74286E6577207165286529292929297D6F6E6B6579757028652C74297B746869732E5F726567697374657228627328652C61722E4B45595F55502C28653D3E74286E6577207165286529';
wwv_flow_imp.g_varchar2_table(12107) := '292929297D6F6E696E70757428652C74297B746869732E5F726567697374657228627328652C61722E494E5055542C7429297D6F6E626C757228652C74297B746869732E5F726567697374657228627328652C61722E424C55522C7429297D6F6E666F63';
wwv_flow_imp.g_varchar2_table(12108) := '757328652C74297B746869732E5F726567697374657228627328652C61722E464F4355532C7429297D69676E6F7265476573747572652865297B72657475726E2049452E69676E6F72655461726765742865297D7D636C61737320514420657874656E64';
wwv_flow_imp.g_varchar2_table(12109) := '732047447B636F6E7374727563746F722865297B737570657228292C746869732E5F6F6E41637469766174653D652E6F6E41637469766174652C746869732E6267446F6D4E6F64653D646F63756D656E742E637265617465456C656D656E742822646976';
wwv_flow_imp.g_varchar2_table(12110) := '22292C746869732E6267446F6D4E6F64652E636C6173734E616D653D226172726F772D6261636B67726F756E64222C746869732E6267446F6D4E6F64652E7374796C652E706F736974696F6E3D226162736F6C757465222C746869732E6267446F6D4E6F';
wwv_flow_imp.g_varchar2_table(12111) := '64652E7374796C652E77696474683D652E626757696474682B227078222C746869732E6267446F6D4E6F64652E7374796C652E6865696768743D652E62674865696768742B227078222C766F69642030213D3D652E746F70262628746869732E6267446F';
wwv_flow_imp.g_varchar2_table(12112) := '6D4E6F64652E7374796C652E746F703D2230707822292C766F69642030213D3D652E6C656674262628746869732E6267446F6D4E6F64652E7374796C652E6C6566743D2230707822292C766F69642030213D3D652E626F74746F6D262628746869732E62';
wwv_flow_imp.g_varchar2_table(12113) := '67446F6D4E6F64652E7374796C652E626F74746F6D3D2230707822292C766F69642030213D3D652E7269676874262628746869732E6267446F6D4E6F64652E7374796C652E72696768743D2230707822292C746869732E646F6D4E6F64653D646F63756D';
wwv_flow_imp.g_varchar2_table(12114) := '656E742E637265617465456C656D656E74282264697622292C746869732E646F6D4E6F64652E636C6173734E616D653D652E636C6173734E616D652C746869732E646F6D4E6F64652E636C6173734C6973742E616464282E2E2E546C2E6173436C617373';
wwv_flow_imp.g_varchar2_table(12115) := '4E616D65417272617928652E69636F6E29292C746869732E646F6D4E6F64652E7374796C652E706F736974696F6E3D226162736F6C757465222C746869732E646F6D4E6F64652E7374796C652E77696474683D2231317078222C746869732E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(12116) := '64652E7374796C652E6865696768743D2231317078222C766F69642030213D3D652E746F70262628746869732E646F6D4E6F64652E7374796C652E746F703D652E746F702B22707822292C766F69642030213D3D652E6C656674262628746869732E646F';
wwv_flow_imp.g_varchar2_table(12117) := '6D4E6F64652E7374796C652E6C6566743D652E6C6566742B22707822292C766F69642030213D3D652E626F74746F6D262628746869732E646F6D4E6F64652E7374796C652E626F74746F6D3D652E626F74746F6D2B22707822292C766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(12118) := '652E7269676874262628746869732E646F6D4E6F64652E7374796C652E72696768743D652E72696768742B22707822292C746869732E5F706F696E7465724D6F76654D6F6E69746F723D746869732E5F7265676973746572286E6577204B44292C746869';
wwv_flow_imp.g_varchar2_table(12119) := '732E5F726567697374657228797328746869732E6267446F6D4E6F64652C61722E504F494E5445525F444F574E2C28653D3E746869732E5F6172726F77506F696E746572446F776E2865292929292C746869732E5F726567697374657228797328746869';
wwv_flow_imp.g_varchar2_table(12120) := '732E646F6D4E6F64652C61722E504F494E5445525F444F574E2C28653D3E746869732E5F6172726F77506F696E746572446F776E2865292929292C746869732E5F706F696E746572646F776E52657065617454696D65723D746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(12121) := '6572286E6577206B73292C746869732E5F706F696E746572646F776E5363686564756C6552657065617454696D65723D746869732E5F7265676973746572286E6577202474297D5F6172726F77506F696E746572446F776E2865297B652E746172676574';
wwv_flow_imp.g_varchar2_table(12122) := '2626652E74617267657420696E7374616E63656F6620456C656D656E74262628746869732E5F6F6E416374697661746528292C746869732E5F706F696E746572646F776E52657065617454696D65722E63616E63656C28292C746869732E5F706F696E74';
wwv_flow_imp.g_varchar2_table(12123) := '6572646F776E5363686564756C6552657065617454696D65722E63616E63656C416E64536574282828293D3E7B746869732E5F706F696E746572646F776E52657065617454696D65722E63616E63656C416E64536574282828293D3E746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(12124) := '41637469766174652829292C3165332F32342C7273286529297D292C323030292C746869732E5F706F696E7465724D6F76654D6F6E69746F722E73746172744D6F6E69746F72696E6728652E7461726765742C652E706F696E74657249642C652E627574';
wwv_flow_imp.g_varchar2_table(12125) := '746F6E732C28653D3E7B7D292C2828293D3E7B746869732E5F706F696E746572646F776E52657065617454696D65722E63616E63656C28292C746869732E5F706F696E746572646F776E5363686564756C6552657065617454696D65722E63616E63656C';
wwv_flow_imp.g_varchar2_table(12126) := '28297D29292C652E70726576656E7444656661756C742829297D7D636C61737320594420657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F7669736962696C6974793D652C746869732E5F76';
wwv_flow_imp.g_varchar2_table(12127) := '697369626C65436C6173734E616D653D742C746869732E5F696E76697369626C65436C6173734E616D653D6E2C746869732E5F646F6D4E6F64653D6E756C6C2C746869732E5F697356697369626C653D21312C746869732E5F69734E65656465643D2131';
wwv_flow_imp.g_varchar2_table(12128) := '2C746869732E5F72617753686F756C64426556697369626C653D21312C746869732E5F73686F756C64426556697369626C653D21312C746869732E5F72657665616C54696D65723D746869732E5F7265676973746572286E6577202474297D7365745669';
wwv_flow_imp.g_varchar2_table(12129) := '736962696C6974792865297B746869732E5F7669736962696C697479213D3D65262628746869732E5F7669736962696C6974793D652C746869732E5F75706461746553686F756C64426556697369626C652829297D73657453686F756C64426556697369';
wwv_flow_imp.g_varchar2_table(12130) := '626C652865297B746869732E5F72617753686F756C64426556697369626C653D652C746869732E5F75706461746553686F756C64426556697369626C6528297D5F6170706C795669736962696C69747953657474696E6728297B72657475726E2032213D';
wwv_flow_imp.g_varchar2_table(12131) := '3D746869732E5F7669736962696C697479262628333D3D3D746869732E5F7669736962696C6974797C7C746869732E5F72617753686F756C64426556697369626C65297D5F75706461746553686F756C64426556697369626C6528297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(12132) := '3D746869732E5F6170706C795669736962696C69747953657474696E6728293B746869732E5F73686F756C64426556697369626C65213D3D65262628746869732E5F73686F756C64426556697369626C653D652C746869732E656E737572655669736962';
wwv_flow_imp.g_varchar2_table(12133) := '696C6974792829297D73657449734E65656465642865297B746869732E5F69734E6565646564213D3D65262628746869732E5F69734E65656465643D652C746869732E656E737572655669736962696C6974792829297D736574446F6D4E6F6465286529';
wwv_flow_imp.g_varchar2_table(12134) := '7B746869732E5F646F6D4E6F64653D652C746869732E5F646F6D4E6F64652E736574436C6173734E616D6528746869732E5F696E76697369626C65436C6173734E616D65292C746869732E73657453686F756C64426556697369626C65282131297D656E';
wwv_flow_imp.g_varchar2_table(12135) := '737572655669736962696C69747928297B746869732E5F69734E65656465643F746869732E5F73686F756C64426556697369626C653F746869732E5F72657665616C28293A746869732E5F68696465282130293A746869732E5F68696465282131297D5F';
wwv_flow_imp.g_varchar2_table(12136) := '72657665616C28297B746869732E5F697356697369626C657C7C28746869732E5F697356697369626C653D21302C746869732E5F72657665616C54696D65722E73657449664E6F74536574282828293D3E7B76617220653B6E756C6C3D3D3D28653D7468';
wwv_flow_imp.g_varchar2_table(12137) := '69732E5F646F6D4E6F6465297C7C766F696420303D3D3D657C7C652E736574436C6173734E616D6528746869732E5F76697369626C65436C6173734E616D65297D292C3029297D5F686964652865297B76617220743B746869732E5F72657665616C5469';
wwv_flow_imp.g_varchar2_table(12138) := '6D65722E63616E63656C28292C746869732E5F697356697369626C65262628746869732E5F697356697369626C653D21312C6E756C6C3D3D3D28743D746869732E5F646F6D4E6F6465297C7C766F696420303D3D3D747C7C742E736574436C6173734E61';
wwv_flow_imp.g_varchar2_table(12139) := '6D6528746869732E5F696E76697369626C65436C6173734E616D652B28653F222066616465223A22222929297D7D636C617373205A4420657874656E64732047447B636F6E7374727563746F722865297B737570657228292C746869732E5F6C617A7952';
wwv_flow_imp.g_varchar2_table(12140) := '656E6465723D652E6C617A7952656E6465722C746869732E5F686F73743D652E686F73742C746869732E5F7363726F6C6C61626C653D652E7363726F6C6C61626C652C746869732E5F7363726F6C6C4279506167653D652E7363726F6C6C427950616765';
wwv_flow_imp.g_varchar2_table(12141) := '2C746869732E5F7363726F6C6C62617253746174653D652E7363726F6C6C62617253746174652C746869732E5F7669736962696C697479436F6E74726F6C6C65723D746869732E5F7265676973746572286E657720594428652E7669736962696C697479';
wwv_flow_imp.g_varchar2_table(12142) := '2C2276697369626C65207363726F6C6C62617220222B652E65787472615363726F6C6C626172436C6173734E616D652C22696E76697369626C65207363726F6C6C62617220222B652E65787472615363726F6C6C626172436C6173734E616D6529292C74';
wwv_flow_imp.g_varchar2_table(12143) := '6869732E5F7669736962696C697479436F6E74726F6C6C65722E73657449734E656564656428746869732E5F7363726F6C6C62617253746174652E69734E65656465642829292C746869732E5F706F696E7465724D6F76654D6F6E69746F723D74686973';
wwv_flow_imp.g_varchar2_table(12144) := '2E5F7265676973746572286E6577204B44292C746869732E5F73686F756C6452656E6465723D21302C746869732E646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(12145) := '2E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F7669736962696C6974';
wwv_flow_imp.g_varchar2_table(12146) := '79436F6E74726F6C6C65722E736574446F6D4E6F646528746869732E646F6D4E6F6465292C746869732E646F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C746869732E5F726567697374657228627328746869732E646F6D';
wwv_flow_imp.g_varchar2_table(12147) := '4E6F64652E646F6D4E6F64652C61722E504F494E5445525F444F574E2C28653D3E746869732E5F646F6D4E6F6465506F696E746572446F776E2865292929297D5F6372656174654172726F772865297B636F6E737420743D746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(12148) := '6572286E6577205144286529293B746869732E646F6D4E6F64652E646F6D4E6F64652E617070656E644368696C6428742E6267446F6D4E6F6465292C746869732E646F6D4E6F64652E646F6D4E6F64652E617070656E644368696C6428742E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(12149) := '6465297D5F637265617465536C6964657228652C742C6E2C69297B746869732E736C696465723D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E736C696465722E736574436C6173734E616D65282273';
wwv_flow_imp.g_varchar2_table(12150) := '6C6964657222292C746869732E736C696465722E736574506F736974696F6E28226162736F6C75746522292C746869732E736C696465722E736574546F702865292C746869732E736C696465722E7365744C6566742874292C226E756D626572223D3D74';
wwv_flow_imp.g_varchar2_table(12151) := '7970656F66206E2626746869732E736C696465722E7365745769647468286E292C226E756D626572223D3D747970656F6620692626746869732E736C696465722E7365744865696768742869292C746869732E736C696465722E7365744C617965724869';
wwv_flow_imp.g_varchar2_table(12152) := '6E74696E67282130292C746869732E736C696465722E736574436F6E7461696E282273747269637422292C746869732E646F6D4E6F64652E646F6D4E6F64652E617070656E644368696C6428746869732E736C696465722E646F6D4E6F6465292C746869';
wwv_flow_imp.g_varchar2_table(12153) := '732E5F726567697374657228627328746869732E736C696465722E646F6D4E6F64652C61722E504F494E5445525F444F574E2C28653D3E7B303D3D3D652E627574746F6E262628652E70726576656E7444656661756C7428292C746869732E5F736C6964';
wwv_flow_imp.g_varchar2_table(12154) := '6572506F696E746572446F776E286529297D2929292C746869732E6F6E636C69636B28746869732E736C696465722E646F6D4E6F64652C28653D3E7B652E6C656674427574746F6E2626652E73746F7050726F7061676174696F6E28297D29297D5F6F6E';
wwv_flow_imp.g_varchar2_table(12155) := '456C656D656E7453697A652865297B72657475726E20746869732E5F7363726F6C6C62617253746174652E73657456697369626C6553697A65286529262628746869732E5F7669736962696C697479436F6E74726F6C6C65722E73657449734E65656465';
wwv_flow_imp.g_varchar2_table(12156) := '6428746869732E5F7363726F6C6C62617253746174652E69734E65656465642829292C746869732E5F73686F756C6452656E6465723D21302C746869732E5F6C617A7952656E6465727C7C746869732E72656E6465722829292C746869732E5F73686F75';
wwv_flow_imp.g_varchar2_table(12157) := '6C6452656E6465727D5F6F6E456C656D656E745363726F6C6C53697A652865297B72657475726E20746869732E5F7363726F6C6C62617253746174652E7365745363726F6C6C53697A65286529262628746869732E5F7669736962696C697479436F6E74';
wwv_flow_imp.g_varchar2_table(12158) := '726F6C6C65722E73657449734E656564656428746869732E5F7363726F6C6C62617253746174652E69734E65656465642829292C746869732E5F73686F756C6452656E6465723D21302C746869732E5F6C617A7952656E6465727C7C746869732E72656E';
wwv_flow_imp.g_varchar2_table(12159) := '6465722829292C746869732E5F73686F756C6452656E6465727D5F6F6E456C656D656E745363726F6C6C506F736974696F6E2865297B72657475726E20746869732E5F7363726F6C6C62617253746174652E7365745363726F6C6C506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(12160) := '6529262628746869732E5F7669736962696C697479436F6E74726F6C6C65722E73657449734E656564656428746869732E5F7363726F6C6C62617253746174652E69734E65656465642829292C746869732E5F73686F756C6452656E6465723D21302C74';
wwv_flow_imp.g_varchar2_table(12161) := '6869732E5F6C617A7952656E6465727C7C746869732E72656E6465722829292C746869732E5F73686F756C6452656E6465727D626567696E52657665616C28297B746869732E5F7669736962696C697479436F6E74726F6C6C65722E73657453686F756C';
wwv_flow_imp.g_varchar2_table(12162) := '64426556697369626C65282130297D626567696E4869646528297B746869732E5F7669736962696C697479436F6E74726F6C6C65722E73657453686F756C64426556697369626C65282131297D72656E64657228297B746869732E5F73686F756C645265';
wwv_flow_imp.g_varchar2_table(12163) := '6E646572262628746869732E5F73686F756C6452656E6465723D21312C746869732E5F72656E646572446F6D4E6F646528746869732E5F7363726F6C6C62617253746174652E67657452656374616E676C654C6172676553697A6528292C746869732E5F';
wwv_flow_imp.g_varchar2_table(12164) := '7363726F6C6C62617253746174652E67657452656374616E676C65536D616C6C53697A652829292C746869732E5F757064617465536C6964657228746869732E5F7363726F6C6C62617253746174652E676574536C6964657253697A6528292C74686973';
wwv_flow_imp.g_varchar2_table(12165) := '2E5F7363726F6C6C62617253746174652E6765744172726F7753697A6528292B746869732E5F7363726F6C6C62617253746174652E676574536C69646572506F736974696F6E282929297D5F646F6D4E6F6465506F696E746572446F776E2865297B652E';
wwv_flow_imp.g_varchar2_table(12166) := '7461726765743D3D3D746869732E646F6D4E6F64652E646F6D4E6F64652626746869732E5F6F6E506F696E746572446F776E2865297D64656C6567617465506F696E746572446F776E2865297B636F6E737420743D746869732E646F6D4E6F64652E646F';
wwv_flow_imp.g_varchar2_table(12167) := '6D4E6F64652E676574436C69656E74526563747328295B305D2E746F702C6E3D742B746869732E5F7363726F6C6C62617253746174652E676574536C69646572506F736974696F6E28292C693D742B746869732E5F7363726F6C6C62617253746174652E';
wwv_flow_imp.g_varchar2_table(12168) := '676574536C69646572506F736974696F6E28292B746869732E5F7363726F6C6C62617253746174652E676574536C6964657253697A6528292C6F3D746869732E5F736C69646572506F696E746572506F736974696F6E2865293B6E3C3D6F26266F3C3D69';
wwv_flow_imp.g_varchar2_table(12169) := '3F303D3D3D652E627574746F6E262628652E70726576656E7444656661756C7428292C746869732E5F736C69646572506F696E746572446F776E286529293A746869732E5F6F6E506F696E746572446F776E2865297D5F6F6E506F696E746572446F776E';
wwv_flow_imp.g_varchar2_table(12170) := '2865297B6C657420742C6E3B696628652E7461726765743D3D3D746869732E646F6D4E6F64652E646F6D4E6F64652626226E756D626572223D3D747970656F6620652E6F6666736574582626226E756D626572223D3D747970656F6620652E6F66667365';
wwv_flow_imp.g_varchar2_table(12171) := '745929743D652E6F6666736574582C6E3D652E6F6666736574593B656C73657B636F6E737420693D417328746869732E646F6D4E6F64652E646F6D4E6F6465293B743D652E70616765582D692E6C6566742C6E3D652E70616765592D692E746F707D636F';
wwv_flow_imp.g_varchar2_table(12172) := '6E737420693D746869732E5F706F696E746572446F776E52656C6174697665506F736974696F6E28742C6E293B746869732E5F736574446573697265645363726F6C6C506F736974696F6E4E6F7728746869732E5F7363726F6C6C4279506167653F7468';
wwv_flow_imp.g_varchar2_table(12173) := '69732E5F7363726F6C6C62617253746174652E676574446573697265645363726F6C6C506F736974696F6E46726F6D4F666673657450616765642869293A746869732E5F7363726F6C6C62617253746174652E676574446573697265645363726F6C6C50';
wwv_flow_imp.g_varchar2_table(12174) := '6F736974696F6E46726F6D4F6666736574286929292C303D3D3D652E627574746F6E262628652E70726576656E7444656661756C7428292C746869732E5F736C69646572506F696E746572446F776E286529297D5F736C69646572506F696E746572446F';
wwv_flow_imp.g_varchar2_table(12175) := '776E2865297B6966282128652E7461726765742626652E74617267657420696E7374616E63656F6620456C656D656E74292972657475726E3B636F6E737420743D746869732E5F736C69646572506F696E746572506F736974696F6E2865292C6E3D7468';
wwv_flow_imp.g_varchar2_table(12176) := '69732E5F736C696465724F7274686F676F6E616C506F696E746572506F736974696F6E2865292C693D746869732E5F7363726F6C6C62617253746174652E636C6F6E6528293B746869732E736C696465722E746F67676C65436C6173734E616D65282261';
wwv_flow_imp.g_varchar2_table(12177) := '6374697665222C2130292C746869732E5F706F696E7465724D6F76654D6F6E69746F722E73746172744D6F6E69746F72696E6728652E7461726765742C652E706F696E74657249642C652E627574746F6E732C28653D3E7B636F6E7374206F3D74686973';
wwv_flow_imp.g_varchar2_table(12178) := '2E5F736C696465724F7274686F676F6E616C506F696E746572506F736974696F6E2865292C733D4D6174682E616273286F2D6E293B6966286A2626733E3134302972657475726E20766F696420746869732E5F736574446573697265645363726F6C6C50';
wwv_flow_imp.g_varchar2_table(12179) := '6F736974696F6E4E6F7728692E6765745363726F6C6C506F736974696F6E2829293B636F6E737420723D746869732E5F736C69646572506F696E746572506F736974696F6E2865292D743B746869732E5F736574446573697265645363726F6C6C506F73';
wwv_flow_imp.g_varchar2_table(12180) := '6974696F6E4E6F7728692E676574446573697265645363726F6C6C506F736974696F6E46726F6D44656C7461287229297D292C2828293D3E7B746869732E736C696465722E746F67676C65436C6173734E616D652822616374697665222C2131292C7468';
wwv_flow_imp.g_varchar2_table(12181) := '69732E5F686F73742E6F6E44726167456E6428297D29292C746869732E5F686F73742E6F6E44726167537461727428297D5F736574446573697265645363726F6C6C506F736974696F6E4E6F772865297B636F6E737420743D7B7D3B746869732E777269';
wwv_flow_imp.g_varchar2_table(12182) := '74655363726F6C6C506F736974696F6E28742C65292C746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E4E6F772874297D7570646174655363726F6C6C62617253697A652865297B746869732E5F7570646174655363';
wwv_flow_imp.g_varchar2_table(12183) := '726F6C6C62617253697A652865292C746869732E5F7363726F6C6C62617253746174652E7365745363726F6C6C62617253697A652865292C746869732E5F73686F756C6452656E6465723D21302C746869732E5F6C617A7952656E6465727C7C74686973';
wwv_flow_imp.g_varchar2_table(12184) := '2E72656E64657228297D69734E656564656428297B72657475726E20746869732E5F7363726F6C6C62617253746174652E69734E656564656428297D7D636C6173732058447B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E';
wwv_flow_imp.g_varchar2_table(12185) := '5F7363726F6C6C62617253697A653D4D6174682E726F756E642874292C746869732E5F6F70706F736974655363726F6C6C62617253697A653D4D6174682E726F756E64286E292C746869732E5F6172726F7753697A653D4D6174682E726F756E64286529';
wwv_flow_imp.g_varchar2_table(12186) := '2C746869732E5F76697369626C6553697A653D692C746869732E5F7363726F6C6C53697A653D6F2C746869732E5F7363726F6C6C506F736974696F6E3D732C746869732E5F636F6D7075746564417661696C61626C6553697A653D302C746869732E5F63';
wwv_flow_imp.g_varchar2_table(12187) := '6F6D707574656449734E65656465643D21312C746869732E5F636F6D7075746564536C6964657253697A653D302C746869732E5F636F6D7075746564536C69646572526174696F3D302C746869732E5F636F6D7075746564536C69646572506F73697469';
wwv_flow_imp.g_varchar2_table(12188) := '6F6E3D302C746869732E5F72656672657368436F6D707574656456616C75657328297D636C6F6E6528297B72657475726E206E657720584428746869732E5F6172726F7753697A652C746869732E5F7363726F6C6C62617253697A652C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(12189) := '70706F736974655363726F6C6C62617253697A652C746869732E5F76697369626C6553697A652C746869732E5F7363726F6C6C53697A652C746869732E5F7363726F6C6C506F736974696F6E297D73657456697369626C6553697A652865297B636F6E73';
wwv_flow_imp.g_varchar2_table(12190) := '7420743D4D6174682E726F756E642865293B72657475726E20746869732E5F76697369626C6553697A65213D3D74262628746869732E5F76697369626C6553697A653D742C746869732E5F72656672657368436F6D707574656456616C75657328292C21';
wwv_flow_imp.g_varchar2_table(12191) := '30297D7365745363726F6C6C53697A652865297B636F6E737420743D4D6174682E726F756E642865293B72657475726E20746869732E5F7363726F6C6C53697A65213D3D74262628746869732E5F7363726F6C6C53697A653D742C746869732E5F726566';
wwv_flow_imp.g_varchar2_table(12192) := '72657368436F6D707574656456616C75657328292C2130297D7365745363726F6C6C506F736974696F6E2865297B636F6E737420743D4D6174682E726F756E642865293B72657475726E20746869732E5F7363726F6C6C506F736974696F6E213D3D7426';
wwv_flow_imp.g_varchar2_table(12193) := '2628746869732E5F7363726F6C6C506F736974696F6E3D742C746869732E5F72656672657368436F6D707574656456616C75657328292C2130297D7365745363726F6C6C62617253697A652865297B746869732E5F7363726F6C6C62617253697A653D4D';
wwv_flow_imp.g_varchar2_table(12194) := '6174682E726F756E642865297D7365744F70706F736974655363726F6C6C62617253697A652865297B746869732E5F6F70706F736974655363726F6C6C62617253697A653D4D6174682E726F756E642865297D737461746963205F636F6D707574655661';
wwv_flow_imp.g_varchar2_table(12195) := '6C75657328652C742C6E2C692C6F297B636F6E737420733D4D6174682E6D617828302C6E2D65292C723D4D6174682E6D617828302C732D322A74292C613D693E302626693E6E3B69662821612972657475726E7B636F6D7075746564417661696C61626C';
wwv_flow_imp.g_varchar2_table(12196) := '6553697A653A4D6174682E726F756E642873292C636F6D707574656449734E65656465643A612C636F6D7075746564536C6964657253697A653A4D6174682E726F756E642872292C636F6D7075746564536C69646572526174696F3A302C636F6D707574';
wwv_flow_imp.g_varchar2_table(12197) := '6564536C69646572506F736974696F6E3A307D3B636F6E7374206C3D4D6174682E726F756E64284D6174682E6D61782832302C4D6174682E666C6F6F72286E2A722F692929292C633D28722D6C292F28692D6E292C643D6F2A633B72657475726E7B636F';
wwv_flow_imp.g_varchar2_table(12198) := '6D7075746564417661696C61626C6553697A653A4D6174682E726F756E642873292C636F6D707574656449734E65656465643A612C636F6D7075746564536C6964657253697A653A4D6174682E726F756E64286C292C636F6D7075746564536C69646572';
wwv_flow_imp.g_varchar2_table(12199) := '526174696F3A632C636F6D7075746564536C69646572506F736974696F6E3A4D6174682E726F756E642864297D7D5F72656672657368436F6D707574656456616C75657328297B636F6E737420653D58442E5F636F6D7075746556616C75657328746869';
wwv_flow_imp.g_varchar2_table(12200) := '732E5F6F70706F736974655363726F6C6C62617253697A652C746869732E5F6172726F7753697A652C746869732E5F76697369626C6553697A652C746869732E5F7363726F6C6C53697A652C746869732E5F7363726F6C6C506F736974696F6E293B7468';
wwv_flow_imp.g_varchar2_table(12201) := '69732E5F636F6D7075746564417661696C61626C6553697A653D652E636F6D7075746564417661696C61626C6553697A652C746869732E5F636F6D707574656449734E65656465643D652E636F6D707574656449734E65656465642C746869732E5F636F';
wwv_flow_imp.g_varchar2_table(12202) := '6D7075746564536C6964657253697A653D652E636F6D7075746564536C6964657253697A652C746869732E5F636F6D7075746564536C69646572526174696F3D652E636F6D7075746564536C69646572526174696F2C746869732E5F636F6D7075746564';
wwv_flow_imp.g_varchar2_table(12203) := '536C69646572506F736974696F6E3D652E636F6D7075746564536C69646572506F736974696F6E7D6765744172726F7753697A6528297B72657475726E20746869732E5F6172726F7753697A657D6765745363726F6C6C506F736974696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(12204) := '7475726E20746869732E5F7363726F6C6C506F736974696F6E7D67657452656374616E676C654C6172676553697A6528297B72657475726E20746869732E5F636F6D7075746564417661696C61626C6553697A657D67657452656374616E676C65536D61';
wwv_flow_imp.g_varchar2_table(12205) := '6C6C53697A6528297B72657475726E20746869732E5F7363726F6C6C62617253697A657D69734E656564656428297B72657475726E20746869732E5F636F6D707574656449734E65656465647D676574536C6964657253697A6528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(12206) := '746869732E5F636F6D7075746564536C6964657253697A657D676574536C69646572506F736974696F6E28297B72657475726E20746869732E5F636F6D7075746564536C69646572506F736974696F6E7D676574446573697265645363726F6C6C506F73';
wwv_flow_imp.g_varchar2_table(12207) := '6974696F6E46726F6D4F66667365742865297B69662821746869732E5F636F6D707574656449734E65656465642972657475726E20303B636F6E737420743D652D746869732E5F6172726F7753697A652D746869732E5F636F6D7075746564536C696465';
wwv_flow_imp.g_varchar2_table(12208) := '7253697A652F323B72657475726E204D6174682E726F756E6428742F746869732E5F636F6D7075746564536C69646572526174696F297D676574446573697265645363726F6C6C506F736974696F6E46726F6D4F666673657450616765642865297B6966';
wwv_flow_imp.g_varchar2_table(12209) := '2821746869732E5F636F6D707574656449734E65656465642972657475726E20303B636F6E737420743D652D746869732E5F6172726F7753697A653B6C6574206E3D746869732E5F7363726F6C6C506F736974696F6E3B72657475726E20743C74686973';
wwv_flow_imp.g_varchar2_table(12210) := '2E5F636F6D7075746564536C69646572506F736974696F6E3F6E2D3D746869732E5F76697369626C6553697A653A6E2B3D746869732E5F76697369626C6553697A652C6E7D676574446573697265645363726F6C6C506F736974696F6E46726F6D44656C';
wwv_flow_imp.g_varchar2_table(12211) := '74612865297B69662821746869732E5F636F6D707574656449734E65656465642972657475726E20303B636F6E737420743D746869732E5F636F6D7075746564536C69646572506F736974696F6E2B653B72657475726E204D6174682E726F756E642874';
wwv_flow_imp.g_varchar2_table(12212) := '2F746869732E5F636F6D7075746564536C69646572526174696F297D7D636C617373204A4420657874656E6473205A447B636F6E7374727563746F7228652C742C6E297B636F6E737420693D652E6765745363726F6C6C44696D656E73696F6E7328292C';
wwv_flow_imp.g_varchar2_table(12213) := '6F3D652E67657443757272656E745363726F6C6C506F736974696F6E28293B6966287375706572287B6C617A7952656E6465723A742E6C617A7952656E6465722C686F73743A6E2C7363726F6C6C62617253746174653A6E657720584428742E686F7269';
wwv_flow_imp.g_varchar2_table(12214) := '7A6F6E74616C4861734172726F77733F742E6172726F7753697A653A302C323D3D3D742E686F72697A6F6E74616C3F303A742E686F72697A6F6E74616C5363726F6C6C62617253697A652C323D3D3D742E766572746963616C3F303A742E766572746963';
wwv_flow_imp.g_varchar2_table(12215) := '616C5363726F6C6C62617253697A652C692E77696474682C692E7363726F6C6C57696474682C6F2E7363726F6C6C4C656674292C7669736962696C6974793A742E686F72697A6F6E74616C2C65787472615363726F6C6C626172436C6173734E616D653A';
wwv_flow_imp.g_varchar2_table(12216) := '22686F72697A6F6E74616C222C7363726F6C6C61626C653A652C7363726F6C6C4279506167653A742E7363726F6C6C4279506167657D292C742E686F72697A6F6E74616C4861734172726F7773297B636F6E737420653D28742E6172726F7753697A652D';
wwv_flow_imp.g_varchar2_table(12217) := '3131292F322C6E3D28742E686F72697A6F6E74616C5363726F6C6C62617253697A652D3131292F323B746869732E5F6372656174654172726F77287B636C6173734E616D653A2273637261222C69636F6E3A4C6C2E7363726F6C6C626172427574746F6E';
wwv_flow_imp.g_varchar2_table(12218) := '4C6566742C746F703A6E2C6C6566743A652C626F74746F6D3A766F696420302C72696768743A766F696420302C626757696474683A742E6172726F7753697A652C62674865696768743A742E686F72697A6F6E74616C5363726F6C6C62617253697A652C';
wwv_flow_imp.g_varchar2_table(12219) := '6F6E41637469766174653A28293D3E746869732E5F686F73742E6F6E4D6F757365576865656C286E6577205165286E756C6C2C312C3029297D292C746869732E5F6372656174654172726F77287B636C6173734E616D653A2273637261222C69636F6E3A';
wwv_flow_imp.g_varchar2_table(12220) := '4C6C2E7363726F6C6C626172427574746F6E52696768742C746F703A6E2C6C6566743A766F696420302C626F74746F6D3A766F696420302C72696768743A652C626757696474683A742E6172726F7753697A652C62674865696768743A742E686F72697A';
wwv_flow_imp.g_varchar2_table(12221) := '6F6E74616C5363726F6C6C62617253697A652C6F6E41637469766174653A28293D3E746869732E5F686F73742E6F6E4D6F757365576865656C286E6577205165286E756C6C2C2D312C3029297D297D746869732E5F637265617465536C69646572284D61';
wwv_flow_imp.g_varchar2_table(12222) := '74682E666C6F6F722828742E686F72697A6F6E74616C5363726F6C6C62617253697A652D742E686F72697A6F6E74616C536C6964657253697A65292F32292C302C766F696420302C742E686F72697A6F6E74616C536C6964657253697A65297D5F757064';
wwv_flow_imp.g_varchar2_table(12223) := '617465536C6964657228652C74297B746869732E736C696465722E73657457696474682865292C746869732E736C696465722E7365744C6566742874297D5F72656E646572446F6D4E6F646528652C74297B746869732E646F6D4E6F64652E7365745769';
wwv_flow_imp.g_varchar2_table(12224) := '6474682865292C746869732E646F6D4E6F64652E7365744865696768742874292C746869732E646F6D4E6F64652E7365744C6566742830292C746869732E646F6D4E6F64652E736574426F74746F6D2830297D6F6E4469645363726F6C6C2865297B7265';
wwv_flow_imp.g_varchar2_table(12225) := '7475726E20746869732E5F73686F756C6452656E6465723D746869732E5F6F6E456C656D656E745363726F6C6C53697A6528652E7363726F6C6C5769647468297C7C746869732E5F73686F756C6452656E6465722C746869732E5F73686F756C6452656E';
wwv_flow_imp.g_varchar2_table(12226) := '6465723D746869732E5F6F6E456C656D656E745363726F6C6C506F736974696F6E28652E7363726F6C6C4C656674297C7C746869732E5F73686F756C6452656E6465722C746869732E5F73686F756C6452656E6465723D746869732E5F6F6E456C656D65';
wwv_flow_imp.g_varchar2_table(12227) := '6E7453697A6528652E7769647468297C7C746869732E5F73686F756C6452656E6465722C746869732E5F73686F756C6452656E6465727D5F706F696E746572446F776E52656C6174697665506F736974696F6E28652C74297B72657475726E20657D5F73';
wwv_flow_imp.g_varchar2_table(12228) := '6C69646572506F696E746572506F736974696F6E2865297B72657475726E20652E70616765587D5F736C696465724F7274686F676F6E616C506F696E746572506F736974696F6E2865297B72657475726E20652E70616765597D5F757064617465536372';
wwv_flow_imp.g_varchar2_table(12229) := '6F6C6C62617253697A652865297B746869732E736C696465722E7365744865696768742865297D77726974655363726F6C6C506F736974696F6E28652C74297B652E7363726F6C6C4C6566743D747D7570646174654F7074696F6E732865297B74686973';
wwv_flow_imp.g_varchar2_table(12230) := '2E7570646174655363726F6C6C62617253697A6528323D3D3D652E686F72697A6F6E74616C3F303A652E686F72697A6F6E74616C5363726F6C6C62617253697A65292C746869732E5F7363726F6C6C62617253746174652E7365744F70706F7369746553';
wwv_flow_imp.g_varchar2_table(12231) := '63726F6C6C62617253697A6528323D3D3D652E766572746963616C3F303A652E766572746963616C5363726F6C6C62617253697A65292C746869732E5F7669736962696C697479436F6E74726F6C6C65722E7365745669736962696C69747928652E686F';
wwv_flow_imp.g_varchar2_table(12232) := '72697A6F6E74616C292C746869732E5F7363726F6C6C4279506167653D652E7363726F6C6C4279506167657D7D636C61737320655420657874656E6473205A447B636F6E7374727563746F7228652C742C6E297B636F6E737420693D652E676574536372';
wwv_flow_imp.g_varchar2_table(12233) := '6F6C6C44696D656E73696F6E7328292C6F3D652E67657443757272656E745363726F6C6C506F736974696F6E28293B6966287375706572287B6C617A7952656E6465723A742E6C617A7952656E6465722C686F73743A6E2C7363726F6C6C626172537461';
wwv_flow_imp.g_varchar2_table(12234) := '74653A6E657720584428742E766572746963616C4861734172726F77733F742E6172726F7753697A653A302C323D3D3D742E766572746963616C3F303A742E766572746963616C5363726F6C6C62617253697A652C302C692E6865696768742C692E7363';
wwv_flow_imp.g_varchar2_table(12235) := '726F6C6C4865696768742C6F2E7363726F6C6C546F70292C7669736962696C6974793A742E766572746963616C2C65787472615363726F6C6C626172436C6173734E616D653A22766572746963616C222C7363726F6C6C61626C653A652C7363726F6C6C';
wwv_flow_imp.g_varchar2_table(12236) := '4279506167653A742E7363726F6C6C4279506167657D292C742E766572746963616C4861734172726F7773297B636F6E737420653D28742E6172726F7753697A652D3131292F322C6E3D28742E766572746963616C5363726F6C6C62617253697A652D31';
wwv_flow_imp.g_varchar2_table(12237) := '31292F323B746869732E5F6372656174654172726F77287B636C6173734E616D653A2273637261222C69636F6E3A4C6C2E7363726F6C6C626172427574746F6E55702C746F703A652C6C6566743A6E2C626F74746F6D3A766F696420302C72696768743A';
wwv_flow_imp.g_varchar2_table(12238) := '766F696420302C626757696474683A742E766572746963616C5363726F6C6C62617253697A652C62674865696768743A742E6172726F7753697A652C6F6E41637469766174653A28293D3E746869732E5F686F73742E6F6E4D6F757365576865656C286E';
wwv_flow_imp.g_varchar2_table(12239) := '6577205165286E756C6C2C302C3129297D292C746869732E5F6372656174654172726F77287B636C6173734E616D653A2273637261222C69636F6E3A4C6C2E7363726F6C6C626172427574746F6E446F776E2C746F703A766F696420302C6C6566743A6E';
wwv_flow_imp.g_varchar2_table(12240) := '2C626F74746F6D3A652C72696768743A766F696420302C626757696474683A742E766572746963616C5363726F6C6C62617253697A652C62674865696768743A742E6172726F7753697A652C6F6E41637469766174653A28293D3E746869732E5F686F73';
wwv_flow_imp.g_varchar2_table(12241) := '742E6F6E4D6F757365576865656C286E6577205165286E756C6C2C302C2D3129297D297D746869732E5F637265617465536C6964657228302C4D6174682E666C6F6F722828742E766572746963616C5363726F6C6C62617253697A652D742E7665727469';
wwv_flow_imp.g_varchar2_table(12242) := '63616C536C6964657253697A65292F32292C742E766572746963616C536C6964657253697A652C766F69642030297D5F757064617465536C6964657228652C74297B746869732E736C696465722E7365744865696768742865292C746869732E736C6964';
wwv_flow_imp.g_varchar2_table(12243) := '65722E736574546F702874297D5F72656E646572446F6D4E6F646528652C74297B746869732E646F6D4E6F64652E73657457696474682874292C746869732E646F6D4E6F64652E7365744865696768742865292C746869732E646F6D4E6F64652E736574';
wwv_flow_imp.g_varchar2_table(12244) := '52696768742830292C746869732E646F6D4E6F64652E736574546F702830297D6F6E4469645363726F6C6C2865297B72657475726E20746869732E5F73686F756C6452656E6465723D746869732E5F6F6E456C656D656E745363726F6C6C53697A652865';
wwv_flow_imp.g_varchar2_table(12245) := '2E7363726F6C6C486569676874297C7C746869732E5F73686F756C6452656E6465722C746869732E5F73686F756C6452656E6465723D746869732E5F6F6E456C656D656E745363726F6C6C506F736974696F6E28652E7363726F6C6C546F70297C7C7468';
wwv_flow_imp.g_varchar2_table(12246) := '69732E5F73686F756C6452656E6465722C746869732E5F73686F756C6452656E6465723D746869732E5F6F6E456C656D656E7453697A6528652E686569676874297C7C746869732E5F73686F756C6452656E6465722C746869732E5F73686F756C645265';
wwv_flow_imp.g_varchar2_table(12247) := '6E6465727D5F706F696E746572446F776E52656C6174697665506F736974696F6E28652C74297B72657475726E20747D5F736C69646572506F696E746572506F736974696F6E2865297B72657475726E20652E70616765597D5F736C696465724F727468';
wwv_flow_imp.g_varchar2_table(12248) := '6F676F6E616C506F696E746572506F736974696F6E2865297B72657475726E20652E70616765587D5F7570646174655363726F6C6C62617253697A652865297B746869732E736C696465722E73657457696474682865297D77726974655363726F6C6C50';
wwv_flow_imp.g_varchar2_table(12249) := '6F736974696F6E28652C74297B652E7363726F6C6C546F703D747D7570646174654F7074696F6E732865297B746869732E7570646174655363726F6C6C62617253697A6528323D3D3D652E766572746963616C3F303A652E766572746963616C5363726F';
wwv_flow_imp.g_varchar2_table(12250) := '6C6C62617253697A65292C746869732E5F7363726F6C6C62617253746174652E7365744F70706F736974655363726F6C6C62617253697A652830292C746869732E5F7669736962696C697479436F6E74726F6C6C65722E7365745669736962696C697479';
wwv_flow_imp.g_varchar2_table(12251) := '28652E766572746963616C292C746869732E5F7363726F6C6C4279506167653D652E7363726F6C6C4279506167657D7D636C6173732074547B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E5F666F726365496E746567';
wwv_flow_imp.g_varchar2_table(12252) := '657256616C7565733D652C746869732E5F7363726F6C6C53746174654272616E643D766F696420302C746869732E5F666F726365496E746567657256616C756573262628747C3D302C6E7C3D302C697C3D302C6F7C3D302C737C3D302C727C3D30292C74';
wwv_flow_imp.g_varchar2_table(12253) := '6869732E7261775363726F6C6C4C6566743D692C746869732E7261775363726F6C6C546F703D722C743C30262628743D30292C692B743E6E262628693D6E2D74292C693C30262628693D30292C6F3C302626286F3D30292C722B6F3E73262628723D732D';
wwv_flow_imp.g_varchar2_table(12254) := '6F292C723C30262628723D30292C746869732E77696474683D742C746869732E7363726F6C6C57696474683D6E2C746869732E7363726F6C6C4C6566743D692C746869732E6865696768743D6F2C746869732E7363726F6C6C4865696768743D732C7468';
wwv_flow_imp.g_varchar2_table(12255) := '69732E7363726F6C6C546F703D727D657175616C732865297B72657475726E20746869732E7261775363726F6C6C4C6566743D3D3D652E7261775363726F6C6C4C6566742626746869732E7261775363726F6C6C546F703D3D3D652E7261775363726F6C';
wwv_flow_imp.g_varchar2_table(12256) := '6C546F702626746869732E77696474683D3D3D652E77696474682626746869732E7363726F6C6C57696474683D3D3D652E7363726F6C6C57696474682626746869732E7363726F6C6C4C6566743D3D3D652E7363726F6C6C4C6566742626746869732E68';
wwv_flow_imp.g_varchar2_table(12257) := '65696768743D3D3D652E6865696768742626746869732E7363726F6C6C4865696768743D3D3D652E7363726F6C6C4865696768742626746869732E7363726F6C6C546F703D3D3D652E7363726F6C6C546F707D776974685363726F6C6C44696D656E7369';
wwv_flow_imp.g_varchar2_table(12258) := '6F6E7328652C74297B72657475726E206E657720745428746869732E5F666F726365496E746567657256616C7565732C766F69642030213D3D652E77696474683F652E77696474683A746869732E77696474682C766F69642030213D3D652E7363726F6C';
wwv_flow_imp.g_varchar2_table(12259) := '6C57696474683F652E7363726F6C6C57696474683A746869732E7363726F6C6C57696474682C743F746869732E7261775363726F6C6C4C6566743A746869732E7363726F6C6C4C6566742C766F69642030213D3D652E6865696768743F652E6865696768';
wwv_flow_imp.g_varchar2_table(12260) := '743A746869732E6865696768742C766F69642030213D3D652E7363726F6C6C4865696768743F652E7363726F6C6C4865696768743A746869732E7363726F6C6C4865696768742C743F746869732E7261775363726F6C6C546F703A746869732E7363726F';
wwv_flow_imp.g_varchar2_table(12261) := '6C6C546F70297D776974685363726F6C6C506F736974696F6E2865297B72657475726E206E657720745428746869732E5F666F726365496E746567657256616C7565732C746869732E77696474682C746869732E7363726F6C6C57696474682C766F6964';
wwv_flow_imp.g_varchar2_table(12262) := '2030213D3D652E7363726F6C6C4C6566743F652E7363726F6C6C4C6566743A746869732E7261775363726F6C6C4C6566742C746869732E6865696768742C746869732E7363726F6C6C4865696768742C766F69642030213D3D652E7363726F6C6C546F70';
wwv_flow_imp.g_varchar2_table(12263) := '3F652E7363726F6C6C546F703A746869732E7261775363726F6C6C546F70297D6372656174655363726F6C6C4576656E7428652C74297B636F6E7374206E3D746869732E7769647468213D3D652E77696474682C693D746869732E7363726F6C6C576964';
wwv_flow_imp.g_varchar2_table(12264) := '7468213D3D652E7363726F6C6C57696474682C6F3D746869732E7363726F6C6C4C656674213D3D652E7363726F6C6C4C6566742C733D746869732E686569676874213D3D652E6865696768742C723D746869732E7363726F6C6C486569676874213D3D65';
wwv_flow_imp.g_varchar2_table(12265) := '2E7363726F6C6C4865696768742C613D746869732E7363726F6C6C546F70213D3D652E7363726F6C6C546F703B72657475726E7B696E536D6F6F74685363726F6C6C696E673A742C6F6C6457696474683A652E77696474682C6F6C645363726F6C6C5769';
wwv_flow_imp.g_varchar2_table(12266) := '6474683A652E7363726F6C6C57696474682C6F6C645363726F6C6C4C6566743A652E7363726F6C6C4C6566742C77696474683A746869732E77696474682C7363726F6C6C57696474683A746869732E7363726F6C6C57696474682C7363726F6C6C4C6566';
wwv_flow_imp.g_varchar2_table(12267) := '743A746869732E7363726F6C6C4C6566742C6F6C644865696768743A652E6865696768742C6F6C645363726F6C6C4865696768743A652E7363726F6C6C4865696768742C6F6C645363726F6C6C546F703A652E7363726F6C6C546F702C6865696768743A';
wwv_flow_imp.g_varchar2_table(12268) := '746869732E6865696768742C7363726F6C6C4865696768743A746869732E7363726F6C6C4865696768742C7363726F6C6C546F703A746869732E7363726F6C6C546F702C77696474684368616E6765643A6E2C7363726F6C6C57696474684368616E6765';
wwv_flow_imp.g_varchar2_table(12269) := '643A692C7363726F6C6C4C6566744368616E6765643A6F2C6865696768744368616E6765643A732C7363726F6C6C4865696768744368616E6765643A722C7363726F6C6C546F704368616E6765643A617D7D7D636C617373206E5420657874656E647320';
wwv_flow_imp.g_varchar2_table(12270) := '6C747B636F6E7374727563746F722865297B737570657228292C746869732E5F7363726F6C6C61626C654272616E643D766F696420302C746869732E5F6F6E5363726F6C6C3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E';
wwv_flow_imp.g_varchar2_table(12271) := '5363726F6C6C3D746869732E5F6F6E5363726F6C6C2E6576656E742C746869732E5F736D6F6F74685363726F6C6C4475726174696F6E3D652E736D6F6F74685363726F6C6C4475726174696F6E2C746869732E5F7363686564756C6541744E657874416E';
wwv_flow_imp.g_varchar2_table(12272) := '696D6174696F6E4672616D653D652E7363686564756C6541744E657874416E696D6174696F6E4672616D652C746869732E5F73746174653D6E657720745428652E666F726365496E746567657256616C7565732C302C302C302C302C302C30292C746869';
wwv_flow_imp.g_varchar2_table(12273) := '732E5F736D6F6F74685363726F6C6C696E673D6E756C6C7D646973706F736528297B746869732E5F736D6F6F74685363726F6C6C696E67262628746869732E5F736D6F6F74685363726F6C6C696E672E646973706F736528292C746869732E5F736D6F6F';
wwv_flow_imp.g_varchar2_table(12274) := '74685363726F6C6C696E673D6E756C6C292C73757065722E646973706F736528297D736574536D6F6F74685363726F6C6C4475726174696F6E2865297B746869732E5F736D6F6F74685363726F6C6C4475726174696F6E3D657D76616C69646174655363';
wwv_flow_imp.g_varchar2_table(12275) := '726F6C6C506F736974696F6E2865297B72657475726E20746869732E5F73746174652E776974685363726F6C6C506F736974696F6E2865297D6765745363726F6C6C44696D656E73696F6E7328297B72657475726E20746869732E5F73746174657D7365';
wwv_flow_imp.g_varchar2_table(12276) := '745363726F6C6C44696D656E73696F6E7328652C74297B766172206E3B636F6E737420693D746869732E5F73746174652E776974685363726F6C6C44696D656E73696F6E7328652C74293B746869732E5F736574537461746528692C426F6F6C65616E28';
wwv_flow_imp.g_varchar2_table(12277) := '746869732E5F736D6F6F74685363726F6C6C696E6729292C6E756C6C3D3D3D286E3D746869732E5F736D6F6F74685363726F6C6C696E67297C7C766F696420303D3D3D6E7C7C6E2E6163636570745363726F6C6C44696D656E73696F6E7328746869732E';
wwv_flow_imp.g_varchar2_table(12278) := '5F7374617465297D6765744675747572655363726F6C6C506F736974696F6E28297B72657475726E20746869732E5F736D6F6F74685363726F6C6C696E673F746869732E5F736D6F6F74685363726F6C6C696E672E746F3A746869732E5F73746174657D';
wwv_flow_imp.g_varchar2_table(12279) := '67657443757272656E745363726F6C6C506F736974696F6E28297B72657475726E20746869732E5F73746174657D7365745363726F6C6C506F736974696F6E4E6F772865297B636F6E737420743D746869732E5F73746174652E776974685363726F6C6C';
wwv_flow_imp.g_varchar2_table(12280) := '506F736974696F6E2865293B746869732E5F736D6F6F74685363726F6C6C696E67262628746869732E5F736D6F6F74685363726F6C6C696E672E646973706F736528292C746869732E5F736D6F6F74685363726F6C6C696E673D6E756C6C292C74686973';
wwv_flow_imp.g_varchar2_table(12281) := '2E5F736574537461746528742C2131297D7365745363726F6C6C506F736974696F6E536D6F6F746828652C74297B696628303D3D3D746869732E5F736D6F6F74685363726F6C6C4475726174696F6E2972657475726E20746869732E7365745363726F6C';
wwv_flow_imp.g_varchar2_table(12282) := '6C506F736974696F6E4E6F772865293B696628746869732E5F736D6F6F74685363726F6C6C696E67297B653D7B7363726F6C6C4C6566743A766F696420303D3D3D652E7363726F6C6C4C6566743F746869732E5F736D6F6F74685363726F6C6C696E672E';
wwv_flow_imp.g_varchar2_table(12283) := '746F2E7363726F6C6C4C6566743A652E7363726F6C6C4C6566742C7363726F6C6C546F703A766F696420303D3D3D652E7363726F6C6C546F703F746869732E5F736D6F6F74685363726F6C6C696E672E746F2E7363726F6C6C546F703A652E7363726F6C';
wwv_flow_imp.g_varchar2_table(12284) := '6C546F707D3B636F6E7374206E3D746869732E5F73746174652E776974685363726F6C6C506F736974696F6E2865293B696628746869732E5F736D6F6F74685363726F6C6C696E672E746F2E7363726F6C6C4C6566743D3D3D6E2E7363726F6C6C4C6566';
wwv_flow_imp.g_varchar2_table(12285) := '742626746869732E5F736D6F6F74685363726F6C6C696E672E746F2E7363726F6C6C546F703D3D3D6E2E7363726F6C6C546F702972657475726E3B6C657420693B693D743F6E657720735428746869732E5F736D6F6F74685363726F6C6C696E672E6672';
wwv_flow_imp.g_varchar2_table(12286) := '6F6D2C6E2C746869732E5F736D6F6F74685363726F6C6C696E672E737461727454696D652C746869732E5F736D6F6F74685363726F6C6C696E672E6475726174696F6E293A746869732E5F736D6F6F74685363726F6C6C696E672E636F6D62696E652874';
wwv_flow_imp.g_varchar2_table(12287) := '6869732E5F73746174652C6E2C746869732E5F736D6F6F74685363726F6C6C4475726174696F6E292C746869732E5F736D6F6F74685363726F6C6C696E672E646973706F736528292C746869732E5F736D6F6F74685363726F6C6C696E673D697D656C73';
wwv_flow_imp.g_varchar2_table(12288) := '657B636F6E737420743D746869732E5F73746174652E776974685363726F6C6C506F736974696F6E2865293B746869732E5F736D6F6F74685363726F6C6C696E673D73542E737461727428746869732E5F73746174652C742C746869732E5F736D6F6F74';
wwv_flow_imp.g_varchar2_table(12289) := '685363726F6C6C4475726174696F6E297D746869732E5F736D6F6F74685363726F6C6C696E672E616E696D6174696F6E4672616D65446973706F7361626C653D746869732E5F7363686564756C6541744E657874416E696D6174696F6E4672616D652828';
wwv_flow_imp.g_varchar2_table(12290) := '28293D3E7B746869732E5F736D6F6F74685363726F6C6C696E67262628746869732E5F736D6F6F74685363726F6C6C696E672E616E696D6174696F6E4672616D65446973706F7361626C653D6E756C6C2C746869732E5F706572666F726D536D6F6F7468';
wwv_flow_imp.g_varchar2_table(12291) := '5363726F6C6C696E672829297D29297D68617350656E64696E675363726F6C6C416E696D6174696F6E28297B72657475726E20426F6F6C65616E28746869732E5F736D6F6F74685363726F6C6C696E67297D5F706572666F726D536D6F6F74685363726F';
wwv_flow_imp.g_varchar2_table(12292) := '6C6C696E6728297B69662821746869732E5F736D6F6F74685363726F6C6C696E672972657475726E3B636F6E737420653D746869732E5F736D6F6F74685363726F6C6C696E672E7469636B28292C743D746869732E5F73746174652E776974685363726F';
wwv_flow_imp.g_varchar2_table(12293) := '6C6C506F736974696F6E2865293B72657475726E20746869732E5F736574537461746528742C2130292C746869732E5F736D6F6F74685363726F6C6C696E673F652E6973446F6E653F28746869732E5F736D6F6F74685363726F6C6C696E672E64697370';
wwv_flow_imp.g_varchar2_table(12294) := '6F736528292C766F696428746869732E5F736D6F6F74685363726F6C6C696E673D6E756C6C29293A766F696428746869732E5F736D6F6F74685363726F6C6C696E672E616E696D6174696F6E4672616D65446973706F7361626C653D746869732E5F7363';
wwv_flow_imp.g_varchar2_table(12295) := '686564756C6541744E657874416E696D6174696F6E4672616D65282828293D3E7B746869732E5F736D6F6F74685363726F6C6C696E67262628746869732E5F736D6F6F74685363726F6C6C696E672E616E696D6174696F6E4672616D65446973706F7361';
wwv_flow_imp.g_varchar2_table(12296) := '626C653D6E756C6C2C746869732E5F706572666F726D536D6F6F74685363726F6C6C696E672829297D2929293A766F696420307D5F736574537461746528652C74297B636F6E7374206E3D746869732E5F73746174653B6E2E657175616C732865297C7C';
wwv_flow_imp.g_varchar2_table(12297) := '28746869732E5F73746174653D652C746869732E5F6F6E5363726F6C6C2E6669726528746869732E5F73746174652E6372656174655363726F6C6C4576656E74286E2C742929297D7D636C6173732069547B636F6E7374727563746F7228652C742C6E29';
wwv_flow_imp.g_varchar2_table(12298) := '7B746869732E7363726F6C6C4C6566743D652C746869732E7363726F6C6C546F703D742C746869732E6973446F6E653D6E7D7D66756E6374696F6E206F5428652C74297B636F6E7374206E3D742D653B72657475726E2066756E6374696F6E2874297B72';
wwv_flow_imp.g_varchar2_table(12299) := '657475726E20652B6E2A28312D28693D312D742C4D6174682E706F7728692C332929293B76617220697D7D636C6173732073547B636F6E7374727563746F7228652C742C6E2C69297B746869732E66726F6D3D652C746869732E746F3D742C746869732E';
wwv_flow_imp.g_varchar2_table(12300) := '6475726174696F6E3D692C746869732E737461727454696D653D6E2C746869732E616E696D6174696F6E4672616D65446973706F7361626C653D6E756C6C2C746869732E5F696E6974416E696D6174696F6E7328297D5F696E6974416E696D6174696F6E';
wwv_flow_imp.g_varchar2_table(12301) := '7328297B746869732E7363726F6C6C4C6566743D746869732E5F696E6974416E696D6174696F6E28746869732E66726F6D2E7363726F6C6C4C6566742C746869732E746F2E7363726F6C6C4C6566742C746869732E746F2E7769647468292C746869732E';
wwv_flow_imp.g_varchar2_table(12302) := '7363726F6C6C546F703D746869732E5F696E6974416E696D6174696F6E28746869732E66726F6D2E7363726F6C6C546F702C746869732E746F2E7363726F6C6C546F702C746869732E746F2E686569676874297D5F696E6974416E696D6174696F6E2865';
wwv_flow_imp.g_varchar2_table(12303) := '2C742C6E297B6966284D6174682E61627328652D74293E322E352A6E297B6C657420722C613B72657475726E20653C743F28723D652B2E37352A6E2C613D742D2E37352A6E293A28723D652D2E37352A6E2C613D742B2E37352A6E292C693D6F5428652C';
wwv_flow_imp.g_varchar2_table(12304) := '72292C6F3D6F5428612C74292C733D2E33332C66756E6374696F6E2865297B72657475726E20653C733F6928652F73293A6F2828652D73292F28312D7329297D7D76617220692C6F2C733B72657475726E206F5428652C74297D646973706F736528297B';
wwv_flow_imp.g_varchar2_table(12305) := '6E756C6C213D3D746869732E616E696D6174696F6E4672616D65446973706F7361626C65262628746869732E616E696D6174696F6E4672616D65446973706F7361626C652E646973706F736528292C746869732E616E696D6174696F6E4672616D654469';
wwv_flow_imp.g_varchar2_table(12306) := '73706F7361626C653D6E756C6C297D6163636570745363726F6C6C44696D656E73696F6E732865297B746869732E746F3D652E776974685363726F6C6C506F736974696F6E28746869732E746F292C746869732E5F696E6974416E696D6174696F6E7328';
wwv_flow_imp.g_varchar2_table(12307) := '297D7469636B28297B72657475726E20746869732E5F7469636B28446174652E6E6F772829297D5F7469636B2865297B636F6E737420743D28652D746869732E737461727454696D65292F746869732E6475726174696F6E3B696628743C31297B636F6E';
wwv_flow_imp.g_varchar2_table(12308) := '737420653D746869732E7363726F6C6C4C6566742874292C6E3D746869732E7363726F6C6C546F702874293B72657475726E206E657720695428652C6E2C2131297D72657475726E206E657720695428746869732E746F2E7363726F6C6C4C6566742C74';
wwv_flow_imp.g_varchar2_table(12309) := '6869732E746F2E7363726F6C6C546F702C2130297D636F6D62696E6528652C742C6E297B72657475726E2073542E737461727428652C742C6E297D73746174696320737461727428652C742C6E297B6E2B3D31303B636F6E737420693D446174652E6E6F';
wwv_flow_imp.g_varchar2_table(12310) := '7728292D31303B72657475726E206E657720735428652C742C692C6E297D7D7661722072542C61543D6E28313430292C6C543D7B7D3B6C542E7374796C655461675472616E73666F726D3D6A7228292C6C542E736574417474726962757465733D567228';
wwv_flow_imp.g_varchar2_table(12311) := '292C6C542E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6C542E646F6D4150493D4F7228292C6C542E696E736572745374796C65456C656D656E743D487228292C4E7228292861542E412C6C54292C61542E41262661542E';
wwv_flow_imp.g_varchar2_table(12312) := '412E6C6F63616C73262661542E412E6C6F63616C733B636C6173732063547B636F6E7374727563746F7228652C742C6E297B746869732E74696D657374616D703D652C746869732E64656C7461583D742C746869732E64656C7461593D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(12313) := '73636F72653D307D7D636C6173732064547B636F6E7374727563746F7228297B746869732E5F63617061636974793D352C746869732E5F6D656D6F72793D5B5D2C746869732E5F66726F6E743D2D312C746869732E5F726561723D2D317D697350687973';
wwv_flow_imp.g_varchar2_table(12314) := '6963616C4D6F757365576865656C28297B6966282D313D3D3D746869732E5F66726F6E7426262D313D3D3D746869732E5F726561722972657475726E21313B6C657420653D312C743D302C6E3D312C693D746869732E5F726561723B666F72283B3B297B';
wwv_flow_imp.g_varchar2_table(12315) := '636F6E7374206F3D693D3D3D746869732E5F66726F6E743F653A4D6174682E706F7728322C2D6E293B696628652D3D6F2C742B3D746869732E5F6D656D6F72795B695D2E73636F72652A6F2C693D3D3D746869732E5F66726F6E7429627265616B3B693D';
wwv_flow_imp.g_varchar2_table(12316) := '28746869732E5F63617061636974792B692D312925746869732E5F63617061636974792C6E2B2B7D72657475726E20743C3D2E357D6163636570745374616E64617264576865656C4576656E742865297B69662868297B636F6E7374206E3D28743D7273';
wwv_flow_imp.g_varchar2_table(12317) := '28652E62726F777365724576656E74292C722E494E5354414E43452E6765745A6F6F6D466163746F72287429293B746869732E61636365707428446174652E6E6F7728292C652E64656C7461582A6E2C652E64656C7461592A6E297D656C736520746869';
wwv_flow_imp.g_varchar2_table(12318) := '732E61636365707428446174652E6E6F7728292C652E64656C7461582C652E64656C746159293B76617220747D61636365707428652C742C6E297B6C657420693D6E756C6C3B636F6E7374206F3D6E657720635428652C742C6E293B2D313D3D3D746869';
wwv_flow_imp.g_varchar2_table(12319) := '732E5F66726F6E7426262D313D3D3D746869732E5F726561723F28746869732E5F6D656D6F72795B305D3D6F2C746869732E5F66726F6E743D302C746869732E5F726561723D30293A28693D746869732E5F6D656D6F72795B746869732E5F726561725D';
wwv_flow_imp.g_varchar2_table(12320) := '2C746869732E5F726561723D28746869732E5F726561722B312925746869732E5F63617061636974792C746869732E5F726561723D3D3D746869732E5F66726F6E74262628746869732E5F66726F6E743D28746869732E5F66726F6E742B312925746869';
wwv_flow_imp.g_varchar2_table(12321) := '732E5F6361706163697479292C746869732E5F6D656D6F72795B746869732E5F726561725D3D6F292C6F2E73636F72653D746869732E5F636F6D7075746553636F7265286F2C69297D5F636F6D7075746553636F726528652C74297B6966284D6174682E';
wwv_flow_imp.g_varchar2_table(12322) := '61627328652E64656C746158293E3026264D6174682E61627328652E64656C746159293E302972657475726E20313B6C6574206E3D2E353B696628746869732E5F6973416C6D6F7374496E7428652E64656C746158292626746869732E5F6973416C6D6F';
wwv_flow_imp.g_varchar2_table(12323) := '7374496E7428652E64656C746159297C7C286E2B3D2E3235292C74297B636F6E737420693D4D6174682E61627328652E64656C746158292C6F3D4D6174682E61627328652E64656C746159292C733D4D6174682E61627328742E64656C746158292C723D';
wwv_flow_imp.g_varchar2_table(12324) := '4D6174682E61627328742E64656C746159292C613D4D6174682E6D6178284D6174682E6D696E28692C73292C31292C6C3D4D6174682E6D6178284D6174682E6D696E286F2C72292C31292C633D4D6174682E6D617828692C73292C643D4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(12325) := '78286F2C72293B6325613D3D30262664256C3D3D302626286E2D3D2E35297D72657475726E204D6174682E6D696E284D6174682E6D6178286E2C30292C31297D5F6973416C6D6F7374496E742865297B72657475726E204D6174682E616273284D617468';
wwv_flow_imp.g_varchar2_table(12326) := '2E726F756E642865292D65293C2E30317D7D64542E494E5354414E43453D6E65772064543B636C61737320685420657874656E64732047447B676574206F7074696F6E7328297B72657475726E20746869732E5F6F7074696F6E737D636F6E7374727563';
wwv_flow_imp.g_varchar2_table(12327) := '746F7228652C742C6E297B737570657228292C746869732E5F6F6E5363726F6C6C3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E5363726F6C6C3D746869732E5F6F6E5363726F6C6C2E6576656E742C746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(12328) := '57696C6C5363726F6C6C3D746869732E5F7265676973746572286E6577204374292C652E7374796C652E6F766572666C6F773D2268696464656E222C746869732E5F6F7074696F6E733D66756E6374696F6E2865297B636F6E737420743D7B6C617A7952';
wwv_flow_imp.g_varchar2_table(12329) := '656E6465723A766F69642030213D3D652E6C617A7952656E6465722626652E6C617A7952656E6465722C636C6173734E616D653A766F69642030213D3D652E636C6173734E616D653F652E636C6173734E616D653A22222C757365536861646F77733A76';
wwv_flow_imp.g_varchar2_table(12330) := '6F696420303D3D3D652E757365536861646F77737C7C652E757365536861646F77732C68616E646C654D6F757365576865656C3A766F696420303D3D3D652E68616E646C654D6F757365576865656C7C7C652E68616E646C654D6F757365576865656C2C';
wwv_flow_imp.g_varchar2_table(12331) := '666C6970417865733A766F69642030213D3D652E666C6970417865732626652E666C6970417865732C636F6E73756D654D6F757365576865656C49665363726F6C6C62617249734E65656465643A766F69642030213D3D652E636F6E73756D654D6F7573';
wwv_flow_imp.g_varchar2_table(12332) := '65576865656C49665363726F6C6C62617249734E65656465642626652E636F6E73756D654D6F757365576865656C49665363726F6C6C62617249734E65656465642C616C77617973436F6E73756D654D6F757365576865656C3A766F69642030213D3D65';
wwv_flow_imp.g_varchar2_table(12333) := '2E616C77617973436F6E73756D654D6F757365576865656C2626652E616C77617973436F6E73756D654D6F757365576865656C2C7363726F6C6C59546F583A766F69642030213D3D652E7363726F6C6C59546F582626652E7363726F6C6C59546F582C6D';
wwv_flow_imp.g_varchar2_table(12334) := '6F757365576865656C5363726F6C6C53656E73697469766974793A766F69642030213D3D652E6D6F757365576865656C5363726F6C6C53656E73697469766974793F652E6D6F757365576865656C5363726F6C6C53656E73697469766974793A312C6661';
wwv_flow_imp.g_varchar2_table(12335) := '73745363726F6C6C53656E73697469766974793A766F69642030213D3D652E666173745363726F6C6C53656E73697469766974793F652E666173745363726F6C6C53656E73697469766974793A352C7363726F6C6C507265646F6D696E616E7441786973';
wwv_flow_imp.g_varchar2_table(12336) := '3A766F696420303D3D3D652E7363726F6C6C507265646F6D696E616E74417869737C7C652E7363726F6C6C507265646F6D696E616E74417869732C6D6F757365576865656C536D6F6F74685363726F6C6C3A766F696420303D3D3D652E6D6F7573655768';
wwv_flow_imp.g_varchar2_table(12337) := '65656C536D6F6F74685363726F6C6C7C7C652E6D6F757365576865656C536D6F6F74685363726F6C6C2C6172726F7753697A653A766F69642030213D3D652E6172726F7753697A653F652E6172726F7753697A653A31312C6C697374656E4F6E446F6D4E';
wwv_flow_imp.g_varchar2_table(12338) := '6F64653A766F69642030213D3D652E6C697374656E4F6E446F6D4E6F64653F652E6C697374656E4F6E446F6D4E6F64653A6E756C6C2C686F72697A6F6E74616C3A766F69642030213D3D652E686F72697A6F6E74616C3F652E686F72697A6F6E74616C3A';
wwv_flow_imp.g_varchar2_table(12339) := '312C686F72697A6F6E74616C5363726F6C6C62617253697A653A766F69642030213D3D652E686F72697A6F6E74616C5363726F6C6C62617253697A653F652E686F72697A6F6E74616C5363726F6C6C62617253697A653A31302C686F72697A6F6E74616C';
wwv_flow_imp.g_varchar2_table(12340) := '536C6964657253697A653A766F69642030213D3D652E686F72697A6F6E74616C536C6964657253697A653F652E686F72697A6F6E74616C536C6964657253697A653A302C686F72697A6F6E74616C4861734172726F77733A766F69642030213D3D652E68';
wwv_flow_imp.g_varchar2_table(12341) := '6F72697A6F6E74616C4861734172726F77732626652E686F72697A6F6E74616C4861734172726F77732C766572746963616C3A766F69642030213D3D652E766572746963616C3F652E766572746963616C3A312C766572746963616C5363726F6C6C6261';
wwv_flow_imp.g_varchar2_table(12342) := '7253697A653A766F69642030213D3D652E766572746963616C5363726F6C6C62617253697A653F652E766572746963616C5363726F6C6C62617253697A653A31302C766572746963616C4861734172726F77733A766F69642030213D3D652E7665727469';
wwv_flow_imp.g_varchar2_table(12343) := '63616C4861734172726F77732626652E766572746963616C4861734172726F77732C766572746963616C536C6964657253697A653A766F69642030213D3D652E766572746963616C536C6964657253697A653F652E766572746963616C536C6964657253';
wwv_flow_imp.g_varchar2_table(12344) := '697A653A302C7363726F6C6C4279506167653A766F69642030213D3D652E7363726F6C6C4279506167652626652E7363726F6C6C4279506167657D3B72657475726E20742E686F72697A6F6E74616C536C6964657253697A653D766F69642030213D3D65';
wwv_flow_imp.g_varchar2_table(12345) := '2E686F72697A6F6E74616C536C6964657253697A653F652E686F72697A6F6E74616C536C6964657253697A653A742E686F72697A6F6E74616C5363726F6C6C62617253697A652C742E766572746963616C536C6964657253697A653D766F69642030213D';
wwv_flow_imp.g_varchar2_table(12346) := '3D652E766572746963616C536C6964657253697A653F652E766572746963616C536C6964657253697A653A742E766572746963616C5363726F6C6C62617253697A652C71262628742E636C6173734E616D652B3D22206D616322292C747D2874292C7468';
wwv_flow_imp.g_varchar2_table(12347) := '69732E5F7363726F6C6C61626C653D6E2C746869732E5F726567697374657228746869732E5F7363726F6C6C61626C652E6F6E5363726F6C6C2828653D3E7B746869732E5F6F6E57696C6C5363726F6C6C2E666972652865292C746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(12348) := '645363726F6C6C2865292C746869732E5F6F6E5363726F6C6C2E666972652865297D2929293B636F6E737420693D7B6F6E4D6F757365576865656C3A653D3E746869732E5F6F6E4D6F757365576865656C2865292C6F6E4472616753746172743A28293D';
wwv_flow_imp.g_varchar2_table(12349) := '3E746869732E5F6F6E44726167537461727428292C6F6E44726167456E643A28293D3E746869732E5F6F6E44726167456E6428297D3B746869732E5F766572746963616C5363726F6C6C6261723D746869732E5F7265676973746572286E657720655428';
wwv_flow_imp.g_varchar2_table(12350) := '746869732E5F7363726F6C6C61626C652C746869732E5F6F7074696F6E732C6929292C746869732E5F686F72697A6F6E74616C5363726F6C6C6261723D746869732E5F7265676973746572286E6577204A4428746869732E5F7363726F6C6C61626C652C';
wwv_flow_imp.g_varchar2_table(12351) := '746869732E5F6F7074696F6E732C6929292C746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D7363726F6C6C';
wwv_flow_imp.g_varchar2_table(12352) := '61626C652D656C656D656E7420222B746869732E5F6F7074696F6E732E636C6173734E616D652C746869732E5F646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C746869732E5F646F6D4E6F';
wwv_flow_imp.g_varchar2_table(12353) := '64652E7374796C652E706F736974696F6E3D2272656C6174697665222C746869732E5F646F6D4E6F64652E7374796C652E6F766572666C6F773D2268696464656E222C746869732E5F646F6D4E6F64652E617070656E644368696C642865292C74686973';
wwv_flow_imp.g_varchar2_table(12354) := '2E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F686F72697A6F6E74616C5363726F6C6C6261722E646F6D4E6F64652E646F6D4E6F6465292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F766572';
wwv_flow_imp.g_varchar2_table(12355) := '746963616C5363726F6C6C6261722E646F6D4E6F64652E646F6D4E6F6465292C746869732E5F6F7074696F6E732E757365536861646F77733F28746869732E5F6C656674536861646F77446F6D4E6F64653D734528646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(12356) := '456C656D656E7428226469762229292C746869732E5F6C656674536861646F77446F6D4E6F64652E736574436C6173734E616D652822736861646F7722292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F6C65667453';
wwv_flow_imp.g_varchar2_table(12357) := '6861646F77446F6D4E6F64652E646F6D4E6F6465292C746869732E5F746F70536861646F77446F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F746F70536861646F77446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(12358) := '652E736574436C6173734E616D652822736861646F7722292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F746F70536861646F77446F6D4E6F64652E646F6D4E6F6465292C746869732E5F746F704C65667453686164';
wwv_flow_imp.g_varchar2_table(12359) := '6F77446F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F746F704C656674536861646F77446F6D4E6F64652E736574436C6173734E616D652822736861646F7722292C746869732E5F';
wwv_flow_imp.g_varchar2_table(12360) := '646F6D4E6F64652E617070656E644368696C6428746869732E5F746F704C656674536861646F77446F6D4E6F64652E646F6D4E6F646529293A28746869732E5F6C656674536861646F77446F6D4E6F64653D6E756C6C2C746869732E5F746F7053686164';
wwv_flow_imp.g_varchar2_table(12361) := '6F77446F6D4E6F64653D6E756C6C2C746869732E5F746F704C656674536861646F77446F6D4E6F64653D6E756C6C292C746869732E5F6C697374656E4F6E446F6D4E6F64653D746869732E5F6F7074696F6E732E6C697374656E4F6E446F6D4E6F64657C';
wwv_flow_imp.g_varchar2_table(12362) := '7C746869732E5F646F6D4E6F64652C746869732E5F6D6F757365576865656C546F446973706F73653D5B5D2C746869732E5F7365744C697374656E696E67546F4D6F757365576865656C28746869732E5F6F7074696F6E732E68616E646C654D6F757365';
wwv_flow_imp.g_varchar2_table(12363) := '576865656C292C746869732E6F6E6D6F7573656F76657228746869732E5F6C697374656E4F6E446F6D4E6F64652C28653D3E746869732E5F6F6E4D6F7573654F76657228652929292C746869732E6F6E6D6F7573656C6561766528746869732E5F6C6973';
wwv_flow_imp.g_varchar2_table(12364) := '74656E4F6E446F6D4E6F64652C28653D3E746869732E5F6F6E4D6F7573654C6561766528652929292C746869732E5F6869646554696D656F75743D746869732E5F7265676973746572286E6577202474292C746869732E5F69734472616767696E673D21';
wwv_flow_imp.g_varchar2_table(12365) := '312C746869732E5F6D6F75736549734F7665723D21312C746869732E5F73686F756C6452656E6465723D21302C746869732E5F72657665616C4F6E5363726F6C6C3D21307D646973706F736528297B746869732E5F6D6F757365576865656C546F446973';
wwv_flow_imp.g_varchar2_table(12366) := '706F73653D6F7428746869732E5F6D6F757365576865656C546F446973706F7365292C73757065722E646973706F736528297D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D6765744F7665727669657752756C65';
wwv_flow_imp.g_varchar2_table(12367) := '724C61796F7574496E666F28297B72657475726E7B706172656E743A746869732E5F646F6D4E6F64652C696E736572744265666F72653A746869732E5F766572746963616C5363726F6C6C6261722E646F6D4E6F64652E646F6D4E6F64657D7D64656C65';
wwv_flow_imp.g_varchar2_table(12368) := '67617465566572746963616C5363726F6C6C626172506F696E746572446F776E2865297B746869732E5F766572746963616C5363726F6C6C6261722E64656C6567617465506F696E746572446F776E2865297D6765745363726F6C6C44696D656E73696F';
wwv_flow_imp.g_varchar2_table(12369) := '6E7328297B72657475726E20746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328297D7365745363726F6C6C44696D656E73696F6E732865297B746869732E5F7363726F6C6C61626C652E7365745363726F6C6C';
wwv_flow_imp.g_varchar2_table(12370) := '44696D656E73696F6E7328652C2131297D757064617465436C6173734E616D652865297B746869732E5F6F7074696F6E732E636C6173734E616D653D652C71262628746869732E5F6F7074696F6E732E636C6173734E616D652B3D22206D616322292C74';
wwv_flow_imp.g_varchar2_table(12371) := '6869732E5F646F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D7363726F6C6C61626C652D656C656D656E7420222B746869732E5F6F7074696F6E732E636C6173734E616D657D7570646174654F7074696F6E732865297B766F6964203021';
wwv_flow_imp.g_varchar2_table(12372) := '3D3D652E68616E646C654D6F757365576865656C262628746869732E5F6F7074696F6E732E68616E646C654D6F757365576865656C3D652E68616E646C654D6F757365576865656C2C746869732E5F7365744C697374656E696E67546F4D6F7573655768';
wwv_flow_imp.g_varchar2_table(12373) := '65656C28746869732E5F6F7074696F6E732E68616E646C654D6F757365576865656C29292C766F69642030213D3D652E6D6F757365576865656C5363726F6C6C53656E7369746976697479262628746869732E5F6F7074696F6E732E6D6F757365576865';
wwv_flow_imp.g_varchar2_table(12374) := '656C5363726F6C6C53656E73697469766974793D652E6D6F757365576865656C5363726F6C6C53656E7369746976697479292C766F69642030213D3D652E666173745363726F6C6C53656E7369746976697479262628746869732E5F6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(12375) := '666173745363726F6C6C53656E73697469766974793D652E666173745363726F6C6C53656E7369746976697479292C766F69642030213D3D652E7363726F6C6C507265646F6D696E616E7441786973262628746869732E5F6F7074696F6E732E7363726F';
wwv_flow_imp.g_varchar2_table(12376) := '6C6C507265646F6D696E616E74417869733D652E7363726F6C6C507265646F6D696E616E7441786973292C766F69642030213D3D652E686F72697A6F6E74616C262628746869732E5F6F7074696F6E732E686F72697A6F6E74616C3D652E686F72697A6F';
wwv_flow_imp.g_varchar2_table(12377) := '6E74616C292C766F69642030213D3D652E766572746963616C262628746869732E5F6F7074696F6E732E766572746963616C3D652E766572746963616C292C766F69642030213D3D652E686F72697A6F6E74616C5363726F6C6C62617253697A65262628';
wwv_flow_imp.g_varchar2_table(12378) := '746869732E5F6F7074696F6E732E686F72697A6F6E74616C5363726F6C6C62617253697A653D652E686F72697A6F6E74616C5363726F6C6C62617253697A65292C766F69642030213D3D652E766572746963616C5363726F6C6C62617253697A65262628';
wwv_flow_imp.g_varchar2_table(12379) := '746869732E5F6F7074696F6E732E766572746963616C5363726F6C6C62617253697A653D652E766572746963616C5363726F6C6C62617253697A65292C766F69642030213D3D652E7363726F6C6C427950616765262628746869732E5F6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(12380) := '2E7363726F6C6C4279506167653D652E7363726F6C6C427950616765292C746869732E5F686F72697A6F6E74616C5363726F6C6C6261722E7570646174654F7074696F6E7328746869732E5F6F7074696F6E73292C746869732E5F766572746963616C53';
wwv_flow_imp.g_varchar2_table(12381) := '63726F6C6C6261722E7570646174654F7074696F6E7328746869732E5F6F7074696F6E73292C746869732E5F6F7074696F6E732E6C617A7952656E6465727C7C746869732E5F72656E64657228297D64656C65676174655363726F6C6C46726F6D4D6F75';
wwv_flow_imp.g_varchar2_table(12382) := '7365576865656C4576656E742865297B746869732E5F6F6E4D6F757365576865656C286E6577205165286529297D5F7365744C697374656E696E67546F4D6F757365576865656C2865297B696628746869732E5F6D6F757365576865656C546F44697370';
wwv_flow_imp.g_varchar2_table(12383) := '6F73652E6C656E6774683E30213D3D65262628746869732E5F6D6F757365576865656C546F446973706F73653D6F7428746869732E5F6D6F757365576865656C546F446973706F7365292C6529297B636F6E737420653D653D3E7B746869732E5F6F6E4D';
wwv_flow_imp.g_varchar2_table(12384) := '6F757365576865656C286E6577205165286529297D3B746869732E5F6D6F757365576865656C546F446973706F73652E7075736828627328746869732E5F6C697374656E4F6E446F6D4E6F64652C61722E4D4F5553455F574845454C2C652C7B70617373';
wwv_flow_imp.g_varchar2_table(12385) := '6976653A21317D29297D7D5F6F6E4D6F757365576865656C2865297B76617220743B6966286E756C6C3D3D3D28743D652E62726F777365724576656E74297C7C766F696420303D3D3D743F766F696420303A742E64656661756C7450726576656E746564';
wwv_flow_imp.g_varchar2_table(12386) := '2972657475726E3B636F6E7374206E3D64542E494E5354414E43453B6E2E6163636570745374616E64617264576865656C4576656E742865293B6C657420693D21313B696628652E64656C7461597C7C652E64656C746158297B6C657420743D652E6465';
wwv_flow_imp.g_varchar2_table(12387) := '6C7461592A746869732E5F6F7074696F6E732E6D6F757365576865656C5363726F6C6C53656E73697469766974792C6F3D652E64656C7461582A746869732E5F6F7074696F6E732E6D6F757365576865656C5363726F6C6C53656E73697469766974793B';
wwv_flow_imp.g_varchar2_table(12388) := '746869732E5F6F7074696F6E732E7363726F6C6C507265646F6D696E616E7441786973262628746869732E5F6F7074696F6E732E7363726F6C6C59546F5826266F2B743D3D3D303F6F3D743D303A4D6174682E6162732874293E3D4D6174682E61627328';
wwv_flow_imp.g_varchar2_table(12389) := '6F293F6F3D303A743D30292C746869732E5F6F7074696F6E732E666C6970417865732626285B742C6F5D3D5B6F2C745D293B636F6E737420733D21712626652E62726F777365724576656E742626652E62726F777365724576656E742E73686966744B65';
wwv_flow_imp.g_varchar2_table(12390) := '793B21746869732E5F6F7074696F6E732E7363726F6C6C59546F58262621737C7C6F7C7C286F3D742C743D30292C652E62726F777365724576656E742626652E62726F777365724576656E742E616C744B65792626286F2A3D746869732E5F6F7074696F';
wwv_flow_imp.g_varchar2_table(12391) := '6E732E666173745363726F6C6C53656E73697469766974792C742A3D746869732E5F6F7074696F6E732E666173745363726F6C6C53656E7369746976697479293B636F6E737420723D746869732E5F7363726F6C6C61626C652E67657446757475726553';
wwv_flow_imp.g_varchar2_table(12392) := '63726F6C6C506F736974696F6E28293B6C657420613D7B7D3B69662874297B636F6E737420653D35302A742C6E3D722E7363726F6C6C546F702D28653C303F4D6174682E666C6F6F722865293A4D6174682E6365696C286529293B746869732E5F766572';
wwv_flow_imp.g_varchar2_table(12393) := '746963616C5363726F6C6C6261722E77726974655363726F6C6C506F736974696F6E28612C6E297D6966286F297B636F6E737420653D35302A6F2C743D722E7363726F6C6C4C6566742D28653C303F4D6174682E666C6F6F722865293A4D6174682E6365';
wwv_flow_imp.g_varchar2_table(12394) := '696C286529293B746869732E5F686F72697A6F6E74616C5363726F6C6C6261722E77726974655363726F6C6C506F736974696F6E28612C74297D613D746869732E5F7363726F6C6C61626C652E76616C69646174655363726F6C6C506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(12395) := '61292C28722E7363726F6C6C4C656674213D3D612E7363726F6C6C4C6566747C7C722E7363726F6C6C546F70213D3D612E7363726F6C6C546F7029262628746869732E5F6F7074696F6E732E6D6F757365576865656C536D6F6F74685363726F6C6C2626';
wwv_flow_imp.g_varchar2_table(12396) := '6E2E6973506879736963616C4D6F757365576865656C28293F746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E536D6F6F74682861293A746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974';
wwv_flow_imp.g_varchar2_table(12397) := '696F6E4E6F772861292C693D2130297D6C6574206F3D693B216F2626746869732E5F6F7074696F6E732E616C77617973436F6E73756D654D6F757365576865656C2626286F3D2130292C216F2626746869732E5F6F7074696F6E732E636F6E73756D654D';
wwv_flow_imp.g_varchar2_table(12398) := '6F757365576865656C49665363726F6C6C62617249734E6565646564262628746869732E5F766572746963616C5363726F6C6C6261722E69734E656564656428297C7C746869732E5F686F72697A6F6E74616C5363726F6C6C6261722E69734E65656465';
wwv_flow_imp.g_varchar2_table(12399) := '642829292626286F3D2130292C6F262628652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E2829297D5F6F6E4469645363726F6C6C2865297B746869732E5F73686F756C6452656E6465723D746869732E5F686F';
wwv_flow_imp.g_varchar2_table(12400) := '72697A6F6E74616C5363726F6C6C6261722E6F6E4469645363726F6C6C2865297C7C746869732E5F73686F756C6452656E6465722C746869732E5F73686F756C6452656E6465723D746869732E5F766572746963616C5363726F6C6C6261722E6F6E4469';
wwv_flow_imp.g_varchar2_table(12401) := '645363726F6C6C2865297C7C746869732E5F73686F756C6452656E6465722C746869732E5F6F7074696F6E732E757365536861646F7773262628746869732E5F73686F756C6452656E6465723D2130292C746869732E5F72657665616C4F6E5363726F6C';
wwv_flow_imp.g_varchar2_table(12402) := '6C2626746869732E5F72657665616C28292C746869732E5F6F7074696F6E732E6C617A7952656E6465727C7C746869732E5F72656E64657228297D72656E6465724E6F7728297B69662821746869732E5F6F7074696F6E732E6C617A7952656E64657229';
wwv_flow_imp.g_varchar2_table(12403) := '7468726F77206E6577204572726F722822506C656173652075736520606C617A7952656E6465726020746F6765746865722077697468206072656E6465724E6F77602122293B746869732E5F72656E64657228297D5F72656E64657228297B6966287468';
wwv_flow_imp.g_varchar2_table(12404) := '69732E5F73686F756C6452656E646572262628746869732E5F73686F756C6452656E6465723D21312C746869732E5F686F72697A6F6E74616C5363726F6C6C6261722E72656E64657228292C746869732E5F766572746963616C5363726F6C6C6261722E';
wwv_flow_imp.g_varchar2_table(12405) := '72656E64657228292C746869732E5F6F7074696F6E732E757365536861646F777329297B636F6E737420653D746869732E5F7363726F6C6C61626C652E67657443757272656E745363726F6C6C506F736974696F6E28292C743D652E7363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(12406) := '703E302C6E3D652E7363726F6C6C4C6566743E302C693D6E3F22206C656674223A22222C6F3D743F2220746F70223A22222C733D6E7C7C743F2220746F702D6C6566742D636F726E6572223A22223B746869732E5F6C656674536861646F77446F6D4E6F';
wwv_flow_imp.g_varchar2_table(12407) := '64652E736574436C6173734E616D652860736861646F77247B697D60292C746869732E5F746F70536861646F77446F6D4E6F64652E736574436C6173734E616D652860736861646F77247B6F7D60292C746869732E5F746F704C656674536861646F7744';
wwv_flow_imp.g_varchar2_table(12408) := '6F6D4E6F64652E736574436C6173734E616D652860736861646F77247B737D247B6F7D247B697D60297D7D5F6F6E44726167537461727428297B746869732E5F69734472616767696E673D21302C746869732E5F72657665616C28297D5F6F6E44726167';
wwv_flow_imp.g_varchar2_table(12409) := '456E6428297B746869732E5F69734472616767696E673D21312C746869732E5F6869646528297D5F6F6E4D6F7573654C656176652865297B746869732E5F6D6F75736549734F7665723D21312C746869732E5F6869646528297D5F6F6E4D6F7573654F76';
wwv_flow_imp.g_varchar2_table(12410) := '65722865297B746869732E5F6D6F75736549734F7665723D21302C746869732E5F72657665616C28297D5F72657665616C28297B746869732E5F766572746963616C5363726F6C6C6261722E626567696E52657665616C28292C746869732E5F686F7269';
wwv_flow_imp.g_varchar2_table(12411) := '7A6F6E74616C5363726F6C6C6261722E626567696E52657665616C28292C746869732E5F7363686564756C654869646528297D5F6869646528297B746869732E5F6D6F75736549734F7665727C7C746869732E5F69734472616767696E677C7C28746869';
wwv_flow_imp.g_varchar2_table(12412) := '732E5F766572746963616C5363726F6C6C6261722E626567696E4869646528292C746869732E5F686F72697A6F6E74616C5363726F6C6C6261722E626567696E486964652829297D5F7363686564756C654869646528297B746869732E5F6D6F75736549';
wwv_flow_imp.g_varchar2_table(12413) := '734F7665727C7C746869732E5F69734472616767696E677C7C746869732E5F6869646554696D656F75742E63616E63656C416E64536574282828293D3E746869732E5F686964652829292C353030297D7D636C61737320755420657874656E6473206854';
wwv_flow_imp.g_varchar2_table(12414) := '7B636F6E7374727563746F7228652C74297B28743D747C7C7B7D292E6D6F757365576865656C536D6F6F74685363726F6C6C3D21313B636F6E7374206E3D6E6577206E54287B666F726365496E746567657256616C7565733A21302C736D6F6F74685363';
wwv_flow_imp.g_varchar2_table(12415) := '726F6C6C4475726174696F6E3A302C7363686564756C6541744E657874416E696D6174696F6E4672616D653A743D3E78732872732865292C74297D293B737570657228652C742C6E292C746869732E5F7265676973746572286E297D7365745363726F6C';
wwv_flow_imp.g_varchar2_table(12416) := '6C506F736974696F6E2865297B746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E4E6F772865297D7D636C61737320705420657874656E64732068547B636F6E7374727563746F7228652C742C6E297B737570657228';
wwv_flow_imp.g_varchar2_table(12417) := '652C742C6E297D7365745363726F6C6C506F736974696F6E2865297B652E7265757365416E696D6174696F6E3F746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E536D6F6F746828652C652E7265757365416E696D61';
wwv_flow_imp.g_varchar2_table(12418) := '74696F6E293A746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E4E6F772865297D6765745363726F6C6C506F736974696F6E28297B72657475726E20746869732E5F7363726F6C6C61626C652E67657443757272656E';
wwv_flow_imp.g_varchar2_table(12419) := '745363726F6C6C506F736974696F6E28297D7D636C61737320675420657874656E64732068547B636F6E7374727563746F7228652C74297B28743D747C7C7B7D292E6D6F757365576865656C536D6F6F74685363726F6C6C3D21313B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(12420) := '6E6577206E54287B666F726365496E746567657256616C7565733A21312C736D6F6F74685363726F6C6C4475726174696F6E3A302C7363686564756C6541744E657874416E696D6174696F6E4672616D653A743D3E78732872732865292C74297D293B73';
wwv_flow_imp.g_varchar2_table(12421) := '7570657228652C742C6E292C746869732E5F7265676973746572286E292C746869732E5F656C656D656E743D652C746869732E5F726567697374657228746869732E6F6E5363726F6C6C2828653D3E7B652E7363726F6C6C546F704368616E6765642626';
wwv_flow_imp.g_varchar2_table(12422) := '28746869732E5F656C656D656E742E7363726F6C6C546F703D652E7363726F6C6C546F70292C652E7363726F6C6C4C6566744368616E676564262628746869732E5F656C656D656E742E7363726F6C6C4C6566743D652E7363726F6C6C4C656674297D29';
wwv_flow_imp.g_varchar2_table(12423) := '29292C746869732E7363616E446F6D4E6F646528297D7365745363726F6C6C506F736974696F6E2865297B746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E4E6F772865297D6765745363726F6C6C506F736974696F';
wwv_flow_imp.g_varchar2_table(12424) := '6E28297B72657475726E20746869732E5F7363726F6C6C61626C652E67657443757272656E745363726F6C6C506F736974696F6E28297D7363616E446F6D4E6F646528297B746869732E7365745363726F6C6C44696D656E73696F6E73287B7769647468';
wwv_flow_imp.g_varchar2_table(12425) := '3A746869732E5F656C656D656E742E636C69656E7457696474682C7363726F6C6C57696474683A746869732E5F656C656D656E742E7363726F6C6C57696474682C6865696768743A746869732E5F656C656D656E742E636C69656E744865696768742C73';
wwv_flow_imp.g_varchar2_table(12426) := '63726F6C6C4865696768743A746869732E5F656C656D656E742E7363726F6C6C4865696768747D292C746869732E7365745363726F6C6C506F736974696F6E287B7363726F6C6C4C6566743A746869732E5F656C656D656E742E7363726F6C6C4C656674';
wwv_flow_imp.g_varchar2_table(12427) := '2C7363726F6C6C546F703A746869732E5F656C656D656E742E7363726F6C6C546F707D297D7D66756E6374696F6E206D5428652C74297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F662074297B696628652E73746172743E3D692E7261';
wwv_flow_imp.g_varchar2_table(12428) := '6E67652E656E6429636F6E74696E75653B696628652E656E643C692E72616E67652E737461727429627265616B3B636F6E737420743D72542E696E7465727365637428652C692E72616E6765293B72542E6973456D7074792874297C7C6E2E7075736828';
wwv_flow_imp.g_varchar2_table(12429) := '7B72616E67653A742C73697A653A692E73697A657D297D72657475726E206E7D66756E6374696F6E206654287B73746172743A652C656E643A747D2C6E297B72657475726E7B73746172743A652B6E2C656E643A742B6E7D7D2166756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(12430) := '297B66756E6374696F6E207428652C74297B696628652E73746172743E3D742E656E647C7C742E73746172743E3D652E656E642972657475726E7B73746172743A302C656E643A307D3B636F6E7374206E3D4D6174682E6D617828652E73746172742C74';
wwv_flow_imp.g_varchar2_table(12431) := '2E7374617274292C693D4D6174682E6D696E28652E656E642C742E656E64293B72657475726E20692D6E3C3D303F7B73746172743A302C656E643A307D3A7B73746172743A6E2C656E643A697D7D66756E6374696F6E206E2865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(12432) := '2E656E642D652E73746172743C3D307D652E696E746572736563743D742C652E6973456D7074793D6E2C652E696E74657273656374733D66756E6374696F6E28652C69297B72657475726E216E287428652C6929297D2C652E72656C6174697665436F6D';
wwv_flow_imp.g_varchar2_table(12433) := '706C656D656E743D66756E6374696F6E28652C74297B636F6E737420693D5B5D2C6F3D7B73746172743A652E73746172742C656E643A4D6174682E6D696E28742E73746172742C652E656E64297D2C733D7B73746172743A4D6174682E6D617828742E65';
wwv_flow_imp.g_varchar2_table(12434) := '6E642C652E7374617274292C656E643A652E656E647D3B72657475726E206E286F297C7C692E70757368286F292C6E2873297C7C692E707573682873292C697D7D2872547C7C2872543D7B7D29293B636C6173732076547B6765742070616464696E6754';
wwv_flow_imp.g_varchar2_table(12435) := '6F7028297B72657475726E20746869732E5F70616464696E67546F707D7365742070616464696E67546F702865297B746869732E5F73697A653D746869732E5F73697A652B652D746869732E5F70616464696E67546F702C746869732E5F70616464696E';
wwv_flow_imp.g_varchar2_table(12436) := '67546F703D657D636F6E7374727563746F722865297B746869732E67726F7570733D5B5D2C746869732E5F73697A653D302C746869732E5F70616464696E67546F703D302C746869732E5F70616464696E67546F703D6E756C6C213D653F653A302C7468';
wwv_flow_imp.g_varchar2_table(12437) := '69732E5F73697A653D746869732E5F70616464696E67546F707D73706C69636528652C742C6E3D5B5D297B636F6E737420693D6E2E6C656E6774682D742C6F3D6D54287B73746172743A302C656E643A657D2C746869732E67726F757073292C733D6D54';
wwv_flow_imp.g_varchar2_table(12438) := '287B73746172743A652B742C656E643A4E756D6265722E504F5349544956455F494E46494E4954597D2C746869732E67726F757073292E6D61702828653D3E287B72616E67653A665428652E72616E67652C69292C73697A653A652E73697A657D292929';
wwv_flow_imp.g_varchar2_table(12439) := '2C723D6E2E6D6170282828742C6E293D3E287B72616E67653A7B73746172743A652B6E2C656E643A652B6E2B317D2C73697A653A742E73697A657D2929293B746869732E67726F7570733D66756E6374696F6E282E2E2E65297B72657475726E2066756E';
wwv_flow_imp.g_varchar2_table(12440) := '6374696F6E2865297B636F6E737420743D5B5D3B6C6574206E3D6E756C6C3B666F7228636F6E73742069206F662065297B636F6E737420653D692E72616E67652E73746172742C6F3D692E72616E67652E656E642C733D692E73697A653B6E2626733D3D';
wwv_flow_imp.g_varchar2_table(12441) := '3D6E2E73697A653F6E2E72616E67652E656E643D6F3A286E3D7B72616E67653A7B73746172743A652C656E643A6F7D2C73697A653A737D2C742E70757368286E29297D72657475726E20747D28652E726564756365282828652C74293D3E652E636F6E63';
wwv_flow_imp.g_varchar2_table(12442) := '6174287429292C5B5D29297D286F2C722C73292C746869732E5F73697A653D746869732E5F70616464696E67546F702B746869732E67726F7570732E726564756365282828652C74293D3E652B742E73697A652A28742E72616E67652E656E642D742E72';
wwv_flow_imp.g_varchar2_table(12443) := '616E67652E737461727429292C30297D67657420636F756E7428297B636F6E737420653D746869732E67726F7570732E6C656E6774683B72657475726E20653F746869732E67726F7570735B652D315D2E72616E67652E656E643A307D6765742073697A';
wwv_flow_imp.g_varchar2_table(12444) := '6528297B72657475726E20746869732E5F73697A657D696E64657841742865297B696628653C302972657475726E2D313B696628653C746869732E5F70616464696E67546F702972657475726E20303B6C657420743D302C6E3D746869732E5F70616464';
wwv_flow_imp.g_varchar2_table(12445) := '696E67546F703B666F7228636F6E73742069206F6620746869732E67726F757073297B636F6E7374206F3D692E72616E67652E656E642D692E72616E67652E73746172742C733D6E2B6F2A692E73697A653B696628653C732972657475726E20742B4D61';
wwv_flow_imp.g_varchar2_table(12446) := '74682E666C6F6F722828652D6E292F692E73697A65293B742B3D6F2C6E3D737D72657475726E20747D696E64657841667465722865297B72657475726E204D6174682E6D696E28746869732E696E64657841742865292B312C746869732E636F756E7429';
wwv_flow_imp.g_varchar2_table(12447) := '7D706F736974696F6E41742865297B696628653C302972657475726E2D313B6C657420743D302C6E3D303B666F7228636F6E73742069206F6620746869732E67726F757073297B636F6E7374206F3D692E72616E67652E656E642D692E72616E67652E73';
wwv_flow_imp.g_varchar2_table(12448) := '746172742C733D6E2B6F3B696628653C732972657475726E20746869732E5F70616464696E67546F702B742B28652D6E292A692E73697A653B742B3D6F2A692E73697A652C6E3D737D72657475726E2D317D7D636C6173732062547B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(12449) := '746F722865297B746869732E72656E6465726572733D652C746869732E63616368653D6E6577204D61702C746869732E7472616E73616374696F6E4E6F64657350656E64696E6752656D6F76616C3D6E6577205365742C746869732E696E5472616E7361';
wwv_flow_imp.g_varchar2_table(12450) := '6374696F6E3D21317D616C6C6F632865297B6C657420743D746869732E67657454656D706C61746543616368652865292E706F7028292C6E3D21313B69662874296E3D746869732E7472616E73616374696F6E4E6F64657350656E64696E6752656D6F76';
wwv_flow_imp.g_varchar2_table(12451) := '616C2E68617328742E646F6D4E6F6465292C6E2626746869732E7472616E73616374696F6E4E6F64657350656E64696E6752656D6F76616C2E64656C65746528742E646F6D4E6F6465293B656C73657B636F6E7374206E3D627228222E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(12452) := '6C6973742D726F7722293B743D7B646F6D4E6F64653A6E2C74656D706C61746549643A652C74656D706C617465446174613A746869732E67657452656E64657265722865292E72656E64657254656D706C617465286E297D7D72657475726E7B726F773A';
wwv_flow_imp.g_varchar2_table(12453) := '742C697352657573696E67436F6E6E6563746564446F6D4E6F64653A6E7D7D72656C656173652865297B652626746869732E72656C65617365526F772865297D7472616E736163742865297B696628746869732E696E5472616E73616374696F6E297468';
wwv_flow_imp.g_varchar2_table(12454) := '726F77206E6577204572726F722822416C726561647920696E207472616E73616374696F6E22293B746869732E696E5472616E73616374696F6E3D21303B7472797B6528297D66696E616C6C797B666F7228636F6E73742065206F6620746869732E7472';
wwv_flow_imp.g_varchar2_table(12455) := '616E73616374696F6E4E6F64657350656E64696E6752656D6F76616C29746869732E646F52656D6F76654E6F64652865293B746869732E7472616E73616374696F6E4E6F64657350656E64696E6752656D6F76616C2E636C65617228292C746869732E69';
wwv_flow_imp.g_varchar2_table(12456) := '6E5472616E73616374696F6E3D21317D7D72656C65617365526F772865297B636F6E73747B646F6D4E6F64653A742C74656D706C61746549643A6E7D3D653B74262628746869732E696E5472616E73616374696F6E3F746869732E7472616E7361637469';
wwv_flow_imp.g_varchar2_table(12457) := '6F6E4E6F64657350656E64696E6752656D6F76616C2E6164642874293A746869732E646F52656D6F76654E6F6465287429292C746869732E67657454656D706C6174654361636865286E292E707573682865297D646F52656D6F76654E6F64652865297B';
wwv_flow_imp.g_varchar2_table(12458) := '652E636C6173734C6973742E72656D6F766528227363726F6C6C696E6722292C66756E6374696F6E2865297B76617220743B7472797B6E756C6C3D3D3D28743D652E706172656E74456C656D656E74297C7C766F696420303D3D3D747C7C742E72656D6F';
wwv_flow_imp.g_varchar2_table(12459) := '76654368696C642865297D63617463682865297B7D7D2865297D67657454656D706C61746543616368652865297B6C657420743D746869732E63616368652E6765742865293B72657475726E20747C7C28743D5B5D2C746869732E63616368652E736574';
wwv_flow_imp.g_varchar2_table(12460) := '28652C7429292C747D646973706F736528297B746869732E63616368652E666F7245616368282828652C74293D3E7B666F7228636F6E7374206E206F66206529746869732E67657452656E64657265722874292E646973706F736554656D706C61746528';
wwv_flow_imp.g_varchar2_table(12461) := '6E2E74656D706C61746544617461292C6E2E74656D706C617465446174613D6E756C6C7D29292C746869732E63616368652E636C65617228292C746869732E7472616E73616374696F6E4E6F64657350656E64696E6752656D6F76616C2E636C65617228';
wwv_flow_imp.g_varchar2_table(12462) := '297D67657452656E64657265722865297B636F6E737420743D746869732E72656E6465726572732E6765742865293B6966282174297468726F77206E6577204572726F7228604E6F2072656E646572657220666F756E6420666F7220247B657D60293B72';
wwv_flow_imp.g_varchar2_table(12463) := '657475726E20747D7D766172205F543D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944';
wwv_flow_imp.g_varchar2_table(12464) := '657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F72617465';
wwv_flow_imp.g_varchar2_table(12465) := '28652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20';
wwv_flow_imp.g_varchar2_table(12466) := '733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D3B636F6E73742079543D7B43757272656E7444726167416E6444726F70446174613A766F696420307D2C77543D7B757365536861646F77733A21302C76';
wwv_flow_imp.g_varchar2_table(12467) := '6572746963616C5363726F6C6C4D6F64653A312C736574526F774C696E654865696768743A21302C736574526F774865696768743A21302C737570706F727444796E616D6963486569676874733A21312C646E643A7B67657444726167456C656D656E74';
wwv_flow_imp.g_varchar2_table(12468) := '733A653D3E5B655D2C676574447261675552493A28293D3E6E756C6C2C6F6E44726167537461727428297B7D2C6F6E447261674F7665723A28293D3E21312C64726F7028297B7D2C646973706F736528297B7D7D2C686F72697A6F6E74616C5363726F6C';
wwv_flow_imp.g_varchar2_table(12469) := '6C696E673A21312C7472616E73666F726D4F7074696D697A6174696F6E3A21302C616C77617973436F6E73756D654D6F757365576865656C3A21307D3B636C6173732043547B636F6E7374727563746F722865297B746869732E656C656D656E74733D65';
wwv_flow_imp.g_varchar2_table(12470) := '7D75706461746528297B7D6765744461746128297B72657475726E20746869732E656C656D656E74737D7D636C6173732053547B636F6E7374727563746F722865297B746869732E656C656D656E74733D657D75706461746528297B7D67657444617461';
wwv_flow_imp.g_varchar2_table(12471) := '28297B72657475726E20746869732E656C656D656E74737D7D636C6173732078547B636F6E7374727563746F7228297B746869732E74797065733D5B5D2C746869732E66696C65733D5B5D7D7570646174652865297B696628652E747970657326267468';
wwv_flow_imp.g_varchar2_table(12472) := '69732E74797065732E73706C69636528302C746869732E74797065732E6C656E6774682C2E2E2E652E7479706573292C652E66696C6573297B746869732E66696C65732E73706C69636528302C746869732E66696C65732E6C656E677468293B666F7228';
wwv_flow_imp.g_varchar2_table(12473) := '6C657420743D303B743C652E66696C65732E6C656E6774683B742B2B297B636F6E7374206E3D652E66696C65732E6974656D2874293B6E2626286E2E73697A657C7C6E2E74797065292626746869732E66696C65732E70757368286E297D7D7D67657444';
wwv_flow_imp.g_varchar2_table(12474) := '61746128297B72657475726E7B74797065733A746869732E74797065732C66696C65733A746869732E66696C65737D7D7D636C617373206B547B636F6E7374727563746F722865297B286E756C6C3D3D653F766F696420303A652E67657453657453697A';
wwv_flow_imp.g_varchar2_table(12475) := '65293F746869732E67657453657453697A653D652E67657453657453697A652E62696E642865293A746869732E67657453657453697A653D28652C742C6E293D3E6E2C286E756C6C3D3D653F766F696420303A652E676574506F73496E536574293F7468';
wwv_flow_imp.g_varchar2_table(12476) := '69732E676574506F73496E5365743D652E676574506F73496E5365742E62696E642865293A746869732E676574506F73496E5365743D28652C74293D3E742B312C286E756C6C3D3D653F766F696420303A652E676574526F6C65293F746869732E676574';
wwv_flow_imp.g_varchar2_table(12477) := '526F6C653D652E676574526F6C652E62696E642865293A746869732E676574526F6C653D653D3E226C6973746974656D222C286E756C6C3D3D653F766F696420303A652E6973436865636B6564293F746869732E6973436865636B65643D652E69734368';
wwv_flow_imp.g_varchar2_table(12478) := '65636B65642E62696E642865293A746869732E6973436865636B65643D653D3E7B7D7D7D636C6173732045547B67657420636F6E74656E7448656967687428297B72657475726E20746869732E72616E67654D61702E73697A657D676574206F6E446964';
wwv_flow_imp.g_varchar2_table(12479) := '5363726F6C6C28297B72657475726E20746869732E7363726F6C6C61626C65456C656D656E742E6F6E5363726F6C6C7D676574207363726F6C6C61626C65456C656D656E74446F6D4E6F646528297B72657475726E20746869732E7363726F6C6C61626C';
wwv_flow_imp.g_varchar2_table(12480) := '65456C656D656E742E676574446F6D4E6F646528297D67657420686F72697A6F6E74616C5363726F6C6C696E6728297B72657475726E20746869732E5F686F72697A6F6E74616C5363726F6C6C696E677D73657420686F72697A6F6E74616C5363726F6C';
wwv_flow_imp.g_varchar2_table(12481) := '6C696E672865297B69662865213D3D746869732E5F686F72697A6F6E74616C5363726F6C6C696E67297B696628652626746869732E737570706F727444796E616D696348656967687473297468726F77206E6577204572726F722822486F72697A6F6E74';
wwv_flow_imp.g_varchar2_table(12482) := '616C207363726F6C6C696E6720616E642064796E616D69632068656967687473206E6F7420737570706F727465642073696D756C74616E656F75736C7922293B696628746869732E5F686F72697A6F6E74616C5363726F6C6C696E673D652C746869732E';
wwv_flow_imp.g_varchar2_table(12483) := '646F6D4E6F64652E636C6173734C6973742E746F67676C652822686F72697A6F6E74616C2D7363726F6C6C696E67222C746869732E5F686F72697A6F6E74616C5363726F6C6C696E67292C746869732E5F686F72697A6F6E74616C5363726F6C6C696E67';
wwv_flow_imp.g_varchar2_table(12484) := '297B666F7228636F6E73742065206F6620746869732E6974656D7329746869732E6D6561737572654974656D57696474682865293B746869732E7570646174655363726F6C6C576964746828292C746869732E7363726F6C6C61626C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(12485) := '2E7365745363726F6C6C44696D656E73696F6E73287B77696474683A4F7328746869732E646F6D4E6F6465297D292C746869732E726F7773436F6E7461696E65722E7374796C652E77696474683D60247B4D6174682E6D617828746869732E7363726F6C';
wwv_flow_imp.g_varchar2_table(12486) := '6C57696474687C7C302C746869732E72656E6465725769647468297D7078607D656C736520746869732E7363726F6C6C61626C65456C656D656E74576964746844656C617965722E63616E63656C28292C746869732E7363726F6C6C61626C65456C656D';
wwv_flow_imp.g_varchar2_table(12487) := '656E742E7365745363726F6C6C44696D656E73696F6E73287B77696474683A746869732E72656E64657257696474682C7363726F6C6C57696474683A746869732E72656E64657257696474687D292C746869732E726F7773436F6E7461696E65722E7374';
wwv_flow_imp.g_varchar2_table(12488) := '796C652E77696474683D22227D7D636F6E7374727563746F7228652C742C6E2C693D7754297B766172206F2C732C722C612C6C2C632C642C682C752C702C672C6D2C663B696628746869732E7669727475616C44656C65676174653D742C746869732E64';
wwv_flow_imp.g_varchar2_table(12489) := '6F6D49643D226C6973745F69645F222B202B2B45542E496E7374616E6365436F756E742C746869732E72656E6465726572733D6E6577204D61702C746869732E72656E64657257696474683D302C746869732E5F7363726F6C6C4865696768743D302C74';
wwv_flow_imp.g_varchar2_table(12490) := '6869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C653D6E756C6C2C746869732E7363726F6C6C61626C65456C656D656E74576964746844656C617965723D6E6577207A74283530292C746869732E73706C696369';
wwv_flow_imp.g_varchar2_table(12491) := '6E673D21312C746869732E647261674F766572416E696D6174696F6E53746F70446973706F7361626C653D6C742E4E6F6E652C746869732E647261674F7665724D6F757365593D302C746869732E63616E44726F703D21312C746869732E63757272656E';
wwv_flow_imp.g_varchar2_table(12492) := '7444726167466565646261636B446973706F7361626C653D6C742E4E6F6E652C746869732E6F6E447261674C6561766554696D656F75743D6C742E4E6F6E652C746869732E646973706F7361626C65733D6E65772061742C746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(12493) := '68616E6765436F6E74656E744865696768743D6E65772043742C746869732E5F6F6E4469644368616E6765436F6E74656E7457696474683D6E65772043742C746869732E6F6E4469644368616E6765436F6E74656E744865696768743D76742E6C617463';
wwv_flow_imp.g_varchar2_table(12494) := '6828746869732E5F6F6E4469644368616E6765436F6E74656E744865696768742E6576656E742C766F696420302C746869732E646973706F7361626C6573292C746869732E5F686F72697A6F6E74616C5363726F6C6C696E673D21312C692E686F72697A';
wwv_flow_imp.g_varchar2_table(12495) := '6F6E74616C5363726F6C6C696E672626692E737570706F727444796E616D696348656967687473297468726F77206E6577204572726F722822486F72697A6F6E74616C207363726F6C6C696E6720616E642064796E616D69632068656967687473206E6F';
wwv_flow_imp.g_varchar2_table(12496) := '7420737570706F727465642073696D756C74616E656F75736C7922293B746869732E6974656D733D5B5D2C746869732E6974656D49643D302C746869732E72616E67654D61703D746869732E63726561746552616E67654D6170286E756C6C213D3D286F';
wwv_flow_imp.g_varchar2_table(12497) := '3D692E70616464696E67546F70292626766F69642030213D3D6F3F6F3A30293B666F7228636F6E73742065206F66206E29746869732E72656E6465726572732E73657428652E74656D706C61746549642C65293B746869732E63616368653D746869732E';
wwv_flow_imp.g_varchar2_table(12498) := '646973706F7361626C65732E616464286E657720625428746869732E72656E64657265727329292C746869732E6C61737452656E646572546F703D302C746869732E6C61737452656E6465724865696768743D302C746869732E646F6D4E6F64653D646F';
wwv_flow_imp.g_varchar2_table(12499) := '63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D6C697374222C746869732E646F6D4E6F64652E636C6173734C6973742E61646428746869732E646F6D';
wwv_flow_imp.g_varchar2_table(12500) := '4964292C746869732E646F6D4E6F64652E746162496E6465783D302C746869732E646F6D4E6F64652E636C6173734C6973742E746F67676C6528226D6F7573652D737570706F7274222C22626F6F6C65616E22213D747970656F6620692E6D6F75736553';
wwv_flow_imp.g_varchar2_table(12501) := '7570706F72747C7C692E6D6F757365537570706F7274292C746869732E5F686F72697A6F6E74616C5363726F6C6C696E673D6E756C6C213D3D28733D692E686F72697A6F6E74616C5363726F6C6C696E67292626766F69642030213D3D733F733A77542E';
wwv_flow_imp.g_varchar2_table(12502) := '686F72697A6F6E74616C5363726F6C6C696E672C746869732E646F6D4E6F64652E636C6173734C6973742E746F67676C652822686F72697A6F6E74616C2D7363726F6C6C696E67222C746869732E5F686F72697A6F6E74616C5363726F6C6C696E67292C';
wwv_flow_imp.g_varchar2_table(12503) := '746869732E70616464696E67426F74746F6D3D766F696420303D3D3D692E70616464696E67426F74746F6D3F303A692E70616464696E67426F74746F6D2C746869732E6163636573736962696C69747950726F76696465723D6E6577206B5428692E6163';
wwv_flow_imp.g_varchar2_table(12504) := '636573736962696C69747950726F7669646572292C746869732E726F7773436F6E7461696E65723D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E726F7773436F6E7461696E65722E636C6173734E616D653D22';
wwv_flow_imp.g_varchar2_table(12505) := '6D6F6E61636F2D6C6973742D726F7773222C286E756C6C213D3D28723D692E7472616E73666F726D4F7074696D697A6174696F6E292626766F69642030213D3D723F723A77542E7472616E73666F726D4F7074696D697A6174696F6E2926262874686973';
wwv_flow_imp.g_varchar2_table(12506) := '2E726F7773436F6E7461696E65722E7374796C652E7472616E73666F726D3D227472616E736C6174653364283070782C203070782C2030707829222C746869732E726F7773436F6E7461696E65722E7374796C652E6F766572666C6F773D226869646465';
wwv_flow_imp.g_varchar2_table(12507) := '6E222C746869732E726F7773436F6E7461696E65722E7374796C652E636F6E7461696E3D2273747269637422292C746869732E646973706F7361626C65732E6164642849452E61646454617267657428746869732E726F7773436F6E7461696E65722929';
wwv_flow_imp.g_varchar2_table(12508) := '2C746869732E7363726F6C6C61626C653D746869732E646973706F7361626C65732E616464286E6577206E54287B666F726365496E746567657256616C7565733A21302C736D6F6F74685363726F6C6C4475726174696F6E3A6E756C6C213D3D28613D69';
wwv_flow_imp.g_varchar2_table(12509) := '2E736D6F6F74685363726F6C6C696E67292626766F69642030213D3D612626613F3132353A302C7363686564756C6541744E657874416E696D6174696F6E4672616D653A653D3E787328727328746869732E646F6D4E6F6465292C65297D29292C746869';
wwv_flow_imp.g_varchar2_table(12510) := '732E7363726F6C6C61626C65456C656D656E743D746869732E646973706F7361626C65732E616464286E657720705428746869732E726F7773436F6E7461696E65722C7B616C77617973436F6E73756D654D6F757365576865656C3A6E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(12511) := '6C3D692E616C77617973436F6E73756D654D6F757365576865656C292626766F69642030213D3D6C3F6C3A77542E616C77617973436F6E73756D654D6F757365576865656C2C686F72697A6F6E74616C3A312C766572746963616C3A6E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(12512) := '633D692E766572746963616C5363726F6C6C4D6F6465292626766F69642030213D3D633F633A77542E766572746963616C5363726F6C6C4D6F64652C757365536861646F77733A6E756C6C213D3D28643D692E757365536861646F7773292626766F6964';
wwv_flow_imp.g_varchar2_table(12513) := '2030213D3D643F643A77542E757365536861646F77732C6D6F757365576865656C5363726F6C6C53656E73697469766974793A692E6D6F757365576865656C5363726F6C6C53656E73697469766974792C666173745363726F6C6C53656E736974697669';
wwv_flow_imp.g_varchar2_table(12514) := '74793A692E666173745363726F6C6C53656E73697469766974792C7363726F6C6C4279506167653A692E7363726F6C6C4279506167657D2C746869732E7363726F6C6C61626C6529292C746869732E646F6D4E6F64652E617070656E644368696C642874';
wwv_flow_imp.g_varchar2_table(12515) := '6869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F64652829292C652E617070656E644368696C6428746869732E646F6D4E6F6465292C746869732E7363726F6C6C61626C65456C656D656E742E6F6E5363726F6C6C2874686973';
wwv_flow_imp.g_varchar2_table(12516) := '2E6F6E5363726F6C6C2C746869732C746869732E646973706F7361626C6573292C746869732E646973706F7361626C65732E61646428627328746869732E726F7773436F6E7461696E65722C54452E4368616E67652C28653D3E746869732E6F6E546F75';
wwv_flow_imp.g_varchar2_table(12517) := '63684368616E67652865292929292C746869732E646973706F7361626C65732E61646428627328746869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F646528292C227363726F6C6C222C28653D3E652E7461726765742E736372';
wwv_flow_imp.g_varchar2_table(12518) := '6F6C6C546F703D302929292C746869732E646973706F7361626C65732E61646428627328746869732E646F6D4E6F64652C22647261676F766572222C28653D3E746869732E6F6E447261674F76657228746869732E746F447261674576656E7428652929';
wwv_flow_imp.g_varchar2_table(12519) := '2929292C746869732E646973706F7361626C65732E61646428627328746869732E646F6D4E6F64652C2264726F70222C28653D3E746869732E6F6E44726F7028746869732E746F447261674576656E74286529292929292C746869732E646973706F7361';
wwv_flow_imp.g_varchar2_table(12520) := '626C65732E61646428627328746869732E646F6D4E6F64652C22647261676C65617665222C28653D3E746869732E6F6E447261674C6561766528746869732E746F447261674576656E74286529292929292C746869732E646973706F7361626C65732E61';
wwv_flow_imp.g_varchar2_table(12521) := '646428627328746869732E646F6D4E6F64652C2264726167656E64222C28653D3E746869732E6F6E44726167456E642865292929292C746869732E736574526F774C696E654865696768743D6E756C6C213D3D28683D692E736574526F774C696E654865';
wwv_flow_imp.g_varchar2_table(12522) := '69676874292626766F69642030213D3D683F683A77542E736574526F774C696E654865696768742C746869732E736574526F774865696768743D6E756C6C213D3D28753D692E736574526F77486569676874292626766F69642030213D3D753F753A7754';
wwv_flow_imp.g_varchar2_table(12523) := '2E736574526F774865696768742C746869732E737570706F727444796E616D6963486569676874733D6E756C6C213D3D28703D692E737570706F727444796E616D696348656967687473292626766F69642030213D3D703F703A77542E737570706F7274';
wwv_flow_imp.g_varchar2_table(12524) := '44796E616D6963486569676874732C746869732E646E643D6E756C6C213D3D28673D692E646E64292626766F69642030213D3D673F673A746869732E646973706F7361626C65732E6164642877542E646E64292C746869732E6C61796F7574286E756C6C';
wwv_flow_imp.g_varchar2_table(12525) := '3D3D3D286D3D692E696E697469616C53697A65297C7C766F696420303D3D3D6D3F766F696420303A6D2E6865696768742C6E756C6C3D3D3D28663D692E696E697469616C53697A65297C7C766F696420303D3D3D663F766F696420303A662E7769647468';
wwv_flow_imp.g_varchar2_table(12526) := '297D7570646174654F7074696F6E732865297B6C657420743B696628766F69642030213D3D652E70616464696E67426F74746F6D262628746869732E70616464696E67426F74746F6D3D652E70616464696E67426F74746F6D2C746869732E7363726F6C';
wwv_flow_imp.g_varchar2_table(12527) := '6C61626C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E73287B7363726F6C6C4865696768743A746869732E7363726F6C6C4865696768747D29292C766F69642030213D3D652E736D6F6F74685363726F6C6C696E67262674686973';
wwv_flow_imp.g_varchar2_table(12528) := '2E7363726F6C6C61626C652E736574536D6F6F74685363726F6C6C4475726174696F6E28652E736D6F6F74685363726F6C6C696E673F3132353A30292C766F69642030213D3D652E686F72697A6F6E74616C5363726F6C6C696E67262628746869732E68';
wwv_flow_imp.g_varchar2_table(12529) := '6F72697A6F6E74616C5363726F6C6C696E673D652E686F72697A6F6E74616C5363726F6C6C696E67292C766F69642030213D3D652E7363726F6C6C427950616765262628743D7B2E2E2E6E756C6C213D743F743A7B7D2C7363726F6C6C4279506167653A';
wwv_flow_imp.g_varchar2_table(12530) := '652E7363726F6C6C4279506167657D292C766F69642030213D3D652E6D6F757365576865656C5363726F6C6C53656E7369746976697479262628743D7B2E2E2E6E756C6C213D743F743A7B7D2C6D6F757365576865656C5363726F6C6C53656E73697469';
wwv_flow_imp.g_varchar2_table(12531) := '766974793A652E6D6F757365576865656C5363726F6C6C53656E73697469766974797D292C766F69642030213D3D652E666173745363726F6C6C53656E7369746976697479262628743D7B2E2E2E6E756C6C213D743F743A7B7D2C666173745363726F6C';
wwv_flow_imp.g_varchar2_table(12532) := '6C53656E73697469766974793A652E666173745363726F6C6C53656E73697469766974797D292C742626746869732E7363726F6C6C61626C65456C656D656E742E7570646174654F7074696F6E732874292C766F69642030213D3D652E70616464696E67';
wwv_flow_imp.g_varchar2_table(12533) := '546F702626652E70616464696E67546F70213D3D746869732E72616E67654D61702E70616464696E67546F70297B636F6E737420743D746869732E67657452656E64657252616E676528746869732E6C61737452656E646572546F702C746869732E6C61';
wwv_flow_imp.g_varchar2_table(12534) := '737452656E646572486569676874292C6E3D652E70616464696E67546F702D746869732E72616E67654D61702E70616464696E67546F703B746869732E72616E67654D61702E70616464696E67546F703D652E70616464696E67546F702C746869732E72';
wwv_flow_imp.g_varchar2_table(12535) := '656E64657228742C4D6174682E6D617828302C746869732E6C61737452656E646572546F702B6E292C746869732E6C61737452656E6465724865696768742C766F696420302C766F696420302C2130292C746869732E7365745363726F6C6C546F702874';
wwv_flow_imp.g_varchar2_table(12536) := '6869732E6C61737452656E646572546F70292C746869732E6576656E7475616C6C795570646174655363726F6C6C44696D656E73696F6E7328292C746869732E737570706F727444796E616D6963486569676874732626746869732E5F726572656E6465';
wwv_flow_imp.g_varchar2_table(12537) := '7228746869732E6C61737452656E646572546F702C746869732E6C61737452656E646572486569676874297D7D63726561746552616E67654D61702865297B72657475726E206E65772076542865297D73706C69636528652C742C6E3D5B5D297B696628';
wwv_flow_imp.g_varchar2_table(12538) := '746869732E73706C6963696E67297468726F77206E6577204572726F72282243616E27742072756E207265637572736976652073706C696365732E22293B746869732E73706C6963696E673D21303B7472797B72657475726E20746869732E5F73706C69';
wwv_flow_imp.g_varchar2_table(12539) := '636528652C742C6E297D66696E616C6C797B746869732E73706C6963696E673D21312C746869732E5F6F6E4469644368616E6765436F6E74656E744865696768742E6669726528746869732E636F6E74656E74486569676874297D7D5F73706C69636528';
wwv_flow_imp.g_varchar2_table(12540) := '652C742C6E3D5B5D297B636F6E737420693D746869732E67657452656E64657252616E676528746869732E6C61737452656E646572546F702C746869732E6C61737452656E646572486569676874292C6F3D7B73746172743A652C656E643A652B747D2C';
wwv_flow_imp.g_varchar2_table(12541) := '733D72542E696E7465727365637428692C6F292C723D6E6577204D61703B666F72286C657420653D732E656E642D313B653E3D732E73746172743B652D2D297B636F6E737420743D746869732E6974656D735B655D3B696628742E647261675374617274';
wwv_flow_imp.g_varchar2_table(12542) := '446973706F7361626C652E646973706F736528292C742E636865636B6564446973706F7361626C652E646973706F736528292C742E726F77297B6C6574206E3D722E67657428742E74656D706C6174654964293B6E7C7C286E3D5B5D2C722E7365742874';
wwv_flow_imp.g_varchar2_table(12543) := '2E74656D706C61746549642C6E29293B636F6E737420693D746869732E72656E6465726572732E67657428742E74656D706C6174654964293B692626692E646973706F7365456C656D656E742626692E646973706F7365456C656D656E7428742E656C65';
wwv_flow_imp.g_varchar2_table(12544) := '6D656E742C652C742E726F772E74656D706C617465446174612C742E73697A65292C6E2E756E736869667428742E726F77297D742E726F773D6E756C6C2C742E7374616C653D21307D636F6E737420613D7B73746172743A652B742C656E643A74686973';
wwv_flow_imp.g_varchar2_table(12545) := '2E6974656D732E6C656E6774687D2C6C3D72542E696E7465727365637428612C69292C633D72542E72656C6174697665436F6D706C656D656E7428612C69292C643D6E2E6D61702828653D3E287B69643A537472696E6728746869732E6974656D49642B';
wwv_flow_imp.g_varchar2_table(12546) := '2B292C656C656D656E743A652C74656D706C61746549643A746869732E7669727475616C44656C65676174652E67657454656D706C61746549642865292C73697A653A746869732E7669727475616C44656C65676174652E676574486569676874286529';
wwv_flow_imp.g_varchar2_table(12547) := '2C77696474683A766F696420302C68617344796E616D69634865696768743A2121746869732E7669727475616C44656C65676174652E68617344796E616D69634865696768742626746869732E7669727475616C44656C65676174652E68617344796E61';
wwv_flow_imp.g_varchar2_table(12548) := '6D69634865696768742865292C6C61737444796E616D696348656967687457696474683A766F696420302C726F773A6E756C6C2C7572693A766F696420302C64726F705461726765743A21312C647261675374617274446973706F7361626C653A6C742E';
wwv_flow_imp.g_varchar2_table(12549) := '4E6F6E652C636865636B6564446973706F7361626C653A6C742E4E6F6E652C7374616C653A21317D2929293B6C657420683B303D3D3D652626743E3D746869732E6974656D732E6C656E6774683F28746869732E72616E67654D61703D746869732E6372';
wwv_flow_imp.g_varchar2_table(12550) := '6561746552616E67654D617028746869732E72616E67654D61702E70616464696E67546F70292C746869732E72616E67654D61702E73706C69636528302C302C64292C683D746869732E6974656D732C746869732E6974656D733D64293A28746869732E';
wwv_flow_imp.g_varchar2_table(12551) := '72616E67654D61702E73706C69636528652C742C64292C683D746869732E6974656D732E73706C69636528652C742C2E2E2E6429293B636F6E737420753D6E2E6C656E6774682D742C703D746869732E67657452656E64657252616E676528746869732E';
wwv_flow_imp.g_varchar2_table(12552) := '6C61737452656E646572546F702C746869732E6C61737452656E646572486569676874292C673D6654286C2C75292C6D3D72542E696E7465727365637428702C67293B666F72286C657420653D6D2E73746172743B653C6D2E656E643B652B2B29746869';
wwv_flow_imp.g_varchar2_table(12553) := '732E7570646174654974656D496E444F4D28746869732E6974656D735B655D2C65293B636F6E737420663D72542E72656C6174697665436F6D706C656D656E7428672C70293B666F7228636F6E73742065206F66206629666F72286C657420743D652E73';
wwv_flow_imp.g_varchar2_table(12554) := '746172743B743C652E656E643B742B2B29746869732E72656D6F76654974656D46726F6D444F4D2874293B636F6E737420763D632E6D61702828653D3E665428652C752929292C623D5B7B73746172743A652C656E643A652B6E2E6C656E6774687D2C2E';
wwv_flow_imp.g_varchar2_table(12555) := '2E2E765D2E6D61702828653D3E72542E696E7465727365637428702C652929292E7265766572736528293B666F7228636F6E73742065206F66206229666F72286C657420743D652E656E642D313B743E3D652E73746172743B742D2D297B636F6E737420';
wwv_flow_imp.g_varchar2_table(12556) := '653D746869732E6974656D735B745D2C6E3D722E67657428652E74656D706C6174654964292C693D6E756C6C3D3D6E3F766F696420303A6E2E706F7028293B746869732E696E736572744974656D496E444F4D28742C69297D666F7228636F6E73742065';
wwv_flow_imp.g_varchar2_table(12557) := '206F6620722E76616C756573282929666F7228636F6E73742074206F66206529746869732E63616368652E72656C656173652874293B72657475726E20746869732E6576656E7475616C6C795570646174655363726F6C6C44696D656E73696F6E732829';
wwv_flow_imp.g_varchar2_table(12558) := '2C746869732E737570706F727444796E616D6963486569676874732626746869732E5F726572656E64657228746869732E7363726F6C6C546F702C746869732E72656E646572486569676874292C682E6D61702828653D3E652E656C656D656E7429297D';
wwv_flow_imp.g_varchar2_table(12559) := '6576656E7475616C6C795570646174655363726F6C6C44696D656E73696F6E7328297B746869732E5F7363726F6C6C4865696768743D746869732E636F6E74656E744865696768742C746869732E726F7773436F6E7461696E65722E7374796C652E6865';
wwv_flow_imp.g_varchar2_table(12560) := '696768743D60247B746869732E5F7363726F6C6C4865696768747D7078602C746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C657C7C28746869732E7363726F6C6C61626C65456C656D656E74557064617465';
wwv_flow_imp.g_varchar2_table(12561) := '446973706F7361626C653D787328727328746869732E646F6D4E6F6465292C2828293D3E7B746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E73287B7363726F6C6C4865696768743A746869732E73';
wwv_flow_imp.g_varchar2_table(12562) := '63726F6C6C4865696768747D292C746869732E7570646174655363726F6C6C576964746828292C746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C653D6E756C6C7D2929297D6576656E7475616C6C79557064';
wwv_flow_imp.g_varchar2_table(12563) := '6174655363726F6C6C576964746828297B746869732E686F72697A6F6E74616C5363726F6C6C696E673F746869732E7363726F6C6C61626C65456C656D656E74576964746844656C617965722E74726967676572282828293D3E746869732E7570646174';
wwv_flow_imp.g_varchar2_table(12564) := '655363726F6C6C5769647468282929293A746869732E7363726F6C6C61626C65456C656D656E74576964746844656C617965722E63616E63656C28297D7570646174655363726F6C6C576964746828297B69662821746869732E686F72697A6F6E74616C';
wwv_flow_imp.g_varchar2_table(12565) := '5363726F6C6C696E672972657475726E3B6C657420653D303B666F7228636F6E73742074206F6620746869732E6974656D7329766F69642030213D3D742E7769647468262628653D4D6174682E6D617828652C742E776964746829293B746869732E7363';
wwv_flow_imp.g_varchar2_table(12566) := '726F6C6C57696474683D652C746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E73287B7363726F6C6C57696474683A303D3D3D653F303A652B31307D292C746869732E5F6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(12567) := '436F6E74656E7457696474682E6669726528746869732E7363726F6C6C5769647468297D726572656E64657228297B696628746869732E737570706F727444796E616D696348656967687473297B666F7228636F6E73742065206F6620746869732E6974';
wwv_flow_imp.g_varchar2_table(12568) := '656D7329652E6C61737444796E616D696348656967687457696474683D766F696420303B746869732E5F726572656E64657228746869732E6C61737452656E646572546F702C746869732E6C61737452656E646572486569676874297D7D676574206C65';
wwv_flow_imp.g_varchar2_table(12569) := '6E67746828297B72657475726E20746869732E6974656D732E6C656E6774687D6765742072656E64657248656967687428297B72657475726E20746869732E7363726F6C6C61626C65456C656D656E742E6765745363726F6C6C44696D656E73696F6E73';
wwv_flow_imp.g_varchar2_table(12570) := '28292E6865696768747D67657420666972737456697369626C65496E64657828297B72657475726E20746869732E67657452656E64657252616E676528746869732E6C61737452656E646572546F702C746869732E6C61737452656E6465724865696768';
wwv_flow_imp.g_varchar2_table(12571) := '74292E73746172747D656C656D656E742865297B72657475726E20746869732E6974656D735B655D2E656C656D656E747D696E6465784F662865297B72657475726E20746869732E6974656D732E66696E64496E6465782828743D3E742E656C656D656E';
wwv_flow_imp.g_varchar2_table(12572) := '743D3D3D6529297D646F6D456C656D656E742865297B636F6E737420743D746869732E6974656D735B655D2E726F773B72657475726E20742626742E646F6D4E6F64657D656C656D656E744865696768742865297B72657475726E20746869732E697465';
wwv_flow_imp.g_varchar2_table(12573) := '6D735B655D2E73697A657D656C656D656E74546F702865297B72657475726E20746869732E72616E67654D61702E706F736974696F6E41742865297D696E64657841742865297B72657475726E20746869732E72616E67654D61702E696E646578417428';
wwv_flow_imp.g_varchar2_table(12574) := '65297D696E64657841667465722865297B72657475726E20746869732E72616E67654D61702E696E64657841667465722865297D6C61796F757428652C74297B636F6E7374206E3D7B6865696768743A226E756D626572223D3D747970656F6620653F65';
wwv_flow_imp.g_varchar2_table(12575) := '3A527328746869732E646F6D4E6F6465297D3B746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C65262628746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C652E64';
wwv_flow_imp.g_varchar2_table(12576) := '6973706F736528292C746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C653D6E756C6C2C6E2E7363726F6C6C4865696768743D746869732E7363726F6C6C486569676874292C746869732E7363726F6C6C6162';
wwv_flow_imp.g_varchar2_table(12577) := '6C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E73286E292C766F69642030213D3D74262628746869732E72656E64657257696474683D742C746869732E737570706F727444796E616D6963486569676874732626746869732E5F72';
wwv_flow_imp.g_varchar2_table(12578) := '6572656E64657228746869732E7363726F6C6C546F702C746869732E72656E64657248656967687429292C746869732E686F72697A6F6E74616C5363726F6C6C696E672626746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C';
wwv_flow_imp.g_varchar2_table(12579) := '6C44696D656E73696F6E73287B77696474683A226E756D626572223D3D747970656F6620743F743A4F7328746869732E646F6D4E6F6465297D297D72656E64657228652C742C6E2C692C6F2C733D2131297B636F6E737420723D746869732E6765745265';
wwv_flow_imp.g_varchar2_table(12580) := '6E64657252616E676528742C6E292C613D72542E72656C6174697665436F6D706C656D656E7428722C65292E7265766572736528292C6C3D72542E72656C6174697665436F6D706C656D656E7428652C72293B69662873297B636F6E737420743D72542E';
wwv_flow_imp.g_varchar2_table(12581) := '696E7465727365637428652C72293B666F72286C657420653D742E73746172743B653C742E656E643B652B2B29746869732E7570646174654974656D496E444F4D28746869732E6974656D735B655D2C65297D746869732E63616368652E7472616E7361';
wwv_flow_imp.g_varchar2_table(12582) := '6374282828293D3E7B666F7228636F6E73742065206F66206C29666F72286C657420743D652E73746172743B743C652E656E643B742B2B29746869732E72656D6F76654974656D46726F6D444F4D2874293B666F7228636F6E73742065206F6620612966';
wwv_flow_imp.g_varchar2_table(12583) := '6F72286C657420743D652E656E642D313B743E3D652E73746172743B742D2D29746869732E696E736572744974656D496E444F4D2874297D29292C766F69642030213D3D69262628746869732E726F7773436F6E7461696E65722E7374796C652E6C6566';
wwv_flow_imp.g_varchar2_table(12584) := '743D602D247B697D707860292C746869732E726F7773436F6E7461696E65722E7374796C652E746F703D602D247B747D7078602C746869732E686F72697A6F6E74616C5363726F6C6C696E672626766F69642030213D3D6F262628746869732E726F7773';
wwv_flow_imp.g_varchar2_table(12585) := '436F6E7461696E65722E7374796C652E77696474683D60247B4D6174682E6D6178286F2C746869732E72656E6465725769647468297D707860292C746869732E6C61737452656E646572546F703D742C746869732E6C61737452656E6465724865696768';
wwv_flow_imp.g_varchar2_table(12586) := '743D6E7D696E736572744974656D496E444F4D28652C74297B766172206E2C692C6F3B636F6E737420733D746869732E6974656D735B655D3B69662821732E726F77296966287429732E726F773D742C732E7374616C653D21303B656C73657B636F6E73';
wwv_flow_imp.g_varchar2_table(12587) := '7420653D746869732E63616368652E616C6C6F6328732E74656D706C6174654964293B732E726F773D652E726F772C732E7374616C657C7C28732E7374616C653D652E697352657573696E67436F6E6E6563746564446F6D4E6F6465297D636F6E737420';
wwv_flow_imp.g_varchar2_table(12588) := '723D746869732E6163636573736962696C69747950726F76696465722E676574526F6C6528732E656C656D656E74297C7C226C6973746974656D223B732E726F772E646F6D4E6F64652E7365744174747269627574652822726F6C65222C72293B636F6E';
wwv_flow_imp.g_varchar2_table(12589) := '737420613D746869732E6163636573736962696C69747950726F76696465722E6973436865636B656428732E656C656D656E74293B69662822626F6F6C65616E223D3D747970656F66206129732E726F772E646F6D4E6F64652E73657441747472696275';
wwv_flow_imp.g_varchar2_table(12590) := '74652822617269612D636865636B6564222C537472696E672821216129293B656C73652069662861297B636F6E737420653D653D3E732E726F772E646F6D4E6F64652E7365744174747269627574652822617269612D636865636B6564222C537472696E';
wwv_flow_imp.g_varchar2_table(12591) := '672821216529293B6528612E76616C7565292C732E636865636B6564446973706F7361626C653D612E6F6E4469644368616E6765282828293D3E6528612E76616C75652929297D696628732E7374616C657C7C21732E726F772E646F6D4E6F64652E7061';
wwv_flow_imp.g_varchar2_table(12592) := '72656E74456C656D656E74297B636F6E737420743D6E756C6C213D3D286F3D6E756C6C3D3D3D28693D6E756C6C3D3D3D286E3D746869732E6974656D732E617428652B3129297C7C766F696420303D3D3D6E3F766F696420303A6E2E726F77297C7C766F';
wwv_flow_imp.g_varchar2_table(12593) := '696420303D3D3D693F766F696420303A692E646F6D4E6F6465292626766F69642030213D3D6F3F6F3A6E756C6C3B732E726F772E646F6D4E6F64652E706172656E74456C656D656E743D3D3D746869732E726F7773436F6E7461696E65722626732E726F';
wwv_flow_imp.g_varchar2_table(12594) := '772E646F6D4E6F64652E6E657874456C656D656E745369626C696E673D3D3D747C7C746869732E726F7773436F6E7461696E65722E696E736572744265666F726528732E726F772E646F6D4E6F64652C74292C732E7374616C653D21317D746869732E75';
wwv_flow_imp.g_varchar2_table(12595) := '70646174654974656D496E444F4D28732C65293B636F6E7374206C3D746869732E72656E6465726572732E67657428732E74656D706C6174654964293B696628216C297468726F77206E6577204572726F7228604E6F2072656E646572657220666F756E';
wwv_flow_imp.g_varchar2_table(12596) := '6420666F722074656D706C61746520696420247B732E74656D706C61746549647D60293B6E756C6C3D3D6C7C7C6C2E72656E646572456C656D656E7428732E656C656D656E742C652C732E726F772E74656D706C617465446174612C732E73697A65293B';
wwv_flow_imp.g_varchar2_table(12597) := '636F6E737420633D746869732E646E642E6765744472616755524928732E656C656D656E74293B732E647261675374617274446973706F7361626C652E646973706F736528292C732E726F772E646F6D4E6F64652E647261676761626C653D2121632C63';
wwv_flow_imp.g_varchar2_table(12598) := '262628732E647261675374617274446973706F7361626C653D627328732E726F772E646F6D4E6F64652C22647261677374617274222C28653D3E746869732E6F6E44726167537461727428732E656C656D656E742C632C65292929292C746869732E686F';
wwv_flow_imp.g_varchar2_table(12599) := '72697A6F6E74616C5363726F6C6C696E67262628746869732E6D6561737572654974656D57696474682873292C746869732E6576656E7475616C6C795570646174655363726F6C6C57696474682829297D6D6561737572654974656D5769647468286529';
wwv_flow_imp.g_varchar2_table(12600) := '7B69662821652E726F777C7C21652E726F772E646F6D4E6F64652972657475726E3B652E726F772E646F6D4E6F64652E7374796C652E77696474683D226669742D636F6E74656E74222C652E77696474683D4F7328652E726F772E646F6D4E6F6465293B';
wwv_flow_imp.g_varchar2_table(12601) := '636F6E737420743D727328652E726F772E646F6D4E6F6465292E676574436F6D70757465645374796C6528652E726F772E646F6D4E6F6465293B742E70616464696E674C656674262628652E77696474682B3D7061727365466C6F617428742E70616464';
wwv_flow_imp.g_varchar2_table(12602) := '696E674C65667429292C742E70616464696E675269676874262628652E77696474682B3D7061727365466C6F617428742E70616464696E67526967687429292C652E726F772E646F6D4E6F64652E7374796C652E77696474683D22227D75706461746549';
wwv_flow_imp.g_varchar2_table(12603) := '74656D496E444F4D28652C74297B652E726F772E646F6D4E6F64652E7374796C652E746F703D60247B746869732E656C656D656E74546F702874297D7078602C746869732E736574526F77486569676874262628652E726F772E646F6D4E6F64652E7374';
wwv_flow_imp.g_varchar2_table(12604) := '796C652E6865696768743D60247B652E73697A657D707860292C746869732E736574526F774C696E65486569676874262628652E726F772E646F6D4E6F64652E7374796C652E6C696E654865696768743D60247B652E73697A657D707860292C652E726F';
wwv_flow_imp.g_varchar2_table(12605) := '772E646F6D4E6F64652E7365744174747269627574652822646174612D696E646578222C60247B747D60292C652E726F772E646F6D4E6F64652E7365744174747269627574652822646174612D6C6173742D656C656D656E74222C743D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(12606) := '6C656E6774682D313F2274727565223A2266616C736522292C652E726F772E646F6D4E6F64652E7365744174747269627574652822646174612D706172697479222C7425323D3D303F226576656E223A226F646422292C652E726F772E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(12607) := '2E7365744174747269627574652822617269612D73657473697A65222C537472696E6728746869732E6163636573736962696C69747950726F76696465722E67657453657453697A6528652E656C656D656E742C742C746869732E6C656E677468292929';
wwv_flow_imp.g_varchar2_table(12608) := '2C652E726F772E646F6D4E6F64652E7365744174747269627574652822617269612D706F73696E736574222C537472696E6728746869732E6163636573736962696C69747950726F76696465722E676574506F73496E53657428652E656C656D656E742C';
wwv_flow_imp.g_varchar2_table(12609) := '742929292C652E726F772E646F6D4E6F64652E73657441747472696275746528226964222C746869732E676574456C656D656E74446F6D4964287429292C652E726F772E646F6D4E6F64652E636C6173734C6973742E746F67676C65282264726F702D74';
wwv_flow_imp.g_varchar2_table(12610) := '6172676574222C652E64726F70546172676574297D72656D6F76654974656D46726F6D444F4D2865297B636F6E737420743D746869732E6974656D735B655D3B696628742E647261675374617274446973706F7361626C652E646973706F736528292C74';
wwv_flow_imp.g_varchar2_table(12611) := '2E636865636B6564446973706F7361626C652E646973706F736528292C742E726F77297B636F6E7374206E3D746869732E72656E6465726572732E67657428742E74656D706C6174654964293B6E26266E2E646973706F7365456C656D656E7426266E2E';
wwv_flow_imp.g_varchar2_table(12612) := '646973706F7365456C656D656E7428742E656C656D656E742C652C742E726F772E74656D706C617465446174612C742E73697A65292C746869732E63616368652E72656C6561736528742E726F77292C742E726F773D6E756C6C7D746869732E686F7269';
wwv_flow_imp.g_varchar2_table(12613) := '7A6F6E74616C5363726F6C6C696E672626746869732E6576656E7475616C6C795570646174655363726F6C6C576964746828297D6765745363726F6C6C546F7028297B72657475726E20746869732E7363726F6C6C61626C65456C656D656E742E676574';
wwv_flow_imp.g_varchar2_table(12614) := '5363726F6C6C506F736974696F6E28292E7363726F6C6C546F707D7365745363726F6C6C546F7028652C74297B746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C65262628746869732E7363726F6C6C61626C';
wwv_flow_imp.g_varchar2_table(12615) := '65456C656D656E74557064617465446973706F7361626C652E646973706F736528292C746869732E7363726F6C6C61626C65456C656D656E74557064617465446973706F7361626C653D6E756C6C2C746869732E7363726F6C6C61626C65456C656D656E';
wwv_flow_imp.g_varchar2_table(12616) := '742E7365745363726F6C6C44696D656E73696F6E73287B7363726F6C6C4865696768743A746869732E7363726F6C6C4865696768747D29292C746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C506F736974696F6E287B73';
wwv_flow_imp.g_varchar2_table(12617) := '63726F6C6C546F703A652C7265757365416E696D6174696F6E3A747D297D676574207363726F6C6C546F7028297B72657475726E20746869732E6765745363726F6C6C546F7028297D736574207363726F6C6C546F702865297B746869732E7365745363';
wwv_flow_imp.g_varchar2_table(12618) := '726F6C6C546F702865297D676574207363726F6C6C48656967687428297B72657475726E20746869732E5F7363726F6C6C4865696768742B28746869732E686F72697A6F6E74616C5363726F6C6C696E673F31303A30292B746869732E70616464696E67';
wwv_flow_imp.g_varchar2_table(12619) := '426F74746F6D7D676574206F6E4D6F757365436C69636B28297B72657475726E2076742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C22636C69636B2229292E6576656E742C28653D';
wwv_flow_imp.g_varchar2_table(12620) := '3E746869732E746F4D6F7573654576656E74286529292C746869732E646973706F7361626C6573297D676574206F6E4D6F75736544626C436C69636B28297B72657475726E2076742E6D617028746869732E646973706F7361626C65732E616464286E65';
wwv_flow_imp.g_varchar2_table(12621) := '77204B5328746869732E646F6D4E6F64652C2264626C636C69636B2229292E6576656E742C28653D3E746869732E746F4D6F7573654576656E74286529292C746869732E646973706F7361626C6573297D676574206F6E4D6F7573654D6964646C65436C';
wwv_flow_imp.g_varchar2_table(12622) := '69636B28297B72657475726E2076742E66696C7465722876742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C22617578636C69636B2229292E6576656E742C28653D3E746869732E74';
wwv_flow_imp.g_varchar2_table(12623) := '6F4D6F7573654576656E74286529292C746869732E646973706F7361626C6573292C28653D3E313D3D3D652E62726F777365724576656E742E627574746F6E292C746869732E646973706F7361626C6573297D676574206F6E4D6F757365446F776E2829';
wwv_flow_imp.g_varchar2_table(12624) := '7B72657475726E2076742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C226D6F757365646F776E2229292E6576656E742C28653D3E746869732E746F4D6F7573654576656E74286529';
wwv_flow_imp.g_varchar2_table(12625) := '292C746869732E646973706F7361626C6573297D676574206F6E4D6F7573654F76657228297B72657475726E2076742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C226D6F7573656F';
wwv_flow_imp.g_varchar2_table(12626) := '7665722229292E6576656E742C28653D3E746869732E746F4D6F7573654576656E74286529292C746869732E646973706F7361626C6573297D676574206F6E4D6F7573654F757428297B72657475726E2076742E6D617028746869732E646973706F7361';
wwv_flow_imp.g_varchar2_table(12627) := '626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C226D6F7573656F75742229292E6576656E742C28653D3E746869732E746F4D6F7573654576656E74286529292C746869732E646973706F7361626C6573297D676574206F6E436F';
wwv_flow_imp.g_varchar2_table(12628) := '6E746578744D656E7528297B72657475726E2076742E616E792876742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C22636F6E746578746D656E752229292E6576656E742C28653D3E';
wwv_flow_imp.g_varchar2_table(12629) := '746869732E746F4D6F7573654576656E74286529292C746869732E646973706F7361626C6573292C76742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C54452E436F6E746578746D65';
wwv_flow_imp.g_varchar2_table(12630) := '6E7529292E6576656E742C28653D3E746869732E746F476573747572654576656E74286529292C746869732E646973706F7361626C657329297D676574206F6E546F756368537461727428297B72657475726E2076742E6D617028746869732E64697370';
wwv_flow_imp.g_varchar2_table(12631) := '6F7361626C65732E616464286E6577204B5328746869732E646F6D4E6F64652C22746F75636873746172742229292E6576656E742C28653D3E746869732E746F546F7563684576656E74286529292C746869732E646973706F7361626C6573297D676574';
wwv_flow_imp.g_varchar2_table(12632) := '206F6E54617028297B72657475726E2076742E6D617028746869732E646973706F7361626C65732E616464286E6577204B5328746869732E726F7773436F6E7461696E65722C54452E54617029292E6576656E742C28653D3E746869732E746F47657374';
wwv_flow_imp.g_varchar2_table(12633) := '7572654576656E74286529292C746869732E646973706F7361626C6573297D746F4D6F7573654576656E742865297B636F6E737420743D746869732E6765744974656D496E64657846726F6D4576656E7454617267657428652E7461726765747C7C6E75';
wwv_flow_imp.g_varchar2_table(12634) := '6C6C292C6E3D766F696420303D3D3D743F766F696420303A746869732E6974656D735B745D3B72657475726E7B62726F777365724576656E743A652C696E6465783A742C656C656D656E743A6E26266E2E656C656D656E747D7D746F546F756368457665';
wwv_flow_imp.g_varchar2_table(12635) := '6E742865297B636F6E737420743D746869732E6765744974656D496E64657846726F6D4576656E7454617267657428652E7461726765747C7C6E756C6C292C6E3D766F696420303D3D3D743F766F696420303A746869732E6974656D735B745D3B726574';
wwv_flow_imp.g_varchar2_table(12636) := '75726E7B62726F777365724576656E743A652C696E6465783A742C656C656D656E743A6E26266E2E656C656D656E747D7D746F476573747572654576656E742865297B636F6E737420743D746869732E6765744974656D496E64657846726F6D4576656E';
wwv_flow_imp.g_varchar2_table(12637) := '7454617267657428652E696E697469616C5461726765747C7C6E756C6C292C6E3D766F696420303D3D3D743F766F696420303A746869732E6974656D735B745D3B72657475726E7B62726F777365724576656E743A652C696E6465783A742C656C656D65';
wwv_flow_imp.g_varchar2_table(12638) := '6E743A6E26266E2E656C656D656E747D7D746F447261674576656E742865297B636F6E737420743D746869732E6765744974656D496E64657846726F6D4576656E7454617267657428652E7461726765747C7C6E756C6C292C6E3D766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(12639) := '743F766F696420303A746869732E6974656D735B745D3B72657475726E7B62726F777365724576656E743A652C696E6465783A742C656C656D656E743A6E26266E2E656C656D656E742C736563746F723A746869732E676574546172676574536563746F';
wwv_flow_imp.g_varchar2_table(12640) := '7228652C74297D7D6F6E5363726F6C6C2865297B7472797B636F6E737420743D746869732E67657452656E64657252616E676528746869732E6C61737452656E646572546F702C746869732E6C61737452656E646572486569676874293B746869732E72';
wwv_flow_imp.g_varchar2_table(12641) := '656E64657228742C652E7363726F6C6C546F702C652E6865696768742C652E7363726F6C6C4C6566742C652E7363726F6C6C5769647468292C746869732E737570706F727444796E616D6963486569676874732626746869732E5F726572656E64657228';
wwv_flow_imp.g_varchar2_table(12642) := '652E7363726F6C6C546F702C652E6865696768742C652E696E536D6F6F74685363726F6C6C696E67297D63617463682874297B7468726F7720636F6E736F6C652E6572726F722822476F7420626164207363726F6C6C206576656E743A222C65292C747D';
wwv_flow_imp.g_varchar2_table(12643) := '7D6F6E546F7563684368616E67652865297B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E7363726F6C6C546F702D3D652E7472616E736C6174696F6E597D6F6E44726167537461727428';
wwv_flow_imp.g_varchar2_table(12644) := '652C742C6E297B76617220692C6F3B696628216E2E646174615472616E736665722972657475726E3B636F6E737420733D746869732E646E642E67657444726167456C656D656E74732865293B6966286E2E646174615472616E736665722E6566666563';
wwv_flow_imp.g_varchar2_table(12645) := '74416C6C6F7765643D22636F70794D6F7665222C6E2E646174615472616E736665722E736574446174612867782E544558542C74292C6E2E646174615472616E736665722E73657444726167496D616765297B6C657420653B746869732E646E642E6765';
wwv_flow_imp.g_varchar2_table(12646) := '74447261674C6162656C262628653D746869732E646E642E676574447261674C6162656C28732C6E29292C766F696420303D3D3D65262628653D537472696E6728732E6C656E67746829293B636F6E737420743D627228222E6D6F6E61636F2D64726167';
wwv_flow_imp.g_varchar2_table(12647) := '2D696D61676522293B742E74657874436F6E74656E743D653B636F6E737420693D28653D3E7B666F72283B65262621652E636C6173734C6973742E636F6E7461696E7328226D6F6E61636F2D776F726B62656E636822293B29653D652E706172656E7445';
wwv_flow_imp.g_varchar2_table(12648) := '6C656D656E743B72657475726E20657C7C746869732E646F6D4E6F64652E6F776E6572446F63756D656E747D2928746869732E646F6D4E6F6465293B692E617070656E644368696C642874292C6E2E646174615472616E736665722E7365744472616749';
wwv_flow_imp.g_varchar2_table(12649) := '6D61676528742C2D31302C2D3130292C73657454696D656F7574282828293D3E692E72656D6F76654368696C64287429292C30297D746869732E646F6D4E6F64652E636C6173734C6973742E61646428226472616767696E6722292C746869732E637572';
wwv_flow_imp.g_varchar2_table(12650) := '72656E7444726167446174613D6E65772043542873292C79542E43757272656E7444726167416E6444726F70446174613D6E65772053542873292C6E756C6C3D3D3D286F3D28693D746869732E646E64292E6F6E447261675374617274297C7C766F6964';
wwv_flow_imp.g_varchar2_table(12651) := '20303D3D3D6F7C7C6F2E63616C6C28692C746869732E63757272656E7444726167446174612C6E297D6F6E447261674F7665722865297B76617220742C6E3B696628652E62726F777365724576656E742E70726576656E7444656661756C7428292C7468';
wwv_flow_imp.g_varchar2_table(12652) := '69732E6F6E447261674C6561766554696D656F75742E646973706F736528292C79542E43757272656E7444726167416E6444726F70446174612626227673636F64652D7569223D3D3D79542E43757272656E7444726167416E6444726F70446174612E67';
wwv_flow_imp.g_varchar2_table(12653) := '65744461746128292972657475726E21313B696628746869732E736574757044726167416E6444726F705363726F6C6C546F70416E696D6174696F6E28652E62726F777365724576656E74292C21652E62726F777365724576656E742E64617461547261';
wwv_flow_imp.g_varchar2_table(12654) := '6E736665722972657475726E21313B69662821746869732E63757272656E7444726167446174612969662879542E43757272656E7444726167416E6444726F704461746129746869732E63757272656E7444726167446174613D79542E43757272656E74';
wwv_flow_imp.g_varchar2_table(12655) := '44726167416E6444726F70446174613B656C73657B69662821652E62726F777365724576656E742E646174615472616E736665722E74797065732972657475726E21313B746869732E63757272656E7444726167446174613D6E65772078547D636F6E73';
wwv_flow_imp.g_varchar2_table(12656) := '7420693D746869732E646E642E6F6E447261674F76657228746869732E63757272656E7444726167446174612C652E656C656D656E742C652E696E6465782C652E736563746F722C652E62726F777365724576656E74293B696628746869732E63616E44';
wwv_flow_imp.g_varchar2_table(12657) := '726F703D22626F6F6C65616E223D3D747970656F6620693F693A692E6163636570742C21746869732E63616E44726F702972657475726E20746869732E63757272656E7444726167466565646261636B3D766F696420302C746869732E63757272656E74';
wwv_flow_imp.g_varchar2_table(12658) := '44726167466565646261636B446973706F7361626C652E646973706F736528292C21313B6C6574206F3B652E62726F777365724576656E742E646174615472616E736665722E64726F704566666563743D22626F6F6C65616E22213D747970656F662069';
wwv_flow_imp.g_varchar2_table(12659) := '2626303D3D3D286E756C6C3D3D3D28743D692E656666656374297C7C766F696420303D3D3D743F766F696420303A742E74797065293F22636F7079223A226D6F7665222C6F3D22626F6F6C65616E22213D747970656F6620692626692E66656564626163';
wwv_flow_imp.g_varchar2_table(12660) := '6B3F692E666565646261636B3A766F696420303D3D3D652E696E6465783F5B2D315D3A5B652E696E6465785D2C6F3D7168286F292E66696C7465722828653D3E653E3D2D312626653C746869732E6C656E67746829292E736F7274282828652C74293D3E';
wwv_flow_imp.g_varchar2_table(12661) := '652D7429292C6F3D2D313D3D3D6F5B305D3F5B2D315D3A6F3B6C657420733D22626F6F6C65616E22213D747970656F6620692626692E6566666563742626692E6566666563742E706F736974696F6E3F692E6566666563742E706F736974696F6E3A2264';
wwv_flow_imp.g_varchar2_table(12662) := '726F702D746172676574223B696628723D746869732E63757272656E7444726167466565646261636B2C613D6F2C2841727261792E69734172726179287229262641727261792E697341727261792861293F506828722C61293A723D3D3D612926267468';
wwv_flow_imp.g_varchar2_table(12663) := '69732E63757272656E7444726167466565646261636B506F736974696F6E3D3D3D732972657475726E21303B76617220722C613B696628746869732E63757272656E7444726167466565646261636B3D6F2C746869732E63757272656E74447261674665';
wwv_flow_imp.g_varchar2_table(12664) := '65646261636B506F736974696F6E3D732C746869732E63757272656E7444726167466565646261636B446973706F7361626C652E646973706F736528292C2D313D3D3D6F5B305D29746869732E646F6D4E6F64652E636C6173734C6973742E6164642873';
wwv_flow_imp.g_varchar2_table(12665) := '292C746869732E726F7773436F6E7461696E65722E636C6173734C6973742E6164642873292C746869732E63757272656E7444726167466565646261636B446973706F7361626C653D7274282828293D3E7B746869732E646F6D4E6F64652E636C617373';
wwv_flow_imp.g_varchar2_table(12666) := '4C6973742E72656D6F76652873292C746869732E726F7773436F6E7461696E65722E636C6173734C6973742E72656D6F76652873297D29293B656C73657B6966286F2E6C656E6774683E3126262264726F702D74617267657422213D3D73297468726F77';
wwv_flow_imp.g_varchar2_table(12667) := '206E6577204572726F72282243616E277420757365206D756C7469706C6520666565646261636B73207769746820706F736974696F6E20646966666572656E74207468616E20276F7665722722293B2264726F702D7461726765742D6166746572223D3D';
wwv_flow_imp.g_varchar2_table(12668) := '3D7326266F5B305D3C746869732E6C656E6774682D312626286F5B305D2B3D312C733D2264726F702D7461726765742D6265666F726522293B666F7228636F6E73742065206F66206F297B636F6E737420743D746869732E6974656D735B655D3B742E64';
wwv_flow_imp.g_varchar2_table(12669) := '726F705461726765743D21302C6E756C6C3D3D3D286E3D742E726F77297C7C766F696420303D3D3D6E7C7C6E2E646F6D4E6F64652E636C6173734C6973742E6164642873297D746869732E63757272656E7444726167466565646261636B446973706F73';
wwv_flow_imp.g_varchar2_table(12670) := '61626C653D7274282828293D3E7B76617220653B666F7228636F6E73742074206F66206F297B636F6E7374206E3D746869732E6974656D735B745D3B6E2E64726F705461726765743D21312C6E756C6C3D3D3D28653D6E2E726F77297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(12671) := '3D3D3D657C7C652E646F6D4E6F64652E636C6173734C6973742E72656D6F76652873297D7D29297D72657475726E21307D6F6E447261674C656176652865297B76617220742C6E3B746869732E6F6E447261674C6561766554696D656F75742E64697370';
wwv_flow_imp.g_varchar2_table(12672) := '6F736528292C746869732E6F6E447261674C6561766554696D656F75743D6A74282828293D3E746869732E636C656172447261674F766572466565646261636B2829292C3130302C746869732E646973706F7361626C6573292C746869732E6375727265';
wwv_flow_imp.g_varchar2_table(12673) := '6E7444726167446174612626286E756C6C3D3D3D286E3D28743D746869732E646E64292E6F6E447261674C65617665297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C746869732E63757272656E7444726167446174612C652E656C656D656E';
wwv_flow_imp.g_varchar2_table(12674) := '742C652E696E6465782C652E62726F777365724576656E7429297D6F6E44726F702865297B69662821746869732E63616E44726F702972657475726E3B636F6E737420743D746869732E63757272656E7444726167446174613B746869732E7465617264';
wwv_flow_imp.g_varchar2_table(12675) := '6F776E44726167416E6444726F705363726F6C6C546F70416E696D6174696F6E28292C746869732E636C656172447261674F766572466565646261636B28292C746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F766528226472616767';
wwv_flow_imp.g_varchar2_table(12676) := '696E6722292C746869732E63757272656E7444726167446174613D766F696420302C79542E43757272656E7444726167416E6444726F70446174613D766F696420302C742626652E62726F777365724576656E742E646174615472616E73666572262628';
wwv_flow_imp.g_varchar2_table(12677) := '652E62726F777365724576656E742E70726576656E7444656661756C7428292C742E75706461746528652E62726F777365724576656E742E646174615472616E73666572292C746869732E646E642E64726F7028742C652E656C656D656E742C652E696E';
wwv_flow_imp.g_varchar2_table(12678) := '6465782C652E736563746F722C652E62726F777365724576656E7429297D6F6E44726167456E642865297B76617220742C6E3B746869732E63616E44726F703D21312C746869732E74656172646F776E44726167416E6444726F705363726F6C6C546F70';
wwv_flow_imp.g_varchar2_table(12679) := '416E696D6174696F6E28292C746869732E636C656172447261674F766572466565646261636B28292C746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F766528226472616767696E6722292C746869732E63757272656E744472616744';
wwv_flow_imp.g_varchar2_table(12680) := '6174613D766F696420302C79542E43757272656E7444726167416E6444726F70446174613D766F696420302C6E756C6C3D3D3D286E3D28743D746869732E646E64292E6F6E44726167456E64297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C';
wwv_flow_imp.g_varchar2_table(12681) := '65297D636C656172447261674F766572466565646261636B28297B746869732E63757272656E7444726167466565646261636B3D766F696420302C746869732E63757272656E7444726167466565646261636B506F736974696F6E3D766F696420302C74';
wwv_flow_imp.g_varchar2_table(12682) := '6869732E63757272656E7444726167466565646261636B446973706F7361626C652E646973706F736528292C746869732E63757272656E7444726167466565646261636B446973706F7361626C653D6C742E4E6F6E657D736574757044726167416E6444';
wwv_flow_imp.g_varchar2_table(12683) := '726F705363726F6C6C546F70416E696D6174696F6E2865297B69662821746869732E647261674F766572416E696D6174696F6E446973706F7361626C65297B636F6E737420653D4D7328746869732E646F6D4E6F6465292E746F703B746869732E647261';
wwv_flow_imp.g_varchar2_table(12684) := '674F766572416E696D6174696F6E446973706F7361626C653D66756E6374696F6E28652C74297B636F6E7374206E3D28293D3E7B7428292C693D787328652C6E297D3B6C657420693D787328652C6E293B72657475726E207274282828293D3E692E6469';
wwv_flow_imp.g_varchar2_table(12685) := '73706F7365282929297D28727328746869732E646F6D4E6F6465292C746869732E616E696D61746544726167416E6444726F705363726F6C6C546F702E62696E6428746869732C6529297D746869732E647261674F766572416E696D6174696F6E53746F';
wwv_flow_imp.g_varchar2_table(12686) := '70446973706F7361626C652E646973706F736528292C746869732E647261674F766572416E696D6174696F6E53746F70446973706F7361626C653D6A74282828293D3E7B746869732E647261674F766572416E696D6174696F6E446973706F7361626C65';
wwv_flow_imp.g_varchar2_table(12687) := '262628746869732E647261674F766572416E696D6174696F6E446973706F7361626C652E646973706F736528292C746869732E647261674F766572416E696D6174696F6E446973706F7361626C653D766F69642030297D292C3165332C746869732E6469';
wwv_flow_imp.g_varchar2_table(12688) := '73706F7361626C6573292C746869732E647261674F7665724D6F757365593D652E70616765597D616E696D61746544726167416E6444726F705363726F6C6C546F702865297B696628766F696420303D3D3D746869732E647261674F7665724D6F757365';
wwv_flow_imp.g_varchar2_table(12689) := '592972657475726E3B636F6E737420743D746869732E647261674F7665724D6F757365592D652C6E3D746869732E72656E6465724865696768742D33353B743C33353F746869732E7363726F6C6C546F702B3D4D6174682E6D6178282D31342C4D617468';
wwv_flow_imp.g_varchar2_table(12690) := '2E666C6F6F72282E332A28742D33352929293A743E6E262628746869732E7363726F6C6C546F702B3D4D6174682E6D696E2831342C4D6174682E666C6F6F72282E332A28742D6E292929297D74656172646F776E44726167416E6444726F705363726F6C';
wwv_flow_imp.g_varchar2_table(12691) := '6C546F70416E696D6174696F6E28297B746869732E647261674F766572416E696D6174696F6E53746F70446973706F7361626C652E646973706F736528292C746869732E647261674F766572416E696D6174696F6E446973706F7361626C652626287468';
wwv_flow_imp.g_varchar2_table(12692) := '69732E647261674F766572416E696D6174696F6E446973706F7361626C652E646973706F736528292C746869732E647261674F766572416E696D6174696F6E446973706F7361626C653D766F69642030297D676574546172676574536563746F7228652C';
wwv_flow_imp.g_varchar2_table(12693) := '74297B696628766F696420303D3D3D742972657475726E3B636F6E7374206E3D652E6F6666736574592F746869732E6974656D735B745D2E73697A653B72657475726E204844284D6174682E666C6F6F72286E2F2E3235292C302C33297D676574497465';
wwv_flow_imp.g_varchar2_table(12694) := '6D496E64657846726F6D4576656E745461726765742865297B636F6E737420743D746869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F646528293B6C6574206E3D653B666F72283B6E20696E7374616E63656F662048544D4C45';
wwv_flow_imp.g_varchar2_table(12695) := '6C656D656E7426266E213D3D746869732E726F7773436F6E7461696E65722626742E636F6E7461696E73286E293B297B636F6E737420653D6E2E6765744174747269627574652822646174612D696E64657822293B69662865297B636F6E737420743D4E';
wwv_flow_imp.g_varchar2_table(12696) := '756D6265722865293B6966282169734E614E2874292972657475726E20747D6E3D6E2E706172656E74456C656D656E747D7D67657452656E64657252616E676528652C74297B72657475726E7B73746172743A746869732E72616E67654D61702E696E64';
wwv_flow_imp.g_varchar2_table(12697) := '657841742865292C656E643A746869732E72616E67654D61702E696E646578416674657228652B742D31297D7D5F726572656E64657228652C742C6E297B636F6E737420693D746869732E67657452656E64657252616E676528652C74293B6C6574206F';
wwv_flow_imp.g_varchar2_table(12698) := '2C733B653D3D3D746869732E656C656D656E74546F7028692E7374617274293F286F3D692E73746172742C733D30293A692E656E642D692E73746172743E312626286F3D692E73746172742B312C733D746869732E656C656D656E74546F70286F292D65';
wwv_flow_imp.g_varchar2_table(12699) := '293B6C657420723D303B666F72283B3B297B636F6E737420613D746869732E67657452656E64657252616E676528652C74293B6C6574206C3D21313B666F72286C657420653D612E73746172743B653C612E656E643B652B2B297B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(12700) := '6869732E70726F626544796E616D69634865696768742865293B30213D3D742626746869732E72616E67654D61702E73706C69636528652C312C5B746869732E6974656D735B655D5D292C722B3D742C6C3D6C7C7C30213D3D747D696628216C297B3021';
wwv_flow_imp.g_varchar2_table(12701) := '3D3D722626746869732E6576656E7475616C6C795570646174655363726F6C6C44696D656E73696F6E7328293B636F6E737420743D72542E72656C6174697665436F6D706C656D656E7428692C61293B666F7228636F6E73742065206F66207429666F72';
wwv_flow_imp.g_varchar2_table(12702) := '286C657420743D652E73746172743B743C652E656E643B742B2B29746869732E6974656D735B745D2E726F772626746869732E72656D6F76654974656D46726F6D444F4D2874293B636F6E7374206C3D72542E72656C6174697665436F6D706C656D656E';
wwv_flow_imp.g_varchar2_table(12703) := '7428612C69292E7265766572736528293B666F7228636F6E73742065206F66206C29666F72286C657420743D652E656E642D313B743E3D652E73746172743B742D2D29746869732E696E736572744974656D496E444F4D2874293B666F72286C65742065';
wwv_flow_imp.g_varchar2_table(12704) := '3D612E73746172743B653C612E656E643B652B2B29746869732E6974656D735B655D2E726F772626746869732E7570646174654974656D496E444F4D28746869732E6974656D735B655D2C65293B696628226E756D626572223D3D747970656F66206F29';
wwv_flow_imp.g_varchar2_table(12705) := '7B636F6E737420743D746869732E7363726F6C6C61626C652E6765744675747572655363726F6C6C506F736974696F6E28292E7363726F6C6C546F702D652C693D746869732E656C656D656E74546F70286F292D732B743B746869732E7365745363726F';
wwv_flow_imp.g_varchar2_table(12706) := '6C6C546F7028692C6E297D72657475726E20766F696420746869732E5F6F6E4469644368616E6765436F6E74656E744865696768742E6669726528746869732E636F6E74656E74486569676874297D7D7D70726F626544796E616D696348656967687428';
wwv_flow_imp.g_varchar2_table(12707) := '65297B76617220742C6E2C693B636F6E7374206F3D746869732E6974656D735B655D3B696628746869732E7669727475616C44656C65676174652E67657444796E616D6963486569676874297B636F6E737420653D746869732E7669727475616C44656C';
wwv_flow_imp.g_varchar2_table(12708) := '65676174652E67657444796E616D6963486569676874286F2E656C656D656E74293B6966286E756C6C213D3D65297B636F6E737420743D6F2E73697A653B72657475726E206F2E73697A653D652C6F2E6C61737444796E616D6963486569676874576964';
wwv_flow_imp.g_varchar2_table(12709) := '74683D746869732E72656E64657257696474682C652D747D7D696628216F2E68617344796E616D69634865696768747C7C6F2E6C61737444796E616D696348656967687457696474683D3D3D746869732E72656E64657257696474682972657475726E20';
wwv_flow_imp.g_varchar2_table(12710) := '303B696628746869732E7669727475616C44656C65676174652E68617344796E616D6963486569676874262621746869732E7669727475616C44656C65676174652E68617344796E616D6963486569676874286F2E656C656D656E74292972657475726E';
wwv_flow_imp.g_varchar2_table(12711) := '20303B636F6E737420733D6F2E73697A653B6966286F2E726F772972657475726E206F2E726F772E646F6D4E6F64652E7374796C652E6865696768743D22222C6F2E73697A653D6F2E726F772E646F6D4E6F64652E6F66667365744865696768742C3021';
wwv_flow_imp.g_varchar2_table(12712) := '3D3D6F2E73697A657C7C4273286F2E726F772E646F6D4E6F64652C7273286F2E726F772E646F6D4E6F6465292E646F63756D656E742E626F6479297C7C636F6E736F6C652E7761726E28224D6561737572696E67206974656D206E6F6465207468617420';
wwv_flow_imp.g_varchar2_table(12713) := '6973206E6F7420696E20444F4D2120416464204C6973745669657720746F2074686520444F4D206265666F7265206D6561737572696E6720726F77206865696768742122292C6F2E6C61737444796E616D696348656967687457696474683D746869732E';
wwv_flow_imp.g_varchar2_table(12714) := '72656E64657257696474682C6F2E73697A652D733B636F6E73747B726F773A727D3D746869732E63616368652E616C6C6F63286F2E74656D706C6174654964293B722E646F6D4E6F64652E7374796C652E6865696768743D22222C746869732E726F7773';
wwv_flow_imp.g_varchar2_table(12715) := '436F6E7461696E65722E617070656E644368696C6428722E646F6D4E6F6465293B636F6E737420613D746869732E72656E6465726572732E676574286F2E74656D706C6174654964293B6966282161297468726F77206E6577204F6528224D697373696E';
wwv_flow_imp.g_varchar2_table(12716) := '672072656E646572657220666F722074656D706C61746549643A20222B6F2E74656D706C6174654964293B72657475726E20612E72656E646572456C656D656E74286F2E656C656D656E742C652C722E74656D706C617465446174612C766F6964203029';
wwv_flow_imp.g_varchar2_table(12717) := '2C6F2E73697A653D722E646F6D4E6F64652E6F66667365744865696768742C6E756C6C3D3D3D28743D612E646973706F7365456C656D656E74297C7C766F696420303D3D3D747C7C742E63616C6C28612C6F2E656C656D656E742C652C722E74656D706C';
wwv_flow_imp.g_varchar2_table(12718) := '617465446174612C766F69642030292C6E756C6C3D3D3D28693D286E3D746869732E7669727475616C44656C6567617465292E73657444796E616D6963486569676874297C7C766F696420303D3D3D697C7C692E63616C6C286E2C6F2E656C656D656E74';
wwv_flow_imp.g_varchar2_table(12719) := '2C6F2E73697A65292C6F2E6C61737444796E616D696348656967687457696474683D746869732E72656E64657257696474682C746869732E726F7773436F6E7461696E65722E72656D6F76654368696C6428722E646F6D4E6F6465292C746869732E6361';
wwv_flow_imp.g_varchar2_table(12720) := '6368652E72656C656173652872292C6F2E73697A652D737D676574456C656D656E74446F6D49642865297B72657475726E60247B746869732E646F6D49647D5F247B657D607D646973706F736528297B76617220652C743B666F7228636F6E7374207420';
wwv_flow_imp.g_varchar2_table(12721) := '6F6620746869732E6974656D7329696628742E647261675374617274446973706F7361626C652E646973706F736528292C742E636865636B6564446973706F7361626C652E646973706F736528292C742E726F77297B636F6E7374206E3D746869732E72';
wwv_flow_imp.g_varchar2_table(12722) := '656E6465726572732E67657428742E726F772E74656D706C6174654964293B6E2626286E756C6C3D3D3D28653D6E2E646973706F7365456C656D656E74297C7C766F696420303D3D3D657C7C652E63616C6C286E2C742E656C656D656E742C2D312C742E';
wwv_flow_imp.g_varchar2_table(12723) := '726F772E74656D706C617465446174612C766F69642030292C6E2E646973706F736554656D706C61746528742E726F772E74656D706C6174654461746129297D746869732E6974656D733D5B5D2C746869732E646F6D4E6F64652626746869732E646F6D';
wwv_flow_imp.g_varchar2_table(12724) := '4E6F64652E706172656E744E6F64652626746869732E646F6D4E6F64652E706172656E744E6F64652E72656D6F76654368696C6428746869732E646F6D4E6F6465292C6E756C6C3D3D3D28743D746869732E647261674F766572416E696D6174696F6E44';
wwv_flow_imp.g_varchar2_table(12725) := '6973706F7361626C65297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E646973706F7361626C65732E646973706F736528297D7D45542E496E7374616E6365436F756E743D302C5F54285B44455D2C45542E70726F746F74';
wwv_flow_imp.g_varchar2_table(12726) := '7970652C226F6E4D6F757365436C69636B222C6E756C6C292C5F54285B44455D2C45542E70726F746F747970652C226F6E4D6F75736544626C436C69636B222C6E756C6C292C5F54285B44455D2C45542E70726F746F747970652C226F6E4D6F7573654D';
wwv_flow_imp.g_varchar2_table(12727) := '6964646C65436C69636B222C6E756C6C292C5F54285B44455D2C45542E70726F746F747970652C226F6E4D6F757365446F776E222C6E756C6C292C5F54285B44455D2C45542E70726F746F747970652C226F6E4D6F7573654F766572222C6E756C6C292C';
wwv_flow_imp.g_varchar2_table(12728) := '5F54285B44455D2C45542E70726F746F747970652C226F6E4D6F7573654F7574222C6E756C6C292C5F54285B44455D2C45542E70726F746F747970652C226F6E436F6E746578744D656E75222C6E756C6C292C5F54285B44455D2C45542E70726F746F74';
wwv_flow_imp.g_varchar2_table(12729) := '7970652C226F6E546F7563685374617274222C6E756C6C292C5F54285B44455D2C45542E70726F746F747970652C226F6E546170222C6E756C6C293B636F6E7374204C543D28652C74293D3E653D3D3D743B66756E6374696F6E20445428653D4C54297B';
wwv_flow_imp.g_varchar2_table(12730) := '72657475726E28742C6E293D3E506828742C6E2C65297D6E6577205765616B4D61703B636C6173732054547B636F6E7374727563746F7228652C742C6E297B746869732E6F776E65723D652C746869732E64656275674E616D65536F757263653D742C74';
wwv_flow_imp.g_varchar2_table(12731) := '6869732E7265666572656E6365466E3D6E7D67657444656275674E616D652865297B72657475726E2066756E6374696F6E28652C74297B766172206E3B636F6E737420693D4D542E6765742865293B696628692972657475726E20693B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(12732) := '3D66756E6374696F6E28652C74297B636F6E7374206E3D4D542E6765742865293B6966286E2972657475726E206E3B636F6E737420693D742E6F776E65723F66756E6374696F6E2865297B76617220743B636F6E7374206E3D4E542E6765742865293B69';
wwv_flow_imp.g_varchar2_table(12733) := '66286E2972657475726E206E3B636F6E737420693D66756E6374696F6E2865297B636F6E737420743D652E636F6E7374727563746F723B72657475726E20743F742E6E616D653A224F626A656374227D2865293B6C6574206F3D6E756C6C213D3D28743D';
wwv_flow_imp.g_varchar2_table(12734) := '41542E676574286929292626766F69642030213D3D743F743A303B6F2B2B2C41542E73657428692C6F293B636F6E737420733D313D3D3D6F3F693A60247B697D23247B6F7D603B72657475726E204E542E73657428652C73292C737D28742E6F776E6572';
wwv_flow_imp.g_varchar2_table(12735) := '292B222E223A22223B6C6574206F3B636F6E737420733D742E64656275674E616D65536F757263653B696628766F69642030213D3D73297B6966282266756E6374696F6E22213D747970656F6620732972657475726E20692B733B6966286F3D7328292C';
wwv_flow_imp.g_varchar2_table(12736) := '766F69642030213D3D6F2972657475726E20692B6F7D636F6E737420723D742E7265666572656E6365466E3B696628766F69642030213D3D722626286F3D50542872292C766F69642030213D3D6F292972657475726E20692B6F3B696628766F69642030';
wwv_flow_imp.g_varchar2_table(12737) := '213D3D742E6F776E6572297B636F6E7374206E3D66756E6374696F6E28652C74297B666F7228636F6E7374206E20696E206529696628655B6E5D3D3D3D742972657475726E206E7D28742E6F776E65722C65293B696628766F69642030213D3D6E297265';
wwv_flow_imp.g_varchar2_table(12738) := '7475726E20692B6E7D7D28652C74293B6966286F297B6C657420743D6E756C6C213D3D286E3D49542E676574286F29292626766F69642030213D3D6E3F6E3A303B742B2B2C49542E736574286F2C74293B636F6E737420693D313D3D3D743F6F3A60247B';
wwv_flow_imp.g_varchar2_table(12739) := '6F7D23247B747D603B72657475726E204D542E73657428652C69292C697D7D28652C74686973297D7D636F6E73742049543D6E6577204D61702C4D543D6E6577205765616B4D61702C41543D6E6577204D61702C4E543D6E6577205765616B4D61703B66';
wwv_flow_imp.g_varchar2_table(12740) := '756E6374696F6E2050542865297B636F6E737420743D652E746F537472696E6728292C6E3D2F5C2F5C2A5C2A5C732A406465736372697074696F6E5C732A285B5E2A5D2A295C2A5C2F2F2E657865632874292C693D6E3F6E5B315D3A766F696420303B72';
wwv_flow_imp.g_varchar2_table(12741) := '657475726E206E756C6C3D3D693F766F696420303A692E7472696D28297D6C6574204F542C52542C46542C42543B636C6173732056547B67657420544368616E676528297B72657475726E206E756C6C7D7265706F72744368616E67657328297B746869';
wwv_flow_imp.g_varchar2_table(12742) := '732E67657428297D726561642865297B72657475726E20653F652E726561644F627365727661626C652874686973293A746869732E67657428297D6D617028652C74297B636F6E7374206E3D766F696420303D3D3D743F766F696420303A652C693D766F';
wwv_flow_imp.g_varchar2_table(12743) := '696420303D3D3D743F653A743B72657475726E204654287B6F776E65723A6E2C64656275674E616D653A28293D3E7B636F6E737420653D50542869293B696628766F69642030213D3D652972657475726E20653B636F6E737420743D2F5E5C732A5C283F';
wwv_flow_imp.g_varchar2_table(12744) := '5C732A285B612D7A412D5A5F245D5B612D7A412D5A5F24302D395D2A295C732A5C293F5C732A3D3E5C732A5C31283F3A5C3F3F295C2E285B612D7A412D5A5F245D5B612D7A412D5A5F24302D395D2A295C732A242F2E6578656328692E746F537472696E';
wwv_flow_imp.g_varchar2_table(12745) := '672829293B72657475726E20743F60247B746869732E64656275674E616D657D2E247B745B325D7D603A6E3F766F696420303A60247B746869732E64656275674E616D657D20286D617070656429607D2C64656275675265666572656E6365466E3A697D';
wwv_flow_imp.g_varchar2_table(12746) := '2C28653D3E6928746869732E726561642865292C652929297D7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528652C74297B72657475726E20652E616464284F5428746869732C7429292C746869737D7D636C617373207A5420';
wwv_flow_imp.g_varchar2_table(12747) := '657874656E64732056547B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E6F62736572766572733D6E6577205365747D6164644F627365727665722865297B636F6E737420743D746869732E6F627365';
wwv_flow_imp.g_varchar2_table(12748) := '72766572732E73697A653B746869732E6F62736572766572732E6164642865292C303D3D3D742626746869732E6F6E46697273744F62736572766572416464656428297D72656D6F76654F627365727665722865297B746869732E6F6273657276657273';
wwv_flow_imp.g_varchar2_table(12749) := '2E64656C6574652865292626303D3D3D746869732E6F62736572766572732E73697A652626746869732E6F6E4C6173744F6273657276657252656D6F76656428297D6F6E46697273744F62736572766572416464656428297B7D6F6E4C6173744F627365';
wwv_flow_imp.g_varchar2_table(12750) := '7276657252656D6F76656428297B7D7D66756E6374696F6E20485428652C74297B636F6E7374206E3D6E657720715428652C74293B7472797B65286E297D66696E616C6C797B6E2E66696E69736828297D7D66756E6374696F6E2057542865297B696628';
wwv_flow_imp.g_varchar2_table(12751) := '42542965284254293B656C73657B636F6E737420743D6E657720715428652C766F69642030293B42543D743B7472797B652874297D66696E616C6C797B742E66696E69736828292C42543D766F696420307D7D7D66756E6374696F6E206A5428652C742C';
wwv_flow_imp.g_varchar2_table(12752) := '6E297B653F742865293A485428742C6E297D636C6173732071547B636F6E7374727563746F7228652C74297B766172206E3B746869732E5F666E3D652C746869732E5F67657444656275674E616D653D742C746869732E7570646174696E674F62736572';
wwv_flow_imp.g_varchar2_table(12753) := '766572733D5B5D2C6E756C6C3D3D3D286E3D766F69642030297C7C766F696420303D3D3D6E7C7C6E2E68616E646C65426567696E5472616E73616374696F6E2874686973297D67657444656275674E616D6528297B72657475726E20746869732E5F6765';
wwv_flow_imp.g_varchar2_table(12754) := '7444656275674E616D653F746869732E5F67657444656275674E616D6528293A505428746869732E5F666E297D7570646174654F6273657276657228652C74297B746869732E7570646174696E674F62736572766572732E70757368287B6F6273657276';
wwv_flow_imp.g_varchar2_table(12755) := '65723A652C6F627365727661626C653A747D292C652E626567696E5570646174652874297D66696E69736828297B76617220653B636F6E737420743D746869732E7570646174696E674F62736572766572733B666F72286C657420653D303B653C742E6C';
wwv_flow_imp.g_varchar2_table(12756) := '656E6774683B652B2B297B636F6E73747B6F627365727665723A6E2C6F627365727661626C653A697D3D745B655D3B6E2E656E645570646174652869297D746869732E7570646174696E674F62736572766572733D6E756C6C2C6E756C6C3D3D3D28653D';
wwv_flow_imp.g_varchar2_table(12757) := '766F69642030297C7C766F696420303D3D3D657C7C652E68616E646C65456E645472616E73616374696F6E28297D7D66756E6374696F6E20245428652C74297B6C6574206E3B72657475726E206E3D22737472696E67223D3D747970656F6620653F6E65';
wwv_flow_imp.g_varchar2_table(12758) := '7720545428766F696420302C652C766F69642030293A6E657720545428652C766F696420302C766F69642030292C6E6577205554286E2C742C4C54297D636C61737320555420657874656E6473207A547B6765742064656275674E616D6528297B766172';
wwv_flow_imp.g_varchar2_table(12759) := '20653B72657475726E206E756C6C213D3D28653D746869732E5F64656275674E616D65446174612E67657444656275674E616D65287468697329292626766F69642030213D3D653F653A224F627365727661626C6556616C7565227D636F6E7374727563';
wwv_flow_imp.g_varchar2_table(12760) := '746F7228652C742C6E297B737570657228292C746869732E5F64656275674E616D65446174613D652C746869732E5F657175616C697479436F6D70617261746F723D6E2C746869732E5F76616C75653D747D67657428297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(12761) := '5F76616C75657D73657428652C742C6E297B76617220693B696628746869732E5F657175616C697479436F6D70617261746F7228746869732E5F76616C75652C65292972657475726E3B6C6574206F3B747C7C28743D6F3D6E6577207154282828293D3E';
wwv_flow_imp.g_varchar2_table(12762) := '7B7D292C2828293D3E6053657474696E6720247B746869732E64656275674E616D657D602929293B7472797B636F6E7374206F3D746869732E5F76616C75653B746869732E5F73657456616C75652865292C6E756C6C3D3D3D28693D766F69642030297C';
wwv_flow_imp.g_varchar2_table(12763) := '7C766F696420303D3D3D697C7C692E68616E646C654F627365727661626C654368616E67656428746869732C7B6F6C6456616C75653A6F2C6E657756616C75653A652C6368616E67653A6E2C6469644368616E67653A21302C68616456616C75653A2130';
wwv_flow_imp.g_varchar2_table(12764) := '7D293B666F7228636F6E73742065206F6620746869732E6F627365727665727329742E7570646174654F6273657276657228652C74686973292C652E68616E646C654368616E676528746869732C6E297D66696E616C6C797B6F26266F2E66696E697368';
wwv_flow_imp.g_varchar2_table(12765) := '28297D7D746F537472696E6728297B72657475726E60247B746869732E64656275674E616D657D3A20247B746869732E5F76616C75657D607D5F73657456616C75652865297B746869732E5F76616C75653D657D7D66756E6374696F6E204B5428652C74';
wwv_flow_imp.g_varchar2_table(12766) := '297B6C6574206E3B72657475726E206E3D22737472696E67223D3D747970656F6620653F6E657720545428766F696420302C652C766F69642030293A6E657720545428652C766F696420302C766F69642030292C6E6577204754286E2C742C4C54297D63';
wwv_flow_imp.g_varchar2_table(12767) := '6C61737320475420657874656E64732055547B5F73657456616C75652865297B746869732E5F76616C7565213D3D65262628746869732E5F76616C75652626746869732E5F76616C75652E646973706F736528292C746869732E5F76616C75653D65297D';
wwv_flow_imp.g_varchar2_table(12768) := '646973706F736528297B76617220653B6E756C6C3D3D3D28653D746869732E5F76616C7565297C7C766F696420303D3D3D657C7C652E646973706F736528297D7D66756E6374696F6E20515428652C74297B72657475726E20766F69642030213D3D743F';
wwv_flow_imp.g_varchar2_table(12769) := '6E6577204A54286E657720545428652C766F696420302C74292C742C766F696420302C766F696420302C766F696420302C4C54293A6E6577204A54286E657720545428766F696420302C766F696420302C65292C652C766F696420302C766F696420302C';
wwv_flow_imp.g_varchar2_table(12770) := '766F696420302C4C54297D66756E6374696F6E20595428652C74297B766172206E3B72657475726E206E6577204A54286E657720545428652E6F776E65722C652E64656275674E616D652C652E64656275675265666572656E6365466E292C742C766F69';
wwv_flow_imp.g_varchar2_table(12771) := '6420302C766F696420302C652E6F6E4C6173744F6273657276657252656D6F7665642C6E756C6C213D3D286E3D652E657175616C73466E292626766F69642030213D3D6E3F6E3A4C54297D66756E6374696F6E205A5428652C74297B6C6574206E2C693B';
wwv_flow_imp.g_varchar2_table(12772) := '766F696420303D3D3D743F286E3D652C693D766F69642030293A28693D652C6E3D74293B636F6E7374206F3D6E65772061743B72657475726E206E6577204A54286E657720545428692C766F696420302C6E292C28653D3E286F2E636C65617228292C6E';
wwv_flow_imp.g_varchar2_table(12773) := '28652C6F2929292C766F696420302C766F696420302C2828293D3E6F2E646973706F73652829292C4C54297D66756E6374696F6E20585428652C74297B6C6574206E2C693B766F696420303D3D3D743F286E3D652C693D766F69642030293A28693D652C';
wwv_flow_imp.g_varchar2_table(12774) := '6E3D74293B636F6E7374206F3D6E65772061743B72657475726E206E6577204A54286E657720545428692C766F696420302C6E292C28653D3E7B6F2E636C65617228293B636F6E737420743D6E2865293B72657475726E207426266F2E6164642874292C';
wwv_flow_imp.g_varchar2_table(12775) := '747D292C766F696420302C766F696420302C2828293D3E6F2E646973706F73652829292C4C54297D46543D59543B636C617373204A5420657874656E6473207A547B6765742064656275674E616D6528297B76617220653B72657475726E206E756C6C21';
wwv_flow_imp.g_varchar2_table(12776) := '3D3D28653D746869732E5F64656275674E616D65446174612E67657444656275674E616D65287468697329292626766F69642030213D3D653F653A2228616E6F6E796D6F757329227D636F6E7374727563746F7228652C742C6E2C692C6F3D766F696420';
wwv_flow_imp.g_varchar2_table(12777) := '302C73297B76617220722C613B737570657228292C746869732E5F64656275674E616D65446174613D652C746869732E5F636F6D70757465466E3D742C746869732E6372656174654368616E676553756D6D6172793D6E2C746869732E5F68616E646C65';
wwv_flow_imp.g_varchar2_table(12778) := '4368616E67653D692C746869732E5F68616E646C654C6173744F6273657276657252656D6F7665643D6F2C746869732E5F657175616C697479436F6D70617261746F723D732C746869732E73746174653D302C746869732E76616C75653D766F69642030';
wwv_flow_imp.g_varchar2_table(12779) := '2C746869732E757064617465436F756E743D302C746869732E646570656E64656E636965733D6E6577205365742C746869732E646570656E64656E63696573546F426552656D6F7665643D6E6577205365742C746869732E6368616E676553756D6D6172';
wwv_flow_imp.g_varchar2_table(12780) := '793D766F696420302C746869732E6368616E676553756D6D6172793D6E756C6C3D3D3D28723D746869732E6372656174654368616E676553756D6D617279297C7C766F696420303D3D3D723F766F696420303A722E63616C6C2874686973292C6E756C6C';
wwv_flow_imp.g_varchar2_table(12781) := '3D3D3D28613D766F69642030297C7C766F696420303D3D3D617C7C612E68616E646C6544657269766564437265617465642874686973297D6F6E4C6173744F6273657276657252656D6F76656428297B76617220653B746869732E73746174653D302C74';
wwv_flow_imp.g_varchar2_table(12782) := '6869732E76616C75653D766F696420303B666F7228636F6E73742065206F6620746869732E646570656E64656E6369657329652E72656D6F76654F627365727665722874686973293B746869732E646570656E64656E636965732E636C65617228292C6E';
wwv_flow_imp.g_varchar2_table(12783) := '756C6C3D3D3D28653D746869732E5F68616E646C654C6173744F6273657276657252656D6F766564297C7C766F696420303D3D3D657C7C652E63616C6C2874686973297D67657428297B76617220653B696628303D3D3D746869732E6F62736572766572';
wwv_flow_imp.g_varchar2_table(12784) := '732E73697A65297B636F6E737420743D746869732E5F636F6D70757465466E28746869732C6E756C6C3D3D3D28653D746869732E6372656174654368616E676553756D6D617279297C7C766F696420303D3D3D653F766F696420303A652E63616C6C2874';
wwv_flow_imp.g_varchar2_table(12785) := '68697329293B72657475726E20746869732E6F6E4C6173744F6273657276657252656D6F76656428292C747D646F7B696628313D3D3D746869732E737461746529666F7228636F6E73742065206F6620746869732E646570656E64656E63696573296966';
wwv_flow_imp.g_varchar2_table(12786) := '28652E7265706F72744368616E67657328292C323D3D3D746869732E737461746529627265616B3B313D3D3D746869732E7374617465262628746869732E73746174653D33292C746869732E5F7265636F6D7075746549664E656564656428297D776869';
wwv_flow_imp.g_varchar2_table(12787) := '6C652833213D3D746869732E7374617465293B72657475726E20746869732E76616C75657D5F7265636F6D7075746549664E656564656428297B76617220652C743B696628333D3D3D746869732E73746174652972657475726E3B636F6E7374206E3D74';
wwv_flow_imp.g_varchar2_table(12788) := '6869732E646570656E64656E63696573546F426552656D6F7665643B746869732E646570656E64656E63696573546F426552656D6F7665643D746869732E646570656E64656E636965732C746869732E646570656E64656E636965733D6E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(12789) := '20693D30213D3D746869732E73746174652C6F3D746869732E76616C75653B746869732E73746174653D333B636F6E737420733D746869732E6368616E676553756D6D6172793B746869732E6368616E676553756D6D6172793D6E756C6C3D3D3D28653D';
wwv_flow_imp.g_varchar2_table(12790) := '746869732E6372656174654368616E676553756D6D617279297C7C766F696420303D3D3D653F766F696420303A652E63616C6C2874686973293B7472797B746869732E76616C75653D746869732E5F636F6D70757465466E28746869732C73297D66696E';
wwv_flow_imp.g_varchar2_table(12791) := '616C6C797B666F7228636F6E73742065206F6620746869732E646570656E64656E63696573546F426552656D6F76656429652E72656D6F76654F627365727665722874686973293B746869732E646570656E64656E63696573546F426552656D6F766564';
wwv_flow_imp.g_varchar2_table(12792) := '2E636C65617228297D636F6E737420723D69262621746869732E5F657175616C697479436F6D70617261746F72286F2C746869732E76616C7565293B6966286E756C6C3D3D3D28743D766F69642030297C7C766F696420303D3D3D747C7C742E68616E64';
wwv_flow_imp.g_varchar2_table(12793) := '6C65446572697665645265636F6D707574656428746869732C7B6F6C6456616C75653A6F2C6E657756616C75653A746869732E76616C75652C6368616E67653A766F696420302C6469644368616E67653A722C68616456616C75653A697D292C7229666F';
wwv_flow_imp.g_varchar2_table(12794) := '7228636F6E73742065206F6620746869732E6F627365727665727329652E68616E646C654368616E676528746869732C766F69642030297D746F537472696E6728297B72657475726E604C617A79446572697665643C247B746869732E64656275674E61';
wwv_flow_imp.g_varchar2_table(12795) := '6D657D3E607D626567696E5570646174652865297B746869732E757064617465436F756E742B2B3B636F6E737420743D313D3D3D746869732E757064617465436F756E743B696628333D3D3D746869732E7374617465262628746869732E73746174653D';
wwv_flow_imp.g_varchar2_table(12796) := '312C21742929666F7228636F6E73742065206F6620746869732E6F627365727665727329652E68616E646C65506F737369626C654368616E67652874686973293B6966287429666F7228636F6E73742065206F6620746869732E6F627365727665727329';
wwv_flow_imp.g_varchar2_table(12797) := '652E626567696E5570646174652874686973297D656E645570646174652865297B696628746869732E757064617465436F756E742D2D2C303D3D3D746869732E757064617465436F756E74297B636F6E737420653D5B2E2E2E746869732E6F6273657276';
wwv_flow_imp.g_varchar2_table(12798) := '6572735D3B666F7228636F6E73742074206F66206529742E656E645570646174652874686973297D6264282828293D3E746869732E757064617465436F756E743E3D3029297D68616E646C65506F737369626C654368616E67652865297B696628333D3D';
wwv_flow_imp.g_varchar2_table(12799) := '3D746869732E73746174652626746869732E646570656E64656E636965732E686173286529262621746869732E646570656E64656E63696573546F426552656D6F7665642E686173286529297B746869732E73746174653D313B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(12800) := '65206F6620746869732E6F627365727665727329652E68616E646C65506F737369626C654368616E67652874686973297D7D68616E646C654368616E676528652C74297B696628746869732E646570656E64656E636965732E6861732865292626217468';
wwv_flow_imp.g_varchar2_table(12801) := '69732E646570656E64656E63696573546F426552656D6F7665642E686173286529297B636F6E7374206E3D21746869732E5F68616E646C654368616E67657C7C746869732E5F68616E646C654368616E6765287B6368616E6765644F627365727661626C';
wwv_flow_imp.g_varchar2_table(12802) := '653A652C6368616E67653A742C6469644368616E67653A743D3E743D3D3D657D2C746869732E6368616E676553756D6D617279292C693D333D3D3D746869732E73746174653B6966286E262628313D3D3D746869732E73746174657C7C69292626287468';
wwv_flow_imp.g_varchar2_table(12803) := '69732E73746174653D322C692929666F7228636F6E73742065206F6620746869732E6F627365727665727329652E68616E646C65506F737369626C654368616E67652874686973297D7D726561644F627365727661626C652865297B652E6164644F6273';
wwv_flow_imp.g_varchar2_table(12804) := '65727665722874686973293B636F6E737420743D652E67657428293B72657475726E20746869732E646570656E64656E636965732E6164642865292C746869732E646570656E64656E63696573546F426552656D6F7665642E64656C6574652865292C74';
wwv_flow_imp.g_varchar2_table(12805) := '7D6164644F627365727665722865297B636F6E737420743D21746869732E6F62736572766572732E6861732865292626746869732E757064617465436F756E743E303B73757065722E6164644F627365727665722865292C742626652E626567696E5570';
wwv_flow_imp.g_varchar2_table(12806) := '646174652874686973297D72656D6F76654F627365727665722865297B636F6E737420743D746869732E6F62736572766572732E6861732865292626746869732E757064617465436F756E743E303B73757065722E72656D6F76654F6273657276657228';
wwv_flow_imp.g_varchar2_table(12807) := '65292C742626652E656E645570646174652874686973297D7D66756E6374696F6E2065492865297B72657475726E206E6577206F49286E657720545428766F696420302C766F696420302C65292C652C766F696420302C766F69642030297D66756E6374';
wwv_flow_imp.g_varchar2_table(12808) := '696F6E20744928652C74297B766172206E3B72657475726E206E6577206F49286E657720545428652E6F776E65722C652E64656275674E616D652C6E756C6C213D3D286E3D652E64656275675265666572656E6365466E292626766F69642030213D3D6E';
wwv_flow_imp.g_varchar2_table(12809) := '3F6E3A74292C742C766F696420302C766F69642030297D66756E6374696F6E206E4928652C74297B766172206E3B72657475726E206E6577206F49286E657720545428652E6F776E65722C652E64656275674E616D652C6E756C6C213D3D286E3D652E64';
wwv_flow_imp.g_varchar2_table(12810) := '656275675265666572656E6365466E292626766F69642030213D3D6E3F6E3A74292C742C652E637265617465456D7074794368616E676553756D6D6172792C652E68616E646C654368616E6765297D66756E6374696F6E2069492865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(12811) := '743D6E65772061742C6E3D7449287B6F776E65723A766F696420302C64656275674E616D653A766F696420302C64656275675265666572656E6365466E3A657D2C286E3D3E7B742E636C65617228292C65286E2C74297D29293B72657475726E20727428';
wwv_flow_imp.g_varchar2_table(12812) := '2828293D3E7B6E2E646973706F736528292C742E646973706F736528297D29297D636C617373206F497B6765742064656275674E616D6528297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F64656275674E616D6544617461';
wwv_flow_imp.g_varchar2_table(12813) := '2E67657444656275674E616D65287468697329292626766F69642030213D3D653F653A2228616E6F6E796D6F757329227D636F6E7374727563746F7228652C742C6E2C69297B766172206F2C733B746869732E5F64656275674E616D65446174613D652C';
wwv_flow_imp.g_varchar2_table(12814) := '746869732E5F72756E466E3D742C746869732E6372656174654368616E676553756D6D6172793D6E2C746869732E5F68616E646C654368616E67653D692C746869732E73746174653D322C746869732E757064617465436F756E743D302C746869732E64';
wwv_flow_imp.g_varchar2_table(12815) := '6973706F7365643D21312C746869732E646570656E64656E636965733D6E6577205365742C746869732E646570656E64656E63696573546F426552656D6F7665643D6E6577205365742C746869732E6368616E676553756D6D6172793D6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(12816) := '286F3D746869732E6372656174654368616E676553756D6D617279297C7C766F696420303D3D3D6F3F766F696420303A6F2E63616C6C2874686973292C6E756C6C3D3D3D28733D766F69642030297C7C766F696420303D3D3D737C7C732E68616E646C65';
wwv_flow_imp.g_varchar2_table(12817) := '4175746F72756E437265617465642874686973292C746869732E5F72756E49664E656564656428292C4A652874686973297D646973706F736528297B746869732E646973706F7365643D21303B666F7228636F6E73742065206F6620746869732E646570';
wwv_flow_imp.g_varchar2_table(12818) := '656E64656E6369657329652E72656D6F76654F627365727665722874686973293B746869732E646570656E64656E636965732E636C65617228292C65742874686973297D5F72756E49664E656564656428297B76617220652C742C6E3B696628333D3D3D';
wwv_flow_imp.g_varchar2_table(12819) := '746869732E73746174652972657475726E3B636F6E737420693D746869732E646570656E64656E63696573546F426552656D6F7665643B746869732E646570656E64656E63696573546F426552656D6F7665643D746869732E646570656E64656E636965';
wwv_flow_imp.g_varchar2_table(12820) := '732C746869732E646570656E64656E636965733D692C746869732E73746174653D333B636F6E7374206F3D746869732E646973706F7365643B7472797B696628216F297B6E756C6C3D3D3D28653D766F69642030297C7C766F696420303D3D3D657C7C65';
wwv_flow_imp.g_varchar2_table(12821) := '2E68616E646C654175746F72756E5472696767657265642874686973293B636F6E7374206E3D746869732E6368616E676553756D6D6172793B746869732E6368616E676553756D6D6172793D6E756C6C3D3D3D28743D746869732E637265617465436861';
wwv_flow_imp.g_varchar2_table(12822) := '6E676553756D6D617279297C7C766F696420303D3D3D743F766F696420303A742E63616C6C2874686973292C746869732E5F72756E466E28746869732C6E297D7D66696E616C6C797B6F7C7C6E756C6C3D3D3D286E3D766F69642030297C7C766F696420';
wwv_flow_imp.g_varchar2_table(12823) := '303D3D3D6E7C7C6E2E68616E646C654175746F72756E46696E69736865642874686973293B666F7228636F6E73742065206F6620746869732E646570656E64656E63696573546F426552656D6F76656429652E72656D6F76654F62736572766572287468';
wwv_flow_imp.g_varchar2_table(12824) := '6973293B746869732E646570656E64656E63696573546F426552656D6F7665642E636C65617228297D7D746F537472696E6728297B72657475726E604175746F72756E3C247B746869732E64656275674E616D657D3E607D626567696E55706461746528';
wwv_flow_imp.g_varchar2_table(12825) := '297B333D3D3D746869732E7374617465262628746869732E73746174653D31292C746869732E757064617465436F756E742B2B7D656E6455706461746528297B696628313D3D3D746869732E757064617465436F756E7429646F7B696628313D3D3D7468';
wwv_flow_imp.g_varchar2_table(12826) := '69732E7374617465297B746869732E73746174653D333B666F7228636F6E73742065206F6620746869732E646570656E64656E6369657329696628652E7265706F72744368616E67657328292C323D3D3D746869732E737461746529627265616B7D7468';
wwv_flow_imp.g_varchar2_table(12827) := '69732E5F72756E49664E656564656428297D7768696C652833213D3D746869732E7374617465293B746869732E757064617465436F756E742D2D2C6264282828293D3E746869732E757064617465436F756E743E3D3029297D68616E646C65506F737369';
wwv_flow_imp.g_varchar2_table(12828) := '626C654368616E67652865297B333D3D3D746869732E73746174652626746869732E646570656E64656E636965732E686173286529262621746869732E646570656E64656E63696573546F426552656D6F7665642E686173286529262628746869732E73';
wwv_flow_imp.g_varchar2_table(12829) := '746174653D31297D68616E646C654368616E676528652C74297B746869732E646570656E64656E636965732E686173286529262621746869732E646570656E64656E63696573546F426552656D6F7665642E68617328652926262821746869732E5F6861';
wwv_flow_imp.g_varchar2_table(12830) := '6E646C654368616E67657C7C746869732E5F68616E646C654368616E6765287B6368616E6765644F627365727661626C653A652C6368616E67653A742C6469644368616E67653A743D3E743D3D3D657D2C746869732E6368616E676553756D6D61727929';
wwv_flow_imp.g_varchar2_table(12831) := '29262628746869732E73746174653D32297D726561644F627365727661626C652865297B696628746869732E646973706F7365642972657475726E20652E67657428293B652E6164644F627365727665722874686973293B636F6E737420743D652E6765';
wwv_flow_imp.g_varchar2_table(12832) := '7428293B72657475726E20746869732E646570656E64656E636965732E6164642865292C746869732E646570656E64656E63696573546F426552656D6F7665642E64656C6574652865292C747D7D66756E6374696F6E2073492865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(12833) := '6E65772072492865297D2166756E6374696F6E2865297B652E4F627365727665723D6F497D2865497C7C2865493D7B7D29293B636C61737320724920657874656E64732056547B636F6E7374727563746F722865297B737570657228292C746869732E76';
wwv_flow_imp.g_varchar2_table(12834) := '616C75653D657D6765742064656275674E616D6528297B72657475726E20746869732E746F537472696E6728297D67657428297B72657475726E20746869732E76616C75657D6164644F627365727665722865297B7D72656D6F76654F62736572766572';
wwv_flow_imp.g_varchar2_table(12835) := '2865297B7D746F537472696E6728297B72657475726E60436F6E73743A20247B746869732E76616C75657D607D7D66756E6374696F6E20614928652C74297B72657475726E206E6577206C4928652C74297D636C617373206C4920657874656E6473207A';
wwv_flow_imp.g_varchar2_table(12836) := '547B636F6E7374727563746F7228652C74297B737570657228292C746869732E6576656E743D652C746869732E5F67657456616C75653D742C746869732E68617356616C75653D21312C746869732E68616E646C654576656E743D653D3E7B7661722074';
wwv_flow_imp.g_varchar2_table(12837) := '3B636F6E7374206E3D746869732E5F67657456616C75652865292C693D746869732E76616C75652C6F3D21746869732E68617356616C75657C7C69213D3D6E3B6C657420733D21313B6F262628746869732E76616C75653D6E2C746869732E6861735661';
wwv_flow_imp.g_varchar2_table(12838) := '6C7565262628733D21302C6A54286C492E676C6F62616C5472616E73616374696F6E2C28653D3E7B76617220743B6E756C6C3D3D3D28743D766F69642030297C7C766F696420303D3D3D747C7C742E68616E646C6546726F6D4576656E744F6273657276';
wwv_flow_imp.g_varchar2_table(12839) := '61626C6554726967676572656428746869732C7B6F6C6456616C75653A692C6E657756616C75653A6E2C6368616E67653A766F696420302C6469644368616E67653A6F2C68616456616C75653A746869732E68617356616C75657D293B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(12840) := '73742074206F6620746869732E6F627365727665727329652E7570646174654F6273657276657228742C74686973292C742E68616E646C654368616E676528746869732C766F69642030297D292C2828293D3E7B636F6E737420653D746869732E676574';
wwv_flow_imp.g_varchar2_table(12841) := '44656275674E616D6528293B72657475726E224576656E74206669726564222B28653F603A20247B657D603A2222297D2929292C746869732E68617356616C75653D2130292C737C7C6E756C6C3D3D3D28743D766F69642030297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(12842) := '3D747C7C742E68616E646C6546726F6D4576656E744F627365727661626C6554726967676572656428746869732C7B6F6C6456616C75653A692C6E657756616C75653A6E2C6368616E67653A766F696420302C6469644368616E67653A6F2C6861645661';
wwv_flow_imp.g_varchar2_table(12843) := '6C75653A746869732E68617356616C75657D297D7D67657444656275674E616D6528297B72657475726E20505428746869732E5F67657456616C7565297D6765742064656275674E616D6528297B636F6E737420653D746869732E67657444656275674E';
wwv_flow_imp.g_varchar2_table(12844) := '616D6528293B72657475726E2246726F6D204576656E74222B28653F603A20247B657D603A2222297D6F6E46697273744F62736572766572416464656428297B746869732E737562736372697074696F6E3D746869732E6576656E7428746869732E6861';
wwv_flow_imp.g_varchar2_table(12845) := '6E646C654576656E74297D6F6E4C6173744F6273657276657252656D6F76656428297B746869732E737562736372697074696F6E2E646973706F736528292C746869732E737562736372697074696F6E3D766F696420302C746869732E68617356616C75';
wwv_flow_imp.g_varchar2_table(12846) := '653D21312C746869732E76616C75653D766F696420307D67657428297B72657475726E20746869732E737562736372697074696F6E3F28746869732E68617356616C75657C7C746869732E68616E646C654576656E7428766F69642030292C746869732E';
wwv_flow_imp.g_varchar2_table(12847) := '76616C7565293A746869732E5F67657456616C756528766F69642030297D7D66756E6374696F6E20634928652C74297B72657475726E206E657720644928652C74297D2166756E6374696F6E2865297B652E4F627365727665723D6C492C652E62617463';
wwv_flow_imp.g_varchar2_table(12848) := '684576656E7473476C6F62616C6C793D66756E6374696F6E28652C74297B6C6574206E3D21313B766F696420303D3D3D6C492E676C6F62616C5472616E73616374696F6E2626286C492E676C6F62616C5472616E73616374696F6E3D652C6E3D2130293B';
wwv_flow_imp.g_varchar2_table(12849) := '7472797B7428297D66696E616C6C797B6E2626286C492E676C6F62616C5472616E73616374696F6E3D766F69642030297D7D7D2861497C7C2861493D7B7D29293B636C61737320644920657874656E6473207A547B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(12850) := '297B737570657228292C746869732E64656275674E616D653D652C746869732E6576656E743D742C746869732E68616E646C654576656E743D28293D3E7B48542828653D3E7B666F7228636F6E73742074206F6620746869732E6F627365727665727329';
wwv_flow_imp.g_varchar2_table(12851) := '652E7570646174654F6273657276657228742C74686973292C742E68616E646C654368616E676528746869732C766F69642030297D292C2828293D3E746869732E64656275674E616D6529297D7D6F6E46697273744F6273657276657241646465642829';
wwv_flow_imp.g_varchar2_table(12852) := '7B746869732E737562736372697074696F6E3D746869732E6576656E7428746869732E68616E646C654576656E74297D6F6E4C6173744F6273657276657252656D6F76656428297B746869732E737562736372697074696F6E2E646973706F736528292C';
wwv_flow_imp.g_varchar2_table(12853) := '746869732E737562736372697074696F6E3D766F696420307D67657428297B7D7D66756E6374696F6E2068492865297B72657475726E22737472696E67223D3D747970656F6620653F6E65772075492865293A6E657720754928766F696420302C65297D';
wwv_flow_imp.g_varchar2_table(12854) := '636C61737320754920657874656E6473207A547B6765742064656275674E616D6528297B76617220653B72657475726E206E756C6C213D3D28653D6E657720545428746869732E5F6F776E65722C746869732E5F64656275674E616D652C766F69642030';
wwv_flow_imp.g_varchar2_table(12855) := '292E67657444656275674E616D65287468697329292626766F69642030213D3D653F653A224F627365727661626C65205369676E616C227D636F6E7374727563746F7228652C74297B737570657228292C746869732E5F64656275674E616D653D652C74';
wwv_flow_imp.g_varchar2_table(12856) := '6869732E5F6F776E65723D747D7472696767657228652C74297B6966286529666F7228636F6E7374206E206F6620746869732E6F627365727665727329652E7570646174654F62736572766572286E2C74686973292C6E2E68616E646C654368616E6765';
wwv_flow_imp.g_varchar2_table(12857) := '28746869732C74293B656C73652048542828653D3E7B746869732E7472696767657228652C74297D292C2828293D3E6054726967676572207369676E616C20247B746869732E64656275674E616D657D6029297D67657428297B7D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(12858) := '20704928652C74297B636F6E7374206E3D6E65772067492821302C74293B72657475726E20652E6164644F62736572766572286E292C743F7428652E6765742829293A652E7265706F72744368616E67657328292C7274282828293D3E7B652E72656D6F';
wwv_flow_imp.g_varchar2_table(12859) := '76654F62736572766572286E297D29297D52543D66756E6374696F6E2865297B636F6E737420743D6E65772067492821312C766F69642030293B72657475726E20652E6164644F627365727665722874292C7274282828293D3E7B652E72656D6F76654F';
wwv_flow_imp.g_varchar2_table(12860) := '627365727665722874297D29297D2C66756E6374696F6E2865297B4F543D657D287049293B636C6173732067497B636F6E7374727563746F7228652C74297B746869732E5F666F7263655265636F6D707574653D652C746869732E5F68616E646C655661';
wwv_flow_imp.g_varchar2_table(12861) := '6C75653D742C746869732E5F636F756E7465723D307D626567696E5570646174652865297B746869732E5F636F756E7465722B2B7D656E645570646174652865297B746869732E5F636F756E7465722D2D2C303D3D3D746869732E5F636F756E74657226';
wwv_flow_imp.g_varchar2_table(12862) := '26746869732E5F666F7263655265636F6D70757465262628746869732E5F68616E646C6556616C75653F746869732E5F68616E646C6556616C756528652E6765742829293A652E7265706F72744368616E6765732829297D68616E646C65506F73736962';
wwv_flow_imp.g_varchar2_table(12863) := '6C654368616E67652865297B7D68616E646C654368616E676528652C74297B7D7D636C617373206D497B636F6E7374727563746F7228652C74297B746869732E5F6D61703D652C746869732E5F6B657953656C6563746F723D742C746869732E5F636163';
wwv_flow_imp.g_varchar2_table(12864) := '68653D6E6577204D61702C746869732E5F6974656D733D5B5D7D646973706F736528297B746869732E5F63616368652E666F72456163682828653D3E652E73746F72652E646973706F7365282929292C746869732E5F63616368652E636C65617228297D';
wwv_flow_imp.g_varchar2_table(12865) := '7365744974656D732865297B636F6E737420743D5B5D2C6E3D6E65772053657428746869732E5F63616368652E6B6579732829293B666F7228636F6E73742069206F662065297B636F6E737420653D746869732E5F6B657953656C6563746F723F746869';
wwv_flow_imp.g_varchar2_table(12866) := '732E5F6B657953656C6563746F722869293A693B6C6574206F3D746869732E5F63616368652E6765742865293B6966286F296E2E64656C6574652865293B656C73657B636F6E737420743D6E65772061743B6F3D7B6F75743A746869732E5F6D61702869';
wwv_flow_imp.g_varchar2_table(12867) := '2C74292C73746F72653A747D2C746869732E5F63616368652E73657428652C6F297D742E70757368286F2E6F7574297D666F7228636F6E73742065206F66206E29746869732E5F63616368652E6765742865292E73746F72652E646973706F736528292C';
wwv_flow_imp.g_varchar2_table(12868) := '746869732E5F63616368652E64656C6574652865293B746869732E5F6974656D733D747D6765744974656D7328297B72657475726E20746869732E5F6974656D737D7D66756E6374696F6E20664928652C742C6E2C69297B72657475726E20747C7C2874';
wwv_flow_imp.g_varchar2_table(12869) := '3D653D3E6E756C6C213D65292C6E65772050726F6D6973652828286F2C73293D3E7B6C657420723D21302C613D21313B636F6E7374206C3D652E6D61702828653D3E287B697346696E69736865643A742865292C6572726F723A21216E26266E2865292C';
wwv_flow_imp.g_varchar2_table(12870) := '73746174653A657D2929292C633D65492828653D3E7B636F6E73747B697346696E69736865643A742C6572726F723A6E2C73746174653A697D3D6C2E726561642865293B28747C7C6E29262628723F613D21303A632E646973706F736528292C6E3F7328';
wwv_flow_imp.g_varchar2_table(12871) := '21303D3D3D6E3F693A6E293A6F286929297D29293B69662869297B636F6E737420653D692E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B632E646973706F736528292C652E646973706F736528292C73286E657720496529';
wwv_flow_imp.g_varchar2_table(12872) := '7D29293B696628692E697343616E63656C6C6174696F6E5265717565737465642972657475726E20632E646973706F736528292C652E646973706F736528292C766F69642073286E6577204965297D723D21312C612626632E646973706F736528297D29';
wwv_flow_imp.g_varchar2_table(12873) := '297D7661722076492C62492C5F493D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F70657274794465';
wwv_flow_imp.g_varchar2_table(12874) := '7363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528';
wwv_flow_imp.g_varchar2_table(12875) := '652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E2073';
wwv_flow_imp.g_varchar2_table(12876) := '3E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D3B636C6173732079497B636F6E7374727563746F722865297B746869732E74726169743D652C746869732E72656E6465726564456C656D656E74733D5B5D';
wwv_flow_imp.g_varchar2_table(12877) := '7D6765742074656D706C617465496428297B72657475726E6074656D706C6174653A247B746869732E74726169742E6E616D657D607D72656E64657254656D706C6174652865297B72657475726E20657D72656E646572456C656D656E7428652C742C6E';
wwv_flow_imp.g_varchar2_table(12878) := '297B636F6E737420693D746869732E72656E6465726564456C656D656E74732E66696E64496E6465782828653D3E652E74656D706C617465446174613D3D3D6E29293B696628693E3D30297B636F6E737420653D746869732E72656E6465726564456C65';
wwv_flow_imp.g_varchar2_table(12879) := '6D656E74735B695D3B746869732E74726169742E756E72656E646572286E292C652E696E6465783D747D656C73657B636F6E737420653D7B696E6465783A742C74656D706C617465446174613A6E7D3B746869732E72656E6465726564456C656D656E74';
wwv_flow_imp.g_varchar2_table(12880) := '732E707573682865297D746869732E74726169742E72656E646572496E64657828742C6E297D73706C69636528652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E7374206F206F6620746869732E72656E6465726564456C656D656E747329';
wwv_flow_imp.g_varchar2_table(12881) := '6F2E696E6465783C653F692E70757368286F293A6F2E696E6465783E3D652B742626692E70757368287B696E6465783A6F2E696E6465782B6E2D742C74656D706C617465446174613A6F2E74656D706C617465446174617D293B746869732E72656E6465';
wwv_flow_imp.g_varchar2_table(12882) := '726564456C656D656E74733D697D72656E646572496E64657865732865297B666F7228636F6E73747B696E6465783A742C74656D706C617465446174613A6E7D6F6620746869732E72656E6465726564456C656D656E747329652E696E6465784F662874';
wwv_flow_imp.g_varchar2_table(12883) := '293E2D312626746869732E74726169742E72656E646572496E64657828742C6E297D646973706F736554656D706C6174652865297B636F6E737420743D746869732E72656E6465726564456C656D656E74732E66696E64496E6465782828743D3E742E74';
wwv_flow_imp.g_varchar2_table(12884) := '656D706C617465446174613D3D3D6529293B743C307C7C746869732E72656E6465726564456C656D656E74732E73706C69636528742C31297D7D636C6173732077497B676574206E616D6528297B72657475726E20746869732E5F74726169747D676574';
wwv_flow_imp.g_varchar2_table(12885) := '2072656E646572657228297B72657475726E206E65772079492874686973297D636F6E7374727563746F722865297B746869732E5F74726169743D652C746869732E696E64657865733D5B5D2C746869732E736F72746564496E64657865733D5B5D2C74';
wwv_flow_imp.g_varchar2_table(12886) := '6869732E5F6F6E4368616E67653D6E65772043742C746869732E6F6E4368616E67653D746869732E5F6F6E4368616E67652E6576656E747D73706C69636528652C742C6E297B636F6E737420693D6E2E6C656E6774682D742C6F3D652B742C733D5B5D3B';
wwv_flow_imp.g_varchar2_table(12887) := '6C657420723D303B666F72283B723C746869732E736F72746564496E64657865732E6C656E6774682626746869732E736F72746564496E64657865735B725D3C653B29732E7075736828746869732E736F72746564496E64657865735B722B2B5D293B66';
wwv_flow_imp.g_varchar2_table(12888) := '6F72286C657420743D303B743C6E2E6C656E6774683B742B2B296E5B745D2626732E7075736828742B65293B666F72283B723C746869732E736F72746564496E64657865732E6C656E6774682626746869732E736F72746564496E64657865735B725D3E';
wwv_flow_imp.g_varchar2_table(12889) := '3D6F3B29732E7075736828746869732E736F72746564496E64657865735B722B2B5D2B69293B746869732E72656E64657265722E73706C69636528652C742C6E2E6C656E677468292C746869732E5F73657428732C73297D72656E646572496E64657828';
wwv_flow_imp.g_varchar2_table(12890) := '652C74297B742E636C6173734C6973742E746F67676C6528746869732E5F74726169742C746869732E636F6E7461696E73286529297D756E72656E6465722865297B652E636C6173734C6973742E72656D6F766528746869732E5F7472616974297D7365';
wwv_flow_imp.g_varchar2_table(12891) := '7428652C74297B72657475726E20746869732E5F73657428652C5B2E2E2E655D2E736F7274285749292C74297D5F73657428652C742C6E297B636F6E737420693D746869732E696E64657865732C6F3D746869732E736F72746564496E64657865733B74';
wwv_flow_imp.g_varchar2_table(12892) := '6869732E696E64657865733D652C746869732E736F72746564496E64657865733D743B636F6E737420733D4849286F2C65293B72657475726E20746869732E72656E64657265722E72656E646572496E64657865732873292C746869732E5F6F6E436861';
wwv_flow_imp.g_varchar2_table(12893) := '6E67652E66697265287B696E64657865733A652C62726F777365724576656E743A6E7D292C697D67657428297B72657475726E20746869732E696E64657865737D636F6E7461696E732865297B72657475726E204F6828746869732E736F72746564496E';
wwv_flow_imp.g_varchar2_table(12894) := '64657865732C652C5749293E3D307D646973706F736528297B6F7428746869732E5F6F6E4368616E6765297D7D5F49285B44455D2C77492E70726F746F747970652C2272656E6465726572222C6E756C6C293B636C61737320434920657874656E647320';
wwv_flow_imp.g_varchar2_table(12895) := '77497B636F6E7374727563746F722865297B7375706572282273656C656374656422292C746869732E7365744172696153656C65637465643D657D72656E646572496E64657828652C74297B73757065722E72656E646572496E64657828652C74292C74';
wwv_flow_imp.g_varchar2_table(12896) := '6869732E7365744172696153656C6563746564262628746869732E636F6E7461696E732865293F742E7365744174747269627574652822617269612D73656C6563746564222C227472756522293A742E7365744174747269627574652822617269612D73';
wwv_flow_imp.g_varchar2_table(12897) := '656C6563746564222C2266616C73652229297D7D636C6173732053497B636F6E7374727563746F7228652C742C6E297B746869732E74726169743D652C746869732E766965773D742C746869732E6964656E7469747950726F76696465723D6E7D73706C';
wwv_flow_imp.g_varchar2_table(12898) := '69636528652C742C6E297B69662821746869732E6964656E7469747950726F76696465722972657475726E20746869732E74726169742E73706C69636528652C742C6E6577204172726179286E2E6C656E677468292E66696C6C28213129293B636F6E73';
wwv_flow_imp.g_varchar2_table(12899) := '7420693D746869732E74726169742E67657428292E6D61702828653D3E746869732E6964656E7469747950726F76696465722E676574496428746869732E766965772E656C656D656E74286529292E746F537472696E67282929293B696628303D3D3D69';
wwv_flow_imp.g_varchar2_table(12900) := '2E6C656E6774682972657475726E20746869732E74726169742E73706C69636528652C742C6E6577204172726179286E2E6C656E677468292E66696C6C28213129293B636F6E7374206F3D6E6577205365742869292C733D6E2E6D61702828653D3E6F2E';
wwv_flow_imp.g_varchar2_table(12901) := '68617328746869732E6964656E7469747950726F76696465722E67657449642865292E746F537472696E6728292929293B746869732E74726169742E73706C69636528652C742C73297D7D66756E6374696F6E2078492865297B72657475726E22494E50';
wwv_flow_imp.g_varchar2_table(12902) := '5554223D3D3D652E7461674E616D657C7C225445585441524541223D3D3D652E7461674E616D657D66756E6374696F6E206B4928652C74297B72657475726E2121652E636C6173734C6973742E636F6E7461696E732874297C7C21652E636C6173734C69';
wwv_flow_imp.g_varchar2_table(12903) := '73742E636F6E7461696E7328226D6F6E61636F2D6C697374222926262121652E706172656E74456C656D656E7426266B4928652E706172656E74456C656D656E742C74297D66756E6374696F6E2045492865297B72657475726E206B4928652C226D6F6E';
wwv_flow_imp.g_varchar2_table(12904) := '61636F2D656469746F7222297D66756E6374696F6E204C492865297B72657475726E206B4928652C226D6F6E61636F2D747265652D737469636B792D726F7722297D66756E6374696F6E2044492865297B72657475726E20652E636C6173734C6973742E';
wwv_flow_imp.g_varchar2_table(12905) := '636F6E7461696E7328226D6F6E61636F2D747265652D737469636B792D636F6E7461696E657222297D66756E6374696F6E2054492865297B72657475726E2121282241223D3D3D652E7461674E616D652626652E636C6173734C6973742E636F6E746169';
wwv_flow_imp.g_varchar2_table(12906) := '6E7328226D6F6E61636F2D627574746F6E22297C7C22444956223D3D3D652E7461674E616D652626652E636C6173734C6973742E636F6E7461696E7328226D6F6E61636F2D627574746F6E2D64726F70646F776E2229297C7C21652E636C6173734C6973';
wwv_flow_imp.g_varchar2_table(12907) := '742E636F6E7461696E7328226D6F6E61636F2D6C697374222926262121652E706172656E74456C656D656E742626544928652E706172656E74456C656D656E74297D636C6173732049497B676574206F6E4B6579446F776E28297B72657475726E207674';
wwv_flow_imp.g_varchar2_table(12908) := '2E636861696E28746869732E646973706F7361626C65732E616464286E6577204B5328746869732E766965772E646F6D4E6F64652C226B6579646F776E2229292E6576656E742C28653D3E652E66696C7465722828653D3E21784928652E746172676574';
wwv_flow_imp.g_varchar2_table(12909) := '2929292E6D61702828653D3E6E6577207165286529292929297D636F6E7374727563746F7228652C742C6E297B746869732E6C6973743D652C746869732E766965773D742C746869732E646973706F7361626C65733D6E65772061742C746869732E6D75';
wwv_flow_imp.g_varchar2_table(12910) := '6C7469706C6553656C656374696F6E446973706F7361626C65733D6E65772061742C746869732E6D756C7469706C6553656C656374696F6E537570706F72743D6E2E6D756C7469706C6553656C656374696F6E537570706F72742C746869732E64697370';
wwv_flow_imp.g_varchar2_table(12911) := '6F7361626C65732E61646428746869732E6F6E4B6579446F776E2828653D3E7B73776974636828652E6B6579436F6465297B6361736520333A72657475726E20746869732E6F6E456E7465722865293B636173652031363A72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(12912) := '6F6E55704172726F772865293B636173652031383A72657475726E20746869732E6F6E446F776E4172726F772865293B636173652031313A72657475726E20746869732E6F6E5061676555704172726F772865293B636173652031323A72657475726E20';
wwv_flow_imp.g_varchar2_table(12913) := '746869732E6F6E50616765446F776E4172726F772865293B6361736520393A72657475726E20746869732E6F6E4573636170652865293B636173652033313A746869732E6D756C7469706C6553656C656374696F6E537570706F7274262628713F652E6D';
wwv_flow_imp.g_varchar2_table(12914) := '6574614B65793A652E6374726C4B6579292626746869732E6F6E4374726C412865297D7D2929297D7570646174654F7074696F6E732865297B766F69642030213D3D652E6D756C7469706C6553656C656374696F6E537570706F7274262628746869732E';
wwv_flow_imp.g_varchar2_table(12915) := '6D756C7469706C6553656C656374696F6E537570706F72743D652E6D756C7469706C6553656C656374696F6E537570706F7274297D6F6E456E7465722865297B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E';
wwv_flow_imp.g_varchar2_table(12916) := '28292C746869732E6C6973742E73657453656C656374696F6E28746869732E6C6973742E676574466F63757328292C652E62726F777365724576656E74297D6F6E55704172726F772865297B652E70726576656E7444656661756C7428292C652E73746F';
wwv_flow_imp.g_varchar2_table(12917) := '7050726F7061676174696F6E28292C746869732E6C6973742E666F63757350726576696F757328312C21312C652E62726F777365724576656E74293B636F6E737420743D746869732E6C6973742E676574466F63757328295B305D3B746869732E6C6973';
wwv_flow_imp.g_varchar2_table(12918) := '742E736574416E63686F722874292C746869732E6C6973742E72657665616C2874292C746869732E766965772E646F6D4E6F64652E666F63757328297D6F6E446F776E4172726F772865297B652E70726576656E7444656661756C7428292C652E73746F';
wwv_flow_imp.g_varchar2_table(12919) := '7050726F7061676174696F6E28292C746869732E6C6973742E666F6375734E65787428312C21312C652E62726F777365724576656E74293B636F6E737420743D746869732E6C6973742E676574466F63757328295B305D3B746869732E6C6973742E7365';
wwv_flow_imp.g_varchar2_table(12920) := '74416E63686F722874292C746869732E6C6973742E72657665616C2874292C746869732E766965772E646F6D4E6F64652E666F63757328297D6F6E5061676555704172726F772865297B652E70726576656E7444656661756C7428292C652E73746F7050';
wwv_flow_imp.g_varchar2_table(12921) := '726F7061676174696F6E28292C746869732E6C6973742E666F63757350726576696F75735061676528652E62726F777365724576656E74293B636F6E737420743D746869732E6C6973742E676574466F63757328295B305D3B746869732E6C6973742E73';
wwv_flow_imp.g_varchar2_table(12922) := '6574416E63686F722874292C746869732E6C6973742E72657665616C2874292C746869732E766965772E646F6D4E6F64652E666F63757328297D6F6E50616765446F776E4172726F772865297B652E70726576656E7444656661756C7428292C652E7374';
wwv_flow_imp.g_varchar2_table(12923) := '6F7050726F7061676174696F6E28292C746869732E6C6973742E666F6375734E6578745061676528652E62726F777365724576656E74293B636F6E737420743D746869732E6C6973742E676574466F63757328295B305D3B746869732E6C6973742E7365';
wwv_flow_imp.g_varchar2_table(12924) := '74416E63686F722874292C746869732E6C6973742E72657665616C2874292C746869732E766965772E646F6D4E6F64652E666F63757328297D6F6E4374726C412865297B652E70726576656E7444656661756C7428292C652E73746F7050726F70616761';
wwv_flow_imp.g_varchar2_table(12925) := '74696F6E28292C746869732E6C6973742E73657453656C656374696F6E28556828746869732E6C6973742E6C656E677468292C652E62726F777365724576656E74292C746869732E6C6973742E736574416E63686F7228766F69642030292C746869732E';
wwv_flow_imp.g_varchar2_table(12926) := '766965772E646F6D4E6F64652E666F63757328297D6F6E4573636170652865297B746869732E6C6973742E67657453656C656374696F6E28292E6C656E677468262628652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174';
wwv_flow_imp.g_varchar2_table(12927) := '696F6E28292C746869732E6C6973742E73657453656C656374696F6E285B5D2C652E62726F777365724576656E74292C746869732E6C6973742E736574416E63686F7228766F69642030292C746869732E766965772E646F6D4E6F64652E666F63757328';
wwv_flow_imp.g_varchar2_table(12928) := '29297D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528292C746869732E6D756C7469706C6553656C656374696F6E446973706F7361626C65732E646973706F736528297D7D5F49285B44455D2C49492E70726F74';
wwv_flow_imp.g_varchar2_table(12929) := '6F747970652C226F6E4B6579446F776E222C6E756C6C292C66756E6374696F6E2865297B655B652E4175746F6D617469633D305D3D224175746F6D61746963222C655B652E547269676765723D315D3D2254726967676572227D2876497C7C2876493D7B';
wwv_flow_imp.g_varchar2_table(12930) := '7D29292C66756E6374696F6E2865297B655B652E49646C653D305D3D2249646C65222C655B652E547970696E673D315D3D22547970696E67227D2862497C7C2862493D7B7D29293B636F6E7374204D493D6E657720636C6173737B6D6967687450726F64';
wwv_flow_imp.g_varchar2_table(12931) := '7563655072696E7461626C654368617261637465722865297B72657475726E2128652E6374726C4B65797C7C652E6D6574614B65797C7C652E616C744B657929262628652E6B6579436F64653E3D33312626652E6B6579436F64653C3D35367C7C652E6B';
wwv_flow_imp.g_varchar2_table(12932) := '6579436F64653E3D32312626652E6B6579436F64653C3D33307C7C652E6B6579436F64653E3D39382626652E6B6579436F64653C3D3130377C7C652E6B6579436F64653E3D38352626652E6B6579436F64653C3D3935297D7D3B636C6173732041497B63';
wwv_flow_imp.g_varchar2_table(12933) := '6F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6C6973743D652C746869732E766965773D742C746869732E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723D6E2C746869732E6B6579626F6172644E61';
wwv_flow_imp.g_varchar2_table(12934) := '7669676174696F6E4576656E7446696C7465723D692C746869732E64656C65676174653D6F2C746869732E656E61626C65643D21312C746869732E73746174653D62492E49646C652C746869732E6D6F64653D76492E4175746F6D617469632C74686973';
wwv_flow_imp.g_varchar2_table(12935) := '2E7472696767657265643D21312C746869732E70726576696F75736C79466F63757365643D2D312C746869732E656E61626C6564446973706F7361626C65733D6E65772061742C746869732E646973706F7361626C65733D6E65772061742C746869732E';
wwv_flow_imp.g_varchar2_table(12936) := '7570646174654F7074696F6E7328652E6F7074696F6E73297D7570646174654F7074696F6E732865297B76617220742C6E3B6E756C6C3D3D3D28743D652E747970654E617669676174696F6E456E61626C6564297C7C766F696420303D3D3D747C7C743F';
wwv_flow_imp.g_varchar2_table(12937) := '746869732E656E61626C6528293A746869732E64697361626C6528292C746869732E6D6F64653D6E756C6C213D3D286E3D652E747970654E617669676174696F6E4D6F6465292626766F69642030213D3D6E3F6E3A76492E4175746F6D617469637D656E';
wwv_flow_imp.g_varchar2_table(12938) := '61626C6528297B696628746869732E656E61626C65642972657475726E3B6C657420653D21313B636F6E737420743D76742E636861696E28746869732E656E61626C6564446973706F7361626C65732E616464286E6577204B5328746869732E76696577';
wwv_flow_imp.g_varchar2_table(12939) := '2E646F6D4E6F64652C226B6579646F776E2229292E6576656E742C28743D3E742E66696C7465722828653D3E21784928652E7461726765742929292E66696C746572282828293D3E746869732E6D6F64653D3D3D76492E4175746F6D617469637C7C7468';
wwv_flow_imp.g_varchar2_table(12940) := '69732E74726967676572656429292E6D61702828653D3E6E657720716528652929292E66696C7465722828743D3E657C7C746869732E6B6579626F6172644E617669676174696F6E4576656E7446696C74657228742929292E66696C7465722828653D3E';
wwv_flow_imp.g_varchar2_table(12941) := '746869732E64656C65676174652E6D6967687450726F647563655072696E7461626C6543686172616374657228652929292E666F72456163682828653D3E637228652C21302929292E6D61702828653D3E652E62726F777365724576656E742E6B657929';
wwv_flow_imp.g_varchar2_table(12942) := '2929292C6E3D76742E6465626F756E636528742C2828293D3E6E756C6C292C3830302C766F696420302C766F696420302C766F696420302C746869732E656E61626C6564446973706F7361626C6573293B76742E7265647563652876742E616E7928742C';
wwv_flow_imp.g_varchar2_table(12943) := '6E292C2828652C74293D3E6E756C6C3D3D3D743F6E756C6C3A28657C7C2222292B74292C766F696420302C746869732E656E61626C6564446973706F7361626C65732928746869732E6F6E496E7075742C746869732C746869732E656E61626C65644469';
wwv_flow_imp.g_varchar2_table(12944) := '73706F7361626C6573292C6E28746869732E6F6E436C6561722C746869732C746869732E656E61626C6564446973706F7361626C6573292C74282828293D3E653D2130292C766F696420302C746869732E656E61626C6564446973706F7361626C657329';
wwv_flow_imp.g_varchar2_table(12945) := '2C6E282828293D3E653D2131292C766F696420302C746869732E656E61626C6564446973706F7361626C6573292C746869732E656E61626C65643D21302C746869732E7472696767657265643D21317D64697361626C6528297B746869732E656E61626C';
wwv_flow_imp.g_varchar2_table(12946) := '6564262628746869732E656E61626C6564446973706F7361626C65732E636C65617228292C746869732E656E61626C65643D21312C746869732E7472696767657265643D2131297D6F6E436C65617228297B76617220653B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(12947) := '2E6C6973742E676574466F63757328293B696628742E6C656E6774683E302626745B305D3D3D3D746869732E70726576696F75736C79466F6375736564297B636F6E7374206E3D6E756C6C3D3D3D28653D746869732E6C6973742E6F7074696F6E732E61';
wwv_flow_imp.g_varchar2_table(12948) := '63636573736962696C69747950726F7669646572297C7C766F696420303D3D3D653F766F696420303A652E676574417269614C6162656C28746869732E6C6973742E656C656D656E7428745B305D29293B22737472696E67223D3D747970656F66206E3F';
wwv_flow_imp.g_varchar2_table(12949) := '5872286E293A6E26265872286E2E6765742829297D746869732E70726576696F75736C79466F63757365643D2D317D6F6E496E7075742865297B69662821652972657475726E20746869732E73746174653D62492E49646C652C766F696428746869732E';
wwv_flow_imp.g_varchar2_table(12950) := '7472696767657265643D2131293B636F6E737420743D746869732E6C6973742E676574466F63757328292C6E3D742E6C656E6774683E303F745B305D3A302C693D746869732E73746174653D3D3D62492E49646C653F313A303B746869732E7374617465';
wwv_flow_imp.g_varchar2_table(12951) := '3D62492E547970696E673B666F72286C657420743D303B743C746869732E6C6973742E6C656E6774683B742B2B297B636F6E7374206F3D286E2B742B692925746869732E6C6973742E6C656E6774682C733D746869732E6B6579626F6172644E61766967';
wwv_flow_imp.g_varchar2_table(12952) := '6174696F6E4C6162656C50726F76696465722E6765744B6579626F6172644E617669676174696F6E4C6162656C28746869732E766965772E656C656D656E74286F29292C723D732626732E746F537472696E6728293B696628746869732E6C6973742E6F';
wwv_flow_imp.g_varchar2_table(12953) := '7074696F6E732E747970654E617669676174696F6E456E61626C6564297B696628766F69642030213D3D72297B696628626128652C72292972657475726E20746869732E70726576696F75736C79466F63757365643D6E2C746869732E6C6973742E7365';
wwv_flow_imp.g_varchar2_table(12954) := '74466F637573285B6F5D292C766F696420746869732E6C6973742E72657665616C286F293B636F6E737420743D6A6128652C72293B696628742626745B305D2E656E642D745B305D2E73746172743E312626313D3D3D742E6C656E677468297265747572';
wwv_flow_imp.g_varchar2_table(12955) := '6E20746869732E70726576696F75736C79466F63757365643D6E2C746869732E6C6973742E736574466F637573285B6F5D292C766F696420746869732E6C6973742E72657665616C286F297D7D656C736520696628766F696420303D3D3D727C7C626128';
wwv_flow_imp.g_varchar2_table(12956) := '652C72292972657475726E20746869732E70726576696F75736C79466F63757365643D6E2C746869732E6C6973742E736574466F637573285B6F5D292C766F696420746869732E6C6973742E72657665616C286F297D7D646973706F736528297B746869';
wwv_flow_imp.g_varchar2_table(12957) := '732E64697361626C6528292C746869732E656E61626C6564446973706F7361626C65732E646973706F736528292C746869732E646973706F7361626C65732E646973706F736528297D7D636C617373204E497B636F6E7374727563746F7228652C74297B';
wwv_flow_imp.g_varchar2_table(12958) := '746869732E6C6973743D652C746869732E766965773D742C746869732E646973706F7361626C65733D6E65772061743B636F6E7374206E3D76742E636861696E28746869732E646973706F7361626C65732E616464286E6577204B5328742E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(12959) := '64652C226B6579646F776E2229292E6576656E742C28653D3E652E66696C7465722828653D3E21784928652E7461726765742929292E6D61702828653D3E6E6577207165286529292929292C693D76742E636861696E286E2C28653D3E652E66696C7465';
wwv_flow_imp.g_varchar2_table(12960) := '722828653D3E212832213D3D652E6B6579436F64657C7C652E6374726C4B65797C7C652E6D6574614B65797C7C652E73686966744B65797C7C652E616C744B657929292929293B6928746869732E6F6E5461622C746869732C746869732E646973706F73';
wwv_flow_imp.g_varchar2_table(12961) := '61626C6573297D6F6E5461622865297B696628652E746172676574213D3D746869732E766965772E646F6D4E6F64652972657475726E3B636F6E737420743D746869732E6C6973742E676574466F63757328293B696628303D3D3D742E6C656E67746829';
wwv_flow_imp.g_varchar2_table(12962) := '72657475726E3B636F6E7374206E3D746869732E766965772E646F6D456C656D656E7428745B305D293B696628216E2972657475726E3B636F6E737420693D6E2E717565727953656C6563746F7228225B746162496E6465785D22293B69662821286926';
wwv_flow_imp.g_varchar2_table(12963) := '266920696E7374616E63656F662048544D4C456C656D656E7426262D31213D3D692E746162496E646578292972657475726E3B636F6E7374206F3D72732869292E676574436F6D70757465645374796C652869293B2268696464656E22213D3D6F2E7669';
wwv_flow_imp.g_varchar2_table(12964) := '736962696C6974792626226E6F6E6522213D3D6F2E646973706C6179262628652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C692E666F6375732829297D646973706F736528297B746869732E64697370';
wwv_flow_imp.g_varchar2_table(12965) := '6F7361626C65732E646973706F736528297D7D66756E6374696F6E2050492865297B72657475726E20713F652E62726F777365724576656E742E6D6574614B65793A652E62726F777365724576656E742E6374726C4B65797D66756E6374696F6E204F49';
wwv_flow_imp.g_varchar2_table(12966) := '2865297B72657475726E20652E62726F777365724576656E742E73686966744B65797D636F6E73742052493D7B697353656C656374696F6E53696E676C654368616E67654576656E743A50492C697353656C656374696F6E52616E67654368616E676545';
wwv_flow_imp.g_varchar2_table(12967) := '76656E743A4F497D3B636C6173732046497B636F6E7374727563746F722865297B746869732E6C6973743D652C746869732E646973706F7361626C65733D6E65772061742C746869732E5F6F6E506F696E7465723D6E65772043742C746869732E6F6E50';
wwv_flow_imp.g_varchar2_table(12968) := '6F696E7465723D746869732E5F6F6E506F696E7465722E6576656E742C2131213D3D652E6F7074696F6E732E6D756C7469706C6553656C656374696F6E537570706F7274262628746869732E6D756C7469706C6553656C656374696F6E436F6E74726F6C';
wwv_flow_imp.g_varchar2_table(12969) := '6C65723D746869732E6C6973742E6F7074696F6E732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65727C7C5249292C746869732E6D6F757365537570706F72743D766F696420303D3D3D652E6F7074696F6E732E6D6F757365537570';
wwv_flow_imp.g_varchar2_table(12970) := '706F72747C7C2121652E6F7074696F6E732E6D6F757365537570706F72742C746869732E6D6F757365537570706F7274262628652E6F6E4D6F757365446F776E28746869732E6F6E4D6F757365446F776E2C746869732C746869732E646973706F736162';
wwv_flow_imp.g_varchar2_table(12971) := '6C6573292C652E6F6E436F6E746578744D656E7528746869732E6F6E436F6E746578744D656E752C746869732C746869732E646973706F7361626C6573292C652E6F6E4D6F75736544626C436C69636B28746869732E6F6E446F75626C65436C69636B2C';
wwv_flow_imp.g_varchar2_table(12972) := '746869732C746869732E646973706F7361626C6573292C652E6F6E546F756368537461727428746869732E6F6E4D6F757365446F776E2C746869732C746869732E646973706F7361626C6573292C746869732E646973706F7361626C65732E6164642849';
wwv_flow_imp.g_varchar2_table(12973) := '452E61646454617267657428652E67657448544D4C456C656D656E7428292929292C76742E616E7928652E6F6E4D6F757365436C69636B2C652E6F6E4D6F7573654D6964646C65436C69636B2C652E6F6E5461702928746869732E6F6E56696577506F69';
wwv_flow_imp.g_varchar2_table(12974) := '6E7465722C746869732C746869732E646973706F7361626C6573297D7570646174654F7074696F6E732865297B766F69642030213D3D652E6D756C7469706C6553656C656374696F6E537570706F7274262628746869732E6D756C7469706C6553656C65';
wwv_flow_imp.g_varchar2_table(12975) := '6374696F6E436F6E74726F6C6C65723D766F696420302C652E6D756C7469706C6553656C656374696F6E537570706F7274262628746869732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65723D746869732E6C6973742E6F7074696F';
wwv_flow_imp.g_varchar2_table(12976) := '6E732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65727C7C524929297D697353656C656374696F6E53696E676C654368616E67654576656E742865297B72657475726E2121746869732E6D756C7469706C6553656C656374696F6E43';
wwv_flow_imp.g_varchar2_table(12977) := '6F6E74726F6C6C65722626746869732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722E697353656C656374696F6E53696E676C654368616E67654576656E742865297D697353656C656374696F6E52616E67654368616E67654576';
wwv_flow_imp.g_varchar2_table(12978) := '656E742865297B72657475726E2121746869732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722626746869732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722E697353656C656374696F6E52616E67654368';
wwv_flow_imp.g_varchar2_table(12979) := '616E67654576656E742865297D697353656C656374696F6E4368616E67654576656E742865297B72657475726E20746869732E697353656C656374696F6E53696E676C654368616E67654576656E742865297C7C746869732E697353656C656374696F6E';
wwv_flow_imp.g_varchar2_table(12980) := '52616E67654368616E67654576656E742865297D6F6E4D6F757365446F776E2865297B454928652E62726F777365724576656E742E746172676574297C7C6A732829213D3D652E62726F777365724576656E742E7461726765742626746869732E6C6973';
wwv_flow_imp.g_varchar2_table(12981) := '742E646F6D466F63757328297D6F6E436F6E746578744D656E752865297B696628784928652E62726F777365724576656E742E746172676574297C7C454928652E62726F777365724576656E742E746172676574292972657475726E3B636F6E73742074';
wwv_flow_imp.g_varchar2_table(12982) := '3D766F696420303D3D3D652E696E6465783F5B5D3A5B652E696E6465785D3B746869732E6C6973742E736574466F63757328742C652E62726F777365724576656E74297D6F6E56696577506F696E7465722865297B69662821746869732E6D6F75736553';
wwv_flow_imp.g_varchar2_table(12983) := '7570706F72742972657475726E3B696628784928652E62726F777365724576656E742E746172676574297C7C454928652E62726F777365724576656E742E746172676574292972657475726E3B696628652E62726F777365724576656E742E697348616E';
wwv_flow_imp.g_varchar2_table(12984) := '646C656442794C6973742972657475726E3B652E62726F777365724576656E742E697348616E646C656442794C6973743D21303B636F6E737420743D652E696E6465783B72657475726E20766F696420303D3D3D743F28746869732E6C6973742E736574';
wwv_flow_imp.g_varchar2_table(12985) := '466F637573285B5D2C652E62726F777365724576656E74292C746869732E6C6973742E73657453656C656374696F6E285B5D2C652E62726F777365724576656E74292C766F696420746869732E6C6973742E736574416E63686F7228766F696420302929';
wwv_flow_imp.g_varchar2_table(12986) := '3A746869732E697353656C656374696F6E4368616E67654576656E742865293F746869732E6368616E676553656C656374696F6E2865293A28746869732E6C6973742E736574466F637573285B745D2C652E62726F777365724576656E74292C74686973';
wwv_flow_imp.g_varchar2_table(12987) := '2E6C6973742E736574416E63686F722874292C7372286E3D652E62726F777365724576656E74292626323D3D3D6E2E627574746F6E7C7C746869732E6C6973742E73657453656C656374696F6E285B745D2C652E62726F777365724576656E74292C766F';
wwv_flow_imp.g_varchar2_table(12988) := '696420746869732E5F6F6E506F696E7465722E66697265286529293B766172206E7D6F6E446F75626C65436C69636B2865297B696628784928652E62726F777365724576656E742E746172676574297C7C454928652E62726F777365724576656E742E74';
wwv_flow_imp.g_varchar2_table(12989) := '6172676574292972657475726E3B696628746869732E697353656C656374696F6E4368616E67654576656E742865292972657475726E3B696628652E62726F777365724576656E742E697348616E646C656442794C6973742972657475726E3B652E6272';
wwv_flow_imp.g_varchar2_table(12990) := '6F777365724576656E742E697348616E646C656442794C6973743D21303B636F6E737420743D746869732E6C6973742E676574466F63757328293B746869732E6C6973742E73657453656C656374696F6E28742C652E62726F777365724576656E74297D';
wwv_flow_imp.g_varchar2_table(12991) := '6368616E676553656C656374696F6E2865297B636F6E737420743D652E696E6465783B6C6574206E3D746869732E6C6973742E676574416E63686F7228293B696628746869732E697353656C656374696F6E52616E67654368616E67654576656E742865';
wwv_flow_imp.g_varchar2_table(12992) := '29297B696628766F696420303D3D3D6E297B636F6E737420653D746869732E6C6973742E676574466F63757328295B305D3B6E3D6E756C6C213D653F653A742C746869732E6C6973742E736574416E63686F72286E297D636F6E737420693D5568284D61';
wwv_flow_imp.g_varchar2_table(12993) := '74682E6D696E286E2C74292C4D6174682E6D6178286E2C74292B31292C6F3D746869732E6C6973742E67657453656C656374696F6E28292C733D66756E6374696F6E28652C74297B636F6E7374206E3D652E696E6465784F662874293B6966282D313D3D';
wwv_flow_imp.g_varchar2_table(12994) := '3D6E2972657475726E5B5D3B636F6E737420693D5B5D3B6C6574206F3D6E2D313B666F72283B6F3E3D302626655B6F5D3D3D3D742D286E2D6F293B29692E7075736828655B6F2D2D5D293B666F7228692E7265766572736528292C6F3D6E3B6F3C652E6C';
wwv_flow_imp.g_varchar2_table(12995) := '656E6774682626655B6F5D3D3D3D742B286F2D6E293B29692E7075736828655B6F2B2B5D293B72657475726E20697D284849286F2C5B6E5D292C6E293B696628303D3D3D732E6C656E6774682972657475726E3B636F6E737420723D484928692C66756E';
wwv_flow_imp.g_varchar2_table(12996) := '6374696F6E28652C74297B636F6E7374206E3D5B5D3B6C657420693D302C6F3D303B666F72283B693C652E6C656E6774687C7C6F3C742E6C656E6774683B29696628693E3D652E6C656E677468296E2E7075736828745B6F2B2B5D293B656C7365206966';
wwv_flow_imp.g_varchar2_table(12997) := '286F3E3D742E6C656E677468296E2E7075736828655B692B2B5D293B656C73657B696628655B695D3D3D3D745B6F5D297B692B2B2C6F2B2B3B636F6E74696E75657D655B695D3C745B6F5D3F6E2E7075736828655B692B2B5D293A6F2B2B7D7265747572';
wwv_flow_imp.g_varchar2_table(12998) := '6E206E7D286F2C7329293B746869732E6C6973742E73657453656C656374696F6E28722C652E62726F777365724576656E74292C746869732E6C6973742E736574466F637573285B745D2C652E62726F777365724576656E74297D656C73652069662874';
wwv_flow_imp.g_varchar2_table(12999) := '6869732E697353656C656374696F6E53696E676C654368616E67654576656E74286529297B636F6E7374206E3D746869732E6C6973742E67657453656C656374696F6E28292C693D6E2E66696C7465722828653D3E65213D3D7429293B746869732E6C69';
wwv_flow_imp.g_varchar2_table(13000) := '73742E736574466F637573285B745D292C746869732E6C6973742E736574416E63686F722874292C6E2E6C656E6774683D3D3D692E6C656E6774683F746869732E6C6973742E73657453656C656374696F6E285B2E2E2E692C745D2C652E62726F777365';
wwv_flow_imp.g_varchar2_table(13001) := '724576656E74293A746869732E6C6973742E73657453656C656374696F6E28692C652E62726F777365724576656E74297D7D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528297D7D636C6173732042497B636F6E';
wwv_flow_imp.g_varchar2_table(13002) := '7374727563746F7228652C74297B746869732E7374796C65456C656D656E743D652C746869732E73656C6563746F725375666669783D747D7374796C652865297B76617220742C6E3B636F6E737420693D746869732E73656C6563746F72537566666978';
wwv_flow_imp.g_varchar2_table(13003) := '2626602E247B746869732E73656C6563746F725375666669787D602C6F3D5B5D3B652E6C6973744261636B67726F756E6426266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F7773207B206261636B';
wwv_flow_imp.g_varchar2_table(13004) := '67726F756E643A20247B652E6C6973744261636B67726F756E647D3B207D60292C652E6C697374466F6375734261636B67726F756E642626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C697374';
wwv_flow_imp.g_varchar2_table(13005) := '2D726F772E666F6375736564207B206261636B67726F756E642D636F6C6F723A20247B652E6C697374466F6375734261636B67726F756E647D3B207D60292C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(13006) := '6F2D6C6973742D726F772E666F63757365643A686F766572207B206261636B67726F756E642D636F6C6F723A20247B652E6C697374466F6375734261636B67726F756E647D3B207D6029292C652E6C697374466F637573466F726567726F756E6426266F';
wwv_flow_imp.g_varchar2_table(13007) := '2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B20636F6C6F723A20247B652E6C697374466F637573466F726567726F756E647D3B207D60292C652E6C697374';
wwv_flow_imp.g_varchar2_table(13008) := '41637469766553656C656374696F6E4261636B67726F756E642626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E73656C6563746564207B206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(13009) := '6C6F723A20247B652E6C69737441637469766553656C656374696F6E4261636B67726F756E647D3B207D60292C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E73656C65637465';
wwv_flow_imp.g_varchar2_table(13010) := '643A686F766572207B206261636B67726F756E642D636F6C6F723A20247B652E6C69737441637469766553656C656374696F6E4261636B67726F756E647D3B207D6029292C652E6C69737441637469766553656C656374696F6E466F726567726F756E64';
wwv_flow_imp.g_varchar2_table(13011) := '26266F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E73656C6563746564207B20636F6C6F723A20247B652E6C69737441637469766553656C656374696F6E466F726567726F756E';
wwv_flow_imp.g_varchar2_table(13012) := '647D3B207D60292C652E6C69737441637469766553656C656374696F6E49636F6E466F726567726F756E6426266F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E73656C65637465';
wwv_flow_imp.g_varchar2_table(13013) := '64202E636F6469636F6E207B20636F6C6F723A20247B652E6C69737441637469766553656C656374696F6E49636F6E466F726567726F756E647D3B207D60292C652E6C697374466F637573416E6453656C656374696F6E4261636B67726F756E6426266F';
wwv_flow_imp.g_varchar2_table(13014) := '2E7075736828605C6E5C745C745C745C742E6D6F6E61636F2D647261672D696D6167652C5C6E5C745C745C745C742E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E73656C65637465642E666F637573';
wwv_flow_imp.g_varchar2_table(13015) := '6564207B206261636B67726F756E642D636F6C6F723A20247B652E6C697374466F637573416E6453656C656374696F6E4261636B67726F756E647D3B207D5C6E5C745C745C7460292C652E6C697374466F637573416E6453656C656374696F6E466F7265';
wwv_flow_imp.g_varchar2_table(13016) := '67726F756E6426266F2E7075736828605C6E5C745C745C745C742E6D6F6E61636F2D647261672D696D6167652C5C6E5C745C745C745C742E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E73656C6563';
wwv_flow_imp.g_varchar2_table(13017) := '7465642E666F6375736564207B20636F6C6F723A20247B652E6C697374466F637573416E6453656C656374696F6E466F726567726F756E647D3B207D5C6E5C745C745C7460292C652E6C697374496E616374697665466F637573466F726567726F756E64';
wwv_flow_imp.g_varchar2_table(13018) := '2626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B20636F6C6F723A2020247B652E6C697374496E616374697665466F637573466F726567726F756E647D3B207D6029';
wwv_flow_imp.g_varchar2_table(13019) := '2C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E666F63757365643A686F766572207B20636F6C6F723A2020247B652E6C697374496E616374697665466F637573466F726567726F756E647D3B';
wwv_flow_imp.g_varchar2_table(13020) := '207D6029292C652E6C697374496E61637469766553656C656374696F6E49636F6E466F726567726F756E6426266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E636F6469';
wwv_flow_imp.g_varchar2_table(13021) := '636F6E207B20636F6C6F723A2020247B652E6C697374496E61637469766553656C656374696F6E49636F6E466F726567726F756E647D3B207D60292C652E6C697374496E616374697665466F6375734261636B67726F756E642626286F2E707573682860';
wwv_flow_imp.g_varchar2_table(13022) := '2E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206261636B67726F756E642D636F6C6F723A2020247B652E6C697374496E616374697665466F6375734261636B67726F756E647D3B207D6029';
wwv_flow_imp.g_varchar2_table(13023) := '2C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E666F63757365643A686F766572207B206261636B67726F756E642D636F6C6F723A2020247B652E6C697374496E616374697665466F63757342';
wwv_flow_imp.g_varchar2_table(13024) := '61636B67726F756E647D3B207D6029292C652E6C697374496E61637469766553656C656374696F6E4261636B67726F756E642626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E73656C6563';
wwv_flow_imp.g_varchar2_table(13025) := '746564207B206261636B67726F756E642D636F6C6F723A2020247B652E6C697374496E61637469766553656C656374696F6E4261636B67726F756E647D3B207D60292C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(13026) := '6C6973742D726F772E73656C65637465643A686F766572207B206261636B67726F756E642D636F6C6F723A2020247B652E6C697374496E61637469766553656C656374696F6E4261636B67726F756E647D3B207D6029292C652E6C697374496E61637469';
wwv_flow_imp.g_varchar2_table(13027) := '766553656C656374696F6E466F726567726F756E6426266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E73656C6563746564207B20636F6C6F723A20247B652E6C697374496E61637469766553';
wwv_flow_imp.g_varchar2_table(13028) := '656C656374696F6E466F726567726F756E647D3B207D60292C652E6C697374486F7665724261636B67726F756E6426266F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A6E6F74282E64726F702D746172676574293A6E6F74282E64726167';
wwv_flow_imp.g_varchar2_table(13029) := '67696E6729202E6D6F6E61636F2D6C6973742D726F773A686F7665723A6E6F74282E73656C6563746564293A6E6F74282E666F637573656429207B206261636B67726F756E642D636F6C6F723A20247B652E6C697374486F7665724261636B67726F756E';
wwv_flow_imp.g_varchar2_table(13030) := '647D3B207D60292C652E6C697374486F766572466F726567726F756E6426266F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A6E6F74282E64726F702D746172676574293A6E6F74282E6472616767696E6729202E6D6F6E61636F2D6C6973';
wwv_flow_imp.g_varchar2_table(13031) := '742D726F773A686F7665723A6E6F74282E73656C6563746564293A6E6F74282E666F637573656429207B20636F6C6F723A2020247B652E6C697374486F766572466F726567726F756E647D3B207D60293B636F6E737420733D6B7228652E6C697374466F';
wwv_flow_imp.g_varchar2_table(13032) := '637573416E6453656C656374696F6E4F75746C696E652C6B7228652E6C69737453656C656374696F6E4F75746C696E652C6E756C6C213D3D28743D652E6C697374466F6375734F75746C696E65292626766F69642030213D3D743F743A222229293B7326';
wwv_flow_imp.g_varchar2_table(13033) := '266F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E666F63757365642E73656C6563746564207B206F75746C696E653A2031707820736F6C696420247B737D3B206F75746C696E65';
wwv_flow_imp.g_varchar2_table(13034) := '2D6F66667365743A202D3170783B7D60292C652E6C697374466F6375734F75746C696E6526266F2E7075736828605C6E5C745C745C745C742E6D6F6E61636F2D647261672D696D6167652C5C6E5C745C745C745C742E6D6F6E61636F2D6C697374247B69';
wwv_flow_imp.g_varchar2_table(13035) := '7D3A666F637573202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206F75746C696E653A2031707820736F6C696420247B652E6C697374466F6375734F75746C696E657D3B206F75746C696E652D6F66667365743A202D3170783B207D';
wwv_flow_imp.g_varchar2_table(13036) := '5C6E5C745C745C745C742E6D6F6E61636F2D776F726B62656E63682E636F6E746578742D6D656E752D76697369626C65202E6D6F6E61636F2D6C697374247B697D2E6C6173742D666F6375736564202E6D6F6E61636F2D6C6973742D726F772E666F6375';
wwv_flow_imp.g_varchar2_table(13037) := '736564207B206F75746C696E653A2031707820736F6C696420247B652E6C697374466F6375734F75746C696E657D3B206F75746C696E652D6F66667365743A202D3170783B207D5C6E5C745C745C7460293B636F6E737420723D6B7228652E6C69737453';
wwv_flow_imp.g_varchar2_table(13038) := '656C656374696F6E4F75746C696E652C6E756C6C213D3D286E3D652E6C697374496E616374697665466F6375734F75746C696E65292626766F69642030213D3D6E3F6E3A2222293B7226266F2E7075736828602E6D6F6E61636F2D6C697374247B697D20';
wwv_flow_imp.g_varchar2_table(13039) := '2E6D6F6E61636F2D6C6973742D726F772E666F63757365642E73656C6563746564207B206F75746C696E653A2031707820646F7474656420247B727D3B206F75746C696E652D6F66667365743A202D3170783B207D60292C652E6C69737453656C656374';
wwv_flow_imp.g_varchar2_table(13040) := '696F6E4F75746C696E6526266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E73656C6563746564207B206F75746C696E653A2031707820646F7474656420247B652E6C69737453656C65637469';
wwv_flow_imp.g_varchar2_table(13041) := '6F6E4F75746C696E657D3B206F75746C696E652D6F66667365743A202D3170783B207D60292C652E6C697374496E616374697665466F6375734F75746C696E6526266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C';
wwv_flow_imp.g_varchar2_table(13042) := '6973742D726F772E666F6375736564207B206F75746C696E653A2031707820646F7474656420247B652E6C697374496E616374697665466F6375734F75746C696E657D3B206F75746C696E652D6F66667365743A202D3170783B207D60292C652E6C6973';
wwv_flow_imp.g_varchar2_table(13043) := '74486F7665724F75746C696E6526266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F773A686F766572207B206F75746C696E653A203170782064617368656420247B652E6C697374486F7665724F75';
wwv_flow_imp.g_varchar2_table(13044) := '746C696E657D3B206F75746C696E652D6F66667365743A202D3170783B207D60292C652E6C69737444726F704F7665724261636B67726F756E6426266F2E7075736828605C6E5C745C745C745C742E6D6F6E61636F2D6C697374247B697D2E64726F702D';
wwv_flow_imp.g_varchar2_table(13045) := '7461726765742C5C6E5C745C745C745C742E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F77732E64726F702D7461726765742C5C6E5C745C745C745C742E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C';
wwv_flow_imp.g_varchar2_table(13046) := '6973742D726F772E64726F702D746172676574207B206261636B67726F756E642D636F6C6F723A20247B652E6C69737444726F704F7665724261636B67726F756E647D2021696D706F7274616E743B20636F6C6F723A20696E68657269742021696D706F';
wwv_flow_imp.g_varchar2_table(13047) := '7274616E743B207D5C6E5C745C745C7460292C652E6C69737444726F704265747765656E4261636B67726F756E642626286F2E7075736828605C6E5C745C745C742E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F77732E';
wwv_flow_imp.g_varchar2_table(13048) := '64726F702D7461726765742D6265666F7265202E6D6F6E61636F2D6C6973742D726F773A66697273742D6368696C643A3A6265666F72652C5C6E5C745C745C742E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E6472';
wwv_flow_imp.g_varchar2_table(13049) := '6F702D7461726765742D6265666F72653A3A6265666F7265207B5C6E5C745C745C745C74636F6E74656E743A2022223B20706F736974696F6E3A206162736F6C7574653B20746F703A203070783B206C6566743A203070783B2077696474683A20313030';
wwv_flow_imp.g_varchar2_table(13050) := '253B206865696768743A203170783B5C6E5C745C745C745C746261636B67726F756E642D636F6C6F723A20247B652E6C69737444726F704265747765656E4261636B67726F756E647D3B5C6E5C745C745C747D60292C6F2E7075736828605C6E5C745C74';
wwv_flow_imp.g_varchar2_table(13051) := '5C742E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F77732E64726F702D7461726765742D6166746572202E6D6F6E61636F2D6C6973742D726F773A6C6173742D6368696C643A3A61667465722C5C6E5C745C745C742E6D';
wwv_flow_imp.g_varchar2_table(13052) := '6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D6C6973742D726F772E64726F702D7461726765742D61667465723A3A6166746572207B5C6E5C745C745C745C74636F6E74656E743A2022223B20706F736974696F6E3A206162736F6C7574653B';
wwv_flow_imp.g_varchar2_table(13053) := '20626F74746F6D3A203070783B206C6566743A203070783B2077696474683A20313030253B206865696768743A203170783B5C6E5C745C745C745C746261636B67726F756E642D636F6C6F723A20247B652E6C69737444726F704265747765656E426163';
wwv_flow_imp.g_varchar2_table(13054) := '6B67726F756E647D3B5C6E5C745C745C747D6029292C652E7461626C65436F6C756D6E73426F7264657226266F2E7075736828605C6E5C745C745C745C742E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D73706C69742D76696577322C5C6E';
wwv_flow_imp.g_varchar2_table(13055) := '5C745C745C745C742E6D6F6E61636F2D7461626C65203E202E6D6F6E61636F2D73706C69742D7669657732202E6D6F6E61636F2D736173682E766572746963616C3A3A6265666F72652C5C6E5C745C745C745C742E6D6F6E61636F2D776F726B62656E63';
wwv_flow_imp.g_varchar2_table(13056) := '683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D7461626C653A686F766572203E202E6D6F6E61636F2D73706C69742D76696577322C5C6E5C745C745C745C742E6D6F6E61636F2D776F726B62656E63683A6E6F74282E726564';
wwv_flow_imp.g_varchar2_table(13057) := '7563652D6D6F74696F6E29202E6D6F6E61636F2D7461626C653A686F766572203E202E6D6F6E61636F2D73706C69742D7669657732202E6D6F6E61636F2D736173682E766572746963616C3A3A6265666F7265207B5C6E5C745C745C745C745C74626F72';
wwv_flow_imp.g_varchar2_table(13058) := '6465722D636F6C6F723A20247B652E7461626C65436F6C756D6E73426F726465727D3B5C6E5C745C745C745C747D5C6E5C6E5C745C745C745C742E6D6F6E61636F2D776F726B62656E63683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E';
wwv_flow_imp.g_varchar2_table(13059) := '61636F2D7461626C65203E202E6D6F6E61636F2D73706C69742D76696577322C5C6E5C745C745C745C742E6D6F6E61636F2D776F726B62656E63683A6E6F74282E7265647563652D6D6F74696F6E29202E6D6F6E61636F2D7461626C65203E202E6D6F6E';
wwv_flow_imp.g_varchar2_table(13060) := '61636F2D73706C69742D7669657732202E6D6F6E61636F2D736173682E766572746963616C3A3A6265666F7265207B5C6E5C745C745C745C745C74626F726465722D636F6C6F723A207472616E73706172656E743B5C6E5C745C745C745C747D5C6E5C74';
wwv_flow_imp.g_varchar2_table(13061) := '5C745C7460292C652E7461626C654F6464526F77734261636B67726F756E64436F6C6F7226266F2E7075736828605C6E5C745C745C745C742E6D6F6E61636F2D7461626C65202E6D6F6E61636F2D6C6973742D726F775B646174612D7061726974793D6F';
wwv_flow_imp.g_varchar2_table(13062) := '64645D3A6E6F74282E666F6375736564293A6E6F74282E73656C6563746564293A6E6F74283A686F76657229202E6D6F6E61636F2D7461626C652D74722C5C6E5C745C745C745C742E6D6F6E61636F2D7461626C65202E6D6F6E61636F2D6C6973743A6E';
wwv_flow_imp.g_varchar2_table(13063) := '6F74283A666F63757329202E6D6F6E61636F2D6C6973742D726F775B646174612D7061726974793D6F64645D2E666F63757365643A6E6F74282E73656C6563746564293A6E6F74283A686F76657229202E6D6F6E61636F2D7461626C652D74722C5C6E5C';
wwv_flow_imp.g_varchar2_table(13064) := '745C745C745C742E6D6F6E61636F2D7461626C65202E6D6F6E61636F2D6C6973743A6E6F74282E666F637573656429202E6D6F6E61636F2D6C6973742D726F775B646174612D7061726974793D6F64645D2E666F63757365643A6E6F74282E73656C6563';
wwv_flow_imp.g_varchar2_table(13065) := '746564293A6E6F74283A686F76657229202E6D6F6E61636F2D7461626C652D7472207B5C6E5C745C745C745C745C746261636B67726F756E642D636F6C6F723A20247B652E7461626C654F6464526F77734261636B67726F756E64436F6C6F727D3B5C6E';
wwv_flow_imp.g_varchar2_table(13066) := '5C745C745C745C747D5C6E5C745C745C7460292C746869732E7374796C65456C656D656E742E74657874436F6E74656E743D6F2E6A6F696E28225C6E22297D7D636F6E73742056493D7B6C697374466F6375734261636B67726F756E643A222337464230';
wwv_flow_imp.g_varchar2_table(13067) := '4430222C6C69737441637469766553656C656374696F6E4261636B67726F756E643A2223304536333943222C6C69737441637469766553656C656374696F6E466F726567726F756E643A2223464646464646222C6C69737441637469766553656C656374';
wwv_flow_imp.g_varchar2_table(13068) := '696F6E49636F6E466F726567726F756E643A2223464646464646222C6C697374466F637573416E6453656C656374696F6E4F75746C696E653A2223393043324639222C6C697374466F637573416E6453656C656374696F6E4261636B67726F756E643A22';
wwv_flow_imp.g_varchar2_table(13069) := '23303934373731222C6C697374466F637573416E6453656C656374696F6E466F726567726F756E643A2223464646464646222C6C697374496E61637469766553656C656374696F6E4261636B67726F756E643A2223334633463436222C6C697374496E61';
wwv_flow_imp.g_varchar2_table(13070) := '637469766553656C656374696F6E49636F6E466F726567726F756E643A2223464646464646222C6C697374486F7665724261636B67726F756E643A2223324132443245222C6C69737444726F704F7665724261636B67726F756E643A2223333833423344';
wwv_flow_imp.g_varchar2_table(13071) := '222C6C69737444726F704265747765656E4261636B67726F756E643A2223454545454545222C74726565496E64656E744775696465735374726F6B653A2223613961396139222C74726565496E616374697665496E64656E744775696465735374726F6B';
wwv_flow_imp.g_varchar2_table(13072) := '653A68752E66726F6D48657828222361396139613922292E7472616E73706172656E74282E34292E746F537472696E6728292C7461626C65436F6C756D6E73426F726465723A68752E66726F6D48657828222363636363636322292E7472616E73706172';
wwv_flow_imp.g_varchar2_table(13073) := '656E74282E32292E746F537472696E6728292C7461626C654F6464526F77734261636B67726F756E64436F6C6F723A68752E66726F6D48657828222363636363636322292E7472616E73706172656E74282E3034292E746F537472696E6728292C6C6973';
wwv_flow_imp.g_varchar2_table(13074) := '744261636B67726F756E643A766F696420302C6C697374466F637573466F726567726F756E643A766F696420302C6C697374496E61637469766553656C656374696F6E466F726567726F756E643A766F696420302C6C697374496E616374697665466F63';
wwv_flow_imp.g_varchar2_table(13075) := '7573466F726567726F756E643A766F696420302C6C697374496E616374697665466F6375734261636B67726F756E643A766F696420302C6C697374486F766572466F726567726F756E643A766F696420302C6C697374466F6375734F75746C696E653A76';
wwv_flow_imp.g_varchar2_table(13076) := '6F696420302C6C697374496E616374697665466F6375734F75746C696E653A766F696420302C6C69737453656C656374696F6E4F75746C696E653A766F696420302C6C697374486F7665724F75746C696E653A766F696420302C74726565537469636B79';
wwv_flow_imp.g_varchar2_table(13077) := '5363726F6C6C4261636B67726F756E643A766F696420302C74726565537469636B795363726F6C6C426F726465723A766F696420302C74726565537469636B795363726F6C6C536861646F773A766F696420307D2C7A493D7B6B6579626F617264537570';
wwv_flow_imp.g_varchar2_table(13078) := '706F72743A21302C6D6F757365537570706F72743A21302C6D756C7469706C6553656C656374696F6E537570706F72743A21302C646E643A7B676574447261675552493A28293D3E6E756C6C2C6F6E44726167537461727428297B7D2C6F6E447261674F';
wwv_flow_imp.g_varchar2_table(13079) := '7665723A28293D3E21312C64726F7028297B7D2C646973706F736528297B7D7D7D3B66756E6374696F6E20484928652C74297B636F6E7374206E3D5B5D3B6C657420693D302C6F3D303B666F72283B693C652E6C656E6774687C7C6F3C742E6C656E6774';
wwv_flow_imp.g_varchar2_table(13080) := '683B29696628693E3D652E6C656E677468296E2E7075736828745B6F2B2B5D293B656C7365206966286F3E3D742E6C656E677468296E2E7075736828655B692B2B5D293B656C73657B696628655B695D3D3D3D745B6F5D297B6E2E7075736828655B695D';
wwv_flow_imp.g_varchar2_table(13081) := '292C692B2B2C6F2B2B3B636F6E74696E75657D655B695D3C745B6F5D3F6E2E7075736828655B692B2B5D293A6E2E7075736828745B6F2B2B5D297D72657475726E206E7D636F6E73742057493D28652C74293D3E652D743B636C617373206A497B636F6E';
wwv_flow_imp.g_varchar2_table(13082) := '7374727563746F7228652C74297B746869732E5F74656D706C61746549643D652C746869732E72656E6465726572733D747D6765742074656D706C617465496428297B72657475726E20746869732E5F74656D706C61746549647D72656E64657254656D';
wwv_flow_imp.g_varchar2_table(13083) := '706C6174652865297B72657475726E20746869732E72656E6465726572732E6D61702828743D3E742E72656E64657254656D706C61746528652929297D72656E646572456C656D656E7428652C742C6E2C69297B6C6574206F3D303B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(13084) := '742073206F6620746869732E72656E64657265727329732E72656E646572456C656D656E7428652C742C6E5B6F2B2B5D2C69297D646973706F7365456C656D656E7428652C742C6E2C69297B766172206F3B6C657420733D303B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(13085) := '72206F6620746869732E72656E646572657273296E756C6C3D3D3D286F3D722E646973706F7365456C656D656E74297C7C766F696420303D3D3D6F7C7C6F2E63616C6C28722C652C742C6E5B735D2C69292C732B3D317D646973706F736554656D706C61';
wwv_flow_imp.g_varchar2_table(13086) := '74652865297B6C657420743D303B666F7228636F6E7374206E206F6620746869732E72656E646572657273296E2E646973706F736554656D706C61746528655B742B2B5D297D7D636C6173732071497B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(13087) := '6163636573736962696C69747950726F76696465723D652C746869732E74656D706C61746549643D226131386E227D72656E64657254656D706C6174652865297B72657475726E7B636F6E7461696E65723A652C646973706F7361626C65733A6E657720';
wwv_flow_imp.g_varchar2_table(13088) := '61747D7D72656E646572456C656D656E7428652C742C6E297B636F6E737420693D746869732E6163636573736962696C69747950726F76696465722E676574417269614C6162656C2865292C6F3D69262622737472696E6722213D747970656F6620693F';
wwv_flow_imp.g_varchar2_table(13089) := '693A73492869293B6E2E646973706F7361626C65732E6164642865492828653D3E7B746869732E736574417269614C6162656C28652E726561644F627365727661626C65286F292C6E2E636F6E7461696E6572297D2929293B636F6E737420733D746869';
wwv_flow_imp.g_varchar2_table(13090) := '732E6163636573736962696C69747950726F76696465722E676574417269614C6576656C2626746869732E6163636573736962696C69747950726F76696465722E676574417269614C6576656C2865293B226E756D626572223D3D747970656F6620733F';
wwv_flow_imp.g_varchar2_table(13091) := '6E2E636F6E7461696E65722E7365744174747269627574652822617269612D6C6576656C222C60247B737D60293A6E2E636F6E7461696E65722E72656D6F76654174747269627574652822617269612D6C6576656C22297D736574417269614C6162656C';
wwv_flow_imp.g_varchar2_table(13092) := '28652C74297B653F742E7365744174747269627574652822617269612D6C6162656C222C65293A742E72656D6F76654174747269627574652822617269612D6C6162656C22297D646973706F7365456C656D656E7428652C742C6E2C69297B6E2E646973';
wwv_flow_imp.g_varchar2_table(13093) := '706F7361626C65732E636C65617228297D646973706F736554656D706C6174652865297B652E646973706F7361626C65732E646973706F736528297D7D636C6173732024497B636F6E7374727563746F7228652C74297B746869732E6C6973743D652C74';
wwv_flow_imp.g_varchar2_table(13094) := '6869732E646E643D747D67657444726167456C656D656E74732865297B636F6E737420743D746869732E6C6973742E67657453656C6563746564456C656D656E747328293B72657475726E20742E696E6465784F662865293E2D313F743A5B655D7D6765';
wwv_flow_imp.g_varchar2_table(13095) := '74447261675552492865297B72657475726E20746869732E646E642E676574447261675552492865297D676574447261674C6162656C28652C74297B696628746869732E646E642E676574447261674C6162656C2972657475726E20746869732E646E64';
wwv_flow_imp.g_varchar2_table(13096) := '2E676574447261674C6162656C28652C74297D6F6E44726167537461727428652C74297B766172206E2C693B6E756C6C3D3D3D28693D286E3D746869732E646E64292E6F6E447261675374617274297C7C766F696420303D3D3D697C7C692E63616C6C28';
wwv_flow_imp.g_varchar2_table(13097) := '6E2C652C74297D6F6E447261674F76657228652C742C6E2C692C6F297B72657475726E20746869732E646E642E6F6E447261674F76657228652C742C6E2C692C6F297D6F6E447261674C6561766528652C742C6E2C69297B766172206F2C733B6E756C6C';
wwv_flow_imp.g_varchar2_table(13098) := '3D3D3D28733D286F3D746869732E646E64292E6F6E447261674C65617665297C7C766F696420303D3D3D737C7C732E63616C6C286F2C652C742C6E2C69297D6F6E44726167456E642865297B76617220742C6E3B6E756C6C3D3D3D286E3D28743D746869';
wwv_flow_imp.g_varchar2_table(13099) := '732E646E64292E6F6E44726167456E64297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D64726F7028652C742C6E2C692C6F297B746869732E646E642E64726F7028652C742C6E2C692C6F297D646973706F736528297B746869732E64';
wwv_flow_imp.g_varchar2_table(13100) := '6E642E646973706F736528297D7D636C6173732055497B676574206F6E4469644368616E6765466F63757328297B72657475726E2076742E6D617028746869732E6576656E7442756666657265722E777261704576656E7428746869732E666F6375732E';
wwv_flow_imp.g_varchar2_table(13101) := '6F6E4368616E6765292C28653D3E746869732E746F4C6973744576656E74286529292C746869732E646973706F7361626C6573297D676574206F6E4469644368616E676553656C656374696F6E28297B72657475726E2076742E6D617028746869732E65';
wwv_flow_imp.g_varchar2_table(13102) := '76656E7442756666657265722E777261704576656E7428746869732E73656C656374696F6E2E6F6E4368616E6765292C28653D3E746869732E746F4C6973744576656E74286529292C746869732E646973706F7361626C6573297D67657420646F6D4964';
wwv_flow_imp.g_varchar2_table(13103) := '28297B72657475726E20746869732E766965772E646F6D49647D676574206F6E4469645363726F6C6C28297B72657475726E20746869732E766965772E6F6E4469645363726F6C6C7D676574206F6E4D6F757365436C69636B28297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(13104) := '6869732E766965772E6F6E4D6F757365436C69636B7D676574206F6E4D6F75736544626C436C69636B28297B72657475726E20746869732E766965772E6F6E4D6F75736544626C436C69636B7D676574206F6E4D6F7573654D6964646C65436C69636B28';
wwv_flow_imp.g_varchar2_table(13105) := '297B72657475726E20746869732E766965772E6F6E4D6F7573654D6964646C65436C69636B7D676574206F6E506F696E74657228297B72657475726E20746869732E6D6F757365436F6E74726F6C6C65722E6F6E506F696E7465727D676574206F6E4D6F';
wwv_flow_imp.g_varchar2_table(13106) := '757365446F776E28297B72657475726E20746869732E766965772E6F6E4D6F757365446F776E7D676574206F6E4D6F7573654F76657228297B72657475726E20746869732E766965772E6F6E4D6F7573654F7665727D676574206F6E4D6F7573654F7574';
wwv_flow_imp.g_varchar2_table(13107) := '28297B72657475726E20746869732E766965772E6F6E4D6F7573654F75747D676574206F6E546F756368537461727428297B72657475726E20746869732E766965772E6F6E546F75636853746172747D676574206F6E54617028297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(13108) := '6869732E766965772E6F6E5461707D676574206F6E436F6E746578744D656E7528297B6C657420653D21313B636F6E737420743D76742E636861696E28746869732E646973706F7361626C65732E616464286E6577204B5328746869732E766965772E64';
wwv_flow_imp.g_varchar2_table(13109) := '6F6D4E6F64652C226B6579646F776E2229292E6576656E742C28743D3E742E6D61702828653D3E6E657720716528652929292E66696C7465722828743D3E653D35383D3D3D742E6B6579436F64657C7C742E73686966744B6579262636383D3D3D742E6B';
wwv_flow_imp.g_varchar2_table(13110) := '6579436F646529292E6D61702828653D3E637228652C21302929292E66696C746572282828293D3E2131292929292C6E3D76742E636861696E28746869732E646973706F7361626C65732E616464286E6577204B5328746869732E766965772E646F6D4E';
wwv_flow_imp.g_varchar2_table(13111) := '6F64652C226B657975702229292E6576656E742C28743D3E742E666F7245616368282828293D3E653D213129292E6D61702828653D3E6E657720716528652929292E66696C7465722828653D3E35383D3D3D652E6B6579436F64657C7C652E7368696674';
wwv_flow_imp.g_varchar2_table(13112) := '4B6579262636383D3D3D652E6B6579436F646529292E6D61702828653D3E637228652C21302929292E6D61702828287B62726F777365724576656E743A657D293D3E7B636F6E737420743D746869732E676574466F63757328292C6E3D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(13113) := '683F745B305D3A766F696420303B72657475726E7B696E6465783A6E2C656C656D656E743A766F69642030213D3D6E3F746869732E766965772E656C656D656E74286E293A766F696420302C616E63686F723A766F69642030213D3D6E3F746869732E76';
wwv_flow_imp.g_varchar2_table(13114) := '6965772E646F6D456C656D656E74286E293A746869732E766965772E646F6D4E6F64652C62726F777365724576656E743A657D7D292929292C693D76742E636861696E28746869732E766965772E6F6E436F6E746578744D656E752C28743D3E742E6669';
wwv_flow_imp.g_varchar2_table(13115) := '6C7465722828743D3E216529292E6D61702828287B656C656D656E743A652C696E6465783A742C62726F777365724576656E743A6E7D293D3E287B656C656D656E743A652C696E6465783A742C616E63686F723A6E657720476528727328746869732E76';
wwv_flow_imp.g_varchar2_table(13116) := '6965772E646F6D4E6F6465292C6E292C62726F777365724576656E743A6E7D29292929293B72657475726E2076742E616E7928742C6E2C69297D676574206F6E4B6579446F776E28297B72657475726E20746869732E646973706F7361626C65732E6164';
wwv_flow_imp.g_varchar2_table(13117) := '64286E6577204B5328746869732E766965772E646F6D4E6F64652C226B6579646F776E2229292E6576656E747D676574206F6E446964466F63757328297B72657475726E2076742E7369676E616C28746869732E646973706F7361626C65732E61646428';
wwv_flow_imp.g_varchar2_table(13118) := '6E6577204B5328746869732E766965772E646F6D4E6F64652C22666F637573222C213029292E6576656E74297D676574206F6E446964426C757228297B72657475726E2076742E7369676E616C28746869732E646973706F7361626C65732E616464286E';
wwv_flow_imp.g_varchar2_table(13119) := '6577204B5328746869732E766965772E646F6D4E6F64652C22626C7572222C213029292E6576656E74297D636F6E7374727563746F7228652C742C6E2C692C6F3D7A49297B76617220732C722C612C6C3B746869732E757365723D652C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(13120) := '7074696F6E733D6F2C746869732E666F6375733D6E65772077492822666F637573656422292C746869732E616E63686F723D6E65772077492822616E63686F7222292C746869732E6576656E7442756666657265723D6E65772044742C746869732E5F61';
wwv_flow_imp.g_varchar2_table(13121) := '7269614C6162656C3D22222C746869732E646973706F7361626C65733D6E65772061742C746869732E5F6F6E446964446973706F73653D6E65772043742C746869732E6F6E446964446973706F73653D746869732E5F6F6E446964446973706F73652E65';
wwv_flow_imp.g_varchar2_table(13122) := '76656E743B636F6E737420633D746869732E5F6F7074696F6E732E6163636573736962696C69747950726F76696465722626746869732E5F6F7074696F6E732E6163636573736962696C69747950726F76696465722E676574576964676574526F6C653F';
wwv_flow_imp.g_varchar2_table(13123) := '6E756C6C3D3D3D28733D746869732E5F6F7074696F6E732E6163636573736962696C69747950726F7669646572297C7C766F696420303D3D3D733F766F696420303A732E676574576964676574526F6C6528293A226C697374223B746869732E73656C65';
wwv_flow_imp.g_varchar2_table(13124) := '6374696F6E3D6E657720434928226C697374626F7822213D3D63293B636F6E737420643D5B746869732E666F6375732E72656E64657265722C746869732E73656C656374696F6E2E72656E64657265725D3B746869732E6163636573736962696C697479';
wwv_flow_imp.g_varchar2_table(13125) := '50726F76696465723D6F2E6163636573736962696C69747950726F76696465722C746869732E6163636573736962696C69747950726F7669646572262628642E70757368286E657720714928746869732E6163636573736962696C69747950726F766964';
wwv_flow_imp.g_varchar2_table(13126) := '657229292C6E756C6C3D3D3D28613D28723D746869732E6163636573736962696C69747950726F7669646572292E6F6E4469644368616E676541637469766544657363656E64616E74297C7C766F696420303D3D3D617C7C612E63616C6C28722C746869';
wwv_flow_imp.g_varchar2_table(13127) := '732E6F6E4469644368616E676541637469766544657363656E64616E742C746869732C746869732E646973706F7361626C657329292C693D692E6D61702828653D3E6E6577206A4928652E74656D706C61746549642C5B2E2E2E642C655D2929293B636F';
wwv_flow_imp.g_varchar2_table(13128) := '6E737420683D7B2E2E2E6F2C646E643A6F2E646E6426266E657720244928746869732C6F2E646E64297D3B696628746869732E766965773D746869732E6372656174654C6973745669657728742C6E2C692C68292C746869732E766965772E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(13129) := '64652E7365744174747269627574652822726F6C65222C63292C6F2E7374796C65436F6E74726F6C6C657229746869732E7374796C65436F6E74726F6C6C65723D6F2E7374796C65436F6E74726F6C6C657228746869732E766965772E646F6D4964293B';
wwv_flow_imp.g_varchar2_table(13130) := '656C73657B636F6E737420653D597328746869732E766965772E646F6D4E6F6465293B746869732E7374796C65436F6E74726F6C6C65723D6E657720424928652C746869732E766965772E646F6D4964297D696628746869732E73706C69636561626C65';
wwv_flow_imp.g_varchar2_table(13131) := '3D6E6577207A44285B6E657720534928746869732E666F6375732C746869732E766965772C6F2E6964656E7469747950726F7669646572292C6E657720534928746869732E73656C656374696F6E2C746869732E766965772C6F2E6964656E7469747950';
wwv_flow_imp.g_varchar2_table(13132) := '726F7669646572292C6E657720534928746869732E616E63686F722C746869732E766965772C6F2E6964656E7469747950726F7669646572292C746869732E766965775D292C746869732E646973706F7361626C65732E61646428746869732E666F6375';
wwv_flow_imp.g_varchar2_table(13133) := '73292C746869732E646973706F7361626C65732E61646428746869732E73656C656374696F6E292C746869732E646973706F7361626C65732E61646428746869732E616E63686F72292C746869732E646973706F7361626C65732E61646428746869732E';
wwv_flow_imp.g_varchar2_table(13134) := '76696577292C746869732E646973706F7361626C65732E61646428746869732E5F6F6E446964446973706F7365292C746869732E646973706F7361626C65732E616464286E6577204E4928746869732C746869732E7669657729292C2822626F6F6C6561';
wwv_flow_imp.g_varchar2_table(13135) := '6E22213D747970656F66206F2E6B6579626F617264537570706F72747C7C6F2E6B6579626F617264537570706F727429262628746869732E6B6579626F617264436F6E74726F6C6C65723D6E657720494928746869732C746869732E766965772C6F292C';
wwv_flow_imp.g_varchar2_table(13136) := '746869732E646973706F7361626C65732E61646428746869732E6B6579626F617264436F6E74726F6C6C657229292C6F2E6B6579626F6172644E617669676174696F6E4C6162656C50726F7669646572297B636F6E737420653D6F2E6B6579626F617264';
wwv_flow_imp.g_varchar2_table(13137) := '4E617669676174696F6E44656C65676174657C7C4D493B746869732E747970654E617669676174696F6E436F6E74726F6C6C65723D6E657720414928746869732C746869732E766965772C6F2E6B6579626F6172644E617669676174696F6E4C6162656C';
wwv_flow_imp.g_varchar2_table(13138) := '50726F76696465722C6E756C6C213D3D286C3D6F2E6B6579626F6172644E617669676174696F6E4576656E7446696C746572292626766F69642030213D3D6C3F6C3A28293D3E21302C65292C746869732E646973706F7361626C65732E61646428746869';
wwv_flow_imp.g_varchar2_table(13139) := '732E747970654E617669676174696F6E436F6E74726F6C6C6572297D746869732E6D6F757365436F6E74726F6C6C65723D746869732E6372656174654D6F757365436F6E74726F6C6C6572286F292C746869732E646973706F7361626C65732E61646428';
wwv_flow_imp.g_varchar2_table(13140) := '746869732E6D6F757365436F6E74726F6C6C6572292C746869732E6F6E4469644368616E6765466F63757328746869732E5F6F6E466F6375734368616E67652C746869732C746869732E646973706F7361626C6573292C746869732E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(13141) := '6E676553656C656374696F6E28746869732E5F6F6E53656C656374696F6E4368616E67652C746869732C746869732E646973706F7361626C6573292C746869732E6163636573736962696C69747950726F7669646572262628746869732E617269614C61';
wwv_flow_imp.g_varchar2_table(13142) := '62656C3D746869732E6163636573736962696C69747950726F76696465722E676574576964676574417269614C6162656C2829292C2131213D3D746869732E5F6F7074696F6E732E6D756C7469706C6553656C656374696F6E537570706F727426267468';
wwv_flow_imp.g_varchar2_table(13143) := '69732E766965772E646F6D4E6F64652E7365744174747269627574652822617269612D6D756C746973656C65637461626C65222C227472756522297D6372656174654C6973745669657728652C742C6E2C69297B72657475726E206E657720455428652C';
wwv_flow_imp.g_varchar2_table(13144) := '742C6E2C69297D6372656174654D6F757365436F6E74726F6C6C65722865297B72657475726E206E65772046492874686973297D7570646174654F7074696F6E7328653D7B7D297B76617220742C6E3B746869732E5F6F7074696F6E733D7B2E2E2E7468';
wwv_flow_imp.g_varchar2_table(13145) := '69732E5F6F7074696F6E732C2E2E2E657D2C6E756C6C3D3D3D28743D746869732E747970654E617669676174696F6E436F6E74726F6C6C6572297C7C766F696420303D3D3D747C7C742E7570646174654F7074696F6E7328746869732E5F6F7074696F6E';
wwv_flow_imp.g_varchar2_table(13146) := '73292C766F69642030213D3D746869732E5F6F7074696F6E732E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C6572262628746869732E5F6F7074696F6E732E6D756C7469706C6553656C656374696F6E537570706F72743F746869732E';
wwv_flow_imp.g_varchar2_table(13147) := '766965772E646F6D4E6F64652E7365744174747269627574652822617269612D6D756C746973656C65637461626C65222C227472756522293A746869732E766965772E646F6D4E6F64652E72656D6F76654174747269627574652822617269612D6D756C';
wwv_flow_imp.g_varchar2_table(13148) := '746973656C65637461626C652229292C746869732E6D6F757365436F6E74726F6C6C65722E7570646174654F7074696F6E732865292C6E756C6C3D3D3D286E3D746869732E6B6579626F617264436F6E74726F6C6C6572297C7C766F696420303D3D3D6E';
wwv_flow_imp.g_varchar2_table(13149) := '7C7C6E2E7570646174654F7074696F6E732865292C746869732E766965772E7570646174654F7074696F6E732865297D676574206F7074696F6E7328297B72657475726E20746869732E5F6F7074696F6E737D73706C69636528652C742C6E3D5B5D297B';
wwv_flow_imp.g_varchar2_table(13150) := '696628653C307C7C653E746869732E766965772E6C656E677468297468726F77206E657720554428746869732E757365722C60496E76616C696420737461727420696E6465783A20247B657D60293B696628743C30297468726F77206E65772055442874';
wwv_flow_imp.g_varchar2_table(13151) := '6869732E757365722C60496E76616C69642064656C65746520636F756E743A20247B747D60293B303D3D3D742626303D3D3D6E2E6C656E6774687C7C746869732E6576656E7442756666657265722E6275666665724576656E7473282828293D3E746869';
wwv_flow_imp.g_varchar2_table(13152) := '732E73706C69636561626C652E73706C69636528652C742C6E2929297D726572656E64657228297B746869732E766965772E726572656E64657228297D656C656D656E742865297B72657475726E20746869732E766965772E656C656D656E742865297D';
wwv_flow_imp.g_varchar2_table(13153) := '696E6465784F662865297B72657475726E20746869732E766965772E696E6465784F662865297D696E64657841742865297B72657475726E20746869732E766965772E696E64657841742865297D676574206C656E67746828297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(13154) := '69732E766965772E6C656E6774687D67657420636F6E74656E7448656967687428297B72657475726E20746869732E766965772E636F6E74656E744865696768747D676574206F6E4469644368616E6765436F6E74656E7448656967687428297B726574';
wwv_flow_imp.g_varchar2_table(13155) := '75726E20746869732E766965772E6F6E4469644368616E6765436F6E74656E744865696768747D676574207363726F6C6C546F7028297B72657475726E20746869732E766965772E6765745363726F6C6C546F7028297D736574207363726F6C6C546F70';
wwv_flow_imp.g_varchar2_table(13156) := '2865297B746869732E766965772E7365745363726F6C6C546F702865297D676574207363726F6C6C48656967687428297B72657475726E20746869732E766965772E7363726F6C6C4865696768747D6765742072656E64657248656967687428297B7265';
wwv_flow_imp.g_varchar2_table(13157) := '7475726E20746869732E766965772E72656E6465724865696768747D67657420666972737456697369626C65496E64657828297B72657475726E20746869732E766965772E666972737456697369626C65496E6465787D67657420617269614C6162656C';
wwv_flow_imp.g_varchar2_table(13158) := '28297B72657475726E20746869732E5F617269614C6162656C7D73657420617269614C6162656C2865297B746869732E5F617269614C6162656C3D652C746869732E766965772E646F6D4E6F64652E7365744174747269627574652822617269612D6C61';
wwv_flow_imp.g_varchar2_table(13159) := '62656C222C65297D646F6D466F63757328297B746869732E766965772E646F6D4E6F64652E666F637573287B70726576656E745363726F6C6C3A21307D297D6C61796F757428652C74297B746869732E766965772E6C61796F757428652C74297D736574';
wwv_flow_imp.g_varchar2_table(13160) := '53656C656374696F6E28652C74297B666F7228636F6E73742074206F66206529696628743C307C7C743E3D746869732E6C656E677468297468726F77206E657720554428746869732E757365722C60496E76616C696420696E64657820247B747D60293B';
wwv_flow_imp.g_varchar2_table(13161) := '746869732E73656C656374696F6E2E73657428652C74297D67657453656C656374696F6E28297B72657475726E20746869732E73656C656374696F6E2E67657428297D67657453656C6563746564456C656D656E747328297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(13162) := '2E67657453656C656374696F6E28292E6D61702828653D3E746869732E766965772E656C656D656E7428652929297D736574416E63686F722865297B696628766F69642030213D3D65297B696628653C307C7C653E3D746869732E6C656E677468297468';
wwv_flow_imp.g_varchar2_table(13163) := '726F77206E657720554428746869732E757365722C60496E76616C696420696E64657820247B657D60293B746869732E616E63686F722E736574285B655D297D656C736520746869732E616E63686F722E736574285B5D297D676574416E63686F722829';
wwv_flow_imp.g_varchar2_table(13164) := '7B72657475726E20246828746869732E616E63686F722E67657428292C766F69642030297D676574416E63686F72456C656D656E7428297B636F6E737420653D746869732E676574416E63686F7228293B72657475726E20766F696420303D3D3D653F76';
wwv_flow_imp.g_varchar2_table(13165) := '6F696420303A746869732E656C656D656E742865297D736574466F63757328652C74297B666F7228636F6E73742074206F66206529696628743C307C7C743E3D746869732E6C656E677468297468726F77206E657720554428746869732E757365722C60';
wwv_flow_imp.g_varchar2_table(13166) := '496E76616C696420696E64657820247B747D60293B746869732E666F6375732E73657428652C74297D666F6375734E65787428653D312C743D21312C6E2C69297B696628303D3D3D746869732E6C656E6774682972657475726E3B636F6E7374206F3D74';
wwv_flow_imp.g_varchar2_table(13167) := '6869732E666F6375732E67657428292C733D746869732E66696E644E657874496E646578286F2E6C656E6774683E303F6F5B305D2B653A302C742C69293B733E2D312626746869732E736574466F637573285B735D2C6E297D666F63757350726576696F';
wwv_flow_imp.g_varchar2_table(13168) := '757328653D312C743D21312C6E2C69297B696628303D3D3D746869732E6C656E6774682972657475726E3B636F6E7374206F3D746869732E666F6375732E67657428292C733D746869732E66696E6450726576696F7573496E646578286F2E6C656E6774';
wwv_flow_imp.g_varchar2_table(13169) := '683E303F6F5B305D2D653A302C742C69293B733E2D312626746869732E736574466F637573285B735D2C6E297D6173796E6320666F6375734E6578745061676528652C74297B6C6574206E3D746869732E766965772E696E646578417428746869732E76';
wwv_flow_imp.g_varchar2_table(13170) := '6965772E6765745363726F6C6C546F7028292B746869732E766965772E72656E646572486569676874293B6E3D303D3D3D6E3F303A6E2D313B636F6E737420693D746869732E676574466F63757328295B305D3B69662869213D3D6E262628766F696420';
wwv_flow_imp.g_varchar2_table(13171) := '303D3D3D697C7C6E3E6929297B636F6E7374206F3D746869732E66696E6450726576696F7573496E646578286E2C21312C74293B6F3E2D31262669213D3D6F3F746869732E736574466F637573285B6F5D2C65293A746869732E736574466F637573285B';
wwv_flow_imp.g_varchar2_table(13172) := '6E5D2C65297D656C73657B636F6E7374206F3D746869732E766965772E6765745363726F6C6C546F7028293B6C657420733D6F2B746869732E766965772E72656E6465724865696768743B6E3E69262628732D3D746869732E766965772E656C656D656E';
wwv_flow_imp.g_varchar2_table(13173) := '74486569676874286E29292C746869732E766965772E7365745363726F6C6C546F702873292C746869732E766965772E6765745363726F6C6C546F702829213D3D6F262628746869732E736574466F637573285B5D292C61776169742057742830292C61';
wwv_flow_imp.g_varchar2_table(13174) := '7761697420746869732E666F6375734E6578745061676528652C7429297D7D6173796E6320666F63757350726576696F75735061676528652C742C6E3D28293D3E30297B6C657420693B636F6E7374206F3D6E28292C733D746869732E766965772E6765';
wwv_flow_imp.g_varchar2_table(13175) := '745363726F6C6C546F7028292B6F3B693D303D3D3D733F746869732E766965772E696E64657841742873293A746869732E766965772E696E646578416674657228732D31293B636F6E737420723D746869732E676574466F63757328295B305D3B696628';
wwv_flow_imp.g_varchar2_table(13176) := '72213D3D69262628766F696420303D3D3D727C7C723E3D6929297B636F6E7374206E3D746869732E66696E644E657874496E64657828692C21312C74293B6E3E2D31262672213D3D6E3F746869732E736574466F637573285B6E5D2C65293A746869732E';
wwv_flow_imp.g_varchar2_table(13177) := '736574466F637573285B695D2C65297D656C73657B636F6E737420693D733B746869732E766965772E7365745363726F6C6C546F7028732D746869732E766965772E72656E6465724865696768742D6F292C746869732E766965772E6765745363726F6C';
wwv_flow_imp.g_varchar2_table(13178) := '6C546F7028292B6E2829213D3D69262628746869732E736574466F637573285B5D292C61776169742057742830292C617761697420746869732E666F63757350726576696F75735061676528652C742C6E29297D7D666F6375734C61737428652C74297B';
wwv_flow_imp.g_varchar2_table(13179) := '696628303D3D3D746869732E6C656E6774682972657475726E3B636F6E7374206E3D746869732E66696E6450726576696F7573496E64657828746869732E6C656E6774682D312C21312C74293B6E3E2D312626746869732E736574466F637573285B6E5D';
wwv_flow_imp.g_varchar2_table(13180) := '2C65297D666F637573466972737428652C74297B746869732E666F6375734E746828302C652C74297D666F6375734E746828652C742C6E297B696628303D3D3D746869732E6C656E6774682972657475726E3B636F6E737420693D746869732E66696E64';
wwv_flow_imp.g_varchar2_table(13181) := '4E657874496E64657828652C21312C6E293B693E2D312626746869732E736574466F637573285B695D2C74297D66696E644E657874496E64657828652C743D21312C6E297B666F72286C657420693D303B693C746869732E6C656E6774683B692B2B297B';
wwv_flow_imp.g_varchar2_table(13182) := '696628653E3D746869732E6C656E677468262621742972657475726E2D313B69662865253D746869732E6C656E6774682C216E7C7C6E28746869732E656C656D656E74286529292972657475726E20653B652B2B7D72657475726E2D317D66696E645072';
wwv_flow_imp.g_varchar2_table(13183) := '6576696F7573496E64657828652C743D21312C6E297B666F72286C657420693D303B693C746869732E6C656E6774683B692B2B297B696628653C30262621742972657475726E2D313B696628653D28746869732E6C656E6774682B6525746869732E6C65';
wwv_flow_imp.g_varchar2_table(13184) := '6E6774682925746869732E6C656E6774682C216E7C7C6E28746869732E656C656D656E74286529292972657475726E20653B652D2D7D72657475726E2D317D676574466F63757328297B72657475726E20746869732E666F6375732E67657428297D6765';
wwv_flow_imp.g_varchar2_table(13185) := '74466F6375736564456C656D656E747328297B72657475726E20746869732E676574466F63757328292E6D61702828653D3E746869732E766965772E656C656D656E7428652929297D72657665616C28652C742C6E3D30297B696628653C307C7C653E3D';
wwv_flow_imp.g_varchar2_table(13186) := '746869732E6C656E677468297468726F77206E657720554428746869732E757365722C60496E76616C696420696E64657820247B657D60293B636F6E737420693D746869732E766965772E6765745363726F6C6C546F7028292C6F3D746869732E766965';
wwv_flow_imp.g_varchar2_table(13187) := '772E656C656D656E74546F702865292C733D746869732E766965772E656C656D656E744865696768742865293B696628676C287429297B636F6E737420653D732D746869732E766965772E72656E6465724865696768742B6E3B746869732E766965772E';
wwv_flow_imp.g_varchar2_table(13188) := '7365745363726F6C6C546F7028652A484428742C302C31292B6F2D6E297D656C73657B636F6E737420653D6F2B732C743D692B746869732E766965772E72656E6465724865696768743B6F3C692B6E2626653E3D747C7C286F3C692B6E7C7C653E3D7426';
wwv_flow_imp.g_varchar2_table(13189) := '26733E3D746869732E766965772E72656E6465724865696768743F746869732E766965772E7365745363726F6C6C546F70286F2D6E293A653E3D742626746869732E766965772E7365745363726F6C6C546F7028652D746869732E766965772E72656E64';
wwv_flow_imp.g_varchar2_table(13190) := '657248656967687429297D7D67657452656C6174697665546F7028652C743D30297B696628653C307C7C653E3D746869732E6C656E677468297468726F77206E657720554428746869732E757365722C60496E76616C696420696E64657820247B657D60';
wwv_flow_imp.g_varchar2_table(13191) := '293B636F6E7374206E3D746869732E766965772E6765745363726F6C6C546F7028292C693D746869732E766965772E656C656D656E74546F702865292C6F3D746869732E766965772E656C656D656E744865696768742865293B696628693C6E2B747C7C';
wwv_flow_imp.g_varchar2_table(13192) := '692B6F3E6E2B746869732E766965772E72656E6465724865696768742972657475726E206E756C6C3B636F6E737420733D6F2D746869732E766965772E72656E6465724865696768742B743B72657475726E204D6174682E61627328286E2B742D69292F';
wwv_flow_imp.g_varchar2_table(13193) := '73297D67657448544D4C456C656D656E7428297B72657475726E20746869732E766965772E646F6D4E6F64657D6765745363726F6C6C61626C65456C656D656E7428297B72657475726E20746869732E766965772E7363726F6C6C61626C65456C656D65';
wwv_flow_imp.g_varchar2_table(13194) := '6E74446F6D4E6F64657D676574456C656D656E7449442865297B72657475726E20746869732E766965772E676574456C656D656E74446F6D49642865297D676574456C656D656E74546F702865297B72657475726E20746869732E766965772E656C656D';
wwv_flow_imp.g_varchar2_table(13195) := '656E74546F702865297D7374796C652865297B746869732E7374796C65436F6E74726F6C6C65722E7374796C652865297D746F4C6973744576656E74287B696E64657865733A652C62726F777365724576656E743A747D297B72657475726E7B696E6465';
wwv_flow_imp.g_varchar2_table(13196) := '7865733A652C656C656D656E74733A652E6D61702828653D3E746869732E766965772E656C656D656E7428652929292C62726F777365724576656E743A747D7D5F6F6E466F6375734368616E676528297B636F6E737420653D746869732E666F6375732E';
wwv_flow_imp.g_varchar2_table(13197) := '67657428293B746869732E766965772E646F6D4E6F64652E636C6173734C6973742E746F67676C652822656C656D656E742D666F6375736564222C652E6C656E6774683E30292C746869732E6F6E4469644368616E676541637469766544657363656E64';
wwv_flow_imp.g_varchar2_table(13198) := '616E7428297D6F6E4469644368616E676541637469766544657363656E64616E7428297B76617220653B636F6E737420743D746869732E666F6375732E67657428293B696628742E6C656E6774683E30297B6C6574206E3B286E756C6C3D3D3D28653D74';
wwv_flow_imp.g_varchar2_table(13199) := '6869732E6163636573736962696C69747950726F7669646572297C7C766F696420303D3D3D653F766F696420303A652E67657441637469766544657363656E64616E744964292626286E3D746869732E6163636573736962696C69747950726F76696465';
wwv_flow_imp.g_varchar2_table(13200) := '722E67657441637469766544657363656E64616E74496428746869732E766965772E656C656D656E7428745B305D2929292C746869732E766965772E646F6D4E6F64652E7365744174747269627574652822617269612D61637469766564657363656E64';
wwv_flow_imp.g_varchar2_table(13201) := '616E74222C6E7C7C746869732E766965772E676574456C656D656E74446F6D496428745B305D29297D656C736520746869732E766965772E646F6D4E6F64652E72656D6F76654174747269627574652822617269612D61637469766564657363656E6461';
wwv_flow_imp.g_varchar2_table(13202) := '6E7422297D5F6F6E53656C656374696F6E4368616E676528297B636F6E737420653D746869732E73656C656374696F6E2E67657428293B746869732E766965772E646F6D4E6F64652E636C6173734C6973742E746F67676C65282273656C656374696F6E';
wwv_flow_imp.g_varchar2_table(13203) := '2D6E6F6E65222C303D3D3D652E6C656E677468292C746869732E766965772E646F6D4E6F64652E636C6173734C6973742E746F67676C65282273656C656374696F6E2D73696E676C65222C313D3D3D652E6C656E677468292C746869732E766965772E64';
wwv_flow_imp.g_varchar2_table(13204) := '6F6D4E6F64652E636C6173734C6973742E746F67676C65282273656C656374696F6E2D6D756C7469706C65222C652E6C656E6774683E31297D646973706F736528297B746869732E5F6F6E446964446973706F73652E6669726528292C746869732E6469';
wwv_flow_imp.g_varchar2_table(13205) := '73706F7361626C65732E646973706F736528292C746869732E5F6F6E446964446973706F73652E646973706F736528297D7D5F49285B44455D2C55492E70726F746F747970652C226F6E4469644368616E6765466F637573222C6E756C6C292C5F49285B';
wwv_flow_imp.g_varchar2_table(13206) := '44455D2C55492E70726F746F747970652C226F6E4469644368616E676553656C656374696F6E222C6E756C6C292C5F49285B44455D2C55492E70726F746F747970652C226F6E436F6E746578744D656E75222C6E756C6C292C5F49285B44455D2C55492E';
wwv_flow_imp.g_varchar2_table(13207) := '70726F746F747970652C226F6E4B6579446F776E222C6E756C6C292C5F49285B44455D2C55492E70726F746F747970652C226F6E446964466F637573222C6E756C6C292C5F49285B44455D2C55492E70726F746F747970652C226F6E446964426C757222';
wwv_flow_imp.g_varchar2_table(13208) := '2C6E756C6C293B766172204B493D6E2837363139292C47493D7B7D3B47492E7374796C655461675472616E73666F726D3D6A7228292C47492E736574417474726962757465733D567228292C47492E696E736572743D467228292E62696E64286E756C6C';
wwv_flow_imp.g_varchar2_table(13209) := '2C226865616422292C47492E646F6D4150493D4F7228292C47492E696E736572745374796C65456C656D656E743D487228292C4E722829284B492E412C4749292C4B492E4126264B492E412E6C6F63616C7326264B492E412E6C6F63616C733B636F6E73';
wwv_flow_imp.g_varchar2_table(13210) := '742051493D62722C59493D2273656C6563744F7074696F6E2E656E7472792E74656D706C617465223B636C617373205A497B6765742074656D706C617465496428297B72657475726E2059497D72656E64657254656D706C6174652865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(13211) := '20743D4F626A6563742E637265617465286E756C6C293B72657475726E20742E726F6F743D652C742E746578743D757228652C514928222E6F7074696F6E2D746578742229292C742E64657461696C3D757228652C514928222E6F7074696F6E2D646574';
wwv_flow_imp.g_varchar2_table(13212) := '61696C2229292C742E6465636F7261746F7252696768743D757228652C514928222E6F7074696F6E2D6465636F7261746F722D72696768742229292C747D72656E646572456C656D656E7428652C742C6E297B636F6E737420693D6E2C6F3D652E746578';
wwv_flow_imp.g_varchar2_table(13213) := '742C733D652E64657461696C2C723D652E6465636F7261746F7252696768742C613D652E697344697361626C65643B692E746578742E74657874436F6E74656E743D6F2C692E64657461696C2E74657874436F6E74656E743D737C7C22222C692E646563';
wwv_flow_imp.g_varchar2_table(13214) := '6F7261746F7252696768742E696E6E6572546578743D727C7C22222C613F692E726F6F742E636C6173734C6973742E61646428226F7074696F6E2D64697361626C656422293A692E726F6F742E636C6173734C6973742E72656D6F766528226F7074696F';
wwv_flow_imp.g_varchar2_table(13215) := '6E2D64697361626C656422297D646973706F736554656D706C6174652865297B7D7D636C61737320584920657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E6F7074696F6E733D5B5D';
wwv_flow_imp.g_varchar2_table(13216) := '2C746869732E5F63757272656E7453656C656374696F6E3D302C746869732E5F68617344657461696C733D21312C746869732E5F736B69704C61796F75743D21312C746869732E5F737469636B793D21312C746869732E5F697356697369626C653D2131';
wwv_flow_imp.g_varchar2_table(13217) := '2C746869732E7374796C65733D692C746869732E73656C656374426F784F7074696F6E733D6F7C7C4F626A6563742E637265617465286E756C6C292C226E756D62657222213D747970656F6620746869732E73656C656374426F784F7074696F6E732E6D';
wwv_flow_imp.g_varchar2_table(13218) := '696E426F74746F6D4D617267696E3F746869732E73656C656374426F784F7074696F6E732E6D696E426F74746F6D4D617267696E3D58492E44454641554C545F44524F50444F574E5F4D494E494D554D5F424F54544F4D5F4D415247494E3A746869732E';
wwv_flow_imp.g_varchar2_table(13219) := '73656C656374426F784F7074696F6E732E6D696E426F74746F6D4D617267696E3C30262628746869732E73656C656374426F784F7074696F6E732E6D696E426F74746F6D4D617267696E3D30292C746869732E73656C656374456C656D656E743D646F63';
wwv_flow_imp.g_varchar2_table(13220) := '756D656E742E637265617465456C656D656E74282273656C65637422292C746869732E73656C656374456C656D656E742E636C6173734E616D653D226D6F6E61636F2D73656C6563742D626F78206D6F6E61636F2D73656C6563742D626F782D64726F70';
wwv_flow_imp.g_varchar2_table(13221) := '646F776E2D70616464696E67222C22737472696E67223D3D747970656F6620746869732E73656C656374426F784F7074696F6E732E617269614C6162656C2626746869732E73656C656374456C656D656E742E7365744174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(13222) := '612D6C6162656C222C746869732E73656C656374426F784F7074696F6E732E617269614C6162656C292C22737472696E67223D3D747970656F6620746869732E73656C656374426F784F7074696F6E732E617269614465736372697074696F6E26267468';
wwv_flow_imp.g_varchar2_table(13223) := '69732E73656C656374456C656D656E742E7365744174747269627574652822617269612D6465736372697074696F6E222C746869732E73656C656374426F784F7074696F6E732E617269614465736372697074696F6E292C746869732E5F6F6E44696453';
wwv_flow_imp.g_varchar2_table(13224) := '656C6563743D6E65772043742C746869732E5F726567697374657228746869732E5F6F6E44696453656C656374292C746869732E72656769737465724C697374656E65727328292C746869732E636F6E73747275637453656C65637444726F70446F776E';
wwv_flow_imp.g_varchar2_table(13225) := '286E292C746869732E73656C65637465643D747C7C302C652626746869732E7365744F7074696F6E7328652C74292C746869732E696E69745374796C65536865657428297D7365745469746C652865297B21746869732E5F686F7665722626653F746869';
wwv_flow_imp.g_varchar2_table(13226) := '732E5F686F7665723D746869732E5F726567697374657228564528292E7365747570557064617461626C65486F76657228504528226D6F75736522292C746869732E73656C656374456C656D656E742C6529293A746869732E5F686F7665722626746869';
wwv_flow_imp.g_varchar2_table(13227) := '732E5F686F7665722E7570646174652865297D67657448656967687428297B72657475726E2032327D67657454656D706C617465496428297B72657475726E2059497D636F6E73747275637453656C65637444726F70446F776E2865297B746869732E63';
wwv_flow_imp.g_varchar2_table(13228) := '6F6E746578745669657750726F76696465723D652C746869732E73656C65637444726F70446F776E436F6E7461696E65723D627228222E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E657222292C746869732E73';
wwv_flow_imp.g_varchar2_table(13229) := '656C65637444726F70446F776E436F6E7461696E65722E636C6173734C6973742E61646428226D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D70616464696E6722292C746869732E73656C656374696F6E44657461696C7350616E65';
wwv_flow_imp.g_varchar2_table(13230) := '3D757228746869732E73656C65637444726F70446F776E436F6E7461696E65722C514928222E73656C6563742D626F782D64657461696C732D70616E652229293B636F6E737420743D757228746869732E73656C65637444726F70446F776E436F6E7461';
wwv_flow_imp.g_varchar2_table(13231) := '696E65722C514928222E73656C6563742D626F782D64726F70646F776E2D636F6E7461696E65722D77696474682D636F6E74726F6C2229292C6E3D757228742C514928222E77696474682D636F6E74726F6C2D6469762229293B746869732E7769647468';
wwv_flow_imp.g_varchar2_table(13232) := '436F6E74726F6C456C656D656E743D646F63756D656E742E637265617465456C656D656E7428227370616E22292C746869732E7769647468436F6E74726F6C456C656D656E742E636C6173734E616D653D226F7074696F6E2D746578742D77696474682D';
wwv_flow_imp.g_varchar2_table(13233) := '636F6E74726F6C222C7572286E2C746869732E7769647468436F6E74726F6C456C656D656E74292C746869732E5F64726F70446F776E506F736974696F6E3D302C746869732E7374796C65456C656D656E743D597328746869732E73656C65637444726F';
wwv_flow_imp.g_varchar2_table(13234) := '70446F776E436F6E7461696E6572292C746869732E73656C65637444726F70446F776E436F6E7461696E65722E7365744174747269627574652822647261676761626C65222C227472756522292C746869732E5F72656769737465722862732874686973';
wwv_flow_imp.g_varchar2_table(13235) := '2E73656C65637444726F70446F776E436F6E7461696E65722C61722E445241475F53544152542C28653D3E7B637228652C2130297D2929297D72656769737465724C697374656E65727328297B6C657420653B746869732E5F7265676973746572287973';
wwv_flow_imp.g_varchar2_table(13236) := '28746869732E73656C656374456C656D656E742C226368616E6765222C28653D3E7B746869732E73656C65637465643D652E7461726765742E73656C6563746564496E6465782C746869732E5F6F6E44696453656C6563742E66697265287B696E646578';
wwv_flow_imp.g_varchar2_table(13237) := '3A652E7461726765742E73656C6563746564496E6465782C73656C65637465643A652E7461726765742E76616C75657D292C746869732E6F7074696F6E735B746869732E73656C65637465645D2626746869732E6F7074696F6E735B746869732E73656C';
wwv_flow_imp.g_varchar2_table(13238) := '65637465645D2E746578742626746869732E7365745469746C6528746869732E6F7074696F6E735B746869732E73656C65637465645D2E74657874297D2929292C746869732E5F726567697374657228627328746869732E73656C656374456C656D656E';
wwv_flow_imp.g_varchar2_table(13239) := '742C61722E434C49434B2C28653D3E7B63722865292C746869732E5F697356697369626C653F746869732E6869646553656C65637444726F70446F776E282130293A746869732E73686F7753656C65637444726F70446F776E28297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(13240) := '2E5F726567697374657228627328746869732E73656C656374456C656D656E742C61722E4D4F5553455F444F574E2C28653D3E7B63722865297D2929292C746869732E5F726567697374657228627328746869732E73656C656374456C656D656E742C22';
wwv_flow_imp.g_varchar2_table(13241) := '746F7563687374617274222C28743D3E7B653D746869732E5F697356697369626C657D2929292C746869732E5F726567697374657228627328746869732E73656C656374456C656D656E742C22746F756368656E64222C28743D3E7B63722874292C653F';
wwv_flow_imp.g_varchar2_table(13242) := '746869732E6869646553656C65637444726F70446F776E282130293A746869732E73686F7753656C65637444726F70446F776E28297D2929292C746869732E5F726567697374657228627328746869732E73656C656374456C656D656E742C61722E4B45';
wwv_flow_imp.g_varchar2_table(13243) := '595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B6C6574206E3D21313B713F3138213D3D742E6B6579436F646526263136213D3D742E6B6579436F646526263130213D3D742E6B6579436F6465262633213D3D742E6B6579436F';
wwv_flow_imp.g_varchar2_table(13244) := '64657C7C286E3D2130293A2831383D3D3D742E6B6579436F64652626742E616C744B65797C7C31363D3D3D742E6B6579436F64652626742E616C744B65797C7C31303D3D3D742E6B6579436F64657C7C333D3D3D742E6B6579436F6465292626286E3D21';
wwv_flow_imp.g_varchar2_table(13245) := '30292C6E262628746869732E73686F7753656C65637444726F70446F776E28292C637228652C213029297D2929297D676574206F6E44696453656C65637428297B72657475726E20746869732E5F6F6E44696453656C6563742E6576656E747D7365744F';
wwv_flow_imp.g_varchar2_table(13246) := '7074696F6E7328652C74297B506828746869732E6F7074696F6E732C65297C7C28746869732E6F7074696F6E733D652C746869732E73656C656374456C656D656E742E6F7074696F6E732E6C656E6774683D302C746869732E5F68617344657461696C73';
wwv_flow_imp.g_varchar2_table(13247) := '3D21312C746869732E5F6361636865644D617844657461696C734865696768743D766F696420302C746869732E6F7074696F6E732E666F7245616368282828652C74293D3E7B746869732E73656C656374456C656D656E742E61646428746869732E6372';
wwv_flow_imp.g_varchar2_table(13248) := '656174654F7074696F6E28652E746578742C742C652E697344697361626C656429292C22737472696E67223D3D747970656F6620652E6465736372697074696F6E262628746869732E5F68617344657461696C733D2130297D2929292C766F6964203021';
wwv_flow_imp.g_varchar2_table(13249) := '3D3D74262628746869732E73656C6563742874292C746869732E5F63757272656E7453656C656374696F6E3D746869732E73656C6563746564297D7365744F7074696F6E734C69737428297B76617220653B6E756C6C3D3D3D28653D746869732E73656C';
wwv_flow_imp.g_varchar2_table(13250) := '6563744C697374297C7C766F696420303D3D3D657C7C652E73706C69636528302C746869732E73656C6563744C6973742E6C656E6774682C746869732E6F7074696F6E73297D73656C6563742865297B653E3D302626653C746869732E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(13251) := '2E6C656E6774683F746869732E73656C65637465643D653A653E746869732E6F7074696F6E732E6C656E6774682D313F746869732E73656C65637428746869732E6F7074696F6E732E6C656E6774682D31293A746869732E73656C65637465643C302626';
wwv_flow_imp.g_varchar2_table(13252) := '28746869732E73656C65637465643D30292C746869732E73656C656374456C656D656E742E73656C6563746564496E6465783D746869732E73656C65637465642C746869732E6F7074696F6E735B746869732E73656C65637465645D2626746869732E6F';
wwv_flow_imp.g_varchar2_table(13253) := '7074696F6E735B746869732E73656C65637465645D2E746578742626746869732E7365745469746C6528746869732E6F7074696F6E735B746869732E73656C65637465645D2E74657874297D666F63757328297B746869732E73656C656374456C656D65';
wwv_flow_imp.g_varchar2_table(13254) := '6E74262628746869732E73656C656374456C656D656E742E746162496E6465783D302C746869732E73656C656374456C656D656E742E666F6375732829297D626C757228297B746869732E73656C656374456C656D656E74262628746869732E73656C65';
wwv_flow_imp.g_varchar2_table(13255) := '6374456C656D656E742E746162496E6465783D2D312C746869732E73656C656374456C656D656E742E626C75722829297D736574466F63757361626C652865297B746869732E73656C656374456C656D656E742E746162496E6465783D653F303A2D317D';
wwv_flow_imp.g_varchar2_table(13256) := '72656E6465722865297B746869732E636F6E7461696E65723D652C652E636C6173734C6973742E616464282273656C6563742D636F6E7461696E657222292C652E617070656E644368696C6428746869732E73656C656374456C656D656E74292C746869';
wwv_flow_imp.g_varchar2_table(13257) := '732E7374796C6553656C656374456C656D656E7428297D696E69745374796C65536865657428297B636F6E737420653D5B5D3B746869732E7374796C65732E6C697374466F6375734261636B67726F756E642626652E7075736828602E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(13258) := '73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F';
wwv_flow_imp.g_varchar2_table(13259) := '6375736564207B206261636B67726F756E642D636F6C6F723A20247B746869732E7374796C65732E6C697374466F6375734261636B67726F756E647D2021696D706F7274616E743B207D60292C746869732E7374796C65732E6C697374466F637573466F';
wwv_flow_imp.g_varchar2_table(13260) := '726567726F756E642626652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(13261) := '6F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B20636F6C6F723A20247B746869732E7374796C65732E6C697374466F637573466F726567726F756E647D2021696D706F7274616E743B207D60292C746869732E737479';
wwv_flow_imp.g_varchar2_table(13262) := '6C65732E6465636F7261746F725269676874466F726567726F756E642626652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C';
wwv_flow_imp.g_varchar2_table(13263) := '6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A6E6F74282E666F637573656429202E6F7074696F6E2D6465636F7261746F722D7269676874207B20636F6C6F723A20247B746869732E7374';
wwv_flow_imp.g_varchar2_table(13264) := '796C65732E6465636F7261746F725269676874466F726567726F756E647D3B207D60292C746869732E7374796C65732E73656C6563744261636B67726F756E642626746869732E7374796C65732E73656C656374426F726465722626746869732E737479';
wwv_flow_imp.g_varchar2_table(13265) := '6C65732E73656C656374426F72646572213D3D746869732E7374796C65732E73656C6563744261636B67726F756E643F28652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572207B20626F72';
wwv_flow_imp.g_varchar2_table(13266) := '6465723A2031707820736F6C696420247B746869732E7374796C65732E73656C656374426F726465727D207D2060292C652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C';
wwv_flow_imp.g_varchar2_table(13267) := '6563742D626F782D64657461696C732D70616E652E626F726465722D746F70207B20626F726465722D746F703A2031707820736F6C696420247B746869732E7374796C65732E73656C656374426F726465727D207D2060292C652E7075736828602E6D6F';
wwv_flow_imp.g_varchar2_table(13268) := '6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64657461696C732D70616E652E626F726465722D626F74746F6D207B20626F726465722D626F74746F6D3A2031707820736F6C';
wwv_flow_imp.g_varchar2_table(13269) := '696420247B746869732E7374796C65732E73656C656374426F726465727D207D206029293A746869732E7374796C65732E73656C6563744C697374426F72646572262628652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F7064';
wwv_flow_imp.g_varchar2_table(13270) := '6F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64657461696C732D70616E652E626F726465722D746F70207B20626F726465722D746F703A2031707820736F6C696420247B746869732E7374796C65732E73656C6563744C697374';
wwv_flow_imp.g_varchar2_table(13271) := '426F726465727D207D2060292C652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64657461696C732D70616E652E626F726465722D626F74746F6D20';
wwv_flow_imp.g_varchar2_table(13272) := '7B20626F726465722D626F74746F6D3A2031707820736F6C696420247B746869732E7374796C65732E73656C6563744C697374426F726465727D207D206029292C746869732E7374796C65732E6C697374486F766572466F726567726F756E642626652E';
wwv_flow_imp.g_varchar2_table(13273) := '7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(13274) := '636F2D6C6973742D726F773A6E6F74282E6F7074696F6E2D64697361626C6564293A6E6F74282E666F6375736564293A686F766572207B20636F6C6F723A20247B746869732E7374796C65732E6C697374486F766572466F726567726F756E647D202169';
wwv_flow_imp.g_varchar2_table(13275) := '6D706F7274616E743B207D60292C746869732E7374796C65732E6C697374486F7665724261636B67726F756E642626652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C65';
wwv_flow_imp.g_varchar2_table(13276) := '63742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A6E6F74282E6F7074696F6E2D64697361626C6564293A6E6F74282E666F6375736564293A686F76';
wwv_flow_imp.g_varchar2_table(13277) := '6572207B206261636B67726F756E642D636F6C6F723A20247B746869732E7374796C65732E6C697374486F7665724261636B67726F756E647D2021696D706F7274616E743B207D60292C746869732E7374796C65732E6C697374466F6375734F75746C69';
wwv_flow_imp.g_varchar2_table(13278) := '6E652626652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374';
wwv_flow_imp.g_varchar2_table(13279) := '202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206F75746C696E653A20312E36707820646F7474656420247B746869732E7374796C65732E6C697374466F6375734F75746C696E657D2021696D706F7274616E743B206F75746C696E';
wwv_flow_imp.g_varchar2_table(13280) := '652D6F66667365743A202D312E3670782021696D706F7274616E743B207D60292C746869732E7374796C65732E6C697374486F7665724F75746C696E652626652E7075736828602E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D63';
wwv_flow_imp.g_varchar2_table(13281) := '6F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F773A6E6F74282E6F7074696F6E2D64697361626C6564293A6E';
wwv_flow_imp.g_varchar2_table(13282) := '6F74282E666F6375736564293A686F766572207B206F75746C696E653A20312E3670782064617368656420247B746869732E7374796C65732E6C697374486F7665724F75746C696E657D2021696D706F7274616E743B206F75746C696E652D6F66667365';
wwv_flow_imp.g_varchar2_table(13283) := '743A202D312E3670782021696D706F7274616E743B207D60292C652E7075736828222E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D';
wwv_flow_imp.g_varchar2_table(13284) := '636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E6F7074696F6E2D64697361626C65642E666F6375736564207B206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D70';
wwv_flow_imp.g_varchar2_table(13285) := '6F7274616E743B20636F6C6F723A20696E68657269742021696D706F7274616E743B206F75746C696E653A206E6F6E652021696D706F7274616E743B207D22292C652E7075736828222E6D6F6E61636F2D73656C6563742D626F782D64726F70646F776E';
wwv_flow_imp.g_varchar2_table(13286) := '2D636F6E7461696E6572203E202E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E6572202E6D6F6E61636F2D6C697374202E6D6F6E61636F2D6C6973742D726F772E6F7074696F6E2D64697361626C65643A686F766572';
wwv_flow_imp.g_varchar2_table(13287) := '207B206261636B67726F756E642D636F6C6F723A207472616E73706172656E742021696D706F7274616E743B20636F6C6F723A20696E68657269742021696D706F7274616E743B206F75746C696E653A206E6F6E652021696D706F7274616E743B207D22';
wwv_flow_imp.g_varchar2_table(13288) := '292C746869732E7374796C65456C656D656E742E74657874436F6E74656E743D652E6A6F696E28225C6E22297D7374796C6553656C656374456C656D656E7428297B76617220652C742C6E3B636F6E737420693D6E756C6C213D3D28653D746869732E73';
wwv_flow_imp.g_varchar2_table(13289) := '74796C65732E73656C6563744261636B67726F756E64292626766F69642030213D3D653F653A22222C6F3D6E756C6C213D3D28743D746869732E7374796C65732E73656C656374466F726567726F756E64292626766F69642030213D3D743F743A22222C';
wwv_flow_imp.g_varchar2_table(13290) := '733D6E756C6C213D3D286E3D746869732E7374796C65732E73656C656374426F72646572292626766F69642030213D3D6E3F6E3A22223B746869732E73656C656374456C656D656E742E7374796C652E6261636B67726F756E64436F6C6F723D692C7468';
wwv_flow_imp.g_varchar2_table(13291) := '69732E73656C656374456C656D656E742E7374796C652E636F6C6F723D6F2C746869732E73656C656374456C656D656E742E7374796C652E626F72646572436F6C6F723D737D7374796C654C69737428297B76617220652C743B636F6E7374206E3D6E75';
wwv_flow_imp.g_varchar2_table(13292) := '6C6C213D3D28653D746869732E7374796C65732E73656C6563744261636B67726F756E64292626766F69642030213D3D653F653A22222C693D6B7228746869732E7374796C65732E73656C6563744C6973744261636B67726F756E642C6E293B74686973';
wwv_flow_imp.g_varchar2_table(13293) := '2E73656C65637444726F70446F776E4C697374436F6E7461696E65722E7374796C652E6261636B67726F756E64436F6C6F723D692C746869732E73656C656374696F6E44657461696C7350616E652E7374796C652E6261636B67726F756E64436F6C6F72';
wwv_flow_imp.g_varchar2_table(13294) := '3D693B636F6E7374206F3D6E756C6C213D3D28743D746869732E7374796C65732E666F637573426F72646572292626766F69642030213D3D743F743A22223B746869732E73656C65637444726F70446F776E436F6E7461696E65722E7374796C652E6F75';
wwv_flow_imp.g_varchar2_table(13295) := '746C696E65436F6C6F723D6F2C746869732E73656C65637444726F70446F776E436F6E7461696E65722E7374796C652E6F75746C696E654F66667365743D222D317078222C746869732E73656C6563744C6973742E7374796C6528746869732E7374796C';
wwv_flow_imp.g_varchar2_table(13296) := '6573297D6372656174654F7074696F6E28652C742C6E297B636F6E737420693D646F63756D656E742E637265617465456C656D656E7428226F7074696F6E22293B72657475726E20692E76616C75653D652C692E746578743D652C692E64697361626C65';
wwv_flow_imp.g_varchar2_table(13297) := '643D21216E2C697D73686F7753656C65637444726F70446F776E28297B746869732E73656C656374696F6E44657461696C7350616E652E696E6E6572546578743D22222C746869732E636F6E746578745669657750726F7669646572262621746869732E';
wwv_flow_imp.g_varchar2_table(13298) := '5F697356697369626C65262628746869732E63726561746553656C6563744C69737428746869732E73656C65637444726F70446F776E436F6E7461696E6572292C746869732E7365744F7074696F6E734C69737428292C746869732E636F6E7465787456';
wwv_flow_imp.g_varchar2_table(13299) := '69657750726F76696465722E73686F77436F6E7465787456696577287B676574416E63686F723A28293D3E746869732E73656C656374456C656D656E742C72656E6465723A653D3E746869732E72656E64657253656C65637444726F70446F776E28652C';
wwv_flow_imp.g_varchar2_table(13300) := '2130292C6C61796F75743A28293D3E7B746869732E6C61796F757453656C65637444726F70446F776E28297D2C6F6E486964653A28293D3E7B746869732E73656C65637444726F70446F776E436F6E7461696E65722E636C6173734C6973742E72656D6F';
wwv_flow_imp.g_varchar2_table(13301) := '7665282276697369626C6522292C746869732E73656C656374456C656D656E742E636C6173734C6973742E72656D6F7665282273796E7468657469632D666F63757322297D2C616E63686F72506F736974696F6E3A746869732E5F64726F70446F776E50';
wwv_flow_imp.g_varchar2_table(13302) := '6F736974696F6E7D2C746869732E73656C656374426F784F7074696F6E732E6F7074696F6E7341734368696C6472656E3F746869732E636F6E7461696E65723A766F69642030292C746869732E5F697356697369626C653D21302C746869732E68696465';
wwv_flow_imp.g_varchar2_table(13303) := '53656C65637444726F70446F776E282131292C746869732E636F6E746578745669657750726F76696465722E73686F77436F6E7465787456696577287B676574416E63686F723A28293D3E746869732E73656C656374456C656D656E742C72656E646572';
wwv_flow_imp.g_varchar2_table(13304) := '3A653D3E746869732E72656E64657253656C65637444726F70446F776E2865292C6C61796F75743A28293D3E746869732E6C61796F757453656C65637444726F70446F776E28292C6F6E486964653A28293D3E7B746869732E73656C65637444726F7044';
wwv_flow_imp.g_varchar2_table(13305) := '6F776E436F6E7461696E65722E636C6173734C6973742E72656D6F7665282276697369626C6522292C746869732E73656C656374456C656D656E742E636C6173734C6973742E72656D6F7665282273796E7468657469632D666F63757322297D2C616E63';
wwv_flow_imp.g_varchar2_table(13306) := '686F72506F736974696F6E3A746869732E5F64726F70446F776E506F736974696F6E7D2C746869732E73656C656374426F784F7074696F6E732E6F7074696F6E7341734368696C6472656E3F746869732E636F6E7461696E65723A766F69642030292C74';
wwv_flow_imp.g_varchar2_table(13307) := '6869732E5F63757272656E7453656C656374696F6E3D746869732E73656C65637465642C746869732E5F697356697369626C653D21302C746869732E73656C656374456C656D656E742E7365744174747269627574652822617269612D657870616E6465';
wwv_flow_imp.g_varchar2_table(13308) := '64222C22747275652229297D6869646553656C65637444726F70446F776E2865297B746869732E636F6E746578745669657750726F76696465722626746869732E5F697356697369626C65262628746869732E5F697356697369626C653D21312C746869';
wwv_flow_imp.g_varchar2_table(13309) := '732E73656C656374456C656D656E742E7365744174747269627574652822617269612D657870616E646564222C2266616C736522292C652626746869732E73656C656374456C656D656E742E666F63757328292C746869732E636F6E7465787456696577';
wwv_flow_imp.g_varchar2_table(13310) := '50726F76696465722E68696465436F6E74657874566965772829297D72656E64657253656C65637444726F70446F776E28652C74297B72657475726E20652E617070656E644368696C6428746869732E73656C65637444726F70446F776E436F6E746169';
wwv_flow_imp.g_varchar2_table(13311) := '6E6572292C746869732E6C61796F757453656C65637444726F70446F776E2874292C7B646973706F73653A28293D3E7B7472797B652E72656D6F76654368696C6428746869732E73656C65637444726F70446F776E436F6E7461696E6572297D63617463';
wwv_flow_imp.g_varchar2_table(13312) := '682865297B7D7D7D7D6D6561737572654D617844657461696C7348656967687428297B6C657420653D303B72657475726E20746869732E6F7074696F6E732E666F7245616368282828742C6E293D3E7B746869732E75706461746544657461696C286E29';
wwv_flow_imp.g_varchar2_table(13313) := '2C746869732E73656C656374696F6E44657461696C7350616E652E6F66667365744865696768743E65262628653D746869732E73656C656374696F6E44657461696C7350616E652E6F6666736574486569676874297D29292C657D6C61796F757453656C';
wwv_flow_imp.g_varchar2_table(13314) := '65637444726F70446F776E2865297B696628746869732E5F736B69704C61796F75742972657475726E21313B696628746869732E73656C6563744C697374297B746869732E73656C65637444726F70446F776E436F6E7461696E65722E636C6173734C69';
wwv_flow_imp.g_varchar2_table(13315) := '73742E616464282276697369626C6522293B636F6E737420743D727328746869732E73656C656374456C656D656E74292C6E3D417328746869732E73656C656374456C656D656E74292C693D727328746869732E73656C656374456C656D656E74292E67';
wwv_flow_imp.g_varchar2_table(13316) := '6574436F6D70757465645374796C6528746869732E73656C656374456C656D656E74292C6F3D7061727365466C6F617428692E67657450726F706572747956616C756528222D2D64726F70646F776E2D70616464696E672D746F702229292B7061727365';
wwv_flow_imp.g_varchar2_table(13317) := '466C6F617428692E67657450726F706572747956616C756528222D2D64726F70646F776E2D70616464696E672D626F74746F6D2229292C733D742E696E6E65724865696768742D6E2E746F702D6E2E6865696768742D28746869732E73656C656374426F';
wwv_flow_imp.g_varchar2_table(13318) := '784F7074696F6E732E6D696E426F74746F6D4D617267696E7C7C30292C723D6E2E746F702D58492E44454641554C545F44524F50444F574E5F4D494E494D554D5F544F505F4D415247494E2C613D746869732E73656C656374456C656D656E742E6F6666';
wwv_flow_imp.g_varchar2_table(13319) := '73657457696474682C6C3D746869732E7365745769647468436F6E74726F6C456C656D656E7428746869732E7769647468436F6E74726F6C456C656D656E74292C633D4D6174682E6D6178286C2C4D6174682E726F756E64286129292E746F537472696E';
wwv_flow_imp.g_varchar2_table(13320) := '6728292B227078223B746869732E73656C65637444726F70446F776E436F6E7461696E65722E7374796C652E77696474683D632C746869732E73656C6563744C6973742E67657448544D4C456C656D656E7428292E7374796C652E6865696768743D2222';
wwv_flow_imp.g_varchar2_table(13321) := '2C746869732E73656C6563744C6973742E6C61796F757428293B6C657420643D746869732E73656C6563744C6973742E636F6E74656E744865696768743B746869732E5F68617344657461696C732626766F696420303D3D3D746869732E5F6361636865';
wwv_flow_imp.g_varchar2_table(13322) := '644D617844657461696C73486569676874262628746869732E5F6361636865644D617844657461696C734865696768743D746869732E6D6561737572654D617844657461696C734865696768742829293B636F6E737420683D746869732E5F6861734465';
wwv_flow_imp.g_varchar2_table(13323) := '7461696C733F746869732E5F6361636865644D617844657461696C734865696768743A302C753D642B6F2B682C703D4D6174682E666C6F6F722828732D6F2D68292F746869732E6765744865696768742829292C673D4D6174682E666C6F6F722828722D';
wwv_flow_imp.g_varchar2_table(13324) := '6F2D68292F746869732E6765744865696768742829293B696628652972657475726E21286E2E746F702B6E2E6865696768743E742E696E6E65724865696768742D32327C7C6E2E746F703C58492E44454641554C545F44524F50444F574E5F4D494E494D';
wwv_flow_imp.g_varchar2_table(13325) := '554D5F544F505F4D415247494E7C7C703C312626673C317C7C28703C58492E44454641554C545F4D494E494D554D5F56495349424C455F4F5054494F4E532626673E702626746869732E6F7074696F6E732E6C656E6774683E703F28746869732E5F6472';
wwv_flow_imp.g_varchar2_table(13326) := '6F70446F776E506F736974696F6E3D312C746869732E73656C65637444726F70446F776E436F6E7461696E65722E72656D6F76654368696C6428746869732E73656C65637444726F70446F776E4C697374436F6E7461696E6572292C746869732E73656C';
wwv_flow_imp.g_varchar2_table(13327) := '65637444726F70446F776E436F6E7461696E65722E72656D6F76654368696C6428746869732E73656C656374696F6E44657461696C7350616E65292C746869732E73656C65637444726F70446F776E436F6E7461696E65722E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(13328) := '28746869732E73656C656374696F6E44657461696C7350616E65292C746869732E73656C65637444726F70446F776E436F6E7461696E65722E617070656E644368696C6428746869732E73656C65637444726F70446F776E4C697374436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(13329) := '72292C746869732E73656C656374696F6E44657461696C7350616E652E636C6173734C6973742E72656D6F76652822626F726465722D746F7022292C746869732E73656C656374696F6E44657461696C7350616E652E636C6173734C6973742E61646428';
wwv_flow_imp.g_varchar2_table(13330) := '22626F726465722D626F74746F6D2229293A28746869732E5F64726F70446F776E506F736974696F6E3D302C746869732E73656C65637444726F70446F776E436F6E7461696E65722E72656D6F76654368696C6428746869732E73656C65637444726F70';
wwv_flow_imp.g_varchar2_table(13331) := '446F776E4C697374436F6E7461696E6572292C746869732E73656C65637444726F70446F776E436F6E7461696E65722E72656D6F76654368696C6428746869732E73656C656374696F6E44657461696C7350616E65292C746869732E73656C6563744472';
wwv_flow_imp.g_varchar2_table(13332) := '6F70446F776E436F6E7461696E65722E617070656E644368696C6428746869732E73656C65637444726F70446F776E4C697374436F6E7461696E6572292C746869732E73656C65637444726F70446F776E436F6E7461696E65722E617070656E64436869';
wwv_flow_imp.g_varchar2_table(13333) := '6C6428746869732E73656C656374696F6E44657461696C7350616E65292C746869732E73656C656374696F6E44657461696C7350616E652E636C6173734C6973742E72656D6F76652822626F726465722D626F74746F6D22292C746869732E73656C6563';
wwv_flow_imp.g_varchar2_table(13334) := '74696F6E44657461696C7350616E652E636C6173734C6973742E6164642822626F726465722D746F702229292C3029293B6966286E2E746F702B6E2E6865696768743E742E696E6E65724865696768742D32327C7C6E2E746F703C58492E44454641554C';
wwv_flow_imp.g_varchar2_table(13335) := '545F44524F50444F574E5F4D494E494D554D5F544F505F4D415247494E7C7C303D3D3D746869732E5F64726F70446F776E506F736974696F6E2626703C317C7C313D3D3D746869732E5F64726F70446F776E506F736974696F6E2626673C312972657475';
wwv_flow_imp.g_varchar2_table(13336) := '726E20746869732E6869646553656C65637444726F70446F776E282130292C21313B696628303D3D3D746869732E5F64726F70446F776E506F736974696F6E297B696628746869732E5F697356697369626C652626702B673C312972657475726E207468';
wwv_flow_imp.g_varchar2_table(13337) := '69732E6869646553656C65637444726F70446F776E282130292C21313B753E73262628643D702A746869732E6765744865696768742829297D656C736520753E72262628643D672A746869732E6765744865696768742829293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(13338) := '732E73656C6563744C6973742E6C61796F75742864292C746869732E73656C6563744C6973742E646F6D466F63757328292C746869732E73656C6563744C6973742E6C656E6774683E30262628746869732E73656C6563744C6973742E736574466F6375';
wwv_flow_imp.g_varchar2_table(13339) := '73285B746869732E73656C65637465647C7C305D292C746869732E73656C6563744C6973742E72657665616C28746869732E73656C6563744C6973742E676574466F63757328295B305D7C7C3029292C746869732E5F68617344657461696C733F287468';
wwv_flow_imp.g_varchar2_table(13340) := '69732E73656C6563744C6973742E67657448544D4C456C656D656E7428292E7374796C652E6865696768743D642B6F2B227078222C746869732E73656C65637444726F70446F776E436F6E7461696E65722E7374796C652E6865696768743D2222293A74';
wwv_flow_imp.g_varchar2_table(13341) := '6869732E73656C65637444726F70446F776E436F6E7461696E65722E7374796C652E6865696768743D642B6F2B227078222C746869732E75706461746544657461696C28746869732E73656C6563746564292C746869732E73656C65637444726F70446F';
wwv_flow_imp.g_varchar2_table(13342) := '776E436F6E7461696E65722E7374796C652E77696474683D632C746869732E73656C65637444726F70446F776E4C697374436F6E7461696E65722E7365744174747269627574652822746162696E646578222C223022292C746869732E73656C65637445';
wwv_flow_imp.g_varchar2_table(13343) := '6C656D656E742E636C6173734C6973742E616464282273796E7468657469632D666F63757322292C746869732E73656C65637444726F70446F776E436F6E7461696E65722E636C6173734C6973742E616464282273796E7468657469632D666F63757322';
wwv_flow_imp.g_varchar2_table(13344) := '292C21307D72657475726E21317D7365745769647468436F6E74726F6C456C656D656E742865297B6C657420743D303B69662865297B6C6574206E3D302C693D303B746869732E6F7074696F6E732E666F7245616368282828652C74293D3E7B636F6E73';
wwv_flow_imp.g_varchar2_table(13345) := '74206F3D652E64657461696C3F652E64657461696C2E6C656E6774683A302C733D652E6465636F7261746F7252696768743F652E6465636F7261746F7252696768742E6C656E6774683A302C723D652E746578742E6C656E6774682B6F2B733B723E6926';
wwv_flow_imp.g_varchar2_table(13346) := '26286E3D742C693D72297D29292C652E74657874436F6E74656E743D746869732E6F7074696F6E735B6E5D2E746578742B28746869732E6F7074696F6E735B6E5D2E6465636F7261746F7252696768743F746869732E6F7074696F6E735B6E5D2E646563';
wwv_flow_imp.g_varchar2_table(13347) := '6F7261746F7252696768742B2220223A2222292C743D50732865297D72657475726E20747D63726561746553656C6563744C6973742865297B696628746869732E73656C6563744C6973742972657475726E3B746869732E73656C65637444726F70446F';
wwv_flow_imp.g_varchar2_table(13348) := '776E4C697374436F6E7461696E65723D757228652C514928222E73656C6563742D626F782D64726F70646F776E2D6C6973742D636F6E7461696E65722229292C746869732E6C69737452656E64657265723D6E6577205A492C746869732E73656C656374';
wwv_flow_imp.g_varchar2_table(13349) := '4C6973743D6E6577205549282253656C656374426F78437573746F6D222C746869732E73656C65637444726F70446F776E4C697374436F6E7461696E65722C746869732C5B746869732E6C69737452656E64657265725D2C7B757365536861646F77733A';
wwv_flow_imp.g_varchar2_table(13350) := '21312C766572746963616C5363726F6C6C4D6F64653A332C6B6579626F617264537570706F72743A21312C6D6F757365537570706F72743A21312C6163636573736962696C69747950726F76696465723A7B676574417269614C6162656C3A653D3E7B6C';
wwv_flow_imp.g_varchar2_table(13351) := '657420743D652E746578743B72657475726E20652E64657461696C262628742B3D602E20247B652E64657461696C7D60292C652E6465636F7261746F725269676874262628742B3D602E20247B652E6465636F7261746F7252696768747D60292C652E64';
wwv_flow_imp.g_varchar2_table(13352) := '65736372697074696F6E262628742B3D602E20247B652E6465736372697074696F6E7D60292C747D2C676574576964676574417269614C6162656C3A28293D3E6228302C2253656C65637420426F7822292C676574526F6C653A28293D3E713F22223A22';
wwv_flow_imp.g_varchar2_table(13353) := '6F7074696F6E222C676574576964676574526F6C653A28293D3E226C697374626F78227D7D292C746869732E73656C656374426F784F7074696F6E732E617269614C6162656C262628746869732E73656C6563744C6973742E617269614C6162656C3D74';
wwv_flow_imp.g_varchar2_table(13354) := '6869732E73656C656374426F784F7074696F6E732E617269614C6162656C293B636F6E737420743D746869732E5F7265676973746572286E6577204B5328746869732E73656C65637444726F70446F776E4C697374436F6E7461696E65722C226B657964';
wwv_flow_imp.g_varchar2_table(13355) := '6F776E2229292C6E3D76742E636861696E28742E6576656E742C28653D3E652E66696C746572282828293D3E746869732E73656C6563744C6973742E6C656E6774683E3029292E6D61702828653D3E6E6577207165286529292929293B746869732E5F72';
wwv_flow_imp.g_varchar2_table(13356) := '656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E333D3D3D652E6B6579436F64652929292928746869732E6F6E456E7465722C7468697329292C746869732E5F72656769737465722876742E636861696E286E2C';
wwv_flow_imp.g_varchar2_table(13357) := '28653D3E652E66696C7465722828653D3E323D3D3D652E6B6579436F64652929292928746869732E6F6E456E7465722C7468697329292C746869732E5F72656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E393D';
wwv_flow_imp.g_varchar2_table(13358) := '3D3D652E6B6579436F64652929292928746869732E6F6E4573636170652C7468697329292C746869732E5F72656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E31363D3D3D652E6B6579436F6465292929292874';
wwv_flow_imp.g_varchar2_table(13359) := '6869732E6F6E55704172726F772C7468697329292C746869732E5F72656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E31383D3D3D652E6B6579436F64652929292928746869732E6F6E446F776E4172726F772C';
wwv_flow_imp.g_varchar2_table(13360) := '7468697329292C746869732E5F72656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E31323D3D3D652E6B6579436F64652929292928746869732E6F6E50616765446F776E2C7468697329292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(13361) := '6769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E31313D3D3D652E6B6579436F64652929292928746869732E6F6E5061676555702C7468697329292C746869732E5F72656769737465722876742E636861696E286E';
wwv_flow_imp.g_varchar2_table(13362) := '2C28653D3E652E66696C7465722828653D3E31343D3D3D652E6B6579436F64652929292928746869732E6F6E486F6D652C7468697329292C746869732E5F72656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E31';
wwv_flow_imp.g_varchar2_table(13363) := '333D3D3D652E6B6579436F64652929292928746869732E6F6E456E642C7468697329292C746869732E5F72656769737465722876742E636861696E286E2C28653D3E652E66696C7465722828653D3E652E6B6579436F64653E3D32312626652E6B657943';
wwv_flow_imp.g_varchar2_table(13364) := '6F64653C3D35367C7C652E6B6579436F64653E3D38352626652E6B6579436F64653C3D3131332929292928746869732E6F6E4368617261637465722C7468697329292C746869732E5F726567697374657228627328746869732E73656C6563744C697374';
wwv_flow_imp.g_varchar2_table(13365) := '2E67657448544D4C456C656D656E7428292C61722E504F494E5445525F55502C28653D3E746869732E6F6E506F696E74657255702865292929292C746869732E5F726567697374657228746869732E73656C6563744C6973742E6F6E4D6F7573654F7665';
wwv_flow_imp.g_varchar2_table(13366) := '722828653D3E766F69642030213D3D652E696E6465782626746869732E73656C6563744C6973742E736574466F637573285B652E696E6465785D292929292C746869732E5F726567697374657228746869732E73656C6563744C6973742E6F6E44696443';
wwv_flow_imp.g_varchar2_table(13367) := '68616E6765466F6375732828653D3E746869732E6F6E4C697374466F6375732865292929292C746869732E5F726567697374657228627328746869732E73656C65637444726F70446F776E436F6E7461696E65722C61722E464F4355535F4F55542C2865';
wwv_flow_imp.g_varchar2_table(13368) := '3D3E7B746869732E5F697356697369626C65262621427328652E72656C617465645461726765742C746869732E73656C65637444726F70446F776E436F6E7461696E6572292626746869732E6F6E4C697374426C757228297D2929292C746869732E7365';
wwv_flow_imp.g_varchar2_table(13369) := '6C6563744C6973742E67657448544D4C456C656D656E7428292E7365744174747269627574652822617269612D6C6162656C222C746869732E73656C656374426F784F7074696F6E732E617269614C6162656C7C7C2222292C746869732E73656C656374';
wwv_flow_imp.g_varchar2_table(13370) := '4C6973742E67657448544D4C456C656D656E7428292E7365744174747269627574652822617269612D657870616E646564222C227472756522292C746869732E7374796C654C69737428297D6F6E506F696E74657255702865297B69662821746869732E';
wwv_flow_imp.g_varchar2_table(13371) := '73656C6563744C6973742E6C656E6774682972657475726E3B63722865293B636F6E737420743D652E7461726765743B69662821742972657475726E3B696628742E636C6173734C6973742E636F6E7461696E732822736C696465722229297265747572';
wwv_flow_imp.g_varchar2_table(13372) := '6E3B636F6E7374206E3D742E636C6F7365737428222E6D6F6E61636F2D6C6973742D726F7722293B696628216E2972657475726E3B636F6E737420693D4E756D626572286E2E6765744174747269627574652822646174612D696E6465782229292C6F3D';
wwv_flow_imp.g_varchar2_table(13373) := '6E2E636C6173734C6973742E636F6E7461696E7328226F7074696F6E2D64697361626C656422293B693E3D302626693C746869732E6F7074696F6E732E6C656E6774682626216F262628746869732E73656C65637465643D692C746869732E73656C6563';
wwv_flow_imp.g_varchar2_table(13374) := '7428746869732E73656C6563746564292C746869732E73656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D292C746869732E73656C6563744C6973742E72657665616C28746869732E73656C6563744C6973742E6765';
wwv_flow_imp.g_varchar2_table(13375) := '74466F63757328295B305D292C746869732E73656C6563746564213D3D746869732E5F63757272656E7453656C656374696F6E262628746869732E5F63757272656E7453656C656374696F6E3D746869732E73656C65637465642C746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(13376) := '696453656C6563742E66697265287B696E6465783A746869732E73656C656374456C656D656E742E73656C6563746564496E6465782C73656C65637465643A746869732E6F7074696F6E735B746869732E73656C65637465645D2E746578747D292C7468';
wwv_flow_imp.g_varchar2_table(13377) := '69732E6F7074696F6E735B746869732E73656C65637465645D2626746869732E6F7074696F6E735B746869732E73656C65637465645D2E746578742626746869732E7365745469746C6528746869732E6F7074696F6E735B746869732E73656C65637465';
wwv_flow_imp.g_varchar2_table(13378) := '645D2E7465787429292C746869732E6869646553656C65637444726F70446F776E28213029297D6F6E4C697374426C757228297B746869732E5F737469636B797C7C28746869732E73656C6563746564213D3D746869732E5F63757272656E7453656C65';
wwv_flow_imp.g_varchar2_table(13379) := '6374696F6E2626746869732E73656C65637428746869732E5F63757272656E7453656C656374696F6E292C746869732E6869646553656C65637444726F70446F776E28213129297D72656E6465724465736372697074696F6E4D61726B646F776E28652C';
wwv_flow_imp.g_varchar2_table(13380) := '74297B636F6E7374206E3D653D3E7B666F72286C657420743D303B743C652E6368696C644E6F6465732E6C656E6774683B742B2B297B636F6E737420693D652E6368696C644E6F6465732E6974656D2874293B22696D67223D3D3D28692E7461674E616D';
wwv_flow_imp.g_varchar2_table(13381) := '652626692E7461674E616D652E746F4C6F776572436173652829293F652E72656D6F76654368696C642869293A6E2869297D7D2C693D4E6B287B76616C75653A652C737570706F72745468656D6549636F6E733A21307D2C7B616374696F6E48616E646C';
wwv_flow_imp.g_varchar2_table(13382) := '65723A747D293B72657475726E20692E656C656D656E742E636C6173734C6973742E616464282273656C6563742D626F782D6465736372697074696F6E2D6D61726B646F776E22292C6E28692E656C656D656E74292C692E656C656D656E747D6F6E4C69';
wwv_flow_imp.g_varchar2_table(13383) := '7374466F6375732865297B746869732E5F697356697369626C652626746869732E5F68617344657461696C732626746869732E75706461746544657461696C28652E696E64657865735B305D297D75706461746544657461696C2865297B76617220742C';
wwv_flow_imp.g_varchar2_table(13384) := '6E3B746869732E73656C656374696F6E44657461696C7350616E652E696E6E6572546578743D22223B636F6E737420693D746869732E6F7074696F6E735B655D2C6F3D6E756C6C213D3D28743D6E756C6C3D3D693F766F696420303A692E646573637269';
wwv_flow_imp.g_varchar2_table(13385) := '7074696F6E292626766F69642030213D3D743F743A22222C733D6E756C6C213D3D286E3D6E756C6C3D3D693F766F696420303A692E6465736372697074696F6E49734D61726B646F776E292626766F69642030213D3D6E26266E3B6966286F297B696628';
wwv_flow_imp.g_varchar2_table(13386) := '73297B636F6E737420653D692E6465736372697074696F6E4D61726B646F776E416374696F6E48616E646C65723B746869732E73656C656374696F6E44657461696C7350616E652E617070656E644368696C6428746869732E72656E6465724465736372';
wwv_flow_imp.g_varchar2_table(13387) := '697074696F6E4D61726B646F776E286F2C6529297D656C736520746869732E73656C656374696F6E44657461696C7350616E652E696E6E6572546578743D6F3B746869732E73656C656374696F6E44657461696C7350616E652E7374796C652E64697370';
wwv_flow_imp.g_varchar2_table(13388) := '6C61793D22626C6F636B227D656C736520746869732E73656C656374696F6E44657461696C7350616E652E7374796C652E646973706C61793D226E6F6E65223B746869732E5F736B69704C61796F75743D21302C746869732E636F6E7465787456696577';
wwv_flow_imp.g_varchar2_table(13389) := '50726F76696465722E6C61796F757428292C746869732E5F736B69704C61796F75743D21317D6F6E4573636170652865297B63722865292C746869732E73656C65637428746869732E5F63757272656E7453656C656374696F6E292C746869732E686964';
wwv_flow_imp.g_varchar2_table(13390) := '6553656C65637444726F70446F776E282130297D6F6E456E7465722865297B63722865292C746869732E73656C6563746564213D3D746869732E5F63757272656E7453656C656374696F6E262628746869732E5F63757272656E7453656C656374696F6E';
wwv_flow_imp.g_varchar2_table(13391) := '3D746869732E73656C65637465642C746869732E5F6F6E44696453656C6563742E66697265287B696E6465783A746869732E73656C656374456C656D656E742E73656C6563746564496E6465782C73656C65637465643A746869732E6F7074696F6E735B';
wwv_flow_imp.g_varchar2_table(13392) := '746869732E73656C65637465645D2E746578747D292C746869732E6F7074696F6E735B746869732E73656C65637465645D2626746869732E6F7074696F6E735B746869732E73656C65637465645D2E746578742626746869732E7365745469746C652874';
wwv_flow_imp.g_varchar2_table(13393) := '6869732E6F7074696F6E735B746869732E73656C65637465645D2E7465787429292C746869732E6869646553656C65637444726F70446F776E282130297D6F6E446F776E4172726F772865297B696628746869732E73656C65637465643C746869732E6F';
wwv_flow_imp.g_varchar2_table(13394) := '7074696F6E732E6C656E6774682D31297B637228652C2130293B636F6E737420743D746869732E6F7074696F6E735B746869732E73656C65637465642B315D2E697344697361626C65643B696628742626746869732E6F7074696F6E732E6C656E677468';
wwv_flow_imp.g_varchar2_table(13395) := '3E746869732E73656C65637465642B3229746869732E73656C65637465642B3D323B656C73657B696628742972657475726E3B746869732E73656C65637465642B2B7D746869732E73656C65637428746869732E73656C6563746564292C746869732E73';
wwv_flow_imp.g_varchar2_table(13396) := '656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D292C746869732E73656C6563744C6973742E72657665616C28746869732E73656C6563744C6973742E676574466F63757328295B305D297D7D6F6E55704172726F77';
wwv_flow_imp.g_varchar2_table(13397) := '2865297B746869732E73656C65637465643E30262628637228652C2130292C746869732E6F7074696F6E735B746869732E73656C65637465642D315D2E697344697361626C65642626746869732E73656C65637465643E313F746869732E73656C656374';
wwv_flow_imp.g_varchar2_table(13398) := '65642D3D323A746869732E73656C65637465642D2D2C746869732E73656C65637428746869732E73656C6563746564292C746869732E73656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D292C746869732E73656C65';
wwv_flow_imp.g_varchar2_table(13399) := '63744C6973742E72657665616C28746869732E73656C6563744C6973742E676574466F63757328295B305D29297D6F6E5061676555702865297B63722865292C746869732E73656C6563744C6973742E666F63757350726576696F75735061676528292C';
wwv_flow_imp.g_varchar2_table(13400) := '73657454696D656F7574282828293D3E7B746869732E73656C65637465643D746869732E73656C6563744C6973742E676574466F63757328295B305D2C746869732E6F7074696F6E735B746869732E73656C65637465645D2E697344697361626C656426';
wwv_flow_imp.g_varchar2_table(13401) := '26746869732E73656C65637465643C746869732E6F7074696F6E732E6C656E6774682D31262628746869732E73656C65637465642B2B2C746869732E73656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D29292C7468';
wwv_flow_imp.g_varchar2_table(13402) := '69732E73656C6563744C6973742E72657665616C28746869732E73656C6563746564292C746869732E73656C65637428746869732E73656C6563746564297D292C31297D6F6E50616765446F776E2865297B63722865292C746869732E73656C6563744C';
wwv_flow_imp.g_varchar2_table(13403) := '6973742E666F6375734E6578745061676528292C73657454696D656F7574282828293D3E7B746869732E73656C65637465643D746869732E73656C6563744C6973742E676574466F63757328295B305D2C746869732E6F7074696F6E735B746869732E73';
wwv_flow_imp.g_varchar2_table(13404) := '656C65637465645D2E697344697361626C65642626746869732E73656C65637465643E30262628746869732E73656C65637465642D2D2C746869732E73656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D29292C7468';
wwv_flow_imp.g_varchar2_table(13405) := '69732E73656C6563744C6973742E72657665616C28746869732E73656C6563746564292C746869732E73656C65637428746869732E73656C6563746564297D292C31297D6F6E486F6D652865297B63722865292C746869732E6F7074696F6E732E6C656E';
wwv_flow_imp.g_varchar2_table(13406) := '6774683C327C7C28746869732E73656C65637465643D302C746869732E6F7074696F6E735B746869732E73656C65637465645D2E697344697361626C65642626746869732E73656C65637465643E312626746869732E73656C65637465642B2B2C746869';
wwv_flow_imp.g_varchar2_table(13407) := '732E73656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D292C746869732E73656C6563744C6973742E72657665616C28746869732E73656C6563746564292C746869732E73656C65637428746869732E73656C656374';
wwv_flow_imp.g_varchar2_table(13408) := '656429297D6F6E456E642865297B63722865292C746869732E6F7074696F6E732E6C656E6774683C327C7C28746869732E73656C65637465643D746869732E6F7074696F6E732E6C656E6774682D312C746869732E6F7074696F6E735B746869732E7365';
wwv_flow_imp.g_varchar2_table(13409) := '6C65637465645D2E697344697361626C65642626746869732E73656C65637465643E312626746869732E73656C65637465642D2D2C746869732E73656C6563744C6973742E736574466F637573285B746869732E73656C65637465645D292C746869732E';
wwv_flow_imp.g_varchar2_table(13410) := '73656C6563744C6973742E72657665616C28746869732E73656C6563746564292C746869732E73656C65637428746869732E73656C656374656429297D6F6E4368617261637465722865297B636F6E737420743D43652E746F537472696E6728652E6B65';
wwv_flow_imp.g_varchar2_table(13411) := '79436F6465293B6C6574206E3D2D313B666F72286C657420693D303B693C746869732E6F7074696F6E732E6C656E6774682D313B692B2B296966286E3D28692B746869732E73656C65637465642B312925746869732E6F7074696F6E732E6C656E677468';
wwv_flow_imp.g_varchar2_table(13412) := '2C746869732E6F7074696F6E735B6E5D2E746578742E6368617241742830292E746F55707065724361736528293D3D3D74262621746869732E6F7074696F6E735B6E5D2E697344697361626C6564297B746869732E73656C656374286E292C746869732E';
wwv_flow_imp.g_varchar2_table(13413) := '73656C6563744C6973742E736574466F637573285B6E5D292C746869732E73656C6563744C6973742E72657665616C28746869732E73656C6563744C6973742E676574466F63757328295B305D292C63722865293B627265616B7D7D646973706F736528';
wwv_flow_imp.g_varchar2_table(13414) := '297B746869732E6869646553656C65637444726F70446F776E282131292C73757065722E646973706F736528297D7D58492E44454641554C545F44524F50444F574E5F4D494E494D554D5F424F54544F4D5F4D415247494E3D33322C58492E4445464155';
wwv_flow_imp.g_varchar2_table(13415) := '4C545F44524F50444F574E5F4D494E494D554D5F544F505F4D415247494E3D322C58492E44454641554C545F4D494E494D554D5F56495349424C455F4F5054494F4E533D333B636C617373204A4920657874656E6473206C747B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(13416) := '7228652C742C6E2C69297B737570657228292C746869732E73656C65637465643D302C746869732E73656C656374426F784F7074696F6E733D697C7C4F626A6563742E637265617465286E756C6C292C746869732E6F7074696F6E733D5B5D2C74686973';
wwv_flow_imp.g_varchar2_table(13417) := '2E73656C656374456C656D656E743D646F63756D656E742E637265617465456C656D656E74282273656C65637422292C746869732E73656C656374456C656D656E742E636C6173734E616D653D226D6F6E61636F2D73656C6563742D626F78222C227374';
wwv_flow_imp.g_varchar2_table(13418) := '72696E67223D3D747970656F6620746869732E73656C656374426F784F7074696F6E732E617269614C6162656C2626746869732E73656C656374456C656D656E742E7365744174747269627574652822617269612D6C6162656C222C746869732E73656C';
wwv_flow_imp.g_varchar2_table(13419) := '656374426F784F7074696F6E732E617269614C6162656C292C22737472696E67223D3D747970656F6620746869732E73656C656374426F784F7074696F6E732E617269614465736372697074696F6E2626746869732E73656C656374456C656D656E742E';
wwv_flow_imp.g_varchar2_table(13420) := '7365744174747269627574652822617269612D6465736372697074696F6E222C746869732E73656C656374426F784F7074696F6E732E617269614465736372697074696F6E292C746869732E5F6F6E44696453656C6563743D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(13421) := '746572286E6577204374292C746869732E7374796C65733D6E2C746869732E72656769737465724C697374656E65727328292C746869732E7365744F7074696F6E7328652C74297D72656769737465724C697374656E65727328297B746869732E5F7265';
wwv_flow_imp.g_varchar2_table(13422) := '6769737465722849452E61646454617267657428746869732E73656C656374456C656D656E7429292C5B54452E5461705D2E666F72456163682828653D3E7B746869732E5F726567697374657228627328746869732E73656C656374456C656D656E742C';
wwv_flow_imp.g_varchar2_table(13423) := '652C28653D3E7B746869732E73656C656374456C656D656E742E666F63757328297D2929297D29292C746869732E5F726567697374657228797328746869732E73656C656374456C656D656E742C22636C69636B222C28653D3E7B637228652C2130297D';
wwv_flow_imp.g_varchar2_table(13424) := '2929292C746869732E5F726567697374657228797328746869732E73656C656374456C656D656E742C226368616E6765222C28653D3E7B746869732E73656C656374456C656D656E742E7469746C653D652E7461726765742E76616C75652C746869732E';
wwv_flow_imp.g_varchar2_table(13425) := '5F6F6E44696453656C6563742E66697265287B696E6465783A652E7461726765742E73656C6563746564496E6465782C73656C65637465643A652E7461726765742E76616C75657D297D2929292C746869732E5F72656769737465722879732874686973';
wwv_flow_imp.g_varchar2_table(13426) := '2E73656C656374456C656D656E742C226B6579646F776E222C28653D3E7B6C657420743D21313B713F3138213D3D652E6B6579436F646526263136213D3D652E6B6579436F646526263130213D3D652E6B6579436F64657C7C28743D2130293A2831383D';
wwv_flow_imp.g_varchar2_table(13427) := '3D3D652E6B6579436F64652626652E616C744B65797C7C31303D3D3D652E6B6579436F64657C7C333D3D3D652E6B6579436F646529262628743D2130292C742626652E73746F7050726F7061676174696F6E28297D2929297D676574206F6E4469645365';
wwv_flow_imp.g_varchar2_table(13428) := '6C65637428297B72657475726E20746869732E5F6F6E44696453656C6563742E6576656E747D7365744F7074696F6E7328652C74297B746869732E6F7074696F6E732626506828746869732E6F7074696F6E732C65297C7C28746869732E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(13429) := '733D652C746869732E73656C656374456C656D656E742E6F7074696F6E732E6C656E6774683D302C746869732E6F7074696F6E732E666F7245616368282828652C74293D3E7B746869732E73656C656374456C656D656E742E61646428746869732E6372';
wwv_flow_imp.g_varchar2_table(13430) := '656174654F7074696F6E28652E746578742C742C652E697344697361626C656429297D2929292C766F69642030213D3D742626746869732E73656C6563742874297D73656C6563742865297B303D3D3D746869732E6F7074696F6E732E6C656E6774683F';
wwv_flow_imp.g_varchar2_table(13431) := '746869732E73656C65637465643D303A653E3D302626653C746869732E6F7074696F6E732E6C656E6774683F746869732E73656C65637465643D653A653E746869732E6F7074696F6E732E6C656E6774682D313F746869732E73656C6563742874686973';
wwv_flow_imp.g_varchar2_table(13432) := '2E6F7074696F6E732E6C656E6774682D31293A746869732E73656C65637465643C30262628746869732E73656C65637465643D30292C746869732E73656C656374456C656D656E742E73656C6563746564496E6465783D746869732E73656C6563746564';
wwv_flow_imp.g_varchar2_table(13433) := '2C746869732E73656C65637465643C746869732E6F7074696F6E732E6C656E677468262622737472696E67223D3D747970656F6620746869732E6F7074696F6E735B746869732E73656C65637465645D2E746578743F746869732E73656C656374456C65';
wwv_flow_imp.g_varchar2_table(13434) := '6D656E742E7469746C653D746869732E6F7074696F6E735B746869732E73656C65637465645D2E746578743A746869732E73656C656374456C656D656E742E7469746C653D22227D666F63757328297B746869732E73656C656374456C656D656E742626';
wwv_flow_imp.g_varchar2_table(13435) := '28746869732E73656C656374456C656D656E742E746162496E6465783D302C746869732E73656C656374456C656D656E742E666F6375732829297D626C757228297B746869732E73656C656374456C656D656E74262628746869732E73656C656374456C';
wwv_flow_imp.g_varchar2_table(13436) := '656D656E742E746162496E6465783D2D312C746869732E73656C656374456C656D656E742E626C75722829297D736574466F63757361626C652865297B746869732E73656C656374456C656D656E742E746162496E6465783D653F303A2D317D72656E64';
wwv_flow_imp.g_varchar2_table(13437) := '65722865297B652E636C6173734C6973742E616464282273656C6563742D636F6E7461696E657222292C652E617070656E644368696C6428746869732E73656C656374456C656D656E74292C746869732E7365744F7074696F6E7328746869732E6F7074';
wwv_flow_imp.g_varchar2_table(13438) := '696F6E732C746869732E73656C6563746564292C746869732E6170706C795374796C657328297D6170706C795374796C657328297B76617220652C742C6E3B746869732E73656C656374456C656D656E74262628746869732E73656C656374456C656D65';
wwv_flow_imp.g_varchar2_table(13439) := '6E742E7374796C652E6261636B67726F756E64436F6C6F723D6E756C6C213D3D28653D746869732E7374796C65732E73656C6563744261636B67726F756E64292626766F69642030213D3D653F653A22222C746869732E73656C656374456C656D656E74';
wwv_flow_imp.g_varchar2_table(13440) := '2E7374796C652E636F6C6F723D6E756C6C213D3D28743D746869732E7374796C65732E73656C656374466F726567726F756E64292626766F69642030213D3D743F743A22222C746869732E73656C656374456C656D656E742E7374796C652E626F726465';
wwv_flow_imp.g_varchar2_table(13441) := '72436F6C6F723D6E756C6C213D3D286E3D746869732E7374796C65732E73656C656374426F72646572292626766F69642030213D3D6E3F6E3A2222297D6372656174654F7074696F6E28652C742C6E297B636F6E737420693D646F63756D656E742E6372';
wwv_flow_imp.g_varchar2_table(13442) := '65617465456C656D656E7428226F7074696F6E22293B72657475726E20692E76616C75653D652C692E746578743D652C692E64697361626C65643D21216E2C697D7D76617220654D3D6E2835303730292C744D3D7B7D3B744D2E7374796C655461675472';
wwv_flow_imp.g_varchar2_table(13443) := '616E73666F726D3D6A7228292C744D2E736574417474726962757465733D567228292C744D2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C744D2E646F6D4150493D4F7228292C744D2E696E736572745374796C65456C65';
wwv_flow_imp.g_varchar2_table(13444) := '6D656E743D487228292C4E72282928654D2E412C744D292C654D2E412626654D2E412E6C6F63616C732626654D2E412E6C6F63616C733B636C617373206E4D20657874656E64732047447B636F6E7374727563746F7228652C742C6E2C692C6F297B7375';
wwv_flow_imp.g_varchar2_table(13445) := '70657228292C71262621286E756C6C3D3D6F3F766F696420303A6F2E757365437573746F6D447261776E293F746869732E73656C656374426F7844656C65676174653D6E6577204A4928652C742C692C6F293A746869732E73656C656374426F7844656C';
wwv_flow_imp.g_varchar2_table(13446) := '65676174653D6E657720584928652C742C6E2C692C6F292C746869732E5F726567697374657228746869732E73656C656374426F7844656C6567617465297D676574206F6E44696453656C65637428297B72657475726E20746869732E73656C65637442';
wwv_flow_imp.g_varchar2_table(13447) := '6F7844656C65676174652E6F6E44696453656C6563747D7365744F7074696F6E7328652C74297B746869732E73656C656374426F7844656C65676174652E7365744F7074696F6E7328652C74297D73656C6563742865297B746869732E73656C65637442';
wwv_flow_imp.g_varchar2_table(13448) := '6F7844656C65676174652E73656C6563742865297D666F63757328297B746869732E73656C656374426F7844656C65676174652E666F63757328297D626C757228297B746869732E73656C656374426F7844656C65676174652E626C757228297D736574';
wwv_flow_imp.g_varchar2_table(13449) := '466F63757361626C652865297B746869732E73656C656374426F7844656C65676174652E736574466F63757361626C652865297D72656E6465722865297B746869732E73656C656374426F7844656C65676174652E72656E6465722865297D7D76617220';
wwv_flow_imp.g_varchar2_table(13450) := '694D3D6E2834353636292C6F4D3D7B7D3B6F4D2E7374796C655461675472616E73666F726D3D6A7228292C6F4D2E736574417474726962757465733D567228292C6F4D2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6F4D';
wwv_flow_imp.g_varchar2_table(13451) := '2E646F6D4150493D4F7228292C6F4D2E696E736572745374796C65456C656D656E743D487228292C4E72282928694D2E412C6F4D292C694D2E412626694D2E412E6C6F63616C732626694D2E412E6C6F63616C733B636C61737320734D20657874656E64';
wwv_flow_imp.g_varchar2_table(13452) := '73206C747B67657420616374696F6E28297B72657475726E20746869732E5F616374696F6E7D636F6E7374727563746F7228652C742C6E3D7B7D297B737570657228292C746869732E6F7074696F6E733D6E2C746869732E5F636F6E746578743D657C7C';
wwv_flow_imp.g_varchar2_table(13453) := '746869732C746869732E5F616374696F6E3D742C7420696E7374616E63656F662062632626746869732E5F726567697374657228742E6F6E4469644368616E67652828653D3E7B746869732E656C656D656E742626746869732E68616E646C6541637469';
wwv_flow_imp.g_varchar2_table(13454) := '6F6E4368616E67654576656E742865297D2929297D68616E646C65416374696F6E4368616E67654576656E742865297B766F69642030213D3D652E656E61626C65642626746869732E757064617465456E61626C656428292C766F69642030213D3D652E';
wwv_flow_imp.g_varchar2_table(13455) := '636865636B65642626746869732E757064617465436865636B656428292C766F69642030213D3D652E636C6173732626746869732E757064617465436C61737328292C766F69642030213D3D652E6C6162656C262628746869732E7570646174654C6162';
wwv_flow_imp.g_varchar2_table(13456) := '656C28292C746869732E757064617465546F6F6C7469702829292C766F69642030213D3D652E746F6F6C7469702626746869732E757064617465546F6F6C74697028297D67657420616374696F6E52756E6E657228297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(13457) := '616374696F6E52756E6E65727C7C28746869732E5F616374696F6E52756E6E65723D746869732E5F7265676973746572286E6577205F6329292C746869732E5F616374696F6E52756E6E65727D73657420616374696F6E52756E6E65722865297B746869';
wwv_flow_imp.g_varchar2_table(13458) := '732E5F616374696F6E52756E6E65723D657D6973456E61626C656428297B72657475726E20746869732E5F616374696F6E2E656E61626C65647D736574416374696F6E436F6E746578742865297B746869732E5F636F6E746578743D657D72656E646572';
wwv_flow_imp.g_varchar2_table(13459) := '2865297B636F6E737420743D746869732E656C656D656E743D653B746869732E5F72656769737465722849452E616464546172676574286529293B636F6E7374206E3D746869732E6F7074696F6E732626746869732E6F7074696F6E732E647261676761';
wwv_flow_imp.g_varchar2_table(13460) := '626C653B6E262628652E647261676761626C653D21302C632626746869732E5F726567697374657228627328652C61722E445241475F53544152542C28653D3E7B76617220743B72657475726E206E756C6C3D3D3D28743D652E646174615472616E7366';
wwv_flow_imp.g_varchar2_table(13461) := '6572297C7C766F696420303D3D3D743F766F696420303A742E736574446174612867782E544558542C746869732E5F616374696F6E2E6C6162656C297D292929292C746869732E5F726567697374657228627328742C54452E5461702C28653D3E746869';
wwv_flow_imp.g_varchar2_table(13462) := '732E6F6E436C69636B28652C2130292929292C746869732E5F726567697374657228627328742C61722E4D4F5553455F444F574E2C28653D3E7B6E7C7C637228652C2130292C746869732E5F616374696F6E2E656E61626C65642626303D3D3D652E6275';
wwv_flow_imp.g_varchar2_table(13463) := '74746F6E2626742E636C6173734C6973742E616464282261637469766522297D2929292C712626746869732E5F726567697374657228627328742C61722E434F4E544558545F4D454E552C28653D3E7B303D3D3D652E627574746F6E262621303D3D3D65';
wwv_flow_imp.g_varchar2_table(13464) := '2E6374726C4B65792626746869732E6F6E436C69636B2865297D2929292C746869732E5F726567697374657228627328742C61722E434C49434B2C28653D3E7B637228652C2130292C746869732E6F7074696F6E732626746869732E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(13465) := '69734D656E757C7C746869732E6F6E436C69636B2865297D2929292C746869732E5F726567697374657228627328742C61722E44424C434C49434B2C28653D3E7B637228652C2130297D2929292C5B61722E4D4F5553455F55502C61722E4D4F5553455F';
wwv_flow_imp.g_varchar2_table(13466) := '4F55545D2E666F72456163682828653D3E7B746869732E5F726567697374657228627328742C652C28653D3E7B63722865292C742E636C6173734C6973742E72656D6F7665282261637469766522297D2929297D29297D6F6E436C69636B28652C743D21';
wwv_flow_imp.g_varchar2_table(13467) := '31297B766172206E3B637228652C2130293B636F6E737420693D5F6C28746869732E5F636F6E74657874293F286E756C6C3D3D3D286E3D746869732E6F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E7573654576656E744173';
wwv_flow_imp.g_varchar2_table(13468) := '436F6E74657874293F653A7B7072657365727665466F6375733A747D3A746869732E5F636F6E746578743B746869732E616374696F6E52756E6E65722E72756E28746869732E5F616374696F6E2C69297D666F63757328297B746869732E656C656D656E';
wwv_flow_imp.g_varchar2_table(13469) := '74262628746869732E656C656D656E742E746162496E6465783D302C746869732E656C656D656E742E666F63757328292C746869732E656C656D656E742E636C6173734C6973742E6164642822666F63757365642229297D626C757228297B746869732E';
wwv_flow_imp.g_varchar2_table(13470) := '656C656D656E74262628746869732E656C656D656E742E626C757228292C746869732E656C656D656E742E746162496E6465783D2D312C746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822666F63757365642229297D736574';
wwv_flow_imp.g_varchar2_table(13471) := '466F63757361626C652865297B746869732E656C656D656E74262628746869732E656C656D656E742E746162496E6465783D653F303A2D31297D6765742074726170734172726F774E617669676174696F6E28297B72657475726E21317D757064617465';
wwv_flow_imp.g_varchar2_table(13472) := '456E61626C656428297B7D7570646174654C6162656C28297B7D676574436C61737328297B72657475726E20746869732E616374696F6E2E636C6173737D676574546F6F6C74697028297B72657475726E20746869732E616374696F6E2E746F6F6C7469';
wwv_flow_imp.g_varchar2_table(13473) := '707D757064617465546F6F6C74697028297B76617220652C742C6E3B69662821746869732E656C656D656E742972657475726E3B636F6E737420693D6E756C6C213D3D28653D746869732E676574546F6F6C7469702829292626766F69642030213D3D65';
wwv_flow_imp.g_varchar2_table(13474) := '3F653A22223B696628746869732E757064617465417269614C6162656C28292C6E756C6C3D3D3D28743D746869732E6F7074696F6E732E686F76657244656C6567617465297C7C766F696420303D3D3D743F766F696420303A742E73686F774E61746976';
wwv_flow_imp.g_varchar2_table(13475) := '65486F76657229746869732E656C656D656E742E7469746C653D693B656C736520696628746869732E637573746F6D486F7665727C7C22223D3D3D6929746869732E637573746F6D486F7665722626746869732E637573746F6D486F7665722E75706461';
wwv_flow_imp.g_varchar2_table(13476) := '74652869293B656C73657B636F6E737420653D6E756C6C213D3D286E3D746869732E6F7074696F6E732E686F76657244656C6567617465292626766F69642030213D3D6E3F6E3A50452822656C656D656E7422293B746869732E637573746F6D486F7665';
wwv_flow_imp.g_varchar2_table(13477) := '723D746869732E5F73746F72652E61646428564528292E7365747570557064617461626C65486F76657228652C746869732E656C656D656E742C6929297D7D757064617465417269614C6162656C28297B76617220653B696628746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(13478) := '6E74297B636F6E737420743D6E756C6C213D3D28653D746869732E676574546F6F6C7469702829292626766F69642030213D3D653F653A22223B746869732E656C656D656E742E7365744174747269627574652822617269612D6C6162656C222C74297D';
wwv_flow_imp.g_varchar2_table(13479) := '7D757064617465436C61737328297B7D757064617465436865636B656428297B7D646973706F736528297B746869732E656C656D656E74262628746869732E656C656D656E742E72656D6F766528292C746869732E656C656D656E743D766F6964203029';
wwv_flow_imp.g_varchar2_table(13480) := '2C746869732E5F636F6E746578743D766F696420302C73757065722E646973706F736528297D7D636C61737320724D20657874656E647320734D7B636F6E7374727563746F7228652C742C6E297B737570657228652C742C6E292C746869732E6F707469';
wwv_flow_imp.g_varchar2_table(13481) := '6F6E733D6E2C746869732E6F7074696F6E732E69636F6E3D766F69642030213D3D6E2E69636F6E26266E2E69636F6E2C746869732E6F7074696F6E732E6C6162656C3D766F696420303D3D3D6E2E6C6162656C7C7C6E2E6C6162656C2C746869732E6373';
wwv_flow_imp.g_varchar2_table(13482) := '73436C6173733D22227D72656E6465722865297B73757065722E72656E6465722865292C796C28746869732E656C656D656E74293B636F6E737420743D646F63756D656E742E637265617465456C656D656E7428226122293B696628742E636C6173734C';
wwv_flow_imp.g_varchar2_table(13483) := '6973742E6164642822616374696F6E2D6C6162656C22292C742E7365744174747269627574652822726F6C65222C746869732E67657444656661756C7441726961526F6C652829292C746869732E6C6162656C3D742C746869732E656C656D656E742E61';
wwv_flow_imp.g_varchar2_table(13484) := '7070656E644368696C642874292C746869732E6F7074696F6E732E6C6162656C2626746869732E6F7074696F6E732E6B657962696E64696E67297B636F6E737420653D646F63756D656E742E637265617465456C656D656E7428227370616E22293B652E';
wwv_flow_imp.g_varchar2_table(13485) := '636C6173734C6973742E61646428226B657962696E64696E6722292C652E74657874436F6E74656E743D746869732E6F7074696F6E732E6B657962696E64696E672C746869732E656C656D656E742E617070656E644368696C642865297D746869732E75';
wwv_flow_imp.g_varchar2_table(13486) := '7064617465436C61737328292C746869732E7570646174654C6162656C28292C746869732E757064617465546F6F6C74697028292C746869732E757064617465456E61626C656428292C746869732E757064617465436865636B656428297D6765744465';
wwv_flow_imp.g_varchar2_table(13487) := '6661756C7441726961526F6C6528297B72657475726E20746869732E5F616374696F6E2E69643D3D3D79632E49443F2270726573656E746174696F6E223A746869732E6F7074696F6E732E69734D656E753F226D656E756974656D223A22627574746F6E';
wwv_flow_imp.g_varchar2_table(13488) := '227D666F63757328297B746869732E6C6162656C262628746869732E6C6162656C2E746162496E6465783D302C746869732E6C6162656C2E666F6375732829297D626C757228297B746869732E6C6162656C262628746869732E6C6162656C2E74616249';
wwv_flow_imp.g_varchar2_table(13489) := '6E6465783D2D31297D736574466F63757361626C652865297B746869732E6C6162656C262628746869732E6C6162656C2E746162496E6465783D653F303A2D31297D7570646174654C6162656C28297B746869732E6F7074696F6E732E6C6162656C2626';
wwv_flow_imp.g_varchar2_table(13490) := '746869732E6C6162656C262628746869732E6C6162656C2E74657874436F6E74656E743D746869732E616374696F6E2E6C6162656C297D676574546F6F6C74697028297B6C657420653D6E756C6C3B72657475726E20746869732E616374696F6E2E746F';
wwv_flow_imp.g_varchar2_table(13491) := '6F6C7469703F653D746869732E616374696F6E2E746F6F6C7469703A21746869732E6F7074696F6E732E6C6162656C2626746869732E616374696F6E2E6C6162656C2626746869732E6F7074696F6E732E69636F6E262628653D746869732E616374696F';
wwv_flow_imp.g_varchar2_table(13492) := '6E2E6C6162656C2C746869732E6F7074696F6E732E6B657962696E64696E67262628653D6228302C227B307D20287B317D29222C652C746869732E6F7074696F6E732E6B657962696E64696E672929292C6E756C6C213D653F653A766F696420307D7570';
wwv_flow_imp.g_varchar2_table(13493) := '64617465436C61737328297B76617220653B746869732E637373436C6173732626746869732E6C6162656C2626746869732E6C6162656C2E636C6173734C6973742E72656D6F7665282E2E2E746869732E637373436C6173732E73706C69742822202229';
wwv_flow_imp.g_varchar2_table(13494) := '292C746869732E6F7074696F6E732E69636F6E3F28746869732E637373436C6173733D746869732E676574436C61737328292C746869732E6C6162656C262628746869732E6C6162656C2E636C6173734C6973742E6164642822636F6469636F6E22292C';
wwv_flow_imp.g_varchar2_table(13495) := '746869732E637373436C6173732626746869732E6C6162656C2E636C6173734C6973742E616464282E2E2E746869732E637373436C6173732E73706C6974282220222929292C746869732E757064617465456E61626C65642829293A6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(13496) := '653D746869732E6C6162656C297C7C766F696420303D3D3D657C7C652E636C6173734C6973742E72656D6F76652822636F6469636F6E22297D757064617465456E61626C656428297B76617220652C743B746869732E616374696F6E2E656E61626C6564';
wwv_flow_imp.g_varchar2_table(13497) := '3F28746869732E6C6162656C262628746869732E6C6162656C2E72656D6F76654174747269627574652822617269612D64697361626C656422292C746869732E6C6162656C2E636C6173734C6973742E72656D6F7665282264697361626C65642229292C';
wwv_flow_imp.g_varchar2_table(13498) := '6E756C6C3D3D3D28653D746869732E656C656D656E74297C7C766F696420303D3D3D657C7C652E636C6173734C6973742E72656D6F7665282264697361626C65642229293A28746869732E6C6162656C262628746869732E6C6162656C2E736574417474';
wwv_flow_imp.g_varchar2_table(13499) := '7269627574652822617269612D64697361626C6564222C227472756522292C746869732E6C6162656C2E636C6173734C6973742E616464282264697361626C65642229292C6E756C6C3D3D3D28743D746869732E656C656D656E74297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(13500) := '3D3D3D747C7C742E636C6173734C6973742E616464282264697361626C65642229297D757064617465417269614C6162656C28297B76617220653B696628746869732E6C6162656C297B636F6E737420743D6E756C6C213D3D28653D746869732E676574';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(13501) := '546F6F6C7469702829292626766F69642030213D3D653F653A22223B746869732E6C6162656C2E7365744174747269627574652822617269612D6C6162656C222C74297D7D757064617465436865636B656428297B746869732E6C6162656C262628766F';
wwv_flow_imp.g_varchar2_table(13502) := '69642030213D3D746869732E616374696F6E2E636865636B65643F28746869732E6C6162656C2E636C6173734C6973742E746F67676C652822636865636B6564222C746869732E616374696F6E2E636865636B6564292C746869732E6C6162656C2E7365';
wwv_flow_imp.g_varchar2_table(13503) := '744174747269627574652822617269612D636865636B6564222C746869732E616374696F6E2E636865636B65643F2274727565223A2266616C736522292C746869732E6C6162656C2E7365744174747269627574652822726F6C65222C22636865636B62';
wwv_flow_imp.g_varchar2_table(13504) := '6F782229293A28746869732E6C6162656C2E636C6173734C6973742E72656D6F76652822636865636B656422292C746869732E6C6162656C2E72656D6F76654174747269627574652822617269612D636865636B656422292C746869732E6C6162656C2E';
wwv_flow_imp.g_varchar2_table(13505) := '7365744174747269627574652822726F6C65222C746869732E67657444656661756C7441726961526F6C6528292929297D7D636C61737320614D20657874656E647320734D7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570';
wwv_flow_imp.g_varchar2_table(13506) := '657228652C74292C746869732E73656C656374426F783D6E6577206E4D286E2C692C6F2C732C72292C746869732E73656C656374426F782E736574466F63757361626C65282131292C746869732E5F726567697374657228746869732E73656C65637442';
wwv_flow_imp.g_varchar2_table(13507) := '6F78292C746869732E72656769737465724C697374656E65727328297D73656C6563742865297B746869732E73656C656374426F782E73656C6563742865297D72656769737465724C697374656E65727328297B746869732E5F72656769737465722874';
wwv_flow_imp.g_varchar2_table(13508) := '6869732E73656C656374426F782E6F6E44696453656C6563742828653D3E746869732E72756E416374696F6E28652E73656C65637465642C652E696E646578292929297D72756E416374696F6E28652C74297B746869732E616374696F6E52756E6E6572';
wwv_flow_imp.g_varchar2_table(13509) := '2E72756E28746869732E5F616374696F6E2C746869732E676574416374696F6E436F6E7465787428652C7429297D676574416374696F6E436F6E7465787428652C74297B72657475726E20657D736574466F63757361626C652865297B746869732E7365';
wwv_flow_imp.g_varchar2_table(13510) := '6C656374426F782E736574466F63757361626C652865297D666F63757328297B76617220653B6E756C6C3D3D3D28653D746869732E73656C656374426F78297C7C766F696420303D3D3D657C7C652E666F63757328297D626C757228297B76617220653B';
wwv_flow_imp.g_varchar2_table(13511) := '6E756C6C3D3D3D28653D746869732E73656C656374426F78297C7C766F696420303D3D3D657C7C652E626C757228297D72656E6465722865297B746869732E73656C656374426F782E72656E6465722865297D7D636C617373206C4D20657874656E6473';
wwv_flow_imp.g_varchar2_table(13512) := '206C747B636F6E7374727563746F7228652C743D7B7D297B766172206E2C692C6F2C732C722C612C6C3B6C657420632C643B73776974636828737570657228292C746869732E5F616374696F6E52756E6E6572446973706F7361626C65733D746869732E';
wwv_flow_imp.g_varchar2_table(13513) := '5F7265676973746572286E6577206174292C746869732E766965774974656D446973706F7361626C65733D746869732E5F7265676973746572286E6577207574292C746869732E747269676765724B6579446F776E3D21312C746869732E666F63757361';
wwv_flow_imp.g_varchar2_table(13514) := '626C653D21302C746869732E5F6F6E446964426C75723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964426C75723D746869732E5F6F6E446964426C75722E6576656E742C746869732E5F6F6E44696443616E63656C';
wwv_flow_imp.g_varchar2_table(13515) := '3D746869732E5F7265676973746572286E6577204374287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E746869732E63616E63656C4861734C697374656E65723D21307D29292C746869732E6F6E44696443616E63656C3D746869';
wwv_flow_imp.g_varchar2_table(13516) := '732E5F6F6E44696443616E63656C2E6576656E742C746869732E63616E63656C4861734C697374656E65723D21312C746869732E5F6F6E44696452756E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696452756E3D74';
wwv_flow_imp.g_varchar2_table(13517) := '6869732E5F6F6E44696452756E2E6576656E742C746869732E5F6F6E57696C6C52756E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E57696C6C52756E3D746869732E5F6F6E57696C6C52756E2E6576656E742C74686973';
wwv_flow_imp.g_varchar2_table(13518) := '2E6F7074696F6E733D742C746869732E5F636F6E746578743D6E756C6C213D3D286E3D742E636F6E74657874292626766F69642030213D3D6E3F6E3A6E756C6C2C746869732E5F6F7269656E746174696F6E3D6E756C6C213D3D28693D746869732E6F70';
wwv_flow_imp.g_varchar2_table(13519) := '74696F6E732E6F7269656E746174696F6E292626766F69642030213D3D693F693A302C746869732E5F747269676765724B6579733D7B6B6579446F776E3A6E756C6C213D3D28733D6E756C6C3D3D3D286F3D746869732E6F7074696F6E732E7472696767';
wwv_flow_imp.g_varchar2_table(13520) := '65724B657973297C7C766F696420303D3D3D6F3F766F696420303A6F2E6B6579446F776E292626766F69642030213D3D732626732C6B6579733A6E756C6C213D3D28613D6E756C6C3D3D3D28723D746869732E6F7074696F6E732E747269676765724B65';
wwv_flow_imp.g_varchar2_table(13521) := '7973297C7C766F696420303D3D3D723F766F696420303A722E6B657973292626766F69642030213D3D613F613A5B332C31305D7D2C746869732E5F686F76657244656C65676174653D6E756C6C213D3D286C3D742E686F76657244656C65676174652926';
wwv_flow_imp.g_varchar2_table(13522) := '26766F69642030213D3D6C3F6C3A746869732E5F7265676973746572284F452829292C746869732E6F7074696F6E732E616374696F6E52756E6E65723F746869732E5F616374696F6E52756E6E65723D746869732E6F7074696F6E732E616374696F6E52';
wwv_flow_imp.g_varchar2_table(13523) := '756E6E65723A28746869732E5F616374696F6E52756E6E65723D6E6577205F632C746869732E5F616374696F6E52756E6E6572446973706F7361626C65732E61646428746869732E5F616374696F6E52756E6E657229292C746869732E5F616374696F6E';
wwv_flow_imp.g_varchar2_table(13524) := '52756E6E6572446973706F7361626C65732E61646428746869732E5F616374696F6E52756E6E65722E6F6E44696452756E2828653D3E746869732E5F6F6E44696452756E2E666972652865292929292C746869732E5F616374696F6E52756E6E65724469';
wwv_flow_imp.g_varchar2_table(13525) := '73706F7361626C65732E61646428746869732E5F616374696F6E52756E6E65722E6F6E57696C6C52756E2828653D3E746869732E5F6F6E57696C6C52756E2E666972652865292929292C746869732E766965774974656D733D5B5D2C746869732E666F63';
wwv_flow_imp.g_varchar2_table(13526) := '757365644974656D3D766F696420302C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D616374696F6E2D626172';
wwv_flow_imp.g_varchar2_table(13527) := '222C746869732E5F6F7269656E746174696F6E297B6361736520303A633D5B31355D2C643D5B31375D3B627265616B3B6361736520313A633D5B31365D2C643D5B31385D2C746869732E646F6D4E6F64652E636C6173734E616D652B3D22207665727469';
wwv_flow_imp.g_varchar2_table(13528) := '63616C227D746869732E5F726567697374657228627328746869732E646F6D4E6F64652C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B6C6574206E3D21303B636F6E737420693D226E756D626572223D3D7479';
wwv_flow_imp.g_varchar2_table(13529) := '70656F6620746869732E666F63757365644974656D3F746869732E766965774974656D735B746869732E666F63757365644974656D5D3A766F696420303B63262628742E657175616C7328635B305D297C7C742E657175616C7328635B315D29293F6E3D';
wwv_flow_imp.g_varchar2_table(13530) := '746869732E666F63757350726576696F757328293A64262628742E657175616C7328645B305D297C7C742E657175616C7328645B315D29293F6E3D746869732E666F6375734E65787428293A742E657175616C732839292626746869732E63616E63656C';
wwv_flow_imp.g_varchar2_table(13531) := '4861734C697374656E65723F746869732E5F6F6E44696443616E63656C2E6669726528293A742E657175616C73283134293F6E3D746869732E666F637573466972737428293A742E657175616C73283133293F6E3D746869732E666F6375734C61737428';
wwv_flow_imp.g_varchar2_table(13532) := '293A742E657175616C7328322926266920696E7374616E63656F6620734D2626692E74726170734172726F774E617669676174696F6E3F6E3D746869732E666F6375734E65787428293A746869732E6973547269676765724B65794576656E742874293F';
wwv_flow_imp.g_varchar2_table(13533) := '746869732E5F747269676765724B6579732E6B6579446F776E3F746869732E646F547269676765722874293A746869732E747269676765724B6579446F776E3D21303A6E3D21312C6E262628742E70726576656E7444656661756C7428292C742E73746F';
wwv_flow_imp.g_varchar2_table(13534) := '7050726F7061676174696F6E2829297D2929292C746869732E5F726567697374657228627328746869732E646F6D4E6F64652C61722E4B45595F55502C28653D3E7B636F6E737420743D6E65772071652865293B746869732E6973547269676765724B65';
wwv_flow_imp.g_varchar2_table(13535) := '794576656E742874293F2821746869732E5F747269676765724B6579732E6B6579446F776E2626746869732E747269676765724B6579446F776E262628746869732E747269676765724B6579446F776E3D21312C746869732E646F547269676765722874';
wwv_flow_imp.g_varchar2_table(13536) := '29292C742E70726576656E7444656661756C7428292C742E73746F7050726F7061676174696F6E2829293A28742E657175616C732832297C7C742E657175616C732831303236297C7C742E657175616C73283136297C7C742E657175616C73283138297C';
wwv_flow_imp.g_varchar2_table(13537) := '7C742E657175616C73283135297C7C742E657175616C7328313729292626746869732E757064617465466F63757365644974656D28297D2929292C746869732E666F637573547261636B65723D746869732E5F726567697374657228687228746869732E';
wwv_flow_imp.g_varchar2_table(13538) := '646F6D4E6F646529292C746869732E5F726567697374657228746869732E666F637573547261636B65722E6F6E446964426C7572282828293D3E7B6A732829213D3D746869732E646F6D4E6F646526264273286A7328292C746869732E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(13539) := '297C7C28746869732E5F6F6E446964426C75722E6669726528292C746869732E70726576696F75736C79466F63757365644974656D3D746869732E666F63757365644974656D2C746869732E666F63757365644974656D3D766F696420302C746869732E';
wwv_flow_imp.g_varchar2_table(13540) := '747269676765724B6579446F776E3D2131297D2929292C746869732E5F726567697374657228746869732E666F637573547261636B65722E6F6E446964466F637573282828293D3E746869732E757064617465466F63757365644974656D28292929292C';
wwv_flow_imp.g_varchar2_table(13541) := '746869732E616374696F6E734C6973743D646F63756D656E742E637265617465456C656D656E742822756C22292C746869732E616374696F6E734C6973742E636C6173734E616D653D22616374696F6E732D636F6E7461696E6572222C746869732E6F70';
wwv_flow_imp.g_varchar2_table(13542) := '74696F6E732E686967686C69676874546F67676C65644974656D732626746869732E616374696F6E734C6973742E636C6173734C6973742E6164642822686967686C696768742D746F67676C656422292C746869732E616374696F6E734C6973742E7365';
wwv_flow_imp.g_varchar2_table(13543) := '744174747269627574652822726F6C65222C746869732E6F7074696F6E732E61726961526F6C657C7C22746F6F6C62617222292C746869732E6F7074696F6E732E617269614C6162656C2626746869732E616374696F6E734C6973742E73657441747472';
wwv_flow_imp.g_varchar2_table(13544) := '69627574652822617269612D6C6162656C222C746869732E6F7074696F6E732E617269614C6162656C292C746869732E646F6D4E6F64652E617070656E644368696C6428746869732E616374696F6E734C697374292C652E617070656E644368696C6428';
wwv_flow_imp.g_varchar2_table(13545) := '746869732E646F6D4E6F6465297D72656672657368526F6C6528297B746869732E6C656E67746828293E3D313F746869732E616374696F6E734C6973742E7365744174747269627574652822726F6C65222C746869732E6F7074696F6E732E6172696152';
wwv_flow_imp.g_varchar2_table(13546) := '6F6C657C7C22746F6F6C62617222293A746869732E616374696F6E734C6973742E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22297D736574466F63757361626C652865297B696628746869732E666F6375736162';
wwv_flow_imp.g_varchar2_table(13547) := '6C653D652C746869732E666F63757361626C65297B636F6E737420653D746869732E766965774974656D732E66696E642828653D3E6520696E7374616E63656F6620734D2626652E6973456E61626C6564282929293B6520696E7374616E63656F662073';
wwv_flow_imp.g_varchar2_table(13548) := '4D2626652E736574466F63757361626C65282130297D656C736520746869732E766965774974656D732E666F72456163682828653D3E7B6520696E7374616E63656F6620734D2626652E736574466F63757361626C65282131297D29297D697354726967';
wwv_flow_imp.g_varchar2_table(13549) := '6765724B65794576656E742865297B6C657420743D21313B72657475726E20746869732E5F747269676765724B6579732E6B6579732E666F724561636828286E3D3E7B743D747C7C652E657175616C73286E297D29292C747D757064617465466F637573';
wwv_flow_imp.g_varchar2_table(13550) := '65644974656D28297B76617220652C743B666F72286C6574206E3D303B6E3C746869732E616374696F6E734C6973742E6368696C6472656E2E6C656E6774683B6E2B2B297B636F6E737420693D746869732E616374696F6E734C6973742E6368696C6472';
wwv_flow_imp.g_varchar2_table(13551) := '656E5B6E5D3B6966284273286A7328292C6929297B746869732E666F63757365644974656D3D6E2C6E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E766965774974656D735B746869732E666F63757365644974656D5D297C7C766F696420';
wwv_flow_imp.g_varchar2_table(13552) := '303D3D3D653F766F696420303A652E73686F77486F766572297C7C766F696420303D3D3D747C7C742E63616C6C2865293B627265616B7D7D7D67657420636F6E7465787428297B72657475726E20746869732E5F636F6E746578747D73657420636F6E74';
wwv_flow_imp.g_varchar2_table(13553) := '6578742865297B746869732E5F636F6E746578743D652C746869732E766965774974656D732E666F72456163682828743D3E742E736574416374696F6E436F6E7465787428652929297D67657420616374696F6E52756E6E657228297B72657475726E20';
wwv_flow_imp.g_varchar2_table(13554) := '746869732E5F616374696F6E52756E6E65727D73657420616374696F6E52756E6E65722865297B746869732E5F616374696F6E52756E6E65723D652C746869732E5F616374696F6E52756E6E6572446973706F7361626C65732E636C65617228292C7468';
wwv_flow_imp.g_varchar2_table(13555) := '69732E5F616374696F6E52756E6E6572446973706F7361626C65732E61646428746869732E5F616374696F6E52756E6E65722E6F6E44696452756E2828653D3E746869732E5F6F6E44696452756E2E666972652865292929292C746869732E5F61637469';
wwv_flow_imp.g_varchar2_table(13556) := '6F6E52756E6E6572446973706F7361626C65732E61646428746869732E5F616374696F6E52756E6E65722E6F6E57696C6C52756E2828653D3E746869732E5F6F6E57696C6C52756E2E666972652865292929292C746869732E766965774974656D732E66';
wwv_flow_imp.g_varchar2_table(13557) := '6F72456163682828743D3E742E616374696F6E52756E6E65723D6529297D676574436F6E7461696E657228297B72657475726E20746869732E646F6D4E6F64657D676574416374696F6E2865297B76617220743B696628226E756D626572223D3D747970';
wwv_flow_imp.g_varchar2_table(13558) := '656F6620652972657475726E206E756C6C3D3D3D28743D746869732E766965774974656D735B655D297C7C766F696420303D3D3D743F766F696420303A742E616374696F6E3B6966286520696E7374616E63656F662048544D4C456C656D656E74297B66';
wwv_flow_imp.g_varchar2_table(13559) := '6F72283B652E706172656E74456C656D656E74213D3D746869732E616374696F6E734C6973743B297B69662821652E706172656E74456C656D656E742972657475726E3B653D652E706172656E74456C656D656E747D666F72286C657420743D303B743C';
wwv_flow_imp.g_varchar2_table(13560) := '746869732E616374696F6E734C6973742E6368696C644E6F6465732E6C656E6774683B742B2B29696628746869732E616374696F6E734C6973742E6368696C644E6F6465735B745D3D3D3D652972657475726E20746869732E766965774974656D735B74';
wwv_flow_imp.g_varchar2_table(13561) := '5D2E616374696F6E7D7D7075736828652C743D7B7D297B636F6E7374206E3D41727261792E697341727261792865293F653A5B655D3B6C657420693D676C28742E696E646578293F742E696E6465783A6E756C6C3B6E2E666F72456163682828653D3E7B';
wwv_flow_imp.g_varchar2_table(13562) := '636F6E7374206E3D646F63756D656E742E637265617465456C656D656E7428226C6922293B6C6574206F3B6E2E636C6173734E616D653D22616374696F6E2D6974656D222C6E2E7365744174747269627574652822726F6C65222C2270726573656E7461';
wwv_flow_imp.g_varchar2_table(13563) := '74696F6E22293B636F6E737420733D7B686F76657244656C65676174653A746869732E5F686F76657244656C65676174652C2E2E2E747D3B746869732E6F7074696F6E732E616374696F6E566965774974656D50726F76696465722626286F3D74686973';
wwv_flow_imp.g_varchar2_table(13564) := '2E6F7074696F6E732E616374696F6E566965774974656D50726F766964657228652C7329292C6F7C7C286F3D6E657720724D28746869732E636F6E746578742C652C7329292C746869732E6F7074696F6E732E616C6C6F77436F6E746578744D656E757C';
wwv_flow_imp.g_varchar2_table(13565) := '7C746869732E766965774974656D446973706F7361626C65732E736574286F2C6273286E2C61722E434F4E544558545F4D454E552C28653D3E7B637228652C2130297D2929292C6F2E616374696F6E52756E6E65723D746869732E5F616374696F6E5275';
wwv_flow_imp.g_varchar2_table(13566) := '6E6E65722C6F2E736574416374696F6E436F6E7465787428746869732E636F6E74657874292C6F2E72656E646572286E292C746869732E666F63757361626C6526266F20696E7374616E63656F6620734D2626303D3D3D746869732E766965774974656D';
wwv_flow_imp.g_varchar2_table(13567) := '732E6C656E67746826266F2E736574466F63757361626C65282130292C6E756C6C3D3D3D697C7C693C307C7C693E3D746869732E616374696F6E734C6973742E6368696C6472656E2E6C656E6774683F28746869732E616374696F6E734C6973742E6170';
wwv_flow_imp.g_varchar2_table(13568) := '70656E644368696C64286E292C746869732E766965774974656D732E70757368286F29293A28746869732E616374696F6E734C6973742E696E736572744265666F7265286E2C746869732E616374696F6E734C6973742E6368696C6472656E5B695D292C';
wwv_flow_imp.g_varchar2_table(13569) := '746869732E766965774974656D732E73706C69636528692C302C6F292C692B2B297D29292C226E756D626572223D3D747970656F6620746869732E666F63757365644974656D2626746869732E666F63757328746869732E666F63757365644974656D29';
wwv_flow_imp.g_varchar2_table(13570) := '2C746869732E72656672657368526F6C6528297D636C65617228297B746869732E6973456D70747928297C7C28746869732E766965774974656D733D6F7428746869732E766965774974656D73292C746869732E766965774974656D446973706F736162';
wwv_flow_imp.g_varchar2_table(13571) := '6C65732E636C656172416E64446973706F7365416C6C28292C667328746869732E616374696F6E734C697374292C746869732E72656672657368526F6C652829297D6C656E67746828297B72657475726E20746869732E766965774974656D732E6C656E';
wwv_flow_imp.g_varchar2_table(13572) := '6774687D6973456D70747928297B72657475726E20303D3D3D746869732E766965774974656D732E6C656E6774687D666F6375732865297B6C657420742C6E3D21313B696628766F696420303D3D3D653F6E3D21303A226E756D626572223D3D74797065';
wwv_flow_imp.g_varchar2_table(13573) := '6F6620653F743D653A22626F6F6C65616E223D3D747970656F6620652626286E3D65292C6E2626766F696420303D3D3D746869732E666F63757365644974656D297B636F6E737420653D746869732E766965774974656D732E66696E64496E6465782828';
wwv_flow_imp.g_varchar2_table(13574) := '653D3E652E6973456E61626C6564282929293B746869732E666F63757365644974656D3D2D313D3D3D653F766F696420303A652C746869732E757064617465466F63757328766F696420302C766F696420302C2130297D656C736520766F69642030213D';
wwv_flow_imp.g_varchar2_table(13575) := '3D74262628746869732E666F63757365644974656D3D74292C746869732E757064617465466F63757328766F696420302C766F696420302C2130297D666F637573466972737428297B72657475726E20746869732E666F63757365644974656D3D746869';
wwv_flow_imp.g_varchar2_table(13576) := '732E6C656E67746828292D312C746869732E666F6375734E657874282130297D666F6375734C61737428297B72657475726E20746869732E666F63757365644974656D3D302C746869732E666F63757350726576696F7573282130297D666F6375734E65';
wwv_flow_imp.g_varchar2_table(13577) := '78742865297B696628766F696420303D3D3D746869732E666F63757365644974656D29746869732E666F63757365644974656D3D746869732E766965774974656D732E6C656E6774682D313B656C736520696628746869732E766965774974656D732E6C';
wwv_flow_imp.g_varchar2_table(13578) := '656E6774683C3D312972657475726E21313B636F6E737420743D746869732E666F63757365644974656D3B6C6574206E3B646F7B69662821652626746869732E6F7074696F6E732E70726576656E744C6F6F704E617669676174696F6E2626746869732E';
wwv_flow_imp.g_varchar2_table(13579) := '666F63757365644974656D2B313E3D746869732E766965774974656D732E6C656E6774682972657475726E20746869732E666F63757365644974656D3D742C21313B746869732E666F63757365644974656D3D28746869732E666F63757365644974656D';
wwv_flow_imp.g_varchar2_table(13580) := '2B312925746869732E766965774974656D732E6C656E6774682C6E3D746869732E766965774974656D735B746869732E666F63757365644974656D5D7D7768696C6528746869732E666F63757365644974656D213D3D74262628746869732E6F7074696F';
wwv_flow_imp.g_varchar2_table(13581) := '6E732E666F6375734F6E6C79456E61626C65644974656D732626216E2E6973456E61626C656428297C7C6E2E616374696F6E2E69643D3D3D79632E494429293B72657475726E20746869732E757064617465466F63757328292C21307D666F6375735072';
wwv_flow_imp.g_varchar2_table(13582) := '6576696F75732865297B696628766F696420303D3D3D746869732E666F63757365644974656D29746869732E666F63757365644974656D3D303B656C736520696628746869732E766965774974656D732E6C656E6774683C3D312972657475726E21313B';
wwv_flow_imp.g_varchar2_table(13583) := '636F6E737420743D746869732E666F63757365644974656D3B6C6574206E3B646F7B696628746869732E666F63757365644974656D3D746869732E666F63757365644974656D2D312C746869732E666F63757365644974656D3C30297B69662821652626';
wwv_flow_imp.g_varchar2_table(13584) := '746869732E6F7074696F6E732E70726576656E744C6F6F704E617669676174696F6E2972657475726E20746869732E666F63757365644974656D3D742C21313B746869732E666F63757365644974656D3D746869732E766965774974656D732E6C656E67';
wwv_flow_imp.g_varchar2_table(13585) := '74682D317D6E3D746869732E766965774974656D735B746869732E666F63757365644974656D5D7D7768696C6528746869732E666F63757365644974656D213D3D74262628746869732E6F7074696F6E732E666F6375734F6E6C79456E61626C65644974';
wwv_flow_imp.g_varchar2_table(13586) := '656D732626216E2E6973456E61626C656428297C7C6E2E616374696F6E2E69643D3D3D79632E494429293B72657475726E20746869732E757064617465466F637573282130292C21307D757064617465466F63757328652C742C6E3D2131297B76617220';
wwv_flow_imp.g_varchar2_table(13587) := '692C6F3B766F696420303D3D3D746869732E666F63757365644974656D2626746869732E616374696F6E734C6973742E666F637573287B70726576656E745363726F6C6C3A747D292C766F69642030213D3D746869732E70726576696F75736C79466F63';
wwv_flow_imp.g_varchar2_table(13588) := '757365644974656D2626746869732E70726576696F75736C79466F63757365644974656D213D3D746869732E666F63757365644974656D2626286E756C6C3D3D3D28693D746869732E766965774974656D735B746869732E70726576696F75736C79466F';
wwv_flow_imp.g_varchar2_table(13589) := '63757365644974656D5D297C7C766F696420303D3D3D697C7C692E626C75722829293B636F6E737420733D766F69642030213D3D746869732E666F63757365644974656D3F746869732E766965774974656D735B746869732E666F63757365644974656D';
wwv_flow_imp.g_varchar2_table(13590) := '5D3A766F696420303B69662873297B6C657420693D21303B436C28732E666F637573297C7C28693D2131292C746869732E6F7074696F6E732E666F6375734F6E6C79456E61626C65644974656D732626436C28732E6973456E61626C656429262621732E';
wwv_flow_imp.g_varchar2_table(13591) := '6973456E61626C65642829262628693D2131292C732E616374696F6E2E69643D3D3D79632E4944262628693D2131292C693F286E7C7C746869732E70726576696F75736C79466F63757365644974656D213D3D746869732E666F63757365644974656D29';
wwv_flow_imp.g_varchar2_table(13592) := '262628732E666F6375732865292C746869732E70726576696F75736C79466F63757365644974656D3D746869732E666F63757365644974656D293A28746869732E616374696F6E734C6973742E666F637573287B70726576656E745363726F6C6C3A747D';
wwv_flow_imp.g_varchar2_table(13593) := '292C746869732E70726576696F75736C79466F63757365644974656D3D766F69642030292C692626286E756C6C3D3D3D286F3D732E73686F77486F766572297C7C766F696420303D3D3D6F7C7C6F2E63616C6C287329297D7D646F547269676765722865';
wwv_flow_imp.g_varchar2_table(13594) := '297B696628766F696420303D3D3D746869732E666F63757365644974656D2972657475726E3B636F6E737420743D746869732E766965774974656D735B746869732E666F63757365644974656D5D3B6966287420696E7374616E63656F6620734D297B63';
wwv_flow_imp.g_varchar2_table(13595) := '6F6E7374206E3D6E756C6C3D3D3D742E5F636F6E746578747C7C766F696420303D3D3D742E5F636F6E746578743F653A742E5F636F6E746578743B746869732E72756E28742E5F616374696F6E2C6E297D7D6173796E632072756E28652C74297B617761';
wwv_flow_imp.g_varchar2_table(13596) := '697420746869732E5F616374696F6E52756E6E65722E72756E28652C74297D646973706F736528297B746869732E5F636F6E746578743D766F696420302C746869732E766965774974656D733D6F7428746869732E766965774974656D73292C74686973';
wwv_flow_imp.g_varchar2_table(13597) := '2E676574436F6E7461696E657228292E72656D6F766528292C73757065722E646973706F736528297D7D76617220634D3D6E2836373435292C644D3D7B7D3B644D2E7374796C655461675472616E73666F726D3D6A7228292C644D2E7365744174747269';
wwv_flow_imp.g_varchar2_table(13598) := '62757465733D567228292C644D2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C644D2E646F6D4150493D4F7228292C644D2E696E736572745374796C65456C656D656E743D487228292C4E72282928634D2E412C644D292C';
wwv_flow_imp.g_varchar2_table(13599) := '634D2E412626634D2E412E6C6F63616C732626634D2E412E6C6F63616C733B636C61737320684D7B636F6E7374727563746F7228652C742C6E3D74297B746869732E6D6F6469666965724C6162656C733D5B6E756C6C5D2C746869732E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(13600) := '724C6162656C735B325D3D652C746869732E6D6F6469666965724C6162656C735B315D3D742C746869732E6D6F6469666965724C6162656C735B335D3D6E7D746F4C6162656C28652C742C6E297B696628303D3D3D742E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(13601) := '206E756C6C3B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C723D6E2873293B6966286E756C6C3D3D3D722972657475726E206E756C6C3B695B6F5D3D664D';
wwv_flow_imp.g_varchar2_table(13602) := '28732C722C746869732E6D6F6469666965724C6162656C735B655D297D72657475726E20692E6A6F696E28222022297D7D636F6E737420754D3D6E657720684D287B6374726C4B65793A22E28C83222C73686966744B65793A22E287A7222C616C744B65';
wwv_flow_imp.g_varchar2_table(13603) := '793A22E28CA5222C6D6574614B65793A22E28C98222C736570617261746F723A22227D2C7B6374726C4B65793A6228302C224374726C22292C73686966744B65793A6228302C22536869667422292C616C744B65793A6228302C22416C7422292C6D6574';
wwv_flow_imp.g_varchar2_table(13604) := '614B65793A6228302C2257696E646F777322292C736570617261746F723A222B227D2C7B6374726C4B65793A6228302C224374726C22292C73686966744B65793A6228302C22536869667422292C616C744B65793A6228302C22416C7422292C6D657461';
wwv_flow_imp.g_varchar2_table(13605) := '4B65793A6228302C22537570657222292C736570617261746F723A222B227D292C704D3D6E657720684D287B6374726C4B65793A6228302C22436F6E74726F6C22292C73686966744B65793A6228302C22536869667422292C616C744B65793A6228302C';
wwv_flow_imp.g_varchar2_table(13606) := '224F7074696F6E22292C6D6574614B65793A6228302C22436F6D6D616E6422292C736570617261746F723A222B227D2C7B6374726C4B65793A6228302C22436F6E74726F6C22292C73686966744B65793A6228302C22536869667422292C616C744B6579';
wwv_flow_imp.g_varchar2_table(13607) := '3A6228302C22416C7422292C6D6574614B65793A6228302C2257696E646F777322292C736570617261746F723A222B227D2C7B6374726C4B65793A6228302C22436F6E74726F6C22292C73686966744B65793A6228302C22536869667422292C616C744B';
wwv_flow_imp.g_varchar2_table(13608) := '65793A6228302C22416C7422292C6D6574614B65793A6228302C22537570657222292C736570617261746F723A222B227D292C674D3D6E657720684D287B6374726C4B65793A224374726C222C73686966744B65793A225368696674222C616C744B6579';
wwv_flow_imp.g_varchar2_table(13609) := '3A22416C74222C6D6574614B65793A22436D64222C736570617261746F723A222B227D2C7B6374726C4B65793A224374726C222C73686966744B65793A225368696674222C616C744B65793A22416C74222C6D6574614B65793A225375706572222C7365';
wwv_flow_imp.g_varchar2_table(13610) := '70617261746F723A222B227D292C6D4D3D6E657720684D287B6374726C4B65793A226374726C222C73686966744B65793A227368696674222C616C744B65793A22616C74222C6D6574614B65793A22636D64222C736570617261746F723A222B227D2C7B';
wwv_flow_imp.g_varchar2_table(13611) := '6374726C4B65793A226374726C222C73686966744B65793A227368696674222C616C744B65793A22616C74222C6D6574614B65793A2277696E222C736570617261746F723A222B227D2C7B6374726C4B65793A226374726C222C73686966744B65793A22';
wwv_flow_imp.g_varchar2_table(13612) := '7368696674222C616C744B65793A22616C74222C6D6574614B65793A226D657461222C736570617261746F723A222B227D293B66756E6374696F6E20664D28652C742C6E297B6966286E756C6C3D3D3D742972657475726E22223B636F6E737420693D5B';
wwv_flow_imp.g_varchar2_table(13613) := '5D3B72657475726E20652E6374726C4B65792626692E70757368286E2E6374726C4B6579292C652E73686966744B65792626692E70757368286E2E73686966744B6579292C652E616C744B65792626692E70757368286E2E616C744B6579292C652E6D65';
wwv_flow_imp.g_varchar2_table(13614) := '74614B65792626692E70757368286E2E6D6574614B6579292C2222213D3D742626692E707573682874292C692E6A6F696E286E2E736570617261746F72297D76617220764D3D6E2835343232292C624D3D7B7D3B624D2E7374796C655461675472616E73';
wwv_flow_imp.g_varchar2_table(13615) := '666F726D3D6A7228292C624D2E736574417474726962757465733D567228292C624D2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C624D2E646F6D4150493D4F7228292C624D2E696E736572745374796C65456C656D656E';
wwv_flow_imp.g_varchar2_table(13616) := '743D487228292C4E72282928764D2E412C624D292C764D2E412626764D2E412E6C6F63616C732626764D2E412E6C6F63616C733B636F6E7374205F4D3D62722C794D3D7B6B657962696E64696E674C6162656C4261636B67726F756E643A766F69642030';
wwv_flow_imp.g_varchar2_table(13617) := '2C6B657962696E64696E674C6162656C466F726567726F756E643A766F696420302C6B657962696E64696E674C6162656C426F726465723A766F696420302C6B657962696E64696E674C6162656C426F74746F6D426F726465723A766F696420302C6B65';
wwv_flow_imp.g_varchar2_table(13618) := '7962696E64696E674C6162656C536861646F773A766F696420307D3B636C61737320774D20657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E6F733D742C746869732E6B6579456C656D656E74';
wwv_flow_imp.g_varchar2_table(13619) := '733D6E6577205365742C746869732E6F7074696F6E733D6E7C7C4F626A6563742E637265617465286E756C6C293B636F6E737420693D746869732E6F7074696F6E732E6B657962696E64696E674C6162656C466F726567726F756E643B746869732E646F';
wwv_flow_imp.g_varchar2_table(13620) := '6D4E6F64653D757228652C5F4D28222E6D6F6E61636F2D6B657962696E64696E672229292C69262628746869732E646F6D4E6F64652E7374796C652E636F6C6F723D69292C746869732E686F7665723D746869732E5F726567697374657228564528292E';
wwv_flow_imp.g_varchar2_table(13621) := '7365747570557064617461626C65486F76657228504528226D6F75736522292C746869732E646F6D4E6F64652C222229292C746869732E6469644576657252656E6465723D21312C652E617070656E644368696C6428746869732E646F6D4E6F6465297D';
wwv_flow_imp.g_varchar2_table(13622) := '67657420656C656D656E7428297B72657475726E20746869732E646F6D4E6F64657D73657428652C74297B746869732E6469644576657252656E6465722626746869732E6B657962696E64696E673D3D3D652626774D2E61726553616D6528746869732E';
wwv_flow_imp.g_varchar2_table(13623) := '6D6174636865732C74297C7C28746869732E6B657962696E64696E673D652C746869732E6D6174636865733D742C746869732E72656E6465722829297D72656E64657228297B76617220653B696628746869732E636C65617228292C746869732E6B6579';
wwv_flow_imp.g_varchar2_table(13624) := '62696E64696E67297B636F6E737420743D746869732E6B657962696E64696E672E67657443686F72647328293B745B305D2626746869732E72656E64657243686F726428746869732E646F6D4E6F64652C745B305D2C746869732E6D6174636865733F74';
wwv_flow_imp.g_varchar2_table(13625) := '6869732E6D6174636865732E6669727374506172743A6E756C6C293B666F72286C657420653D313B653C742E6C656E6774683B652B2B29757228746869732E646F6D4E6F64652C5F4D28227370616E2E6D6F6E61636F2D6B657962696E64696E672D6B65';
wwv_flow_imp.g_varchar2_table(13626) := '792D63686F72642D736570617261746F72222C766F696420302C22202229292C746869732E72656E64657243686F726428746869732E646F6D4E6F64652C745B655D2C746869732E6D6174636865733F746869732E6D6174636865732E63686F72645061';
wwv_flow_imp.g_varchar2_table(13627) := '72743A6E756C6C293B636F6E7374206E3D6E756C6C213D3D28653D746869732E6F7074696F6E732E64697361626C655469746C65292626766F69642030213D3D652626653F766F696420303A746869732E6B657962696E64696E672E676574417269614C';
wwv_flow_imp.g_varchar2_table(13628) := '6162656C28297C7C766F696420303B746869732E686F7665722E757064617465286E292C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D6C6162656C222C6E7C7C2222297D656C736520746869732E6F7074696F6E7326';
wwv_flow_imp.g_varchar2_table(13629) := '26746869732E6F7074696F6E732E72656E646572556E626F756E644B657962696E64696E67732626746869732E72656E646572556E626F756E6428746869732E646F6D4E6F6465293B746869732E6469644576657252656E6465723D21307D636C656172';
wwv_flow_imp.g_varchar2_table(13630) := '28297B667328746869732E646F6D4E6F6465292C746869732E6B6579456C656D656E74732E636C65617228297D72656E64657243686F726428652C742C6E297B636F6E737420693D754D2E6D6F6469666965724C6162656C735B746869732E6F735D3B74';
wwv_flow_imp.g_varchar2_table(13631) := '2E6374726C4B65792626746869732E72656E6465724B657928652C692E6374726C4B65792C426F6F6C65616E286E756C6C3D3D6E3F766F696420303A6E2E6374726C4B6579292C692E736570617261746F72292C742E73686966744B6579262674686973';
wwv_flow_imp.g_varchar2_table(13632) := '2E72656E6465724B657928652C692E73686966744B65792C426F6F6C65616E286E756C6C3D3D6E3F766F696420303A6E2E73686966744B6579292C692E736570617261746F72292C742E616C744B65792626746869732E72656E6465724B657928652C69';
wwv_flow_imp.g_varchar2_table(13633) := '2E616C744B65792C426F6F6C65616E286E756C6C3D3D6E3F766F696420303A6E2E616C744B6579292C692E736570617261746F72292C742E6D6574614B65792626746869732E72656E6465724B657928652C692E6D6574614B65792C426F6F6C65616E28';
wwv_flow_imp.g_varchar2_table(13634) := '6E756C6C3D3D6E3F766F696420303A6E2E6D6574614B6579292C692E736570617261746F72293B636F6E7374206F3D742E6B65794C6162656C3B6F2626746869732E72656E6465724B657928652C6F2C426F6F6C65616E286E756C6C3D3D6E3F766F6964';
wwv_flow_imp.g_varchar2_table(13635) := '20303A6E2E6B6579436F6465292C2222297D72656E6465724B657928652C742C6E2C69297B757228652C746869732E6372656174654B6579456C656D656E7428742C6E3F222E686967686C69676874223A222229292C692626757228652C5F4D28227370';
wwv_flow_imp.g_varchar2_table(13636) := '616E2E6D6F6E61636F2D6B657962696E64696E672D6B65792D736570617261746F72222C766F696420302C6929297D72656E646572556E626F756E642865297B757228652C746869732E6372656174654B6579456C656D656E74286228302C22556E626F';
wwv_flow_imp.g_varchar2_table(13637) := '756E64222929297D6372656174654B6579456C656D656E7428652C743D2222297B636F6E7374206E3D5F4D28227370616E2E6D6F6E61636F2D6B657962696E64696E672D6B6579222B742C766F696420302C65293B72657475726E20746869732E6B6579';
wwv_flow_imp.g_varchar2_table(13638) := '456C656D656E74732E616464286E292C746869732E6F7074696F6E732E6B657962696E64696E674C6162656C4261636B67726F756E642626286E2E7374796C652E6261636B67726F756E64436F6C6F723D746869732E6F7074696F6E732E6B657962696E';
wwv_flow_imp.g_varchar2_table(13639) := '64696E674C6162656C4261636B67726F756E64292C746869732E6F7074696F6E732E6B657962696E64696E674C6162656C426F726465722626286E2E7374796C652E626F72646572436F6C6F723D746869732E6F7074696F6E732E6B657962696E64696E';
wwv_flow_imp.g_varchar2_table(13640) := '674C6162656C426F72646572292C746869732E6F7074696F6E732E6B657962696E64696E674C6162656C426F74746F6D426F726465722626286E2E7374796C652E626F72646572426F74746F6D436F6C6F723D746869732E6F7074696F6E732E6B657962';
wwv_flow_imp.g_varchar2_table(13641) := '696E64696E674C6162656C426F74746F6D426F72646572292C746869732E6F7074696F6E732E6B657962696E64696E674C6162656C536861646F772626286E2E7374796C652E626F78536861646F773D60696E7365742030202D317078203020247B7468';
wwv_flow_imp.g_varchar2_table(13642) := '69732E6F7074696F6E732E6B657962696E64696E674C6162656C536861646F777D60292C6E7D7374617469632061726553616D6528652C74297B72657475726E20653D3D3D747C7C2165262621747C7C21216526262121742626776828652E6669727374';
wwv_flow_imp.g_varchar2_table(13643) := '506172742C742E666972737450617274292626776828652E63686F7264506172742C742E63686F726450617274297D7D636F6E737420434D3D7B6B657962696E64696E674C6162656C4261636B67726F756E643A786D284676292C6B657962696E64696E';
wwv_flow_imp.g_varchar2_table(13644) := '674C6162656C466F726567726F756E643A786D284276292C6B657962696E64696E674C6162656C426F726465723A786D285676292C6B657962696E64696E674C6162656C426F74746F6D426F726465723A786D287A76292C6B657962696E64696E674C61';
wwv_flow_imp.g_varchar2_table(13645) := '62656C536861646F773A786D284E66297D2C534D3D7B627574746F6E466F726567726F756E643A786D284576292C627574746F6E536570617261746F723A786D284C76292C627574746F6E4261636B67726F756E643A786D284476292C627574746F6E48';
wwv_flow_imp.g_varchar2_table(13646) := '6F7665724261636B67726F756E643A786D285476292C627574746F6E5365636F6E64617279466F726567726F756E643A786D284D76292C627574746F6E5365636F6E646172794261636B67726F756E643A786D284176292C627574746F6E5365636F6E64';
wwv_flow_imp.g_varchar2_table(13647) := '617279486F7665724261636B67726F756E643A786D284E76292C627574746F6E426F726465723A786D284976297D2C784D3D7B70726F67726573734261724261636B67726F756E643A786D28516D297D2C6B4D3D7B696E7075744163746976654F707469';
wwv_flow_imp.g_varchar2_table(13648) := '6F6E426F726465723A786D286476292C696E7075744163746976654F7074696F6E466F726567726F756E643A786D287576292C696E7075744163746976654F7074696F6E4261636B67726F756E643A786D286876297D2C454D3D28786D285076292C786D';
wwv_flow_imp.g_varchar2_table(13649) := '285276292C786D284F76292C786D28586D292C786D284A6D292C786D284E66292C786D287A6D292C786D285966292C786D285A66292C786D285866292C786D28576D292C7B696E7075744261636B67726F756E643A786D286176292C696E707574466F72';
wwv_flow_imp.g_varchar2_table(13650) := '6567726F756E643A786D286C76292C696E707574426F726465723A786D286376292C696E70757456616C69646174696F6E496E666F426F726465723A786D286D76292C696E70757456616C69646174696F6E496E666F4261636B67726F756E643A786D28';
wwv_flow_imp.g_varchar2_table(13651) := '7076292C696E70757456616C69646174696F6E496E666F466F726567726F756E643A786D286776292C696E70757456616C69646174696F6E5761726E696E67426F726465723A786D286276292C696E70757456616C69646174696F6E5761726E696E6742';
wwv_flow_imp.g_varchar2_table(13652) := '61636B67726F756E643A786D286676292C696E70757456616C69646174696F6E5761726E696E67466F726567726F756E643A786D287676292C696E70757456616C69646174696F6E4572726F72426F726465723A786D287776292C696E70757456616C69';
wwv_flow_imp.g_varchar2_table(13653) := '646174696F6E4572726F724261636B67726F756E643A786D285F76292C696E70757456616C69646174696F6E4572726F72466F726567726F756E643A786D287976297D292C4C4D3D7B6C69737446696C7465725769646765744261636B67726F756E643A';
wwv_flow_imp.g_varchar2_table(13654) := '786D286162292C6C69737446696C7465725769646765744F75746C696E653A786D286C62292C6C69737446696C7465725769646765744E6F4D6174636865734F75746C696E653A786D286362292C6C69737446696C746572576964676574536861646F77';
wwv_flow_imp.g_varchar2_table(13655) := '3A786D286462292C696E707574426F785374796C65733A454D2C746F67676C655374796C65733A6B4D7D2C444D3D7B62616467654261636B67726F756E643A786D286A6D292C6261646765466F726567726F756E643A786D28716D292C6261646765426F';
wwv_flow_imp.g_varchar2_table(13656) := '726465723A786D287A6D297D2C544D3D28786D284666292C786D285266292C786D284266292C786D284266292C786D285666292C7B6C6973744261636B67726F756E643A766F696420302C6C697374496E616374697665466F637573466F726567726F75';
wwv_flow_imp.g_varchar2_table(13657) := '6E643A766F696420302C6C697374466F6375734261636B67726F756E643A786D284876292C6C697374466F637573466F726567726F756E643A786D285776292C6C697374466F6375734F75746C696E653A786D286A76292C6C6973744163746976655365';
wwv_flow_imp.g_varchar2_table(13658) := '6C656374696F6E4261636B67726F756E643A786D282476292C6C69737441637469766553656C656374696F6E466F726567726F756E643A786D285576292C6C69737441637469766553656C656374696F6E49636F6E466F726567726F756E643A786D284B';
wwv_flow_imp.g_varchar2_table(13659) := '76292C6C697374466F637573416E6453656C656374696F6E4F75746C696E653A786D287176292C6C697374466F637573416E6453656C656374696F6E4261636B67726F756E643A786D282476292C6C697374466F637573416E6453656C656374696F6E46';
wwv_flow_imp.g_varchar2_table(13660) := '6F726567726F756E643A786D285576292C6C697374496E61637469766553656C656374696F6E4261636B67726F756E643A786D284776292C6C697374496E61637469766553656C656374696F6E49636F6E466F726567726F756E643A786D285976292C6C';
wwv_flow_imp.g_varchar2_table(13661) := '697374496E61637469766553656C656374696F6E466F726567726F756E643A786D285176292C6C697374496E616374697665466F6375734261636B67726F756E643A786D285A76292C6C697374496E616374697665466F6375734F75746C696E653A786D';
wwv_flow_imp.g_varchar2_table(13662) := '285876292C6C697374486F7665724261636B67726F756E643A786D284A76292C6C697374486F766572466F726567726F756E643A786D286562292C6C69737444726F704F7665724261636B67726F756E643A786D287462292C6C69737444726F70426574';
wwv_flow_imp.g_varchar2_table(13663) := '7765656E4261636B67726F756E643A786D286E62292C6C69737453656C656374696F6E4F75746C696E653A786D28486D292C6C697374486F7665724F75746C696E653A786D28486D292C74726565496E64656E744775696465735374726F6B653A786D28';
wwv_flow_imp.g_varchar2_table(13664) := '6862292C74726565496E616374697665496E64656E744775696465735374726F6B653A786D287562292C74726565537469636B795363726F6C6C4261636B67726F756E643A766F696420302C74726565537469636B795363726F6C6C426F726465723A76';
wwv_flow_imp.g_varchar2_table(13665) := '6F696420302C74726565537469636B795363726F6C6C536861646F773A766F696420302C7461626C65436F6C756D6E73426F726465723A786D287062292C7461626C654F6464526F77734261636B67726F756E64436F6C6F723A786D286762297D293B66';
wwv_flow_imp.g_varchar2_table(13666) := '756E6374696F6E20494D2865297B72657475726E2066756E6374696F6E28652C74297B636F6E7374206E3D7B2E2E2E747D3B666F7228636F6E7374207420696E2065297B636F6E737420693D655B745D3B6E5B745D3D766F69642030213D3D693F786D28';
wwv_flow_imp.g_varchar2_table(13667) := '69293A766F696420307D72657475726E206E7D28652C544D297D636F6E7374204D4D3D7B73656C6563744261636B67726F756E643A786D284376292C73656C6563744C6973744261636B67726F756E643A786D285376292C73656C656374466F72656772';
wwv_flow_imp.g_varchar2_table(13668) := '6F756E643A786D287876292C6465636F7261746F725269676874466F726567726F756E643A786D286B62292C73656C656374426F726465723A786D286B76292C666F637573426F726465723A786D28566D292C6C697374466F6375734261636B67726F75';
wwv_flow_imp.g_varchar2_table(13669) := '6E643A786D284962292C6C697374496E61637469766553656C656374696F6E49636F6E466F726567726F756E643A786D285462292C6C697374466F637573466F726567726F756E643A786D284462292C6C697374466F6375734F75746C696E653A28414D';
wwv_flow_imp.g_varchar2_table(13670) := '3D486D2C4E4D3D68752E7472616E73706172656E742E746F537472696E6728292C6076617228247B536D28414D297D2C20247B4E4D7D2960292C6C697374486F7665724261636B67726F756E643A786D284A76292C6C697374486F766572466F72656772';
wwv_flow_imp.g_varchar2_table(13671) := '6F756E643A786D286562292C6C697374486F7665724F75746C696E653A786D28486D292C73656C6563744C697374426F726465723A786D286566292C6C6973744261636B67726F756E643A766F696420302C6C69737441637469766553656C656374696F';
wwv_flow_imp.g_varchar2_table(13672) := '6E4261636B67726F756E643A766F696420302C6C69737441637469766553656C656374696F6E466F726567726F756E643A766F696420302C6C69737441637469766553656C656374696F6E49636F6E466F726567726F756E643A766F696420302C6C6973';
wwv_flow_imp.g_varchar2_table(13673) := '74466F637573416E6453656C656374696F6E4261636B67726F756E643A766F696420302C6C69737444726F704F7665724261636B67726F756E643A766F696420302C6C69737444726F704265747765656E4261636B67726F756E643A766F696420302C6C';
wwv_flow_imp.g_varchar2_table(13674) := '697374496E61637469766553656C656374696F6E4261636B67726F756E643A766F696420302C6C697374496E61637469766553656C656374696F6E466F726567726F756E643A766F696420302C6C697374496E616374697665466F6375734261636B6772';
wwv_flow_imp.g_varchar2_table(13675) := '6F756E643A766F696420302C6C697374496E616374697665466F6375734F75746C696E653A766F696420302C6C69737453656C656374696F6E4F75746C696E653A766F696420302C6C697374466F637573416E6453656C656374696F6E466F726567726F';
wwv_flow_imp.g_varchar2_table(13676) := '756E643A766F696420302C6C697374466F637573416E6453656C656374696F6E4F75746C696E653A766F696420302C6C697374496E616374697665466F637573466F726567726F756E643A766F696420302C7461626C65436F6C756D6E73426F72646572';
wwv_flow_imp.g_varchar2_table(13677) := '3A766F696420302C7461626C654F6464526F77734261636B67726F756E64436F6C6F723A766F696420302C74726565496E64656E744775696465735374726F6B653A766F696420302C74726565496E616374697665496E64656E74477569646573537472';
wwv_flow_imp.g_varchar2_table(13678) := '6F6B653A766F696420302C74726565537469636B795363726F6C6C4261636B67726F756E643A766F696420302C74726565537469636B795363726F6C6C426F726465723A766F696420302C74726565537469636B795363726F6C6C536861646F773A766F';
wwv_flow_imp.g_varchar2_table(13679) := '696420307D3B76617220414D2C4E4D3B636F6E737420504D3D7B736861646F77436F6C6F723A786D284E66292C626F72646572436F6C6F723A786D286D62292C666F726567726F756E64436F6C6F723A786D286662292C6261636B67726F756E64436F6C';
wwv_flow_imp.g_varchar2_table(13680) := '6F723A786D287662292C73656C656374696F6E466F726567726F756E64436F6C6F723A786D286262292C73656C656374696F6E4261636B67726F756E64436F6C6F723A786D285F62292C73656C656374696F6E426F72646572436F6C6F723A786D287962';
wwv_flow_imp.g_varchar2_table(13681) := '292C736570617261746F72436F6C6F723A786D287762292C7363726F6C6C626172536861646F773A786D28246D292C7363726F6C6C626172536C696465724261636B67726F756E643A786D28556D292C7363726F6C6C626172536C69646572486F766572';
wwv_flow_imp.g_varchar2_table(13682) := '4261636B67726F756E643A786D284B6D292C7363726F6C6C626172536C696465724163746976654261636B67726F756E643A786D28476D297D3B766172204F4D3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E7473';
wwv_flow_imp.g_varchar2_table(13683) := '2E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E63';
wwv_flow_imp.g_varchar2_table(13684) := '74696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B61';
wwv_flow_imp.g_varchar2_table(13685) := '5D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C524D3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(13686) := '28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E737420464D3D2261636365707453656C6563746564436F6465416374696F6E222C424D3D227072657669657753656C6563746564436F6465416374';
wwv_flow_imp.g_varchar2_table(13687) := '696F6E223B636C61737320564D7B6765742074656D706C617465496428297B72657475726E22686561646572227D72656E64657254656D706C6174652865297B652E636C6173734C6973742E616464282267726F75702D68656164657222293B636F6E73';
wwv_flow_imp.g_varchar2_table(13688) := '7420743D646F63756D656E742E637265617465456C656D656E7428227370616E22293B72657475726E20652E617070656E642874292C7B636F6E7461696E65723A652C746578743A747D7D72656E646572456C656D656E7428652C742C6E297B76617220';
wwv_flow_imp.g_varchar2_table(13689) := '692C6F3B6E2E746578742E74657874436F6E74656E743D6E756C6C213D3D286F3D6E756C6C3D3D3D28693D652E67726F7570297C7C766F696420303D3D3D693F766F696420303A692E7469746C65292626766F69642030213D3D6F3F6F3A22227D646973';
wwv_flow_imp.g_varchar2_table(13690) := '706F736554656D706C6174652865297B7D7D6C6574207A4D3D636C6173737B6765742074656D706C617465496428297B72657475726E22616374696F6E227D636F6E7374727563746F7228652C74297B746869732E5F737570706F727473507265766965';
wwv_flow_imp.g_varchar2_table(13691) := '773D652C746869732E5F6B657962696E64696E67536572766963653D747D72656E64657254656D706C6174652865297B652E636C6173734C6973742E61646428746869732E74656D706C6174654964293B636F6E737420743D646F63756D656E742E6372';
wwv_flow_imp.g_varchar2_table(13692) := '65617465456C656D656E74282264697622293B742E636C6173734E616D653D2269636F6E222C652E617070656E642874293B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E7428227370616E22293B72657475726E206E2E636C';
wwv_flow_imp.g_varchar2_table(13693) := '6173734E616D653D227469746C65222C652E617070656E64286E292C7B636F6E7461696E65723A652C69636F6E3A742C746578743A6E2C6B657962696E64696E673A6E657720774D28652C7465297D7D72656E646572456C656D656E7428652C742C6E29';
wwv_flow_imp.g_varchar2_table(13694) := '7B76617220692C6F2C733B696628286E756C6C3D3D3D28693D652E67726F7570297C7C766F696420303D3D3D693F766F696420303A692E69636F6E293F286E2E69636F6E2E636C6173734E616D653D546C2E6173436C6173734E616D6528652E67726F75';
wwv_flow_imp.g_varchar2_table(13695) := '702E69636F6E292C652E67726F75702E69636F6E2E636F6C6F722626286E2E69636F6E2E7374796C652E636F6C6F723D786D28652E67726F75702E69636F6E2E636F6C6F722E69642929293A286E2E69636F6E2E636C6173734E616D653D546C2E617343';
wwv_flow_imp.g_varchar2_table(13696) := '6C6173734E616D65284C6C2E6C6967687442756C62292C6E2E69636F6E2E7374796C652E636F6C6F723D22766172282D2D7673636F64652D656469746F724C6967687442756C622D666F726567726F756E642922292C21652E6974656D7C7C21652E6C61';
wwv_flow_imp.g_varchar2_table(13697) := '62656C2972657475726E3B6E2E746578742E74657874436F6E74656E743D244D28652E6C6162656C292C6E2E6B657962696E64696E672E73657428652E6B657962696E64696E67292C66756E6374696F6E28652C2E2E2E74297B653F5F72282E2E2E7429';
wwv_flow_imp.g_varchar2_table(13698) := '3A7972282E2E2E74297D282121652E6B657962696E64696E672C6E2E6B657962696E64696E672E656C656D656E74293B636F6E737420723D6E756C6C3D3D3D286F3D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962';
wwv_flow_imp.g_varchar2_table(13699) := '696E64696E6728464D29297C7C766F696420303D3D3D6F3F766F696420303A6F2E6765744C6162656C28292C613D6E756C6C3D3D3D28733D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728424D29';
wwv_flow_imp.g_varchar2_table(13700) := '297C7C766F696420303D3D3D733F766F696420303A732E6765744C6162656C28293B6E2E636F6E7461696E65722E636C6173734C6973742E746F67676C6528226F7074696F6E2D64697361626C6564222C652E64697361626C6564292C652E6469736162';
wwv_flow_imp.g_varchar2_table(13701) := '6C65643F6E2E636F6E7461696E65722E7469746C653D652E6C6162656C3A722626613F746869732E5F737570706F727473507265766965772626652E63616E507265766965773F6E2E636F6E7461696E65722E7469746C653D6228302C227B307D20746F';
wwv_flow_imp.g_varchar2_table(13702) := '204170706C792C207B317D20746F2050726576696577222C722C61293A6E2E636F6E7461696E65722E7469746C653D6228302C227B307D20746F204170706C79222C72293A6E2E636F6E7461696E65722E7469746C653D22227D646973706F736554656D';
wwv_flow_imp.g_varchar2_table(13703) := '706C6174652865297B652E6B657962696E64696E672E646973706F736528297D7D3B7A4D3D4F4D285B524D28312C2445295D2C7A4D293B636C61737320484D20657874656E64732055494576656E747B636F6E7374727563746F7228297B737570657228';
wwv_flow_imp.g_varchar2_table(13704) := '2261636365707453656C6563746564416374696F6E22297D7D636C61737320574D20657874656E64732055494576656E747B636F6E7374727563746F7228297B737570657228227072657669657753656C6563746564416374696F6E22297D7D66756E63';
wwv_flow_imp.g_varchar2_table(13705) := '74696F6E206A4D2865297B69662822616374696F6E223D3D3D652E6B696E642972657475726E20652E6C6162656C7D6C657420714D3D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B73757065';
wwv_flow_imp.g_varchar2_table(13706) := '7228292C746869732E5F64656C65676174653D692C746869732E5F636F6E7465787456696577536572766963653D6F2C746869732E5F6B657962696E64696E67536572766963653D732C746869732E5F616374696F6E4C696E654865696768743D32342C';
wwv_flow_imp.g_varchar2_table(13707) := '746869732E5F6865616465724C696E654865696768743D32362C746869732E6374733D746869732E5F7265676973746572286E6577204E74292C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E7428226469762229';
wwv_flow_imp.g_varchar2_table(13708) := '2C746869732E646F6D4E6F64652E636C6173734C6973742E6164642822616374696F6E4C69737422293B636F6E737420723D7B6765744865696768743A653D3E22686561646572223D3D3D652E6B696E643F746869732E5F6865616465724C696E654865';
wwv_flow_imp.g_varchar2_table(13709) := '696768743A746869732E5F616374696F6E4C696E654865696768742C67657454656D706C61746549643A653D3E652E6B696E647D3B746869732E5F6C6973743D746869732E5F7265676973746572286E657720554928652C746869732E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(13710) := '2C722C5B6E6577207A4D28742C746869732E5F6B657962696E64696E6753657276696365292C6E657720564D5D2C7B6B6579626F617264537570706F72743A21312C747970654E617669676174696F6E456E61626C65643A21302C6B6579626F6172644E';
wwv_flow_imp.g_varchar2_table(13711) := '617669676174696F6E4C6162656C50726F76696465723A7B6765744B6579626F6172644E617669676174696F6E4C6162656C3A6A4D7D2C6163636573736962696C69747950726F76696465723A7B676574417269614C6162656C3A653D3E7B6966282261';
wwv_flow_imp.g_varchar2_table(13712) := '6374696F6E223D3D3D652E6B696E64297B6C657420743D652E6C6162656C3F244D286E756C6C3D3D653F766F696420303A652E6C6162656C293A22223B72657475726E20652E64697361626C6564262628743D6228302C227B307D2C2044697361626C65';
wwv_flow_imp.g_varchar2_table(13713) := '6420526561736F6E3A207B317D222C742C652E64697361626C656429292C747D72657475726E206E756C6C7D2C676574576964676574417269614C6162656C3A28293D3E6228302C22416374696F6E2057696467657422292C676574526F6C653A653D3E';
wwv_flow_imp.g_varchar2_table(13714) := '22616374696F6E223D3D3D652E6B696E643F226F7074696F6E223A22736570617261746F72222C676574576964676574526F6C653A28293D3E226C697374626F78227D7D29292C746869732E5F6C6973742E7374796C6528544D292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(13715) := '67697374657228746869732E5F6C6973742E6F6E4D6F757365436C69636B2828653D3E746869732E6F6E4C697374436C69636B2865292929292C746869732E5F726567697374657228746869732E5F6C6973742E6F6E4D6F7573654F7665722828653D3E';
wwv_flow_imp.g_varchar2_table(13716) := '746869732E6F6E4C697374486F7665722865292929292C746869732E5F726567697374657228746869732E5F6C6973742E6F6E4469644368616E6765466F637573282828293D3E746869732E6F6E466F63757328292929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(13717) := '74657228746869732E5F6C6973742E6F6E4469644368616E676553656C656374696F6E2828653D3E746869732E6F6E4C69737453656C656374696F6E2865292929292C746869732E5F616C6C4D656E754974656D733D6E2C746869732E5F6C6973742E73';
wwv_flow_imp.g_varchar2_table(13718) := '706C69636528302C746869732E5F6C6973742E6C656E6774682C746869732E5F616C6C4D656E754974656D73292C746869732E5F6C6973742E6C656E6774682626746869732E666F6375734E65787428297D666F637573436F6E646974696F6E2865297B';
wwv_flow_imp.g_varchar2_table(13719) := '72657475726E21652E64697361626C6564262622616374696F6E223D3D3D652E6B696E647D686964652865297B746869732E5F64656C65676174652E6F6E486964652865292C746869732E6374732E63616E63656C28292C746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(13720) := '7456696577536572766963652E68696465436F6E746578745669657728297D6C61796F75742865297B636F6E737420743D746869732E5F616C6C4D656E754974656D732E66696C7465722828653D3E22686561646572223D3D3D652E6B696E6429292E6C';
wwv_flow_imp.g_varchar2_table(13721) := '656E6774682C6E3D746869732E5F616C6C4D656E754974656D732E6C656E6774682A746869732E5F616374696F6E4C696E654865696768742B742A746869732E5F6865616465724C696E654865696768742D742A746869732E5F616374696F6E4C696E65';
wwv_flow_imp.g_varchar2_table(13722) := '4865696768743B746869732E5F6C6973742E6C61796F7574286E293B6C657420693D653B696628746869732E5F616C6C4D656E754974656D732E6C656E6774683E3D353029693D3338303B656C73657B636F6E737420743D746869732E5F616C6C4D656E';
wwv_flow_imp.g_varchar2_table(13723) := '754974656D732E6D6170282828652C74293D3E7B636F6E7374206E3D746869732E646F6D4E6F64652E6F776E6572446F63756D656E742E676574456C656D656E744279496428746869732E5F6C6973742E676574456C656D656E744944287429293B6966';
wwv_flow_imp.g_varchar2_table(13724) := '286E297B6E2E7374796C652E77696474683D226175746F223B636F6E737420653D6E2E676574426F756E64696E67436C69656E745265637428292E77696474683B72657475726E206E2E7374796C652E77696474683D22222C657D72657475726E20307D';
wwv_flow_imp.g_varchar2_table(13725) := '29293B693D4D6174682E6D6178282E2E2E742C65297D636F6E7374206F3D4D6174682E6D696E286E2C2E372A746869732E646F6D4E6F64652E6F776E6572446F63756D656E742E626F64792E636C69656E74486569676874293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(13726) := '732E5F6C6973742E6C61796F7574286F2C69292C746869732E646F6D4E6F64652E7374796C652E6865696768743D60247B6F7D7078602C746869732E5F6C6973742E646F6D466F63757328292C697D666F63757350726576696F757328297B746869732E';
wwv_flow_imp.g_varchar2_table(13727) := '5F6C6973742E666F63757350726576696F757328312C21302C766F696420302C746869732E666F637573436F6E646974696F6E297D666F6375734E65787428297B746869732E5F6C6973742E666F6375734E65787428312C21302C766F696420302C7468';
wwv_flow_imp.g_varchar2_table(13728) := '69732E666F637573436F6E646974696F6E297D61636365707453656C65637465642865297B636F6E737420743D746869732E5F6C6973742E676574466F63757328293B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D745B';
wwv_flow_imp.g_varchar2_table(13729) := '305D2C693D746869732E5F6C6973742E656C656D656E74286E293B69662821746869732E666F637573436F6E646974696F6E2869292972657475726E3B636F6E7374206F3D653F6E657720574D3A6E657720484D3B746869732E5F6C6973742E73657453';
wwv_flow_imp.g_varchar2_table(13730) := '656C656374696F6E285B6E5D2C6F297D6F6E4C69737453656C656374696F6E2865297B69662821652E656C656D656E74732E6C656E6774682972657475726E3B636F6E737420743D652E656C656D656E74735B305D3B742E6974656D2626746869732E66';
wwv_flow_imp.g_varchar2_table(13731) := '6F637573436F6E646974696F6E2874293F746869732E5F64656C65676174652E6F6E53656C65637428742E6974656D2C652E62726F777365724576656E7420696E7374616E63656F6620574D293A746869732E5F6C6973742E73657453656C656374696F';
wwv_flow_imp.g_varchar2_table(13732) := '6E285B5D297D6F6E466F63757328297B76617220652C743B636F6E7374206E3D746869732E5F6C6973742E676574466F63757328293B696628303D3D3D6E2E6C656E6774682972657475726E3B636F6E737420693D6E5B305D2C6F3D746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(13733) := '73742E656C656D656E742869293B6E756C6C3D3D3D28743D28653D746869732E5F64656C6567617465292E6F6E466F637573297C7C766F696420303D3D3D747C7C742E63616C6C28652C6F2E6974656D297D6173796E63206F6E4C697374486F76657228';
wwv_flow_imp.g_varchar2_table(13734) := '65297B636F6E737420743D652E656C656D656E743B696628742626742E6974656D2626746869732E666F637573436F6E646974696F6E287429297B696628746869732E5F64656C65676174652E6F6E486F766572262621742E64697361626C6564262622';
wwv_flow_imp.g_varchar2_table(13735) := '616374696F6E223D3D3D742E6B696E64297B636F6E737420653D617761697420746869732E5F64656C65676174652E6F6E486F76657228742E6974656D2C746869732E6374732E746F6B656E293B742E63616E507265766965773D653F652E63616E5072';
wwv_flow_imp.g_varchar2_table(13736) := '65766965773A766F696420307D652E696E6465782626746869732E5F6C6973742E73706C69636528652E696E6465782C312C5B745D297D746869732E5F6C6973742E736574466F63757328226E756D626572223D3D747970656F6620652E696E6465783F';
wwv_flow_imp.g_varchar2_table(13737) := '5B652E696E6465785D3A5B5D297D6F6E4C697374436C69636B2865297B652E656C656D656E742626746869732E666F637573436F6E646974696F6E28652E656C656D656E74292626746869732E5F6C6973742E736574466F637573285B5D297D7D3B6675';
wwv_flow_imp.g_varchar2_table(13738) := '6E6374696F6E20244D2865297B72657475726E20652E7265706C616365282F5C725C6E7C5C727C5C6E2F672C222022297D714D3D4F4D285B524D28342C6A45292C524D28352C2445295D2C714D293B76617220554D3D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(13739) := '72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B4C6D2822616374696F6E4261722E746F67676C65644261636B67726F756E64222C7B6461726B3A68762C6C696768743A68762C68634461726B3A68762C68634C69676874';
wwv_flow_imp.g_varchar2_table(13740) := '3A68767D2C6228302C224261636B67726F756E6420636F6C6F7220666F7220746F67676C656420616374696F6E206974656D7320696E20616374696F6E206261722E2229293B636F6E7374204B4D3D7B56697369626C653A6E6577206C642822636F6465';
wwv_flow_imp.g_varchar2_table(13741) := '416374696F6E4D656E7556697369626C65222C21312C6228302C22576865746865722074686520616374696F6E20776964676574206C6973742069732076697369626C652229297D2C474D3D70632822616374696F6E5769646765745365727669636522';
wwv_flow_imp.g_varchar2_table(13742) := '293B6C657420514D3D636C61737320657874656E6473206C747B67657420697356697369626C6528297B72657475726E204B4D2E56697369626C652E67657456616C756528746869732E5F636F6E746578744B657953657276696365297C7C21317D636F';
wwv_flow_imp.g_varchar2_table(13743) := '6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F636F6E7465787456696577536572766963653D652C746869732E5F636F6E746578744B6579536572766963653D742C746869732E5F696E7374616E74696174696F6E536572';
wwv_flow_imp.g_varchar2_table(13744) := '766963653D6E2C746869732E5F6C6973743D746869732E5F7265676973746572286E6577206374297D73686F7728652C742C6E2C692C6F2C732C72297B636F6E737420613D4B4D2E56697369626C652E62696E64546F28746869732E5F636F6E74657874';
wwv_flow_imp.g_varchar2_table(13745) := '4B657953657276696365292C6C3D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528714D2C652C742C6E2C69293B746869732E5F636F6E7465787456696577536572766963652E73686F77436F6E';
wwv_flow_imp.g_varchar2_table(13746) := '7465787456696577287B676574416E63686F723A28293D3E6F2C72656E6465723A653D3E28612E736574282130292C746869732E5F72656E64657257696467657428652C6C2C6E756C6C213D723F723A5B5D29292C6F6E486964653A653D3E7B612E7265';
wwv_flow_imp.g_varchar2_table(13747) := '73657428292C746869732E5F6F6E576964676574436C6F7365642865297D7D2C732C2131297D61636365707453656C65637465642865297B76617220743B6E756C6C3D3D3D28743D746869732E5F6C6973742E76616C7565297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(13748) := '747C7C742E61636365707453656C65637465642865297D666F63757350726576696F757328297B76617220652C743B6E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E5F6C697374297C7C766F696420303D3D3D653F766F696420303A652E';
wwv_flow_imp.g_varchar2_table(13749) := '76616C7565297C7C766F696420303D3D3D747C7C742E666F63757350726576696F757328297D666F6375734E65787428297B76617220652C743B6E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E5F6C697374297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(13750) := '653F766F696420303A652E76616C7565297C7C766F696420303D3D3D747C7C742E666F6375734E65787428297D686964652865297B76617220743B6E756C6C3D3D3D28743D746869732E5F6C6973742E76616C7565297C7C766F696420303D3D3D747C7C';
wwv_flow_imp.g_varchar2_table(13751) := '742E686964652865292C746869732E5F6C6973742E636C65617228297D5F72656E64657257696467657428652C742C6E297B76617220693B636F6E7374206F3D646F63756D656E742E637265617465456C656D656E74282264697622293B6966286F2E63';
wwv_flow_imp.g_varchar2_table(13752) := '6C6173734C6973742E6164642822616374696F6E2D77696467657422292C652E617070656E644368696C64286F292C746869732E5F6C6973742E76616C75653D742C21746869732E5F6C6973742E76616C7565297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(13753) := '224C69737420686173206E6F2076616C756522293B6F2E617070656E644368696C6428746869732E5F6C6973742E76616C75652E646F6D4E6F6465293B636F6E737420733D6E65772061742C723D646F63756D656E742E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(13754) := '282264697622292C613D652E617070656E644368696C642872293B612E636C6173734C6973742E6164642822636F6E746578742D766965772D626C6F636B22292C732E61646428627328612C61722E4D4F5553455F444F574E2C28653D3E652E73746F70';
wwv_flow_imp.g_varchar2_table(13755) := '50726F7061676174696F6E28292929293B636F6E7374206C3D646F63756D656E742E637265617465456C656D656E74282264697622292C633D652E617070656E644368696C64286C293B632E636C6173734C6973742E6164642822636F6E746578742D76';
wwv_flow_imp.g_varchar2_table(13756) := '6965772D706F696E746572426C6F636B22292C732E61646428627328632C61722E504F494E5445525F4D4F56452C2828293D3E632E72656D6F766528292929292C732E61646428627328632C61722E4D4F5553455F444F574E2C2828293D3E632E72656D';
wwv_flow_imp.g_varchar2_table(13757) := '6F766528292929293B6C657420643D303B6966286E2E6C656E677468297B636F6E737420653D746869732E5F637265617465416374696F6E42617228222E616374696F6E2D7769646765742D616374696F6E2D626172222C6E293B652626286F2E617070';
wwv_flow_imp.g_varchar2_table(13758) := '656E644368696C6428652E676574436F6E7461696E657228292E706172656E74456C656D656E74292C732E6164642865292C643D652E676574436F6E7461696E657228292E6F66667365745769647468297D636F6E737420683D6E756C6C3D3D3D28693D';
wwv_flow_imp.g_varchar2_table(13759) := '746869732E5F6C6973742E76616C7565297C7C766F696420303D3D3D693F766F696420303A692E6C61796F75742864293B6F2E7374796C652E77696474683D60247B687D7078603B636F6E737420753D732E616464286872286529293B72657475726E20';
wwv_flow_imp.g_varchar2_table(13760) := '732E61646428752E6F6E446964426C7572282828293D3E746869732E68696465282130292929292C737D5F637265617465416374696F6E42617228652C74297B69662821742E6C656E6774682972657475726E3B636F6E7374206E3D62722865292C693D';
wwv_flow_imp.g_varchar2_table(13761) := '6E6577206C4D286E293B72657475726E20692E7075736828742C7B69636F6E3A21312C6C6162656C3A21307D292C697D5F6F6E576964676574436C6F7365642865297B76617220743B6E756C6C3D3D3D28743D746869732E5F6C6973742E76616C756529';
wwv_flow_imp.g_varchar2_table(13762) := '7C7C766F696420303D3D3D747C7C742E686964652865297D7D3B514D3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765';
wwv_flow_imp.g_varchar2_table(13763) := '744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D526566';
wwv_flow_imp.g_varchar2_table(13764) := '6C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29';
wwv_flow_imp.g_varchar2_table(13765) := '297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B554D28302C6A45292C554D28312C6364292C554D28322C7563295D2C514D292C787028474D2C514D2C31293B636F';
wwv_flow_imp.g_varchar2_table(13766) := '6E737420594D3D313130303B766172205A4D2C584D3B506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A2268696465436F6465416374696F6E576964676574222C7469746C653A5F28302C22';
wwv_flow_imp.g_varchar2_table(13767) := '4869646520616374696F6E2077696467657422292C707265636F6E646974696F6E3A4B4D2E56697369626C652C6B657962696E64696E673A7B7765696768743A594D2C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D297D72756E';
wwv_flow_imp.g_varchar2_table(13768) := '2865297B652E67657428474D292E68696465282130297D7D292C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A2273656C65637450726576436F6465416374696F6E222C7469746C653A5F';
wwv_flow_imp.g_varchar2_table(13769) := '28302C2253656C6563742070726576696F757320616374696F6E22292C707265636F6E646974696F6E3A4B4D2E56697369626C652C6B657962696E64696E673A7B7765696768743A594D2C7072696D6172793A31362C7365636F6E646172793A5B323036';
wwv_flow_imp.g_varchar2_table(13770) := '345D2C6D61633A7B7072696D6172793A31362C7365636F6E646172793A5B323036342C3330325D7D7D7D297D72756E2865297B636F6E737420743D652E67657428474D293B7420696E7374616E63656F6620514D2626742E666F63757350726576696F75';
wwv_flow_imp.g_varchar2_table(13771) := '7328297D7D292C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A2273656C6563744E657874436F6465416374696F6E222C7469746C653A5F28302C2253656C656374206E65787420616374';
wwv_flow_imp.g_varchar2_table(13772) := '696F6E22292C707265636F6E646974696F6E3A4B4D2E56697369626C652C6B657962696E64696E673A7B7765696768743A594D2C7072696D6172793A31382C7365636F6E646172793A5B323036365D2C6D61633A7B7072696D6172793A31382C7365636F';
wwv_flow_imp.g_varchar2_table(13773) := '6E646172793A5B323036362C3330305D7D7D7D297D72756E2865297B636F6E737420743D652E67657428474D293B7420696E7374616E63656F6620514D2626742E666F6375734E65787428297D7D292C506428636C61737320657874656E6473204E647B';
wwv_flow_imp.g_varchar2_table(13774) := '636F6E7374727563746F7228297B7375706572287B69643A464D2C7469746C653A5F28302C224163636570742073656C656374656420616374696F6E22292C707265636F6E646974696F6E3A4B4D2E56697369626C652C6B657962696E64696E673A7B77';
wwv_flow_imp.g_varchar2_table(13775) := '65696768743A594D2C7072696D6172793A332C7365636F6E646172793A5B323133375D7D7D297D72756E2865297B636F6E737420743D652E67657428474D293B7420696E7374616E63656F6620514D2626742E61636365707453656C656374656428297D';
wwv_flow_imp.g_varchar2_table(13776) := '7D292C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A424D2C7469746C653A5F28302C22507265766965772073656C656374656420616374696F6E22292C707265636F6E646974696F6E3A';
wwv_flow_imp.g_varchar2_table(13777) := '4B4D2E56697369626C652C6B657962696E64696E673A7B7765696768743A594D2C7072696D6172793A323035317D7D297D72756E2865297B636F6E737420743D652E67657428474D293B7420696E7374616E63656F6620514D2626742E61636365707453';
wwv_flow_imp.g_varchar2_table(13778) := '656C6563746564282130297D7D292C66756E6374696F6E2865297B655B652E48696E743D315D3D2248696E74222C655B652E496E666F3D325D3D22496E666F222C655B652E5761726E696E673D345D3D225761726E696E67222C655B652E4572726F723D';
wwv_flow_imp.g_varchar2_table(13779) := '385D3D224572726F72227D285A4D7C7C285A4D3D7B7D29292C66756E6374696F6E2865297B652E636F6D706172653D66756E6374696F6E28652C74297B72657475726E20742D657D3B636F6E737420743D4F626A6563742E637265617465286E756C6C29';
wwv_flow_imp.g_varchar2_table(13780) := '3B745B652E4572726F725D3D6228302C224572726F7222292C745B652E5761726E696E675D3D6228302C225761726E696E6722292C745B652E496E666F5D3D6228302C22496E666F22292C652E746F537472696E673D66756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(13781) := '7475726E20745B655D7C7C22227D2C652E66726F6D53657665726974793D66756E6374696F6E2874297B7377697463682874297B636173652069442E4572726F723A72657475726E20652E4572726F723B636173652069442E5761726E696E673A726574';
wwv_flow_imp.g_varchar2_table(13782) := '75726E20652E5761726E696E673B636173652069442E496E666F3A72657475726E20652E496E666F3B636173652069442E49676E6F72653A72657475726E20652E48696E747D7D2C652E746F53657665726974793D66756E6374696F6E2874297B737769';
wwv_flow_imp.g_varchar2_table(13783) := '7463682874297B6361736520652E4572726F723A72657475726E2069442E4572726F723B6361736520652E5761726E696E673A72657475726E2069442E5761726E696E673B6361736520652E496E666F3A72657475726E2069442E496E666F3B63617365';
wwv_flow_imp.g_varchar2_table(13784) := '20652E48696E743A72657475726E2069442E49676E6F72657D7D7D285A4D7C7C285A4D3D7B7D29292C66756E6374696F6E2865297B636F6E737420743D22223B66756E6374696F6E206E28652C6E297B636F6E737420693D5B745D3B72657475726E2065';
wwv_flow_imp.g_varchar2_table(13785) := '2E736F757263653F692E7075736828652E736F757263652E7265706C6163652822C2A6222C225C5CC2A62229293A692E707573682874292C652E636F64653F22737472696E67223D3D747970656F6620652E636F64653F692E7075736828652E636F6465';
wwv_flow_imp.g_varchar2_table(13786) := '2E7265706C6163652822C2A6222C225C5CC2A62229293A692E7075736828652E636F64652E76616C75652E7265706C6163652822C2A6222C225C5CC2A62229293A692E707573682874292C766F69642030213D3D652E736576657269747926266E756C6C';
wwv_flow_imp.g_varchar2_table(13787) := '213D3D652E73657665726974793F692E70757368285A4D2E746F537472696E6728652E736576657269747929293A692E707573682874292C652E6D65737361676526266E3F692E7075736828652E6D6573736167652E7265706C6163652822C2A6222C22';
wwv_flow_imp.g_varchar2_table(13788) := '5C5CC2A62229293A692E707573682874292C766F69642030213D3D652E73746172744C696E654E756D62657226266E756C6C213D3D652E73746172744C696E654E756D6265723F692E7075736828652E73746172744C696E654E756D6265722E746F5374';
wwv_flow_imp.g_varchar2_table(13789) := '72696E672829293A692E707573682874292C766F69642030213D3D652E7374617274436F6C756D6E26266E756C6C213D3D652E7374617274436F6C756D6E3F692E7075736828652E7374617274436F6C756D6E2E746F537472696E672829293A692E7075';
wwv_flow_imp.g_varchar2_table(13790) := '73682874292C766F69642030213D3D652E656E644C696E654E756D62657226266E756C6C213D3D652E656E644C696E654E756D6265723F692E7075736828652E656E644C696E654E756D6265722E746F537472696E672829293A692E707573682874292C';
wwv_flow_imp.g_varchar2_table(13791) := '766F69642030213D3D652E656E64436F6C756D6E26266E756C6C213D3D652E656E64436F6C756D6E3F692E7075736828652E656E64436F6C756D6E2E746F537472696E672829293A692E707573682874292C692E707573682874292C692E6A6F696E2822';
wwv_flow_imp.g_varchar2_table(13792) := 'C2A622297D652E6D616B654B65793D66756E6374696F6E2865297B72657475726E206E28652C2130297D2C652E6D616B654B65794F7074696F6E616C4D6573736167653D6E7D28584D7C7C28584D3D7B7D29293B636F6E7374204A4D3D706328226D6172';
wwv_flow_imp.g_varchar2_table(13793) := '6B65725365727669636522292C65413D6E6577206C642822737570706F72746564436F6465416374696F6E222C2222292C74413D225F747970657363726970742E6170706C79466978416C6C436F6465416374696F6E223B636C617373206E4120657874';
wwv_flow_imp.g_varchar2_table(13794) := '656E6473206C747B636F6E7374727563746F7228652C742C6E2C693D323530297B737570657228292C746869732E5F656469746F723D652C746869732E5F6D61726B6572536572766963653D742C746869732E5F7369676E616C4368616E67653D6E2C74';
wwv_flow_imp.g_varchar2_table(13795) := '6869732E5F64656C61793D692C746869732E5F6175746F5472696767657254696D65723D746869732E5F7265676973746572286E6577202474292C746869732E5F726567697374657228746869732E5F6D61726B6572536572766963652E6F6E4D61726B';
wwv_flow_imp.g_varchar2_table(13796) := '65724368616E6765642828653D3E746869732E5F6F6E4D61726B65724368616E6765732865292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D';
wwv_flow_imp.g_varchar2_table(13797) := '3E746869732E5F7472794175746F5472696767657228292929297D747269676765722865297B636F6E737420743D746869732E5F67657452616E67654F6653656C656374696F6E556E6C65737357686974657370616365456E636C6F7365642865293B74';
wwv_flow_imp.g_varchar2_table(13798) := '6869732E5F7369676E616C4368616E676528743F7B747269676765723A652C73656C656374696F6E3A747D3A766F69642030297D5F6F6E4D61726B65724368616E6765732865297B636F6E737420743D746869732E5F656469746F722E6765744D6F6465';
wwv_flow_imp.g_varchar2_table(13799) := '6C28293B742626652E736F6D652828653D3E556C28652C742E7572692929292626746869732E5F7472794175746F5472696767657228297D5F7472794175746F5472696767657228297B746869732E5F6175746F5472696767657254696D65722E63616E';
wwv_flow_imp.g_varchar2_table(13800) := '63656C416E64536574282828293D3E7B746869732E74726967676572287B747970653A322C74726967676572416374696F6E3A61442E44656661756C747D297D292C746869732E5F64656C6179297D5F67657452616E67654F6653656C656374696F6E55';
wwv_flow_imp.g_varchar2_table(13801) := '6E6C65737357686974657370616365456E636C6F7365642865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E5F656469746F722E67657453656C656374696F6E28293B6966';
wwv_flow_imp.g_varchar2_table(13802) := '28313D3D3D652E747970652972657475726E20743B636F6E7374206E3D746869732E5F656469746F722E6765744F7074696F6E283635292E656E61626C65643B6966286E213D3D4D4C2E4F6666297B6966286E3D3D3D4D4C2E4F6E2972657475726E2074';
wwv_flow_imp.g_varchar2_table(13803) := '3B6966286E3D3D3D4D4C2E4F6E436F6465297B69662821742E6973456D70747928292972657475726E20743B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C7B6C696E654E756D6265723A6E2C636F6C756D6E3A697D3D';
wwv_flow_imp.g_varchar2_table(13804) := '742E676574506F736974696F6E28292C6F3D652E6765744C696E65436F6E74656E74286E293B696628303D3D3D6F2E6C656E6774682972657475726E3B696628313D3D3D69297B6966282F5C732F2E74657374286F5B305D292972657475726E7D656C73';
wwv_flow_imp.g_varchar2_table(13805) := '6520696628693D3D3D652E6765744C696E654D6178436F6C756D6E286E29297B6966282F5C732F2E74657374286F5B6F2E6C656E6774682D315D292972657475726E7D656C7365206966282F5C732F2E74657374286F5B692D325D2926262F5C732F2E74';
wwv_flow_imp.g_varchar2_table(13806) := '657374286F5B692D315D292972657475726E7D72657475726E20747D7D7D7661722069413B2166756E6374696F6E2865297B652E456D7074793D7B747970653A307D2C652E5472696767657265643D636C6173737B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(13807) := '2C6E297B746869732E747269676765723D652C746869732E706F736974696F6E3D742C746869732E5F63616E63656C6C61626C6550726F6D6973653D6E2C746869732E747970653D312C746869732E616374696F6E733D6E2E63617463682828653D3E7B';
wwv_flow_imp.g_varchar2_table(13808) := '69662854652865292972657475726E206F413B7468726F7720657D29297D63616E63656C28297B746869732E5F63616E63656C6C61626C6550726F6D6973652E63616E63656C28297D7D7D2869417C7C2869413D7B7D29293B636F6E7374206F413D4F62';
wwv_flow_imp.g_varchar2_table(13809) := '6A6563742E667265657A65287B616C6C416374696F6E733A5B5D2C76616C6964416374696F6E733A5B5D2C646973706F73653A28293D3E7B7D2C646F63756D656E746174696F6E3A5B5D2C6861734175746F4669783A21312C68617341494669783A2131';
wwv_flow_imp.g_varchar2_table(13810) := '2C616C6C414946697865733A21317D293B636C61737320734120657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E5F656469746F723D652C746869732E5F72656769737472793D';
wwv_flow_imp.g_varchar2_table(13811) := '742C746869732E5F6D61726B6572536572766963653D6E2C746869732E5F70726F6772657373536572766963653D6F2C746869732E5F636F6E66696775726174696F6E536572766963653D732C746869732E5F636F6465416374696F6E4F7261636C653D';
wwv_flow_imp.g_varchar2_table(13812) := '746869732E5F7265676973746572286E6577206374292C746869732E5F73746174653D69412E456D7074792C746869732E5F6F6E4469644368616E676553746174653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964';
wwv_flow_imp.g_varchar2_table(13813) := '4368616E676553746174653D746869732E5F6F6E4469644368616E676553746174652E6576656E742C746869732E5F646973706F7365643D21312C746869732E5F737570706F72746564436F6465416374696F6E733D65412E62696E64546F2869292C74';
wwv_flow_imp.g_varchar2_table(13814) := '6869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F75706461746528292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E446964';
wwv_flow_imp.g_varchar2_table(13815) := '4368616E67654D6F64656C4C616E6775616765282828293D3E746869732E5F75706461746528292929292C746869732E5F726567697374657228746869732E5F72656769737472792E6F6E4469644368616E6765282828293D3E746869732E5F75706461';
wwv_flow_imp.g_varchar2_table(13816) := '746528292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E676564283635292626746869732E5F75706461746528297D29';
wwv_flow_imp.g_varchar2_table(13817) := '29292C746869732E5F75706461746528297D646973706F736528297B746869732E5F646973706F7365647C7C28746869732E5F646973706F7365643D21302C73757065722E646973706F736528292C746869732E73657453746174652869412E456D7074';
wwv_flow_imp.g_varchar2_table(13818) := '792C213029297D5F73657474696E67456E61626C65644E6561726279517569636B666978657328297B76617220653B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F656469746F72297C7C766F696420303D3D3D653F766F696420303A652E';
wwv_flow_imp.g_varchar2_table(13819) := '6765744D6F64656C28293B72657475726E2121746869732E5F636F6E66696775726174696F6E536572766963652626746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E636F6465416374696F';
wwv_flow_imp.g_varchar2_table(13820) := '6E5769646765742E696E636C7564654E6561726279517569636B4669786573222C7B7265736F757263653A6E756C6C3D3D743F766F696420303A742E7572697D297D5F75706461746528297B696628746869732E5F646973706F7365642972657475726E';
wwv_flow_imp.g_varchar2_table(13821) := '3B746869732E5F636F6465416374696F6E4F7261636C652E76616C75653D766F696420302C746869732E73657453746174652869412E456D707479293B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B69662865262674';
wwv_flow_imp.g_varchar2_table(13822) := '6869732E5F72656769737472792E686173286529262621746869732E5F656469746F722E6765744F7074696F6E28393129297B636F6E737420743D746869732E5F72656769737472792E616C6C2865292E666C61744D61702828653D3E7B76617220743B';
wwv_flow_imp.g_varchar2_table(13823) := '72657475726E206E756C6C213D3D28743D652E70726F7669646564436F6465416374696F6E4B696E6473292626766F69642030213D3D743F743A5B5D7D29293B746869732E5F737570706F72746564436F6465416374696F6E732E73657428742E6A6F69';
wwv_flow_imp.g_varchar2_table(13824) := '6E2822202229292C746869732E5F636F6465416374696F6E4F7261636C652E76616C75653D6E6577206E4128746869732E5F656469746F722C746869732E5F6D61726B6572536572766963652C28743D3E7B766172206E3B69662821742972657475726E';
wwv_flow_imp.g_varchar2_table(13825) := '20766F696420746869732E73657453746174652869412E456D707479293B636F6E737420693D742E73656C656374696F6E2E6765745374617274506F736974696F6E28292C6F3D467428286173796E63206E3D3E7B76617220692C6F2C732C722C612C6C';
wwv_flow_imp.g_varchar2_table(13826) := '2C632C642C682C753B696628746869732E5F73657474696E67456E61626C65644E6561726279517569636B666978657328292626313D3D3D742E747269676765722E74797065262628742E747269676765722E74726967676572416374696F6E3D3D3D61';
wwv_flow_imp.g_varchar2_table(13827) := '442E517569636B4669787C7C286E756C6C3D3D3D286F3D6E756C6C3D3D3D28693D742E747269676765722E66696C746572297C7C766F696420303D3D3D693F766F696420303A692E696E636C756465297C7C766F696420303D3D3D6F3F766F696420303A';
wwv_flow_imp.g_varchar2_table(13828) := '6F2E636F6E7461696E732872442E517569636B466978292929297B636F6E737420693D617761697420794428746869732E5F72656769737472792C652C742E73656C656374696F6E2C742E747269676765722C43452E4E6F6E652C6E292C6F3D5B2E2E2E';
wwv_flow_imp.g_varchar2_table(13829) := '692E616C6C416374696F6E735D3B6966286E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E206F413B636F6E737420703D6E756C6C3D3D3D28733D692E76616C6964416374696F6E73297C7C766F696420303D3D3D733F76';
wwv_flow_imp.g_varchar2_table(13830) := '6F696420303A732E736F6D652828653D3E2121652E616374696F6E2E6B696E64262672442E517569636B4669782E636F6E7461696E73286E657720707828652E616374696F6E2E6B696E64292929292C673D746869732E5F6D61726B6572536572766963';
wwv_flow_imp.g_varchar2_table(13831) := '652E72656164287B7265736F757263653A652E7572697D293B69662870297B666F7228636F6E73742065206F6620692E76616C6964416374696F6E7329286E756C6C3D3D3D28613D6E756C6C3D3D3D28723D652E616374696F6E2E636F6D6D616E64297C';
wwv_flow_imp.g_varchar2_table(13832) := '7C766F696420303D3D3D723F766F696420303A722E617267756D656E7473297C7C766F696420303D3D3D613F766F696420303A612E736F6D652828653D3E22737472696E67223D3D747970656F6620652626652E696E636C756465732874412929292926';
wwv_flow_imp.g_varchar2_table(13833) := '2628652E616374696F6E2E646961676E6F73746963733D5B2E2E2E672E66696C7465722828653D3E652E72656C61746564496E666F726D6174696F6E29295D293B72657475726E7B76616C6964416374696F6E733A692E76616C6964416374696F6E732C';
wwv_flow_imp.g_varchar2_table(13834) := '616C6C416374696F6E733A6F2C646F63756D656E746174696F6E3A692E646F63756D656E746174696F6E2C6861734175746F4669783A692E6861734175746F4669782C68617341494669783A692E68617341494669782C616C6C414946697865733A692E';
wwv_flow_imp.g_varchar2_table(13835) := '616C6C414946697865732C646973706F73653A28293D3E7B692E646973706F736528297D7D7D69662821702626672E6C656E6774683E30297B636F6E737420733D742E73656C656374696F6E2E676574506F736974696F6E28293B6C657420723D732C61';
wwv_flow_imp.g_varchar2_table(13836) := '3D4E756D6265722E4D41585F56414C55453B636F6E737420703D5B2E2E2E692E76616C6964416374696F6E735D3B666F7228636F6E7374206D206F662067297B636F6E737420663D6D2E656E64436F6C756D6E2C763D6D2E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(13837) := '722C623D6D2E73746172744C696E654E756D6265723B696628763D3D3D732E6C696E654E756D6265727C7C623D3D3D732E6C696E654E756D626572297B723D6E6577206D6328762C66293B636F6E7374206D3D7B747970653A742E747269676765722E74';
wwv_flow_imp.g_varchar2_table(13838) := '7970652C74726967676572416374696F6E3A742E747269676765722E74726967676572416374696F6E2C66696C7465723A7B696E636C7564653A286E756C6C3D3D3D286C3D742E747269676765722E66696C746572297C7C766F696420303D3D3D6C3F76';
wwv_flow_imp.g_varchar2_table(13839) := '6F696420303A6C2E696E636C756465293F6E756C6C3D3D3D28633D742E747269676765722E66696C746572297C7C766F696420303D3D3D633F766F696420303A632E696E636C7564653A72442E517569636B4669787D2C6175746F4170706C793A742E74';
wwv_flow_imp.g_varchar2_table(13840) := '7269676765722E6175746F4170706C792C636F6E746578743A7B6E6F74417661696C61626C654D6573736167653A286E756C6C3D3D3D28643D742E747269676765722E636F6E74657874297C7C766F696420303D3D3D643F766F696420303A642E6E6F74';
wwv_flow_imp.g_varchar2_table(13841) := '417661696C61626C654D657373616765297C7C22222C706F736974696F6E3A727D7D2C623D6E657720616828722E6C696E654E756D6265722C722E636F6C756D6E2C722E6C696E654E756D6265722C722E636F6C756D6E292C5F3D617761697420794428';
wwv_flow_imp.g_varchar2_table(13842) := '746869732E5F72656769737472792C652C622C6D2C43452E4E6F6E652C6E293B69662830213D3D5F2E76616C6964416374696F6E732E6C656E677468297B666F7228636F6E73742065206F66205F2E76616C6964416374696F6E7329286E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(13843) := '28753D6E756C6C3D3D3D28683D652E616374696F6E2E636F6D6D616E64297C7C766F696420303D3D3D683F766F696420303A682E617267756D656E7473297C7C766F696420303D3D3D753F766F696420303A752E736F6D652828653D3E22737472696E67';
wwv_flow_imp.g_varchar2_table(13844) := '223D3D747970656F6620652626652E696E636C7564657328744129292929262628652E616374696F6E2E646961676E6F73746963733D5B2E2E2E672E66696C7465722828653D3E652E72656C61746564496E666F726D6174696F6E29295D293B303D3D3D';
wwv_flow_imp.g_varchar2_table(13845) := '692E616C6C416374696F6E732E6C656E67746826266F2E70757368282E2E2E5F2E616C6C416374696F6E73292C4D6174682E61627328732E636F6C756D6E2D66293C613F702E756E7368696674282E2E2E5F2E76616C6964416374696F6E73293A702E70';
wwv_flow_imp.g_varchar2_table(13846) := '757368282E2E2E5F2E76616C6964416374696F6E73297D613D4D6174682E61627328732E636F6C756D6E2D66297D7D636F6E7374206D3D702E66696C746572282828652C742C6E293D3E6E2E66696E64496E6465782828743D3E742E616374696F6E2E74';
wwv_flow_imp.g_varchar2_table(13847) := '69746C653D3D3D652E616374696F6E2E7469746C6529293D3D3D7429293B72657475726E206D2E736F7274282828652C74293D3E652E616374696F6E2E6973507265666572726564262621742E616374696F6E2E69735072656665727265643F2D313A21';
wwv_flow_imp.g_varchar2_table(13848) := '652E616374696F6E2E69735072656665727265642626742E616374696F6E2E69735072656665727265647C7C652E616374696F6E2E69734149262621742E616374696F6E2E697341493F313A21652E616374696F6E2E697341492626742E616374696F6E';
wwv_flow_imp.g_varchar2_table(13849) := '2E697341493F2D313A3029292C7B76616C6964416374696F6E733A6D2C616C6C416374696F6E733A6F2C646F63756D656E746174696F6E3A692E646F63756D656E746174696F6E2C6861734175746F4669783A692E6861734175746F4669782C68617341';
wwv_flow_imp.g_varchar2_table(13850) := '494669783A692E68617341494669782C616C6C414946697865733A692E616C6C414946697865732C646973706F73653A28293D3E7B692E646973706F736528297D7D7D7D72657475726E20794428746869732E5F72656769737472792C652C742E73656C';
wwv_flow_imp.g_varchar2_table(13851) := '656374696F6E2C742E747269676765722C43452E4E6F6E652C6E297D29293B313D3D3D742E747269676765722E747970652626286E756C6C3D3D3D286E3D746869732E5F70726F677265737353657276696365297C7C766F696420303D3D3D6E7C7C6E2E';
wwv_flow_imp.g_varchar2_table(13852) := '73686F775768696C65286F2C32353029293B636F6E737420733D6E65772069412E54726967676572656428742E747269676765722C692C6F293B6C657420723D21313B313D3D3D746869732E5F73746174652E74797065262628723D313D3D3D74686973';
wwv_flow_imp.g_varchar2_table(13853) := '2E5F73746174652E747269676765722E747970652626313D3D3D732E747970652626323D3D3D732E747269676765722E747970652626746869732E5F73746174652E706F736974696F6E213D3D732E706F736974696F6E292C723F73657454696D656F75';
wwv_flow_imp.g_varchar2_table(13854) := '74282828293D3E7B746869732E73657453746174652873297D292C353030293A746869732E73657453746174652873297D292C766F69642030292C746869732E5F636F6465416374696F6E4F7261636C652E76616C75652E74726967676572287B747970';
wwv_flow_imp.g_varchar2_table(13855) := '653A322C74726967676572416374696F6E3A61442E44656661756C747D297D656C736520746869732E5F737570706F72746564436F6465416374696F6E732E726573657428297D747269676765722865297B76617220743B6E756C6C3D3D3D28743D7468';
wwv_flow_imp.g_varchar2_table(13856) := '69732E5F636F6465416374696F6E4F7261636C652E76616C7565297C7C766F696420303D3D3D747C7C742E747269676765722865297D736574537461746528652C74297B65213D3D746869732E5F7374617465262628313D3D3D746869732E5F73746174';
wwv_flow_imp.g_varchar2_table(13857) := '652E747970652626746869732E5F73746174652E63616E63656C28292C746869732E5F73746174653D652C747C7C746869732E5F646973706F7365647C7C746869732E5F6F6E4469644368616E676553746174652E66697265286529297D7D7661722072';
wwv_flow_imp.g_varchar2_table(13858) := '412C61413D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206C413D72413D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(13859) := '2E676574436F6E747269627574696F6E2872412E4944297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C64297B737570657228292C746869732E5F636F6D6D616E64536572766963653D722C746869732E5F636F6E66';
wwv_flow_imp.g_varchar2_table(13860) := '696775726174696F6E536572766963653D612C746869732E5F616374696F6E576964676574536572766963653D6C2C746869732E5F696E7374616E74696174696F6E536572766963653D632C746869732E5F74656C656D65747279536572766963653D64';
wwv_flow_imp.g_varchar2_table(13861) := '2C746869732E5F616374697665436F6465416374696F6E733D746869732E5F7265676973746572286E6577206374292C746869732E5F73686F7744697361626C65643D21312C746869732E5F646973706F7365643D21312C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(13862) := '3D652C746869732E5F6D6F64656C3D746869732E5F7265676973746572286E657720734128746869732E5F656469746F722C6F2E636F6465416374696F6E50726F76696465722C742C6E2C732C6129292C746869732E5F72656769737465722874686973';
wwv_flow_imp.g_varchar2_table(13863) := '2E5F6D6F64656C2E6F6E4469644368616E676553746174652828653D3E746869732E7570646174652865292929292C746869732E5F6C6967687442756C625769646765743D6E6577206969282828293D3E7B636F6E737420653D746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(13864) := '6F722E676574436F6E747269627574696F6E2856442E4944293B72657475726E20652626746869732E5F726567697374657228652E6F6E436C69636B2828653D3E746869732E73686F77436F6465416374696F6E7346726F6D4C6967687462756C622865';
wwv_flow_imp.g_varchar2_table(13865) := '2E616374696F6E732C65292929292C657D29292C746869732E5F7265736F6C7665723D692E637265617465496E7374616E6365286B44292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644C61796F75744368616E67';
wwv_flow_imp.g_varchar2_table(13866) := '65282828293D3E746869732E5F616374696F6E576964676574536572766963652E6869646528292929297D646973706F736528297B746869732E5F646973706F7365643D21302C73757065722E646973706F736528297D6173796E632073686F77436F64';
wwv_flow_imp.g_varchar2_table(13867) := '65416374696F6E7346726F6D4C6967687462756C6228652C74297B696628746869732E5F74656C656D65747279536572766963652E7075626C69634C6F67322822636F6465416374696F6E2E73686F77436F6465416374696F6E7346726F6D4C69676874';
wwv_flow_imp.g_varchar2_table(13868) := '62756C62222C7B636F6465416374696F6E4C6973744C656E6774683A652E76616C6964416374696F6E732E6C656E6774682C636F6465416374696F6E733A652E76616C6964416374696F6E732E6D61702828653D3E652E616374696F6E2E7469746C6529';
wwv_flow_imp.g_varchar2_table(13869) := '292C636F6465416374696F6E50726F7669646572733A652E76616C6964416374696F6E732E6D61702828653D3E7B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D652E70726F7669646572297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(13870) := '3D3D3D743F766F696420303A742E646973706C61794E616D65292626766F69642030213D3D6E3F6E3A22227D29297D292C652E616C6C414946697865732626313D3D3D652E76616C6964416374696F6E732E6C656E677468297B636F6E737420743D652E';
wwv_flow_imp.g_varchar2_table(13871) := '76616C6964416374696F6E735B305D2C6E3D742E616374696F6E2E636F6D6D616E643B72657475726E206E262622696E6C696E65436861742E7374617274223D3D3D6E2E696426266E2E617267756D656E747326266E2E617267756D656E74732E6C656E';
wwv_flow_imp.g_varchar2_table(13872) := '6774683E3D312626286E2E617267756D656E74735B305D3D7B2E2E2E6E2E617267756D656E74735B305D2C6175746F53656E643A21317D292C766F696420617761697420746869732E5F6170706C79436F6465416374696F6E28742C21312C21312C4344';
wwv_flow_imp.g_varchar2_table(13873) := '2E46726F6D41494C6967687462756C62297D617761697420746869732E73686F77436F6465416374696F6E4C69737428652C742C7B696E636C75646544697361626C6564416374696F6E733A21312C66726F6D4C6967687462756C623A21307D297D7368';
wwv_flow_imp.g_varchar2_table(13874) := '6F77436F6465416374696F6E7328652C742C6E297B72657475726E20746869732E73686F77436F6465416374696F6E4C69737428742C6E2C7B696E636C75646544697361626C6564416374696F6E733A21312C66726F6D4C6967687462756C623A21317D';
wwv_flow_imp.g_varchar2_table(13875) := '297D6D616E75616C54726967676572417443757272656E74506F736974696F6E28652C742C6E2C69297B766172206F3B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B6E756C6C3D3D3D286F3D62452E67657428';
wwv_flow_imp.g_varchar2_table(13876) := '746869732E5F656469746F7229297C7C766F696420303D3D3D6F7C7C6F2E636C6F73654D65737361676528293B636F6E737420733D746869732E5F656469746F722E676574506F736974696F6E28293B746869732E5F74726967676572287B747970653A';
wwv_flow_imp.g_varchar2_table(13877) := '312C74726967676572416374696F6E3A742C66696C7465723A6E2C6175746F4170706C793A692C636F6E746578743A7B6E6F74417661696C61626C654D6573736167653A652C706F736974696F6E3A737D7D297D5F747269676765722865297B72657475';
wwv_flow_imp.g_varchar2_table(13878) := '726E20746869732E5F6D6F64656C2E747269676765722865297D6173796E63205F6170706C79436F6465416374696F6E28652C742C6E2C69297B7472797B617761697420746869732E5F696E7374616E74696174696F6E536572766963652E696E766F6B';
wwv_flow_imp.g_varchar2_table(13879) := '6546756E6374696F6E2853442C652C692C7B707265766965773A6E2C656469746F723A746869732E5F656469746F727D297D66696E616C6C797B742626746869732E5F74726967676572287B747970653A322C74726967676572416374696F6E3A61442E';
wwv_flow_imp.g_varchar2_table(13880) := '517569636B4669782C66696C7465723A7B7D7D297D7D6173796E63207570646174652865297B76617220742C6E2C692C6F2C732C722C613B69662831213D3D652E747970652972657475726E20766F6964286E756C6C3D3D3D28743D746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(13881) := '67687442756C625769646765742E72617756616C7565297C7C766F696420303D3D3D747C7C742E686964652829293B6C6574206C3B7472797B6C3D617761697420652E616374696F6E737D63617463682865297B72657475726E20766F6964206B652865';
wwv_flow_imp.g_varchar2_table(13882) := '297D69662821746869732E5F646973706F736564296966286E756C6C3D3D3D286E3D746869732E5F6C6967687442756C625769646765742E76616C7565297C7C766F696420303D3D3D6E7C7C6E2E757064617465286C2C652E747269676765722C652E70';
wwv_flow_imp.g_varchar2_table(13883) := '6F736974696F6E292C313D3D3D652E747269676765722E74797065297B6966286E756C6C3D3D3D28693D652E747269676765722E66696C746572297C7C766F696420303D3D3D693F766F696420303A692E696E636C756465297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(13884) := '69732E74727947657456616C6964416374696F6E546F4170706C7928652E747269676765722C6C293B69662874297B7472797B6E756C6C3D3D3D286F3D746869732E5F6C6967687442756C625769646765742E76616C7565297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(13885) := '6F7C7C6F2E6869646528292C617761697420746869732E5F6170706C79436F6465416374696F6E28742C21312C21312C43442E46726F6D436F6465416374696F6E73297D66696E616C6C797B6C2E646973706F736528297D72657475726E7D696628652E';
wwv_flow_imp.g_varchar2_table(13886) := '747269676765722E636F6E74657874297B636F6E737420743D746869732E676574496E76616C6964416374696F6E54686174576F756C64486176654265656E4170706C69656428652E747269676765722C6C293B696628742626742E616374696F6E2E64';
wwv_flow_imp.g_varchar2_table(13887) := '697361626C65642972657475726E206E756C6C3D3D3D28733D62452E67657428746869732E5F656469746F7229297C7C766F696420303D3D3D737C7C732E73686F774D65737361676528742E616374696F6E2E64697361626C65642C652E747269676765';
wwv_flow_imp.g_varchar2_table(13888) := '722E636F6E746578742E706F736974696F6E292C766F6964206C2E646973706F736528297D7D636F6E737420743D2121286E756C6C3D3D3D28723D652E747269676765722E66696C746572297C7C766F696420303D3D3D723F766F696420303A722E696E';
wwv_flow_imp.g_varchar2_table(13889) := '636C756465293B696628652E747269676765722E636F6E74657874262628216C2E616C6C416374696F6E732E6C656E6774687C7C21742626216C2E76616C6964416374696F6E732E6C656E677468292972657475726E206E756C6C3D3D3D28613D62452E';
wwv_flow_imp.g_varchar2_table(13890) := '67657428746869732E5F656469746F7229297C7C766F696420303D3D3D617C7C612E73686F774D65737361676528652E747269676765722E636F6E746578742E6E6F74417661696C61626C654D6573736167652C652E747269676765722E636F6E746578';
wwv_flow_imp.g_varchar2_table(13891) := '742E706F736974696F6E292C746869732E5F616374697665436F6465416374696F6E732E76616C75653D6C2C766F6964206C2E646973706F736528293B746869732E5F616374697665436F6465416374696F6E732E76616C75653D6C2C746869732E7368';
wwv_flow_imp.g_varchar2_table(13892) := '6F77436F6465416374696F6E4C697374286C2C746869732E746F436F6F72647328652E706F736974696F6E292C7B696E636C75646544697361626C6564416374696F6E733A742C66726F6D4C6967687462756C623A21317D297D656C736520746869732E';
wwv_flow_imp.g_varchar2_table(13893) := '5F616374696F6E576964676574536572766963652E697356697369626C653F6C2E646973706F736528293A746869732E5F616374697665436F6465416374696F6E732E76616C75653D6C7D676574496E76616C6964416374696F6E54686174576F756C64';
wwv_flow_imp.g_varchar2_table(13894) := '486176654265656E4170706C69656428652C74297B696628742E616C6C416374696F6E732E6C656E6774682972657475726E226669727374223D3D3D652E6175746F4170706C792626303D3D3D742E76616C6964416374696F6E732E6C656E6774687C7C';
wwv_flow_imp.g_varchar2_table(13895) := '22696653696E676C65223D3D3D652E6175746F4170706C792626313D3D3D742E616C6C416374696F6E732E6C656E6774683F742E616C6C416374696F6E732E66696E642828287B616374696F6E3A657D293D3E652E64697361626C656429293A766F6964';
wwv_flow_imp.g_varchar2_table(13896) := '20307D74727947657456616C6964416374696F6E546F4170706C7928652C74297B696628742E76616C6964416374696F6E732E6C656E6774682972657475726E226669727374223D3D3D652E6175746F4170706C792626742E76616C6964416374696F6E';
wwv_flow_imp.g_varchar2_table(13897) := '732E6C656E6774683E307C7C22696653696E676C65223D3D3D652E6175746F4170706C792626313D3D3D742E76616C6964416374696F6E732E6C656E6774683F742E76616C6964416374696F6E735B305D3A766F696420307D6173796E632073686F7743';
wwv_flow_imp.g_varchar2_table(13898) := '6F6465416374696F6E4C69737428652C742C6E297B636F6E737420693D746869732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C6F3D746869732E5F656469746F722E676574446F6D4E6F646528293B';
wwv_flow_imp.g_varchar2_table(13899) := '696628216F2972657475726E3B636F6E737420733D6E2E696E636C75646544697361626C6564416374696F6E73262628746869732E5F73686F7744697361626C65647C7C303D3D3D652E76616C6964416374696F6E732E6C656E677468293F652E616C6C';
wwv_flow_imp.g_varchar2_table(13900) := '416374696F6E733A652E76616C6964416374696F6E733B69662821732E6C656E6774682972657475726E3B636F6E737420723D6D632E697349506F736974696F6E2874293F746869732E746F436F6F7264732874293A742C613D7B6F6E53656C6563743A';
wwv_flow_imp.g_varchar2_table(13901) := '6173796E6328652C74293D3E7B746869732E5F6170706C79436F6465416374696F6E28652C21302C2121742C6E2E66726F6D4C6967687462756C623F43442E46726F6D41494C6967687462756C623A43442E46726F6D436F6465416374696F6E73292C74';
wwv_flow_imp.g_varchar2_table(13902) := '6869732E5F616374696F6E576964676574536572766963652E68696465282131292C692E636C65617228297D2C6F6E486964653A743D3E7B766172206F3B6E756C6C3D3D3D286F3D746869732E5F656469746F72297C7C766F696420303D3D3D6F7C7C6F';
wwv_flow_imp.g_varchar2_table(13903) := '2E666F63757328292C692E636C65617228292C6E2E66726F6D4C6967687462756C622626766F69642030213D3D742626746869732E5F74656C656D65747279536572766963652E7075626C69634C6F67322822636F6465416374696F6E2E73686F77436F';
wwv_flow_imp.g_varchar2_table(13904) := '6465416374696F6E4C6973742E6F6E48696465222C7B636F6465416374696F6E4C6973744C656E6774683A652E76616C6964416374696F6E732E6C656E6774682C64696443616E63656C3A747D297D2C6F6E486F7665723A6173796E6328652C74293D3E';
wwv_flow_imp.g_varchar2_table(13905) := '7B766172206E3B696628742E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6C657420693D21313B636F6E7374206F3D652E616374696F6E2E6B696E643B6966286F297B636F6E737420653D6E6577207078286F293B693D';
wwv_flow_imp.g_varchar2_table(13906) := '5B72442E5265666163746F72457874726163742C72442E5265666163746F72496E6C696E652C72442E5265666163746F72526577726974652C72442E5265666163746F724D6F76652C72442E536F757263655D2E736F6D652828743D3E742E636F6E7461';
wwv_flow_imp.g_varchar2_table(13907) := '696E7328652929297D72657475726E7B63616E507265766965773A697C7C2121286E756C6C3D3D3D286E3D652E616374696F6E2E65646974297C7C766F696420303D3D3D6E3F766F696420303A6E2E65646974732E6C656E677468297D7D2C6F6E466F63';
wwv_flow_imp.g_varchar2_table(13908) := '75733A653D3E7B76617220742C6E3B696628652626652E616374696F6E297B636F6E7374206F3D652E616374696F6E2E72616E6765732C733D652E616374696F6E2E646961676E6F73746963733B696628692E636C65617228292C6F26266F2E6C656E67';
wwv_flow_imp.g_varchar2_table(13909) := '74683E30297B636F6E737420653D732626286E756C6C3D3D733F766F696420303A732E6C656E677468293E313F732E6D61702828653D3E287B72616E67653A652C6F7074696F6E733A72412E4445434F524154494F4E7D2929293A6F2E6D61702828653D';
wwv_flow_imp.g_varchar2_table(13910) := '3E287B72616E67653A652C6F7074696F6E733A72412E4445434F524154494F4E7D2929293B692E7365742865297D656C736520696628732626732E6C656E6774683E30297B636F6E737420653D732E6D61702828653D3E287B72616E67653A652C6F7074';
wwv_flow_imp.g_varchar2_table(13911) := '696F6E733A72412E4445434F524154494F4E7D2929293B692E7365742865293B636F6E7374206F3D735B305D3B6F2E73746172744C696E654E756D62657226266F2E7374617274436F6C756D6E26264A72286228302C22436F6E746578743A207B307D20';
wwv_flow_imp.g_varchar2_table(13912) := '6174206C696E65207B317D20616E6420636F6C756D6E207B327D2E222C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D743F766F696420303A742E676574576F';
wwv_flow_imp.g_varchar2_table(13913) := '72644174506F736974696F6E287B6C696E654E756D6265723A6F2E73746172744C696E654E756D6265722C636F6C756D6E3A6F2E7374617274436F6C756D6E7D29297C7C766F696420303D3D3D6E3F766F696420303A6E2E776F72642C6F2E7374617274';
wwv_flow_imp.g_varchar2_table(13914) := '4C696E654E756D6265722C6F2E7374617274436F6C756D6E29297D7D656C736520692E636C65617228297D7D3B746869732E5F616374696F6E576964676574536572766963652E73686F772822636F6465416374696F6E576964676574222C21302C6675';
wwv_flow_imp.g_varchar2_table(13915) := '6E6374696F6E28652C742C6E297B69662821742972657475726E20652E6D61702828653D3E7B76617220743B72657475726E7B6B696E643A22616374696F6E222C6974656D3A652C67726F75703A41442C64697361626C65643A2121652E616374696F6E';
wwv_flow_imp.g_varchar2_table(13916) := '2E64697361626C65642C6C6162656C3A652E616374696F6E2E64697361626C65647C7C652E616374696F6E2E7469746C652C63616E507265766965773A2121286E756C6C3D3D3D28743D652E616374696F6E2E65646974297C7C766F696420303D3D3D74';
wwv_flow_imp.g_varchar2_table(13917) := '3F766F696420303A742E65646974732E6C656E677468297D7D29293B636F6E737420693D4E442E6D61702828653D3E287B67726F75703A652C616374696F6E733A5B5D7D2929293B666F7228636F6E73742074206F662065297B636F6E737420653D742E';
wwv_flow_imp.g_varchar2_table(13918) := '616374696F6E2E6B696E643F6E657720707828742E616374696F6E2E6B696E64293A70782E4E6F6E653B666F7228636F6E7374206E206F662069296966286E2E67726F75702E6B696E642E636F6E7461696E73286529297B6E2E616374696F6E732E7075';
wwv_flow_imp.g_varchar2_table(13919) := '73682874293B627265616B7D7D636F6E7374206F3D5B5D3B666F7228636F6E73742065206F66206929696628652E616374696F6E732E6C656E677468297B6F2E70757368287B6B696E643A22686561646572222C67726F75703A652E67726F75707D293B';
wwv_flow_imp.g_varchar2_table(13920) := '666F7228636F6E73742074206F6620652E616374696F6E73297B636F6E737420693D652E67726F75703B6F2E70757368287B6B696E643A22616374696F6E222C6974656D3A742C67726F75703A742E616374696F6E2E697341493F7B7469746C653A692E';
wwv_flow_imp.g_varchar2_table(13921) := '7469746C652C6B696E643A692E6B696E642C69636F6E3A4C6C2E737061726B6C657D3A692C6C6162656C3A742E616374696F6E2E7469746C652C64697361626C65643A2121742E616374696F6E2E64697361626C65642C6B657962696E64696E673A6E28';
wwv_flow_imp.g_varchar2_table(13922) := '742E616374696F6E297D297D7D72657475726E206F7D28732C746869732E5F73686F756C6453686F774865616465727328292C746869732E5F7265736F6C7665722E6765745265736F6C7665722829292C612C722C6F2C746869732E5F67657441637469';
wwv_flow_imp.g_varchar2_table(13923) := '6F6E426172416374696F6E7328652C742C6E29297D746F436F6F7264732865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E7B783A302C793A307D3B746869732E5F656469746F722E72657665616C506F7369';
wwv_flow_imp.g_varchar2_table(13924) := '74696F6E28652C31292C746869732E5F656469746F722E72656E64657228293B636F6E737420743D746869732E5F656469746F722E6765745363726F6C6C656456697369626C65506F736974696F6E2865292C6E3D417328746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(13925) := '2E676574446F6D4E6F64652829293B72657475726E7B783A6E2E6C6566742B742E6C6566742C793A6E2E746F702B742E746F702B742E6865696768747D7D5F73686F756C6453686F774865616465727328297B76617220653B636F6E737420743D6E756C';
wwv_flow_imp.g_varchar2_table(13926) := '6C3D3D3D28653D746869732E5F656469746F72297C7C766F696420303D3D3D653F766F696420303A652E6765744D6F64656C28293B72657475726E20746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469';
wwv_flow_imp.g_varchar2_table(13927) := '746F722E636F6465416374696F6E5769646765742E73686F7748656164657273222C7B7265736F757263653A6E756C6C3D3D743F766F696420303A742E7572697D297D5F676574416374696F6E426172416374696F6E7328652C742C6E297B6966286E2E';
wwv_flow_imp.g_varchar2_table(13928) := '66726F6D4C6967687462756C622972657475726E5B5D3B636F6E737420693D652E646F63756D656E746174696F6E2E6D61702828653D3E7B76617220743B72657475726E7B69643A652E69642C6C6162656C3A652E7469746C652C746F6F6C7469703A6E';
wwv_flow_imp.g_varchar2_table(13929) := '756C6C213D3D28743D652E746F6F6C746970292626766F69642030213D3D743F743A22222C636C6173733A766F696420302C656E61626C65643A21302C72756E3A28293D3E7B76617220743B72657475726E20746869732E5F636F6D6D616E6453657276';
wwv_flow_imp.g_varchar2_table(13930) := '6963652E65786563757465436F6D6D616E6428652E69642C2E2E2E6E756C6C213D3D28743D652E617267756D656E7473292626766F69642030213D3D743F743A5B5D297D7D7D29293B72657475726E206E2E696E636C75646544697361626C6564416374';
wwv_flow_imp.g_varchar2_table(13931) := '696F6E732626652E76616C6964416374696F6E732E6C656E6774683E302626652E616C6C416374696F6E732E6C656E677468213D3D652E76616C6964416374696F6E732E6C656E6774682626692E7075736828746869732E5F73686F7744697361626C65';
wwv_flow_imp.g_varchar2_table(13932) := '643F7B69643A22686964654D6F7265416374696F6E73222C6C6162656C3A6228302C22486964652044697361626C656422292C656E61626C65643A21302C746F6F6C7469703A22222C636C6173733A766F696420302C72756E3A28293D3E28746869732E';
wwv_flow_imp.g_varchar2_table(13933) := '5F73686F7744697361626C65643D21312C746869732E73686F77436F6465416374696F6E4C69737428652C742C6E29297D3A7B69643A2273686F774D6F7265416374696F6E73222C6C6162656C3A6228302C2253686F772044697361626C656422292C65';
wwv_flow_imp.g_varchar2_table(13934) := '6E61626C65643A21302C746F6F6C7469703A22222C636C6173733A766F696420302C72756E3A28293D3E28746869732E5F73686F7744697361626C65643D21302C746869732E73686F77436F6465416374696F6E4C69737428652C742C6E29297D292C69';
wwv_flow_imp.g_varchar2_table(13935) := '7D7D3B66756E6374696F6E2063412865297B72657475726E2057632E72656765782865412E6B65797328295B305D2C6E6577205265674578702822285C5C737C5E29222B636928652E76616C7565292B225C5C622229297D6C412E49443D22656469746F';
wwv_flow_imp.g_varchar2_table(13936) := '722E636F6E747269622E636F6465416374696F6E436F6E74726F6C6C6572222C6C412E4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22717569636B6669782D686967686C69676874222C636C6173734E616D';
wwv_flow_imp.g_varchar2_table(13937) := '653A22717569636B6669782D656469742D686967686C69676874227D292C6C413D72413D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F62';
wwv_flow_imp.g_varchar2_table(13938) := '6A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F726174';
wwv_flow_imp.g_varchar2_table(13939) := '6529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C7229';
wwv_flow_imp.g_varchar2_table(13940) := '3A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B614128312C4A4D292C614128322C6364292C614128332C7563292C614128342C7878292C614128';
wwv_flow_imp.g_varchar2_table(13941) := '352C5345292C614128362C7863292C614128372C6670292C614128382C474D292C614128392C7563292C61412831302C4F64295D2C6C41292C5662282828652C74293D3E7B2828652C6E293D3E7B6E2626742E61646452756C6528602E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(13942) := '656469746F72202E717569636B6669782D656469742D686967686C69676874207B206261636B67726F756E642D636F6C6F723A20247B6E7D3B207D60297D2928302C652E676574436F6C6F72286D6629293B636F6E7374206E3D652E676574436F6C6F72';
wwv_flow_imp.g_varchar2_table(13943) := '286666293B6E2626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E717569636B6669782D656469742D686967686C69676874207B20626F726465723A2031707820247B416228652E74797065293F22646F74746564223A22736F6C69';
wwv_flow_imp.g_varchar2_table(13944) := '64227D20247B6E7D3B20626F782D73697A696E673A20626F726465722D626F783B207D60297D29293B636F6E73742064413D7B747970653A226F626A656374222C64656661756C74536E6970706574733A5B7B626F64793A7B6B696E643A22227D7D5D2C';
wwv_flow_imp.g_varchar2_table(13945) := '70726F706572746965733A7B6B696E643A7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C224B696E64206F662074686520636F646520616374696F6E20746F2072756E2E22297D2C6170706C793A7B747970653A22737472';
wwv_flow_imp.g_varchar2_table(13946) := '696E67222C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768656E207468652072657475726E656420616374696F6E7320617265206170706C6965642E22292C64656661756C743A22696653696E676C65222C656E756D3A5B226669';
wwv_flow_imp.g_varchar2_table(13947) := '727374222C22696653696E676C65222C226E65766572225D2C656E756D4465736372697074696F6E733A5B6228302C22416C77617973206170706C79207468652066697273742072657475726E656420636F646520616374696F6E2E22292C6228302C22';
wwv_flow_imp.g_varchar2_table(13948) := '4170706C79207468652066697273742072657475726E656420636F646520616374696F6E20696620697420697320746865206F6E6C79206F6E652E22292C6228302C22446F206E6F74206170706C79207468652072657475726E656420636F6465206163';
wwv_flow_imp.g_varchar2_table(13949) := '74696F6E732E22295D7D2C7072656665727265643A7B747970653A22626F6F6C65616E222C64656661756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C73206966206F6E6C792070726566657272656420636F646520616374';
wwv_flow_imp.g_varchar2_table(13950) := '696F6E732073686F756C642062652072657475726E65642E22297D7D7D3B66756E6374696F6E20684128652C742C6E2C692C6F3D61442E44656661756C74297B696628652E6861734D6F64656C2829297B636F6E737420733D6C412E6765742865293B6E';
wwv_flow_imp.g_varchar2_table(13951) := '756C6C3D3D737C7C732E6D616E75616C54726967676572417443757272656E74506F736974696F6E28742C6F2C6E2C69297D7D4A64286C412E49442C6C412C33292C4A642856442E49442C56442C34292C5A6428636C61737320657874656E6473205564';
wwv_flow_imp.g_varchar2_table(13952) := '7B636F6E7374727563746F7228297B7375706572287B69643A75442C6C6162656C3A6228302C22517569636B204669782E2E2E22292C616C6961733A22517569636B204669782E2E2E222C707265636F6E646974696F6E3A57632E616E64286C682E7772';
wwv_flow_imp.g_varchar2_table(13953) := '697461626C652C6C682E686173436F6465416374696F6E7350726F7669646572292C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323133372C7765696768743A3130307D7D297D72756E28652C';
wwv_flow_imp.g_varchar2_table(13954) := '74297B72657475726E20684128742C6228302C224E6F20636F646520616374696F6E7320617661696C61626C6522292C766F696420302C766F696420302C61442E517569636B466978297D7D292C5A6428636C61737320657874656E64732055647B636F';
wwv_flow_imp.g_varchar2_table(13955) := '6E7374727563746F7228297B7375706572287B69643A67442C6C6162656C3A6228302C225265666163746F722E2E2E22292C616C6961733A225265666163746F722E2E2E222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C';
wwv_flow_imp.g_varchar2_table(13956) := '652C6C682E686173436F6465416374696F6E7350726F7669646572292C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A333132302C6D61633A7B7072696D6172793A313332387D2C776569676874';
wwv_flow_imp.g_varchar2_table(13957) := '3A3130307D2C636F6E746578744D656E754F7074733A7B67726F75703A22315F6D6F64696669636174696F6E222C6F726465723A322C7768656E3A57632E616E64286C682E7772697461626C652C63412872442E5265666163746F7229297D2C6D657461';
wwv_flow_imp.g_varchar2_table(13958) := '646174613A7B6465736372697074696F6E3A225265666163746F722E2E2E222C617267733A5B7B6E616D653A2261726773222C736368656D613A64417D5D7D7D297D72756E28652C742C6E297B636F6E737420693D63442E66726F6D55736572286E2C7B';
wwv_flow_imp.g_varchar2_table(13959) := '6B696E643A72442E5265666163746F722C6170706C793A226E65766572227D293B72657475726E20684128742C22737472696E67223D3D747970656F66286E756C6C3D3D6E3F766F696420303A6E2E6B696E64293F692E7072656665727265643F622830';
wwv_flow_imp.g_varchar2_table(13960) := '2C224E6F20707265666572726564207265666163746F72696E677320666F7220277B307D2720617661696C61626C65222C6E2E6B696E64293A6228302C224E6F207265666163746F72696E677320666F7220277B307D2720617661696C61626C65222C6E';
wwv_flow_imp.g_varchar2_table(13961) := '2E6B696E64293A692E7072656665727265643F6228302C224E6F20707265666572726564207265666163746F72696E677320617661696C61626C6522293A6228302C224E6F207265666163746F72696E677320617661696C61626C6522292C7B696E636C';
wwv_flow_imp.g_varchar2_table(13962) := '7564653A72442E5265666163746F722E636F6E7461696E7328692E6B696E64293F692E6B696E643A70782E4E6F6E652C6F6E6C79496E636C756465507265666572726564416374696F6E733A692E7072656665727265647D2C692E6170706C792C61442E';
wwv_flow_imp.g_varchar2_table(13963) := '5265666163746F72297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A6D442C6C6162656C3A6228302C22536F7572636520416374696F6E2E2E2E22292C616C6961733A22536F75';
wwv_flow_imp.g_varchar2_table(13964) := '72636520416374696F6E2E2E2E222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6C682E686173436F6465416374696F6E7350726F7669646572292C636F6E746578744D656E754F7074733A7B67726F75703A22315F';
wwv_flow_imp.g_varchar2_table(13965) := '6D6F64696669636174696F6E222C6F726465723A322E312C7768656E3A57632E616E64286C682E7772697461626C652C63412872442E536F7572636529297D2C6D657461646174613A7B6465736372697074696F6E3A22536F7572636520416374696F6E';
wwv_flow_imp.g_varchar2_table(13966) := '2E2E2E222C617267733A5B7B6E616D653A2261726773222C736368656D613A64417D5D7D7D297D72756E28652C742C6E297B636F6E737420693D63442E66726F6D55736572286E2C7B6B696E643A72442E536F757263652C6170706C793A226E65766572';
wwv_flow_imp.g_varchar2_table(13967) := '227D293B72657475726E20684128742C22737472696E67223D3D747970656F66286E756C6C3D3D6E3F766F696420303A6E2E6B696E64293F692E7072656665727265643F6228302C224E6F2070726566657272656420736F7572636520616374696F6E73';
wwv_flow_imp.g_varchar2_table(13968) := '20666F7220277B307D2720617661696C61626C65222C6E2E6B696E64293A6228302C224E6F20736F7572636520616374696F6E7320666F7220277B307D2720617661696C61626C65222C6E2E6B696E64293A692E7072656665727265643F6228302C224E';
wwv_flow_imp.g_varchar2_table(13969) := '6F2070726566657272656420736F7572636520616374696F6E7320617661696C61626C6522293A6228302C224E6F20736F7572636520616374696F6E7320617661696C61626C6522292C7B696E636C7564653A72442E536F757263652E636F6E7461696E';
wwv_flow_imp.g_varchar2_table(13970) := '7328692E6B696E64293F692E6B696E643A70782E4E6F6E652C696E636C756465536F75726365416374696F6E733A21302C6F6E6C79496E636C756465507265666572726564416374696F6E733A692E7072656665727265647D2C692E6170706C792C6144';
wwv_flow_imp.g_varchar2_table(13971) := '2E536F75726365416374696F6E297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A66442C6C6162656C3A6228302C224F7267616E697A6520496D706F72747322292C616C696173';
wwv_flow_imp.g_varchar2_table(13972) := '3A224F7267616E697A6520496D706F727473222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C63412872442E536F757263654F7267616E697A65496D706F72747329292C6B624F7074733A7B6B62457870723A6C682E';
wwv_flow_imp.g_varchar2_table(13973) := '74657874496E707574466F6375732C7072696D6172793A313538312C7765696768743A3130307D7D297D72756E28652C74297B72657475726E20684128742C6228302C224E6F206F7267616E697A6520696D706F72747320616374696F6E20617661696C';
wwv_flow_imp.g_varchar2_table(13974) := '61626C6522292C7B696E636C7564653A72442E536F757263654F7267616E697A65496D706F7274732C696E636C756465536F75726365416374696F6E733A21307D2C22696653696E676C65222C61442E4F7267616E697A65496D706F727473297D7D292C';
wwv_flow_imp.g_varchar2_table(13975) := '5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A70442C6C6162656C3A6228302C224175746F204669782E2E2E22292C616C6961733A224175746F204669782E2E2E222C707265636F6E6469';
wwv_flow_imp.g_varchar2_table(13976) := '74696F6E3A57632E616E64286C682E7772697461626C652C63412872442E517569636B46697829292C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313632352C6D61633A7B7072696D6172793A';
wwv_flow_imp.g_varchar2_table(13977) := '323634397D2C7765696768743A3130307D7D297D72756E28652C74297B72657475726E20684128742C6228302C224E6F206175746F20666978657320617661696C61626C6522292C7B696E636C7564653A72442E517569636B4669782C6F6E6C79496E63';
wwv_flow_imp.g_varchar2_table(13978) := '6C756465507265666572726564416374696F6E733A21307D2C22696653696E676C65222C61442E4175746F466978297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A76442C6C61';
wwv_flow_imp.g_varchar2_table(13979) := '62656C3A6228302C2246697820416C6C22292C616C6961733A2246697820416C6C222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C63412872442E536F75726365466978416C6C29297D297D72756E28652C74297B72';
wwv_flow_imp.g_varchar2_table(13980) := '657475726E20684128742C6228302C224E6F2066697820616C6C20616374696F6E20617661696C61626C6522292C7B696E636C7564653A72442E536F75726365466978416C6C2C696E636C756465536F75726365416374696F6E733A21307D2C22696653';
wwv_flow_imp.g_varchar2_table(13981) := '696E676C65222C61442E466978416C6C297D7D292C5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B69643A68442C707265636F6E646974696F6E3A57632E616E64286C682E7772697461';
wwv_flow_imp.g_varchar2_table(13982) := '626C652C6C682E686173436F6465416374696F6E7350726F7669646572292C6D657461646174613A7B6465736372697074696F6E3A2254726967676572206120636F646520616374696F6E222C617267733A5B7B6E616D653A2261726773222C73636865';
wwv_flow_imp.g_varchar2_table(13983) := '6D613A64417D5D7D7D297D72756E456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D63442E66726F6D55736572286E2C7B6B696E643A70782E456D7074792C6170706C793A22696653696E676C65227D293B72657475726E206841';
wwv_flow_imp.g_varchar2_table(13984) := '28742C22737472696E67223D3D747970656F66286E756C6C3D3D6E3F766F696420303A6E2E6B696E64293F692E7072656665727265643F6228302C224E6F2070726566657272656420636F646520616374696F6E7320666F7220277B307D272061766169';
wwv_flow_imp.g_varchar2_table(13985) := '6C61626C65222C6E2E6B696E64293A6228302C224E6F20636F646520616374696F6E7320666F7220277B307D2720617661696C61626C65222C6E2E6B696E64293A692E7072656665727265643F6228302C224E6F2070726566657272656420636F646520';
wwv_flow_imp.g_varchar2_table(13986) := '616374696F6E7320617661696C61626C6522293A6228302C224E6F20636F646520616374696F6E7320617661696C61626C6522292C7B696E636C7564653A692E6B696E642C696E636C756465536F75726365416374696F6E733A21302C6F6E6C79496E63';
wwv_flow_imp.g_varchar2_table(13987) := '6C756465507265666572726564416374696F6E733A692E7072656665727265647D2C692E6170706C79297D7D292C79642E6173285470292E7265676973746572436F6E66696775726174696F6E287B2E2E2E5A4C2C70726F706572746965733A7B226564';
wwv_flow_imp.g_varchar2_table(13988) := '69746F722E636F6465416374696F6E5769646765742E73686F7748656164657273223A7B747970653A22626F6F6C65616E222C73636F70653A352C6465736372697074696F6E3A6228302C22456E61626C652F64697361626C652073686F77696E672067';
wwv_flow_imp.g_varchar2_table(13989) := '726F7570206865616465727320696E2074686520436F646520416374696F6E206D656E752E22292C64656661756C743A21307D7D7D292C79642E6173285470292E7265676973746572436F6E66696775726174696F6E287B2E2E2E5A4C2C70726F706572';
wwv_flow_imp.g_varchar2_table(13990) := '746965733A7B22656469746F722E636F6465416374696F6E5769646765742E696E636C7564654E6561726279517569636B4669786573223A7B747970653A22626F6F6C65616E222C73636F70653A352C6465736372697074696F6E3A6228302C22456E61';
wwv_flow_imp.g_varchar2_table(13991) := '626C652F64697361626C652073686F77696E67206E65617265737420517569636B204669782077697468696E2061206C696E65207768656E206E6F742063757272656E746C79206F6E206120646961676E6F737469632E22292C64656661756C743A2130';
wwv_flow_imp.g_varchar2_table(13992) := '7D7D7D293B636F6E73742075413D706328226D61726B65724465636F726174696F6E735365727669636522293B6C65742070413D636C6173737B636F6E7374727563746F7228652C74297B7D646973706F736528297B7D7D3B70412E49443D2265646974';
wwv_flow_imp.g_varchar2_table(13993) := '6F722E636F6E747269622E6D61726B65724465636F726174696F6E73222C70413D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563';
wwv_flow_imp.g_varchar2_table(13994) := '742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F726174652972';
wwv_flow_imp.g_varchar2_table(13995) := '3D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28';
wwv_flow_imp.g_varchar2_table(13996) := '742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65';
wwv_flow_imp.g_varchar2_table(13997) := '297D7D28312C7541295D2C7041292C4A642870412E49442C70412C30293B7661722067413D6E2836303439292C6D413D7B7D3B6D412E7374796C655461675472616E73666F726D3D6A7228292C6D412E736574417474726962757465733D567228292C6D';
wwv_flow_imp.g_varchar2_table(13998) := '412E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6D412E646F6D4150493D4F7228292C6D412E696E736572745374796C65456C656D656E743D487228292C4E7228292867412E412C6D41292C67412E41262667412E412E6C';
wwv_flow_imp.g_varchar2_table(13999) := '6F63616C73262667412E412E6C6F63616C733B636C61737320664120657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577';
wwv_flow_imp.g_varchar2_table(14000) := '204374292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F7265666572656E6365446F6D456C656D656E743D652C746869732E5F77696474683D2D312C746869732E5F6865696768';
wwv_flow_imp.g_varchar2_table(14001) := '743D2D312C746869732E5F726573697A654F627365727665723D6E756C6C2C746869732E6D6561737572655265666572656E6365446F6D456C656D656E742821312C74297D646973706F736528297B746869732E73746F704F6273657276696E6728292C';
wwv_flow_imp.g_varchar2_table(14002) := '73757065722E646973706F736528297D676574576964746828297B72657475726E20746869732E5F77696474687D67657448656967687428297B72657475726E20746869732E5F6865696768747D73746172744F6273657276696E6728297B6966282174';
wwv_flow_imp.g_varchar2_table(14003) := '6869732E5F726573697A654F627365727665722626746869732E5F7265666572656E6365446F6D456C656D656E74297B6C657420653D6E756C6C3B636F6E737420743D28293D3E7B653F746869732E6F627365727665287B77696474683A652E77696474';
wwv_flow_imp.g_varchar2_table(14004) := '682C6865696768743A652E6865696768747D293A746869732E6F62736572766528297D3B6C6574206E3D21312C693D21313B636F6E7374206F3D28293D3E7B6966286E26262169297472797B6E3D21312C693D21302C7428297D66696E616C6C797B7873';
wwv_flow_imp.g_varchar2_table(14005) := '28727328746869732E5F7265666572656E6365446F6D456C656D656E74292C2828293D3E7B693D21312C6F28297D29297D7D3B746869732E5F726573697A654F627365727665723D6E657720526573697A654F627365727665722828743D3E7B653D7426';
wwv_flow_imp.g_varchar2_table(14006) := '26745B305D2626745B305D2E636F6E74656E74526563743F7B77696474683A745B305D2E636F6E74656E74526563742E77696474682C6865696768743A745B305D2E636F6E74656E74526563742E6865696768747D3A6E756C6C2C6E3D21302C6F28297D';
wwv_flow_imp.g_varchar2_table(14007) := '29292C746869732E5F726573697A654F627365727665722E6F62736572766528746869732E5F7265666572656E6365446F6D456C656D656E74297D7D73746F704F6273657276696E6728297B746869732E5F726573697A654F6273657276657226262874';
wwv_flow_imp.g_varchar2_table(14008) := '6869732E5F726573697A654F627365727665722E646973636F6E6E65637428292C746869732E5F726573697A654F627365727665723D6E756C6C297D6F6273657276652865297B746869732E6D6561737572655265666572656E6365446F6D456C656D65';
wwv_flow_imp.g_varchar2_table(14009) := '6E742821302C65297D6D6561737572655265666572656E6365446F6D456C656D656E7428652C74297B6C6574206E3D302C693D303B743F286E3D742E77696474682C693D742E686569676874293A746869732E5F7265666572656E6365446F6D456C656D';
wwv_flow_imp.g_varchar2_table(14010) := '656E742626286E3D746869732E5F7265666572656E6365446F6D456C656D656E742E636C69656E7457696474682C693D746869732E5F7265666572656E6365446F6D456C656D656E742E636C69656E74486569676874292C6E3D4D6174682E6D61782835';
wwv_flow_imp.g_varchar2_table(14011) := '2C6E292C693D4D6174682E6D617828352C69292C746869732E5F77696474683D3D3D6E2626746869732E5F6865696768743D3D3D697C7C28746869732E5F77696474683D6E2C746869732E5F6865696768743D692C652626746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(14012) := '68616E67652E666972652829297D7D636C61737320764120657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C74';
wwv_flow_imp.g_varchar2_table(14013) := '6869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F6C697374656E65723D28293D3E746869732E5F68616E646C654368616E676528652C2130292C746869732E5F6D656469615175657279';
wwv_flow_imp.g_varchar2_table(14014) := '4C6973743D6E756C6C2C746869732E5F68616E646C654368616E676528652C2131297D5F68616E646C654368616E676528652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E5F6D6564696151756572794C697374297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(14015) := '3D3D6E7C7C6E2E72656D6F76654576656E744C697374656E657228226368616E6765222C746869732E5F6C697374656E6572292C746869732E5F6D6564696151756572794C6973743D652E6D617463684D656469612860287265736F6C7574696F6E3A20';
wwv_flow_imp.g_varchar2_table(14016) := '247B652E646576696365506978656C526174696F7D647070782960292C746869732E5F6D6564696151756572794C6973742E6164644576656E744C697374656E657228226368616E6765222C746869732E5F6C697374656E6572292C742626746869732E';
wwv_flow_imp.g_varchar2_table(14017) := '5F6F6E4469644368616E67652E6669726528297D7D636C61737320624120657874656E6473206C747B6765742076616C756528297B72657475726E20746869732E5F76616C75657D636F6E7374727563746F722865297B737570657228292C746869732E';
wwv_flow_imp.g_varchar2_table(14018) := '5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F76616C75653D746869732E5F6765745069';
wwv_flow_imp.g_varchar2_table(14019) := '78656C526174696F2865293B636F6E737420743D746869732E5F7265676973746572286E6577207641286529293B746869732E5F726567697374657228742E6F6E4469644368616E6765282828293D3E7B746869732E5F76616C75653D746869732E5F67';
wwv_flow_imp.g_varchar2_table(14020) := '6574506978656C526174696F2865292C746869732E5F6F6E4469644368616E67652E6669726528746869732E5F76616C7565297D2929297D5F676574506978656C526174696F2865297B636F6E737420743D646F63756D656E742E637265617465456C65';
wwv_flow_imp.g_varchar2_table(14021) := '6D656E74282263616E76617322292E676574436F6E746578742822326422293B72657475726E28652E646576696365506978656C526174696F7C7C31292F28742E7765626B69744261636B696E6753746F7265506978656C526174696F7C7C742E6D6F7A';
wwv_flow_imp.g_varchar2_table(14022) := '4261636B696E6753746F7265506978656C526174696F7C7C742E6D734261636B696E6753746F7265506978656C526174696F7C7C742E6F4261636B696E6753746F7265506978656C526174696F7C7C742E6261636B696E6753746F7265506978656C5261';
wwv_flow_imp.g_varchar2_table(14023) := '74696F7C7C31297D7D636F6E7374205F413D6E657720636C6173737B636F6E7374727563746F7228297B746869732E6D617057696E646F774964546F506978656C526174696F4D6F6E69746F723D6E6577204D61707D5F6765744F724372656174655069';
wwv_flow_imp.g_varchar2_table(14024) := '78656C526174696F4D6F6E69746F722865297B636F6E737420743D64732865293B6C6574206E3D746869732E6D617057696E646F774964546F506978656C526174696F4D6F6E69746F722E6765742874293B72657475726E206E7C7C286E3D6E74286E65';
wwv_flow_imp.g_varchar2_table(14025) := '77206241286529292C746869732E6D617057696E646F774964546F506978656C526174696F4D6F6E69746F722E73657428742C6E292C6E742876742E6F6E6365286D73292828287B7673636F646557696E646F7749643A657D293D3E7B653D3D3D742626';
wwv_flow_imp.g_varchar2_table(14026) := '286E756C6C3D3D6E7C7C6E2E646973706F736528292C746869732E6D617057696E646F774964546F506978656C526174696F4D6F6E69746F722E64656C657465287429297D292929292C6E7D676574496E7374616E63652865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(14027) := '69732E5F6765744F72437265617465506978656C526174696F4D6F6E69746F722865297D7D3B636C6173732079417B636F6E7374727563746F7228652C74297B746869732E6368723D652C746869732E747970653D742C746869732E77696474683D307D';
wwv_flow_imp.g_varchar2_table(14028) := '66756C66696C6C2865297B746869732E77696474683D657D7D636C6173732077417B636F6E7374727563746F7228652C74297B746869732E5F62617265466F6E74496E666F3D652C746869732E5F72657175657374733D742C746869732E5F636F6E7461';
wwv_flow_imp.g_varchar2_table(14029) := '696E65723D6E756C6C2C746869732E5F74657374456C656D656E74733D6E756C6C7D726561642865297B746869732E5F637265617465446F6D456C656D656E747328292C652E646F63756D656E742E626F64792E617070656E644368696C642874686973';
wwv_flow_imp.g_varchar2_table(14030) := '2E5F636F6E7461696E6572292C746869732E5F7265616446726F6D446F6D456C656D656E747328292C652E646F63756D656E742E626F64792E72656D6F76654368696C6428746869732E5F636F6E7461696E6572292C746869732E5F636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(14031) := '723D6E756C6C2C746869732E5F74657374456C656D656E74733D6E756C6C7D5F637265617465446F6D456C656D656E747328297B636F6E737420653D646F63756D656E742E637265617465456C656D656E74282264697622293B652E7374796C652E706F';
wwv_flow_imp.g_varchar2_table(14032) := '736974696F6E3D226162736F6C757465222C652E7374796C652E746F703D222D35303030307078222C652E7374796C652E77696474683D2235303030307078223B636F6E737420743D646F63756D656E742E637265617465456C656D656E742822646976';
wwv_flow_imp.g_varchar2_table(14033) := '22293B724528742C746869732E5F62617265466F6E74496E666F292C652E617070656E644368696C642874293B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E74282264697622293B7245286E2C746869732E5F62617265466F';
wwv_flow_imp.g_varchar2_table(14034) := '6E74496E666F292C6E2E7374796C652E666F6E745765696768743D22626F6C64222C652E617070656E644368696C64286E293B636F6E737420693D646F63756D656E742E637265617465456C656D656E74282264697622293B724528692C746869732E5F';
wwv_flow_imp.g_varchar2_table(14035) := '62617265466F6E74496E666F292C692E7374796C652E666F6E745374796C653D226974616C6963222C652E617070656E644368696C642869293B636F6E7374206F3D5B5D3B666F7228636F6E73742065206F6620746869732E5F7265717565737473297B';
wwv_flow_imp.g_varchar2_table(14036) := '6C657420733B303D3D3D652E74797065262628733D74292C323D3D3D652E74797065262628733D6E292C313D3D3D652E74797065262628733D69292C732E617070656E644368696C6428646F63756D656E742E637265617465456C656D656E7428226272';
wwv_flow_imp.g_varchar2_table(14037) := '2229293B636F6E737420723D646F63756D656E742E637265617465456C656D656E7428227370616E22293B77412E5F72656E64657228722C65292C732E617070656E644368696C642872292C6F2E707573682872297D746869732E5F636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(14038) := '723D652C746869732E5F74657374456C656D656E74733D6F7D737461746963205F72656E64657228652C74297B6966282220223D3D3D742E636872297B6C657420743D22C2A0223B666F72286C657420653D303B653C383B652B2B29742B3D743B652E69';
wwv_flow_imp.g_varchar2_table(14039) := '6E6E6572546578743D747D656C73657B6C6574206E3D742E6368723B666F72286C657420653D303B653C383B652B2B296E2B3D6E3B652E74657874436F6E74656E743D6E7D7D5F7265616446726F6D446F6D456C656D656E747328297B666F72286C6574';
wwv_flow_imp.g_varchar2_table(14040) := '20653D302C743D746869732E5F72657175657374732E6C656E6774683B653C743B652B2B297B636F6E737420743D746869732E5F72657175657374735B655D2C6E3D746869732E5F74657374456C656D656E74735B655D3B742E66756C66696C6C286E2E';
wwv_flow_imp.g_varchar2_table(14041) := '6F666673657457696474682F323536297D7D7D636F6E73742043413D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F7A6F6F6D4C6576656C3D302C746869732E5F6F6E4469644368616E67655A6F6F6D4C6576656C3D6E6577';
wwv_flow_imp.g_varchar2_table(14042) := '2043742C746869732E6F6E4469644368616E67655A6F6F6D4C6576656C3D746869732E5F6F6E4469644368616E67655A6F6F6D4C6576656C2E6576656E747D6765745A6F6F6D4C6576656C28297B72657475726E20746869732E5F7A6F6F6D4C6576656C';
wwv_flow_imp.g_varchar2_table(14043) := '7D7365745A6F6F6D4C6576656C2865297B653D4D6174682E6D696E284D6174682E6D6178282D352C65292C3230292C746869732E5F7A6F6F6D4C6576656C213D3D65262628746869732E5F7A6F6F6D4C6576656C3D652C746869732E5F6F6E4469644368';
wwv_flow_imp.g_varchar2_table(14044) := '616E67655A6F6F6D4C6576656C2E6669726528746869732E5F7A6F6F6D4C6576656C29297D7D2C53413D713F312E353A312E33353B636C6173732078417B7374617469632063726561746546726F6D56616C69646174656453657474696E677328652C74';
wwv_flow_imp.g_varchar2_table(14045) := '2C6E297B636F6E737420693D652E676574283439292C6F3D652E676574283533292C733D652E676574283532292C723D652E676574283531292C613D652E676574283534292C6C3D652E676574283637292C633D652E676574283634293B72657475726E';
wwv_flow_imp.g_varchar2_table(14046) := '2078412E5F63726561746528692C6F2C732C722C612C6C2C632C742C6E297D737461746963205F63726561746528652C742C6E2C692C6F2C732C722C612C6C297B303D3D3D733F733D53412A6E3A733C38262628732A3D6E292C28733D4D6174682E726F';
wwv_flow_imp.g_varchar2_table(14047) := '756E64287329293C38262628733D38293B636F6E737420633D312B286C3F303A2E312A43412E6765745A6F6F6D4C6576656C2829293B72657475726E206E2A3D632C732A3D632C6F3D3D3D4E4C2E5452414E534C415445262628226E6F726D616C223D3D';
wwv_flow_imp.g_varchar2_table(14048) := '3D747C7C22626F6C64223D3D3D743F6F3D4E4C2E4F46463A286F3D6027776768742720247B7061727365496E7428742C3130297D602C743D226E6F726D616C2229292C6E6577207841287B706978656C526174696F3A612C666F6E7446616D696C793A65';
wwv_flow_imp.g_varchar2_table(14049) := '2C666F6E745765696768743A742C666F6E7453697A653A6E2C666F6E744665617475726553657474696E67733A692C666F6E74566172696174696F6E53657474696E67733A6F2C6C696E654865696768743A732C6C657474657253706163696E673A727D';
wwv_flow_imp.g_varchar2_table(14050) := '297D636F6E7374727563746F722865297B746869732E5F62617265466F6E74496E666F4272616E643D766F696420302C746869732E706978656C526174696F3D652E706978656C526174696F2C746869732E666F6E7446616D696C793D537472696E6728';
wwv_flow_imp.g_varchar2_table(14051) := '652E666F6E7446616D696C79292C746869732E666F6E745765696768743D537472696E6728652E666F6E74576569676874292C746869732E666F6E7453697A653D652E666F6E7453697A652C746869732E666F6E744665617475726553657474696E6773';
wwv_flow_imp.g_varchar2_table(14052) := '3D652E666F6E744665617475726553657474696E67732C746869732E666F6E74566172696174696F6E53657474696E67733D652E666F6E74566172696174696F6E53657474696E67732C746869732E6C696E654865696768743D307C652E6C696E654865';
wwv_flow_imp.g_varchar2_table(14053) := '696768742C746869732E6C657474657253706163696E673D652E6C657474657253706163696E677D676574496428297B72657475726E60247B746869732E706978656C526174696F7D2D247B746869732E666F6E7446616D696C797D2D247B746869732E';
wwv_flow_imp.g_varchar2_table(14054) := '666F6E745765696768747D2D247B746869732E666F6E7453697A657D2D247B746869732E666F6E744665617475726553657474696E67737D2D247B746869732E666F6E74566172696174696F6E53657474696E67737D2D247B746869732E6C696E654865';
wwv_flow_imp.g_varchar2_table(14055) := '696768747D2D247B746869732E6C657474657253706163696E677D607D6765744D61737361676564466F6E7446616D696C7928297B636F6E737420653D4B4C2E666F6E7446616D696C792C743D78412E5F77726170496E51756F74657328746869732E66';
wwv_flow_imp.g_varchar2_table(14056) := '6F6E7446616D696C79293B72657475726E20652626746869732E666F6E7446616D696C79213D3D653F60247B747D2C20247B657D603A747D737461746963205F77726170496E51756F7465732865297B72657475726E2F5B2C22275D2F2E746573742865';
wwv_flow_imp.g_varchar2_table(14057) := '293F653A2F5B2B205D2F2E746573742865293F6022247B657D22603A657D7D636C617373206B4120657874656E64732078417B636F6E7374727563746F7228652C74297B73757065722865292C746869732E5F656469746F725374796C696E674272616E';
wwv_flow_imp.g_varchar2_table(14058) := '643D766F696420302C746869732E76657273696F6E3D322C746869732E6973547275737465643D742C746869732E69734D6F6E6F73706163653D652E69734D6F6E6F73706163652C746869732E7479706963616C48616C66776964746843686172616374';
wwv_flow_imp.g_varchar2_table(14059) := '657257696474683D652E7479706963616C48616C66776964746843686172616374657257696474682C746869732E7479706963616C46756C6C776964746843686172616374657257696474683D652E7479706963616C46756C6C77696474684368617261';
wwv_flow_imp.g_varchar2_table(14060) := '6374657257696474682C746869732E63616E55736548616C667769647468526967687477617264734172726F773D652E63616E55736548616C667769647468526967687477617264734172726F772C746869732E737061636557696474683D652E737061';
wwv_flow_imp.g_varchar2_table(14061) := '636557696474682C746869732E6D6964646F7457696474683D652E6D6964646F7457696474682C746869732E77736D6964646F7457696474683D652E77736D6964646F7457696474682C746869732E6D6178446967697457696474683D652E6D61784469';
wwv_flow_imp.g_varchar2_table(14062) := '67697457696474687D657175616C732865297B72657475726E20746869732E666F6E7446616D696C793D3D3D652E666F6E7446616D696C792626746869732E666F6E745765696768743D3D3D652E666F6E745765696768742626746869732E666F6E7453';
wwv_flow_imp.g_varchar2_table(14063) := '697A653D3D3D652E666F6E7453697A652626746869732E666F6E744665617475726553657474696E67733D3D3D652E666F6E744665617475726553657474696E67732626746869732E666F6E74566172696174696F6E53657474696E67733D3D3D652E66';
wwv_flow_imp.g_varchar2_table(14064) := '6F6E74566172696174696F6E53657474696E67732626746869732E6C696E654865696768743D3D3D652E6C696E654865696768742626746869732E6C657474657253706163696E673D3D3D652E6C657474657253706163696E672626746869732E747970';
wwv_flow_imp.g_varchar2_table(14065) := '6963616C48616C66776964746843686172616374657257696474683D3D3D652E7479706963616C48616C66776964746843686172616374657257696474682626746869732E7479706963616C46756C6C776964746843686172616374657257696474683D';
wwv_flow_imp.g_varchar2_table(14066) := '3D3D652E7479706963616C46756C6C776964746843686172616374657257696474682626746869732E63616E55736548616C667769647468526967687477617264734172726F773D3D3D652E63616E55736548616C667769647468526967687477617264';
wwv_flow_imp.g_varchar2_table(14067) := '734172726F772626746869732E737061636557696474683D3D3D652E737061636557696474682626746869732E6D6964646F7457696474683D3D3D652E6D6964646F7457696474682626746869732E77736D6964646F7457696474683D3D3D652E77736D';
wwv_flow_imp.g_varchar2_table(14068) := '6964646F7457696474682626746869732E6D6178446967697457696474683D3D3D652E6D6178446967697457696474687D7D636C6173732045417B636F6E7374727563746F7228297B746869732E5F6B6579733D4F626A6563742E637265617465286E75';
wwv_flow_imp.g_varchar2_table(14069) := '6C6C292C746869732E5F76616C7565733D4F626A6563742E637265617465286E756C6C297D6861732865297B636F6E737420743D652E676574496428293B72657475726E2121746869732E5F76616C7565735B745D7D6765742865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(14070) := '3D652E676574496428293B72657475726E20746869732E5F76616C7565735B745D7D70757428652C74297B636F6E7374206E3D652E676574496428293B746869732E5F6B6579735B6E5D3D652C746869732E5F76616C7565735B6E5D3D747D72656D6F76';
wwv_flow_imp.g_varchar2_table(14071) := '652865297B636F6E737420743D652E676574496428293B64656C65746520746869732E5F6B6579735B745D2C64656C65746520746869732E5F76616C7565735B745D7D67657456616C75657328297B72657475726E204F626A6563742E6B657973287468';
wwv_flow_imp.g_varchar2_table(14072) := '69732E5F6B657973292E6D61702828653D3E746869732E5F76616C7565735B655D29297D7D636F6E7374204C413D6E657720636C61737320657874656E6473206C747B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E747329';
wwv_flow_imp.g_varchar2_table(14073) := '2C746869732E5F63616368653D6E6577204D61702C746869732E5F6576696374556E7472757374656452656164696E677354696D656F75743D2D312C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E657720437429';
wwv_flow_imp.g_varchar2_table(14074) := '2C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E747D646973706F736528297B2D31213D3D746869732E5F6576696374556E7472757374656452656164696E677354696D656F7574262628636C656172';
wwv_flow_imp.g_varchar2_table(14075) := '54696D656F757428746869732E5F6576696374556E7472757374656452656164696E677354696D656F7574292C746869732E5F6576696374556E7472757374656452656164696E677354696D656F75743D2D31292C73757065722E646973706F73652829';
wwv_flow_imp.g_varchar2_table(14076) := '7D636C656172416C6C466F6E74496E666F7328297B746869732E5F63616368652E636C65617228292C746869732E5F6F6E4469644368616E67652E6669726528297D5F656E7375726543616368652865297B636F6E737420743D64732865293B6C657420';
wwv_flow_imp.g_varchar2_table(14077) := '6E3D746869732E5F63616368652E6765742874293B72657475726E206E7C7C286E3D6E65772045412C746869732E5F63616368652E73657428742C6E29292C6E7D5F7772697465546F436163686528652C742C6E297B746869732E5F656E737572654361';
wwv_flow_imp.g_varchar2_table(14078) := '6368652865292E70757428742C6E292C6E2E6973547275737465647C7C2D31213D3D746869732E5F6576696374556E7472757374656452656164696E677354696D656F75747C7C28746869732E5F6576696374556E7472757374656452656164696E6773';
wwv_flow_imp.g_varchar2_table(14079) := '54696D656F75743D652E73657454696D656F7574282828293D3E7B746869732E5F6576696374556E7472757374656452656164696E677354696D656F75743D2D312C746869732E5F6576696374556E7472757374656452656164696E67732865297D292C';
wwv_flow_imp.g_varchar2_table(14080) := '35653329297D5F6576696374556E7472757374656452656164696E67732865297B636F6E737420743D746869732E5F656E7375726543616368652865292C6E3D742E67657456616C75657328293B6C657420693D21313B666F7228636F6E73742065206F';
wwv_flow_imp.g_varchar2_table(14081) := '66206E29652E6973547275737465647C7C28693D21302C742E72656D6F7665286529293B692626746869732E5F6F6E4469644368616E67652E6669726528297D72656164466F6E74496E666F28652C74297B636F6E7374206E3D746869732E5F656E7375';
wwv_flow_imp.g_varchar2_table(14082) := '726543616368652865293B696628216E2E686173287429297B6C6574206E3D746869732E5F61637475616C52656164466F6E74496E666F28652C74293B286E2E7479706963616C48616C66776964746843686172616374657257696474683C3D327C7C6E';
wwv_flow_imp.g_varchar2_table(14083) := '2E7479706963616C46756C6C776964746843686172616374657257696474683C3D327C7C6E2E737061636557696474683C3D327C7C6E2E6D6178446967697457696474683C3D32292626286E3D6E6577206B41287B706978656C526174696F3A5F412E67';
wwv_flow_imp.g_varchar2_table(14084) := '6574496E7374616E63652865292E76616C75652C666F6E7446616D696C793A6E2E666F6E7446616D696C792C666F6E745765696768743A6E2E666F6E745765696768742C666F6E7453697A653A6E2E666F6E7453697A652C666F6E744665617475726553';
wwv_flow_imp.g_varchar2_table(14085) := '657474696E67733A6E2E666F6E744665617475726553657474696E67732C666F6E74566172696174696F6E53657474696E67733A6E2E666F6E74566172696174696F6E53657474696E67732C6C696E654865696768743A6E2E6C696E654865696768742C';
wwv_flow_imp.g_varchar2_table(14086) := '6C657474657253706163696E673A6E2E6C657474657253706163696E672C69734D6F6E6F73706163653A6E2E69734D6F6E6F73706163652C7479706963616C48616C66776964746843686172616374657257696474683A4D6174682E6D6178286E2E7479';
wwv_flow_imp.g_varchar2_table(14087) := '706963616C48616C66776964746843686172616374657257696474682C35292C7479706963616C46756C6C776964746843686172616374657257696474683A4D6174682E6D6178286E2E7479706963616C46756C6C776964746843686172616374657257';
wwv_flow_imp.g_varchar2_table(14088) := '696474682C35292C63616E55736548616C667769647468526967687477617264734172726F773A6E2E63616E55736548616C667769647468526967687477617264734172726F772C737061636557696474683A4D6174682E6D6178286E2E737061636557';
wwv_flow_imp.g_varchar2_table(14089) := '696474682C35292C6D6964646F7457696474683A4D6174682E6D6178286E2E6D6964646F7457696474682C35292C77736D6964646F7457696474683A4D6174682E6D6178286E2E77736D6964646F7457696474682C35292C6D6178446967697457696474';
wwv_flow_imp.g_varchar2_table(14090) := '683A4D6174682E6D6178286E2E6D6178446967697457696474682C35297D2C213129292C746869732E5F7772697465546F436163686528652C742C6E297D72657475726E206E2E6765742874297D5F6372656174655265717565737428652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(14091) := '297B636F6E7374206F3D6E657720794128652C74293B72657475726E206E2E70757368286F292C6E756C6C3D3D697C7C692E70757368286F292C6F7D5F61637475616C52656164466F6E74496E666F28652C74297B636F6E7374206E3D5B5D2C693D5B5D';
wwv_flow_imp.g_varchar2_table(14092) := '2C6F3D746869732E5F6372656174655265717565737428226E222C302C6E2C69292C733D746869732E5F637265617465526571756573742822EFBD8D222C302C6E2C6E756C6C292C723D746869732E5F63726561746552657175657374282220222C302C';
wwv_flow_imp.g_varchar2_table(14093) := '6E2C69292C613D746869732E5F63726561746552657175657374282230222C302C6E2C69292C6C3D746869732E5F63726561746552657175657374282231222C302C6E2C69292C633D746869732E5F63726561746552657175657374282232222C302C6E';
wwv_flow_imp.g_varchar2_table(14094) := '2C69292C643D746869732E5F63726561746552657175657374282233222C302C6E2C69292C683D746869732E5F63726561746552657175657374282234222C302C6E2C69292C753D746869732E5F63726561746552657175657374282235222C302C6E2C';
wwv_flow_imp.g_varchar2_table(14095) := '69292C703D746869732E5F63726561746552657175657374282236222C302C6E2C69292C673D746869732E5F63726561746552657175657374282237222C302C6E2C69292C6D3D746869732E5F63726561746552657175657374282238222C302C6E2C69';
wwv_flow_imp.g_varchar2_table(14096) := '292C663D746869732E5F63726561746552657175657374282239222C302C6E2C69292C763D746869732E5F637265617465526571756573742822E28692222C302C6E2C69292C623D746869732E5F637265617465526571756573742822EFBFAB222C302C';
wwv_flow_imp.g_varchar2_table(14097) := '6E2C6E756C6C292C5F3D746869732E5F637265617465526571756573742822C2B7222C302C6E2C69292C793D746869732E5F6372656174655265717565737428537472696E672E66726F6D43686172436F6465283131383235292C302C6E2C6E756C6C29';
wwv_flow_imp.g_varchar2_table(14098) := '2C773D227C2F2D5F696C6D25223B666F72286C657420653D302C743D383B653C743B652B2B29746869732E5F6372656174655265717565737428772E6368617241742865292C302C6E2C69292C746869732E5F6372656174655265717565737428772E63';
wwv_flow_imp.g_varchar2_table(14099) := '68617241742865292C312C6E2C69292C746869732E5F6372656174655265717565737428772E6368617241742865292C322C6E2C69293B2166756E6374696F6E28652C742C6E297B6E657720774128742C6E292E726561642865297D28652C742C6E293B';
wwv_flow_imp.g_varchar2_table(14100) := '636F6E737420433D4D6174682E6D617828612E77696474682C6C2E77696474682C632E77696474682C642E77696474682C682E77696474682C752E77696474682C702E77696474682C672E77696474682C6D2E77696474682C662E7769647468293B6C65';
wwv_flow_imp.g_varchar2_table(14101) := '7420533D742E666F6E744665617475726553657474696E67733D3D3D414C2E4F46463B636F6E737420783D695B305D2E77696474683B666F72286C657420653D312C743D692E6C656E6774683B532626653C743B652B2B297B636F6E737420743D782D69';
wwv_flow_imp.g_varchar2_table(14102) := '5B655D2E77696474683B696628743C2D2E3030317C7C743E2E303031297B533D21313B627265616B7D7D6C6574206B3D21303B72657475726E20532626622E7769647468213D3D782626286B3D2131292C622E77696474683E762E77696474682626286B';
wwv_flow_imp.g_varchar2_table(14103) := '3D2131292C6E6577206B41287B706978656C526174696F3A5F412E676574496E7374616E63652865292E76616C75652C666F6E7446616D696C793A742E666F6E7446616D696C792C666F6E745765696768743A742E666F6E745765696768742C666F6E74';
wwv_flow_imp.g_varchar2_table(14104) := '53697A653A742E666F6E7453697A652C666F6E744665617475726553657474696E67733A742E666F6E744665617475726553657474696E67732C666F6E74566172696174696F6E53657474696E67733A742E666F6E74566172696174696F6E5365747469';
wwv_flow_imp.g_varchar2_table(14105) := '6E67732C6C696E654865696768743A742E6C696E654865696768742C6C657474657253706163696E673A742E6C657474657253706163696E672C69734D6F6E6F73706163653A532C7479706963616C48616C667769647468436861726163746572576964';
wwv_flow_imp.g_varchar2_table(14106) := '74683A6F2E77696474682C7479706963616C46756C6C776964746843686172616374657257696474683A732E77696474682C63616E55736548616C667769647468526967687477617264734172726F773A6B2C737061636557696474683A722E77696474';
wwv_flow_imp.g_varchar2_table(14107) := '682C6D6964646F7457696474683A5F2E77696474682C77736D6964646F7457696474683A792E77696474682C6D6178446967697457696474683A437D2C2130297D7D3B636C6173732044417B636F6E7374727563746F7228652C74297B746869732E6B65';
wwv_flow_imp.g_varchar2_table(14108) := '793D652C746869732E6D6967726174653D747D6170706C792865297B636F6E737420743D44412E5F7265616428652C746869732E6B6579293B746869732E6D69677261746528742C28743D3E44412E5F7265616428652C7429292C2828742C6E293D3E44';
wwv_flow_imp.g_varchar2_table(14109) := '412E5F777269746528652C742C6E2929297D737461746963205F7265616428652C74297B696628766F696420303D3D3D652972657475726E3B636F6E7374206E3D742E696E6465784F6628222E22293B6966286E3E3D30297B636F6E737420693D742E73';
wwv_flow_imp.g_varchar2_table(14110) := '7562737472696E6728302C6E293B72657475726E20746869732E5F7265616428655B695D2C742E737562737472696E67286E2B3129297D72657475726E20655B745D7D737461746963205F777269746528652C742C6E297B636F6E737420693D742E696E';
wwv_flow_imp.g_varchar2_table(14111) := '6465784F6628222E22293B696628693E3D30297B636F6E7374206F3D742E737562737472696E6728302C69293B72657475726E20655B6F5D3D655B6F5D7C7C7B7D2C766F696420746869732E5F777269746528655B6F5D2C742E737562737472696E6728';
wwv_flow_imp.g_varchar2_table(14112) := '692B31292C6E297D655B745D3D6E7D7D66756E6374696F6E20544128652C74297B44412E6974656D732E70757368286E657720444128652C7429297D66756E6374696F6E20494128652C74297B544128652C28286E2C692C6F293D3E7B696628766F6964';
wwv_flow_imp.g_varchar2_table(14113) := '2030213D3D6E29666F7228636F6E73745B692C735D6F662074296966286E3D3D3D692972657475726E20766F6964206F28652C73297D29297D44412E6974656D733D5B5D2C49412822776F726457726170222C5B5B21302C226F6E225D2C5B21312C226F';
wwv_flow_imp.g_varchar2_table(14114) := '6666225D5D292C494128226C696E654E756D62657273222C5B5B21302C226F6E225D2C5B21312C226F6666225D5D292C49412822637572736F72426C696E6B696E67222C5B5B2276697369626C65222C22736F6C6964225D5D292C4941282272656E6465';
wwv_flow_imp.g_varchar2_table(14115) := '7257686974657370616365222C5B5B21302C22626F756E64617279225D2C5B21312C226E6F6E65225D5D292C4941282272656E6465724C696E65486967686C69676874222C5B5B21302C226C696E65225D2C5B21312C226E6F6E65225D5D292C49412822';
wwv_flow_imp.g_varchar2_table(14116) := '61636365707453756767657374696F6E4F6E456E746572222C5B5B21302C226F6E225D2C5B21312C226F6666225D5D292C49412822746162436F6D706C6574696F6E222C5B5B21312C226F6666225D2C5B21302C226F6E6C79536E697070657473225D5D';
wwv_flow_imp.g_varchar2_table(14117) := '292C49412822686F766572222C5B5B21302C7B656E61626C65643A21307D5D2C5B21312C7B656E61626C65643A21317D5D5D292C49412822706172616D6574657248696E7473222C5B5B21302C7B656E61626C65643A21307D5D2C5B21312C7B656E6162';
wwv_flow_imp.g_varchar2_table(14118) := '6C65643A21317D5D5D292C494128226175746F496E64656E74222C5B5B21312C22616476616E636564225D2C5B21302C2266756C6C225D5D292C494128226D61746368427261636B657473222C5B5B21302C22616C77617973225D2C5B21312C226E6576';
wwv_flow_imp.g_varchar2_table(14119) := '6572225D5D292C4941282272656E64657246696E616C4E65776C696E65222C5B5B21302C226F6E225D2C5B21312C226F6666225D5D292C49412822637572736F72536D6F6F74684361726574416E696D6174696F6E222C5B5B21302C226F6E225D2C5B21';
wwv_flow_imp.g_varchar2_table(14120) := '312C226F6666225D5D292C494128226F6363757272656E636573486967686C69676874222C5B5B21302C2273696E676C6546696C65225D2C5B21312C226F6666225D5D292C49412822776F7264426173656453756767657374696F6E73222C5B5B21302C';
wwv_flow_imp.g_varchar2_table(14121) := '226D61746368696E67446F63756D656E7473225D2C5B21312C226F6666225D5D292C544128226175746F436C6F73696E67427261636B657473222C2828652C742C6E293D3E7B21313D3D3D652626286E28226175746F436C6F73696E67427261636B6574';
wwv_flow_imp.g_varchar2_table(14122) := '73222C226E6576657222292C766F696420303D3D3D7428226175746F436C6F73696E6751756F746573222926266E28226175746F436C6F73696E6751756F746573222C226E6576657222292C766F696420303D3D3D7428226175746F537572726F756E64';
wwv_flow_imp.g_varchar2_table(14123) := '222926266E28226175746F537572726F756E64222C226E657665722229297D29292C5441282272656E646572496E64656E74477569646573222C2828652C742C6E293D3E7B766F69642030213D3D652626286E282272656E646572496E64656E74477569';
wwv_flow_imp.g_varchar2_table(14124) := '646573222C766F69642030292C766F696420303D3D3D7428226775696465732E696E64656E746174696F6E222926266E28226775696465732E696E64656E746174696F6E222C21216529297D29292C54412822686967686C69676874416374697665496E';
wwv_flow_imp.g_varchar2_table(14125) := '64656E744775696465222C2828652C742C6E293D3E7B766F69642030213D3D652626286E2822686967686C69676874416374697665496E64656E744775696465222C766F69642030292C766F696420303D3D3D7428226775696465732E686967686C6967';
wwv_flow_imp.g_varchar2_table(14126) := '6874416374697665496E64656E746174696F6E222926266E28226775696465732E686967686C69676874416374697665496E64656E746174696F6E222C21216529297D29293B636F6E7374204D413D7B6D6574686F643A2273686F774D6574686F647322';
wwv_flow_imp.g_varchar2_table(14127) := '2C66756E6374696F6E3A2273686F7746756E6374696F6E73222C636F6E7374727563746F723A2273686F77436F6E7374727563746F7273222C646570726563617465643A2273686F7744657072656361746564222C6669656C643A2273686F774669656C';
wwv_flow_imp.g_varchar2_table(14128) := '6473222C7661726961626C653A2273686F775661726961626C6573222C636C6173733A2273686F77436C6173736573222C7374727563743A2273686F7753747275637473222C696E746572666163653A2273686F77496E7465726661636573222C6D6F64';
wwv_flow_imp.g_varchar2_table(14129) := '756C653A2273686F774D6F64756C6573222C70726F70657274793A2273686F7750726F70657274696573222C6576656E743A2273686F774576656E7473222C6F70657261746F723A2273686F774F70657261746F7273222C756E69743A2273686F77556E';
wwv_flow_imp.g_varchar2_table(14130) := '697473222C76616C75653A2273686F7756616C756573222C636F6E7374616E743A2273686F77436F6E7374616E7473222C656E756D3A2273686F77456E756D73222C656E756D4D656D6265723A2273686F77456E756D4D656D62657273222C6B6579776F';
wwv_flow_imp.g_varchar2_table(14131) := '72643A2273686F774B6579776F726473222C746578743A2273686F77576F726473222C636F6C6F723A2273686F77436F6C6F7273222C66696C653A2273686F7746696C6573222C7265666572656E63653A2273686F775265666572656E636573222C666F';
wwv_flow_imp.g_varchar2_table(14132) := '6C6465723A2273686F77466F6C64657273222C74797065506172616D657465723A2273686F7754797065506172616D6574657273222C736E69707065743A2273686F77536E697070657473227D3B54412822737567676573742E66696C74657265645479';
wwv_flow_imp.g_varchar2_table(14133) := '706573222C2828652C742C6E293D3E7B696628652626226F626A656374223D3D747970656F662065297B666F7228636F6E73742069206F66204F626A6563742E656E7472696573284D41292921313D3D3D655B695B305D5D2626766F696420303D3D3D74';
wwv_flow_imp.g_varchar2_table(14134) := '2860737567676573742E247B695B315D7D602926266E2860737567676573742E247B695B315D7D602C2131293B6E2822737567676573742E66696C74657265645479706573222C766F69642030297D7D29292C54412822717569636B5375676765737469';
wwv_flow_imp.g_varchar2_table(14135) := '6F6E73222C2828652C742C6E293D3E7B69662822626F6F6C65616E223D3D747970656F662065297B636F6E737420743D653F226F6E223A226F6666223B6E2822717569636B53756767657374696F6E73222C7B636F6D6D656E74733A742C737472696E67';
wwv_flow_imp.g_varchar2_table(14136) := '733A742C6F746865723A747D297D7D29292C544128226578706572696D656E74616C2E737469636B795363726F6C6C2E656E61626C6564222C2828652C742C6E293D3E7B22626F6F6C65616E223D3D747970656F6620652626286E28226578706572696D';
wwv_flow_imp.g_varchar2_table(14137) := '656E74616C2E737469636B795363726F6C6C2E656E61626C6564222C766F69642030292C766F696420303D3D3D742822737469636B795363726F6C6C2E656E61626C6564222926266E2822737469636B795363726F6C6C2E656E61626C6564222C652929';
wwv_flow_imp.g_varchar2_table(14138) := '7D29292C544128226578706572696D656E74616C2E737469636B795363726F6C6C2E6D61784C696E65436F756E74222C2828652C742C6E293D3E7B226E756D626572223D3D747970656F6620652626286E28226578706572696D656E74616C2E73746963';
wwv_flow_imp.g_varchar2_table(14139) := '6B795363726F6C6C2E6D61784C696E65436F756E74222C766F69642030292C766F696420303D3D3D742822737469636B795363726F6C6C2E6D61784C696E65436F756E74222926266E2822737469636B795363726F6C6C2E6D61784C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(14140) := '222C6529297D29292C54412822636F6465416374696F6E734F6E53617665222C2828652C742C6E293D3E7B696628652626226F626A656374223D3D747970656F662065297B6C657420743D21313B636F6E737420693D7B7D3B666F7228636F6E7374206E';
wwv_flow_imp.g_varchar2_table(14141) := '206F66204F626A6563742E656E74726965732865292922626F6F6C65616E223D3D747970656F66206E5B315D3F28743D21302C695B6E5B305D5D3D6E5B315D3F226578706C69636974223A226E6576657222293A695B6E5B305D5D3D6E5B315D3B742626';
wwv_flow_imp.g_varchar2_table(14142) := '6E2822636F6465416374696F6E734F6E53617665222C69297D7D29292C54412822636F6465416374696F6E5769646765742E696E636C7564654E6561726279517569636B6669786573222C2828652C742C6E293D3E7B22626F6F6C65616E223D3D747970';
wwv_flow_imp.g_varchar2_table(14143) := '656F6620652626286E2822636F6465416374696F6E5769646765742E696E636C7564654E6561726279517569636B6669786573222C766F69642030292C766F696420303D3D3D742822636F6465416374696F6E5769646765742E696E636C7564654E6561';
wwv_flow_imp.g_varchar2_table(14144) := '726279517569636B4669786573222926266E2822636F6465416374696F6E5769646765742E696E636C7564654E6561726279517569636B4669786573222C6529297D29292C544128226C6967687462756C622E656E61626C6564222C2828652C742C6E29';
wwv_flow_imp.g_varchar2_table(14145) := '3D3E7B22626F6F6C65616E223D3D747970656F66206526266E28226C6967687462756C622E656E61626C6564222C653F766F696420303A226F666622297D29293B636F6E73742041413D6E657720636C6173737B636F6E7374727563746F7228297B7468';
wwv_flow_imp.g_varchar2_table(14146) := '69732E5F746162466F6375733D21312C746869732E5F6F6E4469644368616E6765546162466F6375733D6E65772043742C746869732E6F6E4469644368616E6765546162466F6375733D746869732E5F6F6E4469644368616E6765546162466F6375732E';
wwv_flow_imp.g_varchar2_table(14147) := '6576656E747D676574546162466F6375734D6F646528297B72657475726E20746869732E5F746162466F6375737D736574546162466F6375734D6F64652865297B746869732E5F746162466F6375733D652C746869732E5F6F6E4469644368616E676554';
wwv_flow_imp.g_varchar2_table(14148) := '6162466F6375732E6669726528746869732E5F746162466F637573297D7D3B6C6574204E413D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E5F6163636573736962';
wwv_flow_imp.g_varchar2_table(14149) := '696C697479536572766963653D6F2C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869';
wwv_flow_imp.g_varchar2_table(14150) := '732E5F6F6E4469644368616E6765466173743D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E6765466173743D746869732E5F6F6E4469644368616E6765466173742E6576656E742C746869732E5F697344';
wwv_flow_imp.g_varchar2_table(14151) := '6F6D696E6174656442794C6F6E674C696E65733D21312C746869732E5F766965774C696E65436F756E743D312C746869732E5F6C696E654E756D626572734469676974436F756E743D312C746869732E5F72657365727665644865696768743D302C7468';
wwv_flow_imp.g_varchar2_table(14152) := '69732E5F676C7970684D617267696E4465636F726174696F6E4C616E65436F756E743D312C746869732E5F636F6D707574654F7074696F6E734D656D6F72793D6E657720674C2C746869732E697353696D706C655769646765743D652C746869732E636F';
wwv_flow_imp.g_varchar2_table(14153) := '6E746578744D656E7549643D742C746869732E5F636F6E7461696E65724F627365727665723D746869732E5F7265676973746572286E657720664128692C6E2E64696D656E73696F6E29292C746869732E5F74617267657457696E646F7749643D727328';
wwv_flow_imp.g_varchar2_table(14154) := '69292E7673636F646557696E646F7749642C746869732E5F7261774F7074696F6E733D4241286E292C746869732E5F76616C6964617465644F7074696F6E733D46412E76616C69646174654F7074696F6E7328746869732E5F7261774F7074696F6E7329';
wwv_flow_imp.g_varchar2_table(14155) := '2C746869732E6F7074696F6E733D746869732E5F636F6D707574654F7074696F6E7328292C746869732E6F7074696F6E732E676574283133292626746869732E5F636F6E7461696E65724F627365727665722E73746172744F6273657276696E6728292C';
wwv_flow_imp.g_varchar2_table(14156) := '746869732E5F72656769737465722843412E6F6E4469644368616E67655A6F6F6D4C6576656C282828293D3E746869732E5F7265636F6D707574654F7074696F6E7328292929292C746869732E5F72656769737465722841412E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(14157) := '65546162466F637573282828293D3E746869732E5F7265636F6D707574654F7074696F6E7328292929292C746869732E5F726567697374657228746869732E5F636F6E7461696E65724F627365727665722E6F6E4469644368616E6765282828293D3E74';
wwv_flow_imp.g_varchar2_table(14158) := '6869732E5F7265636F6D707574654F7074696F6E7328292929292C746869732E5F7265676973746572284C412E6F6E4469644368616E6765282828293D3E746869732E5F7265636F6D707574654F7074696F6E7328292929292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(14159) := '73746572285F412E676574496E7374616E6365287273286929292E6F6E4469644368616E6765282828293D3E746869732E5F7265636F6D707574654F7074696F6E7328292929292C746869732E5F726567697374657228746869732E5F61636365737369';
wwv_flow_imp.g_varchar2_table(14160) := '62696C697479536572766963652E6F6E4469644368616E676553637265656E5265616465724F7074696D697A6564282828293D3E746869732E5F7265636F6D707574654F7074696F6E7328292929297D5F7265636F6D707574654F7074696F6E7328297B';
wwv_flow_imp.g_varchar2_table(14161) := '636F6E737420653D746869732E5F636F6D707574654F7074696F6E7328292C743D46412E636865636B457175616C7328746869732E6F7074696F6E732C65293B6E756C6C213D3D74262628746869732E6F7074696F6E733D652C746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(14162) := '644368616E6765466173742E666972652874292C746869732E5F6F6E4469644368616E67652E66697265287429297D5F636F6D707574654F7074696F6E7328297B636F6E737420653D746869732E5F72656164456E76436F6E66696775726174696F6E28';
wwv_flow_imp.g_varchar2_table(14163) := '292C743D78412E63726561746546726F6D56616C69646174656453657474696E677328746869732E5F76616C6964617465644F7074696F6E732C652E706978656C526174696F2C746869732E697353696D706C65576964676574292C6E3D746869732E5F';
wwv_flow_imp.g_varchar2_table(14164) := '72656164466F6E74496E666F2874292C693D7B6D656D6F72793A746869732E5F636F6D707574654F7074696F6E734D656D6F72792C6F7574657257696474683A652E6F7574657257696474682C6F757465724865696768743A652E6F7574657248656967';
wwv_flow_imp.g_varchar2_table(14165) := '68742D746869732E5F72657365727665644865696768742C666F6E74496E666F3A6E2C6578747261456469746F72436C6173734E616D653A652E6578747261456469746F72436C6173734E616D652C6973446F6D696E6174656442794C6F6E674C696E65';
wwv_flow_imp.g_varchar2_table(14166) := '733A746869732E5F6973446F6D696E6174656442794C6F6E674C696E65732C766965774C696E65436F756E743A746869732E5F766965774C696E65436F756E742C6C696E654E756D626572734469676974436F756E743A746869732E5F6C696E654E756D';
wwv_flow_imp.g_varchar2_table(14167) := '626572734469676974436F756E742C656D70747953656C656374696F6E436C6970626F6172643A652E656D70747953656C656374696F6E436C6970626F6172642C706978656C526174696F3A652E706978656C526174696F2C746162466F6375734D6F64';
wwv_flow_imp.g_varchar2_table(14168) := '653A41412E676574546162466F6375734D6F646528292C6163636573736962696C697479537570706F72743A652E6163636573736962696C697479537570706F72742C676C7970684D617267696E4465636F726174696F6E4C616E65436F756E743A7468';
wwv_flow_imp.g_varchar2_table(14169) := '69732E5F676C7970684D617267696E4465636F726174696F6E4C616E65436F756E747D3B72657475726E2046412E636F6D707574654F7074696F6E7328746869732E5F76616C6964617465644F7074696F6E732C69297D5F72656164456E76436F6E6669';
wwv_flow_imp.g_varchar2_table(14170) := '6775726174696F6E28297B72657475726E7B6578747261456469746F72436C6173734E616D653A504128292C6F7574657257696474683A746869732E5F636F6E7461696E65724F627365727665722E676574576964746828292C6F757465724865696768';
wwv_flow_imp.g_varchar2_table(14171) := '743A746869732E5F636F6E7461696E65724F627365727665722E67657448656967687428292C656D70747953656C656374696F6E436C6970626F6172643A647C7C632C706978656C526174696F3A5F412E676574496E7374616E63652868732874686973';
wwv_flow_imp.g_varchar2_table(14172) := '2E5F74617267657457696E646F7749642C2130292E77696E646F77292E76616C75652C6163636573736962696C697479537570706F72743A746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074';
wwv_flow_imp.g_varchar2_table(14173) := '696D697A656428293F323A746869732E5F6163636573736962696C697479536572766963652E6765744163636573736962696C697479537570706F727428297D7D5F72656164466F6E74496E666F2865297B72657475726E204C412E72656164466F6E74';
wwv_flow_imp.g_varchar2_table(14174) := '496E666F28687328746869732E5F74617267657457696E646F7749642C2130292E77696E646F772C65297D6765745261774F7074696F6E7328297B72657475726E20746869732E5F7261774F7074696F6E737D7570646174654F7074696F6E732865297B';
wwv_flow_imp.g_varchar2_table(14175) := '636F6E737420743D42412865293B46412E6170706C7955706461746528746869732E5F7261774F7074696F6E732C7429262628746869732E5F76616C6964617465644F7074696F6E733D46412E76616C69646174654F7074696F6E7328746869732E5F72';
wwv_flow_imp.g_varchar2_table(14176) := '61774F7074696F6E73292C746869732E5F7265636F6D707574654F7074696F6E732829297D6F627365727665436F6E7461696E65722865297B746869732E5F636F6E7461696E65724F627365727665722E6F6273657276652865297D7365744973446F6D';
wwv_flow_imp.g_varchar2_table(14177) := '696E6174656442794C6F6E674C696E65732865297B746869732E5F6973446F6D696E6174656442794C6F6E674C696E6573213D3D65262628746869732E5F6973446F6D696E6174656442794C6F6E674C696E65733D652C746869732E5F7265636F6D7075';
wwv_flow_imp.g_varchar2_table(14178) := '74654F7074696F6E732829297D7365744D6F64656C4C696E65436F756E742865297B636F6E737420743D66756E6374696F6E2865297B6C657420743D303B666F72283B653B29653D4D6174682E666C6F6F7228652F3130292C742B2B3B72657475726E20';
wwv_flow_imp.g_varchar2_table(14179) := '747C7C317D2865293B746869732E5F6C696E654E756D626572734469676974436F756E74213D3D74262628746869732E5F6C696E654E756D626572734469676974436F756E743D742C746869732E5F7265636F6D707574654F7074696F6E732829297D73';
wwv_flow_imp.g_varchar2_table(14180) := '6574566965774C696E65436F756E742865297B746869732E5F766965774C696E65436F756E74213D3D65262628746869732E5F766965774C696E65436F756E743D652C746869732E5F7265636F6D707574654F7074696F6E732829297D73657452657365';
wwv_flow_imp.g_varchar2_table(14181) := '727665644865696768742865297B746869732E5F7265736572766564486569676874213D3D65262628746869732E5F72657365727665644865696768743D652C746869732E5F7265636F6D707574654F7074696F6E732829297D736574476C7970684D61';
wwv_flow_imp.g_varchar2_table(14182) := '7267696E4465636F726174696F6E4C616E65436F756E742865297B746869732E5F676C7970684D617267696E4465636F726174696F6E4C616E65436F756E74213D3D65262628746869732E5F676C7970684D617267696E4465636F726174696F6E4C616E';
wwv_flow_imp.g_varchar2_table(14183) := '65436F756E743D652C746869732E5F7265636F6D707574654F7074696F6E732829297D7D3B66756E6374696F6E20504128297B6C657420653D22223B72657475726E20757C7C707C7C28652B3D226E6F2D757365722D73656C6563742022292C75262628';
wwv_flow_imp.g_varchar2_table(14184) := '652B3D226E6F2D6D696E696D61702D736861646F7720222C652B3D22656E61626C652D757365722D73656C6563742022292C71262628652B3D226D61632022292C657D4E413D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D61726775';
wwv_flow_imp.g_varchar2_table(14185) := '6D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C6563742626';
wwv_flow_imp.g_varchar2_table(14186) := '2266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D2928';
wwv_flow_imp.g_varchar2_table(14187) := '6F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374';
wwv_flow_imp.g_varchar2_table(14188) := '696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28342C5953295D2C4E41293B636C617373204F417B636F6E7374727563746F7228297B746869732E5F76616C7565733D5B5D7D5F726561642865297B';
wwv_flow_imp.g_varchar2_table(14189) := '72657475726E20746869732E5F76616C7565735B655D7D6765742865297B72657475726E20746869732E5F76616C7565735B655D7D5F777269746528652C74297B746869732E5F76616C7565735B655D3D747D7D636C6173732052417B636F6E73747275';
wwv_flow_imp.g_varchar2_table(14190) := '63746F7228297B746869732E5F76616C7565733D5B5D7D5F726561642865297B696628653E3D746869732E5F76616C7565732E6C656E677468297468726F77206E6577204572726F72282243616E6E6F74207265616420756E696E697469616C697A6564';
wwv_flow_imp.g_varchar2_table(14191) := '2076616C756522293B72657475726E20746869732E5F76616C7565735B655D7D6765742865297B72657475726E20746869732E5F726561642865297D5F777269746528652C74297B746869732E5F76616C7565735B655D3D747D7D636C6173732046417B';
wwv_flow_imp.g_varchar2_table(14192) := '7374617469632076616C69646174654F7074696F6E732865297B636F6E737420743D6E6577204F413B666F7228636F6E7374206E206F6620474C297B636F6E737420693D225F6E657665725F223D3D3D6E2E6E616D653F766F696420303A655B6E2E6E61';
wwv_flow_imp.g_varchar2_table(14193) := '6D655D3B742E5F7772697465286E2E69642C6E2E76616C6964617465286929297D72657475726E20747D73746174696320636F6D707574654F7074696F6E7328652C74297B636F6E7374206E3D6E65772052413B666F7228636F6E73742069206F662047';
wwv_flow_imp.g_varchar2_table(14194) := '4C296E2E5F777269746528692E69642C692E636F6D7075746528742C6E2C652E5F7265616428692E69642929293B72657475726E206E7D737461746963205F64656570457175616C7328652C74297B696628226F626A65637422213D747970656F662065';
wwv_flow_imp.g_varchar2_table(14195) := '7C7C226F626A65637422213D747970656F6620747C7C21657C7C21742972657475726E20653D3D3D743B69662841727261792E697341727261792865297C7C41727261792E697341727261792874292972657475726E21282141727261792E6973417272';
wwv_flow_imp.g_varchar2_table(14196) := '61792865297C7C2141727261792E69734172726179287429292626506828652C74293B6966284F626A6563742E6B6579732865292E6C656E677468213D3D4F626A6563742E6B6579732874292E6C656E6774682972657475726E21313B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(14197) := '7374206E20696E2065296966282146412E5F64656570457175616C7328655B6E5D2C745B6E5D292972657475726E21313B72657475726E21307D73746174696320636865636B457175616C7328652C74297B636F6E7374206E3D5B5D3B6C657420693D21';
wwv_flow_imp.g_varchar2_table(14198) := '313B666F7228636F6E7374206F206F6620474C297B636F6E737420733D2146412E5F64656570457175616C7328652E5F72656164286F2E6964292C742E5F72656164286F2E696429293B6E5B6F2E69645D3D732C73262628693D2130297D72657475726E';
wwv_flow_imp.g_varchar2_table(14199) := '20693F6E657720704C286E293A6E756C6C7D737461746963206170706C7955706461746528652C74297B6C6574206E3D21313B666F7228636F6E73742069206F6620474C29696628742E6861734F776E50726F706572747928692E6E616D6529297B636F';
wwv_flow_imp.g_varchar2_table(14200) := '6E7374206F3D692E6170706C7955706461746528655B692E6E616D655D2C745B692E6E616D655D293B655B692E6E616D655D3D6F2E6E657756616C75652C6E3D6E7C7C6F2E6469644368616E67657D72657475726E206E7D7D66756E6374696F6E204241';
wwv_flow_imp.g_varchar2_table(14201) := '2865297B636F6E737420743D66682865293B72657475726E2066756E6374696F6E2865297B44412E6974656D732E666F72456163682828743D3E742E6170706C7928652929297D2874292C747D636C6173732056417B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(14202) := '74297B746869732E783D652C746869732E793D742C746869732E5F70616765436F6F7264696E617465734272616E643D766F696420307D746F436C69656E74436F6F7264696E617465732865297B72657475726E206E6577207A4128746869732E782D65';
wwv_flow_imp.g_varchar2_table(14203) := '2E7363726F6C6C582C746869732E792D652E7363726F6C6C59297D7D636C617373207A417B636F6E7374727563746F7228652C74297B746869732E636C69656E74583D652C746869732E636C69656E74593D742C746869732E5F636C69656E74436F6F72';
wwv_flow_imp.g_varchar2_table(14204) := '64696E617465734272616E643D766F696420307D746F50616765436F6F7264696E617465732865297B72657475726E206E657720564128746869732E636C69656E74582B652E7363726F6C6C582C746869732E636C69656E74592B652E7363726F6C6C59';
wwv_flow_imp.g_varchar2_table(14205) := '297D7D636C6173732048417B636F6E7374727563746F7228652C742C6E2C69297B746869732E783D652C746869732E793D742C746869732E77696474683D6E2C746869732E6865696768743D692C746869732E5F656469746F7250616765506F73697469';
wwv_flow_imp.g_varchar2_table(14206) := '6F6E4272616E643D766F696420307D7D636C6173732057417B636F6E7374727563746F7228652C74297B746869732E783D652C746869732E793D742C746869732E5F706F736974696F6E52656C6174697665546F456469746F724272616E643D766F6964';
wwv_flow_imp.g_varchar2_table(14207) := '20307D7D66756E6374696F6E206A412865297B636F6E737420743D41732865293B72657475726E206E657720484128742E6C6566742C742E746F702C742E77696474682C742E686569676874297D66756E6374696F6E20714128652C742C6E297B636F6E';
wwv_flow_imp.g_varchar2_table(14208) := '737420693D742E77696474682F652E6F666673657457696474682C6F3D742E6865696768742F652E6F66667365744865696768742C733D286E2E782D742E78292F692C723D286E2E792D742E79292F6F3B72657475726E206E657720574128732C72297D';
wwv_flow_imp.g_varchar2_table(14209) := '636C61737320244120657874656E64732047657B636F6E7374727563746F7228652C742C6E297B7375706572287273286E292C65292C746869732E5F656469746F724D6F7573654576656E744272616E643D766F696420302C746869732E697346726F6D';
wwv_flow_imp.g_varchar2_table(14210) := '506F696E746572436170747572653D742C746869732E706F733D6E657720564128746869732E706F73782C746869732E706F7379292C746869732E656469746F72506F733D6A41286E292C746869732E72656C6174697665506F733D7141286E2C746869';
wwv_flow_imp.g_varchar2_table(14211) := '732E656469746F72506F732C746869732E706F73297D7D636C6173732055417B636F6E7374727563746F722865297B746869732E5F656469746F7256696577446F6D4E6F64653D657D5F6372656174652865297B72657475726E206E657720244128652C';
wwv_flow_imp.g_varchar2_table(14212) := '21312C746869732E5F656469746F7256696577446F6D4E6F6465297D6F6E436F6E746578744D656E7528652C74297B72657475726E20627328652C22636F6E746578746D656E75222C28653D3E7B7428746869732E5F637265617465286529297D29297D';
wwv_flow_imp.g_varchar2_table(14213) := '6F6E4D6F757365557028652C74297B72657475726E20627328652C226D6F7573657570222C28653D3E7B7428746869732E5F637265617465286529297D29297D6F6E4D6F757365446F776E28652C74297B72657475726E20627328652C61722E4D4F5553';
wwv_flow_imp.g_varchar2_table(14214) := '455F444F574E2C28653D3E7B7428746869732E5F637265617465286529297D29297D6F6E506F696E746572446F776E28652C74297B72657475726E20627328652C61722E504F494E5445525F444F574E2C28653D3E7B7428746869732E5F637265617465';
wwv_flow_imp.g_varchar2_table(14215) := '2865292C652E706F696E7465724964297D29297D6F6E4D6F7573654C6561766528652C74297B72657475726E20627328652C61722E4D4F5553455F4C454156452C28653D3E7B7428746869732E5F637265617465286529297D29297D6F6E4D6F7573654D';
wwv_flow_imp.g_varchar2_table(14216) := '6F766528652C74297B72657475726E20627328652C226D6F7573656D6F7665222C28653D3E7428746869732E5F6372656174652865292929297D7D636C617373204B417B636F6E7374727563746F722865297B746869732E5F656469746F725669657744';
wwv_flow_imp.g_varchar2_table(14217) := '6F6D4E6F64653D657D5F6372656174652865297B72657475726E206E657720244128652C21312C746869732E5F656469746F7256696577446F6D4E6F6465297D6F6E506F696E746572557028652C74297B72657475726E20627328652C22706F696E7465';
wwv_flow_imp.g_varchar2_table(14218) := '727570222C28653D3E7B7428746869732E5F637265617465286529297D29297D6F6E506F696E746572446F776E28652C74297B72657475726E20627328652C61722E504F494E5445525F444F574E2C28653D3E7B7428746869732E5F6372656174652865';
wwv_flow_imp.g_varchar2_table(14219) := '292C652E706F696E7465724964297D29297D6F6E506F696E7465724C6561766528652C74297B72657475726E20627328652C61722E504F494E5445525F4C454156452C28653D3E7B7428746869732E5F637265617465286529297D29297D6F6E506F696E';
wwv_flow_imp.g_varchar2_table(14220) := '7465724D6F766528652C74297B72657475726E20627328652C22706F696E7465726D6F7665222C28653D3E7428746869732E5F6372656174652865292929297D7D636C61737320474120657874656E6473206C747B636F6E7374727563746F722865297B';
wwv_flow_imp.g_varchar2_table(14221) := '737570657228292C746869732E5F656469746F7256696577446F6D4E6F64653D652C746869732E5F676C6F62616C506F696E7465724D6F76654D6F6E69746F723D746869732E5F7265676973746572286E6577204B44292C746869732E5F6B6579646F77';
wwv_flow_imp.g_varchar2_table(14222) := '6E4C697374656E65723D6E756C6C7D73746172744D6F6E69746F72696E6728652C742C6E2C692C6F297B746869732E5F6B6579646F776E4C697374656E65723D797328652E6F776E6572446F63756D656E742C226B6579646F776E222C28653D3E7B652E';
wwv_flow_imp.g_varchar2_table(14223) := '746F4B6579436F646543686F726428292E69734D6F6469666965724B657928297C7C746869732E5F676C6F62616C506F696E7465724D6F76654D6F6E69746F722E73746F704D6F6E69746F72696E672821302C652E62726F777365724576656E74297D29';
wwv_flow_imp.g_varchar2_table(14224) := '2C2130292C746869732E5F676C6F62616C506F696E7465724D6F76654D6F6E69746F722E73746172744D6F6E69746F72696E6728652C742C6E2C28653D3E7B69286E657720244128652C21302C746869732E5F656469746F7256696577446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(14225) := '29297D292C28653D3E7B746869732E5F6B6579646F776E4C697374656E65722E646973706F736528292C6F2865297D29297D73746F704D6F6E69746F72696E6728297B746869732E5F676C6F62616C506F696E7465724D6F76654D6F6E69746F722E7374';
wwv_flow_imp.g_varchar2_table(14226) := '6F704D6F6E69746F72696E67282130297D7D636C6173732051417B636F6E7374727563746F722865297B746869732E5F656469746F723D652C746869732E5F696E7374616E636549643D2B2B51412E5F6964506F6F6C2C746869732E5F636F756E746572';
wwv_flow_imp.g_varchar2_table(14227) := '3D302C746869732E5F72756C65733D6E6577204D61702C746869732E5F67617262616765436F6C6C656374696F6E5363686564756C65723D6E6577204B74282828293D3E746869732E67617262616765436F6C6C6563742829292C316533297D63726561';
wwv_flow_imp.g_varchar2_table(14228) := '7465436C6173734E616D655265662865297B636F6E737420743D746869732E6765744F7243726561746552756C652865293B72657475726E20742E696E637265617365526566436F756E7428292C7B636C6173734E616D653A742E636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(14229) := '2C646973706F73653A28293D3E7B742E6465637265617365526566436F756E7428292C746869732E5F67617262616765436F6C6C656374696F6E5363686564756C65722E7363686564756C6528297D7D7D6765744F7243726561746552756C652865297B';
wwv_flow_imp.g_varchar2_table(14230) := '636F6E737420743D746869732E636F6D70757465556E697175654B65792865293B6C6574206E3D746869732E5F72756C65732E6765742874293B696628216E297B636F6E737420693D746869732E5F636F756E7465722B2B3B6E3D6E657720594128742C';
wwv_flow_imp.g_varchar2_table(14231) := '6064796E2D72756C652D247B746869732E5F696E7374616E636549647D2D247B697D602C487328746869732E5F656469746F722E676574436F6E7461696E6572446F6D4E6F64652829293F746869732E5F656469746F722E676574436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(14232) := '446F6D4E6F646528293A766F696420302C65292C746869732E5F72756C65732E73657428742C6E297D72657475726E206E7D636F6D70757465556E697175654B65792865297B72657475726E204A534F4E2E737472696E676966792865297D6761726261';
wwv_flow_imp.g_varchar2_table(14233) := '6765436F6C6C65637428297B666F7228636F6E73742065206F6620746869732E5F72756C65732E76616C756573282929652E6861735265666572656E63657328297C7C28746869732E5F72756C65732E64656C65746528652E6B6579292C652E64697370';
wwv_flow_imp.g_varchar2_table(14234) := '6F73652829297D7D51412E5F6964506F6F6C3D303B636C6173732059417B636F6E7374727563746F7228652C742C6E2C69297B746869732E6B65793D652C746869732E636C6173734E616D653D742C746869732E70726F706572746965733D692C746869';
wwv_flow_imp.g_varchar2_table(14235) := '732E5F7265666572656E6365436F756E743D302C746869732E5F7374796C65456C656D656E74446973706F7361626C65733D6E65772061742C746869732E5F7374796C65456C656D656E743D5973286E2C766F696420302C746869732E5F7374796C6545';
wwv_flow_imp.g_varchar2_table(14236) := '6C656D656E74446973706F7361626C6573292C746869732E5F7374796C65456C656D656E742E74657874436F6E74656E743D746869732E6765744373735465787428746869732E636C6173734E616D652C746869732E70726F70657274696573297D6765';
wwv_flow_imp.g_varchar2_table(14237) := '744373735465787428652C74297B6C6574206E3D602E247B657D207B603B666F7228636F6E7374206520696E2074297B636F6E737420693D745B655D3B6C6574206F3B6F3D226F626A656374223D3D747970656F6620693F786D28692E6964293A692C6E';
wwv_flow_imp.g_varchar2_table(14238) := '2B3D605C6E5C74247B5A412865297D3A20247B6F7D3B607D72657475726E206E2B3D225C6E7D222C6E7D646973706F736528297B746869732E5F7374796C65456C656D656E74446973706F7361626C65732E646973706F736528292C746869732E5F7374';
wwv_flow_imp.g_varchar2_table(14239) := '796C65456C656D656E743D766F696420307D696E637265617365526566436F756E7428297B746869732E5F7265666572656E6365436F756E742B2B7D6465637265617365526566436F756E7428297B746869732E5F7265666572656E6365436F756E742D';
wwv_flow_imp.g_varchar2_table(14240) := '2D7D6861735265666572656E63657328297B72657475726E20746869732E5F7265666572656E6365436F756E743E307D7D66756E6374696F6E205A412865297B72657475726E20652E7265706C616365282F285E5B412D5A5D292F2C28285B655D293D3E';
wwv_flow_imp.g_varchar2_table(14241) := '652E746F4C6F77657243617365282929292E7265706C616365282F285B412D5A5D292F672C28285B655D293D3E602D247B652E746F4C6F7765724361736528297D6029297D636C61737320584120657874656E6473206C747B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(14242) := '28297B737570657228292C746869732E5F73686F756C6452656E6465723D21307D73686F756C6452656E64657228297B72657475726E20746869732E5F73686F756C6452656E6465727D666F72636553686F756C6452656E64657228297B746869732E5F';
wwv_flow_imp.g_varchar2_table(14243) := '73686F756C6452656E6465723D21307D73657453686F756C6452656E64657228297B746869732E5F73686F756C6452656E6465723D21307D6F6E44696452656E64657228297B746869732E5F73686F756C6452656E6465723D21317D6F6E436F6D706F73';
wwv_flow_imp.g_varchar2_table(14244) := '6974696F6E53746172742865297B72657475726E21317D6F6E436F6D706F736974696F6E456E642865297B72657475726E21317D6F6E436F6E66696775726174696F6E4368616E6765642865297B72657475726E21317D6F6E437572736F725374617465';
wwv_flow_imp.g_varchar2_table(14245) := '4368616E6765642865297B72657475726E21317D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21317D6F6E466C75736865642865297B72657475726E21317D6F6E466F6375734368616E6765642865297B72657475726E21';
wwv_flow_imp.g_varchar2_table(14246) := '317D6F6E4C616E6775616765436F6E66696775726174696F6E4368616E6765642865297B72657475726E21317D6F6E4C696E654D617070696E674368616E6765642865297B72657475726E21317D6F6E4C696E65734368616E6765642865297B72657475';
wwv_flow_imp.g_varchar2_table(14247) := '726E21317D6F6E4C696E657344656C657465642865297B72657475726E21317D6F6E4C696E6573496E7365727465642865297B72657475726E21317D6F6E52657665616C52616E6765526571756573742865297B72657475726E21317D6F6E5363726F6C';
wwv_flow_imp.g_varchar2_table(14248) := '6C4368616E6765642865297B72657475726E21317D6F6E5468656D654368616E6765642865297B72657475726E21317D6F6E546F6B656E734368616E6765642865297B72657475726E21317D6F6E546F6B656E73436F6C6F72734368616E676564286529';
wwv_flow_imp.g_varchar2_table(14249) := '7B72657475726E21317D6F6E5A6F6E65734368616E6765642865297B72657475726E21317D68616E646C654576656E74732865297B6C657420743D21313B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(14250) := '693D655B6E5D3B73776974636828692E74797065297B6361736520303A746869732E6F6E436F6D706F736974696F6E5374617274286929262628743D2130293B627265616B3B6361736520313A746869732E6F6E436F6D706F736974696F6E456E642869';
wwv_flow_imp.g_varchar2_table(14251) := '29262628743D2130293B627265616B3B6361736520323A746869732E6F6E436F6E66696775726174696F6E4368616E676564286929262628743D2130293B627265616B3B6361736520333A746869732E6F6E437572736F7253746174654368616E676564';
wwv_flow_imp.g_varchar2_table(14252) := '286929262628743D2130293B627265616B3B6361736520343A746869732E6F6E4465636F726174696F6E734368616E676564286929262628743D2130293B627265616B3B6361736520353A746869732E6F6E466C7573686564286929262628743D213029';
wwv_flow_imp.g_varchar2_table(14253) := '3B627265616B3B6361736520363A746869732E6F6E466F6375734368616E676564286929262628743D2130293B627265616B3B6361736520373A746869732E6F6E4C616E6775616765436F6E66696775726174696F6E4368616E67656428692926262874';
wwv_flow_imp.g_varchar2_table(14254) := '3D2130293B627265616B3B6361736520383A746869732E6F6E4C696E654D617070696E674368616E676564286929262628743D2130293B627265616B3B6361736520393A746869732E6F6E4C696E65734368616E676564286929262628743D2130293B62';
wwv_flow_imp.g_varchar2_table(14255) := '7265616B3B636173652031303A746869732E6F6E4C696E657344656C65746564286929262628743D2130293B627265616B3B636173652031313A746869732E6F6E4C696E6573496E736572746564286929262628743D2130293B627265616B3B63617365';
wwv_flow_imp.g_varchar2_table(14256) := '2031323A746869732E6F6E52657665616C52616E676552657175657374286929262628743D2130293B627265616B3B636173652031333A746869732E6F6E5363726F6C6C4368616E676564286929262628743D2130293B627265616B3B63617365203135';
wwv_flow_imp.g_varchar2_table(14257) := '3A746869732E6F6E546F6B656E734368616E676564286929262628743D2130293B627265616B3B636173652031343A746869732E6F6E5468656D654368616E676564286929262628743D2130293B627265616B3B636173652031363A746869732E6F6E54';
wwv_flow_imp.g_varchar2_table(14258) := '6F6B656E73436F6C6F72734368616E676564286929262628743D2130293B627265616B3B636173652031373A746869732E6F6E5A6F6E65734368616E676564286929262628743D2130293B627265616B3B64656661756C743A636F6E736F6C652E696E66';
wwv_flow_imp.g_varchar2_table(14259) := '6F28225669657720726563656976656420756E6B6E6F776E206576656E743A2022292C636F6E736F6C652E696E666F2869297D7D74262628746869732E5F73686F756C6452656E6465723D2130297D7D636C617373204A4120657874656E64732058417B';
wwv_flow_imp.g_varchar2_table(14260) := '636F6E7374727563746F722865297B737570657228292C746869732E5F636F6E746578743D652C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E5F636F6E746578742E72';
wwv_flow_imp.g_varchar2_table(14261) := '656D6F76654576656E7448616E646C65722874686973292C73757065722E646973706F736528297D7D636C61737320654E7B73746174696320777269746528652C74297B652E7365744174747269627574652822646174612D6D707274222C537472696E';
wwv_flow_imp.g_varchar2_table(14262) := '67287429297D73746174696320726561642865297B636F6E737420743D652E6765744174747269627574652822646174612D6D70727422293B72657475726E206E756C6C3D3D3D743F303A7061727365496E7428742C3130297D73746174696320636F6C';
wwv_flow_imp.g_varchar2_table(14263) := '6C65637428652C74297B636F6E7374206E3D5B5D3B6C657420693D303B666F72283B65262665213D3D652E6F776E6572446F63756D656E742E626F6479262665213D3D743B29652E6E6F6465547970653D3D3D652E454C454D454E545F4E4F4445262628';
wwv_flow_imp.g_varchar2_table(14264) := '6E5B692B2B5D3D746869732E72656164286529292C653D652E706172656E74456C656D656E743B636F6E7374206F3D6E65772055696E743841727261792869293B666F72286C657420653D303B653C693B652B2B296F5B655D3D6E5B692D652D315D3B72';
wwv_flow_imp.g_varchar2_table(14265) := '657475726E206F7D7D636C61737320744E7B636F6E7374727563746F7228652C74297B746869732E5F7265737472696374656452656E646572696E67436F6E746578744272616E643D766F696420302C746869732E5F766965774C61796F75743D652C74';
wwv_flow_imp.g_varchar2_table(14266) := '6869732E76696577706F7274446174613D742C746869732E7363726F6C6C57696474683D746869732E5F766965774C61796F75742E6765745363726F6C6C576964746828292C746869732E7363726F6C6C4865696768743D746869732E5F766965774C61';
wwv_flow_imp.g_varchar2_table(14267) := '796F75742E6765745363726F6C6C48656967687428292C746869732E76697369626C6552616E67653D746869732E76696577706F7274446174612E76697369626C6552616E67652C746869732E6269674E756D6265727344656C74613D746869732E7669';
wwv_flow_imp.g_varchar2_table(14268) := '6577706F7274446174612E6269674E756D6265727344656C74613B636F6E7374206E3D746869732E5F766965774C61796F75742E67657443757272656E7456696577706F727428293B746869732E7363726F6C6C546F703D6E2E746F702C746869732E73';
wwv_flow_imp.g_varchar2_table(14269) := '63726F6C6C4C6566743D6E2E6C6566742C746869732E76696577706F727457696474683D6E2E77696474682C746869732E76696577706F72744865696768743D6E2E6865696768747D6765745363726F6C6C6564546F7046726F6D4162736F6C75746554';
wwv_flow_imp.g_varchar2_table(14270) := '6F702865297B72657475726E20652D746869732E7363726F6C6C546F707D676574566572746963616C4F6666736574466F724C696E654E756D62657228652C74297B72657475726E20746869732E5F766965774C61796F75742E67657456657274696361';
wwv_flow_imp.g_varchar2_table(14271) := '6C4F6666736574466F724C696E654E756D62657228652C74297D676574566572746963616C4F666673657441667465724C696E654E756D62657228652C74297B72657475726E20746869732E5F766965774C61796F75742E676574566572746963616C4F';
wwv_flow_imp.g_varchar2_table(14272) := '666673657441667465724C696E654E756D62657228652C74297D6765744465636F726174696F6E73496E56696577706F727428297B72657475726E20746869732E76696577706F7274446174612E6765744465636F726174696F6E73496E56696577706F';
wwv_flow_imp.g_varchar2_table(14273) := '727428297D7D636C617373206E4E20657874656E647320744E7B636F6E7374727563746F7228652C742C6E297B737570657228652C74292C746869732E5F72656E646572696E67436F6E746578744272616E643D766F696420302C746869732E5F766965';
wwv_flow_imp.g_varchar2_table(14274) := '774C696E65733D6E7D6C696E657356697369626C6552616E676573466F7252616E676528652C74297B72657475726E20746869732E5F766965774C696E65732E6C696E657356697369626C6552616E676573466F7252616E676528652C74297D76697369';
wwv_flow_imp.g_varchar2_table(14275) := '626C6552616E6765466F72506F736974696F6E2865297B72657475726E20746869732E5F766965774C696E65732E76697369626C6552616E6765466F72506F736974696F6E2865297D7D636C61737320694E7B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(14276) := '2C69297B746869732E6F75747369646552656E64657265644C696E653D652C746869732E6C696E654E756D6265723D742C746869732E72616E6765733D6E2C746869732E636F6E74696E7565734F6E4E6578744C696E653D697D7D636C617373206F4E7B';
wwv_flow_imp.g_varchar2_table(14277) := '7374617469632066726F6D2865297B636F6E737420743D6E657720417272617928652E6C656E677468293B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B745B6E5D3D6E6577206F4E28';
wwv_flow_imp.g_varchar2_table(14278) := '692E6C6566742C692E7769647468297D72657475726E20747D636F6E7374727563746F7228652C74297B746869732E5F686F72697A6F6E74616C52616E67654272616E643D766F696420302C746869732E6C6566743D4D6174682E726F756E642865292C';
wwv_flow_imp.g_varchar2_table(14279) := '746869732E77696474683D4D6174682E726F756E642874297D746F537472696E6728297B72657475726E605B247B746869732E6C6566747D2C247B746869732E77696474687D5D607D7D636C61737320734E7B636F6E7374727563746F7228652C74297B';
wwv_flow_imp.g_varchar2_table(14280) := '746869732E5F666C6F6174486F72697A6F6E74616C52616E67654272616E643D766F696420302C746869732E6C6566743D652C746869732E77696474683D747D746F537472696E6728297B72657475726E605B247B746869732E6C6566747D2C247B7468';
wwv_flow_imp.g_varchar2_table(14281) := '69732E77696474687D5D607D73746174696320636F6D7061726528652C74297B72657475726E20652E6C6566742D742E6C6566747D7D636C61737320724E7B636F6E7374727563746F7228652C74297B746869732E6F75747369646552656E6465726564';
wwv_flow_imp.g_varchar2_table(14282) := '4C696E653D652C746869732E6F726967696E616C4C6566743D742C746869732E6C6566743D4D6174682E726F756E6428746869732E6F726967696E616C4C656674297D7D636C61737320614E7B636F6E7374727563746F7228652C74297B746869732E6F';
wwv_flow_imp.g_varchar2_table(14283) := '75747369646552656E64657265644C696E653D652C746869732E72616E6765733D747D7D636C617373206C4E7B737461746963205F63726561746552616E676528297B72657475726E20746869732E5F68616E6479526561647952616E67657C7C287468';
wwv_flow_imp.g_varchar2_table(14284) := '69732E5F68616E6479526561647952616E67653D646F63756D656E742E63726561746552616E67652829292C746869732E5F68616E6479526561647952616E67657D737461746963205F64657461636852616E676528652C74297B652E73656C6563744E';
wwv_flow_imp.g_varchar2_table(14285) := '6F6465436F6E74656E74732874297D737461746963205F72656164436C69656E74526563747328652C742C6E2C692C6F297B636F6E737420733D746869732E5F63726561746552616E676528293B7472797B72657475726E20732E736574537461727428';
wwv_flow_imp.g_varchar2_table(14286) := '652C74292C732E736574456E64286E2C69292C732E676574436C69656E74526563747328297D63617463682865297B72657475726E206E756C6C7D66696E616C6C797B746869732E5F64657461636852616E676528732C6F297D7D737461746963205F6D';
wwv_flow_imp.g_varchar2_table(14287) := '6572676541646A6163656E7452616E6765732865297B696628313D3D3D652E6C656E6774682972657475726E20653B652E736F727428734E2E636F6D70617265293B636F6E737420743D5B5D3B6C6574206E3D302C693D655B305D3B666F72286C657420';
wwv_flow_imp.g_varchar2_table(14288) := '6F3D312C733D652E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D655B6F5D3B692E6C6566742B692E77696474682B2E393E3D732E6C6566743F692E77696474683D4D6174682E6D617828692E77696474682C732E6C6566742B732E776964';
wwv_flow_imp.g_varchar2_table(14289) := '74682D692E6C656674293A28745B6E2B2B5D3D692C693D73297D72657475726E20745B6E2B2B5D3D692C747D737461746963205F637265617465486F72697A6F6E74616C52616E67657346726F6D436C69656E74526563747328652C742C6E297B696628';
wwv_flow_imp.g_varchar2_table(14290) := '21657C7C303D3D3D652E6C656E6774682972657475726E206E756C6C3B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D652E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D655B6F5D3B695B6F5D3D6E657720734E284D6174';
wwv_flow_imp.g_varchar2_table(14291) := '682E6D617828302C28732E6C6566742D74292F6E292C732E77696474682F6E297D72657475726E20746869732E5F6D6572676541646A6163656E7452616E6765732869297D7374617469632072656164486F72697A6F6E74616C52616E67657328652C74';
wwv_flow_imp.g_varchar2_table(14292) := '2C6E2C692C6F2C73297B636F6E737420723D652E6368696C6472656E2E6C656E6774682D313B696628303E722972657475726E206E756C6C3B69662828743D4D6174682E6D696E28722C4D6174682E6D617828302C742929293D3D3D28693D4D6174682E';
wwv_flow_imp.g_varchar2_table(14293) := '6D696E28722C4D6174682E6D617828302C6929292926266E3D3D3D6F2626303D3D3D6E262621652E6368696C6472656E5B745D2E66697273744368696C64297B636F6E7374206E3D652E6368696C6472656E5B745D2E676574436C69656E745265637473';
wwv_flow_imp.g_varchar2_table(14294) := '28293B72657475726E20732E6D61726B446964446F6D4C61796F757428292C746869732E5F637265617465486F72697A6F6E74616C52616E67657346726F6D436C69656E745265637473286E2C732E636C69656E745265637444656C74614C6566742C73';
wwv_flow_imp.g_varchar2_table(14295) := '2E636C69656E74526563745363616C65297D74213D3D692626693E302626303D3D3D6F262628692D2D2C6F3D31303733373431383234293B6C657420613D652E6368696C6472656E5B745D2E66697273744368696C642C6C3D652E6368696C6472656E5B';
wwv_flow_imp.g_varchar2_table(14296) := '695D2E66697273744368696C643B6966286126266C7C7C2821612626303D3D3D6E2626743E30262628613D652E6368696C6472656E5B742D315D2E66697273744368696C642C6E3D31303733373431383234292C216C2626303D3D3D6F2626693E302626';
wwv_flow_imp.g_varchar2_table(14297) := '286C3D652E6368696C6472656E5B692D315D2E66697273744368696C642C6F3D3130373337343138323429292C21617C7C216C2972657475726E206E756C6C3B6E3D4D6174682E6D696E28612E74657874436F6E74656E742E6C656E6774682C4D617468';
wwv_flow_imp.g_varchar2_table(14298) := '2E6D617828302C6E29292C6F3D4D6174682E6D696E286C2E74657874436F6E74656E742E6C656E6774682C4D6174682E6D617828302C6F29293B636F6E737420633D746869732E5F72656164436C69656E74526563747328612C6E2C6C2C6F2C732E656E';
wwv_flow_imp.g_varchar2_table(14299) := '644E6F6465293B72657475726E20732E6D61726B446964446F6D4C61796F757428292C746869732E5F637265617465486F72697A6F6E74616C52616E67657346726F6D436C69656E74526563747328632C732E636C69656E745265637444656C74614C65';
wwv_flow_imp.g_varchar2_table(14300) := '66742C732E636C69656E74526563745363616C65297D7D636C61737320634E7B636F6E7374727563746F7228652C742C6E2C69297B746869732E7374617274436F6C756D6E3D652C746869732E656E64436F6C756D6E3D742C746869732E636C6173734E';
wwv_flow_imp.g_varchar2_table(14301) := '616D653D6E2C746869732E747970653D692C746869732E5F6C696E654465636F726174696F6E4272616E643D766F696420307D737461746963205F657175616C7328652C74297B72657475726E20652E7374617274436F6C756D6E3D3D3D742E73746172';
wwv_flow_imp.g_varchar2_table(14302) := '74436F6C756D6E2626652E656E64436F6C756D6E3D3D3D742E656E64436F6C756D6E2626652E636C6173734E616D653D3D3D742E636C6173734E616D652626652E747970653D3D3D742E747970657D73746174696320657175616C7341727228652C7429';
wwv_flow_imp.g_varchar2_table(14303) := '7B636F6E7374206E3D652E6C656E6774683B6966286E213D3D742E6C656E6774682972657475726E21313B666F72286C657420693D303B693C6E3B692B2B2969662821634E2E5F657175616C7328655B695D2C745B695D292972657475726E21313B7265';
wwv_flow_imp.g_varchar2_table(14304) := '7475726E21307D73746174696320657874726163745772617070656428652C742C6E297B696628303D3D3D652E6C656E6774682972657475726E20653B636F6E737420693D742B312C6F3D6E2B312C733D6E2D742C723D5B5D3B6C657420613D303B666F';
wwv_flow_imp.g_varchar2_table(14305) := '7228636F6E73742074206F66206529742E656E64436F6C756D6E3C3D697C7C742E7374617274436F6C756D6E3E3D6F7C7C28725B612B2B5D3D6E657720634E284D6174682E6D617828312C742E7374617274436F6C756D6E2D692B31292C4D6174682E6D';
wwv_flow_imp.g_varchar2_table(14306) := '696E28732B312C742E656E64436F6C756D6E2D692B31292C742E636C6173734E616D652C742E7479706529293B72657475726E20727D7374617469632066696C74657228652C742C6E2C69297B696628303D3D3D652E6C656E6774682972657475726E5B';
wwv_flow_imp.g_varchar2_table(14307) := '5D3B636F6E7374206F3D5B5D3B6C657420733D303B666F72286C657420723D302C613D652E6C656E6774683B723C613B722B2B297B636F6E737420613D655B725D2C6C3D612E72616E67653B6966286C2E656E644C696E654E756D6265723C747C7C6C2E';
wwv_flow_imp.g_varchar2_table(14308) := '73746172744C696E654E756D6265723E7429636F6E74696E75653B6966286C2E6973456D7074792829262628303D3D3D612E747970657C7C333D3D3D612E747970652929636F6E74696E75653B636F6E737420633D6C2E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(14309) := '65723D3D3D743F6C2E7374617274436F6C756D6E3A6E2C643D6C2E656E644C696E654E756D6265723D3D3D743F6C2E656E64436F6C756D6E3A693B6F5B732B2B5D3D6E657720634E28632C642C612E696E6C696E65436C6173734E616D652C612E747970';
wwv_flow_imp.g_varchar2_table(14310) := '65297D72657475726E206F7D737461746963205F74797065436F6D7061726528652C74297B636F6E7374206E3D5B322C302C312C335D3B72657475726E206E5B655D2D6E5B745D7D73746174696320636F6D7061726528652C74297B696628652E737461';
wwv_flow_imp.g_varchar2_table(14311) := '7274436F6C756D6E213D3D742E7374617274436F6C756D6E2972657475726E20652E7374617274436F6C756D6E2D742E7374617274436F6C756D6E3B696628652E656E64436F6C756D6E213D3D742E656E64436F6C756D6E2972657475726E20652E656E';
wwv_flow_imp.g_varchar2_table(14312) := '64436F6C756D6E2D742E656E64436F6C756D6E3B636F6E7374206E3D634E2E5F74797065436F6D7061726528652E747970652C742E74797065293B72657475726E2030213D3D6E3F6E3A652E636C6173734E616D65213D3D742E636C6173734E616D653F';
wwv_flow_imp.g_varchar2_table(14313) := '652E636C6173734E616D653C742E636C6173734E616D653F2D313A313A307D7D636C61737320644E7B636F6E7374727563746F7228652C742C6E2C69297B746869732E73746172744F66667365743D652C746869732E656E644F66667365743D742C7468';
wwv_flow_imp.g_varchar2_table(14314) := '69732E636C6173734E616D653D6E2C746869732E6D657461646174613D697D7D636C61737320684E7B636F6E7374727563746F7228297B746869732E73746F704F6666736574733D5B5D2C746869732E636C6173734E616D65733D5B5D2C746869732E6D';
wwv_flow_imp.g_varchar2_table(14315) := '657461646174613D5B5D2C746869732E636F756E743D307D737461746963205F6D657461646174612865297B6C657420743D303B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29747C3D655B6E5D3B72657475726E20747D';
wwv_flow_imp.g_varchar2_table(14316) := '636F6E73756D654C6F7765725468616E28652C742C6E297B666F72283B746869732E636F756E743E302626746869732E73746F704F6666736574735B305D3C653B297B6C657420653D303B666F72283B652B313C746869732E636F756E74262674686973';
wwv_flow_imp.g_varchar2_table(14317) := '2E73746F704F6666736574735B655D3D3D3D746869732E73746F704F6666736574735B652B315D3B29652B2B3B6E2E70757368286E657720644E28742C746869732E73746F704F6666736574735B655D2C746869732E636C6173734E616D65732E6A6F69';
wwv_flow_imp.g_varchar2_table(14318) := '6E28222022292C684E2E5F6D6574616461746128746869732E6D657461646174612929292C743D746869732E73746F704F6666736574735B655D2B312C746869732E73746F704F6666736574732E73706C69636528302C652B31292C746869732E636C61';
wwv_flow_imp.g_varchar2_table(14319) := '73734E616D65732E73706C69636528302C652B31292C746869732E6D657461646174612E73706C69636528302C652B31292C746869732E636F756E742D3D652B317D72657475726E20746869732E636F756E743E302626743C652626286E2E7075736828';
wwv_flow_imp.g_varchar2_table(14320) := '6E657720644E28742C652D312C746869732E636C6173734E616D65732E6A6F696E28222022292C684E2E5F6D6574616461746128746869732E6D657461646174612929292C743D65292C747D696E7365727428652C742C6E297B696628303D3D3D746869';
wwv_flow_imp.g_varchar2_table(14321) := '732E636F756E747C7C746869732E73746F704F6666736574735B746869732E636F756E742D315D3C3D6529746869732E73746F704F6666736574732E707573682865292C746869732E636C6173734E616D65732E707573682874292C746869732E6D6574';
wwv_flow_imp.g_varchar2_table(14322) := '61646174612E70757368286E293B656C736520666F72286C657420693D303B693C746869732E636F756E743B692B2B29696628746869732E73746F704F6666736574735B695D3E3D65297B746869732E73746F704F6666736574732E73706C6963652869';
wwv_flow_imp.g_varchar2_table(14323) := '2C302C65292C746869732E636C6173734E616D65732E73706C69636528692C302C74292C746869732E6D657461646174612E73706C69636528692C302C6E293B627265616B7D746869732E636F756E742B2B7D7D636C61737320754E7B73746174696320';
wwv_flow_imp.g_varchar2_table(14324) := '6E6F726D616C697A6528652C74297B696628303D3D3D742E6C656E6774682972657475726E5B5D3B636F6E7374206E3D5B5D2C693D6E657720684E3B6C6574206F3D303B666F72286C657420733D302C723D742E6C656E6774683B733C723B732B2B297B';
wwv_flow_imp.g_varchar2_table(14325) := '636F6E737420723D745B735D3B6C657420613D722E7374617274436F6C756D6E2C6C3D722E656E64436F6C756D6E3B636F6E737420633D722E636C6173734E616D652C643D313D3D3D722E747970653F323A323D3D3D722E747970653F343A303B613E31';
wwv_flow_imp.g_varchar2_table(14326) := '2626546928652E63686172436F6465417428612D3229292626612D2D2C6C3E312626546928652E63686172436F64654174286C2D32292926266C2D2D3B636F6E737420683D612D312C753D6C2D323B6F3D692E636F6E73756D654C6F7765725468616E28';
wwv_flow_imp.g_varchar2_table(14327) := '682C6F2C6E292C303D3D3D692E636F756E742626286F3D68292C692E696E7365727428752C632C64297D72657475726E20692E636F6E73756D654C6F7765725468616E28313037333734313832342C6F2C6E292C6E7D7D636C61737320704E7B636F6E73';
wwv_flow_imp.g_varchar2_table(14328) := '74727563746F7228652C742C6E2C69297B746869732E656E64496E6465783D652C746869732E747970653D742C746869732E6D657461646174613D6E2C746869732E636F6E7461696E7352544C3D692C746869732E5F6C696E65506172744272616E643D';
wwv_flow_imp.g_varchar2_table(14329) := '766F696420307D69735768697465737061636528297B72657475726E2121283126746869732E6D65746164617461297D697350736575646F416674657228297B72657475726E2121283426746869732E6D65746164617461297D7D636C61737320674E7B';
wwv_flow_imp.g_varchar2_table(14330) := '636F6E7374727563746F7228652C74297B746869732E73746172744F66667365743D652C746869732E656E644F66667365743D747D657175616C732865297B72657475726E20746869732E73746172744F66667365743D3D3D652E73746172744F666673';
wwv_flow_imp.g_varchar2_table(14331) := '65742626746869732E656E644F66667365743D3D3D652E656E644F66667365747D7D636C617373206D4E7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C752C702C672C6D2C662C762C62297B746869732E75';
wwv_flow_imp.g_varchar2_table(14332) := '73654D6F6E6F73706163654F7074696D697A6174696F6E733D652C746869732E63616E55736548616C667769647468526967687477617264734172726F773D742C746869732E6C696E65436F6E74656E743D6E2C746869732E636F6E74696E7565735769';
wwv_flow_imp.g_varchar2_table(14333) := '7468577261707065644C696E653D692C746869732E6973426173696341534349493D6F2C746869732E636F6E7461696E7352544C3D732C746869732E66617578496E64656E744C656E6774683D722C746869732E6C696E65546F6B656E733D612C746869';
wwv_flow_imp.g_varchar2_table(14334) := '732E6C696E654465636F726174696F6E733D6C2E736F727428634E2E636F6D70617265292C746869732E74616253697A653D632C746869732E737461727456697369626C65436F6C756D6E3D642C746869732E737061636557696474683D682C74686973';
wwv_flow_imp.g_varchar2_table(14335) := '2E73746F7052656E646572696E674C696E6541667465723D672C746869732E72656E646572576869746573706163653D22616C6C223D3D3D6D3F343A22626F756E64617279223D3D3D6D3F313A2273656C656374696F6E223D3D3D6D3F323A2274726169';
wwv_flow_imp.g_varchar2_table(14336) := '6C696E67223D3D3D6D3F333A302C746869732E72656E646572436F6E74726F6C436861726163746572733D662C746869732E666F6E744C69676174757265733D762C746869732E73656C656374696F6E734F6E4C696E653D622626622E736F7274282828';
wwv_flow_imp.g_varchar2_table(14337) := '652C74293D3E652E73746172744F66667365743C742E73746172744F66667365743F2D313A3129292C4D6174682E61627328702D68293C4D6174682E61627328752D68293F28746869732E72656E646572537061636557696474683D702C746869732E72';
wwv_flow_imp.g_varchar2_table(14338) := '656E646572537061636543686172436F64653D3131383235293A28746869732E72656E646572537061636557696474683D752C746869732E72656E646572537061636543686172436F64653D313833297D73616D6553656C656374696F6E2865297B6966';
wwv_flow_imp.g_varchar2_table(14339) := '286E756C6C3D3D3D746869732E73656C656374696F6E734F6E4C696E652972657475726E206E756C6C3D3D3D653B6966286E756C6C3D3D3D652972657475726E21313B696628652E6C656E677468213D3D746869732E73656C656374696F6E734F6E4C69';
wwv_flow_imp.g_varchar2_table(14340) := '6E652E6C656E6774682972657475726E21313B666F72286C657420743D303B743C746869732E73656C656374696F6E734F6E4C696E652E6C656E6774683B742B2B2969662821746869732E73656C656374696F6E734F6E4C696E655B745D2E657175616C';
wwv_flow_imp.g_varchar2_table(14341) := '7328655B745D292972657475726E21313B72657475726E21307D657175616C732865297B72657475726E20746869732E7573654D6F6E6F73706163654F7074696D697A6174696F6E733D3D3D652E7573654D6F6E6F73706163654F7074696D697A617469';
wwv_flow_imp.g_varchar2_table(14342) := '6F6E732626746869732E63616E55736548616C667769647468526967687477617264734172726F773D3D3D652E63616E55736548616C667769647468526967687477617264734172726F772626746869732E6C696E65436F6E74656E743D3D3D652E6C69';
wwv_flow_imp.g_varchar2_table(14343) := '6E65436F6E74656E742626746869732E636F6E74696E75657357697468577261707065644C696E653D3D3D652E636F6E74696E75657357697468577261707065644C696E652626746869732E6973426173696341534349493D3D3D652E69734261736963';
wwv_flow_imp.g_varchar2_table(14344) := '41534349492626746869732E636F6E7461696E7352544C3D3D3D652E636F6E7461696E7352544C2626746869732E66617578496E64656E744C656E6774683D3D3D652E66617578496E64656E744C656E6774682626746869732E74616253697A653D3D3D';
wwv_flow_imp.g_varchar2_table(14345) := '652E74616253697A652626746869732E737461727456697369626C65436F6C756D6E3D3D3D652E737461727456697369626C65436F6C756D6E2626746869732E737061636557696474683D3D3D652E737061636557696474682626746869732E72656E64';
wwv_flow_imp.g_varchar2_table(14346) := '6572537061636557696474683D3D3D652E72656E646572537061636557696474682626746869732E72656E646572537061636543686172436F64653D3D3D652E72656E646572537061636543686172436F64652626746869732E73746F7052656E646572';
wwv_flow_imp.g_varchar2_table(14347) := '696E674C696E6541667465723D3D3D652E73746F7052656E646572696E674C696E6541667465722626746869732E72656E646572576869746573706163653D3D3D652E72656E646572576869746573706163652626746869732E72656E646572436F6E74';
wwv_flow_imp.g_varchar2_table(14348) := '726F6C436861726163746572733D3D3D652E72656E646572436F6E74726F6C436861726163746572732626746869732E666F6E744C69676174757265733D3D3D652E666F6E744C69676174757265732626634E2E657175616C7341727228746869732E6C';
wwv_flow_imp.g_varchar2_table(14349) := '696E654465636F726174696F6E732C652E6C696E654465636F726174696F6E73292626746869732E6C696E65546F6B656E732E657175616C7328652E6C696E65546F6B656E73292626746869732E73616D6553656C656374696F6E28652E73656C656374';
wwv_flow_imp.g_varchar2_table(14350) := '696F6E734F6E4C696E65297D7D636C61737320664E7B636F6E7374727563746F7228652C74297B746869732E70617274496E6465783D652C746869732E63686172496E6465783D747D7D636C61737320764E7B7374617469632067657450617274496E64';
wwv_flow_imp.g_varchar2_table(14351) := '65782865297B72657475726E28343239343930313736302665293E3E3E31367D7374617469632067657443686172496E6465782865297B72657475726E2836353533352665293E3E3E307D636F6E7374727563746F7228652C74297B746869732E6C656E';
wwv_flow_imp.g_varchar2_table(14352) := '6774683D652C746869732E5F646174613D6E65772055696E743332417272617928746869732E6C656E677468292C746869732E5F686F72697A6F6E74616C4F66667365743D6E65772055696E743332417272617928746869732E6C656E677468297D7365';
wwv_flow_imp.g_varchar2_table(14353) := '74436F6C756D6E496E666F28652C742C6E2C69297B636F6E7374206F3D28743C3C31367C6E293E3E3E303B746869732E5F646174615B652D315D3D6F2C746869732E5F686F72697A6F6E74616C4F66667365745B652D315D3D697D676574486F72697A6F';
wwv_flow_imp.g_varchar2_table(14354) := '6E74616C4F66667365742865297B72657475726E20303D3D3D746869732E5F686F72697A6F6E74616C4F66667365742E6C656E6774683F303A746869732E5F686F72697A6F6E74616C4F66667365745B652D315D7D636861724F6666736574546F506172';
wwv_flow_imp.g_varchar2_table(14355) := '74446174612865297B72657475726E20303D3D3D746869732E6C656E6774683F303A653C303F746869732E5F646174615B305D3A653E3D746869732E6C656E6774683F746869732E5F646174615B746869732E6C656E6774682D315D3A746869732E5F64';
wwv_flow_imp.g_varchar2_table(14356) := '6174615B655D7D676574446F6D506F736974696F6E2865297B636F6E737420743D746869732E636861724F6666736574546F506172744461746128652D31292C6E3D764E2E67657450617274496E6465782874292C693D764E2E67657443686172496E64';
wwv_flow_imp.g_varchar2_table(14357) := '65782874293B72657475726E206E657720664E286E2C69297D676574436F6C756D6E28652C74297B72657475726E20746869732E7061727444617461546F436861724F666673657428652E70617274496E6465782C742C652E63686172496E646578292B';
wwv_flow_imp.g_varchar2_table(14358) := '317D7061727444617461546F436861724F666673657428652C742C6E297B696628303D3D3D746869732E6C656E6774682972657475726E20303B636F6E737420693D28653C3C31367C6E293E3E3E303B6C6574206F3D302C733D746869732E6C656E6774';
wwv_flow_imp.g_varchar2_table(14359) := '682D313B666F72283B6F2B313C733B297B636F6E737420653D6F2B733E3E3E312C743D746869732E5F646174615B655D3B696628743D3D3D692972657475726E20653B743E693F733D653A6F3D657D6966286F3D3D3D732972657475726E206F3B636F6E';
wwv_flow_imp.g_varchar2_table(14360) := '737420723D746869732E5F646174615B6F5D2C613D746869732E5F646174615B735D3B696628723D3D3D692972657475726E206F3B696628613D3D3D692972657475726E20733B636F6E7374206C3D764E2E67657450617274496E6465782872292C633D';
wwv_flow_imp.g_varchar2_table(14361) := '764E2E67657443686172496E6465782872293B6C657420643B72657475726E20643D6C213D3D764E2E67657450617274496E6465782861293F743A764E2E67657443686172496E6465782861292C6E2D633C3D642D6E3F6F3A737D7D636C61737320624E';
wwv_flow_imp.g_varchar2_table(14362) := '7B636F6E7374727563746F7228652C742C6E297B746869732E5F72656E6465724C696E654F75747075744272616E643D766F696420302C746869732E6368617261637465724D617070696E673D652C746869732E636F6E7461696E7352544C3D742C7468';
wwv_flow_imp.g_varchar2_table(14363) := '69732E636F6E7461696E73466F726569676E456C656D656E74733D6E7D7D66756E6374696F6E205F4E28652C74297B696628303D3D3D652E6C696E65436F6E74656E742E6C656E677468297B696628652E6C696E654465636F726174696F6E732E6C656E';
wwv_flow_imp.g_varchar2_table(14364) := '6774683E30297B742E617070656E64537472696E6728223C7370616E3E22293B6C6574206E3D302C693D302C6F3D303B666F7228636F6E73742073206F6620652E6C696E654465636F726174696F6E732931213D3D732E74797065262632213D3D732E74';
wwv_flow_imp.g_varchar2_table(14365) := '7970657C7C28742E617070656E64537472696E6728273C7370616E20636C6173733D2227292C742E617070656E64537472696E6728732E636C6173734E616D65292C742E617070656E64537472696E672827223E3C2F7370616E3E27292C313D3D3D732E';
wwv_flow_imp.g_varchar2_table(14366) := '747970652626286F7C3D312C6E2B2B292C323D3D3D732E747970652626286F7C3D322C692B2B29293B742E617070656E64537472696E6728223C2F7370616E3E22293B636F6E737420733D6E657720764E28312C6E2B69293B72657475726E20732E7365';
wwv_flow_imp.g_varchar2_table(14367) := '74436F6C756D6E496E666F28312C6E2C302C30292C6E657720624E28732C21312C6F297D72657475726E20742E617070656E64537472696E6728223C7370616E3E3C7370616E3E3C2F7370616E3E3C2F7370616E3E22292C6E657720624E286E65772076';
wwv_flow_imp.g_varchar2_table(14368) := '4E28302C30292C21312C30297D72657475726E2066756E6374696F6E28652C74297B636F6E7374206E3D652E666F6E7449734D6F6E6F73706163652C693D652E63616E55736548616C667769647468526967687477617264734172726F772C6F3D652E63';
wwv_flow_imp.g_varchar2_table(14369) := '6F6E7461696E73466F726569676E456C656D656E74732C733D652E6C696E65436F6E74656E742C723D652E6C656E2C613D652E69734F766572666C6F77696E672C6C3D652E6F766572666C6F77696E6743686172436F756E742C633D652E70617274732C';
wwv_flow_imp.g_varchar2_table(14370) := '643D652E66617578496E64656E744C656E6774682C683D652E74616253697A652C753D652E737461727456697369626C65436F6C756D6E2C703D652E636F6E7461696E7352544C2C673D652E737061636557696474682C6D3D652E72656E646572537061';
wwv_flow_imp.g_varchar2_table(14371) := '636543686172436F64652C663D652E72656E646572576869746573706163652C763D652E72656E646572436F6E74726F6C436861726163746572732C5F3D6E657720764E28722B312C632E6C656E677468293B6C657420793D21312C773D302C433D752C';
wwv_flow_imp.g_varchar2_table(14372) := '533D302C783D302C6B3D303B703F742E617070656E64537472696E6728273C7370616E206469723D226C7472223E27293A742E617070656E64537472696E6728223C7370616E3E22293B666F72286C657420653D302C613D632E6C656E6774683B653C61';
wwv_flow_imp.g_varchar2_table(14373) := '3B652B2B297B636F6E737420613D635B655D2C6C3D612E656E64496E6465782C753D612E747970652C703D612E636F6E7461696E7352544C2C623D30213D3D662626612E69735768697465737061636528292C453D622626216E262628226D746B77223D';
wwv_flow_imp.g_varchar2_table(14374) := '3D3D757C7C216F292C4C3D773D3D3D6C2626612E697350736575646F416674657228293B696628533D302C742E617070656E64537472696E6728223C7370616E2022292C702626742E617070656E64537472696E6728277374796C653D22756E69636F64';
wwv_flow_imp.g_varchar2_table(14375) := '652D626964693A69736F6C617465222027292C742E617070656E64537472696E672827636C6173733D2227292C742E617070656E64537472696E6728453F226D746B7A223A75292C742E617070656E64415343494943686172436F6465283334292C6229';
wwv_flow_imp.g_varchar2_table(14376) := '7B6C6574206E3D303B7B6C657420653D772C743D433B666F72283B653C6C3B652B2B297B636F6E737420693D307C28393D3D3D732E63686172436F646541742865293F682D7425683A31293B6E2B3D692C653E3D64262628742B3D69297D7D666F722845';
wwv_flow_imp.g_varchar2_table(14377) := '262628742E617070656E64537472696E672827207374796C653D2277696474683A27292C742E617070656E64537472696E6728537472696E6728672A6E29292C742E617070656E64537472696E6728277078222729292C742E617070656E644153434949';
wwv_flow_imp.g_varchar2_table(14378) := '43686172436F6465283632293B773C6C3B772B2B297B6C6574206E2C6F3B6966285F2E736574436F6C756D6E496E666F28772B312C652D6B2C532C78292C6B3D302C393D3D3D732E63686172436F64654174287729297B6E3D682D4325687C302C6F3D6E';
wwv_flow_imp.g_varchar2_table(14379) := '2C21697C7C6F3E313F742E617070656E6443686172436F64652838353934293A742E617070656E6443686172436F6465283635353135293B666F72286C657420653D323B653C3D6F3B652B2B29742E617070656E6443686172436F646528313630297D65';
wwv_flow_imp.g_varchar2_table(14380) := '6C7365206E3D322C6F3D312C742E617070656E6443686172436F6465286D292C742E617070656E6443686172436F64652838323034293B532B3D6E2C782B3D6F2C773E3D64262628432B3D6F297D7D656C736520666F7228742E617070656E6441534349';
wwv_flow_imp.g_varchar2_table(14381) := '4943686172436F6465283632293B773C6C3B772B2B297B5F2E736574436F6C756D6E496E666F28772B312C652D6B2C532C78292C6B3D303B636F6E7374206E3D732E63686172436F646541742877293B6C657420693D312C6F3D313B737769746368286E';
wwv_flow_imp.g_varchar2_table(14382) := '297B6361736520393A693D682D4325682C6F3D693B666F72286C657420653D313B653C3D693B652B2B29742E617070656E6443686172436F646528313630293B627265616B3B636173652033323A742E617070656E6443686172436F646528313630293B';
wwv_flow_imp.g_varchar2_table(14383) := '627265616B3B636173652036303A742E617070656E64537472696E672822266C743B22293B627265616B3B636173652036323A742E617070656E64537472696E6728222667743B22293B627265616B3B636173652033383A742E617070656E6453747269';
wwv_flow_imp.g_varchar2_table(14384) := '6E67282226616D703B22293B627265616B3B6361736520303A763F742E617070656E6443686172436F64652839323136293A742E617070656E64537472696E672822262330303B22293B627265616B3B636173652036353237393A636173652038323332';
wwv_flow_imp.g_varchar2_table(14385) := '3A6361736520383233333A63617365203133333A742E617070656E6443686172436F6465283635353333293B627265616B3B64656661756C743A6A69286E2926266F2B2B2C7626266E3C33323F742E617070656E6443686172436F646528393231362B6E';
wwv_flow_imp.g_varchar2_table(14386) := '293A7626263132373D3D3D6E3F742E617070656E6443686172436F64652839323439293A762626534E286E293F28742E617070656E64537472696E6728225B552B22292C742E617070656E64537472696E67286E2E746F537472696E67283136292E746F';
wwv_flow_imp.g_varchar2_table(14387) := '55707065724361736528292E706164537461727428342C22302229292C742E617070656E64537472696E6728225D22292C693D382C6F3D69293A742E617070656E6443686172436F6465286E297D532B3D692C782B3D6F2C773E3D64262628432B3D6F29';
wwv_flow_imp.g_varchar2_table(14388) := '7D4C3F6B2B2B3A6B3D302C773E3D72262621792626612E697350736575646F41667465722829262628793D21302C5F2E736574436F6C756D6E496E666F28772B312C652C532C7829292C742E617070656E64537472696E6728223C2F7370616E3E22297D';
wwv_flow_imp.g_varchar2_table(14389) := '72657475726E20797C7C5F2E736574436F6C756D6E496E666F28722B312C632E6C656E6774682D312C532C78292C61262628742E617070656E64537472696E6728273C7370616E20636C6173733D226D746B6F766572666C6F77223E27292C742E617070';
wwv_flow_imp.g_varchar2_table(14390) := '656E64537472696E67286228302C2253686F77206D6F726520287B307D29222C66756E6374696F6E2865297B72657475726E20653C313032343F6228302C227B307D206368617273222C65293A653C313034383537363F60247B28652F31303234292E74';
wwv_flow_imp.g_varchar2_table(14391) := '6F46697865642831297D204B42603A60247B28652F313032342F31303234292E746F46697865642831297D204D42607D286C2929292C742E617070656E64537472696E6728223C2F7370616E3E2229292C742E617070656E64537472696E6728223C2F73';
wwv_flow_imp.g_varchar2_table(14392) := '70616E3E22292C6E657720624E285F2C702C6F297D2866756E6374696F6E2865297B636F6E737420743D652E6C696E65436F6E74656E743B6C6574206E2C692C6F3B2D31213D3D652E73746F7052656E646572696E674C696E6541667465722626652E73';
wwv_flow_imp.g_varchar2_table(14393) := '746F7052656E646572696E674C696E6541667465723C742E6C656E6774683F286E3D21302C693D742E6C656E6774682D652E73746F7052656E646572696E674C696E6541667465722C6F3D652E73746F7052656E646572696E674C696E65416674657229';
wwv_flow_imp.g_varchar2_table(14394) := '3A286E3D21312C693D302C6F3D742E6C656E677468293B6C657420733D66756E6374696F6E28652C742C6E2C692C6F297B636F6E737420733D5B5D3B6C657420723D303B693E30262628735B722B2B5D3D6E657720704E28692C22222C302C213129293B';
wwv_flow_imp.g_varchar2_table(14395) := '6C657420613D693B666F72286C6574206C3D302C633D6E2E676574436F756E7428293B6C3C633B6C2B2B297B636F6E737420633D6E2E676574456E644F6666736574286C293B696628633C3D6929636F6E74696E75653B636F6E737420643D6E2E676574';
wwv_flow_imp.g_varchar2_table(14396) := '436C6173734E616D65286C293B696628633E3D6F297B636F6E7374206E3D2121742626426928652E737562737472696E6728612C6F29293B735B722B2B5D3D6E657720704E286F2C642C302C6E293B627265616B7D636F6E737420683D21217426264269';
wwv_flow_imp.g_varchar2_table(14397) := '28652E737562737472696E6728612C6329293B735B722B2B5D3D6E657720704E28632C642C302C68292C613D637D72657475726E20737D28742C652E636F6E7461696E7352544C2C652E6C696E65546F6B656E732C652E66617578496E64656E744C656E';
wwv_flow_imp.g_varchar2_table(14398) := '6774682C6F293B652E72656E646572436F6E74726F6C43686172616374657273262621652E697342617369634153434949262628733D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D3B6C657420693D6E657720704E28302C22222C302C21';
wwv_flow_imp.g_varchar2_table(14399) := '31292C6F3D303B666F7228636F6E73742073206F662074297B636F6E737420743D732E656E64496E6465783B666F72283B6F3C743B6F2B2B29534E28652E63686172436F64654174286F29292626286F3E692E656E64496E646578262628693D6E657720';
wwv_flow_imp.g_varchar2_table(14400) := '704E286F2C732E747970652C732E6D657461646174612C732E636F6E7461696E7352544C292C6E2E70757368286929292C693D6E657720704E286F2B312C226D746B636F6E74726F6C222C732E6D657461646174612C2131292C6E2E7075736828692929';
wwv_flow_imp.g_varchar2_table(14401) := '3B6F3E692E656E64496E646578262628693D6E657720704E28742C732E747970652C732E6D657461646174612C732E636F6E7461696E7352544C292C6E2E70757368286929297D72657475726E206E7D28742C7329292C28343D3D3D652E72656E646572';
wwv_flow_imp.g_varchar2_table(14402) := '576869746573706163657C7C313D3D3D652E72656E646572576869746573706163657C7C323D3D3D652E72656E646572576869746573706163652626652E73656C656374696F6E734F6E4C696E657C7C333D3D3D652E72656E6465725768697465737061';
wwv_flow_imp.g_varchar2_table(14403) := '6365262621652E636F6E74696E75657357697468577261707065644C696E6529262628733D66756E6374696F6E28652C742C6E2C69297B636F6E7374206F3D652E636F6E74696E75657357697468577261707065644C696E652C733D652E66617578496E';
wwv_flow_imp.g_varchar2_table(14404) := '64656E744C656E6774682C723D652E74616253697A652C613D652E737461727456697369626C65436F6C756D6E2C6C3D652E7573654D6F6E6F73706163654F7074696D697A6174696F6E732C633D652E73656C656374696F6E734F6E4C696E652C643D31';
wwv_flow_imp.g_varchar2_table(14405) := '3D3D3D652E72656E646572576869746573706163652C683D333D3D3D652E72656E646572576869746573706163652C753D652E72656E64657253706163655769647468213D3D652E737061636557696474682C703D5B5D3B6C657420673D302C6D3D302C';
wwv_flow_imp.g_varchar2_table(14406) := '663D695B6D5D2E747970652C763D695B6D5D2E636F6E7461696E7352544C2C623D695B6D5D2E656E64496E6465783B636F6E7374205F3D692E6C656E6774683B6C657420792C773D21312C433D6D692874293B2D313D3D3D433F28773D21302C433D6E2C';
wwv_flow_imp.g_varchar2_table(14407) := '793D6E293A793D76692874293B6C657420533D21312C783D302C6B3D632626635B785D2C453D6125723B666F72286C657420653D733B653C6E3B652B2B297B636F6E7374206F3D742E63686172436F646541742865293B6C657420613B6966286B262665';
wwv_flow_imp.g_varchar2_table(14408) := '3E3D6B2E656E644F6666736574262628782B2B2C6B3D632626635B785D292C653C437C7C653E7929613D21303B656C736520696628393D3D3D6F29613D21303B656C73652069662833323D3D3D6F2969662864296966285329613D21303B656C73657B63';
wwv_flow_imp.g_varchar2_table(14409) := '6F6E737420693D652B313C6E3F742E63686172436F6465417428652B31293A303B613D33323D3D3D697C7C393D3D3D697D656C736520613D21303B656C736520613D21313B69662861262663262628613D21216B26266B2E73746172744F66667365743C';
wwv_flow_imp.g_varchar2_table(14410) := '3D6526266B2E656E644F66667365743E65292C61262668262628613D777C7C653E79292C612626762626653E3D432626653C3D79262628613D2131292C53297B69662821617C7C216C2626453E3D72297B6966287529666F72286C657420743D28673E30';
wwv_flow_imp.g_varchar2_table(14411) := '3F705B672D315D2E656E64496E6465783A73292B313B743C3D653B742B2B29705B672B2B5D3D6E657720704E28742C226D746B77222C312C2131293B656C736520705B672B2B5D3D6E657720704E28652C226D746B77222C312C2131293B45253D727D7D';
wwv_flow_imp.g_varchar2_table(14412) := '656C736528653D3D3D627C7C612626653E7329262628705B672B2B5D3D6E657720704E28652C662C302C76292C45253D72293B666F7228393D3D3D6F3F453D723A6A69286F293F452B3D323A452B2B2C533D613B653D3D3D622626286D2B2B2C6D3C5F29';
wwv_flow_imp.g_varchar2_table(14413) := '3B29663D695B6D5D2E747970652C763D695B6D5D2E636F6E7461696E7352544C2C623D695B6D5D2E656E64496E6465787D6C6574204C3D21313B69662853296966286F262664297B636F6E737420653D6E3E303F742E63686172436F64654174286E2D31';
wwv_flow_imp.g_varchar2_table(14414) := '293A302C693D6E3E313F742E63686172436F64654174286E2D32293A303B33323D3D3D6526263332213D3D69262639213D3D697C7C284C3D2130297D656C7365204C3D21303B6966284C296966287529666F72286C657420653D28673E303F705B672D31';
wwv_flow_imp.g_varchar2_table(14415) := '5D2E656E64496E6465783A73292B313B653C3D6E3B652B2B29705B672B2B5D3D6E657720704E28652C226D746B77222C312C2131293B656C736520705B672B2B5D3D6E657720704E286E2C226D746B77222C312C2131293B656C736520705B672B2B5D3D';
wwv_flow_imp.g_varchar2_table(14416) := '6E657720704E286E2C662C302C76293B72657475726E20707D28652C742C6F2C7329293B6C657420723D303B696628652E6C696E654465636F726174696F6E732E6C656E6774683E30297B666F72286C657420743D302C6E3D652E6C696E654465636F72';
wwv_flow_imp.g_varchar2_table(14417) := '6174696F6E732E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D652E6C696E654465636F726174696F6E735B745D3B333D3D3D6E2E747970657C7C313D3D3D6E2E747970653F727C3D313A323D3D3D6E2E74797065262628727C3D32297D73';
wwv_flow_imp.g_varchar2_table(14418) := '3D66756E6374696F6E28652C742C6E2C69297B692E736F727428634E2E636F6D70617265293B636F6E7374206F3D754E2E6E6F726D616C697A6528652C69292C733D6F2E6C656E6774683B6C657420723D303B636F6E737420613D5B5D3B6C6574206C3D';
wwv_flow_imp.g_varchar2_table(14419) := '302C633D303B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D2C693D742E656E64496E6465782C643D742E747970652C683D742E6D657461646174612C753D742E636F6E7461696E735254';
wwv_flow_imp.g_varchar2_table(14420) := '4C3B666F72283B723C7326266F5B725D2E73746172744F66667365743C693B297B636F6E737420653D6F5B725D3B696628652E73746172744F66667365743E63262628633D652E73746172744F66667365742C615B6C2B2B5D3D6E657720704E28632C64';
wwv_flow_imp.g_varchar2_table(14421) := '2C682C7529292C2128652E656E644F66667365742B313C3D6929297B633D692C615B6C2B2B5D3D6E657720704E28632C642B2220222B652E636C6173734E616D652C687C652E6D657461646174612C75293B627265616B7D633D652E656E644F66667365';
wwv_flow_imp.g_varchar2_table(14422) := '742B312C615B6C2B2B5D3D6E657720704E28632C642B2220222B652E636C6173734E616D652C687C652E6D657461646174612C75292C722B2B7D693E63262628633D692C615B6C2B2B5D3D6E657720704E28632C642C682C7529297D636F6E737420643D';
wwv_flow_imp.g_varchar2_table(14423) := '6E5B6E2E6C656E6774682D315D2E656E64496E6465783B696628723C7326266F5B725D2E73746172744F66667365743D3D3D6429666F72283B723C7326266F5B725D2E73746172744F66667365743D3D3D643B297B636F6E737420653D6F5B725D3B615B';
wwv_flow_imp.g_varchar2_table(14424) := '6C2B2B5D3D6E657720704E28632C652E636C6173734E616D652C652E6D657461646174612C2131292C722B2B7D72657475726E20617D28742C302C732C652E6C696E654465636F726174696F6E73297D72657475726E20652E636F6E7461696E7352544C';
wwv_flow_imp.g_varchar2_table(14425) := '7C7C28733D66756E6374696F6E28652C742C6E297B6C657420693D303B636F6E7374206F3D5B5D3B6C657420733D303B6966286E29666F72286C6574206E3D302C723D742E6C656E6774683B6E3C723B6E2B2B297B636F6E737420723D745B6E5D2C613D';
wwv_flow_imp.g_varchar2_table(14426) := '722E656E64496E6465783B696628692B35303C61297B636F6E737420743D722E747970652C6E3D722E6D657461646174612C6C3D722E636F6E7461696E7352544C3B6C657420633D2D312C643D693B666F72286C657420723D693B723C613B722B2B2933';
wwv_flow_imp.g_varchar2_table(14427) := '323D3D3D652E63686172436F64654174287229262628633D72292C2D31213D3D632626722D643E3D35302626286F5B732B2B5D3D6E657720704E28632B312C742C6E2C6C292C643D632B312C633D2D31293B64213D3D612626286F5B732B2B5D3D6E6577';
wwv_flow_imp.g_varchar2_table(14428) := '20704E28612C742C6E2C6C29297D656C7365206F5B732B2B5D3D723B693D617D656C736520666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D2C723D6E2E656E64496E6465782C613D722D69';
wwv_flow_imp.g_varchar2_table(14429) := '3B696628613E3530297B636F6E737420653D6E2E747970652C743D6E2E6D657461646174612C6C3D6E2E636F6E7461696E7352544C2C633D4D6174682E6365696C28612F3530293B666F72286C6574206E3D313B6E3C633B6E2B2B297B636F6E73742072';
wwv_flow_imp.g_varchar2_table(14430) := '3D692B35302A6E3B6F5B732B2B5D3D6E657720704E28722C652C742C6C297D6F5B732B2B5D3D6E657720704E28722C652C742C6C297D656C7365206F5B732B2B5D3D6E3B693D727D72657475726E206F7D28742C732C21652E6973426173696341534349';
wwv_flow_imp.g_varchar2_table(14431) := '497C7C652E666F6E744C696761747572657329292C6E657720434E28652E7573654D6F6E6F73706163654F7074696D697A6174696F6E732C652E63616E55736548616C667769647468526967687477617264734172726F772C742C6F2C6E2C692C732C72';
wwv_flow_imp.g_varchar2_table(14432) := '2C652E66617578496E64656E744C656E6774682C652E74616253697A652C652E737461727456697369626C65436F6C756D6E2C652E636F6E7461696E7352544C2C652E737061636557696474682C652E72656E646572537061636543686172436F64652C';
wwv_flow_imp.g_varchar2_table(14433) := '652E72656E646572576869746573706163652C652E72656E646572436F6E74726F6C43686172616374657273297D2865292C74297D636C61737320794E7B636F6E7374727563746F7228652C742C6E2C69297B746869732E6368617261637465724D6170';
wwv_flow_imp.g_varchar2_table(14434) := '70696E673D652C746869732E68746D6C3D742C746869732E636F6E7461696E7352544C3D6E2C746869732E636F6E7461696E73466F726569676E456C656D656E74733D697D7D66756E6374696F6E20774E2865297B636F6E737420743D6E6577206E7028';
wwv_flow_imp.g_varchar2_table(14435) := '316534292C6E3D5F4E28652C74293B72657475726E206E657720794E286E2E6368617261637465724D617070696E672C742E6275696C6428292C6E2E636F6E7461696E7352544C2C6E2E636F6E7461696E73466F726569676E456C656D656E7473297D63';
wwv_flow_imp.g_varchar2_table(14436) := '6C61737320434E7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C752C702C672C6D297B746869732E666F6E7449734D6F6E6F73706163653D652C746869732E63616E55736548616C66776964746852696768';
wwv_flow_imp.g_varchar2_table(14437) := '7477617264734172726F773D742C746869732E6C696E65436F6E74656E743D6E2C746869732E6C656E3D692C746869732E69734F766572666C6F77696E673D6F2C746869732E6F766572666C6F77696E6743686172436F756E743D732C746869732E7061';
wwv_flow_imp.g_varchar2_table(14438) := '7274733D722C746869732E636F6E7461696E73466F726569676E456C656D656E74733D612C746869732E66617578496E64656E744C656E6774683D6C2C746869732E74616253697A653D632C746869732E737461727456697369626C65436F6C756D6E3D';
wwv_flow_imp.g_varchar2_table(14439) := '642C746869732E636F6E7461696E7352544C3D682C746869732E737061636557696474683D752C746869732E72656E646572537061636543686172436F64653D702C746869732E72656E646572576869746573706163653D672C746869732E72656E6465';
wwv_flow_imp.g_varchar2_table(14440) := '72436F6E74726F6C436861726163746572733D6D7D7D66756E6374696F6E20534E2865297B72657475726E20653C33323F39213D3D653A3132373D3D3D657C7C653E3D383233342626653C3D383233387C7C653E3D383239342626653C3D383239377C7C';
wwv_flow_imp.g_varchar2_table(14441) := '653E3D383230362626653C3D383230377C7C313536343D3D3D657D636F6E737420784E3D2121557C7C2128247C7C637C7C75293B6C6574206B4E3D21303B636C61737320454E7B636F6E7374727563746F7228652C74297B746869732E7468656D655479';
wwv_flow_imp.g_varchar2_table(14442) := '70653D743B636F6E7374206E3D652E6F7074696F6E732C693D6E2E676574283530292C6F3D6E2E676574283338293B746869732E72656E646572576869746573706163653D226F6666223D3D3D6F3F6E2E676574283939293A226E6F6E65222C74686973';
wwv_flow_imp.g_varchar2_table(14443) := '2E72656E646572436F6E74726F6C436861726163746572733D6E2E676574283934292C746869732E737061636557696474683D692E737061636557696474682C746869732E6D6964646F7457696474683D692E6D6964646F7457696474682C746869732E';
wwv_flow_imp.g_varchar2_table(14444) := '77736D6964646F7457696474683D692E77736D6964646F7457696474682C746869732E7573654D6F6E6F73706163654F7074696D697A6174696F6E733D692E69734D6F6E6F73706163652626216E2E676574283333292C746869732E63616E5573654861';
wwv_flow_imp.g_varchar2_table(14445) := '6C667769647468526967687477617264734172726F773D692E63616E55736548616C667769647468526967687477617264734172726F772C746869732E6C696E654865696768743D6E2E676574283637292C746869732E73746F7052656E646572696E67';
wwv_flow_imp.g_varchar2_table(14446) := '4C696E6541667465723D6E2E67657428313137292C746869732E666F6E744C69676174757265733D6E2E676574283531297D657175616C732865297B72657475726E20746869732E7468656D65547970653D3D3D652E7468656D65547970652626746869';
wwv_flow_imp.g_varchar2_table(14447) := '732E72656E646572576869746573706163653D3D3D652E72656E646572576869746573706163652626746869732E72656E646572436F6E74726F6C436861726163746572733D3D3D652E72656E646572436F6E74726F6C43686172616374657273262674';
wwv_flow_imp.g_varchar2_table(14448) := '6869732E737061636557696474683D3D3D652E737061636557696474682626746869732E6D6964646F7457696474683D3D3D652E6D6964646F7457696474682626746869732E77736D6964646F7457696474683D3D3D652E77736D6964646F7457696474';
wwv_flow_imp.g_varchar2_table(14449) := '682626746869732E7573654D6F6E6F73706163654F7074696D697A6174696F6E733D3D3D652E7573654D6F6E6F73706163654F7074696D697A6174696F6E732626746869732E63616E55736548616C667769647468526967687477617264734172726F77';
wwv_flow_imp.g_varchar2_table(14450) := '3D3D3D652E63616E55736548616C667769647468526967687477617264734172726F772626746869732E6C696E654865696768743D3D3D652E6C696E654865696768742626746869732E73746F7052656E646572696E674C696E6541667465723D3D3D65';
wwv_flow_imp.g_varchar2_table(14451) := '2E73746F7052656E646572696E674C696E6541667465722626746869732E666F6E744C69676174757265733D3D3D652E666F6E744C69676174757265737D7D636C617373204C4E7B636F6E7374727563746F722865297B746869732E5F6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(14452) := '3D652C746869732E5F69734D61796265496E76616C69643D21302C746869732E5F72656E6465726564566965774C696E653D6E756C6C7D676574446F6D4E6F646528297B72657475726E20746869732E5F72656E6465726564566965774C696E65262674';
wwv_flow_imp.g_varchar2_table(14453) := '6869732E5F72656E6465726564566965774C696E652E646F6D4E6F64653F746869732E5F72656E6465726564566965774C696E652E646F6D4E6F64652E646F6D4E6F64653A6E756C6C7D736574446F6D4E6F64652865297B69662821746869732E5F7265';
wwv_flow_imp.g_varchar2_table(14454) := '6E6465726564566965774C696E65297468726F77206E6577204572726F722822492068617665206E6F2072656E64657265642076696577206C696E6520746F207365742074686520646F6D206E6F646520746F2E2E2E22293B746869732E5F72656E6465';
wwv_flow_imp.g_varchar2_table(14455) := '726564566965774C696E652E646F6D4E6F64653D73452865297D6F6E436F6E74656E744368616E67656428297B746869732E5F69734D61796265496E76616C69643D21307D6F6E546F6B656E734368616E67656428297B746869732E5F69734D61796265';
wwv_flow_imp.g_varchar2_table(14456) := '496E76616C69643D21307D6F6E4465636F726174696F6E734368616E67656428297B746869732E5F69734D61796265496E76616C69643D21307D6F6E4F7074696F6E734368616E6765642865297B746869732E5F69734D61796265496E76616C69643D21';
wwv_flow_imp.g_varchar2_table(14457) := '302C746869732E5F6F7074696F6E733D657D6F6E53656C656374696F6E4368616E67656428297B72657475726E212821416228746869732E5F6F7074696F6E732E7468656D65547970652926262273656C656374696F6E22213D3D746869732E5F6F7074';
wwv_flow_imp.g_varchar2_table(14458) := '696F6E732E72656E646572576869746573706163657C7C28746869732E5F69734D61796265496E76616C69643D21302C3029297D72656E6465724C696E6528652C742C6E2C692C6F297B69662821313D3D3D746869732E5F69734D61796265496E76616C';
wwv_flow_imp.g_varchar2_table(14459) := '69642972657475726E21313B746869732E5F69734D61796265496E76616C69643D21313B636F6E737420733D692E676574566965774C696E6552656E646572696E67446174612865292C723D746869732E5F6F7074696F6E732C613D634E2E66696C7465';
wwv_flow_imp.g_varchar2_table(14460) := '7228732E696E6C696E654465636F726174696F6E732C652C732E6D696E436F6C756D6E2C732E6D6178436F6C756D6E293B6C6574206C3D6E756C6C3B696628416228722E7468656D6554797065297C7C2273656C656374696F6E223D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(14461) := '6F7074696F6E732E72656E64657257686974657370616365297B636F6E737420743D692E73656C656374696F6E733B666F7228636F6E7374206E206F662074297B6966286E2E656E644C696E654E756D6265723C657C7C6E2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(14462) := '6D6265723E6529636F6E74696E75653B636F6E737420743D6E2E73746172744C696E654E756D6265723D3D3D653F6E2E7374617274436F6C756D6E3A732E6D696E436F6C756D6E2C693D6E2E656E644C696E654E756D6265723D3D3D653F6E2E656E6443';
wwv_flow_imp.g_varchar2_table(14463) := '6F6C756D6E3A732E6D6178436F6C756D6E3B743C69262628416228722E7468656D6554797065292626612E70757368286E657720634E28742C692C22696E6C696E652D73656C65637465642D74657874222C3029292C2273656C656374696F6E223D3D3D';
wwv_flow_imp.g_varchar2_table(14464) := '746869732E5F6F7074696F6E732E72656E646572576869746573706163652626286C7C7C286C3D5B5D292C6C2E70757368286E657720674E28742D312C692D31292929297D7D636F6E737420633D6E6577206D4E28722E7573654D6F6E6F73706163654F';
wwv_flow_imp.g_varchar2_table(14465) := '7074696D697A6174696F6E732C722E63616E55736548616C667769647468526967687477617264734172726F772C732E636F6E74656E742C732E636F6E74696E75657357697468577261707065644C696E652C732E6973426173696341534349492C732E';
wwv_flow_imp.g_varchar2_table(14466) := '636F6E7461696E7352544C2C732E6D696E436F6C756D6E2D312C732E746F6B656E732C612C732E74616253697A652C732E737461727456697369626C65436F6C756D6E2C722E737061636557696474682C722E6D6964646F7457696474682C722E77736D';
wwv_flow_imp.g_varchar2_table(14467) := '6964646F7457696474682C722E73746F7052656E646572696E674C696E6541667465722C722E72656E646572576869746573706163652C722E72656E646572436F6E74726F6C436861726163746572732C722E666F6E744C6967617475726573213D3D41';
wwv_flow_imp.g_varchar2_table(14468) := '4C2E4F46462C6C293B696628746869732E5F72656E6465726564566965774C696E652626746869732E5F72656E6465726564566965774C696E652E696E7075742E657175616C732863292972657475726E21313B6F2E617070656E64537472696E672827';
wwv_flow_imp.g_varchar2_table(14469) := '3C646976207374796C653D22746F703A27292C6F2E617070656E64537472696E6728537472696E67287429292C6F2E617070656E64537472696E67282270783B6865696768743A22292C6F2E617070656E64537472696E6728537472696E67286E29292C';
wwv_flow_imp.g_varchar2_table(14470) := '6F2E617070656E64537472696E67282770783B2220636C6173733D2227292C6F2E617070656E64537472696E67284C4E2E434C4153535F4E414D45292C6F2E617070656E64537472696E672827223E27293B636F6E737420643D5F4E28632C6F293B6F2E';
wwv_flow_imp.g_varchar2_table(14471) := '617070656E64537472696E6728223C2F6469763E22293B6C657420683D6E756C6C3B72657475726E206B4E2626784E2626732E6973426173696341534349492626722E7573654D6F6E6F73706163654F7074696D697A6174696F6E732626303D3D3D642E';
wwv_flow_imp.g_varchar2_table(14472) := '636F6E7461696E73466F726569676E456C656D656E7473262628683D6E657720444E28746869732E5F72656E6465726564566965774C696E653F746869732E5F72656E6465726564566965774C696E652E646F6D4E6F64653A6E756C6C2C632C642E6368';
wwv_flow_imp.g_varchar2_table(14473) := '617261637465724D617070696E6729292C687C7C28683D4D4E28746869732E5F72656E6465726564566965774C696E653F746869732E5F72656E6465726564566965774C696E652E646F6D4E6F64653A6E756C6C2C632C642E6368617261637465724D61';
wwv_flow_imp.g_varchar2_table(14474) := '7070696E672C642E636F6E7461696E7352544C2C642E636F6E7461696E73466F726569676E456C656D656E747329292C746869732E5F72656E6465726564566965774C696E653D682C21307D6C61796F75744C696E6528652C742C6E297B746869732E5F';
wwv_flow_imp.g_varchar2_table(14475) := '72656E6465726564566965774C696E652626746869732E5F72656E6465726564566965774C696E652E646F6D4E6F6465262628746869732E5F72656E6465726564566965774C696E652E646F6D4E6F64652E736574546F702874292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(14476) := '6E6465726564566965774C696E652E646F6D4E6F64652E736574486569676874286E29297D67657457696474682865297B72657475726E20746869732E5F72656E6465726564566965774C696E653F746869732E5F72656E6465726564566965774C696E';
wwv_flow_imp.g_varchar2_table(14477) := '652E67657457696474682865293A307D676574576964746849734661737428297B72657475726E21746869732E5F72656E6465726564566965774C696E657C7C746869732E5F72656E6465726564566965774C696E652E67657457696474684973466173';
wwv_flow_imp.g_varchar2_table(14478) := '7428297D6E656564734D6F6E6F7370616365466F6E74436865636B28297B72657475726E2121746869732E5F72656E6465726564566965774C696E652626746869732E5F72656E6465726564566965774C696E6520696E7374616E63656F6620444E7D6D';
wwv_flow_imp.g_varchar2_table(14479) := '6F6E6F7370616365417373756D7074696F6E7341726556616C696428297B72657475726E20746869732E5F72656E6465726564566965774C696E652626746869732E5F72656E6465726564566965774C696E6520696E7374616E63656F6620444E3F7468';
wwv_flow_imp.g_varchar2_table(14480) := '69732E5F72656E6465726564566965774C696E652E6D6F6E6F7370616365417373756D7074696F6E7341726556616C696428293A6B4E7D6F6E4D6F6E6F7370616365417373756D7074696F6E73496E76616C69646174656428297B746869732E5F72656E';
wwv_flow_imp.g_varchar2_table(14481) := '6465726564566965774C696E652626746869732E5F72656E6465726564566965774C696E6520696E7374616E63656F6620444E262628746869732E5F72656E6465726564566965774C696E653D746869732E5F72656E6465726564566965774C696E652E';
wwv_flow_imp.g_varchar2_table(14482) := '746F536C6F7752656E64657265644C696E652829297D67657456697369626C6552616E676573466F7252616E676528652C742C6E2C69297B69662821746869732E5F72656E6465726564566965774C696E652972657475726E206E756C6C3B743D4D6174';
wwv_flow_imp.g_varchar2_table(14483) := '682E6D696E28746869732E5F72656E6465726564566965774C696E652E696E7075742E6C696E65436F6E74656E742E6C656E6774682B312C4D6174682E6D617828312C7429292C6E3D4D6174682E6D696E28746869732E5F72656E646572656456696577';
wwv_flow_imp.g_varchar2_table(14484) := '4C696E652E696E7075742E6C696E65436F6E74656E742E6C656E6774682B312C4D6174682E6D617828312C6E29293B636F6E7374206F3D746869732E5F72656E6465726564566965774C696E652E696E7075742E73746F7052656E646572696E674C696E';
wwv_flow_imp.g_varchar2_table(14485) := '6541667465723B6966282D31213D3D6F2626743E6F2B3126266E3E6F2B312972657475726E206E657720614E2821302C5B6E657720734E28746869732E67657457696474682869292C30295D293B2D31213D3D6F2626743E6F2B31262628743D6F2B3129';
wwv_flow_imp.g_varchar2_table(14486) := '2C2D31213D3D6F26266E3E6F2B312626286E3D6F2B31293B636F6E737420733D746869732E5F72656E6465726564566965774C696E652E67657456697369626C6552616E676573466F7252616E676528652C742C6E2C69293B72657475726E2073262673';
wwv_flow_imp.g_varchar2_table(14487) := '2E6C656E6774683E303F6E657720614E2821312C73293A6E756C6C7D676574436F6C756D6E4F664E6F64654F666673657428652C74297B72657475726E20746869732E5F72656E6465726564566965774C696E653F746869732E5F72656E646572656456';
wwv_flow_imp.g_varchar2_table(14488) := '6965774C696E652E676574436F6C756D6E4F664E6F64654F666673657428652C74293A317D7D4C4E2E434C4153535F4E414D453D22766965772D6C696E65223B636C61737320444E7B636F6E7374727563746F7228652C742C6E297B746869732E5F6361';
wwv_flow_imp.g_varchar2_table(14489) := '6368656457696474683D2D312C746869732E646F6D4E6F64653D652C746869732E696E7075743D743B636F6E737420693D4D6174682E666C6F6F7228742E6C696E65436F6E74656E742E6C656E6774682F333030293B696628693E30297B746869732E5F';
wwv_flow_imp.g_varchar2_table(14490) := '6B6579436F6C756D6E506978656C4F666673657443616368653D6E657720466C6F6174333241727261792869293B666F72286C657420653D303B653C693B652B2B29746869732E5F6B6579436F6C756D6E506978656C4F666673657443616368655B655D';
wwv_flow_imp.g_varchar2_table(14491) := '3D2D317D656C736520746869732E5F6B6579436F6C756D6E506978656C4F666673657443616368653D6E756C6C3B746869732E5F6368617261637465724D617070696E673D6E2C746869732E5F6368617257696474683D742E737061636557696474687D';
wwv_flow_imp.g_varchar2_table(14492) := '67657457696474682865297B69662821746869732E646F6D4E6F64657C7C746869732E696E7075742E6C696E65436F6E74656E742E6C656E6774683C333030297B636F6E737420653D746869732E5F6368617261637465724D617070696E672E67657448';
wwv_flow_imp.g_varchar2_table(14493) := '6F72697A6F6E74616C4F666673657428746869732E5F6368617261637465724D617070696E672E6C656E677468293B72657475726E204D6174682E726F756E6428746869732E5F6368617257696474682A65297D72657475726E2D313D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(14494) := '5F6361636865645769647468262628746869732E5F63616368656457696474683D746869732E5F67657452656164696E6754617267657428746869732E646F6D4E6F6465292E6F666673657457696474682C6E756C6C3D3D657C7C652E6D61726B446964';
wwv_flow_imp.g_varchar2_table(14495) := '446F6D4C61796F75742829292C746869732E5F63616368656457696474687D676574576964746849734661737428297B72657475726E20746869732E696E7075742E6C696E65436F6E74656E742E6C656E6774683C3330307C7C2D31213D3D746869732E';
wwv_flow_imp.g_varchar2_table(14496) := '5F63616368656457696474687D6D6F6E6F7370616365417373756D7074696F6E7341726556616C696428297B69662821746869732E646F6D4E6F64652972657475726E206B4E3B696628746869732E696E7075742E6C696E65436F6E74656E742E6C656E';
wwv_flow_imp.g_varchar2_table(14497) := '6774683C333030297B636F6E737420653D746869732E6765745769647468286E756C6C292C743D746869732E646F6D4E6F64652E646F6D4E6F64652E66697273744368696C642E6F666673657457696474683B4D6174682E61627328652D74293E3D3226';
wwv_flow_imp.g_varchar2_table(14498) := '2628636F6E736F6C652E7761726E28226D6F6E6F737061636520617373756D7074696F6E732068617665206265656E2076696F6C617465642C207468657265666F72652064697361626C696E67206D6F6E6F7370616365206F7074696D697A6174696F6E';
wwv_flow_imp.g_varchar2_table(14499) := '732122292C6B4E3D2131297D72657475726E206B4E7D746F536C6F7752656E64657265644C696E6528297B72657475726E204D4E28746869732E646F6D4E6F64652C746869732E696E7075742C746869732E5F6368617261637465724D617070696E672C';
wwv_flow_imp.g_varchar2_table(14500) := '21312C30297D67657456697369626C6552616E676573466F7252616E676528652C742C6E2C69297B636F6E7374206F3D746869732E5F676574436F6C756D6E506978656C4F666673657428652C742C69292C733D746869732E5F676574436F6C756D6E50';
wwv_flow_imp.g_varchar2_table(14501) := '6978656C4F666673657428652C6E2C69293B72657475726E5B6E657720734E286F2C732D6F295D7D5F676574436F6C756D6E506978656C4F666673657428652C742C6E297B696628743C3D333030297B636F6E737420653D746869732E5F636861726163';
wwv_flow_imp.g_varchar2_table(14502) := '7465724D617070696E672E676574486F72697A6F6E74616C4F66667365742874293B72657475726E20746869732E5F6368617257696474682A657D636F6E737420693D4D6174682E666C6F6F722828742D31292F333030292D312C6F3D3330302A28692B';
wwv_flow_imp.g_varchar2_table(14503) := '31292B313B6C657420733D2D313B696628746869732E5F6B6579436F6C756D6E506978656C4F66667365744361636865262628733D746869732E5F6B6579436F6C756D6E506978656C4F666673657443616368655B695D2C2D313D3D3D73262628733D74';
wwv_flow_imp.g_varchar2_table(14504) := '6869732E5F61637475616C52656164506978656C4F666673657428652C6F2C6E292C746869732E5F6B6579436F6C756D6E506978656C4F666673657443616368655B695D3D7329292C2D313D3D3D73297B636F6E737420653D746869732E5F6368617261';
wwv_flow_imp.g_varchar2_table(14505) := '637465724D617070696E672E676574486F72697A6F6E74616C4F66667365742874293B72657475726E20746869732E5F6368617257696474682A657D636F6E737420723D746869732E5F6368617261637465724D617070696E672E676574486F72697A6F';
wwv_flow_imp.g_varchar2_table(14506) := '6E74616C4F6666736574286F292C613D746869732E5F6368617261637465724D617070696E672E676574486F72697A6F6E74616C4F66667365742874293B72657475726E20732B746869732E5F6368617257696474682A28612D72297D5F676574526561';
wwv_flow_imp.g_varchar2_table(14507) := '64696E675461726765742865297B72657475726E20652E646F6D4E6F64652E66697273744368696C647D5F61637475616C52656164506978656C4F666673657428652C742C6E297B69662821746869732E646F6D4E6F64652972657475726E2D313B636F';
wwv_flow_imp.g_varchar2_table(14508) := '6E737420693D746869732E5F6368617261637465724D617070696E672E676574446F6D506F736974696F6E2874292C6F3D6C4E2E72656164486F72697A6F6E74616C52616E67657328746869732E5F67657452656164696E675461726765742874686973';
wwv_flow_imp.g_varchar2_table(14509) := '2E646F6D4E6F6465292C692E70617274496E6465782C692E63686172496E6465782C692E70617274496E6465782C692E63686172496E6465782C6E293B72657475726E206F262630213D3D6F2E6C656E6774683F6F5B305D2E6C6566743A2D317D676574';
wwv_flow_imp.g_varchar2_table(14510) := '436F6C756D6E4F664E6F64654F666673657428652C74297B72657475726E20414E28746869732E5F6368617261637465724D617070696E672C652C74297D7D636C61737320544E7B636F6E7374727563746F7228652C742C6E2C692C6F297B6966287468';
wwv_flow_imp.g_varchar2_table(14511) := '69732E646F6D4E6F64653D652C746869732E696E7075743D742C746869732E5F6368617261637465724D617070696E673D6E2C746869732E5F6973576869746573706163654F6E6C793D2F5E5C732A242F2E7465737428742E6C696E65436F6E74656E74';
wwv_flow_imp.g_varchar2_table(14512) := '292C746869732E5F636F6E7461696E73466F726569676E456C656D656E74733D6F2C746869732E5F63616368656457696474683D2D312C746869732E5F706978656C4F666673657443616368653D6E756C6C2C21697C7C303D3D3D746869732E5F636861';
wwv_flow_imp.g_varchar2_table(14513) := '7261637465724D617070696E672E6C656E677468297B746869732E5F706978656C4F666673657443616368653D6E657720466C6F617433324172726179284D6174682E6D617828322C746869732E5F6368617261637465724D617070696E672E6C656E67';
wwv_flow_imp.g_varchar2_table(14514) := '74682B3129293B666F72286C657420653D302C743D746869732E5F6368617261637465724D617070696E672E6C656E6774683B653C3D743B652B2B29746869732E5F706978656C4F666673657443616368655B655D3D2D317D7D5F67657452656164696E';
wwv_flow_imp.g_varchar2_table(14515) := '675461726765742865297B72657475726E20652E646F6D4E6F64652E66697273744368696C647D67657457696474682865297B72657475726E20746869732E646F6D4E6F64653F282D313D3D3D746869732E5F6361636865645769647468262628746869';
wwv_flow_imp.g_varchar2_table(14516) := '732E5F63616368656457696474683D746869732E5F67657452656164696E6754617267657428746869732E646F6D4E6F6465292E6F666673657457696474682C6E756C6C3D3D657C7C652E6D61726B446964446F6D4C61796F75742829292C746869732E';
wwv_flow_imp.g_varchar2_table(14517) := '5F6361636865645769647468293A307D676574576964746849734661737428297B72657475726E2D31213D3D746869732E5F63616368656457696474687D67657456697369626C6552616E676573466F7252616E676528652C742C6E2C69297B69662821';
wwv_flow_imp.g_varchar2_table(14518) := '746869732E646F6D4E6F64652972657475726E206E756C6C3B6966286E756C6C213D3D746869732E5F706978656C4F66667365744361636865297B636F6E7374206F3D746869732E5F72656164506978656C4F666673657428746869732E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(14519) := '652C652C742C69293B6966282D313D3D3D6F2972657475726E206E756C6C3B636F6E737420733D746869732E5F72656164506978656C4F666673657428746869732E646F6D4E6F64652C652C6E2C69293B72657475726E2D313D3D3D733F6E756C6C3A5B';
wwv_flow_imp.g_varchar2_table(14520) := '6E657720734E286F2C732D6F295D7D72657475726E20746869732E5F7265616456697369626C6552616E676573466F7252616E676528746869732E646F6D4E6F64652C652C742C6E2C69297D5F7265616456697369626C6552616E676573466F7252616E';
wwv_flow_imp.g_varchar2_table(14521) := '676528652C742C6E2C692C6F297B6966286E3D3D3D69297B636F6E737420693D746869732E5F72656164506978656C4F666673657428652C742C6E2C6F293B72657475726E2D313D3D3D693F6E756C6C3A5B6E657720734E28692C30295D7D7265747572';
wwv_flow_imp.g_varchar2_table(14522) := '6E20746869732E5F7265616452617756697369626C6552616E676573466F7252616E676528652C6E2C692C6F297D5F72656164506978656C4F666673657428652C742C6E2C69297B696628303D3D3D746869732E5F6368617261637465724D617070696E';
wwv_flow_imp.g_varchar2_table(14523) := '672E6C656E677468297B696628303D3D3D746869732E5F636F6E7461696E73466F726569676E456C656D656E74732972657475726E20303B696628323D3D3D746869732E5F636F6E7461696E73466F726569676E456C656D656E74732972657475726E20';
wwv_flow_imp.g_varchar2_table(14524) := '303B696628313D3D3D746869732E5F636F6E7461696E73466F726569676E456C656D656E74732972657475726E20746869732E67657457696474682869293B636F6E737420743D746869732E5F67657452656164696E675461726765742865293B726574';
wwv_flow_imp.g_varchar2_table(14525) := '75726E20742E66697273744368696C643F28692E6D61726B446964446F6D4C61796F757428292C742E66697273744368696C642E6F66667365745769647468293A307D6966286E756C6C213D3D746869732E5F706978656C4F6666736574436163686529';
wwv_flow_imp.g_varchar2_table(14526) := '7B636F6E7374206F3D746869732E5F706978656C4F666673657443616368655B6E5D3B6966282D31213D3D6F2972657475726E206F3B636F6E737420733D746869732E5F61637475616C52656164506978656C4F666673657428652C742C6E2C69293B72';
wwv_flow_imp.g_varchar2_table(14527) := '657475726E20746869732E5F706978656C4F666673657443616368655B6E5D3D732C737D72657475726E20746869732E5F61637475616C52656164506978656C4F666673657428652C742C6E2C69297D5F61637475616C52656164506978656C4F666673';
wwv_flow_imp.g_varchar2_table(14528) := '657428652C742C6E2C69297B696628303D3D3D746869732E5F6368617261637465724D617070696E672E6C656E677468297B636F6E737420743D6C4E2E72656164486F72697A6F6E74616C52616E67657328746869732E5F67657452656164696E675461';
wwv_flow_imp.g_varchar2_table(14529) := '726765742865292C302C302C302C302C69293B72657475726E2074262630213D3D742E6C656E6774683F745B305D2E6C6566743A2D317D6966286E3D3D3D746869732E5F6368617261637465724D617070696E672E6C656E6774682626746869732E5F69';
wwv_flow_imp.g_varchar2_table(14530) := '73576869746573706163654F6E6C792626303D3D3D746869732E5F636F6E7461696E73466F726569676E456C656D656E74732972657475726E20746869732E67657457696474682869293B636F6E7374206F3D746869732E5F6368617261637465724D61';
wwv_flow_imp.g_varchar2_table(14531) := '7070696E672E676574446F6D506F736974696F6E286E292C733D6C4E2E72656164486F72697A6F6E74616C52616E67657328746869732E5F67657452656164696E675461726765742865292C6F2E70617274496E6465782C6F2E63686172496E6465782C';
wwv_flow_imp.g_varchar2_table(14532) := '6F2E70617274496E6465782C6F2E63686172496E6465782C69293B69662821737C7C303D3D3D732E6C656E6774682972657475726E2D313B636F6E737420723D735B305D2E6C6566743B696628746869732E696E7075742E697342617369634153434949';
wwv_flow_imp.g_varchar2_table(14533) := '297B636F6E737420653D746869732E5F6368617261637465724D617070696E672E676574486F72697A6F6E74616C4F6666736574286E292C743D4D6174682E726F756E6428746869732E696E7075742E737061636557696474682A65293B6966284D6174';
wwv_flow_imp.g_varchar2_table(14534) := '682E61627328742D72293C3D312972657475726E20747D72657475726E20727D5F7265616452617756697369626C6552616E676573466F7252616E676528652C742C6E2C69297B696628313D3D3D7426266E3D3D3D746869732E5F636861726163746572';
wwv_flow_imp.g_varchar2_table(14535) := '4D617070696E672E6C656E6774682972657475726E5B6E657720734E28302C746869732E6765745769647468286929295D3B636F6E7374206F3D746869732E5F6368617261637465724D617070696E672E676574446F6D506F736974696F6E2874292C73';
wwv_flow_imp.g_varchar2_table(14536) := '3D746869732E5F6368617261637465724D617070696E672E676574446F6D506F736974696F6E286E293B72657475726E206C4E2E72656164486F72697A6F6E74616C52616E67657328746869732E5F67657452656164696E675461726765742865292C6F';
wwv_flow_imp.g_varchar2_table(14537) := '2E70617274496E6465782C6F2E63686172496E6465782C732E70617274496E6465782C732E63686172496E6465782C69297D676574436F6C756D6E4F664E6F64654F666673657428652C74297B72657475726E20414E28746869732E5F63686172616374';
wwv_flow_imp.g_varchar2_table(14538) := '65724D617070696E672C652C74297D7D636C61737320494E20657874656E647320544E7B5F7265616456697369626C6552616E676573466F7252616E676528652C742C6E2C692C6F297B636F6E737420733D73757065722E5F7265616456697369626C65';
wwv_flow_imp.g_varchar2_table(14539) := '52616E676573466F7252616E676528652C742C6E2C692C6F293B69662821737C7C303D3D3D732E6C656E6774687C7C6E3D3D3D697C7C313D3D3D6E2626693D3D3D746869732E5F6368617261637465724D617070696E672E6C656E677468297265747572';
wwv_flow_imp.g_varchar2_table(14540) := '6E20733B69662821746869732E696E7075742E636F6E7461696E7352544C297B636F6E7374206E3D746869732E5F72656164506978656C4F666673657428652C742C692C6F293B6966282D31213D3D6E297B636F6E737420653D735B732E6C656E677468';
wwv_flow_imp.g_varchar2_table(14541) := '2D315D3B652E6C6566743C6E262628652E77696474683D6E2D652E6C656674297D7D72657475726E20737D7D636F6E7374204D4E3D643F66756E6374696F6E28652C742C6E2C692C6F297B72657475726E206E657720494E28652C742C6E2C692C6F297D';
wwv_flow_imp.g_varchar2_table(14542) := '3A66756E6374696F6E28652C742C6E2C692C6F297B72657475726E206E657720544E28652C742C6E2C692C6F297D3B66756E6374696F6E20414E28652C742C6E297B636F6E737420693D742E74657874436F6E74656E742E6C656E6774683B6C6574206F';
wwv_flow_imp.g_varchar2_table(14543) := '3D2D313B666F72283B743B29743D742E70726576696F75735369626C696E672C6F2B2B3B72657475726E20652E676574436F6C756D6E286E657720664E286F2C6E292C69297D636C617373204E4E7B636F6E7374727563746F7228653D6E756C6C297B74';
wwv_flow_imp.g_varchar2_table(14544) := '6869732E6869745461726765743D652C746869732E747970653D307D7D636C61737320504E7B6765742068697454617267657428297B72657475726E20746869732E7370616E4E6F64657D636F6E7374727563746F7228652C742C6E297B746869732E70';
wwv_flow_imp.g_varchar2_table(14545) := '6F736974696F6E3D652C746869732E7370616E4E6F64653D742C746869732E696E6A6563746564546578743D6E2C746869732E747970653D317D7D766172204F4E3B2166756E6374696F6E2865297B652E63726561746546726F6D444F4D496E666F3D66';
wwv_flow_imp.g_varchar2_table(14546) := '756E6374696F6E28652C742C6E297B636F6E737420693D652E676574506F736974696F6E46726F6D444F4D496E666F28742C6E293B72657475726E20693F6E657720504E28692C742C6E756C6C293A6E6577204E4E2874297D7D284F4E7C7C284F4E3D7B';
wwv_flow_imp.g_varchar2_table(14547) := '7D29293B636C61737320524E7B636F6E7374727563746F7228652C74297B746869732E6C61737456696577437572736F727352656E646572446174613D652C746869732E6C6173745465787461726561506F736974696F6E3D747D7D636C61737320464E';
wwv_flow_imp.g_varchar2_table(14548) := '7B737461746963205F6465647563655261676528652C743D6E756C6C297B72657475726E21742626653F6E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C756D6E293A6E756C6C213D';
wwv_flow_imp.g_varchar2_table(14549) := '743F743A6E756C6C7D73746174696320637265617465556E6B6E6F776E28652C742C6E297B72657475726E7B747970653A302C656C656D656E743A652C6D6F757365436F6C756D6E3A742C706F736974696F6E3A6E2C72616E67653A746869732E5F6465';
wwv_flow_imp.g_varchar2_table(14550) := '6475636552616765286E297D7D73746174696320637265617465546578746172656128652C74297B72657475726E7B747970653A312C656C656D656E743A652C6D6F757365436F6C756D6E3A742C706F736974696F6E3A6E756C6C2C72616E67653A6E75';
wwv_flow_imp.g_varchar2_table(14551) := '6C6C7D7D737461746963206372656174654D617267696E28652C742C6E2C692C6F2C73297B72657475726E7B747970653A652C656C656D656E743A742C6D6F757365436F6C756D6E3A6E2C706F736974696F6E3A692C72616E67653A6F2C64657461696C';
wwv_flow_imp.g_varchar2_table(14552) := '3A737D7D73746174696320637265617465566965775A6F6E6528652C742C6E2C692C6F297B72657475726E7B747970653A652C656C656D656E743A742C6D6F757365436F6C756D6E3A6E2C706F736974696F6E3A692C72616E67653A746869732E5F6465';
wwv_flow_imp.g_varchar2_table(14553) := '64756365526167652869292C64657461696C3A6F7D7D73746174696320637265617465436F6E74656E745465787428652C742C6E2C692C6F297B72657475726E7B747970653A362C656C656D656E743A652C6D6F757365436F6C756D6E3A742C706F7369';
wwv_flow_imp.g_varchar2_table(14554) := '74696F6E3A6E2C72616E67653A746869732E5F64656475636552616765286E2C69292C64657461696C3A6F7D7D73746174696320637265617465436F6E74656E74456D70747928652C742C6E2C69297B72657475726E7B747970653A372C656C656D656E';
wwv_flow_imp.g_varchar2_table(14555) := '743A652C6D6F757365436F6C756D6E3A742C706F736974696F6E3A6E2C72616E67653A746869732E5F64656475636552616765286E292C64657461696C3A697D7D73746174696320637265617465436F6E74656E7457696467657428652C742C6E297B72';
wwv_flow_imp.g_varchar2_table(14556) := '657475726E7B747970653A392C656C656D656E743A652C6D6F757365436F6C756D6E3A742C706F736974696F6E3A6E756C6C2C72616E67653A6E756C6C2C64657461696C3A6E7D7D737461746963206372656174655363726F6C6C62617228652C742C6E';
wwv_flow_imp.g_varchar2_table(14557) := '297B72657475726E7B747970653A31312C656C656D656E743A652C6D6F757365436F6C756D6E3A742C706F736974696F6E3A6E2C72616E67653A746869732E5F64656475636552616765286E297D7D737461746963206372656174654F7665726C617957';
wwv_flow_imp.g_varchar2_table(14558) := '696467657428652C742C6E297B72657475726E7B747970653A31322C656C656D656E743A652C6D6F757365436F6C756D6E3A742C706F736974696F6E3A6E756C6C2C72616E67653A6E756C6C2C64657461696C3A6E7D7D73746174696320637265617465';
wwv_flow_imp.g_varchar2_table(14559) := '4F757473696465456469746F7228652C742C6E2C69297B72657475726E7B747970653A31332C656C656D656E743A6E756C6C2C6D6F757365436F6C756D6E3A652C706F736974696F6E3A742C72616E67653A746869732E5F646564756365526167652874';
wwv_flow_imp.g_varchar2_table(14560) := '292C6F757473696465506F736974696F6E3A6E2C6F75747369646544697374616E63653A697D7D737461746963205F74797065546F537472696E672865297B72657475726E20313D3D3D653F225445585441524541223A323D3D3D653F22475554544552';
wwv_flow_imp.g_varchar2_table(14561) := '5F474C5950485F4D415247494E223A333D3D3D653F224755545445525F4C494E455F4E554D42455253223A343D3D3D653F224755545445525F4C494E455F4445434F524154494F4E53223A353D3D3D653F224755545445525F564945575F5A4F4E45223A';
wwv_flow_imp.g_varchar2_table(14562) := '363D3D3D653F22434F4E54454E545F54455854223A373D3D3D653F22434F4E54454E545F454D505459223A383D3D3D653F22434F4E54454E545F564945575F5A4F4E45223A393D3D3D653F22434F4E54454E545F574944474554223A31303D3D3D653F22';
wwv_flow_imp.g_varchar2_table(14563) := '4F564552564945575F52554C4552223A31313D3D3D653F225343524F4C4C424152223A31323D3D3D653F224F5645524C41595F574944474554223A22554E4B4E4F574E227D73746174696320746F537472696E672865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(14564) := '5F74797065546F537472696E6728652E74797065292B223A20222B652E706F736974696F6E2B22202D20222B652E72616E67652B22202D20222B4A534F4E2E737472696E6769667928652E64657461696C297D7D636C61737320424E7B73746174696320';
wwv_flow_imp.g_varchar2_table(14565) := '697354657874417265612865297B72657475726E20323D3D3D652E6C656E6774682626333D3D3D655B305D2626373D3D3D655B315D7D7374617469632069734368696C644F66566965774C696E65732865297B72657475726E20652E6C656E6774683E3D';
wwv_flow_imp.g_varchar2_table(14566) := '342626333D3D3D655B305D2626383D3D3D655B335D7D7374617469632069735374726963744368696C644F66566965774C696E65732865297B72657475726E20652E6C656E6774683E342626333D3D3D655B305D2626383D3D3D655B335D7D7374617469';
wwv_flow_imp.g_varchar2_table(14567) := '632069734368696C644F665363726F6C6C61626C65456C656D656E742865297B72657475726E20652E6C656E6774683E3D322626333D3D3D655B305D2626363D3D3D655B315D7D7374617469632069734368696C644F664D696E696D61702865297B7265';
wwv_flow_imp.g_varchar2_table(14568) := '7475726E20652E6C656E6774683E3D322626333D3D3D655B305D2626393D3D3D655B315D7D7374617469632069734368696C644F66436F6E74656E74576964676574732865297B72657475726E20652E6C656E6774683E3D342626333D3D3D655B305D26';
wwv_flow_imp.g_varchar2_table(14569) := '26313D3D3D655B335D7D7374617469632069734368696C644F664F766572666C6F7747756172642865297B72657475726E20652E6C656E6774683E3D312626333D3D3D655B305D7D7374617469632069734368696C644F664F766572666C6F77696E6743';
wwv_flow_imp.g_varchar2_table(14570) := '6F6E74656E74576964676574732865297B72657475726E20652E6C656E6774683E3D312626323D3D3D655B305D7D7374617469632069734368696C644F664F7665726C6179576964676574732865297B72657475726E20652E6C656E6774683E3D322626';
wwv_flow_imp.g_varchar2_table(14571) := '333D3D3D655B305D2626343D3D3D655B315D7D7374617469632069734368696C644F664F766572666C6F77696E674F7665726C6179576964676574732865297B72657475726E20652E6C656E6774683E3D312626353D3D3D655B305D7D7D636C61737320';
wwv_flow_imp.g_varchar2_table(14572) := '564E7B636F6E7374727563746F7228652C742C6E297B746869732E766965774D6F64656C3D652E766965774D6F64656C3B636F6E737420693D652E636F6E66696775726174696F6E2E6F7074696F6E733B746869732E6C61796F7574496E666F3D692E67';
wwv_flow_imp.g_varchar2_table(14573) := '657428313435292C746869732E76696577446F6D4E6F64653D742E76696577446F6D4E6F64652C746869732E6C696E654865696768743D692E676574283637292C746869732E737469636B7954616253746F70733D692E67657428313136292C74686973';
wwv_flow_imp.g_varchar2_table(14574) := '2E7479706963616C48616C66776964746843686172616374657257696474683D692E676574283530292E7479706963616C48616C66776964746843686172616374657257696474682C746869732E6C61737452656E646572446174613D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(14575) := '5F636F6E746578743D652C746869732E5F7669657748656C7065723D747D6765745A6F6E654174436F6F72642865297B72657475726E20564E2E6765745A6F6E654174436F6F726428746869732E5F636F6E746578742C65297D73746174696320676574';
wwv_flow_imp.g_varchar2_table(14576) := '5A6F6E654174436F6F726428652C74297B636F6E7374206E3D652E766965774C61796F75742E676574576869746573706163654174566572746963616C4F66667365742874293B6966286E297B636F6E737420693D6E2E766572746963616C4F66667365';
wwv_flow_imp.g_varchar2_table(14577) := '742B6E2E6865696768742F322C6F3D652E766965774D6F64656C2E6765744C696E65436F756E7428293B6C657420732C723D6E756C6C2C613D6E756C6C3B72657475726E206E2E61667465724C696E654E756D626572213D3D6F262628613D6E6577206D';
wwv_flow_imp.g_varchar2_table(14578) := '63286E2E61667465724C696E654E756D6265722B312C3129292C6E2E61667465724C696E654E756D6265723E30262628723D6E6577206D63286E2E61667465724C696E654E756D6265722C652E766965774D6F64656C2E6765744C696E654D6178436F6C';
wwv_flow_imp.g_varchar2_table(14579) := '756D6E286E2E61667465724C696E654E756D6265722929292C733D6E756C6C3D3D3D613F723A6E756C6C3D3D3D723F613A743C693F723A612C7B766965775A6F6E6549643A6E2E69642C61667465724C696E654E756D6265723A6E2E61667465724C696E';
wwv_flow_imp.g_varchar2_table(14580) := '654E756D6265722C706F736974696F6E4265666F72653A722C706F736974696F6E41667465723A612C706F736974696F6E3A737D7D72657475726E206E756C6C7D67657446756C6C4C696E6552616E67654174436F6F72642865297B696628746869732E';
wwv_flow_imp.g_varchar2_table(14581) := '5F636F6E746578742E766965774C61796F75742E697341667465724C696E6573286529297B636F6E737420653D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E7428292C743D746869732E5F636F6E746578742E';
wwv_flow_imp.g_varchar2_table(14582) := '766965774D6F64656C2E6765744C696E654D6178436F6C756D6E2865293B72657475726E7B72616E67653A6E657720726828652C742C652C74292C697341667465724C696E65733A21307D7D636F6E737420743D746869732E5F636F6E746578742E7669';
wwv_flow_imp.g_varchar2_table(14583) := '65774C61796F75742E6765744C696E654E756D6265724174566572746963616C4F66667365742865292C6E3D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E2874293B72657475726E7B72616E6765';
wwv_flow_imp.g_varchar2_table(14584) := '3A6E657720726828742C312C742C6E292C697341667465724C696E65733A21317D7D6765744C696E654E756D6265724174566572746963616C4F66667365742865297B72657475726E20746869732E5F636F6E746578742E766965774C61796F75742E67';
wwv_flow_imp.g_varchar2_table(14585) := '65744C696E654E756D6265724174566572746963616C4F66667365742865297D697341667465724C696E65732865297B72657475726E20746869732E5F636F6E746578742E766965774C61796F75742E697341667465724C696E65732865297D6973496E';
wwv_flow_imp.g_varchar2_table(14586) := '546F7050616464696E672865297B72657475726E20746869732E5F636F6E746578742E766965774C61796F75742E6973496E546F7050616464696E672865297D6973496E426F74746F6D50616464696E672865297B72657475726E20746869732E5F636F';
wwv_flow_imp.g_varchar2_table(14587) := '6E746578742E766965774C61796F75742E6973496E426F74746F6D50616464696E672865297D676574566572746963616C4F6666736574466F724C696E654E756D6265722865297B72657475726E20746869732E5F636F6E746578742E766965774C6179';
wwv_flow_imp.g_varchar2_table(14588) := '6F75742E676574566572746963616C4F6666736574466F724C696E654E756D6265722865297D66696E6441747472696275746528652C74297B72657475726E20564E2E5F66696E6441747472696275746528652C742C746869732E5F7669657748656C70';
wwv_flow_imp.g_varchar2_table(14589) := '65722E76696577446F6D4E6F6465297D737461746963205F66696E6441747472696275746528652C742C6E297B666F72283B65262665213D3D652E6F776E6572446F63756D656E742E626F64793B297B696628652E686173417474726962757465262665';
wwv_flow_imp.g_varchar2_table(14590) := '2E6861734174747269627574652874292972657475726E20652E6765744174747269627574652874293B696628653D3D3D6E2972657475726E206E756C6C3B653D652E706172656E744E6F64657D72657475726E206E756C6C7D6765744C696E65576964';
wwv_flow_imp.g_varchar2_table(14591) := '74682865297B72657475726E20746869732E5F7669657748656C7065722E6765744C696E6557696474682865297D76697369626C6552616E6765466F72506F736974696F6E28652C74297B72657475726E20746869732E5F7669657748656C7065722E76';
wwv_flow_imp.g_varchar2_table(14592) := '697369626C6552616E6765466F72506F736974696F6E28652C74297D676574506F736974696F6E46726F6D444F4D496E666F28652C74297B72657475726E20746869732E5F7669657748656C7065722E676574506F736974696F6E46726F6D444F4D496E';
wwv_flow_imp.g_varchar2_table(14593) := '666F28652C74297D67657443757272656E745363726F6C6C546F7028297B72657475726E20746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E745363726F6C6C546F7028297D67657443757272656E745363726F6C6C';
wwv_flow_imp.g_varchar2_table(14594) := '4C65667428297B72657475726E20746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E745363726F6C6C4C65667428297D7D636C617373207A4E7B636F6E7374727563746F7228652C742C6E2C69297B746869732E6564';
wwv_flow_imp.g_varchar2_table(14595) := '69746F72506F733D742C746869732E706F733D6E2C746869732E72656C6174697665506F733D692C746869732E6D6F757365566572746963616C4F66667365743D4D6174682E6D617828302C652E67657443757272656E745363726F6C6C546F7028292B';
wwv_flow_imp.g_varchar2_table(14596) := '746869732E72656C6174697665506F732E79292C746869732E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365743D652E67657443757272656E745363726F6C6C4C65667428292B746869732E72656C6174697665506F732E782D652E';
wwv_flow_imp.g_varchar2_table(14597) := '6C61796F7574496E666F2E636F6E74656E744C6566742C746869732E6973496E4D617267696E417265613D746869732E72656C6174697665506F732E783C652E6C61796F7574496E666F2E636F6E74656E744C6566742626746869732E72656C61746976';
wwv_flow_imp.g_varchar2_table(14598) := '65506F732E783E3D652E6C61796F7574496E666F2E676C7970684D617267696E4C6566742C746869732E6973496E436F6E74656E74417265613D21746869732E6973496E4D617267696E417265612C746869732E6D6F757365436F6C756D6E3D4D617468';
wwv_flow_imp.g_varchar2_table(14599) := '2E6D617828302C714E2E5F6765744D6F757365436F6C756D6E28746869732E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365742C652E7479706963616C48616C667769647468436861726163746572576964746829297D7D636C6173';
wwv_flow_imp.g_varchar2_table(14600) := '7320484E20657874656E6473207A4E7B6765742074617267657428297B72657475726E20746869732E5F757365486974546573745461726765743F746869732E68697454657374526573756C742E76616C75652E6869745461726765743A746869732E5F';
wwv_flow_imp.g_varchar2_table(14601) := '6576656E745461726765747D676574207461726765745061746828297B72657475726E20746869732E5F746172676574506174684361636865456C656D656E74213D3D746869732E746172676574262628746869732E5F74617267657450617468436163';
wwv_flow_imp.g_varchar2_table(14602) := '6865456C656D656E743D746869732E7461726765742C746869732E5F74617267657450617468436163686556616C75653D654E2E636F6C6C65637428746869732E7461726765742C746869732E5F6374782E76696577446F6D4E6F646529292C74686973';
wwv_flow_imp.g_varchar2_table(14603) := '2E5F74617267657450617468436163686556616C75657D636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228652C742C6E2C69292C746869732E68697454657374526573756C743D6E6577206969282828293D3E714E2E646F486974';
wwv_flow_imp.g_varchar2_table(14604) := '5465737428746869732E5F6374782C746869732929292C746869732E5F746172676574506174684361636865456C656D656E743D6E756C6C2C746869732E5F74617267657450617468436163686556616C75653D6E65772055696E743841727261792830';
wwv_flow_imp.g_varchar2_table(14605) := '292C746869732E5F6374783D652C746869732E5F6576656E745461726765743D6F3B636F6E737420733D426F6F6C65616E28746869732E5F6576656E74546172676574293B746869732E5F757365486974546573745461726765743D21737D746F537472';
wwv_flow_imp.g_varchar2_table(14606) := '696E6728297B72657475726E60706F7328247B746869732E706F732E787D2C247B746869732E706F732E797D292C20656469746F72506F7328247B746869732E656469746F72506F732E787D2C247B746869732E656469746F72506F732E797D292C2072';
wwv_flow_imp.g_varchar2_table(14607) := '656C6174697665506F7328247B746869732E72656C6174697665506F732E787D2C247B746869732E72656C6174697665506F732E797D292C206D6F757365566572746963616C4F66667365743A20247B746869732E6D6F757365566572746963616C4F66';
wwv_flow_imp.g_varchar2_table(14608) := '667365747D2C206D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365743A20247B746869732E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365747D5C6E5C747461726765743A20247B746869732E7461726765743F74';
wwv_flow_imp.g_varchar2_table(14609) := '6869732E7461726765742E6F7574657248544D4C3A6E756C6C7D607D67657420776F756C6442656E6566697446726F6D4869745465737454617267657453776974636828297B72657475726E21746869732E5F7573654869745465737454617267657426';
wwv_flow_imp.g_varchar2_table(14610) := '266E756C6C213D3D746869732E68697454657374526573756C742E76616C75652E6869745461726765742626746869732E746172676574213D3D746869732E68697454657374526573756C742E76616C75652E6869745461726765747D73776974636854';
wwv_flow_imp.g_varchar2_table(14611) := '6F4869745465737454617267657428297B746869732E5F757365486974546573745461726765743D21307D5F6765744D6F757365436F6C756D6E28653D6E756C6C297B72657475726E20652626652E636F6C756D6E3C746869732E5F6374782E76696577';
wwv_flow_imp.g_varchar2_table(14612) := '4D6F64656C2E6765744C696E654D6178436F6C756D6E28652E6C696E654E756D626572293F70752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28746869732E5F6374782E766965774D6F64656C2E6765744C696E65436F6E74656E742865';
wwv_flow_imp.g_varchar2_table(14613) := '2E6C696E654E756D626572292C652E636F6C756D6E2C746869732E5F6374782E766965774D6F64656C2E6D6F64656C2E6765744F7074696F6E7328292E74616253697A65292B313A746869732E6D6F757365436F6C756D6E7D66756C66696C6C556E6B6E';
wwv_flow_imp.g_varchar2_table(14614) := '6F776E28653D6E756C6C297B72657475726E20464E2E637265617465556E6B6E6F776E28746869732E7461726765742C746869732E5F6765744D6F757365436F6C756D6E2865292C65297D66756C66696C6C546578746172656128297B72657475726E20';
wwv_flow_imp.g_varchar2_table(14615) := '464E2E637265617465546578746172656128746869732E7461726765742C746869732E5F6765744D6F757365436F6C756D6E2829297D66756C66696C6C4D617267696E28652C742C6E2C69297B72657475726E20464E2E6372656174654D617267696E28';
wwv_flow_imp.g_varchar2_table(14616) := '652C746869732E7461726765742C746869732E5F6765744D6F757365436F6C756D6E2874292C742C6E2C69297D66756C66696C6C566965775A6F6E6528652C742C6E297B72657475726E20464E2E637265617465566965775A6F6E6528652C746869732E';
wwv_flow_imp.g_varchar2_table(14617) := '7461726765742C746869732E5F6765744D6F757365436F6C756D6E2874292C742C6E297D66756C66696C6C436F6E74656E745465787428652C742C6E297B72657475726E20464E2E637265617465436F6E74656E745465787428746869732E7461726765';
wwv_flow_imp.g_varchar2_table(14618) := '742C746869732E5F6765744D6F757365436F6C756D6E2865292C652C742C6E297D66756C66696C6C436F6E74656E74456D70747928652C74297B72657475726E20464E2E637265617465436F6E74656E74456D70747928746869732E7461726765742C74';
wwv_flow_imp.g_varchar2_table(14619) := '6869732E5F6765744D6F757365436F6C756D6E2865292C652C74297D66756C66696C6C436F6E74656E745769646765742865297B72657475726E20464E2E637265617465436F6E74656E7457696467657428746869732E7461726765742C746869732E5F';
wwv_flow_imp.g_varchar2_table(14620) := '6765744D6F757365436F6C756D6E28292C65297D66756C66696C6C5363726F6C6C6261722865297B72657475726E20464E2E6372656174655363726F6C6C62617228746869732E7461726765742C746869732E5F6765744D6F757365436F6C756D6E2865';
wwv_flow_imp.g_varchar2_table(14621) := '292C65297D66756C66696C6C4F7665726C61795769646765742865297B72657475726E20464E2E6372656174654F7665726C617957696467657428746869732E7461726765742C746869732E5F6765744D6F757365436F6C756D6E28292C65297D7D636F';
wwv_flow_imp.g_varchar2_table(14622) := '6E737420574E3D7B697341667465724C696E65733A21307D3B66756E6374696F6E206A4E2865297B72657475726E7B697341667465724C696E65733A21312C686F72697A6F6E74616C44697374616E6365546F546578743A657D7D636C61737320714E7B';
wwv_flow_imp.g_varchar2_table(14623) := '636F6E7374727563746F7228652C74297B746869732E5F636F6E746578743D652C746869732E5F7669657748656C7065723D747D6D6F75736554617267657449735769646765742865297B636F6E737420743D652E7461726765742C6E3D654E2E636F6C';
wwv_flow_imp.g_varchar2_table(14624) := '6C65637428742C746869732E5F7669657748656C7065722E76696577446F6D4E6F6465293B72657475726E212128424E2E69734368696C644F66436F6E74656E7457696467657473286E297C7C424E2E69734368696C644F664F766572666C6F77696E67';
wwv_flow_imp.g_varchar2_table(14625) := '436F6E74656E7457696467657473286E297C7C424E2E69734368696C644F664F7665726C617957696467657473286E297C7C424E2E69734368696C644F664F766572666C6F77696E674F7665726C617957696467657473286E29297D6372656174654D6F';
wwv_flow_imp.g_varchar2_table(14626) := '75736554617267657428652C742C6E2C692C6F297B636F6E737420733D6E657720564E28746869732E5F636F6E746578742C746869732E5F7669657748656C7065722C65292C723D6E657720484E28732C742C6E2C692C6F293B7472797B636F6E737420';
wwv_flow_imp.g_varchar2_table(14627) := '653D714E2E5F6372656174654D6F75736554617267657428732C72293B696628363D3D3D652E747970652626732E737469636B7954616253746F707326266E756C6C213D3D652E706F736974696F6E297B636F6E737420743D714E2E5F736E6170546F53';
wwv_flow_imp.g_varchar2_table(14628) := '6F6674546162426F756E6461727928652E706F736974696F6E2C732E766965774D6F64656C292C6E3D72682E66726F6D506F736974696F6E7328742C74292E706C757352616E676528652E72616E6765293B72657475726E20722E66756C66696C6C436F';
wwv_flow_imp.g_varchar2_table(14629) := '6E74656E745465787428742C6E2C652E64657461696C297D72657475726E20657D63617463682865297B72657475726E20722E66756C66696C6C556E6B6E6F776E28297D7D737461746963205F6372656174654D6F75736554617267657428652C74297B';
wwv_flow_imp.g_varchar2_table(14630) := '6966286E756C6C3D3D3D742E7461726765742972657475726E20742E66756C66696C6C556E6B6E6F776E28293B636F6E7374206E3D743B6C657420693D6E756C6C3B72657475726E20424E2E69734368696C644F664F766572666C6F7747756172642874';
wwv_flow_imp.g_varchar2_table(14631) := '2E74617267657450617468297C7C424E2E69734368696C644F664F766572666C6F77696E67436F6E74656E745769646765747328742E74617267657450617468297C7C424E2E69734368696C644F664F766572666C6F77696E674F7665726C6179576964';
wwv_flow_imp.g_varchar2_table(14632) := '6765747328742E74617267657450617468297C7C28693D697C7C742E66756C66696C6C556E6B6E6F776E2829292C693D697C7C714E2E5F68697454657374436F6E74656E7457696467657428652C6E292C693D697C7C714E2E5F686974546573744F7665';
wwv_flow_imp.g_varchar2_table(14633) := '726C617957696467657428652C6E292C693D697C7C714E2E5F686974546573744D696E696D617028652C6E292C693D697C7C714E2E5F686974546573745363726F6C6C626172536C6964657228652C6E292C693D697C7C714E2E5F686974546573745669';
wwv_flow_imp.g_varchar2_table(14634) := '65775A6F6E6528652C6E292C693D697C7C714E2E5F686974546573744D617267696E28652C6E292C693D697C7C714E2E5F6869745465737456696577437572736F7228652C6E292C693D697C7C714E2E5F68697454657374546578744172656128652C6E';
wwv_flow_imp.g_varchar2_table(14635) := '292C693D697C7C714E2E5F68697454657374566965774C696E657328652C6E292C693D697C7C714E2E5F686974546573745363726F6C6C62617228652C6E292C697C7C742E66756C66696C6C556E6B6E6F776E28297D737461746963205F686974546573';
wwv_flow_imp.g_varchar2_table(14636) := '74436F6E74656E7457696467657428652C74297B696628424E2E69734368696C644F66436F6E74656E745769646765747328742E74617267657450617468297C7C424E2E69734368696C644F664F766572666C6F77696E67436F6E74656E745769646765';
wwv_flow_imp.g_varchar2_table(14637) := '747328742E7461726765745061746829297B636F6E7374206E3D652E66696E6441747472696275746528742E7461726765742C22776964676574496422293B72657475726E206E3F742E66756C66696C6C436F6E74656E74576964676574286E293A742E';
wwv_flow_imp.g_varchar2_table(14638) := '66756C66696C6C556E6B6E6F776E28297D72657475726E206E756C6C7D737461746963205F686974546573744F7665726C617957696467657428652C74297B696628424E2E69734368696C644F664F7665726C61795769646765747328742E7461726765';
wwv_flow_imp.g_varchar2_table(14639) := '7450617468297C7C424E2E69734368696C644F664F766572666C6F77696E674F7665726C61795769646765747328742E7461726765745061746829297B636F6E7374206E3D652E66696E6441747472696275746528742E7461726765742C227769646765';
wwv_flow_imp.g_varchar2_table(14640) := '74496422293B72657475726E206E3F742E66756C66696C6C4F7665726C6179576964676574286E293A742E66756C66696C6C556E6B6E6F776E28297D72657475726E206E756C6C7D737461746963205F6869745465737456696577437572736F7228652C';
wwv_flow_imp.g_varchar2_table(14641) := '74297B696628742E746172676574297B636F6E7374206E3D652E6C61737452656E646572446174612E6C61737456696577437572736F727352656E646572446174613B666F7228636F6E73742065206F66206E29696628742E7461726765743D3D3D652E';
wwv_flow_imp.g_varchar2_table(14642) := '646F6D4E6F64652972657475726E20742E66756C66696C6C436F6E74656E745465787428652E706F736974696F6E2C6E756C6C2C7B6D696768744265466F726569676E456C656D656E743A21312C696E6A6563746564546578743A6E756C6C7D297D6966';
wwv_flow_imp.g_varchar2_table(14643) := '28742E6973496E436F6E74656E7441726561297B636F6E7374206E3D652E6C61737452656E646572446174612E6C61737456696577437572736F727352656E646572446174612C693D742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F6666';
wwv_flow_imp.g_varchar2_table(14644) := '7365742C6F3D742E6D6F757365566572746963616C4F66667365743B666F7228636F6E73742073206F66206E297B696628693C732E636F6E74656E744C65667429636F6E74696E75653B696628693E732E636F6E74656E744C6566742B732E7769647468';
wwv_flow_imp.g_varchar2_table(14645) := '29636F6E74696E75653B636F6E7374206E3D652E676574566572746963616C4F6666736574466F724C696E654E756D62657228732E706F736974696F6E2E6C696E654E756D626572293B6966286E3C3D6F26266F3C3D6E2B732E68656967687429726574';
wwv_flow_imp.g_varchar2_table(14646) := '75726E20742E66756C66696C6C436F6E74656E745465787428732E706F736974696F6E2C6E756C6C2C7B6D696768744265466F726569676E456C656D656E743A21312C696E6A6563746564546578743A6E756C6C7D297D7D72657475726E206E756C6C7D';
wwv_flow_imp.g_varchar2_table(14647) := '737461746963205F68697454657374566965775A6F6E6528652C74297B636F6E7374206E3D652E6765745A6F6E654174436F6F726428742E6D6F757365566572746963616C4F6666736574293B6966286E297B636F6E737420653D742E6973496E436F6E';
wwv_flow_imp.g_varchar2_table(14648) := '74656E74417265613F383A353B72657475726E20742E66756C66696C6C566965775A6F6E6528652C6E2E706F736974696F6E2C6E297D72657475726E206E756C6C7D737461746963205F68697454657374546578744172656128652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(14649) := '6E20424E2E6973546578744172656128742E74617267657450617468293F652E6C61737452656E646572446174612E6C6173745465787461726561506F736974696F6E3F742E66756C66696C6C436F6E74656E745465787428652E6C61737452656E6465';
wwv_flow_imp.g_varchar2_table(14650) := '72446174612E6C6173745465787461726561506F736974696F6E2C6E756C6C2C7B6D696768744265466F726569676E456C656D656E743A21312C696E6A6563746564546578743A6E756C6C7D293A742E66756C66696C6C546578746172656128293A6E75';
wwv_flow_imp.g_varchar2_table(14651) := '6C6C7D737461746963205F686974546573744D617267696E28652C74297B696628742E6973496E4D617267696E41726561297B636F6E7374206E3D652E67657446756C6C4C696E6552616E67654174436F6F726428742E6D6F757365566572746963616C';
wwv_flow_imp.g_varchar2_table(14652) := '4F6666736574292C693D6E2E72616E67652E6765745374617274506F736974696F6E28293B6C6574206F3D4D6174682E61627328742E72656C6174697665506F732E78293B636F6E737420733D7B697341667465724C696E65733A6E2E69734166746572';
wwv_flow_imp.g_varchar2_table(14653) := '4C696E65732C676C7970684D617267696E4C6566743A652E6C61796F7574496E666F2E676C7970684D617267696E4C6566742C676C7970684D617267696E57696474683A652E6C61796F7574496E666F2E676C7970684D617267696E57696474682C6C69';
wwv_flow_imp.g_varchar2_table(14654) := '6E654E756D6265727357696474683A652E6C61796F7574496E666F2E6C696E654E756D6265727357696474682C6F6666736574583A6F7D3B6966286F2D3D652E6C61796F7574496E666F2E676C7970684D617267696E4C6566742C6F3C3D652E6C61796F';
wwv_flow_imp.g_varchar2_table(14655) := '7574496E666F2E676C7970684D617267696E5769647468297B636F6E737420723D652E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E';
wwv_flow_imp.g_varchar2_table(14656) := '286E2E72616E67652E6765745374617274506F736974696F6E2829292C613D652E766965774D6F64656C2E676C7970684C616E65732E6765744C616E657341744C696E6528722E6C696E654E756D626572293B72657475726E20732E676C7970684D6172';
wwv_flow_imp.g_varchar2_table(14657) := '67696E4C616E653D615B4D6174682E666C6F6F72286F2F652E6C696E65486569676874295D2C742E66756C66696C6C4D617267696E28322C692C6E2E72616E67652C73297D72657475726E206F2D3D652E6C61796F7574496E666F2E676C7970684D6172';
wwv_flow_imp.g_varchar2_table(14658) := '67696E57696474682C6F3C3D652E6C61796F7574496E666F2E6C696E654E756D6265727357696474683F742E66756C66696C6C4D617267696E28332C692C6E2E72616E67652C73293A286F2D3D652E6C61796F7574496E666F2E6C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(14659) := '7357696474682C742E66756C66696C6C4D617267696E28342C692C6E2E72616E67652C7329297D72657475726E206E756C6C7D737461746963205F68697454657374566965774C696E657328652C74297B69662821424E2E69734368696C644F66566965';
wwv_flow_imp.g_varchar2_table(14660) := '774C696E657328742E74617267657450617468292972657475726E206E756C6C3B696628652E6973496E546F7050616464696E6728742E6D6F757365566572746963616C4F6666736574292972657475726E20742E66756C66696C6C436F6E74656E7445';
wwv_flow_imp.g_varchar2_table(14661) := '6D707479286E6577206D6328312C31292C574E293B696628652E697341667465724C696E657328742E6D6F757365566572746963616C4F6666736574297C7C652E6973496E426F74746F6D50616464696E6728742E6D6F757365566572746963616C4F66';
wwv_flow_imp.g_varchar2_table(14662) := '6673657429297B636F6E7374206E3D652E766965774D6F64656C2E6765744C696E65436F756E7428292C693D652E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E286E293B72657475726E20742E66756C66696C6C436F6E74656E7445';
wwv_flow_imp.g_varchar2_table(14663) := '6D707479286E6577206D63286E2C69292C574E297D696628424E2E69735374726963744368696C644F66566965774C696E657328742E7461726765745061746829297B636F6E7374206E3D652E6765744C696E654E756D6265724174566572746963616C';
wwv_flow_imp.g_varchar2_table(14664) := '4F666673657428742E6D6F757365566572746963616C4F6666736574293B696628303D3D3D652E766965774D6F64656C2E6765744C696E654C656E677468286E29297B636F6E737420693D652E6765744C696E655769647468286E292C6F3D6A4E28742E';
wwv_flow_imp.g_varchar2_table(14665) := '6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365742D69293B72657475726E20742E66756C66696C6C436F6E74656E74456D707479286E6577206D63286E2C31292C6F297D636F6E737420693D652E6765744C696E655769647468286E';
wwv_flow_imp.g_varchar2_table(14666) := '293B696628742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365743E3D69297B636F6E7374206F3D6A4E28742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365742D69292C733D6E6577206D63286E2C652E7669';
wwv_flow_imp.g_varchar2_table(14667) := '65774D6F64656C2E6765744C696E654D6178436F6C756D6E286E29293B72657475726E20742E66756C66696C6C436F6E74656E74456D70747928732C6F297D7D636F6E7374206E3D742E68697454657374526573756C742E76616C75653B72657475726E';
wwv_flow_imp.g_varchar2_table(14668) := '20313D3D3D6E2E747970653F714E2E6372656174654D6F75736554617267657446726F6D48697454657374506F736974696F6E28652C742C6E2E7370616E4E6F64652C6E2E706F736974696F6E2C6E2E696E6A656374656454657874293A742E776F756C';
wwv_flow_imp.g_varchar2_table(14669) := '6442656E6566697446726F6D486974546573745461726765745377697463683F28742E737769746368546F4869745465737454617267657428292C746869732E5F6372656174654D6F75736554617267657428652C7429293A742E66756C66696C6C556E';
wwv_flow_imp.g_varchar2_table(14670) := '6B6E6F776E28297D737461746963205F686974546573744D696E696D617028652C74297B696628424E2E69734368696C644F664D696E696D617028742E7461726765745061746829297B636F6E7374206E3D652E6765744C696E654E756D626572417456';
wwv_flow_imp.g_varchar2_table(14671) := '6572746963616C4F666673657428742E6D6F757365566572746963616C4F6666736574292C693D652E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E286E293B72657475726E20742E66756C66696C6C5363726F6C6C626172286E6577';
wwv_flow_imp.g_varchar2_table(14672) := '206D63286E2C6929297D72657475726E206E756C6C7D737461746963205F686974546573745363726F6C6C626172536C6964657228652C74297B696628424E2E69734368696C644F665363726F6C6C61626C65456C656D656E7428742E74617267657450';
wwv_flow_imp.g_varchar2_table(14673) := '617468292626742E7461726765742626313D3D3D742E7461726765742E6E6F646554797065297B636F6E7374206E3D742E7461726765742E636C6173734E616D653B6966286E26262F5C6228736C696465727C7363726F6C6C626172295C622F2E746573';
wwv_flow_imp.g_varchar2_table(14674) := '74286E29297B636F6E7374206E3D652E6765744C696E654E756D6265724174566572746963616C4F666673657428742E6D6F757365566572746963616C4F6666736574292C693D652E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(14675) := '6E293B72657475726E20742E66756C66696C6C5363726F6C6C626172286E6577206D63286E2C6929297D7D72657475726E206E756C6C7D737461746963205F686974546573745363726F6C6C62617228652C74297B696628424E2E69734368696C644F66';
wwv_flow_imp.g_varchar2_table(14676) := '5363726F6C6C61626C65456C656D656E7428742E7461726765745061746829297B636F6E7374206E3D652E6765744C696E654E756D6265724174566572746963616C4F666673657428742E6D6F757365566572746963616C4F6666736574292C693D652E';
wwv_flow_imp.g_varchar2_table(14677) := '766965774D6F64656C2E6765744C696E654D6178436F6C756D6E286E293B72657475726E20742E66756C66696C6C5363726F6C6C626172286E6577206D63286E2C6929297D72657475726E206E756C6C7D6765744D6F757365436F6C756D6E2865297B63';
wwv_flow_imp.g_varchar2_table(14678) := '6F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435292C693D746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E745363726F6C6C4C';
wwv_flow_imp.g_varchar2_table(14679) := '65667428292B652E782D6E2E636F6E74656E744C6566743B72657475726E20714E2E5F6765744D6F757365436F6C756D6E28692C742E676574283530292E7479706963616C48616C6677696474684368617261637465725769647468297D737461746963';
wwv_flow_imp.g_varchar2_table(14680) := '205F6765744D6F757365436F6C756D6E28652C74297B72657475726E20653C303F313A4D6174682E726F756E6428652F74292B317D737461746963206372656174654D6F75736554617267657446726F6D48697454657374506F736974696F6E28652C74';
wwv_flow_imp.g_varchar2_table(14681) := '2C6E2C692C6F297B636F6E737420733D692E6C696E654E756D6265722C723D692E636F6C756D6E2C613D652E6765744C696E6557696474682873293B696628742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365743E61297B636F6E';
wwv_flow_imp.g_varchar2_table(14682) := '737420653D6A4E28742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365742D61293B72657475726E20742E66756C66696C6C436F6E74656E74456D70747928692C65297D636F6E7374206C3D652E76697369626C6552616E6765466F';
wwv_flow_imp.g_varchar2_table(14683) := '72506F736974696F6E28732C72293B696628216C2972657475726E20742E66756C66696C6C556E6B6E6F776E2869293B636F6E737420633D6C2E6C6566743B6966284D6174682E61627328742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F';
wwv_flow_imp.g_varchar2_table(14684) := '66667365742D63293C312972657475726E20742E66756C66696C6C436F6E74656E745465787428692C6E756C6C2C7B6D696768744265466F726569676E456C656D656E743A21216F2C696E6A6563746564546578743A6F7D293B636F6E737420643D5B5D';
wwv_flow_imp.g_varchar2_table(14685) := '3B696628642E70757368287B6F66667365743A6C2E6C6566742C636F6C756D6E3A727D292C723E31297B636F6E737420743D652E76697369626C6552616E6765466F72506F736974696F6E28732C722D31293B742626642E70757368287B6F6666736574';
wwv_flow_imp.g_varchar2_table(14686) := '3A742E6C6566742C636F6C756D6E3A722D317D297D696628723C652E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E287329297B636F6E737420743D652E76697369626C6552616E6765466F72506F736974696F6E28732C722B31293B';
wwv_flow_imp.g_varchar2_table(14687) := '742626642E70757368287B6F66667365743A742E6C6566742C636F6C756D6E3A722B317D297D642E736F7274282828652C74293D3E652E6F66667365742D742E6F666673657429293B636F6E737420683D742E706F732E746F436C69656E74436F6F7264';
wwv_flow_imp.g_varchar2_table(14688) := '696E6174657328727328652E76696577446F6D4E6F646529292C753D6E2E676574426F756E64696E67436C69656E745265637428292C703D752E6C6566743C3D682E636C69656E74582626682E636C69656E74583C3D752E72696768743B6C657420673D';
wwv_flow_imp.g_varchar2_table(14689) := '6E756C6C3B666F72286C657420653D313B653C642E6C656E6774683B652B2B297B636F6E7374206E3D645B652D315D2C6F3D645B655D3B6966286E2E6F66667365743C3D742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365742626';
wwv_flow_imp.g_varchar2_table(14690) := '742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F66667365743C3D6F2E6F6666736574297B673D6E657720726828732C6E2E636F6C756D6E2C732C6F2E636F6C756D6E293B636F6E737420653D4D6174682E616273286E2E6F66667365742D';
wwv_flow_imp.g_varchar2_table(14691) := '742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F6666736574292C723D4D6174682E616273286F2E6F66667365742D742E6D6F757365436F6E74656E74486F72697A6F6E74616C4F6666736574293B693D6E6577206D6328732C653C723F6E';
wwv_flow_imp.g_varchar2_table(14692) := '2E636F6C756D6E3A6F2E636F6C756D6E293B627265616B7D7D72657475726E20742E66756C66696C6C436F6E74656E745465787428692C672C7B6D696768744265466F726569676E456C656D656E743A21707C7C21216F2C696E6A656374656454657874';
wwv_flow_imp.g_varchar2_table(14693) := '3A6F7D297D737461746963205F646F4869745465737457697468436172657452616E676546726F6D506F696E7428652C74297B636F6E7374206E3D652E6765744C696E654E756D6265724174566572746963616C4F666673657428742E6D6F7573655665';
wwv_flow_imp.g_varchar2_table(14694) := '72746963616C4F6666736574292C693D652E676574566572746963616C4F6666736574466F724C696E654E756D626572286E292C6F3D692B652E6C696E654865696768743B69662821286E3D3D3D652E766965774D6F64656C2E6765744C696E65436F75';
wwv_flow_imp.g_varchar2_table(14695) := '6E7428292626742E6D6F757365566572746963616C4F66667365743E6F29297B636F6E7374206E3D4D6174682E666C6F6F722828692B6F292F32293B6C657420733D742E706F732E792B286E2D742E6D6F757365566572746963616C4F6666736574293B';
wwv_flow_imp.g_varchar2_table(14696) := '733C3D742E656469746F72506F732E79262628733D742E656469746F72506F732E792B31292C733E3D742E656469746F72506F732E792B742E656469746F72506F732E686569676874262628733D742E656469746F72506F732E792B742E656469746F72';
wwv_flow_imp.g_varchar2_table(14697) := '506F732E6865696768742D31293B636F6E737420723D6E657720564128742E706F732E782C73292C613D746869732E5F61637475616C446F4869745465737457697468436172657452616E676546726F6D506F696E7428652C722E746F436C69656E7443';
wwv_flow_imp.g_varchar2_table(14698) := '6F6F7264696E6174657328727328652E76696577446F6D4E6F64652929293B696628313D3D3D612E747970652972657475726E20617D72657475726E20746869732E5F61637475616C446F4869745465737457697468436172657452616E676546726F6D';
wwv_flow_imp.g_varchar2_table(14699) := '506F696E7428652C742E706F732E746F436C69656E74436F6F7264696E6174657328727328652E76696577446F6D4E6F64652929297D737461746963205F61637475616C446F4869745465737457697468436172657452616E676546726F6D506F696E74';
wwv_flow_imp.g_varchar2_table(14700) := '28652C74297B636F6E7374206E3D577328652E76696577446F6D4E6F6465293B6C657420693B696628693D6E3F766F696420303D3D3D6E2E636172657452616E676546726F6D506F696E743F66756E6374696F6E28652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(14701) := '646F63756D656E742E63726561746552616E676528293B6C6574206F3D652E656C656D656E7446726F6D506F696E7428742C6E293B6966286E756C6C213D3D6F297B666F72283B6F26266F2E66697273744368696C6426266F2E66697273744368696C64';
wwv_flow_imp.g_varchar2_table(14702) := '2E6E6F646554797065213D3D6F2E66697273744368696C642E544558545F4E4F444526266F2E6C6173744368696C6426266F2E6C6173744368696C642E66697273744368696C643B296F3D6F2E6C6173744368696C643B636F6E737420653D6F2E676574';
wwv_flow_imp.g_varchar2_table(14703) := '426F756E64696E67436C69656E745265637428292C6E3D7273286F292C733D60247B6E2E676574436F6D70757465645374796C65286F2C6E756C6C292E67657450726F706572747956616C75652822666F6E742D7374796C6522297D20247B6E2E676574';
wwv_flow_imp.g_varchar2_table(14704) := '436F6D70757465645374796C65286F2C6E756C6C292E67657450726F706572747956616C75652822666F6E742D76617269616E7422297D20247B6E2E676574436F6D70757465645374796C65286F2C6E756C6C292E67657450726F706572747956616C75';
wwv_flow_imp.g_varchar2_table(14705) := '652822666F6E742D77656967687422297D20247B6E2E676574436F6D70757465645374796C65286F2C6E756C6C292E67657450726F706572747956616C75652822666F6E742D73697A6522297D2F247B6E2E676574436F6D70757465645374796C65286F';
wwv_flow_imp.g_varchar2_table(14706) := '2C6E756C6C292E67657450726F706572747956616C756528226C696E652D68656967687422297D20247B6E2E676574436F6D70757465645374796C65286F2C6E756C6C292E67657450726F706572747956616C75652822666F6E742D66616D696C792229';
wwv_flow_imp.g_varchar2_table(14707) := '7D602C723D6F2E696E6E6572546578743B6C657420612C6C3D652E6C6566742C633D303B696628743E652E6C6566742B652E776964746829633D722E6C656E6774683B656C73657B636F6E737420653D244E2E676574496E7374616E636528293B666F72';
wwv_flow_imp.g_varchar2_table(14708) := '286C6574206E3D303B6E3C722E6C656E6774682B313B6E2B2B297B696628613D652E67657443686172576964746828722E636861724174286E292C73292F322C6C2B3D612C743C6C297B633D6E3B627265616B7D6C2B3D617D7D692E7365745374617274';
wwv_flow_imp.g_varchar2_table(14709) := '286F2E66697273744368696C642C63292C692E736574456E64286F2E66697273744368696C642C63297D72657475726E20697D286E2C742E636C69656E74582C742E636C69656E7459293A6E2E636172657452616E676546726F6D506F696E7428742E63';
wwv_flow_imp.g_varchar2_table(14710) := '6C69656E74582C742E636C69656E7459293A652E76696577446F6D4E6F64652E6F776E6572446F63756D656E742E636172657452616E676546726F6D506F696E7428742E636C69656E74582C742E636C69656E7459292C21697C7C21692E737461727443';
wwv_flow_imp.g_varchar2_table(14711) := '6F6E7461696E65722972657475726E206E6577204E4E3B636F6E7374206F3D692E7374617274436F6E7461696E65723B6966286F2E6E6F6465547970653D3D3D6F2E544558545F4E4F4445297B636F6E737420743D6F2E706172656E744E6F64652C6E3D';
wwv_flow_imp.g_varchar2_table(14712) := '743F742E706172656E744E6F64653A6E756C6C2C733D6E3F6E2E706172656E744E6F64653A6E756C6C3B72657475726E28732626732E6E6F6465547970653D3D3D732E454C454D454E545F4E4F44453F732E636C6173734E616D653A6E756C6C293D3D3D';
wwv_flow_imp.g_varchar2_table(14713) := '4C4E2E434C4153535F4E414D453F4F4E2E63726561746546726F6D444F4D496E666F28652C742C692E73746172744F6666736574293A6E6577204E4E286F2E706172656E744E6F6465297D6966286F2E6E6F6465547970653D3D3D6F2E454C454D454E54';
wwv_flow_imp.g_varchar2_table(14714) := '5F4E4F4445297B636F6E737420743D6F2E706172656E744E6F64652C6E3D743F742E706172656E744E6F64653A6E756C6C3B72657475726E286E26266E2E6E6F6465547970653D3D3D6E2E454C454D454E545F4E4F44453F6E2E636C6173734E616D653A';
wwv_flow_imp.g_varchar2_table(14715) := '6E756C6C293D3D3D4C4E2E434C4153535F4E414D453F4F4E2E63726561746546726F6D444F4D496E666F28652C6F2C6F2E74657874436F6E74656E742E6C656E677468293A6E6577204E4E286F297D72657475726E206E6577204E4E7D73746174696320';
wwv_flow_imp.g_varchar2_table(14716) := '5F646F48697454657374576974684361726574506F736974696F6E46726F6D506F696E7428652C74297B636F6E7374206E3D652E76696577446F6D4E6F64652E6F776E6572446F63756D656E742E6361726574506F736974696F6E46726F6D506F696E74';
wwv_flow_imp.g_varchar2_table(14717) := '28742E636C69656E74582C742E636C69656E7459293B6966286E2E6F66667365744E6F64652E6E6F6465547970653D3D3D6E2E6F66667365744E6F64652E544558545F4E4F4445297B636F6E737420743D6E2E6F66667365744E6F64652E706172656E74';
wwv_flow_imp.g_varchar2_table(14718) := '4E6F64652C693D743F742E706172656E744E6F64653A6E756C6C2C6F3D693F692E706172656E744E6F64653A6E756C6C3B72657475726E286F26266F2E6E6F6465547970653D3D3D6F2E454C454D454E545F4E4F44453F6F2E636C6173734E616D653A6E';
wwv_flow_imp.g_varchar2_table(14719) := '756C6C293D3D3D4C4E2E434C4153535F4E414D453F4F4E2E63726561746546726F6D444F4D496E666F28652C6E2E6F66667365744E6F64652E706172656E744E6F64652C6E2E6F6666736574293A6E6577204E4E286E2E6F66667365744E6F64652E7061';
wwv_flow_imp.g_varchar2_table(14720) := '72656E744E6F6465297D6966286E2E6F66667365744E6F64652E6E6F6465547970653D3D3D6E2E6F66667365744E6F64652E454C454D454E545F4E4F4445297B636F6E737420743D6E2E6F66667365744E6F64652E706172656E744E6F64652C693D7426';
wwv_flow_imp.g_varchar2_table(14721) := '26742E6E6F6465547970653D3D3D742E454C454D454E545F4E4F44453F742E636C6173734E616D653A6E756C6C2C6F3D743F742E706172656E744E6F64653A6E756C6C2C733D6F26266F2E6E6F6465547970653D3D3D6F2E454C454D454E545F4E4F4445';
wwv_flow_imp.g_varchar2_table(14722) := '3F6F2E636C6173734E616D653A6E756C6C3B696628693D3D3D4C4E2E434C4153535F4E414D45297B636F6E737420743D6E2E6F66667365744E6F64652E6368696C644E6F6465735B4D6174682E6D696E286E2E6F66667365742C6E2E6F66667365744E6F';
wwv_flow_imp.g_varchar2_table(14723) := '64652E6368696C644E6F6465732E6C656E6774682D31295D3B696628742972657475726E204F4E2E63726561746546726F6D444F4D496E666F28652C742C30297D656C736520696628733D3D3D4C4E2E434C4153535F4E414D452972657475726E204F4E';
wwv_flow_imp.g_varchar2_table(14724) := '2E63726561746546726F6D444F4D496E666F28652C6E2E6F66667365744E6F64652C30297D72657475726E206E6577204E4E286E2E6F66667365744E6F6465297D737461746963205F736E6170546F536F6674546162426F756E6461727928652C74297B';
wwv_flow_imp.g_varchar2_table(14725) := '636F6E7374206E3D742E6765744C696E65436F6E74656E7428652E6C696E654E756D626572292C7B74616253697A653A697D3D742E6D6F64656C2E6765744F7074696F6E7328292C6F3D61532E61746F6D6963506F736974696F6E286E2C652E636F6C75';
wwv_flow_imp.g_varchar2_table(14726) := '6D6E2D312C692C32293B72657475726E2D31213D3D6F3F6E6577206D6328652E6C696E654E756D6265722C6F2B31293A657D73746174696320646F4869745465737428652C74297B6C6574206E3D6E6577204E4E3B6966282266756E6374696F6E223D3D';
wwv_flow_imp.g_varchar2_table(14727) := '747970656F6620652E76696577446F6D4E6F64652E6F776E6572446F63756D656E742E636172657452616E676546726F6D506F696E743F6E3D746869732E5F646F4869745465737457697468436172657452616E676546726F6D506F696E7428652C7429';
wwv_flow_imp.g_varchar2_table(14728) := '3A652E76696577446F6D4E6F64652E6F776E6572446F63756D656E742E6361726574506F736974696F6E46726F6D506F696E742626286E3D746869732E5F646F48697454657374576974684361726574506F736974696F6E46726F6D506F696E7428652C';
wwv_flow_imp.g_varchar2_table(14729) := '742E706F732E746F436C69656E74436F6F7264696E6174657328727328652E76696577446F6D4E6F6465292929292C313D3D3D6E2E74797065297B636F6E737420743D652E766965774D6F64656C2E676574496E6A6563746564546578744174286E2E70';
wwv_flow_imp.g_varchar2_table(14730) := '6F736974696F6E292C693D652E766965774D6F64656C2E6E6F726D616C697A65506F736974696F6E286E2E706F736974696F6E2C32293B21742626692E657175616C73286E2E706F736974696F6E297C7C286E3D6E657720504E28692C6E2E7370616E4E';
wwv_flow_imp.g_varchar2_table(14731) := '6F64652C7429297D72657475726E206E7D7D636C61737320244E7B73746174696320676574496E7374616E636528297B72657475726E20244E2E5F494E5354414E43457C7C28244E2E5F494E5354414E43453D6E657720244E292C244E2E5F494E535441';
wwv_flow_imp.g_varchar2_table(14732) := '4E43457D636F6E7374727563746F7228297B746869732E5F63616368653D7B7D2C746869732E5F63616E7661733D646F63756D656E742E637265617465456C656D656E74282263616E76617322297D67657443686172576964746828652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(14733) := '7374206E3D652B743B696628746869732E5F63616368655B6E5D2972657475726E20746869732E5F63616368655B6E5D3B636F6E737420693D746869732E5F63616E7661732E676574436F6E746578742822326422293B692E666F6E743D743B636F6E73';
wwv_flow_imp.g_varchar2_table(14734) := '74206F3D692E6D656173757265546578742865292E77696474683B72657475726E20746869732E5F63616368655B6E5D3D6F2C6F7D7D244E2E5F494E5354414E43453D6E756C6C3B636C61737320554E20657874656E64732058417B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(14735) := '746F7228652C742C6E297B737570657228292C746869732E5F6D6F7573654C656176654D6F6E69746F723D6E756C6C2C746869732E5F636F6E746578743D652C746869732E76696577436F6E74726F6C6C65723D742C746869732E7669657748656C7065';
wwv_flow_imp.g_varchar2_table(14736) := '723D6E2C746869732E6D6F757365546172676574466163746F72793D6E657720714E28746869732E5F636F6E746578742C6E292C746869732E5F6D6F757365446F776E4F7065726174696F6E3D746869732E5F7265676973746572286E6577204B4E2874';
wwv_flow_imp.g_varchar2_table(14737) := '6869732E5F636F6E746578742C746869732E76696577436F6E74726F6C6C65722C746869732E7669657748656C7065722C746869732E6D6F757365546172676574466163746F72792C2828652C74293D3E746869732E5F6372656174654D6F7573655461';
wwv_flow_imp.g_varchar2_table(14738) := '7267657428652C7429292C28653D3E746869732E5F6765744D6F757365436F6C756D6E2865292929292C746869732E6C6173744D6F7573654C6561766554696D653D2D312C746869732E5F6865696768743D746869732E5F636F6E746578742E636F6E66';
wwv_flow_imp.g_varchar2_table(14739) := '696775726174696F6E2E6F7074696F6E732E67657428313435292E6865696768743B636F6E737420693D6E657720554128746869732E7669657748656C7065722E76696577446F6D4E6F6465293B746869732E5F726567697374657228692E6F6E436F6E';
wwv_flow_imp.g_varchar2_table(14740) := '746578744D656E7528746869732E7669657748656C7065722E76696577446F6D4E6F64652C28653D3E746869732E5F6F6E436F6E746578744D656E7528652C2130292929292C746869732E5F726567697374657228692E6F6E4D6F7573654D6F76652874';
wwv_flow_imp.g_varchar2_table(14741) := '6869732E7669657748656C7065722E76696577446F6D4E6F64652C28653D3E7B746869732E5F6F6E4D6F7573654D6F76652865292C746869732E5F6D6F7573654C656176654D6F6E69746F727C7C28746869732E5F6D6F7573654C656176654D6F6E6974';
wwv_flow_imp.g_varchar2_table(14742) := '6F723D627328746869732E7669657748656C7065722E76696577446F6D4E6F64652E6F776E6572446F63756D656E742C226D6F7573656D6F7665222C28653D3E7B746869732E7669657748656C7065722E76696577446F6D4E6F64652E636F6E7461696E';
wwv_flow_imp.g_varchar2_table(14743) := '7328652E746172676574297C7C746869732E5F6F6E4D6F7573654C65617665286E657720244128652C21312C746869732E7669657748656C7065722E76696577446F6D4E6F646529297D2929297D2929292C746869732E5F726567697374657228692E6F';
wwv_flow_imp.g_varchar2_table(14744) := '6E4D6F757365557028746869732E7669657748656C7065722E76696577446F6D4E6F64652C28653D3E746869732E5F6F6E4D6F75736555702865292929292C746869732E5F726567697374657228692E6F6E4D6F7573654C6561766528746869732E7669';
wwv_flow_imp.g_varchar2_table(14745) := '657748656C7065722E76696577446F6D4E6F64652C28653D3E746869732E5F6F6E4D6F7573654C656176652865292929293B6C6574206F3D303B746869732E5F726567697374657228692E6F6E506F696E746572446F776E28746869732E766965774865';
wwv_flow_imp.g_varchar2_table(14746) := '6C7065722E76696577446F6D4E6F64652C2828652C74293D3E7B6F3D747D2929292C746869732E5F726567697374657228627328746869732E7669657748656C7065722E76696577446F6D4E6F64652C61722E504F494E5445525F55502C28653D3E7B74';
wwv_flow_imp.g_varchar2_table(14747) := '6869732E5F6D6F757365446F776E4F7065726174696F6E2E6F6E506F696E746572557028297D2929292C746869732E5F726567697374657228692E6F6E4D6F757365446F776E28746869732E7669657748656C7065722E76696577446F6D4E6F64652C28';
wwv_flow_imp.g_varchar2_table(14748) := '653D3E746869732E5F6F6E4D6F757365446F776E28652C6F292929292C746869732E5F73657475704D6F757365576865656C5A6F6F6D4C697374656E657228292C746869732E5F636F6E746578742E6164644576656E7448616E646C6572287468697329';
wwv_flow_imp.g_varchar2_table(14749) := '7D5F73657475704D6F757365576865656C5A6F6F6D4C697374656E657228297B636F6E737420653D64542E494E5354414E43453B6C657420743D302C6E3D43412E6765745A6F6F6D4C6576656C28292C693D21312C6F3D303B66756E6374696F6E207328';
wwv_flow_imp.g_varchar2_table(14750) := '65297B72657475726E20713F28652E6D6574614B65797C7C652E6374726C4B657929262621652E73686966744B6579262621652E616C744B65793A652E6374726C4B6579262621652E6D6574614B6579262621652E73686966744B6579262621652E616C';
wwv_flow_imp.g_varchar2_table(14751) := '744B65797D746869732E5F726567697374657228627328746869732E7669657748656C7065722E76696577446F6D4E6F64652C61722E4D4F5553455F574845454C2C28723D3E7B696628746869732E76696577436F6E74726F6C6C65722E656D69744D6F';
wwv_flow_imp.g_varchar2_table(14752) := '757365576865656C2872292C21746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E676574283736292972657475726E3B636F6E737420613D6E65772051652872293B696628652E6163636570745374616E646172';
wwv_flow_imp.g_varchar2_table(14753) := '64576865656C4576656E742861292C652E6973506879736963616C4D6F757365576865656C2829297B69662873287229297B636F6E737420653D43412E6765745A6F6F6D4C6576656C28292C743D612E64656C7461593E303F313A2D313B43412E736574';
wwv_flow_imp.g_varchar2_table(14754) := '5A6F6F6D4C6576656C28652B74292C612E70726576656E7444656661756C7428292C612E73746F7050726F7061676174696F6E28297D7D656C736520446174652E6E6F7728292D743E35302626286E3D43412E6765745A6F6F6D4C6576656C28292C693D';
wwv_flow_imp.g_varchar2_table(14755) := '732872292C6F3D30292C743D446174652E6E6F7728292C6F2B3D612E64656C7461592C6926262843412E7365745A6F6F6D4C6576656C286E2B6F2F35292C612E70726576656E7444656661756C7428292C612E73746F7050726F7061676174696F6E2829';
wwv_flow_imp.g_varchar2_table(14756) := '297D292C7B636170747572653A21302C706173736976653A21317D29297D646973706F736528297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E5F6D6F7573654C656176654D6F6E6974';
wwv_flow_imp.g_varchar2_table(14757) := '6F72262628746869732E5F6D6F7573654C656176654D6F6E69746F722E646973706F736528292C746869732E5F6D6F7573654C656176654D6F6E69746F723D6E756C6C292C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(14758) := '4368616E6765642865297B696628652E6861734368616E6765642831343529297B636F6E737420653D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435292E6865696768743B746869732E5F68';
wwv_flow_imp.g_varchar2_table(14759) := '6569676874213D3D65262628746869732E5F6865696768743D652C746869732E5F6D6F757365446F776E4F7065726174696F6E2E6F6E4865696768744368616E6765642829297D72657475726E21317D6F6E437572736F7253746174654368616E676564';
wwv_flow_imp.g_varchar2_table(14760) := '2865297B72657475726E20746869732E5F6D6F757365446F776E4F7065726174696F6E2E6F6E437572736F7253746174654368616E6765642865292C21317D6F6E466F6375734368616E6765642865297B72657475726E21317D67657454617267657441';
wwv_flow_imp.g_varchar2_table(14761) := '74436C69656E74506F696E7428652C74297B636F6E7374206E3D6E6577207A4128652C74292E746F50616765436F6F7264696E6174657328727328746869732E7669657748656C7065722E76696577446F6D4E6F646529292C693D6A4128746869732E76';
wwv_flow_imp.g_varchar2_table(14762) := '69657748656C7065722E76696577446F6D4E6F6465293B6966286E2E793C692E797C7C6E2E793E692E792B692E6865696768747C7C6E2E783C692E787C7C6E2E783E692E782B692E77696474682972657475726E206E756C6C3B636F6E7374206F3D7141';
wwv_flow_imp.g_varchar2_table(14763) := '28746869732E7669657748656C7065722E76696577446F6D4E6F64652C692C6E293B72657475726E20746869732E6D6F757365546172676574466163746F72792E6372656174654D6F75736554617267657428746869732E7669657748656C7065722E67';
wwv_flow_imp.g_varchar2_table(14764) := '65744C61737452656E6465724461746128292C692C6E2C6F2C6E756C6C297D5F6372656174654D6F75736554617267657428652C74297B6C6574206E3D652E7461726765743B69662821746869732E7669657748656C7065722E76696577446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(14765) := '652E636F6E7461696E73286E29297B636F6E737420743D577328746869732E7669657748656C7065722E76696577446F6D4E6F6465293B742626286E3D742E656C656D656E747346726F6D506F696E7428652E706F73782C652E706F7379292E66696E64';
wwv_flow_imp.g_varchar2_table(14766) := '2828653D3E746869732E7669657748656C7065722E76696577446F6D4E6F64652E636F6E7461696E732865292929297D72657475726E20746869732E6D6F757365546172676574466163746F72792E6372656174654D6F75736554617267657428746869';
wwv_flow_imp.g_varchar2_table(14767) := '732E7669657748656C7065722E6765744C61737452656E6465724461746128292C652E656469746F72506F732C652E706F732C652E72656C6174697665506F732C743F6E3A6E756C6C297D5F6765744D6F757365436F6C756D6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(14768) := '20746869732E6D6F757365546172676574466163746F72792E6765744D6F757365436F6C756D6E28652E72656C6174697665506F73297D5F6F6E436F6E746578744D656E7528652C74297B746869732E76696577436F6E74726F6C6C65722E656D697443';
wwv_flow_imp.g_varchar2_table(14769) := '6F6E746578744D656E75287B6576656E743A652C7461726765743A746869732E5F6372656174654D6F75736554617267657428652C74297D297D5F6F6E4D6F7573654D6F76652865297B746869732E6D6F757365546172676574466163746F72792E6D6F';
wwv_flow_imp.g_varchar2_table(14770) := '75736554617267657449735769646765742865297C7C652E70726576656E7444656661756C7428292C746869732E5F6D6F757365446F776E4F7065726174696F6E2E697341637469766528297C7C652E74696D657374616D703C746869732E6C6173744D';
wwv_flow_imp.g_varchar2_table(14771) := '6F7573654C6561766554696D657C7C746869732E76696577436F6E74726F6C6C65722E656D69744D6F7573654D6F7665287B6576656E743A652C7461726765743A746869732E5F6372656174654D6F75736554617267657428652C2130297D297D5F6F6E';
wwv_flow_imp.g_varchar2_table(14772) := '4D6F7573654C656176652865297B746869732E5F6D6F7573654C656176654D6F6E69746F72262628746869732E5F6D6F7573654C656176654D6F6E69746F722E646973706F736528292C746869732E5F6D6F7573654C656176654D6F6E69746F723D6E75';
wwv_flow_imp.g_varchar2_table(14773) := '6C6C292C746869732E6C6173744D6F7573654C6561766554696D653D286E65772044617465292E67657454696D6528292C746869732E76696577436F6E74726F6C6C65722E656D69744D6F7573654C65617665287B6576656E743A652C7461726765743A';
wwv_flow_imp.g_varchar2_table(14774) := '6E756C6C7D297D5F6F6E4D6F75736555702865297B746869732E76696577436F6E74726F6C6C65722E656D69744D6F7573655570287B6576656E743A652C7461726765743A746869732E5F6372656174654D6F75736554617267657428652C2130297D29';
wwv_flow_imp.g_varchar2_table(14775) := '7D5F6F6E4D6F757365446F776E28652C74297B636F6E7374206E3D746869732E5F6372656174654D6F75736554617267657428652C2130292C693D363D3D3D6E2E747970657C7C373D3D3D6E2E747970652C6F3D323D3D3D6E2E747970657C7C333D3D3D';
wwv_flow_imp.g_varchar2_table(14776) := '6E2E747970657C7C343D3D3D6E2E747970652C733D333D3D3D6E2E747970652C723D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313039292C613D383D3D3D6E2E747970657C7C353D3D3D6E2E74';
wwv_flow_imp.g_varchar2_table(14777) := '7970652C6C3D393D3D3D6E2E747970653B6C657420633D652E6C656674427574746F6E7C7C652E6D6964646C65427574746F6E3B712626652E6C656674427574746F6E2626652E6374726C4B6579262628633D2131293B636F6E737420643D28293D3E7B';
wwv_flow_imp.g_varchar2_table(14778) := '652E70726576656E7444656661756C7428292C746869732E7669657748656C7065722E666F637573546578744172656128297D3B69662863262628697C7C7326267229296428292C746869732E5F6D6F757365446F776E4F7065726174696F6E2E737461';
wwv_flow_imp.g_varchar2_table(14779) := '7274286E2E747970652C652C74293B656C7365206966286F29652E70726576656E7444656661756C7428293B656C73652069662861297B636F6E737420693D6E2E64657461696C3B632626746869732E7669657748656C7065722E73686F756C64537570';
wwv_flow_imp.g_varchar2_table(14780) := '70726573734D6F757365446F776E4F6E566965775A6F6E6528692E766965775A6F6E654964292626286428292C746869732E5F6D6F757365446F776E4F7065726174696F6E2E7374617274286E2E747970652C652C74292C652E70726576656E74446566';
wwv_flow_imp.g_varchar2_table(14781) := '61756C742829297D656C7365206C2626746869732E7669657748656C7065722E73686F756C6453757070726573734D6F757365446F776E4F6E576964676574286E2E64657461696C292626286428292C652E70726576656E7444656661756C742829293B';
wwv_flow_imp.g_varchar2_table(14782) := '746869732E76696577436F6E74726F6C6C65722E656D69744D6F757365446F776E287B6576656E743A652C7461726765743A6E7D297D7D636C617373204B4E20657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B';
wwv_flow_imp.g_varchar2_table(14783) := '737570657228292C746869732E5F636F6E746578743D652C746869732E5F76696577436F6E74726F6C6C65723D742C746869732E5F7669657748656C7065723D6E2C746869732E5F6D6F757365546172676574466163746F72793D692C746869732E5F63';
wwv_flow_imp.g_varchar2_table(14784) := '72656174654D6F7573655461726765743D6F2C746869732E5F6765744D6F757365436F6C756D6E3D732C746869732E5F6D6F7573654D6F76654D6F6E69746F723D746869732E5F7265676973746572286E657720474128746869732E5F7669657748656C';
wwv_flow_imp.g_varchar2_table(14785) := '7065722E76696577446F6D4E6F646529292C746869732E5F746F70426F74746F6D447261675363726F6C6C696E673D746869732E5F7265676973746572286E657720474E28746869732E5F636F6E746578742C746869732E5F7669657748656C7065722C';
wwv_flow_imp.g_varchar2_table(14786) := '746869732E5F6D6F757365546172676574466163746F72792C2828652C742C6E293D3E746869732E5F64697370617463684D6F75736528652C742C6E292929292C746869732E5F6D6F75736553746174653D6E657720594E2C746869732E5F6375727265';
wwv_flow_imp.g_varchar2_table(14787) := '6E7453656C656374696F6E3D6E657720616828312C312C312C31292C746869732E5F69734163746976653D21312C746869732E5F6C6173744D6F7573654576656E743D6E756C6C7D646973706F736528297B73757065722E646973706F736528297D6973';
wwv_flow_imp.g_varchar2_table(14788) := '41637469766528297B72657475726E20746869732E5F69734163746976657D5F6F6E4D6F757365446F776E5468656E4D6F76652865297B746869732E5F6C6173744D6F7573654576656E743D652C746869732E5F6D6F75736553746174652E7365744D6F';
wwv_flow_imp.g_varchar2_table(14789) := '646966696572732865293B636F6E737420743D746869732E5F66696E644D6F757365506F736974696F6E28652C2131293B74262628746869732E5F6D6F75736553746174652E697344726167416E6444726F703F746869732E5F76696577436F6E74726F';
wwv_flow_imp.g_varchar2_table(14790) := '6C6C65722E656D69744D6F75736544726167287B6576656E743A652C7461726765743A747D293A3133213D3D742E747970657C7C2261626F766522213D3D742E6F757473696465506F736974696F6E26262262656C6F7722213D3D742E6F757473696465';
wwv_flow_imp.g_varchar2_table(14791) := '506F736974696F6E3F28746869732E5F746F70426F74746F6D447261675363726F6C6C696E672E73746F7028292C746869732E5F64697370617463684D6F75736528742C21302C3129293A746869732E5F746F70426F74746F6D447261675363726F6C6C';
wwv_flow_imp.g_varchar2_table(14792) := '696E672E737461727428742C6529297D737461727428652C742C6E297B746869732E5F6C6173744D6F7573654576656E743D742C746869732E5F6D6F75736553746174652E736574537461727465644F6E4C696E654E756D6265727328333D3D3D65292C';
wwv_flow_imp.g_varchar2_table(14793) := '746869732E5F6D6F75736553746174652E7365745374617274427574746F6E732874292C746869732E5F6D6F75736553746174652E7365744D6F646966696572732874293B636F6E737420693D746869732E5F66696E644D6F757365506F736974696F6E';
wwv_flow_imp.g_varchar2_table(14794) := '28742C2130293B69662821697C7C21692E706F736974696F6E2972657475726E3B746869732E5F6D6F75736553746174652E747279536574436F756E7428742E64657461696C2C692E706F736974696F6E292C742E64657461696C3D746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(14795) := '75736553746174652E636F756E743B636F6E7374206F3D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B696628216F2E6765742839312926266F2E676574283335292626216F2E676574283232292626217468';
wwv_flow_imp.g_varchar2_table(14796) := '69732E5F6D6F75736553746174652E616C744B65792626742E64657461696C3C32262621746869732E5F6973416374697665262621746869732E5F63757272656E7453656C656374696F6E2E6973456D70747928292626363D3D3D692E74797065262669';
wwv_flow_imp.g_varchar2_table(14797) := '2E706F736974696F6E2626746869732E5F63757272656E7453656C656374696F6E2E636F6E7461696E73506F736974696F6E28692E706F736974696F6E292972657475726E20746869732E5F6D6F75736553746174652E697344726167416E6444726F70';
wwv_flow_imp.g_varchar2_table(14798) := '3D21302C746869732E5F69734163746976653D21302C766F696420746869732E5F6D6F7573654D6F76654D6F6E69746F722E73746172744D6F6E69746F72696E6728746869732E5F7669657748656C7065722E766965774C696E6573446F6D4E6F64652C';
wwv_flow_imp.g_varchar2_table(14799) := '6E2C742E627574746F6E732C28653D3E746869732E5F6F6E4D6F757365446F776E5468656E4D6F7665286529292C28653D3E7B636F6E737420743D746869732E5F66696E644D6F757365506F736974696F6E28746869732E5F6C6173744D6F7573654576';
wwv_flow_imp.g_varchar2_table(14800) := '656E742C2131293B72722865293F746869732E5F76696577436F6E74726F6C6C65722E656D69744D6F75736544726F7043616E63656C656428293A746869732E5F76696577436F6E74726F6C6C65722E656D69744D6F75736544726F70287B6576656E74';
wwv_flow_imp.g_varchar2_table(14801) := '3A746869732E5F6C6173744D6F7573654576656E742C7461726765743A743F746869732E5F6372656174654D6F75736554617267657428746869732E5F6C6173744D6F7573654576656E742C2130293A6E756C6C7D292C746869732E5F73746F7028297D';
wwv_flow_imp.g_varchar2_table(14802) := '29293B746869732E5F6D6F75736553746174652E697344726167416E6444726F703D21312C746869732E5F64697370617463684D6F75736528692C742E73686966744B65792C31292C746869732E5F69734163746976657C7C28746869732E5F69734163';
wwv_flow_imp.g_varchar2_table(14803) := '746976653D21302C746869732E5F6D6F7573654D6F76654D6F6E69746F722E73746172744D6F6E69746F72696E6728746869732E5F7669657748656C7065722E766965774C696E6573446F6D4E6F64652C6E2C742E627574746F6E732C28653D3E746869';
wwv_flow_imp.g_varchar2_table(14804) := '732E5F6F6E4D6F757365446F776E5468656E4D6F7665286529292C2828293D3E746869732E5F73746F7028292929297D5F73746F7028297B746869732E5F69734163746976653D21312C746869732E5F746F70426F74746F6D447261675363726F6C6C69';
wwv_flow_imp.g_varchar2_table(14805) := '6E672E73746F7028297D6F6E4865696768744368616E67656428297B746869732E5F6D6F7573654D6F76654D6F6E69746F722E73746F704D6F6E69746F72696E6728297D6F6E506F696E746572557028297B746869732E5F6D6F7573654D6F76654D6F6E';
wwv_flow_imp.g_varchar2_table(14806) := '69746F722E73746F704D6F6E69746F72696E6728297D6F6E437572736F7253746174654368616E6765642865297B746869732E5F63757272656E7453656C656374696F6E3D652E73656C656374696F6E735B305D7D5F676574506F736974696F6E4F7574';
wwv_flow_imp.g_varchar2_table(14807) := '73696465456469746F722865297B636F6E737420743D652E656469746F72506F732C6E3D746869732E5F636F6E746578742E766965774D6F64656C2C693D746869732E5F636F6E746578742E766965774C61796F75742C6F3D746869732E5F6765744D6F';
wwv_flow_imp.g_varchar2_table(14808) := '757365436F6C756D6E2865293B696628652E706F73793C742E79297B636F6E7374206E3D742E792D652E706F73792C733D4D6174682E6D617828692E67657443757272656E745363726F6C6C546F7028292D6E2C30292C723D564E2E6765745A6F6E6541';
wwv_flow_imp.g_varchar2_table(14809) := '74436F6F726428746869732E5F636F6E746578742C73293B69662872297B636F6E737420653D746869732E5F68656C70506F736974696F6E4A756D704F766572566965775A6F6E652872293B696628652972657475726E20464E2E6372656174654F7574';
wwv_flow_imp.g_varchar2_table(14810) := '73696465456469746F72286F2C652C2261626F7665222C6E297D636F6E737420613D692E6765744C696E654E756D6265724174566572746963616C4F66667365742873293B72657475726E20464E2E6372656174654F757473696465456469746F72286F';
wwv_flow_imp.g_varchar2_table(14811) := '2C6E6577206D6328612C31292C2261626F7665222C6E297D696628652E706F73793E742E792B742E686569676874297B636F6E737420733D652E706F73792D742E792D742E6865696768742C723D692E67657443757272656E745363726F6C6C546F7028';
wwv_flow_imp.g_varchar2_table(14812) := '292B652E72656C6174697665506F732E792C613D564E2E6765745A6F6E654174436F6F726428746869732E5F636F6E746578742C72293B69662861297B636F6E737420653D746869732E5F68656C70506F736974696F6E4A756D704F766572566965775A';
wwv_flow_imp.g_varchar2_table(14813) := '6F6E652861293B696628652972657475726E20464E2E6372656174654F757473696465456469746F72286F2C652C2262656C6F77222C73297D636F6E7374206C3D692E6765744C696E654E756D6265724174566572746963616C4F66667365742872293B';
wwv_flow_imp.g_varchar2_table(14814) := '72657475726E20464E2E6372656174654F757473696465456469746F72286F2C6E6577206D63286C2C6E2E6765744C696E654D6178436F6C756D6E286C29292C2262656C6F77222C73297D636F6E737420733D692E6765744C696E654E756D6265724174';
wwv_flow_imp.g_varchar2_table(14815) := '566572746963616C4F666673657428692E67657443757272656E745363726F6C6C546F7028292B652E72656C6174697665506F732E79293B696628652E706F73783C742E78297B636F6E7374206E3D742E782D652E706F73783B72657475726E20464E2E';
wwv_flow_imp.g_varchar2_table(14816) := '6372656174654F757473696465456469746F72286F2C6E6577206D6328732C31292C226C656674222C6E297D696628652E706F73783E742E782B742E7769647468297B636F6E737420693D652E706F73782D742E782D742E77696474683B72657475726E';
wwv_flow_imp.g_varchar2_table(14817) := '20464E2E6372656174654F757473696465456469746F72286F2C6E6577206D6328732C6E2E6765744C696E654D6178436F6C756D6E287329292C227269676874222C69297D72657475726E206E756C6C7D5F66696E644D6F757365506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(14818) := '652C74297B636F6E7374206E3D746869732E5F676574506F736974696F6E4F757473696465456469746F722865293B6966286E2972657475726E206E3B636F6E737420693D746869732E5F6372656174654D6F75736554617267657428652C74293B6966';
wwv_flow_imp.g_varchar2_table(14819) := '2821692E706F736974696F6E2972657475726E206E756C6C3B696628383D3D3D692E747970657C7C353D3D3D692E74797065297B636F6E737420653D746869732E5F68656C70506F736974696F6E4A756D704F766572566965775A6F6E6528692E646574';
wwv_flow_imp.g_varchar2_table(14820) := '61696C293B696628652972657475726E20464E2E637265617465566965775A6F6E6528692E747970652C692E656C656D656E742C692E6D6F757365436F6C756D6E2C652C692E64657461696C297D72657475726E20697D5F68656C70506F736974696F6E';
wwv_flow_imp.g_varchar2_table(14821) := '4A756D704F766572566965775A6F6E652865297B636F6E737420743D6E6577206D6328746869732E5F63757272656E7453656C656374696F6E2E73656C656374696F6E53746172744C696E654E756D6265722C746869732E5F63757272656E7453656C65';
wwv_flow_imp.g_varchar2_table(14822) := '6374696F6E2E73656C656374696F6E5374617274436F6C756D6E292C6E3D652E706F736974696F6E4265666F72652C693D652E706F736974696F6E41667465723B72657475726E206E2626693F6E2E69734265666F72652874293F6E3A693A6E756C6C7D';
wwv_flow_imp.g_varchar2_table(14823) := '5F64697370617463684D6F75736528652C742C6E297B652E706F736974696F6E2626746869732E5F76696577436F6E74726F6C6C65722E64697370617463684D6F757365287B706F736974696F6E3A652E706F736974696F6E2C6D6F757365436F6C756D';
wwv_flow_imp.g_varchar2_table(14824) := '6E3A652E6D6F757365436F6C756D6E2C737461727465644F6E4C696E654E756D626572733A746869732E5F6D6F75736553746174652E737461727465644F6E4C696E654E756D626572732C72657665616C547970653A6E2C696E53656C656374696F6E4D';
wwv_flow_imp.g_varchar2_table(14825) := '6F64653A742C6D6F757365446F776E436F756E743A746869732E5F6D6F75736553746174652E636F756E742C616C744B65793A746869732E5F6D6F75736553746174652E616C744B65792C6374726C4B65793A746869732E5F6D6F75736553746174652E';
wwv_flow_imp.g_varchar2_table(14826) := '6374726C4B65792C6D6574614B65793A746869732E5F6D6F75736553746174652E6D6574614B65792C73686966744B65793A746869732E5F6D6F75736553746174652E73686966744B65792C6C656674427574746F6E3A746869732E5F6D6F7573655374';
wwv_flow_imp.g_varchar2_table(14827) := '6174652E6C656674427574746F6E2C6D6964646C65427574746F6E3A746869732E5F6D6F75736553746174652E6D6964646C65427574746F6E2C6F6E496E6A6563746564546578743A363D3D3D652E7479706526266E756C6C213D3D652E64657461696C';
wwv_flow_imp.g_varchar2_table(14828) := '2E696E6A6563746564546578747D297D7D636C61737320474E20657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F636F6E746578743D652C746869732E5F7669657748656C7065723D74';
wwv_flow_imp.g_varchar2_table(14829) := '2C746869732E5F6D6F757365546172676574466163746F72793D6E2C746869732E5F64697370617463684D6F7573653D692C746869732E5F6F7065726174696F6E3D6E756C6C7D646973706F736528297B73757065722E646973706F736528292C746869';
wwv_flow_imp.g_varchar2_table(14830) := '732E73746F7028297D737461727428652C74297B746869732E5F6F7065726174696F6E3F746869732E5F6F7065726174696F6E2E736574506F736974696F6E28652C74293A746869732E5F6F7065726174696F6E3D6E657720514E28746869732E5F636F';
wwv_flow_imp.g_varchar2_table(14831) := '6E746578742C746869732E5F7669657748656C7065722C746869732E5F6D6F757365546172676574466163746F72792C746869732E5F64697370617463684D6F7573652C652C74297D73746F7028297B746869732E5F6F7065726174696F6E2626287468';
wwv_flow_imp.g_varchar2_table(14832) := '69732E5F6F7065726174696F6E2E646973706F736528292C746869732E5F6F7065726174696F6E3D6E756C6C297D7D636C61737320514E20657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C';
wwv_flow_imp.g_varchar2_table(14833) := '746869732E5F636F6E746578743D652C746869732E5F7669657748656C7065723D742C746869732E5F6D6F757365546172676574466163746F72793D6E2C746869732E5F64697370617463684D6F7573653D692C746869732E5F706F736974696F6E3D6F';
wwv_flow_imp.g_varchar2_table(14834) := '2C746869732E5F6D6F7573654576656E743D732C746869732E5F6C61737454696D653D446174652E6E6F7728292C746869732E5F616E696D6174696F6E4672616D65446973706F7361626C653D787328727328732E62726F777365724576656E74292C28';
wwv_flow_imp.g_varchar2_table(14835) := '28293D3E746869732E5F65786563757465282929297D646973706F736528297B746869732E5F616E696D6174696F6E4672616D65446973706F7361626C652E646973706F736528292C73757065722E646973706F736528297D736574506F736974696F6E';
wwv_flow_imp.g_varchar2_table(14836) := '28652C74297B746869732E5F706F736974696F6E3D652C746869732E5F6D6F7573654576656E743D747D5F7469636B28297B636F6E737420653D446174652E6E6F7728292C743D652D746869732E5F6C61737454696D653B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(14837) := '5F6C61737454696D653D652C747D5F6765745363726F6C6C537065656428297B636F6E737420653D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E676574283637292C743D746869732E5F636F6E746578742E';
wwv_flow_imp.g_varchar2_table(14838) := '636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435292E6865696768742F652C6E3D746869732E5F706F736974696F6E2E6F75747369646544697374616E63652F653B72657475726E206E3C3D312E353F4D6174682E6D6178283330';
wwv_flow_imp.g_varchar2_table(14839) := '2C742A28312B6E29293A6E3C3D333F4D6174682E6D61782836302C742A28322B6E29293A4D6174682E6D6178283230302C742A28372B6E29297D5F6578656375746528297B636F6E737420653D746869732E5F636F6E746578742E636F6E666967757261';
wwv_flow_imp.g_varchar2_table(14840) := '74696F6E2E6F7074696F6E732E676574283637292C743D746869732E5F6765745363726F6C6C537065656428292A28746869732E5F7469636B28292F316533292A652C6E3D2261626F7665223D3D3D746869732E5F706F736974696F6E2E6F7574736964';
wwv_flow_imp.g_varchar2_table(14841) := '65506F736974696F6E3F2D743A743B746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75742E64656C74615363726F6C6C4E6F7728302C6E292C746869732E5F7669657748656C7065722E72656E6465724E6F7728293B63';
wwv_flow_imp.g_varchar2_table(14842) := '6F6E737420693D746869732E5F636F6E746578742E766965774C61796F75742E6765744C696E657356696577706F72744461746128292C6F3D2261626F7665223D3D3D746869732E5F706F736974696F6E2E6F757473696465506F736974696F6E3F692E';
wwv_flow_imp.g_varchar2_table(14843) := '73746172744C696E654E756D6265723A692E656E644C696E654E756D6265723B6C657420733B7B636F6E737420653D6A4128746869732E5F7669657748656C7065722E76696577446F6D4E6F6465292C743D746869732E5F636F6E746578742E636F6E66';
wwv_flow_imp.g_varchar2_table(14844) := '696775726174696F6E2E6F7074696F6E732E67657428313435292E686F72697A6F6E74616C5363726F6C6C6261724865696768742C6E3D6E657720564128746869732E5F6D6F7573654576656E742E706F732E782C652E792B652E6865696768742D742D';
wwv_flow_imp.g_varchar2_table(14845) := '2E31292C693D714128746869732E5F7669657748656C7065722E76696577446F6D4E6F64652C652C6E293B733D746869732E5F6D6F757365546172676574466163746F72792E6372656174654D6F75736554617267657428746869732E5F766965774865';
wwv_flow_imp.g_varchar2_table(14846) := '6C7065722E6765744C61737452656E6465724461746128292C652C6E2C692C6E756C6C297D732E706F736974696F6E2626732E706F736974696F6E2E6C696E654E756D6265723D3D3D6F7C7C28733D2261626F7665223D3D3D746869732E5F706F736974';
wwv_flow_imp.g_varchar2_table(14847) := '696F6E2E6F757473696465506F736974696F6E3F464E2E6372656174654F757473696465456469746F7228746869732E5F706F736974696F6E2E6D6F757365436F6C756D6E2C6E6577206D63286F2C31292C2261626F7665222C746869732E5F706F7369';
wwv_flow_imp.g_varchar2_table(14848) := '74696F6E2E6F75747369646544697374616E6365293A464E2E6372656174654F757473696465456469746F7228746869732E5F706F736974696F6E2E6D6F757365436F6C756D6E2C6E6577206D63286F2C746869732E5F636F6E746578742E766965774D';
wwv_flow_imp.g_varchar2_table(14849) := '6F64656C2E6765744C696E654D6178436F6C756D6E286F29292C2262656C6F77222C746869732E5F706F736974696F6E2E6F75747369646544697374616E636529292C746869732E5F64697370617463684D6F75736528732C21302C32292C746869732E';
wwv_flow_imp.g_varchar2_table(14850) := '5F616E696D6174696F6E4672616D65446973706F7361626C653D787328727328732E656C656D656E74292C2828293D3E746869732E5F65786563757465282929297D7D636C61737320594E7B67657420616C744B657928297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(14851) := '2E5F616C744B65797D676574206374726C4B657928297B72657475726E20746869732E5F6374726C4B65797D676574206D6574614B657928297B72657475726E20746869732E5F6D6574614B65797D6765742073686966744B657928297B72657475726E';
wwv_flow_imp.g_varchar2_table(14852) := '20746869732E5F73686966744B65797D676574206C656674427574746F6E28297B72657475726E20746869732E5F6C656674427574746F6E7D676574206D6964646C65427574746F6E28297B72657475726E20746869732E5F6D6964646C65427574746F';
wwv_flow_imp.g_varchar2_table(14853) := '6E7D67657420737461727465644F6E4C696E654E756D6265727328297B72657475726E20746869732E5F737461727465644F6E4C696E654E756D626572737D636F6E7374727563746F7228297B746869732E5F616C744B65793D21312C746869732E5F63';
wwv_flow_imp.g_varchar2_table(14854) := '74726C4B65793D21312C746869732E5F6D6574614B65793D21312C746869732E5F73686966744B65793D21312C746869732E5F6C656674427574746F6E3D21312C746869732E5F6D6964646C65427574746F6E3D21312C746869732E5F73746172746564';
wwv_flow_imp.g_varchar2_table(14855) := '4F6E4C696E654E756D626572733D21312C746869732E5F6C6173744D6F757365446F776E506F736974696F6E3D6E756C6C2C746869732E5F6C6173744D6F757365446F776E506F736974696F6E457175616C436F756E743D302C746869732E5F6C617374';
wwv_flow_imp.g_varchar2_table(14856) := '4D6F757365446F776E436F756E743D302C746869732E5F6C6173745365744D6F757365446F776E436F756E7454696D653D302C746869732E697344726167416E6444726F703D21317D67657420636F756E7428297B72657475726E20746869732E5F6C61';
wwv_flow_imp.g_varchar2_table(14857) := '73744D6F757365446F776E436F756E747D7365744D6F646966696572732865297B746869732E5F616C744B65793D652E616C744B65792C746869732E5F6374726C4B65793D652E6374726C4B65792C746869732E5F6D6574614B65793D652E6D6574614B';
wwv_flow_imp.g_varchar2_table(14858) := '65792C746869732E5F73686966744B65793D652E73686966744B65797D7365745374617274427574746F6E732865297B746869732E5F6C656674427574746F6E3D652E6C656674427574746F6E2C746869732E5F6D6964646C65427574746F6E3D652E6D';
wwv_flow_imp.g_varchar2_table(14859) := '6964646C65427574746F6E7D736574537461727465644F6E4C696E654E756D626572732865297B746869732E5F737461727465644F6E4C696E654E756D626572733D657D747279536574436F756E7428652C74297B636F6E7374206E3D286E6577204461';
wwv_flow_imp.g_varchar2_table(14860) := '7465292E67657454696D6528293B6E2D746869732E5F6C6173745365744D6F757365446F776E436F756E7454696D653E594E2E434C4541525F4D4F5553455F444F574E5F434F554E545F54494D45262628653D31292C746869732E5F6C6173745365744D';
wwv_flow_imp.g_varchar2_table(14861) := '6F757365446F776E436F756E7454696D653D6E2C653E746869732E5F6C6173744D6F757365446F776E436F756E742B31262628653D746869732E5F6C6173744D6F757365446F776E436F756E742B31292C746869732E5F6C6173744D6F757365446F776E';
wwv_flow_imp.g_varchar2_table(14862) := '506F736974696F6E2626746869732E5F6C6173744D6F757365446F776E506F736974696F6E2E657175616C732874293F746869732E5F6C6173744D6F757365446F776E506F736974696F6E457175616C436F756E742B2B3A746869732E5F6C6173744D6F';
wwv_flow_imp.g_varchar2_table(14863) := '757365446F776E506F736974696F6E457175616C436F756E743D312C746869732E5F6C6173744D6F757365446F776E506F736974696F6E3D742C746869732E5F6C6173744D6F757365446F776E436F756E743D4D6174682E6D696E28652C746869732E5F';
wwv_flow_imp.g_varchar2_table(14864) := '6C6173744D6F757365446F776E506F736974696F6E457175616C436F756E74297D7D594E2E434C4541525F4D4F5553455F444F574E5F434F554E545F54494D453D3430303B636C617373205A4E20657874656E647320554E7B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(14865) := '28652C742C6E297B737570657228652C742C6E292C746869732E5F72656769737465722849452E61646454617267657428746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F646529292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(14866) := '7228627328746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F64652C54452E5461702C28653D3E746869732E6F6E5461702865292929292C746869732E5F726567697374657228627328746869732E7669657748656C70';
wwv_flow_imp.g_varchar2_table(14867) := '65722E6C696E6573436F6E74656E74446F6D4E6F64652C54452E4368616E67652C28653D3E746869732E6F6E4368616E67652865292929292C746869732E5F726567697374657228627328746869732E7669657748656C7065722E6C696E6573436F6E74';
wwv_flow_imp.g_varchar2_table(14868) := '656E74446F6D4E6F64652C54452E436F6E746578746D656E752C28653D3E746869732E5F6F6E436F6E746578744D656E75286E657720244128652C21312C746869732E7669657748656C7065722E76696577446F6D4E6F6465292C2131292929292C7468';
wwv_flow_imp.g_varchar2_table(14869) := '69732E5F6C617374506F696E746572547970653D226D6F757365222C746869732E5F726567697374657228627328746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F64652C22706F696E746572646F776E222C28653D3E';
wwv_flow_imp.g_varchar2_table(14870) := '7B636F6E737420743D652E706F696E746572547970653B746869732E5F6C617374506F696E746572547970653D226D6F75736522213D3D743F22746F756368223D3D3D743F22746F756368223A2270656E223A226D6F757365227D2929293B636F6E7374';
wwv_flow_imp.g_varchar2_table(14871) := '20693D6E6577204B4128746869732E7669657748656C7065722E76696577446F6D4E6F6465293B746869732E5F726567697374657228692E6F6E506F696E7465724D6F766528746869732E7669657748656C7065722E76696577446F6D4E6F64652C2865';
wwv_flow_imp.g_varchar2_table(14872) := '3D3E746869732E5F6F6E4D6F7573654D6F76652865292929292C746869732E5F726567697374657228692E6F6E506F696E746572557028746869732E7669657748656C7065722E76696577446F6D4E6F64652C28653D3E746869732E5F6F6E4D6F757365';
wwv_flow_imp.g_varchar2_table(14873) := '55702865292929292C746869732E5F726567697374657228692E6F6E506F696E7465724C6561766528746869732E7669657748656C7065722E76696577446F6D4E6F64652C28653D3E746869732E5F6F6E4D6F7573654C656176652865292929292C7468';
wwv_flow_imp.g_varchar2_table(14874) := '69732E5F726567697374657228692E6F6E506F696E746572446F776E28746869732E7669657748656C7065722E76696577446F6D4E6F64652C2828652C74293D3E746869732E5F6F6E4D6F757365446F776E28652C74292929297D6F6E5461702865297B';
wwv_flow_imp.g_varchar2_table(14875) := '652E696E697469616C5461726765742626746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F64652E636F6E7461696E7328652E696E697469616C54617267657429262628652E70726576656E7444656661756C7428292C';
wwv_flow_imp.g_varchar2_table(14876) := '746869732E7669657748656C7065722E666F637573546578744172656128292C746869732E5F64697370617463684765737475726528652C213129297D6F6E4368616E67652865297B22746F756368223D3D3D746869732E5F6C617374506F696E746572';
wwv_flow_imp.g_varchar2_table(14877) := '547970652626746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75742E64656C74615363726F6C6C4E6F77282D652E7472616E736C6174696F6E582C2D652E7472616E736C6174696F6E59292C2270656E223D3D3D746869';
wwv_flow_imp.g_varchar2_table(14878) := '732E5F6C617374506F696E746572547970652626746869732E5F64697370617463684765737475726528652C2130297D5F64697370617463684765737475726528652C74297B636F6E7374206E3D746869732E5F6372656174654D6F7573655461726765';
wwv_flow_imp.g_varchar2_table(14879) := '74286E657720244128652C21312C746869732E7669657748656C7065722E76696577446F6D4E6F6465292C2131293B6E2E706F736974696F6E2626746869732E76696577436F6E74726F6C6C65722E64697370617463684D6F757365287B706F73697469';
wwv_flow_imp.g_varchar2_table(14880) := '6F6E3A6E2E706F736974696F6E2C6D6F757365436F6C756D6E3A6E2E706F736974696F6E2E636F6C756D6E2C737461727465644F6E4C696E654E756D626572733A21312C72657665616C547970653A312C6D6F757365446F776E436F756E743A652E7461';
wwv_flow_imp.g_varchar2_table(14881) := '70436F756E742C696E53656C656374696F6E4D6F64653A742C616C744B65793A21312C6374726C4B65793A21312C6D6574614B65793A21312C73686966744B65793A21312C6C656674427574746F6E3A21312C6D6964646C65427574746F6E3A21312C6F';
wwv_flow_imp.g_varchar2_table(14882) := '6E496E6A6563746564546578743A363D3D3D6E2E7479706526266E756C6C213D3D6E2E64657461696C2E696E6A6563746564546578747D297D5F6F6E4D6F757365446F776E28652C74297B22746F75636822213D3D652E62726F777365724576656E742E';
wwv_flow_imp.g_varchar2_table(14883) := '706F696E74657254797065262673757065722E5F6F6E4D6F757365446F776E28652C74297D7D636C61737320584E20657874656E647320554E7B636F6E7374727563746F7228652C742C6E297B737570657228652C742C6E292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(14884) := '737465722849452E61646454617267657428746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F646529292C746869732E5F726567697374657228627328746869732E7669657748656C7065722E6C696E6573436F6E7465';
wwv_flow_imp.g_varchar2_table(14885) := '6E74446F6D4E6F64652C54452E5461702C28653D3E746869732E6F6E5461702865292929292C746869732E5F726567697374657228627328746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F64652C54452E4368616E67';
wwv_flow_imp.g_varchar2_table(14886) := '652C28653D3E746869732E6F6E4368616E67652865292929292C746869732E5F726567697374657228627328746869732E7669657748656C7065722E6C696E6573436F6E74656E74446F6D4E6F64652C54452E436F6E746578746D656E752C28653D3E74';
wwv_flow_imp.g_varchar2_table(14887) := '6869732E5F6F6E436F6E746578744D656E75286E657720244128652C21312C746869732E7669657748656C7065722E76696577446F6D4E6F6465292C2131292929297D6F6E5461702865297B652E70726576656E7444656661756C7428292C746869732E';
wwv_flow_imp.g_varchar2_table(14888) := '7669657748656C7065722E666F637573546578744172656128293B636F6E737420743D746869732E5F6372656174654D6F757365546172676574286E657720244128652C21312C746869732E7669657748656C7065722E76696577446F6D4E6F6465292C';
wwv_flow_imp.g_varchar2_table(14889) := '2131293B696628742E706F736974696F6E297B636F6E737420653D646F63756D656E742E6372656174654576656E742822437573746F6D4576656E7422293B652E696E69744576656E742858532E5461702C21312C2130292C746869732E766965774865';
wwv_flow_imp.g_varchar2_table(14890) := '6C7065722E646973706174636854657874417265614576656E742865292C746869732E76696577436F6E74726F6C6C65722E6D6F7665546F28742E706F736974696F6E2C31297D7D6F6E4368616E67652865297B746869732E5F636F6E746578742E7669';
wwv_flow_imp.g_varchar2_table(14891) := '65774D6F64656C2E766965774C61796F75742E64656C74615363726F6C6C4E6F77282D652E7472616E736C6174696F6E582C2D652E7472616E736C6174696F6E59297D7D636C617373204A4E20657874656E6473206C747B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(14892) := '652C742C6E297B737570657228292C28517C7C636526265929262664653F746869732E68616E646C65723D746869732E5F7265676973746572286E6577205A4E28652C742C6E29293A732E546F7563684576656E743F746869732E68616E646C65723D74';
wwv_flow_imp.g_varchar2_table(14893) := '6869732E5F7265676973746572286E657720584E28652C742C6E29293A746869732E68616E646C65723D746869732E5F7265676973746572286E657720554E28652C742C6E29297D6765745461726765744174436C69656E74506F696E7428652C74297B';
wwv_flow_imp.g_varchar2_table(14894) := '72657475726E20746869732E68616E646C65722E6765745461726765744174436C69656E74506F696E7428652C74297D7D7661722065503D6E2836333037292C74503D7B7D3B74502E7374796C655461675472616E73666F726D3D6A7228292C74502E73';
wwv_flow_imp.g_varchar2_table(14895) := '6574417474726962757465733D567228292C74502E696E736572743D467228292E62696E64286E756C6C2C226865616422292C74502E646F6D4150493D4F7228292C74502E696E736572745374796C65456C656D656E743D487228292C4E722829286550';
wwv_flow_imp.g_varchar2_table(14896) := '2E412C7450292C65502E41262665502E412E6C6F63616C73262665502E412E6C6F63616C733B766172206E503D6E2836393533292C69503D7B7D3B69502E7374796C655461675472616E73666F726D3D6A7228292C69502E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(14897) := '733D567228292C69502E696E736572743D467228292E62696E64286E756C6C2C226865616422292C69502E646F6D4150493D4F7228292C69502E696E736572745374796C65456C656D656E743D487228292C4E722829286E502E412C6950292C6E502E41';
wwv_flow_imp.g_varchar2_table(14898) := '26266E502E412E6C6F63616C7326266E502E412E6C6F63616C733B636C617373206F5020657874656E64732058417B7D636C61737320735020657874656E6473206F507B636F6E7374727563746F722865297B737570657228292C746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(14899) := '746578743D652C746869732E5F72656164436F6E66696728292C746869732E5F6C617374437572736F724D6F64656C506F736974696F6E3D6E6577206D6328312C31292C746869732E5F72656E646572526573756C743D6E756C6C2C746869732E5F6163';
wwv_flow_imp.g_varchar2_table(14900) := '746976654C696E654E756D6265723D312C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D5F72656164436F6E66696728297B636F6E737420653D746869732E5F636F6E746578742E636F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(14901) := '6F6E2E6F7074696F6E733B746869732E5F6C696E654865696768743D652E676574283637293B636F6E737420743D652E676574283638293B746869732E5F72656E6465724C696E654E756D626572733D742E72656E646572547970652C746869732E5F72';
wwv_flow_imp.g_varchar2_table(14902) := '656E646572437573746F6D4C696E654E756D626572733D742E72656E646572466E2C746869732E5F72656E64657246696E616C4E65776C696E653D652E676574283935293B636F6E7374206E3D652E67657428313435293B746869732E5F6C696E654E75';
wwv_flow_imp.g_varchar2_table(14903) := '6D626572734C6566743D6E2E6C696E654E756D626572734C6566742C746869732E5F6C696E654E756D6265727357696474683D6E2E6C696E654E756D6265727357696474687D646973706F736528297B746869732E5F636F6E746578742E72656D6F7665';
wwv_flow_imp.g_varchar2_table(14904) := '4576656E7448616E646C65722874686973292C746869732E5F72656E646572526573756C743D6E756C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B72657475726E20746869732E5F7265';
wwv_flow_imp.g_varchar2_table(14905) := '6164436F6E66696728292C21307D6F6E437572736F7253746174654368616E6765642865297B636F6E737420743D652E73656C656374696F6E735B305D2E676574506F736974696F6E28293B746869732E5F6C617374437572736F724D6F64656C506F73';
wwv_flow_imp.g_varchar2_table(14906) := '6974696F6E3D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E2874293B6C6574206E3D21313B7265';
wwv_flow_imp.g_varchar2_table(14907) := '7475726E20746869732E5F6163746976654C696E654E756D626572213D3D742E6C696E654E756D626572262628746869732E5F6163746976654C696E654E756D6265723D742E6C696E654E756D6265722C6E3D2130292C32213D3D746869732E5F72656E';
wwv_flow_imp.g_varchar2_table(14908) := '6465724C696E654E756D62657273262633213D3D746869732E5F72656E6465724C696E654E756D626572737C7C286E3D2130292C6E7D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E';
wwv_flow_imp.g_varchar2_table(14909) := '21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E67';
wwv_flow_imp.g_varchar2_table(14910) := '65647D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E20652E616666656374734C696E654E756D6265727D5F6765744C696E6552656E6465724C696E654E';
wwv_flow_imp.g_varchar2_table(14911) := '756D6265722865297B636F6E737420743D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E6577';
wwv_flow_imp.g_varchar2_table(14912) := '206D6328652C3129293B69662831213D3D742E636F6C756D6E2972657475726E22223B636F6E7374206E3D742E6C696E654E756D6265723B696628746869732E5F72656E646572437573746F6D4C696E654E756D626572732972657475726E2074686973';
wwv_flow_imp.g_varchar2_table(14913) := '2E5F72656E646572437573746F6D4C696E654E756D62657273286E293B696628323D3D3D746869732E5F72656E6465724C696E654E756D62657273297B636F6E737420653D4D6174682E61627328746869732E5F6C617374437572736F724D6F64656C50';
wwv_flow_imp.g_varchar2_table(14914) := '6F736974696F6E2E6C696E654E756D6265722D6E293B72657475726E20303D3D3D653F273C7370616E20636C6173733D2272656C61746976652D63757272656E742D6C696E652D6E756D626572223E272B6E2B223C2F7370616E3E223A537472696E6728';
wwv_flow_imp.g_varchar2_table(14915) := '65297D72657475726E20333D3D3D746869732E5F72656E6465724C696E654E756D626572733F746869732E5F6C617374437572736F724D6F64656C506F736974696F6E2E6C696E654E756D6265723D3D3D6E7C7C6E2531303D3D307C7C6E3D3D3D746869';
wwv_flow_imp.g_varchar2_table(14916) := '732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E7428293F537472696E67286E293A22223A537472696E67286E297D7072657061726552656E6465722865297B696628303D3D3D746869732E5F72656E6465724C696E654E';
wwv_flow_imp.g_varchar2_table(14917) := '756D626572732972657475726E20766F696428746869732E5F72656E646572526573756C743D6E756C6C293B636F6E737420743D243F746869732E5F6C696E6548656967687425323D3D303F22206C682D6576656E223A22206C682D6F6464223A22222C';
wwv_flow_imp.g_varchar2_table(14918) := '6E3D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C693D652E76697369626C6552616E67652E656E644C696E654E756D6265722C6F3D746869732E5F636F6E746578742E766965774D6F64656C2E6765744465636F726174';
wwv_flow_imp.g_varchar2_table(14919) := '696F6E73496E56696577706F727428652E76697369626C6552616E6765292E66696C7465722828653D3E2121652E6F7074696F6E732E6C696E654E756D626572436C6173734E616D6529293B6F2E736F7274282828652C74293D3E72682E636F6D706172';
wwv_flow_imp.g_varchar2_table(14920) := '6552616E6765735573696E67456E647328652E72616E67652C742E72616E67652929293B6C657420733D303B636F6E737420723D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E7428292C613D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(14921) := '6C657420653D6E3B653C3D693B652B2B297B636F6E737420693D652D6E3B6C6574206C3D746869732E5F6765744C696E6552656E6465724C696E654E756D6265722865292C633D22223B666F72283B733C6F2E6C656E67746826266F5B735D2E72616E67';
wwv_flow_imp.g_varchar2_table(14922) := '652E656E644C696E654E756D6265723C653B29732B2B3B666F72286C657420743D733B743C6F2E6C656E6774683B742B2B297B636F6E73747B72616E67653A6E2C6F7074696F6E733A697D3D6F5B745D3B6E2E73746172744C696E654E756D6265723C3D';
wwv_flow_imp.g_varchar2_table(14923) := '65262628632B3D2220222B692E6C696E654E756D626572436C6173734E616D65297D6C7C7C633F28653D3D3D722626303D3D3D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654C656E677468286529262628226F6666223D';
wwv_flow_imp.g_varchar2_table(14924) := '3D3D746869732E5F72656E64657246696E616C4E65776C696E652626286C3D2222292C2264696D6D6564223D3D3D746869732E5F72656E64657246696E616C4E65776C696E65262628632B3D222064696D6D65642D6C696E652D6E756D6265722229292C';
wwv_flow_imp.g_varchar2_table(14925) := '653D3D3D746869732E5F6163746976654C696E654E756D626572262628632B3D22206163746976652D6C696E652D6E756D62657222292C615B695D3D603C64697620636C6173733D22247B73502E434C4153535F4E414D457D247B747D247B637D222073';
wwv_flow_imp.g_varchar2_table(14926) := '74796C653D226C6566743A247B746869732E5F6C696E654E756D626572734C6566747D70783B77696474683A247B746869732E5F6C696E654E756D6265727357696474687D70783B223E247B6C7D3C2F6469763E60293A615B695D3D22227D746869732E';
wwv_flow_imp.g_varchar2_table(14927) := '5F72656E646572526573756C743D617D72656E64657228652C74297B69662821746869732E5F72656E646572526573756C742972657475726E22223B636F6E7374206E3D742D653B72657475726E206E3C307C7C6E3E3D746869732E5F72656E64657252';
wwv_flow_imp.g_varchar2_table(14928) := '6573756C742E6C656E6774683F22223A746869732E5F72656E646572526573756C745B6E5D7D7D73502E434C4153535F4E414D453D226C696E652D6E756D62657273222C5662282828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F722859';
wwv_flow_imp.g_varchar2_table(14929) := '62292C693D652E676574436F6C6F7228755F293B693F742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6C696E652D6E756D626572732E64696D6D65642D6C696E652D6E756D626572207B20636F6C6F723A20247B697D3B207D60293A';
wwv_flow_imp.g_varchar2_table(14930) := '6E2626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6C696E652D6E756D626572732E64696D6D65642D6C696E652D6E756D626572207B20636F6C6F723A20247B6E2E7472616E73706172656E74282E34297D3B207D60297D29293B';
wwv_flow_imp.g_varchar2_table(14931) := '7661722072503D6E2838373331292C61503D7B7D3B61502E7374796C655461675472616E73666F726D3D6A7228292C61502E736574417474726962757465733D567228292C61502E696E736572743D467228292E62696E64286E756C6C2C226865616422';
wwv_flow_imp.g_varchar2_table(14932) := '292C61502E646F6D4150493D4F7228292C61502E696E736572745374796C65456C656D656E743D487228292C4E7228292872502E412C6150292C72502E41262672502E412E6C6F63616C73262672502E412E6C6F63616C733B636C617373206C50206578';
wwv_flow_imp.g_varchar2_table(14933) := '74656E6473204A417B636F6E7374727563746F722865297B73757065722865293B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B746869732E5F63616E55';
wwv_flow_imp.g_varchar2_table(14934) := '73654C6179657248696E74696E673D21742E676574283332292C746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E5F676C7970684D617267696E4C6566743D6E2E676C7970684D617267696E4C6566742C7468';
wwv_flow_imp.g_varchar2_table(14935) := '69732E5F676C7970684D617267696E57696474683D6E2E676C7970684D617267696E57696474682C746869732E5F646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(14936) := '652E736574436C6173734E616D65286C502E4F555445525F434C4153535F4E414D45292C746869732E5F646F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C746869732E5F646F6D4E6F64652E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(14937) := '2822726F6C65222C2270726573656E746174696F6E22292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F676C7970684D617267696E4261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(14938) := '446F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F676C7970684D617267696E4261636B67726F756E64446F6D4E6F64652E736574436C6173734E616D65286C502E434C4153535F4E';
wwv_flow_imp.g_varchar2_table(14939) := '414D45292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F676C7970684D617267696E4261636B67726F756E64446F6D4E6F6465297D646973706F736528297B73757065722E646973706F736528297D676574446F6D4E';
wwv_flow_imp.g_varchar2_table(14940) := '6F646528297B72657475726E20746869732E5F646F6D4E6F64657D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D74';
wwv_flow_imp.g_varchar2_table(14941) := '2E67657428313435293B72657475726E20746869732E5F63616E5573654C6179657248696E74696E673D21742E676574283332292C746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E5F676C7970684D617267';
wwv_flow_imp.g_varchar2_table(14942) := '696E4C6566743D6E2E676C7970684D617267696E4C6566742C746869732E5F676C7970684D617267696E57696474683D6E2E676C7970684D617267696E57696474682C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E2073757065';
wwv_flow_imp.g_varchar2_table(14943) := '722E6F6E5363726F6C6C4368616E6765642865297C7C652E7363726F6C6C546F704368616E6765647D7072657061726552656E6465722865297B7D72656E6465722865297B746869732E5F646F6D4E6F64652E7365744C6179657248696E74696E672874';
wwv_flow_imp.g_varchar2_table(14944) := '6869732E5F63616E5573654C6179657248696E74696E67292C746869732E5F646F6D4E6F64652E736574436F6E7461696E282273747269637422293B636F6E737420743D652E7363726F6C6C546F702D652E6269674E756D6265727344656C74613B7468';
wwv_flow_imp.g_varchar2_table(14945) := '69732E5F646F6D4E6F64652E736574546F70282D74293B636F6E7374206E3D4D6174682E6D696E28652E7363726F6C6C4865696768742C316536293B746869732E5F646F6D4E6F64652E736574486569676874286E292C746869732E5F646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(14946) := '2E736574576964746828746869732E5F636F6E74656E744C656674292C746869732E5F676C7970684D617267696E4261636B67726F756E64446F6D4E6F64652E7365744C65667428746869732E5F676C7970684D617267696E4C656674292C746869732E';
wwv_flow_imp.g_varchar2_table(14947) := '5F676C7970684D617267696E4261636B67726F756E64446F6D4E6F64652E736574576964746828746869732E5F676C7970684D617267696E5769647468292C746869732E5F676C7970684D617267696E4261636B67726F756E64446F6D4E6F64652E7365';
wwv_flow_imp.g_varchar2_table(14948) := '74486569676874286E297D7D6C502E434C4153535F4E414D453D22676C7970682D6D617267696E222C6C502E4F555445525F434C4153535F4E414D453D226D617267696E223B7661722063503D6E28323636292C64503D7B7D3B64502E7374796C655461';
wwv_flow_imp.g_varchar2_table(14949) := '675472616E73666F726D3D6A7228292C64502E736574417474726962757465733D567228292C64502E696E736572743D467228292E62696E64286E756C6C2C226865616422292C64502E646F6D4150493D4F7228292C64502E696E736572745374796C65';
wwv_flow_imp.g_varchar2_table(14950) := '456C656D656E743D487228292C4E7228292863502E412C6450292C63502E41262663502E412E6C6F63616C73262663502E412E6C6F63616C733B636F6E73742068503D226D6F6E61636F2D6D6F7573652D637572736F722D74657874222C75503D6E6577';
wwv_flow_imp.g_varchar2_table(14951) := '20636C6173737B636F6E7374727563746F7228297B746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F656E61626C6564';
wwv_flow_imp.g_varchar2_table(14952) := '3D21307D67657420656E61626C656428297B72657475726E20746869732E5F656E61626C65647D656E61626C6528297B746869732E5F656E61626C65643D21302C746869732E5F6F6E4469644368616E67652E6669726528297D64697361626C6528297B';
wwv_flow_imp.g_varchar2_table(14953) := '746869732E5F656E61626C65643D21312C746869732E5F6F6E4469644368616E67652E6669726528297D7D3B7661722070503D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C61';
wwv_flow_imp.g_varchar2_table(14954) := '73732067507B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F636F6E746578743D652C746869732E6D6F64656C4C696E654E756D6265723D742C746869732E64697374616E6365546F4D6F64656C4C696E6553746172743D6E2C';
wwv_flow_imp.g_varchar2_table(14955) := '746869732E77696474684F6648696464656E4C696E65546578744265666F72653D692C746869732E64697374616E6365546F4D6F64656C4C696E65456E643D6F2C746869732E5F76697369626C6554657874417265614272616E643D766F696420302C74';
wwv_flow_imp.g_varchar2_table(14956) := '6869732E7374617274506F736974696F6E3D6E756C6C2C746869732E656E64506F736974696F6E3D6E756C6C2C746869732E76697369626C65546578746172656153746172743D6E756C6C2C746869732E76697369626C655465787461726561456E643D';
wwv_flow_imp.g_varchar2_table(14957) := '6E756C6C2C746869732E5F70726576696F757350726573656E746174696F6E3D6E756C6C7D7072657061726552656E6465722865297B636F6E737420743D6E6577206D6328746869732E6D6F64656C4C696E654E756D6265722C746869732E6469737461';
wwv_flow_imp.g_varchar2_table(14958) := '6E6365546F4D6F64656C4C696E6553746172742B31292C6E3D6E6577206D6328746869732E6D6F64656C4C696E654E756D6265722C746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744C696E654D6178436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(14959) := '746869732E6D6F64656C4C696E654E756D626572292D746869732E64697374616E6365546F4D6F64656C4C696E65456E64293B746869732E7374617274506F736974696F6E3D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F726469';
wwv_flow_imp.g_varchar2_table(14960) := '6E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E2874292C746869732E656E64506F736974696F6E3D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F726469';
wwv_flow_imp.g_varchar2_table(14961) := '6E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E292C746869732E7374617274506F736974696F6E2E6C696E654E756D6265723D3D3D746869732E656E64506F736974696F';
wwv_flow_imp.g_varchar2_table(14962) := '6E2E6C696E654E756D6265723F28746869732E76697369626C65546578746172656153746172743D652E76697369626C6552616E6765466F72506F736974696F6E28746869732E7374617274506F736974696F6E292C746869732E76697369626C655465';
wwv_flow_imp.g_varchar2_table(14963) := '787461726561456E643D652E76697369626C6552616E6765466F72506F736974696F6E28746869732E656E64506F736974696F6E29293A28746869732E76697369626C65546578746172656153746172743D6E756C6C2C746869732E76697369626C6554';
wwv_flow_imp.g_varchar2_table(14964) := '65787461726561456E643D6E756C6C297D646566696E6550726573656E746174696F6E2865297B72657475726E20746869732E5F70726576696F757350726573656E746174696F6E7C7C28746869732E5F70726576696F757350726573656E746174696F';
wwv_flow_imp.g_varchar2_table(14965) := '6E3D657C7C7B666F726567726F756E643A312C6974616C69633A21312C626F6C643A21312C756E6465726C696E653A21312C737472696B657468726F7567683A21317D292C746869732E5F70726576696F757350726573656E746174696F6E7D7D636F6E';
wwv_flow_imp.g_varchar2_table(14966) := '7374206D503D633B6C65742066503D636C61737320657874656E6473204A417B636F6E7374727563746F7228652C742C6E2C692C6F297B73757065722865292C746869732E5F6B657962696E64696E67536572766963653D692C746869732E5F696E7374';
wwv_flow_imp.g_varchar2_table(14967) := '616E74696174696F6E536572766963653D6F2C746869732E5F7072696D617279437572736F72506F736974696F6E3D6E6577206D6328312C31292C746869732E5F7072696D617279437572736F7256697369626C6552616E67653D6E756C6C2C74686973';
wwv_flow_imp.g_varchar2_table(14968) := '2E5F76696577436F6E74726F6C6C65723D742C746869732E5F76697369626C6552616E676550726F76696465723D6E2C746869732E5F7363726F6C6C4C6566743D302C746869732E5F7363726F6C6C546F703D303B636F6E737420733D746869732E5F63';
wwv_flow_imp.g_varchar2_table(14969) := '6F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C723D732E67657428313435293B746869732E5F7365744163636573736962696C6974794F7074696F6E732873292C746869732E5F636F6E74656E744C6566743D722E636F6E7465';
wwv_flow_imp.g_varchar2_table(14970) := '6E744C6566742C746869732E5F636F6E74656E7457696474683D722E636F6E74656E7457696474682C746869732E5F636F6E74656E744865696768743D722E6865696768742C746869732E5F666F6E74496E666F3D732E676574283530292C746869732E';
wwv_flow_imp.g_varchar2_table(14971) := '5F6C696E654865696768743D732E676574283637292C746869732E5F656D70747953656C656374696F6E436C6970626F6172643D732E676574283337292C746869732E5F636F70795769746853796E746178486967686C69676874696E673D732E676574';
wwv_flow_imp.g_varchar2_table(14972) := '283235292C746869732E5F76697369626C6554657874417265613D6E756C6C2C746869732E5F73656C656374696F6E733D5B6E657720616828312C312C312C31295D2C746869732E5F6D6F64656C53656C656374696F6E733D5B6E657720616828312C31';
wwv_flow_imp.g_varchar2_table(14973) := '2C312C31295D2C746869732E5F6C61737452656E646572506F736974696F6E3D6E756C6C2C746869732E74657874417265613D734528646F63756D656E742E637265617465456C656D656E74282274657874617265612229292C654E2E77726974652874';
wwv_flow_imp.g_varchar2_table(14974) := '6869732E74657874417265612C37292C746869732E74657874417265612E736574436C6173734E616D652860696E7075746172656120247B68507D60292C746869732E74657874417265612E736574417474726962757465282277726170222C74686973';
wwv_flow_imp.g_varchar2_table(14975) := '2E5F74657874417265615772617070696E67262621746869732E5F76697369626C6554657874417265613F226F6E223A226F666622293B636F6E73747B74616253697A653A617D3D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F6465';
wwv_flow_imp.g_varchar2_table(14976) := '6C2E6765744F7074696F6E7328293B746869732E74657874417265612E646F6D4E6F64652E7374796C652E74616253697A653D612A746869732E5F666F6E74496E666F2E737061636557696474682B227078222C746869732E74657874417265612E7365';
wwv_flow_imp.g_varchar2_table(14977) := '7441747472696275746528226175746F636F7272656374222C226F666622292C746869732E74657874417265612E73657441747472696275746528226175746F6361706974616C697A65222C226F666622292C746869732E74657874417265612E736574';
wwv_flow_imp.g_varchar2_table(14978) := '41747472696275746528226175746F636F6D706C657465222C226F666622292C746869732E74657874417265612E73657441747472696275746528227370656C6C636865636B222C2266616C736522292C746869732E74657874417265612E7365744174';
wwv_flow_imp.g_varchar2_table(14979) := '747269627574652822617269612D6C6162656C222C746869732E5F676574417269614C6162656C287329292C746869732E74657874417265612E7365744174747269627574652822617269612D7265717569726564222C732E6765742835293F22747275';
wwv_flow_imp.g_varchar2_table(14980) := '65223A2266616C736522292C746869732E74657874417265612E7365744174747269627574652822746162696E646578222C537472696E6728732E676574283132342929292C746869732E74657874417265612E7365744174747269627574652822726F';
wwv_flow_imp.g_varchar2_table(14981) := '6C65222C2274657874626F7822292C746869732E74657874417265612E7365744174747269627574652822617269612D726F6C656465736372697074696F6E222C6228302C22656469746F722229292C746869732E74657874417265612E736574417474';
wwv_flow_imp.g_varchar2_table(14982) := '7269627574652822617269612D6D756C74696C696E65222C227472756522292C746869732E74657874417265612E7365744174747269627574652822617269612D6175746F636F6D706C657465222C732E676574283931293F226E6F6E65223A22626F74';
wwv_flow_imp.g_varchar2_table(14983) := '6822292C746869732E5F656E73757265526561644F6E6C7941747472696275746528292C746869732E7465787441726561436F7665723D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E746578744172';
wwv_flow_imp.g_varchar2_table(14984) := '6561436F7665722E736574506F736974696F6E28226162736F6C75746522293B636F6E7374206C3D7B6765744C696E65436F756E743A28293D3E746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E7428292C676574';
wwv_flow_imp.g_varchar2_table(14985) := '4C696E654D6178436F6C756D6E3A653D3E746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E2865292C67657456616C7565496E52616E67653A28652C74293D3E746869732E5F636F6E746578742E7669';
wwv_flow_imp.g_varchar2_table(14986) := '65774D6F64656C2E67657456616C7565496E52616E676528652C74292C67657456616C75654C656E677468496E52616E67653A28652C74293D3E746869732E5F636F6E746578742E766965774D6F64656C2E67657456616C75654C656E677468496E5261';
wwv_flow_imp.g_varchar2_table(14987) := '6E676528652C74292C6D6F64696679506F736974696F6E3A28652C74293D3E746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64696679506F736974696F6E28652C74297D2C643D7B67657444617461546F436F70793A28293D3E7B636F';
wwv_flow_imp.g_varchar2_table(14988) := '6E737420653D746869732E5F636F6E746578742E766965774D6F64656C2E676574506C61696E54657874546F436F707928746869732E5F6D6F64656C53656C656374696F6E732C746869732E5F656D70747953656C656374696F6E436C6970626F617264';
wwv_flow_imp.g_varchar2_table(14989) := '2C6A292C743D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E676574454F4C28292C6E3D746869732E5F656D70747953656C656374696F6E436C6970626F6172642626313D3D3D746869732E5F6D6F64656C53656C65637469';
wwv_flow_imp.g_varchar2_table(14990) := '6F6E732E6C656E6774682626746869732E5F6D6F64656C53656C656374696F6E735B305D2E6973456D70747928292C693D41727261792E697341727261792865293F653A6E756C6C2C6F3D41727261792E697341727261792865293F652E6A6F696E2874';
wwv_flow_imp.g_varchar2_table(14991) := '293A653B6C657420732C723D6E756C6C3B69662865782E666F726365436F70795769746853796E746178486967686C69676874696E677C7C746869732E5F636F70795769746853796E746178486967686C69676874696E6726266F2E6C656E6774683C36';
wwv_flow_imp.g_varchar2_table(14992) := '35353336297B636F6E737420653D746869732E5F636F6E746578742E766965774D6F64656C2E6765745269636854657874546F436F707928746869732E5F6D6F64656C53656C656374696F6E732C746869732E5F656D70747953656C656374696F6E436C';
wwv_flow_imp.g_varchar2_table(14993) := '6970626F617264293B65262628733D652E68746D6C2C723D652E6D6F6465297D72657475726E7B697346726F6D456D70747953656C656374696F6E3A6E2C6D756C7469637572736F72546578743A692C746578743A6F2C68746D6C3A732C6D6F64653A72';
wwv_flow_imp.g_varchar2_table(14994) := '7D7D2C67657453637265656E526561646572436F6E74656E743A28293D3E7B696628313D3D3D746869732E5F6163636573736962696C697479537570706F7274297B636F6E737420653D746869732E5F73656C656374696F6E735B305D3B696628712626';
wwv_flow_imp.g_varchar2_table(14995) := '652E6973456D7074792829297B636F6E737420743D652E6765745374617274506F736974696F6E28293B6C6574206E3D746869732E5F676574576F72644265666F7265506F736974696F6E2874293B696628303D3D3D6E2E6C656E6774682626286E3D74';
wwv_flow_imp.g_varchar2_table(14996) := '6869732E5F6765744368617261637465724265666F7265506F736974696F6E287429292C6E2E6C656E6774683E302972657475726E206E6577204753286E2C6E2E6C656E6774682C6E2E6C656E6774682C72682E66726F6D506F736974696F6E73287429';
wwv_flow_imp.g_varchar2_table(14997) := '2C30297D636F6E737420743D3530303B69662871262621652E6973456D707479282926266C2E67657456616C75654C656E677468496E52616E676528652C30293C74297B636F6E737420743D6C2E67657456616C7565496E52616E676528652C30293B72';
wwv_flow_imp.g_varchar2_table(14998) := '657475726E206E657720475328742C302C742E6C656E6774682C652C30297D69662875262621652E6973456D7074792829297B636F6E737420653D227673636F64652D706C616365686F6C646572223B72657475726E206E657720475328652C302C652E';
wwv_flow_imp.g_varchar2_table(14999) := '6C656E6774682C6E756C6C2C766F69642030297D72657475726E2047532E454D5054597D69662867297B636F6E737420653D746869732E5F73656C656374696F6E735B305D3B696628652E6973456D7074792829297B636F6E737420743D652E67657453';
wwv_flow_imp.g_varchar2_table(15000) := '74617274506F736974696F6E28292C5B6E2C695D3D746869732E5F676574416E64726F6964576F72644174506F736974696F6E2874293B6966286E2E6C656E6774683E302972657475726E206E6577204753286E2C692C692C72682E66726F6D506F7369';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(15001) := '74696F6E732874292C30297D72657475726E2047532E454D5054597D72657475726E2051532E66726F6D456469746F7253656C656374696F6E286C2C746869732E5F73656C656374696F6E735B305D2C746869732E5F6163636573736962696C69747950';
wwv_flow_imp.g_varchar2_table(15002) := '61676553697A652C303D3D3D746869732E5F6163636573736962696C697479537570706F7274297D2C6465647563654D6F64656C506F736974696F6E3A28652C742C6E293D3E746869732E5F636F6E746578742E766965774D6F64656C2E646564756365';
wwv_flow_imp.g_varchar2_table(15003) := '4D6F64656C506F736974696F6E52656C6174697665546F56696577506F736974696F6E28652C742C6E297D2C703D746869732E5F7265676973746572286E657720737828746869732E74657874417265612E646F6D4E6F646529293B746869732E5F7465';
wwv_flow_imp.g_varchar2_table(15004) := '787441726561496E7075743D746869732E5F726567697374657228746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652869782C642C702C74652C7B6973416E64726F69643A672C69734368726F6D65';
wwv_flow_imp.g_varchar2_table(15005) := '3A682C697346697265666F783A632C69735361666172693A757D29292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E4B6579446F776E2828653D3E7B746869732E5F76696577436F6E74726F6C6C65722E';
wwv_flow_imp.g_varchar2_table(15006) := '656D69744B6579446F776E2865297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E4B657955702828653D3E7B746869732E5F76696577436F6E74726F6C6C65722E656D69744B65795570286529';
wwv_flow_imp.g_varchar2_table(15007) := '7D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E50617374652828653D3E7B6C657420743D21312C6E3D6E756C6C2C693D6E756C6C3B652E6D65746164617461262628743D746869732E5F656D70';
wwv_flow_imp.g_varchar2_table(15008) := '747953656C656374696F6E436C6970626F61726426262121652E6D657461646174612E697346726F6D456D70747953656C656374696F6E2C6E3D766F69642030213D3D652E6D657461646174612E6D756C7469637572736F72546578743F652E6D657461';
wwv_flow_imp.g_varchar2_table(15009) := '646174612E6D756C7469637572736F72546578743A6E756C6C2C693D652E6D657461646174612E6D6F6465292C746869732E5F76696577436F6E74726F6C6C65722E706173746528652E746578742C742C6E2C69297D2929292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(15010) := '7374657228746869732E5F7465787441726561496E7075742E6F6E437574282828293D3E7B746869732E5F76696577436F6E74726F6C6C65722E63757428297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E70';
wwv_flow_imp.g_varchar2_table(15011) := '75742E6F6E547970652828653D3E7B652E7265706C6163655072657643686172436E747C7C652E7265706C6163654E65787443686172436E747C7C652E706F736974696F6E44656C74613F746869732E5F76696577436F6E74726F6C6C65722E636F6D70';
wwv_flow_imp.g_varchar2_table(15012) := '6F736974696F6E5479706528652E746578742C652E7265706C6163655072657643686172436E742C652E7265706C6163654E65787443686172436E742C652E706F736974696F6E44656C7461293A746869732E5F76696577436F6E74726F6C6C65722E74';
wwv_flow_imp.g_varchar2_table(15013) := '79706528652E74657874297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E53656C656374696F6E4368616E6765526571756573742828653D3E7B746869732E5F76696577436F6E74726F6C6C65';
wwv_flow_imp.g_varchar2_table(15014) := '722E73657453656C656374696F6E2865297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E436F6D706F736974696F6E53746172742828653D3E7B636F6E737420743D746869732E746578744172';
wwv_flow_imp.g_varchar2_table(15015) := '65612E646F6D4E6F64652C6E3D746869732E5F6D6F64656C53656C656374696F6E735B305D2C7B64697374616E6365546F4D6F64656C4C696E6553746172743A692C77696474684F6648696464656E546578744265666F72653A6F7D3D2828293D3E7B63';
wwv_flow_imp.g_varchar2_table(15016) := '6F6E737420653D742E76616C75652E737562737472696E6728302C4D6174682E6D696E28742E73656C656374696F6E53746172742C742E73656C656374696F6E456E6429292C693D652E6C617374496E6465784F6628225C6E22292C6F3D652E73756273';
wwv_flow_imp.g_varchar2_table(15017) := '7472696E6728692B31292C733D6F2E6C617374496E6465784F6628225C7422292C723D6F2E6C656E6774682D732D312C613D6E2E6765745374617274506F736974696F6E28292C6C3D4D6174682E6D696E28612E636F6C756D6E2D312C72292C633D612E';
wwv_flow_imp.g_varchar2_table(15018) := '636F6C756D6E2D312D6C2C643D6F2E737562737472696E6728302C6F2E6C656E6774682D6C292C7B74616253697A653A687D3D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744F7074696F6E7328292C753D66756E63';
wwv_flow_imp.g_varchar2_table(15019) := '74696F6E28652C742C6E2C69297B696628303D3D3D742E6C656E6774682972657475726E20303B636F6E7374206F3D652E637265617465456C656D656E74282264697622293B6F2E7374796C652E706F736974696F6E3D226162736F6C757465222C6F2E';
wwv_flow_imp.g_varchar2_table(15020) := '7374796C652E746F703D222D35303030307078222C6F2E7374796C652E77696474683D2235303030307078223B636F6E737420733D652E637265617465456C656D656E7428227370616E22293B724528732C6E292C732E7374796C652E77686974655370';
wwv_flow_imp.g_varchar2_table(15021) := '6163653D22707265222C732E7374796C652E74616253697A653D692A6E2E737061636557696474682B227078222C732E617070656E642874292C6F2E617070656E644368696C642873292C652E626F64792E617070656E644368696C64286F293B636F6E';
wwv_flow_imp.g_varchar2_table(15022) := '737420723D732E6F666673657457696474683B72657475726E20652E626F64792E72656D6F76654368696C64286F292C727D28746869732E74657874417265612E646F6D4E6F64652E6F776E6572446F63756D656E742C642C746869732E5F666F6E7449';
wwv_flow_imp.g_varchar2_table(15023) := '6E666F2C68293B72657475726E7B64697374616E6365546F4D6F64656C4C696E6553746172743A632C77696474684F6648696464656E546578744265666F72653A757D7D2928292C7B64697374616E6365546F4D6F64656C4C696E65456E643A737D3D28';
wwv_flow_imp.g_varchar2_table(15024) := '28293D3E7B636F6E737420653D742E76616C75652E737562737472696E67284D6174682E6D617828742E73656C656374696F6E53746172742C742E73656C656374696F6E456E6429292C693D652E696E6465784F6628225C6E22292C6F3D2D313D3D3D69';
wwv_flow_imp.g_varchar2_table(15025) := '3F653A652E737562737472696E6728302C69292C733D6F2E696E6465784F6628225C7422292C723D2D313D3D3D733F6F2E6C656E6774683A6F2E6C656E6774682D732D312C613D6E2E676574456E64506F736974696F6E28292C6C3D4D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(15026) := '28746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744C696E654D6178436F6C756D6E28612E6C696E654E756D626572292D612E636F6C756D6E2C72293B72657475726E7B64697374616E6365546F4D6F64656C4C696E65';
wwv_flow_imp.g_varchar2_table(15027) := '456E643A746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744C696E654D6178436F6C756D6E28612E6C696E654E756D626572292D612E636F6C756D6E2D6C7D7D2928293B746869732E5F636F6E746578742E766965774D';
wwv_flow_imp.g_varchar2_table(15028) := '6F64656C2E72657665616C52616E676528226B6579626F617264222C21302C72682E66726F6D506F736974696F6E7328746869732E5F73656C656374696F6E735B305D2E6765745374617274506F736974696F6E2829292C302C31292C746869732E5F76';
wwv_flow_imp.g_varchar2_table(15029) := '697369626C6554657874417265613D6E657720675028746869732E5F636F6E746578742C6E2E73746172744C696E654E756D6265722C692C6F2C73292C746869732E74657874417265612E736574417474726962757465282277726170222C746869732E';
wwv_flow_imp.g_varchar2_table(15030) := '5F74657874417265615772617070696E67262621746869732E5F76697369626C6554657874417265613F226F6E223A226F666622292C746869732E5F76697369626C6554657874417265612E7072657061726552656E64657228746869732E5F76697369';
wwv_flow_imp.g_varchar2_table(15031) := '626C6552616E676550726F7669646572292C746869732E5F72656E64657228292C746869732E74657874417265612E736574436C6173734E616D652860696E7075746172656120247B68507D20696D652D696E70757460292C746869732E5F7669657743';
wwv_flow_imp.g_varchar2_table(15032) := '6F6E74726F6C6C65722E636F6D706F736974696F6E537461727428292C746869732E5F636F6E746578742E766965774D6F64656C2E6F6E436F6D706F736974696F6E537461727428297D2929292C746869732E5F726567697374657228746869732E5F74';
wwv_flow_imp.g_varchar2_table(15033) := '65787441726561496E7075742E6F6E436F6D706F736974696F6E5570646174652828653D3E7B746869732E5F76697369626C655465787441726561262628746869732E5F76697369626C6554657874417265612E7072657061726552656E646572287468';
wwv_flow_imp.g_varchar2_table(15034) := '69732E5F76697369626C6552616E676550726F7669646572292C746869732E5F72656E6465722829297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E436F6D706F736974696F6E456E64282828';
wwv_flow_imp.g_varchar2_table(15035) := '293D3E7B746869732E5F76697369626C6554657874417265613D6E756C6C2C746869732E74657874417265612E736574417474726962757465282277726170222C746869732E5F74657874417265615772617070696E67262621746869732E5F76697369';
wwv_flow_imp.g_varchar2_table(15036) := '626C6554657874417265613F226F6E223A226F666622292C746869732E5F72656E64657228292C746869732E74657874417265612E736574436C6173734E616D652860696E7075746172656120247B68507D60292C746869732E5F76696577436F6E7472';
wwv_flow_imp.g_varchar2_table(15037) := '6F6C6C65722E636F6D706F736974696F6E456E6428292C746869732E5F636F6E746578742E766965774D6F64656C2E6F6E436F6D706F736974696F6E456E6428297D2929292C746869732E5F726567697374657228746869732E5F746578744172656149';
wwv_flow_imp.g_varchar2_table(15038) := '6E7075742E6F6E466F637573282828293D3E7B746869732E5F636F6E746578742E766965774D6F64656C2E736574486173466F637573282130297D2929292C746869732E5F726567697374657228746869732E5F7465787441726561496E7075742E6F6E';
wwv_flow_imp.g_varchar2_table(15039) := '426C7572282828293D3E7B746869732E5F636F6E746578742E766965774D6F64656C2E736574486173466F637573282131297D2929292C746869732E5F72656769737465722875502E6F6E4469644368616E6765282828293D3E7B746869732E5F656E73';
wwv_flow_imp.g_varchar2_table(15040) := '757265526561644F6E6C7941747472696275746528297D2929297D777269746553637265656E526561646572436F6E74656E742865297B746869732E5F7465787441726561496E7075742E77726974654E61746976655465787441726561436F6E74656E';
wwv_flow_imp.g_varchar2_table(15041) := '742865297D646973706F736528297B73757065722E646973706F736528297D5F676574416E64726F6964576F72644174506F736974696F6E2865297B636F6E737420743D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E6543';
wwv_flow_imp.g_varchar2_table(15042) := '6F6E74656E7428652E6C696E654E756D626572292C6E3D59792827607E21402324255E262A28292D3D2B5B7B5D7D5C5C7C3B3A222C2E3C3E2F3F272C5B5D293B6C657420693D21302C6F3D652E636F6C756D6E2C733D21302C723D652E636F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(15043) := '613D303B666F72283B613C3530262628697C7C73293B297B6966286926266F3C3D31262628693D2131292C69297B636F6E737420653D742E63686172436F64654174286F2D32293B30213D3D6E2E6765742865293F693D21313A6F2D2D7D696628732626';
wwv_flow_imp.g_varchar2_table(15044) := '723E742E6C656E677468262628733D2131292C73297B636F6E737420653D742E63686172436F6465417428722D31293B30213D3D6E2E6765742865293F733D21313A722B2B7D612B2B7D72657475726E5B742E737562737472696E67286F2D312C722D31';
wwv_flow_imp.g_varchar2_table(15045) := '292C652E636F6C756D6E2D6F5D7D5F676574576F72644265666F7265506F736974696F6E2865297B636F6E737420743D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F6E74656E7428652E6C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(15046) := '2C6E3D597928746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313331292C5B5D293B6C657420693D652E636F6C756D6E2C6F3D303B666F72283B693E313B297B636F6E737420733D742E6368617243';
wwv_flow_imp.g_varchar2_table(15047) := '6F6465417428692D32293B69662830213D3D6E2E6765742873297C7C6F3E35302972657475726E20742E737562737472696E6728692D312C652E636F6C756D6E2D31293B6F2B2B2C692D2D7D72657475726E20742E737562737472696E6728302C652E63';
wwv_flow_imp.g_varchar2_table(15048) := '6F6C756D6E2D31297D5F6765744368617261637465724265666F7265506F736974696F6E2865297B696628652E636F6C756D6E3E31297B636F6E737420743D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F6E74656E';
wwv_flow_imp.g_varchar2_table(15049) := '7428652E6C696E654E756D626572292E63686172417428652E636F6C756D6E2D32293B69662821546928742E63686172436F64654174283029292972657475726E20747D72657475726E22227D5F676574417269614C6162656C2865297B76617220742C';
wwv_flow_imp.g_varchar2_table(15050) := '6E2C693B696628313D3D3D652E676574283229297B636F6E737420653D6E756C6C3D3D3D28743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672822656469746F722E616374696F6E2E746F67676C';
wwv_flow_imp.g_varchar2_table(15051) := '6553637265656E5265616465724163636573736962696C6974794D6F64652229297C7C766F696420303D3D3D743F766F696420303A742E676574417269614C6162656C28292C6F3D6E756C6C3D3D3D286E3D746869732E5F6B657962696E64696E675365';
wwv_flow_imp.g_varchar2_table(15052) := '72766963652E6C6F6F6B75704B657962696E64696E672822776F726B62656E63682E616374696F6E2E73686F77436F6D6D616E64732229297C7C766F696420303D3D3D6E3F766F696420303A6E2E676574417269614C6162656C28292C733D6E756C6C3D';
wwv_flow_imp.g_varchar2_table(15053) := '3D3D28693D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672822776F726B62656E63682E616374696F6E2E6F70656E476C6F62616C4B657962696E64696E67732229297C7C766F696420303D3D3D69';
wwv_flow_imp.g_varchar2_table(15054) := '3F766F696420303A692E676574417269614C6162656C28292C723D6228302C2254686520656469746F72206973206E6F742061636365737369626C6520617420746869732074696D652E22293B72657475726E20653F6228302C227B307D20546F20656E';
wwv_flow_imp.g_varchar2_table(15055) := '61626C652073637265656E20726561646572206F7074696D697A6564206D6F64652C20757365207B317D222C722C65293A6F3F6228302C227B307D20546F20656E61626C652073637265656E20726561646572206F7074696D697A6564206D6F64652C20';
wwv_flow_imp.g_varchar2_table(15056) := '6F70656E2074686520717569636B207069636B2077697468207B317D20616E642072756E2074686520636F6D6D616E6420546F67676C652053637265656E20526561646572204163636573736962696C697479204D6F64652C2077686963682069732063';
wwv_flow_imp.g_varchar2_table(15057) := '757272656E746C79206E6F74207472696767657261626C6520766961206B6579626F6172642E222C722C6F293A733F6228302C227B307D20506C656173652061737369676E2061206B657962696E64696E6720666F722074686520636F6D6D616E642054';
wwv_flow_imp.g_varchar2_table(15058) := '6F67676C652053637265656E20526561646572204163636573736962696C697479204D6F646520627920616363657373696E6720746865206B657962696E64696E677320656469746F722077697468207B317D20616E642072756E2069742E222C722C73';
wwv_flow_imp.g_varchar2_table(15059) := '293A727D72657475726E20652E6765742834297D5F7365744163636573736962696C6974794F7074696F6E732865297B746869732E5F6163636573736962696C697479537570706F72743D652E6765742832293B636F6E737420743D652E676574283329';
wwv_flow_imp.g_varchar2_table(15060) := '3B323D3D3D746869732E5F6163636573736962696C697479537570706F72742626743D3D3D594C2E6163636573736962696C6974795061676553697A652E64656661756C7456616C75653F746869732E5F6163636573736962696C697479506167655369';
wwv_flow_imp.g_varchar2_table(15061) := '7A653D3530303A746869732E5F6163636573736962696C6974795061676553697A653D743B636F6E7374206E3D652E67657428313435292E7772617070696E67436F6C756D6E3B6966282D31213D3D6E262631213D3D746869732E5F6163636573736962';
wwv_flow_imp.g_varchar2_table(15062) := '696C697479537570706F7274297B636F6E737420743D652E676574283530293B746869732E5F74657874417265615772617070696E673D21302C746869732E5F746578744172656157696474683D4D6174682E726F756E64286E2A742E7479706963616C';
wwv_flow_imp.g_varchar2_table(15063) := '48616C6677696474684368617261637465725769647468297D656C736520746869732E5F74657874417265615772617070696E673D21312C746869732E5F746578744172656157696474683D6D503F303A317D6F6E436F6E66696775726174696F6E4368';
wwv_flow_imp.g_varchar2_table(15064) := '616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B746869732E5F7365744163636573736962696C6974794F7074696F6E732874292C74';
wwv_flow_imp.g_varchar2_table(15065) := '6869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E5F636F6E74656E7457696474683D6E2E636F6E74656E7457696474682C746869732E5F636F6E74656E744865696768743D6E2E6865696768742C746869732E5F';
wwv_flow_imp.g_varchar2_table(15066) := '666F6E74496E666F3D742E676574283530292C746869732E5F6C696E654865696768743D742E676574283637292C746869732E5F656D70747953656C656374696F6E436C6970626F6172643D742E676574283337292C746869732E5F636F707957697468';
wwv_flow_imp.g_varchar2_table(15067) := '53796E746178486967686C69676874696E673D742E676574283235292C746869732E74657874417265612E736574417474726962757465282277726170222C746869732E5F74657874417265615772617070696E67262621746869732E5F76697369626C';
wwv_flow_imp.g_varchar2_table(15068) := '6554657874417265613F226F6E223A226F666622293B636F6E73747B74616253697A653A697D3D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744F7074696F6E7328293B72657475726E20746869732E746578744172';
wwv_flow_imp.g_varchar2_table(15069) := '65612E646F6D4E6F64652E7374796C652E74616253697A653D692A746869732E5F666F6E74496E666F2E737061636557696474682B227078222C746869732E74657874417265612E7365744174747269627574652822617269612D6C6162656C222C7468';
wwv_flow_imp.g_varchar2_table(15070) := '69732E5F676574417269614C6162656C287429292C746869732E74657874417265612E7365744174747269627574652822617269612D7265717569726564222C742E6765742835293F2274727565223A2266616C736522292C746869732E746578744172';
wwv_flow_imp.g_varchar2_table(15071) := '65612E7365744174747269627574652822746162696E646578222C537472696E6728742E676574283132342929292C28652E6861734368616E676564283334297C7C652E6861734368616E67656428393129292626746869732E5F656E73757265526561';
wwv_flow_imp.g_varchar2_table(15072) := '644F6E6C7941747472696275746528292C652E6861734368616E6765642832292626746869732E5F7465787441726561496E7075742E77726974654E61746976655465787441726561436F6E74656E7428227374726174656779206368616E6765642229';
wwv_flow_imp.g_varchar2_table(15073) := '2C21307D6F6E437572736F7253746174654368616E6765642865297B72657475726E20746869732E5F73656C656374696F6E733D652E73656C656374696F6E732E736C6963652830292C746869732E5F6D6F64656C53656C656374696F6E733D652E6D6F';
wwv_flow_imp.g_varchar2_table(15074) := '64656C53656C656374696F6E732E736C6963652830292C746869732E5F7465787441726561496E7075742E77726974654E61746976655465787441726561436F6E74656E74282273656C656374696F6E206368616E67656422292C21307D6F6E4465636F';
wwv_flow_imp.g_varchar2_table(15075) := '726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E';
wwv_flow_imp.g_varchar2_table(15076) := '21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20746869732E5F7363726F6C6C4C6566743D652E7363726F6C6C4C6566742C746869732E5F7363726F6C6C54';
wwv_flow_imp.g_varchar2_table(15077) := '6F703D652E7363726F6C6C546F702C21307D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D6973466F637573656428297B72657475726E20746869732E5F7465787441726561496E7075742E6973466F637573656428297D666F6375';
wwv_flow_imp.g_varchar2_table(15078) := '73546578744172656128297B746869732E5F7465787441726561496E7075742E666F637573546578744172656128297D6765744C61737452656E6465724461746128297B72657475726E20746869732E5F6C61737452656E646572506F736974696F6E7D';
wwv_flow_imp.g_varchar2_table(15079) := '736574417269614F7074696F6E732865297B652E61637469766544657363656E64616E743F28746869732E74657874417265612E7365744174747269627574652822617269612D686173706F707570222C227472756522292C746869732E746578744172';
wwv_flow_imp.g_varchar2_table(15080) := '65612E7365744174747269627574652822617269612D6175746F636F6D706C657465222C226C69737422292C746869732E74657874417265612E7365744174747269627574652822617269612D61637469766564657363656E64616E74222C652E616374';
wwv_flow_imp.g_varchar2_table(15081) := '69766544657363656E64616E7429293A28746869732E74657874417265612E7365744174747269627574652822617269612D686173706F707570222C2266616C736522292C746869732E74657874417265612E7365744174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(15082) := '612D6175746F636F6D706C657465222C22626F746822292C746869732E74657874417265612E72656D6F76654174747269627574652822617269612D61637469766564657363656E64616E742229292C652E726F6C652626746869732E74657874417265';
wwv_flow_imp.g_varchar2_table(15083) := '612E7365744174747269627574652822726F6C65222C652E726F6C65297D5F656E73757265526561644F6E6C7941747472696275746528297B636F6E737420653D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(15084) := '3B2175502E656E61626C65647C7C652E676574283334292626652E676574283931293F746869732E74657874417265612E7365744174747269627574652822726561646F6E6C79222C227472756522293A746869732E74657874417265612E72656D6F76';
wwv_flow_imp.g_varchar2_table(15085) := '654174747269627574652822726561646F6E6C7922297D7072657061726552656E6465722865297B76617220743B746869732E5F7072696D617279437572736F72506F736974696F6E3D6E6577206D6328746869732E5F73656C656374696F6E735B305D';
wwv_flow_imp.g_varchar2_table(15086) := '2E706F736974696F6E4C696E654E756D6265722C746869732E5F73656C656374696F6E735B305D2E706F736974696F6E436F6C756D6E292C746869732E5F7072696D617279437572736F7256697369626C6552616E67653D652E76697369626C6552616E';
wwv_flow_imp.g_varchar2_table(15087) := '6765466F72506F736974696F6E28746869732E5F7072696D617279437572736F72506F736974696F6E292C6E756C6C3D3D3D28743D746869732E5F76697369626C655465787441726561297C7C766F696420303D3D3D747C7C742E707265706172655265';
wwv_flow_imp.g_varchar2_table(15088) := '6E6465722865297D72656E6465722865297B746869732E5F7465787441726561496E7075742E77726974654E61746976655465787441726561436F6E74656E74282272656E64657222292C746869732E5F72656E64657228297D5F72656E64657228297B';
wwv_flow_imp.g_varchar2_table(15089) := '76617220653B696628746869732E5F76697369626C655465787441726561297B636F6E737420653D746869732E5F76697369626C6554657874417265612E76697369626C65546578746172656153746172742C743D746869732E5F76697369626C655465';
wwv_flow_imp.g_varchar2_table(15090) := '7874417265612E76697369626C655465787461726561456E642C6E3D746869732E5F76697369626C6554657874417265612E7374617274506F736974696F6E2C693D746869732E5F76697369626C6554657874417265612E656E64506F736974696F6E3B';
wwv_flow_imp.g_varchar2_table(15091) := '6966286E2626692626652626742626742E6C6566743E3D746869732E5F7363726F6C6C4C6566742626652E6C6566743C3D746869732E5F7363726F6C6C4C6566742B746869732E5F636F6E74656E745769647468297B636F6E7374206F3D746869732E5F';
wwv_flow_imp.g_varchar2_table(15092) := '636F6E746578742E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228746869732E5F7072696D617279437572736F72506F736974696F6E2E6C696E654E756D626572292D746869732E5F7363726F';
wwv_flow_imp.g_varchar2_table(15093) := '6C6C546F702C733D746869732E5F6E65776C696E65636F756E7428746869732E74657874417265612E646F6D4E6F64652E76616C75652E73756273747228302C746869732E74657874417265612E646F6D4E6F64652E73656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(15094) := '29293B6C657420723D746869732E5F76697369626C6554657874417265612E77696474684F6648696464656E4C696E65546578744265666F72652C613D746869732E5F636F6E74656E744C6566742B652E6C6566742D746869732E5F7363726F6C6C4C65';
wwv_flow_imp.g_varchar2_table(15095) := '66742C6C3D742E6C6566742D652E6C6566742B313B696628613C746869732E5F636F6E74656E744C656674297B636F6E737420653D746869732E5F636F6E74656E744C6566742D613B612B3D652C722B3D652C6C2D3D657D6C3E746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(15096) := '656E7457696474682626286C3D746869732E5F636F6E74656E745769647468293B636F6E737420633D746869732E5F636F6E746578742E766965774D6F64656C2E676574566965774C696E6544617461286E2E6C696E654E756D626572292C643D632E74';
wwv_flow_imp.g_varchar2_table(15097) := '6F6B656E732E66696E64546F6B656E496E64657841744F6666736574286E2E636F6C756D6E2D31292C683D643D3D3D632E746F6B656E732E66696E64546F6B656E496E64657841744F666673657428692E636F6C756D6E2D31292C753D746869732E5F76';
wwv_flow_imp.g_varchar2_table(15098) := '697369626C6554657874417265612E646566696E6550726573656E746174696F6E28683F632E746F6B656E732E67657450726573656E746174696F6E2864293A6E756C6C293B746869732E74657874417265612E646F6D4E6F64652E7363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(15099) := '703D732A746869732E5F6C696E654865696768742C746869732E74657874417265612E646F6D4E6F64652E7363726F6C6C4C6566743D722C746869732E5F646F52656E646572287B6C61737452656E646572506F736974696F6E3A6E756C6C2C746F703A';
wwv_flow_imp.g_varchar2_table(15100) := '6F2C6C6566743A612C77696474683A6C2C6865696768743A746869732E5F6C696E654865696768742C757365436F7665723A21312C636F6C6F723A2850772E676574436F6C6F724D617028297C7C5B5D295B752E666F726567726F756E645D2C6974616C';
wwv_flow_imp.g_varchar2_table(15101) := '69633A752E6974616C69632C626F6C643A752E626F6C642C756E6465726C696E653A752E756E6465726C696E652C737472696B657468726F7567683A752E737472696B657468726F7567687D297D72657475726E7D69662821746869732E5F7072696D61';
wwv_flow_imp.g_varchar2_table(15102) := '7279437572736F7256697369626C6552616E67652972657475726E20766F696420746869732E5F72656E6465724174546F704C65667428293B636F6E737420743D746869732E5F636F6E74656E744C6566742B746869732E5F7072696D61727943757273';
wwv_flow_imp.g_varchar2_table(15103) := '6F7256697369626C6552616E67652E6C6566742D746869732E5F7363726F6C6C4C6566743B696628743C746869732E5F636F6E74656E744C6566747C7C743E746869732E5F636F6E74656E744C6566742B746869732E5F636F6E74656E74576964746829';
wwv_flow_imp.g_varchar2_table(15104) := '72657475726E20766F696420746869732E5F72656E6465724174546F704C65667428293B636F6E7374206E3D746869732E5F636F6E746578742E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228';
wwv_flow_imp.g_varchar2_table(15105) := '746869732E5F73656C656374696F6E735B305D2E706F736974696F6E4C696E654E756D626572292D746869732E5F7363726F6C6C546F703B6966286E3C307C7C6E3E746869732E5F636F6E74656E7448656967687429746869732E5F72656E6465724174';
wwv_flow_imp.g_varchar2_table(15106) := '546F704C65667428293B656C736520696628717C7C323D3D3D746869732E5F6163636573736962696C697479537570706F7274297B746869732E5F646F52656E646572287B6C61737452656E646572506F736974696F6E3A746869732E5F7072696D6172';
wwv_flow_imp.g_varchar2_table(15107) := '79437572736F72506F736974696F6E2C746F703A6E2C6C6566743A746869732E5F74657874417265615772617070696E673F746869732E5F636F6E74656E744C6566743A742C77696474683A746869732E5F746578744172656157696474682C68656967';
wwv_flow_imp.g_varchar2_table(15108) := '68743A746869732E5F6C696E654865696768742C757365436F7665723A21317D292C746869732E74657874417265612E646F6D4E6F64652E7363726F6C6C4C6566743D746869732E5F7072696D617279437572736F7256697369626C6552616E67652E6C';
wwv_flow_imp.g_varchar2_table(15109) := '6566743B636F6E737420693D6E756C6C213D3D28653D746869732E5F7465787441726561496E7075742E746578744172656153746174652E6E65776C696E65436F756E744265666F726553656C656374696F6E292626766F69642030213D3D653F653A74';
wwv_flow_imp.g_varchar2_table(15110) := '6869732E5F6E65776C696E65636F756E7428746869732E74657874417265612E646F6D4E6F64652E76616C75652E73756273747228302C746869732E74657874417265612E646F6D4E6F64652E73656C656374696F6E537461727429293B746869732E74';
wwv_flow_imp.g_varchar2_table(15111) := '657874417265612E646F6D4E6F64652E7363726F6C6C546F703D692A746869732E5F6C696E654865696768747D656C736520746869732E5F646F52656E646572287B6C61737452656E646572506F736974696F6E3A746869732E5F7072696D6172794375';
wwv_flow_imp.g_varchar2_table(15112) := '72736F72506F736974696F6E2C746F703A6E2C6C6566743A746869732E5F74657874417265615772617070696E673F746869732E5F636F6E74656E744C6566743A742C77696474683A746869732E5F746578744172656157696474682C6865696768743A';
wwv_flow_imp.g_varchar2_table(15113) := '6D503F303A312C757365436F7665723A21317D297D5F6E65776C696E65636F756E742865297B6C657420743D302C6E3D2D313B666F72283B6E3D652E696E6465784F6628225C6E222C6E2B31292C2D31213D3D6E3B29742B2B3B72657475726E20747D5F';
wwv_flow_imp.g_varchar2_table(15114) := '72656E6465724174546F704C65667428297B746869732E5F646F52656E646572287B6C61737452656E646572506F736974696F6E3A6E756C6C2C746F703A302C6C6566743A302C77696474683A746869732E5F746578744172656157696474682C686569';
wwv_flow_imp.g_varchar2_table(15115) := '6768743A6D503F303A312C757365436F7665723A21307D297D5F646F52656E6465722865297B746869732E5F6C61737452656E646572506F736974696F6E3D652E6C61737452656E646572506F736974696F6E3B636F6E737420743D746869732E746578';
wwv_flow_imp.g_varchar2_table(15116) := '74417265612C6E3D746869732E7465787441726561436F7665723B724528742C746869732E5F666F6E74496E666F292C742E736574546F7028652E746F70292C742E7365744C65667428652E6C656674292C742E736574576964746828652E7769647468';
wwv_flow_imp.g_varchar2_table(15117) := '292C742E73657448656967687428652E686569676874292C742E736574436F6C6F7228652E636F6C6F723F68752E466F726D61742E4353532E666F726D617448657828652E636F6C6F72293A2222292C742E736574466F6E745374796C6528652E697461';
wwv_flow_imp.g_varchar2_table(15118) := '6C69633F226974616C6963223A2222292C652E626F6C642626742E736574466F6E745765696768742822626F6C6422292C742E736574546578744465636F726174696F6E2860247B652E756E6465726C696E653F2220756E6465726C696E65223A22227D';
wwv_flow_imp.g_varchar2_table(15119) := '247B652E737472696B657468726F7567683F22206C696E652D7468726F756768223A22227D60292C6E2E736574546F7028652E757365436F7665723F652E746F703A30292C6E2E7365744C65667428652E757365436F7665723F652E6C6566743A30292C';
wwv_flow_imp.g_varchar2_table(15120) := '6E2E736574576964746828652E757365436F7665723F652E77696474683A30292C6E2E73657448656967687428652E757365436F7665723F652E6865696768743A30293B636F6E737420693D746869732E5F636F6E746578742E636F6E66696775726174';
wwv_flow_imp.g_varchar2_table(15121) := '696F6E2E6F7074696F6E733B692E676574283537293F6E2E736574436C6173734E616D6528226D6F6E61636F2D656469746F722D6261636B67726F756E64207465787441726561436F76657220222B6C502E4F555445525F434C4153535F4E414D45293A';
wwv_flow_imp.g_varchar2_table(15122) := '30213D3D692E676574283638292E72656E646572547970653F6E2E736574436C6173734E616D6528226D6F6E61636F2D656469746F722D6261636B67726F756E64207465787441726561436F76657220222B73502E434C4153535F4E414D45293A6E2E73';
wwv_flow_imp.g_varchar2_table(15123) := '6574436C6173734E616D6528226D6F6E61636F2D656469746F722D6261636B67726F756E64207465787441726561436F76657222297D7D3B66503D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774';
wwv_flow_imp.g_varchar2_table(15124) := '682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D';
wwv_flow_imp.g_varchar2_table(15125) := '3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D2926262872';
wwv_flow_imp.g_varchar2_table(15126) := '3D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B705028332C2445292C705028342C7563';
wwv_flow_imp.g_varchar2_table(15127) := '295D2C6650293B636C6173732076507B636F6E7374727563746F7228652C742C6E2C69297B746869732E636F6E66696775726174696F6E3D652C746869732E766965774D6F64656C3D742C746869732E75736572496E7075744576656E74733D6E2C7468';
wwv_flow_imp.g_varchar2_table(15128) := '69732E636F6D6D616E6444656C65676174653D697D706173746528652C742C6E2C69297B746869732E636F6D6D616E6444656C65676174652E706173746528652C742C6E2C69297D747970652865297B746869732E636F6D6D616E6444656C6567617465';
wwv_flow_imp.g_varchar2_table(15129) := '2E747970652865297D636F6D706F736974696F6E5479706528652C742C6E2C69297B746869732E636F6D6D616E6444656C65676174652E636F6D706F736974696F6E5479706528652C742C6E2C69297D636F6D706F736974696F6E537461727428297B74';
wwv_flow_imp.g_varchar2_table(15130) := '6869732E636F6D6D616E6444656C65676174652E7374617274436F6D706F736974696F6E28297D636F6D706F736974696F6E456E6428297B746869732E636F6D6D616E6444656C65676174652E656E64436F6D706F736974696F6E28297D63757428297B';
wwv_flow_imp.g_varchar2_table(15131) := '746869732E636F6D6D616E6444656C65676174652E63757428297D73657453656C656374696F6E2865297B52532E53657453656C656374696F6E2E72756E436F7265456469746F72436F6D6D616E6428746869732E766965774D6F64656C2C7B736F7572';
wwv_flow_imp.g_varchar2_table(15132) := '63653A226B6579626F617264222C73656C656374696F6E3A657D297D5F76616C696461746556696577436F6C756D6E2865297B636F6E737420743D746869732E766965774D6F64656C2E6765744C696E654D696E436F6C756D6E28652E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(15133) := '626572293B72657475726E20652E636F6C756D6E3C743F6E6577206D6328652E6C696E654E756D6265722C74293A657D5F6861734D756C7469637572736F724D6F6469666965722865297B73776974636828746869732E636F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(15134) := '2E6F7074696F6E732E67657428373829297B6361736522616C744B6579223A72657475726E20652E616C744B65793B63617365226374726C4B6579223A72657475726E20652E6374726C4B65793B63617365226D6574614B6579223A72657475726E2065';
wwv_flow_imp.g_varchar2_table(15135) := '2E6D6574614B65793B64656661756C743A72657475726E21317D7D5F6861734E6F6E4D756C7469637572736F724D6F6469666965722865297B73776974636828746869732E636F6E66696775726174696F6E2E6F7074696F6E732E67657428373829297B';
wwv_flow_imp.g_varchar2_table(15136) := '6361736522616C744B6579223A72657475726E20652E6374726C4B65797C7C652E6D6574614B65793B63617365226374726C4B6579223A72657475726E20652E616C744B65797C7C652E6D6574614B65793B63617365226D6574614B6579223A72657475';
wwv_flow_imp.g_varchar2_table(15137) := '726E20652E6374726C4B65797C7C652E616C744B65793B64656661756C743A72657475726E21317D7D64697370617463684D6F7573652865297B636F6E737420743D746869732E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D242626742E';
wwv_flow_imp.g_varchar2_table(15138) := '67657428313037292C693D742E676574283232293B652E6D6964646C65427574746F6E2626216E3F746869732E5F636F6C756D6E53656C65637428652E706F736974696F6E2C652E6D6F757365436F6C756D6E2C652E696E53656C656374696F6E4D6F64';
wwv_flow_imp.g_varchar2_table(15139) := '65293A652E737461727465644F6E4C696E654E756D626572733F746869732E5F6861734D756C7469637572736F724D6F6469666965722865293F652E696E53656C656374696F6E4D6F64653F746869732E5F6C617374437572736F724C696E6553656C65';
wwv_flow_imp.g_varchar2_table(15140) := '637428652E706F736974696F6E2C652E72657665616C54797065293A746869732E5F637265617465437572736F7228652E706F736974696F6E2C2130293A652E696E53656C656374696F6E4D6F64653F746869732E5F6C696E6553656C65637444726167';
wwv_flow_imp.g_varchar2_table(15141) := '28652E706F736974696F6E2C652E72657665616C54797065293A746869732E5F6C696E6553656C65637428652E706F736974696F6E2C652E72657665616C54797065293A652E6D6F757365446F776E436F756E743E3D343F746869732E5F73656C656374';
wwv_flow_imp.g_varchar2_table(15142) := '416C6C28293A333D3D3D652E6D6F757365446F776E436F756E743F746869732E5F6861734D756C7469637572736F724D6F6469666965722865293F652E696E53656C656374696F6E4D6F64653F746869732E5F6C617374437572736F724C696E6553656C';
wwv_flow_imp.g_varchar2_table(15143) := '6563744472616728652E706F736974696F6E2C652E72657665616C54797065293A746869732E5F6C617374437572736F724C696E6553656C65637428652E706F736974696F6E2C652E72657665616C54797065293A652E696E53656C656374696F6E4D6F';
wwv_flow_imp.g_varchar2_table(15144) := '64653F746869732E5F6C696E6553656C6563744472616728652E706F736974696F6E2C652E72657665616C54797065293A746869732E5F6C696E6553656C65637428652E706F736974696F6E2C652E72657665616C54797065293A323D3D3D652E6D6F75';
wwv_flow_imp.g_varchar2_table(15145) := '7365446F776E436F756E743F652E6F6E496E6A6563746564546578747C7C28746869732E5F6861734D756C7469637572736F724D6F6469666965722865293F746869732E5F6C617374437572736F72576F726453656C65637428652E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(15146) := '2C652E72657665616C54797065293A652E696E53656C656374696F6E4D6F64653F746869732E5F776F726453656C6563744472616728652E706F736974696F6E2C652E72657665616C54797065293A746869732E5F776F726453656C65637428652E706F';
wwv_flow_imp.g_varchar2_table(15147) := '736974696F6E2C652E72657665616C5479706529293A746869732E5F6861734D756C7469637572736F724D6F6469666965722865293F746869732E5F6861734E6F6E4D756C7469637572736F724D6F6469666965722865297C7C28652E73686966744B65';
wwv_flow_imp.g_varchar2_table(15148) := '793F746869732E5F636F6C756D6E53656C65637428652E706F736974696F6E2C652E6D6F757365436F6C756D6E2C2130293A652E696E53656C656374696F6E4D6F64653F746869732E5F6C617374437572736F724D6F7665546F53656C65637428652E70';
wwv_flow_imp.g_varchar2_table(15149) := '6F736974696F6E2C652E72657665616C54797065293A746869732E5F637265617465437572736F7228652E706F736974696F6E2C213129293A652E696E53656C656374696F6E4D6F64653F652E616C744B65797C7C693F746869732E5F636F6C756D6E53';
wwv_flow_imp.g_varchar2_table(15150) := '656C65637428652E706F736974696F6E2C652E6D6F757365436F6C756D6E2C2130293A746869732E5F6D6F7665546F53656C65637428652E706F736974696F6E2C652E72657665616C54797065293A746869732E6D6F7665546F28652E706F736974696F';
wwv_flow_imp.g_varchar2_table(15151) := '6E2C652E72657665616C54797065297D5F757375616C4172677328652C74297B72657475726E20653D746869732E5F76616C696461746556696577436F6C756D6E2865292C7B736F757263653A226D6F757365222C706F736974696F6E3A746869732E5F';
wwv_flow_imp.g_varchar2_table(15152) := '636F6E7665727456696577546F4D6F64656C506F736974696F6E2865292C76696577506F736974696F6E3A652C72657665616C547970653A747D7D6D6F7665546F28652C74297B52532E4D6F7665546F2E72756E436F7265456469746F72436F6D6D616E';
wwv_flow_imp.g_varchar2_table(15153) := '6428746869732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F6D6F7665546F53656C65637428652C74297B52532E4D6F7665546F53656C6563742E72756E436F7265456469746F72436F6D6D616E6428746869732E';
wwv_flow_imp.g_varchar2_table(15154) := '766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F636F6C756D6E53656C65637428652C742C6E297B653D746869732E5F76616C696461746556696577436F6C756D6E2865292C52532E436F6C756D6E53656C6563742E72';
wwv_flow_imp.g_varchar2_table(15155) := '756E436F7265456469746F72436F6D6D616E6428746869732E766965774D6F64656C2C7B736F757263653A226D6F757365222C706F736974696F6E3A746869732E5F636F6E7665727456696577546F4D6F64656C506F736974696F6E2865292C76696577';
wwv_flow_imp.g_varchar2_table(15156) := '506F736974696F6E3A652C6D6F757365436F6C756D6E3A742C646F436F6C756D6E53656C6563743A6E7D297D5F637265617465437572736F7228652C74297B653D746869732E5F76616C696461746556696577436F6C756D6E2865292C52532E43726561';
wwv_flow_imp.g_varchar2_table(15157) := '7465437572736F722E72756E436F7265456469746F72436F6D6D616E6428746869732E766965774D6F64656C2C7B736F757263653A226D6F757365222C706F736974696F6E3A746869732E5F636F6E7665727456696577546F4D6F64656C506F73697469';
wwv_flow_imp.g_varchar2_table(15158) := '6F6E2865292C76696577506F736974696F6E3A652C77686F6C654C696E653A747D297D5F6C617374437572736F724D6F7665546F53656C65637428652C74297B52532E4C617374437572736F724D6F7665546F53656C6563742E72756E436F7265456469';
wwv_flow_imp.g_varchar2_table(15159) := '746F72436F6D6D616E6428746869732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F776F726453656C65637428652C74297B52532E576F726453656C6563742E72756E436F7265456469746F72436F6D6D616E6428';
wwv_flow_imp.g_varchar2_table(15160) := '746869732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F776F726453656C6563744472616728652C74297B52532E576F726453656C656374447261672E72756E436F7265456469746F72436F6D6D616E6428746869';
wwv_flow_imp.g_varchar2_table(15161) := '732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F6C617374437572736F72576F726453656C65637428652C74297B52532E4C617374437572736F72576F726453656C6563742E72756E436F7265456469746F72436F';
wwv_flow_imp.g_varchar2_table(15162) := '6D6D616E6428746869732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F6C696E6553656C65637428652C74297B52532E4C696E6553656C6563742E72756E436F7265456469746F72436F6D6D616E6428746869732E';
wwv_flow_imp.g_varchar2_table(15163) := '766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F6C696E6553656C6563744472616728652C74297B52532E4C696E6553656C656374447261672E72756E436F7265456469746F72436F6D6D616E6428746869732E766965';
wwv_flow_imp.g_varchar2_table(15164) := '774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F6C617374437572736F724C696E6553656C65637428652C74297B52532E4C617374437572736F724C696E6553656C6563742E72756E436F7265456469746F72436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(15165) := '28746869732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F6C617374437572736F724C696E6553656C6563744472616728652C74297B52532E4C617374437572736F724C696E6553656C656374447261672E72756E';
wwv_flow_imp.g_varchar2_table(15166) := '436F7265456469746F72436F6D6D616E6428746869732E766965774D6F64656C2C746869732E5F757375616C4172677328652C7429297D5F73656C656374416C6C28297B52532E53656C656374416C6C2E72756E436F7265456469746F72436F6D6D616E';
wwv_flow_imp.g_varchar2_table(15167) := '6428746869732E766965774D6F64656C2C7B736F757263653A226D6F757365227D297D5F636F6E7665727456696577546F4D6F64656C506F736974696F6E2865297B72657475726E20746869732E766965774D6F64656C2E636F6F7264696E6174657343';
wwv_flow_imp.g_varchar2_table(15168) := '6F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E2865297D656D69744B6579446F776E2865297B746869732E75736572496E7075744576656E74732E656D69744B6579446F776E2865297D656D';
wwv_flow_imp.g_varchar2_table(15169) := '69744B657955702865297B746869732E75736572496E7075744576656E74732E656D69744B657955702865297D656D6974436F6E746578744D656E752865297B746869732E75736572496E7075744576656E74732E656D6974436F6E746578744D656E75';
wwv_flow_imp.g_varchar2_table(15170) := '2865297D656D69744D6F7573654D6F76652865297B746869732E75736572496E7075744576656E74732E656D69744D6F7573654D6F76652865297D656D69744D6F7573654C656176652865297B746869732E75736572496E7075744576656E74732E656D';
wwv_flow_imp.g_varchar2_table(15171) := '69744D6F7573654C656176652865297D656D69744D6F75736555702865297B746869732E75736572496E7075744576656E74732E656D69744D6F75736555702865297D656D69744D6F757365446F776E2865297B746869732E75736572496E7075744576';
wwv_flow_imp.g_varchar2_table(15172) := '656E74732E656D69744D6F757365446F776E2865297D656D69744D6F757365447261672865297B746869732E75736572496E7075744576656E74732E656D69744D6F757365447261672865297D656D69744D6F75736544726F702865297B746869732E75';
wwv_flow_imp.g_varchar2_table(15173) := '736572496E7075744576656E74732E656D69744D6F75736544726F702865297D656D69744D6F75736544726F7043616E63656C656428297B746869732E75736572496E7075744576656E74732E656D69744D6F75736544726F7043616E63656C65642829';
wwv_flow_imp.g_varchar2_table(15174) := '7D656D69744D6F757365576865656C2865297B746869732E75736572496E7075744576656E74732E656D69744D6F757365576865656C2865297D7D636C6173732062507B636F6E7374727563746F722865297B746869732E5F6372656174654C696E653D';
wwv_flow_imp.g_varchar2_table(15175) := '652C746869732E5F73657428312C5B5D297D666C75736828297B746869732E5F73657428312C5B5D297D5F73657428652C74297B746869732E5F6C696E65733D742C746869732E5F72656E644C696E654E756D62657253746172743D657D5F6765742829';
wwv_flow_imp.g_varchar2_table(15176) := '7B72657475726E7B72656E644C696E654E756D62657253746172743A746869732E5F72656E644C696E654E756D62657253746172742C6C696E65733A746869732E5F6C696E65737D7D67657453746172744C696E654E756D62657228297B72657475726E';
wwv_flow_imp.g_varchar2_table(15177) := '20746869732E5F72656E644C696E654E756D62657253746172747D676574456E644C696E654E756D62657228297B72657475726E20746869732E5F72656E644C696E654E756D62657253746172742B746869732E5F6C696E65732E6C656E6774682D317D';
wwv_flow_imp.g_varchar2_table(15178) := '676574436F756E7428297B72657475726E20746869732E5F6C696E65732E6C656E6774687D6765744C696E652865297B636F6E737420743D652D746869732E5F72656E644C696E654E756D62657253746172743B696628743C307C7C743E3D746869732E';
wwv_flow_imp.g_varchar2_table(15179) := '5F6C696E65732E6C656E677468297468726F77206E6577204F652822496C6C6567616C2076616C756520666F72206C696E654E756D62657222293B72657475726E20746869732E5F6C696E65735B745D7D6F6E4C696E657344656C6574656428652C7429';
wwv_flow_imp.g_varchar2_table(15180) := '7B696628303D3D3D746869732E676574436F756E7428292972657475726E206E756C6C3B636F6E7374206E3D746869732E67657453746172744C696E654E756D62657228292C693D746869732E676574456E644C696E654E756D62657228293B69662874';
wwv_flow_imp.g_varchar2_table(15181) := '3C6E297B636F6E7374206E3D742D652B313B72657475726E20746869732E5F72656E644C696E654E756D62657253746172742D3D6E2C6E756C6C7D696628653E692972657475726E206E756C6C3B6C6574206F3D302C733D303B666F72286C657420723D';
wwv_flow_imp.g_varchar2_table(15182) := '6E3B723C3D693B722B2B297B636F6E7374206E3D722D746869732E5F72656E644C696E654E756D62657253746172743B653C3D722626723C3D74262628303D3D3D733F286F3D6E2C733D31293A732B2B297D696628653C6E297B6C657420693D303B693D';
wwv_flow_imp.g_varchar2_table(15183) := '743C6E3F742D652B313A6E2D652C746869732E5F72656E644C696E654E756D62657253746172742D3D697D72657475726E20746869732E5F6C696E65732E73706C696365286F2C73297D6F6E4C696E65734368616E67656428652C74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(15184) := '6E3D652B742D313B696628303D3D3D746869732E676574436F756E7428292972657475726E21313B636F6E737420693D746869732E67657453746172744C696E654E756D62657228292C6F3D746869732E676574456E644C696E654E756D62657228293B';
wwv_flow_imp.g_varchar2_table(15185) := '6C657420733D21313B666F72286C657420743D653B743C3D6E3B742B2B29743E3D692626743C3D6F262628746869732E5F6C696E65735B742D746869732E5F72656E644C696E654E756D62657253746172745D2E6F6E436F6E74656E744368616E676564';
wwv_flow_imp.g_varchar2_table(15186) := '28292C733D2130293B72657475726E20737D6F6E4C696E6573496E73657274656428652C74297B696628303D3D3D746869732E676574436F756E7428292972657475726E206E756C6C3B636F6E7374206E3D742D652B312C693D746869732E6765745374';
wwv_flow_imp.g_varchar2_table(15187) := '6172744C696E654E756D62657228292C6F3D746869732E676574456E644C696E654E756D62657228293B696628653C3D692972657475726E20746869732E5F72656E644C696E654E756D62657253746172742B3D6E2C6E756C6C3B696628653E6F297265';
wwv_flow_imp.g_varchar2_table(15188) := '7475726E206E756C6C3B6966286E2B653E6F2972657475726E20746869732E5F6C696E65732E73706C69636528652D746869732E5F72656E644C696E654E756D62657253746172742C6F2D652B31293B636F6E737420733D5B5D3B666F72286C65742065';
wwv_flow_imp.g_varchar2_table(15189) := '3D303B653C6E3B652B2B29735B655D3D746869732E5F6372656174654C696E6528293B636F6E737420723D652D746869732E5F72656E644C696E654E756D62657253746172742C613D746869732E5F6C696E65732E736C69636528302C72292C6C3D7468';
wwv_flow_imp.g_varchar2_table(15190) := '69732E5F6C696E65732E736C69636528722C746869732E5F6C696E65732E6C656E6774682D6E292C633D746869732E5F6C696E65732E736C69636528746869732E5F6C696E65732E6C656E6774682D6E2C746869732E5F6C696E65732E6C656E67746829';
wwv_flow_imp.g_varchar2_table(15191) := '3B72657475726E20746869732E5F6C696E65733D612E636F6E6361742873292E636F6E636174286C292C637D6F6E546F6B656E734368616E6765642865297B696628303D3D3D746869732E676574436F756E7428292972657475726E21313B636F6E7374';
wwv_flow_imp.g_varchar2_table(15192) := '20743D746869732E67657453746172744C696E654E756D62657228292C6E3D746869732E676574456E644C696E654E756D62657228293B6C657420693D21313B666F72286C6574206F3D302C733D652E6C656E6774683B6F3C733B6F2B2B297B636F6E73';
wwv_flow_imp.g_varchar2_table(15193) := '7420733D655B6F5D3B696628732E746F4C696E654E756D6265723C747C7C732E66726F6D4C696E654E756D6265723E6E29636F6E74696E75653B636F6E737420723D4D6174682E6D617828742C732E66726F6D4C696E654E756D626572292C613D4D6174';
wwv_flow_imp.g_varchar2_table(15194) := '682E6D696E286E2C732E746F4C696E654E756D626572293B666F72286C657420653D723B653C3D613B652B2B297B636F6E737420743D652D746869732E5F72656E644C696E654E756D62657253746172743B746869732E5F6C696E65735B745D2E6F6E54';
wwv_flow_imp.g_varchar2_table(15195) := '6F6B656E734368616E67656428292C693D21307D7D72657475726E20697D7D636C617373205F507B636F6E7374727563746F722865297B746869732E5F686F73743D652C746869732E646F6D4E6F64653D746869732E5F637265617465446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(15196) := '28292C746869732E5F6C696E6573436F6C6C656374696F6E3D6E6577206250282828293D3E746869732E5F686F73742E63726561746556697369626C654C696E65282929297D5F637265617465446F6D4E6F646528297B636F6E737420653D734528646F';
wwv_flow_imp.g_varchar2_table(15197) := '63756D656E742E637265617465456C656D656E7428226469762229293B72657475726E20652E736574436C6173734E616D652822766965772D6C6179657222292C652E736574506F736974696F6E28226162736F6C75746522292C652E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(15198) := '2E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C652E646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C657D6F6E436F6E66696775726174696F6E43';
wwv_flow_imp.g_varchar2_table(15199) := '68616E6765642865297B72657475726E2121652E6861734368616E67656428313435297D6F6E466C75736865642865297B72657475726E20746869732E5F6C696E6573436F6C6C656374696F6E2E666C75736828292C21307D6F6E4C696E65734368616E';
wwv_flow_imp.g_varchar2_table(15200) := '6765642865297B72657475726E20746869732E5F6C696E6573436F6C6C656374696F6E2E6F6E4C696E65734368616E67656428652E66726F6D4C696E654E756D6265722C652E636F756E74297D6F6E4C696E657344656C657465642865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(15201) := '20743D746869732E5F6C696E6573436F6C6C656374696F6E2E6F6E4C696E657344656C6574656428652E66726F6D4C696E654E756D6265722C652E746F4C696E654E756D626572293B6966287429666F72286C657420653D302C6E3D742E6C656E677468';
wwv_flow_imp.g_varchar2_table(15202) := '3B653C6E3B652B2B297B636F6E7374206E3D745B655D2E676574446F6D4E6F646528293B6E2626746869732E646F6D4E6F64652E646F6D4E6F64652E72656D6F76654368696C64286E297D72657475726E21307D6F6E4C696E6573496E73657274656428';
wwv_flow_imp.g_varchar2_table(15203) := '65297B636F6E737420743D746869732E5F6C696E6573436F6C6C656374696F6E2E6F6E4C696E6573496E73657274656428652E66726F6D4C696E654E756D6265722C652E746F4C696E654E756D626572293B6966287429666F72286C657420653D302C6E';
wwv_flow_imp.g_varchar2_table(15204) := '3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D2E676574446F6D4E6F646528293B6E2626746869732E646F6D4E6F64652E646F6D4E6F64652E72656D6F76654368696C64286E297D72657475726E21307D6F6E5363726F6C';
wwv_flow_imp.g_varchar2_table(15205) := '6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D6F6E546F6B656E734368616E6765642865297B72657475726E20746869732E5F6C696E6573436F6C6C656374696F6E2E6F6E546F6B656E734368616E6765';
wwv_flow_imp.g_varchar2_table(15206) := '6428652E72616E676573297D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D67657453746172744C696E654E756D62657228297B72657475726E20746869732E5F6C696E6573436F6C6C656374696F6E2E67657453746172744C696E';
wwv_flow_imp.g_varchar2_table(15207) := '654E756D62657228297D676574456E644C696E654E756D62657228297B72657475726E20746869732E5F6C696E6573436F6C6C656374696F6E2E676574456E644C696E654E756D62657228297D67657456697369626C654C696E652865297B7265747572';
wwv_flow_imp.g_varchar2_table(15208) := '6E20746869732E5F6C696E6573436F6C6C656374696F6E2E6765744C696E652865297D72656E6465724C696E65732865297B636F6E737420743D746869732E5F6C696E6573436F6C6C656374696F6E2E5F67657428292C6E3D6E65772079502874686973';
wwv_flow_imp.g_varchar2_table(15209) := '2E646F6D4E6F64652E646F6D4E6F64652C746869732E5F686F73742C65292C693D7B72656E644C696E654E756D62657253746172743A742E72656E644C696E654E756D62657253746172742C6C696E65733A742E6C696E65732C6C696E65734C656E6774';
wwv_flow_imp.g_varchar2_table(15210) := '683A742E6C696E65732E6C656E6774687D2C6F3D6E2E72656E64657228692C652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722C652E72656C6174697665566572746963616C4F6666736574293B746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(15211) := '6573436F6C6C656374696F6E2E5F736574286F2E72656E644C696E654E756D62657253746172742C6F2E6C696E6573297D7D636C6173732079507B636F6E7374727563746F7228652C742C6E297B746869732E646F6D4E6F64653D652C746869732E686F';
wwv_flow_imp.g_varchar2_table(15212) := '73743D742C746869732E76696577706F7274446174613D6E7D72656E64657228652C742C6E2C69297B636F6E7374206F3D7B72656E644C696E654E756D62657253746172743A652E72656E644C696E654E756D62657253746172742C6C696E65733A652E';
wwv_flow_imp.g_varchar2_table(15213) := '6C696E65732E736C6963652830292C6C696E65734C656E6774683A652E6C696E65734C656E6774687D3B6966286F2E72656E644C696E654E756D62657253746172742B6F2E6C696E65734C656E6774682D313C747C7C6E3C6F2E72656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(15214) := '6D6265725374617274297B6F2E72656E644C696E654E756D62657253746172743D742C6F2E6C696E65734C656E6774683D6E2D742B312C6F2E6C696E65733D5B5D3B666F72286C657420653D743B653C3D6E3B652B2B296F2E6C696E65735B652D745D3D';
wwv_flow_imp.g_varchar2_table(15215) := '746869732E686F73742E63726561746556697369626C654C696E6528293B72657475726E20746869732E5F66696E69736852656E646572696E67286F2C21302C69292C6F7D696628746869732E5F72656E646572556E746F75636865644C696E6573286F';
wwv_flow_imp.g_varchar2_table(15216) := '2C4D6174682E6D617828742D6F2E72656E644C696E654E756D62657253746172742C30292C4D6174682E6D696E286E2D6F2E72656E644C696E654E756D62657253746172742C6F2E6C696E65734C656E6774682D31292C692C74292C6F2E72656E644C69';
wwv_flow_imp.g_varchar2_table(15217) := '6E654E756D62657253746172743E74297B636F6E737420653D742C733D4D6174682E6D696E286E2C6F2E72656E644C696E654E756D62657253746172742D31293B653C3D73262628746869732E5F696E736572744C696E65734265666F7265286F2C652C';
wwv_flow_imp.g_varchar2_table(15218) := '732C692C74292C6F2E6C696E65734C656E6774682B3D732D652B31297D656C7365206966286F2E72656E644C696E654E756D62657253746172743C74297B636F6E737420653D4D6174682E6D696E286F2E6C696E65734C656E6774682C742D6F2E72656E';
wwv_flow_imp.g_varchar2_table(15219) := '644C696E654E756D6265725374617274293B653E30262628746869732E5F72656D6F76654C696E65734265666F7265286F2C65292C6F2E6C696E65734C656E6774682D3D65297D6966286F2E72656E644C696E654E756D62657253746172743D742C6F2E';
wwv_flow_imp.g_varchar2_table(15220) := '72656E644C696E654E756D62657253746172742B6F2E6C696E65734C656E6774682D313C6E297B636F6E737420653D6F2E72656E644C696E654E756D62657253746172742B6F2E6C696E65734C656E6774682C733D6E3B653C3D73262628746869732E5F';
wwv_flow_imp.g_varchar2_table(15221) := '696E736572744C696E65734166746572286F2C652C732C692C74292C6F2E6C696E65734C656E6774682B3D732D652B31297D656C7365206966286F2E72656E644C696E654E756D62657253746172742B6F2E6C696E65734C656E6774682D313E6E297B63';
wwv_flow_imp.g_varchar2_table(15222) := '6F6E737420653D4D6174682E6D617828302C6E2D6F2E72656E644C696E654E756D62657253746172742B31292C743D6F2E6C696E65734C656E6774682D312D652B313B743E30262628746869732E5F72656D6F76654C696E65734166746572286F2C7429';
wwv_flow_imp.g_varchar2_table(15223) := '2C6F2E6C696E65734C656E6774682D3D74297D72657475726E20746869732E5F66696E69736852656E646572696E67286F2C21312C69292C6F7D5F72656E646572556E746F75636865644C696E657328652C742C6E2C692C6F297B636F6E737420733D65';
wwv_flow_imp.g_varchar2_table(15224) := '2E72656E644C696E654E756D62657253746172742C723D652E6C696E65733B666F72286C657420653D743B653C3D6E3B652B2B297B636F6E737420743D732B653B725B655D2E6C61796F75744C696E6528742C695B742D6F5D2C746869732E7669657770';
wwv_flow_imp.g_varchar2_table(15225) := '6F7274446174612E6C696E65486569676874297D7D5F696E736572744C696E65734265666F726528652C742C6E2C692C6F297B636F6E737420733D5B5D3B6C657420723D303B666F72286C657420653D743B653C3D6E3B652B2B29735B722B2B5D3D7468';
wwv_flow_imp.g_varchar2_table(15226) := '69732E686F73742E63726561746556697369626C654C696E6528293B652E6C696E65733D732E636F6E63617428652E6C696E6573297D5F72656D6F76654C696E65734265666F726528652C74297B666F72286C6574206E3D303B6E3C743B6E2B2B297B63';
wwv_flow_imp.g_varchar2_table(15227) := '6F6E737420743D652E6C696E65735B6E5D2E676574446F6D4E6F646528293B742626746869732E646F6D4E6F64652E72656D6F76654368696C642874297D652E6C696E65732E73706C69636528302C74297D5F696E736572744C696E6573416674657228';
wwv_flow_imp.g_varchar2_table(15228) := '652C742C6E2C692C6F297B636F6E737420733D5B5D3B6C657420723D303B666F72286C657420653D743B653C3D6E3B652B2B29735B722B2B5D3D746869732E686F73742E63726561746556697369626C654C696E6528293B652E6C696E65733D652E6C69';
wwv_flow_imp.g_varchar2_table(15229) := '6E65732E636F6E6361742873297D5F72656D6F76654C696E6573416674657228652C74297B636F6E7374206E3D652E6C696E65734C656E6774682D743B666F72286C657420693D303B693C743B692B2B297B636F6E737420743D652E6C696E65735B6E2B';
wwv_flow_imp.g_varchar2_table(15230) := '695D2E676574446F6D4E6F646528293B742626746869732E646F6D4E6F64652E72656D6F76654368696C642874297D652E6C696E65732E73706C696365286E2C74297D5F66696E69736852656E646572696E674E65774C696E657328652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(15231) := '7B79502E5F7474506F6C6963792626286E3D79502E5F7474506F6C6963792E63726561746548544D4C286E29293B636F6E7374206F3D746869732E646F6D4E6F64652E6C6173744368696C643B747C7C216F3F746869732E646F6D4E6F64652E696E6E65';
wwv_flow_imp.g_varchar2_table(15232) := '7248544D4C3D6E3A6F2E696E7365727441646A6163656E7448544D4C28226166746572656E64222C6E293B6C657420733D746869732E646F6D4E6F64652E6C6173744368696C643B666F72286C657420743D652E6C696E65734C656E6774682D313B743E';
wwv_flow_imp.g_varchar2_table(15233) := '3D303B742D2D297B636F6E7374206E3D652E6C696E65735B745D3B695B745D2626286E2E736574446F6D4E6F64652873292C733D732E70726576696F75735369626C696E67297D7D5F66696E69736852656E646572696E67496E76616C69644C696E6573';
wwv_flow_imp.g_varchar2_table(15234) := '28652C742C6E297B636F6E737420693D646F63756D656E742E637265617465456C656D656E74282264697622293B79502E5F7474506F6C696379262628743D79502E5F7474506F6C6963792E63726561746548544D4C287429292C692E696E6E65724854';
wwv_flow_imp.g_varchar2_table(15235) := '4D4C3D743B666F72286C657420743D303B743C652E6C696E65734C656E6774683B742B2B297B636F6E7374206F3D652E6C696E65735B745D3B6966286E5B745D297B636F6E737420653D692E66697273744368696C642C743D6F2E676574446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(15236) := '6528293B742E706172656E744E6F64652E7265706C6163654368696C6428652C74292C6F2E736574446F6D4E6F64652865297D7D7D5F66696E69736852656E646572696E6728652C742C6E297B636F6E737420693D79502E5F73622C6F3D652E6C696E65';
wwv_flow_imp.g_varchar2_table(15237) := '734C656E6774682C733D652E6C696E65732C723D652E72656E644C696E654E756D62657253746172742C613D5B5D3B7B692E726573657428293B6C6574206C3D21313B666F72286C657420653D303B653C6F3B652B2B297B636F6E737420743D735B655D';
wwv_flow_imp.g_varchar2_table(15238) := '3B615B655D3D21312C742E676574446F6D4E6F646528297C7C742E72656E6465724C696E6528652B722C6E5B655D2C746869732E76696577706F7274446174612E6C696E654865696768742C746869732E76696577706F7274446174612C692926262861';
wwv_flow_imp.g_varchar2_table(15239) := '5B655D3D21302C6C3D2130297D6C2626746869732E5F66696E69736852656E646572696E674E65774C696E657328652C742C692E6275696C6428292C61297D7B692E726573657428293B6C657420743D21313B636F6E7374206C3D5B5D3B666F72286C65';
wwv_flow_imp.g_varchar2_table(15240) := '7420653D303B653C6F3B652B2B297B636F6E7374206F3D735B655D3B286C5B655D3D21312C615B655D297C7C6F2E72656E6465724C696E6528652B722C6E5B655D2C746869732E76696577706F7274446174612E6C696E654865696768742C746869732E';
wwv_flow_imp.g_varchar2_table(15241) := '76696577706F7274446174612C69292626286C5B655D3D21302C743D2130297D742626746869732E5F66696E69736852656E646572696E67496E76616C69644C696E657328652C692E6275696C6428292C6C297D7D7D79502E5F7474506F6C6963793D65';
wwv_flow_imp.g_varchar2_table(15242) := '452822656469746F72566965774C61796572222C7B63726561746548544D4C3A653D3E657D292C79502E5F73623D6E6577206E7028316535293B636C61737320775020657874656E6473204A417B636F6E7374727563746F722865297B73757065722865';
wwv_flow_imp.g_varchar2_table(15243) := '292C746869732E5F76697369626C654C696E65733D6E6577205F502874686973292C746869732E646F6D4E6F64653D746869732E5F76697369626C654C696E65732E646F6D4E6F64653B636F6E737420743D746869732E5F636F6E746578742E636F6E66';
wwv_flow_imp.g_varchar2_table(15244) := '696775726174696F6E2E6F7074696F6E732E676574283530293B724528746869732E646F6D4E6F64652C74292C746869732E5F64796E616D69634F7665726C6179733D5B5D2C746869732E5F6973466F63757365643D21312C746869732E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(15245) := '652E736574436C6173734E616D652822766965772D6F7665726C61797322297D73686F756C6452656E64657228297B69662873757065722E73686F756C6452656E64657228292972657475726E21303B666F72286C657420653D302C743D746869732E5F';
wwv_flow_imp.g_varchar2_table(15246) := '64796E616D69634F7665726C6179732E6C656E6774683B653C743B652B2B29696628746869732E5F64796E616D69634F7665726C6179735B655D2E73686F756C6452656E64657228292972657475726E21303B72657475726E21317D646973706F736528';
wwv_flow_imp.g_varchar2_table(15247) := '297B73757065722E646973706F736528293B666F72286C657420653D302C743D746869732E5F64796E616D69634F7665726C6179732E6C656E6774683B653C743B652B2B29746869732E5F64796E616D69634F7665726C6179735B655D2E646973706F73';
wwv_flow_imp.g_varchar2_table(15248) := '6528293B746869732E5F64796E616D69634F7665726C6179733D5B5D7D676574446F6D4E6F646528297B72657475726E20746869732E646F6D4E6F64657D63726561746556697369626C654C696E6528297B72657475726E206E65772043502874686973';
wwv_flow_imp.g_varchar2_table(15249) := '2E5F64796E616D69634F7665726C617973297D61646444796E616D69634F7665726C61792865297B746869732E5F64796E616D69634F7665726C6179732E707573682865297D6F6E436F6E66696775726174696F6E4368616E6765642865297B74686973';
wwv_flow_imp.g_varchar2_table(15250) := '2E5F76697369626C654C696E65732E6F6E436F6E66696775726174696F6E4368616E6765642865293B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E676574283530293B72657475726E20';
wwv_flow_imp.g_varchar2_table(15251) := '724528746869732E646F6D4E6F64652C74292C21307D6F6E466C75736865642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E466C75736865642865297D6F6E466F6375734368616E6765642865297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(15252) := '6869732E5F6973466F63757365643D652E6973466F63757365642C21307D6F6E4C696E65734368616E6765642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E4C696E65734368616E6765642865297D6F6E4C696E657344';
wwv_flow_imp.g_varchar2_table(15253) := '656C657465642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E4C696E657344656C657465642865297D6F6E4C696E6573496E7365727465642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F';
wwv_flow_imp.g_varchar2_table(15254) := '6E4C696E6573496E7365727465642865297D6F6E5363726F6C6C4368616E6765642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E5363726F6C6C4368616E6765642865297C7C21307D6F6E546F6B656E734368616E6765';
wwv_flow_imp.g_varchar2_table(15255) := '642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E546F6B656E734368616E6765642865297D6F6E5A6F6E65734368616E6765642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E5A6F6E65';
wwv_flow_imp.g_varchar2_table(15256) := '734368616E6765642865297D7072657061726552656E6465722865297B636F6E737420743D746869732E5F64796E616D69634F7665726C6179732E66696C7465722828653D3E652E73686F756C6452656E646572282929293B666F72286C6574206E3D30';
wwv_flow_imp.g_varchar2_table(15257) := '2C693D742E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D745B6E5D3B692E7072657061726552656E6465722865292C692E6F6E44696452656E64657228297D7D72656E6465722865297B746869732E5F766965774F7665726C6179735265';
wwv_flow_imp.g_varchar2_table(15258) := '6E6465722865292C746869732E646F6D4E6F64652E746F67676C65436C6173734E616D652822666F6375736564222C746869732E5F6973466F6375736564297D5F766965774F7665726C61797352656E6465722865297B746869732E5F76697369626C65';
wwv_flow_imp.g_varchar2_table(15259) := '4C696E65732E72656E6465724C696E657328652E76696577706F727444617461297D7D636C6173732043507B636F6E7374727563746F722865297B746869732E5F64796E616D69634F7665726C6179733D652C746869732E5F646F6D4E6F64653D6E756C';
wwv_flow_imp.g_varchar2_table(15260) := '6C2C746869732E5F72656E6465726564436F6E74656E743D6E756C6C7D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64653F746869732E5F646F6D4E6F64652E646F6D4E6F64653A6E756C6C7D736574446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(15261) := '2865297B746869732E5F646F6D4E6F64653D73452865297D6F6E436F6E74656E744368616E67656428297B7D6F6E546F6B656E734368616E67656428297B7D72656E6465724C696E6528652C742C6E2C692C6F297B6C657420733D22223B666F72286C65';
wwv_flow_imp.g_varchar2_table(15262) := '7420743D302C6E3D746869732E5F64796E616D69634F7665726C6179732E6C656E6774683B743C6E3B742B2B29732B3D746869732E5F64796E616D69634F7665726C6179735B745D2E72656E64657228692E73746172744C696E654E756D6265722C6529';
wwv_flow_imp.g_varchar2_table(15263) := '3B72657475726E20746869732E5F72656E6465726564436F6E74656E74213D3D73262628746869732E5F72656E6465726564436F6E74656E743D732C6F2E617070656E64537472696E6728273C646976207374796C653D22746F703A27292C6F2E617070';
wwv_flow_imp.g_varchar2_table(15264) := '656E64537472696E6728537472696E67287429292C6F2E617070656E64537472696E67282270783B6865696768743A22292C6F2E617070656E64537472696E6728537472696E67286E29292C6F2E617070656E64537472696E67282770783B223E27292C';
wwv_flow_imp.g_varchar2_table(15265) := '6F2E617070656E64537472696E672873292C6F2E617070656E64537472696E6728223C2F6469763E22292C2130297D6C61796F75744C696E6528652C742C6E297B746869732E5F646F6D4E6F6465262628746869732E5F646F6D4E6F64652E736574546F';
wwv_flow_imp.g_varchar2_table(15266) := '702874292C746869732E5F646F6D4E6F64652E736574486569676874286E29297D7D636C61737320535020657874656E64732077507B636F6E7374727563746F722865297B73757065722865293B636F6E737420743D746869732E5F636F6E746578742E';
wwv_flow_imp.g_varchar2_table(15267) := '636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B746869732E5F636F6E74656E7457696474683D742E636F6E74656E7457696474682C746869732E646F6D4E6F64652E7365744865696768742830297D6F6E436F6E66696775';
wwv_flow_imp.g_varchar2_table(15268) := '726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B72657475726E20746869732E5F636F6E74656E7457696474683D742E636F';
wwv_flow_imp.g_varchar2_table(15269) := '6E74656E7457696474682C73757065722E6F6E436F6E66696775726174696F6E4368616E6765642865297C7C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E2073757065722E6F6E5363726F6C6C4368616E6765642865297C7C65';
wwv_flow_imp.g_varchar2_table(15270) := '2E7363726F6C6C57696474684368616E6765647D5F766965774F7665726C61797352656E6465722865297B73757065722E5F766965774F7665726C61797352656E6465722865292C746869732E646F6D4E6F64652E7365745769647468284D6174682E6D';
wwv_flow_imp.g_varchar2_table(15271) := '617828652E7363726F6C6C57696474682C746869732E5F636F6E74656E74576964746829297D7D636C61737320785020657874656E64732077507B636F6E7374727563746F722865297B73757065722865293B636F6E737420743D746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(15272) := '746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E646F6D4E6F64652E736574436C6173734E616D6528226D';
wwv_flow_imp.g_varchar2_table(15273) := '617267696E2D766965772D6F7665726C61797322292C746869732E646F6D4E6F64652E73657457696474682831292C724528746869732E646F6D4E6F64652C742E67657428353029297D6F6E436F6E66696775726174696F6E4368616E6765642865297B';
wwv_flow_imp.g_varchar2_table(15274) := '636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B724528746869732E646F6D4E6F64652C742E67657428353029293B636F6E7374206E3D742E67657428313435293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(15275) := '732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C73757065722E6F6E436F6E66696775726174696F6E4368616E6765642865297C7C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E2073757065722E6F6E53';
wwv_flow_imp.g_varchar2_table(15276) := '63726F6C6C4368616E6765642865297C7C652E7363726F6C6C4865696768744368616E6765647D5F766965774F7665726C61797352656E6465722865297B73757065722E5F766965774F7665726C61797352656E6465722865293B636F6E737420743D4D';
wwv_flow_imp.g_varchar2_table(15277) := '6174682E6D696E28652E7363726F6C6C4865696768742C316536293B746869732E646F6D4E6F64652E7365744865696768742874292C746869732E646F6D4E6F64652E736574576964746828746869732E5F636F6E74656E744C656674297D7D636C6173';
wwv_flow_imp.g_varchar2_table(15278) := '73206B507B636F6E7374727563746F722865297B746869732E6F6E4B6579446F776E3D6E756C6C2C746869732E6F6E4B657955703D6E756C6C2C746869732E6F6E436F6E746578744D656E753D6E756C6C2C746869732E6F6E4D6F7573654D6F76653D6E';
wwv_flow_imp.g_varchar2_table(15279) := '756C6C2C746869732E6F6E4D6F7573654C656176653D6E756C6C2C746869732E6F6E4D6F757365446F776E3D6E756C6C2C746869732E6F6E4D6F75736555703D6E756C6C2C746869732E6F6E4D6F757365447261673D6E756C6C2C746869732E6F6E4D6F';
wwv_flow_imp.g_varchar2_table(15280) := '75736544726F703D6E756C6C2C746869732E6F6E4D6F75736544726F7043616E63656C65643D6E756C6C2C746869732E6F6E4D6F757365576865656C3D6E756C6C2C746869732E5F636F6F7264696E61746573436F6E7665727465723D657D656D69744B';
wwv_flow_imp.g_varchar2_table(15281) := '6579446F776E2865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E4B6579446F776E297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C65297D656D69744B657955702865297B76617220743B6E756C6C3D3D3D28743D74';
wwv_flow_imp.g_varchar2_table(15282) := '6869732E6F6E4B65795570297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C65297D656D6974436F6E746578744D656E752865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E436F6E746578744D656E75297C7C766F69';
wwv_flow_imp.g_varchar2_table(15283) := '6420303D3D3D747C7C742E63616C6C28746869732C746869732E5F636F6E7665727456696577546F4D6F64656C4D6F7573654576656E74286529297D656D69744D6F7573654D6F76652865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E';
wwv_flow_imp.g_varchar2_table(15284) := '4D6F7573654D6F7665297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C746869732E5F636F6E7665727456696577546F4D6F64656C4D6F7573654576656E74286529297D656D69744D6F7573654C656176652865297B76617220743B6E';
wwv_flow_imp.g_varchar2_table(15285) := '756C6C3D3D3D28743D746869732E6F6E4D6F7573654C65617665297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C746869732E5F636F6E7665727456696577546F4D6F64656C4D6F7573654576656E74286529297D656D69744D6F7573';
wwv_flow_imp.g_varchar2_table(15286) := '65446F776E2865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E4D6F757365446F776E297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C746869732E5F636F6E7665727456696577546F4D6F64656C4D6F757365457665';
wwv_flow_imp.g_varchar2_table(15287) := '6E74286529297D656D69744D6F75736555702865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E4D6F7573655570297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C746869732E5F636F6E7665727456696577546F4D6F';
wwv_flow_imp.g_varchar2_table(15288) := '64656C4D6F7573654576656E74286529297D656D69744D6F757365447261672865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E4D6F75736544726167297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C746869732E5F';
wwv_flow_imp.g_varchar2_table(15289) := '636F6E7665727456696577546F4D6F64656C4D6F7573654576656E74286529297D656D69744D6F75736544726F702865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E4D6F75736544726F70297C7C766F696420303D3D3D747C7C742E63';
wwv_flow_imp.g_varchar2_table(15290) := '616C6C28746869732C746869732E5F636F6E7665727456696577546F4D6F64656C4D6F7573654576656E74286529297D656D69744D6F75736544726F7043616E63656C656428297B76617220653B6E756C6C3D3D3D28653D746869732E6F6E4D6F757365';
wwv_flow_imp.g_varchar2_table(15291) := '44726F7043616E63656C6564297C7C766F696420303D3D3D657C7C652E63616C6C2874686973297D656D69744D6F757365576865656C2865297B76617220743B6E756C6C3D3D3D28743D746869732E6F6E4D6F757365576865656C297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(15292) := '3D3D3D747C7C742E63616C6C28746869732C65297D5F636F6E7665727456696577546F4D6F64656C4D6F7573654576656E742865297B72657475726E20652E7461726765743F7B6576656E743A652E6576656E742C7461726765743A746869732E5F636F';
wwv_flow_imp.g_varchar2_table(15293) := '6E7665727456696577546F4D6F64656C4D6F75736554617267657428652E746172676574297D3A657D5F636F6E7665727456696577546F4D6F64656C4D6F7573655461726765742865297B72657475726E206B502E636F6E7665727456696577546F4D6F';
wwv_flow_imp.g_varchar2_table(15294) := '64656C4D6F75736554617267657428652C746869732E5F636F6F7264696E61746573436F6E766572746572297D73746174696320636F6E7665727456696577546F4D6F64656C4D6F75736554617267657428652C74297B636F6E7374206E3D7B2E2E2E65';
wwv_flow_imp.g_varchar2_table(15295) := '7D3B72657475726E206E2E706F736974696F6E2626286E2E706F736974696F6E3D742E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E2E706F736974696F6E29292C6E2E72616E67652626286E2E72616E6765';
wwv_flow_imp.g_varchar2_table(15296) := '3D742E636F6E766572745669657752616E6765546F4D6F64656C52616E6765286E2E72616E676529292C35213D3D6E2E74797065262638213D3D6E2E747970657C7C286E2E64657461696C3D746869732E636F6E7665727456696577546F4D6F64656C56';
wwv_flow_imp.g_varchar2_table(15297) := '6965775A6F6E6544617461286E2E64657461696C2C7429292C6E7D73746174696320636F6E7665727456696577546F4D6F64656C566965775A6F6E654461746128652C74297B72657475726E7B766965775A6F6E6549643A652E766965775A6F6E654964';
wwv_flow_imp.g_varchar2_table(15298) := '2C706F736974696F6E4265666F72653A652E706F736974696F6E4265666F72653F742E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E706F736974696F6E4265666F7265293A652E706F736974696F6E4265';
wwv_flow_imp.g_varchar2_table(15299) := '666F72652C706F736974696F6E41667465723A652E706F736974696F6E41667465723F742E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E706F736974696F6E4166746572293A652E706F736974696F6E41';
wwv_flow_imp.g_varchar2_table(15300) := '667465722C706F736974696F6E3A742E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E706F736974696F6E292C61667465724C696E654E756D6265723A742E636F6E7665727456696577506F736974696F6E';
wwv_flow_imp.g_varchar2_table(15301) := '546F4D6F64656C506F736974696F6E286E6577206D6328652E61667465724C696E654E756D6265722C3129292E6C696E654E756D6265727D7D7D7661722045503D6E2832303335292C4C503D7B7D3B4C502E7374796C655461675472616E73666F726D3D';
wwv_flow_imp.g_varchar2_table(15302) := '6A7228292C4C502E736574417474726962757465733D567228292C4C502E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4C502E646F6D4150493D4F7228292C4C502E696E736572745374796C65456C656D656E743D487228';
wwv_flow_imp.g_varchar2_table(15303) := '292C4E7228292845502E412C4C50292C45502E41262645502E412E6C6F63616C73262645502E412E6C6F63616C733B636C61737320445020657874656E6473204A417B636F6E7374727563746F722865297B73757065722865292C746869732E626C6F63';
wwv_flow_imp.g_varchar2_table(15304) := '6B733D5B5D2C746869732E636F6E74656E7457696474683D2D312C746869732E636F6E74656E744C6566743D302C746869732E646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F';
wwv_flow_imp.g_varchar2_table(15305) := '6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(15306) := '64652E736574436C6173734E616D652822626C6F636B4465636F726174696F6E732D636F6E7461696E657222292C746869732E75706461746528297D75706461746528297B6C657420653D21313B636F6E737420743D746869732E5F636F6E746578742E';
wwv_flow_imp.g_varchar2_table(15307) := '636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435292C6E3D742E636F6E74656E7457696474682D742E766572746963616C5363726F6C6C62617257696474683B746869732E636F6E74656E745769647468213D3D6E262628746869';
wwv_flow_imp.g_varchar2_table(15308) := '732E636F6E74656E7457696474683D6E2C653D2130293B636F6E737420693D742E636F6E74656E744C6566743B72657475726E20746869732E636F6E74656E744C656674213D3D69262628746869732E636F6E74656E744C6566743D692C653D2130292C';
wwv_flow_imp.g_varchar2_table(15309) := '657D646973706F736528297B73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B72657475726E20746869732E75706461746528297D6F6E5363726F6C6C4368616E6765642865297B72657475726E';
wwv_flow_imp.g_varchar2_table(15310) := '20652E7363726F6C6C546F704368616E6765647C7C652E7363726F6C6C4C6566744368616E6765647D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E5A6F6E65734368616E6765642865297B72657475726E2130';
wwv_flow_imp.g_varchar2_table(15311) := '7D7072657061726552656E6465722865297B7D72656E6465722865297B76617220743B6C6574206E3D303B636F6E737420693D652E6765744465636F726174696F6E73496E56696577706F727428293B666F7228636F6E7374206F206F662069297B6966';
wwv_flow_imp.g_varchar2_table(15312) := '28216F2E6F7074696F6E732E626C6F636B436C6173734E616D6529636F6E74696E75653B6C657420692C732C723D746869732E626C6F636B735B6E5D3B727C7C28723D746869732E626C6F636B735B6E5D3D734528646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(15313) := '456C656D656E7428226469762229292C746869732E646F6D4E6F64652E617070656E644368696C64287229292C6F2E6F7074696F6E732E626C6F636B49734166746572456E643F28693D652E676574566572746963616C4F666673657441667465724C69';
wwv_flow_imp.g_varchar2_table(15314) := '6E654E756D626572286F2E72616E67652E656E644C696E654E756D6265722C2131292C733D652E676574566572746963616C4F666673657441667465724C696E654E756D626572286F2E72616E67652E656E644C696E654E756D6265722C213029293A28';
wwv_flow_imp.g_varchar2_table(15315) := '693D652E676574566572746963616C4F6666736574466F724C696E654E756D626572286F2E72616E67652E73746172744C696E654E756D6265722C2130292C733D6F2E72616E67652E6973456D70747928292626216F2E6F7074696F6E732E626C6F636B';
wwv_flow_imp.g_varchar2_table(15316) := '446F65734E6F74436F6C6C617073653F652E676574566572746963616C4F6666736574466F724C696E654E756D626572286F2E72616E67652E73746172744C696E654E756D6265722C2131293A652E676574566572746963616C4F666673657441667465';
wwv_flow_imp.g_varchar2_table(15317) := '724C696E654E756D626572286F2E72616E67652E656E644C696E654E756D6265722C213029293B636F6E73745B612C6C2C632C645D3D6E756C6C213D3D28743D6F2E6F7074696F6E732E626C6F636B50616464696E67292626766F69642030213D3D743F';
wwv_flow_imp.g_varchar2_table(15318) := '743A5B302C302C302C305D3B722E736574436C6173734E616D652822626C6F636B4465636F726174696F6E732D626C6F636B20222B6F2E6F7074696F6E732E626C6F636B436C6173734E616D65292C722E7365744C65667428746869732E636F6E74656E';
wwv_flow_imp.g_varchar2_table(15319) := '744C6566742D64292C722E736574576964746828746869732E636F6E74656E7457696474682B642B6C292C722E736574546F7028692D652E7363726F6C6C546F702D61292C722E73657448656967687428732D692B612B63292C6E2B2B7D666F72286C65';
wwv_flow_imp.g_varchar2_table(15320) := '7420653D6E3B653C746869732E626C6F636B732E6C656E6774683B652B2B29746869732E626C6F636B735B655D2E646F6D4E6F64652E72656D6F766528293B746869732E626C6F636B732E6C656E6774683D6E7D7D636C61737320545020657874656E64';
wwv_flow_imp.g_varchar2_table(15321) := '73204A417B636F6E7374727563746F7228652C74297B73757065722865292C746869732E5F76696577446F6D4E6F64653D742C746869732E5F776964676574733D7B7D2C746869732E646F6D4E6F64653D734528646F63756D656E742E63726561746545';
wwv_flow_imp.g_varchar2_table(15322) := '6C656D656E7428226469762229292C654E2E777269746528746869732E646F6D4E6F64652C31292C746869732E646F6D4E6F64652E736574436C6173734E616D652822636F6E74656E745769646765747322292C746869732E646F6D4E6F64652E736574';
wwv_flow_imp.g_varchar2_table(15323) := '506F736974696F6E28226162736F6C75746522292C746869732E646F6D4E6F64652E736574546F702830292C746869732E6F766572666C6F77696E67436F6E74656E7457696467657473446F6D4E6F64653D734528646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(15324) := '456C656D656E7428226469762229292C654E2E777269746528746869732E6F766572666C6F77696E67436F6E74656E7457696467657473446F6D4E6F64652C32292C746869732E6F766572666C6F77696E67436F6E74656E7457696467657473446F6D4E';
wwv_flow_imp.g_varchar2_table(15325) := '6F64652E736574436C6173734E616D6528226F766572666C6F77696E67436F6E74656E745769646765747322297D646973706F736528297B73757065722E646973706F736528292C746869732E5F776964676574733D7B7D7D6F6E436F6E666967757261';
wwv_flow_imp.g_varchar2_table(15326) := '74696F6E4368616E6765642865297B636F6E737420743D4F626A6563742E6B65797328746869732E5F77696467657473293B666F7228636F6E7374206E206F66207429746869732E5F776964676574735B6E5D2E6F6E436F6E66696775726174696F6E43';
wwv_flow_imp.g_varchar2_table(15327) := '68616E6765642865293B72657475726E21307D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E654D617070696E674368616E6765642865297B7265';
wwv_flow_imp.g_varchar2_table(15328) := '7475726E20746869732E5F757064617465416E63686F727356696577506F736974696F6E7328292C21307D6F6E4C696E65734368616E6765642865297B72657475726E20746869732E5F757064617465416E63686F727356696577506F736974696F6E73';
wwv_flow_imp.g_varchar2_table(15329) := '28292C21307D6F6E4C696E657344656C657465642865297B72657475726E20746869732E5F757064617465416E63686F727356696577506F736974696F6E7328292C21307D6F6E4C696E6573496E7365727465642865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(15330) := '5F757064617465416E63686F727356696577506F736974696F6E7328292C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E21307D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D5F757064617465416E63686F';
wwv_flow_imp.g_varchar2_table(15331) := '727356696577506F736974696F6E7328297B636F6E737420653D4F626A6563742E6B65797328746869732E5F77696467657473293B666F7228636F6E73742074206F66206529746869732E5F776964676574735B745D2E757064617465416E63686F7256';
wwv_flow_imp.g_varchar2_table(15332) := '696577506F736974696F6E28297D6164645769646765742865297B636F6E737420743D6E657720495028746869732E5F636F6E746578742C746869732E5F76696577446F6D4E6F64652C65293B746869732E5F776964676574735B742E69645D3D742C74';
wwv_flow_imp.g_varchar2_table(15333) := '2E616C6C6F77456469746F724F766572666C6F773F746869732E6F766572666C6F77696E67436F6E74656E7457696467657473446F6D4E6F64652E617070656E644368696C6428742E646F6D4E6F6465293A746869732E646F6D4E6F64652E617070656E';
wwv_flow_imp.g_varchar2_table(15334) := '644368696C6428742E646F6D4E6F6465292C746869732E73657453686F756C6452656E64657228297D736574576964676574506F736974696F6E28652C742C6E2C692C6F297B746869732E5F776964676574735B652E676574496428295D2E736574506F';
wwv_flow_imp.g_varchar2_table(15335) := '736974696F6E28742C6E2C692C6F292C746869732E73657453686F756C6452656E64657228297D72656D6F76655769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F776964676574732E6861734F776E50726F70';
wwv_flow_imp.g_varchar2_table(15336) := '65727479287429297B636F6E737420653D746869732E5F776964676574735B745D3B64656C65746520746869732E5F776964676574735B745D3B636F6E7374206E3D652E646F6D4E6F64652E646F6D4E6F64653B6E2E706172656E744E6F64652E72656D';
wwv_flow_imp.g_varchar2_table(15337) := '6F76654368696C64286E292C6E2E72656D6F766541747472696275746528226D6F6E61636F2D76697369626C652D636F6E74656E742D77696467657422292C746869732E73657453686F756C6452656E64657228297D7D73686F756C6453757070726573';
wwv_flow_imp.g_varchar2_table(15338) := '734D6F757365446F776E4F6E5769646765742865297B72657475726E2121746869732E5F776964676574732E6861734F776E50726F70657274792865292626746869732E5F776964676574735B655D2E73757070726573734D6F757365446F776E7D6F6E';
wwv_flow_imp.g_varchar2_table(15339) := '4265666F726552656E6465722865297B636F6E737420743D4F626A6563742E6B65797328746869732E5F77696467657473293B666F7228636F6E7374206E206F66207429746869732E5F776964676574735B6E5D2E6F6E4265666F726552656E64657228';
wwv_flow_imp.g_varchar2_table(15340) := '65297D7072657061726552656E6465722865297B636F6E737420743D4F626A6563742E6B65797328746869732E5F77696467657473293B666F7228636F6E7374206E206F66207429746869732E5F776964676574735B6E5D2E7072657061726552656E64';
wwv_flow_imp.g_varchar2_table(15341) := '65722865297D72656E6465722865297B636F6E737420743D4F626A6563742E6B65797328746869732E5F77696467657473293B666F7228636F6E7374206E206F66207429746869732E5F776964676574735B6E5D2E72656E6465722865297D7D636C6173';
wwv_flow_imp.g_varchar2_table(15342) := '732049507B636F6E7374727563746F7228652C742C6E297B746869732E5F7072696D617279416E63686F723D6E6577204D50286E756C6C2C6E756C6C292C746869732E5F7365636F6E64617279416E63686F723D6E6577204D50286E756C6C2C6E756C6C';
wwv_flow_imp.g_varchar2_table(15343) := '292C746869732E5F636F6E746578743D652C746869732E5F76696577446F6D4E6F64653D742C746869732E5F61637475616C3D6E2C746869732E646F6D4E6F64653D734528746869732E5F61637475616C2E676574446F6D4E6F64652829292C74686973';
wwv_flow_imp.g_varchar2_table(15344) := '2E69643D746869732E5F61637475616C2E676574496428292C746869732E616C6C6F77456469746F724F766572666C6F773D746869732E5F61637475616C2E616C6C6F77456469746F724F766572666C6F777C7C21312C746869732E7375707072657373';
wwv_flow_imp.g_varchar2_table(15345) := '4D6F757365446F776E3D746869732E5F61637475616C2E73757070726573734D6F757365446F776E7C7C21313B636F6E737420693D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6F3D692E67657428313435';
wwv_flow_imp.g_varchar2_table(15346) := '293B746869732E5F66697865644F766572666C6F77576964676574733D692E676574283432292C746869732E5F636F6E74656E7457696474683D6F2E636F6E74656E7457696474682C746869732E5F636F6E74656E744C6566743D6F2E636F6E74656E74';
wwv_flow_imp.g_varchar2_table(15347) := '4C6566742C746869732E5F6C696E654865696768743D692E676574283637292C746869732E5F616666696E6974793D6E756C6C2C746869732E5F707265666572656E63653D5B5D2C746869732E5F636163686564446F6D4E6F64654F6666736574576964';
wwv_flow_imp.g_varchar2_table(15348) := '74683D2D312C746869732E5F636163686564446F6D4E6F64654F66667365744865696768743D2D312C746869732E5F6D617857696474683D746869732E5F6765744D6178576964746828292C746869732E5F697356697369626C653D21312C746869732E';
wwv_flow_imp.g_varchar2_table(15349) := '5F72656E646572446174613D6E756C6C2C746869732E646F6D4E6F64652E736574506F736974696F6E28746869732E5F66697865644F766572666C6F77576964676574732626746869732E616C6C6F77456469746F724F766572666C6F773F2266697865';
wwv_flow_imp.g_varchar2_table(15350) := '64223A226162736F6C75746522292C746869732E646F6D4E6F64652E736574446973706C617928226E6F6E6522292C746869732E646F6D4E6F64652E7365745669736962696C697479282268696464656E22292C746869732E646F6D4E6F64652E736574';
wwv_flow_imp.g_varchar2_table(15351) := '41747472696275746528227769646765744964222C746869732E6964292C746869732E646F6D4E6F64652E7365744D6178576964746828746869732E5F6D61785769647468297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E';
wwv_flow_imp.g_varchar2_table(15352) := '737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B696628746869732E5F6C696E654865696768743D742E676574283637292C652E6861734368616E6765642831343529297B636F6E737420653D742E';
wwv_flow_imp.g_varchar2_table(15353) := '67657428313435293B746869732E5F636F6E74656E744C6566743D652E636F6E74656E744C6566742C746869732E5F636F6E74656E7457696474683D652E636F6E74656E7457696474682C746869732E5F6D617857696474683D746869732E5F6765744D';
wwv_flow_imp.g_varchar2_table(15354) := '6178576964746828297D7D757064617465416E63686F7256696577506F736974696F6E28297B746869732E5F736574506F736974696F6E28746869732E5F616666696E6974792C746869732E5F7072696D617279416E63686F722E6D6F64656C506F7369';
wwv_flow_imp.g_varchar2_table(15355) := '74696F6E2C746869732E5F7365636F6E64617279416E63686F722E6D6F64656C506F736974696F6E297D5F736574506F736974696F6E28652C742C6E297B66756E6374696F6E206928652C742C6E297B69662821652972657475726E206E6577204D5028';
wwv_flow_imp.g_varchar2_table(15356) := '6E756C6C2C6E756C6C293B636F6E737420693D742E6D6F64656C2E76616C6964617465506F736974696F6E2865293B696628742E636F6F7264696E61746573436F6E7665727465722E6D6F64656C506F736974696F6E497356697369626C65286929297B';
wwv_flow_imp.g_varchar2_table(15357) := '636F6E7374206F3D742E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28692C6E756C6C213D6E3F6E3A766F69642030293B72657475726E206E6577204D5028';
wwv_flow_imp.g_varchar2_table(15358) := '652C6F297D72657475726E206E6577204D5028652C6E756C6C297D746869732E5F616666696E6974793D652C746869732E5F7072696D617279416E63686F723D6928742C746869732E5F636F6E746578742E766965774D6F64656C2C746869732E5F6166';
wwv_flow_imp.g_varchar2_table(15359) := '66696E697479292C746869732E5F7365636F6E64617279416E63686F723D69286E2C746869732E5F636F6E746578742E766965774D6F64656C2C746869732E5F616666696E697479297D5F6765744D6178576964746828297B636F6E737420653D746869';
wwv_flow_imp.g_varchar2_table(15360) := '732E646F6D4E6F64652E646F6D4E6F64652E6F776E6572446F63756D656E742C743D652E64656661756C74566965773B72657475726E20746869732E616C6C6F77456469746F724F766572666C6F773F286E756C6C3D3D743F766F696420303A742E696E';
wwv_flow_imp.g_varchar2_table(15361) := '6E65725769647468297C7C652E646F63756D656E74456C656D656E742E6F666673657457696474687C7C652E626F64792E6F666673657457696474683A746869732E5F636F6E74656E7457696474687D736574506F736974696F6E28652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(15362) := '7B746869732E5F736574506F736974696F6E28692C652C74292C746869732E5F707265666572656E63653D6E2C746869732E5F7072696D617279416E63686F722E76696577506F736974696F6E2626746869732E5F707265666572656E63652626746869';
wwv_flow_imp.g_varchar2_table(15363) := '732E5F707265666572656E63652E6C656E6774683E303F746869732E646F6D4E6F64652E736574446973706C61792822626C6F636B22293A746869732E646F6D4E6F64652E736574446973706C617928226E6F6E6522292C746869732E5F636163686564';
wwv_flow_imp.g_varchar2_table(15364) := '446F6D4E6F64654F666673657457696474683D2D312C746869732E5F636163686564446F6D4E6F64654F66667365744865696768743D2D317D5F6C61796F7574426F78496E56696577706F727428652C742C6E2C69297B636F6E7374206F3D652E746F70';
wwv_flow_imp.g_varchar2_table(15365) := '2C733D6F2C723D652E746F702B652E6865696768742C613D6F2D6E2C6C3D733E3D6E2C633D722C643D692E76696577706F72744865696768742D723E3D6E3B6C657420683D652E6C6566743B72657475726E20682B743E692E7363726F6C6C4C6566742B';
wwv_flow_imp.g_varchar2_table(15366) := '692E76696577706F72745769647468262628683D692E7363726F6C6C4C6566742B692E76696577706F727457696474682D74292C683C692E7363726F6C6C4C656674262628683D692E7363726F6C6C4C656674292C7B6669747341626F76653A6C2C6162';
wwv_flow_imp.g_varchar2_table(15367) := '6F7665546F703A612C6669747342656C6F773A642C62656C6F77546F703A632C6C6566743A687D7D5F6C61796F7574486F72697A6F6E74616C5365676D656E74496E5061676528652C742C6E2C69297B766172206F3B636F6E737420733D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(15368) := '61782831352C742E6C6566742D69292C723D4D6174682E6D696E28742E6C6566742B742E77696474682B692C652E77696474682D3135292C613D746869732E5F76696577446F6D4E6F64652E646F6D4E6F64652E6F776E6572446F63756D656E742E6465';
wwv_flow_imp.g_varchar2_table(15369) := '6661756C74566965773B6C6574206C3D742E6C6566742B6E2D286E756C6C213D3D286F3D6E756C6C3D3D613F766F696420303A612E7363726F6C6C58292626766F69642030213D3D6F3F6F3A30293B6966286C2B693E72297B636F6E737420653D6C2D28';
wwv_flow_imp.g_varchar2_table(15370) := '722D69293B6C2D3D652C6E2D3D657D6966286C3C73297B636F6E737420653D6C2D733B6C2D3D652C6E2D3D657D72657475726E5B6E2C6C5D7D5F6C61796F7574426F78496E5061676528652C742C6E2C69297B766172206F2C733B636F6E737420723D65';
wwv_flow_imp.g_varchar2_table(15371) := '2E746F702D6E2C613D652E746F702B652E6865696768742C6C3D417328746869732E5F76696577446F6D4E6F64652E646F6D4E6F6465292C633D746869732E5F76696577446F6D4E6F64652E646F6D4E6F64652E6F776E6572446F63756D656E742C643D';
wwv_flow_imp.g_varchar2_table(15372) := '632E64656661756C74566965772C683D6C2E746F702B722D286E756C6C213D3D286F3D6E756C6C3D3D643F766F696420303A642E7363726F6C6C59292626766F69642030213D3D6F3F6F3A30292C753D6C2E746F702B612D286E756C6C213D3D28733D6E';
wwv_flow_imp.g_varchar2_table(15373) := '756C6C3D3D643F766F696420303A642E7363726F6C6C59292626766F69642030213D3D733F733A30292C703D447328632E626F6479292C5B672C6D5D3D746869732E5F6C61796F7574486F72697A6F6E74616C5365676D656E74496E5061676528702C6C';
wwv_flow_imp.g_varchar2_table(15374) := '2C652E6C6566742D692E7363726F6C6C4C6566742B746869732E5F636F6E74656E744C6566742C74292C663D683E3D32322C763D752B6E3C3D702E6865696768742D32323B72657475726E20746869732E5F66697865644F766572666C6F775769646765';
wwv_flow_imp.g_varchar2_table(15375) := '74733F7B6669747341626F76653A662C61626F7665546F703A4D6174682E6D617828682C3232292C6669747342656C6F773A762C62656C6F77546F703A752C6C6566743A6D7D3A7B6669747341626F76653A662C61626F7665546F703A722C6669747342';
wwv_flow_imp.g_varchar2_table(15376) := '656C6F773A762C62656C6F77546F703A612C6C6566743A677D7D5F7072657061726552656E64657257696467657441744578616374506F736974696F6E4F766572666C6F77696E672865297B72657475726E206E657720415028652E746F702C652E6C65';
wwv_flow_imp.g_varchar2_table(15377) := '66742B746869732E5F636F6E74656E744C656674297D5F676574416E63686F7273436F6F7264696E617465732865297B76617220742C6E3B72657475726E7B7072696D6172793A6928746869732E5F7072696D617279416E63686F722E76696577506F73';
wwv_flow_imp.g_varchar2_table(15378) := '6974696F6E2C746869732E5F616666696E6974792C746869732E5F6C696E65486569676874292C7365636F6E646172793A6928286E756C6C3D3D3D28743D746869732E5F7365636F6E64617279416E63686F722E76696577506F736974696F6E297C7C76';
wwv_flow_imp.g_varchar2_table(15379) := '6F696420303D3D3D743F766F696420303A742E6C696E654E756D626572293D3D3D286E756C6C3D3D3D286E3D746869732E5F7072696D617279416E63686F722E76696577506F736974696F6E297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C';
wwv_flow_imp.g_varchar2_table(15380) := '696E654E756D626572293F746869732E5F7365636F6E64617279416E63686F722E76696577506F736974696F6E3A6E756C6C2C746869732E5F616666696E6974792C746869732E5F6C696E65486569676874297D3B66756E6374696F6E206928742C6E2C';
wwv_flow_imp.g_varchar2_table(15381) := '69297B69662821742972657475726E206E756C6C3B636F6E7374206F3D652E76697369626C6552616E6765466F72506F736974696F6E2874293B696628216F2972657475726E206E756C6C3B636F6E737420733D313D3D3D742E636F6C756D6E2626333D';
wwv_flow_imp.g_varchar2_table(15382) := '3D3D6E3F303A6F2E6C6566742C723D652E676574566572746963616C4F6666736574466F724C696E654E756D62657228742E6C696E654E756D626572292D652E7363726F6C6C546F703B72657475726E206E6577204E5028722C732C69297D7D5F726564';
wwv_flow_imp.g_varchar2_table(15383) := '756365416E63686F72436F6F7264696E6174657328652C742C6E297B69662821742972657475726E20653B636F6E737420693D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E676574283530293B6C6574206F';
wwv_flow_imp.g_varchar2_table(15384) := '3D742E6C6566743B72657475726E206F3D6F3C652E6C6566743F4D6174682E6D6178286F2C652E6C6566742D6E2B692E7479706963616C46756C6C77696474684368617261637465725769647468293A4D6174682E6D696E286F2C652E6C6566742B6E2D';
wwv_flow_imp.g_varchar2_table(15385) := '692E7479706963616C46756C6C77696474684368617261637465725769647468292C6E6577204E5028652E746F702C6F2C652E686569676874297D5F7072657061726552656E6465725769646765742865297B69662821746869732E5F70726566657265';
wwv_flow_imp.g_varchar2_table(15386) := '6E63657C7C303D3D3D746869732E5F707265666572656E63652E6C656E6774682972657475726E206E756C6C3B636F6E73747B7072696D6172793A742C7365636F6E646172793A6E7D3D746869732E5F676574416E63686F7273436F6F7264696E617465';
wwv_flow_imp.g_varchar2_table(15387) := '732865293B69662821742972657475726E206E756C6C3B6966282D313D3D3D746869732E5F636163686564446F6D4E6F64654F666673657457696474687C7C2D313D3D3D746869732E5F636163686564446F6D4E6F64654F666673657448656967687429';
wwv_flow_imp.g_varchar2_table(15388) := '7B6C657420653D6E756C6C3B6966282266756E6374696F6E223D3D747970656F6620746869732E5F61637475616C2E6265666F726552656E646572262628653D505028746869732E5F61637475616C2E6265666F726552656E6465722C746869732E5F61';
wwv_flow_imp.g_varchar2_table(15389) := '637475616C29292C6529746869732E5F636163686564446F6D4E6F64654F666673657457696474683D652E77696474682C746869732E5F636163686564446F6D4E6F64654F66667365744865696768743D652E6865696768743B656C73657B636F6E7374';
wwv_flow_imp.g_varchar2_table(15390) := '20653D746869732E646F6D4E6F64652E646F6D4E6F64652E676574426F756E64696E67436C69656E745265637428293B746869732E5F636163686564446F6D4E6F64654F666673657457696474683D4D6174682E726F756E6428652E7769647468292C74';
wwv_flow_imp.g_varchar2_table(15391) := '6869732E5F636163686564446F6D4E6F64654F66667365744865696768743D4D6174682E726F756E6428652E686569676874297D7D636F6E737420693D746869732E5F726564756365416E63686F72436F6F7264696E6174657328742C6E2C746869732E';
wwv_flow_imp.g_varchar2_table(15392) := '5F636163686564446F6D4E6F64654F66667365745769647468293B6C6574206F3B6F3D746869732E616C6C6F77456469746F724F766572666C6F773F746869732E5F6C61796F7574426F78496E5061676528692C746869732E5F636163686564446F6D4E';
wwv_flow_imp.g_varchar2_table(15393) := '6F64654F666673657457696474682C746869732E5F636163686564446F6D4E6F64654F66667365744865696768742C65293A746869732E5F6C61796F7574426F78496E56696577706F727428692C746869732E5F636163686564446F6D4E6F64654F6666';
wwv_flow_imp.g_varchar2_table(15394) := '73657457696474682C746869732E5F636163686564446F6D4E6F64654F66667365744865696768742C65293B666F72286C657420653D313B653C3D323B652B2B29666F7228636F6E73742074206F6620746869732E5F707265666572656E636529696628';
wwv_flow_imp.g_varchar2_table(15395) := '313D3D3D74297B696628216F2972657475726E206E756C6C3B696628323D3D3D657C7C6F2E6669747341626F76652972657475726E7B636F6F7264696E6174653A6E6577204150286F2E61626F7665546F702C6F2E6C656674292C706F736974696F6E3A';
wwv_flow_imp.g_varchar2_table(15396) := '317D7D656C73657B69662832213D3D742972657475726E20746869732E616C6C6F77456469746F724F766572666C6F773F7B636F6F7264696E6174653A746869732E5F7072657061726552656E64657257696467657441744578616374506F736974696F';
wwv_flow_imp.g_varchar2_table(15397) := '6E4F766572666C6F77696E67286E657720415028692E746F702C692E6C65667429292C706F736974696F6E3A307D3A7B636F6F7264696E6174653A6E657720415028692E746F702C692E6C656674292C706F736974696F6E3A307D3B696628216F297265';
wwv_flow_imp.g_varchar2_table(15398) := '7475726E206E756C6C3B696628323D3D3D657C7C6F2E6669747342656C6F772972657475726E7B636F6F7264696E6174653A6E6577204150286F2E62656C6F77546F702C6F2E6C656674292C706F736974696F6E3A327D7D72657475726E206E756C6C7D';
wwv_flow_imp.g_varchar2_table(15399) := '6F6E4265666F726552656E6465722865297B746869732E5F7072696D617279416E63686F722E76696577506F736974696F6E2626746869732E5F707265666572656E6365262628746869732E5F7072696D617279416E63686F722E76696577506F736974';
wwv_flow_imp.g_varchar2_table(15400) := '696F6E2E6C696E654E756D6265723C652E73746172744C696E654E756D6265727C7C746869732E5F7072696D617279416E63686F722E76696577506F736974696F6E2E6C696E654E756D6265723E652E656E644C696E654E756D6265727C7C746869732E';
wwv_flow_imp.g_varchar2_table(15401) := '646F6D4E6F64652E7365744D6178576964746828746869732E5F6D6178576964746829297D7072657061726552656E6465722865297B746869732E5F72656E646572446174613D746869732E5F7072657061726552656E6465725769646765742865297D';
wwv_flow_imp.g_varchar2_table(15402) := '72656E6465722865297B69662821746869732E5F72656E646572446174612972657475726E20746869732E5F697356697369626C65262628746869732E646F6D4E6F64652E72656D6F766541747472696275746528226D6F6E61636F2D76697369626C65';
wwv_flow_imp.g_varchar2_table(15403) := '2D636F6E74656E742D77696467657422292C746869732E5F697356697369626C653D21312C746869732E646F6D4E6F64652E7365745669736962696C697479282268696464656E2229292C766F6964282266756E6374696F6E223D3D747970656F662074';
wwv_flow_imp.g_varchar2_table(15404) := '6869732E5F61637475616C2E616674657252656E6465722626505028746869732E5F61637475616C2E616674657252656E6465722C746869732E5F61637475616C2C6E756C6C29293B746869732E616C6C6F77456469746F724F766572666C6F773F2874';
wwv_flow_imp.g_varchar2_table(15405) := '6869732E646F6D4E6F64652E736574546F7028746869732E5F72656E646572446174612E636F6F7264696E6174652E746F70292C746869732E646F6D4E6F64652E7365744C65667428746869732E5F72656E646572446174612E636F6F7264696E617465';
wwv_flow_imp.g_varchar2_table(15406) := '2E6C65667429293A28746869732E646F6D4E6F64652E736574546F7028746869732E5F72656E646572446174612E636F6F7264696E6174652E746F702B652E7363726F6C6C546F702D652E6269674E756D6265727344656C7461292C746869732E646F6D';
wwv_flow_imp.g_varchar2_table(15407) := '4E6F64652E7365744C65667428746869732E5F72656E646572446174612E636F6F7264696E6174652E6C65667429292C746869732E5F697356697369626C657C7C28746869732E646F6D4E6F64652E7365745669736962696C6974792822696E68657269';
wwv_flow_imp.g_varchar2_table(15408) := '7422292C746869732E646F6D4E6F64652E73657441747472696275746528226D6F6E61636F2D76697369626C652D636F6E74656E742D776964676574222C227472756522292C746869732E5F697356697369626C653D2130292C2266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(15409) := '3D3D747970656F6620746869732E5F61637475616C2E616674657252656E6465722626505028746869732E5F61637475616C2E616674657252656E6465722C746869732E5F61637475616C2C746869732E5F72656E646572446174612E706F736974696F';
wwv_flow_imp.g_varchar2_table(15410) := '6E297D7D636C617373204D507B636F6E7374727563746F7228652C74297B746869732E6D6F64656C506F736974696F6E3D652C746869732E76696577506F736974696F6E3D747D7D636C6173732041507B636F6E7374727563746F7228652C74297B7468';
wwv_flow_imp.g_varchar2_table(15411) := '69732E746F703D652C746869732E6C6566743D742C746869732E5F636F6F7264696E6174654272616E643D766F696420307D7D636C617373204E507B636F6E7374727563746F7228652C742C6E297B746869732E746F703D652C746869732E6C6566743D';
wwv_flow_imp.g_varchar2_table(15412) := '742C746869732E6865696768743D6E2C746869732E5F616E63686F72436F6F7264696E6174654272616E643D766F696420307D7D66756E6374696F6E20505028652C742C2E2E2E6E297B7472797B72657475726E20652E63616C6C28742C2E2E2E6E297D';
wwv_flow_imp.g_varchar2_table(15413) := '63617463682865297B72657475726E206E756C6C7D7D766172204F503D6E2838343035292C52503D7B7D3B52502E7374796C655461675472616E73666F726D3D6A7228292C52502E736574417474726962757465733D567228292C52502E696E73657274';
wwv_flow_imp.g_varchar2_table(15414) := '3D467228292E62696E64286E756C6C2C226865616422292C52502E646F6D4150493D4F7228292C52502E696E736572745374796C65456C656D656E743D487228292C4E722829284F502E412C5250292C4F502E4126264F502E412E6C6F63616C7326264F';
wwv_flow_imp.g_varchar2_table(15415) := '502E412E6C6F63616C733B636C61737320465020657874656E6473206F507B636F6E7374727563746F722865297B737570657228292C746869732E5F636F6E746578743D653B636F6E737420743D746869732E5F636F6E746578742E636F6E6669677572';
wwv_flow_imp.g_varchar2_table(15416) := '6174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B746869732E5F72656E6465724C696E65486967686C696768743D742E676574283936292C746869732E5F72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375';
wwv_flow_imp.g_varchar2_table(15417) := '733D742E676574283937292C746869732E5F776F7264577261703D6E2E697356696577706F72745772617070696E672C746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E5F636F6E74656E7457696474683D6E';
wwv_flow_imp.g_varchar2_table(15418) := '2E636F6E74656E7457696474682C746869732E5F73656C656374696F6E4973456D7074793D21302C746869732E5F666F63757365643D21312C746869732E5F637572736F724C696E654E756D626572733D5B315D2C746869732E5F73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(15419) := '733D5B6E657720616828312C312C312C31295D2C746869732E5F72656E646572446174613D6E756C6C2C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(15420) := '742E72656D6F76654576656E7448616E646C65722874686973292C73757065722E646973706F736528297D5F7265616446726F6D53656C656374696F6E7328297B6C657420653D21313B636F6E737420743D6E6577205365743B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(15421) := '65206F6620746869732E5F73656C656374696F6E7329742E61646428652E706F736974696F6E4C696E654E756D626572293B636F6E7374206E3D41727261792E66726F6D2874293B6E2E736F7274282828652C74293D3E652D7429292C50682874686973';
wwv_flow_imp.g_varchar2_table(15422) := '2E5F637572736F724C696E654E756D626572732C6E297C7C28746869732E5F637572736F724C696E654E756D626572733D6E2C653D2130293B636F6E737420693D746869732E5F73656C656374696F6E732E65766572792828653D3E652E6973456D7074';
wwv_flow_imp.g_varchar2_table(15423) := '79282929293B72657475726E20746869732E5F73656C656374696F6E4973456D707479213D3D69262628746869732E5F73656C656374696F6E4973456D7074793D692C653D2130292C657D6F6E5468656D654368616E6765642865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(15424) := '746869732E5F7265616446726F6D53656C656374696F6E7328297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D74';
wwv_flow_imp.g_varchar2_table(15425) := '2E67657428313435293B72657475726E20746869732E5F72656E6465724C696E65486967686C696768743D742E676574283936292C746869732E5F72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375733D742E676574283937';
wwv_flow_imp.g_varchar2_table(15426) := '292C746869732E5F776F7264577261703D6E2E697356696577706F72745772617070696E672C746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E5F636F6E74656E7457696474683D6E2E636F6E74656E745769';
wwv_flow_imp.g_varchar2_table(15427) := '6474682C21307D6F6E437572736F7253746174654368616E6765642865297B72657475726E20746869732E5F73656C656374696F6E733D652E73656C656374696F6E732C746869732E5F7265616446726F6D53656C656374696F6E7328297D6F6E466C75';
wwv_flow_imp.g_varchar2_table(15428) := '736865642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E';
wwv_flow_imp.g_varchar2_table(15429) := '7363726F6C6C57696474684368616E6765647C7C652E7363726F6C6C546F704368616E6765647D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D6F6E466F6375734368616E6765642865297B72657475726E2121746869732E5F7265';
wwv_flow_imp.g_varchar2_table(15430) := '6E6465724C696E65486967686C696768744F6E6C795768656E466F637573262628746869732E5F666F63757365643D652E6973466F63757365642C2130297D7072657061726552656E6465722865297B69662821746869732E5F73686F756C6452656E64';
wwv_flow_imp.g_varchar2_table(15431) := '65725468697328292972657475726E20766F696428746869732E5F72656E646572446174613D6E756C6C293B636F6E737420743D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C6E3D652E76697369626C6552616E67652E';
wwv_flow_imp.g_varchar2_table(15432) := '656E644C696E654E756D6265722C693D5B5D3B666F72286C657420653D743B653C3D6E3B652B2B29695B652D745D3D22223B696628746869732E5F776F726457726170297B636F6E7374206F3D746869732E5F72656E6465724F6E6528652C2131293B66';
wwv_flow_imp.g_varchar2_table(15433) := '6F7228636F6E73742065206F6620746869732E5F637572736F724C696E654E756D62657273297B636F6E737420733D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722C723D732E636F6E76';
wwv_flow_imp.g_varchar2_table(15434) := '65727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E6577206D6328652C3129292E6C696E654E756D6265722C613D732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D63';
wwv_flow_imp.g_varchar2_table(15435) := '28722C3129292E6C696E654E756D6265722C6C3D732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328722C746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744C';
wwv_flow_imp.g_varchar2_table(15436) := '696E654D6178436F6C756D6E28722929292E6C696E654E756D6265722C633D4D6174682E6D617828612C74292C643D4D6174682E6D696E286C2C6E293B666F72286C657420653D633B653C3D643B652B2B29695B652D745D3D6F7D7D636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(15437) := '746869732E5F72656E6465724F6E6528652C2130293B666F7228636F6E73742065206F6620746869732E5F637572736F724C696E654E756D6265727329653C747C7C653E6E7C7C28695B652D745D3D6F293B746869732E5F72656E646572446174613D69';
wwv_flow_imp.g_varchar2_table(15438) := '7D72656E64657228652C74297B69662821746869732E5F72656E646572446174612972657475726E22223B636F6E7374206E3D742D653B72657475726E206E3E3D746869732E5F72656E646572446174612E6C656E6774683F22223A746869732E5F7265';
wwv_flow_imp.g_varchar2_table(15439) := '6E646572446174615B6E5D7D5F73686F756C6452656E646572496E4D617267696E28297B72657475726E2822677574746572223D3D3D746869732E5F72656E6465724C696E65486967686C696768747C7C22616C6C223D3D3D746869732E5F72656E6465';
wwv_flow_imp.g_varchar2_table(15440) := '724C696E65486967686C696768742926262821746869732E5F72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375737C7C746869732E5F666F6375736564297D5F73686F756C6452656E646572496E436F6E74656E7428297B72';
wwv_flow_imp.g_varchar2_table(15441) := '657475726E28226C696E65223D3D3D746869732E5F72656E6465724C696E65486967686C696768747C7C22616C6C223D3D3D746869732E5F72656E6465724C696E65486967686C69676874292626746869732E5F73656C656374696F6E4973456D707479';
wwv_flow_imp.g_varchar2_table(15442) := '26262821746869732E5F72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375737C7C746869732E5F666F6375736564297D7D636C61737320425020657874656E64732046507B5F72656E6465724F6E6528652C74297B72657475';
wwv_flow_imp.g_varchar2_table(15443) := '726E603C64697620636C6173733D22247B2263757272656E742D6C696E65222B28746869732E5F73686F756C6452656E646572496E4D617267696E28293F222063757272656E742D6C696E652D626F7468223A2222292B28743F222063757272656E742D';
wwv_flow_imp.g_varchar2_table(15444) := '6C696E652D6578616374223A2222297D22207374796C653D2277696474683A247B4D6174682E6D617828652E7363726F6C6C57696474682C746869732E5F636F6E74656E745769647468297D70783B223E3C2F6469763E607D5F73686F756C6452656E64';
wwv_flow_imp.g_varchar2_table(15445) := '65725468697328297B72657475726E20746869732E5F73686F756C6452656E646572496E436F6E74656E7428297D5F73686F756C6452656E6465724F7468657228297B72657475726E20746869732E5F73686F756C6452656E646572496E4D617267696E';
wwv_flow_imp.g_varchar2_table(15446) := '28297D7D636C61737320565020657874656E64732046507B5F72656E6465724F6E6528652C74297B72657475726E603C64697620636C6173733D22247B2263757272656E742D6C696E65222B28746869732E5F73686F756C6452656E646572496E4D6172';
wwv_flow_imp.g_varchar2_table(15447) := '67696E28293F222063757272656E742D6C696E652D6D617267696E223A2222292B28746869732E5F73686F756C6452656E6465724F7468657228293F222063757272656E742D6C696E652D6D617267696E2D626F7468223A2222292B28746869732E5F73';
wwv_flow_imp.g_varchar2_table(15448) := '686F756C6452656E646572496E4D617267696E28292626743F222063757272656E742D6C696E652D65786163742D6D617267696E223A2222297D22207374796C653D2277696474683A247B746869732E5F636F6E74656E744C6566747D7078223E3C2F64';
wwv_flow_imp.g_varchar2_table(15449) := '69763E607D5F73686F756C6452656E6465725468697328297B72657475726E21307D5F73686F756C6452656E6465724F7468657228297B72657475726E20746869732E5F73686F756C6452656E646572496E436F6E74656E7428297D7D5662282828652C';
wwv_flow_imp.g_varchar2_table(15450) := '74293D3E7B636F6E7374206E3D652E676574436F6C6F72284862293B6966286E262628742E61646452756C6528602E6D6F6E61636F2D656469746F72202E766965772D6F7665726C617973202E63757272656E742D6C696E65207B206261636B67726F75';
wwv_flow_imp.g_varchar2_table(15451) := '6E642D636F6C6F723A20247B6E7D3B207D60292C742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E63757272656E742D6C696E652D6D617267696E207B206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(15452) := '642D636F6C6F723A20247B6E7D3B20626F726465723A206E6F6E653B207D6029292C216E7C7C6E2E69735472616E73706172656E7428297C7C652E646566696E657328576229297B636F6E7374206E3D652E676574436F6C6F72285762293B6E26262874';
wwv_flow_imp.g_varchar2_table(15453) := '2E61646452756C6528602E6D6F6E61636F2D656469746F72202E766965772D6F7665726C617973202E63757272656E742D6C696E652D6578616374207B20626F726465723A2032707820736F6C696420247B6E7D3B207D60292C742E61646452756C6528';
wwv_flow_imp.g_varchar2_table(15454) := '602E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E63757272656E742D6C696E652D65786163742D6D617267696E207B20626F726465723A2032707820736F6C696420247B6E7D3B207D60292C416228652E';
wwv_flow_imp.g_varchar2_table(15455) := '7479706529262628742E61646452756C6528222E6D6F6E61636F2D656469746F72202E766965772D6F7665726C617973202E63757272656E742D6C696E652D6578616374207B20626F726465722D77696474683A203170783B207D22292C742E61646452';
wwv_flow_imp.g_varchar2_table(15456) := '756C6528222E6D6F6E61636F2D656469746F72202E6D617267696E2D766965772D6F7665726C617973202E63757272656E742D6C696E652D65786163742D6D617267696E207B20626F726465722D77696474683A203170783B207D222929297D7D29293B';
wwv_flow_imp.g_varchar2_table(15457) := '766172207A503D6E2833303933292C48503D7B7D3B48502E7374796C655461675472616E73666F726D3D6A7228292C48502E736574417474726962757465733D567228292C48502E696E736572743D467228292E62696E64286E756C6C2C226865616422';
wwv_flow_imp.g_varchar2_table(15458) := '292C48502E646F6D4150493D4F7228292C48502E696E736572745374796C65456C656D656E743D487228292C4E722829287A502E412C4850292C7A502E4126267A502E412E6C6F63616C7326267A502E412E6C6F63616C733B636C617373205750206578';
wwv_flow_imp.g_varchar2_table(15459) := '74656E6473206F507B636F6E7374727563746F722865297B737570657228292C746869732E5F636F6E746578743D653B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B746869732E5F7479';
wwv_flow_imp.g_varchar2_table(15460) := '706963616C48616C66776964746843686172616374657257696474683D742E676574283530292E7479706963616C48616C66776964746843686172616374657257696474682C746869732E5F72656E646572526573756C743D6E756C6C2C746869732E5F';
wwv_flow_imp.g_varchar2_table(15461) := '636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E5F72656E646572526573756C743D6E75';
wwv_flow_imp.g_varchar2_table(15462) := '6C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(15463) := '2E5F7479706963616C48616C66776964746843686172616374657257696474683D742E676574283530292E7479706963616C48616C66776964746843686172616374657257696474682C21307D6F6E4465636F726174696F6E734368616E676564286529';
wwv_flow_imp.g_varchar2_table(15464) := '7B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465';
wwv_flow_imp.g_varchar2_table(15465) := '642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647C7C652E7363726F6C6C57696474684368616E6765647D6F6E5A6F6E65734368616E6765642865297B72';
wwv_flow_imp.g_varchar2_table(15466) := '657475726E21307D7072657061726552656E6465722865297B636F6E737420743D652E6765744465636F726174696F6E73496E56696577706F727428293B6C6574206E3D5B5D2C693D303B666F72286C657420653D302C6F3D742E6C656E6774683B653C';
wwv_flow_imp.g_varchar2_table(15467) := '6F3B652B2B297B636F6E7374206F3D745B655D3B6F2E6F7074696F6E732E636C6173734E616D652626286E5B692B2B5D3D6F297D6E3D6E2E736F7274282828652C74293D3E7B696628652E6F7074696F6E732E7A496E6465783C742E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(15468) := '7A496E6465782972657475726E2D313B696628652E6F7074696F6E732E7A496E6465783E742E6F7074696F6E732E7A496E6465782972657475726E20313B636F6E7374206E3D652E6F7074696F6E732E636C6173734E616D652C693D742E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(15469) := '732E636C6173734E616D653B72657475726E206E3C693F2D313A6E3E693F313A72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E6765297D29293B636F6E7374206F3D652E76697369626C6552616E';
wwv_flow_imp.g_varchar2_table(15470) := '67652E73746172744C696E654E756D6265722C733D652E76697369626C6552616E67652E656E644C696E654E756D6265722C723D5B5D3B666F72286C657420653D6F3B653C3D733B652B2B29725B652D6F5D3D22223B746869732E5F72656E6465725768';
wwv_flow_imp.g_varchar2_table(15471) := '6F6C654C696E654465636F726174696F6E7328652C6E2C72292C746869732E5F72656E6465724E6F726D616C4465636F726174696F6E7328652C6E2C72292C746869732E5F72656E646572526573756C743D727D5F72656E64657257686F6C654C696E65';
wwv_flow_imp.g_varchar2_table(15472) := '4465636F726174696F6E7328652C742C6E297B636F6E737420693D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C6F3D652E76697369626C6552616E67652E656E644C696E654E756D6265723B666F72286C657420653D30';
wwv_flow_imp.g_varchar2_table(15473) := '2C733D742E6C656E6774683B653C733B652B2B297B636F6E737420733D745B655D3B69662821732E6F7074696F6E732E697357686F6C654C696E6529636F6E74696E75653B636F6E737420723D273C64697620636C6173733D2263647220272B732E6F70';
wwv_flow_imp.g_varchar2_table(15474) := '74696F6E732E636C6173734E616D652B2722207374796C653D226C6566743A303B77696474683A313030253B223E3C2F6469763E272C613D4D6174682E6D617828732E72616E67652E73746172744C696E654E756D6265722C69292C6C3D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(15475) := '696E28732E72616E67652E656E644C696E654E756D6265722C6F293B666F72286C657420653D613B653C3D6C3B652B2B296E5B652D695D2B3D727D7D5F72656E6465724E6F726D616C4465636F726174696F6E7328652C742C6E297B76617220693B636F';
wwv_flow_imp.g_varchar2_table(15476) := '6E7374206F3D652E76697369626C6552616E67652E73746172744C696E654E756D6265723B6C657420733D6E756C6C2C723D21312C613D6E756C6C2C6C3D21313B666F72286C657420633D302C643D742E6C656E6774683B633C643B632B2B297B636F6E';
wwv_flow_imp.g_varchar2_table(15477) := '737420643D745B635D3B696628642E6F7074696F6E732E697357686F6C654C696E6529636F6E74696E75653B636F6E737420683D642E6F7074696F6E732E636C6173734E616D652C753D426F6F6C65616E28642E6F7074696F6E732E73686F774966436F';
wwv_flow_imp.g_varchar2_table(15478) := '6C6C6170736564293B6C657420703D642E72616E67653B752626313D3D3D702E656E64436F6C756D6E2626702E656E644C696E654E756D626572213D3D702E73746172744C696E654E756D626572262628703D6E657720726828702E73746172744C696E';
wwv_flow_imp.g_varchar2_table(15479) := '654E756D6265722C702E7374617274436F6C756D6E2C702E656E644C696E654E756D6265722D312C746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E28702E656E644C696E654E756D6265722D312929';
wwv_flow_imp.g_varchar2_table(15480) := '292C733D3D3D682626723D3D3D75262672682E617265496E74657273656374696E674F72546F756368696E6728612C70293F613D72682E706C757352616E676528612C70293A286E756C6C213D3D732626746869732E5F72656E6465724E6F726D616C44';
wwv_flow_imp.g_varchar2_table(15481) := '65636F726174696F6E28652C612C732C6C2C722C6F2C6E292C733D682C723D752C613D702C6C3D6E756C6C213D3D28693D642E6F7074696F6E732E73686F756C6446696C6C4C696E654F6E4C696E65427265616B292626766F69642030213D3D69262669';
wwv_flow_imp.g_varchar2_table(15482) := '297D6E756C6C213D3D732626746869732E5F72656E6465724E6F726D616C4465636F726174696F6E28652C612C732C6C2C722C6F2C6E297D5F72656E6465724E6F726D616C4465636F726174696F6E28652C742C6E2C692C6F2C732C72297B636F6E7374';
wwv_flow_imp.g_varchar2_table(15483) := '20613D652E6C696E657356697369626C6552616E676573466F7252616E676528742C2266696E644D61746368223D3D3D6E293B6966286129666F72286C657420653D302C743D612E6C656E6774683B653C743B652B2B297B636F6E737420743D615B655D';
wwv_flow_imp.g_varchar2_table(15484) := '3B696628742E6F75747369646552656E64657265644C696E6529636F6E74696E75653B636F6E7374206C3D742E6C696E654E756D6265722D733B6966286F2626313D3D3D742E72616E6765732E6C656E677468297B636F6E737420653D742E72616E6765';
wwv_flow_imp.g_varchar2_table(15485) := '735B305D3B696628652E77696474683C746869732E5F7479706963616C48616C6677696474684368617261637465725769647468297B636F6E7374206E3D4D6174682E726F756E6428652E6C6566742B652E77696474682F32292C693D4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(15486) := '7828302C4D6174682E726F756E64286E2D746869732E5F7479706963616C48616C66776964746843686172616374657257696474682F3229293B742E72616E6765735B305D3D6E6577206F4E28692C746869732E5F7479706963616C48616C6677696474';
wwv_flow_imp.g_varchar2_table(15487) := '684368617261637465725769647468297D7D666F72286C657420653D302C6F3D742E72616E6765732E6C656E6774683B653C6F3B652B2B297B636F6E737420733D692626742E636F6E74696E7565734F6E4E6578744C696E652626313D3D3D6F2C613D74';
wwv_flow_imp.g_varchar2_table(15488) := '2E72616E6765735B655D2C633D273C64697620636C6173733D2263647220272B6E2B2722207374796C653D226C6566743A272B537472696E6728612E6C656674292B2270783B77696474683A222B28733F22313030253B223A537472696E6728612E7769';
wwv_flow_imp.g_varchar2_table(15489) := '647468292B2270783B22292B27223E3C2F6469763E273B725B6C5D2B3D637D7D7D72656E64657228652C74297B69662821746869732E5F72656E646572526573756C742972657475726E22223B636F6E7374206E3D742D653B72657475726E206E3C307C';
wwv_flow_imp.g_varchar2_table(15490) := '7C6E3E3D746869732E5F72656E646572526573756C742E6C656E6774683F22223A746869732E5F72656E646572526573756C745B6E5D7D7D636C617373206A5020657874656E6473204A417B636F6E7374727563746F7228652C742C6E2C69297B737570';
wwv_flow_imp.g_varchar2_table(15491) := '65722865293B636F6E7374206F3D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C733D6F2E67657428313033292C723D6F2E676574283735292C613D6F2E676574283430292C6C3D6F2E67657428313036292C';
wwv_flow_imp.g_varchar2_table(15492) := '633D7B6C697374656E4F6E446F6D4E6F64653A6E2E646F6D4E6F64652C636C6173734E616D653A22656469746F722D7363726F6C6C61626C6520222B526228652E7468656D652E74797065292C757365536861646F77733A21312C6C617A7952656E6465';
wwv_flow_imp.g_varchar2_table(15493) := '723A21302C766572746963616C3A732E766572746963616C2C686F72697A6F6E74616C3A732E686F72697A6F6E74616C2C766572746963616C4861734172726F77733A732E766572746963616C4861734172726F77732C686F72697A6F6E74616C486173';
wwv_flow_imp.g_varchar2_table(15494) := '4172726F77733A732E686F72697A6F6E74616C4861734172726F77732C766572746963616C5363726F6C6C62617253697A653A732E766572746963616C5363726F6C6C62617253697A652C766572746963616C536C6964657253697A653A732E76657274';
wwv_flow_imp.g_varchar2_table(15495) := '6963616C536C6964657253697A652C686F72697A6F6E74616C5363726F6C6C62617253697A653A732E686F72697A6F6E74616C5363726F6C6C62617253697A652C686F72697A6F6E74616C536C6964657253697A653A732E686F72697A6F6E74616C536C';
wwv_flow_imp.g_varchar2_table(15496) := '6964657253697A652C68616E646C654D6F757365576865656C3A732E68616E646C654D6F757365576865656C2C616C77617973436F6E73756D654D6F757365576865656C3A732E616C77617973436F6E73756D654D6F757365576865656C2C6172726F77';
wwv_flow_imp.g_varchar2_table(15497) := '53697A653A732E6172726F7753697A652C6D6F757365576865656C5363726F6C6C53656E73697469766974793A722C666173745363726F6C6C53656E73697469766974793A612C7363726F6C6C507265646F6D696E616E74417869733A6C2C7363726F6C';
wwv_flow_imp.g_varchar2_table(15498) := '6C4279506167653A732E7363726F6C6C4279506167657D3B746869732E7363726F6C6C6261723D746869732E5F7265676973746572286E657720705428742E646F6D4E6F64652C632C746869732E5F636F6E746578742E766965774C61796F75742E6765';
wwv_flow_imp.g_varchar2_table(15499) := '745363726F6C6C61626C65282929292C654E2E777269746528746869732E7363726F6C6C6261722E676574446F6D4E6F646528292C36292C746869732E7363726F6C6C626172446F6D4E6F64653D734528746869732E7363726F6C6C6261722E67657444';
wwv_flow_imp.g_varchar2_table(15500) := '6F6D4E6F64652829292C746869732E7363726F6C6C626172446F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C746869732E5F7365744C61796F757428293B636F6E737420643D28652C742C6E293D3E7B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(15501) := '7B7D3B69662874297B636F6E737420743D652E7363726F6C6C546F703B74262628692E7363726F6C6C546F703D746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E745363726F6C6C546F7028292B742C652E7363726F';
wwv_flow_imp.g_varchar2_table(15502) := '6C6C546F703D30297D6966286E297B636F6E737420743D652E7363726F6C6C4C6566743B74262628692E7363726F6C6C4C6566743D746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E745363726F6C6C4C6566742829';
wwv_flow_imp.g_varchar2_table(15503) := '2B742C652E7363726F6C6C4C6566743D30297D746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E28692C31297D3B746869732E5F7265676973746572286273286E2E646F';
wwv_flow_imp.g_varchar2_table(15504) := '6D4E6F64652C227363726F6C6C222C28653D3E64286E2E646F6D4E6F64652C21302C2130292929292C746869732E5F726567697374657228627328742E646F6D4E6F64652C227363726F6C6C222C28653D3E6428742E646F6D4E6F64652C21302C213129';
wwv_flow_imp.g_varchar2_table(15505) := '2929292C746869732E5F726567697374657228627328692E646F6D4E6F64652C227363726F6C6C222C28653D3E6428692E646F6D4E6F64652C21302C2131292929292C746869732E5F726567697374657228627328746869732E7363726F6C6C62617244';
wwv_flow_imp.g_varchar2_table(15506) := '6F6D4E6F64652E646F6D4E6F64652C227363726F6C6C222C28653D3E6428746869732E7363726F6C6C626172446F6D4E6F64652E646F6D4E6F64652C21302C2131292929297D646973706F736528297B73757065722E646973706F736528297D5F736574';
wwv_flow_imp.g_varchar2_table(15507) := '4C61796F757428297B636F6E737420653D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C743D652E67657428313435293B746869732E7363726F6C6C626172446F6D4E6F64652E7365744C65667428742E636F';
wwv_flow_imp.g_varchar2_table(15508) := '6E74656E744C656674292C227269676874223D3D3D652E676574283733292E736964653F746869732E7363726F6C6C626172446F6D4E6F64652E736574576964746828742E636F6E74656E7457696474682B742E6D696E696D61702E6D696E696D617057';
wwv_flow_imp.g_varchar2_table(15509) := '69647468293A746869732E7363726F6C6C626172446F6D4E6F64652E736574576964746828742E636F6E74656E745769647468292C746869732E7363726F6C6C626172446F6D4E6F64652E73657448656967687428742E686569676874297D6765744F76';
wwv_flow_imp.g_varchar2_table(15510) := '65727669657752756C65724C61796F7574496E666F28297B72657475726E20746869732E7363726F6C6C6261722E6765744F7665727669657752756C65724C61796F7574496E666F28297D676574446F6D4E6F646528297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(15511) := '7363726F6C6C626172446F6D4E6F64657D64656C6567617465566572746963616C5363726F6C6C626172506F696E746572446F776E2865297B746869732E7363726F6C6C6261722E64656C6567617465566572746963616C5363726F6C6C626172506F69';
wwv_flow_imp.g_varchar2_table(15512) := '6E746572446F776E2865297D64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E742865297B746869732E7363726F6C6C6261722E64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E74286529';
wwv_flow_imp.g_varchar2_table(15513) := '7D6F6E436F6E66696775726174696F6E4368616E6765642865297B696628652E6861734368616E67656428313033297C7C652E6861734368616E676564283735297C7C652E6861734368616E67656428343029297B636F6E737420653D746869732E5F63';
wwv_flow_imp.g_varchar2_table(15514) := '6F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C743D652E67657428313033292C6E3D652E676574283735292C693D652E676574283430292C6F3D652E67657428313036292C733D7B766572746963616C3A742E76657274696361';
wwv_flow_imp.g_varchar2_table(15515) := '6C2C686F72697A6F6E74616C3A742E686F72697A6F6E74616C2C766572746963616C5363726F6C6C62617253697A653A742E766572746963616C5363726F6C6C62617253697A652C686F72697A6F6E74616C5363726F6C6C62617253697A653A742E686F';
wwv_flow_imp.g_varchar2_table(15516) := '72697A6F6E74616C5363726F6C6C62617253697A652C7363726F6C6C4279506167653A742E7363726F6C6C4279506167652C68616E646C654D6F757365576865656C3A742E68616E646C654D6F757365576865656C2C6D6F757365576865656C5363726F';
wwv_flow_imp.g_varchar2_table(15517) := '6C6C53656E73697469766974793A6E2C666173745363726F6C6C53656E73697469766974793A692C7363726F6C6C507265646F6D696E616E74417869733A6F7D3B746869732E7363726F6C6C6261722E7570646174654F7074696F6E732873297D726574';
wwv_flow_imp.g_varchar2_table(15518) := '75726E20652E6861734368616E67656428313435292626746869732E5F7365744C61796F757428292C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E21307D6F6E5468656D654368616E6765642865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(15519) := '732E7363726F6C6C6261722E757064617465436C6173734E616D652822656469746F722D7363726F6C6C61626C6520222B526228746869732E5F636F6E746578742E7468656D652E7479706529292C21307D7072657061726552656E6465722865297B7D';
wwv_flow_imp.g_varchar2_table(15520) := '72656E6465722865297B746869732E7363726F6C6C6261722E72656E6465724E6F7728297D7D7661722071503D6E2838303831292C24503D7B7D3B24502E7374796C655461675472616E73666F726D3D6A7228292C24502E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(15521) := '733D567228292C24502E696E736572743D467228292E62696E64286E756C6C2C226865616422292C24502E646F6D4150493D4F7228292C24502E696E736572745374796C65456C656D656E743D487228292C4E7228292871502E412C2450292C71502E41';
wwv_flow_imp.g_varchar2_table(15522) := '262671502E412E6C6F63616C73262671502E412E6C6F63616C733B636C6173732055507B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(15523) := '3D742C746869732E636C6173734E616D653D6E2C746869732E746F6F6C7469703D692C746869732E5F6465636F726174696F6E546F52656E6465724272616E643D766F696420302C746869732E7A496E6465783D6E756C6C213D6F3F6F3A307D7D636C61';
wwv_flow_imp.g_varchar2_table(15524) := '7373204B507B636F6E7374727563746F7228652C742C6E297B746869732E636C6173734E616D653D652C746869732E7A496E6465783D742C746869732E746F6F6C7469703D6E7D7D636C6173732047507B636F6E7374727563746F7228297B746869732E';
wwv_flow_imp.g_varchar2_table(15525) := '6465636F726174696F6E733D5B5D7D6164642865297B746869732E6465636F726174696F6E732E707573682865297D6765744465636F726174696F6E7328297B72657475726E20746869732E6465636F726174696F6E737D7D636C617373205150206578';
wwv_flow_imp.g_varchar2_table(15526) := '74656E6473206F507B5F72656E64657228652C742C6E297B636F6E737420693D5B5D3B666F72286C6574206E3D653B6E3C3D743B6E2B2B29695B6E2D655D3D6E65772047503B696628303D3D3D6E2E6C656E6774682972657475726E20693B6E2E736F72';
wwv_flow_imp.g_varchar2_table(15527) := '74282828652C74293D3E652E636C6173734E616D653D3D3D742E636C6173734E616D653F652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E656E644C696E654E756D6265722D742E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(15528) := '756D6265723A652E73746172744C696E654E756D6265722D742E73746172744C696E654E756D6265723A652E636C6173734E616D653C742E636C6173734E616D653F2D313A3129293B6C6574206F3D6E756C6C2C733D303B666F72286C657420723D302C';
wwv_flow_imp.g_varchar2_table(15529) := '613D6E2E6C656E6774683B723C613B722B2B297B636F6E737420613D6E5B725D2C6C3D612E636C6173734E616D652C633D612E7A496E6465783B6C657420643D4D6174682E6D617828612E73746172744C696E654E756D6265722C65292D653B636F6E73';
wwv_flow_imp.g_varchar2_table(15530) := '7420683D4D6174682E6D696E28612E656E644C696E654E756D6265722C74292D653B6F3D3D3D6C3F28643D4D6174682E6D617828732B312C64292C733D4D6174682E6D617828732C6829293A286F3D6C2C733D68293B666F72286C657420653D643B653C';
wwv_flow_imp.g_varchar2_table(15531) := '3D733B652B2B29695B655D2E616464286E6577204B50286C2C632C612E746F6F6C74697029297D72657475726E20697D7D636C61737320595020657874656E6473204A417B636F6E7374727563746F722865297B73757065722865292C746869732E5F77';
wwv_flow_imp.g_varchar2_table(15532) := '6964676574733D7B7D2C746869732E5F636F6E746578743D653B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B746869732E646F6D4E6F64653D73452864';
wwv_flow_imp.g_varchar2_table(15533) := '6F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F6D4E6F64652E736574436C6173734E616D652822676C7970682D6D617267696E2D7769646765747322292C746869732E646F6D4E6F64652E736574506F7369';
wwv_flow_imp.g_varchar2_table(15534) := '74696F6E28226162736F6C75746522292C746869732E646F6D4E6F64652E736574546F702830292C746869732E5F6C696E654865696768743D742E676574283637292C746869732E5F676C7970684D617267696E3D742E676574283537292C746869732E';
wwv_flow_imp.g_varchar2_table(15535) := '5F676C7970684D617267696E4C6566743D6E2E676C7970684D617267696E4C6566742C746869732E5F676C7970684D617267696E57696474683D6E2E676C7970684D617267696E57696474682C746869732E5F676C7970684D617267696E4465636F7261';
wwv_flow_imp.g_varchar2_table(15536) := '74696F6E4C616E65436F756E743D6E2E676C7970684D617267696E4465636F726174696F6E4C616E65436F756E742C746869732E5F6D616E61676564446F6D4E6F6465733D5B5D2C746869732E5F6465636F726174696F6E476C79706873546F52656E64';
wwv_flow_imp.g_varchar2_table(15537) := '65723D5B5D7D646973706F736528297B746869732E5F6D616E61676564446F6D4E6F6465733D5B5D2C746869732E5F6465636F726174696F6E476C79706873546F52656E6465723D5B5D2C746869732E5F776964676574733D7B7D2C73757065722E6469';
wwv_flow_imp.g_varchar2_table(15538) := '73706F736528297D6765745769646765747328297B72657475726E204F626A6563742E76616C75657328746869732E5F77696467657473297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(15539) := '746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B72657475726E20746869732E5F6C696E654865696768743D742E676574283637292C746869732E5F676C7970684D617267696E3D742E676574283537';
wwv_flow_imp.g_varchar2_table(15540) := '292C746869732E5F676C7970684D617267696E4C6566743D6E2E676C7970684D617267696E4C6566742C746869732E5F676C7970684D617267696E57696474683D6E2E676C7970684D617267696E57696474682C746869732E5F676C7970684D61726769';
wwv_flow_imp.g_varchar2_table(15541) := '6E4465636F726174696F6E4C616E65436F756E743D6E2E676C7970684D617267696E4465636F726174696F6E4C616E65436F756E742C21307D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C757368656428';
wwv_flow_imp.g_varchar2_table(15542) := '65297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F';
wwv_flow_imp.g_varchar2_table(15543) := '6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D6164645769646765742865297B636F6E737420743D734528652E676574446F6D4E6F';
wwv_flow_imp.g_varchar2_table(15544) := '64652829293B746869732E5F776964676574735B652E676574496428295D3D7B7769646765743A652C707265666572656E63653A652E676574506F736974696F6E28292C646F6D4E6F64653A742C72656E646572496E666F3A6E756C6C7D2C742E736574';
wwv_flow_imp.g_varchar2_table(15545) := '506F736974696F6E28226162736F6C75746522292C742E736574446973706C617928226E6F6E6522292C742E73657441747472696275746528227769646765744964222C652E67657449642829292C746869732E646F6D4E6F64652E617070656E644368';
wwv_flow_imp.g_varchar2_table(15546) := '696C642874292C746869732E73657453686F756C6452656E64657228297D736574576964676574506F736974696F6E28652C74297B636F6E7374206E3D746869732E5F776964676574735B652E676574496428295D3B72657475726E21286E2E70726566';
wwv_flow_imp.g_varchar2_table(15547) := '6572656E63652E6C616E653D3D3D742E6C616E6526266E2E707265666572656E63652E7A496E6465783D3D3D742E7A496E646578262672682E657175616C7352616E6765286E2E707265666572656E63652E72616E67652C742E72616E6765297C7C286E';
wwv_flow_imp.g_varchar2_table(15548) := '2E707265666572656E63653D742C746869732E73657453686F756C6452656E64657228292C3029297D72656D6F76655769646765742865297B76617220743B636F6E7374206E3D652E676574496428293B696628746869732E5F776964676574735B6E5D';
wwv_flow_imp.g_varchar2_table(15549) := '297B636F6E737420653D746869732E5F776964676574735B6E5D2E646F6D4E6F64652E646F6D4E6F64653B64656C65746520746869732E5F776964676574735B6E5D2C6E756C6C3D3D3D28743D652E706172656E744E6F6465297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(15550) := '3D747C7C742E72656D6F76654368696C642865292C746869732E73657453686F756C6452656E64657228297D7D5F636F6C6C6563744465636F726174696F6E4261736564476C79706852656E6465725265717565737428652C74297B766172206E2C692C';
wwv_flow_imp.g_varchar2_table(15551) := '6F3B636F6E737420733D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C723D652E76697369626C6552616E67652E656E644C696E654E756D6265722C613D652E6765744465636F726174696F6E73496E56696577706F7274';
wwv_flow_imp.g_varchar2_table(15552) := '28293B666F7228636F6E73742065206F662061297B636F6E737420613D652E6F7074696F6E732E676C7970684D617267696E436C6173734E616D653B696628216129636F6E74696E75653B636F6E7374206C3D4D6174682E6D617828652E72616E67652E';
wwv_flow_imp.g_varchar2_table(15553) := '73746172744C696E654E756D6265722C73292C633D4D6174682E6D696E28652E72616E67652E656E644C696E654E756D6265722C72292C643D6E756C6C213D3D28693D6E756C6C3D3D3D286E3D652E6F7074696F6E732E676C7970684D617267696E297C';
wwv_flow_imp.g_varchar2_table(15554) := '7C766F696420303D3D3D6E3F766F696420303A6E2E706F736974696F6E292626766F69642030213D3D693F693A78682E43656E7465722C683D6E756C6C213D3D286F3D652E6F7074696F6E732E7A496E646578292626766F69642030213D3D6F3F6F3A30';
wwv_flow_imp.g_varchar2_table(15555) := '3B666F72286C657420653D6C3B653C3D633B652B2B297B636F6E7374206E3D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64';
wwv_flow_imp.g_varchar2_table(15556) := '656C506F736974696F6E286E6577206D6328652C3029292C693D746869732E5F636F6E746578742E766965774D6F64656C2E676C7970684C616E65732E6765744C616E657341744C696E65286E2E6C696E654E756D626572292E696E6465784F66286429';
wwv_flow_imp.g_varchar2_table(15557) := '3B742E70757368286E6577205A5028652C692C682C6129297D7D7D5F636F6C6C6563745769646765744261736564476C79706852656E6465725265717565737428652C74297B636F6E7374206E3D652E76697369626C6552616E67652E73746172744C69';
wwv_flow_imp.g_varchar2_table(15558) := '6E654E756D6265722C693D652E76697369626C6552616E67652E656E644C696E654E756D6265723B666F7228636F6E73742065206F66204F626A6563742E76616C75657328746869732E5F7769646765747329297B636F6E7374206F3D652E7072656665';
wwv_flow_imp.g_varchar2_table(15559) := '72656E63652E72616E67652C7B73746172744C696E654E756D6265723A732C656E644C696E654E756D6265723A727D3D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E76657274';
wwv_flow_imp.g_varchar2_table(15560) := '4D6F64656C52616E6765546F5669657752616E67652872682E6C696674286F29293B69662821737C7C21727C7C723C6E7C7C733E6929636F6E74696E75653B636F6E737420613D4D6174682E6D617828732C6E292C6C3D746869732E5F636F6E74657874';
wwv_flow_imp.g_varchar2_table(15561) := '2E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E6577206D6328612C3029292C633D746869732E5F636F6E746578742E76696577';
wwv_flow_imp.g_varchar2_table(15562) := '4D6F64656C2E676C7970684C616E65732E6765744C616E657341744C696E65286C2E6C696E654E756D626572292E696E6465784F6628652E707265666572656E63652E6C616E65293B742E70757368286E657720585028612C632C652E70726566657265';
wwv_flow_imp.g_varchar2_table(15563) := '6E63652E7A496E6465782C6529297D7D5F636F6C6C656374536F72746564476C79706852656E64657252657175657374732865297B636F6E737420743D5B5D3B72657475726E20746869732E5F636F6C6C6563744465636F726174696F6E426173656447';
wwv_flow_imp.g_varchar2_table(15564) := '6C79706852656E6465725265717565737428652C74292C746869732E5F636F6C6C6563745769646765744261736564476C79706852656E6465725265717565737428652C74292C742E736F7274282828652C74293D3E652E6C696E654E756D6265723D3D';
wwv_flow_imp.g_varchar2_table(15565) := '3D742E6C696E654E756D6265723F652E6C616E65496E6465783D3D3D742E6C616E65496E6465783F652E7A496E6465783D3D3D742E7A496E6465783F742E747970653D3D3D652E747970653F303D3D3D652E747970652626303D3D3D742E747970653F65';
wwv_flow_imp.g_varchar2_table(15566) := '2E636C6173734E616D653C742E636C6173734E616D653F2D313A313A303A742E747970652D652E747970653A742E7A496E6465782D652E7A496E6465783A652E6C616E65496E6465782D742E6C616E65496E6465783A652E6C696E654E756D6265722D74';
wwv_flow_imp.g_varchar2_table(15567) := '2E6C696E654E756D62657229292C747D7072657061726552656E6465722865297B69662821746869732E5F676C7970684D617267696E2972657475726E20766F696428746869732E5F6465636F726174696F6E476C79706873546F52656E6465723D5B5D';
wwv_flow_imp.g_varchar2_table(15568) := '293B666F7228636F6E73742065206F66204F626A6563742E76616C75657328746869732E5F776964676574732929652E72656E646572496E666F3D6E756C6C3B636F6E737420743D6E6577206F7528746869732E5F636F6C6C656374536F72746564476C';
wwv_flow_imp.g_varchar2_table(15569) := '79706852656E6465725265717565737473286529292C6E3D5B5D3B666F72283B742E6C656E6774683E303B297B636F6E737420653D742E7065656B28293B696628216529627265616B3B636F6E737420693D742E74616B655768696C652828743D3E742E';
wwv_flow_imp.g_varchar2_table(15570) := '6C696E654E756D6265723D3D3D652E6C696E654E756D6265722626742E6C616E65496E6465783D3D3D652E6C616E65496E64657829293B69662821697C7C303D3D3D692E6C656E67746829627265616B3B636F6E7374206F3D695B305D3B696628303D3D';
wwv_flow_imp.g_varchar2_table(15571) := '3D6F2E74797065297B636F6E737420653D5B5D3B666F7228636F6E73742074206F662069297B696628742E7A496E646578213D3D6F2E7A496E6465787C7C742E74797065213D3D6F2E7479706529627265616B3B30213D3D652E6C656E6774682626655B';
wwv_flow_imp.g_varchar2_table(15572) := '652E6C656E6774682D315D3D3D3D742E636C6173734E616D657C7C652E7075736828742E636C6173734E616D65297D6E2E70757368286F2E61636365707428652E6A6F696E282220222929297D656C7365206F2E7769646765742E72656E646572496E66';
wwv_flow_imp.g_varchar2_table(15573) := '6F3D7B6C696E654E756D6265723A6F2E6C696E654E756D6265722C6C616E65496E6465783A6F2E6C616E65496E6465787D7D746869732E5F6465636F726174696F6E476C79706873546F52656E6465723D6E7D72656E6465722865297B69662821746869';
wwv_flow_imp.g_varchar2_table(15574) := '732E5F676C7970684D617267696E297B666F7228636F6E73742065206F66204F626A6563742E76616C75657328746869732E5F776964676574732929652E646F6D4E6F64652E736574446973706C617928226E6F6E6522293B666F72283B746869732E5F';
wwv_flow_imp.g_varchar2_table(15575) := '6D616E61676564446F6D4E6F6465732E6C656E6774683E303B297B636F6E737420653D746869732E5F6D616E61676564446F6D4E6F6465732E706F7028293B6E756C6C3D3D657C7C652E646F6D4E6F64652E72656D6F766528297D72657475726E7D636F';
wwv_flow_imp.g_varchar2_table(15576) := '6E737420743D4D6174682E726F756E6428746869732E5F676C7970684D617267696E57696474682F746869732E5F676C7970684D617267696E4465636F726174696F6E4C616E65436F756E74293B666F7228636F6E7374206E206F66204F626A6563742E';
wwv_flow_imp.g_varchar2_table(15577) := '76616C75657328746869732E5F7769646765747329296966286E2E72656E646572496E666F297B636F6E737420693D652E76696577706F7274446174612E72656C6174697665566572746963616C4F66667365745B6E2E72656E646572496E666F2E6C69';
wwv_flow_imp.g_varchar2_table(15578) := '6E654E756D6265722D652E76696577706F7274446174612E73746172744C696E654E756D6265725D2C6F3D746869732E5F676C7970684D617267696E4C6566742B6E2E72656E646572496E666F2E6C616E65496E6465782A746869732E5F6C696E654865';
wwv_flow_imp.g_varchar2_table(15579) := '696768743B6E2E646F6D4E6F64652E736574446973706C61792822626C6F636B22292C6E2E646F6D4E6F64652E736574546F702869292C6E2E646F6D4E6F64652E7365744C656674286F292C6E2E646F6D4E6F64652E73657457696474682874292C6E2E';
wwv_flow_imp.g_varchar2_table(15580) := '646F6D4E6F64652E73657448656967687428746869732E5F6C696E65486569676874297D656C7365206E2E646F6D4E6F64652E736574446973706C617928226E6F6E6522293B666F72286C6574206E3D303B6E3C746869732E5F6465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(15581) := '476C79706873546F52656E6465722E6C656E6774683B6E2B2B297B636F6E737420693D746869732E5F6465636F726174696F6E476C79706873546F52656E6465725B6E5D2C6F3D652E76696577706F7274446174612E72656C6174697665566572746963';
wwv_flow_imp.g_varchar2_table(15582) := '616C4F66667365745B692E6C696E654E756D6265722D652E76696577706F7274446174612E73746172744C696E654E756D6265725D2C733D746869732E5F676C7970684D617267696E4C6566742B692E6C616E65496E6465782A746869732E5F6C696E65';
wwv_flow_imp.g_varchar2_table(15583) := '4865696768743B6C657420723B6E3C746869732E5F6D616E61676564446F6D4E6F6465732E6C656E6774683F723D746869732E5F6D616E61676564446F6D4E6F6465735B6E5D3A28723D734528646F63756D656E742E637265617465456C656D656E7428';
wwv_flow_imp.g_varchar2_table(15584) := '226469762229292C746869732E5F6D616E61676564446F6D4E6F6465732E707573682872292C746869732E646F6D4E6F64652E617070656E644368696C64287229292C722E736574436C6173734E616D65282263676D7220636F6469636F6E20222B692E';
wwv_flow_imp.g_varchar2_table(15585) := '636F6D62696E6564436C6173734E616D65292C722E736574506F736974696F6E28226162736F6C75746522292C722E736574546F70286F292C722E7365744C6566742873292C722E73657457696474682874292C722E7365744865696768742874686973';
wwv_flow_imp.g_varchar2_table(15586) := '2E5F6C696E65486569676874297D666F72283B746869732E5F6D616E61676564446F6D4E6F6465732E6C656E6774683E746869732E5F6465636F726174696F6E476C79706873546F52656E6465722E6C656E6774683B297B636F6E737420653D74686973';
wwv_flow_imp.g_varchar2_table(15587) := '2E5F6D616E61676564446F6D4E6F6465732E706F7028293B6E756C6C3D3D657C7C652E646F6D4E6F64652E72656D6F766528297D7D7D636C617373205A507B636F6E7374727563746F7228652C742C6E2C69297B746869732E6C696E654E756D6265723D';
wwv_flow_imp.g_varchar2_table(15588) := '652C746869732E6C616E65496E6465783D742C746869732E7A496E6465783D6E2C746869732E636C6173734E616D653D692C746869732E747970653D307D6163636570742865297B72657475726E206E6577204A5028746869732E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(15589) := '722C746869732E6C616E65496E6465782C65297D7D636C6173732058507B636F6E7374727563746F7228652C742C6E2C69297B746869732E6C696E654E756D6265723D652C746869732E6C616E65496E6465783D742C746869732E7A496E6465783D6E2C';
wwv_flow_imp.g_varchar2_table(15590) := '746869732E7769646765743D692C746869732E747970653D317D7D636C617373204A507B636F6E7374727563746F7228652C742C6E297B746869732E6C696E654E756D6265723D652C746869732E6C616E65496E6465783D742C746869732E636F6D6269';
wwv_flow_imp.g_varchar2_table(15591) := '6E6564436C6173734E616D653D6E7D7D76617220654F3D6E2833373737292C744F3D7B7D3B744F2E7374796C655461675472616E73666F726D3D6A7228292C744F2E736574417474726962757465733D567228292C744F2E696E736572743D467228292E';
wwv_flow_imp.g_varchar2_table(15592) := '62696E64286E756C6C2C226865616422292C744F2E646F6D4150493D4F7228292C744F2E696E736572745374796C65456C656D656E743D487228292C4E72282928654F2E412C744F292C654F2E412626654F2E412E6C6F63616C732626654F2E412E6C6F';
wwv_flow_imp.g_varchar2_table(15593) := '63616C733B636C617373206E4F20657874656E6473206F507B636F6E7374727563746F722865297B737570657228292C746869732E5F636F6E746578743D652C746869732E5F7072696D617279506F736974696F6E3D6E756C6C3B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(15594) := '6869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313436292C693D742E676574283530293B746869732E5F737061636557696474683D692E737061636557696474682C746869732E5F6D617849';
wwv_flow_imp.g_varchar2_table(15595) := '6E64656E744C6566743D2D313D3D3D6E2E7772617070696E67436F6C756D6E3F2D313A6E2E7772617070696E67436F6C756D6E2A692E7479706963616C48616C66776964746843686172616374657257696474682C746869732E5F627261636B65745061';
wwv_flow_imp.g_varchar2_table(15596) := '697247756964654F7074696F6E733D742E676574283136292C746869732E5F72656E646572526573756C743D6E756C6C2C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E';
wwv_flow_imp.g_varchar2_table(15597) := '5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E5F72656E646572526573756C743D6E756C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B';
wwv_flow_imp.g_varchar2_table(15598) := '636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313436292C693D742E676574283530293B72657475726E20746869732E5F737061636557696474683D692E7370616365';
wwv_flow_imp.g_varchar2_table(15599) := '57696474682C746869732E5F6D6178496E64656E744C6566743D2D313D3D3D6E2E7772617070696E67436F6C756D6E3F2D313A6E2E7772617070696E67436F6C756D6E2A692E7479706963616C48616C6677696474684368617261637465725769647468';
wwv_flow_imp.g_varchar2_table(15600) := '2C746869732E5F627261636B65745061697247756964654F7074696F6E733D742E676574283136292C21307D6F6E437572736F7253746174654368616E6765642865297B76617220743B636F6E7374206E3D652E73656C656374696F6E735B305D2E6765';
wwv_flow_imp.g_varchar2_table(15601) := '74506F736974696F6E28293B72657475726E21286E756C6C3D3D3D28743D746869732E5F7072696D617279506F736974696F6E297C7C766F696420303D3D3D743F766F696420303A742E657175616C73286E2929262628746869732E5F7072696D617279';
wwv_flow_imp.g_varchar2_table(15602) := '506F736974696F6E3D6E2C2130297D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C';
wwv_flow_imp.g_varchar2_table(15603) := '696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D6F6E5A';
wwv_flow_imp.g_varchar2_table(15604) := '6F6E65734368616E6765642865297B72657475726E21307D6F6E4C616E6775616765436F6E66696775726174696F6E4368616E6765642865297B72657475726E21307D7072657061726552656E6465722865297B76617220742C6E2C692C6F3B69662821';
wwv_flow_imp.g_varchar2_table(15605) := '746869732E5F627261636B65745061697247756964654F7074696F6E732E696E64656E746174696F6E262621313D3D3D746869732E5F627261636B65745061697247756964654F7074696F6E732E627261636B657450616972732972657475726E20766F';
wwv_flow_imp.g_varchar2_table(15606) := '696428746869732E5F72656E646572526573756C743D6E756C6C293B636F6E737420733D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C723D652E76697369626C6552616E67652E656E644C696E654E756D6265722C613D';
wwv_flow_imp.g_varchar2_table(15607) := '652E7363726F6C6C57696474682C6C3D746869732E5F7072696D617279506F736974696F6E2C633D746869732E67657447756964657342794C696E6528732C4D6174682E6D696E28722B312C746869732E5F636F6E746578742E766965774D6F64656C2E';
wwv_flow_imp.g_varchar2_table(15608) := '6765744C696E65436F756E742829292C6C292C643D5B5D3B666F72286C6574206C3D733B6C3C3D723B6C2B2B297B636F6E737420723D6C2D732C683D635B725D3B6C657420753D22223B636F6E737420703D6E756C6C213D3D286E3D6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(15609) := '743D652E76697369626C6552616E6765466F72506F736974696F6E286E6577206D63286C2C312929297C7C766F696420303D3D3D743F766F696420303A742E6C656674292626766F69642030213D3D6E3F6E3A303B666F7228636F6E73742074206F6620';
wwv_flow_imp.g_varchar2_table(15610) := '68297B636F6E7374206E3D2D313D3D3D742E636F6C756D6E3F702B28742E76697369626C65436F6C756D6E2D31292A746869732E5F737061636557696474683A652E76697369626C6552616E6765466F72506F736974696F6E286E6577206D63286C2C74';
wwv_flow_imp.g_varchar2_table(15611) := '2E636F6C756D6E29292E6C6566743B6966286E3E617C7C746869732E5F6D6178496E64656E744C6566743E3026266E3E746869732E5F6D6178496E64656E744C65667429627265616B3B636F6E737420733D742E686F72697A6F6E74616C4C696E653F74';
wwv_flow_imp.g_varchar2_table(15612) := '2E686F72697A6F6E74616C4C696E652E746F703F22686F72697A6F6E74616C2D746F70223A22686F72697A6F6E74616C2D626F74746F6D223A22766572746963616C222C723D742E686F72697A6F6E74616C4C696E653F286E756C6C213D3D286F3D6E75';
wwv_flow_imp.g_varchar2_table(15613) := '6C6C3D3D3D28693D652E76697369626C6552616E6765466F72506F736974696F6E286E6577206D63286C2C742E686F72697A6F6E74616C4C696E652E656E64436F6C756D6E2929297C7C766F696420303D3D3D693F766F696420303A692E6C6566742926';
wwv_flow_imp.g_varchar2_table(15614) := '26766F69642030213D3D6F3F6F3A6E2B746869732E5F73706163655769647468292D6E3A746869732E5F737061636557696474683B752B3D603C64697620636C6173733D22636F72652D677569646520247B742E636C6173734E616D657D20247B737D22';
wwv_flow_imp.g_varchar2_table(15615) := '207374796C653D226C6566743A247B6E7D70783B77696474683A247B727D7078223E3C2F6469763E607D645B725D3D757D746869732E5F72656E646572526573756C743D647D67657447756964657342794C696E6528652C742C6E297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(15616) := '3D2131213D3D746869732E5F627261636B65745061697247756964654F7074696F6E732E627261636B657450616972733F746869732E5F636F6E746578742E766965774D6F64656C2E676574427261636B6574477569646573496E52616E676542794C69';
wwv_flow_imp.g_varchar2_table(15617) := '6E6528652C742C6E2C7B686967686C696768744163746976653A746869732E5F627261636B65745061697247756964654F7074696F6E732E686967686C69676874416374697665427261636B6574506169722C686F72697A6F6E74616C4775696465733A';
wwv_flow_imp.g_varchar2_table(15618) := '21303D3D3D746869732E5F627261636B65745061697247756964654F7074696F6E732E627261636B65745061697273486F72697A6F6E74616C3F65792E456E61626C65643A22616374697665223D3D3D746869732E5F627261636B657450616972477569';
wwv_flow_imp.g_varchar2_table(15619) := '64654F7074696F6E732E627261636B65745061697273486F72697A6F6E74616C3F65792E456E61626C6564466F724163746976653A65792E44697361626C65642C696E636C756465496E6163746976653A21303D3D3D746869732E5F627261636B657450';
wwv_flow_imp.g_varchar2_table(15620) := '61697247756964654F7074696F6E732E627261636B657450616972737D293A6E756C6C2C6F3D746869732E5F627261636B65745061697247756964654F7074696F6E732E696E64656E746174696F6E3F746869732E5F636F6E746578742E766965774D6F';
wwv_flow_imp.g_varchar2_table(15621) := '64656C2E6765744C696E6573496E64656E7447756964657328652C74293A6E756C6C3B6C657420733D302C723D302C613D303B6966282131213D3D746869732E5F627261636B65745061697247756964654F7074696F6E732E686967686C696768744163';
wwv_flow_imp.g_varchar2_table(15622) := '74697665496E64656E746174696F6E26266E297B636F6E737420693D746869732E5F636F6E746578742E766965774D6F64656C2E676574416374697665496E64656E744775696465286E2E6C696E654E756D6265722C652C74293B733D692E7374617274';
wwv_flow_imp.g_varchar2_table(15623) := '4C696E654E756D6265722C723D692E656E644C696E654E756D6265722C613D692E696E64656E747D636F6E73747B696E64656E7453697A653A6C7D3D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744F7074696F6E73';
wwv_flow_imp.g_varchar2_table(15624) := '28292C633D5B5D3B666F72286C6574206E3D653B6E3C3D743B6E2B2B297B636F6E737420743D6E65772041727261793B632E707573682874293B636F6E737420643D693F695B6E2D655D3A5B5D2C683D6E6577206F752864292C753D6F3F6F5B6E2D655D';
wwv_flow_imp.g_varchar2_table(15625) := '3A303B666F72286C657420653D313B653C3D753B652B2B297B636F6E737420693D28652D31292A6C2B312C6F3D2822616C77617973223D3D3D746869732E5F627261636B65745061697247756964654F7074696F6E732E686967686C6967687441637469';
wwv_flow_imp.g_varchar2_table(15626) := '7665496E64656E746174696F6E7C7C303D3D3D642E6C656E677468292626733C3D6E26266E3C3D722626653D3D3D613B742E70757368282E2E2E682E74616B655768696C652828653D3E652E76697369626C65436F6C756D6E3C6929297C7C5B5D293B63';
wwv_flow_imp.g_varchar2_table(15627) := '6F6E737420633D682E7065656B28293B632626632E76697369626C65436F6C756D6E3D3D3D69262621632E686F72697A6F6E74616C4C696E657C7C742E70757368286E657720747928692C2D312C22636F72652D67756964652D696E64656E74206C766C';
wwv_flow_imp.g_varchar2_table(15628) := '2D222B28652D31292533302B286F3F2220696E64656E742D616374697665223A2222292C6E756C6C2C2D312C2D3129297D742E70757368282E2E2E682E74616B655768696C652828653D3E213029297C7C5B5D297D72657475726E20637D72656E646572';
wwv_flow_imp.g_varchar2_table(15629) := '28652C74297B69662821746869732E5F72656E646572526573756C742972657475726E22223B636F6E7374206E3D742D653B72657475726E206E3C307C7C6E3E3D746869732E5F72656E646572526573756C742E6C656E6774683F22223A746869732E5F';
wwv_flow_imp.g_varchar2_table(15630) := '72656E646572526573756C745B6E5D7D7D66756E6374696F6E20694F2865297B69662821657C7C21652E69735472616E73706172656E7428292972657475726E20657D5662282828652C74293D3E7B636F6E7374206E3D5B7B627261636B6574436F6C6F';
wwv_flow_imp.g_varchar2_table(15631) := '723A775F2C6775696465436F6C6F723A445F2C6775696465436F6C6F724163746976653A505F7D2C7B627261636B6574436F6C6F723A435F2C6775696465436F6C6F723A545F2C6775696465436F6C6F724163746976653A4F5F7D2C7B627261636B6574';
wwv_flow_imp.g_varchar2_table(15632) := '436F6C6F723A535F2C6775696465436F6C6F723A495F2C6775696465436F6C6F724163746976653A525F7D2C7B627261636B6574436F6C6F723A785F2C6775696465436F6C6F723A4D5F2C6775696465436F6C6F724163746976653A465F7D2C7B627261';
wwv_flow_imp.g_varchar2_table(15633) := '636B6574436F6C6F723A6B5F2C6775696465436F6C6F723A415F2C6775696465436F6C6F724163746976653A425F7D2C7B627261636B6574436F6C6F723A455F2C6775696465436F6C6F723A4E5F2C6775696465436F6C6F724163746976653A565F7D5D';
wwv_flow_imp.g_varchar2_table(15634) := '2C693D6E6577206F792C6F3D5B7B696E64656E74436F6C6F723A4A622C696E64656E74436F6C6F724163746976653A735F7D2C7B696E64656E74436F6C6F723A655F2C696E64656E74436F6C6F724163746976653A725F7D2C7B696E64656E74436F6C6F';
wwv_flow_imp.g_varchar2_table(15635) := '723A745F2C696E64656E74436F6C6F724163746976653A615F7D2C7B696E64656E74436F6C6F723A6E5F2C696E64656E74436F6C6F724163746976653A6C5F7D2C7B696E64656E74436F6C6F723A695F2C696E64656E74436F6C6F724163746976653A63';
wwv_flow_imp.g_varchar2_table(15636) := '5F7D2C7B696E64656E74436F6C6F723A6F5F2C696E64656E74436F6C6F724163746976653A645F7D5D2C733D6E2E6D61702828743D3E7B766172206E2C693B636F6E7374206F3D652E676574436F6C6F7228742E627261636B6574436F6C6F72292C733D';
wwv_flow_imp.g_varchar2_table(15637) := '652E676574436F6C6F7228742E6775696465436F6C6F72292C723D652E676574436F6C6F7228742E6775696465436F6C6F72416374697665292C613D694F286E756C6C213D3D286E3D694F287329292626766F69642030213D3D6E3F6E3A6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(15638) := '6F3F766F696420303A6F2E7472616E73706172656E74282E3329292C6C3D694F286E756C6C213D3D28693D694F287229292626766F69642030213D3D693F693A6F293B6966286126266C2972657475726E7B6775696465436F6C6F723A612C6775696465';
wwv_flow_imp.g_varchar2_table(15639) := '436F6C6F724163746976653A6C7D7D29292E66696C74657228626C292C723D6F2E6D61702828743D3E7B636F6E7374206E3D652E676574436F6C6F7228742E696E64656E74436F6C6F72292C693D652E676574436F6C6F7228742E696E64656E74436F6C';
wwv_flow_imp.g_varchar2_table(15640) := '6F72416374697665292C6F3D694F286E292C733D694F2869293B6966286F2626732972657475726E7B696E64656E74436F6C6F723A6F2C696E64656E74436F6C6F724163746976653A737D7D29292E66696C74657228626C293B696628732E6C656E6774';
wwv_flow_imp.g_varchar2_table(15641) := '683E30297B666F72286C657420653D303B653C33303B652B2B297B636F6E7374206E3D735B6525732E6C656E6774685D3B742E61646452756C6528602E6D6F6E61636F2D656469746F72202E247B692E676574496E6C696E65436C6173734E616D654F66';
wwv_flow_imp.g_varchar2_table(15642) := '4C6576656C2865292E7265706C616365282F202F672C222E22297D207B202D2D67756964652D636F6C6F723A20247B6E2E6775696465436F6C6F727D3B202D2D67756964652D636F6C6F722D6163746976653A20247B6E2E6775696465436F6C6F724163';
wwv_flow_imp.g_varchar2_table(15643) := '746976657D3B207D60297D742E61646452756C6528222E6D6F6E61636F2D656469746F72202E766572746963616C207B20626F782D736861646F773A2031707820302030203020766172282D2D67756964652D636F6C6F722920696E7365743B207D2229';
wwv_flow_imp.g_varchar2_table(15644) := '2C742E61646452756C6528222E6D6F6E61636F2D656469746F72202E686F72697A6F6E74616C2D746F70207B20626F726465722D746F703A2031707820736F6C696420766172282D2D67756964652D636F6C6F72293B207D22292C742E61646452756C65';
wwv_flow_imp.g_varchar2_table(15645) := '28222E6D6F6E61636F2D656469746F72202E686F72697A6F6E74616C2D626F74746F6D207B20626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D67756964652D636F6C6F72293B207D22292C742E61646452756C6528602E6D';
wwv_flow_imp.g_varchar2_table(15646) := '6F6E61636F2D656469746F72202E766572746963616C2E247B692E616374697665436C6173734E616D657D207B20626F782D736861646F773A2031707820302030203020766172282D2D67756964652D636F6C6F722D6163746976652920696E7365743B';
wwv_flow_imp.g_varchar2_table(15647) := '207D60292C742E61646452756C6528602E6D6F6E61636F2D656469746F72202E686F72697A6F6E74616C2D746F702E247B692E616374697665436C6173734E616D657D207B20626F726465722D746F703A2031707820736F6C696420766172282D2D6775';
wwv_flow_imp.g_varchar2_table(15648) := '6964652D636F6C6F722D616374697665293B207D60292C742E61646452756C6528602E6D6F6E61636F2D656469746F72202E686F72697A6F6E74616C2D626F74746F6D2E247B692E616374697665436C6173734E616D657D207B20626F726465722D626F';
wwv_flow_imp.g_varchar2_table(15649) := '74746F6D3A2031707820736F6C696420766172282D2D67756964652D636F6C6F722D616374697665293B207D60297D696628722E6C656E6774683E30297B666F72286C657420653D303B653C33303B652B2B297B636F6E7374206E3D725B6525722E6C65';
wwv_flow_imp.g_varchar2_table(15650) := '6E6774685D3B742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6C696E65732D636F6E74656E74202E636F72652D67756964652D696E64656E742E6C766C2D247B657D207B202D2D696E64656E742D636F6C6F723A20247B6E2E696E64';
wwv_flow_imp.g_varchar2_table(15651) := '656E74436F6C6F727D3B202D2D696E64656E742D636F6C6F722D6163746976653A20247B6E2E696E64656E74436F6C6F724163746976657D3B207D60297D742E61646452756C6528222E6D6F6E61636F2D656469746F72202E6C696E65732D636F6E7465';
wwv_flow_imp.g_varchar2_table(15652) := '6E74202E636F72652D67756964652D696E64656E74207B20626F782D736861646F773A2031707820302030203020766172282D2D696E64656E742D636F6C6F722920696E7365743B207D22292C742E61646452756C6528222E6D6F6E61636F2D65646974';
wwv_flow_imp.g_varchar2_table(15653) := '6F72202E6C696E65732D636F6E74656E74202E636F72652D67756964652D696E64656E742E696E64656E742D616374697665207B20626F782D736861646F773A2031707820302030203020766172282D2D696E64656E742D636F6C6F722D616374697665';
wwv_flow_imp.g_varchar2_table(15654) := '2920696E7365743B207D22297D7D29293B766172206F4F3D6E2835383736292C734F3D7B7D3B734F2E7374796C655461675472616E73666F726D3D6A7228292C734F2E736574417474726962757465733D567228292C734F2E696E736572743D46722829';
wwv_flow_imp.g_varchar2_table(15655) := '2E62696E64286E756C6C2C226865616422292C734F2E646F6D4150493D4F7228292C734F2E696E736572745374796C65456C656D656E743D487228292C4E722829286F4F2E412C734F292C6F4F2E4126266F4F2E412E6C6F63616C7326266F4F2E412E6C';
wwv_flow_imp.g_varchar2_table(15656) := '6F63616C733B636C61737320724F7B67657420646964446F6D4C61796F757428297B72657475726E20746869732E5F646964446F6D4C61796F75747D72656164436C69656E745265637428297B69662821746869732E5F636C69656E7452656374526561';
wwv_flow_imp.g_varchar2_table(15657) := '64297B746869732E5F636C69656E7452656374526561643D21303B636F6E737420653D746869732E5F646F6D4E6F64652E676574426F756E64696E67436C69656E745265637428293B746869732E6D61726B446964446F6D4C61796F757428292C746869';
wwv_flow_imp.g_varchar2_table(15658) := '732E5F636C69656E745265637444656C74614C6566743D652E6C6566742C746869732E5F636C69656E74526563745363616C653D652E77696474682F746869732E5F646F6D4E6F64652E6F666673657457696474687D7D67657420636C69656E74526563';
wwv_flow_imp.g_varchar2_table(15659) := '7444656C74614C65667428297B72657475726E20746869732E5F636C69656E7452656374526561647C7C746869732E72656164436C69656E745265637428292C746869732E5F636C69656E745265637444656C74614C6566747D67657420636C69656E74';
wwv_flow_imp.g_varchar2_table(15660) := '526563745363616C6528297B72657475726E20746869732E5F636C69656E7452656374526561647C7C746869732E72656164436C69656E745265637428292C746869732E5F636C69656E74526563745363616C657D636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(15661) := '297B746869732E5F646F6D4E6F64653D652C746869732E656E644E6F64653D742C746869732E5F646964446F6D4C61796F75743D21312C746869732E5F636C69656E745265637444656C74614C6566743D302C746869732E5F636C69656E745265637453';
wwv_flow_imp.g_varchar2_table(15662) := '63616C653D312C746869732E5F636C69656E7452656374526561643D21317D6D61726B446964446F6D4C61796F757428297B746869732E5F646964446F6D4C61796F75743D21307D7D636C61737320614F7B636F6E7374727563746F7228297B74686973';
wwv_flow_imp.g_varchar2_table(15663) := '2E5F63757272656E7456697369626C6552616E67653D6E657720726828312C312C312C31297D67657443757272656E7456697369626C6552616E676528297B72657475726E20746869732E5F63757272656E7456697369626C6552616E67657D73657443';
wwv_flow_imp.g_varchar2_table(15664) := '757272656E7456697369626C6552616E67652865297B746869732E5F63757272656E7456697369626C6552616E67653D657D7D636C617373206C4F7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E6D696E696D616C52';
wwv_flow_imp.g_varchar2_table(15665) := '657665616C3D652C746869732E6C696E654E756D6265723D742C746869732E7374617274436F6C756D6E3D6E2C746869732E656E64436F6C756D6E3D692C746869732E73746172745363726F6C6C546F703D6F2C746869732E73746F705363726F6C6C54';
wwv_flow_imp.g_varchar2_table(15666) := '6F703D732C746869732E7363726F6C6C547970653D722C746869732E747970653D2272616E6765222C746869732E6D696E4C696E654E756D6265723D742C746869732E6D61784C696E654E756D6265723D747D7D636C61737320634F7B636F6E73747275';
wwv_flow_imp.g_varchar2_table(15667) := '63746F7228652C742C6E2C692C6F297B746869732E6D696E696D616C52657665616C3D652C746869732E73656C656374696F6E733D742C746869732E73746172745363726F6C6C546F703D6E2C746869732E73746F705363726F6C6C546F703D692C7468';
wwv_flow_imp.g_varchar2_table(15668) := '69732E7363726F6C6C547970653D6F2C746869732E747970653D2273656C656374696F6E73223B6C657420733D745B305D2E73746172744C696E654E756D6265722C723D745B305D2E656E644C696E654E756D6265723B666F72286C657420653D312C6E';
wwv_flow_imp.g_varchar2_table(15669) := '3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D3B733D4D6174682E6D696E28732C6E2E73746172744C696E654E756D626572292C723D4D6174682E6D617828722C6E2E656E644C696E654E756D626572297D746869732E6D';
wwv_flow_imp.g_varchar2_table(15670) := '696E4C696E654E756D6265723D732C746869732E6D61784C696E654E756D6265723D727D7D636C61737320644F20657874656E6473204A417B636F6E7374727563746F7228652C74297B73757065722865292C746869732E5F6C696E6573436F6E74656E';
wwv_flow_imp.g_varchar2_table(15671) := '743D742C746869732E5F7465787452616E676552657374696E6753706F743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F76697369626C654C696E65733D6E6577205F502874686973292C746869732E646F';
wwv_flow_imp.g_varchar2_table(15672) := '6D4E6F64653D746869732E5F76697369626C654C696E65732E646F6D4E6F64653B636F6E7374206E3D746869732E5F636F6E746578742E636F6E66696775726174696F6E2C693D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F';
wwv_flow_imp.g_varchar2_table(15673) := '7074696F6E732C6F3D692E676574283530292C733D692E67657428313436293B746869732E5F6C696E654865696768743D692E676574283637292C746869732E5F7479706963616C48616C66776964746843686172616374657257696474683D6F2E7479';
wwv_flow_imp.g_varchar2_table(15674) := '706963616C48616C66776964746843686172616374657257696474682C746869732E5F697356696577706F72745772617070696E673D732E697356696577706F72745772617070696E672C746869732E5F72657665616C486F72697A6F6E74616C526967';
wwv_flow_imp.g_varchar2_table(15675) := '687450616464696E673D692E67657428313030292C746869732E5F637572736F72537572726F756E64696E674C696E65733D692E676574283239292C746869732E5F637572736F72537572726F756E64696E674C696E65735374796C653D692E67657428';
wwv_flow_imp.g_varchar2_table(15676) := '3330292C746869732E5F63616E5573654C6179657248696E74696E673D21692E676574283332292C746869732E5F766965774C696E654F7074696F6E733D6E657720454E286E2C746869732E5F636F6E746578742E7468656D652E74797065292C654E2E';
wwv_flow_imp.g_varchar2_table(15677) := '777269746528746869732E646F6D4E6F64652C38292C746869732E646F6D4E6F64652E736574436C6173734E616D652860766965772D6C696E657320247B68507D60292C724528746869732E646F6D4E6F64652C6F292C746869732E5F6D61784C696E65';
wwv_flow_imp.g_varchar2_table(15678) := '57696474683D302C746869732E5F6173796E635570646174654C696E655769647468733D6E6577204B74282828293D3E7B746869732E5F7570646174654C696E65576964746873536C6F7728297D292C323030292C746869732E5F6173796E6343686563';
wwv_flow_imp.g_varchar2_table(15679) := '6B4D6F6E6F7370616365466F6E74417373756D7074696F6E733D6E6577204B74282828293D3E7B746869732E5F636865636B4D6F6E6F7370616365466F6E74417373756D7074696F6E7328297D292C326533292C746869732E5F6C61737452656E646572';
wwv_flow_imp.g_varchar2_table(15680) := '6564446174613D6E657720614F2C746869732E5F686F72697A6F6E74616C52657665616C526571756573743D6E756C6C2C746869732E5F737469636B795363726F6C6C456E61626C65643D692E67657428313135292E656E61626C65642C746869732E5F';
wwv_flow_imp.g_varchar2_table(15681) := '6D61784E756D626572537469636B794C696E65733D692E67657428313135292E6D61784C696E65436F756E747D646973706F736528297B746869732E5F6173796E635570646174654C696E655769647468732E646973706F736528292C746869732E5F61';
wwv_flow_imp.g_varchar2_table(15682) := '73796E63436865636B4D6F6E6F7370616365466F6E74417373756D7074696F6E732E646973706F736528292C73757065722E646973706F736528297D676574446F6D4E6F646528297B72657475726E20746869732E646F6D4E6F64657D63726561746556';
wwv_flow_imp.g_varchar2_table(15683) := '697369626C654C696E6528297B72657475726E206E6577204C4E28746869732E5F766965774C696E654F7074696F6E73297D6F6E436F6E66696775726174696F6E4368616E6765642865297B746869732E5F76697369626C654C696E65732E6F6E436F6E';
wwv_flow_imp.g_varchar2_table(15684) := '66696775726174696F6E4368616E6765642865292C652E6861734368616E6765642831343629262628746869732E5F6D61784C696E6557696474683D30293B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F';
wwv_flow_imp.g_varchar2_table(15685) := '7074696F6E732C6E3D742E676574283530292C693D742E67657428313436293B72657475726E20746869732E5F6C696E654865696768743D742E676574283637292C746869732E5F7479706963616C48616C667769647468436861726163746572576964';
wwv_flow_imp.g_varchar2_table(15686) := '74683D6E2E7479706963616C48616C66776964746843686172616374657257696474682C746869732E5F697356696577706F72745772617070696E673D692E697356696577706F72745772617070696E672C746869732E5F72657665616C486F72697A6F';
wwv_flow_imp.g_varchar2_table(15687) := '6E74616C526967687450616464696E673D742E67657428313030292C746869732E5F637572736F72537572726F756E64696E674C696E65733D742E676574283239292C746869732E5F637572736F72537572726F756E64696E674C696E65735374796C65';
wwv_flow_imp.g_varchar2_table(15688) := '3D742E676574283330292C746869732E5F63616E5573654C6179657248696E74696E673D21742E676574283332292C746869732E5F737469636B795363726F6C6C456E61626C65643D742E67657428313135292E656E61626C65642C746869732E5F6D61';
wwv_flow_imp.g_varchar2_table(15689) := '784E756D626572537469636B794C696E65733D742E67657428313135292E6D61784C696E65436F756E742C724528746869732E646F6D4E6F64652C6E292C746869732E5F6F6E4F7074696F6E734D617962654368616E67656428292C652E686173436861';
wwv_flow_imp.g_varchar2_table(15690) := '6E6765642831343529262628746869732E5F6D61784C696E6557696474683D30292C21307D5F6F6E4F7074696F6E734D617962654368616E67656428297B636F6E737420653D746869732E5F636F6E746578742E636F6E66696775726174696F6E2C743D';
wwv_flow_imp.g_varchar2_table(15691) := '6E657720454E28652C746869732E5F636F6E746578742E7468656D652E74797065293B69662821746869732E5F766965774C696E654F7074696F6E732E657175616C73287429297B746869732E5F766965774C696E654F7074696F6E733D743B636F6E73';
wwv_flow_imp.g_varchar2_table(15692) := '7420653D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C6E3D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B666F72286C657420743D653B743C3D6E';
wwv_flow_imp.g_varchar2_table(15693) := '3B742B2B29746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652874292E6F6E4F7074696F6E734368616E67656428746869732E5F766965774C696E654F7074696F6E73293B72657475726E21307D72657475726E21317D';
wwv_flow_imp.g_varchar2_table(15694) := '6F6E437572736F7253746174654368616E6765642865297B636F6E737420743D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C6E3D746869732E5F76697369626C654C696E65732E676574456E644C';
wwv_flow_imp.g_varchar2_table(15695) := '696E654E756D62657228293B6C657420693D21313B666F72286C657420653D743B653C3D6E3B652B2B29693D746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652865292E6F6E53656C656374696F6E4368616E67656428';
wwv_flow_imp.g_varchar2_table(15696) := '297C7C693B72657475726E20697D6F6E4465636F726174696F6E734368616E6765642865297B7B636F6E737420653D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C743D746869732E5F7669736962';
wwv_flow_imp.g_varchar2_table(15697) := '6C654C696E65732E676574456E644C696E654E756D62657228293B666F72286C6574206E3D653B6E3C3D743B6E2B2B29746869732E5F76697369626C654C696E65732E67657456697369626C654C696E65286E292E6F6E4465636F726174696F6E734368';
wwv_flow_imp.g_varchar2_table(15698) := '616E67656428297D72657475726E21307D6F6E466C75736865642865297B636F6E737420743D746869732E5F76697369626C654C696E65732E6F6E466C75736865642865293B72657475726E20746869732E5F6D61784C696E6557696474683D302C747D';
wwv_flow_imp.g_varchar2_table(15699) := '6F6E4C696E65734368616E6765642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E4C696E65734368616E6765642865297D6F6E4C696E657344656C657465642865297B72657475726E20746869732E5F76697369626C65';
wwv_flow_imp.g_varchar2_table(15700) := '4C696E65732E6F6E4C696E657344656C657465642865297D6F6E4C696E6573496E7365727465642865297B72657475726E20746869732E5F76697369626C654C696E65732E6F6E4C696E6573496E7365727465642865297D6F6E52657665616C52616E67';
wwv_flow_imp.g_varchar2_table(15701) := '65526571756573742865297B636F6E737420743D746869732E5F636F6D707574655363726F6C6C546F70546F52657665616C52616E676528746869732E5F636F6E746578742E766965774C61796F75742E67657446757475726556696577706F72742829';
wwv_flow_imp.g_varchar2_table(15702) := '2C652E736F757263652C652E6D696E696D616C52657665616C2C652E72616E67652C652E73656C656374696F6E732C652E766572746963616C54797065293B6966282D313D3D3D742972657475726E21313B6C6574206E3D746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(15703) := '742E766965774C61796F75742E76616C69646174655363726F6C6C506F736974696F6E287B7363726F6C6C546F703A747D293B652E72657665616C486F72697A6F6E74616C3F652E72616E67652626652E72616E67652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(15704) := '6572213D3D652E72616E67652E656E644C696E654E756D6265723F6E3D7B7363726F6C6C546F703A6E2E7363726F6C6C546F702C7363726F6C6C4C6566743A307D3A652E72616E67653F746869732E5F686F72697A6F6E74616C52657665616C52657175';
wwv_flow_imp.g_varchar2_table(15705) := '6573743D6E6577206C4F28652E6D696E696D616C52657665616C2C652E72616E67652E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E2C652E72616E67652E656E64436F6C756D6E2C746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(15706) := '78742E766965774C61796F75742E67657443757272656E745363726F6C6C546F7028292C6E2E7363726F6C6C546F702C652E7363726F6C6C54797065293A652E73656C656374696F6E732626652E73656C656374696F6E732E6C656E6774683E30262628';
wwv_flow_imp.g_varchar2_table(15707) := '746869732E5F686F72697A6F6E74616C52657665616C526571756573743D6E657720634F28652E6D696E696D616C52657665616C2C652E73656C656374696F6E732C746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E';
wwv_flow_imp.g_varchar2_table(15708) := '745363726F6C6C546F7028292C6E2E7363726F6C6C546F702C652E7363726F6C6C5479706529293A746869732E5F686F72697A6F6E74616C52657665616C526571756573743D6E756C6C3B636F6E737420693D4D6174682E61627328746869732E5F636F';
wwv_flow_imp.g_varchar2_table(15709) := '6E746578742E766965774C61796F75742E67657443757272656E745363726F6C6C546F7028292D6E2E7363726F6C6C546F70293C3D746869732E5F6C696E654865696768743F313A652E7363726F6C6C547970653B72657475726E20746869732E5F636F';
wwv_flow_imp.g_varchar2_table(15710) := '6E746578742E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E286E2C69292C21307D6F6E5363726F6C6C4368616E6765642865297B696628746869732E5F686F72697A6F6E74616C52657665616C526571';
wwv_flow_imp.g_varchar2_table(15711) := '756573742626652E7363726F6C6C4C6566744368616E676564262628746869732E5F686F72697A6F6E74616C52657665616C526571756573743D6E756C6C292C746869732E5F686F72697A6F6E74616C52657665616C526571756573742626652E736372';
wwv_flow_imp.g_varchar2_table(15712) := '6F6C6C546F704368616E676564297B636F6E737420743D4D6174682E6D696E28746869732E5F686F72697A6F6E74616C52657665616C526571756573742E73746172745363726F6C6C546F702C746869732E5F686F72697A6F6E74616C52657665616C52';
wwv_flow_imp.g_varchar2_table(15713) := '6571756573742E73746F705363726F6C6C546F70292C6E3D4D6174682E6D617828746869732E5F686F72697A6F6E74616C52657665616C526571756573742E73746172745363726F6C6C546F702C746869732E5F686F72697A6F6E74616C52657665616C';
wwv_flow_imp.g_varchar2_table(15714) := '526571756573742E73746F705363726F6C6C546F70293B28652E7363726F6C6C546F703C747C7C652E7363726F6C6C546F703E6E29262628746869732E5F686F72697A6F6E74616C52657665616C526571756573743D6E756C6C297D72657475726E2074';
wwv_flow_imp.g_varchar2_table(15715) := '6869732E646F6D4E6F64652E736574576964746828652E7363726F6C6C5769647468292C746869732E5F76697369626C654C696E65732E6F6E5363726F6C6C4368616E6765642865297C7C21307D6F6E546F6B656E734368616E6765642865297B726574';
wwv_flow_imp.g_varchar2_table(15716) := '75726E20746869732E5F76697369626C654C696E65732E6F6E546F6B656E734368616E6765642865297D6F6E5A6F6E65734368616E6765642865297B72657475726E20746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75';
wwv_flow_imp.g_varchar2_table(15717) := '742E7365744D61784C696E65576964746828746869732E5F6D61784C696E655769647468292C746869732E5F76697369626C654C696E65732E6F6E5A6F6E65734368616E6765642865297D6F6E5468656D654368616E6765642865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(15718) := '746869732E5F6F6E4F7074696F6E734D617962654368616E67656428297D676574506F736974696F6E46726F6D444F4D496E666F28652C74297B636F6E7374206E3D746869732E5F676574566965774C696E65446F6D4E6F64652865293B6966286E756C';
wwv_flow_imp.g_varchar2_table(15719) := '6C3D3D3D6E2972657475726E206E756C6C3B636F6E737420693D746869732E5F6765744C696E654E756D626572466F72286E293B6966282D313D3D3D692972657475726E206E756C6C3B696628693C317C7C693E746869732E5F636F6E746578742E7669';
wwv_flow_imp.g_varchar2_table(15720) := '65774D6F64656C2E6765744C696E65436F756E7428292972657475726E206E756C6C3B696628313D3D3D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E2869292972657475726E206E6577206D6328';
wwv_flow_imp.g_varchar2_table(15721) := '692C31293B636F6E7374206F3D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C733D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B696628693C6F7C';
wwv_flow_imp.g_varchar2_table(15722) := '7C693E732972657475726E206E756C6C3B6C657420723D746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652869292E676574436F6C756D6E4F664E6F64654F666673657428652C74293B636F6E737420613D746869732E';
wwv_flow_imp.g_varchar2_table(15723) := '5F636F6E746578742E766965774D6F64656C2E6765744C696E654D696E436F6C756D6E2869293B72657475726E20723C61262628723D61292C6E6577206D6328692C72297D5F676574566965774C696E65446F6D4E6F64652865297B666F72283B652626';
wwv_flow_imp.g_varchar2_table(15724) := '313D3D3D652E6E6F6465547970653B297B696628652E636C6173734E616D653D3D3D4C4E2E434C4153535F4E414D452972657475726E20653B653D652E706172656E74456C656D656E747D72657475726E206E756C6C7D5F6765744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(15725) := '72466F722865297B636F6E737420743D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C6E3D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B666F7228';
wwv_flow_imp.g_varchar2_table(15726) := '6C657420693D743B693C3D6E3B692B2B29696628653D3D3D746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652869292E676574446F6D4E6F646528292972657475726E20693B72657475726E2D317D6765744C696E6557';
wwv_flow_imp.g_varchar2_table(15727) := '696474682865297B636F6E737420743D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C6E3D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B69662865';
wwv_flow_imp.g_varchar2_table(15728) := '3C747C7C653E6E2972657475726E2D313B636F6E737420693D6E657720724F28746869732E646F6D4E6F64652E646F6D4E6F64652C746869732E5F7465787452616E676552657374696E6753706F74292C6F3D746869732E5F76697369626C654C696E65';
wwv_flow_imp.g_varchar2_table(15729) := '732E67657456697369626C654C696E652865292E67657457696474682869293B72657475726E20746869732E5F7570646174654C696E65576964746873536C6F774966446F6D4469644C61796F75742869292C6F7D6C696E657356697369626C6552616E';
wwv_flow_imp.g_varchar2_table(15730) := '676573466F7252616E676528652C74297B696628746869732E73686F756C6452656E64657228292972657475726E206E756C6C3B636F6E7374206E3D652E656E644C696E654E756D6265722C693D72682E696E7465727365637452616E67657328652C74';
wwv_flow_imp.g_varchar2_table(15731) := '6869732E5F6C61737452656E6465726564446174612E67657443757272656E7456697369626C6552616E67652829293B69662821692972657475726E206E756C6C3B636F6E7374206F3D5B5D3B6C657420733D303B636F6E737420723D6E657720724F28';
wwv_flow_imp.g_varchar2_table(15732) := '746869732E646F6D4E6F64652E646F6D4E6F64652C746869732E5F7465787452616E676552657374696E6753706F74293B6C657420613D303B74262628613D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F';
wwv_flow_imp.g_varchar2_table(15733) := '6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E6577206D6328692E73746172744C696E654E756D6265722C3129292E6C696E654E756D626572293B636F6E7374206C3D746869732E5F7669';
wwv_flow_imp.g_varchar2_table(15734) := '7369626C654C696E65732E67657453746172744C696E654E756D62657228292C633D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B666F72286C657420653D692E73746172744C696E654E756D6265723B';
wwv_flow_imp.g_varchar2_table(15735) := '653C3D692E656E644C696E654E756D6265723B652B2B297B696628653C6C7C7C653E6329636F6E74696E75653B636F6E737420643D653D3D3D692E73746172744C696E654E756D6265723F692E7374617274436F6C756D6E3A312C683D65213D3D692E65';
wwv_flow_imp.g_varchar2_table(15736) := '6E644C696E654E756D6265722C753D683F746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E2865293A692E656E64436F6C756D6E2C703D746869732E5F76697369626C654C696E65732E676574566973';
wwv_flow_imp.g_varchar2_table(15737) := '69626C654C696E652865292E67657456697369626C6552616E676573466F7252616E676528652C642C752C72293B69662870297B696628742626653C6E297B636F6E737420743D613B613D746869732E5F636F6E746578742E766965774D6F64656C2E63';
wwv_flow_imp.g_varchar2_table(15738) := '6F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E6577206D6328652B312C3129292E6C696E654E756D6265722C74213D3D61262628702E72616E6765735B702E';
wwv_flow_imp.g_varchar2_table(15739) := '72616E6765732E6C656E6774682D315D2E77696474682B3D746869732E5F7479706963616C48616C6677696474684368617261637465725769647468297D6F5B732B2B5D3D6E657720694E28702E6F75747369646552656E64657265644C696E652C652C';
wwv_flow_imp.g_varchar2_table(15740) := '6F4E2E66726F6D28702E72616E676573292C68297D7D72657475726E20746869732E5F7570646174654C696E65576964746873536C6F774966446F6D4469644C61796F75742872292C303D3D3D733F6E756C6C3A6F7D5F76697369626C6552616E676573';
wwv_flow_imp.g_varchar2_table(15741) := '466F724C696E6552616E676528652C742C6E297B696628746869732E73686F756C6452656E64657228292972657475726E206E756C6C3B696628653C746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228297C';
wwv_flow_imp.g_varchar2_table(15742) := '7C653E746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228292972657475726E206E756C6C3B636F6E737420693D6E657720724F28746869732E646F6D4E6F64652E646F6D4E6F64652C746869732E5F7465787452';
wwv_flow_imp.g_varchar2_table(15743) := '616E676552657374696E6753706F74292C6F3D746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652865292E67657456697369626C6552616E676573466F7252616E676528652C742C6E2C69293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(15744) := '732E5F7570646174654C696E65576964746873536C6F774966446F6D4469644C61796F75742869292C6F7D76697369626C6552616E6765466F72506F736974696F6E2865297B636F6E737420743D746869732E5F76697369626C6552616E676573466F72';
wwv_flow_imp.g_varchar2_table(15745) := '4C696E6552616E676528652E6C696E654E756D6265722C652E636F6C756D6E2C652E636F6C756D6E293B72657475726E20743F6E657720724E28742E6F75747369646552656E64657265644C696E652C742E72616E6765735B305D2E6C656674293A6E75';
wwv_flow_imp.g_varchar2_table(15746) := '6C6C7D5F7570646174654C696E655769647468734661737428297B72657475726E20746869732E5F7570646174654C696E65576964746873282130297D5F7570646174654C696E65576964746873536C6F7728297B746869732E5F7570646174654C696E';
wwv_flow_imp.g_varchar2_table(15747) := '65576964746873282131297D5F7570646174654C696E65576964746873536C6F774966446F6D4469644C61796F75742865297B652E646964446F6D4C61796F7574262628746869732E5F6173796E635570646174654C696E655769647468732E69735363';
wwv_flow_imp.g_varchar2_table(15748) := '686564756C656428297C7C28746869732E5F6173796E635570646174654C696E655769647468732E63616E63656C28292C746869732E5F7570646174654C696E65576964746873536C6F77282929297D5F7570646174654C696E65576964746873286529';
wwv_flow_imp.g_varchar2_table(15749) := '7B636F6E737420743D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C6E3D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B6C657420693D312C6F3D21';
wwv_flow_imp.g_varchar2_table(15750) := '303B666F72286C657420733D743B733C3D6E3B732B2B297B636F6E737420743D746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652873293B21657C7C742E676574576964746849734661737428293F693D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(15751) := '617828692C742E6765745769647468286E756C6C29293A6F3D21317D72657475726E206F2626313D3D3D7426266E3D3D3D746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E742829262628746869732E5F6D61784C';
wwv_flow_imp.g_varchar2_table(15752) := '696E6557696474683D30292C746869732E5F656E737572654D61784C696E6557696474682869292C6F7D5F636865636B4D6F6E6F7370616365466F6E74417373756D7074696F6E7328297B6C657420653D2D312C743D2D313B636F6E7374206E3D746869';
wwv_flow_imp.g_varchar2_table(15753) := '732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C693D746869732E5F76697369626C654C696E65732E676574456E644C696E654E756D62657228293B666F72286C6574206F3D6E3B6F3C3D693B6F2B2B297B63';
wwv_flow_imp.g_varchar2_table(15754) := '6F6E7374206E3D746869732E5F76697369626C654C696E65732E67657456697369626C654C696E65286F293B6966286E2E6E656564734D6F6E6F7370616365466F6E74436865636B2829297B636F6E737420693D6E2E6765745769647468286E756C6C29';
wwv_flow_imp.g_varchar2_table(15755) := '3B693E74262628743D692C653D6F297D7D6966282D31213D3D65262621746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652865292E6D6F6E6F7370616365417373756D7074696F6E7341726556616C6964282929666F72';
wwv_flow_imp.g_varchar2_table(15756) := '286C657420653D6E3B653C3D693B652B2B29746869732E5F76697369626C654C696E65732E67657456697369626C654C696E652865292E6F6E4D6F6E6F7370616365417373756D7074696F6E73496E76616C69646174656428297D707265706172655265';
wwv_flow_imp.g_varchar2_table(15757) := '6E64657228297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D72656E64657228297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D72656E646572546578742865297B69662874';
wwv_flow_imp.g_varchar2_table(15758) := '6869732E5F76697369626C654C696E65732E72656E6465724C696E65732865292C746869732E5F6C61737452656E6465726564446174612E73657443757272656E7456697369626C6552616E676528652E76697369626C6552616E6765292C746869732E';
wwv_flow_imp.g_varchar2_table(15759) := '646F6D4E6F64652E736574576964746828746869732E5F636F6E746578742E766965774C61796F75742E6765745363726F6C6C57696474682829292C746869732E646F6D4E6F64652E736574486569676874284D6174682E6D696E28746869732E5F636F';
wwv_flow_imp.g_varchar2_table(15760) := '6E746578742E766965774C61796F75742E6765745363726F6C6C48656967687428292C31653629292C746869732E5F686F72697A6F6E74616C52657665616C52657175657374297B636F6E737420743D746869732E5F686F72697A6F6E74616C52657665';
wwv_flow_imp.g_varchar2_table(15761) := '616C526571756573743B696628652E73746172744C696E654E756D6265723C3D742E6D696E4C696E654E756D6265722626742E6D61784C696E654E756D6265723C3D652E656E644C696E654E756D626572297B746869732E5F686F72697A6F6E74616C52';
wwv_flow_imp.g_varchar2_table(15762) := '657665616C526571756573743D6E756C6C2C746869732E6F6E44696452656E64657228293B636F6E737420653D746869732E5F636F6D707574655363726F6C6C4C656674546F52657665616C2874293B65262628746869732E5F697356696577706F7274';
wwv_flow_imp.g_varchar2_table(15763) := '5772617070696E677C7C746869732E5F656E737572654D61784C696E65576964746828652E6D6178486F72697A6F6E74616C4F6666736574292C746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75742E7365745363726F';
wwv_flow_imp.g_varchar2_table(15764) := '6C6C506F736974696F6E287B7363726F6C6C4C6566743A652E7363726F6C6C4C6566747D2C742E7363726F6C6C5479706529297D7D696628746869732E5F7570646174654C696E655769647468734661737428293F746869732E5F6173796E6355706461';
wwv_flow_imp.g_varchar2_table(15765) := '74654C696E655769647468732E63616E63656C28293A746869732E5F6173796E635570646174654C696E655769647468732E7363686564756C6528292C24262621746869732E5F6173796E63436865636B4D6F6E6F7370616365466F6E74417373756D70';
wwv_flow_imp.g_varchar2_table(15766) := '74696F6E732E69735363686564756C65642829297B636F6E737420653D746869732E5F76697369626C654C696E65732E67657453746172744C696E654E756D62657228292C743D746869732E5F76697369626C654C696E65732E676574456E644C696E65';
wwv_flow_imp.g_varchar2_table(15767) := '4E756D62657228293B666F72286C6574206E3D653B6E3C3D743B6E2B2B29696628746869732E5F76697369626C654C696E65732E67657456697369626C654C696E65286E292E6E656564734D6F6E6F7370616365466F6E74436865636B2829297B746869';
wwv_flow_imp.g_varchar2_table(15768) := '732E5F6173796E63436865636B4D6F6E6F7370616365466F6E74417373756D7074696F6E732E7363686564756C6528293B627265616B7D7D746869732E5F6C696E6573436F6E74656E742E7365744C6179657248696E74696E6728746869732E5F63616E';
wwv_flow_imp.g_varchar2_table(15769) := '5573654C6179657248696E74696E67292C746869732E5F6C696E6573436F6E74656E742E736574436F6E7461696E282273747269637422293B636F6E737420743D746869732E5F636F6E746578742E766965774C61796F75742E67657443757272656E74';
wwv_flow_imp.g_varchar2_table(15770) := '5363726F6C6C546F7028292D652E6269674E756D6265727344656C74613B746869732E5F6C696E6573436F6E74656E742E736574546F70282D74292C746869732E5F6C696E6573436F6E74656E742E7365744C656674282D746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(15771) := '742E766965774C61796F75742E67657443757272656E745363726F6C6C4C6566742829297D5F656E737572654D61784C696E6557696474682865297B636F6E737420743D4D6174682E6365696C2865293B746869732E5F6D61784C696E6557696474683C';
wwv_flow_imp.g_varchar2_table(15772) := '74262628746869732E5F6D61784C696E6557696474683D742C746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75742E7365744D61784C696E65576964746828746869732E5F6D61784C696E65576964746829297D5F636F';
wwv_flow_imp.g_varchar2_table(15773) := '6D707574655363726F6C6C546F70546F52657665616C52616E676528652C742C6E2C692C6F2C73297B636F6E737420723D652E746F702C613D652E6865696768742C6C3D722B613B6C657420632C642C683B6966286F26266F2E6C656E6774683E30297B';
wwv_flow_imp.g_varchar2_table(15774) := '6C657420653D6F5B305D2E73746172744C696E654E756D6265722C743D6F5B305D2E656E644C696E654E756D6265723B666F72286C6574206E3D312C693D6F2E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D6F5B6E5D3B653D4D6174682E';
wwv_flow_imp.g_varchar2_table(15775) := '6D696E28652C692E73746172744C696E654E756D626572292C743D4D6174682E6D617828742C692E656E644C696E654E756D626572297D633D21312C643D746869732E5F636F6E746578742E766965774C61796F75742E676574566572746963616C4F66';
wwv_flow_imp.g_varchar2_table(15776) := '66736574466F724C696E654E756D6265722865292C683D746869732E5F636F6E746578742E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D6265722874292B746869732E5F6C696E654865696768747D65';
wwv_flow_imp.g_varchar2_table(15777) := '6C73657B69662821692972657475726E2D313B633D21302C643D746869732E5F636F6E746578742E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228692E73746172744C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(15778) := '2C683D746869732E5F636F6E746578742E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228692E656E644C696E654E756D626572292B746869732E5F6C696E654865696768747D6C657420752C70';
wwv_flow_imp.g_varchar2_table(15779) := '3D302C673D303B696628226D6F75736522213D3D742626216E7C7C2264656661756C7422213D3D746869732E5F637572736F72537572726F756E64696E674C696E65735374796C65297B636F6E737420653D4D6174682E6D696E28612F746869732E5F6C';
wwv_flow_imp.g_varchar2_table(15780) := '696E654865696768742F322C746869732E5F637572736F72537572726F756E64696E674C696E6573293B703D746869732E5F737469636B795363726F6C6C456E61626C65643F4D6174682E6D617828652C746869732E5F6D61784E756D62657253746963';
wwv_flow_imp.g_varchar2_table(15781) := '6B794C696E6573292A746869732E5F6C696E654865696768743A652A746869732E5F6C696E654865696768742C673D4D6174682E6D617828302C652D31292A746869732E5F6C696E654865696768747D656C7365206E7C7C28703D746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(15782) := '65486569676874293B6966286E7C7C30213D3D73262634213D3D737C7C28672B3D746869732E5F6C696E65486569676874292C642D3D702C682B3D672C682D643E61297B69662821632972657475726E2D313B753D647D656C736520696628353D3D3D73';
wwv_flow_imp.g_varchar2_table(15783) := '7C7C363D3D3D7329696628363D3D3D732626723C3D642626683C3D6C29753D723B656C73657B636F6E737420653D642D4D6174682E6D617828352A746869732E5F6C696E654865696768742C2E322A61292C743D682D613B753D4D6174682E6D61782874';
wwv_flow_imp.g_varchar2_table(15784) := '2C65297D656C736520696628313D3D3D737C7C323D3D3D7329696628323D3D3D732626723C3D642626683C3D6C29753D723B656C73657B636F6E737420653D28642B68292F323B753D4D6174682E6D617828302C652D612F32297D656C736520753D7468';
wwv_flow_imp.g_varchar2_table(15785) := '69732E5F636F6D707574654D696E696D756D5363726F6C6C696E6728722C6C2C642C682C333D3D3D732C343D3D3D73293B72657475726E20757D5F636F6D707574655363726F6C6C4C656674546F52657665616C2865297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(15786) := '2E5F636F6E746578742E766965774C61796F75742E67657443757272656E7456696577706F727428292C6E3D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435292C693D742E6C6566742C6F3D';
wwv_flow_imp.g_varchar2_table(15787) := '692B742E77696474682D6E2E766572746963616C5363726F6C6C62617257696474683B6C657420733D313037333734313832342C723D303B6966282272616E6765223D3D3D652E74797065297B636F6E737420743D746869732E5F76697369626C655261';
wwv_flow_imp.g_varchar2_table(15788) := '6E676573466F724C696E6552616E676528652E6C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E64436F6C756D6E293B69662821742972657475726E206E756C6C3B666F7228636F6E73742065206F6620742E72616E6765732973';
wwv_flow_imp.g_varchar2_table(15789) := '3D4D6174682E6D696E28732C4D6174682E726F756E6428652E6C65667429292C723D4D6174682E6D617828722C4D6174682E726F756E6428652E6C6566742B652E776964746829297D656C736520666F7228636F6E73742074206F6620652E73656C6563';
wwv_flow_imp.g_varchar2_table(15790) := '74696F6E73297B696628742E73746172744C696E654E756D626572213D3D742E656E644C696E654E756D6265722972657475726E206E756C6C3B636F6E737420653D746869732E5F76697369626C6552616E676573466F724C696E6552616E676528742E';
wwv_flow_imp.g_varchar2_table(15791) := '73746172744C696E654E756D6265722C742E7374617274436F6C756D6E2C742E656E64436F6C756D6E293B69662821652972657475726E206E756C6C3B666F7228636F6E73742074206F6620652E72616E67657329733D4D6174682E6D696E28732C4D61';
wwv_flow_imp.g_varchar2_table(15792) := '74682E726F756E6428742E6C65667429292C723D4D6174682E6D617828722C4D6174682E726F756E6428742E6C6566742B742E776964746829297D72657475726E20652E6D696E696D616C52657665616C7C7C28733D4D6174682E6D617828302C732D64';
wwv_flow_imp.g_varchar2_table(15793) := '4F2E484F52495A4F4E54414C5F45585452415F5058292C722B3D746869732E5F72657665616C486F72697A6F6E74616C526967687450616464696E67292C2273656C656374696F6E73223D3D3D652E747970652626722D733E742E77696474683F6E756C';
wwv_flow_imp.g_varchar2_table(15794) := '6C3A7B7363726F6C6C4C6566743A746869732E5F636F6D707574654D696E696D756D5363726F6C6C696E6728692C6F2C732C72292C6D6178486F72697A6F6E74616C4F66667365743A727D7D5F636F6D707574654D696E696D756D5363726F6C6C696E67';
wwv_flow_imp.g_varchar2_table(15795) := '28652C742C6E2C692C6F2C73297B6F3D21216F2C733D2121733B636F6E737420723D28747C3D30292D28657C3D30293B72657475726E28697C3D30292D286E7C3D30293C723F6F3F6E3A733F4D6174682E6D617828302C692D72293A6E3C653F6E3A693E';
wwv_flow_imp.g_varchar2_table(15796) := '743F4D6174682E6D617828302C692D72293A653A6E7D7D644F2E484F52495A4F4E54414C5F45585452415F50583D33303B76617220684F3D6E2837333735292C754F3D7B7D3B754F2E7374796C655461675472616E73666F726D3D6A7228292C754F2E73';
wwv_flow_imp.g_varchar2_table(15797) := '6574417474726962757465733D567228292C754F2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C754F2E646F6D4150493D4F7228292C754F2E696E736572745374796C65456C656D656E743D487228292C4E72282928684F';
wwv_flow_imp.g_varchar2_table(15798) := '2E412C754F292C684F2E412626684F2E412E6C6F63616C732626684F2E412E6C6F63616C733B636C61737320704F20657874656E64732051507B636F6E7374727563746F722865297B737570657228292C746869732E5F636F6E746578743D653B636F6E';
wwv_flow_imp.g_varchar2_table(15799) := '737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B746869732E5F6465636F726174696F6E734C6566743D742E6465636F726174696F6E734C6566742C746869732E5F6465636F';
wwv_flow_imp.g_varchar2_table(15800) := '726174696F6E7357696474683D742E6465636F726174696F6E7357696474682C746869732E5F72656E646572526573756C743D6E756C6C2C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528';
wwv_flow_imp.g_varchar2_table(15801) := '297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E5F72656E646572526573756C743D6E756C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E';
wwv_flow_imp.g_varchar2_table(15802) := '6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B72657475726E20746869732E5F6465636F726174696F6E734C6566743D742E6465636F726174696F';
wwv_flow_imp.g_varchar2_table(15803) := '6E734C6566742C746869732E5F6465636F726174696F6E7357696474683D742E6465636F726174696F6E7357696474682C21307D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B7265';
wwv_flow_imp.g_varchar2_table(15804) := '7475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C436861';
wwv_flow_imp.g_varchar2_table(15805) := '6E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D5F6765744465636F726174696F6E732865297B76617220742C6E3B636F6E737420693D652E6765';
wwv_flow_imp.g_varchar2_table(15806) := '744465636F726174696F6E73496E56696577706F727428292C6F3D5B5D3B6C657420733D303B666F72286C657420653D302C723D692E6C656E6774683B653C723B652B2B297B636F6E737420723D695B655D2C613D722E6F7074696F6E732E6C696E6573';
wwv_flow_imp.g_varchar2_table(15807) := '4465636F726174696F6E73436C6173734E616D652C6C3D722E6F7074696F6E732E7A496E6465783B612626286F5B732B2B5D3D6E657720555028722E72616E67652E73746172744C696E654E756D6265722C722E72616E67652E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(15808) := '6265722C612C6E756C6C213D3D28743D722E6F7074696F6E732E6C696E65734465636F726174696F6E73546F6F6C746970292626766F69642030213D3D743F743A6E756C6C2C6C29293B636F6E737420633D722E6F7074696F6E732E66697273744C696E';
wwv_flow_imp.g_varchar2_table(15809) := '654465636F726174696F6E436C6173734E616D653B632626286F5B732B2B5D3D6E657720555028722E72616E67652E73746172744C696E654E756D6265722C722E72616E67652E73746172744C696E654E756D6265722C632C6E756C6C213D3D286E3D72';
wwv_flow_imp.g_varchar2_table(15810) := '2E6F7074696F6E732E6C696E65734465636F726174696F6E73546F6F6C746970292626766F69642030213D3D6E3F6E3A6E756C6C2C6C29297D72657475726E206F7D7072657061726552656E6465722865297B636F6E737420743D652E76697369626C65';
wwv_flow_imp.g_varchar2_table(15811) := '52616E67652E73746172744C696E654E756D6265722C6E3D652E76697369626C6552616E67652E656E644C696E654E756D6265722C693D746869732E5F72656E64657228742C6E2C746869732E5F6765744465636F726174696F6E73286529292C6F3D27';
wwv_flow_imp.g_varchar2_table(15812) := '22207374796C653D226C6566743A272B746869732E5F6465636F726174696F6E734C6566742E746F537472696E6728292B2270783B77696474683A222B746869732E5F6465636F726174696F6E7357696474682E746F537472696E6728292B2770783B22';
wwv_flow_imp.g_varchar2_table(15813) := '3E3C2F6469763E272C733D5B5D3B666F72286C657420653D743B653C3D6E3B652B2B297B636F6E7374206E3D652D742C723D695B6E5D2E6765744465636F726174696F6E7328293B6C657420613D22223B666F7228636F6E73742065206F662072297B6C';
wwv_flow_imp.g_varchar2_table(15814) := '657420743D273C64697620636C6173733D22636C647220272B652E636C6173734E616D653B6E756C6C213D3D652E746F6F6C746970262628742B3D2722207469746C653D22272B652E746F6F6C746970292C742B3D6F2C612B3D747D735B6E5D3D617D74';
wwv_flow_imp.g_varchar2_table(15815) := '6869732E5F72656E646572526573756C743D737D72656E64657228652C74297B72657475726E20746869732E5F72656E646572526573756C743F746869732E5F72656E646572526573756C745B742D655D3A22227D7D76617220674F3D6E283333313329';
wwv_flow_imp.g_varchar2_table(15816) := '2C6D4F3D7B7D3B6D4F2E7374796C655461675472616E73666F726D3D6A7228292C6D4F2E736574417474726962757465733D567228292C6D4F2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6D4F2E646F6D4150493D4F72';
wwv_flow_imp.g_varchar2_table(15817) := '28292C6D4F2E696E736572745374796C65456C656D656E743D487228292C4E72282928674F2E412C6D4F292C674F2E412626674F2E412E6C6F63616C732626674F2E412E6C6F63616C733B636C61737320664F20657874656E64732051507B636F6E7374';
wwv_flow_imp.g_varchar2_table(15818) := '727563746F722865297B737570657228292C746869732E5F636F6E746578743D652C746869732E5F72656E646572526573756C743D6E756C6C2C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F73';
wwv_flow_imp.g_varchar2_table(15819) := '6528297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E5F72656E646572526573756C743D6E756C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368';
wwv_flow_imp.g_varchar2_table(15820) := '616E6765642865297B72657475726E21307D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D';
wwv_flow_imp.g_varchar2_table(15821) := '6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D';
wwv_flow_imp.g_varchar2_table(15822) := '6F6E5A6F6E65734368616E6765642865297B72657475726E21307D5F6765744465636F726174696F6E732865297B636F6E737420743D652E6765744465636F726174696F6E73496E56696577706F727428292C6E3D5B5D3B6C657420693D303B666F7228';
wwv_flow_imp.g_varchar2_table(15823) := '6C657420653D302C6F3D742E6C656E6774683B653C6F3B652B2B297B636F6E7374206F3D745B655D2C733D6F2E6F7074696F6E732E6D617267696E436C6173734E616D652C723D6F2E6F7074696F6E732E7A496E6465783B732626286E5B692B2B5D3D6E';
wwv_flow_imp.g_varchar2_table(15824) := '6577205550286F2E72616E67652E73746172744C696E654E756D6265722C6F2E72616E67652E656E644C696E654E756D6265722C732C6E756C6C2C7229297D72657475726E206E7D7072657061726552656E6465722865297B636F6E737420743D652E76';
wwv_flow_imp.g_varchar2_table(15825) := '697369626C6552616E67652E73746172744C696E654E756D6265722C6E3D652E76697369626C6552616E67652E656E644C696E654E756D6265722C693D746869732E5F72656E64657228742C6E2C746869732E5F6765744465636F726174696F6E732865';
wwv_flow_imp.g_varchar2_table(15826) := '29292C6F3D5B5D3B666F72286C657420653D743B653C3D6E3B652B2B297B636F6E7374206E3D652D742C733D695B6E5D2E6765744465636F726174696F6E7328293B6C657420723D22223B666F7228636F6E73742065206F66207329722B3D273C646976';
wwv_flow_imp.g_varchar2_table(15827) := '20636C6173733D22636D647220272B652E636C6173734E616D652B2722207374796C653D22223E3C2F6469763E273B6F5B6E5D3D727D746869732E5F72656E646572526573756C743D6F7D72656E64657228652C74297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(15828) := '72656E646572526573756C743F746869732E5F72656E646572526573756C745B742D655D3A22227D7D76617220764F3D6E2836343933292C624F3D7B7D3B624F2E7374796C655461675472616E73666F726D3D6A7228292C624F2E736574417474726962';
wwv_flow_imp.g_varchar2_table(15829) := '757465733D567228292C624F2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C624F2E646F6D4150493D4F7228292C624F2E696E736572745374796C65456C656D656E743D487228292C4E72282928764F2E412C624F292C76';
wwv_flow_imp.g_varchar2_table(15830) := '4F2E412626764F2E412E6C6F63616C732626764F2E412E6C6F63616C733B636C617373205F4F7B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F72676261384272616E643D766F696420302C746869732E723D5F4F2E5F636C616D70';
wwv_flow_imp.g_varchar2_table(15831) := '2865292C746869732E673D5F4F2E5F636C616D702874292C746869732E623D5F4F2E5F636C616D70286E292C746869732E613D5F4F2E5F636C616D702869297D657175616C732865297B72657475726E20746869732E723D3D3D652E722626746869732E';
wwv_flow_imp.g_varchar2_table(15832) := '673D3D3D652E672626746869732E623D3D3D652E622626746869732E613D3D3D652E617D737461746963205F636C616D702865297B72657475726E20653C303F303A653E3235353F3235353A307C657D7D5F4F2E456D7074793D6E6577205F4F28302C30';
wwv_flow_imp.g_varchar2_table(15833) := '2C302C30293B636C61737320794F20657874656E6473206C747B73746174696320676574496E7374616E636528297B72657475726E20746869732E5F494E5354414E43457C7C28746869732E5F494E5354414E43453D6E74286E657720794F29292C7468';
wwv_flow_imp.g_varchar2_table(15834) := '69732E5F494E5354414E43457D636F6E7374727563746F7228297B737570657228292C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E74';
wwv_flow_imp.g_varchar2_table(15835) := '2C746869732E5F757064617465436F6C6F724D617028292C746869732E5F72656769737465722850772E6F6E4469644368616E67652828653D3E7B652E6368616E676564436F6C6F724D61702626746869732E5F757064617465436F6C6F724D61702829';
wwv_flow_imp.g_varchar2_table(15836) := '7D2929297D5F757064617465436F6C6F724D617028297B636F6E737420653D50772E676574436F6C6F724D617028293B69662821652972657475726E20746869732E5F636F6C6F72733D5B5F4F2E456D7074795D2C766F696428746869732E5F6261636B';
wwv_flow_imp.g_varchar2_table(15837) := '67726F756E6449734C696768743D2130293B746869732E5F636F6C6F72733D5B5F4F2E456D7074795D3B666F72286C657420743D313B743C652E6C656E6774683B742B2B297B636F6E7374206E3D655B745D2E726762613B746869732E5F636F6C6F7273';
wwv_flow_imp.g_varchar2_table(15838) := '5B745D3D6E6577205F4F286E2E722C6E2E672C6E2E622C4D6174682E726F756E64283235352A6E2E6129297D636F6E737420743D655B325D2E67657452656C61746976654C756D696E616E636528293B746869732E5F6261636B67726F756E6449734C69';
wwv_flow_imp.g_varchar2_table(15839) := '6768743D743E3D2E352C746869732E5F6F6E4469644368616E67652E6669726528766F69642030297D676574436F6C6F722865297B72657475726E28653C317C7C653E3D746869732E5F636F6C6F72732E6C656E67746829262628653D32292C74686973';
wwv_flow_imp.g_varchar2_table(15840) := '2E5F636F6C6F72735B655D7D6261636B67726F756E6449734C6967687428297B72657475726E20746869732E5F6261636B67726F756E6449734C696768747D7D794F2E5F494E5354414E43453D6E756C6C3B636C61737320774F7B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(15841) := '6F7228652C742C6E2C69297B746869732E5F76696577706F72744272616E643D766F696420302C746869732E746F703D307C652C746869732E6C6566743D307C742C746869732E77696474683D307C6E2C746869732E6865696768743D307C697D7D636C';
wwv_flow_imp.g_varchar2_table(15842) := '61737320434F7B636F6E7374727563746F7228652C74297B746869732E74616253697A653D652C746869732E646174613D747D7D636C61737320534F7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E5F766965774C69';
wwv_flow_imp.g_varchar2_table(15843) := '6E65446174614272616E643D766F696420302C746869732E636F6E74656E743D652C746869732E636F6E74696E75657357697468577261707065644C696E653D742C746869732E6D696E436F6C756D6E3D6E2C746869732E6D6178436F6C756D6E3D692C';
wwv_flow_imp.g_varchar2_table(15844) := '746869732E737461727456697369626C65436F6C756D6E3D6F2C746869732E746F6B656E733D732C746869732E696E6C696E654465636F726174696F6E733D727D7D636C61737320784F7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72';
wwv_flow_imp.g_varchar2_table(15845) := '2C612C6C2C63297B746869732E6D696E436F6C756D6E3D652C746869732E6D6178436F6C756D6E3D742C746869732E636F6E74656E743D6E2C746869732E636F6E74696E75657357697468577261707065644C696E653D692C746869732E697342617369';
wwv_flow_imp.g_varchar2_table(15846) := '6341534349493D784F2E697342617369634153434949286E2C73292C746869732E636F6E7461696E7352544C3D784F2E636F6E7461696E7352544C286E2C746869732E6973426173696341534349492C6F292C746869732E746F6B656E733D722C746869';
wwv_flow_imp.g_varchar2_table(15847) := '732E696E6C696E654465636F726174696F6E733D612C746869732E74616253697A653D6C2C746869732E737461727456697369626C65436F6C756D6E3D637D7374617469632069734261736963415343494928652C74297B72657475726E21747C7C7A69';
wwv_flow_imp.g_varchar2_table(15848) := '2865297D73746174696320636F6E7461696E7352544C28652C742C6E297B72657475726E2128747C7C216E29262642692865297D7D636C617373206B4F7B636F6E7374727563746F7228652C742C6E297B746869732E72616E67653D652C746869732E69';
wwv_flow_imp.g_varchar2_table(15849) := '6E6C696E65436C6173734E616D653D742C746869732E747970653D6E7D7D636C61737320454F7B636F6E7374727563746F7228652C742C6E2C69297B746869732E73746172744F66667365743D652C746869732E656E644F66667365743D742C74686973';
wwv_flow_imp.g_varchar2_table(15850) := '2E696E6C696E65436C6173734E616D653D6E2C746869732E696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673D697D746F496E6C696E654465636F726174696F6E2865297B72657475726E206E6577206B4F286E65';
wwv_flow_imp.g_varchar2_table(15851) := '7720726828652C746869732E73746172744F66667365742B312C652C746869732E656E644F66667365742B31292C746869732E696E6C696E65436C6173734E616D652C746869732E696E6C696E65436C6173734E616D65416666656374734C6574746572';
wwv_flow_imp.g_varchar2_table(15852) := '53706163696E673F333A30297D7D636C617373204C4F7B636F6E7374727563746F7228652C74297B746869732E5F766965774D6F64656C4465636F726174696F6E4272616E643D766F696420302C746869732E72616E67653D652C746869732E6F707469';
wwv_flow_imp.g_varchar2_table(15853) := '6F6E733D747D7D636C61737320444F7B636F6E7374727563746F7228652C742C6E297B746869732E636F6C6F723D652C746869732E7A496E6465783D742C746869732E646174613D6E7D73746174696320636F6D70617265427952656E646572696E6750';
wwv_flow_imp.g_varchar2_table(15854) := '726F707328652C74297B72657475726E20652E7A496E6465783D3D3D742E7A496E6465783F652E636F6C6F723C742E636F6C6F723F2D313A652E636F6C6F723E742E636F6C6F723F313A303A652E7A496E6465782D742E7A496E6465787D737461746963';
wwv_flow_imp.g_varchar2_table(15855) := '20657175616C7328652C74297B72657475726E20652E636F6C6F723D3D3D742E636F6C6F722626652E7A496E6465783D3D3D742E7A496E6465782626506828652E646174612C742E64617461297D73746174696320657175616C7341727228652C74297B';
wwv_flow_imp.g_varchar2_table(15856) := '72657475726E20506828652C742C444F2E657175616C73297D7D636F6E737420544F3D2828293D3E7B636F6E737420653D5B5D3B666F72286C657420743D33323B743C3D3132363B742B2B29652E707573682874293B72657475726E20652E7075736828';
wwv_flow_imp.g_varchar2_table(15857) := '3635353333292C657D2928293B636C61737320494F7B636F6E7374727563746F7228652C74297B746869732E7363616C653D742C746869732E5F6D696E696D61704368617252656E64657265724272616E643D766F696420302C746869732E6368617244';
wwv_flow_imp.g_varchar2_table(15858) := '6174614E6F726D616C3D494F2E736F6674656E28652C2E38292C746869732E63686172446174614C696768743D494F2E736F6674656E28652C35302F3630297D73746174696320736F6674656E28652C74297B636F6E7374206E3D6E65772055696E7438';
wwv_flow_imp.g_varchar2_table(15859) := '436C616D706564417272617928652E6C656E677468293B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B296E5B695D3D717928655B695D2A74293B72657475726E206E7D72656E6465724368617228652C742C6E2C692C6F2C';
wwv_flow_imp.g_varchar2_table(15860) := '732C722C612C6C2C632C64297B636F6E737420683D312A746869732E7363616C652C753D322A746869732E7363616C652C703D643F313A753B696628742B683E652E77696474687C7C6E2B703E652E6865696768742972657475726E20766F696420636F';
wwv_flow_imp.g_varchar2_table(15861) := '6E736F6C652E7761726E28226261642072656E6465722072657175657374206F75747369646520696D616765206461746122293B636F6E737420673D633F746869732E63686172446174614C696768743A746869732E63686172446174614E6F726D616C';
wwv_flow_imp.g_varchar2_table(15862) := '2C6D3D2828652C74293D3E28652D3D3332293C307C7C653E39363F743C3D323F28652B3936292539363A39353A652928692C6C292C663D342A652E77696474682C763D722E722C623D722E672C5F3D722E622C793D6F2E722D762C773D6F2E672D622C43';
wwv_flow_imp.g_varchar2_table(15863) := '3D6F2E622D5F2C533D4D6174682E6D617828732C61292C783D652E646174613B6C6574206B3D6D2A682A752C453D6E2A662B342A743B666F72286C657420653D303B653C703B652B2B297B6C657420653D453B666F72286C657420743D303B743C683B74';
wwv_flow_imp.g_varchar2_table(15864) := '2B2B297B636F6E737420743D675B6B2B2B5D2F3235352A28732F323535293B785B652B2B5D3D762B792A742C785B652B2B5D3D622B772A742C785B652B2B5D3D5F2B432A742C785B652B2B5D3D537D452B3D667D7D626C6F636B52656E64657243686172';
wwv_flow_imp.g_varchar2_table(15865) := '28652C742C6E2C692C6F2C732C722C61297B636F6E7374206C3D312A746869732E7363616C652C633D322A746869732E7363616C652C643D613F313A633B696628742B6C3E652E77696474687C7C6E2B643E652E6865696768742972657475726E20766F';
wwv_flow_imp.g_varchar2_table(15866) := '696420636F6E736F6C652E7761726E28226261642072656E6465722072657175657374206F75747369646520696D616765206461746122293B636F6E737420683D342A652E77696474682C753D6F2F3235352A2E352C703D732E722C673D732E672C6D3D';
wwv_flow_imp.g_varchar2_table(15867) := '732E622C663D702B28692E722D70292A752C763D672B28692E672D67292A752C623D6D2B28692E622D6D292A752C5F3D4D6174682E6D6178286F2C72292C793D652E646174613B6C657420773D6E2A682B342A743B666F72286C657420653D303B653C64';
wwv_flow_imp.g_varchar2_table(15868) := '3B652B2B297B6C657420653D773B666F72286C657420743D303B743C6C3B742B2B29795B652B2B5D3D662C795B652B2B5D3D762C795B652B2B5D3D622C795B652B2B5D3D5F3B772B3D687D7D7D636F6E7374204D4F3D7B303A302C313A312C323A322C33';
wwv_flow_imp.g_varchar2_table(15869) := '3A332C343A342C353A352C363A362C373A372C383A382C393A392C413A31302C423A31312C433A31322C443A31332C453A31342C463A31357D2C414F3D653D3E7B636F6E737420743D6E65772055696E7438436C616D706564417272617928652E6C656E';
wwv_flow_imp.g_varchar2_table(15870) := '6774682F32293B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B3D3229745B6E3E3E315D3D4D4F5B655B6E5D5D3C3C347C3135264D4F5B655B6E2B315D5D3B72657475726E20747D2C4E4F3D7B313A5965282828293D3E414F2822303030';
wwv_flow_imp.g_varchar2_table(15871) := '30353131443633303043463630394337303936343541373834333230303536343235373431373134383730323130303343343531393030323734443335443736323735354538423632394335424138353641463537424136343935333043313637443135';
wwv_flow_imp.g_varchar2_table(15872) := '31324132373241334636303338363034343630333938353236424341324139363844423646383935374337363842453546424532464234363743463544384435423739354443373632354235444646353044453634433436364442324643343743443836';
wwv_flow_imp.g_varchar2_table(15873) := '30413635453941324542393643423534434530364441373633414232454132363836303532344433373633353336363031303035313136303038313737413837303545353341423733384536413938324638384241413335423546354236323644394336';
wwv_flow_imp.g_varchar2_table(15874) := '333642343439423733374535423742363738353938383639413636324636423542383534323730364337303443383037333641363037353738363835423730353934413439373135413435323245373932222929292C323A5965282828293D3E414F2822';
wwv_flow_imp.g_varchar2_table(15875) := '30303030303030303030303030303030353533393446333833443238303030303842384231463231303030323030303038314231434243424343383230303030383437414146364239414146323131394245303842383838314144363030303041343446';
wwv_flow_imp.g_varchar2_table(15876) := '44303744434346313037303135333338313330433030303030303030333835393732323635463339304234303645323433373633344234423438303331423132423841303834373030303030314531354232394134303246303030303030303030303030';
wwv_flow_imp.g_varchar2_table(15877) := '34423333343630423030303037413735324332413030303030303030303030303444333930303030303038343339344238323031333430304142413543464337414439433033303241343541334535413938414230303030383941343333383244393739';
wwv_flow_imp.g_varchar2_table(15878) := '30303030384241353441413038374137304130323438413641374145364442453030303042463646393439383745413430413031413036444346413741374139303330343936433332463737383931443030303041393946423141304146413830363033';
wwv_flow_imp.g_varchar2_table(15879) := '42323941423943413735393330443031304330393438333534443339303030303043303934383335344633373436304430303238424536373344383430303030303030304146394437423645303030303242303037414138393333343030303037414136';
wwv_flow_imp.g_varchar2_table(15880) := '34323637354332373030303037393834434642394333393835423736383737324138413642374232303030304341414543414146433442373030303039463934413630303946383430303039443039463942413443413943303030304343384643373644';
wwv_flow_imp.g_varchar2_table(15881) := '43383746303030304339393143343732413230303030303041383934413438434137423530313037394241324339433639424132303030304231394135443346413839303030303035434136303039444132393630393031423041374630363639464232';
wwv_flow_imp.g_varchar2_table(15882) := '30303030394430303945303042373839303030304441443046354430393238323030303044323934443443343842443130303030423541374134413342314135303430324341423643424136413230303030303042354137413441334231413830343446';
wwv_flow_imp.g_varchar2_table(15883) := '43444144443139443943423030303030423737373846374238414145303830334339414235443346354433463030303039454130394541304241423030363033394541303938394138433739303030303942394546344436423743303030303041394137';
wwv_flow_imp.g_varchar2_table(15884) := '38313643414341383030303041424143383437303544334630303030393644413633354344433843303030303646343836463236364632363344343738343030363132343039374230303337344636443244364432443644344133413935383732333232';
wwv_flow_imp.g_varchar2_table(15885) := '30303030303030333030303030303030303030303844383933393133303030303030303030303030324532324135433943424337303630304142323543304235433942343030303631413244423034434136373030313038324141364245424542464336';
wwv_flow_imp.g_varchar2_table(15886) := '30363030323332314441434243313945303330383741413038423637363833383030303032383246424143304238434137413838414432354242413541323939303030303443333936433538393441363030303034303438354136453335364539343432';
wwv_flow_imp.g_varchar2_table(15887) := '41333243443137454144413730303030423432333739323336323836303030303345324445394331443742353030303032463235424241354132393930303030323331444236414642344138303430323330323543304235434142353838303632423243';
wwv_flow_imp.g_varchar2_table(15888) := '42444245433043373036383832343335413735434132303030303030323332364244364138324139303830343842344239413541363638303030303032343233413039434234424230363030323532353943394438413739303030303143314643414232';
wwv_flow_imp.g_varchar2_table(15889) := '43374337303030303241324139333837414241323030303032363236413441343744364539443134333333313633413043383735303030303442364639433244363433413235373034393336343933363439333634373335384133343433383335353439';
wwv_flow_imp.g_varchar2_table(15890) := '374631413030303041323443314435393030303044333844464642444434434433313236222929297D3B636C61737320504F7B7374617469632063726561746528652C74297B696628746869732E6C617374437265617465642626653D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(15891) := '6C617374437265617465642E7363616C652626743D3D3D746869732E6C617374466F6E7446616D696C792972657475726E20746869732E6C617374437265617465643B6C6574206E3B72657475726E206E3D4E4F5B655D3F6E657720494F284E4F5B655D';
wwv_flow_imp.g_varchar2_table(15892) := '28292C65293A504F2E63726561746546726F6D53616D706C654461746128504F2E63726561746553616D706C65446174612874292E646174612C65292C746869732E6C617374466F6E7446616D696C793D742C746869732E6C617374437265617465643D';
wwv_flow_imp.g_varchar2_table(15893) := '6E2C6E7D7374617469632063726561746553616D706C65446174612865297B636F6E737420743D646F63756D656E742E637265617465456C656D656E74282263616E76617322292C6E3D742E676574436F6E746578742822326422293B742E7374796C65';
wwv_flow_imp.g_varchar2_table(15894) := '2E6865696768743D2231367078222C742E6865696768743D31362C742E77696474683D3936302C742E7374796C652E77696474683D223936307078222C6E2E66696C6C5374796C653D2223666666666666222C6E2E666F6E743D60626F6C642031367078';
wwv_flow_imp.g_varchar2_table(15895) := '20247B657D602C6E2E74657874426173656C696E653D226D6964646C65223B6C657420693D303B666F7228636F6E73742065206F6620544F296E2E66696C6C5465787428537472696E672E66726F6D43686172436F64652865292C692C38292C692B3D31';
wwv_flow_imp.g_varchar2_table(15896) := '303B72657475726E206E2E676574496D6167654461746128302C302C3936302C3136297D7374617469632063726561746546726F6D53616D706C654461746128652C74297B6966283631343430213D3D652E6C656E677468297468726F77206E65772045';
wwv_flow_imp.g_varchar2_table(15897) := '72726F722822556E657870656374656420736F7572636520696E204D696E696D61704368617252656E646572657222293B636F6E7374206E3D504F2E5F646F776E73616D706C6528652C74293B72657475726E206E657720494F286E2C74297D73746174';
wwv_flow_imp.g_varchar2_table(15898) := '6963205F646F776E73616D706C654368617228652C742C6E2C692C6F297B636F6E737420733D312A6F2C723D322A6F3B6C657420613D692C6C3D303B666F72286C657420693D303B693C723B692B2B297B636F6E7374206F3D692F722A31362C633D2869';
wwv_flow_imp.g_varchar2_table(15899) := '2B31292F722A31363B666F72286C657420693D303B693C733B692B2B297B636F6E737420723D692F732A31302C643D28692B31292F732A31303B6C657420683D302C753D303B666F72286C6574206E3D6F3B6E3C633B6E2B2B297B636F6E737420693D74';
wwv_flow_imp.g_varchar2_table(15900) := '2B333834302A4D6174682E666C6F6F72286E292C6F3D312D286E2D4D6174682E666C6F6F72286E29293B666F72286C657420743D723B743C643B742B2B297B636F6E7374206E3D312D28742D4D6174682E666C6F6F72287429292C733D692B342A4D6174';
wwv_flow_imp.g_varchar2_table(15901) := '682E666C6F6F722874292C723D6E2A6F3B752B3D722C682B3D655B735D2A655B732B335D2F3235352A727D7D636F6E737420703D682F753B6C3D4D6174682E6D6178286C2C70292C6E5B612B2B5D3D71792870297D7D72657475726E206C7D7374617469';
wwv_flow_imp.g_varchar2_table(15902) := '63205F646F776E73616D706C6528652C74297B636F6E7374206E3D322A742A312A742C693D39362A6E2C6F3D6E65772055696E7438436C616D70656441727261792869293B6C657420733D302C723D302C613D303B666F72286C657420693D303B693C39';
wwv_flow_imp.g_varchar2_table(15903) := '363B692B2B29613D4D6174682E6D617828612C746869732E5F646F776E73616D706C654368617228652C722C6F2C732C7429292C732B3D6E2C722B3D34303B696628613E30297B636F6E737420653D3235352F613B666F72286C657420743D303B743C69';
wwv_flow_imp.g_varchar2_table(15904) := '3B742B2B296F5B745D2A3D657D72657475726E206F7D7D636F6E7374204F4F3D6A3F27225365676F6520575043222C20225365676F65205549222C2073616E732D7365726966273A713F222D6170706C652D73797374656D2C20426C696E6B4D61635379';
wwv_flow_imp.g_varchar2_table(15905) := '7374656D466F6E742C2073616E732D7365726966223A2773797374656D2D75692C20225562756E7475222C202244726F69642053616E73222C2073616E732D7365726966273B636C61737320524F7B636F6E7374727563746F7228652C742C6E297B636F';
wwv_flow_imp.g_varchar2_table(15906) := '6E737420693D652E6F7074696F6E732C6F3D692E67657428313433292C733D692E67657428313435292C723D732E6D696E696D61702C613D692E676574283530292C6C3D692E676574283733293B746869732E72656E6465724D696E696D61703D722E72';
wwv_flow_imp.g_varchar2_table(15907) := '656E6465724D696E696D61702C746869732E73697A653D6C2E73697A652C746869732E6D696E696D61704865696768744973456469746F724865696768743D722E6D696E696D61704865696768744973456469746F724865696768742C746869732E7363';
wwv_flow_imp.g_varchar2_table(15908) := '726F6C6C4265796F6E644C6173744C696E653D692E67657428313035292C746869732E70616464696E67546F703D692E676574283834292E746F702C746869732E70616464696E67426F74746F6D3D692E676574283834292E626F74746F6D2C74686973';
wwv_flow_imp.g_varchar2_table(15909) := '2E73686F77536C696465723D6C2E73686F77536C696465722C746869732E6175746F686964653D6C2E6175746F686964652C746869732E706978656C526174696F3D6F2C746869732E7479706963616C48616C6677696474684368617261637465725769';
wwv_flow_imp.g_varchar2_table(15910) := '6474683D612E7479706963616C48616C66776964746843686172616374657257696474682C746869732E6C696E654865696768743D692E676574283637292C746869732E6D696E696D61704C6566743D722E6D696E696D61704C6566742C746869732E6D';
wwv_flow_imp.g_varchar2_table(15911) := '696E696D617057696474683D722E6D696E696D617057696474682C746869732E6D696E696D61704865696768743D732E6865696768742C746869732E63616E766173496E6E657257696474683D722E6D696E696D617043616E766173496E6E6572576964';
wwv_flow_imp.g_varchar2_table(15912) := '74682C746869732E63616E766173496E6E65724865696768743D722E6D696E696D617043616E766173496E6E65724865696768742C746869732E63616E7661734F7574657257696474683D722E6D696E696D617043616E7661734F757465725769647468';
wwv_flow_imp.g_varchar2_table(15913) := '2C746869732E63616E7661734F757465724865696768743D722E6D696E696D617043616E7661734F757465724865696768742C746869732E697353616D706C696E673D722E6D696E696D6170497353616D706C696E672C746869732E656469746F724865';
wwv_flow_imp.g_varchar2_table(15914) := '696768743D732E6865696768742C746869732E666F6E745363616C653D722E6D696E696D61705363616C652C746869732E6D696E696D61704C696E654865696768743D722E6D696E696D61704C696E654865696768742C746869732E6D696E696D617043';
wwv_flow_imp.g_varchar2_table(15915) := '68617257696474683D312A746869732E666F6E745363616C652C746869732E73656374696F6E486561646572466F6E7446616D696C793D4F4F2C746869732E73656374696F6E486561646572466F6E7453697A653D6C2E73656374696F6E486561646572';
wwv_flow_imp.g_varchar2_table(15916) := '466F6E7453697A652A6F2C746869732E73656374696F6E486561646572466F6E74436F6C6F723D524F2E5F67657453656374696F6E486561646572436F6C6F7228742C6E2E676574436F6C6F72283129292C746869732E6368617252656E64657265723D';
wwv_flow_imp.g_varchar2_table(15917) := '5965282828293D3E504F2E63726561746528746869732E666F6E745363616C652C612E666F6E7446616D696C792929292C746869732E64656661756C744261636B67726F756E64436F6C6F723D6E2E676574436F6C6F722832292C746869732E6261636B';
wwv_flow_imp.g_varchar2_table(15918) := '67726F756E64436F6C6F723D524F2E5F6765744D696E696D61704261636B67726F756E6428742C746869732E64656661756C744261636B67726F756E64436F6C6F72292C746869732E666F726567726F756E64416C7068613D524F2E5F6765744D696E69';
wwv_flow_imp.g_varchar2_table(15919) := '6D6170466F726567726F756E644F7061636974792874297D737461746963205F6765744D696E696D61704261636B67726F756E6428652C74297B636F6E7374206E3D652E676574436F6C6F72287376293B72657475726E206E3F6E6577205F4F286E2E72';
wwv_flow_imp.g_varchar2_table(15920) := '6762612E722C6E2E726762612E672C6E2E726762612E622C4D6174682E726F756E64283235352A6E2E726762612E6129293A747D737461746963205F6765744D696E696D6170466F726567726F756E644F7061636974792865297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(15921) := '2E676574436F6C6F72287276293B72657475726E20743F5F4F2E5F636C616D70284D6174682E726F756E64283235352A742E726762612E6129293A3235357D737461746963205F67657453656374696F6E486561646572436F6C6F7228652C74297B636F';
wwv_flow_imp.g_varchar2_table(15922) := '6E7374206E3D652E676574436F6C6F72285A6D293B72657475726E206E3F6E6577205F4F286E2E726762612E722C6E2E726762612E672C6E2E726762612E622C4D6174682E726F756E64283235352A6E2E726762612E6129293A747D657175616C732865';
wwv_flow_imp.g_varchar2_table(15923) := '297B72657475726E20746869732E72656E6465724D696E696D61703D3D3D652E72656E6465724D696E696D61702626746869732E73697A653D3D3D652E73697A652626746869732E6D696E696D61704865696768744973456469746F724865696768743D';
wwv_flow_imp.g_varchar2_table(15924) := '3D3D652E6D696E696D61704865696768744973456469746F724865696768742626746869732E7363726F6C6C4265796F6E644C6173744C696E653D3D3D652E7363726F6C6C4265796F6E644C6173744C696E652626746869732E70616464696E67546F70';
wwv_flow_imp.g_varchar2_table(15925) := '3D3D3D652E70616464696E67546F702626746869732E70616464696E67426F74746F6D3D3D3D652E70616464696E67426F74746F6D2626746869732E73686F77536C696465723D3D3D652E73686F77536C696465722626746869732E6175746F68696465';
wwv_flow_imp.g_varchar2_table(15926) := '3D3D3D652E6175746F686964652626746869732E706978656C526174696F3D3D3D652E706978656C526174696F2626746869732E7479706963616C48616C66776964746843686172616374657257696474683D3D3D652E7479706963616C48616C667769';
wwv_flow_imp.g_varchar2_table(15927) := '64746843686172616374657257696474682626746869732E6C696E654865696768743D3D3D652E6C696E654865696768742626746869732E6D696E696D61704C6566743D3D3D652E6D696E696D61704C6566742626746869732E6D696E696D6170576964';
wwv_flow_imp.g_varchar2_table(15928) := '74683D3D3D652E6D696E696D617057696474682626746869732E6D696E696D61704865696768743D3D3D652E6D696E696D61704865696768742626746869732E63616E766173496E6E657257696474683D3D3D652E63616E766173496E6E657257696474';
wwv_flow_imp.g_varchar2_table(15929) := '682626746869732E63616E766173496E6E65724865696768743D3D3D652E63616E766173496E6E65724865696768742626746869732E63616E7661734F7574657257696474683D3D3D652E63616E7661734F7574657257696474682626746869732E6361';
wwv_flow_imp.g_varchar2_table(15930) := '6E7661734F757465724865696768743D3D3D652E63616E7661734F757465724865696768742626746869732E697353616D706C696E673D3D3D652E697353616D706C696E672626746869732E656469746F724865696768743D3D3D652E656469746F7248';
wwv_flow_imp.g_varchar2_table(15931) := '65696768742626746869732E666F6E745363616C653D3D3D652E666F6E745363616C652626746869732E6D696E696D61704C696E654865696768743D3D3D652E6D696E696D61704C696E654865696768742626746869732E6D696E696D61704368617257';
wwv_flow_imp.g_varchar2_table(15932) := '696474683D3D3D652E6D696E696D61704368617257696474682626746869732E73656374696F6E486561646572466F6E7453697A653D3D3D652E73656374696F6E486561646572466F6E7453697A652626746869732E64656661756C744261636B67726F';
wwv_flow_imp.g_varchar2_table(15933) := '756E64436F6C6F722626746869732E64656661756C744261636B67726F756E64436F6C6F722E657175616C7328652E64656661756C744261636B67726F756E64436F6C6F72292626746869732E6261636B67726F756E64436F6C6F722626746869732E62';
wwv_flow_imp.g_varchar2_table(15934) := '61636B67726F756E64436F6C6F722E657175616C7328652E6261636B67726F756E64436F6C6F72292626746869732E666F726567726F756E64416C7068613D3D3D652E666F726567726F756E64416C7068617D7D636C61737320464F7B636F6E73747275';
wwv_flow_imp.g_varchar2_table(15935) := '63746F7228652C742C6E2C692C6F2C732C722C612C6C297B746869732E7363726F6C6C546F703D652C746869732E7363726F6C6C4865696768743D742C746869732E736C696465724E65656465643D6E2C746869732E5F636F6D7075746564536C696465';
wwv_flow_imp.g_varchar2_table(15936) := '72526174696F3D692C746869732E736C69646572546F703D6F2C746869732E736C696465724865696768743D732C746869732E746F7050616464696E674C696E65436F756E743D722C746869732E73746172744C696E654E756D6265723D612C74686973';
wwv_flow_imp.g_varchar2_table(15937) := '2E656E644C696E654E756D6265723D6C7D676574446573697265645363726F6C6C546F7046726F6D44656C74612865297B72657475726E204D6174682E726F756E6428746869732E7363726F6C6C546F702B652F746869732E5F636F6D7075746564536C';
wwv_flow_imp.g_varchar2_table(15938) := '69646572526174696F297D676574446573697265645363726F6C6C546F7046726F6D546F7563684C6F636174696F6E2865297B72657475726E204D6174682E726F756E642828652D746869732E736C696465724865696768742F32292F746869732E5F63';
wwv_flow_imp.g_varchar2_table(15939) := '6F6D7075746564536C69646572526174696F297D696E746572736563745769746856696577706F72742865297B636F6E737420743D4D6174682E6D617828746869732E73746172744C696E654E756D6265722C652E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(15940) := '292C6E3D4D6174682E6D696E28746869732E656E644C696E654E756D6265722C652E656E644C696E654E756D626572293B72657475726E20743E6E3F6E756C6C3A5B742C6E5D7D67657459466F724C696E654E756D62657228652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(15941) := '2B28652D746869732E73746172744C696E654E756D6265722B746869732E746F7050616464696E674C696E65436F756E74292A747D7374617469632063726561746528652C742C6E2C692C6F2C732C722C612C6C2C632C64297B636F6E737420683D652E';
wwv_flow_imp.g_varchar2_table(15942) := '706978656C526174696F2C753D652E6D696E696D61704C696E654865696768742C703D4D6174682E666C6F6F7228652E63616E766173496E6E65724865696768742F75292C673D652E6C696E654865696768743B696628652E6D696E696D617048656967';
wwv_flow_imp.g_varchar2_table(15943) := '68744973456469746F72486569676874297B6C657420743D612A652E6C696E654865696768742B652E70616464696E67546F702B652E70616464696E67426F74746F6D3B652E7363726F6C6C4265796F6E644C6173744C696E65262628742B3D4D617468';
wwv_flow_imp.g_varchar2_table(15944) := '2E6D617828302C6F2D652E6C696E654865696768742D652E70616464696E67426F74746F6D29293B636F6E7374206E3D4D6174682E6D617828312C4D6174682E666C6F6F72286F2A6F2F7429292C693D4D6174682E6D617828302C652E6D696E696D6170';
wwv_flow_imp.g_varchar2_table(15945) := '4865696768742D6E292C733D692F28632D6F292C643D6C2A732C683D693E302C753D4D6174682E666C6F6F7228652E63616E766173496E6E65724865696768742F652E6D696E696D61704C696E65486569676874292C703D4D6174682E666C6F6F722865';
wwv_flow_imp.g_varchar2_table(15946) := '2E70616464696E67546F702F652E6C696E65486569676874293B72657475726E206E657720464F286C2C632C682C732C642C6E2C702C312C4D6174682E6D696E28722C7529297D6C6574206D3B6966287326266E213D3D72297B636F6E737420653D6E2D';
wwv_flow_imp.g_varchar2_table(15947) := '742B313B6D3D4D6174682E666C6F6F7228652A752F68297D656C73657B636F6E737420653D6F2F673B6D3D4D6174682E666C6F6F7228652A752F68297D636F6E737420663D4D6174682E666C6F6F7228652E70616464696E67546F702F67293B6C657420';
wwv_flow_imp.g_varchar2_table(15948) := '762C623D4D6174682E666C6F6F7228652E70616464696E67426F74746F6D2F67293B696628652E7363726F6C6C4265796F6E644C6173744C696E65297B636F6E737420653D6F2F673B623D4D6174682E6D617828622C652D31297D763D623E303F28662B';
wwv_flow_imp.g_varchar2_table(15949) := '722B622D6F2F672D31292A752F683A4D6174682E6D617828302C28662B72292A752F682D6D292C763D4D6174682E6D696E28652E6D696E696D61704865696768742D6D2C76293B636F6E7374205F3D762F28632D6F292C793D6C2A5F3B696628703E3D66';
wwv_flow_imp.g_varchar2_table(15950) := '2B722B622972657475726E206E657720464F286C2C632C763E302C5F2C792C6D2C662C312C72293B7B6C6574206E2C6F3B6E3D743E313F742B663A4D6174682E6D617828312C6C2F67293B6C657420733D4D6174682E6D617828312C4D6174682E666C6F';
wwv_flow_imp.g_varchar2_table(15951) := '6F72286E2D792A682F7529293B733C663F286F3D662D732B312C733D31293A286F3D302C733D4D6174682E6D617828312C732D6629292C642626642E7363726F6C6C4865696768743D3D3D63262628642E7363726F6C6C546F703E6C262628733D4D6174';
wwv_flow_imp.g_varchar2_table(15952) := '682E6D696E28732C642E73746172744C696E654E756D626572292C6F3D4D6174682E6D6178286F2C642E746F7050616464696E674C696E65436F756E7429292C642E7363726F6C6C546F703C6C262628733D4D6174682E6D617828732C642E7374617274';
wwv_flow_imp.g_varchar2_table(15953) := '4C696E654E756D626572292C6F3D4D6174682E6D696E286F2C642E746F7050616464696E674C696E65436F756E742929293B636F6E737420613D4D6174682E6D696E28722C732D6F2B702D31292C763D286C2D69292F673B6C657420623B72657475726E';
wwv_flow_imp.g_varchar2_table(15954) := '20623D6C3E3D652E70616464696E67546F703F28742D732B6F2B76292A752F683A6C2F652E70616464696E67546F702A286F2B76292A752F682C6E657720464F286C2C632C21302C5F2C622C6D2C6F2C732C61297D7D7D636C61737320424F7B636F6E73';
wwv_flow_imp.g_varchar2_table(15955) := '74727563746F722865297B746869732E64793D657D6F6E436F6E74656E744368616E67656428297B746869732E64793D2D317D6F6E546F6B656E734368616E67656428297B746869732E64793D2D317D7D424F2E494E56414C49443D6E657720424F282D';
wwv_flow_imp.g_varchar2_table(15956) := '31293B636C61737320564F7B636F6E7374727563746F7228652C742C6E297B746869732E72656E64657265644C61796F75743D652C746869732E5F696D616765446174613D742C746869732E5F72656E64657265644C696E65733D6E6577206250282828';
wwv_flow_imp.g_varchar2_table(15957) := '293D3E424F2E494E56414C494429292C746869732E5F72656E64657265644C696E65732E5F73657428652E73746172744C696E654E756D6265722C6E297D6C696E6573457175616C732865297B69662821746869732E7363726F6C6C457175616C732865';
wwv_flow_imp.g_varchar2_table(15958) := '292972657475726E21313B636F6E737420743D746869732E5F72656E64657265644C696E65732E5F67657428292E6C696E65733B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B296966282D313D3D3D745B655D2E64792972';
wwv_flow_imp.g_varchar2_table(15959) := '657475726E21313B72657475726E21307D7363726F6C6C457175616C732865297B72657475726E20746869732E72656E64657265644C61796F75742E73746172744C696E654E756D6265723D3D3D652E73746172744C696E654E756D6265722626746869';
wwv_flow_imp.g_varchar2_table(15960) := '732E72656E64657265644C61796F75742E656E644C696E654E756D6265723D3D3D652E656E644C696E654E756D6265727D5F67657428297B636F6E737420653D746869732E5F72656E64657265644C696E65732E5F67657428293B72657475726E7B696D';
wwv_flow_imp.g_varchar2_table(15961) := '616765446174613A746869732E5F696D616765446174612C72656E644C696E654E756D62657253746172743A652E72656E644C696E654E756D62657253746172742C6C696E65733A652E6C696E65737D7D6F6E4C696E65734368616E67656428652C7429';
wwv_flow_imp.g_varchar2_table(15962) := '7B72657475726E20746869732E5F72656E64657265644C696E65732E6F6E4C696E65734368616E67656428652C74297D6F6E4C696E657344656C6574656428652C74297B746869732E5F72656E64657265644C696E65732E6F6E4C696E657344656C6574';
wwv_flow_imp.g_varchar2_table(15963) := '656428652C74297D6F6E4C696E6573496E73657274656428652C74297B746869732E5F72656E64657265644C696E65732E6F6E4C696E6573496E73657274656428652C74297D6F6E546F6B656E734368616E6765642865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(15964) := '2E5F72656E64657265644C696E65732E6F6E546F6B656E734368616E6765642865297D7D636C617373207A4F7B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F6261636B67726F756E6446696C6C446174613D7A4F2E5F6372656174';
wwv_flow_imp.g_varchar2_table(15965) := '654261636B67726F756E6446696C6C4461746128742C6E2C69292C746869732E5F627566666572733D5B652E637265617465496D6167654461746128742C6E292C652E637265617465496D6167654461746128742C6E295D2C746869732E5F6C61737455';
wwv_flow_imp.g_varchar2_table(15966) := '7365644275666665723D307D67657442756666657228297B746869732E5F6C617374557365644275666665723D312D746869732E5F6C617374557365644275666665723B636F6E737420653D746869732E5F627566666572735B746869732E5F6C617374';
wwv_flow_imp.g_varchar2_table(15967) := '557365644275666665725D3B72657475726E20652E646174612E73657428746869732E5F6261636B67726F756E6446696C6C44617461292C657D737461746963205F6372656174654261636B67726F756E6446696C6C4461746128652C742C6E297B636F';
wwv_flow_imp.g_varchar2_table(15968) := '6E737420693D6E2E722C6F3D6E2E672C733D6E2E622C723D6E2E612C613D6E65772055696E7438436C616D706564417272617928652A742A34293B6C6574206C3D303B666F72286C6574206E3D303B6E3C743B6E2B2B29666F72286C657420743D303B74';
wwv_flow_imp.g_varchar2_table(15969) := '3C653B742B2B29615B6C5D3D692C615B6C2B315D3D6F2C615B6C2B325D3D732C615B6C2B335D3D722C6C2B3D343B72657475726E20617D7D636C61737320484F7B73746174696320636F6D7075746528652C742C6E297B696628303D3D3D652E72656E64';
wwv_flow_imp.g_varchar2_table(15970) := '65724D696E696D61707C7C21652E697353616D706C696E672972657475726E5B6E756C6C2C5B5D5D3B636F6E73747B6D696E696D61704C696E65436F756E743A697D3D4F4C2E636F6D70757465436F6E7461696E65644D696E696D61704C696E65436F75';
wwv_flow_imp.g_varchar2_table(15971) := '6E74287B766965774C696E65436F756E743A742C7363726F6C6C4265796F6E644C6173744C696E653A652E7363726F6C6C4265796F6E644C6173744C696E652C70616464696E67546F703A652E70616464696E67546F702C70616464696E67426F74746F';
wwv_flow_imp.g_varchar2_table(15972) := '6D3A652E70616464696E67426F74746F6D2C6865696768743A652E656469746F724865696768742C6C696E654865696768743A652E6C696E654865696768742C706978656C526174696F3A652E706978656C526174696F7D292C6F3D742F692C733D6F2F';
wwv_flow_imp.g_varchar2_table(15973) := '323B696628216E7C7C303D3D3D6E2E6D696E696D61704C696E65732E6C656E677468297B636F6E737420653D5B5D3B696628655B305D3D312C693E31297B666F72286C657420743D302C6E3D692D313B743C6E3B742B2B29655B745D3D4D6174682E726F';
wwv_flow_imp.g_varchar2_table(15974) := '756E6428742A6F2B73293B655B692D315D3D747D72657475726E5B6E657720484F286F2C65292C5B5D5D7D636F6E737420723D6E2E6D696E696D61704C696E65732C613D722E6C656E6774682C6C3D5B5D3B6C657420633D302C643D302C683D312C753D';
wwv_flow_imp.g_varchar2_table(15975) := '5B5D2C703D6E756C6C3B666F72286C657420653D303B653C693B652B2B297B636F6E7374206E3D4D6174682E6D617828682C4D6174682E726F756E6428652A6F29292C673D4D6174682E6D6178286E2C4D6174682E726F756E642828652B31292A6F2929';
wwv_flow_imp.g_varchar2_table(15976) := '3B666F72283B633C612626725B635D3C6E3B297B696628752E6C656E6774683C3130297B636F6E737420653D632B312B643B7026262264656C65746564223D3D3D702E747970652626702E5F6F6C64496E6465783D3D3D632D313F702E64656C65746554';
wwv_flow_imp.g_varchar2_table(15977) := '6F4C696E654E756D6265722B2B3A28703D7B747970653A2264656C65746564222C5F6F6C64496E6465783A632C64656C65746546726F6D4C696E654E756D6265723A652C64656C657465546F4C696E654E756D6265723A657D2C752E7075736828702929';
wwv_flow_imp.g_varchar2_table(15978) := '2C642D2D7D632B2B7D6C6574206D3B696628633C612626725B635D3C3D67296D3D725B635D2C632B2B3B656C7365206966286D3D303D3D3D653F313A652B313D3D3D693F743A4D6174682E726F756E6428652A6F2B73292C752E6C656E6774683C313029';
wwv_flow_imp.g_varchar2_table(15979) := '7B636F6E737420743D632B312B643B70262622696E736572746564223D3D3D702E747970652626702E5F693D3D3D652D313F702E696E73657274546F4C696E654E756D6265722B2B3A28703D7B747970653A22696E736572746564222C5F693A652C696E';
wwv_flow_imp.g_varchar2_table(15980) := '7365727446726F6D4C696E654E756D6265723A742C696E73657274546F4C696E654E756D6265723A747D2C752E70757368287029292C642B2B7D6C5B655D3D6D2C683D6D7D696628752E6C656E6774683C313029666F72283B633C613B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(15981) := '20653D632B312B643B7026262264656C65746564223D3D3D702E747970652626702E5F6F6C64496E6465783D3D3D632D313F702E64656C657465546F4C696E654E756D6265722B2B3A28703D7B747970653A2264656C65746564222C5F6F6C64496E6465';
wwv_flow_imp.g_varchar2_table(15982) := '783A632C64656C65746546726F6D4C696E654E756D6265723A652C64656C657465546F4C696E654E756D6265723A657D2C752E70757368287029292C642D2D2C632B2B7D656C736520753D5B7B747970653A22666C757368227D5D3B72657475726E5B6E';
wwv_flow_imp.g_varchar2_table(15983) := '657720484F286F2C6C292C755D7D636F6E7374727563746F7228652C74297B746869732E73616D706C696E67526174696F3D652C746869732E6D696E696D61704C696E65733D747D6D6F64656C4C696E65546F4D696E696D61704C696E652865297B7265';
wwv_flow_imp.g_varchar2_table(15984) := '7475726E204D6174682E6D696E28746869732E6D696E696D61704C696E65732E6C656E6774682C4D6174682E6D617828312C4D6174682E726F756E6428652F746869732E73616D706C696E67526174696F2929297D6D6F64656C4C696E6552616E676554';
wwv_flow_imp.g_varchar2_table(15985) := '6F4D696E696D61704C696E6552616E676528652C74297B6C6574206E3D746869732E6D6F64656C4C696E65546F4D696E696D61704C696E652865292D313B666F72283B6E3E302626746869732E6D696E696D61704C696E65735B6E2D315D3E3D653B296E';
wwv_flow_imp.g_varchar2_table(15986) := '2D2D3B6C657420693D746869732E6D6F64656C4C696E65546F4D696E696D61704C696E652874292D313B666F72283B692B313C746869732E6D696E696D61704C696E65732E6C656E6774682626746869732E6D696E696D61704C696E65735B692B315D3C';
wwv_flow_imp.g_varchar2_table(15987) := '3D743B29692B2B3B6966286E3D3D3D69297B636F6E737420693D746869732E6D696E696D61704C696E65735B6E5D3B696628693C657C7C693E742972657475726E206E756C6C7D72657475726E5B6E2B312C692B315D7D6465636F726174696F6E4C696E';
wwv_flow_imp.g_varchar2_table(15988) := '6552616E6765546F4D696E696D61704C696E6552616E676528652C74297B6C6574206E3D746869732E6D6F64656C4C696E65546F4D696E696D61704C696E652865292C693D746869732E6D6F64656C4C696E65546F4D696E696D61704C696E652874293B';
wwv_flow_imp.g_varchar2_table(15989) := '72657475726E2065213D3D742626693D3D3D6E262628693D3D3D746869732E6D696E696D61704C696E65732E6C656E6774683F6E3E3126266E2D2D3A692B2B292C5B6E2C695D7D6F6E4C696E657344656C657465642865297B636F6E737420743D652E74';
wwv_flow_imp.g_varchar2_table(15990) := '6F4C696E654E756D6265722D652E66726F6D4C696E654E756D6265722B313B6C6574206E3D746869732E6D696E696D61704C696E65732E6C656E6774682C693D303B666F72286C6574206F3D746869732E6D696E696D61704C696E65732E6C656E677468';
wwv_flow_imp.g_varchar2_table(15991) := '2D313B6F3E3D3026262128746869732E6D696E696D61704C696E65735B6F5D3C652E66726F6D4C696E654E756D626572293B6F2D2D29746869732E6D696E696D61704C696E65735B6F5D3C3D652E746F4C696E654E756D6265723F28746869732E6D696E';
wwv_flow_imp.g_varchar2_table(15992) := '696D61704C696E65735B6F5D3D4D6174682E6D617828312C652E66726F6D4C696E654E756D6265722D31292C6E3D4D6174682E6D696E286E2C6F292C693D4D6174682E6D617828692C6F29293A746869732E6D696E696D61704C696E65735B6F5D2D3D74';
wwv_flow_imp.g_varchar2_table(15993) := '3B72657475726E5B6E2C695D7D6F6E4C696E6573496E7365727465642865297B636F6E737420743D652E746F4C696E654E756D6265722D652E66726F6D4C696E654E756D6265722B313B666F72286C6574206E3D746869732E6D696E696D61704C696E65';
wwv_flow_imp.g_varchar2_table(15994) := '732E6C656E6774682D313B6E3E3D3026262128746869732E6D696E696D61704C696E65735B6E5D3C652E66726F6D4C696E654E756D626572293B6E2D2D29746869732E6D696E696D61704C696E65735B6E5D2B3D747D7D636C61737320574F2065787465';
wwv_flow_imp.g_varchar2_table(15995) := '6E6473204A417B636F6E7374727563746F722865297B73757065722865292C746869732E5F73656374696F6E48656164657243616368653D6E65772061612831302C312E35292C746869732E746F6B656E73436F6C6F72547261636B65723D794F2E6765';
wwv_flow_imp.g_varchar2_table(15996) := '74496E7374616E636528292C746869732E5F73656C656374696F6E733D5B5D2C746869732E5F6D696E696D617053656C656374696F6E733D6E756C6C2C746869732E6F7074696F6E733D6E657720524F28746869732E5F636F6E746578742E636F6E6669';
wwv_flow_imp.g_varchar2_table(15997) := '6775726174696F6E2C746869732E5F636F6E746578742E7468656D652C746869732E746F6B656E73436F6C6F72547261636B6572293B636F6E73745B745D3D484F2E636F6D7075746528746869732E6F7074696F6E732C746869732E5F636F6E74657874';
wwv_flow_imp.g_varchar2_table(15998) := '2E766965774D6F64656C2E6765744C696E65436F756E7428292C6E756C6C293B746869732E5F73616D706C696E6753746174653D742C746869732E5F73686F756C64436865636B53616D706C696E673D21312C746869732E5F61637475616C3D6E657720';
wwv_flow_imp.g_varchar2_table(15999) := '6A4F28652E7468656D652C74686973297D646973706F736528297B746869732E5F61637475616C2E646973706F736528292C73757065722E646973706F736528297D676574446F6D4E6F646528297B72657475726E20746869732E5F61637475616C2E67';
wwv_flow_imp.g_varchar2_table(16000) := '6574446F6D4E6F646528297D5F6F6E4F7074696F6E734D617962654368616E67656428297B636F6E737420653D6E657720524F28746869732E5F636F6E746578742E636F6E66696775726174696F6E2C746869732E5F636F6E746578742E7468656D652C';
wwv_flow_imp.g_varchar2_table(16001) := '746869732E746F6B656E73436F6C6F72547261636B6572293B72657475726E21746869732E6F7074696F6E732E657175616C73286529262628746869732E6F7074696F6E733D652C746869732E5F72656372656174654C696E6553616D706C696E672829';
wwv_flow_imp.g_varchar2_table(16002) := '2C746869732E5F61637475616C2E6F6E4469644368616E67654F7074696F6E7328292C2130297D6F6E436F6E66696775726174696F6E4368616E6765642865297B72657475726E20746869732E5F6F6E4F7074696F6E734D617962654368616E67656428';
wwv_flow_imp.g_varchar2_table(16003) := '297D6F6E437572736F7253746174654368616E6765642865297B72657475726E20746869732E5F73656C656374696F6E733D652E73656C656374696F6E732C746869732E5F6D696E696D617053656C656374696F6E733D6E756C6C2C746869732E5F6163';
wwv_flow_imp.g_varchar2_table(16004) := '7475616C2E6F6E53656C656374696F6E4368616E67656428297D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E2121652E616666656374734D696E696D61702626746869732E5F61637475616C2E6F6E4465636F726174696F';
wwv_flow_imp.g_varchar2_table(16005) := '6E734368616E67656428297D6F6E466C75736865642865297B72657475726E20746869732E5F73616D706C696E675374617465262628746869732E5F73686F756C64436865636B53616D706C696E673D2130292C746869732E5F61637475616C2E6F6E46';
wwv_flow_imp.g_varchar2_table(16006) := '6C757368656428297D6F6E4C696E65734368616E6765642865297B696628746869732E5F73616D706C696E675374617465297B636F6E737420743D746869732E5F73616D706C696E6753746174652E6D6F64656C4C696E6552616E6765546F4D696E696D';
wwv_flow_imp.g_varchar2_table(16007) := '61704C696E6552616E676528652E66726F6D4C696E654E756D6265722C652E66726F6D4C696E654E756D6265722B652E636F756E742D31293B72657475726E2121742626746869732E5F61637475616C2E6F6E4C696E65734368616E67656428745B305D';
wwv_flow_imp.g_varchar2_table(16008) := '2C745B315D2D745B305D2B31297D72657475726E20746869732E5F61637475616C2E6F6E4C696E65734368616E67656428652E66726F6D4C696E654E756D6265722C652E636F756E74297D6F6E4C696E657344656C657465642865297B69662874686973';
wwv_flow_imp.g_varchar2_table(16009) := '2E5F73616D706C696E675374617465297B636F6E73745B742C6E5D3D746869732E5F73616D706C696E6753746174652E6F6E4C696E657344656C657465642865293B72657475726E20743C3D6E2626746869732E5F61637475616C2E6F6E4C696E657343';
wwv_flow_imp.g_varchar2_table(16010) := '68616E67656428742B312C6E2D742B31292C746869732E5F73686F756C64436865636B53616D706C696E673D21302C21307D72657475726E20746869732E5F61637475616C2E6F6E4C696E657344656C6574656428652E66726F6D4C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(16011) := '722C652E746F4C696E654E756D626572297D6F6E4C696E6573496E7365727465642865297B72657475726E20746869732E5F73616D706C696E6753746174653F28746869732E5F73616D706C696E6753746174652E6F6E4C696E6573496E736572746564';
wwv_flow_imp.g_varchar2_table(16012) := '2865292C746869732E5F73686F756C64436865636B53616D706C696E673D21302C2130293A746869732E5F61637475616C2E6F6E4C696E6573496E73657274656428652E66726F6D4C696E654E756D6265722C652E746F4C696E654E756D626572297D6F';
wwv_flow_imp.g_varchar2_table(16013) := '6E5363726F6C6C4368616E6765642865297B72657475726E20746869732E5F61637475616C2E6F6E5363726F6C6C4368616E67656428297D6F6E5468656D654368616E6765642865297B72657475726E20746869732E5F61637475616C2E6F6E5468656D';
wwv_flow_imp.g_varchar2_table(16014) := '654368616E67656428292C746869732E5F6F6E4F7074696F6E734D617962654368616E67656428292C21307D6F6E546F6B656E734368616E6765642865297B696628746869732E5F73616D706C696E675374617465297B636F6E737420743D5B5D3B666F';
wwv_flow_imp.g_varchar2_table(16015) := '7228636F6E7374206E206F6620652E72616E676573297B636F6E737420653D746869732E5F73616D706C696E6753746174652E6D6F64656C4C696E6552616E6765546F4D696E696D61704C696E6552616E6765286E2E66726F6D4C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(16016) := '2C6E2E746F4C696E654E756D626572293B652626742E70757368287B66726F6D4C696E654E756D6265723A655B305D2C746F4C696E654E756D6265723A655B315D7D297D72657475726E2121742E6C656E6774682626746869732E5F61637475616C2E6F';
wwv_flow_imp.g_varchar2_table(16017) := '6E546F6B656E734368616E6765642874297D72657475726E20746869732E5F61637475616C2E6F6E546F6B656E734368616E67656428652E72616E676573297D6F6E546F6B656E73436F6C6F72734368616E6765642865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(16018) := '2E5F6F6E4F7074696F6E734D617962654368616E67656428292C746869732E5F61637475616C2E6F6E546F6B656E73436F6C6F72734368616E67656428297D6F6E5A6F6E65734368616E6765642865297B72657475726E20746869732E5F61637475616C';
wwv_flow_imp.g_varchar2_table(16019) := '2E6F6E5A6F6E65734368616E67656428297D7072657061726552656E6465722865297B746869732E5F73686F756C64436865636B53616D706C696E67262628746869732E5F73686F756C64436865636B53616D706C696E673D21312C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(16020) := '6372656174654C696E6553616D706C696E672829297D72656E6465722865297B6C657420743D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C6E3D652E76697369626C6552616E67652E656E644C696E654E756D6265723B';
wwv_flow_imp.g_varchar2_table(16021) := '746869732E5F73616D706C696E675374617465262628743D746869732E5F73616D706C696E6753746174652E6D6F64656C4C696E65546F4D696E696D61704C696E652874292C6E3D746869732E5F73616D706C696E6753746174652E6D6F64656C4C696E';
wwv_flow_imp.g_varchar2_table(16022) := '65546F4D696E696D61704C696E65286E29293B636F6E737420693D7B76696577706F7274436F6E7461696E7357686974657370616365476170733A652E76696577706F7274446174612E7768697465737061636556696577706F7274446174612E6C656E';
wwv_flow_imp.g_varchar2_table(16023) := '6774683E302C7363726F6C6C57696474683A652E7363726F6C6C57696474682C7363726F6C6C4865696768743A652E7363726F6C6C4865696768742C76696577706F727453746172744C696E654E756D6265723A742C76696577706F7274456E644C696E';
wwv_flow_imp.g_varchar2_table(16024) := '654E756D6265723A6E2C76696577706F727453746172744C696E654E756D626572566572746963616C4F66667365743A652E676574566572746963616C4F6666736574466F724C696E654E756D6265722874292C7363726F6C6C546F703A652E7363726F';
wwv_flow_imp.g_varchar2_table(16025) := '6C6C546F702C7363726F6C6C4C6566743A652E7363726F6C6C4C6566742C76696577706F727457696474683A652E76696577706F727457696474682C76696577706F72744865696768743A652E76696577706F72744865696768747D3B746869732E5F61';
wwv_flow_imp.g_varchar2_table(16026) := '637475616C2E72656E6465722869297D5F72656372656174654C696E6553616D706C696E6728297B746869732E5F6D696E696D617053656C656374696F6E733D6E756C6C3B636F6E737420653D426F6F6C65616E28746869732E5F73616D706C696E6753';
wwv_flow_imp.g_varchar2_table(16027) := '74617465292C5B742C6E5D3D484F2E636F6D7075746528746869732E6F7074696F6E732C746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E7428292C746869732E5F73616D706C696E675374617465293B69662874';
wwv_flow_imp.g_varchar2_table(16028) := '6869732E5F73616D706C696E6753746174653D742C652626746869732E5F73616D706C696E67537461746529666F7228636F6E73742065206F66206E2973776974636828652E74797065297B636173652264656C65746564223A746869732E5F61637475';
wwv_flow_imp.g_varchar2_table(16029) := '616C2E6F6E4C696E657344656C6574656428652E64656C65746546726F6D4C696E654E756D6265722C652E64656C657465546F4C696E654E756D626572293B627265616B3B6361736522696E736572746564223A746869732E5F61637475616C2E6F6E4C';
wwv_flow_imp.g_varchar2_table(16030) := '696E6573496E73657274656428652E696E7365727446726F6D4C696E654E756D6265722C652E696E73657274546F4C696E654E756D626572293B627265616B3B6361736522666C757368223A746869732E5F61637475616C2E6F6E466C75736865642829';
wwv_flow_imp.g_varchar2_table(16031) := '7D7D6765744C696E65436F756E7428297B72657475726E20746869732E5F73616D706C696E6753746174653F746869732E5F73616D706C696E6753746174652E6D696E696D61704C696E65732E6C656E6774683A746869732E5F636F6E746578742E7669';
wwv_flow_imp.g_varchar2_table(16032) := '65774D6F64656C2E6765744C696E65436F756E7428297D6765745265616C4C696E65436F756E7428297B72657475726E20746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F756E7428297D6765744C696E65436F6E7465';
wwv_flow_imp.g_varchar2_table(16033) := '6E742865297B72657475726E20746869732E5F73616D706C696E6753746174653F746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F6E74656E7428746869732E5F73616D706C696E6753746174652E6D696E696D61704C';
wwv_flow_imp.g_varchar2_table(16034) := '696E65735B652D315D293A746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E65436F6E74656E742865297D6765744C696E654D6178436F6C756D6E2865297B72657475726E20746869732E5F73616D706C696E6753746174653F';
wwv_flow_imp.g_varchar2_table(16035) := '746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E28746869732E5F73616D706C696E6753746174652E6D696E696D61704C696E65735B652D315D293A746869732E5F636F6E746578742E766965774D6F';
wwv_flow_imp.g_varchar2_table(16036) := '64656C2E6765744C696E654D6178436F6C756D6E2865297D6765744D696E696D61704C696E657352656E646572696E674461746128652C742C6E297B696628746869732E5F73616D706C696E675374617465297B636F6E737420693D5B5D3B666F72286C';
wwv_flow_imp.g_varchar2_table(16037) := '6574206F3D302C733D742D652B313B6F3C733B6F2B2B296E5B6F5D3F695B6F5D3D746869732E5F636F6E746578742E766965774D6F64656C2E676574566965774C696E654461746128746869732E5F73616D706C696E6753746174652E6D696E696D6170';
wwv_flow_imp.g_varchar2_table(16038) := '4C696E65735B652B6F2D315D293A695B6F5D3D6E756C6C3B72657475726E20697D72657475726E20746869732E5F636F6E746578742E766965774D6F64656C2E6765744D696E696D61704C696E657352656E646572696E674461746128652C742C6E292E';
wwv_flow_imp.g_varchar2_table(16039) := '646174617D67657453656C656374696F6E7328297B6966286E756C6C3D3D3D746869732E5F6D696E696D617053656C656374696F6E7329696628746869732E5F73616D706C696E675374617465297B746869732E5F6D696E696D617053656C656374696F';
wwv_flow_imp.g_varchar2_table(16040) := '6E733D5B5D3B666F7228636F6E73742065206F6620746869732E5F73656C656374696F6E73297B636F6E73745B742C6E5D3D746869732E5F73616D706C696E6753746174652E6465636F726174696F6E4C696E6552616E6765546F4D696E696D61704C69';
wwv_flow_imp.g_varchar2_table(16041) := '6E6552616E676528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D626572293B746869732E5F6D696E696D617053656C656374696F6E732E70757368286E657720616828742C652E7374617274436F6C756D6E2C6E2C652E65';
wwv_flow_imp.g_varchar2_table(16042) := '6E64436F6C756D6E29297D7D656C736520746869732E5F6D696E696D617053656C656374696F6E733D746869732E5F73656C656374696F6E733B72657475726E20746869732E5F6D696E696D617053656C656374696F6E737D6765744D696E696D617044';
wwv_flow_imp.g_varchar2_table(16043) := '65636F726174696F6E73496E56696577706F727428652C74297B636F6E7374206E3D746869732E5F6765744D696E696D61704465636F726174696F6E73496E56696577706F727428652C74292E66696C7465722828653D3E7B76617220743B7265747572';
wwv_flow_imp.g_varchar2_table(16044) := '6E21286E756C6C3D3D3D28743D652E6F7074696F6E732E6D696E696D6170297C7C766F696420303D3D3D743F766F696420303A742E73656374696F6E4865616465725374796C65297D29293B696628746869732E5F73616D706C696E675374617465297B';
wwv_flow_imp.g_varchar2_table(16045) := '636F6E737420653D5B5D3B666F7228636F6E73742074206F66206E297B69662821742E6F7074696F6E732E6D696E696D617029636F6E74696E75653B636F6E7374206E3D742E72616E67652C693D746869732E5F73616D706C696E6753746174652E6D6F';
wwv_flow_imp.g_varchar2_table(16046) := '64656C4C696E65546F4D696E696D61704C696E65286E2E73746172744C696E654E756D626572292C6F3D746869732E5F73616D706C696E6753746174652E6D6F64656C4C696E65546F4D696E696D61704C696E65286E2E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(16047) := '293B652E70757368286E6577204C4F286E657720726828692C6E2E7374617274436F6C756D6E2C6F2C6E2E656E64436F6C756D6E292C742E6F7074696F6E7329297D72657475726E20657D72657475726E206E7D67657453656374696F6E486561646572';
wwv_flow_imp.g_varchar2_table(16048) := '4465636F726174696F6E73496E56696577706F727428652C74297B636F6E7374206E3D746869732E6F7074696F6E732E6D696E696D61704C696E654865696768742C693D746869732E6F7074696F6E732E73656374696F6E486561646572466F6E745369';
wwv_flow_imp.g_varchar2_table(16049) := '7A652F6E3B72657475726E20653D4D6174682E666C6F6F72284D6174682E6D617828312C652D6929292C746869732E5F6765744D696E696D61704465636F726174696F6E73496E56696577706F727428652C74292E66696C7465722828653D3E7B766172';
wwv_flow_imp.g_varchar2_table(16050) := '20743B72657475726E2121286E756C6C3D3D3D28743D652E6F7074696F6E732E6D696E696D6170297C7C766F696420303D3D3D743F766F696420303A742E73656374696F6E4865616465725374796C65297D29297D5F6765744D696E696D61704465636F';
wwv_flow_imp.g_varchar2_table(16051) := '726174696F6E73496E56696577706F727428652C74297B6C6574206E3B696628746869732E5F73616D706C696E675374617465297B636F6E737420693D746869732E5F73616D706C696E6753746174652E6D696E696D61704C696E65735B652D315D2C6F';
wwv_flow_imp.g_varchar2_table(16052) := '3D746869732E5F73616D706C696E6753746174652E6D696E696D61704C696E65735B742D315D3B6E3D6E657720726828692C312C6F2C746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E286F29297D65';
wwv_flow_imp.g_varchar2_table(16053) := '6C7365206E3D6E657720726828652C312C742C746869732E5F636F6E746578742E766965774D6F64656C2E6765744C696E654D6178436F6C756D6E287429293B72657475726E20746869732E5F636F6E746578742E766965774D6F64656C2E6765744D69';
wwv_flow_imp.g_varchar2_table(16054) := '6E696D61704465636F726174696F6E73496E52616E6765286E297D67657453656374696F6E4865616465725465787428652C74297B766172206E3B636F6E737420693D6E756C6C3D3D3D286E3D652E6F7074696F6E732E6D696E696D6170297C7C766F69';
wwv_flow_imp.g_varchar2_table(16055) := '6420303D3D3D6E3F766F696420303A6E2E73656374696F6E486561646572546578743B69662821692972657475726E206E756C6C3B636F6E7374206F3D746869732E5F73656374696F6E48656164657243616368652E6765742869293B6966286F297265';
wwv_flow_imp.g_varchar2_table(16056) := '7475726E206F3B636F6E737420733D742869293B72657475726E20746869732E5F73656374696F6E48656164657243616368652E73657428692C73292C737D6765744F7074696F6E7328297B72657475726E20746869732E5F636F6E746578742E766965';
wwv_flow_imp.g_varchar2_table(16057) := '774D6F64656C2E6D6F64656C2E6765744F7074696F6E7328297D72657665616C4C696E654E756D6265722865297B746869732E5F73616D706C696E675374617465262628653D746869732E5F73616D706C696E6753746174652E6D696E696D61704C696E';
wwv_flow_imp.g_varchar2_table(16058) := '65735B652D315D292C746869732E5F636F6E746578742E766965774D6F64656C2E72657665616C52616E676528226D6F757365222C21312C6E657720726828652C312C652C31292C312C30297D7365745363726F6C6C546F702865297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(16059) := '6F6E746578742E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A657D2C31297D7D636C617373206A4F20657874656E6473206C747B636F6E7374727563746F7228652C7429';
wwv_flow_imp.g_varchar2_table(16060) := '7B737570657228292C746869732E5F72656E6465724465636F726174696F6E733D21312C746869732E5F67657374757265496E50726F67726573733D21312C746869732E5F7468656D653D652C746869732E5F6D6F64656C3D742C746869732E5F6C6173';
wwv_flow_imp.g_varchar2_table(16061) := '7452656E646572446174613D6E756C6C2C746869732E5F627566666572733D6E756C6C2C746869732E5F73656C656374696F6E436F6C6F723D746869732E5F7468656D652E676574436F6C6F72287476292C746869732E5F646F6D4E6F64653D73452864';
wwv_flow_imp.g_varchar2_table(16062) := '6F63756D656E742E637265617465456C656D656E7428226469762229292C654E2E777269746528746869732E5F646F6D4E6F64652C39292C746869732E5F646F6D4E6F64652E736574436C6173734E616D6528746869732E5F6765744D696E696D617044';
wwv_flow_imp.g_varchar2_table(16063) := '6F6D4E6F6465436C6173734E616D652829292C746869732E5F646F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C746869732E5F646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E7461';
wwv_flow_imp.g_varchar2_table(16064) := '74696F6E22292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F736861646F773D734528646F63756D656E742E637265617465456C656D656E74282264697622';
wwv_flow_imp.g_varchar2_table(16065) := '29292C746869732E5F736861646F772E736574436C6173734E616D6528226D696E696D61702D736861646F772D68696464656E22292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F736861646F77292C746869732E5F';
wwv_flow_imp.g_varchar2_table(16066) := '63616E7661733D734528646F63756D656E742E637265617465456C656D656E74282263616E7661732229292C746869732E5F63616E7661732E736574506F736974696F6E28226162736F6C75746522292C746869732E5F63616E7661732E7365744C6566';
wwv_flow_imp.g_varchar2_table(16067) := '742830292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F63616E766173292C746869732E5F6465636F726174696F6E7343616E7661733D734528646F63756D656E742E637265617465456C656D656E74282263616E76';
wwv_flow_imp.g_varchar2_table(16068) := '61732229292C746869732E5F6465636F726174696F6E7343616E7661732E736574506F736974696F6E28226162736F6C75746522292C746869732E5F6465636F726174696F6E7343616E7661732E736574436C6173734E616D6528226D696E696D61702D';
wwv_flow_imp.g_varchar2_table(16069) := '6465636F726174696F6E732D6C6179657222292C746869732E5F6465636F726174696F6E7343616E7661732E7365744C6566742830292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F6465636F726174696F6E734361';
wwv_flow_imp.g_varchar2_table(16070) := '6E766173292C746869732E5F736C696465723D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F736C696465722E736574506F736974696F6E28226162736F6C75746522292C746869732E5F736C6964';
wwv_flow_imp.g_varchar2_table(16071) := '65722E736574436C6173734E616D6528226D696E696D61702D736C6964657222292C746869732E5F736C696465722E7365744C6179657248696E74696E67282130292C746869732E5F736C696465722E736574436F6E7461696E28227374726963742229';
wwv_flow_imp.g_varchar2_table(16072) := '2C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F736C69646572292C746869732E5F736C69646572486F72697A6F6E74616C3D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C7468';
wwv_flow_imp.g_varchar2_table(16073) := '69732E5F736C69646572486F72697A6F6E74616C2E736574506F736974696F6E28226162736F6C75746522292C746869732E5F736C69646572486F72697A6F6E74616C2E736574436C6173734E616D6528226D696E696D61702D736C696465722D686F72';
wwv_flow_imp.g_varchar2_table(16074) := '697A6F6E74616C22292C746869732E5F736C696465722E617070656E644368696C6428746869732E5F736C69646572486F72697A6F6E74616C292C746869732E5F6170706C794C61796F757428292C746869732E5F706F696E746572446F776E4C697374';
wwv_flow_imp.g_varchar2_table(16075) := '656E65723D797328746869732E5F646F6D4E6F64652E646F6D4E6F64652C61722E504F494E5445525F444F574E2C28653D3E7B696628652E70726576656E7444656661756C7428292C303D3D3D746869732E5F6D6F64656C2E6F7074696F6E732E72656E';
wwv_flow_imp.g_varchar2_table(16076) := '6465724D696E696D61702972657475726E3B69662821746869732E5F6C61737452656E646572446174612972657475726E3B6966282270726F706F7274696F6E616C22213D3D746869732E5F6D6F64656C2E6F7074696F6E732E73697A65297B69662830';
wwv_flow_imp.g_varchar2_table(16077) := '3D3D3D652E627574746F6E2626746869732E5F6C61737452656E64657244617461297B636F6E737420743D417328746869732E5F736C696465722E646F6D4E6F6465292C6E3D742E746F702B742E6865696768742F323B746869732E5F7374617274536C';
wwv_flow_imp.g_varchar2_table(16078) := '696465724472616767696E6728652C6E2C746869732E5F6C61737452656E646572446174612E72656E64657265644C61796F7574297D72657475726E7D636F6E737420743D746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61704C696E65';
wwv_flow_imp.g_varchar2_table(16079) := '4865696768742C6E3D746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E65724865696768742F746869732E5F6D6F64656C2E6F7074696F6E732E63616E7661734F757465724865696768742A652E6F6666736574593B6C65742069';
wwv_flow_imp.g_varchar2_table(16080) := '3D4D6174682E666C6F6F72286E2F74292B746869732E5F6C61737452656E646572446174612E72656E64657265644C61796F75742E73746172744C696E654E756D6265722D746869732E5F6C61737452656E646572446174612E72656E64657265644C61';
wwv_flow_imp.g_varchar2_table(16081) := '796F75742E746F7050616464696E674C696E65436F756E743B693D4D6174682E6D696E28692C746869732E5F6D6F64656C2E6765744C696E65436F756E742829292C746869732E5F6D6F64656C2E72657665616C4C696E654E756D6265722869297D2929';
wwv_flow_imp.g_varchar2_table(16082) := '2C746869732E5F736C69646572506F696E7465724D6F76654D6F6E69746F723D6E6577204B442C746869732E5F736C69646572506F696E746572446F776E4C697374656E65723D797328746869732E5F736C696465722E646F6D4E6F64652C61722E504F';
wwv_flow_imp.g_varchar2_table(16083) := '494E5445525F444F574E2C28653D3E7B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C303D3D3D652E627574746F6E2626746869732E5F6C61737452656E646572446174612626746869732E5F737461';
wwv_flow_imp.g_varchar2_table(16084) := '7274536C696465724472616767696E6728652C652E70616765592C746869732E5F6C61737452656E646572446174612E72656E64657265644C61796F7574297D29292C746869732E5F67657374757265446973706F7361626C653D49452E616464546172';
wwv_flow_imp.g_varchar2_table(16085) := '67657428746869732E5F646F6D4E6F64652E646F6D4E6F6465292C746869732E5F736C69646572546F75636853746172744C697374656E65723D627328746869732E5F646F6D4E6F64652E646F6D4E6F64652C54452E53746172742C28653D3E7B652E70';
wwv_flow_imp.g_varchar2_table(16086) := '726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E5F6C61737452656E64657244617461262628746869732E5F736C696465722E746F67676C65436C6173734E616D652822616374697665222C213029';
wwv_flow_imp.g_varchar2_table(16087) := '2C746869732E5F67657374757265496E50726F67726573733D21302C746869732E7363726F6C6C447565546F546F7563684576656E74286529297D292C7B706173736976653A21317D292C746869732E5F736C69646572546F7563684D6F76654C697374';
wwv_flow_imp.g_varchar2_table(16088) := '656E65723D627328746869732E5F646F6D4E6F64652E646F6D4E6F64652C54452E4368616E67652C28653D3E7B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E5F6C61737452656E646572';
wwv_flow_imp.g_varchar2_table(16089) := '446174612626746869732E5F67657374757265496E50726F67726573732626746869732E7363726F6C6C447565546F546F7563684576656E742865297D292C7B706173736976653A21317D292C746869732E5F736C69646572546F756368456E644C6973';
wwv_flow_imp.g_varchar2_table(16090) := '74656E65723D797328746869732E5F646F6D4E6F64652E646F6D4E6F64652C54452E456E642C28653D3E7B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E5F67657374757265496E50726F';
wwv_flow_imp.g_varchar2_table(16091) := '67726573733D21312C746869732E5F736C696465722E746F67676C65436C6173734E616D652822616374697665222C2131297D29297D5F7374617274536C696465724472616767696E6728652C742C6E297B6966282128652E7461726765742626652E74';
wwv_flow_imp.g_varchar2_table(16092) := '617267657420696E7374616E63656F6620456C656D656E74292972657475726E3B636F6E737420693D652E70616765583B746869732E5F736C696465722E746F67676C65436C6173734E616D652822616374697665222C2130293B636F6E7374206F3D28';
wwv_flow_imp.g_varchar2_table(16093) := '652C6F293D3E7B636F6E737420733D417328746869732E5F646F6D4E6F64652E646F6D4E6F6465292C723D4D6174682E6D696E284D6174682E616273286F2D69292C4D6174682E616273286F2D732E6C656674292C4D6174682E616273286F2D732E6C65';
wwv_flow_imp.g_varchar2_table(16094) := '66742D732E776964746829293B6966286A2626723E3134302972657475726E20766F696420746869732E5F6D6F64656C2E7365745363726F6C6C546F70286E2E7363726F6C6C546F70293B636F6E737420613D652D743B746869732E5F6D6F64656C2E73';
wwv_flow_imp.g_varchar2_table(16095) := '65745363726F6C6C546F70286E2E676574446573697265645363726F6C6C546F7046726F6D44656C7461286129297D3B652E7061676559213D3D7426266F28652E70616765592C69292C746869732E5F736C69646572506F696E7465724D6F76654D6F6E';
wwv_flow_imp.g_varchar2_table(16096) := '69746F722E73746172744D6F6E69746F72696E6728652E7461726765742C652E706F696E74657249642C652E627574746F6E732C28653D3E6F28652E70616765592C652E706167655829292C2828293D3E7B746869732E5F736C696465722E746F67676C';
wwv_flow_imp.g_varchar2_table(16097) := '65436C6173734E616D652822616374697665222C2131297D29297D7363726F6C6C447565546F546F7563684576656E742865297B636F6E737420743D746869732E5F646F6D4E6F64652E646F6D4E6F64652E676574426F756E64696E67436C69656E7452';
wwv_flow_imp.g_varchar2_table(16098) := '65637428292E746F702C6E3D746869732E5F6C61737452656E646572446174612E72656E64657265644C61796F75742E676574446573697265645363726F6C6C546F7046726F6D546F7563684C6F636174696F6E28652E70616765592D74293B74686973';
wwv_flow_imp.g_varchar2_table(16099) := '2E5F6D6F64656C2E7365745363726F6C6C546F70286E297D646973706F736528297B746869732E5F706F696E746572446F776E4C697374656E65722E646973706F736528292C746869732E5F736C69646572506F696E7465724D6F76654D6F6E69746F72';
wwv_flow_imp.g_varchar2_table(16100) := '2E646973706F736528292C746869732E5F736C69646572506F696E746572446F776E4C697374656E65722E646973706F736528292C746869732E5F67657374757265446973706F7361626C652E646973706F736528292C746869732E5F736C6964657254';
wwv_flow_imp.g_varchar2_table(16101) := '6F75636853746172744C697374656E65722E646973706F736528292C746869732E5F736C69646572546F7563684D6F76654C697374656E65722E646973706F736528292C746869732E5F736C69646572546F756368456E644C697374656E65722E646973';
wwv_flow_imp.g_varchar2_table(16102) := '706F736528292C73757065722E646973706F736528297D5F6765744D696E696D6170446F6D4E6F6465436C6173734E616D6528297B636F6E737420653D5B226D696E696D6170225D3B72657475726E22616C77617973223D3D3D746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(16103) := '6C2E6F7074696F6E732E73686F77536C696465723F652E707573682822736C696465722D616C7761797322293A652E707573682822736C696465722D6D6F7573656F76657222292C746869732E5F6D6F64656C2E6F7074696F6E732E6175746F68696465';
wwv_flow_imp.g_varchar2_table(16104) := '2626652E7075736828226175746F6869646522292C652E6A6F696E28222022297D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D5F6170706C794C61796F757428297B746869732E5F646F6D4E6F64652E7365744C';
wwv_flow_imp.g_varchar2_table(16105) := '65667428746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61704C656674292C746869732E5F646F6D4E6F64652E736574576964746828746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61705769647468292C746869732E5F';
wwv_flow_imp.g_varchar2_table(16106) := '646F6D4E6F64652E73657448656967687428746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D6170486569676874292C746869732E5F736861646F772E73657448656967687428746869732E5F6D6F64656C2E6F7074696F6E732E6D696E69';
wwv_flow_imp.g_varchar2_table(16107) := '6D6170486569676874292C746869732E5F63616E7661732E736574576964746828746869732E5F6D6F64656C2E6F7074696F6E732E63616E7661734F757465725769647468292C746869732E5F63616E7661732E73657448656967687428746869732E5F';
wwv_flow_imp.g_varchar2_table(16108) := '6D6F64656C2E6F7074696F6E732E63616E7661734F75746572486569676874292C746869732E5F63616E7661732E646F6D4E6F64652E77696474683D746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E657257696474682C746869';
wwv_flow_imp.g_varchar2_table(16109) := '732E5F63616E7661732E646F6D4E6F64652E6865696768743D746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E65724865696768742C746869732E5F6465636F726174696F6E7343616E7661732E73657457696474682874686973';
wwv_flow_imp.g_varchar2_table(16110) := '2E5F6D6F64656C2E6F7074696F6E732E63616E7661734F757465725769647468292C746869732E5F6465636F726174696F6E7343616E7661732E73657448656967687428746869732E5F6D6F64656C2E6F7074696F6E732E63616E7661734F7574657248';
wwv_flow_imp.g_varchar2_table(16111) := '6569676874292C746869732E5F6465636F726174696F6E7343616E7661732E646F6D4E6F64652E77696474683D746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E657257696474682C746869732E5F6465636F726174696F6E7343';
wwv_flow_imp.g_varchar2_table(16112) := '616E7661732E646F6D4E6F64652E6865696768743D746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E65724865696768742C746869732E5F736C696465722E736574576964746828746869732E5F6D6F64656C2E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(16113) := '2E6D696E696D61705769647468297D5F67657442756666657228297B72657475726E20746869732E5F627566666572737C7C746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E657257696474683E302626746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(16114) := '6C2E6F7074696F6E732E63616E766173496E6E65724865696768743E30262628746869732E5F627566666572733D6E6577207A4F28746869732E5F63616E7661732E646F6D4E6F64652E676574436F6E746578742822326422292C746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(16115) := '656C2E6F7074696F6E732E63616E766173496E6E657257696474682C746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E65724865696768742C746869732E5F6D6F64656C2E6F7074696F6E732E6261636B67726F756E64436F6C6F';
wwv_flow_imp.g_varchar2_table(16116) := '7229292C746869732E5F627566666572733F746869732E5F627566666572732E67657442756666657228293A6E756C6C7D6F6E4469644368616E67654F7074696F6E7328297B746869732E5F6C61737452656E646572446174613D6E756C6C2C74686973';
wwv_flow_imp.g_varchar2_table(16117) := '2E5F627566666572733D6E756C6C2C746869732E5F6170706C794C61796F757428292C746869732E5F646F6D4E6F64652E736574436C6173734E616D6528746869732E5F6765744D696E696D6170446F6D4E6F6465436C6173734E616D652829297D6F6E';
wwv_flow_imp.g_varchar2_table(16118) := '53656C656374696F6E4368616E67656428297B72657475726E20746869732E5F72656E6465724465636F726174696F6E733D21302C21307D6F6E4465636F726174696F6E734368616E67656428297B72657475726E20746869732E5F72656E6465724465';
wwv_flow_imp.g_varchar2_table(16119) := '636F726174696F6E733D21302C21307D6F6E466C757368656428297B72657475726E20746869732E5F6C61737452656E646572446174613D6E756C6C2C21307D6F6E4C696E65734368616E67656428652C74297B72657475726E2121746869732E5F6C61';
wwv_flow_imp.g_varchar2_table(16120) := '737452656E646572446174612626746869732E5F6C61737452656E646572446174612E6F6E4C696E65734368616E67656428652C74297D6F6E4C696E657344656C6574656428652C74297B766172206E3B72657475726E206E756C6C3D3D3D286E3D7468';
wwv_flow_imp.g_varchar2_table(16121) := '69732E5F6C61737452656E64657244617461297C7C766F696420303D3D3D6E7C7C6E2E6F6E4C696E657344656C6574656428652C74292C21307D6F6E4C696E6573496E73657274656428652C74297B766172206E3B72657475726E206E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(16122) := '6E3D746869732E5F6C61737452656E64657244617461297C7C766F696420303D3D3D6E7C7C6E2E6F6E4C696E6573496E73657274656428652C74292C21307D6F6E5363726F6C6C4368616E67656428297B72657475726E20746869732E5F72656E646572';
wwv_flow_imp.g_varchar2_table(16123) := '4465636F726174696F6E733D21302C21307D6F6E5468656D654368616E67656428297B72657475726E20746869732E5F73656C656374696F6E436F6C6F723D746869732E5F7468656D652E676574436F6C6F72287476292C746869732E5F72656E646572';
wwv_flow_imp.g_varchar2_table(16124) := '4465636F726174696F6E733D21302C21307D6F6E546F6B656E734368616E6765642865297B72657475726E2121746869732E5F6C61737452656E646572446174612626746869732E5F6C61737452656E646572446174612E6F6E546F6B656E734368616E';
wwv_flow_imp.g_varchar2_table(16125) := '6765642865297D6F6E546F6B656E73436F6C6F72734368616E67656428297B72657475726E20746869732E5F6C61737452656E646572446174613D6E756C6C2C746869732E5F627566666572733D6E756C6C2C21307D6F6E5A6F6E65734368616E676564';
wwv_flow_imp.g_varchar2_table(16126) := '28297B72657475726E20746869732E5F6C61737452656E646572446174613D6E756C6C2C21307D72656E6465722865297B696628303D3D3D746869732E5F6D6F64656C2E6F7074696F6E732E72656E6465724D696E696D61702972657475726E20746869';
wwv_flow_imp.g_varchar2_table(16127) := '732E5F736861646F772E736574436C6173734E616D6528226D696E696D61702D736861646F772D68696464656E22292C746869732E5F736C69646572486F72697A6F6E74616C2E73657457696474682830292C766F696420746869732E5F736C69646572';
wwv_flow_imp.g_varchar2_table(16128) := '486F72697A6F6E74616C2E7365744865696768742830293B652E7363726F6C6C4C6566742B652E76696577706F727457696474683E3D652E7363726F6C6C57696474683F746869732E5F736861646F772E736574436C6173734E616D6528226D696E696D';
wwv_flow_imp.g_varchar2_table(16129) := '61702D736861646F772D68696464656E22293A746869732E5F736861646F772E736574436C6173734E616D6528226D696E696D61702D736861646F772D76697369626C6522293B636F6E737420743D464F2E63726561746528746869732E5F6D6F64656C';
wwv_flow_imp.g_varchar2_table(16130) := '2E6F7074696F6E732C652E76696577706F727453746172744C696E654E756D6265722C652E76696577706F7274456E644C696E654E756D6265722C652E76696577706F727453746172744C696E654E756D626572566572746963616C4F66667365742C65';
wwv_flow_imp.g_varchar2_table(16131) := '2E76696577706F72744865696768742C652E76696577706F7274436F6E7461696E7357686974657370616365476170732C746869732E5F6D6F64656C2E6765744C696E65436F756E7428292C746869732E5F6D6F64656C2E6765745265616C4C696E6543';
wwv_flow_imp.g_varchar2_table(16132) := '6F756E7428292C652E7363726F6C6C546F702C652E7363726F6C6C4865696768742C746869732E5F6C61737452656E646572446174613F746869732E5F6C61737452656E646572446174612E72656E64657265644C61796F75743A6E756C6C293B746869';
wwv_flow_imp.g_varchar2_table(16133) := '732E5F736C696465722E736574446973706C617928742E736C696465724E65656465643F22626C6F636B223A226E6F6E6522292C746869732E5F736C696465722E736574546F7028742E736C69646572546F70292C746869732E5F736C696465722E7365';
wwv_flow_imp.g_varchar2_table(16134) := '7448656967687428742E736C69646572486569676874292C746869732E5F736C69646572486F72697A6F6E74616C2E7365744C6566742830292C746869732E5F736C69646572486F72697A6F6E74616C2E736574576964746828746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(16135) := '6C2E6F7074696F6E732E6D696E696D61705769647468292C746869732E5F736C69646572486F72697A6F6E74616C2E736574546F702830292C746869732E5F736C69646572486F72697A6F6E74616C2E73657448656967687428742E736C696465724865';
wwv_flow_imp.g_varchar2_table(16136) := '69676874292C746869732E72656E6465724465636F726174696F6E732874292C746869732E5F6C61737452656E646572446174613D746869732E72656E6465724C696E65732874297D72656E6465724465636F726174696F6E732865297B696628746869';
wwv_flow_imp.g_varchar2_table(16137) := '732E5F72656E6465724465636F726174696F6E73297B746869732E5F72656E6465724465636F726174696F6E733D21313B636F6E737420743D746869732E5F6D6F64656C2E67657453656C656374696F6E7328293B742E736F72742872682E636F6D7061';
wwv_flow_imp.g_varchar2_table(16138) := '726552616E6765735573696E67537461727473293B636F6E7374206E3D746869732E5F6D6F64656C2E6765744D696E696D61704465636F726174696F6E73496E56696577706F727428652E73746172744C696E654E756D6265722C652E656E644C696E65';
wwv_flow_imp.g_varchar2_table(16139) := '4E756D626572293B6E2E736F7274282828652C74293D3E28652E6F7074696F6E732E7A496E6465787C7C30292D28742E6F7074696F6E732E7A496E6465787C7C302929293B636F6E73747B63616E766173496E6E657257696474683A692C63616E766173';
wwv_flow_imp.g_varchar2_table(16140) := '496E6E65724865696768743A6F7D3D746869732E5F6D6F64656C2E6F7074696F6E732C733D746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61704C696E654865696768742C723D746869732E5F6D6F64656C2E6F7074696F6E732E6D696E';
wwv_flow_imp.g_varchar2_table(16141) := '696D61704368617257696474682C613D746869732E5F6D6F64656C2E6765744F7074696F6E7328292E74616253697A652C6C3D746869732E5F6465636F726174696F6E7343616E7661732E646F6D4E6F64652E676574436F6E746578742822326422293B';
wwv_flow_imp.g_varchar2_table(16142) := '6C2E636C6561725265637428302C302C692C6F293B636F6E737420633D6E657720714F28652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722C2131293B746869732E5F72656E64657253656C656374696F6E4C696E6548';
wwv_flow_imp.g_varchar2_table(16143) := '6967686C6967687473286C2C742C632C652C73292C746869732E5F72656E6465724465636F726174696F6E734C696E65486967686C6967687473286C2C6E2C632C652C73293B636F6E737420643D6E657720714F28652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(16144) := '65722C652E656E644C696E654E756D6265722C6E756C6C293B746869732E5F72656E64657253656C656374696F6E73486967686C6967687473286C2C742C642C652C732C612C722C69292C746869732E5F72656E6465724465636F726174696F6E734869';
wwv_flow_imp.g_varchar2_table(16145) := '67686C6967687473286C2C6E2C642C652C732C612C722C69292C746869732E5F72656E64657253656374696F6E486561646572732865297D7D5F72656E64657253656C656374696F6E4C696E65486967686C696768747328652C742C6E2C692C6F297B69';
wwv_flow_imp.g_varchar2_table(16146) := '662821746869732E5F73656C656374696F6E436F6C6F727C7C746869732E5F73656C656374696F6E436F6C6F722E69735472616E73706172656E7428292972657475726E3B652E66696C6C5374796C653D746869732E5F73656C656374696F6E436F6C6F';
wwv_flow_imp.g_varchar2_table(16147) := '722E7472616E73706172656E74282E35292E746F537472696E6728293B6C657420733D302C723D303B666F7228636F6E73742061206F662074297B636F6E737420743D692E696E746572736563745769746856696577706F72742861293B696628217429';
wwv_flow_imp.g_varchar2_table(16148) := '636F6E74696E75653B636F6E73745B6C2C635D3D743B666F72286C657420653D6C3B653C3D633B652B2B296E2E73657428652C2130293B636F6E737420643D692E67657459466F724C696E654E756D626572286C2C6F292C683D692E67657459466F724C';
wwv_flow_imp.g_varchar2_table(16149) := '696E654E756D62657228632C6F293B723E3D647C7C28723E732626652E66696C6C5265637428382C732C652E63616E7661732E77696474682C722D73292C733D64292C723D687D723E732626652E66696C6C5265637428382C732C652E63616E7661732E';
wwv_flow_imp.g_varchar2_table(16150) := '77696474682C722D73297D5F72656E6465724465636F726174696F6E734C696E65486967686C696768747328652C742C6E2C692C6F297B636F6E737420733D6E6577204D61703B666F72286C657420723D742E6C656E6774682D313B723E3D303B722D2D';
wwv_flow_imp.g_varchar2_table(16151) := '297B636F6E737420613D745B725D2C6C3D612E6F7074696F6E732E6D696E696D61703B696628216C7C7C31213D3D6C2E706F736974696F6E29636F6E74696E75653B636F6E737420633D692E696E746572736563745769746856696577706F727428612E';
wwv_flow_imp.g_varchar2_table(16152) := '72616E6765293B696628216329636F6E74696E75653B636F6E73745B642C685D3D632C753D6C2E676574436F6C6F7228746869732E5F7468656D652E76616C7565293B69662821757C7C752E69735472616E73706172656E74282929636F6E74696E7565';
wwv_flow_imp.g_varchar2_table(16153) := '3B6C657420703D732E67657428752E746F537472696E672829293B707C7C28703D752E7472616E73706172656E74282E35292E746F537472696E6728292C732E73657428752E746F537472696E6728292C7029292C652E66696C6C5374796C653D703B66';
wwv_flow_imp.g_varchar2_table(16154) := '6F72286C657420743D643B743C3D683B742B2B297B6966286E2E68617328742929636F6E74696E75653B6E2E73657428742C2130293B636F6E737420733D692E67657459466F724C696E654E756D62657228642C6F293B652E66696C6C5265637428382C';
wwv_flow_imp.g_varchar2_table(16155) := '732C652E63616E7661732E77696474682C6F297D7D7D5F72656E64657253656C656374696F6E73486967686C696768747328652C742C6E2C692C6F2C732C722C61297B696628746869732E5F73656C656374696F6E436F6C6F72262621746869732E5F73';
wwv_flow_imp.g_varchar2_table(16156) := '656C656374696F6E436F6C6F722E69735472616E73706172656E74282929666F7228636F6E7374206C206F662074297B636F6E737420743D692E696E746572736563745769746856696577706F7274286C293B696628217429636F6E74696E75653B636F';
wwv_flow_imp.g_varchar2_table(16157) := '6E73745B632C645D3D743B666F72286C657420743D633B743C3D643B742B2B29746869732E72656E6465724465636F726174696F6E4F6E4C696E6528652C6E2C6C2C746869732E5F73656C656374696F6E436F6C6F722C692C742C6F2C6F2C732C722C61';
wwv_flow_imp.g_varchar2_table(16158) := '297D7D5F72656E6465724465636F726174696F6E73486967686C696768747328652C742C6E2C692C6F2C732C722C61297B666F7228636F6E7374206C206F662074297B636F6E737420743D6C2E6F7074696F6E732E6D696E696D61703B69662821742963';
wwv_flow_imp.g_varchar2_table(16159) := '6F6E74696E75653B636F6E737420633D692E696E746572736563745769746856696577706F7274286C2E72616E6765293B696628216329636F6E74696E75653B636F6E73745B642C685D3D632C753D742E676574436F6C6F7228746869732E5F7468656D';
wwv_flow_imp.g_varchar2_table(16160) := '652E76616C7565293B69662875262621752E69735472616E73706172656E74282929666F72286C657420633D643B633C3D683B632B2B2973776974636828742E706F736974696F6E297B6361736520313A746869732E72656E6465724465636F72617469';
wwv_flow_imp.g_varchar2_table(16161) := '6F6E4F6E4C696E6528652C6E2C6C2E72616E67652C752C692C632C6F2C6F2C732C722C61293B636F6E74696E75653B6361736520323A7B636F6E737420743D692E67657459466F724C696E654E756D62657228632C6F292C6E3D323B746869732E72656E';
wwv_flow_imp.g_varchar2_table(16162) := '6465724465636F726174696F6E28652C752C6E2C742C322C6F293B636F6E74696E75657D7D7D7D72656E6465724465636F726174696F6E4F6E4C696E6528652C742C6E2C692C6F2C732C722C612C6C2C632C64297B636F6E737420683D6F2E6765745946';
wwv_flow_imp.g_varchar2_table(16163) := '6F724C696E654E756D62657228732C61293B696628682B723C307C7C683E746869732E5F6D6F64656C2E6F7074696F6E732E63616E766173496E6E65724865696768742972657475726E3B636F6E73747B73746172744C696E654E756D6265723A752C65';
wwv_flow_imp.g_varchar2_table(16164) := '6E644C696E654E756D6265723A707D3D6E2C673D753D3D3D733F6E2E7374617274436F6C756D6E3A312C6D3D703D3D3D733F6E2E656E64436F6C756D6E3A746869732E5F6D6F64656C2E6765744C696E654D6178436F6C756D6E2873292C663D74686973';
wwv_flow_imp.g_varchar2_table(16165) := '2E676574584F6666736574466F72506F736974696F6E28742C732C672C6C2C632C64292C763D746869732E676574584F6666736574466F72506F736974696F6E28742C732C6D2C6C2C632C64293B746869732E72656E6465724465636F726174696F6E28';
wwv_flow_imp.g_varchar2_table(16166) := '652C692C662C682C762D662C72297D676574584F6666736574466F72506F736974696F6E28652C742C6E2C692C6F2C73297B696628313D3D3D6E2972657475726E20383B696628286E2D31292A6F3E3D732972657475726E20733B6C657420723D652E67';
wwv_flow_imp.g_varchar2_table(16167) := '65742874293B6966282172297B636F6E7374206E3D746869732E5F6D6F64656C2E6765744C696E65436F6E74656E742874293B723D5B385D3B6C657420613D383B666F72286C657420653D313B653C6E2E6C656E6774682B313B652B2B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(16168) := '20743D6E2E63686172436F6465417428652D31292C6C3D612B28393D3D3D743F692A6F3A6A692874293F322A6F3A6F293B6966286C3E3D73297B725B655D3D733B627265616B7D725B655D3D6C2C613D6C7D652E73657428742C72297D72657475726E20';
wwv_flow_imp.g_varchar2_table(16169) := '6E2D313C722E6C656E6774683F725B6E2D315D3A737D72656E6465724465636F726174696F6E28652C742C6E2C692C6F2C73297B652E66696C6C5374796C653D742626742E746F537472696E6728297C7C22222C652E66696C6C52656374286E2C692C6F';
wwv_flow_imp.g_varchar2_table(16170) := '2C73297D5F72656E64657253656374696F6E486561646572732865297B76617220743B636F6E7374206E3D746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61704C696E654865696768742C693D746869732E5F6D6F64656C2E6F7074696F';
wwv_flow_imp.g_varchar2_table(16171) := '6E732E73656374696F6E486561646572466F6E7453697A652C6F3D312E352A692C7B63616E766173496E6E657257696474683A737D3D746869732E5F6D6F64656C2E6F7074696F6E732C723D746869732E5F6D6F64656C2E6F7074696F6E732E6261636B';
wwv_flow_imp.g_varchar2_table(16172) := '67726F756E64436F6C6F722C613D6072676228247B722E727D20247B722E677D20247B722E627D202F202E3729602C6C3D746869732E5F6D6F64656C2E6F7074696F6E732E73656374696F6E486561646572466F6E74436F6C6F722C633D607267622824';
wwv_flow_imp.g_varchar2_table(16173) := '7B6C2E727D20247B6C2E677D20247B6C2E627D29602C643D632C683D746869732E5F6465636F726174696F6E7343616E7661732E646F6D4E6F64652E676574436F6E746578742822326422293B682E666F6E743D692B22707820222B746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(16174) := '64656C2E6F7074696F6E732E73656374696F6E486561646572466F6E7446616D696C792C682E7374726F6B655374796C653D642C682E6C696E6557696474683D2E323B636F6E737420753D746869732E5F6D6F64656C2E67657453656374696F6E486561';
wwv_flow_imp.g_varchar2_table(16175) := '6465724465636F726174696F6E73496E56696577706F727428652E73746172744C696E654E756D6265722C652E656E644C696E654E756D626572293B752E736F7274282828652C74293D3E652E72616E67652E73746172744C696E654E756D6265722D74';
wwv_flow_imp.g_varchar2_table(16176) := '2E72616E67652E73746172744C696E654E756D62657229293B636F6E737420703D6A4F2E5F66697453656374696F6E4865616465722E62696E64286E756C6C2C682C732D38293B666F7228636F6E73742072206F662075297B636F6E7374206C3D652E67';
wwv_flow_imp.g_varchar2_table(16177) := '657459466F724C696E654E756D62657228722E72616E67652E73746172744C696E654E756D6265722C6E292B692C643D6C2D692C753D642B322C673D746869732E5F6D6F64656C2E67657453656374696F6E4865616465725465787428722C70293B6A4F';
wwv_flow_imp.g_varchar2_table(16178) := '2E5F72656E64657253656374696F6E4C6162656C28682C672C323D3D3D286E756C6C3D3D3D28743D722E6F7074696F6E732E6D696E696D6170297C7C766F696420303D3D3D743F766F696420303A742E73656374696F6E4865616465725374796C65292C';
wwv_flow_imp.g_varchar2_table(16179) := '612C632C732C642C6F2C6C2C75297D7D737461746963205F66697453656374696F6E48656164657228652C742C6E297B696628216E2972657475726E206E3B636F6E737420693D652E6D65617375726554657874286E292E77696474682C6F3D652E6D65';
wwv_flow_imp.g_varchar2_table(16180) := '6173757265546578742822E280A622292E77696474683B696628693C3D747C7C693C3D6F2972657475726E206E3B636F6E737420733D6E2E6C656E6774682C723D692F6E2E6C656E6774682C613D4D6174682E666C6F6F722828742D6F292F72292D313B';
wwv_flow_imp.g_varchar2_table(16181) := '6C6574206C3D4D6174682E6365696C28612F32293B666F72283B6C3E3026262F5C732F2E74657374286E5B6C2D315D293B292D2D6C3B72657475726E206E2E737562737472696E6728302C6C292B22E280A6222B6E2E737562737472696E6728732D2861';
wwv_flow_imp.g_varchar2_table(16182) := '2D6C29297D737461746963205F72656E64657253656374696F6E4C6162656C28652C742C6E2C692C6F2C732C722C612C6C2C63297B74262628652E66696C6C5374796C653D692C652E66696C6C5265637428302C722C732C61292C652E66696C6C537479';
wwv_flow_imp.g_varchar2_table(16183) := '6C653D6F2C652E66696C6C5465787428742C382C6C29292C6E262628652E626567696E5061746828292C652E6D6F7665546F28302C63292C652E6C696E65546F28732C63292C652E636C6F73655061746828292C652E7374726F6B652829297D72656E64';
wwv_flow_imp.g_varchar2_table(16184) := '65724C696E65732865297B636F6E737420743D652E73746172744C696E654E756D6265722C6E3D652E656E644C696E654E756D6265722C693D746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61704C696E654865696768743B6966287468';
wwv_flow_imp.g_varchar2_table(16185) := '69732E5F6C61737452656E646572446174612626746869732E5F6C61737452656E646572446174612E6C696E6573457175616C73286529297B636F6E737420743D746869732E5F6C61737452656E646572446174612E5F67657428293B72657475726E20';
wwv_flow_imp.g_varchar2_table(16186) := '6E657720564F28652C742E696D616765446174612C742E6C696E6573297D636F6E7374206F3D746869732E5F67657442756666657228293B696628216F2972657475726E206E756C6C3B636F6E73745B732C722C615D3D6A4F2E5F72656E646572556E74';
wwv_flow_imp.g_varchar2_table(16187) := '6F75636865644C696E6573286F2C652E746F7050616464696E674C696E65436F756E742C742C6E2C692C746869732E5F6C61737452656E64657244617461292C6C3D746869732E5F6D6F64656C2E6765744D696E696D61704C696E657352656E64657269';
wwv_flow_imp.g_varchar2_table(16188) := '6E674461746128742C6E2C61292C633D746869732E5F6D6F64656C2E6765744F7074696F6E7328292E74616253697A652C643D746869732E5F6D6F64656C2E6F7074696F6E732E64656661756C744261636B67726F756E64436F6C6F722C683D74686973';
wwv_flow_imp.g_varchar2_table(16189) := '2E5F6D6F64656C2E6F7074696F6E732E6261636B67726F756E64436F6C6F722C753D746869732E5F6D6F64656C2E6F7074696F6E732E666F726567726F756E64416C7068612C703D746869732E5F6D6F64656C2E746F6B656E73436F6C6F72547261636B';
wwv_flow_imp.g_varchar2_table(16190) := '65722C673D702E6261636B67726F756E6449734C6967687428292C6D3D746869732E5F6D6F64656C2E6F7074696F6E732E72656E6465724D696E696D61702C663D746869732E5F6D6F64656C2E6F7074696F6E732E6368617252656E646572657228292C';
wwv_flow_imp.g_varchar2_table(16191) := '763D746869732E5F6D6F64656C2E6F7074696F6E732E666F6E745363616C652C623D746869732E5F6D6F64656C2E6F7074696F6E732E6D696E696D61704368617257696474682C5F3D28313D3D3D6D3F323A33292A762C793D693E5F3F4D6174682E666C';
wwv_flow_imp.g_varchar2_table(16192) := '6F6F722828692D5F292F32293A302C773D682E612F3235352C433D6E6577205F4F284D6174682E726F756E642828682E722D642E72292A772B642E72292C4D6174682E726F756E642828682E672D642E67292A772B642E67292C4D6174682E726F756E64';
wwv_flow_imp.g_varchar2_table(16193) := '2828682E622D642E62292A772B642E62292C323535293B6C657420533D652E746F7050616464696E674C696E65436F756E742A693B636F6E737420783D5B5D3B666F72286C657420653D302C733D6E2D742B313B653C733B652B2B29615B655D26266A4F';
wwv_flow_imp.g_varchar2_table(16194) := '2E5F72656E6465724C696E65286F2C432C682E612C672C6D2C622C702C752C662C532C792C632C6C5B655D2C762C69292C785B655D3D6E657720424F2853292C532B3D693B636F6E7374206B3D2D313D3D3D733F303A732C453D282D313D3D3D723F6F2E';
wwv_flow_imp.g_varchar2_table(16195) := '6865696768743A72292D6B3B72657475726E20746869732E5F63616E7661732E646F6D4E6F64652E676574436F6E746578742822326422292E707574496D61676544617461286F2C302C302C302C6B2C6F2E77696474682C45292C6E657720564F28652C';
wwv_flow_imp.g_varchar2_table(16196) := '6F2C78297D737461746963205F72656E646572556E746F75636865644C696E657328652C742C6E2C692C6F2C73297B636F6E737420723D5B5D3B6966282173297B666F72286C657420653D302C743D692D6E2B313B653C743B652B2B29725B655D3D2130';
wwv_flow_imp.g_varchar2_table(16197) := '3B72657475726E5B2D312C2D312C725D7D636F6E737420613D732E5F67657428292C6C3D612E696D616765446174612E646174612C633D612E72656E644C696E654E756D62657253746172742C643D612E6C696E65732C683D642E6C656E6774682C753D';
wwv_flow_imp.g_varchar2_table(16198) := '652E77696474682C703D652E646174612C673D28692D6E2B31292A6F2A752A343B6C6574206D3D2D312C663D2D312C763D2D312C623D2D312C5F3D2D312C793D2D312C773D742A6F3B666F72286C657420653D6E3B653C3D693B652B2B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(16199) := '20743D652D6E2C693D652D632C733D693E3D302626693C683F645B695D2E64793A2D313B6966282D313D3D3D73297B725B745D3D21302C772B3D6F3B636F6E74696E75657D636F6E737420613D732A752A342C433D28732B6F292A752A342C533D772A75';
wwv_flow_imp.g_varchar2_table(16200) := '2A342C783D28772B6F292A752A343B623D3D3D612626793D3D3D533F28623D432C793D78293A282D31213D3D76262628702E736574286C2E737562617272617928762C62292C5F292C2D313D3D3D6D2626303D3D3D762626763D3D3D5F2626286D3D6229';
wwv_flow_imp.g_varchar2_table(16201) := '2C2D313D3D3D662626623D3D3D672626763D3D3D5F262628663D7629292C763D612C623D432C5F3D532C793D78292C725B745D3D21312C772B3D6F7D72657475726E2D31213D3D76262628702E736574286C2E737562617272617928762C62292C5F292C';
wwv_flow_imp.g_varchar2_table(16202) := '2D313D3D3D6D2626303D3D3D762626763D3D3D5F2626286D3D62292C2D313D3D3D662626623D3D3D672626763D3D3D5F262628663D7629292C5B2D313D3D3D6D3F2D313A6D2F28342A75292C2D313D3D3D663F2D313A662F28342A75292C725D7D737461';
wwv_flow_imp.g_varchar2_table(16203) := '746963205F72656E6465724C696E6528652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C752C702C67297B636F6E7374206D3D752E636F6E74656E742C663D752E746F6B656E732C763D652E77696474682D732C623D313D3D3D673B6C657420';
wwv_flow_imp.g_varchar2_table(16204) := '5F3D382C793D302C773D303B666F72286C657420753D302C673D662E676574436F756E7428293B753C673B752B2B297B636F6E737420673D662E676574456E644F66667365742875292C433D662E676574466F726567726F756E642875292C533D722E67';
wwv_flow_imp.g_varchar2_table(16205) := '6574436F6C6F722843293B666F72283B793C673B792B2B297B6966285F3E762972657475726E3B636F6E737420723D6D2E63686172436F646541742879293B696628393D3D3D72297B636F6E737420653D682D28792B772925683B772B3D652D312C5F2B';
wwv_flow_imp.g_varchar2_table(16206) := '3D652A737D656C73652069662833323D3D3D72295F2B3D733B656C73657B636F6E737420683D6A692872293F323A313B666F72286C657420753D303B753C683B752B2B29696628323D3D3D6F3F6C2E626C6F636B52656E6465724368617228652C5F2C63';
wwv_flow_imp.g_varchar2_table(16207) := '2B642C532C612C742C6E2C62293A6C2E72656E6465724368617228652C5F2C632B642C722C532C612C742C6E2C702C692C62292C5F2B3D732C5F3E762972657475726E7D7D7D7D7D636C61737320714F7B636F6E7374727563746F7228652C742C6E297B';
wwv_flow_imp.g_varchar2_table(16208) := '746869732E5F73746172744C696E654E756D6265723D652C746869732E5F656E644C696E654E756D6265723D742C746869732E5F64656661756C7456616C75653D6E2C746869732E5F76616C7565733D5B5D3B666F72286C657420653D302C743D746869';
wwv_flow_imp.g_varchar2_table(16209) := '732E5F656E644C696E654E756D6265722D746869732E5F73746172744C696E654E756D6265722B313B653C743B652B2B29746869732E5F76616C7565735B655D3D6E7D6861732865297B72657475726E20746869732E676574286529213D3D746869732E';
wwv_flow_imp.g_varchar2_table(16210) := '5F64656661756C7456616C75657D73657428652C74297B653C746869732E5F73746172744C696E654E756D6265727C7C653E746869732E5F656E644C696E654E756D6265727C7C28746869732E5F76616C7565735B652D746869732E5F73746172744C69';
wwv_flow_imp.g_varchar2_table(16211) := '6E654E756D6265725D3D74297D6765742865297B72657475726E20653C746869732E5F73746172744C696E654E756D6265727C7C653E746869732E5F656E644C696E654E756D6265723F746869732E5F64656661756C7456616C75653A746869732E5F76';
wwv_flow_imp.g_varchar2_table(16212) := '616C7565735B652D746869732E5F73746172744C696E654E756D6265725D7D7D76617220244F3D6E28323133292C554F3D7B7D3B554F2E7374796C655461675472616E73666F726D3D6A7228292C554F2E736574417474726962757465733D567228292C';
wwv_flow_imp.g_varchar2_table(16213) := '554F2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C554F2E646F6D4150493D4F7228292C554F2E696E736572745374796C65456C656D656E743D487228292C4E72282928244F2E412C554F292C244F2E412626244F2E412E';
wwv_flow_imp.g_varchar2_table(16214) := '6C6F63616C732626244F2E412E6C6F63616C733B636C617373204B4F20657874656E6473204A417B636F6E7374727563746F7228652C74297B73757065722865292C746869732E5F76696577446F6D4E6F64653D743B636F6E7374206E3D746869732E5F';
wwv_flow_imp.g_varchar2_table(16215) := '636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B746869732E5F776964676574733D7B7D2C746869732E5F766572746963616C5363726F6C6C62617257696474683D6E2E766572746963616C5363726F6C';
wwv_flow_imp.g_varchar2_table(16216) := '6C62617257696474682C746869732E5F6D696E696D617057696474683D6E2E6D696E696D61702E6D696E696D617057696474682C746869732E5F686F72697A6F6E74616C5363726F6C6C6261724865696768743D6E2E686F72697A6F6E74616C5363726F';
wwv_flow_imp.g_varchar2_table(16217) := '6C6C6261724865696768742C746869732E5F656469746F724865696768743D6E2E6865696768742C746869732E5F656469746F7257696474683D6E2E77696474682C746869732E5F76696577446F6D4E6F6465526563743D7B746F703A302C6C6566743A';
wwv_flow_imp.g_varchar2_table(16218) := '302C77696474683A302C6865696768743A307D2C746869732E5F646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C654E2E777269746528746869732E5F646F6D4E6F64652C34292C746869732E5F';
wwv_flow_imp.g_varchar2_table(16219) := '646F6D4E6F64652E736574436C6173734E616D6528226F7665726C61795769646765747322292C746869732E6F766572666C6F77696E674F7665726C617957696467657473446F6D4E6F64653D734528646F63756D656E742E637265617465456C656D65';
wwv_flow_imp.g_varchar2_table(16220) := '6E7428226469762229292C654E2E777269746528746869732E6F766572666C6F77696E674F7665726C617957696467657473446F6D4E6F64652C35292C746869732E6F766572666C6F77696E674F7665726C617957696467657473446F6D4E6F64652E73';
wwv_flow_imp.g_varchar2_table(16221) := '6574436C6173734E616D6528226F766572666C6F77696E674F7665726C61795769646765747322297D646973706F736528297B73757065722E646973706F736528292C746869732E5F776964676574733D7B7D7D676574446F6D4E6F646528297B726574';
wwv_flow_imp.g_varchar2_table(16222) := '75726E20746869732E5F646F6D4E6F64657D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B726574';
wwv_flow_imp.g_varchar2_table(16223) := '75726E20746869732E5F766572746963616C5363726F6C6C62617257696474683D742E766572746963616C5363726F6C6C62617257696474682C746869732E5F6D696E696D617057696474683D742E6D696E696D61702E6D696E696D617057696474682C';
wwv_flow_imp.g_varchar2_table(16224) := '746869732E5F686F72697A6F6E74616C5363726F6C6C6261724865696768743D742E686F72697A6F6E74616C5363726F6C6C6261724865696768742C746869732E5F656469746F724865696768743D742E6865696768742C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(16225) := '57696474683D742E77696474682C21307D6164645769646765742865297B636F6E737420743D734528652E676574446F6D4E6F64652829293B746869732E5F776964676574735B652E676574496428295D3D7B7769646765743A652C707265666572656E';
wwv_flow_imp.g_varchar2_table(16226) := '63653A6E756C6C2C646F6D4E6F64653A747D2C742E736574506F736974696F6E28226162736F6C75746522292C742E73657441747472696275746528227769646765744964222C652E67657449642829292C652E616C6C6F77456469746F724F76657266';
wwv_flow_imp.g_varchar2_table(16227) := '6C6F773F746869732E6F766572666C6F77696E674F7665726C617957696467657473446F6D4E6F64652E617070656E644368696C642874293A746869732E5F646F6D4E6F64652E617070656E644368696C642874292C746869732E73657453686F756C64';
wwv_flow_imp.g_varchar2_table(16228) := '52656E64657228292C746869732E5F7570646174654D61784D696E576964746828297D736574576964676574506F736974696F6E28652C74297B636F6E7374206E3D746869732E5F776964676574735B652E676574496428295D3B72657475726E206E2E';
wwv_flow_imp.g_varchar2_table(16229) := '707265666572656E63653D3D3D743F28746869732E5F7570646174654D61784D696E576964746828292C2131293A286E2E707265666572656E63653D742C746869732E73657453686F756C6452656E64657228292C746869732E5F7570646174654D6178';
wwv_flow_imp.g_varchar2_table(16230) := '4D696E576964746828292C2130297D72656D6F76655769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F776964676574732E6861734F776E50726F7065727479287429297B636F6E737420653D746869732E5F77';
wwv_flow_imp.g_varchar2_table(16231) := '6964676574735B745D2E646F6D4E6F64652E646F6D4E6F64653B64656C65746520746869732E5F776964676574735B745D2C652E72656D6F766528292C746869732E73657453686F756C6452656E64657228292C746869732E5F7570646174654D61784D';
wwv_flow_imp.g_varchar2_table(16232) := '696E576964746828297D7D5F7570646174654D61784D696E576964746828297B76617220652C743B6C6574206E3D303B636F6E737420693D4F626A6563742E6B65797328746869732E5F77696467657473293B666F72286C6574206F3D302C733D692E6C';
wwv_flow_imp.g_varchar2_table(16233) := '656E6774683B6F3C733B6F2B2B297B636F6E737420733D695B6F5D2C723D6E756C6C3D3D3D28743D28653D746869732E5F776964676574735B735D2E776964676574292E6765744D696E436F6E74656E745769647468496E5078297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(16234) := '3D3D743F766F696420303A742E63616C6C2865293B766F69642030213D3D722626286E3D4D6174682E6D6178286E2C7229297D746869732E5F636F6E746578742E766965774C61796F75742E7365744F7665726C6179576964676574734D696E57696474';
wwv_flow_imp.g_varchar2_table(16235) := '68286E297D5F72656E6465725769646765742865297B636F6E737420743D652E646F6D4E6F64653B6966286E756C6C213D3D652E707265666572656E636529696628303D3D3D652E707265666572656E636529742E736574546F702830292C742E736574';
wwv_flow_imp.g_varchar2_table(16236) := '526967687428322A746869732E5F766572746963616C5363726F6C6C62617257696474682B746869732E5F6D696E696D61705769647468293B656C736520696628313D3D3D652E707265666572656E6365297B636F6E737420653D742E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(16237) := '2E636C69656E744865696768743B742E736574546F7028746869732E5F656469746F724865696768742D652D322A746869732E5F686F72697A6F6E74616C5363726F6C6C626172486569676874292C742E736574526967687428322A746869732E5F7665';
wwv_flow_imp.g_varchar2_table(16238) := '72746963616C5363726F6C6C62617257696474682B746869732E5F6D696E696D61705769647468297D656C736520696628323D3D3D652E707265666572656E636529742E736574546F702830292C742E646F6D4E6F64652E7374796C652E72696768743D';
wwv_flow_imp.g_varchar2_table(16239) := '22353025223B656C73657B636F6E73747B746F703A6E2C6C6566743A697D3D652E707265666572656E63653B696628746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E676574283432292626652E776964676574';
wwv_flow_imp.g_varchar2_table(16240) := '2E616C6C6F77456469746F724F766572666C6F77297B636F6E737420653D746869732E5F76696577446F6D4E6F6465526563743B742E736574546F70286E2B652E746F70292C742E7365744C65667428692B652E6C656674292C742E736574506F736974';
wwv_flow_imp.g_varchar2_table(16241) := '696F6E2822666978656422297D656C736520742E736574546F70286E292C742E7365744C6566742869292C742E736574506F736974696F6E28226162736F6C75746522297D656C736520742E736574546F70282222297D7072657061726552656E646572';
wwv_flow_imp.g_varchar2_table(16242) := '2865297B746869732E5F76696577446F6D4E6F6465526563743D417328746869732E5F76696577446F6D4E6F64652E646F6D4E6F6465297D72656E6465722865297B746869732E5F646F6D4E6F64652E736574576964746828746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(16243) := '725769647468293B636F6E737420743D4F626A6563742E6B65797328746869732E5F77696467657473293B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D3B746869732E5F72656E646572';
wwv_flow_imp.g_varchar2_table(16244) := '57696467657428746869732E5F776964676574735B6E5D297D7D7D636C61737320474F7B636F6E7374727563746F7228652C74297B636F6E7374206E3D652E6F7074696F6E733B746869732E6C696E654865696768743D6E2E676574283637292C746869';
wwv_flow_imp.g_varchar2_table(16245) := '732E706978656C526174696F3D6E2E67657428313433292C746869732E6F7665727669657752756C65724C616E65733D6E2E676574283833292C746869732E72656E646572426F726465723D6E2E676574283832293B636F6E737420693D742E67657443';
wwv_flow_imp.g_varchar2_table(16246) := '6F6C6F7228705F293B746869732E626F72646572436F6C6F723D693F692E746F537472696E6728293A6E756C6C2C746869732E68696465437572736F723D6E2E676574283539293B636F6E7374206F3D742E676574436F6C6F72286A62293B746869732E';
wwv_flow_imp.g_varchar2_table(16247) := '637572736F72436F6C6F7253696E676C653D6F3F6F2E7472616E73706172656E74282E37292E746F537472696E6728293A6E756C6C3B636F6E737420733D742E676574436F6C6F72282462293B746869732E637572736F72436F6C6F725072696D617279';
wwv_flow_imp.g_varchar2_table(16248) := '3D733F732E7472616E73706172656E74282E37292E746F537472696E6728293A6E756C6C3B636F6E737420723D742E676574436F6C6F72284B62293B746869732E637572736F72436F6C6F725365636F6E646172793D723F722E7472616E73706172656E';
wwv_flow_imp.g_varchar2_table(16249) := '74282E37292E746F537472696E6728293A6E756C6C2C746869732E7468656D65547970653D742E747970653B636F6E737420613D6E2E676574283733292C6C3D612E656E61626C65642C633D612E736964652C643D742E676574436F6C6F7228675F292C';
wwv_flow_imp.g_varchar2_table(16250) := '683D50772E67657444656661756C744261636B67726F756E6428293B746869732E6261636B67726F756E64436F6C6F723D647C7C286C2626227269676874223D3D3D633F683A6E756C6C293B636F6E737420753D6E2E67657428313435292E6F76657276';
wwv_flow_imp.g_varchar2_table(16251) := '69657752756C65723B746869732E746F703D752E746F702C746869732E72696768743D752E72696768742C746869732E646F6D57696474683D752E77696474682C746869732E646F6D4865696768743D752E6865696768742C303D3D3D746869732E6F76';
wwv_flow_imp.g_varchar2_table(16252) := '65727669657752756C65724C616E65733F28746869732E63616E76617357696474683D302C746869732E63616E7661734865696768743D30293A28746869732E63616E76617357696474683D746869732E646F6D57696474682A746869732E706978656C';
wwv_flow_imp.g_varchar2_table(16253) := '526174696F7C302C746869732E63616E7661734865696768743D746869732E646F6D4865696768742A746869732E706978656C526174696F7C30293B636F6E73745B702C675D3D746869732E5F696E69744C616E657328312C746869732E63616E766173';
wwv_flow_imp.g_varchar2_table(16254) := '57696474682C746869732E6F7665727669657752756C65724C616E6573293B746869732E783D702C746869732E773D677D5F696E69744C616E657328652C742C6E297B636F6E737420693D742D653B6966286E3E3D33297B636F6E737420743D4D617468';
wwv_flow_imp.g_varchar2_table(16255) := '2E666C6F6F7228692F33292C6E3D4D6174682E666C6F6F7228692F33292C6F3D692D742D6E2C733D652B743B72657475726E5B5B302C652C732C652C652B742B6F2C652C732C655D2C5B302C742C6F2C742B6F2C6E2C742B6F2B6E2C6F2B6E2C742B6F2B';
wwv_flow_imp.g_varchar2_table(16256) := '6E5D5D7D696628323D3D3D6E297B636F6E737420743D4D6174682E666C6F6F7228692F32292C6E3D692D743B72657475726E5B5B302C652C652C652C652B742C652C652C655D2C5B302C742C742C742C6E2C742B6E2C742B6E2C742B6E5D5D7D72657475';
wwv_flow_imp.g_varchar2_table(16257) := '726E5B5B302C652C652C652C652C652C652C655D2C5B302C692C692C692C692C692C692C695D5D7D657175616C732865297B72657475726E20746869732E6C696E654865696768743D3D3D652E6C696E654865696768742626746869732E706978656C52';
wwv_flow_imp.g_varchar2_table(16258) := '6174696F3D3D3D652E706978656C526174696F2626746869732E6F7665727669657752756C65724C616E65733D3D3D652E6F7665727669657752756C65724C616E65732626746869732E72656E646572426F726465723D3D3D652E72656E646572426F72';
wwv_flow_imp.g_varchar2_table(16259) := '6465722626746869732E626F72646572436F6C6F723D3D3D652E626F72646572436F6C6F722626746869732E68696465437572736F723D3D3D652E68696465437572736F722626746869732E637572736F72436F6C6F7253696E676C653D3D3D652E6375';
wwv_flow_imp.g_varchar2_table(16260) := '72736F72436F6C6F7253696E676C652626746869732E637572736F72436F6C6F725072696D6172793D3D3D652E637572736F72436F6C6F725072696D6172792626746869732E637572736F72436F6C6F725365636F6E646172793D3D3D652E637572736F';
wwv_flow_imp.g_varchar2_table(16261) := '72436F6C6F725365636F6E646172792626746869732E7468656D65547970653D3D3D652E7468656D6554797065262668752E657175616C7328746869732E6261636B67726F756E64436F6C6F722C652E6261636B67726F756E64436F6C6F722926267468';
wwv_flow_imp.g_varchar2_table(16262) := '69732E746F703D3D3D652E746F702626746869732E72696768743D3D3D652E72696768742626746869732E646F6D57696474683D3D3D652E646F6D57696474682626746869732E646F6D4865696768743D3D3D652E646F6D486569676874262674686973';
wwv_flow_imp.g_varchar2_table(16263) := '2E63616E76617357696474683D3D3D652E63616E76617357696474682626746869732E63616E7661734865696768743D3D3D652E63616E7661734865696768747D7D636C61737320514F20657874656E6473204A417B636F6E7374727563746F72286529';
wwv_flow_imp.g_varchar2_table(16264) := '7B73757065722865292C746869732E5F61637475616C53686F756C6452656E6465723D302C746869732E5F72656E64657265644465636F726174696F6E733D5B5D2C746869732E5F72656E6465726564437572736F72506F736974696F6E733D5B5D2C74';
wwv_flow_imp.g_varchar2_table(16265) := '6869732E5F646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E74282263616E7661732229292C746869732E5F646F6D4E6F64652E736574436C6173734E616D6528226465636F726174696F6E734F7665727669657752756C';
wwv_flow_imp.g_varchar2_table(16266) := '657222292C746869732E5F646F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C746869732E5F646F6D4E6F64652E7365744C6179657248696E74696E67282130292C746869732E5F646F6D4E6F64652E736574436F6E746169';
wwv_flow_imp.g_varchar2_table(16267) := '6E282273747269637422292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F75706461746553657474696E6773282131292C746869732E5F746F6B656E73436F';
wwv_flow_imp.g_varchar2_table(16268) := '6C6F72547261636B65724C697374656E65723D50772E6F6E4469644368616E67652828653D3E7B652E6368616E676564436F6C6F724D61702626746869732E5F75706461746553657474696E6773282130297D29292C746869732E5F637572736F72506F';
wwv_flow_imp.g_varchar2_table(16269) := '736974696F6E733D5B7B706F736974696F6E3A6E6577206D6328312C31292C636F6C6F723A746869732E5F73657474696E67732E637572736F72436F6C6F7253696E676C657D5D7D646973706F736528297B73757065722E646973706F736528292C7468';
wwv_flow_imp.g_varchar2_table(16270) := '69732E5F746F6B656E73436F6C6F72547261636B65724C697374656E65722E646973706F736528297D5F75706461746553657474696E67732865297B636F6E737420743D6E657720474F28746869732E5F636F6E746578742E636F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(16271) := '6F6E2C746869732E5F636F6E746578742E7468656D65293B72657475726E2128746869732E5F73657474696E67732626746869732E5F73657474696E67732E657175616C732874297C7C28746869732E5F73657474696E67733D742C746869732E5F646F';
wwv_flow_imp.g_varchar2_table(16272) := '6D4E6F64652E736574546F7028746869732E5F73657474696E67732E746F70292C746869732E5F646F6D4E6F64652E736574526967687428746869732E5F73657474696E67732E7269676874292C746869732E5F646F6D4E6F64652E7365745769647468';
wwv_flow_imp.g_varchar2_table(16273) := '28746869732E5F73657474696E67732E646F6D5769647468292C746869732E5F646F6D4E6F64652E73657448656967687428746869732E5F73657474696E67732E646F6D486569676874292C746869732E5F646F6D4E6F64652E646F6D4E6F64652E7769';
wwv_flow_imp.g_varchar2_table(16274) := '6474683D746869732E5F73657474696E67732E63616E76617357696474682C746869732E5F646F6D4E6F64652E646F6D4E6F64652E6865696768743D746869732E5F73657474696E67732E63616E7661734865696768742C652626746869732E5F72656E';
wwv_flow_imp.g_varchar2_table(16275) := '64657228292C3029297D5F6D61726B52656E646572696E6749734E656564656428297B72657475726E20746869732E5F61637475616C53686F756C6452656E6465723D322C21307D5F6D61726B52656E646572696E6749734D617962654E656564656428';
wwv_flow_imp.g_varchar2_table(16276) := '297B72657475726E20746869732E5F61637475616C53686F756C6452656E6465723D312C21307D6F6E436F6E66696775726174696F6E4368616E6765642865297B72657475726E2121746869732E5F75706461746553657474696E677328213129262674';
wwv_flow_imp.g_varchar2_table(16277) := '6869732E5F6D61726B52656E646572696E6749734E656564656428297D6F6E437572736F7253746174654368616E6765642865297B746869732E5F637572736F72506F736974696F6E733D5B5D3B666F72286C657420743D302C6E3D652E73656C656374';
wwv_flow_imp.g_varchar2_table(16278) := '696F6E732E6C656E6774683B743C6E3B742B2B297B6C657420693D746869732E5F73657474696E67732E637572736F72436F6C6F7253696E676C653B6E3E31262628693D303D3D3D743F746869732E5F73657474696E67732E637572736F72436F6C6F72';
wwv_flow_imp.g_varchar2_table(16279) := '5072696D6172793A746869732E5F73657474696E67732E637572736F72436F6C6F725365636F6E64617279292C746869732E5F637572736F72506F736974696F6E732E70757368287B706F736974696F6E3A652E73656C656374696F6E735B745D2E6765';
wwv_flow_imp.g_varchar2_table(16280) := '74506F736974696F6E28292C636F6C6F723A697D297D72657475726E20746869732E5F637572736F72506F736974696F6E732E736F7274282828652C74293D3E6D632E636F6D7061726528652E706F736974696F6E2C742E706F736974696F6E2929292C';
wwv_flow_imp.g_varchar2_table(16281) := '746869732E5F6D61726B52656E646572696E6749734D617962654E656564656428297D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E2121652E616666656374734F7665727669657752756C65722626746869732E5F6D6172';
wwv_flow_imp.g_varchar2_table(16282) := '6B52656E646572696E6749734D617962654E656564656428297D6F6E466C75736865642865297B72657475726E20746869732E5F6D61726B52656E646572696E6749734E656564656428297D6F6E5363726F6C6C4368616E6765642865297B7265747572';
wwv_flow_imp.g_varchar2_table(16283) := '6E2121652E7363726F6C6C4865696768744368616E6765642626746869732E5F6D61726B52656E646572696E6749734E656564656428297D6F6E5A6F6E65734368616E6765642865297B72657475726E20746869732E5F6D61726B52656E646572696E67';
wwv_flow_imp.g_varchar2_table(16284) := '49734E656564656428297D6F6E5468656D654368616E6765642865297B72657475726E2121746869732E5F75706461746553657474696E6773282131292626746869732E5F6D61726B52656E646572696E6749734E656564656428297D676574446F6D4E';
wwv_flow_imp.g_varchar2_table(16285) := '6F646528297B72657475726E20746869732E5F646F6D4E6F64652E646F6D4E6F64657D7072657061726552656E6465722865297B7D72656E6465722865297B746869732E5F72656E64657228292C746869732E5F61637475616C53686F756C6452656E64';
wwv_flow_imp.g_varchar2_table(16286) := '65723D307D5F72656E64657228297B636F6E737420653D746869732E5F73657474696E67732E6261636B67726F756E64436F6C6F723B696628303D3D3D746869732E5F73657474696E67732E6F7665727669657752756C65724C616E6573297265747572';
wwv_flow_imp.g_varchar2_table(16287) := '6E20746869732E5F646F6D4E6F64652E7365744261636B67726F756E64436F6C6F7228653F68752E466F726D61742E4353532E666F726D6174486578412865293A2222292C766F696420746869732E5F646F6D4E6F64652E736574446973706C61792822';
wwv_flow_imp.g_varchar2_table(16288) := '6E6F6E6522293B636F6E737420743D746869732E5F636F6E746578742E766965774D6F64656C2E676574416C6C4F7665727669657752756C65724465636F726174696F6E7328746869732E5F636F6E746578742E7468656D65293B696628742E736F7274';
wwv_flow_imp.g_varchar2_table(16289) := '28444F2E636F6D70617265427952656E646572696E6750726F7073292C31213D3D746869732E5F61637475616C53686F756C6452656E6465727C7C444F2E657175616C7341727228746869732E5F72656E64657265644465636F726174696F6E732C7429';
wwv_flow_imp.g_varchar2_table(16290) := '7C7C28746869732E5F61637475616C53686F756C6452656E6465723D32292C31213D3D746869732E5F61637475616C53686F756C6452656E6465727C7C506828746869732E5F72656E6465726564437572736F72506F736974696F6E732C746869732E5F';
wwv_flow_imp.g_varchar2_table(16291) := '637572736F72506F736974696F6E732C2828652C74293D3E652E706F736974696F6E2E6C696E654E756D6265723D3D3D742E706F736974696F6E2E6C696E654E756D6265722626652E636F6C6F723D3D3D742E636F6C6F7229297C7C28746869732E5F61';
wwv_flow_imp.g_varchar2_table(16292) := '637475616C53686F756C6452656E6465723D32292C313D3D3D746869732E5F61637475616C53686F756C6452656E6465722972657475726E3B746869732E5F72656E64657265644465636F726174696F6E733D742C746869732E5F72656E646572656443';
wwv_flow_imp.g_varchar2_table(16293) := '7572736F72506F736974696F6E733D746869732E5F637572736F72506F736974696F6E732C746869732E5F646F6D4E6F64652E736574446973706C61792822626C6F636B22293B636F6E7374206E3D746869732E5F73657474696E67732E63616E766173';
wwv_flow_imp.g_varchar2_table(16294) := '57696474682C693D746869732E5F73657474696E67732E63616E7661734865696768742C6F3D746869732E5F73657474696E67732E6C696E654865696768742C733D746869732E5F636F6E746578742E766965774C61796F75742C723D692F746869732E';
wwv_flow_imp.g_varchar2_table(16295) := '5F636F6E746578742E766965774C61796F75742E6765745363726F6C6C48656967687428292C613D362A746869732E5F73657474696E67732E706978656C526174696F7C302C6C3D612F327C302C633D746869732E5F646F6D4E6F64652E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(16296) := '652E676574436F6E746578742822326422293B653F652E69734F706171756528293F28632E66696C6C5374796C653D68752E466F726D61742E4353532E666F726D6174486578412865292C632E66696C6C5265637428302C302C6E2C6929293A28632E63';
wwv_flow_imp.g_varchar2_table(16297) := '6C6561725265637428302C302C6E2C69292C632E66696C6C5374796C653D68752E466F726D61742E4353532E666F726D6174486578412865292C632E66696C6C5265637428302C302C6E2C6929293A632E636C6561725265637428302C302C6E2C69293B';
wwv_flow_imp.g_varchar2_table(16298) := '636F6E737420643D746869732E5F73657474696E67732E782C683D746869732E5F73657474696E67732E773B666F7228636F6E73742065206F662074297B636F6E737420743D652E636F6C6F722C6E3D652E646174613B632E66696C6C5374796C653D74';
wwv_flow_imp.g_varchar2_table(16299) := '3B6C657420753D302C703D302C673D303B666F72286C657420653D302C743D6E2E6C656E6774682F333B653C743B652B2B297B636F6E737420743D6E5B332A655D2C6D3D6E5B332A652B315D2C663D6E5B332A652B325D3B6C657420763D732E67657456';
wwv_flow_imp.g_varchar2_table(16300) := '6572746963616C4F6666736574466F724C696E654E756D626572286D292A727C302C623D28732E676574566572746963616C4F6666736574466F724C696E654E756D6265722866292B6F292A727C303B696628622D763C61297B6C657420653D28762B62';
wwv_flow_imp.g_varchar2_table(16301) := '292F327C303B653C6C3F653D6C3A652B6C3E69262628653D692D6C292C763D652D6C2C623D652B6C7D763E672B317C7C74213D3D753F2830213D3D652626632E66696C6C5265637428645B755D2C702C685B755D2C672D70292C753D742C703D762C673D';
wwv_flow_imp.g_varchar2_table(16302) := '62293A623E67262628673D62297D632E66696C6C5265637428645B755D2C702C685B755D2C672D70297D69662821746869732E5F73657474696E67732E68696465437572736F72297B636F6E737420653D322A746869732E5F73657474696E67732E7069';
wwv_flow_imp.g_varchar2_table(16303) := '78656C526174696F7C302C743D652F327C302C6E3D746869732E5F73657474696E67732E785B375D2C6F3D746869732E5F73657474696E67732E775B375D3B6C657420613D2D3130302C6C3D2D3130302C643D6E756C6C3B666F72286C657420683D302C';
wwv_flow_imp.g_varchar2_table(16304) := '753D746869732E5F637572736F72506F736974696F6E732E6C656E6774683B683C753B682B2B297B636F6E737420753D746869732E5F637572736F72506F736974696F6E735B685D2E636F6C6F723B696628217529636F6E74696E75653B636F6E737420';
wwv_flow_imp.g_varchar2_table(16305) := '703D746869732E5F637572736F72506F736974696F6E735B685D2E706F736974696F6E3B6C657420673D732E676574566572746963616C4F6666736574466F724C696E654E756D62657228702E6C696E654E756D626572292A727C303B673C743F673D74';
wwv_flow_imp.g_varchar2_table(16306) := '3A672B743E69262628673D692D74293B636F6E7374206D3D672D742C663D6D2B653B6D3E6C2B317C7C75213D3D643F2830213D3D682626642626632E66696C6C52656374286E2C612C6F2C6C2D61292C613D6D2C6C3D66293A663E6C2626286C3D66292C';
wwv_flow_imp.g_varchar2_table(16307) := '643D752C632E66696C6C5374796C653D757D642626632E66696C6C52656374286E2C612C6F2C6C2D61297D746869732E5F73657474696E67732E72656E646572426F726465722626746869732E5F73657474696E67732E626F72646572436F6C6F722626';
wwv_flow_imp.g_varchar2_table(16308) := '746869732E5F73657474696E67732E6F7665727669657752756C65724C616E65733E30262628632E626567696E5061746828292C632E6C696E6557696474683D312C632E7374726F6B655374796C653D746869732E5F73657474696E67732E626F726465';
wwv_flow_imp.g_varchar2_table(16309) := '72436F6C6F722C632E6D6F7665546F28302C30292C632E6C696E65546F28302C69292C632E7374726F6B6528292C632E6D6F7665546F28302C30292C632E6C696E65546F286E2C30292C632E7374726F6B652829297D7D636C61737320594F7B636F6E73';
wwv_flow_imp.g_varchar2_table(16310) := '74727563746F7228652C742C6E297B746869732E5F636F6C6F725A6F6E654272616E643D766F696420302C746869732E66726F6D3D307C652C746869732E746F3D307C742C746869732E636F6C6F7249643D307C6E7D73746174696320636F6D70617265';
wwv_flow_imp.g_varchar2_table(16311) := '28652C74297B72657475726E20652E636F6C6F7249643D3D3D742E636F6C6F7249643F652E66726F6D3D3D3D742E66726F6D3F652E746F2D742E746F3A652E66726F6D2D742E66726F6D3A652E636F6C6F7249642D742E636F6C6F7249647D7D636C6173';
wwv_flow_imp.g_varchar2_table(16312) := '73205A4F7B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F6F7665727669657752756C65725A6F6E654272616E643D766F696420302C746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(16313) := '6265723D742C746869732E686569676874496E4C696E65733D6E2C746869732E636F6C6F723D692C746869732E5F636F6C6F725A6F6E653D6E756C6C7D73746174696320636F6D7061726528652C74297B72657475726E20652E636F6C6F723D3D3D742E';
wwv_flow_imp.g_varchar2_table(16314) := '636F6C6F723F652E73746172744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E686569676874496E4C696E65733D3D3D742E686569676874496E4C696E65733F652E656E644C696E654E756D6265722D742E656E644C';
wwv_flow_imp.g_varchar2_table(16315) := '696E654E756D6265723A652E686569676874496E4C696E65732D742E686569676874496E4C696E65733A652E73746172744C696E654E756D6265722D742E73746172744C696E654E756D6265723A652E636F6C6F723C742E636F6C6F723F2D313A317D73';
wwv_flow_imp.g_varchar2_table(16316) := '6574436F6C6F725A6F6E652865297B746869732E5F636F6C6F725A6F6E653D657D676574436F6C6F725A6F6E657328297B72657475726E20746869732E5F636F6C6F725A6F6E657D7D636C61737320584F7B636F6E7374727563746F722865297B746869';
wwv_flow_imp.g_varchar2_table(16317) := '732E5F676574566572746963616C4F6666736574466F724C696E653D652C746869732E5F7A6F6E65733D5B5D2C746869732E5F636F6C6F725A6F6E6573496E76616C69643D21312C746869732E5F6C696E654865696768743D302C746869732E5F646F6D';
wwv_flow_imp.g_varchar2_table(16318) := '57696474683D302C746869732E5F646F6D4865696768743D302C746869732E5F6F757465724865696768743D302C746869732E5F706978656C526174696F3D312C746869732E5F6C61737441737369676E656449643D302C746869732E5F636F6C6F7232';
wwv_flow_imp.g_varchar2_table(16319) := '49643D4F626A6563742E637265617465286E756C6C292C746869732E5F696432436F6C6F723D5B5D7D676574496432436F6C6F7228297B72657475726E20746869732E5F696432436F6C6F727D7365745A6F6E65732865297B746869732E5F7A6F6E6573';
wwv_flow_imp.g_varchar2_table(16320) := '3D652C746869732E5F7A6F6E65732E736F7274285A4F2E636F6D70617265297D7365744C696E654865696768742865297B72657475726E20746869732E5F6C696E65486569676874213D3D65262628746869732E5F6C696E654865696768743D652C7468';
wwv_flow_imp.g_varchar2_table(16321) := '69732E5F636F6C6F725A6F6E6573496E76616C69643D21302C2130297D736574506978656C526174696F2865297B746869732E5F706978656C526174696F3D652C746869732E5F636F6C6F725A6F6E6573496E76616C69643D21307D676574444F4D5769';
wwv_flow_imp.g_varchar2_table(16322) := '64746828297B72657475726E20746869732E5F646F6D57696474687D67657443616E766173576964746828297B72657475726E20746869732E5F646F6D57696474682A746869732E5F706978656C526174696F7D736574444F4D57696474682865297B72';
wwv_flow_imp.g_varchar2_table(16323) := '657475726E20746869732E5F646F6D5769647468213D3D65262628746869732E5F646F6D57696474683D652C746869732E5F636F6C6F725A6F6E6573496E76616C69643D21302C2130297D676574444F4D48656967687428297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(16324) := '732E5F646F6D4865696768747D67657443616E76617348656967687428297B72657475726E20746869732E5F646F6D4865696768742A746869732E5F706978656C526174696F7D736574444F4D4865696768742865297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(16325) := '646F6D486569676874213D3D65262628746869732E5F646F6D4865696768743D652C746869732E5F636F6C6F725A6F6E6573496E76616C69643D21302C2130297D6765744F7574657248656967687428297B72657475726E20746869732E5F6F75746572';
wwv_flow_imp.g_varchar2_table(16326) := '4865696768747D7365744F757465724865696768742865297B72657475726E20746869732E5F6F75746572486569676874213D3D65262628746869732E5F6F757465724865696768743D652C746869732E5F636F6C6F725A6F6E6573496E76616C69643D';
wwv_flow_imp.g_varchar2_table(16327) := '21302C2130297D7265736F6C7665436F6C6F725A6F6E657328297B636F6E737420653D746869732E5F636F6C6F725A6F6E6573496E76616C69642C743D4D6174682E666C6F6F7228746869732E5F6C696E65486569676874292C6E3D4D6174682E666C6F';
wwv_flow_imp.g_varchar2_table(16328) := '6F7228746869732E67657443616E7661734865696768742829292C693D6E2F4D6174682E666C6F6F7228746869732E5F6F75746572486569676874292C6F3D4D6174682E666C6F6F7228342A746869732E5F706978656C526174696F2F32292C733D5B5D';
wwv_flow_imp.g_varchar2_table(16329) := '3B666F72286C657420723D302C613D746869732E5F7A6F6E65732E6C656E6774683B723C613B722B2B297B636F6E737420613D746869732E5F7A6F6E65735B725D3B6966282165297B636F6E737420653D612E676574436F6C6F725A6F6E657328293B69';
wwv_flow_imp.g_varchar2_table(16330) := '662865297B732E707573682865293B636F6E74696E75657D7D636F6E7374206C3D746869732E5F676574566572746963616C4F6666736574466F724C696E6528612E73746172744C696E654E756D626572292C633D303D3D3D612E686569676874496E4C';
wwv_flow_imp.g_varchar2_table(16331) := '696E65733F746869732E5F676574566572746963616C4F6666736574466F724C696E6528612E656E644C696E654E756D626572292B743A6C2B612E686569676874496E4C696E65732A742C643D4D6174682E666C6F6F7228692A6C292C683D4D6174682E';
wwv_flow_imp.g_varchar2_table(16332) := '666C6F6F7228692A63293B6C657420753D4D6174682E666C6F6F722828642B68292F32292C703D682D753B703C6F262628703D6F292C752D703C30262628753D70292C752B703E6E262628753D6E2D70293B636F6E737420673D612E636F6C6F723B6C65';
wwv_flow_imp.g_varchar2_table(16333) := '74206D3D746869732E5F636F6C6F723249645B675D3B6D7C7C286D3D2B2B746869732E5F6C61737441737369676E656449642C746869732E5F636F6C6F723249645B675D3D6D2C746869732E5F696432436F6C6F725B6D5D3D67293B636F6E737420663D';
wwv_flow_imp.g_varchar2_table(16334) := '6E657720594F28752D702C752B702C6D293B612E736574436F6C6F725A6F6E652866292C732E707573682866297D72657475726E20746869732E5F636F6C6F725A6F6E6573496E76616C69643D21312C732E736F727428594F2E636F6D70617265292C73';
wwv_flow_imp.g_varchar2_table(16335) := '7D7D636C617373204A4F20657874656E64732058417B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F636F6E746578743D653B636F6E7374206E3D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F';
wwv_flow_imp.g_varchar2_table(16336) := '7074696F6E733B746869732E5F646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E74282263616E7661732229292C746869732E5F646F6D4E6F64652E736574436C6173734E616D652874292C746869732E5F646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(16337) := '652E736574506F736974696F6E28226162736F6C75746522292C746869732E5F646F6D4E6F64652E7365744C6179657248696E74696E67282130292C746869732E5F646F6D4E6F64652E736574436F6E7461696E282273747269637422292C746869732E';
wwv_flow_imp.g_varchar2_table(16338) := '5F7A6F6E654D616E616765723D6E657720584F2828653D3E746869732E5F636F6E746578742E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228652929292C746869732E5F7A6F6E654D616E6167';
wwv_flow_imp.g_varchar2_table(16339) := '65722E736574444F4D57696474682830292C746869732E5F7A6F6E654D616E616765722E736574444F4D4865696768742830292C746869732E5F7A6F6E654D616E616765722E7365744F7574657248656967687428746869732E5F636F6E746578742E76';
wwv_flow_imp.g_varchar2_table(16340) := '6965774C61796F75742E6765745363726F6C6C4865696768742829292C746869732E5F7A6F6E654D616E616765722E7365744C696E65486569676874286E2E67657428363729292C746869732E5F7A6F6E654D616E616765722E736574506978656C5261';
wwv_flow_imp.g_varchar2_table(16341) := '74696F286E2E6765742831343329292C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C6572287468697329';
wwv_flow_imp.g_varchar2_table(16342) := '2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B72657475726E20652E68617343';
wwv_flow_imp.g_varchar2_table(16343) := '68616E67656428363729262628746869732E5F7A6F6E654D616E616765722E7365744C696E6548656967687428742E67657428363729292C746869732E5F72656E6465722829292C652E6861734368616E6765642831343329262628746869732E5F7A6F';
wwv_flow_imp.g_varchar2_table(16344) := '6E654D616E616765722E736574506978656C526174696F28742E6765742831343329292C746869732E5F646F6D4E6F64652E736574576964746828746869732E5F7A6F6E654D616E616765722E676574444F4D57696474682829292C746869732E5F646F';
wwv_flow_imp.g_varchar2_table(16345) := '6D4E6F64652E73657448656967687428746869732E5F7A6F6E654D616E616765722E676574444F4D4865696768742829292C746869732E5F646F6D4E6F64652E646F6D4E6F64652E77696474683D746869732E5F7A6F6E654D616E616765722E67657443';
wwv_flow_imp.g_varchar2_table(16346) := '616E766173576964746828292C746869732E5F646F6D4E6F64652E646F6D4E6F64652E6865696768743D746869732E5F7A6F6E654D616E616765722E67657443616E76617348656967687428292C746869732E5F72656E6465722829292C21307D6F6E46';
wwv_flow_imp.g_varchar2_table(16347) := '6C75736865642865297B72657475726E20746869732E5F72656E64657228292C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C4865696768744368616E676564262628746869732E5F7A6F6E654D616E6167';
wwv_flow_imp.g_varchar2_table(16348) := '65722E7365744F7574657248656967687428652E7363726F6C6C486569676874292C746869732E5F72656E6465722829292C21307D6F6E5A6F6E65734368616E6765642865297B72657475726E20746869732E5F72656E64657228292C21307D67657444';
wwv_flow_imp.g_varchar2_table(16349) := '6F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64652E646F6D4E6F64657D7365744C61796F75742865297B746869732E5F646F6D4E6F64652E736574546F7028652E746F70292C746869732E5F646F6D4E6F64652E73657452696768';
wwv_flow_imp.g_varchar2_table(16350) := '7428652E7269676874293B6C657420743D21313B743D746869732E5F7A6F6E654D616E616765722E736574444F4D576964746828652E7769647468297C7C742C743D746869732E5F7A6F6E654D616E616765722E736574444F4D48656967687428652E68';
wwv_flow_imp.g_varchar2_table(16351) := '6569676874297C7C742C74262628746869732E5F646F6D4E6F64652E736574576964746828746869732E5F7A6F6E654D616E616765722E676574444F4D57696474682829292C746869732E5F646F6D4E6F64652E73657448656967687428746869732E5F';
wwv_flow_imp.g_varchar2_table(16352) := '7A6F6E654D616E616765722E676574444F4D4865696768742829292C746869732E5F646F6D4E6F64652E646F6D4E6F64652E77696474683D746869732E5F7A6F6E654D616E616765722E67657443616E766173576964746828292C746869732E5F646F6D';
wwv_flow_imp.g_varchar2_table(16353) := '4E6F64652E646F6D4E6F64652E6865696768743D746869732E5F7A6F6E654D616E616765722E67657443616E76617348656967687428292C746869732E5F72656E6465722829297D7365745A6F6E65732865297B746869732E5F7A6F6E654D616E616765';
wwv_flow_imp.g_varchar2_table(16354) := '722E7365745A6F6E65732865292C746869732E5F72656E64657228297D5F72656E64657228297B696628303D3D3D746869732E5F7A6F6E654D616E616765722E6765744F7574657248656967687428292972657475726E21313B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(16355) := '69732E5F7A6F6E654D616E616765722E67657443616E766173576964746828292C743D746869732E5F7A6F6E654D616E616765722E67657443616E76617348656967687428292C6E3D746869732E5F7A6F6E654D616E616765722E7265736F6C7665436F';
wwv_flow_imp.g_varchar2_table(16356) := '6C6F725A6F6E657328292C693D746869732E5F7A6F6E654D616E616765722E676574496432436F6C6F7228292C6F3D746869732E5F646F6D4E6F64652E646F6D4E6F64652E676574436F6E746578742822326422293B72657475726E206F2E636C656172';
wwv_flow_imp.g_varchar2_table(16357) := '5265637428302C302C652C74292C6E2E6C656E6774683E302626746869732E5F72656E6465724F6E654C616E65286F2C6E2C692C65292C21307D5F72656E6465724F6E654C616E6528652C742C6E2C69297B6C6574206F3D302C733D302C723D303B666F';
wwv_flow_imp.g_varchar2_table(16358) := '7228636F6E73742061206F662074297B636F6E737420743D612E636F6C6F7249642C6C3D612E66726F6D2C633D612E746F3B74213D3D6F3F28652E66696C6C5265637428302C732C692C722D73292C6F3D742C652E66696C6C5374796C653D6E5B6F5D2C';
wwv_flow_imp.g_varchar2_table(16359) := '733D6C2C723D63293A723E3D6C3F723D4D6174682E6D617828722C63293A28652E66696C6C5265637428302C732C692C722D73292C733D6C2C723D63297D652E66696C6C5265637428302C732C692C722D73297D7D7661722065523D6E2831363337292C';
wwv_flow_imp.g_varchar2_table(16360) := '74523D7B7D3B74522E7374796C655461675472616E73666F726D3D6A7228292C74522E736574417474726962757465733D567228292C74522E696E736572743D467228292E62696E64286E756C6C2C226865616422292C74522E646F6D4150493D4F7228';
wwv_flow_imp.g_varchar2_table(16361) := '292C74522E696E736572745374796C65456C656D656E743D487228292C4E7228292865522E412C7452292C65522E41262665522E412E6C6F63616C73262665522E412E6C6F63616C733B636C617373206E5220657874656E6473204A417B636F6E737472';
wwv_flow_imp.g_varchar2_table(16362) := '7563746F722865297B73757065722865292C746869732E646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270';
wwv_flow_imp.g_varchar2_table(16363) := '726573656E746174696F6E22292C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E646F6D4E6F64652E736574436C6173734E616D652822766965772D72756C657273';
wwv_flow_imp.g_varchar2_table(16364) := '22292C746869732E5F72656E646572656452756C6572733D5B5D3B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B746869732E5F72756C6572733D742E67657428313032292C746869732E';
wwv_flow_imp.g_varchar2_table(16365) := '5F7479706963616C48616C66776964746843686172616374657257696474683D742E676574283530292E7479706963616C48616C66776964746843686172616374657257696474687D646973706F736528297B73757065722E646973706F736528297D6F';
wwv_flow_imp.g_varchar2_table(16366) := '6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B72657475726E20746869732E5F72756C6572733D742E67657428313032292C';
wwv_flow_imp.g_varchar2_table(16367) := '746869732E5F7479706963616C48616C66776964746843686172616374657257696474683D742E676574283530292E7479706963616C48616C66776964746843686172616374657257696474682C21307D6F6E5363726F6C6C4368616E6765642865297B';
wwv_flow_imp.g_varchar2_table(16368) := '72657475726E20652E7363726F6C6C4865696768744368616E6765647D7072657061726552656E6465722865297B7D5F656E7375726552756C657273436F756E7428297B636F6E737420653D746869732E5F72656E646572656452756C6572732E6C656E';
wwv_flow_imp.g_varchar2_table(16369) := '6774682C743D746869732E5F72756C6572732E6C656E6774683B696628653D3D3D742972657475726E3B696628653C74297B636F6E73747B74616253697A653A6E7D3D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E676574';
wwv_flow_imp.g_varchar2_table(16370) := '4F7074696F6E7328292C693D6E3B6C6574206F3D742D653B666F72283B6F3E303B297B636F6E737420653D734528646F63756D656E742E637265617465456C656D656E7428226469762229293B652E736574436C6173734E616D652822766965772D7275';
wwv_flow_imp.g_varchar2_table(16371) := '6C657222292C652E73657457696474682869292C746869732E646F6D4E6F64652E617070656E644368696C642865292C746869732E5F72656E646572656452756C6572732E707573682865292C6F2D2D7D72657475726E7D6C6574206E3D652D743B666F';
wwv_flow_imp.g_varchar2_table(16372) := '72283B6E3E303B297B636F6E737420653D746869732E5F72656E646572656452756C6572732E706F7028293B746869732E646F6D4E6F64652E72656D6F76654368696C642865292C6E2D2D7D7D72656E6465722865297B746869732E5F656E7375726552';
wwv_flow_imp.g_varchar2_table(16373) := '756C657273436F756E7428293B666F72286C657420743D302C6E3D746869732E5F72756C6572732E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D746869732E5F72656E646572656452756C6572735B745D2C693D746869732E5F72756C65';
wwv_flow_imp.g_varchar2_table(16374) := '72735B745D3B6E2E736574426F78536861646F7728692E636F6C6F723F6031707820302030203020247B692E636F6C6F727D20696E736574603A2222292C6E2E736574486569676874284D6174682E6D696E28652E7363726F6C6C4865696768742C3165';
wwv_flow_imp.g_varchar2_table(16375) := '3629292C6E2E7365744C65667428692E636F6C756D6E2A746869732E5F7479706963616C48616C6677696474684368617261637465725769647468297D7D7D7661722069523D6E2839313333292C6F523D7B7D3B6F522E7374796C655461675472616E73';
wwv_flow_imp.g_varchar2_table(16376) := '666F726D3D6A7228292C6F522E736574417474726962757465733D567228292C6F522E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6F522E646F6D4150493D4F7228292C6F522E696E736572745374796C65456C656D656E';
wwv_flow_imp.g_varchar2_table(16377) := '743D487228292C4E7228292869522E412C6F52292C69522E41262669522E412E6C6F63616C73262669522E412E6C6F63616C733B636C61737320735220657874656E6473204A417B636F6E7374727563746F722865297B73757065722865292C74686973';
wwv_flow_imp.g_varchar2_table(16378) := '2E5F7363726F6C6C546F703D302C746869732E5F77696474683D302C746869732E5F757064617465576964746828292C746869732E5F73686F756C6453686F773D21313B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174';
wwv_flow_imp.g_varchar2_table(16379) := '696F6E2E6F7074696F6E732E67657428313033293B746869732E5F757365536861646F77733D742E757365536861646F77732C746869732E5F646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C74';
wwv_flow_imp.g_varchar2_table(16380) := '6869732E5F646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522297D6469';
wwv_flow_imp.g_varchar2_table(16381) := '73706F736528297B73757065722E646973706F736528297D5F75706461746553686F756C6453686F7728297B636F6E737420653D746869732E5F757365536861646F77732626746869732E5F7363726F6C6C546F703E303B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(16382) := '5F73686F756C6453686F77213D3D65262628746869732E5F73686F756C6453686F773D652C2130297D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D5F757064617465576964746828297B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(16383) := '69732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435293B303D3D3D652E6D696E696D61702E72656E6465724D696E696D61707C7C652E6D696E696D61702E6D696E696D617057696474683E302626303D';
wwv_flow_imp.g_varchar2_table(16384) := '3D3D652E6D696E696D61702E6D696E696D61704C6566743F746869732E5F77696474683D652E77696474683A746869732E5F77696474683D652E77696474682D652E766572746963616C5363726F6C6C62617257696474687D6F6E436F6E666967757261';
wwv_flow_imp.g_varchar2_table(16385) := '74696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313033293B72657475726E20746869732E5F757365536861646F77733D742E757365536861';
wwv_flow_imp.g_varchar2_table(16386) := '646F77732C746869732E5F757064617465576964746828292C746869732E5F75706461746553686F756C6453686F7728292C21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20746869732E5F7363726F6C6C546F703D652E736372';
wwv_flow_imp.g_varchar2_table(16387) := '6F6C6C546F702C746869732E5F75706461746553686F756C6453686F7728297D7072657061726552656E6465722865297B7D72656E6465722865297B746869732E5F646F6D4E6F64652E736574576964746828746869732E5F7769647468292C74686973';
wwv_flow_imp.g_varchar2_table(16388) := '2E5F646F6D4E6F64652E736574436C6173734E616D6528746869732E5F73686F756C6453686F773F227363726F6C6C2D6465636F726174696F6E223A2222297D7D7661722072523D6E2838383239292C61523D7B7D3B61522E7374796C65546167547261';
wwv_flow_imp.g_varchar2_table(16389) := '6E73666F726D3D6A7228292C61522E736574417474726962757465733D567228292C61522E696E736572743D467228292E62696E64286E756C6C2C226865616422292C61522E646F6D4150493D4F7228292C61522E696E736572745374796C65456C656D';
wwv_flow_imp.g_varchar2_table(16390) := '656E743D487228292C4E7228292872522E412C6152292C72522E41262672522E412E6C6F63616C73262672522E412E6C6F63616C733B636C617373206C527B636F6E7374727563746F722865297B746869732E6C6566743D652E6C6566742C746869732E';
wwv_flow_imp.g_varchar2_table(16391) := '77696474683D652E77696474682C746869732E73746172745374796C653D6E756C6C2C746869732E656E645374796C653D6E756C6C7D7D636C6173732063527B636F6E7374727563746F7228652C74297B746869732E6C696E654E756D6265723D652C74';
wwv_flow_imp.g_varchar2_table(16392) := '6869732E72616E6765733D747D7D66756E6374696F6E2064522865297B72657475726E206E6577206C522865297D66756E6374696F6E2068522865297B72657475726E206E657720635228652E6C696E654E756D6265722C652E72616E6765732E6D6170';
wwv_flow_imp.g_varchar2_table(16393) := '28645229297D636C61737320755220657874656E6473206F507B636F6E7374727563746F722865297B737570657228292C746869732E5F70726576696F75734672616D6556697369626C6552616E676573576974685374796C653D5B5D2C746869732E5F';
wwv_flow_imp.g_varchar2_table(16394) := '636F6E746578743D653B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B746869732E5F726F756E64656453656C656374696F6E3D742E67657428313031292C746869732E5F747970696361';
wwv_flow_imp.g_varchar2_table(16395) := '6C48616C66776964746843686172616374657257696474683D742E676574283530292E7479706963616C48616C66776964746843686172616374657257696474682C746869732E5F73656C656374696F6E733D5B5D2C746869732E5F72656E6465725265';
wwv_flow_imp.g_varchar2_table(16396) := '73756C743D6E756C6C2C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E';
wwv_flow_imp.g_varchar2_table(16397) := '5F72656E646572526573756C743D6E756C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074';
wwv_flow_imp.g_varchar2_table(16398) := '696F6E733B72657475726E20746869732E5F726F756E64656453656C656374696F6E3D742E67657428313031292C746869732E5F7479706963616C48616C66776964746843686172616374657257696474683D742E676574283530292E7479706963616C';
wwv_flow_imp.g_varchar2_table(16399) := '48616C66776964746843686172616374657257696474682C21307D6F6E437572736F7253746174654368616E6765642865297B72657475726E20746869732E5F73656C656374696F6E733D652E73656C656374696F6E732E736C6963652830292C21307D';
wwv_flow_imp.g_varchar2_table(16400) := '6F6E4465636F726174696F6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B';
wwv_flow_imp.g_varchar2_table(16401) := '72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D6F6E5A6F6E65734368616E6765642865297B';
wwv_flow_imp.g_varchar2_table(16402) := '72657475726E21307D5F76697369626C6552616E67657348617665476170732865297B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B29696628655B745D2E72616E6765732E6C656E6774683E312972657475726E21303B72';
wwv_flow_imp.g_varchar2_table(16403) := '657475726E21317D5F656E7269636856697369626C6552616E676573576974685374796C6528652C742C6E297B636F6E737420693D746869732E5F7479706963616C48616C66776964746843686172616374657257696474682F343B6C6574206F3D6E75';
wwv_flow_imp.g_varchar2_table(16404) := '6C6C2C733D6E756C6C3B6966286E26266E2E6C656E6774683E302626742E6C656E6774683E30297B636F6E737420693D745B305D2E6C696E654E756D6265723B696628693D3D3D652E73746172744C696E654E756D62657229666F72286C657420653D30';
wwv_flow_imp.g_varchar2_table(16405) := '3B216F2626653C6E2E6C656E6774683B652B2B296E5B655D2E6C696E654E756D6265723D3D3D692626286F3D6E5B655D2E72616E6765735B305D293B636F6E737420723D745B742E6C656E6774682D315D2E6C696E654E756D6265723B696628723D3D3D';
wwv_flow_imp.g_varchar2_table(16406) := '652E656E644C696E654E756D62657229666F72286C657420653D6E2E6C656E6774682D313B21732626653E3D303B652D2D296E5B655D2E6C696E654E756D6265723D3D3D72262628733D6E5B655D2E72616E6765735B305D293B6F2626216F2E73746172';
wwv_flow_imp.g_varchar2_table(16407) := '745374796C652626286F3D6E756C6C292C73262621732E73746172745374796C65262628733D6E756C6C297D666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E737420723D745B655D2E72616E6765735B305D2C61';
wwv_flow_imp.g_varchar2_table(16408) := '3D722E6C6566742C6C3D722E6C6566742B722E77696474682C633D7B746F703A302C626F74746F6D3A307D2C643D7B746F703A302C626F74746F6D3A307D3B696628653E30297B636F6E7374206E3D745B652D315D2E72616E6765735B305D2E6C656674';
wwv_flow_imp.g_varchar2_table(16409) := '2C6F3D745B652D315D2E72616E6765735B305D2E6C6566742B745B652D315D2E72616E6765735B305D2E77696474683B705228612D6E293C693F632E746F703D323A613E6E262628632E746F703D31292C7052286C2D6F293C693F642E746F703D323A6E';
wwv_flow_imp.g_varchar2_table(16410) := '3C6C26266C3C6F262628642E746F703D31297D656C7365206F262628632E746F703D6F2E73746172745374796C652E746F702C642E746F703D6F2E656E645374796C652E746F70293B696628652B313C6E297B636F6E7374206E3D745B652B315D2E7261';
wwv_flow_imp.g_varchar2_table(16411) := '6E6765735B305D2E6C6566742C6F3D745B652B315D2E72616E6765735B305D2E6C6566742B745B652B315D2E72616E6765735B305D2E77696474683B705228612D6E293C693F632E626F74746F6D3D323A6E3C612626613C6F262628632E626F74746F6D';
wwv_flow_imp.g_varchar2_table(16412) := '3D31292C7052286C2D6F293C693F642E626F74746F6D3D323A6C3C6F262628642E626F74746F6D3D31297D656C73652073262628632E626F74746F6D3D732E73746172745374796C652E626F74746F6D2C642E626F74746F6D3D732E656E645374796C65';
wwv_flow_imp.g_varchar2_table(16413) := '2E626F74746F6D293B722E73746172745374796C653D632C722E656E645374796C653D647D7D5F67657456697369626C6552616E676573576974685374796C6528652C742C6E297B636F6E737420693D28742E6C696E657356697369626C6552616E6765';
wwv_flow_imp.g_varchar2_table(16414) := '73466F7252616E676528652C2130297C7C5B5D292E6D6170286852293B72657475726E21746869732E5F76697369626C6552616E67657348617665476170732869292626746869732E5F726F756E64656453656C656374696F6E2626746869732E5F656E';
wwv_flow_imp.g_varchar2_table(16415) := '7269636856697369626C6552616E676573576974685374796C6528742E76697369626C6552616E67652C692C6E292C697D5F63726561746553656C656374696F6E506965636528652C742C6E2C692C6F297B72657475726E273C64697620636C6173733D';
wwv_flow_imp.g_varchar2_table(16416) := '2263736C7220272B6E2B2722207374796C653D22746F703A272B652E746F537472696E6728292B2270783B626F74746F6D3A222B742E746F537472696E6728292B2270783B6C6566743A222B692E746F537472696E6728292B2270783B77696474683A22';
wwv_flow_imp.g_varchar2_table(16417) := '2B6F2E746F537472696E6728292B2770783B223E3C2F6469763E277D5F61637475616C52656E6465724F6E6553656C656374696F6E28652C742C6E2C69297B696628303D3D3D692E6C656E6774682972657475726E3B636F6E7374206F3D2121695B305D';
wwv_flow_imp.g_varchar2_table(16418) := '2E72616E6765735B305D2E73746172745374796C652C733D695B305D2E6C696E654E756D6265722C723D695B692E6C656E6774682D315D2E6C696E654E756D6265723B666F72286C657420613D302C6C3D692E6C656E6774683B613C6C3B612B2B297B63';
wwv_flow_imp.g_varchar2_table(16419) := '6F6E7374206C3D695B615D2C633D6C2E6C696E654E756D6265722C643D632D742C683D6E2626633D3D3D733F313A302C753D6E262663213D3D732626633D3D3D723F313A303B6C657420703D22222C673D22223B666F72286C657420653D302C743D6C2E';
wwv_flow_imp.g_varchar2_table(16420) := '72616E6765732E6C656E6774683B653C743B652B2B297B636F6E737420743D6C2E72616E6765735B655D3B6966286F297B636F6E737420653D742E73746172745374796C652C6E3D742E656E645374796C653B696628313D3D3D652E746F707C7C313D3D';
wwv_flow_imp.g_varchar2_table(16421) := '3D652E626F74746F6D297B702B3D746869732E5F63726561746553656C656374696F6E506965636528682C752C75522E53454C454354494F4E5F434C4153535F4E414D452C742E6C6566742D75522E524F554E4445445F50494543455F57494454482C75';
wwv_flow_imp.g_varchar2_table(16422) := '522E524F554E4445445F50494543455F5749445448293B6C6574206E3D75522E454449544F525F4241434B47524F554E445F434C4153535F4E414D453B313D3D3D652E746F702626286E2B3D2220222B75522E53454C454354494F4E5F544F505F524947';
wwv_flow_imp.g_varchar2_table(16423) := '4854292C313D3D3D652E626F74746F6D2626286E2B3D2220222B75522E53454C454354494F4E5F424F54544F4D5F5249474854292C702B3D746869732E5F63726561746553656C656374696F6E506965636528682C752C6E2C742E6C6566742D75522E52';
wwv_flow_imp.g_varchar2_table(16424) := '4F554E4445445F50494543455F57494454482C75522E524F554E4445445F50494543455F5749445448297D696628313D3D3D6E2E746F707C7C313D3D3D6E2E626F74746F6D297B702B3D746869732E5F63726561746553656C656374696F6E5069656365';
wwv_flow_imp.g_varchar2_table(16425) := '28682C752C75522E53454C454354494F4E5F434C4153535F4E414D452C742E6C6566742B742E77696474682C75522E524F554E4445445F50494543455F5749445448293B6C657420653D75522E454449544F525F4241434B47524F554E445F434C415353';
wwv_flow_imp.g_varchar2_table(16426) := '5F4E414D453B313D3D3D6E2E746F70262628652B3D2220222B75522E53454C454354494F4E5F544F505F4C454654292C313D3D3D6E2E626F74746F6D262628652B3D2220222B75522E53454C454354494F4E5F424F54544F4D5F4C454654292C702B3D74';
wwv_flow_imp.g_varchar2_table(16427) := '6869732E5F63726561746553656C656374696F6E506965636528682C752C652C742E6C6566742B742E77696474682C75522E524F554E4445445F50494543455F5749445448297D7D6C6574206E3D75522E53454C454354494F4E5F434C4153535F4E414D';
wwv_flow_imp.g_varchar2_table(16428) := '453B6966286F297B636F6E737420653D742E73746172745374796C652C693D742E656E645374796C653B303D3D3D652E746F702626286E2B3D2220222B75522E53454C454354494F4E5F544F505F4C454654292C303D3D3D652E626F74746F6D2626286E';
wwv_flow_imp.g_varchar2_table(16429) := '2B3D2220222B75522E53454C454354494F4E5F424F54544F4D5F4C454654292C303D3D3D692E746F702626286E2B3D2220222B75522E53454C454354494F4E5F544F505F5249474854292C303D3D3D692E626F74746F6D2626286E2B3D2220222B75522E';
wwv_flow_imp.g_varchar2_table(16430) := '53454C454354494F4E5F424F54544F4D5F5249474854297D672B3D746869732E5F63726561746553656C656374696F6E506965636528682C752C6E2C742E6C6566742C742E7769647468297D655B645D5B305D2B3D702C655B645D5B315D2B3D677D7D70';
wwv_flow_imp.g_varchar2_table(16431) := '72657061726552656E6465722865297B636F6E737420743D5B5D2C6E3D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C693D652E76697369626C6552616E67652E656E644C696E654E756D6265723B666F72286C65742065';
wwv_flow_imp.g_varchar2_table(16432) := '3D6E3B653C3D693B652B2B29745B652D6E5D3D5B22222C22225D3B636F6E7374206F3D5B5D3B666F72286C657420693D302C733D746869732E5F73656C656374696F6E732E6C656E6774683B693C733B692B2B297B636F6E737420733D746869732E5F73';
wwv_flow_imp.g_varchar2_table(16433) := '656C656374696F6E735B695D3B696628732E6973456D7074792829297B6F5B695D3D6E756C6C3B636F6E74696E75657D636F6E737420723D746869732E5F67657456697369626C6552616E676573576974685374796C6528732C652C746869732E5F7072';
wwv_flow_imp.g_varchar2_table(16434) := '6576696F75734672616D6556697369626C6552616E676573576974685374796C655B695D293B6F5B695D3D722C746869732E5F61637475616C52656E6465724F6E6553656C656374696F6E28742C6E2C746869732E5F73656C656374696F6E732E6C656E';
wwv_flow_imp.g_varchar2_table(16435) := '6774683E312C72297D746869732E5F70726576696F75734672616D6556697369626C6552616E676573576974685374796C653D6F2C746869732E5F72656E646572526573756C743D742E6D61702828285B652C745D293D3E652B7429297D72656E646572';
wwv_flow_imp.g_varchar2_table(16436) := '28652C74297B69662821746869732E5F72656E646572526573756C742972657475726E22223B636F6E7374206E3D742D653B72657475726E206E3C307C7C6E3E3D746869732E5F72656E646572526573756C742E6C656E6774683F22223A746869732E5F';
wwv_flow_imp.g_varchar2_table(16437) := '72656E646572526573756C745B6E5D7D7D66756E6374696F6E2070522865297B72657475726E20653C303F2D653A657D75522E53454C454354494F4E5F434C4153535F4E414D453D2273656C65637465642D74657874222C75522E53454C454354494F4E';
wwv_flow_imp.g_varchar2_table(16438) := '5F544F505F4C4546543D22746F702D6C6566742D726164697573222C75522E53454C454354494F4E5F424F54544F4D5F4C4546543D22626F74746F6D2D6C6566742D726164697573222C75522E53454C454354494F4E5F544F505F52494748543D22746F';
wwv_flow_imp.g_varchar2_table(16439) := '702D72696768742D726164697573222C75522E53454C454354494F4E5F424F54544F4D5F52494748543D22626F74746F6D2D72696768742D726164697573222C75522E454449544F525F4241434B47524F554E445F434C4153535F4E414D453D226D6F6E';
wwv_flow_imp.g_varchar2_table(16440) := '61636F2D656469746F722D6261636B67726F756E64222C75522E524F554E4445445F50494543455F57494454483D31302C5662282828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F72287566293B6E2626216E2E69735472616E73706172';
wwv_flow_imp.g_varchar2_table(16441) := '656E7428292626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E766965772D6C696E65207370616E2E696E6C696E652D73656C65637465642D74657874207B20636F6C6F723A20247B6E7D3B207D60297D29293B7661722067522C6D';
wwv_flow_imp.g_varchar2_table(16442) := '523D6E2832323839292C66523D7B7D3B66522E7374796C655461675472616E73666F726D3D6A7228292C66522E736574417474726962757465733D567228292C66522E696E736572743D467228292E62696E64286E756C6C2C226865616422292C66522E';
wwv_flow_imp.g_varchar2_table(16443) := '646F6D4150493D4F7228292C66522E696E736572745374796C65456C656D656E743D487228292C4E722829286D522E412C6652292C6D522E4126266D522E412E6C6F63616C7326266D522E412E6C6F63616C733B636C6173732076527B636F6E73747275';
wwv_flow_imp.g_varchar2_table(16444) := '63746F7228652C742C6E2C692C6F2C732C72297B746869732E746F703D652C746869732E6C6566743D742C746869732E70616464696E674C6566743D6E2C746869732E77696474683D692C746869732E6865696768743D6F2C746869732E74657874436F';
wwv_flow_imp.g_varchar2_table(16445) := '6E74656E743D732C746869732E74657874436F6E74656E74436C6173734E616D653D727D7D2166756E6374696F6E2865297B655B652E53696E676C653D305D3D2253696E676C65222C655B652E4D756C74695072696D6172793D315D3D224D756C746950';
wwv_flow_imp.g_varchar2_table(16446) := '72696D617279222C655B652E4D756C74695365636F6E646172793D325D3D224D756C74695365636F6E64617279227D2867527C7C2867523D7B7D29293B636C6173732062527B636F6E7374727563746F7228652C74297B746869732E5F636F6E74657874';
wwv_flow_imp.g_varchar2_table(16447) := '3D653B636F6E7374206E3D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C693D6E2E676574283530293B746869732E5F637572736F725374796C653D6E2E676574283238292C746869732E5F6C696E65486569';
wwv_flow_imp.g_varchar2_table(16448) := '6768743D6E2E676574283637292C746869732E5F7479706963616C48616C66776964746843686172616374657257696474683D692E7479706963616C48616C66776964746843686172616374657257696474682C746869732E5F6C696E65437572736F72';
wwv_flow_imp.g_varchar2_table(16449) := '57696474683D4D6174682E6D696E286E2E676574283331292C746869732E5F7479706963616C48616C6677696474684368617261637465725769647468292C746869732E5F697356697369626C653D21302C746869732E5F646F6D4E6F64653D73452864';
wwv_flow_imp.g_varchar2_table(16450) := '6F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F646F6D4E6F64652E736574436C6173734E616D652860637572736F7220247B68507D60292C746869732E5F646F6D4E6F64652E73657448656967687428746869';
wwv_flow_imp.g_varchar2_table(16451) := '732E5F6C696E65486569676874292C746869732E5F646F6D4E6F64652E736574546F702830292C746869732E5F646F6D4E6F64652E7365744C6566742830292C724528746869732E5F646F6D4E6F64652C69292C746869732E5F646F6D4E6F64652E7365';
wwv_flow_imp.g_varchar2_table(16452) := '74446973706C617928226E6F6E6522292C746869732E5F706F736974696F6E3D6E6577206D6328312C31292C746869732E5F706C7572616C697479436C6173733D22222C746869732E736574506C7572616C6974792874292C746869732E5F6C61737452';
wwv_flow_imp.g_varchar2_table(16453) := '656E6465726564436F6E74656E743D22222C746869732E5F72656E646572446174613D6E756C6C7D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(16454) := '5F706F736974696F6E7D736574506C7572616C6974792865297B7377697463682865297B64656661756C743A636173652067522E53696E676C653A746869732E5F706C7572616C697479436C6173733D22223B627265616B3B636173652067522E4D756C';
wwv_flow_imp.g_varchar2_table(16455) := '74695072696D6172793A746869732E5F706C7572616C697479436C6173733D22637572736F722D7072696D617279223B627265616B3B636173652067522E4D756C74695365636F6E646172793A746869732E5F706C7572616C697479436C6173733D2263';
wwv_flow_imp.g_varchar2_table(16456) := '7572736F722D7365636F6E64617279227D7D73686F7728297B746869732E5F697356697369626C657C7C28746869732E5F646F6D4E6F64652E7365745669736962696C6974792822696E686572697422292C746869732E5F697356697369626C653D2130';
wwv_flow_imp.g_varchar2_table(16457) := '297D6869646528297B746869732E5F697356697369626C65262628746869732E5F646F6D4E6F64652E7365745669736962696C697479282268696464656E22292C746869732E5F697356697369626C653D2131297D6F6E436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(16458) := '4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E676574283530293B72657475726E20746869732E5F637572736F725374796C653D742E676574283238';
wwv_flow_imp.g_varchar2_table(16459) := '292C746869732E5F6C696E654865696768743D742E676574283637292C746869732E5F7479706963616C48616C66776964746843686172616374657257696474683D6E2E7479706963616C48616C66776964746843686172616374657257696474682C74';
wwv_flow_imp.g_varchar2_table(16460) := '6869732E5F6C696E65437572736F7257696474683D4D6174682E6D696E28742E676574283331292C746869732E5F7479706963616C48616C6677696474684368617261637465725769647468292C724528746869732E5F646F6D4E6F64652C6E292C2130';
wwv_flow_imp.g_varchar2_table(16461) := '7D6F6E437572736F72506F736974696F6E4368616E67656428652C74297B72657475726E20746869732E5F646F6D4E6F64652E646F6D4E6F64652E7374796C652E7472616E736974696F6E50726F70657274793D743F226E6F6E65223A22222C74686973';
wwv_flow_imp.g_varchar2_table(16462) := '2E5F706F736974696F6E3D652C21307D5F6765744772617068656D654177617265506F736974696F6E28297B636F6E73747B6C696E654E756D6265723A652C636F6C756D6E3A747D3D746869732E5F706F736974696F6E2C6E3D746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(16463) := '6578742E766965774D6F64656C2E6765744C696E65436F6E74656E742865292C5B692C6F5D3D66756E6374696F6E28652C74297B743E302626496928652E63686172436F64654174287429292626742D2D3B636F6E7374206E3D742B4F6928652C74293B';
wwv_flow_imp.g_varchar2_table(16464) := '72657475726E5B6E2D526928652C6E292C6E5D7D286E2C742D31293B72657475726E5B6E6577206D6328652C692B31292C6E2E737562737472696E6728692C6F295D7D5F7072657061726552656E6465722865297B6C657420743D22222C6E3D22223B63';
wwv_flow_imp.g_varchar2_table(16465) := '6F6E73745B692C6F5D3D746869732E5F6765744772617068656D654177617265506F736974696F6E28293B696628746869732E5F637572736F725374796C653D3D3D494C2E4C696E657C7C746869732E5F637572736F725374796C653D3D3D494C2E4C69';
wwv_flow_imp.g_varchar2_table(16466) := '6E655468696E297B636F6E737420733D652E76697369626C6552616E6765466F72506F736974696F6E2869293B69662821737C7C732E6F75747369646552656E64657265644C696E652972657475726E206E756C6C3B636F6E737420723D727328746869';
wwv_flow_imp.g_varchar2_table(16467) := '732E5F646F6D4E6F64652E646F6D4E6F6465293B6C657420613B746869732E5F637572736F725374796C653D3D3D494C2E4C696E653F28613D777228722C746869732E5F6C696E65437572736F7257696474683E303F746869732E5F6C696E6543757273';
wwv_flow_imp.g_varchar2_table(16468) := '6F7257696474683A32292C613E32262628743D6F2C6E3D746869732E5F676574546F6B656E436C6173734E616D6528692929293A613D777228722C31293B6C6574206C3D732E6C6566742C633D303B613E3D3226266C3E3D31262628633D312C6C2D3D63';
wwv_flow_imp.g_varchar2_table(16469) := '293B636F6E737420643D652E676574566572746963616C4F6666736574466F724C696E654E756D62657228692E6C696E654E756D626572292D652E6269674E756D6265727344656C74613B72657475726E206E657720765228642C6C2C632C612C746869';
wwv_flow_imp.g_varchar2_table(16470) := '732E5F6C696E654865696768742C742C6E297D636F6E737420733D652E6C696E657356697369626C6552616E676573466F7252616E6765286E657720726828692E6C696E654E756D6265722C692E636F6C756D6E2C692E6C696E654E756D6265722C692E';
wwv_flow_imp.g_varchar2_table(16471) := '636F6C756D6E2B6F2E6C656E677468292C2131293B69662821737C7C303D3D3D732E6C656E6774682972657475726E206E756C6C3B636F6E737420723D735B305D3B696628722E6F75747369646552656E64657265644C696E657C7C303D3D3D722E7261';
wwv_flow_imp.g_varchar2_table(16472) := '6E6765732E6C656E6774682972657475726E206E756C6C3B636F6E737420613D722E72616E6765735B305D2C6C3D225C74223D3D3D6F7C7C612E77696474683C313F746869732E5F7479706963616C48616C667769647468436861726163746572576964';
wwv_flow_imp.g_varchar2_table(16473) := '74683A612E77696474683B746869732E5F637572736F725374796C653D3D3D494C2E426C6F636B262628743D6F2C6E3D746869732E5F676574546F6B656E436C6173734E616D65286929293B6C657420633D652E676574566572746963616C4F66667365';
wwv_flow_imp.g_varchar2_table(16474) := '74466F724C696E654E756D62657228692E6C696E654E756D626572292D652E6269674E756D6265727344656C74612C643D746869732E5F6C696E654865696768743B72657475726E20746869732E5F637572736F725374796C65213D3D494C2E556E6465';
wwv_flow_imp.g_varchar2_table(16475) := '726C696E652626746869732E5F637572736F725374796C65213D3D494C2E556E6465726C696E655468696E7C7C28632B3D746869732E5F6C696E654865696768742D322C643D32292C6E657720765228632C612E6C6566742C302C6C2C642C742C6E297D';
wwv_flow_imp.g_varchar2_table(16476) := '5F676574546F6B656E436C6173734E616D652865297B636F6E737420743D746869732E5F636F6E746578742E766965774D6F64656C2E676574566965774C696E654461746128652E6C696E654E756D626572292C6E3D742E746F6B656E732E66696E6454';
wwv_flow_imp.g_varchar2_table(16477) := '6F6B656E496E64657841744F666673657428652E636F6C756D6E2D31293B72657475726E20742E746F6B656E732E676574436C6173734E616D65286E297D7072657061726552656E6465722865297B746869732E5F72656E646572446174613D74686973';
wwv_flow_imp.g_varchar2_table(16478) := '2E5F7072657061726552656E6465722865297D72656E6465722865297B72657475726E20746869732E5F72656E646572446174613F28746869732E5F6C61737452656E6465726564436F6E74656E74213D3D746869732E5F72656E646572446174612E74';
wwv_flow_imp.g_varchar2_table(16479) := '657874436F6E74656E74262628746869732E5F6C61737452656E6465726564436F6E74656E743D746869732E5F72656E646572446174612E74657874436F6E74656E742C746869732E5F646F6D4E6F64652E646F6D4E6F64652E74657874436F6E74656E';
wwv_flow_imp.g_varchar2_table(16480) := '743D746869732E5F6C61737452656E6465726564436F6E74656E74292C746869732E5F646F6D4E6F64652E736574436C6173734E616D652860637572736F7220247B746869732E5F706C7572616C697479436C6173737D20247B68507D20247B74686973';
wwv_flow_imp.g_varchar2_table(16481) := '2E5F72656E646572446174612E74657874436F6E74656E74436C6173734E616D657D60292C746869732E5F646F6D4E6F64652E736574446973706C61792822626C6F636B22292C746869732E5F646F6D4E6F64652E736574546F7028746869732E5F7265';
wwv_flow_imp.g_varchar2_table(16482) := '6E646572446174612E746F70292C746869732E5F646F6D4E6F64652E7365744C65667428746869732E5F72656E646572446174612E6C656674292C746869732E5F646F6D4E6F64652E73657450616464696E674C65667428746869732E5F72656E646572';
wwv_flow_imp.g_varchar2_table(16483) := '446174612E70616464696E674C656674292C746869732E5F646F6D4E6F64652E736574576964746828746869732E5F72656E646572446174612E7769647468292C746869732E5F646F6D4E6F64652E7365744C696E6548656967687428746869732E5F72';
wwv_flow_imp.g_varchar2_table(16484) := '656E646572446174612E686569676874292C746869732E5F646F6D4E6F64652E73657448656967687428746869732E5F72656E646572446174612E686569676874292C7B646F6D4E6F64653A746869732E5F646F6D4E6F64652E646F6D4E6F64652C706F';
wwv_flow_imp.g_varchar2_table(16485) := '736974696F6E3A746869732E5F706F736974696F6E2C636F6E74656E744C6566743A746869732E5F72656E646572446174612E6C6566742C6865696768743A746869732E5F72656E646572446174612E6865696768742C77696474683A327D293A287468';
wwv_flow_imp.g_varchar2_table(16486) := '69732E5F646F6D4E6F64652E736574446973706C617928226E6F6E6522292C6E756C6C297D7D636C617373205F5220657874656E6473204A417B636F6E7374727563746F722865297B73757065722865293B636F6E737420743D746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(16487) := '6578742E636F6E66696775726174696F6E2E6F7074696F6E733B746869732E5F726561644F6E6C793D742E676574283931292C746869732E5F637572736F72426C696E6B696E673D742E676574283236292C746869732E5F637572736F725374796C653D';
wwv_flow_imp.g_varchar2_table(16488) := '742E676574283238292C746869732E5F637572736F72536D6F6F74684361726574416E696D6174696F6E3D742E676574283237292C746869732E5F73656C656374696F6E4973456D7074793D21302C746869732E5F6973436F6D706F73696E67496E7075';
wwv_flow_imp.g_varchar2_table(16489) := '743D21312C746869732E5F697356697369626C653D21312C746869732E5F7072696D617279437572736F723D6E657720625228746869732E5F636F6E746578742C67522E53696E676C65292C746869732E5F7365636F6E64617279437572736F72733D5B';
wwv_flow_imp.g_varchar2_table(16490) := '5D2C746869732E5F72656E646572446174613D5B5D2C746869732E5F646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E5F646F6D4E6F64652E7365744174747269627574652822726F';
wwv_flow_imp.g_varchar2_table(16491) := '6C65222C2270726573656E746174696F6E22292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F757064617465446F6D436C6173734E616D6528292C74686973';
wwv_flow_imp.g_varchar2_table(16492) := '2E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F7072696D617279437572736F722E676574446F6D4E6F64652829292C746869732E5F7374617274437572736F72426C696E6B416E696D6174696F6E3D6E65772024742C746869732E';
wwv_flow_imp.g_varchar2_table(16493) := '5F637572736F72466C6174426C696E6B496E74657276616C3D6E6577206B732C746869732E5F626C696E6B696E67456E61626C65643D21312C746869732E5F656469746F72486173466F6375733D21312C746869732E5F757064617465426C696E6B696E';
wwv_flow_imp.g_varchar2_table(16494) := '6728297D646973706F736528297B73757065722E646973706F736528292C746869732E5F7374617274437572736F72426C696E6B416E696D6174696F6E2E646973706F736528292C746869732E5F637572736F72466C6174426C696E6B496E7465727661';
wwv_flow_imp.g_varchar2_table(16495) := '6C2E646973706F736528297D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D6F6E436F6D706F736974696F6E53746172742865297B72657475726E20746869732E5F6973436F6D706F73696E67496E7075743D2130';
wwv_flow_imp.g_varchar2_table(16496) := '2C746869732E5F757064617465426C696E6B696E6728292C21307D6F6E436F6D706F736974696F6E456E642865297B72657475726E20746869732E5F6973436F6D706F73696E67496E7075743D21312C746869732E5F757064617465426C696E6B696E67';
wwv_flow_imp.g_varchar2_table(16497) := '28292C21307D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E733B746869732E5F726561644F6E6C793D742E67657428393129';
wwv_flow_imp.g_varchar2_table(16498) := '2C746869732E5F637572736F72426C696E6B696E673D742E676574283236292C746869732E5F637572736F725374796C653D742E676574283238292C746869732E5F637572736F72536D6F6F74684361726574416E696D6174696F6E3D742E6765742832';
wwv_flow_imp.g_varchar2_table(16499) := '37292C746869732E5F757064617465426C696E6B696E6728292C746869732E5F757064617465446F6D436C6173734E616D6528292C746869732E5F7072696D617279437572736F722E6F6E436F6E66696775726174696F6E4368616E6765642865293B66';
wwv_flow_imp.g_varchar2_table(16500) := '6F72286C657420743D302C6E3D746869732E5F7365636F6E64617279437572736F72732E6C656E6774683B743C6E3B742B2B29746869732E5F7365636F6E64617279437572736F72735B745D2E6F6E436F6E66696775726174696F6E4368616E67656428';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(16501) := '65293B72657475726E21307D5F6F6E437572736F72506F736974696F6E4368616E67656428652C742C6E297B636F6E737420693D746869732E5F7365636F6E64617279437572736F72732E6C656E677468213D3D742E6C656E6774687C7C226578706C69';
wwv_flow_imp.g_varchar2_table(16502) := '636974223D3D3D746869732E5F637572736F72536D6F6F74684361726574416E696D6174696F6E262633213D3D6E3B696628746869732E5F7072696D617279437572736F722E736574506C7572616C69747928742E6C656E6774683F67522E4D756C7469';
wwv_flow_imp.g_varchar2_table(16503) := '5072696D6172793A67522E53696E676C65292C746869732E5F7072696D617279437572736F722E6F6E437572736F72506F736974696F6E4368616E67656428652C69292C746869732E5F757064617465426C696E6B696E6728292C746869732E5F736563';
wwv_flow_imp.g_varchar2_table(16504) := '6F6E64617279437572736F72732E6C656E6774683C742E6C656E677468297B636F6E737420653D742E6C656E6774682D746869732E5F7365636F6E64617279437572736F72732E6C656E6774683B666F72286C657420743D303B743C653B742B2B297B63';
wwv_flow_imp.g_varchar2_table(16505) := '6F6E737420653D6E657720625228746869732E5F636F6E746578742C67522E4D756C74695365636F6E64617279293B746869732E5F646F6D4E6F64652E646F6D4E6F64652E696E736572744265666F726528652E676574446F6D4E6F646528292E646F6D';
wwv_flow_imp.g_varchar2_table(16506) := '4E6F64652C746869732E5F7072696D617279437572736F722E676574446F6D4E6F646528292E646F6D4E6F64652E6E6578745369626C696E67292C746869732E5F7365636F6E64617279437572736F72732E707573682865297D7D656C73652069662874';
wwv_flow_imp.g_varchar2_table(16507) := '6869732E5F7365636F6E64617279437572736F72732E6C656E6774683E742E6C656E677468297B636F6E737420653D746869732E5F7365636F6E64617279437572736F72732E6C656E6774682D742E6C656E6774683B666F72286C657420743D303B743C';
wwv_flow_imp.g_varchar2_table(16508) := '653B742B2B29746869732E5F646F6D4E6F64652E72656D6F76654368696C6428746869732E5F7365636F6E64617279437572736F72735B305D2E676574446F6D4E6F64652829292C746869732E5F7365636F6E64617279437572736F72732E73706C6963';
wwv_flow_imp.g_varchar2_table(16509) := '6528302C31297D666F72286C657420653D303B653C742E6C656E6774683B652B2B29746869732E5F7365636F6E64617279437572736F72735B655D2E6F6E437572736F72506F736974696F6E4368616E67656428745B655D2C69297D6F6E437572736F72';
wwv_flow_imp.g_varchar2_table(16510) := '53746174654368616E6765642865297B636F6E737420743D5B5D3B666F72286C6574206E3D302C693D652E73656C656374696F6E732E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D652E73656C656374696F6E735B6E5D2E676574506F736974696F';
wwv_flow_imp.g_varchar2_table(16511) := '6E28293B746869732E5F6F6E437572736F72506F736974696F6E4368616E67656428745B305D2C742E736C6963652831292C652E726561736F6E293B636F6E7374206E3D652E73656C656374696F6E735B305D2E6973456D70747928293B72657475726E';
wwv_flow_imp.g_varchar2_table(16512) := '20746869732E5F73656C656374696F6E4973456D707479213D3D6E262628746869732E5F73656C656374696F6E4973456D7074793D6E2C746869732E5F757064617465446F6D436C6173734E616D652829292C21307D6F6E4465636F726174696F6E7343';
wwv_flow_imp.g_varchar2_table(16513) := '68616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E466F6375734368616E6765642865297B72657475726E20746869732E5F656469746F72486173466F6375733D652E6973466F63757365642C74';
wwv_flow_imp.g_varchar2_table(16514) := '6869732E5F757064617465426C696E6B696E6728292C21317D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B7265';
wwv_flow_imp.g_varchar2_table(16515) := '7475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E21307D6F6E546F6B656E734368616E6765642865297B636F6E737420743D743D3E7B666F72286C6574206E3D302C693D652E72616E6765732E6C656E6774683B6E3C693B';
wwv_flow_imp.g_varchar2_table(16516) := '6E2B2B29696628652E72616E6765735B6E5D2E66726F6D4C696E654E756D6265723C3D742E6C696E654E756D6265722626742E6C696E654E756D6265723C3D652E72616E6765735B6E5D2E746F4C696E654E756D6265722972657475726E21303B726574';
wwv_flow_imp.g_varchar2_table(16517) := '75726E21317D3B6966287428746869732E5F7072696D617279437572736F722E676574506F736974696F6E2829292972657475726E21303B666F7228636F6E73742065206F6620746869732E5F7365636F6E64617279437572736F727329696628742865';
wwv_flow_imp.g_varchar2_table(16518) := '2E676574506F736974696F6E2829292972657475726E21303B72657475726E21317D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D5F676574437572736F72426C696E6B696E6728297B72657475726E20746869732E5F6973436F6D';
wwv_flow_imp.g_varchar2_table(16519) := '706F73696E67496E7075743F303A746869732E5F656469746F72486173466F6375733F746869732E5F726561644F6E6C793F353A746869732E5F637572736F72426C696E6B696E673A307D5F757064617465426C696E6B696E6728297B746869732E5F73';
wwv_flow_imp.g_varchar2_table(16520) := '74617274437572736F72426C696E6B416E696D6174696F6E2E63616E63656C28292C746869732E5F637572736F72466C6174426C696E6B496E74657276616C2E63616E63656C28293B636F6E737420653D746869732E5F676574437572736F72426C696E';
wwv_flow_imp.g_varchar2_table(16521) := '6B696E6728292C743D303D3D3D652C6E3D353D3D3D653B743F746869732E5F6869646528293A746869732E5F73686F7728292C746869732E5F626C696E6B696E67456E61626C65643D21312C746869732E5F757064617465446F6D436C6173734E616D65';
wwv_flow_imp.g_varchar2_table(16522) := '28292C747C7C6E7C7C28313D3D3D653F746869732E5F637572736F72466C6174426C696E6B496E74657276616C2E63616E63656C416E64536574282828293D3E7B746869732E5F697356697369626C653F746869732E5F6869646528293A746869732E5F';
wwv_flow_imp.g_varchar2_table(16523) := '73686F7728297D292C5F522E424C494E4B5F494E54455256414C2C727328746869732E5F646F6D4E6F64652E646F6D4E6F646529293A746869732E5F7374617274437572736F72426C696E6B416E696D6174696F6E2E73657449664E6F74536574282828';
wwv_flow_imp.g_varchar2_table(16524) := '293D3E7B746869732E5F626C696E6B696E67456E61626C65643D21302C746869732E5F757064617465446F6D436C6173734E616D6528297D292C5F522E424C494E4B5F494E54455256414C29297D5F757064617465446F6D436C6173734E616D6528297B';
wwv_flow_imp.g_varchar2_table(16525) := '746869732E5F646F6D4E6F64652E736574436C6173734E616D6528746869732E5F676574436C6173734E616D652829297D5F676574436C6173734E616D6528297B6C657420653D22637572736F72732D6C61796572223B73776974636828746869732E5F';
wwv_flow_imp.g_varchar2_table(16526) := '73656C656374696F6E4973456D7074797C7C28652B3D22206861732D73656C656374696F6E22292C746869732E5F637572736F725374796C65297B6361736520494C2E4C696E653A652B3D2220637572736F722D6C696E652D7374796C65223B62726561';
wwv_flow_imp.g_varchar2_table(16527) := '6B3B6361736520494C2E426C6F636B3A652B3D2220637572736F722D626C6F636B2D7374796C65223B627265616B3B6361736520494C2E556E6465726C696E653A652B3D2220637572736F722D756E6465726C696E652D7374796C65223B627265616B3B';
wwv_flow_imp.g_varchar2_table(16528) := '6361736520494C2E4C696E655468696E3A652B3D2220637572736F722D6C696E652D7468696E2D7374796C65223B627265616B3B6361736520494C2E426C6F636B4F75746C696E653A652B3D2220637572736F722D626C6F636B2D6F75746C696E652D73';
wwv_flow_imp.g_varchar2_table(16529) := '74796C65223B627265616B3B6361736520494C2E556E6465726C696E655468696E3A652B3D2220637572736F722D756E6465726C696E652D7468696E2D7374796C65223B627265616B3B64656661756C743A652B3D2220637572736F722D6C696E652D73';
wwv_flow_imp.g_varchar2_table(16530) := '74796C65227D696628746869732E5F626C696E6B696E67456E61626C65642973776974636828746869732E5F676574437572736F72426C696E6B696E672829297B6361736520313A652B3D2220637572736F722D626C696E6B223B627265616B3B636173';
wwv_flow_imp.g_varchar2_table(16531) := '6520323A652B3D2220637572736F722D736D6F6F7468223B627265616B3B6361736520333A652B3D2220637572736F722D7068617365223B627265616B3B6361736520343A652B3D2220637572736F722D657870616E64223B627265616B3B6465666175';
wwv_flow_imp.g_varchar2_table(16532) := '6C743A652B3D2220637572736F722D736F6C6964227D656C736520652B3D2220637572736F722D736F6C6964223B72657475726E226F6E22213D3D746869732E5F637572736F72536D6F6F74684361726574416E696D6174696F6E2626226578706C6963';
wwv_flow_imp.g_varchar2_table(16533) := '697422213D3D746869732E5F637572736F72536D6F6F74684361726574416E696D6174696F6E7C7C28652B3D2220637572736F722D736D6F6F74682D63617265742D616E696D6174696F6E22292C657D5F73686F7728297B746869732E5F7072696D6172';
wwv_flow_imp.g_varchar2_table(16534) := '79437572736F722E73686F7728293B666F72286C657420653D302C743D746869732E5F7365636F6E64617279437572736F72732E6C656E6774683B653C743B652B2B29746869732E5F7365636F6E64617279437572736F72735B655D2E73686F7728293B';
wwv_flow_imp.g_varchar2_table(16535) := '746869732E5F697356697369626C653D21307D5F6869646528297B746869732E5F7072696D617279437572736F722E6869646528293B666F72286C657420653D302C743D746869732E5F7365636F6E64617279437572736F72732E6C656E6774683B653C';
wwv_flow_imp.g_varchar2_table(16536) := '743B652B2B29746869732E5F7365636F6E64617279437572736F72735B655D2E6869646528293B746869732E5F697356697369626C653D21317D7072657061726552656E6465722865297B746869732E5F7072696D617279437572736F722E7072657061';
wwv_flow_imp.g_varchar2_table(16537) := '726552656E6465722865293B666F72286C657420743D302C6E3D746869732E5F7365636F6E64617279437572736F72732E6C656E6774683B743C6E3B742B2B29746869732E5F7365636F6E64617279437572736F72735B745D2E7072657061726552656E';
wwv_flow_imp.g_varchar2_table(16538) := '6465722865297D72656E6465722865297B636F6E737420743D5B5D3B6C6574206E3D303B636F6E737420693D746869732E5F7072696D617279437572736F722E72656E6465722865293B69262628745B6E2B2B5D3D69293B666F72286C657420693D302C';
wwv_flow_imp.g_varchar2_table(16539) := '6F3D746869732E5F7365636F6E64617279437572736F72732E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D746869732E5F7365636F6E64617279437572736F72735B695D2E72656E6465722865293B6F262628745B6E2B2B5D3D6F297D74';
wwv_flow_imp.g_varchar2_table(16540) := '6869732E5F72656E646572446174613D747D6765744C61737452656E6465724461746128297B72657475726E20746869732E5F72656E646572446174617D7D5F522E424C494E4B5F494E54455256414C3D3530302C5662282828652C74293D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(16541) := '7374206E3D5B7B636C6173733A222E637572736F72222C666F726567726F756E643A6A622C6261636B67726F756E643A71627D2C7B636C6173733A222E637572736F722D7072696D617279222C666F726567726F756E643A24622C6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(16542) := '643A55627D2C7B636C6173733A222E637572736F722D7365636F6E64617279222C666F726567726F756E643A4B622C6261636B67726F756E643A47627D5D3B666F7228636F6E73742069206F66206E297B636F6E7374206E3D652E676574436F6C6F7228';
wwv_flow_imp.g_varchar2_table(16543) := '692E666F726567726F756E64293B6966286E297B6C6574206F3D652E676574436F6C6F7228692E6261636B67726F756E64293B6F7C7C286F3D6E2E6F70706F736974652829292C742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6375';
wwv_flow_imp.g_varchar2_table(16544) := '72736F72732D6C6179657220247B692E636C6173737D207B206261636B67726F756E642D636F6C6F723A20247B6E7D3B20626F726465722D636F6C6F723A20247B6E7D3B20636F6C6F723A20247B6F7D3B207D60292C416228652E74797065292626742E';
wwv_flow_imp.g_varchar2_table(16545) := '61646452756C6528602E6D6F6E61636F2D656469746F72202E637572736F72732D6C617965722E6861732D73656C656374696F6E20247B692E636C6173737D207B20626F726465722D6C6566743A2031707820736F6C696420247B6F7D3B20626F726465';
wwv_flow_imp.g_varchar2_table(16546) := '722D72696768743A2031707820736F6C696420247B6F7D3B207D60297D7D7D29293B636F6E73742079523D28293D3E7B7468726F77206E6577204572726F722822496E76616C6964206368616E6765206163636573736F7222297D3B636C617373207752';
wwv_flow_imp.g_varchar2_table(16547) := '20657874656E6473204A417B636F6E7374727563746F722865297B73757065722865293B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B746869732E5F6C';
wwv_flow_imp.g_varchar2_table(16548) := '696E654865696768743D742E676574283637292C746869732E5F636F6E74656E7457696474683D6E2E636F6E74656E7457696474682C746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C746869732E646F6D4E6F64653D73';
wwv_flow_imp.g_varchar2_table(16549) := '4528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F6D4E6F64652E736574436C6173734E616D652822766965772D7A6F6E657322292C746869732E646F6D4E6F64652E736574506F736974696F6E282261';
wwv_flow_imp.g_varchar2_table(16550) := '62736F6C75746522292C746869732E646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C22';
wwv_flow_imp.g_varchar2_table(16551) := '7472756522292C746869732E6D617267696E446F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E6D617267696E446F6D4E6F64652E736574436C6173734E616D6528226D617267696E2D';
wwv_flow_imp.g_varchar2_table(16552) := '766965772D7A6F6E657322292C746869732E6D617267696E446F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C746869732E6D617267696E446F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573';
wwv_flow_imp.g_varchar2_table(16553) := '656E746174696F6E22292C746869732E6D617267696E446F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F7A6F6E65733D7B7D7D646973706F736528297B73757065722E64697370';
wwv_flow_imp.g_varchar2_table(16554) := '6F736528292C746869732E5F7A6F6E65733D7B7D7D5F7265636F6D70757465576869746573706163657350726F707328297B636F6E737420653D746869732E5F636F6E746578742E766965774C61796F75742E676574576869746573706163657328292C';
wwv_flow_imp.g_varchar2_table(16555) := '743D6E6577204D61703B666F7228636F6E7374206E206F66206529742E736574286E2E69642C6E293B6C6574206E3D21313B72657475726E20746869732E5F636F6E746578742E766965774D6F64656C2E6368616E676557686974657370616365282865';
wwv_flow_imp.g_varchar2_table(16556) := '3D3E7B636F6E737420693D4F626A6563742E6B65797328746869732E5F7A6F6E6573293B666F72286C6574206F3D302C733D692E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D695B6F5D2C723D746869732E5F7A6F6E65735B735D2C613D';
wwv_flow_imp.g_varchar2_table(16557) := '746869732E5F636F6D707574655768697465737061636550726F707328722E64656C6567617465293B722E6973496E48696464656E417265613D612E6973496E48696464656E417265613B636F6E7374206C3D742E6765742873293B216C7C7C6C2E6166';
wwv_flow_imp.g_varchar2_table(16558) := '7465724C696E654E756D6265723D3D3D612E6166746572566965774C696E654E756D62657226266C2E6865696768743D3D3D612E686569676874496E50787C7C28652E6368616E67654F6E655768697465737061636528732C612E616674657256696577';
wwv_flow_imp.g_varchar2_table(16559) := '4C696E654E756D6265722C612E686569676874496E5078292C746869732E5F7361666543616C6C4F6E436F6D707574656448656967687428722E64656C65676174652C612E686569676874496E5078292C6E3D2130297D7D29292C6E7D6F6E436F6E6669';
wwv_flow_imp.g_varchar2_table(16560) := '6775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732C6E3D742E67657428313435293B72657475726E20746869732E5F6C696E654865696768743D';
wwv_flow_imp.g_varchar2_table(16561) := '742E676574283637292C746869732E5F636F6E74656E7457696474683D6E2E636F6E74656E7457696474682C746869732E5F636F6E74656E744C6566743D6E2E636F6E74656E744C6566742C652E6861734368616E676564283637292626746869732E5F';
wwv_flow_imp.g_varchar2_table(16562) := '7265636F6D70757465576869746573706163657350726F707328292C21307D6F6E4C696E654D617070696E674368616E6765642865297B72657475726E20746869732E5F7265636F6D70757465576869746573706163657350726F707328297D6F6E4C69';
wwv_flow_imp.g_varchar2_table(16563) := '6E657344656C657465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647C7C652E7363726F6C6C57696474684368616E6765647D6F6E5A6F6E6573436861';
wwv_flow_imp.g_varchar2_table(16564) := '6E6765642865297B72657475726E21307D6F6E4C696E6573496E7365727465642865297B72657475726E21307D5F6765745A6F6E654F7264696E616C2865297B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C213D3D28743D65';
wwv_flow_imp.g_varchar2_table(16565) := '2E6F7264696E616C292626766F69642030213D3D743F743A652E6166746572436F6C756D6E292626766F69642030213D3D6E3F6E3A3165347D5F636F6D707574655768697465737061636550726F70732865297B696628303D3D3D652E61667465724C69';
wwv_flow_imp.g_varchar2_table(16566) := '6E654E756D6265722972657475726E7B6973496E48696464656E417265613A21312C6166746572566965774C696E654E756D6265723A302C686569676874496E50783A746869732E5F686569676874496E506978656C732865292C6D696E576964746849';
wwv_flow_imp.g_varchar2_table(16567) := '6E50783A746869732E5F6D696E5769647468496E506978656C732865297D3B6C657420742C6E3B696628766F69642030213D3D652E6166746572436F6C756D6E29743D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E76616C';
wwv_flow_imp.g_varchar2_table(16568) := '6964617465506F736974696F6E287B6C696E654E756D6265723A652E61667465724C696E654E756D6265722C636F6C756D6E3A652E6166746572436F6C756D6E7D293B656C73657B636F6E7374206E3D746869732E5F636F6E746578742E766965774D6F';
wwv_flow_imp.g_varchar2_table(16569) := '64656C2E6D6F64656C2E76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E61667465724C696E654E756D6265722C636F6C756D6E3A317D292E6C696E654E756D6265723B743D6E6577206D63286E2C746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(16570) := '6578742E766965774D6F64656C2E6D6F64656C2E6765744C696E654D6178436F6C756D6E286E29297D6E3D742E636F6C756D6E3D3D3D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E6765744C696E654D6178436F6C756D6E';
wwv_flow_imp.g_varchar2_table(16571) := '28742E6C696E654E756D626572293F746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E76616C6964617465506F736974696F6E287B6C696E654E756D6265723A742E6C696E654E756D6265722B312C636F6C756D6E3A317D293A';
wwv_flow_imp.g_varchar2_table(16572) := '746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2E76616C6964617465506F736974696F6E287B6C696E654E756D6265723A742E6C696E654E756D6265722C636F6C756D6E3A742E636F6C756D6E2B317D293B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(16573) := '746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28742C652E6166746572436F6C756D6E416666696E';
wwv_flow_imp.g_varchar2_table(16574) := '6974792C2130292C6F3D652E73686F77496E48696464656E41726561737C7C746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E6D6F64656C506F736974696F6E497356697369626C65286E';
wwv_flow_imp.g_varchar2_table(16575) := '293B72657475726E7B6973496E48696464656E417265613A216F2C6166746572566965774C696E654E756D6265723A692E6C696E654E756D6265722C686569676874496E50783A6F3F746869732E5F686569676874496E506978656C732865293A302C6D';
wwv_flow_imp.g_varchar2_table(16576) := '696E5769647468496E50783A746869732E5F6D696E5769647468496E506978656C732865297D7D6368616E6765566965775A6F6E65732865297B6C657420743D21313B72657475726E20746869732E5F636F6E746578742E766965774D6F64656C2E6368';
wwv_flow_imp.g_varchar2_table(16577) := '616E67655768697465737061636528286E3D3E7B636F6E737420693D7B6164645A6F6E653A653D3E28743D21302C746869732E5F6164645A6F6E65286E2C6529292C72656D6F76655A6F6E653A653D3E7B65262628743D746869732E5F72656D6F76655A';
wwv_flow_imp.g_varchar2_table(16578) := '6F6E65286E2C65297C7C74297D2C6C61796F75745A6F6E653A653D3E7B65262628743D746869732E5F6C61796F75745A6F6E65286E2C65297C7C74297D7D3B2166756E6374696F6E28652C74297B7472797B72657475726E20652874297D636174636828';
wwv_flow_imp.g_varchar2_table(16579) := '65297B6B652865297D7D28652C69292C692E6164645A6F6E653D79522C692E72656D6F76655A6F6E653D79522C692E6C61796F75745A6F6E653D79527D29292C747D5F6164645A6F6E6528652C74297B636F6E7374206E3D746869732E5F636F6D707574';
wwv_flow_imp.g_varchar2_table(16580) := '655768697465737061636550726F70732874292C693D7B7768697465737061636549643A652E696E7365727457686974657370616365286E2E6166746572566965774C696E654E756D6265722C746869732E5F6765745A6F6E654F7264696E616C287429';
wwv_flow_imp.g_varchar2_table(16581) := '2C6E2E686569676874496E50782C6E2E6D696E5769647468496E5078292C64656C65676174653A742C6973496E48696464656E417265613A6E2E6973496E48696464656E417265612C697356697369626C653A21312C646F6D4E6F64653A734528742E64';
wwv_flow_imp.g_varchar2_table(16582) := '6F6D4E6F6465292C6D617267696E446F6D4E6F64653A742E6D617267696E446F6D4E6F64653F734528742E6D617267696E446F6D4E6F6465293A6E756C6C7D3B72657475726E20746869732E5F7361666543616C6C4F6E436F6D70757465644865696768';
wwv_flow_imp.g_varchar2_table(16583) := '7428692E64656C65676174652C6E2E686569676874496E5078292C692E646F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C692E646F6D4E6F64652E646F6D4E6F64652E7374796C652E77696474683D2231303025222C692E';
wwv_flow_imp.g_varchar2_table(16584) := '646F6D4E6F64652E736574446973706C617928226E6F6E6522292C692E646F6D4E6F64652E73657441747472696275746528226D6F6E61636F2D766965772D7A6F6E65222C692E776869746573706163654964292C746869732E646F6D4E6F64652E6170';
wwv_flow_imp.g_varchar2_table(16585) := '70656E644368696C6428692E646F6D4E6F6465292C692E6D617267696E446F6D4E6F6465262628692E6D617267696E446F6D4E6F64652E736574506F736974696F6E28226162736F6C75746522292C692E6D617267696E446F6D4E6F64652E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(16586) := '64652E7374796C652E77696474683D2231303025222C692E6D617267696E446F6D4E6F64652E736574446973706C617928226E6F6E6522292C692E6D617267696E446F6D4E6F64652E73657441747472696275746528226D6F6E61636F2D766965772D7A';
wwv_flow_imp.g_varchar2_table(16587) := '6F6E65222C692E776869746573706163654964292C746869732E6D617267696E446F6D4E6F64652E617070656E644368696C6428692E6D617267696E446F6D4E6F646529292C746869732E5F7A6F6E65735B692E7768697465737061636549645D3D692C';
wwv_flow_imp.g_varchar2_table(16588) := '746869732E73657453686F756C6452656E64657228292C692E7768697465737061636549647D5F72656D6F76655A6F6E6528652C74297B696628746869732E5F7A6F6E65732E6861734F776E50726F7065727479287429297B636F6E7374206E3D746869';
wwv_flow_imp.g_varchar2_table(16589) := '732E5F7A6F6E65735B745D3B72657475726E2064656C65746520746869732E5F7A6F6E65735B745D2C652E72656D6F766557686974657370616365286E2E776869746573706163654964292C6E2E646F6D4E6F64652E72656D6F76654174747269627574';
wwv_flow_imp.g_varchar2_table(16590) := '6528226D6F6E61636F2D76697369626C652D766965772D7A6F6E6522292C6E2E646F6D4E6F64652E72656D6F766541747472696275746528226D6F6E61636F2D766965772D7A6F6E6522292C6E2E646F6D4E6F64652E646F6D4E6F64652E706172656E74';
wwv_flow_imp.g_varchar2_table(16591) := '4E6F64652E72656D6F76654368696C64286E2E646F6D4E6F64652E646F6D4E6F6465292C6E2E6D617267696E446F6D4E6F64652626286E2E6D617267696E446F6D4E6F64652E72656D6F766541747472696275746528226D6F6E61636F2D76697369626C';
wwv_flow_imp.g_varchar2_table(16592) := '652D766965772D7A6F6E6522292C6E2E6D617267696E446F6D4E6F64652E72656D6F766541747472696275746528226D6F6E61636F2D766965772D7A6F6E6522292C6E2E6D617267696E446F6D4E6F64652E646F6D4E6F64652E706172656E744E6F6465';
wwv_flow_imp.g_varchar2_table(16593) := '2E72656D6F76654368696C64286E2E6D617267696E446F6D4E6F64652E646F6D4E6F646529292C746869732E73657453686F756C6452656E64657228292C21307D72657475726E21317D5F6C61796F75745A6F6E6528652C74297B696628746869732E5F';
wwv_flow_imp.g_varchar2_table(16594) := '7A6F6E65732E6861734F776E50726F7065727479287429297B636F6E7374206E3D746869732E5F7A6F6E65735B745D2C693D746869732E5F636F6D707574655768697465737061636550726F7073286E2E64656C6567617465293B72657475726E206E2E';
wwv_flow_imp.g_varchar2_table(16595) := '6973496E48696464656E417265613D692E6973496E48696464656E417265612C652E6368616E67654F6E6557686974657370616365286E2E7768697465737061636549642C692E6166746572566965774C696E654E756D6265722C692E68656967687449';
wwv_flow_imp.g_varchar2_table(16596) := '6E5078292C746869732E5F7361666543616C6C4F6E436F6D7075746564486569676874286E2E64656C65676174652C692E686569676874496E5078292C746869732E73657453686F756C6452656E64657228292C21307D72657475726E21317D73686F75';
wwv_flow_imp.g_varchar2_table(16597) := '6C6453757070726573734D6F757365446F776E4F6E566965775A6F6E652865297B696628746869732E5F7A6F6E65732E6861734F776E50726F7065727479286529297B636F6E737420743D746869732E5F7A6F6E65735B655D3B72657475726E20426F6F';
wwv_flow_imp.g_varchar2_table(16598) := '6C65616E28742E64656C65676174652E73757070726573734D6F757365446F776E297D72657475726E21317D5F686569676874496E506978656C732865297B72657475726E226E756D626572223D3D747970656F6620652E686569676874496E50783F65';
wwv_flow_imp.g_varchar2_table(16599) := '2E686569676874496E50783A226E756D626572223D3D747970656F6620652E686569676874496E4C696E65733F746869732E5F6C696E654865696768742A652E686569676874496E4C696E65733A746869732E5F6C696E654865696768747D5F6D696E57';
wwv_flow_imp.g_varchar2_table(16600) := '69647468496E506978656C732865297B72657475726E226E756D626572223D3D747970656F6620652E6D696E5769647468496E50783F652E6D696E5769647468496E50783A307D5F7361666543616C6C4F6E436F6D707574656448656967687428652C74';
wwv_flow_imp.g_varchar2_table(16601) := '297B6966282266756E6374696F6E223D3D747970656F6620652E6F6E436F6D7075746564486569676874297472797B652E6F6E436F6D70757465644865696768742874297D63617463682865297B6B652865297D7D5F7361666543616C6C4F6E446F6D4E';
wwv_flow_imp.g_varchar2_table(16602) := '6F6465546F7028652C74297B6966282266756E6374696F6E223D3D747970656F6620652E6F6E446F6D4E6F6465546F70297472797B652E6F6E446F6D4E6F6465546F702874297D63617463682865297B6B652865297D7D7072657061726552656E646572';
wwv_flow_imp.g_varchar2_table(16603) := '2865297B7D72656E6465722865297B636F6E737420743D652E76696577706F7274446174612E7768697465737061636556696577706F7274446174612C6E3D7B7D3B6C657420693D21313B666F7228636F6E73742065206F66207429746869732E5F7A6F';
wwv_flow_imp.g_varchar2_table(16604) := '6E65735B652E69645D2E6973496E48696464656E417265617C7C286E5B652E69645D3D652C693D2130293B636F6E7374206F3D4F626A6563742E6B65797328746869732E5F7A6F6E6573293B666F72286C657420743D302C693D6F2E6C656E6774683B74';
wwv_flow_imp.g_varchar2_table(16605) := '3C693B742B2B297B636F6E737420693D6F5B745D2C733D746869732E5F7A6F6E65735B695D3B6C657420723D302C613D302C6C3D226E6F6E65223B6E2E6861734F776E50726F70657274792869293F28723D6E5B695D2E766572746963616C4F66667365';
wwv_flow_imp.g_varchar2_table(16606) := '742D652E6269674E756D6265727344656C74612C613D6E5B695D2E6865696768742C6C3D22626C6F636B222C732E697356697369626C657C7C28732E646F6D4E6F64652E73657441747472696275746528226D6F6E61636F2D76697369626C652D766965';
wwv_flow_imp.g_varchar2_table(16607) := '772D7A6F6E65222C227472756522292C732E697356697369626C653D2130292C746869732E5F7361666543616C6C4F6E446F6D4E6F6465546F7028732E64656C65676174652C652E6765745363726F6C6C6564546F7046726F6D4162736F6C757465546F';
wwv_flow_imp.g_varchar2_table(16608) := '70286E5B695D2E766572746963616C4F66667365742929293A28732E697356697369626C65262628732E646F6D4E6F64652E72656D6F766541747472696275746528226D6F6E61636F2D76697369626C652D766965772D7A6F6E6522292C732E69735669';
wwv_flow_imp.g_varchar2_table(16609) := '7369626C653D2131292C746869732E5F7361666543616C6C4F6E446F6D4E6F6465546F7028732E64656C65676174652C652E6765745363726F6C6C6564546F7046726F6D4162736F6C757465546F70282D3165362929292C732E646F6D4E6F64652E7365';
wwv_flow_imp.g_varchar2_table(16610) := '74546F702872292C732E646F6D4E6F64652E7365744865696768742861292C732E646F6D4E6F64652E736574446973706C6179286C292C732E6D617267696E446F6D4E6F6465262628732E6D617267696E446F6D4E6F64652E736574546F702872292C73';
wwv_flow_imp.g_varchar2_table(16611) := '2E6D617267696E446F6D4E6F64652E7365744865696768742861292C732E6D617267696E446F6D4E6F64652E736574446973706C6179286C29297D69262628746869732E646F6D4E6F64652E7365745769647468284D6174682E6D617828652E7363726F';
wwv_flow_imp.g_varchar2_table(16612) := '6C6C57696474682C746869732E5F636F6E74656E74576964746829292C746869732E6D617267696E446F6D4E6F64652E736574576964746828746869732E5F636F6E74656E744C65667429297D7D7661722043523D6E2838313839292C53523D7B7D3B53';
wwv_flow_imp.g_varchar2_table(16613) := '522E7374796C655461675472616E73666F726D3D6A7228292C53522E736574417474726962757465733D567228292C53522E696E736572743D467228292E62696E64286E756C6C2C226865616422292C53522E646F6D4150493D4F7228292C53522E696E';
wwv_flow_imp.g_varchar2_table(16614) := '736572745374796C65456C656D656E743D487228292C4E7228292843522E412C5352292C43522E41262643522E412E6C6F63616C73262643522E412E6C6F63616C733B636C61737320785220657874656E6473206F507B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(16615) := '297B737570657228292C746869732E5F636F6E746578743D652C746869732E5F6F7074696F6E733D6E6577206B5228746869732E5F636F6E746578742E636F6E66696775726174696F6E292C746869732E5F73656C656374696F6E3D5B5D2C746869732E';
wwv_flow_imp.g_varchar2_table(16616) := '5F72656E646572526573756C743D6E756C6C2C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973297D646973706F736528297B746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C6572287468';
wwv_flow_imp.g_varchar2_table(16617) := '6973292C746869732E5F72656E646572526573756C743D6E756C6C2C73757065722E646973706F736528297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D6E6577206B5228746869732E5F636F6E746578742E63';
wwv_flow_imp.g_varchar2_table(16618) := '6F6E66696775726174696F6E293B72657475726E20746869732E5F6F7074696F6E732E657175616C732874293F652E6861734368616E67656428313435293A28746869732E5F6F7074696F6E733D742C2130297D6F6E437572736F725374617465436861';
wwv_flow_imp.g_varchar2_table(16619) := '6E6765642865297B72657475726E20746869732E5F73656C656374696F6E3D652E73656C656374696F6E732C2273656C656374696F6E223D3D3D746869732E5F6F7074696F6E732E72656E646572576869746573706163657D6F6E4465636F726174696F';
wwv_flow_imp.g_varchar2_table(16620) := '6E734368616E6765642865297B72657475726E21307D6F6E466C75736865642865297B72657475726E21307D6F6E4C696E65734368616E6765642865297B72657475726E21307D6F6E4C696E657344656C657465642865297B72657475726E21307D6F6E';
wwv_flow_imp.g_varchar2_table(16621) := '4C696E6573496E7365727465642865297B72657475726E21307D6F6E5363726F6C6C4368616E6765642865297B72657475726E20652E7363726F6C6C546F704368616E6765647D6F6E5A6F6E65734368616E6765642865297B72657475726E21307D7072';
wwv_flow_imp.g_varchar2_table(16622) := '657061726552656E6465722865297B696628226E6F6E65223D3D3D746869732E5F6F7074696F6E732E72656E646572576869746573706163652972657475726E20766F696428746869732E5F72656E646572526573756C743D6E756C6C293B636F6E7374';
wwv_flow_imp.g_varchar2_table(16623) := '20743D652E76697369626C6552616E67652E73746172744C696E654E756D6265722C6E3D652E76697369626C6552616E67652E656E644C696E654E756D6265722D742B312C693D6E6577204172726179286E293B666F72286C657420653D303B653C6E3B';
wwv_flow_imp.g_varchar2_table(16624) := '652B2B29695B655D3D21303B636F6E7374206F3D746869732E5F636F6E746578742E766965774D6F64656C2E6765744D696E696D61704C696E657352656E646572696E674461746128652E76696577706F7274446174612E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(16625) := '6265722C652E76696577706F7274446174612E656E644C696E654E756D6265722C69293B746869732E5F72656E646572526573756C743D5B5D3B666F72286C657420743D652E76696577706F7274446174612E73746172744C696E654E756D6265723B74';
wwv_flow_imp.g_varchar2_table(16626) := '3C3D652E76696577706F7274446174612E656E644C696E654E756D6265723B742B2B297B636F6E7374206E3D742D652E76696577706F7274446174612E73746172744C696E654E756D6265722C693D6F2E646174615B6E5D3B6C657420733D6E756C6C3B';
wwv_flow_imp.g_varchar2_table(16627) := '6966282273656C656374696F6E223D3D3D746869732E5F6F7074696F6E732E72656E64657257686974657370616365297B636F6E737420653D746869732E5F73656C656374696F6E3B666F7228636F6E7374206E206F662065297B6966286E2E656E644C';
wwv_flow_imp.g_varchar2_table(16628) := '696E654E756D6265723C747C7C6E2E73746172744C696E654E756D6265723E7429636F6E74696E75653B636F6E737420653D6E2E73746172744C696E654E756D6265723D3D3D743F6E2E7374617274436F6C756D6E3A692E6D696E436F6C756D6E2C6F3D';
wwv_flow_imp.g_varchar2_table(16629) := '6E2E656E644C696E654E756D6265723D3D3D743F6E2E656E64436F6C756D6E3A692E6D6178436F6C756D6E3B653C6F262628737C7C28733D5B5D292C732E70757368286E657720674E28652D312C6F2D312929297D7D746869732E5F72656E6465725265';
wwv_flow_imp.g_varchar2_table(16630) := '73756C745B6E5D3D746869732E5F6170706C7952656E6465725768697465737061636528652C742C732C69297D7D5F6170706C7952656E6465725768697465737061636528652C742C6E2C69297B6966282273656C656374696F6E223D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(16631) := '5F6F7074696F6E732E72656E646572576869746573706163652626216E2972657475726E22223B69662822747261696C696E67223D3D3D746869732E5F6F7074696F6E732E72656E646572576869746573706163652626692E636F6E74696E7565735769';
wwv_flow_imp.g_varchar2_table(16632) := '7468577261707065644C696E652972657475726E22223B636F6E7374206F3D746869732E5F636F6E746578742E7468656D652E676574436F6C6F72285162292C733D746869732E5F6F7074696F6E732E72656E646572576974685356472C723D692E636F';
wwv_flow_imp.g_varchar2_table(16633) := '6E74656E742C613D2D313D3D3D746869732E5F6F7074696F6E732E73746F7052656E646572696E674C696E6541667465723F722E6C656E6774683A4D6174682E6D696E28746869732E5F6F7074696F6E732E73746F7052656E646572696E674C696E6541';
wwv_flow_imp.g_varchar2_table(16634) := '667465722C722E6C656E677468292C6C3D692E636F6E74696E75657357697468577261707065644C696E652C633D692E6D696E436F6C756D6E2D312C643D22626F756E64617279223D3D3D746869732E5F6F7074696F6E732E72656E6465725768697465';
wwv_flow_imp.g_varchar2_table(16635) := '73706163652C683D22747261696C696E67223D3D3D746869732E5F6F7074696F6E732E72656E646572576869746573706163652C753D746869732E5F6F7074696F6E732E6C696E654865696768742C703D746869732E5F6F7074696F6E732E6D6964646F';
wwv_flow_imp.g_varchar2_table(16636) := '7457696474682C673D746869732E5F6F7074696F6E732E77736D6964646F7457696474682C6D3D746869732E5F6F7074696F6E732E737061636557696474682C663D4D6174682E61627328672D6D293C4D6174682E61627328702D6D293F31313832353A';
wwv_flow_imp.g_varchar2_table(16637) := '3138332C763D746869732E5F6F7074696F6E732E63616E55736548616C667769647468526967687477617264734172726F773B6C657420622C5F3D22222C793D21312C773D6D692872293B2D313D3D3D773F28793D21302C773D612C623D61293A623D76';
wwv_flow_imp.g_varchar2_table(16638) := '692872293B6C657420433D302C533D6E26266E5B435D2C783D303B666F72286C657420693D633B693C613B692B2B297B636F6E7374206F3D722E63686172436F646541742869293B696628532626693E3D532E656E644F6666736574262628432B2B2C53';
wwv_flow_imp.g_varchar2_table(16639) := '3D6E26266E5B435D292C39213D3D6F26263332213D3D6F29636F6E74696E75653B69662868262621792626693C3D6229636F6E74696E75653B696628642626693E3D772626693C3D62262633323D3D3D6F297B636F6E737420653D692D313E3D303F722E';
wwv_flow_imp.g_varchar2_table(16640) := '63686172436F6465417428692D31293A302C743D692B313C613F722E63686172436F6465417428692B31293A303B6966283332213D3D6526263332213D3D7429636F6E74696E75657D6966286426266C2626693D3D3D612D31297B636F6E737420653D69';
wwv_flow_imp.g_varchar2_table(16641) := '2D313E3D303F722E63686172436F6465417428692D31293A303B69662833323D3D3D6F26263332213D3D65262639213D3D6529636F6E74696E75657D6966286E26262821537C7C532E73746172744F66667365743E697C7C532E656E644F66667365743C';
wwv_flow_imp.g_varchar2_table(16642) := '3D692929636F6E74696E75653B636F6E737420633D652E76697369626C6552616E6765466F72506F736974696F6E286E6577206D6328742C692B3129293B63262628733F28783D4D6174682E6D617828782C632E6C656674292C5F2B3D393D3D3D6F3F74';
wwv_flow_imp.g_varchar2_table(16643) := '6869732E5F72656E6465724172726F7728752C6D2C632E6C656674293A603C636972636C652063783D22247B28632E6C6566742B6D2F32292E746F46697865642832297D222063793D22247B28752F32292E746F46697865642832297D2220723D22247B';
wwv_flow_imp.g_varchar2_table(16644) := '286D2F37292E746F46697865642832297D22202F3E60293A5F2B3D393D3D3D6F3F603C64697620636C6173733D226D776822207374796C653D226C6566743A247B632E6C6566747D70783B6865696768743A247B757D70783B223E247B763F537472696E';
wwv_flow_imp.g_varchar2_table(16645) := '672E66726F6D43686172436F6465283635353135293A537472696E672E66726F6D43686172436F64652838353934297D3C2F6469763E603A603C64697620636C6173733D226D776822207374796C653D226C6566743A247B632E6C6566747D70783B6865';
wwv_flow_imp.g_varchar2_table(16646) := '696768743A247B757D70783B223E247B537472696E672E66726F6D43686172436F64652866297D3C2F6469763E60297D72657475726E20733F28783D4D6174682E726F756E6428782B6D292C603C737667207374796C653D22626F74746F6D3A303B706F';
wwv_flow_imp.g_varchar2_table(16647) := '736974696F6E3A6162736F6C7574653B77696474683A247B787D70783B6865696768743A247B757D7078222076696577426F783D2230203020247B787D20247B757D2220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376';
wwv_flow_imp.g_varchar2_table(16648) := '67222066696C6C3D22247B6F7D223E602B5F2B223C2F7376673E22293A5F7D5F72656E6465724172726F7728652C742C6E297B636F6E737420693D652F322C6F3D6E2C733D7B783A302C793A742F372F327D2C723D7B783A2E382A742C793A732E797D2C';
wwv_flow_imp.g_varchar2_table(16649) := '613D7B783A722E782D2E322A722E782C793A722E792B2E322A722E787D2C6C3D7B783A612E782B2E312A722E782C793A612E792B2E312A722E787D2C633D7B783A6C2E782B2E33352A722E782C793A6C2E792D2E33352A722E787D3B72657475726E603C';
wwv_flow_imp.g_varchar2_table(16650) := '7061746820643D224D20247B5B732C722C612C6C2C632C7B783A632E782C793A2D632E797D2C7B783A6C2E782C793A2D6C2E797D2C7B783A612E782C793A2D612E797D2C7B783A722E782C793A2D722E797D2C7B783A732E782C793A2D732E797D5D2E6D';
wwv_flow_imp.g_varchar2_table(16651) := '61702828653D3E60247B286F2B652E78292E746F46697865642832297D20247B28692B652E79292E746F46697865642832297D6029292E6A6F696E2822204C2022297D22202F3E607D72656E64657228652C74297B69662821746869732E5F72656E6465';
wwv_flow_imp.g_varchar2_table(16652) := '72526573756C742972657475726E22223B636F6E7374206E3D742D653B72657475726E206E3C307C7C6E3E3D746869732E5F72656E646572526573756C742E6C656E6774683F22223A746869732E5F72656E646572526573756C745B6E5D7D7D636C6173';
wwv_flow_imp.g_varchar2_table(16653) := '73206B527B636F6E7374727563746F722865297B636F6E737420743D652E6F7074696F6E732C6E3D742E676574283530292C693D742E676574283338293B226F6666223D3D3D693F28746869732E72656E646572576869746573706163653D226E6F6E65';
wwv_flow_imp.g_varchar2_table(16654) := '222C746869732E72656E646572576974685356473D2131293A22737667223D3D3D693F28746869732E72656E646572576869746573706163653D742E676574283939292C746869732E72656E646572576974685356473D2130293A28746869732E72656E';
wwv_flow_imp.g_varchar2_table(16655) := '646572576869746573706163653D742E676574283939292C746869732E72656E646572576974685356473D2131292C746869732E737061636557696474683D6E2E737061636557696474682C746869732E6D6964646F7457696474683D6E2E6D6964646F';
wwv_flow_imp.g_varchar2_table(16656) := '7457696474682C746869732E77736D6964646F7457696474683D6E2E77736D6964646F7457696474682C746869732E63616E55736548616C667769647468526967687477617264734172726F773D6E2E63616E55736548616C6677696474685269676874';
wwv_flow_imp.g_varchar2_table(16657) := '77617264734172726F772C746869732E6C696E654865696768743D742E676574283637292C746869732E73746F7052656E646572696E674C696E6541667465723D742E67657428313137297D657175616C732865297B72657475726E20746869732E7265';
wwv_flow_imp.g_varchar2_table(16658) := '6E646572576869746573706163653D3D3D652E72656E646572576869746573706163652626746869732E72656E646572576974685356473D3D3D652E72656E646572576974685356472626746869732E737061636557696474683D3D3D652E7370616365';
wwv_flow_imp.g_varchar2_table(16659) := '57696474682626746869732E6D6964646F7457696474683D3D3D652E6D6964646F7457696474682626746869732E77736D6964646F7457696474683D3D3D652E77736D6964646F7457696474682626746869732E63616E55736548616C66776964746852';
wwv_flow_imp.g_varchar2_table(16660) := '6967687477617264734172726F773D3D3D652E63616E55736548616C667769647468526967687477617264734172726F772626746869732E6C696E654865696768743D3D3D652E6C696E654865696768742626746869732E73746F7052656E646572696E';
wwv_flow_imp.g_varchar2_table(16661) := '674C696E6541667465723D3D3D652E73746F7052656E646572696E674C696E6541667465727D7D636C6173732045527B636F6E7374727563746F7228652C742C6E2C69297B746869732E73656C656374696F6E733D652C746869732E73746172744C696E';
wwv_flow_imp.g_varchar2_table(16662) := '654E756D6265723D307C742E73746172744C696E654E756D6265722C746869732E656E644C696E654E756D6265723D307C742E656E644C696E654E756D6265722C746869732E72656C6174697665566572746963616C4F66667365743D742E72656C6174';
wwv_flow_imp.g_varchar2_table(16663) := '697665566572746963616C4F66667365742C746869732E6269674E756D6265727344656C74613D307C742E6269674E756D6265727344656C74612C746869732E6C696E654865696768743D307C742E6C696E654865696768742C746869732E7768697465';
wwv_flow_imp.g_varchar2_table(16664) := '737061636556696577706F7274446174613D6E2C746869732E5F6D6F64656C3D692C746869732E76697369626C6552616E67653D6E657720726828742E73746172744C696E654E756D6265722C746869732E5F6D6F64656C2E6765744C696E654D696E43';
wwv_flow_imp.g_varchar2_table(16665) := '6F6C756D6E28742E73746172744C696E654E756D626572292C742E656E644C696E654E756D6265722C746869732E5F6D6F64656C2E6765744C696E654D6178436F6C756D6E28742E656E644C696E654E756D62657229297D676574566965774C696E6552';
wwv_flow_imp.g_varchar2_table(16666) := '656E646572696E67446174612865297B72657475726E20746869732E5F6D6F64656C2E67657456696577706F7274566965774C696E6552656E646572696E674461746128746869732E76697369626C6552616E67652C65297D6765744465636F72617469';
wwv_flow_imp.g_varchar2_table(16667) := '6F6E73496E56696577706F727428297B72657475726E20746869732E5F6D6F64656C2E6765744465636F726174696F6E73496E56696577706F727428746869732E76697369626C6552616E6765297D7D636C617373204C527B676574207479706528297B';
wwv_flow_imp.g_varchar2_table(16668) := '72657475726E20746869732E5F7468656D652E747970657D6765742076616C756528297B72657475726E20746869732E5F7468656D657D636F6E7374727563746F722865297B746869732E5F7468656D653D657D7570646174652865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(16669) := '7468656D653D657D676574436F6C6F722865297B72657475726E20746869732E5F7468656D652E676574436F6C6F722865297D7D636C6173732044527B636F6E7374727563746F7228652C742C6E297B746869732E636F6E66696775726174696F6E3D65';
wwv_flow_imp.g_varchar2_table(16670) := '2C746869732E7468656D653D6E6577204C522874292C746869732E766965774D6F64656C3D6E2C746869732E766965774C61796F75743D6E2E766965774C61796F75747D6164644576656E7448616E646C65722865297B746869732E766965774D6F6465';
wwv_flow_imp.g_varchar2_table(16671) := '6C2E616464566965774576656E7448616E646C65722865297D72656D6F76654576656E7448616E646C65722865297B746869732E766965774D6F64656C2E72656D6F7665566965774576656E7448616E646C65722865297D7D6C65742054523D636C6173';
wwv_flow_imp.g_varchar2_table(16672) := '7320657874656E64732058417B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228292C746869732E5F696E7374616E74696174696F6E536572766963653D722C746869732E5F73686F756C645265636F6D70757465476C';
wwv_flow_imp.g_varchar2_table(16673) := '7970684D617267696E4C616E65733D21312C746869732E5F73656C656374696F6E733D5B6E657720616828312C312C312C31295D2C746869732E5F72656E646572416E696D6174696F6E4672616D653D6E756C6C3B636F6E737420613D6E657720765028';
wwv_flow_imp.g_varchar2_table(16674) := '742C692C6F2C65293B746869732E5F636F6E746578743D6E657720445228742C6E2C69292C746869732E5F636F6E746578742E6164644576656E7448616E646C65722874686973292C746869732E5F7669657750617274733D5B5D2C746869732E5F7465';
wwv_flow_imp.g_varchar2_table(16675) := '78744172656148616E646C65723D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652866502C746869732E5F636F6E746578742C612C746869732E5F637265617465546578744172656148616E646C';
wwv_flow_imp.g_varchar2_table(16676) := '657248656C7065722829292C746869732E5F7669657750617274732E7075736828746869732E5F746578744172656148616E646C6572292C746869732E5F6C696E6573436F6E74656E743D734528646F63756D656E742E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(16677) := '28226469762229292C746869732E5F6C696E6573436F6E74656E742E736574436C6173734E616D6528226C696E65732D636F6E74656E74206D6F6E61636F2D656469746F722D6261636B67726F756E6422292C746869732E5F6C696E6573436F6E74656E';
wwv_flow_imp.g_varchar2_table(16678) := '742E736574506F736974696F6E28226162736F6C75746522292C746869732E646F6D4E6F64653D734528646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F6D4E6F64652E736574436C6173734E616D652874';
wwv_flow_imp.g_varchar2_table(16679) := '6869732E5F676574456469746F72436C6173734E616D652829292C746869732E646F6D4E6F64652E7365744174747269627574652822726F6C65222C22636F646522292C746869732E5F6F766572666C6F774775617264436F6E7461696E65723D734528';
wwv_flow_imp.g_varchar2_table(16680) := '646F63756D656E742E637265617465456C656D656E7428226469762229292C654E2E777269746528746869732E5F6F766572666C6F774775617264436F6E7461696E65722C33292C746869732E5F6F766572666C6F774775617264436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(16681) := '2E736574436C6173734E616D6528226F766572666C6F772D677561726422292C746869732E5F7363726F6C6C6261723D6E6577206A5028746869732E5F636F6E746578742C746869732E5F6C696E6573436F6E74656E742C746869732E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(16682) := '2C746869732E5F6F766572666C6F774775617264436F6E7461696E6572292C746869732E5F7669657750617274732E7075736828746869732E5F7363726F6C6C626172292C746869732E5F766965774C696E65733D6E657720644F28746869732E5F636F';
wwv_flow_imp.g_varchar2_table(16683) := '6E746578742C746869732E5F6C696E6573436F6E74656E74292C746869732E5F766965775A6F6E65733D6E657720775228746869732E5F636F6E74657874292C746869732E5F7669657750617274732E7075736828746869732E5F766965775A6F6E6573';
wwv_flow_imp.g_varchar2_table(16684) := '293B636F6E7374206C3D6E657720514F28746869732E5F636F6E74657874293B746869732E5F7669657750617274732E70757368286C293B636F6E737420633D6E657720735228746869732E5F636F6E74657874293B746869732E5F7669657750617274';
wwv_flow_imp.g_varchar2_table(16685) := '732E707573682863293B636F6E737420643D6E657720535028746869732E5F636F6E74657874293B746869732E5F7669657750617274732E707573682864292C642E61646444796E616D69634F7665726C6179286E657720425028746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(16686) := '7465787429292C642E61646444796E616D69634F7665726C6179286E657720755228746869732E5F636F6E7465787429292C642E61646444796E616D69634F7665726C6179286E6577206E4F28746869732E5F636F6E7465787429292C642E6164644479';
wwv_flow_imp.g_varchar2_table(16687) := '6E616D69634F7665726C6179286E657720575028746869732E5F636F6E7465787429292C642E61646444796E616D69634F7665726C6179286E657720785228746869732E5F636F6E7465787429293B636F6E737420683D6E657720785028746869732E5F';
wwv_flow_imp.g_varchar2_table(16688) := '636F6E74657874293B746869732E5F7669657750617274732E707573682868292C682E61646444796E616D69634F7665726C6179286E657720565028746869732E5F636F6E7465787429292C682E61646444796E616D69634F7665726C6179286E657720';
wwv_flow_imp.g_varchar2_table(16689) := '664F28746869732E5F636F6E7465787429292C682E61646444796E616D69634F7665726C6179286E657720704F28746869732E5F636F6E7465787429292C682E61646444796E616D69634F7665726C6179286E657720735028746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(16690) := '787429292C746869732E5F676C7970684D617267696E576964676574733D6E657720595028746869732E5F636F6E74657874292C746869732E5F7669657750617274732E7075736828746869732E5F676C7970684D617267696E57696467657473293B63';
wwv_flow_imp.g_varchar2_table(16691) := '6F6E737420753D6E6577206C5028746869732E5F636F6E74657874293B752E676574446F6D4E6F646528292E617070656E644368696C6428746869732E5F766965775A6F6E65732E6D617267696E446F6D4E6F6465292C752E676574446F6D4E6F646528';
wwv_flow_imp.g_varchar2_table(16692) := '292E617070656E644368696C6428682E676574446F6D4E6F64652829292C752E676574446F6D4E6F646528292E617070656E644368696C6428746869732E5F676C7970684D617267696E576964676574732E646F6D4E6F6465292C746869732E5F766965';
wwv_flow_imp.g_varchar2_table(16693) := '7750617274732E707573682875292C746869732E5F636F6E74656E74576964676574733D6E657720545028746869732E5F636F6E746578742C746869732E646F6D4E6F6465292C746869732E5F7669657750617274732E7075736828746869732E5F636F';
wwv_flow_imp.g_varchar2_table(16694) := '6E74656E7457696467657473292C746869732E5F76696577437572736F72733D6E6577205F5228746869732E5F636F6E74657874292C746869732E5F7669657750617274732E7075736828746869732E5F76696577437572736F7273292C746869732E5F';
wwv_flow_imp.g_varchar2_table(16695) := '6F7665726C6179576964676574733D6E6577204B4F28746869732E5F636F6E746578742C746869732E646F6D4E6F6465292C746869732E5F7669657750617274732E7075736828746869732E5F6F7665726C617957696467657473293B636F6E73742070';
wwv_flow_imp.g_varchar2_table(16696) := '3D6E6577206E5228746869732E5F636F6E74657874293B746869732E5F7669657750617274732E707573682870293B636F6E737420673D6E657720445028746869732E5F636F6E74657874293B746869732E5F7669657750617274732E70757368286729';
wwv_flow_imp.g_varchar2_table(16697) := '3B636F6E7374206D3D6E657720574F28746869732E5F636F6E74657874293B696628746869732E5F7669657750617274732E70757368286D292C6C297B636F6E737420653D746869732E5F7363726F6C6C6261722E6765744F7665727669657752756C65';
wwv_flow_imp.g_varchar2_table(16698) := '724C61796F7574496E666F28293B652E706172656E742E696E736572744265666F7265286C2E676574446F6D4E6F646528292C652E696E736572744265666F7265297D746869732E5F6C696E6573436F6E74656E742E617070656E644368696C6428642E';
wwv_flow_imp.g_varchar2_table(16699) := '676574446F6D4E6F64652829292C746869732E5F6C696E6573436F6E74656E742E617070656E644368696C6428702E646F6D4E6F6465292C746869732E5F6C696E6573436F6E74656E742E617070656E644368696C6428746869732E5F766965775A6F6E';
wwv_flow_imp.g_varchar2_table(16700) := '65732E646F6D4E6F6465292C746869732E5F6C696E6573436F6E74656E742E617070656E644368696C6428746869732E5F766965774C696E65732E676574446F6D4E6F64652829292C746869732E5F6C696E6573436F6E74656E742E617070656E644368';
wwv_flow_imp.g_varchar2_table(16701) := '696C6428746869732E5F636F6E74656E74576964676574732E646F6D4E6F6465292C746869732E5F6C696E6573436F6E74656E742E617070656E644368696C6428746869732E5F76696577437572736F72732E676574446F6D4E6F64652829292C746869';
wwv_flow_imp.g_varchar2_table(16702) := '732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E644368696C6428752E676574446F6D4E6F64652829292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E644368696C6428746869732E';
wwv_flow_imp.g_varchar2_table(16703) := '5F7363726F6C6C6261722E676574446F6D4E6F64652829292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E644368696C6428632E676574446F6D4E6F64652829292C746869732E5F6F766572666C6F7747756172';
wwv_flow_imp.g_varchar2_table(16704) := '64436F6E7461696E65722E617070656E644368696C6428746869732E5F746578744172656148616E646C65722E7465787441726561292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E644368696C642874686973';
wwv_flow_imp.g_varchar2_table(16705) := '2E5F746578744172656148616E646C65722E7465787441726561436F766572292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E644368696C6428746869732E5F6F7665726C6179576964676574732E676574446F';
wwv_flow_imp.g_varchar2_table(16706) := '6D4E6F64652829292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E644368696C64286D2E676574446F6D4E6F64652829292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E617070656E';
wwv_flow_imp.g_varchar2_table(16707) := '644368696C6428672E646F6D4E6F6465292C746869732E646F6D4E6F64652E617070656E644368696C6428746869732E5F6F766572666C6F774775617264436F6E7461696E6572292C733F28732E617070656E644368696C6428746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(16708) := '656E74576964676574732E6F766572666C6F77696E67436F6E74656E7457696467657473446F6D4E6F64652E646F6D4E6F6465292C732E617070656E644368696C6428746869732E5F6F7665726C6179576964676574732E6F766572666C6F77696E674F';
wwv_flow_imp.g_varchar2_table(16709) := '7665726C617957696467657473446F6D4E6F64652E646F6D4E6F646529293A28746869732E646F6D4E6F64652E617070656E644368696C6428746869732E5F636F6E74656E74576964676574732E6F766572666C6F77696E67436F6E74656E7457696467';
wwv_flow_imp.g_varchar2_table(16710) := '657473446F6D4E6F6465292C746869732E646F6D4E6F64652E617070656E644368696C6428746869732E5F6F7665726C6179576964676574732E6F766572666C6F77696E674F7665726C617957696467657473446F6D4E6F646529292C746869732E5F61';
wwv_flow_imp.g_varchar2_table(16711) := '70706C794C61796F757428292C746869732E5F706F696E74657248616E646C65723D746869732E5F7265676973746572286E6577204A4E28746869732E5F636F6E746578742C612C746869732E5F637265617465506F696E74657248616E646C65724865';
wwv_flow_imp.g_varchar2_table(16712) := '6C706572282929297D5F636F6D70757465476C7970684D617267696E4C616E657328297B636F6E737420653D746869732E5F636F6E746578742E766965774D6F64656C2E6D6F64656C2C743D746869732E5F636F6E746578742E766965774D6F64656C2E';
wwv_flow_imp.g_varchar2_table(16713) := '676C7970684C616E65733B6C6574206E3D5B5D2C693D303B6E3D6E2E636F6E63617428652E676574416C6C4D617267696E4465636F726174696F6E7328292E6D61702828653D3E7B76617220742C6E2C6F3B636F6E737420733D6E756C6C213D3D286E3D';
wwv_flow_imp.g_varchar2_table(16714) := '6E756C6C3D3D3D28743D652E6F7074696F6E732E676C7970684D617267696E297C7C766F696420303D3D3D743F766F696420303A742E706F736974696F6E292626766F69642030213D3D6E3F6E3A78682E43656E7465723B72657475726E20693D4D6174';
wwv_flow_imp.g_varchar2_table(16715) := '682E6D617828692C652E72616E67652E656E644C696E654E756D626572292C7B72616E67653A652E72616E67652C6C616E653A732C706572736973743A6E756C6C3D3D3D286F3D652E6F7074696F6E732E676C7970684D617267696E297C7C766F696420';
wwv_flow_imp.g_varchar2_table(16716) := '303D3D3D6F3F766F696420303A6F2E706572736973744C616E657D7D2929292C6E3D6E2E636F6E63617428746869732E5F676C7970684D617267696E576964676574732E6765745769646765747328292E6D61702828743D3E7B636F6E7374206E3D652E';
wwv_flow_imp.g_varchar2_table(16717) := '76616C696461746552616E676528742E707265666572656E63652E72616E6765293B72657475726E20693D4D6174682E6D617828692C6E2E656E644C696E654E756D626572292C7B72616E67653A6E2C6C616E653A742E707265666572656E63652E6C61';
wwv_flow_imp.g_varchar2_table(16718) := '6E657D7D2929292C6E2E736F7274282828652C74293D3E72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E67652929292C742E72657365742869293B666F7228636F6E73742065206F66206E29742E';
wwv_flow_imp.g_varchar2_table(16719) := '7075736828652E6C616E652C652E72616E67652C652E70657273697374293B72657475726E20747D5F637265617465506F696E74657248616E646C657248656C70657228297B72657475726E7B76696577446F6D4E6F64653A746869732E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(16720) := '652E646F6D4E6F64652C6C696E6573436F6E74656E74446F6D4E6F64653A746869732E5F6C696E6573436F6E74656E742E646F6D4E6F64652C766965774C696E6573446F6D4E6F64653A746869732E5F766965774C696E65732E676574446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(16721) := '28292E646F6D4E6F64652C666F63757354657874417265613A28293D3E7B746869732E666F63757328297D2C646973706174636854657874417265614576656E743A653D3E7B746869732E5F746578744172656148616E646C65722E7465787441726561';
wwv_flow_imp.g_varchar2_table(16722) := '2E646F6D4E6F64652E64697370617463684576656E742865297D2C6765744C61737452656E646572446174613A28293D3E7B636F6E737420653D746869732E5F76696577437572736F72732E6765744C61737452656E6465724461746128297C7C5B5D2C';
wwv_flow_imp.g_varchar2_table(16723) := '743D746869732E5F746578744172656148616E646C65722E6765744C61737452656E6465724461746128293B72657475726E206E657720524E28652C74297D2C72656E6465724E6F773A28293D3E7B746869732E72656E6465722821302C2131297D2C73';
wwv_flow_imp.g_varchar2_table(16724) := '686F756C6453757070726573734D6F757365446F776E4F6E566965775A6F6E653A653D3E746869732E5F766965775A6F6E65732E73686F756C6453757070726573734D6F757365446F776E4F6E566965775A6F6E652865292C73686F756C645375707072';
wwv_flow_imp.g_varchar2_table(16725) := '6573734D6F757365446F776E4F6E5769646765743A653D3E746869732E5F636F6E74656E74576964676574732E73686F756C6453757070726573734D6F757365446F776E4F6E5769646765742865292C676574506F736974696F6E46726F6D444F4D496E';
wwv_flow_imp.g_varchar2_table(16726) := '666F3A28652C74293D3E28746869732E5F666C757368416363756D756C61746564416E6452656E6465724E6F7728292C746869732E5F766965774C696E65732E676574506F736974696F6E46726F6D444F4D496E666F28652C7429292C76697369626C65';
wwv_flow_imp.g_varchar2_table(16727) := '52616E6765466F72506F736974696F6E3A28652C74293D3E28746869732E5F666C757368416363756D756C61746564416E6452656E6465724E6F7728292C746869732E5F766965774C696E65732E76697369626C6552616E6765466F72506F736974696F';
wwv_flow_imp.g_varchar2_table(16728) := '6E286E6577206D6328652C742929292C6765744C696E6557696474683A653D3E28746869732E5F666C757368416363756D756C61746564416E6452656E6465724E6F7728292C746869732E5F766965774C696E65732E6765744C696E6557696474682865';
wwv_flow_imp.g_varchar2_table(16729) := '29297D7D5F637265617465546578744172656148616E646C657248656C70657228297B72657475726E7B76697369626C6552616E6765466F72506F736974696F6E3A653D3E28746869732E5F666C757368416363756D756C61746564416E6452656E6465';
wwv_flow_imp.g_varchar2_table(16730) := '724E6F7728292C746869732E5F766965774C696E65732E76697369626C6552616E6765466F72506F736974696F6E286529297D7D5F6170706C794C61796F757428297B636F6E737420653D746869732E5F636F6E746578742E636F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(16731) := '6F6E2E6F7074696F6E732E67657428313435293B746869732E646F6D4E6F64652E736574576964746828652E7769647468292C746869732E646F6D4E6F64652E73657448656967687428652E686569676874292C746869732E5F6F766572666C6F774775';
wwv_flow_imp.g_varchar2_table(16732) := '617264436F6E7461696E65722E736574576964746828652E7769647468292C746869732E5F6F766572666C6F774775617264436F6E7461696E65722E73657448656967687428652E686569676874292C746869732E5F6C696E6573436F6E74656E742E73';
wwv_flow_imp.g_varchar2_table(16733) := '65745769647468283136373737323136292C746869732E5F6C696E6573436F6E74656E742E736574486569676874283136373737323136297D5F676574456469746F72436C6173734E616D6528297B636F6E737420653D746869732E5F74657874417265';
wwv_flow_imp.g_varchar2_table(16734) := '6148616E646C65722E6973466F637573656428293F2220666F6375736564223A22223B72657475726E20746869732E5F636F6E746578742E636F6E66696775726174696F6E2E6F7074696F6E732E67657428313432292B2220222B526228746869732E5F';
wwv_flow_imp.g_varchar2_table(16735) := '636F6E746578742E7468656D652E74797065292B657D68616E646C654576656E74732865297B73757065722E68616E646C654576656E74732865292C746869732E5F7363686564756C6552656E64657228297D6F6E436F6E66696775726174696F6E4368';
wwv_flow_imp.g_varchar2_table(16736) := '616E6765642865297B72657475726E20746869732E646F6D4E6F64652E736574436C6173734E616D6528746869732E5F676574456469746F72436C6173734E616D652829292C746869732E5F6170706C794C61796F757428292C21317D6F6E437572736F';
wwv_flow_imp.g_varchar2_table(16737) := '7253746174654368616E6765642865297B72657475726E20746869732E5F73656C656374696F6E733D652E73656C656374696F6E732C21317D6F6E4465636F726174696F6E734368616E6765642865297B72657475726E20652E61666665637473476C79';
wwv_flow_imp.g_varchar2_table(16738) := '70684D617267696E262628746869732E5F73686F756C645265636F6D70757465476C7970684D617267696E4C616E65733D2130292C21317D6F6E466F6375734368616E6765642865297B72657475726E20746869732E646F6D4E6F64652E736574436C61';
wwv_flow_imp.g_varchar2_table(16739) := '73734E616D6528746869732E5F676574456469746F72436C6173734E616D652829292C21317D6F6E5468656D654368616E6765642865297B72657475726E20746869732E5F636F6E746578742E7468656D652E75706461746528652E7468656D65292C74';
wwv_flow_imp.g_varchar2_table(16740) := '6869732E646F6D4E6F64652E736574436C6173734E616D6528746869732E5F676574456469746F72436C6173734E616D652829292C21317D646973706F736528297B6E756C6C213D3D746869732E5F72656E646572416E696D6174696F6E4672616D6526';
wwv_flow_imp.g_varchar2_table(16741) := '2628746869732E5F72656E646572416E696D6174696F6E4672616D652E646973706F736528292C746869732E5F72656E646572416E696D6174696F6E4672616D653D6E756C6C292C746869732E5F636F6E74656E74576964676574732E6F766572666C6F';
wwv_flow_imp.g_varchar2_table(16742) := '77696E67436F6E74656E7457696467657473446F6D4E6F64652E646F6D4E6F64652E72656D6F766528292C746869732E5F636F6E746578742E72656D6F76654576656E7448616E646C65722874686973292C746869732E5F766965774C696E65732E6469';
wwv_flow_imp.g_varchar2_table(16743) := '73706F736528293B666F7228636F6E73742065206F6620746869732E5F76696577506172747329652E646973706F736528293B73757065722E646973706F736528297D5F7363686564756C6552656E64657228297B696628746869732E5F73746F72652E';
wwv_flow_imp.g_varchar2_table(16744) := '6973446973706F736564297468726F77206E6577204F653B6966286E756C6C3D3D3D746869732E5F72656E646572416E696D6174696F6E4672616D65297B636F6E737420653D746869732E5F637265617465436F6F7264696E6174656452656E64657269';
wwv_flow_imp.g_varchar2_table(16745) := '6E6728293B746869732E5F72656E646572416E696D6174696F6E4672616D653D4D522E494E5354414E43452E7363686564756C65436F6F7264696E6174656452656E646572696E67287B77696E646F773A727328746869732E646F6D4E6F64652E646F6D';
wwv_flow_imp.g_varchar2_table(16746) := '4E6F6465292C7072657061726552656E646572546578743A28293D3E7B696628746869732E5F73746F72652E6973446973706F736564297468726F77206E6577204F653B7472797B72657475726E20652E7072657061726552656E646572546578742829';
wwv_flow_imp.g_varchar2_table(16747) := '7D66696E616C6C797B746869732E5F72656E646572416E696D6174696F6E4672616D653D6E756C6C7D7D2C72656E646572546578743A28293D3E7B696628746869732E5F73746F72652E6973446973706F736564297468726F77206E6577204F653B7265';
wwv_flow_imp.g_varchar2_table(16748) := '7475726E20652E72656E6465725465787428297D2C7072657061726552656E6465723A28742C6E293D3E7B696628746869732E5F73746F72652E6973446973706F736564297468726F77206E6577204F653B72657475726E20652E707265706172655265';
wwv_flow_imp.g_varchar2_table(16749) := '6E64657228742C6E297D2C72656E6465723A28742C6E293D3E7B696628746869732E5F73746F72652E6973446973706F736564297468726F77206E6577204F653B72657475726E20652E72656E64657228742C6E297D7D297D7D5F666C75736841636375';
wwv_flow_imp.g_varchar2_table(16750) := '6D756C61746564416E6452656E6465724E6F7728297B636F6E737420653D746869732E5F637265617465436F6F7264696E6174656452656E646572696E6728293B4952282828293D3E652E7072657061726552656E64657254657874282929293B636F6E';
wwv_flow_imp.g_varchar2_table(16751) := '737420743D4952282828293D3E652E72656E64657254657874282929293B69662874297B636F6E73745B6E2C695D3D743B4952282828293D3E652E7072657061726552656E646572286E2C692929292C4952282828293D3E652E72656E646572286E2C69';
wwv_flow_imp.g_varchar2_table(16752) := '2929297D7D5F676574566965775061727473546F52656E64657228297B636F6E737420653D5B5D3B6C657420743D303B666F7228636F6E7374206E206F6620746869732E5F766965775061727473296E2E73686F756C6452656E6465722829262628655B';
wwv_flow_imp.g_varchar2_table(16753) := '742B2B5D3D6E293B72657475726E20657D5F637265617465436F6F7264696E6174656452656E646572696E6728297B72657475726E7B7072657061726552656E646572546578743A28293D3E7B696628746869732E5F73686F756C645265636F6D707574';
wwv_flow_imp.g_varchar2_table(16754) := '65476C7970684D617267696E4C616E6573297B746869732E5F73686F756C645265636F6D70757465476C7970684D617267696E4C616E65733D21313B636F6E737420653D746869732E5F636F6D70757465476C7970684D617267696E4C616E657328293B';
wwv_flow_imp.g_varchar2_table(16755) := '746869732E5F636F6E746578742E636F6E66696775726174696F6E2E736574476C7970684D617267696E4465636F726174696F6E4C616E65436F756E7428652E72657175697265644C616E6573297D57532E6F6E52656E646572537461727428297D2C72';
wwv_flow_imp.g_varchar2_table(16756) := '656E646572546578743A28293D3E7B69662821746869732E646F6D4E6F64652E646F6D4E6F64652E6973436F6E6E65637465642972657475726E206E756C6C3B6C657420653D746869732E5F676574566965775061727473546F52656E64657228293B69';
wwv_flow_imp.g_varchar2_table(16757) := '662821746869732E5F766965774C696E65732E73686F756C6452656E64657228292626303D3D3D652E6C656E6774682972657475726E206E756C6C3B636F6E737420743D746869732E5F636F6E746578742E766965774C61796F75742E6765744C696E65';
wwv_flow_imp.g_varchar2_table(16758) := '7356696577706F72744461746128293B746869732E5F636F6E746578742E766965774D6F64656C2E73657456696577706F727428742E73746172744C696E654E756D6265722C742E656E644C696E654E756D6265722C742E63656E74657265644C696E65';
wwv_flow_imp.g_varchar2_table(16759) := '4E756D626572293B636F6E7374206E3D6E657720455228746869732E5F73656C656374696F6E732C742C746869732E5F636F6E746578742E766965774C61796F75742E6765745768697465737061636556696577706F72744461746128292C746869732E';
wwv_flow_imp.g_varchar2_table(16760) := '5F636F6E746578742E766965774D6F64656C293B72657475726E20746869732E5F636F6E74656E74576964676574732E73686F756C6452656E64657228292626746869732E5F636F6E74656E74576964676574732E6F6E4265666F726552656E64657228';
wwv_flow_imp.g_varchar2_table(16761) := '6E292C746869732E5F766965774C696E65732E73686F756C6452656E6465722829262628746869732E5F766965774C696E65732E72656E64657254657874286E292C746869732E5F766965774C696E65732E6F6E44696452656E64657228292C653D7468';
wwv_flow_imp.g_varchar2_table(16762) := '69732E5F676574566965775061727473546F52656E6465722829292C5B652C6E6577206E4E28746869732E5F636F6E746578742E766965774C61796F75742C6E2C746869732E5F766965774C696E6573295D7D2C7072657061726552656E6465723A2865';
wwv_flow_imp.g_varchar2_table(16763) := '2C74293D3E7B666F7228636F6E7374206E206F662065296E2E7072657061726552656E6465722874297D2C72656E6465723A28652C74293D3E7B666F7228636F6E7374206E206F662065296E2E72656E6465722874292C6E2E6F6E44696452656E646572';
wwv_flow_imp.g_varchar2_table(16764) := '28297D7D7D64656C6567617465566572746963616C5363726F6C6C626172506F696E746572446F776E2865297B746869732E5F7363726F6C6C6261722E64656C6567617465566572746963616C5363726F6C6C626172506F696E746572446F776E286529';
wwv_flow_imp.g_varchar2_table(16765) := '7D64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E742865297B746869732E5F7363726F6C6C6261722E64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E742865297D726573746F72655374';
wwv_flow_imp.g_varchar2_table(16766) := '6174652865297B746869732E5F636F6E746578742E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A652E7363726F6C6C546F702C7363726F6C6C4C6566743A652E7363726F';
wwv_flow_imp.g_varchar2_table(16767) := '6C6C4C6566747D2C31292C746869732E5F636F6E746578742E766965774D6F64656C2E76697369626C654C696E657353746162696C697A656428297D6765744F6666736574466F72436F6C756D6E28652C74297B636F6E7374206E3D746869732E5F636F';
wwv_flow_imp.g_varchar2_table(16768) := '6E746578742E766965774D6F64656C2E6D6F64656C2E76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652C636F6C756D6E3A747D292C693D746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E617465';
wwv_flow_imp.g_varchar2_table(16769) := '73436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E293B746869732E5F666C757368416363756D756C61746564416E6452656E6465724E6F7728293B636F6E7374206F3D746869732E5F';
wwv_flow_imp.g_varchar2_table(16770) := '766965774C696E65732E76697369626C6552616E6765466F72506F736974696F6E286E6577206D6328692E6C696E654E756D6265722C692E636F6C756D6E29293B72657475726E206F3F6F2E6C6566743A2D317D6765745461726765744174436C69656E';
wwv_flow_imp.g_varchar2_table(16771) := '74506F696E7428652C74297B636F6E7374206E3D746869732E5F706F696E74657248616E646C65722E6765745461726765744174436C69656E74506F696E7428652C74293B72657475726E206E3F6B502E636F6E7665727456696577546F4D6F64656C4D';
wwv_flow_imp.g_varchar2_table(16772) := '6F757365546172676574286E2C746869732E5F636F6E746578742E766965774D6F64656C2E636F6F7264696E61746573436F6E766572746572293A6E756C6C7D6372656174654F7665727669657752756C65722865297B72657475726E206E6577204A4F';
wwv_flow_imp.g_varchar2_table(16773) := '28746869732E5F636F6E746578742C65297D6368616E67652865297B746869732E5F766965775A6F6E65732E6368616E6765566965775A6F6E65732865292C746869732E5F7363686564756C6552656E64657228297D72656E64657228652C74297B6966';
wwv_flow_imp.g_varchar2_table(16774) := '2874297B746869732E5F766965774C696E65732E666F72636553686F756C6452656E64657228293B666F7228636F6E73742065206F6620746869732E5F76696577506172747329652E666F72636553686F756C6452656E64657228297D653F746869732E';
wwv_flow_imp.g_varchar2_table(16775) := '5F666C757368416363756D756C61746564416E6452656E6465724E6F7728293A746869732E5F7363686564756C6552656E64657228297D777269746553637265656E526561646572436F6E74656E742865297B746869732E5F746578744172656148616E';
wwv_flow_imp.g_varchar2_table(16776) := '646C65722E777269746553637265656E526561646572436F6E74656E742865297D666F63757328297B746869732E5F746578744172656148616E646C65722E666F637573546578744172656128297D6973466F637573656428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(16777) := '69732E5F746578744172656148616E646C65722E6973466F637573656428297D736574417269614F7074696F6E732865297B746869732E5F746578744172656148616E646C65722E736574417269614F7074696F6E732865297D616464436F6E74656E74';
wwv_flow_imp.g_varchar2_table(16778) := '5769646765742865297B746869732E5F636F6E74656E74576964676574732E61646457696467657428652E776964676574292C746869732E6C61796F7574436F6E74656E745769646765742865292C746869732E5F7363686564756C6552656E64657228';
wwv_flow_imp.g_varchar2_table(16779) := '297D6C61796F7574436F6E74656E745769646765742865297B76617220742C6E2C692C6F2C732C722C612C6C3B746869732E5F636F6E74656E74576964676574732E736574576964676574506F736974696F6E28652E7769646765742C6E756C6C213D3D';
wwv_flow_imp.g_varchar2_table(16780) := '286E3D6E756C6C3D3D3D28743D652E706F736974696F6E297C7C766F696420303D3D3D743F766F696420303A742E706F736974696F6E292626766F69642030213D3D6E3F6E3A6E756C6C2C6E756C6C213D3D286F3D6E756C6C3D3D3D28693D652E706F73';
wwv_flow_imp.g_varchar2_table(16781) := '6974696F6E297C7C766F696420303D3D3D693F766F696420303A692E7365636F6E64617279506F736974696F6E292626766F69642030213D3D6F3F6F3A6E756C6C2C6E756C6C213D3D28723D6E756C6C3D3D3D28733D652E706F736974696F6E297C7C76';
wwv_flow_imp.g_varchar2_table(16782) := '6F696420303D3D3D733F766F696420303A732E707265666572656E6365292626766F69642030213D3D723F723A6E756C6C2C6E756C6C213D3D286C3D6E756C6C3D3D3D28613D652E706F736974696F6E297C7C766F696420303D3D3D613F766F69642030';
wwv_flow_imp.g_varchar2_table(16783) := '3A612E706F736974696F6E416666696E697479292626766F69642030213D3D6C3F6C3A6E756C6C292C746869732E5F7363686564756C6552656E64657228297D72656D6F7665436F6E74656E745769646765742865297B746869732E5F636F6E74656E74';
wwv_flow_imp.g_varchar2_table(16784) := '576964676574732E72656D6F766557696467657428652E776964676574292C746869732E5F7363686564756C6552656E64657228297D6164644F7665726C61795769646765742865297B746869732E5F6F7665726C6179576964676574732E6164645769';
wwv_flow_imp.g_varchar2_table(16785) := '6467657428652E776964676574292C746869732E6C61796F75744F7665726C61795769646765742865292C746869732E5F7363686564756C6552656E64657228297D6C61796F75744F7665726C61795769646765742865297B636F6E737420743D652E70';
wwv_flow_imp.g_varchar2_table(16786) := '6F736974696F6E3F652E706F736974696F6E2E707265666572656E63653A6E756C6C3B746869732E5F6F7665726C6179576964676574732E736574576964676574506F736974696F6E28652E7769646765742C74292626746869732E5F7363686564756C';
wwv_flow_imp.g_varchar2_table(16787) := '6552656E64657228297D72656D6F76654F7665726C61795769646765742865297B746869732E5F6F7665726C6179576964676574732E72656D6F766557696467657428652E776964676574292C746869732E5F7363686564756C6552656E64657228297D';
wwv_flow_imp.g_varchar2_table(16788) := '616464476C7970684D617267696E5769646765742865297B746869732E5F676C7970684D617267696E576964676574732E61646457696467657428652E776964676574292C746869732E5F73686F756C645265636F6D70757465476C7970684D61726769';
wwv_flow_imp.g_varchar2_table(16789) := '6E4C616E65733D21302C746869732E5F7363686564756C6552656E64657228297D6C61796F7574476C7970684D617267696E5769646765742865297B636F6E737420743D652E706F736974696F6E3B746869732E5F676C7970684D617267696E57696467';
wwv_flow_imp.g_varchar2_table(16790) := '6574732E736574576964676574506F736974696F6E28652E7769646765742C7429262628746869732E5F73686F756C645265636F6D70757465476C7970684D617267696E4C616E65733D21302C746869732E5F7363686564756C6552656E646572282929';
wwv_flow_imp.g_varchar2_table(16791) := '7D72656D6F7665476C7970684D617267696E5769646765742865297B746869732E5F676C7970684D617267696E576964676574732E72656D6F766557696467657428652E776964676574292C746869732E5F73686F756C645265636F6D70757465476C79';
wwv_flow_imp.g_varchar2_table(16792) := '70684D617267696E4C616E65733D21302C746869732E5F7363686564756C6552656E64657228297D7D3B66756E6374696F6E2049522865297B7472797B72657475726E206528297D63617463682865297B72657475726E206B652865292C6E756C6C7D7D';
wwv_flow_imp.g_varchar2_table(16793) := '54523D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E';
wwv_flow_imp.g_varchar2_table(16794) := '293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73';
wwv_flow_imp.g_varchar2_table(16795) := '6520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563';
wwv_flow_imp.g_varchar2_table(16796) := '742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28362C7563295D2C5452293B636C617373204D527B636F6E737472';
wwv_flow_imp.g_varchar2_table(16797) := '7563746F7228297B746869732E5F636F6F7264696E6174656452656E646572696E67733D5B5D2C746869732E5F616E696D6174696F6E4672616D6552756E6E6572733D6E6577204D61707D7363686564756C65436F6F7264696E6174656452656E646572';
wwv_flow_imp.g_varchar2_table(16798) := '696E672865297B72657475726E20746869732E5F636F6F7264696E6174656452656E646572696E67732E707573682865292C746869732E5F7363686564756C6552656E64657228652E77696E646F77292C7B646973706F73653A28293D3E7B636F6E7374';
wwv_flow_imp.g_varchar2_table(16799) := '20743D746869732E5F636F6F7264696E6174656452656E646572696E67732E696E6465784F662865293B6966282D31213D3D74262628746869732E5F636F6F7264696E6174656452656E646572696E67732E73706C69636528742C31292C303D3D3D7468';
wwv_flow_imp.g_varchar2_table(16800) := '69732E5F636F6F7264696E6174656452656E646572696E67732E6C656E67746829297B666F7228636F6E73745B652C745D6F6620746869732E5F616E696D6174696F6E4672616D6552756E6E65727329742E646973706F736528293B746869732E5F616E';
wwv_flow_imp.g_varchar2_table(16801) := '696D6174696F6E4672616D6552756E6E6572732E636C65617228297D7D7D7D5F7363686564756C6552656E6465722865297B69662821746869732E5F616E696D6174696F6E4672616D6552756E6E6572732E686173286529297B636F6E737420743D2829';
wwv_flow_imp.g_varchar2_table(16802) := '3D3E7B746869732E5F616E696D6174696F6E4672616D6552756E6E6572732E64656C6574652865292C746869732E5F6F6E52656E6465725363686564756C656428297D3B746869732E5F616E696D6174696F6E4672616D6552756E6E6572732E73657428';
wwv_flow_imp.g_varchar2_table(16803) := '652C537328652C742C31303029297D7D5F6F6E52656E6465725363686564756C656428297B636F6E737420653D746869732E5F636F6F7264696E6174656452656E646572696E67732E736C6963652830293B746869732E5F636F6F7264696E6174656452';
wwv_flow_imp.g_varchar2_table(16804) := '656E646572696E67733D5B5D3B666F7228636F6E73742074206F662065294952282828293D3E742E7072657061726552656E64657254657874282929293B636F6E737420743D5B5D3B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B';
wwv_flow_imp.g_varchar2_table(16805) := '6E2B2B297B636F6E737420693D655B6E5D3B745B6E5D3D4952282828293D3E692E72656E64657254657874282929297D666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D2C6F3D745B6E5D3B';
wwv_flow_imp.g_varchar2_table(16806) := '696628216F29636F6E74696E75653B636F6E73745B732C725D3D6F3B4952282828293D3E692E7072657061726552656E64657228732C722929297D666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D65';
wwv_flow_imp.g_varchar2_table(16807) := '5B6E5D2C6F3D745B6E5D3B696628216F29636F6E74696E75653B636F6E73745B732C725D3D6F3B4952282828293D3E692E72656E64657228732C722929297D7D7D4D522E494E5354414E43453D6E6577204D523B636C6173732041527B636F6E73747275';
wwv_flow_imp.g_varchar2_table(16808) := '63746F7228652C742C6E2C692C6F297B746869732E696E6A656374696F6E4F6666736574733D652C746869732E696E6A656374696F6E4F7074696F6E733D742C746869732E627265616B4F6666736574733D6E2C746869732E627265616B4F6666736574';
wwv_flow_imp.g_varchar2_table(16809) := '7356697369626C65436F6C756D6E3D692C746869732E7772617070656454657874496E64656E744C656E6774683D6F7D6765744F75747075744C696E65436F756E7428297B72657475726E20746869732E627265616B4F6666736574732E6C656E677468';
wwv_flow_imp.g_varchar2_table(16810) := '7D6765744D696E4F75747075744F66667365742865297B72657475726E20653E303F746869732E7772617070656454657874496E64656E744C656E6774683A307D6765744C696E654C656E6774682865297B636F6E737420743D653E303F746869732E62';
wwv_flow_imp.g_varchar2_table(16811) := '7265616B4F6666736574735B652D315D3A303B6C6574206E3D746869732E627265616B4F6666736574735B655D2D743B72657475726E20653E302626286E2B3D746869732E7772617070656454657874496E64656E744C656E677468292C6E7D6765744D';
wwv_flow_imp.g_varchar2_table(16812) := '61784F75747075744F66667365742865297B72657475726E20746869732E6765744C696E654C656E6774682865297D7472616E736C617465546F496E7075744F666673657428652C74297B653E30262628743D4D6174682E6D617828302C742D74686973';
wwv_flow_imp.g_varchar2_table(16813) := '2E7772617070656454657874496E64656E744C656E67746829293B6C6574206E3D303D3D3D653F743A746869732E627265616B4F6666736574735B652D315D2B743B6966286E756C6C213D3D746869732E696E6A656374696F6E4F66667365747329666F';
wwv_flow_imp.g_varchar2_table(16814) := '72286C657420653D303B653C746869732E696E6A656374696F6E4F6666736574732E6C656E67746826266E3E746869732E696E6A656374696F6E4F6666736574735B655D3B652B2B296E3C746869732E696E6A656374696F6E4F6666736574735B655D2B';
wwv_flow_imp.g_varchar2_table(16815) := '746869732E696E6A656374696F6E4F7074696F6E735B655D2E636F6E74656E742E6C656E6774683F6E3D746869732E696E6A656374696F6E4F6666736574735B655D3A6E2D3D746869732E696E6A656374696F6E4F7074696F6E735B655D2E636F6E7465';
wwv_flow_imp.g_varchar2_table(16816) := '6E742E6C656E6774683B72657475726E206E7D7472616E736C617465546F4F7574707574506F736974696F6E28652C743D32297B6C6574206E3D653B6966286E756C6C213D3D746869732E696E6A656374696F6E4F66667365747329666F72286C657420';
wwv_flow_imp.g_varchar2_table(16817) := '693D303B693C746869732E696E6A656374696F6E4F6666736574732E6C656E67746826262128653C746869732E696E6A656374696F6E4F6666736574735B695D29262628313D3D3D747C7C65213D3D746869732E696E6A656374696F6E4F666673657473';
wwv_flow_imp.g_varchar2_table(16818) := '5B695D293B692B2B296E2B3D746869732E696E6A656374696F6E4F7074696F6E735B695D2E636F6E74656E742E6C656E6774683B72657475726E20746869732E6F6666736574496E496E70757457697468496E6A656374696F6E73546F4F757470757450';
wwv_flow_imp.g_varchar2_table(16819) := '6F736974696F6E286E2C74297D6F6666736574496E496E70757457697468496E6A656374696F6E73546F4F7574707574506F736974696F6E28652C743D32297B6C6574206E3D302C693D746869732E627265616B4F6666736574732E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(16820) := '2C6F3D302C733D303B666F72283B6E3C3D693B297B6F3D6E2B28692D6E292F327C303B636F6E737420723D746869732E627265616B4F6666736574735B6F5D3B696628733D6F3E303F746869732E627265616B4F6666736574735B6F2D315D3A302C303D';
wwv_flow_imp.g_varchar2_table(16821) := '3D3D7429696628653C3D7329693D6F2D313B656C73657B6966282128653E722929627265616B3B6E3D6F2B317D656C736520696628653C7329693D6F2D313B656C73657B6966282128653E3D722929627265616B3B6E3D6F2B317D7D6C657420723D652D';
wwv_flow_imp.g_varchar2_table(16822) := '733B72657475726E206F3E30262628722B3D746869732E7772617070656454657874496E64656E744C656E677468292C6E6577204F52286F2C72297D6E6F726D616C697A654F7574707574506F736974696F6E28652C742C6E297B6966286E756C6C213D';
wwv_flow_imp.g_varchar2_table(16823) := '3D746869732E696E6A656374696F6E4F666673657473297B636F6E737420693D746869732E6F7574707574506F736974696F6E546F4F6666736574496E496E70757457697468496E6A656374696F6E7328652C74292C6F3D746869732E6E6F726D616C69';
wwv_flow_imp.g_varchar2_table(16824) := '7A654F6666736574496E496E70757457697468496E6A656374696F6E7341726F756E64496E6A656374696F6E7328692C6E293B6966286F213D3D692972657475726E20746869732E6F6666736574496E496E70757457697468496E6A656374696F6E7354';
wwv_flow_imp.g_varchar2_table(16825) := '6F4F7574707574506F736974696F6E286F2C6E297D696628303D3D3D6E297B696628653E302626743D3D3D746869732E6765744D696E4F75747075744F66667365742865292972657475726E206E6577204F5228652D312C746869732E6765744D61784F';
wwv_flow_imp.g_varchar2_table(16826) := '75747075744F666673657428652D3129297D656C736520696628313D3D3D6E2626653C746869732E6765744F75747075744C696E65436F756E7428292D312626743D3D3D746869732E6765744D61784F75747075744F6666736574286529297265747572';
wwv_flow_imp.g_varchar2_table(16827) := '6E206E6577204F5228652B312C746869732E6765744D696E4F75747075744F666673657428652B3129293B72657475726E206E6577204F5228652C74297D6F7574707574506F736974696F6E546F4F6666736574496E496E70757457697468496E6A6563';
wwv_flow_imp.g_varchar2_table(16828) := '74696F6E7328652C74297B72657475726E20653E30262628743D4D6174682E6D617828302C742D746869732E7772617070656454657874496E64656E744C656E67746829292C28653E303F746869732E627265616B4F6666736574735B652D315D3A3029';
wwv_flow_imp.g_varchar2_table(16829) := '2B747D6E6F726D616C697A654F6666736574496E496E70757457697468496E6A656374696F6E7341726F756E64496E6A656374696F6E7328652C74297B636F6E7374206E3D746869732E676574496E6A65637465645465787441744F6666736574286529';
wwv_flow_imp.g_varchar2_table(16830) := '3B696628216E2972657475726E20653B696628323D3D3D74297B696628653D3D3D6E2E6F6666736574496E496E70757457697468496E6A656374696F6E732B6E2E6C656E67746826264E5228746869732E696E6A656374696F6E4F7074696F6E735B6E2E';
wwv_flow_imp.g_varchar2_table(16831) := '696E6A656374656454657874496E6465785D2E637572736F7253746F7073292972657475726E206E2E6F6666736574496E496E70757457697468496E6A656374696F6E732B6E2E6C656E6774683B7B6C657420653D6E2E6F6666736574496E496E707574';
wwv_flow_imp.g_varchar2_table(16832) := '57697468496E6A656374696F6E733B696628505228746869732E696E6A656374696F6E4F7074696F6E735B6E2E696E6A656374656454657874496E6465785D2E637572736F7253746F7073292972657475726E20653B6C657420743D6E2E696E6A656374';
wwv_flow_imp.g_varchar2_table(16833) := '656454657874496E6465782D313B666F72283B743E3D302626746869732E696E6A656374696F6E4F6666736574735B745D3D3D3D746869732E696E6A656374696F6E4F6666736574735B6E2E696E6A656374656454657874496E6465785D2626214E5228';
wwv_flow_imp.g_varchar2_table(16834) := '746869732E696E6A656374696F6E4F7074696F6E735B745D2E637572736F7253746F707329262628652D3D746869732E696E6A656374696F6E4F7074696F6E735B745D2E636F6E74656E742E6C656E6774682C21505228746869732E696E6A656374696F';
wwv_flow_imp.g_varchar2_table(16835) := '6E4F7074696F6E735B745D2E637572736F7253746F707329293B29742D2D3B72657475726E20657D7D696628313D3D3D747C7C343D3D3D74297B6C657420653D6E2E6F6666736574496E496E70757457697468496E6A656374696F6E732B6E2E6C656E67';
wwv_flow_imp.g_varchar2_table(16836) := '74682C743D6E2E696E6A656374656454657874496E6465783B666F72283B742B313C746869732E696E6A656374696F6E4F6666736574732E6C656E6774682626746869732E696E6A656374696F6E4F6666736574735B742B315D3D3D3D746869732E696E';
wwv_flow_imp.g_varchar2_table(16837) := '6A656374696F6E4F6666736574735B745D3B29652B3D746869732E696E6A656374696F6E4F7074696F6E735B742B315D2E636F6E74656E742E6C656E6774682C742B2B3B72657475726E20657D696628303D3D3D747C7C333D3D3D74297B6C657420653D';
wwv_flow_imp.g_varchar2_table(16838) := '6E2E6F6666736574496E496E70757457697468496E6A656374696F6E732C743D6E2E696E6A656374656454657874496E6465783B666F72283B742D313E3D302626746869732E696E6A656374696F6E4F6666736574735B742D315D3D3D3D746869732E69';
wwv_flow_imp.g_varchar2_table(16839) := '6E6A656374696F6E4F6666736574735B745D3B29652D3D746869732E696E6A656374696F6E4F7074696F6E735B742D315D2E636F6E74656E742E6C656E6774682C742D2D3B72657475726E20657D666428297D676574496E6A6563746564546578742865';
wwv_flow_imp.g_varchar2_table(16840) := '2C74297B636F6E7374206E3D746869732E6F7574707574506F736974696F6E546F4F6666736574496E496E70757457697468496E6A656374696F6E7328652C74292C693D746869732E676574496E6A65637465645465787441744F6666736574286E293B';
wwv_flow_imp.g_varchar2_table(16841) := '72657475726E20693F7B6F7074696F6E733A746869732E696E6A656374696F6E4F7074696F6E735B692E696E6A656374656454657874496E6465785D7D3A6E756C6C7D676574496E6A65637465645465787441744F66667365742865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(16842) := '743D746869732E696E6A656374696F6E4F6666736574732C6E3D746869732E696E6A656374696F6E4F7074696F6E733B6966286E756C6C213D3D74297B6C657420693D303B666F72286C6574206F3D303B6F3C742E6C656E6774683B6F2B2B297B636F6E';
wwv_flow_imp.g_varchar2_table(16843) := '737420733D6E5B6F5D2E636F6E74656E742E6C656E6774682C723D745B6F5D2B692C613D745B6F5D2B692B733B696628723E6529627265616B3B696628653C3D612972657475726E7B696E6A656374656454657874496E6465783A6F2C6F666673657449';
wwv_flow_imp.g_varchar2_table(16844) := '6E496E70757457697468496E6A656374696F6E733A722C6C656E6774683A737D3B692B3D737D7D7D7D66756E6374696F6E204E522865297B72657475726E206E756C6C3D3D657C7C653D3D3D6B682E52696768747C7C653D3D3D6B682E426F74687D6675';
wwv_flow_imp.g_varchar2_table(16845) := '6E6374696F6E2050522865297B72657475726E206E756C6C3D3D657C7C653D3D3D6B682E4C6566747C7C653D3D3D6B682E426F74687D636C617373204F527B636F6E7374727563746F7228652C74297B746869732E6F75747075744C696E65496E646578';
wwv_flow_imp.g_varchar2_table(16846) := '3D652C746869732E6F75747075744F66667365743D747D746F537472696E6728297B72657475726E60247B746869732E6F75747075744C696E65496E6465787D3A247B746869732E6F75747075744F66667365747D607D746F506F736974696F6E286529';
wwv_flow_imp.g_varchar2_table(16847) := '7B72657475726E206E6577206D6328652B746869732E6F75747075744C696E65496E6465782C746869732E6F75747075744F66667365742B31297D7D636F6E73742052523D65452822646F6D4C696E65427265616B73436F6D7075746572222C7B637265';
wwv_flow_imp.g_varchar2_table(16848) := '61746548544D4C3A653D3E657D293B636C6173732046527B737461746963206372656174652865297B72657475726E206E6577204652286E6577205765616B526566286529297D636F6E7374727563746F722865297B746869732E74617267657457696E';
wwv_flow_imp.g_varchar2_table(16849) := '646F773D657D6372656174654C696E65427265616B73436F6D707574657228652C742C6E2C692C6F297B636F6E737420733D5B5D2C723D5B5D3B72657475726E7B616464526571756573743A28652C742C6E293D3E7B732E707573682865292C722E7075';
wwv_flow_imp.g_varchar2_table(16850) := '73682874297D2C66696E616C697A653A28293D3E66756E6374696F6E28652C742C6E2C692C6F2C732C722C61297B766172206C3B66756E6374696F6E20632865297B636F6E7374206E3D615B655D3B6966286E297B636F6E737420693D61432E6170706C';
wwv_flow_imp.g_varchar2_table(16851) := '79496E6A65637465645465787428745B655D2C6E292C6F3D6E2E6D61702828653D3E652E6F7074696F6E7329292C733D6E2E6D61702828653D3E652E636F6C756D6E2D3129293B72657475726E206E657720415228732C6F2C5B692E6C656E6774685D2C';
wwv_flow_imp.g_varchar2_table(16852) := '5B5D2C30297D72657475726E206E756C6C7D6966282D313D3D3D6F297B636F6E737420653D5B5D3B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29655B6E5D3D63286E293B72657475726E20657D636F6E737420643D4D61';
wwv_flow_imp.g_varchar2_table(16853) := '74682E726F756E64286F2A6E2E7479706963616C48616C6677696474684368617261637465725769647468292C683D333D3D3D733F323A323D3D3D733F313A302C753D4D6174682E726F756E6428692A68292C703D4D6174682E6365696C286E2E737061';
wwv_flow_imp.g_varchar2_table(16854) := '636557696474682A75292C673D646F63756D656E742E637265617465456C656D656E74282264697622293B724528672C6E293B636F6E7374206D3D6E6577206E7028316534292C663D5B5D2C763D5B5D2C623D5B5D2C5F3D5B5D2C793D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(16855) := '6C657420653D303B653C742E6C656E6774683B652B2B297B636F6E7374206F3D61432E6170706C79496E6A65637465645465787428745B655D2C615B655D293B6C657420723D302C6C3D302C633D643B69662830213D3D7329696628723D6D69286F292C';
wwv_flow_imp.g_varchar2_table(16856) := '2D313D3D3D7229723D303B656C73657B666F72286C657420653D303B653C723B652B2B296C2B3D393D3D3D6F2E63686172436F646541742865293F692D6C25693A313B636F6E737420653D4D6174682E6365696C286E2E737061636557696474682A6C29';
wwv_flow_imp.g_varchar2_table(16857) := '3B652B6E2E7479706963616C46756C6C776964746843686172616374657257696474683E643F28723D302C6C3D30293A633D642D657D636F6E737420683D6F2E7375627374722872292C753D425228682C6C2C692C632C6D2C70293B665B655D3D722C76';
wwv_flow_imp.g_varchar2_table(16858) := '5B655D3D6C2C625B655D3D682C5F5B655D3D755B305D2C795B655D3D755B315D7D636F6E737420773D6D2E6275696C6428292C433D6E756C6C213D3D286C3D6E756C6C3D3D52523F766F696420303A52522E63726561746548544D4C287729292626766F';
wwv_flow_imp.g_varchar2_table(16859) := '69642030213D3D6C3F6C3A773B672E696E6E657248544D4C3D432C672E7374796C652E706F736974696F6E3D226162736F6C757465222C672E7374796C652E746F703D223130303030222C226B656570416C6C223D3D3D723F28672E7374796C652E776F';
wwv_flow_imp.g_varchar2_table(16860) := '7264427265616B3D226B6565702D616C6C222C672E7374796C652E6F766572666C6F77577261703D22616E79776865726522293A28672E7374796C652E776F7264427265616B3D22696E6865726974222C672E7374796C652E6F766572666C6F77577261';
wwv_flow_imp.g_varchar2_table(16861) := '703D22627265616B2D776F726422292C652E646F63756D656E742E626F64792E617070656E644368696C642867293B636F6E737420533D646F63756D656E742E63726561746552616E676528292C783D41727261792E70726F746F747970652E736C6963';
wwv_flow_imp.g_varchar2_table(16862) := '652E63616C6C28672E6368696C6472656E2C30292C6B3D5B5D3B666F72286C657420653D303B653C742E6C656E6774683B652B2B297B636F6E737420743D565228532C785B655D2C625B655D2C5F5B655D293B6966286E756C6C3D3D3D74297B6B5B655D';
wwv_flow_imp.g_varchar2_table(16863) := '3D632865293B636F6E74696E75657D636F6E7374206E3D665B655D2C693D765B655D2B752C6F3D795B655D2C733D5B5D3B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B29735B655D3D6F5B745B655D5D3B69662830213D3D';
wwv_flow_imp.g_varchar2_table(16864) := '6E29666F72286C657420653D302C693D742E6C656E6774683B653C693B652B2B29745B655D2B3D6E3B6C657420722C6C3B636F6E737420643D615B655D3B643F28723D642E6D61702828653D3E652E6F7074696F6E7329292C6C3D642E6D61702828653D';
wwv_flow_imp.g_varchar2_table(16865) := '3E652E636F6C756D6E2D312929293A28723D6E756C6C2C6C3D6E756C6C292C6B5B655D3D6E6577204152286C2C722C742C732C69297D72657475726E20652E646F63756D656E742E626F64792E72656D6F76654368696C642867292C6B7D28776C287468';
wwv_flow_imp.g_varchar2_table(16866) := '69732E74617267657457696E646F772E64657265662829292C732C652C742C6E2C692C6F2C72297D7D7D66756E6374696F6E20425228652C742C6E2C692C6F2C73297B69662830213D3D73297B636F6E737420653D537472696E672873293B6F2E617070';
wwv_flow_imp.g_varchar2_table(16867) := '656E64537472696E6728273C646976207374796C653D22746578742D696E64656E743A202D27292C6F2E617070656E64537472696E672865292C6F2E617070656E64537472696E67282270783B2070616464696E672D6C6566743A2022292C6F2E617070';
wwv_flow_imp.g_varchar2_table(16868) := '656E64537472696E672865292C6F2E617070656E64537472696E67282270783B20626F782D73697A696E673A20626F726465722D626F783B2077696474683A22297D656C7365206F2E617070656E64537472696E6728273C646976207374796C653D2277';
wwv_flow_imp.g_varchar2_table(16869) := '696474683A27293B6F2E617070656E64537472696E6728537472696E67286929292C6F2E617070656E64537472696E67282770783B223E27293B636F6E737420723D652E6C656E6774683B6C657420613D742C6C3D303B636F6E737420633D5B5D2C643D';
wwv_flow_imp.g_varchar2_table(16870) := '5B5D3B6C657420683D303C723F652E63686172436F646541742830293A303B6F2E617070656E64537472696E6728223C7370616E3E22293B666F72286C657420743D303B743C723B742B2B297B30213D3D742626742531363338343D3D3026266F2E6170';
wwv_flow_imp.g_varchar2_table(16871) := '70656E64537472696E6728223C2F7370616E3E3C7370616E3E22292C635B745D3D6C2C645B745D3D613B636F6E737420693D683B683D742B313C723F652E63686172436F6465417428742B31293A303B6C657420733D312C753D313B7377697463682869';
wwv_flow_imp.g_varchar2_table(16872) := '297B6361736520393A733D6E2D61256E2C753D733B666F72286C657420653D313B653C3D733B652B2B29653C733F6F2E617070656E6443686172436F646528313630293A6F2E617070656E64415343494943686172436F6465283332293B627265616B3B';
wwv_flow_imp.g_varchar2_table(16873) := '636173652033323A33323D3D3D683F6F2E617070656E6443686172436F646528313630293A6F2E617070656E64415343494943686172436F6465283332293B627265616B3B636173652036303A6F2E617070656E64537472696E672822266C743B22293B';
wwv_flow_imp.g_varchar2_table(16874) := '627265616B3B636173652036323A6F2E617070656E64537472696E6728222667743B22293B627265616B3B636173652033383A6F2E617070656E64537472696E67282226616D703B22293B627265616B3B6361736520303A6F2E617070656E6453747269';
wwv_flow_imp.g_varchar2_table(16875) := '6E672822262330303B22293B627265616B3B636173652036353237393A6361736520383233323A6361736520383233333A63617365203133333A6F2E617070656E6443686172436F6465283635353333293B627265616B3B64656661756C743A6A692869';
wwv_flow_imp.g_varchar2_table(16876) := '292626752B2B2C693C33323F6F2E617070656E6443686172436F646528393231362B69293A6F2E617070656E6443686172436F64652869297D6C2B3D732C612B3D757D72657475726E206F2E617070656E64537472696E6728223C2F7370616E3E22292C';
wwv_flow_imp.g_varchar2_table(16877) := '635B652E6C656E6774685D3D6C2C645B652E6C656E6774685D3D612C6F2E617070656E64537472696E6728223C2F6469763E22292C5B632C645D7D66756E6374696F6E20565228652C742C6E2C69297B6966286E2E6C656E6774683C3D31297265747572';
wwv_flow_imp.g_varchar2_table(16878) := '6E206E756C6C3B636F6E7374206F3D41727261792E70726F746F747970652E736C6963652E63616C6C28742E6368696C6472656E2C30292C733D5B5D3B7472797B7A5228652C6F2C692C302C6E756C6C2C6E2E6C656E6774682D312C6E756C6C2C73297D';
wwv_flow_imp.g_varchar2_table(16879) := '63617463682865297B72657475726E20636F6E736F6C652E6C6F672865292C6E756C6C7D72657475726E20303D3D3D732E6C656E6774683F6E756C6C3A28732E70757368286E2E6C656E677468292C73297D66756E6374696F6E207A5228652C742C6E2C';
wwv_flow_imp.g_varchar2_table(16880) := '692C6F2C732C722C61297B696628693D3D3D732972657475726E3B6966286F3D6F7C7C485228652C742C6E5B695D2C6E5B692B315D292C723D727C7C485228652C742C6E5B735D2C6E5B732B315D292C4D6174682E616273286F5B305D2E746F702D725B';
wwv_flow_imp.g_varchar2_table(16881) := '305D2E746F70293C3D2E312972657475726E3B696628692B313D3D3D732972657475726E20766F696420612E707573682873293B636F6E7374206C3D692B28732D69292F327C302C633D485228652C742C6E5B6C5D2C6E5B6C2B315D293B7A5228652C74';
wwv_flow_imp.g_varchar2_table(16882) := '2C6E2C692C6F2C6C2C632C61292C7A5228652C742C6E2C6C2C632C732C722C61297D66756E6374696F6E20485228652C742C6E2C69297B72657475726E20652E736574537461727428745B6E2F31363338347C305D2E66697273744368696C642C6E2531';
wwv_flow_imp.g_varchar2_table(16883) := '36333834292C652E736574456E6428745B692F31363338347C305D2E66697273744368696C642C69253136333834292C652E676574436C69656E74526563747328297D636C61737320575220657874656E6473206C747B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(16884) := '7B737570657228292C746869732E5F656469746F723D6E756C6C2C746869732E5F696E7374616E74696174696F6E536572766963653D6E756C6C2C746869732E5F696E7374616E6365733D746869732E5F7265676973746572286E6577207574292C7468';
wwv_flow_imp.g_varchar2_table(16885) := '69732E5F70656E64696E673D6E6577204D61702C746869732E5F66696E6973686564496E7374616E74696174696F6E3D5B5D2C746869732E5F66696E6973686564496E7374616E74696174696F6E5B305D3D21312C746869732E5F66696E697368656449';
wwv_flow_imp.g_varchar2_table(16886) := '6E7374616E74696174696F6E5B315D3D21312C746869732E5F66696E6973686564496E7374616E74696174696F6E5B325D3D21312C746869732E5F66696E6973686564496E7374616E74696174696F6E5B335D3D21317D696E697469616C697A6528652C';
wwv_flow_imp.g_varchar2_table(16887) := '742C6E297B746869732E5F656469746F723D652C746869732E5F696E7374616E74696174696F6E536572766963653D6E3B666F7228636F6E73742065206F66207429746869732E5F70656E64696E672E68617328652E6964293F6B65286E657720457272';
wwv_flow_imp.g_varchar2_table(16888) := '6F72286043616E6E6F7420686176652074776F20636F6E747269627574696F6E732077697468207468652073616D6520696420247B652E69647D6029293A746869732E5F70656E64696E672E73657428652E69642C65293B746869732E5F696E7374616E';
wwv_flow_imp.g_varchar2_table(16889) := '7469617465536F6D652830292C746869732E5F726567697374657228777328727328746869732E5F656469746F722E676574446F6D4E6F64652829292C2828293D3E7B746869732E5F696E7374616E7469617465536F6D652831297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(16890) := '2E5F726567697374657228777328727328746869732E5F656469746F722E676574446F6D4E6F64652829292C2828293D3E7B746869732E5F696E7374616E7469617465536F6D652832297D2929292C746869732E5F726567697374657228777328727328';
wwv_flow_imp.g_varchar2_table(16891) := '746869732E5F656469746F722E676574446F6D4E6F64652829292C2828293D3E7B746869732E5F696E7374616E7469617465536F6D652833297D292C35653329297D7361766556696577537461746528297B636F6E737420653D7B7D3B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(16892) := '73745B742C6E5D6F6620746869732E5F696E7374616E636573292266756E6374696F6E223D3D747970656F66206E2E73617665566965775374617465262628655B745D3D6E2E736176655669657753746174652829293B72657475726E20657D72657374';
wwv_flow_imp.g_varchar2_table(16893) := '6F72655669657753746174652865297B666F7228636F6E73745B742C6E5D6F6620746869732E5F696E7374616E636573292266756E6374696F6E223D3D747970656F66206E2E726573746F726556696577537461746526266E2E726573746F7265566965';
wwv_flow_imp.g_varchar2_table(16894) := '77537461746528655B745D297D6765742865297B72657475726E20746869732E5F696E7374616E7469617465427949642865292C746869732E5F696E7374616E6365732E6765742865297C7C6E756C6C7D6F6E4265666F7265496E746572616374696F6E';
wwv_flow_imp.g_varchar2_table(16895) := '4576656E7428297B746869732E5F696E7374616E7469617465536F6D652832297D6F6E41667465724D6F64656C417474616368656428297B76617220653B72657475726E207773287273286E756C6C3D3D3D28653D746869732E5F656469746F72297C7C';
wwv_flow_imp.g_varchar2_table(16896) := '766F696420303D3D3D653F766F696420303A652E676574446F6D4E6F64652829292C2828293D3E7B746869732E5F696E7374616E7469617465536F6D652831297D292C3530297D5F696E7374616E7469617465536F6D652865297B696628746869732E5F';
wwv_flow_imp.g_varchar2_table(16897) := '66696E6973686564496E7374616E74696174696F6E5B655D2972657475726E3B746869732E5F66696E6973686564496E7374616E74696174696F6E5B655D3D21303B636F6E737420743D746869732E5F66696E6450656E64696E67436F6E747269627574';
wwv_flow_imp.g_varchar2_table(16898) := '696F6E734279496E7374616E74696174696F6E2865293B666F7228636F6E73742065206F66207429746869732E5F696E7374616E74696174654279496428652E6964297D5F66696E6450656E64696E67436F6E747269627574696F6E734279496E737461';
wwv_flow_imp.g_varchar2_table(16899) := '6E74696174696F6E2865297B636F6E737420743D5B5D3B666F7228636F6E73745B2C6E5D6F6620746869732E5F70656E64696E67296E2E696E7374616E74696174696F6E3D3D3D652626742E70757368286E293B72657475726E20747D5F696E7374616E';
wwv_flow_imp.g_varchar2_table(16900) := '7469617465427949642865297B636F6E737420743D746869732E5F70656E64696E672E6765742865293B69662874297B696628746869732E5F70656E64696E672E64656C6574652865292C21746869732E5F696E7374616E74696174696F6E5365727669';
wwv_flow_imp.g_varchar2_table(16901) := '63657C7C21746869732E5F656469746F72297468726F77206E6577204572726F72282243616E6E6F7420696E7374616E746961746520636F6E747269627574696F6E73206265666F7265206265696E6720696E697469616C697A65642122293B7472797B';
wwv_flow_imp.g_varchar2_table(16902) := '636F6E737420653D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528742E63746F722C746869732E5F656469746F72293B746869732E5F696E7374616E6365732E73657428742E69642C65292C22';
wwv_flow_imp.g_varchar2_table(16903) := '66756E6374696F6E223D3D747970656F6620652E726573746F7265566965775374617465262630213D3D742E696E7374616E74696174696F6E2626636F6E736F6C652E7761726E2860456469746F7220636F6E747269627574696F6E2027247B742E6964';
wwv_flow_imp.g_varchar2_table(16904) := '7D272073686F756C6420626520656167657220696E7374616E746961746564206265636175736520697420757365732073617665566965775374617465202F20726573746F72655669657753746174652E60297D63617463682865297B6B652865297D7D';
wwv_flow_imp.g_varchar2_table(16905) := '7D7D636C617373206A527B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E69643D652C746869732E6C6162656C3D742C746869732E616C6961733D6E2C746869732E6D657461646174613D692C746869732E5F70726563';
wwv_flow_imp.g_varchar2_table(16906) := '6F6E646974696F6E3D6F2C746869732E5F72756E3D732C746869732E5F636F6E746578744B6579536572766963653D727D6973537570706F7274656428297B72657475726E20746869732E5F636F6E746578744B6579536572766963652E636F6E746578';
wwv_flow_imp.g_varchar2_table(16907) := '744D61746368657352756C657328746869732E5F707265636F6E646974696F6E297D72756E2865297B72657475726E20746869732E6973537570706F7274656428293F746869732E5F72756E2865293A50726F6D6973652E7265736F6C766528766F6964';
wwv_flow_imp.g_varchar2_table(16908) := '2030297D7D636F6E73742071523D7B49436F6465456469746F723A2276732E656469746F722E49436F6465456469746F72222C4944696666456469746F723A2276732E656469746F722E4944696666456469746F72227D3B636C6173732024527B737461';
wwv_flow_imp.g_varchar2_table(16909) := '746963206372656174652865297B72657475726E206E657720245228652E67657428313334292C652E6765742831333329297D636F6E7374727563746F7228652C74297B746869732E636C61737369666965723D6E657720555228652C74297D63726561';
wwv_flow_imp.g_varchar2_table(16910) := '74654C696E65427265616B73436F6D707574657228652C742C6E2C692C6F297B636F6E737420733D5B5D2C723D5B5D2C613D5B5D3B72657475726E7B616464526571756573743A28652C742C6E293D3E7B732E707573682865292C722E70757368287429';
wwv_flow_imp.g_varchar2_table(16911) := '2C612E70757368286E297D2C66696E616C697A653A28293D3E7B636F6E7374206C3D652E7479706963616C46756C6C776964746843686172616374657257696474682F652E7479706963616C48616C66776964746843686172616374657257696474682C';
wwv_flow_imp.g_varchar2_table(16912) := '633D5B5D3B666F72286C657420653D302C643D732E6C656E6774683B653C643B652B2B297B636F6E737420643D725B655D2C683D615B655D3B21687C7C682E696E6A656374696F6E4F7074696F6E737C7C643F635B655D3D595228746869732E636C6173';
wwv_flow_imp.g_varchar2_table(16913) := '7369666965722C735B655D2C642C742C6E2C6C2C692C6F293A635B655D3D515228746869732E636C61737369666965722C682C735B655D2C742C6E2C6C2C692C6F297D72657475726E204B522E6C656E6774683D302C47522E6C656E6774683D302C637D';
wwv_flow_imp.g_varchar2_table(16914) := '7D7D7D636C61737320555220657874656E64732055797B636F6E7374727563746F7228652C74297B73757065722830293B666F72286C657420743D303B743C652E6C656E6774683B742B2B29746869732E73657428652E63686172436F64654174287429';
wwv_flow_imp.g_varchar2_table(16915) := '2C31293B666F72286C657420653D303B653C742E6C656E6774683B652B2B29746869732E73657428742E63686172436F646541742865292C32297D6765742865297B72657475726E20653E3D302626653C3235363F746869732E5F61736369694D61705B';
wwv_flow_imp.g_varchar2_table(16916) := '655D3A653E3D31323335322626653C3D31323534337C7C653E3D31333331322626653C3D31393930337C7C653E3D31393936382626653C3D34303935393F333A746869732E5F6D61702E6765742865297C7C746869732E5F64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(16917) := '7D7D6C6574204B523D5B5D2C47523D5B5D3B66756E6374696F6E20515228652C742C6E2C692C6F2C732C722C61297B6966282D313D3D3D6F2972657475726E206E756C6C3B636F6E7374206C3D6E2E6C656E6774683B6966286C3C3D312972657475726E';
wwv_flow_imp.g_varchar2_table(16918) := '206E756C6C3B636F6E737420633D226B656570416C6C223D3D3D612C643D742E627265616B4F6666736574732C683D742E627265616B4F66667365747356697369626C65436F6C756D6E2C753D6546286E2C692C6F2C732C72292C703D6F2D752C673D4B';
wwv_flow_imp.g_varchar2_table(16919) := '522C6D3D47523B6C657420663D302C763D302C623D302C5F3D6F3B636F6E737420793D642E6C656E6774683B6C657420773D303B696628773E3D30297B6C657420653D4D6174682E61627328685B775D2D5F293B666F72283B772B313C793B297B636F6E';
wwv_flow_imp.g_varchar2_table(16920) := '737420743D4D6174682E61627328685B772B315D2D5F293B696628743E3D6529627265616B3B653D742C772B2B7D7D666F72283B773C793B297B6C657420743D773C303F303A645B775D2C6F3D773C303F303A685B775D3B763E74262628743D762C6F3D';
wwv_flow_imp.g_varchar2_table(16921) := '62293B6C657420723D302C613D302C753D302C433D303B6966286F3C3D5F297B6C657420623D6F2C793D303D3D3D743F303A6E2E63686172436F6465417428742D31292C773D303D3D3D743F303A652E6765742879292C533D21303B666F72286C657420';
wwv_flow_imp.g_varchar2_table(16922) := '6F3D743B6F3C6C3B6F2B2B297B636F6E737420743D6F2C6C3D6E2E63686172436F64654174286F293B6C657420642C683B6966285469286C293F286F2B2B2C643D302C683D32293A28643D652E676574286C292C683D5A52286C2C622C692C7329292C74';
wwv_flow_imp.g_varchar2_table(16923) := '3E7626264A5228302C772C6C2C642C6329262628723D742C613D62292C622B3D682C623E5F297B743E763F28753D742C433D622D68293A28753D6F2B312C433D62292C622D613E70262628723D30292C533D21313B627265616B7D793D6C2C773D647D69';
wwv_flow_imp.g_varchar2_table(16924) := '662853297B663E30262628675B665D3D645B642E6C656E6774682D315D2C6D5B665D3D685B642E6C656E6774682D315D2C662B2B293B627265616B7D7D696628303D3D3D72297B6C6574206C3D6F2C643D6E2E63686172436F646541742874292C683D65';
wwv_flow_imp.g_varchar2_table(16925) := '2E6765742864292C673D21313B666F72286C657420693D742D313B693E3D763B692D2D297B636F6E737420743D692B312C6F3D6E2E63686172436F646541742869293B696628393D3D3D6F297B673D21303B627265616B7D6C6574206D2C663B69662849';
wwv_flow_imp.g_varchar2_table(16926) := '69286F293F28692D2D2C6D3D302C663D32293A286D3D652E676574286F292C663D6A69286F293F733A31292C6C3C3D5F297B696628303D3D3D75262628753D742C433D6C292C6C3C3D5F2D7029627265616B3B6966284A5228302C6D2C642C682C632929';
wwv_flow_imp.g_varchar2_table(16927) := '7B723D742C613D6C3B627265616B7D7D6C2D3D662C643D6F2C683D6D7D69662830213D3D72297B636F6E737420653D702D28432D61293B696628653C3D69297B636F6E737420743D6E2E63686172436F646541742875293B6C6574206F3B6F3D54692874';
wwv_flow_imp.g_varchar2_table(16928) := '293F323A5A5228742C432C692C73292C652D6F3C30262628723D30297D7D69662867297B772D2D3B636F6E74696E75657D7D696628303D3D3D72262628723D752C613D43292C723C3D76297B636F6E737420653D6E2E63686172436F646541742876293B';
wwv_flow_imp.g_varchar2_table(16929) := '54692865293F28723D762B322C613D622B32293A28723D762B312C613D622B5A5228652C622C692C7329297D666F7228763D722C675B665D3D722C623D612C6D5B665D3D612C662B2B2C5F3D612B703B773C307C7C773C792626685B775D3C613B29772B';
wwv_flow_imp.g_varchar2_table(16930) := '2B3B6C657420533D4D6174682E61627328685B775D2D5F293B666F72283B772B313C793B297B636F6E737420653D4D6174682E61627328685B772B315D2D5F293B696628653E3D5329627265616B3B533D652C772B2B7D7D72657475726E20303D3D3D66';
wwv_flow_imp.g_varchar2_table(16931) := '3F6E756C6C3A28672E6C656E6774683D662C6D2E6C656E6774683D662C4B523D742E627265616B4F6666736574732C47523D742E627265616B4F66667365747356697369626C65436F6C756D6E2C742E627265616B4F6666736574733D672C742E627265';
wwv_flow_imp.g_varchar2_table(16932) := '616B4F66667365747356697369626C65436F6C756D6E3D6D2C742E7772617070656454657874496E64656E744C656E6774683D752C74297D66756E6374696F6E20595228652C742C6E2C692C6F2C732C722C61297B636F6E7374206C3D61432E6170706C';
wwv_flow_imp.g_varchar2_table(16933) := '79496E6A65637465645465787428742C6E293B6C657420632C643B6966286E26266E2E6C656E6774683E303F28633D6E2E6D61702828653D3E652E6F7074696F6E7329292C643D6E2E6D61702828653D3E652E636F6C756D6E2D312929293A28633D6E75';
wwv_flow_imp.g_varchar2_table(16934) := '6C6C2C643D6E756C6C292C2D313D3D3D6F2972657475726E20633F6E657720415228642C632C5B6C2E6C656E6774685D2C5B5D2C30293A6E756C6C3B636F6E737420683D6C2E6C656E6774683B696628683C3D312972657475726E20633F6E6577204152';
wwv_flow_imp.g_varchar2_table(16935) := '28642C632C5B6C2E6C656E6774685D2C5B5D2C30293A6E756C6C3B636F6E737420753D226B656570416C6C223D3D3D612C703D6546286C2C692C6F2C732C72292C673D6F2D702C6D3D5B5D2C663D5B5D3B6C657420763D302C623D302C5F3D302C793D6F';
wwv_flow_imp.g_varchar2_table(16936) := '2C773D6C2E63686172436F646541742830292C433D652E6765742877292C533D5A5228772C302C692C73292C783D313B5469287729262628532B3D312C773D6C2E63686172436F646541742831292C433D652E6765742877292C782B2B293B666F72286C';
wwv_flow_imp.g_varchar2_table(16937) := '657420743D783B743C683B742B2B297B636F6E7374206E3D742C6F3D6C2E63686172436F646541742874293B6C657420722C613B5469286F293F28742B2B2C723D302C613D32293A28723D652E676574286F292C613D5A52286F2C532C692C7329292C4A';
wwv_flow_imp.g_varchar2_table(16938) := '5228302C432C6F2C722C7529262628623D6E2C5F3D53292C532B3D612C533E7926262828303D3D3D627C7C532D5F3E6729262628623D6E2C5F3D532D61292C6D5B765D3D622C665B765D3D5F2C762B2B2C793D5F2B672C623D30292C773D6F2C433D727D';
wwv_flow_imp.g_varchar2_table(16939) := '72657475726E2030213D3D767C7C6E262630213D3D6E2E6C656E6774683F286D5B765D3D682C665B765D3D532C6E657720415228642C632C6D2C662C7029293A6E756C6C7D66756E6374696F6E205A5228652C742C6E2C69297B72657475726E20393D3D';
wwv_flow_imp.g_varchar2_table(16940) := '3D653F6E2D74256E3A6A692865297C7C653C33323F693A317D66756E6374696F6E20585228652C74297B72657475726E20742D6525747D66756E6374696F6E204A5228652C742C6E2C692C6F297B72657475726E203332213D3D6E262628323D3D3D7426';
wwv_flow_imp.g_varchar2_table(16941) := '2632213D3D697C7C31213D3D742626313D3D3D697C7C216F2626333D3D3D74262632213D3D697C7C216F2626333D3D3D69262631213D3D74297D66756E6374696F6E20654628652C742C6E2C692C6F297B6C657420733D303B69662830213D3D6F297B63';
wwv_flow_imp.g_varchar2_table(16942) := '6F6E737420723D6D692865293B6966282D31213D3D72297B666F72286C6574206E3D303B6E3C723B6E2B2B29732B3D393D3D3D652E63686172436F64654174286E293F585228732C74293A313B636F6E737420613D333D3D3D6F3F323A323D3D3D6F3F31';
wwv_flow_imp.g_varchar2_table(16943) := '3A303B666F72286C657420653D303B653C613B652B2B29732B3D585228732C74293B732B693E6E262628733D30297D7D72657475726E20737D636C6173732074467B636F6E7374727563746F722865297B746869732E5F73656C547261636B656452616E';
wwv_flow_imp.g_varchar2_table(16944) := '67653D6E756C6C2C746869732E5F747261636B53656C656374696F6E3D21302C746869732E5F736574537461746528652C6E6577205843286E657720726828312C312C312C31292C302C302C6E6577206D6328312C31292C30292C6E6577205843286E65';
wwv_flow_imp.g_varchar2_table(16945) := '7720726828312C312C312C31292C302C302C6E6577206D6328312C31292C3029297D646973706F73652865297B746869732E5F72656D6F7665547261636B656452616E67652865297D7374617274547261636B696E6753656C656374696F6E2865297B74';
wwv_flow_imp.g_varchar2_table(16946) := '6869732E5F747261636B53656C656374696F6E3D21302C746869732E5F757064617465547261636B656452616E67652865297D73746F70547261636B696E6753656C656374696F6E2865297B746869732E5F747261636B53656C656374696F6E3D21312C';
wwv_flow_imp.g_varchar2_table(16947) := '746869732E5F72656D6F7665547261636B656452616E67652865297D5F757064617465547261636B656452616E67652865297B746869732E5F747261636B53656C656374696F6E262628746869732E5F73656C547261636B656452616E67653D652E6D6F';
wwv_flow_imp.g_varchar2_table(16948) := '64656C2E5F736574547261636B656452616E676528746869732E5F73656C547261636B656452616E67652C746869732E6D6F64656C53746174652E73656C656374696F6E2C3029297D5F72656D6F7665547261636B656452616E67652865297B74686973';
wwv_flow_imp.g_varchar2_table(16949) := '2E5F73656C547261636B656452616E67653D652E6D6F64656C2E5F736574547261636B656452616E676528746869732E5F73656C547261636B656452616E67652C6E756C6C2C30297D6173437572736F72537461746528297B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(16950) := '514328746869732E6D6F64656C53746174652C746869732E766965775374617465297D7265616453656C656374696F6E46726F6D4D61726B6572732865297B636F6E737420743D652E6D6F64656C2E5F676574547261636B656452616E67652874686973';
wwv_flow_imp.g_varchar2_table(16951) := '2E5F73656C547261636B656452616E6765293B72657475726E20746869732E6D6F64656C53746174652E73656C656374696F6E2E6973456D7074792829262621742E6973456D70747928293F61682E66726F6D52616E676528742E636F6C6C6170736554';
wwv_flow_imp.g_varchar2_table(16952) := '6F456E6428292C746869732E6D6F64656C53746174652E73656C656374696F6E2E676574446972656374696F6E2829293A61682E66726F6D52616E676528742C746869732E6D6F64656C53746174652E73656C656374696F6E2E67657444697265637469';
wwv_flow_imp.g_varchar2_table(16953) := '6F6E2829297D656E7375726556616C696453746174652865297B746869732E5F736574537461746528652C746869732E6D6F64656C53746174652C746869732E766965775374617465297D736574537461746528652C742C6E297B746869732E5F736574';
wwv_flow_imp.g_varchar2_table(16954) := '537461746528652C742C6E297D737461746963205F76616C6964617465506F736974696F6E57697468436163686528652C742C6E2C69297B72657475726E20742E657175616C73286E293F693A652E6E6F726D616C697A65506F736974696F6E28742C32';
wwv_flow_imp.g_varchar2_table(16955) := '297D737461746963205F76616C696461746556696577537461746528652C74297B636F6E7374206E3D742E706F736974696F6E2C693D742E73656C656374696F6E53746172742E6765745374617274506F736974696F6E28292C6F3D742E73656C656374';
wwv_flow_imp.g_varchar2_table(16956) := '696F6E53746172742E676574456E64506F736974696F6E28292C733D652E6E6F726D616C697A65506F736974696F6E286E2C32292C723D746869732E5F76616C6964617465506F736974696F6E57697468436163686528652C692C6E2C73292C613D7468';
wwv_flow_imp.g_varchar2_table(16957) := '69732E5F76616C6964617465506F736974696F6E57697468436163686528652C6F2C692C72293B72657475726E206E2E657175616C732873292626692E657175616C7328722926266F2E657175616C732861293F743A6E65772058432872682E66726F6D';
wwv_flow_imp.g_varchar2_table(16958) := '506F736974696F6E7328722C61292C742E73656C656374696F6E53746172744B696E642C742E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E732B692E636F6C756D6E2D722E636F6C756D6E2C732C742E6C6566';
wwv_flow_imp.g_varchar2_table(16959) := '746F76657256697369626C65436F6C756D6E732B6E2E636F6C756D6E2D732E636F6C756D6E297D5F736574537461746528652C742C6E297B6966286E2626286E3D74462E5F76616C696461746556696577537461746528652E766965774D6F64656C2C6E';
wwv_flow_imp.g_varchar2_table(16960) := '29292C74297B636F6E7374206E3D652E6D6F64656C2E76616C696461746552616E676528742E73656C656374696F6E5374617274292C693D742E73656C656374696F6E53746172742E657175616C7352616E6765286E293F742E73656C656374696F6E53';
wwv_flow_imp.g_varchar2_table(16961) := '746172744C6566746F76657256697369626C65436F6C756D6E733A302C6F3D652E6D6F64656C2E76616C6964617465506F736974696F6E28742E706F736974696F6E292C733D742E706F736974696F6E2E657175616C73286F293F742E6C6566746F7665';
wwv_flow_imp.g_varchar2_table(16962) := '7256697369626C65436F6C756D6E733A303B743D6E6577205843286E2C742E73656C656374696F6E53746172744B696E642C692C6F2C73297D656C73657B696628216E2972657475726E3B636F6E737420693D652E6D6F64656C2E76616C696461746552';
wwv_flow_imp.g_varchar2_table(16963) := '616E676528652E636F6F7264696E61746573436F6E7665727465722E636F6E766572745669657752616E6765546F4D6F64656C52616E6765286E2E73656C656374696F6E537461727429292C6F3D652E6D6F64656C2E76616C6964617465506F73697469';
wwv_flow_imp.g_varchar2_table(16964) := '6F6E28652E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E2E706F736974696F6E29293B743D6E657720584328692C6E2E73656C656374696F6E53746172';
wwv_flow_imp.g_varchar2_table(16965) := '744B696E642C6E2E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E732C6F2C6E2E6C6566746F76657256697369626C65436F6C756D6E73297D6966286E297B636F6E737420693D652E636F6F7264696E61746573';
wwv_flow_imp.g_varchar2_table(16966) := '436F6E7665727465722E76616C69646174655669657752616E6765286E2E73656C656374696F6E53746172742C742E73656C656374696F6E5374617274292C6F3D652E636F6F7264696E61746573436F6E7665727465722E76616C696461746556696577';
wwv_flow_imp.g_varchar2_table(16967) := '506F736974696F6E286E2E706F736974696F6E2C742E706F736974696F6E293B6E3D6E657720584328692C742E73656C656374696F6E53746172744B696E642C742E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D';
wwv_flow_imp.g_varchar2_table(16968) := '6E732C6F2C742E6C6566746F76657256697369626C65436F6C756D6E73297D656C73657B636F6E737420693D652E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F';
wwv_flow_imp.g_varchar2_table(16969) := '6E286E6577206D6328742E73656C656374696F6E53746172742E73746172744C696E654E756D6265722C742E73656C656374696F6E53746172742E7374617274436F6C756D6E29292C6F3D652E636F6F7264696E61746573436F6E7665727465722E636F';
wwv_flow_imp.g_varchar2_table(16970) := '6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328742E73656C656374696F6E53746172742E656E644C696E654E756D6265722C742E73656C656374696F6E53746172742E656E64436F6C756D6E29292C';
wwv_flow_imp.g_varchar2_table(16971) := '733D6E657720726828692E6C696E654E756D6265722C692E636F6C756D6E2C6F2E6C696E654E756D6265722C6F2E636F6C756D6E292C723D652E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E54';
wwv_flow_imp.g_varchar2_table(16972) := '6F56696577506F736974696F6E28742E706F736974696F6E293B6E3D6E657720584328732C742E73656C656374696F6E53746172744B696E642C742E73656C656374696F6E53746172744C6566746F76657256697369626C65436F6C756D6E732C722C74';
wwv_flow_imp.g_varchar2_table(16973) := '2E6C6566746F76657256697369626C65436F6C756D6E73297D746869732E6D6F64656C53746174653D742C746869732E7669657753746174653D6E2C746869732E5F757064617465547261636B656452616E67652865297D7D636C617373206E467B636F';
wwv_flow_imp.g_varchar2_table(16974) := '6E7374727563746F722865297B746869732E636F6E746578743D652C746869732E637572736F72733D5B6E65772074462865295D2C746869732E6C6173744164646564437572736F72496E6465783D307D646973706F736528297B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(16975) := '2065206F6620746869732E637572736F727329652E646973706F736528746869732E636F6E74657874297D7374617274547261636B696E6753656C656374696F6E7328297B666F7228636F6E73742065206F6620746869732E637572736F727329652E73';
wwv_flow_imp.g_varchar2_table(16976) := '74617274547261636B696E6753656C656374696F6E28746869732E636F6E74657874297D73746F70547261636B696E6753656C656374696F6E7328297B666F7228636F6E73742065206F6620746869732E637572736F727329652E73746F70547261636B';
wwv_flow_imp.g_varchar2_table(16977) := '696E6753656C656374696F6E28746869732E636F6E74657874297D757064617465436F6E746578742865297B746869732E636F6E746578743D657D656E7375726556616C6964537461746528297B666F7228636F6E73742065206F6620746869732E6375';
wwv_flow_imp.g_varchar2_table(16978) := '72736F727329652E656E7375726556616C6964537461746528746869732E636F6E74657874297D7265616453656C656374696F6E46726F6D4D61726B65727328297B72657475726E20746869732E637572736F72732E6D61702828653D3E652E72656164';
wwv_flow_imp.g_varchar2_table(16979) := '53656C656374696F6E46726F6D4D61726B65727328746869732E636F6E746578742929297D676574416C6C28297B72657475726E20746869732E637572736F72732E6D61702828653D3E652E6173437572736F725374617465282929297D676574566965';
wwv_flow_imp.g_varchar2_table(16980) := '77506F736974696F6E7328297B72657475726E20746869732E637572736F72732E6D61702828653D3E652E7669657753746174652E706F736974696F6E29297D676574546F704D6F737456696577506F736974696F6E28297B72657475726E2066756E63';
wwv_flow_imp.g_varchar2_table(16981) := '74696F6E28652C74297B72657475726E20437528652C2828652C6E293D3E2D7428652C6E2929297D28746869732E637572736F72732C65752828653D3E652E7669657753746174652E706F736974696F6E292C6D632E636F6D7061726529292E76696577';
wwv_flow_imp.g_varchar2_table(16982) := '53746174652E706F736974696F6E7D676574426F74746F6D4D6F737456696577506F736974696F6E28297B72657475726E2066756E6374696F6E28652C74297B696628303D3D3D652E6C656E6774682972657475726E3B6C6574206E3D655B305D3B666F';
wwv_flow_imp.g_varchar2_table(16983) := '72286C657420693D313B693C652E6C656E6774683B692B2B297B636F6E7374206F3D655B695D3B74286F2C6E293E3D302626286E3D6F297D72657475726E206E7D28746869732E637572736F72732C65752828653D3E652E7669657753746174652E706F';
wwv_flow_imp.g_varchar2_table(16984) := '736974696F6E292C6D632E636F6D7061726529292E7669657753746174652E706F736974696F6E7D67657453656C656374696F6E7328297B72657475726E20746869732E637572736F72732E6D61702828653D3E652E6D6F64656C53746174652E73656C';
wwv_flow_imp.g_varchar2_table(16985) := '656374696F6E29297D6765745669657753656C656374696F6E7328297B72657475726E20746869732E637572736F72732E6D61702828653D3E652E7669657753746174652E73656C656374696F6E29297D73657453656C656374696F6E732865297B7468';
wwv_flow_imp.g_varchar2_table(16986) := '69732E7365745374617465732851432E66726F6D4D6F64656C53656C656374696F6E73286529297D6765745072696D617279437572736F7228297B72657475726E20746869732E637572736F72735B305D2E6173437572736F72537461746528297D7365';
wwv_flow_imp.g_varchar2_table(16987) := '745374617465732865297B6E756C6C213D3D65262628746869732E637572736F72735B305D2E736574537461746528746869732E636F6E746578742C655B305D2E6D6F64656C53746174652C655B305D2E766965775374617465292C746869732E5F7365';
wwv_flow_imp.g_varchar2_table(16988) := '745365636F6E6461727953746174657328652E736C69636528312929297D5F7365745365636F6E646172795374617465732865297B636F6E737420743D746869732E637572736F72732E6C656E6774682D312C6E3D652E6C656E6774683B696628743C6E';
wwv_flow_imp.g_varchar2_table(16989) := '297B636F6E737420653D6E2D743B666F72286C657420743D303B743C653B742B2B29746869732E5F6164645365636F6E64617279437572736F7228297D656C736520696628743E6E297B636F6E737420653D742D6E3B666F72286C657420743D303B743C';
wwv_flow_imp.g_varchar2_table(16990) := '653B742B2B29746869732E5F72656D6F76655365636F6E64617279437572736F7228746869732E637572736F72732E6C656E6774682D32297D666F72286C657420743D303B743C6E3B742B2B29746869732E637572736F72735B742B315D2E7365745374';
wwv_flow_imp.g_varchar2_table(16991) := '61746528746869732E636F6E746578742C655B745D2E6D6F64656C53746174652C655B745D2E766965775374617465297D6B696C6C5365636F6E64617279437572736F727328297B746869732E5F7365745365636F6E64617279537461746573285B5D29';
wwv_flow_imp.g_varchar2_table(16992) := '7D5F6164645365636F6E64617279437572736F7228297B746869732E637572736F72732E70757368286E657720744628746869732E636F6E7465787429292C746869732E6C6173744164646564437572736F72496E6465783D746869732E637572736F72';
wwv_flow_imp.g_varchar2_table(16993) := '732E6C656E6774682D317D6765744C6173744164646564437572736F72496E64657828297B72657475726E20313D3D3D746869732E637572736F72732E6C656E6774687C7C303D3D3D746869732E6C6173744164646564437572736F72496E6465783F30';
wwv_flow_imp.g_varchar2_table(16994) := '3A746869732E6C6173744164646564437572736F72496E6465787D5F72656D6F76655365636F6E64617279437572736F722865297B746869732E6C6173744164646564437572736F72496E6465783E3D652B312626746869732E6C617374416464656443';
wwv_flow_imp.g_varchar2_table(16995) := '7572736F72496E6465782D2D2C746869732E637572736F72735B652B315D2E646973706F736528746869732E636F6E74657874292C746869732E637572736F72732E73706C69636528652B312C31297D6E6F726D616C697A6528297B696628313D3D3D74';
wwv_flow_imp.g_varchar2_table(16996) := '6869732E637572736F72732E6C656E6774682972657475726E3B636F6E737420653D746869732E637572736F72732E736C6963652830292C743D5B5D3B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29742E70757368287B';
wwv_flow_imp.g_varchar2_table(16997) := '696E6465783A6E2C73656C656374696F6E3A655B6E5D2E6D6F64656C53746174652E73656C656374696F6E7D293B742E736F72742865752828653D3E652E73656C656374696F6E292C72682E636F6D7061726552616E6765735573696E67537461727473';
wwv_flow_imp.g_varchar2_table(16998) := '29293B666F72286C6574206E3D303B6E3C742E6C656E6774682D313B6E2B2B297B636F6E737420693D745B6E5D2C6F3D745B6E2B315D2C733D692E73656C656374696F6E2C723D6F2E73656C656374696F6E3B69662821746869732E636F6E746578742E';
wwv_flow_imp.g_varchar2_table(16999) := '637572736F72436F6E6669672E6D756C7469437572736F724D657267654F7665726C617070696E6729636F6E74696E75653B6C657420613B696628613D722E6973456D70747928297C7C732E6973456D70747928293F722E6765745374617274506F7369';
wwv_flow_imp.g_varchar2_table(17000) := '74696F6E28292E69734265666F72654F72457175616C28732E676574456E64506F736974696F6E2829293A722E6765745374617274506F736974696F6E28292E69734265666F726528732E676574456E64506F736974696F6E2829292C61297B636F6E73';
wwv_flow_imp.g_varchar2_table(17001) := '7420733D692E696E6465783C6F2E696E6465783F6E3A6E2B312C723D692E696E6465783C6F2E696E6465783F6E2B313A6E2C613D745B725D2E696E6465782C6C3D745B735D2E696E6465782C633D745B725D2E73656C656374696F6E2C643D745B735D2E';
wwv_flow_imp.g_varchar2_table(17002) := '73656C656374696F6E3B69662821632E657175616C7353656C656374696F6E286429297B636F6E7374206E3D632E706C757352616E67652864292C693D632E73656C656374696F6E53746172744C696E654E756D6265723D3D3D632E73746172744C696E';
wwv_flow_imp.g_varchar2_table(17003) := '654E756D6265722626632E73656C656374696F6E5374617274436F6C756D6E3D3D3D632E7374617274436F6C756D6E2C6F3D642E73656C656374696F6E53746172744C696E654E756D6265723D3D3D642E73746172744C696E654E756D6265722626642E';
wwv_flow_imp.g_varchar2_table(17004) := '73656C656374696F6E5374617274436F6C756D6E3D3D3D642E7374617274436F6C756D6E3B6C657420722C683B613D3D3D746869732E6C6173744164646564437572736F72496E6465783F28723D692C746869732E6C6173744164646564437572736F72';
wwv_flow_imp.g_varchar2_table(17005) := '496E6465783D6C293A723D6F2C683D723F6E6577206168286E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E293A6E6577206168286E2E656E644C696E';
wwv_flow_imp.g_varchar2_table(17006) := '654E756D6265722C6E2E656E64436F6C756D6E2C6E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E292C745B735D2E73656C656374696F6E3D683B636F6E737420753D51432E66726F6D4D6F64656C53656C656374696F6E28';
wwv_flow_imp.g_varchar2_table(17007) := '68293B655B6C5D2E736574537461746528746869732E636F6E746578742C752E6D6F64656C53746174652C752E766965775374617465297D666F7228636F6E73742065206F66207429652E696E6465783E612626652E696E6465782D2D3B652E73706C69';
wwv_flow_imp.g_varchar2_table(17008) := '636528612C31292C742E73706C69636528722C31292C746869732E5F72656D6F76655365636F6E64617279437572736F7228612D31292C6E2D2D7D7D7D7D636C6173732069467B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F6375';
wwv_flow_imp.g_varchar2_table(17009) := '72736F72436F6E746578744272616E643D766F696420302C746869732E6D6F64656C3D652C746869732E766965774D6F64656C3D742C746869732E636F6F7264696E61746573436F6E7665727465723D6E2C746869732E637572736F72436F6E6669673D';
wwv_flow_imp.g_varchar2_table(17010) := '697D7D636C617373206F467B636F6E7374727563746F7228297B746869732E747970653D307D7D636C6173732073467B636F6E7374727563746F7228297B746869732E747970653D317D7D636C6173732072467B636F6E7374727563746F722865297B74';
wwv_flow_imp.g_varchar2_table(17011) := '6869732E747970653D322C746869732E5F736F757263653D657D6861734368616E6765642865297B72657475726E20746869732E5F736F757263652E6861734368616E6765642865297D7D636C6173732061467B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(17012) := '6E297B746869732E73656C656374696F6E733D652C746869732E6D6F64656C53656C656374696F6E733D742C746869732E726561736F6E3D6E2C746869732E747970653D337D7D636C617373206C467B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(17013) := '747970653D342C653F28746869732E616666656374734D696E696D61703D652E616666656374734D696E696D61702C746869732E616666656374734F7665727669657752756C65723D652E616666656374734F7665727669657752756C65722C74686973';
wwv_flow_imp.g_varchar2_table(17014) := '2E61666665637473476C7970684D617267696E3D652E61666665637473476C7970684D617267696E2C746869732E616666656374734C696E654E756D6265723D652E616666656374734C696E654E756D626572293A28746869732E616666656374734D69';
wwv_flow_imp.g_varchar2_table(17015) := '6E696D61703D21302C746869732E616666656374734F7665727669657752756C65723D21302C746869732E61666665637473476C7970684D617267696E3D21302C746869732E616666656374734C696E654E756D6265723D2130297D7D636C6173732063';
wwv_flow_imp.g_varchar2_table(17016) := '467B636F6E7374727563746F7228297B746869732E747970653D357D7D636C6173732064467B636F6E7374727563746F722865297B746869732E747970653D362C746869732E6973466F63757365643D657D7D636C6173732068467B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(17017) := '746F7228297B746869732E747970653D377D7D636C6173732075467B636F6E7374727563746F7228297B746869732E747970653D387D7D636C6173732070467B636F6E7374727563746F7228652C74297B746869732E66726F6D4C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(17018) := '3D652C746869732E636F756E743D742C746869732E747970653D397D7D636C6173732067467B636F6E7374727563746F7228652C74297B746869732E747970653D31302C746869732E66726F6D4C696E654E756D6265723D652C746869732E746F4C696E';
wwv_flow_imp.g_varchar2_table(17019) := '654E756D6265723D747D7D636C617373206D467B636F6E7374727563746F7228652C74297B746869732E747970653D31312C746869732E66726F6D4C696E654E756D6265723D652C746869732E746F4C696E654E756D6265723D747D7D636C6173732066';
wwv_flow_imp.g_varchar2_table(17020) := '467B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E736F757263653D652C746869732E6D696E696D616C52657665616C3D742C746869732E72616E67653D6E2C746869732E73656C656374696F6E733D692C746869732E';
wwv_flow_imp.g_varchar2_table(17021) := '766572746963616C547970653D6F2C746869732E72657665616C486F72697A6F6E74616C3D732C746869732E7363726F6C6C547970653D722C746869732E747970653D31327D7D636C6173732076467B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(17022) := '747970653D31332C746869732E7363726F6C6C57696474683D652E7363726F6C6C57696474682C746869732E7363726F6C6C4C6566743D652E7363726F6C6C4C6566742C746869732E7363726F6C6C4865696768743D652E7363726F6C6C486569676874';
wwv_flow_imp.g_varchar2_table(17023) := '2C746869732E7363726F6C6C546F703D652E7363726F6C6C546F702C746869732E7363726F6C6C57696474684368616E6765643D652E7363726F6C6C57696474684368616E6765642C746869732E7363726F6C6C4C6566744368616E6765643D652E7363';
wwv_flow_imp.g_varchar2_table(17024) := '726F6C6C4C6566744368616E6765642C746869732E7363726F6C6C4865696768744368616E6765643D652E7363726F6C6C4865696768744368616E6765642C746869732E7363726F6C6C546F704368616E6765643D652E7363726F6C6C546F704368616E';
wwv_flow_imp.g_varchar2_table(17025) := '6765647D7D636C6173732062467B636F6E7374727563746F722865297B746869732E7468656D653D652C746869732E747970653D31347D7D636C617373205F467B636F6E7374727563746F722865297B746869732E747970653D31352C746869732E7261';
wwv_flow_imp.g_varchar2_table(17026) := '6E6765733D657D7D636C6173732079467B636F6E7374727563746F7228297B746869732E747970653D31367D7D636C6173732077467B636F6E7374727563746F7228297B746869732E747970653D31377D7D636C61737320434620657874656E6473206C';
wwv_flow_imp.g_varchar2_table(17027) := '747B636F6E7374727563746F7228297B737570657228292C746869732E5F6F6E4576656E743D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4576656E743D746869732E5F6F6E4576656E742E6576656E742C746869732E5F';
wwv_flow_imp.g_varchar2_table(17028) := '6576656E7448616E646C6572733D5B5D2C746869732E5F766965774576656E7451756575653D6E756C6C2C746869732E5F6973436F6E73756D696E67566965774576656E7451756575653D21312C746869732E5F636F6C6C6563746F723D6E756C6C2C74';
wwv_flow_imp.g_varchar2_table(17029) := '6869732E5F636F6C6C6563746F72436E743D302C746869732E5F6F7574676F696E674576656E74733D5B5D7D656D69744F7574676F696E674576656E742865297B746869732E5F6164644F7574676F696E674576656E742865292C746869732E5F656D69';
wwv_flow_imp.g_varchar2_table(17030) := '744F7574676F696E674576656E747328297D5F6164644F7574676F696E674576656E742865297B666F72286C657420743D302C6E3D746869732E5F6F7574676F696E674576656E74732E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(17031) := '69732E5F6F7574676F696E674576656E74735B745D2E6B696E643D3D3D652E6B696E643F746869732E5F6F7574676F696E674576656E74735B745D2E617474656D7074546F4D657267652865293A6E756C6C3B6966286E2972657475726E20766F696428';
wwv_flow_imp.g_varchar2_table(17032) := '746869732E5F6F7574676F696E674576656E74735B745D3D6E297D746869732E5F6F7574676F696E674576656E74732E707573682865297D5F656D69744F7574676F696E674576656E747328297B666F72283B746869732E5F6F7574676F696E67457665';
wwv_flow_imp.g_varchar2_table(17033) := '6E74732E6C656E6774683E303B297B696628746869732E5F636F6C6C6563746F727C7C746869732E5F6973436F6E73756D696E67566965774576656E7451756575652972657475726E3B636F6E737420653D746869732E5F6F7574676F696E674576656E';
wwv_flow_imp.g_varchar2_table(17034) := '74732E736869667428293B652E69734E6F4F7028297C7C746869732E5F6F6E4576656E742E666972652865297D7D616464566965774576656E7448616E646C65722865297B666F72286C657420743D302C6E3D746869732E5F6576656E7448616E646C65';
wwv_flow_imp.g_varchar2_table(17035) := '72732E6C656E6774683B743C6E3B742B2B29746869732E5F6576656E7448616E646C6572735B745D3D3D3D652626636F6E736F6C652E7761726E28224465746563746564206475706C6963617465206C697374656E657220696E20566965774576656E74';
wwv_flow_imp.g_varchar2_table(17036) := '44697370617463686572222C65293B746869732E5F6576656E7448616E646C6572732E707573682865297D72656D6F7665566965774576656E7448616E646C65722865297B666F72286C657420743D303B743C746869732E5F6576656E7448616E646C65';
wwv_flow_imp.g_varchar2_table(17037) := '72732E6C656E6774683B742B2B29696628746869732E5F6576656E7448616E646C6572735B745D3D3D3D65297B746869732E5F6576656E7448616E646C6572732E73706C69636528742C31293B627265616B7D7D626567696E456D697456696577457665';
wwv_flow_imp.g_varchar2_table(17038) := '6E747328297B72657475726E20746869732E5F636F6C6C6563746F72436E742B2B2C313D3D3D746869732E5F636F6C6C6563746F72436E74262628746869732E5F636F6C6C6563746F723D6E6577205346292C746869732E5F636F6C6C6563746F727D65';
wwv_flow_imp.g_varchar2_table(17039) := '6E64456D6974566965774576656E747328297B696628746869732E5F636F6C6C6563746F72436E742D2D2C303D3D3D746869732E5F636F6C6C6563746F72436E74297B636F6E737420653D746869732E5F636F6C6C6563746F722E6F7574676F696E6745';
wwv_flow_imp.g_varchar2_table(17040) := '76656E74732C743D746869732E5F636F6C6C6563746F722E766965774576656E74733B746869732E5F636F6C6C6563746F723D6E756C6C3B666F7228636F6E73742074206F66206529746869732E5F6164644F7574676F696E674576656E742874293B74';
wwv_flow_imp.g_varchar2_table(17041) := '2E6C656E6774683E302626746869732E5F656D69744D616E792874297D746869732E5F656D69744F7574676F696E674576656E747328297D656D697453696E676C65566965774576656E742865297B7472797B746869732E626567696E456D6974566965';
wwv_flow_imp.g_varchar2_table(17042) := '774576656E747328292E656D6974566965774576656E742865297D66696E616C6C797B746869732E656E64456D6974566965774576656E747328297D7D5F656D69744D616E792865297B746869732E5F766965774576656E7451756575653F746869732E';
wwv_flow_imp.g_varchar2_table(17043) := '5F766965774576656E7451756575653D746869732E5F766965774576656E7451756575652E636F6E6361742865293A746869732E5F766965774576656E7451756575653D652C746869732E5F6973436F6E73756D696E67566965774576656E7451756575';
wwv_flow_imp.g_varchar2_table(17044) := '657C7C746869732E5F636F6E73756D65566965774576656E74517565756528297D5F636F6E73756D65566965774576656E74517565756528297B7472797B746869732E5F6973436F6E73756D696E67566965774576656E7451756575653D21302C746869';
wwv_flow_imp.g_varchar2_table(17045) := '732E5F646F436F6E73756D65517565756528297D66696E616C6C797B746869732E5F6973436F6E73756D696E67566965774576656E7451756575653D21317D7D5F646F436F6E73756D65517565756528297B666F72283B746869732E5F76696577457665';
wwv_flow_imp.g_varchar2_table(17046) := '6E7451756575653B297B636F6E737420653D746869732E5F766965774576656E7451756575653B746869732E5F766965774576656E7451756575653D6E756C6C3B636F6E737420743D746869732E5F6576656E7448616E646C6572732E736C6963652830';
wwv_flow_imp.g_varchar2_table(17047) := '293B666F7228636F6E7374206E206F662074296E2E68616E646C654576656E74732865297D7D7D636C6173732053467B636F6E7374727563746F7228297B746869732E766965774576656E74733D5B5D2C746869732E6F7574676F696E674576656E7473';
wwv_flow_imp.g_varchar2_table(17048) := '3D5B5D7D656D6974566965774576656E742865297B746869732E766965774576656E74732E707573682865297D656D69744F7574676F696E674576656E742865297B746869732E6F7574676F696E674576656E74732E707573682865297D7D636C617373';
wwv_flow_imp.g_varchar2_table(17049) := '2078467B636F6E7374727563746F7228652C742C6E2C69297B746869732E6B696E643D302C746869732E5F6F6C64436F6E74656E7457696474683D652C746869732E5F6F6C64436F6E74656E744865696768743D742C746869732E636F6E74656E745769';
wwv_flow_imp.g_varchar2_table(17050) := '6474683D6E2C746869732E636F6E74656E744865696768743D692C746869732E636F6E74656E7457696474684368616E6765643D746869732E5F6F6C64436F6E74656E745769647468213D3D746869732E636F6E74656E7457696474682C746869732E63';
wwv_flow_imp.g_varchar2_table(17051) := '6F6E74656E744865696768744368616E6765643D746869732E5F6F6C64436F6E74656E74486569676874213D3D746869732E636F6E74656E744865696768747D69734E6F4F7028297B72657475726E21746869732E636F6E74656E745769647468436861';
wwv_flow_imp.g_varchar2_table(17052) := '6E676564262621746869732E636F6E74656E744865696768744368616E6765647D617474656D7074546F4D657267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E643F6E756C6C3A6E657720784628746869732E5F6F6C64436F';
wwv_flow_imp.g_varchar2_table(17053) := '6E74656E7457696474682C746869732E5F6F6C64436F6E74656E744865696768742C652E636F6E74656E7457696474682C652E636F6E74656E74486569676874297D7D636C617373206B467B636F6E7374727563746F7228652C74297B746869732E6B69';
wwv_flow_imp.g_varchar2_table(17054) := '6E643D312C746869732E6F6C64486173466F6375733D652C746869732E686173466F6375733D747D69734E6F4F7028297B72657475726E20746869732E6F6C64486173466F6375733D3D3D746869732E686173466F6375737D617474656D7074546F4D65';
wwv_flow_imp.g_varchar2_table(17055) := '7267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E643F6E756C6C3A6E6577206B4628746869732E6F6C64486173466F6375732C652E686173466F637573297D7D636C6173732045467B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(17056) := '6E2C692C6F2C732C722C61297B746869732E6B696E643D322C746869732E5F6F6C645363726F6C6C57696474683D652C746869732E5F6F6C645363726F6C6C4C6566743D742C746869732E5F6F6C645363726F6C6C4865696768743D6E2C746869732E5F';
wwv_flow_imp.g_varchar2_table(17057) := '6F6C645363726F6C6C546F703D692C746869732E7363726F6C6C57696474683D6F2C746869732E7363726F6C6C4C6566743D732C746869732E7363726F6C6C4865696768743D722C746869732E7363726F6C6C546F703D612C746869732E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(17058) := '57696474684368616E6765643D746869732E5F6F6C645363726F6C6C5769647468213D3D746869732E7363726F6C6C57696474682C746869732E7363726F6C6C4C6566744368616E6765643D746869732E5F6F6C645363726F6C6C4C656674213D3D7468';
wwv_flow_imp.g_varchar2_table(17059) := '69732E7363726F6C6C4C6566742C746869732E7363726F6C6C4865696768744368616E6765643D746869732E5F6F6C645363726F6C6C486569676874213D3D746869732E7363726F6C6C4865696768742C746869732E7363726F6C6C546F704368616E67';
wwv_flow_imp.g_varchar2_table(17060) := '65643D746869732E5F6F6C645363726F6C6C546F70213D3D746869732E7363726F6C6C546F707D69734E6F4F7028297B72657475726E2128746869732E7363726F6C6C57696474684368616E6765647C7C746869732E7363726F6C6C4C6566744368616E';
wwv_flow_imp.g_varchar2_table(17061) := '6765647C7C746869732E7363726F6C6C4865696768744368616E6765647C7C746869732E7363726F6C6C546F704368616E676564297D617474656D7074546F4D657267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E643F6E75';
wwv_flow_imp.g_varchar2_table(17062) := '6C6C3A6E657720454628746869732E5F6F6C645363726F6C6C57696474682C746869732E5F6F6C645363726F6C6C4C6566742C746869732E5F6F6C645363726F6C6C4865696768742C746869732E5F6F6C645363726F6C6C546F702C652E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(17063) := '57696474682C652E7363726F6C6C4C6566742C652E7363726F6C6C4865696768742C652E7363726F6C6C546F70297D7D636C617373204C467B636F6E7374727563746F7228297B746869732E6B696E643D337D69734E6F4F7028297B72657475726E2131';
wwv_flow_imp.g_varchar2_table(17064) := '7D617474656D7074546F4D657267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E643F6E756C6C3A746869737D7D636C6173732044467B636F6E7374727563746F7228297B746869732E6B696E643D347D69734E6F4F7028297B';
wwv_flow_imp.g_varchar2_table(17065) := '72657475726E21317D617474656D7074546F4D657267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E643F6E756C6C3A746869737D7D636C6173732054467B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B';
wwv_flow_imp.g_varchar2_table(17066) := '746869732E6B696E643D362C746869732E6F6C6453656C656374696F6E733D652C746869732E73656C656374696F6E733D742C746869732E6F6C644D6F64656C56657273696F6E49643D6E2C746869732E6D6F64656C56657273696F6E49643D692C7468';
wwv_flow_imp.g_varchar2_table(17067) := '69732E736F757263653D6F2C746869732E726561736F6E3D732C746869732E726561636865644D6178437572736F72436F756E743D727D737461746963205F73656C656374696F6E73417265457175616C28652C74297B69662821652626217429726574';
wwv_flow_imp.g_varchar2_table(17068) := '75726E21303B69662821657C7C21742972657475726E21313B636F6E7374206E3D652E6C656E6774683B6966286E213D3D742E6C656E6774682972657475726E21313B666F72286C657420693D303B693C6E3B692B2B2969662821655B695D2E65717561';
wwv_flow_imp.g_varchar2_table(17069) := '6C7353656C656374696F6E28745B695D292972657475726E21313B72657475726E21307D69734E6F4F7028297B72657475726E2054462E5F73656C656374696F6E73417265457175616C28746869732E6F6C6453656C656374696F6E732C746869732E73';
wwv_flow_imp.g_varchar2_table(17070) := '656C656374696F6E73292626746869732E6F6C644D6F64656C56657273696F6E49643D3D3D746869732E6D6F64656C56657273696F6E49647D617474656D7074546F4D657267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E64';
wwv_flow_imp.g_varchar2_table(17071) := '3F6E756C6C3A6E657720544628746869732E6F6C6453656C656374696F6E732C652E73656C656374696F6E732C746869732E6F6C644D6F64656C56657273696F6E49642C652E6D6F64656C56657273696F6E49642C652E736F757263652C652E72656173';
wwv_flow_imp.g_varchar2_table(17072) := '6F6E2C746869732E726561636865644D6178437572736F72436F756E747C7C652E726561636865644D6178437572736F72436F756E74297D7D636C6173732049467B636F6E7374727563746F7228297B746869732E6B696E643D357D69734E6F4F702829';
wwv_flow_imp.g_varchar2_table(17073) := '7B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E20652E6B696E64213D3D746869732E6B696E643F6E756C6C3A746869737D7D636C617373204D467B636F6E7374727563746F722865297B746869732E6576656E743D';
wwv_flow_imp.g_varchar2_table(17074) := '652C746869732E6B696E643D377D69734E6F4F7028297B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E206E756C6C7D7D636C6173732041467B636F6E7374727563746F722865297B746869732E6576656E743D652C';
wwv_flow_imp.g_varchar2_table(17075) := '746869732E6B696E643D387D69734E6F4F7028297B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E206E756C6C7D7D636C617373204E467B636F6E7374727563746F722865297B746869732E6576656E743D652C7468';
wwv_flow_imp.g_varchar2_table(17076) := '69732E6B696E643D397D69734E6F4F7028297B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E206E756C6C7D7D636C6173732050467B636F6E7374727563746F722865297B746869732E6576656E743D652C74686973';
wwv_flow_imp.g_varchar2_table(17077) := '2E6B696E643D31307D69734E6F4F7028297B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E206E756C6C7D7D636C617373204F467B636F6E7374727563746F722865297B746869732E6576656E743D652C746869732E';
wwv_flow_imp.g_varchar2_table(17078) := '6B696E643D31317D69734E6F4F7028297B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E206E756C6C7D7D636C6173732052467B636F6E7374727563746F722865297B746869732E6576656E743D652C746869732E6B';
wwv_flow_imp.g_varchar2_table(17079) := '696E643D31327D69734E6F4F7028297B72657475726E21317D617474656D7074546F4D657267652865297B72657475726E206E756C6C7D7D636C61737320464620657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570';
wwv_flow_imp.g_varchar2_table(17080) := '657228292C746869732E5F6D6F64656C3D652C746869732E5F6B6E6F776E4D6F64656C56657273696F6E49643D746869732E5F6D6F64656C2E67657456657273696F6E496428292C746869732E5F766965774D6F64656C3D742C746869732E5F636F6F72';
wwv_flow_imp.g_varchar2_table(17081) := '64696E61746573436F6E7665727465723D6E2C746869732E636F6E746578743D6E657720694628746869732E5F6D6F64656C2C746869732E5F766965774D6F64656C2C746869732E5F636F6F7264696E61746573436F6E7665727465722C69292C746869';
wwv_flow_imp.g_varchar2_table(17082) := '732E5F637572736F72733D6E6577206E4628746869732E636F6E74657874292C746869732E5F686173466F6375733D21312C746869732E5F697348616E646C696E673D21312C746869732E5F636F6D706F736974696F6E53746174653D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(17083) := '69732E5F636F6C756D6E53656C656374446174613D6E756C6C2C746869732E5F6175746F436C6F736564416374696F6E733D5B5D2C746869732E5F70726576456469744F7065726174696F6E547970653D307D646973706F736528297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(17084) := '7572736F72732E646973706F736528292C746869732E5F6175746F436C6F736564416374696F6E733D6F7428746869732E5F6175746F436C6F736564416374696F6E73292C73757065722E646973706F736528297D757064617465436F6E666967757261';
wwv_flow_imp.g_varchar2_table(17085) := '74696F6E2865297B746869732E636F6E746578743D6E657720694628746869732E5F6D6F64656C2C746869732E5F766965774D6F64656C2C746869732E5F636F6F7264696E61746573436F6E7665727465722C65292C746869732E5F637572736F72732E';
wwv_flow_imp.g_varchar2_table(17086) := '757064617465436F6E7465787428746869732E636F6E74657874297D6F6E4C696E654D617070696E674368616E6765642865297B746869732E5F6B6E6F776E4D6F64656C56657273696F6E49643D3D3D746869732E5F6D6F64656C2E6765745665727369';
wwv_flow_imp.g_varchar2_table(17087) := '6F6E496428292626746869732E73657453746174657328652C22766965774D6F64656C222C302C746869732E676574437572736F725374617465732829297D736574486173466F6375732865297B746869732E5F686173466F6375733D657D5F76616C69';
wwv_flow_imp.g_varchar2_table(17088) := '646174654175746F436C6F736564416374696F6E7328297B696628746869732E5F6175746F436C6F736564416374696F6E732E6C656E6774683E30297B636F6E737420653D746869732E5F637572736F72732E67657453656C656374696F6E7328293B66';
wwv_flow_imp.g_varchar2_table(17089) := '6F72286C657420743D303B743C746869732E5F6175746F436C6F736564416374696F6E732E6C656E6774683B742B2B297B636F6E7374206E3D746869732E5F6175746F436C6F736564416374696F6E735B745D3B6E2E697356616C69642865297C7C286E';
wwv_flow_imp.g_varchar2_table(17090) := '2E646973706F736528292C746869732E5F6175746F436C6F736564416374696F6E732E73706C69636528742C31292C742D2D297D7D7D6765745072696D617279437572736F72537461746528297B72657475726E20746869732E5F637572736F72732E67';
wwv_flow_imp.g_varchar2_table(17091) := '65745072696D617279437572736F7228297D6765744C6173744164646564437572736F72496E64657828297B72657475726E20746869732E5F637572736F72732E6765744C6173744164646564437572736F72496E64657828297D676574437572736F72';
wwv_flow_imp.g_varchar2_table(17092) := '53746174657328297B72657475726E20746869732E5F637572736F72732E676574416C6C28297D73657453746174657328652C742C6E2C69297B6C6574206F3D21313B636F6E737420733D746869732E636F6E746578742E637572736F72436F6E666967';
wwv_flow_imp.g_varchar2_table(17093) := '2E6D756C7469437572736F724C696D69743B6E756C6C213D3D692626692E6C656E6774683E73262628693D692E736C69636528302C73292C6F3D2130293B636F6E737420723D42462E66726F6D28746869732E5F6D6F64656C2C74686973293B72657475';
wwv_flow_imp.g_varchar2_table(17094) := '726E20746869732E5F637572736F72732E7365745374617465732869292C746869732E5F637572736F72732E6E6F726D616C697A6528292C746869732E5F636F6C756D6E53656C656374446174613D6E756C6C2C746869732E5F76616C69646174654175';
wwv_flow_imp.g_varchar2_table(17095) := '746F436C6F736564416374696F6E7328292C746869732E5F656D697453746174654368616E67656449664E656365737361727928652C742C6E2C722C6F297D736574437572736F72436F6C756D6E53656C656374446174612865297B746869732E5F636F';
wwv_flow_imp.g_varchar2_table(17096) := '6C756D6E53656C656374446174613D657D72657665616C416C6C28652C742C6E2C692C6F2C73297B636F6E737420723D746869732E5F637572736F72732E67657456696577506F736974696F6E7328293B6C657420613D6E756C6C2C6C3D6E756C6C3B72';
wwv_flow_imp.g_varchar2_table(17097) := '2E6C656E6774683E313F6C3D746869732E5F637572736F72732E6765745669657753656C656374696F6E7328293A613D72682E66726F6D506F736974696F6E7328725B305D2C725B305D292C652E656D6974566965774576656E74286E65772066462874';
wwv_flow_imp.g_varchar2_table(17098) := '2C6E2C612C6C2C692C6F2C7329297D72657665616C5072696D61727928652C742C6E2C692C6F2C73297B636F6E737420723D5B746869732E5F637572736F72732E6765745072696D617279437572736F7228292E7669657753746174652E73656C656374';
wwv_flow_imp.g_varchar2_table(17099) := '696F6E5D3B652E656D6974566965774576656E74286E657720664628742C6E2C6E756C6C2C722C692C6F2C7329297D73617665537461746528297B636F6E737420653D5B5D2C743D746869732E5F637572736F72732E67657453656C656374696F6E7328';
wwv_flow_imp.g_varchar2_table(17100) := '293B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D745B6E5D3B652E70757368287B696E53656C656374696F6E4D6F64653A21692E6973456D70747928292C73656C656374696F6E53746172743A7B';
wwv_flow_imp.g_varchar2_table(17101) := '6C696E654E756D6265723A692E73656C656374696F6E53746172744C696E654E756D6265722C636F6C756D6E3A692E73656C656374696F6E5374617274436F6C756D6E7D2C706F736974696F6E3A7B6C696E654E756D6265723A692E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(17102) := '4C696E654E756D6265722C636F6C756D6E3A692E706F736974696F6E436F6C756D6E7D7D297D72657475726E20657D726573746F7265537461746528652C74297B636F6E7374206E3D5B5D3B666F72286C657420653D302C693D742E6C656E6774683B65';
wwv_flow_imp.g_varchar2_table(17103) := '3C693B652B2B297B636F6E737420693D745B655D3B6C6574206F3D312C733D313B692E706F736974696F6E2626692E706F736974696F6E2E6C696E654E756D6265722626286F3D692E706F736974696F6E2E6C696E654E756D626572292C692E706F7369';
wwv_flow_imp.g_varchar2_table(17104) := '74696F6E2626692E706F736974696F6E2E636F6C756D6E262628733D692E706F736974696F6E2E636F6C756D6E293B6C657420723D6F2C613D733B692E73656C656374696F6E53746172742626692E73656C656374696F6E53746172742E6C696E654E75';
wwv_flow_imp.g_varchar2_table(17105) := '6D626572262628723D692E73656C656374696F6E53746172742E6C696E654E756D626572292C692E73656C656374696F6E53746172742626692E73656C656374696F6E53746172742E636F6C756D6E262628613D692E73656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(17106) := '2E636F6C756D6E292C6E2E70757368287B73656C656374696F6E53746172744C696E654E756D6265723A722C73656C656374696F6E5374617274436F6C756D6E3A612C706F736974696F6E4C696E654E756D6265723A6F2C706F736974696F6E436F6C75';
wwv_flow_imp.g_varchar2_table(17107) := '6D6E3A737D297D746869732E73657453746174657328652C22726573746F72655374617465222C302C51432E66726F6D4D6F64656C53656C656374696F6E73286E29292C746869732E72657665616C416C6C28652C22726573746F72655374617465222C';
wwv_flow_imp.g_varchar2_table(17108) := '21312C302C21302C31297D6F6E4D6F64656C436F6E74656E744368616E67656428652C74297B6966287420696E7374616E63656F66207043297B696628746869732E5F697348616E646C696E672972657475726E3B746869732E5F697348616E646C696E';
wwv_flow_imp.g_varchar2_table(17109) := '673D21303B7472797B746869732E73657453746174657328652C226D6F64656C4368616E6765222C302C746869732E676574437572736F725374617465732829297D66696E616C6C797B746869732E5F697348616E646C696E673D21317D7D656C73657B';
wwv_flow_imp.g_varchar2_table(17110) := '636F6E7374206E3D742E726177436F6E74656E744368616E6765644576656E743B696628746869732E5F6B6E6F776E4D6F64656C56657273696F6E49643D6E2E76657273696F6E49642C746869732E5F697348616E646C696E672972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(17111) := '6E737420693D6E2E636F6E7461696E734576656E742831293B696628746869732E5F70726576456469744F7065726174696F6E547970653D302C6929746869732E5F637572736F72732E646973706F736528292C746869732E5F637572736F72733D6E65';
wwv_flow_imp.g_varchar2_table(17112) := '77206E4628746869732E636F6E74657874292C746869732E5F76616C69646174654175746F436C6F736564416374696F6E7328292C746869732E5F656D697453746174654368616E67656449664E656365737361727928652C226D6F64656C222C312C6E';
wwv_flow_imp.g_varchar2_table(17113) := '756C6C2C2131293B656C736520696628746869732E5F686173466F63757326266E2E726573756C74696E6753656C656374696F6E26266E2E726573756C74696E6753656C656374696F6E2E6C656E6774683E30297B636F6E737420743D51432E66726F6D';
wwv_flow_imp.g_varchar2_table(17114) := '4D6F64656C53656C656374696F6E73286E2E726573756C74696E6753656C656374696F6E293B746869732E73657453746174657328652C226D6F64656C4368616E6765222C6E2E6973556E646F696E673F353A6E2E69735265646F696E673F363A322C74';
wwv_flow_imp.g_varchar2_table(17115) := '292626746869732E72657665616C416C6C28652C226D6F64656C4368616E6765222C21312C302C21302C30297D656C73657B636F6E737420743D746869732E5F637572736F72732E7265616453656C656374696F6E46726F6D4D61726B65727328293B74';
wwv_flow_imp.g_varchar2_table(17116) := '6869732E73657453746174657328652C226D6F64656C4368616E6765222C322C51432E66726F6D4D6F64656C53656C656374696F6E73287429297D7D7D67657453656C656374696F6E28297B72657475726E20746869732E5F637572736F72732E676574';
wwv_flow_imp.g_varchar2_table(17117) := '5072696D617279437572736F7228292E6D6F64656C53746174652E73656C656374696F6E7D676574546F704D6F737456696577506F736974696F6E28297B72657475726E20746869732E5F637572736F72732E676574546F704D6F737456696577506F73';
wwv_flow_imp.g_varchar2_table(17118) := '6974696F6E28297D676574426F74746F6D4D6F737456696577506F736974696F6E28297B72657475726E20746869732E5F637572736F72732E676574426F74746F6D4D6F737456696577506F736974696F6E28297D676574437572736F72436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17119) := '53656C6563744461746128297B696628746869732E5F636F6C756D6E53656C656374446174612972657475726E20746869732E5F636F6C756D6E53656C656374446174613B636F6E737420653D746869732E5F637572736F72732E6765745072696D6172';
wwv_flow_imp.g_varchar2_table(17120) := '79437572736F7228292C743D652E7669657753746174652E73656C656374696F6E53746172742E6765745374617274506F736974696F6E28292C6E3D652E7669657753746174652E706F736974696F6E3B72657475726E7B69735265616C3A21312C6672';
wwv_flow_imp.g_varchar2_table(17121) := '6F6D566965774C696E654E756D6265723A742E6C696E654E756D6265722C66726F6D5669657756697375616C436F6C756D6E3A746869732E636F6E746578742E637572736F72436F6E6669672E76697369626C65436F6C756D6E46726F6D436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17122) := '28746869732E5F766965774D6F64656C2C74292C746F566965774C696E654E756D6265723A6E2E6C696E654E756D6265722C746F5669657756697375616C436F6C756D6E3A746869732E636F6E746578742E637572736F72436F6E6669672E7669736962';
wwv_flow_imp.g_varchar2_table(17123) := '6C65436F6C756D6E46726F6D436F6C756D6E28746869732E5F766965774D6F64656C2C6E297D7D67657453656C656374696F6E7328297B72657475726E20746869732E5F637572736F72732E67657453656C656374696F6E7328297D73657453656C6563';
wwv_flow_imp.g_varchar2_table(17124) := '74696F6E7328652C742C6E2C69297B746869732E73657453746174657328652C742C692C51432E66726F6D4D6F64656C53656C656374696F6E73286E29297D67657450726576456469744F7065726174696F6E5479706528297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(17125) := '732E5F70726576456469744F7065726174696F6E547970657D73657450726576456469744F7065726174696F6E547970652865297B746869732E5F70726576456469744F7065726174696F6E547970653D657D5F707573684175746F436C6F7365644163';
wwv_flow_imp.g_varchar2_table(17126) := '74696F6E28652C74297B636F6E7374206E3D5B5D2C693D5B5D3B666F72286C6574206F3D302C733D652E6C656E6774683B6F3C733B6F2B2B296E2E70757368287B72616E67653A655B6F5D2C6F7074696F6E733A7B6465736372697074696F6E3A226175';
wwv_flow_imp.g_varchar2_table(17127) := '746F2D636C6F7365642D636861726163746572222C696E6C696E65436C6173734E616D653A226175746F2D636C6F7365642D636861726163746572222C737469636B696E6573733A317D7D292C692E70757368287B72616E67653A745B6F5D2C6F707469';
wwv_flow_imp.g_varchar2_table(17128) := '6F6E733A7B6465736372697074696F6E3A226175746F2D636C6F7365642D656E636C6F73696E67222C737469636B696E6573733A317D7D293B636F6E7374206F3D746869732E5F6D6F64656C2E64656C74614465636F726174696F6E73285B5D2C6E292C';
wwv_flow_imp.g_varchar2_table(17129) := '733D746869732E5F6D6F64656C2E64656C74614465636F726174696F6E73285B5D2C69293B746869732E5F6175746F436C6F736564416374696F6E732E70757368286E657720564628746869732E5F6D6F64656C2C6F2C7329297D5F6578656375746545';
wwv_flow_imp.g_varchar2_table(17130) := '6469744F7065726174696F6E2865297B69662821652972657475726E3B652E73686F756C6450757368537461636B456C656D656E744265666F72652626746869732E5F6D6F64656C2E70757368537461636B456C656D656E7428293B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(17131) := '7A462E65786563757465436F6D6D616E647328746869732E5F6D6F64656C2C746869732E5F637572736F72732E67657453656C656374696F6E7328292C652E636F6D6D616E6473293B69662874297B746869732E5F696E74657270726574436F6D6D616E';
wwv_flow_imp.g_varchar2_table(17132) := '64526573756C742874293B636F6E7374206E3D5B5D2C693D5B5D3B666F72286C657420743D303B743C652E636F6D6D616E64732E6C656E6774683B742B2B297B636F6E7374206F3D652E636F6D6D616E64735B745D3B6F20696E7374616E63656F66204C';
wwv_flow_imp.g_varchar2_table(17133) := '5326266F2E656E636C6F73696E6752616E676526266F2E636C6F736543686172616374657252616E67652626286E2E70757368286F2E636C6F736543686172616374657252616E6765292C692E70757368286F2E656E636C6F73696E6752616E67652929';
wwv_flow_imp.g_varchar2_table(17134) := '7D6E2E6C656E6774683E302626746869732E5F707573684175746F436C6F736564416374696F6E286E2C69292C746869732E5F70726576456469744F7065726174696F6E547970653D652E747970657D652E73686F756C6450757368537461636B456C65';
wwv_flow_imp.g_varchar2_table(17135) := '6D656E7441667465722626746869732E5F6D6F64656C2E70757368537461636B456C656D656E7428297D5F696E74657270726574436F6D6D616E64526573756C742865297B65262630213D3D652E6C656E6774687C7C28653D746869732E5F637572736F';
wwv_flow_imp.g_varchar2_table(17136) := '72732E7265616453656C656374696F6E46726F6D4D61726B6572732829292C746869732E5F636F6C756D6E53656C656374446174613D6E756C6C2C746869732E5F637572736F72732E73657453656C656374696F6E732865292C746869732E5F63757273';
wwv_flow_imp.g_varchar2_table(17137) := '6F72732E6E6F726D616C697A6528297D5F656D697453746174654368616E67656449664E656365737361727928652C742C6E2C692C6F297B636F6E737420733D42462E66726F6D28746869732E5F6D6F64656C2C74686973293B696628732E657175616C';
wwv_flow_imp.g_varchar2_table(17138) := '732869292972657475726E21313B636F6E737420723D746869732E5F637572736F72732E67657453656C656374696F6E7328292C613D746869732E5F637572736F72732E6765745669657753656C656374696F6E7328293B696628652E656D6974566965';
wwv_flow_imp.g_varchar2_table(17139) := '774576656E74286E657720614628612C722C6E29292C21697C7C692E637572736F7253746174652E6C656E677468213D3D732E637572736F7253746174652E6C656E6774687C7C732E637572736F7253746174652E736F6D65282828652C74293D3E2165';
wwv_flow_imp.g_varchar2_table(17140) := '2E6D6F64656C53746174652E657175616C7328692E637572736F7253746174655B745D2E6D6F64656C5374617465292929297B636F6E737420613D693F692E637572736F7253746174652E6D61702828653D3E652E6D6F64656C53746174652E73656C65';
wwv_flow_imp.g_varchar2_table(17141) := '6374696F6E29293A6E756C6C2C6C3D693F692E6D6F64656C56657273696F6E49643A303B652E656D69744F7574676F696E674576656E74286E657720544628612C722C6C2C732E6D6F64656C56657273696F6E49642C747C7C226B6579626F617264222C';
wwv_flow_imp.g_varchar2_table(17142) := '6E2C6F29297D72657475726E21307D5F66696E644175746F436C6F73696E6750616972732865297B69662821652E6C656E6774682972657475726E206E756C6C3B636F6E737420743D5B5D3B666F72286C6574206E3D302C693D652E6C656E6774683B6E';
wwv_flow_imp.g_varchar2_table(17143) := '3C693B6E2B2B297B636F6E737420693D655B6E5D3B69662821692E746578747C7C692E746578742E696E6465784F6628225C6E22293E3D302972657475726E206E756C6C3B636F6E7374206F3D692E746578742E6D61746368282F285B295C5D7D3E2722';
wwv_flow_imp.g_varchar2_table(17144) := '605D29285B5E295C5D7D3E2722605D2A29242F293B696628216F2972657475726E206E756C6C3B636F6E737420733D6F5B315D2C723D746869732E636F6E746578742E637572736F72436F6E6669672E6175746F436C6F73696E6750616972732E617574';
wwv_flow_imp.g_varchar2_table(17145) := '6F436C6F73696E675061697273436C6F736553696E676C65436861722E6765742873293B69662821727C7C31213D3D722E6C656E6774682972657475726E206E756C6C3B636F6E737420613D725B305D2E6F70656E2C6C3D692E746578742E6C656E6774';
wwv_flow_imp.g_varchar2_table(17146) := '682D6F5B325D2E6C656E6774682D312C633D692E746578742E6C617374496E6465784F6628612C6C2D31293B6966282D313D3D3D632972657475726E206E756C6C3B742E70757368285B632C6C5D297D72657475726E20747D6578656375746545646974';
wwv_flow_imp.g_varchar2_table(17147) := '7328652C742C6E2C69297B6C6574206F3D6E756C6C3B22736E6970706574223D3D3D742626286F3D746869732E5F66696E644175746F436C6F73696E675061697273286E29292C6F2626286E5B305D2E5F6973547261636B65643D2130293B636F6E7374';
wwv_flow_imp.g_varchar2_table(17148) := '20733D5B5D2C723D5B5D2C613D746869732E5F6D6F64656C2E70757368456469744F7065726174696F6E7328746869732E67657453656C656374696F6E7328292C6E2C28653D3E7B6966286F29666F72286C657420743D302C6E3D6F2E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(17149) := '743C6E3B742B2B297B636F6E73745B6E2C695D3D6F5B745D2C613D655B745D2C6C3D612E72616E67652E73746172744C696E654E756D6265722C633D612E72616E67652E7374617274436F6C756D6E2D312B6E2C643D612E72616E67652E737461727443';
wwv_flow_imp.g_varchar2_table(17150) := '6F6C756D6E2D312B693B732E70757368286E6577207268286C2C642B312C6C2C642B3229292C722E70757368286E6577207268286C2C632B312C6C2C642B3229297D636F6E737420743D692865293B72657475726E2074262628746869732E5F69734861';
wwv_flow_imp.g_varchar2_table(17151) := '6E646C696E673D2130292C747D29293B61262628746869732E5F697348616E646C696E673D21312C746869732E73657453656C656374696F6E7328652C742C612C3029292C732E6C656E6774683E302626746869732E5F707573684175746F436C6F7365';
wwv_flow_imp.g_varchar2_table(17152) := '64416374696F6E28732C72297D5F657865637574654564697428652C742C6E2C693D30297B696628746869732E636F6E746578742E637572736F72436F6E6669672E726561644F6E6C792972657475726E3B636F6E7374206F3D42462E66726F6D287468';
wwv_flow_imp.g_varchar2_table(17153) := '69732E5F6D6F64656C2C74686973293B746869732E5F637572736F72732E73746F70547261636B696E6753656C656374696F6E7328292C746869732E5F697348616E646C696E673D21303B7472797B746869732E5F637572736F72732E656E7375726556';
wwv_flow_imp.g_varchar2_table(17154) := '616C6964537461746528292C6528297D63617463682865297B6B652865297D746869732E5F697348616E646C696E673D21312C746869732E5F637572736F72732E7374617274547261636B696E6753656C656374696F6E7328292C746869732E5F76616C';
wwv_flow_imp.g_varchar2_table(17155) := '69646174654175746F436C6F736564416374696F6E7328292C746869732E5F656D697453746174654368616E67656449664E656365737361727928742C6E2C692C6F2C2131292626746869732E72657665616C416C6C28742C6E2C21312C302C21302C30';
wwv_flow_imp.g_varchar2_table(17156) := '297D6765744175746F436C6F7365644368617261637465727328297B72657475726E2056462E676574416C6C4175746F436C6F7365644368617261637465727328746869732E5F6175746F436C6F736564416374696F6E73297D7374617274436F6D706F';
wwv_flow_imp.g_varchar2_table(17157) := '736974696F6E2865297B746869732E5F636F6D706F736974696F6E53746174653D6E657720574628746869732E5F6D6F64656C2C746869732E67657453656C656374696F6E732829297D656E64436F6D706F736974696F6E28652C74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(17158) := '6E3D746869732E5F636F6D706F736974696F6E53746174653F746869732E5F636F6D706F736974696F6E53746174652E6465647563654F7574636F6D6528746869732E5F6D6F64656C2C746869732E67657453656C656374696F6E732829293A6E756C6C';
wwv_flow_imp.g_varchar2_table(17159) := '3B746869732E5F636F6D706F736974696F6E53746174653D6E756C6C2C746869732E5F6578656375746545646974282828293D3E7B226B6579626F617264223D3D3D742626746869732E5F65786563757465456469744F7065726174696F6E2845532E63';
wwv_flow_imp.g_varchar2_table(17160) := '6F6D706F736974696F6E456E6457697468496E746572636570746F727328746869732E5F70726576456469744F7065726174696F6E547970652C746869732E636F6E746578742E637572736F72436F6E6669672C746869732E5F6D6F64656C2C6E2C7468';
wwv_flow_imp.g_varchar2_table(17161) := '69732E67657453656C656374696F6E7328292C746869732E6765744175746F436C6F73656443686172616374657273282929297D292C652C74297D7479706528652C742C6E297B746869732E5F6578656375746545646974282828293D3E7B696628226B';
wwv_flow_imp.g_varchar2_table(17162) := '6579626F617264223D3D3D6E297B636F6E737420653D742E6C656E6774683B6C6574206E3D303B666F72283B6E3C653B297B636F6E737420653D4F6928742C6E292C693D742E737562737472286E2C65293B746869732E5F65786563757465456469744F';
wwv_flow_imp.g_varchar2_table(17163) := '7065726174696F6E2845532E7479706557697468496E746572636570746F7273282121746869732E5F636F6D706F736974696F6E53746174652C746869732E5F70726576456469744F7065726174696F6E547970652C746869732E636F6E746578742E63';
wwv_flow_imp.g_varchar2_table(17164) := '7572736F72436F6E6669672C746869732E5F6D6F64656C2C746869732E67657453656C656374696F6E7328292C746869732E6765744175746F436C6F7365644368617261637465727328292C6929292C6E2B3D657D7D656C736520746869732E5F657865';
wwv_flow_imp.g_varchar2_table(17165) := '63757465456469744F7065726174696F6E2845532E74797065576974686F7574496E746572636570746F727328746869732E5F70726576456469744F7065726174696F6E547970652C746869732E636F6E746578742E637572736F72436F6E6669672C74';
wwv_flow_imp.g_varchar2_table(17166) := '6869732E5F6D6F64656C2C746869732E67657453656C656374696F6E7328292C7429297D292C652C6E297D636F6D706F736974696F6E5479706528652C742C6E2C692C6F2C73297B69662830213D3D742E6C656E6774687C7C30213D3D6E7C7C30213D3D';
wwv_flow_imp.g_varchar2_table(17167) := '6929746869732E5F6578656375746545646974282828293D3E7B746869732E5F65786563757465456469744F7065726174696F6E2845532E636F6D706F736974696F6E5479706528746869732E5F70726576456469744F7065726174696F6E547970652C';
wwv_flow_imp.g_varchar2_table(17168) := '746869732E636F6E746578742E637572736F72436F6E6669672C746869732E5F6D6F64656C2C746869732E67657453656C656374696F6E7328292C742C6E2C692C6F29297D292C652C73293B656C73652069662830213D3D6F297B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(17169) := '6869732E67657453656C656374696F6E7328292E6D61702828653D3E7B636F6E737420743D652E676574506F736974696F6E28293B72657475726E206E657720616828742E6C696E654E756D6265722C742E636F6C756D6E2B6F2C742E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(17170) := '6265722C742E636F6C756D6E2B6F297D29293B746869732E73657453656C656374696F6E7328652C732C742C30297D7D706173746528652C742C6E2C692C6F297B746869732E5F6578656375746545646974282828293D3E7B746869732E5F6578656375';
wwv_flow_imp.g_varchar2_table(17171) := '7465456469744F7065726174696F6E2845532E706173746528746869732E636F6E746578742E637572736F72436F6E6669672C746869732E5F6D6F64656C2C746869732E67657453656C656374696F6E7328292C742C6E2C697C7C5B5D29297D292C652C';
wwv_flow_imp.g_varchar2_table(17172) := '6F2C34297D63757428652C74297B746869732E5F6578656375746545646974282828293D3E7B746869732E5F65786563757465456469744F7065726174696F6E2864532E63757428746869732E636F6E746578742E637572736F72436F6E6669672C7468';
wwv_flow_imp.g_varchar2_table(17173) := '69732E5F6D6F64656C2C746869732E67657453656C656374696F6E73282929297D292C652C74297D65786563757465436F6D6D616E6428652C742C6E297B746869732E5F6578656375746545646974282828293D3E7B746869732E5F637572736F72732E';
wwv_flow_imp.g_varchar2_table(17174) := '6B696C6C5365636F6E64617279437572736F727328292C746869732E5F65786563757465456469744F7065726174696F6E286E6577204A4328302C5B745D2C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21312C73686F75';
wwv_flow_imp.g_varchar2_table(17175) := '6C6450757368537461636B456C656D656E7441667465723A21317D29297D292C652C6E297D65786563757465436F6D6D616E647328652C742C6E297B746869732E5F6578656375746545646974282828293D3E7B746869732E5F65786563757465456469';
wwv_flow_imp.g_varchar2_table(17176) := '744F7065726174696F6E286E6577204A4328302C742C7B73686F756C6450757368537461636B456C656D656E744265666F72653A21312C73686F756C6450757368537461636B456C656D656E7441667465723A21317D29297D292C652C6E297D7D636C61';
wwv_flow_imp.g_varchar2_table(17177) := '73732042467B7374617469632066726F6D28652C74297B72657475726E206E657720424628652E67657456657273696F6E496428292C742E676574437572736F725374617465732829297D636F6E7374727563746F7228652C74297B746869732E6D6F64';
wwv_flow_imp.g_varchar2_table(17178) := '656C56657273696F6E49643D652C746869732E637572736F7253746174653D747D657175616C732865297B69662821652972657475726E21313B696628746869732E6D6F64656C56657273696F6E4964213D3D652E6D6F64656C56657273696F6E496429';
wwv_flow_imp.g_varchar2_table(17179) := '72657475726E21313B696628746869732E637572736F7253746174652E6C656E677468213D3D652E637572736F7253746174652E6C656E6774682972657475726E21313B666F72286C657420743D302C6E3D746869732E637572736F7253746174652E6C';
wwv_flow_imp.g_varchar2_table(17180) := '656E6774683B743C6E3B742B2B2969662821746869732E637572736F7253746174655B745D2E657175616C7328652E637572736F7253746174655B745D292972657475726E21313B72657475726E21307D7D636C6173732056467B737461746963206765';
wwv_flow_imp.g_varchar2_table(17181) := '74416C6C4175746F436C6F736564436861726163746572732865297B6C657420743D5B5D3B666F7228636F6E7374206E206F66206529743D742E636F6E636174286E2E6765744175746F436C6F7365644368617261637465727352616E6765732829293B';
wwv_flow_imp.g_varchar2_table(17182) := '72657475726E20747D636F6E7374727563746F7228652C742C6E297B746869732E5F6D6F64656C3D652C746869732E5F6175746F436C6F736564436861726163746572734465636F726174696F6E733D742C746869732E5F6175746F436C6F736564456E';
wwv_flow_imp.g_varchar2_table(17183) := '636C6F73696E674465636F726174696F6E733D6E7D646973706F736528297B746869732E5F6175746F436C6F736564436861726163746572734465636F726174696F6E733D746869732E5F6D6F64656C2E64656C74614465636F726174696F6E73287468';
wwv_flow_imp.g_varchar2_table(17184) := '69732E5F6175746F436C6F736564436861726163746572734465636F726174696F6E732C5B5D292C746869732E5F6175746F436C6F736564456E636C6F73696E674465636F726174696F6E733D746869732E5F6D6F64656C2E64656C74614465636F7261';
wwv_flow_imp.g_varchar2_table(17185) := '74696F6E7328746869732E5F6175746F436C6F736564456E636C6F73696E674465636F726174696F6E732C5B5D297D6765744175746F436C6F7365644368617261637465727352616E67657328297B636F6E737420653D5B5D3B666F72286C657420743D';
wwv_flow_imp.g_varchar2_table(17186) := '303B743C746869732E5F6175746F436C6F736564436861726163746572734465636F726174696F6E732E6C656E6774683B742B2B297B636F6E7374206E3D746869732E5F6D6F64656C2E6765744465636F726174696F6E52616E676528746869732E5F61';
wwv_flow_imp.g_varchar2_table(17187) := '75746F436C6F736564436861726163746572734465636F726174696F6E735B745D293B6E2626652E70757368286E297D72657475726E20657D697356616C69642865297B636F6E737420743D5B5D3B666F72286C657420653D303B653C746869732E5F61';
wwv_flow_imp.g_varchar2_table(17188) := '75746F436C6F736564456E636C6F73696E674465636F726174696F6E732E6C656E6774683B652B2B297B636F6E7374206E3D746869732E5F6D6F64656C2E6765744465636F726174696F6E52616E676528746869732E5F6175746F436C6F736564456E63';
wwv_flow_imp.g_varchar2_table(17189) := '6C6F73696E674465636F726174696F6E735B655D293B6966286E262628742E70757368286E292C6E2E73746172744C696E654E756D626572213D3D6E2E656E644C696E654E756D626572292972657475726E21317D742E736F72742872682E636F6D7061';
wwv_flow_imp.g_varchar2_table(17190) := '726552616E6765735573696E67537461727473292C652E736F72742872682E636F6D7061726552616E6765735573696E67537461727473293B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B6966286E3E3D742E6C656E67746829';
wwv_flow_imp.g_varchar2_table(17191) := '72657475726E21313B69662821745B6E5D2E737472696374436F6E7461696E7352616E676528655B6E5D292972657475726E21317D72657475726E21307D7D636C617373207A467B7374617469632065786563757465436F6D6D616E647328652C742C6E';
wwv_flow_imp.g_varchar2_table(17192) := '297B636F6E737420693D7B6D6F64656C3A652C73656C656374696F6E734265666F72653A742C747261636B656452616E6765733A5B5D2C747261636B656452616E676573446972656374696F6E3A5B5D7D2C6F3D746869732E5F696E6E65724578656375';
wwv_flow_imp.g_varchar2_table(17193) := '7465436F6D6D616E647328692C6E293B666F72286C657420653D302C743D692E747261636B656452616E6765732E6C656E6774683B653C743B652B2B29692E6D6F64656C2E5F736574547261636B656452616E676528692E747261636B656452616E6765';
wwv_flow_imp.g_varchar2_table(17194) := '735B655D2C6E756C6C2C30293B72657475726E206F7D737461746963205F696E6E657245786563757465436F6D6D616E647328652C74297B696628746869732E5F61727261794973456D7074792874292972657475726E206E756C6C3B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(17195) := '3D746869732E5F676574456469744F7065726174696F6E7328652C74293B696628303D3D3D6E2E6F7065726174696F6E732E6C656E6774682972657475726E206E756C6C3B636F6E737420693D6E2E6F7065726174696F6E732C6F3D746869732E5F6765';
wwv_flow_imp.g_varchar2_table(17196) := '744C6F736572437572736F724D61702869293B6966286F2E6861734F776E50726F706572747928223022292972657475726E20636F6E736F6C652E7761726E282249676E6F72696E6720636F6D6D616E647322292C6E756C6C3B636F6E737420733D5B5D';
wwv_flow_imp.g_varchar2_table(17197) := '3B666F72286C657420653D302C743D692E6C656E6774683B653C743B652B2B296F2E6861734F776E50726F706572747928695B655D2E6964656E7469666965722E6D616A6F722E746F537472696E672829297C7C732E7075736828695B655D293B6E2E68';
wwv_flow_imp.g_varchar2_table(17198) := '6164547261636B6564456469744F7065726174696F6E2626732E6C656E6774683E30262628735B305D2E5F6973547261636B65643D2130293B6C657420723D652E6D6F64656C2E70757368456469744F7065726174696F6E7328652E73656C656374696F';
wwv_flow_imp.g_varchar2_table(17199) := '6E734265666F72652C732C286E3D3E7B636F6E737420693D5B5D3B666F72286C657420743D303B743C652E73656C656374696F6E734265666F72652E6C656E6774683B742B2B29695B745D3D5B5D3B666F7228636F6E73742065206F66206E29652E6964';
wwv_flow_imp.g_varchar2_table(17200) := '656E7469666965722626695B652E6964656E7469666965722E6D616A6F725D2E707573682865293B636F6E7374206F3D28652C74293D3E652E6964656E7469666965722E6D696E6F722D742E6964656E7469666965722E6D696E6F722C733D5B5D3B666F';
wwv_flow_imp.g_varchar2_table(17201) := '72286C6574206E3D303B6E3C652E73656C656374696F6E734265666F72652E6C656E6774683B6E2B2B29695B6E5D2E6C656E6774683E303F28695B6E5D2E736F7274286F292C735B6E5D3D745B6E5D2E636F6D70757465437572736F7253746174652865';
wwv_flow_imp.g_varchar2_table(17202) := '2E6D6F64656C2C7B676574496E7665727365456469744F7065726174696F6E733A28293D3E695B6E5D2C676574547261636B656453656C656374696F6E3A743D3E7B636F6E7374206E3D7061727365496E7428742C3130292C693D652E6D6F64656C2E5F';
wwv_flow_imp.g_varchar2_table(17203) := '676574547261636B656452616E676528652E747261636B656452616E6765735B6E5D293B72657475726E20303D3D3D652E747261636B656452616E676573446972656374696F6E5B6E5D3F6E657720616828692E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(17204) := '692E7374617274436F6C756D6E2C692E656E644C696E654E756D6265722C692E656E64436F6C756D6E293A6E657720616828692E656E644C696E654E756D6265722C692E656E64436F6C756D6E2C692E73746172744C696E654E756D6265722C692E7374';
wwv_flow_imp.g_varchar2_table(17205) := '617274436F6C756D6E297D7D29293A735B6E5D3D652E73656C656374696F6E734265666F72655B6E5D3B72657475726E20737D29293B727C7C28723D652E73656C656374696F6E734265666F7265293B636F6E737420613D5B5D3B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(17206) := '206520696E206F296F2E6861734F776E50726F70657274792865292626612E70757368287061727365496E7428652C313029293B612E736F7274282828652C74293D3E742D6529293B666F7228636F6E73742065206F66206129722E73706C6963652865';
wwv_flow_imp.g_varchar2_table(17207) := '2C31293B72657475726E20727D737461746963205F61727261794973456D7074792865297B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B29696628655B745D2972657475726E21313B72657475726E21307D737461746963';
wwv_flow_imp.g_varchar2_table(17208) := '205F676574456469744F7065726174696F6E7328652C74297B6C6574206E3D5B5D2C693D21313B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D3B69662873297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(17209) := '69732E5F676574456469744F7065726174696F6E7346726F6D436F6D6D616E6428652C6F2C73293B6E3D6E2E636F6E63617428742E6F7065726174696F6E73292C693D697C7C742E686164547261636B6564456469744F7065726174696F6E7D7D726574';
wwv_flow_imp.g_varchar2_table(17210) := '75726E7B6F7065726174696F6E733A6E2C686164547261636B6564456469744F7065726174696F6E3A697D7D737461746963205F676574456469744F7065726174696F6E7346726F6D436F6D6D616E6428652C742C6E297B636F6E737420693D5B5D3B6C';
wwv_flow_imp.g_varchar2_table(17211) := '6574206F3D303B636F6E737420733D28652C732C723D2131293D3E7B72682E6973456D707479286529262622223D3D3D737C7C692E70757368287B6964656E7469666965723A7B6D616A6F723A742C6D696E6F723A6F2B2B7D2C72616E67653A652C7465';
wwv_flow_imp.g_varchar2_table(17212) := '78743A732C666F7263654D6F76654D61726B6572733A722C69734175746F57686974657370616365456469743A6E2E696E73657274734175746F576869746573706163657D297D3B6C657420723D21313B636F6E737420613D7B616464456469744F7065';
wwv_flow_imp.g_varchar2_table(17213) := '726174696F6E3A732C616464547261636B6564456469744F7065726174696F6E3A28652C742C6E293D3E7B723D21302C7328652C742C6E297D2C747261636B53656C656374696F6E3A28742C6E293D3E7B636F6E737420693D61682E6C69667453656C65';
wwv_flow_imp.g_varchar2_table(17214) := '6374696F6E2874293B6C6574206F3B696628692E6973456D70747928292969662822626F6F6C65616E223D3D747970656F66206E296F3D6E3F323A333B656C73657B636F6E737420743D652E6D6F64656C2E6765744C696E654D6178436F6C756D6E2869';
wwv_flow_imp.g_varchar2_table(17215) := '2E73746172744C696E654E756D626572293B6F3D692E7374617274436F6C756D6E3D3D3D743F323A337D656C7365206F3D313B636F6E737420733D652E747261636B656452616E6765732E6C656E6774682C723D652E6D6F64656C2E5F73657454726163';
wwv_flow_imp.g_varchar2_table(17216) := '6B656452616E6765286E756C6C2C692C6F293B72657475726E20652E747261636B656452616E6765735B735D3D722C652E747261636B656452616E676573446972656374696F6E5B735D3D692E676574446972656374696F6E28292C732E746F53747269';
wwv_flow_imp.g_varchar2_table(17217) := '6E6728297D7D3B7472797B6E2E676574456469744F7065726174696F6E7328652E6D6F64656C2C61297D63617463682865297B72657475726E206B652865292C7B6F7065726174696F6E733A5B5D2C686164547261636B6564456469744F706572617469';
wwv_flow_imp.g_varchar2_table(17218) := '6F6E3A21317D7D72657475726E7B6F7065726174696F6E733A692C686164547261636B6564456469744F7065726174696F6E3A727D7D737461746963205F6765744C6F736572437572736F724D61702865297B28653D652E736C696365283029292E736F';
wwv_flow_imp.g_varchar2_table(17219) := '7274282828652C74293D3E2D72682E636F6D7061726552616E6765735573696E67456E647328652E72616E67652C742E72616E67652929293B636F6E737420743D7B7D3B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B297B636F6E73';
wwv_flow_imp.g_varchar2_table(17220) := '7420693D655B6E2D315D2C6F3D655B6E5D3B69662872682E6765745374617274506F736974696F6E28692E72616E6765292E69734265666F72652872682E676574456E64506F736974696F6E286F2E72616E67652929297B6C657420733B733D692E6964';
wwv_flow_imp.g_varchar2_table(17221) := '656E7469666965722E6D616A6F723E6F2E6964656E7469666965722E6D616A6F723F692E6964656E7469666965722E6D616A6F723A6F2E6964656E7469666965722E6D616A6F722C745B732E746F537472696E6728295D3D21303B666F72286C65742074';
wwv_flow_imp.g_varchar2_table(17222) := '3D303B743C652E6C656E6774683B742B2B29655B745D2E6964656E7469666965722E6D616A6F723D3D3D73262628652E73706C69636528742C31292C743C6E26266E2D2D2C742D2D293B6E3E3026266E2D2D7D7D72657475726E20747D7D636C61737320';
wwv_flow_imp.g_varchar2_table(17223) := '48467B636F6E7374727563746F7228652C742C6E297B746869732E746578743D652C746869732E737461727453656C656374696F6E3D742C746869732E656E6453656C656374696F6E3D6E7D7D636C6173732057467B737461746963205F636170747572';
wwv_flow_imp.g_varchar2_table(17224) := '6528652C74297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F662074297B696628692E73746172744C696E654E756D626572213D3D692E656E644C696E654E756D6265722972657475726E206E756C6C3B6E2E70757368286E6577204846';
wwv_flow_imp.g_varchar2_table(17225) := '28652E6765744C696E65436F6E74656E7428692E73746172744C696E654E756D626572292C692E7374617274436F6C756D6E2D312C692E656E64436F6C756D6E2D3129297D72657475726E206E7D636F6E7374727563746F7228652C74297B746869732E';
wwv_flow_imp.g_varchar2_table(17226) := '5F6F726967696E616C3D57462E5F6361707475726528652C74297D6465647563654F7574636F6D6528652C74297B69662821746869732E5F6F726967696E616C2972657475726E206E756C6C3B636F6E7374206E3D57462E5F6361707475726528652C74';
wwv_flow_imp.g_varchar2_table(17227) := '293B696628216E2972657475726E206E756C6C3B696628746869732E5F6F726967696E616C2E6C656E677468213D3D6E2E6C656E6774682972657475726E206E756C6C3B636F6E737420693D5B5D3B666F72286C657420653D302C743D746869732E5F6F';
wwv_flow_imp.g_varchar2_table(17228) := '726967696E616C2E6C656E6774683B653C743B652B2B29692E707573682857462E5F6465647563654F7574636F6D6528746869732E5F6F726967696E616C5B655D2C6E5B655D29293B72657475726E20697D737461746963205F6465647563654F757463';
wwv_flow_imp.g_varchar2_table(17229) := '6F6D6528652C74297B636F6E7374206E3D4D6174682E6D696E28652E737461727453656C656374696F6E2C742E737461727453656C656374696F6E2C4C6928652E746578742C742E7465787429292C693D4D6174682E6D696E28652E746578742E6C656E';
wwv_flow_imp.g_varchar2_table(17230) := '6774682D652E656E6453656C656374696F6E2C742E746578742E6C656E6774682D742E656E6453656C656374696F6E2C446928652E746578742C742E7465787429292C6F3D652E746578742E737562737472696E67286E2C652E746578742E6C656E6774';
wwv_flow_imp.g_varchar2_table(17231) := '682D69292C733D742E746578742E737562737472696E67286E2C742E746578742E6C656E6774682D69293B72657475726E206E6577204453286F2C652E737461727453656C656374696F6E2D6E2C652E656E6453656C656374696F6E2D6E2C732C742E73';
wwv_flow_imp.g_varchar2_table(17232) := '7461727453656C656374696F6E2D6E2C742E656E6453656C656374696F6E2D6E297D7D636C617373206A467B636F6E7374727563746F7228297B746869732E5F68617350656E64696E673D21312C746869732E5F696E73657274733D5B5D2C746869732E';
wwv_flow_imp.g_varchar2_table(17233) := '5F6368616E6765733D5B5D2C746869732E5F72656D6F7665733D5B5D7D696E736572742865297B746869732E5F68617350656E64696E673D21302C746869732E5F696E73657274732E707573682865297D6368616E67652865297B746869732E5F686173';
wwv_flow_imp.g_varchar2_table(17234) := '50656E64696E673D21302C746869732E5F6368616E6765732E707573682865297D72656D6F76652865297B746869732E5F68617350656E64696E673D21302C746869732E5F72656D6F7665732E707573682865297D6D757374436F6D6D697428297B7265';
wwv_flow_imp.g_varchar2_table(17235) := '7475726E20746869732E5F68617350656E64696E677D636F6D6D69742865297B69662821746869732E5F68617350656E64696E672972657475726E3B636F6E737420743D746869732E5F696E73657274732C6E3D746869732E5F6368616E6765732C693D';
wwv_flow_imp.g_varchar2_table(17236) := '746869732E5F72656D6F7665733B746869732E5F68617350656E64696E673D21312C746869732E5F696E73657274733D5B5D2C746869732E5F6368616E6765733D5B5D2C746869732E5F72656D6F7665733D5B5D2C652E5F636F6D6D697450656E64696E';
wwv_flow_imp.g_varchar2_table(17237) := '674368616E67657328742C6E2C69297D7D636C6173732071467B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E69643D652C746869732E61667465724C696E654E756D6265723D742C746869732E6F7264696E616C3D6E2C746869';
wwv_flow_imp.g_varchar2_table(17238) := '732E6865696768743D692C746869732E6D696E57696474683D6F2C746869732E70726566697853756D3D307D7D636C6173732024467B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F696E7374616E636549643D4B69282B2B24462E';
wwv_flow_imp.g_varchar2_table(17239) := '494E5354414E43455F434F554E54292C746869732E5F70656E64696E674368616E6765733D6E6577206A462C746869732E5F6C6173745768697465737061636549643D302C746869732E5F6172723D5B5D2C746869732E5F70726566697853756D56616C';
wwv_flow_imp.g_varchar2_table(17240) := '6964496E6465783D2D312C746869732E5F6D696E57696474683D2D312C746869732E5F6C696E65436F756E743D652C746869732E5F6C696E654865696768743D742C746869732E5F70616464696E67546F703D6E2C746869732E5F70616464696E67426F';
wwv_flow_imp.g_varchar2_table(17241) := '74746F6D3D697D7374617469632066696E64496E73657274696F6E496E64657828652C742C6E297B6C657420693D302C6F3D652E6C656E6774683B666F72283B693C6F3B297B636F6E737420733D692B6F3E3E3E313B743D3D3D655B735D2E6166746572';
wwv_flow_imp.g_varchar2_table(17242) := '4C696E654E756D6265723F6E3C655B735D2E6F7264696E616C3F6F3D733A693D732B313A743C655B735D2E61667465724C696E654E756D6265723F6F3D733A693D732B317D72657475726E20697D7365744C696E654865696768742865297B746869732E';
wwv_flow_imp.g_varchar2_table(17243) := '5F636865636B50656E64696E674368616E67657328292C746869732E5F6C696E654865696768743D657D73657450616464696E6728652C74297B746869732E5F70616464696E67546F703D652C746869732E5F70616464696E67426F74746F6D3D747D6F';
wwv_flow_imp.g_varchar2_table(17244) := '6E466C75736865642865297B746869732E5F636865636B50656E64696E674368616E67657328292C746869732E5F6C696E65436F756E743D657D6368616E6765576869746573706163652865297B6C657420743D21313B7472797B65287B696E73657274';
wwv_flow_imp.g_varchar2_table(17245) := '576869746573706163653A28652C6E2C692C6F293D3E7B743D21302C657C3D302C6E7C3D302C697C3D302C6F7C3D303B636F6E737420733D746869732E5F696E7374616E636549642B202B2B746869732E5F6C6173745768697465737061636549643B72';
wwv_flow_imp.g_varchar2_table(17246) := '657475726E20746869732E5F70656E64696E674368616E6765732E696E73657274286E657720714628732C652C6E2C692C6F29292C737D2C6368616E67654F6E65576869746573706163653A28652C6E2C69293D3E7B743D21302C6E7C3D302C697C3D30';
wwv_flow_imp.g_varchar2_table(17247) := '2C746869732E5F70656E64696E674368616E6765732E6368616E6765287B69643A652C6E657741667465724C696E654E756D6265723A6E2C6E65774865696768743A697D297D2C72656D6F7665576869746573706163653A653D3E7B743D21302C746869';
wwv_flow_imp.g_varchar2_table(17248) := '732E5F70656E64696E674368616E6765732E72656D6F7665287B69643A657D297D7D297D66696E616C6C797B746869732E5F70656E64696E674368616E6765732E636F6D6D69742874686973297D72657475726E20747D5F636F6D6D697450656E64696E';
wwv_flow_imp.g_varchar2_table(17249) := '674368616E67657328652C742C6E297B69662828652E6C656E6774683E307C7C6E2E6C656E6774683E3029262628746869732E5F6D696E57696474683D2D31292C652E6C656E6774682B742E6C656E6774682B6E2E6C656E6774683C3D31297B666F7228';
wwv_flow_imp.g_varchar2_table(17250) := '636F6E73742074206F66206529746869732E5F696E73657274576869746573706163652874293B666F7228636F6E73742065206F66207429746869732E5F6368616E67654F6E655768697465737061636528652E69642C652E6E657741667465724C696E';
wwv_flow_imp.g_varchar2_table(17251) := '654E756D6265722C652E6E6577486569676874293B666F7228636F6E73742065206F66206E297B636F6E737420743D746869732E5F66696E6457686974657370616365496E64657828652E6964293B2D31213D3D742626746869732E5F72656D6F766557';
wwv_flow_imp.g_varchar2_table(17252) := '6869746573706163652874297D72657475726E7D636F6E737420693D6E6577205365743B666F7228636F6E73742065206F66206E29692E61646428652E6964293B636F6E7374206F3D6E6577204D61703B666F7228636F6E73742065206F662074296F2E';
wwv_flow_imp.g_varchar2_table(17253) := '73657428652E69642C65293B636F6E737420733D653D3E7B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620652969662821692E686173286E2E696429297B6966286F2E686173286E2E696429297B636F6E737420653D6F2E676574286E';
wwv_flow_imp.g_varchar2_table(17254) := '2E6964293B6E2E61667465724C696E654E756D6265723D652E6E657741667465724C696E654E756D6265722C6E2E6865696768743D652E6E65774865696768747D742E70757368286E297D72657475726E20747D2C723D7328746869732E5F617272292E';
wwv_flow_imp.g_varchar2_table(17255) := '636F6E6361742873286529293B722E736F7274282828652C74293D3E652E61667465724C696E654E756D6265723D3D3D742E61667465724C696E654E756D6265723F652E6F7264696E616C2D742E6F7264696E616C3A652E61667465724C696E654E756D';
wwv_flow_imp.g_varchar2_table(17256) := '6265722D742E61667465724C696E654E756D62657229292C746869732E5F6172723D722C746869732E5F70726566697853756D56616C6964496E6465783D2D317D5F636865636B50656E64696E674368616E67657328297B746869732E5F70656E64696E';
wwv_flow_imp.g_varchar2_table(17257) := '674368616E6765732E6D757374436F6D6D697428292626746869732E5F70656E64696E674368616E6765732E636F6D6D69742874686973297D5F696E73657274576869746573706163652865297B636F6E737420743D24462E66696E64496E7365727469';
wwv_flow_imp.g_varchar2_table(17258) := '6F6E496E64657828746869732E5F6172722C652E61667465724C696E654E756D6265722C652E6F7264696E616C293B746869732E5F6172722E73706C69636528742C302C65292C746869732E5F70726566697853756D56616C6964496E6465783D4D6174';
wwv_flow_imp.g_varchar2_table(17259) := '682E6D696E28746869732E5F70726566697853756D56616C6964496E6465782C742D31297D5F66696E6457686974657370616365496E6465782865297B636F6E737420743D746869732E5F6172723B666F72286C6574206E3D302C693D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(17260) := '683B6E3C693B6E2B2B29696628745B6E5D2E69643D3D3D652972657475726E206E3B72657475726E2D317D5F6368616E67654F6E655768697465737061636528652C742C6E297B636F6E737420693D746869732E5F66696E645768697465737061636549';
wwv_flow_imp.g_varchar2_table(17261) := '6E6465782865293B6966282D31213D3D69262628746869732E5F6172725B695D2E686569676874213D3D6E262628746869732E5F6172725B695D2E6865696768743D6E2C746869732E5F70726566697853756D56616C6964496E6465783D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(17262) := '696E28746869732E5F70726566697853756D56616C6964496E6465782C692D3129292C746869732E5F6172725B695D2E61667465724C696E654E756D626572213D3D7429297B636F6E737420653D746869732E5F6172725B695D3B746869732E5F72656D';
wwv_flow_imp.g_varchar2_table(17263) := '6F7665576869746573706163652869292C652E61667465724C696E654E756D6265723D742C746869732E5F696E73657274576869746573706163652865297D7D5F72656D6F7665576869746573706163652865297B746869732E5F6172722E73706C6963';
wwv_flow_imp.g_varchar2_table(17264) := '6528652C31292C746869732E5F70726566697853756D56616C6964496E6465783D4D6174682E6D696E28746869732E5F70726566697853756D56616C6964496E6465782C652D31297D6F6E4C696E657344656C6574656428652C74297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(17265) := '6865636B50656E64696E674368616E67657328292C657C3D302C747C3D302C746869732E5F6C696E65436F756E742D3D742D652B313B666F72286C6574206E3D302C693D746869732E5F6172722E6C656E6774683B6E3C693B6E2B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(17266) := '693D746869732E5F6172725B6E5D2E61667465724C696E654E756D6265723B653C3D692626693C3D743F746869732E5F6172725B6E5D2E61667465724C696E654E756D6265723D652D313A693E74262628746869732E5F6172725B6E5D2E61667465724C';
wwv_flow_imp.g_varchar2_table(17267) := '696E654E756D6265722D3D742D652B31297D7D6F6E4C696E6573496E73657274656428652C74297B746869732E5F636865636B50656E64696E674368616E67657328292C657C3D302C747C3D302C746869732E5F6C696E65436F756E742B3D742D652B31';
wwv_flow_imp.g_varchar2_table(17268) := '3B666F72286C6574206E3D302C693D746869732E5F6172722E6C656E6774683B6E3C693B6E2B2B29653C3D746869732E5F6172725B6E5D2E61667465724C696E654E756D626572262628746869732E5F6172725B6E5D2E61667465724C696E654E756D62';
wwv_flow_imp.g_varchar2_table(17269) := '65722B3D742D652B31297D6765745768697465737061636573546F74616C48656967687428297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C303D3D3D746869732E5F6172722E6C656E6774683F303A746869';
wwv_flow_imp.g_varchar2_table(17270) := '732E6765745768697465737061636573416363756D756C6174656448656967687428746869732E5F6172722E6C656E6774682D31297D6765745768697465737061636573416363756D756C617465644865696768742865297B746869732E5F636865636B';
wwv_flow_imp.g_varchar2_table(17271) := '50656E64696E674368616E67657328292C657C3D303B6C657420743D4D6174682E6D617828302C746869732E5F70726566697853756D56616C6964496E6465782B31293B303D3D3D74262628746869732E5F6172725B305D2E70726566697853756D3D74';
wwv_flow_imp.g_varchar2_table(17272) := '6869732E5F6172725B305D2E6865696768742C742B2B293B666F72286C6574206E3D743B6E3C3D653B6E2B2B29746869732E5F6172725B6E5D2E70726566697853756D3D746869732E5F6172725B6E2D315D2E70726566697853756D2B746869732E5F61';
wwv_flow_imp.g_varchar2_table(17273) := '72725B6E5D2E6865696768743B72657475726E20746869732E5F70726566697853756D56616C6964496E6465783D4D6174682E6D617828746869732E5F70726566697853756D56616C6964496E6465782C65292C746869732E5F6172725B655D2E707265';
wwv_flow_imp.g_varchar2_table(17274) := '66697853756D7D6765744C696E6573546F74616C48656967687428297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C746869732E5F6C696E654865696768742A746869732E5F6C696E65436F756E742B746869';
wwv_flow_imp.g_varchar2_table(17275) := '732E6765745768697465737061636573546F74616C48656967687428292B746869732E5F70616464696E67546F702B746869732E5F70616464696E67426F74746F6D7D67657457686974657370616365416363756D756C61746564486569676874426566';
wwv_flow_imp.g_varchar2_table(17276) := '6F72654C696E654E756D6265722865297B746869732E5F636865636B50656E64696E674368616E67657328292C657C3D303B636F6E737420743D746869732E5F66696E644C617374576869746573706163654265666F72654C696E654E756D6265722865';
wwv_flow_imp.g_varchar2_table(17277) := '293B72657475726E2D313D3D3D743F303A746869732E6765745768697465737061636573416363756D756C617465644865696768742874297D5F66696E644C617374576869746573706163654265666F72654C696E654E756D6265722865297B657C3D30';
wwv_flow_imp.g_varchar2_table(17278) := '3B636F6E737420743D746869732E5F6172723B6C6574206E3D302C693D742E6C656E6774682D313B666F72283B6E3C3D693B297B636F6E7374206F3D6E2B2828692D6E7C30292F327C30297C303B696628745B6F5D2E61667465724C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(17279) := '723C65297B6966286F2B313E3D742E6C656E6774687C7C745B6F2B315D2E61667465724C696E654E756D6265723E3D652972657475726E206F3B6E3D6F2B317C307D656C736520693D6F2D317C307D72657475726E2D317D5F66696E6446697273745768';
wwv_flow_imp.g_varchar2_table(17280) := '697465737061636541667465724C696E654E756D6265722865297B657C3D303B636F6E737420743D746869732E5F66696E644C617374576869746573706163654265666F72654C696E654E756D6265722865292B313B72657475726E20743C746869732E';
wwv_flow_imp.g_varchar2_table(17281) := '5F6172722E6C656E6774683F743A2D317D676574466972737457686974657370616365496E64657841667465724C696E654E756D6265722865297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C657C3D302C74';
wwv_flow_imp.g_varchar2_table(17282) := '6869732E5F66696E6446697273745768697465737061636541667465724C696E654E756D6265722865297D676574566572746963616C4F6666736574466F724C696E654E756D62657228652C743D2131297B6C6574206E3B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(17283) := '5F636865636B50656E64696E674368616E67657328292C6E3D28657C3D30293E313F746869732E5F6C696E654865696768742A28652D31293A302C6E2B746869732E67657457686974657370616365416363756D756C617465644865696768744265666F';
wwv_flow_imp.g_varchar2_table(17284) := '72654C696E654E756D62657228652D28743F313A3029292B746869732E5F70616464696E67546F707D676574566572746963616C4F666673657441667465724C696E654E756D62657228652C743D2131297B72657475726E20746869732E5F636865636B';
wwv_flow_imp.g_varchar2_table(17285) := '50656E64696E674368616E67657328292C657C3D302C746869732E5F6C696E654865696768742A652B746869732E67657457686974657370616365416363756D756C617465644865696768744265666F72654C696E654E756D62657228652B28743F313A';
wwv_flow_imp.g_varchar2_table(17286) := '3029292B746869732E5F70616464696E67546F707D676574576869746573706163654D696E576964746828297B696628746869732E5F636865636B50656E64696E674368616E67657328292C2D313D3D3D746869732E5F6D696E5769647468297B6C6574';
wwv_flow_imp.g_varchar2_table(17287) := '20653D303B666F72286C657420743D302C6E3D746869732E5F6172722E6C656E6774683B743C6E3B742B2B29653D4D6174682E6D617828652C746869732E5F6172725B745D2E6D696E5769647468293B746869732E5F6D696E57696474683D657D726574';
wwv_flow_imp.g_varchar2_table(17288) := '75726E20746869732E5F6D696E57696474687D697341667465724C696E65732865297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C653E746869732E6765744C696E6573546F74616C48656967687428297D69';
wwv_flow_imp.g_varchar2_table(17289) := '73496E546F7050616464696E672865297B72657475726E2030213D3D746869732E5F70616464696E67546F70262628746869732E5F636865636B50656E64696E674368616E67657328292C653C746869732E5F70616464696E67546F70297D6973496E42';
wwv_flow_imp.g_varchar2_table(17290) := '6F74746F6D50616464696E672865297B72657475726E2030213D3D746869732E5F70616464696E67426F74746F6D262628746869732E5F636865636B50656E64696E674368616E67657328292C653E3D746869732E6765744C696E6573546F74616C4865';
wwv_flow_imp.g_varchar2_table(17291) := '6967687428292D746869732E5F70616464696E67426F74746F6D297D6765744C696E654E756D62657241744F724166746572566572746963616C4F66667365742865297B696628746869732E5F636865636B50656E64696E674368616E67657328292C28';
wwv_flow_imp.g_varchar2_table(17292) := '657C3D30293C302972657475726E20313B636F6E737420743D307C746869732E5F6C696E65436F756E742C6E3D746869732E5F6C696E654865696768743B6C657420693D312C6F3D743B666F72283B693C6F3B297B636F6E737420743D28692B6F292F32';
wwv_flow_imp.g_varchar2_table(17293) := '7C302C733D307C746869732E676574566572746963616C4F6666736574466F724C696E654E756D6265722874293B696628653E3D732B6E29693D742B313B656C73657B696628653E3D732972657475726E20743B6F3D747D7D72657475726E20693E743F';
wwv_flow_imp.g_varchar2_table(17294) := '743A697D6765744C696E657356696577706F72744461746128652C74297B746869732E5F636865636B50656E64696E674368616E67657328292C657C3D302C747C3D303B636F6E7374206E3D746869732E5F6C696E654865696768742C693D307C746869';
wwv_flow_imp.g_varchar2_table(17295) := '732E6765744C696E654E756D62657241744F724166746572566572746963616C4F66667365742865292C6F3D307C746869732E676574566572746963616C4F6666736574466F724C696E654E756D6265722869293B6C657420733D307C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(17296) := '696E65436F756E742C723D307C746869732E676574466972737457686974657370616365496E64657841667465724C696E654E756D6265722869293B636F6E737420613D307C746869732E6765745768697465737061636573436F756E7428293B6C6574';
wwv_flow_imp.g_varchar2_table(17297) := '206C2C633B2D313D3D3D723F28723D612C633D732B312C6C3D30293A28633D307C746869732E67657441667465724C696E654E756D626572466F7257686974657370616365496E6465782872292C6C3D307C746869732E676574486569676874466F7257';
wwv_flow_imp.g_varchar2_table(17298) := '686974657370616365496E646578287229293B6C657420643D6F2C683D643B636F6E737420753D3565353B6C657420703D303B6F3E3D75262628703D4D6174682E666C6F6F72286F2F75292A752C703D4D6174682E666C6F6F7228702F6E292A6E2C682D';
wwv_flow_imp.g_varchar2_table(17299) := '3D70293B636F6E737420673D5B5D2C6D3D652B28742D65292F323B6C657420663D2D313B666F72286C657420653D693B653C3D733B652B2B297B666F72282D313D3D3D66262628643C3D6D26266D3C642B6E7C7C643E6D29262628663D65292C642B3D6E';
wwv_flow_imp.g_varchar2_table(17300) := '2C675B652D695D3D682C682B3D6E3B633D3D3D653B29682B3D6C2C642B3D6C2C722B2B2C723E3D613F633D732B313A28633D307C746869732E67657441667465724C696E654E756D626572466F7257686974657370616365496E6465782872292C6C3D30';
wwv_flow_imp.g_varchar2_table(17301) := '7C746869732E676574486569676874466F7257686974657370616365496E646578287229293B696628643E3D74297B733D653B627265616B7D7D2D313D3D3D66262628663D73293B636F6E737420763D307C746869732E676574566572746963616C4F66';
wwv_flow_imp.g_varchar2_table(17302) := '66736574466F724C696E654E756D6265722873293B6C657420623D692C5F3D733B72657475726E20623C5F26266F3C652626622B2B2C623C5F2626762B6E3E7426265F2D2D2C7B6269674E756D6265727344656C74613A702C73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(17303) := '6D6265723A692C656E644C696E654E756D6265723A732C72656C6174697665566572746963616C4F66667365743A672C63656E74657265644C696E654E756D6265723A662C636F6D706C6574656C7956697369626C6553746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(17304) := '723A622C636F6D706C6574656C7956697369626C65456E644C696E654E756D6265723A5F2C6C696E654865696768743A746869732E5F6C696E654865696768747D7D676574566572746963616C4F6666736574466F7257686974657370616365496E6465';
wwv_flow_imp.g_varchar2_table(17305) := '782865297B746869732E5F636865636B50656E64696E674368616E67657328292C657C3D303B636F6E737420743D746869732E67657441667465724C696E654E756D626572466F7257686974657370616365496E6465782865293B6C6574206E2C693B72';
wwv_flow_imp.g_varchar2_table(17306) := '657475726E206E3D743E3D313F746869732E5F6C696E654865696768742A743A302C693D653E303F746869732E6765745768697465737061636573416363756D756C6174656448656967687428652D31293A302C6E2B692B746869732E5F70616464696E';
wwv_flow_imp.g_varchar2_table(17307) := '67546F707D67657457686974657370616365496E64657841744F724166746572566572746963616C6C4F66667365742865297B746869732E5F636865636B50656E64696E674368616E67657328292C657C3D303B6C657420743D302C6E3D746869732E67';
wwv_flow_imp.g_varchar2_table(17308) := '65745768697465737061636573436F756E7428292D313B6966286E3C302972657475726E2D313B696628653E3D746869732E676574566572746963616C4F6666736574466F7257686974657370616365496E646578286E292B746869732E676574486569';
wwv_flow_imp.g_varchar2_table(17309) := '676874466F7257686974657370616365496E646578286E292972657475726E2D313B666F72283B743C6E3B297B636F6E737420693D4D6174682E666C6F6F722828742B6E292F32292C6F3D746869732E676574566572746963616C4F6666736574466F72';
wwv_flow_imp.g_varchar2_table(17310) := '57686974657370616365496E6465782869293B696628653E3D6F2B746869732E676574486569676874466F7257686974657370616365496E64657828692929743D692B313B656C73657B696628653E3D6F2972657475726E20693B6E3D697D7D72657475';
wwv_flow_imp.g_varchar2_table(17311) := '726E20747D676574576869746573706163654174566572746963616C4F66667365742865297B746869732E5F636865636B50656E64696E674368616E67657328292C657C3D303B636F6E737420743D746869732E67657457686974657370616365496E64';
wwv_flow_imp.g_varchar2_table(17312) := '657841744F724166746572566572746963616C6C4F66667365742865293B696628743C302972657475726E206E756C6C3B696628743E3D746869732E6765745768697465737061636573436F756E7428292972657475726E206E756C6C3B636F6E737420';
wwv_flow_imp.g_varchar2_table(17313) := '6E3D746869732E676574566572746963616C4F6666736574466F7257686974657370616365496E6465782874293B6966286E3E652972657475726E206E756C6C3B636F6E737420693D746869732E676574486569676874466F7257686974657370616365';
wwv_flow_imp.g_varchar2_table(17314) := '496E6465782874293B72657475726E7B69643A746869732E6765744964466F7257686974657370616365496E6465782874292C61667465724C696E654E756D6265723A746869732E67657441667465724C696E654E756D626572466F7257686974657370';
wwv_flow_imp.g_varchar2_table(17315) := '616365496E6465782874292C766572746963616C4F66667365743A6E2C6865696768743A697D7D6765745768697465737061636556696577706F72744461746128652C74297B746869732E5F636865636B50656E64696E674368616E67657328292C657C';
wwv_flow_imp.g_varchar2_table(17316) := '3D302C747C3D303B636F6E7374206E3D746869732E67657457686974657370616365496E64657841744F724166746572566572746963616C6C4F66667365742865292C693D746869732E6765745768697465737061636573436F756E7428292D313B6966';
wwv_flow_imp.g_varchar2_table(17317) := '286E3C302972657475726E5B5D3B636F6E7374206F3D5B5D3B666F72286C657420653D6E3B653C3D693B652B2B297B636F6E7374206E3D746869732E676574566572746963616C4F6666736574466F7257686974657370616365496E6465782865292C69';
wwv_flow_imp.g_varchar2_table(17318) := '3D746869732E676574486569676874466F7257686974657370616365496E6465782865293B6966286E3E3D7429627265616B3B6F2E70757368287B69643A746869732E6765744964466F7257686974657370616365496E6465782865292C61667465724C';
wwv_flow_imp.g_varchar2_table(17319) := '696E654E756D6265723A746869732E67657441667465724C696E654E756D626572466F7257686974657370616365496E6465782865292C766572746963616C4F66667365743A6E2C6865696768743A697D297D72657475726E206F7D6765745768697465';
wwv_flow_imp.g_varchar2_table(17320) := '73706163657328297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C746869732E5F6172722E736C6963652830297D6765745768697465737061636573436F756E7428297B72657475726E20746869732E5F6368';
wwv_flow_imp.g_varchar2_table(17321) := '65636B50656E64696E674368616E67657328292C746869732E5F6172722E6C656E6774687D6765744964466F7257686974657370616365496E6465782865297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C65';
wwv_flow_imp.g_varchar2_table(17322) := '7C3D302C746869732E5F6172725B655D2E69647D67657441667465724C696E654E756D626572466F7257686974657370616365496E6465782865297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C657C3D302C';
wwv_flow_imp.g_varchar2_table(17323) := '746869732E5F6172725B655D2E61667465724C696E654E756D6265727D676574486569676874466F7257686974657370616365496E6465782865297B72657475726E20746869732E5F636865636B50656E64696E674368616E67657328292C657C3D302C';
wwv_flow_imp.g_varchar2_table(17324) := '746869732E5F6172725B655D2E6865696768747D7D24462E494E5354414E43455F434F554E543D303B636C6173732055467B636F6E7374727563746F7228652C742C6E2C69297B28657C3D30293C30262628653D30292C28747C3D30293C30262628743D';
wwv_flow_imp.g_varchar2_table(17325) := '30292C286E7C3D30293C302626286E3D30292C28697C3D30293C30262628693D30292C746869732E77696474683D652C746869732E636F6E74656E7457696474683D742C746869732E7363726F6C6C57696474683D4D6174682E6D617828652C74292C74';
wwv_flow_imp.g_varchar2_table(17326) := '6869732E6865696768743D6E2C746869732E636F6E74656E744865696768743D692C746869732E7363726F6C6C4865696768743D4D6174682E6D6178286E2C69297D657175616C732865297B72657475726E20746869732E77696474683D3D3D652E7769';
wwv_flow_imp.g_varchar2_table(17327) := '6474682626746869732E636F6E74656E7457696474683D3D3D652E636F6E74656E7457696474682626746869732E6865696768743D3D3D652E6865696768742626746869732E636F6E74656E744865696768743D3D3D652E636F6E74656E744865696768';
wwv_flow_imp.g_varchar2_table(17328) := '747D7D636C617373204B4620657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6F6E446964436F6E74656E7453697A654368616E67653D746869732E5F7265676973746572286E6577204374292C';
wwv_flow_imp.g_varchar2_table(17329) := '746869732E6F6E446964436F6E74656E7453697A654368616E67653D746869732E5F6F6E446964436F6E74656E7453697A654368616E67652E6576656E742C746869732E5F64696D656E73696F6E733D6E657720554628302C302C302C30292C74686973';
wwv_flow_imp.g_varchar2_table(17330) := '2E5F7363726F6C6C61626C653D746869732E5F7265676973746572286E6577206E54287B666F726365496E746567657256616C7565733A21302C736D6F6F74685363726F6C6C4475726174696F6E3A652C7363686564756C6541744E657874416E696D61';
wwv_flow_imp.g_varchar2_table(17331) := '74696F6E4672616D653A747D29292C746869732E6F6E4469645363726F6C6C3D746869732E5F7363726F6C6C61626C652E6F6E5363726F6C6C7D6765745363726F6C6C61626C6528297B72657475726E20746869732E5F7363726F6C6C61626C657D7365';
wwv_flow_imp.g_varchar2_table(17332) := '74536D6F6F74685363726F6C6C4475726174696F6E2865297B746869732E5F7363726F6C6C61626C652E736574536D6F6F74685363726F6C6C4475726174696F6E2865297D76616C69646174655363726F6C6C506F736974696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(17333) := '6E20746869732E5F7363726F6C6C61626C652E76616C69646174655363726F6C6C506F736974696F6E2865297D6765745363726F6C6C44696D656E73696F6E7328297B72657475726E20746869732E5F64696D656E73696F6E737D7365745363726F6C6C';
wwv_flow_imp.g_varchar2_table(17334) := '44696D656E73696F6E732865297B696628746869732E5F64696D656E73696F6E732E657175616C732865292972657475726E3B636F6E737420743D746869732E5F64696D656E73696F6E733B746869732E5F64696D656E73696F6E733D652C746869732E';
wwv_flow_imp.g_varchar2_table(17335) := '5F7363726F6C6C61626C652E7365745363726F6C6C44696D656E73696F6E73287B77696474683A652E77696474682C7363726F6C6C57696474683A652E7363726F6C6C57696474682C6865696768743A652E6865696768742C7363726F6C6C4865696768';
wwv_flow_imp.g_varchar2_table(17336) := '743A652E7363726F6C6C4865696768747D2C2130293B636F6E7374206E3D742E636F6E74656E745769647468213D3D652E636F6E74656E7457696474682C693D742E636F6E74656E74486569676874213D3D652E636F6E74656E744865696768743B286E';
wwv_flow_imp.g_varchar2_table(17337) := '7C7C69292626746869732E5F6F6E446964436F6E74656E7453697A654368616E67652E66697265286E657720784628742E636F6E74656E7457696474682C742E636F6E74656E744865696768742C652E636F6E74656E7457696474682C652E636F6E7465';
wwv_flow_imp.g_varchar2_table(17338) := '6E7448656967687429297D6765744675747572655363726F6C6C506F736974696F6E28297B72657475726E20746869732E5F7363726F6C6C61626C652E6765744675747572655363726F6C6C506F736974696F6E28297D67657443757272656E74536372';
wwv_flow_imp.g_varchar2_table(17339) := '6F6C6C506F736974696F6E28297B72657475726E20746869732E5F7363726F6C6C61626C652E67657443757272656E745363726F6C6C506F736974696F6E28297D7365745363726F6C6C506F736974696F6E4E6F772865297B746869732E5F7363726F6C';
wwv_flow_imp.g_varchar2_table(17340) := '6C61626C652E7365745363726F6C6C506F736974696F6E4E6F772865297D7365745363726F6C6C506F736974696F6E536D6F6F74682865297B746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E536D6F6F7468286529';
wwv_flow_imp.g_varchar2_table(17341) := '7D68617350656E64696E675363726F6C6C416E696D6174696F6E28297B72657475726E20746869732E5F7363726F6C6C61626C652E68617350656E64696E675363726F6C6C416E696D6174696F6E28297D7D636C61737320474620657874656E6473206C';
wwv_flow_imp.g_varchar2_table(17342) := '747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F636F6E66696775726174696F6E3D653B636F6E737420693D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732C6F3D692E67657428313435292C';
wwv_flow_imp.g_varchar2_table(17343) := '733D692E676574283834293B746869732E5F6C696E65734C61796F75743D6E657720244628742C692E676574283637292C732E746F702C732E626F74746F6D292C746869732E5F6D61784C696E6557696474683D302C746869732E5F6F7665726C617957';
wwv_flow_imp.g_varchar2_table(17344) := '6964676574734D696E57696474683D302C746869732E5F7363726F6C6C61626C653D746869732E5F7265676973746572286E6577204B4628302C6E29292C746869732E5F636F6E666967757265536D6F6F74685363726F6C6C4475726174696F6E28292C';
wwv_flow_imp.g_varchar2_table(17345) := '746869732E5F7363726F6C6C61626C652E7365745363726F6C6C44696D656E73696F6E73286E6577205546286F2E636F6E74656E7457696474682C302C6F2E6865696768742C3029292C746869732E6F6E4469645363726F6C6C3D746869732E5F736372';
wwv_flow_imp.g_varchar2_table(17346) := '6F6C6C61626C652E6F6E4469645363726F6C6C2C746869732E6F6E446964436F6E74656E7453697A654368616E67653D746869732E5F7363726F6C6C61626C652E6F6E446964436F6E74656E7453697A654368616E67652C746869732E5F757064617465';
wwv_flow_imp.g_varchar2_table(17347) := '48656967687428297D646973706F736528297B73757065722E646973706F736528297D6765745363726F6C6C61626C6528297B72657475726E20746869732E5F7363726F6C6C61626C652E6765745363726F6C6C61626C6528297D6F6E4865696768744D';
wwv_flow_imp.g_varchar2_table(17348) := '617962654368616E67656428297B746869732E5F75706461746548656967687428297D5F636F6E666967757265536D6F6F74685363726F6C6C4475726174696F6E28297B746869732E5F7363726F6C6C61626C652E736574536D6F6F74685363726F6C6C';
wwv_flow_imp.g_varchar2_table(17349) := '4475726174696F6E28746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E67657428313134293F3132353A30297D6F6E436F6E66696775726174696F6E4368616E6765642865297B636F6E737420743D746869732E5F636F6E66696775';
wwv_flow_imp.g_varchar2_table(17350) := '726174696F6E2E6F7074696F6E733B696628652E6861734368616E676564283637292626746869732E5F6C696E65734C61796F75742E7365744C696E6548656967687428742E67657428363729292C652E6861734368616E67656428383429297B636F6E';
wwv_flow_imp.g_varchar2_table(17351) := '737420653D742E676574283834293B746869732E5F6C696E65734C61796F75742E73657450616464696E6728652E746F702C652E626F74746F6D297D696628652E6861734368616E6765642831343529297B636F6E737420653D742E6765742831343529';
wwv_flow_imp.g_varchar2_table(17352) := '2C6E3D652E636F6E74656E7457696474682C693D652E6865696768742C6F3D746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292C733D6F2E636F6E74656E7457696474683B746869732E5F7363726F6C6C61';
wwv_flow_imp.g_varchar2_table(17353) := '626C652E7365745363726F6C6C44696D656E73696F6E73286E6577205546286E2C6F2E636F6E74656E7457696474682C692C746869732E5F676574436F6E74656E74486569676874286E2C692C732929297D656C736520746869732E5F75706461746548';
wwv_flow_imp.g_varchar2_table(17354) := '656967687428293B652E6861734368616E67656428313134292626746869732E5F636F6E666967757265536D6F6F74685363726F6C6C4475726174696F6E28297D6F6E466C75736865642865297B746869732E5F6C696E65734C61796F75742E6F6E466C';
wwv_flow_imp.g_varchar2_table(17355) := '75736865642865297D6F6E4C696E657344656C6574656428652C74297B746869732E5F6C696E65734C61796F75742E6F6E4C696E657344656C6574656428652C74297D6F6E4C696E6573496E73657274656428652C74297B746869732E5F6C696E65734C';
wwv_flow_imp.g_varchar2_table(17356) := '61796F75742E6F6E4C696E6573496E73657274656428652C74297D5F676574486F72697A6F6E74616C5363726F6C6C62617248656967687428652C74297B636F6E7374206E3D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E6765';
wwv_flow_imp.g_varchar2_table(17357) := '7428313033293B72657475726E20323D3D3D6E2E686F72697A6F6E74616C7C7C653E3D743F303A6E2E686F72697A6F6E74616C5363726F6C6C62617253697A657D5F676574436F6E74656E7448656967687428652C742C6E297B636F6E737420693D7468';
wwv_flow_imp.g_varchar2_table(17358) := '69732E5F636F6E66696775726174696F6E2E6F7074696F6E733B6C6574206F3D746869732E5F6C696E65734C61796F75742E6765744C696E6573546F74616C48656967687428293B72657475726E20692E67657428313035293F6F2B3D4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(17359) := '7828302C742D692E676574283637292D692E676574283834292E626F74746F6D293A692E67657428313033292E69676E6F7265486F72697A6F6E74616C5363726F6C6C626172496E436F6E74656E744865696768747C7C286F2B3D746869732E5F676574';
wwv_flow_imp.g_varchar2_table(17360) := '486F72697A6F6E74616C5363726F6C6C62617248656967687428652C6E29292C6F7D5F75706461746548656967687428297B636F6E737420653D746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292C743D65';
wwv_flow_imp.g_varchar2_table(17361) := '2E77696474682C6E3D652E6865696768742C693D652E636F6E74656E7457696474683B746869732E5F7363726F6C6C61626C652E7365745363726F6C6C44696D656E73696F6E73286E657720554628742C652E636F6E74656E7457696474682C6E2C7468';
wwv_flow_imp.g_varchar2_table(17362) := '69732E5F676574436F6E74656E7448656967687428742C6E2C692929297D67657443757272656E7456696577706F727428297B636F6E737420653D746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292C743D';
wwv_flow_imp.g_varchar2_table(17363) := '746869732E5F7363726F6C6C61626C652E67657443757272656E745363726F6C6C506F736974696F6E28293B72657475726E206E657720774F28742E7363726F6C6C546F702C742E7363726F6C6C4C6566742C652E77696474682C652E68656967687429';
wwv_flow_imp.g_varchar2_table(17364) := '7D67657446757475726556696577706F727428297B636F6E737420653D746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292C743D746869732E5F7363726F6C6C61626C652E6765744675747572655363726F';
wwv_flow_imp.g_varchar2_table(17365) := '6C6C506F736974696F6E28293B72657475726E206E657720774F28742E7363726F6C6C546F702C742E7363726F6C6C4C6566742C652E77696474682C652E686569676874297D5F636F6D70757465436F6E74656E74576964746828297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(17366) := '3D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732C743D746869732E5F6D61784C696E6557696474682C6E3D652E67657428313436292C693D652E676574283530292C6F3D652E67657428313435293B6966286E2E69735669657770';
wwv_flow_imp.g_varchar2_table(17367) := '6F72745772617070696E67297B636F6E7374206E3D652E676574283733293B72657475726E20743E6F2E636F6E74656E7457696474682B692E7479706963616C48616C667769647468436861726163746572576964746826266E2E656E61626C65642626';
wwv_flow_imp.g_varchar2_table(17368) := '227269676874223D3D3D6E2E736964653F742B6F2E766572746963616C5363726F6C6C62617257696474683A747D7B636F6E7374206E3D652E67657428313034292A692E7479706963616C48616C66776964746843686172616374657257696474682C73';
wwv_flow_imp.g_varchar2_table(17369) := '3D746869732E5F6C696E65734C61796F75742E676574576869746573706163654D696E576964746828293B72657475726E204D6174682E6D617828742B6E2B6F2E766572746963616C5363726F6C6C62617257696474682C732C746869732E5F6F766572';
wwv_flow_imp.g_varchar2_table(17370) := '6C6179576964676574734D696E5769647468297D7D7365744D61784C696E6557696474682865297B746869732E5F6D61784C696E6557696474683D652C746869732E5F757064617465436F6E74656E74576964746828297D7365744F7665726C61795769';
wwv_flow_imp.g_varchar2_table(17371) := '64676574734D696E57696474682865297B746869732E5F6F7665726C6179576964676574734D696E57696474683D652C746869732E5F757064617465436F6E74656E74576964746828297D5F757064617465436F6E74656E74576964746828297B636F6E';
wwv_flow_imp.g_varchar2_table(17372) := '737420653D746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328293B746869732E5F7363726F6C6C61626C652E7365745363726F6C6C44696D656E73696F6E73286E657720554628652E77696474682C74686973';
wwv_flow_imp.g_varchar2_table(17373) := '2E5F636F6D70757465436F6E74656E74576964746828292C652E6865696768742C652E636F6E74656E7448656967687429292C746869732E5F75706461746548656967687428297D73617665537461746528297B636F6E737420653D746869732E5F7363';
wwv_flow_imp.g_varchar2_table(17374) := '726F6C6C61626C652E6765744675747572655363726F6C6C506F736974696F6E28292C743D652E7363726F6C6C546F702C6E3D746869732E5F6C696E65734C61796F75742E6765744C696E654E756D62657241744F724166746572566572746963616C4F';
wwv_flow_imp.g_varchar2_table(17375) := '66667365742874293B72657475726E7B7363726F6C6C546F703A742C7363726F6C6C546F70576974686F7574566965775A6F6E65733A742D746869732E5F6C696E65734C61796F75742E67657457686974657370616365416363756D756C617465644865';
wwv_flow_imp.g_varchar2_table(17376) := '696768744265666F72654C696E654E756D626572286E292C7363726F6C6C4C6566743A652E7363726F6C6C4C6566747D7D6368616E6765576869746573706163652865297B636F6E737420743D746869732E5F6C696E65734C61796F75742E6368616E67';
wwv_flow_imp.g_varchar2_table(17377) := '65576869746573706163652865293B72657475726E20742626746869732E6F6E4865696768744D617962654368616E67656428292C747D676574566572746963616C4F6666736574466F724C696E654E756D62657228652C743D2131297B72657475726E';
wwv_flow_imp.g_varchar2_table(17378) := '20746869732E5F6C696E65734C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228652C74297D676574566572746963616C4F666673657441667465724C696E654E756D62657228652C743D2131297B72657475';
wwv_flow_imp.g_varchar2_table(17379) := '726E20746869732E5F6C696E65734C61796F75742E676574566572746963616C4F666673657441667465724C696E654E756D62657228652C74297D697341667465724C696E65732865297B72657475726E20746869732E5F6C696E65734C61796F75742E';
wwv_flow_imp.g_varchar2_table(17380) := '697341667465724C696E65732865297D6973496E546F7050616464696E672865297B72657475726E20746869732E5F6C696E65734C61796F75742E6973496E546F7050616464696E672865297D6973496E426F74746F6D50616464696E672865297B7265';
wwv_flow_imp.g_varchar2_table(17381) := '7475726E20746869732E5F6C696E65734C61796F75742E6973496E426F74746F6D50616464696E672865297D6765744C696E654E756D6265724174566572746963616C4F66667365742865297B72657475726E20746869732E5F6C696E65734C61796F75';
wwv_flow_imp.g_varchar2_table(17382) := '742E6765744C696E654E756D62657241744F724166746572566572746963616C4F66667365742865297D676574576869746573706163654174566572746963616C4F66667365742865297B72657475726E20746869732E5F6C696E65734C61796F75742E';
wwv_flow_imp.g_varchar2_table(17383) := '676574576869746573706163654174566572746963616C4F66667365742865297D6765744C696E657356696577706F72744461746128297B636F6E737420653D746869732E67657443757272656E7456696577706F727428293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(17384) := '732E5F6C696E65734C61796F75742E6765744C696E657356696577706F72744461746128652E746F702C652E746F702B652E686569676874297D6765744C696E657356696577706F72744461746141745363726F6C6C546F702865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(17385) := '3D746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328293B72657475726E20652B742E6865696768743E742E7363726F6C6C486569676874262628653D742E7363726F6C6C4865696768742D742E686569676874';
wwv_flow_imp.g_varchar2_table(17386) := '292C653C30262628653D30292C746869732E5F6C696E65734C61796F75742E6765744C696E657356696577706F72744461746128652C652B742E686569676874297D6765745768697465737061636556696577706F72744461746128297B636F6E737420';
wwv_flow_imp.g_varchar2_table(17387) := '653D746869732E67657443757272656E7456696577706F727428293B72657475726E20746869732E5F6C696E65734C61796F75742E6765745768697465737061636556696577706F72744461746128652E746F702C652E746F702B652E68656967687429';
wwv_flow_imp.g_varchar2_table(17388) := '7D676574576869746573706163657328297B72657475726E20746869732E5F6C696E65734C61796F75742E676574576869746573706163657328297D676574436F6E74656E74576964746828297B72657475726E20746869732E5F7363726F6C6C61626C';
wwv_flow_imp.g_varchar2_table(17389) := '652E6765745363726F6C6C44696D656E73696F6E7328292E636F6E74656E7457696474687D6765745363726F6C6C576964746828297B72657475726E20746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292E';
wwv_flow_imp.g_varchar2_table(17390) := '7363726F6C6C57696474687D676574436F6E74656E7448656967687428297B72657475726E20746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292E636F6E74656E744865696768747D6765745363726F6C6C';
wwv_flow_imp.g_varchar2_table(17391) := '48656967687428297B72657475726E20746869732E5F7363726F6C6C61626C652E6765745363726F6C6C44696D656E73696F6E7328292E7363726F6C6C4865696768747D67657443757272656E745363726F6C6C4C65667428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(17392) := '69732E5F7363726F6C6C61626C652E67657443757272656E745363726F6C6C506F736974696F6E28292E7363726F6C6C4C6566747D67657443757272656E745363726F6C6C546F7028297B72657475726E20746869732E5F7363726F6C6C61626C652E67';
wwv_flow_imp.g_varchar2_table(17393) := '657443757272656E745363726F6C6C506F736974696F6E28292E7363726F6C6C546F707D76616C69646174655363726F6C6C506F736974696F6E2865297B72657475726E20746869732E5F7363726F6C6C61626C652E76616C69646174655363726F6C6C';
wwv_flow_imp.g_varchar2_table(17394) := '506F736974696F6E2865297D7365745363726F6C6C506F736974696F6E28652C74297B313D3D3D743F746869732E5F7363726F6C6C61626C652E7365745363726F6C6C506F736974696F6E4E6F772865293A746869732E5F7363726F6C6C61626C652E73';
wwv_flow_imp.g_varchar2_table(17395) := '65745363726F6C6C506F736974696F6E536D6F6F74682865297D68617350656E64696E675363726F6C6C416E696D6174696F6E28297B72657475726E20746869732E5F7363726F6C6C61626C652E68617350656E64696E675363726F6C6C416E696D6174';
wwv_flow_imp.g_varchar2_table(17396) := '696F6E28297D64656C74615363726F6C6C4E6F7728652C74297B636F6E7374206E3D746869732E5F7363726F6C6C61626C652E67657443757272656E745363726F6C6C506F736974696F6E28293B746869732E5F7363726F6C6C61626C652E7365745363';
wwv_flow_imp.g_varchar2_table(17397) := '726F6C6C506F736974696F6E4E6F77287B7363726F6C6C4C6566743A6E2E7363726F6C6C4C6566742B652C7363726F6C6C546F703A6E2E7363726F6C6C546F702B747D297D7D636C6173732051467B636F6E7374727563746F7228652C742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(17398) := '297B746869732E656469746F7249643D652C746869732E6D6F64656C3D742C746869732E636F6E66696775726174696F6E3D6E2C746869732E5F6C696E6573436F6C6C656374696F6E3D692C746869732E5F636F6F7264696E61746573436F6E76657274';
wwv_flow_imp.g_varchar2_table(17399) := '65723D6F2C746869732E5F6465636F726174696F6E7343616368653D4F626A6563742E637265617465286E756C6C292C746869732E5F6361636865644D6F64656C4465636F726174696F6E735265736F6C7665723D6E756C6C2C746869732E5F63616368';
wwv_flow_imp.g_varchar2_table(17400) := '65644D6F64656C4465636F726174696F6E735265736F6C7665725669657752616E67653D6E756C6C7D5F636C6561724361636865644D6F64656C4465636F726174696F6E735265736F6C76657228297B746869732E5F6361636865644D6F64656C446563';
wwv_flow_imp.g_varchar2_table(17401) := '6F726174696F6E735265736F6C7665723D6E756C6C2C746869732E5F6361636865644D6F64656C4465636F726174696F6E735265736F6C7665725669657752616E67653D6E756C6C7D646973706F736528297B746869732E5F6465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(17402) := '43616368653D4F626A6563742E637265617465286E756C6C292C746869732E5F636C6561724361636865644D6F64656C4465636F726174696F6E735265736F6C76657228297D726573657428297B746869732E5F6465636F726174696F6E734361636865';
wwv_flow_imp.g_varchar2_table(17403) := '3D4F626A6563742E637265617465286E756C6C292C746869732E5F636C6561724361636865644D6F64656C4465636F726174696F6E735265736F6C76657228297D6F6E4D6F64656C4465636F726174696F6E734368616E67656428297B746869732E5F64';
wwv_flow_imp.g_varchar2_table(17404) := '65636F726174696F6E7343616368653D4F626A6563742E637265617465286E756C6C292C746869732E5F636C6561724361636865644D6F64656C4465636F726174696F6E735265736F6C76657228297D6F6E4C696E654D617070696E674368616E676564';
wwv_flow_imp.g_varchar2_table(17405) := '28297B746869732E5F6465636F726174696F6E7343616368653D4F626A6563742E637265617465286E756C6C292C746869732E5F636C6561724361636865644D6F64656C4465636F726174696F6E735265736F6C76657228297D5F6765744F7243726561';
wwv_flow_imp.g_varchar2_table(17406) := '7465566965774D6F64656C4465636F726174696F6E2865297B636F6E737420743D652E69643B6C6574206E3D746869732E5F6465636F726174696F6E7343616368655B745D3B696628216E297B636F6E737420693D652E72616E67652C6F3D652E6F7074';
wwv_flow_imp.g_varchar2_table(17407) := '696F6E733B6C657420733B6966286F2E697357686F6C654C696E65297B636F6E737420653D746869732E5F636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E';
wwv_flow_imp.g_varchar2_table(17408) := '6577206D6328692E73746172744C696E654E756D6265722C31292C302C21312C2130292C743D746869732E5F636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(17409) := '6E6577206D6328692E656E644C696E654E756D6265722C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E28692E656E644C696E654E756D62657229292C31293B733D6E657720726828652E6C696E654E756D6265722C652E636F6C75';
wwv_flow_imp.g_varchar2_table(17410) := '6D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D656C736520733D746869732E5F636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C52616E6765546F5669657752616E676528692C31293B6E3D6E657720';
wwv_flow_imp.g_varchar2_table(17411) := '4C4F28732C6F292C746869732E5F6465636F726174696F6E7343616368655B745D3D6E7D72657475726E206E7D6765744D696E696D61704465636F726174696F6E73496E52616E67652865297B72657475726E20746869732E5F6765744465636F726174';
wwv_flow_imp.g_varchar2_table(17412) := '696F6E73496E52616E676528652C21302C2131292E6465636F726174696F6E737D6765744465636F726174696F6E7356696577706F7274446174612865297B6C657420743D6E756C6C213D3D746869732E5F6361636865644D6F64656C4465636F726174';
wwv_flow_imp.g_varchar2_table(17413) := '696F6E735265736F6C7665723B72657475726E20743D742626652E657175616C7352616E676528746869732E5F6361636865644D6F64656C4465636F726174696F6E735265736F6C7665725669657752616E6765292C747C7C28746869732E5F63616368';
wwv_flow_imp.g_varchar2_table(17414) := '65644D6F64656C4465636F726174696F6E735265736F6C7665723D746869732E5F6765744465636F726174696F6E73496E52616E676528652C21312C2131292C746869732E5F6361636865644D6F64656C4465636F726174696F6E735265736F6C766572';
wwv_flow_imp.g_varchar2_table(17415) := '5669657752616E67653D65292C746869732E5F6361636865644D6F64656C4465636F726174696F6E735265736F6C7665727D676574496E6C696E654465636F726174696F6E734F6E4C696E6528652C743D21312C6E3D2131297B636F6E737420693D6E65';
wwv_flow_imp.g_varchar2_table(17416) := '7720726828652C746869732E5F6C696E6573436F6C6C656374696F6E2E676574566965774C696E654D696E436F6C756D6E2865292C652C746869732E5F6C696E6573436F6C6C656374696F6E2E676574566965774C696E654D6178436F6C756D6E286529';
wwv_flow_imp.g_varchar2_table(17417) := '293B72657475726E20746869732E5F6765744465636F726174696F6E73496E52616E676528692C742C6E292E696E6C696E654465636F726174696F6E735B305D7D5F6765744465636F726174696F6E73496E52616E676528652C742C6E297B636F6E7374';
wwv_flow_imp.g_varchar2_table(17418) := '20693D746869732E5F6C696E6573436F6C6C656374696F6E2E6765744465636F726174696F6E73496E52616E676528652C746869732E656469746F7249642C524C28746869732E636F6E66696775726174696F6E2E6F7074696F6E73292C742C6E292C6F';
wwv_flow_imp.g_varchar2_table(17419) := '3D652E73746172744C696E654E756D6265722C733D652E656E644C696E654E756D6265722C723D5B5D3B6C657420613D303B636F6E7374206C3D5B5D3B666F72286C657420653D6F3B653C3D733B652B2B296C5B652D6F5D3D5B5D3B666F72286C657420';
wwv_flow_imp.g_varchar2_table(17420) := '653D302C743D692E6C656E6774683B653C743B652B2B297B636F6E737420743D695B655D2C6E3D742E6F7074696F6E733B69662821594628746869732E6D6F64656C2C742929636F6E74696E75653B636F6E737420633D746869732E5F6765744F724372';
wwv_flow_imp.g_varchar2_table(17421) := '65617465566965774D6F64656C4465636F726174696F6E2874292C643D632E72616E67653B696628725B612B2B5D3D632C6E2E696E6C696E65436C6173734E616D65297B636F6E737420653D6E6577206B4F28642C6E2E696E6C696E65436C6173734E61';
wwv_flow_imp.g_varchar2_table(17422) := '6D652C6E2E696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673F333A30292C743D4D6174682E6D6178286F2C642E73746172744C696E654E756D626572292C693D4D6174682E6D696E28732C642E656E644C696E65';
wwv_flow_imp.g_varchar2_table(17423) := '4E756D626572293B666F72286C6574206E3D743B6E3C3D693B6E2B2B296C5B6E2D6F5D2E707573682865297D6966286E2E6265666F7265436F6E74656E74436C6173734E616D6526266F3C3D642E73746172744C696E654E756D6265722626642E737461';
wwv_flow_imp.g_varchar2_table(17424) := '72744C696E654E756D6265723C3D73297B636F6E737420653D6E6577206B4F286E657720726828642E73746172744C696E654E756D6265722C642E7374617274436F6C756D6E2C642E73746172744C696E654E756D6265722C642E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(17425) := '6D6E292C6E2E6265666F7265436F6E74656E74436C6173734E616D652C31293B6C5B642E73746172744C696E654E756D6265722D6F5D2E707573682865297D6966286E2E6166746572436F6E74656E74436C6173734E616D6526266F3C3D642E656E644C';
wwv_flow_imp.g_varchar2_table(17426) := '696E654E756D6265722626642E656E644C696E654E756D6265723C3D73297B636F6E737420653D6E6577206B4F286E657720726828642E656E644C696E654E756D6265722C642E656E64436F6C756D6E2C642E656E644C696E654E756D6265722C642E65';
wwv_flow_imp.g_varchar2_table(17427) := '6E64436F6C756D6E292C6E2E6166746572436F6E74656E74436C6173734E616D652C32293B6C5B642E656E644C696E654E756D6265722D6F5D2E707573682865297D7D72657475726E7B6465636F726174696F6E733A722C696E6C696E654465636F7261';
wwv_flow_imp.g_varchar2_table(17428) := '74696F6E733A6C7D7D7D66756E6374696F6E20594628652C74297B72657475726E2128742E6F7074696F6E732E68696465496E436F6D6D656E74546F6B656E7326265A4628652C74297C7C742E6F7074696F6E732E68696465496E537472696E67546F6B';
wwv_flow_imp.g_varchar2_table(17429) := '656E732626584628652C7429297D66756E6374696F6E205A4628652C74297B72657475726E204A4628652C742E72616E67652C28653D3E313D3D3D6529297D66756E6374696F6E20584628652C74297B72657475726E204A4628652C742E72616E67652C';
wwv_flow_imp.g_varchar2_table(17430) := '28653D3E323D3D3D6529297D66756E6374696F6E204A4628652C742C6E297B666F72286C657420693D742E73746172744C696E654E756D6265723B693C3D742E656E644C696E654E756D6265723B692B2B297B636F6E7374206F3D652E746F6B656E697A';
wwv_flow_imp.g_varchar2_table(17431) := '6174696F6E2E6765744C696E65546F6B656E732869292C733D693D3D3D742E73746172744C696E654E756D6265722C723D693D3D3D742E656E644C696E654E756D6265723B6C657420613D733F6F2E66696E64546F6B656E496E64657841744F66667365';
wwv_flow_imp.g_varchar2_table(17432) := '7428742E7374617274436F6C756D6E2D31293A303B666F72283B613C6F2E676574436F756E742829262621287226266F2E67657453746172744F66667365742861293E742E656E64436F6C756D6E2D31293B297B696628216E286F2E6765745374616E64';
wwv_flow_imp.g_varchar2_table(17433) := '617264546F6B656E54797065286129292972657475726E21313B612B2B7D7D72657475726E21307D66756E6374696F6E20654228652C74297B72657475726E206E756C6C3D3D3D653F743F6E422E494E5354414E43453A69422E494E5354414E43453A6E';
wwv_flow_imp.g_varchar2_table(17434) := '657720744228652C74297D636C6173732074427B636F6E7374727563746F7228652C74297B746869732E5F70726F6A656374696F6E446174613D652C746869732E5F697356697369626C653D747D697356697369626C6528297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(17435) := '732E5F697356697369626C657D73657456697369626C652865297B72657475726E20746869732E5F697356697369626C653D652C746869737D67657450726F6A656374696F6E4461746128297B72657475726E20746869732E5F70726F6A656374696F6E';
wwv_flow_imp.g_varchar2_table(17436) := '446174617D676574566965774C696E65436F756E7428297B72657475726E20746869732E5F697356697369626C653F746869732E5F70726F6A656374696F6E446174612E6765744F75747075744C696E65436F756E7428293A307D676574566965774C69';
wwv_flow_imp.g_varchar2_table(17437) := '6E65436F6E74656E7428652C742C6E297B746869732E5F61737365727456697369626C6528293B636F6E737420693D6E3E303F746869732E5F70726F6A656374696F6E446174612E627265616B4F6666736574735B6E2D315D3A302C6F3D746869732E5F';
wwv_flow_imp.g_varchar2_table(17438) := '70726F6A656374696F6E446174612E627265616B4F6666736574735B6E5D3B6C657420733B6966286E756C6C213D3D746869732E5F70726F6A656374696F6E446174612E696E6A656374696F6E4F666673657473297B636F6E7374206E3D746869732E5F';
wwv_flow_imp.g_varchar2_table(17439) := '70726F6A656374696F6E446174612E696E6A656374696F6E4F6666736574732E6D6170282828652C74293D3E6E657720614328302C302C652B312C746869732E5F70726F6A656374696F6E446174612E696E6A656374696F6E4F7074696F6E735B745D2C';
wwv_flow_imp.g_varchar2_table(17440) := '302929293B733D61432E6170706C79496E6A65637465645465787428652E6765744C696E65436F6E74656E742874292C6E292E737562737472696E6728692C6F297D656C736520733D652E67657456616C7565496E52616E6765287B73746172744C696E';
wwv_flow_imp.g_varchar2_table(17441) := '654E756D6265723A742C7374617274436F6C756D6E3A692B312C656E644C696E654E756D6265723A742C656E64436F6C756D6E3A6F2B317D293B72657475726E206E3E30262628733D734228746869732E5F70726F6A656374696F6E446174612E777261';
wwv_flow_imp.g_varchar2_table(17442) := '7070656454657874496E64656E744C656E677468292B73292C737D676574566965774C696E654C656E67746828652C742C6E297B72657475726E20746869732E5F61737365727456697369626C6528292C746869732E5F70726F6A656374696F6E446174';
wwv_flow_imp.g_varchar2_table(17443) := '612E6765744C696E654C656E677468286E297D676574566965774C696E654D696E436F6C756D6E28652C742C6E297B72657475726E20746869732E5F61737365727456697369626C6528292C746869732E5F70726F6A656374696F6E446174612E676574';
wwv_flow_imp.g_varchar2_table(17444) := '4D696E4F75747075744F6666736574286E292B317D676574566965774C696E654D6178436F6C756D6E28652C742C6E297B72657475726E20746869732E5F61737365727456697369626C6528292C746869732E5F70726F6A656374696F6E446174612E67';
wwv_flow_imp.g_varchar2_table(17445) := '65744D61784F75747075744F6666736574286E292B317D676574566965774C696E654461746128652C742C6E297B636F6E737420693D6E65772041727261793B72657475726E20746869732E676574566965774C696E65734461746128652C742C6E2C31';
wwv_flow_imp.g_varchar2_table(17446) := '2C302C5B21305D2C69292C695B305D7D676574566965774C696E65734461746128652C742C6E2C692C6F2C732C72297B746869732E5F61737365727456697369626C6528293B636F6E737420613D746869732E5F70726F6A656374696F6E446174612C6C';
wwv_flow_imp.g_varchar2_table(17447) := '3D612E696E6A656374696F6E4F6666736574732C633D612E696E6A656374696F6E4F7074696F6E733B6C657420642C683D6E756C6C3B6966286C297B683D5B5D3B6C657420653D302C743D303B666F72286C6574206E3D303B6E3C612E6765744F757470';
wwv_flow_imp.g_varchar2_table(17448) := '75744C696E65436F756E7428293B6E2B2B297B636F6E737420693D6E65772041727261793B685B6E5D3D693B636F6E7374206F3D6E3E303F612E627265616B4F6666736574735B6E2D315D3A302C733D612E627265616B4F6666736574735B6E5D3B666F';
wwv_flow_imp.g_varchar2_table(17449) := '72283B743C6C2E6C656E6774683B297B636F6E737420723D635B745D2E636F6E74656E742E6C656E6774682C643D6C5B745D2B652C683D642B723B696628643E7329627265616B3B6966286F3C68297B636F6E737420653D635B745D3B696628652E696E';
wwv_flow_imp.g_varchar2_table(17450) := '6C696E65436C6173734E616D65297B636F6E737420743D6E3E303F612E7772617070656454657874496E64656E744C656E6774683A302C723D742B4D6174682E6D617828642D6F2C30292C6C3D742B4D6174682E6D696E28682D6F2C732D6F293B72213D';
wwv_flow_imp.g_varchar2_table(17451) := '3D6C2626692E70757368286E657720454F28722C6C2C652E696E6C696E65436C6173734E616D652C652E696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E6729297D7D6966282128683C3D732929627265616B3B652B';
wwv_flow_imp.g_varchar2_table(17452) := '3D722C742B2B7D7D7D643D6C3F652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732874292E77697468496E736572746564286C2E6D6170282828652C74293D3E287B6F66667365743A652C746578743A635B745D2E636F6E74656E74';
wwv_flow_imp.g_varchar2_table(17453) := '2C746F6B656E4D657461646174613A57772E64656661756C74546F6B656E4D657461646174617D292929293A652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732874293B666F72286C657420653D6E3B653C6E2B693B652B2B297B63';
wwv_flow_imp.g_varchar2_table(17454) := '6F6E737420743D6F2B652D6E3B735B745D3F725B745D3D746869732E5F676574566965774C696E654461746128642C683F685B655D3A6E756C6C2C65293A725B745D3D6E756C6C7D7D5F676574566965774C696E654461746128652C742C6E297B746869';
wwv_flow_imp.g_varchar2_table(17455) := '732E5F61737365727456697369626C6528293B636F6E737420693D746869732E5F70726F6A656374696F6E446174612C6F3D6E3E303F692E7772617070656454657874496E64656E744C656E6774683A302C733D6E3E303F692E627265616B4F66667365';
wwv_flow_imp.g_varchar2_table(17456) := '74735B6E2D315D3A302C723D692E627265616B4F6666736574735B6E5D2C613D652E736C696365416E64496E666C61746528732C722C6F293B6C6574206C3D612E6765744C696E65436F6E74656E7428293B6E3E302626286C3D734228692E7772617070';
wwv_flow_imp.g_varchar2_table(17457) := '656454657874496E64656E744C656E677468292B6C293B636F6E737420633D746869732E5F70726F6A656374696F6E446174612E6765744D696E4F75747075744F6666736574286E292B312C643D6C2E6C656E6774682B312C683D6E2B313C746869732E';
wwv_flow_imp.g_varchar2_table(17458) := '676574566965774C696E65436F756E7428292C753D303D3D3D6E3F303A692E627265616B4F66667365747356697369626C65436F6C756D6E5B6E2D315D3B72657475726E206E657720534F286C2C682C632C642C752C612C74297D6765744D6F64656C43';
wwv_flow_imp.g_varchar2_table(17459) := '6F6C756D6E4F6656696577506F736974696F6E28652C74297B72657475726E20746869732E5F61737365727456697369626C6528292C746869732E5F70726F6A656374696F6E446174612E7472616E736C617465546F496E7075744F666673657428652C';
wwv_flow_imp.g_varchar2_table(17460) := '742D31292B317D67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28652C742C6E3D32297B72657475726E20746869732E5F61737365727456697369626C6528292C746869732E5F70726F6A656374696F6E446174612E747261';
wwv_flow_imp.g_varchar2_table(17461) := '6E736C617465546F4F7574707574506F736974696F6E28742D312C6E292E746F506F736974696F6E2865297D676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297B72657475726E20746869732E5F6173736572';
wwv_flow_imp.g_varchar2_table(17462) := '7456697369626C6528292C652B746869732E5F70726F6A656374696F6E446174612E7472616E736C617465546F4F7574707574506F736974696F6E28742D31292E6F75747075744C696E65496E6465787D6E6F726D616C697A65506F736974696F6E2865';
wwv_flow_imp.g_varchar2_table(17463) := '2C742C6E297B636F6E737420693D742E6C696E654E756D6265722D653B72657475726E20746869732E5F70726F6A656374696F6E446174612E6E6F726D616C697A654F7574707574506F736974696F6E28652C742E636F6C756D6E2D312C6E292E746F50';
wwv_flow_imp.g_varchar2_table(17464) := '6F736974696F6E2869297D676574496E6A656374656454657874417428652C74297B72657475726E20746869732E5F70726F6A656374696F6E446174612E676574496E6A65637465645465787428652C742D31297D5F61737365727456697369626C6528';
wwv_flow_imp.g_varchar2_table(17465) := '297B69662821746869732E5F697356697369626C65297468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D7D636C617373206E427B636F6E7374727563746F7228297B7D697356697369626C6528297B72657475726E2130';
wwv_flow_imp.g_varchar2_table(17466) := '7D73657456697369626C652865297B72657475726E20653F746869733A69422E494E5354414E43457D67657450726F6A656374696F6E4461746128297B72657475726E206E756C6C7D676574566965774C696E65436F756E7428297B72657475726E2031';
wwv_flow_imp.g_varchar2_table(17467) := '7D676574566965774C696E65436F6E74656E7428652C742C6E297B72657475726E20652E6765744C696E65436F6E74656E742874297D676574566965774C696E654C656E67746828652C742C6E297B72657475726E20652E6765744C696E654C656E6774';
wwv_flow_imp.g_varchar2_table(17468) := '682874297D676574566965774C696E654D696E436F6C756D6E28652C742C6E297B72657475726E20652E6765744C696E654D696E436F6C756D6E2874297D676574566965774C696E654D6178436F6C756D6E28652C742C6E297B72657475726E20652E67';
wwv_flow_imp.g_varchar2_table(17469) := '65744C696E654D6178436F6C756D6E2874297D676574566965774C696E654461746128652C742C6E297B636F6E737420693D652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732874292C6F3D692E6765744C696E65436F6E74656E74';
wwv_flow_imp.g_varchar2_table(17470) := '28293B72657475726E206E657720534F286F2C21312C312C6F2E6C656E6774682B312C302C692E696E666C61746528292C6E756C6C297D676574566965774C696E65734461746128652C742C6E2C692C6F2C732C72297B735B6F5D3F725B6F5D3D746869';
wwv_flow_imp.g_varchar2_table(17471) := '732E676574566965774C696E654461746128652C742C30293A725B6F5D3D6E756C6C7D6765744D6F64656C436F6C756D6E4F6656696577506F736974696F6E28652C74297B72657475726E20747D67657456696577506F736974696F6E4F664D6F64656C';
wwv_flow_imp.g_varchar2_table(17472) := '506F736974696F6E28652C74297B72657475726E206E6577206D6328652C74297D676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297B72657475726E20657D6E6F726D616C697A65506F736974696F6E28652C';
wwv_flow_imp.g_varchar2_table(17473) := '742C6E297B72657475726E20747D676574496E6A656374656454657874417428652C74297B72657475726E206E756C6C7D7D6E422E494E5354414E43453D6E6577206E423B636C6173732069427B636F6E7374727563746F7228297B7D69735669736962';
wwv_flow_imp.g_varchar2_table(17474) := '6C6528297B72657475726E21317D73657456697369626C652865297B72657475726E20653F6E422E494E5354414E43453A746869737D67657450726F6A656374696F6E4461746128297B72657475726E206E756C6C7D676574566965774C696E65436F75';
wwv_flow_imp.g_varchar2_table(17475) := '6E7428297B72657475726E20307D676574566965774C696E65436F6E74656E7428652C742C6E297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D676574566965774C696E654C656E67746828652C742C6E297B7468';
wwv_flow_imp.g_varchar2_table(17476) := '726F77206E6577204572726F7228224E6F7420737570706F7274656422297D676574566965774C696E654D696E436F6C756D6E28652C742C6E297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D676574566965774C';
wwv_flow_imp.g_varchar2_table(17477) := '696E654D6178436F6C756D6E28652C742C6E297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D676574566965774C696E654461746128652C742C6E297B7468726F77206E6577204572726F7228224E6F7420737570';
wwv_flow_imp.g_varchar2_table(17478) := '706F7274656422297D676574566965774C696E65734461746128652C742C6E2C692C6F2C732C72297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D6765744D6F64656C436F6C756D6E4F6656696577506F73697469';
wwv_flow_imp.g_varchar2_table(17479) := '6F6E28652C74297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28652C74297B7468726F77206E6577204572726F7228224E6F74207375';
wwv_flow_imp.g_varchar2_table(17480) := '70706F7274656422297D676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D6E6F726D616C697A65506F736974696F6E2865';
wwv_flow_imp.g_varchar2_table(17481) := '2C742C6E297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D676574496E6A656374656454657874417428652C74297B7468726F77206E6577204572726F7228224E6F7420737570706F7274656422297D7D69422E49';
wwv_flow_imp.g_varchar2_table(17482) := '4E5354414E43453D6E65772069423B636F6E7374206F423D5B22225D3B66756E6374696F6E2073422865297B696628653E3D6F422E6C656E67746829666F72286C657420743D313B743C3D653B742B2B296F425B745D3D72422874293B72657475726E20';
wwv_flow_imp.g_varchar2_table(17483) := '6F425B655D7D66756E6374696F6E2072422865297B72657475726E206E657720417272617928652B31292E6A6F696E28222022297D636C6173732061427B636F6E7374727563746F722865297B746869732E76616C7565733D652C746869732E70726566';
wwv_flow_imp.g_varchar2_table(17484) := '697853756D3D6E65772055696E743332417272617928652E6C656E677468292C746869732E70726566697853756D56616C6964496E6465783D6E657720496E74333241727261792831292C746869732E70726566697853756D56616C6964496E6465785B';
wwv_flow_imp.g_varchar2_table(17485) := '305D3D2D317D696E7365727456616C75657328652C74297B653D24792865293B636F6E7374206E3D746869732E76616C7565732C693D746869732E70726566697853756D2C6F3D742E6C656E6774683B72657475726E2030213D3D6F262628746869732E';
wwv_flow_imp.g_varchar2_table(17486) := '76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682B6F292C746869732E76616C7565732E736574286E2E737562617272617928302C65292C30292C746869732E76616C7565732E736574286E2E73756261727261792865292C';
wwv_flow_imp.g_varchar2_table(17487) := '652B6F292C746869732E76616C7565732E73657428742C65292C652D313C746869732E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C746869732E7072';
wwv_flow_imp.g_varchar2_table(17488) := '6566697853756D3D6E65772055696E743332417272617928746869732E76616C7565732E6C656E677468292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566697853756D2E73657428692E737562';
wwv_flow_imp.g_varchar2_table(17489) := '617272617928302C746869732E70726566697853756D56616C6964496E6465785B305D2B3129292C2130297D73657456616C756528652C74297B72657475726E20653D24792865292C743D24792874292C746869732E76616C7565735B655D213D3D7426';
wwv_flow_imp.g_varchar2_table(17490) := '2628746869732E76616C7565735B655D3D742C652D313C746869732E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C2130297D72656D6F766556616C75';
wwv_flow_imp.g_varchar2_table(17491) := '657328652C74297B653D24792865292C743D24792874293B636F6E7374206E3D746869732E76616C7565732C693D746869732E70726566697853756D3B696628653E3D6E2E6C656E6774682972657475726E21313B636F6E7374206F3D6E2E6C656E6774';
wwv_flow_imp.g_varchar2_table(17492) := '682D653B72657475726E20743E3D6F262628743D6F292C30213D3D74262628746869732E76616C7565733D6E65772055696E7433324172726179286E2E6C656E6774682D74292C746869732E76616C7565732E736574286E2E737562617272617928302C';
wwv_flow_imp.g_varchar2_table(17493) := '65292C30292C746869732E76616C7565732E736574286E2E737562617272617928652B74292C65292C746869732E70726566697853756D3D6E65772055696E743332417272617928746869732E76616C7565732E6C656E677468292C652D313C74686973';
wwv_flow_imp.g_varchar2_table(17494) := '2E70726566697853756D56616C6964496E6465785B305D262628746869732E70726566697853756D56616C6964496E6465785B305D3D652D31292C746869732E70726566697853756D56616C6964496E6465785B305D3E3D302626746869732E70726566';
wwv_flow_imp.g_varchar2_table(17495) := '697853756D2E73657428692E737562617272617928302C746869732E70726566697853756D56616C6964496E6465785B305D2B3129292C2130297D676574546F74616C53756D28297B72657475726E20303D3D3D746869732E76616C7565732E6C656E67';
wwv_flow_imp.g_varchar2_table(17496) := '74683F303A746869732E5F67657450726566697853756D28746869732E76616C7565732E6C656E6774682D31297D67657450726566697853756D2865297B72657475726E20653C303F303A28653D24792865292C746869732E5F67657450726566697853';
wwv_flow_imp.g_varchar2_table(17497) := '756D286529297D5F67657450726566697853756D2865297B696628653C3D746869732E70726566697853756D56616C6964496E6465785B305D2972657475726E20746869732E70726566697853756D5B655D3B6C657420743D746869732E707265666978';
wwv_flow_imp.g_varchar2_table(17498) := '53756D56616C6964496E6465785B305D2B313B303D3D3D74262628746869732E70726566697853756D5B305D3D746869732E76616C7565735B305D2C742B2B292C653E3D746869732E76616C7565732E6C656E677468262628653D746869732E76616C75';
wwv_flow_imp.g_varchar2_table(17499) := '65732E6C656E6774682D31293B666F72286C6574206E3D743B6E3C3D653B6E2B2B29746869732E70726566697853756D5B6E5D3D746869732E70726566697853756D5B6E2D315D2B746869732E76616C7565735B6E5D3B72657475726E20746869732E70';
wwv_flow_imp.g_varchar2_table(17500) := '726566697853756D56616C6964496E6465785B305D3D4D6174682E6D617828746869732E70726566697853756D56616C6964496E6465785B305D2C65292C746869732E70726566697853756D5B655D7D676574496E6465784F662865297B653D4D617468';
wwv_flow_imp.g_varchar2_table(17501) := '2E666C6F6F722865292C746869732E676574546F74616C53756D28293B6C657420743D302C6E3D746869732E76616C7565732E6C656E6774682D312C693D302C6F3D302C733D303B666F72283B743C3D6E3B29696628693D742B286E2D74292F327C302C';
wwv_flow_imp.g_varchar2_table(17502) := '6F3D746869732E70726566697853756D5B695D2C733D6F2D746869732E76616C7565735B695D2C653C73296E3D692D313B656C73657B6966282128653E3D6F2929627265616B3B743D692B317D72657475726E206E657720634228692C652D73297D7D63';
wwv_flow_imp.g_varchar2_table(17503) := '6C617373206C427B636F6E7374727563746F722865297B746869732E5F76616C7565733D652C746869732E5F697356616C69643D21312C746869732E5F76616C6964456E64496E6465783D2D312C746869732E5F70726566697853756D3D5B5D2C746869';
wwv_flow_imp.g_varchar2_table(17504) := '732E5F696E646578427953756D3D5B5D7D676574546F74616C53756D28297B72657475726E20746869732E5F656E7375726556616C696428292C746869732E5F696E646578427953756D2E6C656E6774687D67657450726566697853756D2865297B7265';
wwv_flow_imp.g_varchar2_table(17505) := '7475726E20746869732E5F656E7375726556616C696428292C303D3D3D653F303A746869732E5F70726566697853756D5B652D315D7D676574496E6465784F662865297B746869732E5F656E7375726556616C696428293B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(17506) := '2E5F696E646578427953756D5B655D2C6E3D743E303F746869732E5F70726566697853756D5B742D315D3A303B72657475726E206E657720634228742C652D6E297D72656D6F766556616C75657328652C74297B746869732E5F76616C7565732E73706C';
wwv_flow_imp.g_varchar2_table(17507) := '69636528652C74292C746869732E5F696E76616C69646174652865297D696E7365727456616C75657328652C74297B746869732E5F76616C7565733D4B6828746869732E5F76616C7565732C652C74292C746869732E5F696E76616C6964617465286529';
wwv_flow_imp.g_varchar2_table(17508) := '7D5F696E76616C69646174652865297B746869732E5F697356616C69643D21312C746869732E5F76616C6964456E64496E6465783D4D6174682E6D696E28746869732E5F76616C6964456E64496E6465782C652D31297D5F656E7375726556616C696428';
wwv_flow_imp.g_varchar2_table(17509) := '297B69662821746869732E5F697356616C6964297B666F72286C657420653D746869732E5F76616C6964456E64496E6465782B312C743D746869732E5F76616C7565732E6C656E6774683B653C743B652B2B297B636F6E737420743D746869732E5F7661';
wwv_flow_imp.g_varchar2_table(17510) := '6C7565735B655D2C6E3D653E303F746869732E5F70726566697853756D5B652D315D3A303B746869732E5F70726566697853756D5B655D3D6E2B743B666F72286C657420693D303B693C743B692B2B29746869732E5F696E646578427953756D5B6E2B69';
wwv_flow_imp.g_varchar2_table(17511) := '5D3D657D746869732E5F70726566697853756D2E6C656E6774683D746869732E5F76616C7565732E6C656E6774682C746869732E5F696E646578427953756D2E6C656E6774683D746869732E5F70726566697853756D5B746869732E5F70726566697853';
wwv_flow_imp.g_varchar2_table(17512) := '756D2E6C656E6774682D315D2C746869732E5F697356616C69643D21302C746869732E5F76616C6964456E64496E6465783D746869732E5F76616C7565732E6C656E6774682D317D7D73657456616C756528652C74297B746869732E5F76616C7565735B';
wwv_flow_imp.g_varchar2_table(17513) := '655D213D3D74262628746869732E5F76616C7565735B655D3D742C746869732E5F696E76616C6964617465286529297D7D636C6173732063427B636F6E7374727563746F7228652C74297B746869732E696E6465783D652C746869732E72656D61696E64';
wwv_flow_imp.g_varchar2_table(17514) := '65723D742C746869732E5F70726566697853756D496E6465784F66526573756C744272616E643D766F696420302C746869732E696E6465783D652C746869732E72656D61696E6465723D747D7D636C6173732064427B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(17515) := '742C6E2C692C6F2C732C722C612C6C2C63297B746869732E5F656469746F7249643D652C746869732E6D6F64656C3D742C746869732E5F76616C69644D6F64656C56657273696F6E49643D2D312C746869732E5F646F6D4C696E65427265616B73436F6D';
wwv_flow_imp.g_varchar2_table(17516) := '7075746572466163746F72793D6E2C746869732E5F6D6F6E6F73706163654C696E65427265616B73436F6D7075746572466163746F72793D692C746869732E666F6E74496E666F3D6F2C746869732E74616253697A653D732C746869732E777261707069';
wwv_flow_imp.g_varchar2_table(17517) := '6E6753747261746567793D722C746869732E7772617070696E67436F6C756D6E3D612C746869732E7772617070696E67496E64656E743D6C2C746869732E776F7264427265616B3D632C746869732E5F636F6E7374727563744C696E65732821302C6E75';
wwv_flow_imp.g_varchar2_table(17518) := '6C6C297D646973706F736528297B746869732E68696464656E41726561734465636F726174696F6E4964733D746869732E6D6F64656C2E64656C74614465636F726174696F6E7328746869732E68696464656E41726561734465636F726174696F6E4964';
wwv_flow_imp.g_varchar2_table(17519) := '732C5B5D297D637265617465436F6F7264696E61746573436F6E76657274657228297B72657475726E206E65772070422874686973297D5F636F6E7374727563744C696E657328652C74297B746869732E6D6F64656C4C696E6550726F6A656374696F6E';
wwv_flow_imp.g_varchar2_table(17520) := '733D5B5D2C65262628746869732E68696464656E41726561734465636F726174696F6E4964733D746869732E6D6F64656C2E64656C74614465636F726174696F6E7328746869732E68696464656E41726561734465636F726174696F6E4964732C5B5D29';
wwv_flow_imp.g_varchar2_table(17521) := '293B636F6E7374206E3D746869732E6D6F64656C2E6765744C696E6573436F6E74656E7428292C693D746869732E6D6F64656C2E676574496E6A6563746564546578744465636F726174696F6E7328746869732E5F656469746F724964292C6F3D6E2E6C';
wwv_flow_imp.g_varchar2_table(17522) := '656E6774682C733D746869732E6372656174654C696E65427265616B73436F6D707574657228292C723D6E6577206F752861432E66726F6D4465636F726174696F6E73286929293B666F72286C657420653D303B653C6F3B652B2B297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(17523) := '3D722E74616B655768696C652828743D3E742E6C696E654E756D6265723D3D3D652B3129293B732E61646452657175657374286E5B655D2C692C743F745B655D3A6E756C6C297D636F6E737420613D732E66696E616C697A6528292C6C3D5B5D2C633D74';
wwv_flow_imp.g_varchar2_table(17524) := '6869732E68696464656E41726561734465636F726174696F6E4964732E6D61702828653D3E746869732E6D6F64656C2E6765744465636F726174696F6E52616E676528652929292E736F72742872682E636F6D7061726552616E6765735573696E675374';
wwv_flow_imp.g_varchar2_table(17525) := '61727473293B6C657420643D312C683D302C753D2D312C703D752B313C632E6C656E6774683F682B313A6F2B323B666F72286C657420653D303B653C6F3B652B2B297B636F6E737420743D652B313B743D3D3D70262628752B2B2C643D635B755D2E7374';
wwv_flow_imp.g_varchar2_table(17526) := '6172744C696E654E756D6265722C683D635B755D2E656E644C696E654E756D6265722C703D752B313C632E6C656E6774683F682B313A6F2B32293B636F6E7374206E3D743E3D642626743C3D682C693D654228615B655D2C216E293B6C5B655D3D692E67';
wwv_flow_imp.g_varchar2_table(17527) := '6574566965774C696E65436F756E7428292C746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D3D697D746869732E5F76616C69644D6F64656C56657273696F6E49643D746869732E6D6F64656C2E67657456657273696F6E49642829';
wwv_flow_imp.g_varchar2_table(17528) := '2C746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74733D6E6577206C42286C297D67657448696464656E417265617328297B72657475726E20746869732E68696464656E41726561734465636F726174696F6E4964732E6D';
wwv_flow_imp.g_varchar2_table(17529) := '61702828653D3E746869732E6D6F64656C2E6765744465636F726174696F6E52616E676528652929297D73657448696464656E41726561732865297B636F6E737420743D66756E6374696F6E2865297B696628303D3D3D652E6C656E6774682972657475';
wwv_flow_imp.g_varchar2_table(17530) := '726E5B5D3B636F6E737420743D652E736C69636528293B742E736F72742872682E636F6D7061726552616E6765735573696E67537461727473293B636F6E7374206E3D5B5D3B6C657420693D745B305D2E73746172744C696E654E756D6265722C6F3D74';
wwv_flow_imp.g_varchar2_table(17531) := '5B305D2E656E644C696E654E756D6265723B666F72286C657420653D312C733D742E6C656E6774683B653C733B652B2B297B636F6E737420733D745B655D3B732E73746172744C696E654E756D6265723E6F2B313F286E2E70757368286E657720726828';
wwv_flow_imp.g_varchar2_table(17532) := '692C312C6F2C3129292C693D732E73746172744C696E654E756D6265722C6F3D732E656E644C696E654E756D626572293A732E656E644C696E654E756D6265723E6F2626286F3D732E656E644C696E654E756D626572297D72657475726E206E2E707573';
wwv_flow_imp.g_varchar2_table(17533) := '68286E657720726828692C312C6F2C3129292C6E7D28652E6D61702828653D3E746869732E6D6F64656C2E76616C696461746552616E67652865292929292C6E3D746869732E68696464656E41726561734465636F726174696F6E4964732E6D61702828';
wwv_flow_imp.g_varchar2_table(17534) := '653D3E746869732E6D6F64656C2E6765744465636F726174696F6E52616E676528652929292E736F72742872682E636F6D7061726552616E6765735573696E67537461727473293B696628742E6C656E6774683D3D3D6E2E6C656E677468297B6C657420';
wwv_flow_imp.g_varchar2_table(17535) := '653D21313B666F72286C657420693D303B693C742E6C656E6774683B692B2B2969662821745B695D2E657175616C7352616E6765286E5B695D29297B653D21303B627265616B7D69662821652972657475726E21317D636F6E737420693D742E6D617028';
wwv_flow_imp.g_varchar2_table(17536) := '28653D3E287B72616E67653A652C6F7074696F6E733A4F432E454D5054597D2929293B746869732E68696464656E41726561734465636F726174696F6E4964733D746869732E6D6F64656C2E64656C74614465636F726174696F6E7328746869732E6869';
wwv_flow_imp.g_varchar2_table(17537) := '6464656E41726561734465636F726174696F6E4964732C69293B636F6E7374206F3D743B6C657420733D312C723D302C613D2D312C6C3D612B313C6F2E6C656E6774683F722B313A746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C65';
wwv_flow_imp.g_varchar2_table(17538) := '6E6774682B322C633D21313B666F72286C657420653D303B653C746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C656E6774683B652B2B297B636F6E737420743D652B313B743D3D3D6C262628612B2B2C733D6F5B615D2E7374617274';
wwv_flow_imp.g_varchar2_table(17539) := '4C696E654E756D6265722C723D6F5B615D2E656E644C696E654E756D6265722C6C3D612B313C6F2E6C656E6774683F722B313A746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C656E6774682B32293B6C6574206E3D21313B69662874';
wwv_flow_imp.g_varchar2_table(17540) := '3E3D732626743C3D723F746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D2E697356697369626C652829262628746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D3D746869732E6D6F64656C4C696E6550726F6A';
wwv_flow_imp.g_varchar2_table(17541) := '656374696F6E735B655D2E73657456697369626C65282131292C6E3D2130293A28633D21302C746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D2E697356697369626C6528297C7C28746869732E6D6F64656C4C696E6550726F6A65';
wwv_flow_imp.g_varchar2_table(17542) := '6374696F6E735B655D3D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D2E73657456697369626C65282130292C6E3D213029292C6E297B636F6E737420743D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D';
wwv_flow_imp.g_varchar2_table(17543) := '2E676574566965774C696E65436F756E7428293B746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E73657456616C756528652C74297D7D72657475726E20637C7C746869732E73657448696464656E4172656173285B';
wwv_flow_imp.g_varchar2_table(17544) := '5D292C21307D6D6F64656C506F736974696F6E497356697369626C6528652C74297B72657475726E2128653C317C7C653E746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C656E677468292626746869732E6D6F64656C4C696E655072';
wwv_flow_imp.g_varchar2_table(17545) := '6F6A656374696F6E735B652D315D2E697356697369626C6528297D6765744D6F64656C4C696E65566965774C696E65436F756E742865297B72657475726E20653C317C7C653E746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C656E67';
wwv_flow_imp.g_varchar2_table(17546) := '74683F313A746869732E6D6F64656C4C696E6550726F6A656374696F6E735B652D315D2E676574566965774C696E65436F756E7428297D73657454616253697A652865297B72657475726E20746869732E74616253697A65213D3D65262628746869732E';
wwv_flow_imp.g_varchar2_table(17547) := '74616253697A653D652C746869732E5F636F6E7374727563744C696E65732821312C6E756C6C292C2130297D7365745772617070696E6753657474696E677328652C742C6E2C692C6F297B636F6E737420733D746869732E666F6E74496E666F2E657175';
wwv_flow_imp.g_varchar2_table(17548) := '616C732865292C723D746869732E7772617070696E6753747261746567793D3D3D742C613D746869732E7772617070696E67436F6C756D6E3D3D3D6E2C6C3D746869732E7772617070696E67496E64656E743D3D3D692C633D746869732E776F72644272';
wwv_flow_imp.g_varchar2_table(17549) := '65616B3D3D3D6F3B6966287326267226266126266C2626632972657475726E21313B636F6E737420643D732626722626216126266C2626633B746869732E666F6E74496E666F3D652C746869732E7772617070696E6753747261746567793D742C746869';
wwv_flow_imp.g_varchar2_table(17550) := '732E7772617070696E67436F6C756D6E3D6E2C746869732E7772617070696E67496E64656E743D692C746869732E776F7264427265616B3D6F3B6C657420683D6E756C6C3B69662864297B683D5B5D3B666F72286C657420653D302C743D746869732E6D';
wwv_flow_imp.g_varchar2_table(17551) := '6F64656C4C696E6550726F6A656374696F6E732E6C656E6774683B653C743B652B2B29685B655D3D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D2E67657450726F6A656374696F6E4461746128297D72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(17552) := '2E5F636F6E7374727563744C696E65732821312C68292C21307D6372656174654C696E65427265616B73436F6D707574657228297B72657475726E2822616476616E636564223D3D3D746869732E7772617070696E6753747261746567793F746869732E';
wwv_flow_imp.g_varchar2_table(17553) := '5F646F6D4C696E65427265616B73436F6D7075746572466163746F72793A746869732E5F6D6F6E6F73706163654C696E65427265616B73436F6D7075746572466163746F7279292E6372656174654C696E65427265616B73436F6D707574657228746869';
wwv_flow_imp.g_varchar2_table(17554) := '732E666F6E74496E666F2C746869732E74616253697A652C746869732E7772617070696E67436F6C756D6E2C746869732E7772617070696E67496E64656E742C746869732E776F7264427265616B297D6F6E4D6F64656C466C757368656428297B746869';
wwv_flow_imp.g_varchar2_table(17555) := '732E5F636F6E7374727563744C696E65732821302C6E756C6C297D6F6E4D6F64656C4C696E657344656C6574656428652C742C6E297B69662821657C7C653C3D746869732E5F76616C69644D6F64656C56657273696F6E49642972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(17556) := '6C3B636F6E737420693D313D3D3D743F313A746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D28742D31292B312C6F3D746869732E70726F6A65637465644D6F64656C4C696E654C696E';
wwv_flow_imp.g_varchar2_table(17557) := '65436F756E74732E67657450726566697853756D286E293B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E732E73706C69636528742D312C6E2D742B31292C746869732E70726F6A65637465644D6F64656C4C696E654C69';
wwv_flow_imp.g_varchar2_table(17558) := '6E65436F756E74732E72656D6F766556616C75657328742D312C6E2D742B31292C6E657720674628692C6F297D6F6E4D6F64656C4C696E6573496E73657274656428652C742C6E2C69297B69662821657C7C653C3D746869732E5F76616C69644D6F6465';
wwv_flow_imp.g_varchar2_table(17559) := '6C56657273696F6E49642972657475726E206E756C6C3B636F6E7374206F3D743E32262621746869732E6D6F64656C4C696E6550726F6A656374696F6E735B742D325D2E697356697369626C6528292C733D313D3D3D743F313A746869732E70726F6A65';
wwv_flow_imp.g_varchar2_table(17560) := '637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D28742D31292B313B6C657420723D303B636F6E737420613D5B5D2C6C3D5B5D3B666F72286C657420653D302C743D692E6C656E6774683B653C743B652B2B297B';
wwv_flow_imp.g_varchar2_table(17561) := '636F6E737420743D654228695B655D2C216F293B612E707573682874293B636F6E7374206E3D742E676574566965774C696E65436F756E7428293B722B3D6E2C6C5B655D3D6E7D72657475726E20746869732E6D6F64656C4C696E6550726F6A65637469';
wwv_flow_imp.g_varchar2_table(17562) := '6F6E733D746869732E6D6F64656C4C696E6550726F6A656374696F6E732E736C69636528302C742D31292E636F6E6361742861292E636F6E63617428746869732E6D6F64656C4C696E6550726F6A656374696F6E732E736C69636528742D3129292C7468';
wwv_flow_imp.g_varchar2_table(17563) := '69732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E696E7365727456616C75657328742D312C6C292C6E6577206D4628732C732B722D31297D6F6E4D6F64656C4C696E654368616E67656428652C742C6E297B6966286E756C';
wwv_flow_imp.g_varchar2_table(17564) := '6C213D3D652626653C3D746869732E5F76616C69644D6F64656C56657273696F6E49642972657475726E5B21312C6E756C6C2C6E756C6C2C6E756C6C5D3B636F6E737420693D742D312C6F3D746869732E6D6F64656C4C696E6550726F6A656374696F6E';
wwv_flow_imp.g_varchar2_table(17565) := '735B695D2E676574566965774C696E65436F756E7428292C733D6542286E2C746869732E6D6F64656C4C696E6550726F6A656374696F6E735B695D2E697356697369626C652829293B746869732E6D6F64656C4C696E6550726F6A656374696F6E735B69';
wwv_flow_imp.g_varchar2_table(17566) := '5D3D733B636F6E737420723D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B695D2E676574566965774C696E65436F756E7428293B6C657420613D21312C6C3D302C633D2D312C643D302C683D2D312C753D302C703D2D313B72657475';
wwv_flow_imp.g_varchar2_table(17567) := '726E206F3E723F286C3D746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D28742D31292B312C633D6C2B722D312C753D632B312C703D752B286F2D72292D312C613D2130293A6F3C723F';
wwv_flow_imp.g_varchar2_table(17568) := '286C3D746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D28742D31292B312C633D6C2B6F2D312C643D632B312C683D642B28722D6F292D312C613D2130293A286C3D746869732E70726F';
wwv_flow_imp.g_varchar2_table(17569) := '6A65637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D28742D31292B312C633D6C2B722D31292C746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E73657456616C756528692C';
wwv_flow_imp.g_varchar2_table(17570) := '72292C5B612C6C3C3D633F6E6577207046286C2C632D6C2B31293A6E756C6C2C643C3D683F6E6577206D4628642C68293A6E756C6C2C753C3D703F6E657720674628752C70293A6E756C6C5D7D61636365707456657273696F6E49642865297B74686973';
wwv_flow_imp.g_varchar2_table(17571) := '2E5F76616C69644D6F64656C56657273696F6E49643D652C31213D3D746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C656E6774687C7C746869732E6D6F64656C4C696E6550726F6A656374696F6E735B305D2E697356697369626C65';
wwv_flow_imp.g_varchar2_table(17572) := '28297C7C746869732E73657448696464656E4172656173285B5D297D676574566965774C696E65436F756E7428297B72657475726E20746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E676574546F74616C53756D28';
wwv_flow_imp.g_varchar2_table(17573) := '297D5F746F56616C6964566965774C696E654E756D6265722865297B696628653C312972657475726E20313B636F6E737420743D746869732E676574566965774C696E65436F756E7428293B72657475726E20653E743F743A307C657D67657441637469';
wwv_flow_imp.g_varchar2_table(17574) := '7665496E64656E74477569646528652C742C6E297B653D746869732E5F746F56616C6964566965774C696E654E756D6265722865292C743D746869732E5F746F56616C6964566965774C696E654E756D6265722874292C6E3D746869732E5F746F56616C';
wwv_flow_imp.g_varchar2_table(17575) := '6964566965774C696E654E756D626572286E293B636F6E737420693D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652C746869732E676574566965774C696E654D696E436F6C756D6E286529292C';
wwv_flow_imp.g_varchar2_table(17576) := '6F3D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28742C746869732E676574566965774C696E654D696E436F6C756D6E287429292C733D746869732E636F6E7665727456696577506F736974696F6E';
wwv_flow_imp.g_varchar2_table(17577) := '546F4D6F64656C506F736974696F6E286E2C746869732E676574566965774C696E654D696E436F6C756D6E286E29292C723D746869732E6D6F64656C2E6775696465732E676574416374697665496E64656E74477569646528692E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(17578) := '722C6F2E6C696E654E756D6265722C732E6C696E654E756D626572292C613D746869732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28722E73746172744C696E654E756D6265722C31292C6C3D746869732E63';
wwv_flow_imp.g_varchar2_table(17579) := '6F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28722E656E644C696E654E756D6265722C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E28722E656E644C696E654E756D62657229293B72657475';
wwv_flow_imp.g_varchar2_table(17580) := '726E7B73746172744C696E654E756D6265723A612E6C696E654E756D6265722C656E644C696E654E756D6265723A6C2E6C696E654E756D6265722C696E64656E743A722E696E64656E747D7D676574566965774C696E65496E666F2865297B653D746869';
wwv_flow_imp.g_varchar2_table(17581) := '732E5F746F56616C6964566965774C696E654E756D6265722865293B636F6E737420743D746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E676574496E6465784F6628652D31292C6E3D742E696E6465782C693D742E';
wwv_flow_imp.g_varchar2_table(17582) := '72656D61696E6465723B72657475726E206E6577206842286E2B312C69297D6765744D696E436F6C756D6E4F66566965774C696E652865297B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B652E6D6F64656C4C696E';
wwv_flow_imp.g_varchar2_table(17583) := '654E756D6265722D315D2E676574566965774C696E654D696E436F6C756D6E28746869732E6D6F64656C2C652E6D6F64656C4C696E654E756D6265722C652E6D6F64656C4C696E65577261707065644C696E65496478297D6765744D6178436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17584) := '4F66566965774C696E652865297B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B652E6D6F64656C4C696E654E756D6265722D315D2E676574566965774C696E654D6178436F6C756D6E28746869732E6D6F64656C2C';
wwv_flow_imp.g_varchar2_table(17585) := '652E6D6F64656C4C696E654E756D6265722C652E6D6F64656C4C696E65577261707065644C696E65496478297D6765744D6F64656C5374617274506F736974696F6E4F66566965774C696E652865297B636F6E737420743D746869732E6D6F64656C4C69';
wwv_flow_imp.g_varchar2_table(17586) := '6E6550726F6A656374696F6E735B652E6D6F64656C4C696E654E756D6265722D315D2C6E3D742E676574566965774C696E654D696E436F6C756D6E28746869732E6D6F64656C2C652E6D6F64656C4C696E654E756D6265722C652E6D6F64656C4C696E65';
wwv_flow_imp.g_varchar2_table(17587) := '577261707065644C696E65496478292C693D742E6765744D6F64656C436F6C756D6E4F6656696577506F736974696F6E28652E6D6F64656C4C696E65577261707065644C696E654964782C6E293B72657475726E206E6577206D6328652E6D6F64656C4C';
wwv_flow_imp.g_varchar2_table(17588) := '696E654E756D6265722C69297D6765744D6F64656C456E64506F736974696F6E4F66566965774C696E652865297B636F6E737420743D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B652E6D6F64656C4C696E654E756D6265722D315D';
wwv_flow_imp.g_varchar2_table(17589) := '2C6E3D742E676574566965774C696E654D6178436F6C756D6E28746869732E6D6F64656C2C652E6D6F64656C4C696E654E756D6265722C652E6D6F64656C4C696E65577261707065644C696E65496478292C693D742E6765744D6F64656C436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17590) := '4F6656696577506F736974696F6E28652E6D6F64656C4C696E65577261707065644C696E654964782C6E293B72657475726E206E6577206D6328652E6D6F64656C4C696E654E756D6265722C69297D676574566965774C696E65496E666F7347726F7570';
wwv_flow_imp.g_varchar2_table(17591) := '656442794D6F64656C52616E67657328652C74297B636F6E7374206E3D746869732E676574566965774C696E65496E666F2865292C693D746869732E676574566965774C696E65496E666F2874292C6F3D6E65772041727261793B6C657420733D746869';
wwv_flow_imp.g_varchar2_table(17592) := '732E6765744D6F64656C5374617274506F736974696F6E4F66566965774C696E65286E292C723D6E65772041727261793B666F72286C657420653D6E2E6D6F64656C4C696E654E756D6265723B653C3D692E6D6F64656C4C696E654E756D6265723B652B';
wwv_flow_imp.g_varchar2_table(17593) := '2B297B636F6E737420743D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B652D315D3B696628742E697356697369626C652829297B636F6E7374206F3D653D3D3D6E2E6D6F64656C4C696E654E756D6265723F6E2E6D6F64656C4C696E';
wwv_flow_imp.g_varchar2_table(17594) := '65577261707065644C696E654964783A302C733D653D3D3D692E6D6F64656C4C696E654E756D6265723F692E6D6F64656C4C696E65577261707065644C696E654964782B313A742E676574566965774C696E65436F756E7428293B666F72286C65742074';
wwv_flow_imp.g_varchar2_table(17595) := '3D6F3B743C733B742B2B29722E70757368286E657720684228652C7429297D69662821742E697356697369626C652829262673297B636F6E737420743D6E6577206D6328652D312C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(17596) := '652D31292B31292C6E3D72682E66726F6D506F736974696F6E7328732C74293B6F2E70757368286E6577207542286E2C7229292C723D5B5D2C733D6E756C6C7D656C736520742E697356697369626C65282926262173262628733D6E6577206D6328652C';
wwv_flow_imp.g_varchar2_table(17597) := '3129297D69662873297B636F6E737420653D72682E66726F6D506F736974696F6E7328732C746869732E6765744D6F64656C456E64506F736974696F6E4F66566965774C696E65286929293B6F2E70757368286E657720754228652C7229297D72657475';
wwv_flow_imp.g_varchar2_table(17598) := '726E206F7D676574566965774C696E6573427261636B657447756964657328652C742C6E2C69297B636F6E7374206F3D6E3F746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E2E6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(17599) := '65722C6E2E636F6C756D6E293A6E756C6C2C733D5B5D3B666F7228636F6E7374206E206F6620746869732E676574566965774C696E65496E666F7347726F7570656442794D6F64656C52616E67657328652C7429297B636F6E737420653D6E2E6D6F6465';
wwv_flow_imp.g_varchar2_table(17600) := '6C52616E67652E73746172744C696E654E756D6265722C743D746869732E6D6F64656C2E6775696465732E6765744C696E6573427261636B657447756964657328652C6E2E6D6F64656C52616E67652E656E644C696E654E756D6265722C6F2C69293B66';
wwv_flow_imp.g_varchar2_table(17601) := '6F7228636F6E73742069206F66206E2E766965774C696E6573297B636F6E7374206E3D745B692E6D6F64656C4C696E654E756D6265722D655D2E6D61702828653D3E7B6966282D31213D3D652E666F72577261707065644C696E65734166746572436F6C';
wwv_flow_imp.g_varchar2_table(17602) := '756D6E2626746869732E6D6F64656C4C696E6550726F6A656374696F6E735B692E6D6F64656C4C696E654E756D6265722D315D2E67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28302C652E666F72577261707065644C696E';
wwv_flow_imp.g_varchar2_table(17603) := '65734166746572436F6C756D6E292E6C696E654E756D6265723E3D692E6D6F64656C4C696E65577261707065644C696E654964782972657475726E3B6966282D31213D3D652E666F72577261707065644C696E65734265666F72654F724174436F6C756D';
wwv_flow_imp.g_varchar2_table(17604) := '6E2626746869732E6D6F64656C4C696E6550726F6A656374696F6E735B692E6D6F64656C4C696E654E756D6265722D315D2E67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28302C652E666F72577261707065644C696E6573';
wwv_flow_imp.g_varchar2_table(17605) := '4265666F72654F724174436F6C756D6E292E6C696E654E756D6265723C692E6D6F64656C4C696E65577261707065644C696E654964782972657475726E3B69662821652E686F72697A6F6E74616C4C696E652972657475726E20653B6C657420743D2D31';
wwv_flow_imp.g_varchar2_table(17606) := '3B6966282D31213D3D652E636F6C756D6E297B636F6E7374206E3D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B692E6D6F64656C4C696E654E756D6265722D315D2E67657456696577506F736974696F6E4F664D6F64656C506F7369';
wwv_flow_imp.g_varchar2_table(17607) := '74696F6E28302C652E636F6C756D6E293B6966286E2E6C696E654E756D6265723D3D3D692E6D6F64656C4C696E65577261707065644C696E6549647829743D6E2E636F6C756D6E3B656C7365206966286E2E6C696E654E756D6265723C692E6D6F64656C';
wwv_flow_imp.g_varchar2_table(17608) := '4C696E65577261707065644C696E6549647829743D746869732E6765744D696E436F6C756D6E4F66566965774C696E652869293B656C7365206966286E2E6C696E654E756D6265723E692E6D6F64656C4C696E65577261707065644C696E654964782972';
wwv_flow_imp.g_varchar2_table(17609) := '657475726E7D636F6E7374206E3D746869732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28692E6D6F64656C4C696E654E756D6265722C652E686F72697A6F6E74616C4C696E652E656E64436F6C756D6E292C';
wwv_flow_imp.g_varchar2_table(17610) := '6F3D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B692E6D6F64656C4C696E654E756D6265722D315D2E67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28302C652E686F72697A6F6E74616C4C696E652E65';
wwv_flow_imp.g_varchar2_table(17611) := '6E64436F6C756D6E293B72657475726E206F2E6C696E654E756D6265723D3D3D692E6D6F64656C4C696E65577261707065644C696E654964783F6E657720747928652E76697369626C65436F6C756D6E2C742C652E636C6173734E616D652C6E6577206E';
wwv_flow_imp.g_varchar2_table(17612) := '7928652E686F72697A6F6E74616C4C696E652E746F702C6E2E636F6C756D6E292C2D312C2D31293A6F2E6C696E654E756D6265723C692E6D6F64656C4C696E65577261707065644C696E654964787C7C2D31213D3D652E76697369626C65436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17613) := '3F766F696420303A6E657720747928652E76697369626C65436F6C756D6E2C742C652E636C6173734E616D652C6E6577206E7928652E686F72697A6F6E74616C4C696E652E746F702C746869732E6765744D6178436F6C756D6E4F66566965774C696E65';
wwv_flow_imp.g_varchar2_table(17614) := '286929292C2D312C2D31297D29293B732E70757368286E2E66696C7465722828653D3E2121652929297D7D72657475726E20737D676574566965774C696E6573496E64656E7447756964657328652C74297B653D746869732E5F746F56616C6964566965';
wwv_flow_imp.g_varchar2_table(17615) := '774C696E654E756D6265722865292C743D746869732E5F746F56616C6964566965774C696E654E756D6265722874293B636F6E7374206E3D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652C7468';
wwv_flow_imp.g_varchar2_table(17616) := '69732E676574566965774C696E654D696E436F6C756D6E286529292C693D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28742C746869732E676574566965774C696E654D6178436F6C756D6E287429';
wwv_flow_imp.g_varchar2_table(17617) := '293B6C6574206F3D5B5D3B636F6E737420733D5B5D2C723D5B5D2C613D6E2E6C696E654E756D6265722D312C6C3D692E6C696E654E756D6265722D313B6C657420633D6E756C6C3B666F72286C657420653D613B653C3D6C3B652B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(17618) := '743D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D3B696628742E697356697369626C652829297B636F6E737420693D742E676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28302C653D3D3D613F';
wwv_flow_imp.g_varchar2_table(17619) := '6E2E636F6C756D6E3A31292C6F3D742E676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28302C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E28652B3129292C6C3D6F2D692B313B6C657420643D30';
wwv_flow_imp.g_varchar2_table(17620) := '3B6C3E312626313D3D3D742E676574566965774C696E654D696E436F6C756D6E28746869732E6D6F64656C2C652B312C6F29262628643D303D3D3D693F313A32292C732E70757368286C292C722E707573682864292C6E756C6C3D3D3D63262628633D6E';
wwv_flow_imp.g_varchar2_table(17621) := '6577206D6328652B312C3029297D656C7365206E756C6C213D3D632626286F3D6F2E636F6E63617428746869732E6D6F64656C2E6775696465732E6765744C696E6573496E64656E7447756964657328632E6C696E654E756D6265722C6529292C633D6E';
wwv_flow_imp.g_varchar2_table(17622) := '756C6C297D6E756C6C213D3D632626286F3D6F2E636F6E63617428746869732E6D6F64656C2E6775696465732E6765744C696E6573496E64656E7447756964657328632E6C696E654E756D6265722C692E6C696E654E756D62657229292C633D6E756C6C';
wwv_flow_imp.g_varchar2_table(17623) := '293B636F6E737420643D742D652B312C683D6E65772041727261792864293B6C657420753D303B666F72286C657420653D302C743D6F2E6C656E6774683B653C743B652B2B297B6C657420743D6F5B655D3B636F6E7374206E3D4D6174682E6D696E2864';
wwv_flow_imp.g_varchar2_table(17624) := '2D752C735B655D292C693D725B655D3B6C657420613B613D323D3D3D693F303A313D3D3D693F313A6E3B666F72286C657420653D303B653C6E3B652B2B29653D3D3D61262628743D30292C685B752B2B5D3D747D72657475726E20687D67657456696577';
wwv_flow_imp.g_varchar2_table(17625) := '4C696E65436F6E74656E742865297B636F6E737420743D746869732E676574566965774C696E65496E666F2865293B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B742E6D6F64656C4C696E654E756D6265722D315D';
wwv_flow_imp.g_varchar2_table(17626) := '2E676574566965774C696E65436F6E74656E7428746869732E6D6F64656C2C742E6D6F64656C4C696E654E756D6265722C742E6D6F64656C4C696E65577261707065644C696E65496478297D676574566965774C696E654C656E6774682865297B636F6E';
wwv_flow_imp.g_varchar2_table(17627) := '737420743D746869732E676574566965774C696E65496E666F2865293B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B742E6D6F64656C4C696E654E756D6265722D315D2E676574566965774C696E654C656E677468';
wwv_flow_imp.g_varchar2_table(17628) := '28746869732E6D6F64656C2C742E6D6F64656C4C696E654E756D6265722C742E6D6F64656C4C696E65577261707065644C696E65496478297D676574566965774C696E654D696E436F6C756D6E2865297B636F6E737420743D746869732E676574566965';
wwv_flow_imp.g_varchar2_table(17629) := '774C696E65496E666F2865293B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B742E6D6F64656C4C696E654E756D6265722D315D2E676574566965774C696E654D696E436F6C756D6E28746869732E6D6F64656C2C74';
wwv_flow_imp.g_varchar2_table(17630) := '2E6D6F64656C4C696E654E756D6265722C742E6D6F64656C4C696E65577261707065644C696E65496478297D676574566965774C696E654D6178436F6C756D6E2865297B636F6E737420743D746869732E676574566965774C696E65496E666F2865293B';
wwv_flow_imp.g_varchar2_table(17631) := '72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B742E6D6F64656C4C696E654E756D6265722D315D2E676574566965774C696E654D6178436F6C756D6E28746869732E6D6F64656C2C742E6D6F64656C4C696E654E756D';
wwv_flow_imp.g_varchar2_table(17632) := '6265722C742E6D6F64656C4C696E65577261707065644C696E65496478297D676574566965774C696E65446174612865297B636F6E737420743D746869732E676574566965774C696E65496E666F2865293B72657475726E20746869732E6D6F64656C4C';
wwv_flow_imp.g_varchar2_table(17633) := '696E6550726F6A656374696F6E735B742E6D6F64656C4C696E654E756D6265722D315D2E676574566965774C696E654461746128746869732E6D6F64656C2C742E6D6F64656C4C696E654E756D6265722C742E6D6F64656C4C696E65577261707065644C';
wwv_flow_imp.g_varchar2_table(17634) := '696E65496478297D676574566965774C696E65734461746128652C742C6E297B653D746869732E5F746F56616C6964566965774C696E654E756D6265722865292C743D746869732E5F746F56616C6964566965774C696E654E756D6265722874293B636F';
wwv_flow_imp.g_varchar2_table(17635) := '6E737420693D746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E676574496E6465784F6628652D31293B6C6574206F3D653B636F6E737420733D692E696E6465782C723D692E72656D61696E6465722C613D5B5D3B66';
wwv_flow_imp.g_varchar2_table(17636) := '6F72286C657420693D732C6C3D746869732E6D6F64656C2E6765744C696E65436F756E7428293B693C6C3B692B2B297B636F6E7374206C3D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B695D3B696628216C2E697356697369626C65';
wwv_flow_imp.g_varchar2_table(17637) := '282929636F6E74696E75653B636F6E737420633D693D3D3D733F723A303B6C657420643D6C2E676574566965774C696E65436F756E7428292D632C683D21313B6966286F2B643E74262628683D21302C643D742D6F2B31292C6C2E676574566965774C69';
wwv_flow_imp.g_varchar2_table(17638) := '6E65734461746128746869732E6D6F64656C2C692B312C632C642C6F2D652C6E2C61292C6F2B3D642C6829627265616B7D72657475726E20617D76616C696461746556696577506F736974696F6E28652C742C6E297B653D746869732E5F746F56616C69';
wwv_flow_imp.g_varchar2_table(17639) := '64566965774C696E654E756D6265722865293B636F6E737420693D746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E676574496E6465784F6628652D31292C6F3D692E696E6465782C733D692E72656D61696E646572';
wwv_flow_imp.g_varchar2_table(17640) := '2C723D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6F5D2C613D722E676574566965774C696E654D696E436F6C756D6E28746869732E6D6F64656C2C6F2B312C73292C6C3D722E676574566965774C696E654D6178436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(17641) := '746869732E6D6F64656C2C6F2B312C73293B743C61262628743D61292C743E6C262628743D6C293B636F6E737420633D722E6765744D6F64656C436F6C756D6E4F6656696577506F736974696F6E28732C74293B72657475726E20746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(17642) := '6C2E76616C6964617465506F736974696F6E286E6577206D63286F2B312C6329292E657175616C73286E293F6E6577206D6328652C74293A746869732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E2E6C69';
wwv_flow_imp.g_varchar2_table(17643) := '6E654E756D6265722C6E2E636F6C756D6E297D76616C69646174655669657752616E676528652C74297B636F6E7374206E3D746869732E76616C696461746556696577506F736974696F6E28652E73746172744C696E654E756D6265722C652E73746172';
wwv_flow_imp.g_varchar2_table(17644) := '74436F6C756D6E2C742E6765745374617274506F736974696F6E2829292C693D746869732E76616C696461746556696577506F736974696F6E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C742E676574456E64506F73697469';
wwv_flow_imp.g_varchar2_table(17645) := '6F6E2829293B72657475726E206E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C692E6C696E654E756D6265722C692E636F6C756D6E297D636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(17646) := '652C74297B636F6E7374206E3D746869732E676574566965774C696E65496E666F2865292C693D746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6E2E6D6F64656C4C696E654E756D6265722D315D2E6765744D6F64656C436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17647) := '4F6656696577506F736974696F6E286E2E6D6F64656C4C696E65577261707065644C696E654964782C74293B72657475726E20746869732E6D6F64656C2E76616C6964617465506F736974696F6E286E6577206D63286E2E6D6F64656C4C696E654E756D';
wwv_flow_imp.g_varchar2_table(17648) := '6265722C6929297D636F6E766572745669657752616E6765546F4D6F64656C52616E67652865297B636F6E737420743D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(17649) := '756D6265722C652E7374617274436F6C756D6E292C6E3D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(17650) := '657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E297D636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652C742C6E3D322C693D21312C6F';
wwv_flow_imp.g_varchar2_table(17651) := '3D2131297B636F6E737420733D746869732E6D6F64656C2E76616C6964617465506F736974696F6E286E6577206D6328652C7429292C723D732E6C696E654E756D6265722C613D732E636F6C756D6E3B6C6574206C3D722D312C633D21313B6966286F29';
wwv_flow_imp.g_varchar2_table(17652) := '666F72283B6C3C746869732E6D6F64656C4C696E6550726F6A656374696F6E732E6C656E677468262621746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6C5D2E697356697369626C6528293B296C2B2B2C633D21303B656C736520666F';
wwv_flow_imp.g_varchar2_table(17653) := '72283B6C3E30262621746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6C5D2E697356697369626C6528293B296C2D2D2C633D21303B696628303D3D3D6C262621746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6C5D2E';
wwv_flow_imp.g_varchar2_table(17654) := '697356697369626C6528292972657475726E206E6577206D6328693F303A312C31293B636F6E737420643D312B746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D286C293B6C65742068';
wwv_flow_imp.g_varchar2_table(17655) := '3B72657475726E20683D633F6F3F746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6C5D2E67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28642C312C6E293A746869732E6D6F64656C4C696E6550726F6A65';
wwv_flow_imp.g_varchar2_table(17656) := '6374696F6E735B6C5D2E67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28642C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E286C2B31292C6E293A746869732E6D6F64656C4C696E6550726F6A656374';
wwv_flow_imp.g_varchar2_table(17657) := '696F6E735B722D315D2E67657456696577506F736974696F6E4F664D6F64656C506F736974696F6E28642C612C6E292C687D636F6E766572744D6F64656C52616E6765546F5669657752616E676528652C743D30297B696628652E6973456D7074792829';
wwv_flow_imp.g_varchar2_table(17658) := '297B636F6E7374206E3D746869732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C74293B72657475726E2072682E66726F6D50';
wwv_flow_imp.g_varchar2_table(17659) := '6F736974696F6E73286E297D7B636F6E737420743D746869732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C31292C6E3D7468';
wwv_flow_imp.g_varchar2_table(17660) := '69732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C30293B72657475726E206E657720726828742E6C696E654E756D6265722C742E636F';
wwv_flow_imp.g_varchar2_table(17661) := '6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E297D7D676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297B6C6574206E3D652D313B696628746869732E6D6F64656C4C696E6550726F6A6563';
wwv_flow_imp.g_varchar2_table(17662) := '74696F6E735B6E5D2E697356697369626C652829297B636F6E737420653D312B746869732E70726F6A65637465644D6F64656C4C696E654C696E65436F756E74732E67657450726566697853756D286E293B72657475726E20746869732E6D6F64656C4C';
wwv_flow_imp.g_varchar2_table(17663) := '696E6550726F6A656374696F6E735B6E5D2E676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297D666F72283B6E3E30262621746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6E5D2E69735669';
wwv_flow_imp.g_varchar2_table(17664) := '7369626C6528293B296E2D2D3B696628303D3D3D6E262621746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6E5D2E697356697369626C6528292972657475726E20313B636F6E737420693D312B746869732E70726F6A65637465644D6F';
wwv_flow_imp.g_varchar2_table(17665) := '64656C4C696E654C696E65436F756E74732E67657450726566697853756D286E293B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6E5D2E676574566965774C696E654E756D6265724F664D6F64656C506F73697469';
wwv_flow_imp.g_varchar2_table(17666) := '6F6E28692C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E286E2B3129297D6765744465636F726174696F6E73496E52616E676528652C742C6E2C692C6F297B636F6E737420733D746869732E636F6E7665727456696577506F7369';
wwv_flow_imp.g_varchar2_table(17667) := '74696F6E546F4D6F64656C506F736974696F6E28652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C723D746869732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E656E64';
wwv_flow_imp.g_varchar2_table(17668) := '4C696E654E756D6265722C652E656E64436F6C756D6E293B696628722E6C696E654E756D6265722D732E6C696E654E756D6265723C3D652E656E644C696E654E756D6265722D652E73746172744C696E654E756D6265722972657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(17669) := '6D6F64656C2E6765744465636F726174696F6E73496E52616E6765286E657720726828732E6C696E654E756D6265722C312C722E6C696E654E756D6265722C722E636F6C756D6E292C742C6E2C692C6F293B6C657420613D5B5D3B636F6E7374206C3D73';
wwv_flow_imp.g_varchar2_table(17670) := '2E6C696E654E756D6265722D312C633D722E6C696E654E756D6265722D313B6C657420643D6E756C6C3B666F72286C657420653D6C3B653C3D633B652B2B29696628746869732E6D6F64656C4C696E6550726F6A656374696F6E735B655D2E6973566973';
wwv_flow_imp.g_varchar2_table(17671) := '69626C652829296E756C6C3D3D3D64262628643D6E6577206D6328652B312C653D3D3D6C3F732E636F6C756D6E3A3129293B656C7365206966286E756C6C213D3D64297B636F6E7374206F3D746869732E6D6F64656C2E6765744C696E654D6178436F6C';
wwv_flow_imp.g_varchar2_table(17672) := '756D6E2865293B613D612E636F6E63617428746869732E6D6F64656C2E6765744465636F726174696F6E73496E52616E6765286E657720726828642E6C696E654E756D6265722C642E636F6C756D6E2C652C6F292C742C6E2C6929292C643D6E756C6C7D';
wwv_flow_imp.g_varchar2_table(17673) := '6E756C6C213D3D64262628613D612E636F6E63617428746869732E6D6F64656C2E6765744465636F726174696F6E73496E52616E6765286E657720726828642E6C696E654E756D6265722C642E636F6C756D6E2C722E6C696E654E756D6265722C722E63';
wwv_flow_imp.g_varchar2_table(17674) := '6F6C756D6E292C742C6E2C6929292C643D6E756C6C292C612E736F7274282828652C74293D3E7B636F6E7374206E3D72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E6765293B72657475726E2030';
wwv_flow_imp.g_varchar2_table(17675) := '3D3D3D6E3F652E69643C742E69643F2D313A652E69643E742E69643F313A303A6E7D29293B636F6E737420683D5B5D3B6C657420753D302C703D6E756C6C3B666F7228636F6E73742065206F662061297B636F6E737420743D652E69643B70213D3D7426';
wwv_flow_imp.g_varchar2_table(17676) := '2628703D742C685B752B2B5D3D65297D72657475726E20687D676574496E6A65637465645465787441742865297B636F6E737420743D746869732E676574566965774C696E65496E666F28652E6C696E654E756D626572293B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(17677) := '2E6D6F64656C4C696E6550726F6A656374696F6E735B742E6D6F64656C4C696E654E756D6265722D315D2E676574496E6A656374656454657874417428742E6D6F64656C4C696E65577261707065644C696E654964782C652E636F6C756D6E297D6E6F72';
wwv_flow_imp.g_varchar2_table(17678) := '6D616C697A65506F736974696F6E28652C74297B636F6E7374206E3D746869732E676574566965774C696E65496E666F28652E6C696E654E756D626572293B72657475726E20746869732E6D6F64656C4C696E6550726F6A656374696F6E735B6E2E6D6F';
wwv_flow_imp.g_varchar2_table(17679) := '64656C4C696E654E756D6265722D315D2E6E6F726D616C697A65506F736974696F6E286E2E6D6F64656C4C696E65577261707065644C696E654964782C652C74297D6765744C696E65496E64656E74436F6C756D6E2865297B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(17680) := '732E676574566965774C696E65496E666F2865293B72657475726E20303D3D3D742E6D6F64656C4C696E65577261707065644C696E654964783F746869732E6D6F64656C2E6765744C696E65496E64656E74436F6C756D6E28742E6D6F64656C4C696E65';
wwv_flow_imp.g_varchar2_table(17681) := '4E756D626572293A307D7D636C6173732068427B636F6E7374727563746F7228652C74297B746869732E6D6F64656C4C696E654E756D6265723D652C746869732E6D6F64656C4C696E65577261707065644C696E654964783D747D7D636C617373207542';
wwv_flow_imp.g_varchar2_table(17682) := '7B636F6E7374727563746F7228652C74297B746869732E6D6F64656C52616E67653D652C746869732E766965774C696E65733D747D7D636C6173732070427B636F6E7374727563746F722865297B746869732E5F6C696E65733D657D636F6E7665727456';
wwv_flow_imp.g_varchar2_table(17683) := '696577506F736974696F6E546F4D6F64656C506F736974696F6E2865297B72657475726E20746869732E5F6C696E65732E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E28652E6C696E654E756D6265722C652E63';
wwv_flow_imp.g_varchar2_table(17684) := '6F6C756D6E297D636F6E766572745669657752616E6765546F4D6F64656C52616E67652865297B72657475726E20746869732E5F6C696E65732E636F6E766572745669657752616E6765546F4D6F64656C52616E67652865297D76616C69646174655669';
wwv_flow_imp.g_varchar2_table(17685) := '6577506F736974696F6E28652C74297B72657475726E20746869732E5F6C696E65732E76616C696461746556696577506F736974696F6E28652E6C696E654E756D6265722C652E636F6C756D6E2C74297D76616C69646174655669657752616E67652865';
wwv_flow_imp.g_varchar2_table(17686) := '2C74297B72657475726E20746869732E5F6C696E65732E76616C69646174655669657752616E676528652C74297D636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652C742C6E2C69297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(17687) := '732E5F6C696E65732E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652E6C696E654E756D6265722C652E636F6C756D6E2C742C6E2C69297D636F6E766572744D6F64656C52616E6765546F5669657752616E67';
wwv_flow_imp.g_varchar2_table(17688) := '6528652C74297B72657475726E20746869732E5F6C696E65732E636F6E766572744D6F64656C52616E6765546F5669657752616E676528652C74297D6D6F64656C506F736974696F6E497356697369626C652865297B72657475726E20746869732E5F6C';
wwv_flow_imp.g_varchar2_table(17689) := '696E65732E6D6F64656C506F736974696F6E497356697369626C6528652E6C696E654E756D6265722C652E636F6C756D6E297D6765744D6F64656C4C696E65566965774C696E65436F756E742865297B72657475726E20746869732E5F6C696E65732E67';
wwv_flow_imp.g_varchar2_table(17690) := '65744D6F64656C4C696E65566965774C696E65436F756E742865297D676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297B72657475726E20746869732E5F6C696E65732E676574566965774C696E654E756D62';
wwv_flow_imp.g_varchar2_table(17691) := '65724F664D6F64656C506F736974696F6E28652C74297D7D636C6173732067427B636F6E7374727563746F722865297B746869732E6D6F64656C3D657D646973706F736528297B7D637265617465436F6F7264696E61746573436F6E7665727465722829';
wwv_flow_imp.g_varchar2_table(17692) := '7B72657475726E206E6577206D422874686973297D67657448696464656E417265617328297B72657475726E5B5D7D73657448696464656E41726561732865297B72657475726E21317D73657454616253697A652865297B72657475726E21317D736574';
wwv_flow_imp.g_varchar2_table(17693) := '5772617070696E6753657474696E677328652C742C6E2C69297B72657475726E21317D6372656174654C696E65427265616B73436F6D707574657228297B636F6E737420653D5B5D3B72657475726E7B616464526571756573743A28742C6E2C69293D3E';
wwv_flow_imp.g_varchar2_table(17694) := '7B652E70757368286E756C6C297D2C66696E616C697A653A28293D3E657D7D6F6E4D6F64656C466C757368656428297B7D6F6E4D6F64656C4C696E657344656C6574656428652C742C6E297B72657475726E206E657720674628742C6E297D6F6E4D6F64';
wwv_flow_imp.g_varchar2_table(17695) := '656C4C696E6573496E73657274656428652C742C6E2C69297B72657475726E206E6577206D4628742C6E297D6F6E4D6F64656C4C696E654368616E67656428652C742C6E297B72657475726E5B21312C6E657720704628742C31292C6E756C6C2C6E756C';
wwv_flow_imp.g_varchar2_table(17696) := '6C5D7D61636365707456657273696F6E49642865297B7D676574566965774C696E65436F756E7428297B72657475726E20746869732E6D6F64656C2E6765744C696E65436F756E7428297D676574416374697665496E64656E74477569646528652C742C';
wwv_flow_imp.g_varchar2_table(17697) := '6E297B72657475726E7B73746172744C696E654E756D6265723A652C656E644C696E654E756D6265723A652C696E64656E743A307D7D676574566965774C696E6573427261636B657447756964657328652C742C6E297B72657475726E206E6577204172';
wwv_flow_imp.g_varchar2_table(17698) := '72617928742D652B31292E66696C6C285B5D297D676574566965774C696E6573496E64656E7447756964657328652C74297B636F6E7374206E3D742D652B312C693D6E6577204172726179286E293B666F72286C657420653D303B653C6E3B652B2B2969';
wwv_flow_imp.g_varchar2_table(17699) := '5B655D3D303B72657475726E20697D676574566965774C696E65436F6E74656E742865297B72657475726E20746869732E6D6F64656C2E6765744C696E65436F6E74656E742865297D676574566965774C696E654C656E6774682865297B72657475726E';
wwv_flow_imp.g_varchar2_table(17700) := '20746869732E6D6F64656C2E6765744C696E654C656E6774682865297D676574566965774C696E654D696E436F6C756D6E2865297B72657475726E20746869732E6D6F64656C2E6765744C696E654D696E436F6C756D6E2865297D676574566965774C69';
wwv_flow_imp.g_varchar2_table(17701) := '6E654D6178436F6C756D6E2865297B72657475726E20746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E2865297D676574566965774C696E65446174612865297B636F6E737420743D746869732E6D6F64656C2E746F6B656E697A6174';
wwv_flow_imp.g_varchar2_table(17702) := '696F6E2E6765744C696E65546F6B656E732865292C6E3D742E6765744C696E65436F6E74656E7428293B72657475726E206E657720534F286E2C21312C312C6E2E6C656E6774682B312C302C742E696E666C61746528292C6E756C6C297D676574566965';
wwv_flow_imp.g_varchar2_table(17703) := '774C696E65734461746128652C742C6E297B636F6E737420693D746869732E6D6F64656C2E6765744C696E65436F756E7428293B653D4D6174682E6D696E284D6174682E6D617828312C65292C69292C743D4D6174682E6D696E284D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(17704) := '312C74292C69293B636F6E7374206F3D5B5D3B666F72286C657420693D653B693C3D743B692B2B297B636F6E737420743D692D653B6F5B745D3D6E5B745D3F746869732E676574566965774C696E65446174612869293A6E756C6C7D72657475726E206F';
wwv_flow_imp.g_varchar2_table(17705) := '7D6765744465636F726174696F6E73496E52616E676528652C742C6E2C692C6F297B72657475726E20746869732E6D6F64656C2E6765744465636F726174696F6E73496E52616E676528652C742C6E2C692C6F297D6E6F726D616C697A65506F73697469';
wwv_flow_imp.g_varchar2_table(17706) := '6F6E28652C74297B72657475726E20746869732E6D6F64656C2E6E6F726D616C697A65506F736974696F6E28652C74297D6765744C696E65496E64656E74436F6C756D6E2865297B72657475726E20746869732E6D6F64656C2E6765744C696E65496E64';
wwv_flow_imp.g_varchar2_table(17707) := '656E74436F6C756D6E2865297D676574496E6A65637465645465787441742865297B72657475726E206E756C6C7D7D636C617373206D427B636F6E7374727563746F722865297B746869732E5F6C696E65733D657D5F76616C6964506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(17708) := '65297B72657475726E20746869732E5F6C696E65732E6D6F64656C2E76616C6964617465506F736974696F6E2865297D5F76616C696452616E67652865297B72657475726E20746869732E5F6C696E65732E6D6F64656C2E76616C696461746552616E67';
wwv_flow_imp.g_varchar2_table(17709) := '652865297D636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E2865297B72657475726E20746869732E5F76616C6964506F736974696F6E2865297D636F6E766572745669657752616E6765546F4D6F64656C52616E67';
wwv_flow_imp.g_varchar2_table(17710) := '652865297B72657475726E20746869732E5F76616C696452616E67652865297D76616C696461746556696577506F736974696F6E28652C74297B72657475726E20746869732E5F76616C6964506F736974696F6E2874297D76616C696461746556696577';
wwv_flow_imp.g_varchar2_table(17711) := '52616E676528652C74297B72657475726E20746869732E5F76616C696452616E67652874297D636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E2865297B72657475726E20746869732E5F76616C6964506F73697469';
wwv_flow_imp.g_varchar2_table(17712) := '6F6E2865297D636F6E766572744D6F64656C52616E6765546F5669657752616E67652865297B72657475726E20746869732E5F76616C696452616E67652865297D6D6F64656C506F736974696F6E497356697369626C652865297B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(17713) := '6869732E5F6C696E65732E6D6F64656C2E6765744C696E65436F756E7428293B72657475726E2128652E6C696E654E756D6265723C317C7C652E6C696E654E756D6265723E74297D6765744D6F64656C4C696E65566965774C696E65436F756E74286529';
wwv_flow_imp.g_varchar2_table(17714) := '7B72657475726E20317D676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28652C74297B72657475726E20657D7D636F6E73742066423D78682E52696768743B636C6173732076427B636F6E7374727563746F722865297B';
wwv_flow_imp.g_varchar2_table(17715) := '746869732E706572736973743D302C746869732E5F72657175697265644C616E65733D312C746869732E6C616E65733D6E65772055696E74384172726179284D6174682E6365696C2828652B31292A66422F3829297D72657365742865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(17716) := '20743D4D6174682E6365696C2828652B31292A66422F38293B746869732E6C616E65732E6C656E6774683C743F746869732E6C616E65733D6E65772055696E743841727261792874293A746869732E6C616E65732E66696C6C2830292C746869732E5F72';
wwv_flow_imp.g_varchar2_table(17717) := '657175697265644C616E65733D317D6765742072657175697265644C616E657328297B72657475726E20746869732E5F72657175697265644C616E65737D7075736828652C742C6E297B6E262628746869732E706572736973747C3D313C3C652D31293B';
wwv_flow_imp.g_varchar2_table(17718) := '666F72286C6574206E3D742E73746172744C696E654E756D6265723B6E3C3D742E656E644C696E654E756D6265723B6E2B2B297B636F6E737420743D66422A6E2B28652D31293B746869732E6C616E65735B743E3E3E335D7C3D313C3C7425382C746869';
wwv_flow_imp.g_varchar2_table(17719) := '732E5F72657175697265644C616E65733D4D6174682E6D617828746869732E5F72657175697265644C616E65732C746869732E636F756E7441744C696E65286E29297D7D6765744C616E657341744C696E652865297B636F6E737420743D5B5D3B6C6574';
wwv_flow_imp.g_varchar2_table(17720) := '206E3D66422A653B666F72286C657420653D303B653C66423B652B2B2928746869732E7065727369737426313C3C657C7C746869732E6C616E65735B6E3E3E3E335D26313C3C6E2538292626742E7075736828652B31292C6E2B2B3B72657475726E2074';
wwv_flow_imp.g_varchar2_table(17721) := '2E6C656E6774683F743A5B78682E43656E7465725D7D636F756E7441744C696E652865297B6C657420743D66422A652C6E3D303B666F72286C657420653D303B653C66423B652B2B2928746869732E7065727369737426313C3C657C7C746869732E6C61';
wwv_flow_imp.g_varchar2_table(17722) := '6E65735B743E3E3E335D26313C3C7425382926266E2B2B2C742B2B3B72657475726E206E7D7D636C61737320624220657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B696628737570657228292C';
wwv_flow_imp.g_varchar2_table(17723) := '746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D722C746869732E5F7468656D65536572766963653D612C746869732E5F6174746163686564566965773D6C2C746869732E68696464656E41726561734D6F64656C3D';
wwv_flow_imp.g_varchar2_table(17724) := '6E65772077422C746869732E70726576696F757348696464656E41726561733D5B5D2C746869732E5F656469746F7249643D652C746869732E5F636F6E66696775726174696F6E3D742C746869732E6D6F64656C3D6E2C746869732E5F6576656E744469';
wwv_flow_imp.g_varchar2_table(17725) := '73706174636865723D6E65772043462C746869732E6F6E4576656E743D746869732E5F6576656E74446973706174636865722E6F6E4576656E742C746869732E637572736F72436F6E6669673D6E657720474328746869732E6D6F64656C2E6765744C61';
wwv_flow_imp.g_varchar2_table(17726) := '6E6775616765496428292C746869732E6D6F64656C2E6765744F7074696F6E7328292C746869732E5F636F6E66696775726174696F6E2C746869732E6C616E6775616765436F6E66696775726174696F6E53657276696365292C746869732E5F75706461';
wwv_flow_imp.g_varchar2_table(17727) := '7465436F6E66696775726174696F6E566965774C696E65436F756E743D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F757064617465436F6E66696775726174696F6E566965774C696E65436F756E744E6F77282929';
wwv_flow_imp.g_varchar2_table(17728) := '2C3029292C746869732E5F686173466F6375733D21312C746869732E5F76696577706F727453746172743D5F422E63726561746528746869732E6D6F64656C292C746869732E676C7970684C616E65733D6E65772076422830292C746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(17729) := '6C2E6973546F6F4C61726765466F72546F6B656E697A6174696F6E282929746869732E5F6C696E65733D6E657720674228746869732E6D6F64656C293B656C73657B636F6E737420653D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(17730) := '732C743D652E676574283530292C6E3D652E67657428313339292C733D652E67657428313436292C723D652E67657428313338292C613D652E67657428313239293B746869732E5F6C696E65733D6E657720644228746869732E5F656469746F7249642C';
wwv_flow_imp.g_varchar2_table(17731) := '746869732E6D6F64656C2C692C6F2C742C746869732E6D6F64656C2E6765744F7074696F6E7328292E74616253697A652C6E2C732E7772617070696E67436F6C756D6E2C722C61297D746869732E636F6F7264696E61746573436F6E7665727465723D74';
wwv_flow_imp.g_varchar2_table(17732) := '6869732E5F6C696E65732E637265617465436F6F7264696E61746573436F6E76657274657228292C746869732E5F637572736F723D746869732E5F7265676973746572286E6577204646286E2C746869732C746869732E636F6F7264696E61746573436F';
wwv_flow_imp.g_varchar2_table(17733) := '6E7665727465722C746869732E637572736F72436F6E66696729292C746869732E766965774C61796F75743D746869732E5F7265676973746572286E657720474628746869732E5F636F6E66696775726174696F6E2C746869732E6765744C696E65436F';
wwv_flow_imp.g_varchar2_table(17734) := '756E7428292C7329292C746869732E5F726567697374657228746869732E766965774C61796F75742E6F6E4469645363726F6C6C2828653D3E7B652E7363726F6C6C546F704368616E6765642626746869732E5F68616E646C6556697369626C654C696E';
wwv_flow_imp.g_varchar2_table(17735) := '65734368616E67656428292C652E7363726F6C6C546F704368616E6765642626746869732E5F76696577706F727453746172742E696E76616C696461746528292C746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965';
wwv_flow_imp.g_varchar2_table(17736) := '774576656E74286E6577207646286529292C746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E74286E657720454628652E6F6C645363726F6C6C57696474682C652E6F6C645363726F6C6C4C6566742C652E';
wwv_flow_imp.g_varchar2_table(17737) := '6F6C645363726F6C6C4865696768742C652E6F6C645363726F6C6C546F702C652E7363726F6C6C57696474682C652E7363726F6C6C4C6566742C652E7363726F6C6C4865696768742C652E7363726F6C6C546F7029297D2929292C746869732E5F726567';
wwv_flow_imp.g_varchar2_table(17738) := '697374657228746869732E766965774C61796F75742E6F6E446964436F6E74656E7453697A654368616E67652828653D3E7B746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E742865297D2929292C746869';
wwv_flow_imp.g_varchar2_table(17739) := '732E5F6465636F726174696F6E733D6E657720514628746869732E5F656469746F7249642C746869732E6D6F64656C2C746869732E5F636F6E66696775726174696F6E2C746869732E5F6C696E65732C746869732E636F6F7264696E61746573436F6E76';
wwv_flow_imp.g_varchar2_table(17740) := '6572746572292C746869732E5F72656769737465724D6F64656C4576656E747328292C746869732E5F726567697374657228746869732E5F636F6E66696775726174696F6E2E6F6E4469644368616E6765466173742828653D3E7B7472797B636F6E7374';
wwv_flow_imp.g_varchar2_table(17741) := '20743D746869732E5F6576656E74446973706174636865722E626567696E456D6974566965774576656E747328293B746869732E5F6F6E436F6E66696775726174696F6E4368616E67656428742C65297D66696E616C6C797B746869732E5F6576656E74';
wwv_flow_imp.g_varchar2_table(17742) := '446973706174636865722E656E64456D6974566965774576656E747328297D7D2929292C746869732E5F726567697374657228794F2E676574496E7374616E636528292E6F6E4469644368616E6765282828293D3E7B746869732E5F6576656E74446973';
wwv_flow_imp.g_varchar2_table(17743) := '706174636865722E656D697453696E676C65566965774576656E74286E6577207946297D2929292C746869732E5F726567697374657228746869732E5F7468656D65536572766963652E6F6E446964436F6C6F725468656D654368616E67652828653D3E';
wwv_flow_imp.g_varchar2_table(17744) := '7B746869732E5F696E76616C69646174654465636F726174696F6E73436F6C6F72436163686528292C746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577206246286529297D2929292C7468';
wwv_flow_imp.g_varchar2_table(17745) := '69732E5F757064617465436F6E66696775726174696F6E566965774C696E65436F756E744E6F7728297D646973706F736528297B73757065722E646973706F736528292C746869732E5F6465636F726174696F6E732E646973706F736528292C74686973';
wwv_flow_imp.g_varchar2_table(17746) := '2E5F6C696E65732E646973706F736528292C746869732E5F76696577706F727453746172742E646973706F736528292C746869732E5F6576656E74446973706174636865722E646973706F736528297D6372656174654C696E65427265616B73436F6D70';
wwv_flow_imp.g_varchar2_table(17747) := '7574657228297B72657475726E20746869732E5F6C696E65732E6372656174654C696E65427265616B73436F6D707574657228297D616464566965774576656E7448616E646C65722865297B746869732E5F6576656E74446973706174636865722E6164';
wwv_flow_imp.g_varchar2_table(17748) := '64566965774576656E7448616E646C65722865297D72656D6F7665566965774576656E7448616E646C65722865297B746869732E5F6576656E74446973706174636865722E72656D6F7665566965774576656E7448616E646C65722865297D5F75706461';
wwv_flow_imp.g_varchar2_table(17749) := '7465436F6E66696775726174696F6E566965774C696E65436F756E744E6F7728297B746869732E5F636F6E66696775726174696F6E2E736574566965774C696E65436F756E7428746869732E5F6C696E65732E676574566965774C696E65436F756E7428';
wwv_flow_imp.g_varchar2_table(17750) := '29297D6765744D6F64656C56697369626C6552616E67657328297B636F6E737420653D746869732E766965774C61796F75742E6765744C696E657356696577706F72744461746128292C743D6E657720726828652E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(17751) := '2C746869732E6765744C696E654D696E436F6C756D6E28652E73746172744C696E654E756D626572292C652E656E644C696E654E756D6265722C746869732E6765744C696E654D6178436F6C756D6E28652E656E644C696E654E756D62657229293B7265';
wwv_flow_imp.g_varchar2_table(17752) := '7475726E20746869732E5F746F4D6F64656C56697369626C6552616E6765732874297D76697369626C654C696E657353746162696C697A656428297B636F6E737420653D746869732E6765744D6F64656C56697369626C6552616E67657328293B746869';
wwv_flow_imp.g_varchar2_table(17753) := '732E5F6174746163686564566965772E73657456697369626C654C696E657328652C2130297D5F68616E646C6556697369626C654C696E65734368616E67656428297B636F6E737420653D746869732E6765744D6F64656C56697369626C6552616E6765';
wwv_flow_imp.g_varchar2_table(17754) := '7328293B746869732E5F6174746163686564566965772E73657456697369626C654C696E657328652C2131297D736574486173466F6375732865297B746869732E5F686173466F6375733D652C746869732E5F637572736F722E736574486173466F6375';
wwv_flow_imp.g_varchar2_table(17755) := '732865292C746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577206446286529292C746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E74286E65';
wwv_flow_imp.g_varchar2_table(17756) := '77206B462821652C6529297D6F6E436F6D706F736974696F6E537461727428297B746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577206F46297D6F6E436F6D706F736974696F6E456E6428';
wwv_flow_imp.g_varchar2_table(17757) := '297B746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577207346297D5F63617074757265537461626C6556696577706F727428297B696628746869732E5F76696577706F727453746172742E';
wwv_flow_imp.g_varchar2_table(17758) := '697356616C69642626746869732E766965774C61796F75742E67657443757272656E745363726F6C6C546F7028293E30297B636F6E737420653D6E6577206D6328746869732E5F76696577706F727453746172742E766965774C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(17759) := '746869732E6765744C696E654D696E436F6C756D6E28746869732E5F76696577706F727453746172742E766965774C696E654E756D62657229292C743D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F';
wwv_flow_imp.g_varchar2_table(17760) := '736974696F6E546F4D6F64656C506F736974696F6E2865293B72657475726E206E657720534228742C746869732E5F76696577706F727453746172742E73746172744C696E6544656C7461297D72657475726E206E6577205342286E756C6C2C30297D5F';
wwv_flow_imp.g_varchar2_table(17761) := '6F6E436F6E66696775726174696F6E4368616E67656428652C74297B636F6E7374206E3D746869732E5F63617074757265537461626C6556696577706F727428292C693D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732C6F3D692E';
wwv_flow_imp.g_varchar2_table(17762) := '676574283530292C733D692E67657428313339292C723D692E67657428313436292C613D692E67657428313338292C6C3D692E67657428313239293B746869732E5F6C696E65732E7365745772617070696E6753657474696E6773286F2C732C722E7772';
wwv_flow_imp.g_varchar2_table(17763) := '617070696E67436F6C756D6E2C612C6C29262628652E656D6974566965774576656E74286E6577206346292C652E656D6974566965774576656E74286E6577207546292C652E656D6974566965774576656E74286E6577206C46286E756C6C29292C7468';
wwv_flow_imp.g_varchar2_table(17764) := '69732E5F637572736F722E6F6E4C696E654D617070696E674368616E6765642865292C746869732E5F6465636F726174696F6E732E6F6E4C696E654D617070696E674368616E67656428292C746869732E766965774C61796F75742E6F6E466C75736865';
wwv_flow_imp.g_varchar2_table(17765) := '6428746869732E6765744C696E65436F756E742829292C746869732E5F757064617465436F6E66696775726174696F6E566965774C696E65436F756E742E7363686564756C652829292C742E6861734368616E67656428393129262628746869732E5F64';
wwv_flow_imp.g_varchar2_table(17766) := '65636F726174696F6E732E726573657428292C652E656D6974566965774576656E74286E6577206C46286E756C6C2929292C742E6861734368616E67656428393829262628746869732E5F6465636F726174696F6E732E726573657428292C652E656D69';
wwv_flow_imp.g_varchar2_table(17767) := '74566965774576656E74286E6577206C46286E756C6C2929292C652E656D6974566965774576656E74286E6577207246287429292C746869732E766965774C61796F75742E6F6E436F6E66696775726174696F6E4368616E6765642874292C6E2E726563';
wwv_flow_imp.g_varchar2_table(17768) := '6F76657256696577706F7274537461727428746869732E636F6F7264696E61746573436F6E7665727465722C746869732E766965774C61796F7574292C47432E73686F756C645265637265617465287429262628746869732E637572736F72436F6E6669';
wwv_flow_imp.g_varchar2_table(17769) := '673D6E657720474328746869732E6D6F64656C2E6765744C616E6775616765496428292C746869732E6D6F64656C2E6765744F7074696F6E7328292C746869732E5F636F6E66696775726174696F6E2C746869732E6C616E6775616765436F6E66696775';
wwv_flow_imp.g_varchar2_table(17770) := '726174696F6E53657276696365292C746869732E5F637572736F722E757064617465436F6E66696775726174696F6E28746869732E637572736F72436F6E66696729297D5F72656769737465724D6F64656C4576656E747328297B746869732E5F726567';
wwv_flow_imp.g_varchar2_table(17771) := '697374657228746869732E6D6F64656C2E6F6E4469644368616E6765436F6E74656E744F72496E6A6563746564546578742828653D3E7B7472797B636F6E737420743D746869732E5F6576656E74446973706174636865722E626567696E456D69745669';
wwv_flow_imp.g_varchar2_table(17772) := '65774576656E747328293B6C6574206E3D21312C693D21313B636F6E7374206F3D6520696E7374616E63656F662067433F652E726177436F6E74656E744368616E6765644576656E742E6368616E6765733A652E6368616E6765732C733D6520696E7374';
wwv_flow_imp.g_varchar2_table(17773) := '616E63656F662067433F652E726177436F6E74656E744368616E6765644576656E742E76657273696F6E49643A6E756C6C2C723D746869732E5F6C696E65732E6372656174654C696E65427265616B73436F6D707574657228293B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(17774) := '2065206F66206F2973776974636828652E6368616E676554797065297B6361736520343A666F72286C657420743D303B743C652E64657461696C2E6C656E6774683B742B2B297B636F6E7374206E3D652E64657461696C5B745D3B6C657420693D652E69';
wwv_flow_imp.g_varchar2_table(17775) := '6E6A656374656454657874735B745D3B69262628693D692E66696C7465722828653D3E21652E6F776E657249647C7C652E6F776E657249643D3D3D746869732E5F656469746F7249642929292C722E61646452657175657374286E2C692C6E756C6C297D';
wwv_flow_imp.g_varchar2_table(17776) := '627265616B3B6361736520323A7B6C657420743D6E756C6C3B652E696E6A656374656454657874262628743D652E696E6A6563746564546578742E66696C7465722828653D3E21652E6F776E657249647C7C652E6F776E657249643D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(17777) := '656469746F7249642929292C722E6164645265717565737428652E64657461696C2C742C6E756C6C293B627265616B7D7D636F6E737420613D722E66696E616C697A6528292C6C3D6E6577206F752861293B666F7228636F6E73742065206F66206F2973';
wwv_flow_imp.g_varchar2_table(17778) := '776974636828652E6368616E676554797065297B6361736520313A746869732E5F6C696E65732E6F6E4D6F64656C466C757368656428292C742E656D6974566965774576656E74286E6577206346292C746869732E5F6465636F726174696F6E732E7265';
wwv_flow_imp.g_varchar2_table(17779) := '73657428292C746869732E766965774C61796F75742E6F6E466C757368656428746869732E6765744C696E65436F756E742829292C6E3D21303B627265616B3B6361736520333A7B636F6E737420693D746869732E5F6C696E65732E6F6E4D6F64656C4C';
wwv_flow_imp.g_varchar2_table(17780) := '696E657344656C6574656428732C652E66726F6D4C696E654E756D6265722C652E746F4C696E654E756D626572293B6E756C6C213D3D69262628742E656D6974566965774576656E742869292C746869732E766965774C61796F75742E6F6E4C696E6573';
wwv_flow_imp.g_varchar2_table(17781) := '44656C6574656428692E66726F6D4C696E654E756D6265722C692E746F4C696E654E756D62657229292C6E3D21303B627265616B7D6361736520343A7B636F6E737420693D6C2E74616B65436F756E7428652E64657461696C2E6C656E677468292C6F3D';
wwv_flow_imp.g_varchar2_table(17782) := '746869732E5F6C696E65732E6F6E4D6F64656C4C696E6573496E73657274656428732C652E66726F6D4C696E654E756D6265722C652E746F4C696E654E756D6265722C69293B6E756C6C213D3D6F262628742E656D6974566965774576656E74286F292C';
wwv_flow_imp.g_varchar2_table(17783) := '746869732E766965774C61796F75742E6F6E4C696E6573496E736572746564286F2E66726F6D4C696E654E756D6265722C6F2E746F4C696E654E756D62657229292C6E3D21303B627265616B7D6361736520323A7B636F6E7374206E3D6C2E6465717565';
wwv_flow_imp.g_varchar2_table(17784) := '756528292C5B6F2C722C612C635D3D746869732E5F6C696E65732E6F6E4D6F64656C4C696E654368616E67656428732C652E6C696E654E756D6265722C6E293B693D6F2C722626742E656D6974566965774576656E742872292C61262628742E656D6974';
wwv_flow_imp.g_varchar2_table(17785) := '566965774576656E742861292C746869732E766965774C61796F75742E6F6E4C696E6573496E73657274656428612E66726F6D4C696E654E756D6265722C612E746F4C696E654E756D62657229292C63262628742E656D6974566965774576656E742863';
wwv_flow_imp.g_varchar2_table(17786) := '292C746869732E766965774C61796F75742E6F6E4C696E657344656C6574656428632E66726F6D4C696E654E756D6265722C632E746F4C696E654E756D62657229293B627265616B7D7D6E756C6C213D3D732626746869732E5F6C696E65732E61636365';
wwv_flow_imp.g_varchar2_table(17787) := '707456657273696F6E49642873292C746869732E766965774C61796F75742E6F6E4865696768744D617962654368616E67656428292C216E262669262628742E656D6974566965774576656E74286E6577207546292C742E656D6974566965774576656E';
wwv_flow_imp.g_varchar2_table(17788) := '74286E6577206C46286E756C6C29292C746869732E5F637572736F722E6F6E4C696E654D617070696E674368616E6765642874292C746869732E5F6465636F726174696F6E732E6F6E4C696E654D617070696E674368616E6765642829297D66696E616C';
wwv_flow_imp.g_varchar2_table(17789) := '6C797B746869732E5F6576656E74446973706174636865722E656E64456D6974566965774576656E747328297D636F6E737420743D746869732E5F76696577706F727453746172742E697356616C69643B696628746869732E5F76696577706F72745374';
wwv_flow_imp.g_varchar2_table(17790) := '6172742E696E76616C696461746528292C746869732E5F636F6E66696775726174696F6E2E7365744D6F64656C4C696E65436F756E7428746869732E6D6F64656C2E6765744C696E65436F756E742829292C746869732E5F757064617465436F6E666967';
wwv_flow_imp.g_varchar2_table(17791) := '75726174696F6E566965774C696E65436F756E744E6F7728292C21746869732E5F686173466F6375732626746869732E6D6F64656C2E6765744174746163686564456469746F72436F756E7428293E3D32262674297B636F6E737420653D746869732E6D';
wwv_flow_imp.g_varchar2_table(17792) := '6F64656C2E5F676574547261636B656452616E676528746869732E5F76696577706F727453746172742E6D6F64656C547261636B656452616E6765293B69662865297B636F6E737420743D746869732E636F6F7264696E61746573436F6E766572746572';
wwv_flow_imp.g_varchar2_table(17793) := '2E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28652E6765745374617274506F736974696F6E2829292C6E3D746869732E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E65';
wwv_flow_imp.g_varchar2_table(17794) := '4E756D62657228742E6C696E654E756D626572293B746869732E766965774C61796F75742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A6E2B746869732E5F76696577706F727453746172742E73746172744C696E6544656C';
wwv_flow_imp.g_varchar2_table(17795) := '74617D2C31297D7D7472797B636F6E737420743D746869732E5F6576656E74446973706174636865722E626567696E456D6974566965774576656E747328293B6520696E7374616E63656F662067432626742E656D69744F7574676F696E674576656E74';
wwv_flow_imp.g_varchar2_table(17796) := '286E657720504628652E636F6E74656E744368616E6765644576656E7429292C746869732E5F637572736F722E6F6E4D6F64656C436F6E74656E744368616E67656428742C65297D66696E616C6C797B746869732E5F6576656E74446973706174636865';
wwv_flow_imp.g_varchar2_table(17797) := '722E656E64456D6974566965774576656E747328297D746869732E5F68616E646C6556697369626C654C696E65734368616E67656428297D2929292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4469644368616E6765546F6B';
wwv_flow_imp.g_varchar2_table(17798) := '656E732828653D3E7B636F6E737420743D5B5D3B666F72286C6574206E3D302C693D652E72616E6765732E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D652E72616E6765735B6E5D2C6F3D746869732E636F6F7264696E61746573436F6E';
wwv_flow_imp.g_varchar2_table(17799) := '7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328692E66726F6D4C696E654E756D6265722C3129292E6C696E654E756D6265722C733D746869732E636F6F7264696E6174657343';
wwv_flow_imp.g_varchar2_table(17800) := '6F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328692E746F4C696E654E756D6265722C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E28692E746F4C69';
wwv_flow_imp.g_varchar2_table(17801) := '6E654E756D6265722929292E6C696E654E756D6265723B745B6E5D3D7B66726F6D4C696E654E756D6265723A6F2C746F4C696E654E756D6265723A737D7D746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576';
wwv_flow_imp.g_varchar2_table(17802) := '656E74286E6577205F46287429292C746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E74286E6577205246286529297D2929292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4469';
wwv_flow_imp.g_varchar2_table(17803) := '644368616E67654C616E6775616765436F6E66696775726174696F6E2828653D3E7B746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577206846292C746869732E637572736F72436F6E6669';
wwv_flow_imp.g_varchar2_table(17804) := '673D6E657720474328746869732E6D6F64656C2E6765744C616E6775616765496428292C746869732E6D6F64656C2E6765744F7074696F6E7328292C746869732E5F636F6E66696775726174696F6E2C746869732E6C616E6775616765436F6E66696775';
wwv_flow_imp.g_varchar2_table(17805) := '726174696F6E53657276696365292C746869732E5F637572736F722E757064617465436F6E66696775726174696F6E28746869732E637572736F72436F6E666967292C746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E';
wwv_flow_imp.g_varchar2_table(17806) := '674576656E74286E6577204E46286529297D2929292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4469644368616E67654C616E67756167652828653D3E7B746869732E637572736F72436F6E6669673D6E6577204743287468';
wwv_flow_imp.g_varchar2_table(17807) := '69732E6D6F64656C2E6765744C616E6775616765496428292C746869732E6D6F64656C2E6765744F7074696F6E7328292C746869732E5F636F6E66696775726174696F6E2C746869732E6C616E6775616765436F6E66696775726174696F6E5365727669';
wwv_flow_imp.g_varchar2_table(17808) := '6365292C746869732E5F637572736F722E757064617465436F6E66696775726174696F6E28746869732E637572736F72436F6E666967292C746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E74286E657720';
wwv_flow_imp.g_varchar2_table(17809) := '4146286529297D2929292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4469644368616E67654F7074696F6E732828653D3E7B696628746869732E5F6C696E65732E73657454616253697A6528746869732E6D6F64656C2E6765';
wwv_flow_imp.g_varchar2_table(17810) := '744F7074696F6E7328292E74616253697A6529297B7472797B636F6E737420653D746869732E5F6576656E74446973706174636865722E626567696E456D6974566965774576656E747328293B652E656D6974566965774576656E74286E657720634629';
wwv_flow_imp.g_varchar2_table(17811) := '2C652E656D6974566965774576656E74286E6577207546292C652E656D6974566965774576656E74286E6577206C46286E756C6C29292C746869732E5F637572736F722E6F6E4C696E654D617070696E674368616E6765642865292C746869732E5F6465';
wwv_flow_imp.g_varchar2_table(17812) := '636F726174696F6E732E6F6E4C696E654D617070696E674368616E67656428292C746869732E766965774C61796F75742E6F6E466C757368656428746869732E6765744C696E65436F756E742829297D66696E616C6C797B746869732E5F6576656E7444';
wwv_flow_imp.g_varchar2_table(17813) := '6973706174636865722E656E64456D6974566965774576656E747328297D746869732E5F757064617465436F6E66696775726174696F6E566965774C696E65436F756E742E7363686564756C6528297D746869732E637572736F72436F6E6669673D6E65';
wwv_flow_imp.g_varchar2_table(17814) := '7720474328746869732E6D6F64656C2E6765744C616E6775616765496428292C746869732E6D6F64656C2E6765744F7074696F6E7328292C746869732E5F636F6E66696775726174696F6E2C746869732E6C616E6775616765436F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(17815) := '6F6E53657276696365292C746869732E5F637572736F722E757064617465436F6E66696775726174696F6E28746869732E637572736F72436F6E666967292C746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E67457665';
wwv_flow_imp.g_varchar2_table(17816) := '6E74286E6577204F46286529297D2929292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4469644368616E67654465636F726174696F6E732828653D3E7B746869732E5F6465636F726174696F6E732E6F6E4D6F64656C446563';
wwv_flow_imp.g_varchar2_table(17817) := '6F726174696F6E734368616E67656428292C746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577206C46286529292C746869732E5F6576656E74446973706174636865722E656D69744F7574';
wwv_flow_imp.g_varchar2_table(17818) := '676F696E674576656E74286E6577204D46286529297D2929297D73657448696464656E417265617328652C74297B766172206E3B746869732E68696464656E41726561734D6F64656C2E73657448696464656E417265617328742C65293B636F6E737420';
wwv_flow_imp.g_varchar2_table(17819) := '693D746869732E68696464656E41726561734D6F64656C2E6765744D657267656452616E67657328293B696628693D3D3D746869732E70726576696F757348696464656E41726561732972657475726E3B746869732E70726576696F757348696464656E';
wwv_flow_imp.g_varchar2_table(17820) := '41726561733D693B636F6E7374206F3D746869732E5F63617074757265537461626C6556696577706F727428293B6C657420733D21313B7472797B636F6E737420653D746869732E5F6576656E74446973706174636865722E626567696E456D69745669';
wwv_flow_imp.g_varchar2_table(17821) := '65774576656E747328293B733D746869732E5F6C696E65732E73657448696464656E41726561732869292C73262628652E656D6974566965774576656E74286E6577206346292C652E656D6974566965774576656E74286E6577207546292C652E656D69';
wwv_flow_imp.g_varchar2_table(17822) := '74566965774576656E74286E6577206C46286E756C6C29292C746869732E5F637572736F722E6F6E4C696E654D617070696E674368616E6765642865292C746869732E5F6465636F726174696F6E732E6F6E4C696E654D617070696E674368616E676564';
wwv_flow_imp.g_varchar2_table(17823) := '28292C746869732E766965774C61796F75742E6F6E466C757368656428746869732E6765744C696E65436F756E742829292C746869732E766965774C61796F75742E6F6E4865696768744D617962654368616E6765642829293B636F6E737420743D6E75';
wwv_flow_imp.g_varchar2_table(17824) := '6C6C3D3D3D286E3D6F2E76696577706F727453746172744D6F64656C506F736974696F6E297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C696E654E756D6265722C723D742626692E736F6D652828653D3E652E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(17825) := '6265723C3D742626743C3D652E656E644C696E654E756D62657229293B727C7C6F2E7265636F76657256696577706F7274537461727428746869732E636F6F7264696E61746573436F6E7665727465722C746869732E766965774C61796F7574297D6669';
wwv_flow_imp.g_varchar2_table(17826) := '6E616C6C797B746869732E5F6576656E74446973706174636865722E656E64456D6974566965774576656E747328297D746869732E5F757064617465436F6E66696775726174696F6E566965774C696E65436F756E742E7363686564756C6528292C7326';
wwv_flow_imp.g_varchar2_table(17827) := '26746869732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E74286E6577204446297D67657456697369626C6552616E676573506C757356696577706F727441626F766542656C6F7728297B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(17828) := '69732E5F636F6E66696775726174696F6E2E6F7074696F6E732E67657428313435292C743D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E676574283637292C6E3D4D6174682E6D61782832302C4D6174682E726F756E6428652E';
wwv_flow_imp.g_varchar2_table(17829) := '6865696768742F7429292C693D746869732E766965774C61796F75742E6765744C696E657356696577706F72744461746128292C6F3D4D6174682E6D617828312C692E636F6D706C6574656C7956697369626C6553746172744C696E654E756D6265722D';
wwv_flow_imp.g_varchar2_table(17830) := '6E292C733D4D6174682E6D696E28746869732E6765744C696E65436F756E7428292C692E636F6D706C6574656C7956697369626C65456E644C696E654E756D6265722B6E293B72657475726E20746869732E5F746F4D6F64656C56697369626C6552616E';
wwv_flow_imp.g_varchar2_table(17831) := '676573286E6577207268286F2C746869732E6765744C696E654D696E436F6C756D6E286F292C732C746869732E6765744C696E654D6178436F6C756D6E28732929297D67657456697369626C6552616E67657328297B636F6E737420653D746869732E67';
wwv_flow_imp.g_varchar2_table(17832) := '6574436F6D706C6574656C7956697369626C655669657752616E676528293B72657475726E20746869732E5F746F4D6F64656C56697369626C6552616E6765732865297D67657448696464656E417265617328297B72657475726E20746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(17833) := '6E65732E67657448696464656E417265617328297D5F746F4D6F64656C56697369626C6552616E6765732865297B636F6E737420743D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E766572745669657752616E6765546F4D6F';
wwv_flow_imp.g_varchar2_table(17834) := '64656C52616E67652865292C6E3D746869732E5F6C696E65732E67657448696464656E417265617328293B696628303D3D3D6E2E6C656E6774682972657475726E5B745D3B636F6E737420693D5B5D3B6C6574206F3D302C733D742E73746172744C696E';
wwv_flow_imp.g_varchar2_table(17835) := '654E756D6265722C723D742E7374617274436F6C756D6E3B636F6E737420613D742E656E644C696E654E756D6265722C6C3D742E656E64436F6C756D6E3B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(17836) := '743D6E5B655D2E73746172744C696E654E756D6265722C6C3D6E5B655D2E656E644C696E654E756D6265723B6C3C737C7C743E617C7C28733C74262628695B6F2B2B5D3D6E657720726828732C722C742D312C746869732E6D6F64656C2E6765744C696E';
wwv_flow_imp.g_varchar2_table(17837) := '654D6178436F6C756D6E28742D312929292C733D6C2B312C723D31297D72657475726E28733C617C7C733D3D3D612626723C6C29262628695B6F2B2B5D3D6E657720726828732C722C612C6C29292C697D676574436F6D706C6574656C7956697369626C';
wwv_flow_imp.g_varchar2_table(17838) := '655669657752616E676528297B636F6E737420653D746869732E766965774C61796F75742E6765744C696E657356696577706F72744461746128292C743D652E636F6D706C6574656C7956697369626C6553746172744C696E654E756D6265722C6E3D65';
wwv_flow_imp.g_varchar2_table(17839) := '2E636F6D706C6574656C7956697369626C65456E644C696E654E756D6265723B72657475726E206E657720726828742C746869732E6765744C696E654D696E436F6C756D6E2874292C6E2C746869732E6765744C696E654D6178436F6C756D6E286E2929';
wwv_flow_imp.g_varchar2_table(17840) := '7D676574436F6D706C6574656C7956697369626C655669657752616E676541745363726F6C6C546F702865297B636F6E737420743D746869732E766965774C61796F75742E6765744C696E657356696577706F72744461746141745363726F6C6C546F70';
wwv_flow_imp.g_varchar2_table(17841) := '2865292C6E3D742E636F6D706C6574656C7956697369626C6553746172744C696E654E756D6265722C693D742E636F6D706C6574656C7956697369626C65456E644C696E654E756D6265723B72657475726E206E6577207268286E2C746869732E676574';
wwv_flow_imp.g_varchar2_table(17842) := '4C696E654D696E436F6C756D6E286E292C692C746869732E6765744C696E654D6178436F6C756D6E286929297D73617665537461746528297B636F6E737420653D746869732E766965774C61796F75742E73617665537461746528292C743D652E736372';
wwv_flow_imp.g_varchar2_table(17843) := '6F6C6C546F702C6E3D746869732E766965774C61796F75742E6765744C696E654E756D6265724174566572746963616C4F66667365742874292C693D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F73';
wwv_flow_imp.g_varchar2_table(17844) := '6974696F6E546F4D6F64656C506F736974696F6E286E6577206D63286E2C746869732E6765744C696E654D696E436F6C756D6E286E2929292C6F3D746869732E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E';
wwv_flow_imp.g_varchar2_table(17845) := '756D626572286E292D743B72657475726E7B7363726F6C6C4C6566743A652E7363726F6C6C4C6566742C6669727374506F736974696F6E3A692C6669727374506F736974696F6E44656C7461546F703A6F7D7D726564756365526573746F726553746174';
wwv_flow_imp.g_varchar2_table(17846) := '652865297B696628766F696420303D3D3D652E6669727374506F736974696F6E2972657475726E20746869732E5F726564756365526573746F72655374617465436F6D7061746962696C6974792865293B636F6E737420743D746869732E6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(17847) := '76616C6964617465506F736974696F6E28652E6669727374506F736974696F6E292C6E3D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E2874292C';
wwv_flow_imp.g_varchar2_table(17848) := '693D746869732E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D626572286E2E6C696E654E756D626572292D652E6669727374506F736974696F6E44656C7461546F703B72657475726E7B7363726F6C6C';
wwv_flow_imp.g_varchar2_table(17849) := '4C6566743A652E7363726F6C6C4C6566742C7363726F6C6C546F703A697D7D5F726564756365526573746F72655374617465436F6D7061746962696C6974792865297B72657475726E7B7363726F6C6C4C6566743A652E7363726F6C6C4C6566742C7363';
wwv_flow_imp.g_varchar2_table(17850) := '726F6C6C546F703A652E7363726F6C6C546F70576974686F7574566965775A6F6E65737D7D67657454616253697A6528297B72657475726E20746869732E6D6F64656C2E6765744F7074696F6E7328292E74616253697A657D6765744C696E65436F756E';
wwv_flow_imp.g_varchar2_table(17851) := '7428297B72657475726E20746869732E5F6C696E65732E676574566965774C696E65436F756E7428297D73657456696577706F727428652C742C6E297B746869732E5F76696577706F727453746172742E75706461746528746869732C65297D67657441';
wwv_flow_imp.g_varchar2_table(17852) := '6374697665496E64656E74477569646528652C742C6E297B72657475726E20746869732E5F6C696E65732E676574416374697665496E64656E74477569646528652C742C6E297D6765744C696E6573496E64656E7447756964657328652C74297B726574';
wwv_flow_imp.g_varchar2_table(17853) := '75726E20746869732E5F6C696E65732E676574566965774C696E6573496E64656E7447756964657328652C74297D676574427261636B6574477569646573496E52616E676542794C696E6528652C742C6E2C69297B72657475726E20746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(17854) := '6E65732E676574566965774C696E6573427261636B657447756964657328652C742C6E2C69297D6765744C696E65436F6E74656E742865297B72657475726E20746869732E5F6C696E65732E676574566965774C696E65436F6E74656E742865297D6765';
wwv_flow_imp.g_varchar2_table(17855) := '744C696E654C656E6774682865297B72657475726E20746869732E5F6C696E65732E676574566965774C696E654C656E6774682865297D6765744C696E654D696E436F6C756D6E2865297B72657475726E20746869732E5F6C696E65732E676574566965';
wwv_flow_imp.g_varchar2_table(17856) := '774C696E654D696E436F6C756D6E2865297D6765744C696E654D6178436F6C756D6E2865297B72657475726E20746869732E5F6C696E65732E676574566965774C696E654D6178436F6C756D6E2865297D6765744C696E6546697273744E6F6E57686974';
wwv_flow_imp.g_varchar2_table(17857) := '657370616365436F6C756D6E2865297B636F6E737420743D6D6928746869732E6765744C696E65436F6E74656E74286529293B72657475726E2D313D3D3D743F303A742B317D6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E';
wwv_flow_imp.g_varchar2_table(17858) := '2865297B636F6E737420743D766928746869732E6765744C696E65436F6E74656E74286529293B72657475726E2D313D3D3D743F303A742B327D6765744D696E696D61704465636F726174696F6E73496E52616E67652865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(17859) := '732E5F6465636F726174696F6E732E6765744D696E696D61704465636F726174696F6E73496E52616E67652865297D6765744465636F726174696F6E73496E56696577706F72742865297B72657475726E20746869732E5F6465636F726174696F6E732E';
wwv_flow_imp.g_varchar2_table(17860) := '6765744465636F726174696F6E7356696577706F7274446174612865292E6465636F726174696F6E737D676574496E6A65637465645465787441742865297B72657475726E20746869732E5F6C696E65732E676574496E6A656374656454657874417428';
wwv_flow_imp.g_varchar2_table(17861) := '65297D67657456696577706F7274566965774C696E6552656E646572696E674461746128652C74297B636F6E7374206E3D746869732E5F6465636F726174696F6E732E6765744465636F726174696F6E7356696577706F7274446174612865292E696E6C';
wwv_flow_imp.g_varchar2_table(17862) := '696E654465636F726174696F6E735B742D652E73746172744C696E654E756D6265725D3B72657475726E20746869732E5F676574566965774C696E6552656E646572696E674461746128742C6E297D676574566965774C696E6552656E646572696E6744';
wwv_flow_imp.g_varchar2_table(17863) := '6174612865297B636F6E737420743D746869732E5F6465636F726174696F6E732E676574496E6C696E654465636F726174696F6E734F6E4C696E652865293B72657475726E20746869732E5F676574566965774C696E6552656E646572696E6744617461';
wwv_flow_imp.g_varchar2_table(17864) := '28652C74297D5F676574566965774C696E6552656E646572696E674461746128652C74297B636F6E7374206E3D746869732E6D6F64656C2E6D69676874436F6E7461696E52544C28292C693D746869732E6D6F64656C2E6D69676874436F6E7461696E4E';
wwv_flow_imp.g_varchar2_table(17865) := '6F6E4261736963415343494928292C6F3D746869732E67657454616253697A6528292C733D746869732E5F6C696E65732E676574566965774C696E65446174612865293B72657475726E20732E696E6C696E654465636F726174696F6E73262628743D5B';
wwv_flow_imp.g_varchar2_table(17866) := '2E2E2E742C2E2E2E732E696E6C696E654465636F726174696F6E732E6D61702828743D3E742E746F496E6C696E654465636F726174696F6E28652929295D292C6E657720784F28732E6D696E436F6C756D6E2C732E6D6178436F6C756D6E2C732E636F6E';
wwv_flow_imp.g_varchar2_table(17867) := '74656E742C732E636F6E74696E75657357697468577261707065644C696E652C6E2C692C732E746F6B656E732C742C6F2C732E737461727456697369626C65436F6C756D6E297D676574566965774C696E65446174612865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(17868) := '732E5F6C696E65732E676574566965774C696E65446174612865297D6765744D696E696D61704C696E657352656E646572696E674461746128652C742C6E297B636F6E737420693D746869732E5F6C696E65732E676574566965774C696E657344617461';
wwv_flow_imp.g_varchar2_table(17869) := '28652C742C6E293B72657475726E206E657720434F28746869732E67657454616253697A6528292C69297D676574416C6C4F7665727669657752756C65724465636F726174696F6E732865297B636F6E737420743D746869732E6D6F64656C2E6765744F';
wwv_flow_imp.g_varchar2_table(17870) := '7665727669657752756C65724465636F726174696F6E7328746869732E5F656469746F7249642C524C28746869732E5F636F6E66696775726174696F6E2E6F7074696F6E7329292C6E3D6E65772079423B666F7228636F6E73742069206F662074297B63';
wwv_flow_imp.g_varchar2_table(17871) := '6F6E737420743D692E6F7074696F6E732C6F3D742E6F7665727669657752756C65723B696628216F29636F6E74696E75653B636F6E737420733D6F2E706F736974696F6E3B696628303D3D3D7329636F6E74696E75653B636F6E737420723D6F2E676574';
wwv_flow_imp.g_varchar2_table(17872) := '436F6C6F7228652E76616C7565292C613D746869732E636F6F7264696E61746573436F6E7665727465722E676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28692E72616E67652E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(17873) := '692E72616E67652E7374617274436F6C756D6E292C6C3D746869732E636F6F7264696E61746573436F6E7665727465722E676574566965774C696E654E756D6265724F664D6F64656C506F736974696F6E28692E72616E67652E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(17874) := '6265722C692E72616E67652E656E64436F6C756D6E293B6E2E61636365707428722C742E7A496E6465782C612C6C2C73297D72657475726E206E2E617341727261797D5F696E76616C69646174654465636F726174696F6E73436F6C6F72436163686528';
wwv_flow_imp.g_varchar2_table(17875) := '297B636F6E737420653D746869732E6D6F64656C2E6765744F7665727669657752756C65724465636F726174696F6E7328293B666F7228636F6E73742074206F662065297B636F6E737420653D742E6F7074696F6E732E6F7665727669657752756C6572';
wwv_flow_imp.g_varchar2_table(17876) := '3B6E756C6C3D3D657C7C652E696E76616C6964617465436163686564436F6C6F7228293B636F6E7374206E3D742E6F7074696F6E732E6D696E696D61703B6E756C6C3D3D6E7C7C6E2E696E76616C6964617465436163686564436F6C6F7228297D7D6765';
wwv_flow_imp.g_varchar2_table(17877) := '7456616C7565496E52616E676528652C74297B636F6E7374206E3D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E766572745669657752616E6765546F4D6F64656C52616E67652865293B72657475726E20746869732E6D6F64';
wwv_flow_imp.g_varchar2_table(17878) := '656C2E67657456616C7565496E52616E6765286E2C74297D67657456616C75654C656E677468496E52616E676528652C74297B636F6E7374206E3D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E766572745669657752616E67';
wwv_flow_imp.g_varchar2_table(17879) := '65546F4D6F64656C52616E67652865293B72657475726E20746869732E6D6F64656C2E67657456616C75654C656E677468496E52616E6765286E2C74297D6D6F64696679506F736974696F6E28652C74297B636F6E7374206E3D746869732E636F6F7264';
wwv_flow_imp.g_varchar2_table(17880) := '696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E2865292C693D746869732E6D6F64656C2E6D6F64696679506F736974696F6E286E2C74293B72657475726E20746869732E63';
wwv_flow_imp.g_varchar2_table(17881) := '6F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E2869297D6465647563654D6F64656C506F736974696F6E52656C6174697665546F56696577506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(17882) := '652C742C6E297B636F6E737420693D746869732E636F6F7264696E61746573436F6E7665727465722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E2865293B323D3D3D746869732E6D6F64656C2E676574454F4C';
wwv_flow_imp.g_varchar2_table(17883) := '28292E6C656E677468262628743C303F742D3D6E3A742B3D6E293B636F6E7374206F3D746869732E6D6F64656C2E6765744F666673657441742869292B743B72657475726E20746869732E6D6F64656C2E676574506F736974696F6E4174286F297D6765';
wwv_flow_imp.g_varchar2_table(17884) := '74506C61696E54657874546F436F707928652C742C6E297B636F6E737420693D6E3F225C725C6E223A746869732E6D6F64656C2E676574454F4C28293B28653D652E736C696365283029292E736F72742872682E636F6D7061726552616E676573557369';
wwv_flow_imp.g_varchar2_table(17885) := '6E67537461727473293B6C6574206F3D21312C733D21313B666F7228636F6E73742074206F66206529742E6973456D70747928293F6F3D21303A733D21303B6966282173297B69662821742972657475726E22223B636F6E7374206E3D652E6D61702828';
wwv_flow_imp.g_varchar2_table(17886) := '653D3E652E73746172744C696E654E756D62657229293B6C6574206F3D22223B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B29653E3026266E5B652D315D3D3D3D6E5B655D7C7C286F2B3D746869732E6D6F64656C2E6765744C696E';
wwv_flow_imp.g_varchar2_table(17887) := '65436F6E74656E74286E5B655D292B69293B72657475726E206F7D6966286F262674297B636F6E737420743D5B5D3B6C657420693D303B666F7228636F6E7374206F206F662065297B636F6E737420653D6F2E73746172744C696E654E756D6265723B6F';
wwv_flow_imp.g_varchar2_table(17888) := '2E6973456D70747928293F65213D3D692626742E7075736828746869732E6D6F64656C2E6765744C696E65436F6E74656E74286529293A742E7075736828746869732E6D6F64656C2E67657456616C7565496E52616E6765286F2C6E3F323A3029292C69';
wwv_flow_imp.g_varchar2_table(17889) := '3D657D72657475726E20313D3D3D742E6C656E6774683F745B305D3A747D636F6E737420723D5B5D3B666F7228636F6E73742074206F66206529742E6973456D70747928297C7C722E7075736828746869732E6D6F64656C2E67657456616C7565496E52';
wwv_flow_imp.g_varchar2_table(17890) := '616E676528742C6E3F323A3029293B72657475726E20313D3D3D722E6C656E6774683F725B305D3A727D6765745269636854657874546F436F707928652C74297B636F6E7374206E3D746869732E6D6F64656C2E6765744C616E6775616765496428293B';
wwv_flow_imp.g_varchar2_table(17891) := '6966286E3D3D3D55702972657475726E206E756C6C3B69662831213D3D652E6C656E6774682972657475726E206E756C6C3B6C657420693D655B305D3B696628692E6973456D7074792829297B69662821742972657475726E206E756C6C3B636F6E7374';
wwv_flow_imp.g_varchar2_table(17892) := '20653D692E73746172744C696E654E756D6265723B693D6E657720726828652C746869732E6D6F64656C2E6765744C696E654D696E436F6C756D6E2865292C652C746869732E6D6F64656C2E6765744C696E654D6178436F6C756D6E286529297D636F6E';
wwv_flow_imp.g_varchar2_table(17893) := '7374206F3D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E676574283530292C733D746869732E5F676574436F6C6F724D617028293B6C657420723B72657475726E2F5B3A3B5C5C5C2F3C3E5D2F2E74657374286F2E666F6E7446';
wwv_flow_imp.g_varchar2_table(17894) := '616D696C79297C7C6F2E666F6E7446616D696C793D3D3D4B4C2E666F6E7446616D696C793F723D4B4C2E666F6E7446616D696C793A28723D6F2E666F6E7446616D696C792C723D722E7265706C616365282F222F672C222722292C2F5B2C275D2F2E7465';
wwv_flow_imp.g_varchar2_table(17895) := '73742872297C7C2F5B2B205D2F2E74657374287229262628723D6027247B727D2760292C723D60247B727D2C20247B4B4C2E666F6E7446616D696C797D60292C7B6D6F64653A6E2C68746D6C3A603C646976207374796C653D22636F6C6F723A20247B73';
wwv_flow_imp.g_varchar2_table(17896) := '5B315D7D3B6261636B67726F756E642D636F6C6F723A20247B735B325D7D3B666F6E742D66616D696C793A20247B727D3B666F6E742D7765696768743A20247B6F2E666F6E745765696768747D3B666F6E742D73697A653A20247B6F2E666F6E7453697A';
wwv_flow_imp.g_varchar2_table(17897) := '657D70783B6C696E652D6865696768743A20247B6F2E6C696E654865696768747D70783B77686974652D73706163653A207072653B223E602B746869732E5F67657448544D4C546F436F707928692C73292B223C2F6469763E227D7D5F67657448544D4C';
wwv_flow_imp.g_varchar2_table(17898) := '546F436F707928652C74297B636F6E7374206E3D652E73746172744C696E654E756D6265722C693D652E7374617274436F6C756D6E2C6F3D652E656E644C696E654E756D6265722C733D652E656E64436F6C756D6E2C723D746869732E67657454616253';
wwv_flow_imp.g_varchar2_table(17899) := '697A6528293B6C657420613D22223B666F72286C657420653D6E3B653C3D6F3B652B2B297B636F6E7374206C3D746869732E6D6F64656C2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732865292C633D6C2E6765744C696E65436F6E';
wwv_flow_imp.g_varchar2_table(17900) := '74656E7428292C643D653D3D3D6E3F692D313A302C683D653D3D3D6F3F732D313A632E6C656E6774683B612B3D22223D3D3D633F223C62723E223A6C4528632C6C2E696E666C61746528292C742C642C682C722C6A297D72657475726E20617D5F676574';
wwv_flow_imp.g_varchar2_table(17901) := '436F6C6F724D617028297B636F6E737420653D50772E676574436F6C6F724D617028292C743D5B2223303030303030225D3B6966286529666F72286C6574206E3D312C693D652E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D68752E466F726D6174';
wwv_flow_imp.g_varchar2_table(17902) := '2E4353532E666F726D617448657828655B6E5D293B72657475726E20747D6765745072696D617279437572736F72537461746528297B72657475726E20746869732E5F637572736F722E6765745072696D617279437572736F72537461746528297D6765';
wwv_flow_imp.g_varchar2_table(17903) := '744C6173744164646564437572736F72496E64657828297B72657475726E20746869732E5F637572736F722E6765744C6173744164646564437572736F72496E64657828297D676574437572736F7253746174657328297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(17904) := '5F637572736F722E676574437572736F7253746174657328297D736574437572736F7253746174657328652C742C6E297B72657475726E20746869732E5F77697468566965774576656E7473436F6C6C6563746F722828693D3E746869732E5F63757273';
wwv_flow_imp.g_varchar2_table(17905) := '6F722E73657453746174657328692C652C742C6E2929297D676574437572736F72436F6C756D6E53656C6563744461746128297B72657475726E20746869732E5F637572736F722E676574437572736F72436F6C756D6E53656C6563744461746128297D';
wwv_flow_imp.g_varchar2_table(17906) := '676574437572736F724175746F436C6F7365644368617261637465727328297B72657475726E20746869732E5F637572736F722E6765744175746F436C6F7365644368617261637465727328297D736574437572736F72436F6C756D6E53656C65637444';
wwv_flow_imp.g_varchar2_table(17907) := '6174612865297B746869732E5F637572736F722E736574437572736F72436F6C756D6E53656C656374446174612865297D67657450726576456469744F7065726174696F6E5479706528297B72657475726E20746869732E5F637572736F722E67657450';
wwv_flow_imp.g_varchar2_table(17908) := '726576456469744F7065726174696F6E5479706528297D73657450726576456469744F7065726174696F6E547970652865297B746869732E5F637572736F722E73657450726576456469744F7065726174696F6E547970652865297D67657453656C6563';
wwv_flow_imp.g_varchar2_table(17909) := '74696F6E28297B72657475726E20746869732E5F637572736F722E67657453656C656374696F6E28297D67657453656C656374696F6E7328297B72657475726E20746869732E5F637572736F722E67657453656C656374696F6E7328297D676574506F73';
wwv_flow_imp.g_varchar2_table(17910) := '6974696F6E28297B72657475726E20746869732E5F637572736F722E6765745072696D617279437572736F72537461746528292E6D6F64656C53746174652E706F736974696F6E7D73657453656C656374696F6E7328652C742C6E3D30297B746869732E';
wwv_flow_imp.g_varchar2_table(17911) := '5F77697468566965774576656E7473436F6C6C6563746F722828693D3E746869732E5F637572736F722E73657453656C656374696F6E7328692C652C742C6E2929297D73617665437572736F72537461746528297B72657475726E20746869732E5F6375';
wwv_flow_imp.g_varchar2_table(17912) := '72736F722E73617665537461746528297D726573746F7265437572736F7253746174652865297B746869732E5F77697468566965774576656E7473436F6C6C6563746F722828743D3E746869732E5F637572736F722E726573746F726553746174652874';
wwv_flow_imp.g_varchar2_table(17913) := '2C652929297D5F65786563757465437572736F72456469742865297B746869732E5F637572736F722E636F6E746578742E637572736F72436F6E6669672E726561644F6E6C793F746869732E5F6576656E74446973706174636865722E656D69744F7574';
wwv_flow_imp.g_varchar2_table(17914) := '676F696E674576656E74286E6577204946293A746869732E5F77697468566965774576656E7473436F6C6C6563746F722865297D65786563757465456469747328652C742C6E297B746869732E5F65786563757465437572736F72456469742828693D3E';
wwv_flow_imp.g_varchar2_table(17915) := '746869732E5F637572736F722E65786563757465456469747328692C652C742C6E2929297D7374617274436F6D706F736974696F6E28297B746869732E5F65786563757465437572736F72456469742828653D3E746869732E5F637572736F722E737461';
wwv_flow_imp.g_varchar2_table(17916) := '7274436F6D706F736974696F6E28652929297D656E64436F6D706F736974696F6E2865297B746869732E5F65786563757465437572736F72456469742828743D3E746869732E5F637572736F722E656E64436F6D706F736974696F6E28742C652929297D';
wwv_flow_imp.g_varchar2_table(17917) := '7479706528652C74297B746869732E5F65786563757465437572736F724564697428286E3D3E746869732E5F637572736F722E74797065286E2C652C742929297D636F6D706F736974696F6E5479706528652C742C6E2C692C6F297B746869732E5F6578';
wwv_flow_imp.g_varchar2_table(17918) := '6563757465437572736F72456469742828733D3E746869732E5F637572736F722E636F6D706F736974696F6E5479706528732C652C742C6E2C692C6F2929297D706173746528652C742C6E2C69297B746869732E5F65786563757465437572736F724564';
wwv_flow_imp.g_varchar2_table(17919) := '697428286F3D3E746869732E5F637572736F722E7061737465286F2C652C742C6E2C692929297D6375742865297B746869732E5F65786563757465437572736F72456469742828743D3E746869732E5F637572736F722E63757428742C652929297D6578';
wwv_flow_imp.g_varchar2_table(17920) := '6563757465436F6D6D616E6428652C74297B746869732E5F65786563757465437572736F724564697428286E3D3E746869732E5F637572736F722E65786563757465436F6D6D616E64286E2C652C742929297D65786563757465436F6D6D616E64732865';
wwv_flow_imp.g_varchar2_table(17921) := '2C74297B746869732E5F65786563757465437572736F724564697428286E3D3E746869732E5F637572736F722E65786563757465436F6D6D616E6473286E2C652C742929297D72657665616C416C6C437572736F727328652C742C6E3D2131297B746869';
wwv_flow_imp.g_varchar2_table(17922) := '732E5F77697468566965774576656E7473436F6C6C6563746F722828693D3E746869732E5F637572736F722E72657665616C416C6C28692C652C6E2C302C742C302929297D72657665616C5072696D617279437572736F7228652C742C6E3D2131297B74';
wwv_flow_imp.g_varchar2_table(17923) := '6869732E5F77697468566965774576656E7473436F6C6C6563746F722828693D3E746869732E5F637572736F722E72657665616C5072696D61727928692C652C6E2C302C742C302929297D72657665616C546F704D6F7374437572736F722865297B636F';
wwv_flow_imp.g_varchar2_table(17924) := '6E737420743D746869732E5F637572736F722E676574546F704D6F737456696577506F736974696F6E28292C6E3D6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E293B7468';
wwv_flow_imp.g_varchar2_table(17925) := '69732E5F77697468566965774576656E7473436F6C6C6563746F722828743D3E742E656D6974566965774576656E74286E657720664628652C21312C6E2C6E756C6C2C302C21302C30292929297D72657665616C426F74746F6D4D6F7374437572736F72';
wwv_flow_imp.g_varchar2_table(17926) := '2865297B636F6E737420743D746869732E5F637572736F722E676574426F74746F6D4D6F737456696577506F736974696F6E28292C6E3D6E657720726828742E6C696E654E756D6265722C742E636F6C756D6E2C742E6C696E654E756D6265722C742E63';
wwv_flow_imp.g_varchar2_table(17927) := '6F6C756D6E293B746869732E5F77697468566965774576656E7473436F6C6C6563746F722828743D3E742E656D6974566965774576656E74286E657720664628652C21312C6E2C6E756C6C2C302C21302C30292929297D72657665616C52616E67652865';
wwv_flow_imp.g_varchar2_table(17928) := '2C742C6E2C692C6F297B746869732E5F77697468566965774576656E7473436F6C6C6563746F722828733D3E732E656D6974566965774576656E74286E657720664628652C21312C6E2C6E756C6C2C692C742C6F292929297D6368616E67655768697465';
wwv_flow_imp.g_varchar2_table(17929) := '73706163652865297B746869732E766965774C61796F75742E6368616E676557686974657370616365286529262628746869732E5F6576656E74446973706174636865722E656D697453696E676C65566965774576656E74286E6577207746292C746869';
wwv_flow_imp.g_varchar2_table(17930) := '732E5F6576656E74446973706174636865722E656D69744F7574676F696E674576656E74286E6577204C4629297D5F77697468566965774576656E7473436F6C6C6563746F722865297B7472797B72657475726E206528746869732E5F6576656E744469';
wwv_flow_imp.g_varchar2_table(17931) := '73706174636865722E626567696E456D6974566965774576656E74732829297D66696E616C6C797B746869732E5F6576656E74446973706174636865722E656E64456D6974566965774576656E747328297D7D62617463684576656E74732865297B7468';
wwv_flow_imp.g_varchar2_table(17932) := '69732E5F77697468566965774576656E7473436F6C6C6563746F72282828293D3E7B6528297D29297D6E6F726D616C697A65506F736974696F6E28652C74297B72657475726E20746869732E5F6C696E65732E6E6F726D616C697A65506F736974696F6E';
wwv_flow_imp.g_varchar2_table(17933) := '28652C74297D6765744C696E65496E64656E74436F6C756D6E2865297B72657475726E20746869732E5F6C696E65732E6765744C696E65496E64656E74436F6C756D6E2865297D7D636C617373205F427B737461746963206372656174652865297B636F';
wwv_flow_imp.g_varchar2_table(17934) := '6E737420743D652E5F736574547261636B656452616E6765286E756C6C2C6E657720726828312C312C312C31292C31293B72657475726E206E6577205F4228652C312C21312C742C30297D67657420766965774C696E654E756D62657228297B72657475';
wwv_flow_imp.g_varchar2_table(17935) := '726E20746869732E5F766965774C696E654E756D6265727D67657420697356616C696428297B72657475726E20746869732E5F697356616C69647D676574206D6F64656C547261636B656452616E676528297B72657475726E20746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(17936) := '6C547261636B656452616E67657D6765742073746172744C696E6544656C746128297B72657475726E20746869732E5F73746172744C696E6544656C74617D636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F6D6F64656C3D652C';
wwv_flow_imp.g_varchar2_table(17937) := '746869732E5F766965774C696E654E756D6265723D742C746869732E5F697356616C69643D6E2C746869732E5F6D6F64656C547261636B656452616E67653D692C746869732E5F73746172744C696E6544656C74613D6F7D646973706F736528297B7468';
wwv_flow_imp.g_varchar2_table(17938) := '69732E5F6D6F64656C2E5F736574547261636B656452616E676528746869732E5F6D6F64656C547261636B656452616E67652C6E756C6C2C31297D75706461746528652C74297B636F6E7374206E3D652E636F6F7264696E61746573436F6E7665727465';
wwv_flow_imp.g_varchar2_table(17939) := '722E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E286E6577206D6328742C652E6765744C696E654D696E436F6C756D6E28742929292C693D652E6D6F64656C2E5F736574547261636B656452616E676528746869';
wwv_flow_imp.g_varchar2_table(17940) := '732E5F6D6F64656C547261636B656452616E67652C6E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E292C31292C6F3D652E766965774C61796F75742E676574566572746963';
wwv_flow_imp.g_varchar2_table(17941) := '616C4F6666736574466F724C696E654E756D6265722874292C733D652E766965774C61796F75742E67657443757272656E745363726F6C6C546F7028293B746869732E5F766965774C696E654E756D6265723D742C746869732E5F697356616C69643D21';
wwv_flow_imp.g_varchar2_table(17942) := '302C746869732E5F6D6F64656C547261636B656452616E67653D692C746869732E5F73746172744C696E6544656C74613D732D6F7D696E76616C696461746528297B746869732E5F697356616C69643D21317D7D636C6173732079427B636F6E73747275';
wwv_flow_imp.g_varchar2_table(17943) := '63746F7228297B746869732E5F61734D61703D4F626A6563742E637265617465286E756C6C292C746869732E617341727261793D5B5D7D61636365707428652C742C6E2C692C6F297B636F6E737420733D746869732E5F61734D61705B655D3B69662873';
wwv_flow_imp.g_varchar2_table(17944) := '297B636F6E737420653D732E646174612C743D655B652E6C656E6774682D335D2C723D655B652E6C656E6774682D315D3B696628743D3D3D6F2626722B313E3D6E2972657475726E20766F696428693E72262628655B652E6C656E6774682D315D3D6929';
wwv_flow_imp.g_varchar2_table(17945) := '293B652E70757368286F2C6E2C69297D656C73657B636F6E737420733D6E657720444F28652C742C5B6F2C6E2C695D293B746869732E5F61734D61705B655D3D732C746869732E617341727261792E707573682873297D7D7D636C6173732077427B636F';
wwv_flow_imp.g_varchar2_table(17946) := '6E7374727563746F7228297B746869732E68696464656E41726561733D6E6577204D61702C746869732E73686F756C645265636F6D707574653D21312C746869732E72616E6765733D5B5D7D73657448696464656E417265617328652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(17947) := '74206E3D746869732E68696464656E41726561732E6765742865293B6E26264342286E2C74297C7C28746869732E68696464656E41726561732E73657428652C74292C746869732E73686F756C645265636F6D707574653D2130297D6765744D65726765';
wwv_flow_imp.g_varchar2_table(17948) := '6452616E67657328297B69662821746869732E73686F756C645265636F6D707574652972657475726E20746869732E72616E6765733B746869732E73686F756C645265636F6D707574653D21313B636F6E737420653D41727261792E66726F6D28746869';
wwv_flow_imp.g_varchar2_table(17949) := '732E68696464656E41726561732E76616C7565732829292E726564756365282828652C74293D3E66756E6374696F6E28652C74297B636F6E7374206E3D5B5D3B6C657420693D302C6F3D303B666F72283B693C652E6C656E67746826266F3C742E6C656E';
wwv_flow_imp.g_varchar2_table(17950) := '6774683B297B636F6E737420733D655B695D2C723D745B6F5D3B696628732E656E644C696E654E756D6265723C722E73746172744C696E654E756D6265722D31296E2E7075736828655B692B2B5D293B656C736520696628722E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(17951) := '6265723C732E73746172744C696E654E756D6265722D31296E2E7075736828745B6F2B2B5D293B656C73657B636F6E737420653D4D6174682E6D696E28732E73746172744C696E654E756D6265722C722E73746172744C696E654E756D626572292C743D';
wwv_flow_imp.g_varchar2_table(17952) := '4D6174682E6D617828732E656E644C696E654E756D6265722C722E656E644C696E654E756D626572293B6E2E70757368286E657720726828652C312C742C3129292C692B2B2C6F2B2B7D7D666F72283B693C652E6C656E6774683B296E2E707573682865';
wwv_flow_imp.g_varchar2_table(17953) := '5B692B2B5D293B666F72283B6F3C742E6C656E6774683B296E2E7075736828745B6F2B2B5D293B72657475726E206E7D28652C7429292C5B5D293B72657475726E20434228746869732E72616E6765732C65297C7C28746869732E72616E6765733D6529';
wwv_flow_imp.g_varchar2_table(17954) := '2C746869732E72616E6765737D7D66756E6374696F6E20434228652C74297B696628652E6C656E677468213D3D742E6C656E6774682972657475726E21313B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B2969662821655B6E5D2E65';
wwv_flow_imp.g_varchar2_table(17955) := '7175616C7352616E676528745B6E5D292972657475726E21313B72657475726E21307D636C6173732053427B636F6E7374727563746F7228652C74297B746869732E76696577706F727453746172744D6F64656C506F736974696F6E3D652C746869732E';
wwv_flow_imp.g_varchar2_table(17956) := '73746172744C696E6544656C74613D747D7265636F76657256696577706F7274537461727428652C74297B69662821746869732E76696577706F727453746172744D6F64656C506F736974696F6E2972657475726E3B636F6E7374206E3D652E636F6E76';
wwv_flow_imp.g_varchar2_table(17957) := '6572744D6F64656C506F736974696F6E546F56696577506F736974696F6E28746869732E76696577706F727453746172744D6F64656C506F736974696F6E292C693D742E676574566572746963616C4F6666736574466F724C696E654E756D626572286E';
wwv_flow_imp.g_varchar2_table(17958) := '2E6C696E654E756D626572293B742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A692B746869732E73746172744C696E6544656C74617D2C31297D7D636C6173732078427B636F6E7374727563746F72282E2E2E65297B7468';
wwv_flow_imp.g_varchar2_table(17959) := '69732E5F656E74726965733D6E6577204D61703B666F7228636F6E73745B742C6E5D6F66206529746869732E73657428742C6E297D73657428652C74297B636F6E7374206E3D746869732E5F656E74726965732E6765742865293B72657475726E207468';
wwv_flow_imp.g_varchar2_table(17960) := '69732E5F656E74726965732E73657428652C74292C6E7D6765742865297B72657475726E20746869732E5F656E74726965732E6765742865297D7D766172206B422C45423D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(17961) := '2C69297B74286E2C692C65297D7D3B6C6574204C423D6B423D636C61737320657874656E6473206C747B67657420697353696D706C6557696467657428297B72657475726E20746869732E5F636F6E66696775726174696F6E2E697353696D706C655769';
wwv_flow_imp.g_varchar2_table(17962) := '646765747D67657420636F6E746578744D656E75496428297B72657475726E20746869732E5F636F6E66696775726174696F6E2E636F6E746578744D656E7549647D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C';
wwv_flow_imp.g_varchar2_table(17963) := '68297B76617220752C703B737570657228292C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D642C746869732E5F64656C697665727951756575653D6E65772053742C746869732E5F636F6E747269627574696F6E';
wwv_flow_imp.g_varchar2_table(17964) := '733D746869732E5F7265676973746572286E6577205752292C746869732E5F6F6E446964446973706F73653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964446973706F73653D746869732E5F6F6E44696444697370';
wwv_flow_imp.g_varchar2_table(17965) := '6F73652E6576656E742C746869732E5F6F6E4469644368616E67654D6F64656C436F6E74656E743D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C';
wwv_flow_imp.g_varchar2_table(17966) := '746869732E6F6E4469644368616E67654D6F64656C436F6E74656E743D746869732E5F6F6E4469644368616E67654D6F64656C436F6E74656E742E6576656E742C746869732E5F6F6E4469644368616E67654D6F64656C4C616E67756167653D74686973';
wwv_flow_imp.g_varchar2_table(17967) := '2E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E67654D6F64656C4C616E67756167653D746869732E5F6F6E446964436861';
wwv_flow_imp.g_varchar2_table(17968) := '6E67654D6F64656C4C616E67756167652E6576656E742C746869732E5F6F6E4469644368616E67654D6F64656C4C616E6775616765436F6E66696775726174696F6E3D746869732E5F7265676973746572286E6577204374287B64656C69766572795175';
wwv_flow_imp.g_varchar2_table(17969) := '6575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E67654D6F64656C4C616E6775616765436F6E66696775726174696F6E3D746869732E5F6F6E4469644368616E67654D6F64656C4C616E6775616765';
wwv_flow_imp.g_varchar2_table(17970) := '436F6E66696775726174696F6E2E6576656E742C746869732E5F6F6E4469644368616E67654D6F64656C4F7074696F6E733D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C69766572';
wwv_flow_imp.g_varchar2_table(17971) := '7951756575657D29292C746869732E6F6E4469644368616E67654D6F64656C4F7074696F6E733D746869732E5F6F6E4469644368616E67654D6F64656C4F7074696F6E732E6576656E742C746869732E5F6F6E4469644368616E67654D6F64656C446563';
wwv_flow_imp.g_varchar2_table(17972) := '6F726174696F6E733D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E67654D6F64656C4465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(17973) := '733D746869732E5F6F6E4469644368616E67654D6F64656C4465636F726174696F6E732E6576656E742C746869732E5F6F6E4469644368616E67654D6F64656C546F6B656E733D746869732E5F7265676973746572286E6577204374287B64656C697665';
wwv_flow_imp.g_varchar2_table(17974) := '727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E67654D6F64656C546F6B656E733D746869732E5F6F6E4469644368616E67654D6F64656C546F6B656E732E6576656E742C746869732E5F';
wwv_flow_imp.g_varchar2_table(17975) := '6F6E4469644368616E6765436F6E66696775726174696F6E3D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(17976) := '65436F6E66696775726174696F6E3D746869732E5F6F6E4469644368616E6765436F6E66696775726174696F6E2E6576656E742C746869732E5F6F6E57696C6C4368616E67654D6F64656C3D746869732E5F7265676973746572286E6577204374287B64';
wwv_flow_imp.g_varchar2_table(17977) := '656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E57696C6C4368616E67654D6F64656C3D746869732E5F6F6E57696C6C4368616E67654D6F64656C2E6576656E742C746869732E5F6F6E446964';
wwv_flow_imp.g_varchar2_table(17978) := '4368616E67654D6F64656C3D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E67654D6F64656C3D746869732E5F';
wwv_flow_imp.g_varchar2_table(17979) := '6F6E4469644368616E67654D6F64656C2E6576656E742C746869732E5F6F6E4469644368616E6765437572736F72506F736974696F6E3D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F6465';
wwv_flow_imp.g_varchar2_table(17980) := '6C697665727951756575657D29292C746869732E6F6E4469644368616E6765437572736F72506F736974696F6E3D746869732E5F6F6E4469644368616E6765437572736F72506F736974696F6E2E6576656E742C746869732E5F6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(17981) := '65437572736F7253656C656374696F6E3D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E6765437572736F7253';
wwv_flow_imp.g_varchar2_table(17982) := '656C656374696F6E3D746869732E5F6F6E4469644368616E6765437572736F7253656C656374696F6E2E6576656E742C746869732E5F6F6E446964417474656D7074526561644F6E6C79456469743D746869732E5F7265676973746572286E6577204D42';
wwv_flow_imp.g_varchar2_table(17983) := '28746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E446964417474656D7074526561644F6E6C79456469743D746869732E5F6F6E446964417474656D7074526561644F6E6C7945';
wwv_flow_imp.g_varchar2_table(17984) := '6469742E6576656E742C746869732E5F6F6E4469644C61796F75744368616E67653D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F';
wwv_flow_imp.g_varchar2_table(17985) := '6E4469644C61796F75744368616E67653D746869732E5F6F6E4469644C61796F75744368616E67652E6576656E742C746869732E5F656469746F7254657874466F6375733D746869732E5F7265676973746572286E6577204942287B64656C6976657279';
wwv_flow_imp.g_varchar2_table(17986) := '51756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E446964466F637573456469746F72546578743D746869732E5F656469746F7254657874466F6375732E6F6E4469644368616E6765546F547275652C746869732E';
wwv_flow_imp.g_varchar2_table(17987) := '6F6E446964426C7572456469746F72546578743D746869732E5F656469746F7254657874466F6375732E6F6E4469644368616E6765546F46616C73652C746869732E5F656469746F72576964676574466F6375733D746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(17988) := '6E6577204942287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E446964466F637573456469746F725769646765743D746869732E5F656469746F72576964676574466F6375732E6F6E44';
wwv_flow_imp.g_varchar2_table(17989) := '69644368616E6765546F547275652C746869732E6F6E446964426C7572456469746F725769646765743D746869732E5F656469746F72576964676574466F6375732E6F6E4469644368616E6765546F46616C73652C746869732E5F6F6E57696C6C547970';
wwv_flow_imp.g_varchar2_table(17990) := '653D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E57696C6C547970653D746869732E5F6F6E57696C6C547970652E65';
wwv_flow_imp.g_varchar2_table(17991) := '76656E742C746869732E5F6F6E446964547970653D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E446964547970653D';
wwv_flow_imp.g_varchar2_table(17992) := '746869732E5F6F6E446964547970652E6576656E742C746869732E5F6F6E446964436F6D706F736974696F6E53746172743D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F6465';
wwv_flow_imp.g_varchar2_table(17993) := '6C6976657279517565756529292C746869732E6F6E446964436F6D706F736974696F6E53746172743D746869732E5F6F6E446964436F6D706F736974696F6E53746172742E6576656E742C746869732E5F6F6E446964436F6D706F736974696F6E456E64';
wwv_flow_imp.g_varchar2_table(17994) := '3D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E446964436F6D706F736974696F6E456E643D746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(17995) := '64436F6D706F736974696F6E456E642E6576656E742C746869732E5F6F6E44696450617374653D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C69766572795175657565';
wwv_flow_imp.g_varchar2_table(17996) := '29292C746869732E6F6E44696450617374653D746869732E5F6F6E44696450617374652E6576656E742C746869732E5F6F6E4D6F75736555703D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C';
wwv_flow_imp.g_varchar2_table(17997) := '746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F75736555703D746869732E5F6F6E4D6F75736555702E6576656E742C746869732E5F6F6E4D6F757365446F776E3D746869732E5F7265676973746572286E6577204D422874';
wwv_flow_imp.g_varchar2_table(17998) := '6869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F757365446F776E3D746869732E5F6F6E4D6F757365446F776E2E6576656E742C746869732E5F6F6E4D6F757365447261673D';
wwv_flow_imp.g_varchar2_table(17999) := '746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F757365447261673D746869732E5F6F6E4D6F757365447261672E65';
wwv_flow_imp.g_varchar2_table(18000) := '76656E742C746869732E5F6F6E4D6F75736544726F703D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F75736544';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(18001) := '726F703D746869732E5F6F6E4D6F75736544726F702E6576656E742C746869732E5F6F6E4D6F75736544726F7043616E63656C65643D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C74686973';
wwv_flow_imp.g_varchar2_table(18002) := '2E5F64656C6976657279517565756529292C746869732E6F6E4D6F75736544726F7043616E63656C65643D746869732E5F6F6E4D6F75736544726F7043616E63656C65642E6576656E742C746869732E5F6F6E44726F70496E746F456469746F723D7468';
wwv_flow_imp.g_varchar2_table(18003) := '69732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E44726F70496E746F456469746F723D746869732E5F6F6E44726F70496E746F';
wwv_flow_imp.g_varchar2_table(18004) := '456469746F722E6576656E742C746869732E5F6F6E436F6E746578744D656E753D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869';
wwv_flow_imp.g_varchar2_table(18005) := '732E6F6E436F6E746578744D656E753D746869732E5F6F6E436F6E746578744D656E752E6576656E742C746869732E5F6F6E4D6F7573654D6F76653D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E';
wwv_flow_imp.g_varchar2_table(18006) := '732C746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F7573654D6F76653D746869732E5F6F6E4D6F7573654D6F76652E6576656E742C746869732E5F6F6E4D6F7573654C656176653D746869732E5F7265676973746572286E';
wwv_flow_imp.g_varchar2_table(18007) := '6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F7573654C656176653D746869732E5F6F6E4D6F7573654C656176652E6576656E742C746869732E5F6F6E4D';
wwv_flow_imp.g_varchar2_table(18008) := '6F757365576865656C3D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E6F6E4D6F757365576865656C3D746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(18009) := '4D6F757365576865656C2E6576656E742C746869732E5F6F6E4B657955703D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279517565756529292C746869732E';
wwv_flow_imp.g_varchar2_table(18010) := '6F6E4B657955703D746869732E5F6F6E4B657955702E6576656E742C746869732E5F6F6E4B6579446F776E3D746869732E5F7265676973746572286E6577204D4228746869732E5F636F6E747269627574696F6E732C746869732E5F64656C6976657279';
wwv_flow_imp.g_varchar2_table(18011) := '517565756529292C746869732E6F6E4B6579446F776E3D746869732E5F6F6E4B6579446F776E2E6576656E742C746869732E5F6F6E446964436F6E74656E7453697A654368616E67653D746869732E5F7265676973746572286E6577204374287B64656C';
wwv_flow_imp.g_varchar2_table(18012) := '697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E446964436F6E74656E7453697A654368616E67653D746869732E5F6F6E446964436F6E74656E7453697A654368616E67652E6576656E742C746869';
wwv_flow_imp.g_varchar2_table(18013) := '732E5F6F6E4469645363726F6C6C4368616E67653D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469645363726F6C6C436861';
wwv_flow_imp.g_varchar2_table(18014) := '6E67653D746869732E5F6F6E4469645363726F6C6C4368616E67652E6576656E742C746869732E5F6F6E4469644368616E6765566965775A6F6E65733D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A7468';
wwv_flow_imp.g_varchar2_table(18015) := '69732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E6765566965775A6F6E65733D746869732E5F6F6E4469644368616E6765566965775A6F6E65732E6576656E742C746869732E5F6F6E4469644368616E6765486964';
wwv_flow_imp.g_varchar2_table(18016) := '64656E41726561733D746869732E5F7265676973746572286E6577204374287B64656C697665727951756575653A746869732E5F64656C697665727951756575657D29292C746869732E6F6E4469644368616E676548696464656E41726561733D746869';
wwv_flow_imp.g_varchar2_table(18017) := '732E5F6F6E4469644368616E676548696464656E41726561732E6576656E742C746869732E5F616374696F6E733D6E6577204D61702C746869732E5F62616E6E6572446F6D4E6F64653D6E756C6C2C746869732E5F64726F70496E746F456469746F7244';
wwv_flow_imp.g_varchar2_table(18018) := '65636F726174696F6E733D746869732E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C6F2E77696C6C437265617465436F6465456469746F7228293B636F6E737420673D7B2E2E2E747D3B6C6574206D3B746869732E5F646F';
wwv_flow_imp.g_varchar2_table(18019) := '6D456C656D656E743D652C746869732E5F6F766572666C6F7757696467657473446F6D4E6F64653D672E6F766572666C6F7757696467657473446F6D4E6F64652C64656C65746520672E6F766572666C6F7757696467657473446F6D4E6F64652C746869';
wwv_flow_imp.g_varchar2_table(18020) := '732E5F69643D2B2B44422C746869732E5F6465636F726174696F6E547970654B657973546F4964733D7B7D2C746869732E5F6465636F726174696F6E5479706553756274797065733D7B7D2C746869732E5F74656C656D65747279446174613D6E2E7465';
wwv_flow_imp.g_varchar2_table(18021) := '6C656D65747279446174612C746869732E5F636F6E66696775726174696F6E3D746869732E5F726567697374657228746869732E5F637265617465436F6E66696775726174696F6E286E2E697353696D706C655769646765747C7C21312C6E756C6C213D';
wwv_flow_imp.g_varchar2_table(18022) := '3D28753D6E2E636F6E746578744D656E754964292626766F69642030213D3D753F753A6E2E697353696D706C655769646765743F4C642E53696D706C65456469746F72436F6E746578743A4C642E456469746F72436F6E746578742C672C6329292C7468';
wwv_flow_imp.g_varchar2_table(18023) := '69732E5F726567697374657228746869732E5F636F6E66696775726174696F6E2E6F6E4469644368616E67652828653D3E7B746869732E5F6F6E4469644368616E6765436F6E66696775726174696F6E2E666972652865293B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(18024) := '732E5F636F6E66696775726174696F6E2E6F7074696F6E733B696628652E6861734368616E6765642831343529297B636F6E737420653D742E67657428313435293B746869732E5F6F6E4469644C61796F75744368616E67652E666972652865297D7D29';
wwv_flow_imp.g_varchar2_table(18025) := '29292C746869732E5F636F6E746578744B6579536572766963653D746869732E5F726567697374657228722E63726561746553636F70656428746869732E5F646F6D456C656D656E7429292C746869732E5F6E6F74696669636174696F6E536572766963';
wwv_flow_imp.g_varchar2_table(18026) := '653D6C2C746869732E5F636F6465456469746F72536572766963653D6F2C746869732E5F636F6D6D616E64536572766963653D732C746869732E5F7468656D65536572766963653D612C746869732E5F7265676973746572286E65772041422874686973';
wwv_flow_imp.g_varchar2_table(18027) := '2C746869732E5F636F6E746578744B65795365727669636529292C746869732E5F7265676973746572286E6577204E4228746869732C746869732E5F636F6E746578744B6579536572766963652C6829292C746869732E5F696E7374616E74696174696F';
wwv_flow_imp.g_varchar2_table(18028) := '6E536572766963653D692E6372656174654368696C64286E6577207842285B63642C746869732E5F636F6E746578744B6579536572766963655D29292C746869732E5F6D6F64656C446174613D6E756C6C2C746869732E5F666F637573547261636B6572';
wwv_flow_imp.g_varchar2_table(18029) := '3D6E657720504228652C746869732E5F6F766572666C6F7757696467657473446F6D4E6F6465292C746869732E5F726567697374657228746869732E5F666F637573547261636B65722E6F6E4368616E6765282828293D3E7B746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(18030) := '72576964676574466F6375732E73657456616C756528746869732E5F666F637573547261636B65722E686173466F6375732829297D2929292C746869732E5F636F6E74656E74576964676574733D7B7D2C746869732E5F6F7665726C6179576964676574';
wwv_flow_imp.g_varchar2_table(18031) := '733D7B7D2C746869732E5F676C7970684D617267696E576964676574733D7B7D2C6D3D41727261792E69734172726179286E2E636F6E747269627574696F6E73293F6E2E636F6E747269627574696F6E733A65682E676574456469746F72436F6E747269';
wwv_flow_imp.g_varchar2_table(18032) := '627574696F6E7328292C746869732E5F636F6E747269627574696F6E732E696E697469616C697A6528746869732C6D2C746869732E5F696E7374616E74696174696F6E53657276696365293B666F7228636F6E73742065206F662065682E676574456469';
wwv_flow_imp.g_varchar2_table(18033) := '746F72416374696F6E732829297B696628746869732E5F616374696F6E732E68617328652E696429297B6B65286E6577204572726F72286043616E6E6F7420686176652074776F20616374696F6E732077697468207468652073616D6520696420247B65';
wwv_flow_imp.g_varchar2_table(18034) := '2E69647D6029293B636F6E74696E75657D636F6E737420743D6E6577206A5228652E69642C652E6C6162656C2C652E616C6961732C652E6D657461646174612C6E756C6C213D3D28703D652E707265636F6E646974696F6E292626766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(18035) := '703F703A766F696420302C28743D3E746869732E5F696E7374616E74696174696F6E536572766963652E696E766F6B6546756E6374696F6E28286E3D3E50726F6D6973652E7265736F6C766528652E72756E456469746F72436F6D6D616E64286E2C7468';
wwv_flow_imp.g_varchar2_table(18036) := '69732C7429292929292C746869732E5F636F6E746578744B657953657276696365293B746869732E5F616374696F6E732E73657428742E69642C74297D636F6E737420663D28293D3E21746869732E5F636F6E66696775726174696F6E2E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(18037) := '732E676574283931292626746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E676574283336292E656E61626C65643B746869732E5F7265676973746572286E657720447228746869732E5F646F6D456C656D656E742C7B6F6E447261';
wwv_flow_imp.g_varchar2_table(18038) := '674F7665723A653D3E7B696628216628292972657475726E3B636F6E737420743D746869732E6765745461726765744174436C69656E74506F696E7428652E636C69656E74582C652E636C69656E7459293B286E756C6C3D3D743F766F696420303A742E';
wwv_flow_imp.g_varchar2_table(18039) := '706F736974696F6E292626746869732E73686F7744726F70496E64696361746F72417428742E706F736974696F6E297D2C6F6E44726F703A6173796E6320653D3E7B696628216628292972657475726E3B696628746869732E72656D6F766544726F7049';
wwv_flow_imp.g_varchar2_table(18040) := '6E64696361746F7228292C21652E646174615472616E736665722972657475726E3B636F6E737420743D746869732E6765745461726765744174436C69656E74506F696E7428652E636C69656E74582C652E636C69656E7459293B286E756C6C3D3D743F';
wwv_flow_imp.g_varchar2_table(18041) := '766F696420303A742E706F736974696F6E292626746869732E5F6F6E44726F70496E746F456469746F722E66697265287B706F736974696F6E3A742E706F736974696F6E2C6576656E743A657D297D2C6F6E447261674C656176653A28293D3E7B746869';
wwv_flow_imp.g_varchar2_table(18042) := '732E72656D6F766544726F70496E64696361746F7228297D2C6F6E44726167456E643A28293D3E7B746869732E72656D6F766544726F70496E64696361746F7228297D7D29292C746869732E5F636F6465456469746F72536572766963652E616464436F';
wwv_flow_imp.g_varchar2_table(18043) := '6465456469746F722874686973297D777269746553637265656E526561646572436F6E74656E742865297B76617220743B6E756C6C3D3D3D28743D746869732E5F6D6F64656C44617461297C7C766F696420303D3D3D747C7C742E766965772E77726974';
wwv_flow_imp.g_varchar2_table(18044) := '6553637265656E526561646572436F6E74656E742865297D5F637265617465436F6E66696775726174696F6E28652C742C6E2C69297B72657475726E206E6577204E4128652C742C6E2C746869732E5F646F6D456C656D656E742C69297D676574496428';
wwv_flow_imp.g_varchar2_table(18045) := '297B72657475726E20746869732E676574456469746F725479706528292B223A222B746869732E5F69647D676574456469746F725479706528297B72657475726E2071522E49436F6465456469746F727D646973706F736528297B746869732E5F636F64';
wwv_flow_imp.g_varchar2_table(18046) := '65456469746F72536572766963652E72656D6F7665436F6465456469746F722874686973292C746869732E5F666F637573547261636B65722E646973706F736528292C746869732E5F616374696F6E732E636C65617228292C746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(18047) := '6E74576964676574733D7B7D2C746869732E5F6F7665726C6179576964676574733D7B7D2C746869732E5F72656D6F76654465636F726174696F6E547970657328292C746869732E5F706F73744465746163684D6F64656C436C65616E75702874686973';
wwv_flow_imp.g_varchar2_table(18048) := '2E5F6465746163684D6F64656C2829292C746869732E5F6F6E446964446973706F73652E6669726528292C73757065722E646973706F736528297D696E766F6B6557697468696E436F6E746578742865297B72657475726E20746869732E5F696E737461';
wwv_flow_imp.g_varchar2_table(18049) := '6E74696174696F6E536572766963652E696E766F6B6546756E6374696F6E2865297D7570646174654F7074696F6E732865297B746869732E5F636F6E66696775726174696F6E2E7570646174654F7074696F6E7328657C7C7B7D297D6765744F7074696F';
wwv_flow_imp.g_varchar2_table(18050) := '6E7328297B72657475726E20746869732E5F636F6E66696775726174696F6E2E6F7074696F6E737D6765744F7074696F6E2865297B72657475726E20746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E6765742865297D6765745261';
wwv_flow_imp.g_varchar2_table(18051) := '774F7074696F6E7328297B72657475726E20746869732E5F636F6E66696775726174696F6E2E6765745261774F7074696F6E7328297D6765744F766572666C6F7757696467657473446F6D4E6F646528297B72657475726E20746869732E5F6F76657266';
wwv_flow_imp.g_varchar2_table(18052) := '6C6F7757696467657473446F6D4E6F64657D676574436F6E66696775726564576F72644174506F736974696F6E2865297B72657475726E20746869732E5F6D6F64656C446174613F68532E676574576F72644174506F736974696F6E28746869732E5F6D';
wwv_flow_imp.g_varchar2_table(18053) := '6F64656C446174612E6D6F64656C2C746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E67657428313331292C746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E67657428313330292C65293A6E756C6C7D676574';
wwv_flow_imp.g_varchar2_table(18054) := '56616C756528653D6E756C6C297B69662821746869732E5F6D6F64656C446174612972657475726E22223B636F6E737420743D212821657C7C21652E7072657365727665424F4D293B6C6574206E3D303B72657475726E20652626652E6C696E65456E64';
wwv_flow_imp.g_varchar2_table(18055) := '696E672626225C6E223D3D3D652E6C696E65456E64696E673F6E3D313A652626652E6C696E65456E64696E672626225C725C6E223D3D3D652E6C696E65456E64696E672626286E3D32292C746869732E5F6D6F64656C446174612E6D6F64656C2E676574';
wwv_flow_imp.g_varchar2_table(18056) := '56616C7565286E2C74297D73657456616C75652865297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6D6F64656C2E73657456616C75652865297D6765744D6F64656C28297B72657475726E20746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(18057) := '64656C446174613F746869732E5F6D6F64656C446174612E6D6F64656C3A6E756C6C7D7365744D6F64656C28653D6E756C6C297B76617220743B636F6E7374206E3D653B6966286E756C6C3D3D3D746869732E5F6D6F64656C4461746126266E756C6C3D';
wwv_flow_imp.g_varchar2_table(18058) := '3D3D6E2972657475726E3B696628746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6D6F64656C3D3D3D6E2972657475726E3B636F6E737420693D7B6F6C644D6F64656C55726C3A286E756C6C3D3D3D28743D74686973';
wwv_flow_imp.g_varchar2_table(18059) := '2E5F6D6F64656C44617461297C7C766F696420303D3D3D743F766F696420303A742E6D6F64656C2E757269297C7C6E756C6C2C6E65774D6F64656C55726C3A286E756C6C3D3D6E3F766F696420303A6E2E757269297C7C6E756C6C7D3B746869732E5F6F';
wwv_flow_imp.g_varchar2_table(18060) := '6E57696C6C4368616E67654D6F64656C2E666972652869293B636F6E7374206F3D746869732E68617354657874466F63757328292C733D746869732E5F6465746163684D6F64656C28293B746869732E5F6174746163684D6F64656C286E292C6F262674';
wwv_flow_imp.g_varchar2_table(18061) := '6869732E6861734D6F64656C28292626746869732E666F63757328292C746869732E5F72656D6F76654465636F726174696F6E547970657328292C746869732E5F6F6E4469644368616E67654D6F64656C2E666972652869292C746869732E5F706F7374';
wwv_flow_imp.g_varchar2_table(18062) := '4465746163684D6F64656C436C65616E75702873292C746869732E5F636F6E747269627574696F6E73446973706F7361626C653D746869732E5F636F6E747269627574696F6E732E6F6E41667465724D6F64656C417474616368656428297D5F72656D6F';
wwv_flow_imp.g_varchar2_table(18063) := '76654465636F726174696F6E547970657328297B696628746869732E5F6465636F726174696F6E547970654B657973546F4964733D7B7D2C746869732E5F6465636F726174696F6E547970655375627479706573297B666F7228636F6E7374206520696E';
wwv_flow_imp.g_varchar2_table(18064) := '20746869732E5F6465636F726174696F6E547970655375627479706573297B636F6E737420743D746869732E5F6465636F726174696F6E5479706553756274797065735B655D3B666F7228636F6E7374206E20696E207429746869732E5F72656D6F7665';
wwv_flow_imp.g_varchar2_table(18065) := '4465636F726174696F6E5479706528652B222D222B6E297D746869732E5F6465636F726174696F6E5479706553756274797065733D7B7D7D7D67657456697369626C6552616E67657328297B72657475726E20746869732E5F6D6F64656C446174613F74';
wwv_flow_imp.g_varchar2_table(18066) := '6869732E5F6D6F64656C446174612E766965774D6F64656C2E67657456697369626C6552616E67657328293A5B5D7D67657456697369626C6552616E676573506C757356696577706F727441626F766542656C6F7728297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(18067) := '5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E67657456697369626C6552616E676573506C757356696577706F727441626F766542656C6F7728293A5B5D7D676574576869746573706163657328297B7265';
wwv_flow_imp.g_varchar2_table(18068) := '7475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E676574576869746573706163657328293A5B5D7D737461746963205F676574566572746963616C4F6666';
wwv_flow_imp.g_varchar2_table(18069) := '7365744166746572506F736974696F6E28652C742C6E2C69297B636F6E7374206F3D652E6D6F64656C2E76616C6964617465506F736974696F6E287B6C696E654E756D6265723A742C636F6C756D6E3A6E7D292C733D652E766965774D6F64656C2E636F';
wwv_flow_imp.g_varchar2_table(18070) := '6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286F293B72657475726E20652E766965774D6F64656C2E766965774C61796F75742E676574566572746963616C4F66';
wwv_flow_imp.g_varchar2_table(18071) := '6673657441667465724C696E654E756D62657228732E6C696E654E756D6265722C69297D676574546F70466F724C696E654E756D62657228652C743D2131297B72657475726E20746869732E5F6D6F64656C446174613F6B422E5F676574566572746963';
wwv_flow_imp.g_varchar2_table(18072) := '616C4F6666736574466F72506F736974696F6E28746869732E5F6D6F64656C446174612C652C312C74293A2D317D676574546F70466F72506F736974696F6E28652C74297B72657475726E20746869732E5F6D6F64656C446174613F6B422E5F67657456';
wwv_flow_imp.g_varchar2_table(18073) := '6572746963616C4F6666736574466F72506F736974696F6E28746869732E5F6D6F64656C446174612C652C742C2131293A2D317D737461746963205F676574566572746963616C4F6666736574466F72506F736974696F6E28652C742C6E2C693D213129';
wwv_flow_imp.g_varchar2_table(18074) := '7B636F6E7374206F3D652E6D6F64656C2E76616C6964617465506F736974696F6E287B6C696E654E756D6265723A742C636F6C756D6E3A6E7D292C733D652E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E766572';
wwv_flow_imp.g_varchar2_table(18075) := '744D6F64656C506F736974696F6E546F56696577506F736974696F6E286F293B72657475726E20652E766965774D6F64656C2E766965774C61796F75742E676574566572746963616C4F6666736574466F724C696E654E756D62657228732E6C696E654E';
wwv_flow_imp.g_varchar2_table(18076) := '756D6265722C69297D676574426F74746F6D466F724C696E654E756D62657228652C743D2131297B72657475726E20746869732E5F6D6F64656C446174613F6B422E5F676574566572746963616C4F66667365744166746572506F736974696F6E287468';
wwv_flow_imp.g_varchar2_table(18077) := '69732E5F6D6F64656C446174612C652C312C74293A2D317D73657448696464656E417265617328652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E5F6D6F64656C44617461297C7C766F696420303D3D3D6E7C7C6E2E766965774D6F6465';
wwv_flow_imp.g_varchar2_table(18078) := '6C2E73657448696464656E417265617328652E6D61702828653D3E72682E6C69667428652929292C74297D67657456697369626C65436F6C756D6E46726F6D506F736974696F6E2865297B69662821746869732E5F6D6F64656C44617461297265747572';
wwv_flow_imp.g_varchar2_table(18079) := '6E20652E636F6C756D6E3B636F6E737420743D746869732E5F6D6F64656C446174612E6D6F64656C2E76616C6964617465506F736974696F6E2865292C6E3D746869732E5F6D6F64656C446174612E6D6F64656C2E6765744F7074696F6E7328292E7461';
wwv_flow_imp.g_varchar2_table(18080) := '6253697A653B72657475726E2070752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28746869732E5F6D6F64656C446174612E6D6F64656C2E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C742E636F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(18081) := '6E292B317D676574506F736974696F6E28297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E676574506F736974696F6E28293A6E756C6C7D736574506F736974696F6E2865';
wwv_flow_imp.g_varchar2_table(18082) := '2C743D2261706922297B696628746869732E5F6D6F64656C44617461297B696628216D632E697349506F736974696F6E286529297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B746869732E5F6D6F64656C';
wwv_flow_imp.g_varchar2_table(18083) := '446174612E766965774D6F64656C2E73657453656C656374696F6E7328742C5B7B73656C656374696F6E53746172744C696E654E756D6265723A652E6C696E654E756D6265722C73656C656374696F6E5374617274436F6C756D6E3A652E636F6C756D6E';
wwv_flow_imp.g_varchar2_table(18084) := '2C706F736974696F6E4C696E654E756D6265723A652E6C696E654E756D6265722C706F736974696F6E436F6C756D6E3A652E636F6C756D6E7D5D297D7D5F73656E6452657665616C52616E676528652C742C6E2C69297B69662821746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(18085) := '656C446174612972657475726E3B6966282172682E69734952616E6765286529297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B636F6E7374206F3D746869732E5F6D6F64656C446174612E6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(18086) := '76616C696461746552616E67652865292C733D746869732E5F6D6F64656C446174612E766965774D6F64656C2E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C52616E6765546F5669657752616E6765286F293B7468';
wwv_flow_imp.g_varchar2_table(18087) := '69732E5F6D6F64656C446174612E766965774D6F64656C2E72657665616C52616E67652822617069222C6E2C732C742C69297D72657665616C4C696E6528652C743D30297B746869732E5F72657665616C4C696E6528652C302C74297D72657665616C4C';
wwv_flow_imp.g_varchar2_table(18088) := '696E65496E43656E74657228652C743D30297B746869732E5F72657665616C4C696E6528652C312C74297D72657665616C4C696E65496E43656E74657249664F75747369646556696577706F727428652C743D30297B746869732E5F72657665616C4C69';
wwv_flow_imp.g_varchar2_table(18089) := '6E6528652C322C74297D72657665616C4C696E654E656172546F7028652C743D30297B746869732E5F72657665616C4C696E6528652C352C74297D5F72657665616C4C696E6528652C742C6E297B696628226E756D62657222213D747970656F66206529';
wwv_flow_imp.g_varchar2_table(18090) := '7468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B746869732E5F73656E6452657665616C52616E6765286E657720726828652C312C652C31292C742C21312C6E297D72657665616C506F736974696F6E28652C';
wwv_flow_imp.g_varchar2_table(18091) := '743D30297B746869732E5F72657665616C506F736974696F6E28652C302C21302C74297D72657665616C506F736974696F6E496E43656E74657228652C743D30297B746869732E5F72657665616C506F736974696F6E28652C312C21302C74297D726576';
wwv_flow_imp.g_varchar2_table(18092) := '65616C506F736974696F6E496E43656E74657249664F75747369646556696577706F727428652C743D30297B746869732E5F72657665616C506F736974696F6E28652C322C21302C74297D72657665616C506F736974696F6E4E656172546F7028652C74';
wwv_flow_imp.g_varchar2_table(18093) := '3D30297B746869732E5F72657665616C506F736974696F6E28652C352C21302C74297D5F72657665616C506F736974696F6E28652C742C6E2C69297B696628216D632E697349506F736974696F6E286529297468726F77206E6577204572726F72282249';
wwv_flow_imp.g_varchar2_table(18094) := '6E76616C696420617267756D656E747322293B746869732E5F73656E6452657665616C52616E6765286E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C756D6E292C742C6E2C69297D';
wwv_flow_imp.g_varchar2_table(18095) := '67657453656C656374696F6E28297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E67657453656C656374696F6E28293A6E756C6C7D67657453656C656374696F6E7328297B';
wwv_flow_imp.g_varchar2_table(18096) := '72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E67657453656C656374696F6E7328293A6E756C6C7D73657453656C656374696F6E28652C743D2261706922297B636F6E737420';
wwv_flow_imp.g_varchar2_table(18097) := '6E3D61682E69734953656C656374696F6E2865292C693D72682E69734952616E67652865293B696628216E26262169297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B6966286E29746869732E5F73657453';
wwv_flow_imp.g_varchar2_table(18098) := '656C656374696F6E496D706C28652C74293B656C73652069662869297B636F6E7374206E3D7B73656C656374696F6E53746172744C696E654E756D6265723A652E73746172744C696E654E756D6265722C73656C656374696F6E5374617274436F6C756D';
wwv_flow_imp.g_varchar2_table(18099) := '6E3A652E7374617274436F6C756D6E2C706F736974696F6E4C696E654E756D6265723A652E656E644C696E654E756D6265722C706F736974696F6E436F6C756D6E3A652E656E64436F6C756D6E7D3B746869732E5F73657453656C656374696F6E496D70';
wwv_flow_imp.g_varchar2_table(18100) := '6C286E2C74297D7D5F73657453656C656374696F6E496D706C28652C74297B69662821746869732E5F6D6F64656C446174612972657475726E3B636F6E7374206E3D6E657720616828652E73656C656374696F6E53746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(18101) := '652E73656C656374696F6E5374617274436F6C756D6E2C652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E293B746869732E5F6D6F64656C446174612E766965774D6F64656C2E73657453656C656374696F6E';
wwv_flow_imp.g_varchar2_table(18102) := '7328742C5B6E5D297D72657665616C4C696E657328652C742C6E3D30297B746869732E5F72657665616C4C696E657328652C742C302C6E297D72657665616C4C696E6573496E43656E74657228652C742C6E3D30297B746869732E5F72657665616C4C69';
wwv_flow_imp.g_varchar2_table(18103) := '6E657328652C742C312C6E297D72657665616C4C696E6573496E43656E74657249664F75747369646556696577706F727428652C742C6E3D30297B746869732E5F72657665616C4C696E657328652C742C322C6E297D72657665616C4C696E65734E6561';
wwv_flow_imp.g_varchar2_table(18104) := '72546F7028652C742C6E3D30297B746869732E5F72657665616C4C696E657328652C742C352C6E297D5F72657665616C4C696E657328652C742C6E2C69297B696628226E756D62657222213D747970656F6620657C7C226E756D62657222213D74797065';
wwv_flow_imp.g_varchar2_table(18105) := '6F662074297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B746869732E5F73656E6452657665616C52616E6765286E657720726828652C312C742C31292C6E2C21312C69297D72657665616C52616E676528';
wwv_flow_imp.g_varchar2_table(18106) := '652C743D302C6E3D21312C693D2130297B746869732E5F72657665616C52616E676528652C6E3F313A302C692C74297D72657665616C52616E6765496E43656E74657228652C743D30297B746869732E5F72657665616C52616E676528652C312C21302C';
wwv_flow_imp.g_varchar2_table(18107) := '74297D72657665616C52616E6765496E43656E74657249664F75747369646556696577706F727428652C743D30297B746869732E5F72657665616C52616E676528652C322C21302C74297D72657665616C52616E67654E656172546F7028652C743D3029';
wwv_flow_imp.g_varchar2_table(18108) := '7B746869732E5F72657665616C52616E676528652C352C21302C74297D72657665616C52616E67654E656172546F7049664F75747369646556696577706F727428652C743D30297B746869732E5F72657665616C52616E676528652C362C21302C74297D';
wwv_flow_imp.g_varchar2_table(18109) := '72657665616C52616E67654174546F7028652C743D30297B746869732E5F72657665616C52616E676528652C332C21302C74297D5F72657665616C52616E676528652C742C6E2C69297B6966282172682E69734952616E6765286529297468726F77206E';
wwv_flow_imp.g_varchar2_table(18110) := '6577204572726F722822496E76616C696420617267756D656E747322293B746869732E5F73656E6452657665616C52616E67652872682E6C6966742865292C742C6E2C69297D73657453656C656374696F6E7328652C743D22617069222C6E3D30297B69';
wwv_flow_imp.g_varchar2_table(18111) := '6628746869732E5F6D6F64656C44617461297B69662821657C7C303D3D3D652E6C656E677468297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B666F72286C657420743D302C6E3D652E6C656E6774683B74';
wwv_flow_imp.g_varchar2_table(18112) := '3C6E3B742B2B296966282161682E69734953656C656374696F6E28655B745D29297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B746869732E5F6D6F64656C446174612E766965774D6F64656C2E73657453';
wwv_flow_imp.g_varchar2_table(18113) := '656C656374696F6E7328742C652C6E297D7D676574436F6E74656E74576964746828297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E67657443';
wwv_flow_imp.g_varchar2_table(18114) := '6F6E74656E74576964746828293A2D317D6765745363726F6C6C576964746828297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E676574536372';
wwv_flow_imp.g_varchar2_table(18115) := '6F6C6C576964746828293A2D317D6765745363726F6C6C4C65667428297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E67657443757272656E74';
wwv_flow_imp.g_varchar2_table(18116) := '5363726F6C6C4C65667428293A2D317D676574436F6E74656E7448656967687428297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E676574436F';
wwv_flow_imp.g_varchar2_table(18117) := '6E74656E7448656967687428293A2D317D6765745363726F6C6C48656967687428297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E6765745363';
wwv_flow_imp.g_varchar2_table(18118) := '726F6C6C48656967687428293A2D317D6765745363726F6C6C546F7028297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E67657443757272656E';
wwv_flow_imp.g_varchar2_table(18119) := '745363726F6C6C546F7028293A2D317D7365745363726F6C6C4C65667428652C743D31297B696628746869732E5F6D6F64656C44617461297B696628226E756D62657222213D747970656F662065297468726F77206E6577204572726F722822496E7661';
wwv_flow_imp.g_varchar2_table(18120) := '6C696420617267756D656E747322293B746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C4C6566743A657D2C74297D7D7365745363726F6C6C54';
wwv_flow_imp.g_varchar2_table(18121) := '6F7028652C743D31297B696628746869732E5F6D6F64656C44617461297B696628226E756D62657222213D747970656F662065297468726F77206E6577204572726F722822496E76616C696420617267756D656E747322293B746869732E5F6D6F64656C';
wwv_flow_imp.g_varchar2_table(18122) := '446174612E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A657D2C74297D7D7365745363726F6C6C506F736974696F6E28652C743D31297B746869732E5F6D6F64656C4461';
wwv_flow_imp.g_varchar2_table(18123) := '74612626746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E7365745363726F6C6C506F736974696F6E28652C74297D68617350656E64696E675363726F6C6C416E696D6174696F6E28297B72657475726E2121';
wwv_flow_imp.g_varchar2_table(18124) := '746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E766965774D6F64656C2E766965774C61796F75742E68617350656E64696E675363726F6C6C416E696D6174696F6E28297D7361766556696577537461746528297B6966';
wwv_flow_imp.g_varchar2_table(18125) := '2821746869732E5F6D6F64656C446174612972657475726E206E756C6C3B636F6E737420653D746869732E5F636F6E747269627574696F6E732E7361766556696577537461746528293B72657475726E7B637572736F7253746174653A746869732E5F6D';
wwv_flow_imp.g_varchar2_table(18126) := '6F64656C446174612E766965774D6F64656C2E73617665437572736F72537461746528292C7669657753746174653A746869732E5F6D6F64656C446174612E766965774D6F64656C2E73617665537461746528292C636F6E747269627574696F6E735374';
wwv_flow_imp.g_varchar2_table(18127) := '6174653A657D7D726573746F72655669657753746174652865297B69662821746869732E5F6D6F64656C446174617C7C21746869732E5F6D6F64656C446174612E6861735265616C566965772972657475726E3B636F6E737420743D653B696628742626';
wwv_flow_imp.g_varchar2_table(18128) := '742E637572736F7253746174652626742E766965775374617465297B636F6E737420653D742E637572736F7253746174653B41727261792E697341727261792865293F652E6C656E6774683E302626746869732E5F6D6F64656C446174612E766965774D';
wwv_flow_imp.g_varchar2_table(18129) := '6F64656C2E726573746F7265437572736F7253746174652865293A746869732E5F6D6F64656C446174612E766965774D6F64656C2E726573746F7265437572736F725374617465285B655D292C746869732E5F636F6E747269627574696F6E732E726573';
wwv_flow_imp.g_varchar2_table(18130) := '746F726556696577537461746528742E636F6E747269627574696F6E7353746174657C7C7B7D293B636F6E7374206E3D746869732E5F6D6F64656C446174612E766965774D6F64656C2E726564756365526573746F7265537461746528742E7669657753';
wwv_flow_imp.g_varchar2_table(18131) := '74617465293B746869732E5F6D6F64656C446174612E766965772E726573746F72655374617465286E297D7D68616E646C65496E697469616C697A656428297B76617220653B6E756C6C3D3D3D28653D746869732E5F676574566965774D6F64656C2829';
wwv_flow_imp.g_varchar2_table(18132) := '297C7C766F696420303D3D3D657C7C652E76697369626C654C696E657353746162696C697A656428297D676574436F6E747269627574696F6E2865297B72657475726E20746869732E5F636F6E747269627574696F6E732E6765742865297D6765744163';
wwv_flow_imp.g_varchar2_table(18133) := '74696F6E7328297B72657475726E2041727261792E66726F6D28746869732E5F616374696F6E732E76616C7565732829297D676574537570706F72746564416374696F6E7328297B6C657420653D746869732E676574416374696F6E7328293B72657475';
wwv_flow_imp.g_varchar2_table(18134) := '726E20653D652E66696C7465722828653D3E652E6973537570706F72746564282929292C657D676574416374696F6E2865297B72657475726E20746869732E5F616374696F6E732E6765742865297C7C6E756C6C7D7472696767657228652C742C6E297B';
wwv_flow_imp.g_varchar2_table(18135) := '737769746368286E3D6E7C7C7B7D2C74297B6361736522636F6D706F736974696F6E5374617274223A72657475726E20766F696420746869732E5F7374617274436F6D706F736974696F6E28293B6361736522636F6D706F736974696F6E456E64223A72';
wwv_flow_imp.g_varchar2_table(18136) := '657475726E20766F696420746869732E5F656E64436F6D706F736974696F6E2865293B636173652274797065223A7B636F6E737420743D6E3B72657475726E20766F696420746869732E5F7479706528652C742E746578747C7C2222297D636173652272';
wwv_flow_imp.g_varchar2_table(18137) := '65706C61636550726576696F757343686172223A7B636F6E737420743D6E3B72657475726E20766F696420746869732E5F636F6D706F736974696F6E5479706528652C742E746578747C7C22222C742E7265706C61636543686172436E747C7C302C302C';
wwv_flow_imp.g_varchar2_table(18138) := '30297D6361736522636F6D706F736974696F6E54797065223A7B636F6E737420743D6E3B72657475726E20766F696420746869732E5F636F6D706F736974696F6E5479706528652C742E746578747C7C22222C742E7265706C6163655072657643686172';
wwv_flow_imp.g_varchar2_table(18139) := '436E747C7C302C742E7265706C6163654E65787443686172436E747C7C302C742E706F736974696F6E44656C74617C7C30297D63617365227061737465223A7B636F6E737420743D6E3B72657475726E20766F696420746869732E5F706173746528652C';
wwv_flow_imp.g_varchar2_table(18140) := '742E746578747C7C22222C742E70617374654F6E4E65774C696E657C7C21312C742E6D756C7469637572736F72546578747C7C6E756C6C2C742E6D6F64657C7C6E756C6C2C742E636C6970626F6172644576656E74297D6361736522637574223A726574';
wwv_flow_imp.g_varchar2_table(18141) := '75726E20766F696420746869732E5F6375742865297D636F6E737420693D746869732E676574416374696F6E2874293B693F50726F6D6973652E7265736F6C766528692E72756E286E29292E7468656E28766F696420302C6B65293A746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(18142) := '64656C44617461262628746869732E5F74726967676572456469746F72436F6D6D616E6428652C742C6E297C7C746869732E5F74726967676572436F6D6D616E6428742C6E29297D5F74726967676572436F6D6D616E6428652C74297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(18143) := '6F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652C74297D5F7374617274436F6D706F736974696F6E28297B746869732E5F6D6F64656C44617461262628746869732E5F6D6F64656C446174612E766965774D6F64656C2E7374';
wwv_flow_imp.g_varchar2_table(18144) := '617274436F6D706F736974696F6E28292C746869732E5F6F6E446964436F6D706F736974696F6E53746172742E666972652829297D5F656E64436F6D706F736974696F6E2865297B746869732E5F6D6F64656C44617461262628746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(18145) := '6C446174612E766965774D6F64656C2E656E64436F6D706F736974696F6E2865292C746869732E5F6F6E446964436F6D706F736974696F6E456E642E666972652829297D5F7479706528652C74297B746869732E5F6D6F64656C44617461262630213D3D';
wwv_flow_imp.g_varchar2_table(18146) := '742E6C656E677468262628226B6579626F617264223D3D3D652626746869732E5F6F6E57696C6C547970652E666972652874292C746869732E5F6D6F64656C446174612E766965774D6F64656C2E7479706528742C65292C226B6579626F617264223D3D';
wwv_flow_imp.g_varchar2_table(18147) := '3D652626746869732E5F6F6E446964547970652E66697265287429297D5F636F6D706F736974696F6E5479706528652C742C6E2C692C6F297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E766965774D6F64656C2E';
wwv_flow_imp.g_varchar2_table(18148) := '636F6D706F736974696F6E5479706528742C6E2C692C6F2C65297D5F706173746528652C742C6E2C692C6F2C73297B69662821746869732E5F6D6F64656C446174612972657475726E3B636F6E737420723D746869732E5F6D6F64656C446174612E7669';
wwv_flow_imp.g_varchar2_table(18149) := '65774D6F64656C2C613D722E67657453656C656374696F6E28292E6765745374617274506F736974696F6E28293B722E706173746528742C6E2C692C65293B636F6E7374206C3D722E67657453656C656374696F6E28292E6765745374617274506F7369';
wwv_flow_imp.g_varchar2_table(18150) := '74696F6E28293B226B6579626F617264223D3D3D652626746869732E5F6F6E44696450617374652E66697265287B636C6970626F6172644576656E743A732C72616E67653A6E657720726828612E6C696E654E756D6265722C612E636F6C756D6E2C6C2E';
wwv_flow_imp.g_varchar2_table(18151) := '6C696E654E756D6265722C6C2E636F6C756D6E292C6C616E677561676549643A6F7D297D5F6375742865297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E766965774D6F64656C2E6375742865297D5F7472696767';
wwv_flow_imp.g_varchar2_table(18152) := '6572456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D65682E676574456469746F72436F6D6D616E642874293B72657475726E212169262628286E3D6E7C7C7B7D292E736F757263653D652C746869732E5F696E7374616E746961';
wwv_flow_imp.g_varchar2_table(18153) := '74696F6E536572766963652E696E766F6B6546756E6374696F6E2828653D3E7B50726F6D6973652E7265736F6C766528692E72756E456469746F72436F6D6D616E6428652C746869732C6E29292E7468656E28766F696420302C6B65297D29292C213029';
wwv_flow_imp.g_varchar2_table(18154) := '7D5F676574566965774D6F64656C28297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E766965774D6F64656C3A6E756C6C7D70757368556E646F53746F7028297B72657475726E2121746869732E5F';
wwv_flow_imp.g_varchar2_table(18155) := '6D6F64656C44617461262621746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E67657428393129262628746869732E5F6D6F64656C446174612E6D6F64656C2E70757368537461636B456C656D656E7428292C2130297D706F70556E';
wwv_flow_imp.g_varchar2_table(18156) := '646F53746F7028297B72657475726E2121746869732E5F6D6F64656C44617461262621746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E67657428393129262628746869732E5F6D6F64656C446174612E6D6F64656C2E706F705374';
wwv_flow_imp.g_varchar2_table(18157) := '61636B456C656D656E7428292C2130297D65786563757465456469747328652C742C6E297B69662821746869732E5F6D6F64656C446174612972657475726E21313B696628746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E676574';
wwv_flow_imp.g_varchar2_table(18158) := '283931292972657475726E21313B6C657420693B72657475726E20693D6E3F41727261792E69734172726179286E293F28293D3E6E3A6E3A28293D3E6E756C6C2C746869732E5F6D6F64656C446174612E766965774D6F64656C2E657865637574654564';
wwv_flow_imp.g_varchar2_table(18159) := '69747328652C742C69292C21307D65786563757465436F6D6D616E6428652C74297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E766965774D6F64656C2E65786563757465436F6D6D616E6428742C65297D657865';
wwv_flow_imp.g_varchar2_table(18160) := '63757465436F6D6D616E647328652C74297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E766965774D6F64656C2E65786563757465436F6D6D616E647328742C65297D6372656174654465636F726174696F6E7343';
wwv_flow_imp.g_varchar2_table(18161) := '6F6C6C656374696F6E2865297B72657475726E206E6577204F4228746869732C65297D6368616E67654465636F726174696F6E732865297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E6D6F64656C';
wwv_flow_imp.g_varchar2_table(18162) := '2E6368616E67654465636F726174696F6E7328652C746869732E5F6964293A6E756C6C7D6765744C696E654465636F726174696F6E732865297B72657475726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E6D6F64';
wwv_flow_imp.g_varchar2_table(18163) := '656C2E6765744C696E654465636F726174696F6E7328652C746869732E5F69642C524C28746869732E5F636F6E66696775726174696F6E2E6F7074696F6E7329293A6E756C6C7D6765744465636F726174696F6E73496E52616E67652865297B72657475';
wwv_flow_imp.g_varchar2_table(18164) := '726E20746869732E5F6D6F64656C446174613F746869732E5F6D6F64656C446174612E6D6F64656C2E6765744465636F726174696F6E73496E52616E676528652C746869732E5F69642C524C28746869732E5F636F6E66696775726174696F6E2E6F7074';
wwv_flow_imp.g_varchar2_table(18165) := '696F6E7329293A6E756C6C7D64656C74614465636F726174696F6E7328652C74297B72657475726E20746869732E5F6D6F64656C446174613F303D3D3D652E6C656E6774682626303D3D3D742E6C656E6774683F653A746869732E5F6D6F64656C446174';
wwv_flow_imp.g_varchar2_table(18166) := '612E6D6F64656C2E64656C74614465636F726174696F6E7328652C742C746869732E5F6964293A5B5D7D72656D6F76654465636F726174696F6E732865297B746869732E5F6D6F64656C44617461262630213D3D652E6C656E6774682626746869732E5F';
wwv_flow_imp.g_varchar2_table(18167) := '6D6F64656C446174612E6D6F64656C2E6368616E67654465636F726174696F6E732828743D3E7B742E64656C74614465636F726174696F6E7328652C5B5D297D29297D72656D6F76654465636F726174696F6E734279547970652865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(18168) := '743D746869732E5F6465636F726174696F6E547970654B657973546F4964735B655D3B742626746869732E6368616E67654465636F726174696F6E732828653D3E652E64656C74614465636F726174696F6E7328742C5B5D2929292C746869732E5F6465';
wwv_flow_imp.g_varchar2_table(18169) := '636F726174696F6E547970654B657973546F4964732E6861734F776E50726F7065727479286529262664656C65746520746869732E5F6465636F726174696F6E547970654B657973546F4964735B655D2C746869732E5F6465636F726174696F6E547970';
wwv_flow_imp.g_varchar2_table(18170) := '6553756274797065732E6861734F776E50726F7065727479286529262664656C65746520746869732E5F6465636F726174696F6E5479706553756274797065735B655D7D6765744C61796F7574496E666F28297B72657475726E20746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(18171) := '66696775726174696F6E2E6F7074696F6E732E67657428313435297D6372656174654F7665727669657752756C65722865297B72657475726E20746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C5669';
wwv_flow_imp.g_varchar2_table(18172) := '65773F746869732E5F6D6F64656C446174612E766965772E6372656174654F7665727669657752756C65722865293A6E756C6C7D676574436F6E7461696E6572446F6D4E6F646528297B72657475726E20746869732E5F646F6D456C656D656E747D6765';
wwv_flow_imp.g_varchar2_table(18173) := '74446F6D4E6F646528297B72657475726E20746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965773F746869732E5F6D6F64656C446174612E766965772E646F6D4E6F64652E646F6D4E6F64653A';
wwv_flow_imp.g_varchar2_table(18174) := '6E756C6C7D64656C6567617465566572746963616C5363726F6C6C626172506F696E746572446F776E2865297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(18175) := '656C446174612E766965772E64656C6567617465566572746963616C5363726F6C6C626172506F696E746572446F776E2865297D64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E742865297B746869732E5F6D6F64656C';
wwv_flow_imp.g_varchar2_table(18176) := '446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E742865297D6C61796F757428';
wwv_flow_imp.g_varchar2_table(18177) := '652C743D2131297B746869732E5F636F6E66696775726174696F6E2E6F627365727665436F6E7461696E65722865292C747C7C746869732E72656E64657228297D666F63757328297B746869732E5F6D6F64656C446174612626746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(18178) := '6C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E666F63757328297D68617354657874466F63757328297B72657475726E212821746869732E5F6D6F64656C446174617C7C21746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(18179) := '6C446174612E6861735265616C56696577292626746869732E5F6D6F64656C446174612E766965772E6973466F637573656428297D686173576964676574466F63757328297B72657475726E20746869732E5F666F637573547261636B65722626746869';
wwv_flow_imp.g_varchar2_table(18180) := '732E5F666F637573547261636B65722E686173466F63757328297D616464436F6E74656E745769646765742865297B636F6E737420743D7B7769646765743A652C706F736974696F6E3A652E676574506F736974696F6E28297D3B746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(18181) := '74656E74576964676574732E6861734F776E50726F706572747928652E67657449642829292626636F6E736F6C652E7761726E28224F76657277726974696E67206120636F6E74656E74207769646765742077697468207468652073616D652069643A22';
wwv_flow_imp.g_varchar2_table(18182) := '2B652E67657449642829292C746869732E5F636F6E74656E74576964676574735B652E676574496428295D3D742C746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(18183) := '64656C446174612E766965772E616464436F6E74656E745769646765742874297D6C61796F7574436F6E74656E745769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F636F6E74656E74576964676574732E6861';
wwv_flow_imp.g_varchar2_table(18184) := '734F776E50726F7065727479287429297B636F6E7374206E3D746869732E5F636F6E74656E74576964676574735B745D3B6E2E706F736974696F6E3D652E676574506F736974696F6E28292C746869732E5F6D6F64656C446174612626746869732E5F6D';
wwv_flow_imp.g_varchar2_table(18185) := '6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E6C61796F7574436F6E74656E74576964676574286E297D7D72656D6F7665436F6E74656E745769646765742865297B636F6E737420743D652E';
wwv_flow_imp.g_varchar2_table(18186) := '676574496428293B696628746869732E5F636F6E74656E74576964676574732E6861734F776E50726F7065727479287429297B636F6E737420653D746869732E5F636F6E74656E74576964676574735B745D3B64656C65746520746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(18187) := '656E74576964676574735B745D2C746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E72656D6F7665436F6E74656E74576964676574';
wwv_flow_imp.g_varchar2_table(18188) := '2865297D7D6164644F7665726C61795769646765742865297B636F6E737420743D7B7769646765743A652C706F736974696F6E3A652E676574506F736974696F6E28297D3B746869732E5F6F7665726C6179576964676574732E6861734F776E50726F70';
wwv_flow_imp.g_varchar2_table(18189) := '6572747928652E67657449642829292626636F6E736F6C652E7761726E28224F76657277726974696E6720616E206F7665726C6179207769646765742077697468207468652073616D652069642E22292C746869732E5F6F7665726C6179576964676574';
wwv_flow_imp.g_varchar2_table(18190) := '735B652E676574496428295D3D742C746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E6164644F7665726C61795769646765742874';
wwv_flow_imp.g_varchar2_table(18191) := '297D6C61796F75744F7665726C61795769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F6F7665726C6179576964676574732E6861734F776E50726F7065727479287429297B636F6E7374206E3D746869732E5F';
wwv_flow_imp.g_varchar2_table(18192) := '6F7665726C6179576964676574735B745D3B6E2E706F736974696F6E3D652E676574506F736974696F6E28292C746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(18193) := '656C446174612E766965772E6C61796F75744F7665726C6179576964676574286E297D7D72656D6F76654F7665726C61795769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F6F7665726C617957696467657473';
wwv_flow_imp.g_varchar2_table(18194) := '2E6861734F776E50726F7065727479287429297B636F6E737420653D746869732E5F6F7665726C6179576964676574735B745D3B64656C65746520746869732E5F6F7665726C6179576964676574735B745D2C746869732E5F6D6F64656C446174612626';
wwv_flow_imp.g_varchar2_table(18195) := '746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E72656D6F76654F7665726C61795769646765742865297D7D616464476C7970684D617267696E5769646765742865297B636F';
wwv_flow_imp.g_varchar2_table(18196) := '6E737420743D7B7769646765743A652C706F736974696F6E3A652E676574506F736974696F6E28297D3B746869732E5F676C7970684D617267696E576964676574732E6861734F776E50726F706572747928652E67657449642829292626636F6E736F6C';
wwv_flow_imp.g_varchar2_table(18197) := '652E7761726E28224F76657277726974696E67206120676C797068206D617267696E207769646765742077697468207468652073616D652069642E22292C746869732E5F676C7970684D617267696E576964676574735B652E676574496428295D3D742C';
wwv_flow_imp.g_varchar2_table(18198) := '746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E616464476C7970684D617267696E5769646765742874297D6C61796F7574476C79';
wwv_flow_imp.g_varchar2_table(18199) := '70684D617267696E5769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F676C7970684D617267696E576964676574732E6861734F776E50726F7065727479287429297B636F6E7374206E3D746869732E5F676C79';
wwv_flow_imp.g_varchar2_table(18200) := '70684D617267696E576964676574735B745D3B6E2E706F736974696F6E3D652E676574506F736974696F6E28292C746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(18201) := '64656C446174612E766965772E6C61796F7574476C7970684D617267696E576964676574286E297D7D72656D6F7665476C7970684D617267696E5769646765742865297B636F6E737420743D652E676574496428293B696628746869732E5F676C797068';
wwv_flow_imp.g_varchar2_table(18202) := '4D617267696E576964676574732E6861734F776E50726F7065727479287429297B636F6E737420653D746869732E5F676C7970684D617267696E576964676574735B745D3B64656C65746520746869732E5F676C7970684D617267696E57696467657473';
wwv_flow_imp.g_varchar2_table(18203) := '5B745D2C746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E72656D6F7665476C7970684D617267696E5769646765742865297D7D63';
wwv_flow_imp.g_varchar2_table(18204) := '68616E6765566965775A6F6E65732865297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965772E6368616E67652865297D6765745461';
wwv_flow_imp.g_varchar2_table(18205) := '726765744174436C69656E74506F696E7428652C74297B72657475726E20746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965773F746869732E5F6D6F64656C446174612E766965772E67657454';
wwv_flow_imp.g_varchar2_table(18206) := '61726765744174436C69656E74506F696E7428652C74293A6E756C6C7D6765745363726F6C6C656456697369626C65506F736974696F6E2865297B69662821746869732E5F6D6F64656C446174617C7C21746869732E5F6D6F64656C446174612E686173';
wwv_flow_imp.g_varchar2_table(18207) := '5265616C566965772972657475726E206E756C6C3B636F6E737420743D746869732E5F6D6F64656C446174612E6D6F64656C2E76616C6964617465506F736974696F6E2865292C6E3D746869732E5F636F6E66696775726174696F6E2E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(18208) := '2C693D6E2E67657428313435293B72657475726E7B746F703A6B422E5F676574566572746963616C4F6666736574466F72506F736974696F6E28746869732E5F6D6F64656C446174612C742E6C696E654E756D6265722C742E636F6C756D6E292D746869';
wwv_flow_imp.g_varchar2_table(18209) := '732E6765745363726F6C6C546F7028292C6C6566743A746869732E5F6D6F64656C446174612E766965772E6765744F6666736574466F72436F6C756D6E28742E6C696E654E756D6265722C742E636F6C756D6E292B692E676C7970684D617267696E5769';
wwv_flow_imp.g_varchar2_table(18210) := '6474682B692E6C696E654E756D6265727357696474682B692E6465636F726174696F6E7357696474682D746869732E6765745363726F6C6C4C65667428292C6865696768743A6E2E676574283637297D7D6765744F6666736574466F72436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(18211) := '652C74297B72657475726E20746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965773F746869732E5F6D6F64656C446174612E766965772E6765744F6666736574466F72436F6C756D6E28652C74';
wwv_flow_imp.g_varchar2_table(18212) := '293A2D317D72656E64657228653D2131297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E6861735265616C566965772626746869732E5F6D6F64656C446174612E766965774D6F64656C2E62617463684576656E74';
wwv_flow_imp.g_varchar2_table(18213) := '73282828293D3E7B746869732E5F6D6F64656C446174612E766965772E72656E6465722821302C65297D29297D736574417269614F7074696F6E732865297B746869732E5F6D6F64656C446174612626746869732E5F6D6F64656C446174612E68617352';
wwv_flow_imp.g_varchar2_table(18214) := '65616C566965772626746869732E5F6D6F64656C446174612E766965772E736574417269614F7074696F6E732865297D6170706C79466F6E74496E666F2865297B724528652C746869732E5F636F6E66696775726174696F6E2E6F7074696F6E732E6765';
wwv_flow_imp.g_varchar2_table(18215) := '7428353029297D73657442616E6E657228652C74297B746869732E5F62616E6E6572446F6D4E6F64652626746869732E5F646F6D456C656D656E742E636F6E7461696E7328746869732E5F62616E6E6572446F6D4E6F6465292626746869732E5F646F6D';
wwv_flow_imp.g_varchar2_table(18216) := '456C656D656E742E72656D6F76654368696C6428746869732E5F62616E6E6572446F6D4E6F6465292C746869732E5F62616E6E6572446F6D4E6F64653D652C746869732E5F636F6E66696775726174696F6E2E7365745265736572766564486569676874';
wwv_flow_imp.g_varchar2_table(18217) := '28653F743A30292C746869732E5F62616E6E6572446F6D4E6F64652626746869732E5F646F6D456C656D656E742E70726570656E6428746869732E5F62616E6E6572446F6D4E6F6465297D5F6174746163684D6F64656C2865297B696628216529726574';
wwv_flow_imp.g_varchar2_table(18218) := '75726E20766F696428746869732E5F6D6F64656C446174613D6E756C6C293B636F6E737420743D5B5D3B746869732E5F646F6D456C656D656E742E7365744174747269627574652822646174612D6D6F64652D6964222C652E6765744C616E6775616765';
wwv_flow_imp.g_varchar2_table(18219) := '49642829292C746869732E5F636F6E66696775726174696F6E2E7365744973446F6D696E6174656442794C6F6E674C696E657328652E6973446F6D696E6174656442794C6F6E674C696E65732829292C746869732E5F636F6E66696775726174696F6E2E';
wwv_flow_imp.g_varchar2_table(18220) := '7365744D6F64656C4C696E65436F756E7428652E6765744C696E65436F756E742829293B636F6E7374206E3D652E6F6E4265666F7265417474616368656428292C693D6E657720624228746869732E5F69642C746869732E5F636F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(18221) := '6F6E2C652C46522E63726561746528727328746869732E5F646F6D456C656D656E7429292C24522E63726561746528746869732E5F636F6E66696775726174696F6E2E6F7074696F6E73292C28653D3E787328727328746869732E5F646F6D456C656D65';
wwv_flow_imp.g_varchar2_table(18222) := '6E74292C6529292C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652C746869732E5F7468656D65536572766963652C6E293B742E7075736828652E6F6E57696C6C446973706F7365282828293D3E746869732E736574';
wwv_flow_imp.g_varchar2_table(18223) := '4D6F64656C286E756C6C292929292C742E7075736828692E6F6E4576656E742828743D3E7B73776974636828742E6B696E64297B6361736520303A746869732E5F6F6E446964436F6E74656E7453697A654368616E67652E666972652874293B62726561';
wwv_flow_imp.g_varchar2_table(18224) := '6B3B6361736520313A746869732E5F656469746F7254657874466F6375732E73657456616C756528742E686173466F637573293B627265616B3B6361736520323A746869732E5F6F6E4469645363726F6C6C4368616E67652E666972652874293B627265';
wwv_flow_imp.g_varchar2_table(18225) := '616B3B6361736520333A746869732E5F6F6E4469644368616E6765566965775A6F6E65732E6669726528293B627265616B3B6361736520343A746869732E5F6F6E4469644368616E676548696464656E41726561732E6669726528293B627265616B3B63';
wwv_flow_imp.g_varchar2_table(18226) := '61736520353A746869732E5F6F6E446964417474656D7074526561644F6E6C79456469742E6669726528293B627265616B3B6361736520363A7B696628742E726561636865644D6178437572736F72436F756E74297B636F6E737420653D6228302C2254';
wwv_flow_imp.g_varchar2_table(18227) := '6865206E756D626572206F6620637572736F727320686173206265656E206C696D6974656420746F207B307D2E20436F6E7369646572207573696E67205B66696E6420616E64207265706C6163655D2868747470733A2F2F636F64652E76697375616C73';
wwv_flow_imp.g_varchar2_table(18228) := '747564696F2E636F6D2F646F63732F656469746F722F636F6465626173696373235F66696E642D616E642D7265706C6163652920666F72206C6172676572206368616E676573206F7220696E6372656173652074686520656469746F72206D756C746920';
wwv_flow_imp.g_varchar2_table(18229) := '637572736F72206C696D69742073657474696E672E222C746869732E6765744F7074696F6E28383029293B746869732E5F6E6F74696669636174696F6E536572766963652E70726F6D7074286F442E5761726E696E672C652C5B7B6C6162656C3A224669';
wwv_flow_imp.g_varchar2_table(18230) := '6E6420616E64205265706C616365222C72756E3A28293D3E7B746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E642822656469746F722E616374696F6E2E737461727446696E645265706C616365416374696F6E2229';
wwv_flow_imp.g_varchar2_table(18231) := '7D7D2C7B6C6162656C3A6228302C22496E637265617365204D756C746920437572736F72204C696D697422292C72756E3A28293D3E7B746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E642822776F726B62656E6368';
wwv_flow_imp.g_varchar2_table(18232) := '2E616374696F6E2E6F70656E53657474696E677332222C7B71756572793A22656469746F722E6D756C7469437572736F724C696D6974227D297D7D5D297D636F6E737420653D5B5D3B666F72286C6574206E3D302C693D742E73656C656374696F6E732E';
wwv_flow_imp.g_varchar2_table(18233) := '6C656E6774683B6E3C693B6E2B2B29655B6E5D3D742E73656C656374696F6E735B6E5D2E676574506F736974696F6E28293B636F6E7374206E3D7B706F736974696F6E3A655B305D2C7365636F6E64617279506F736974696F6E733A652E736C69636528';
wwv_flow_imp.g_varchar2_table(18234) := '31292C726561736F6E3A742E726561736F6E2C736F757263653A742E736F757263657D3B746869732E5F6F6E4469644368616E6765437572736F72506F736974696F6E2E66697265286E293B636F6E737420693D7B73656C656374696F6E3A742E73656C';
wwv_flow_imp.g_varchar2_table(18235) := '656374696F6E735B305D2C7365636F6E6461727953656C656374696F6E733A742E73656C656374696F6E732E736C6963652831292C6D6F64656C56657273696F6E49643A742E6D6F64656C56657273696F6E49642C6F6C6453656C656374696F6E733A74';
wwv_flow_imp.g_varchar2_table(18236) := '2E6F6C6453656C656374696F6E732C6F6C644D6F64656C56657273696F6E49643A742E6F6C644D6F64656C56657273696F6E49642C736F757263653A742E736F757263652C726561736F6E3A742E726561736F6E7D3B746869732E5F6F6E446964436861';
wwv_flow_imp.g_varchar2_table(18237) := '6E6765437572736F7253656C656374696F6E2E666972652869293B627265616B7D6361736520373A746869732E5F6F6E4469644368616E67654D6F64656C4465636F726174696F6E732E6669726528742E6576656E74293B627265616B3B636173652038';
wwv_flow_imp.g_varchar2_table(18238) := '3A746869732E5F646F6D456C656D656E742E7365744174747269627574652822646174612D6D6F64652D6964222C652E6765744C616E677561676549642829292C746869732E5F6F6E4469644368616E67654D6F64656C4C616E67756167652E66697265';
wwv_flow_imp.g_varchar2_table(18239) := '28742E6576656E74293B627265616B3B6361736520393A746869732E5F6F6E4469644368616E67654D6F64656C4C616E6775616765436F6E66696775726174696F6E2E6669726528742E6576656E74293B627265616B3B636173652031303A746869732E';
wwv_flow_imp.g_varchar2_table(18240) := '5F6F6E4469644368616E67654D6F64656C436F6E74656E742E6669726528742E6576656E74293B627265616B3B636173652031313A746869732E5F6F6E4469644368616E67654D6F64656C4F7074696F6E732E6669726528742E6576656E74293B627265';
wwv_flow_imp.g_varchar2_table(18241) := '616B3B636173652031323A746869732E5F6F6E4469644368616E67654D6F64656C546F6B656E732E6669726528742E6576656E74297D7D2929293B636F6E73745B6F2C735D3D746869732E5F637265617465566965772869293B69662873297B74686973';
wwv_flow_imp.g_varchar2_table(18242) := '2E5F646F6D456C656D656E742E617070656E644368696C64286F2E646F6D4E6F64652E646F6D4E6F6465293B6C657420743D4F626A6563742E6B65797328746869732E5F636F6E74656E7457696467657473293B666F72286C657420653D302C6E3D742E';
wwv_flow_imp.g_varchar2_table(18243) := '6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D3B6F2E616464436F6E74656E7457696467657428746869732E5F636F6E74656E74576964676574735B6E5D297D743D4F626A6563742E6B65797328746869732E5F6F7665726C6179';
wwv_flow_imp.g_varchar2_table(18244) := '57696467657473293B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D3B6F2E6164644F7665726C617957696467657428746869732E5F6F7665726C6179576964676574735B6E5D297D743D';
wwv_flow_imp.g_varchar2_table(18245) := '4F626A6563742E6B65797328746869732E5F676C7970684D617267696E57696467657473293B666F72286C657420653D302C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E7374206E3D745B655D3B6F2E616464476C7970684D617267696E57';
wwv_flow_imp.g_varchar2_table(18246) := '696467657428746869732E5F676C7970684D617267696E576964676574735B6E5D297D6F2E72656E6465722821312C2130292C6F2E646F6D4E6F64652E646F6D4E6F64652E7365744174747269627574652822646174612D757269222C652E7572692E74';
wwv_flow_imp.g_varchar2_table(18247) := '6F537472696E672829297D746869732E5F6D6F64656C446174613D6E657720544228652C692C6F2C732C742C6E297D5F637265617465566965772865297B6C657420743B743D746869732E697353696D706C655769646765743F7B70617374653A28652C';
wwv_flow_imp.g_varchar2_table(18248) := '742C6E2C69293D3E7B746869732E5F706173746528226B6579626F617264222C652C742C6E2C69297D2C747970653A653D3E7B746869732E5F7479706528226B6579626F617264222C65297D2C636F6D706F736974696F6E547970653A28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(18249) := '69293D3E7B746869732E5F636F6D706F736974696F6E5479706528226B6579626F617264222C652C742C6E2C69297D2C7374617274436F6D706F736974696F6E3A28293D3E7B746869732E5F7374617274436F6D706F736974696F6E28297D2C656E6443';
wwv_flow_imp.g_varchar2_table(18250) := '6F6D706F736974696F6E3A28293D3E7B746869732E5F656E64436F6D706F736974696F6E28226B6579626F61726422297D2C6375743A28293D3E7B746869732E5F63757428226B6579626F61726422297D7D3A7B70617374653A28652C742C6E2C69293D';
wwv_flow_imp.g_varchar2_table(18251) := '3E7B636F6E7374206F3D7B746578743A652C70617374654F6E4E65774C696E653A742C6D756C7469637572736F72546578743A6E2C6D6F64653A697D3B746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428227061';
wwv_flow_imp.g_varchar2_table(18252) := '737465222C6F297D2C747970653A653D3E7B636F6E737420743D7B746578743A657D3B746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E64282274797065222C74297D2C636F6D706F736974696F6E547970653A2865';
wwv_flow_imp.g_varchar2_table(18253) := '2C742C6E2C69293D3E7B6966286E7C7C69297B636F6E7374206F3D7B746578743A652C7265706C6163655072657643686172436E743A742C7265706C6163654E65787443686172436E743A6E2C706F736974696F6E44656C74613A697D3B746869732E5F';
wwv_flow_imp.g_varchar2_table(18254) := '636F6D6D616E64536572766963652E65786563757465436F6D6D616E642822636F6D706F736974696F6E54797065222C6F297D656C73657B636F6E7374206E3D7B746578743A652C7265706C61636543686172436E743A747D3B746869732E5F636F6D6D';
wwv_flow_imp.g_varchar2_table(18255) := '616E64536572766963652E65786563757465436F6D6D616E6428227265706C61636550726576696F757343686172222C6E297D7D2C7374617274436F6D706F736974696F6E3A28293D3E7B746869732E5F636F6D6D616E64536572766963652E65786563';
wwv_flow_imp.g_varchar2_table(18256) := '757465436F6D6D616E642822636F6D706F736974696F6E5374617274222C7B7D297D2C656E64436F6D706F736974696F6E3A28293D3E7B746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E642822636F6D706F736974';
wwv_flow_imp.g_varchar2_table(18257) := '696F6E456E64222C7B7D297D2C6375743A28293D3E7B746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E642822637574222C7B7D297D7D3B636F6E7374206E3D6E6577206B5028652E636F6F7264696E61746573436F';
wwv_flow_imp.g_varchar2_table(18258) := '6E766572746572293B72657475726E206E2E6F6E4B6579446F776E3D653D3E746869732E5F6F6E4B6579446F776E2E666972652865292C6E2E6F6E4B657955703D653D3E746869732E5F6F6E4B657955702E666972652865292C6E2E6F6E436F6E746578';
wwv_flow_imp.g_varchar2_table(18259) := '744D656E753D653D3E746869732E5F6F6E436F6E746578744D656E752E666972652865292C6E2E6F6E4D6F7573654D6F76653D653D3E746869732E5F6F6E4D6F7573654D6F76652E666972652865292C6E2E6F6E4D6F7573654C656176653D653D3E7468';
wwv_flow_imp.g_varchar2_table(18260) := '69732E5F6F6E4D6F7573654C656176652E666972652865292C6E2E6F6E4D6F757365446F776E3D653D3E746869732E5F6F6E4D6F757365446F776E2E666972652865292C6E2E6F6E4D6F75736555703D653D3E746869732E5F6F6E4D6F75736555702E66';
wwv_flow_imp.g_varchar2_table(18261) := '6972652865292C6E2E6F6E4D6F757365447261673D653D3E746869732E5F6F6E4D6F757365447261672E666972652865292C6E2E6F6E4D6F75736544726F703D653D3E746869732E5F6F6E4D6F75736544726F702E666972652865292C6E2E6F6E4D6F75';
wwv_flow_imp.g_varchar2_table(18262) := '736544726F7043616E63656C65643D653D3E746869732E5F6F6E4D6F75736544726F7043616E63656C65642E666972652865292C6E2E6F6E4D6F757365576865656C3D653D3E746869732E5F6F6E4D6F757365576865656C2E666972652865292C5B6E65';
wwv_flow_imp.g_varchar2_table(18263) := '7720545228742C746869732E5F636F6E66696775726174696F6E2C746869732E5F7468656D65536572766963652E676574436F6C6F725468656D6528292C652C6E2C746869732E5F6F766572666C6F7757696467657473446F6D4E6F64652C746869732E';
wwv_flow_imp.g_varchar2_table(18264) := '5F696E7374616E74696174696F6E53657276696365292C21305D7D5F706F73744465746163684D6F64656C436C65616E75702865297B6E756C6C3D3D657C7C652E72656D6F7665416C6C4465636F726174696F6E73576974684F776E6572496428746869';
wwv_flow_imp.g_varchar2_table(18265) := '732E5F6964297D5F6465746163684D6F64656C28297B76617220653B6966286E756C6C3D3D3D28653D746869732E5F636F6E747269627574696F6E73446973706F7361626C65297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869';
wwv_flow_imp.g_varchar2_table(18266) := '732E5F636F6E747269627574696F6E73446973706F7361626C653D766F696420302C21746869732E5F6D6F64656C446174612972657475726E206E756C6C3B636F6E737420743D746869732E5F6D6F64656C446174612E6D6F64656C2C6E3D746869732E';
wwv_flow_imp.g_varchar2_table(18267) := '5F6D6F64656C446174612E6861735265616C566965773F746869732E5F6D6F64656C446174612E766965772E646F6D4E6F64652E646F6D4E6F64653A6E756C6C3B72657475726E20746869732E5F6D6F64656C446174612E646973706F736528292C7468';
wwv_flow_imp.g_varchar2_table(18268) := '69732E5F6D6F64656C446174613D6E756C6C2C746869732E5F646F6D456C656D656E742E72656D6F76654174747269627574652822646174612D6D6F64652D696422292C6E2626746869732E5F646F6D456C656D656E742E636F6E7461696E73286E2926';
wwv_flow_imp.g_varchar2_table(18269) := '26746869732E5F646F6D456C656D656E742E72656D6F76654368696C64286E292C746869732E5F62616E6E6572446F6D4E6F64652626746869732E5F646F6D456C656D656E742E636F6E7461696E7328746869732E5F62616E6E6572446F6D4E6F646529';
wwv_flow_imp.g_varchar2_table(18270) := '2626746869732E5F646F6D456C656D656E742E72656D6F76654368696C6428746869732E5F62616E6E6572446F6D4E6F6465292C747D5F72656D6F76654465636F726174696F6E547970652865297B746869732E5F636F6465456469746F725365727669';
wwv_flow_imp.g_varchar2_table(18271) := '63652E72656D6F76654465636F726174696F6E547970652865297D6861734D6F64656C28297B72657475726E206E756C6C213D3D746869732E5F6D6F64656C446174617D73686F7744726F70496E64696361746F7241742865297B636F6E737420743D5B';
wwv_flow_imp.g_varchar2_table(18272) := '7B72616E67653A6E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C756D6E292C6F7074696F6E733A6B422E64726F70496E746F456469746F724465636F726174696F6E4F7074696F6E';
wwv_flow_imp.g_varchar2_table(18273) := '737D5D3B746869732E5F64726F70496E746F456469746F724465636F726174696F6E732E7365742874292C746869732E72657665616C506F736974696F6E28652C31297D72656D6F766544726F70496E64696361746F7228297B746869732E5F64726F70';
wwv_flow_imp.g_varchar2_table(18274) := '496E746F456469746F724465636F726174696F6E732E636C65617228297D736574436F6E7465787456616C756528652C74297B746869732E5F636F6E746578744B6579536572766963652E6372656174654B657928652C74297D7D3B4C422E64726F7049';
wwv_flow_imp.g_varchar2_table(18275) := '6E746F456469746F724465636F726174696F6E4F7074696F6E733D4F432E7265676973746572287B6465736372697074696F6E3A22776F726B62656E63682D646E642D746172676574222C636C6173734E616D653A22646E642D746172676574227D292C';
wwv_flow_imp.g_varchar2_table(18276) := '4C423D6B423D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228';
wwv_flow_imp.g_varchar2_table(18277) := '742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B';
wwv_flow_imp.g_varchar2_table(18278) := '656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F62';
wwv_flow_imp.g_varchar2_table(18279) := '6A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B454228332C7563292C454228342C6763292C454228352C7863292C454228362C6364292C454228372C5062292C454228382C7344292C454228392C5953292C45422831302C';
wwv_flow_imp.g_varchar2_table(18280) := '6567292C45422831312C7878295D2C4C42293B6C65742044423D303B636C6173732054427B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E6D6F64656C3D652C746869732E766965774D6F64656C3D742C746869732E766965';
wwv_flow_imp.g_varchar2_table(18281) := '773D6E2C746869732E6861735265616C566965773D692C746869732E6C697374656E657273546F52656D6F76653D6F2C746869732E6174746163686564566965773D737D646973706F736528297B6F7428746869732E6C697374656E657273546F52656D';
wwv_flow_imp.g_varchar2_table(18282) := '6F7665292C746869732E6D6F64656C2E6F6E4265666F7265446574616368656428746869732E617474616368656456696577292C746869732E6861735265616C566965772626746869732E766965772E646973706F736528292C746869732E766965774D';
wwv_flow_imp.g_varchar2_table(18283) := '6F64656C2E646973706F736528297D7D636C61737320494220657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F656D69747465724F7074696F6E733D652C746869732E5F6F6E4469644368616E676554';
wwv_flow_imp.g_varchar2_table(18284) := '6F547275653D746869732E5F7265676973746572286E657720437428746869732E5F656D69747465724F7074696F6E7329292C746869732E6F6E4469644368616E6765546F547275653D746869732E5F6F6E4469644368616E6765546F547275652E6576';
wwv_flow_imp.g_varchar2_table(18285) := '656E742C746869732E5F6F6E4469644368616E6765546F46616C73653D746869732E5F7265676973746572286E657720437428746869732E5F656D69747465724F7074696F6E7329292C746869732E6F6E4469644368616E6765546F46616C73653D7468';
wwv_flow_imp.g_varchar2_table(18286) := '69732E5F6F6E4469644368616E6765546F46616C73652E6576656E742C746869732E5F76616C75653D307D73657456616C75652865297B636F6E737420743D653F323A313B746869732E5F76616C7565213D3D74262628746869732E5F76616C75653D74';
wwv_flow_imp.g_varchar2_table(18287) := '2C323D3D3D746869732E5F76616C75653F746869732E5F6F6E4469644368616E6765546F547275652E6669726528293A313D3D3D746869732E5F76616C75652626746869732E5F6F6E4469644368616E6765546F46616C73652E666972652829297D7D63';
wwv_flow_imp.g_varchar2_table(18288) := '6C617373204D4220657874656E64732043747B636F6E7374727563746F7228652C74297B7375706572287B64656C697665727951756575653A747D292C746869732E5F636F6E747269627574696F6E733D657D666972652865297B746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(18289) := '747269627574696F6E732E6F6E4265666F7265496E746572616374696F6E4576656E7428292C73757065722E666972652865297D7D636C61737320414220657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C7468';
wwv_flow_imp.g_varchar2_table(18290) := '69732E5F656469746F723D652C742E6372656174654B65792822656469746F724964222C652E67657449642829292C746869732E5F656469746F7253696D706C65496E7075743D6C682E656469746F7253696D706C65496E7075742E62696E64546F2874';
wwv_flow_imp.g_varchar2_table(18291) := '292C746869732E5F656469746F72466F6375733D6C682E666F6375732E62696E64546F2874292C746869732E5F74657874496E707574466F6375733D6C682E74657874496E707574466F6375732E62696E64546F2874292C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(18292) := '54657874466F6375733D6C682E656469746F7254657874466F6375732E62696E64546F2874292C746869732E5F7461624D6F766573466F6375733D6C682E7461624D6F766573466F6375732E62696E64546F2874292C746869732E5F656469746F725265';
wwv_flow_imp.g_varchar2_table(18293) := '61646F6E6C793D6C682E726561644F6E6C792E62696E64546F2874292C746869732E5F696E44696666456469746F723D6C682E696E44696666456469746F722E62696E64546F2874292C746869732E5F656469746F72436F6C756D6E53656C656374696F';
wwv_flow_imp.g_varchar2_table(18294) := '6E3D6C682E636F6C756D6E53656C656374696F6E2E62696E64546F2874292C746869732E5F6861734D756C7469706C6553656C656374696F6E733D6C682E6861734D756C7469706C6553656C656374696F6E732E62696E64546F2874292C746869732E5F';
wwv_flow_imp.g_varchar2_table(18295) := '6861734E6F6E456D70747953656C656374696F6E3D6C682E6861734E6F6E456D70747953656C656374696F6E2E62696E64546F2874292C746869732E5F63616E556E646F3D6C682E63616E556E646F2E62696E64546F2874292C746869732E5F63616E52';
wwv_flow_imp.g_varchar2_table(18296) := '65646F3D6C682E63616E5265646F2E62696E64546F2874292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E282828293D3E746869732E5F75706461746546726F6D43';
wwv_flow_imp.g_varchar2_table(18297) := '6F6E66696728292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E282828293D3E746869732E5F75706461746546726F6D53656C656374696F6E28292929';
wwv_flow_imp.g_varchar2_table(18298) := '292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E446964466F637573456469746F72576964676574282828293D3E746869732E5F75706461746546726F6D466F63757328292929292C746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(18299) := '746869732E5F656469746F722E6F6E446964426C7572456469746F72576964676574282828293D3E746869732E5F75706461746546726F6D466F63757328292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E446964';
wwv_flow_imp.g_varchar2_table(18300) := '466F637573456469746F7254657874282828293D3E746869732E5F75706461746546726F6D466F63757328292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E446964426C7572456469746F7254657874282828293D';
wwv_flow_imp.g_varchar2_table(18301) := '3E746869732E5F75706461746546726F6D466F63757328292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F75706461746546726F6D4D6F64656C28';
wwv_flow_imp.g_varchar2_table(18302) := '292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E282828293D3E746869732E5F75706461746546726F6D4D6F64656C28292929292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(18303) := '737465722841412E6F6E4469644368616E6765546162466F6375732828653D3E746869732E5F7461624D6F766573466F6375732E7365742865292929292C746869732E5F75706461746546726F6D436F6E66696728292C746869732E5F75706461746546';
wwv_flow_imp.g_varchar2_table(18304) := '726F6D53656C656374696F6E28292C746869732E5F75706461746546726F6D466F63757328292C746869732E5F75706461746546726F6D4D6F64656C28292C746869732E5F656469746F7253696D706C65496E7075742E73657428746869732E5F656469';
wwv_flow_imp.g_varchar2_table(18305) := '746F722E697353696D706C65576964676574297D5F75706461746546726F6D436F6E66696728297B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E7328293B746869732E5F7461624D6F766573466F6375732E736574284141';
wwv_flow_imp.g_varchar2_table(18306) := '2E676574546162466F6375734D6F64652829292C746869732E5F656469746F72526561646F6E6C792E73657428652E67657428393129292C746869732E5F696E44696666456469746F722E73657428652E67657428363129292C746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(18307) := '6F72436F6C756D6E53656C656374696F6E2E73657428652E67657428323229297D5F75706461746546726F6D53656C656374696F6E28297B636F6E737420653D746869732E5F656469746F722E67657453656C656374696F6E7328293B653F2874686973';
wwv_flow_imp.g_varchar2_table(18308) := '2E5F6861734D756C7469706C6553656C656374696F6E732E73657428652E6C656E6774683E31292C746869732E5F6861734E6F6E456D70747953656C656374696F6E2E73657428652E736F6D652828653D3E21652E6973456D7074792829292929293A28';
wwv_flow_imp.g_varchar2_table(18309) := '746869732E5F6861734D756C7469706C6553656C656374696F6E732E726573657428292C746869732E5F6861734E6F6E456D70747953656C656374696F6E2E72657365742829297D5F75706461746546726F6D466F63757328297B746869732E5F656469';
wwv_flow_imp.g_varchar2_table(18310) := '746F72466F6375732E73657428746869732E5F656469746F722E686173576964676574466F6375732829262621746869732E5F656469746F722E697353696D706C65576964676574292C746869732E5F656469746F7254657874466F6375732E73657428';
wwv_flow_imp.g_varchar2_table(18311) := '746869732E5F656469746F722E68617354657874466F6375732829262621746869732E5F656469746F722E697353696D706C65576964676574292C746869732E5F74657874496E707574466F6375732E73657428746869732E5F656469746F722E686173';
wwv_flow_imp.g_varchar2_table(18312) := '54657874466F6375732829297D5F75706461746546726F6D4D6F64656C28297B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B746869732E5F63616E556E646F2E73657428426F6F6C65616E28652626652E63616E556E';
wwv_flow_imp.g_varchar2_table(18313) := '646F282929292C746869732E5F63616E5265646F2E73657428426F6F6C65616E28652626652E63616E5265646F282929297D7D636C617373204E4220657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C7468';
wwv_flow_imp.g_varchar2_table(18314) := '69732E5F656469746F723D652C746869732E5F636F6E746578744B6579536572766963653D742C746869732E5F6C616E67756167654665617475726573536572766963653D6E2C746869732E5F6C616E6749643D6C682E6C616E677561676549642E6269';
wwv_flow_imp.g_varchar2_table(18315) := '6E64546F2874292C746869732E5F686173436F6D706C6574696F6E4974656D50726F76696465723D6C682E686173436F6D706C6574696F6E4974656D50726F76696465722E62696E64546F2874292C746869732E5F686173436F6465416374696F6E7350';
wwv_flow_imp.g_varchar2_table(18316) := '726F76696465723D6C682E686173436F6465416374696F6E7350726F76696465722E62696E64546F2874292C746869732E5F686173436F64654C656E7350726F76696465723D6C682E686173436F64654C656E7350726F76696465722E62696E64546F28';
wwv_flow_imp.g_varchar2_table(18317) := '74292C746869732E5F686173446566696E6974696F6E50726F76696465723D6C682E686173446566696E6974696F6E50726F76696465722E62696E64546F2874292C746869732E5F6861734465636C61726174696F6E50726F76696465723D6C682E6861';
wwv_flow_imp.g_varchar2_table(18318) := '734465636C61726174696F6E50726F76696465722E62696E64546F2874292C746869732E5F686173496D706C656D656E746174696F6E50726F76696465723D6C682E686173496D706C656D656E746174696F6E50726F76696465722E62696E64546F2874';
wwv_flow_imp.g_varchar2_table(18319) := '292C746869732E5F68617354797065446566696E6974696F6E50726F76696465723D6C682E68617354797065446566696E6974696F6E50726F76696465722E62696E64546F2874292C746869732E5F686173486F76657250726F76696465723D6C682E68';
wwv_flow_imp.g_varchar2_table(18320) := '6173486F76657250726F76696465722E62696E64546F2874292C746869732E5F686173446F63756D656E74486967686C6967687450726F76696465723D6C682E686173446F63756D656E74486967686C6967687450726F76696465722E62696E64546F28';
wwv_flow_imp.g_varchar2_table(18321) := '74292C746869732E5F686173446F63756D656E7453796D626F6C50726F76696465723D6C682E686173446F63756D656E7453796D626F6C50726F76696465722E62696E64546F2874292C746869732E5F6861735265666572656E636550726F7669646572';
wwv_flow_imp.g_varchar2_table(18322) := '3D6C682E6861735265666572656E636550726F76696465722E62696E64546F2874292C746869732E5F68617352656E616D6550726F76696465723D6C682E68617352656E616D6550726F76696465722E62696E64546F2874292C746869732E5F68617353';
wwv_flow_imp.g_varchar2_table(18323) := '69676E617475726548656C7050726F76696465723D6C682E6861735369676E617475726548656C7050726F76696465722E62696E64546F2874292C746869732E5F686173496E6C617948696E747350726F76696465723D6C682E686173496E6C61794869';
wwv_flow_imp.g_varchar2_table(18324) := '6E747350726F76696465722E62696E64546F2874292C746869732E5F686173446F63756D656E74466F726D617474696E6750726F76696465723D6C682E686173446F63756D656E74466F726D617474696E6750726F76696465722E62696E64546F287429';
wwv_flow_imp.g_varchar2_table(18325) := '2C746869732E5F686173446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465723D6C682E686173446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465722E62696E64546F2874292C7468';
wwv_flow_imp.g_varchar2_table(18326) := '69732E5F6861734D756C7469706C65446F63756D656E74466F726D617474696E6750726F76696465723D6C682E6861734D756C7469706C65446F63756D656E74466F726D617474696E6750726F76696465722E62696E64546F2874292C746869732E5F68';
wwv_flow_imp.g_varchar2_table(18327) := '61734D756C7469706C65446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465723D6C682E6861734D756C7469706C65446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465722E62696E64';
wwv_flow_imp.g_varchar2_table(18328) := '546F2874292C746869732E5F6973496E456D626564646564456469746F723D6C682E6973496E456D626564646564456469746F722E62696E64546F2874293B636F6E737420693D28293D3E746869732E5F75706461746528293B746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(18329) := '7374657228652E6F6E4469644368616E67654D6F64656C286929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C4C616E6775616765286929292C746869732E5F7265676973746572286E2E636F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(18330) := '6E50726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E636F6465416374696F6E50726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E636F64654C';
wwv_flow_imp.g_varchar2_table(18331) := '656E7350726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E646566696E6974696F6E50726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E646563';
wwv_flow_imp.g_varchar2_table(18332) := '6C61726174696F6E50726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E696D706C656D656E746174696F6E50726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(18333) := '746572286E2E74797065446566696E6974696F6E50726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E686F76657250726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(18334) := '676973746572286E2E646F63756D656E74486967686C6967687450726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E646F63756D656E7453796D626F6C50726F76696465722E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(18335) := '6765286929292C746869732E5F7265676973746572286E2E7265666572656E636550726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E72656E616D6550726F76696465722E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(18336) := '65286929292C746869732E5F7265676973746572286E2E646F63756D656E74466F726D617474696E674564697450726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E646F63756D656E7452616E6765';
wwv_flow_imp.g_varchar2_table(18337) := '466F726D617474696E674564697450726F76696465722E6F6E4469644368616E6765286929292C746869732E5F7265676973746572286E2E7369676E617475726548656C7050726F76696465722E6F6E4469644368616E6765286929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(18338) := '7265676973746572286E2E696E6C617948696E747350726F76696465722E6F6E4469644368616E6765286929292C6928297D646973706F736528297B73757065722E646973706F736528297D726573657428297B746869732E5F636F6E746578744B6579';
wwv_flow_imp.g_varchar2_table(18339) := '536572766963652E6275666665724368616E67654576656E7473282828293D3E7B746869732E5F6C616E6749642E726573657428292C746869732E5F686173436F6D706C6574696F6E4974656D50726F76696465722E726573657428292C746869732E5F';
wwv_flow_imp.g_varchar2_table(18340) := '686173436F6465416374696F6E7350726F76696465722E726573657428292C746869732E5F686173436F64654C656E7350726F76696465722E726573657428292C746869732E5F686173446566696E6974696F6E50726F76696465722E72657365742829';
wwv_flow_imp.g_varchar2_table(18341) := '2C746869732E5F6861734465636C61726174696F6E50726F76696465722E726573657428292C746869732E5F686173496D706C656D656E746174696F6E50726F76696465722E726573657428292C746869732E5F68617354797065446566696E6974696F';
wwv_flow_imp.g_varchar2_table(18342) := '6E50726F76696465722E726573657428292C746869732E5F686173486F76657250726F76696465722E726573657428292C746869732E5F686173446F63756D656E74486967686C6967687450726F76696465722E726573657428292C746869732E5F6861';
wwv_flow_imp.g_varchar2_table(18343) := '73446F63756D656E7453796D626F6C50726F76696465722E726573657428292C746869732E5F6861735265666572656E636550726F76696465722E726573657428292C746869732E5F68617352656E616D6550726F76696465722E726573657428292C74';
wwv_flow_imp.g_varchar2_table(18344) := '6869732E5F686173446F63756D656E74466F726D617474696E6750726F76696465722E726573657428292C746869732E5F686173446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465722E726573657428292C74686973';
wwv_flow_imp.g_varchar2_table(18345) := '2E5F6861735369676E617475726548656C7050726F76696465722E726573657428292C746869732E5F6973496E456D626564646564456469746F722E726573657428297D29297D5F75706461746528297B636F6E737420653D746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(18346) := '722E6765744D6F64656C28293B653F746869732E5F636F6E746578744B6579536572766963652E6275666665724368616E67654576656E7473282828293D3E7B746869732E5F6C616E6749642E73657428652E6765744C616E677561676549642829292C';
wwv_flow_imp.g_varchar2_table(18347) := '746869732E5F686173436F6D706C6574696F6E4974656D50726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E636F6D706C6574696F6E50726F76696465722E686173286529292C746869732E5F68';
wwv_flow_imp.g_varchar2_table(18348) := '6173436F6465416374696F6E7350726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E636F6465416374696F6E50726F76696465722E686173286529292C746869732E5F686173436F64654C656E73';
wwv_flow_imp.g_varchar2_table(18349) := '50726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E636F64654C656E7350726F76696465722E686173286529292C746869732E5F686173446566696E6974696F6E50726F76696465722E73657428';
wwv_flow_imp.g_varchar2_table(18350) := '746869732E5F6C616E67756167654665617475726573536572766963652E646566696E6974696F6E50726F76696465722E686173286529292C746869732E5F6861734465636C61726174696F6E50726F76696465722E73657428746869732E5F6C616E67';
wwv_flow_imp.g_varchar2_table(18351) := '756167654665617475726573536572766963652E6465636C61726174696F6E50726F76696465722E686173286529292C746869732E5F686173496D706C656D656E746174696F6E50726F76696465722E73657428746869732E5F6C616E67756167654665';
wwv_flow_imp.g_varchar2_table(18352) := '617475726573536572766963652E696D706C656D656E746174696F6E50726F76696465722E686173286529292C746869732E5F68617354797065446566696E6974696F6E50726F76696465722E73657428746869732E5F6C616E67756167654665617475';
wwv_flow_imp.g_varchar2_table(18353) := '726573536572766963652E74797065446566696E6974696F6E50726F76696465722E686173286529292C746869732E5F686173486F76657250726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E68';
wwv_flow_imp.g_varchar2_table(18354) := '6F76657250726F76696465722E686173286529292C746869732E5F686173446F63756D656E74486967686C6967687450726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E744869';
wwv_flow_imp.g_varchar2_table(18355) := '67686C6967687450726F76696465722E686173286529292C746869732E5F686173446F63756D656E7453796D626F6C50726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E745379';
wwv_flow_imp.g_varchar2_table(18356) := '6D626F6C50726F76696465722E686173286529292C746869732E5F6861735265666572656E636550726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E7265666572656E636550726F76696465722E';
wwv_flow_imp.g_varchar2_table(18357) := '686173286529292C746869732E5F68617352656E616D6550726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E72656E616D6550726F76696465722E686173286529292C746869732E5F6861735369';
wwv_flow_imp.g_varchar2_table(18358) := '676E617475726548656C7050726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E7369676E617475726548656C7050726F76696465722E686173286529292C746869732E5F686173496E6C61794869';
wwv_flow_imp.g_varchar2_table(18359) := '6E747350726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E696E6C617948696E747350726F76696465722E686173286529292C746869732E5F686173446F63756D656E74466F726D617474696E67';
wwv_flow_imp.g_varchar2_table(18360) := '50726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E74466F726D617474696E674564697450726F76696465722E6861732865297C7C746869732E5F6C616E677561676546656174';
wwv_flow_imp.g_varchar2_table(18361) := '75726573536572766963652E646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722E686173286529292C746869732E5F686173446F63756D656E7453656C656374696F6E466F726D617474696E6750726F7669646572';
wwv_flow_imp.g_varchar2_table(18362) := '2E73657428746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722E686173286529292C746869732E5F6861734D756C7469706C65446F6375';
wwv_flow_imp.g_varchar2_table(18363) := '6D656E74466F726D617474696E6750726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E74466F726D617474696E674564697450726F76696465722E616C6C2865292E6C656E6774';
wwv_flow_imp.g_varchar2_table(18364) := '682B746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722E616C6C2865292E6C656E6774683E31292C746869732E5F6861734D756C746970';
wwv_flow_imp.g_varchar2_table(18365) := '6C65446F63756D656E7453656C656374696F6E466F726D617474696E6750726F76696465722E73657428746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7452616E6765466F726D617474696E674564697450';
wwv_flow_imp.g_varchar2_table(18366) := '726F76696465722E616C6C2865292E6C656E6774683E31292C746869732E5F6973496E456D626564646564456469746F722E73657428652E7572692E736368656D653D3D3D716F2E77616C6B5468726F756768536E69707065747C7C652E7572692E7363';
wwv_flow_imp.g_varchar2_table(18367) := '68656D653D3D3D716F2E7673636F646543686174436F6465426C6F636B297D29293A746869732E726573657428297D7D636C61737320504220657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(18368) := '6E4368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4368616E67653D746869732E5F6F6E4368616E67652E6576656E742C746869732E5F686164466F6375733D766F696420302C746869732E5F686173446F6D';
wwv_flow_imp.g_varchar2_table(18369) := '456C656D656E74466F6375733D21312C746869732E5F646F6D466F637573547261636B65723D746869732E5F7265676973746572286872286529292C746869732E5F6F766572666C6F7757696467657473446F6D4E6F6465486173466F6375733D21312C';
wwv_flow_imp.g_varchar2_table(18370) := '746869732E5F726567697374657228746869732E5F646F6D466F637573547261636B65722E6F6E446964466F637573282828293D3E7B746869732E5F686173446F6D456C656D656E74466F6375733D21302C746869732E5F75706461746528297D292929';
wwv_flow_imp.g_varchar2_table(18371) := '2C746869732E5F726567697374657228746869732E5F646F6D466F637573547261636B65722E6F6E446964426C7572282828293D3E7B746869732E5F686173446F6D456C656D656E74466F6375733D21312C746869732E5F75706461746528297D292929';
wwv_flow_imp.g_varchar2_table(18372) := '2C74262628746869732E5F6F766572666C6F7757696467657473446F6D4E6F64653D746869732E5F7265676973746572286872287429292C746869732E5F726567697374657228746869732E5F6F766572666C6F7757696467657473446F6D4E6F64652E';
wwv_flow_imp.g_varchar2_table(18373) := '6F6E446964466F637573282828293D3E7B746869732E5F6F766572666C6F7757696467657473446F6D4E6F6465486173466F6375733D21302C746869732E5F75706461746528297D2929292C746869732E5F726567697374657228746869732E5F6F7665';
wwv_flow_imp.g_varchar2_table(18374) := '72666C6F7757696467657473446F6D4E6F64652E6F6E446964426C7572282828293D3E7B746869732E5F6F766572666C6F7757696467657473446F6D4E6F6465486173466F6375733D21312C746869732E5F75706461746528297D292929297D5F757064';
wwv_flow_imp.g_varchar2_table(18375) := '61746528297B636F6E737420653D746869732E5F686173446F6D456C656D656E74466F6375737C7C746869732E5F6F766572666C6F7757696467657473446F6D4E6F6465486173466F6375733B746869732E5F686164466F637573213D3D652626287468';
wwv_flow_imp.g_varchar2_table(18376) := '69732E5F686164466F6375733D652C746869732E5F6F6E4368616E67652E6669726528766F6964203029297D686173466F63757328297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F686164466F637573292626766F696420';
wwv_flow_imp.g_varchar2_table(18377) := '30213D3D652626657D7D636C617373204F427B676574206C656E67746828297B72657475726E20746869732E5F6465636F726174696F6E4964732E6C656E6774687D636F6E7374727563746F7228652C74297B746869732E5F656469746F723D652C7468';
wwv_flow_imp.g_varchar2_table(18378) := '69732E5F6465636F726174696F6E4964733D5B5D2C746869732E5F69734368616E67696E674465636F726174696F6E733D21312C41727261792E697341727261792874292626742E6C656E6774683E302626746869732E7365742874297D6F6E44696443';
wwv_flow_imp.g_varchar2_table(18379) := '68616E676528652C742C6E297B72657475726E20746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4465636F726174696F6E7328286E3D3E7B746869732E5F69734368616E67696E674465636F726174696F6E737C7C652E63616C';
wwv_flow_imp.g_varchar2_table(18380) := '6C28742C6E297D292C6E297D67657452616E67652865297B72657475726E20746869732E5F656469746F722E6861734D6F64656C28293F653E3D746869732E5F6465636F726174696F6E4964732E6C656E6774683F6E756C6C3A746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(18381) := '6F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528746869732E5F6465636F726174696F6E4964735B655D293A6E756C6C7D67657452616E67657328297B69662821746869732E5F656469746F722E6861734D6F64656C28';
wwv_flow_imp.g_varchar2_table(18382) := '292972657475726E5B5D3B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C743D5B5D3B666F7228636F6E7374206E206F6620746869732E5F6465636F726174696F6E496473297B636F6E737420693D652E676574446563';
wwv_flow_imp.g_varchar2_table(18383) := '6F726174696F6E52616E6765286E293B692626742E707573682869297D72657475726E20747D6861732865297B72657475726E20746869732E5F6465636F726174696F6E4964732E696E636C7564657328652E6964297D636C65617228297B30213D3D74';
wwv_flow_imp.g_varchar2_table(18384) := '6869732E5F6465636F726174696F6E4964732E6C656E6774682626746869732E736574285B5D297D7365742865297B7472797B746869732E5F69734368616E67696E674465636F726174696F6E733D21302C746869732E5F656469746F722E6368616E67';
wwv_flow_imp.g_varchar2_table(18385) := '654465636F726174696F6E732828743D3E7B746869732E5F6465636F726174696F6E4964733D742E64656C74614465636F726174696F6E7328746869732E5F6465636F726174696F6E4964732C65297D29297D66696E616C6C797B746869732E5F697343';
wwv_flow_imp.g_varchar2_table(18386) := '68616E67696E674465636F726174696F6E733D21317D72657475726E20746869732E5F6465636F726174696F6E4964737D617070656E642865297B6C657420743D5B5D3B7472797B746869732E5F69734368616E67696E674465636F726174696F6E733D';
wwv_flow_imp.g_varchar2_table(18387) := '21302C746869732E5F656469746F722E6368616E67654465636F726174696F6E7328286E3D3E7B743D6E2E64656C74614465636F726174696F6E73285B5D2C65292C746869732E5F6465636F726174696F6E4964733D746869732E5F6465636F72617469';
wwv_flow_imp.g_varchar2_table(18388) := '6F6E4964732E636F6E6361742874297D29297D66696E616C6C797B746869732E5F69734368616E67696E674465636F726174696F6E733D21317D72657475726E20747D7D636F6E73742052423D656E636F6465555249436F6D706F6E656E7428223C7376';
wwv_flow_imp.g_varchar2_table(18389) := '6720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272076696577426F783D27302030203620332720656E61626C652D6261636B67726F756E643D276E6577203020302036203327206865696768743D273327207769';
wwv_flow_imp.g_varchar2_table(18390) := '6474683D2736273E3C672066696C6C3D2722292C46423D656E636F6465555249436F6D706F6E656E742822273E3C706F6C79676F6E20706F696E74733D27352E352C3020322E352C3320312E312C3320342E312C30272F3E3C706F6C79676F6E20706F69';
wwv_flow_imp.g_varchar2_table(18391) := '6E74733D27342C3020362C3220362C302E3620352E342C30272F3E3C706F6C79676F6E20706F696E74733D27302C3220312C3320322E342C3320302C302E36272F3E3C2F673E3C2F7376673E22293B66756E6374696F6E2042422865297B72657475726E';
wwv_flow_imp.g_varchar2_table(18392) := '2052422B656E636F6465555249436F6D706F6E656E7428652E746F537472696E672829292B46427D636F6E73742056423D656E636F6465555249436F6D706F6E656E7428273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F32';
wwv_flow_imp.g_varchar2_table(18393) := '3030302F73766722206865696768743D2233222077696474683D223132223E3C672066696C6C3D2227292C7A423D656E636F6465555249436F6D706F6E656E742827223E3C636972636C652063783D2231222063793D22312220723D2231222F3E3C6369';
wwv_flow_imp.g_varchar2_table(18394) := '72636C652063783D2235222063793D22312220723D2231222F3E3C636972636C652063783D2239222063793D22312220723D2231222F3E3C2F673E3C2F7376673E27293B5662282828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F722874';
wwv_flow_imp.g_varchar2_table(18395) := '66293B6E2626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E7371756967676C792D6572726F72207B206261636B67726F756E643A2075726C2822646174613A696D6167652F7376672B786D6C2C247B4242286E297D222920726570';
wwv_flow_imp.g_varchar2_table(18396) := '6561742D7820626F74746F6D206C6566743B207D60293B636F6E737420693D652E676574436F6C6F72287366293B692626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E7371756967676C792D7761726E696E67207B206261636B67';
wwv_flow_imp.g_varchar2_table(18397) := '726F756E643A2075726C2822646174613A696D6167652F7376672B786D6C2C247B42422869297D2229207265706561742D7820626F74746F6D206C6566743B207D60293B636F6E7374206F3D652E676574436F6C6F72286166293B6F2626742E61646452';
wwv_flow_imp.g_varchar2_table(18398) := '756C6528602E6D6F6E61636F2D656469746F72202E7371756967676C792D696E666F207B206261636B67726F756E643A2075726C2822646174613A696D6167652F7376672B786D6C2C247B4242286F297D2229207265706561742D7820626F74746F6D20';
wwv_flow_imp.g_varchar2_table(18399) := '6C6566743B207D60293B636F6E737420733D652E676574436F6C6F72286366293B732626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E7371756967676C792D68696E74207B206261636B67726F756E643A2075726C282264617461';
wwv_flow_imp.g_varchar2_table(18400) := '3A696D6167652F7376672B786D6C2C247B66756E6374696F6E2865297B72657475726E2056422B656E636F6465555249436F6D706F6E656E7428652E746F537472696E672829292B7A427D2873297D2229206E6F2D72657065617420626F74746F6D206C';
wwv_flow_imp.g_varchar2_table(18401) := '6566743B207D60293B636F6E737420723D652E676574436F6C6F72286D5F293B722626742E61646452756C6528602E6D6F6E61636F2D656469746F722E73686F77556E75736564202E7371756967676C792D696E6C696E652D756E6E6563657373617279';
wwv_flow_imp.g_varchar2_table(18402) := '207B206F7061636974793A20247B722E726762612E617D3B207D60297D29293B636C6173732048427B73746174696320636170747572652865297B696628303D3D3D652E6765745363726F6C6C546F7028297C7C652E68617350656E64696E675363726F';
wwv_flow_imp.g_varchar2_table(18403) := '6C6C416E696D6174696F6E28292972657475726E206E657720484228652E6765745363726F6C6C546F7028292C652E676574436F6E74656E7448656967687428292C6E756C6C2C302C6E756C6C293B6C657420743D6E756C6C2C6E3D303B636F6E737420';
wwv_flow_imp.g_varchar2_table(18404) := '693D652E67657456697369626C6552616E67657328293B696628692E6C656E6774683E30297B743D695B305D2E6765745374617274506F736974696F6E28293B636F6E7374206F3D652E676574546F70466F72506F736974696F6E28742E6C696E654E75';
wwv_flow_imp.g_varchar2_table(18405) := '6D6265722C742E636F6C756D6E293B6E3D652E6765745363726F6C6C546F7028292D6F7D72657475726E206E657720484228652E6765745363726F6C6C546F7028292C652E676574436F6E74656E7448656967687428292C742C6E2C652E676574506F73';
wwv_flow_imp.g_varchar2_table(18406) := '6974696F6E2829297D636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F696E697469616C5363726F6C6C546F703D652C746869732E5F696E697469616C436F6E74656E744865696768743D742C746869732E5F76697369626C6550';
wwv_flow_imp.g_varchar2_table(18407) := '6F736974696F6E3D6E2C746869732E5F76697369626C65506F736974696F6E5363726F6C6C44656C74613D692C746869732E5F637572736F72506F736974696F6E3D6F7D726573746F72652865297B69662828746869732E5F696E697469616C436F6E74';
wwv_flow_imp.g_varchar2_table(18408) := '656E74486569676874213D3D652E676574436F6E74656E7448656967687428297C7C746869732E5F696E697469616C5363726F6C6C546F70213D3D652E6765745363726F6C6C546F702829292626746869732E5F76697369626C65506F736974696F6E29';
wwv_flow_imp.g_varchar2_table(18409) := '7B636F6E737420743D652E676574546F70466F72506F736974696F6E28746869732E5F76697369626C65506F736974696F6E2E6C696E654E756D6265722C746869732E5F76697369626C65506F736974696F6E2E636F6C756D6E293B652E736574536372';
wwv_flow_imp.g_varchar2_table(18410) := '6F6C6C546F7028742B746869732E5F76697369626C65506F736974696F6E5363726F6C6C44656C7461297D7D726573746F726552656C6174697665566572746963616C506F736974696F6E4F66437572736F722865297B696628746869732E5F696E6974';
wwv_flow_imp.g_varchar2_table(18411) := '69616C436F6E74656E744865696768743D3D3D652E676574436F6E74656E7448656967687428292626746869732E5F696E697469616C5363726F6C6C546F703D3D3D652E6765745363726F6C6C546F7028292972657475726E3B636F6E737420743D652E';
wwv_flow_imp.g_varchar2_table(18412) := '676574506F736974696F6E28293B69662821746869732E5F637572736F72506F736974696F6E7C7C21742972657475726E3B636F6E7374206E3D652E676574546F70466F724C696E654E756D62657228742E6C696E654E756D626572292D652E67657454';
wwv_flow_imp.g_varchar2_table(18413) := '6F70466F724C696E654E756D62657228746869732E5F637572736F72506F736974696F6E2E6C696E654E756D626572293B652E7365745363726F6C6C546F7028652E6765745363726F6C6C546F7028292B6E297D7D636C6173732057427B636F6E737472';
wwv_flow_imp.g_varchar2_table(18414) := '7563746F7228297B746869732E6C656E7365733D5B5D2C746869732E5F646973706F7361626C65733D6E65772061747D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528297D676574206973446973706F736564';
wwv_flow_imp.g_varchar2_table(18415) := '28297B72657475726E20746869732E5F646973706F7361626C65732E6973446973706F7365647D61646428652C74297B746869732E5F646973706F7361626C65732E6164642865293B666F7228636F6E7374206E206F6620652E6C656E73657329746869';
wwv_flow_imp.g_varchar2_table(18416) := '732E6C656E7365732E70757368287B73796D626F6C3A6E2C70726F76696465723A747D297D7D6173796E632066756E6374696F6E206A4228652C742C6E297B636F6E737420693D652E6F7264657265642874292C6F3D6E6577204D61702C733D6E657720';
wwv_flow_imp.g_varchar2_table(18417) := '57422C723D692E6D617028286173796E6328652C69293D3E7B6F2E73657428652C69293B7472797B636F6E737420693D61776169742050726F6D6973652E7265736F6C766528652E70726F76696465436F64654C656E73657328742C6E29293B69262673';
wwv_flow_imp.g_varchar2_table(18418) := '2E61646428692C65297D63617463682865297B45652865297D7D29293B72657475726E2061776169742050726F6D6973652E616C6C2872292C732E6C656E7365733D732E6C656E7365732E736F7274282828652C74293D3E652E73796D626F6C2E72616E';
wwv_flow_imp.g_varchar2_table(18419) := '67652E73746172744C696E654E756D6265723C742E73796D626F6C2E72616E67652E73746172744C696E654E756D6265723F2D313A652E73796D626F6C2E72616E67652E73746172744C696E654E756D6265723E742E73796D626F6C2E72616E67652E73';
wwv_flow_imp.g_varchar2_table(18420) := '746172744C696E654E756D6265723F313A6F2E67657428652E70726F7669646572293C6F2E67657428742E70726F7669646572293F2D313A6F2E67657428652E70726F7669646572293E6F2E67657428742E70726F7669646572293F313A652E73796D62';
wwv_flow_imp.g_varchar2_table(18421) := '6F6C2E72616E67652E7374617274436F6C756D6E3C742E73796D626F6C2E72616E67652E7374617274436F6C756D6E3F2D313A652E73796D626F6C2E72616E67652E7374617274436F6C756D6E3E742E73796D626F6C2E72616E67652E7374617274436F';
wwv_flow_imp.g_varchar2_table(18422) := '6C756D6E3F313A3029292C737D7661722071422C24423B6B632E7265676973746572436F6D6D616E6428225F65786563757465436F64654C656E7350726F7669646572222C2866756E6374696F6E28652C2E2E2E74297B6C65745B6E2C695D3D743B796C';
wwv_flow_imp.g_varchar2_table(18423) := '284E6F2E6973557269286E29292C796C28226E756D626572223D3D747970656F6620697C7C2169293B636F6E73747B636F64654C656E7350726F76696465723A6F7D3D652E676574287878292C733D652E676574286663292E6765744D6F64656C286E29';
wwv_flow_imp.g_varchar2_table(18424) := '3B6966282173297468726F77204D6528293B636F6E737420723D5B5D2C613D6E65772061743B72657475726E206A42286F2C732C4D742E4E6F6E65292E7468656E2828653D3E7B612E6164642865293B636F6E737420743D5B5D3B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(18425) := '206E206F6620652E6C656E736573296E756C6C3D3D697C7C426F6F6C65616E286E2E73796D626F6C2E636F6D6D616E64293F722E70757368286E2E73796D626F6C293A692D2D203E3026266E2E70726F76696465722E7265736F6C7665436F64654C656E';
wwv_flow_imp.g_varchar2_table(18426) := '732626742E707573682850726F6D6973652E7265736F6C7665286E2E70726F76696465722E7265736F6C7665436F64654C656E7328732C6E2E73796D626F6C2C4D742E4E6F6E6529292E7468656E2828653D3E722E7075736828657C7C6E2E73796D626F';
wwv_flow_imp.g_varchar2_table(18427) := '6C292929293B72657475726E2050726F6D6973652E616C6C2874297D29292E7468656E282828293D3E7229292E66696E616C6C79282828293D3E7B73657454696D656F7574282828293D3E612E646973706F73652829292C313030297D29297D29292C66';
wwv_flow_imp.g_varchar2_table(18428) := '756E6374696F6E2865297B655B652E53544F524147455F444F45535F4E4F545F45584953543D305D3D2253544F524147455F444F45535F4E4F545F4558495354222C655B652E53544F524147455F494E5F4D454D4F52593D315D3D2253544F524147455F';
wwv_flow_imp.g_varchar2_table(18429) := '494E5F4D454D4F5259227D2871427C7C2871423D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E496E697469616C697A65643D315D3D22496E697469616C697A6564222C655B652E436C6F7365643D';
wwv_flow_imp.g_varchar2_table(18430) := '325D3D22436C6F736564227D2824427C7C2824423D7B7D29293B636C61737320554220657874656E6473206C747B636F6E7374727563746F7228652C743D4F626A6563742E637265617465286E756C6C29297B737570657228292C746869732E64617461';
wwv_flow_imp.g_varchar2_table(18431) := '626173653D652C746869732E6F7074696F6E733D742C746869732E5F6F6E4469644368616E676553746F726167653D746869732E5F7265676973746572286E6577207874292C746869732E6F6E4469644368616E676553746F726167653D746869732E5F';
wwv_flow_imp.g_varchar2_table(18432) := '6F6E4469644368616E676553746F726167652E6576656E742C746869732E73746174653D24422E4E6F6E652C746869732E63616368653D6E6577204D61702C746869732E666C75736844656C617965723D746869732E5F7265676973746572286E657720';
wwv_flow_imp.g_varchar2_table(18433) := '48742855422E44454641554C545F464C5553485F44454C415929292C746869732E70656E64696E6744656C657465733D6E6577205365742C746869732E70656E64696E67496E73657274733D6E6577204D61702C746869732E7768656E466C7573686564';
wwv_flow_imp.g_varchar2_table(18434) := '43616C6C6261636B733D5B5D2C746869732E72656769737465724C697374656E65727328297D72656769737465724C697374656E65727328297B746869732E5F726567697374657228746869732E64617461626173652E6F6E4469644368616E67654974';
wwv_flow_imp.g_varchar2_table(18435) := '656D7345787465726E616C2828653D3E746869732E6F6E4469644368616E67654974656D7345787465726E616C2865292929297D6F6E4469644368616E67654974656D7345787465726E616C2865297B76617220742C6E3B746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(18436) := '68616E676553746F726167652E706175736528293B7472797B6E756C6C3D3D3D28743D652E6368616E676564297C7C766F696420303D3D3D747C7C742E666F7245616368282828652C74293D3E746869732E61636365707445787465726E616C28742C65';
wwv_flow_imp.g_varchar2_table(18437) := '2929292C6E756C6C3D3D3D286E3D652E64656C65746564297C7C766F696420303D3D3D6E7C7C6E2E666F72456163682828653D3E746869732E61636365707445787465726E616C28652C766F696420302929297D66696E616C6C797B746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(18438) := '4469644368616E676553746F726167652E726573756D6528297D7D61636365707445787465726E616C28652C74297B696628746869732E73746174653D3D3D24422E436C6F7365642972657475726E3B6C6574206E3D21313B5F6C2874293F6E3D746869';
wwv_flow_imp.g_varchar2_table(18439) := '732E63616368652E64656C6574652865293A746869732E63616368652E676574286529213D3D74262628746869732E63616368652E73657428652C74292C6E3D2130292C6E2626746869732E5F6F6E4469644368616E676553746F726167652E66697265';
wwv_flow_imp.g_varchar2_table(18440) := '287B6B65793A652C65787465726E616C3A21307D297D67657428652C74297B636F6E7374206E3D746869732E63616368652E6765742865293B72657475726E205F6C286E293F743A6E7D676574426F6F6C65616E28652C74297B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(18441) := '69732E6765742865293B72657475726E205F6C286E293F743A2274727565223D3D3D6E7D6765744E756D62657228652C74297B636F6E7374206E3D746869732E6765742865293B72657475726E205F6C286E293F743A7061727365496E74286E2C313029';
wwv_flow_imp.g_varchar2_table(18442) := '7D6173796E632073657428652C742C6E3D2131297B696628746869732E73746174653D3D3D24422E436C6F7365642972657475726E3B6966285F6C2874292972657475726E20746869732E64656C65746528652C6E293B636F6E737420693D756C287429';
wwv_flow_imp.g_varchar2_table(18443) := '7C7C41727261792E697341727261792874293F286F3D742C4A534F4E2E737472696E67696679286F2C496B29293A537472696E672874293B766172206F3B72657475726E20746869732E63616368652E676574286529213D3D693F28746869732E636163';
wwv_flow_imp.g_varchar2_table(18444) := '68652E73657428652C69292C746869732E70656E64696E67496E73657274732E73657428652C69292C746869732E70656E64696E6744656C657465732E64656C6574652865292C746869732E5F6F6E4469644368616E676553746F726167652E66697265';
wwv_flow_imp.g_varchar2_table(18445) := '287B6B65793A652C65787465726E616C3A6E7D292C746869732E646F466C7573682829293A766F696420307D6173796E632064656C65746528652C743D2131297B696628746869732E7374617465213D3D24422E436C6F7365642972657475726E207468';
wwv_flow_imp.g_varchar2_table(18446) := '69732E63616368652E64656C6574652865293F28746869732E70656E64696E6744656C657465732E6861732865297C7C746869732E70656E64696E6744656C657465732E6164642865292C746869732E70656E64696E67496E73657274732E64656C6574';
wwv_flow_imp.g_varchar2_table(18447) := '652865292C746869732E5F6F6E4469644368616E676553746F726167652E66697265287B6B65793A652C65787465726E616C3A747D292C746869732E646F466C7573682829293A766F696420307D6765742068617350656E64696E6728297B7265747572';
wwv_flow_imp.g_varchar2_table(18448) := '6E20746869732E70656E64696E67496E73657274732E73697A653E307C7C746869732E70656E64696E6744656C657465732E73697A653E307D6173796E6320666C75736850656E64696E6728297B69662821746869732E68617350656E64696E67297265';
wwv_flow_imp.g_varchar2_table(18449) := '7475726E3B636F6E737420653D7B696E736572743A746869732E70656E64696E67496E73657274732C64656C6574653A746869732E70656E64696E6744656C657465737D3B72657475726E20746869732E70656E64696E6744656C657465733D6E657720';
wwv_flow_imp.g_varchar2_table(18450) := '5365742C746869732E70656E64696E67496E73657274733D6E6577204D61702C746869732E64617461626173652E7570646174654974656D732865292E66696E616C6C79282828293D3E7B76617220653B69662821746869732E68617350656E64696E67';
wwv_flow_imp.g_varchar2_table(18451) := '29666F72283B746869732E7768656E466C757368656443616C6C6261636B732E6C656E6774683B296E756C6C3D3D3D28653D746869732E7768656E466C757368656443616C6C6261636B732E706F702829297C7C766F696420303D3D3D657C7C6528297D';
wwv_flow_imp.g_varchar2_table(18452) := '29297D6173796E6320646F466C7573682865297B72657475726E20746869732E6F7074696F6E732E68696E743D3D3D71422E53544F524147455F494E5F4D454D4F52593F746869732E666C75736850656E64696E6728293A746869732E666C7573684465';
wwv_flow_imp.g_varchar2_table(18453) := '6C617965722E74726967676572282828293D3E746869732E666C75736850656E64696E672829292C65297D7D55422E44454641554C545F464C5553485F44454C41593D3130303B636C617373204B427B636F6E7374727563746F7228297B746869732E6F';
wwv_flow_imp.g_varchar2_table(18454) := '6E4469644368616E67654974656D7345787465726E616C3D76742E4E6F6E652C746869732E6974656D733D6E6577204D61707D6173796E63207570646174654974656D732865297B76617220742C6E3B6E756C6C3D3D3D28743D652E696E73657274297C';
wwv_flow_imp.g_varchar2_table(18455) := '7C766F696420303D3D3D747C7C742E666F7245616368282828652C74293D3E746869732E6974656D732E73657428742C652929292C6E756C6C3D3D3D286E3D652E64656C657465297C7C766F696420303D3D3D6E7C7C6E2E666F72456163682828653D3E';
wwv_flow_imp.g_varchar2_table(18456) := '746869732E6974656D732E64656C65746528652929297D7D636F6E73742047423D225F5F245F5F74617267657453746F726167654D61726B6572222C51423D7063282273746F726167655365727669636522293B7661722059423B2166756E6374696F6E';
wwv_flow_imp.g_varchar2_table(18457) := '2865297B655B652E4E4F4E453D305D3D224E4F4E45222C655B652E53485554444F574E3D315D3D2253485554444F574E227D2859427C7C2859423D7B7D29293B636C617373205A4220657874656E6473206C747B636F6E7374727563746F7228653D7B66';
wwv_flow_imp.g_varchar2_table(18458) := '6C757368496E74657276616C3A5A422E44454641554C545F464C5553485F494E54455256414C7D297B737570657228292C746869732E6F7074696F6E733D652C746869732E5F6F6E4469644368616E676556616C75653D746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(18459) := '72286E6577207874292C746869732E5F6F6E4469644368616E67655461726765743D746869732E5F7265676973746572286E6577207874292C746869732E5F6F6E57696C6C5361766553746174653D746869732E5F7265676973746572286E6577204374';
wwv_flow_imp.g_varchar2_table(18460) := '292C746869732E6F6E57696C6C5361766553746174653D746869732E5F6F6E57696C6C5361766553746174652E6576656E742C746869732E5F776F726B73706163654B6579546172676574733D766F696420302C746869732E5F70726F66696C654B6579';
wwv_flow_imp.g_varchar2_table(18461) := '546172676574733D766F696420302C746869732E5F6170706C69636174696F6E4B6579546172676574733D766F696420307D6F6E4469644368616E676556616C756528652C742C6E297B72657475726E2076742E66696C74657228746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(18462) := '69644368616E676556616C75652E6576656E742C286E3D3E6E2E73636F70653D3D3D65262628766F696420303D3D3D747C7C6E2E6B65793D3D3D7429292C6E297D656D69744469644368616E676556616C756528652C74297B636F6E73747B6B65793A6E';
wwv_flow_imp.g_varchar2_table(18463) := '2C65787465726E616C3A697D3D743B6966286E3D3D3D4742297B7377697463682865297B636173652D313A746869732E5F6170706C69636174696F6E4B6579546172676574733D766F696420303B627265616B3B6361736520303A746869732E5F70726F';
wwv_flow_imp.g_varchar2_table(18464) := '66696C654B6579546172676574733D766F696420303B627265616B3B6361736520313A746869732E5F776F726B73706163654B6579546172676574733D766F696420307D746869732E5F6F6E4469644368616E67655461726765742E66697265287B7363';
wwv_flow_imp.g_varchar2_table(18465) := '6F70653A657D297D656C736520746869732E5F6F6E4469644368616E676556616C75652E66697265287B73636F70653A652C6B65793A6E2C7461726765743A746869732E6765744B6579546172676574732865295B6E5D2C65787465726E616C3A697D29';
wwv_flow_imp.g_varchar2_table(18466) := '7D67657428652C742C6E297B76617220693B72657475726E206E756C6C3D3D3D28693D746869732E67657453746F72616765287429297C7C766F696420303D3D3D693F766F696420303A692E67657428652C6E297D676574426F6F6C65616E28652C742C';
wwv_flow_imp.g_varchar2_table(18467) := '6E297B76617220693B72657475726E206E756C6C3D3D3D28693D746869732E67657453746F72616765287429297C7C766F696420303D3D3D693F766F696420303A692E676574426F6F6C65616E28652C6E297D6765744E756D62657228652C742C6E297B';
wwv_flow_imp.g_varchar2_table(18468) := '76617220693B72657475726E206E756C6C3D3D3D28693D746869732E67657453746F72616765287429297C7C766F696420303D3D3D693F766F696420303A692E6765744E756D62657228652C6E297D73746F726528652C742C6E2C692C6F3D2131297B5F';
wwv_flow_imp.g_varchar2_table(18469) := '6C2874293F746869732E72656D6F766528652C6E2C6F293A746869732E77697468506175736564456D697474657273282828293D3E7B76617220733B746869732E7570646174654B657954617267657428652C6E2C69292C6E756C6C3D3D3D28733D7468';
wwv_flow_imp.g_varchar2_table(18470) := '69732E67657453746F72616765286E29297C7C766F696420303D3D3D737C7C732E73657428652C742C6F297D29297D72656D6F766528652C742C6E3D2131297B746869732E77697468506175736564456D697474657273282828293D3E7B76617220693B';
wwv_flow_imp.g_varchar2_table(18471) := '746869732E7570646174654B657954617267657428652C742C766F69642030292C6E756C6C3D3D3D28693D746869732E67657453746F72616765287429297C7C766F696420303D3D3D697C7C692E64656C65746528652C6E297D29297D77697468506175';
wwv_flow_imp.g_varchar2_table(18472) := '736564456D6974746572732865297B746869732E5F6F6E4469644368616E676556616C75652E706175736528292C746869732E5F6F6E4469644368616E67655461726765742E706175736528293B7472797B6528297D66696E616C6C797B746869732E5F';
wwv_flow_imp.g_varchar2_table(18473) := '6F6E4469644368616E676556616C75652E726573756D6528292C746869732E5F6F6E4469644368616E67655461726765742E726573756D6528297D7D7570646174654B657954617267657428652C742C6E2C693D2131297B766172206F2C733B636F6E73';
wwv_flow_imp.g_varchar2_table(18474) := '7420723D746869732E6765744B6579546172676574732874293B226E756D626572223D3D747970656F66206E3F725B655D213D3D6E262628725B655D3D6E2C6E756C6C3D3D3D286F3D746869732E67657453746F72616765287429297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(18475) := '3D3D3D6F7C7C6F2E7365742847422C4A534F4E2E737472696E676966792872292C6929293A226E756D626572223D3D747970656F6620725B655D26262864656C65746520725B655D2C6E756C6C3D3D3D28733D746869732E67657453746F726167652874';
wwv_flow_imp.g_varchar2_table(18476) := '29297C7C766F696420303D3D3D737C7C732E7365742847422C4A534F4E2E737472696E676966792872292C6929297D67657420776F726B73706163654B65795461726765747328297B72657475726E20746869732E5F776F726B73706163654B65795461';
wwv_flow_imp.g_varchar2_table(18477) := '72676574737C7C28746869732E5F776F726B73706163654B6579546172676574733D746869732E6C6F61644B657954617267657473283129292C746869732E5F776F726B73706163654B6579546172676574737D6765742070726F66696C654B65795461';
wwv_flow_imp.g_varchar2_table(18478) := '726765747328297B72657475726E20746869732E5F70726F66696C654B6579546172676574737C7C28746869732E5F70726F66696C654B6579546172676574733D746869732E6C6F61644B657954617267657473283029292C746869732E5F70726F6669';
wwv_flow_imp.g_varchar2_table(18479) := '6C654B6579546172676574737D676574206170706C69636174696F6E4B65795461726765747328297B72657475726E20746869732E5F6170706C69636174696F6E4B6579546172676574737C7C28746869732E5F6170706C69636174696F6E4B65795461';
wwv_flow_imp.g_varchar2_table(18480) := '72676574733D746869732E6C6F61644B657954617267657473282D3129292C746869732E5F6170706C69636174696F6E4B6579546172676574737D6765744B6579546172676574732865297B7377697463682865297B636173652D313A72657475726E20';
wwv_flow_imp.g_varchar2_table(18481) := '746869732E6170706C69636174696F6E4B6579546172676574733B6361736520303A72657475726E20746869732E70726F66696C654B6579546172676574733B64656661756C743A72657475726E20746869732E776F726B73706163654B657954617267';
wwv_flow_imp.g_varchar2_table(18482) := '6574737D7D6C6F61644B6579546172676574732865297B636F6E737420743D746869732E67657453746F726167652865293B72657475726E20743F66756E6374696F6E2865297B636F6E737420743D652E676574284742293B69662874297472797B7265';
wwv_flow_imp.g_varchar2_table(18483) := '7475726E204A534F4E2E70617273652874297D63617463682865297B7D72657475726E204F626A6563742E637265617465286E756C6C297D2874293A4F626A6563742E637265617465286E756C6C297D7D5A422E44454641554C545F464C5553485F494E';
wwv_flow_imp.g_varchar2_table(18484) := '54455256414C3D3665343B636F6E73742058423D7063282249436F64654C656E73436163686522293B636C617373204A427B636F6E7374727563746F7228652C74297B746869732E6C696E65436F756E743D652C746869732E646174613D747D7D6C6574';
wwv_flow_imp.g_varchar2_table(18485) := '2065563D636C6173737B636F6E7374727563746F722865297B746869732E5F66616B6550726F76696465723D6E657720636C6173737B70726F76696465436F64654C656E73657328297B7468726F77206E6577204572726F7228226E6F7420737570706F';
wwv_flow_imp.g_varchar2_table(18486) := '7274656422297D7D2C746869732E5F63616368653D6E65772061612832302C2E3735292C777328732C2828293D3E652E72656D6F76652822636F64656C656E732F6361636865222C312929293B636F6E737420743D22636F64656C656E732F6361636865';
wwv_flow_imp.g_varchar2_table(18487) := '32222C6E3D652E67657428742C312C227B7D22293B746869732E5F646573657269616C697A65286E292C76742E6F6E636528652E6F6E57696C6C5361766553746174652928286E3D3E7B6E2E726561736F6E3D3D3D59422E53485554444F574E2626652E';
wwv_flow_imp.g_varchar2_table(18488) := '73746F726528742C746869732E5F73657269616C697A6528292C312C31297D29297D70757428652C74297B636F6E7374206E3D742E6C656E7365732E6D61702828653D3E7B76617220743B72657475726E7B72616E67653A652E73796D626F6C2E72616E';
wwv_flow_imp.g_varchar2_table(18489) := '67652C636F6D6D616E643A652E73796D626F6C2E636F6D6D616E6426267B69643A22222C7469746C653A6E756C6C3D3D3D28743D652E73796D626F6C2E636F6D6D616E64297C7C766F696420303D3D3D743F766F696420303A742E7469746C657D7D7D29';
wwv_flow_imp.g_varchar2_table(18490) := '292C693D6E65772057423B692E616464287B6C656E7365733A6E2C646973706F73653A28293D3E7B7D7D2C746869732E5F66616B6550726F7669646572293B636F6E7374206F3D6E6577204A4228652E6765744C696E65436F756E7428292C69293B7468';
wwv_flow_imp.g_varchar2_table(18491) := '69732E5F63616368652E73657428652E7572692E746F537472696E6728292C6F297D6765742865297B636F6E737420743D746869732E5F63616368652E67657428652E7572692E746F537472696E672829293B72657475726E20742626742E6C696E6543';
wwv_flow_imp.g_varchar2_table(18492) := '6F756E743D3D3D652E6765744C696E65436F756E7428293F742E646174613A766F696420307D64656C6574652865297B746869732E5F63616368652E64656C65746528652E7572692E746F537472696E672829297D5F73657269616C697A6528297B636F';
wwv_flow_imp.g_varchar2_table(18493) := '6E737420653D4F626A6563742E637265617465286E756C6C293B666F7228636F6E73745B742C6E5D6F6620746869732E5F6361636865297B636F6E737420693D6E6577205365743B666F7228636F6E73742065206F66206E2E646174612E6C656E736573';
wwv_flow_imp.g_varchar2_table(18494) := '29692E61646428652E73796D626F6C2E72616E67652E73746172744C696E654E756D626572293B655B745D3D7B6C696E65436F756E743A6E2E6C696E65436F756E742C6C696E65733A5B2E2E2E692E76616C75657328295D7D7D72657475726E204A534F';
wwv_flow_imp.g_varchar2_table(18495) := '4E2E737472696E676966792865297D5F646573657269616C697A652865297B7472797B636F6E737420743D4A534F4E2E70617273652865293B666F7228636F6E7374206520696E2074297B636F6E7374206E3D745B655D2C693D5B5D3B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(18496) := '73742065206F66206E2E6C696E657329692E70757368287B72616E67653A6E657720726828652C312C652C3131297D293B636F6E7374206F3D6E65772057423B6F2E616464287B6C656E7365733A692C646973706F736528297B7D7D2C746869732E5F66';
wwv_flow_imp.g_varchar2_table(18497) := '616B6550726F7669646572292C746869732E5F63616368652E73657428652C6E6577204A42286E2E6C696E65436F756E742C6F29297D7D63617463682865297B7D7D7D3B65563D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267';
wwv_flow_imp.g_varchar2_table(18498) := '756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426';
wwv_flow_imp.g_varchar2_table(18499) := '262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29';
wwv_flow_imp.g_varchar2_table(18500) := '286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E63';
wwv_flow_imp.g_varchar2_table(18501) := '74696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28302C5142295D2C6556292C78702858422C65562C31293B7661722074563D6E2831373237292C6E563D7B7D3B6E562E7374796C65546167547261';
wwv_flow_imp.g_varchar2_table(18502) := '6E73666F726D3D6A7228292C6E562E736574417474726962757465733D567228292C6E562E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6E562E646F6D4150493D4F7228292C6E562E696E736572745374796C65456C656D';
wwv_flow_imp.g_varchar2_table(18503) := '656E743D487228292C4E7228292874562E412C6E56292C74562E41262674562E412E6C6F63616C73262674562E412E6C6F63616C733B636C6173732069567B636F6E7374727563746F7228652C742C6E297B746869732E6166746572436F6C756D6E3D31';
wwv_flow_imp.g_varchar2_table(18504) := '3037333734313832342C746869732E61667465724C696E654E756D6265723D652C746869732E686569676874496E50783D742C746869732E5F6F6E4865696768743D6E2C746869732E73757070726573734D6F757365446F776E3D21302C746869732E64';
wwv_flow_imp.g_varchar2_table(18505) := '6F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622297D6F6E436F6D70757465644865696768742865297B766F696420303D3D3D746869732E5F6C6173744865696768743F746869732E5F6C6173744865696768743D';
wwv_flow_imp.g_varchar2_table(18506) := '653A746869732E5F6C617374486569676874213D3D65262628746869732E5F6C6173744865696768743D652C746869732E5F6F6E4865696768742829297D697356697369626C6528297B72657475726E2030213D3D746869732E5F6C6173744865696768';
wwv_flow_imp.g_varchar2_table(18507) := '742626746869732E646F6D4E6F64652E68617341747472696275746528226D6F6E61636F2D76697369626C652D766965772D7A6F6E6522297D7D636C617373206F567B636F6E7374727563746F7228652C74297B746869732E616C6C6F77456469746F72';
wwv_flow_imp.g_varchar2_table(18508) := '4F766572666C6F773D21312C746869732E73757070726573734D6F757365446F776E3D21302C746869732E5F636F6D6D616E64733D6E6577204D61702C746869732E5F6973456D7074793D21302C746869732E5F656469746F723D652C746869732E5F69';
wwv_flow_imp.g_varchar2_table(18509) := '643D22636F64656C656E732E7769646765742D222B6F562E5F6964506F6F6C2B2B2C746869732E757064617465506F736974696F6E2874292C746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E7428227370616E22';
wwv_flow_imp.g_varchar2_table(18510) := '292C746869732E5F646F6D4E6F64652E636C6173734E616D653D22636F64656C656E732D6465636F726174696F6E227D77697468436F6D6D616E647328652C74297B746869732E5F636F6D6D616E64732E636C65617228293B636F6E7374206E3D5B5D3B';
wwv_flow_imp.g_varchar2_table(18511) := '6C657420693D21313B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B636F6E7374206F3D655B745D3B6966286F262628693D21302C6F2E636F6D6D616E6429297B636F6E737420693D536B286F2E636F6D6D616E642E7469746C65';
wwv_flow_imp.g_varchar2_table(18512) := '2E7472696D2829293B6966286F2E636F6D6D616E642E6964297B636F6E737420653D2263222B6F562E5F6964506F6F6C2B2B3B6E2E70757368286272282261222C7B69643A652C7469746C653A6F2E636F6D6D616E642E746F6F6C7469702C726F6C653A';
wwv_flow_imp.g_varchar2_table(18513) := '22627574746F6E227D2C2E2E2E6929292C746869732E5F636F6D6D616E64732E73657428652C6F2E636F6D6D616E64297D656C7365206E2E7075736828627228227370616E222C7B7469746C653A6F2E636F6D6D616E642E746F6F6C7469707D2C2E2E2E';
wwv_flow_imp.g_varchar2_table(18514) := '6929293B742B313C652E6C656E67746826266E2E7075736828627228227370616E222C766F696420302C22C2A07CC2A02229297D7D693F28677228746869732E5F646F6D4E6F64652C2E2E2E6E292C746869732E5F6973456D7074792626742626746869';
wwv_flow_imp.g_varchar2_table(18515) := '732E5F646F6D4E6F64652E636C6173734C6973742E616464282266616465696E22292C746869732E5F6973456D7074793D2131293A677228746869732E5F646F6D4E6F64652C627228227370616E222C766F696420302C226E6F20636F6D6D616E647322';
wwv_flow_imp.g_varchar2_table(18516) := '29297D676574436F6D6D616E642865297B72657475726E20652E706172656E74456C656D656E743D3D3D746869732E5F646F6D4E6F64653F746869732E5F636F6D6D616E64732E67657428652E6964293A766F696420307D676574496428297B72657475';
wwv_flow_imp.g_varchar2_table(18517) := '726E20746869732E5F69647D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D757064617465506F736974696F6E2865297B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292E6765744C';
wwv_flow_imp.g_varchar2_table(18518) := '696E6546697273744E6F6E57686974657370616365436F6C756D6E2865293B746869732E5F776964676574506F736974696F6E3D7B706F736974696F6E3A7B6C696E654E756D6265723A652C636F6C756D6E3A747D2C707265666572656E63653A5B315D';
wwv_flow_imp.g_varchar2_table(18519) := '7D7D676574506F736974696F6E28297B72657475726E20746869732E5F776964676574506F736974696F6E7C7C6E756C6C7D7D6F562E5F6964506F6F6C3D303B636C6173732073567B636F6E7374727563746F7228297B746869732E5F72656D6F766544';
wwv_flow_imp.g_varchar2_table(18520) := '65636F726174696F6E733D5B5D2C746869732E5F6164644465636F726174696F6E733D5B5D2C746869732E5F6164644465636F726174696F6E7343616C6C6261636B733D5B5D7D6164644465636F726174696F6E28652C74297B746869732E5F61646444';
wwv_flow_imp.g_varchar2_table(18521) := '65636F726174696F6E732E707573682865292C746869732E5F6164644465636F726174696F6E7343616C6C6261636B732E707573682874297D72656D6F76654465636F726174696F6E2865297B746869732E5F72656D6F76654465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(18522) := '2E707573682865297D636F6D6D69742865297B636F6E737420743D652E64656C74614465636F726174696F6E7328746869732E5F72656D6F76654465636F726174696F6E732C746869732E5F6164644465636F726174696F6E73293B666F72286C657420';
wwv_flow_imp.g_varchar2_table(18523) := '653D302C6E3D742E6C656E6774683B653C6E3B652B2B29746869732E5F6164644465636F726174696F6E7343616C6C6261636B735B655D28745B655D297D7D636F6E73742072563D4F432E7265676973746572287B636F6C6C617073654F6E5265706C61';
wwv_flow_imp.g_varchar2_table(18524) := '6365456469743A21302C6465736372697074696F6E3A22636F64656C656E73227D293B636C6173732061567B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B6C657420723B746869732E5F6973446973706F7365643D21312C746869732E';
wwv_flow_imp.g_varchar2_table(18525) := '5F656469746F723D742C746869732E5F646174613D652C746869732E5F6465636F726174696F6E4964733D5B5D3B636F6E737420613D5B5D3B746869732E5F646174612E666F7245616368282828652C74293D3E7B652E73796D626F6C2E636F6D6D616E';
wwv_flow_imp.g_varchar2_table(18526) := '642626612E7075736828652E73796D626F6C292C6E2E6164644465636F726174696F6E287B72616E67653A652E73796D626F6C2E72616E67652C6F7074696F6E733A72567D2C28653D3E746869732E5F6465636F726174696F6E4964735B745D3D652929';
wwv_flow_imp.g_varchar2_table(18527) := '2C723D723F72682E706C757352616E676528722C652E73796D626F6C2E72616E6765293A72682E6C69667428652E73796D626F6C2E72616E6765297D29292C746869732E5F766965775A6F6E653D6E657720695628722E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(18528) := '65722D312C6F2C73292C746869732E5F766965775A6F6E6549643D692E6164645A6F6E6528746869732E5F766965775A6F6E65292C612E6C656E6774683E30262628746869732E5F637265617465436F6E74656E7457696467657449664E656365737361';
wwv_flow_imp.g_varchar2_table(18529) := '727928292C746869732E5F636F6E74656E745769646765742E77697468436F6D6D616E647328612C213129297D5F637265617465436F6E74656E7457696467657449664E656365737361727928297B746869732E5F636F6E74656E745769646765743F74';
wwv_flow_imp.g_varchar2_table(18530) := '6869732E5F656469746F722E6C61796F7574436F6E74656E7457696467657428746869732E5F636F6E74656E74576964676574293A28746869732E5F636F6E74656E745769646765743D6E6577206F5628746869732E5F656469746F722C746869732E5F';
wwv_flow_imp.g_varchar2_table(18531) := '766965775A6F6E652E61667465724C696E654E756D6265722B31292C746869732E5F656469746F722E616464436F6E74656E7457696467657428746869732E5F636F6E74656E7457696467657429297D646973706F736528652C74297B746869732E5F64';
wwv_flow_imp.g_varchar2_table(18532) := '65636F726174696F6E4964732E666F724561636828652E72656D6F76654465636F726174696F6E2C65292C746869732E5F6465636F726174696F6E4964733D5B5D2C6E756C6C3D3D747C7C742E72656D6F76655A6F6E6528746869732E5F766965775A6F';
wwv_flow_imp.g_varchar2_table(18533) := '6E654964292C746869732E5F636F6E74656E74576964676574262628746869732E5F656469746F722E72656D6F7665436F6E74656E7457696467657428746869732E5F636F6E74656E74576964676574292C746869732E5F636F6E74656E745769646765';
wwv_flow_imp.g_varchar2_table(18534) := '743D766F69642030292C746869732E5F6973446973706F7365643D21307D6973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D697356616C696428297B72657475726E20746869732E5F6465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(18535) := '4964732E736F6D65282828652C74293D3E7B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652865292C693D746869732E5F646174615B745D2E73796D626F6C3B7265747572';
wwv_flow_imp.g_varchar2_table(18536) := '6E2128216E7C7C72682E6973456D70747928692E72616E676529213D3D6E2E6973456D7074792829297D29297D757064617465436F64654C656E7353796D626F6C7328652C74297B746869732E5F6465636F726174696F6E4964732E666F724561636828';
wwv_flow_imp.g_varchar2_table(18537) := '742E72656D6F76654465636F726174696F6E2C74292C746869732E5F6465636F726174696F6E4964733D5B5D2C746869732E5F646174613D652C746869732E5F646174612E666F7245616368282828652C6E293D3E7B742E6164644465636F726174696F';
wwv_flow_imp.g_varchar2_table(18538) := '6E287B72616E67653A652E73796D626F6C2E72616E67652C6F7074696F6E733A72567D2C28653D3E746869732E5F6465636F726174696F6E4964735B6E5D3D6529297D29297D75706461746548656967687428652C74297B746869732E5F766965775A6F';
wwv_flow_imp.g_varchar2_table(18539) := '6E652E686569676874496E50783D652C742E6C61796F75745A6F6E6528746869732E5F766965775A6F6E654964292C746869732E5F636F6E74656E745769646765742626746869732E5F656469746F722E6C61796F7574436F6E74656E74576964676574';
wwv_flow_imp.g_varchar2_table(18540) := '28746869732E5F636F6E74656E74576964676574297D636F6D7075746549664E65636573736172792865297B69662821746869732E5F766965775A6F6E652E697356697369626C6528292972657475726E206E756C6C3B666F72286C657420743D303B74';
wwv_flow_imp.g_varchar2_table(18541) := '3C746869732E5F6465636F726174696F6E4964732E6C656E6774683B742B2B297B636F6E7374206E3D652E6765744465636F726174696F6E52616E676528746869732E5F6465636F726174696F6E4964735B745D293B6E262628746869732E5F64617461';
wwv_flow_imp.g_varchar2_table(18542) := '5B745D2E73796D626F6C2E72616E67653D6E297D72657475726E20746869732E5F646174617D757064617465436F6D6D616E64732865297B746869732E5F637265617465436F6E74656E7457696467657449664E656365737361727928292C746869732E';
wwv_flow_imp.g_varchar2_table(18543) := '5F636F6E74656E745769646765742E77697468436F6D6D616E647328652C2130293B666F72286C657420743D303B743C746869732E5F646174612E6C656E6774683B742B2B297B636F6E7374206E3D655B745D3B6966286E297B636F6E73747B73796D62';
wwv_flow_imp.g_varchar2_table(18544) := '6F6C3A657D3D746869732E5F646174615B745D3B652E636F6D6D616E643D6E2E636F6D6D616E647C7C652E636F6D6D616E647D7D7D676574436F6D6D616E642865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(18545) := '656E74576964676574297C7C766F696420303D3D3D743F766F696420303A742E676574436F6D6D616E642865297D6765744C696E654E756D62657228297B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292E676574446563';
wwv_flow_imp.g_varchar2_table(18546) := '6F726174696F6E52616E676528746869732E5F6465636F726174696F6E4964735B305D293B72657475726E20653F652E73746172744C696E654E756D6265723A2D317D7570646174652865297B696628746869732E697356616C69642829297B636F6E73';
wwv_flow_imp.g_varchar2_table(18547) := '7420743D746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528746869732E5F6465636F726174696F6E4964735B305D293B74262628746869732E5F766965775A6F6E652E61667465724C696E654E';
wwv_flow_imp.g_varchar2_table(18548) := '756D6265723D742E73746172744C696E654E756D6265722D312C652E6C61796F75745A6F6E6528746869732E5F766965775A6F6E654964292C746869732E5F636F6E74656E74576964676574262628746869732E5F636F6E74656E745769646765742E75';
wwv_flow_imp.g_varchar2_table(18549) := '7064617465506F736974696F6E28742E73746172744C696E654E756D626572292C746869732E5F656469746F722E6C61796F7574436F6E74656E7457696467657428746869732E5F636F6E74656E745769646765742929297D7D7D636F6E7374206C563D';
wwv_flow_imp.g_varchar2_table(18550) := '70632822656E7669726F6E6D656E745365727669636522293B7661722063563D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742064563D70632822494C616E6775616765';
wwv_flow_imp.g_varchar2_table(18551) := '466561747572654465626F756E63655365727669636522293B7661722068563B2166756E6374696F6E2865297B636F6E737420743D6E6577205765616B4D61703B6C6574206E3D303B652E6F663D66756E6374696F6E2865297B6C657420693D742E6765';
wwv_flow_imp.g_varchar2_table(18552) := '742865293B72657475726E20766F696420303D3D3D69262628693D2B2B6E2C742E73657428652C6929292C697D7D2868567C7C2868563D7B7D29293B636C6173732075567B636F6E7374727563746F722865297B746869732E5F64656661756C743D657D';
wwv_flow_imp.g_varchar2_table(18553) := '6765742865297B72657475726E20746869732E5F64656661756C747D75706461746528652C74297B72657475726E20746869732E5F64656661756C747D64656661756C7428297B72657475726E20746869732E5F64656661756C747D7D636C6173732070';
wwv_flow_imp.g_varchar2_table(18554) := '567B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E5F6C6F67536572766963653D652C746869732E5F6E616D653D742C746869732E5F72656769737472793D6E2C746869732E5F64656661756C743D692C746869732E5F6D69';
wwv_flow_imp.g_varchar2_table(18555) := '6E3D6F2C746869732E5F6D61783D732C746869732E5F63616368653D6E65772061612835302C2E37297D5F6B65792865297B72657475726E20652E69642B746869732E5F72656769737472792E616C6C2865292E726564756365282828652C74293D3E58';
wwv_flow_imp.g_varchar2_table(18556) := '6F2868562E6F662874292C6529292C30297D6765742865297B636F6E737420743D746869732E5F6B65792865292C6E3D746869732E5F63616368652E6765742874293B72657475726E206E3F4844286E2E76616C75652C746869732E5F6D696E2C746869';
wwv_flow_imp.g_varchar2_table(18557) := '732E5F6D6178293A746869732E64656661756C7428297D75706461746528652C74297B636F6E7374206E3D746869732E5F6B65792865293B6C657420693D746869732E5F63616368652E676574286E293B697C7C28693D6E6577206A442836292C746869';
wwv_flow_imp.g_varchar2_table(18558) := '732E5F63616368652E736574286E2C6929293B636F6E7374206F3D484428692E7570646174652874292C746869732E5F6D696E2C746869732E5F6D6178293B72657475726E20246F28652E7572692C226F757470757422297C7C746869732E5F6C6F6753';
wwv_flow_imp.g_varchar2_table(18559) := '6572766963652E747261636528605B4445424F554E43453A20247B746869732E5F6E616D657D5D20666F7220247B652E7572692E746F537472696E6728297D20697320247B6F7D6D7360292C6F7D5F6F766572616C6C28297B636F6E737420653D6E6577';
wwv_flow_imp.g_varchar2_table(18560) := '2057443B666F7228636F6E73745B2C745D6F6620746869732E5F636163686529652E75706461746528742E76616C7565293B72657475726E20652E76616C75657D64656661756C7428297B72657475726E20484428307C746869732E5F6F766572616C6C';
wwv_flow_imp.g_varchar2_table(18561) := '28297C7C746869732E5F64656661756C742C746869732E5F6D696E2C746869732E5F6D6178297D7D6C65742067563D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F6C6F67536572766963653D652C746869732E5F646174613D';
wwv_flow_imp.g_varchar2_table(18562) := '6E6577204D61702C746869732E5F69734465763D742E6973457874656E73696F6E446576656C6F706D656E747C7C21742E69734275696C747D666F7228652C742C6E297B76617220692C6F2C733B636F6E737420723D6E756C6C213D3D28693D6E756C6C';
wwv_flow_imp.g_varchar2_table(18563) := '3D3D6E3F766F696420303A6E2E6D696E292626766F69642030213D3D693F693A35302C613D6E756C6C213D3D286F3D6E756C6C3D3D6E3F766F696420303A6E2E6D6178292626766F69642030213D3D6F3F6F3A722A2A322C6C3D6E756C6C213D3D28733D';
wwv_flow_imp.g_varchar2_table(18564) := '6E756C6C3D3D6E3F766F696420303A6E2E6B6579292626766F69642030213D3D733F733A766F696420302C633D60247B68562E6F662865297D2C247B727D247B6C3F222C222B6C3A22227D603B6C657420643D746869732E5F646174612E676574286329';
wwv_flow_imp.g_varchar2_table(18565) := '3B72657475726E20647C7C28746869732E5F69734465763F28746869732E5F6C6F67536572766963652E646562756728605B4445424F554E43453A20247B747D5D2069732064697361626C656420696E20646576656C6F706564206D6F646560292C643D';
wwv_flow_imp.g_varchar2_table(18566) := '6E657720755628312E352A7229293A643D6E657720705628746869732E5F6C6F67536572766963652C742C652C307C746869732E5F6F766572616C6C4176657261676528297C7C312E352A722C722C61292C746869732E5F646174612E73657428632C64';
wwv_flow_imp.g_varchar2_table(18567) := '29292C647D5F6F766572616C6C4176657261676528297B636F6E737420653D6E65772057443B666F7228636F6E73742074206F6620746869732E5F646174612E76616C756573282929652E75706461746528742E64656661756C742829293B7265747572';
wwv_flow_imp.g_varchar2_table(18568) := '6E20652E76616C75657D7D3B67563D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F70657274794465';
wwv_flow_imp.g_varchar2_table(18569) := '7363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528';
wwv_flow_imp.g_varchar2_table(18570) := '652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E2073';
wwv_flow_imp.g_varchar2_table(18571) := '3E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B635628302C5264292C635628312C6C56295D2C6756292C78702864562C67562C31293B766172206D563D66756E6374696F6E28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(18572) := '726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742066563D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E5F656469746F723D652C746869732E5F6C616E67756167654665617475';
wwv_flow_imp.g_varchar2_table(18573) := '726573536572766963653D742C746869732E5F636F6D6D616E64536572766963653D692C746869732E5F6E6F74696669636174696F6E536572766963653D6F2C746869732E5F636F64654C656E7343616368653D732C746869732E5F646973706F736162';
wwv_flow_imp.g_varchar2_table(18574) := '6C65733D6E65772061742C746869732E5F6C6F63616C546F446973706F73653D6E65772061742C746869732E5F6C656E7365733D5B5D2C746869732E5F6F6C64436F64654C656E734D6F64656C733D6E65772061742C746869732E5F70726F7669646543';
wwv_flow_imp.g_varchar2_table(18575) := '6F64654C656E734465626F756E63653D6E2E666F7228742E636F64654C656E7350726F76696465722C22436F64654C656E7350726F76696465222C7B6D696E3A3235307D292C746869732E5F7265736F6C7665436F64654C656E7365734465626F756E63';
wwv_flow_imp.g_varchar2_table(18576) := '653D6E2E666F7228742E636F64654C656E7350726F76696465722C22436F64654C656E735265736F6C7665222C7B6D696E3A3235302C73616C743A227265736F6C7665227D292C746869732E5F7265736F6C7665436F64654C656E736573536368656475';
wwv_flow_imp.g_varchar2_table(18577) := '6C65723D6E6577204B74282828293D3E746869732E5F7265736F6C7665436F64654C656E736573496E56696577706F72742829292C746869732E5F7265736F6C7665436F64654C656E7365734465626F756E63652E64656661756C742829292C74686973';
wwv_flow_imp.g_varchar2_table(18578) := '2E5F646973706F7361626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F6F6E4D6F64656C4368616E676528292929292C746869732E5F646973706F7361626C65732E61646428';
wwv_flow_imp.g_varchar2_table(18579) := '746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E746869732E5F6F6E4D6F64656C4368616E676528292929292C746869732E5F646973706F7361626C65732E61646428746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(18580) := '6F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B28652E6861734368616E676564283530297C7C652E6861734368616E676564283139297C7C652E6861734368616E67656428313829292626746869732E5F7570646174';
wwv_flow_imp.g_varchar2_table(18581) := '654C656E735374796C6528292C652E6861734368616E676564283137292626746869732E5F6F6E4D6F64656C4368616E676528297D2929292C746869732E5F646973706F7361626C65732E61646428742E636F64654C656E7350726F76696465722E6F6E';
wwv_flow_imp.g_varchar2_table(18582) := '4469644368616E676528746869732E5F6F6E4D6F64656C4368616E67652C7468697329292C746869732E5F6F6E4D6F64656C4368616E676528292C746869732E5F7570646174654C656E735374796C6528297D646973706F736528297B76617220653B74';
wwv_flow_imp.g_varchar2_table(18583) := '6869732E5F6C6F63616C446973706F736528292C746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F6F6C64436F64654C656E734D6F64656C732E646973706F736528292C6E756C6C3D3D3D28653D746869732E5F6375';
wwv_flow_imp.g_varchar2_table(18584) := '7272656E74436F64654C656E734D6F64656C297C7C766F696420303D3D3D657C7C652E646973706F736528297D5F6765744C61796F7574496E666F28297B636F6E737420653D4D6174682E6D617828312E332C746869732E5F656469746F722E6765744F';
wwv_flow_imp.g_varchar2_table(18585) := '7074696F6E283637292F746869732E5F656469746F722E6765744F7074696F6E28353229293B6C657420743D746869732E5F656469746F722E6765744F7074696F6E283139293B72657475726E2821747C7C743C3529262628743D2E392A746869732E5F';
wwv_flow_imp.g_varchar2_table(18586) := '656469746F722E6765744F7074696F6E283532297C30292C7B666F6E7453697A653A742C636F64654C656E734865696768743A742A657C307D7D5F7570646174654C656E735374796C6528297B636F6E73747B636F64654C656E734865696768743A652C';
wwv_flow_imp.g_varchar2_table(18587) := '666F6E7453697A653A747D3D746869732E5F6765744C61796F7574496E666F28292C6E3D746869732E5F656469746F722E6765744F7074696F6E283138292C693D746869732E5F656469746F722E6765744F7074696F6E283530292C7B7374796C653A6F';
wwv_flow_imp.g_varchar2_table(18588) := '7D3D746869732E5F656469746F722E676574436F6E7461696E6572446F6D4E6F646528293B6F2E73657450726F706572747928222D2D7673636F64652D656469746F72436F64654C656E732D6C696E65486569676874222C60247B657D707860292C6F2E';
wwv_flow_imp.g_varchar2_table(18589) := '73657450726F706572747928222D2D7673636F64652D656469746F72436F64654C656E732D666F6E7453697A65222C60247B747D707860292C6F2E73657450726F706572747928222D2D7673636F64652D656469746F72436F64654C656E732D666F6E74';
wwv_flow_imp.g_varchar2_table(18590) := '4665617475726553657474696E6773222C692E666F6E744665617475726553657474696E6773292C6E2626286F2E73657450726F706572747928222D2D7673636F64652D656469746F72436F64654C656E732D666F6E7446616D696C79222C6E292C6F2E';
wwv_flow_imp.g_varchar2_table(18591) := '73657450726F706572747928222D2D7673636F64652D656469746F72436F64654C656E732D666F6E7446616D696C7944656661756C74222C4B4C2E666F6E7446616D696C7929292C746869732E5F656469746F722E6368616E6765566965775A6F6E6573';
wwv_flow_imp.g_varchar2_table(18592) := '2828743D3E7B666F7228636F6E7374206E206F6620746869732E5F6C656E736573296E2E75706461746548656967687428652C74297D29297D5F6C6F63616C446973706F736528297B76617220652C742C6E3B6E756C6C3D3D3D28653D746869732E5F67';
wwv_flow_imp.g_varchar2_table(18593) := '6574436F64654C656E734D6F64656C50726F6D697365297C7C766F696420303D3D3D657C7C652E63616E63656C28292C746869732E5F676574436F64654C656E734D6F64656C50726F6D6973653D766F696420302C6E756C6C3D3D3D28743D746869732E';
wwv_flow_imp.g_varchar2_table(18594) := '5F7265736F6C7665436F64654C656E73657350726F6D697365297C7C766F696420303D3D3D747C7C742E63616E63656C28292C746869732E5F7265736F6C7665436F64654C656E73657350726F6D6973653D766F696420302C746869732E5F6C6F63616C';
wwv_flow_imp.g_varchar2_table(18595) := '546F446973706F73652E636C65617228292C746869732E5F6F6C64436F64654C656E734D6F64656C732E636C65617228292C6E756C6C3D3D3D286E3D746869732E5F63757272656E74436F64654C656E734D6F64656C297C7C766F696420303D3D3D6E7C';
wwv_flow_imp.g_varchar2_table(18596) := '7C6E2E646973706F736528297D5F6F6E4D6F64656C4368616E676528297B746869732E5F6C6F63616C446973706F736528293B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B69662821652972657475726E3B69662821';
wwv_flow_imp.g_varchar2_table(18597) := '746869732E5F656469746F722E6765744F7074696F6E283137297C7C652E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28292972657475726E3B636F6E737420743D746869732E5F636F64654C656E7343616368652E6765742865293B';
wwv_flow_imp.g_varchar2_table(18598) := '696628742626746869732E5F72656E646572436F64654C656E7353796D626F6C732874292C21746869732E5F6C616E67756167654665617475726573536572766963652E636F64654C656E7350726F76696465722E6861732865292972657475726E2076';
wwv_flow_imp.g_varchar2_table(18599) := '6F6964287426266A74282828293D3E7B636F6E7374206E3D746869732E5F636F64654C656E7343616368652E6765742865293B743D3D3D6E262628746869732E5F636F64654C656E7343616368652E64656C6574652865292C746869732E5F6F6E4D6F64';
wwv_flow_imp.g_varchar2_table(18600) := '656C4368616E67652829297D292C3365342C746869732E5F6C6F63616C546F446973706F736529293B666F7228636F6E73742074206F6620746869732E5F6C616E67756167654665617475726573536572766963652E636F64654C656E7350726F766964';
wwv_flow_imp.g_varchar2_table(18601) := '65722E616C6C286529296966282266756E6374696F6E223D3D747970656F6620742E6F6E4469644368616E6765297B636F6E737420653D742E6F6E4469644368616E6765282828293D3E6E2E7363686564756C65282929293B746869732E5F6C6F63616C';
wwv_flow_imp.g_varchar2_table(18602) := '546F446973706F73652E6164642865297D636F6E7374206E3D6E6577204B74282828293D3E7B76617220743B636F6E737420693D446174652E6E6F7728293B6E756C6C3D3D3D28743D746869732E5F676574436F64654C656E734D6F64656C50726F6D69';
wwv_flow_imp.g_varchar2_table(18603) := '7365297C7C766F696420303D3D3D747C7C742E63616E63656C28292C746869732E5F676574436F64654C656E734D6F64656C50726F6D6973653D46742828743D3E6A4228746869732E5F6C616E67756167654665617475726573536572766963652E636F';
wwv_flow_imp.g_varchar2_table(18604) := '64654C656E7350726F76696465722C652C742929292C746869732E5F676574436F64654C656E734D6F64656C50726F6D6973652E7468656E2828743D3E7B746869732E5F63757272656E74436F64654C656E734D6F64656C2626746869732E5F6F6C6443';
wwv_flow_imp.g_varchar2_table(18605) := '6F64654C656E734D6F64656C732E61646428746869732E5F63757272656E74436F64654C656E734D6F64656C292C746869732E5F63757272656E74436F64654C656E734D6F64656C3D742C746869732E5F636F64654C656E7343616368652E7075742865';
wwv_flow_imp.g_varchar2_table(18606) := '2C74293B636F6E7374206F3D746869732E5F70726F76696465436F64654C656E734465626F756E63652E75706461746528652C446174652E6E6F7728292D69293B6E2E64656C61793D6F2C746869732E5F72656E646572436F64654C656E7353796D626F';
wwv_flow_imp.g_varchar2_table(18607) := '6C732874292C746869732E5F7265736F6C7665436F64654C656E736573496E56696577706F7274536F6F6E28297D292C6B65297D292C746869732E5F70726F76696465436F64654C656E734465626F756E63652E676574286529293B746869732E5F6C6F';
wwv_flow_imp.g_varchar2_table(18608) := '63616C546F446973706F73652E616464286E292C746869732E5F6C6F63616C546F446973706F73652E616464287274282828293D3E746869732E5F7265736F6C7665436F64654C656E7365735363686564756C65722E63616E63656C28292929292C7468';
wwv_flow_imp.g_varchar2_table(18609) := '69732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E74282828293D3E7B76617220653B746869732E5F656469746F722E6368616E67654465636F726174696F';
wwv_flow_imp.g_varchar2_table(18610) := '6E732828653D3E7B746869732E5F656469746F722E6368616E6765566965775A6F6E65732828743D3E7B636F6E7374206E3D5B5D3B6C657420693D2D313B746869732E5F6C656E7365732E666F72456163682828653D3E7B652E697356616C6964282926';
wwv_flow_imp.g_varchar2_table(18611) := '2669213D3D652E6765744C696E654E756D62657228293F28652E7570646174652874292C693D652E6765744C696E654E756D6265722829293A6E2E707573682865297D29293B636F6E7374206F3D6E65772073563B6E2E666F72456163682828653D3E7B';
wwv_flow_imp.g_varchar2_table(18612) := '652E646973706F7365286F2C74292C746869732E5F6C656E7365732E73706C69636528746869732E5F6C656E7365732E696E6465784F662865292C31297D29292C6F2E636F6D6D69742865297D29297D29292C6E2E7363686564756C6528292C74686973';
wwv_flow_imp.g_varchar2_table(18613) := '2E5F7265736F6C7665436F64654C656E7365735363686564756C65722E63616E63656C28292C6E756C6C3D3D3D28653D746869732E5F7265736F6C7665436F64654C656E73657350726F6D697365297C7C766F696420303D3D3D657C7C652E63616E6365';
wwv_flow_imp.g_varchar2_table(18614) := '6C28292C746869732E5F7265736F6C7665436F64654C656E73657350726F6D6973653D766F696420307D2929292C746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E446964466F637573456469746F72';
wwv_flow_imp.g_varchar2_table(18615) := '576964676574282828293D3E7B6E2E7363686564756C6528297D2929292C746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E446964426C7572456469746F7254657874282828293D3E7B6E2E63616E63';
wwv_flow_imp.g_varchar2_table(18616) := '656C28297D2929292C746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E4469645363726F6C6C4368616E67652828653D3E7B652E7363726F6C6C546F704368616E6765642626746869732E5F6C656E73';
wwv_flow_imp.g_varchar2_table(18617) := '65732E6C656E6774683E302626746869732E5F7265736F6C7665436F64654C656E736573496E56696577706F7274536F6F6E28297D2929292C746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E446964';
wwv_flow_imp.g_varchar2_table(18618) := '4C61796F75744368616E6765282828293D3E7B746869732E5F7265736F6C7665436F64654C656E736573496E56696577706F7274536F6F6E28297D2929292C746869732E5F6C6F63616C546F446973706F73652E616464287274282828293D3E7B696628';
wwv_flow_imp.g_varchar2_table(18619) := '746869732E5F656469746F722E6765744D6F64656C2829297B636F6E737420653D48422E6361707475726528746869732E5F656469746F72293B746869732E5F656469746F722E6368616E67654465636F726174696F6E732828653D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(18620) := '656469746F722E6368616E6765566965775A6F6E65732828743D3E7B746869732E5F646973706F7365416C6C4C656E73657328652C74297D29297D29292C652E726573746F726528746869732E5F656469746F72297D656C736520746869732E5F646973';
wwv_flow_imp.g_varchar2_table(18621) := '706F7365416C6C4C656E73657328766F696420302C766F69642030297D2929292C746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E4D6F757365446F776E2828653D3E7B69662839213D3D652E746172';
wwv_flow_imp.g_varchar2_table(18622) := '6765742E747970652972657475726E3B6C657420743D652E7461726765742E656C656D656E743B696628225350414E223D3D3D286E756C6C3D3D743F766F696420303A742E7461674E616D6529262628743D742E706172656E74456C656D656E74292C22';
wwv_flow_imp.g_varchar2_table(18623) := '41223D3D3D286E756C6C3D3D743F766F696420303A742E7461674E616D652929666F7228636F6E73742065206F6620746869732E5F6C656E736573297B636F6E7374206E3D652E676574436F6D6D616E642874293B6966286E297B746869732E5F636F6D';
wwv_flow_imp.g_varchar2_table(18624) := '6D616E64536572766963652E65786563757465436F6D6D616E64286E2E69642C2E2E2E6E2E617267756D656E74737C7C5B5D292E63617463682828653D3E746869732E5F6E6F74696669636174696F6E536572766963652E6572726F7228652929293B62';
wwv_flow_imp.g_varchar2_table(18625) := '7265616B7D7D7D2929292C6E2E7363686564756C6528297D5F646973706F7365416C6C4C656E73657328652C74297B636F6E7374206E3D6E65772073563B666F7228636F6E73742065206F6620746869732E5F6C656E73657329652E646973706F736528';
wwv_flow_imp.g_varchar2_table(18626) := '6E2C74293B6526266E2E636F6D6D69742865292C746869732E5F6C656E7365732E6C656E6774683D307D5F72656E646572436F64654C656E7353796D626F6C732865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475';
wwv_flow_imp.g_varchar2_table(18627) := '726E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292E6765744C696E65436F756E7428292C6E3D5B5D3B6C657420693B666F7228636F6E7374206F206F6620652E6C656E736573297B636F6E737420653D6F2E73796D62';
wwv_flow_imp.g_varchar2_table(18628) := '6F6C2E72616E67652E73746172744C696E654E756D6265723B653C317C7C653E747C7C28692626695B692E6C656E6774682D315D2E73796D626F6C2E72616E67652E73746172744C696E654E756D6265723D3D3D653F692E70757368286F293A28693D5B';
wwv_flow_imp.g_varchar2_table(18629) := '6F5D2C6E2E7075736828692929297D696628216E2E6C656E677468262621746869732E5F6C656E7365732E6C656E6774682972657475726E3B636F6E7374206F3D48422E6361707475726528746869732E5F656469746F72292C733D746869732E5F6765';
wwv_flow_imp.g_varchar2_table(18630) := '744C61796F7574496E666F28293B746869732E5F656469746F722E6368616E67654465636F726174696F6E732828653D3E7B746869732E5F656469746F722E6368616E6765566965775A6F6E65732828743D3E7B636F6E737420693D6E65772073563B6C';
wwv_flow_imp.g_varchar2_table(18631) := '6574206F3D302C723D303B666F72283B723C6E2E6C656E67746826266F3C746869732E5F6C656E7365732E6C656E6774683B297B636F6E737420653D6E5B725D5B305D2E73796D626F6C2E72616E67652E73746172744C696E654E756D6265722C613D74';
wwv_flow_imp.g_varchar2_table(18632) := '6869732E5F6C656E7365735B6F5D2E6765744C696E654E756D62657228293B613C653F28746869732E5F6C656E7365735B6F5D2E646973706F736528692C74292C746869732E5F6C656E7365732E73706C696365286F2C3129293A613D3D3D653F287468';
wwv_flow_imp.g_varchar2_table(18633) := '69732E5F6C656E7365735B6F5D2E757064617465436F64654C656E7353796D626F6C73286E5B725D2C69292C722B2B2C6F2B2B293A28746869732E5F6C656E7365732E73706C696365286F2C302C6E6577206156286E5B725D2C746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(18634) := '6F722C692C742C732E636F64654C656E734865696768742C2828293D3E746869732E5F7265736F6C7665436F64654C656E736573496E56696577706F7274536F6F6E28292929292C6F2B2B2C722B2B297D666F72283B6F3C746869732E5F6C656E736573';
wwv_flow_imp.g_varchar2_table(18635) := '2E6C656E6774683B29746869732E5F6C656E7365735B6F5D2E646973706F736528692C74292C746869732E5F6C656E7365732E73706C696365286F2C31293B666F72283B723C6E2E6C656E6774683B29746869732E5F6C656E7365732E70757368286E65';
wwv_flow_imp.g_varchar2_table(18636) := '77206156286E5B725D2C746869732E5F656469746F722C692C742C732E636F64654C656E734865696768742C2828293D3E746869732E5F7265736F6C7665436F64654C656E736573496E56696577706F7274536F6F6E28292929292C722B2B3B692E636F';
wwv_flow_imp.g_varchar2_table(18637) := '6D6D69742865297D29297D29292C6F2E726573746F726528746869732E5F656469746F72297D5F7265736F6C7665436F64654C656E736573496E56696577706F7274536F6F6E28297B746869732E5F656469746F722E6765744D6F64656C282926267468';
wwv_flow_imp.g_varchar2_table(18638) := '69732E5F7265736F6C7665436F64654C656E7365735363686564756C65722E7363686564756C6528297D5F7265736F6C7665436F64654C656E736573496E56696577706F727428297B76617220653B6E756C6C3D3D3D28653D746869732E5F7265736F6C';
wwv_flow_imp.g_varchar2_table(18639) := '7665436F64654C656E73657350726F6D697365297C7C766F696420303D3D3D657C7C652E63616E63656C28292C746869732E5F7265736F6C7665436F64654C656E73657350726F6D6973653D766F696420303B636F6E737420743D746869732E5F656469';
wwv_flow_imp.g_varchar2_table(18640) := '746F722E6765744D6F64656C28293B69662821742972657475726E3B636F6E7374206E3D5B5D2C693D5B5D3B696628746869732E5F6C656E7365732E666F72456163682828653D3E7B636F6E7374206F3D652E636F6D7075746549664E65636573736172';
wwv_flow_imp.g_varchar2_table(18641) := '792874293B6F2626286E2E70757368286F292C692E70757368286529297D29292C303D3D3D6E2E6C656E6774682972657475726E3B636F6E7374206F3D446174652E6E6F7728292C733D46742828653D3E7B636F6E7374206F3D6E2E6D61702828286E2C';
wwv_flow_imp.g_varchar2_table(18642) := '6F293D3E7B636F6E737420733D6E6577204172726179286E2E6C656E677468292C723D6E2E6D61702828286E2C69293D3E6E2E73796D626F6C2E636F6D6D616E647C7C2266756E6374696F6E22213D747970656F66206E2E70726F76696465722E726573';
wwv_flow_imp.g_varchar2_table(18643) := '6F6C7665436F64654C656E733F28735B695D3D6E2E73796D626F6C2C50726F6D6973652E7265736F6C766528766F6964203029293A50726F6D6973652E7265736F6C7665286E2E70726F76696465722E7265736F6C7665436F64654C656E7328742C6E2E';
wwv_flow_imp.g_varchar2_table(18644) := '73796D626F6C2C6529292E7468656E2828653D3E7B735B695D3D657D292C45652929293B72657475726E2050726F6D6973652E616C6C2872292E7468656E282828293D3E7B652E697343616E63656C6C6174696F6E5265717565737465647C7C695B6F5D';
wwv_flow_imp.g_varchar2_table(18645) := '2E6973446973706F73656428297C7C695B6F5D2E757064617465436F6D6D616E64732873297D29297D29293B72657475726E2050726F6D6973652E616C6C286F297D29293B746869732E5F7265736F6C7665436F64654C656E73657350726F6D6973653D';
wwv_flow_imp.g_varchar2_table(18646) := '732C746869732E5F7265736F6C7665436F64654C656E73657350726F6D6973652E7468656E282828293D3E7B636F6E737420653D746869732E5F7265736F6C7665436F64654C656E7365734465626F756E63652E75706461746528742C446174652E6E6F';
wwv_flow_imp.g_varchar2_table(18647) := '7728292D6F293B746869732E5F7265736F6C7665436F64654C656E7365735363686564756C65722E64656C61793D652C746869732E5F63757272656E74436F64654C656E734D6F64656C2626746869732E5F636F64654C656E7343616368652E70757428';
wwv_flow_imp.g_varchar2_table(18648) := '742C746869732E5F63757272656E74436F64654C656E734D6F64656C292C746869732E5F6F6C64436F64654C656E734D6F64656C732E636C65617228292C733D3D3D746869732E5F7265736F6C7665436F64654C656E73657350726F6D69736526262874';
wwv_flow_imp.g_varchar2_table(18649) := '6869732E5F7265736F6C7665436F64654C656E73657350726F6D6973653D766F69642030297D292C28653D3E7B6B652865292C733D3D3D746869732E5F7265736F6C7665436F64654C656E73657350726F6D697365262628746869732E5F7265736F6C76';
wwv_flow_imp.g_varchar2_table(18650) := '65436F64654C656E73657350726F6D6973653D766F69642030297D29297D6173796E63206765744D6F64656C28297B76617220653B72657475726E20617761697420746869732E5F676574436F64654C656E734D6F64656C50726F6D6973652C61776169';
wwv_flow_imp.g_varchar2_table(18651) := '7420746869732E5F7265736F6C7665436F64654C656E73657350726F6D6973652C286E756C6C3D3D3D28653D746869732E5F63757272656E74436F64654C656E734D6F64656C297C7C766F696420303D3D3D653F766F696420303A652E6973446973706F';
wwv_flow_imp.g_varchar2_table(18652) := '736564293F766F696420303A746869732E5F63757272656E74436F64654C656E734D6F64656C7D7D3B66562E49443D226373732E656469746F722E636F64654C656E73222C66563D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D6172';
wwv_flow_imp.g_varchar2_table(18653) := '67756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C656374';
wwv_flow_imp.g_varchar2_table(18654) := '26262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D';
wwv_flow_imp.g_varchar2_table(18655) := '29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6D5628';
wwv_flow_imp.g_varchar2_table(18656) := '312C7878292C6D5628322C6456292C6D5628332C7863292C6D5628342C7344292C6D5628352C5842295D2C6656292C4A642866562E49442C66562C31292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B73757065';
wwv_flow_imp.g_varchar2_table(18657) := '72287B69643A22636F64656C656E732E73686F774C656E736573496E43757272656E744C696E65222C707265636F6E646974696F6E3A6C682E686173436F64654C656E7350726F76696465722C6C6162656C3A6228302C2253686F7720436F64654C656E';
wwv_flow_imp.g_varchar2_table(18658) := '7320436F6D6D616E647320466F722043757272656E74204C696E6522292C616C6961733A2253686F7720436F64654C656E7320436F6D6D616E647320466F722043757272656E74204C696E65227D297D6173796E632072756E28652C74297B6966282174';
wwv_flow_imp.g_varchar2_table(18659) := '2E6861734D6F64656C28292972657475726E3B636F6E7374206E3D652E676574284C45292C693D652E676574287863292C6F3D652E676574287344292C733D742E67657453656C656374696F6E28292E706F736974696F6E4C696E654E756D6265722C72';
wwv_flow_imp.g_varchar2_table(18660) := '3D742E676574436F6E747269627574696F6E2866562E4944293B69662821722972657475726E3B636F6E737420613D617761697420722E6765744D6F64656C28293B69662821612972657475726E3B636F6E7374206C3D5B5D3B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(18661) := '65206F6620612E6C656E73657329652E73796D626F6C2E636F6D6D616E642626652E73796D626F6C2E72616E67652E73746172744C696E654E756D6265723D3D3D7326266C2E70757368287B6C6162656C3A652E73796D626F6C2E636F6D6D616E642E74';
wwv_flow_imp.g_varchar2_table(18662) := '69746C652C636F6D6D616E643A652E73796D626F6C2E636F6D6D616E647D293B696628303D3D3D6C2E6C656E6774682972657475726E3B636F6E737420633D6177616974206E2E7069636B286C2C7B63616E5069636B4D616E793A21312C706C61636548';
wwv_flow_imp.g_varchar2_table(18663) := '6F6C6465723A6228302C2253656C656374206120636F6D6D616E6422297D293B69662821632972657475726E3B6C657420643D632E636F6D6D616E643B696628612E6973446973706F736564297B636F6E737420653D617761697420722E6765744D6F64';
wwv_flow_imp.g_varchar2_table(18664) := '656C28292C743D6E756C6C3D3D653F766F696420303A652E6C656E7365732E66696E642828653D3E7B76617220743B72657475726E20652E73796D626F6C2E72616E67652E73746172744C696E654E756D6265723D3D3D732626286E756C6C3D3D3D2874';
wwv_flow_imp.g_varchar2_table(18665) := '3D652E73796D626F6C2E636F6D6D616E64297C7C766F696420303D3D3D743F766F696420303A742E7469746C65293D3D3D642E7469746C657D29293B69662821747C7C21742E73796D626F6C2E636F6D6D616E642972657475726E3B643D742E73796D62';
wwv_flow_imp.g_varchar2_table(18666) := '6F6C2E636F6D6D616E647D7472797B617761697420692E65786563757465436F6D6D616E6428642E69642C2E2E2E642E617267756D656E74737C7C5B5D297D63617463682865297B6F2E6572726F722865297D7D7D293B6C65742076563D21313B66756E';
wwv_flow_imp.g_varchar2_table(18667) := '6374696F6E2062562865297B4B26262876567C7C2876563D21302C636F6E736F6C652E7761726E2822436F756C64206E6F74206372656174652077656220776F726B65722873292E2046616C6C696E67206261636B20746F206C6F6164696E6720776562';
wwv_flow_imp.g_varchar2_table(18668) := '20776F726B657220636F646520696E206D61696E207468726561642C207768696368206D6967687420636175736520554920667265657A65732E20506C65617365207365652068747470733A2F2F6769746875622E636F6D2F6D6963726F736F66742F6D';
wwv_flow_imp.g_varchar2_table(18669) := '6F6E61636F2D656469746F72236661712229292C636F6E736F6C652E7761726E28652E6D65737361676529297D636C617373205F567B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7265713D';
wwv_flow_imp.g_varchar2_table(18670) := '742C746869732E6D6574686F643D6E2C746869732E617267733D692C746869732E747970653D307D7D636C6173732079567B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7365713D742C7468';
wwv_flow_imp.g_varchar2_table(18671) := '69732E7265733D6E2C746869732E6572723D692C746869732E747970653D317D7D636C6173732077567B636F6E7374727563746F7228652C742C6E2C69297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E74';
wwv_flow_imp.g_varchar2_table(18672) := '4E616D653D6E2C746869732E6172673D692C746869732E747970653D327D7D636C6173732043567B636F6E7374727563746F7228652C742C6E297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E6576656E743D6E2C74';
wwv_flow_imp.g_varchar2_table(18673) := '6869732E747970653D337D7D636C6173732053567B636F6E7374727563746F7228652C74297B746869732E7673576F726B65723D652C746869732E7265713D742C746869732E747970653D347D7D636C6173732078567B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(18674) := '297B746869732E5F776F726B657249643D2D312C746869732E5F68616E646C65723D652C746869732E5F6C61737453656E745265713D302C746869732E5F70656E64696E675265706C6965733D4F626A6563742E637265617465286E756C6C292C746869';
wwv_flow_imp.g_varchar2_table(18675) := '732E5F70656E64696E67456D6974746572733D6E6577204D61702C746869732E5F70656E64696E674576656E74733D6E6577204D61707D736574576F726B657249642865297B746869732E5F776F726B657249643D657D73656E644D6573736167652865';
wwv_flow_imp.g_varchar2_table(18676) := '2C74297B636F6E7374206E3D537472696E67282B2B746869732E5F6C61737453656E74526571293B72657475726E206E65772050726F6D697365282828692C6F293D3E7B746869732E5F70656E64696E675265706C6965735B6E5D3D7B7265736F6C7665';
wwv_flow_imp.g_varchar2_table(18677) := '3A692C72656A6563743A6F7D2C746869732E5F73656E64286E6577205F5628746869732E5F776F726B657249642C6E2C652C7429297D29297D6C697374656E28652C74297B6C6574206E3D6E756C6C3B636F6E737420693D6E6577204374287B6F6E5769';
wwv_flow_imp.g_varchar2_table(18678) := '6C6C41646446697273744C697374656E65723A28293D3E7B6E3D537472696E67282B2B746869732E5F6C61737453656E74526571292C746869732E5F70656E64696E67456D6974746572732E736574286E2C69292C746869732E5F73656E64286E657720';
wwv_flow_imp.g_varchar2_table(18679) := '775628746869732E5F776F726B657249642C6E2C652C7429297D2C6F6E44696452656D6F76654C6173744C697374656E65723A28293D3E7B746869732E5F70656E64696E67456D6974746572732E64656C657465286E292C746869732E5F73656E64286E';
wwv_flow_imp.g_varchar2_table(18680) := '657720535628746869732E5F776F726B657249642C6E29292C6E3D6E756C6C7D7D293B72657475726E20692E6576656E747D68616E646C654D6573736167652865297B652626652E7673576F726B65722626282D31213D3D746869732E5F776F726B6572';
wwv_flow_imp.g_varchar2_table(18681) := '49642626652E7673576F726B6572213D3D746869732E5F776F726B657249647C7C746869732E5F68616E646C654D657373616765286529297D5F68616E646C654D6573736167652865297B73776974636828652E74797065297B6361736520313A726574';
wwv_flow_imp.g_varchar2_table(18682) := '75726E20746869732E5F68616E646C655265706C794D6573736167652865293B6361736520303A72657475726E20746869732E5F68616E646C65526571756573744D6573736167652865293B6361736520323A72657475726E20746869732E5F68616E64';
wwv_flow_imp.g_varchar2_table(18683) := '6C655375627363726962654576656E744D6573736167652865293B6361736520333A72657475726E20746869732E5F68616E646C654576656E744D6573736167652865293B6361736520343A72657475726E20746869732E5F68616E646C65556E737562';
wwv_flow_imp.g_varchar2_table(18684) := '7363726962654576656E744D6573736167652865297D7D5F68616E646C655265706C794D6573736167652865297B69662821746869732E5F70656E64696E675265706C6965735B652E7365715D2972657475726E20766F696420636F6E736F6C652E7761';
wwv_flow_imp.g_varchar2_table(18685) := '726E2822476F74207265706C7920746F20756E6B6E6F776E2073657122293B636F6E737420743D746869732E5F70656E64696E675265706C6965735B652E7365715D3B69662864656C65746520746869732E5F70656E64696E675265706C6965735B652E';
wwv_flow_imp.g_varchar2_table(18686) := '7365715D2C652E657272297B6C6574206E3D652E6572723B72657475726E20652E6572722E2469734572726F722626286E3D6E6577204572726F722C6E2E6E616D653D652E6572722E6E616D652C6E2E6D6573736167653D652E6572722E6D6573736167';
wwv_flow_imp.g_varchar2_table(18687) := '652C6E2E737461636B3D652E6572722E737461636B292C766F696420742E72656A656374286E297D742E7265736F6C766528652E726573297D5F68616E646C65526571756573744D6573736167652865297B636F6E737420743D652E7265713B74686973';
wwv_flow_imp.g_varchar2_table(18688) := '2E5F68616E646C65722E68616E646C654D65737361676528652E6D6574686F642C652E61726773292E7468656E2828653D3E7B746869732E5F73656E64286E657720795628746869732E5F776F726B657249642C742C652C766F6964203029297D292C28';
wwv_flow_imp.g_varchar2_table(18689) := '653D3E7B652E64657461696C20696E7374616E63656F66204572726F72262628652E64657461696C3D4C6528652E64657461696C29292C746869732E5F73656E64286E657720795628746869732E5F776F726B657249642C742C766F696420302C4C6528';
wwv_flow_imp.g_varchar2_table(18690) := '652929297D29297D5F68616E646C655375627363726962654576656E744D6573736167652865297B636F6E737420743D652E7265712C6E3D746869732E5F68616E646C65722E68616E646C654576656E7428652E6576656E744E616D652C652E61726729';
wwv_flow_imp.g_varchar2_table(18691) := '2828653D3E7B746869732E5F73656E64286E657720435628746869732E5F776F726B657249642C742C6529297D29293B746869732E5F70656E64696E674576656E74732E73657428742C6E297D5F68616E646C654576656E744D6573736167652865297B';
wwv_flow_imp.g_varchar2_table(18692) := '746869732E5F70656E64696E67456D6974746572732E68617328652E726571293F746869732E5F70656E64696E67456D6974746572732E67657428652E726571292E6669726528652E6576656E74293A636F6E736F6C652E7761726E2822476F74206576';
wwv_flow_imp.g_varchar2_table(18693) := '656E7420666F7220756E6B6E6F776E2072657122297D5F68616E646C65556E7375627363726962654576656E744D6573736167652865297B746869732E5F70656E64696E674576656E74732E68617328652E726571293F28746869732E5F70656E64696E';
wwv_flow_imp.g_varchar2_table(18694) := '674576656E74732E67657428652E726571292E646973706F736528292C746869732E5F70656E64696E674576656E74732E64656C65746528652E72657129293A636F6E736F6C652E7761726E2822476F7420756E73756273637269626520666F7220756E';
wwv_flow_imp.g_varchar2_table(18695) := '6B6E6F776E2072657122297D5F73656E642865297B636F6E737420743D5B5D3B696628303D3D3D652E7479706529666F72286C6574206E3D303B6E3C652E617267732E6C656E6774683B6E2B2B29652E617267735B6E5D696E7374616E63656F66204172';
wwv_flow_imp.g_varchar2_table(18696) := '7261794275666665722626742E7075736828652E617267735B6E5D293B656C736520313D3D3D652E747970652626652E72657320696E7374616E63656F662041727261794275666665722626742E7075736828652E726573293B746869732E5F68616E64';
wwv_flow_imp.g_varchar2_table(18697) := '6C65722E73656E644D65737361676528652C74297D7D636C617373206B5620657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228293B6C657420693D6E756C6C3B746869732E5F776F726B65723D746869732E5F72';
wwv_flow_imp.g_varchar2_table(18698) := '6567697374657228652E637265617465282276732F626173652F636F6D6D6F6E2F776F726B65722F73696D706C65576F726B6572222C28653D3E7B746869732E5F70726F746F636F6C2E68616E646C654D6573736167652865297D292C28653D3E7B6E75';
wwv_flow_imp.g_varchar2_table(18699) := '6C6C3D3D697C7C692865297D2929292C746869732E5F70726F746F636F6C3D6E6577207856287B73656E644D6573736167653A28652C74293D3E7B746869732E5F776F726B65722E706F73744D65737361676528652C74297D2C68616E646C654D657373';
wwv_flow_imp.g_varchar2_table(18700) := '6167653A28652C74293D3E7B6966282266756E6374696F6E22213D747970656F66206E5B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E67206D6574686F6420222B652B22206F6E206D61696E';
wwv_flow_imp.g_varchar2_table(18701) := '2074687265616420686F73742E2229293B7472797B72657475726E2050726F6D6973652E7265736F6C7665286E5B655D2E6170706C79286E2C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D2C68616E';
wwv_flow_imp.g_varchar2_table(18702) := '646C654576656E743A28652C74293D3E7B6966284C56286529297B636F6E737420693D6E5B655D2E63616C6C286E2C74293B6966282266756E6374696F6E22213D747970656F662069297468726F77206E6577204572726F7228604D697373696E672064';
wwv_flow_imp.g_varchar2_table(18703) := '796E616D6963206576656E7420247B657D206F6E206D61696E2074687265616420686F73742E60293B72657475726E20697D6966284556286529297B636F6E737420743D6E5B655D3B6966282266756E6374696F6E22213D747970656F66207429746872';
wwv_flow_imp.g_varchar2_table(18704) := '6F77206E6577204572726F7228604D697373696E67206576656E7420247B657D206F6E206D61696E2074687265616420686F73742E60293B72657475726E20747D7468726F77206E6577204572726F7228604D616C666F726D6564206576656E74206E61';
wwv_flow_imp.g_varchar2_table(18705) := '6D6520247B657D60297D7D292C746869732E5F70726F746F636F6C2E736574576F726B6572496428746869732E5F776F726B65722E67657449642829293B6C6574206F3D6E756C6C3B636F6E737420733D676C6F62616C546869732E726571756972653B';
wwv_flow_imp.g_varchar2_table(18706) := '766F69642030213D3D7326262266756E6374696F6E223D3D747970656F6620732E676574436F6E6669673F6F3D732E676574436F6E66696728293A766F69642030213D3D676C6F62616C546869732E726571756972656A732626286F3D676C6F62616C54';
wwv_flow_imp.g_varchar2_table(18707) := '6869732E726571756972656A732E732E636F6E74657874732E5F2E636F6E666967293B636F6E737420723D4368286E293B746869732E5F6F6E4D6F64756C654C6F616465643D746869732E5F70726F746F636F6C2E73656E644D65737361676528222469';
wwv_flow_imp.g_varchar2_table(18708) := '6E697469616C697A65222C5B746869732E5F776F726B65722E676574496428292C4A534F4E2E7061727365284A534F4E2E737472696E67696679286F29292C742C725D293B636F6E737420613D28652C74293D3E746869732E5F7265717565737428652C';
wwv_flow_imp.g_varchar2_table(18709) := '74292C6C3D28652C74293D3E746869732E5F70726F746F636F6C2E6C697374656E28652C74293B746869732E5F6C617A7950726F78793D6E65772050726F6D697365282828652C6E293D3E7B693D6E2C746869732E5F6F6E4D6F64756C654C6F61646564';
wwv_flow_imp.g_varchar2_table(18710) := '2E7468656E2828743D3E7B652866756E6374696F6E28652C742C6E297B636F6E737420693D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B72';
wwv_flow_imp.g_varchar2_table(18711) := '657475726E207428652C6E297D2C6F3D653D3E66756E6374696F6E2874297B72657475726E206E28652C74297D2C733D7B7D3B666F7228636F6E73742074206F662065294C562874293F735B745D3D6F2874293A45562874293F735B745D3D6E28742C76';
wwv_flow_imp.g_varchar2_table(18712) := '6F69642030293A735B745D3D692874293B72657475726E20737D28742C612C6C29297D292C28653D3E7B6E2865292C746869732E5F6F6E4572726F722822576F726B6572206661696C656420746F206C6F616420222B742C65297D29297D29297D676574';
wwv_flow_imp.g_varchar2_table(18713) := '50726F78794F626A65637428297B72657475726E20746869732E5F6C617A7950726F78797D5F7265717565737428652C74297B72657475726E206E65772050726F6D6973652828286E2C69293D3E7B746869732E5F6F6E4D6F64756C654C6F616465642E';
wwv_flow_imp.g_varchar2_table(18714) := '7468656E282828293D3E7B746869732E5F70726F746F636F6C2E73656E644D65737361676528652C74292E7468656E286E2C69297D292C69297D29297D5F6F6E4572726F7228652C74297B636F6E736F6C652E6572726F722865292C636F6E736F6C652E';
wwv_flow_imp.g_varchar2_table(18715) := '696E666F2874297D7D66756E6374696F6E2045562865297B72657475726E226F223D3D3D655B305D2626226E223D3D3D655B315D2626786928652E63686172436F64654174283229297D66756E6374696F6E204C562865297B72657475726E2F5E6F6E44';
wwv_flow_imp.g_varchar2_table(18716) := '796E616D69632F2E746573742865292626786928652E63686172436F64654174283929297D636F6E73742044563D6545282264656661756C74576F726B6572466163746F7279222C7B63726561746553637269707455524C3A653D3E657D293B636C6173';
wwv_flow_imp.g_varchar2_table(18717) := '7320545620657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E69643D742C746869732E6C6162656C3D6E3B636F6E737420733D66756E6374696F6E2865297B636F6E737420743D676C';
wwv_flow_imp.g_varchar2_table(18718) := '6F62616C546869732E4D6F6E61636F456E7669726F6E6D656E743B69662874297B6966282266756E6374696F6E223D3D747970656F6620742E676574576F726B65722972657475726E20742E676574576F726B65722822776F726B65724D61696E2E6A73';
wwv_flow_imp.g_varchar2_table(18719) := '222C65293B6966282266756E6374696F6E223D3D747970656F6620742E676574576F726B657255726C297B636F6E7374206E3D742E676574576F726B657255726C2822776F726B65724D61696E2E6A73222C65293B72657475726E206E657720576F726B';
wwv_flow_imp.g_varchar2_table(18720) := '65722844563F44562E63726561746553637269707455524C286E293A6E2C7B6E616D653A657D297D7D7468726F77206E6577204572726F722822596F75206D75737420646566696E6520612066756E6374696F6E204D6F6E61636F456E7669726F6E6D65';
wwv_flow_imp.g_varchar2_table(18721) := '6E742E676574576F726B657255726C206F72204D6F6E61636F456E7669726F6E6D656E742E676574576F726B657222297D286E293B2266756E6374696F6E223D3D747970656F6620732E7468656E3F746869732E776F726B65723D733A746869732E776F';
wwv_flow_imp.g_varchar2_table(18722) := '726B65723D50726F6D6973652E7265736F6C76652873292C746869732E706F73744D65737361676528652C5B5D292C746869732E776F726B65722E7468656E2828653D3E7B652E6F6E6D6573736167653D66756E6374696F6E2865297B6928652E646174';
wwv_flow_imp.g_varchar2_table(18723) := '61297D2C652E6F6E6D6573736167656572726F723D6F2C2266756E6374696F6E223D3D747970656F6620652E6164644576656E744C697374656E65722626652E6164644576656E744C697374656E657228226572726F72222C6F297D29292C746869732E';
wwv_flow_imp.g_varchar2_table(18724) := '5F7265676973746572287274282828293D3E7B76617220653B6E756C6C3D3D3D28653D746869732E776F726B6572297C7C766F696420303D3D3D657C7C652E7468656E2828653D3E7B652E6F6E6D6573736167653D6E756C6C2C652E6F6E6D6573736167';
wwv_flow_imp.g_varchar2_table(18725) := '656572726F723D6E756C6C2C652E72656D6F76654576656E744C697374656E657228226572726F72222C6F292C652E7465726D696E61746528297D29292C746869732E776F726B65723D6E756C6C7D2929297D676574496428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(18726) := '69732E69647D706F73744D65737361676528652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E776F726B6572297C7C766F696420303D3D3D6E7C7C6E2E7468656E28286E3D3E7B7472797B6E2E706F73744D65737361676528652C74297D';
wwv_flow_imp.g_varchar2_table(18727) := '63617463682865297B6B652865292C6B65286E6577204572726F7228604641494C454420746F20706F7374206D65737361676520746F2027247B746869732E6C6162656C7D272D776F726B6572602C7B63617573653A657D29297D7D29297D7D636C6173';
wwv_flow_imp.g_varchar2_table(18728) := '732049567B636F6E7374727563746F722865297B746869732E5F6C6162656C3D652C746869732E5F776562576F726B65724661696C65644265666F72654572726F723D21317D63726561746528652C742C6E297B636F6E737420693D2B2B49562E4C4153';
wwv_flow_imp.g_varchar2_table(18729) := '545F574F524B45525F49443B696628746869732E5F776562576F726B65724661696C65644265666F72654572726F72297468726F7720746869732E5F776562576F726B65724661696C65644265666F72654572726F723B72657475726E206E6577205456';
wwv_flow_imp.g_varchar2_table(18730) := '28652C692C746869732E5F6C6162656C7C7C22616E6F6E796D6F7573222B692C742C28653D3E7B62562865292C746869732E5F776562576F726B65724661696C65644265666F72654572726F723D652C6E2865297D29297D7D49562E4C4153545F574F52';
wwv_flow_imp.g_varchar2_table(18731) := '4B45525F49443D303B636C617373204D567B636F6E7374727563746F7228652C742C6E2C69297B746869732E6F726967696E616C53746172743D652C746869732E6F726967696E616C4C656E6774683D742C746869732E6D6F6469666965645374617274';
wwv_flow_imp.g_varchar2_table(18732) := '3D6E2C746869732E6D6F6469666965644C656E6774683D697D6765744F726967696E616C456E6428297B72657475726E20746869732E6F726967696E616C53746172742B746869732E6F726967696E616C4C656E6774687D6765744D6F64696669656445';
wwv_flow_imp.g_varchar2_table(18733) := '6E6428297B72657475726E20746869732E6D6F64696669656453746172742B746869732E6D6F6469666965644C656E6774687D7D636C6173732041567B636F6E7374727563746F722865297B746869732E736F757263653D657D676574456C656D656E74';
wwv_flow_imp.g_varchar2_table(18734) := '7328297B636F6E737420653D746869732E736F757263652C743D6E657720496E743332417272617928652E6C656E677468293B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29745B6E5D3D652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(18735) := '6E293B72657475726E20747D7D66756E6374696F6E204E5628652C742C6E297B72657475726E206E6577204656286E65772041562865292C6E6577204156287429292E436F6D7075746544696666286E292E6368616E6765737D636C6173732050567B73';
wwv_flow_imp.g_varchar2_table(18736) := '74617469632041737365727428652C74297B6966282165297468726F77206E6577204572726F722874297D7D636C617373204F567B73746174696320436F707928652C742C6E2C692C6F297B666F72286C657420733D303B733C6F3B732B2B296E5B692B';
wwv_flow_imp.g_varchar2_table(18737) := '735D3D655B742B735D7D73746174696320436F70793228652C742C6E2C692C6F297B666F72286C657420733D303B733C6F3B732B2B296E5B692B735D3D655B742B735D7D7D636C6173732052567B636F6E7374727563746F7228297B746869732E6D5F63';
wwv_flow_imp.g_varchar2_table(18738) := '68616E6765733D5B5D2C746869732E6D5F6F726967696E616C53746172743D313037333734313832342C746869732E6D5F6D6F64696669656453746172743D313037333734313832342C746869732E6D5F6F726967696E616C436F756E743D302C746869';
wwv_flow_imp.g_varchar2_table(18739) := '732E6D5F6D6F646966696564436F756E743D307D4D61726B4E6578744368616E676528297B28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E6D5F6368616E6765';
wwv_flow_imp.g_varchar2_table(18740) := '732E70757368286E6577204D5628746869732E6D5F6F726967696E616C53746172742C746869732E6D5F6F726967696E616C436F756E742C746869732E6D5F6D6F64696669656453746172742C746869732E6D5F6D6F646966696564436F756E7429292C';
wwv_flow_imp.g_varchar2_table(18741) := '746869732E6D5F6F726967696E616C436F756E743D302C746869732E6D5F6D6F646966696564436F756E743D302C746869732E6D5F6F726967696E616C53746172743D313037333734313832342C746869732E6D5F6D6F64696669656453746172743D31';
wwv_flow_imp.g_varchar2_table(18742) := '3037333734313832347D4164644F726967696E616C456C656D656E7428652C74297B746869732E6D5F6F726967696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F726967696E616C53746172742C65292C746869732E6D5F6D6F646966';
wwv_flow_imp.g_varchar2_table(18743) := '69656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669656453746172742C74292C746869732E6D5F6F726967696E616C436F756E742B2B7D4164644D6F646966696564456C656D656E7428652C74297B746869732E6D5F6F726967';
wwv_flow_imp.g_varchar2_table(18744) := '696E616C53746172743D4D6174682E6D696E28746869732E6D5F6F726967696E616C53746172742C65292C746869732E6D5F6D6F64696669656453746172743D4D6174682E6D696E28746869732E6D5F6D6F64696669656453746172742C74292C746869';
wwv_flow_imp.g_varchar2_table(18745) := '732E6D5F6D6F646966696564436F756E742B2B7D6765744368616E67657328297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E30292626746869732E4D61726B4E65';
wwv_flow_imp.g_varchar2_table(18746) := '78744368616E676528292C746869732E6D5F6368616E6765737D676574526576657273654368616E67657328297B72657475726E28746869732E6D5F6F726967696E616C436F756E743E307C7C746869732E6D5F6D6F646966696564436F756E743E3029';
wwv_flow_imp.g_varchar2_table(18747) := '2626746869732E4D61726B4E6578744368616E676528292C746869732E6D5F6368616E6765732E7265766572736528292C746869732E6D5F6368616E6765737D7D636C6173732046567B636F6E7374727563746F7228652C742C6E3D6E756C6C297B7468';
wwv_flow_imp.g_varchar2_table(18748) := '69732E436F6E74696E756550726F63657373696E675072656469636174653D6E2C746869732E5F6F726967696E616C53657175656E63653D652C746869732E5F6D6F64696669656453657175656E63653D743B636F6E73745B692C6F2C735D3D46562E5F';
wwv_flow_imp.g_varchar2_table(18749) := '676574456C656D656E74732865292C5B722C612C6C5D3D46562E5F676574456C656D656E74732874293B746869732E5F686173537472696E67733D7326266C2C746869732E5F6F726967696E616C537472696E67456C656D656E74733D692C746869732E';
wwv_flow_imp.g_varchar2_table(18750) := '5F6F726967696E616C456C656D656E74734F72486173683D6F2C746869732E5F6D6F646966696564537472696E67456C656D656E74733D722C746869732E5F6D6F646966696564456C656D656E74734F72486173683D612C746869732E6D5F666F727761';
wwv_flow_imp.g_varchar2_table(18751) := '7264486973746F72793D5B5D2C746869732E6D5F72657665727365486973746F72793D5B5D7D737461746963205F6973537472696E6741727261792865297B72657475726E20652E6C656E6774683E30262622737472696E67223D3D747970656F662065';
wwv_flow_imp.g_varchar2_table(18752) := '5B305D7D737461746963205F676574456C656D656E74732865297B636F6E737420743D652E676574456C656D656E747328293B69662846562E5F6973537472696E674172726179287429297B636F6E737420653D6E657720496E74333241727261792874';
wwv_flow_imp.g_varchar2_table(18753) := '2E6C656E677468293B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29655B6E5D3D657328745B6E5D2C30293B72657475726E5B742C652C21305D7D72657475726E207420696E7374616E63656F6620496E74333241727261';
wwv_flow_imp.g_varchar2_table(18754) := '793F5B5B5D2C742C21315D3A5B5B5D2C6E657720496E74333241727261792874292C21315D7D456C656D656E7473417265457175616C28652C74297B72657475726E20746869732E5F6F726967696E616C456C656D656E74734F72486173685B655D3D3D';
wwv_flow_imp.g_varchar2_table(18755) := '3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D3D3D3D746869732E5F6D6F64696669';
wwv_flow_imp.g_varchar2_table(18756) := '6564537472696E67456C656D656E74735B745D297D456C656D656E7473417265537472696374457175616C28652C74297B72657475726E2121746869732E456C656D656E7473417265457175616C28652C7429262646562E5F676574537472696374456C';
wwv_flow_imp.g_varchar2_table(18757) := '656D656E7428746869732E5F6F726967696E616C53657175656E63652C65293D3D3D46562E5F676574537472696374456C656D656E7428746869732E5F6D6F64696669656453657175656E63652C74297D737461746963205F676574537472696374456C';
wwv_flow_imp.g_varchar2_table(18758) := '656D656E7428652C74297B72657475726E2266756E6374696F6E223D3D747970656F6620652E676574537472696374456C656D656E743F652E676574537472696374456C656D656E742874293A6E756C6C7D4F726967696E616C456C656D656E74734172';
wwv_flow_imp.g_varchar2_table(18759) := '65457175616C28652C74297B72657475726E20746869732E5F6F726967696E616C456C656D656E74734F72486173685B655D3D3D3D746869732E5F6F726967696E616C456C656D656E74734F72486173685B745D26262821746869732E5F686173537472';
wwv_flow_imp.g_varchar2_table(18760) := '696E67737C7C746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D3D3D3D746869732E5F6F726967696E616C537472696E67456C656D656E74735B745D297D4D6F646966696564456C656D656E7473417265457175616C28652C';
wwv_flow_imp.g_varchar2_table(18761) := '74297B72657475726E20746869732E5F6D6F646966696564456C656D656E74734F72486173685B655D3D3D3D746869732E5F6D6F646966696564456C656D656E74734F72486173685B745D26262821746869732E5F686173537472696E67737C7C746869';
wwv_flow_imp.g_varchar2_table(18762) := '732E5F6D6F646966696564537472696E67456C656D656E74735B655D3D3D3D746869732E5F6D6F646966696564537472696E67456C656D656E74735B745D297D436F6D70757465446966662865297B72657475726E20746869732E5F436F6D7075746544';
wwv_flow_imp.g_varchar2_table(18763) := '69666628302C746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E6774682D312C302C746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682D312C65297D5F436F6D707574654469666628';
wwv_flow_imp.g_varchar2_table(18764) := '652C742C6E2C692C6F297B636F6E737420733D5B21315D3B6C657420723D746869732E436F6D707574654469666652656375727369766528652C742C6E2C692C73293B72657475726E206F262628723D746869732E50726574746966794368616E676573';
wwv_flow_imp.g_varchar2_table(18765) := '287229292C7B717569744561726C793A735B305D2C6368616E6765733A727D7D436F6D707574654469666652656375727369766528652C742C6E2C692C6F297B666F72286F5B305D3D21313B653C3D7426266E3C3D692626746869732E456C656D656E74';
wwv_flow_imp.g_varchar2_table(18766) := '73417265457175616C28652C6E293B29652B2B2C6E2B2B3B666F72283B743E3D652626693E3D6E2626746869732E456C656D656E7473417265457175616C28742C69293B29742D2D2C692D2D3B696628653E747C7C6E3E69297B6C6574206F3B72657475';
wwv_flow_imp.g_varchar2_table(18767) := '726E206E3C3D693F2850562E41737365727428653D3D3D742B312C226F726967696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C6F3D5B6E6577204D5628652C302C6E';
wwv_flow_imp.g_varchar2_table(18768) := '2C692D6E2B31295D293A653C3D743F2850562E417373657274286E3D3D3D692B312C226D6F64696669656453746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C6F3D5B6E6577204D';
wwv_flow_imp.g_varchar2_table(18769) := '5628652C742D652B312C6E2C30295D293A2850562E41737365727428653D3D3D742B312C226F726967696E616C53746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206F726967696E616C456E6422292C50562E417373';
wwv_flow_imp.g_varchar2_table(18770) := '657274286E3D3D3D692B312C226D6F64696669656453746172742073686F756C64206F6E6C79206265206F6E65206D6F7265207468616E206D6F646966696564456E6422292C6F3D5B5D292C6F7D636F6E737420733D5B305D2C723D5B305D2C613D7468';
wwv_flow_imp.g_varchar2_table(18771) := '69732E436F6D70757465526563757273696F6E506F696E7428652C742C6E2C692C732C722C6F292C6C3D735B305D2C633D725B305D3B6966286E756C6C213D3D612972657475726E20613B696628216F5B305D297B636F6E737420733D746869732E436F';
wwv_flow_imp.g_varchar2_table(18772) := '6D707574654469666652656375727369766528652C6C2C6E2C632C6F293B6C657420723D5B5D3B72657475726E20723D6F5B305D3F5B6E6577204D56286C2B312C742D286C2B31292B312C632B312C692D28632B31292B31295D3A746869732E436F6D70';
wwv_flow_imp.g_varchar2_table(18773) := '75746544696666526563757273697665286C2B312C742C632B312C692C6F292C746869732E436F6E636174656E6174654368616E67657328732C72297D72657475726E5B6E6577204D5628652C742D652B312C6E2C692D6E2B31295D7D57414C4B545241';
wwv_flow_imp.g_varchar2_table(18774) := '434528652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C752C702C672C6D2C662C76297B6C657420623D6E756C6C2C5F3D6E756C6C2C793D6E65772052562C773D742C433D6E2C533D755B305D2D6D5B305D2D692C783D2D3130373337343138';
wwv_flow_imp.g_varchar2_table(18775) := '32342C6B3D746869732E6D5F666F7277617264486973746F72792E6C656E6774682D313B646F7B636F6E737420743D532B653B743D3D3D777C7C743C4326266C5B742D315D3C6C5B742B315D3F28703D28643D6C5B742B315D292D532D692C643C782626';
wwv_flow_imp.g_varchar2_table(18776) := '792E4D61726B4E6578744368616E676528292C783D642C792E4164644D6F646966696564456C656D656E7428642B312C70292C533D742B312D65293A28703D28643D6C5B742D315D2B31292D532D692C643C782626792E4D61726B4E6578744368616E67';
wwv_flow_imp.g_varchar2_table(18777) := '6528292C783D642D312C792E4164644F726967696E616C456C656D656E7428642C702B31292C533D742D312D65292C6B3E3D30262628653D286C3D746869732E6D5F666F7277617264486973746F72795B6B5D295B305D2C773D312C433D6C2E6C656E67';
wwv_flow_imp.g_varchar2_table(18778) := '74682D31297D7768696C65282D2D6B3E3D2D31293B696628623D792E676574526576657273654368616E67657328292C765B305D297B6C657420653D755B305D2B312C743D6D5B305D2B313B6966286E756C6C213D3D622626622E6C656E6774683E3029';
wwv_flow_imp.g_varchar2_table(18779) := '7B636F6E7374206E3D625B622E6C656E6774682D315D3B653D4D6174682E6D617828652C6E2E6765744F726967696E616C456E642829292C743D4D6174682E6D617828742C6E2E6765744D6F646966696564456E642829297D5F3D5B6E6577204D562865';
wwv_flow_imp.g_varchar2_table(18780) := '2C682D652B312C742C672D742B31295D7D656C73657B793D6E65772052562C773D732C433D722C533D755B305D2D6D5B305D2D612C783D313037333734313832342C6B3D663F746869732E6D5F72657665727365486973746F72792E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(18781) := '3A746869732E6D5F72657665727365486973746F72792E6C656E6774682D323B646F7B636F6E737420653D532B6F3B653D3D3D777C7C653C432626635B652D315D3E3D635B652B315D3F28703D28643D635B652B315D2D31292D532D612C643E78262679';
wwv_flow_imp.g_varchar2_table(18782) := '2E4D61726B4E6578744368616E676528292C783D642B312C792E4164644F726967696E616C456C656D656E7428642B312C702B31292C533D652B312D6F293A28703D28643D635B652D315D292D532D612C643E782626792E4D61726B4E6578744368616E';
wwv_flow_imp.g_varchar2_table(18783) := '676528292C783D642C792E4164644D6F646966696564456C656D656E7428642B312C702B31292C533D652D312D6F292C6B3E3D302626286F3D28633D746869732E6D5F72657665727365486973746F72795B6B5D295B305D2C773D312C433D632E6C656E';
wwv_flow_imp.g_varchar2_table(18784) := '6774682D31297D7768696C65282D2D6B3E3D2D31293B5F3D792E6765744368616E67657328297D72657475726E20746869732E436F6E636174656E6174654368616E67657328622C5F297D436F6D70757465526563757273696F6E506F696E7428652C74';
wwv_flow_imp.g_varchar2_table(18785) := '2C6E2C692C6F2C732C72297B6C657420613D302C6C3D302C633D302C643D302C683D302C753D303B652D2D2C6E2D2D2C6F5B305D3D302C735B305D3D302C746869732E6D5F666F7277617264486973746F72793D5B5D2C746869732E6D5F726576657273';
wwv_flow_imp.g_varchar2_table(18786) := '65486973746F72793D5B5D3B636F6E737420703D742D652B28692D6E292C673D702B312C6D3D6E657720496E74333241727261792867292C663D6E657720496E74333241727261792867292C763D692D6E2C623D742D652C5F3D652D6E2C793D742D692C';
wwv_flow_imp.g_varchar2_table(18787) := '773D28622D762925323D3D303B6D5B765D3D652C665B625D3D742C725B305D3D21313B666F72286C657420433D313B433C3D702F322B313B432B2B297B6C657420703D302C533D303B633D746869732E436C6970446961676F6E616C426F756E6428762D';
wwv_flow_imp.g_varchar2_table(18788) := '432C432C762C67292C643D746869732E436C6970446961676F6E616C426F756E6428762B432C432C762C67293B666F72286C657420653D633B653C3D643B652B3D32297B613D653D3D3D637C7C653C6426266D5B652D315D3C6D5B652B315D3F6D5B652B';
wwv_flow_imp.g_varchar2_table(18789) := '315D3A6D5B652D315D2B312C6C3D612D28652D76292D5F3B636F6E7374206E3D613B666F72283B613C7426266C3C692626746869732E456C656D656E7473417265457175616C28612B312C6C2B31293B29612B2B2C6C2B2B3B6966286D5B655D3D612C61';
wwv_flow_imp.g_varchar2_table(18790) := '2B6C3E702B53262628703D612C533D6C292C217726264D6174682E61627328652D62293C3D432D312626613E3D665B655D2972657475726E206F5B305D3D612C735B305D3D6C2C6E3C3D665B655D2626433C3D313434383F746869732E57414C4B545241';
wwv_flow_imp.g_varchar2_table(18791) := '434528762C632C642C5F2C622C682C752C792C6D2C662C612C742C6F2C6C2C692C732C772C72293A6E756C6C7D636F6E737420783D28702D652B28532D6E292D43292F323B6966286E756C6C213D3D746869732E436F6E74696E756550726F6365737369';
wwv_flow_imp.g_varchar2_table(18792) := '6E67507265646963617465262621746869732E436F6E74696E756550726F63657373696E6750726564696361746528702C78292972657475726E20725B305D3D21302C6F5B305D3D702C735B305D3D532C783E302626433C3D313434383F746869732E57';
wwv_flow_imp.g_varchar2_table(18793) := '414C4B545241434528762C632C642C5F2C622C682C752C792C6D2C662C612C742C6F2C6C2C692C732C772C72293A28652B2B2C6E2B2B2C5B6E6577204D5628652C742D652B312C6E2C692D6E2B31295D293B683D746869732E436C6970446961676F6E61';
wwv_flow_imp.g_varchar2_table(18794) := '6C426F756E6428622D432C432C622C67292C753D746869732E436C6970446961676F6E616C426F756E6428622B432C432C622C67293B666F72286C657420703D683B703C3D753B702B3D32297B613D703D3D3D687C7C703C752626665B702D315D3E3D66';
wwv_flow_imp.g_varchar2_table(18795) := '5B702B315D3F665B702B315D2D313A665B702D315D2C6C3D612D28702D62292D793B636F6E737420673D613B666F72283B613E6526266C3E6E2626746869732E456C656D656E7473417265457175616C28612C6C293B29612D2D2C6C2D2D3B696628665B';
wwv_flow_imp.g_varchar2_table(18796) := '705D3D612C7726264D6174682E61627328702D76293C3D432626613C3D6D5B705D2972657475726E206F5B305D3D612C735B305D3D6C2C673E3D6D5B705D2626433C3D313434383F746869732E57414C4B545241434528762C632C642C5F2C622C682C75';
wwv_flow_imp.g_varchar2_table(18797) := '2C792C6D2C662C612C742C6F2C6C2C692C732C772C72293A6E756C6C7D696628433C3D31343437297B6C657420653D6E657720496E743332417272617928642D632B32293B655B305D3D762D632B312C4F562E436F707932286D2C632C652C312C642D63';
wwv_flow_imp.g_varchar2_table(18798) := '2B31292C746869732E6D5F666F7277617264486973746F72792E707573682865292C653D6E657720496E743332417272617928752D682B32292C655B305D3D622D682B312C4F562E436F70793228662C682C652C312C752D682B31292C746869732E6D5F';
wwv_flow_imp.g_varchar2_table(18799) := '72657665727365486973746F72792E707573682865297D7D72657475726E20746869732E57414C4B545241434528762C632C642C5F2C622C682C752C792C6D2C662C612C742C6F2C6C2C692C732C772C72297D50726574746966794368616E6765732865';
wwv_flow_imp.g_varchar2_table(18800) := '297B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B636F6E7374206E3D655B745D2C693D743C652E6C656E6774682D313F655B742B315D2E6F726967696E616C53746172743A746869732E5F6F726967696E616C456C656D656E74';
wwv_flow_imp.g_varchar2_table(18801) := '734F72486173682E6C656E6774682C6F3D743C652E6C656E6774682D313F655B742B315D2E6D6F64696669656453746172743A746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682C733D6E2E6F726967696E616C4C';
wwv_flow_imp.g_varchar2_table(18802) := '656E6774683E302C723D6E2E6D6F6469666965644C656E6774683E303B666F72283B6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774683C6926266E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E67';
wwv_flow_imp.g_varchar2_table(18803) := '74683C6F26262821737C7C746869732E4F726967696E616C456C656D656E7473417265457175616C286E2E6F726967696E616C53746172742C6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E677468292926262821727C7C7468';
wwv_flow_imp.g_varchar2_table(18804) := '69732E4D6F646966696564456C656D656E7473417265457175616C286E2E6D6F64696669656453746172742C6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E67746829293B297B636F6E737420653D746869732E456C656D656E';
wwv_flow_imp.g_varchar2_table(18805) := '7473417265537472696374457175616C286E2E6F726967696E616C53746172742C6E2E6D6F6469666965645374617274293B696628746869732E456C656D656E7473417265537472696374457175616C286E2E6F726967696E616C53746172742B6E2E6F';
wwv_flow_imp.g_varchar2_table(18806) := '726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E677468292626216529627265616B3B6E2E6F726967696E616C53746172742B2B2C6E2E6D6F64696669656453746172742B2B7D636F6E737420';
wwv_flow_imp.g_varchar2_table(18807) := '613D5B6E756C6C5D3B743C652E6C656E6774682D312626746869732E4368616E6765734F7665726C617028655B745D2C655B742B315D2C6129262628655B745D3D615B305D2C652E73706C69636528742B312C31292C742D2D297D666F72286C65742074';
wwv_flow_imp.g_varchar2_table(18808) := '3D652E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D655B745D3B6C657420693D302C6F3D303B696628743E30297B636F6E7374206E3D655B742D315D3B693D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C65';
wwv_flow_imp.g_varchar2_table(18809) := '6E6774682C6F3D6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E6774687D636F6E737420733D6E2E6F726967696E616C4C656E6774683E302C723D6E2E6D6F6469666965644C656E6774683E303B6C657420613D302C6C3D7468';
wwv_flow_imp.g_varchar2_table(18810) := '69732E5F626F756E6461727953636F7265286E2E6F726967696E616C53746172742C6E2E6F726967696E616C4C656E6774682C6E2E6D6F64696669656453746172742C6E2E6D6F6469666965644C656E677468293B666F72286C657420653D313B3B652B';
wwv_flow_imp.g_varchar2_table(18811) := '2B297B636F6E737420743D6E2E6F726967696E616C53746172742D652C633D6E2E6D6F64696669656453746172742D653B696628743C697C7C633C6F29627265616B3B69662873262621746869732E4F726967696E616C456C656D656E74734172654571';
wwv_flow_imp.g_varchar2_table(18812) := '75616C28742C742B6E2E6F726967696E616C4C656E6774682929627265616B3B69662872262621746869732E4D6F646966696564456C656D656E7473417265457175616C28632C632B6E2E6D6F6469666965644C656E6774682929627265616B3B636F6E';
wwv_flow_imp.g_varchar2_table(18813) := '737420643D28743D3D3D692626633D3D3D6F3F353A30292B746869732E5F626F756E6461727953636F726528742C6E2E6F726967696E616C4C656E6774682C632C6E2E6D6F6469666965644C656E677468293B643E6C2626286C3D642C613D65297D6E2E';
wwv_flow_imp.g_varchar2_table(18814) := '6F726967696E616C53746172742D3D612C6E2E6D6F64696669656453746172742D3D613B636F6E737420633D5B6E756C6C5D3B743E302626746869732E4368616E6765734F7665726C617028655B742D315D2C655B745D2C6329262628655B742D315D3D';
wwv_flow_imp.g_varchar2_table(18815) := '635B305D2C652E73706C69636528742C31292C742B2B297D696628746869732E5F686173537472696E677329666F72286C657420743D312C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B742D315D2C693D655B745D2C6F3D';
wwv_flow_imp.g_varchar2_table(18816) := '692E6F726967696E616C53746172742D6E2E6F726967696E616C53746172742D6E2E6F726967696E616C4C656E6774682C733D6E2E6F726967696E616C53746172742C723D692E6F726967696E616C53746172742B692E6F726967696E616C4C656E6774';
wwv_flow_imp.g_varchar2_table(18817) := '682C613D722D732C6C3D6E2E6D6F64696669656453746172742C633D692E6D6F64696669656453746172742B692E6D6F6469666965644C656E6774682C643D632D6C3B6966286F3C352626613C32302626643C3230297B636F6E737420653D746869732E';
wwv_flow_imp.g_varchar2_table(18818) := '5F66696E64426574746572436F6E746967756F757353657175656E636528732C612C6C2C642C6F293B69662865297B636F6E73745B742C735D3D653B743D3D3D6E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E6774682626733D';
wwv_flow_imp.g_varchar2_table(18819) := '3D3D6E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E6774687C7C286E2E6F726967696E616C4C656E6774683D742D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D732D6E2E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(18820) := '6453746172742C692E6F726967696E616C53746172743D742B6F2C692E6D6F64696669656453746172743D732B6F2C692E6F726967696E616C4C656E6774683D722D692E6F726967696E616C53746172742C692E6D6F6469666965644C656E6774683D63';
wwv_flow_imp.g_varchar2_table(18821) := '2D692E6D6F6469666965645374617274297D7D7D72657475726E20657D5F66696E64426574746572436F6E746967756F757353657175656E636528652C742C6E2C692C6F297B696628743C6F7C7C693C6F2972657475726E206E756C6C3B636F6E737420';
wwv_flow_imp.g_varchar2_table(18822) := '733D652B742D6F2B312C723D6E2B692D6F2B313B6C657420613D302C6C3D302C633D303B666F72286C657420743D653B743C733B742B2B29666F72286C657420653D6E3B653C723B652B2B297B636F6E7374206E3D746869732E5F636F6E746967756F75';
wwv_flow_imp.g_varchar2_table(18823) := '7353657175656E636553636F726528742C652C6F293B6E3E3026266E3E61262628613D6E2C6C3D742C633D65297D72657475726E20613E303F5B6C2C635D3A6E756C6C7D5F636F6E746967756F757353657175656E636553636F726528652C742C6E297B';
wwv_flow_imp.g_varchar2_table(18824) := '6C657420693D303B666F72286C6574206F3D303B6F3C6E3B6F2B2B297B69662821746869732E456C656D656E7473417265457175616C28652B6F2C742B6F292972657475726E20303B692B3D746869732E5F6F726967696E616C537472696E67456C656D';
wwv_flow_imp.g_varchar2_table(18825) := '656E74735B652B6F5D2E6C656E6774687D72657475726E20697D5F4F726967696E616C4973426F756E646172792865297B72657475726E20653C3D307C7C653E3D746869732E5F6F726967696E616C456C656D656E74734F72486173682E6C656E677468';
wwv_flow_imp.g_varchar2_table(18826) := '2D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E7465737428746869732E5F6F726967696E616C537472696E67456C656D656E74735B655D297D5F4F726967696E616C526567696F6E4973426F756E6461727928652C74297B69';
wwv_flow_imp.g_varchar2_table(18827) := '6628746869732E5F4F726967696E616C4973426F756E646172792865297C7C746869732E5F4F726967696E616C4973426F756E6461727928652D31292972657475726E21303B696628743E30297B636F6E7374206E3D652B743B696628746869732E5F4F';
wwv_flow_imp.g_varchar2_table(18828) := '726967696E616C4973426F756E64617279286E2D31297C7C746869732E5F4F726967696E616C4973426F756E64617279286E292972657475726E21307D72657475726E21317D5F4D6F6469666965644973426F756E646172792865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(18829) := '653C3D307C7C653E3D746869732E5F6D6F646966696564456C656D656E74734F72486173682E6C656E6774682D317C7C746869732E5F686173537472696E677326262F5E5C732A242F2E7465737428746869732E5F6D6F646966696564537472696E6745';
wwv_flow_imp.g_varchar2_table(18830) := '6C656D656E74735B655D297D5F4D6F646966696564526567696F6E4973426F756E6461727928652C74297B696628746869732E5F4D6F6469666965644973426F756E646172792865297C7C746869732E5F4D6F6469666965644973426F756E6461727928';
wwv_flow_imp.g_varchar2_table(18831) := '652D31292972657475726E21303B696628743E30297B636F6E7374206E3D652B743B696628746869732E5F4D6F6469666965644973426F756E64617279286E2D31297C7C746869732E5F4D6F6469666965644973426F756E64617279286E292972657475';
wwv_flow_imp.g_varchar2_table(18832) := '726E21307D72657475726E21317D5F626F756E6461727953636F726528652C742C6E2C69297B72657475726E28746869732E5F4F726967696E616C526567696F6E4973426F756E6461727928652C74293F313A30292B28746869732E5F4D6F6469666965';
wwv_flow_imp.g_varchar2_table(18833) := '64526567696F6E4973426F756E64617279286E2C69293F313A30297D436F6E636174656E6174654368616E67657328652C74297B636F6E7374206E3D5B5D3B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E20';
wwv_flow_imp.g_varchar2_table(18834) := '742E6C656E6774683E303F743A653B696628746869732E4368616E6765734F7665726C617028655B652E6C656E6774682D315D2C745B305D2C6E29297B636F6E737420693D6E657720417272617928652E6C656E6774682B742E6C656E6774682D31293B';
wwv_flow_imp.g_varchar2_table(18835) := '72657475726E204F562E436F707928652C302C692C302C652E6C656E6774682D31292C695B652E6C656E6774682D315D3D6E5B305D2C4F562E436F707928742C312C692C652E6C656E6774682C742E6C656E6774682D31292C697D7B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(18836) := '6E657720417272617928652E6C656E6774682B742E6C656E677468293B72657475726E204F562E436F707928652C302C6E2C302C652E6C656E677468292C4F562E436F707928742C302C6E2C652E6C656E6774682C742E6C656E677468292C6E7D7D4368';
wwv_flow_imp.g_varchar2_table(18837) := '616E6765734F7665726C617028652C742C6E297B69662850562E41737365727428652E6F726967696E616C53746172743C3D742E6F726967696E616C53746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F722065';
wwv_flow_imp.g_varchar2_table(18838) := '7175616C20746F207269676874206368616E676522292C50562E41737365727428652E6D6F64696669656453746172743C3D742E6D6F64696669656453746172742C224C656674206368616E6765206973206E6F74206C657373207468616E206F722065';
wwv_flow_imp.g_varchar2_table(18839) := '7175616C20746F207269676874206368616E676522292C652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C53746172747C7C652E6D6F64696669656453746172742B652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(18840) := '4C656E6774683E3D742E6D6F6469666965645374617274297B636F6E737420693D652E6F726967696E616C53746172743B6C6574206F3D652E6F726967696E616C4C656E6774683B636F6E737420733D652E6D6F64696669656453746172743B6C657420';
wwv_flow_imp.g_varchar2_table(18841) := '723D652E6D6F6469666965644C656E6774683B72657475726E20652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774683E3D742E6F726967696E616C53746172742626286F3D742E6F726967696E616C53746172742B742E6F72';
wwv_flow_imp.g_varchar2_table(18842) := '6967696E616C4C656E6774682D652E6F726967696E616C5374617274292C652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774683E3D742E6D6F6469666965645374617274262628723D742E6D6F64696669656453746172742B';
wwv_flow_imp.g_varchar2_table(18843) := '742E6D6F6469666965644C656E6774682D652E6D6F6469666965645374617274292C6E5B305D3D6E6577204D5628692C6F2C732C72292C21307D72657475726E206E5B305D3D6E756C6C2C21317D436C6970446961676F6E616C426F756E6428652C742C';
wwv_flow_imp.g_varchar2_table(18844) := '6E2C69297B696628653E3D302626653C692972657475726E20653B636F6E7374206F3D7425323D3D303B72657475726E20653C303F6F3D3D3D286E25323D3D30293F303A313A6F3D3D3D2828692D6E2D312925323D3D30293F692D313A692D327D7D636C';
wwv_flow_imp.g_varchar2_table(18845) := '6173732042567B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F7572693D652C746869732E5F6C696E65733D742C746869732E5F656F6C3D6E2C746869732E5F76657273696F6E49643D692C746869732E5F6C696E65537461727473';
wwv_flow_imp.g_varchar2_table(18846) := '3D6E756C6C2C746869732E5F6361636865645465787456616C75653D6E756C6C7D646973706F736528297B746869732E5F6C696E65732E6C656E6774683D307D6765742076657273696F6E28297B72657475726E20746869732E5F76657273696F6E4964';
wwv_flow_imp.g_varchar2_table(18847) := '7D6765745465787428297B72657475726E206E756C6C3D3D3D746869732E5F6361636865645465787456616C7565262628746869732E5F6361636865645465787456616C75653D746869732E5F6C696E65732E6A6F696E28746869732E5F656F6C29292C';
wwv_flow_imp.g_varchar2_table(18848) := '746869732E5F6361636865645465787456616C75657D6F6E4576656E74732865297B652E656F6C2626652E656F6C213D3D746869732E5F656F6C262628746869732E5F656F6C3D652E656F6C2C746869732E5F6C696E655374617274733D6E756C6C293B';
wwv_flow_imp.g_varchar2_table(18849) := '636F6E737420743D652E6368616E6765733B666F7228636F6E73742065206F66207429746869732E5F61636365707444656C65746552616E676528652E72616E6765292C746869732E5F616363657074496E7365727454657874286E6577206D6328652E';
wwv_flow_imp.g_varchar2_table(18850) := '72616E67652E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E292C652E74657874293B746869732E5F76657273696F6E49643D652E76657273696F6E49642C746869732E5F6361636865645465787456616C7565';
wwv_flow_imp.g_varchar2_table(18851) := '3D6E756C6C7D5F656E737572654C696E6553746172747328297B69662821746869732E5F6C696E65537461727473297B636F6E737420653D746869732E5F656F6C2E6C656E6774682C743D746869732E5F6C696E65732E6C656E6774682C6E3D6E657720';
wwv_flow_imp.g_varchar2_table(18852) := '55696E74333241727261792874293B666F72286C657420693D303B693C743B692B2B296E5B695D3D746869732E5F6C696E65735B695D2E6C656E6774682B653B746869732E5F6C696E655374617274733D6E6577206142286E297D7D5F7365744C696E65';
wwv_flow_imp.g_varchar2_table(18853) := '5465787428652C74297B746869732E5F6C696E65735B655D3D742C746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E73657456616C756528652C746869732E5F6C696E65735B655D2E6C656E6774682B746869732E';
wwv_flow_imp.g_varchar2_table(18854) := '5F656F6C2E6C656E677468297D5F61636365707444656C65746552616E67652865297B696628652E73746172744C696E654E756D626572213D3D652E656E644C696E654E756D62657229746869732E5F7365744C696E655465787428652E73746172744C';
wwv_flow_imp.g_varchar2_table(18855) := '696E654E756D6265722D312C746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(18856) := '722D315D2E737562737472696E6728652E656E64436F6C756D6E2D3129292C746869732E5F6C696E65732E73706C69636528652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(18857) := '72292C746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E72656D6F766556616C75657328652E73746172744C696E654E756D6265722C652E656E644C696E654E756D6265722D652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(18858) := '6572293B656C73657B696628652E7374617274436F6C756D6E3D3D3D652E656E64436F6C756D6E2972657475726E3B746869732E5F7365744C696E655465787428652E73746172744C696E654E756D6265722D312C746869732E5F6C696E65735B652E73';
wwv_flow_imp.g_varchar2_table(18859) := '746172744C696E654E756D6265722D315D2E737562737472696E6728302C652E7374617274436F6C756D6E2D31292B746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E737562737472696E6728652E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(18860) := '6E2D3129297D7D5F616363657074496E736572745465787428652C74297B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D67692874293B696628313D3D3D6E2E6C656E6774682972657475726E20766F696420746869732E';
wwv_flow_imp.g_varchar2_table(18861) := '5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B305D2B746869732E5F6C696E65735B652E6C';
wwv_flow_imp.g_varchar2_table(18862) := '696E654E756D6265722D315D2E737562737472696E6728652E636F6C756D6E2D3129293B6E5B6E2E6C656E6774682D315D2B3D746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728652E636F6C756D6E2D3129';
wwv_flow_imp.g_varchar2_table(18863) := '2C746869732E5F7365744C696E655465787428652E6C696E654E756D6265722D312C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2E737562737472696E6728302C652E636F6C756D6E2D31292B6E5B305D293B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(18864) := '6E65772055696E7433324172726179286E2E6C656E6774682D31293B666F72286C657420743D313B743C6E2E6C656E6774683B742B2B29746869732E5F6C696E65732E73706C69636528652E6C696E654E756D6265722B742D312C302C6E5B745D292C69';
wwv_flow_imp.g_varchar2_table(18865) := '5B742D315D3D6E5B745D2E6C656E6774682B746869732E5F656F6C2E6C656E6774683B746869732E5F6C696E655374617274732626746869732E5F6C696E655374617274732E696E7365727456616C75657328652E6C696E654E756D6265722C69297D7D';
wwv_flow_imp.g_varchar2_table(18866) := '636C6173732056567B636F6E7374727563746F7228652C742C6E297B636F6E737420693D6E65772055696E7438417272617928652A74293B666F72286C6574206F3D302C733D652A743B6F3C733B6F2B2B29695B6F5D3D6E3B746869732E5F646174613D';
wwv_flow_imp.g_varchar2_table(18867) := '692C746869732E726F77733D652C746869732E636F6C733D747D67657428652C74297B72657475726E20746869732E5F646174615B652A746869732E636F6C732B745D7D73657428652C742C6E297B746869732E5F646174615B652A746869732E636F6C';
wwv_flow_imp.g_varchar2_table(18868) := '732B745D3D6E7D7D636C617373207A567B636F6E7374727563746F722865297B6C657420743D302C6E3D303B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E73745B6F2C732C725D3D655B695D3B733E74262628';
wwv_flow_imp.g_varchar2_table(18869) := '743D73292C6F3E6E2626286E3D6F292C723E6E2626286E3D72297D742B2B2C6E2B2B3B636F6E737420693D6E6577205656286E2C742C30293B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B297B636F6E73745B6E2C6F2C73';
wwv_flow_imp.g_varchar2_table(18870) := '5D3D655B745D3B692E736574286E2C6F2C73297D746869732E5F7374617465733D692C746869732E5F6D617843686172436F64653D747D6E657874537461746528652C74297B72657475726E20743C307C7C743E3D746869732E5F6D617843686172436F';
wwv_flow_imp.g_varchar2_table(18871) := '64653F303A746869732E5F7374617465732E67657428652C74297D7D6C65742048563D6E756C6C2C57563D6E756C6C3B636C617373206A567B737461746963205F6372656174654C696E6B28652C742C6E2C692C6F297B6C657420733D6F2D313B646F7B';
wwv_flow_imp.g_varchar2_table(18872) := '636F6E7374206E3D742E63686172436F646541742873293B69662832213D3D652E676574286E2929627265616B3B732D2D7D7768696C6528733E69293B696628693E30297B636F6E737420653D742E63686172436F6465417428692D31292C6E3D742E63';
wwv_flow_imp.g_varchar2_table(18873) := '686172436F646541742873293B2834303D3D3D65262634313D3D3D6E7C7C39313D3D3D65262639333D3D3D6E7C7C3132333D3D3D6526263132353D3D3D6E292626732D2D7D72657475726E7B72616E67653A7B73746172744C696E654E756D6265723A6E';
wwv_flow_imp.g_varchar2_table(18874) := '2C7374617274436F6C756D6E3A692B312C656E644C696E654E756D6265723A6E2C656E64436F6C756D6E3A732B327D2C75726C3A742E737562737472696E6728692C732B31297D7D73746174696320636F6D707574654C696E6B7328652C743D66756E63';
wwv_flow_imp.g_varchar2_table(18875) := '74696F6E28297B72657475726E206E756C6C3D3D3D485626262848563D6E6577207A56285B5B312C3130342C325D2C5B312C37322C325D2C5B312C3130322C365D2C5B312C37302C365D2C5B322C3131362C335D2C5B322C38342C335D2C5B332C313136';
wwv_flow_imp.g_varchar2_table(18876) := '2C345D2C5B332C38342C345D2C5B342C3131322C355D2C5B342C38302C355D2C5B352C3131352C395D2C5B352C38332C395D2C5B352C35382C31305D2C5B362C3130352C375D2C5B362C37332C375D2C5B372C3130382C385D2C5B372C37362C385D2C5B';
wwv_flow_imp.g_varchar2_table(18877) := '382C3130312C395D2C5B382C36392C395D2C5B392C35382C31305D2C5B31302C34372C31315D2C5B31312C34372C31325D5D29292C48567D2829297B636F6E7374206E3D66756E6374696F6E28297B6966286E756C6C3D3D3D5756297B57563D6E657720';
wwv_flow_imp.g_varchar2_table(18878) := '55792830293B636F6E737420653D22205C743C3E275C22E38081E38082EFBDA1EFBDA4EFBC8CEFBC8EEFBC9AEFBC9BE28098E38088E3808CE3808EE38094EFBC88EFBCBBEFBD9BEFBDA2EFBDA3EFBD9DEFBCBDEFBC89E38095E3808FE3808DE38089E280';
wwv_flow_imp.g_varchar2_table(18879) := '99EFBD80EFBD9EE280A6223B666F72286C657420743D303B743C652E6C656E6774683B742B2B2957562E73657428652E63686172436F646541742874292C31293B636F6E737420743D222E2C3B3A223B666F72286C657420653D303B653C742E6C656E67';
wwv_flow_imp.g_varchar2_table(18880) := '74683B652B2B2957562E73657428742E63686172436F646541742865292C32297D72657475726E2057567D28292C693D5B5D3B666F72286C6574206F3D312C733D652E6765744C696E65436F756E7428293B6F3C3D733B6F2B2B297B636F6E737420733D';
wwv_flow_imp.g_varchar2_table(18881) := '652E6765744C696E65436F6E74656E74286F292C723D732E6C656E6774683B6C657420613D302C6C3D302C633D302C643D312C683D21312C753D21312C703D21312C673D21313B666F72283B613C723B297B6C657420653D21313B636F6E737420723D73';
wwv_flow_imp.g_varchar2_table(18882) := '2E63686172436F646541742861293B69662831333D3D3D64297B6C657420743B7377697463682872297B636173652034303A683D21302C743D303B627265616B3B636173652034313A743D683F303A313B627265616B3B636173652039313A703D21302C';
wwv_flow_imp.g_varchar2_table(18883) := '753D21302C743D303B627265616B3B636173652039333A703D21312C743D753F303A313B627265616B3B63617365203132333A673D21302C743D303B627265616B3B63617365203132353A743D673F303A313B627265616B3B636173652033393A636173';
wwv_flow_imp.g_varchar2_table(18884) := '652033343A636173652039363A743D633D3D3D723F313A33393D3D3D637C7C33343D3D3D637C7C39363D3D3D633F303A313B627265616B3B636173652034323A743D34323D3D3D633F313A303B627265616B3B63617365203132343A743D3132343D3D3D';
wwv_flow_imp.g_varchar2_table(18885) := '633F313A303B627265616B3B636173652033323A743D703F303A313B627265616B3B64656661756C743A743D6E2E6765742872297D313D3D3D74262628692E70757368286A562E5F6372656174654C696E6B286E2C732C6F2C6C2C6129292C653D213029';
wwv_flow_imp.g_varchar2_table(18886) := '7D656C73652069662831323D3D3D64297B6C657420743B39313D3D3D723F28753D21302C743D30293A743D6E2E6765742872292C313D3D3D743F653D21303A643D31337D656C736520643D742E6E657874537461746528642C72292C303D3D3D64262628';
wwv_flow_imp.g_varchar2_table(18887) := '653D2130293B65262628643D312C683D21312C753D21312C673D21312C6C3D612B312C633D72292C612B2B7D31333D3D3D642626692E70757368286A562E5F6372656174654C696E6B286E2C732C6F2C6C2C7229297D72657475726E20697D7D636C6173';
wwv_flow_imp.g_varchar2_table(18888) := '732071567B636F6E7374727563746F7228297B746869732E5F64656661756C7456616C75655365743D5B5B2274727565222C2266616C7365225D2C5B2254727565222C2246616C7365225D2C5B2250726976617465222C225075626C6963222C22467269';
wwv_flow_imp.g_varchar2_table(18889) := '656E64222C22526561644F6E6C79222C225061727469616C222C2250726F746563746564222C2257726974654F6E6C79225D2C5B227075626C6963222C2270726F746563746564222C2270726976617465225D5D7D6E6176696761746556616C75655365';
wwv_flow_imp.g_varchar2_table(18890) := '7428652C742C6E2C692C6F297B69662865262674297B636F6E7374206E3D746869732E646F4E6176696761746556616C756553657428742C6F293B6966286E2972657475726E7B72616E67653A652C76616C75653A6E7D7D6966286E262669297B636F6E';
wwv_flow_imp.g_varchar2_table(18891) := '737420653D746869732E646F4E6176696761746556616C756553657428692C6F293B696628652972657475726E7B72616E67653A6E2C76616C75653A657D7D72657475726E206E756C6C7D646F4E6176696761746556616C756553657428652C74297B63';
wwv_flow_imp.g_varchar2_table(18892) := '6F6E7374206E3D746869732E6E756D6265725265706C61636528652C74293B72657475726E206E756C6C213D3D6E3F6E3A746869732E746578745265706C61636528652C74297D6E756D6265725265706C61636528652C74297B636F6E7374206E3D4D61';
wwv_flow_imp.g_varchar2_table(18893) := '74682E706F772831302C652E6C656E6774682D28652E6C617374496E6465784F6628222E22292B3129293B6C657420693D4E756D6265722865293B636F6E7374206F3D7061727365466C6F61742865293B72657475726E2069734E614E2869297C7C6973';
wwv_flow_imp.g_varchar2_table(18894) := '4E614E286F297C7C69213D3D6F3F6E756C6C3A30213D3D697C7C743F28693D4D6174682E666C6F6F7228692A6E292C692B3D743F6E3A2D6E2C537472696E6728692F6E29293A6E756C6C7D746578745265706C61636528652C74297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(18895) := '6869732E76616C7565536574735265706C61636528746869732E5F64656661756C7456616C75655365742C652C74297D76616C7565536574735265706C61636528652C742C6E297B6C657420693D6E756C6C3B666F72286C6574206F3D302C733D652E6C';
wwv_flow_imp.g_varchar2_table(18896) := '656E6774683B6E756C6C3D3D3D6926266F3C733B6F2B2B29693D746869732E76616C75655365745265706C61636528655B6F5D2C742C6E293B72657475726E20697D76616C75655365745265706C61636528652C742C6E297B6C657420693D652E696E64';
wwv_flow_imp.g_varchar2_table(18897) := '65784F662874293B72657475726E20693E3D303F28692B3D6E3F313A2D312C693C303F693D652E6C656E6774682D313A69253D652E6C656E6774682C655B695D293A6E756C6C7D7D7661722024562C55562C4B562C47562C51562C59562C5A562C58562C';
wwv_flow_imp.g_varchar2_table(18898) := '4A562C657A2C747A2C6E7A2C697A2C6F7A2C737A2C727A2C617A2C6C7A2C637A2C647A2C687A2C757A2C707A2C677A2C6D7A2C667A2C767A2C627A2C5F7A2C797A2C777A2C437A2C537A2C787A2C6B7A2C457A2C4C7A2C447A2C547A2C497A2C4D7A2C41';
wwv_flow_imp.g_varchar2_table(18899) := '7A2C4E7A2C507A2C4F7A2C527A3B71562E494E5354414E43453D6E65772071562C66756E6374696F6E2865297B655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C655B652E44697361626C65643D315D3D2244697361626C6564222C655B65';
wwv_flow_imp.g_varchar2_table(18900) := '2E456E61626C65643D325D3D22456E61626C6564227D2824567C7C2824563D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D315D3D22496E766F6B65222C655B652E4175746F3D325D3D224175746F227D2855567C7C2855563D7B';
wwv_flow_imp.g_varchar2_table(18901) := '7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E4B656570576869746573706163653D315D3D224B65657057686974657370616365222C655B652E496E736572744173536E69707065743D345D3D22496E';
wwv_flow_imp.g_varchar2_table(18902) := '736572744173536E6970706574227D284B567C7C284B563D7B7D29292C66756E6374696F6E2865297B655B652E4D6574686F643D305D3D224D6574686F64222C655B652E46756E6374696F6E3D315D3D2246756E6374696F6E222C655B652E436F6E7374';
wwv_flow_imp.g_varchar2_table(18903) := '727563746F723D325D3D22436F6E7374727563746F72222C655B652E4669656C643D335D3D224669656C64222C655B652E5661726961626C653D345D3D225661726961626C65222C655B652E436C6173733D355D3D22436C617373222C655B652E537472';
wwv_flow_imp.g_varchar2_table(18904) := '7563743D365D3D22537472756374222C655B652E496E746572666163653D375D3D22496E74657266616365222C655B652E4D6F64756C653D385D3D224D6F64756C65222C655B652E50726F70657274793D395D3D2250726F7065727479222C655B652E45';
wwv_flow_imp.g_varchar2_table(18905) := '76656E743D31305D3D224576656E74222C655B652E4F70657261746F723D31315D3D224F70657261746F72222C655B652E556E69743D31325D3D22556E6974222C655B652E56616C75653D31335D3D2256616C7565222C655B652E436F6E7374616E743D';
wwv_flow_imp.g_varchar2_table(18906) := '31345D3D22436F6E7374616E74222C655B652E456E756D3D31355D3D22456E756D222C655B652E456E756D4D656D6265723D31365D3D22456E756D4D656D626572222C655B652E4B6579776F72643D31375D3D224B6579776F7264222C655B652E546578';
wwv_flow_imp.g_varchar2_table(18907) := '743D31385D3D2254657874222C655B652E436F6C6F723D31395D3D22436F6C6F72222C655B652E46696C653D32305D3D2246696C65222C655B652E5265666572656E63653D32315D3D225265666572656E6365222C655B652E437573746F6D636F6C6F72';
wwv_flow_imp.g_varchar2_table(18908) := '3D32325D3D22437573746F6D636F6C6F72222C655B652E466F6C6465723D32335D3D22466F6C646572222C655B652E54797065506172616D657465723D32345D3D2254797065506172616D65746572222C655B652E557365723D32355D3D225573657222';
wwv_flow_imp.g_varchar2_table(18909) := '2C655B652E49737375653D32365D3D224973737565222C655B652E536E69707065743D32375D3D22536E6970706574227D2847567C7C2847563D7B7D29292C66756E6374696F6E2865297B655B652E446570726563617465643D315D3D22446570726563';
wwv_flow_imp.g_varchar2_table(18910) := '61746564227D2851567C7C2851563D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E547269676765724368617261637465723D315D3D2254726967676572436861726163746572222C655B';
wwv_flow_imp.g_varchar2_table(18911) := '652E54726967676572466F72496E636F6D706C657465436F6D706C6574696F6E733D325D3D2254726967676572466F72496E636F6D706C657465436F6D706C6574696F6E73227D2859567C7C2859563D7B7D29292C66756E6374696F6E2865297B655B65';
wwv_flow_imp.g_varchar2_table(18912) := '2E45584143543D305D3D224558414354222C655B652E41424F56453D315D3D2241424F5645222C655B652E42454C4F573D325D3D2242454C4F57227D285A567C7C285A563D7B7D29292C66756E6374696F6E2865297B655B652E4E6F745365743D305D3D';
wwv_flow_imp.g_varchar2_table(18913) := '224E6F74536574222C655B652E436F6E74656E74466C7573683D315D3D22436F6E74656E74466C757368222C655B652E5265636F76657246726F6D4D61726B6572733D325D3D225265636F76657246726F6D4D61726B657273222C655B652E4578706C69';
wwv_flow_imp.g_varchar2_table(18914) := '6369743D335D3D224578706C69636974222C655B652E50617374653D345D3D225061737465222C655B652E556E646F3D355D3D22556E646F222C655B652E5265646F3D365D3D225265646F227D2858567C7C2858563D7B7D29292C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(18915) := '65297B655B652E4C463D315D3D224C46222C655B652E43524C463D325D3D2243524C46227D284A567C7C284A563D7B7D29292C66756E6374696F6E2865297B655B652E546578743D305D3D2254657874222C655B652E526561643D315D3D225265616422';
wwv_flow_imp.g_varchar2_table(18916) := '2C655B652E57726974653D325D3D225772697465227D28657A7C7C28657A3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E4B6565703D315D3D224B656570222C655B652E427261636B6574733D32';
wwv_flow_imp.g_varchar2_table(18917) := '5D3D22427261636B657473222C655B652E416476616E6365643D335D3D22416476616E636564222C655B652E46756C6C3D345D3D2246756C6C227D28747A7C7C28747A3D7B7D29292C66756E6374696F6E2865297B655B652E6163636570745375676765';
wwv_flow_imp.g_varchar2_table(18918) := '7374696F6E4F6E436F6D6D69744368617261637465723D305D3D2261636365707453756767657374696F6E4F6E436F6D6D6974436861726163746572222C655B652E61636365707453756767657374696F6E4F6E456E7465723D315D3D22616363657074';
wwv_flow_imp.g_varchar2_table(18919) := '53756767657374696F6E4F6E456E746572222C655B652E6163636573736962696C697479537570706F72743D325D3D226163636573736962696C697479537570706F7274222C655B652E6163636573736962696C6974795061676553697A653D335D3D22';
wwv_flow_imp.g_varchar2_table(18920) := '6163636573736962696C6974795061676553697A65222C655B652E617269614C6162656C3D345D3D22617269614C6162656C222C655B652E6172696152657175697265643D355D3D22617269615265717569726564222C655B652E6175746F436C6F7369';
wwv_flow_imp.g_varchar2_table(18921) := '6E67427261636B6574733D365D3D226175746F436C6F73696E67427261636B657473222C655B652E6175746F436C6F73696E67436F6D6D656E74733D375D3D226175746F436C6F73696E67436F6D6D656E7473222C655B652E73637265656E5265616465';
wwv_flow_imp.g_varchar2_table(18922) := '72416E6E6F756E6365496E6C696E6553756767657374696F6E3D385D3D2273637265656E526561646572416E6E6F756E6365496E6C696E6553756767657374696F6E222C655B652E6175746F436C6F73696E6744656C6574653D395D3D226175746F436C';
wwv_flow_imp.g_varchar2_table(18923) := '6F73696E6744656C657465222C655B652E6175746F436C6F73696E674F766572747970653D31305D3D226175746F436C6F73696E674F76657274797065222C655B652E6175746F436C6F73696E6751756F7465733D31315D3D226175746F436C6F73696E';
wwv_flow_imp.g_varchar2_table(18924) := '6751756F746573222C655B652E6175746F496E64656E743D31325D3D226175746F496E64656E74222C655B652E6175746F6D617469634C61796F75743D31335D3D226175746F6D617469634C61796F7574222C655B652E6175746F537572726F756E643D';
wwv_flow_imp.g_varchar2_table(18925) := '31345D3D226175746F537572726F756E64222C655B652E627261636B657450616972436F6C6F72697A6174696F6E3D31355D3D22627261636B657450616972436F6C6F72697A6174696F6E222C655B652E6775696465733D31365D3D2267756964657322';
wwv_flow_imp.g_varchar2_table(18926) := '2C655B652E636F64654C656E733D31375D3D22636F64654C656E73222C655B652E636F64654C656E73466F6E7446616D696C793D31385D3D22636F64654C656E73466F6E7446616D696C79222C655B652E636F64654C656E73466F6E7453697A653D3139';
wwv_flow_imp.g_varchar2_table(18927) := '5D3D22636F64654C656E73466F6E7453697A65222C655B652E636F6C6F724465636F7261746F72733D32305D3D22636F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734C696D69743D32315D3D22636F6C6F724465';
wwv_flow_imp.g_varchar2_table(18928) := '636F7261746F72734C696D6974222C655B652E636F6C756D6E53656C656374696F6E3D32325D3D22636F6C756D6E53656C656374696F6E222C655B652E636F6D6D656E74733D32335D3D22636F6D6D656E7473222C655B652E636F6E746578746D656E75';
wwv_flow_imp.g_varchar2_table(18929) := '3D32345D3D22636F6E746578746D656E75222C655B652E636F70795769746853796E746178486967686C69676874696E673D32355D3D22636F70795769746853796E746178486967686C69676874696E67222C655B652E637572736F72426C696E6B696E';
wwv_flow_imp.g_varchar2_table(18930) := '673D32365D3D22637572736F72426C696E6B696E67222C655B652E637572736F72536D6F6F74684361726574416E696D6174696F6E3D32375D3D22637572736F72536D6F6F74684361726574416E696D6174696F6E222C655B652E637572736F72537479';
wwv_flow_imp.g_varchar2_table(18931) := '6C653D32385D3D22637572736F725374796C65222C655B652E637572736F72537572726F756E64696E674C696E65733D32395D3D22637572736F72537572726F756E64696E674C696E6573222C655B652E637572736F72537572726F756E64696E674C69';
wwv_flow_imp.g_varchar2_table(18932) := '6E65735374796C653D33305D3D22637572736F72537572726F756E64696E674C696E65735374796C65222C655B652E637572736F7257696474683D33315D3D22637572736F725769647468222C655B652E64697361626C654C6179657248696E74696E67';
wwv_flow_imp.g_varchar2_table(18933) := '3D33325D3D2264697361626C654C6179657248696E74696E67222C655B652E64697361626C654D6F6E6F73706163654F7074696D697A6174696F6E733D33335D3D2264697361626C654D6F6E6F73706163654F7074696D697A6174696F6E73222C655B65';
wwv_flow_imp.g_varchar2_table(18934) := '2E646F6D526561644F6E6C793D33345D3D22646F6D526561644F6E6C79222C655B652E64726167416E6444726F703D33355D3D2264726167416E6444726F70222C655B652E64726F70496E746F456469746F723D33365D3D2264726F70496E746F456469';
wwv_flow_imp.g_varchar2_table(18935) := '746F72222C655B652E656D70747953656C656374696F6E436C6970626F6172643D33375D3D22656D70747953656C656374696F6E436C6970626F617264222C655B652E6578706572696D656E74616C5768697465737061636552656E646572696E673D33';
wwv_flow_imp.g_varchar2_table(18936) := '385D3D226578706572696D656E74616C5768697465737061636552656E646572696E67222C655B652E6578747261456469746F72436C6173734E616D653D33395D3D226578747261456469746F72436C6173734E616D65222C655B652E66617374536372';
wwv_flow_imp.g_varchar2_table(18937) := '6F6C6C53656E73697469766974793D34305D3D22666173745363726F6C6C53656E7369746976697479222C655B652E66696E643D34315D3D2266696E64222C655B652E66697865644F766572666C6F77576964676574733D34325D3D2266697865644F76';
wwv_flow_imp.g_varchar2_table(18938) := '6572666C6F7757696467657473222C655B652E666F6C64696E673D34335D3D22666F6C64696E67222C655B652E666F6C64696E6753747261746567793D34345D3D22666F6C64696E675374726174656779222C655B652E666F6C64696E67486967686C69';
wwv_flow_imp.g_varchar2_table(18939) := '6768743D34355D3D22666F6C64696E67486967686C69676874222C655B652E666F6C64696E67496D706F727473427944656661756C743D34365D3D22666F6C64696E67496D706F727473427944656661756C74222C655B652E666F6C64696E674D617869';
wwv_flow_imp.g_varchar2_table(18940) := '6D756D526567696F6E733D34375D3D22666F6C64696E674D6178696D756D526567696F6E73222C655B652E756E666F6C644F6E436C69636B4166746572456E644F664C696E653D34385D3D22756E666F6C644F6E436C69636B4166746572456E644F664C';
wwv_flow_imp.g_varchar2_table(18941) := '696E65222C655B652E666F6E7446616D696C793D34395D3D22666F6E7446616D696C79222C655B652E666F6E74496E666F3D35305D3D22666F6E74496E666F222C655B652E666F6E744C69676174757265733D35315D3D22666F6E744C69676174757265';
wwv_flow_imp.g_varchar2_table(18942) := '73222C655B652E666F6E7453697A653D35325D3D22666F6E7453697A65222C655B652E666F6E745765696768743D35335D3D22666F6E74576569676874222C655B652E666F6E74566172696174696F6E733D35345D3D22666F6E74566172696174696F6E';
wwv_flow_imp.g_varchar2_table(18943) := '73222C655B652E666F726D61744F6E50617374653D35355D3D22666F726D61744F6E5061737465222C655B652E666F726D61744F6E547970653D35365D3D22666F726D61744F6E54797065222C655B652E676C7970684D617267696E3D35375D3D22676C';
wwv_flow_imp.g_varchar2_table(18944) := '7970684D617267696E222C655B652E676F746F4C6F636174696F6E3D35385D3D22676F746F4C6F636174696F6E222C655B652E68696465437572736F72496E4F7665727669657752756C65723D35395D3D2268696465437572736F72496E4F7665727669';
wwv_flow_imp.g_varchar2_table(18945) := '657752756C6572222C655B652E686F7665723D36305D3D22686F766572222C655B652E696E44696666456469746F723D36315D3D22696E44696666456469746F72222C655B652E696E6C696E65537567676573743D36325D3D22696E6C696E6553756767';
wwv_flow_imp.g_varchar2_table(18946) := '657374222C655B652E696E6C696E65456469743D36335D3D22696E6C696E6545646974222C655B652E6C657474657253706163696E673D36345D3D226C657474657253706163696E67222C655B652E6C6967687462756C623D36355D3D226C6967687462';
wwv_flow_imp.g_varchar2_table(18947) := '756C62222C655B652E6C696E654465636F726174696F6E7357696474683D36365D3D226C696E654465636F726174696F6E735769647468222C655B652E6C696E654865696768743D36375D3D226C696E65486569676874222C655B652E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(18948) := '626572733D36385D3D226C696E654E756D62657273222C655B652E6C696E654E756D626572734D696E43686172733D36395D3D226C696E654E756D626572734D696E4368617273222C655B652E6C696E6B656445646974696E673D37305D3D226C696E6B';
wwv_flow_imp.g_varchar2_table(18949) := '656445646974696E67222C655B652E6C696E6B733D37315D3D226C696E6B73222C655B652E6D61746368427261636B6574733D37325D3D226D61746368427261636B657473222C655B652E6D696E696D61703D37335D3D226D696E696D6170222C655B65';
wwv_flow_imp.g_varchar2_table(18950) := '2E6D6F7573655374796C653D37345D3D226D6F7573655374796C65222C655B652E6D6F757365576865656C5363726F6C6C53656E73697469766974793D37355D3D226D6F757365576865656C5363726F6C6C53656E7369746976697479222C655B652E6D';
wwv_flow_imp.g_varchar2_table(18951) := '6F757365576865656C5A6F6F6D3D37365D3D226D6F757365576865656C5A6F6F6D222C655B652E6D756C7469437572736F724D657267654F7665726C617070696E673D37375D3D226D756C7469437572736F724D657267654F7665726C617070696E6722';
wwv_flow_imp.g_varchar2_table(18952) := '2C655B652E6D756C7469437572736F724D6F6469666965723D37385D3D226D756C7469437572736F724D6F646966696572222C655B652E6D756C7469437572736F7250617374653D37395D3D226D756C7469437572736F725061737465222C655B652E6D';
wwv_flow_imp.g_varchar2_table(18953) := '756C7469437572736F724C696D69743D38305D3D226D756C7469437572736F724C696D6974222C655B652E6F6363757272656E636573486967686C696768743D38315D3D226F6363757272656E636573486967686C69676874222C655B652E6F76657276';
wwv_flow_imp.g_varchar2_table(18954) := '69657752756C6572426F726465723D38325D3D226F7665727669657752756C6572426F72646572222C655B652E6F7665727669657752756C65724C616E65733D38335D3D226F7665727669657752756C65724C616E6573222C655B652E70616464696E67';
wwv_flow_imp.g_varchar2_table(18955) := '3D38345D3D2270616464696E67222C655B652E706173746541733D38355D3D2270617374654173222C655B652E706172616D6574657248696E74733D38365D3D22706172616D6574657248696E7473222C655B652E7065656B5769646765744465666175';
wwv_flow_imp.g_varchar2_table(18956) := '6C74466F6375733D38375D3D227065656B57696467657444656661756C74466F637573222C655B652E646566696E6974696F6E4C696E6B4F70656E73496E5065656B3D38385D3D22646566696E6974696F6E4C696E6B4F70656E73496E5065656B222C65';
wwv_flow_imp.g_varchar2_table(18957) := '5B652E717569636B53756767657374696F6E733D38395D3D22717569636B53756767657374696F6E73222C655B652E717569636B53756767657374696F6E7344656C61793D39305D3D22717569636B53756767657374696F6E7344656C6179222C655B65';
wwv_flow_imp.g_varchar2_table(18958) := '2E726561644F6E6C793D39315D3D22726561644F6E6C79222C655B652E726561644F6E6C794D6573736167653D39325D3D22726561644F6E6C794D657373616765222C655B652E72656E616D654F6E547970653D39335D3D2272656E616D654F6E547970';
wwv_flow_imp.g_varchar2_table(18959) := '65222C655B652E72656E646572436F6E74726F6C436861726163746572733D39345D3D2272656E646572436F6E74726F6C43686172616374657273222C655B652E72656E64657246696E616C4E65776C696E653D39355D3D2272656E64657246696E616C';
wwv_flow_imp.g_varchar2_table(18960) := '4E65776C696E65222C655B652E72656E6465724C696E65486967686C696768743D39365D3D2272656E6465724C696E65486967686C69676874222C655B652E72656E6465724C696E65486967686C696768744F6E6C795768656E466F6375733D39375D3D';
wwv_flow_imp.g_varchar2_table(18961) := '2272656E6465724C696E65486967686C696768744F6E6C795768656E466F637573222C655B652E72656E64657256616C69646174696F6E4465636F726174696F6E733D39385D3D2272656E64657256616C69646174696F6E4465636F726174696F6E7322';
wwv_flow_imp.g_varchar2_table(18962) := '2C655B652E72656E646572576869746573706163653D39395D3D2272656E64657257686974657370616365222C655B652E72657665616C486F72697A6F6E74616C526967687450616464696E673D3130305D3D2272657665616C486F72697A6F6E74616C';
wwv_flow_imp.g_varchar2_table(18963) := '526967687450616464696E67222C655B652E726F756E64656453656C656374696F6E3D3130315D3D22726F756E64656453656C656374696F6E222C655B652E72756C6572733D3130325D3D2272756C657273222C655B652E7363726F6C6C6261723D3130';
wwv_flow_imp.g_varchar2_table(18964) := '335D3D227363726F6C6C626172222C655B652E7363726F6C6C4265796F6E644C617374436F6C756D6E3D3130345D3D227363726F6C6C4265796F6E644C617374436F6C756D6E222C655B652E7363726F6C6C4265796F6E644C6173744C696E653D313035';
wwv_flow_imp.g_varchar2_table(18965) := '5D3D227363726F6C6C4265796F6E644C6173744C696E65222C655B652E7363726F6C6C507265646F6D696E616E74417869733D3130365D3D227363726F6C6C507265646F6D696E616E7441786973222C655B652E73656C656374696F6E436C6970626F61';
wwv_flow_imp.g_varchar2_table(18966) := '72643D3130375D3D2273656C656374696F6E436C6970626F617264222C655B652E73656C656374696F6E486967686C696768743D3130385D3D2273656C656374696F6E486967686C69676874222C655B652E73656C6563744F6E4C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(18967) := '733D3130395D3D2273656C6563744F6E4C696E654E756D62657273222C655B652E73686F77466F6C64696E67436F6E74726F6C733D3131305D3D2273686F77466F6C64696E67436F6E74726F6C73222C655B652E73686F77556E757365643D3131315D3D';
wwv_flow_imp.g_varchar2_table(18968) := '2273686F77556E75736564222C655B652E736E697070657453756767657374696F6E733D3131325D3D22736E697070657453756767657374696F6E73222C655B652E736D61727453656C6563743D3131335D3D22736D61727453656C656374222C655B65';
wwv_flow_imp.g_varchar2_table(18969) := '2E736D6F6F74685363726F6C6C696E673D3131345D3D22736D6F6F74685363726F6C6C696E67222C655B652E737469636B795363726F6C6C3D3131355D3D22737469636B795363726F6C6C222C655B652E737469636B7954616253746F70733D3131365D';
wwv_flow_imp.g_varchar2_table(18970) := '3D22737469636B7954616253746F7073222C655B652E73746F7052656E646572696E674C696E6541667465723D3131375D3D2273746F7052656E646572696E674C696E654166746572222C655B652E737567676573743D3131385D3D2273756767657374';
wwv_flow_imp.g_varchar2_table(18971) := '222C655B652E73756767657374466F6E7453697A653D3131395D3D2273756767657374466F6E7453697A65222C655B652E737567676573744C696E654865696768743D3132305D3D22737567676573744C696E65486569676874222C655B652E73756767';
wwv_flow_imp.g_varchar2_table(18972) := '6573744F6E54726967676572436861726163746572733D3132315D3D22737567676573744F6E5472696767657243686172616374657273222C655B652E7375676765737453656C656374696F6E3D3132325D3D227375676765737453656C656374696F6E';
wwv_flow_imp.g_varchar2_table(18973) := '222C655B652E746162436F6D706C6574696F6E3D3132335D3D22746162436F6D706C6574696F6E222C655B652E746162496E6465783D3132345D3D22746162496E646578222C655B652E756E69636F6465486967686C69676874696E673D3132355D3D22';
wwv_flow_imp.g_varchar2_table(18974) := '756E69636F6465486967686C69676874696E67222C655B652E756E757375616C4C696E655465726D696E61746F72733D3132365D3D22756E757375616C4C696E655465726D696E61746F7273222C655B652E757365536861646F77444F4D3D3132375D3D';
wwv_flow_imp.g_varchar2_table(18975) := '22757365536861646F77444F4D222C655B652E75736554616253746F70733D3132385D3D2275736554616253746F7073222C655B652E776F7264427265616B3D3132395D3D22776F7264427265616B222C655B652E776F72645365676D656E7465724C6F';
wwv_flow_imp.g_varchar2_table(18976) := '63616C65733D3133305D3D22776F72645365676D656E7465724C6F63616C6573222C655B652E776F7264536570617261746F72733D3133315D3D22776F7264536570617261746F7273222C655B652E776F7264577261703D3133325D3D22776F72645772';
wwv_flow_imp.g_varchar2_table(18977) := '6170222C655B652E776F726457726170427265616B4166746572436861726163746572733D3133335D3D22776F726457726170427265616B416674657243686172616374657273222C655B652E776F726457726170427265616B4265666F726543686172';
wwv_flow_imp.g_varchar2_table(18978) := '6163746572733D3133345D3D22776F726457726170427265616B4265666F726543686172616374657273222C655B652E776F726457726170436F6C756D6E3D3133355D3D22776F726457726170436F6C756D6E222C655B652E776F7264577261704F7665';
wwv_flow_imp.g_varchar2_table(18979) := '7272696465313D3133365D3D22776F7264577261704F7665727269646531222C655B652E776F7264577261704F76657272696465323D3133375D3D22776F7264577261704F7665727269646532222C655B652E7772617070696E67496E64656E743D3133';
wwv_flow_imp.g_varchar2_table(18980) := '385D3D227772617070696E67496E64656E74222C655B652E7772617070696E6753747261746567793D3133395D3D227772617070696E675374726174656779222C655B652E73686F77446570726563617465643D3134305D3D2273686F77446570726563';
wwv_flow_imp.g_varchar2_table(18981) := '61746564222C655B652E696E6C617948696E74733D3134315D3D22696E6C617948696E7473222C655B652E656469746F72436C6173734E616D653D3134325D3D22656469746F72436C6173734E616D65222C655B652E706978656C526174696F3D313433';
wwv_flow_imp.g_varchar2_table(18982) := '5D3D22706978656C526174696F222C655B652E746162466F6375734D6F64653D3134345D3D22746162466F6375734D6F6465222C655B652E6C61796F7574496E666F3D3134355D3D226C61796F7574496E666F222C655B652E7772617070696E67496E66';
wwv_flow_imp.g_varchar2_table(18983) := '6F3D3134365D3D227772617070696E67496E666F222C655B652E64656661756C74436F6C6F724465636F7261746F72733D3134375D3D2264656661756C74436F6C6F724465636F7261746F7273222C655B652E636F6C6F724465636F7261746F72734163';
wwv_flow_imp.g_varchar2_table(18984) := '746976617465644F6E3D3134385D3D22636F6C6F724465636F7261746F72734163746976617465644F6E222C655B652E696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F73653D3134395D3D22696E6C696E65436F';
wwv_flow_imp.g_varchar2_table(18985) := '6D706C6574696F6E734163636573736962696C697479566572626F7365227D286E7A7C7C286E7A3D7B7D29292C66756E6374696F6E2865297B655B652E54657874446566696E65643D305D3D2254657874446566696E6564222C655B652E4C463D315D3D';
wwv_flow_imp.g_varchar2_table(18986) := '224C46222C655B652E43524C463D325D3D2243524C46227D28697A7C7C28697A3D7B7D29292C66756E6374696F6E2865297B655B652E4C463D305D3D224C46222C655B652E43524C463D315D3D2243524C46227D286F7A7C7C286F7A3D7B7D29292C6675';
wwv_flow_imp.g_varchar2_table(18987) := '6E6374696F6E2865297B655B652E4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D335D3D225269676874227D28737A7C7C28737A3D7B7D29292C66756E6374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(18988) := '5B652E496E6372656173653D305D3D22496E637265617365222C655B652E44656372656173653D315D3D224465637265617365227D28727A7C7C28727A3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B';
wwv_flow_imp.g_varchar2_table(18989) := '652E496E64656E743D315D3D22496E64656E74222C655B652E496E64656E744F757464656E743D325D3D22496E64656E744F757464656E74222C655B652E4F757464656E743D335D3D224F757464656E74227D28617A7C7C28617A3D7B7D29292C66756E';
wwv_flow_imp.g_varchar2_table(18990) := '6374696F6E2865297B655B652E426F74683D305D3D22426F7468222C655B652E52696768743D315D3D225269676874222C655B652E4C6566743D325D3D224C656674222C655B652E4E6F6E653D335D3D224E6F6E65227D286C7A7C7C286C7A3D7B7D2929';
wwv_flow_imp.g_varchar2_table(18991) := '2C66756E6374696F6E2865297B655B652E547970653D315D3D2254797065222C655B652E506172616D657465723D325D3D22506172616D65746572227D28637A7C7C28637A3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F6D61746963';
wwv_flow_imp.g_varchar2_table(18992) := '3D305D3D224175746F6D61746963222C655B652E4578706C696369743D315D3D224578706C69636974227D28647A7C7C28647A3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F';
wwv_flow_imp.g_varchar2_table(18993) := '6D617469633D315D3D224175746F6D61746963227D28687A7C7C28687A3D7B7D29292C66756E6374696F6E2865297B655B652E446570656E64734F6E4B624C61796F75743D2D315D3D22446570656E64734F6E4B624C61796F7574222C655B652E556E6B';
wwv_flow_imp.g_varchar2_table(18994) := '6E6F776E3D305D3D22556E6B6E6F776E222C655B652E4261636B73706163653D315D3D224261636B7370616365222C655B652E5461623D325D3D22546162222C655B652E456E7465723D335D3D22456E746572222C655B652E53686966743D345D3D2253';
wwv_flow_imp.g_varchar2_table(18995) := '68696674222C655B652E4374726C3D355D3D224374726C222C655B652E416C743D365D3D22416C74222C655B652E5061757365427265616B3D375D3D225061757365427265616B222C655B652E436170734C6F636B3D385D3D22436170734C6F636B222C';
wwv_flow_imp.g_varchar2_table(18996) := '655B652E4573636170653D395D3D22457363617065222C655B652E53706163653D31305D3D225370616365222C655B652E5061676555703D31315D3D22506167655570222C655B652E50616765446F776E3D31325D3D2250616765446F776E222C655B65';
wwv_flow_imp.g_varchar2_table(18997) := '2E456E643D31335D3D22456E64222C655B652E486F6D653D31345D3D22486F6D65222C655B652E4C6566744172726F773D31355D3D224C6566744172726F77222C655B652E55704172726F773D31365D3D2255704172726F77222C655B652E5269676874';
wwv_flow_imp.g_varchar2_table(18998) := '4172726F773D31375D3D2252696768744172726F77222C655B652E446F776E4172726F773D31385D3D22446F776E4172726F77222C655B652E496E736572743D31395D3D22496E73657274222C655B652E44656C6574653D32305D3D2244656C65746522';
wwv_flow_imp.g_varchar2_table(18999) := '2C655B652E4469676974303D32315D3D22446967697430222C655B652E4469676974313D32325D3D22446967697431222C655B652E4469676974323D32335D3D22446967697432222C655B652E4469676974333D32345D3D22446967697433222C655B65';
wwv_flow_imp.g_varchar2_table(19000) := '2E4469676974343D32355D3D22446967697434222C655B652E4469676974353D32365D3D22446967697435222C655B652E4469676974363D32375D3D22446967697436222C655B652E4469676974373D32385D3D22446967697437222C655B652E446967';
wwv_flow_imp.g_varchar2_table(19001) := '6974383D32395D3D22446967697438222C655B652E4469676974393D33305D3D22446967697439222C655B652E4B6579413D33315D3D224B657941222C655B652E4B6579423D33325D3D224B657942222C655B652E4B6579433D33335D3D224B65794322';
wwv_flow_imp.g_varchar2_table(19002) := '2C655B652E4B6579443D33345D3D224B657944222C655B652E4B6579453D33355D3D224B657945222C655B652E4B6579463D33365D3D224B657946222C655B652E4B6579473D33375D3D224B657947222C655B652E4B6579483D33385D3D224B65794822';
wwv_flow_imp.g_varchar2_table(19003) := '2C655B652E4B6579493D33395D3D224B657949222C655B652E4B65794A3D34305D3D224B65794A222C655B652E4B65794B3D34315D3D224B65794B222C655B652E4B65794C3D34325D3D224B65794C222C655B652E4B65794D3D34335D3D224B65794D22';
wwv_flow_imp.g_varchar2_table(19004) := '2C655B652E4B65794E3D34345D3D224B65794E222C655B652E4B65794F3D34355D3D224B65794F222C655B652E4B6579503D34365D3D224B657950222C655B652E4B6579513D34375D3D224B657951222C655B652E4B6579523D34385D3D224B65795222';
wwv_flow_imp.g_varchar2_table(19005) := '2C655B652E4B6579533D34395D3D224B657953222C655B652E4B6579543D35305D3D224B657954222C655B652E4B6579553D35315D3D224B657955222C655B652E4B6579563D35325D3D224B657956222C655B652E4B6579573D35335D3D224B65795722';
wwv_flow_imp.g_varchar2_table(19006) := '2C655B652E4B6579583D35345D3D224B657958222C655B652E4B6579593D35355D3D224B657959222C655B652E4B65795A3D35365D3D224B65795A222C655B652E4D6574613D35375D3D224D657461222C655B652E436F6E746578744D656E753D35385D';
wwv_flow_imp.g_varchar2_table(19007) := '3D22436F6E746578744D656E75222C655B652E46313D35395D3D224631222C655B652E46323D36305D3D224632222C655B652E46333D36315D3D224633222C655B652E46343D36325D3D224634222C655B652E46353D36335D3D224635222C655B652E46';
wwv_flow_imp.g_varchar2_table(19008) := '363D36345D3D224636222C655B652E46373D36355D3D224637222C655B652E46383D36365D3D224638222C655B652E46393D36375D3D224639222C655B652E4631303D36385D3D22463130222C655B652E4631313D36395D3D22463131222C655B652E46';
wwv_flow_imp.g_varchar2_table(19009) := '31323D37305D3D22463132222C655B652E4631333D37315D3D22463133222C655B652E4631343D37325D3D22463134222C655B652E4631353D37335D3D22463135222C655B652E4631363D37345D3D22463136222C655B652E4631373D37355D3D224631';
wwv_flow_imp.g_varchar2_table(19010) := '37222C655B652E4631383D37365D3D22463138222C655B652E4631393D37375D3D22463139222C655B652E4632303D37385D3D22463230222C655B652E4632313D37395D3D22463231222C655B652E4632323D38305D3D22463232222C655B652E463233';
wwv_flow_imp.g_varchar2_table(19011) := '3D38315D3D22463233222C655B652E4632343D38325D3D22463234222C655B652E4E756D4C6F636B3D38335D3D224E756D4C6F636B222C655B652E5363726F6C6C4C6F636B3D38345D3D225363726F6C6C4C6F636B222C655B652E53656D69636F6C6F6E';
wwv_flow_imp.g_varchar2_table(19012) := '3D38355D3D2253656D69636F6C6F6E222C655B652E457175616C3D38365D3D22457175616C222C655B652E436F6D6D613D38375D3D22436F6D6D61222C655B652E4D696E75733D38385D3D224D696E7573222C655B652E506572696F643D38395D3D2250';
wwv_flow_imp.g_varchar2_table(19013) := '6572696F64222C655B652E536C6173683D39305D3D22536C617368222C655B652E4261636B71756F74653D39315D3D224261636B71756F7465222C655B652E427261636B65744C6566743D39325D3D22427261636B65744C656674222C655B652E426163';
wwv_flow_imp.g_varchar2_table(19014) := '6B736C6173683D39335D3D224261636B736C617368222C655B652E427261636B657452696768743D39345D3D22427261636B65745269676874222C655B652E51756F74653D39355D3D2251756F7465222C655B652E4F454D5F383D39365D3D224F454D5F';
wwv_flow_imp.g_varchar2_table(19015) := '38222C655B652E496E746C4261636B736C6173683D39375D3D22496E746C4261636B736C617368222C655B652E4E756D706164303D39385D3D224E756D70616430222C655B652E4E756D706164313D39395D3D224E756D70616431222C655B652E4E756D';
wwv_flow_imp.g_varchar2_table(19016) := '706164323D3130305D3D224E756D70616432222C655B652E4E756D706164333D3130315D3D224E756D70616433222C655B652E4E756D706164343D3130325D3D224E756D70616434222C655B652E4E756D706164353D3130335D3D224E756D7061643522';
wwv_flow_imp.g_varchar2_table(19017) := '2C655B652E4E756D706164363D3130345D3D224E756D70616436222C655B652E4E756D706164373D3130355D3D224E756D70616437222C655B652E4E756D706164383D3130365D3D224E756D70616438222C655B652E4E756D706164393D3130375D3D22';
wwv_flow_imp.g_varchar2_table(19018) := '4E756D70616439222C655B652E4E756D7061644D756C7469706C793D3130385D3D224E756D7061644D756C7469706C79222C655B652E4E756D7061644164643D3130395D3D224E756D706164416464222C655B652E4E554D5041445F534550415241544F';
wwv_flow_imp.g_varchar2_table(19019) := '523D3131305D3D224E554D5041445F534550415241544F52222C655B652E4E756D70616453756274726163743D3131315D3D224E756D7061645375627472616374222C655B652E4E756D706164446563696D616C3D3131325D3D224E756D706164446563';
wwv_flow_imp.g_varchar2_table(19020) := '696D616C222C655B652E4E756D7061644469766964653D3131335D3D224E756D706164446976696465222C655B652E4B45595F494E5F434F4D504F534954494F4E3D3131345D3D224B45595F494E5F434F4D504F534954494F4E222C655B652E41424E54';
wwv_flow_imp.g_varchar2_table(19021) := '5F43313D3131355D3D2241424E545F4331222C655B652E41424E545F43323D3131365D3D2241424E545F4332222C655B652E417564696F566F6C756D654D7574653D3131375D3D22417564696F566F6C756D654D757465222C655B652E417564696F566F';
wwv_flow_imp.g_varchar2_table(19022) := '6C756D6555703D3131385D3D22417564696F566F6C756D655570222C655B652E417564696F566F6C756D65446F776E3D3131395D3D22417564696F566F6C756D65446F776E222C655B652E42726F777365725365617263683D3132305D3D2242726F7773';
wwv_flow_imp.g_varchar2_table(19023) := '6572536561726368222C655B652E42726F77736572486F6D653D3132315D3D2242726F77736572486F6D65222C655B652E42726F777365724261636B3D3132325D3D2242726F777365724261636B222C655B652E42726F77736572466F72776172643D31';
wwv_flow_imp.g_varchar2_table(19024) := '32335D3D2242726F77736572466F7277617264222C655B652E4D65646961547261636B4E6578743D3132345D3D224D65646961547261636B4E657874222C655B652E4D65646961547261636B50726576696F75733D3132355D3D224D6564696154726163';
wwv_flow_imp.g_varchar2_table(19025) := '6B50726576696F7573222C655B652E4D6564696153746F703D3132365D3D224D6564696153746F70222C655B652E4D65646961506C617950617573653D3132375D3D224D65646961506C61795061757365222C655B652E4C61756E63684D65646961506C';
wwv_flow_imp.g_varchar2_table(19026) := '617965723D3132385D3D224C61756E63684D65646961506C61796572222C655B652E4C61756E63684D61696C3D3132395D3D224C61756E63684D61696C222C655B652E4C61756E6368417070323D3133305D3D224C61756E636841707032222C655B652E';
wwv_flow_imp.g_varchar2_table(19027) := '436C6561723D3133315D3D22436C656172222C655B652E4D41585F56414C55453D3133325D3D224D41585F56414C5545227D28757A7C7C28757A3D7B7D29292C66756E6374696F6E2865297B655B652E48696E743D315D3D2248696E74222C655B652E49';
wwv_flow_imp.g_varchar2_table(19028) := '6E666F3D325D3D22496E666F222C655B652E5761726E696E673D345D3D225761726E696E67222C655B652E4572726F723D385D3D224572726F72227D28707A7C7C28707A3D7B7D29292C66756E6374696F6E2865297B655B652E556E6E65636573736172';
wwv_flow_imp.g_varchar2_table(19029) := '793D315D3D22556E6E6563657373617279222C655B652E446570726563617465643D325D3D2244657072656361746564227D28677A7C7C28677A3D7B7D29292C66756E6374696F6E2865297B655B652E496E6C696E653D315D3D22496E6C696E65222C65';
wwv_flow_imp.g_varchar2_table(19030) := '5B652E4775747465723D325D3D22477574746572227D286D7A7C7C286D7A3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F726D616C3D315D3D224E6F726D616C222C655B652E556E6465726C696E65643D325D3D22556E6465726C696E6564';
wwv_flow_imp.g_varchar2_table(19031) := '227D28667A7C7C28667A3D7B7D29292C66756E6374696F6E2865297B655B652E554E4B4E4F574E3D305D3D22554E4B4E4F574E222C655B652E54455854415245413D315D3D225445585441524541222C655B652E4755545445525F474C5950485F4D4152';
wwv_flow_imp.g_varchar2_table(19032) := '47494E3D325D3D224755545445525F474C5950485F4D415247494E222C655B652E4755545445525F4C494E455F4E554D424552533D335D3D224755545445525F4C494E455F4E554D42455253222C655B652E4755545445525F4C494E455F4445434F5241';
wwv_flow_imp.g_varchar2_table(19033) := '54494F4E533D345D3D224755545445525F4C494E455F4445434F524154494F4E53222C655B652E4755545445525F564945575F5A4F4E453D355D3D224755545445525F564945575F5A4F4E45222C655B652E434F4E54454E545F544558543D365D3D2243';
wwv_flow_imp.g_varchar2_table(19034) := '4F4E54454E545F54455854222C655B652E434F4E54454E545F454D5054593D375D3D22434F4E54454E545F454D505459222C655B652E434F4E54454E545F564945575F5A4F4E453D385D3D22434F4E54454E545F564945575F5A4F4E45222C655B652E43';
wwv_flow_imp.g_varchar2_table(19035) := '4F4E54454E545F5749444745543D395D3D22434F4E54454E545F574944474554222C655B652E4F564552564945575F52554C45523D31305D3D224F564552564945575F52554C4552222C655B652E5343524F4C4C4241523D31315D3D225343524F4C4C42';
wwv_flow_imp.g_varchar2_table(19036) := '4152222C655B652E4F5645524C41595F5749444745543D31325D3D224F5645524C41595F574944474554222C655B652E4F5554534944455F454449544F523D31335D3D224F5554534944455F454449544F52227D28767A7C7C28767A3D7B7D29292C6675';
wwv_flow_imp.g_varchar2_table(19037) := '6E6374696F6E2865297B655B652E414947656E6572617465643D315D3D22414947656E657261746564227D28627A7C7C28627A3D7B7D29292C66756E6374696F6E2865297B655B652E496E766F6B653D305D3D22496E766F6B65222C655B652E4175746F';
wwv_flow_imp.g_varchar2_table(19038) := '6D617469633D315D3D224175746F6D61746963227D285F7A7C7C285F7A3D7B7D29292C66756E6374696F6E2865297B655B652E544F505F52494748545F434F524E45523D305D3D22544F505F52494748545F434F524E4552222C655B652E424F54544F4D';
wwv_flow_imp.g_varchar2_table(19039) := '5F52494748545F434F524E45523D315D3D22424F54544F4D5F52494748545F434F524E4552222C655B652E544F505F43454E5445523D325D3D22544F505F43454E544552227D28797A7C7C28797A3D7B7D29292C66756E6374696F6E2865297B655B652E';
wwv_flow_imp.g_varchar2_table(19040) := '4C6566743D315D3D224C656674222C655B652E43656E7465723D325D3D2243656E746572222C655B652E52696768743D345D3D225269676874222C655B652E46756C6C3D375D3D2246756C6C227D28777A7C7C28777A3D7B7D29292C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(19041) := '2865297B655B652E576F72643D305D3D22576F7264222C655B652E4C696E653D315D3D224C696E65222C655B652E537567676573743D325D3D2253756767657374227D28437A7C7C28437A3D7B7D29292C66756E6374696F6E2865297B655B652E4C6566';
wwv_flow_imp.g_varchar2_table(19042) := '743D305D3D224C656674222C655B652E52696768743D315D3D225269676874222C655B652E4E6F6E653D325D3D224E6F6E65222C655B652E4C6566744F66496E6A6563746564546578743D335D3D224C6566744F66496E6A656374656454657874222C65';
wwv_flow_imp.g_varchar2_table(19043) := '5B652E52696768744F66496E6A6563746564546578743D345D3D2252696768744F66496E6A656374656454657874227D28537A7C7C28537A3D7B7D29292C66756E6374696F6E2865297B655B652E4F66663D305D3D224F6666222C655B652E4F6E3D315D';
wwv_flow_imp.g_varchar2_table(19044) := '3D224F6E222C655B652E52656C61746976653D325D3D2252656C6174697665222C655B652E496E74657276616C3D335D3D22496E74657276616C222C655B652E437573746F6D3D345D3D22437573746F6D227D28787A7C7C28787A3D7B7D29292C66756E';
wwv_flow_imp.g_varchar2_table(19045) := '6374696F6E2865297B655B652E4E6F6E653D305D3D224E6F6E65222C655B652E546578743D315D3D2254657874222C655B652E426C6F636B733D325D3D22426C6F636B73227D286B7A7C7C286B7A3D7B7D29292C66756E6374696F6E2865297B655B652E';
wwv_flow_imp.g_varchar2_table(19046) := '536D6F6F74683D305D3D22536D6F6F7468222C655B652E496D6D6564696174653D315D3D22496D6D656469617465227D28457A7C7C28457A3D7B7D29292C66756E6374696F6E2865297B655B652E4175746F3D315D3D224175746F222C655B652E486964';
wwv_flow_imp.g_varchar2_table(19047) := '64656E3D325D3D2248696464656E222C655B652E56697369626C653D335D3D2256697369626C65227D284C7A7C7C284C7A3D7B7D29292C66756E6374696F6E2865297B655B652E4C54523D305D3D224C5452222C655B652E52544C3D315D3D2252544C22';
wwv_flow_imp.g_varchar2_table(19048) := '7D28447A7C7C28447A3D7B7D29292C66756E6374696F6E2865297B652E4F66663D226F6666222C652E4F6E436F64653D226F6E436F6465222C652E4F6E3D226F6E227D28547A7C7C28547A3D7B7D29292C66756E6374696F6E2865297B655B652E496E76';
wwv_flow_imp.g_varchar2_table(19049) := '6F6B653D315D3D22496E766F6B65222C655B652E547269676765724368617261637465723D325D3D2254726967676572436861726163746572222C655B652E436F6E74656E744368616E67653D335D3D22436F6E74656E744368616E6765227D28497A7C';
wwv_flow_imp.g_varchar2_table(19050) := '7C28497A3D7B7D29292C66756E6374696F6E2865297B655B652E46696C653D305D3D2246696C65222C655B652E4D6F64756C653D315D3D224D6F64756C65222C655B652E4E616D6573706163653D325D3D224E616D657370616365222C655B652E506163';
wwv_flow_imp.g_varchar2_table(19051) := '6B6167653D335D3D225061636B616765222C655B652E436C6173733D345D3D22436C617373222C655B652E4D6574686F643D355D3D224D6574686F64222C655B652E50726F70657274793D365D3D2250726F7065727479222C655B652E4669656C643D37';
wwv_flow_imp.g_varchar2_table(19052) := '5D3D224669656C64222C655B652E436F6E7374727563746F723D385D3D22436F6E7374727563746F72222C655B652E456E756D3D395D3D22456E756D222C655B652E496E746572666163653D31305D3D22496E74657266616365222C655B652E46756E63';
wwv_flow_imp.g_varchar2_table(19053) := '74696F6E3D31315D3D2246756E6374696F6E222C655B652E5661726961626C653D31325D3D225661726961626C65222C655B652E436F6E7374616E743D31335D3D22436F6E7374616E74222C655B652E537472696E673D31345D3D22537472696E67222C';
wwv_flow_imp.g_varchar2_table(19054) := '655B652E4E756D6265723D31355D3D224E756D626572222C655B652E426F6F6C65616E3D31365D3D22426F6F6C65616E222C655B652E41727261793D31375D3D224172726179222C655B652E4F626A6563743D31385D3D224F626A656374222C655B652E';
wwv_flow_imp.g_varchar2_table(19055) := '4B65793D31395D3D224B6579222C655B652E4E756C6C3D32305D3D224E756C6C222C655B652E456E756D4D656D6265723D32315D3D22456E756D4D656D626572222C655B652E5374727563743D32325D3D22537472756374222C655B652E4576656E743D';
wwv_flow_imp.g_varchar2_table(19056) := '32335D3D224576656E74222C655B652E4F70657261746F723D32345D3D224F70657261746F72222C655B652E54797065506172616D657465723D32355D3D2254797065506172616D65746572227D284D7A7C7C284D7A3D7B7D29292C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(19057) := '2865297B655B652E446570726563617465643D315D3D2244657072656361746564227D28417A7C7C28417A3D7B7D29292C66756E6374696F6E2865297B655B652E48696464656E3D305D3D2248696464656E222C655B652E426C696E6B3D315D3D22426C';
wwv_flow_imp.g_varchar2_table(19058) := '696E6B222C655B652E536D6F6F74683D325D3D22536D6F6F7468222C655B652E50686173653D335D3D225068617365222C655B652E457870616E643D345D3D22457870616E64222C655B652E536F6C69643D355D3D22536F6C6964227D284E7A7C7C284E';
wwv_flow_imp.g_varchar2_table(19059) := '7A3D7B7D29292C66756E6374696F6E2865297B655B652E4C696E653D315D3D224C696E65222C655B652E426C6F636B3D325D3D22426C6F636B222C655B652E556E6465726C696E653D335D3D22556E6465726C696E65222C655B652E4C696E655468696E';
wwv_flow_imp.g_varchar2_table(19060) := '3D345D3D224C696E655468696E222C655B652E426C6F636B4F75746C696E653D355D3D22426C6F636B4F75746C696E65222C655B652E556E6465726C696E655468696E3D365D3D22556E6465726C696E655468696E227D28507A7C7C28507A3D7B7D2929';
wwv_flow_imp.g_varchar2_table(19061) := '2C66756E6374696F6E2865297B655B652E416C7761797347726F77735768656E547970696E67417445646765733D305D3D22416C7761797347726F77735768656E547970696E6741744564676573222C655B652E4E6576657247726F77735768656E5479';
wwv_flow_imp.g_varchar2_table(19062) := '70696E67417445646765733D315D3D224E6576657247726F77735768656E547970696E6741744564676573222C655B652E47726F77734F6E6C795768656E547970696E674265666F72653D325D3D2247726F77734F6E6C795768656E547970696E674265';
wwv_flow_imp.g_varchar2_table(19063) := '666F7265222C655B652E47726F77734F6E6C795768656E547970696E6741667465723D335D3D2247726F77734F6E6C795768656E547970696E674166746572227D284F7A7C7C284F7A3D7B7D29292C66756E6374696F6E2865297B655B652E4E6F6E653D';
wwv_flow_imp.g_varchar2_table(19064) := '305D3D224E6F6E65222C655B652E53616D653D315D3D2253616D65222C655B652E496E64656E743D325D3D22496E64656E74222C655B652E44656570496E64656E743D335D3D2244656570496E64656E74227D28527A7C7C28527A3D7B7D29293B636C61';
wwv_flow_imp.g_varchar2_table(19065) := '737320467A7B7374617469632063686F726428652C74297B72657475726E20536528652C74297D7D66756E6374696F6E20427A28297B72657475726E7B656469746F723A766F696420302C6C616E6775616765733A766F696420302C43616E63656C6C61';
wwv_flow_imp.g_varchar2_table(19066) := '74696F6E546F6B656E536F757263653A4E742C456D69747465723A43742C4B6579436F64653A757A2C4B65794D6F643A467A2C506F736974696F6E3A6D632C52616E67653A72682C53656C656374696F6E3A61682C53656C656374696F6E446972656374';
wwv_flow_imp.g_varchar2_table(19067) := '696F6E3A447A2C4D61726B657253657665726974793A707A2C4D61726B65725461673A677A2C5572693A4E6F2C546F6B656E3A66777D7D467A2E4374726C436D643D323034382C467A2E53686966743D313032342C467A2E416C743D3531322C467A2E57';
wwv_flow_imp.g_varchar2_table(19068) := '696E4374726C3D3235363B636C61737320567A7B73746174696320636F6D70757465556E69636F6465486967686C696768747328652C742C6E297B636F6E737420693D6E3F6E2E73746172744C696E654E756D6265723A312C6F3D6E3F6E2E656E644C69';
wwv_flow_imp.g_varchar2_table(19069) := '6E654E756D6265723A652E6765744C696E65436F756E7428292C733D6E6577207A7A2874292C723D732E67657443616E646964617465436F6465506F696E747328293B6C657420613B613D22616C6C4E6F6E42617369634173636969223D3D3D723F6E65';
wwv_flow_imp.g_varchar2_table(19070) := '772052656745787028225B5E5C5C745C5C6E5C5C725C5C7832302D5C5C7837455D222C226722293A6E65772052656745787028605B247B63692841727261792E66726F6D2872292E6D61702828653D3E537472696E672E66726F6D436F6465506F696E74';
wwv_flow_imp.g_varchar2_table(19071) := '28652929292E6A6F696E28222229297D5D602C226722293B636F6E7374206C3D6E6577206E77286E756C6C2C61292C633D5B5D3B6C657420642C683D21312C753D302C703D302C673D303B653A666F72286C657420743D692C6E3D6F3B743C3D6E3B742B';
wwv_flow_imp.g_varchar2_table(19072) := '2B297B636F6E7374206E3D652E6765744C696E65436F6E74656E742874292C693D6E2E6C656E6774683B6C2E72657365742830293B646F7B696628643D6C2E6E657874286E292C64297B6C657420653D642E696E6465782C6F3D642E696E6465782B645B';
wwv_flow_imp.g_varchar2_table(19073) := '305D2E6C656E6774683B653E3026265469286E2E63686172436F6465417428652D3129292626652D2D2C6F2B313C6926265469286E2E63686172436F64654174286F2D31292926266F2B2B3B636F6E737420723D6E2E737562737472696E6728652C6F29';
wwv_flow_imp.g_varchar2_table(19074) := '3B6C657420613D417528652B312C54752C6E2C30293B612626612E656E64436F6C756D6E3C3D652B31262628613D6E756C6C293B636F6E7374206C3D732E73686F756C64486967686C696768744E6F6E4261736963415343494928722C613F612E776F72';
wwv_flow_imp.g_varchar2_table(19075) := '643A6E756C6C293B69662830213D3D6C297B333D3D3D6C3F752B2B3A323D3D3D6C3F702B2B3A313D3D3D6C3F672B2B3A666428293B636F6E7374206E3D3165333B696628632E6C656E6774683E3D6E297B683D21303B627265616B20657D632E70757368';
wwv_flow_imp.g_varchar2_table(19076) := '286E657720726828742C652B312C742C6F2B3129297D7D7D7768696C652864297D72657475726E7B72616E6765733A632C6861734D6F72653A682C616D626967756F7573436861726163746572436F756E743A752C696E76697369626C65436861726163';
wwv_flow_imp.g_varchar2_table(19077) := '746572436F756E743A702C6E6F6E42617369634173636969436861726163746572436F756E743A677D7D73746174696320636F6D70757465556E69636F6465486967686C69676874526561736F6E28652C74297B636F6E7374206E3D6E6577207A7A2874';
wwv_flow_imp.g_varchar2_table(19078) := '293B737769746368286E2E73686F756C64486967686C696768744E6F6E4261736963415343494928652C6E756C6C29297B6361736520303A72657475726E206E756C6C3B6361736520323A72657475726E7B6B696E643A317D3B6361736520333A7B636F';
wwv_flow_imp.g_varchar2_table(19079) := '6E737420693D652E636F6465506F696E7441742830292C6F3D6E2E616D626967756F7573436861726163746572732E6765745072696D617279436F6E66757361626C652869292C733D5A692E6765744C6F63616C657328292E66696C7465722828653D3E';
wwv_flow_imp.g_varchar2_table(19080) := '215A692E676574496E7374616E6365286E657720536574285B2E2E2E742E616C6C6F7765644C6F63616C65732C655D29292E6973416D626967756F757328692929293B72657475726E7B6B696E643A302C636F6E66757361626C65576974683A53747269';
wwv_flow_imp.g_varchar2_table(19081) := '6E672E66726F6D436F6465506F696E74286F292C6E6F74416D626967756F7573496E4C6F63616C65733A737D7D6361736520313A72657475726E7B6B696E643A327D7D7D7D636C617373207A7A7B636F6E7374727563746F722865297B746869732E6F70';
wwv_flow_imp.g_varchar2_table(19082) := '74696F6E733D652C746869732E616C6C6F776564436F6465506F696E74733D6E65772053657428652E616C6C6F776564436F6465506F696E7473292C746869732E616D626967756F7573436861726163746572733D5A692E676574496E7374616E636528';
wwv_flow_imp.g_varchar2_table(19083) := '6E65772053657428652E616C6C6F7765644C6F63616C657329297D67657443616E646964617465436F6465506F696E747328297B696628746869732E6F7074696F6E732E6E6F6E426173696341534349492972657475726E22616C6C4E6F6E4261736963';
wwv_flow_imp.g_varchar2_table(19084) := '4173636969223B636F6E737420653D6E6577205365743B696628746869732E6F7074696F6E732E696E76697369626C654368617261637465727329666F7228636F6E73742074206F662058692E636F6465506F696E747329487A28537472696E672E6672';
wwv_flow_imp.g_varchar2_table(19085) := '6F6D436F6465506F696E74287429297C7C652E6164642874293B696628746869732E6F7074696F6E732E616D626967756F75734368617261637465727329666F7228636F6E73742074206F6620746869732E616D626967756F7573436861726163746572';
wwv_flow_imp.g_varchar2_table(19086) := '732E676574436F6E66757361626C65436F6465506F696E7473282929652E6164642874293B666F7228636F6E73742074206F6620746869732E616C6C6F776564436F6465506F696E747329652E64656C6574652874293B72657475726E20657D73686F75';
wwv_flow_imp.g_varchar2_table(19087) := '6C64486967686C696768744E6F6E4261736963415343494928652C74297B636F6E7374206E3D652E636F6465506F696E7441742830293B696628746869732E616C6C6F776564436F6465506F696E74732E686173286E292972657475726E20303B696628';
wwv_flow_imp.g_varchar2_table(19088) := '746869732E6F7074696F6E732E6E6F6E426173696341534349492972657475726E20313B6C657420693D21312C6F3D21313B6966287429666F7228636F6E73742065206F662074297B636F6E737420743D652E636F6465506F696E7441742830292C6E3D';
wwv_flow_imp.g_varchar2_table(19089) := '7A692865293B693D697C7C6E2C6E7C7C746869732E616D626967756F7573436861726163746572732E6973416D626967756F75732874297C7C58692E6973496E76697369626C654368617261637465722874297C7C286F3D2130297D72657475726E2169';
wwv_flow_imp.g_varchar2_table(19090) := '26266F3F303A746869732E6F7074696F6E732E696E76697369626C6543686172616374657273262621487A286529262658692E6973496E76697369626C65436861726163746572286E293F323A746869732E6F7074696F6E732E616D626967756F757343';
wwv_flow_imp.g_varchar2_table(19091) := '6861726163746572732626746869732E616D626967756F7573436861726163746572732E6973416D626967756F7573286E293F333A307D7D66756E6374696F6E20487A2865297B72657475726E2220223D3D3D657C7C225C6E223D3D3D657C7C225C7422';
wwv_flow_imp.g_varchar2_table(19092) := '3D3D3D657D636C61737320577A7B636F6E7374727563746F7228652C742C6E297B746869732E6368616E6765733D652C746869732E6D6F7665733D742C746869732E68697454696D656F75743D6E7D7D636C617373206A7A7B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(19093) := '28652C74297B746869732E6C696E6552616E67654D617070696E673D652C746869732E6368616E6765733D747D7D636C61737320717A7B636F6E7374727563746F722865297B746869732E746578743D652C746869732E6C696E6553746172744F666673';
wwv_flow_imp.g_varchar2_table(19094) := '657442794C696E654964783D5B5D2C746869732E6C696E6553746172744F666673657442794C696E654964782E707573682830293B666F72286C657420743D303B743C652E6C656E6774683B742B2B29225C6E223D3D3D652E6368617241742874292626';
wwv_flow_imp.g_varchar2_table(19095) := '746869732E6C696E6553746172744F666673657442794C696E654964782E7075736828742B31297D6765744F66667365742865297B72657475726E20746869732E6C696E6553746172744F666673657442794C696E654964785B652E6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(19096) := '65722D315D2B652E636F6C756D6E2D317D6765744F666673657452616E67652865297B72657475726E206E6577206D7528746869732E6765744F666673657428652E6765745374617274506F736974696F6E2829292C746869732E6765744F6666736574';
wwv_flow_imp.g_varchar2_table(19097) := '28652E676574456E64506F736974696F6E282929297D67657420746578744C656E67746828297B636F6E737420653D746869732E6C696E6553746172744F666673657442794C696E654964782E6C656E6774682D313B72657475726E206E6577206D6728';
wwv_flow_imp.g_varchar2_table(19098) := '652C746869732E746578742E6C656E6774682D746869732E6C696E6553746172744F666673657442794C696E654964785B655D297D7D636C61737320247A7B636F6E7374727563746F722865297B746869732E65646974733D652C6264282828293D3E5F';
wwv_flow_imp.g_varchar2_table(19099) := '6428652C2828652C74293D3E652E72616E67652E676574456E64506F736974696F6E28292E69734265666F72654F72457175616C28742E72616E67652E6765745374617274506F736974696F6E282929292929297D6170706C792865297B6C657420743D';
wwv_flow_imp.g_varchar2_table(19100) := '22222C6E3D6E6577206D6328312C31293B666F7228636F6E73742069206F6620746869732E6564697473297B636F6E7374206F3D692E72616E67652C733D6F2E6765745374617274506F736974696F6E28292C723D6F2E676574456E64506F736974696F';
wwv_flow_imp.g_varchar2_table(19101) := '6E28292C613D4B7A286E2C73293B612E6973456D70747928297C7C28742B3D652E67657456616C75654F6652616E6765286129292C742B3D692E746578742C6E3D727D636F6E737420693D4B7A286E2C652E656E64506F736974696F6E4578636C757369';
wwv_flow_imp.g_varchar2_table(19102) := '7665293B72657475726E20692E6973456D70747928297C7C28742B3D652E67657456616C75654F6652616E6765286929292C747D6170706C79546F537472696E672865297B636F6E737420743D6E657720517A2865293B72657475726E20746869732E61';
wwv_flow_imp.g_varchar2_table(19103) := '70706C792874297D6765744E657752616E67657328297B636F6E737420653D5B5D3B6C657420743D302C6E3D302C693D303B666F7228636F6E7374206F206F6620746869732E6564697473297B636F6E737420733D6D672E6F6654657874286F2E746578';
wwv_flow_imp.g_varchar2_table(19104) := '74292C723D6D632E6C696674287B6C696E654E756D6265723A6F2E72616E67652E73746172744C696E654E756D6265722B6E2C636F6C756D6E3A6F2E72616E67652E7374617274436F6C756D6E2B286F2E72616E67652E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(19105) := '65723D3D3D743F693A30297D292C613D732E63726561746552616E67652872293B652E707573682861292C6E3D612E656E644C696E654E756D6265722D6F2E72616E67652E656E644C696E654E756D6265722C693D612E656E64436F6C756D6E2D6F2E72';
wwv_flow_imp.g_varchar2_table(19106) := '616E67652E656E64436F6C756D6E2C743D6F2E72616E67652E656E644C696E654E756D6265727D72657475726E20657D7D636C61737320557A7B636F6E7374727563746F7228652C74297B746869732E72616E67653D652C746869732E746578743D747D';
wwv_flow_imp.g_varchar2_table(19107) := '7D66756E6374696F6E204B7A28652C74297B696628652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265722626652E636F6C756D6E3D3D3D4E756D6265722E4D41585F534146455F494E54454745522972657475726E2072682E66726F6D50';
wwv_flow_imp.g_varchar2_table(19108) := '6F736974696F6E7328742C74293B69662821652E69734265666F72654F72457175616C287429297468726F77206E6577204F6528227374617274206D757374206265206265666F726520656E6422293B72657475726E206E657720726828652E6C696E65';
wwv_flow_imp.g_varchar2_table(19109) := '4E756D6265722C652E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D636C61737320477A7B67657420656E64506F736974696F6E4578636C757369766528297B72657475726E20746869732E6C656E6774682E616464546F50';
wwv_flow_imp.g_varchar2_table(19110) := '6F736974696F6E286E6577206D6328312C3129297D7D636C61737320517A20657874656E647320477A7B636F6E7374727563746F722865297B737570657228292C746869732E76616C75653D652C746869732E5F743D6E657720717A28746869732E7661';
wwv_flow_imp.g_varchar2_table(19111) := '6C7565297D67657456616C75654F6652616E67652865297B72657475726E20746869732E5F742E6765744F666673657452616E67652865292E737562737472696E6728746869732E76616C7565297D676574206C656E67746828297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(19112) := '6869732E5F742E746578744C656E6774687D7D636C61737320597A7B73746174696320696E766572736528652C742C6E297B636F6E737420693D5B5D3B6C6574206F3D312C733D313B666F7228636F6E73742074206F662065297B636F6E737420653D6E';
wwv_flow_imp.g_varchar2_table(19113) := '657720597A286E6577207875286F2C742E6F726967696E616C2E73746172744C696E654E756D626572292C6E657720787528732C742E6D6F6469666965642E73746172744C696E654E756D62657229293B652E6D6F6469666965642E6973456D7074797C';
wwv_flow_imp.g_varchar2_table(19114) := '7C692E707573682865292C6F3D742E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C733D742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976657D636F6E737420723D6E657720597A286E65';
wwv_flow_imp.g_varchar2_table(19115) := '77207875286F2C742B31292C6E657720787528732C6E2B3129293B72657475726E20722E6D6F6469666965642E6973456D7074797C7C692E707573682872292C697D73746174696320636C697028652C742C6E297B636F6E737420693D5B5D3B666F7228';
wwv_flow_imp.g_varchar2_table(19116) := '636F6E7374206F206F662065297B636F6E737420653D6F2E6F726967696E616C2E696E746572736563742874292C733D6F2E6D6F6469666965642E696E74657273656374286E293B65262621652E6973456D707479262673262621732E6973456D707479';
wwv_flow_imp.g_varchar2_table(19117) := '2626692E70757368286E657720597A28652C7329297D72657475726E20697D636F6E7374727563746F7228652C74297B746869732E6F726967696E616C3D652C746869732E6D6F6469666965643D747D746F537472696E6728297B72657475726E607B24';
wwv_flow_imp.g_varchar2_table(19118) := '7B746869732E6F726967696E616C2E746F537472696E6728297D2D3E247B746869732E6D6F6469666965642E746F537472696E6728297D7D607D666C697028297B72657475726E206E657720597A28746869732E6D6F6469666965642C746869732E6F72';
wwv_flow_imp.g_varchar2_table(19119) := '6967696E616C297D6A6F696E2865297B72657475726E206E657720597A28746869732E6F726967696E616C2E6A6F696E28652E6F726967696E616C292C746869732E6D6F6469666965642E6A6F696E28652E6D6F64696669656429297D746F52616E6765';
wwv_flow_imp.g_varchar2_table(19120) := '4D617070696E6728297B636F6E737420653D746869732E6F726967696E616C2E746F496E636C757369766552616E676528292C743D746869732E6D6F6469666965642E746F496E636C757369766552616E676528293B696628652626742972657475726E';
wwv_flow_imp.g_varchar2_table(19121) := '206E657720587A28652C74293B696628313D3D3D746869732E6F726967696E616C2E73746172744C696E654E756D6265727C7C313D3D3D746869732E6D6F6469666965642E73746172744C696E654E756D626572297B69662831213D3D746869732E6D6F';
wwv_flow_imp.g_varchar2_table(19122) := '6469666965642E73746172744C696E654E756D6265727C7C31213D3D746869732E6F726967696E616C2E73746172744C696E654E756D626572297468726F77206E6577204F6528226E6F7420612076616C6964206469666622293B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(19123) := '7720587A286E657720726828746869732E6F726967696E616C2E73746172744C696E654E756D6265722C312C746869732E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C31292C6E657720726828746869732E6D6F6469';
wwv_flow_imp.g_varchar2_table(19124) := '666965642E73746172744C696E654E756D6265722C312C746869732E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C3129297D72657475726E206E657720587A286E657720726828746869732E6F726967696E616C2E73';
wwv_flow_imp.g_varchar2_table(19125) := '746172744C696E654E756D6265722D312C4E756D6265722E4D41585F534146455F494E54454745522C746869732E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D312C4E756D6265722E4D41585F534146455F494E5445';
wwv_flow_imp.g_varchar2_table(19126) := '474552292C6E657720726828746869732E6D6F6469666965642E73746172744C696E654E756D6265722D312C4E756D6265722E4D41585F534146455F494E54454745522C746869732E6D6F6469666965642E656E644C696E654E756D6265724578636C75';
wwv_flow_imp.g_varchar2_table(19127) := '736976652D312C4E756D6265722E4D41585F534146455F494E544547455229297D7D636C617373205A7A20657874656E647320597A7B7374617469632066726F6D52616E67654D617070696E67732865297B636F6E737420743D78752E6A6F696E28652E';
wwv_flow_imp.g_varchar2_table(19128) := '6D61702828653D3E78752E66726F6D52616E6765496E636C757369766528652E6F726967696E616C52616E6765292929292C6E3D78752E6A6F696E28652E6D61702828653D3E78752E66726F6D52616E6765496E636C757369766528652E6D6F64696669';
wwv_flow_imp.g_varchar2_table(19129) := '656452616E6765292929293B72657475726E206E6577205A7A28742C6E2C65297D636F6E7374727563746F7228652C742C6E297B737570657228652C74292C746869732E696E6E65724368616E6765733D6E7D666C697028297B76617220653B72657475';
wwv_flow_imp.g_varchar2_table(19130) := '726E206E6577205A7A28746869732E6D6F6469666965642C746869732E6F726967696E616C2C6E756C6C3D3D3D28653D746869732E696E6E65724368616E676573297C7C766F696420303D3D3D653F766F696420303A652E6D61702828653D3E652E666C';
wwv_flow_imp.g_varchar2_table(19131) := '697028292929297D77697468496E6E65724368616E67657346726F6D4C696E6552616E67657328297B72657475726E206E6577205A7A28746869732E6F726967696E616C2C746869732E6D6F6469666965642C5B746869732E746F52616E67654D617070';
wwv_flow_imp.g_varchar2_table(19132) := '696E6728295D297D7D636C61737320587A7B636F6E7374727563746F7228652C74297B746869732E6F726967696E616C52616E67653D652C746869732E6D6F64696669656452616E67653D747D746F537472696E6728297B72657475726E607B247B7468';
wwv_flow_imp.g_varchar2_table(19133) := '69732E6F726967696E616C52616E67652E746F537472696E6728297D2D3E247B746869732E6D6F64696669656452616E67652E746F537472696E6728297D7D607D666C697028297B72657475726E206E657720587A28746869732E6D6F64696669656452';
wwv_flow_imp.g_varchar2_table(19134) := '616E67652C746869732E6F726967696E616C52616E6765297D746F54657874456469742865297B636F6E737420743D652E67657456616C75654F6652616E676528746869732E6D6F64696669656452616E6765293B72657475726E206E657720557A2874';
wwv_flow_imp.g_varchar2_table(19135) := '6869732E6F726967696E616C52616E67652C74297D7D636C617373204A7A7B636F6D707574654469666628652C742C6E297B76617220693B636F6E7374206F3D6E657720734828652C742C7B6D6178436F6D7075746174696F6E54696D653A6E2E6D6178';
wwv_flow_imp.g_varchar2_table(19136) := '436F6D7075746174696F6E54696D654D732C73686F756C6449676E6F72655472696D576869746573706163653A6E2E69676E6F72655472696D576869746573706163652C73686F756C64436F6D70757465436861724368616E6765733A21302C73686F75';
wwv_flow_imp.g_varchar2_table(19137) := '6C644D616B65507265747479446966663A21302C73686F756C64506F737450726F63657373436861724368616E6765733A21307D292E636F6D707574654469666628292C733D5B5D3B6C657420723D6E756C6C3B666F7228636F6E73742065206F66206F';
wwv_flow_imp.g_varchar2_table(19138) := '2E6368616E676573297B6C657420742C6E3B743D303D3D3D652E6F726967696E616C456E644C696E654E756D6265723F6E657720787528652E6F726967696E616C53746172744C696E654E756D6265722B312C652E6F726967696E616C53746172744C69';
wwv_flow_imp.g_varchar2_table(19139) := '6E654E756D6265722B31293A6E657720787528652E6F726967696E616C53746172744C696E654E756D6265722C652E6F726967696E616C456E644C696E654E756D6265722B31292C6E3D303D3D3D652E6D6F646966696564456E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(19140) := '723F6E657720787528652E6D6F64696669656453746172744C696E654E756D6265722B312C652E6D6F64696669656453746172744C696E654E756D6265722B31293A6E657720787528652E6D6F64696669656453746172744C696E654E756D6265722C65';
wwv_flow_imp.g_varchar2_table(19141) := '2E6D6F646966696564456E644C696E654E756D6265722B31293B6C6574206F3D6E6577205A7A28742C6E2C6E756C6C3D3D3D28693D652E636861724368616E676573297C7C766F696420303D3D3D693F766F696420303A692E6D61702828653D3E6E6577';
wwv_flow_imp.g_varchar2_table(19142) := '20587A286E657720726828652E6F726967696E616C53746172744C696E654E756D6265722C652E6F726967696E616C5374617274436F6C756D6E2C652E6F726967696E616C456E644C696E654E756D6265722C652E6F726967696E616C456E64436F6C75';
wwv_flow_imp.g_varchar2_table(19143) := '6D6E292C6E657720726828652E6D6F64696669656453746172744C696E654E756D6265722C652E6D6F6469666965645374617274436F6C756D6E2C652E6D6F646966696564456E644C696E654E756D6265722C652E6D6F646966696564456E64436F6C75';
wwv_flow_imp.g_varchar2_table(19144) := '6D6E29292929293B72262628722E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665213D3D6F2E6D6F6469666965642E73746172744C696E654E756D6265722626722E6F726967696E616C2E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19145) := '4578636C7573697665213D3D6F2E6F726967696E616C2E73746172744C696E654E756D6265727C7C286F3D6E6577205A7A28722E6F726967696E616C2E6A6F696E286F2E6F726967696E616C292C722E6D6F6469666965642E6A6F696E286F2E6D6F6469';
wwv_flow_imp.g_varchar2_table(19146) := '66696564292C722E696E6E65724368616E67657326266F2E696E6E65724368616E6765733F722E696E6E65724368616E6765732E636F6E636174286F2E696E6E65724368616E676573293A766F69642030292C732E706F70282929292C732E7075736828';
wwv_flow_imp.g_varchar2_table(19147) := '6F292C723D6F7D72657475726E206264282828293D3E5F6428732C2828652C74293D3E742E6F726967696E616C2E73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D';
wwv_flow_imp.g_varchar2_table(19148) := '6F6469666965642E73746172744C696E654E756D6265722D652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F72696769';
wwv_flow_imp.g_varchar2_table(19149) := '6E616C2E73746172744C696E654E756D6265722626652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D626572292929292C6E657720577A28732C5B5D2C6F2E';
wwv_flow_imp.g_varchar2_table(19150) := '717569744561726C79297D7D66756E6374696F6E20654828652C742C6E2C69297B72657475726E206E657720465628652C742C6E292E436F6D70757465446966662869297D636C6173732074487B636F6E7374727563746F722865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(19151) := '3D5B5D2C6E3D5B5D3B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B29745B695D3D724828655B695D2C31292C6E5B695D3D614828655B695D2C31293B746869732E6C696E65733D652C746869732E5F7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(19152) := '6D6E733D742C746869732E5F656E64436F6C756D6E733D6E7D676574456C656D656E747328297B636F6E737420653D5B5D3B666F72286C657420743D302C6E3D746869732E6C696E65732E6C656E6774683B743C6E3B742B2B29655B745D3D746869732E';
wwv_flow_imp.g_varchar2_table(19153) := '6C696E65735B745D2E737562737472696E6728746869732E5F7374617274436F6C756D6E735B745D2D312C746869732E5F656E64436F6C756D6E735B745D2D31293B72657475726E20657D676574537472696374456C656D656E742865297B7265747572';
wwv_flow_imp.g_varchar2_table(19154) := '6E20746869732E6C696E65735B655D7D67657453746172744C696E654E756D6265722865297B72657475726E20652B317D676574456E644C696E654E756D6265722865297B72657475726E20652B317D6372656174654368617253657175656E63652865';
wwv_flow_imp.g_varchar2_table(19155) := '2C742C6E297B636F6E737420693D5B5D2C6F3D5B5D2C733D5B5D3B6C657420723D303B666F72286C657420613D743B613C3D6E3B612B2B297B636F6E737420743D746869732E6C696E65735B615D2C6C3D653F746869732E5F7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(19156) := '735B615D3A312C633D653F746869732E5F656E64436F6C756D6E735B615D3A742E6C656E6774682B313B666F72286C657420653D6C3B653C633B652B2B29695B725D3D742E63686172436F6465417428652D31292C6F5B725D3D612B312C735B725D3D65';
wwv_flow_imp.g_varchar2_table(19157) := '2C722B2B3B21652626613C6E262628695B725D3D31302C6F5B725D3D612B312C735B725D3D742E6C656E6774682B312C722B2B297D72657475726E206E6577206E4828692C6F2C73297D7D636C617373206E487B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(19158) := '6E297B746869732E5F63686172436F6465733D652C746869732E5F6C696E654E756D626572733D742C746869732E5F636F6C756D6E733D6E7D746F537472696E6728297B72657475726E225B222B746869732E5F63686172436F6465732E6D6170282828';
wwv_flow_imp.g_varchar2_table(19159) := '652C74293D3E2831303D3D3D653F225C5C6E223A537472696E672E66726F6D43686172436F6465286529292B602D28247B746869732E5F6C696E654E756D626572735B745D7D2C247B746869732E5F636F6C756D6E735B745D7D296029292E6A6F696E28';
wwv_flow_imp.g_varchar2_table(19160) := '222C2022292B225D227D5F617373657274496E64657828652C74297B696628653C307C7C653E3D742E6C656E677468297468726F77206E6577204572726F722822496C6C6567616C20696E64657822297D676574456C656D656E747328297B7265747572';
wwv_flow_imp.g_varchar2_table(19161) := '6E20746869732E5F63686172436F6465737D67657453746172744C696E654E756D6265722865297B72657475726E20653E302626653D3D3D746869732E5F6C696E654E756D626572732E6C656E6774683F746869732E676574456E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(19162) := '657228652D31293A28746869732E5F617373657274496E64657828652C746869732E5F6C696E654E756D62657273292C746869732E5F6C696E654E756D626572735B655D297D676574456E644C696E654E756D6265722865297B72657475726E2D313D3D';
wwv_flow_imp.g_varchar2_table(19163) := '3D653F746869732E67657453746172744C696E654E756D62657228652B31293A28746869732E5F617373657274496E64657828652C746869732E5F6C696E654E756D62657273292C31303D3D3D746869732E5F63686172436F6465735B655D3F74686973';
wwv_flow_imp.g_varchar2_table(19164) := '2E5F6C696E654E756D626572735B655D2B313A746869732E5F6C696E654E756D626572735B655D297D6765745374617274436F6C756D6E2865297B72657475726E20653E302626653D3D3D746869732E5F636F6C756D6E732E6C656E6774683F74686973';
wwv_flow_imp.g_varchar2_table(19165) := '2E676574456E64436F6C756D6E28652D31293A28746869732E5F617373657274496E64657828652C746869732E5F636F6C756D6E73292C746869732E5F636F6C756D6E735B655D297D676574456E64436F6C756D6E2865297B72657475726E2D313D3D3D';
wwv_flow_imp.g_varchar2_table(19166) := '653F746869732E6765745374617274436F6C756D6E28652B31293A28746869732E5F617373657274496E64657828652C746869732E5F636F6C756D6E73292C31303D3D3D746869732E5F63686172436F6465735B655D3F313A746869732E5F636F6C756D';
wwv_flow_imp.g_varchar2_table(19167) := '6E735B655D2B31297D7D636C6173732069487B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C5374617274436F6C';
wwv_flow_imp.g_varchar2_table(19168) := '756D6E3D742C746869732E6F726967696E616C456E644C696E654E756D6265723D6E2C746869732E6F726967696E616C456E64436F6C756D6E3D692C746869732E6D6F64696669656453746172744C696E654E756D6265723D6F2C746869732E6D6F6469';
wwv_flow_imp.g_varchar2_table(19169) := '666965645374617274436F6C756D6E3D732C746869732E6D6F646966696564456E644C696E654E756D6265723D722C746869732E6D6F646966696564456E64436F6C756D6E3D617D7374617469632063726561746546726F6D446966664368616E676528';
wwv_flow_imp.g_varchar2_table(19170) := '652C742C6E297B636F6E737420693D742E67657453746172744C696E654E756D62657228652E6F726967696E616C5374617274292C6F3D742E6765745374617274436F6C756D6E28652E6F726967696E616C5374617274292C733D742E676574456E644C';
wwv_flow_imp.g_varchar2_table(19171) := '696E654E756D62657228652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C723D742E676574456E64436F6C756D6E28652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774682D31292C61';
wwv_flow_imp.g_varchar2_table(19172) := '3D6E2E67657453746172744C696E654E756D62657228652E6D6F6469666965645374617274292C6C3D6E2E6765745374617274436F6C756D6E28652E6D6F6469666965645374617274292C633D6E2E676574456E644C696E654E756D62657228652E6D6F';
wwv_flow_imp.g_varchar2_table(19173) := '64696669656453746172742B652E6D6F6469666965644C656E6774682D31292C643D6E2E676574456E64436F6C756D6E28652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682D31293B72657475726E206E65772069482869';
wwv_flow_imp.g_varchar2_table(19174) := '2C6F2C732C722C612C6C2C632C64297D7D636C617373206F487B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6F726967696E616C53746172744C696E654E756D6265723D652C746869732E6F726967696E616C456E644C696E65';
wwv_flow_imp.g_varchar2_table(19175) := '4E756D6265723D742C746869732E6D6F64696669656453746172744C696E654E756D6265723D6E2C746869732E6D6F646966696564456E644C696E654E756D6265723D692C746869732E636861724368616E6765733D6F7D737461746963206372656174';
wwv_flow_imp.g_varchar2_table(19176) := '6546726F6D44696666526573756C7428652C742C6E2C692C6F2C732C72297B6C657420612C6C2C632C642C683B696628303D3D3D742E6F726967696E616C4C656E6774683F28613D6E2E67657453746172744C696E654E756D62657228742E6F72696769';
wwv_flow_imp.g_varchar2_table(19177) := '6E616C5374617274292D312C6C3D30293A28613D6E2E67657453746172744C696E654E756D62657228742E6F726967696E616C5374617274292C6C3D6E2E676574456E644C696E654E756D62657228742E6F726967696E616C53746172742B742E6F7269';
wwv_flow_imp.g_varchar2_table(19178) := '67696E616C4C656E6774682D3129292C303D3D3D742E6D6F6469666965644C656E6774683F28633D692E67657453746172744C696E654E756D62657228742E6D6F6469666965645374617274292D312C643D30293A28633D692E67657453746172744C69';
wwv_flow_imp.g_varchar2_table(19179) := '6E654E756D62657228742E6D6F6469666965645374617274292C643D692E676574456E644C696E654E756D62657228742E6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D3129292C732626742E6F726967696E616C4C656E';
wwv_flow_imp.g_varchar2_table(19180) := '6774683E302626742E6F726967696E616C4C656E6774683C32302626742E6D6F6469666965644C656E6774683E302626742E6D6F6469666965644C656E6774683C323026266F2829297B636F6E737420733D6E2E6372656174654368617253657175656E';
wwv_flow_imp.g_varchar2_table(19181) := '636528652C742E6F726967696E616C53746172742C742E6F726967696E616C53746172742B742E6F726967696E616C4C656E6774682D31292C613D692E6372656174654368617253657175656E636528652C742E6D6F64696669656453746172742C742E';
wwv_flow_imp.g_varchar2_table(19182) := '6D6F64696669656453746172742B742E6D6F6469666965644C656E6774682D31293B696628732E676574456C656D656E747328292E6C656E6774683E302626612E676574456C656D656E747328292E6C656E6774683E30297B6C657420653D654828732C';
wwv_flow_imp.g_varchar2_table(19183) := '612C6F2C2130292E6368616E6765733B72262628653D66756E6374696F6E2865297B696628652E6C656E6774683C3D312972657475726E20653B636F6E737420743D5B655B305D5D3B6C6574206E3D745B305D3B666F72286C657420693D312C6F3D652E';
wwv_flow_imp.g_varchar2_table(19184) := '6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D655B695D2C733D6F2E6F726967696E616C53746172742D286E2E6F726967696E616C53746172742B6E2E6F726967696E616C4C656E677468292C723D6F2E6D6F64696669656453746172742D';
wwv_flow_imp.g_varchar2_table(19185) := '286E2E6D6F64696669656453746172742B6E2E6D6F6469666965644C656E677468293B4D6174682E6D696E28732C72293C333F286E2E6F726967696E616C4C656E6774683D6F2E6F726967696E616C53746172742B6F2E6F726967696E616C4C656E6774';
wwv_flow_imp.g_varchar2_table(19186) := '682D6E2E6F726967696E616C53746172742C6E2E6D6F6469666965644C656E6774683D6F2E6D6F64696669656453746172742B6F2E6D6F6469666965644C656E6774682D6E2E6D6F6469666965645374617274293A28742E70757368286F292C6E3D6F29';
wwv_flow_imp.g_varchar2_table(19187) := '7D72657475726E20747D286529292C683D5B5D3B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B29682E707573682869482E63726561746546726F6D446966664368616E676528655B745D2C732C6129297D7D72657475726E';
wwv_flow_imp.g_varchar2_table(19188) := '206E6577206F4828612C6C2C632C642C68297D7D636C6173732073487B636F6E7374727563746F7228652C742C6E297B746869732E73686F756C64436F6D70757465436861724368616E6765733D6E2E73686F756C64436F6D7075746543686172436861';
wwv_flow_imp.g_varchar2_table(19189) := '6E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E6765733D6E2E73686F756C64506F737450726F63657373436861724368616E6765732C746869732E73686F756C6449676E6F72655472696D576869746573706163';
wwv_flow_imp.g_varchar2_table(19190) := '653D6E2E73686F756C6449676E6F72655472696D576869746573706163652C746869732E73686F756C644D616B65507265747479446966663D6E2E73686F756C644D616B65507265747479446966662C746869732E6F726967696E616C4C696E65733D65';
wwv_flow_imp.g_varchar2_table(19191) := '2C746869732E6D6F6469666965644C696E65733D742C746869732E6F726967696E616C3D6E65772074482865292C746869732E6D6F6469666965643D6E65772074482874292C746869732E636F6E74696E75654C696E65446966663D6C48286E2E6D6178';
wwv_flow_imp.g_varchar2_table(19192) := '436F6D7075746174696F6E54696D65292C746869732E636F6E74696E756543686172446966663D6C4828303D3D3D6E2E6D6178436F6D7075746174696F6E54696D653F303A4D6174682E6D696E286E2E6D6178436F6D7075746174696F6E54696D652C35';
wwv_flow_imp.g_varchar2_table(19193) := '653329297D636F6D707574654469666628297B696628313D3D3D746869732E6F726967696E616C2E6C696E65732E6C656E6774682626303D3D3D746869732E6F726967696E616C2E6C696E65735B305D2E6C656E6774682972657475726E20313D3D3D74';
wwv_flow_imp.g_varchar2_table(19194) := '6869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869732E6D6F6469666965642E6C696E65735B305D2E6C656E6774683F7B717569744561726C793A21312C6368616E6765733A5B5D7D3A7B717569744561726C793A2131';
wwv_flow_imp.g_varchar2_table(19195) := '2C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C456E644C696E654E756D6265723A312C6D6F64696669656453746172744C696E654E756D6265723A312C6D6F646966696564456E644C69';
wwv_flow_imp.g_varchar2_table(19196) := '6E654E756D6265723A746869732E6D6F6469666965642E6C696E65732E6C656E6774682C636861724368616E6765733A766F696420307D5D7D3B696628313D3D3D746869732E6D6F6469666965642E6C696E65732E6C656E6774682626303D3D3D746869';
wwv_flow_imp.g_varchar2_table(19197) := '732E6D6F6469666965642E6C696E65735B305D2E6C656E6774682972657475726E7B717569744561726C793A21312C6368616E6765733A5B7B6F726967696E616C53746172744C696E654E756D6265723A312C6F726967696E616C456E644C696E654E75';
wwv_flow_imp.g_varchar2_table(19198) := '6D6265723A746869732E6F726967696E616C2E6C696E65732E6C656E6774682C6D6F64696669656453746172744C696E654E756D6265723A312C6D6F646966696564456E644C696E654E756D6265723A312C636861724368616E6765733A766F69642030';
wwv_flow_imp.g_varchar2_table(19199) := '7D5D7D3B636F6E737420653D654828746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E74696E75654C696E65446966662C746869732E73686F756C644D616B6550726574747944696666292C743D652E6368616E';
wwv_flow_imp.g_varchar2_table(19200) := '6765732C6E3D652E717569744561726C793B696628746869732E73686F756C6449676E6F72655472696D57686974657370616365297B636F6E737420653D5B5D3B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29652E7075';
wwv_flow_imp.g_varchar2_table(19201) := '7368286F482E63726561746546726F6D44696666526573756C7428746869732E73686F756C6449676E6F72655472696D576869746573706163652C745B6E5D2C746869732E6F726967696E616C2C746869732E6D6F6469666965642C746869732E636F6E';
wwv_flow_imp.g_varchar2_table(19202) := '74696E756543686172446966662C746869732E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E67657329293B72657475726E7B717569744561726C793A6E2C63';
wwv_flow_imp.g_varchar2_table(19203) := '68616E6765733A657D7D636F6E737420693D5B5D3B6C6574206F3D302C733D303B666F72286C657420653D2D312C6E3D742E6C656E6774683B653C6E3B652B2B297B636F6E737420723D652B313C6E3F745B652B315D3A6E756C6C2C613D723F722E6F72';
wwv_flow_imp.g_varchar2_table(19204) := '6967696E616C53746172743A746869732E6F726967696E616C4C696E65732E6C656E6774682C6C3D723F722E6D6F64696669656453746172743A746869732E6D6F6469666965644C696E65732E6C656E6774683B666F72283B6F3C612626733C6C3B297B';
wwv_flow_imp.g_varchar2_table(19205) := '636F6E737420653D746869732E6F726967696E616C4C696E65735B6F5D2C743D746869732E6D6F6469666965644C696E65735B735D3B69662865213D3D74297B7B6C6574206E3D724828652C31292C723D724828742C31293B666F72283B6E3E31262672';
wwv_flow_imp.g_varchar2_table(19206) := '3E312626652E63686172436F64654174286E2D32293D3D3D742E63686172436F6465417428722D32293B296E2D2D2C722D2D3B286E3E317C7C723E31292626746869732E5F707573685472696D57686974657370616365436861724368616E676528692C';
wwv_flow_imp.g_varchar2_table(19207) := '6F2B312C312C6E2C732B312C312C72297D7B6C6574206E3D614828652C31292C723D614828742C31293B636F6E737420613D652E6C656E6774682B312C6C3D742E6C656E6774682B313B666F72283B6E3C612626723C6C2626652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(19208) := '74286E2D31293D3D3D652E63686172436F6465417428722D31293B296E2B2B2C722B2B3B286E3C617C7C723C6C292626746869732E5F707573685472696D57686974657370616365436861724368616E676528692C6F2B312C6E2C612C732B312C722C6C';
wwv_flow_imp.g_varchar2_table(19209) := '297D7D6F2B2B2C732B2B7D72262628692E70757368286F482E63726561746546726F6D44696666526573756C7428746869732E73686F756C6449676E6F72655472696D576869746573706163652C722C746869732E6F726967696E616C2C746869732E6D';
wwv_flow_imp.g_varchar2_table(19210) := '6F6469666965642C746869732E636F6E74696E756543686172446966662C746869732E73686F756C64436F6D70757465436861724368616E6765732C746869732E73686F756C64506F737450726F63657373436861724368616E67657329292C6F2B3D72';
wwv_flow_imp.g_varchar2_table(19211) := '2E6F726967696E616C4C656E6774682C732B3D722E6D6F6469666965644C656E677468297D72657475726E7B717569744561726C793A6E2C6368616E6765733A697D7D5F707573685472696D57686974657370616365436861724368616E676528652C74';
wwv_flow_imp.g_varchar2_table(19212) := '2C6E2C692C6F2C732C72297B696628746869732E5F6D657267655472696D57686974657370616365436861724368616E676528652C742C6E2C692C6F2C732C72292972657475726E3B6C657420613B746869732E73686F756C64436F6D70757465436861';
wwv_flow_imp.g_varchar2_table(19213) := '724368616E676573262628613D5B6E657720694828742C6E2C742C692C6F2C732C6F2C72295D292C652E70757368286E6577206F4828742C742C6F2C6F2C6129297D5F6D657267655472696D57686974657370616365436861724368616E676528652C74';
wwv_flow_imp.g_varchar2_table(19214) := '2C6E2C692C6F2C732C72297B636F6E737420613D652E6C656E6774683B696628303D3D3D612972657475726E21313B636F6E7374206C3D655B612D315D3B72657475726E2030213D3D6C2E6F726967696E616C456E644C696E654E756D62657226263021';
wwv_flow_imp.g_varchar2_table(19215) := '3D3D6C2E6D6F646966696564456E644C696E654E756D6265722626286C2E6F726967696E616C456E644C696E654E756D6265723D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265723D3D3D6F3F28746869732E73686F756C64436F6D';
wwv_flow_imp.g_varchar2_table(19216) := '70757465436861724368616E67657326266C2E636861724368616E67657326266C2E636861724368616E6765732E70757368286E657720694828742C6E2C742C692C6F2C732C6F2C7229292C2130293A6C2E6F726967696E616C456E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(19217) := '6265722B313D3D3D7426266C2E6D6F646966696564456E644C696E654E756D6265722B313D3D3D6F2626286C2E6F726967696E616C456E644C696E654E756D6265723D742C6C2E6D6F646966696564456E644C696E654E756D6265723D6F2C746869732E';
wwv_flow_imp.g_varchar2_table(19218) := '73686F756C64436F6D70757465436861724368616E67657326266C2E636861724368616E67657326266C2E636861724368616E6765732E70757368286E657720694828742C6E2C742C692C6F2C732C6F2C7229292C213029297D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(19219) := '724828652C74297B636F6E7374206E3D6D692865293B72657475726E2D313D3D3D6E3F743A6E2B317D66756E6374696F6E20614828652C74297B636F6E7374206E3D76692865293B72657475726E2D313D3D3D6E3F743A6E2B327D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(19220) := '6C482865297B696628303D3D3D652972657475726E28293D3E21303B636F6E737420743D446174652E6E6F7728293B72657475726E28293D3E446174652E6E6F7728292D743C657D636C6173732063487B737461746963207472697669616C28652C7429';
wwv_flow_imp.g_varchar2_table(19221) := '7B72657475726E206E6577206348285B6E6577206448286D752E6F664C656E67746828652E6C656E677468292C6D752E6F664C656E67746828742E6C656E67746829295D2C2131297D737461746963207472697669616C54696D65644F757428652C7429';
wwv_flow_imp.g_varchar2_table(19222) := '7B72657475726E206E6577206348285B6E6577206448286D752E6F664C656E67746828652E6C656E677468292C6D752E6F664C656E67746828742E6C656E67746829295D2C2130297D636F6E7374727563746F7228652C74297B746869732E6469666673';
wwv_flow_imp.g_varchar2_table(19223) := '3D652C746869732E68697454696D656F75743D747D7D636C6173732064487B73746174696320696E7665727428652C74297B636F6E7374206E3D5B5D3B72657475726E20566828652C2828652C69293D3E7B6E2E707573682864482E66726F6D4F666673';
wwv_flow_imp.g_varchar2_table(19224) := '6574506169727328653F652E676574456E644578636C75736976657328293A68482E7A65726F2C693F692E67657453746172747328293A6E657720684828742C28653F652E7365713252616E67652E656E644578636C75736976652D652E736571315261';
wwv_flow_imp.g_varchar2_table(19225) := '6E67652E656E644578636C75736976653A30292B742929297D29292C6E7D7374617469632066726F6D4F6666736574506169727328652C74297B72657475726E206E6577206448286E6577206D7528652E6F6666736574312C742E6F666673657431292C';
wwv_flow_imp.g_varchar2_table(19226) := '6E6577206D7528652E6F6666736574322C742E6F66667365743229297D636F6E7374727563746F7228652C74297B746869732E7365713152616E67653D652C746869732E7365713252616E67653D747D7377617028297B72657475726E206E6577206448';
wwv_flow_imp.g_varchar2_table(19227) := '28746869732E7365713252616E67652C746869732E7365713152616E6765297D746F537472696E6728297B72657475726E60247B746869732E7365713152616E67657D203C2D3E20247B746869732E7365713252616E67657D607D6A6F696E2865297B72';
wwv_flow_imp.g_varchar2_table(19228) := '657475726E206E657720644828746869732E7365713152616E67652E6A6F696E28652E7365713152616E6765292C746869732E7365713252616E67652E6A6F696E28652E7365713252616E676529297D64656C74612865297B72657475726E20303D3D3D';
wwv_flow_imp.g_varchar2_table(19229) := '653F746869733A6E657720644828746869732E7365713152616E67652E64656C74612865292C746869732E7365713252616E67652E64656C7461286529297D64656C746153746172742865297B72657475726E20303D3D3D653F746869733A6E65772064';
wwv_flow_imp.g_varchar2_table(19230) := '4828746869732E7365713152616E67652E64656C746153746172742865292C746869732E7365713252616E67652E64656C74615374617274286529297D64656C7461456E642865297B72657475726E20303D3D3D653F746869733A6E6577206448287468';
wwv_flow_imp.g_varchar2_table(19231) := '69732E7365713152616E67652E64656C7461456E642865292C746869732E7365713252616E67652E64656C7461456E64286529297D696E746572736563742865297B636F6E737420743D746869732E7365713152616E67652E696E746572736563742865';
wwv_flow_imp.g_varchar2_table(19232) := '2E7365713152616E6765292C6E3D746869732E7365713252616E67652E696E7465727365637428652E7365713252616E6765293B6966287426266E2972657475726E206E657720644828742C6E297D67657453746172747328297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(19233) := '7720684828746869732E7365713152616E67652E73746172742C746869732E7365713252616E67652E7374617274297D676574456E644578636C75736976657328297B72657475726E206E657720684828746869732E7365713152616E67652E656E6445';
wwv_flow_imp.g_varchar2_table(19234) := '78636C75736976652C746869732E7365713252616E67652E656E644578636C7573697665297D7D636C6173732068487B636F6E7374727563746F7228652C74297B746869732E6F6666736574313D652C746869732E6F6666736574323D747D746F537472';
wwv_flow_imp.g_varchar2_table(19235) := '696E6728297B72657475726E60247B746869732E6F6666736574317D203C2D3E20247B746869732E6F6666736574327D607D64656C74612865297B72657475726E20303D3D3D653F746869733A6E657720684828746869732E6F6666736574312B652C74';
wwv_flow_imp.g_varchar2_table(19236) := '6869732E6F6666736574322B65297D657175616C732865297B72657475726E20746869732E6F6666736574313D3D3D652E6F6666736574312626746869732E6F6666736574323D3D3D652E6F6666736574327D7D68482E7A65726F3D6E65772068482830';
wwv_flow_imp.g_varchar2_table(19237) := '2C30292C68482E6D61783D6E6577206848284E756D6265722E4D41585F534146455F494E54454745522C4E756D6265722E4D41585F534146455F494E5445474552293B636C6173732075487B697356616C696428297B72657475726E21307D7D75482E69';
wwv_flow_imp.g_varchar2_table(19238) := '6E7374616E63653D6E65772075483B636C6173732070487B636F6E7374727563746F722865297B696628746869732E74696D656F75743D652C746869732E737461727454696D653D446174652E6E6F7728292C746869732E76616C69643D21302C653C3D';
wwv_flow_imp.g_varchar2_table(19239) := '30297468726F77206E6577204F65282274696D656F7574206D75737420626520706F73697469766522297D697356616C696428297B72657475726E2128446174652E6E6F7728292D746869732E737461727454696D653C746869732E74696D656F757429';
wwv_flow_imp.g_varchar2_table(19240) := '2626746869732E76616C6964262628746869732E76616C69643D2131292C746869732E76616C69647D7D636C6173732067487B636F6E7374727563746F7228652C74297B746869732E77696474683D652C746869732E6865696768743D742C746869732E';
wwv_flow_imp.g_varchar2_table(19241) := '61727261793D5B5D2C746869732E61727261793D6E657720417272617928652A74297D67657428652C74297B72657475726E20746869732E61727261795B652B742A746869732E77696474685D7D73657428652C742C6E297B746869732E61727261795B';
wwv_flow_imp.g_varchar2_table(19242) := '652B742A746869732E77696474685D3D6E7D7D66756E6374696F6E206D482865297B72657475726E2033323D3D3D657C7C393D3D3D657D636C6173732066487B737461746963206765744B65792865297B6C657420743D746869732E6368724B6579732E';
wwv_flow_imp.g_varchar2_table(19243) := '6765742865293B72657475726E20766F696420303D3D3D74262628743D746869732E6368724B6579732E73697A652C746869732E6368724B6579732E73657428652C7429292C747D636F6E7374727563746F7228652C742C6E297B746869732E72616E67';
wwv_flow_imp.g_varchar2_table(19244) := '653D652C746869732E6C696E65733D742C746869732E736F757263653D6E2C746869732E686973746F6772616D3D5B5D3B6C657420693D303B666F72286C6574206E3D652E73746172744C696E654E756D6265722D313B6E3C652E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(19245) := '6D6265724578636C75736976652D313B6E2B2B297B636F6E737420653D745B6E5D3B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B692B2B3B636F6E7374206E3D655B745D2C6F3D66482E6765744B6579286E293B746869732E68';
wwv_flow_imp.g_varchar2_table(19246) := '6973746F6772616D5B6F5D3D28746869732E686973746F6772616D5B6F5D7C7C30292B317D692B2B3B636F6E7374206F3D66482E6765744B657928225C6E22293B746869732E686973746F6772616D5B6F5D3D28746869732E686973746F6772616D5B6F';
wwv_flow_imp.g_varchar2_table(19247) := '5D7C7C30292B317D746869732E746F74616C436F756E743D697D636F6D7075746553696D696C61726974792865297B76617220742C6E3B6C657420693D303B636F6E7374206F3D4D6174682E6D617828746869732E686973746F6772616D2E6C656E6774';
wwv_flow_imp.g_varchar2_table(19248) := '682C652E686973746F6772616D2E6C656E677468293B666F72286C657420733D303B733C6F3B732B2B29692B3D4D6174682E61627328286E756C6C213D3D28743D746869732E686973746F6772616D5B735D292626766F69642030213D3D743F743A3029';
wwv_flow_imp.g_varchar2_table(19249) := '2D286E756C6C213D3D286E3D652E686973746F6772616D5B735D292626766F69642030213D3D6E3F6E3A3029293B72657475726E20312D692F28746869732E746F74616C436F756E742B652E746F74616C436F756E74297D7D66482E6368724B6579733D';
wwv_flow_imp.g_varchar2_table(19250) := '6E6577204D61703B636C6173732076487B636F6D7075746528652C742C6E3D75482E696E7374616E63652C69297B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774682972657475726E2063482E7472697669616C28652C74293B63';
wwv_flow_imp.g_varchar2_table(19251) := '6F6E7374206F3D6E657720674828652E6C656E6774682C742E6C656E677468292C733D6E657720674828652E6C656E6774682C742E6C656E677468292C723D6E657720674828652E6C656E6774682C742E6C656E677468293B666F72286C657420613D30';
wwv_flow_imp.g_varchar2_table(19252) := '3B613C652E6C656E6774683B612B2B29666F72286C6574206C3D303B6C3C742E6C656E6774683B6C2B2B297B696628216E2E697356616C696428292972657475726E2063482E7472697669616C54696D65644F757428652C74293B636F6E737420633D30';
wwv_flow_imp.g_varchar2_table(19253) := '3D3D3D613F303A6F2E67657428612D312C6C292C643D303D3D3D6C3F303A6F2E67657428612C6C2D31293B6C657420683B652E676574456C656D656E742861293D3D3D742E676574456C656D656E74286C293F28683D303D3D3D617C7C303D3D3D6C3F30';
wwv_flow_imp.g_varchar2_table(19254) := '3A6F2E67657428612D312C6C2D31292C613E3026266C3E302626333D3D3D732E67657428612D312C6C2D3129262628682B3D722E67657428612D312C6C2D3129292C682B3D693F6928612C6C293A31293A683D2D313B636F6E737420753D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(19255) := '617828632C642C68293B696628753D3D3D68297B636F6E737420653D613E3026266C3E303F722E67657428612D312C6C2D31293A303B722E73657428612C6C2C652B31292C732E73657428612C6C2C33297D656C736520753D3D3D633F28722E73657428';
wwv_flow_imp.g_varchar2_table(19256) := '612C6C2C30292C732E73657428612C6C2C3129293A753D3D3D64262628722E73657428612C6C2C30292C732E73657428612C6C2C3229293B6F2E73657428612C6C2C75297D636F6E737420613D5B5D3B6C6574206C3D652E6C656E6774682C633D742E6C';
wwv_flow_imp.g_varchar2_table(19257) := '656E6774683B66756E6374696F6E206428652C74297B652B313D3D3D6C2626742B313D3D3D637C7C612E70757368286E6577206448286E6577206D7528652B312C6C292C6E6577206D7528742B312C632929292C6C3D652C633D747D6C657420683D652E';
wwv_flow_imp.g_varchar2_table(19258) := '6C656E6774682D312C753D742E6C656E6774682D313B666F72283B683E3D302626753E3D303B29333D3D3D732E67657428682C75293F286428682C75292C682D2D2C752D2D293A313D3D3D732E67657428682C75293F682D2D3A752D2D3B72657475726E';
wwv_flow_imp.g_varchar2_table(19259) := '2064282D312C2D31292C612E7265766572736528292C6E657720634828612C2131297D7D636C6173732062487B636F6D7075746528652C742C6E3D75482E696E7374616E6365297B696628303D3D3D652E6C656E6774687C7C303D3D3D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(19260) := '682972657475726E2063482E7472697669616C28652C74293B636F6E737420693D652C6F3D743B66756E6374696F6E207328652C74297B666F72283B653C692E6C656E6774682626743C6F2E6C656E6774682626692E676574456C656D656E742865293D';
wwv_flow_imp.g_varchar2_table(19261) := '3D3D6F2E676574456C656D656E742874293B29652B2B2C742B2B3B72657475726E20657D6C657420723D303B636F6E737420613D6E65772079483B612E73657428302C7328302C3029293B636F6E7374206C3D6E65772077483B6C2E73657428302C303D';
wwv_flow_imp.g_varchar2_table(19262) := '3D3D612E6765742830293F6E756C6C3A6E6577205F48286E756C6C2C302C302C612E67657428302929293B6C657420633D303B653A666F72283B3B297B696628722B2B2C216E2E697356616C696428292972657475726E2063482E7472697669616C5469';
wwv_flow_imp.g_varchar2_table(19263) := '6D65644F757428692C6F293B636F6E737420653D2D4D6174682E6D696E28722C6F2E6C656E6774682B722532292C743D4D6174682E6D696E28722C692E6C656E6774682B722532293B666F7228633D653B633C3D743B632B3D32297B6C6574206E3D303B';
wwv_flow_imp.g_varchar2_table(19264) := '636F6E737420723D633D3D3D743F2D313A612E67657428632B31292C643D633D3D3D653F2D313A612E67657428632D31292B313B6E2B2B3B636F6E737420683D4D6174682E6D696E284D6174682E6D617828722C64292C692E6C656E677468292C753D68';
wwv_flow_imp.g_varchar2_table(19265) := '2D633B6966286E2B2B2C683E692E6C656E6774687C7C753E6F2E6C656E67746829636F6E74696E75653B636F6E737420703D7328682C75293B612E73657428632C70293B636F6E737420673D683D3D3D723F6C2E67657428632B31293A6C2E6765742863';
wwv_flow_imp.g_varchar2_table(19266) := '2D31293B6966286C2E73657428632C70213D3D683F6E6577205F4828672C682C752C702D68293A67292C612E6765742863293D3D3D692E6C656E6774682626612E6765742863292D633D3D3D6F2E6C656E67746829627265616B20657D7D6C657420643D';
wwv_flow_imp.g_varchar2_table(19267) := '6C2E6765742863293B636F6E737420683D5B5D3B6C657420753D692E6C656E6774682C703D6F2E6C656E6774683B666F72283B3B297B636F6E737420653D643F642E782B642E6C656E6774683A302C743D643F642E792B642E6C656E6774683A303B6966';
wwv_flow_imp.g_varchar2_table(19268) := '28653D3D3D752626743D3D3D707C7C682E70757368286E6577206448286E6577206D7528652C75292C6E6577206D7528742C702929292C216429627265616B3B753D642E782C703D642E792C643D642E707265767D72657475726E20682E726576657273';
wwv_flow_imp.g_varchar2_table(19269) := '6528292C6E657720634828682C2131297D7D636C617373205F487B636F6E7374727563746F7228652C742C6E2C69297B746869732E707265763D652C746869732E783D742C746869732E793D6E2C746869732E6C656E6774683D697D7D636C6173732079';
wwv_flow_imp.g_varchar2_table(19270) := '487B636F6E7374727563746F7228297B746869732E706F7369746976654172723D6E657720496E7433324172726179283130292C746869732E6E656761746976654172723D6E657720496E7433324172726179283130297D6765742865297B7265747572';
wwv_flow_imp.g_varchar2_table(19271) := '6E20653C303F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976654172725B655D7D73657428652C74297B696628653C30297B69662828653D2D652D31293E3D746869732E6E656761746976654172';
wwv_flow_imp.g_varchar2_table(19272) := '722E6C656E677468297B636F6E737420653D746869732E6E656761746976654172723B746869732E6E656761746976654172723D6E657720496E743332417272617928322A652E6C656E677468292C746869732E6E656761746976654172722E73657428';
wwv_flow_imp.g_varchar2_table(19273) := '65297D746869732E6E656761746976654172725B655D3D747D656C73657B696628653E3D746869732E706F7369746976654172722E6C656E677468297B636F6E737420653D746869732E706F7369746976654172723B746869732E706F73697469766541';
wwv_flow_imp.g_varchar2_table(19274) := '72723D6E657720496E743332417272617928322A652E6C656E677468292C746869732E706F7369746976654172722E7365742865297D746869732E706F7369746976654172725B655D3D747D7D7D636C6173732077487B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(19275) := '7B746869732E706F7369746976654172723D5B5D2C746869732E6E656761746976654172723D5B5D7D6765742865297B72657475726E20653C303F28653D2D652D312C746869732E6E656761746976654172725B655D293A746869732E706F7369746976';
wwv_flow_imp.g_varchar2_table(19276) := '654172725B655D7D73657428652C74297B653C303F28653D2D652D312C746869732E6E656761746976654172725B655D3D74293A746869732E706F7369746976654172725B655D3D747D7D636C6173732043487B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(19277) := '6E297B746869732E6C696E65733D652C746869732E636F6E7369646572576869746573706163654368616E6765733D6E2C746869732E656C656D656E74733D5B5D2C746869732E6669727374436861724F666673657442794C696E653D5B5D2C74686973';
wwv_flow_imp.g_varchar2_table(19278) := '2E6164646974696F6E616C4F666673657442794C696E653D5B5D3B6C657420693D21313B742E73746172743E302626742E656E644578636C75736976653E3D652E6C656E677468262628743D6E6577206D7528742E73746172742D312C742E656E644578';
wwv_flow_imp.g_varchar2_table(19279) := '636C7573697665292C693D2130292C746869732E6C696E6552616E67653D742C746869732E6669727374436861724F666673657442794C696E655B305D3D303B666F72286C657420743D746869732E6C696E6552616E67652E73746172743B743C746869';
wwv_flow_imp.g_varchar2_table(19280) := '732E6C696E6552616E67652E656E644578636C75736976653B742B2B297B6C6574206F3D655B745D2C733D303B6966286929733D6F2E6C656E6774682C6F3D22222C693D21313B656C736520696628216E297B636F6E737420653D6F2E7472696D537461';
wwv_flow_imp.g_varchar2_table(19281) := '727428293B733D6F2E6C656E6774682D652E6C656E6774682C6F3D652E7472696D456E6428297D746869732E6164646974696F6E616C4F666673657442794C696E652E707573682873293B666F72286C657420653D303B653C6F2E6C656E6774683B652B';
wwv_flow_imp.g_varchar2_table(19282) := '2B29746869732E656C656D656E74732E70757368286F2E63686172436F64654174286529293B743C652E6C656E6774682D31262628746869732E656C656D656E74732E7075736828225C6E222E63686172436F64654174283029292C746869732E666972';
wwv_flow_imp.g_varchar2_table(19283) := '7374436861724F666673657442794C696E655B742D746869732E6C696E6552616E67652E73746172742B315D3D746869732E656C656D656E74732E6C656E677468297D746869732E6164646974696F6E616C4F666673657442794C696E652E7075736828';
wwv_flow_imp.g_varchar2_table(19284) := '30297D746F537472696E6728297B72657475726E60536C6963653A2022247B746869732E746578747D22607D676574207465787428297B72657475726E20746869732E67657454657874286E6577206D7528302C746869732E6C656E67746829297D6765';
wwv_flow_imp.g_varchar2_table(19285) := '74546578742865297B72657475726E20746869732E656C656D656E74732E736C69636528652E73746172742C652E656E644578636C7573697665292E6D61702828653D3E537472696E672E66726F6D43686172436F646528652929292E6A6F696E282222';
wwv_flow_imp.g_varchar2_table(19286) := '297D676574456C656D656E742865297B72657475726E20746869732E656C656D656E74735B655D7D676574206C656E67746828297B72657475726E20746869732E656C656D656E74732E6C656E6774687D676574426F756E6461727953636F7265286529';
wwv_flow_imp.g_varchar2_table(19287) := '7B636F6E737420743D454828653E303F746869732E656C656D656E74735B652D315D3A2D31292C6E3D454828653C746869732E656C656D656E74732E6C656E6774683F746869732E656C656D656E74735B655D3A2D31293B696628373D3D3D742626383D';
wwv_flow_imp.g_varchar2_table(19288) := '3D3D6E2972657475726E20303B696628383D3D3D742972657475726E203135303B6C657420693D303B72657475726E2074213D3D6E262628692B3D31302C303D3D3D742626313D3D3D6E262628692B3D3129292C692B3D6B482874292C692B3D6B48286E';
wwv_flow_imp.g_varchar2_table(19289) := '292C697D7472616E736C6174654F66667365742865297B696628746869732E6C696E6552616E67652E6973456D7074792972657475726E206E6577206D6328746869732E6C696E6552616E67652E73746172742B312C31293B636F6E737420743D5F7528';
wwv_flow_imp.g_varchar2_table(19290) := '746869732E6669727374436861724F666673657442794C696E652C28743D3E743C3D6529293B72657475726E206E6577206D6328746869732E6C696E6552616E67652E73746172742B742B312C652D746869732E6669727374436861724F666673657442';
wwv_flow_imp.g_varchar2_table(19291) := '794C696E655B745D2B746869732E6164646974696F6E616C4F666673657442794C696E655B745D2B31297D7472616E736C61746552616E67652865297B72657475726E2072682E66726F6D506F736974696F6E7328746869732E7472616E736C6174654F';
wwv_flow_imp.g_varchar2_table(19292) := '666673657428652E7374617274292C746869732E7472616E736C6174654F666673657428652E656E644578636C757369766529297D66696E64576F7264436F6E7461696E696E672865297B696628653C307C7C653E3D746869732E656C656D656E74732E';
wwv_flow_imp.g_varchar2_table(19293) := '6C656E6774682972657475726E3B69662821534828746869732E656C656D656E74735B655D292972657475726E3B6C657420743D653B666F72283B743E302626534828746869732E656C656D656E74735B742D315D293B29742D2D3B6C6574206E3D653B';
wwv_flow_imp.g_varchar2_table(19294) := '666F72283B6E3C746869732E656C656D656E74732E6C656E6774682626534828746869732E656C656D656E74735B6E5D293B296E2B2B3B72657475726E206E6577206D7528742C6E297D636F756E744C696E6573496E2865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(19295) := '732E7472616E736C6174654F666673657428652E656E644578636C7573697665292E6C696E654E756D6265722D746869732E7472616E736C6174654F666673657428652E7374617274292E6C696E654E756D6265727D69735374726F6E676C7945717561';
wwv_flow_imp.g_varchar2_table(19296) := '6C28652C74297B72657475726E20746869732E656C656D656E74735B655D3D3D3D746869732E656C656D656E74735B745D7D657874656E64546F46756C6C4C696E65732865297B76617220742C6E3B636F6E737420693D6E756C6C213D3D28743D627528';
wwv_flow_imp.g_varchar2_table(19297) := '746869732E6669727374436861724F666673657442794C696E652C28743D3E743C3D652E73746172742929292626766F69642030213D3D743F743A302C6F3D6E756C6C213D3D286E3D66756E6374696F6E2874297B636F6E7374206E3D797528742C2874';
wwv_flow_imp.g_varchar2_table(19298) := '3D3E652E656E644578636C75736976653C3D7429293B72657475726E206E3D3D3D742E6C656E6774683F766F696420303A745B6E5D7D28746869732E6669727374436861724F666673657442794C696E6529292626766F69642030213D3D6E3F6E3A7468';
wwv_flow_imp.g_varchar2_table(19299) := '69732E656C656D656E74732E6C656E6774683B72657475726E206E6577206D7528692C6F297D7D66756E6374696F6E2053482865297B72657475726E20653E3D39372626653C3D3132327C7C653E3D36352626653C3D39307C7C653E3D34382626653C3D';
wwv_flow_imp.g_varchar2_table(19300) := '35377D636F6E73742078483D7B303A302C313A302C323A302C333A31302C343A322C353A33302C363A332C373A31302C383A31307D3B66756E6374696F6E206B482865297B72657475726E2078485B655D7D66756E6374696F6E2045482865297B726574';
wwv_flow_imp.g_varchar2_table(19301) := '75726E2031303D3D3D653F383A31333D3D3D653F373A6D482865293F363A653E3D39372626653C3D3132323F303A653E3D36352626653C3D39303F313A653E3D34382626653C3D35373F323A2D313D3D3D653F333A34343D3D3D657C7C35393D3D3D653F';
wwv_flow_imp.g_varchar2_table(19302) := '353A347D66756E6374696F6E204C4828652C742C6E297B696628652E7472696D28293D3D3D742E7472696D28292972657475726E21303B696628652E6C656E6774683E3330302626742E6C656E6774683E3330302972657475726E21313B636F6E737420';
wwv_flow_imp.g_varchar2_table(19303) := '693D286E6577206248292E636F6D70757465286E6577204348285B655D2C6E6577206D7528302C31292C2131292C6E6577204348285B745D2C6E6577206D7528302C31292C2131292C6E293B6C6574206F3D303B636F6E737420733D64482E696E766572';
wwv_flow_imp.g_varchar2_table(19304) := '7428692E64696666732C652E6C656E677468293B666F7228636F6E73742074206F66207329742E7365713152616E67652E666F72456163682828743D3E7B6D4828652E63686172436F64654174287429297C7C6F2B2B7D29293B636F6E737420723D6675';
wwv_flow_imp.g_varchar2_table(19305) := '6E6374696F6E2874297B6C6574206E3D303B666F72286C657420693D303B693C652E6C656E6774683B692B2B296D4828742E63686172436F64654174286929297C7C6E2B2B3B72657475726E206E7D28652E6C656E6774683E742E6C656E6774683F653A';
wwv_flow_imp.g_varchar2_table(19306) := '74293B72657475726E206F2F723E2E362626723E31307D66756E6374696F6E20444828652C742C6E297B6C657420693D6E3B72657475726E20693D544828652C742C69292C693D544828652C742C69292C693D66756E6374696F6E28652C742C6E297B69';
wwv_flow_imp.g_varchar2_table(19307) := '662821652E676574426F756E6461727953636F72657C7C21742E676574426F756E6461727953636F72652972657475726E206E3B666F72286C657420693D303B693C6E2E6C656E6774683B692B2B297B636F6E7374206F3D693E303F6E5B692D315D3A76';
wwv_flow_imp.g_varchar2_table(19308) := '6F696420302C733D6E5B695D2C723D692B313C6E2E6C656E6774683F6E5B692B315D3A766F696420302C613D6E6577206D75286F3F6F2E7365713152616E67652E656E644578636C75736976652B313A302C723F722E7365713152616E67652E73746172';
wwv_flow_imp.g_varchar2_table(19309) := '742D313A652E6C656E677468292C6C3D6E6577206D75286F3F6F2E7365713252616E67652E656E644578636C75736976652B313A302C723F722E7365713252616E67652E73746172742D313A742E6C656E677468293B732E7365713152616E67652E6973';
wwv_flow_imp.g_varchar2_table(19310) := '456D7074793F6E5B695D3D494828732C652C742C612C6C293A732E7365713252616E67652E6973456D7074792626286E5B695D3D494828732E7377617028292C742C652C6C2C61292E737761702829297D72657475726E206E7D28652C742C69292C697D';
wwv_flow_imp.g_varchar2_table(19311) := '66756E6374696F6E20544828652C742C6E297B696628303D3D3D6E2E6C656E6774682972657475726E206E3B636F6E737420693D5B5D3B692E70757368286E5B305D293B666F72286C6574206F3D313B6F3C6E2E6C656E6774683B6F2B2B297B636F6E73';
wwv_flow_imp.g_varchar2_table(19312) := '7420733D695B692E6C656E6774682D315D3B6C657420723D6E5B6F5D3B696628722E7365713152616E67652E6973456D7074797C7C722E7365713252616E67652E6973456D707479297B636F6E7374206E3D722E7365713152616E67652E73746172742D';
wwv_flow_imp.g_varchar2_table(19313) := '732E7365713152616E67652E656E644578636C75736976653B6C6574206F3B666F72286F3D313B6F3C3D6E2626652E676574456C656D656E7428722E7365713152616E67652E73746172742D6F293D3D3D652E676574456C656D656E7428722E73657131';
wwv_flow_imp.g_varchar2_table(19314) := '52616E67652E656E644578636C75736976652D6F292626742E676574456C656D656E7428722E7365713252616E67652E73746172742D6F293D3D3D742E676574456C656D656E7428722E7365713252616E67652E656E644578636C75736976652D6F293B';
wwv_flow_imp.g_varchar2_table(19315) := '6F2B2B293B6966286F2D2D2C6F3D3D3D6E297B695B692E6C656E6774682D315D3D6E6577206448286E6577206D7528732E7365713152616E67652E73746172742C722E7365713152616E67652E656E644578636C75736976652D6E292C6E6577206D7528';
wwv_flow_imp.g_varchar2_table(19316) := '732E7365713252616E67652E73746172742C722E7365713252616E67652E656E644578636C75736976652D6E29293B636F6E74696E75657D723D722E64656C7461282D6F297D692E707573682872297D636F6E7374206F3D5B5D3B666F72286C6574206E';
wwv_flow_imp.g_varchar2_table(19317) := '3D303B6E3C692E6C656E6774682D313B6E2B2B297B636F6E737420733D695B6E2B315D3B6C657420723D695B6E5D3B696628722E7365713152616E67652E6973456D7074797C7C722E7365713252616E67652E6973456D707479297B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(19318) := '732E7365713152616E67652E73746172742D722E7365713152616E67652E656E644578636C75736976653B6C657420613B666F7228613D303B613C6F2626652E69735374726F6E676C79457175616C28722E7365713152616E67652E73746172742B612C';
wwv_flow_imp.g_varchar2_table(19319) := '722E7365713152616E67652E656E644578636C75736976652B61292626742E69735374726F6E676C79457175616C28722E7365713252616E67652E73746172742B612C722E7365713252616E67652E656E644578636C75736976652B61293B612B2B293B';
wwv_flow_imp.g_varchar2_table(19320) := '696628613D3D3D6F297B695B6E2B315D3D6E6577206448286E6577206D7528722E7365713152616E67652E73746172742B6F2C732E7365713152616E67652E656E644578636C7573697665292C6E6577206D7528722E7365713252616E67652E73746172';
wwv_flow_imp.g_varchar2_table(19321) := '742B6F2C732E7365713252616E67652E656E644578636C757369766529293B636F6E74696E75657D613E30262628723D722E64656C7461286129297D6F2E707573682872297D72657475726E20692E6C656E6774683E3026266F2E7075736828695B692E';
wwv_flow_imp.g_varchar2_table(19322) := '6C656E6774682D315D292C6F7D66756E6374696F6E20494828652C742C6E2C692C6F297B6C657420733D313B666F72283B652E7365713152616E67652E73746172742D733E3D692E73746172742626652E7365713252616E67652E73746172742D733E3D';
wwv_flow_imp.g_varchar2_table(19323) := '6F2E737461727426266E2E69735374726F6E676C79457175616C28652E7365713252616E67652E73746172742D732C652E7365713252616E67652E656E644578636C75736976652D73292626733C3130303B29732B2B3B732D2D3B6C657420723D303B66';
wwv_flow_imp.g_varchar2_table(19324) := '6F72283B652E7365713152616E67652E73746172742B723C692E656E644578636C75736976652626652E7365713252616E67652E656E644578636C75736976652B723C6F2E656E644578636C757369766526266E2E69735374726F6E676C79457175616C';
wwv_flow_imp.g_varchar2_table(19325) := '28652E7365713252616E67652E73746172742B722C652E7365713252616E67652E656E644578636C75736976652B72292626723C3130303B29722B2B3B696628303D3D3D732626303D3D3D722972657475726E20653B6C657420613D302C6C3D2D313B66';
wwv_flow_imp.g_varchar2_table(19326) := '6F72286C657420693D2D733B693C3D723B692B2B297B636F6E7374206F3D652E7365713252616E67652E73746172742B692C733D652E7365713252616E67652E656E644578636C75736976652B692C723D652E7365713152616E67652E73746172742B69';
wwv_flow_imp.g_varchar2_table(19327) := '2C633D742E676574426F756E6461727953636F72652872292B6E2E676574426F756E6461727953636F7265286F292B6E2E676574426F756E6461727953636F72652873293B633E6C2626286C3D632C613D69297D72657475726E20652E64656C74612861';
wwv_flow_imp.g_varchar2_table(19328) := '297D636C617373204D487B636F6E7374727563746F7228652C74297B746869732E7472696D6D6564486173683D652C746869732E6C696E65733D747D676574456C656D656E742865297B72657475726E20746869732E7472696D6D6564486173685B655D';
wwv_flow_imp.g_varchar2_table(19329) := '7D676574206C656E67746828297B72657475726E20746869732E7472696D6D6564486173682E6C656E6774687D676574426F756E6461727953636F72652865297B72657475726E203165332D2828303D3D3D653F303A414828746869732E6C696E65735B';
wwv_flow_imp.g_varchar2_table(19330) := '652D315D29292B28653D3D3D746869732E6C696E65732E6C656E6774683F303A414828746869732E6C696E65735B655D2929297D676574546578742865297B72657475726E20746869732E6C696E65732E736C69636528652E73746172742C652E656E64';
wwv_flow_imp.g_varchar2_table(19331) := '4578636C7573697665292E6A6F696E28225C6E22297D69735374726F6E676C79457175616C28652C74297B72657475726E20746869732E6C696E65735B655D3D3D3D746869732E6C696E65735B745D7D7D66756E6374696F6E2041482865297B6C657420';
wwv_flow_imp.g_varchar2_table(19332) := '743D303B666F72283B743C652E6C656E67746826262833323D3D3D652E63686172436F646541742874297C7C393D3D3D652E63686172436F64654174287429293B29742B2B3B72657475726E20747D636C617373204E487B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(19333) := '297B746869732E64796E616D696350726F6772616D6D696E6744696666696E673D6E65772076482C746869732E6D7965727344696666696E67416C676F726974686D3D6E65772062487D636F6D707574654469666628652C742C6E297B696628652E6C65';
wwv_flow_imp.g_varchar2_table(19334) := '6E6774683C3D312626506828652C742C2828652C74293D3E653D3D3D7429292972657475726E206E657720577A285B5D2C5B5D2C2131293B696628313D3D3D652E6C656E6774682626303D3D3D655B305D2E6C656E6774687C7C313D3D3D742E6C656E67';
wwv_flow_imp.g_varchar2_table(19335) := '74682626303D3D3D745B305D2E6C656E6774682972657475726E206E657720577A285B6E6577205A7A286E657720787528312C652E6C656E6774682B31292C6E657720787528312C742E6C656E6774682B31292C5B6E657720587A286E65772072682831';
wwv_flow_imp.g_varchar2_table(19336) := '2C312C652E6C656E6774682C655B652E6C656E6774682D315D2E6C656E6774682B31292C6E657720726828312C312C742E6C656E6774682C745B742E6C656E6774682D315D2E6C656E6774682B3129295D295D2C5B5D2C2131293B636F6E737420693D30';
wwv_flow_imp.g_varchar2_table(19337) := '3D3D3D6E2E6D6178436F6D7075746174696F6E54696D654D733F75482E696E7374616E63653A6E6577207048286E2E6D6178436F6D7075746174696F6E54696D654D73292C6F3D216E2E69676E6F72655472696D576869746573706163652C733D6E6577';
wwv_flow_imp.g_varchar2_table(19338) := '204D61703B66756E6374696F6E20722865297B6C657420743D732E6765742865293B72657475726E20766F696420303D3D3D74262628743D732E73697A652C732E73657428652C7429292C747D636F6E737420613D652E6D61702828653D3E7228652E74';
wwv_flow_imp.g_varchar2_table(19339) := '72696D28292929292C6C3D742E6D61702828653D3E7228652E7472696D28292929292C633D6E6577204D4828612C65292C643D6E6577204D48286C2C74292C683D2828293D3E632E6C656E6774682B642E6C656E6774683C313730303F746869732E6479';
wwv_flow_imp.g_varchar2_table(19340) := '6E616D696350726F6772616D6D696E6744696666696E672E636F6D7075746528632C642C692C28286E2C69293D3E655B6E5D3D3D3D745B695D3F303D3D3D745B695D2E6C656E6774683F2E313A312B4D6174682E6C6F6728312B745B695D2E6C656E6774';
wwv_flow_imp.g_varchar2_table(19341) := '68293A2E393929293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528632C64292928293B6C657420753D682E64696666732C703D682E68697454696D656F75743B753D444828632C642C75292C753D66756E6374';
wwv_flow_imp.g_varchar2_table(19342) := '696F6E28652C742C6E297B6C657420693D6E3B696628303D3D3D692E6C656E6774682972657475726E20693B6C6574206F2C733D303B646F7B6F3D21313B636F6E737420723D5B695B305D5D3B666F72286C657420613D313B613C692E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(19343) := '612B2B297B636F6E7374206C3D695B615D2C633D725B722E6C656E6774682D315D3B66756E6374696F6E206428742C6E297B636F6E737420693D6E6577206D7528632E7365713152616E67652E656E644578636C75736976652C6C2E7365713152616E67';
wwv_flow_imp.g_varchar2_table(19344) := '652E7374617274293B72657475726E20652E676574546578742869292E7265706C616365282F5C732F672C2222292E6C656E6774683C3D34262628742E7365713152616E67652E6C656E6774682B742E7365713252616E67652E6C656E6774683E357C7C';
wwv_flow_imp.g_varchar2_table(19345) := '6E2E7365713152616E67652E6C656E6774682B6E2E7365713252616E67652E6C656E6774683E35297D6428632C6C293F286F3D21302C725B722E6C656E6774682D315D3D725B722E6C656E6774682D315D2E6A6F696E286C29293A722E70757368286C29';
wwv_flow_imp.g_varchar2_table(19346) := '7D693D727D7768696C6528732B2B3C313026266F293B72657475726E20697D28632C302C75293B636F6E737420673D5B5D2C6D3D6E3D3E7B6966286F29666F72286C657420733D303B733C6E3B732B2B297B636F6E7374206E3D662B732C723D762B733B';
wwv_flow_imp.g_varchar2_table(19347) := '696628655B6E5D213D3D745B725D297B636F6E737420733D746869732E726566696E654469666628652C742C6E6577206448286E6577206D75286E2C6E2B31292C6E6577206D7528722C722B3129292C692C6F293B666F7228636F6E73742065206F6620';
wwv_flow_imp.g_varchar2_table(19348) := '732E6D617070696E677329672E707573682865293B732E68697454696D656F7574262628703D2130297D7D7D3B6C657420663D302C763D303B666F7228636F6E7374206E206F662075297B6264282828293D3E6E2E7365713152616E67652E7374617274';
wwv_flow_imp.g_varchar2_table(19349) := '2D663D3D6E2E7365713252616E67652E73746172742D7629292C6D286E2E7365713152616E67652E73746172742D66292C663D6E2E7365713152616E67652E656E644578636C75736976652C763D6E2E7365713252616E67652E656E644578636C757369';
wwv_flow_imp.g_varchar2_table(19350) := '76653B636F6E737420733D746869732E726566696E654469666628652C742C6E2C692C6F293B732E68697454696D656F7574262628703D2130293B666F7228636F6E73742065206F6620732E6D617070696E677329672E707573682865297D6D28652E6C';
wwv_flow_imp.g_varchar2_table(19351) := '656E6774682D66293B636F6E737420623D504828672C652C74293B6C6574205F3D5B5D3B72657475726E206E2E636F6D707574654D6F7665732626285F3D746869732E636F6D707574654D6F76657328622C652C742C612C6C2C692C6F29292C62642828';
wwv_flow_imp.g_varchar2_table(19352) := '28293D3E7B66756E6374696F6E206E28652C74297B696628652E6C696E654E756D6265723C317C7C652E6C696E654E756D6265723E742E6C656E6774682972657475726E21313B636F6E7374206E3D745B652E6C696E654E756D6265722D315D3B726574';
wwv_flow_imp.g_varchar2_table(19353) := '75726E2128652E636F6C756D6E3C317C7C652E636F6C756D6E3E6E2E6C656E6774682B31297D66756E6374696F6E206928652C74297B72657475726E2128652E73746172744C696E654E756D6265723C317C7C652E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19354) := '3E742E6C656E6774682B317C7C652E656E644C696E654E756D6265724578636C75736976653C317C7C652E656E644C696E654E756D6265724578636C75736976653E742E6C656E6774682B31297D666F7228636F6E7374206F206F662062297B69662821';
wwv_flow_imp.g_varchar2_table(19355) := '6F2E696E6E65724368616E6765732972657475726E21313B666F7228636F6E73742069206F66206F2E696E6E65724368616E6765732969662821286E28692E6D6F64696669656452616E67652E6765745374617274506F736974696F6E28292C74292626';
wwv_flow_imp.g_varchar2_table(19356) := '6E28692E6D6F64696669656452616E67652E676574456E64506F736974696F6E28292C742926266E28692E6F726967696E616C52616E67652E6765745374617274506F736974696F6E28292C652926266E28692E6F726967696E616C52616E67652E6765';
wwv_flow_imp.g_varchar2_table(19357) := '74456E64506F736974696F6E28292C6529292972657475726E21313B6966282169286F2E6D6F6469666965642C74297C7C2169286F2E6F726967696E616C2C65292972657475726E21317D72657475726E21307D29292C6E657720577A28622C5F2C7029';
wwv_flow_imp.g_varchar2_table(19358) := '7D636F6D707574654D6F76657328652C742C6E2C692C6F2C732C72297B72657475726E2066756E6374696F6E28652C742C6E2C692C6F2C73297B6C65747B6D6F7665733A722C6578636C756465644368616E6765733A617D3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(19359) := '742C6E2C69297B636F6E7374206F3D5B5D2C733D652E66696C7465722828653D3E652E6D6F6469666965642E6973456D7074792626652E6F726967696E616C2E6C656E6774683E3D3329292E6D61702828653D3E6E657720664828652E6F726967696E61';
wwv_flow_imp.g_varchar2_table(19360) := '6C2C742C652929292C723D6E65772053657428652E66696C7465722828653D3E652E6F726967696E616C2E6973456D7074792626652E6D6F6469666965642E6C656E6774683E3D3329292E6D61702828653D3E6E657720664828652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(19361) := '2C6E2C65292929292C613D6E6577205365743B666F7228636F6E73742065206F662073297B6C657420742C6E3D2D313B666F7228636F6E73742069206F662072297B636F6E7374206F3D652E636F6D7075746553696D696C61726974792869293B6F3E6E';
wwv_flow_imp.g_varchar2_table(19362) := '2626286E3D6F2C743D69297D6966286E3E2E39262674262628722E64656C6574652874292C6F2E70757368286E657720597A28652E72616E67652C742E72616E676529292C612E61646428652E736F75726365292C612E61646428742E736F7572636529';
wwv_flow_imp.g_varchar2_table(19363) := '292C21692E697356616C696428292972657475726E7B6D6F7665733A6F2C6578636C756465644368616E6765733A617D7D72657475726E7B6D6F7665733A6F2C6578636C756465644368616E6765733A617D7D28652C742C6E2C73293B69662821732E69';
wwv_flow_imp.g_varchar2_table(19364) := '7356616C696428292972657475726E5B5D3B636F6E7374206C3D66756E6374696F6E28652C742C6E2C692C6F2C73297B636F6E737420723D5B5D2C613D6E65772063613B666F7228636F6E7374206E206F66206529666F72286C657420653D6E2E6F7269';
wwv_flow_imp.g_varchar2_table(19365) := '67696E616C2E73746172744C696E654E756D6265723B653C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D323B652B2B297B636F6E7374206E3D60247B745B652D315D7D3A247B745B652B312D315D7D3A247B745B';
wwv_flow_imp.g_varchar2_table(19366) := '652B322D315D7D603B612E616464286E2C7B72616E67653A6E657720787528652C652B33297D297D636F6E7374206C3D5B5D3B652E736F72742865752828653D3E652E6D6F6469666965642E73746172744C696E654E756D626572292C747529293B666F';
wwv_flow_imp.g_varchar2_table(19367) := '7228636F6E73742074206F662065297B6C657420653D5B5D3B666F72286C657420693D742E6D6F6469666965642E73746172744C696E654E756D6265723B693C742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D323B';
wwv_flow_imp.g_varchar2_table(19368) := '692B2B297B636F6E737420743D60247B6E5B692D315D7D3A247B6E5B692B312D315D7D3A247B6E5B692B322D315D7D602C6F3D6E657720787528692C692B33292C733D5B5D3B612E666F724561636828742C28287B72616E67653A747D293D3E7B666F72';
wwv_flow_imp.g_varchar2_table(19369) := '28636F6E7374206E206F662065296966286E2E6F726967696E616C4C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D742E656E644C696E654E756D6265724578636C757369766526266E2E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(19370) := '4C696E6552616E67652E656E644C696E654E756D6265724578636C75736976652B313D3D3D6F2E656E644C696E654E756D6265724578636C75736976652972657475726E206E2E6F726967696E616C4C696E6552616E67653D6E6577207875286E2E6F72';
wwv_flow_imp.g_varchar2_table(19371) := '6967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C742E656E644C696E654E756D6265724578636C7573697665292C6E2E6D6F6469666965644C696E6552616E67653D6E6577207875286E2E6D6F6469666965644C696E6552';
wwv_flow_imp.g_varchar2_table(19372) := '616E67652E73746172744C696E654E756D6265722C6F2E656E644C696E654E756D6265724578636C7573697665292C766F696420732E70757368286E293B636F6E7374206E3D7B6D6F6469666965644C696E6552616E67653A6F2C6F726967696E616C4C';
wwv_flow_imp.g_varchar2_table(19373) := '696E6552616E67653A747D3B6C2E70757368286E292C732E70757368286E297D29292C653D737D69662821732E697356616C696428292972657475726E5B5D7D6C2E736F72742869752865752828653D3E652E6D6F6469666965644C696E6552616E6765';
wwv_flow_imp.g_varchar2_table(19374) := '2E6C656E677468292C74752929293B636F6E737420633D6E6577206B752C643D6E6577206B753B666F7228636F6E73742065206F66206C297B636F6E737420743D652E6D6F6469666965644C696E6552616E67652E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19375) := '2D652E6F726967696E616C4C696E6552616E67652E73746172744C696E654E756D6265722C6E3D632E737562747261637446726F6D28652E6D6F6469666965644C696E6552616E6765292C693D642E737562747261637446726F6D28652E6F726967696E';
wwv_flow_imp.g_varchar2_table(19376) := '616C4C696E6552616E6765292E6765745769746844656C74612874292C6F3D6E2E676574496E74657273656374696F6E2869293B666F7228636F6E73742065206F66206F2E72616E676573297B696628652E6C656E6774683C3329636F6E74696E75653B';
wwv_flow_imp.g_varchar2_table(19377) := '636F6E7374206E3D652C693D652E64656C7461282D74293B722E70757368286E657720597A28692C6E29292C632E61646452616E6765286E292C642E61646452616E67652869297D7D722E736F72742865752828653D3E652E6F726967696E616C2E7374';
wwv_flow_imp.g_varchar2_table(19378) := '6172744C696E654E756D626572292C747529293B636F6E737420683D6E65772077752865293B666F72286C657420743D303B743C722E6C656E6774683B742B2B297B636F6E7374206E3D725B745D2C613D682E66696E644C6173744D6F6E6F746F6E6F75';
wwv_flow_imp.g_varchar2_table(19379) := '732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C3D6E2E6F726967696E616C2E73746172744C696E654E756D62657229292C6C3D627528652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19380) := '3C3D6E2E6D6F6469666965642E73746172744C696E654E756D62657229292C753D4D6174682E6D6178286E2E6F726967696E616C2E73746172744C696E654E756D6265722D612E6F726967696E616C2E73746172744C696E654E756D6265722C6E2E6D6F';
wwv_flow_imp.g_varchar2_table(19381) := '6469666965642E73746172744C696E654E756D6265722D6C2E6D6F6469666965642E73746172744C696E654E756D626572292C703D682E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(19382) := '6D6265723C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529292C673D627528652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C6E2E6D6F6469666965642E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(19383) := '6265724578636C757369766529292C6D3D4D6174682E6D617828702E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C672E6D6F6469';
wwv_flow_imp.g_varchar2_table(19384) := '666965642E656E644C696E654E756D6265724578636C75736976652D6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665293B6C657420662C763B666F7228663D303B663C753B662B2B297B636F6E737420653D6E2E6F72';
wwv_flow_imp.g_varchar2_table(19385) := '6967696E616C2E73746172744C696E654E756D6265722D662D312C743D6E2E6D6F6469666965642E73746172744C696E654E756D6265722D662D313B696628653E692E6C656E6774687C7C743E6F2E6C656E67746829627265616B3B696628632E636F6E';
wwv_flow_imp.g_varchar2_table(19386) := '7461696E732874297C7C642E636F6E7461696E7328652929627265616B3B696628214C4828695B652D315D2C6F5B742D315D2C732929627265616B7D666F7228663E30262628642E61646452616E6765286E6577207875286E2E6F726967696E616C2E73';
wwv_flow_imp.g_varchar2_table(19387) := '746172744C696E654E756D6265722D662C6E2E6F726967696E616C2E73746172744C696E654E756D62657229292C632E61646452616E6765286E6577207875286E2E6D6F6469666965642E73746172744C696E654E756D6265722D662C6E2E6D6F646966';
wwv_flow_imp.g_varchar2_table(19388) := '6965642E73746172744C696E654E756D6265722929292C763D303B763C6D3B762B2B297B636F6E737420653D6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B762C743D6E2E6D6F6469666965642E656E644C696E65';
wwv_flow_imp.g_varchar2_table(19389) := '4E756D6265724578636C75736976652B763B696628653E692E6C656E6774687C7C743E6F2E6C656E67746829627265616B3B696628632E636F6E7461696E732874297C7C642E636F6E7461696E7328652929627265616B3B696628214C4828695B652D31';
wwv_flow_imp.g_varchar2_table(19390) := '5D2C6F5B742D315D2C732929627265616B7D763E30262628642E61646452616E6765286E6577207875286E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C6E2E6F726967696E616C2E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19391) := '4578636C75736976652B7629292C632E61646452616E6765286E6577207875286E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B';
wwv_flow_imp.g_varchar2_table(19392) := '762929292C28663E307C7C763E3029262628725B745D3D6E657720597A286E6577207875286E2E6F726967696E616C2E73746172744C696E654E756D6265722D662C6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B';
wwv_flow_imp.g_varchar2_table(19393) := '76292C6E6577207875286E2E6D6F6469666965642E73746172744C696E654E756D6265722D662C6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B762929297D72657475726E20727D28652E66696C7465722828653D';
wwv_flow_imp.g_varchar2_table(19394) := '3E21612E68617328652929292C692C6F2C742C6E2C73293B72657475726E20596828722C6C292C723D66756E6374696F6E2865297B696628303D3D3D652E6C656E6774682972657475726E20653B652E736F72742865752828653D3E652E6F726967696E';
wwv_flow_imp.g_varchar2_table(19395) := '616C2E73746172744C696E654E756D626572292C747529293B636F6E737420743D5B655B305D5D3B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B297B636F6E737420693D745B742E6C656E6774682D315D2C6F3D655B6E5D2C733D6F';
wwv_flow_imp.g_varchar2_table(19396) := '2E6F726967696E616C2E73746172744C696E654E756D6265722D692E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C723D6F2E6D6F6469666965642E73746172744C696E654E756D6265722D692E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(19397) := '656E644C696E654E756D6265724578636C75736976653B733E3D302626723E3D302626732B723C3D323F745B742E6C656E6774682D315D3D692E6A6F696E286F293A742E70757368286F297D72657475726E20747D2872292C723D722E66696C74657228';
wwv_flow_imp.g_varchar2_table(19398) := '28653D3E7B636F6E7374206E3D652E6F726967696E616C2E746F4F666673657452616E676528292E736C6963652874292E6D61702828653D3E652E7472696D282929293B72657475726E206E2E6A6F696E28225C6E22292E6C656E6774683E3D31352626';
wwv_flow_imp.g_varchar2_table(19399) := '66756E6374696F6E2865297B6C657420743D303B666F7228636F6E7374206E206F662065296E2E6C656E6774683E3D322626742B2B3B72657475726E20747D286E293E3D327D29292C723D66756E6374696F6E28652C74297B636F6E7374206E3D6E6577';
wwv_flow_imp.g_varchar2_table(19400) := '2077752865293B72657475726E20742E66696C7465722828743D3E286E2E66696E644C6173744D6F6E6F746F6E6F75732828653D3E652E6F726967696E616C2E73746172744C696E654E756D6265723C742E6F726967696E616C2E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(19401) := '6D6265724578636C757369766529297C7C6E657720597A286E657720787528312C31292C6E657720787528312C31292929213D3D627528652C28653D3E652E6D6F6469666965642E73746172744C696E654E756D6265723C742E6D6F6469666965642E65';
wwv_flow_imp.g_varchar2_table(19402) := '6E644C696E654E756D6265724578636C7573697665292929297D28652C72292C727D28652C742C6E2C692C6F2C73292E6D61702828653D3E7B636F6E737420693D504828746869732E726566696E654469666628742C6E2C6E657720644828652E6F7269';
wwv_flow_imp.g_varchar2_table(19403) := '67696E616C2E746F4F666673657452616E676528292C652E6D6F6469666965642E746F4F666673657452616E67652829292C732C72292E6D617070696E67732C742C6E2C2130293B72657475726E206E6577206A7A28652C69297D29297D726566696E65';
wwv_flow_imp.g_varchar2_table(19404) := '4469666628652C742C6E2C692C6F297B636F6E737420733D6E657720434828652C6E2E7365713152616E67652C6F292C723D6E657720434828742C6E2E7365713252616E67652C6F292C613D732E6C656E6774682B722E6C656E6774683C3530303F7468';
wwv_flow_imp.g_varchar2_table(19405) := '69732E64796E616D696350726F6772616D6D696E6744696666696E672E636F6D7075746528732C722C69293A746869732E6D7965727344696666696E67416C676F726974686D2E636F6D7075746528732C722C69293B6C6574206C3D612E64696666733B';
wwv_flow_imp.g_varchar2_table(19406) := '72657475726E206C3D444828732C722C6C292C6C3D66756E6374696F6E28652C742C6E297B636F6E737420693D64482E696E76657274286E2C652E6C656E677468292C6F3D5B5D3B6C657420733D6E657720684828302C30293B66756E6374696F6E2072';
wwv_flow_imp.g_varchar2_table(19407) := '286E2C72297B6966286E2E6F6666736574313C732E6F6666736574317C7C6E2E6F6666736574323C732E6F6666736574322972657475726E3B636F6E737420613D652E66696E64576F7264436F6E7461696E696E67286E2E6F666673657431292C6C3D74';
wwv_flow_imp.g_varchar2_table(19408) := '2E66696E64576F7264436F6E7461696E696E67286E2E6F666673657432293B69662821617C7C216C2972657475726E3B6C657420633D6E657720644828612C6C293B636F6E737420643D632E696E746572736563742872293B6C657420683D642E736571';
wwv_flow_imp.g_varchar2_table(19409) := '3152616E67652E6C656E6774682C753D642E7365713252616E67652E6C656E6774683B666F72283B692E6C656E6774683E303B297B636F6E7374206E3D695B305D3B696628216E2E7365713152616E67652E696E746572736563747328632E7365713152';
wwv_flow_imp.g_varchar2_table(19410) := '616E6765292626216E2E7365713252616E67652E696E746572736563747328632E7365713252616E67652929627265616B3B636F6E7374206F3D652E66696E64576F7264436F6E7461696E696E67286E2E7365713152616E67652E7374617274292C733D';
wwv_flow_imp.g_varchar2_table(19411) := '742E66696E64576F7264436F6E7461696E696E67286E2E7365713252616E67652E7374617274292C723D6E6577206448286F2C73292C613D722E696E74657273656374286E293B696628682B3D612E7365713152616E67652E6C656E6774682C752B3D61';
wwv_flow_imp.g_varchar2_table(19412) := '2E7365713252616E67652E6C656E6774682C633D632E6A6F696E2872292C2128632E7365713152616E67652E656E644578636C75736976653E3D6E2E7365713152616E67652E656E644578636C75736976652929627265616B3B692E736869667428297D';
wwv_flow_imp.g_varchar2_table(19413) := '682B753C322A28632E7365713152616E67652E6C656E6774682B632E7365713252616E67652E6C656E677468292F3326266F2E707573682863292C733D632E676574456E644578636C75736976657328297D666F72283B692E6C656E6774683E303B297B';
wwv_flow_imp.g_varchar2_table(19414) := '636F6E737420653D692E736869667428293B652E7365713152616E67652E6973456D7074797C7C287228652E67657453746172747328292C65292C7228652E676574456E644578636C75736976657328292E64656C7461282D31292C6529297D72657475';
wwv_flow_imp.g_varchar2_table(19415) := '726E2066756E6374696F6E28652C74297B636F6E7374206E3D5B5D3B666F72283B652E6C656E6774683E307C7C742E6C656E6774683E303B297B636F6E737420693D655B305D2C6F3D745B305D3B6C657420733B733D69262628216F7C7C692E73657131';
wwv_flow_imp.g_varchar2_table(19416) := '52616E67652E73746172743C6F2E7365713152616E67652E7374617274293F652E736869667428293A742E736869667428292C6E2E6C656E6774683E3026266E5B6E2E6C656E6774682D315D2E7365713152616E67652E656E644578636C75736976653E';
wwv_flow_imp.g_varchar2_table(19417) := '3D732E7365713152616E67652E73746172743F6E5B6E2E6C656E6774682D315D3D6E5B6E2E6C656E6774682D315D2E6A6F696E2873293A6E2E707573682873297D72657475726E206E7D286E2C6F297D28732C722C6C292C6C3D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(19418) := '2C742C6E297B636F6E737420693D5B5D3B666F7228636F6E73742065206F66206E297B636F6E737420743D695B692E6C656E6774682D315D3B74262628652E7365713152616E67652E73746172742D742E7365713152616E67652E656E644578636C7573';
wwv_flow_imp.g_varchar2_table(19419) := '6976653C3D327C7C652E7365713252616E67652E73746172742D742E7365713252616E67652E656E644578636C75736976653C3D32293F695B692E6C656E6774682D315D3D6E657720644828742E7365713152616E67652E6A6F696E28652E7365713152';
wwv_flow_imp.g_varchar2_table(19420) := '616E6765292C742E7365713252616E67652E6A6F696E28652E7365713252616E676529293A692E707573682865297D72657475726E20697D28302C302C6C292C6C3D66756E6374696F6E28652C742C6E297B6C657420693D6E3B696628303D3D3D692E6C';
wwv_flow_imp.g_varchar2_table(19421) := '656E6774682972657475726E20693B6C6574206F2C733D303B646F7B6F3D21313B636F6E737420613D5B695B305D5D3B666F72286C6574206C3D313B6C3C692E6C656E6774683B6C2B2B297B636F6E737420633D695B6C5D2C643D615B612E6C656E6774';
wwv_flow_imp.g_varchar2_table(19422) := '682D315D3B66756E6374696F6E2068286E2C69297B636F6E7374206F3D6E6577206D7528642E7365713152616E67652E656E644578636C75736976652C632E7365713152616E67652E7374617274293B696628652E636F756E744C696E6573496E286F29';
wwv_flow_imp.g_varchar2_table(19423) := '3E357C7C6F2E6C656E6774683E3530302972657475726E21313B636F6E737420733D652E67657454657874286F292E7472696D28293B696628732E6C656E6774683E32307C7C732E73706C6974282F5C725C6E7C5C727C5C6E2F292E6C656E6774683E31';
wwv_flow_imp.g_varchar2_table(19424) := '2972657475726E21313B636F6E737420723D652E636F756E744C696E6573496E286E2E7365713152616E6765292C613D6E2E7365713152616E67652E6C656E6774682C6C3D742E636F756E744C696E6573496E286E2E7365713252616E6765292C683D6E';
wwv_flow_imp.g_varchar2_table(19425) := '2E7365713252616E67652E6C656E6774682C753D652E636F756E744C696E6573496E28692E7365713152616E6765292C703D692E7365713152616E67652E6C656E6774682C673D742E636F756E744C696E6573496E28692E7365713252616E6765292C6D';
wwv_flow_imp.g_varchar2_table(19426) := '3D692E7365713252616E67652E6C656E6774683B66756E6374696F6E20662865297B72657475726E204D6174682E6D696E28652C313330297D72657475726E204D6174682E706F77284D6174682E706F7728662834302A722B61292C312E35292B4D6174';
wwv_flow_imp.g_varchar2_table(19427) := '682E706F7728662834302A6C2B68292C312E35292C312E35292B4D6174682E706F77284D6174682E706F7728662834302A752B70292C312E35292B4D6174682E706F7728662834302A672B6D292C312E35292C312E35293E37343138342E393634383037';
wwv_flow_imp.g_varchar2_table(19428) := '32313234337D6828642C63293F286F3D21302C615B612E6C656E6774682D315D3D615B612E6C656E6774682D315D2E6A6F696E286329293A612E707573682863297D693D617D7768696C6528732B2B3C313026266F293B636F6E737420723D5B5D3B7265';
wwv_flow_imp.g_varchar2_table(19429) := '7475726E2066756E6374696F6E28652C74297B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297428303D3D3D6E3F766F696420303A655B6E2D315D2C655B6E5D2C6E2B313D3D3D652E6C656E6774683F766F696420303A655B6E2B31';
wwv_flow_imp.g_varchar2_table(19430) := '5D297D28692C2828742C6E2C69293D3E7B6C6574206F3D6E3B66756E6374696F6E20732865297B72657475726E20652E6C656E6774683E302626652E7472696D28292E6C656E6774683C3D3326266E2E7365713152616E67652E6C656E6774682B6E2E73';
wwv_flow_imp.g_varchar2_table(19431) := '65713252616E67652E6C656E6774683E3130307D636F6E737420613D652E657874656E64546F46756C6C4C696E6573286E2E7365713152616E6765292C6C3D652E67657454657874286E6577206D7528612E73746172742C6E2E7365713152616E67652E';
wwv_flow_imp.g_varchar2_table(19432) := '737461727429293B73286C292626286F3D6F2E64656C74615374617274282D6C2E6C656E67746829293B636F6E737420633D652E67657454657874286E6577206D75286E2E7365713152616E67652E656E644578636C75736976652C612E656E64457863';
wwv_flow_imp.g_varchar2_table(19433) := '6C757369766529293B732863292626286F3D6F2E64656C7461456E6428632E6C656E67746829293B636F6E737420643D64482E66726F6D4F6666736574506169727328743F742E676574456E644578636C75736976657328293A68482E7A65726F2C693F';
wwv_flow_imp.g_varchar2_table(19434) := '692E67657453746172747328293A68482E6D6178292C683D6F2E696E746572736563742864293B722E6C656E6774683E302626682E67657453746172747328292E657175616C7328725B722E6C656E6774682D315D2E676574456E644578636C75736976';
wwv_flow_imp.g_varchar2_table(19435) := '65732829293F725B722E6C656E6774682D315D3D725B722E6C656E6774682D315D2E6A6F696E2868293A722E707573682868297D29292C727D28732C722C6C292C7B6D617070696E67733A6C2E6D61702828653D3E6E657720587A28732E7472616E736C';
wwv_flow_imp.g_varchar2_table(19436) := '61746552616E676528652E7365713152616E6765292C722E7472616E736C61746552616E676528652E7365713252616E6765292929292C68697454696D656F75743A612E68697454696D656F75747D7D7D66756E6374696F6E20504828652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(19437) := '3D2131297B636F6E7374206F3D5B5D3B666F7228636F6E73742069206F6620426828652E6D61702828653D3E66756E6374696F6E28652C742C6E297B6C657420693D302C6F3D303B313D3D3D652E6D6F64696669656452616E67652E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(19438) := '6E2626313D3D3D652E6F726967696E616C52616E67652E656E64436F6C756D6E2626652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722B693C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722626';
wwv_flow_imp.g_varchar2_table(19439) := '652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B693C3D652E6D6F64696669656452616E67652E656E644C696E654E756D6265722626286F3D2D31292C652E6D6F64696669656452616E67652E7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(19440) := '2D313E3D6E5B652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722D315D2E6C656E6774682626652E6F726967696E616C52616E67652E7374617274436F6C756D6E2D313E3D745B652E6F726967696E616C52616E67652E7374';
wwv_flow_imp.g_varchar2_table(19441) := '6172744C696E654E756D6265722D315D2E6C656E6774682626652E6F726967696E616C52616E67652E73746172744C696E654E756D6265723C3D652E6F726967696E616C52616E67652E656E644C696E654E756D6265722B6F2626652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(19442) := '6452616E67652E73746172744C696E654E756D6265723C3D652E6D6F64696669656452616E67652E656E644C696E654E756D6265722B6F262628693D31293B636F6E737420733D6E657720787528652E6F726967696E616C52616E67652E73746172744C';
wwv_flow_imp.g_varchar2_table(19443) := '696E654E756D6265722B692C652E6F726967696E616C52616E67652E656E644C696E654E756D6265722B312B6F292C723D6E657720787528652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722B692C652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(19444) := '52616E67652E656E644C696E654E756D6265722B312B6F293B72657475726E206E6577205A7A28732C722C5B655D297D28652C742C6E2929292C2828652C74293D3E652E6F726967696E616C2E6F7665726C61704F72546F75636828742E6F726967696E';
wwv_flow_imp.g_varchar2_table(19445) := '616C297C7C652E6D6F6469666965642E6F7665726C61704F72546F75636828742E6D6F646966696564292929297B636F6E737420653D695B305D2C743D695B692E6C656E6774682D315D3B6F2E70757368286E6577205A7A28652E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(19446) := '6A6F696E28742E6F726967696E616C292C652E6D6F6469666965642E6A6F696E28742E6D6F646966696564292C692E6D61702828653D3E652E696E6E65724368616E6765735B305D292929297D72657475726E206264282828293D3E7B69662821692626';
wwv_flow_imp.g_varchar2_table(19447) := '6F2E6C656E6774683E30297B6966286F5B305D2E6D6F6469666965642E73746172744C696E654E756D626572213D3D6F5B305D2E6F726967696E616C2E73746172744C696E654E756D6265722972657475726E21313B6966286E2E6C656E6774682D6F5B';
wwv_flow_imp.g_varchar2_table(19448) := '6F2E6C656E6774682D315D2E6D6F6469666965642E656E644C696E654E756D6265724578636C7573697665213D742E6C656E6774682D6F5B6F2E6C656E6774682D315D2E6F726967696E616C2E656E644C696E654E756D6265724578636C757369766529';
wwv_flow_imp.g_varchar2_table(19449) := '72657475726E21317D72657475726E205F64286F2C2828652C74293D3E742E6F726967696E616C2E73746172744C696E654E756D6265722D652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653D3D742E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(19450) := '642E73746172744C696E654E756D6265722D652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652626652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C742E6F726967696E616C2E7374';
wwv_flow_imp.g_varchar2_table(19451) := '6172744C696E654E756D6265722626652E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653C742E6D6F6469666965642E73746172744C696E654E756D62657229297D29292C6F7D66756E6374696F6E204F482865297B636F';
wwv_flow_imp.g_varchar2_table(19452) := '6E737420743D5B5D3B666F7228636F6E7374206E206F662065297B636F6E737420653D4E756D626572286E293B28657C7C303D3D3D6526262222213D3D6E2E7265706C616365282F5C732F672C222229292626742E707573682865297D72657475726E20';
wwv_flow_imp.g_varchar2_table(19453) := '747D66756E6374696F6E20524828652C742C6E2C69297B72657475726E7B7265643A652F3235352C626C75653A6E2F3235352C677265656E3A742F3235352C616C7068613A697D7D66756E6374696F6E20464828652C74297B636F6E7374206E3D742E69';
wwv_flow_imp.g_varchar2_table(19454) := '6E6465782C693D745B305D2E6C656E6774683B696628216E2972657475726E3B636F6E7374206F3D652E706F736974696F6E4174286E293B72657475726E7B73746172744C696E654E756D6265723A6F2E6C696E654E756D6265722C7374617274436F6C';
wwv_flow_imp.g_varchar2_table(19455) := '756D6E3A6F2E636F6C756D6E2C656E644C696E654E756D6265723A6F2E6C696E654E756D6265722C656E64436F6C756D6E3A6F2E636F6C756D6E2B697D7D66756E6374696F6E20424828652C74297B69662821652972657475726E3B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(19456) := '68752E466F726D61742E4353532E70617273654865782874293B72657475726E206E3F7B72616E67653A652C636F6C6F723A5248286E2E726762612E722C6E2E726762612E672C6E2E726762612E622C6E2E726762612E61297D3A766F696420307D6675';
wwv_flow_imp.g_varchar2_table(19457) := '6E6374696F6E20564828652C742C6E297B69662821657C7C31213D3D742E6C656E6774682972657475726E3B636F6E737420693D4F4828745B305D2E76616C7565732829293B72657475726E7B72616E67653A652C636F6C6F723A524828695B305D2C69';
wwv_flow_imp.g_varchar2_table(19458) := '5B315D2C695B325D2C6E3F695B335D3A31297D7D66756E6374696F6E207A4828652C742C6E297B69662821657C7C31213D3D742E6C656E6774682972657475726E3B636F6E737420693D4F4828745B305D2E76616C7565732829292C6F3D6E6577206875';
wwv_flow_imp.g_varchar2_table(19459) := '286E657720637528695B305D2C695B315D2F3130302C695B325D2F3130302C6E3F695B335D3A3129293B72657475726E7B72616E67653A652C636F6C6F723A5248286F2E726762612E722C6F2E726762612E672C6F2E726762612E622C6F2E726762612E';
wwv_flow_imp.g_varchar2_table(19460) := '61297D7D66756E6374696F6E20484828652C74297B72657475726E22737472696E67223D3D747970656F6620653F5B2E2E2E652E6D61746368416C6C2874295D3A652E66696E644D6174636865732874297D636F6E73742057483D2F5C624D41524B3A5C';
wwv_flow_imp.g_varchar2_table(19461) := '732A282E2A29242F642C6A483D2F5E2D2B7C2D2B242F673B66756E6374696F6E20714828652C742C6E297B57482E6C617374496E6465783D303B636F6E737420693D57482E657865632865293B69662869297B636F6E737420653D7B73746172744C696E';
wwv_flow_imp.g_varchar2_table(19462) := '654E756D6265723A742C7374617274436F6C756D6E3A692E696E64696365735B315D5B305D2B312C656E644C696E654E756D6265723A742C656E64436F6C756D6E3A692E696E64696365735B315D5B315D2B317D3B696628652E656E64436F6C756D6E3E';
wwv_flow_imp.g_varchar2_table(19463) := '652E7374617274436F6C756D6E297B636F6E737420743D7B72616E67653A652C2E2E2E244828695B315D292C73686F756C644265496E436F6D6D656E74733A21307D3B28742E746578747C7C742E686173536570617261746F724C696E652926266E2E70';
wwv_flow_imp.g_varchar2_table(19464) := '7573682874297D7D7D66756E6374696F6E2024482865297B636F6E737420743D28653D652E7472696D2829292E7374617274735769746828222D22293B72657475726E7B746578743A653D652E7265706C616365286A482C2222292C6861735365706172';
wwv_flow_imp.g_varchar2_table(19465) := '61746F724C696E653A747D7D636C61737320554820657874656E64732042567B6765742075726928297B72657475726E20746869732E5F7572697D67657420656F6C28297B72657475726E20746869732E5F656F6C7D67657456616C756528297B726574';
wwv_flow_imp.g_varchar2_table(19466) := '75726E20746869732E6765745465787428297D66696E644D6174636865732865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C746869732E5F6C696E65732E6C656E6774683B6E2B2B297B636F6E737420693D746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(19467) := '65735B6E5D2C6F3D746869732E6F66667365744174286E6577206D63286E2B312C3129292C733D692E6D61746368416C6C2865293B666F7228636F6E73742065206F6620732928652E696E6465787C7C303D3D3D652E696E64657829262628652E696E64';
wwv_flow_imp.g_varchar2_table(19468) := '65783D652E696E6465782B6F292C742E707573682865297D72657475726E20747D6765744C696E6573436F6E74656E7428297B72657475726E20746869732E5F6C696E65732E736C6963652830297D6765744C696E65436F756E7428297B72657475726E';
wwv_flow_imp.g_varchar2_table(19469) := '20746869732E5F6C696E65732E6C656E6774687D6765744C696E65436F6E74656E742865297B72657475726E20746869732E5F6C696E65735B652D315D7D676574576F72644174506F736974696F6E28652C74297B636F6E7374206E3D417528652E636F';
wwv_flow_imp.g_varchar2_table(19470) := '6C756D6E2C49752874292C746869732E5F6C696E65735B652E6C696E654E756D6265722D315D2C30293B72657475726E206E3F6E657720726828652E6C696E654E756D6265722C6E2E7374617274436F6C756D6E2C652E6C696E654E756D6265722C6E2E';
wwv_flow_imp.g_varchar2_table(19471) := '656E64436F6C756D6E293A6E756C6C7D776F7264732865297B636F6E737420743D746869732E5F6C696E65732C6E3D746869732E5F776F7264656E697A652E62696E642874686973293B6C657420693D302C6F3D22222C733D302C723D5B5D3B72657475';
wwv_flow_imp.g_varchar2_table(19472) := '726E7B2A5B53796D626F6C2E6974657261746F725D28297B666F72283B3B29696628733C722E6C656E677468297B636F6E737420653D6F2E737562737472696E6728725B735D2E73746172742C725B735D2E656E64293B732B3D312C7969656C6420657D';
wwv_flow_imp.g_varchar2_table(19473) := '656C73657B6966282128693C742E6C656E6774682929627265616B3B6F3D745B695D2C723D6E286F2C65292C733D302C692B3D317D7D7D7D6765744C696E65576F72647328652C74297B636F6E7374206E3D746869732E5F6C696E65735B652D315D2C69';
wwv_flow_imp.g_varchar2_table(19474) := '3D746869732E5F776F7264656E697A65286E2C74292C6F3D5B5D3B666F7228636F6E73742065206F662069296F2E70757368287B776F72643A6E2E737562737472696E6728652E73746172742C652E656E64292C7374617274436F6C756D6E3A652E7374';
wwv_flow_imp.g_varchar2_table(19475) := '6172742B312C656E64436F6C756D6E3A652E656E642B317D293B72657475726E206F7D5F776F7264656E697A6528652C74297B636F6E7374206E3D5B5D3B6C657420693B666F7228742E6C617374496E6465783D303B28693D742E657865632865292926';
wwv_flow_imp.g_varchar2_table(19476) := '2630213D3D695B305D2E6C656E6774683B296E2E70757368287B73746172743A692E696E6465782C656E643A692E696E6465782B695B305D2E6C656E6774687D293B72657475726E206E7D67657456616C7565496E52616E67652865297B69662828653D';
wwv_flow_imp.g_varchar2_table(19477) := '746869732E5F76616C696461746552616E6765286529292E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722972657475726E20746869732E5F6C696E65735B652E73746172744C696E654E756D6265722D315D2E7375';
wwv_flow_imp.g_varchar2_table(19478) := '62737472696E6728652E7374617274436F6C756D6E2D312C652E656E64436F6C756D6E2D31293B636F6E737420743D746869732E5F656F6C2C6E3D652E73746172744C696E654E756D6265722D312C693D652E656E644C696E654E756D6265722D312C6F';
wwv_flow_imp.g_varchar2_table(19479) := '3D5B5D3B6F2E7075736828746869732E5F6C696E65735B6E5D2E737562737472696E6728652E7374617274436F6C756D6E2D3129293B666F72286C657420653D6E2B313B653C693B652B2B296F2E7075736828746869732E5F6C696E65735B655D293B72';
wwv_flow_imp.g_varchar2_table(19480) := '657475726E206F2E7075736828746869732E5F6C696E65735B695D2E737562737472696E6728302C652E656E64436F6C756D6E2D3129292C6F2E6A6F696E2874297D6F666673657441742865297B72657475726E20653D746869732E5F76616C69646174';
wwv_flow_imp.g_varchar2_table(19481) := '65506F736974696F6E2865292C746869732E5F656E737572654C696E6553746172747328292C746869732E5F6C696E655374617274732E67657450726566697853756D28652E6C696E654E756D6265722D32292B28652E636F6C756D6E2D31297D706F73';
wwv_flow_imp.g_varchar2_table(19482) := '6974696F6E41742865297B653D4D6174682E666C6F6F722865292C653D4D6174682E6D617828302C65292C746869732E5F656E737572654C696E6553746172747328293B636F6E737420743D746869732E5F6C696E655374617274732E676574496E6465';
wwv_flow_imp.g_varchar2_table(19483) := '784F662865292C6E3D746869732E5F6C696E65735B742E696E6465785D2E6C656E6774683B72657475726E7B6C696E654E756D6265723A312B742E696E6465782C636F6C756D6E3A312B4D6174682E6D696E28742E72656D61696E6465722C6E297D7D5F';
wwv_flow_imp.g_varchar2_table(19484) := '76616C696461746552616E67652865297B636F6E737420743D746869732E5F76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E73746172744C696E654E756D6265722C636F6C756D6E3A652E7374617274436F6C756D6E7D29';
wwv_flow_imp.g_varchar2_table(19485) := '2C6E3D746869732E5F76616C6964617465506F736974696F6E287B6C696E654E756D6265723A652E656E644C696E654E756D6265722C636F6C756D6E3A652E656E64436F6C756D6E7D293B72657475726E20742E6C696E654E756D626572213D3D652E73';
wwv_flow_imp.g_varchar2_table(19486) := '746172744C696E654E756D6265727C7C742E636F6C756D6E213D3D652E7374617274436F6C756D6E7C7C6E2E6C696E654E756D626572213D3D652E656E644C696E654E756D6265727C7C6E2E636F6C756D6E213D3D652E656E64436F6C756D6E3F7B7374';
wwv_flow_imp.g_varchar2_table(19487) := '6172744C696E654E756D6265723A742E6C696E654E756D6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D3A657D5F7661';
wwv_flow_imp.g_varchar2_table(19488) := '6C6964617465506F736974696F6E2865297B696628216D632E697349506F736974696F6E286529297468726F77206E6577204572726F72282262616420706F736974696F6E22293B6C65747B6C696E654E756D6265723A742C636F6C756D6E3A6E7D3D65';
wwv_flow_imp.g_varchar2_table(19489) := '2C693D21313B696628743C3129743D312C6E3D312C693D21303B656C736520696628743E746869732E5F6C696E65732E6C656E67746829743D746869732E5F6C696E65732E6C656E6774682C6E3D746869732E5F6C696E65735B742D315D2E6C656E6774';
wwv_flow_imp.g_varchar2_table(19490) := '682B312C693D21303B656C73657B636F6E737420653D746869732E5F6C696E65735B742D315D2E6C656E6774682B313B6E3C313F286E3D312C693D2130293A6E3E652626286E3D652C693D2130297D72657475726E20693F7B6C696E654E756D6265723A';
wwv_flow_imp.g_varchar2_table(19491) := '742C636F6C756D6E3A6E7D3A657D7D636C617373204B487B636F6E7374727563746F7228652C74297B746869732E5F686F73743D652C746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C292C746869732E5F666F726569676E';
wwv_flow_imp.g_varchar2_table(19492) := '4D6F64756C65466163746F72793D742C746869732E5F666F726569676E4D6F64756C653D6E756C6C7D646973706F736528297B746869732E5F6D6F64656C733D4F626A6563742E637265617465286E756C6C297D5F6765744D6F64656C2865297B726574';
wwv_flow_imp.g_varchar2_table(19493) := '75726E20746869732E5F6D6F64656C735B655D7D5F6765744D6F64656C7328297B636F6E737420653D5B5D3B72657475726E204F626A6563742E6B65797328746869732E5F6D6F64656C73292E666F72456163682828743D3E652E707573682874686973';
wwv_flow_imp.g_varchar2_table(19494) := '2E5F6D6F64656C735B745D2929292C657D6163636570744E65774D6F64656C2865297B746869732E5F6D6F64656C735B652E75726C5D3D6E6577205548284E6F2E706172736528652E75726C292C652E6C696E65732C652E454F4C2C652E76657273696F';
wwv_flow_imp.g_varchar2_table(19495) := '6E4964297D6163636570744D6F64656C4368616E67656428652C74297B746869732E5F6D6F64656C735B655D2626746869732E5F6D6F64656C735B655D2E6F6E4576656E74732874297D61636365707452656D6F7665644D6F64656C2865297B74686973';
wwv_flow_imp.g_varchar2_table(19496) := '2E5F6D6F64656C735B655D262664656C65746520746869732E5F6D6F64656C735B655D7D6173796E6320636F6D70757465556E69636F6465486967686C696768747328652C742C6E297B636F6E737420693D746869732E5F6765744D6F64656C2865293B';
wwv_flow_imp.g_varchar2_table(19497) := '72657475726E20693F567A2E636F6D70757465556E69636F6465486967686C696768747328692C742C6E293A7B72616E6765733A5B5D2C6861734D6F72653A21312C616D626967756F7573436861726163746572436F756E743A302C696E76697369626C';
wwv_flow_imp.g_varchar2_table(19498) := '65436861726163746572436F756E743A302C6E6F6E42617369634173636969436861726163746572436F756E743A307D7D6173796E632066696E6453656374696F6E4865616465727328652C74297B636F6E7374206E3D746869732E5F6765744D6F6465';
wwv_flow_imp.g_varchar2_table(19499) := '6C2865293B72657475726E206E3F66756E6374696F6E28652C74297B766172206E3B6C657420693D5B5D3B696628742E66696E64526567696F6E53656374696F6E486561646572732626286E756C6C3D3D3D286E3D742E666F6C64696E6752756C657329';
wwv_flow_imp.g_varchar2_table(19500) := '7C7C766F696420303D3D3D6E3F766F696420303A6E2E6D61726B65727329297B636F6E7374206E3D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D2C693D652E6765744C696E65436F756E7428293B666F72286C6574206F3D313B6F3C3D69';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(19501) := '3B6F2B2B297B636F6E737420693D652E6765744C696E65436F6E74656E74286F292C733D692E6D6174636828742E666F6C64696E6752756C65732E6D61726B6572732E7374617274293B69662873297B636F6E737420653D7B73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(19502) := '6D6265723A6F2C7374617274436F6C756D6E3A735B305D2E6C656E6774682B312C656E644C696E654E756D6265723A6F2C656E64436F6C756D6E3A692E6C656E6774682B317D3B696628652E656E64436F6C756D6E3E652E7374617274436F6C756D6E29';
wwv_flow_imp.g_varchar2_table(19503) := '7B636F6E737420743D7B72616E67653A652C2E2E2E244828692E737562737472696E6728735B305D2E6C656E67746829292C73686F756C644265496E436F6D6D656E74733A21317D3B28742E746578747C7C742E686173536570617261746F724C696E65';
wwv_flow_imp.g_varchar2_table(19504) := '2926266E2E707573682874297D7D7D72657475726E206E7D28652C74293B693D692E636F6E636174286E297D696628742E66696E644D61726B53656374696F6E48656164657273297B636F6E737420743D66756E6374696F6E2865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(19505) := '3D5B5D2C6E3D652E6765744C696E65436F756E7428293B666F72286C657420693D313B693C3D6E3B692B2B29714828652E6765744C696E65436F6E74656E742869292C692C74293B72657475726E20747D2865293B693D692E636F6E6361742874297D72';
wwv_flow_imp.g_varchar2_table(19506) := '657475726E20697D286E2C74293A5B5D7D6173796E6320636F6D707574654469666628652C742C6E2C69297B636F6E7374206F3D746869732E5F6765744D6F64656C2865292C733D746869732E5F6765744D6F64656C2874293B72657475726E206F2626';
wwv_flow_imp.g_varchar2_table(19507) := '733F4B482E636F6D7075746544696666286F2C732C6E2C69293A6E756C6C7D73746174696320636F6D707574654469666628652C742C6E2C69297B636F6E7374206F3D22616476616E636564223D3D3D693F6E6577204E483A6E6577204A7A2C733D652E';
wwv_flow_imp.g_varchar2_table(19508) := '6765744C696E6573436F6E74656E7428292C723D742E6765744C696E6573436F6E74656E7428292C613D6F2E636F6D707574654469666628732C722C6E293B66756E6374696F6E206C2865297B72657475726E20652E6D61702828653D3E7B7661722074';
wwv_flow_imp.g_varchar2_table(19509) := '3B72657475726E5B652E6F726967696E616C2E73746172744C696E654E756D6265722C652E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6D6F6469666965642E73746172744C696E654E756D6265722C652E6D6F';
wwv_flow_imp.g_varchar2_table(19510) := '6469666965642E656E644C696E654E756D6265724578636C75736976652C6E756C6C3D3D3D28743D652E696E6E65724368616E676573297C7C766F696420303D3D3D743F766F696420303A742E6D61702828653D3E5B652E6F726967696E616C52616E67';
wwv_flow_imp.g_varchar2_table(19511) := '652E73746172744C696E654E756D6265722C652E6F726967696E616C52616E67652E7374617274436F6C756D6E2C652E6F726967696E616C52616E67652E656E644C696E654E756D6265722C652E6F726967696E616C52616E67652E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(19512) := '6E2C652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722C652E6D6F64696669656452616E67652E7374617274436F6C756D6E2C652E6D6F64696669656452616E67652E656E644C696E654E756D6265722C652E6D6F64696669';
wwv_flow_imp.g_varchar2_table(19513) := '656452616E67652E656E64436F6C756D6E5D29295D7D29297D72657475726E7B6964656E746963616C3A2128612E6368616E6765732E6C656E6774683E30292626746869732E5F6D6F64656C734172654964656E746963616C28652C74292C7175697445';
wwv_flow_imp.g_varchar2_table(19514) := '61726C793A612E68697454696D656F75742C6368616E6765733A6C28612E6368616E676573292C6D6F7665733A612E6D6F7665732E6D61702828653D3E5B652E6C696E6552616E67654D617070696E672E6F726967696E616C2E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(19515) := '756D6265722C652E6C696E6552616E67654D617070696E672E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19516) := '2C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652C6C28652E6368616E676573295D29297D7D737461746963205F6D6F64656C734172654964656E746963616C28652C7429';
wwv_flow_imp.g_varchar2_table(19517) := '7B636F6E7374206E3D652E6765744C696E65436F756E7428293B6966286E213D3D742E6765744C696E65436F756E7428292972657475726E21313B666F72286C657420693D313B693C3D6E3B692B2B29696628652E6765744C696E65436F6E74656E7428';
wwv_flow_imp.g_varchar2_table(19518) := '6929213D3D742E6765744C696E65436F6E74656E742869292972657475726E21313B72657475726E21307D6173796E6320636F6D707574654D6F72654D696E696D616C456469747328652C742C6E297B636F6E737420693D746869732E5F6765744D6F64';
wwv_flow_imp.g_varchar2_table(19519) := '656C2865293B69662821692972657475726E20743B636F6E7374206F3D5B5D3B6C657420733B743D742E736C6963652830292E736F7274282828652C74293D3E652E72616E67652626742E72616E67653F72682E636F6D7061726552616E676573557369';
wwv_flow_imp.g_varchar2_table(19520) := '6E6753746172747328652E72616E67652C742E72616E6765293A28652E72616E67653F303A31292D28742E72616E67653F303A312929293B6C657420723D303B666F72286C657420653D313B653C742E6C656E6774683B652B2B2972682E676574456E64';
wwv_flow_imp.g_varchar2_table(19521) := '506F736974696F6E28745B725D2E72616E6765292E657175616C732872682E6765745374617274506F736974696F6E28745B655D2E72616E676529293F28745B725D2E72616E67653D72682E66726F6D506F736974696F6E732872682E67657453746172';
wwv_flow_imp.g_varchar2_table(19522) := '74506F736974696F6E28745B725D2E72616E6765292C72682E676574456E64506F736974696F6E28745B655D2E72616E676529292C745B725D2E746578742B3D745B655D2E74657874293A28722B2B2C745B725D3D745B655D293B742E6C656E6774683D';
wwv_flow_imp.g_varchar2_table(19523) := '722B313B666F72286C65747B72616E67653A652C746578743A722C656F6C3A617D6F662074297B696628226E756D626572223D3D747970656F662061262628733D61292C72682E6973456D7074792865292626217229636F6E74696E75653B636F6E7374';
wwv_flow_imp.g_varchar2_table(19524) := '20743D692E67657456616C7565496E52616E67652865293B696628723D722E7265706C616365282F5C725C6E7C5C6E7C5C722F672C692E656F6C292C743D3D3D7229636F6E74696E75653B6966284D6174682E6D617828722E6C656E6774682C742E6C65';
wwv_flow_imp.g_varchar2_table(19525) := '6E677468293E4B482E5F646966664C696D6974297B6F2E70757368287B72616E67653A652C746578743A727D293B636F6E74696E75657D636F6E7374206C3D4E5628742C722C6E292C633D692E6F666673657441742872682E6C6966742865292E676574';
wwv_flow_imp.g_varchar2_table(19526) := '5374617274506F736974696F6E2829293B666F7228636F6E73742065206F66206C297B636F6E737420743D692E706F736974696F6E417428632B652E6F726967696E616C5374617274292C6E3D692E706F736974696F6E417428632B652E6F726967696E';
wwv_flow_imp.g_varchar2_table(19527) := '616C53746172742B652E6F726967696E616C4C656E677468292C733D7B746578743A722E73756273747228652E6D6F64696669656453746172742C652E6D6F6469666965644C656E677468292C72616E67653A7B73746172744C696E654E756D6265723A';
wwv_flow_imp.g_varchar2_table(19528) := '742E6C696E654E756D6265722C7374617274436F6C756D6E3A742E636F6C756D6E2C656E644C696E654E756D6265723A6E2E6C696E654E756D6265722C656E64436F6C756D6E3A6E2E636F6C756D6E7D7D3B692E67657456616C7565496E52616E676528';
wwv_flow_imp.g_varchar2_table(19529) := '732E72616E676529213D3D732E7465787426266F2E707573682873297D7D72657475726E226E756D626572223D3D747970656F66207326266F2E70757368287B656F6C3A732C746578743A22222C72616E67653A7B73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(19530) := '3A302C7374617274436F6C756D6E3A302C656E644C696E654E756D6265723A302C656E64436F6C756D6E3A307D7D292C6F7D6173796E6320636F6D707574654C696E6B732865297B636F6E737420743D746869732E5F6765744D6F64656C2865293B7265';
wwv_flow_imp.g_varchar2_table(19531) := '7475726E20743F66756E6374696F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F756E7426262266756E6374696F6E223D3D747970656F6620652E6765744C696E65436F6E74656E743F';
wwv_flow_imp.g_varchar2_table(19532) := '6A562E636F6D707574654C696E6B732865293A5B5D7D2874293A6E756C6C7D6173796E6320636F6D7075746544656661756C74446F63756D656E74436F6C6F72732865297B636F6E737420743D746869732E5F6765744D6F64656C2865293B7265747572';
wwv_flow_imp.g_varchar2_table(19533) := '6E20743F66756E6374696F6E2865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E67657456616C756526262266756E6374696F6E223D3D747970656F6620652E706F736974696F6E41743F66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(19534) := '7B636F6E737420743D5B5D2C6E3D484828652C2F5C62287267627C726762617C68736C7C68736C6129285C285B302D395C732C2E5C255D2A5C29297C282329285B412D46612D66302D395D7B337D295C627C282329285B412D46612D66302D395D7B347D';
wwv_flow_imp.g_varchar2_table(19535) := '295C627C282329285B412D46612D66302D395D7B367D295C627C282329285B412D46612D66302D395D7B387D295C622F676D293B6966286E2E6C656E6774683E3029666F7228636F6E73742069206F66206E297B636F6E7374206E3D692E66696C746572';
wwv_flow_imp.g_varchar2_table(19536) := '2828653D3E766F69642030213D3D6529292C6F3D6E5B315D2C733D6E5B325D3B696628217329636F6E74696E75653B6C657420723B69662822726762223D3D3D6F297B636F6E737420743D2F5E5C285C732A2832355B302D355D7C325B302D345D5B302D';
wwv_flow_imp.g_varchar2_table(19537) := '395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D';
wwv_flow_imp.g_varchar2_table(19538) := '7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A5C29242F676D3B723D564828464828652C69292C484828732C74292C2131297D656C7365206966282272676261223D3D3D6F297B636F6E7374';
wwv_flow_imp.g_varchar2_table(19539) := '20743D2F5E5C285C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D39';
wwv_flow_imp.g_varchar2_table(19540) := '5D5B302D395D7C5B302D395D295C732A2C5C732A2832355B302D355D7C325B302D345D5B302D395D7C315B302D395D7B327D7C5B312D395D5B302D395D7C5B302D395D295C732A2C5C732A28305B2E5D5B302D395D2B7C5B2E5D5B302D395D2B7C5B3031';
wwv_flow_imp.g_varchar2_table(19541) := '5D5B2E5D7C5B30315D295C732A5C29242F676D3B723D564828464828652C69292C484828732C74292C2130297D656C7365206966282268736C223D3D3D6F297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D395D7C5B31';
wwv_flow_imp.g_varchar2_table(19542) := '325D5B302D395D5B302D395D7C5B312D395D3F5B302D395D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A5C29';
wwv_flow_imp.g_varchar2_table(19543) := '242F676D3B723D7A4828464828652C69292C484828732C74292C2131297D656C7365206966282268736C61223D3D3D6F297B636F6E737420743D2F5E5C285C732A2833365B305D7C335B302D355D5B302D395D7C5B31325D5B302D395D5B302D395D7C5B';
wwv_flow_imp.g_varchar2_table(19544) := '312D395D3F5B302D395D295C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A283130307C5C647B312C327D5B2E5D5C642A7C5C647B312C327D29255C732A2C5C732A28305B2E5D5B302D395D2B7C';
wwv_flow_imp.g_varchar2_table(19545) := '5B2E5D5B302D395D2B7C5B30315D5B2E5D7C5B30315D295C732A5C29242F676D3B723D7A4828464828652C69292C484828732C74292C2130297D656C73652223223D3D3D6F262628723D424828464828652C69292C6F2B7329293B722626742E70757368';
wwv_flow_imp.g_varchar2_table(19546) := '2872297D72657475726E20747D2865293A5B5D7D2874293A6E756C6C7D6173796E63207465787475616C5375676765737428652C742C6E2C69297B636F6E7374206F3D6E65772066742C733D6E657720526567457870286E2C69292C723D6E6577205365';
wwv_flow_imp.g_varchar2_table(19547) := '743B653A666F7228636F6E7374206E206F662065297B636F6E737420653D746869732E5F6765744D6F64656C286E293B6966286529666F7228636F6E7374206E206F6620652E776F726473287329296966286E213D3D74262669734E614E284E756D6265';
wwv_flow_imp.g_varchar2_table(19548) := '72286E2929262628722E616464286E292C722E73697A653E4B482E5F73756767657374696F6E734C696D69742929627265616B20657D72657475726E7B776F7264733A41727261792E66726F6D2872292C6475726174696F6E3A6F2E656C617073656428';
wwv_flow_imp.g_varchar2_table(19549) := '297D7D6173796E6320636F6D70757465576F726452616E67657328652C742C6E2C69297B636F6E7374206F3D746869732E5F6765744D6F64656C2865293B696628216F2972657475726E204F626A6563742E637265617465286E756C6C293B636F6E7374';
wwv_flow_imp.g_varchar2_table(19550) := '20733D6E657720526567457870286E2C69292C723D4F626A6563742E637265617465286E756C6C293B666F72286C657420653D742E73746172744C696E654E756D6265723B653C742E656E644C696E654E756D6265723B652B2B297B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(19551) := '6F2E6765744C696E65576F72647328652C73293B666F7228636F6E7374206E206F662074297B6966282169734E614E284E756D626572286E2E776F7264292929636F6E74696E75653B6C657420743D725B6E2E776F72645D3B747C7C28743D5B5D2C725B';
wwv_flow_imp.g_varchar2_table(19552) := '6E2E776F72645D3D74292C742E70757368287B73746172744C696E654E756D6265723A652C7374617274436F6C756D6E3A6E2E7374617274436F6C756D6E2C656E644C696E654E756D6265723A652C656E64436F6C756D6E3A6E2E656E64436F6C756D6E';
wwv_flow_imp.g_varchar2_table(19553) := '7D297D7D72657475726E20727D6173796E63206E6176696761746556616C756553657428652C742C6E2C692C6F297B636F6E737420733D746869732E5F6765744D6F64656C2865293B69662821732972657475726E206E756C6C3B636F6E737420723D6E';
wwv_flow_imp.g_varchar2_table(19554) := '65772052656745787028692C6F293B742E7374617274436F6C756D6E3D3D3D742E656E64436F6C756D6E262628743D7B73746172744C696E654E756D6265723A742E73746172744C696E654E756D6265722C7374617274436F6C756D6E3A742E73746172';
wwv_flow_imp.g_varchar2_table(19555) := '74436F6C756D6E2C656E644C696E654E756D6265723A742E656E644C696E654E756D6265722C656E64436F6C756D6E3A742E656E64436F6C756D6E2B317D293B636F6E737420613D732E67657456616C7565496E52616E67652874292C6C3D732E676574';
wwv_flow_imp.g_varchar2_table(19556) := '576F72644174506F736974696F6E287B6C696E654E756D6265723A742E73746172744C696E654E756D6265722C636F6C756D6E3A742E7374617274436F6C756D6E7D2C72293B696628216C2972657475726E206E756C6C3B636F6E737420633D732E6765';
wwv_flow_imp.g_varchar2_table(19557) := '7456616C7565496E52616E6765286C293B72657475726E2071562E494E5354414E43452E6E6176696761746556616C756553657428742C612C6C2C632C6E297D6C6F6164466F726569676E4D6F64756C6528652C742C6E297B636F6E737420693D66756E';
wwv_flow_imp.g_varchar2_table(19558) := '6374696F6E28652C74297B636F6E7374206E3D653D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30293B72657475726E207428652C6E297D2C693D7B7D';
wwv_flow_imp.g_varchar2_table(19559) := '3B666F7228636F6E73742074206F66206529695B745D3D6E2874293B72657475726E20697D286E2C2828652C74293D3E746869732E5F686F73742E66687228652C742929292C6F3D7B686F73743A692C6765744D6972726F724D6F64656C733A28293D3E';
wwv_flow_imp.g_varchar2_table(19560) := '746869732E5F6765744D6F64656C7328297D3B72657475726E20746869732E5F666F726569676E4D6F64756C65466163746F72793F28746869732E5F666F726569676E4D6F64756C653D746869732E5F666F726569676E4D6F64756C65466163746F7279';
wwv_flow_imp.g_varchar2_table(19561) := '286F2C74292C50726F6D6973652E7265736F6C766528436828746869732E5F666F726569676E4D6F64756C652929293A50726F6D6973652E72656A656374286E6577204572726F722822556E65787065637465642075736167652229297D666D7228652C';
wwv_flow_imp.g_varchar2_table(19562) := '74297B69662821746869732E5F666F726569676E4D6F64756C657C7C2266756E6374696F6E22213D747970656F6620746869732E5F666F726569676E4D6F64756C655B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F';
wwv_flow_imp.g_varchar2_table(19563) := '7228224D697373696E67207265717565737448616E646C6572206F72206D6574686F643A20222B6529293B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F666F726569676E4D6F64756C655B655D2E6170706C792874';
wwv_flow_imp.g_varchar2_table(19564) := '6869732E5F666F726569676E4D6F64756C652C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D7D4B482E5F646966664C696D69743D3165352C4B482E5F73756767657374696F6E734C696D69743D3165';
wwv_flow_imp.g_varchar2_table(19565) := '342C2266756E6374696F6E223D3D747970656F6620696D706F727453637269707473262628676C6F62616C546869732E6D6F6E61636F3D427A2829293B636F6E73742047483D70632822746578745265736F75726365436F6E66696775726174696F6E53';
wwv_flow_imp.g_varchar2_table(19566) := '65727669636522292C51483D70632822746578745265736F7572636550726F706572746965735365727669636522293B7661722059483D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D';
wwv_flow_imp.g_varchar2_table(19567) := '3B66756E6374696F6E205A4828652C74297B636F6E7374206E3D652E6765744D6F64656C2874293B72657475726E21216E2626216E2E6973546F6F4C61726765466F7253796E63696E6728297D6C65742058483D636C61737320657874656E6473206C74';
wwv_flow_imp.g_varchar2_table(19568) := '7B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E5F6D6F64656C536572766963653D652C746869732E5F776F726B65724D616E616765723D746869732E5F7265676973746572286E657720655728746869732E';
wwv_flow_imp.g_varchar2_table(19569) := '5F6D6F64656C536572766963652C6929292C746869732E5F6C6F67536572766963653D6E2C746869732E5F7265676973746572286F2E6C696E6B50726F76696465722E7265676973746572287B6C616E67756167653A222A222C68617341636365737354';
wwv_flow_imp.g_varchar2_table(19570) := '6F416C6C4D6F64656C733A21307D2C7B70726F766964654C696E6B733A28652C74293D3E5A4828746869732E5F6D6F64656C536572766963652C652E757269293F746869732E5F776F726B65724D616E616765722E77697468576F726B657228292E7468';
wwv_flow_imp.g_varchar2_table(19571) := '656E2828743D3E742E636F6D707574654C696E6B7328652E7572692929292E7468656E2828653D3E6526267B6C696E6B733A657D29293A50726F6D6973652E7265736F6C7665287B6C696E6B733A5B5D7D297D29292C746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(19572) := '286F2E636F6D706C6574696F6E50726F76696465722E726567697374657228222A222C6E6577204A4828746869732E5F776F726B65724D616E616765722C742C746869732E5F6D6F64656C536572766963652C692929297D646973706F736528297B7375';
wwv_flow_imp.g_varchar2_table(19573) := '7065722E646973706F736528297D63616E436F6D70757465556E69636F6465486967686C69676874732865297B72657475726E205A4828746869732E5F6D6F64656C536572766963652C65297D636F6D7075746564556E69636F6465486967686C696768';
wwv_flow_imp.g_varchar2_table(19574) := '747328652C742C6E297B72657475726E20746869732E5F776F726B65724D616E616765722E77697468576F726B657228292E7468656E2828693D3E692E636F6D7075746564556E69636F6465486967686C696768747328652C742C6E2929297D6173796E';
wwv_flow_imp.g_varchar2_table(19575) := '6320636F6D707574654469666628652C742C6E2C69297B636F6E7374206F3D617761697420746869732E5F776F726B65724D616E616765722E77697468576F726B657228292E7468656E28286F3D3E6F2E636F6D707574654469666628652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(19576) := '2929293B72657475726E206F3F7B6964656E746963616C3A6F2E6964656E746963616C2C717569744561726C793A6F2E717569744561726C792C6368616E6765733A73286F2E6368616E676573292C6D6F7665733A6F2E6D6F7665732E6D61702828653D';
wwv_flow_imp.g_varchar2_table(19577) := '3E6E6577206A7A286E657720597A286E657720787528655B305D2C655B315D292C6E657720787528655B325D2C655B335D29292C7328655B345D292929297D3A6E756C6C3B66756E6374696F6E20732865297B72657475726E20652E6D61702828653D3E';
wwv_flow_imp.g_varchar2_table(19578) := '7B76617220743B72657475726E206E6577205A7A286E657720787528655B305D2C655B315D292C6E657720787528655B325D2C655B335D292C6E756C6C3D3D3D28743D655B345D297C7C766F696420303D3D3D743F766F696420303A742E6D6170282865';
wwv_flow_imp.g_varchar2_table(19579) := '3D3E6E657720587A286E657720726828655B305D2C655B315D2C655B325D2C655B335D292C6E657720726828655B345D2C655B355D2C655B365D2C655B375D29292929297D29297D7D636F6D707574654D6F72654D696E696D616C456469747328652C74';
wwv_flow_imp.g_varchar2_table(19580) := '2C6E3D2131297B6966286A68287429297B696628215A4828746869732E5F6D6F64656C536572766963652C65292972657475726E2050726F6D6973652E7265736F6C76652874293B636F6E737420693D66742E63726561746528292C6F3D746869732E5F';
wwv_flow_imp.g_varchar2_table(19581) := '776F726B65724D616E616765722E77697468576F726B657228292E7468656E2828693D3E692E636F6D707574654D6F72654D696E696D616C456469747328652C742C6E2929293B72657475726E206F2E66696E616C6C79282828293D3E746869732E5F6C';
wwv_flow_imp.g_varchar2_table(19582) := '6F67536572766963652E74726163652822464F524D415423636F6D707574654D6F72654D696E696D616C4564697473222C652E746F537472696E67282130292C692E656C617073656428292929292C50726F6D6973652E72616365285B6F2C5774283165';
wwv_flow_imp.g_varchar2_table(19583) := '33292E7468656E282828293D3E7429295D297D72657475726E2050726F6D6973652E7265736F6C766528766F69642030297D63616E4E6176696761746556616C75655365742865297B72657475726E205A4828746869732E5F6D6F64656C536572766963';
wwv_flow_imp.g_varchar2_table(19584) := '652C65297D6E6176696761746556616C756553657428652C742C6E297B72657475726E20746869732E5F776F726B65724D616E616765722E77697468576F726B657228292E7468656E2828693D3E692E6E6176696761746556616C756553657428652C74';
wwv_flow_imp.g_varchar2_table(19585) := '2C6E2929297D63616E436F6D70757465576F726452616E6765732865297B72657475726E205A4828746869732E5F6D6F64656C536572766963652C65297D636F6D70757465576F726452616E67657328652C74297B72657475726E20746869732E5F776F';
wwv_flow_imp.g_varchar2_table(19586) := '726B65724D616E616765722E77697468576F726B657228292E7468656E28286E3D3E6E2E636F6D70757465576F726452616E67657328652C742929297D66696E6453656374696F6E4865616465727328652C74297B72657475726E20746869732E5F776F';
wwv_flow_imp.g_varchar2_table(19587) := '726B65724D616E616765722E77697468576F726B657228292E7468656E28286E3D3E6E2E66696E6453656374696F6E4865616465727328652C742929297D7D3B58483D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E';
wwv_flow_imp.g_varchar2_table(19588) := '74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C6563742626226675';
wwv_flow_imp.g_varchar2_table(19589) := '6E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D65';
wwv_flow_imp.g_varchar2_table(19590) := '5B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B594828302C666329';
wwv_flow_imp.g_varchar2_table(19591) := '2C594828312C4748292C594828322C5264292C594828332C6567292C594828342C7878295D2C5848293B636C617373204A487B636F6E7374727563746F7228652C742C6E2C69297B746869732E6C616E6775616765436F6E66696775726174696F6E5365';
wwv_flow_imp.g_varchar2_table(19592) := '72766963653D692C746869732E5F6465627567446973706C61794E616D653D22776F72646261736564436F6D706C6574696F6E73222C746869732E5F776F726B65724D616E616765723D652C746869732E5F636F6E66696775726174696F6E5365727669';
wwv_flow_imp.g_varchar2_table(19593) := '63653D742C746869732E5F6D6F64656C536572766963653D6E7D6173796E632070726F76696465436F6D706C6574696F6E4974656D7328652C74297B636F6E7374206E3D746869732E5F636F6E66696775726174696F6E536572766963652E6765745661';
wwv_flow_imp.g_varchar2_table(19594) := '6C756528652E7572692C742C22656469746F7222293B696628226F6666223D3D3D6E2E776F7264426173656453756767657374696F6E732972657475726E3B636F6E737420693D5B5D3B6966282263757272656E74446F63756D656E74223D3D3D6E2E77';
wwv_flow_imp.g_varchar2_table(19595) := '6F7264426173656453756767657374696F6E73295A4828746869732E5F6D6F64656C536572766963652C652E757269292626692E7075736828652E757269293B656C736520666F7228636F6E73742074206F6620746869732E5F6D6F64656C5365727669';
wwv_flow_imp.g_varchar2_table(19596) := '63652E6765744D6F64656C732829295A4828746869732E5F6D6F64656C536572766963652C742E75726929262628743D3D3D653F692E756E736869667428742E757269293A22616C6C446F63756D656E747322213D3D6E2E776F72644261736564537567';
wwv_flow_imp.g_varchar2_table(19597) := '67657374696F6E732626742E6765744C616E677561676549642829213D3D652E6765744C616E6775616765496428297C7C692E7075736828742E75726929293B696628303D3D3D692E6C656E6774682972657475726E3B636F6E7374206F3D746869732E';
wwv_flow_imp.g_varchar2_table(19598) := '6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28652E6765744C616E677561676549642829292E676574576F7264446566696E6974696F6E28292C733D652E676574';
wwv_flow_imp.g_varchar2_table(19599) := '576F72644174506F736974696F6E2874292C723D733F6E657720726828742E6C696E654E756D6265722C732E7374617274436F6C756D6E2C742E6C696E654E756D6265722C732E656E64436F6C756D6E293A72682E66726F6D506F736974696F6E732874';
wwv_flow_imp.g_varchar2_table(19600) := '292C613D722E736574456E64506F736974696F6E28742E6C696E654E756D6265722C742E636F6C756D6E292C6C3D617761697420746869732E5F776F726B65724D616E616765722E77697468576F726B657228292C633D6177616974206C2E7465787475';
wwv_flow_imp.g_varchar2_table(19601) := '616C5375676765737428692C6E756C6C3D3D733F766F696420303A732E776F72642C6F293B72657475726E20633F7B6475726174696F6E3A632E6475726174696F6E2C73756767657374696F6E733A632E776F7264732E6D61702828653D3E287B6B696E';
wwv_flow_imp.g_varchar2_table(19602) := '643A31382C6C6162656C3A652C696E73657274546578743A652C72616E67653A7B696E736572743A612C7265706C6163653A727D7D2929297D3A766F696420307D7D636C61737320655720657874656E6473206C747B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(19603) := '74297B737570657228292C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E5F6D6F64656C536572766963653D652C746869732E5F656469746F72576F726B6572436C69656E743D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(19604) := '69732E5F6C617374576F726B65725573656454696D653D286E65772044617465292E67657454696D6528292C746869732E5F7265676973746572286E6577206B73292E63616E63656C416E64536574282828293D3E746869732E5F636865636B53746F70';
wwv_flow_imp.g_varchar2_table(19605) := '49646C65576F726B65722829292C4D6174682E726F756E642831356534292C73292C746869732E5F726567697374657228746869732E5F6D6F64656C536572766963652E6F6E4D6F64656C52656D6F7665642828653D3E746869732E5F636865636B5374';
wwv_flow_imp.g_varchar2_table(19606) := '6F70456D707479576F726B657228292929297D646973706F736528297B746869732E5F656469746F72576F726B6572436C69656E74262628746869732E5F656469746F72576F726B6572436C69656E742E646973706F736528292C746869732E5F656469';
wwv_flow_imp.g_varchar2_table(19607) := '746F72576F726B6572436C69656E743D6E756C6C292C73757065722E646973706F736528297D5F636865636B53746F70456D707479576F726B657228297B746869732E5F656469746F72576F726B6572436C69656E742626303D3D3D746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(19608) := '64656C536572766963652E6765744D6F64656C7328292E6C656E677468262628746869732E5F656469746F72576F726B6572436C69656E742E646973706F736528292C746869732E5F656469746F72576F726B6572436C69656E743D6E756C6C297D5F63';
wwv_flow_imp.g_varchar2_table(19609) := '6865636B53746F7049646C65576F726B657228297B746869732E5F656469746F72576F726B6572436C69656E742626286E65772044617465292E67657454696D6528292D746869732E5F6C617374576F726B65725573656454696D653E33653526262874';
wwv_flow_imp.g_varchar2_table(19610) := '6869732E5F656469746F72576F726B6572436C69656E742E646973706F736528292C746869732E5F656469746F72576F726B6572436C69656E743D6E756C6C297D77697468576F726B657228297B72657475726E20746869732E5F6C617374576F726B65';
wwv_flow_imp.g_varchar2_table(19611) := '725573656454696D653D286E65772044617465292E67657454696D6528292C746869732E5F656469746F72576F726B6572436C69656E747C7C28746869732E5F656469746F72576F726B6572436C69656E743D6E6577206F5728746869732E5F6D6F6465';
wwv_flow_imp.g_varchar2_table(19612) := '6C536572766963652C21312C22656469746F72576F726B657253657276696365222C746869732E6C616E6775616765436F6E66696775726174696F6E5365727669636529292C50726F6D6973652E7265736F6C766528746869732E5F656469746F72576F';
wwv_flow_imp.g_varchar2_table(19613) := '726B6572436C69656E74297D7D636C61737320745720657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B696628737570657228292C746869732E5F73796E6365644D6F64656C733D4F626A6563742E637265617465286E756C6C';
wwv_flow_imp.g_varchar2_table(19614) := '292C746869732E5F73796E6365644D6F64656C734C6173745573656454696D653D4F626A6563742E637265617465286E756C6C292C746869732E5F70726F78793D652C746869732E5F6D6F64656C536572766963653D742C216E297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(19615) := '6E65772055743B652E63616E63656C416E64536574282828293D3E746869732E5F636865636B53746F704D6F64656C53796E632829292C4D6174682E726F756E642833653429292C746869732E5F72656769737465722865297D7D646973706F73652829';
wwv_flow_imp.g_varchar2_table(19616) := '7B666F7228636F6E7374206520696E20746869732E5F73796E6365644D6F64656C73296F7428746869732E5F73796E6365644D6F64656C735B655D293B746869732E5F73796E6365644D6F64656C733D4F626A6563742E637265617465286E756C6C292C';
wwv_flow_imp.g_varchar2_table(19617) := '746869732E5F73796E6365644D6F64656C734C6173745573656454696D653D4F626A6563742E637265617465286E756C6C292C73757065722E646973706F736528297D656E7375726553796E6365645265736F757263657328652C74297B666F7228636F';
wwv_flow_imp.g_varchar2_table(19618) := '6E7374206E206F662065297B636F6E737420653D6E2E746F537472696E6728293B746869732E5F73796E6365644D6F64656C735B655D7C7C746869732E5F626567696E4D6F64656C53796E63286E2C74292C746869732E5F73796E6365644D6F64656C73';
wwv_flow_imp.g_varchar2_table(19619) := '5B655D262628746869732E5F73796E6365644D6F64656C734C6173745573656454696D655B655D3D286E65772044617465292E67657454696D652829297D7D5F636865636B53746F704D6F64656C53796E6328297B636F6E737420653D286E6577204461';
wwv_flow_imp.g_varchar2_table(19620) := '7465292E67657454696D6528292C743D5B5D3B666F7228636F6E7374206E20696E20746869732E5F73796E6365644D6F64656C734C6173745573656454696D6529652D746869732E5F73796E6365644D6F64656C734C6173745573656454696D655B6E5D';
wwv_flow_imp.g_varchar2_table(19621) := '3E3665342626742E70757368286E293B666F7228636F6E73742065206F66207429746869732E5F73746F704D6F64656C53796E632865297D5F626567696E4D6F64656C53796E6328652C74297B636F6E7374206E3D746869732E5F6D6F64656C53657276';
wwv_flow_imp.g_varchar2_table(19622) := '6963652E6765744D6F64656C2865293B696628216E2972657475726E3B696628217426266E2E6973546F6F4C61726765466F7253796E63696E6728292972657475726E3B636F6E737420693D652E746F537472696E6728293B746869732E5F70726F7879';
wwv_flow_imp.g_varchar2_table(19623) := '2E6163636570744E65774D6F64656C287B75726C3A6E2E7572692E746F537472696E6728292C6C696E65733A6E2E6765744C696E6573436F6E74656E7428292C454F4C3A6E2E676574454F4C28292C76657273696F6E49643A6E2E67657456657273696F';
wwv_flow_imp.g_varchar2_table(19624) := '6E496428297D293B636F6E7374206F3D6E65772061743B6F2E616464286E2E6F6E4469644368616E6765436F6E74656E742828653D3E7B746869732E5F70726F78792E6163636570744D6F64656C4368616E67656428692E746F537472696E6728292C65';
wwv_flow_imp.g_varchar2_table(19625) := '297D2929292C6F2E616464286E2E6F6E57696C6C446973706F7365282828293D3E7B746869732E5F73746F704D6F64656C53796E632869297D2929292C6F2E616464287274282828293D3E7B746869732E5F70726F78792E61636365707452656D6F7665';
wwv_flow_imp.g_varchar2_table(19626) := '644D6F64656C2869297D2929292C746869732E5F73796E6365644D6F64656C735B695D3D6F7D5F73746F704D6F64656C53796E632865297B636F6E737420743D746869732E5F73796E6365644D6F64656C735B655D3B64656C65746520746869732E5F73';
wwv_flow_imp.g_varchar2_table(19627) := '796E6365644D6F64656C735B655D2C64656C65746520746869732E5F73796E6365644D6F64656C734C6173745573656454696D655B655D2C6F742874297D7D636C617373206E577B636F6E7374727563746F722865297B746869732E5F696E7374616E63';
wwv_flow_imp.g_varchar2_table(19628) := '653D652C746869732E5F70726F78794F626A3D50726F6D6973652E7265736F6C766528746869732E5F696E7374616E6365297D646973706F736528297B746869732E5F696E7374616E63652E646973706F736528297D67657450726F78794F626A656374';
wwv_flow_imp.g_varchar2_table(19629) := '28297B72657475726E20746869732E5F70726F78794F626A7D7D636C6173732069577B636F6E7374727563746F722865297B746869732E5F776F726B6572436C69656E743D657D66687228652C74297B72657475726E20746869732E5F776F726B657243';
wwv_flow_imp.g_varchar2_table(19630) := '6C69656E742E66687228652C74297D7D636C617373206F5720657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D69';
wwv_flow_imp.g_varchar2_table(19631) := '2C746869732E5F646973706F7365643D21312C746869732E5F6D6F64656C536572766963653D652C746869732E5F6B65657049646C654D6F64656C733D742C746869732E5F776F726B6572466163746F72793D6E6577204956286E292C746869732E5F77';
wwv_flow_imp.g_varchar2_table(19632) := '6F726B65723D6E756C6C2C746869732E5F6D6F64656C4D616E616765723D6E756C6C7D66687228652C74297B7468726F77206E6577204572726F7228224E6F7420696D706C656D656E7465642122297D5F6765744F72437265617465576F726B65722829';
wwv_flow_imp.g_varchar2_table(19633) := '7B69662821746869732E5F776F726B6572297472797B746869732E5F776F726B65723D746869732E5F7265676973746572286E6577206B5628746869732E5F776F726B6572466163746F72792C2276732F656469746F722F636F6D6D6F6E2F7365727669';
wwv_flow_imp.g_varchar2_table(19634) := '6365732F656469746F7253696D706C65576F726B6572222C6E657720695728746869732929297D63617463682865297B62562865292C746869732E5F776F726B65723D6E6577206E57286E6577204B48286E65772069572874686973292C6E756C6C2929';
wwv_flow_imp.g_varchar2_table(19635) := '7D72657475726E20746869732E5F776F726B65727D5F67657450726F787928297B72657475726E20746869732E5F6765744F72437265617465576F726B657228292E67657450726F78794F626A65637428292E7468656E28766F696420302C28653D3E28';
wwv_flow_imp.g_varchar2_table(19636) := '62562865292C746869732E5F776F726B65723D6E6577206E57286E6577204B48286E65772069572874686973292C6E756C6C29292C746869732E5F6765744F72437265617465576F726B657228292E67657450726F78794F626A65637428292929297D5F';
wwv_flow_imp.g_varchar2_table(19637) := '6765744F724372656174654D6F64656C4D616E616765722865297B72657475726E20746869732E5F6D6F64656C4D616E616765727C7C28746869732E5F6D6F64656C4D616E616765723D746869732E5F7265676973746572286E657720745728652C7468';
wwv_flow_imp.g_varchar2_table(19638) := '69732E5F6D6F64656C536572766963652C746869732E5F6B65657049646C654D6F64656C732929292C746869732E5F6D6F64656C4D616E616765727D6173796E63205F7769746853796E6365645265736F757263657328652C743D2131297B7265747572';
wwv_flow_imp.g_varchar2_table(19639) := '6E20746869732E5F646973706F7365643F50726F6D6973652E72656A6563742866756E6374696F6E28297B636F6E737420653D6E6577204572726F72284465293B72657475726E20652E6E616D653D652E6D6573736167652C657D2829293A746869732E';
wwv_flow_imp.g_varchar2_table(19640) := '5F67657450726F787928292E7468656E28286E3D3E28746869732E5F6765744F724372656174654D6F64656C4D616E61676572286E292E656E7375726553796E6365645265736F757263657328652C74292C6E2929297D636F6D7075746564556E69636F';
wwv_flow_imp.g_varchar2_table(19641) := '6465486967686C696768747328652C742C6E297B72657475726E20746869732E5F7769746853796E6365645265736F7572636573285B655D292E7468656E2828693D3E692E636F6D70757465556E69636F6465486967686C696768747328652E746F5374';
wwv_flow_imp.g_varchar2_table(19642) := '72696E6728292C742C6E2929297D636F6D707574654469666628652C742C6E2C69297B72657475726E20746869732E5F7769746853796E6365645265736F7572636573285B652C745D2C2130292E7468656E28286F3D3E6F2E636F6D7075746544696666';
wwv_flow_imp.g_varchar2_table(19643) := '28652E746F537472696E6728292C742E746F537472696E6728292C6E2C692929297D636F6D707574654D6F72654D696E696D616C456469747328652C742C6E297B72657475726E20746869732E5F7769746853796E6365645265736F7572636573285B65';
wwv_flow_imp.g_varchar2_table(19644) := '5D292E7468656E2828693D3E692E636F6D707574654D6F72654D696E696D616C456469747328652E746F537472696E6728292C742C6E2929297D636F6D707574654C696E6B732865297B72657475726E20746869732E5F7769746853796E636564526573';
wwv_flow_imp.g_varchar2_table(19645) := '6F7572636573285B655D292E7468656E2828743D3E742E636F6D707574654C696E6B7328652E746F537472696E6728292929297D636F6D7075746544656661756C74446F63756D656E74436F6C6F72732865297B72657475726E20746869732E5F776974';
wwv_flow_imp.g_varchar2_table(19646) := '6853796E6365645265736F7572636573285B655D292E7468656E2828743D3E742E636F6D7075746544656661756C74446F63756D656E74436F6C6F727328652E746F537472696E6728292929297D6173796E63207465787475616C537567676573742865';
wwv_flow_imp.g_varchar2_table(19647) := '2C742C6E297B636F6E737420693D617761697420746869732E5F7769746853796E6365645265736F75726365732865292C6F3D6E2E736F757263652C733D6E2E666C6167733B72657475726E20692E7465787475616C5375676765737428652E6D617028';
wwv_flow_imp.g_varchar2_table(19648) := '28653D3E652E746F537472696E67282929292C742C6F2C73297D636F6D70757465576F726452616E67657328652C74297B72657475726E20746869732E5F7769746853796E6365645265736F7572636573285B655D292E7468656E28286E3D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(19649) := '737420693D746869732E5F6D6F64656C536572766963652E6765744D6F64656C2865293B69662821692972657475726E2050726F6D6973652E7265736F6C7665286E756C6C293B636F6E7374206F3D746869732E6C616E6775616765436F6E6669677572';
wwv_flow_imp.g_varchar2_table(19650) := '6174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28692E6765744C616E677561676549642829292E676574576F7264446566696E6974696F6E28292C733D6F2E736F757263652C723D6F2E666C6167733B7265';
wwv_flow_imp.g_varchar2_table(19651) := '7475726E206E2E636F6D70757465576F726452616E67657328652E746F537472696E6728292C742C732C72297D29297D6E6176696761746556616C756553657428652C742C6E297B72657475726E20746869732E5F7769746853796E6365645265736F75';
wwv_flow_imp.g_varchar2_table(19652) := '72636573285B655D292E7468656E2828693D3E7B636F6E7374206F3D746869732E5F6D6F64656C536572766963652E6765744D6F64656C2865293B696628216F2972657475726E206E756C6C3B636F6E737420733D746869732E6C616E6775616765436F';
wwv_flow_imp.g_varchar2_table(19653) := '6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F2E6765744C616E677561676549642829292E676574576F7264446566696E6974696F6E28292C723D732E736F757263652C613D732E666C';
wwv_flow_imp.g_varchar2_table(19654) := '6167733B72657475726E20692E6E6176696761746556616C756553657428652E746F537472696E6728292C742C6E2C722C61297D29297D66696E6453656374696F6E4865616465727328652C74297B72657475726E20746869732E5F7769746853796E63';
wwv_flow_imp.g_varchar2_table(19655) := '65645265736F7572636573285B655D292E7468656E28286E3D3E6E2E66696E6453656374696F6E4865616465727328652E746F537472696E6728292C742929297D646973706F736528297B73757065722E646973706F736528292C746869732E5F646973';
wwv_flow_imp.g_varchar2_table(19656) := '706F7365643D21307D7D636F6E73742073573D5B5D3B66756E6374696F6E2072572865297B73572E707573682865297D66756E6374696F6E20615728297B72657475726E2073572E736C6963652830297D766172206C573D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(19657) := '297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732063577B636F6E7374727563746F7228652C74297B746869732E5F656469746F72576F726B6572436C69656E743D6E6577206F5728652C21312C226564';
wwv_flow_imp.g_varchar2_table(19658) := '69746F72576F726B657253657276696365222C74297D6173796E632070726F76696465446F63756D656E74436F6C6F727328652C74297B72657475726E20746869732E5F656469746F72576F726B6572436C69656E742E636F6D7075746544656661756C';
wwv_flow_imp.g_varchar2_table(19659) := '74446F63756D656E74436F6C6F727328652E757269297D70726F76696465436F6C6F7250726573656E746174696F6E7328652C742C6E297B636F6E737420693D742E72616E67652C6F3D742E636F6C6F722C733D6F2E616C7068612C723D6E6577206875';
wwv_flow_imp.g_varchar2_table(19660) := '286E6577206C75284D6174682E726F756E64283235352A6F2E726564292C4D6174682E726F756E64283235352A6F2E677265656E292C4D6174682E726F756E64283235352A6F2E626C7565292C7329292C613D733F68752E466F726D61742E4353532E66';
wwv_flow_imp.g_varchar2_table(19661) := '6F726D61745247422872293A68752E466F726D61742E4353532E666F726D6174524742412872292C6C3D733F68752E466F726D61742E4353532E666F726D617448534C2872293A68752E466F726D61742E4353532E666F726D617448534C412872292C63';
wwv_flow_imp.g_varchar2_table(19662) := '3D733F68752E466F726D61742E4353532E666F726D61744865782872293A68752E466F726D61742E4353532E666F726D6174486578412872292C643D5B5D3B72657475726E20642E70757368287B6C6162656C3A612C74657874456469743A7B72616E67';
wwv_flow_imp.g_varchar2_table(19663) := '653A692C746578743A617D7D292C642E70757368287B6C6162656C3A6C2C74657874456469743A7B72616E67653A692C746578743A6C7D7D292C642E70757368287B6C6162656C3A632C74657874456469743A7B72616E67653A692C746578743A637D7D';
wwv_flow_imp.g_varchar2_table(19664) := '292C647D7D6C65742064573D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F7265676973746572286E2E636F6C6F7250726F76696465722E726567697374657228222A222C';
wwv_flow_imp.g_varchar2_table(19665) := '6E657720635728652C742929297D7D3B6173796E632066756E6374696F6E20685728652C742C6E2C693D2130297B72657475726E206657286E65772070572C652C742C6E2C69297D66756E6374696F6E20755728652C742C6E2C69297B72657475726E20';
wwv_flow_imp.g_varchar2_table(19666) := '50726F6D6973652E7265736F6C7665286E2E70726F76696465436F6C6F7250726573656E746174696F6E7328652C742C6929297D64573D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D';
wwv_flow_imp.g_varchar2_table(19667) := '733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970';
wwv_flow_imp.g_varchar2_table(19668) := '656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C';
wwv_flow_imp.g_varchar2_table(19669) := '333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6C5728302C6663292C6C5728312C6567292C6C57';
wwv_flow_imp.g_varchar2_table(19670) := '28322C7878295D2C6457292C7257286457293B636C6173732070577B636F6E7374727563746F7228297B7D6173796E6320636F6D7075746528652C742C6E2C69297B636F6E7374206F3D617761697420652E70726F76696465446F63756D656E74436F6C';
wwv_flow_imp.g_varchar2_table(19671) := '6F727328742C6E293B69662841727261792E69734172726179286F2929666F7228636F6E73742074206F66206F29692E70757368287B636F6C6F72496E666F3A742C70726F76696465723A657D293B72657475726E2041727261792E6973417272617928';
wwv_flow_imp.g_varchar2_table(19672) := '6F297D7D636C6173732067577B636F6E7374727563746F7228297B7D6173796E6320636F6D7075746528652C742C6E2C69297B636F6E7374206F3D617761697420652E70726F76696465446F63756D656E74436F6C6F727328742C6E293B696628417272';
wwv_flow_imp.g_varchar2_table(19673) := '61792E69734172726179286F2929666F7228636F6E73742065206F66206F29692E70757368287B72616E67653A652E72616E67652C636F6C6F723A5B652E636F6C6F722E7265642C652E636F6C6F722E677265656E2C652E636F6C6F722E626C75652C65';
wwv_flow_imp.g_varchar2_table(19674) := '2E636F6C6F722E616C7068615D7D293B72657475726E2041727261792E69734172726179286F297D7D636C617373206D577B636F6E7374727563746F722865297B746869732E636F6C6F72496E666F3D657D6173796E6320636F6D7075746528652C742C';
wwv_flow_imp.g_varchar2_table(19675) := '6E2C69297B636F6E7374206F3D617761697420652E70726F76696465436F6C6F7250726573656E746174696F6E7328742C746869732E636F6C6F72496E666F2C4D742E4E6F6E65293B72657475726E2041727261792E69734172726179286F292626692E';
wwv_flow_imp.g_varchar2_table(19676) := '70757368282E2E2E6F292C41727261792E69734172726179286F297D7D6173796E632066756E6374696F6E20665728652C742C6E2C692C6F297B6C657420732C723D21313B636F6E737420613D5B5D2C6C3D742E6F726465726564286E293B666F72286C';
wwv_flow_imp.g_varchar2_table(19677) := '657420743D6C2E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206F3D6C5B745D3B6966286F20696E7374616E63656F6620635729733D6F3B656C7365207472797B617761697420652E636F6D70757465286F2C6E2C692C6129262628723D';
wwv_flow_imp.g_varchar2_table(19678) := '2130297D63617463682865297B45652865297D7D72657475726E20723F613A7326266F3F28617761697420652E636F6D7075746528732C6E2C692C61292C61293A5B5D7D66756E6374696F6E20765728652C74297B636F6E73747B636F6C6F7250726F76';
wwv_flow_imp.g_varchar2_table(19679) := '696465723A6E7D3D652E676574287878292C693D652E676574286663292E6765744D6F64656C2874293B6966282169297468726F77204D6528293B72657475726E7B6D6F64656C3A692C636F6C6F7250726F766964657252656769737472793A6E2C6973';
wwv_flow_imp.g_varchar2_table(19680) := '44656661756C74436F6C6F724465636F7261746F7273456E61626C65643A652E676574286670292E67657456616C75652822656469746F722E64656661756C74436F6C6F724465636F7261746F7273222C7B7265736F757263653A747D297D7D6B632E72';
wwv_flow_imp.g_varchar2_table(19681) := '65676973746572436F6D6D616E6428225F65786563757465446F63756D656E74436F6C6F7250726F7669646572222C2866756E6374696F6E28652C2E2E2E74297B636F6E73745B6E5D3D743B69662821286E20696E7374616E63656F66204E6F29297468';
wwv_flow_imp.g_varchar2_table(19682) := '726F77204D6528293B636F6E73747B6D6F64656C3A692C636F6C6F7250726F766964657252656769737472793A6F2C697344656661756C74436F6C6F724465636F7261746F7273456E61626C65643A737D3D765728652C6E293B72657475726E20665728';
wwv_flow_imp.g_varchar2_table(19683) := '6E65772067572C6F2C692C4D742E4E6F6E652C73297D29292C6B632E7265676973746572436F6D6D616E6428225F65786563757465436F6C6F7250726573656E746174696F6E50726F7669646572222C2866756E6374696F6E28652C2E2E2E74297B636F';
wwv_flow_imp.g_varchar2_table(19684) := '6E73745B6E2C695D3D742C7B7572693A6F2C72616E67653A737D3D693B69662821286F20696E7374616E63656F66204E6F262641727261792E69734172726179286E292626343D3D3D6E2E6C656E677468262672682E69734952616E6765287329292974';
wwv_flow_imp.g_varchar2_table(19685) := '68726F77204D6528293B636F6E73747B6D6F64656C3A722C636F6C6F7250726F766964657252656769737472793A612C697344656661756C74436F6C6F724465636F7261746F7273456E61626C65643A6C7D3D765728652C6F292C5B632C642C682C755D';
wwv_flow_imp.g_varchar2_table(19686) := '3D6E3B72657475726E206657286E6577206D57287B72616E67653A732C636F6C6F723A7B7265643A632C677265656E3A642C626C75653A682C616C7068613A757D7D292C612C722C4D742E4E6F6E652C6C297D29293B7661722062572C5F573D66756E63';
wwv_flow_imp.g_varchar2_table(19687) := '74696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742079573D4F626A6563742E637265617465287B7D293B6C65742077573D62573D636C61737320657874656E6473206C747B636F6E73';
wwv_flow_imp.g_varchar2_table(19688) := '74727563746F7228652C742C6E2C69297B737570657228292C746869732E5F656469746F723D652C746869732E5F636F6E66696775726174696F6E536572766963653D742C746869732E5F6C616E67756167654665617475726573536572766963653D6E';
wwv_flow_imp.g_varchar2_table(19689) := '2C746869732E5F6C6F63616C546F446973706F73653D746869732E5F7265676973746572286E6577206174292C746869732E5F6465636F726174696F6E734964733D5B5D2C746869732E5F636F6C6F7244617461733D6E6577204D61702C746869732E5F';
wwv_flow_imp.g_varchar2_table(19690) := '636F6C6F724465636F7261746F724964733D746869732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E5F72756C65466163746F72793D6E657720514128746869732E5F656469746F72292C';
wwv_flow_imp.g_varchar2_table(19691) := '746869732E5F6465636F7261746F724C696D69745265706F727465723D6E65772043572C746869732E5F636F6C6F724465636F726174696F6E436C617373526566733D746869732E5F7265676973746572286E6577206174292C746869732E5F6465626F';
wwv_flow_imp.g_varchar2_table(19692) := '756E6365496E666F726D6174696F6E3D692E666F72286E2E636F6C6F7250726F76696465722C22446F63756D656E7420436F6C6F7273222C7B6D696E3A62572E5245434F4D505554455F54494D457D292C746869732E5F726567697374657228652E6F6E';
wwv_flow_imp.g_varchar2_table(19693) := '4469644368616E67654D6F64656C282828293D3E7B746869732E5F6973436F6C6F724465636F7261746F7273456E61626C65643D746869732E6973456E61626C656428292C746869732E757064617465436F6C6F727328297D2929292C746869732E5F72';
wwv_flow_imp.g_varchar2_table(19694) := '6567697374657228652E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E746869732E757064617465436F6C6F727328292929292C746869732E5F7265676973746572286E2E636F6C6F7250726F76696465722E6F6E44696443';
wwv_flow_imp.g_varchar2_table(19695) := '68616E6765282828293D3E746869732E757064617465436F6C6F727328292929292C746869732E5F726567697374657228652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B636F6E737420743D746869732E5F6973436F6C';
wwv_flow_imp.g_varchar2_table(19696) := '6F724465636F7261746F7273456E61626C65643B746869732E5F6973436F6C6F724465636F7261746F7273456E61626C65643D746869732E6973456E61626C656428292C746869732E5F697344656661756C74436F6C6F724465636F7261746F7273456E';
wwv_flow_imp.g_varchar2_table(19697) := '61626C65643D746869732E5F656469746F722E6765744F7074696F6E28313437293B636F6E7374206E3D74213D3D746869732E5F6973436F6C6F724465636F7261746F7273456E61626C65647C7C652E6861734368616E676564283231292C693D652E68';
wwv_flow_imp.g_varchar2_table(19698) := '61734368616E67656428313437293B286E7C7C6929262628746869732E5F6973436F6C6F724465636F7261746F7273456E61626C65643F746869732E757064617465436F6C6F727328293A746869732E72656D6F7665416C6C4465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(19699) := '2829297D2929292C746869732E5F74696D656F757454696D65723D6E756C6C2C746869732E5F636F6D7075746550726F6D6973653D6E756C6C2C746869732E5F6973436F6C6F724465636F7261746F7273456E61626C65643D746869732E6973456E6162';
wwv_flow_imp.g_varchar2_table(19700) := '6C656428292C746869732E5F697344656661756C74436F6C6F724465636F7261746F7273456E61626C65643D746869732E5F656469746F722E6765744F7074696F6E28313437292C746869732E757064617465436F6C6F727328297D6973456E61626C65';
wwv_flow_imp.g_varchar2_table(19701) := '6428297B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B69662821652972657475726E21313B636F6E737420743D652E6765744C616E6775616765496428292C6E3D746869732E5F636F6E66696775726174696F6E5365';
wwv_flow_imp.g_varchar2_table(19702) := '72766963652E67657456616C75652874293B6966286E2626226F626A656374223D3D747970656F66206E297B636F6E737420653D6E2E636F6C6F724465636F7261746F72733B696628652626766F69642030213D3D652E656E61626C65262621652E656E';
wwv_flow_imp.g_varchar2_table(19703) := '61626C652972657475726E20652E656E61626C657D72657475726E20746869732E5F656469746F722E6765744F7074696F6E283230297D737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E28746869732E49';
wwv_flow_imp.g_varchar2_table(19704) := '44297D646973706F736528297B746869732E73746F7028292C746869732E72656D6F7665416C6C4465636F726174696F6E7328292C73757065722E646973706F736528297D757064617465436F6C6F727328297B696628746869732E73746F7028292C21';
wwv_flow_imp.g_varchar2_table(19705) := '746869732E5F6973436F6C6F724465636F7261746F7273456E61626C65642972657475726E3B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B652626746869732E5F6C616E677561676546656174757265735365727669';
wwv_flow_imp.g_varchar2_table(19706) := '63652E636F6C6F7250726F76696465722E686173286529262628746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E74282828293D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(19707) := '74696D656F757454696D65727C7C28746869732E5F74696D656F757454696D65723D6E65772024742C746869732E5F74696D656F757454696D65722E63616E63656C416E64536574282828293D3E7B746869732E5F74696D656F757454696D65723D6E75';
wwv_flow_imp.g_varchar2_table(19708) := '6C6C2C746869732E626567696E436F6D7075746528297D292C746869732E5F6465626F756E6365496E666F726D6174696F6E2E67657428652929297D2929292C746869732E626567696E436F6D707574652829297D6173796E6320626567696E436F6D70';
wwv_flow_imp.g_varchar2_table(19709) := '75746528297B746869732E5F636F6D7075746550726F6D6973653D467428286173796E6320653D3E7B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28293B69662821742972657475726E5B5D3B636F6E7374206E3D6E657720';
wwv_flow_imp.g_varchar2_table(19710) := '6674282131292C693D617761697420685728746869732E5F6C616E67756167654665617475726573536572766963652E636F6C6F7250726F76696465722C742C652C746869732E5F697344656661756C74436F6C6F724465636F7261746F7273456E6162';
wwv_flow_imp.g_varchar2_table(19711) := '6C6564293B72657475726E20746869732E5F6465626F756E6365496E666F726D6174696F6E2E75706461746528742C6E2E656C61707365642829292C697D29293B7472797B636F6E737420653D617761697420746869732E5F636F6D7075746550726F6D';
wwv_flow_imp.g_varchar2_table(19712) := '6973653B746869732E7570646174654465636F726174696F6E732865292C746869732E757064617465436F6C6F724465636F7261746F72732865292C746869732E5F636F6D7075746550726F6D6973653D6E756C6C7D63617463682865297B6B65286529';
wwv_flow_imp.g_varchar2_table(19713) := '7D7D73746F7028297B746869732E5F74696D656F757454696D6572262628746869732E5F74696D656F757454696D65722E63616E63656C28292C746869732E5F74696D656F757454696D65723D6E756C6C292C746869732E5F636F6D7075746550726F6D';
wwv_flow_imp.g_varchar2_table(19714) := '697365262628746869732E5F636F6D7075746550726F6D6973652E63616E63656C28292C746869732E5F636F6D7075746550726F6D6973653D6E756C6C292C746869732E5F6C6F63616C546F446973706F73652E636C65617228297D7570646174654465';
wwv_flow_imp.g_varchar2_table(19715) := '636F726174696F6E732865297B636F6E737420743D652E6D61702828653D3E287B72616E67653A7B73746172744C696E654E756D6265723A652E636F6C6F72496E666F2E72616E67652E73746172744C696E654E756D6265722C7374617274436F6C756D';
wwv_flow_imp.g_varchar2_table(19716) := '6E3A652E636F6C6F72496E666F2E72616E67652E7374617274436F6C756D6E2C656E644C696E654E756D6265723A652E636F6C6F72496E666F2E72616E67652E656E644C696E654E756D6265722C656E64436F6C756D6E3A652E636F6C6F72496E666F2E';
wwv_flow_imp.g_varchar2_table(19717) := '72616E67652E656E64436F6C756D6E7D2C6F7074696F6E733A4F432E454D5054597D2929293B746869732E5F656469746F722E6368616E67654465636F726174696F6E7328286E3D3E7B746869732E5F6465636F726174696F6E734964733D6E2E64656C';
wwv_flow_imp.g_varchar2_table(19718) := '74614465636F726174696F6E7328746869732E5F6465636F726174696F6E734964732C74292C746869732E5F636F6C6F7244617461733D6E6577204D61702C746869732E5F6465636F726174696F6E734964732E666F7245616368282828742C6E293D3E';
wwv_flow_imp.g_varchar2_table(19719) := '746869732E5F636F6C6F7244617461732E73657428742C655B6E5D2929297D29297D757064617465436F6C6F724465636F7261746F72732865297B746869732E5F636F6C6F724465636F726174696F6E436C617373526566732E636C65617228293B636F';
wwv_flow_imp.g_varchar2_table(19720) := '6E737420743D5B5D2C6E3D746869732E5F656469746F722E6765744F7074696F6E283231293B666F72286C657420693D303B693C652E6C656E6774682626742E6C656E6774683C6E3B692B2B297B636F6E73747B7265643A6E2C677265656E3A6F2C626C';
wwv_flow_imp.g_varchar2_table(19721) := '75653A732C616C7068613A727D3D655B695D2E636F6C6F72496E666F2E636F6C6F722C613D6E6577206C75284D6174682E726F756E64283235352A6E292C4D6174682E726F756E64283235352A6F292C4D6174682E726F756E64283235352A73292C7229';
wwv_flow_imp.g_varchar2_table(19722) := '2C6C3D607267626128247B612E727D2C20247B612E677D2C20247B612E627D2C20247B612E617D29602C633D746869732E5F636F6C6F724465636F726174696F6E436C617373526566732E61646428746869732E5F72756C65466163746F72792E637265';
wwv_flow_imp.g_varchar2_table(19723) := '617465436C6173734E616D65526566287B6261636B67726F756E64436F6C6F723A6C7D29293B742E70757368287B72616E67653A7B73746172744C696E654E756D6265723A655B695D2E636F6C6F72496E666F2E72616E67652E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(19724) := '756D6265722C7374617274436F6C756D6E3A655B695D2E636F6C6F72496E666F2E72616E67652E7374617274436F6C756D6E2C656E644C696E654E756D6265723A655B695D2E636F6C6F72496E666F2E72616E67652E656E644C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(19725) := '656E64436F6C756D6E3A655B695D2E636F6C6F72496E666F2E72616E67652E656E64436F6C756D6E7D2C6F7074696F6E733A7B6465736372697074696F6E3A22636F6C6F724465746563746F72222C6265666F72653A7B636F6E74656E743A22C2A0222C';
wwv_flow_imp.g_varchar2_table(19726) := '696E6C696E65436C6173734E616D653A60247B632E636C6173734E616D657D20636F6C6F727069636B65722D636F6C6F722D6465636F726174696F6E602C696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673A2130';
wwv_flow_imp.g_varchar2_table(19727) := '2C6174746163686564446174613A79577D7D7D297D636F6E737420693D6E3C652E6C656E67746826266E3B746869732E5F6465636F7261746F724C696D69745265706F727465722E75706461746528652E6C656E6774682C69292C746869732E5F636F6C';
wwv_flow_imp.g_varchar2_table(19728) := '6F724465636F7261746F724964732E7365742874297D72656D6F7665416C6C4465636F726174696F6E7328297B746869732E5F656469746F722E72656D6F76654465636F726174696F6E7328746869732E5F6465636F726174696F6E73496473292C7468';
wwv_flow_imp.g_varchar2_table(19729) := '69732E5F6465636F726174696F6E734964733D5B5D2C746869732E5F636F6C6F724465636F7261746F724964732E636C65617228292C746869732E5F636F6C6F724465636F726174696F6E436C617373526566732E636C65617228297D676574436F6C6F';
wwv_flow_imp.g_varchar2_table(19730) := '72446174612865297B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28293B69662821742972657475726E206E756C6C3B636F6E7374206E3D742E6765744465636F726174696F6E73496E52616E67652872682E66726F6D506F';
wwv_flow_imp.g_varchar2_table(19731) := '736974696F6E7328652C6529292E66696C7465722828653D3E746869732E5F636F6C6F7244617461732E68617328652E69642929293B72657475726E20303D3D3D6E2E6C656E6774683F6E756C6C3A746869732E5F636F6C6F7244617461732E67657428';
wwv_flow_imp.g_varchar2_table(19732) := '6E5B305D2E6964297D6973436F6C6F724465636F726174696F6E2865297B72657475726E20746869732E5F636F6C6F724465636F7261746F724964732E6861732865297D7D3B77572E49443D22656469746F722E636F6E747269622E636F6C6F72446574';
wwv_flow_imp.g_varchar2_table(19733) := '6563746F72222C77572E5245434F4D505554455F54494D453D3165332C77573D62573D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A';
wwv_flow_imp.g_varchar2_table(19734) := '6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F72617465';
wwv_flow_imp.g_varchar2_table(19735) := '29723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A';
wwv_flow_imp.g_varchar2_table(19736) := '6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B5F5728312C6670292C5F5728322C7878292C5F5728332C6456295D2C7757293B636C617373204357';
wwv_flow_imp.g_varchar2_table(19737) := '7B636F6E7374727563746F7228297B746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E5F636F6D70757465643D302C746869732E5F6C696D697465643D21317D75706461746528652C74297B653D3D3D746869732E5F636F6D70';
wwv_flow_imp.g_varchar2_table(19738) := '757465642626743D3D3D746869732E5F6C696D697465647C7C28746869732E5F636F6D70757465643D652C746869732E5F6C696D697465643D742C746869732E5F6F6E4469644368616E67652E666972652829297D7D4A642877572E49442C77572C3129';
wwv_flow_imp.g_varchar2_table(19739) := '3B636C6173732053577B67657420636F6C6F7228297B72657475726E20746869732E5F636F6C6F727D73657420636F6C6F722865297B746869732E5F636F6C6F722E657175616C732865297C7C28746869732E5F636F6C6F723D652C746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(19740) := '4469644368616E6765436F6C6F722E66697265286529297D6765742070726573656E746174696F6E28297B72657475726E20746869732E636F6C6F7250726573656E746174696F6E735B746869732E70726573656E746174696F6E496E6465785D7D6765';
wwv_flow_imp.g_varchar2_table(19741) := '7420636F6C6F7250726573656E746174696F6E7328297B72657475726E20746869732E5F636F6C6F7250726573656E746174696F6E737D73657420636F6C6F7250726573656E746174696F6E732865297B746869732E5F636F6C6F7250726573656E7461';
wwv_flow_imp.g_varchar2_table(19742) := '74696F6E733D652C746869732E70726573656E746174696F6E496E6465783E652E6C656E6774682D31262628746869732E70726573656E746174696F6E496E6465783D30292C746869732E5F6F6E4469644368616E676550726573656E746174696F6E2E';
wwv_flow_imp.g_varchar2_table(19743) := '6669726528746869732E70726573656E746174696F6E297D636F6E7374727563746F7228652C742C6E297B746869732E70726573656E746174696F6E496E6465783D6E2C746869732E5F6F6E436F6C6F72466C75736865643D6E65772043742C74686973';
wwv_flow_imp.g_varchar2_table(19744) := '2E6F6E436F6C6F72466C75736865643D746869732E5F6F6E436F6C6F72466C75736865642E6576656E742C746869732E5F6F6E4469644368616E6765436F6C6F723D6E65772043742C746869732E6F6E4469644368616E6765436F6C6F723D746869732E';
wwv_flow_imp.g_varchar2_table(19745) := '5F6F6E4469644368616E6765436F6C6F722E6576656E742C746869732E5F6F6E4469644368616E676550726573656E746174696F6E3D6E65772043742C746869732E6F6E4469644368616E676550726573656E746174696F6E3D746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(19746) := '644368616E676550726573656E746174696F6E2E6576656E742C746869732E6F726967696E616C436F6C6F723D652C746869732E5F636F6C6F723D652C746869732E5F636F6C6F7250726573656E746174696F6E733D747D73656C6563744E657874436F';
wwv_flow_imp.g_varchar2_table(19747) := '6C6F7250726573656E746174696F6E28297B746869732E70726573656E746174696F6E496E6465783D28746869732E70726573656E746174696F6E496E6465782B312925746869732E636F6C6F7250726573656E746174696F6E732E6C656E6774682C74';
wwv_flow_imp.g_varchar2_table(19748) := '6869732E666C757368436F6C6F7228292C746869732E5F6F6E4469644368616E676550726573656E746174696F6E2E6669726528746869732E70726573656E746174696F6E297D6775657373436F6C6F7250726573656E746174696F6E28652C74297B6C';
wwv_flow_imp.g_varchar2_table(19749) := '6574206E3D2D313B666F72286C657420653D303B653C746869732E636F6C6F7250726573656E746174696F6E732E6C656E6774683B652B2B29696628742E746F4C6F7765724361736528293D3D3D746869732E636F6C6F7250726573656E746174696F6E';
wwv_flow_imp.g_varchar2_table(19750) := '735B655D2E6C6162656C297B6E3D653B627265616B7D6966282D313D3D3D6E297B636F6E737420653D742E73706C697428222822295B305D2E746F4C6F7765724361736528293B666F72286C657420743D303B743C746869732E636F6C6F725072657365';
wwv_flow_imp.g_varchar2_table(19751) := '6E746174696F6E732E6C656E6774683B742B2B29696628746869732E636F6C6F7250726573656E746174696F6E735B745D2E6C6162656C2E746F4C6F7765724361736528292E73746172747357697468286529297B6E3D743B627265616B7D7D2D31213D';
wwv_flow_imp.g_varchar2_table(19752) := '3D6E26266E213D3D746869732E70726573656E746174696F6E496E646578262628746869732E70726573656E746174696F6E496E6465783D6E2C746869732E5F6F6E4469644368616E676550726573656E746174696F6E2E6669726528746869732E7072';
wwv_flow_imp.g_varchar2_table(19753) := '6573656E746174696F6E29297D666C757368436F6C6F7228297B746869732E5F6F6E436F6C6F72466C75736865642E6669726528746869732E5F636F6C6F72297D7D7661722078572C6B572C45573D6E2833333435292C4C573D7B7D3B4C572E7374796C';
wwv_flow_imp.g_varchar2_table(19754) := '655461675472616E73666F726D3D6A7228292C4C572E736574417474726962757465733D567228292C4C572E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4C572E646F6D4150493D4F7228292C4C572E696E736572745374';
wwv_flow_imp.g_varchar2_table(19755) := '796C65456C656D656E743D487228292C4E7228292845572E412C4C57292C45572E41262645572E412E6C6F63616C73262645572E412E6C6F63616C732C66756E6374696F6E2865297B652E676574446566696E6974696F6E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(19756) := '74297B6C6574206E3D652E64656661756C74733B666F72283B546C2E69735468656D6549636F6E286E293B297B636F6E737420653D44572E67657449636F6E286E2E6964293B69662821652972657475726E3B6E3D652E64656661756C74737D72657475';
wwv_flow_imp.g_varchar2_table(19757) := '726E206E7D7D2878577C7C2878573D7B7D29292C66756E6374696F6E2865297B652E746F4A534F4E4F626A6563743D66756E6374696F6E2865297B72657475726E7B7765696768743A652E7765696768742C7374796C653A652E7374796C652C7372633A';
wwv_flow_imp.g_varchar2_table(19758) := '652E7372632E6D61702828653D3E287B666F726D61743A652E666F726D61742C6C6F636174696F6E3A652E6C6F636174696F6E2E746F537472696E6728297D2929297D7D2C652E66726F6D4A534F4E4F626A6563743D66756E6374696F6E2865297B636F';
wwv_flow_imp.g_varchar2_table(19759) := '6E737420743D653D3E686C2865293F653A766F696420303B69662865262641727261792E6973417272617928652E737263292626652E7372632E65766572792828653D3E686C28652E666F726D6174292626686C28652E6C6F636174696F6E2929292972';
wwv_flow_imp.g_varchar2_table(19760) := '657475726E7B7765696768743A7428652E776569676874292C7374796C653A7428652E7374796C65292C7372633A652E7372632E6D61702828653D3E287B666F726D61743A652E666F726D61742C6C6F636174696F6E3A4E6F2E706172736528652E6C6F';
wwv_flow_imp.g_varchar2_table(19761) := '636174696F6E297D2929297D7D7D286B577C7C286B573D7B7D29293B636F6E73742044573D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(19762) := '67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E69636F6E536368656D613D7B646566696E6974696F6E733A7B69636F6E733A7B747970653A226F626A656374222C70726F706572746965733A7B666F6E7449643A7B7479';
wwv_flow_imp.g_varchar2_table(19763) := '70653A22737472696E67222C6465736372697074696F6E3A6228302C22546865206964206F662074686520666F6E7420746F207573652E204966206E6F74207365742C2074686520666F6E74207468617420697320646566696E65642066697273742069';
wwv_flow_imp.g_varchar2_table(19764) := '7320757365642E22297D2C666F6E744368617261637465723A7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C2254686520666F6E7420636861726163746572206173736F6369617465642077697468207468652069636F6E';
wwv_flow_imp.g_varchar2_table(19765) := '20646566696E6974696F6E2E22297D7D2C6164646974696F6E616C50726F706572746965733A21312C64656661756C74536E6970706574733A5B7B626F64793A7B666F6E744368617261637465723A225C5C5C5C65303330227D7D5D7D7D2C747970653A';
wwv_flow_imp.g_varchar2_table(19766) := '226F626A656374222C70726F706572746965733A7B7D7D2C746869732E69636F6E5265666572656E6365536368656D613D7B747970653A22737472696E67222C7061747465726E3A605E247B546C2E69636F6E4E616D6545787072657373696F6E7D2460';
wwv_flow_imp.g_varchar2_table(19767) := '2C656E756D3A5B5D2C656E756D4465736372697074696F6E733A5B5D7D2C746869732E69636F6E73427949643D7B7D2C746869732E69636F6E466F6E7473427949643D7B7D7D726567697374657249636F6E28652C742C6E2C69297B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(19768) := '746869732E69636F6E73427949645B655D3B6966286F297B6966286E2626216F2E6465736372697074696F6E297B6F2E6465736372697074696F6E3D6E2C746869732E69636F6E536368656D612E70726F706572746965735B655D2E6D61726B646F776E';
wwv_flow_imp.g_varchar2_table(19769) := '4465736372697074696F6E3D60247B6E7D202428247B657D29603B636F6E737420743D746869732E69636F6E5265666572656E6365536368656D612E656E756D2E696E6465784F662865293B2D31213D3D74262628746869732E69636F6E526566657265';
wwv_flow_imp.g_varchar2_table(19770) := '6E6365536368656D612E656E756D4465736372697074696F6E735B745D3D6E292C746869732E5F6F6E4469644368616E67652E6669726528297D72657475726E206F7D636F6E737420733D7B69643A652C6465736372697074696F6E3A6E2C6465666175';
wwv_flow_imp.g_varchar2_table(19771) := '6C74733A742C6465707265636174696F6E4D6573736167653A697D3B746869732E69636F6E73427949645B655D3D733B636F6E737420723D7B247265663A22232F646566696E6974696F6E732F69636F6E73227D3B72657475726E2069262628722E6465';
wwv_flow_imp.g_varchar2_table(19772) := '707265636174696F6E4D6573736167653D69292C6E262628722E6D61726B646F776E4465736372697074696F6E3D60247B6E7D3A202428247B657D2960292C746869732E69636F6E536368656D612E70726F706572746965735B655D3D722C746869732E';
wwv_flow_imp.g_varchar2_table(19773) := '69636F6E5265666572656E6365536368656D612E656E756D2E707573682865292C746869732E69636F6E5265666572656E6365536368656D612E656E756D4465736372697074696F6E732E70757368286E7C7C2222292C746869732E5F6F6E4469644368';
wwv_flow_imp.g_varchar2_table(19774) := '616E67652E6669726528292C7B69643A657D7D67657449636F6E7328297B72657475726E204F626A6563742E6B65797328746869732E69636F6E7342794964292E6D61702828653D3E746869732E69636F6E73427949645B655D29297D67657449636F6E';
wwv_flow_imp.g_varchar2_table(19775) := '2865297B72657475726E20746869732E69636F6E73427949645B655D7D67657449636F6E536368656D6128297B72657475726E20746869732E69636F6E536368656D617D746F537472696E6728297B636F6E737420653D28652C74293D3E652E69642E6C';
wwv_flow_imp.g_varchar2_table(19776) := '6F63616C65436F6D7061726528742E6964292C743D653D3E7B666F72283B546C2E69735468656D6549636F6E28652E64656661756C7473293B29653D746869732E69636F6E73427949645B652E64656661756C74732E69645D3B72657475726E60636F64';
wwv_flow_imp.g_varchar2_table(19777) := '69636F6E20636F6469636F6E2D247B653F652E69643A22227D607D2C6E3D5B5D3B6E2E7075736828227C207072657669657720202020207C206964656E7469666965722020202020202020202020202020202020202020202020207C2064656661756C74';
wwv_flow_imp.g_varchar2_table(19778) := '20636F6469636F6E204944202020202020202020202020202020207C206465736372697074696F6E22292C6E2E7075736828227C202D2D2D2D2D2D2D2D2D2D2D207C202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(19779) := '207C202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D207C202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D207C22293B636F6E737420693D4F626A6563742E6B65797328746869';
wwv_flow_imp.g_varchar2_table(19780) := '732E69636F6E7342794964292E6D61702828653D3E746869732E69636F6E73427949645B655D29293B666F7228636F6E7374206F206F6620692E66696C7465722828653D3E2121652E6465736372697074696F6E29292E736F7274286529296E2E707573';
wwv_flow_imp.g_varchar2_table(19781) := '6828607C3C6920636C6173733D22247B74286F297D223E3C2F693E7C247B6F2E69647D7C247B546C2E69735468656D6549636F6E286F2E64656661756C7473293F6F2E64656661756C74732E69643A6F2E69647D7C247B6F2E6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(19782) := '7C7C22227D7C60293B6E2E7075736828227C207072657669657720202020207C206964656E74696669657220202020202020202020202020202020202020202020202022292C6E2E7075736828227C202D2D2D2D2D2D2D2D2D2D2D207C202D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(19783) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D207C22293B666F7228636F6E7374206F206F6620692E66696C7465722828653D3E21546C2E69735468656D6549636F6E28652E64656661756C74732929292E736F7274286529296E2E';
wwv_flow_imp.g_varchar2_table(19784) := '7075736828607C3C6920636C6173733D22247B74286F297D223E3C2F693E7C247B6F2E69647D7C60293B72657475726E206E2E6A6F696E28225C6E22297D7D3B66756E6374696F6E20545728652C742C6E2C69297B72657475726E2044572E7265676973';
wwv_flow_imp.g_varchar2_table(19785) := '74657249636F6E28652C742C6E2C69297D66756E6374696F6E20495728297B72657475726E2044577D79642E6164642822626173652E636F6E747269627574696F6E732E69636F6E73222C4457292C66756E6374696F6E28297B636F6E737420653D456C';
wwv_flow_imp.g_varchar2_table(19786) := '28293B666F7228636F6E7374207420696E2065297B636F6E7374206E3D225C5C222B655B745D2E746F537472696E67283136293B44572E726567697374657249636F6E28742C7B666F6E744368617261637465723A6E7D297D7D28293B636F6E7374204D';
wwv_flow_imp.g_varchar2_table(19787) := '573D227673636F64653A2F2F736368656D61732F69636F6E73222C41573D79642E6173284C70293B41572E7265676973746572536368656D61284D572C44572E67657449636F6E536368656D612829293B636F6E7374204E573D6E6577204B7428282829';
wwv_flow_imp.g_varchar2_table(19788) := '3D3E41572E6E6F74696679536368656D614368616E676564284D5729292C323030293B44572E6F6E4469644368616E6765282828293D3E7B4E572E69735363686564756C656428297C7C4E572E7363686564756C6528297D29293B636F6E73742050573D';
wwv_flow_imp.g_varchar2_table(19789) := '545728227769646765742D636C6F7365222C4C6C2E636C6F73652C6228302C2249636F6E20666F722074686520636C6F736520616374696F6E20696E20776964676574732E2229292C4F573D2854572822676F746F2D70726576696F75732D6C6F636174';
wwv_flow_imp.g_varchar2_table(19790) := '696F6E222C4C6C2E6172726F7755702C6228302C2249636F6E20666F7220676F746F2070726576696F757320656469746F72206C6F636174696F6E2E2229292C54572822676F746F2D6E6578742D6C6F636174696F6E222C4C6C2E6172726F77446F776E';
wwv_flow_imp.g_varchar2_table(19791) := '2C6228302C2249636F6E20666F7220676F746F206E65787420656469746F72206C6F636174696F6E2E2229292C546C2E6D6F64696679284C6C2E73796E632C227370696E22292C546C2E6D6F64696679284C6C2E6C6F6164696E672C227370696E22292C';
wwv_flow_imp.g_varchar2_table(19792) := '6272293B636C61737320525720657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C693D2131297B737570657228292C746869732E6D6F64656C3D742C746869732E73686F77696E675374616E64616C6F6E65436F6C6F725069636B';
wwv_flow_imp.g_varchar2_table(19793) := '65723D692C746869732E5F636C6F7365427574746F6E3D6E756C6C2C746869732E5F646F6D4E6F64653D4F5728222E636F6C6F727069636B65722D68656164657222292C757228652C746869732E5F646F6D4E6F6465292C746869732E5F7069636B6564';
wwv_flow_imp.g_varchar2_table(19794) := '436F6C6F724E6F64653D757228746869732E5F646F6D4E6F64652C4F5728222E7069636B65642D636F6C6F722229292C757228746869732E5F7069636B6564436F6C6F724E6F64652C4F5728227370616E2E636F6469636F6E2E636F6469636F6E2D636F';
wwv_flow_imp.g_varchar2_table(19795) := '6C6F722D6D6F64652229292C746869732E5F7069636B6564436F6C6F7250726573656E746174696F6E3D757228746869732E5F7069636B6564436F6C6F724E6F64652C646F63756D656E742E637265617465456C656D656E7428227370616E2229292C74';
wwv_flow_imp.g_varchar2_table(19796) := '6869732E5F7069636B6564436F6C6F7250726573656E746174696F6E2E636C6173734C6973742E61646428227069636B65642D636F6C6F722D70726573656E746174696F6E22293B636F6E7374206F3D6228302C22436C69636B20746F20746F67676C65';
wwv_flow_imp.g_varchar2_table(19797) := '20636F6C6F72206F7074696F6E7320287267622F68736C2F6865782922293B746869732E5F7069636B6564436F6C6F724E6F64652E73657441747472696275746528227469746C65222C6F292C746869732E5F6F726967696E616C436F6C6F724E6F6465';
wwv_flow_imp.g_varchar2_table(19798) := '3D757228746869732E5F646F6D4E6F64652C4F5728222E6F726967696E616C2D636F6C6F722229292C746869732E5F6F726967696E616C436F6C6F724E6F64652E7374796C652E6261636B67726F756E64436F6C6F723D68752E466F726D61742E435353';
wwv_flow_imp.g_varchar2_table(19799) := '2E666F726D617428746869732E6D6F64656C2E6F726967696E616C436F6C6F72297C7C22222C746869732E6261636B67726F756E64436F6C6F723D6E2E676574436F6C6F725468656D6528292E676574436F6C6F72286266297C7C68752E77686974652C';
wwv_flow_imp.g_varchar2_table(19800) := '746869732E5F7265676973746572286E2E6F6E446964436F6C6F725468656D654368616E67652828653D3E7B746869732E6261636B67726F756E64436F6C6F723D652E676574436F6C6F72286266297C7C68752E77686974657D2929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(19801) := '726567697374657228627328746869732E5F7069636B6564436F6C6F724E6F64652C61722E434C49434B2C2828293D3E746869732E6D6F64656C2E73656C6563744E657874436F6C6F7250726573656E746174696F6E28292929292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(19802) := '67697374657228627328746869732E5F6F726967696E616C436F6C6F724E6F64652C61722E434C49434B2C2828293D3E7B746869732E6D6F64656C2E636F6C6F723D746869732E6D6F64656C2E6F726967696E616C436F6C6F722C746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(19803) := '6C2E666C757368436F6C6F7228297D2929292C746869732E5F726567697374657228742E6F6E4469644368616E6765436F6C6F7228746869732E6F6E4469644368616E6765436F6C6F722C7468697329292C746869732E5F726567697374657228742E6F';
wwv_flow_imp.g_varchar2_table(19804) := '6E4469644368616E676550726573656E746174696F6E28746869732E6F6E4469644368616E676550726573656E746174696F6E2C7468697329292C746869732E5F7069636B6564436F6C6F724E6F64652E7374796C652E6261636B67726F756E64436F6C';
wwv_flow_imp.g_varchar2_table(19805) := '6F723D68752E466F726D61742E4353532E666F726D617428742E636F6C6F72297C7C22222C746869732E5F7069636B6564436F6C6F724E6F64652E636C6173734C6973742E746F67676C6528226C69676874222C742E636F6C6F722E726762612E613C2E';
wwv_flow_imp.g_varchar2_table(19806) := '353F746869732E6261636B67726F756E64436F6C6F722E69734C69676874657228293A742E636F6C6F722E69734C6967687465722829292C746869732E6F6E4469644368616E6765436F6C6F7228746869732E6D6F64656C2E636F6C6F72292C74686973';
wwv_flow_imp.g_varchar2_table(19807) := '2E73686F77696E675374616E64616C6F6E65436F6C6F725069636B6572262628746869732E5F646F6D4E6F64652E636C6173734C6973742E61646428227374616E64616C6F6E652D636F6C6F727069636B657222292C746869732E5F636C6F7365427574';
wwv_flow_imp.g_varchar2_table(19808) := '746F6E3D746869732E5F7265676973746572286E657720465728746869732E5F646F6D4E6F64652929297D67657420636C6F7365427574746F6E28297B72657475726E20746869732E5F636C6F7365427574746F6E7D676574207069636B6564436F6C6F';
wwv_flow_imp.g_varchar2_table(19809) := '724E6F646528297B72657475726E20746869732E5F7069636B6564436F6C6F724E6F64657D676574206F726967696E616C436F6C6F724E6F646528297B72657475726E20746869732E5F6F726967696E616C436F6C6F724E6F64657D6F6E446964436861';
wwv_flow_imp.g_varchar2_table(19810) := '6E6765436F6C6F722865297B746869732E5F7069636B6564436F6C6F724E6F64652E7374796C652E6261636B67726F756E64436F6C6F723D68752E466F726D61742E4353532E666F726D61742865297C7C22222C746869732E5F7069636B6564436F6C6F';
wwv_flow_imp.g_varchar2_table(19811) := '724E6F64652E636C6173734C6973742E746F67676C6528226C69676874222C652E726762612E613C2E353F746869732E6261636B67726F756E64436F6C6F722E69734C69676874657228293A652E69734C6967687465722829292C746869732E6F6E4469';
wwv_flow_imp.g_varchar2_table(19812) := '644368616E676550726573656E746174696F6E28297D6F6E4469644368616E676550726573656E746174696F6E28297B746869732E5F7069636B6564436F6C6F7250726573656E746174696F6E2E74657874436F6E74656E743D746869732E6D6F64656C';
wwv_flow_imp.g_varchar2_table(19813) := '2E70726573656E746174696F6E3F746869732E6D6F64656C2E70726573656E746174696F6E2E6C6162656C3A22227D7D636C61737320465720657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F6F6E43';
wwv_flow_imp.g_varchar2_table(19814) := '6C69636B65643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436C69636B65643D746869732E5F6F6E436C69636B65642E6576656E742C746869732E5F627574746F6E3D646F63756D656E742E637265617465456C656D65';
wwv_flow_imp.g_varchar2_table(19815) := '6E74282264697622292C746869732E5F627574746F6E2E636C6173734C6973742E6164642822636C6F73652D627574746F6E22292C757228652C746869732E5F627574746F6E293B636F6E737420743D646F63756D656E742E637265617465456C656D65';
wwv_flow_imp.g_varchar2_table(19816) := '6E74282264697622293B742E636C6173734C6973742E6164642822636C6F73652D627574746F6E2D696E6E65722D64697622292C757228746869732E5F627574746F6E2C74292C757228742C4F5728222E627574746F6E222B546C2E617343535353656C';
wwv_flow_imp.g_varchar2_table(19817) := '6563746F722854572822636F6C6F722D7069636B65722D636C6F7365222C4C6C2E636C6F73652C6228302C2249636F6E20746F20636C6F73652074686520636F6C6F72207069636B65722229292929292E636C6173734C6973742E6164642822636C6F73';
wwv_flow_imp.g_varchar2_table(19818) := '652D69636F6E22292C746869732E5F726567697374657228627328746869732E5F627574746F6E2C61722E434C49434B2C2828293D3E7B746869732E5F6F6E436C69636B65642E6669726528297D2929297D7D636C61737320425720657874656E647320';
wwv_flow_imp.g_varchar2_table(19819) := '6C747B636F6E7374727563746F7228652C742C6E2C693D2131297B737570657228292C746869732E6D6F64656C3D742C746869732E706978656C526174696F3D6E2C746869732E5F696E73657274427574746F6E3D6E756C6C2C746869732E5F646F6D4E';
wwv_flow_imp.g_varchar2_table(19820) := '6F64653D4F5728222E636F6C6F727069636B65722D626F647922292C757228652C746869732E5F646F6D4E6F6465292C746869732E5F73617475726174696F6E426F783D6E657720565728746869732E5F646F6D4E6F64652C746869732E6D6F64656C2C';
wwv_flow_imp.g_varchar2_table(19821) := '746869732E706978656C526174696F292C746869732E5F726567697374657228746869732E5F73617475726174696F6E426F78292C746869732E5F726567697374657228746869732E5F73617475726174696F6E426F782E6F6E4469644368616E676528';
wwv_flow_imp.g_varchar2_table(19822) := '746869732E6F6E44696453617475726174696F6E56616C75654368616E67652C7468697329292C746869732E5F726567697374657228746869732E5F73617475726174696F6E426F782E6F6E436F6C6F72466C757368656428746869732E666C75736843';
wwv_flow_imp.g_varchar2_table(19823) := '6F6C6F722C7468697329292C746869732E5F6F70616369747953747269703D6E657720485728746869732E5F646F6D4E6F64652C746869732E6D6F64656C2C69292C746869732E5F726567697374657228746869732E5F6F706163697479537472697029';
wwv_flow_imp.g_varchar2_table(19824) := '2C746869732E5F726567697374657228746869732E5F6F70616369747953747269702E6F6E4469644368616E676528746869732E6F6E4469644F7061636974794368616E67652C7468697329292C746869732E5F726567697374657228746869732E5F6F';
wwv_flow_imp.g_varchar2_table(19825) := '70616369747953747269702E6F6E436F6C6F72466C757368656428746869732E666C757368436F6C6F722C7468697329292C746869732E5F68756553747269703D6E657720575728746869732E5F646F6D4E6F64652C746869732E6D6F64656C2C69292C';
wwv_flow_imp.g_varchar2_table(19826) := '746869732E5F726567697374657228746869732E5F6875655374726970292C746869732E5F726567697374657228746869732E5F68756553747269702E6F6E4469644368616E676528746869732E6F6E4469644875654368616E67652C7468697329292C';
wwv_flow_imp.g_varchar2_table(19827) := '746869732E5F726567697374657228746869732E5F68756553747269702E6F6E436F6C6F72466C757368656428746869732E666C757368436F6C6F722C7468697329292C69262628746869732E5F696E73657274427574746F6E3D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(19828) := '6973746572286E6577206A5728746869732E5F646F6D4E6F646529292C746869732E5F646F6D4E6F64652E636C6173734C6973742E61646428227374616E64616C6F6E652D636F6C6F727069636B65722229297D666C757368436F6C6F7228297B746869';
wwv_flow_imp.g_varchar2_table(19829) := '732E6D6F64656C2E666C757368436F6C6F7228297D6F6E44696453617475726174696F6E56616C75654368616E6765287B733A652C763A747D297B636F6E7374206E3D746869732E6D6F64656C2E636F6C6F722E687376613B746869732E6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(19830) := '636F6C6F723D6E6577206875286E6577206475286E2E682C652C742C6E2E6129297D6F6E4469644F7061636974794368616E67652865297B636F6E737420743D746869732E6D6F64656C2E636F6C6F722E687376613B746869732E6D6F64656C2E636F6C';
wwv_flow_imp.g_varchar2_table(19831) := '6F723D6E6577206875286E657720647528742E682C742E732C742E762C6529297D6F6E4469644875654368616E67652865297B636F6E737420743D746869732E6D6F64656C2E636F6C6F722E687376612C6E3D3336302A28312D65293B746869732E6D6F';
wwv_flow_imp.g_varchar2_table(19832) := '64656C2E636F6C6F723D6E6577206875286E6577206475283336303D3D3D6E3F303A6E2C742E732C742E762C742E6129297D67657420646F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D6765742073617475726174696F6E42';
wwv_flow_imp.g_varchar2_table(19833) := '6F7828297B72657475726E20746869732E5F73617475726174696F6E426F787D67657420656E746572427574746F6E28297B72657475726E20746869732E5F696E73657274427574746F6E7D6C61796F757428297B746869732E5F73617475726174696F';
wwv_flow_imp.g_varchar2_table(19834) := '6E426F782E6C61796F757428292C746869732E5F6F70616369747953747269702E6C61796F757428292C746869732E5F68756553747269702E6C61796F757428297D7D636C61737320565720657874656E6473206C747B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(19835) := '2C742C6E297B737570657228292C746869732E6D6F64656C3D742C746869732E706978656C526174696F3D6E2C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368';
wwv_flow_imp.g_varchar2_table(19836) := '616E67652E6576656E742C746869732E5F6F6E436F6C6F72466C75736865643D6E65772043742C746869732E6F6E436F6C6F72466C75736865643D746869732E5F6F6E436F6C6F72466C75736865642E6576656E742C746869732E5F646F6D4E6F64653D';
wwv_flow_imp.g_varchar2_table(19837) := '4F5728222E73617475726174696F6E2D7772617022292C757228652C746869732E5F646F6D4E6F6465292C746869732E5F63616E7661733D646F63756D656E742E637265617465456C656D656E74282263616E76617322292C746869732E5F63616E7661';
wwv_flow_imp.g_varchar2_table(19838) := '732E636C6173734E616D653D2273617475726174696F6E2D626F78222C757228746869732E5F646F6D4E6F64652C746869732E5F63616E766173292C746869732E73656C656374696F6E3D4F5728222E73617475726174696F6E2D73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(19839) := '22292C757228746869732E5F646F6D4E6F64652C746869732E73656C656374696F6E292C746869732E6C61796F757428292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C61722E504F494E5445525F444F574E2C2865';
wwv_flow_imp.g_varchar2_table(19840) := '3D3E746869732E6F6E506F696E746572446F776E2865292929292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4469644368616E6765436F6C6F7228746869732E6F6E4469644368616E6765436F6C6F722C7468697329292C74';
wwv_flow_imp.g_varchar2_table(19841) := '6869732E6D6F6E69746F723D6E756C6C7D67657420646F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D6F6E506F696E746572446F776E2865297B6966282128652E7461726765742626652E74617267657420696E7374616E63';
wwv_flow_imp.g_varchar2_table(19842) := '656F6620456C656D656E74292972657475726E3B746869732E6D6F6E69746F723D746869732E5F7265676973746572286E6577204B44293B636F6E737420743D417328746869732E5F646F6D4E6F6465293B652E746172676574213D3D746869732E7365';
wwv_flow_imp.g_varchar2_table(19843) := '6C656374696F6E2626746869732E6F6E4469644368616E6765506F736974696F6E28652E6F6666736574582C652E6F666673657459292C746869732E6D6F6E69746F722E73746172744D6F6E69746F72696E6728652E7461726765742C652E706F696E74';
wwv_flow_imp.g_varchar2_table(19844) := '657249642C652E627574746F6E732C28653D3E746869732E6F6E4469644368616E6765506F736974696F6E28652E70616765582D742E6C6566742C652E70616765592D742E746F7029292C2828293D3E6E756C6C29293B636F6E7374206E3D627328652E';
wwv_flow_imp.g_varchar2_table(19845) := '7461726765742E6F776E6572446F63756D656E742C61722E504F494E5445525F55502C2828293D3E7B746869732E5F6F6E436F6C6F72466C75736865642E6669726528292C6E2E646973706F736528292C746869732E6D6F6E69746F7226262874686973';
wwv_flow_imp.g_varchar2_table(19846) := '2E6D6F6E69746F722E73746F704D6F6E69746F72696E67282130292C746869732E6D6F6E69746F723D6E756C6C297D292C2130297D6F6E4469644368616E6765506F736974696F6E28652C74297B636F6E7374206E3D4D6174682E6D617828302C4D6174';
wwv_flow_imp.g_varchar2_table(19847) := '682E6D696E28312C652F746869732E776964746829292C693D4D6174682E6D617828302C4D6174682E6D696E28312C312D742F746869732E68656967687429293B746869732E7061696E7453656C656374696F6E286E2C69292C746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(19848) := '644368616E67652E66697265287B733A6E2C763A697D297D6C61796F757428297B746869732E77696474683D746869732E5F646F6D4E6F64652E6F666673657457696474682C746869732E6865696768743D746869732E5F646F6D4E6F64652E6F666673';
wwv_flow_imp.g_varchar2_table(19849) := '65744865696768742C746869732E5F63616E7661732E77696474683D746869732E77696474682A746869732E706978656C526174696F2C746869732E5F63616E7661732E6865696768743D746869732E6865696768742A746869732E706978656C526174';
wwv_flow_imp.g_varchar2_table(19850) := '696F2C746869732E7061696E7428293B636F6E737420653D746869732E6D6F64656C2E636F6C6F722E687376613B746869732E7061696E7453656C656374696F6E28652E732C652E76297D7061696E7428297B636F6E737420653D746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(19851) := '6C2E636F6C6F722E687376612C743D6E6577206875286E657720647528652E682C312C312C3129292C6E3D746869732E5F63616E7661732E676574436F6E746578742822326422292C693D6E2E6372656174654C696E6561724772616469656E7428302C';
wwv_flow_imp.g_varchar2_table(19852) := '302C746869732E5F63616E7661732E77696474682C30293B692E616464436F6C6F7253746F7028302C2272676261283235352C203235352C203235352C20312922292C692E616464436F6C6F7253746F70282E352C2272676261283235352C203235352C';
wwv_flow_imp.g_varchar2_table(19853) := '203235352C20302E352922292C692E616464436F6C6F7253746F7028312C2272676261283235352C203235352C203235352C20302922293B636F6E7374206F3D6E2E6372656174654C696E6561724772616469656E7428302C302C302C746869732E5F63';
wwv_flow_imp.g_varchar2_table(19854) := '616E7661732E686569676874293B6F2E616464436F6C6F7253746F7028302C227267626128302C20302C20302C20302922292C6F2E616464436F6C6F7253746F7028312C227267626128302C20302C20302C20312922292C6E2E7265637428302C302C74';
wwv_flow_imp.g_varchar2_table(19855) := '6869732E5F63616E7661732E77696474682C746869732E5F63616E7661732E686569676874292C6E2E66696C6C5374796C653D68752E466F726D61742E4353532E666F726D61742874292C6E2E66696C6C28292C6E2E66696C6C5374796C653D692C6E2E';
wwv_flow_imp.g_varchar2_table(19856) := '66696C6C28292C6E2E66696C6C5374796C653D6F2C6E2E66696C6C28297D7061696E7453656C656374696F6E28652C74297B746869732E73656C656374696F6E2E7374796C652E6C6566743D652A746869732E77696474682B227078222C746869732E73';
wwv_flow_imp.g_varchar2_table(19857) := '656C656374696F6E2E7374796C652E746F703D746869732E6865696768742D742A746869732E6865696768742B227078227D6F6E4469644368616E6765436F6C6F722865297B696628746869732E6D6F6E69746F722626746869732E6D6F6E69746F722E';
wwv_flow_imp.g_varchar2_table(19858) := '69734D6F6E69746F72696E6728292972657475726E3B746869732E7061696E7428293B636F6E737420743D652E687376613B746869732E7061696E7453656C656374696F6E28742E732C742E76297D7D636C617373207A5720657874656E6473206C747B';
wwv_flow_imp.g_varchar2_table(19859) := '636F6E7374727563746F7228652C742C6E3D2131297B737570657228292C746869732E6D6F64656C3D742C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(19860) := '67652E6576656E742C746869732E5F6F6E436F6C6F72466C75736865643D6E65772043742C746869732E6F6E436F6C6F72466C75736865643D746869732E5F6F6E436F6C6F72466C75736865642E6576656E742C6E3F28746869732E646F6D4E6F64653D';
wwv_flow_imp.g_varchar2_table(19861) := '757228652C4F5728222E7374616E64616C6F6E652D73747269702229292C746869732E6F7665726C61793D757228746869732E646F6D4E6F64652C4F5728222E7374616E64616C6F6E652D6F7665726C6179222929293A28746869732E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(19862) := '3D757228652C4F5728222E73747269702229292C746869732E6F7665726C61793D757228746869732E646F6D4E6F64652C4F5728222E6F7665726C6179222929292C746869732E736C696465723D757228746869732E646F6D4E6F64652C4F5728222E73';
wwv_flow_imp.g_varchar2_table(19863) := '6C696465722229292C746869732E736C696465722E7374796C652E746F703D22307078222C746869732E5F726567697374657228627328746869732E646F6D4E6F64652C61722E504F494E5445525F444F574E2C28653D3E746869732E6F6E506F696E74';
wwv_flow_imp.g_varchar2_table(19864) := '6572446F776E2865292929292C746869732E5F726567697374657228742E6F6E4469644368616E6765436F6C6F7228746869732E6F6E4469644368616E6765436F6C6F722C7468697329292C746869732E6C61796F757428297D6C61796F757428297B74';
wwv_flow_imp.g_varchar2_table(19865) := '6869732E6865696768743D746869732E646F6D4E6F64652E6F66667365744865696768742D746869732E736C696465722E6F66667365744865696768743B636F6E737420653D746869732E67657456616C756528746869732E6D6F64656C2E636F6C6F72';
wwv_flow_imp.g_varchar2_table(19866) := '293B746869732E757064617465536C69646572506F736974696F6E2865297D6F6E4469644368616E6765436F6C6F722865297B636F6E737420743D746869732E67657456616C75652865293B746869732E757064617465536C69646572506F736974696F';
wwv_flow_imp.g_varchar2_table(19867) := '6E2874297D6F6E506F696E746572446F776E2865297B6966282128652E7461726765742626652E74617267657420696E7374616E63656F6620456C656D656E74292972657475726E3B636F6E737420743D746869732E5F7265676973746572286E657720';
wwv_flow_imp.g_varchar2_table(19868) := '4B44292C6E3D417328746869732E646F6D4E6F6465293B746869732E646F6D4E6F64652E636C6173734C6973742E61646428226772616262696E6722292C652E746172676574213D3D746869732E736C696465722626746869732E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(19869) := '6765546F7028652E6F666673657459292C742E73746172744D6F6E69746F72696E6728652E7461726765742C652E706F696E74657249642C652E627574746F6E732C28653D3E746869732E6F6E4469644368616E6765546F7028652E70616765592D6E2E';
wwv_flow_imp.g_varchar2_table(19870) := '746F7029292C2828293D3E6E756C6C29293B636F6E737420693D627328652E7461726765742E6F776E6572446F63756D656E742C61722E504F494E5445525F55502C2828293D3E7B746869732E5F6F6E436F6C6F72466C75736865642E6669726528292C';
wwv_flow_imp.g_varchar2_table(19871) := '692E646973706F736528292C742E73746F704D6F6E69746F72696E67282130292C746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F766528226772616262696E6722297D292C2130297D6F6E4469644368616E6765546F702865297B63';
wwv_flow_imp.g_varchar2_table(19872) := '6F6E737420743D4D6174682E6D617828302C4D6174682E6D696E28312C312D652F746869732E68656967687429293B746869732E757064617465536C69646572506F736974696F6E2874292C746869732E5F6F6E4469644368616E67652E666972652874';
wwv_flow_imp.g_varchar2_table(19873) := '297D757064617465536C69646572506F736974696F6E2865297B746869732E736C696465722E7374796C652E746F703D28312D65292A746869732E6865696768742B227078227D7D636C61737320485720657874656E6473207A577B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(19874) := '746F7228652C742C6E3D2131297B737570657228652C742C6E292C746869732E646F6D4E6F64652E636C6173734C6973742E61646428226F7061636974792D737472697022292C746869732E6F6E4469644368616E6765436F6C6F7228746869732E6D6F';
wwv_flow_imp.g_varchar2_table(19875) := '64656C2E636F6C6F72297D6F6E4469644368616E6765436F6C6F722865297B73757065722E6F6E4469644368616E6765436F6C6F722865293B636F6E73747B723A742C673A6E2C623A697D3D652E726762612C6F3D6E6577206875286E6577206C752874';
wwv_flow_imp.g_varchar2_table(19876) := '2C6E2C692C3129292C733D6E6577206875286E6577206C7528742C6E2C692C3029293B746869732E6F7665726C61792E7374796C652E6261636B67726F756E643D606C696E6561722D6772616469656E7428746F20626F74746F6D2C20247B6F7D203025';
wwv_flow_imp.g_varchar2_table(19877) := '2C20247B737D203130302529607D67657456616C75652865297B72657475726E20652E687376612E617D7D636C61737320575720657874656E6473207A577B636F6E7374727563746F7228652C742C6E3D2131297B737570657228652C742C6E292C7468';
wwv_flow_imp.g_varchar2_table(19878) := '69732E646F6D4E6F64652E636C6173734C6973742E61646428226875652D737472697022297D67657456616C75652865297B72657475726E20312D652E687376612E682F3336307D7D636C617373206A5720657874656E6473206C747B636F6E73747275';
wwv_flow_imp.g_varchar2_table(19879) := '63746F722865297B737570657228292C746869732E5F6F6E436C69636B65643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436C69636B65643D746869732E5F6F6E436C69636B65642E6576656E742C746869732E5F6275';
wwv_flow_imp.g_varchar2_table(19880) := '74746F6E3D757228652C646F63756D656E742E637265617465456C656D656E742822627574746F6E2229292C746869732E5F627574746F6E2E636C6173734C6973742E6164642822696E736572742D627574746F6E22292C746869732E5F627574746F6E';
wwv_flow_imp.g_varchar2_table(19881) := '2E74657874436F6E74656E743D22496E73657274222C746869732E5F726567697374657228627328746869732E5F627574746F6E2C61722E434C49434B2C2828293D3E7B746869732E5F6F6E436C69636B65642E6669726528297D2929297D6765742062';
wwv_flow_imp.g_varchar2_table(19882) := '7574746F6E28297B72657475726E20746869732E5F627574746F6E7D7D636C61737320715720657874656E64732047447B636F6E7374727563746F7228652C742C6E2C692C6F3D2131297B737570657228292C746869732E6D6F64656C3D742C74686973';
wwv_flow_imp.g_varchar2_table(19883) := '2E706978656C526174696F3D6E2C746869732E5F7265676973746572285F412E676574496E7374616E6365287273286529292E6F6E4469644368616E6765282828293D3E746869732E6C61796F757428292929293B636F6E737420733D4F5728222E636F';
wwv_flow_imp.g_varchar2_table(19884) := '6C6F727069636B65722D77696467657422293B652E617070656E644368696C642873292C746869732E6865616465723D746869732E5F7265676973746572286E657720525728732C746869732E6D6F64656C2C692C6F29292C746869732E626F64793D74';
wwv_flow_imp.g_varchar2_table(19885) := '6869732E5F7265676973746572286E657720425728732C746869732E6D6F64656C2C746869732E706978656C526174696F2C6F29297D6C61796F757428297B746869732E626F64792E6C61796F757428297D7D7661722024573D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(19886) := '2C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A6563';
wwv_flow_imp.g_varchar2_table(19887) := '74223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D65';
wwv_flow_imp.g_varchar2_table(19888) := '2E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(19889) := '72747928742C6E2C72292C727D2C55573D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C617373204B577B636F6E7374727563746F7228652C742C6E2C69297B746869732E6F77';
wwv_flow_imp.g_varchar2_table(19890) := '6E65723D652C746869732E72616E67653D742C746869732E6D6F64656C3D6E2C746869732E70726F76696465723D692C746869732E666F72636553686F77417452616E67653D21307D697356616C6964466F72486F766572416E63686F722865297B7265';
wwv_flow_imp.g_varchar2_table(19891) := '7475726E20313D3D3D652E747970652626746869732E72616E67652E7374617274436F6C756D6E3C3D652E72616E67652E7374617274436F6C756D6E2626746869732E72616E67652E656E64436F6C756D6E3E3D652E72616E67652E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(19892) := '6E7D7D6C65742047573D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F656469746F723D652C746869732E5F7468656D65536572766963653D742C746869732E686F7665724F7264696E616C3D327D636F6D7075746553796E63';
wwv_flow_imp.g_varchar2_table(19893) := '28652C74297B72657475726E5B5D7D636F6D707574654173796E6328652C742C6E297B72657475726E20656E2E66726F6D50726F6D69736528746869732E5F636F6D707574654173796E6328652C742C6E29297D6173796E63205F636F6D707574654173';
wwv_flow_imp.g_varchar2_table(19894) := '796E6328652C742C6E297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E5B5D3B636F6E737420693D77572E67657428746869732E5F656469746F72293B69662821692972657475726E5B5D3B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(19895) := '742065206F662074297B69662821692E6973436F6C6F724465636F726174696F6E28652929636F6E74696E75653B636F6E737420743D692E676574436F6C6F724461746128652E72616E67652E6765745374617274506F736974696F6E2829293B696628';
wwv_flow_imp.g_varchar2_table(19896) := '742972657475726E5B6177616974205A5728746869732C746869732E5F656469746F722E6765744D6F64656C28292C742E636F6C6F72496E666F2C742E70726F7669646572295D7D72657475726E5B5D7D72656E646572486F766572506172747328652C';
wwv_flow_imp.g_varchar2_table(19897) := '74297B72657475726E20585728746869732C746869732E5F656469746F722C746869732E5F7468656D65536572766963652C742C65297D7D3B47573D2457285B555728312C5062295D2C4757293B636C6173732051577B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(19898) := '2C742C6E2C69297B746869732E6F776E65723D652C746869732E72616E67653D742C746869732E6D6F64656C3D6E2C746869732E70726F76696465723D697D7D6C65742059573D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F';
wwv_flow_imp.g_varchar2_table(19899) := '656469746F723D652C746869732E5F7468656D65536572766963653D742C746869732E5F636F6C6F723D6E756C6C7D6173796E6320637265617465436F6C6F72486F76657228652C742C6E297B69662821746869732E5F656469746F722E6861734D6F64';
wwv_flow_imp.g_varchar2_table(19900) := '656C28292972657475726E206E756C6C3B6966282177572E67657428746869732E5F656469746F72292972657475726E206E756C6C3B636F6E737420693D6177616974206857286E2C746869732E5F656469746F722E6765744D6F64656C28292C4D742E';
wwv_flow_imp.g_varchar2_table(19901) := '4E6F6E65293B6C6574206F3D6E756C6C2C733D6E756C6C3B666F7228636F6E73742074206F662069297B636F6E7374206E3D742E636F6C6F72496E666F3B72682E636F6E7461696E7352616E6765286E2E72616E67652C652E72616E6765292626286F3D';
wwv_flow_imp.g_varchar2_table(19902) := '6E2C733D742E70726F7669646572297D636F6E737420723D6E756C6C213D6F3F6F3A652C613D6E756C6C213D733F733A742C6C3D21216F3B72657475726E7B636F6C6F72486F7665723A6177616974205A5728746869732C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(19903) := '2E6765744D6F64656C28292C722C61292C666F756E64496E456469746F723A6C7D7D6173796E6320757064617465456469746F724D6F64656C2865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E73';
wwv_flow_imp.g_varchar2_table(19904) := '7420743D652E6D6F64656C3B6C6574206E3D6E657720726828652E72616E67652E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E2C652E72616E67652E656E644C696E654E756D6265722C652E72616E67652E65';
wwv_flow_imp.g_varchar2_table(19905) := '6E64436F6C756D6E293B746869732E5F636F6C6F72262628617761697420656A28746869732E5F656469746F722E6765744D6F64656C28292C742C746869732E5F636F6C6F722C6E2C65292C6E3D4A5728746869732E5F656469746F722C6E2C7429297D';
wwv_flow_imp.g_varchar2_table(19906) := '72656E646572486F766572506172747328652C74297B72657475726E20585728746869732C746869732E5F656469746F722C746869732E5F7468656D65536572766963652C742C65297D73657420636F6C6F722865297B746869732E5F636F6C6F723D65';
wwv_flow_imp.g_varchar2_table(19907) := '7D67657420636F6C6F7228297B72657475726E20746869732E5F636F6C6F727D7D3B6173796E632066756E6374696F6E205A5728652C742C6E2C69297B636F6E7374206F3D742E67657456616C7565496E52616E6765286E2E72616E6765292C7B726564';
wwv_flow_imp.g_varchar2_table(19908) := '3A732C677265656E3A722C626C75653A612C616C7068613A6C7D3D6E2E636F6C6F722C633D6E6577206C75284D6174682E726F756E64283235352A73292C4D6174682E726F756E64283235352A72292C4D6174682E726F756E64283235352A61292C6C29';
wwv_flow_imp.g_varchar2_table(19909) := '2C643D6E65772068752863292C683D617761697420755728742C6E2C692C4D742E4E6F6E65292C753D6E657720535728642C5B5D2C30293B72657475726E20752E636F6C6F7250726573656E746174696F6E733D687C7C5B5D2C752E6775657373436F6C';
wwv_flow_imp.g_varchar2_table(19910) := '6F7250726573656E746174696F6E28642C6F292C6520696E7374616E63656F662047573F6E6577204B5728652C72682E6C696674286E2E72616E6765292C752C69293A6E657720515728652C72682E6C696674286E2E72616E6765292C752C69297D6675';
wwv_flow_imp.g_varchar2_table(19911) := '6E6374696F6E20585728652C742C6E2C692C6F297B696628303D3D3D692E6C656E6774687C7C21742E6861734D6F64656C28292972657475726E206C742E4E6F6E653B6966286F2E7365744D696E696D756D44696D656E73696F6E73297B636F6E737420';
wwv_flow_imp.g_varchar2_table(19912) := '653D742E6765744F7074696F6E283637292B383B6F2E7365744D696E696D756D44696D656E73696F6E73286E6577204973283330322C6529297D636F6E737420733D6E65772061742C723D695B305D2C613D742E6765744D6F64656C28292C6C3D722E6D';
wwv_flow_imp.g_varchar2_table(19913) := '6F64656C2C633D732E616464286E6577207157286F2E667261676D656E742C6C2C742E6765744F7074696F6E28313433292C6E2C6520696E7374616E63656F6620595729293B6F2E736574436F6C6F725069636B65722863293B6C657420643D21312C68';
wwv_flow_imp.g_varchar2_table(19914) := '3D6E657720726828722E72616E67652E73746172744C696E654E756D6265722C722E72616E67652E7374617274436F6C756D6E2C722E72616E67652E656E644C696E654E756D6265722C722E72616E67652E656E64436F6C756D6E293B6966286520696E';
wwv_flow_imp.g_varchar2_table(19915) := '7374616E63656F66205957297B636F6E737420743D695B305D2E6D6F64656C2E636F6C6F723B652E636F6C6F723D742C656A28612C6C2C742C682C72292C732E616464286C2E6F6E436F6C6F72466C75736865642828743D3E7B652E636F6C6F723D747D';
wwv_flow_imp.g_varchar2_table(19916) := '2929297D656C736520732E616464286C2E6F6E436F6C6F72466C757368656428286173796E6320653D3E7B617761697420656A28612C6C2C652C682C72292C643D21302C683D4A5728742C682C6C297D2929293B72657475726E20732E616464286C2E6F';
wwv_flow_imp.g_varchar2_table(19917) := '6E4469644368616E6765436F6C6F722828653D3E7B656A28612C6C2C652C682C72297D2929292C732E61646428742E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B643F643D21313A286F2E6869646528292C742E666F637573';
wwv_flow_imp.g_varchar2_table(19918) := '2829297D2929292C737D66756E6374696F6E204A5728652C742C6E297B76617220692C6F3B636F6E737420733D5B5D2C723D6E756C6C213D3D28693D6E2E70726573656E746174696F6E2E7465787445646974292626766F69642030213D3D693F693A7B';
wwv_flow_imp.g_varchar2_table(19919) := '72616E67653A742C746578743A6E2E70726573656E746174696F6E2E6C6162656C2C666F7263654D6F76654D61726B6572733A21317D3B732E707573682872292C6E2E70726573656E746174696F6E2E6164646974696F6E616C54657874456469747326';
wwv_flow_imp.g_varchar2_table(19920) := '26732E70757368282E2E2E6E2E70726573656E746174696F6E2E6164646974696F6E616C546578744564697473293B636F6E737420613D72682E6C69667428722E72616E6765292C6C3D652E6765744D6F64656C28292E5F736574547261636B65645261';
wwv_flow_imp.g_varchar2_table(19921) := '6E6765286E756C6C2C612C33293B72657475726E20652E6578656375746545646974732822636F6C6F727069636B6572222C73292C652E70757368556E646F53746F7028292C6E756C6C213D3D286F3D652E6765744D6F64656C28292E5F676574547261';
wwv_flow_imp.g_varchar2_table(19922) := '636B656452616E6765286C29292626766F69642030213D3D6F3F6F3A617D6173796E632066756E6374696F6E20656A28652C742C6E2C692C6F297B636F6E737420733D617761697420755728652C7B72616E67653A692C636F6C6F723A7B7265643A6E2E';
wwv_flow_imp.g_varchar2_table(19923) := '726762612E722F3235352C677265656E3A6E2E726762612E672F3235352C626C75653A6E2E726762612E622F3235352C616C7068613A6E2E726762612E617D7D2C6F2E70726F76696465722C4D742E4E6F6E65293B742E636F6C6F7250726573656E7461';
wwv_flow_imp.g_varchar2_table(19924) := '74696F6E733D737C7C5B5D7D59573D2457285B555728312C5062295D2C5957293B636F6E737420746A3D22656469746F722E616374696F6E2E73686F77486F766572222C6E6A3D22656469746F722E616374696F6E2E696E637265617365486F76657256';
wwv_flow_imp.g_varchar2_table(19925) := '6572626F736974794C6576656C222C696A3D22656469746F722E616374696F6E2E6465637265617365486F766572566572626F736974794C6576656C223B766172206F6A3D6E2835343135292C736A3D7B7D3B736A2E7374796C655461675472616E7366';
wwv_flow_imp.g_varchar2_table(19926) := '6F726D3D6A7228292C736A2E736574417474726962757465733D567228292C736A2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C736A2E646F6D4150493D4F7228292C736A2E696E736572745374796C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(19927) := '3D487228292C4E722829286F6A2E412C736A292C6F6A2E4126266F6A2E412E6C6F63616C7326266F6A2E412E6C6F63616C733B636F6E737420726A3D22656469746F722E616374696F6E2E696E6C696E65537567676573742E636F6D6D6974222C616A3D';
wwv_flow_imp.g_varchar2_table(19928) := '22656469746F722E616374696F6E2E696E6C696E65537567676573742E73686F7750726576696F7573222C6C6A3D22656469746F722E616374696F6E2E696E6C696E65537567676573742E73686F774E657874223B76617220636A3D6E2839383632292C';
wwv_flow_imp.g_varchar2_table(19929) := '646A3D7B7D3B646A2E7374796C655461675472616E73666F726D3D6A7228292C646A2E736574417474726962757465733D567228292C646A2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C646A2E646F6D4150493D4F7228';
wwv_flow_imp.g_varchar2_table(19930) := '292C646A2E696E736572745374796C65456C656D656E743D487228292C4E72282928636A2E412C646A292C636A2E412626636A2E412E6C6F63616C732626636A2E412E6C6F63616C733B636C61737320686A20657874656E6473205F637B636F6E737472';
wwv_flow_imp.g_varchar2_table(19931) := '7563746F7228652C74297B737570657228292C746869732E5F6F6E4469644368616E67655669736962696C6974793D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67655669736962696C6974793D746869';
wwv_flow_imp.g_varchar2_table(19932) := '732E5F6F6E4469644368616E67655669736962696C6974792E6576656E742C746869732E5F656C656D656E743D757228652C627228222E6D6F6E61636F2D64726F70646F776E2229292C746869732E5F6C6162656C3D757228746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(19933) := '6E742C627228222E64726F70646F776E2D6C6162656C2229293B6C6574206E3D742E6C6162656C52656E64657265723B6E7C7C286E3D653D3E28652E74657874436F6E74656E743D742E6C6162656C7C7C22222C6E756C6C29293B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(19934) := '2065206F665B61722E434C49434B2C61722E4D4F5553455F444F574E2C54452E5461705D29746869732E5F726567697374657228627328746869732E656C656D656E742C652C28653D3E637228652C2130292929293B666F7228636F6E73742065206F66';
wwv_flow_imp.g_varchar2_table(19935) := '5B61722E4D4F5553455F444F574E2C54452E5461705D29746869732E5F726567697374657228627328746869732E5F6C6162656C2C652C28653D3E7B7372286529262628652E64657461696C3E317C7C30213D3D652E627574746F6E297C7C2874686973';
wwv_flow_imp.g_varchar2_table(19936) := '2E76697369626C653F746869732E6869646528293A746869732E73686F772829297D2929293B746869732E5F726567697374657228627328746869732E5F6C6162656C2C61722E4B45595F55502C28653D3E7B636F6E737420743D6E6577207165286529';
wwv_flow_imp.g_varchar2_table(19937) := '3B28742E657175616C732833297C7C742E657175616C732831302929262628637228652C2130292C746869732E76697369626C653F746869732E6869646528293A746869732E73686F772829297D2929293B636F6E737420693D6E28746869732E5F6C61';
wwv_flow_imp.g_varchar2_table(19938) := '62656C293B692626746869732E5F72656769737465722869292C746869732E5F72656769737465722849452E61646454617267657428746869732E5F6C6162656C29297D67657420656C656D656E7428297B72657475726E20746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(19939) := '6E747D73686F7728297B746869732E76697369626C657C7C28746869732E76697369626C653D21302C746869732E5F6F6E4469644368616E67655669736962696C6974792E6669726528213029297D6869646528297B746869732E76697369626C652626';
wwv_flow_imp.g_varchar2_table(19940) := '28746869732E76697369626C653D21312C746869732E5F6F6E4469644368616E67655669736962696C6974792E6669726528213129297D646973706F736528297B73757065722E646973706F736528292C746869732E6869646528292C746869732E626F';
wwv_flow_imp.g_varchar2_table(19941) := '78436F6E7461696E6572262628746869732E626F78436F6E7461696E65722E72656D6F766528292C746869732E626F78436F6E7461696E65723D766F69642030292C746869732E636F6E74656E7473262628746869732E636F6E74656E74732E72656D6F';
wwv_flow_imp.g_varchar2_table(19942) := '766528292C746869732E636F6E74656E74733D766F69642030292C746869732E5F6C6162656C262628746869732E5F6C6162656C2E72656D6F766528292C746869732E5F6C6162656C3D766F69642030297D7D636C61737320756A20657874656E647320';
wwv_flow_imp.g_varchar2_table(19943) := '686A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E5F6F7074696F6E733D742C746869732E5F616374696F6E733D5B5D2C746869732E616374696F6E733D742E616374696F6E737C7C5B5D7D736574206D656E754F';
wwv_flow_imp.g_varchar2_table(19944) := '7074696F6E732865297B746869732E5F6D656E754F7074696F6E733D657D676574206D656E754F7074696F6E7328297B72657475726E20746869732E5F6D656E754F7074696F6E737D67657420616374696F6E7328297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(19945) := '6F7074696F6E732E616374696F6E50726F76696465723F746869732E5F6F7074696F6E732E616374696F6E50726F76696465722E676574416374696F6E7328293A746869732E5F616374696F6E737D73657420616374696F6E732865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(19946) := '616374696F6E733D657D73686F7728297B73757065722E73686F7728292C746869732E656C656D656E742E636C6173734C6973742E616464282261637469766522292C746869732E5F6F7074696F6E732E636F6E746578744D656E7550726F7669646572';
wwv_flow_imp.g_varchar2_table(19947) := '2E73686F77436F6E746578744D656E75287B676574416E63686F723A28293D3E746869732E656C656D656E742C676574416374696F6E733A28293D3E746869732E616374696F6E732C676574416374696F6E73436F6E746578743A28293D3E746869732E';
wwv_flow_imp.g_varchar2_table(19948) := '6D656E754F7074696F6E733F746869732E6D656E754F7074696F6E732E636F6E746578743A6E756C6C2C676574416374696F6E566965774974656D3A28652C74293D3E746869732E6D656E754F7074696F6E732626746869732E6D656E754F7074696F6E';
wwv_flow_imp.g_varchar2_table(19949) := '732E616374696F6E566965774974656D50726F76696465723F746869732E6D656E754F7074696F6E732E616374696F6E566965774974656D50726F766964657228652C74293A766F696420302C6765744B657942696E64696E673A653D3E746869732E6D';
wwv_flow_imp.g_varchar2_table(19950) := '656E754F7074696F6E732626746869732E6D656E754F7074696F6E732E6765744B657942696E64696E673F746869732E6D656E754F7074696F6E732E6765744B657942696E64696E672865293A766F696420302C6765744D656E75436C6173734E616D65';
wwv_flow_imp.g_varchar2_table(19951) := '3A28293D3E746869732E5F6F7074696F6E732E6D656E75436C6173734E616D657C7C22222C6F6E486964653A28293D3E746869732E6F6E4869646528292C616374696F6E52756E6E65723A746869732E6D656E754F7074696F6E733F746869732E6D656E';
wwv_flow_imp.g_varchar2_table(19952) := '754F7074696F6E732E616374696F6E52756E6E65723A766F696420302C616E63686F72416C69676E6D656E743A746869732E6D656E754F7074696F6E733F746869732E6D656E754F7074696F6E732E616E63686F72416C69676E6D656E743A302C646F6D';
wwv_flow_imp.g_varchar2_table(19953) := '466F72536861646F77526F6F743A746869732E5F6F7074696F6E732E6D656E7541734368696C643F746869732E656C656D656E743A766F696420302C736B697054656C656D657472793A746869732E5F6F7074696F6E732E736B697054656C656D657472';
wwv_flow_imp.g_varchar2_table(19954) := '797D297D6869646528297B73757065722E6869646528297D6F6E4869646528297B746869732E6869646528292C746869732E656C656D656E742E636C6173734C6973742E72656D6F7665282261637469766522297D7D636C61737320706A20657874656E';
wwv_flow_imp.g_varchar2_table(19955) := '647320734D7B636F6E7374727563746F7228652C742C6E2C693D4F626A6563742E637265617465286E756C6C29297B7375706572286E756C6C2C652C69292C746869732E616374696F6E4974656D3D6E756C6C2C746869732E5F6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(19956) := '655669736962696C6974793D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67655669736962696C6974793D746869732E5F6F6E4469644368616E67655669736962696C6974792E6576656E742C74686973';
wwv_flow_imp.g_varchar2_table(19957) := '2E6D656E75416374696F6E734F7250726F76696465723D742C746869732E636F6E746578744D656E7550726F76696465723D6E2C746869732E6F7074696F6E733D692C746869732E6F7074696F6E732E616374696F6E52756E6E6572262628746869732E';
wwv_flow_imp.g_varchar2_table(19958) := '616374696F6E52756E6E65723D746869732E6F7074696F6E732E616374696F6E52756E6E6572297D72656E6465722865297B746869732E616374696F6E4974656D3D653B636F6E737420743D41727261792E6973417272617928746869732E6D656E7541';
wwv_flow_imp.g_varchar2_table(19959) := '6374696F6E734F7250726F7669646572292C6E3D7B636F6E746578744D656E7550726F76696465723A746869732E636F6E746578744D656E7550726F76696465722C6C6162656C52656E64657265723A653D3E7B76617220743B746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(19960) := '6E743D757228652C62722822612E616374696F6E2D6C6162656C2229293B6C6574206E3D5B5D3B72657475726E22737472696E67223D3D747970656F6620746869732E6F7074696F6E732E636C6173734E616D65733F6E3D746869732E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(19961) := '2E636C6173734E616D65732E73706C6974282F5C732B2F67292E66696C7465722828653D3E21216529293A746869732E6F7074696F6E732E636C6173734E616D65732626286E3D746869732E6F7074696F6E732E636C6173734E616D6573292C6E2E6669';
wwv_flow_imp.g_varchar2_table(19962) := '6E642828653D3E2269636F6E223D3D3D6529297C7C6E2E707573682822636F6469636F6E22292C746869732E656C656D656E742E636C6173734C6973742E616464282E2E2E6E292C746869732E656C656D656E742E736574417474726962757465282272';
wwv_flow_imp.g_varchar2_table(19963) := '6F6C65222C22627574746F6E22292C746869732E656C656D656E742E7365744174747269627574652822617269612D686173706F707570222C227472756522292C746869732E656C656D656E742E7365744174747269627574652822617269612D657870';
wwv_flow_imp.g_varchar2_table(19964) := '616E646564222C2266616C736522292C746869732E5F616374696F6E2E6C6162656C2626746869732E5F726567697374657228564528292E7365747570557064617461626C65486F766572286E756C6C213D3D28743D746869732E6F7074696F6E732E68';
wwv_flow_imp.g_varchar2_table(19965) := '6F76657244656C6567617465292626766F69642030213D3D743F743A504528226D6F75736522292C746869732E656C656D656E742C746869732E5F616374696F6E2E6C6162656C29292C746869732E656C656D656E742E617269614C6162656C3D746869';
wwv_flow_imp.g_varchar2_table(19966) := '732E5F616374696F6E2E6C6162656C7C7C22222C6E756C6C7D2C6D656E7541734368696C643A746869732E6F7074696F6E732E6D656E7541734368696C642C616374696F6E733A743F746869732E6D656E75416374696F6E734F7250726F76696465723A';
wwv_flow_imp.g_varchar2_table(19967) := '766F696420302C616374696F6E50726F76696465723A743F766F696420303A746869732E6D656E75416374696F6E734F7250726F76696465722C736B697054656C656D657472793A746869732E6F7074696F6E732E736B697054656C656D657472797D3B';
wwv_flow_imp.g_varchar2_table(19968) := '696628746869732E64726F70646F776E4D656E753D746869732E5F7265676973746572286E657720756A28652C6E29292C746869732E5F726567697374657228746869732E64726F70646F776E4D656E752E6F6E4469644368616E67655669736962696C';
wwv_flow_imp.g_varchar2_table(19969) := '6974792828653D3E7B76617220743B6E756C6C3D3D3D28743D746869732E656C656D656E74297C7C766F696420303D3D3D747C7C742E7365744174747269627574652822617269612D657870616E646564222C60247B657D60292C746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(19970) := '69644368616E67655669736962696C6974792E666972652865297D2929292C746869732E64726F70646F776E4D656E752E6D656E754F7074696F6E733D7B616374696F6E566965774974656D50726F76696465723A746869732E6F7074696F6E732E6163';
wwv_flow_imp.g_varchar2_table(19971) := '74696F6E566965774974656D50726F76696465722C616374696F6E52756E6E65723A746869732E616374696F6E52756E6E65722C6765744B657942696E64696E673A746869732E6F7074696F6E732E6B657962696E64696E6750726F76696465722C636F';
wwv_flow_imp.g_varchar2_table(19972) := '6E746578743A746869732E5F636F6E746578747D2C746869732E6F7074696F6E732E616E63686F72416C69676E6D656E7450726F7669646572297B636F6E737420653D746869733B746869732E64726F70646F776E4D656E752E6D656E754F7074696F6E';
wwv_flow_imp.g_varchar2_table(19973) := '733D7B2E2E2E746869732E64726F70646F776E4D656E752E6D656E754F7074696F6E732C67657420616E63686F72416C69676E6D656E7428297B72657475726E20652E6F7074696F6E732E616E63686F72416C69676E6D656E7450726F76696465722829';
wwv_flow_imp.g_varchar2_table(19974) := '7D7D7D746869732E757064617465546F6F6C74697028292C746869732E757064617465456E61626C656428297D676574546F6F6C74697028297B6C657420653D6E756C6C3B72657475726E20746869732E616374696F6E2E746F6F6C7469703F653D7468';
wwv_flow_imp.g_varchar2_table(19975) := '69732E616374696F6E2E746F6F6C7469703A746869732E616374696F6E2E6C6162656C262628653D746869732E616374696F6E2E6C6162656C292C6E756C6C213D653F653A766F696420307D736574416374696F6E436F6E746578742865297B73757065';
wwv_flow_imp.g_varchar2_table(19976) := '722E736574416374696F6E436F6E746578742865292C746869732E64726F70646F776E4D656E75262628746869732E64726F70646F776E4D656E752E6D656E754F7074696F6E733F746869732E64726F70646F776E4D656E752E6D656E754F7074696F6E';
wwv_flow_imp.g_varchar2_table(19977) := '732E636F6E746578743D653A746869732E64726F70646F776E4D656E752E6D656E754F7074696F6E733D7B636F6E746578743A657D297D73686F7728297B76617220653B6E756C6C3D3D3D28653D746869732E64726F70646F776E4D656E75297C7C766F';
wwv_flow_imp.g_varchar2_table(19978) := '696420303D3D3D657C7C652E73686F7728297D757064617465456E61626C656428297B76617220652C743B636F6E7374206E3D21746869732E616374696F6E2E656E61626C65643B6E756C6C3D3D3D28653D746869732E616374696F6E4974656D297C7C';
wwv_flow_imp.g_varchar2_table(19979) := '766F696420303D3D3D657C7C652E636C6173734C6973742E746F67676C65282264697361626C6564222C6E292C6E756C6C3D3D3D28743D746869732E656C656D656E74297C7C766F696420303D3D3D747C7C742E636C6173734C6973742E746F67676C65';
wwv_flow_imp.g_varchar2_table(19980) := '282264697361626C6564222C6E297D7D76617220676A3D6E2839303535292C6D6A3D7B7D3B6D6A2E7374796C655461675472616E73666F726D3D6A7228292C6D6A2E736574417474726962757465733D567228292C6D6A2E696E736572743D467228292E';
wwv_flow_imp.g_varchar2_table(19981) := '62696E64286E756C6C2C226865616422292C6D6A2E646F6D4150493D4F7228292C6D6A2E696E736572745374796C65456C656D656E743D487228292C4E72282928676A2E412C6D6A292C676A2E412626676A2E412E6C6F63616C732626676A2E412E6C6F';
wwv_flow_imp.g_varchar2_table(19982) := '63616C733B76617220666A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F70657274794465736372';
wwv_flow_imp.g_varchar2_table(19983) := '6970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C74';
wwv_flow_imp.g_varchar2_table(19984) := '2C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326';
wwv_flow_imp.g_varchar2_table(19985) := '267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C766A3D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E20626A28652C74';
wwv_flow_imp.g_varchar2_table(19986) := '2C6E2C692C6F2C73297B5F6A28652E676574416374696F6E732874292C6E2C21312C22737472696E67223D3D747970656F6620693F653D3E653D3D3D693A692C6F2C73297D66756E6374696F6E205F6A28652C742C6E2C693D653D3E226E617669676174';
wwv_flow_imp.g_varchar2_table(19987) := '696F6E223D3D3D652C6F3D28293D3E21312C733D2131297B6C657420722C613B41727261792E697341727261792874293F28723D742C613D74293A28723D742E7072696D6172792C613D742E7365636F6E64617279293B636F6E7374206C3D6E65772053';
wwv_flow_imp.g_varchar2_table(19988) := '65743B666F7228636F6E73745B742C6F5D6F662065297B6C657420653B692874293F28653D722C652E6C656E6774683E302626732626652E70757368286E657720796329293A28653D612C652E6C656E6774683E302626652E70757368286E6577207963';
wwv_flow_imp.g_varchar2_table(19989) := '29293B666F72286C65742069206F66206F297B6E262628693D6920696E7374616E63656F662041642626692E616C743F692E616C743A69293B636F6E7374206F3D652E707573682869293B6920696E7374616E63656F6620776326266C2E616464287B67';
wwv_flow_imp.g_varchar2_table(19990) := '726F75703A742C616374696F6E3A692C696E6465783A6F2D317D297D7D666F7228636F6E73747B67726F75703A652C616374696F6E3A742C696E6465783A6E7D6F66206C297B636F6E737420733D692865293F723A612C6C3D742E616374696F6E733B6F';
wwv_flow_imp.g_varchar2_table(19991) := '28742C652C732E6C656E677468292626732E73706C696365286E2C312C2E2E2E6C297D7D6C657420796A3D636C61737320657874656E647320724D7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B737570657228766F696420';
wwv_flow_imp.g_varchar2_table(19992) := '302C652C7B69636F6E3A212821652E636C617373262621652E6974656D2E69636F6E292C6C6162656C3A21652E636C617373262621652E6974656D2E69636F6E2C647261676761626C653A6E756C6C3D3D743F766F696420303A742E647261676761626C';
wwv_flow_imp.g_varchar2_table(19993) := '652C6B657962696E64696E673A6E756C6C3D3D743F766F696420303A742E6B657962696E64696E672C686F76657244656C65676174653A6E756C6C3D3D743F766F696420303A742E686F76657244656C65676174657D292C746869732E5F6B657962696E';
wwv_flow_imp.g_varchar2_table(19994) := '64696E67536572766963653D6E2C746869732E5F6E6F74696669636174696F6E536572766963653D692C746869732E5F636F6E746578744B6579536572766963653D6F2C746869732E5F7468656D65536572766963653D732C746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(19995) := '78744D656E75536572766963653D722C746869732E5F6163636573736962696C697479536572766963653D612C746869732E5F77616E7473416C74436F6D6D616E643D21312C746869732E5F6974656D436C617373446973706F73653D746869732E5F72';
wwv_flow_imp.g_varchar2_table(19996) := '65676973746572286E6577206374292C746869732E5F616C744B65793D4C722E676574496E7374616E636528297D676574205F6D656E754974656D416374696F6E28297B72657475726E20746869732E5F616374696F6E7D676574205F636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(19997) := '416374696F6E28297B72657475726E20746869732E5F77616E7473416C74436F6D6D616E642626746869732E5F6D656E754974656D416374696F6E2E616C747C7C746869732E5F6D656E754974656D416374696F6E7D6173796E63206F6E436C69636B28';
wwv_flow_imp.g_varchar2_table(19998) := '65297B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28293B7472797B617761697420746869732E616374696F6E52756E6E65722E72756E28746869732E5F636F6D6D616E64416374696F6E2C746869732E5F';
wwv_flow_imp.g_varchar2_table(19999) := '636F6E74657874297D63617463682865297B746869732E5F6E6F74696669636174696F6E536572766963652E6572726F722865297D7D72656E6465722865297B69662873757065722E72656E6465722865292C652E636C6173734C6973742E6164642822';
wwv_flow_imp.g_varchar2_table(20000) := '6D656E752D656E74727922292C746869732E6F7074696F6E732E69636F6E2626746869732E5F7570646174654974656D436C61737328746869732E5F6D656E754974656D416374696F6E2E6974656D292C746869732E5F6D656E754974656D416374696F';
wwv_flow_imp.g_varchar2_table(20001) := '6E2E616C74297B6C657420743D21313B636F6E7374206E3D28293D3E7B76617220653B636F6E7374206E3D2121286E756C6C3D3D3D28653D746869732E5F6D656E754974656D416374696F6E2E616C74297C7C766F696420303D3D3D653F766F69642030';
wwv_flow_imp.g_varchar2_table(20002) := '3A652E656E61626C65642926262821746869732E5F6163636573736962696C697479536572766963652E69734D6F74696F6E5265647563656428297C7C7429262628746869732E5F616C744B65792E6B65795374617475732E616C744B65797C7C746869';
wwv_flow_imp.g_varchar2_table(20003) := '732E5F616C744B65792E6B65795374617475732E73686966744B6579262674293B6E213D3D746869732E5F77616E7473416C74436F6D6D616E64262628746869732E5F77616E7473416C74436F6D6D616E643D6E2C746869732E7570646174654C616265';
wwv_flow_imp.g_varchar2_table(20004) := '6C28292C746869732E757064617465546F6F6C74697028292C746869732E757064617465436C6173732829297D3B746869732E5F726567697374657228746869732E5F616C744B65792E6576656E74286E29292C746869732E5F72656769737465722862';
wwv_flow_imp.g_varchar2_table(20005) := '7328652C226D6F7573656C65617665222C28653D3E7B743D21312C6E28297D2929292C746869732E5F726567697374657228627328652C226D6F757365656E746572222C28653D3E7B743D21302C6E28297D2929292C6E28297D7D7570646174654C6162';
wwv_flow_imp.g_varchar2_table(20006) := '656C28297B746869732E6F7074696F6E732E6C6162656C2626746869732E6C6162656C262628746869732E6C6162656C2E74657874436F6E74656E743D746869732E5F636F6D6D616E64416374696F6E2E6C6162656C297D676574546F6F6C7469702829';
wwv_flow_imp.g_varchar2_table(20007) := '7B76617220653B636F6E737420743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728746869732E5F636F6D6D616E64416374696F6E2E69642C746869732E5F636F6E746578744B65795365727669';
wwv_flow_imp.g_varchar2_table(20008) := '6365292C6E3D742626742E6765744C6162656C28292C693D746869732E5F636F6D6D616E64416374696F6E2E746F6F6C7469707C7C746869732E5F636F6D6D616E64416374696F6E2E6C6162656C3B6C6574206F3D6E3F6228302C227B307D20287B317D';
wwv_flow_imp.g_varchar2_table(20009) := '29222C692C6E293A693B69662821746869732E5F77616E7473416C74436F6D6D616E642626286E756C6C3D3D3D28653D746869732E5F6D656E754974656D416374696F6E2E616C74297C7C766F696420303D3D3D653F766F696420303A652E656E61626C';
wwv_flow_imp.g_varchar2_table(20010) := '656429297B636F6E737420653D746869732E5F6D656E754974656D416374696F6E2E616C742E746F6F6C7469707C7C746869732E5F6D656E754974656D416374696F6E2E616C742E6C6162656C2C743D746869732E5F6B657962696E64696E6753657276';
wwv_flow_imp.g_varchar2_table(20011) := '6963652E6C6F6F6B75704B657962696E64696E6728746869732E5F6D656E754974656D416374696F6E2E616C742E69642C746869732E5F636F6E746578744B657953657276696365292C6E3D742626742E6765744C6162656C28292C693D6E3F6228302C';
wwv_flow_imp.g_varchar2_table(20012) := '227B307D20287B317D29222C652C6E293A653B6F3D6228302C227B307D5C6E5B7B317D5D207B327D222C6F2C754D2E6D6F6469666965724C6162656C735B74655D2E616C744B65792C69297D72657475726E206F7D757064617465436C61737328297B74';
wwv_flow_imp.g_varchar2_table(20013) := '6869732E6F7074696F6E732E69636F6E262628746869732E5F636F6D6D616E64416374696F6E213D3D746869732E5F6D656E754974656D416374696F6E3F746869732E5F6D656E754974656D416374696F6E2E616C742626746869732E5F757064617465';
wwv_flow_imp.g_varchar2_table(20014) := '4974656D436C61737328746869732E5F6D656E754974656D416374696F6E2E616C742E6974656D293A746869732E5F7570646174654974656D436C61737328746869732E5F6D656E754974656D416374696F6E2E6974656D29297D5F7570646174654974';
wwv_flow_imp.g_varchar2_table(20015) := '656D436C6173732865297B746869732E5F6974656D436C617373446973706F73652E76616C75653D766F696420303B636F6E73747B656C656D656E743A742C6C6162656C3A6E7D3D746869733B69662821747C7C216E2972657475726E3B636F6E737420';
wwv_flow_imp.g_varchar2_table(20016) := '693D746869732E5F636F6D6D616E64416374696F6E2E636865636B65642626286F3D652E746F67676C6564292626766F69642030213D3D6F2E636F6E646974696F6E2626652E746F67676C65642E69636F6E3F652E746F67676C65642E69636F6E3A652E';
wwv_flow_imp.g_varchar2_table(20017) := '69636F6E3B766172206F3B6966286929696628546C2E69735468656D6549636F6E286929297B636F6E737420653D546C2E6173436C6173734E616D6541727261792869293B6E2E636C6173734C6973742E616464282E2E2E65292C746869732E5F697465';
wwv_flow_imp.g_varchar2_table(20018) := '6D436C617373446973706F73652E76616C75653D7274282828293D3E7B6E2E636C6173734C6973742E72656D6F7665282E2E2E65297D29297D656C7365206E2E7374796C652E6261636B67726F756E64496D6167653D4E6228746869732E5F7468656D65';
wwv_flow_imp.g_varchar2_table(20019) := '536572766963652E676574436F6C6F725468656D6528292E74797065293F537228692E6461726B293A537228692E6C69676874292C6E2E636C6173734C6973742E616464282269636F6E22292C746869732E5F6974656D436C617373446973706F73652E';
wwv_flow_imp.g_varchar2_table(20020) := '76616C75653D7374287274282828293D3E7B6E2E7374796C652E6261636B67726F756E64496D6167653D22222C6E2E636C6173734C6973742E72656D6F7665282269636F6E22297D29292C746869732E5F7468656D65536572766963652E6F6E44696443';
wwv_flow_imp.g_varchar2_table(20021) := '6F6C6F725468656D654368616E6765282828293D3E7B746869732E757064617465436C61737328297D2929297D7D3B796A3D666A285B766A28322C2445292C766A28332C7344292C766A28342C6364292C766A28352C5062292C766A28362C7145292C76';
wwv_flow_imp.g_varchar2_table(20022) := '6A28372C5953295D2C796A293B6C657420776A3D636C61737320657874656E647320706A7B636F6E7374727563746F7228652C742C6E2C692C6F297B76617220732C722C613B636F6E7374206C3D7B2E2E2E742C6D656E7541734368696C643A6E756C6C';
wwv_flow_imp.g_varchar2_table(20023) := '213D3D28733D6E756C6C3D3D743F766F696420303A742E6D656E7541734368696C64292626766F69642030213D3D732626732C636C6173734E616D65733A6E756C6C213D3D28723D6E756C6C3D3D743F766F696420303A742E636C6173734E616D657329';
wwv_flow_imp.g_varchar2_table(20024) := '2626766F69642030213D3D723F723A546C2E69735468656D6549636F6E28652E6974656D2E69636F6E293F546C2E6173436C6173734E616D6528652E6974656D2E69636F6E293A766F696420302C6B657962696E64696E6750726F76696465723A6E756C';
wwv_flow_imp.g_varchar2_table(20025) := '6C213D3D28613D6E756C6C3D3D743F766F696420303A742E6B657962696E64696E6750726F7669646572292626766F69642030213D3D613F613A653D3E6E2E6C6F6F6B75704B657962696E64696E6728652E6964297D3B737570657228652C7B67657441';
wwv_flow_imp.g_varchar2_table(20026) := '6374696F6E733A28293D3E652E616374696F6E737D2C692C6C292C746869732E5F6B657962696E64696E67536572766963653D6E2C746869732E5F636F6E746578744D656E75536572766963653D692C746869732E5F7468656D65536572766963653D6F';
wwv_flow_imp.g_varchar2_table(20027) := '7D72656E6465722865297B73757065722E72656E6465722865292C796C28746869732E656C656D656E74292C652E636C6173734C6973742E61646428226D656E752D656E74727922293B636F6E737420743D746869732E5F616374696F6E2C7B69636F6E';
wwv_flow_imp.g_varchar2_table(20028) := '3A6E7D3D742E6974656D3B6966286E262621546C2E69735468656D6549636F6E286E29297B746869732E656C656D656E742E636C6173734C6973742E616464282269636F6E22293B636F6E737420653D28293D3E7B746869732E656C656D656E74262628';
wwv_flow_imp.g_varchar2_table(20029) := '746869732E656C656D656E742E7374796C652E6261636B67726F756E64496D6167653D4E6228746869732E5F7468656D65536572766963652E676574436F6C6F725468656D6528292E74797065293F5372286E2E6461726B293A5372286E2E6C69676874';
wwv_flow_imp.g_varchar2_table(20030) := '29297D3B6528292C746869732E5F726567697374657228746869732E5F7468656D65536572766963652E6F6E446964436F6C6F725468656D654368616E6765282828293D3E7B6528297D2929297D7D7D3B776A3D666A285B766A28322C2445292C766A28';
wwv_flow_imp.g_varchar2_table(20031) := '332C7145292C766A28342C5062295D2C776A293B6C657420436A3D636C61737320657874656E647320734D7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B766172206C2C632C643B6C657420683B7375706572286E756C6C2C';
wwv_flow_imp.g_varchar2_table(20032) := '65292C746869732E5F6B657962696E64696E67536572766963653D6E2C746869732E5F6E6F74696669636174696F6E536572766963653D692C746869732E5F636F6E746578744D656E75536572766963653D6F2C746869732E5F6D656E75536572766963';
wwv_flow_imp.g_varchar2_table(20033) := '653D732C746869732E5F696E737461536572766963653D722C746869732E5F73746F72616765536572766963653D612C746869732E5F636F6E7461696E65723D6E756C6C2C746869732E5F6F7074696F6E733D742C746869732E5F73746F726167654B65';
wwv_flow_imp.g_varchar2_table(20034) := '793D60247B652E6974656D2E7375626D656E752E69647D5F6C617374416374696F6E4964603B636F6E737420753D286E756C6C3D3D743F766F696420303A742E706572736973744C617374416374696F6E4964293F612E67657428746869732E5F73746F';
wwv_flow_imp.g_varchar2_table(20035) := '726167654B65792C31293A766F696420303B75262628683D652E616374696F6E732E66696E642828653D3E753D3D3D652E69642929292C687C7C28683D652E616374696F6E735B305D292C746869732E5F64656661756C74416374696F6E3D746869732E';
wwv_flow_imp.g_varchar2_table(20036) := '5F696E737461536572766963652E637265617465496E7374616E636528796A2C682C7B6B657962696E64696E673A746869732E5F67657444656661756C74416374696F6E4B657962696E64696E674C6162656C2868297D293B636F6E737420703D7B6B65';
wwv_flow_imp.g_varchar2_table(20037) := '7962696E64696E6750726F76696465723A653D3E746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728652E6964292C2E2E2E742C6D656E7541734368696C643A6E756C6C3D3D3D286C3D6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(20038) := '743F766F696420303A742E6D656E7541734368696C64297C7C766F696420303D3D3D6C7C7C6C2C636C6173734E616D65733A6E756C6C213D3D28633D6E756C6C3D3D743F766F696420303A742E636C6173734E616D6573292626766F69642030213D3D63';
wwv_flow_imp.g_varchar2_table(20039) := '3F633A5B22636F6469636F6E222C22636F6469636F6E2D63686576726F6E2D646F776E225D2C616374696F6E52756E6E65723A6E756C6C213D3D28643D6E756C6C3D3D743F766F696420303A742E616374696F6E52756E6E6572292626766F6964203021';
wwv_flow_imp.g_varchar2_table(20040) := '3D3D643F643A6E6577205F637D3B746869732E5F64726F70646F776E3D6E657720706A28652C652E616374696F6E732C746869732E5F636F6E746578744D656E75536572766963652C70292C746869732E5F726567697374657228746869732E5F64726F';
wwv_flow_imp.g_varchar2_table(20041) := '70646F776E2E616374696F6E52756E6E65722E6F6E44696452756E2828653D3E7B652E616374696F6E20696E7374616E63656F662041642626746869732E75706461746528652E616374696F6E297D2929297D7570646174652865297B76617220743B28';
wwv_flow_imp.g_varchar2_table(20042) := '6E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E706572736973744C617374416374696F6E4964292626746869732E5F73746F72616765536572766963652E73746F726528746869732E';
wwv_flow_imp.g_varchar2_table(20043) := '5F73746F726167654B65792C652E69642C312C31292C746869732E5F64656661756C74416374696F6E2E646973706F736528292C746869732E5F64656661756C74416374696F6E3D746869732E5F696E737461536572766963652E637265617465496E73';
wwv_flow_imp.g_varchar2_table(20044) := '74616E636528796A2C652C7B6B657962696E64696E673A746869732E5F67657444656661756C74416374696F6E4B657962696E64696E674C6162656C2865297D292C746869732E5F64656661756C74416374696F6E2E616374696F6E52756E6E65723D6E';
wwv_flow_imp.g_varchar2_table(20045) := '657720636C61737320657874656E6473205F637B6173796E632072756E416374696F6E28652C74297B617761697420652E72756E28766F69642030297D7D2C746869732E5F636F6E7461696E65722626746869732E5F64656661756C74416374696F6E2E';
wwv_flow_imp.g_varchar2_table(20046) := '72656E64657228707228746869732E5F636F6E7461696E65722C627228222E616374696F6E2D636F6E7461696E6572222929297D5F67657444656661756C74416374696F6E4B657962696E64696E674C6162656C2865297B76617220743B6C6574206E3B';
wwv_flow_imp.g_varchar2_table(20047) := '6966286E756C6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E72656E6465724B657962696E64696E675769746844656661756C74416374696F6E4C6162656C297B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(20048) := '732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728652E6964293B742626286E3D6028247B742E6765744C6162656C28297D2960297D72657475726E206E7D736574416374696F6E436F6E746578742865297B';
wwv_flow_imp.g_varchar2_table(20049) := '73757065722E736574416374696F6E436F6E746578742865292C746869732E5F64656661756C74416374696F6E2E736574416374696F6E436F6E746578742865292C746869732E5F64726F70646F776E2E736574416374696F6E436F6E74657874286529';
wwv_flow_imp.g_varchar2_table(20050) := '7D72656E6465722865297B746869732E5F636F6E7461696E65723D652C73757065722E72656E64657228746869732E5F636F6E7461696E6572292C746869732E5F636F6E7461696E65722E636C6173734C6973742E61646428226D6F6E61636F2D64726F';
wwv_flow_imp.g_varchar2_table(20051) := '70646F776E2D776974682D64656661756C7422293B636F6E737420743D627228222E616374696F6E2D636F6E7461696E657222293B746869732E5F64656661756C74416374696F6E2E72656E64657228757228746869732E5F636F6E7461696E65722C74';
wwv_flow_imp.g_varchar2_table(20052) := '29292C746869732E5F726567697374657228627328742C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B742E657175616C7328313729262628746869732E5F64656661756C74416374696F6E2E656C656D656E74';
wwv_flow_imp.g_varchar2_table(20053) := '2E746162496E6465783D2D312C746869732E5F64726F70646F776E2E666F63757328292C742E73746F7050726F7061676174696F6E2829297D2929293B636F6E7374206E3D627228222E64726F70646F776E2D616374696F6E2D636F6E7461696E657222';
wwv_flow_imp.g_varchar2_table(20054) := '293B746869732E5F64726F70646F776E2E72656E64657228757228746869732E5F636F6E7461696E65722C6E29292C746869732E5F7265676973746572286273286E2C61722E4B45595F444F574E2C28653D3E7B76617220743B636F6E7374206E3D6E65';
wwv_flow_imp.g_varchar2_table(20055) := '772071652865293B6E2E657175616C7328313529262628746869732E5F64656661756C74416374696F6E2E656C656D656E742E746162496E6465783D302C746869732E5F64726F70646F776E2E736574466F63757361626C65282131292C6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(20056) := '3D28743D746869732E5F64656661756C74416374696F6E2E656C656D656E74297C7C766F696420303D3D3D747C7C742E666F63757328292C6E2E73746F7050726F7061676174696F6E2829297D2929297D666F6375732865297B653F746869732E5F6472';
wwv_flow_imp.g_varchar2_table(20057) := '6F70646F776E2E666F63757328293A28746869732E5F64656661756C74416374696F6E2E656C656D656E742E746162496E6465783D302C746869732E5F64656661756C74416374696F6E2E656C656D656E742E666F6375732829297D626C757228297B74';
wwv_flow_imp.g_varchar2_table(20058) := '6869732E5F64656661756C74416374696F6E2E656C656D656E742E746162496E6465783D2D312C746869732E5F64726F70646F776E2E626C757228292C746869732E5F636F6E7461696E65722E626C757228297D736574466F63757361626C652865297B';
wwv_flow_imp.g_varchar2_table(20059) := '653F746869732E5F64656661756C74416374696F6E2E656C656D656E742E746162496E6465783D303A28746869732E5F64656661756C74416374696F6E2E656C656D656E742E746162496E6465783D2D312C746869732E5F64726F70646F776E2E736574';
wwv_flow_imp.g_varchar2_table(20060) := '466F63757361626C6528213129297D646973706F736528297B746869732E5F64656661756C74416374696F6E2E646973706F736528292C746869732E5F64726F70646F776E2E646973706F736528292C73757065722E646973706F736528297D7D3B436A';
wwv_flow_imp.g_varchar2_table(20061) := '3D666A285B766A28322C2445292C766A28332C7344292C766A28342C7145292C766A28352C4464292C766A28362C7563292C766A28372C5142295D2C436A293B6C657420536A3D636C61737320657874656E647320614D7B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(20062) := '652C74297B7375706572286E756C6C2C652C652E616374696F6E732E6D61702828653D3E287B746578743A652E69643D3D3D79632E49443F22E29480E29480E29480E29480E29480E29480E29480E29480E29480223A652E6C6162656C2C697344697361';
wwv_flow_imp.g_varchar2_table(20063) := '626C65643A21652E656E61626C65647D2929292C302C742C4D4D2C7B617269614C6162656C3A652E746F6F6C7469702C6F7074696F6E7341734368696C6472656E3A21307D292C746869732E73656C656374284D6174682E6D617828302C652E61637469';
wwv_flow_imp.g_varchar2_table(20064) := '6F6E732E66696E64496E6465782828653D3E652E636865636B6564292929297D72656E6465722865297B73757065722E72656E6465722865292C652E7374796C652E626F72646572436F6C6F723D786D286B76297D72756E416374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(20065) := '636F6E7374206E3D746869732E616374696F6E2E616374696F6E735B745D3B6E2626746869732E616374696F6E52756E6E65722E72756E286E297D7D3B66756E6374696F6E20786A28652C742C6E297B72657475726E207420696E7374616E63656F6620';
wwv_flow_imp.g_varchar2_table(20066) := '41643F652E637265617465496E7374616E636528796A2C742C6E293A7420696E7374616E63656F66204D643F742E6974656D2E697353656C656374696F6E3F652E637265617465496E7374616E636528536A2C74293A742E6974656D2E72656D656D6265';
wwv_flow_imp.g_varchar2_table(20067) := '7244656661756C74416374696F6E3F652E637265617465496E7374616E636528436A2C742C7B2E2E2E6E2C706572736973744C617374416374696F6E49643A21307D293A652E637265617465496E7374616E636528776A2C742C6E293A766F696420307D';
wwv_flow_imp.g_varchar2_table(20068) := '536A3D666A285B766A28312C6A45295D2C536A293B766172206B6A3D6E2837393832292C456A3D7B7D3B456A2E7374796C655461675472616E73666F726D3D6A7228292C456A2E736574417474726962757465733D567228292C456A2E696E736572743D';
wwv_flow_imp.g_varchar2_table(20069) := '467228292E62696E64286E756C6C2C226865616422292C456A2E646F6D4150493D4F7228292C456A2E696E736572745374796C65456C656D656E743D487228292C4E722829286B6A2E412C456A292C6B6A2E4126266B6A2E412E6C6F63616C7326266B6A';
wwv_flow_imp.g_varchar2_table(20070) := '2E412E6C6F63616C733B636C617373204C6A20657874656E6473206C747B636F6E7374727563746F7228652C742C6E3D7B6F7269656E746174696F6E3A307D297B76617220693B737570657228292C746869732E7375626D656E75416374696F6E566965';
wwv_flow_imp.g_varchar2_table(20071) := '774974656D733D5B5D2C746869732E6861735365636F6E64617279416374696F6E733D21312C746869732E5F6F6E4469644368616E676544726F70646F776E5669736962696C6974793D746869732E5F7265676973746572286E6577204C74292C746869';
wwv_flow_imp.g_varchar2_table(20072) := '732E6F6E4469644368616E676544726F70646F776E5669736962696C6974793D746869732E5F6F6E4469644368616E676544726F70646F776E5669736962696C6974792E6576656E742C746869732E646973706F7361626C65733D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(20073) := '6973746572286E6577206174292C6E2E686F76657244656C65676174653D6E756C6C213D3D28693D6E2E686F76657244656C6567617465292626766F69642030213D3D693F693A746869732E5F7265676973746572284F452829292C746869732E6F7074';
wwv_flow_imp.g_varchar2_table(20074) := '696F6E733D6E2C746869732E6C6F6F6B75704B657962696E64696E67733D2266756E6374696F6E223D3D747970656F6620746869732E6F7074696F6E732E6765744B657942696E64696E672C746869732E746F67676C654D656E75416374696F6E3D7468';
wwv_flow_imp.g_varchar2_table(20075) := '69732E5F7265676973746572286E657720446A282828293D3E7B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E746F67676C654D656E75416374696F6E566965774974656D297C7C766F696420303D3D3D653F766F696420303A65';
wwv_flow_imp.g_varchar2_table(20076) := '2E73686F7728297D292C6E2E746F67676C654D656E755469746C6529292C746869732E656C656D656E743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E656C656D656E742E636C6173734E616D653D226D6F6E';
wwv_flow_imp.g_varchar2_table(20077) := '61636F2D746F6F6C626172222C652E617070656E644368696C6428746869732E656C656D656E74292C746869732E616374696F6E4261723D746869732E5F7265676973746572286E6577206C4D28746869732E656C656D656E742C7B6F7269656E746174';
wwv_flow_imp.g_varchar2_table(20078) := '696F6E3A6E2E6F7269656E746174696F6E2C617269614C6162656C3A6E2E617269614C6162656C2C616374696F6E52756E6E65723A6E2E616374696F6E52756E6E65722C616C6C6F77436F6E746578744D656E753A6E2E616C6C6F77436F6E746578744D';
wwv_flow_imp.g_varchar2_table(20079) := '656E752C686967686C69676874546F67676C65644974656D733A6E2E686967686C69676874546F67676C65644974656D732C686F76657244656C65676174653A6E2E686F76657244656C65676174652C616374696F6E566965774974656D50726F766964';
wwv_flow_imp.g_varchar2_table(20080) := '65723A28652C69293D3E7B766172206F3B696628652E69643D3D3D446A2E49442972657475726E20746869732E746F67676C654D656E75416374696F6E566965774974656D3D6E657720706A28652C652E6D656E75416374696F6E732C742C7B61637469';
wwv_flow_imp.g_varchar2_table(20081) := '6F6E566965774974656D50726F76696465723A746869732E6F7074696F6E732E616374696F6E566965774974656D50726F76696465722C616374696F6E52756E6E65723A746869732E616374696F6E52756E6E65722C6B657962696E64696E6750726F76';
wwv_flow_imp.g_varchar2_table(20082) := '696465723A746869732E6F7074696F6E732E6765744B657942696E64696E672C636C6173734E616D65733A546C2E6173436C6173734E616D654172726179286E756C6C213D3D286F3D6E2E6D6F726549636F6E292626766F69642030213D3D6F3F6F3A4C';
wwv_flow_imp.g_varchar2_table(20083) := '6C2E746F6F6C4261724D6F7265292C616E63686F72416C69676E6D656E7450726F76696465723A746869732E6F7074696F6E732E616E63686F72416C69676E6D656E7450726F76696465722C6D656E7541734368696C643A2121746869732E6F7074696F';
wwv_flow_imp.g_varchar2_table(20084) := '6E732E72656E64657244726F70646F776E41734368696C64456C656D656E742C736B697054656C656D657472793A746869732E6F7074696F6E732E736B697054656C656D657472792C69734D656E753A21302C686F76657244656C65676174653A746869';
wwv_flow_imp.g_varchar2_table(20085) := '732E6F7074696F6E732E686F76657244656C65676174657D292C746869732E746F67676C654D656E75416374696F6E566965774974656D2E736574416374696F6E436F6E7465787428746869732E616374696F6E4261722E636F6E74657874292C746869';
wwv_flow_imp.g_varchar2_table(20086) := '732E646973706F7361626C65732E61646428746869732E5F6F6E4469644368616E676544726F70646F776E5669736962696C6974792E61646428746869732E746F67676C654D656E75416374696F6E566965774974656D2E6F6E4469644368616E676556';
wwv_flow_imp.g_varchar2_table(20087) := '69736962696C69747929292C746869732E746F67676C654D656E75416374696F6E566965774974656D3B6966286E2E616374696F6E566965774974656D50726F7669646572297B636F6E737420743D6E2E616374696F6E566965774974656D50726F7669';
wwv_flow_imp.g_varchar2_table(20088) := '64657228652C69293B696628742972657475726E20747D6966286520696E7374616E63656F66207763297B636F6E7374206E3D6E657720706A28652C652E616374696F6E732C742C7B616374696F6E566965774974656D50726F76696465723A74686973';
wwv_flow_imp.g_varchar2_table(20089) := '2E6F7074696F6E732E616374696F6E566965774974656D50726F76696465722C616374696F6E52756E6E65723A746869732E616374696F6E52756E6E65722C6B657962696E64696E6750726F76696465723A746869732E6F7074696F6E732E6765744B65';
wwv_flow_imp.g_varchar2_table(20090) := '7942696E64696E672C636C6173734E616D65733A652E636C6173732C616E63686F72416C69676E6D656E7450726F76696465723A746869732E6F7074696F6E732E616E63686F72416C69676E6D656E7450726F76696465722C6D656E7541734368696C64';
wwv_flow_imp.g_varchar2_table(20091) := '3A2121746869732E6F7074696F6E732E72656E64657244726F70646F776E41734368696C64456C656D656E742C736B697054656C656D657472793A746869732E6F7074696F6E732E736B697054656C656D657472792C686F76657244656C65676174653A';
wwv_flow_imp.g_varchar2_table(20092) := '746869732E6F7074696F6E732E686F76657244656C65676174657D293B72657475726E206E2E736574416374696F6E436F6E7465787428746869732E616374696F6E4261722E636F6E74657874292C746869732E7375626D656E75416374696F6E566965';
wwv_flow_imp.g_varchar2_table(20093) := '774974656D732E70757368286E292C746869732E646973706F7361626C65732E61646428746869732E5F6F6E4469644368616E676544726F70646F776E5669736962696C6974792E616464286E2E6F6E4469644368616E67655669736962696C69747929';
wwv_flow_imp.g_varchar2_table(20094) := '292C6E7D7D7D29297D73657420616374696F6E52756E6E65722865297B746869732E616374696F6E4261722E616374696F6E52756E6E65723D657D67657420616374696F6E52756E6E657228297B72657475726E20746869732E616374696F6E4261722E';
wwv_flow_imp.g_varchar2_table(20095) := '616374696F6E52756E6E65727D676574456C656D656E7428297B72657475726E20746869732E656C656D656E747D6765744974656D416374696F6E2865297B72657475726E20746869732E616374696F6E4261722E676574416374696F6E2865297D7365';
wwv_flow_imp.g_varchar2_table(20096) := '74416374696F6E7328652C74297B746869732E636C65617228293B636F6E7374206E3D653F652E736C6963652830293A5B5D3B746869732E6861735365636F6E64617279416374696F6E733D212128742626742E6C656E6774683E30292C746869732E68';
wwv_flow_imp.g_varchar2_table(20097) := '61735365636F6E64617279416374696F6E73262674262628746869732E746F67676C654D656E75416374696F6E2E6D656E75416374696F6E733D742E736C6963652830292C6E2E7075736828746869732E746F67676C654D656E75416374696F6E29292C';
wwv_flow_imp.g_varchar2_table(20098) := '6E2E666F72456163682828653D3E7B746869732E616374696F6E4261722E7075736828652C7B69636F6E3A21302C6C6162656C3A21312C6B657962696E64696E673A746869732E6765744B657962696E64696E674C6162656C2865297D297D29297D6765';
wwv_flow_imp.g_varchar2_table(20099) := '744B657962696E64696E674C6162656C2865297B76617220742C6E2C693B636F6E7374206F3D746869732E6C6F6F6B75704B657962696E64696E67733F6E756C6C3D3D3D286E3D28743D746869732E6F7074696F6E73292E6765744B657942696E64696E';
wwv_flow_imp.g_varchar2_table(20100) := '67297C7C766F696420303D3D3D6E3F766F696420303A6E2E63616C6C28742C65293A766F696420303B72657475726E206E756C6C213D3D28693D6E756C6C3D3D6F3F766F696420303A6F2E6765744C6162656C2829292626766F69642030213D3D693F69';
wwv_flow_imp.g_varchar2_table(20101) := '3A766F696420307D636C65617228297B746869732E7375626D656E75416374696F6E566965774974656D733D5B5D2C746869732E646973706F7361626C65732E636C65617228292C746869732E616374696F6E4261722E636C65617228297D646973706F';
wwv_flow_imp.g_varchar2_table(20102) := '736528297B746869732E636C65617228292C746869732E646973706F7361626C65732E646973706F736528292C73757065722E646973706F736528297D7D636C61737320446A20657874656E64732062637B636F6E7374727563746F7228652C74297B74';
wwv_flow_imp.g_varchar2_table(20103) := '3D747C7C6228302C224D6F726520416374696F6E732E2E2E22292C737570657228446A2E49442C742C766F696420302C2130292C746869732E5F6D656E75416374696F6E733D5B5D2C746869732E746F67676C6544726F70646F776E4D656E753D657D61';
wwv_flow_imp.g_varchar2_table(20104) := '73796E632072756E28297B746869732E746F67676C6544726F70646F776E4D656E7528297D676574206D656E75416374696F6E7328297B72657475726E20746869732E5F6D656E75416374696F6E737D736574206D656E75416374696F6E732865297B74';
wwv_flow_imp.g_varchar2_table(20105) := '6869732E5F6D656E75416374696F6E733D657D7D446A2E49443D22746F6F6C6261722E746F67676C652E6D6F7265223B76617220546A2C496A2C4D6A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E';
wwv_flow_imp.g_varchar2_table(20106) := '6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(20107) := '223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D292626';
wwv_flow_imp.g_varchar2_table(20108) := '28723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C416A3D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(20109) := '297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204E6A3D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F636F6D6D616E64536572766963653D652C746869732E5F6B65796269';
wwv_flow_imp.g_varchar2_table(20110) := '6E64696E67536572766963653D742C746869732E5F68696464656E5374617465733D6E657720506A286E297D6372656174654D656E7528652C742C6E297B72657475726E206E657720526A28652C746869732E5F68696464656E5374617465732C7B656D';
wwv_flow_imp.g_varchar2_table(20111) := '69744576656E7473466F725375626D656E754368616E6765733A21312C6576656E744465626F756E636544656C61793A35302C2E2E2E6E7D2C746869732E5F636F6D6D616E64536572766963652C746869732E5F6B657962696E64696E67536572766963';
wwv_flow_imp.g_varchar2_table(20112) := '652C74297D726573657448696464656E5374617465732865297B746869732E5F68696464656E5374617465732E72657365742865297D7D3B4E6A3D4D6A285B416A28302C7863292C416A28312C2445292C416A28322C5142295D2C4E6A293B6C65742050';
wwv_flow_imp.g_varchar2_table(20113) := '6A3D546A3D636C6173737B636F6E7374727563746F722865297B746869732E5F73746F72616765536572766963653D652C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F6F6E4469644368616E67653D6E65772043742C74';
wwv_flow_imp.g_varchar2_table(20114) := '6869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F69676E6F72654368616E67654576656E743D21312C746869732E5F68696464656E427944656661756C7443616368653D6E6577204D61';
wwv_flow_imp.g_varchar2_table(20115) := '703B7472797B636F6E737420743D652E67657428546A2E5F6B65792C302C227B7D22293B746869732E5F646174613D4A534F4E2E70617273652874297D63617463682865297B746869732E5F646174613D4F626A6563742E637265617465286E756C6C29';
wwv_flow_imp.g_varchar2_table(20116) := '7D746869732E5F646973706F7361626C65732E61646428652E6F6E4469644368616E676556616C756528302C546A2E5F6B65792C746869732E5F646973706F7361626C657329282828293D3E7B69662821746869732E5F69676E6F72654368616E676545';
wwv_flow_imp.g_varchar2_table(20117) := '76656E74297472797B636F6E737420743D652E67657428546A2E5F6B65792C302C227B7D22293B746869732E5F646174613D4A534F4E2E70617273652874297D63617463682865297B636F6E736F6C652E6C6F6728224641494C454420746F2072656164';
wwv_flow_imp.g_varchar2_table(20118) := '2073746F7261676520616674657220555044415445222C65297D746869732E5F6F6E4469644368616E67652E6669726528297D2929297D646973706F736528297B746869732E5F6F6E4469644368616E67652E646973706F736528292C746869732E5F64';
wwv_flow_imp.g_varchar2_table(20119) := '6973706F7361626C65732E646973706F736528297D5F697348696464656E427944656661756C7428652C74297B766172206E3B72657475726E206E756C6C213D3D286E3D746869732E5F68696464656E427944656661756C7443616368652E6765742860';
wwv_flow_imp.g_varchar2_table(20120) := '247B652E69647D2F247B747D6029292626766F69642030213D3D6E26266E7D73657444656661756C74537461746528652C742C6E297B746869732E5F68696464656E427944656661756C7443616368652E7365742860247B652E69647D2F247B747D602C';
wwv_flow_imp.g_varchar2_table(20121) := '6E297D697348696464656E28652C74297B766172206E2C693B636F6E7374206F3D746869732E5F697348696464656E427944656661756C7428652C74292C733D6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F646174615B652E69645D';
wwv_flow_imp.g_varchar2_table(20122) := '297C7C766F696420303D3D3D6E3F766F696420303A6E2E696E636C75646573287429292626766F69642030213D3D692626693B72657475726E206F3F21733A737D75706461746548696464656E28652C742C6E297B746869732E5F697348696464656E42';
wwv_flow_imp.g_varchar2_table(20123) := '7944656661756C7428652C74292626286E3D216E293B636F6E737420693D746869732E5F646174615B652E69645D3B6966286E29693F692E696E6465784F662874293C302626692E707573682874293A746869732E5F646174615B652E69645D3D5B745D';
wwv_flow_imp.g_varchar2_table(20124) := '3B656C73652069662869297B636F6E7374206E3D692E696E6465784F662874293B6E3E3D30262666756E6374696F6E28652C74297B636F6E7374206E3D652E6C656E6774682D313B743C6E262628655B745D3D655B6E5D292C652E706F7028297D28692C';
wwv_flow_imp.g_varchar2_table(20125) := '6E292C303D3D3D692E6C656E677468262664656C65746520746869732E5F646174615B652E69645D7D746869732E5F7065727369737428297D72657365742865297B696628766F696420303D3D3D6529746869732E5F646174613D4F626A6563742E6372';
wwv_flow_imp.g_varchar2_table(20126) := '65617465286E756C6C292C746869732E5F7065727369737428293B656C73657B666F7228636F6E73747B69643A747D6F66206529746869732E5F646174615B745D262664656C65746520746869732E5F646174615B745D3B746869732E5F706572736973';
wwv_flow_imp.g_varchar2_table(20127) := '7428297D7D5F7065727369737428297B7472797B746869732E5F69676E6F72654368616E67654576656E743D21303B636F6E737420653D4A534F4E2E737472696E6769667928746869732E5F64617461293B746869732E5F73746F726167655365727669';
wwv_flow_imp.g_varchar2_table(20128) := '63652E73746F726528546A2E5F6B65792C652C302C30297D66696E616C6C797B746869732E5F69676E6F72654368616E67654576656E743D21317D7D7D3B506A2E5F6B65793D226D656E752E68696464656E436F6D6D616E6473222C506A3D546A3D4D6A';
wwv_flow_imp.g_varchar2_table(20129) := '285B416A28302C5142295D2C506A293B6C6574204F6A3D496A3D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E5F69643D652C746869732E5F68696464656E5374617465733D742C746869732E5F636F6C6C65';
wwv_flow_imp.g_varchar2_table(20130) := '6374436F6E746578744B657973466F725375626D656E75733D6E2C746869732E5F636F6D6D616E64536572766963653D692C746869732E5F6B657962696E64696E67536572766963653D6F2C746869732E5F636F6E746578744B6579536572766963653D';
wwv_flow_imp.g_varchar2_table(20131) := '732C746869732E5F6D656E7547726F7570733D5B5D2C746869732E5F737472756374757265436F6E746578744B6579733D6E6577205365742C746869732E5F707265636F6E646974696F6E436F6E746578744B6579733D6E6577205365742C746869732E';
wwv_flow_imp.g_varchar2_table(20132) := '5F746F67676C6564436F6E746578744B6579733D6E6577205365742C746869732E7265667265736828297D67657420737472756374757265436F6E746578744B65797328297B72657475726E20746869732E5F737472756374757265436F6E746578744B';
wwv_flow_imp.g_varchar2_table(20133) := '6579737D67657420707265636F6E646974696F6E436F6E746578744B65797328297B72657475726E20746869732E5F707265636F6E646974696F6E436F6E746578744B6579737D67657420746F67676C6564436F6E746578744B65797328297B72657475';
wwv_flow_imp.g_varchar2_table(20134) := '726E20746869732E5F746F67676C6564436F6E746578744B6579737D7265667265736828297B746869732E5F6D656E7547726F7570732E6C656E6774683D302C746869732E5F737472756374757265436F6E746578744B6579732E636C65617228292C74';
wwv_flow_imp.g_varchar2_table(20135) := '6869732E5F707265636F6E646974696F6E436F6E746578744B6579732E636C65617228292C746869732E5F746F67676C6564436F6E746578744B6579732E636C65617228293B636F6E737420653D49642E6765744D656E754974656D7328746869732E5F';
wwv_flow_imp.g_varchar2_table(20136) := '6964293B6C657420743B652E736F727428496A2E5F636F6D706172654D656E754974656D73293B666F7228636F6E7374206E206F662065297B636F6E737420653D6E2E67726F75707C7C22223B742626745B305D3D3D3D657C7C28743D5B652C5B5D5D2C';
wwv_flow_imp.g_varchar2_table(20137) := '746869732E5F6D656E7547726F7570732E70757368287429292C745B315D2E70757368286E292C746869732E5F636F6C6C656374436F6E746578744B657973286E297D7D5F636F6C6C656374436F6E746578744B6579732865297B696628496A2E5F6669';
wwv_flow_imp.g_varchar2_table(20138) := '6C6C496E4B62457870724B65797328652E7768656E2C746869732E5F737472756374757265436F6E746578744B657973292C4564286529297B696628652E636F6D6D616E642E707265636F6E646974696F6E2626496A2E5F66696C6C496E4B6245787072';
wwv_flow_imp.g_varchar2_table(20139) := '4B65797328652E636F6D6D616E642E707265636F6E646974696F6E2C746869732E5F707265636F6E646974696F6E436F6E746578744B657973292C652E636F6D6D616E642E746F67676C6564297B636F6E737420743D652E636F6D6D616E642E746F6767';
wwv_flow_imp.g_varchar2_table(20140) := '6C65642E636F6E646974696F6E7C7C652E636F6D6D616E642E746F67676C65643B496A2E5F66696C6C496E4B62457870724B65797328742C746869732E5F746F67676C6564436F6E746578744B657973297D7D656C736520746869732E5F636F6C6C6563';
wwv_flow_imp.g_varchar2_table(20141) := '74436F6E746578744B657973466F725375626D656E7573262649642E6765744D656E754974656D7328652E7375626D656E75292E666F724561636828746869732E5F636F6C6C656374436F6E746578744B6579732C74686973297D637265617465416374';
wwv_flow_imp.g_varchar2_table(20142) := '696F6E47726F7570732865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620746869732E5F6D656E7547726F757073297B636F6E73745B692C6F5D3D6E2C733D5B5D3B666F7228636F6E73742074206F66206F29696628746869732E';
wwv_flow_imp.g_varchar2_table(20143) := '5F636F6E746578744B6579536572766963652E636F6E746578744D61746368657352756C657328742E7768656E29297B636F6E7374206E3D45642874293B6E2626746869732E5F68696464656E5374617465732E73657444656661756C74537461746528';
wwv_flow_imp.g_varchar2_table(20144) := '746869732E5F69642C742E636F6D6D616E642E69642C2121742E697348696464656E427944656661756C74293B636F6E737420693D466A28746869732E5F69642C6E3F742E636F6D6D616E643A742C746869732E5F68696464656E537461746573293B69';
wwv_flow_imp.g_varchar2_table(20145) := '66286E297B636F6E7374206E3D426A28742E636F6D6D616E642E69642C742E7768656E2C746869732E5F636F6D6D616E64536572766963652C746869732E5F6B657962696E64696E6753657276696365293B732E70757368286E657720416428742E636F';
wwv_flow_imp.g_varchar2_table(20146) := '6D6D616E642C742E616C742C652C692C6E2C746869732E5F636F6E746578744B6579536572766963652C746869732E5F636F6D6D616E645365727669636529297D656C73657B636F6E7374206E3D6E657720496A28742E7375626D656E752C746869732E';
wwv_flow_imp.g_varchar2_table(20147) := '5F68696464656E5374617465732C746869732E5F636F6C6C656374436F6E746578744B657973466F725375626D656E75732C746869732E5F636F6D6D616E64536572766963652C746869732E5F6B657962696E64696E67536572766963652C746869732E';
wwv_flow_imp.g_varchar2_table(20148) := '5F636F6E746578744B657953657276696365292E637265617465416374696F6E47726F7570732865292C6F3D79632E6A6F696E282E2E2E6E2E6D61702828653D3E655B315D2929293B6F2E6C656E6774683E302626732E70757368286E6577204D642874';
wwv_flow_imp.g_varchar2_table(20149) := '2C692C6F29297D7D732E6C656E6774683E302626742E70757368285B692C735D297D72657475726E20747D737461746963205F66696C6C496E4B62457870724B65797328652C74297B6966286529666F7228636F6E7374206E206F6620652E6B65797328';
wwv_flow_imp.g_varchar2_table(20150) := '2929742E616464286E297D737461746963205F636F6D706172654D656E754974656D7328652C74297B636F6E7374206E3D652E67726F75702C693D742E67726F75703B6966286E213D3D69297B696628216E2972657475726E20313B6966282169297265';
wwv_flow_imp.g_varchar2_table(20151) := '7475726E2D313B696628226E617669676174696F6E223D3D3D6E2972657475726E2D313B696628226E617669676174696F6E223D3D3D692972657475726E20313B636F6E737420653D6E2E6C6F63616C65436F6D706172652869293B69662830213D3D65';
wwv_flow_imp.g_varchar2_table(20152) := '2972657475726E20657D636F6E7374206F3D652E6F726465727C7C302C733D742E6F726465727C7C303B72657475726E206F3C733F2D313A6F3E733F313A496A2E5F636F6D706172655469746C65732845642865293F652E636F6D6D616E642E7469746C';
wwv_flow_imp.g_varchar2_table(20153) := '653A652E7469746C652C45642874293F742E636F6D6D616E642E7469746C653A742E7469746C65297D737461746963205F636F6D706172655469746C657328652C74297B636F6E7374206E3D22737472696E67223D3D747970656F6620653F653A652E6F';
wwv_flow_imp.g_varchar2_table(20154) := '726967696E616C2C693D22737472696E67223D3D747970656F6620743F743A742E6F726967696E616C3B72657475726E206E2E6C6F63616C65436F6D706172652869297D7D3B4F6A3D496A3D4D6A285B416A28332C7863292C416A28342C2445292C416A';
wwv_flow_imp.g_varchar2_table(20155) := '28352C6364295D2C4F6A293B6C657420526A3D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F6D656E75496E666F3D6E6577204F6A28652C74';
wwv_flow_imp.g_varchar2_table(20156) := '2C6E2E656D69744576656E7473466F725375626D656E754368616E6765732C692C6F2C73293B636F6E737420723D6E6577204B74282828293D3E7B746869732E5F6D656E75496E666F2E7265667265736828292C746869732E5F6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(20157) := '652E66697265287B6D656E753A746869732C69735374727563747572616C4368616E67653A21302C6973456E61626C656D656E744368616E67653A21302C6973546F67676C654368616E67653A21307D297D292C6E2E6576656E744465626F756E636544';
wwv_flow_imp.g_varchar2_table(20158) := '656C6179293B746869732E5F646973706F7361626C65732E6164642872292C746869732E5F646973706F7361626C65732E6164642849642E6F6E4469644368616E67654D656E752828743D3E7B742E6861732865292626722E7363686564756C6528297D';
wwv_flow_imp.g_varchar2_table(20159) := '2929293B636F6E737420613D746869732E5F646973706F7361626C65732E616464286E6577206174293B746869732E5F6F6E4469644368616E67653D6E6577206B74287B6F6E57696C6C41646446697273744C697374656E65723A28293D3E7B612E6164';
wwv_flow_imp.g_varchar2_table(20160) := '6428732E6F6E4469644368616E6765436F6E746578742828653D3E7B636F6E737420743D652E61666665637473536F6D6528746869732E5F6D656E75496E666F2E737472756374757265436F6E746578744B657973292C6E3D652E61666665637473536F';
wwv_flow_imp.g_varchar2_table(20161) := '6D6528746869732E5F6D656E75496E666F2E707265636F6E646974696F6E436F6E746578744B657973292C693D652E61666665637473536F6D6528746869732E5F6D656E75496E666F2E746F67676C6564436F6E746578744B657973293B28747C7C6E7C';
wwv_flow_imp.g_varchar2_table(20162) := '7C69292626746869732E5F6F6E4469644368616E67652E66697265287B6D656E753A746869732C69735374727563747572616C4368616E67653A742C6973456E61626C656D656E744368616E67653A6E2C6973546F67676C654368616E67653A697D297D';
wwv_flow_imp.g_varchar2_table(20163) := '2929292C612E61646428742E6F6E4469644368616E67652828653D3E7B746869732E5F6F6E4469644368616E67652E66697265287B6D656E753A746869732C69735374727563747572616C4368616E67653A21302C6973456E61626C656D656E74436861';
wwv_flow_imp.g_varchar2_table(20164) := '6E67653A21312C6973546F67676C654368616E67653A21317D297D2929297D2C6F6E44696452656D6F76654C6173744C697374656E65723A612E636C6561722E62696E642861292C64656C61793A6E2E6576656E744465626F756E636544656C61792C6D';
wwv_flow_imp.g_varchar2_table(20165) := '657267653A653D3E7B6C657420743D21312C6E3D21312C693D21313B666F7228636F6E7374206F206F66206529696628743D747C7C6F2E69735374727563747572616C4368616E67652C6E3D6E7C7C6F2E6973456E61626C656D656E744368616E67652C';
wwv_flow_imp.g_varchar2_table(20166) := '693D697C7C6F2E6973546F67676C654368616E67652C7426266E26266929627265616B3B72657475726E7B6D656E753A746869732C69735374727563747572616C4368616E67653A742C6973456E61626C656D656E744368616E67653A6E2C6973546F67';
wwv_flow_imp.g_varchar2_table(20167) := '676C654368616E67653A697D7D7D292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E747D676574416374696F6E732865297B72657475726E20746869732E5F6D656E75496E666F2E63726561746541';
wwv_flow_imp.g_varchar2_table(20168) := '6374696F6E47726F7570732865297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F6F6E4469644368616E67652E646973706F736528297D7D3B66756E6374696F6E20466A28652C742C6E';
wwv_flow_imp.g_varchar2_table(20169) := '297B636F6E737420693D766F69642030213D3D742E7375626D656E753F742E7375626D656E752E69643A742E69642C6F3D22737472696E67223D3D747970656F6620742E7469746C653F742E7469746C653A742E7469746C652E76616C75652C733D5363';
wwv_flow_imp.g_varchar2_table(20170) := '287B69643A60686964652F247B652E69647D2F247B697D602C6C6162656C3A6228302C224869646520277B307D27222C6F292C72756E28297B6E2E75706461746548696464656E28652C692C2130297D7D292C723D5363287B69643A60746F67676C652F';
wwv_flow_imp.g_varchar2_table(20171) := '247B652E69647D2F247B697D602C6C6162656C3A6F2C67657420636865636B656428297B72657475726E216E2E697348696464656E28652C69297D2C72756E28297B6E2E75706461746548696464656E28652C692C2121746869732E636865636B656429';
wwv_flow_imp.g_varchar2_table(20172) := '7D7D293B72657475726E7B686964653A732C746F67676C653A722C67657420697348696464656E28297B72657475726E21722E636865636B65647D7D7D66756E6374696F6E20426A28652C743D766F696420302C6E2C69297B72657475726E205363287B';
wwv_flow_imp.g_varchar2_table(20173) := '69643A60636F6E6669677572654B657962696E64696E672F247B657D602C6C6162656C3A6228302C22436F6E666967757265204B657962696E64696E6722292C72756E28297B636F6E7374206F3D21692E6C6F6F6B75704B657962696E64696E67286529';
wwv_flow_imp.g_varchar2_table(20174) := '2626743F742E73657269616C697A6528293A766F696420303B6E2E65786563757465436F6D6D616E642822776F726B62656E63682E616374696F6E2E6F70656E476C6F62616C4B657962696E64696E6773222C6040636F6D6D616E643A247B657D602B28';
wwv_flow_imp.g_varchar2_table(20175) := '6F3F60202B7768656E3A247B6F7D603A222229297D7D297D526A3D4D6A285B416A28332C7863292C416A28342C2445292C416A28352C6364295D2C526A293B76617220566A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D61726775';
wwv_flow_imp.g_varchar2_table(20176) := '6D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C6563742626';
wwv_flow_imp.g_varchar2_table(20177) := '2266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D2928';
wwv_flow_imp.g_varchar2_table(20178) := '6F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C7A6A3D66756E';
wwv_flow_imp.g_varchar2_table(20179) := '6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C657420486A3D636C61737320657874656E6473204C6A7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B73757065';
wwv_flow_imp.g_varchar2_table(20180) := '7228652C6F2C7B6765744B657942696E64696E673A653D3E7B76617220743B72657475726E206E756C6C213D3D28743D732E6C6F6F6B75704B657962696E64696E6728652E696429292626766F69642030213D3D743F743A766F696420307D2C2E2E2E74';
wwv_flow_imp.g_varchar2_table(20181) := '2C616C6C6F77436F6E746578744D656E753A21302C736B697054656C656D657472793A22737472696E67223D3D747970656F66286E756C6C3D3D743F766F696420303A742E74656C656D65747279536F75726365297D292C746869732E5F6F7074696F6E';
wwv_flow_imp.g_varchar2_table(20182) := '733D742C746869732E5F6D656E75536572766963653D6E2C746869732E5F636F6E746578744B6579536572766963653D692C746869732E5F636F6E746578744D656E75536572766963653D6F2C746869732E5F6B657962696E64696E6753657276696365';
wwv_flow_imp.g_varchar2_table(20183) := '3D732C746869732E5F636F6D6D616E64536572766963653D722C746869732E5F73657373696F6E446973706F7361626C65733D746869732E5F73746F72652E616464286E6577206174293B636F6E7374206C3D6E756C6C3D3D743F766F696420303A742E';
wwv_flow_imp.g_varchar2_table(20184) := '74656C656D65747279536F757263653B6C2626746869732E5F73746F72652E61646428746869732E616374696F6E4261722E6F6E44696452756E2828653D3E612E7075626C69634C6F67322822776F726B62656E6368416374696F6E4578656375746564';
wwv_flow_imp.g_varchar2_table(20185) := '222C7B69643A652E616374696F6E2E69642C66726F6D3A6C7D292929297D736574416374696F6E7328652C743D5B5D2C6E297B76617220692C6F2C733B746869732E5F73657373696F6E446973706F7361626C65732E636C65617228293B636F6E737420';
wwv_flow_imp.g_varchar2_table(20186) := '723D652E736C69636528292C613D742E736C69636528292C6C3D5B5D3B6C657420633D303B636F6E737420643D5B5D3B6C657420683D21313B6966282D31213D3D286E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(20187) := '3D693F766F696420303A692E68696464656E4974656D53747261746567792929666F72286C657420653D303B653C722E6C656E6774683B652B2B297B636F6E737420743D725B655D3B287420696E7374616E63656F662041647C7C7420696E7374616E63';
wwv_flow_imp.g_varchar2_table(20188) := '656F66204D64292626742E68696465416374696F6E732626286C2E7075736828742E68696465416374696F6E732E746F67676C65292C742E68696465416374696F6E732E746F67676C652E636865636B65642626632B2B2C742E68696465416374696F6E';
wwv_flow_imp.g_varchar2_table(20189) := '732E697348696464656E262628683D21302C725B655D3D766F696420302C30213D3D286E756C6C3D3D3D286F3D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E68696464656E4974656D537472617465677929';
wwv_flow_imp.g_varchar2_table(20190) := '262628645B655D3D742929297D696628766F69642030213D3D286E756C6C3D3D3D28733D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D733F766F696420303A732E6F766572666C6F774265686176696F7229297B636F6E737420653D66';
wwv_flow_imp.g_varchar2_table(20191) := '756E6374696F6E28652C74297B636F6E7374206E3D6E6577205365743B666F7228636F6E73742069206F66207429652E68617328692926266E2E6164642869293B72657475726E206E7D286E65772053657428746869732E5F6F7074696F6E732E6F7665';
wwv_flow_imp.g_varchar2_table(20192) := '72666C6F774265686176696F722E6578656D70746564292C5A652E6D617028722C28653D3E6E756C6C3D3D653F766F696420303A652E69642929292C743D746869732E5F6F7074696F6E732E6F766572666C6F774265686176696F722E6D61784974656D';
wwv_flow_imp.g_varchar2_table(20193) := '732D652E73697A653B6C6574206E3D303B666F72286C657420693D303B693C722E6C656E6774683B692B2B297B636F6E7374206F3D725B695D3B6F2626286E2B2B2C652E686173286F2E6964297C7C6E3E3D74262628725B695D3D766F696420302C645B';
wwv_flow_imp.g_varchar2_table(20194) := '695D3D6F29297D7D48682872292C48682864292C73757065722E736574416374696F6E7328722C79632E6A6F696E28642C6129292C286C2E6C656E6774683E307C7C722E6C656E6774683E30292626746869732E5F73657373696F6E446973706F736162';
wwv_flow_imp.g_varchar2_table(20195) := '6C65732E61646428627328746869732E676574456C656D656E7428292C22636F6E746578746D656E75222C28653D3E7B76617220742C692C6F2C732C723B636F6E737420613D6E657720476528727328746869732E676574456C656D656E742829292C65';
wwv_flow_imp.g_varchar2_table(20196) := '292C643D746869732E6765744974656D416374696F6E28612E746172676574293B69662821642972657475726E3B612E70726576656E7444656661756C7428292C612E73746F7050726F7061676174696F6E28293B636F6E737420753D5B5D3B69662864';
wwv_flow_imp.g_varchar2_table(20197) := '20696E7374616E63656F662041642626642E6D656E754B657962696E64696E673F752E7075736828642E6D656E754B657962696E64696E67293A6420696E7374616E63656F66204D647C7C6420696E7374616E63656F6620446A7C7C752E707573682842';
wwv_flow_imp.g_varchar2_table(20198) := '6A28642E69642C766F696420302C746869732E5F636F6D6D616E64536572766963652C746869732E5F6B657962696E64696E675365727669636529292C6C2E6C656E6774683E30297B6C657420653D21313B696628313D3D3D632626303D3D3D286E756C';
wwv_flow_imp.g_varchar2_table(20199) := '6C3D3D3D28743D746869732E5F6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E68696464656E4974656D537472617465677929297B653D21303B666F72286C657420653D303B653C6C2E6C656E6774683B652B2B296966286C';
wwv_flow_imp.g_varchar2_table(20200) := '5B655D2E636865636B6564297B6C5B655D3D5363287B69643A642E69642C6C6162656C3A642E6C6162656C2C636865636B65643A21302C656E61626C65643A21312C72756E28297B7D7D293B627265616B7D7D69662821652626286420696E7374616E63';
wwv_flow_imp.g_varchar2_table(20201) := '656F662041647C7C6420696E7374616E63656F66204D6429297B69662821642E68696465416374696F6E732972657475726E3B752E7075736828642E68696465416374696F6E732E68696465297D656C736520752E70757368285363287B69643A226C61';
wwv_flow_imp.g_varchar2_table(20202) := '62656C222C6C6162656C3A6228302C224869646522292C656E61626C65643A21312C72756E28297B7D7D29297D636F6E737420703D79632E6A6F696E28752C6C293B286E756C6C3D3D3D28693D746869732E5F6F7074696F6E73297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(20203) := '3D3D693F766F696420303A692E72657365744D656E75292626216E2626286E3D5B746869732E5F6F7074696F6E732E72657365744D656E755D292C6826266E262628702E70757368286E6577207963292C702E70757368285363287B69643A2272657365';
wwv_flow_imp.g_varchar2_table(20204) := '74546869734D656E75222C6C6162656C3A6228302C225265736574204D656E7522292C72756E3A28293D3E746869732E5F6D656E75536572766963652E726573657448696464656E537461746573286E297D2929292C30213D3D702E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(20205) := '746869732E5F636F6E746578744D656E75536572766963652E73686F77436F6E746578744D656E75287B676574416E63686F723A28293D3E612C676574416374696F6E733A28293D3E702C6D656E7549643A6E756C6C3D3D3D286F3D746869732E5F6F70';
wwv_flow_imp.g_varchar2_table(20206) := '74696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E636F6E746578744D656E752C6D656E75416374696F6E4F7074696F6E733A7B72656E64657253686F72745469746C653A21302C2E2E2E6E756C6C3D3D3D28733D746869732E5F6F70';
wwv_flow_imp.g_varchar2_table(20207) := '74696F6E73297C7C766F696420303D3D3D733F766F696420303A732E6D656E754F7074696F6E737D2C736B697054656C656D657472793A22737472696E67223D3D747970656F66286E756C6C3D3D3D28723D746869732E5F6F7074696F6E73297C7C766F';
wwv_flow_imp.g_varchar2_table(20208) := '696420303D3D3D723F766F696420303A722E74656C656D65747279536F75726365292C636F6E746578744B6579536572766963653A746869732E5F636F6E746578744B6579536572766963657D297D2929297D7D3B486A3D566A285B7A6A28322C446429';
wwv_flow_imp.g_varchar2_table(20209) := '2C7A6A28332C6364292C7A6A28342C7145292C7A6A28352C2445292C7A6A28362C7863292C7A6A28372C4F64295D2C486A293B6C657420576A3D636C61737320657874656E647320486A7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72';
wwv_flow_imp.g_varchar2_table(20210) := '2C612C6C297B737570657228652C7B72657365744D656E753A742C2E2E2E6E7D2C692C6F2C732C722C612C6C292C746869732E5F6F6E4469644368616E67654D656E754974656D733D746869732E5F73746F72652E616464286E6577204374292C746869';
wwv_flow_imp.g_varchar2_table(20211) := '732E6F6E4469644368616E67654D656E754974656D733D746869732E5F6F6E4469644368616E67654D656E754974656D732E6576656E743B636F6E737420633D746869732E5F73746F72652E61646428692E6372656174654D656E7528742C6F2C7B656D';
wwv_flow_imp.g_varchar2_table(20212) := '69744576656E7473466F725375626D656E754368616E6765733A21307D29292C643D28293D3E7B76617220742C692C6F3B636F6E737420733D5B5D2C723D5B5D3B626A28632C6E756C6C3D3D6E3F766F696420303A6E2E6D656E754F7074696F6E732C7B';
wwv_flow_imp.g_varchar2_table(20213) := '7072696D6172793A732C7365636F6E646172793A727D2C6E756C6C3D3D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E7072696D61727947726F75702C';
wwv_flow_imp.g_varchar2_table(20214) := '6E756C6C3D3D3D28693D6E756C6C3D3D6E3F766F696420303A6E2E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E73686F756C64496E6C696E655375626D656E752C6E756C6C3D3D3D286F3D6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(20215) := '6E3F766F696420303A6E2E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E757365536570617261746F7273496E5072696D617279416374696F6E73292C652E636C6173734C6973742E746F67676C65282268';
wwv_flow_imp.g_varchar2_table(20216) := '61732D6E6F2D616374696F6E73222C303D3D3D732E6C656E6774682626303D3D3D722E6C656E677468292C73757065722E736574416374696F6E7328732C72297D3B746869732E5F73746F72652E61646428632E6F6E4469644368616E6765282828293D';
wwv_flow_imp.g_varchar2_table(20217) := '3E7B6428292C746869732E5F6F6E4469644368616E67654D656E754974656D732E666972652874686973297D2929292C6428297D736574416374696F6E7328297B7468726F77206E6577204F6528225468697320746F6F6C62617220697320706F70756C';
wwv_flow_imp.g_varchar2_table(20218) := '617465642066726F6D2061206D656E752E22297D7D3B576A3D566A285B7A6A28332C4464292C7A6A28342C6364292C7A6A28352C7145292C7A6A28362C2445292C7A6A28372C7863292C7A6A28382C4F64295D2C576A293B766172206A6A2C716A3D6675';
wwv_flow_imp.g_varchar2_table(20219) := '6E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B69';
wwv_flow_imp.g_varchar2_table(20220) := '6628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F72';
wwv_flow_imp.g_varchar2_table(20221) := '2876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566';
wwv_flow_imp.g_varchar2_table(20222) := '696E6550726F706572747928742C6E2C72292C727D2C246A3D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C657420556A3D636C61737320657874656E6473206C747B636F6E7374';
wwv_flow_imp.g_varchar2_table(20223) := '727563746F7228652C742C6E297B737570657228292C746869732E656469746F723D652C746869732E6D6F64656C3D742C746869732E696E7374616E74696174696F6E536572766963653D6E2C746869732E616C7761797353686F77546F6F6C6261723D';
wwv_flow_imp.g_varchar2_table(20224) := '614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E22616C77617973223D3D3D746869732E656469746F722E6765744F7074696F6E283632292E73686F77546F6F6C62617229292C74686973';
wwv_flow_imp.g_varchar2_table(20225) := '2E73657373696F6E506F736974696F6E3D766F696420302C746869732E706F736974696F6E3D515428746869732C28653D3E7B76617220742C6E2C693B636F6E7374206F3D6E756C6C3D3D3D28743D746869732E6D6F64656C2E72656164286529297C7C';
wwv_flow_imp.g_varchar2_table(20226) := '766F696420303D3D3D743F766F696420303A742E7072696D61727947686F7374546578742E726561642865293B69662821746869732E616C7761797353686F77546F6F6C6261722E726561642865297C7C216F7C7C303D3D3D6F2E70617274732E6C656E';
wwv_flow_imp.g_varchar2_table(20227) := '6774682972657475726E20746869732E73657373696F6E506F736974696F6E3D766F696420302C6E756C6C3B636F6E737420733D6F2E70617274735B305D2E636F6C756D6E3B746869732E73657373696F6E506F736974696F6E2626746869732E736573';
wwv_flow_imp.g_varchar2_table(20228) := '73696F6E506F736974696F6E2E6C696E654E756D626572213D3D6F2E6C696E654E756D626572262628746869732E73657373696F6E506F736974696F6E3D766F69642030293B636F6E737420723D6E6577206D63286F2E6C696E654E756D6265722C4D61';
wwv_flow_imp.g_varchar2_table(20229) := '74682E6D696E28732C6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E73657373696F6E506F736974696F6E297C7C766F696420303D3D3D6E3F766F696420303A6E2E636F6C756D6E292626766F69642030213D3D693F693A4E756D626572';
wwv_flow_imp.g_varchar2_table(20230) := '2E4D41585F534146455F494E544547455229293B72657475726E20746869732E73657373696F6E506F736974696F6E3D722C727D29292C746869732E5F7265676973746572286949282828742C6E293D3E7B636F6E737420693D746869732E6D6F64656C';
wwv_flow_imp.g_varchar2_table(20231) := '2E726561642874293B69662821697C7C21746869732E616C7761797353686F77546F6F6C6261722E726561642874292972657475726E3B636F6E7374206F3D6E2E61646428746869732E696E7374616E74696174696F6E536572766963652E6372656174';
wwv_flow_imp.g_varchar2_table(20232) := '65496E7374616E636528516A2C746869732E656469746F722C21302C746869732E706F736974696F6E2C692E73656C6563746564496E6C696E65436F6D706C6574696F6E496E6465782C692E696E6C696E65436F6D706C6574696F6E73436F756E742C69';
wwv_flow_imp.g_varchar2_table(20233) := '2E616374697665436F6D6D616E647329293B652E616464436F6E74656E74576964676574286F292C6E2E616464287274282828293D3E652E72656D6F7665436F6E74656E74576964676574286F292929292C6E2E6164642865492828653D3E7B74686973';
wwv_flow_imp.g_varchar2_table(20234) := '2E706F736974696F6E2E726561642865292626692E6C617374547269676765724B696E642E72656164286529213D3D77772E4578706C696369742626692E747269676765724578706C696369746C7928297D2929297D2929297D7D3B556A3D716A285B24';
wwv_flow_imp.g_varchar2_table(20235) := '6A28322C7563295D2C556A293B636F6E7374204B6A3D54572822696E6C696E652D73756767657374696F6E2D68696E74732D6E657874222C4C6C2E63686576726F6E52696768742C6228302C2249636F6E20666F722073686F77206E6578742070617261';
wwv_flow_imp.g_varchar2_table(20236) := '6D657465722068696E742E2229292C476A3D54572822696E6C696E652D73756767657374696F6E2D68696E74732D70726576696F7573222C4C6C2E63686576726F6E4C6566742C6228302C2249636F6E20666F722073686F772070726576696F75732070';
wwv_flow_imp.g_varchar2_table(20237) := '6172616D657465722068696E742E2229293B6C657420516A3D6A6A3D636C61737320657874656E6473206C747B737461746963206765742064726F70446F776E56697369626C6528297B72657475726E20746869732E5F64726F70446F776E5669736962';
wwv_flow_imp.g_varchar2_table(20238) := '6C657D637265617465436F6D6D616E64416374696F6E28652C742C6E297B636F6E737420693D6E657720626328652C742C6E2C21302C2828293D3E746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652929292C';
wwv_flow_imp.g_varchar2_table(20239) := '6F3D746869732E6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728652C746869732E5F636F6E746578744B657953657276696365293B6C657420733D743B72657475726E206F262628733D6228302C227B307D2028';
wwv_flow_imp.g_varchar2_table(20240) := '7B317D29222C742C6F2E6765744C6162656C282929292C692E746F6F6C7469703D732C697D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C64297B737570657228292C746869732E656469746F723D652C746869732E77';
wwv_flow_imp.g_varchar2_table(20241) := '697468426F726465723D742C746869732E5F706F736974696F6E3D6E2C746869732E5F63757272656E7453756767657374696F6E4964783D692C746869732E5F73756767657374696F6E436F756E743D6F2C746869732E5F6578747261436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(20242) := '733D732C746869732E5F636F6D6D616E64536572766963653D722C746869732E6B657962696E64696E67536572766963653D6C2C746869732E5F636F6E746578744B6579536572766963653D632C746869732E5F6D656E75536572766963653D642C7468';
wwv_flow_imp.g_varchar2_table(20243) := '69732E69643D22496E6C696E6553756767657374696F6E48696E7473436F6E74656E74576964676574222B6A6A2E69642B2B2C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E73757070726573734D6F757365446F77';
wwv_flow_imp.g_varchar2_table(20244) := '6E3D21312C746869732E6E6F6465733D497228226469762E696E6C696E6553756767657374696F6E7348696E7473222C7B636C6173734E616D653A746869732E77697468426F726465723F222E77697468426F72646572223A22227D2C5B497228226469';
wwv_flow_imp.g_varchar2_table(20245) := '7640746F6F6C42617222295D292C746869732E70726576696F7573416374696F6E3D746869732E637265617465436F6D6D616E64416374696F6E28616A2C6228302C2250726576696F757322292C546C2E6173436C6173734E616D6528476A29292C7468';
wwv_flow_imp.g_varchar2_table(20246) := '69732E617661696C61626C6553756767657374696F6E436F756E74416374696F6E3D6E65772062632822696E6C696E6553756767657374696F6E48696E74732E617661696C61626C6553756767657374696F6E436F756E74222C22222C766F696420302C';
wwv_flow_imp.g_varchar2_table(20247) := '2131292C746869732E6E657874416374696F6E3D746869732E637265617465436F6D6D616E64416374696F6E286C6A2C6228302C224E65787422292C546C2E6173436C6173734E616D65284B6A29292C746869732E696E6C696E65436F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(20248) := '6E73416374696F6E734D656E75733D746869732E5F726567697374657228746869732E5F6D656E75536572766963652E6372656174654D656E75284C642E496E6C696E65436F6D706C6574696F6E73416374696F6E732C746869732E5F636F6E74657874';
wwv_flow_imp.g_varchar2_table(20249) := '4B65795365727669636529292C746869732E636C656172417661696C61626C6553756767657374696F6E436F756E744C6162656C4465626F756E6365643D746869732E5F7265676973746572286E6577204B74282828293D3E7B746869732E617661696C';
wwv_flow_imp.g_varchar2_table(20250) := '61626C6553756767657374696F6E436F756E74416374696F6E2E6C6162656C3D22227D292C31303029292C746869732E64697361626C65427574746F6E734465626F756E6365643D746869732E5F7265676973746572286E6577204B74282828293D3E7B';
wwv_flow_imp.g_varchar2_table(20251) := '746869732E70726576696F7573416374696F6E2E656E61626C65643D746869732E6E657874416374696F6E2E656E61626C65643D21317D292C31303029292C746869732E746F6F6C4261723D746869732E5F726567697374657228612E63726561746549';
wwv_flow_imp.g_varchar2_table(20252) := '6E7374616E636528586A2C746869732E6E6F6465732E746F6F6C4261722C4C642E496E6C696E6553756767657374696F6E546F6F6C6261722C7B6D656E754F7074696F6E733A7B72656E64657253686F72745469746C653A21307D2C746F6F6C6261724F';
wwv_flow_imp.g_varchar2_table(20253) := '7074696F6E733A7B7072696D61727947726F75703A653D3E652E7374617274735769746828227072696D61727922297D2C616374696F6E566965774974656D50726F76696465723A28652C74293D3E7B6966286520696E7374616E63656F662041642972';
wwv_flow_imp.g_varchar2_table(20254) := '657475726E20612E637265617465496E7374616E6365285A6A2C652C766F69642030293B696628653D3D3D746869732E617661696C61626C6553756767657374696F6E436F756E74416374696F6E297B636F6E737420743D6E657720596A28766F696420';
wwv_flow_imp.g_varchar2_table(20255) := '302C652C7B6C6162656C3A21302C69636F6E3A21317D293B72657475726E20742E736574436C6173732822617661696C61626C6553756767657374696F6E436F756E7422292C747D7D2C74656C656D65747279536F757263653A22496E6C696E65537567';
wwv_flow_imp.g_varchar2_table(20256) := '67657374696F6E546F6F6C626172227D29292C746869732E746F6F6C4261722E73657450726570656E6465645072696D617279416374696F6E73285B746869732E70726576696F7573416374696F6E2C746869732E617661696C61626C65537567676573';
wwv_flow_imp.g_varchar2_table(20257) := '74696F6E436F756E74416374696F6E2C746869732E6E657874416374696F6E5D292C746869732E5F726567697374657228746869732E746F6F6C4261722E6F6E4469644368616E676544726F70646F776E5669736962696C6974792828653D3E7B6A6A2E';
wwv_flow_imp.g_varchar2_table(20258) := '5F64726F70446F776E56697369626C653D657D2929292C746869732E5F72656769737465722865492828653D3E7B746869732E5F706F736974696F6E2E726561642865292C746869732E656469746F722E6C61796F7574436F6E74656E74576964676574';
wwv_flow_imp.g_varchar2_table(20259) := '2874686973297D2929292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F73756767657374696F6E436F756E742E726561642865292C6E3D746869732E5F63757272656E7453756767657374696F6E496478';
wwv_flow_imp.g_varchar2_table(20260) := '2E726561642865293B766F69642030213D3D743F28746869732E636C656172417661696C61626C6553756767657374696F6E436F756E744C6162656C4465626F756E6365642E63616E63656C28292C746869732E617661696C61626C6553756767657374';
wwv_flow_imp.g_varchar2_table(20261) := '696F6E436F756E74416374696F6E2E6C6162656C3D60247B6E2B317D2F247B747D60293A746869732E636C656172417661696C61626C6553756767657374696F6E436F756E744C6162656C4465626F756E6365642E7363686564756C6528292C766F6964';
wwv_flow_imp.g_varchar2_table(20262) := '2030213D3D742626743E313F28746869732E64697361626C65427574746F6E734465626F756E6365642E63616E63656C28292C746869732E70726576696F7573416374696F6E2E656E61626C65643D746869732E6E657874416374696F6E2E656E61626C';
wwv_flow_imp.g_varchar2_table(20263) := '65643D2130293A746869732E64697361626C65427574746F6E734465626F756E6365642E7363686564756C6528297D2929292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F6578747261436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(20264) := '732E726561642865292E6D61702828653D3E287B636C6173733A766F696420302C69643A652E69642C656E61626C65643A21302C746F6F6C7469703A652E746F6F6C7469707C7C22222C6C6162656C3A652E7469746C652C72756E3A743D3E746869732E';
wwv_flow_imp.g_varchar2_table(20265) := '5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652E6964297D2929293B666F7228636F6E73745B652C6E5D6F6620746869732E696E6C696E65436F6D706C6574696F6E73416374696F6E734D656E75732E67657441637469';
wwv_flow_imp.g_varchar2_table(20266) := '6F6E73282929666F7228636F6E73742065206F66206E296520696E7374616E63656F662041642626742E707573682865293B742E6C656E6774683E302626742E756E7368696674286E6577207963292C746869732E746F6F6C4261722E73657441646469';
wwv_flow_imp.g_varchar2_table(20267) := '74696F6E616C5365636F6E64617279416374696F6E732874297D2929297D676574496428297B72657475726E20746869732E69647D676574446F6D4E6F646528297B72657475726E20746869732E6E6F6465732E726F6F747D676574506F736974696F6E';
wwv_flow_imp.g_varchar2_table(20268) := '28297B72657475726E7B706F736974696F6E3A746869732E5F706F736974696F6E2E67657428292C707265666572656E63653A5B312C325D2C706F736974696F6E416666696E6974793A337D7D7D3B516A2E5F64726F70446F776E56697369626C653D21';
wwv_flow_imp.g_varchar2_table(20269) := '312C516A2E69643D302C516A3D6A6A3D716A285B246A28362C7863292C246A28372C7563292C246A28382C2445292C246A28392C6364292C246A2831302C4464295D2C516A293B636C61737320596A20657874656E647320724D7B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(20270) := '6F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F636C6173734E616D653D766F696420307D736574436C6173732865297B746869732E5F636C6173734E616D653D657D72656E6465722865297B73757065722E72656E646572';
wwv_flow_imp.g_varchar2_table(20271) := '2865292C746869732E5F636C6173734E616D652626652E636C6173734C6973742E61646428746869732E5F636C6173734E616D65297D757064617465546F6F6C74697028297B7D7D636C617373205A6A20657874656E647320796A7B7570646174654C61';
wwv_flow_imp.g_varchar2_table(20272) := '62656C28297B636F6E737420653D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728746869732E5F616374696F6E2E69642C746869732E5F636F6E746578744B657953657276696365293B69662821';
wwv_flow_imp.g_varchar2_table(20273) := '652972657475726E2073757065722E7570646174654C6162656C28293B696628746869732E6C6162656C297B636F6E737420743D497228226469762E6B657962696E64696E6722292E726F6F743B746869732E5F7265676973746572286E657720774D28';
wwv_flow_imp.g_varchar2_table(20274) := '742C74652C7B64697361626C655469746C653A21302C2E2E2E794D7D29292E7365742865292C746869732E6C6162656C2E74657874436F6E74656E743D746869732E5F616374696F6E2E6C6162656C2C746869732E6C6162656C2E617070656E64436869';
wwv_flow_imp.g_varchar2_table(20275) := '6C642874292C746869732E6C6162656C2E636C6173734C6973742E6164642822696E6C696E6553756767657374696F6E5374617475734261724974656D4C6162656C22297D7D757064617465546F6F6C74697028297B7D7D6C657420586A3D636C617373';
wwv_flow_imp.g_varchar2_table(20276) := '20657874656E647320486A7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B737570657228652C7B72657365744D656E753A742C2E2E2E6E7D2C692C6F2C732C722C612C6C292C746869732E6D656E7549643D742C746869';
wwv_flow_imp.g_varchar2_table(20277) := '732E6F7074696F6E73323D6E2C746869732E6D656E75536572766963653D692C746869732E636F6E746578744B6579536572766963653D6F2C746869732E6D656E753D746869732E5F73746F72652E61646428746869732E6D656E75536572766963652E';
wwv_flow_imp.g_varchar2_table(20278) := '6372656174654D656E7528746869732E6D656E7549642C746869732E636F6E746578744B6579536572766963652C7B656D69744576656E7473466F725375626D656E754368616E6765733A21307D29292C746869732E6164646974696F6E616C41637469';
wwv_flow_imp.g_varchar2_table(20279) := '6F6E733D5B5D2C746869732E70726570656E6465645072696D617279416374696F6E733D5B5D2C746869732E5F73746F72652E61646428746869732E6D656E752E6F6E4469644368616E6765282828293D3E746869732E757064617465546F6F6C626172';
wwv_flow_imp.g_varchar2_table(20280) := '28292929292C746869732E757064617465546F6F6C62617228297D757064617465546F6F6C62617228297B76617220652C742C6E2C692C6F2C732C723B636F6E737420613D5B5D2C6C3D5B5D3B626A28746869732E6D656E752C6E756C6C3D3D3D28653D';
wwv_flow_imp.g_varchar2_table(20281) := '746869732E6F7074696F6E7332297C7C766F696420303D3D3D653F766F696420303A652E6D656E754F7074696F6E732C7B7072696D6172793A612C7365636F6E646172793A6C7D2C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E6F7074';
wwv_flow_imp.g_varchar2_table(20282) := '696F6E7332297C7C766F696420303D3D3D743F766F696420303A742E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E7072696D61727947726F75702C6E756C6C3D3D3D286F3D6E756C6C3D3D3D28693D7468';
wwv_flow_imp.g_varchar2_table(20283) := '69732E6F7074696F6E7332297C7C766F696420303D3D3D693F766F696420303A692E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E73686F756C64496E6C696E655375626D656E752C6E756C6C3D3D3D2872';
wwv_flow_imp.g_varchar2_table(20284) := '3D6E756C6C3D3D3D28733D746869732E6F7074696F6E7332297C7C766F696420303D3D3D733F766F696420303A732E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E757365536570617261746F7273496E50';
wwv_flow_imp.g_varchar2_table(20285) := '72696D617279416374696F6E73292C6C2E70757368282E2E2E746869732E6164646974696F6E616C416374696F6E73292C612E756E7368696674282E2E2E746869732E70726570656E6465645072696D617279416374696F6E73292C746869732E736574';
wwv_flow_imp.g_varchar2_table(20286) := '416374696F6E7328612C6C297D73657450726570656E6465645072696D617279416374696F6E732865297B506828746869732E70726570656E6465645072696D617279416374696F6E732C652C2828652C74293D3E653D3D3D7429297C7C28746869732E';
wwv_flow_imp.g_varchar2_table(20287) := '70726570656E6465645072696D617279416374696F6E733D652C746869732E757064617465546F6F6C6261722829297D7365744164646974696F6E616C5365636F6E64617279416374696F6E732865297B506828746869732E6164646974696F6E616C41';
wwv_flow_imp.g_varchar2_table(20288) := '6374696F6E732C652C2828652C74293D3E653D3D3D7429297C7C28746869732E6164646974696F6E616C416374696F6E733D652C746869732E757064617465546F6F6C6261722829297D7D3B586A3D716A285B246A28332C4464292C246A28342C636429';
wwv_flow_imp.g_varchar2_table(20289) := '2C246A28352C7145292C246A28362C2445292C246A28372C7863292C246A28382C4F64295D2C586A293B766172204A6A3D6E2834313636292C65713D7B7D3B65712E7374796C655461675472616E73666F726D3D6A7228292C65712E7365744174747269';
wwv_flow_imp.g_varchar2_table(20290) := '62757465733D567228292C65712E696E736572743D467228292E62696E64286E756C6C2C226865616422292C65712E646F6D4150493D4F7228292C65712E696E736572745374796C65456C656D656E743D487228292C4E722829284A6A2E412C6571292C';
wwv_flow_imp.g_varchar2_table(20291) := '4A6A2E4126264A6A2E412E6C6F63616C7326264A6A2E412E6C6F63616C733B7661722074712C6E713D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D69';
wwv_flow_imp.g_varchar2_table(20292) := '3F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465';
wwv_flow_imp.g_varchar2_table(20293) := '636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F2874';
wwv_flow_imp.g_varchar2_table(20294) := '2C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D3B2166756E6374696F6E2865297B652E4E6F7274683D226E6F727468222C652E536F7574';
wwv_flow_imp.g_varchar2_table(20295) := '683D22736F757468222C652E456173743D2265617374222C652E576573743D2277657374227D2874717C7C2874713D7B7D29293B636F6E73742069713D6E65772043742C6F713D6E65772043743B636C6173732073717B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(20296) := '297B746869732E656C3D652C746869732E646973706F7361626C65733D6E65772061747D676574206F6E506F696E7465724D6F766528297B72657475726E20746869732E646973706F7361626C65732E616464286E6577204B5328727328746869732E65';
wwv_flow_imp.g_varchar2_table(20297) := '6C292C226D6F7573656D6F76652229292E6576656E747D676574206F6E506F696E746572557028297B72657475726E20746869732E646973706F7361626C65732E616464286E6577204B5328727328746869732E656C292C226D6F75736575702229292E';
wwv_flow_imp.g_varchar2_table(20298) := '6576656E747D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528297D7D6E71285B44455D2C73712E70726F746F747970652C226F6E506F696E7465724D6F7665222C6E756C6C292C6E71285B44455D2C73712E7072';
wwv_flow_imp.g_varchar2_table(20299) := '6F746F747970652C226F6E506F696E7465725570222C6E756C6C293B636C6173732072717B676574206F6E506F696E7465724D6F766528297B72657475726E20746869732E646973706F7361626C65732E616464286E6577204B5328746869732E656C2C';
wwv_flow_imp.g_varchar2_table(20300) := '54452E4368616E676529292E6576656E747D676574206F6E506F696E746572557028297B72657475726E20746869732E646973706F7361626C65732E616464286E6577204B5328746869732E656C2C54452E456E6429292E6576656E747D636F6E737472';
wwv_flow_imp.g_varchar2_table(20301) := '7563746F722865297B746869732E656C3D652C746869732E646973706F7361626C65733D6E65772061747D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528297D7D6E71285B44455D2C72712E70726F746F747970';
wwv_flow_imp.g_varchar2_table(20302) := '652C226F6E506F696E7465724D6F7665222C6E756C6C292C6E71285B44455D2C72712E70726F746F747970652C226F6E506F696E7465725570222C6E756C6C293B636C6173732061717B676574206F6E506F696E7465724D6F766528297B72657475726E';
wwv_flow_imp.g_varchar2_table(20303) := '20746869732E666163746F72792E6F6E506F696E7465724D6F76657D676574206F6E506F696E746572557028297B72657475726E20746869732E666163746F72792E6F6E506F696E74657255707D636F6E7374727563746F722865297B746869732E6661';
wwv_flow_imp.g_varchar2_table(20304) := '63746F72793D657D646973706F736528297B7D7D6E71285B44455D2C61712E70726F746F747970652C226F6E506F696E7465724D6F7665222C6E756C6C292C6E71285B44455D2C61712E70726F746F747970652C226F6E506F696E7465725570222C6E75';
wwv_flow_imp.g_varchar2_table(20305) := '6C6C293B636F6E7374206C713D22706F696E7465722D6576656E74732D64697361626C6564223B636C61737320637120657874656E6473206C747B67657420737461746528297B72657475726E20746869732E5F73746174657D676574206F7274686F67';
wwv_flow_imp.g_varchar2_table(20306) := '6F6E616C53746172745361736828297B72657475726E20746869732E5F6F7274686F676F6E616C5374617274536173687D676574206F7274686F676F6E616C456E645361736828297B72657475726E20746869732E5F6F7274686F676F6E616C456E6453';
wwv_flow_imp.g_varchar2_table(20307) := '6173687D7365742073746174652865297B746869732E5F7374617465213D3D65262628746869732E656C2E636C6173734C6973742E746F67676C65282264697361626C6564222C303D3D3D65292C746869732E656C2E636C6173734C6973742E746F6767';
wwv_flow_imp.g_varchar2_table(20308) := '6C6528226D696E696D756D222C313D3D3D65292C746869732E656C2E636C6173734C6973742E746F67676C6528226D6178696D756D222C323D3D3D65292C746869732E5F73746174653D652C746869732E6F6E446964456E61626C656D656E744368616E';
wwv_flow_imp.g_varchar2_table(20309) := '67652E66697265286529297D736574206F7274686F676F6E616C5374617274536173682865297B696628746869732E5F6F7274686F676F6E616C537461727453617368213D3D65297B696628746869732E6F7274686F676F6E616C537461727444726167';
wwv_flow_imp.g_varchar2_table(20310) := '48616E646C65446973706F7361626C65732E636C65617228292C746869732E6F7274686F676F6E616C537461727453617368446973706F7361626C65732E636C65617228292C65297B636F6E737420743D743D3E7B746869732E6F7274686F676F6E616C';
wwv_flow_imp.g_varchar2_table(20311) := '53746172744472616748616E646C65446973706F7361626C65732E636C65617228292C30213D3D74262628746869732E5F6F7274686F676F6E616C53746172744472616748616E646C653D757228746869732E656C2C627228222E6F7274686F676F6E61';
wwv_flow_imp.g_varchar2_table(20312) := '6C2D647261672D68616E646C652E73746172742229292C746869732E6F7274686F676F6E616C53746172744472616748616E646C65446973706F7361626C65732E616464287274282828293D3E746869732E5F6F7274686F676F6E616C53746172744472';
wwv_flow_imp.g_varchar2_table(20313) := '616748616E646C652E72656D6F766528292929292C746869732E6F7274686F676F6E616C53746172744472616748616E646C65446973706F7361626C65732E616464286E6577204B5328746869732E5F6F7274686F676F6E616C53746172744472616748';
wwv_flow_imp.g_varchar2_table(20314) := '616E646C652C226D6F757365656E7465722229292E6576656E74282828293D3E63712E6F6E4D6F757365456E746572286529292C766F696420302C746869732E6F7274686F676F6E616C53746172744472616748616E646C65446973706F7361626C6573';
wwv_flow_imp.g_varchar2_table(20315) := '292C746869732E6F7274686F676F6E616C53746172744472616748616E646C65446973706F7361626C65732E616464286E6577204B5328746869732E5F6F7274686F676F6E616C53746172744472616748616E646C652C226D6F7573656C656176652229';
wwv_flow_imp.g_varchar2_table(20316) := '292E6576656E74282828293D3E63712E6F6E4D6F7573654C65617665286529292C766F696420302C746869732E6F7274686F676F6E616C53746172744472616748616E646C65446973706F7361626C657329297D3B746869732E6F7274686F676F6E616C';
wwv_flow_imp.g_varchar2_table(20317) := '537461727453617368446973706F7361626C65732E61646428652E6F6E446964456E61626C656D656E744368616E67652E6576656E7428742C7468697329292C7428652E7374617465297D746869732E5F6F7274686F676F6E616C537461727453617368';
wwv_flow_imp.g_varchar2_table(20318) := '3D657D7D736574206F7274686F676F6E616C456E64536173682865297B696628746869732E5F6F7274686F676F6E616C456E6453617368213D3D65297B696628746869732E6F7274686F676F6E616C456E644472616748616E646C65446973706F736162';
wwv_flow_imp.g_varchar2_table(20319) := '6C65732E636C65617228292C746869732E6F7274686F676F6E616C456E6453617368446973706F7361626C65732E636C65617228292C65297B636F6E737420743D743D3E7B746869732E6F7274686F676F6E616C456E644472616748616E646C65446973';
wwv_flow_imp.g_varchar2_table(20320) := '706F7361626C65732E636C65617228292C30213D3D74262628746869732E5F6F7274686F676F6E616C456E644472616748616E646C653D757228746869732E656C2C627228222E6F7274686F676F6E616C2D647261672D68616E646C652E656E64222929';
wwv_flow_imp.g_varchar2_table(20321) := '2C746869732E6F7274686F676F6E616C456E644472616748616E646C65446973706F7361626C65732E616464287274282828293D3E746869732E5F6F7274686F676F6E616C456E644472616748616E646C652E72656D6F766528292929292C746869732E';
wwv_flow_imp.g_varchar2_table(20322) := '6F7274686F676F6E616C456E644472616748616E646C65446973706F7361626C65732E616464286E6577204B5328746869732E5F6F7274686F676F6E616C456E644472616748616E646C652C226D6F757365656E7465722229292E6576656E7428282829';
wwv_flow_imp.g_varchar2_table(20323) := '3D3E63712E6F6E4D6F757365456E746572286529292C766F696420302C746869732E6F7274686F676F6E616C456E644472616748616E646C65446973706F7361626C6573292C746869732E6F7274686F676F6E616C456E644472616748616E646C654469';
wwv_flow_imp.g_varchar2_table(20324) := '73706F7361626C65732E616464286E6577204B5328746869732E5F6F7274686F676F6E616C456E644472616748616E646C652C226D6F7573656C656176652229292E6576656E74282828293D3E63712E6F6E4D6F7573654C65617665286529292C766F69';
wwv_flow_imp.g_varchar2_table(20325) := '6420302C746869732E6F7274686F676F6E616C456E644472616748616E646C65446973706F7361626C657329297D3B746869732E6F7274686F676F6E616C456E6453617368446973706F7361626C65732E61646428652E6F6E446964456E61626C656D65';
wwv_flow_imp.g_varchar2_table(20326) := '6E744368616E67652E6576656E7428742C7468697329292C7428652E7374617465297D746869732E5F6F7274686F676F6E616C456E64536173683D657D7D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E686F76657244';
wwv_flow_imp.g_varchar2_table(20327) := '656C61793D3330302C746869732E686F76657244656C617965723D746869732E5F7265676973746572286E6577207A7428746869732E686F76657244656C617929292C746869732E5F73746174653D332C746869732E6F6E446964456E61626C656D656E';
wwv_flow_imp.g_varchar2_table(20328) := '744368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E44696453746172743D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(20329) := '746572286E6577204374292C746869732E5F6F6E44696452657365743D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E446964456E643D746869732E5F7265676973746572286E6577204374292C746869732E6F7274686F';
wwv_flow_imp.g_varchar2_table(20330) := '676F6E616C537461727453617368446973706F7361626C65733D746869732E5F7265676973746572286E6577206174292C746869732E6F7274686F676F6E616C53746172744472616748616E646C65446973706F7361626C65733D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(20331) := '6973746572286E6577206174292C746869732E6F7274686F676F6E616C456E6453617368446973706F7361626C65733D746869732E5F7265676973746572286E6577206174292C746869732E6F7274686F676F6E616C456E644472616748616E646C6544';
wwv_flow_imp.g_varchar2_table(20332) := '6973706F7361626C65733D746869732E5F7265676973746572286E6577206174292C746869732E6F6E44696453746172743D746869732E5F6F6E44696453746172742E6576656E742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(20333) := '644368616E67652E6576656E742C746869732E6F6E44696452657365743D746869732E5F6F6E44696452657365742E6576656E742C746869732E6F6E446964456E643D746869732E5F6F6E446964456E642E6576656E742C746869732E6C696E6B656453';
wwv_flow_imp.g_varchar2_table(20334) := '6173683D766F696420302C746869732E656C3D757228652C627228222E6D6F6E61636F2D736173682229292C6E2E6F7274686F676F6E616C456467652626746869732E656C2E636C6173734C6973742E61646428606F7274686F676F6E616C2D65646765';
wwv_flow_imp.g_varchar2_table(20335) := '2D247B6E2E6F7274686F676F6E616C456467657D60292C712626746869732E656C2E636C6173734C6973742E61646428226D616322293B636F6E737420693D746869732E5F7265676973746572286E6577204B5328746869732E656C2C226D6F75736564';
wwv_flow_imp.g_varchar2_table(20336) := '6F776E2229292E6576656E743B746869732E5F726567697374657228692828743D3E746869732E6F6E506F696E746572537461727428742C6E657720737128652929292C7468697329293B636F6E7374206F3D746869732E5F7265676973746572286E65';
wwv_flow_imp.g_varchar2_table(20337) := '77204B5328746869732E656C2C2264626C636C69636B2229292E6576656E743B746869732E5F7265676973746572286F28746869732E6F6E506F696E746572446F75626C6550726573732C7468697329293B636F6E737420733D746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(20338) := '73746572286E6577204B5328746869732E656C2C226D6F757365656E7465722229292E6576656E743B746869732E5F72656769737465722873282828293D3E63712E6F6E4D6F757365456E7465722874686973292929293B636F6E737420723D74686973';
wwv_flow_imp.g_varchar2_table(20339) := '2E5F7265676973746572286E6577204B5328746869732E656C2C226D6F7573656C656176652229292E6576656E743B746869732E5F72656769737465722872282828293D3E63712E6F6E4D6F7573654C656176652874686973292929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(20340) := '72656769737465722849452E61646454617267657428746869732E656C29293B636F6E737420613D746869732E5F7265676973746572286E6577204B5328746869732E656C2C54452E537461727429292E6576656E743B746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(20341) := '7228612828653D3E746869732E6F6E506F696E746572537461727428652C6E657720727128746869732E656C2929292C7468697329293B636F6E7374206C3D746869732E5F7265676973746572286E6577204B5328746869732E656C2C54452E54617029';
wwv_flow_imp.g_varchar2_table(20342) := '292E6576656E743B6C657420633B746869732E5F7265676973746572286C2828653D3E7B696628632972657475726E20636C65617254696D656F75742863292C633D766F696420302C766F696420746869732E6F6E506F696E746572446F75626C655072';
wwv_flow_imp.g_varchar2_table(20343) := '6573732865293B636C65617254696D656F75742863292C633D73657454696D656F7574282828293D3E633D766F69642030292C323530297D292C7468697329292C226E756D626572223D3D747970656F66206E2E73697A653F28746869732E73697A653D';
wwv_flow_imp.g_varchar2_table(20344) := '6E2E73697A652C303D3D3D6E2E6F7269656E746174696F6E3F746869732E656C2E7374796C652E77696474683D60247B746869732E73697A657D7078603A746869732E656C2E7374796C652E6865696768743D60247B746869732E73697A657D70786029';
wwv_flow_imp.g_varchar2_table(20345) := '3A28746869732E73697A653D342C746869732E5F72656769737465722869712E6576656E742828653D3E7B746869732E73697A653D652C746869732E6C61796F757428297D292929292C746869732E5F7265676973746572286F712E6576656E74282865';
wwv_flow_imp.g_varchar2_table(20346) := '3D3E746869732E686F76657244656C61793D652929292C746869732E6C61796F757450726F76696465723D742C746869732E6F7274686F676F6E616C5374617274536173683D6E2E6F7274686F676F6E616C5374617274536173682C746869732E6F7274';
wwv_flow_imp.g_varchar2_table(20347) := '686F676F6E616C456E64536173683D6E2E6F7274686F676F6E616C456E64536173682C746869732E6F7269656E746174696F6E3D6E2E6F7269656E746174696F6E7C7C302C313D3D3D746869732E6F7269656E746174696F6E3F28746869732E656C2E63';
wwv_flow_imp.g_varchar2_table(20348) := '6C6173734C6973742E6164642822686F72697A6F6E74616C22292C746869732E656C2E636C6173734C6973742E72656D6F76652822766572746963616C2229293A28746869732E656C2E636C6173734C6973742E72656D6F76652822686F72697A6F6E74';
wwv_flow_imp.g_varchar2_table(20349) := '616C22292C746869732E656C2E636C6173734C6973742E6164642822766572746963616C2229292C746869732E656C2E636C6173734C6973742E746F67676C6528226465627567222C2131292C746869732E6C61796F757428297D6F6E506F696E746572';
wwv_flow_imp.g_varchar2_table(20350) := '537461727428652C74297B63722865293B6C6574206E3D21313B69662821652E5F5F6F7274686F676F6E616C536173684576656E74297B636F6E737420693D746869732E6765744F7274686F676F6E616C536173682865293B692626286E3D21302C652E';
wwv_flow_imp.g_varchar2_table(20351) := '5F5F6F7274686F676F6E616C536173684576656E743D21302C692E6F6E506F696E746572537461727428652C6E657720617128742929297D696628746869732E6C696E6B656453617368262621652E5F5F6C696E6B6564536173684576656E7426262865';
wwv_flow_imp.g_varchar2_table(20352) := '2E5F5F6C696E6B6564536173684576656E743D21302C746869732E6C696E6B6564536173682E6F6E506F696E746572537461727428652C6E657720617128742929292C21746869732E73746174652972657475726E3B636F6E737420693D746869732E65';
wwv_flow_imp.g_varchar2_table(20353) := '6C2E6F776E6572446F63756D656E742E676574456C656D656E747342795461674E616D652822696672616D6522293B666F7228636F6E73742065206F66206929652E636C6173734C6973742E616464286C71293B636F6E7374206F3D652E70616765582C';
wwv_flow_imp.g_varchar2_table(20354) := '733D652E70616765592C723D652E616C744B65792C613D7B7374617274583A6F2C63757272656E74583A6F2C7374617274593A732C63757272656E74593A732C616C744B65793A727D3B746869732E656C2E636C6173734C6973742E6164642822616374';
wwv_flow_imp.g_varchar2_table(20355) := '69766522292C746869732E5F6F6E44696453746172742E666972652861293B636F6E7374206C3D597328746869732E656C292C633D28293D3E7B6C657420653D22223B653D6E3F22616C6C2D7363726F6C6C223A313D3D3D746869732E6F7269656E7461';
wwv_flow_imp.g_varchar2_table(20356) := '74696F6E3F313D3D3D746869732E73746174653F22732D726573697A65223A323D3D3D746869732E73746174653F226E2D726573697A65223A713F22726F772D726573697A65223A226E732D726573697A65223A313D3D3D746869732E73746174653F22';
wwv_flow_imp.g_varchar2_table(20357) := '652D726573697A65223A323D3D3D746869732E73746174653F22772D726573697A65223A713F22636F6C2D726573697A65223A2265772D726573697A65222C6C2E74657874436F6E74656E743D602A207B20637572736F723A20247B657D2021696D706F';
wwv_flow_imp.g_varchar2_table(20358) := '7274616E743B207D607D2C643D6E65772061743B6328292C6E7C7C746869732E6F6E446964456E61626C656D656E744368616E67652E6576656E7428632C6E756C6C2C64292C742E6F6E506F696E7465724D6F76652828653D3E7B637228652C2131293B';
wwv_flow_imp.g_varchar2_table(20359) := '636F6E737420743D7B7374617274583A6F2C63757272656E74583A652E70616765582C7374617274593A732C63757272656E74593A652E70616765592C616C744B65793A727D3B746869732E5F6F6E4469644368616E67652E666972652874297D292C6E';
wwv_flow_imp.g_varchar2_table(20360) := '756C6C2C64292C742E6F6E506F696E74657255702828653D3E7B637228652C2131292C746869732E656C2E72656D6F76654368696C64286C292C746869732E656C2E636C6173734C6973742E72656D6F7665282261637469766522292C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(20361) := '6E446964456E642E6669726528292C642E646973706F736528293B666F7228636F6E73742065206F66206929652E636C6173734C6973742E72656D6F7665286C71297D292C6E756C6C2C64292C642E6164642874297D6F6E506F696E746572446F75626C';
wwv_flow_imp.g_varchar2_table(20362) := '6550726573732865297B636F6E737420743D746869732E6765744F7274686F676F6E616C536173682865293B742626742E5F6F6E44696452657365742E6669726528292C746869732E6C696E6B6564536173682626746869732E6C696E6B656453617368';
wwv_flow_imp.g_varchar2_table(20363) := '2E5F6F6E44696452657365742E6669726528292C746869732E5F6F6E44696452657365742E6669726528297D737461746963206F6E4D6F757365456E74657228652C743D2131297B652E656C2E636C6173734C6973742E636F6E7461696E732822616374';
wwv_flow_imp.g_varchar2_table(20364) := '69766522293F28652E686F76657244656C617965722E63616E63656C28292C652E656C2E636C6173734C6973742E6164642822686F7665722229293A652E686F76657244656C617965722E74726967676572282828293D3E652E656C2E636C6173734C69';
wwv_flow_imp.g_varchar2_table(20365) := '73742E6164642822686F7665722229292C652E686F76657244656C6179292E7468656E28766F696420302C2828293D3E7B7D29292C21742626652E6C696E6B656453617368262663712E6F6E4D6F757365456E74657228652E6C696E6B6564536173682C';
wwv_flow_imp.g_varchar2_table(20366) := '2130297D737461746963206F6E4D6F7573654C6561766528652C743D2131297B652E686F76657244656C617965722E63616E63656C28292C652E656C2E636C6173734C6973742E72656D6F76652822686F76657222292C21742626652E6C696E6B656453';
wwv_flow_imp.g_varchar2_table(20367) := '617368262663712E6F6E4D6F7573654C6561766528652E6C696E6B6564536173682C2130297D636C65617253617368486F766572537461746528297B63712E6F6E4D6F7573654C656176652874686973297D6C61796F757428297B696628303D3D3D7468';
wwv_flow_imp.g_varchar2_table(20368) := '69732E6F7269656E746174696F6E297B636F6E737420653D746869732E6C61796F757450726F76696465723B746869732E656C2E7374796C652E6C6566743D652E676574566572746963616C536173684C6566742874686973292D746869732E73697A65';
wwv_flow_imp.g_varchar2_table(20369) := '2F322B227078222C652E676574566572746963616C53617368546F70262628746869732E656C2E7374796C652E746F703D652E676574566572746963616C53617368546F702874686973292B22707822292C652E676574566572746963616C5361736848';
wwv_flow_imp.g_varchar2_table(20370) := '6569676874262628746869732E656C2E7374796C652E6865696768743D652E676574566572746963616C536173684865696768742874686973292B22707822297D656C73657B636F6E737420653D746869732E6C61796F757450726F76696465723B7468';
wwv_flow_imp.g_varchar2_table(20371) := '69732E656C2E7374796C652E746F703D652E676574486F72697A6F6E74616C53617368546F702874686973292D746869732E73697A652F322B227078222C652E676574486F72697A6F6E74616C536173684C656674262628746869732E656C2E7374796C';
wwv_flow_imp.g_varchar2_table(20372) := '652E6C6566743D652E676574486F72697A6F6E74616C536173684C6566742874686973292B22707822292C652E676574486F72697A6F6E74616C536173685769647468262628746869732E656C2E7374796C652E77696474683D652E676574486F72697A';
wwv_flow_imp.g_varchar2_table(20373) := '6F6E74616C5361736857696474682874686973292B22707822297D7D6765744F7274686F676F6E616C536173682865297B76617220743B636F6E7374206E3D6E756C6C213D3D28743D652E696E697469616C546172676574292626766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(20374) := '743F743A652E7461726765743B6966286E26266E20696E7374616E63656F662048544D4C456C656D656E742972657475726E206E2E636C6173734C6973742E636F6E7461696E7328226F7274686F676F6E616C2D647261672D68616E646C6522293F6E2E';
wwv_flow_imp.g_varchar2_table(20375) := '636C6173734C6973742E636F6E7461696E732822737461727422293F746869732E6F7274686F676F6E616C5374617274536173683A746869732E6F7274686F676F6E616C456E64536173683A766F696420307D646973706F736528297B73757065722E64';
wwv_flow_imp.g_varchar2_table(20376) := '6973706F736528292C746869732E656C2E72656D6F766528297D7D636C6173732064717B636F6E7374727563746F7228297B6C657420653B746869732E5F6F6E44696457696C6C526573697A653D6E65772043742C746869732E6F6E44696457696C6C52';
wwv_flow_imp.g_varchar2_table(20377) := '6573697A653D746869732E5F6F6E44696457696C6C526573697A652E6576656E742C746869732E5F6F6E446964526573697A653D6E65772043742C746869732E6F6E446964526573697A653D746869732E5F6F6E446964526573697A652E6576656E742C';
wwv_flow_imp.g_varchar2_table(20378) := '746869732E5F736173684C697374656E65723D6E65772061742C746869732E5F73697A653D6E657720497328302C30292C746869732E5F6D696E53697A653D6E657720497328302C30292C746869732E5F6D617853697A653D6E6577204973284E756D62';
wwv_flow_imp.g_varchar2_table(20379) := '65722E4D41585F534146455F494E54454745522C4E756D6265722E4D41585F534146455F494E5445474552292C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F656173745361';
wwv_flow_imp.g_varchar2_table(20380) := '73683D6E657720637128746869732E646F6D4E6F64652C7B676574566572746963616C536173684C6566743A28293D3E746869732E5F73697A652E77696474687D2C7B6F7269656E746174696F6E3A307D292C746869732E5F77657374536173683D6E65';
wwv_flow_imp.g_varchar2_table(20381) := '7720637128746869732E646F6D4E6F64652C7B676574566572746963616C536173684C6566743A28293D3E307D2C7B6F7269656E746174696F6E3A307D292C746869732E5F6E6F727468536173683D6E657720637128746869732E646F6D4E6F64652C7B';
wwv_flow_imp.g_varchar2_table(20382) := '676574486F72697A6F6E74616C53617368546F703A28293D3E307D2C7B6F7269656E746174696F6E3A312C6F7274686F676F6E616C456467653A74712E4E6F7274687D292C746869732E5F736F757468536173683D6E657720637128746869732E646F6D';
wwv_flow_imp.g_varchar2_table(20383) := '4E6F64652C7B676574486F72697A6F6E74616C53617368546F703A28293D3E746869732E5F73697A652E6865696768747D2C7B6F7269656E746174696F6E3A312C6F7274686F676F6E616C456467653A74712E536F7574687D292C746869732E5F6E6F72';
wwv_flow_imp.g_varchar2_table(20384) := '7468536173682E6F7274686F676F6E616C5374617274536173683D746869732E5F77657374536173682C746869732E5F6E6F727468536173682E6F7274686F676F6E616C456E64536173683D746869732E5F65617374536173682C746869732E5F736F75';
wwv_flow_imp.g_varchar2_table(20385) := '7468536173682E6F7274686F676F6E616C5374617274536173683D746869732E5F77657374536173682C746869732E5F736F757468536173682E6F7274686F676F6E616C456E64536173683D746869732E5F65617374536173683B6C657420743D302C6E';
wwv_flow_imp.g_varchar2_table(20386) := '3D303B746869732E5F736173684C697374656E65722E6164642876742E616E7928746869732E5F6E6F727468536173682E6F6E44696453746172742C746869732E5F65617374536173682E6F6E44696453746172742C746869732E5F736F757468536173';
wwv_flow_imp.g_varchar2_table(20387) := '682E6F6E44696453746172742C746869732E5F77657374536173682E6F6E446964537461727429282828293D3E7B766F696420303D3D3D65262628746869732E5F6F6E44696457696C6C526573697A652E6669726528292C653D746869732E5F73697A65';
wwv_flow_imp.g_varchar2_table(20388) := '2C743D302C6E3D30297D2929292C746869732E5F736173684C697374656E65722E6164642876742E616E7928746869732E5F6E6F727468536173682E6F6E446964456E642C746869732E5F65617374536173682E6F6E446964456E642C746869732E5F73';
wwv_flow_imp.g_varchar2_table(20389) := '6F757468536173682E6F6E446964456E642C746869732E5F77657374536173682E6F6E446964456E6429282828293D3E7B766F69642030213D3D65262628653D766F696420302C743D302C6E3D302C746869732E5F6F6E446964526573697A652E666972';
wwv_flow_imp.g_varchar2_table(20390) := '65287B64696D656E73696F6E3A746869732E5F73697A652C646F6E653A21307D29297D2929292C746869732E5F736173684C697374656E65722E61646428746869732E5F65617374536173682E6F6E4469644368616E67652828693D3E7B652626286E3D';
wwv_flow_imp.g_varchar2_table(20391) := '692E63757272656E74582D692E7374617274582C746869732E6C61796F757428652E6865696768742B742C652E77696474682B6E292C746869732E5F6F6E446964526573697A652E66697265287B64696D656E73696F6E3A746869732E5F73697A652C64';
wwv_flow_imp.g_varchar2_table(20392) := '6F6E653A21312C656173743A21307D29297D2929292C746869732E5F736173684C697374656E65722E61646428746869732E5F77657374536173682E6F6E4469644368616E67652828693D3E7B652626286E3D2D28692E63757272656E74582D692E7374';
wwv_flow_imp.g_varchar2_table(20393) := '61727458292C746869732E6C61796F757428652E6865696768742B742C652E77696474682B6E292C746869732E5F6F6E446964526573697A652E66697265287B64696D656E73696F6E3A746869732E5F73697A652C646F6E653A21312C776573743A2130';
wwv_flow_imp.g_varchar2_table(20394) := '7D29297D2929292C746869732E5F736173684C697374656E65722E61646428746869732E5F6E6F727468536173682E6F6E4469644368616E67652828693D3E7B65262628743D2D28692E63757272656E74592D692E737461727459292C746869732E6C61';
wwv_flow_imp.g_varchar2_table(20395) := '796F757428652E6865696768742B742C652E77696474682B6E292C746869732E5F6F6E446964526573697A652E66697265287B64696D656E73696F6E3A746869732E5F73697A652C646F6E653A21312C6E6F7274683A21307D29297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(20396) := '2E5F736173684C697374656E65722E61646428746869732E5F736F757468536173682E6F6E4469644368616E67652828693D3E7B65262628743D692E63757272656E74592D692E7374617274592C746869732E6C61796F757428652E6865696768742B74';
wwv_flow_imp.g_varchar2_table(20397) := '2C652E77696474682B6E292C746869732E5F6F6E446964526573697A652E66697265287B64696D656E73696F6E3A746869732E5F73697A652C646F6E653A21312C736F7574683A21307D29297D2929292C746869732E5F736173684C697374656E65722E';
wwv_flow_imp.g_varchar2_table(20398) := '6164642876742E616E7928746869732E5F65617374536173682E6F6E44696452657365742C746869732E5F77657374536173682E6F6E4469645265736574292828653D3E7B746869732E5F70726566657272656453697A65262628746869732E6C61796F';
wwv_flow_imp.g_varchar2_table(20399) := '757428746869732E5F73697A652E6865696768742C746869732E5F70726566657272656453697A652E7769647468292C746869732E5F6F6E446964526573697A652E66697265287B64696D656E73696F6E3A746869732E5F73697A652C646F6E653A2130';
wwv_flow_imp.g_varchar2_table(20400) := '7D29297D2929292C746869732E5F736173684C697374656E65722E6164642876742E616E7928746869732E5F6E6F727468536173682E6F6E44696452657365742C746869732E5F736F757468536173682E6F6E4469645265736574292828653D3E7B7468';
wwv_flow_imp.g_varchar2_table(20401) := '69732E5F70726566657272656453697A65262628746869732E6C61796F757428746869732E5F70726566657272656453697A652E6865696768742C746869732E5F73697A652E7769647468292C746869732E5F6F6E446964526573697A652E6669726528';
wwv_flow_imp.g_varchar2_table(20402) := '7B64696D656E73696F6E3A746869732E5F73697A652C646F6E653A21307D29297D2929297D646973706F736528297B746869732E5F6E6F727468536173682E646973706F736528292C746869732E5F736F757468536173682E646973706F736528292C74';
wwv_flow_imp.g_varchar2_table(20403) := '6869732E5F65617374536173682E646973706F736528292C746869732E5F77657374536173682E646973706F736528292C746869732E5F736173684C697374656E65722E646973706F736528292C746869732E5F6F6E446964526573697A652E64697370';
wwv_flow_imp.g_varchar2_table(20404) := '6F736528292C746869732E5F6F6E44696457696C6C526573697A652E646973706F736528292C746869732E646F6D4E6F64652E72656D6F766528297D656E61626C6553617368657328652C742C6E2C69297B746869732E5F6E6F727468536173682E7374';
wwv_flow_imp.g_varchar2_table(20405) := '6174653D653F333A302C746869732E5F65617374536173682E73746174653D743F333A302C746869732E5F736F757468536173682E73746174653D6E3F333A302C746869732E5F77657374536173682E73746174653D693F333A307D6C61796F75742865';
wwv_flow_imp.g_varchar2_table(20406) := '3D746869732E73697A652E6865696768742C743D746869732E73697A652E7769647468297B636F6E73747B6865696768743A6E2C77696474683A697D3D746869732E5F6D696E53697A652C7B6865696768743A6F2C77696474683A737D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(20407) := '6D617853697A653B653D4D6174682E6D6178286E2C4D6174682E6D696E286F2C6529292C743D4D6174682E6D617828692C4D6174682E6D696E28732C7429293B636F6E737420723D6E657720497328742C65293B49732E657175616C7328722C74686973';
wwv_flow_imp.g_varchar2_table(20408) := '2E5F73697A65297C7C28746869732E646F6D4E6F64652E7374796C652E6865696768743D652B227078222C746869732E646F6D4E6F64652E7374796C652E77696474683D742B227078222C746869732E5F73697A653D722C746869732E5F6E6F72746853';
wwv_flow_imp.g_varchar2_table(20409) := '6173682E6C61796F757428292C746869732E5F65617374536173682E6C61796F757428292C746869732E5F736F757468536173682E6C61796F757428292C746869732E5F77657374536173682E6C61796F75742829297D636C65617253617368486F7665';
wwv_flow_imp.g_varchar2_table(20410) := '72537461746528297B746869732E5F65617374536173682E636C65617253617368486F766572537461746528292C746869732E5F77657374536173682E636C65617253617368486F766572537461746528292C746869732E5F6E6F727468536173682E63';
wwv_flow_imp.g_varchar2_table(20411) := '6C65617253617368486F766572537461746528292C746869732E5F736F757468536173682E636C65617253617368486F766572537461746528297D6765742073697A6528297B72657475726E20746869732E5F73697A657D736574206D617853697A6528';
wwv_flow_imp.g_varchar2_table(20412) := '65297B746869732E5F6D617853697A653D657D676574206D617853697A6528297B72657475726E20746869732E5F6D617853697A657D736574206D696E53697A652865297B746869732E5F6D696E53697A653D657D676574206D696E53697A6528297B72';
wwv_flow_imp.g_varchar2_table(20413) := '657475726E20746869732E5F6D696E53697A657D7365742070726566657272656453697A652865297B746869732E5F70726566657272656453697A653D657D6765742070726566657272656453697A6528297B72657475726E20746869732E5F70726566';
wwv_flow_imp.g_varchar2_table(20414) := '657272656453697A657D7D636C61737320687120657874656E6473206C747B636F6E7374727563746F7228652C743D6E65772049732831302C313029297B737570657228292C746869732E5F656469746F723D652C746869732E616C6C6F77456469746F';
wwv_flow_imp.g_varchar2_table(20415) := '724F766572666C6F773D21302C746869732E73757070726573734D6F757365446F776E3D21312C746869732E5F726573697A61626C654E6F64653D746869732E5F7265676973746572286E6577206471292C746869732E5F636F6E74656E74506F736974';
wwv_flow_imp.g_varchar2_table(20416) := '696F6E3D6E756C6C2C746869732E5F6973526573697A696E673D21312C746869732E5F726573697A61626C654E6F64652E646F6D4E6F64652E7374796C652E706F736974696F6E3D226162736F6C757465222C746869732E5F726573697A61626C654E6F';
wwv_flow_imp.g_varchar2_table(20417) := '64652E6D696E53697A653D49732E6C6966742874292C746869732E5F726573697A61626C654E6F64652E6C61796F757428742E6865696768742C742E7769647468292C746869732E5F726573697A61626C654E6F64652E656E61626C6553617368657328';
wwv_flow_imp.g_varchar2_table(20418) := '21302C21302C21302C2130292C746869732E5F726567697374657228746869732E5F726573697A61626C654E6F64652E6F6E446964526573697A652828653D3E7B746869732E5F726573697A65286E657720497328652E64696D656E73696F6E2E776964';
wwv_flow_imp.g_varchar2_table(20419) := '74682C652E64696D656E73696F6E2E68656967687429292C652E646F6E65262628746869732E5F6973526573697A696E673D2131297D2929292C746869732E5F726567697374657228746869732E5F726573697A61626C654E6F64652E6F6E4469645769';
wwv_flow_imp.g_varchar2_table(20420) := '6C6C526573697A65282828293D3E7B746869732E5F6973526573697A696E673D21307D2929297D676574206973526573697A696E6728297B72657475726E20746869732E5F6973526573697A696E677D676574446F6D4E6F646528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(20421) := '746869732E5F726573697A61626C654E6F64652E646F6D4E6F64657D676574506F736974696F6E28297B72657475726E20746869732E5F636F6E74656E74506F736974696F6E7D67657420706F736974696F6E28297B76617220653B72657475726E286E';
wwv_flow_imp.g_varchar2_table(20422) := '756C6C3D3D3D28653D746869732E5F636F6E74656E74506F736974696F6E297C7C766F696420303D3D3D653F766F696420303A652E706F736974696F6E293F6D632E6C69667428746869732E5F636F6E74656E74506F736974696F6E2E706F736974696F';
wwv_flow_imp.g_varchar2_table(20423) := '6E293A766F696420307D5F617661696C61626C65566572746963616C537061636541626F76652865297B636F6E737420743D746869732E5F656469746F722E676574446F6D4E6F646528292C6E3D746869732E5F656469746F722E6765745363726F6C6C';
wwv_flow_imp.g_varchar2_table(20424) := '656456697369626C65506F736974696F6E2865293B6966287426266E2972657475726E2041732874292E746F702B6E2E746F702D33307D5F617661696C61626C65566572746963616C537061636542656C6F772865297B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(20425) := '5F656469746F722E676574446F6D4E6F646528292C6E3D746869732E5F656469746F722E6765745363726F6C6C656456697369626C65506F736974696F6E2865293B69662821747C7C216E2972657475726E3B636F6E737420693D41732874292C6F3D44';
wwv_flow_imp.g_varchar2_table(20426) := '7328742E6F776E6572446F63756D656E742E626F6479292C733D692E746F702B6E2E746F702B6E2E6865696768743B72657475726E206F2E6865696768742D732D32347D5F66696E64506F736974696F6E507265666572656E636528652C74297B766172';
wwv_flow_imp.g_varchar2_table(20427) := '206E2C693B636F6E7374206F3D4D6174682E6D696E286E756C6C213D3D286E3D746869732E5F617661696C61626C65566572746963616C537061636542656C6F77287429292626766F69642030213D3D6E3F6E3A312F302C65292C733D4D6174682E6D69';
wwv_flow_imp.g_varchar2_table(20428) := '6E286E756C6C213D3D28693D746869732E5F617661696C61626C65566572746963616C537061636541626F7665287429292626766F69642030213D3D693F693A312F302C65292C723D4D6174682E6D696E284D6174682E6D617828732C6F292C65292C61';
wwv_flow_imp.g_varchar2_table(20429) := '3D4D6174682E6D696E28652C72293B6C6574206C3B72657475726E206C3D746869732E5F656469746F722E6765744F7074696F6E283630292E61626F76653F613C3D733F313A323A613C3D6F3F323A312C313D3D3D6C3F746869732E5F726573697A6162';
wwv_flow_imp.g_varchar2_table(20430) := '6C654E6F64652E656E61626C655361736865732821302C21302C21312C2131293A746869732E5F726573697A61626C654E6F64652E656E61626C655361736865732821312C21302C21302C2131292C6C7D5F726573697A652865297B746869732E5F7265';
wwv_flow_imp.g_varchar2_table(20431) := '73697A61626C654E6F64652E6C61796F757428652E6865696768742C652E7769647468297D7D7661722075713D6E2838363934292C70713D7B7D3B70712E7374796C655461675472616E73666F726D3D6A7228292C70712E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(20432) := '733D567228292C70712E696E736572743D467228292E62696E64286E756C6C2C226865616422292C70712E646F6D4150493D4F7228292C70712E696E736572745374796C65456C656D656E743D487228292C4E7228292875712E412C7071292C75712E41';
wwv_flow_imp.g_varchar2_table(20433) := '262675712E412E6C6F63616C73262675712E412E6C6F63616C733B636F6E73742067713D62723B636C617373206D7120657874656E6473206C747B636F6E7374727563746F7228297B737570657228292C746869732E636F6E7461696E6572446F6D4E6F';
wwv_flow_imp.g_varchar2_table(20434) := '64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E636F6E7461696E6572446F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D686F766572222C746869732E636F6E7461696E6572446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(20435) := '652E746162496E6465783D302C746869732E636F6E7461696E6572446F6D4E6F64652E7365744174747269627574652822726F6C65222C22746F6F6C74697022292C746869732E636F6E74656E7473446F6D4E6F64653D646F63756D656E742E63726561';
wwv_flow_imp.g_varchar2_table(20436) := '7465456C656D656E74282264697622292C746869732E636F6E74656E7473446F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D686F7665722D636F6E74656E74222C746869732E7363726F6C6C6261723D746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(20437) := '286E657720675428746869732E636F6E74656E7473446F6D4E6F64652C7B636F6E73756D654D6F757365576865656C49665363726F6C6C62617249734E65656465643A21307D29292C746869732E636F6E7461696E6572446F6D4E6F64652E617070656E';
wwv_flow_imp.g_varchar2_table(20438) := '644368696C6428746869732E7363726F6C6C6261722E676574446F6D4E6F64652829297D6F6E436F6E74656E74734368616E67656428297B746869732E7363726F6C6C6261722E7363616E446F6D4E6F646528297D7D636C61737320667120657874656E';
wwv_flow_imp.g_varchar2_table(20439) := '6473206C747B7374617469632072656E64657228652C742C6E297B72657475726E206E657720667128652C742C6E297D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E616374696F6E436F6E7461696E65723D75722865';
wwv_flow_imp.g_varchar2_table(20440) := '2C677128226469762E616374696F6E2D636F6E7461696E65722229292C746869732E616374696F6E436F6E7461696E65722E7365744174747269627574652822746162696E646578222C223022292C746869732E616374696F6E3D757228746869732E61';
wwv_flow_imp.g_varchar2_table(20441) := '6374696F6E436F6E7461696E65722C67712822612E616374696F6E2229292C746869732E616374696F6E2E7365744174747269627574652822726F6C65222C22627574746F6E22292C742E69636F6E436C6173732626757228746869732E616374696F6E';
wwv_flow_imp.g_varchar2_table(20442) := '2C677128607370616E2E69636F6E2E247B742E69636F6E436C6173737D6029292C757228746869732E616374696F6E2C677128227370616E2229292E74657874436F6E74656E743D6E3F60247B742E6C6162656C7D2028247B6E7D29603A742E6C616265';
wwv_flow_imp.g_varchar2_table(20443) := '6C2C746869732E5F73746F72652E616464286E657720627128746869732E616374696F6E436F6E7461696E65722C742E72756E29292C746869732E5F73746F72652E616464286E6577205F7128746869732E616374696F6E436F6E7461696E65722C742E';
wwv_flow_imp.g_varchar2_table(20444) := '72756E2C5B332C31305D29292C746869732E736574456E61626C6564282130297D736574456E61626C65642865297B653F28746869732E616374696F6E436F6E7461696E65722E636C6173734C6973742E72656D6F7665282264697361626C656422292C';
wwv_flow_imp.g_varchar2_table(20445) := '746869732E616374696F6E436F6E7461696E65722E72656D6F76654174747269627574652822617269612D64697361626C65642229293A28746869732E616374696F6E436F6E7461696E65722E636C6173734C6973742E616464282264697361626C6564';
wwv_flow_imp.g_varchar2_table(20446) := '22292C746869732E616374696F6E436F6E7461696E65722E7365744174747269627574652822617269612D64697361626C6564222C22747275652229297D7D66756E6374696F6E20767128652C74297B72657475726E20652626743F6228302C22496E73';
wwv_flow_imp.g_varchar2_table(20447) := '70656374207468697320696E207468652061636365737369626C6520766965772077697468207B307D2E222C74293A653F6228302C22496E7370656374207468697320696E207468652061636365737369626C652076696577207669612074686520636F';
wwv_flow_imp.g_varchar2_table(20448) := '6D6D616E64204F70656E2041636365737369626C6520566965772077686963682069732063757272656E746C79206E6F74207472696767657261626C6520766961206B657962696E64696E672E22293A22227D636C61737320627120657874656E647320';
wwv_flow_imp.g_varchar2_table(20449) := '6C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F726567697374657228627328652C61722E434C49434B2C286E3D3E7B6E2E73746F7050726F7061676174696F6E28292C6E2E70726576656E7444656661756C742829';
wwv_flow_imp.g_varchar2_table(20450) := '2C742865297D2929297D7D636C617373205F7120657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F726567697374657228627328652C61722E4B45595F444F574E2C28693D3E7B636F6E7374';
wwv_flow_imp.g_varchar2_table(20451) := '206F3D6E65772071652869293B6E2E736F6D652828653D3E6F2E657175616C732865292929262628692E73746F7050726F7061676174696F6E28292C692E70726576656E7444656661756C7428292C74286529297D2929297D7D7661722079712C77713D';
wwv_flow_imp.g_varchar2_table(20452) := '66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742043713D79713D636C61737320657874656E64732068717B676574206973436F6C6F725069636B657256697369626C6528297B';
wwv_flow_imp.g_varchar2_table(20453) := '76617220653B72657475726E20426F6F6C65616E286E756C6C3D3D3D28653D746869732E5F76697369626C6544617461297C7C766F696420303D3D3D653F766F696420303A652E636F6C6F725069636B6572297D67657420697356697369626C6546726F';
wwv_flow_imp.g_varchar2_table(20454) := '6D4B6579626F61726428297B76617220653B72657475726E20313D3D3D286E756C6C3D3D3D28653D746869732E5F76697369626C6544617461297C7C766F696420303D3D3D653F766F696420303A652E736F75726365297D67657420697356697369626C';
wwv_flow_imp.g_varchar2_table(20455) := '6528297B76617220653B72657475726E206E756C6C213D3D28653D746869732E5F686F76657256697369626C654B65792E6765742829292626766F69642030213D3D652626657D676574206973466F637573656428297B76617220653B72657475726E20';
wwv_flow_imp.g_varchar2_table(20456) := '6E756C6C213D3D28653D746869732E5F686F766572466F63757365644B65792E6765742829292626766F69642030213D3D652626657D636F6E7374727563746F7228652C742C6E2C692C6F297B636F6E737420733D652E6765744F7074696F6E28363729';
wwv_flow_imp.g_varchar2_table(20457) := '2B382C723D6E6577204973283135302C73293B737570657228652C72292C746869732E5F636F6E66696775726174696F6E536572766963653D6E2C746869732E5F6163636573736962696C697479536572766963653D692C746869732E5F6B657962696E';
wwv_flow_imp.g_varchar2_table(20458) := '64696E67536572766963653D6F2C746869732E5F686F7665723D746869732E5F7265676973746572286E6577206D71292C746869732E5F6D696E696D756D53697A653D722C746869732E5F686F76657256697369626C654B65793D6C682E686F76657256';
wwv_flow_imp.g_varchar2_table(20459) := '697369626C652E62696E64546F2874292C746869732E5F686F766572466F63757365644B65793D6C682E686F766572466F63757365642E62696E64546F2874292C757228746869732E5F726573697A61626C654E6F64652E646F6D4E6F64652C74686973';
wwv_flow_imp.g_varchar2_table(20460) := '2E5F686F7665722E636F6E7461696E6572446F6D4E6F6465292C746869732E5F726573697A61626C654E6F64652E646F6D4E6F64652E7374796C652E7A496E6465783D223530222C746869732E5F726567697374657228746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(20461) := '6F6E4469644C61796F75744368616E6765282828293D3E7B746869732E697356697369626C652626746869732E5F7570646174654D617844696D656E73696F6E7328297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(20462) := '6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E676564283530292626746869732E5F757064617465466F6E7428297D2929293B636F6E737420613D746869732E5F726567697374657228687228746869';
wwv_flow_imp.g_varchar2_table(20463) := '732E5F726573697A61626C654E6F64652E646F6D4E6F646529293B746869732E5F726567697374657228612E6F6E446964466F637573282828293D3E7B746869732E5F686F766572466F63757365644B65792E736574282130297D2929292C746869732E';
wwv_flow_imp.g_varchar2_table(20464) := '5F726567697374657228612E6F6E446964426C7572282828293D3E7B746869732E5F686F766572466F63757365644B65792E736574282131297D2929292C746869732E5F736574486F7665724461746128766F69642030292C746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(20465) := '722E616464436F6E74656E745769646765742874686973297D646973706F736528297B76617220653B73757065722E646973706F736528292C6E756C6C3D3D3D28653D746869732E5F76697369626C6544617461297C7C766F696420303D3D3D657C7C65';
wwv_flow_imp.g_varchar2_table(20466) := '2E646973706F7361626C65732E646973706F736528292C746869732E5F656469746F722E72656D6F7665436F6E74656E745769646765742874686973297D676574496428297B72657475726E2079712E49447D737461746963205F6170706C7944696D65';
wwv_flow_imp.g_varchar2_table(20467) := '6E73696F6E7328652C742C6E297B636F6E737420693D226E756D626572223D3D747970656F6620743F60247B747D7078603A742C6F3D226E756D626572223D3D747970656F66206E3F60247B6E7D7078603A6E3B652E7374796C652E77696474683D692C';
wwv_flow_imp.g_varchar2_table(20468) := '652E7374796C652E6865696768743D6F7D5F736574436F6E74656E7473446F6D4E6F646544696D656E73696F6E7328652C74297B636F6E7374206E3D746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64653B72657475726E2079712E5F61';
wwv_flow_imp.g_varchar2_table(20469) := '70706C7944696D656E73696F6E73286E2C652C74297D5F736574436F6E7461696E6572446F6D4E6F646544696D656E73696F6E7328652C74297B636F6E7374206E3D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64653B7265747572';
wwv_flow_imp.g_varchar2_table(20470) := '6E2079712E5F6170706C7944696D656E73696F6E73286E2C652C74297D5F736574486F76657257696467657444696D656E73696F6E7328652C74297B746869732E5F736574436F6E74656E7473446F6D4E6F646544696D656E73696F6E7328652C74292C';
wwv_flow_imp.g_varchar2_table(20471) := '746869732E5F736574436F6E7461696E6572446F6D4E6F646544696D656E73696F6E7328652C74292C746869732E5F6C61796F7574436F6E74656E7457696467657428297D737461746963205F6170706C794D617844696D656E73696F6E7328652C742C';
wwv_flow_imp.g_varchar2_table(20472) := '6E297B636F6E737420693D226E756D626572223D3D747970656F6620743F60247B747D7078603A742C6F3D226E756D626572223D3D747970656F66206E3F60247B6E7D7078603A6E3B652E7374796C652E6D617857696474683D692C652E7374796C652E';
wwv_flow_imp.g_varchar2_table(20473) := '6D61784865696768743D6F7D5F736574486F7665725769646765744D617844696D656E73696F6E7328652C74297B79712E5F6170706C794D617844696D656E73696F6E7328746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652C652C74';
wwv_flow_imp.g_varchar2_table(20474) := '292C79712E5F6170706C794D617844696D656E73696F6E7328746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652C652C74292C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E73657450726F';
wwv_flow_imp.g_varchar2_table(20475) := '706572747928222D2D7673636F64652D686F7665722D6D61785769647468222C226E756D626572223D3D747970656F6620653F60247B657D7078603A65292C746869732E5F6C61796F7574436F6E74656E7457696467657428297D5F73657441646A7573';
wwv_flow_imp.g_varchar2_table(20476) := '746564486F76657257696467657444696D656E73696F6E732865297B746869732E5F736574486F7665725769646765744D617844696D656E73696F6E7328226E6F6E65222C226E6F6E6522293B636F6E737420743D652E77696474682C6E3D652E686569';
wwv_flow_imp.g_varchar2_table(20477) := '6768743B746869732E5F736574486F76657257696467657444696D656E73696F6E7328742C6E297D5F757064617465526573697A61626C654E6F64654D617844696D656E73696F6E7328297B76617220652C743B636F6E7374206E3D6E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(20478) := '653D746869732E5F66696E644D6178696D756D52656E646572696E6757696474682829292626766F69642030213D3D653F653A312F302C693D6E756C6C213D3D28743D746869732E5F66696E644D6178696D756D52656E646572696E6748656967687428';
wwv_flow_imp.g_varchar2_table(20479) := '29292626766F69642030213D3D743F743A312F303B746869732E5F726573697A61626C654E6F64652E6D617853697A653D6E6577204973286E2C69292C746869732E5F736574486F7665725769646765744D617844696D656E73696F6E73286E2C69297D';
wwv_flow_imp.g_varchar2_table(20480) := '5F726573697A652865297B76617220742C6E3B79712E5F6C61737444696D656E73696F6E733D6E657720497328652E77696474682C652E686569676874292C746869732E5F73657441646A7573746564486F76657257696467657444696D656E73696F6E';
wwv_flow_imp.g_varchar2_table(20481) := '732865292C746869732E5F726573697A61626C654E6F64652E6C61796F757428652E6865696768742C652E7769647468292C746869732E5F757064617465526573697A61626C654E6F64654D617844696D656E73696F6E7328292C746869732E5F686F76';
wwv_flow_imp.g_varchar2_table(20482) := '65722E7363726F6C6C6261722E7363616E446F6D4E6F646528292C746869732E5F656469746F722E6C61796F7574436F6E74656E745769646765742874686973292C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F76697369626C6544';
wwv_flow_imp.g_varchar2_table(20483) := '617461297C7C766F696420303D3D3D743F766F696420303A742E636F6C6F725069636B6572297C7C766F696420303D3D3D6E7C7C6E2E6C61796F757428297D5F66696E64417661696C61626C655370616365566572746963616C6C7928297B7661722065';
wwv_flow_imp.g_varchar2_table(20484) := '3B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F76697369626C6544617461297C7C766F696420303D3D3D653F766F696420303A652E73686F774174506F736974696F6E3B696628742972657475726E20313D3D3D746869732E5F706F7369';
wwv_flow_imp.g_varchar2_table(20485) := '74696F6E507265666572656E63653F746869732E5F617661696C61626C65566572746963616C537061636541626F76652874293A746869732E5F617661696C61626C65566572746963616C537061636542656C6F772874297D5F66696E644D6178696D75';
wwv_flow_imp.g_varchar2_table(20486) := '6D52656E646572696E6748656967687428297B636F6E737420653D746869732E5F66696E64417661696C61626C655370616365566572746963616C6C7928293B69662821652972657475726E3B6C657420743D363B72657475726E2041727261792E6672';
wwv_flow_imp.g_varchar2_table(20487) := '6F6D28746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E6368696C6472656E292E666F72456163682828653D3E7B742B3D652E636C69656E744865696768747D29292C4D6174682E6D696E28652C74297D5F6973486F766572546578';
wwv_flow_imp.g_varchar2_table(20488) := '744F766572666C6F77696E6728297B746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E73657450726F706572747928222D2D7673636F64652D686F7665722D77686974655370616365222C226E6F7772617022292C';
wwv_flow_imp.g_varchar2_table(20489) := '746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E73657450726F706572747928222D2D7673636F64652D686F7665722D736F7572636557686974655370616365222C226E6F7772617022293B636F6E737420653D41';
wwv_flow_imp.g_varchar2_table(20490) := '727261792E66726F6D28746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E6368696C6472656E292E736F6D652828653D3E652E7363726F6C6C57696474683E652E636C69656E74576964746829293B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(20491) := '686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E72656D6F766550726F706572747928222D2D7673636F64652D686F7665722D7768697465537061636522292C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(20492) := '652E7374796C652E72656D6F766550726F706572747928222D2D7673636F64652D686F7665722D736F757263655768697465537061636522292C657D5F66696E644D6178696D756D52656E646572696E67576964746828297B69662821746869732E5F65';
wwv_flow_imp.g_varchar2_table(20493) := '6469746F727C7C21746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420653D746869732E5F6973486F766572546578744F766572666C6F77696E6728292C743D766F696420303D3D3D746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(20494) := '6E7457696474683F303A746869732E5F636F6E74656E7457696474682D323B72657475726E20657C7C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474683C743F447328746869732E5F686F7665722E63';
wwv_flow_imp.g_varchar2_table(20495) := '6F6E7461696E6572446F6D4E6F64652E6F776E6572446F63756D656E742E626F6479292E77696474682D31343A746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682B327D69734D6F7573654765747469';
wwv_flow_imp.g_varchar2_table(20496) := '6E67436C6F73657228652C74297B69662821746869732E5F76697369626C65446174612972657475726E21313B696628766F696420303D3D3D746869732E5F76697369626C65446174612E696E697469616C4D6F757365506F73587C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(20497) := '3D3D746869732E5F76697369626C65446174612E696E697469616C4D6F757365506F73592972657475726E20746869732E5F76697369626C65446174612E696E697469616C4D6F757365506F73583D652C746869732E5F76697369626C65446174612E69';
wwv_flow_imp.g_varchar2_table(20498) := '6E697469616C4D6F757365506F73593D742C21313B636F6E7374206E3D417328746869732E676574446F6D4E6F64652829293B766F696420303D3D3D746869732E5F76697369626C65446174612E636C6F736573744D6F75736544697374616E63652626';
wwv_flow_imp.g_varchar2_table(20499) := '28746869732E5F76697369626C65446174612E636C6F736573744D6F75736544697374616E63653D537128746869732E5F76697369626C65446174612E696E697469616C4D6F757365506F73582C746869732E5F76697369626C65446174612E696E6974';
wwv_flow_imp.g_varchar2_table(20500) := '69616C4D6F757365506F73592C6E2E6C6566742C6E2E746F702C6E2E77696474682C6E2E68656967687429293B636F6E737420693D537128652C742C6E2E6C6566742C6E2E746F702C6E2E77696474682C6E2E686569676874293B72657475726E212869';
wwv_flow_imp.g_varchar2_table(20501) := '3E746869732E5F76697369626C65446174612E636C6F736573744D6F75736544697374616E63652B347C7C28746869732E5F76697369626C65446174612E636C6F736573744D6F75736544697374616E63653D4D6174682E6D696E28746869732E5F7669';
wwv_flow_imp.g_varchar2_table(20502) := '7369626C65446174612E636C6F736573744D6F75736544697374616E63652C69292C3029297D5F736574486F766572446174612865297B76617220743B6E756C6C3D3D3D28743D746869732E5F76697369626C6544617461297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(20503) := '747C7C742E646973706F7361626C65732E646973706F736528292C746869732E5F76697369626C65446174613D652C746869732E5F686F76657256697369626C654B65792E73657428212165292C746869732E5F686F7665722E636F6E7461696E657244';
wwv_flow_imp.g_varchar2_table(20504) := '6F6D4E6F64652E636C6173734C6973742E746F67676C65282268696464656E222C2165297D5F757064617465466F6E7428297B636F6E73747B666F6E7453697A653A652C6C696E654865696768743A747D3D746869732E5F656469746F722E6765744F70';
wwv_flow_imp.g_varchar2_table(20505) := '74696F6E283530292C6E3D746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64653B6E2E7374796C652E666F6E7453697A653D60247B657D7078602C6E2E7374796C652E6C696E654865696768743D22222B742F652C41727261792E70726F';
wwv_flow_imp.g_varchar2_table(20506) := '746F747970652E736C6963652E63616C6C28746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E676574456C656D656E74734279436C6173734E616D652822636F64652229292E666F72456163682828653D3E746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(20507) := '6F722E6170706C79466F6E74496E666F28652929297D5F757064617465436F6E74656E742865297B636F6E737420743D746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64653B742E7374796C652E70616464696E67426F74746F6D3D2222';
wwv_flow_imp.g_varchar2_table(20508) := '2C742E74657874436F6E74656E743D22222C742E617070656E644368696C642865297D5F6C61796F7574436F6E74656E7457696467657428297B746869732E5F656469746F722E6C61796F7574436F6E74656E745769646765742874686973292C746869';
wwv_flow_imp.g_varchar2_table(20509) := '732E5F686F7665722E6F6E436F6E74656E74734368616E67656428297D5F7570646174654D617844696D656E73696F6E7328297B636F6E737420653D4D6174682E6D617828746869732E5F656469746F722E6765744C61796F7574496E666F28292E6865';
wwv_flow_imp.g_varchar2_table(20510) := '696768742F342C3235302C79712E5F6C61737444696D656E73696F6E732E686569676874292C743D4D6174682E6D6178282E36362A746869732E5F656469746F722E6765744C61796F7574496E666F28292E77696474682C3530302C79712E5F6C617374';
wwv_flow_imp.g_varchar2_table(20511) := '44696D656E73696F6E732E7769647468293B746869732E5F736574486F7665725769646765744D617844696D656E73696F6E7328742C65297D5F72656E64657228652C74297B746869732E5F736574486F766572446174612874292C746869732E5F7570';
wwv_flow_imp.g_varchar2_table(20512) := '64617465466F6E7428292C746869732E5F757064617465436F6E74656E742865292C746869732E5F7570646174654D617844696D656E73696F6E7328292C746869732E6F6E436F6E74656E74734368616E67656428292C746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(20513) := '72656E64657228297D676574506F736974696F6E28297B76617220653B72657475726E20746869732E5F76697369626C65446174613F7B706F736974696F6E3A746869732E5F76697369626C65446174612E73686F774174506F736974696F6E2C736563';
wwv_flow_imp.g_varchar2_table(20514) := '6F6E64617279506F736974696F6E3A746869732E5F76697369626C65446174612E73686F7741745365636F6E64617279506F736974696F6E2C706F736974696F6E416666696E6974793A746869732E5F76697369626C65446174612E69734265666F7265';
wwv_flow_imp.g_varchar2_table(20515) := '436F6E74656E743F333A766F696420302C707265666572656E63653A5B6E756C6C213D3D28653D746869732E5F706F736974696F6E507265666572656E6365292626766F69642030213D3D653F653A315D7D3A6E756C6C7D73686F77417428652C74297B';
wwv_flow_imp.g_varchar2_table(20516) := '766172206E2C692C6F2C733B69662821746869732E5F656469746F727C7C21746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B746869732E5F72656E64657228652C74293B636F6E737420723D467328746869732E5F686F76';
wwv_flow_imp.g_varchar2_table(20517) := '65722E636F6E7461696E6572446F6D4E6F6465292C613D742E73686F774174506F736974696F6E3B746869732E5F706F736974696F6E507265666572656E63653D6E756C6C213D3D286E3D746869732E5F66696E64506F736974696F6E50726566657265';
wwv_flow_imp.g_varchar2_table(20518) := '6E636528722C6129292626766F69642030213D3D6E3F6E3A312C746869732E6F6E436F6E74656E74734368616E67656428292C742E73746F6C65466F6375732626746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E666F63757328';
wwv_flow_imp.g_varchar2_table(20519) := '292C6E756C6C3D3D3D28693D742E636F6C6F725069636B6572297C7C766F696420303D3D3D697C7C692E6C61796F757428293B636F6E7374206C3D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E6F776E6572446F63756D656E';
wwv_flow_imp.g_varchar2_table(20520) := '742E616374697665456C656D656E743D3D3D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F6465262676712821303D3D3D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C7565282261636365737369';
wwv_flow_imp.g_varchar2_table(20521) := '62696C6974792E766572626F736974792E686F76657222292626746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A656428292C6E756C6C213D3D28733D6E756C6C3D3D3D286F3D74';
wwv_flow_imp.g_varchar2_table(20522) := '6869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672822656469746F722E616374696F6E2E61636365737369626C65566965772229297C7C766F696420303D3D3D6F3F766F696420303A6F2E676574417269';
wwv_flow_imp.g_varchar2_table(20523) := '614C6162656C2829292626766F69642030213D3D733F733A2222293B6C262628746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E617269614C6162656C3D746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E7465';
wwv_flow_imp.g_varchar2_table(20524) := '7874436F6E74656E742B222C20222B6C297D6869646528297B69662821746869732E5F76697369626C65446174612972657475726E3B636F6E737420653D746869732E5F76697369626C65446174612E73746F6C65466F6375737C7C746869732E5F686F';
wwv_flow_imp.g_varchar2_table(20525) := '766572466F63757365644B65792E67657428293B746869732E5F736574486F7665724461746128766F69642030292C746869732E5F726573697A61626C654E6F64652E6D617853697A653D6E657720497328312F302C312F30292C746869732E5F726573';
wwv_flow_imp.g_varchar2_table(20526) := '697A61626C654E6F64652E636C65617253617368486F766572537461746528292C746869732E5F686F766572466F63757365644B65792E736574282131292C746869732E5F656469746F722E6C61796F7574436F6E74656E745769646765742874686973';
wwv_flow_imp.g_varchar2_table(20527) := '292C652626746869732E5F656469746F722E666F63757328297D5F72656D6F7665436F6E73747261696E747352656E6465724E6F726D616C6C7928297B636F6E737420653D746869732E5F656469746F722E6765744C61796F7574496E666F28293B7468';
wwv_flow_imp.g_varchar2_table(20528) := '69732E5F726573697A61626C654E6F64652E6C61796F757428652E6865696768742C652E7769647468292C746869732E5F736574486F76657257696467657444696D656E73696F6E7328226175746F222C226175746F22297D7365744D696E696D756D44';
wwv_flow_imp.g_varchar2_table(20529) := '696D656E73696F6E732865297B746869732E5F6D696E696D756D53697A653D6E6577204973284D6174682E6D617828746869732E5F6D696E696D756D53697A652E77696474682C652E7769647468292C4D6174682E6D617828746869732E5F6D696E696D';
wwv_flow_imp.g_varchar2_table(20530) := '756D53697A652E6865696768742C652E68656967687429292C746869732E5F7570646174654D696E696D756D576964746828297D5F7570646174654D696E696D756D576964746828297B636F6E737420653D766F696420303D3D3D746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(20531) := '74656E7457696474683F746869732E5F6D696E696D756D53697A652E77696474683A4D6174682E6D696E28746869732E5F636F6E74656E7457696474682C746869732E5F6D696E696D756D53697A652E7769647468293B746869732E5F726573697A6162';
wwv_flow_imp.g_varchar2_table(20532) := '6C654E6F64652E6D696E53697A653D6E657720497328652C746869732E5F6D696E696D756D53697A652E686569676874297D6F6E436F6E74656E74734368616E67656428297B76617220653B746869732E5F72656D6F7665436F6E73747261696E747352';
wwv_flow_imp.g_varchar2_table(20533) := '656E6465724E6F726D616C6C7928293B636F6E737420743D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64653B6C6574206E3D46732874292C693D50732874293B696628746869732E5F726573697A61626C654E6F64652E6C61796F';
wwv_flow_imp.g_varchar2_table(20534) := '7574286E2C69292C746869732E5F736574486F76657257696467657444696D656E73696F6E7328692C6E292C6E3D46732874292C693D50732874292C746869732E5F636F6E74656E7457696474683D692C746869732E5F7570646174654D696E696D756D';
wwv_flow_imp.g_varchar2_table(20535) := '576964746828292C746869732E5F726573697A61626C654E6F64652E6C61796F7574286E2C69292C6E756C6C3D3D3D28653D746869732E5F76697369626C6544617461297C7C766F696420303D3D3D653F766F696420303A652E73686F774174506F7369';
wwv_flow_imp.g_varchar2_table(20536) := '74696F6E297B636F6E737420653D467328746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F6465293B746869732E5F706F736974696F6E507265666572656E63653D746869732E5F66696E64506F736974696F6E507265666572656E6365';
wwv_flow_imp.g_varchar2_table(20537) := '28652C746869732E5F76697369626C65446174612E73686F774174506F736974696F6E297D746869732E5F6C61796F7574436F6E74656E7457696467657428297D666F63757328297B746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64';
wwv_flow_imp.g_varchar2_table(20538) := '652E666F63757328297D7363726F6C6C557028297B636F6E737420653D746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C546F702C743D746869732E5F656469746F722E6765744F';
wwv_flow_imp.g_varchar2_table(20539) := '7074696F6E283530293B746869732E5F686F7665722E7363726F6C6C6261722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A652D742E6C696E654865696768747D297D7363726F6C6C446F776E28297B636F6E737420653D74';
wwv_flow_imp.g_varchar2_table(20540) := '6869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C546F702C743D746869732E5F656469746F722E6765744F7074696F6E283530293B746869732E5F686F7665722E7363726F6C6C6261';
wwv_flow_imp.g_varchar2_table(20541) := '722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A652B742E6C696E654865696768747D297D7363726F6C6C4C65667428297B636F6E737420653D746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C';
wwv_flow_imp.g_varchar2_table(20542) := '506F736974696F6E28292E7363726F6C6C4C6566743B746869732E5F686F7665722E7363726F6C6C6261722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C4C6566743A652D33307D297D7363726F6C6C526967687428297B636F6E7374';
wwv_flow_imp.g_varchar2_table(20543) := '20653D746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C4C6566743B746869732E5F686F7665722E7363726F6C6C6261722E7365745363726F6C6C506F736974696F6E287B736372';
wwv_flow_imp.g_varchar2_table(20544) := '6F6C6C4C6566743A652B33307D297D70616765557028297B636F6E737420653D746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C546F702C743D746869732E5F686F7665722E7363';
wwv_flow_imp.g_varchar2_table(20545) := '726F6C6C6261722E6765745363726F6C6C44696D656E73696F6E7328292E6865696768743B746869732E5F686F7665722E7363726F6C6C6261722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A652D747D297D70616765446F';
wwv_flow_imp.g_varchar2_table(20546) := '776E28297B636F6E737420653D746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C546F702C743D746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C4469';
wwv_flow_imp.g_varchar2_table(20547) := '6D656E73696F6E7328292E6865696768743B746869732E5F686F7665722E7363726F6C6C6261722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A652B747D297D676F546F546F7028297B746869732E5F686F7665722E736372';
wwv_flow_imp.g_varchar2_table(20548) := '6F6C6C6261722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A307D297D676F546F426F74746F6D28297B746869732E5F686F7665722E7363726F6C6C6261722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C';
wwv_flow_imp.g_varchar2_table(20549) := '546F703A746869732E5F686F7665722E7363726F6C6C6261722E6765745363726F6C6C44696D656E73696F6E7328292E7363726F6C6C4865696768747D297D7D3B66756E6374696F6E20537128652C742C6E2C692C6F2C73297B636F6E737420723D6E2B';
wwv_flow_imp.g_varchar2_table(20550) := '6F2F322C613D692B732F322C6C3D4D6174682E6D6178284D6174682E61627328652D72292D6F2F322C30292C633D4D6174682E6D6178284D6174682E61627328742D61292D732F322C30293B72657475726E204D6174682E73717274286C2A6C2B632A63';
wwv_flow_imp.g_varchar2_table(20551) := '297D43712E49443D22656469746F722E636F6E747269622E726573697A61626C65436F6E74656E74486F766572576964676574222C43712E5F6C61737444696D656E73696F6E733D6E657720497328302C30292C43713D79713D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(20552) := '2C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A6563';
wwv_flow_imp.g_varchar2_table(20553) := '74223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D65';
wwv_flow_imp.g_varchar2_table(20554) := '2E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(20555) := '72747928742C6E2C72292C727D285B777128312C6364292C777128322C6670292C777128332C5953292C777128342C2445295D2C4371293B636C6173732078717B636F6E7374727563746F7228652C742C6E297B746869732E76616C75653D652C746869';
wwv_flow_imp.g_varchar2_table(20556) := '732E6973436F6D706C6574653D742C746869732E6861734C6F6164696E674D6573736167653D6E7D7D636C617373206B7120657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F656469746F723D65';
wwv_flow_imp.g_varchar2_table(20557) := '2C746869732E5F636F6D70757465723D742C746869732E5F6F6E526573756C743D746869732E5F7265676973746572286E6577204374292C746869732E6F6E526573756C743D746869732E5F6F6E526573756C742E6576656E742C746869732E5F666972';
wwv_flow_imp.g_varchar2_table(20558) := '7374576169745363686564756C65723D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F747269676765724173796E63436F6D7075746174696F6E2829292C3029292C746869732E5F7365636F6E645761697453636865';
wwv_flow_imp.g_varchar2_table(20559) := '64756C65723D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F7472696767657253796E63436F6D7075746174696F6E2829292C3029292C746869732E5F6C6F6164696E674D6573736167655363686564756C65723D74';
wwv_flow_imp.g_varchar2_table(20560) := '6869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F747269676765724C6F6164696E674D6573736167652829292C3029292C746869732E5F73746174653D302C746869732E5F6173796E634974657261626C653D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(20561) := '746869732E5F6173796E634974657261626C65446F6E653D21312C746869732E5F726573756C743D5B5D7D646973706F736528297B746869732E5F6173796E634974657261626C65262628746869732E5F6173796E634974657261626C652E63616E6365';
wwv_flow_imp.g_varchar2_table(20562) := '6C28292C746869732E5F6173796E634974657261626C653D6E756C6C292C73757065722E646973706F736528297D676574205F686F76657254696D6528297B72657475726E20746869732E5F656469746F722E6765744F7074696F6E283630292E64656C';
wwv_flow_imp.g_varchar2_table(20563) := '61797D676574205F66697273745761697454696D6528297B72657475726E20746869732E5F686F76657254696D652F327D676574205F7365636F6E645761697454696D6528297B72657475726E20746869732E5F686F76657254696D652D746869732E5F';
wwv_flow_imp.g_varchar2_table(20564) := '66697273745761697454696D657D676574205F6C6F6164696E674D65737361676554696D6528297B72657475726E20332A746869732E5F686F76657254696D657D5F736574537461746528652C743D2130297B746869732E5F73746174653D652C742626';
wwv_flow_imp.g_varchar2_table(20565) := '746869732E5F66697265526573756C7428297D5F747269676765724173796E63436F6D7075746174696F6E28297B746869732E5F73657453746174652832292C746869732E5F7365636F6E64576169745363686564756C65722E7363686564756C652874';
wwv_flow_imp.g_varchar2_table(20566) := '6869732E5F7365636F6E645761697454696D65292C746869732E5F636F6D70757465722E636F6D707574654173796E633F28746869732E5F6173796E634974657261626C65446F6E653D21312C746869732E5F6173796E634974657261626C653D66756E';
wwv_flow_imp.g_varchar2_table(20567) := '6374696F6E2865297B636F6E737420743D6E6577204E742C6E3D6528742E746F6B656E293B72657475726E206E657720746E28742C286173796E6320653D3E7B636F6E737420693D742E746F6B656E2E6F6E43616E63656C6C6174696F6E526571756573';
wwv_flow_imp.g_varchar2_table(20568) := '746564282828293D3E7B692E646973706F736528292C742E646973706F736528292C652E72656A656374286E6577204965297D29293B7472797B666F7220617761697428636F6E73742069206F66206E297B696628742E746F6B656E2E697343616E6365';
wwv_flow_imp.g_varchar2_table(20569) := '6C6C6174696F6E5265717565737465642972657475726E3B652E656D69744F6E652869297D692E646973706F736528292C742E646973706F736528297D6361746368286E297B692E646973706F736528292C742E646973706F736528292C652E72656A65';
wwv_flow_imp.g_varchar2_table(20570) := '6374286E297D7D29297D2828653D3E746869732E5F636F6D70757465722E636F6D707574654173796E6328652929292C286173796E6328293D3E7B7472797B666F7220617761697428636F6E73742065206F6620746869732E5F6173796E634974657261';
wwv_flow_imp.g_varchar2_table(20571) := '626C652965262628746869732E5F726573756C742E707573682865292C746869732E5F66697265526573756C742829293B746869732E5F6173796E634974657261626C65446F6E653D21302C33213D3D746869732E5F7374617465262634213D3D746869';
wwv_flow_imp.g_varchar2_table(20572) := '732E5F73746174657C7C746869732E5F73657453746174652830297D63617463682865297B6B652865297D7D292829293A746869732E5F6173796E634974657261626C65446F6E653D21307D5F7472696767657253796E63436F6D7075746174696F6E28';
wwv_flow_imp.g_varchar2_table(20573) := '297B746869732E5F636F6D70757465722E636F6D7075746553796E63262628746869732E5F726573756C743D746869732E5F726573756C742E636F6E63617428746869732E5F636F6D70757465722E636F6D7075746553796E63282929292C746869732E';
wwv_flow_imp.g_varchar2_table(20574) := '5F736574537461746528746869732E5F6173796E634974657261626C65446F6E653F303A33297D5F747269676765724C6F6164696E674D65737361676528297B333D3D3D746869732E5F73746174652626746869732E5F73657453746174652834297D5F';
wwv_flow_imp.g_varchar2_table(20575) := '66697265526573756C7428297B696628313D3D3D746869732E5F73746174657C7C323D3D3D746869732E5F73746174652972657475726E3B636F6E737420653D303D3D3D746869732E5F73746174652C743D343D3D3D746869732E5F73746174653B7468';
wwv_flow_imp.g_varchar2_table(20576) := '69732E5F6F6E526573756C742E66697265286E657720787128746869732E5F726573756C742E736C6963652830292C652C7429297D73746172742865297B696628303D3D3D6529303D3D3D746869732E5F7374617465262628746869732E5F7365745374';
wwv_flow_imp.g_varchar2_table(20577) := '6174652831292C746869732E5F6669727374576169745363686564756C65722E7363686564756C6528746869732E5F66697273745761697454696D65292C746869732E5F6C6F6164696E674D6573736167655363686564756C65722E7363686564756C65';
wwv_flow_imp.g_varchar2_table(20578) := '28746869732E5F6C6F6164696E674D65737361676554696D6529293B656C73652073776974636828746869732E5F7374617465297B6361736520303A746869732E5F747269676765724173796E63436F6D7075746174696F6E28292C746869732E5F7365';
wwv_flow_imp.g_varchar2_table(20579) := '636F6E64576169745363686564756C65722E63616E63656C28292C746869732E5F7472696767657253796E63436F6D7075746174696F6E28293B627265616B3B6361736520323A746869732E5F7365636F6E64576169745363686564756C65722E63616E';
wwv_flow_imp.g_varchar2_table(20580) := '63656C28292C746869732E5F7472696767657253796E63436F6D7075746174696F6E28297D7D63616E63656C28297B746869732E5F6669727374576169745363686564756C65722E63616E63656C28292C746869732E5F7365636F6E6457616974536368';
wwv_flow_imp.g_varchar2_table(20581) := '6564756C65722E63616E63656C28292C746869732E5F6C6F6164696E674D6573736167655363686564756C65722E63616E63656C28292C746869732E5F6173796E634974657261626C65262628746869732E5F6173796E634974657261626C652E63616E';
wwv_flow_imp.g_varchar2_table(20582) := '63656C28292C746869732E5F6173796E634974657261626C653D6E756C6C292C746869732E5F726573756C743D5B5D2C746869732E5F736574537461746528302C2131297D7D636C6173732045717B636F6E7374727563746F7228652C742C6E2C69297B';
wwv_flow_imp.g_varchar2_table(20583) := '746869732E7072696F726974793D652C746869732E72616E67653D742C746869732E696E697469616C4D6F757365506F73583D6E2C746869732E696E697469616C4D6F757365506F73593D692C746869732E747970653D317D657175616C732865297B72';
wwv_flow_imp.g_varchar2_table(20584) := '657475726E20313D3D3D652E747970652626746869732E72616E67652E657175616C7352616E676528652E72616E6765297D63616E41646F707456697369626C65486F76657228652C74297B72657475726E20313D3D3D652E747970652626742E6C696E';
wwv_flow_imp.g_varchar2_table(20585) := '654E756D6265723D3D3D746869732E72616E67652E73746172744C696E654E756D6265727D7D636C617373204C717B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E7072696F726974793D652C746869732E6F776E65723D74';
wwv_flow_imp.g_varchar2_table(20586) := '2C746869732E72616E67653D6E2C746869732E696E697469616C4D6F757365506F73583D692C746869732E696E697469616C4D6F757365506F73593D6F2C746869732E737570706F7274734D61726B6572486F7665723D732C746869732E747970653D32';
wwv_flow_imp.g_varchar2_table(20587) := '7D657175616C732865297B72657475726E20323D3D3D652E747970652626746869732E6F776E65723D3D3D652E6F776E65727D63616E41646F707456697369626C65486F76657228652C74297B72657475726E20323D3D3D652E74797065262674686973';
wwv_flow_imp.g_varchar2_table(20588) := '2E6F776E65723D3D3D652E6F776E65727D7D636F6E73742044713D6E657720636C6173737B636F6E7374727563746F7228297B746869732E5F7061727469636970616E74733D5B5D7D72656769737465722865297B746869732E5F706172746963697061';
wwv_flow_imp.g_varchar2_table(20589) := '6E74732E707573682865297D676574416C6C28297B72657475726E20746869732E5F7061727469636970616E74737D7D3B7661722054713D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D';
wwv_flow_imp.g_varchar2_table(20590) := '7D3B636F6E73742049713D70632822686F7665725365727669636522293B6C6574204D713D636C61737320657874656E6473206C747B6765742064656C617928297B72657475726E20746869732E6973496E7374616E746C79486F766572696E6728293F';
wwv_flow_imp.g_varchar2_table(20591) := '303A746869732E5F64656C61797D636F6E7374727563746F7228652C742C6E3D7B7D2C692C6F297B737570657228292C746869732E706C6163656D656E743D652C746869732E696E7374616E74486F7665723D742C746869732E6F766572726964654F70';
wwv_flow_imp.g_varchar2_table(20592) := '74696F6E733D6E2C746869732E636F6E66696775726174696F6E536572766963653D692C746869732E686F766572536572766963653D6F2C746869732E6C617374486F7665724869646554696D653D302C746869732E74696D654C696D69743D3230302C';
wwv_flow_imp.g_varchar2_table(20593) := '746869732E686F766572446973706F7361626C65733D746869732E5F7265676973746572286E6577206174292C746869732E5F64656C61793D746869732E636F6E66696775726174696F6E536572766963652E67657456616C75652822776F726B62656E';
wwv_flow_imp.g_varchar2_table(20594) := '63682E686F7665722E64656C617922292C746869732E5F726567697374657228746869732E636F6E66696775726174696F6E536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E';
wwv_flow_imp.g_varchar2_table(20595) := '66696775726174696F6E2822776F726B62656E63682E686F7665722E64656C61792229262628746869732E5F64656C61793D746869732E636F6E66696775726174696F6E536572766963652E67657456616C75652822776F726B62656E63682E686F7665';
wwv_flow_imp.g_varchar2_table(20596) := '722E64656C61792229297D2929297D73686F77486F76657228652C74297B636F6E7374206E3D2266756E6374696F6E223D3D747970656F6620746869732E6F766572726964654F7074696F6E733F746869732E6F766572726964654F7074696F6E732865';
wwv_flow_imp.g_varchar2_table(20597) := '2C74293A746869732E6F766572726964654F7074696F6E733B746869732E686F766572446973706F7361626C65732E636C65617228293B636F6E737420693D652E74617267657420696E7374616E63656F662048544D4C456C656D656E743F5B652E7461';
wwv_flow_imp.g_varchar2_table(20598) := '726765745D3A652E7461726765742E746172676574456C656D656E74733B666F7228636F6E73742065206F66206929746869732E686F766572446973706F7361626C65732E61646428797328652C226B6579646F776E222C28653D3E7B652E657175616C';
wwv_flow_imp.g_varchar2_table(20599) := '732839292626746869732E686F766572536572766963652E68696465486F76657228297D2929293B636F6E7374206F3D652E636F6E74656E7420696E7374616E63656F662048544D4C456C656D656E743F766F696420303A652E636F6E74656E742E746F';
wwv_flow_imp.g_varchar2_table(20600) := '537472696E6728293B72657475726E20746869732E686F766572536572766963652E73686F77486F766572287B2E2E2E652C2E2E2E6E2C70657273697374656E63653A7B686964654F6E4B6579446F776E3A21302C2E2E2E6E2E70657273697374656E63';
wwv_flow_imp.g_varchar2_table(20601) := '657D2C69643A6F2C617070656172616E63653A7B2E2E2E652E617070656172616E63652C636F6D706163743A21302C736B697046616465496E416E696D6174696F6E3A746869732E6973496E7374616E746C79486F766572696E6728292C2E2E2E6E2E61';
wwv_flow_imp.g_varchar2_table(20602) := '7070656172616E63657D7D2C74297D6973496E7374616E746C79486F766572696E6728297B72657475726E20746869732E696E7374616E74486F7665722626446174652E6E6F7728292D746869732E6C617374486F7665724869646554696D653C746869';
wwv_flow_imp.g_varchar2_table(20603) := '732E74696D654C696D69747D6F6E44696448696465486F76657228297B746869732E686F766572446973706F7361626C65732E636C65617228292C746869732E696E7374616E74486F766572262628746869732E6C617374486F7665724869646554696D';
wwv_flow_imp.g_varchar2_table(20604) := '653D446174652E6E6F772829297D7D3B4D713D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572';
wwv_flow_imp.g_varchar2_table(20605) := '747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F72';
wwv_flow_imp.g_varchar2_table(20606) := '61746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475';
wwv_flow_imp.g_varchar2_table(20607) := '726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B547128332C6670292C547128342C4971295D2C4D71293B636C6173732041717B636F6E7374727563746F7228652C742C6E297B746869732E';
wwv_flow_imp.g_varchar2_table(20608) := '70726F76696465723D652C746869732E686F7665723D742C746869732E6F7264696E616C3D6E7D7D66756E6374696F6E204E7128652C742C6E2C69297B636F6E7374206F3D652E6F7264657265642874292E6D6170282828652C6F293D3E6173796E6320';
wwv_flow_imp.g_varchar2_table(20609) := '66756E6374696F6E28652C742C6E2C692C6F297B636F6E737420733D61776169742050726F6D6973652E7265736F6C766528652E70726F76696465486F766572286E2C692C6F29292E6361746368284565293B69662873262666756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(20610) := '7B636F6E737420743D766F69642030213D3D652E72616E67652C6E3D766F69642030213D3D652E636F6E74656E74732626652E636F6E74656E74732626652E636F6E74656E74732E6C656E6774683E303B72657475726E207426266E7D28732929726574';
wwv_flow_imp.g_varchar2_table(20611) := '75726E206E657720417128652C732C74297D28652C6F2C742C6E2C692929293B72657475726E20656E2E66726F6D50726F6D69736573286F292E636F616C6573636528297D516428225F65786563757465486F76657250726F7669646572222C2828652C';
wwv_flow_imp.g_varchar2_table(20612) := '742C6E293D3E66756E6374696F6E28652C742C6E2C69297B72657475726E204E7128652C742C6E2C69292E6D61702828653D3E652E686F76657229292E746F50726F6D69736528297D28652E676574287878292E686F76657250726F76696465722C742C';
wwv_flow_imp.g_varchar2_table(20613) := '6E2C4D742E4E6F6E652929293B7661722050713D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374204F713D62722C52713D54572822686F7665722D696E6372656173652D';
wwv_flow_imp.g_varchar2_table(20614) := '766572626F73697479222C4C6C2E6164642C6228302C2249636F6E20666F7220696E637265617365696E6720686F76657220766572626F736974792E2229292C46713D54572822686F7665722D64656372656173652D766572626F73697479222C4C6C2E';
wwv_flow_imp.g_varchar2_table(20615) := '72656D6F76652C6228302C2249636F6E20666F722064656372656173696E6720686F76657220766572626F736974792E2229293B636C6173732042717B636F6E7374727563746F7228652C742C6E2C692C6F2C733D766F69642030297B746869732E6F77';
wwv_flow_imp.g_varchar2_table(20616) := '6E65723D652C746869732E72616E67653D742C746869732E636F6E74656E74733D6E2C746869732E69734265666F7265436F6E74656E743D692C746869732E6F7264696E616C3D6F2C746869732E736F757263653D737D697356616C6964466F72486F76';
wwv_flow_imp.g_varchar2_table(20617) := '6572416E63686F722865297B72657475726E20313D3D3D652E747970652626746869732E72616E67652E7374617274436F6C756D6E3C3D652E72616E67652E7374617274436F6C756D6E2626746869732E72616E67652E656E64436F6C756D6E3E3D652E';
wwv_flow_imp.g_varchar2_table(20618) := '72616E67652E656E64436F6C756D6E7D7D636C6173732056717B636F6E7374727563746F7228652C742C6E297B746869732E686F7665723D652C746869732E686F76657250726F76696465723D742C746869732E686F766572506F736974696F6E3D6E7D';
wwv_flow_imp.g_varchar2_table(20619) := '737570706F727473566572626F73697479416374696F6E2865297B76617220742C6E3B7377697463682865297B63617365205F772E496E6372656173653A72657475726E206E756C6C213D3D28743D746869732E686F7665722E63616E496E6372656173';
wwv_flow_imp.g_varchar2_table(20620) := '65566572626F73697479292626766F69642030213D3D742626743B63617365205F772E44656372656173653A72657475726E206E756C6C213D3D286E3D746869732E686F7665722E63616E4465637265617365566572626F73697479292626766F696420';
wwv_flow_imp.g_varchar2_table(20621) := '30213D3D6E26266E7D7D7D6C6574207A713D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E5F656469746F723D652C746869732E5F6C616E6775616765536572766963653D742C746869732E5F6F70656E';
wwv_flow_imp.g_varchar2_table(20622) := '6572536572766963653D6E2C746869732E5F636F6E66696775726174696F6E536572766963653D692C746869732E5F6C616E67756167654665617475726573536572766963653D6F2C746869732E5F6B657962696E64696E67536572766963653D732C74';
wwv_flow_imp.g_varchar2_table(20623) := '6869732E5F686F766572536572766963653D722C746869732E686F7665724F7264696E616C3D337D6372656174654C6F6164696E674D6573736167652865297B72657475726E206E657720427128746869732C652E72616E67652C5B286E6577206F6329';
wwv_flow_imp.g_varchar2_table(20624) := '2E617070656E6454657874286228302C224C6F6164696E672E2E2E2229295D2C21312C326533297D636F6D7075746553796E6328652C74297B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C31213D3D652E7479706529726574';
wwv_flow_imp.g_varchar2_table(20625) := '75726E5B5D3B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292C693D652E72616E67652E73746172744C696E654E756D6265722C6F3D6E2E6765744C696E654D6178436F6C756D6E2869292C733D5B5D3B6C657420723D31';
wwv_flow_imp.g_varchar2_table(20626) := '65333B636F6E737420613D6E2E6765744C696E654C656E6774682869292C6C3D6E2E6765744C616E677561676549644174506F736974696F6E28652E72616E67652E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D';
wwv_flow_imp.g_varchar2_table(20627) := '6E292C633D746869732E5F656469746F722E6765744F7074696F6E28313137292C643D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E6D6178546F6B656E697A6174696F6E4C696E654C65';
wwv_flow_imp.g_varchar2_table(20628) := '6E677468222C7B6F766572726964654964656E7469666965723A6C7D293B6C657420683D21313B633E3D302626613E632626652E72616E67652E7374617274436F6C756D6E3E3D63262628683D21302C732E70757368286E657720427128746869732C65';
wwv_flow_imp.g_varchar2_table(20629) := '2E72616E67652C5B7B76616C75653A6228302C2252656E646572696E672070617573656420666F72206C6F6E67206C696E6520666F7220706572666F726D616E636520726561736F6E732E20546869732063616E20626520636F6E666967757265642076';
wwv_flow_imp.g_varchar2_table(20630) := '69612060656469746F722E73746F7052656E646572696E674C696E654166746572602E22297D5D2C21312C722B2B2929292C21682626226E756D626572223D3D747970656F6620642626613E3D642626732E70757368286E657720427128746869732C65';
wwv_flow_imp.g_varchar2_table(20631) := '2E72616E67652C5B7B76616C75653A6228302C22546F6B656E697A6174696F6E20697320736B697070656420666F72206C6F6E67206C696E657320666F7220706572666F726D616E636520726561736F6E732E20546869732063616E20626520636F6E66';
wwv_flow_imp.g_varchar2_table(20632) := '696775726564207669612060656469746F722E6D6178546F6B656E697A6174696F6E4C696E654C656E677468602E22297D5D2C21312C722B2B29293B6C657420753D21313B666F7228636F6E7374206E206F662074297B636F6E737420743D6E2E72616E';
wwv_flow_imp.g_varchar2_table(20633) := '67652E73746172744C696E654E756D6265723D3D3D693F6E2E72616E67652E7374617274436F6C756D6E3A312C613D6E2E72616E67652E656E644C696E654E756D6265723D3D3D693F6E2E72616E67652E656E64436F6C756D6E3A6F2C6C3D6E2E6F7074';
wwv_flow_imp.g_varchar2_table(20634) := '696F6E732E686F7665724D6573736167653B696628216C7C7C7363286C2929636F6E74696E75653B6E2E6F7074696F6E732E6265666F7265436F6E74656E74436C6173734E616D65262628753D2130293B636F6E737420633D6E657720726828652E7261';
wwv_flow_imp.g_varchar2_table(20635) := '6E67652E73746172744C696E654E756D6265722C742C652E72616E67652E73746172744C696E654E756D6265722C61293B732E70757368286E657720427128746869732C632C5A68286C292C752C722B2B29297D72657475726E20737D636F6D70757465';
wwv_flow_imp.g_varchar2_table(20636) := '4173796E6328652C742C6E297B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C31213D3D652E747970652972657475726E20656E2E454D5054593B636F6E737420693D746869732E5F656469746F722E6765744D6F64656C2829';
wwv_flow_imp.g_varchar2_table(20637) := '2C6F3D746869732E5F6C616E67756167654665617475726573536572766963652E686F76657250726F76696465723B72657475726E206F2E6861732869293F746869732E5F6765744D61726B646F776E486F76657273286F2C692C652C6E293A656E2E45';
wwv_flow_imp.g_varchar2_table(20638) := '4D5054597D5F6765744D61726B646F776E486F7665727328652C742C6E2C69297B636F6E7374206F3D6E2E72616E67652E6765745374617274506F736974696F6E28292C733D4E7128652C742C6F2C69292E66696C7465722828653D3E21736328652E68';
wwv_flow_imp.g_varchar2_table(20639) := '6F7665722E636F6E74656E74732929292E6D61702828653D3E7B636F6E737420743D652E686F7665722E72616E67653F72682E6C69667428652E686F7665722E72616E6765293A6E2E72616E67652C693D6E657720567128652E686F7665722C652E7072';
wwv_flow_imp.g_varchar2_table(20640) := '6F76696465722C6F293B72657475726E206E657720427128746869732C742C652E686F7665722E636F6E74656E74732C21312C652E6F7264696E616C2C69297D29293B72657475726E20737D72656E646572486F766572506172747328652C74297B7265';
wwv_flow_imp.g_varchar2_table(20641) := '7475726E20746869732E5F72656E6465726564486F76657250617274733D6E657720487128742C652E667261676D656E742C746869732E5F656469746F722C746869732E5F6C616E6775616765536572766963652C746869732E5F6F70656E6572536572';
wwv_flow_imp.g_varchar2_table(20642) := '766963652C746869732E5F6B657962696E64696E67536572766963652C746869732E5F686F766572536572766963652C746869732E5F636F6E66696775726174696F6E536572766963652C652E6F6E436F6E74656E74734368616E676564292C74686973';
wwv_flow_imp.g_varchar2_table(20643) := '2E5F72656E6465726564486F76657250617274737D757064617465466F63757365644D61726B646F776E486F76657250617274566572626F736974794C6576656C2865297B76617220743B6E756C6C3D3D3D28743D746869732E5F72656E646572656448';
wwv_flow_imp.g_varchar2_table(20644) := '6F7665725061727473297C7C766F696420303D3D3D747C7C742E757064617465466F6375736564486F76657250617274566572626F736974794C6576656C2865297D7D3B7A713D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267';
wwv_flow_imp.g_varchar2_table(20645) := '756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426';
wwv_flow_imp.g_varchar2_table(20646) := '262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29';
wwv_flow_imp.g_varchar2_table(20647) := '286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B50712831';
wwv_flow_imp.g_varchar2_table(20648) := '2C4C75292C507128322C6445292C507128332C6670292C507128342C7878292C507128352C2445292C507128362C4971295D2C7A71293B636C61737320487120657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72';
wwv_flow_imp.g_varchar2_table(20649) := '2C612C6C297B737570657228292C746869732E5F656469746F723D6E2C746869732E5F6C616E6775616765536572766963653D692C746869732E5F6F70656E6572536572766963653D6F2C746869732E5F6B657962696E64696E67536572766963653D73';
wwv_flow_imp.g_varchar2_table(20650) := '2C746869732E5F686F766572536572766963653D722C746869732E5F636F6E66696775726174696F6E536572766963653D612C746869732E5F6F6E46696E697368656452656E646572696E673D6C2C746869732E5F686F766572466F637573496E666F3D';
wwv_flow_imp.g_varchar2_table(20651) := '7B686F76657250617274496E6465783A2D312C666F63757352656D61696E733A21317D2C746869732E5F72656E6465726564486F76657250617274733D746869732E5F72656E646572486F766572506172747328652C742C746869732E5F6F6E46696E69';
wwv_flow_imp.g_varchar2_table(20652) := '7368656452656E646572696E67292C746869732E5F7265676973746572287274282828293D3E7B746869732E5F72656E6465726564486F76657250617274732E666F72456163682828653D3E7B652E646973706F7361626C65732E646973706F73652829';
wwv_flow_imp.g_varchar2_table(20653) := '7D29297D2929297D5F72656E646572486F766572506172747328652C742C6E297B72657475726E20652E736F72742865752828653D3E652E6F7264696E616C292C747529292C652E6D6170282828652C69293D3E7B636F6E7374206F3D746869732E5F72';
wwv_flow_imp.g_varchar2_table(20654) := '656E646572486F7665725061727428692C652E636F6E74656E74732C652E736F757263652C6E293B72657475726E20742E617070656E644368696C64286F2E72656E64657265644D61726B646F776E292C6F7D29297D5F72656E646572486F7665725061';
wwv_flow_imp.g_varchar2_table(20655) := '727428652C742C6E2C69297B636F6E73747B72656E64657265644D61726B646F776E3A6F2C646973706F7361626C65733A737D3D746869732E5F72656E6465724D61726B646F776E436F6E74656E7428742C69293B696628216E2972657475726E7B7265';
wwv_flow_imp.g_varchar2_table(20656) := '6E64657265644D61726B646F776E3A6F2C646973706F7361626C65733A737D3B636F6E737420723D6E2E737570706F727473566572626F73697479416374696F6E285F772E496E637265617365292C613D6E2E737570706F727473566572626F73697479';
wwv_flow_imp.g_varchar2_table(20657) := '416374696F6E285F772E4465637265617365293B6966282172262621612972657475726E7B72656E64657265644D61726B646F776E3A6F2C646973706F7361626C65733A732C686F766572536F757263653A6E7D3B636F6E7374206C3D4F712822646976';
wwv_flow_imp.g_varchar2_table(20658) := '2E766572626F736974792D616374696F6E7322293B6F2E70726570656E64286C292C732E61646428746869732E5F72656E646572486F766572457870616E73696F6E416374696F6E286C2C5F772E496E6372656173652C7229292C732E61646428746869';
wwv_flow_imp.g_varchar2_table(20659) := '732E5F72656E646572486F766572457870616E73696F6E416374696F6E286C2C5F772E44656372656173652C6129293B636F6E737420633D732E616464286872286F29293B72657475726E20732E61646428632E6F6E446964466F637573282828293D3E';
wwv_flow_imp.g_varchar2_table(20660) := '7B746869732E5F686F766572466F637573496E666F3D7B686F76657250617274496E6465783A652C666F63757352656D61696E733A21307D7D2929292C732E61646428632E6F6E446964426C7572282828293D3E7B76617220653B286E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(20661) := '653D746869732E5F686F766572466F637573496E666F297C7C766F696420303D3D3D653F766F696420303A652E666F63757352656D61696E7329262628746869732E5F686F766572466F637573496E666F2E666F63757352656D61696E733D2131297D29';
wwv_flow_imp.g_varchar2_table(20662) := '29292C7B72656E64657265644D61726B646F776E3A6F2C646973706F7361626C65733A732C686F766572536F757263653A6E7D7D5F72656E6465724D61726B646F776E436F6E74656E7428652C74297B636F6E7374206E3D4F7128226469762E686F7665';
wwv_flow_imp.g_varchar2_table(20663) := '722D726F7722293B6E2E746162496E6465783D303B636F6E737420693D4F7128226469762E686F7665722D726F772D636F6E74656E747322293B6E2E617070656E644368696C642869293B636F6E7374206F3D6E65772061743B72657475726E206F2E61';
wwv_flow_imp.g_varchar2_table(20664) := '646428577128746869732E5F656469746F722C692C652C746869732E5F6C616E6775616765536572766963652C746869732E5F6F70656E6572536572766963652C7429292C7B72656E64657265644D61726B646F776E3A6E2C646973706F7361626C6573';
wwv_flow_imp.g_varchar2_table(20665) := '3A6F7D7D5F72656E646572486F766572457870616E73696F6E416374696F6E28652C742C6E297B636F6E737420693D6E65772061742C6F3D743D3D3D5F772E496E6372656173652C733D757228652C4F7128546C2E617343535353656C6563746F72286F';
wwv_flow_imp.g_varchar2_table(20666) := '3F52713A46712929293B732E746162496E6465783D303B636F6E737420723D6E6577204D7128226D6F757365222C21312C7B7461726765743A652C706F736974696F6E3A7B686F766572506F736974696F6E3A307D7D2C746869732E5F636F6E66696775';
wwv_flow_imp.g_varchar2_table(20667) := '726174696F6E536572766963652C746869732E5F686F76657253657276696365293B6966286F297B636F6E737420653D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E67286E6A293B692E6164642874';
wwv_flow_imp.g_varchar2_table(20668) := '6869732E5F686F766572536572766963652E7365747570557064617461626C65486F76657228722C732C653F6228302C22496E63726561736520566572626F7369747920287B307D29222C652E6765744C6162656C2829293A6228302C22496E63726561';
wwv_flow_imp.g_varchar2_table(20669) := '736520566572626F73697479222929297D656C73657B636F6E737420653D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728696A293B692E61646428746869732E5F686F766572536572766963652E';
wwv_flow_imp.g_varchar2_table(20670) := '7365747570557064617461626C65486F76657228722C732C653F6228302C22446563726561736520566572626F7369747920287B307D29222C652E6765744C6162656C2829293A6228302C22446563726561736520566572626F73697479222929297D69';
wwv_flow_imp.g_varchar2_table(20671) := '6628216E2972657475726E20732E636C6173734C6973742E616464282264697361626C656422292C693B732E636C6173734C6973742E6164642822656E61626C656422293B636F6E737420613D28293D3E746869732E757064617465466F637573656448';
wwv_flow_imp.g_varchar2_table(20672) := '6F76657250617274566572626F736974794C6576656C2874293B72657475726E20692E616464286E657720627128732C6129292C692E616464286E6577205F7128732C612C5B332C31305D29292C697D6173796E6320757064617465466F637573656448';
wwv_flow_imp.g_varchar2_table(20673) := '6F76657250617274566572626F736974794C6576656C2865297B76617220743B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28293B696628216E2972657475726E3B636F6E737420693D746869732E5F686F766572466F6375';
wwv_flow_imp.g_varchar2_table(20674) := '73496E666F2E686F76657250617274496E6465782C6F3D746869732E5F67657452656E6465726564486F766572506172744174496E6465782869293B696628216F7C7C21286E756C6C3D3D3D28743D6F2E686F766572536F75726365297C7C766F696420';
wwv_flow_imp.g_varchar2_table(20675) := '303D3D3D743F766F696420303A742E737570706F727473566572626F73697479416374696F6E286529292972657475726E3B636F6E737420733D6F2E686F766572536F757263652E686F766572506F736974696F6E2C723D6F2E686F766572536F757263';
wwv_flow_imp.g_varchar2_table(20676) := '652E686F76657250726F76696465722C613D7B766572626F73697479526571756573743A7B616374696F6E3A652C70726576696F7573486F7665723A6F2E686F766572536F757263652E686F7665727D7D3B6C6574206C3B7472797B6C3D617761697420';
wwv_flow_imp.g_varchar2_table(20677) := '50726F6D6973652E7265736F6C766528722E70726F76696465486F766572286E2C732C4D742E4E6F6E652C6129297D63617463682865297B45652865297D696628216C2972657475726E3B636F6E737420633D6E6577205671286C2C722C73292C643D74';
wwv_flow_imp.g_varchar2_table(20678) := '6869732E5F72656E646572486F7665725061727428692C6C2E636F6E74656E74732C632C746869732E5F6F6E46696E697368656452656E646572696E67293B746869732E5F7265706C61636552656E6465726564486F766572506172744174496E646578';
wwv_flow_imp.g_varchar2_table(20679) := '28692C64292C746869732E5F666F6375734F6E486F7665725061727457697468496E6465782869292C746869732E5F6F6E46696E697368656452656E646572696E6728297D5F7265706C61636552656E6465726564486F766572506172744174496E6465';
wwv_flow_imp.g_varchar2_table(20680) := '7828652C74297B696628653E3D746869732E5F72656E646572486F76657250617274732E6C656E6774687C7C653C302972657475726E3B636F6E7374206E3D746869732E5F72656E6465726564486F76657250617274735B655D3B6E2E72656E64657265';
wwv_flow_imp.g_varchar2_table(20681) := '644D61726B646F776E2E7265706C6163655769746828742E72656E64657265644D61726B646F776E292C6E2E646973706F7361626C65732E646973706F736528292C746869732E5F72656E6465726564486F76657250617274735B655D3D747D5F666F63';
wwv_flow_imp.g_varchar2_table(20682) := '75734F6E486F7665725061727457697468496E6465782865297B746869732E5F72656E6465726564486F76657250617274735B655D2E72656E64657265644D61726B646F776E2E666F63757328292C746869732E5F686F766572466F637573496E666F2E';
wwv_flow_imp.g_varchar2_table(20683) := '666F63757352656D61696E733D21307D5F67657452656E6465726564486F766572506172744174496E6465782865297B72657475726E20746869732E5F72656E6465726564486F76657250617274735B655D7D7D66756E6374696F6E20577128652C742C';
wwv_flow_imp.g_varchar2_table(20684) := '6E2C692C6F2C73297B636F6E737420723D6E65772061743B666F7228636F6E73742061206F66206E297B696628736328612929636F6E74696E75653B636F6E7374206E3D4F7128226469762E6D61726B646F776E2D686F76657222292C6C3D7572286E2C';
wwv_flow_imp.g_varchar2_table(20685) := '4F7128226469762E686F7665722D636F6E74656E74732229292C633D722E616464286E6577207045287B656469746F723A657D2C692C6F29293B722E61646428632E6F6E44696452656E6465724173796E63282828293D3E7B6C2E636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(20686) := '3D22686F7665722D636F6E74656E747320636F64652D686F7665722D636F6E74656E7473222C7328297D2929293B636F6E737420643D722E61646428632E72656E646572286129293B6C2E617070656E644368696C6428642E656C656D656E74292C742E';
wwv_flow_imp.g_varchar2_table(20687) := '617070656E644368696C64286E297D72657475726E20727D636C617373206A717B73746174696320696E7365727428652C74297B72657475726E7B72616E67653A6E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E65';
wwv_flow_imp.g_varchar2_table(20688) := '4E756D6265722C652E636F6C756D6E292C746578743A742C666F7263654D6F76654D61726B6572733A21307D7D7374617469632064656C6574652865297B72657475726E7B72616E67653A652C746578743A6E756C6C7D7D737461746963207265706C61';
wwv_flow_imp.g_varchar2_table(20689) := '636528652C74297B72657475726E7B72616E67653A652C746578743A747D7D737461746963207265706C6163654D6F766528652C74297B72657475726E7B72616E67653A652C746578743A742C666F7263654D6F76654D61726B6572733A21307D7D7D66';
wwv_flow_imp.g_varchar2_table(20690) := '756E6374696F6E20717128652C74297B72657475726E2121655B745D7D636C6173732024717B636F6E7374727563746F7228652C74297B746869732E7461726765743D652E7461726765742C746869732E69734C656674436C69636B3D652E6576656E74';
wwv_flow_imp.g_varchar2_table(20691) := '2E6C656674427574746F6E2C746869732E69734D6964646C65436C69636B3D652E6576656E742E6D6964646C65427574746F6E2C746869732E69735269676874436C69636B3D652E6576656E742E7269676874427574746F6E2C746869732E6861735472';
wwv_flow_imp.g_varchar2_table(20692) := '69676765724D6F6469666965723D717128652E6576656E742C742E747269676765724D6F646966696572292C746869732E686173536964654279536964654D6F6469666965723D717128652E6576656E742C742E74726967676572536964654279536964';
wwv_flow_imp.g_varchar2_table(20693) := '654D6F646966696572292C746869732E69734E6F6E654F7253696E676C654D6F757365446F776E3D652E6576656E742E64657461696C3C3D317D7D636C6173732055717B636F6E7374727563746F7228652C74297B746869732E6B6579436F6465497354';
wwv_flow_imp.g_varchar2_table(20694) := '7269676765724B65793D652E6B6579436F64653D3D3D742E747269676765724B65792C746869732E6B6579436F64654973536964654279536964654B65793D652E6B6579436F64653D3D3D742E74726967676572536964654279536964654B65792C7468';
wwv_flow_imp.g_varchar2_table(20695) := '69732E686173547269676765724D6F6469666965723D717128652C742E747269676765724D6F646966696572297D7D636C617373204B717B636F6E7374727563746F7228652C742C6E2C69297B746869732E747269676765724B65793D652C746869732E';
wwv_flow_imp.g_varchar2_table(20696) := '747269676765724D6F6469666965723D742C746869732E74726967676572536964654279536964654B65793D6E2C746869732E74726967676572536964654279536964654D6F6469666965723D697D657175616C732865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(20697) := '2E747269676765724B65793D3D3D652E747269676765724B65792626746869732E747269676765724D6F6469666965723D3D3D652E747269676765724D6F6469666965722626746869732E74726967676572536964654279536964654B65793D3D3D652E';
wwv_flow_imp.g_varchar2_table(20698) := '74726967676572536964654279536964654B65792626746869732E74726967676572536964654279536964654D6F6469666965723D3D3D652E74726967676572536964654279536964654D6F6469666965727D7D66756E6374696F6E2047712865297B72';
wwv_flow_imp.g_varchar2_table(20699) := '657475726E22616C744B6579223D3D3D653F713F6E6577204B712835372C226D6574614B6579222C362C22616C744B657922293A6E6577204B7128352C226374726C4B6579222C362C22616C744B657922293A713F6E6577204B7128362C22616C744B65';
wwv_flow_imp.g_varchar2_table(20700) := '79222C35372C226D6574614B657922293A6E6577204B7128362C22616C744B6579222C352C226374726C4B657922297D636C61737320517120657874656E6473206C747B636F6E7374727563746F7228652C74297B766172206E3B737570657228292C74';
wwv_flow_imp.g_varchar2_table(20701) := '6869732E5F6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E3D746869732E5F6F6E4D';
wwv_flow_imp.g_varchar2_table(20702) := '6F7573654D6F76654F7252656C6576616E744B6579446F776E2E6576656E742C746869732E5F6F6E457865637574653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E457865637574653D746869732E5F6F6E457865637574';
wwv_flow_imp.g_varchar2_table(20703) := '652E6576656E742C746869732E5F6F6E43616E63656C3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E43616E63656C3D746869732E5F6F6E43616E63656C2E6576656E742C746869732E5F656469746F723D652C74686973';
wwv_flow_imp.g_varchar2_table(20704) := '2E5F657874726163744C696E654E756D62657246726F6D4D6F7573654576656E743D6E756C6C213D3D286E3D6E756C6C3D3D743F766F696420303A742E657874726163744C696E654E756D62657246726F6D4D6F7573654576656E74292626766F696420';
wwv_flow_imp.g_varchar2_table(20705) := '30213D3D6E3F6E3A653D3E652E7461726765742E706F736974696F6E3F652E7461726765742E706F736974696F6E2E6C696E654E756D6265723A302C746869732E5F6F7074733D477128746869732E5F656469746F722E6765744F7074696F6E28373829';
wwv_flow_imp.g_varchar2_table(20706) := '292C746869732E5F6C6173744D6F7573654D6F76654576656E743D6E756C6C2C746869732E5F686173547269676765724B65794F6E4D6F757365446F776E3D21312C746869732E5F6C696E654E756D6265724F6E4D6F757365446F776E3D302C74686973';
wwv_flow_imp.g_varchar2_table(20707) := '2E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B696628652E6861734368616E67656428373829297B636F6E737420653D477128746869732E5F656469746F722E67';
wwv_flow_imp.g_varchar2_table(20708) := '65744F7074696F6E28373829293B696628746869732E5F6F7074732E657175616C732865292972657475726E3B746869732E5F6F7074733D652C746869732E5F6C6173744D6F7573654D6F76654576656E743D6E756C6C2C746869732E5F686173547269';
wwv_flow_imp.g_varchar2_table(20709) := '676765724B65794F6E4D6F757365446F776E3D21312C746869732E5F6C696E654E756D6265724F6E4D6F757365446F776E3D302C746869732E5F6F6E43616E63656C2E6669726528297D7D2929292C746869732E5F726567697374657228746869732E5F';
wwv_flow_imp.g_varchar2_table(20710) := '656469746F722E6F6E4D6F7573654D6F76652828653D3E746869732E5F6F6E456469746F724D6F7573654D6F7665286E657720247128652C746869732E5F6F70747329292929292C746869732E5F726567697374657228746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(20711) := '6F6E4D6F757365446F776E2828653D3E746869732E5F6F6E456469746F724D6F757365446F776E286E657720247128652C746869732E5F6F70747329292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4D6F757365';
wwv_flow_imp.g_varchar2_table(20712) := '55702828653D3E746869732E5F6F6E456469746F724D6F7573655570286E657720247128652C746869732E5F6F70747329292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4B6579446F776E2828653D3E74686973';
wwv_flow_imp.g_varchar2_table(20713) := '2E5F6F6E456469746F724B6579446F776E286E657720557128652C746869732E5F6F70747329292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4B657955702828653D3E746869732E5F6F6E456469746F724B6579';
wwv_flow_imp.g_varchar2_table(20714) := '5570286E657720557128652C746869732E5F6F70747329292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4D6F75736544726167282828293D3E746869732E5F726573657448616E646C657228292929292C746869';
wwv_flow_imp.g_varchar2_table(20715) := '732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E2828653D3E746869732E5F6F6E4469644368616E6765437572736F7253656C656374696F6E2865292929292C746869732E';
wwv_flow_imp.g_varchar2_table(20716) := '5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C2828653D3E746869732E5F726573657448616E646C657228292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469';
wwv_flow_imp.g_varchar2_table(20717) := '644368616E67654D6F64656C436F6E74656E74282828293D3E746869732E5F726573657448616E646C657228292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469645363726F6C6C4368616E67652828653D3E7B';
wwv_flow_imp.g_varchar2_table(20718) := '28652E7363726F6C6C546F704368616E6765647C7C652E7363726F6C6C4C6566744368616E676564292626746869732E5F726573657448616E646C657228297D2929297D5F6F6E4469644368616E6765437572736F7253656C656374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(20719) := '2E73656C656374696F6E2626652E73656C656374696F6E2E7374617274436F6C756D6E213D3D652E73656C656374696F6E2E656E64436F6C756D6E2626746869732E5F726573657448616E646C657228297D5F6F6E456469746F724D6F7573654D6F7665';
wwv_flow_imp.g_varchar2_table(20720) := '2865297B746869732E5F6C6173744D6F7573654D6F76654576656E743D652C746869732E5F6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E2E66697265285B652C6E756C6C5D297D5F6F6E456469746F724D6F757365446F776E28';
wwv_flow_imp.g_varchar2_table(20721) := '65297B746869732E5F686173547269676765724B65794F6E4D6F757365446F776E3D652E686173547269676765724D6F6469666965722C746869732E5F6C696E654E756D6265724F6E4D6F757365446F776E3D746869732E5F657874726163744C696E65';
wwv_flow_imp.g_varchar2_table(20722) := '4E756D62657246726F6D4D6F7573654576656E742865297D5F6F6E456469746F724D6F75736555702865297B636F6E737420743D746869732E5F657874726163744C696E654E756D62657246726F6D4D6F7573654576656E742865293B746869732E5F68';
wwv_flow_imp.g_varchar2_table(20723) := '6173547269676765724B65794F6E4D6F757365446F776E2626746869732E5F6C696E654E756D6265724F6E4D6F757365446F776E2626746869732E5F6C696E654E756D6265724F6E4D6F757365446F776E3D3D3D742626746869732E5F6F6E4578656375';
wwv_flow_imp.g_varchar2_table(20724) := '74652E666972652865297D5F6F6E456469746F724B6579446F776E2865297B746869732E5F6C6173744D6F7573654D6F76654576656E74262628652E6B6579436F64654973547269676765724B65797C7C652E6B6579436F646549735369646542795369';
wwv_flow_imp.g_varchar2_table(20725) := '64654B65792626652E686173547269676765724D6F646966696572293F746869732E5F6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E2E66697265285B746869732E5F6C6173744D6F7573654D6F76654576656E742C655D293A65';
wwv_flow_imp.g_varchar2_table(20726) := '2E686173547269676765724D6F6469666965722626746869732E5F6F6E43616E63656C2E6669726528297D5F6F6E456469746F724B657955702865297B652E6B6579436F64654973547269676765724B65792626746869732E5F6F6E43616E63656C2E66';
wwv_flow_imp.g_varchar2_table(20727) := '69726528297D5F726573657448616E646C657228297B746869732E5F6C6173744D6F7573654D6F76654576656E743D6E756C6C2C746869732E5F686173547269676765724B65794F6E4D6F757365446F776E3D21312C746869732E5F6F6E43616E63656C';
wwv_flow_imp.g_varchar2_table(20728) := '2E6669726528297D7D636C6173732059717B636F6E7374727563746F7228652C74297B746869732E72616E67653D652C746869732E646972656374696F6E3D747D7D636C617373205A717B636F6E7374727563746F7228652C742C6E297B746869732E68';
wwv_flow_imp.g_varchar2_table(20729) := '696E743D652C746869732E616E63686F723D742C746869732E70726F76696465723D6E2C746869732E5F69735265736F6C7665643D21317D776974682865297B636F6E737420743D6E6577205A7128746869732E68696E742C652E616E63686F722C7468';
wwv_flow_imp.g_varchar2_table(20730) := '69732E70726F7669646572293B72657475726E20742E5F69735265736F6C7665643D746869732E5F69735265736F6C7665642C742E5F63757272656E745265736F6C76653D746869732E5F63757272656E745265736F6C76652C747D6173796E63207265';
wwv_flow_imp.g_varchar2_table(20731) := '736F6C76652865297B6966282266756E6374696F6E223D3D747970656F6620746869732E70726F76696465722E7265736F6C7665496E6C617948696E74297B696628746869732E5F63757272656E745265736F6C7665297B696628617761697420746869';
wwv_flow_imp.g_varchar2_table(20732) := '732E5F63757272656E745265736F6C76652C652E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B72657475726E20746869732E7265736F6C76652865297D746869732E5F69735265736F6C7665647C7C28746869732E5F63';
wwv_flow_imp.g_varchar2_table(20733) := '757272656E745265736F6C76653D746869732E5F646F5265736F6C76652865292E66696E616C6C79282828293D3E746869732E5F63757272656E745265736F6C76653D766F696420302929292C617761697420746869732E5F63757272656E745265736F';
wwv_flow_imp.g_varchar2_table(20734) := '6C76657D7D6173796E63205F646F5265736F6C76652865297B76617220742C6E2C693B7472797B636F6E7374206F3D61776169742050726F6D6973652E7265736F6C766528746869732E70726F76696465722E7265736F6C7665496E6C617948696E7428';
wwv_flow_imp.g_varchar2_table(20735) := '746869732E68696E742C6529293B746869732E68696E742E746F6F6C7469703D6E756C6C213D3D28743D6E756C6C3D3D6F3F766F696420303A6F2E746F6F6C746970292626766F69642030213D3D743F743A746869732E68696E742E746F6F6C7469702C';
wwv_flow_imp.g_varchar2_table(20736) := '746869732E68696E742E6C6162656C3D6E756C6C213D3D286E3D6E756C6C3D3D6F3F766F696420303A6F2E6C6162656C292626766F69642030213D3D6E3F6E3A746869732E68696E742E6C6162656C2C746869732E68696E742E7465787445646974733D';
wwv_flow_imp.g_varchar2_table(20737) := '6E756C6C213D3D28693D6E756C6C3D3D6F3F766F696420303A6F2E746578744564697473292626766F69642030213D3D693F693A746869732E68696E742E7465787445646974732C746869732E5F69735265736F6C7665643D21307D6361746368286529';
wwv_flow_imp.g_varchar2_table(20738) := '7B45652865292C746869732E5F69735265736F6C7665643D21317D7D7D636C6173732058717B737461746963206173796E632063726561746528652C742C6E2C69297B636F6E7374206F3D5B5D2C733D652E6F7264657265642874292E72657665727365';
wwv_flow_imp.g_varchar2_table(20739) := '28292E6D61702828653D3E6E2E6D617028286173796E63206E3D3E7B7472797B636F6E737420733D617761697420652E70726F76696465496E6C617948696E747328742C6E2C69293B28286E756C6C3D3D733F766F696420303A732E68696E74732E6C65';
wwv_flow_imp.g_varchar2_table(20740) := '6E677468297C7C652E6F6E4469644368616E6765496E6C617948696E74732926266F2E70757368285B6E756C6C213D733F733A58712E5F656D707479496E6C617948696E744C6973742C655D297D63617463682865297B45652865297D7D292929293B69';
wwv_flow_imp.g_varchar2_table(20741) := '662861776169742050726F6D6973652E616C6C28732E666C61742829292C692E697343616E63656C6C6174696F6E5265717565737465647C7C742E6973446973706F7365642829297468726F77206E65772049653B72657475726E206E6577205871286E';
wwv_flow_imp.g_varchar2_table(20742) := '2C6F2C74297D636F6E7374727563746F7228652C742C6E297B746869732E5F646973706F7361626C65733D6E65772061742C746869732E72616E6765733D652C746869732E70726F76696465723D6E6577205365743B636F6E737420693D5B5D3B666F72';
wwv_flow_imp.g_varchar2_table(20743) := '28636F6E73745B652C6F5D6F662074297B746869732E5F646973706F7361626C65732E6164642865292C746869732E70726F76696465722E616464286F293B666F7228636F6E73742074206F6620652E68696E7473297B636F6E737420653D6E2E76616C';
wwv_flow_imp.g_varchar2_table(20744) := '6964617465506F736974696F6E28742E706F736974696F6E293B6C657420733D226265666F7265223B636F6E737420723D58712E5F67657452616E67654174506F736974696F6E286E2C65293B6C657420613B722E6765745374617274506F736974696F';
wwv_flow_imp.g_varchar2_table(20745) := '6E28292E69734265666F72652865293F28613D72682E66726F6D506F736974696F6E7328722E6765745374617274506F736974696F6E28292C65292C733D22616674657222293A28613D72682E66726F6D506F736974696F6E7328652C722E676574456E';
wwv_flow_imp.g_varchar2_table(20746) := '64506F736974696F6E2829292C733D226265666F726522292C692E70757368286E6577205A7128742C6E657720597128612C73292C6F29297D7D746869732E6974656D733D692E736F7274282828652C74293D3E6D632E636F6D7061726528652E68696E';
wwv_flow_imp.g_varchar2_table(20747) := '742E706F736974696F6E2C742E68696E742E706F736974696F6E2929297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528297D737461746963205F67657452616E67654174506F736974696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(20748) := '636F6E7374206E3D742E6C696E654E756D6265722C693D652E676574576F72644174506F736974696F6E2874293B696628692972657475726E206E6577207268286E2C692E7374617274436F6C756D6E2C6E2C692E656E64436F6C756D6E293B652E746F';
wwv_flow_imp.g_varchar2_table(20749) := '6B656E697A6174696F6E2E746F6B656E697A6549664368656170286E293B636F6E7374206F3D652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E73286E292C733D742E636F6C756D6E2D312C723D6F2E66696E64546F6B656E496E6465';
wwv_flow_imp.g_varchar2_table(20750) := '7841744F66667365742873293B6C657420613D6F2E67657453746172744F66667365742872292C6C3D6F2E676574456E644F66667365742872293B72657475726E206C2D613D3D31262628613D3D3D732626723E313F28613D6F2E67657453746172744F';
wwv_flow_imp.g_varchar2_table(20751) := '666673657428722D31292C6C3D6F2E676574456E644F666673657428722D3129293A6C3D3D3D732626723C6F2E676574436F756E7428292D31262628613D6F2E67657453746172744F666673657428722B31292C6C3D6F2E676574456E644F6666736574';
wwv_flow_imp.g_varchar2_table(20752) := '28722B312929292C6E6577207268286E2C612B312C6E2C6C2B31297D7D66756E6374696F6E204A712865297B72657475726E212821657C7C2266756E6374696F6E22213D747970656F6620652E676574456469746F7254797065292626652E6765744564';
wwv_flow_imp.g_varchar2_table(20753) := '69746F725479706528293D3D3D71522E49436F6465456469746F727D66756E6374696F6E2065242865297B72657475726E212821657C7C2266756E6374696F6E22213D747970656F6620652E676574456469746F7254797065292626652E676574456469';
wwv_flow_imp.g_varchar2_table(20754) := '746F725479706528293D3D3D71522E4944696666456469746F727D66756E6374696F6E2074242865297B72657475726E204A712865293F653A65242865293F652E6765744D6F646966696564456469746F7228293A66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(20755) := '75726E2121652626226F626A656374223D3D747970656F66206526262266756E6374696F6E223D3D747970656F6620652E6F6E4469644368616E6765416374697665456469746F727D28652926264A7128652E616374697665436F6465456469746F7229';
wwv_flow_imp.g_varchar2_table(20756) := '3F652E616374697665436F6465456469746F723A6E756C6C7D58712E5F656D707479496E6C617948696E744C6973743D4F626A6563742E667265657A65287B646973706F736528297B7D2C68696E74733A5B5D7D293B766172206E243D66756E6374696F';
wwv_flow_imp.g_varchar2_table(20757) := '6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742069243D636C61737320657874656E6473204C427B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C75';
wwv_flow_imp.g_varchar2_table(20758) := '297B737570657228652C7B2E2E2E692E6765745261774F7074696F6E7328292C6F766572666C6F7757696467657473446F6D4E6F64653A692E6765744F766572666C6F7757696467657473446F6D4E6F646528297D2C6E2C6F2C732C722C612C6C2C632C';
wwv_flow_imp.g_varchar2_table(20759) := '642C682C75292C746869732E5F706172656E74456469746F723D692C746869732E5F6F76657277726974654F7074696F6E733D742C73757065722E7570646174654F7074696F6E7328746869732E5F6F76657277726974654F7074696F6E73292C746869';
wwv_flow_imp.g_varchar2_table(20760) := '732E5F726567697374657228692E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E746869732E5F6F6E506172656E74436F6E66696775726174696F6E4368616E6765642865292929297D676574506172656E74456469746F7228';
wwv_flow_imp.g_varchar2_table(20761) := '297B72657475726E20746869732E5F706172656E74456469746F727D5F6F6E506172656E74436F6E66696775726174696F6E4368616E6765642865297B73757065722E7570646174654F7074696F6E7328746869732E5F706172656E74456469746F722E';
wwv_flow_imp.g_varchar2_table(20762) := '6765745261774F7074696F6E732829292C73757065722E7570646174654F7074696F6E7328746869732E5F6F76657277726974654F7074696F6E73297D7570646174654F7074696F6E732865297B796828746869732E5F6F76657277726974654F707469';
wwv_flow_imp.g_varchar2_table(20763) := '6F6E732C652C2130292C73757065722E7570646174654F7074696F6E7328746869732E5F6F76657277726974654F7074696F6E73297D7D3B69243D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774';
wwv_flow_imp.g_varchar2_table(20764) := '682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D';
wwv_flow_imp.g_varchar2_table(20765) := '3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D2926262872';
wwv_flow_imp.g_varchar2_table(20766) := '3D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6E2428342C7563292C6E2428352C6763';
wwv_flow_imp.g_varchar2_table(20767) := '292C6E2428362C7863292C6E2428372C6364292C6E2428382C5062292C6E2428392C7344292C6E242831302C5953292C6E242831312C6567292C6E242831322C7878295D2C6924293B766172206F243D6E2839373334292C73243D7B7D3B73242E737479';
wwv_flow_imp.g_varchar2_table(20768) := '6C655461675472616E73666F726D3D6A7228292C73242E736574417474726962757465733D567228292C73242E696E736572743D467228292E62696E64286E756C6C2C226865616422292C73242E646F6D4150493D4F7228292C73242E696E7365727453';
wwv_flow_imp.g_varchar2_table(20769) := '74796C65456C656D656E743D487228292C4E722829286F242E412C7324292C6F242E4126266F242E412E6C6F63616C7326266F242E412E6C6F63616C733B7661722072243D6E2832383839292C61243D7B7D3B61242E7374796C655461675472616E7366';
wwv_flow_imp.g_varchar2_table(20770) := '6F726D3D6A7228292C61242E736574417474726962757465733D567228292C61242E696E736572743D467228292E62696E64286E756C6C2C226865616422292C61242E646F6D4150493D4F7228292C61242E696E736572745374796C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(20771) := '3D487228292C4E7228292872242E412C6124292C72242E41262672242E412E6C6F63616C73262672242E412E6C6F63616C733B636F6E7374206C243D6E6577206875286E6577206C7528302C3132322C32303429292C63243D7B73686F774172726F773A';
wwv_flow_imp.g_varchar2_table(20772) := '21302C73686F774672616D653A21302C636C6173734E616D653A22222C6672616D65436F6C6F723A6C242C6172726F77436F6C6F723A6C242C6B656570456469746F7253656C656374696F6E3A21317D3B636C6173732064247B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(20773) := '7228652C742C6E2C692C6F2C732C722C61297B746869732E69643D22222C746869732E646F6D4E6F64653D652C746869732E61667465724C696E654E756D6265723D742C746869732E6166746572436F6C756D6E3D6E2C746869732E686569676874496E';
wwv_flow_imp.g_varchar2_table(20774) := '4C696E65733D692C746869732E73686F77496E48696464656E41726561733D722C746869732E6F7264696E616C3D612C746869732E5F6F6E446F6D4E6F6465546F703D6F2C746869732E5F6F6E436F6D70757465644865696768743D737D6F6E446F6D4E';
wwv_flow_imp.g_varchar2_table(20775) := '6F6465546F702865297B746869732E5F6F6E446F6D4E6F6465546F702865297D6F6E436F6D70757465644865696768742865297B746869732E5F6F6E436F6D70757465644865696768742865297D7D636C6173732068247B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(20776) := '652C74297B746869732E5F69643D652C746869732E5F646F6D4E6F64653D747D676574496428297B72657475726E20746869732E5F69647D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F';
wwv_flow_imp.g_varchar2_table(20777) := '6E28297B72657475726E206E756C6C7D7D636C6173732075247B636F6E7374727563746F722865297B746869732E5F656469746F723D652C746869732E5F72756C654E616D653D75242E5F496447656E657261746F722E6E657874496428292C74686973';
wwv_flow_imp.g_varchar2_table(20778) := '2E5F6465636F726174696F6E733D746869732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E5F636F6C6F723D6E756C6C2C746869732E5F6865696768743D2D317D646973706F736528297B';
wwv_flow_imp.g_varchar2_table(20779) := '746869732E6869646528292C697228746869732E5F72756C654E616D65297D73657420636F6C6F722865297B746869732E5F636F6C6F72213D3D65262628746869732E5F636F6C6F723D652C746869732E5F7570646174655374796C652829297D736574';
wwv_flow_imp.g_varchar2_table(20780) := '206865696768742865297B746869732E5F686569676874213D3D65262628746869732E5F6865696768743D652C746869732E5F7570646174655374796C652829297D5F7570646174655374796C6528297B697228746869732E5F72756C654E616D65292C';
wwv_flow_imp.g_varchar2_table(20781) := '6E7228602E6D6F6E61636F2D656469746F7220247B746869732E5F72756C654E616D657D602C60626F726465722D7374796C653A20736F6C69643B20626F726465722D636F6C6F723A207472616E73706172656E743B20626F726465722D626F74746F6D';
wwv_flow_imp.g_varchar2_table(20782) := '2D636F6C6F723A20247B746869732E5F636F6C6F727D3B20626F726465722D77696474683A20247B746869732E5F6865696768747D70783B20626F74746F6D3A202D247B746869732E5F6865696768747D70782021696D706F7274616E743B206D617267';
wwv_flow_imp.g_varchar2_table(20783) := '696E2D6C6566743A202D247B746869732E5F6865696768747D70783B2060297D73686F772865297B313D3D3D652E636F6C756D6E262628653D7B6C696E654E756D6265723A652E6C696E654E756D6265722C636F6C756D6E3A327D292C746869732E5F64';
wwv_flow_imp.g_varchar2_table(20784) := '65636F726174696F6E732E736574285B7B72616E67653A72682E66726F6D506F736974696F6E732865292C6F7074696F6E733A7B6465736372697074696F6E3A227A6F6E652D7769646765742D6172726F77222C636C6173734E616D653A746869732E5F';
wwv_flow_imp.g_varchar2_table(20785) := '72756C654E616D652C737469636B696E6573733A317D7D5D297D6869646528297B746869732E5F6465636F726174696F6E732E636C65617228297D7D75242E5F496447656E657261746F723D6E6577206B6B28222E6172726F772D6465636F726174696F';
wwv_flow_imp.g_varchar2_table(20786) := '6E2D22293B636C6173732070247B636F6E7374727563746F7228652C743D7B7D297B746869732E5F6172726F773D6E756C6C2C746869732E5F6F7665726C61795769646765743D6E756C6C2C746869732E5F726573697A65536173683D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(20787) := '69732E5F766965775A6F6E653D6E756C6C2C746869732E5F646973706F7361626C65733D6E65772061742C746869732E636F6E7461696E65723D6E756C6C2C746869732E5F697353686F77696E673D21312C746869732E656469746F723D652C74686973';
wwv_flow_imp.g_varchar2_table(20788) := '2E5F706F736974696F6E4D61726B657249643D746869732E656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E6F7074696F6E733D66682874292C796828746869732E6F7074696F6E732C63242C21';
wwv_flow_imp.g_varchar2_table(20789) := '31292C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E6F7074696F6E732E697341636365737369626C657C7C28746869732E646F6D4E6F64652E73657441747472696275746528';
wwv_flow_imp.g_varchar2_table(20790) := '22617269612D68696464656E222C227472756522292C746869732E646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E2229292C746869732E5F646973706F7361626C65732E61646428746869732E65';
wwv_flow_imp.g_varchar2_table(20791) := '6469746F722E6F6E4469644C61796F75744368616E67652828653D3E7B636F6E737420743D746869732E5F67657457696474682865293B746869732E646F6D4E6F64652E7374796C652E77696474683D742B227078222C746869732E646F6D4E6F64652E';
wwv_flow_imp.g_varchar2_table(20792) := '7374796C652E6C6566743D746869732E5F6765744C6566742865292B227078222C746869732E5F6F6E57696474682874297D2929297D646973706F736528297B746869732E5F6F7665726C6179576964676574262628746869732E656469746F722E7265';
wwv_flow_imp.g_varchar2_table(20793) := '6D6F76654F7665726C617957696467657428746869732E5F6F7665726C6179576964676574292C746869732E5F6F7665726C61795769646765743D6E756C6C292C746869732E5F766965775A6F6E652626746869732E656469746F722E6368616E676556';
wwv_flow_imp.g_varchar2_table(20794) := '6965775A6F6E65732828653D3E7B746869732E5F766965775A6F6E652626652E72656D6F76655A6F6E6528746869732E5F766965775A6F6E652E6964292C746869732E5F766965775A6F6E653D6E756C6C7D29292C746869732E5F706F736974696F6E4D';
wwv_flow_imp.g_varchar2_table(20795) := '61726B657249642E636C65617228292C746869732E5F646973706F7361626C65732E646973706F736528297D63726561746528297B746869732E646F6D4E6F64652E636C6173734C6973742E61646428227A6F6E652D77696467657422292C746869732E';
wwv_flow_imp.g_varchar2_table(20796) := '6F7074696F6E732E636C6173734E616D652626746869732E646F6D4E6F64652E636C6173734C6973742E61646428746869732E6F7074696F6E732E636C6173734E616D65292C746869732E636F6E7461696E65723D646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(20797) := '456C656D656E74282264697622292C746869732E636F6E7461696E65722E636C6173734C6973742E61646428227A6F6E652D7769646765742D636F6E7461696E657222292C746869732E646F6D4E6F64652E617070656E644368696C6428746869732E63';
wwv_flow_imp.g_varchar2_table(20798) := '6F6E7461696E6572292C746869732E6F7074696F6E732E73686F774172726F77262628746869732E5F6172726F773D6E657720752428746869732E656469746F72292C746869732E5F646973706F7361626C65732E61646428746869732E5F6172726F77';
wwv_flow_imp.g_varchar2_table(20799) := '29292C746869732E5F66696C6C436F6E7461696E657228746869732E636F6E7461696E6572292C746869732E5F696E69745361736828292C746869732E5F6170706C795374796C657328297D7374796C652865297B652E6672616D65436F6C6F72262628';
wwv_flow_imp.g_varchar2_table(20800) := '746869732E6F7074696F6E732E6672616D65436F6C6F723D652E6672616D65436F6C6F72292C652E6172726F77436F6C6F72262628746869732E6F7074696F6E732E6172726F77436F6C6F723D652E6172726F77436F6C6F72292C746869732E5F617070';
wwv_flow_imp.g_varchar2_table(20801) := '6C795374796C657328297D5F6170706C795374796C657328297B696628746869732E636F6E7461696E65722626746869732E6F7074696F6E732E6672616D65436F6C6F72297B636F6E737420653D746869732E6F7074696F6E732E6672616D65436F6C6F';
wwv_flow_imp.g_varchar2_table(20802) := '722E746F537472696E6728293B746869732E636F6E7461696E65722E7374796C652E626F72646572546F70436F6C6F723D652C746869732E636F6E7461696E65722E7374796C652E626F72646572426F74746F6D436F6C6F723D657D696628746869732E';
wwv_flow_imp.g_varchar2_table(20803) := '5F6172726F772626746869732E6F7074696F6E732E6172726F77436F6C6F72297B636F6E737420653D746869732E6F7074696F6E732E6172726F77436F6C6F722E746F537472696E6728293B746869732E5F6172726F772E636F6C6F723D657D7D5F6765';
wwv_flow_imp.g_varchar2_table(20804) := '7457696474682865297B72657475726E20652E77696474682D652E6D696E696D61702E6D696E696D617057696474682D652E766572746963616C5363726F6C6C62617257696474687D5F6765744C6566742865297B72657475726E20652E6D696E696D61';
wwv_flow_imp.g_varchar2_table(20805) := '702E6D696E696D617057696474683E302626303D3D3D652E6D696E696D61702E6D696E696D61704C6566743F652E6D696E696D61702E6D696E696D617057696474683A307D5F6F6E566965775A6F6E65546F702865297B746869732E646F6D4E6F64652E';
wwv_flow_imp.g_varchar2_table(20806) := '7374796C652E746F703D652B227078227D5F6F6E566965775A6F6E654865696768742865297B76617220743B696628746869732E646F6D4E6F64652E7374796C652E6865696768743D60247B657D7078602C746869732E636F6E7461696E6572297B636F';
wwv_flow_imp.g_varchar2_table(20807) := '6E737420743D652D746869732E5F6465636F726174696E67456C656D656E747348656967687428293B746869732E636F6E7461696E65722E7374796C652E6865696768743D60247B747D7078603B636F6E7374206E3D746869732E656469746F722E6765';
wwv_flow_imp.g_varchar2_table(20808) := '744C61796F7574496E666F28293B746869732E5F646F4C61796F757428742C746869732E5F6765745769647468286E29297D6E756C6C3D3D3D28743D746869732E5F726573697A6553617368297C7C766F696420303D3D3D747C7C742E6C61796F757428';
wwv_flow_imp.g_varchar2_table(20809) := '297D67657420706F736974696F6E28297B636F6E737420653D746869732E5F706F736974696F6E4D61726B657249642E67657452616E67652830293B696628652972657475726E20652E6765745374617274506F736974696F6E28297D73686F7728652C';
wwv_flow_imp.g_varchar2_table(20810) := '74297B636F6E7374206E3D72682E69734952616E67652865293F72682E6C6966742865293A72682E66726F6D506F736974696F6E732865293B746869732E5F697353686F77696E673D21302C746869732E5F73686F77496D706C286E2C74292C74686973';
wwv_flow_imp.g_varchar2_table(20811) := '2E5F697353686F77696E673D21312C746869732E5F706F736974696F6E4D61726B657249642E736574285B7B72616E67653A6E2C6F7074696F6E733A4F432E454D5054597D5D297D6869646528297B76617220653B746869732E5F766965775A6F6E6526';
wwv_flow_imp.g_varchar2_table(20812) := '2628746869732E656469746F722E6368616E6765566965775A6F6E65732828653D3E7B746869732E5F766965775A6F6E652626652E72656D6F76655A6F6E6528746869732E5F766965775A6F6E652E6964297D29292C746869732E5F766965775A6F6E65';
wwv_flow_imp.g_varchar2_table(20813) := '3D6E756C6C292C746869732E5F6F7665726C6179576964676574262628746869732E656469746F722E72656D6F76654F7665726C617957696467657428746869732E5F6F7665726C6179576964676574292C746869732E5F6F7665726C61795769646765';
wwv_flow_imp.g_varchar2_table(20814) := '743D6E756C6C292C6E756C6C3D3D3D28653D746869732E5F6172726F77297C7C766F696420303D3D3D657C7C652E6869646528292C746869732E5F706F736974696F6E4D61726B657249642E636C65617228297D5F6465636F726174696E67456C656D65';
wwv_flow_imp.g_varchar2_table(20815) := '6E747348656967687428297B636F6E737420653D746869732E656469746F722E6765744F7074696F6E283637293B6C657420743D303B72657475726E20746869732E6F7074696F6E732E73686F774172726F77262628742B3D322A4D6174682E726F756E';
wwv_flow_imp.g_varchar2_table(20816) := '6428652F3329292C746869732E6F7074696F6E732E73686F774672616D65262628742B3D322A4D6174682E726F756E6428652F3929292C747D5F73686F77496D706C28652C74297B636F6E7374206E3D652E6765745374617274506F736974696F6E2829';
wwv_flow_imp.g_varchar2_table(20817) := '2C693D746869732E656469746F722E6765744C61796F7574496E666F28292C6F3D746869732E5F67657457696474682869293B746869732E646F6D4E6F64652E7374796C652E77696474683D60247B6F7D7078602C746869732E646F6D4E6F64652E7374';
wwv_flow_imp.g_varchar2_table(20818) := '796C652E6C6566743D746869732E5F6765744C6566742869292B227078223B636F6E737420733D646F63756D656E742E637265617465456C656D656E74282264697622293B732E7374796C652E6F766572666C6F773D2268696464656E223B636F6E7374';
wwv_flow_imp.g_varchar2_table(20819) := '20723D746869732E656469746F722E6765744F7074696F6E283637293B69662821746869732E6F7074696F6E732E616C6C6F77556E6C696D69746564486569676874297B636F6E737420653D4D6174682E6D61782831322C746869732E656469746F722E';
wwv_flow_imp.g_varchar2_table(20820) := '6765744C61796F7574496E666F28292E6865696768742F722A2E38293B743D4D6174682E6D696E28742C65297D6C657420613D302C6C3D303B696628746869732E5F6172726F772626746869732E6F7074696F6E732E73686F774172726F77262628613D';
wwv_flow_imp.g_varchar2_table(20821) := '4D6174682E726F756E6428722F33292C746869732E5F6172726F772E6865696768743D612C746869732E5F6172726F772E73686F77286E29292C746869732E6F7074696F6E732E73686F774672616D652626286C3D4D6174682E726F756E6428722F3929';
wwv_flow_imp.g_varchar2_table(20822) := '292C746869732E656469746F722E6368616E6765566965775A6F6E65732828653D3E7B746869732E5F766965775A6F6E652626652E72656D6F76655A6F6E6528746869732E5F766965775A6F6E652E6964292C746869732E5F6F7665726C617957696467';
wwv_flow_imp.g_varchar2_table(20823) := '6574262628746869732E656469746F722E72656D6F76654F7665726C617957696467657428746869732E5F6F7665726C6179576964676574292C746869732E5F6F7665726C61795769646765743D6E756C6C292C746869732E646F6D4E6F64652E737479';
wwv_flow_imp.g_varchar2_table(20824) := '6C652E746F703D222D313030307078222C746869732E5F766965775A6F6E653D6E657720642428732C6E2E6C696E654E756D6265722C6E2E636F6C756D6E2C742C28653D3E746869732E5F6F6E566965775A6F6E65546F70286529292C28653D3E746869';
wwv_flow_imp.g_varchar2_table(20825) := '732E5F6F6E566965775A6F6E65486569676874286529292C746869732E6F7074696F6E732E73686F77496E48696464656E41726561732C746869732E6F7074696F6E732E6F7264696E616C292C746869732E5F766965775A6F6E652E69643D652E616464';
wwv_flow_imp.g_varchar2_table(20826) := '5A6F6E6528746869732E5F766965775A6F6E65292C746869732E5F6F7665726C61795769646765743D6E6577206824282276732E656469746F722E636F6E747269622E7A6F6E65576964676574222B746869732E5F766965775A6F6E652E69642C746869';
wwv_flow_imp.g_varchar2_table(20827) := '732E646F6D4E6F6465292C746869732E656469746F722E6164644F7665726C617957696467657428746869732E5F6F7665726C6179576964676574297D29292C746869732E636F6E7461696E65722626746869732E6F7074696F6E732E73686F77467261';
wwv_flow_imp.g_varchar2_table(20828) := '6D65297B636F6E737420653D746869732E6F7074696F6E732E6672616D6557696474683F746869732E6F7074696F6E732E6672616D6557696474683A6C3B746869732E636F6E7461696E65722E7374796C652E626F72646572546F7057696474683D652B';
wwv_flow_imp.g_varchar2_table(20829) := '227078222C746869732E636F6E7461696E65722E7374796C652E626F72646572426F74746F6D57696474683D652B227078227D636F6E737420633D742A722D746869732E5F6465636F726174696E67456C656D656E747348656967687428293B74686973';
wwv_flow_imp.g_varchar2_table(20830) := '2E636F6E7461696E6572262628746869732E636F6E7461696E65722E7374796C652E746F703D612B227078222C746869732E636F6E7461696E65722E7374796C652E6865696768743D632B227078222C746869732E636F6E7461696E65722E7374796C65';
wwv_flow_imp.g_varchar2_table(20831) := '2E6F766572666C6F773D2268696464656E22292C746869732E5F646F4C61796F757428632C6F292C746869732E6F7074696F6E732E6B656570456469746F7253656C656374696F6E7C7C746869732E656469746F722E73657453656C656374696F6E2865';
wwv_flow_imp.g_varchar2_table(20832) := '293B636F6E737420643D746869732E656469746F722E6765744D6F64656C28293B69662864297B636F6E737420743D642E76616C696461746552616E6765286E657720726828652E73746172744C696E654E756D6265722C312C652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(20833) := '756D6265722B312C3129293B746869732E72657665616C52616E676528742C742E73746172744C696E654E756D6265723D3D3D642E6765744C696E65436F756E742829297D7D72657665616C52616E676528652C74297B743F746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(20834) := '2E72657665616C4C696E654E656172546F7028652E656E644C696E654E756D6265722C30293A746869732E656469746F722E72657665616C52616E676528652C30297D736574437373436C61737328652C74297B746869732E636F6E7461696E65722626';
wwv_flow_imp.g_varchar2_table(20835) := '28742626746869732E636F6E7461696E65722E636C6173734C6973742E72656D6F76652874292C746869732E636F6E7461696E65722E636C6173734C6973742E616464286529297D5F6F6E57696474682865297B7D5F646F4C61796F757428652C74297B';
wwv_flow_imp.g_varchar2_table(20836) := '7D5F72656C61796F75742865297B746869732E5F766965775A6F6E652626746869732E5F766965775A6F6E652E686569676874496E4C696E6573213D3D652626746869732E656469746F722E6368616E6765566965775A6F6E65732828743D3E7B746869';
wwv_flow_imp.g_varchar2_table(20837) := '732E5F766965775A6F6E65262628746869732E5F766965775A6F6E652E686569676874496E4C696E65733D652C742E6C61796F75745A6F6E6528746869732E5F766965775A6F6E652E696429297D29297D5F696E69745361736828297B69662874686973';
wwv_flow_imp.g_varchar2_table(20838) := '2E5F726573697A65536173682972657475726E3B6C657420653B746869732E5F726573697A65536173683D746869732E5F646973706F7361626C65732E616464286E657720637128746869732E646F6D4E6F64652C746869732C7B6F7269656E74617469';
wwv_flow_imp.g_varchar2_table(20839) := '6F6E3A317D29292C746869732E6F7074696F6E732E6973526573697A6561626C657C7C28746869732E5F726573697A65536173682E73746174653D30292C746869732E5F646973706F7361626C65732E61646428746869732E5F726573697A6553617368';
wwv_flow_imp.g_varchar2_table(20840) := '2E6F6E44696453746172742828743D3E7B746869732E5F766965775A6F6E65262628653D7B7374617274593A742E7374617274592C686569676874496E4C696E65733A746869732E5F766965775A6F6E652E686569676874496E4C696E65737D297D2929';
wwv_flow_imp.g_varchar2_table(20841) := '292C746869732E5F646973706F7361626C65732E61646428746869732E5F726573697A65536173682E6F6E446964456E64282828293D3E7B653D766F696420307D2929292C746869732E5F646973706F7361626C65732E61646428746869732E5F726573';
wwv_flow_imp.g_varchar2_table(20842) := '697A65536173682E6F6E4469644368616E67652828743D3E7B69662865297B636F6E7374206E3D28742E63757272656E74592D652E737461727459292F746869732E656469746F722E6765744F7074696F6E283637292C693D6E3C303F4D6174682E6365';
wwv_flow_imp.g_varchar2_table(20843) := '696C286E293A4D6174682E666C6F6F72286E292C6F3D652E686569676874496E4C696E65732B693B6F3E3526266F3C33352626746869732E5F72656C61796F7574286F297D7D2929297D676574486F72697A6F6E74616C536173684C65667428297B7265';
wwv_flow_imp.g_varchar2_table(20844) := '7475726E20307D676574486F72697A6F6E74616C53617368546F7028297B72657475726E286E756C6C3D3D3D746869732E646F6D4E6F64652E7374796C652E6865696768743F303A7061727365496E7428746869732E646F6D4E6F64652E7374796C652E';
wwv_flow_imp.g_varchar2_table(20845) := '68656967687429292D746869732E5F6465636F726174696E67456C656D656E747348656967687428292F327D676574486F72697A6F6E74616C53617368576964746828297B636F6E737420653D746869732E656469746F722E6765744C61796F7574496E';
wwv_flow_imp.g_varchar2_table(20846) := '666F28293B72657475726E20652E77696474682D652E6D696E696D61702E6D696E696D617057696474687D7D7661722067243D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F';
wwv_flow_imp.g_varchar2_table(20847) := '743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(20848) := '5265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F28';
wwv_flow_imp.g_varchar2_table(20849) := '72293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C6D243D66756E6374696F6E28652C74297B72657475726E2066';
wwv_flow_imp.g_varchar2_table(20850) := '756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742066243D70632822495065656B566965775365727669636522293B7661722076243B78702866242C636C6173737B636F6E7374727563746F7228297B746869732E5F7769646765';
wwv_flow_imp.g_varchar2_table(20851) := '74733D6E6577204D61707D6164644578636C757369766557696467657428652C74297B636F6E7374206E3D746869732E5F776964676574732E6765742865293B6E2626286E2E6C697374656E65722E646973706F736528292C6E2E7769646765742E6469';
wwv_flow_imp.g_varchar2_table(20852) := '73706F73652829292C746869732E5F776964676574732E73657428652C7B7769646765743A742C6C697374656E65723A742E6F6E446964436C6F7365282828293D3E7B636F6E7374206E3D746869732E5F776964676574732E6765742865293B6E26266E';
wwv_flow_imp.g_varchar2_table(20853) := '2E7769646765743D3D3D742626286E2E6C697374656E65722E646973706F736528292C746869732E5F776964676574732E64656C657465286529297D29297D297D7D2C31292C66756E6374696F6E2865297B652E696E5065656B456469746F723D6E6577';
wwv_flow_imp.g_varchar2_table(20854) := '206C642822696E5265666572656E6365536561726368456469746F72222C21302C6228302C2257686574686572207468652063757272656E7420636F646520656469746F7220697320656D62656464656420696E73696465207065656B2229292C652E6E';
wwv_flow_imp.g_varchar2_table(20855) := '6F74496E5065656B456469746F723D652E696E5065656B456469746F722E746F4E65676174656428297D2876247C7C2876243D7B7D29293B6C65742062243D636C6173737B636F6E7374727563746F7228652C74297B6520696E7374616E63656F662069';
wwv_flow_imp.g_varchar2_table(20856) := '24262676242E696E5065656B456469746F722E62696E64546F2874297D646973706F736528297B7D7D3B62242E49443D22656469746F722E636F6E747269622E7265666572656E6365436F6E74726F6C6C6572222C62243D6724285B6D2428312C636429';
wwv_flow_imp.g_varchar2_table(20857) := '5D2C6224292C4A642862242E49442C62242C30293B636F6E7374205F243D7B6865616465724261636B67726F756E64436F6C6F723A68752E77686974652C7072696D61727948656164696E67436F6C6F723A68752E66726F6D4865782822233333333333';
wwv_flow_imp.g_varchar2_table(20858) := '3322292C7365636F6E6461727948656164696E67436F6C6F723A68752E66726F6D486578282223366336633663623322297D3B6C65742079243D636C61737320657874656E64732070247B636F6E7374727563746F7228652C742C6E297B737570657228';
wwv_flow_imp.g_varchar2_table(20859) := '652C74292C746869732E696E7374616E74696174696F6E536572766963653D6E2C746869732E5F6F6E446964436C6F73653D6E65772043742C746869732E6F6E446964436C6F73653D746869732E5F6F6E446964436C6F73652E6576656E742C79682874';
wwv_flow_imp.g_varchar2_table(20860) := '6869732E6F7074696F6E732C5F242C2131297D646973706F736528297B746869732E646973706F7365647C7C28746869732E646973706F7365643D21302C73757065722E646973706F736528292C746869732E5F6F6E446964436C6F73652E6669726528';
wwv_flow_imp.g_varchar2_table(20861) := '7468697329297D7374796C652865297B636F6E737420743D746869732E6F7074696F6E733B652E6865616465724261636B67726F756E64436F6C6F72262628742E6865616465724261636B67726F756E64436F6C6F723D652E6865616465724261636B67';
wwv_flow_imp.g_varchar2_table(20862) := '726F756E64436F6C6F72292C652E7072696D61727948656164696E67436F6C6F72262628742E7072696D61727948656164696E67436F6C6F723D652E7072696D61727948656164696E67436F6C6F72292C652E7365636F6E6461727948656164696E6743';
wwv_flow_imp.g_varchar2_table(20863) := '6F6C6F72262628742E7365636F6E6461727948656164696E67436F6C6F723D652E7365636F6E6461727948656164696E67436F6C6F72292C73757065722E7374796C652865297D5F6170706C795374796C657328297B73757065722E5F6170706C795374';
wwv_flow_imp.g_varchar2_table(20864) := '796C657328293B636F6E737420653D746869732E6F7074696F6E733B746869732E5F68656164456C656D656E742626652E6865616465724261636B67726F756E64436F6C6F72262628746869732E5F68656164456C656D656E742E7374796C652E626163';
wwv_flow_imp.g_varchar2_table(20865) := '6B67726F756E64436F6C6F723D652E6865616465724261636B67726F756E64436F6C6F722E746F537472696E672829292C746869732E5F7072696D61727948656164696E672626652E7072696D61727948656164696E67436F6C6F72262628746869732E';
wwv_flow_imp.g_varchar2_table(20866) := '5F7072696D61727948656164696E672E7374796C652E636F6C6F723D652E7072696D61727948656164696E67436F6C6F722E746F537472696E672829292C746869732E5F7365636F6E6461727948656164696E672626652E7365636F6E64617279486561';
wwv_flow_imp.g_varchar2_table(20867) := '64696E67436F6C6F72262628746869732E5F7365636F6E6461727948656164696E672E7374796C652E636F6C6F723D652E7365636F6E6461727948656164696E67436F6C6F722E746F537472696E672829292C746869732E5F626F6479456C656D656E74';
wwv_flow_imp.g_varchar2_table(20868) := '2626652E6672616D65436F6C6F72262628746869732E5F626F6479456C656D656E742E7374796C652E626F72646572436F6C6F723D652E6672616D65436F6C6F722E746F537472696E672829297D5F66696C6C436F6E7461696E65722865297B74686973';
wwv_flow_imp.g_varchar2_table(20869) := '2E736574437373436C61737328227065656B766965772D77696467657422292C746869732E5F68656164456C656D656E743D627228222E6865616422292C746869732E5F626F6479456C656D656E743D627228222E626F647922292C746869732E5F6669';
wwv_flow_imp.g_varchar2_table(20870) := '6C6C4865616428746869732E5F68656164456C656D656E74292C746869732E5F66696C6C426F647928746869732E5F626F6479456C656D656E74292C652E617070656E644368696C6428746869732E5F68656164456C656D656E74292C652E617070656E';
wwv_flow_imp.g_varchar2_table(20871) := '644368696C6428746869732E5F626F6479456C656D656E74297D5F66696C6C4865616428652C74297B746869732E5F7469746C65456C656D656E743D627228222E7065656B766965772D7469746C6522292C746869732E6F7074696F6E732E737570706F';
wwv_flow_imp.g_varchar2_table(20872) := '72744F6E5469746C65436C69636B262628746869732E5F7469746C65456C656D656E742E636C6173734C6973742E6164642822636C69636B61626C6522292C797328746869732E5F7469746C65456C656D656E742C22636C69636B222C28653D3E746869';
wwv_flow_imp.g_varchar2_table(20873) := '732E5F6F6E5469746C65436C69636B2865292929292C757228746869732E5F68656164456C656D656E742C746869732E5F7469746C65456C656D656E74292C746869732E5F66696C6C5469746C6549636F6E28746869732E5F7469746C65456C656D656E';
wwv_flow_imp.g_varchar2_table(20874) := '74292C746869732E5F7072696D61727948656164696E673D627228227370616E2E66696C656E616D6522292C746869732E5F7365636F6E6461727948656164696E673D627228227370616E2E6469726E616D6522292C746869732E5F6D65746148656164';
wwv_flow_imp.g_varchar2_table(20875) := '696E673D627228227370616E2E6D65746122292C757228746869732E5F7469746C65456C656D656E742C746869732E5F7072696D61727948656164696E672C746869732E5F7365636F6E6461727948656164696E672C746869732E5F6D65746148656164';
wwv_flow_imp.g_varchar2_table(20876) := '696E67293B636F6E7374206E3D627228222E7065656B766965772D616374696F6E7322293B757228746869732E5F68656164456C656D656E742C6E293B636F6E737420693D746869732E5F676574416374696F6E4261724F7074696F6E7328293B746869';
wwv_flow_imp.g_varchar2_table(20877) := '732E5F616374696F6E6261725769646765743D6E6577206C4D286E2C69292C746869732E5F646973706F7361626C65732E61646428746869732E5F616374696F6E626172576964676574292C747C7C746869732E5F616374696F6E626172576964676574';
wwv_flow_imp.g_varchar2_table(20878) := '2E70757368286E657720626328227065656B766965772E636C6F7365222C6228302C22436C6F736522292C546C2E6173436C6173734E616D65284C6C2E636C6F7365292C21302C2828293D3E28746869732E646973706F736528292C50726F6D6973652E';
wwv_flow_imp.g_varchar2_table(20879) := '7265736F6C766528292929292C7B6C6162656C3A21312C69636F6E3A21307D297D5F66696C6C5469746C6549636F6E2865297B7D5F676574416374696F6E4261724F7074696F6E7328297B72657475726E7B616374696F6E566965774974656D50726F76';
wwv_flow_imp.g_varchar2_table(20880) := '696465723A786A2E62696E6428766F696420302C746869732E696E7374616E74696174696F6E53657276696365292C6F7269656E746174696F6E3A307D7D5F6F6E5469746C65436C69636B2865297B7D7365745469746C6528652C74297B746869732E5F';
wwv_flow_imp.g_varchar2_table(20881) := '7072696D61727948656164696E672626746869732E5F7365636F6E6461727948656164696E67262628746869732E5F7072696D61727948656164696E672E696E6E6572546578743D652C746869732E5F7072696D61727948656164696E672E7365744174';
wwv_flow_imp.g_varchar2_table(20882) := '7472696275746528227469746C65222C65292C743F746869732E5F7365636F6E6461727948656164696E672E696E6E6572546578743D743A667328746869732E5F7365636F6E6461727948656164696E6729297D7365744D6574615469746C652865297B';
wwv_flow_imp.g_varchar2_table(20883) := '746869732E5F6D65746148656164696E67262628653F28746869732E5F6D65746148656164696E672E696E6E6572546578743D652C5F7228746869732E5F6D65746148656164696E6729293A797228746869732E5F6D65746148656164696E6729297D5F';
wwv_flow_imp.g_varchar2_table(20884) := '646F4C61796F757428652C74297B69662821746869732E5F697353686F77696E672626653C302972657475726E20766F696420746869732E646973706F736528293B636F6E7374206E3D4D6174682E6365696C28312E322A746869732E656469746F722E';
wwv_flow_imp.g_varchar2_table(20885) := '6765744F7074696F6E28363729292C693D4D6174682E726F756E6428652D286E2B3229293B746869732E5F646F4C61796F757448656164286E2C74292C746869732E5F646F4C61796F7574426F647928692C74297D5F646F4C61796F7574486561642865';
wwv_flow_imp.g_varchar2_table(20886) := '2C74297B746869732E5F68656164456C656D656E74262628746869732E5F68656164456C656D656E742E7374796C652E6865696768743D60247B657D7078602C746869732E5F68656164456C656D656E742E7374796C652E6C696E654865696768743D74';
wwv_flow_imp.g_varchar2_table(20887) := '6869732E5F68656164456C656D656E742E7374796C652E686569676874297D5F646F4C61796F7574426F647928652C74297B746869732E5F626F6479456C656D656E74262628746869732E5F626F6479456C656D656E742E7374796C652E686569676874';
wwv_flow_imp.g_varchar2_table(20888) := '3D60247B657D707860297D7D3B79243D6724285B6D2428322C7563295D2C7924293B636F6E73742077243D4C6D28227065656B566965775469746C652E6261636B67726F756E64222C7B6461726B3A2223323532353236222C6C696768743A2223463346';
wwv_flow_imp.g_varchar2_table(20889) := '334633222C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C224261636B67726F756E6420636F6C6F72206F6620746865207065656B2076696577207469746C6520617265612E2229292C43243D4C6D2822';
wwv_flow_imp.g_varchar2_table(20890) := '7065656B566965775469746C654C6162656C2E666F726567726F756E64222C7B6461726B3A68752E77686974652C6C696768743A68752E626C61636B2C68634461726B3A68752E77686974652C68634C696768743A5A6D7D2C6228302C22436F6C6F7220';
wwv_flow_imp.g_varchar2_table(20891) := '6F6620746865207065656B2076696577207469746C652E2229292C53243D4C6D28227065656B566965775469746C654465736372697074696F6E2E666F726567726F756E64222C7B6461726B3A22236363636363636233222C6C696768743A2223363136';
wwv_flow_imp.g_varchar2_table(20892) := '313631222C68634461726B3A22234646464646463939222C68634C696768743A2223323932393239227D2C6228302C22436F6C6F72206F6620746865207065656B2076696577207469746C6520696E666F2E2229292C78243D4C6D28227065656B566965';
wwv_flow_imp.g_varchar2_table(20893) := '772E626F72646572222C7B6461726B3A61662C6C696768743A61662C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22436F6C6F72206F6620746865207065656B207669657720626F726465727320616E64206172726F772E2229292C';
wwv_flow_imp.g_varchar2_table(20894) := '6B243D4C6D28227065656B56696577526573756C742E6261636B67726F756E64222C7B6461726B3A2223323532353236222C6C696768743A2223463346334633222C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C';
wwv_flow_imp.g_varchar2_table(20895) := '6228302C224261636B67726F756E6420636F6C6F72206F6620746865207065656B207669657720726573756C74206C6973742E2229292C45243D284C6D28227065656B56696577526573756C742E6C696E65466F726567726F756E64222C7B6461726B3A';
wwv_flow_imp.g_varchar2_table(20896) := '2223626262626262222C6C696768743A2223363436343635222C68634461726B3A68752E77686974652C68634C696768743A5A6D7D2C6228302C22466F726567726F756E6420636F6C6F7220666F72206C696E65206E6F64657320696E20746865207065';
wwv_flow_imp.g_varchar2_table(20897) := '656B207669657720726573756C74206C6973742E2229292C4C6D28227065656B56696577526573756C742E66696C65466F726567726F756E64222C7B6461726B3A68752E77686974652C6C696768743A2223314531453145222C68634461726B3A68752E';
wwv_flow_imp.g_varchar2_table(20898) := '77686974652C68634C696768743A5A6D7D2C6228302C22466F726567726F756E6420636F6C6F7220666F722066696C65206E6F64657320696E20746865207065656B207669657720726573756C74206C6973742E2229292C4C6D28227065656B56696577';
wwv_flow_imp.g_varchar2_table(20899) := '526573756C742E73656C656374696F6E4261636B67726F756E64222C7B6461726B3A22233333393966663333222C6C696768743A22233333393966663333222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67';
wwv_flow_imp.g_varchar2_table(20900) := '726F756E6420636F6C6F72206F66207468652073656C656374656420656E74727920696E20746865207065656B207669657720726573756C74206C6973742E2229292C4C6D28227065656B56696577526573756C742E73656C656374696F6E466F726567';
wwv_flow_imp.g_varchar2_table(20901) := '726F756E64222C7B6461726B3A68752E77686974652C6C696768743A2223364336433643222C68634461726B3A68752E77686974652C68634C696768743A5A6D7D2C6228302C22466F726567726F756E6420636F6C6F72206F66207468652073656C6563';
wwv_flow_imp.g_varchar2_table(20902) := '74656420656E74727920696E20746865207065656B207669657720726573756C74206C6973742E2229292C4C6D28227065656B56696577456469746F722E6261636B67726F756E64222C7B6461726B3A2223303031463333222C6C696768743A22234632';
wwv_flow_imp.g_varchar2_table(20903) := '46384643222C68634461726B3A68752E626C61636B2C68634C696768743A68752E77686974657D2C6228302C224261636B67726F756E6420636F6C6F72206F6620746865207065656B207669657720656469746F722E222929293B4C6D28227065656B56';
wwv_flow_imp.g_varchar2_table(20904) := '696577456469746F724775747465722E6261636B67726F756E64222C7B6461726B3A45242C6C696768743A45242C68634461726B3A45242C68634C696768743A45247D2C6228302C224261636B67726F756E6420636F6C6F72206F662074686520677574';
wwv_flow_imp.g_varchar2_table(20905) := '74657220696E20746865207065656B207669657720656469746F722E2229292C4C6D28227065656B56696577456469746F72537469636B795363726F6C6C2E6261636B67726F756E64222C7B6461726B3A45242C6C696768743A45242C68634461726B3A';
wwv_flow_imp.g_varchar2_table(20906) := '45242C68634C696768743A45247D2C6228302C224261636B67726F756E6420636F6C6F72206F6620737469636B79207363726F6C6C20696E20746865207065656B207669657720656469746F722E2229292C4C6D28227065656B56696577526573756C74';
wwv_flow_imp.g_varchar2_table(20907) := '2E6D61746368486967686C696768744261636B67726F756E64222C7B6461726B3A22236561356330303464222C6C696768743A22236561356330303464222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224D6174636820';
wwv_flow_imp.g_varchar2_table(20908) := '686967686C6967687420636F6C6F7220696E20746865207065656B207669657720726573756C74206C6973742E2229292C4C6D28227065656B56696577456469746F722E6D61746368486967686C696768744261636B67726F756E64222C7B6461726B3A';
wwv_flow_imp.g_varchar2_table(20909) := '22236666386630303939222C6C696768743A22236635643830326465222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224D6174636820686967686C6967687420636F6C6F7220696E20746865207065656B207669657720';
wwv_flow_imp.g_varchar2_table(20910) := '656469746F722E2229292C4C6D28227065656B56696577456469746F722E6D61746368486967686C69676874426F72646572222C7B6461726B3A6E756C6C2C6C696768743A6E756C6C2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C';
wwv_flow_imp.g_varchar2_table(20911) := '224D6174636820686967686C6967687420626F7264657220696E20746865207065656B207669657720656469746F722E2229293B636C617373204C247B6765742074656D706C617465496428297B72657475726E20746869732E72656E64657265722E74';
wwv_flow_imp.g_varchar2_table(20912) := '656D706C61746549647D636F6E7374727563746F7228652C74297B746869732E72656E64657265723D652C746869732E6D6F64656C50726F76696465723D747D72656E64657254656D706C6174652865297B72657475726E7B646174613A746869732E72';
wwv_flow_imp.g_varchar2_table(20913) := '656E64657265722E72656E64657254656D706C6174652865292C646973706F7361626C653A6C742E4E6F6E657D7D72656E646572456C656D656E7428652C742C6E2C69297B766172206F3B6966286E756C6C3D3D3D286F3D6E2E646973706F7361626C65';
wwv_flow_imp.g_varchar2_table(20914) := '297C7C766F696420303D3D3D6F7C7C6F2E646973706F736528292C216E2E646174612972657475726E3B636F6E737420733D746869732E6D6F64656C50726F766964657228293B696628732E69735265736F6C7665642865292972657475726E20746869';
wwv_flow_imp.g_varchar2_table(20915) := '732E72656E64657265722E72656E646572456C656D656E7428732E6765742865292C652C6E2E646174612C69293B636F6E737420723D6E6577204E742C613D732E7265736F6C766528652C722E746F6B656E293B6E2E646973706F7361626C653D7B6469';
wwv_flow_imp.g_varchar2_table(20916) := '73706F73653A28293D3E722E63616E63656C28297D2C746869732E72656E64657265722E72656E646572506C616365686F6C64657228652C6E2E64617461292C612E7468656E2828743D3E746869732E72656E64657265722E72656E646572456C656D65';
wwv_flow_imp.g_varchar2_table(20917) := '6E7428742C652C6E2E646174612C692929297D646973706F736554656D706C6174652865297B652E646973706F7361626C65262628652E646973706F7361626C652E646973706F736528292C652E646973706F7361626C653D766F69642030292C652E64';
wwv_flow_imp.g_varchar2_table(20918) := '617461262628746869732E72656E64657265722E646973706F736554656D706C61746528652E64617461292C652E646174613D766F69642030297D7D636C6173732044247B636F6E7374727563746F7228652C74297B746869732E6D6F64656C50726F76';
wwv_flow_imp.g_varchar2_table(20919) := '696465723D652C746869732E6163636573736962696C69747950726F76696465723D747D676574576964676574417269614C6162656C28297B72657475726E20746869732E6163636573736962696C69747950726F76696465722E676574576964676574';
wwv_flow_imp.g_varchar2_table(20920) := '417269614C6162656C28297D676574417269614C6162656C2865297B636F6E737420743D746869732E6D6F64656C50726F766964657228293B72657475726E20742E69735265736F6C7665642865293F746869732E6163636573736962696C6974795072';
wwv_flow_imp.g_varchar2_table(20921) := '6F76696465722E676574417269614C6162656C28742E676574286529293A6E756C6C7D7D636C6173732054247B636F6E7374727563746F7228652C742C6E2C692C6F3D7B7D297B636F6E737420733D28293D3E746869732E6D6F64656C2C723D692E6D61';
wwv_flow_imp.g_varchar2_table(20922) := '702828653D3E6E6577204C2428652C732929293B746869732E6C6973743D6E657720554928652C742C6E2C722C66756E6374696F6E28652C74297B72657475726E7B2E2E2E742C6163636573736962696C69747950726F76696465723A742E6163636573';
wwv_flow_imp.g_varchar2_table(20923) := '736962696C69747950726F766964657226266E657720442428652C742E6163636573736962696C69747950726F7669646572297D7D28732C6F29297D7570646174654F7074696F6E732865297B746869732E6C6973742E7570646174654F7074696F6E73';
wwv_flow_imp.g_varchar2_table(20924) := '2865297D67657448544D4C456C656D656E7428297B72657475726E20746869732E6C6973742E67657448544D4C456C656D656E7428297D676574206F6E446964466F63757328297B72657475726E20746869732E6C6973742E6F6E446964466F6375737D';
wwv_flow_imp.g_varchar2_table(20925) := '6765742077696467657428297B72657475726E20746869732E6C6973747D676574206F6E446964446973706F736528297B72657475726E20746869732E6C6973742E6F6E446964446973706F73657D676574206F6E4D6F75736544626C436C69636B2829';
wwv_flow_imp.g_varchar2_table(20926) := '7B72657475726E2076742E6D617028746869732E6C6973742E6F6E4D6F75736544626C436C69636B2C28287B656C656D656E743A652C696E6465783A742C62726F777365724576656E743A6E7D293D3E287B656C656D656E743A766F696420303D3D3D65';
wwv_flow_imp.g_varchar2_table(20927) := '3F766F696420303A746869732E5F6D6F64656C2E6765742865292C696E6465783A742C62726F777365724576656E743A6E7D2929297D676574206F6E506F696E74657228297B72657475726E2076742E6D617028746869732E6C6973742E6F6E506F696E';
wwv_flow_imp.g_varchar2_table(20928) := '7465722C28287B656C656D656E743A652C696E6465783A742C62726F777365724576656E743A6E7D293D3E287B656C656D656E743A766F696420303D3D3D653F766F696420303A746869732E5F6D6F64656C2E6765742865292C696E6465783A742C6272';
wwv_flow_imp.g_varchar2_table(20929) := '6F777365724576656E743A6E7D2929297D676574206F6E4469644368616E676553656C656374696F6E28297B72657475726E2076742E6D617028746869732E6C6973742E6F6E4469644368616E676553656C656374696F6E2C28287B656C656D656E7473';
wwv_flow_imp.g_varchar2_table(20930) := '3A652C696E64657865733A742C62726F777365724576656E743A6E7D293D3E287B656C656D656E74733A652E6D61702828653D3E746869732E5F6D6F64656C2E67657428652929292C696E64657865733A742C62726F777365724576656E743A6E7D2929';
wwv_flow_imp.g_varchar2_table(20931) := '297D676574206D6F64656C28297B72657475726E20746869732E5F6D6F64656C7D736574206D6F64656C2865297B746869732E5F6D6F64656C3D652C746869732E6C6973742E73706C69636528302C746869732E6C6973742E6C656E6774682C55682865';
wwv_flow_imp.g_varchar2_table(20932) := '2E6C656E67746829297D676574466F63757328297B72657475726E20746869732E6C6973742E676574466F63757328297D67657453656C656374696F6E28297B72657475726E20746869732E6C6973742E67657453656C656374696F6E28297D67657453';
wwv_flow_imp.g_varchar2_table(20933) := '656C6563746564456C656D656E747328297B72657475726E20746869732E67657453656C656374696F6E28292E6D61702828653D3E746869732E6D6F64656C2E67657428652929297D7374796C652865297B746869732E6C6973742E7374796C65286529';
wwv_flow_imp.g_varchar2_table(20934) := '7D646973706F736528297B746869732E6C6973742E646973706F736528297D7D7661722049243D6E2833343734292C4D243D7B7D3B4D242E7374796C655461675472616E73666F726D3D6A7228292C4D242E736574417474726962757465733D56722829';
wwv_flow_imp.g_varchar2_table(20935) := '2C4D242E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4D242E646F6D4150493D4F7228292C4D242E696E736572745374796C65456C656D656E743D487228292C4E7228292849242E412C4D24292C49242E41262649242E41';
wwv_flow_imp.g_varchar2_table(20936) := '2E6C6F63616C73262649242E412E6C6F63616C733B636F6E73742041243D7B736570617261746F72426F726465723A68752E7472616E73706172656E747D3B636C617373204E247B7365742073697A652865297B746869732E5F73697A653D657D676574';
wwv_flow_imp.g_varchar2_table(20937) := '2073697A6528297B72657475726E20746869732E5F73697A657D6765742076697369626C6528297B72657475726E20766F696420303D3D3D746869732E5F63616368656456697369626C6553697A657D73657456697369626C6528652C74297B76617220';
wwv_flow_imp.g_varchar2_table(20938) := '6E2C693B69662865213D3D746869732E76697369626C65297B653F28746869732E73697A653D484428746869732E5F63616368656456697369626C6553697A652C746869732E766965774D696E696D756D53697A652C746869732E766965774D6178696D';
wwv_flow_imp.g_varchar2_table(20939) := '756D53697A65292C746869732E5F63616368656456697369626C6553697A653D766F69642030293A28746869732E5F63616368656456697369626C6553697A653D226E756D626572223D3D747970656F6620743F743A746869732E73697A652C74686973';
wwv_flow_imp.g_varchar2_table(20940) := '2E73697A653D30292C746869732E636F6E7461696E65722E636C6173734C6973742E746F67676C65282276697369626C65222C65293B7472797B6E756C6C3D3D3D28693D286E3D746869732E76696577292E73657456697369626C65297C7C766F696420';
wwv_flow_imp.g_varchar2_table(20941) := '303D3D3D697C7C692E63616C6C286E2C65297D63617463682865297B636F6E736F6C652E6572726F72282253706C6974766965773A204661696C656420746F207365742076697369626C65207669657722292C636F6E736F6C652E6572726F722865297D';
wwv_flow_imp.g_varchar2_table(20942) := '7D7D676574206D696E696D756D53697A6528297B72657475726E20746869732E76697369626C653F746869732E766965772E6D696E696D756D53697A653A307D67657420766965774D696E696D756D53697A6528297B72657475726E20746869732E7669';
wwv_flow_imp.g_varchar2_table(20943) := '65772E6D696E696D756D53697A657D676574206D6178696D756D53697A6528297B72657475726E20746869732E76697369626C653F746869732E766965772E6D6178696D756D53697A653A307D67657420766965774D6178696D756D53697A6528297B72';
wwv_flow_imp.g_varchar2_table(20944) := '657475726E20746869732E766965772E6D6178696D756D53697A657D676574207072696F7269747928297B72657475726E20746869732E766965772E7072696F726974797D6765742070726F706F7274696F6E616C4C61796F757428297B76617220653B';
wwv_flow_imp.g_varchar2_table(20945) := '72657475726E206E756C6C3D3D3D28653D746869732E766965772E70726F706F7274696F6E616C4C61796F7574297C7C766F696420303D3D3D657C7C657D67657420736E617028297B72657475726E2121746869732E766965772E736E61707D73657420';
wwv_flow_imp.g_varchar2_table(20946) := '656E61626C65642865297B746869732E636F6E7461696E65722E7374796C652E706F696E7465724576656E74733D653F22223A226E6F6E65227D636F6E7374727563746F7228652C742C6E2C69297B746869732E636F6E7461696E65723D652C74686973';
wwv_flow_imp.g_varchar2_table(20947) := '2E766965773D742C746869732E646973706F7361626C653D692C746869732E5F63616368656456697369626C6553697A653D766F696420302C226E756D626572223D3D747970656F66206E3F28746869732E5F73697A653D6E2C746869732E5F63616368';
wwv_flow_imp.g_varchar2_table(20948) := '656456697369626C6553697A653D766F696420302C652E636C6173734C6973742E616464282276697369626C652229293A28746869732E5F73697A653D302C746869732E5F63616368656456697369626C6553697A653D6E2E6361636865645669736962';
wwv_flow_imp.g_varchar2_table(20949) := '6C6553697A65297D6C61796F757428652C74297B746869732E6C61796F7574436F6E7461696E65722865293B7472797B746869732E766965772E6C61796F757428746869732E73697A652C652C74297D63617463682865297B636F6E736F6C652E657272';
wwv_flow_imp.g_varchar2_table(20950) := '6F72282253706C6974766965773A204661696C656420746F206C61796F7574207669657722292C636F6E736F6C652E6572726F722865297D7D646973706F736528297B746869732E646973706F7361626C652E646973706F736528297D7D636C61737320';
wwv_flow_imp.g_varchar2_table(20951) := '502420657874656E6473204E247B6C61796F7574436F6E7461696E65722865297B746869732E636F6E7461696E65722E7374796C652E746F703D60247B657D7078602C746869732E636F6E7461696E65722E7374796C652E6865696768743D60247B7468';
wwv_flow_imp.g_varchar2_table(20952) := '69732E73697A657D7078607D7D636C617373204F2420657874656E6473204E247B6C61796F7574436F6E7461696E65722865297B746869732E636F6E7461696E65722E7374796C652E6C6566743D60247B657D7078602C746869732E636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(20953) := '722E7374796C652E77696474683D60247B746869732E73697A657D7078607D7D7661722052242C46243B2166756E6374696F6E2865297B655B652E49646C653D305D3D2249646C65222C655B652E427573793D315D3D2242757379227D2852247C7C2852';
wwv_flow_imp.g_varchar2_table(20954) := '243D7B7D29292C66756E6374696F6E2865297B652E446973747269627574653D7B747970653A2264697374726962757465227D2C652E53706C69743D66756E6374696F6E2865297B72657475726E7B747970653A2273706C6974222C696E6465783A657D';
wwv_flow_imp.g_varchar2_table(20955) := '7D2C652E4175746F3D66756E6374696F6E2865297B72657475726E7B747970653A226175746F222C696E6465783A657D7D2C652E496E76697369626C653D66756E6374696F6E2865297B72657475726E7B747970653A22696E76697369626C65222C6361';
wwv_flow_imp.g_varchar2_table(20956) := '6368656456697369626C6553697A653A657D7D7D2846247C7C2846243D7B7D29293B636C61737320422420657874656E6473206C747B676574206F7274686F676F6E616C53746172745361736828297B72657475726E20746869732E5F6F7274686F676F';
wwv_flow_imp.g_varchar2_table(20957) := '6E616C5374617274536173687D676574206F7274686F676F6E616C456E645361736828297B72657475726E20746869732E5F6F7274686F676F6E616C456E64536173687D676574207374617274536E617070696E67456E61626C656428297B7265747572';
wwv_flow_imp.g_varchar2_table(20958) := '6E20746869732E5F7374617274536E617070696E67456E61626C65647D67657420656E64536E617070696E67456E61626C656428297B72657475726E20746869732E5F656E64536E617070696E67456E61626C65647D736574206F7274686F676F6E616C';
wwv_flow_imp.g_varchar2_table(20959) := '5374617274536173682865297B666F7228636F6E73742074206F6620746869732E736173684974656D7329742E736173682E6F7274686F676F6E616C5374617274536173683D653B746869732E5F6F7274686F676F6E616C5374617274536173683D657D';
wwv_flow_imp.g_varchar2_table(20960) := '736574206F7274686F676F6E616C456E64536173682865297B666F7228636F6E73742074206F6620746869732E736173684974656D7329742E736173682E6F7274686F676F6E616C456E64536173683D653B746869732E5F6F7274686F676F6E616C456E';
wwv_flow_imp.g_varchar2_table(20961) := '64536173683D657D736574207374617274536E617070696E67456E61626C65642865297B746869732E5F7374617274536E617070696E67456E61626C6564213D3D65262628746869732E5F7374617274536E617070696E67456E61626C65643D652C7468';
wwv_flow_imp.g_varchar2_table(20962) := '69732E75706461746553617368456E61626C656D656E742829297D73657420656E64536E617070696E67456E61626C65642865297B746869732E5F656E64536E617070696E67456E61626C6564213D3D65262628746869732E5F656E64536E617070696E';
wwv_flow_imp.g_varchar2_table(20963) := '67456E61626C65643D652C746869732E75706461746553617368456E61626C656D656E742829297D636F6E7374727563746F7228652C743D7B7D297B766172206E2C692C6F2C732C723B737570657228292C746869732E73697A653D302C746869732E5F';
wwv_flow_imp.g_varchar2_table(20964) := '636F6E74656E7453697A653D302C746869732E70726F706F7274696F6E733D766F696420302C746869732E766965774974656D733D5B5D2C746869732E736173684974656D733D5B5D2C746869732E73746174653D52242E49646C652C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(20965) := '6E446964536173684368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E4469645361736852657365743D746869732E5F7265676973746572286E6577204374292C746869732E5F7374617274536E617070696E';
wwv_flow_imp.g_varchar2_table(20966) := '67456E61626C65643D21302C746869732E5F656E64536E617070696E67456E61626C65643D21302C746869732E6F6E446964536173684368616E67653D746869732E5F6F6E446964536173684368616E67652E6576656E742C746869732E6F6E44696453';
wwv_flow_imp.g_varchar2_table(20967) := '61736852657365743D746869732E5F6F6E4469645361736852657365742E6576656E742C746869732E6F7269656E746174696F6E3D6E756C6C213D3D286E3D742E6F7269656E746174696F6E292626766F69642030213D3D6E3F6E3A302C746869732E69';
wwv_flow_imp.g_varchar2_table(20968) := '6E7665727365416C744265686176696F723D6E756C6C213D3D28693D742E696E7665727365416C744265686176696F72292626766F69642030213D3D692626692C746869732E70726F706F7274696F6E616C4C61796F75743D6E756C6C3D3D3D286F3D74';
wwv_flow_imp.g_varchar2_table(20969) := '2E70726F706F7274696F6E616C4C61796F7574297C7C766F696420303D3D3D6F7C7C6F2C746869732E676574536173684F7274686F676F6E616C53697A653D742E676574536173684F7274686F676F6E616C53697A652C746869732E656C3D646F63756D';
wwv_flow_imp.g_varchar2_table(20970) := '656E742E637265617465456C656D656E74282264697622292C746869732E656C2E636C6173734C6973742E61646428226D6F6E61636F2D73706C69742D766965773222292C746869732E656C2E636C6173734C6973742E61646428303D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(20971) := '6F7269656E746174696F6E3F22766572746963616C223A22686F72697A6F6E74616C22292C652E617070656E644368696C6428746869732E656C292C746869732E73617368436F6E7461696E65723D757228746869732E656C2C627228222E736173682D';
wwv_flow_imp.g_varchar2_table(20972) := '636F6E7461696E65722229292C746869732E76696577436F6E7461696E65723D627228222E73706C69742D766965772D636F6E7461696E657222292C746869732E7363726F6C6C61626C653D746869732E5F7265676973746572286E6577206E54287B66';
wwv_flow_imp.g_varchar2_table(20973) := '6F726365496E746567657256616C7565733A21302C736D6F6F74685363726F6C6C4475726174696F6E3A3132352C7363686564756C6541744E657874416E696D6174696F6E4672616D653A653D3E787328727328746869732E656C292C65297D29292C74';
wwv_flow_imp.g_varchar2_table(20974) := '6869732E7363726F6C6C61626C65456C656D656E743D746869732E5F7265676973746572286E657720705428746869732E76696577436F6E7461696E65722C7B766572746963616C3A303D3D3D746869732E6F7269656E746174696F6E3F6E756C6C213D';
wwv_flow_imp.g_varchar2_table(20975) := '3D28733D742E7363726F6C6C6261725669736962696C697479292626766F69642030213D3D733F733A313A322C686F72697A6F6E74616C3A313D3D3D746869732E6F7269656E746174696F6E3F6E756C6C213D3D28723D742E7363726F6C6C6261725669';
wwv_flow_imp.g_varchar2_table(20976) := '736962696C697479292626766F69642030213D3D723F723A313A327D2C746869732E7363726F6C6C61626C6529293B636F6E737420613D746869732E5F7265676973746572286E6577204B5328746869732E76696577436F6E7461696E65722C22736372';
wwv_flow_imp.g_varchar2_table(20977) := '6F6C6C2229292E6576656E743B746869732E5F726567697374657228612828653D3E7B636F6E737420743D746869732E7363726F6C6C61626C65456C656D656E742E6765745363726F6C6C506F736974696F6E28292C6E3D4D6174682E61627328746869';
wwv_flow_imp.g_varchar2_table(20978) := '732E76696577436F6E7461696E65722E7363726F6C6C4C6566742D742E7363726F6C6C4C656674293C3D313F766F696420303A746869732E76696577436F6E7461696E65722E7363726F6C6C4C6566742C693D4D6174682E61627328746869732E766965';
wwv_flow_imp.g_varchar2_table(20979) := '77436F6E7461696E65722E7363726F6C6C546F702D742E7363726F6C6C546F70293C3D313F766F696420303A746869732E76696577436F6E7461696E65722E7363726F6C6C546F703B766F696420303D3D3D6E2626766F696420303D3D3D697C7C746869';
wwv_flow_imp.g_varchar2_table(20980) := '732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C4C6566743A6E2C7363726F6C6C546F703A697D297D2929292C746869732E6F6E4469645363726F6C6C3D746869732E7363726F6C6C6162';
wwv_flow_imp.g_varchar2_table(20981) := '6C65456C656D656E742E6F6E5363726F6C6C2C746869732E5F726567697374657228746869732E6F6E4469645363726F6C6C2828653D3E7B652E7363726F6C6C546F704368616E676564262628746869732E76696577436F6E7461696E65722E7363726F';
wwv_flow_imp.g_varchar2_table(20982) := '6C6C546F703D652E7363726F6C6C546F70292C652E7363726F6C6C4C6566744368616E676564262628746869732E76696577436F6E7461696E65722E7363726F6C6C4C6566743D652E7363726F6C6C4C656674297D2929292C757228746869732E656C2C';
wwv_flow_imp.g_varchar2_table(20983) := '746869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F64652829292C746869732E7374796C6528742E7374796C65737C7C4124292C742E64657363726970746F72262628746869732E73697A653D742E64657363726970746F722E';
wwv_flow_imp.g_varchar2_table(20984) := '73697A652C742E64657363726970746F722E76696577732E666F7245616368282828652C74293D3E7B636F6E7374206E3D766C28652E76697369626C65297C7C652E76697369626C653F652E73697A653A7B747970653A22696E76697369626C65222C63';
wwv_flow_imp.g_varchar2_table(20985) := '616368656456697369626C6553697A653A652E73697A657D2C693D652E766965773B746869732E646F4164645669657728692C6E2C742C2130297D29292C746869732E5F636F6E74656E7453697A653D746869732E766965774974656D732E7265647563';
wwv_flow_imp.g_varchar2_table(20986) := '65282828652C74293D3E652B742E73697A65292C30292C746869732E7361766550726F706F7274696F6E732829297D7374796C652865297B652E736570617261746F72426F726465722E69735472616E73706172656E7428293F28746869732E656C2E63';
wwv_flow_imp.g_varchar2_table(20987) := '6C6173734C6973742E72656D6F76652822736570617261746F722D626F7264657222292C746869732E656C2E7374796C652E72656D6F766550726F706572747928222D2D736570617261746F722D626F726465722229293A28746869732E656C2E636C61';
wwv_flow_imp.g_varchar2_table(20988) := '73734C6973742E6164642822736570617261746F722D626F7264657222292C746869732E656C2E7374796C652E73657450726F706572747928222D2D736570617261746F722D626F72646572222C652E736570617261746F72426F726465722E746F5374';
wwv_flow_imp.g_varchar2_table(20989) := '72696E67282929297D6164645669657728652C742C6E3D746869732E766965774974656D732E6C656E6774682C69297B746869732E646F4164645669657728652C742C6E2C69297D6C61796F757428652C74297B636F6E7374206E3D4D6174682E6D6178';
wwv_flow_imp.g_varchar2_table(20990) := '28746869732E73697A652C746869732E5F636F6E74656E7453697A65293B696628746869732E73697A653D652C746869732E6C61796F7574436F6E746578743D742C746869732E70726F706F7274696F6E73297B6C657420743D303B666F72286C657420';
wwv_flow_imp.g_varchar2_table(20991) := '6E3D303B6E3C746869732E766965774974656D732E6C656E6774683B6E2B2B297B636F6E737420693D746869732E766965774974656D735B6E5D2C6F3D746869732E70726F706F7274696F6E735B6E5D3B226E756D626572223D3D747970656F66206F3F';
wwv_flow_imp.g_varchar2_table(20992) := '742B3D6F3A652D3D692E73697A657D666F72286C6574206E3D303B6E3C746869732E766965774974656D732E6C656E6774683B6E2B2B297B636F6E737420693D746869732E766965774974656D735B6E5D2C6F3D746869732E70726F706F7274696F6E73';
wwv_flow_imp.g_varchar2_table(20993) := '5B6E5D3B226E756D626572223D3D747970656F66206F2626743E30262628692E73697A653D4844284D6174682E726F756E64286F2A652F74292C692E6D696E696D756D53697A652C692E6D6178696D756D53697A6529297D7D656C73657B636F6E737420';
wwv_flow_imp.g_varchar2_table(20994) := '743D556828746869732E766965774974656D732E6C656E677468292C693D742E66696C7465722828653D3E313D3D3D746869732E766965774974656D735B655D2E7072696F7269747929292C6F3D742E66696C7465722828653D3E323D3D3D746869732E';
wwv_flow_imp.g_varchar2_table(20995) := '766965774974656D735B655D2E7072696F7269747929293B746869732E726573697A6528746869732E766965774974656D732E6C656E6774682D312C652D6E2C766F696420302C692C6F297D746869732E64697374726962757465456D70747953706163';
wwv_flow_imp.g_varchar2_table(20996) := '6528292C746869732E6C61796F7574566965777328297D7361766550726F706F7274696F6E7328297B746869732E70726F706F7274696F6E616C4C61796F75742626746869732E5F636F6E74656E7453697A653E30262628746869732E70726F706F7274';
wwv_flow_imp.g_varchar2_table(20997) := '696F6E733D746869732E766965774974656D732E6D61702828653D3E652E70726F706F7274696F6E616C4C61796F75742626652E76697369626C653F652E73697A652F746869732E5F636F6E74656E7453697A653A766F696420302929297D6F6E536173';
wwv_flow_imp.g_varchar2_table(20998) := '685374617274287B736173683A652C73746172743A742C616C743A6E7D297B666F7228636F6E73742065206F6620746869732E766965774974656D7329652E656E61626C65643D21313B636F6E737420693D746869732E736173684974656D732E66696E';
wwv_flow_imp.g_varchar2_table(20999) := '64496E6465782828743D3E742E736173683D3D3D6529292C6F3D737428627328746869732E656C2E6F776E6572446F63756D656E742E626F64792C226B6579646F776E222C28653D3E7328746869732E736173684472616753746174652E63757272656E';
wwv_flow_imp.g_varchar2_table(21000) := '742C652E616C744B65792929292C627328746869732E656C2E6F776E6572446F63756D656E742E626F64792C226B65797570222C2828293D3E7328746869732E736173684472616753746174652E63757272656E742C2131292929292C733D28652C7429';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(21001) := '3D3E7B636F6E7374206E3D746869732E766965774974656D732E6D61702828653D3E652E73697A6529293B6C657420732C722C613D4E756D6265722E4E454741544956455F494E46494E4954592C6C3D4E756D6265722E504F5349544956455F494E4649';
wwv_flow_imp.g_varchar2_table(21002) := '4E4954593B696628746869732E696E7665727365416C744265686176696F72262628743D2174292C7429696628693D3D3D746869732E736173684974656D732E6C656E6774682D31297B636F6E737420653D746869732E766965774974656D735B695D3B';
wwv_flow_imp.g_varchar2_table(21003) := '613D28652E6D696E696D756D53697A652D652E73697A65292F322C6C3D28652E6D6178696D756D53697A652D652E73697A65292F327D656C73657B636F6E737420653D746869732E766965774974656D735B692B315D3B613D28652E73697A652D652E6D';
wwv_flow_imp.g_varchar2_table(21004) := '6178696D756D53697A65292F322C6C3D28652E73697A652D652E6D696E696D756D53697A65292F327D6966282174297B636F6E737420653D556828692C2D31292C743D556828692B312C746869732E766965774974656D732E6C656E677468292C6F3D65';
wwv_flow_imp.g_varchar2_table(21005) := '2E726564756365282828652C74293D3E652B28746869732E766965774974656D735B745D2E6D696E696D756D53697A652D6E5B745D29292C30292C613D652E726564756365282828652C74293D3E652B28746869732E766965774974656D735B745D2E76';
wwv_flow_imp.g_varchar2_table(21006) := '6965774D6178696D756D53697A652D6E5B745D29292C30292C6C3D303D3D3D742E6C656E6774683F4E756D6265722E504F5349544956455F494E46494E4954593A742E726564756365282828652C74293D3E652B286E5B745D2D746869732E7669657749';
wwv_flow_imp.g_varchar2_table(21007) := '74656D735B745D2E6D696E696D756D53697A6529292C30292C633D303D3D3D742E6C656E6774683F4E756D6265722E4E454741544956455F494E46494E4954593A742E726564756365282828652C74293D3E652B286E5B745D2D746869732E7669657749';
wwv_flow_imp.g_varchar2_table(21008) := '74656D735B745D2E766965774D6178696D756D53697A6529292C30292C643D4D6174682E6D6178286F2C63292C683D4D6174682E6D696E286C2C61292C753D746869732E66696E644669727374536E6170496E6465782865292C703D746869732E66696E';
wwv_flow_imp.g_varchar2_table(21009) := '644669727374536E6170496E6465782874293B696628226E756D626572223D3D747970656F662075297B636F6E737420653D746869732E766965774974656D735B755D2C743D4D6174682E666C6F6F7228652E766965774D696E696D756D53697A652F32';
wwv_flow_imp.g_varchar2_table(21010) := '293B733D7B696E6465783A752C6C696D697444656C74613A652E76697369626C653F642D743A642B742C73697A653A652E73697A657D7D696628226E756D626572223D3D747970656F662070297B636F6E737420653D746869732E766965774974656D73';
wwv_flow_imp.g_varchar2_table(21011) := '5B705D2C743D4D6174682E666C6F6F7228652E766965774D696E696D756D53697A652F32293B723D7B696E6465783A702C6C696D697444656C74613A652E76697369626C653F682B743A682D742C73697A653A652E73697A657D7D7D746869732E736173';
wwv_flow_imp.g_varchar2_table(21012) := '684472616753746174653D7B73746172743A652C63757272656E743A652C696E6465783A692C73697A65733A6E2C6D696E44656C74613A612C6D617844656C74613A6C2C616C743A742C736E61704265666F72653A732C736E617041667465723A722C64';
wwv_flow_imp.g_varchar2_table(21013) := '6973706F7361626C653A6F7D7D3B7328742C6E297D6F6E536173684368616E6765287B63757272656E743A657D297B636F6E73747B696E6465783A742C73746172743A6E2C73697A65733A692C616C743A6F2C6D696E44656C74613A732C6D617844656C';
wwv_flow_imp.g_varchar2_table(21014) := '74613A722C736E61704265666F72653A612C736E617041667465723A6C7D3D746869732E736173684472616753746174653B746869732E736173684472616753746174652E63757272656E743D653B636F6E737420633D652D6E2C643D746869732E7265';
wwv_flow_imp.g_varchar2_table(21015) := '73697A6528742C632C692C766F696420302C766F696420302C732C722C612C6C293B6966286F297B636F6E737420653D743D3D3D746869732E736173684974656D732E6C656E6774682D312C6E3D746869732E766965774974656D732E6D61702828653D';
wwv_flow_imp.g_varchar2_table(21016) := '3E652E73697A6529292C693D653F743A742B312C6F3D746869732E766965774974656D735B695D2C733D6F2E73697A652D6F2E6D6178696D756D53697A652C723D6F2E73697A652D6F2E6D696E696D756D53697A652C613D653F742D313A742B313B7468';
wwv_flow_imp.g_varchar2_table(21017) := '69732E726573697A6528612C2D642C6E2C766F696420302C766F696420302C732C72297D746869732E64697374726962757465456D707479537061636528292C746869732E6C61796F7574566965777328297D6F6E53617368456E642865297B74686973';
wwv_flow_imp.g_varchar2_table(21018) := '2E5F6F6E446964536173684368616E67652E666972652865292C746869732E736173684472616753746174652E646973706F7361626C652E646973706F736528292C746869732E7361766550726F706F7274696F6E7328293B666F7228636F6E73742065';
wwv_flow_imp.g_varchar2_table(21019) := '206F6620746869732E766965774974656D7329652E656E61626C65643D21307D6F6E566965774368616E676528652C74297B636F6E7374206E3D746869732E766965774974656D732E696E6465784F662865293B6E3C307C7C6E3E3D746869732E766965';
wwv_flow_imp.g_varchar2_table(21020) := '774974656D732E6C656E6774687C7C28743D484428743D226E756D626572223D3D747970656F6620743F743A652E73697A652C652E6D696E696D756D53697A652C652E6D6178696D756D53697A65292C746869732E696E7665727365416C744265686176';
wwv_flow_imp.g_varchar2_table(21021) := '696F7226266E3E303F28746869732E726573697A65286E2D312C4D6174682E666C6F6F722828652E73697A652D74292F3229292C746869732E64697374726962757465456D707479537061636528292C746869732E6C61796F757456696577732829293A';
wwv_flow_imp.g_varchar2_table(21022) := '28652E73697A653D742C746869732E72656C61796F7574285B6E5D2C766F696420302929297D726573697A655669657728652C74297B6966282128653C307C7C653E3D746869732E766965774974656D732E6C656E67746829297B696628746869732E73';
wwv_flow_imp.g_varchar2_table(21023) := '74617465213D3D52242E49646C65297468726F77206E6577204572726F72282243616E74206D6F646966792073706C69747669657722293B746869732E73746174653D52242E427573793B7472797B636F6E7374206E3D556828746869732E7669657749';
wwv_flow_imp.g_varchar2_table(21024) := '74656D732E6C656E677468292E66696C7465722828743D3E74213D3D6529292C693D5B2E2E2E6E2E66696C7465722828653D3E313D3D3D746869732E766965774974656D735B655D2E7072696F7269747929292C655D2C6F3D6E2E66696C746572282865';
wwv_flow_imp.g_varchar2_table(21025) := '3D3E323D3D3D746869732E766965774974656D735B655D2E7072696F7269747929292C733D746869732E766965774974656D735B655D3B743D484428743D4D6174682E726F756E642874292C732E6D696E696D756D53697A652C4D6174682E6D696E2873';
wwv_flow_imp.g_varchar2_table(21026) := '2E6D6178696D756D53697A652C746869732E73697A6529292C732E73697A653D742C746869732E72656C61796F757428692C6F297D66696E616C6C797B746869732E73746174653D52242E49646C657D7D7D646973747269627574655669657753697A65';
wwv_flow_imp.g_varchar2_table(21027) := '7328297B636F6E737420653D5B5D3B6C657420743D303B666F7228636F6E7374206E206F6620746869732E766965774974656D73296E2E6D6178696D756D53697A652D6E2E6D696E696D756D53697A653E30262628652E70757368286E292C742B3D6E2E';
wwv_flow_imp.g_varchar2_table(21028) := '73697A65293B636F6E7374206E3D4D6174682E666C6F6F7228742F652E6C656E677468293B666F7228636F6E73742074206F66206529742E73697A653D4844286E2C742E6D696E696D756D53697A652C742E6D6178696D756D53697A65293B636F6E7374';
wwv_flow_imp.g_varchar2_table(21029) := '20693D556828746869732E766965774974656D732E6C656E677468292C6F3D692E66696C7465722828653D3E313D3D3D746869732E766965774974656D735B655D2E7072696F7269747929292C733D692E66696C7465722828653D3E323D3D3D74686973';
wwv_flow_imp.g_varchar2_table(21030) := '2E766965774974656D735B655D2E7072696F7269747929293B746869732E72656C61796F7574286F2C73297D6765745669657753697A652865297B72657475726E20653C307C7C653E3D746869732E766965774974656D732E6C656E6774683F2D313A74';
wwv_flow_imp.g_varchar2_table(21031) := '6869732E766965774974656D735B655D2E73697A657D646F4164645669657728652C742C6E3D746869732E766965774974656D732E6C656E6774682C69297B696628746869732E7374617465213D3D52242E49646C65297468726F77206E657720457272';
wwv_flow_imp.g_varchar2_table(21032) := '6F72282243616E74206D6F646966792073706C69747669657722293B746869732E73746174653D52242E427573793B7472797B636F6E7374206F3D627228222E73706C69742D766965772D7669657722293B6E3D3D3D746869732E766965774974656D73';
wwv_flow_imp.g_varchar2_table(21033) := '2E6C656E6774683F746869732E76696577436F6E7461696E65722E617070656E644368696C64286F293A746869732E76696577436F6E7461696E65722E696E736572744265666F7265286F2C746869732E76696577436F6E7461696E65722E6368696C64';
wwv_flow_imp.g_varchar2_table(21034) := '72656E2E6974656D286E29293B636F6E737420733D652E6F6E4469644368616E67652828653D3E746869732E6F6E566965774368616E6765286C2C652929292C723D737428732C7274282828293D3E746869732E76696577436F6E7461696E65722E7265';
wwv_flow_imp.g_varchar2_table(21035) := '6D6F76654368696C64286F292929293B6C657420613B226E756D626572223D3D747970656F6620743F613D743A28226175746F223D3D3D742E74797065262628743D746869732E6172655669657773446973747269627574656428293F7B747970653A22';
wwv_flow_imp.g_varchar2_table(21036) := '64697374726962757465227D3A7B747970653A2273706C6974222C696E6465783A742E696E6465787D292C613D2273706C6974223D3D3D742E747970653F746869732E6765745669657753697A6528742E696E646578292F323A22696E76697369626C65';
wwv_flow_imp.g_varchar2_table(21037) := '223D3D3D742E747970653F7B63616368656456697369626C6553697A653A742E63616368656456697369626C6553697A657D3A652E6D696E696D756D53697A65293B636F6E7374206C3D303D3D3D746869732E6F7269656E746174696F6E3F6E65772050';
wwv_flow_imp.g_varchar2_table(21038) := '24286F2C652C612C72293A6E6577204F24286F2C652C612C72293B696628746869732E766965774974656D732E73706C696365286E2C302C6C292C746869732E766965774974656D732E6C656E6774683E31297B636F6E737420653D7B6F7274686F676F';
wwv_flow_imp.g_varchar2_table(21039) := '6E616C5374617274536173683A746869732E6F7274686F676F6E616C5374617274536173682C6F7274686F676F6E616C456E64536173683A746869732E6F7274686F676F6E616C456E64536173687D2C743D303D3D3D746869732E6F7269656E74617469';
wwv_flow_imp.g_varchar2_table(21040) := '6F6E3F6E657720637128746869732E73617368436F6E7461696E65722C7B676574486F72697A6F6E74616C53617368546F703A653D3E746869732E67657453617368506F736974696F6E2865292C676574486F72697A6F6E74616C536173685769647468';
wwv_flow_imp.g_varchar2_table(21041) := '3A746869732E676574536173684F7274686F676F6E616C53697A657D2C7B2E2E2E652C6F7269656E746174696F6E3A317D293A6E657720637128746869732E73617368436F6E7461696E65722C7B676574566572746963616C536173684C6566743A653D';
wwv_flow_imp.g_varchar2_table(21042) := '3E746869732E67657453617368506F736974696F6E2865292C676574566572746963616C536173684865696768743A746869732E676574536173684F7274686F676F6E616C53697A657D2C7B2E2E2E652C6F7269656E746174696F6E3A307D292C693D30';
wwv_flow_imp.g_varchar2_table(21043) := '3D3D3D746869732E6F7269656E746174696F6E3F653D3E287B736173683A742C73746172743A652E7374617274592C63757272656E743A652E63757272656E74592C616C743A652E616C744B65797D293A653D3E287B736173683A742C73746172743A65';
wwv_flow_imp.g_varchar2_table(21044) := '2E7374617274582C63757272656E743A652E63757272656E74582C616C743A652E616C744B65797D292C6F3D76742E6D617028742E6F6E44696453746172742C692928746869732E6F6E5361736853746172742C74686973292C733D76742E6D61702874';
wwv_flow_imp.g_varchar2_table(21045) := '2E6F6E4469644368616E67652C692928746869732E6F6E536173684368616E67652C74686973292C723D76742E6D617028742E6F6E446964456E642C2828293D3E746869732E736173684974656D732E66696E64496E6465782828653D3E652E73617368';
wwv_flow_imp.g_varchar2_table(21046) := '3D3D3D74292929292C613D7228746869732E6F6E53617368456E642C74686973292C6C3D742E6F6E4469645265736574282828293D3E7B636F6E737420653D746869732E736173684974656D732E66696E64496E6465782828653D3E652E736173683D3D';
wwv_flow_imp.g_varchar2_table(21047) := '3D7429292C6E3D556828652C2D31292C693D556828652B312C746869732E766965774974656D732E6C656E677468292C6F3D746869732E66696E644669727374536E6170496E646578286E292C733D746869732E66696E644669727374536E6170496E64';
wwv_flow_imp.g_varchar2_table(21048) := '65782869293B28226E756D62657222213D747970656F66206F7C7C746869732E766965774974656D735B6F5D2E76697369626C6529262628226E756D62657222213D747970656F6620737C7C746869732E766965774974656D735B735D2E76697369626C';
wwv_flow_imp.g_varchar2_table(21049) := '65292626746869732E5F6F6E4469645361736852657365742E666972652865297D29292C633D7374286F2C732C612C6C2C74292C643D7B736173683A742C646973706F7361626C653A637D3B746869732E736173684974656D732E73706C696365286E2D';
wwv_flow_imp.g_varchar2_table(21050) := '312C302C64297D6C657420633B6F2E617070656E644368696C6428652E656C656D656E74292C226E756D62657222213D747970656F66207426262273706C6974223D3D3D742E74797065262628633D5B742E696E6465785D292C697C7C746869732E7265';
wwv_flow_imp.g_varchar2_table(21051) := '6C61796F7574285B6E5D2C63292C697C7C226E756D626572223D3D747970656F6620747C7C226469737472696275746522213D3D742E747970657C7C746869732E646973747269627574655669657753697A657328297D66696E616C6C797B746869732E';
wwv_flow_imp.g_varchar2_table(21052) := '73746174653D52242E49646C657D7D72656C61796F757428652C74297B636F6E7374206E3D746869732E766965774974656D732E726564756365282828652C74293D3E652B742E73697A65292C30293B746869732E726573697A6528746869732E766965';
wwv_flow_imp.g_varchar2_table(21053) := '774974656D732E6C656E6774682D312C746869732E73697A652D6E2C766F696420302C652C74292C746869732E64697374726962757465456D707479537061636528292C746869732E6C61796F7574566965777328292C746869732E7361766550726F70';
wwv_flow_imp.g_varchar2_table(21054) := '6F7274696F6E7328297D726573697A6528652C742C6E3D746869732E766965774974656D732E6D61702828653D3E652E73697A6529292C692C6F2C733D4E756D6265722E4E454741544956455F494E46494E4954592C723D4E756D6265722E504F534954';
wwv_flow_imp.g_varchar2_table(21055) := '4956455F494E46494E4954592C612C6C297B696628653C307C7C653E3D746869732E766965774974656D732E6C656E6774682972657475726E20303B636F6E737420633D556828652C2D31292C643D556828652B312C746869732E766965774974656D73';
wwv_flow_imp.g_varchar2_table(21056) := '2E6C656E677468293B6966286F29666F7228636F6E73742065206F66206F29476828632C65292C476828642C65293B6966286929666F7228636F6E73742065206F66206929516828632C65292C516828642C65293B636F6E737420683D632E6D61702828';
wwv_flow_imp.g_varchar2_table(21057) := '653D3E746869732E766965774974656D735B655D29292C753D632E6D61702828653D3E6E5B655D29292C703D642E6D61702828653D3E746869732E766965774974656D735B655D29292C673D642E6D61702828653D3E6E5B655D29292C6D3D632E726564';
wwv_flow_imp.g_varchar2_table(21058) := '756365282828652C74293D3E652B28746869732E766965774974656D735B745D2E6D696E696D756D53697A652D6E5B745D29292C30292C663D632E726564756365282828652C74293D3E652B28746869732E766965774974656D735B745D2E6D6178696D';
wwv_flow_imp.g_varchar2_table(21059) := '756D53697A652D6E5B745D29292C30292C763D303D3D3D642E6C656E6774683F4E756D6265722E504F5349544956455F494E46494E4954593A642E726564756365282828652C74293D3E652B286E5B745D2D746869732E766965774974656D735B745D2E';
wwv_flow_imp.g_varchar2_table(21060) := '6D696E696D756D53697A6529292C30292C623D303D3D3D642E6C656E6774683F4E756D6265722E4E454741544956455F494E46494E4954593A642E726564756365282828652C74293D3E652B286E5B745D2D746869732E766965774974656D735B745D2E';
wwv_flow_imp.g_varchar2_table(21061) := '6D6178696D756D53697A6529292C30292C5F3D4D6174682E6D6178286D2C622C73292C793D4D6174682E6D696E28762C662C72293B6C657420773D21313B69662861297B636F6E737420653D746869732E766965774974656D735B612E696E6465785D2C';
wwv_flow_imp.g_varchar2_table(21062) := '6E3D743E3D612E6C696D697444656C74613B773D6E213D3D652E76697369626C652C652E73657456697369626C65286E2C612E73697A65297D696628217726266C297B636F6E737420653D746869732E766965774974656D735B6C2E696E6465785D2C6E';
wwv_flow_imp.g_varchar2_table(21063) := '3D743C6C2E6C696D697444656C74613B773D6E213D3D652E76697369626C652C652E73657456697369626C65286E2C6C2E73697A65297D696628772972657475726E20746869732E726573697A6528652C742C6E2C692C6F2C732C72293B666F72286C65';
wwv_flow_imp.g_varchar2_table(21064) := '7420653D302C6E3D743D484428742C5F2C79293B653C682E6C656E6774683B652B2B297B636F6E737420743D685B655D2C693D484428755B655D2B6E2C742E6D696E696D756D53697A652C742E6D6178696D756D53697A65293B6E2D3D692D755B655D2C';
wwv_flow_imp.g_varchar2_table(21065) := '742E73697A653D697D666F72286C657420653D302C6E3D743B653C702E6C656E6774683B652B2B297B636F6E737420743D705B655D2C693D484428675B655D2D6E2C742E6D696E696D756D53697A652C742E6D6178696D756D53697A65293B6E2B3D692D';
wwv_flow_imp.g_varchar2_table(21066) := '675B655D2C742E73697A653D697D72657475726E20747D64697374726962757465456D70747953706163652865297B636F6E737420743D746869732E766965774974656D732E726564756365282828652C74293D3E652B742E73697A65292C30293B6C65';
wwv_flow_imp.g_varchar2_table(21067) := '74206E3D746869732E73697A652D743B636F6E737420693D556828746869732E766965774974656D732E6C656E6774682D312C2D31292C6F3D692E66696C7465722828653D3E313D3D3D746869732E766965774974656D735B655D2E7072696F72697479';
wwv_flow_imp.g_varchar2_table(21068) := '29292C733D692E66696C7465722828653D3E323D3D3D746869732E766965774974656D735B655D2E7072696F7269747929293B666F7228636F6E73742065206F66207329476828692C65293B666F7228636F6E73742065206F66206F29516828692C6529';
wwv_flow_imp.g_varchar2_table(21069) := '3B226E756D626572223D3D747970656F6620652626516828692C65293B666F72286C657420653D303B30213D3D6E2626653C692E6C656E6774683B652B2B297B636F6E737420743D746869732E766965774974656D735B695B655D5D2C6F3D484428742E';
wwv_flow_imp.g_varchar2_table(21070) := '73697A652B6E2C742E6D696E696D756D53697A652C742E6D6178696D756D53697A65293B6E2D3D6F2D742E73697A652C742E73697A653D6F7D7D6C61796F7574566965777328297B746869732E5F636F6E74656E7453697A653D746869732E7669657749';
wwv_flow_imp.g_varchar2_table(21071) := '74656D732E726564756365282828652C74293D3E652B742E73697A65292C30293B6C657420653D303B666F7228636F6E73742074206F6620746869732E766965774974656D7329742E6C61796F757428652C746869732E6C61796F7574436F6E74657874';
wwv_flow_imp.g_varchar2_table(21072) := '292C652B3D742E73697A653B746869732E736173684974656D732E666F72456163682828653D3E652E736173682E6C61796F7574282929292C746869732E75706461746553617368456E61626C656D656E7428292C746869732E7570646174655363726F';
wwv_flow_imp.g_varchar2_table(21073) := '6C6C61626C65456C656D656E7428297D7570646174655363726F6C6C61626C65456C656D656E7428297B303D3D3D746869732E6F7269656E746174696F6E3F746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C44696D656E';
wwv_flow_imp.g_varchar2_table(21074) := '73696F6E73287B6865696768743A746869732E73697A652C7363726F6C6C4865696768743A746869732E5F636F6E74656E7453697A657D293A746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E7328';
wwv_flow_imp.g_varchar2_table(21075) := '7B77696474683A746869732E73697A652C7363726F6C6C57696474683A746869732E5F636F6E74656E7453697A657D297D75706461746553617368456E61626C656D656E7428297B6C657420653D21313B636F6E737420743D746869732E766965774974';
wwv_flow_imp.g_varchar2_table(21076) := '656D732E6D61702828743D3E653D742E73697A652D742E6D696E696D756D53697A653E307C7C6529293B653D21313B636F6E7374206E3D746869732E766965774974656D732E6D61702828743D3E653D742E6D6178696D756D53697A652D742E73697A65';
wwv_flow_imp.g_varchar2_table(21077) := '3E307C7C6529292C693D5B2E2E2E746869732E766965774974656D735D2E7265766572736528293B653D21313B636F6E7374206F3D692E6D61702828743D3E653D742E73697A652D742E6D696E696D756D53697A653E307C7C6529292E72657665727365';
wwv_flow_imp.g_varchar2_table(21078) := '28293B653D21313B636F6E737420733D692E6D61702828743D3E653D742E6D6178696D756D53697A652D742E73697A653E307C7C6529292E7265766572736528293B6C657420723D303B666F72286C657420653D303B653C746869732E73617368497465';
wwv_flow_imp.g_varchar2_table(21079) := '6D732E6C656E6774683B652B2B297B636F6E73747B736173683A697D3D746869732E736173684974656D735B655D3B722B3D746869732E766965774974656D735B655D2E73697A653B636F6E737420613D2128745B655D2626735B652B315D292C6C3D21';
wwv_flow_imp.g_varchar2_table(21080) := '286E5B655D26266F5B652B315D293B6966286126266C297B636F6E7374206E3D556828652C2D31292C733D556828652B312C746869732E766965774974656D732E6C656E677468292C613D746869732E66696E644669727374536E6170496E646578286E';
wwv_flow_imp.g_varchar2_table(21081) := '292C6C3D746869732E66696E644669727374536E6170496E6465782873292C633D226E756D626572223D3D747970656F662061262621746869732E766965774974656D735B615D2E76697369626C652C643D226E756D626572223D3D747970656F66206C';
wwv_flow_imp.g_varchar2_table(21082) := '262621746869732E766965774974656D735B6C5D2E76697369626C653B6326266F5B655D262628723E307C7C746869732E7374617274536E617070696E67456E61626C6564293F692E73746174653D313A642626745B655D262628723C746869732E5F63';
wwv_flow_imp.g_varchar2_table(21083) := '6F6E74656E7453697A657C7C746869732E656E64536E617070696E67456E61626C6564293F692E73746174653D323A692E73746174653D307D656C736520692E73746174653D612626216C3F313A216126266C3F323A337D7D67657453617368506F7369';
wwv_flow_imp.g_varchar2_table(21084) := '74696F6E2865297B6C657420743D303B666F72286C6574206E3D303B6E3C746869732E736173684974656D732E6C656E6774683B6E2B2B29696628742B3D746869732E766965774974656D735B6E5D2E73697A652C746869732E736173684974656D735B';
wwv_flow_imp.g_varchar2_table(21085) := '6E5D2E736173683D3D3D652972657475726E20743B72657475726E20307D66696E644669727374536E6170496E6465782865297B666F7228636F6E73742074206F662065297B636F6E737420653D746869732E766965774974656D735B745D3B69662865';
wwv_flow_imp.g_varchar2_table(21086) := '2E76697369626C652626652E736E61702972657475726E20747D666F7228636F6E73742074206F662065297B636F6E737420653D746869732E766965774974656D735B745D3B696628652E76697369626C652626652E6D6178696D756D53697A652D652E';
wwv_flow_imp.g_varchar2_table(21087) := '6D696E696D756D53697A653E302972657475726E3B69662821652E76697369626C652626652E736E61702972657475726E20747D7D6172655669657773446973747269627574656428297B6C657420652C743B666F7228636F6E7374206E206F66207468';
wwv_flow_imp.g_varchar2_table(21088) := '69732E766965774974656D7329696628653D766F696420303D3D3D653F6E2E73697A653A4D6174682E6D696E28652C6E2E73697A65292C743D766F696420303D3D3D743F6E2E73697A653A4D6174682E6D617828742C6E2E73697A65292C742D653E3229';
wwv_flow_imp.g_varchar2_table(21089) := '72657475726E21313B72657475726E21307D646973706F736528297B76617220653B6E756C6C3D3D3D28653D746869732E73617368447261675374617465297C7C766F696420303D3D3D657C7C652E646973706F7361626C652E646973706F736528292C';
wwv_flow_imp.g_varchar2_table(21090) := '6F7428746869732E766965774974656D73292C746869732E766965774974656D733D5B5D2C746869732E736173684974656D732E666F72456163682828653D3E652E646973706F7361626C652E646973706F7365282929292C746869732E736173684974';
wwv_flow_imp.g_varchar2_table(21091) := '656D733D5B5D2C73757065722E646973706F736528297D7D7661722056243D6E2834323334292C7A243D7B7D3B7A242E7374796C655461675472616E73666F726D3D6A7228292C7A242E736574417474726962757465733D567228292C7A242E696E7365';
wwv_flow_imp.g_varchar2_table(21092) := '72743D467228292E62696E64286E756C6C2C226865616422292C7A242E646F6D4150493D4F7228292C7A242E696E736572745374796C65456C656D656E743D487228292C4E7228292856242E412C7A24292C56242E41262656242E412E6C6F63616C7326';
wwv_flow_imp.g_varchar2_table(21093) := '2656242E412E6C6F63616C733B636C6173732048247B636F6E7374727563746F7228652C742C6E297B746869732E636F6C756D6E733D652C746869732E676574436F6C756D6E53697A653D6E2C746869732E74656D706C61746549643D48242E54656D70';
wwv_flow_imp.g_varchar2_table(21094) := '6C61746549642C746869732E72656E646572656454656D706C617465733D6E6577205365743B636F6E737420693D6E6577204D617028742E6D61702828653D3E5B652E74656D706C61746549642C655D2929293B746869732E72656E6465726572733D5B';
wwv_flow_imp.g_varchar2_table(21095) := '5D3B666F7228636F6E73742074206F662065297B636F6E737420653D692E67657428742E74656D706C6174654964293B6966282165297468726F77206E6577204572726F7228605461626C652063656C6C2072656E646572657220666F722074656D706C';
wwv_flow_imp.g_varchar2_table(21096) := '61746520696420247B742E74656D706C61746549647D206E6F7420666F756E642E60293B746869732E72656E6465726572732E707573682865297D7D72656E64657254656D706C6174652865297B636F6E737420743D757228652C627228222E6D6F6E61';
wwv_flow_imp.g_varchar2_table(21097) := '636F2D7461626C652D74722229292C6E3D5B5D2C693D5B5D3B666F72286C657420653D303B653C746869732E636F6C756D6E732E6C656E6774683B652B2B297B636F6E7374206F3D746869732E72656E6465726572735B655D2C733D757228742C627228';
wwv_flow_imp.g_varchar2_table(21098) := '222E6D6F6E61636F2D7461626C652D7464222C7B22646174612D636F6C2D696E646578223A657D29293B732E7374796C652E77696474683D60247B746869732E676574436F6C756D6E53697A652865297D7078602C6E2E707573682873292C692E707573';
wwv_flow_imp.g_varchar2_table(21099) := '68286F2E72656E64657254656D706C617465287329297D636F6E7374206F3D7B636F6E7461696E65723A652C63656C6C436F6E7461696E6572733A6E2C63656C6C54656D706C617465446174613A697D3B72657475726E20746869732E72656E64657265';
wwv_flow_imp.g_varchar2_table(21100) := '6454656D706C617465732E616464286F292C6F7D72656E646572456C656D656E7428652C742C6E2C69297B666F72286C6574206F3D303B6F3C746869732E636F6C756D6E732E6C656E6774683B6F2B2B297B636F6E737420733D746869732E636F6C756D';
wwv_flow_imp.g_varchar2_table(21101) := '6E735B6F5D2E70726F6A6563742865293B746869732E72656E6465726572735B6F5D2E72656E646572456C656D656E7428732C742C6E2E63656C6C54656D706C617465446174615B6F5D2C69297D7D646973706F7365456C656D656E7428652C742C6E2C';
wwv_flow_imp.g_varchar2_table(21102) := '69297B666F72286C6574206F3D303B6F3C746869732E636F6C756D6E732E6C656E6774683B6F2B2B297B636F6E737420733D746869732E72656E6465726572735B6F5D3B696628732E646973706F7365456C656D656E74297B636F6E737420723D746869';
wwv_flow_imp.g_varchar2_table(21103) := '732E636F6C756D6E735B6F5D2E70726F6A6563742865293B732E646973706F7365456C656D656E7428722C742C6E2E63656C6C54656D706C617465446174615B6F5D2C69297D7D7D646973706F736554656D706C6174652865297B666F72286C65742074';
wwv_flow_imp.g_varchar2_table(21104) := '3D303B743C746869732E636F6C756D6E732E6C656E6774683B742B2B29746869732E72656E6465726572735B745D2E646973706F736554656D706C61746528652E63656C6C54656D706C617465446174615B745D293B667328652E636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(21105) := '292C746869732E72656E646572656454656D706C617465732E64656C6574652865297D6C61796F7574436F6C756D6E28652C74297B666F7228636F6E73747B63656C6C436F6E7461696E6572733A6E7D6F6620746869732E72656E646572656454656D70';
wwv_flow_imp.g_varchar2_table(21106) := '6C61746573296E5B655D2E7374796C652E77696474683D60247B747D7078607D7D48242E54656D706C61746549643D22726F77223B636C61737320572420657874656E6473206C747B676574206D696E696D756D53697A6528297B76617220653B726574';
wwv_flow_imp.g_varchar2_table(21107) := '75726E206E756C6C213D3D28653D746869732E636F6C756D6E2E6D696E696D756D5769647468292626766F69642030213D3D653F653A3132307D676574206D6178696D756D53697A6528297B76617220653B72657475726E206E756C6C213D3D28653D74';
wwv_flow_imp.g_varchar2_table(21108) := '6869732E636F6C756D6E2E6D6178696D756D5769647468292626766F69642030213D3D653F653A4E756D6265722E504F5349544956455F494E46494E4954597D676574206F6E4469644368616E676528297B76617220653B72657475726E206E756C6C21';
wwv_flow_imp.g_varchar2_table(21109) := '3D3D28653D746869732E636F6C756D6E2E6F6E4469644368616E67655769647468436F6E73747261696E7473292626766F69642030213D3D653F653A76742E4E6F6E657D636F6E7374727563746F7228652C74297B737570657228292C746869732E636F';
wwv_flow_imp.g_varchar2_table(21110) := '6C756D6E3D652C746869732E696E6465783D742C746869732E5F6F6E4469644C61796F75743D6E65772043742C746869732E6F6E4469644C61796F75743D746869732E5F6F6E4469644C61796F75742E6576656E742C746869732E656C656D656E743D62';
wwv_flow_imp.g_varchar2_table(21111) := '7228222E6D6F6E61636F2D7461626C652D7468222C7B22646174612D636F6C2D696E646578223A747D2C652E6C6162656C292C652E746F6F6C7469702626746869732E5F726567697374657228564528292E7365747570557064617461626C65486F7665';
wwv_flow_imp.g_varchar2_table(21112) := '7228504528226D6F75736522292C746869732E656C656D656E742C652E746F6F6C74697029297D6C61796F75742865297B746869732E5F6F6E4469644C61796F75742E66697265285B746869732E696E6465782C655D297D7D636C617373206A247B6765';
wwv_flow_imp.g_varchar2_table(21113) := '74206F6E4469644368616E6765466F63757328297B72657475726E20746869732E6C6973742E6F6E4469644368616E6765466F6375737D676574206F6E4469644368616E676553656C656374696F6E28297B72657475726E20746869732E6C6973742E6F';
wwv_flow_imp.g_varchar2_table(21114) := '6E4469644368616E676553656C656374696F6E7D676574206F6E4469645363726F6C6C28297B72657475726E20746869732E6C6973742E6F6E4469645363726F6C6C7D676574206F6E4D6F75736544626C436C69636B28297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(21115) := '2E6C6973742E6F6E4D6F75736544626C436C69636B7D676574206F6E506F696E74657228297B72657475726E20746869732E6C6973742E6F6E506F696E7465727D676574206F6E446964466F63757328297B72657475726E20746869732E6C6973742E6F';
wwv_flow_imp.g_varchar2_table(21116) := '6E446964466F6375737D676574207363726F6C6C546F7028297B72657475726E20746869732E6C6973742E7363726F6C6C546F707D736574207363726F6C6C546F702865297B746869732E6C6973742E7363726F6C6C546F703D657D676574207363726F';
wwv_flow_imp.g_varchar2_table(21117) := '6C6C48656967687428297B72657475726E20746869732E6C6973742E7363726F6C6C4865696768747D6765742072656E64657248656967687428297B72657475726E20746869732E6C6973742E72656E6465724865696768747D676574206F6E44696444';
wwv_flow_imp.g_varchar2_table(21118) := '6973706F736528297B72657475726E20746869732E6C6973742E6F6E446964446973706F73657D636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E7669727475616C44656C65676174653D6E2C746869732E646F6D49643D2274';
wwv_flow_imp.g_varchar2_table(21119) := '61626C655F69645F222B202B2B6A242E496E7374616E6365436F756E742C746869732E646973706F7361626C65733D6E65772061742C746869732E63616368656457696474683D302C746869732E6361636865644865696768743D302C746869732E646F';
wwv_flow_imp.g_varchar2_table(21120) := '6D4E6F64653D757228742C627228602E6D6F6E61636F2D7461626C652E247B746869732E646F6D49647D6029293B636F6E737420723D692E6D6170282828652C74293D3E746869732E646973706F7361626C65732E616464286E657720572428652C7429';
wwv_flow_imp.g_varchar2_table(21121) := '2929292C613D7B73697A653A722E726564756365282828652C74293D3E652B742E636F6C756D6E2E776569676874292C30292C76696577733A722E6D61702828653D3E287B73697A653A652E636F6C756D6E2E7765696768742C766965773A657D292929';
wwv_flow_imp.g_varchar2_table(21122) := '7D3B746869732E73706C6974766965773D746869732E646973706F7361626C65732E616464286E657720422428746869732E646F6D4E6F64652C7B6F7269656E746174696F6E3A312C7363726F6C6C6261725669736962696C6974793A322C6765745361';
wwv_flow_imp.g_varchar2_table(21123) := '73684F7274686F676F6E616C53697A653A28293D3E746869732E6361636865644865696768742C64657363726970746F723A617D29292C746869732E73706C6974766965772E656C2E7374796C652E6865696768743D60247B6E2E686561646572526F77';
wwv_flow_imp.g_varchar2_table(21124) := '4865696768747D7078602C746869732E73706C6974766965772E656C2E7374796C652E6C696E654865696768743D60247B6E2E686561646572526F774865696768747D7078603B636F6E7374206C3D6E657720482428692C6F2C28653D3E746869732E73';
wwv_flow_imp.g_varchar2_table(21125) := '706C6974766965772E6765745669657753697A6528652929293B76617220633B746869732E6C6973743D746869732E646973706F7361626C65732E616464286E657720554928652C746869732E646F6D4E6F64652C28633D6E2C7B676574486569676874';
wwv_flow_imp.g_varchar2_table(21126) := '3A653D3E632E6765744865696768742865292C67657454656D706C61746549643A28293D3E48242E54656D706C61746549647D292C5B6C5D2C7329292C76742E616E79282E2E2E722E6D61702828653D3E652E6F6E4469644C61796F7574292929282828';
wwv_flow_imp.g_varchar2_table(21127) := '5B652C745D293D3E6C2E6C61796F7574436F6C756D6E28652C7429292C6E756C6C2C746869732E646973706F7361626C6573292C746869732E73706C6974766965772E6F6E4469645361736852657365742828653D3E7B636F6E737420743D692E726564';
wwv_flow_imp.g_varchar2_table(21128) := '756365282828652C74293D3E652B742E776569676874292C30292C6E3D695B655D2E7765696768742F742A746869732E63616368656457696474683B746869732E73706C6974766965772E726573697A655669657728652C6E297D292C6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(21129) := '69732E646973706F7361626C6573292C746869732E7374796C65456C656D656E743D597328746869732E646F6D4E6F6465292C746869732E7374796C65285649297D7570646174654F7074696F6E732865297B746869732E6C6973742E7570646174654F';
wwv_flow_imp.g_varchar2_table(21130) := '7074696F6E732865297D73706C69636528652C742C6E3D5B5D297B746869732E6C6973742E73706C69636528652C742C6E297D67657448544D4C456C656D656E7428297B72657475726E20746869732E646F6D4E6F64657D7374796C652865297B636F6E';
wwv_flow_imp.g_varchar2_table(21131) := '737420743D5B5D3B742E7075736828602E6D6F6E61636F2D7461626C652E247B746869732E646F6D49647D203E202E6D6F6E61636F2D73706C69742D7669657732202E6D6F6E61636F2D736173682E766572746963616C3A3A6265666F7265207B5C6E5C';
wwv_flow_imp.g_varchar2_table(21132) := '745C745C74746F703A20247B746869732E7669727475616C44656C65676174652E686561646572526F774865696768742B317D70783B5C6E5C745C745C746865696768743A2063616C632831303025202D20247B746869732E7669727475616C44656C65';
wwv_flow_imp.g_varchar2_table(21133) := '676174652E686561646572526F774865696768747D7078293B5C6E5C745C747D60292C746869732E7374796C65456C656D656E742E74657874436F6E74656E743D742E6A6F696E28225C6E22292C746869732E6C6973742E7374796C652865297D676574';
wwv_flow_imp.g_varchar2_table(21134) := '53656C6563746564456C656D656E747328297B72657475726E20746869732E6C6973742E67657453656C6563746564456C656D656E747328297D67657453656C656374696F6E28297B72657475726E20746869732E6C6973742E67657453656C65637469';
wwv_flow_imp.g_varchar2_table(21135) := '6F6E28297D676574466F63757328297B72657475726E20746869732E6C6973742E676574466F63757328297D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528297D7D6A242E496E7374616E6365436F756E743D30';
wwv_flow_imp.g_varchar2_table(21136) := '3B7661722071243D6E2832353136292C24243D7B7D3B24242E7374796C655461675472616E73666F726D3D6A7228292C24242E736574417474726962757465733D567228292C24242E696E736572743D467228292E62696E64286E756C6C2C2268656164';
wwv_flow_imp.g_varchar2_table(21137) := '22292C24242E646F6D4150493D4F7228292C24242E696E736572745374796C65456C656D656E743D487228292C4E7228292871242E412C2424292C71242E41262671242E412E6C6F63616C73262671242E412E6C6F63616C733B636C6173732055242065';
wwv_flow_imp.g_varchar2_table(21138) := '7874656E64732047447B636F6E7374727563746F722865297B76617220743B737570657228292C746869732E5F6F6E4368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4368616E67653D746869732E5F6F6E43';
wwv_flow_imp.g_varchar2_table(21139) := '68616E67652E6576656E742C746869732E5F6F6E4B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4B6579446F776E3D746869732E5F6F6E4B6579446F776E2E6576656E742C746869732E5F6F7074733D65';
wwv_flow_imp.g_varchar2_table(21140) := '2C746869732E5F636865636B65643D746869732E5F6F7074732E6973436865636B65643B636F6E7374206E3D5B226D6F6E61636F2D637573746F6D2D746F67676C65225D3B746869732E5F6F7074732E69636F6E262628746869732E5F69636F6E3D7468';
wwv_flow_imp.g_varchar2_table(21141) := '69732E5F6F7074732E69636F6E2C6E2E70757368282E2E2E546C2E6173436C6173734E616D65417272617928746869732E5F69636F6E2929292C746869732E5F6F7074732E616374696F6E436C6173734E616D6526266E2E70757368282E2E2E74686973';
wwv_flow_imp.g_varchar2_table(21142) := '2E5F6F7074732E616374696F6E436C6173734E616D652E73706C69742822202229292C746869732E5F636865636B656426266E2E707573682822636865636B656422292C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D';
wwv_flow_imp.g_varchar2_table(21143) := '656E74282264697622292C746869732E5F686F7665723D746869732E5F726567697374657228564528292E7365747570557064617461626C65486F766572286E756C6C213D3D28743D652E686F76657244656C6567617465292626766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(21144) := '743F743A504528226D6F75736522292C746869732E646F6D4E6F64652C746869732E5F6F7074732E7469746C6529292C746869732E646F6D4E6F64652E636C6173734C6973742E616464282E2E2E6E292C746869732E5F6F7074732E6E6F74466F637573';
wwv_flow_imp.g_varchar2_table(21145) := '61626C657C7C28746869732E646F6D4E6F64652E746162496E6465783D30292C746869732E646F6D4E6F64652E7365744174747269627574652822726F6C65222C22636865636B626F7822292C746869732E646F6D4E6F64652E73657441747472696275';
wwv_flow_imp.g_varchar2_table(21146) := '74652822617269612D636865636B6564222C537472696E6728746869732E5F636865636B656429292C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D6C6162656C222C746869732E5F6F7074732E7469746C65292C7468';
wwv_flow_imp.g_varchar2_table(21147) := '69732E6170706C795374796C657328292C746869732E6F6E636C69636B28746869732E646F6D4E6F64652C28653D3E7B746869732E656E61626C6564262628746869732E636865636B65643D21746869732E5F636865636B65642C746869732E5F6F6E43';
wwv_flow_imp.g_varchar2_table(21148) := '68616E67652E66697265282131292C652E70726576656E7444656661756C742829297D29292C746869732E5F726567697374657228746869732E69676E6F72654765737475726528746869732E646F6D4E6F646529292C746869732E6F6E6B6579646F77';
wwv_flow_imp.g_varchar2_table(21149) := '6E28746869732E646F6D4E6F64652C28653D3E7B69662831303D3D3D652E6B6579436F64657C7C333D3D3D652E6B6579436F64652972657475726E20746869732E636865636B65643D21746869732E5F636865636B65642C746869732E5F6F6E4368616E';
wwv_flow_imp.g_varchar2_table(21150) := '67652E66697265282130292C652E70726576656E7444656661756C7428292C766F696420652E73746F7050726F7061676174696F6E28293B746869732E5F6F6E4B6579446F776E2E666972652865297D29297D67657420656E61626C656428297B726574';
wwv_flow_imp.g_varchar2_table(21151) := '75726E227472756522213D3D746869732E646F6D4E6F64652E6765744174747269627574652822617269612D64697361626C656422297D666F63757328297B746869732E646F6D4E6F64652E666F63757328297D67657420636865636B656428297B7265';
wwv_flow_imp.g_varchar2_table(21152) := '7475726E20746869732E5F636865636B65647D73657420636865636B65642865297B746869732E5F636865636B65643D652C746869732E646F6D4E6F64652E7365744174747269627574652822617269612D636865636B6564222C537472696E67287468';
wwv_flow_imp.g_varchar2_table(21153) := '69732E5F636865636B656429292C746869732E646F6D4E6F64652E636C6173734C6973742E746F67676C652822636865636B6564222C746869732E5F636865636B6564292C746869732E6170706C795374796C657328297D776964746828297B72657475';
wwv_flow_imp.g_varchar2_table(21154) := '726E2032327D6170706C795374796C657328297B746869732E646F6D4E6F6465262628746869732E646F6D4E6F64652E7374796C652E626F72646572436F6C6F723D746869732E5F636865636B65642626746869732E5F6F7074732E696E707574416374';
wwv_flow_imp.g_varchar2_table(21155) := '6976654F7074696F6E426F726465727C7C22222C746869732E646F6D4E6F64652E7374796C652E636F6C6F723D746869732E5F636865636B65642626746869732E5F6F7074732E696E7075744163746976654F7074696F6E466F726567726F756E647C7C';
wwv_flow_imp.g_varchar2_table(21156) := '22696E6865726974222C746869732E646F6D4E6F64652E7374796C652E6261636B67726F756E64436F6C6F723D746869732E5F636865636B65642626746869732E5F6F7074732E696E7075744163746976654F7074696F6E4261636B67726F756E647C7C';
wwv_flow_imp.g_varchar2_table(21157) := '2222297D656E61626C6528297B746869732E646F6D4E6F64652E7365744174747269627574652822617269612D64697361626C6564222C537472696E6728213129297D64697361626C6528297B746869732E646F6D4E6F64652E73657441747472696275';
wwv_flow_imp.g_varchar2_table(21158) := '74652822617269612D64697361626C6564222C537472696E6728213029297D7D636F6E7374204B243D6228302C224D61746368204361736522292C47243D6228302C224D617463682057686F6C6520576F726422292C51243D6228302C22557365205265';
wwv_flow_imp.g_varchar2_table(21159) := '67756C61722045787072657373696F6E22293B636C61737320592420657874656E64732055247B636F6E7374727563746F722865297B76617220743B7375706572287B69636F6E3A4C6C2E6361736553656E7369746976652C7469746C653A4B242B652E';
wwv_flow_imp.g_varchar2_table(21160) := '617070656E645469746C652C6973436865636B65643A652E6973436865636B65642C686F76657244656C65676174653A6E756C6C213D3D28743D652E686F76657244656C6567617465292626766F69642030213D3D743F743A50452822656C656D656E74';
wwv_flow_imp.g_varchar2_table(21161) := '22292C696E7075744163746976654F7074696F6E426F726465723A652E696E7075744163746976654F7074696F6E426F726465722C696E7075744163746976654F7074696F6E466F726567726F756E643A652E696E7075744163746976654F7074696F6E';
wwv_flow_imp.g_varchar2_table(21162) := '466F726567726F756E642C696E7075744163746976654F7074696F6E4261636B67726F756E643A652E696E7075744163746976654F7074696F6E4261636B67726F756E647D297D7D636C617373205A2420657874656E64732055247B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(21163) := '746F722865297B76617220743B7375706572287B69636F6E3A4C6C2E77686F6C65576F72642C7469746C653A47242B652E617070656E645469746C652C6973436865636B65643A652E6973436865636B65642C686F76657244656C65676174653A6E756C';
wwv_flow_imp.g_varchar2_table(21164) := '6C213D3D28743D652E686F76657244656C6567617465292626766F69642030213D3D743F743A50452822656C656D656E7422292C696E7075744163746976654F7074696F6E426F726465723A652E696E7075744163746976654F7074696F6E426F726465';
wwv_flow_imp.g_varchar2_table(21165) := '722C696E7075744163746976654F7074696F6E466F726567726F756E643A652E696E7075744163746976654F7074696F6E466F726567726F756E642C696E7075744163746976654F7074696F6E4261636B67726F756E643A652E696E7075744163746976';
wwv_flow_imp.g_varchar2_table(21166) := '654F7074696F6E4261636B67726F756E647D297D7D636C61737320582420657874656E64732055247B636F6E7374727563746F722865297B76617220743B7375706572287B69636F6E3A4C6C2E72656765782C7469746C653A51242B652E617070656E64';
wwv_flow_imp.g_varchar2_table(21167) := '5469746C652C6973436865636B65643A652E6973436865636B65642C686F76657244656C65676174653A6E756C6C213D3D28743D652E686F76657244656C6567617465292626766F69642030213D3D743F743A50452822656C656D656E7422292C696E70';
wwv_flow_imp.g_varchar2_table(21168) := '75744163746976654F7074696F6E426F726465723A652E696E7075744163746976654F7074696F6E426F726465722C696E7075744163746976654F7074696F6E466F726567726F756E643A652E696E7075744163746976654F7074696F6E466F72656772';
wwv_flow_imp.g_varchar2_table(21169) := '6F756E642C696E7075744163746976654F7074696F6E4261636B67726F756E643A652E696E7075744163746976654F7074696F6E4261636B67726F756E647D297D7D636C617373204A247B636F6E7374727563746F7228652C743D302C6E3D652E6C656E';
wwv_flow_imp.g_varchar2_table(21170) := '6774682C693D742D31297B746869732E6974656D733D652C746869732E73746172743D742C746869732E656E643D6E2C746869732E696E6465783D697D63757272656E7428297B72657475726E20746869732E696E6465783D3D3D746869732E73746172';
wwv_flow_imp.g_varchar2_table(21171) := '742D317C7C746869732E696E6465783D3D3D746869732E656E643F6E756C6C3A746869732E6974656D735B746869732E696E6465785D7D6E65787428297B72657475726E20746869732E696E6465783D4D6174682E6D696E28746869732E696E6465782B';
wwv_flow_imp.g_varchar2_table(21172) := '312C746869732E656E64292C746869732E63757272656E7428297D70726576696F757328297B72657475726E20746869732E696E6465783D4D6174682E6D617828746869732E696E6465782D312C746869732E73746172742D31292C746869732E637572';
wwv_flow_imp.g_varchar2_table(21173) := '72656E7428297D666972737428297B72657475726E20746869732E696E6465783D746869732E73746172742C746869732E63757272656E7428297D6C61737428297B72657475726E20746869732E696E6465783D746869732E656E642D312C746869732E';
wwv_flow_imp.g_varchar2_table(21174) := '63757272656E7428297D7D636C6173732065557B636F6E7374727563746F7228653D5B5D2C743D3130297B746869732E5F696E697469616C697A652865292C746869732E5F6C696D69743D742C746869732E5F6F6E4368616E676528297D676574486973';
wwv_flow_imp.g_varchar2_table(21175) := '746F727928297B72657475726E20746869732E5F656C656D656E74737D6164642865297B746869732E5F686973746F72792E64656C6574652865292C746869732E5F686973746F72792E6164642865292C746869732E5F6F6E4368616E676528297D6E65';
wwv_flow_imp.g_varchar2_table(21176) := '787428297B72657475726E20746869732E5F6E6176696761746F722E6E65787428297D70726576696F757328297B72657475726E2030213D3D746869732E5F63757272656E74506F736974696F6E28293F746869732E5F6E6176696761746F722E707265';
wwv_flow_imp.g_varchar2_table(21177) := '76696F757328293A6E756C6C7D63757272656E7428297B72657475726E20746869732E5F6E6176696761746F722E63757272656E7428297D666972737428297B72657475726E20746869732E5F6E6176696761746F722E666972737428297D6C61737428';
wwv_flow_imp.g_varchar2_table(21178) := '297B72657475726E20746869732E5F6E6176696761746F722E6C61737428297D69734C61737428297B72657475726E20746869732E5F63757272656E74506F736974696F6E28293E3D746869732E5F656C656D656E74732E6C656E6774682D317D69734E';
wwv_flow_imp.g_varchar2_table(21179) := '6F776865726528297B72657475726E206E756C6C3D3D3D746869732E5F6E6176696761746F722E63757272656E7428297D6861732865297B72657475726E20746869732E5F686973746F72792E6861732865297D5F6F6E4368616E676528297B74686973';
wwv_flow_imp.g_varchar2_table(21180) := '2E5F726564756365546F4C696D697428293B636F6E737420653D746869732E5F656C656D656E74733B746869732E5F6E6176696761746F723D6E6577204A2428652C302C652E6C656E6774682C652E6C656E677468297D5F726564756365546F4C696D69';
wwv_flow_imp.g_varchar2_table(21181) := '7428297B636F6E737420653D746869732E5F656C656D656E74733B652E6C656E6774683E746869732E5F6C696D69742626746869732E5F696E697469616C697A6528652E736C69636528652E6C656E6774682D746869732E5F6C696D697429297D5F6375';
wwv_flow_imp.g_varchar2_table(21182) := '7272656E74506F736974696F6E28297B636F6E737420653D746869732E5F6E6176696761746F722E63757272656E7428293B72657475726E20653F746869732E5F656C656D656E74732E696E6465784F662865293A2D317D5F696E697469616C697A6528';
wwv_flow_imp.g_varchar2_table(21183) := '65297B746869732E5F686973746F72793D6E6577205365743B666F7228636F6E73742074206F66206529746869732E5F686973746F72792E6164642874297D676574205F656C656D656E747328297B636F6E737420653D5B5D3B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(21184) := '732E5F686973746F72792E666F72456163682828743D3E652E7075736828742929292C657D7D7661722074553D6E2831333636292C6E553D7B7D3B6E552E7374796C655461675472616E73666F726D3D6A7228292C6E552E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(21185) := '733D567228292C6E552E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6E552E646F6D4150493D4F7228292C6E552E696E736572745374796C65456C656D656E743D487228292C4E7228292874552E412C6E55292C74552E41';
wwv_flow_imp.g_varchar2_table(21186) := '262674552E412E6C6F63616C73262674552E412E6C6F63616C733B636F6E73742069553D62723B636C617373206F5520657874656E64732047447B636F6E7374727563746F7228652C742C6E297B76617220693B737570657228292C746869732E737461';
wwv_flow_imp.g_varchar2_table(21187) := '74653D2269646C65222C746869732E6D61784865696768743D4E756D6265722E504F5349544956455F494E46494E4954592C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469';
wwv_flow_imp.g_varchar2_table(21188) := '644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F6F6E4469644865696768744368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644865696768744368616E67';
wwv_flow_imp.g_varchar2_table(21189) := '653D746869732E5F6F6E4469644865696768744368616E67652E6576656E742C746869732E636F6E746578745669657750726F76696465723D742C746869732E6F7074696F6E733D6E2C746869732E6D6573736167653D6E756C6C2C746869732E706C61';
wwv_flow_imp.g_varchar2_table(21190) := '6365686F6C6465723D746869732E6F7074696F6E732E706C616365686F6C6465727C7C22222C746869732E746F6F6C7469703D6E756C6C213D3D28693D746869732E6F7074696F6E732E746F6F6C746970292626766F69642030213D3D693F693A746869';
wwv_flow_imp.g_varchar2_table(21191) := '732E706C616365686F6C6465727C7C22222C746869732E617269614C6162656C3D746869732E6F7074696F6E732E617269614C6162656C7C7C22222C746869732E6F7074696F6E732E76616C69646174696F6E4F7074696F6E73262628746869732E7661';
wwv_flow_imp.g_varchar2_table(21192) := '6C69646174696F6E3D746869732E6F7074696F6E732E76616C69646174696F6E4F7074696F6E732E76616C69646174696F6E292C746869732E656C656D656E743D757228652C695528222E6D6F6E61636F2D696E707574626F782E69646C652229293B63';
wwv_flow_imp.g_varchar2_table(21193) := '6F6E7374206F3D746869732E6F7074696F6E732E666C657869626C654865696768743F227465787461726561223A22696E707574222C733D757228746869732E656C656D656E742C695528222E6962777261707065722229293B696628746869732E696E';
wwv_flow_imp.g_varchar2_table(21194) := '7075743D757228732C6955286F2B222E696E7075742E656D7074792229292C746869732E696E7075742E73657441747472696275746528226175746F636F7272656374222C226F666622292C746869732E696E7075742E73657441747472696275746528';
wwv_flow_imp.g_varchar2_table(21195) := '226175746F6361706974616C697A65222C226F666622292C746869732E696E7075742E73657441747472696275746528227370656C6C636865636B222C2266616C736522292C746869732E6F6E666F63757328746869732E696E7075742C2828293D3E74';
wwv_flow_imp.g_varchar2_table(21196) := '6869732E656C656D656E742E636C6173734C6973742E616464282273796E7468657469632D666F637573222929292C746869732E6F6E626C757228746869732E696E7075742C2828293D3E746869732E656C656D656E742E636C6173734C6973742E7265';
wwv_flow_imp.g_varchar2_table(21197) := '6D6F7665282273796E7468657469632D666F637573222929292C746869732E6F7074696F6E732E666C657869626C65486569676874297B746869732E6D61784865696768743D226E756D626572223D3D747970656F6620746869732E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(21198) := '666C657869626C654D61784865696768743F746869732E6F7074696F6E732E666C657869626C654D61784865696768743A4E756D6265722E504F5349544956455F494E46494E4954592C746869732E6D6972726F723D757228732C695528226469762E6D';
wwv_flow_imp.g_varchar2_table(21199) := '6972726F722229292C746869732E6D6972726F722E696E6E6572546578743D22C2A0222C746869732E7363726F6C6C61626C65456C656D656E743D6E657720755428746869732E656C656D656E742C7B766572746963616C3A317D292C746869732E6F70';
wwv_flow_imp.g_varchar2_table(21200) := '74696F6E732E666C657869626C655769647468262628746869732E696E7075742E736574417474726962757465282277726170222C226F666622292C746869732E6D6972726F722E7374796C652E776869746553706163653D22707265222C746869732E';
wwv_flow_imp.g_varchar2_table(21201) := '6D6972726F722E7374796C652E776F7264577261703D22696E697469616C22292C757228652C746869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F64652829292C746869732E5F726567697374657228746869732E7363726F6C';
wwv_flow_imp.g_varchar2_table(21202) := '6C61626C65456C656D656E74292C746869732E5F726567697374657228746869732E7363726F6C6C61626C65456C656D656E742E6F6E5363726F6C6C2828653D3E746869732E696E7075742E7363726F6C6C546F703D652E7363726F6C6C546F70292929';
wwv_flow_imp.g_varchar2_table(21203) := '3B636F6E737420743D746869732E5F7265676973746572286E6577204B5328652E6F776E6572446F63756D656E742C2273656C656374696F6E6368616E67652229292C6E3D76742E66696C74657228742E6576656E742C2828293D3E7B636F6E73742074';
wwv_flow_imp.g_varchar2_table(21204) := '3D652E6F776E6572446F63756D656E742E67657453656C656374696F6E28293B72657475726E286E756C6C3D3D743F766F696420303A742E616E63686F724E6F6465293D3D3D737D29293B746869732E5F7265676973746572286E28746869732E757064';
wwv_flow_imp.g_varchar2_table(21205) := '6174655363726F6C6C44696D656E73696F6E732C7468697329292C746869732E5F726567697374657228746869732E6F6E4469644865696768744368616E676528746869732E7570646174655363726F6C6C44696D656E73696F6E732C7468697329297D';
wwv_flow_imp.g_varchar2_table(21206) := '656C736520746869732E696E7075742E747970653D746869732E6F7074696F6E732E747970657C7C2274657874222C746869732E696E7075742E736574417474726962757465282277726170222C226F666622293B746869732E617269614C6162656C26';
wwv_flow_imp.g_varchar2_table(21207) := '26746869732E696E7075742E7365744174747269627574652822617269612D6C6162656C222C746869732E617269614C6162656C292C746869732E706C616365686F6C646572262621746869732E6F7074696F6E732E73686F77506C616365686F6C6465';
wwv_flow_imp.g_varchar2_table(21208) := '724F6E466F6375732626746869732E736574506C616365486F6C64657228746869732E706C616365686F6C646572292C746869732E746F6F6C7469702626746869732E736574546F6F6C74697028746869732E746F6F6C746970292C746869732E6F6E69';
wwv_flow_imp.g_varchar2_table(21209) := '6E70757428746869732E696E7075742C2828293D3E746869732E6F6E56616C75654368616E6765282929292C746869732E6F6E626C757228746869732E696E7075742C2828293D3E746869732E6F6E426C7572282929292C746869732E6F6E666F637573';
wwv_flow_imp.g_varchar2_table(21210) := '28746869732E696E7075742C2828293D3E746869732E6F6E466F637573282929292C746869732E5F726567697374657228746869732E69676E6F72654765737475726528746869732E696E70757429292C73657454696D656F7574282828293D3E746869';
wwv_flow_imp.g_varchar2_table(21211) := '732E7570646174654D6972726F722829292C30292C746869732E6F7074696F6E732E616374696F6E73262628746869732E616374696F6E6261723D746869732E5F7265676973746572286E6577206C4D28746869732E656C656D656E7429292C74686973';
wwv_flow_imp.g_varchar2_table(21212) := '2E616374696F6E6261722E7075736828746869732E6F7074696F6E732E616374696F6E732C7B69636F6E3A21302C6C6162656C3A21317D29292C746869732E6170706C795374796C657328297D6F6E426C757228297B746869732E5F686964654D657373';
wwv_flow_imp.g_varchar2_table(21213) := '61676528292C746869732E6F7074696F6E732E73686F77506C616365686F6C6465724F6E466F6375732626746869732E696E7075742E7365744174747269627574652822706C616365686F6C646572222C2222297D6F6E466F63757328297B746869732E';
wwv_flow_imp.g_varchar2_table(21214) := '5F73686F774D65737361676528292C746869732E6F7074696F6E732E73686F77506C616365686F6C6465724F6E466F6375732626746869732E696E7075742E7365744174747269627574652822706C616365686F6C646572222C746869732E706C616365';
wwv_flow_imp.g_varchar2_table(21215) := '686F6C6465727C7C2222297D736574506C616365486F6C6465722865297B746869732E706C616365686F6C6465723D652C746869732E696E7075742E7365744174747269627574652822706C616365686F6C646572222C65297D736574546F6F6C746970';
wwv_flow_imp.g_varchar2_table(21216) := '2865297B746869732E746F6F6C7469703D652C746869732E686F7665723F746869732E686F7665722E7570646174652865293A746869732E686F7665723D746869732E5F726567697374657228564528292E7365747570557064617461626C65486F7665';
wwv_flow_imp.g_varchar2_table(21217) := '7228504528226D6F75736522292C746869732E696E7075742C6529297D67657420696E707574456C656D656E7428297B72657475726E20746869732E696E7075747D6765742076616C756528297B72657475726E20746869732E696E7075742E76616C75';
wwv_flow_imp.g_varchar2_table(21218) := '657D7365742076616C75652865297B746869732E696E7075742E76616C7565213D3D65262628746869732E696E7075742E76616C75653D652C746869732E6F6E56616C75654368616E67652829297D6765742068656967687428297B72657475726E226E';
wwv_flow_imp.g_varchar2_table(21219) := '756D626572223D3D747970656F6620746869732E6361636865644865696768743F746869732E6361636865644865696768743A467328746869732E656C656D656E74297D666F63757328297B746869732E696E7075742E666F63757328297D626C757228';
wwv_flow_imp.g_varchar2_table(21220) := '297B746869732E696E7075742E626C757228297D686173466F63757328297B72657475726E20717328746869732E696E707574297D73656C65637428653D6E756C6C297B746869732E696E7075742E73656C65637428292C65262628746869732E696E70';
wwv_flow_imp.g_varchar2_table(21221) := '75742E73657453656C656374696F6E52616E676528652E73746172742C652E656E64292C652E656E643D3D3D746869732E696E7075742E76616C75652E6C656E677468262628746869732E696E7075742E7363726F6C6C4C6566743D746869732E696E70';
wwv_flow_imp.g_varchar2_table(21222) := '75742E7363726F6C6C576964746829297D697353656C656374696F6E4174456E6428297B72657475726E20746869732E696E7075742E73656C656374696F6E456E643D3D3D746869732E696E7075742E76616C75652E6C656E6774682626746869732E69';
wwv_flow_imp.g_varchar2_table(21223) := '6E7075742E73656C656374696F6E53746172743D3D3D746869732E696E7075742E73656C656374696F6E456E647D67657453656C656374696F6E28297B76617220653B636F6E737420743D746869732E696E7075742E73656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(21224) := '3B72657475726E206E756C6C3D3D3D743F6E756C6C3A7B73746172743A742C656E643A6E756C6C213D3D28653D746869732E696E7075742E73656C656374696F6E456E64292626766F69642030213D3D653F653A747D7D656E61626C6528297B74686973';
wwv_flow_imp.g_varchar2_table(21225) := '2E696E7075742E72656D6F7665417474726962757465282264697361626C656422297D64697361626C6528297B746869732E626C757228292C746869732E696E7075742E64697361626C65643D21302C746869732E5F686964654D65737361676528297D';
wwv_flow_imp.g_varchar2_table(21226) := '7365742070616464696E6752696768742865297B746869732E696E7075742E7374796C652E77696474683D6063616C632831303025202D20247B657D707829602C746869732E6D6972726F72262628746869732E6D6972726F722E7374796C652E706164';
wwv_flow_imp.g_varchar2_table(21227) := '64696E6752696768743D652B22707822297D7570646174655363726F6C6C44696D656E73696F6E7328297B696628226E756D62657222213D747970656F6620746869732E636163686564436F6E74656E744865696768747C7C226E756D62657222213D74';
wwv_flow_imp.g_varchar2_table(21228) := '7970656F6620746869732E6361636865644865696768747C7C21746869732E7363726F6C6C61626C65456C656D656E742972657475726E3B636F6E737420653D746869732E636163686564436F6E74656E744865696768742C743D746869732E63616368';
wwv_flow_imp.g_varchar2_table(21229) := '65644865696768742C6E3D746869732E696E7075742E7363726F6C6C546F703B746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E73287B7363726F6C6C4865696768743A652C6865696768743A747D';
wwv_flow_imp.g_varchar2_table(21230) := '292C746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A6E7D297D73686F774D65737361676528652C74297B696628226F70656E223D3D3D746869732E7374617465262677';
wwv_flow_imp.g_varchar2_table(21231) := '6828746869732E6D6573736167652C65292972657475726E3B746869732E6D6573736167653D652C746869732E656C656D656E742E636C6173734C6973742E72656D6F7665282269646C6522292C746869732E656C656D656E742E636C6173734C697374';
wwv_flow_imp.g_varchar2_table(21232) := '2E72656D6F76652822696E666F22292C746869732E656C656D656E742E636C6173734C6973742E72656D6F766528227761726E696E6722292C746869732E656C656D656E742E636C6173734C6973742E72656D6F766528226572726F7222292C74686973';
wwv_flow_imp.g_varchar2_table(21233) := '2E656C656D656E742E636C6173734C6973742E61646428746869732E636C617373466F725479706528652E7479706529293B636F6E7374206E3D746869732E7374796C6573466F725479706528746869732E6D6573736167652E74797065293B74686973';
wwv_flow_imp.g_varchar2_table(21234) := '2E656C656D656E742E7374796C652E626F726465723D6031707820736F6C696420247B6B72286E2E626F726465722C227472616E73706172656E7422297D602C746869732E6D6573736167652E636F6E74656E74262628746869732E686173466F637573';
wwv_flow_imp.g_varchar2_table(21235) := '28297C7C74292626746869732E5F73686F774D65737361676528297D686964654D65737361676528297B746869732E6D6573736167653D6E756C6C2C746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822696E666F22292C7468';
wwv_flow_imp.g_varchar2_table(21236) := '69732E656C656D656E742E636C6173734C6973742E72656D6F766528227761726E696E6722292C746869732E656C656D656E742E636C6173734C6973742E72656D6F766528226572726F7222292C746869732E656C656D656E742E636C6173734C697374';
wwv_flow_imp.g_varchar2_table(21237) := '2E616464282269646C6522292C746869732E5F686964654D65737361676528292C746869732E6170706C795374796C657328297D76616C696461746528297B6C657420653D6E756C6C3B72657475726E20746869732E76616C69646174696F6E26262865';
wwv_flow_imp.g_varchar2_table(21238) := '3D746869732E76616C69646174696F6E28746869732E76616C7565292C653F28746869732E696E707574456C656D656E742E7365744174747269627574652822617269612D696E76616C6964222C227472756522292C746869732E73686F774D65737361';
wwv_flow_imp.g_varchar2_table(21239) := '6765286529293A746869732E696E707574456C656D656E742E6861734174747269627574652822617269612D696E76616C69642229262628746869732E696E707574456C656D656E742E72656D6F76654174747269627574652822617269612D696E7661';
wwv_flow_imp.g_varchar2_table(21240) := '6C696422292C746869732E686964654D657373616765282929292C6E756C6C3D3D653F766F696420303A652E747970657D7374796C6573466F72547970652865297B636F6E737420743D746869732E6F7074696F6E732E696E707574426F785374796C65';
wwv_flow_imp.g_varchar2_table(21241) := '733B7377697463682865297B6361736520313A72657475726E7B626F726465723A742E696E70757456616C69646174696F6E496E666F426F726465722C6261636B67726F756E643A742E696E70757456616C69646174696F6E496E666F4261636B67726F';
wwv_flow_imp.g_varchar2_table(21242) := '756E642C666F726567726F756E643A742E696E70757456616C69646174696F6E496E666F466F726567726F756E647D3B6361736520323A72657475726E7B626F726465723A742E696E70757456616C69646174696F6E5761726E696E67426F726465722C';
wwv_flow_imp.g_varchar2_table(21243) := '6261636B67726F756E643A742E696E70757456616C69646174696F6E5761726E696E674261636B67726F756E642C666F726567726F756E643A742E696E70757456616C69646174696F6E5761726E696E67466F726567726F756E647D3B64656661756C74';
wwv_flow_imp.g_varchar2_table(21244) := '3A72657475726E7B626F726465723A742E696E70757456616C69646174696F6E4572726F72426F726465722C6261636B67726F756E643A742E696E70757456616C69646174696F6E4572726F724261636B67726F756E642C666F726567726F756E643A74';
wwv_flow_imp.g_varchar2_table(21245) := '2E696E70757456616C69646174696F6E4572726F72466F726567726F756E647D7D7D636C617373466F72547970652865297B7377697463682865297B6361736520313A72657475726E22696E666F223B6361736520323A72657475726E227761726E696E';
wwv_flow_imp.g_varchar2_table(21246) := '67223B64656661756C743A72657475726E226572726F72227D7D5F73686F774D65737361676528297B69662821746869732E636F6E746578745669657750726F76696465727C7C21746869732E6D6573736167652972657475726E3B6C657420653B636F';
wwv_flow_imp.g_varchar2_table(21247) := '6E737420743D28293D3E652E7374796C652E77696474683D507328746869732E656C656D656E74292B227078223B6C6574206E3B746869732E636F6E746578745669657750726F76696465722E73686F77436F6E7465787456696577287B676574416E63';
wwv_flow_imp.g_varchar2_table(21248) := '686F723A28293D3E746869732E656C656D656E742C616E63686F72416C69676E6D656E743A312C72656E6465723A6E3D3E7B76617220692C6F3B69662821746869732E6D6573736167652972657475726E206E756C6C3B653D7572286E2C695528222E6D';
wwv_flow_imp.g_varchar2_table(21249) := '6F6E61636F2D696E707574626F782D636F6E7461696E65722229292C7428293B636F6E737420733D7B696E6C696E653A21302C636C6173734E616D653A226D6F6E61636F2D696E707574626F782D6D657373616765227D2C723D746869732E6D65737361';
wwv_flow_imp.g_varchar2_table(21250) := '67652E666F726D6174436F6E74656E743F766B28746869732E6D6573736167652E636F6E74656E742C73293A66756E6374696F6E28652C743D7B7D297B636F6E7374206E3D626B2874293B72657475726E206E2E74657874436F6E74656E743D652C6E7D';
wwv_flow_imp.g_varchar2_table(21251) := '28746869732E6D6573736167652E636F6E74656E742C73293B722E636C6173734C6973742E61646428746869732E636C617373466F725479706528746869732E6D6573736167652E7479706529293B636F6E737420613D746869732E7374796C6573466F';
wwv_flow_imp.g_varchar2_table(21252) := '725479706528746869732E6D6573736167652E74797065293B72657475726E20722E7374796C652E6261636B67726F756E64436F6C6F723D6E756C6C213D3D28693D612E6261636B67726F756E64292626766F69642030213D3D693F693A22222C722E73';
wwv_flow_imp.g_varchar2_table(21253) := '74796C652E636F6C6F723D6E756C6C213D3D286F3D612E666F726567726F756E64292626766F69642030213D3D6F3F6F3A22222C722E7374796C652E626F726465723D612E626F726465723F6031707820736F6C696420247B612E626F726465727D603A';
wwv_flow_imp.g_varchar2_table(21254) := '22222C757228652C72292C6E756C6C7D2C6F6E486964653A28293D3E7B746869732E73746174653D22636C6F736564227D2C6C61796F75743A747D292C6E3D333D3D3D746869732E6D6573736167652E747970653F6228302C224572726F723A207B307D';
wwv_flow_imp.g_varchar2_table(21255) := '222C746869732E6D6573736167652E636F6E74656E74293A323D3D3D746869732E6D6573736167652E747970653F6228302C225761726E696E673A207B307D222C746869732E6D6573736167652E636F6E74656E74293A6228302C22496E666F3A207B30';
wwv_flow_imp.g_varchar2_table(21256) := '7D222C746869732E6D6573736167652E636F6E74656E74292C5872286E292C746869732E73746174653D226F70656E227D5F686964654D65737361676528297B746869732E636F6E746578745669657750726F7669646572262628226F70656E223D3D3D';
wwv_flow_imp.g_varchar2_table(21257) := '746869732E73746174652626746869732E636F6E746578745669657750726F76696465722E68696465436F6E746578745669657728292C746869732E73746174653D2269646C6522297D6F6E56616C75654368616E676528297B746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(21258) := '644368616E67652E6669726528746869732E76616C7565292C746869732E76616C696461746528292C746869732E7570646174654D6972726F7228292C746869732E696E7075742E636C6173734C6973742E746F67676C652822656D707479222C217468';
wwv_flow_imp.g_varchar2_table(21259) := '69732E76616C7565292C226F70656E223D3D3D746869732E73746174652626746869732E636F6E746578745669657750726F76696465722626746869732E636F6E746578745669657750726F76696465722E6C61796F757428297D7570646174654D6972';
wwv_flow_imp.g_varchar2_table(21260) := '726F7228297B69662821746869732E6D6972726F722972657475726E3B636F6E737420653D746869732E76616C75652C743D31303D3D3D652E63686172436F6465417428652E6C656E6774682D31293F2220223A22223B28652B74292E7265706C616365';
wwv_flow_imp.g_varchar2_table(21261) := '282F5C75303030632F672C2222293F746869732E6D6972726F722E74657874436F6E74656E743D652B743A746869732E6D6972726F722E696E6E6572546578743D22C2A0222C746869732E6C61796F757428297D6170706C795374796C657328297B7661';
wwv_flow_imp.g_varchar2_table(21262) := '7220652C742C6E3B636F6E737420693D746869732E6F7074696F6E732E696E707574426F785374796C65732C6F3D6E756C6C213D3D28653D692E696E7075744261636B67726F756E64292626766F69642030213D3D653F653A22222C733D6E756C6C213D';
wwv_flow_imp.g_varchar2_table(21263) := '3D28743D692E696E707574466F726567726F756E64292626766F69642030213D3D743F743A22222C723D6E756C6C213D3D286E3D692E696E707574426F72646572292626766F69642030213D3D6E3F6E3A22223B746869732E656C656D656E742E737479';
wwv_flow_imp.g_varchar2_table(21264) := '6C652E6261636B67726F756E64436F6C6F723D6F2C746869732E656C656D656E742E7374796C652E636F6C6F723D732C746869732E696E7075742E7374796C652E6261636B67726F756E64436F6C6F723D22696E6865726974222C746869732E696E7075';
wwv_flow_imp.g_varchar2_table(21265) := '742E7374796C652E636F6C6F723D732C746869732E656C656D656E742E7374796C652E626F726465723D6031707820736F6C696420247B6B7228722C227472616E73706172656E7422297D607D6C61796F757428297B69662821746869732E6D6972726F';
wwv_flow_imp.g_varchar2_table(21266) := '722972657475726E3B636F6E737420653D746869732E636163686564436F6E74656E744865696768743B746869732E636163686564436F6E74656E744865696768743D467328746869732E6D6972726F72292C65213D3D746869732E636163686564436F';
wwv_flow_imp.g_varchar2_table(21267) := '6E74656E74486569676874262628746869732E6361636865644865696768743D4D6174682E6D696E28746869732E636163686564436F6E74656E744865696768742C746869732E6D6178486569676874292C746869732E696E7075742E7374796C652E68';
wwv_flow_imp.g_varchar2_table(21268) := '65696768743D746869732E6361636865644865696768742B227078222C746869732E5F6F6E4469644865696768744368616E67652E6669726528746869732E636163686564436F6E74656E7448656967687429297D696E736572744174437572736F7228';
wwv_flow_imp.g_varchar2_table(21269) := '65297B636F6E737420743D746869732E696E707574456C656D656E742C6E3D742E73656C656374696F6E53746172742C693D742E73656C656374696F6E456E642C6F3D742E76616C75653B6E756C6C213D3D6E26266E756C6C213D3D6926262874686973';
wwv_flow_imp.g_varchar2_table(21270) := '2E76616C75653D6F2E73756273747228302C6E292B652B6F2E7375627374722869292C742E73657453656C656374696F6E52616E6765286E2B312C6E2B31292C746869732E6C61796F75742829297D646973706F736528297B76617220653B746869732E';
wwv_flow_imp.g_varchar2_table(21271) := '5F686964654D65737361676528292C746869732E6D6573736167653D6E756C6C2C6E756C6C3D3D3D28653D746869732E616374696F6E626172297C7C766F696420303D3D3D657C7C652E646973706F736528292C73757065722E646973706F736528297D';
wwv_flow_imp.g_varchar2_table(21272) := '7D636C61737320735520657874656E6473206F557B636F6E7374727563746F7228652C742C6E297B636F6E737420693D6228302C22206F72207B307D20666F7220686973746F7279222C22E2878522292C6F3D6228302C2220287B307D20666F72206869';
wwv_flow_imp.g_varchar2_table(21273) := '73746F727929222C22E2878522293B737570657228652C742C6E292C746869732E5F6F6E446964466F6375733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964466F6375733D746869732E5F6F6E446964466F637573';
wwv_flow_imp.g_varchar2_table(21274) := '2E6576656E742C746869732E5F6F6E446964426C75723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964426C75723D746869732E5F6F6E446964426C75722E6576656E742C746869732E686973746F72793D6E657720';
wwv_flow_imp.g_varchar2_table(21275) := '6555286E2E686973746F72792C313030293B636F6E737420733D28293D3E7B6966286E2E73686F77486973746F727948696E7426266E2E73686F77486973746F727948696E742829262621746869732E706C616365686F6C6465722E656E647357697468';
wwv_flow_imp.g_varchar2_table(21276) := '286929262621746869732E706C616365686F6C6465722E656E647357697468286F292626746869732E686973746F72792E676574486973746F727928292E6C656E677468297B636F6E737420653D746869732E706C616365686F6C6465722E656E647357';
wwv_flow_imp.g_varchar2_table(21277) := '69746828222922293F693A6F2C743D746869732E706C616365686F6C6465722B653B6E2E73686F77506C616365686F6C6465724F6E466F637573262621717328746869732E696E707574293F746869732E706C616365686F6C6465723D743A746869732E';
wwv_flow_imp.g_varchar2_table(21278) := '736574506C616365486F6C6465722874297D7D3B746869732E6F627365727665723D6E6577204D75746174696F6E4F62736572766572282828652C74293D3E7B652E666F72456163682828653D3E7B652E7461726765742E74657874436F6E74656E747C';
wwv_flow_imp.g_varchar2_table(21279) := '7C7328297D29297D29292C746869732E6F627365727665722E6F62736572766528746869732E696E7075742C7B61747472696275746546696C7465723A5B22636C617373225D7D292C746869732E6F6E666F63757328746869732E696E7075742C282829';
wwv_flow_imp.g_varchar2_table(21280) := '3D3E73282929292C746869732E6F6E626C757228746869732E696E7075742C2828293D3E7B636F6E737420653D653D3E7B696628746869732E706C616365686F6C6465722E656E647357697468286529297B636F6E737420743D746869732E706C616365';
wwv_flow_imp.g_varchar2_table(21281) := '686F6C6465722E736C69636528302C746869732E706C616365686F6C6465722E6C656E6774682D652E6C656E677468293B72657475726E206E2E73686F77506C616365686F6C6465724F6E466F6375733F746869732E706C616365686F6C6465723D743A';
wwv_flow_imp.g_varchar2_table(21282) := '746869732E736574506C616365486F6C6465722874292C21307D72657475726E21317D3B65286F297C7C652869297D29297D646973706F736528297B73757065722E646973706F736528292C746869732E6F62736572766572262628746869732E6F6273';
wwv_flow_imp.g_varchar2_table(21283) := '65727665722E646973636F6E6E65637428292C746869732E6F627365727665723D766F69642030297D616464546F486973746F72792865297B746869732E76616C7565262628657C7C746869732E76616C7565213D3D746869732E67657443757272656E';
wwv_flow_imp.g_varchar2_table(21284) := '7456616C75652829292626746869732E686973746F72792E61646428746869732E76616C7565297D697341744C617374496E486973746F727928297B72657475726E20746869732E686973746F72792E69734C61737428297D69734E6F7768657265496E';
wwv_flow_imp.g_varchar2_table(21285) := '486973746F727928297B72657475726E20746869732E686973746F72792E69734E6F776865726528297D73686F774E65787456616C756528297B746869732E686973746F72792E68617328746869732E76616C7565297C7C746869732E616464546F4869';
wwv_flow_imp.g_varchar2_table(21286) := '73746F727928293B6C657420653D746869732E6765744E65787456616C756528293B65262628653D653D3D3D746869732E76616C75653F746869732E6765744E65787456616C756528293A65292C746869732E76616C75653D6E756C6C213D653F653A22';
wwv_flow_imp.g_varchar2_table(21287) := '222C4A7228746869732E76616C75653F746869732E76616C75653A6228302C22436C656172656420496E7075742229297D73686F7750726576696F757356616C756528297B746869732E686973746F72792E68617328746869732E76616C7565297C7C74';
wwv_flow_imp.g_varchar2_table(21288) := '6869732E616464546F486973746F727928293B6C657420653D746869732E67657450726576696F757356616C756528293B65262628653D653D3D3D746869732E76616C75653F746869732E67657450726576696F757356616C756528293A65292C652626';
wwv_flow_imp.g_varchar2_table(21289) := '28746869732E76616C75653D652C4A7228746869732E76616C756529297D736574506C616365486F6C6465722865297B73757065722E736574506C616365486F6C6465722865292C746869732E736574546F6F6C7469702865297D6F6E426C757228297B';
wwv_flow_imp.g_varchar2_table(21290) := '73757065722E6F6E426C757228292C746869732E5F6F6E446964426C75722E6669726528297D6F6E466F63757328297B73757065722E6F6E466F63757328292C746869732E5F6F6E446964466F6375732E6669726528297D67657443757272656E745661';
wwv_flow_imp.g_varchar2_table(21291) := '6C756528297B6C657420653D746869732E686973746F72792E63757272656E7428293B72657475726E20657C7C28653D746869732E686973746F72792E6C61737428292C746869732E686973746F72792E6E6578742829292C657D67657450726576696F';
wwv_flow_imp.g_varchar2_table(21292) := '757356616C756528297B72657475726E20746869732E686973746F72792E70726576696F757328297C7C746869732E686973746F72792E666972737428297D6765744E65787456616C756528297B72657475726E20746869732E686973746F72792E6E65';
wwv_flow_imp.g_varchar2_table(21293) := '787428297D7D7661722072553D6E2838343734292C61553D7B7D3B61552E7374796C655461675472616E73666F726D3D6A7228292C61552E736574417474726962757465733D567228292C61552E696E736572743D467228292E62696E64286E756C6C2C';
wwv_flow_imp.g_varchar2_table(21294) := '226865616422292C61552E646F6D4150493D4F7228292C61552E696E736572745374796C65456C656D656E743D487228292C4E7228292872552E412C6155292C72552E41262672552E412E6C6F63616C73262672552E412E6C6F63616C733B636F6E7374';
wwv_flow_imp.g_varchar2_table(21295) := '206C553D6228302C22696E70757422293B636C61737320635520657874656E64732047447B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65643D2130';
wwv_flow_imp.g_varchar2_table(21296) := '2C746869732E696D6553657373696F6E496E50726F67726573733D21312C746869732E6164646974696F6E616C546F67676C6573446973706F7361626C65733D746869732E5F7265676973746572286E6577206374292C746869732E6164646974696F6E';
wwv_flow_imp.g_varchar2_table(21297) := '616C546F67676C65733D5B5D2C746869732E5F6F6E4469644F7074696F6E4368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644F7074696F6E4368616E67653D746869732E5F6F6E4469644F7074696F6E';
wwv_flow_imp.g_varchar2_table(21298) := '4368616E67652E6576656E742C746869732E5F6F6E4B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4B6579446F776E3D746869732E5F6F6E4B6579446F776E2E6576656E742C746869732E5F6F6E4D6F75';
wwv_flow_imp.g_varchar2_table(21299) := '7365446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4D6F757365446F776E3D746869732E5F6F6E4D6F757365446F776E2E6576656E742C746869732E5F6F6E496E7075743D746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(21300) := '6E6577204374292C746869732E5F6F6E4B657955703D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E4361736553656E7369746976654B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869';
wwv_flow_imp.g_varchar2_table(21301) := '732E6F6E4361736553656E7369746976654B6579446F776E3D746869732E5F6F6E4361736553656E7369746976654B6579446F776E2E6576656E742C746869732E5F6F6E52656765784B6579446F776E3D746869732E5F7265676973746572286E657720';
wwv_flow_imp.g_varchar2_table(21302) := '4374292C746869732E6F6E52656765784B6579446F776E3D746869732E5F6F6E52656765784B6579446F776E2E6576656E742C746869732E5F6C617374486967686C6967687446696E644F7074696F6E733D302C746869732E706C616365686F6C646572';
wwv_flow_imp.g_varchar2_table(21303) := '3D6E2E706C616365686F6C6465727C7C22222C746869732E76616C69646174696F6E3D6E2E76616C69646174696F6E2C746869732E6C6162656C3D6E2E6C6162656C7C7C6C552C746869732E73686F77436F6D6D6F6E46696E64546F67676C65733D2121';
wwv_flow_imp.g_varchar2_table(21304) := '6E2E73686F77436F6D6D6F6E46696E64546F67676C65733B636F6E737420693D6E2E617070656E644361736553656E7369746976654C6162656C7C7C22222C6F3D6E2E617070656E6457686F6C65576F7264734C6162656C7C7C22222C733D6E2E617070';
wwv_flow_imp.g_varchar2_table(21305) := '656E6452656765784C6162656C7C7C22222C723D6E2E686973746F72797C7C5B5D2C613D21216E2E666C657869626C654865696768742C6C3D21216E2E666C657869626C6557696474682C633D6E2E666C657869626C654D61784865696768743B746869';
wwv_flow_imp.g_varchar2_table(21306) := '732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D4E6F64652E636C6173734C6973742E61646428226D6F6E61636F2D66696E64496E70757422292C746869732E696E707574426F78';
wwv_flow_imp.g_varchar2_table(21307) := '3D746869732E5F7265676973746572286E657720735528746869732E646F6D4E6F64652C742C7B706C616365686F6C6465723A746869732E706C616365686F6C6465727C7C22222C617269614C6162656C3A746869732E6C6162656C7C7C22222C76616C';
wwv_flow_imp.g_varchar2_table(21308) := '69646174696F6E4F7074696F6E733A7B76616C69646174696F6E3A746869732E76616C69646174696F6E7D2C686973746F72793A722C73686F77486973746F727948696E743A6E2E73686F77486973746F727948696E742C666C657869626C6548656967';
wwv_flow_imp.g_varchar2_table(21309) := '68743A612C666C657869626C6557696474683A6C2C666C657869626C654D61784865696768743A632C696E707574426F785374796C65733A6E2E696E707574426F785374796C65737D29293B636F6E737420643D746869732E5F7265676973746572284F';
wwv_flow_imp.g_varchar2_table(21310) := '452829293B696628746869732E73686F77436F6D6D6F6E46696E64546F67676C6573297B746869732E72656765783D746869732E5F7265676973746572286E6577205824287B617070656E645469746C653A732C6973436865636B65643A21312C686F76';
wwv_flow_imp.g_varchar2_table(21311) := '657244656C65676174653A642C2E2E2E6E2E746F67676C655374796C65737D29292C746869732E5F726567697374657228746869732E72656765782E6F6E4368616E67652828653D3E7B746869732E5F6F6E4469644F7074696F6E4368616E67652E6669';
wwv_flow_imp.g_varchar2_table(21312) := '72652865292C21652626746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65642626746869732E696E707574426F782E666F63757328292C746869732E76616C696461746528297D2929292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(21313) := '7228746869732E72656765782E6F6E4B6579446F776E2828653D3E7B746869732E5F6F6E52656765784B6579446F776E2E666972652865297D2929292C746869732E77686F6C65576F7264733D746869732E5F7265676973746572286E6577205A24287B';
wwv_flow_imp.g_varchar2_table(21314) := '617070656E645469746C653A6F2C6973436865636B65643A21312C686F76657244656C65676174653A642C2E2E2E6E2E746F67676C655374796C65737D29292C746869732E5F726567697374657228746869732E77686F6C65576F7264732E6F6E436861';
wwv_flow_imp.g_varchar2_table(21315) := '6E67652828653D3E7B746869732E5F6F6E4469644F7074696F6E4368616E67652E666972652865292C21652626746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65642626746869732E696E707574426F782E666F63757328';
wwv_flow_imp.g_varchar2_table(21316) := '292C746869732E76616C696461746528297D2929292C746869732E6361736553656E7369746976653D746869732E5F7265676973746572286E6577205924287B617070656E645469746C653A692C6973436865636B65643A21312C686F76657244656C65';
wwv_flow_imp.g_varchar2_table(21317) := '676174653A642C2E2E2E6E2E746F67676C655374796C65737D29292C746869732E5F726567697374657228746869732E6361736553656E7369746976652E6F6E4368616E67652828653D3E7B746869732E5F6F6E4469644F7074696F6E4368616E67652E';
wwv_flow_imp.g_varchar2_table(21318) := '666972652865292C21652626746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65642626746869732E696E707574426F782E666F63757328292C746869732E76616C696461746528297D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(21319) := '74657228746869732E6361736553656E7369746976652E6F6E4B6579446F776E2828653D3E7B746869732E5F6F6E4361736553656E7369746976654B6579446F776E2E666972652865297D2929293B636F6E737420653D5B746869732E6361736553656E';
wwv_flow_imp.g_varchar2_table(21320) := '7369746976652E646F6D4E6F64652C746869732E77686F6C65576F7264732E646F6D4E6F64652C746869732E72656765782E646F6D4E6F64655D3B746869732E6F6E6B6579646F776E28746869732E646F6D4E6F64652C28743D3E7B696628742E657175';
wwv_flow_imp.g_varchar2_table(21321) := '616C73283135297C7C742E657175616C73283137297C7C742E657175616C73283929297B636F6E7374206E3D652E696E6465784F6628746869732E646F6D4E6F64652E6F776E6572446F63756D656E742E616374697665456C656D656E74293B6966286E';
wwv_flow_imp.g_varchar2_table(21322) := '3E3D30297B6C657420693D2D313B742E657175616C73283137293F693D286E2B312925652E6C656E6774683A742E657175616C7328313529262628693D303D3D3D6E3F652E6C656E6774682D313A6E2D31292C742E657175616C732839293F28655B6E5D';
wwv_flow_imp.g_varchar2_table(21323) := '2E626C757228292C746869732E696E707574426F782E666F6375732829293A693E3D302626655B695D2E666F63757328292C637228742C2130297D7D7D29297D746869732E636F6E74726F6C733D646F63756D656E742E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(21324) := '282264697622292C746869732E636F6E74726F6C732E636C6173734E616D653D22636F6E74726F6C73222C746869732E636F6E74726F6C732E7374796C652E646973706C61793D746869732E73686F77436F6D6D6F6E46696E64546F67676C65733F2222';
wwv_flow_imp.g_varchar2_table(21325) := '3A226E6F6E65222C746869732E6361736553656E7369746976652626746869732E636F6E74726F6C732E617070656E6428746869732E6361736553656E7369746976652E646F6D4E6F6465292C746869732E77686F6C65576F7264732626746869732E63';
wwv_flow_imp.g_varchar2_table(21326) := '6F6E74726F6C732E617070656E644368696C6428746869732E77686F6C65576F7264732E646F6D4E6F6465292C746869732E72656765782626746869732E636F6E74726F6C732E617070656E644368696C6428746869732E72656765782E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(21327) := '65292C746869732E7365744164646974696F6E616C546F67676C6573286E756C6C3D3D6E3F766F696420303A6E2E6164646974696F6E616C546F67676C6573292C746869732E636F6E74726F6C732626746869732E646F6D4E6F64652E617070656E6443';
wwv_flow_imp.g_varchar2_table(21328) := '68696C6428746869732E636F6E74726F6C73292C6E756C6C3D3D657C7C652E617070656E644368696C6428746869732E646F6D4E6F6465292C746869732E5F726567697374657228627328746869732E696E707574426F782E696E707574456C656D656E';
wwv_flow_imp.g_varchar2_table(21329) := '742C22636F6D706F736974696F6E7374617274222C28653D3E7B746869732E696D6553657373696F6E496E50726F67726573733D21307D2929292C746869732E5F726567697374657228627328746869732E696E707574426F782E696E707574456C656D';
wwv_flow_imp.g_varchar2_table(21330) := '656E742C22636F6D706F736974696F6E656E64222C28653D3E7B746869732E696D6553657373696F6E496E50726F67726573733D21312C746869732E5F6F6E496E7075742E6669726528297D2929292C746869732E6F6E6B6579646F776E28746869732E';
wwv_flow_imp.g_varchar2_table(21331) := '696E707574426F782E696E707574456C656D656E742C28653D3E746869732E5F6F6E4B6579446F776E2E6669726528652929292C746869732E6F6E6B6579757028746869732E696E707574426F782E696E707574456C656D656E742C28653D3E74686973';
wwv_flow_imp.g_varchar2_table(21332) := '2E5F6F6E4B657955702E6669726528652929292C746869732E6F6E696E70757428746869732E696E707574426F782E696E707574456C656D656E742C28653D3E746869732E5F6F6E496E7075742E66697265282929292C746869732E6F6E6D6F75736564';
wwv_flow_imp.g_varchar2_table(21333) := '6F776E28746869732E696E707574426F782E696E707574456C656D656E742C28653D3E746869732E5F6F6E4D6F757365446F776E2E6669726528652929297D676574206F6E4469644368616E676528297B72657475726E20746869732E696E707574426F';
wwv_flow_imp.g_varchar2_table(21334) := '782E6F6E4469644368616E67657D6C61796F75742865297B746869732E696E707574426F782E6C61796F757428292C746869732E757064617465496E707574426F7850616464696E6728652E636F6C6C617073656446696E64576964676574297D656E61';
wwv_flow_imp.g_varchar2_table(21335) := '626C6528297B76617220652C742C6E3B746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F7665282264697361626C656422292C746869732E696E707574426F782E656E61626C6528292C6E756C6C3D3D3D28653D746869732E72656765';
wwv_flow_imp.g_varchar2_table(21336) := '78297C7C766F696420303D3D3D657C7C652E656E61626C6528292C6E756C6C3D3D3D28743D746869732E77686F6C65576F726473297C7C766F696420303D3D3D747C7C742E656E61626C6528292C6E756C6C3D3D3D286E3D746869732E6361736553656E';
wwv_flow_imp.g_varchar2_table(21337) := '736974697665297C7C766F696420303D3D3D6E7C7C6E2E656E61626C6528293B666F7228636F6E73742065206F6620746869732E6164646974696F6E616C546F67676C657329652E656E61626C6528297D64697361626C6528297B76617220652C742C6E';
wwv_flow_imp.g_varchar2_table(21338) := '3B746869732E646F6D4E6F64652E636C6173734C6973742E616464282264697361626C656422292C746869732E696E707574426F782E64697361626C6528292C6E756C6C3D3D3D28653D746869732E7265676578297C7C766F696420303D3D3D657C7C65';
wwv_flow_imp.g_varchar2_table(21339) := '2E64697361626C6528292C6E756C6C3D3D3D28743D746869732E77686F6C65576F726473297C7C766F696420303D3D3D747C7C742E64697361626C6528292C6E756C6C3D3D3D286E3D746869732E6361736553656E736974697665297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(21340) := '3D3D3D6E7C7C6E2E64697361626C6528293B666F7228636F6E73742065206F6620746869732E6164646974696F6E616C546F67676C657329652E64697361626C6528297D736574466F637573496E7075744F6E4F7074696F6E436C69636B2865297B7468';
wwv_flow_imp.g_varchar2_table(21341) := '69732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65643D657D736574456E61626C65642865297B653F746869732E656E61626C6528293A746869732E64697361626C6528297D7365744164646974696F6E616C546F67676C657328';
wwv_flow_imp.g_varchar2_table(21342) := '65297B666F7228636F6E73742065206F6620746869732E6164646974696F6E616C546F67676C657329652E646F6D4E6F64652E72656D6F766528293B746869732E6164646974696F6E616C546F67676C65733D5B5D2C746869732E6164646974696F6E61';
wwv_flow_imp.g_varchar2_table(21343) := '6C546F67676C6573446973706F7361626C65732E76616C75653D6E65772061743B666F7228636F6E73742074206F66206E756C6C213D653F653A5B5D29746869732E6164646974696F6E616C546F67676C6573446973706F7361626C65732E76616C7565';
wwv_flow_imp.g_varchar2_table(21344) := '2E6164642874292C746869732E636F6E74726F6C732E617070656E644368696C6428742E646F6D4E6F6465292C746869732E6164646974696F6E616C546F67676C6573446973706F7361626C65732E76616C75652E61646428742E6F6E4368616E676528';
wwv_flow_imp.g_varchar2_table(21345) := '28653D3E7B746869732E5F6F6E4469644F7074696F6E4368616E67652E666972652865292C21652626746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65642626746869732E696E707574426F782E666F63757328297D2929';
wwv_flow_imp.g_varchar2_table(21346) := '292C746869732E6164646974696F6E616C546F67676C65732E707573682874293B746869732E6164646974696F6E616C546F67676C65732E6C656E6774683E30262628746869732E636F6E74726F6C732E7374796C652E646973706C61793D2222292C74';
wwv_flow_imp.g_varchar2_table(21347) := '6869732E757064617465496E707574426F7850616464696E6728297D757064617465496E707574426F7850616464696E6728653D2131297B76617220742C6E2C692C6F2C732C723B746869732E696E707574426F782E70616464696E6752696768743D65';
wwv_flow_imp.g_varchar2_table(21348) := '3F303A286E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E6361736553656E736974697665297C7C766F696420303D3D3D743F766F696420303A742E77696474682829292626766F69642030213D3D6E3F6E3A30292B286E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(21349) := '6F3D6E756C6C3D3D3D28693D746869732E77686F6C65576F726473297C7C766F696420303D3D3D693F766F696420303A692E77696474682829292626766F69642030213D3D6F3F6F3A30292B286E756C6C213D3D28723D6E756C6C3D3D3D28733D746869';
wwv_flow_imp.g_varchar2_table(21350) := '732E7265676578297C7C766F696420303D3D3D733F766F696420303A732E77696474682829292626766F69642030213D3D723F723A30292B746869732E6164646974696F6E616C546F67676C65732E726564756365282828652C74293D3E652B742E7769';
wwv_flow_imp.g_varchar2_table(21351) := '6474682829292C30297D67657456616C756528297B72657475726E20746869732E696E707574426F782E76616C75657D73657456616C75652865297B746869732E696E707574426F782E76616C7565213D3D65262628746869732E696E707574426F782E';
wwv_flow_imp.g_varchar2_table(21352) := '76616C75653D65297D73656C65637428297B746869732E696E707574426F782E73656C65637428297D666F63757328297B746869732E696E707574426F782E666F63757328297D6765744361736553656E73697469766528297B76617220652C743B7265';
wwv_flow_imp.g_varchar2_table(21353) := '7475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E6361736553656E736974697665297C7C766F696420303D3D3D653F766F696420303A652E636865636B6564292626766F69642030213D3D742626747D7365744361736553656E';
wwv_flow_imp.g_varchar2_table(21354) := '7369746976652865297B746869732E6361736553656E736974697665262628746869732E6361736553656E7369746976652E636865636B65643D65297D67657457686F6C65576F72647328297B76617220652C743B72657475726E206E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(21355) := '743D6E756C6C3D3D3D28653D746869732E77686F6C65576F726473297C7C766F696420303D3D3D653F766F696420303A652E636865636B6564292626766F69642030213D3D742626747D73657457686F6C65576F7264732865297B746869732E77686F6C';
wwv_flow_imp.g_varchar2_table(21356) := '65576F726473262628746869732E77686F6C65576F7264732E636865636B65643D65297D676574526567657828297B76617220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E7265676578297C7C766F696420';
wwv_flow_imp.g_varchar2_table(21357) := '303D3D3D653F766F696420303A652E636865636B6564292626766F69642030213D3D742626747D73657452656765782865297B746869732E7265676578262628746869732E72656765782E636865636B65643D652C746869732E76616C69646174652829';
wwv_flow_imp.g_varchar2_table(21358) := '297D666F6375734F6E4361736553656E73697469766528297B76617220653B6E756C6C3D3D3D28653D746869732E6361736553656E736974697665297C7C766F696420303D3D3D657C7C652E666F63757328297D686967686C6967687446696E644F7074';
wwv_flow_imp.g_varchar2_table(21359) := '696F6E7328297B746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F76652822686967686C696768742D222B746869732E5F6C617374486967686C6967687446696E644F7074696F6E73292C746869732E5F6C617374486967686C696768';
wwv_flow_imp.g_varchar2_table(21360) := '7446696E644F7074696F6E733D312D746869732E5F6C617374486967686C6967687446696E644F7074696F6E732C746869732E646F6D4E6F64652E636C6173734C6973742E6164642822686967686C696768742D222B746869732E5F6C61737448696768';
wwv_flow_imp.g_varchar2_table(21361) := '6C6967687446696E644F7074696F6E73297D76616C696461746528297B746869732E696E707574426F782E76616C696461746528297D73686F774D6573736167652865297B746869732E696E707574426F782E73686F774D6573736167652865297D636C';
wwv_flow_imp.g_varchar2_table(21362) := '6561724D65737361676528297B746869732E696E707574426F782E686964654D65737361676528297D7D7661722064552C68553B2166756E6374696F6E2865297B655B652E457870616E6465643D305D3D22457870616E646564222C655B652E436F6C6C';
wwv_flow_imp.g_varchar2_table(21363) := '61707365643D315D3D22436F6C6C6170736564222C655B652E50726573657276654F72457870616E6465643D325D3D2250726573657276654F72457870616E646564222C655B652E50726573657276654F72436F6C6C61707365643D335D3D2250726573';
wwv_flow_imp.g_varchar2_table(21364) := '657276654F72436F6C6C6170736564227D2864557C7C2864553D7B7D29292C66756E6374696F6E2865297B655B652E556E6B6E6F776E3D305D3D22556E6B6E6F776E222C655B652E547769737469653D315D3D2254776973746965222C655B652E456C65';
wwv_flow_imp.g_varchar2_table(21365) := '6D656E743D325D3D22456C656D656E74222C655B652E46696C7465723D335D3D2246696C746572227D2868557C7C2868553D7B7D29293B636C61737320755520657874656E6473204572726F727B636F6E7374727563746F7228652C74297B7375706572';
wwv_flow_imp.g_varchar2_table(21366) := '2860547265654572726F72205B247B657D5D20247B747D60297D7D636C6173732070557B636F6E7374727563746F722865297B746869732E666E3D652C746869732E5F6D61703D6E6577205765616B4D61707D6D61702865297B6C657420743D74686973';
wwv_flow_imp.g_varchar2_table(21367) := '2E5F6D61702E6765742865293B72657475726E20747C7C28743D746869732E666E2865292C746869732E5F6D61702E73657428652C7429292C747D7D66756E6374696F6E2067552865297B72657475726E226F626A656374223D3D747970656F66206526';
wwv_flow_imp.g_varchar2_table(21368) := '26227669736962696C69747922696E20652626226461746122696E20657D66756E6374696F6E206D552865297B7377697463682865297B6361736521303A72657475726E20313B6361736521313A72657475726E20303B64656661756C743A7265747572';
wwv_flow_imp.g_varchar2_table(21369) := '6E20657D7D66756E6374696F6E2066552865297B72657475726E22626F6F6C65616E223D3D747970656F6620652E636F6C6C61707369626C657D636C6173732076557B636F6E7374727563746F7228652C742C6E2C693D7B7D297B766172206F3B746869';
wwv_flow_imp.g_varchar2_table(21370) := '732E757365723D652C746869732E6C6973743D742C746869732E726F6F745265663D5B5D2C746869732E6576656E7442756666657265723D6E65772044742C746869732E5F6F6E4469644368616E6765436F6C6C6170736553746174653D6E6577204374';
wwv_flow_imp.g_varchar2_table(21371) := '2C746869732E6F6E4469644368616E6765436F6C6C6170736553746174653D746869732E6576656E7442756666657265722E777261704576656E7428746869732E5F6F6E4469644368616E6765436F6C6C6170736553746174652E6576656E74292C7468';
wwv_flow_imp.g_varchar2_table(21372) := '69732E5F6F6E4469644368616E676552656E6465724E6F6465436F756E743D6E65772043742C746869732E6F6E4469644368616E676552656E6465724E6F6465436F756E743D746869732E6576656E7442756666657265722E777261704576656E742874';
wwv_flow_imp.g_varchar2_table(21373) := '6869732E5F6F6E4469644368616E676552656E6465724E6F6465436F756E742E6576656E74292C746869732E5F6F6E44696453706C6963653D6E65772043742C746869732E6F6E44696453706C6963653D746869732E5F6F6E44696453706C6963652E65';
wwv_flow_imp.g_varchar2_table(21374) := '76656E742C746869732E726566696C74657244656C617965723D6E6577207A74284F74292C746869732E636F6C6C61707365427944656661756C743D766F69642030213D3D692E636F6C6C61707365427944656661756C742626692E636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(21375) := '427944656661756C742C746869732E616C6C6F774E6F6E436F6C6C61707369626C65506172656E74733D6E756C6C213D3D286F3D692E616C6C6F774E6F6E436F6C6C61707369626C65506172656E7473292626766F69642030213D3D6F26266F2C746869';
wwv_flow_imp.g_varchar2_table(21376) := '732E66696C7465723D692E66696C7465722C746869732E6175746F457870616E6453696E676C654368696C6472656E3D766F69642030213D3D692E6175746F457870616E6453696E676C654368696C6472656E2626692E6175746F457870616E6453696E';
wwv_flow_imp.g_varchar2_table(21377) := '676C654368696C6472656E2C746869732E726F6F743D7B706172656E743A766F696420302C656C656D656E743A6E2C6368696C6472656E3A5B5D2C64657074683A302C76697369626C654368696C6472656E436F756E743A302C76697369626C65436869';
wwv_flow_imp.g_varchar2_table(21378) := '6C64496E6465783A2D312C636F6C6C61707369626C653A21312C636F6C6C61707365643A21312C72656E6465724E6F6465436F756E743A302C7669736962696C6974793A312C76697369626C653A21302C66696C746572446174613A766F696420307D7D';
wwv_flow_imp.g_varchar2_table(21379) := '73706C69636528652C742C6E3D5A652E656D70747928292C693D7B7D297B696628303D3D3D652E6C656E677468297468726F77206E657720755528746869732E757365722C22496E76616C69642074726565206C6F636174696F6E22293B692E64696666';
wwv_flow_imp.g_varchar2_table(21380) := '4964656E7469747950726F76696465723F746869732E73706C696365536D61727428692E646966664964656E7469747950726F76696465722C652C742C6E2C69293A746869732E73706C69636553696D706C6528652C742C6E2C69297D73706C69636553';
wwv_flow_imp.g_varchar2_table(21381) := '6D61727428652C742C6E2C692C6F2C73297B76617220723B766F696420303D3D3D69262628693D5A652E656D7074792829292C766F696420303D3D3D73262628733D6E756C6C213D3D28723D6F2E646966664465707468292626766F69642030213D3D72';
wwv_flow_imp.g_varchar2_table(21382) := '3F723A30293B636F6E73747B706172656E744E6F64653A617D3D746869732E676574506172656E744E6F6465576974684C697374496E6465782874293B69662821612E6C617374446966664964732972657475726E20746869732E73706C69636553696D';
wwv_flow_imp.g_varchar2_table(21383) := '706C6528742C6E2C692C6F293B636F6E7374206C3D5B2E2E2E695D2C633D745B742E6C656E6774682D315D2C643D6E6577204656287B676574456C656D656E74733A28293D3E612E6C617374446966664964737D2C7B676574456C656D656E74733A2829';
wwv_flow_imp.g_varchar2_table(21384) := '3D3E5B2E2E2E612E6368696C6472656E2E736C69636528302C63292C2E2E2E6C2C2E2E2E612E6368696C6472656E2E736C69636528632B6E295D2E6D61702828743D3E652E676574496428742E656C656D656E74292E746F537472696E67282929297D29';
wwv_flow_imp.g_varchar2_table(21385) := '2E436F6D7075746544696666282131293B696628642E717569744561726C792972657475726E20612E6C617374446966664964733D766F696420302C746869732E73706C69636553696D706C6528742C6E2C6C2C6F293B636F6E737420683D742E736C69';
wwv_flow_imp.g_varchar2_table(21386) := '636528302C2D31292C753D28742C6E2C69293D3E7B696628733E3029666F72286C657420723D303B723C693B722B2B29742D2D2C6E2D2D2C746869732E73706C696365536D61727428652C5B2E2E2E682C742C305D2C4E756D6265722E4D41585F534146';
wwv_flow_imp.g_varchar2_table(21387) := '455F494E54454745522C6C5B6E5D2E6368696C6472656E2C6F2C732D31297D3B6C657420703D4D6174682E6D696E28612E6368696C6472656E2E6C656E6774682C632B6E292C673D6C2E6C656E6774683B666F7228636F6E73742065206F6620642E6368';
wwv_flow_imp.g_varchar2_table(21388) := '616E6765732E736F7274282828652C74293D3E742E6F726967696E616C53746172742D652E6F726967696E616C53746172742929297528702C672C702D28652E6F726967696E616C53746172742B652E6F726967696E616C4C656E67746829292C703D65';
wwv_flow_imp.g_varchar2_table(21389) := '2E6F726967696E616C53746172742C673D652E6D6F64696669656453746172742D632C746869732E73706C69636553696D706C65285B2E2E2E682C705D2C652E6F726967696E616C4C656E6774682C5A652E736C696365286C2C672C672B652E6D6F6469';
wwv_flow_imp.g_varchar2_table(21390) := '666965644C656E677468292C6F293B7528702C672C70297D73706C69636553696D706C6528652C742C6E3D5A652E656D70747928292C7B6F6E4469644372656174654E6F64653A692C6F6E44696444656C6574654E6F64653A6F2C646966664964656E74';
wwv_flow_imp.g_varchar2_table(21391) := '69747950726F76696465723A737D297B636F6E73747B706172656E744E6F64653A722C6C697374496E6465783A612C72657665616C65643A6C2C76697369626C653A637D3D746869732E676574506172656E744E6F6465576974684C697374496E646578';
wwv_flow_imp.g_varchar2_table(21392) := '2865292C643D5B5D2C683D5A652E6D6170286E2C28653D3E746869732E637265617465547265654E6F646528652C722C722E76697369626C653F313A302C6C2C642C692929292C753D655B652E6C656E6774682D315D3B6C657420703D303B666F72286C';
wwv_flow_imp.g_varchar2_table(21393) := '657420653D753B653E3D302626653C722E6368696C6472656E2E6C656E6774683B652D2D297B636F6E737420743D722E6368696C6472656E5B655D3B696628742E76697369626C65297B703D742E76697369626C654368696C64496E6465783B62726561';
wwv_flow_imp.g_varchar2_table(21394) := '6B7D7D636F6E737420673D5B5D3B6C6574206D3D302C663D303B666F7228636F6E73742065206F66206829672E707573682865292C662B3D652E72656E6465724E6F6465436F756E742C652E76697369626C65262628652E76697369626C654368696C64';
wwv_flow_imp.g_varchar2_table(21395) := '496E6465783D702B6D2B2B293B636F6E737420763D586828722E6368696C6472656E2C752C742C67293B733F722E6C617374446966664964733F586828722E6C617374446966664964732C752C742C672E6D61702828653D3E732E676574496428652E65';
wwv_flow_imp.g_varchar2_table(21396) := '6C656D656E74292E746F537472696E6728292929293A722E6C617374446966664964733D722E6368696C6472656E2E6D61702828653D3E732E676574496428652E656C656D656E74292E746F537472696E67282929293A722E6C61737444696666496473';
wwv_flow_imp.g_varchar2_table(21397) := '3D766F696420303B6C657420623D303B666F7228636F6E73742065206F66207629652E76697369626C652626622B2B3B69662830213D3D6229666F72286C657420653D752B672E6C656E6774683B653C722E6368696C6472656E2E6C656E6774683B652B';
wwv_flow_imp.g_varchar2_table(21398) := '2B297B636F6E737420743D722E6368696C6472656E5B655D3B742E76697369626C65262628742E76697369626C654368696C64496E6465782D3D62297D696628722E76697369626C654368696C6472656E436F756E742B3D6D2D622C6C262663297B636F';
wwv_flow_imp.g_varchar2_table(21399) := '6E737420653D762E726564756365282828652C74293D3E652B28742E76697369626C653F742E72656E6465724E6F6465436F756E743A3029292C30293B746869732E5F757064617465416E636573746F727352656E6465724E6F6465436F756E7428722C';
wwv_flow_imp.g_varchar2_table(21400) := '662D65292C746869732E6C6973742E73706C69636528612C652C64297D696628762E6C656E6774683E3026266F297B636F6E737420653D743D3E7B6F2874292C742E6368696C6472656E2E666F72456163682865297D3B762E666F72456163682865297D';
wwv_flow_imp.g_varchar2_table(21401) := '746869732E5F6F6E44696453706C6963652E66697265287B696E7365727465644E6F6465733A672C64656C657465644E6F6465733A767D293B6C6574205F3D723B666F72283B5F3B297B696628323D3D3D5F2E7669736962696C697479297B746869732E';
wwv_flow_imp.g_varchar2_table(21402) := '726566696C74657244656C617965722E74726967676572282828293D3E746869732E726566696C746572282929293B627265616B7D5F3D5F2E706172656E747D7D726572656E6465722865297B696628303D3D3D652E6C656E677468297468726F77206E';
wwv_flow_imp.g_varchar2_table(21403) := '657720755528746869732E757365722C22496E76616C69642074726565206C6F636174696F6E22293B636F6E73747B6E6F64653A742C6C697374496E6465783A6E2C72657665616C65643A697D3D746869732E676574547265654E6F6465576974684C69';
wwv_flow_imp.g_varchar2_table(21404) := '7374496E6465782865293B742E76697369626C652626692626746869732E6C6973742E73706C696365286E2C312C5B745D297D6861732865297B72657475726E20746869732E686173547265654E6F64652865297D6765744C697374496E646578286529';
wwv_flow_imp.g_varchar2_table(21405) := '7B636F6E73747B6C697374496E6465783A742C76697369626C653A6E2C72657665616C65643A697D3D746869732E676574547265654E6F6465576974684C697374496E6465782865293B72657475726E206E2626693F743A2D317D6765744C6973745265';
wwv_flow_imp.g_varchar2_table(21406) := '6E646572436F756E742865297B72657475726E20746869732E676574547265654E6F64652865292E72656E6465724E6F6465436F756E747D6973436F6C6C61707369626C652865297B72657475726E20746869732E676574547265654E6F64652865292E';
wwv_flow_imp.g_varchar2_table(21407) := '636F6C6C61707369626C657D736574436F6C6C61707369626C6528652C74297B636F6E7374206E3D746869732E676574547265654E6F64652865293B766F696420303D3D3D74262628743D216E2E636F6C6C61707369626C65293B636F6E737420693D7B';
wwv_flow_imp.g_varchar2_table(21408) := '636F6C6C61707369626C653A747D3B72657475726E20746869732E6576656E7442756666657265722E6275666665724576656E7473282828293D3E746869732E5F736574436F6C6C61707365537461746528652C692929297D6973436F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(21409) := '2865297B72657475726E20746869732E676574547265654E6F64652865292E636F6C6C61707365647D736574436F6C6C617073656428652C742C6E297B636F6E737420693D746869732E676574547265654E6F64652865293B766F696420303D3D3D7426';
wwv_flow_imp.g_varchar2_table(21410) := '2628743D21692E636F6C6C6170736564293B636F6E7374206F3D7B636F6C6C61707365643A742C7265637572736976653A6E7C7C21317D3B72657475726E20746869732E6576656E7442756666657265722E6275666665724576656E7473282828293D3E';
wwv_flow_imp.g_varchar2_table(21411) := '746869732E5F736574436F6C6C61707365537461746528652C6F2929297D5F736574436F6C6C61707365537461746528652C74297B636F6E73747B6E6F64653A6E2C6C697374496E6465783A692C72657665616C65643A6F7D3D746869732E6765745472';
wwv_flow_imp.g_varchar2_table(21412) := '65654E6F6465576974684C697374496E6465782865292C733D746869732E5F7365744C6973744E6F6465436F6C6C617073655374617465286E2C692C6F2C74293B6966286E213D3D746869732E726F6F742626746869732E6175746F457870616E645369';
wwv_flow_imp.g_varchar2_table(21413) := '6E676C654368696C6472656E262673262621665528742926266E2E636F6C6C61707369626C652626216E2E636F6C6C6170736564262621742E726563757273697665297B6C657420693D2D313B666F72286C657420653D303B653C6E2E6368696C647265';
wwv_flow_imp.g_varchar2_table(21414) := '6E2E6C656E6774683B652B2B296966286E2E6368696C6472656E5B655D2E76697369626C65297B696628693E2D31297B693D2D313B627265616B7D693D657D693E2D312626746869732E5F736574436F6C6C617073655374617465285B2E2E2E652C695D';
wwv_flow_imp.g_varchar2_table(21415) := '2C74297D72657475726E20737D5F7365744C6973744E6F6465436F6C6C61707365537461746528652C742C6E2C69297B636F6E7374206F3D746869732E5F7365744E6F6465436F6C6C61707365537461746528652C692C2131293B696628216E7C7C2165';
wwv_flow_imp.g_varchar2_table(21416) := '2E76697369626C657C7C216F2972657475726E206F3B636F6E737420733D652E72656E6465724E6F6465436F756E742C723D746869732E7570646174654E6F64654166746572436F6C6C617073654368616E67652865292C613D732D282D313D3D3D743F';
wwv_flow_imp.g_varchar2_table(21417) := '303A31293B72657475726E20746869732E6C6973742E73706C69636528742B312C612C722E736C696365283129292C6F7D5F7365744E6F6465436F6C6C61707365537461746528652C742C6E297B6C657420693B696628653D3D3D746869732E726F6F74';
wwv_flow_imp.g_varchar2_table(21418) := '3F693D21313A2866552874293F28693D652E636F6C6C61707369626C65213D3D742E636F6C6C61707369626C652C652E636F6C6C61707369626C653D742E636F6C6C61707369626C65293A652E636F6C6C61707369626C653F28693D652E636F6C6C6170';
wwv_flow_imp.g_varchar2_table(21419) := '736564213D3D742E636F6C6C61707365642C652E636F6C6C61707365643D742E636F6C6C6170736564293A693D21312C692626746869732E5F6F6E4469644368616E6765436F6C6C6170736553746174652E66697265287B6E6F64653A652C646565703A';
wwv_flow_imp.g_varchar2_table(21420) := '6E7D29292C2166552874292626742E72656375727369766529666F7228636F6E7374206E206F6620652E6368696C6472656E29693D746869732E5F7365744E6F6465436F6C6C617073655374617465286E2C742C2130297C7C693B72657475726E20697D';
wwv_flow_imp.g_varchar2_table(21421) := '657870616E64546F2865297B746869732E6576656E7442756666657265722E6275666665724576656E7473282828293D3E7B6C657420743D746869732E676574547265654E6F64652865293B666F72283B742E706172656E743B29743D742E706172656E';
wwv_flow_imp.g_varchar2_table(21422) := '742C653D652E736C69636528302C652E6C656E6774682D31292C742E636F6C6C61707365642626746869732E5F736574436F6C6C61707365537461746528652C7B636F6C6C61707365643A21312C7265637572736976653A21317D297D29297D72656669';
wwv_flow_imp.g_varchar2_table(21423) := '6C74657228297B636F6E737420653D746869732E726F6F742E72656E6465724E6F6465436F756E742C743D746869732E7570646174654E6F6465416674657246696C7465724368616E676528746869732E726F6F74293B746869732E6C6973742E73706C';
wwv_flow_imp.g_varchar2_table(21424) := '69636528302C652C74292C746869732E726566696C74657244656C617965722E63616E63656C28297D637265617465547265654E6F646528652C742C6E2C692C6F2C73297B636F6E737420723D7B706172656E743A742C656C656D656E743A652E656C65';
wwv_flow_imp.g_varchar2_table(21425) := '6D656E742C6368696C6472656E3A5B5D2C64657074683A742E64657074682B312C76697369626C654368696C6472656E436F756E743A302C76697369626C654368696C64496E6465783A2D312C636F6C6C61707369626C653A22626F6F6C65616E223D3D';
wwv_flow_imp.g_varchar2_table(21426) := '747970656F6620652E636F6C6C61707369626C653F652E636F6C6C61707369626C653A766F69642030213D3D652E636F6C6C61707365642C636F6C6C61707365643A766F696420303D3D3D652E636F6C6C61707365643F746869732E636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(21427) := '427944656661756C743A652E636F6C6C61707365642C72656E6465724E6F6465436F756E743A312C7669736962696C6974793A312C76697369626C653A21302C66696C746572446174613A766F696420307D2C613D746869732E5F66696C7465724E6F64';
wwv_flow_imp.g_varchar2_table(21428) := '6528722C6E293B722E7669736962696C6974793D612C6926266F2E707573682872293B636F6E7374206C3D652E6368696C6472656E7C7C5A652E656D70747928292C633D69262630213D3D61262621722E636F6C6C61707365643B6C657420643D302C68';
wwv_flow_imp.g_varchar2_table(21429) := '3D313B666F7228636F6E73742065206F66206C297B636F6E737420743D746869732E637265617465547265654E6F646528652C722C612C632C6F2C73293B722E6368696C6472656E2E707573682874292C682B3D742E72656E6465724E6F6465436F756E';
wwv_flow_imp.g_varchar2_table(21430) := '742C742E76697369626C65262628742E76697369626C654368696C64496E6465783D642B2B297D72657475726E20746869732E616C6C6F774E6F6E436F6C6C61707369626C65506172656E74737C7C28722E636F6C6C61707369626C653D722E636F6C6C';
wwv_flow_imp.g_varchar2_table(21431) := '61707369626C657C7C722E6368696C6472656E2E6C656E6774683E30292C722E76697369626C654368696C6472656E436F756E743D642C722E76697369626C653D323D3D3D613F643E303A313D3D3D612C722E76697369626C653F722E636F6C6C617073';
wwv_flow_imp.g_varchar2_table(21432) := '65647C7C28722E72656E6465724E6F6465436F756E743D68293A28722E72656E6465724E6F6465436F756E743D302C6926266F2E706F702829292C6E756C6C3D3D737C7C732872292C727D7570646174654E6F64654166746572436F6C6C617073654368';
wwv_flow_imp.g_varchar2_table(21433) := '616E67652865297B636F6E737420743D652E72656E6465724E6F6465436F756E742C6E3D5B5D3B72657475726E20746869732E5F7570646174654E6F64654166746572436F6C6C617073654368616E676528652C6E292C746869732E5F75706461746541';
wwv_flow_imp.g_varchar2_table(21434) := '6E636573746F727352656E6465724E6F6465436F756E7428652E706172656E742C6E2E6C656E6774682D74292C6E7D5F7570646174654E6F64654166746572436F6C6C617073654368616E676528652C74297B69662821313D3D3D652E76697369626C65';
wwv_flow_imp.g_varchar2_table(21435) := '2972657475726E20303B696628742E707573682865292C652E72656E6465724E6F6465436F756E743D312C21652E636F6C6C617073656429666F7228636F6E7374206E206F6620652E6368696C6472656E29652E72656E6465724E6F6465436F756E742B';
wwv_flow_imp.g_varchar2_table(21436) := '3D746869732E5F7570646174654E6F64654166746572436F6C6C617073654368616E6765286E2C74293B72657475726E20746869732E5F6F6E4469644368616E676552656E6465724E6F6465436F756E742E666972652865292C652E72656E6465724E6F';
wwv_flow_imp.g_varchar2_table(21437) := '6465436F756E747D7570646174654E6F6465416674657246696C7465724368616E67652865297B636F6E737420743D652E72656E6465724E6F6465436F756E742C6E3D5B5D3B72657475726E20746869732E5F7570646174654E6F646541667465724669';
wwv_flow_imp.g_varchar2_table(21438) := '6C7465724368616E676528652C652E76697369626C653F313A302C6E292C746869732E5F757064617465416E636573746F727352656E6465724E6F6465436F756E7428652E706172656E742C6E2E6C656E6774682D74292C6E7D5F7570646174654E6F64';
wwv_flow_imp.g_varchar2_table(21439) := '65416674657246696C7465724368616E676528652C742C6E2C693D2130297B6C6574206F3B69662865213D3D746869732E726F6F74297B6966286F3D746869732E5F66696C7465724E6F646528652C74292C303D3D3D6F2972657475726E20652E766973';
wwv_flow_imp.g_varchar2_table(21440) := '69626C653D21312C652E72656E6465724E6F6465436F756E743D302C21313B6926266E2E707573682865297D636F6E737420733D6E2E6C656E6774683B652E72656E6465724E6F6465436F756E743D653D3D3D746869732E726F6F743F303A313B6C6574';
wwv_flow_imp.g_varchar2_table(21441) := '20723D21313B696628652E636F6C6C61707365642626303D3D3D6F29652E76697369626C654368696C6472656E436F756E743D303B656C73657B6C657420743D303B666F7228636F6E73742073206F6620652E6368696C6472656E29723D746869732E5F';
wwv_flow_imp.g_varchar2_table(21442) := '7570646174654E6F6465416674657246696C7465724368616E676528732C6F2C6E2C69262621652E636F6C6C6170736564297C7C722C732E76697369626C65262628732E76697369626C654368696C64496E6465783D742B2B293B652E76697369626C65';
wwv_flow_imp.g_varchar2_table(21443) := '4368696C6472656E436F756E743D747D72657475726E2065213D3D746869732E726F6F74262628652E76697369626C653D323D3D3D6F3F723A313D3D3D6F2C652E7669736962696C6974793D6F292C652E76697369626C653F652E636F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(21444) := '7C7C28652E72656E6465724E6F6465436F756E742B3D6E2E6C656E6774682D73293A28652E72656E6465724E6F6465436F756E743D302C6926266E2E706F702829292C746869732E5F6F6E4469644368616E676552656E6465724E6F6465436F756E742E';
wwv_flow_imp.g_varchar2_table(21445) := '666972652865292C652E76697369626C657D5F757064617465416E636573746F727352656E6465724E6F6465436F756E7428652C74297B69662830213D3D7429666F72283B653B29652E72656E6465724E6F6465436F756E742B3D742C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(21446) := '6E4469644368616E676552656E6465724E6F6465436F756E742E666972652865292C653D652E706172656E747D5F66696C7465724E6F646528652C74297B636F6E7374206E3D746869732E66696C7465723F746869732E66696C7465722E66696C746572';
wwv_flow_imp.g_varchar2_table(21447) := '28652E656C656D656E742C74293A313B72657475726E22626F6F6C65616E223D3D747970656F66206E3F28652E66696C746572446174613D766F696420302C6E3F313A30293A6755286E293F28652E66696C746572446174613D6E2E646174612C6D5528';
wwv_flow_imp.g_varchar2_table(21448) := '6E2E7669736962696C69747929293A28652E66696C746572446174613D766F696420302C6D55286E29297D686173547265654E6F646528652C743D746869732E726F6F74297B69662821657C7C303D3D3D652E6C656E6774682972657475726E21303B63';
wwv_flow_imp.g_varchar2_table(21449) := '6F6E73745B6E2C2E2E2E695D3D653B72657475726E21286E3C307C7C6E3E742E6368696C6472656E2E6C656E677468292626746869732E686173547265654E6F646528692C742E6368696C6472656E5B6E5D297D676574547265654E6F646528652C743D';
wwv_flow_imp.g_varchar2_table(21450) := '746869732E726F6F74297B69662821657C7C303D3D3D652E6C656E6774682972657475726E20743B636F6E73745B6E2C2E2E2E695D3D653B6966286E3C307C7C6E3E742E6368696C6472656E2E6C656E677468297468726F77206E657720755528746869';
wwv_flow_imp.g_varchar2_table(21451) := '732E757365722C22496E76616C69642074726565206C6F636174696F6E22293B72657475726E20746869732E676574547265654E6F646528692C742E6368696C6472656E5B6E5D297D676574547265654E6F6465576974684C697374496E646578286529';
wwv_flow_imp.g_varchar2_table(21452) := '7B696628303D3D3D652E6C656E6774682972657475726E7B6E6F64653A746869732E726F6F742C6C697374496E6465783A2D312C72657665616C65643A21302C76697369626C653A21317D3B636F6E73747B706172656E744E6F64653A742C6C69737449';
wwv_flow_imp.g_varchar2_table(21453) := '6E6465783A6E2C72657665616C65643A692C76697369626C653A6F7D3D746869732E676574506172656E744E6F6465576974684C697374496E6465782865292C733D655B652E6C656E6774682D315D3B696628733C307C7C733E742E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(21454) := '2E6C656E677468297468726F77206E657720755528746869732E757365722C22496E76616C69642074726565206C6F636174696F6E22293B636F6E737420723D742E6368696C6472656E5B735D3B72657475726E7B6E6F64653A722C6C697374496E6465';
wwv_flow_imp.g_varchar2_table(21455) := '783A6E2C72657665616C65643A692C76697369626C653A6F2626722E76697369626C657D7D676574506172656E744E6F6465576974684C697374496E64657828652C743D746869732E726F6F742C6E3D302C693D21302C6F3D2130297B636F6E73745B73';
wwv_flow_imp.g_varchar2_table(21456) := '2C2E2E2E725D3D653B696628733C307C7C733E742E6368696C6472656E2E6C656E677468297468726F77206E657720755528746869732E757365722C22496E76616C69642074726565206C6F636174696F6E22293B666F72286C657420653D303B653C73';
wwv_flow_imp.g_varchar2_table(21457) := '3B652B2B296E2B3D742E6368696C6472656E5B655D2E72656E6465724E6F6465436F756E743B72657475726E20693D69262621742E636F6C6C61707365642C6F3D6F2626742E76697369626C652C303D3D3D722E6C656E6774683F7B706172656E744E6F';
wwv_flow_imp.g_varchar2_table(21458) := '64653A742C6C697374496E6465783A6E2C72657665616C65643A692C76697369626C653A6F7D3A746869732E676574506172656E744E6F6465576974684C697374496E64657828722C742E6368696C6472656E5B735D2C6E2B312C692C6F297D6765744E';
wwv_flow_imp.g_varchar2_table(21459) := '6F646528653D5B5D297B72657475726E20746869732E676574547265654E6F64652865297D6765744E6F64654C6F636174696F6E2865297B636F6E737420743D5B5D3B6C6574206E3D653B666F72283B6E2E706172656E743B29742E70757368286E2E70';
wwv_flow_imp.g_varchar2_table(21460) := '6172656E742E6368696C6472656E2E696E6465784F66286E29292C6E3D6E2E706172656E743B72657475726E20742E7265766572736528297D676574506172656E744E6F64654C6F636174696F6E2865297B72657475726E20303D3D3D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(21461) := '683F766F696420303A313D3D3D652E6C656E6774683F5B5D3A66756E6374696F6E2865297B696628303D3D3D652E6C656E677468297468726F77206E6577204572726F722822496E76616C6964207461696C2063616C6C22293B72657475726E5B652E73';
wwv_flow_imp.g_varchar2_table(21462) := '6C69636528302C652E6C656E6774682D31292C655B652E6C656E6774682D315D5D7D2865295B305D7D6765744669727374456C656D656E744368696C642865297B636F6E737420743D746869732E676574547265654E6F64652865293B69662830213D3D';
wwv_flow_imp.g_varchar2_table(21463) := '742E6368696C6472656E2E6C656E6774682972657475726E20742E6368696C6472656E5B305D2E656C656D656E747D7D7661722062552C5F552C79552C77553D6E2831393633292C43553D7B7D3B43552E7374796C655461675472616E73666F726D3D6A';
wwv_flow_imp.g_varchar2_table(21464) := '7228292C43552E736574417474726962757465733D567228292C43552E696E736572743D467228292E62696E64286E756C6C2C226865616422292C43552E646F6D4150493D4F7228292C43552E696E736572745374796C65456C656D656E743D48722829';
wwv_flow_imp.g_varchar2_table(21465) := '2C4E7228292877552E412C4355292C77552E41262677552E412E6C6F63616C73262677552E412E6C6F63616C733B636C61737320535520657874656E64732043547B636F6E7374727563746F722865297B737570657228652E656C656D656E74732E6D61';
wwv_flow_imp.g_varchar2_table(21466) := '702828653D3E652E656C656D656E742929292C746869732E646174613D657D7D66756E6374696F6E2078552865297B72657475726E206520696E7374616E63656F662043543F6E65772053552865293A657D636C617373206B557B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(21467) := '6F7228652C74297B746869732E6D6F64656C50726F76696465723D652C746869732E646E643D742C746869732E6175746F457870616E64446973706F7361626C653D6C742E4E6F6E652C746869732E646973706F7361626C65733D6E65772061747D6765';
wwv_flow_imp.g_varchar2_table(21468) := '74447261675552492865297B72657475726E20746869732E646E642E6765744472616755524928652E656C656D656E74297D676574447261674C6162656C28652C74297B696628746869732E646E642E676574447261674C6162656C2972657475726E20';
wwv_flow_imp.g_varchar2_table(21469) := '746869732E646E642E676574447261674C6162656C28652E6D61702828653D3E652E656C656D656E7429292C74297D6F6E44726167537461727428652C74297B766172206E2C693B6E756C6C3D3D3D28693D286E3D746869732E646E64292E6F6E447261';
wwv_flow_imp.g_varchar2_table(21470) := '675374617274297C7C766F696420303D3D3D697C7C692E63616C6C286E2C78552865292C74297D6F6E447261674F76657228652C742C6E2C692C6F2C733D2130297B636F6E737420723D746869732E646E642E6F6E447261674F7665722878552865292C';
wwv_flow_imp.g_varchar2_table(21471) := '742626742E656C656D656E742C6E2C692C6F292C613D746869732E6175746F457870616E644E6F6465213D3D743B69662861262628746869732E6175746F457870616E64446973706F7361626C652E646973706F736528292C746869732E6175746F4578';
wwv_flow_imp.g_varchar2_table(21472) := '70616E644E6F64653D74292C766F696420303D3D3D742972657475726E20723B69662861262622626F6F6C65616E22213D747970656F6620722626722E6175746F457870616E64262628746869732E6175746F457870616E64446973706F7361626C653D';
wwv_flow_imp.g_varchar2_table(21473) := '6A74282828293D3E7B636F6E737420653D746869732E6D6F64656C50726F766964657228292C6E3D652E6765744E6F64654C6F636174696F6E2874293B652E6973436F6C6C6170736564286E292626652E736574436F6C6C6170736564286E2C2131292C';
wwv_flow_imp.g_varchar2_table(21474) := '746869732E6175746F457870616E644E6F64653D766F696420307D292C3530302C746869732E646973706F7361626C657329292C22626F6F6C65616E223D3D747970656F6620727C7C21722E6163636570747C7C766F696420303D3D3D722E627562626C';
wwv_flow_imp.g_varchar2_table(21475) := '657C7C722E666565646261636B2972657475726E20733F723A7B6163636570743A22626F6F6C65616E223D3D747970656F6620723F723A722E6163636570742C6566666563743A22626F6F6C65616E223D3D747970656F6620723F766F696420303A722E';
wwv_flow_imp.g_varchar2_table(21476) := '6566666563742C666565646261636B3A5B6E5D7D3B696628313D3D3D722E627562626C65297B636F6E7374206E3D746869732E6D6F64656C50726F766964657228292C733D6E2E6765744E6F64654C6F636174696F6E2874292C723D6E2E676574506172';
wwv_flow_imp.g_varchar2_table(21477) := '656E744E6F64654C6F636174696F6E2873292C613D6E2E6765744E6F64652872292C6C3D7226266E2E6765744C697374496E6465782872293B72657475726E20746869732E6F6E447261674F76657228652C612C6C2C692C6F2C2131297D636F6E737420';
wwv_flow_imp.g_varchar2_table(21478) := '6C3D746869732E6D6F64656C50726F766964657228292C633D6C2E6765744E6F64654C6F636174696F6E2874292C643D6C2E6765744C697374496E6465782863292C683D6C2E6765744C69737452656E646572436F756E742863293B72657475726E7B2E';
wwv_flow_imp.g_varchar2_table(21479) := '2E2E722C666565646261636B3A556828642C642B68297D7D64726F7028652C742C6E2C692C6F297B746869732E6175746F457870616E64446973706F7361626C652E646973706F736528292C746869732E6175746F457870616E644E6F64653D766F6964';
wwv_flow_imp.g_varchar2_table(21480) := '20302C746869732E646E642E64726F702878552865292C742626742E656C656D656E742C6E2C692C6F297D6F6E44726167456E642865297B76617220742C6E3B6E756C6C3D3D3D286E3D28743D746869732E646E64292E6F6E44726167456E64297C7C76';
wwv_flow_imp.g_varchar2_table(21481) := '6F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528292C746869732E646E642E646973706F736528297D7D66756E6374696F6E20455528652C74297B726574';
wwv_flow_imp.g_varchar2_table(21482) := '75726E207426267B2E2E2E742C6964656E7469747950726F76696465723A742E6964656E7469747950726F766964657226267B67657449643A653D3E742E6964656E7469747950726F76696465722E676574496428652E656C656D656E74297D2C646E64';
wwv_flow_imp.g_varchar2_table(21483) := '3A742E646E6426266E6577206B5528652C742E646E64292C6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65723A742E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C657226267B697353656C656374696F6E53696E676C';
wwv_flow_imp.g_varchar2_table(21484) := '654368616E67654576656E743A653D3E742E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722E697353656C656374696F6E53696E676C654368616E67654576656E74287B2E2E2E652C656C656D656E743A652E656C656D656E747D29';
wwv_flow_imp.g_varchar2_table(21485) := '2C697353656C656374696F6E52616E67654368616E67654576656E743A653D3E742E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722E697353656C656374696F6E52616E67654368616E67654576656E74287B2E2E2E652C656C656D';
wwv_flow_imp.g_varchar2_table(21486) := '656E743A652E656C656D656E747D297D2C6163636573736962696C69747950726F76696465723A742E6163636573736962696C69747950726F766964657226267B2E2E2E742E6163636573736962696C69747950726F76696465722C6765745365745369';
wwv_flow_imp.g_varchar2_table(21487) := '7A652874297B636F6E7374206E3D6528292C693D6E2E6765744E6F64654C6F636174696F6E2874292C6F3D6E2E676574506172656E744E6F64654C6F636174696F6E2869293B72657475726E206E2E6765744E6F6465286F292E76697369626C65436869';
wwv_flow_imp.g_varchar2_table(21488) := '6C6472656E436F756E747D2C676574506F73496E5365743A653D3E652E76697369626C654368696C64496E6465782B312C6973436865636B65643A742E6163636573736962696C69747950726F76696465722626742E6163636573736962696C69747950';
wwv_flow_imp.g_varchar2_table(21489) := '726F76696465722E6973436865636B65643F653D3E742E6163636573736962696C69747950726F76696465722E6973436865636B656428652E656C656D656E74293A766F696420302C676574526F6C653A742E6163636573736962696C69747950726F76';
wwv_flow_imp.g_varchar2_table(21490) := '696465722626742E6163636573736962696C69747950726F76696465722E676574526F6C653F653D3E742E6163636573736962696C69747950726F76696465722E676574526F6C6528652E656C656D656E74293A28293D3E22747265656974656D222C67';
wwv_flow_imp.g_varchar2_table(21491) := '6574417269614C6162656C3A653D3E742E6163636573736962696C69747950726F76696465722E676574417269614C6162656C28652E656C656D656E74292C676574576964676574417269614C6162656C3A28293D3E742E6163636573736962696C6974';
wwv_flow_imp.g_varchar2_table(21492) := '7950726F76696465722E676574576964676574417269614C6162656C28292C676574576964676574526F6C653A742E6163636573736962696C69747950726F76696465722626742E6163636573736962696C69747950726F76696465722E676574576964';
wwv_flow_imp.g_varchar2_table(21493) := '676574526F6C653F28293D3E742E6163636573736962696C69747950726F76696465722E676574576964676574526F6C6528293A28293D3E2274726565222C676574417269614C6576656C3A742E6163636573736962696C69747950726F766964657226';
wwv_flow_imp.g_varchar2_table(21494) := '26742E6163636573736962696C69747950726F76696465722E676574417269614C6576656C3F653D3E742E6163636573736962696C69747950726F76696465722E676574417269614C6576656C28652E656C656D656E74293A653D3E652E64657074682C';
wwv_flow_imp.g_varchar2_table(21495) := '67657441637469766544657363656E64616E7449643A742E6163636573736962696C69747950726F76696465722E67657441637469766544657363656E64616E744964262628653D3E742E6163636573736962696C69747950726F76696465722E676574';
wwv_flow_imp.g_varchar2_table(21496) := '41637469766544657363656E64616E74496428652E656C656D656E7429297D2C6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723A742E6B6579626F6172644E617669676174696F6E4C6162656C50726F766964657226267B';
wwv_flow_imp.g_varchar2_table(21497) := '2E2E2E742E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465722C6765744B6579626F6172644E617669676174696F6E4C6162656C3A653D3E742E6B6579626F6172644E617669676174696F6E4C6162656C50726F7669646572';
wwv_flow_imp.g_varchar2_table(21498) := '2E6765744B6579626F6172644E617669676174696F6E4C6162656C28652E656C656D656E74297D7D7D636C617373204C557B636F6E7374727563746F722865297B746869732E64656C65676174653D657D6765744865696768742865297B72657475726E';
wwv_flow_imp.g_varchar2_table(21499) := '20746869732E64656C65676174652E67657448656967687428652E656C656D656E74297D67657454656D706C61746549642865297B72657475726E20746869732E64656C65676174652E67657454656D706C617465496428652E656C656D656E74297D68';
wwv_flow_imp.g_varchar2_table(21500) := '617344796E616D69634865696768742865297B72657475726E2121746869732E64656C65676174652E68617344796E616D69634865696768742626746869732E64656C65676174652E68617344796E616D696348656967687428652E656C656D656E7429';
wwv_flow_imp.g_varchar2_table(21501) := '7D73657444796E616D696348656967687428652C74297B766172206E2C693B6E756C6C3D3D3D28693D286E3D746869732E64656C6567617465292E73657444796E616D6963486569676874297C7C766F696420303D3D3D697C7C692E63616C6C286E2C65';
wwv_flow_imp.g_varchar2_table(21502) := '2E656C656D656E742C74297D7D2166756E6374696F6E2865297B652E4E6F6E653D226E6F6E65222C652E4F6E486F7665723D226F6E486F766572222C652E416C776179733D22616C77617973227D2862557C7C2862553D7B7D29293B636C617373204455';
wwv_flow_imp.g_varchar2_table(21503) := '7B67657420656C656D656E747328297B72657475726E20746869732E5F656C656D656E74737D636F6E7374727563746F7228652C743D5B5D297B746869732E5F656C656D656E74733D742C746869732E646973706F7361626C65733D6E65772061742C74';
wwv_flow_imp.g_varchar2_table(21504) := '6869732E6F6E4469644368616E67653D76742E666F724561636828652C28653D3E746869732E5F656C656D656E74733D65292C746869732E646973706F7361626C6573297D646973706F736528297B746869732E646973706F7361626C65732E64697370';
wwv_flow_imp.g_varchar2_table(21505) := '6F736528297D7D636C6173732054557B636F6E7374727563746F7228652C742C6E2C692C6F2C733D7B7D297B76617220723B746869732E72656E64657265723D652C746869732E6D6F64656C50726F76696465723D742C746869732E6163746976654E6F';
wwv_flow_imp.g_varchar2_table(21506) := '6465733D692C746869732E72656E6465726564496E64656E744775696465733D6F2C746869732E72656E6465726564456C656D656E74733D6E6577204D61702C746869732E72656E64657265644E6F6465733D6E6577204D61702C746869732E696E6465';
wwv_flow_imp.g_varchar2_table(21507) := '6E743D54552E44656661756C74496E64656E742C746869732E6869646554776973746965734F664368696C646C657373456C656D656E74733D21312C746869732E73686F756C6452656E646572496E64656E744775696465733D21312C746869732E6163';
wwv_flow_imp.g_varchar2_table(21508) := '74697665496E64656E744E6F6465733D6E6577205365742C746869732E696E64656E74477569646573446973706F7361626C653D6C742E4E6F6E652C746869732E646973706F7361626C65733D6E65772061742C746869732E74656D706C61746549643D';
wwv_flow_imp.g_varchar2_table(21509) := '652E74656D706C61746549642C746869732E7570646174654F7074696F6E732873292C76742E6D6170286E2C28653D3E652E6E6F6465292928746869732E6F6E4469644368616E67654E6F64655477697374696553746174652C746869732C746869732E';
wwv_flow_imp.g_varchar2_table(21510) := '646973706F7361626C6573292C6E756C6C3D3D3D28723D652E6F6E4469644368616E6765547769737469655374617465297C7C766F696420303D3D3D727C7C722E63616C6C28652C746869732E6F6E4469644368616E6765547769737469655374617465';
wwv_flow_imp.g_varchar2_table(21511) := '2C746869732C746869732E646973706F7361626C6573297D7570646174654F7074696F6E7328653D7B7D297B696628766F69642030213D3D652E696E64656E74297B636F6E737420743D484428652E696E64656E742C302C3430293B69662874213D3D74';
wwv_flow_imp.g_varchar2_table(21512) := '6869732E696E64656E74297B746869732E696E64656E743D743B666F7228636F6E73745B652C745D6F6620746869732E72656E64657265644E6F64657329746869732E72656E64657254726565456C656D656E7428652C74297D7D696628766F69642030';
wwv_flow_imp.g_varchar2_table(21513) := '213D3D652E72656E646572496E64656E74477569646573297B636F6E737420743D652E72656E646572496E64656E74477569646573213D3D62552E4E6F6E653B69662874213D3D746869732E73686F756C6452656E646572496E64656E74477569646573';
wwv_flow_imp.g_varchar2_table(21514) := '297B746869732E73686F756C6452656E646572496E64656E744775696465733D743B666F7228636F6E73745B652C745D6F6620746869732E72656E64657265644E6F64657329746869732E5F72656E646572496E64656E7447756964657328652C74293B';
wwv_flow_imp.g_varchar2_table(21515) := '696628746869732E696E64656E74477569646573446973706F7361626C652E646973706F736528292C74297B636F6E737420653D6E65772061743B746869732E6163746976654E6F6465732E6F6E4469644368616E676528746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(21516) := '68616E67654163746976654E6F6465732C746869732C65292C746869732E696E64656E74477569646573446973706F7361626C653D652C746869732E5F6F6E4469644368616E67654163746976654E6F64657328746869732E6163746976654E6F646573';
wwv_flow_imp.g_varchar2_table(21517) := '2E656C656D656E7473297D7D7D766F69642030213D3D652E6869646554776973746965734F664368696C646C657373456C656D656E7473262628746869732E6869646554776973746965734F664368696C646C657373456C656D656E74733D652E686964';
wwv_flow_imp.g_varchar2_table(21518) := '6554776973746965734F664368696C646C657373456C656D656E7473297D72656E64657254656D706C6174652865297B636F6E737420743D757228652C627228222E6D6F6E61636F2D746C2D726F772229292C6E3D757228742C627228222E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(21519) := '6F2D746C2D696E64656E742229292C693D757228742C627228222E6D6F6E61636F2D746C2D747769737469652229292C6F3D757228742C627228222E6D6F6E61636F2D746C2D636F6E74656E74732229292C733D746869732E72656E64657265722E7265';
wwv_flow_imp.g_varchar2_table(21520) := '6E64657254656D706C617465286F293B72657475726E7B636F6E7461696E65723A652C696E64656E743A6E2C747769737469653A692C696E64656E74477569646573446973706F7361626C653A6C742E4E6F6E652C74656D706C617465446174613A737D';
wwv_flow_imp.g_varchar2_table(21521) := '7D72656E646572456C656D656E7428652C742C6E2C69297B746869732E72656E64657265644E6F6465732E73657428652C6E292C746869732E72656E6465726564456C656D656E74732E73657428652E656C656D656E742C65292C746869732E72656E64';
wwv_flow_imp.g_varchar2_table(21522) := '657254726565456C656D656E7428652C6E292C746869732E72656E64657265722E72656E646572456C656D656E7428652C742C6E2E74656D706C617465446174612C69297D646973706F7365456C656D656E7428652C742C6E2C69297B766172206F2C73';
wwv_flow_imp.g_varchar2_table(21523) := '3B6E2E696E64656E74477569646573446973706F7361626C652E646973706F736528292C6E756C6C3D3D3D28733D286F3D746869732E72656E6465726572292E646973706F7365456C656D656E74297C7C766F696420303D3D3D737C7C732E63616C6C28';
wwv_flow_imp.g_varchar2_table(21524) := '6F2C652C742C6E2E74656D706C617465446174612C69292C226E756D626572223D3D747970656F662069262628746869732E72656E64657265644E6F6465732E64656C6574652865292C746869732E72656E6465726564456C656D656E74732E64656C65';
wwv_flow_imp.g_varchar2_table(21525) := '746528652E656C656D656E7429297D646973706F736554656D706C6174652865297B746869732E72656E64657265722E646973706F736554656D706C61746528652E74656D706C61746544617461297D6F6E4469644368616E6765547769737469655374';
wwv_flow_imp.g_varchar2_table(21526) := '6174652865297B636F6E737420743D746869732E72656E6465726564456C656D656E74732E6765742865293B742626746869732E6F6E4469644368616E67654E6F64655477697374696553746174652874297D6F6E4469644368616E67654E6F64655477';
wwv_flow_imp.g_varchar2_table(21527) := '697374696553746174652865297B636F6E737420743D746869732E72656E64657265644E6F6465732E6765742865293B74262628746869732E5F6F6E4469644368616E67654163746976654E6F64657328746869732E6163746976654E6F6465732E656C';
wwv_flow_imp.g_varchar2_table(21528) := '656D656E7473292C746869732E72656E64657254726565456C656D656E7428652C7429297D72656E64657254726565456C656D656E7428652C74297B636F6E7374206E3D54552E44656661756C74496E64656E742B28652E64657074682D31292A746869';
wwv_flow_imp.g_varchar2_table(21529) := '732E696E64656E743B742E747769737469652E7374796C652E70616464696E674C6566743D60247B6E7D7078602C742E696E64656E742E7374796C652E77696474683D6E2B746869732E696E64656E742D31362B227078222C652E636F6C6C6170736962';
wwv_flow_imp.g_varchar2_table(21530) := '6C653F742E636F6E7461696E65722E7365744174747269627574652822617269612D657870616E646564222C537472696E672821652E636F6C6C617073656429293A742E636F6E7461696E65722E72656D6F76654174747269627574652822617269612D';
wwv_flow_imp.g_varchar2_table(21531) := '657870616E64656422292C742E747769737469652E636C6173734C6973742E72656D6F7665282E2E2E546C2E6173436C6173734E616D654172726179284C6C2E747265654974656D457870616E64656429293B6C657420693D21313B746869732E72656E';
wwv_flow_imp.g_varchar2_table(21532) := '64657265722E72656E64657254776973746965262628693D746869732E72656E64657265722E72656E6465725477697374696528652E656C656D656E742C742E7477697374696529292C652E636F6C6C61707369626C6526262821746869732E68696465';
wwv_flow_imp.g_varchar2_table(21533) := '54776973746965734F664368696C646C657373456C656D656E74737C7C652E76697369626C654368696C6472656E436F756E743E30293F28697C7C742E747769737469652E636C6173734C6973742E616464282E2E2E546C2E6173436C6173734E616D65';
wwv_flow_imp.g_varchar2_table(21534) := '4172726179284C6C2E747265654974656D457870616E64656429292C742E747769737469652E636C6173734C6973742E6164642822636F6C6C61707369626C6522292C742E747769737469652E636C6173734C6973742E746F67676C652822636F6C6C61';
wwv_flow_imp.g_varchar2_table(21535) := '70736564222C652E636F6C6C617073656429293A742E747769737469652E636C6173734C6973742E72656D6F76652822636F6C6C61707369626C65222C22636F6C6C617073656422292C746869732E5F72656E646572496E64656E744775696465732865';
wwv_flow_imp.g_varchar2_table(21536) := '2C74297D5F72656E646572496E64656E7447756964657328652C74297B696628667328742E696E64656E74292C742E696E64656E74477569646573446973706F7361626C652E646973706F736528292C21746869732E73686F756C6452656E646572496E';
wwv_flow_imp.g_varchar2_table(21537) := '64656E744775696465732972657475726E3B636F6E7374206E3D6E65772061742C693D746869732E6D6F64656C50726F766964657228293B666F72283B3B297B636F6E7374206F3D692E6765744E6F64654C6F636174696F6E2865292C733D692E676574';
wwv_flow_imp.g_varchar2_table(21538) := '506172656E744E6F64654C6F636174696F6E286F293B696628217329627265616B3B636F6E737420723D692E6765744E6F64652873292C613D627228222E696E64656E742D6775696465222C7B7374796C653A6077696474683A20247B746869732E696E';
wwv_flow_imp.g_varchar2_table(21539) := '64656E747D7078607D293B746869732E616374697665496E64656E744E6F6465732E6861732872292626612E636C6173734C6973742E616464282261637469766522292C303D3D3D742E696E64656E742E6368696C64456C656D656E74436F756E743F74';
wwv_flow_imp.g_varchar2_table(21540) := '2E696E64656E742E617070656E644368696C642861293A742E696E64656E742E696E736572744265666F726528612C742E696E64656E742E6669727374456C656D656E744368696C64292C746869732E72656E6465726564496E64656E74477569646573';
wwv_flow_imp.g_varchar2_table(21541) := '2E61646428722C61292C6E2E616464287274282828293D3E746869732E72656E6465726564496E64656E744775696465732E64656C65746528722C61292929292C653D727D742E696E64656E74477569646573446973706F7361626C653D6E7D5F6F6E44';
wwv_flow_imp.g_varchar2_table(21542) := '69644368616E67654163746976654E6F6465732865297B69662821746869732E73686F756C6452656E646572496E64656E744775696465732972657475726E3B636F6E737420743D6E6577205365742C6E3D746869732E6D6F64656C50726F7669646572';
wwv_flow_imp.g_varchar2_table(21543) := '28293B652E666F72456163682828653D3E7B636F6E737420693D6E2E6765744E6F64654C6F636174696F6E2865293B7472797B636F6E7374206F3D6E2E676574506172656E744E6F64654C6F636174696F6E2869293B652E636F6C6C61707369626C6526';
wwv_flow_imp.g_varchar2_table(21544) := '26652E6368696C6472656E2E6C656E6774683E30262621652E636F6C6C61707365643F742E6164642865293A6F2626742E616464286E2E6765744E6F6465286F29297D63617463682865297B7D7D29292C746869732E616374697665496E64656E744E6F';
wwv_flow_imp.g_varchar2_table(21545) := '6465732E666F72456163682828653D3E7B742E6861732865297C7C746869732E72656E6465726564496E64656E744775696465732E666F724561636828652C28653D3E652E636C6173734C6973742E72656D6F76652822616374697665222929297D2929';
wwv_flow_imp.g_varchar2_table(21546) := '2C742E666F72456163682828653D3E7B746869732E616374697665496E64656E744E6F6465732E6861732865297C7C746869732E72656E6465726564496E64656E744775696465732E666F724561636828652C28653D3E652E636C6173734C6973742E61';
wwv_flow_imp.g_varchar2_table(21547) := '64642822616374697665222929297D29292C746869732E616374697665496E64656E744E6F6465733D747D646973706F736528297B746869732E72656E64657265644E6F6465732E636C65617228292C746869732E72656E6465726564456C656D656E74';
wwv_flow_imp.g_varchar2_table(21548) := '732E636C65617228292C746869732E696E64656E74477569646573446973706F7361626C652E646973706F736528292C6F7428746869732E646973706F7361626C6573297D7D54552E44656661756C74496E64656E743D383B636C6173732049557B6765';
wwv_flow_imp.g_varchar2_table(21549) := '7420746F74616C436F756E7428297B72657475726E20746869732E5F746F74616C436F756E747D676574206D61746368436F756E7428297B72657475726E20746869732E5F6D61746368436F756E747D636F6E7374727563746F7228652C742C6E297B74';
wwv_flow_imp.g_varchar2_table(21550) := '6869732E747265653D652C746869732E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723D742C746869732E5F66696C7465723D6E2C746869732E5F746F74616C436F756E743D302C746869732E5F6D61746368436F756E74';
wwv_flow_imp.g_varchar2_table(21551) := '3D302C746869732E5F7061747465726E3D22222C746869732E5F6C6F776572636173655061747465726E3D22222C746869732E646973706F7361626C65733D6E65772061742C652E6F6E57696C6C526566696C74657228746869732E72657365742C7468';
wwv_flow_imp.g_varchar2_table(21552) := '69732C746869732E646973706F7361626C6573297D66696C74657228652C74297B6C6574206E3D313B696628746869732E5F66696C746572297B636F6E737420693D746869732E5F66696C7465722E66696C74657228652C74293B6966286E3D22626F6F';
wwv_flow_imp.g_varchar2_table(21553) := '6C65616E223D3D747970656F6620693F693F313A303A67552869293F6D5528692E7669736962696C697479293A692C303D3D3D6E2972657475726E21317D696628746869732E5F746F74616C436F756E742B2B2C21746869732E5F7061747465726E2972';
wwv_flow_imp.g_varchar2_table(21554) := '657475726E20746869732E5F6D61746368436F756E742B2B2C7B646174613A736C2E44656661756C742C7669736962696C6974793A6E7D3B636F6E737420693D746869732E6B6579626F6172644E617669676174696F6E4C6162656C50726F7669646572';
wwv_flow_imp.g_varchar2_table(21555) := '2E6765744B6579626F6172644E617669676174696F6E4C6162656C2865292C6F3D41727261792E697341727261792869293F693A5B695D3B666F7228636F6E73742065206F66206F297B636F6E737420743D652626652E746F537472696E6728293B6966';
wwv_flow_imp.g_varchar2_table(21556) := '28766F696420303D3D3D742972657475726E7B646174613A736C2E44656661756C742C7669736962696C6974793A6E7D3B6C657420693B696628746869732E747265652E66696E644D61746368547970653D3D3D79552E436F6E746967756F7573297B63';
wwv_flow_imp.g_varchar2_table(21557) := '6F6E737420653D742E746F4C6F7765724361736528292E696E6465784F6628746869732E5F6C6F776572636173655061747465726E293B696628653E2D31297B693D5B4E756D6265722E4D41585F534146455F494E54454745522C305D3B666F72286C65';
wwv_flow_imp.g_varchar2_table(21558) := '7420743D746869732E5F6C6F776572636173655061747465726E2E6C656E6774683B743E303B742D2D29692E7075736828652B742D31297D7D656C736520693D616C28746869732E5F7061747465726E2C746869732E5F6C6F7765726361736550617474';
wwv_flow_imp.g_varchar2_table(21559) := '65726E2C302C742C742E746F4C6F7765724361736528292C302C7B66697273744D6174636843616E42655765616B3A21302C626F6F737446756C6C4D617463683A21307D293B696628692972657475726E20746869732E5F6D61746368436F756E742B2B';
wwv_flow_imp.g_varchar2_table(21560) := '2C313D3D3D6F2E6C656E6774683F7B646174613A692C7669736962696C6974793A6E7D3A7B646174613A7B6C6162656C3A742C73636F72653A697D2C7669736962696C6974793A6E7D7D72657475726E20746869732E747265652E66696E644D6F64653D';
wwv_flow_imp.g_varchar2_table(21561) := '3D3D5F552E46696C7465723F226E756D626572223D3D747970656F6620746869732E747265652E6F7074696F6E732E64656661756C7446696E645669736962696C6974793F746869732E747265652E6F7074696F6E732E64656661756C7446696E645669';
wwv_flow_imp.g_varchar2_table(21562) := '736962696C6974793A746869732E747265652E6F7074696F6E732E64656661756C7446696E645669736962696C6974793F746869732E747265652E6F7074696F6E732E64656661756C7446696E645669736962696C6974792865293A323A7B646174613A';
wwv_flow_imp.g_varchar2_table(21563) := '736C2E44656661756C742C7669736962696C6974793A6E7D7D726573657428297B746869732E5F746F74616C436F756E743D302C746869732E5F6D61746368436F756E743D307D646973706F736528297B6F7428746869732E646973706F7361626C6573';
wwv_flow_imp.g_varchar2_table(21564) := '297D7D2166756E6374696F6E2865297B655B652E486967686C696768743D305D3D22486967686C69676874222C655B652E46696C7465723D315D3D2246696C746572227D285F557C7C285F553D7B7D29292C66756E6374696F6E2865297B655B652E4675';
wwv_flow_imp.g_varchar2_table(21565) := '7A7A793D305D3D2246757A7A79222C655B652E436F6E746967756F75733D315D3D22436F6E746967756F7573227D2879557C7C2879553D7B7D29293B636C617373204D557B676574207061747465726E28297B72657475726E20746869732E5F70617474';
wwv_flow_imp.g_varchar2_table(21566) := '65726E7D676574206D6F646528297B72657475726E20746869732E5F6D6F64657D736574206D6F64652865297B65213D3D746869732E5F6D6F6465262628746869732E5F6D6F64653D652C746869732E776964676574262628746869732E776964676574';
wwv_flow_imp.g_varchar2_table(21567) := '2E6D6F64653D746869732E5F6D6F6465292C746869732E747265652E726566696C74657228292C746869732E72656E64657228292C746869732E5F6F6E4469644368616E67654D6F64652E66697265286529297D676574206D617463685479706528297B';
wwv_flow_imp.g_varchar2_table(21568) := '72657475726E20746869732E5F6D61746368547970657D736574206D61746368547970652865297B65213D3D746869732E5F6D6174636854797065262628746869732E5F6D61746368547970653D652C746869732E776964676574262628746869732E77';
wwv_flow_imp.g_varchar2_table(21569) := '69646765742E6D61746368547970653D746869732E5F6D6174636854797065292C746869732E747265652E726566696C74657228292C746869732E72656E64657228292C746869732E5F6F6E4469644368616E67654D61746368547970652E6669726528';
wwv_flow_imp.g_varchar2_table(21570) := '6529297D636F6E7374727563746F7228652C742C6E2C692C6F2C733D7B7D297B76617220722C613B746869732E747265653D652C746869732E766965773D6E2C746869732E66696C7465723D692C746869732E636F6E746578745669657750726F766964';
wwv_flow_imp.g_varchar2_table(21571) := '65723D6F2C746869732E6F7074696F6E733D732C746869732E5F7061747465726E3D22222C746869732E77696474683D302C746869732E5F6F6E4469644368616E67654D6F64653D6E65772043742C746869732E6F6E4469644368616E67654D6F64653D';
wwv_flow_imp.g_varchar2_table(21572) := '746869732E5F6F6E4469644368616E67654D6F64652E6576656E742C746869732E5F6F6E4469644368616E67654D61746368547970653D6E65772043742C746869732E6F6E4469644368616E67654D61746368547970653D746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(21573) := '68616E67654D61746368547970652E6576656E742C746869732E5F6F6E4469644368616E67655061747465726E3D6E65772043742C746869732E5F6F6E4469644368616E67654F70656E53746174653D6E65772043742C746869732E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(21574) := '6E67654F70656E53746174653D746869732E5F6F6E4469644368616E67654F70656E53746174652E6576656E742C746869732E656E61626C6564446973706F7361626C65733D6E65772061742C746869732E646973706F7361626C65733D6E6577206174';
wwv_flow_imp.g_varchar2_table(21575) := '2C746869732E5F6D6F64653D6E756C6C213D3D28723D652E6F7074696F6E732E64656661756C7446696E644D6F6465292626766F69642030213D3D723F723A5F552E486967686C696768742C746869732E5F6D61746368547970653D6E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(21576) := '613D652E6F7074696F6E732E64656661756C7446696E644D6174636854797065292626766F69642030213D3D613F613A79552E46757A7A792C742E6F6E44696453706C69636528746869732E6F6E44696453706C6963654D6F64656C2C746869732C7468';
wwv_flow_imp.g_varchar2_table(21577) := '69732E646973706F7361626C6573297D7570646174654F7074696F6E7328653D7B7D297B766F69642030213D3D652E64656661756C7446696E644D6F6465262628746869732E6D6F64653D652E64656661756C7446696E644D6F6465292C766F69642030';
wwv_flow_imp.g_varchar2_table(21578) := '213D3D652E64656661756C7446696E644D6174636854797065262628746869732E6D61746368547970653D652E64656661756C7446696E644D6174636854797065297D6F6E44696453706C6963654D6F64656C28297B746869732E776964676574262630';
wwv_flow_imp.g_varchar2_table(21579) := '213D3D746869732E7061747465726E2E6C656E677468262628746869732E747265652E726566696C74657228292C746869732E72656E6465722829297D72656E64657228297B76617220652C742C6E2C693B636F6E7374206F3D746869732E66696C7465';
wwv_flow_imp.g_varchar2_table(21580) := '722E746F74616C436F756E743E302626303D3D3D746869732E66696C7465722E6D61746368436F756E743B746869732E7061747465726E26266F3F6E756C6C3D3D3D28653D746869732E747265652E6F7074696F6E732E73686F774E6F74466F756E644D';
wwv_flow_imp.g_varchar2_table(21581) := '657373616765297C7C766F696420303D3D3D657C7C653F6E756C6C3D3D3D28743D746869732E776964676574297C7C766F696420303D3D3D747C7C742E73686F774D657373616765287B747970653A322C636F6E74656E743A6228302C224E6F20656C65';
wwv_flow_imp.g_varchar2_table(21582) := '6D656E747320666F756E642E22297D293A6E756C6C3D3D3D286E3D746869732E776964676574297C7C766F696420303D3D3D6E7C7C6E2E73686F774D657373616765287B747970653A327D293A6E756C6C3D3D3D28693D746869732E776964676574297C';
wwv_flow_imp.g_varchar2_table(21583) := '7C766F696420303D3D3D697C7C692E636C6561724D65737361676528297D73686F756C64416C6C6F77466F6375732865297B72657475726E21746869732E7769646765747C7C21746869732E7061747465726E7C7C746869732E66696C7465722E746F74';
wwv_flow_imp.g_varchar2_table(21584) := '616C436F756E743E302626746869732E66696C7465722E6D61746368436F756E743C3D317C7C21736C2E697344656661756C7428652E66696C74657244617461297D6C61796F75742865297B76617220743B746869732E77696474683D652C6E756C6C3D';
wwv_flow_imp.g_varchar2_table(21585) := '3D3D28743D746869732E776964676574297C7C766F696420303D3D3D747C7C742E6C61796F75742865297D646973706F736528297B746869732E5F686973746F72793D766F696420302C746869732E5F6F6E4469644368616E67655061747465726E2E64';
wwv_flow_imp.g_varchar2_table(21586) := '6973706F736528292C746869732E656E61626C6564446973706F7361626C65732E646973706F736528292C746869732E646973706F7361626C65732E646973706F736528297D7D66756E6374696F6E20415528652C74297B72657475726E20652E706F73';
wwv_flow_imp.g_varchar2_table(21587) := '6974696F6E3D3D3D742E706F736974696F6E26264E5528652C74297D66756E6374696F6E204E5528652C74297B72657475726E20652E6E6F64652E656C656D656E743D3D3D742E6E6F64652E656C656D656E742626652E7374617274496E6465783D3D3D';
wwv_flow_imp.g_varchar2_table(21588) := '742E7374617274496E6465782626652E6865696768743D3D3D742E6865696768742626652E656E64496E6465783D3D3D742E656E64496E6465787D636C6173732050557B636F6E7374727563746F7228653D5B5D297B746869732E737469636B794E6F64';
wwv_flow_imp.g_varchar2_table(21589) := '65733D657D67657420636F756E7428297B72657475726E20746869732E737469636B794E6F6465732E6C656E6774687D657175616C2865297B72657475726E20506828746869732E737469636B794E6F6465732C652E737469636B794E6F6465732C4155';
wwv_flow_imp.g_varchar2_table(21590) := '297D6C6173744E6F64655061727469616C6C7956697369626C6528297B696628303D3D3D746869732E636F756E742972657475726E21313B636F6E737420653D746869732E737469636B794E6F6465735B746869732E636F756E742D315D3B696628313D';
wwv_flow_imp.g_varchar2_table(21591) := '3D3D746869732E636F756E742972657475726E2030213D3D652E706F736974696F6E3B636F6E737420743D746869732E737469636B794E6F6465735B746869732E636F756E742D325D3B72657475726E20742E706F736974696F6E2B742E686569676874';
wwv_flow_imp.g_varchar2_table(21592) := '213D3D652E706F736974696F6E7D616E696D6174696F6E53746174654368616E6765642865297B69662821506828746869732E737469636B794E6F6465732C652E737469636B794E6F6465732C4E55292972657475726E21313B696628303D3D3D746869';
wwv_flow_imp.g_varchar2_table(21593) := '732E636F756E742972657475726E21313B636F6E737420743D746869732E737469636B794E6F6465735B746869732E636F756E742D315D2C6E3D652E737469636B794E6F6465735B652E636F756E742D315D3B72657475726E20742E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(21594) := '213D3D6E2E706F736974696F6E7D7D636C617373204F557B636F6E73747261696E537469636B795363726F6C6C4E6F64657328652C742C6E297B666F72286C657420693D303B693C652E6C656E6774683B692B2B297B636F6E7374206F3D655B695D3B69';
wwv_flow_imp.g_varchar2_table(21595) := '66286F2E706F736974696F6E2B6F2E6865696768743E6E7C7C693E3D742972657475726E20652E736C69636528302C69297D72657475726E20657D7D636C61737320525520657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C';
wwv_flow_imp.g_varchar2_table(21596) := '6F2C733D7B7D297B76617220723B737570657228292C746869732E747265653D652C746869732E6D6F64656C3D742C746869732E766965773D6E2C746869732E7472656544656C65676174653D6F2C746869732E6D617857696467657456696577526174';
wwv_flow_imp.g_varchar2_table(21597) := '696F3D2E343B636F6E737420613D746869732E76616C6964617465537469636B7953657474696E67732873293B746869732E737469636B795363726F6C6C4D61784974656D436F756E743D612E737469636B795363726F6C6C4D61784974656D436F756E';
wwv_flow_imp.g_varchar2_table(21598) := '742C746869732E737469636B795363726F6C6C44656C65676174653D6E756C6C213D3D28723D732E737469636B795363726F6C6C44656C6567617465292626766F69642030213D3D723F723A6E6577204F552C746869732E5F7769646765743D74686973';
wwv_flow_imp.g_varchar2_table(21599) := '2E5F7265676973746572286E6577204655286E2E6765745363726F6C6C61626C65456C656D656E7428292C6E2C652C692C6F2C732E6163636573736962696C69747950726F766964657229292C746869732E6F6E4469644368616E6765486173466F6375';
wwv_flow_imp.g_varchar2_table(21600) := '733D746869732E5F7769646765742E6F6E4469644368616E6765486173466F6375732C746869732E6F6E436F6E746578744D656E753D746869732E5F7769646765742E6F6E436F6E746578744D656E752C746869732E5F7265676973746572286E2E6F6E';
wwv_flow_imp.g_varchar2_table(21601) := '4469645363726F6C6C282828293D3E746869732E75706461746528292929292C746869732E5F7265676973746572286E2E6F6E4469644368616E6765436F6E74656E74486569676874282828293D3E746869732E75706461746528292929292C74686973';
wwv_flow_imp.g_varchar2_table(21602) := '2E5F726567697374657228652E6F6E4469644368616E6765436F6C6C617073655374617465282828293D3E746869732E75706461746528292929292C746869732E75706461746528297D6765742068656967687428297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(21603) := '7769646765742E6865696768747D6765744E6F646541744865696768742865297B6C657420743B696628743D303D3D3D653F746869732E766965772E666972737456697369626C65496E6465783A746869732E766965772E696E646578417428652B7468';
wwv_flow_imp.g_varchar2_table(21604) := '69732E766965772E7363726F6C6C546F70292C2128743C307C7C743E3D746869732E766965772E6C656E677468292972657475726E20746869732E766965772E656C656D656E742874297D75706461746528297B636F6E737420653D746869732E676574';
wwv_flow_imp.g_varchar2_table(21605) := '4E6F646541744865696768742830293B69662821657C7C303D3D3D746869732E747265652E7363726F6C6C546F702972657475726E20766F696420746869732E5F7769646765742E736574537461746528766F69642030293B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(21606) := '732E66696E64537469636B7953746174652865293B746869732E5F7769646765742E73657453746174652874297D66696E64537469636B7953746174652865297B636F6E737420743D5B5D3B6C6574206E3D652C693D302C6F3D746869732E6765744E65';
wwv_flow_imp.g_varchar2_table(21607) := '7874537469636B794E6F6465286E2C766F696420302C69293B666F72283B6F262628742E70757368286F292C692B3D6F2E6865696768742C2128742E6C656E6774683C3D746869732E737469636B795363726F6C6C4D61784974656D436F756E74297C7C';
wwv_flow_imp.g_varchar2_table(21608) := '286E3D746869732E6765744E65787456697369626C654E6F6465286F292C6E29293B296F3D746869732E6765744E657874537469636B794E6F6465286E2C6F2E6E6F64652C69293B636F6E737420733D746869732E636F6E73747261696E537469636B79';
wwv_flow_imp.g_varchar2_table(21609) := '4E6F6465732874293B72657475726E20732E6C656E6774683F6E65772050552873293A766F696420307D6765744E65787456697369626C654E6F64652865297B72657475726E20746869732E6765744E6F6465417448656967687428652E706F73697469';
wwv_flow_imp.g_varchar2_table(21610) := '6F6E2B652E686569676874297D6765744E657874537469636B794E6F646528652C742C6E297B636F6E737420693D746869732E676574416E636573746F72556E64657250726576696F757328652C74293B69662869297B696628693D3D3D65297B696628';
wwv_flow_imp.g_varchar2_table(21611) := '21746869732E6E6F64654973556E636F6C6C6170736564506172656E742865292972657475726E3B696628746869732E6E6F6465546F70416C69676E7357697468537469636B794E6F646573426F74746F6D28652C6E292972657475726E7D7265747572';
wwv_flow_imp.g_varchar2_table(21612) := '6E20746869732E637265617465537469636B795363726F6C6C4E6F646528692C6E297D7D6E6F6465546F70416C69676E7357697468537469636B794E6F646573426F74746F6D28652C74297B636F6E7374206E3D746869732E6765744E6F6465496E6465';
wwv_flow_imp.g_varchar2_table(21613) := '782865292C693D746869732E766965772E676574456C656D656E74546F70286E292C6F3D743B72657475726E20746869732E766965772E7363726F6C6C546F703D3D3D692D6F7D637265617465537469636B795363726F6C6C4E6F646528652C74297B63';
wwv_flow_imp.g_varchar2_table(21614) := '6F6E7374206E3D746869732E7472656544656C65676174652E6765744865696768742865292C7B7374617274496E6465783A692C656E64496E6465783A6F7D3D746869732E6765744E6F646552616E67652865293B72657475726E7B6E6F64653A652C70';
wwv_flow_imp.g_varchar2_table(21615) := '6F736974696F6E3A746869732E63616C63756C617465537469636B794E6F6465506F736974696F6E286F2C742C6E292C6865696768743A6E2C7374617274496E6465783A692C656E64496E6465783A6F7D7D676574416E636573746F72556E6465725072';
wwv_flow_imp.g_varchar2_table(21616) := '6576696F757328652C743D766F69642030297B6C6574206E3D652C693D746869732E676574506172656E744E6F6465286E293B666F72283B693B297B696628693D3D3D742972657475726E206E3B6E3D692C693D746869732E676574506172656E744E6F';
wwv_flow_imp.g_varchar2_table(21617) := '6465286E297D696628766F696420303D3D3D742972657475726E206E7D63616C63756C617465537469636B794E6F6465506F736974696F6E28652C742C6E297B6C657420693D746869732E766965772E67657452656C6174697665546F702865293B6966';
wwv_flow_imp.g_varchar2_table(21618) := '286E756C6C3D3D3D692626746869732E766965772E666972737456697369626C65496E6465783D3D3D652626652B313C746869732E766965772E6C656E677468297B636F6E737420743D746869732E7472656544656C65676174652E6765744865696768';
wwv_flow_imp.g_varchar2_table(21619) := '7428746869732E766965772E656C656D656E74286529292C6E3D746869732E766965772E67657452656C6174697665546F7028652B31293B693D6E3F6E2D742F746869732E766965772E72656E6465724865696768743A6E756C6C7D6966286E756C6C3D';
wwv_flow_imp.g_varchar2_table(21620) := '3D3D692972657475726E20743B636F6E7374206F3D746869732E766965772E656C656D656E742865292C733D746869732E7472656544656C65676174652E676574486569676874286F292C723D692A746869732E766965772E72656E6465724865696768';
wwv_flow_imp.g_varchar2_table(21621) := '742B733B72657475726E20742B6E3E722626743C3D723F722D6E3A747D636F6E73747261696E537469636B794E6F6465732865297B696628303D3D3D652E6C656E6774682972657475726E5B5D3B636F6E737420743D746869732E766965772E72656E64';
wwv_flow_imp.g_varchar2_table(21622) := '65724865696768742A746869732E6D617857696467657456696577526174696F2C6E3D655B652E6C656E6774682D315D3B696628652E6C656E6774683C3D746869732E737469636B795363726F6C6C4D61784974656D436F756E7426266E2E706F736974';
wwv_flow_imp.g_varchar2_table(21623) := '696F6E2B6E2E6865696768743C3D742972657475726E20653B636F6E737420693D746869732E737469636B795363726F6C6C44656C65676174652E636F6E73747261696E537469636B795363726F6C6C4E6F64657328652C746869732E737469636B7953';
wwv_flow_imp.g_varchar2_table(21624) := '63726F6C6C4D61784974656D436F756E742C74293B69662821692E6C656E6774682972657475726E5B5D3B636F6E7374206F3D695B692E6C656E6774682D315D3B696628692E6C656E6774683E746869732E737469636B795363726F6C6C4D6178497465';
wwv_flow_imp.g_varchar2_table(21625) := '6D436F756E747C7C6F2E706F736974696F6E2B6F2E6865696768743E74297468726F77206E6577204572726F722822737469636B795363726F6C6C44656C65676174652076696F6C6174657320636F6E73747261696E747322293B72657475726E20697D';
wwv_flow_imp.g_varchar2_table(21626) := '676574506172656E744E6F64652865297B636F6E737420743D746869732E6D6F64656C2E6765744E6F64654C6F636174696F6E2865292C6E3D746869732E6D6F64656C2E676574506172656E744E6F64654C6F636174696F6E2874293B72657475726E20';
wwv_flow_imp.g_varchar2_table(21627) := '6E3F746869732E6D6F64656C2E6765744E6F6465286E293A766F696420307D6E6F64654973556E636F6C6C6170736564506172656E742865297B636F6E737420743D746869732E6D6F64656C2E6765744E6F64654C6F636174696F6E2865293B72657475';
wwv_flow_imp.g_varchar2_table(21628) := '726E20746869732E6D6F64656C2E6765744C69737452656E646572436F756E742874293E317D6765744E6F6465496E6465782865297B636F6E737420743D746869732E6D6F64656C2E6765744E6F64654C6F636174696F6E2865293B72657475726E2074';
wwv_flow_imp.g_varchar2_table(21629) := '6869732E6D6F64656C2E6765744C697374496E6465782874297D6765744E6F646552616E67652865297B636F6E737420743D746869732E6D6F64656C2E6765744E6F64654C6F636174696F6E2865292C6E3D746869732E6D6F64656C2E6765744C697374';
wwv_flow_imp.g_varchar2_table(21630) := '496E6465782874293B6966286E3C30297468726F77206E6577204572726F7228224E6F6465206E6F7420666F756E6420696E207472656522293B72657475726E7B7374617274496E6465783A6E2C656E64496E6465783A6E2B746869732E6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(21631) := '6765744C69737452656E646572436F756E742874292D317D7D6E6F6465506F736974696F6E546F7042656C6F775769646765742865297B636F6E737420743D5B5D3B6C6574206E3D746869732E676574506172656E744E6F64652865293B666F72283B6E';
wwv_flow_imp.g_varchar2_table(21632) := '3B29742E70757368286E292C6E3D746869732E676574506172656E744E6F6465286E293B6C657420693D303B666F72286C657420653D303B653C742E6C656E6774682626653C746869732E737469636B795363726F6C6C4D61784974656D436F756E743B';
wwv_flow_imp.g_varchar2_table(21633) := '652B2B29692B3D746869732E7472656544656C65676174652E67657448656967687428745B655D293B72657475726E20697D646F6D466F63757328297B746869732E5F7769646765742E646F6D466F63757328297D666F63757365644C61737428297B72';
wwv_flow_imp.g_varchar2_table(21634) := '657475726E20746869732E5F7769646765742E666F63757365644C61737428297D7570646174654F7074696F6E7328653D7B7D297B69662821652E737469636B795363726F6C6C4D61784974656D436F756E742972657475726E3B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(21635) := '6869732E76616C6964617465537469636B7953657474696E67732865293B746869732E737469636B795363726F6C6C4D61784974656D436F756E74213D3D742E737469636B795363726F6C6C4D61784974656D436F756E74262628746869732E73746963';
wwv_flow_imp.g_varchar2_table(21636) := '6B795363726F6C6C4D61784974656D436F756E743D742E737469636B795363726F6C6C4D61784974656D436F756E742C746869732E7570646174652829297D76616C6964617465537469636B7953657474696E67732865297B6C657420743D373B726574';
wwv_flow_imp.g_varchar2_table(21637) := '75726E226E756D626572223D3D747970656F6620652E737469636B795363726F6C6C4D61784974656D436F756E74262628743D4D6174682E6D617828652E737469636B795363726F6C6C4D61784974656D436F756E742C3129292C7B737469636B795363';
wwv_flow_imp.g_varchar2_table(21638) := '726F6C6C4D61784974656D436F756E743A747D7D7D636C6173732046557B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E766965773D742C746869732E747265653D6E2C746869732E7472656552656E6465726572733D692C';
wwv_flow_imp.g_varchar2_table(21639) := '746869732E7472656544656C65676174653D6F2C746869732E6163636573736962696C69747950726F76696465723D732C746869732E5F70726576696F7573456C656D656E74733D5B5D2C746869732E5F70726576696F75735374617465446973706F73';
wwv_flow_imp.g_varchar2_table(21640) := '61626C65733D6E65772061742C746869732E5F726F6F74446F6D4E6F64653D627228222E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722E656D70747922292C652E617070656E644368696C6428746869732E5F726F6F74446F6D';
wwv_flow_imp.g_varchar2_table(21641) := '4E6F6465293B636F6E737420723D627228222E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722D736861646F7722293B746869732E5F726F6F74446F6D4E6F64652E617070656E644368696C642872292C746869732E737469636B';
wwv_flow_imp.g_varchar2_table(21642) := '795363726F6C6C466F6375733D6E657720425528746869732E5F726F6F74446F6D4E6F64652C74292C746869732E6F6E4469644368616E6765486173466F6375733D746869732E737469636B795363726F6C6C466F6375732E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(21643) := '486173466F6375732C746869732E6F6E436F6E746578744D656E753D746869732E737469636B795363726F6C6C466F6375732E6F6E436F6E746578744D656E757D6765742068656967687428297B69662821746869732E5F70726576696F757353746174';
wwv_flow_imp.g_varchar2_table(21644) := '652972657475726E20303B636F6E737420653D746869732E5F70726576696F757353746174652E737469636B794E6F6465735B746869732E5F70726576696F757353746174652E636F756E742D315D3B72657475726E20652E706F736974696F6E2B652E';
wwv_flow_imp.g_varchar2_table(21645) := '6865696768747D73657453746174652865297B636F6E737420743D2121746869732E5F70726576696F757353746174652626746869732E5F70726576696F757353746174652E636F756E743E302C6E3D2121652626652E636F756E743E303B6966282174';
wwv_flow_imp.g_varchar2_table(21646) := '2626216E7C7C7426266E2626746869732E5F70726576696F757353746174652E657175616C2865292972657475726E3B69662874213D3D6E2626746869732E73657456697369626C65286E292C216E2972657475726E20746869732E5F70726576696F75';
wwv_flow_imp.g_varchar2_table(21647) := '7353746174653D766F696420302C746869732E5F70726576696F7573456C656D656E74733D5B5D2C766F696420746869732E5F70726576696F75735374617465446973706F7361626C65732E636C65617228293B636F6E737420693D652E737469636B79';
wwv_flow_imp.g_varchar2_table(21648) := '4E6F6465735B652E636F756E742D315D3B696628746869732E5F70726576696F757353746174652626652E616E696D6174696F6E53746174654368616E67656428746869732E5F70726576696F757353746174652929746869732E5F70726576696F7573';
wwv_flow_imp.g_varchar2_table(21649) := '456C656D656E74735B746869732E5F70726576696F757353746174652E636F756E742D315D2E7374796C652E746F703D60247B692E706F736974696F6E7D7078603B656C73657B746869732E5F70726576696F75735374617465446973706F7361626C65';
wwv_flow_imp.g_varchar2_table(21650) := '732E636C65617228293B636F6E737420743D417272617928652E636F756E74293B666F72286C6574206E3D652E636F756E742D313B6E3E3D303B6E2D2D297B636F6E737420693D652E737469636B794E6F6465735B6E5D2C7B656C656D656E743A6F2C64';
wwv_flow_imp.g_varchar2_table(21651) := '6973706F7361626C653A737D3D746869732E637265617465456C656D656E7428692C6E2C652E636F756E74293B745B6E5D3D6F2C746869732E5F726F6F74446F6D4E6F64652E617070656E644368696C64286F292C746869732E5F70726576696F757353';
wwv_flow_imp.g_varchar2_table(21652) := '74617465446973706F7361626C65732E6164642873297D746869732E737469636B795363726F6C6C466F6375732E757064617465456C656D656E747328742C65292C746869732E5F70726576696F7573456C656D656E74733D747D746869732E5F707265';
wwv_flow_imp.g_varchar2_table(21653) := '76696F757353746174653D652C746869732E5F726F6F74446F6D4E6F64652E7374796C652E6865696768743D60247B692E706F736974696F6E2B692E6865696768747D7078607D637265617465456C656D656E7428652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(21654) := '652E7374617274496E6465782C6F3D646F63756D656E742E637265617465456C656D656E74282264697622293B6F2E7374796C652E746F703D60247B652E706F736974696F6E7D7078602C2131213D3D746869732E747265652E6F7074696F6E732E7365';
wwv_flow_imp.g_varchar2_table(21655) := '74526F774865696768742626286F2E7374796C652E6865696768743D60247B652E6865696768747D707860292C2131213D3D746869732E747265652E6F7074696F6E732E736574526F774C696E654865696768742626286F2E7374796C652E6C696E6548';
wwv_flow_imp.g_varchar2_table(21656) := '65696768743D60247B652E6865696768747D707860292C6F2E636C6173734C6973742E61646428226D6F6E61636F2D747265652D737469636B792D726F7722292C6F2E636C6173734C6973742E61646428226D6F6E61636F2D6C6973742D726F7722292C';
wwv_flow_imp.g_varchar2_table(21657) := '6F2E7365744174747269627574652822646174612D696E646578222C60247B697D60292C6F2E7365744174747269627574652822646174612D706172697479222C6925323D3D303F226576656E223A226F646422292C6F2E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(21658) := '28226964222C746869732E766965772E676574456C656D656E744944286929293B636F6E737420733D746869732E7365744163636573736962696C69747941747472696275746573286F2C652E6E6F64652E656C656D656E742C742C6E292C723D746869';
wwv_flow_imp.g_varchar2_table(21659) := '732E7472656544656C65676174652E67657454656D706C617465496428652E6E6F6465292C613D746869732E7472656552656E6465726572732E66696E642828653D3E652E74656D706C61746549643D3D3D7229293B6966282161297468726F77206E65';
wwv_flow_imp.g_varchar2_table(21660) := '77204572726F7228604E6F2072656E646572657220666F756E6420666F722074656D706C61746520696420247B727D60293B6C6574206C3D652E6E6F64653B6C3D3D3D746869732E747265652E6765744E6F646528746869732E747265652E6765744E6F';
wwv_flow_imp.g_varchar2_table(21661) := '64654C6F636174696F6E28652E6E6F646529292626286C3D6E65772050726F787928652E6E6F64652C7B7D29293B636F6E737420633D612E72656E64657254656D706C617465286F293B612E72656E646572456C656D656E74286C2C652E737461727449';
wwv_flow_imp.g_varchar2_table(21662) := '6E6465782C632C652E686569676874293B636F6E737420643D7274282828293D3E7B732E646973706F736528292C612E646973706F7365456C656D656E74286C2C652E7374617274496E6465782C632C652E686569676874292C612E646973706F736554';
wwv_flow_imp.g_varchar2_table(21663) := '656D706C6174652863292C6F2E72656D6F766528297D29293B72657475726E7B656C656D656E743A6F2C646973706F7361626C653A647D7D7365744163636573736962696C6974794174747269627574657328652C742C6E2C69297B766172206F3B6966';
wwv_flow_imp.g_varchar2_table(21664) := '2821746869732E6163636573736962696C69747950726F76696465722972657475726E206C742E4E6F6E653B746869732E6163636573736962696C69747950726F76696465722E67657453657453697A652626652E736574417474726962757465282261';
wwv_flow_imp.g_varchar2_table(21665) := '7269612D73657473697A65222C537472696E6728746869732E6163636573736962696C69747950726F76696465722E67657453657453697A6528742C6E2C692929292C746869732E6163636573736962696C69747950726F76696465722E676574506F73';
wwv_flow_imp.g_varchar2_table(21666) := '496E5365742626652E7365744174747269627574652822617269612D706F73696E736574222C537472696E6728746869732E6163636573736962696C69747950726F76696465722E676574506F73496E53657428742C6E2929292C746869732E61636365';
wwv_flow_imp.g_varchar2_table(21667) := '73736962696C69747950726F76696465722E676574526F6C652626652E7365744174747269627574652822726F6C65222C6E756C6C213D3D286F3D746869732E6163636573736962696C69747950726F76696465722E676574526F6C6528742929262676';
wwv_flow_imp.g_varchar2_table(21668) := '6F69642030213D3D6F3F6F3A22747265656974656D22293B636F6E737420733D746869732E6163636573736962696C69747950726F76696465722E676574417269614C6162656C2874292C723D73262622737472696E6722213D747970656F6620733F73';
wwv_flow_imp.g_varchar2_table(21669) := '3A73492873292C613D65492828743D3E7B636F6E7374206E3D742E726561644F627365727661626C652872293B6E3F652E7365744174747269627574652822617269612D6C6162656C222C6E293A652E72656D6F76654174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(21670) := '612D6C6162656C22297D29293B22737472696E67223D3D747970656F6620737C7C732626652E7365744174747269627574652822617269612D6C6162656C222C732E6765742829293B636F6E7374206C3D746869732E6163636573736962696C69747950';
wwv_flow_imp.g_varchar2_table(21671) := '726F76696465722E676574417269614C6576656C2626746869732E6163636573736962696C69747950726F76696465722E676574417269614C6576656C2874293B72657475726E226E756D626572223D3D747970656F66206C2626652E73657441747472';
wwv_flow_imp.g_varchar2_table(21672) := '69627574652822617269612D6C6576656C222C60247B6C7D60292C652E7365744174747269627574652822617269612D73656C6563746564222C537472696E6728213129292C617D73657456697369626C652865297B746869732E5F726F6F74446F6D4E';
wwv_flow_imp.g_varchar2_table(21673) := '6F64652E636C6173734C6973742E746F67676C652822656D707479222C2165292C657C7C746869732E737469636B795363726F6C6C466F6375732E757064617465456C656D656E7473285B5D2C766F69642030297D646F6D466F63757328297B74686973';
wwv_flow_imp.g_varchar2_table(21674) := '2E737469636B795363726F6C6C466F6375732E646F6D466F63757328297D666F63757365644C61737428297B72657475726E20746869732E737469636B795363726F6C6C466F6375732E666F63757365644C61737428297D646973706F736528297B7468';
wwv_flow_imp.g_varchar2_table(21675) := '69732E737469636B795363726F6C6C466F6375732E646973706F736528292C746869732E5F70726576696F75735374617465446973706F7361626C65732E646973706F736528292C746869732E5F726F6F74446F6D4E6F64652E72656D6F766528297D7D';
wwv_flow_imp.g_varchar2_table(21676) := '636C61737320425520657874656E6473206C747B67657420646F6D486173466F63757328297B72657475726E20746869732E5F646F6D486173466F6375737D73657420646F6D486173466F6375732865297B65213D3D746869732E5F646F6D486173466F';
wwv_flow_imp.g_varchar2_table(21677) := '637573262628746869732E5F6F6E4469644368616E6765486173466F6375732E666972652865292C746869732E5F646F6D486173466F6375733D65297D636F6E7374727563746F7228652C74297B737570657228292C746869732E636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(21678) := '3D652C746869732E766965773D742C746869732E666F6375736564496E6465783D2D312C746869732E656C656D656E74733D5B5D2C746869732E5F6F6E4469644368616E6765486173466F6375733D6E65772043742C746869732E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(21679) := '6765486173466F6375733D746869732E5F6F6E4469644368616E6765486173466F6375732E6576656E742C746869732E5F6F6E436F6E746578744D656E753D6E65772043742C746869732E6F6E436F6E746578744D656E753D746869732E5F6F6E436F6E';
wwv_flow_imp.g_varchar2_table(21680) := '746578744D656E752E6576656E742C746869732E5F646F6D486173466F6375733D21312C746869732E636F6E7461696E65722E6164644576656E744C697374656E65722822666F637573222C2828293D3E746869732E6F6E466F637573282929292C7468';
wwv_flow_imp.g_varchar2_table(21681) := '69732E636F6E7461696E65722E6164644576656E744C697374656E65722822626C7572222C2828293D3E746869732E6F6E426C7572282929292C746869732E5F726567697374657228746869732E766965772E6F6E446964466F637573282828293D3E74';
wwv_flow_imp.g_varchar2_table(21682) := '6869732E746F67676C65537469636B795363726F6C6C466F6375736564282131292929292C746869732E5F726567697374657228746869732E766965772E6F6E4B6579446F776E2828653D3E746869732E6F6E4B6579446F776E2865292929292C746869';
wwv_flow_imp.g_varchar2_table(21683) := '732E5F726567697374657228746869732E766965772E6F6E4D6F757365446F776E2828653D3E746869732E6F6E4D6F757365446F776E2865292929292C746869732E5F726567697374657228746869732E766965772E6F6E436F6E746578744D656E7528';
wwv_flow_imp.g_varchar2_table(21684) := '28653D3E746869732E68616E646C65436F6E746578744D656E752865292929297D68616E646C65436F6E746578744D656E752865297B636F6E737420743D652E62726F777365724576656E742E7461726765743B6966282144492874292626214C492874';
wwv_flow_imp.g_varchar2_table(21685) := '292972657475726E20766F696428746869732E666F63757365644C61737428292626746869732E766965772E646F6D466F6375732829293B69662821727228652E62726F777365724576656E7429297B69662821746869732E7374617465297468726F77';
wwv_flow_imp.g_varchar2_table(21686) := '206E6577204572726F722822436F6E74657874206D656E752073686F756C64206E6F7420626520747269676765726564207768656E20737461746520697320756E646566696E656422293B636F6E737420743D746869732E73746174652E737469636B79';
wwv_flow_imp.g_varchar2_table(21687) := '4E6F6465732E66696E64496E6465782828743D3E7B766172206E3B72657475726E20742E6E6F64652E656C656D656E743D3D3D286E756C6C3D3D3D286E3D652E656C656D656E74297C7C766F696420303D3D3D6E3F766F696420303A6E2E656C656D656E';
wwv_flow_imp.g_varchar2_table(21688) := '74297D29293B6966282D313D3D3D74297468726F77206E6577204572726F722822436F6E74657874206D656E752073686F756C64206E6F7420626520747269676765726564207768656E20656C656D656E74206973206E6F7420696E20737469636B7920';
wwv_flow_imp.g_varchar2_table(21689) := '7363726F6C6C2077696467657422293B72657475726E20746869732E636F6E7461696E65722E666F63757328292C766F696420746869732E736574466F6375732874297D69662821746869732E73746174657C7C746869732E666F6375736564496E6465';
wwv_flow_imp.g_varchar2_table(21690) := '783C30297468726F77206E6577204572726F722822436F6E74657874206D656E75206B65792073686F756C64206E6F7420626520747269676765726564207768656E20666F637573206973206E6F7420696E20737469636B79207363726F6C6C20776964';
wwv_flow_imp.g_varchar2_table(21691) := '67657422293B636F6E7374206E3D746869732E73746174652E737469636B794E6F6465735B746869732E666F6375736564496E6465785D2E6E6F64652E656C656D656E742C693D746869732E656C656D656E74735B746869732E666F6375736564496E64';
wwv_flow_imp.g_varchar2_table(21692) := '65785D3B746869732E5F6F6E436F6E746578744D656E752E66697265287B656C656D656E743A6E2C616E63686F723A692C62726F777365724576656E743A652E62726F777365724576656E742C6973537469636B795363726F6C6C3A21307D297D6F6E4B';
wwv_flow_imp.g_varchar2_table(21693) := '6579446F776E2865297B696628746869732E646F6D486173466F6375732626746869732E737461746529696628224172726F775570223D3D3D652E6B657929746869732E736574466F6375736564456C656D656E74284D6174682E6D617828302C746869';
wwv_flow_imp.g_varchar2_table(21694) := '732E666F6375736564496E6465782D3129292C652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28293B656C736520696628224172726F77446F776E223D3D3D652E6B65797C7C224172726F775269676874223D';
wwv_flow_imp.g_varchar2_table(21695) := '3D3D652E6B6579297B696628746869732E666F6375736564496E6465783E3D746869732E73746174652E636F756E742D31297B636F6E737420653D746869732E73746174652E737469636B794E6F6465735B746869732E73746174652E636F756E742D31';
wwv_flow_imp.g_varchar2_table(21696) := '5D2E7374617274496E6465782B313B746869732E766965772E646F6D466F63757328292C746869732E766965772E736574466F637573285B655D292C746869732E7363726F6C6C4E6F6465556E64657257696467657428652C746869732E737461746529';
wwv_flow_imp.g_varchar2_table(21697) := '7D656C736520746869732E736574466F6375736564456C656D656E7428746869732E666F6375736564496E6465782B31293B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28297D7D6F6E4D6F757365446F77';
wwv_flow_imp.g_varchar2_table(21698) := '6E2865297B636F6E737420743D652E62726F777365724576656E742E7461726765743B2844492874297C7C4C4928742929262628652E62726F777365724576656E742E70726576656E7444656661756C7428292C652E62726F777365724576656E742E73';
wwv_flow_imp.g_varchar2_table(21699) := '746F7050726F7061676174696F6E2829297D757064617465456C656D656E747328652C74297B696628742626303D3D3D742E636F756E74297468726F77206E6577204572726F722822537469636B79207363726F6C6C207374617465206D757374206265';
wwv_flow_imp.g_varchar2_table(21700) := '20756E646566696E6564207768656E20746865726520617265206E6F20737469636B79206E6F64657322293B696628742626742E636F756E74213D3D652E6C656E677468297468726F77206E6577204572726F722822537469636B79207363726F6C6C20';
wwv_flow_imp.g_varchar2_table(21701) := '666F63757320726563656976656420696C6C6967656C20737461746522293B636F6E7374206E3D746869732E666F6375736564496E6465783B696628746869732E72656D6F7665466F63757328292C746869732E656C656D656E74733D652C746869732E';
wwv_flow_imp.g_varchar2_table(21702) := '73746174653D742C74297B636F6E737420653D4844286E2C302C742E636F756E742D31293B746869732E736574466F6375732865297D656C736520746869732E646F6D486173466F6375732626746869732E766965772E646F6D466F63757328293B7468';
wwv_flow_imp.g_varchar2_table(21703) := '69732E636F6E7461696E65722E746162496E6465783D743F303A2D317D736574466F6375736564456C656D656E742865297B636F6E737420743D746869732E73746174653B6966282174297468726F77206E6577204572726F72282243616E6E6F742073';
wwv_flow_imp.g_varchar2_table(21704) := '657420666F637573207768656E20737461746520697320756E646566696E656422293B696628746869732E736574466F6375732865292C2128653C742E636F756E742D31292626742E6C6173744E6F64655061727469616C6C7956697369626C65282929';
wwv_flow_imp.g_varchar2_table(21705) := '7B636F6E7374206E3D742E737469636B794E6F6465735B655D3B746869732E7363726F6C6C4E6F6465556E646572576964676574286E2E656E64496E6465782B312C74297D7D7363726F6C6C4E6F6465556E64657257696467657428652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(21706) := '7374206E3D742E737469636B794E6F6465735B742E636F756E742D315D2C693D742E636F756E743E313F742E737469636B794E6F6465735B742E636F756E742D325D3A766F696420302C6F3D746869732E766965772E676574456C656D656E74546F7028';
wwv_flow_imp.g_varchar2_table(21707) := '65292C733D693F692E706F736974696F6E2B692E6865696768742B6E2E6865696768743A6E2E6865696768743B746869732E766965772E7363726F6C6C546F703D6F2D737D646F6D466F63757328297B69662821746869732E7374617465297468726F77';
wwv_flow_imp.g_varchar2_table(21708) := '206E6577204572726F72282243616E6E6F7420666F637573207768656E20737461746520697320756E646566696E656422293B746869732E636F6E7461696E65722E666F63757328297D666F63757365644C61737428297B72657475726E212174686973';
wwv_flow_imp.g_varchar2_table(21709) := '2E73746174652626746869732E766965772E67657448544D4C456C656D656E7428292E636C6173734C6973742E636F6E7461696E732822737469636B792D7363726F6C6C2D666F637573656422297D72656D6F7665466F63757328297B2D31213D3D7468';
wwv_flow_imp.g_varchar2_table(21710) := '69732E666F6375736564496E646578262628746869732E746F67676C65456C656D656E74466F63757328746869732E656C656D656E74735B746869732E666F6375736564496E6465785D2C2131292C746869732E666F6375736564496E6465783D2D3129';
wwv_flow_imp.g_varchar2_table(21711) := '7D736574466F6375732865297B696628303E65297468726F77206E6577204572726F722822616464466F63757328292063616E206E6F742072656D6F766520666F63757322293B69662821746869732E73746174652626653E3D30297468726F77206E65';
wwv_flow_imp.g_varchar2_table(21712) := '77204572726F72282243616E6E6F742073657420666F63757320696E646578207768656E20737461746520697320756E646566696E656422293B696628746869732E73746174652626653E3D746869732E73746174652E636F756E74297468726F77206E';
wwv_flow_imp.g_varchar2_table(21713) := '6577204572726F72282243616E6E6F742073657420666F63757320696E64657820746F20616E20696E646578207468617420646F6573206E6F7420657869737422293B636F6E737420743D746869732E666F6375736564496E6465783B743E3D30262674';
wwv_flow_imp.g_varchar2_table(21714) := '6869732E746F67676C65456C656D656E74466F63757328746869732E656C656D656E74735B745D2C2131292C653E3D302626746869732E746F67676C65456C656D656E74466F63757328746869732E656C656D656E74735B655D2C2130292C746869732E';
wwv_flow_imp.g_varchar2_table(21715) := '666F6375736564496E6465783D657D746F67676C65456C656D656E74466F63757328652C74297B746869732E746F67676C65456C656D656E74416374697665466F63757328652C742626746869732E646F6D486173466F637573292C746869732E746F67';
wwv_flow_imp.g_varchar2_table(21716) := '676C65456C656D656E7450617373697665466F63757328652C74297D746F67676C6543757272656E74456C656D656E74416374697665466F6375732865297B2D31213D3D746869732E666F6375736564496E6465782626746869732E746F67676C65456C';
wwv_flow_imp.g_varchar2_table(21717) := '656D656E74416374697665466F63757328746869732E656C656D656E74735B746869732E666F6375736564496E6465785D2C65297D746F67676C65456C656D656E74416374697665466F63757328652C74297B652E636C6173734C6973742E746F67676C';
wwv_flow_imp.g_varchar2_table(21718) := '652822666F6375736564222C74297D746F67676C65456C656D656E7450617373697665466F63757328652C74297B652E636C6173734C6973742E746F67676C652822706173736976652D666F6375736564222C74297D746F67676C65537469636B795363';
wwv_flow_imp.g_varchar2_table(21719) := '726F6C6C466F63757365642865297B746869732E766965772E67657448544D4C456C656D656E7428292E636C6173734C6973742E746F67676C652822737469636B792D7363726F6C6C2D666F6375736564222C65297D6F6E466F63757328297B69662821';
wwv_flow_imp.g_varchar2_table(21720) := '746869732E73746174657C7C303D3D3D746869732E656C656D656E74732E6C656E677468297468726F77206E6577204572726F72282243616E6E6F7420666F637573207768656E20737461746520697320756E646566696E6564206F7220656C656D656E';
wwv_flow_imp.g_varchar2_table(21721) := '74732061726520656D70747922293B746869732E646F6D486173466F6375733D21302C746869732E746F67676C65537469636B795363726F6C6C466F6375736564282130292C746869732E746F67676C6543757272656E74456C656D656E744163746976';
wwv_flow_imp.g_varchar2_table(21722) := '65466F637573282130292C2D313D3D3D746869732E666F6375736564496E6465782626746869732E736574466F6375732830297D6F6E426C757228297B746869732E646F6D486173466F6375733D21312C746869732E746F67676C6543757272656E7445';
wwv_flow_imp.g_varchar2_table(21723) := '6C656D656E74416374697665466F637573282131297D646973706F736528297B746869732E746F67676C65537469636B795363726F6C6C466F6375736564282131292C746869732E5F6F6E4469644368616E6765486173466F6375732E66697265282131';
wwv_flow_imp.g_varchar2_table(21724) := '292C73757065722E646973706F736528297D7D66756E6374696F6E2056552865297B6C657420743D68552E556E6B6E6F776E3B72657475726E20567328652E62726F777365724576656E742E7461726765742C226D6F6E61636F2D746C2D747769737469';
wwv_flow_imp.g_varchar2_table(21725) := '65222C226D6F6E61636F2D746C2D726F7722293F743D68552E547769737469653A567328652E62726F777365724576656E742E7461726765742C226D6F6E61636F2D746C2D636F6E74656E7473222C226D6F6E61636F2D746C2D726F7722293F743D6855';
wwv_flow_imp.g_varchar2_table(21726) := '2E456C656D656E743A567328652E62726F777365724576656E742E7461726765742C226D6F6E61636F2D747265652D747970652D66696C746572222C226D6F6E61636F2D6C6973742229262628743D68552E46696C746572292C7B62726F777365724576';
wwv_flow_imp.g_varchar2_table(21727) := '656E743A652E62726F777365724576656E742C656C656D656E743A652E656C656D656E743F652E656C656D656E742E656C656D656E743A6E756C6C2C7461726765743A747D7D66756E6374696F6E207A552865297B636F6E737420743D444928652E6272';
wwv_flow_imp.g_varchar2_table(21728) := '6F777365724576656E742E746172676574293B72657475726E7B656C656D656E743A652E656C656D656E743F652E656C656D656E742E656C656D656E743A6E756C6C2C62726F777365724576656E743A652E62726F777365724576656E742C616E63686F';
wwv_flow_imp.g_varchar2_table(21729) := '723A652E616E63686F722C6973537469636B795363726F6C6C3A747D7D66756E6374696F6E20485528652C74297B742865292C652E6368696C6472656E2E666F72456163682828653D3E485528652C742929297D636C6173732057557B676574206E6F64';
wwv_flow_imp.g_varchar2_table(21730) := '6553657428297B72657475726E20746869732E5F6E6F64655365747C7C28746869732E5F6E6F64655365743D746869732E6372656174654E6F64655365742829292C746869732E5F6E6F64655365747D636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(21731) := '732E676574466972737456696577456C656D656E745769746854726169743D652C746869732E6964656E7469747950726F76696465723D742C746869732E6E6F6465733D5B5D2C746869732E5F6F6E4469644368616E67653D6E65772043742C74686973';
wwv_flow_imp.g_varchar2_table(21732) := '2E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E747D73657428652C74297B21286E756C6C3D3D743F766F696420303A742E5F5F666F7263654576656E74292626506828746869732E6E6F6465732C65297C7C7468';
wwv_flow_imp.g_varchar2_table(21733) := '69732E5F73657428652C21312C74297D5F73657428652C742C6E297B696628746869732E6E6F6465733D5B2E2E2E655D2C746869732E656C656D656E74733D766F696420302C746869732E5F6E6F64655365743D766F696420302C2174297B636F6E7374';
wwv_flow_imp.g_varchar2_table(21734) := '20653D746869733B746869732E5F6F6E4469644368616E67652E66697265287B67657420656C656D656E747328297B72657475726E20652E67657428297D2C62726F777365724576656E743A6E7D297D7D67657428297B72657475726E20746869732E65';
wwv_flow_imp.g_varchar2_table(21735) := '6C656D656E74737C7C28746869732E656C656D656E74733D746869732E6E6F6465732E6D61702828653D3E652E656C656D656E742929292C5B2E2E2E746869732E656C656D656E74735D7D6765744E6F64657328297B72657475726E20746869732E6E6F';
wwv_flow_imp.g_varchar2_table(21736) := '6465737D6861732865297B72657475726E20746869732E6E6F64655365742E6861732865297D6F6E4469644D6F64656C53706C696365287B696E7365727465644E6F6465733A652C64656C657465644E6F6465733A747D297B69662821746869732E6964';
wwv_flow_imp.g_varchar2_table(21737) := '656E7469747950726F7669646572297B636F6E737420653D746869732E6372656174654E6F646553657428292C6E3D743D3E652E64656C6574652874293B72657475726E20742E666F72456163682828653D3E485528652C6E2929292C766F6964207468';
wwv_flow_imp.g_varchar2_table(21738) := '69732E736574285B2E2E2E652E76616C75657328295D297D636F6E7374206E3D6E6577205365742C693D653D3E6E2E61646428746869732E6964656E7469747950726F76696465722E676574496428652E656C656D656E74292E746F537472696E672829';
wwv_flow_imp.g_varchar2_table(21739) := '293B742E666F72456163682828653D3E485528652C692929293B636F6E7374206F3D6E6577204D61702C733D653D3E6F2E73657428746869732E6964656E7469747950726F76696465722E676574496428652E656C656D656E74292E746F537472696E67';
wwv_flow_imp.g_varchar2_table(21740) := '28292C65293B652E666F72456163682828653D3E485528652C732929293B636F6E737420723D5B5D3B666F7228636F6E73742065206F6620746869732E6E6F646573297B636F6E737420743D746869732E6964656E7469747950726F76696465722E6765';
wwv_flow_imp.g_varchar2_table(21741) := '74496428652E656C656D656E74292E746F537472696E6728293B6966286E2E686173287429297B636F6E737420653D6F2E6765742874293B652626652E76697369626C652626722E707573682865297D656C736520722E707573682865297D6966287468';
wwv_flow_imp.g_varchar2_table(21742) := '69732E6E6F6465732E6C656E6774683E302626303D3D3D722E6C656E677468297B636F6E737420653D746869732E676574466972737456696577456C656D656E7457697468547261697428293B652626722E707573682865297D746869732E5F73657428';
wwv_flow_imp.g_varchar2_table(21743) := '722C2130297D6372656174654E6F646553657428297B636F6E737420653D6E6577205365743B666F7228636F6E73742074206F6620746869732E6E6F64657329652E6164642874293B72657475726E20657D7D636C617373206A5520657874656E647320';
wwv_flow_imp.g_varchar2_table(21744) := '46497B636F6E7374727563746F7228652C742C6E297B73757065722865292C746869732E747265653D742C746869732E737469636B795363726F6C6C50726F76696465723D6E7D6F6E56696577506F696E7465722865297B696628544928652E62726F77';
wwv_flow_imp.g_varchar2_table(21745) := '7365724576656E742E746172676574297C7C784928652E62726F777365724576656E742E746172676574297C7C454928652E62726F777365724576656E742E746172676574292972657475726E3B696628652E62726F777365724576656E742E69734861';
wwv_flow_imp.g_varchar2_table(21746) := '6E646C656442794C6973742972657475726E3B636F6E737420743D652E656C656D656E743B69662821742972657475726E2073757065722E6F6E56696577506F696E7465722865293B696628746869732E697353656C656374696F6E52616E6765436861';
wwv_flow_imp.g_varchar2_table(21747) := '6E67654576656E742865297C7C746869732E697353656C656374696F6E53696E676C654368616E67654576656E742865292972657475726E2073757065722E6F6E56696577506F696E7465722865293B636F6E7374206E3D652E62726F77736572457665';
wwv_flow_imp.g_varchar2_table(21748) := '6E742E7461726765742C693D6E2E636C6173734C6973742E636F6E7461696E7328226D6F6E61636F2D746C2D7477697374696522297C7C6E2E636C6173734C6973742E636F6E7461696E7328226D6F6E61636F2D69636F6E2D6C6162656C222926266E2E';
wwv_flow_imp.g_varchar2_table(21749) := '636C6173734C6973742E636F6E7461696E732822666F6C6465722D69636F6E22292626652E62726F777365724576656E742E6F6666736574583C31362C6F3D4C4928652E62726F777365724576656E742E746172676574293B6C657420733D21313B6966';
wwv_flow_imp.g_varchar2_table(21750) := '28733D21216F7C7C282266756E6374696F6E223D3D747970656F6620746869732E747265652E657870616E644F6E6C794F6E54776973746965436C69636B3F746869732E747265652E657870616E644F6E6C794F6E54776973746965436C69636B28742E';
wwv_flow_imp.g_varchar2_table(21751) := '656C656D656E74293A2121746869732E747265652E657870616E644F6E6C794F6E54776973746965436C69636B292C6F29746869732E68616E646C65537469636B795363726F6C6C4D6F7573654576656E7428652C74293B656C73657B69662873262621';
wwv_flow_imp.g_varchar2_table(21752) := '69262632213D3D652E62726F777365724576656E742E64657461696C2972657475726E2073757065722E6F6E56696577506F696E7465722865293B69662821746869732E747265652E657870616E644F6E446F75626C65436C69636B2626323D3D3D652E';
wwv_flow_imp.g_varchar2_table(21753) := '62726F777365724576656E742E64657461696C2972657475726E2073757065722E6F6E56696577506F696E7465722865297D696628742E636F6C6C61707369626C65262628216F7C7C6929297B636F6E7374206E3D746869732E747265652E6765744E6F';
wwv_flow_imp.g_varchar2_table(21754) := '64654C6F636174696F6E2874292C6F3D652E62726F777365724576656E742E616C744B65793B696628746869732E747265652E736574466F637573285B6E5D292C746869732E747265652E746F67676C65436F6C6C6170736564286E2C6F292C69297265';
wwv_flow_imp.g_varchar2_table(21755) := '7475726E20766F696428652E62726F777365724576656E742E697348616E646C656442794C6973743D2130297D6F7C7C73757065722E6F6E56696577506F696E7465722865297D68616E646C65537469636B795363726F6C6C4D6F7573654576656E7428';
wwv_flow_imp.g_varchar2_table(21756) := '652C74297B69662866756E6374696F6E2865297B72657475726E206B4928652C226D6F6E61636F2D637573746F6D2D746F67676C6522297D28652E62726F777365724576656E742E746172676574297C7C66756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(21757) := '6B4928652C22616374696F6E2D6974656D22297D28652E62726F777365724576656E742E746172676574292972657475726E3B636F6E7374206E3D746869732E737469636B795363726F6C6C50726F766964657228293B696628216E297468726F77206E';
wwv_flow_imp.g_varchar2_table(21758) := '6577204572726F722822537469636B79207363726F6C6C20636F6E74726F6C6C6572206E6F7420666F756E6422293B636F6E737420693D746869732E6C6973742E696E6465784F662874292C6F3D746869732E6C6973742E676574456C656D656E74546F';
wwv_flow_imp.g_varchar2_table(21759) := '702869292C733D6E2E6E6F6465506F736974696F6E546F7042656C6F775769646765742874293B746869732E747265652E7363726F6C6C546F703D6F2D732C746869732E6C6973742E646F6D466F63757328292C746869732E6C6973742E736574466F63';
wwv_flow_imp.g_varchar2_table(21760) := '7573285B695D292C746869732E6C6973742E73657453656C656374696F6E285B695D297D6F6E446F75626C65436C69636B2865297B21652E62726F777365724576656E742E7461726765742E636C6173734C6973742E636F6E7461696E7328226D6F6E61';
wwv_flow_imp.g_varchar2_table(21761) := '636F2D746C2D7477697374696522292626746869732E747265652E657870616E644F6E446F75626C65436C69636B262628652E62726F777365724576656E742E697348616E646C656442794C6973747C7C73757065722E6F6E446F75626C65436C69636B';
wwv_flow_imp.g_varchar2_table(21762) := '286529297D6F6E4D6F757365446F776E2865297B636F6E737420743D652E62726F777365724576656E742E7461726765743B44492874297C7C4C492874297C7C73757065722E6F6E4D6F757365446F776E2865297D6F6E436F6E746578744D656E752865';
wwv_flow_imp.g_varchar2_table(21763) := '297B636F6E737420743D652E62726F777365724576656E742E7461726765743B44492874297C7C4C492874297C7C73757065722E6F6E436F6E746578744D656E752865297D7D636C61737320715520657874656E64732055497B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(21764) := '7228652C742C6E2C692C6F2C732C722C61297B737570657228652C742C6E2C692C61292C746869732E666F63757354726169743D6F2C746869732E73656C656374696F6E54726169743D732C746869732E616E63686F7254726169743D727D6372656174';
wwv_flow_imp.g_varchar2_table(21765) := '654D6F757365436F6E74726F6C6C65722865297B72657475726E206E6577206A5528746869732C652E747265652C652E737469636B795363726F6C6C50726F7669646572297D73706C69636528652C742C6E3D5B5D297B69662873757065722E73706C69';
wwv_flow_imp.g_varchar2_table(21766) := '636528652C742C6E292C303D3D3D6E2E6C656E6774682972657475726E3B636F6E737420693D5B5D2C6F3D5B5D3B6C657420733B6E2E666F7245616368282828742C6E293D3E7B746869732E666F63757354726169742E6861732874292626692E707573';
wwv_flow_imp.g_varchar2_table(21767) := '6828652B6E292C746869732E73656C656374696F6E54726169742E68617328742926266F2E7075736828652B6E292C746869732E616E63686F7254726169742E686173287429262628733D652B6E297D29292C692E6C656E6774683E3026267375706572';
wwv_flow_imp.g_varchar2_table(21768) := '2E736574466F637573287168285B2E2E2E73757065722E676574466F63757328292C2E2E2E695D29292C6F2E6C656E6774683E30262673757065722E73657453656C656374696F6E287168285B2E2E2E73757065722E67657453656C656374696F6E2829';
wwv_flow_imp.g_varchar2_table(21769) := '2C2E2E2E6F5D29292C226E756D626572223D3D747970656F662073262673757065722E736574416E63686F722873297D736574466F63757328652C742C6E3D2131297B73757065722E736574466F63757328652C74292C6E7C7C746869732E666F637573';
wwv_flow_imp.g_varchar2_table(21770) := '54726169742E73657428652E6D61702828653D3E746869732E656C656D656E7428652929292C74297D73657453656C656374696F6E28652C742C6E3D2131297B73757065722E73657453656C656374696F6E28652C74292C6E7C7C746869732E73656C65';
wwv_flow_imp.g_varchar2_table(21771) := '6374696F6E54726169742E73657428652E6D61702828653D3E746869732E656C656D656E7428652929292C74297D736574416E63686F7228652C743D2131297B73757065722E736574416E63686F722865292C747C7C28766F696420303D3D3D653F7468';
wwv_flow_imp.g_varchar2_table(21772) := '69732E616E63686F7254726169742E736574285B5D293A746869732E616E63686F7254726169742E736574285B746869732E656C656D656E742865295D29297D7D636C6173732024557B676574206F6E4469645363726F6C6C28297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(21773) := '6869732E766965772E6F6E4469645363726F6C6C7D676574206F6E4469644368616E6765466F63757328297B72657475726E20746869732E6576656E7442756666657265722E777261704576656E7428746869732E666F6375732E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(21774) := '6765297D676574206F6E4469644368616E676553656C656374696F6E28297B72657475726E20746869732E6576656E7442756666657265722E777261704576656E7428746869732E73656C656374696F6E2E6F6E4469644368616E6765297D676574206F';
wwv_flow_imp.g_varchar2_table(21775) := '6E4D6F75736544626C436C69636B28297B72657475726E2076742E66696C7465722876742E6D617028746869732E766965772E6F6E4D6F75736544626C436C69636B2C5655292C28653D3E652E746172676574213D3D68552E46696C74657229297D6765';
wwv_flow_imp.g_varchar2_table(21776) := '74206F6E4D6F7573654F76657228297B72657475726E2076742E6D617028746869732E766965772E6F6E4D6F7573654F7665722C5655297D676574206F6E4D6F7573654F757428297B72657475726E2076742E6D617028746869732E766965772E6F6E4D';
wwv_flow_imp.g_varchar2_table(21777) := '6F7573654F75742C5655297D676574206F6E436F6E746578744D656E7528297B76617220652C743B72657475726E2076742E616E792876742E66696C7465722876742E6D617028746869732E766965772E6F6E436F6E746578744D656E752C7A55292C28';
wwv_flow_imp.g_varchar2_table(21778) := '653D3E21652E6973537469636B795363726F6C6C29292C6E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E737469636B795363726F6C6C436F6E74726F6C6C6572297C7C766F696420303D3D3D653F766F696420303A652E6F6E436F6E7465';
wwv_flow_imp.g_varchar2_table(21779) := '78744D656E75292626766F69642030213D3D743F743A76742E4E6F6E65297D676574206F6E506F696E74657228297B72657475726E2076742E6D617028746869732E766965772E6F6E506F696E7465722C5655297D676574206F6E4B6579446F776E2829';
wwv_flow_imp.g_varchar2_table(21780) := '7B72657475726E20746869732E766965772E6F6E4B6579446F776E7D676574206F6E446964466F63757328297B72657475726E20746869732E766965772E6F6E446964466F6375737D676574206F6E4469644368616E67654D6F64656C28297B72657475';
wwv_flow_imp.g_varchar2_table(21781) := '726E2076742E7369676E616C28746869732E6D6F64656C2E6F6E44696453706C696365297D676574206F6E4469644368616E6765436F6C6C61707365537461746528297B72657475726E20746869732E6D6F64656C2E6F6E4469644368616E6765436F6C';
wwv_flow_imp.g_varchar2_table(21782) := '6C6170736553746174657D6765742066696E644D6F646528297B76617220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E66696E64436F6E74726F6C6C6572297C7C766F696420303D3D3D653F766F69642030';
wwv_flow_imp.g_varchar2_table(21783) := '3A652E6D6F6465292626766F69642030213D3D743F743A5F552E486967686C696768747D7365742066696E644D6F64652865297B746869732E66696E64436F6E74726F6C6C6572262628746869732E66696E64436F6E74726F6C6C65722E6D6F64653D65';
wwv_flow_imp.g_varchar2_table(21784) := '297D6765742066696E644D617463685479706528297B76617220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E66696E64436F6E74726F6C6C6572297C7C766F696420303D3D3D653F766F696420303A652E6D';
wwv_flow_imp.g_varchar2_table(21785) := '6174636854797065292626766F69642030213D3D743F743A79552E46757A7A797D7365742066696E644D61746368547970652865297B746869732E66696E64436F6E74726F6C6C6572262628746869732E66696E64436F6E74726F6C6C65722E6D617463';
wwv_flow_imp.g_varchar2_table(21786) := '68547970653D65297D67657420657870616E644F6E446F75626C65436C69636B28297B72657475726E20766F696420303D3D3D746869732E5F6F7074696F6E732E657870616E644F6E446F75626C65436C69636B7C7C746869732E5F6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(21787) := '657870616E644F6E446F75626C65436C69636B7D67657420657870616E644F6E6C794F6E54776973746965436C69636B28297B72657475726E20766F696420303D3D3D746869732E5F6F7074696F6E732E657870616E644F6E6C794F6E54776973746965';
wwv_flow_imp.g_varchar2_table(21788) := '436C69636B7C7C746869732E5F6F7074696F6E732E657870616E644F6E6C794F6E54776973746965436C69636B7D676574206F6E446964446973706F736528297B72657475726E20746869732E766965772E6F6E446964446973706F73657D636F6E7374';
wwv_flow_imp.g_varchar2_table(21789) := '727563746F7228652C742C6E2C692C6F3D7B7D297B76617220733B746869732E5F757365723D652C746869732E5F6F7074696F6E733D6F2C746869732E6576656E7442756666657265723D6E65772044742C746869732E6F6E4469644368616E67654669';
wwv_flow_imp.g_varchar2_table(21790) := '6E644F70656E53746174653D76742E4E6F6E652C746869732E6F6E4469644368616E6765537469636B795363726F6C6C466F63757365643D76742E4E6F6E652C746869732E646973706F7361626C65733D6E65772061742C746869732E5F6F6E57696C6C';
wwv_flow_imp.g_varchar2_table(21791) := '526566696C7465723D6E65772043742C746869732E6F6E57696C6C526566696C7465723D746869732E5F6F6E57696C6C526566696C7465722E6576656E742C746869732E5F6F6E4469645570646174654F7074696F6E733D6E65772043742C746869732E';
wwv_flow_imp.g_varchar2_table(21792) := '7472656544656C65676174653D6E6577204C55286E293B636F6E737420723D6E65772054742C613D6E65772054742C6C3D746869732E646973706F7361626C65732E616464286E657720445528612E6576656E7429292C633D6E65772063613B74686973';
wwv_flow_imp.g_varchar2_table(21793) := '2E72656E6465726572733D692E6D61702828653D3E6E657720545528652C2828293D3E746869732E6D6F64656C292C722E6576656E742C6C2C632C6F2929293B666F7228636F6E73742065206F6620746869732E72656E64657265727329746869732E64';
wwv_flow_imp.g_varchar2_table(21794) := '6973706F7361626C65732E6164642865293B6C657420643B6F2E6B6579626F6172644E617669676174696F6E4C6162656C50726F7669646572262628643D6E657720495528746869732C6F2E6B6579626F6172644E617669676174696F6E4C6162656C50';
wwv_flow_imp.g_varchar2_table(21795) := '726F76696465722C6F2E66696C746572292C6F3D7B2E2E2E6F2C66696C7465723A647D2C746869732E646973706F7361626C65732E616464286429292C746869732E666F6375733D6E6577205755282828293D3E746869732E766965772E676574466F63';
wwv_flow_imp.g_varchar2_table(21796) := '75736564456C656D656E747328295B305D292C6F2E6964656E7469747950726F7669646572292C746869732E73656C656374696F6E3D6E6577205755282828293D3E746869732E766965772E67657453656C6563746564456C656D656E747328295B305D';
wwv_flow_imp.g_varchar2_table(21797) := '292C6F2E6964656E7469747950726F7669646572292C746869732E616E63686F723D6E6577205755282828293D3E746869732E766965772E676574416E63686F72456C656D656E742829292C6F2E6964656E7469747950726F7669646572292C74686973';
wwv_flow_imp.g_varchar2_table(21798) := '2E766965773D6E657720715528652C742C746869732E7472656544656C65676174652C746869732E72656E6465726572732C746869732E666F6375732C746869732E73656C656374696F6E2C746869732E616E63686F722C7B2E2E2E4555282828293D3E';
wwv_flow_imp.g_varchar2_table(21799) := '746869732E6D6F64656C292C6F292C747265653A746869732C737469636B795363726F6C6C50726F76696465723A28293D3E746869732E737469636B795363726F6C6C436F6E74726F6C6C65727D292C746869732E6D6F64656C3D746869732E63726561';
wwv_flow_imp.g_varchar2_table(21800) := '74654D6F64656C28652C746869732E766965772C6F292C722E696E7075743D746869732E6D6F64656C2E6F6E4469644368616E6765436F6C6C6170736553746174653B636F6E737420683D76742E666F724561636828746869732E6D6F64656C2E6F6E44';
wwv_flow_imp.g_varchar2_table(21801) := '696453706C6963652C28653D3E7B746869732E6576656E7442756666657265722E6275666665724576656E7473282828293D3E7B746869732E666F6375732E6F6E4469644D6F64656C53706C6963652865292C746869732E73656C656374696F6E2E6F6E';
wwv_flow_imp.g_varchar2_table(21802) := '4469644D6F64656C53706C6963652865297D29297D292C746869732E646973706F7361626C6573293B68282828293D3E6E756C6C292C6E756C6C2C746869732E646973706F7361626C6573293B636F6E737420753D746869732E646973706F7361626C65';
wwv_flow_imp.g_varchar2_table(21803) := '732E616464286E6577204374292C703D746869732E646973706F7361626C65732E616464286E6577207A74283029293B696628746869732E646973706F7361626C65732E6164642876742E616E7928682C746869732E666F6375732E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(21804) := '6E67652C746869732E73656C656374696F6E2E6F6E4469644368616E676529282828293D3E7B702E74726967676572282828293D3E7B636F6E737420653D6E6577205365743B666F7228636F6E73742074206F6620746869732E666F6375732E6765744E';
wwv_flow_imp.g_varchar2_table(21805) := '6F646573282929652E6164642874293B666F7228636F6E73742074206F6620746869732E73656C656374696F6E2E6765744E6F646573282929652E6164642874293B752E66697265285B2E2E2E652E76616C75657328295D297D29297D2929292C612E69';
wwv_flow_imp.g_varchar2_table(21806) := '6E7075743D752E6576656E742C2131213D3D6F2E6B6579626F617264537570706F7274297B636F6E737420653D76742E636861696E28746869732E766965772E6F6E4B6579446F776E2C28653D3E652E66696C7465722828653D3E21784928652E746172';
wwv_flow_imp.g_varchar2_table(21807) := '6765742929292E6D61702828653D3E6E6577207165286529292929293B76742E636861696E28652C28653D3E652E66696C7465722828653D3E31353D3D3D652E6B6579436F64652929292928746869732E6F6E4C6566744172726F772C746869732C7468';
wwv_flow_imp.g_varchar2_table(21808) := '69732E646973706F7361626C6573292C76742E636861696E28652C28653D3E652E66696C7465722828653D3E31373D3D3D652E6B6579436F64652929292928746869732E6F6E52696768744172726F772C746869732C746869732E646973706F7361626C';
wwv_flow_imp.g_varchar2_table(21809) := '6573292C76742E636861696E28652C28653D3E652E66696C7465722828653D3E31303D3D3D652E6B6579436F64652929292928746869732E6F6E53706163652C746869732C746869732E646973706F7361626C6573297D696628286E756C6C3D3D3D2873';
wwv_flow_imp.g_varchar2_table(21810) := '3D6F2E66696E64576964676574456E61626C6564297C7C766F696420303D3D3D737C7C732926266F2E6B6579626F6172644E617669676174696F6E4C6162656C50726F766964657226266F2E636F6E746578745669657750726F7669646572297B636F6E';
wwv_flow_imp.g_varchar2_table(21811) := '737420653D746869732E6F7074696F6E732E66696E645769646765745374796C65733F7B7374796C65733A746869732E6F7074696F6E732E66696E645769646765745374796C65737D3A766F696420303B746869732E66696E64436F6E74726F6C6C6572';
wwv_flow_imp.g_varchar2_table(21812) := '3D6E6577204D5528746869732C746869732E6D6F64656C2C746869732E766965772C642C6F2E636F6E746578745669657750726F76696465722C65292C746869732E666F6375734E617669676174696F6E46696C7465723D653D3E746869732E66696E64';
wwv_flow_imp.g_varchar2_table(21813) := '436F6E74726F6C6C65722E73686F756C64416C6C6F77466F6375732865292C746869732E6F6E4469644368616E676546696E644F70656E53746174653D746869732E66696E64436F6E74726F6C6C65722E6F6E4469644368616E67654F70656E53746174';
wwv_flow_imp.g_varchar2_table(21814) := '652C746869732E646973706F7361626C65732E61646428746869732E66696E64436F6E74726F6C6C6572292C746869732E6F6E4469644368616E676546696E644D6F64653D746869732E66696E64436F6E74726F6C6C65722E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(21815) := '4D6F64652C746869732E6F6E4469644368616E676546696E644D61746368547970653D746869732E66696E64436F6E74726F6C6C65722E6F6E4469644368616E67654D61746368547970657D656C736520746869732E6F6E4469644368616E676546696E';
wwv_flow_imp.g_varchar2_table(21816) := '644D6F64653D76742E4E6F6E652C746869732E6F6E4469644368616E676546696E644D61746368547970653D76742E4E6F6E653B6F2E656E61626C65537469636B795363726F6C6C262628746869732E737469636B795363726F6C6C436F6E74726F6C6C';
wwv_flow_imp.g_varchar2_table(21817) := '65723D6E657720525528746869732C746869732E6D6F64656C2C746869732E766965772C746869732E72656E6465726572732C746869732E7472656544656C65676174652C6F292C746869732E6F6E4469644368616E6765537469636B795363726F6C6C';
wwv_flow_imp.g_varchar2_table(21818) := '466F63757365643D746869732E737469636B795363726F6C6C436F6E74726F6C6C65722E6F6E4469644368616E6765486173466F637573292C746869732E7374796C65456C656D656E743D597328746869732E766965772E67657448544D4C456C656D65';
wwv_flow_imp.g_varchar2_table(21819) := '6E742829292C746869732E67657448544D4C456C656D656E7428292E636C6173734C6973742E746F67676C652822616C77617973222C746869732E5F6F7074696F6E732E72656E646572496E64656E744775696465733D3D3D62552E416C77617973297D';
wwv_flow_imp.g_varchar2_table(21820) := '7570646174654F7074696F6E7328653D7B7D297B76617220743B746869732E5F6F7074696F6E733D7B2E2E2E746869732E5F6F7074696F6E732C2E2E2E657D3B666F7228636F6E73742074206F6620746869732E72656E64657265727329742E75706461';
wwv_flow_imp.g_varchar2_table(21821) := '74654F7074696F6E732865293B746869732E766965772E7570646174654F7074696F6E7328746869732E5F6F7074696F6E73292C6E756C6C3D3D3D28743D746869732E66696E64436F6E74726F6C6C6572297C7C766F696420303D3D3D747C7C742E7570';
wwv_flow_imp.g_varchar2_table(21822) := '646174654F7074696F6E732865292C746869732E757064617465537469636B795363726F6C6C2865292C746869732E5F6F6E4469645570646174654F7074696F6E732E6669726528746869732E5F6F7074696F6E73292C746869732E67657448544D4C45';
wwv_flow_imp.g_varchar2_table(21823) := '6C656D656E7428292E636C6173734C6973742E746F67676C652822616C77617973222C746869732E5F6F7074696F6E732E72656E646572496E64656E744775696465733D3D3D62552E416C77617973297D676574206F7074696F6E7328297B7265747572';
wwv_flow_imp.g_varchar2_table(21824) := '6E20746869732E5F6F7074696F6E737D757064617465537469636B795363726F6C6C2865297B76617220743B21746869732E737469636B795363726F6C6C436F6E74726F6C6C65722626746869732E5F6F7074696F6E732E656E61626C65537469636B79';
wwv_flow_imp.g_varchar2_table(21825) := '5363726F6C6C3F28746869732E737469636B795363726F6C6C436F6E74726F6C6C65723D6E657720525528746869732C746869732E6D6F64656C2C746869732E766965772C746869732E72656E6465726572732C746869732E7472656544656C65676174';
wwv_flow_imp.g_varchar2_table(21826) := '652C746869732E5F6F7074696F6E73292C746869732E6F6E4469644368616E6765537469636B795363726F6C6C466F63757365643D746869732E737469636B795363726F6C6C436F6E74726F6C6C65722E6F6E4469644368616E6765486173466F637573';
wwv_flow_imp.g_varchar2_table(21827) := '293A746869732E737469636B795363726F6C6C436F6E74726F6C6C6572262621746869732E5F6F7074696F6E732E656E61626C65537469636B795363726F6C6C262628746869732E6F6E4469644368616E6765537469636B795363726F6C6C466F637573';
wwv_flow_imp.g_varchar2_table(21828) := '65643D76742E4E6F6E652C746869732E737469636B795363726F6C6C436F6E74726F6C6C65722E646973706F736528292C746869732E737469636B795363726F6C6C436F6E74726F6C6C65723D766F69642030292C6E756C6C3D3D3D28743D746869732E';
wwv_flow_imp.g_varchar2_table(21829) := '737469636B795363726F6C6C436F6E74726F6C6C6572297C7C766F696420303D3D3D747C7C742E7570646174654F7074696F6E732865297D67657448544D4C456C656D656E7428297B72657475726E20746869732E766965772E67657448544D4C456C65';
wwv_flow_imp.g_varchar2_table(21830) := '6D656E7428297D676574207363726F6C6C546F7028297B72657475726E20746869732E766965772E7363726F6C6C546F707D736574207363726F6C6C546F702865297B746869732E766965772E7363726F6C6C546F703D657D676574207363726F6C6C48';
wwv_flow_imp.g_varchar2_table(21831) := '656967687428297B72657475726E20746869732E766965772E7363726F6C6C4865696768747D6765742072656E64657248656967687428297B72657475726E20746869732E766965772E72656E6465724865696768747D67657420617269614C6162656C';
wwv_flow_imp.g_varchar2_table(21832) := '28297B72657475726E20746869732E766965772E617269614C6162656C7D73657420617269614C6162656C2865297B746869732E766965772E617269614C6162656C3D657D646F6D466F63757328297B76617220653B286E756C6C3D3D3D28653D746869';
wwv_flow_imp.g_varchar2_table(21833) := '732E737469636B795363726F6C6C436F6E74726F6C6C6572297C7C766F696420303D3D3D653F766F696420303A652E666F63757365644C6173742829293F746869732E737469636B795363726F6C6C436F6E74726F6C6C65722E646F6D466F6375732829';
wwv_flow_imp.g_varchar2_table(21834) := '3A746869732E766965772E646F6D466F63757328297D6C61796F757428652C74297B766172206E3B746869732E766965772E6C61796F757428652C74292C676C2874292626286E756C6C3D3D3D286E3D746869732E66696E64436F6E74726F6C6C657229';
wwv_flow_imp.g_varchar2_table(21835) := '7C7C766F696420303D3D3D6E7C7C6E2E6C61796F7574287429297D7374796C652865297B76617220742C6E3B636F6E737420693D602E247B746869732E766965772E646F6D49647D602C6F3D5B5D3B652E74726565496E64656E74477569646573537472';
wwv_flow_imp.g_varchar2_table(21836) := '6F6B652626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A686F766572202E6D6F6E61636F2D746C2D696E64656E74203E202E696E64656E742D67756964652C202E6D6F6E61636F2D6C697374247B697D2E616C77617973202E6D6F6E';
wwv_flow_imp.g_varchar2_table(21837) := '61636F2D746C2D696E64656E74203E202E696E64656E742D677569646520207B20626F726465722D636F6C6F723A20247B652E74726565496E616374697665496E64656E744775696465735374726F6B657D3B207D60292C6F2E7075736828602E6D6F6E';
wwv_flow_imp.g_varchar2_table(21838) := '61636F2D6C697374247B697D202E6D6F6E61636F2D746C2D696E64656E74203E202E696E64656E742D67756964652E616374697665207B20626F726465722D636F6C6F723A20247B652E74726565496E64656E744775696465735374726F6B657D3B207D';
wwv_flow_imp.g_varchar2_table(21839) := '6029293B636F6E737420733D6E756C6C213D3D28743D652E74726565537469636B795363726F6C6C4261636B67726F756E64292626766F69642030213D3D743F743A652E6C6973744261636B67726F756E643B732626286F2E7075736828602E6D6F6E61';
wwv_flow_imp.g_varchar2_table(21840) := '636F2D6C697374247B697D202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E6572207B206261636B67726F756E642D636F6C6F723A20247B737D3B207D60292C6F';
wwv_flow_imp.g_varchar2_table(21841) := '2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E6572202E6D6F6E61636F2D747265652D737469636B79';
wwv_flow_imp.g_varchar2_table(21842) := '2D726F77207B206261636B67726F756E642D636F6C6F723A20247B737D3B207D6029292C652E74726565537469636B795363726F6C6C426F7264657226266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D7363726F6C';
wwv_flow_imp.g_varchar2_table(21843) := '6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E6572207B20626F726465722D626F74746F6D3A2031707820736F6C696420247B652E74726565537469636B795363726F6C6C426F726465727D3B20';
wwv_flow_imp.g_varchar2_table(21844) := '7D60292C652E74726565537469636B795363726F6C6C536861646F7726266F2E7075736828602E6D6F6E61636F2D6C697374247B697D202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B';
wwv_flow_imp.g_varchar2_table(21845) := '792D636F6E7461696E6572202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65722D736861646F77207B20626F782D736861646F773A20247B652E74726565537469636B795363726F6C6C536861646F777D20302036707820367078';
wwv_flow_imp.g_varchar2_table(21846) := '202D36707820696E7365743B206865696768743A203370783B207D60292C652E6C697374466F637573466F726567726F756E642626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D2E737469636B792D7363726F6C6C2D666F6375736564';
wwv_flow_imp.g_varchar2_table(21847) := '202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65723A666F637573202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B20636F6C6F723A20247B';
wwv_flow_imp.g_varchar2_table(21848) := '652E6C697374466F637573466F726567726F756E647D3B207D60292C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A6E6F74282E737469636B792D7363726F6C6C2D666F637573656429202E6D6F6E61636F2D7363726F6C6C61626C652D';
wwv_flow_imp.g_varchar2_table(21849) := '656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E6572202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B20636F6C6F723A20696E68657269743B207D6029293B636F6E737420723D6B7228652E6C';
wwv_flow_imp.g_varchar2_table(21850) := '697374466F637573416E6453656C656374696F6E4F75746C696E652C6B7228652E6C69737453656C656374696F6E4F75746C696E652C6E756C6C213D3D286E3D652E6C697374466F6375734F75746C696E65292626766F69642030213D3D6E3F6E3A2222';
wwv_flow_imp.g_varchar2_table(21851) := '29293B722626286F2E7075736828602E6D6F6E61636F2D6C697374247B697D2E737469636B792D7363726F6C6C2D666F6375736564202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B79';
wwv_flow_imp.g_varchar2_table(21852) := '2D636F6E7461696E65723A666F637573202E6D6F6E61636F2D6C6973742D726F772E666F63757365642E73656C6563746564207B206F75746C696E653A2031707820736F6C696420247B727D3B206F75746C696E652D6F66667365743A202D3170783B7D';
wwv_flow_imp.g_varchar2_table(21853) := '60292C6F2E7075736828602E6D6F6E61636F2D6C697374247B697D3A6E6F74282E737469636B792D7363726F6C6C2D666F637573656429202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D73746963';
wwv_flow_imp.g_varchar2_table(21854) := '6B792D636F6E7461696E6572202E6D6F6E61636F2D6C6973742D726F772E666F63757365642E73656C6563746564207B206F75746C696E653A20696E68657269743B7D6029292C652E6C697374466F6375734F75746C696E652626286F2E707573682860';
wwv_flow_imp.g_varchar2_table(21855) := '2E6D6F6E61636F2D6C697374247B697D2E737469636B792D7363726F6C6C2D666F6375736564202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E7461696E65723A666F6375';
wwv_flow_imp.g_varchar2_table(21856) := '73202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206F75746C696E653A2031707820736F6C696420247B652E6C697374466F6375734F75746C696E657D3B206F75746C696E652D6F66667365743A202D3170783B207D60292C6F2E70';
wwv_flow_imp.g_varchar2_table(21857) := '75736828602E6D6F6E61636F2D6C697374247B697D3A6E6F74282E737469636B792D7363726F6C6C2D666F637573656429202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B792D636F6E';
wwv_flow_imp.g_varchar2_table(21858) := '7461696E6572202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206F75746C696E653A20696E68657269743B207D60292C6F2E7075736828602E6D6F6E61636F2D776F726B62656E63682E636F6E746578742D6D656E752D7669736962';
wwv_flow_imp.g_varchar2_table(21859) := '6C65202E6D6F6E61636F2D6C697374247B697D2E6C6173742D666F63757365642E737469636B792D7363726F6C6C2D666F6375736564202E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74202E6D6F6E61636F2D747265652D737469636B';
wwv_flow_imp.g_varchar2_table(21860) := '792D636F6E7461696E6572202E6D6F6E61636F2D6C6973742D726F772E706173736976652D666F6375736564207B206F75746C696E653A2031707820736F6C696420247B652E6C697374466F6375734F75746C696E657D3B206F75746C696E652D6F6666';
wwv_flow_imp.g_varchar2_table(21861) := '7365743A202D3170783B207D60292C6F2E7075736828602E6D6F6E61636F2D776F726B62656E63682E636F6E746578742D6D656E752D76697369626C65202E6D6F6E61636F2D6C697374247B697D2E6C6173742D666F63757365642E737469636B792D73';
wwv_flow_imp.g_varchar2_table(21862) := '63726F6C6C2D666F6375736564202E6D6F6E61636F2D6C6973742D726F7773202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206F75746C696E653A20696E68657269743B207D60292C6F2E7075736828602E6D6F6E61636F2D776F72';
wwv_flow_imp.g_varchar2_table(21863) := '6B62656E63682E636F6E746578742D6D656E752D76697369626C65202E6D6F6E61636F2D6C697374247B697D2E6C6173742D666F63757365643A6E6F74282E737469636B792D7363726F6C6C2D666F637573656429202E6D6F6E61636F2D747265652D73';
wwv_flow_imp.g_varchar2_table(21864) := '7469636B792D636F6E7461696E6572202E6D6F6E61636F2D6C6973742D726F7773202E6D6F6E61636F2D6C6973742D726F772E666F6375736564207B206F75746C696E653A20696E68657269743B207D6029292C746869732E7374796C65456C656D656E';
wwv_flow_imp.g_varchar2_table(21865) := '742E74657874436F6E74656E743D6F2E6A6F696E28225C6E22292C746869732E766965772E7374796C652865297D676574506172656E74456C656D656E742865297B636F6E737420743D746869732E6D6F64656C2E676574506172656E744E6F64654C6F';
wwv_flow_imp.g_varchar2_table(21866) := '636174696F6E2865293B72657475726E20746869732E6D6F64656C2E6765744E6F64652874292E656C656D656E747D6765744669727374456C656D656E744368696C642865297B72657475726E20746869732E6D6F64656C2E6765744669727374456C65';
wwv_flow_imp.g_varchar2_table(21867) := '6D656E744368696C642865297D6765744E6F64652865297B72657475726E20746869732E6D6F64656C2E6765744E6F64652865297D6765744E6F64654C6F636174696F6E2865297B72657475726E20746869732E6D6F64656C2E6765744E6F64654C6F63';
wwv_flow_imp.g_varchar2_table(21868) := '6174696F6E2865297D636F6C6C6170736528652C743D2131297B72657475726E20746869732E6D6F64656C2E736574436F6C6C617073656428652C21302C74297D657870616E6428652C743D2131297B72657475726E20746869732E6D6F64656C2E7365';
wwv_flow_imp.g_varchar2_table(21869) := '74436F6C6C617073656428652C21312C74297D746F67676C65436F6C6C617073656428652C743D2131297B72657475726E20746869732E6D6F64656C2E736574436F6C6C617073656428652C766F696420302C74297D6973436F6C6C61707369626C6528';
wwv_flow_imp.g_varchar2_table(21870) := '65297B72657475726E20746869732E6D6F64656C2E6973436F6C6C61707369626C652865297D736574436F6C6C61707369626C6528652C74297B72657475726E20746869732E6D6F64656C2E736574436F6C6C61707369626C6528652C74297D6973436F';
wwv_flow_imp.g_varchar2_table(21871) := '6C6C61707365642865297B72657475726E20746869732E6D6F64656C2E6973436F6C6C61707365642865297D726566696C74657228297B746869732E5F6F6E57696C6C526566696C7465722E6669726528766F69642030292C746869732E6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(21872) := '726566696C74657228297D73657453656C656374696F6E28652C74297B746869732E6576656E7442756666657265722E6275666665724576656E7473282828293D3E7B636F6E7374206E3D652E6D61702828653D3E746869732E6D6F64656C2E6765744E';
wwv_flow_imp.g_varchar2_table(21873) := '6F646528652929293B746869732E73656C656374696F6E2E736574286E2C74293B636F6E737420693D652E6D61702828653D3E746869732E6D6F64656C2E6765744C697374496E64657828652929292E66696C7465722828653D3E653E2D3129293B7468';
wwv_flow_imp.g_varchar2_table(21874) := '69732E766965772E73657453656C656374696F6E28692C742C2130297D29297D67657453656C656374696F6E28297B72657475726E20746869732E73656C656374696F6E2E67657428297D736574466F63757328652C74297B746869732E6576656E7442';
wwv_flow_imp.g_varchar2_table(21875) := '756666657265722E6275666665724576656E7473282828293D3E7B636F6E7374206E3D652E6D61702828653D3E746869732E6D6F64656C2E6765744E6F646528652929293B746869732E666F6375732E736574286E2C74293B636F6E737420693D652E6D';
wwv_flow_imp.g_varchar2_table(21876) := '61702828653D3E746869732E6D6F64656C2E6765744C697374496E64657828652929292E66696C7465722828653D3E653E2D3129293B746869732E766965772E736574466F63757328692C742C2130297D29297D666F6375734E65787428653D312C743D';
wwv_flow_imp.g_varchar2_table(21877) := '21312C6E2C693D287272286E2926266E2E616C744B65793F766F696420303A746869732E666F6375734E617669676174696F6E46696C74657229297B746869732E766965772E666F6375734E65787428652C742C6E2C69297D666F63757350726576696F';
wwv_flow_imp.g_varchar2_table(21878) := '757328653D312C743D21312C6E2C693D287272286E2926266E2E616C744B65793F766F696420303A746869732E666F6375734E617669676174696F6E46696C74657229297B746869732E766965772E666F63757350726576696F757328652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(21879) := '297D666F6375734E6578745061676528652C743D2872722865292626652E616C744B65793F766F696420303A746869732E666F6375734E617669676174696F6E46696C74657229297B72657475726E20746869732E766965772E666F6375734E65787450';
wwv_flow_imp.g_varchar2_table(21880) := '61676528652C74297D666F63757350726576696F75735061676528652C743D2872722865292626652E616C744B65793F766F696420303A746869732E666F6375734E617669676174696F6E46696C74657229297B72657475726E20746869732E76696577';
wwv_flow_imp.g_varchar2_table(21881) := '2E666F63757350726576696F75735061676528652C742C2828293D3E7B76617220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E737469636B795363726F6C6C436F6E74726F6C6C6572297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(21882) := '3D3D3D653F766F696420303A652E686569676874292626766F69642030213D3D743F743A307D29297D666F637573466972737428652C743D2872722865292626652E616C744B65793F766F696420303A746869732E666F6375734E617669676174696F6E';
wwv_flow_imp.g_varchar2_table(21883) := '46696C74657229297B746869732E766965772E666F637573466972737428652C74297D676574466F63757328297B72657475726E20746869732E666F6375732E67657428297D72657665616C28652C74297B746869732E6D6F64656C2E657870616E6454';
wwv_flow_imp.g_varchar2_table(21884) := '6F2865293B636F6E7374206E3D746869732E6D6F64656C2E6765744C697374496E6465782865293B6966282D31213D3D6E29696628746869732E737469636B795363726F6C6C436F6E74726F6C6C6572297B636F6E737420693D746869732E737469636B';
wwv_flow_imp.g_varchar2_table(21885) := '795363726F6C6C436F6E74726F6C6C65722E6E6F6465506F736974696F6E546F7042656C6F7757696467657428746869732E6765744E6F6465286529293B746869732E766965772E72657665616C286E2C742C69297D656C736520746869732E76696577';
wwv_flow_imp.g_varchar2_table(21886) := '2E72657665616C286E2C74297D6F6E4C6566744172726F772865297B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28293B636F6E737420743D746869732E766965772E676574466F6375736564456C656D65';
wwv_flow_imp.g_varchar2_table(21887) := '6E747328293B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D745B305D2C693D746869732E6D6F64656C2E6765744E6F64654C6F636174696F6E286E293B69662821746869732E6D6F64656C2E736574436F6C6C61707365';
wwv_flow_imp.g_varchar2_table(21888) := '6428692C213029297B636F6E737420653D746869732E6D6F64656C2E676574506172656E744E6F64654C6F636174696F6E2869293B69662821652972657475726E3B636F6E737420743D746869732E6D6F64656C2E6765744C697374496E646578286529';
wwv_flow_imp.g_varchar2_table(21889) := '3B746869732E766965772E72657665616C2874292C746869732E766965772E736574466F637573285B745D297D7D6F6E52696768744172726F772865297B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E2829';
wwv_flow_imp.g_varchar2_table(21890) := '3B636F6E737420743D746869732E766965772E676574466F6375736564456C656D656E747328293B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D745B305D2C693D746869732E6D6F64656C2E6765744E6F64654C6F6361';
wwv_flow_imp.g_varchar2_table(21891) := '74696F6E286E293B69662821746869732E6D6F64656C2E736574436F6C6C617073656428692C213129297B696628216E2E6368696C6472656E2E736F6D652828653D3E652E76697369626C6529292972657475726E3B636F6E73745B655D3D746869732E';
wwv_flow_imp.g_varchar2_table(21892) := '766965772E676574466F63757328292C743D652B313B746869732E766965772E72657665616C2874292C746869732E766965772E736574466F637573285B745D297D7D6F6E53706163652865297B652E70726576656E7444656661756C7428292C652E73';
wwv_flow_imp.g_varchar2_table(21893) := '746F7050726F7061676174696F6E28293B636F6E737420743D746869732E766965772E676574466F6375736564456C656D656E747328293B696628303D3D3D742E6C656E6774682972657475726E3B636F6E7374206E3D745B305D2C693D746869732E6D';
wwv_flow_imp.g_varchar2_table(21894) := '6F64656C2E6765744E6F64654C6F636174696F6E286E292C6F3D652E62726F777365724576656E742E616C744B65793B746869732E6D6F64656C2E736574436F6C6C617073656428692C766F696420302C6F297D646973706F736528297B76617220653B';
wwv_flow_imp.g_varchar2_table(21895) := '6F7428746869732E646973706F7361626C6573292C6E756C6C3D3D3D28653D746869732E737469636B795363726F6C6C436F6E74726F6C6C6572297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E766965772E646973706F';
wwv_flow_imp.g_varchar2_table(21896) := '736528297D7D636C6173732055557B636F6E7374727563746F7228652C742C6E3D7B7D297B746869732E757365723D652C746869732E726F6F745265663D6E756C6C2C746869732E6E6F6465733D6E6577204D61702C746869732E6E6F64657342794964';
wwv_flow_imp.g_varchar2_table(21897) := '656E746974793D6E6577204D61702C746869732E6D6F64656C3D6E657720765528652C742C6E756C6C2C6E292C746869732E6F6E44696453706C6963653D746869732E6D6F64656C2E6F6E44696453706C6963652C746869732E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(21898) := '65436F6C6C6170736553746174653D746869732E6D6F64656C2E6F6E4469644368616E6765436F6C6C6170736553746174652C746869732E6F6E4469644368616E676552656E6465724E6F6465436F756E743D746869732E6D6F64656C2E6F6E44696443';
wwv_flow_imp.g_varchar2_table(21899) := '68616E676552656E6465724E6F6465436F756E742C6E2E736F72746572262628746869732E736F727465723D7B636F6D706172653A28652C74293D3E6E2E736F727465722E636F6D7061726528652E656C656D656E742C742E656C656D656E74297D292C';
wwv_flow_imp.g_varchar2_table(21900) := '746869732E6964656E7469747950726F76696465723D6E2E6964656E7469747950726F76696465727D7365744368696C6472656E28652C743D5A652E656D70747928292C6E3D7B7D297B636F6E737420693D746869732E676574456C656D656E744C6F63';
wwv_flow_imp.g_varchar2_table(21901) := '6174696F6E2865293B746869732E5F7365744368696C6472656E28692C746869732E7072657365727665436F6C6C6170736553746174652874292C6E297D5F7365744368696C6472656E28652C743D5A652E656D70747928292C6E297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(21902) := '3D6E6577205365742C6F3D6E6577205365743B746869732E6D6F64656C2E73706C696365285B2E2E2E652C305D2C4E756D6265722E4D41585F56414C55452C742C7B2E2E2E6E2C6F6E4469644372656174654E6F64653A653D3E7B76617220743B696628';
wwv_flow_imp.g_varchar2_table(21903) := '6E756C6C3D3D3D652E656C656D656E742972657475726E3B636F6E737420733D653B696628692E61646428732E656C656D656E74292C746869732E6E6F6465732E73657428732E656C656D656E742C73292C746869732E6964656E7469747950726F7669';
wwv_flow_imp.g_varchar2_table(21904) := '646572297B636F6E737420653D746869732E6964656E7469747950726F76696465722E676574496428732E656C656D656E74292E746F537472696E6728293B6F2E6164642865292C746869732E6E6F64657342794964656E746974792E73657428652C73';
wwv_flow_imp.g_varchar2_table(21905) := '297D6E756C6C3D3D3D28743D6E2E6F6E4469644372656174654E6F6465297C7C766F696420303D3D3D747C7C742E63616C6C286E2C73297D2C6F6E44696444656C6574654E6F64653A653D3E7B76617220743B6966286E756C6C3D3D3D652E656C656D65';
wwv_flow_imp.g_varchar2_table(21906) := '6E742972657475726E3B636F6E737420733D653B696628692E68617328732E656C656D656E74297C7C746869732E6E6F6465732E64656C65746528732E656C656D656E74292C746869732E6964656E7469747950726F7669646572297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(21907) := '3D746869732E6964656E7469747950726F76696465722E676574496428732E656C656D656E74292E746F537472696E6728293B6F2E6861732865297C7C746869732E6E6F64657342794964656E746974792E64656C6574652865297D6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(21908) := '743D6E2E6F6E44696444656C6574654E6F6465297C7C766F696420303D3D3D747C7C742E63616C6C286E2C73297D7D297D7072657365727665436F6C6C61707365537461746528653D5A652E656D7074792829297B72657475726E20746869732E736F72';
wwv_flow_imp.g_varchar2_table(21909) := '746572262628653D5B2E2E2E655D2E736F727428746869732E736F727465722E636F6D706172652E62696E6428746869732E736F727465722929292C5A652E6D617028652C28653D3E7B6C657420743D746869732E6E6F6465732E67657428652E656C65';
wwv_flow_imp.g_varchar2_table(21910) := '6D656E74293B69662821742626746869732E6964656E7469747950726F7669646572297B636F6E7374206E3D746869732E6964656E7469747950726F76696465722E676574496428652E656C656D656E74292E746F537472696E6728293B743D74686973';
wwv_flow_imp.g_varchar2_table(21911) := '2E6E6F64657342794964656E746974792E676574286E297D6966282174297B6C657420743B72657475726E20743D766F696420303D3D3D652E636F6C6C61707365643F766F696420303A652E636F6C6C61707365643D3D3D64552E436F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(21912) := '7C7C652E636F6C6C61707365643D3D3D64552E50726573657276654F72436F6C6C61707365647C7C652E636F6C6C6170736564213D3D64552E457870616E6465642626652E636F6C6C6170736564213D3D64552E50726573657276654F72457870616E64';
wwv_flow_imp.g_varchar2_table(21913) := '65642626426F6F6C65616E28652E636F6C6C6170736564292C7B2E2E2E652C6368696C6472656E3A746869732E7072657365727665436F6C6C61707365537461746528652E6368696C6472656E292C636F6C6C61707365643A747D7D636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(21914) := '22626F6F6C65616E223D3D747970656F6620652E636F6C6C61707369626C653F652E636F6C6C61707369626C653A742E636F6C6C61707369626C653B6C657420693B72657475726E20693D766F696420303D3D3D652E636F6C6C61707365647C7C652E63';
wwv_flow_imp.g_varchar2_table(21915) := '6F6C6C61707365643D3D3D64552E50726573657276654F72436F6C6C61707365647C7C652E636F6C6C61707365643D3D3D64552E50726573657276654F72457870616E6465643F742E636F6C6C61707365643A652E636F6C6C61707365643D3D3D64552E';
wwv_flow_imp.g_varchar2_table(21916) := '436F6C6C61707365647C7C652E636F6C6C6170736564213D3D64552E457870616E6465642626426F6F6C65616E28652E636F6C6C6170736564292C7B2E2E2E652C636F6C6C61707369626C653A6E2C636F6C6C61707365643A692C6368696C6472656E3A';
wwv_flow_imp.g_varchar2_table(21917) := '746869732E7072657365727665436F6C6C61707365537461746528652E6368696C6472656E297D7D29297D726572656E6465722865297B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865293B746869732E6D6F64656C';
wwv_flow_imp.g_varchar2_table(21918) := '2E726572656E6465722874297D6765744669727374456C656D656E744368696C6428653D6E756C6C297B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865293B72657475726E20746869732E6D6F64656C2E6765744669';
wwv_flow_imp.g_varchar2_table(21919) := '727374456C656D656E744368696C642874297D6861732865297B72657475726E20746869732E6E6F6465732E6861732865297D6765744C697374496E6465782865297B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865';
wwv_flow_imp.g_varchar2_table(21920) := '293B72657475726E20746869732E6D6F64656C2E6765744C697374496E6465782874297D6765744C69737452656E646572436F756E742865297B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865293B72657475726E20';
wwv_flow_imp.g_varchar2_table(21921) := '746869732E6D6F64656C2E6765744C69737452656E646572436F756E742874297D6973436F6C6C61707369626C652865297B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865293B72657475726E20746869732E6D6F64';
wwv_flow_imp.g_varchar2_table(21922) := '656C2E6973436F6C6C61707369626C652874297D736574436F6C6C61707369626C6528652C74297B636F6E7374206E3D746869732E676574456C656D656E744C6F636174696F6E2865293B72657475726E20746869732E6D6F64656C2E736574436F6C6C';
wwv_flow_imp.g_varchar2_table(21923) := '61707369626C65286E2C74297D6973436F6C6C61707365642865297B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865293B72657475726E20746869732E6D6F64656C2E6973436F6C6C61707365642874297D73657443';
wwv_flow_imp.g_varchar2_table(21924) := '6F6C6C617073656428652C742C6E297B636F6E737420693D746869732E676574456C656D656E744C6F636174696F6E2865293B72657475726E20746869732E6D6F64656C2E736574436F6C6C617073656428692C742C6E297D657870616E64546F286529';
wwv_flow_imp.g_varchar2_table(21925) := '7B636F6E737420743D746869732E676574456C656D656E744C6F636174696F6E2865293B746869732E6D6F64656C2E657870616E64546F2874297D726566696C74657228297B746869732E6D6F64656C2E726566696C74657228297D6765744E6F646528';
wwv_flow_imp.g_varchar2_table(21926) := '653D6E756C6C297B6966286E756C6C3D3D3D652972657475726E20746869732E6D6F64656C2E6765744E6F646528746869732E6D6F64656C2E726F6F74526566293B636F6E737420743D746869732E6E6F6465732E6765742865293B6966282174297468';
wwv_flow_imp.g_varchar2_table(21927) := '726F77206E657720755528746869732E757365722C605472656520656C656D656E74206E6F7420666F756E643A20247B657D60293B72657475726E20747D6765744E6F64654C6F636174696F6E2865297B72657475726E20652E656C656D656E747D6765';
wwv_flow_imp.g_varchar2_table(21928) := '74506172656E744E6F64654C6F636174696F6E2865297B6966286E756C6C3D3D3D65297468726F77206E657720755528746869732E757365722C22496E76616C696420676574506172656E744E6F64654C6F636174696F6E2063616C6C22293B636F6E73';
wwv_flow_imp.g_varchar2_table(21929) := '7420743D746869732E6E6F6465732E6765742865293B6966282174297468726F77206E657720755528746869732E757365722C605472656520656C656D656E74206E6F7420666F756E643A20247B657D60293B636F6E7374206E3D746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(21930) := '6C2E6765744E6F64654C6F636174696F6E2874292C693D746869732E6D6F64656C2E676574506172656E744E6F64654C6F636174696F6E286E293B72657475726E20746869732E6D6F64656C2E6765744E6F64652869292E656C656D656E747D67657445';
wwv_flow_imp.g_varchar2_table(21931) := '6C656D656E744C6F636174696F6E2865297B6966286E756C6C3D3D3D652972657475726E5B5D3B636F6E737420743D746869732E6E6F6465732E6765742865293B6966282174297468726F77206E657720755528746869732E757365722C605472656520';
wwv_flow_imp.g_varchar2_table(21932) := '656C656D656E74206E6F7420666F756E643A20247B657D60293B72657475726E20746869732E6D6F64656C2E6765744E6F64654C6F636174696F6E2874297D7D66756E6374696F6E204B552865297B72657475726E7B656C656D656E743A7B656C656D65';
wwv_flow_imp.g_varchar2_table(21933) := '6E74733A5B652E656C656D656E745D2C696E636F6D707265737369626C653A652E696E636F6D707265737369626C657C7C21317D2C6368696C6472656E3A5A652E6D6170285A652E66726F6D28652E6368696C6472656E292C4B55292C636F6C6C617073';
wwv_flow_imp.g_varchar2_table(21934) := '69626C653A652E636F6C6C61707369626C652C636F6C6C61707365643A652E636F6C6C61707365647D7D66756E6374696F6E2047552865297B636F6E737420743D5B652E656C656D656E745D2C6E3D652E696E636F6D707265737369626C657C7C21313B';
wwv_flow_imp.g_varchar2_table(21935) := '6C657420692C6F3B666F72283B5B6F2C695D3D5A652E636F6E73756D65285A652E66726F6D28652E6368696C6472656E292C32292C313D3D3D6F2E6C656E6774682626216F5B305D2E696E636F6D707265737369626C653B29653D6F5B305D2C742E7075';
wwv_flow_imp.g_varchar2_table(21936) := '736828652E656C656D656E74293B72657475726E7B656C656D656E743A7B656C656D656E74733A742C696E636F6D707265737369626C653A6E7D2C6368696C6472656E3A5A652E6D6170285A652E636F6E636174286F2C69292C4755292C636F6C6C6170';
wwv_flow_imp.g_varchar2_table(21937) := '7369626C653A652E636F6C6C61707369626C652C636F6C6C61707365643A652E636F6C6C61707365647D7D66756E6374696F6E20515528652C743D30297B6C6574206E3B72657475726E206E3D743C652E656C656D656E742E656C656D656E74732E6C65';
wwv_flow_imp.g_varchar2_table(21938) := '6E6774682D313F5B515528652C742B31295D3A5A652E6D6170285A652E66726F6D28652E6368696C6472656E292C28653D3E515528652C302929292C303D3D3D742626652E656C656D656E742E696E636F6D707265737369626C653F7B656C656D656E74';
wwv_flow_imp.g_varchar2_table(21939) := '3A652E656C656D656E742E656C656D656E74735B745D2C6368696C6472656E3A6E2C696E636F6D707265737369626C653A21302C636F6C6C61707369626C653A652E636F6C6C61707369626C652C636F6C6C61707365643A652E636F6C6C61707365647D';
wwv_flow_imp.g_varchar2_table(21940) := '3A7B656C656D656E743A652E656C656D656E742E656C656D656E74735B745D2C6368696C6472656E3A6E2C636F6C6C61707369626C653A652E636F6C6C61707369626C652C636F6C6C61707365643A652E636F6C6C61707365647D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(21941) := '2059552865297B72657475726E20515528652C30297D66756E6374696F6E205A5528652C742C6E297B72657475726E20652E656C656D656E743D3D3D743F7B2E2E2E652C6368696C6472656E3A6E7D3A7B2E2E2E652C6368696C6472656E3A5A652E6D61';
wwv_flow_imp.g_varchar2_table(21942) := '70285A652E66726F6D28652E6368696C6472656E292C28653D3E5A5528652C742C6E2929297D7D636C6173732058557B676574206F6E44696453706C69636528297B72657475726E20746869732E6D6F64656C2E6F6E44696453706C6963657D67657420';
wwv_flow_imp.g_varchar2_table(21943) := '6F6E4469644368616E6765436F6C6C61707365537461746528297B72657475726E20746869732E6D6F64656C2E6F6E4469644368616E6765436F6C6C6170736553746174657D676574206F6E4469644368616E676552656E6465724E6F6465436F756E74';
wwv_flow_imp.g_varchar2_table(21944) := '28297B72657475726E20746869732E6D6F64656C2E6F6E4469644368616E676552656E6465724E6F6465436F756E747D636F6E7374727563746F7228652C742C6E3D7B7D297B746869732E757365723D652C746869732E726F6F745265663D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(21945) := '746869732E6E6F6465733D6E6577204D61702C746869732E6D6F64656C3D6E657720555528652C742C6E292C746869732E656E61626C65643D766F696420303D3D3D6E2E636F6D7072657373696F6E456E61626C65647C7C6E2E636F6D7072657373696F';
wwv_flow_imp.g_varchar2_table(21946) := '6E456E61626C65642C746869732E6964656E7469747950726F76696465723D6E2E6964656E7469747950726F76696465727D7365744368696C6472656E28652C743D5A652E656D70747928292C6E297B636F6E737420693D6E2E646966664964656E7469';
wwv_flow_imp.g_varchar2_table(21947) := '747950726F76696465722626286F3D6E2E646966664964656E7469747950726F76696465722C7B67657449643A653D3E652E656C656D656E74732E6D61702828653D3E6F2E67657449642865292E746F537472696E67282929292E6A6F696E28225C3022';
wwv_flow_imp.g_varchar2_table(21948) := '297D293B766172206F3B6966286E756C6C3D3D3D65297B636F6E737420653D5A652E6D617028742C746869732E656E61626C65643F47553A4B55293B72657475726E20766F696420746869732E5F7365744368696C6472656E286E756C6C2C652C7B6469';
wwv_flow_imp.g_varchar2_table(21949) := '66664964656E7469747950726F76696465723A692C6469666644657074683A312F307D297D636F6E737420733D746869732E6E6F6465732E6765742865293B6966282173297468726F77206E657720755528746869732E757365722C22556E6B6E6F776E';
wwv_flow_imp.g_varchar2_table(21950) := '20636F6D707265737365642074726565206E6F646522293B636F6E737420723D746869732E6D6F64656C2E6765744E6F64652873292C613D746869732E6D6F64656C2E676574506172656E744E6F64654C6F636174696F6E2873292C6C3D746869732E6D';
wwv_flow_imp.g_varchar2_table(21951) := '6F64656C2E6765744E6F64652861292C633D5A552859552872292C652C74292C643D28746869732E656E61626C65643F47553A4B55292863292C683D6E2E646966664964656E7469747950726F76696465723F28652C74293D3E6E2E646966664964656E';
wwv_flow_imp.g_varchar2_table(21952) := '7469747950726F76696465722E67657449642865293D3D3D6E2E646966664964656E7469747950726F76696465722E67657449642874293A766F696420303B696628506828642E656C656D656E742E656C656D656E74732C722E656C656D656E742E656C';
wwv_flow_imp.g_varchar2_table(21953) := '656D656E74732C68292972657475726E20766F696420746869732E5F7365744368696C6472656E28732C642E6368696C6472656E7C7C5A652E656D70747928292C7B646966664964656E7469747950726F76696465723A692C6469666644657074683A31';
wwv_flow_imp.g_varchar2_table(21954) := '7D293B636F6E737420753D6C2E6368696C6472656E2E6D61702828653D3E653D3D3D723F643A6529293B746869732E5F7365744368696C6472656E286C2E656C656D656E742C752C7B646966664964656E7469747950726F76696465723A692C64696666';
wwv_flow_imp.g_varchar2_table(21955) := '44657074683A722E64657074682D6C2E64657074687D297D6973436F6D7072657373696F6E456E61626C656428297B72657475726E20746869732E656E61626C65647D736574436F6D7072657373696F6E456E61626C65642865297B696628653D3D3D74';
wwv_flow_imp.g_varchar2_table(21956) := '6869732E656E61626C65642972657475726E3B746869732E656E61626C65643D653B636F6E737420743D746869732E6D6F64656C2E6765744E6F646528292E6368696C6472656E2C6E3D5A652E6D617028742C5955292C693D5A652E6D6170286E2C653F';
wwv_flow_imp.g_varchar2_table(21957) := '47553A4B55293B746869732E5F7365744368696C6472656E286E756C6C2C692C7B646966664964656E7469747950726F76696465723A746869732E6964656E7469747950726F76696465722C6469666644657074683A312F307D297D5F7365744368696C';
wwv_flow_imp.g_varchar2_table(21958) := '6472656E28652C742C6E297B636F6E737420693D6E6577205365743B746869732E6D6F64656C2E7365744368696C6472656E28652C742C7B2E2E2E6E2C6F6E4469644372656174654E6F64653A653D3E7B666F7228636F6E73742074206F6620652E656C';
wwv_flow_imp.g_varchar2_table(21959) := '656D656E742E656C656D656E747329692E6164642874292C746869732E6E6F6465732E73657428742C652E656C656D656E74297D2C6F6E44696444656C6574654E6F64653A653D3E7B666F7228636F6E73742074206F6620652E656C656D656E742E656C';
wwv_flow_imp.g_varchar2_table(21960) := '656D656E747329692E6861732874297C7C746869732E6E6F6465732E64656C6574652874297D7D297D6861732865297B72657475726E20746869732E6E6F6465732E6861732865297D6765744C697374496E6465782865297B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(21961) := '732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E6765744C697374496E6465782874297D6765744C69737452656E646572436F756E742865297B636F6E737420743D746869732E676574436F6D7072';
wwv_flow_imp.g_varchar2_table(21962) := '65737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E6765744C69737452656E646572436F756E742874297D6765744E6F64652865297B696628766F696420303D3D3D652972657475726E20746869732E6D6F64656C2E6765744E';
wwv_flow_imp.g_varchar2_table(21963) := '6F646528293B636F6E737420743D746869732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E6765744E6F64652874297D6765744E6F64654C6F636174696F6E2865297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(21964) := '2E6D6F64656C2E6765744E6F64654C6F636174696F6E2865293B72657475726E206E756C6C3D3D3D743F6E756C6C3A742E656C656D656E74735B742E656C656D656E74732E6C656E6774682D315D7D676574506172656E744E6F64654C6F636174696F6E';
wwv_flow_imp.g_varchar2_table(21965) := '2865297B636F6E737420743D746869732E676574436F6D707265737365644E6F64652865292C6E3D746869732E6D6F64656C2E676574506172656E744E6F64654C6F636174696F6E2874293B72657475726E206E756C6C3D3D3D6E3F6E756C6C3A6E2E65';
wwv_flow_imp.g_varchar2_table(21966) := '6C656D656E74735B6E2E656C656D656E74732E6C656E6774682D315D7D6765744669727374456C656D656E744368696C642865297B636F6E737420743D746869732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D';
wwv_flow_imp.g_varchar2_table(21967) := '6F64656C2E6765744669727374456C656D656E744368696C642874297D6973436F6C6C61707369626C652865297B636F6E737420743D746869732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E6973';
wwv_flow_imp.g_varchar2_table(21968) := '436F6C6C61707369626C652874297D736574436F6C6C61707369626C6528652C74297B636F6E7374206E3D746869732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E736574436F6C6C61707369626C';
wwv_flow_imp.g_varchar2_table(21969) := '65286E2C74297D6973436F6C6C61707365642865297B636F6E737420743D746869732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E6973436F6C6C61707365642874297D736574436F6C6C61707365';
wwv_flow_imp.g_varchar2_table(21970) := '6428652C742C6E297B636F6E737420693D746869732E676574436F6D707265737365644E6F64652865293B72657475726E20746869732E6D6F64656C2E736574436F6C6C617073656428692C742C6E297D657870616E64546F2865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(21971) := '3D746869732E676574436F6D707265737365644E6F64652865293B746869732E6D6F64656C2E657870616E64546F2874297D726572656E6465722865297B636F6E737420743D746869732E676574436F6D707265737365644E6F64652865293B74686973';
wwv_flow_imp.g_varchar2_table(21972) := '2E6D6F64656C2E726572656E6465722874297D726566696C74657228297B746869732E6D6F64656C2E726566696C74657228297D676574436F6D707265737365644E6F64652865297B6966286E756C6C3D3D3D652972657475726E206E756C6C3B636F6E';
wwv_flow_imp.g_varchar2_table(21973) := '737420743D746869732E6E6F6465732E6765742865293B6966282174297468726F77206E657720755528746869732E757365722C605472656520656C656D656E74206E6F7420666F756E643A20247B657D60293B72657475726E20747D7D636F6E737420';
wwv_flow_imp.g_varchar2_table(21974) := '4A553D653D3E655B652E6C656E6774682D315D3B636C61737320654B7B67657420656C656D656E7428297B72657475726E206E756C6C3D3D3D746869732E6E6F64652E656C656D656E743F6E756C6C3A746869732E756E7772617070657228746869732E';
wwv_flow_imp.g_varchar2_table(21975) := '6E6F64652E656C656D656E74297D676574206368696C6472656E28297B72657475726E20746869732E6E6F64652E6368696C6472656E2E6D61702828653D3E6E657720654B28746869732E756E777261707065722C652929297D67657420646570746828';
wwv_flow_imp.g_varchar2_table(21976) := '297B72657475726E20746869732E6E6F64652E64657074687D6765742076697369626C654368696C6472656E436F756E7428297B72657475726E20746869732E6E6F64652E76697369626C654368696C6472656E436F756E747D6765742076697369626C';
wwv_flow_imp.g_varchar2_table(21977) := '654368696C64496E64657828297B72657475726E20746869732E6E6F64652E76697369626C654368696C64496E6465787D67657420636F6C6C61707369626C6528297B72657475726E20746869732E6E6F64652E636F6C6C61707369626C657D67657420';
wwv_flow_imp.g_varchar2_table(21978) := '636F6C6C617073656428297B72657475726E20746869732E6E6F64652E636F6C6C61707365647D6765742076697369626C6528297B72657475726E20746869732E6E6F64652E76697369626C657D6765742066696C7465724461746128297B7265747572';
wwv_flow_imp.g_varchar2_table(21979) := '6E20746869732E6E6F64652E66696C746572446174617D636F6E7374727563746F7228652C74297B746869732E756E777261707065723D652C746869732E6E6F64653D747D7D636C61737320744B7B676574206F6E44696453706C69636528297B726574';
wwv_flow_imp.g_varchar2_table(21980) := '75726E2076742E6D617028746869732E6D6F64656C2E6F6E44696453706C6963652C28287B696E7365727465644E6F6465733A652C64656C657465644E6F6465733A747D293D3E287B696E7365727465644E6F6465733A652E6D61702828653D3E746869';
wwv_flow_imp.g_varchar2_table(21981) := '732E6E6F64654D61707065722E6D617028652929292C64656C657465644E6F6465733A742E6D61702828653D3E746869732E6E6F64654D61707065722E6D617028652929297D2929297D676574206F6E4469644368616E6765436F6C6C61707365537461';
wwv_flow_imp.g_varchar2_table(21982) := '746528297B72657475726E2076742E6D617028746869732E6D6F64656C2E6F6E4469644368616E6765436F6C6C6170736553746174652C28287B6E6F64653A652C646565703A747D293D3E287B6E6F64653A746869732E6E6F64654D61707065722E6D61';
wwv_flow_imp.g_varchar2_table(21983) := '702865292C646565703A747D2929297D676574206F6E4469644368616E676552656E6465724E6F6465436F756E7428297B72657475726E2076742E6D617028746869732E6D6F64656C2E6F6E4469644368616E676552656E6465724E6F6465436F756E74';
wwv_flow_imp.g_varchar2_table(21984) := '2C28653D3E746869732E6E6F64654D61707065722E6D617028652929297D636F6E7374727563746F7228652C742C6E3D7B7D297B746869732E726F6F745265663D6E756C6C2C746869732E656C656D656E744D61707065723D6E2E656C656D656E744D61';
wwv_flow_imp.g_varchar2_table(21985) := '707065727C7C4A553B636F6E737420693D653D3E746869732E656C656D656E744D617070657228652E656C656D656E7473293B746869732E6E6F64654D61707065723D6E65772070552828653D3E6E657720654B28692C652929292C746869732E6D6F64';
wwv_flow_imp.g_varchar2_table(21986) := '656C3D6E657720585528652C66756E6374696F6E28652C74297B72657475726E7B73706C696365286E2C692C6F297B742E73706C696365286E2C692C6F2E6D61702828743D3E652E6D61702874292929297D2C757064617465456C656D656E7448656967';
wwv_flow_imp.g_varchar2_table(21987) := '687428652C6E297B742E757064617465456C656D656E7448656967687428652C6E297D7D7D28746869732E6E6F64654D61707065722C74292C66756E6374696F6E28652C74297B72657475726E7B2E2E2E742C6964656E7469747950726F76696465723A';
wwv_flow_imp.g_varchar2_table(21988) := '742E6964656E7469747950726F766964657226267B67657449643A6E3D3E742E6964656E7469747950726F76696465722E67657449642865286E29297D2C736F727465723A742E736F7274657226267B636F6D706172653A28652C6E293D3E742E736F72';
wwv_flow_imp.g_varchar2_table(21989) := '7465722E636F6D7061726528652E656C656D656E74735B305D2C6E2E656C656D656E74735B305D297D2C66696C7465723A742E66696C74657226267B66696C7465723A286E2C69293D3E742E66696C7465722E66696C7465722865286E292C69297D7D7D';
wwv_flow_imp.g_varchar2_table(21990) := '28692C6E29297D7365744368696C6472656E28652C743D5A652E656D70747928292C6E3D7B7D297B746869732E6D6F64656C2E7365744368696C6472656E28652C742C6E297D6973436F6D7072657373696F6E456E61626C656428297B72657475726E20';
wwv_flow_imp.g_varchar2_table(21991) := '746869732E6D6F64656C2E6973436F6D7072657373696F6E456E61626C656428297D736574436F6D7072657373696F6E456E61626C65642865297B746869732E6D6F64656C2E736574436F6D7072657373696F6E456E61626C65642865297D6861732865';
wwv_flow_imp.g_varchar2_table(21992) := '297B72657475726E20746869732E6D6F64656C2E6861732865297D6765744C697374496E6465782865297B72657475726E20746869732E6D6F64656C2E6765744C697374496E6465782865297D6765744C69737452656E646572436F756E742865297B72';
wwv_flow_imp.g_varchar2_table(21993) := '657475726E20746869732E6D6F64656C2E6765744C69737452656E646572436F756E742865297D6765744E6F64652865297B72657475726E20746869732E6E6F64654D61707065722E6D617028746869732E6D6F64656C2E6765744E6F6465286529297D';
wwv_flow_imp.g_varchar2_table(21994) := '6765744E6F64654C6F636174696F6E2865297B72657475726E20652E656C656D656E747D676574506172656E744E6F64654C6F636174696F6E2865297B72657475726E20746869732E6D6F64656C2E676574506172656E744E6F64654C6F636174696F6E';
wwv_flow_imp.g_varchar2_table(21995) := '2865297D6765744669727374456C656D656E744368696C642865297B636F6E737420743D746869732E6D6F64656C2E6765744669727374456C656D656E744368696C642865293B72657475726E206E756C6C3D3D743F743A746869732E656C656D656E74';
wwv_flow_imp.g_varchar2_table(21996) := '4D617070657228742E656C656D656E7473297D6973436F6C6C61707369626C652865297B72657475726E20746869732E6D6F64656C2E6973436F6C6C61707369626C652865297D736574436F6C6C61707369626C6528652C74297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(21997) := '69732E6D6F64656C2E736574436F6C6C61707369626C6528652C74297D6973436F6C6C61707365642865297B72657475726E20746869732E6D6F64656C2E6973436F6C6C61707365642865297D736574436F6C6C617073656428652C742C6E297B726574';
wwv_flow_imp.g_varchar2_table(21998) := '75726E20746869732E6D6F64656C2E736574436F6C6C617073656428652C742C6E297D657870616E64546F2865297B72657475726E20746869732E6D6F64656C2E657870616E64546F2865297D726572656E6465722865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(21999) := '2E6D6F64656C2E726572656E6465722865297D726566696C74657228297B72657475726E20746869732E6D6F64656C2E726566696C74657228297D676574436F6D70726573736564547265654E6F646528653D6E756C6C297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(22000) := '2E6D6F64656C2E6765744E6F64652865297D7D636C617373206E4B20657874656E64732024557B676574206F6E4469644368616E6765436F6C6C61707365537461746528297B72657475726E20746869732E6D6F64656C2E6F6E4469644368616E676543';
wwv_flow_imp.g_varchar2_table(22001) := '6F6C6C6170736553746174657D636F6E7374727563746F7228652C742C6E2C692C6F3D7B7D297B737570657228652C742C6E2C692C6F292C746869732E757365723D657D7365744368696C6472656E28652C743D5A652E656D70747928292C6E297B7468';
wwv_flow_imp.g_varchar2_table(22002) := '69732E6D6F64656C2E7365744368696C6472656E28652C742C6E297D726572656E6465722865297B766F69642030213D3D653F746869732E6D6F64656C2E726572656E6465722865293A746869732E766965772E726572656E64657228297D686173456C';
wwv_flow_imp.g_varchar2_table(22003) := '656D656E742865297B72657475726E20746869732E6D6F64656C2E6861732865297D6372656174654D6F64656C28652C742C6E297B72657475726E206E657720555528652C742C6E297D7D636C61737320694B7B67657420636F6D707265737365645472';
wwv_flow_imp.g_varchar2_table(22004) := '65654E6F646550726F766964657228297B72657475726E20746869732E5F636F6D70726573736564547265654E6F646550726F766964657228297D636F6E7374727563746F7228652C742C6E297B746869732E5F636F6D70726573736564547265654E6F';
wwv_flow_imp.g_varchar2_table(22005) := '646550726F76696465723D652C746869732E737469636B795363726F6C6C44656C65676174653D742C746869732E72656E64657265723D6E2C746869732E74656D706C61746549643D6E2E74656D706C61746549642C6E2E6F6E4469644368616E676554';
wwv_flow_imp.g_varchar2_table(22006) := '7769737469655374617465262628746869732E6F6E4469644368616E67655477697374696553746174653D6E2E6F6E4469644368616E6765547769737469655374617465297D72656E64657254656D706C6174652865297B72657475726E7B636F6D7072';
wwv_flow_imp.g_varchar2_table(22007) := '6573736564547265654E6F64653A766F696420302C646174613A746869732E72656E64657265722E72656E64657254656D706C6174652865297D7D72656E646572456C656D656E7428652C742C6E2C69297B6C6574206F3D746869732E737469636B7953';
wwv_flow_imp.g_varchar2_table(22008) := '63726F6C6C44656C65676174652E676574436F6D707265737365644E6F64652865293B6F7C7C286F3D746869732E636F6D70726573736564547265654E6F646550726F76696465722E676574436F6D70726573736564547265654E6F646528652E656C65';
wwv_flow_imp.g_varchar2_table(22009) := '6D656E7429292C313D3D3D6F2E656C656D656E742E656C656D656E74732E6C656E6774683F286E2E636F6D70726573736564547265654E6F64653D766F696420302C746869732E72656E64657265722E72656E646572456C656D656E7428652C742C6E2E';
wwv_flow_imp.g_varchar2_table(22010) := '646174612C6929293A286E2E636F6D70726573736564547265654E6F64653D6F2C746869732E72656E64657265722E72656E646572436F6D70726573736564456C656D656E7473286F2C742C6E2E646174612C6929297D646973706F7365456C656D656E';
wwv_flow_imp.g_varchar2_table(22011) := '7428652C742C6E2C69297B766172206F2C732C722C613B6E2E636F6D70726573736564547265654E6F64653F6E756C6C3D3D3D28733D286F3D746869732E72656E6465726572292E646973706F7365436F6D70726573736564456C656D656E7473297C7C';
wwv_flow_imp.g_varchar2_table(22012) := '766F696420303D3D3D737C7C732E63616C6C286F2C6E2E636F6D70726573736564547265654E6F64652C742C6E2E646174612C69293A6E756C6C3D3D3D28613D28723D746869732E72656E6465726572292E646973706F7365456C656D656E74297C7C76';
wwv_flow_imp.g_varchar2_table(22013) := '6F696420303D3D3D617C7C612E63616C6C28722C652C742C6E2E646174612C69297D646973706F736554656D706C6174652865297B746869732E72656E64657265722E646973706F736554656D706C61746528652E64617461297D72656E646572547769';
wwv_flow_imp.g_varchar2_table(22014) := '7374696528652C74297B72657475726E2121746869732E72656E64657265722E72656E646572547769737469652626746869732E72656E64657265722E72656E6465725477697374696528652C74297D7D2166756E6374696F6E28652C742C6E2C69297B';
wwv_flow_imp.g_varchar2_table(22015) := '766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D74797065';
wwv_flow_imp.g_varchar2_table(22016) := '6F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(22017) := '313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72297D285B4445';
wwv_flow_imp.g_varchar2_table(22018) := '5D2C694B2E70726F746F747970652C22636F6D70726573736564547265654E6F646550726F7669646572222C6E756C6C293B636C617373206F4B7B636F6E7374727563746F722865297B746869732E6D6F64656C50726F76696465723D652C746869732E';
wwv_flow_imp.g_varchar2_table(22019) := '636F6D70726573736564537469636B794E6F6465733D6E6577204D61707D676574436F6D707265737365644E6F64652865297B72657475726E20746869732E636F6D70726573736564537469636B794E6F6465732E6765742865297D636F6E7374726169';
wwv_flow_imp.g_varchar2_table(22020) := '6E537469636B795363726F6C6C4E6F64657328652C742C6E297B696628746869732E636F6D70726573736564537469636B794E6F6465732E636C65617228292C303D3D3D652E6C656E6774682972657475726E5B5D3B666F72286C657420693D303B693C';
wwv_flow_imp.g_varchar2_table(22021) := '652E6C656E6774683B692B2B297B636F6E7374206F3D655B695D2C733D6F2E706F736974696F6E2B6F2E6865696768743B696628692B313C652E6C656E6774682626732B655B692B315D2E6865696768743E6E7C7C693E3D742D312626743C652E6C656E';
wwv_flow_imp.g_varchar2_table(22022) := '677468297B636F6E737420743D652E736C69636528302C69292C6E3D652E736C6963652869293B72657475726E5B2E2E2E742C746869732E636F6D7072657373537469636B794E6F646573286E295D7D7D72657475726E20657D636F6D70726573735374';
wwv_flow_imp.g_varchar2_table(22023) := '69636B794E6F6465732865297B696628303D3D3D652E6C656E677468297468726F77206E6577204572726F72282243616E277420636F6D707265737320656D70747920737469636B79206E6F64657322293B636F6E737420743D746869732E6D6F64656C';
wwv_flow_imp.g_varchar2_table(22024) := '50726F766964657228293B69662821742E6973436F6D7072657373696F6E456E61626C656428292972657475726E20655B305D3B636F6E7374206E3D5B5D3B666F72286C657420693D303B693C652E6C656E6774683B692B2B297B636F6E7374206F3D65';
wwv_flow_imp.g_varchar2_table(22025) := '5B695D2C733D742E676574436F6D70726573736564547265654E6F6465286F2E6E6F64652E656C656D656E74293B696628732E656C656D656E74297B69662830213D3D692626732E656C656D656E742E696E636F6D707265737369626C6529627265616B';
wwv_flow_imp.g_varchar2_table(22026) := '3B6E2E70757368282E2E2E732E656C656D656E742E656C656D656E7473297D7D6966286E2E6C656E6774683C322972657475726E20655B305D3B636F6E737420693D655B652E6C656E6774682D315D2C6F3D7B656C656D656E74733A6E2C696E636F6D70';
wwv_flow_imp.g_varchar2_table(22027) := '7265737369626C653A21317D2C733D7B2E2E2E692E6E6F64652C6368696C6472656E3A5B5D2C656C656D656E743A6F7D2C723D6E65772050726F787928655B305D2E6E6F64652C7B7D292C613D7B6E6F64653A722C7374617274496E6465783A655B305D';
wwv_flow_imp.g_varchar2_table(22028) := '2E7374617274496E6465782C656E64496E6465783A692E656E64496E6465782C706F736974696F6E3A655B305D2E706F736974696F6E2C6865696768743A655B305D2E6865696768747D3B72657475726E20746869732E636F6D70726573736564537469';
wwv_flow_imp.g_varchar2_table(22029) := '636B794E6F6465732E73657428722C73292C617D7D66756E6374696F6E20734B28652C74297B72657475726E207426267B2E2E2E742C6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723A742E6B6579626F6172644E617669';
wwv_flow_imp.g_varchar2_table(22030) := '676174696F6E4C6162656C50726F766964657226267B6765744B6579626F6172644E617669676174696F6E4C6162656C286E297B6C657420693B7472797B693D6528292E676574436F6D70726573736564547265654E6F6465286E297D63617463682865';
wwv_flow_imp.g_varchar2_table(22031) := '297B72657475726E20742E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465722E6765744B6579626F6172644E617669676174696F6E4C6162656C286E297D72657475726E20313D3D3D692E656C656D656E742E656C656D656E';
wwv_flow_imp.g_varchar2_table(22032) := '74732E6C656E6774683F742E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465722E6765744B6579626F6172644E617669676174696F6E4C6162656C286E293A742E6B6579626F6172644E617669676174696F6E4C6162656C50';
wwv_flow_imp.g_varchar2_table(22033) := '726F76696465722E676574436F6D707265737365644E6F64654B6579626F6172644E617669676174696F6E4C6162656C28692E656C656D656E742E656C656D656E7473297D7D7D7D636C61737320724B20657874656E6473206E4B7B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(22034) := '746F7228652C742C6E2C692C6F3D7B7D297B636F6E737420733D28293D3E746869732C723D6E6577206F4B282828293D3E746869732E6D6F64656C29293B737570657228652C742C6E2C692E6D61702828653D3E6E657720694B28732C722C652929292C';
wwv_flow_imp.g_varchar2_table(22035) := '7B2E2E2E734B28732C6F292C737469636B795363726F6C6C44656C65676174653A727D297D7365744368696C6472656E28652C743D5A652E656D70747928292C6E297B746869732E6D6F64656C2E7365744368696C6472656E28652C742C6E297D637265';
wwv_flow_imp.g_varchar2_table(22036) := '6174654D6F64656C28652C742C6E297B72657475726E206E657720744B28652C742C6E297D7570646174654F7074696F6E7328653D7B7D297B73757065722E7570646174654F7074696F6E732865292C766F69642030213D3D652E636F6D707265737369';
wwv_flow_imp.g_varchar2_table(22037) := '6F6E456E61626C65642626746869732E6D6F64656C2E736574436F6D7072657373696F6E456E61626C656428652E636F6D7072657373696F6E456E61626C6564297D676574436F6D70726573736564547265654E6F646528653D6E756C6C297B72657475';
wwv_flow_imp.g_varchar2_table(22038) := '726E20746869732E6D6F64656C2E676574436F6D70726573736564547265654E6F64652865297D7D66756E6374696F6E20614B2865297B72657475726E7B2E2E2E652C6368696C6472656E3A5B5D2C7265667265736850726F6D6973653A766F69642030';
wwv_flow_imp.g_varchar2_table(22039) := '2C7374616C653A21302C736C6F773A21312C666F726365457870616E6465643A21317D7D66756E6374696F6E206C4B28652C74297B72657475726E2121742E706172656E74262628742E706172656E743D3D3D657C7C6C4B28652C742E706172656E7429';
wwv_flow_imp.g_varchar2_table(22040) := '297D636C61737320634B7B67657420656C656D656E7428297B72657475726E20746869732E6E6F64652E656C656D656E742E656C656D656E747D676574206368696C6472656E28297B72657475726E20746869732E6E6F64652E6368696C6472656E2E6D';
wwv_flow_imp.g_varchar2_table(22041) := '61702828653D3E6E657720634B28652929297D67657420646570746828297B72657475726E20746869732E6E6F64652E64657074687D6765742076697369626C654368696C6472656E436F756E7428297B72657475726E20746869732E6E6F64652E7669';
wwv_flow_imp.g_varchar2_table(22042) := '7369626C654368696C6472656E436F756E747D6765742076697369626C654368696C64496E64657828297B72657475726E20746869732E6E6F64652E76697369626C654368696C64496E6465787D67657420636F6C6C61707369626C6528297B72657475';
wwv_flow_imp.g_varchar2_table(22043) := '726E20746869732E6E6F64652E636F6C6C61707369626C657D67657420636F6C6C617073656428297B72657475726E20746869732E6E6F64652E636F6C6C61707365647D6765742076697369626C6528297B72657475726E20746869732E6E6F64652E76';
wwv_flow_imp.g_varchar2_table(22044) := '697369626C657D6765742066696C7465724461746128297B72657475726E20746869732E6E6F64652E66696C746572446174617D636F6E7374727563746F722865297B746869732E6E6F64653D657D7D636C61737320644B7B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(22045) := '28652C742C6E297B746869732E72656E64657265723D652C746869732E6E6F64654D61707065723D742C746869732E6F6E4469644368616E67655477697374696553746174653D6E2C746869732E72656E64657265644E6F6465733D6E6577204D61702C';
wwv_flow_imp.g_varchar2_table(22046) := '746869732E74656D706C61746549643D652E74656D706C61746549647D72656E64657254656D706C6174652865297B72657475726E7B74656D706C617465446174613A746869732E72656E64657265722E72656E64657254656D706C6174652865297D7D';
wwv_flow_imp.g_varchar2_table(22047) := '72656E646572456C656D656E7428652C742C6E2C69297B746869732E72656E64657265722E72656E646572456C656D656E7428746869732E6E6F64654D61707065722E6D61702865292C742C6E2E74656D706C617465446174612C69297D72656E646572';
wwv_flow_imp.g_varchar2_table(22048) := '5477697374696528652C74297B72657475726E20652E736C6F773F28742E636C6173734C6973742E616464282E2E2E546C2E6173436C6173734E616D654172726179284C6C2E747265654974656D4C6F6164696E6729292C2130293A28742E636C617373';
wwv_flow_imp.g_varchar2_table(22049) := '4C6973742E72656D6F7665282E2E2E546C2E6173436C6173734E616D654172726179284C6C2E747265654974656D4C6F6164696E6729292C2131297D646973706F7365456C656D656E7428652C742C6E2C69297B766172206F2C733B6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(22050) := '733D286F3D746869732E72656E6465726572292E646973706F7365456C656D656E74297C7C766F696420303D3D3D737C7C732E63616C6C286F2C746869732E6E6F64654D61707065722E6D61702865292C742C6E2E74656D706C617465446174612C6929';
wwv_flow_imp.g_varchar2_table(22051) := '7D646973706F736554656D706C6174652865297B746869732E72656E64657265722E646973706F736554656D706C61746528652E74656D706C61746544617461297D646973706F736528297B746869732E72656E64657265644E6F6465732E636C656172';
wwv_flow_imp.g_varchar2_table(22052) := '28297D7D66756E6374696F6E20684B2865297B72657475726E7B62726F777365724576656E743A652E62726F777365724576656E742C656C656D656E74733A652E656C656D656E74732E6D61702828653D3E652E656C656D656E7429297D7D66756E6374';
wwv_flow_imp.g_varchar2_table(22053) := '696F6E20754B2865297B72657475726E7B62726F777365724576656E743A652E62726F777365724576656E742C656C656D656E743A652E656C656D656E742626652E656C656D656E742E656C656D656E742C7461726765743A652E7461726765747D7D63';
wwv_flow_imp.g_varchar2_table(22054) := '6C61737320704B20657874656E64732043547B636F6E7374727563746F722865297B737570657228652E656C656D656E74732E6D61702828653D3E652E656C656D656E742929292C746869732E646174613D657D7D66756E6374696F6E20674B2865297B';
wwv_flow_imp.g_varchar2_table(22055) := '72657475726E206520696E7374616E63656F662043543F6E657720704B2865293A657D636C617373206D4B7B636F6E7374727563746F722865297B746869732E646E643D657D676574447261675552492865297B72657475726E20746869732E646E642E';
wwv_flow_imp.g_varchar2_table(22056) := '6765744472616755524928652E656C656D656E74297D676574447261674C6162656C28652C74297B696628746869732E646E642E676574447261674C6162656C2972657475726E20746869732E646E642E676574447261674C6162656C28652E6D617028';
wwv_flow_imp.g_varchar2_table(22057) := '28653D3E652E656C656D656E7429292C74297D6F6E44726167537461727428652C74297B766172206E2C693B6E756C6C3D3D3D28693D286E3D746869732E646E64292E6F6E447261675374617274297C7C766F696420303D3D3D697C7C692E63616C6C28';
wwv_flow_imp.g_varchar2_table(22058) := '6E2C674B2865292C74297D6F6E447261674F76657228652C742C6E2C692C6F2C733D2130297B72657475726E20746869732E646E642E6F6E447261674F76657228674B2865292C742626742E656C656D656E742C6E2C692C6F297D64726F7028652C742C';
wwv_flow_imp.g_varchar2_table(22059) := '6E2C692C6F297B746869732E646E642E64726F7028674B2865292C742626742E656C656D656E742C6E2C692C6F297D6F6E44726167456E642865297B76617220742C6E3B6E756C6C3D3D3D286E3D28743D746869732E646E64292E6F6E44726167456E64';
wwv_flow_imp.g_varchar2_table(22060) := '297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C65297D646973706F736528297B746869732E646E642E646973706F736528297D7D66756E6374696F6E20664B2865297B72657475726E206526267B2E2E2E652C636F6C6C6170736542794465';
wwv_flow_imp.g_varchar2_table(22061) := '6661756C743A21302C6964656E7469747950726F76696465723A652E6964656E7469747950726F766964657226267B67657449643A743D3E652E6964656E7469747950726F76696465722E676574496428742E656C656D656E74297D2C646E643A652E64';
wwv_flow_imp.g_varchar2_table(22062) := '6E6426266E6577206D4B28652E646E64292C6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65723A652E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C657226267B697353656C656374696F6E53696E676C654368616E67';
wwv_flow_imp.g_varchar2_table(22063) := '654576656E743A743D3E652E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722E697353656C656374696F6E53696E676C654368616E67654576656E74287B2E2E2E742C656C656D656E743A742E656C656D656E747D292C697353656C';
wwv_flow_imp.g_varchar2_table(22064) := '656374696F6E52616E67654368616E67654576656E743A743D3E652E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C65722E697353656C656374696F6E52616E67654368616E67654576656E74287B2E2E2E742C656C656D656E743A742E';
wwv_flow_imp.g_varchar2_table(22065) := '656C656D656E747D297D2C6163636573736962696C69747950726F76696465723A652E6163636573736962696C69747950726F766964657226267B2E2E2E652E6163636573736962696C69747950726F76696465722C676574506F73496E5365743A766F';
wwv_flow_imp.g_varchar2_table(22066) := '696420302C67657453657453697A653A766F696420302C676574526F6C653A652E6163636573736962696C69747950726F76696465722E676574526F6C653F743D3E652E6163636573736962696C69747950726F76696465722E676574526F6C6528742E';
wwv_flow_imp.g_varchar2_table(22067) := '656C656D656E74293A28293D3E22747265656974656D222C6973436865636B65643A652E6163636573736962696C69747950726F76696465722E6973436865636B65643F743D3E7B766172206E3B72657475726E2121286E756C6C3D3D3D286E3D652E61';
wwv_flow_imp.g_varchar2_table(22068) := '63636573736962696C69747950726F7669646572297C7C766F696420303D3D3D6E3F766F696420303A6E2E6973436865636B656428742E656C656D656E7429297D3A766F696420302C676574417269614C6162656C3A743D3E652E616363657373696269';
wwv_flow_imp.g_varchar2_table(22069) := '6C69747950726F76696465722E676574417269614C6162656C28742E656C656D656E74292C676574576964676574417269614C6162656C3A28293D3E652E6163636573736962696C69747950726F76696465722E676574576964676574417269614C6162';
wwv_flow_imp.g_varchar2_table(22070) := '656C28292C676574576964676574526F6C653A652E6163636573736962696C69747950726F76696465722E676574576964676574526F6C653F28293D3E652E6163636573736962696C69747950726F76696465722E676574576964676574526F6C652829';
wwv_flow_imp.g_varchar2_table(22071) := '3A28293D3E2274726565222C676574417269614C6576656C3A652E6163636573736962696C69747950726F76696465722E676574417269614C6576656C262628743D3E652E6163636573736962696C69747950726F76696465722E676574417269614C65';
wwv_flow_imp.g_varchar2_table(22072) := '76656C28742E656C656D656E7429292C67657441637469766544657363656E64616E7449643A652E6163636573736962696C69747950726F76696465722E67657441637469766544657363656E64616E744964262628743D3E652E616363657373696269';
wwv_flow_imp.g_varchar2_table(22073) := '6C69747950726F76696465722E67657441637469766544657363656E64616E74496428742E656C656D656E7429297D2C66696C7465723A652E66696C74657226267B66696C7465723A28742C6E293D3E652E66696C7465722E66696C74657228742E656C';
wwv_flow_imp.g_varchar2_table(22074) := '656D656E742C6E297D2C6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723A652E6B6579626F6172644E617669676174696F6E4C6162656C50726F766964657226267B2E2E2E652E6B6579626F6172644E617669676174696F';
wwv_flow_imp.g_varchar2_table(22075) := '6E4C6162656C50726F76696465722C6765744B6579626F6172644E617669676174696F6E4C6162656C3A743D3E652E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465722E6765744B6579626F6172644E617669676174696F6E';
wwv_flow_imp.g_varchar2_table(22076) := '4C6162656C28742E656C656D656E74297D2C736F727465723A766F696420302C657870616E644F6E6C794F6E54776973746965436C69636B3A766F696420303D3D3D652E657870616E644F6E6C794F6E54776973746965436C69636B3F766F696420303A';
wwv_flow_imp.g_varchar2_table(22077) := '2266756E6374696F6E22213D747970656F6620652E657870616E644F6E6C794F6E54776973746965436C69636B3F652E657870616E644F6E6C794F6E54776973746965436C69636B3A743D3E652E657870616E644F6E6C794F6E54776973746965436C69';
wwv_flow_imp.g_varchar2_table(22078) := '636B28742E656C656D656E74292C64656661756C7446696E645669736962696C6974793A743D3E742E6861734368696C6472656E2626742E7374616C653F313A226E756D626572223D3D747970656F6620652E64656661756C7446696E64566973696269';
wwv_flow_imp.g_varchar2_table(22079) := '6C6974793F652E64656661756C7446696E645669736962696C6974793A766F696420303D3D3D652E64656661756C7446696E645669736962696C6974793F323A652E64656661756C7446696E645669736962696C69747928742E656C656D656E74297D7D';
wwv_flow_imp.g_varchar2_table(22080) := '66756E6374696F6E20764B28652C74297B742865292C652E6368696C6472656E2E666F72456163682828653D3E764B28652C742929297D636C61737320624B7B676574206F6E4469645363726F6C6C28297B72657475726E20746869732E747265652E6F';
wwv_flow_imp.g_varchar2_table(22081) := '6E4469645363726F6C6C7D676574206F6E4469644368616E6765466F63757328297B72657475726E2076742E6D617028746869732E747265652E6F6E4469644368616E6765466F6375732C684B297D676574206F6E4469644368616E676553656C656374';
wwv_flow_imp.g_varchar2_table(22082) := '696F6E28297B72657475726E2076742E6D617028746869732E747265652E6F6E4469644368616E676553656C656374696F6E2C684B297D676574206F6E4D6F75736544626C436C69636B28297B72657475726E2076742E6D617028746869732E74726565';
wwv_flow_imp.g_varchar2_table(22083) := '2E6F6E4D6F75736544626C436C69636B2C754B297D676574206F6E506F696E74657228297B72657475726E2076742E6D617028746869732E747265652E6F6E506F696E7465722C754B297D676574206F6E446964466F63757328297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(22084) := '6869732E747265652E6F6E446964466F6375737D676574206F6E4469644368616E67654D6F64656C28297B72657475726E20746869732E747265652E6F6E4469644368616E67654D6F64656C7D676574206F6E4469644368616E6765436F6C6C61707365';
wwv_flow_imp.g_varchar2_table(22085) := '537461746528297B72657475726E20746869732E747265652E6F6E4469644368616E6765436F6C6C6170736553746174657D676574206F6E4469644368616E676546696E644F70656E537461746528297B72657475726E20746869732E747265652E6F6E';
wwv_flow_imp.g_varchar2_table(22086) := '4469644368616E676546696E644F70656E53746174657D676574206F6E4469644368616E6765537469636B795363726F6C6C466F637573656428297B72657475726E20746869732E747265652E6F6E4469644368616E6765537469636B795363726F6C6C';
wwv_flow_imp.g_varchar2_table(22087) := '466F63757365647D676574206F6E446964446973706F736528297B72657475726E20746869732E747265652E6F6E446964446973706F73657D636F6E7374727563746F7228652C742C6E2C692C6F2C733D7B7D297B746869732E757365723D652C746869';
wwv_flow_imp.g_varchar2_table(22088) := '732E64617461536F757263653D6F2C746869732E6E6F6465733D6E6577204D61702C746869732E737562547265655265667265736850726F6D697365733D6E6577204D61702C746869732E7265667265736850726F6D697365733D6E6577204D61702C74';
wwv_flow_imp.g_varchar2_table(22089) := '6869732E5F6F6E44696452656E6465723D6E65772043742C746869732E5F6F6E4469644368616E67654E6F6465536C6F7753746174653D6E65772043742C746869732E6E6F64654D61707065723D6E65772070552828653D3E6E657720634B2865292929';
wwv_flow_imp.g_varchar2_table(22090) := '2C746869732E646973706F7361626C65733D6E65772061742C746869732E6964656E7469747950726F76696465723D732E6964656E7469747950726F76696465722C746869732E6175746F457870616E6453696E676C654368696C6472656E3D766F6964';
wwv_flow_imp.g_varchar2_table(22091) := '2030213D3D732E6175746F457870616E6453696E676C654368696C6472656E2626732E6175746F457870616E6453696E676C654368696C6472656E2C746869732E736F727465723D732E736F727465722C746869732E67657444656661756C74436F6C6C';
wwv_flow_imp.g_varchar2_table(22092) := '6170736553746174653D653D3E732E636F6C6C61707365427944656661756C743F732E636F6C6C61707365427944656661756C742865293F64552E50726573657276654F72436F6C6C61707365643A64552E50726573657276654F72457870616E646564';
wwv_flow_imp.g_varchar2_table(22093) := '3A766F696420302C746869732E747265653D746869732E6372656174655472656528652C742C6E2C692C73292C746869732E6F6E4469644368616E676546696E644D6F64653D746869732E747265652E6F6E4469644368616E676546696E644D6F64652C';
wwv_flow_imp.g_varchar2_table(22094) := '746869732E6F6E4469644368616E676546696E644D61746368547970653D746869732E747265652E6F6E4469644368616E676546696E644D61746368547970652C746869732E726F6F743D614B287B656C656D656E743A766F696420302C706172656E74';
wwv_flow_imp.g_varchar2_table(22095) := '3A6E756C6C2C6861734368696C6472656E3A21302C64656661756C74436F6C6C6170736553746174653A766F696420307D292C746869732E6964656E7469747950726F7669646572262628746869732E726F6F743D7B2E2E2E746869732E726F6F742C69';
wwv_flow_imp.g_varchar2_table(22096) := '643A6E756C6C7D292C746869732E6E6F6465732E736574286E756C6C2C746869732E726F6F74292C746869732E747265652E6F6E4469644368616E6765436F6C6C61707365537461746528746869732E5F6F6E4469644368616E6765436F6C6C61707365';
wwv_flow_imp.g_varchar2_table(22097) := '53746174652C746869732C746869732E646973706F7361626C6573297D6372656174655472656528652C742C6E2C692C6F297B636F6E737420733D6E6577204C55286E292C723D692E6D61702828653D3E6E657720644B28652C746869732E6E6F64654D';
wwv_flow_imp.g_varchar2_table(22098) := '61707065722C746869732E5F6F6E4469644368616E67654E6F6465536C6F7753746174652E6576656E742929292C613D664B286F297C7C7B7D3B72657475726E206E6577206E4B28652C742C732C722C61297D7570646174654F7074696F6E7328653D7B';
wwv_flow_imp.g_varchar2_table(22099) := '7D297B746869732E747265652E7570646174654F7074696F6E732865297D67657448544D4C456C656D656E7428297B72657475726E20746869732E747265652E67657448544D4C456C656D656E7428297D676574207363726F6C6C546F7028297B726574';
wwv_flow_imp.g_varchar2_table(22100) := '75726E20746869732E747265652E7363726F6C6C546F707D736574207363726F6C6C546F702865297B746869732E747265652E7363726F6C6C546F703D657D676574207363726F6C6C48656967687428297B72657475726E20746869732E747265652E73';
wwv_flow_imp.g_varchar2_table(22101) := '63726F6C6C4865696768747D6765742072656E64657248656967687428297B72657475726E20746869732E747265652E72656E6465724865696768747D646F6D466F63757328297B746869732E747265652E646F6D466F63757328297D6C61796F757428';
wwv_flow_imp.g_varchar2_table(22102) := '652C74297B746869732E747265652E6C61796F757428652C74297D7374796C652865297B746869732E747265652E7374796C652865297D676574496E70757428297B72657475726E20746869732E726F6F742E656C656D656E747D6173796E6320736574';
wwv_flow_imp.g_varchar2_table(22103) := '496E70757428652C74297B746869732E7265667265736850726F6D697365732E666F72456163682828653D3E652E63616E63656C282929292C746869732E7265667265736850726F6D697365732E636C65617228292C746869732E726F6F742E656C656D';
wwv_flow_imp.g_varchar2_table(22104) := '656E743D653B636F6E7374206E3D7426267B7669657753746174653A742C666F6375733A5B5D2C73656C656374696F6E3A5B5D7D3B617761697420746869732E5F7570646174654368696C6472656E28652C21302C21312C6E292C6E262628746869732E';
wwv_flow_imp.g_varchar2_table(22105) := '747265652E736574466F637573286E2E666F637573292C746869732E747265652E73657453656C656374696F6E286E2E73656C656374696F6E29292C742626226E756D626572223D3D747970656F6620742E7363726F6C6C546F70262628746869732E73';
wwv_flow_imp.g_varchar2_table(22106) := '63726F6C6C546F703D742E7363726F6C6C546F70297D6173796E63205F7570646174654368696C6472656E28653D746869732E726F6F742E656C656D656E742C743D21302C6E3D21312C692C6F297B696628766F696420303D3D3D746869732E726F6F74';
wwv_flow_imp.g_varchar2_table(22107) := '2E656C656D656E74297468726F77206E657720755528746869732E757365722C225472656520696E707574206E6F742073657422293B746869732E726F6F742E7265667265736850726F6D697365262628617761697420746869732E726F6F742E726566';
wwv_flow_imp.g_varchar2_table(22108) := '7265736850726F6D6973652C61776169742076742E746F50726F6D69736528746869732E5F6F6E44696452656E6465722E6576656E7429293B636F6E737420733D746869732E676574446174614E6F64652865293B696628617761697420746869732E72';
wwv_flow_imp.g_varchar2_table(22109) := '656672657368416E6452656E6465724E6F646528732C742C692C6F292C6E297472797B746869732E747265652E726572656E6465722873297D63617463682865297B7D7D726572656E6465722865297B696628766F696420303D3D3D657C7C653D3D3D74';
wwv_flow_imp.g_varchar2_table(22110) := '6869732E726F6F742E656C656D656E742972657475726E20766F696420746869732E747265652E726572656E64657228293B636F6E737420743D746869732E676574446174614E6F64652865293B746869732E747265652E726572656E6465722874297D';
wwv_flow_imp.g_varchar2_table(22111) := '6765744E6F646528653D746869732E726F6F742E656C656D656E74297B636F6E737420743D746869732E676574446174614E6F64652865292C6E3D746869732E747265652E6765744E6F646528743D3D3D746869732E726F6F743F6E756C6C3A74293B72';
wwv_flow_imp.g_varchar2_table(22112) := '657475726E20746869732E6E6F64654D61707065722E6D6170286E297D636F6C6C6170736528652C743D2131297B636F6E7374206E3D746869732E676574446174614E6F64652865293B72657475726E20746869732E747265652E636F6C6C6170736528';
wwv_flow_imp.g_varchar2_table(22113) := '6E3D3D3D746869732E726F6F743F6E756C6C3A6E2C74297D6173796E6320657870616E6428652C743D2131297B696628766F696420303D3D3D746869732E726F6F742E656C656D656E74297468726F77206E657720755528746869732E757365722C2254';
wwv_flow_imp.g_varchar2_table(22114) := '72656520696E707574206E6F742073657422293B746869732E726F6F742E7265667265736850726F6D697365262628617761697420746869732E726F6F742E7265667265736850726F6D6973652C61776169742076742E746F50726F6D69736528746869';
wwv_flow_imp.g_varchar2_table(22115) := '732E5F6F6E44696452656E6465722E6576656E7429293B636F6E7374206E3D746869732E676574446174614E6F64652865293B696628746869732E747265652E686173456C656D656E74286E29262621746869732E747265652E6973436F6C6C61707369';
wwv_flow_imp.g_varchar2_table(22116) := '626C65286E292972657475726E21313B6966286E2E7265667265736850726F6D697365262628617761697420746869732E726F6F742E7265667265736850726F6D6973652C61776169742076742E746F50726F6D69736528746869732E5F6F6E44696452';
wwv_flow_imp.g_varchar2_table(22117) := '656E6465722E6576656E7429292C6E213D3D746869732E726F6F742626216E2E7265667265736850726F6D697365262621746869732E747265652E6973436F6C6C6170736564286E292972657475726E21313B636F6E737420693D746869732E74726565';
wwv_flow_imp.g_varchar2_table(22118) := '2E657870616E64286E3D3D3D746869732E726F6F743F6E756C6C3A6E2C74293B72657475726E206E2E7265667265736850726F6D697365262628617761697420746869732E726F6F742E7265667265736850726F6D6973652C61776169742076742E746F';
wwv_flow_imp.g_varchar2_table(22119) := '50726F6D69736528746869732E5F6F6E44696452656E6465722E6576656E7429292C697D73657453656C656374696F6E28652C74297B636F6E7374206E3D652E6D61702828653D3E746869732E676574446174614E6F646528652929293B746869732E74';
wwv_flow_imp.g_varchar2_table(22120) := '7265652E73657453656C656374696F6E286E2C74297D67657453656C656374696F6E28297B72657475726E20746869732E747265652E67657453656C656374696F6E28292E6D61702828653D3E652E656C656D656E7429297D736574466F63757328652C';
wwv_flow_imp.g_varchar2_table(22121) := '74297B636F6E7374206E3D652E6D61702828653D3E746869732E676574446174614E6F646528652929293B746869732E747265652E736574466F637573286E2C74297D676574466F63757328297B72657475726E20746869732E747265652E676574466F';
wwv_flow_imp.g_varchar2_table(22122) := '63757328292E6D61702828653D3E652E656C656D656E7429297D72657665616C28652C74297B746869732E747265652E72657665616C28746869732E676574446174614E6F64652865292C74297D676574506172656E74456C656D656E742865297B636F';
wwv_flow_imp.g_varchar2_table(22123) := '6E737420743D746869732E747265652E676574506172656E74456C656D656E7428746869732E676574446174614E6F6465286529293B72657475726E20742626742E656C656D656E747D6765744669727374456C656D656E744368696C6428653D746869';
wwv_flow_imp.g_varchar2_table(22124) := '732E726F6F742E656C656D656E74297B636F6E737420743D746869732E676574446174614E6F64652865292C6E3D746869732E747265652E6765744669727374456C656D656E744368696C6428743D3D3D746869732E726F6F743F6E756C6C3A74293B72';
wwv_flow_imp.g_varchar2_table(22125) := '657475726E206E26266E2E656C656D656E747D676574446174614E6F64652865297B636F6E737420743D746869732E6E6F6465732E67657428653D3D3D746869732E726F6F742E656C656D656E743F6E756C6C3A65293B6966282174297468726F77206E';
wwv_flow_imp.g_varchar2_table(22126) := '657720755528746869732E757365722C60446174612074726565206E6F6465206E6F7420666F756E643A20247B657D60293B72657475726E20747D6173796E632072656672657368416E6452656E6465724E6F646528652C742C6E2C69297B6177616974';
wwv_flow_imp.g_varchar2_table(22127) := '20746869732E726566726573684E6F646528652C742C6E292C746869732E646973706F7361626C65732E6973446973706F7365647C7C746869732E72656E64657228652C6E2C69297D6173796E6320726566726573684E6F646528652C742C6E297B6C65';
wwv_flow_imp.g_varchar2_table(22128) := '7420693B72657475726E20746869732E737562547265655265667265736850726F6D697365732E666F72456163682828286F2C73293D3E7B2169262666756E6374696F6E28652C74297B72657475726E20653D3D3D747C7C6C4B28652C74297C7C6C4B28';
wwv_flow_imp.g_varchar2_table(22129) := '742C65297D28732C6529262628693D6F2E7468656E282828293D3E746869732E726566726573684E6F646528652C742C6E292929297D29292C697C7C2865213D3D746869732E726F6F742626746869732E747265652E6765744E6F64652865292E636F6C';
wwv_flow_imp.g_varchar2_table(22130) := '6C61707365643F28652E6861734368696C6472656E3D2121746869732E64617461536F757263652E6861734368696C6472656E28652E656C656D656E74292C652E7374616C653D21302C766F696420746869732E7365744368696C6472656E28652C5B5D';
wwv_flow_imp.g_varchar2_table(22131) := '2C742C6E29293A746869732E646F526566726573685375625472656528652C742C6E29297D6173796E6320646F526566726573685375625472656528652C742C6E297B6C657420693B652E7265667265736850726F6D6973653D6E65772050726F6D6973';
wwv_flow_imp.g_varchar2_table(22132) := '652828653D3E693D6529292C746869732E737562547265655265667265736850726F6D697365732E73657428652C652E7265667265736850726F6D697365292C652E7265667265736850726F6D6973652E66696E616C6C79282828293D3E7B652E726566';
wwv_flow_imp.g_varchar2_table(22133) := '7265736850726F6D6973653D766F696420302C746869732E737562547265655265667265736850726F6D697365732E64656C6574652865297D29293B7472797B636F6E737420693D617761697420746869732E646F526566726573684E6F646528652C74';
wwv_flow_imp.g_varchar2_table(22134) := '2C6E293B652E7374616C653D21312C6177616974204A742E736574746C656428692E6D61702828653D3E746869732E646F526566726573685375625472656528652C742C6E292929297D66696E616C6C797B6928297D7D6173796E6320646F5265667265';
wwv_flow_imp.g_varchar2_table(22135) := '73684E6F646528652C742C6E297B6C657420693B696628652E6861734368696C6472656E3D2121746869732E64617461536F757263652E6861734368696C6472656E28652E656C656D656E74292C652E6861734368696C6472656E297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(22136) := '3D746869732E646F4765744368696C6472656E2865293B6966286D6C28742929693D50726F6D6973652E7265736F6C76652874293B656C73657B636F6E7374206E3D577428383030293B6E2E7468656E282828293D3E7B652E736C6F773D21302C746869';
wwv_flow_imp.g_varchar2_table(22137) := '732E5F6F6E4469644368616E67654E6F6465536C6F7753746174652E666972652865297D292C28653D3E6E756C6C29292C693D742E66696E616C6C79282828293D3E6E2E63616E63656C282929297D7D656C736520693D50726F6D6973652E7265736F6C';
wwv_flow_imp.g_varchar2_table(22138) := '7665285A652E656D7074792829293B7472797B636F6E7374206F3D617761697420693B72657475726E20746869732E7365744368696C6472656E28652C6F2C742C6E297D63617463682874297B69662865213D3D746869732E726F6F742626746869732E';
wwv_flow_imp.g_varchar2_table(22139) := '747265652E686173456C656D656E742865292626746869732E747265652E636F6C6C617073652865292C54652874292972657475726E5B5D3B7468726F7720747D66696E616C6C797B652E736C6F77262628652E736C6F773D21312C746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(22140) := '4469644368616E67654E6F6465536C6F7753746174652E66697265286529297D7D646F4765744368696C6472656E2865297B6C657420743D746869732E7265667265736850726F6D697365732E6765742865293B696628742972657475726E20743B636F';
wwv_flow_imp.g_varchar2_table(22141) := '6E7374206E3D746869732E64617461536F757263652E6765744368696C6472656E28652E656C656D656E74293B72657475726E206D6C286E293F746869732E70726F636573734368696C6472656E286E293A28743D467428286173796E6328293D3E7468';
wwv_flow_imp.g_varchar2_table(22142) := '69732E70726F636573734368696C6472656E286177616974206E2929292C746869732E7265667265736850726F6D697365732E73657428652C74292C742E66696E616C6C79282828293D3E7B746869732E7265667265736850726F6D697365732E64656C';
wwv_flow_imp.g_varchar2_table(22143) := '6574652865297D2929297D5F6F6E4469644368616E6765436F6C6C617073655374617465287B6E6F64653A652C646565703A747D297B6E756C6C213D3D652E656C656D656E74262621652E636F6C6C61707365642626652E656C656D656E742E7374616C';
wwv_flow_imp.g_varchar2_table(22144) := '65262628743F746869732E636F6C6C6170736528652E656C656D656E742E656C656D656E74293A746869732E72656672657368416E6452656E6465724E6F646528652E656C656D656E742C2131292E6361746368286B6529297D7365744368696C647265';
wwv_flow_imp.g_varchar2_table(22145) := '6E28652C742C6E2C69297B636F6E7374206F3D5B2E2E2E745D3B696628303D3D3D652E6368696C6472656E2E6C656E6774682626303D3D3D6F2E6C656E6774682972657475726E5B5D3B636F6E737420733D6E6577204D61702C723D6E6577204D61703B';
wwv_flow_imp.g_varchar2_table(22146) := '666F7228636F6E73742074206F6620652E6368696C6472656E29732E73657428742E656C656D656E742C74292C746869732E6964656E7469747950726F76696465722626722E73657428742E69642C7B6E6F64653A742C636F6C6C61707365643A746869';
wwv_flow_imp.g_varchar2_table(22147) := '732E747265652E686173456C656D656E742874292626746869732E747265652E6973436F6C6C61707365642874297D293B636F6E737420613D5B5D2C6C3D6F2E6D61702828743D3E7B636F6E7374206F3D2121746869732E64617461536F757263652E68';
wwv_flow_imp.g_varchar2_table(22148) := '61734368696C6472656E2874293B69662821746869732E6964656E7469747950726F7669646572297B636F6E7374206E3D614B287B656C656D656E743A742C706172656E743A652C6861734368696C6472656E3A6F2C64656661756C74436F6C6C617073';
wwv_flow_imp.g_varchar2_table(22149) := '6553746174653A746869732E67657444656661756C74436F6C6C6170736553746174652874297D293B72657475726E206F26266E2E64656661756C74436F6C6C6170736553746174653D3D3D64552E50726573657276654F72457870616E646564262661';
wwv_flow_imp.g_varchar2_table(22150) := '2E70757368286E292C6E7D636F6E7374206C3D746869732E6964656E7469747950726F76696465722E67657449642874292E746F537472696E6728292C633D722E676574286C293B69662863297B636F6E737420653D632E6E6F64653B72657475726E20';
wwv_flow_imp.g_varchar2_table(22151) := '732E64656C65746528652E656C656D656E74292C746869732E6E6F6465732E64656C65746528652E656C656D656E74292C746869732E6E6F6465732E73657428742C65292C652E656C656D656E743D742C652E6861734368696C6472656E3D6F2C6E3F63';
wwv_flow_imp.g_varchar2_table(22152) := '2E636F6C6C61707365643F28652E6368696C6472656E2E666F72456163682828653D3E764B28652C28653D3E746869732E6E6F6465732E64656C65746528652E656C656D656E7429292929292C652E6368696C6472656E2E73706C69636528302C652E63';
wwv_flow_imp.g_varchar2_table(22153) := '68696C6472656E2E6C656E677468292C652E7374616C653D2130293A612E707573682865293A6F262621632E636F6C6C61707365642626612E707573682865292C657D636F6E737420643D614B287B656C656D656E743A742C706172656E743A652C6964';
wwv_flow_imp.g_varchar2_table(22154) := '3A6C2C6861734368696C6472656E3A6F2C64656661756C74436F6C6C6170736553746174653A746869732E67657444656661756C74436F6C6C6170736553746174652874297D293B72657475726E20692626692E7669657753746174652E666F63757326';
wwv_flow_imp.g_varchar2_table(22155) := '26692E7669657753746174652E666F6375732E696E6465784F66286C293E2D312626692E666F6375732E707573682864292C692626692E7669657753746174652E73656C656374696F6E2626692E7669657753746174652E73656C656374696F6E2E696E';
wwv_flow_imp.g_varchar2_table(22156) := '6465784F66286C293E2D312626692E73656C656374696F6E2E707573682864292C28692626692E7669657753746174652E657870616E6465642626692E7669657753746174652E657870616E6465642E696E6465784F66286C293E2D317C7C6F2626642E';
wwv_flow_imp.g_varchar2_table(22157) := '64656661756C74436F6C6C6170736553746174653D3D3D64552E50726573657276654F72457870616E646564292626612E707573682864292C647D29293B666F7228636F6E73742065206F6620732E76616C756573282929764B28652C28653D3E746869';
wwv_flow_imp.g_varchar2_table(22158) := '732E6E6F6465732E64656C65746528652E656C656D656E742929293B666F7228636F6E73742065206F66206C29746869732E6E6F6465732E73657428652E656C656D656E742C65293B72657475726E20652E6368696C6472656E2E73706C69636528302C';
wwv_flow_imp.g_varchar2_table(22159) := '652E6368696C6472656E2E6C656E6774682C2E2E2E6C292C65213D3D746869732E726F6F742626746869732E6175746F457870616E6453696E676C654368696C6472656E2626313D3D3D6C2E6C656E6774682626303D3D3D612E6C656E6774682626286C';
wwv_flow_imp.g_varchar2_table(22160) := '5B305D2E666F726365457870616E6465643D21302C612E70757368286C5B305D29292C617D72656E64657228652C742C6E297B636F6E737420693D652E6368696C6472656E2E6D61702828653D3E746869732E617354726565456C656D656E7428652C74';
wwv_flow_imp.g_varchar2_table(22161) := '2929292C6F3D6E26267B2E2E2E6E2C646966664964656E7469747950726F76696465723A6E2E646966664964656E7469747950726F766964657226267B67657449643A653D3E6E2E646966664964656E7469747950726F76696465722E67657449642865';
wwv_flow_imp.g_varchar2_table(22162) := '2E656C656D656E74297D7D3B746869732E747265652E7365744368696C6472656E28653D3D3D746869732E726F6F743F6E756C6C3A652C692C6F292C65213D3D746869732E726F6F742626746869732E747265652E736574436F6C6C61707369626C6528';
wwv_flow_imp.g_varchar2_table(22163) := '652C652E6861734368696C6472656E292C746869732E5F6F6E44696452656E6465722E6669726528297D617354726565456C656D656E7428652C74297B696628652E7374616C652972657475726E7B656C656D656E743A652C636F6C6C61707369626C65';
wwv_flow_imp.g_varchar2_table(22164) := '3A652E6861734368696C6472656E2C636F6C6C61707365643A21307D3B6C6574206E3B72657475726E20742626742E7669657753746174652E657870616E6465642626652E69642626742E7669657753746174652E657870616E6465642E696E6465784F';
wwv_flow_imp.g_varchar2_table(22165) := '6628652E6964293E2D313F6E3D21313A652E666F726365457870616E6465643F286E3D21312C652E666F726365457870616E6465643D2131293A6E3D652E64656661756C74436F6C6C6170736553746174652C7B656C656D656E743A652C6368696C6472';
wwv_flow_imp.g_varchar2_table(22166) := '656E3A652E6861734368696C6472656E3F5A652E6D617028652E6368696C6472656E2C28653D3E746869732E617354726565456C656D656E7428652C742929293A5B5D2C636F6C6C61707369626C653A652E6861734368696C6472656E2C636F6C6C6170';
wwv_flow_imp.g_varchar2_table(22167) := '7365643A6E7D7D70726F636573734368696C6472656E2865297B72657475726E20746869732E736F72746572262628653D5B2E2E2E655D2E736F727428746869732E736F727465722E636F6D706172652E62696E6428746869732E736F72746572292929';
wwv_flow_imp.g_varchar2_table(22168) := '2C657D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528292C746869732E747265652E646973706F736528297D7D636C617373205F4B7B67657420656C656D656E7428297B72657475726E7B656C656D656E74733A';
wwv_flow_imp.g_varchar2_table(22169) := '746869732E6E6F64652E656C656D656E742E656C656D656E74732E6D61702828653D3E652E656C656D656E7429292C696E636F6D707265737369626C653A746869732E6E6F64652E656C656D656E742E696E636F6D707265737369626C657D7D67657420';
wwv_flow_imp.g_varchar2_table(22170) := '6368696C6472656E28297B72657475726E20746869732E6E6F64652E6368696C6472656E2E6D61702828653D3E6E6577205F4B28652929297D67657420646570746828297B72657475726E20746869732E6E6F64652E64657074687D6765742076697369';
wwv_flow_imp.g_varchar2_table(22171) := '626C654368696C6472656E436F756E7428297B72657475726E20746869732E6E6F64652E76697369626C654368696C6472656E436F756E747D6765742076697369626C654368696C64496E64657828297B72657475726E20746869732E6E6F64652E7669';
wwv_flow_imp.g_varchar2_table(22172) := '7369626C654368696C64496E6465787D67657420636F6C6C61707369626C6528297B72657475726E20746869732E6E6F64652E636F6C6C61707369626C657D67657420636F6C6C617073656428297B72657475726E20746869732E6E6F64652E636F6C6C';
wwv_flow_imp.g_varchar2_table(22173) := '61707365647D6765742076697369626C6528297B72657475726E20746869732E6E6F64652E76697369626C657D6765742066696C7465724461746128297B72657475726E20746869732E6E6F64652E66696C746572446174617D636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(22174) := '722865297B746869732E6E6F64653D657D7D636C61737320794B7B636F6E7374727563746F7228652C742C6E2C69297B746869732E72656E64657265723D652C746869732E6E6F64654D61707065723D742C746869732E636F6D707265737369626C654E';
wwv_flow_imp.g_varchar2_table(22175) := '6F64654D617070657250726F76696465723D6E2C746869732E6F6E4469644368616E67655477697374696553746174653D692C746869732E72656E64657265644E6F6465733D6E6577204D61702C746869732E646973706F7361626C65733D5B5D2C7468';
wwv_flow_imp.g_varchar2_table(22176) := '69732E74656D706C61746549643D652E74656D706C61746549647D72656E64657254656D706C6174652865297B72657475726E7B74656D706C617465446174613A746869732E72656E64657265722E72656E64657254656D706C6174652865297D7D7265';
wwv_flow_imp.g_varchar2_table(22177) := '6E646572456C656D656E7428652C742C6E2C69297B746869732E72656E64657265722E72656E646572456C656D656E7428746869732E6E6F64654D61707065722E6D61702865292C742C6E2E74656D706C617465446174612C69297D72656E646572436F';
wwv_flow_imp.g_varchar2_table(22178) := '6D70726573736564456C656D656E747328652C742C6E2C69297B746869732E72656E64657265722E72656E646572436F6D70726573736564456C656D656E747328746869732E636F6D707265737369626C654E6F64654D617070657250726F7669646572';
wwv_flow_imp.g_varchar2_table(22179) := '28292E6D61702865292C742C6E2E74656D706C617465446174612C69297D72656E6465725477697374696528652C74297B72657475726E20652E736C6F773F28742E636C6173734C6973742E616464282E2E2E546C2E6173436C6173734E616D65417272';
wwv_flow_imp.g_varchar2_table(22180) := '6179284C6C2E747265654974656D4C6F6164696E6729292C2130293A28742E636C6173734C6973742E72656D6F7665282E2E2E546C2E6173436C6173734E616D654172726179284C6C2E747265654974656D4C6F6164696E6729292C2131297D64697370';
wwv_flow_imp.g_varchar2_table(22181) := '6F7365456C656D656E7428652C742C6E2C69297B766172206F2C733B6E756C6C3D3D3D28733D286F3D746869732E72656E6465726572292E646973706F7365456C656D656E74297C7C766F696420303D3D3D737C7C732E63616C6C286F2C746869732E6E';
wwv_flow_imp.g_varchar2_table(22182) := '6F64654D61707065722E6D61702865292C742C6E2E74656D706C617465446174612C69297D646973706F7365436F6D70726573736564456C656D656E747328652C742C6E2C69297B766172206F2C733B6E756C6C3D3D3D28733D286F3D746869732E7265';
wwv_flow_imp.g_varchar2_table(22183) := '6E6465726572292E646973706F7365436F6D70726573736564456C656D656E7473297C7C766F696420303D3D3D737C7C732E63616C6C286F2C746869732E636F6D707265737369626C654E6F64654D617070657250726F766964657228292E6D61702865';
wwv_flow_imp.g_varchar2_table(22184) := '292C742C6E2E74656D706C617465446174612C69297D646973706F736554656D706C6174652865297B746869732E72656E64657265722E646973706F736554656D706C61746528652E74656D706C61746544617461297D646973706F736528297B746869';
wwv_flow_imp.g_varchar2_table(22185) := '732E72656E64657265644E6F6465732E636C65617228292C746869732E646973706F7361626C65733D6F7428746869732E646973706F7361626C6573297D7D636C61737320774B20657874656E647320624B7B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(22186) := '2C692C6F2C732C723D7B7D297B737570657228652C742C6E2C6F2C732C72292C746869732E636F6D7072657373696F6E44656C65676174653D692C746869732E636F6D707265737369626C654E6F64654D61707065723D6E65772070552828653D3E6E65';
wwv_flow_imp.g_varchar2_table(22187) := '77205F4B28652929292C746869732E66696C7465723D722E66696C7465727D6372656174655472656528652C742C6E2C692C6F297B636F6E737420733D6E6577204C55286E292C723D692E6D61702828653D3E6E657720794B28652C746869732E6E6F64';
wwv_flow_imp.g_varchar2_table(22188) := '654D61707065722C2828293D3E746869732E636F6D707265737369626C654E6F64654D6170706572292C746869732E5F6F6E4469644368616E67654E6F6465536C6F7753746174652E6576656E742929292C613D66756E6374696F6E2865297B636F6E73';
wwv_flow_imp.g_varchar2_table(22189) := '7420743D652626664B2865293B72657475726E207426267B2E2E2E742C6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723A742E6B6579626F6172644E617669676174696F6E4C6162656C50726F766964657226267B2E2E2E';
wwv_flow_imp.g_varchar2_table(22190) := '742E6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465722C676574436F6D707265737365644E6F64654B6579626F6172644E617669676174696F6E4C6162656C3A743D3E652E6B6579626F6172644E617669676174696F6E4C61';
wwv_flow_imp.g_varchar2_table(22191) := '62656C50726F76696465722E676574436F6D707265737365644E6F64654B6579626F6172644E617669676174696F6E4C6162656C28742E6D61702828653D3E652E656C656D656E742929297D7D7D286F297C7C7B7D3B72657475726E206E657720724B28';
wwv_flow_imp.g_varchar2_table(22192) := '652C742C732C722C61297D617354726565456C656D656E7428652C74297B72657475726E7B696E636F6D707265737369626C653A746869732E636F6D7072657373696F6E44656C65676174652E6973496E636F6D707265737369626C6528652E656C656D';
wwv_flow_imp.g_varchar2_table(22193) := '656E74292C2E2E2E73757065722E617354726565456C656D656E7428652C74297D7D7570646174654F7074696F6E7328653D7B7D297B746869732E747265652E7570646174654F7074696F6E732865297D72656E64657228652C742C6E297B6966282174';
wwv_flow_imp.g_varchar2_table(22194) := '6869732E6964656E7469747950726F76696465722972657475726E2073757065722E72656E64657228652C74293B636F6E737420693D653D3E746869732E6964656E7469747950726F76696465722E67657449642865292E746F537472696E6728292C6F';
wwv_flow_imp.g_varchar2_table(22195) := '3D653D3E7B636F6E737420743D6E6577205365743B666F7228636F6E7374206E206F662065297B636F6E737420653D746869732E747265652E676574436F6D70726573736564547265654E6F6465286E3D3D3D746869732E726F6F743F6E756C6C3A6E29';
wwv_flow_imp.g_varchar2_table(22196) := '3B696628652E656C656D656E7429666F7228636F6E7374206E206F6620652E656C656D656E742E656C656D656E747329742E6164642869286E2E656C656D656E7429297D72657475726E20747D2C733D6F28746869732E747265652E67657453656C6563';
wwv_flow_imp.g_varchar2_table(22197) := '74696F6E2829292C723D6F28746869732E747265652E676574466F6375732829293B73757065722E72656E64657228652C742C6E293B636F6E737420613D746869732E67657453656C656374696F6E28293B6C6574206C3D21313B636F6E737420633D74';
wwv_flow_imp.g_varchar2_table(22198) := '6869732E676574466F63757328293B6C657420643D21313B636F6E737420683D653D3E7B636F6E737420743D652E656C656D656E743B6966287429666F72286C657420653D303B653C742E656C656D656E74732E6C656E6774683B652B2B297B636F6E73';
wwv_flow_imp.g_varchar2_table(22199) := '74206E3D6928742E656C656D656E74735B655D2E656C656D656E74292C6F3D742E656C656D656E74735B742E656C656D656E74732E6C656E6774682D315D2E656C656D656E743B732E686173286E2926262D313D3D3D612E696E6465784F66286F292626';
wwv_flow_imp.g_varchar2_table(22200) := '28612E70757368286F292C6C3D2130292C722E686173286E2926262D313D3D3D632E696E6465784F66286F29262628632E70757368286F292C643D2130297D652E6368696C6472656E2E666F72456163682868297D3B6828746869732E747265652E6765';
wwv_flow_imp.g_varchar2_table(22201) := '74436F6D70726573736564547265654E6F646528653D3D3D746869732E726F6F743F6E756C6C3A6529292C6C2626746869732E73657453656C656374696F6E2861292C642626746869732E736574466F6375732863297D70726F636573734368696C6472';
wwv_flow_imp.g_varchar2_table(22202) := '656E2865297B72657475726E20746869732E66696C746572262628653D5A652E66696C74657228652C28653D3E7B636F6E737420743D22626F6F6C65616E223D3D747970656F66286E3D746869732E66696C7465722E66696C74657228652C3129293F6E';
wwv_flow_imp.g_varchar2_table(22203) := '3F313A303A6755286E293F6D55286E2E7669736962696C697479293A6D55286E293B766172206E3B696628323D3D3D74297468726F77206E6577204572726F7228225265637572736976652074726565207669736962696C697479206E6F742073757070';
wwv_flow_imp.g_varchar2_table(22204) := '6F7274656420696E206173796E63206461746120636F6D7072657373656420747265657322293B72657475726E20313D3D3D747D2929292C73757065722E70726F636573734368696C6472656E2865297D7D636C61737320434B20657874656E64732024';
wwv_flow_imp.g_varchar2_table(22205) := '557B636F6E7374727563746F7228652C742C6E2C692C6F2C733D7B7D297B737570657228652C742C6E2C692C73292C746869732E757365723D652C746869732E64617461536F757263653D6F2C746869732E6964656E7469747950726F76696465723D73';
wwv_flow_imp.g_varchar2_table(22206) := '2E6964656E7469747950726F76696465727D6372656174654D6F64656C28652C742C6E297B72657475726E206E657720555528652C742C6E297D7D6E6577206C64282269734D6163222C712C6228302C225768657468657220746865206F706572617469';
wwv_flow_imp.g_varchar2_table(22207) := '6E672073797374656D206973206D61634F532229292C6E6577206C64282269734C696E7578222C242C6228302C225768657468657220746865206F7065726174696E672073797374656D206973204C696E75782229293B636F6E737420534B3D6E657720';
wwv_flow_imp.g_varchar2_table(22208) := '6C642822697357696E646F7773222C6A2C6228302C225768657468657220746865206F7065726174696E672073797374656D2069732057696E646F77732229292C784B3D6E6577206C6428226973576562222C4B2C6228302C2257686574686572207468';
wwv_flow_imp.g_varchar2_table(22209) := '6520706C6174666F726D2069732061207765622062726F777365722229292C6B4B3D286E6577206C64282269734D61634E6174697665222C712626214B2C6228302C225768657468657220746865206F7065726174696E672073797374656D206973206D';
wwv_flow_imp.g_varchar2_table(22210) := '61634F53206F6E2061206E6F6E2D62726F7773657220706C6174666F726D2229292C6E6577206C6428226973494F53222C512C6228302C225768657468657220746865206F7065726174696E672073797374656D20697320694F532229292C6E6577206C';
wwv_flow_imp.g_varchar2_table(22211) := '64282269734D6F62696C65222C592C6228302C22576865746865722074686520706C6174666F726D2069732061206D6F62696C65207765622062726F777365722229292C6E6577206C6428226973446576656C6F706D656E74222C21312C2130292C6E65';
wwv_flow_imp.g_varchar2_table(22212) := '77206C64282270726F647563745175616C69747954797065222C22222C6228302C225175616C6974792074797065206F6620565320436F64652229292C22696E707574466F63757322292C454B3D6E6577206C64286B4B2C21312C6228302C2257686574';
wwv_flow_imp.g_varchar2_table(22213) := '686572206B6579626F61726420666F63757320697320696E7369646520616E20696E70757420626F782229293B766172204C4B3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C33';
wwv_flow_imp.g_varchar2_table(22214) := '3F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(22215) := '205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F';
wwv_flow_imp.g_varchar2_table(22216) := '2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C444B3D66756E6374696F6E28652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(22217) := '66756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E737420544B3D706328226C6973745365727669636522292C494B3D6E6577206C6428226C6973745363726F6C6C4174426F756E64617279222C226E6F6E6522292C4D4B3D2857632E';
wwv_flow_imp.g_varchar2_table(22218) := '6F7228494B2E6973457175616C546F2822746F7022292C494B2E6973457175616C546F2822626F74682229292C57632E6F7228494B2E6973457175616C546F2822626F74746F6D22292C494B2E6973457175616C546F2822626F74682229292C6E657720';
wwv_flow_imp.g_varchar2_table(22219) := '6C6428226C697374466F637573222C213029292C414B3D6E6577206C64282274726565737469636B795363726F6C6C466F6375736564222C2131292C4E4B3D6E6577206C6428226C697374537570706F7274734D756C746973656C656374222C2130292C';
wwv_flow_imp.g_varchar2_table(22220) := '504B3D57632E616E64284D4B2C57632E6E6F74286B4B292C414B2E6E65676174652829292C4F4B3D6E6577206C6428226C69737448617353656C656374696F6E4F72466F637573222C2131292C524B3D6E6577206C6428226C697374446F75626C655365';
wwv_flow_imp.g_varchar2_table(22221) := '6C656374696F6E222C2131292C464B3D6E6577206C6428226C6973744D756C746953656C656374696F6E222C2131292C424B3D6E6577206C6428226C69737453656C656374696F6E4E617669676174696F6E222C2131292C564B3D6E6577206C6428226C';
wwv_flow_imp.g_varchar2_table(22222) := '697374537570706F72747346696E64222C2130292C7A4B3D6E6577206C64282274726565456C656D656E7443616E436F6C6C61707365222C2131292C484B3D6E6577206C64282274726565456C656D656E74486173506172656E74222C2131292C574B3D';
wwv_flow_imp.g_varchar2_table(22223) := '6E6577206C64282274726565456C656D656E7443616E457870616E64222C2131292C6A4B3D6E6577206C64282274726565456C656D656E744861734368696C64222C2131292C714B3D6E6577206C6428227472656546696E644F70656E222C2131292C24';
wwv_flow_imp.g_varchar2_table(22224) := '4B3D226C697374547970654E617669676174696F6E4D6F6465222C554B3D226C6973744175746F6D617469634B6579626F6172644E617669676174696F6E223B66756E6374696F6E204B4B28652C74297B636F6E7374206E3D652E63726561746553636F';
wwv_flow_imp.g_varchar2_table(22225) := '70656428742E67657448544D4C456C656D656E742829293B72657475726E204D4B2E62696E64546F286E292C6E7D66756E6374696F6E20474B28652C74297B636F6E7374206E3D494B2E62696E64546F2865292C693D28293D3E7B636F6E737420653D30';
wwv_flow_imp.g_varchar2_table(22226) := '3D3D3D742E7363726F6C6C546F702C693D742E7363726F6C6C4865696768742D742E72656E6465724865696768742D742E7363726F6C6C546F703C313B652626693F6E2E7365742822626F746822293A653F6E2E7365742822746F7022293A693F6E2E73';
wwv_flow_imp.g_varchar2_table(22227) := '65742822626F74746F6D22293A6E2E73657428226E6F6E6522297D3B72657475726E206928292C742E6F6E4469645363726F6C6C2869297D636F6E737420514B3D22776F726B62656E63682E6C6973742E6D756C746953656C6563744D6F646966696572';
wwv_flow_imp.g_varchar2_table(22228) := '222C594B3D22776F726B62656E63682E6C6973742E6F70656E4D6F6465222C5A4B3D22776F726B62656E63682E6C6973742E686F72697A6F6E74616C5363726F6C6C696E67222C584B3D22776F726B62656E63682E6C6973742E64656661756C7446696E';
wwv_flow_imp.g_varchar2_table(22229) := '644D6F6465222C4A4B3D22776F726B62656E63682E6C6973742E747970654E617669676174696F6E4D6F6465222C65473D22776F726B62656E63682E6C6973742E6B6579626F6172644E617669676174696F6E222C74473D22776F726B62656E63682E6C';
wwv_flow_imp.g_varchar2_table(22230) := '6973742E7363726F6C6C427950616765222C6E473D22776F726B62656E63682E6C6973742E64656661756C7446696E644D6174636854797065222C69473D22776F726B62656E63682E747265652E696E64656E74222C6F473D22776F726B62656E63682E';
wwv_flow_imp.g_varchar2_table(22231) := '747265652E72656E646572496E64656E74477569646573222C73473D22776F726B62656E63682E6C6973742E736D6F6F74685363726F6C6C696E67222C72473D22776F726B62656E63682E6C6973742E6D6F757365576865656C5363726F6C6C53656E73';
wwv_flow_imp.g_varchar2_table(22232) := '69746976697479222C61473D22776F726B62656E63682E6C6973742E666173745363726F6C6C53656E7369746976697479222C6C473D22776F726B62656E63682E747265652E657870616E644D6F6465222C63473D22776F726B62656E63682E74726565';
wwv_flow_imp.g_varchar2_table(22233) := '2E656E61626C65537469636B795363726F6C6C222C64473D22776F726B62656E63682E747265652E737469636B795363726F6C6C4D61784974656D436F756E74223B66756E6374696F6E2068472865297B72657475726E22616C74223D3D3D652E676574';
wwv_flow_imp.g_varchar2_table(22234) := '56616C756528514B297D636C61737320754720657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E636F6E66696775726174696F6E536572766963653D652C746869732E757365416C7441734D756C746970';
wwv_flow_imp.g_varchar2_table(22235) := '6C6553656C656374696F6E4D6F6469666965723D68472865292C746869732E72656769737465724C697374656E65727328297D72656769737465724C697374656E65727328297B746869732E5F726567697374657228746869732E636F6E666967757261';
wwv_flow_imp.g_varchar2_table(22236) := '74696F6E536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E28514B29262628746869732E757365416C7441734D756C7469706C6553656C656374696F';
wwv_flow_imp.g_varchar2_table(22237) := '6E4D6F6469666965723D684728746869732E636F6E66696775726174696F6E5365727669636529297D2929297D697353656C656374696F6E53696E676C654368616E67654576656E742865297B72657475726E20746869732E757365416C7441734D756C';
wwv_flow_imp.g_varchar2_table(22238) := '7469706C6553656C656374696F6E4D6F6469666965723F652E62726F777365724576656E742E616C744B65793A50492865297D697353656C656374696F6E52616E67654368616E67654576656E742865297B72657475726E204F492865297D7D66756E63';
wwv_flow_imp.g_varchar2_table(22239) := '74696F6E20704728652C74297B766172206E3B636F6E737420693D652E676574286670292C6F3D652E676574282445292C733D6E65772061743B72657475726E5B7B2E2E2E742C6B6579626F6172644E617669676174696F6E44656C65676174653A7B6D';
wwv_flow_imp.g_varchar2_table(22240) := '6967687450726F647563655072696E7461626C654368617261637465723A653D3E6F2E6D6967687450726F647563655072696E7461626C654368617261637465722865297D2C736D6F6F74685363726F6C6C696E673A426F6F6C65616E28692E67657456';
wwv_flow_imp.g_varchar2_table(22241) := '616C756528734729292C6D6F757365576865656C5363726F6C6C53656E73697469766974793A692E67657456616C7565287247292C666173745363726F6C6C53656E73697469766974793A692E67657456616C7565286147292C6D756C7469706C655365';
wwv_flow_imp.g_varchar2_table(22242) := '6C656374696F6E436F6E74726F6C6C65723A6E756C6C213D3D286E3D742E6D756C7469706C6553656C656374696F6E436F6E74726F6C6C6572292626766F69642030213D3D6E3F6E3A732E616464286E6577207547286929292C6B6579626F6172644E61';
wwv_flow_imp.g_varchar2_table(22243) := '7669676174696F6E4576656E7446696C7465723A7747286F292C7363726F6C6C4279506167653A426F6F6C65616E28692E67657456616C756528744729297D2C735D7D6C65742067473D636C61737320657874656E64732055497B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(22244) := '6F7228652C742C6E2C692C6F2C732C722C612C6C297B636F6E737420633D766F69642030213D3D6F2E686F72697A6F6E74616C5363726F6C6C696E673F6F2E686F72697A6F6E74616C5363726F6C6C696E673A426F6F6C65616E28612E67657456616C75';
wwv_flow_imp.g_varchar2_table(22245) := '65285A4B29292C5B642C685D3D6C2E696E766F6B6546756E6374696F6E2870472C6F293B737570657228652C742C6E2C692C7B6B6579626F617264537570706F72743A21312C2E2E2E642C686F72697A6F6E74616C5363726F6C6C696E673A637D292C74';
wwv_flow_imp.g_varchar2_table(22246) := '6869732E646973706F7361626C65732E6164642868292C746869732E636F6E746578744B6579536572766963653D4B4B28732C74686973292C746869732E646973706F7361626C65732E61646428474B28746869732E636F6E746578744B657953657276';
wwv_flow_imp.g_varchar2_table(22247) := '6963652C7468697329292C746869732E6C697374537570706F7274734D756C746953656C6563743D4E4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C697374537570706F7274734D756C746953656C65';
wwv_flow_imp.g_varchar2_table(22248) := '63742E736574282131213D3D6F2E6D756C7469706C6553656C656374696F6E537570706F7274292C424B2E62696E64546F28746869732E636F6E746578744B657953657276696365292E73657428426F6F6C65616E286F2E73656C656374696F6E4E6176';
wwv_flow_imp.g_varchar2_table(22249) := '69676174696F6E29292C746869732E6C69737448617353656C656374696F6E4F72466F6375733D4F4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C697374446F75626C6553656C656374696F6E3D524B';
wwv_flow_imp.g_varchar2_table(22250) := '2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C6973744D756C746953656C656374696F6E3D464B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E686F72697A';
wwv_flow_imp.g_varchar2_table(22251) := '6F6E74616C5363726F6C6C696E673D6F2E686F72697A6F6E74616C5363726F6C6C696E672C746869732E5F757365416C7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D68472861292C746869732E646973706F7361626C65732E';
wwv_flow_imp.g_varchar2_table(22252) := '61646428746869732E636F6E746578744B657953657276696365292C746869732E646973706F7361626C65732E61646428722E7265676973746572287468697329292C746869732E7570646174655374796C6573286F2E6F766572726964655374796C65';
wwv_flow_imp.g_varchar2_table(22253) := '73292C746869732E646973706F7361626C65732E61646428746869732E6F6E4469644368616E676553656C656374696F6E282828293D3E7B636F6E737420653D746869732E67657453656C656374696F6E28292C743D746869732E676574466F63757328';
wwv_flow_imp.g_varchar2_table(22254) := '293B746869732E636F6E746578744B6579536572766963652E6275666665724368616E67654576656E7473282828293D3E7B746869732E6C69737448617353656C656374696F6E4F72466F6375732E73657428652E6C656E6774683E307C7C742E6C656E';
wwv_flow_imp.g_varchar2_table(22255) := '6774683E30292C746869732E6C6973744D756C746953656C656374696F6E2E73657428652E6C656E6774683E31292C746869732E6C697374446F75626C6553656C656374696F6E2E73657428323D3D3D652E6C656E677468297D29297D2929292C746869';
wwv_flow_imp.g_varchar2_table(22256) := '732E646973706F7361626C65732E61646428746869732E6F6E4469644368616E6765466F637573282828293D3E7B636F6E737420653D746869732E67657453656C656374696F6E28292C743D746869732E676574466F63757328293B746869732E6C6973';
wwv_flow_imp.g_varchar2_table(22257) := '7448617353656C656374696F6E4F72466F6375732E73657428652E6C656E6774683E307C7C742E6C656E6774683E30297D2929292C746869732E646973706F7361626C65732E61646428612E6F6E4469644368616E6765436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(22258) := '2828653D3E7B652E61666665637473436F6E66696775726174696F6E28514B29262628746869732E5F757365416C7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D6847286129293B6C657420743D7B7D3B696628652E61666665';
wwv_flow_imp.g_varchar2_table(22259) := '637473436F6E66696775726174696F6E285A4B292626766F696420303D3D3D746869732E686F72697A6F6E74616C5363726F6C6C696E67297B636F6E737420653D426F6F6C65616E28612E67657456616C7565285A4B29293B743D7B2E2E2E742C686F72';
wwv_flow_imp.g_varchar2_table(22260) := '697A6F6E74616C5363726F6C6C696E673A657D7D696628652E61666665637473436F6E66696775726174696F6E28744729297B636F6E737420653D426F6F6C65616E28612E67657456616C756528744729293B743D7B2E2E2E742C7363726F6C6C427950';
wwv_flow_imp.g_varchar2_table(22261) := '6167653A657D7D696628652E61666665637473436F6E66696775726174696F6E28734729297B636F6E737420653D426F6F6C65616E28612E67657456616C756528734729293B743D7B2E2E2E742C736D6F6F74685363726F6C6C696E673A657D7D696628';
wwv_flow_imp.g_varchar2_table(22262) := '652E61666665637473436F6E66696775726174696F6E28724729297B636F6E737420653D612E67657456616C7565287247293B743D7B2E2E2E742C6D6F757365576865656C5363726F6C6C53656E73697469766974793A657D7D696628652E6166666563';
wwv_flow_imp.g_varchar2_table(22263) := '7473436F6E66696775726174696F6E28614729297B636F6E737420653D612E67657456616C7565286147293B743D7B2E2E2E742C666173745363726F6C6C53656E73697469766974793A657D7D4F626A6563742E6B6579732874292E6C656E6774683E30';
wwv_flow_imp.g_varchar2_table(22264) := '2626746869732E7570646174654F7074696F6E732874297D2929292C746869732E6E6176696761746F723D6E657720624728746869732C7B636F6E66696775726174696F6E536572766963653A612C2E2E2E6F7D292C746869732E646973706F7361626C';
wwv_flow_imp.g_varchar2_table(22265) := '65732E61646428746869732E6E6176696761746F72297D7570646174654F7074696F6E732865297B73757065722E7570646174654F7074696F6E732865292C766F69642030213D3D652E6F766572726964655374796C65732626746869732E7570646174';
wwv_flow_imp.g_varchar2_table(22266) := '655374796C657328652E6F766572726964655374796C6573292C766F69642030213D3D652E6D756C7469706C6553656C656374696F6E537570706F72742626746869732E6C697374537570706F7274734D756C746953656C6563742E736574282121652E';
wwv_flow_imp.g_varchar2_table(22267) := '6D756C7469706C6553656C656374696F6E537570706F7274297D7570646174655374796C65732865297B746869732E7374796C6528653F494D2865293A544D297D7D3B67473D4C4B285B444B28352C6364292C444B28362C544B292C444B28372C667029';
wwv_flow_imp.g_varchar2_table(22268) := '2C444B28382C7563295D2C6747293B6C6574206D473D636C61737320657874656E64732054247B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B636F6E737420633D766F69642030213D3D6F2E686F72697A6F6E74616C53';
wwv_flow_imp.g_varchar2_table(22269) := '63726F6C6C696E673F6F2E686F72697A6F6E74616C5363726F6C6C696E673A426F6F6C65616E28612E67657456616C7565285A4B29292C5B642C685D3D6C2E696E766F6B6546756E6374696F6E2870472C6F293B737570657228652C742C6E2C692C7B6B';
wwv_flow_imp.g_varchar2_table(22270) := '6579626F617264537570706F72743A21312C2E2E2E642C686F72697A6F6E74616C5363726F6C6C696E673A637D292C746869732E646973706F7361626C65733D6E65772061742C746869732E646973706F7361626C65732E6164642868292C746869732E';
wwv_flow_imp.g_varchar2_table(22271) := '636F6E746578744B6579536572766963653D4B4B28732C74686973292C746869732E646973706F7361626C65732E61646428474B28746869732E636F6E746578744B6579536572766963652C746869732E77696467657429292C746869732E686F72697A';
wwv_flow_imp.g_varchar2_table(22272) := '6F6E74616C5363726F6C6C696E673D6F2E686F72697A6F6E74616C5363726F6C6C696E672C746869732E6C697374537570706F7274734D756C746953656C6563743D4E4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C';
wwv_flow_imp.g_varchar2_table(22273) := '746869732E6C697374537570706F7274734D756C746953656C6563742E736574282131213D3D6F2E6D756C7469706C6553656C656374696F6E537570706F7274292C424B2E62696E64546F28746869732E636F6E746578744B657953657276696365292E';
wwv_flow_imp.g_varchar2_table(22274) := '73657428426F6F6C65616E286F2E73656C656374696F6E4E617669676174696F6E29292C746869732E5F757365416C7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D68472861292C746869732E646973706F7361626C65732E61';
wwv_flow_imp.g_varchar2_table(22275) := '646428746869732E636F6E746578744B657953657276696365292C746869732E646973706F7361626C65732E61646428722E7265676973746572287468697329292C746869732E7570646174655374796C6573286F2E6F766572726964655374796C6573';
wwv_flow_imp.g_varchar2_table(22276) := '292C746869732E646973706F7361626C65732E61646428612E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E28514B29262628746869732E5F757365416C7441734D75';
wwv_flow_imp.g_varchar2_table(22277) := '6C7469706C6553656C656374696F6E4D6F6469666965723D6847286129293B6C657420743D7B7D3B696628652E61666665637473436F6E66696775726174696F6E285A4B292626766F696420303D3D3D746869732E686F72697A6F6E74616C5363726F6C';
wwv_flow_imp.g_varchar2_table(22278) := '6C696E67297B636F6E737420653D426F6F6C65616E28612E67657456616C7565285A4B29293B743D7B2E2E2E742C686F72697A6F6E74616C5363726F6C6C696E673A657D7D696628652E61666665637473436F6E66696775726174696F6E28744729297B';
wwv_flow_imp.g_varchar2_table(22279) := '636F6E737420653D426F6F6C65616E28612E67657456616C756528744729293B743D7B2E2E2E742C7363726F6C6C4279506167653A657D7D696628652E61666665637473436F6E66696775726174696F6E28734729297B636F6E737420653D426F6F6C65';
wwv_flow_imp.g_varchar2_table(22280) := '616E28612E67657456616C756528734729293B743D7B2E2E2E742C736D6F6F74685363726F6C6C696E673A657D7D696628652E61666665637473436F6E66696775726174696F6E28724729297B636F6E737420653D612E67657456616C7565287247293B';
wwv_flow_imp.g_varchar2_table(22281) := '743D7B2E2E2E742C6D6F757365576865656C5363726F6C6C53656E73697469766974793A657D7D696628652E61666665637473436F6E66696775726174696F6E28614729297B636F6E737420653D612E67657456616C7565286147293B743D7B2E2E2E74';
wwv_flow_imp.g_varchar2_table(22282) := '2C666173745363726F6C6C53656E73697469766974793A657D7D4F626A6563742E6B6579732874292E6C656E6774683E302626746869732E7570646174654F7074696F6E732874297D2929292C746869732E6E6176696761746F723D6E65772062472874';
wwv_flow_imp.g_varchar2_table(22283) := '6869732C7B636F6E66696775726174696F6E536572766963653A612C2E2E2E6F7D292C746869732E646973706F7361626C65732E61646428746869732E6E6176696761746F72297D7570646174654F7074696F6E732865297B73757065722E7570646174';
wwv_flow_imp.g_varchar2_table(22284) := '654F7074696F6E732865292C766F69642030213D3D652E6F766572726964655374796C65732626746869732E7570646174655374796C657328652E6F766572726964655374796C6573292C766F69642030213D3D652E6D756C7469706C6553656C656374';
wwv_flow_imp.g_varchar2_table(22285) := '696F6E537570706F72742626746869732E6C697374537570706F7274734D756C746953656C6563742E736574282121652E6D756C7469706C6553656C656374696F6E537570706F7274297D7570646174655374796C65732865297B746869732E7374796C';
wwv_flow_imp.g_varchar2_table(22286) := '6528653F494D2865293A544D297D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528292C73757065722E646973706F736528297D7D3B6D473D4C4B285B444B28352C6364292C444B28362C544B292C444B28372C66';
wwv_flow_imp.g_varchar2_table(22287) := '70292C444B28382C7563295D2C6D47293B6C65742066473D636C61737320657874656E6473206A247B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C63297B636F6E737420643D766F69642030213D3D732E686F72697A6F6E';
wwv_flow_imp.g_varchar2_table(22288) := '74616C5363726F6C6C696E673F732E686F72697A6F6E74616C5363726F6C6C696E673A426F6F6C65616E286C2E67657456616C7565285A4B29292C5B682C755D3D632E696E766F6B6546756E6374696F6E2870472C73293B737570657228652C742C6E2C';
wwv_flow_imp.g_varchar2_table(22289) := '692C6F2C7B6B6579626F617264537570706F72743A21312C2E2E2E682C686F72697A6F6E74616C5363726F6C6C696E673A647D292C746869732E646973706F7361626C65732E6164642875292C746869732E636F6E746578744B6579536572766963653D';
wwv_flow_imp.g_varchar2_table(22290) := '4B4B28722C74686973292C746869732E646973706F7361626C65732E61646428474B28746869732E636F6E746578744B6579536572766963652C7468697329292C746869732E6C697374537570706F7274734D756C746953656C6563743D4E4B2E62696E';
wwv_flow_imp.g_varchar2_table(22291) := '64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C697374537570706F7274734D756C746953656C6563742E736574282131213D3D732E6D756C7469706C6553656C656374696F6E537570706F7274292C424B2E62696E';
wwv_flow_imp.g_varchar2_table(22292) := '64546F28746869732E636F6E746578744B657953657276696365292E73657428426F6F6C65616E28732E73656C656374696F6E4E617669676174696F6E29292C746869732E6C69737448617353656C656374696F6E4F72466F6375733D4F4B2E62696E64';
wwv_flow_imp.g_varchar2_table(22293) := '546F28746869732E636F6E746578744B657953657276696365292C746869732E6C697374446F75626C6553656C656374696F6E3D524B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C6973744D756C7469';
wwv_flow_imp.g_varchar2_table(22294) := '53656C656374696F6E3D464B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E686F72697A6F6E74616C5363726F6C6C696E673D732E686F72697A6F6E74616C5363726F6C6C696E672C746869732E5F757365';
wwv_flow_imp.g_varchar2_table(22295) := '416C7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D6847286C292C746869732E646973706F7361626C65732E61646428746869732E636F6E746578744B657953657276696365292C746869732E646973706F7361626C65732E61';
wwv_flow_imp.g_varchar2_table(22296) := '646428612E7265676973746572287468697329292C746869732E7570646174655374796C657328732E6F766572726964655374796C6573292C746869732E646973706F7361626C65732E61646428746869732E6F6E4469644368616E676553656C656374';
wwv_flow_imp.g_varchar2_table(22297) := '696F6E282828293D3E7B636F6E737420653D746869732E67657453656C656374696F6E28292C743D746869732E676574466F63757328293B746869732E636F6E746578744B6579536572766963652E6275666665724368616E67654576656E7473282828';
wwv_flow_imp.g_varchar2_table(22298) := '293D3E7B746869732E6C69737448617353656C656374696F6E4F72466F6375732E73657428652E6C656E6774683E307C7C742E6C656E6774683E30292C746869732E6C6973744D756C746953656C656374696F6E2E73657428652E6C656E6774683E3129';
wwv_flow_imp.g_varchar2_table(22299) := '2C746869732E6C697374446F75626C6553656C656374696F6E2E73657428323D3D3D652E6C656E677468297D29297D2929292C746869732E646973706F7361626C65732E61646428746869732E6F6E4469644368616E6765466F637573282828293D3E7B';
wwv_flow_imp.g_varchar2_table(22300) := '636F6E737420653D746869732E67657453656C656374696F6E28292C743D746869732E676574466F63757328293B746869732E6C69737448617353656C656374696F6E4F72466F6375732E73657428652E6C656E6774683E307C7C742E6C656E6774683E';
wwv_flow_imp.g_varchar2_table(22301) := '30297D2929292C746869732E646973706F7361626C65732E616464286C2E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E28514B29262628746869732E5F757365416C';
wwv_flow_imp.g_varchar2_table(22302) := '7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D6847286C29293B6C657420743D7B7D3B696628652E61666665637473436F6E66696775726174696F6E285A4B292626766F696420303D3D3D746869732E686F72697A6F6E74616C';
wwv_flow_imp.g_varchar2_table(22303) := '5363726F6C6C696E67297B636F6E737420653D426F6F6C65616E286C2E67657456616C7565285A4B29293B743D7B2E2E2E742C686F72697A6F6E74616C5363726F6C6C696E673A657D7D696628652E61666665637473436F6E66696775726174696F6E28';
wwv_flow_imp.g_varchar2_table(22304) := '744729297B636F6E737420653D426F6F6C65616E286C2E67657456616C756528744729293B743D7B2E2E2E742C7363726F6C6C4279506167653A657D7D696628652E61666665637473436F6E66696775726174696F6E28734729297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(22305) := '426F6F6C65616E286C2E67657456616C756528734729293B743D7B2E2E2E742C736D6F6F74685363726F6C6C696E673A657D7D696628652E61666665637473436F6E66696775726174696F6E28724729297B636F6E737420653D6C2E67657456616C7565';
wwv_flow_imp.g_varchar2_table(22306) := '287247293B743D7B2E2E2E742C6D6F757365576865656C5363726F6C6C53656E73697469766974793A657D7D696628652E61666665637473436F6E66696775726174696F6E28614729297B636F6E737420653D6C2E67657456616C7565286147293B743D';
wwv_flow_imp.g_varchar2_table(22307) := '7B2E2E2E742C666173745363726F6C6C53656E73697469766974793A657D7D4F626A6563742E6B6579732874292E6C656E6774683E302626746869732E7570646174654F7074696F6E732874297D2929292C746869732E6E6176696761746F723D6E6577';
wwv_flow_imp.g_varchar2_table(22308) := '205F4728746869732C7B636F6E66696775726174696F6E536572766963653A6C2C2E2E2E737D292C746869732E646973706F7361626C65732E61646428746869732E6E6176696761746F72297D7570646174654F7074696F6E732865297B73757065722E';
wwv_flow_imp.g_varchar2_table(22309) := '7570646174654F7074696F6E732865292C766F69642030213D3D652E6F766572726964655374796C65732626746869732E7570646174655374796C657328652E6F766572726964655374796C6573292C766F69642030213D3D652E6D756C7469706C6553';
wwv_flow_imp.g_varchar2_table(22310) := '656C656374696F6E537570706F72742626746869732E6C697374537570706F7274734D756C746953656C6563742E736574282121652E6D756C7469706C6553656C656374696F6E537570706F7274297D7570646174655374796C65732865297B74686973';
wwv_flow_imp.g_varchar2_table(22311) := '2E7374796C6528653F494D2865293A544D297D646973706F736528297B746869732E646973706F7361626C65732E646973706F736528292C73757065722E646973706F736528297D7D3B66473D4C4B285B444B28362C6364292C444B28372C544B292C44';
wwv_flow_imp.g_varchar2_table(22312) := '4B28382C6670292C444B28392C7563295D2C6647293B636C61737320764720657874656E6473206C747B636F6E7374727563746F7228652C74297B766172206E3B737570657228292C746869732E7769646765743D652C746869732E5F6F6E4469644F70';
wwv_flow_imp.g_varchar2_table(22313) := '656E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644F70656E3D746869732E5F6F6E4469644F70656E2E6576656E742C746869732E5F72656769737465722876742E66696C74657228746869732E7769646765742E';
wwv_flow_imp.g_varchar2_table(22314) := '6F6E4469644368616E676553656C656374696F6E2C28653D3E727228652E62726F777365724576656E742929292828653D3E746869732E6F6E53656C656374696F6E46726F6D4B6579626F6172642865292929292C746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(22315) := '746869732E7769646765742E6F6E506F696E7465722828653D3E746869732E6F6E506F696E74657228652E656C656D656E742C652E62726F777365724576656E74292929292C746869732E5F726567697374657228746869732E7769646765742E6F6E4D';
wwv_flow_imp.g_varchar2_table(22316) := '6F75736544626C436C69636B2828653D3E746869732E6F6E4D6F75736544626C436C69636B28652E656C656D656E742C652E62726F777365724576656E74292929292C22626F6F6C65616E22213D747970656F66286E756C6C3D3D743F766F696420303A';
wwv_flow_imp.g_varchar2_table(22317) := '742E6F70656E4F6E53696E676C65436C69636B292626286E756C6C3D3D743F766F696420303A742E636F6E66696775726174696F6E53657276696365293F28746869732E6F70656E4F6E53696E676C65436C69636B3D22646F75626C65436C69636B2221';
wwv_flow_imp.g_varchar2_table(22318) := '3D3D286E756C6C3D3D743F766F696420303A742E636F6E66696775726174696F6E536572766963652E67657456616C756528594B29292C746869732E5F7265676973746572286E756C6C3D3D743F766F696420303A742E636F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(22319) := '536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E28594B29262628746869732E6F70656E4F6E53696E676C65436C69636B3D22646F75626C65436C69';
wwv_flow_imp.g_varchar2_table(22320) := '636B22213D3D286E756C6C3D3D743F766F696420303A742E636F6E66696775726174696F6E536572766963652E67657456616C756528594B2929297D292929293A746869732E6F70656E4F6E53696E676C65436C69636B3D6E756C6C3D3D3D286E3D6E75';
wwv_flow_imp.g_varchar2_table(22321) := '6C6C3D3D743F766F696420303A742E6F70656E4F6E53696E676C65436C69636B297C7C766F696420303D3D3D6E7C7C6E7D6F6E53656C656374696F6E46726F6D4B6579626F6172642865297B69662831213D3D652E656C656D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(22322) := '2972657475726E3B636F6E737420743D652E62726F777365724576656E742C6E3D22626F6F6C65616E22213D747970656F6620742E7072657365727665466F6375737C7C742E7072657365727665466F6375732C693D22626F6F6C65616E223D3D747970';
wwv_flow_imp.g_varchar2_table(22323) := '656F6620742E70696E6E65643F742E70696E6E65643A216E3B746869732E5F6F70656E28746869732E67657453656C6563746564456C656D656E7428292C6E2C692C21312C652E62726F777365724576656E74297D6F6E506F696E74657228652C74297B';
wwv_flow_imp.g_varchar2_table(22324) := '69662821746869732E6F70656E4F6E53696E676C65436C69636B2972657475726E3B696628323D3D3D742E64657461696C2972657475726E3B636F6E7374206E3D313D3D3D742E627574746F6E2C693D742E6374726C4B65797C7C742E6D6574614B6579';
wwv_flow_imp.g_varchar2_table(22325) := '7C7C742E616C744B65793B746869732E5F6F70656E28652C21302C6E2C692C74297D6F6E4D6F75736544626C436C69636B28652C74297B69662821742972657475726E3B636F6E7374206E3D742E7461726765743B6966286E2E636C6173734C6973742E';
wwv_flow_imp.g_varchar2_table(22326) := '636F6E7461696E7328226D6F6E61636F2D746C2D7477697374696522297C7C6E2E636C6173734C6973742E636F6E7461696E7328226D6F6E61636F2D69636F6E2D6C6162656C222926266E2E636C6173734C6973742E636F6E7461696E732822666F6C64';
wwv_flow_imp.g_varchar2_table(22327) := '65722D69636F6E22292626742E6F6666736574583C31362972657475726E3B636F6E737420693D742E6374726C4B65797C7C742E6D6574614B65797C7C742E616C744B65793B746869732E5F6F70656E28652C21312C21302C692C74297D5F6F70656E28';
wwv_flow_imp.g_varchar2_table(22328) := '652C742C6E2C692C6F297B652626746869732E5F6F6E4469644F70656E2E66697265287B656469746F724F7074696F6E733A7B7072657365727665466F6375733A742C70696E6E65643A6E2C72657665616C496656697369626C653A21307D2C73696465';
wwv_flow_imp.g_varchar2_table(22329) := '4279536964653A692C656C656D656E743A652C62726F777365724576656E743A6F7D297D7D636C61737320624720657874656E64732076477B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E7769646765743D657D67';
wwv_flow_imp.g_varchar2_table(22330) := '657453656C6563746564456C656D656E7428297B72657475726E20746869732E7769646765742E67657453656C6563746564456C656D656E747328295B305D7D7D636C617373205F4720657874656E64732076477B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(22331) := '297B737570657228652C74297D67657453656C6563746564456C656D656E7428297B72657475726E20746869732E7769646765742E67657453656C6563746564456C656D656E747328295B305D7D7D636C61737320794720657874656E64732076477B63';
wwv_flow_imp.g_varchar2_table(22332) := '6F6E7374727563746F7228652C74297B737570657228652C74297D67657453656C6563746564456C656D656E7428297B76617220653B72657475726E206E756C6C213D3D28653D746869732E7769646765742E67657453656C656374696F6E28295B305D';
wwv_flow_imp.g_varchar2_table(22333) := '292626766F69642030213D3D653F653A766F696420307D7D66756E6374696F6E2077472865297B6C657420743D21313B72657475726E206E3D3E7B6966286E2E746F4B6579436F646543686F726428292E69734D6F6469666965724B6579282929726574';
wwv_flow_imp.g_varchar2_table(22334) := '75726E21313B696628742972657475726E20743D21312C21313B636F6E737420693D652E736F66744469737061746368286E2C6E2E746172676574293B72657475726E20313D3D3D692E6B696E643F28743D21302C2131293A28743D21312C303D3D3D69';
wwv_flow_imp.g_varchar2_table(22335) := '2E6B696E64297D7D6C65742043473D636C61737320657874656E6473206E4B7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B636F6E73747B6F7074696F6E733A632C676574547970654E617669676174696F6E4D6F6465';
wwv_flow_imp.g_varchar2_table(22336) := '3A642C646973706F7361626C653A687D3D732E696E766F6B6546756E6374696F6E2854472C6F293B737570657228652C742C6E2C692C63292C746869732E646973706F7361626C65732E6164642868292C746869732E696E7465726E616C733D6E657720';
wwv_flow_imp.g_varchar2_table(22337) := '494728746869732C6F2C642C6F2E6F766572726964655374796C65732C722C612C6C292C746869732E646973706F7361626C65732E61646428746869732E696E7465726E616C73297D7570646174654F7074696F6E732865297B73757065722E75706461';
wwv_flow_imp.g_varchar2_table(22338) := '74654F7074696F6E732865292C746869732E696E7465726E616C732E7570646174654F7074696F6E732865297D7D3B43473D4C4B285B444B28352C7563292C444B28362C6364292C444B28372C544B292C444B28382C6670295D2C4347293B6C65742053';
wwv_flow_imp.g_varchar2_table(22339) := '473D636C61737320657874656E647320724B7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B636F6E73747B6F7074696F6E733A632C676574547970654E617669676174696F6E4D6F64653A642C646973706F7361626C65';
wwv_flow_imp.g_varchar2_table(22340) := '3A687D3D732E696E766F6B6546756E6374696F6E2854472C6F293B737570657228652C742C6E2C692C63292C746869732E646973706F7361626C65732E6164642868292C746869732E696E7465726E616C733D6E657720494728746869732C6F2C642C6F';
wwv_flow_imp.g_varchar2_table(22341) := '2E6F766572726964655374796C65732C722C612C6C292C746869732E646973706F7361626C65732E61646428746869732E696E7465726E616C73297D7570646174654F7074696F6E7328653D7B7D297B73757065722E7570646174654F7074696F6E7328';
wwv_flow_imp.g_varchar2_table(22342) := '65292C652E6F766572726964655374796C65732626746869732E696E7465726E616C732E7570646174655374796C654F766572726964657328652E6F766572726964655374796C6573292C746869732E696E7465726E616C732E7570646174654F707469';
wwv_flow_imp.g_varchar2_table(22343) := '6F6E732865297D7D3B53473D4C4B285B444B28352C7563292C444B28362C6364292C444B28372C544B292C444B28382C6670295D2C5347293B6C65742078473D636C61737320657874656E647320434B7B636F6E7374727563746F7228652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(22344) := '2C6F2C732C722C612C6C2C63297B636F6E73747B6F7074696F6E733A642C676574547970654E617669676174696F6E4D6F64653A682C646973706F7361626C653A757D3D722E696E766F6B6546756E6374696F6E2854472C73293B737570657228652C74';
wwv_flow_imp.g_varchar2_table(22345) := '2C6E2C692C6F2C64292C746869732E646973706F7361626C65732E6164642875292C746869732E696E7465726E616C733D6E657720494728746869732C732C682C732E6F766572726964655374796C65732C612C6C2C63292C746869732E646973706F73';
wwv_flow_imp.g_varchar2_table(22346) := '61626C65732E61646428746869732E696E7465726E616C73297D7570646174654F7074696F6E7328653D7B7D297B73757065722E7570646174654F7074696F6E732865292C766F69642030213D3D652E6F766572726964655374796C6573262674686973';
wwv_flow_imp.g_varchar2_table(22347) := '2E696E7465726E616C732E7570646174655374796C654F766572726964657328652E6F766572726964655374796C6573292C746869732E696E7465726E616C732E7570646174654F7074696F6E732865297D7D3B78473D4C4B285B444B28362C7563292C';
wwv_flow_imp.g_varchar2_table(22348) := '444B28372C6364292C444B28382C544B292C444B28392C6670295D2C7847293B6C6574206B473D636C61737320657874656E647320624B7B676574206F6E4469644F70656E28297B72657475726E20746869732E696E7465726E616C732E6F6E4469644F';
wwv_flow_imp.g_varchar2_table(22349) := '70656E7D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C63297B636F6E73747B6F7074696F6E733A642C676574547970654E617669676174696F6E4D6F64653A682C646973706F7361626C653A757D3D722E696E766F6B6546';
wwv_flow_imp.g_varchar2_table(22350) := '756E6374696F6E2854472C73293B737570657228652C742C6E2C692C6F2C64292C746869732E646973706F7361626C65732E6164642875292C746869732E696E7465726E616C733D6E657720494728746869732C732C682C732E6F766572726964655374';
wwv_flow_imp.g_varchar2_table(22351) := '796C65732C612C6C2C63292C746869732E646973706F7361626C65732E61646428746869732E696E7465726E616C73297D7570646174654F7074696F6E7328653D7B7D297B73757065722E7570646174654F7074696F6E732865292C652E6F7665727269';
wwv_flow_imp.g_varchar2_table(22352) := '64655374796C65732626746869732E696E7465726E616C732E7570646174655374796C654F766572726964657328652E6F766572726964655374796C6573292C746869732E696E7465726E616C732E7570646174654F7074696F6E732865297D7D3B6B47';
wwv_flow_imp.g_varchar2_table(22353) := '3D4C4B285B444B28362C7563292C444B28372C6364292C444B28382C544B292C444B28392C6670295D2C6B47293B6C65742045473D636C61737320657874656E647320774B7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C';
wwv_flow_imp.g_varchar2_table(22354) := '632C64297B636F6E73747B6F7074696F6E733A682C676574547970654E617669676174696F6E4D6F64653A752C646973706F7361626C653A707D3D612E696E766F6B6546756E6374696F6E2854472C72293B737570657228652C742C6E2C692C6F2C732C';
wwv_flow_imp.g_varchar2_table(22355) := '68292C746869732E646973706F7361626C65732E6164642870292C746869732E696E7465726E616C733D6E657720494728746869732C722C752C722E6F766572726964655374796C65732C6C2C632C64292C746869732E646973706F7361626C65732E61';
wwv_flow_imp.g_varchar2_table(22356) := '646428746869732E696E7465726E616C73297D7570646174654F7074696F6E732865297B73757065722E7570646174654F7074696F6E732865292C746869732E696E7465726E616C732E7570646174654F7074696F6E732865297D7D3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(22357) := '6E204C472865297B636F6E737420743D652E67657456616C756528584B293B69662822686967686C69676874223D3D3D742972657475726E205F552E486967686C696768743B6966282266696C746572223D3D3D742972657475726E205F552E46696C74';
wwv_flow_imp.g_varchar2_table(22358) := '65723B636F6E7374206E3D652E67657456616C7565286547293B72657475726E2273696D706C65223D3D3D6E7C7C22686967686C69676874223D3D3D6E3F5F552E486967686C696768743A2266696C746572223D3D3D6E3F5F552E46696C7465723A766F';
wwv_flow_imp.g_varchar2_table(22359) := '696420307D66756E6374696F6E2044472865297B636F6E737420743D652E67657456616C7565286E47293B72657475726E2266757A7A79223D3D3D743F79552E46757A7A793A22636F6E746967756F7573223D3D3D743F79552E436F6E746967756F7573';
wwv_flow_imp.g_varchar2_table(22360) := '3A766F696420307D66756E6374696F6E20544728652C74297B766172206E3B636F6E737420693D652E676574286670292C6F3D652E676574286A45292C733D652E676574286364292C723D652E676574287563292C613D766F69642030213D3D742E686F';
wwv_flow_imp.g_varchar2_table(22361) := '72697A6F6E74616C5363726F6C6C696E673F742E686F72697A6F6E74616C5363726F6C6C696E673A426F6F6C65616E28692E67657456616C7565285A4B29292C5B6C2C635D3D722E696E766F6B6546756E6374696F6E2870472C74292C643D742E706164';
wwv_flow_imp.g_varchar2_table(22362) := '64696E67426F74746F6D2C683D766F69642030213D3D742E72656E646572496E64656E744775696465733F742E72656E646572496E64656E744775696465733A692E67657456616C7565286F47293B72657475726E7B676574547970654E617669676174';
wwv_flow_imp.g_varchar2_table(22363) := '696F6E4D6F64653A28293D3E7B636F6E737420653D732E676574436F6E746578744B657956616C756528244B293B696628226175746F6D61746963223D3D3D652972657475726E2076492E4175746F6D617469633B6966282274726967676572223D3D3D';
wwv_flow_imp.g_varchar2_table(22364) := '652972657475726E2076492E547269676765723B69662821313D3D3D732E676574436F6E746578744B657956616C756528554B292972657475726E2076492E547269676765723B636F6E737420743D692E67657456616C7565284A4B293B72657475726E';
wwv_flow_imp.g_varchar2_table(22365) := '226175746F6D61746963223D3D3D743F76492E4175746F6D617469633A2274726967676572223D3D3D743F76492E547269676765723A766F696420307D2C646973706F7361626C653A632C6F7074696F6E733A7B6B6579626F617264537570706F72743A';
wwv_flow_imp.g_varchar2_table(22366) := '21312C2E2E2E6C2C696E64656E743A226E756D626572223D3D747970656F6620692E67657456616C7565286947293F692E67657456616C7565286947293A766F696420302C72656E646572496E64656E744775696465733A682C736D6F6F74685363726F';
wwv_flow_imp.g_varchar2_table(22367) := '6C6C696E673A426F6F6C65616E28692E67657456616C756528734729292C64656661756C7446696E644D6F64653A4C472869292C64656661756C7446696E644D61746368547970653A44472869292C686F72697A6F6E74616C5363726F6C6C696E673A61';
wwv_flow_imp.g_varchar2_table(22368) := '2C7363726F6C6C4279506167653A426F6F6C65616E28692E67657456616C756528744729292C70616464696E67426F74746F6D3A642C6869646554776973746965734F664368696C646C657373456C656D656E74733A742E686964655477697374696573';
wwv_flow_imp.g_varchar2_table(22369) := '4F664368696C646C657373456C656D656E74732C657870616E644F6E6C794F6E54776973746965436C69636B3A6E756C6C213D3D286E3D742E657870616E644F6E6C794F6E54776973746965436C69636B292626766F69642030213D3D6E3F6E3A22646F';
wwv_flow_imp.g_varchar2_table(22370) := '75626C65436C69636B223D3D3D692E67657456616C7565286C47292C636F6E746578745669657750726F76696465723A6F2C66696E645769646765745374796C65733A4C4D2C656E61626C65537469636B795363726F6C6C3A426F6F6C65616E28692E67';
wwv_flow_imp.g_varchar2_table(22371) := '657456616C756528634729292C737469636B795363726F6C6C4D61784974656D436F756E743A4E756D62657228692E67657456616C756528644729297D7D7D45473D4C4B285B444B28372C7563292C444B28382C6364292C444B28392C544B292C444B28';
wwv_flow_imp.g_varchar2_table(22372) := '31302C6670295D2C4547293B6C65742049473D636C6173737B676574206F6E4469644F70656E28297B72657475726E20746869732E6E6176696761746F722E6F6E4469644F70656E7D636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B';
wwv_flow_imp.g_varchar2_table(22373) := '76617220613B746869732E747265653D652C746869732E646973706F7361626C65733D5B5D2C746869732E636F6E746578744B6579536572766963653D4B4B286F2C65292C746869732E646973706F7361626C65732E7075736828474B28746869732E63';
wwv_flow_imp.g_varchar2_table(22374) := '6F6E746578744B6579536572766963652C6529292C746869732E6C697374537570706F7274734D756C746953656C6563743D4E4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C697374537570706F7274';
wwv_flow_imp.g_varchar2_table(22375) := '734D756C746953656C6563742E736574282131213D3D742E6D756C7469706C6553656C656374696F6E537570706F7274292C424B2E62696E64546F28746869732E636F6E746578744B657953657276696365292E73657428426F6F6C65616E28742E7365';
wwv_flow_imp.g_varchar2_table(22376) := '6C656374696F6E4E617669676174696F6E29292C746869732E6C697374537570706F727446696E645769646765743D564B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6C697374537570706F727446696E';
wwv_flow_imp.g_varchar2_table(22377) := '645769646765742E736574286E756C6C3D3D3D28613D742E66696E64576964676574456E61626C6564297C7C766F696420303D3D3D617C7C61292C746869732E68617353656C656374696F6E4F72466F6375733D4F4B2E62696E64546F28746869732E63';
wwv_flow_imp.g_varchar2_table(22378) := '6F6E746578744B657953657276696365292C746869732E686173446F75626C6553656C656374696F6E3D524B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E6861734D756C746953656C656374696F6E3D46';
wwv_flow_imp.g_varchar2_table(22379) := '4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E74726565456C656D656E7443616E436F6C6C617073653D7A4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E';
wwv_flow_imp.g_varchar2_table(22380) := '74726565456C656D656E74486173506172656E743D484B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E74726565456C656D656E7443616E457870616E643D574B2E62696E64546F28746869732E636F6E74';
wwv_flow_imp.g_varchar2_table(22381) := '6578744B657953657276696365292C746869732E74726565456C656D656E744861734368696C643D6A4B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E7472656546696E644F70656E3D714B2E62696E6454';
wwv_flow_imp.g_varchar2_table(22382) := '6F28746869732E636F6E746578744B657953657276696365292C746869732E74726565537469636B795363726F6C6C466F63757365643D414B2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E5F757365416C';
wwv_flow_imp.g_varchar2_table(22383) := '7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D68472872292C746869732E7570646174655374796C654F76657272696465732869293B636F6E7374206C3D28293D3E7B636F6E737420743D652E676574466F63757328295B305D';
wwv_flow_imp.g_varchar2_table(22384) := '3B69662821742972657475726E3B636F6E7374206E3D652E6765744E6F64652874293B746869732E74726565456C656D656E7443616E436F6C6C617073652E736574286E2E636F6C6C61707369626C652626216E2E636F6C6C6170736564292C74686973';
wwv_flow_imp.g_varchar2_table(22385) := '2E74726565456C656D656E74486173506172656E742E736574282121652E676574506172656E74456C656D656E74287429292C746869732E74726565456C656D656E7443616E457870616E642E736574286E2E636F6C6C61707369626C6526266E2E636F';
wwv_flow_imp.g_varchar2_table(22386) := '6C6C6170736564292C746869732E74726565456C656D656E744861734368696C642E736574282121652E6765744669727374456C656D656E744368696C64287429297D2C633D6E6577205365743B632E61646428244B292C632E61646428554B292C7468';
wwv_flow_imp.g_varchar2_table(22387) := '69732E646973706F7361626C65732E7075736828746869732E636F6E746578744B6579536572766963652C732E72656769737465722865292C652E6F6E4469644368616E676553656C656374696F6E282828293D3E7B636F6E737420743D652E67657453';
wwv_flow_imp.g_varchar2_table(22388) := '656C656374696F6E28292C6E3D652E676574466F63757328293B746869732E636F6E746578744B6579536572766963652E6275666665724368616E67654576656E7473282828293D3E7B746869732E68617353656C656374696F6E4F72466F6375732E73';
wwv_flow_imp.g_varchar2_table(22389) := '657428742E6C656E6774683E307C7C6E2E6C656E6774683E30292C746869732E6861734D756C746953656C656374696F6E2E73657428742E6C656E6774683E31292C746869732E686173446F75626C6553656C656374696F6E2E73657428323D3D3D742E';
wwv_flow_imp.g_varchar2_table(22390) := '6C656E677468297D29297D29292C652E6F6E4469644368616E6765466F637573282828293D3E7B636F6E737420743D652E67657453656C656374696F6E28292C6E3D652E676574466F63757328293B746869732E68617353656C656374696F6E4F72466F';
wwv_flow_imp.g_varchar2_table(22391) := '6375732E73657428742E6C656E6774683E307C7C6E2E6C656E6774683E30292C6C28297D29292C652E6F6E4469644368616E6765436F6C6C617073655374617465286C292C652E6F6E4469644368616E67654D6F64656C286C292C652E6F6E4469644368';
wwv_flow_imp.g_varchar2_table(22392) := '616E676546696E644F70656E53746174652828653D3E746869732E7472656546696E644F70656E2E73657428652929292C652E6F6E4469644368616E6765537469636B795363726F6C6C466F63757365642828653D3E746869732E74726565537469636B';
wwv_flow_imp.g_varchar2_table(22393) := '795363726F6C6C466F63757365642E73657428652929292C722E6F6E4469644368616E6765436F6E66696775726174696F6E2828693D3E7B6C6574206F3D7B7D3B696628692E61666665637473436F6E66696775726174696F6E28514B29262628746869';
wwv_flow_imp.g_varchar2_table(22394) := '732E5F757365416C7441734D756C7469706C6553656C656374696F6E4D6F6469666965723D6847287229292C692E61666665637473436F6E66696775726174696F6E28694729297B636F6E737420653D722E67657456616C7565286947293B6F3D7B2E2E';
wwv_flow_imp.g_varchar2_table(22395) := '2E6F2C696E64656E743A657D7D696628692E61666665637473436F6E66696775726174696F6E286F47292626766F696420303D3D3D742E72656E646572496E64656E74477569646573297B636F6E737420653D722E67657456616C7565286F47293B6F3D';
wwv_flow_imp.g_varchar2_table(22396) := '7B2E2E2E6F2C72656E646572496E64656E744775696465733A657D7D696628692E61666665637473436F6E66696775726174696F6E28734729297B636F6E737420653D426F6F6C65616E28722E67657456616C756528734729293B6F3D7B2E2E2E6F2C73';
wwv_flow_imp.g_varchar2_table(22397) := '6D6F6F74685363726F6C6C696E673A657D7D696628692E61666665637473436F6E66696775726174696F6E28584B297C7C692E61666665637473436F6E66696775726174696F6E28654729297B636F6E737420653D4C472872293B6F3D7B2E2E2E6F2C64';
wwv_flow_imp.g_varchar2_table(22398) := '656661756C7446696E644D6F64653A657D7D696628692E61666665637473436F6E66696775726174696F6E284A4B297C7C692E61666665637473436F6E66696775726174696F6E28654729297B636F6E737420653D6E28293B6F3D7B2E2E2E6F2C747970';
wwv_flow_imp.g_varchar2_table(22399) := '654E617669676174696F6E4D6F64653A657D7D696628692E61666665637473436F6E66696775726174696F6E286E4729297B636F6E737420653D44472872293B6F3D7B2E2E2E6F2C64656661756C7446696E644D61746368547970653A657D7D69662869';
wwv_flow_imp.g_varchar2_table(22400) := '2E61666665637473436F6E66696775726174696F6E285A4B292626766F696420303D3D3D742E686F72697A6F6E74616C5363726F6C6C696E67297B636F6E737420653D426F6F6C65616E28722E67657456616C7565285A4B29293B6F3D7B2E2E2E6F2C68';
wwv_flow_imp.g_varchar2_table(22401) := '6F72697A6F6E74616C5363726F6C6C696E673A657D7D696628692E61666665637473436F6E66696775726174696F6E28744729297B636F6E737420653D426F6F6C65616E28722E67657456616C756528744729293B6F3D7B2E2E2E6F2C7363726F6C6C42';
wwv_flow_imp.g_varchar2_table(22402) := '79506167653A657D7D696628692E61666665637473436F6E66696775726174696F6E286C47292626766F696420303D3D3D742E657870616E644F6E6C794F6E54776973746965436C69636B2626286F3D7B2E2E2E6F2C657870616E644F6E6C794F6E5477';
wwv_flow_imp.g_varchar2_table(22403) := '6973746965436C69636B3A22646F75626C65436C69636B223D3D3D722E67657456616C7565286C47297D292C692E61666665637473436F6E66696775726174696F6E28634729297B636F6E737420653D722E67657456616C7565286347293B6F3D7B2E2E';
wwv_flow_imp.g_varchar2_table(22404) := '2E6F2C656E61626C65537469636B795363726F6C6C3A657D7D696628692E61666665637473436F6E66696775726174696F6E28644729297B636F6E737420653D4D6174682E6D617828312C722E67657456616C756528644729293B6F3D7B2E2E2E6F2C73';
wwv_flow_imp.g_varchar2_table(22405) := '7469636B795363726F6C6C4D61784974656D436F756E743A657D7D696628692E61666665637473436F6E66696775726174696F6E28724729297B636F6E737420653D722E67657456616C7565287247293B6F3D7B2E2E2E6F2C6D6F757365576865656C53';
wwv_flow_imp.g_varchar2_table(22406) := '63726F6C6C53656E73697469766974793A657D7D696628692E61666665637473436F6E66696775726174696F6E28614729297B636F6E737420653D722E67657456616C7565286147293B6F3D7B2E2E2E6F2C666173745363726F6C6C53656E7369746976';
wwv_flow_imp.g_varchar2_table(22407) := '6974793A657D7D4F626A6563742E6B657973286F292E6C656E6774683E302626652E7570646174654F7074696F6E73286F297D29292C746869732E636F6E746578744B6579536572766963652E6F6E4469644368616E6765436F6E746578742828743D3E';
wwv_flow_imp.g_varchar2_table(22408) := '7B742E61666665637473536F6D652863292626652E7570646174654F7074696F6E73287B747970654E617669676174696F6E4D6F64653A6E28297D297D2929292C746869732E6E6176696761746F723D6E657720794728652C7B636F6E66696775726174';
wwv_flow_imp.g_varchar2_table(22409) := '696F6E536572766963653A722C2E2E2E747D292C746869732E646973706F7361626C65732E7075736828746869732E6E6176696761746F72297D7570646174654F7074696F6E732865297B766F69642030213D3D652E6D756C7469706C6553656C656374';
wwv_flow_imp.g_varchar2_table(22410) := '696F6E537570706F72742626746869732E6C697374537570706F7274734D756C746953656C6563742E736574282121652E6D756C7469706C6553656C656374696F6E537570706F7274297D7570646174655374796C654F76657272696465732865297B74';
wwv_flow_imp.g_varchar2_table(22411) := '6869732E747265652E7374796C6528653F494D2865293A544D297D646973706F736528297B746869732E646973706F7361626C65733D6F7428746869732E646973706F7361626C6573297D7D3B49473D4C4B285B444B28342C6364292C444B28352C544B';
wwv_flow_imp.g_varchar2_table(22412) := '292C444B28362C6670295D2C4947292C79642E6173285470292E7265676973746572436F6E66696775726174696F6E287B69643A22776F726B62656E6368222C6F726465723A372C7469746C653A6228302C22576F726B62656E636822292C747970653A';
wwv_flow_imp.g_varchar2_table(22413) := '226F626A656374222C70726F706572746965733A7B5B514B5D3A7B747970653A22737472696E67222C656E756D3A5B226374726C436D64222C22616C74225D2C6D61726B646F776E456E756D4465736372697074696F6E733A5B6228302C224D61707320';
wwv_flow_imp.g_varchar2_table(22414) := '746F2060436F6E74726F6C60206F6E2057696E646F777320616E64204C696E757820616E6420746F2060436F6D6D616E6460206F6E206D61634F532E22292C6228302C224D61707320746F2060416C7460206F6E2057696E646F777320616E64204C696E';
wwv_flow_imp.g_varchar2_table(22415) := '757820616E6420746F20604F7074696F6E60206F6E206D61634F532E22295D2C64656661756C743A226374726C436D64222C6465736372697074696F6E3A6228302C22546865206D6F64696669657220746F206265207573656420746F2061646420616E';
wwv_flow_imp.g_varchar2_table(22416) := '206974656D20696E20747265657320616E64206C6973747320746F2061206D756C74692D73656C656374696F6E207769746820746865206D6F7573652028666F72206578616D706C6520696E20746865206578706C6F7265722C206F70656E2065646974';
wwv_flow_imp.g_varchar2_table(22417) := '6F727320616E642073636D2076696577292E2054686520274F70656E20746F205369646527206D6F757365206765737475726573202D20696620737570706F72746564202D2077696C6C20616461707420737563682074686174207468657920646F206E';
wwv_flow_imp.g_varchar2_table(22418) := '6F7420636F6E666C696374207769746820746865206D756C746973656C656374206D6F6469666965722E22297D2C5B594B5D3A7B747970653A22737472696E67222C656E756D3A5B2273696E676C65436C69636B222C22646F75626C65436C69636B225D';
wwv_flow_imp.g_varchar2_table(22419) := '2C64656661756C743A2273696E676C65436C69636B222C6465736372697074696F6E3A6228302C22436F6E74726F6C7320686F7720746F206F70656E206974656D7320696E20747265657320616E64206C69737473207573696E6720746865206D6F7573';
wwv_flow_imp.g_varchar2_table(22420) := '652028696620737570706F72746564292E204E6F7465207468617420736F6D6520747265657320616E64206C69737473206D696768742063686F6F736520746F2069676E6F726520746869732073657474696E67206966206974206973206E6F74206170';
wwv_flow_imp.g_varchar2_table(22421) := '706C696361626C652E22297D2C5B5A4B5D3A7B747970653A22626F6F6C65616E222C64656661756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206C6973747320616E6420747265657320737570706F';
wwv_flow_imp.g_varchar2_table(22422) := '727420686F72697A6F6E74616C207363726F6C6C696E6720696E2074686520776F726B62656E63682E205761726E696E673A207475726E696E67206F6E20746869732073657474696E6720686173206120706572666F726D616E636520696D706C696361';
wwv_flow_imp.g_varchar2_table(22423) := '74696F6E2E22297D2C5B74475D3A7B747970653A22626F6F6C65616E222C64656661756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C73207768657468657220636C69636B7320696E20746865207363726F6C6C6261722073';
wwv_flow_imp.g_varchar2_table(22424) := '63726F6C6C207061676520627920706167652E22297D2C5B69475D3A7B747970653A226E756D626572222C64656661756C743A382C6D696E696D756D3A342C6D6178696D756D3A34302C6465736372697074696F6E3A6228302C22436F6E74726F6C7320';
wwv_flow_imp.g_varchar2_table(22425) := '7472656520696E64656E746174696F6E20696E20706978656C732E22297D2C5B6F475D3A7B747970653A22737472696E67222C656E756D3A5B226E6F6E65222C226F6E486F766572222C22616C77617973225D2C64656661756C743A226F6E486F766572';
wwv_flow_imp.g_varchar2_table(22426) := '222C6465736372697074696F6E3A6228302C22436F6E74726F6C7320776865746865722074686520747265652073686F756C642072656E64657220696E64656E74206775696465732E22297D2C5B73475D3A7B747970653A22626F6F6C65616E222C6465';
wwv_flow_imp.g_varchar2_table(22427) := '6661756C743A21312C6465736372697074696F6E3A6228302C22436F6E74726F6C732077686574686572206C6973747320616E64207472656573206861766520736D6F6F7468207363726F6C6C696E672E22297D2C5B72475D3A7B747970653A226E756D';
wwv_flow_imp.g_varchar2_table(22428) := '626572222C64656661756C743A312C6D61726B646F776E4465736372697074696F6E3A6228302C2241206D756C7469706C69657220746F2062652075736564206F6E20746865206064656C7461586020616E64206064656C74615960206F66206D6F7573';
wwv_flow_imp.g_varchar2_table(22429) := '6520776865656C207363726F6C6C206576656E74732E22297D2C5B61475D3A7B747970653A226E756D626572222C64656661756C743A352C6D61726B646F776E4465736372697074696F6E3A6228302C225363726F6C6C696E67207370656564206D756C';
wwv_flow_imp.g_varchar2_table(22430) := '7469706C696572207768656E207072657373696E672060416C74602E22297D2C5B584B5D3A7B747970653A22737472696E67222C656E756D3A5B22686967686C69676874222C2266696C746572225D2C656E756D4465736372697074696F6E733A5B6228';
wwv_flow_imp.g_varchar2_table(22431) := '302C22486967686C6967687420656C656D656E7473207768656E20736561726368696E672E204675727468657220757020616E6420646F776E206E617669676174696F6E2077696C6C207472617665727365206F6E6C792074686520686967686C696768';
wwv_flow_imp.g_varchar2_table(22432) := '74656420656C656D656E74732E22292C6228302C2246696C74657220656C656D656E7473207768656E20736561726368696E672E22295D2C64656661756C743A22686967686C69676874222C6465736372697074696F6E3A6228302C22436F6E74726F6C';
wwv_flow_imp.g_varchar2_table(22433) := '73207468652064656661756C742066696E64206D6F646520666F72206C6973747320616E6420747265657320696E2074686520776F726B62656E63682E22297D2C5B65475D3A7B747970653A22737472696E67222C656E756D3A5B2273696D706C65222C';
wwv_flow_imp.g_varchar2_table(22434) := '22686967686C69676874222C2266696C746572225D2C656E756D4465736372697074696F6E733A5B6228302C2253696D706C65206B6579626F617264206E617669676174696F6E20666F637573657320656C656D656E7473207768696368206D61746368';
wwv_flow_imp.g_varchar2_table(22435) := '20746865206B6579626F61726420696E7075742E204D61746368696E6720697320646F6E65206F6E6C79206F6E2070726566697865732E22292C6228302C22486967686C69676874206B6579626F617264206E617669676174696F6E20686967686C6967';
wwv_flow_imp.g_varchar2_table(22436) := '68747320656C656D656E7473207768696368206D6174636820746865206B6579626F61726420696E7075742E204675727468657220757020616E6420646F776E206E617669676174696F6E2077696C6C207472617665727365206F6E6C79207468652068';
wwv_flow_imp.g_varchar2_table(22437) := '6967686C69676874656420656C656D656E74732E22292C6228302C2246696C746572206B6579626F617264206E617669676174696F6E2077696C6C2066696C746572206F757420616E64206869646520616C6C2074686520656C656D656E747320776869';
wwv_flow_imp.g_varchar2_table(22438) := '636820646F206E6F74206D6174636820746865206B6579626F61726420696E7075742E22295D2C64656661756C743A22686967686C69676874222C6465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206B6579626F617264206E61';
wwv_flow_imp.g_varchar2_table(22439) := '7669676174696F6E207374796C6520666F72206C6973747320616E6420747265657320696E2074686520776F726B62656E63682E2043616E2062652073696D706C652C20686967686C6967687420616E642066696C7465722E22292C6465707265636174';
wwv_flow_imp.g_varchar2_table(22440) := '65643A21302C6465707265636174696F6E4D6573736167653A6228302C22506C65617365207573652027776F726B62656E63682E6C6973742E64656661756C7446696E644D6F64652720616E645C7427776F726B62656E63682E6C6973742E747970654E';
wwv_flow_imp.g_varchar2_table(22441) := '617669676174696F6E4D6F64652720696E73746561642E22297D2C5B6E475D3A7B747970653A22737472696E67222C656E756D3A5B2266757A7A79222C22636F6E746967756F7573225D2C656E756D4465736372697074696F6E733A5B6228302C225573';
wwv_flow_imp.g_varchar2_table(22442) := '652066757A7A79206D61746368696E67207768656E20736561726368696E672E22292C6228302C2255736520636F6E746967756F7573206D61746368696E67207768656E20736561726368696E672E22295D2C64656661756C743A2266757A7A79222C64';
wwv_flow_imp.g_varchar2_table(22443) := '65736372697074696F6E3A6228302C22436F6E74726F6C73207468652074797065206F66206D61746368696E672075736564207768656E20736561726368696E67206C6973747320616E6420747265657320696E2074686520776F726B62656E63682E22';
wwv_flow_imp.g_varchar2_table(22444) := '297D2C5B6C475D3A7B747970653A22737472696E67222C656E756D3A5B2273696E676C65436C69636B222C22646F75626C65436C69636B225D2C64656661756C743A2273696E676C65436C69636B222C6465736372697074696F6E3A6228302C22436F6E';
wwv_flow_imp.g_varchar2_table(22445) := '74726F6C7320686F77207472656520666F6C646572732061726520657870616E646564207768656E20636C69636B696E672074686520666F6C646572206E616D65732E204E6F7465207468617420736F6D6520747265657320616E64206C69737473206D';
wwv_flow_imp.g_varchar2_table(22446) := '696768742063686F6F736520746F2069676E6F726520746869732073657474696E67206966206974206973206E6F74206170706C696361626C652E22297D2C5B63475D3A7B747970653A22626F6F6C65616E222C64656661756C743A21302C6465736372';
wwv_flow_imp.g_varchar2_table(22447) := '697074696F6E3A6228302C22436F6E74726F6C73207768657468657220737469636B79207363726F6C6C696E6720697320656E61626C656420696E2074726565732E22297D2C5B64475D3A7B747970653A226E756D626572222C6D696E696D756D3A312C';
wwv_flow_imp.g_varchar2_table(22448) := '64656661756C743A372C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320746865206E756D626572206F6620737469636B7920656C656D656E747320646973706C6179656420696E207468652074726565207768656E';
wwv_flow_imp.g_varchar2_table(22449) := '206023776F726B62656E63682E747265652E656E61626C65537469636B795363726F6C6C236020697320656E61626C65642E22297D2C5B4A4B5D3A7B747970653A22737472696E67222C656E756D3A5B226175746F6D61746963222C2274726967676572';
wwv_flow_imp.g_varchar2_table(22450) := '225D2C64656661756C743A226175746F6D61746963222C6D61726B646F776E4465736372697074696F6E3A6228302C22436F6E74726F6C7320686F772074797065206E617669676174696F6E20776F726B7320696E206C6973747320616E642074726565';
wwv_flow_imp.g_varchar2_table(22451) := '7320696E2074686520776F726B62656E63682E205768656E2073657420746F206074726967676572602C2074797065206E617669676174696F6E20626567696E73206F6E63652074686520606C6973742E74726967676572547970654E61766967617469';
wwv_flow_imp.g_varchar2_table(22452) := '6F6E6020636F6D6D616E642069732072756E2E22297D7D7D293B636C617373204D477B636F6E7374727563746F7228652C742C6E2C69297B746869732E697350726F766964657246697273743D652C746869732E706172656E743D742C746869732E6C69';
wwv_flow_imp.g_varchar2_table(22453) := '6E6B3D6E2C746869732E5F72616E676543616C6C6261636B3D692C746869732E69643D456B2E6E657874496428297D6765742075726928297B72657475726E20746869732E6C696E6B2E7572697D6765742072616E676528297B76617220652C743B7265';
wwv_flow_imp.g_varchar2_table(22454) := '7475726E206E756C6C213D3D28743D6E756C6C213D3D28653D746869732E5F72616E6765292626766F69642030213D3D653F653A746869732E6C696E6B2E74617267657453656C656374696F6E52616E6765292626766F69642030213D3D743F743A7468';
wwv_flow_imp.g_varchar2_table(22455) := '69732E6C696E6B2E72616E67657D7365742072616E67652865297B746869732E5F72616E67653D652C746869732E5F72616E676543616C6C6261636B2874686973297D67657420617269614D65737361676528297B76617220653B636F6E737420743D6E';
wwv_flow_imp.g_varchar2_table(22456) := '756C6C3D3D3D28653D746869732E706172656E742E67657450726576696577287468697329297C7C766F696420303D3D3D653F766F696420303A652E7072657669657728746869732E72616E6765293B72657475726E20743F6228302C227B307D20696E';
wwv_flow_imp.g_varchar2_table(22457) := '207B317D206F6E206C696E65207B327D20617420636F6C756D6E207B337D222C742E76616C75652C476C28746869732E757269292C746869732E72616E67652E73746172744C696E654E756D6265722C746869732E72616E67652E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(22458) := '6D6E293A6228302C22696E207B307D206F6E206C696E65207B317D20617420636F6C756D6E207B327D222C476C28746869732E757269292C746869732E72616E67652E73746172744C696E654E756D6265722C746869732E72616E67652E737461727443';
wwv_flow_imp.g_varchar2_table(22459) := '6F6C756D6E297D7D636C6173732041477B636F6E7374727563746F722865297B746869732E5F6D6F64656C5265666572656E63653D657D646973706F736528297B746869732E5F6D6F64656C5265666572656E63652E646973706F736528297D70726576';
wwv_flow_imp.g_varchar2_table(22460) := '69657728652C743D38297B636F6E7374206E3D746869732E5F6D6F64656C5265666572656E63652E6F626A6563742E74657874456469746F724D6F64656C3B696628216E2972657475726E3B636F6E73747B73746172744C696E654E756D6265723A692C';
wwv_flow_imp.g_varchar2_table(22461) := '7374617274436F6C756D6E3A6F2C656E644C696E654E756D6265723A732C656E64436F6C756D6E3A727D3D652C613D6E2E676574576F7264556E74696C506F736974696F6E287B6C696E654E756D6265723A692C636F6C756D6E3A6F2D747D292C6C3D6E';
wwv_flow_imp.g_varchar2_table(22462) := '657720726828692C612E7374617274436F6C756D6E2C692C6F292C633D6E657720726828732C722C732C31303733373431383234292C643D6E2E67657456616C7565496E52616E6765286C292E7265706C616365282F5E5C732B2F2C2222292C683D6E2E';
wwv_flow_imp.g_varchar2_table(22463) := '67657456616C7565496E52616E67652865293B72657475726E7B76616C75653A642B682B6E2E67657456616C7565496E52616E67652863292E7265706C616365282F5C732B242F2C2222292C686967686C696768743A7B73746172743A642E6C656E6774';
wwv_flow_imp.g_varchar2_table(22464) := '682C656E643A642E6C656E6774682B682E6C656E6774687D7D7D7D636C617373204E477B636F6E7374727563746F7228652C74297B746869732E706172656E743D652C746869732E7572693D742C746869732E6368696C6472656E3D5B5D2C746869732E';
wwv_flow_imp.g_varchar2_table(22465) := '5F70726576696577733D6E6577206F617D646973706F736528297B6F7428746869732E5F70726576696577732E76616C7565732829292C746869732E5F70726576696577732E636C65617228297D676574507265766965772865297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(22466) := '6869732E5F70726576696577732E67657428652E757269297D67657420617269614D65737361676528297B636F6E737420653D746869732E6368696C6472656E2E6C656E6774683B72657475726E20313D3D3D653F6228302C22312073796D626F6C2069';
wwv_flow_imp.g_varchar2_table(22467) := '6E207B307D2C2066756C6C2070617468207B317D222C476C28746869732E757269292C746869732E7572692E667350617468293A6228302C227B307D2073796D626F6C7320696E207B317D2C2066756C6C2070617468207B327D222C652C476C28746869';
wwv_flow_imp.g_varchar2_table(22468) := '732E757269292C746869732E7572692E667350617468297D6173796E63207265736F6C76652865297B69662830213D3D746869732E5F70726576696577732E73697A652972657475726E20746869733B666F7228636F6E73742074206F6620746869732E';
wwv_flow_imp.g_varchar2_table(22469) := '6368696C6472656E2969662821746869732E5F70726576696577732E68617328742E75726929297472797B636F6E7374206E3D617761697420652E6372656174654D6F64656C5265666572656E636528742E757269293B746869732E5F70726576696577';
wwv_flow_imp.g_varchar2_table(22470) := '732E73657428742E7572692C6E6577204147286E29297D63617463682865297B6B652865297D72657475726E20746869737D7D636C6173732050477B636F6E7374727563746F7228652C74297B746869732E67726F7570733D5B5D2C746869732E726566';
wwv_flow_imp.g_varchar2_table(22471) := '6572656E6365733D5B5D2C746869732E5F6F6E4469644368616E67655265666572656E636552616E67653D6E65772043742C746869732E6F6E4469644368616E67655265666572656E636552616E67653D746869732E5F6F6E4469644368616E67655265';
wwv_flow_imp.g_varchar2_table(22472) := '666572656E636552616E67652E6576656E742C746869732E5F6C696E6B733D652C746869732E5F7469746C653D743B636F6E73745B6E5D3D653B6C657420693B652E736F72742850472E5F636F6D706172655265666572656E636573293B666F7228636F';
wwv_flow_imp.g_varchar2_table(22473) := '6E73742074206F66206529696628692626246C2E6973457175616C28692E7572692C742E7572692C2130297C7C28693D6E6577204E4728746869732C742E757269292C746869732E67726F7570732E70757368286929292C303D3D3D692E6368696C6472';
wwv_flow_imp.g_varchar2_table(22474) := '656E2E6C656E6774687C7C30213D3D50472E5F636F6D706172655265666572656E63657328742C692E6368696C6472656E5B692E6368696C6472656E2E6C656E6774682D315D29297B636F6E737420653D6E6577204D47286E3D3D3D742C692C742C2865';
wwv_flow_imp.g_varchar2_table(22475) := '3D3E746869732E5F6F6E4469644368616E67655265666572656E636552616E67652E6669726528652929293B746869732E7265666572656E6365732E707573682865292C692E6368696C6472656E2E707573682865297D7D646973706F736528297B6F74';
wwv_flow_imp.g_varchar2_table(22476) := '28746869732E67726F757073292C746869732E5F6F6E4469644368616E67655265666572656E636552616E67652E646973706F736528292C746869732E67726F7570732E6C656E6774683D307D636C6F6E6528297B72657475726E206E65772050472874';
wwv_flow_imp.g_varchar2_table(22477) := '6869732E5F6C696E6B732C746869732E5F7469746C65297D676574207469746C6528297B72657475726E20746869732E5F7469746C657D676574206973456D70747928297B72657475726E20303D3D3D746869732E67726F7570732E6C656E6774687D67';
wwv_flow_imp.g_varchar2_table(22478) := '657420617269614D65737361676528297B72657475726E20746869732E6973456D7074793F6228302C224E6F20726573756C747320666F756E6422293A313D3D3D746869732E7265666572656E6365732E6C656E6774683F6228302C22466F756E642031';
wwv_flow_imp.g_varchar2_table(22479) := '2073796D626F6C20696E207B307D222C746869732E7265666572656E6365735B305D2E7572692E667350617468293A313D3D3D746869732E67726F7570732E6C656E6774683F6228302C22466F756E64207B307D2073796D626F6C7320696E207B317D22';
wwv_flow_imp.g_varchar2_table(22480) := '2C746869732E7265666572656E6365732E6C656E6774682C746869732E67726F7570735B305D2E7572692E667350617468293A6228302C22466F756E64207B307D2073796D626F6C7320696E207B317D2066696C6573222C746869732E7265666572656E';
wwv_flow_imp.g_varchar2_table(22481) := '6365732E6C656E6774682C746869732E67726F7570732E6C656E677468297D6E6578744F7250726576696F75735265666572656E636528652C74297B636F6E73747B706172656E743A6E7D3D653B6C657420693D6E2E6368696C6472656E2E696E646578';
wwv_flow_imp.g_varchar2_table(22482) := '4F662865293B636F6E7374206F3D6E2E6368696C6472656E2E6C656E6774682C733D6E2E706172656E742E67726F7570732E6C656E6774683B72657475726E20313D3D3D737C7C742626692B313C6F7C7C21742626693E303F28693D743F28692B312925';
wwv_flow_imp.g_varchar2_table(22483) := '6F3A28692B6F2D3129256F2C6E2E6368696C6472656E5B695D293A28693D6E2E706172656E742E67726F7570732E696E6465784F66286E292C743F28693D28692B312925732C6E2E706172656E742E67726F7570735B695D2E6368696C6472656E5B305D';
wwv_flow_imp.g_varchar2_table(22484) := '293A28693D28692B732D312925732C6E2E706172656E742E67726F7570735B695D2E6368696C6472656E5B6E2E706172656E742E67726F7570735B695D2E6368696C6472656E2E6C656E6774682D315D29297D6E6561726573745265666572656E636528';
wwv_flow_imp.g_varchar2_table(22485) := '652C74297B636F6E7374206E3D746869732E7265666572656E6365732E6D61702828286E2C69293D3E287B6964783A692C7072656669784C656E3A4C69286E2E7572692E746F537472696E6728292C652E746F537472696E672829292C6F666673657444';
wwv_flow_imp.g_varchar2_table(22486) := '6973743A3130302A4D6174682E616273286E2E72616E67652E73746172744C696E654E756D6265722D742E6C696E654E756D626572292B4D6174682E616273286E2E72616E67652E7374617274436F6C756D6E2D742E636F6C756D6E297D2929292E736F';
wwv_flow_imp.g_varchar2_table(22487) := '7274282828652C74293D3E652E7072656669784C656E3E742E7072656669784C656E3F2D313A652E7072656669784C656E3C742E7072656669784C656E3F313A652E6F6666736574446973743C742E6F6666736574446973743F2D313A652E6F66667365';
wwv_flow_imp.g_varchar2_table(22488) := '74446973743E742E6F6666736574446973743F313A3029295B305D3B6966286E2972657475726E20746869732E7265666572656E6365735B6E2E6964785D7D7265666572656E6365417428652C74297B666F7228636F6E7374206E206F6620746869732E';
wwv_flow_imp.g_varchar2_table(22489) := '7265666572656E636573296966286E2E7572692E746F537472696E6728293D3D3D652E746F537472696E672829262672682E636F6E7461696E73506F736974696F6E286E2E72616E67652C74292972657475726E206E7D66697273745265666572656E63';
wwv_flow_imp.g_varchar2_table(22490) := '6528297B666F7228636F6E73742065206F6620746869732E7265666572656E63657329696628652E697350726F766964657246697273742972657475726E20653B72657475726E20746869732E7265666572656E6365735B305D7D737461746963205F63';
wwv_flow_imp.g_varchar2_table(22491) := '6F6D706172655265666572656E63657328652C74297B72657475726E20246C2E636F6D7061726528652E7572692C742E757269297C7C72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E6765297D7D';
wwv_flow_imp.g_varchar2_table(22492) := '766172204F473D6E2836333738292C52473D7B7D3B52472E7374796C655461675472616E73666F726D3D6A7228292C52472E736574417474726962757465733D567228292C52472E696E736572743D467228292E62696E64286E756C6C2C226865616422';
wwv_flow_imp.g_varchar2_table(22493) := '292C52472E646F6D4150493D4F7228292C52472E696E736572745374796C65456C656D656E743D487228292C4E722829284F472E412C5247292C4F472E4126264F472E412E6C6F63616C7326264F472E412E6C6F63616C733B7661722046473D6E283136';
wwv_flow_imp.g_varchar2_table(22494) := '3834292C42473D7B7D3B42472E7374796C655461675472616E73666F726D3D6A7228292C42472E736574417474726962757465733D567228292C42472E696E736572743D467228292E62696E64286E756C6C2C226865616422292C42472E646F6D415049';
wwv_flow_imp.g_varchar2_table(22495) := '3D4F7228292C42472E696E736572745374796C65456C656D656E743D487228292C4E7228292846472E412C4247292C46472E41262646472E412E6C6F63616C73262646472E412E6C6F63616C733B636C6173732056477B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(22496) := '2C742C6E297B746869732E6F7074696F6E733D742C746869732E7374796C65733D6E2C746869732E636F756E743D302C746869732E656C656D656E743D757228652C627228222E6D6F6E61636F2D636F756E742D62616467652229292C746869732E636F';
wwv_flow_imp.g_varchar2_table(22497) := '756E74466F726D61743D746869732E6F7074696F6E732E636F756E74466F726D61747C7C227B307D222C746869732E7469746C65466F726D61743D746869732E6F7074696F6E732E7469746C65466F726D61747C7C22222C746869732E736574436F756E';
wwv_flow_imp.g_varchar2_table(22498) := '7428746869732E6F7074696F6E732E636F756E747C7C30297D736574436F756E742865297B746869732E636F756E743D652C746869732E72656E64657228297D7365745469746C65466F726D61742865297B746869732E7469746C65466F726D61743D65';
wwv_flow_imp.g_varchar2_table(22499) := '2C746869732E72656E64657228297D72656E64657228297B76617220652C743B746869732E656C656D656E742E74657874436F6E74656E743D616928746869732E636F756E74466F726D61742C746869732E636F756E74292C746869732E656C656D656E';
wwv_flow_imp.g_varchar2_table(22500) := '742E7469746C653D616928746869732E7469746C65466F726D61742C746869732E636F756E74292C746869732E656C656D656E742E7374796C652E6261636B67726F756E64436F6C6F723D6E756C6C213D3D28653D746869732E7374796C65732E626164';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(22501) := '67654261636B67726F756E64292626766F69642030213D3D653F653A22222C746869732E656C656D656E742E7374796C652E636F6C6F723D6E756C6C213D3D28743D746869732E7374796C65732E6261646765466F726567726F756E64292626766F6964';
wwv_flow_imp.g_varchar2_table(22502) := '2030213D3D743F743A22222C746869732E7374796C65732E6261646765426F72646572262628746869732E656C656D656E742E7374796C652E626F726465723D6031707820736F6C696420247B746869732E7374796C65732E6261646765426F72646572';
wwv_flow_imp.g_varchar2_table(22503) := '7D60297D7D636C617373207A4720657874656E6473206C747B636F6E7374727563746F7228652C74297B766172206E3B737570657228292C746869732E6F7074696F6E733D742C746869732E746578743D22222C746869732E7469746C653D22222C7468';
wwv_flow_imp.g_varchar2_table(22504) := '69732E686967686C69676874733D5B5D2C746869732E6469644576657252656E6465723D21312C746869732E737570706F727449636F6E733D6E756C6C213D3D286E3D6E756C6C3D3D743F766F696420303A742E737570706F727449636F6E7329262676';
wwv_flow_imp.g_varchar2_table(22505) := '6F69642030213D3D6E26266E2C746869732E646F6D4E6F64653D757228652C627228227370616E2E6D6F6E61636F2D686967686C6967687465642D6C6162656C2229297D67657420656C656D656E7428297B72657475726E20746869732E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(22506) := '657D73657428652C743D5B5D2C6E3D22222C69297B657C7C28653D2222292C69262628653D7A472E6573636170654E65774C696E657328652C7429292C746869732E6469644576657252656E6465722626746869732E746578743D3D3D65262674686973';
wwv_flow_imp.g_varchar2_table(22507) := '2E7469746C653D3D3D6E2626776828746869732E686967686C69676874732C74297C7C28746869732E746578743D652C746869732E7469746C653D6E2C746869732E686967686C69676874733D742C746869732E72656E6465722829297D72656E646572';
wwv_flow_imp.g_varchar2_table(22508) := '28297B76617220652C742C6E2C693B636F6E7374206F3D5B5D3B6C657420733D303B666F7228636F6E73742065206F6620746869732E686967686C6967687473297B696628652E656E643D3D3D652E737461727429636F6E74696E75653B696628733C65';
wwv_flow_imp.g_varchar2_table(22509) := '2E7374617274297B636F6E737420743D746869732E746578742E737562737472696E6728732C652E7374617274293B746869732E737570706F727449636F6E733F6F2E70757368282E2E2E536B287429293A6F2E707573682874292C733D652E73746172';
wwv_flow_imp.g_varchar2_table(22510) := '747D636F6E737420743D746869732E746578742E737562737472696E6728732C652E656E64292C6E3D627228227370616E2E686967686C69676874222C766F696420302C2E2E2E746869732E737570706F727449636F6E733F536B2874293A5B745D293B';
wwv_flow_imp.g_varchar2_table(22511) := '652E6578747261436C617373657326266E2E636C6173734C6973742E616464282E2E2E652E6578747261436C6173736573292C6F2E70757368286E292C733D652E656E647D696628733C746869732E746578742E6C656E677468297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(22512) := '746869732E746578742E737562737472696E672873293B746869732E737570706F727449636F6E733F6F2E70757368282E2E2E536B286529293A6F2E707573682865297D696628677228746869732E646F6D4E6F64652C2E2E2E6F292C6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(22513) := '28743D6E756C6C3D3D3D28653D746869732E6F7074696F6E73297C7C766F696420303D3D3D653F766F696420303A652E686F76657244656C6567617465297C7C766F696420303D3D3D743F766F696420303A742E73686F774E6174697665486F76657229';
wwv_flow_imp.g_varchar2_table(22514) := '746869732E646F6D4E6F64652E7469746C653D746869732E7469746C653B656C736520696628746869732E637573746F6D486F7665727C7C22223D3D3D746869732E7469746C6529746869732E637573746F6D486F7665722626746869732E637573746F';
wwv_flow_imp.g_varchar2_table(22515) := '6D486F7665722E75706461746528746869732E7469746C65293B656C73657B636F6E737420653D6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E6F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E686F76657244';
wwv_flow_imp.g_varchar2_table(22516) := '656C6567617465292626766F69642030213D3D693F693A504528226D6F75736522293B746869732E637573746F6D486F7665723D746869732E5F726567697374657228564528292E7365747570557064617461626C65486F76657228652C746869732E64';
wwv_flow_imp.g_varchar2_table(22517) := '6F6D4E6F64652C746869732E7469746C6529297D746869732E6469644576657252656E6465723D21307D737461746963206573636170654E65774C696E657328652C74297B6C6574206E3D302C693D303B72657475726E20652E7265706C616365282F5C';
wwv_flow_imp.g_varchar2_table(22518) := '725C6E7C5C727C5C6E2F672C2828652C6F293D3E7B693D225C725C6E223D3D3D653F2D313A302C6F2B3D6E3B666F7228636F6E73742065206F66207429652E656E643C3D6F7C7C28652E73746172743E3D6F262628652E73746172742B3D69292C652E65';
wwv_flow_imp.g_varchar2_table(22519) := '6E643E3D6F262628652E656E642B3D6929293B72657475726E206E2B3D692C22E28F8E227D29297D7D7661722048473D6E2838313334292C57473D7B7D3B57472E7374796C655461675472616E73666F726D3D6A7228292C57472E736574417474726962';
wwv_flow_imp.g_varchar2_table(22520) := '757465733D567228292C57472E696E736572743D467228292E62696E64286E756C6C2C226865616422292C57472E646F6D4150493D4F7228292C57472E696E736572745374796C65456C656D656E743D487228292C4E7228292848472E412C5747292C48';
wwv_flow_imp.g_varchar2_table(22521) := '472E41262648472E412E6C6F63616C73262648472E412E6C6F63616C733B636C617373206A477B636F6E7374727563746F722865297B746869732E5F656C656D656E743D657D67657420656C656D656E7428297B72657475726E20746869732E5F656C65';
wwv_flow_imp.g_varchar2_table(22522) := '6D656E747D7365742074657874436F6E74656E742865297B746869732E646973706F7365647C7C653D3D3D746869732E5F74657874436F6E74656E747C7C28746869732E5F74657874436F6E74656E743D652C746869732E5F656C656D656E742E746578';
wwv_flow_imp.g_varchar2_table(22523) := '74436F6E74656E743D65297D73657420636C6173734E616D652865297B746869732E646973706F7365647C7C653D3D3D746869732E5F636C6173734E616D657C7C28746869732E5F636C6173734E616D653D652C746869732E5F656C656D656E742E636C';
wwv_flow_imp.g_varchar2_table(22524) := '6173734E616D653D65297D73657420656D7074792865297B746869732E646973706F7365647C7C653D3D3D746869732E5F656D7074797C7C28746869732E5F656D7074793D652C746869732E5F656C656D656E742E7374796C652E6D617267696E4C6566';
wwv_flow_imp.g_varchar2_table(22525) := '743D653F2230223A2222297D646973706F736528297B746869732E646973706F7365643D21307D7D636C61737320714720657874656E6473206C747B636F6E7374727563746F7228652C74297B766172206E3B737570657228292C746869732E63757374';
wwv_flow_imp.g_varchar2_table(22526) := '6F6D486F766572733D6E6577204D61702C746869732E6372656174696F6E4F7074696F6E733D742C746869732E646F6D4E6F64653D746869732E5F7265676973746572286E6577206A4728757228652C627228222E6D6F6E61636F2D69636F6E2D6C6162';
wwv_flow_imp.g_varchar2_table(22527) := '656C22292929292C746869732E6C6162656C436F6E7461696E65723D757228746869732E646F6D4E6F64652E656C656D656E742C627228222E6D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E65722229292C746869732E6E616D65436F6E';
wwv_flow_imp.g_varchar2_table(22528) := '7461696E65723D757228746869732E6C6162656C436F6E7461696E65722C627228227370616E2E6D6F6E61636F2D69636F6E2D6E616D652D636F6E7461696E65722229292C286E756C6C3D3D743F766F696420303A742E737570706F7274486967686C69';
wwv_flow_imp.g_varchar2_table(22529) := '67687473297C7C286E756C6C3D3D743F766F696420303A742E737570706F727449636F6E73293F746869732E6E616D654E6F64653D746869732E5F7265676973746572286E657720554728746869732E6E616D65436F6E7461696E65722C2121742E7375';
wwv_flow_imp.g_varchar2_table(22530) := '70706F727449636F6E7329293A746869732E6E616D654E6F64653D6E657720244728746869732E6E616D65436F6E7461696E6572292C746869732E686F76657244656C65676174653D6E756C6C213D3D286E3D6E756C6C3D3D743F766F696420303A742E';
wwv_flow_imp.g_varchar2_table(22531) := '686F76657244656C6567617465292626766F69642030213D3D6E3F6E3A504528226D6F75736522297D67657420656C656D656E7428297B72657475726E20746869732E646F6D4E6F64652E656C656D656E747D7365744C6162656C28652C742C6E297B76';
wwv_flow_imp.g_varchar2_table(22532) := '617220693B636F6E7374206F3D5B226D6F6E61636F2D69636F6E2D6C6162656C225D2C733D5B226D6F6E61636F2D69636F6E2D6C6162656C2D636F6E7461696E6572225D3B6C657420723D22223B6966286E2626286E2E6578747261436C617373657326';
wwv_flow_imp.g_varchar2_table(22533) := '266F2E70757368282E2E2E6E2E6578747261436C6173736573292C6E2E6974616C696326266F2E7075736828226974616C696322292C6E2E737472696B657468726F75676826266F2E707573682822737472696B657468726F75676822292C6E2E646973';
wwv_flow_imp.g_varchar2_table(22534) := '61626C6564436F6D6D616E642626732E70757368282264697361626C656422292C6E2E7469746C6526262822737472696E67223D3D747970656F66206E2E7469746C653F722B3D6E2E7469746C653A722B3D6529292C746869732E646F6D4E6F64652E63';
wwv_flow_imp.g_varchar2_table(22535) := '6C6173734E616D653D6F2E6A6F696E28222022292C746869732E646F6D4E6F64652E656C656D656E742E7365744174747269627574652822617269612D6C6162656C222C72292C746869732E6C6162656C436F6E7461696E65722E636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(22536) := '3D732E6A6F696E28222022292C746869732E7365747570486F76657228286E756C6C3D3D6E3F766F696420303A6E2E6465736372697074696F6E5469746C65293F746869732E6C6162656C436F6E7461696E65723A746869732E656C656D656E742C6E75';
wwv_flow_imp.g_varchar2_table(22537) := '6C6C3D3D6E3F766F696420303A6E2E7469746C65292C746869732E6E616D654E6F64652E7365744C6162656C28652C6E292C747C7C746869732E6465736372697074696F6E4E6F6465297B636F6E737420653D746869732E6765744F7243726561746544';
wwv_flow_imp.g_varchar2_table(22538) := '65736372697074696F6E4E6F646528293B6520696E7374616E63656F66207A473F28652E73657428747C7C22222C6E3F6E2E6465736372697074696F6E4D6174636865733A766F696420302C766F696420302C6E756C6C3D3D6E3F766F696420303A6E2E';
wwv_flow_imp.g_varchar2_table(22539) := '6C6162656C4573636170654E65774C696E6573292C746869732E7365747570486F76657228652E656C656D656E742C6E756C6C3D3D6E3F766F696420303A6E2E6465736372697074696F6E5469746C6529293A28652E74657874436F6E74656E743D7426';
wwv_flow_imp.g_varchar2_table(22540) := '26286E756C6C3D3D6E3F766F696420303A6E2E6C6162656C4573636170654E65774C696E6573293F7A472E6573636170654E65774C696E657328742C5B5D293A747C7C22222C746869732E7365747570486F76657228652E656C656D656E742C286E756C';
wwv_flow_imp.g_varchar2_table(22541) := '6C3D3D6E3F766F696420303A6E2E6465736372697074696F6E5469746C65297C7C2222292C652E656D7074793D2174297D28286E756C6C3D3D6E3F766F696420303A6E2E737566666978297C7C746869732E7375666669784E6F64652926262874686973';
wwv_flow_imp.g_varchar2_table(22542) := '2E6765744F724372656174655375666669784E6F646528292E74657874436F6E74656E743D6E756C6C213D3D28693D6E756C6C3D3D6E3F766F696420303A6E2E737566666978292626766F69642030213D3D693F693A2222297D7365747570486F766572';
wwv_flow_imp.g_varchar2_table(22543) := '28652C74297B636F6E7374206E3D746869732E637573746F6D486F766572732E6765742865293B6966286E2626286E2E646973706F736528292C746869732E637573746F6D486F766572732E64656C657465286529292C7429696628746869732E686F76';
wwv_flow_imp.g_varchar2_table(22544) := '657244656C65676174652E73686F774E6174697665486F766572297B66756E6374696F6E206928652C74297B686C2874293F652E7469746C653D506C2874293A286E756C6C3D3D743F766F696420303A742E6D61726B646F776E4E6F74537570706F7274';
wwv_flow_imp.g_varchar2_table(22545) := '656446616C6C6261636B293F652E7469746C653D742E6D61726B646F776E4E6F74537570706F7274656446616C6C6261636B3A652E72656D6F766541747472696275746528227469746C6522297D6928652C74297D656C73657B636F6E7374206F3D5645';
wwv_flow_imp.g_varchar2_table(22546) := '28292E7365747570557064617461626C65486F76657228746869732E686F76657244656C65676174652C652C74293B6F2626746869732E637573746F6D486F766572732E73657428652C6F297D656C736520652E72656D6F766541747472696275746528';
wwv_flow_imp.g_varchar2_table(22547) := '227469746C6522297D646973706F736528297B73757065722E646973706F736528293B666F7228636F6E73742065206F6620746869732E637573746F6D486F766572732E76616C756573282929652E646973706F736528293B746869732E637573746F6D';
wwv_flow_imp.g_varchar2_table(22548) := '486F766572732E636C65617228297D6765744F724372656174655375666669784E6F646528297B69662821746869732E7375666669784E6F6465297B636F6E7374206E3D746869732E5F7265676973746572286E6577206A472828653D746869732E6E61';
wwv_flow_imp.g_varchar2_table(22549) := '6D65436F6E7461696E65722C743D627228227370616E2E6D6F6E61636F2D69636F6E2D7375666669782D636F6E7461696E657222292C652E61667465722874292C742929293B746869732E7375666669784E6F64653D746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(22550) := '286E6577206A47287572286E2E656C656D656E742C627228227370616E2E6C6162656C2D73756666697822292929297D76617220652C743B72657475726E20746869732E7375666669784E6F64657D6765744F724372656174654465736372697074696F';
wwv_flow_imp.g_varchar2_table(22551) := '6E4E6F646528297B76617220653B69662821746869732E6465736372697074696F6E4E6F6465297B636F6E737420743D746869732E5F7265676973746572286E6577206A4728757228746869732E6C6162656C436F6E7461696E65722C62722822737061';
wwv_flow_imp.g_varchar2_table(22552) := '6E2E6D6F6E61636F2D69636F6E2D6465736372697074696F6E2D636F6E7461696E657222292929293B286E756C6C3D3D3D28653D746869732E6372656174696F6E4F7074696F6E73297C7C766F696420303D3D3D653F766F696420303A652E737570706F';
wwv_flow_imp.g_varchar2_table(22553) := '72744465736372697074696F6E486967686C6967687473293F746869732E6465736372697074696F6E4E6F64653D746869732E5F7265676973746572286E6577207A4728757228742E656C656D656E742C627228227370616E2E6C6162656C2D64657363';
wwv_flow_imp.g_varchar2_table(22554) := '72697074696F6E2229292C7B737570706F727449636F6E733A2121746869732E6372656174696F6E4F7074696F6E732E737570706F727449636F6E737D29293A746869732E6465736372697074696F6E4E6F64653D746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(22555) := '6E6577206A4728757228742E656C656D656E742C627228227370616E2E6C6162656C2D6465736372697074696F6E22292929297D72657475726E20746869732E6465736372697074696F6E4E6F64657D7D636C6173732024477B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(22556) := '722865297B746869732E636F6E7461696E65723D652C746869732E6C6162656C3D766F696420302C746869732E73696E676C654C6162656C3D766F696420307D7365744C6162656C28652C74297B696628746869732E6C6162656C213D3D657C7C217768';
wwv_flow_imp.g_varchar2_table(22557) := '28746869732E6F7074696F6E732C742929696628746869732E6C6162656C3D652C746869732E6F7074696F6E733D742C22737472696E67223D3D747970656F66206529746869732E73696E676C654C6162656C7C7C28746869732E636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(22558) := '2E696E6E6572546578743D22222C746869732E636F6E7461696E65722E636C6173734C6973742E72656D6F766528226D756C7469706C6522292C746869732E73696E676C654C6162656C3D757228746869732E636F6E7461696E65722C62722822612E6C';
wwv_flow_imp.g_varchar2_table(22559) := '6162656C2D6E616D65222C7B69643A6E756C6C3D3D743F766F696420303A742E646F6D49647D2929292C746869732E73696E676C654C6162656C2E74657874436F6E74656E743D653B656C73657B746869732E636F6E7461696E65722E696E6E65725465';
wwv_flow_imp.g_varchar2_table(22560) := '78743D22222C746869732E636F6E7461696E65722E636C6173734C6973742E61646428226D756C7469706C6522292C746869732E73696E676C654C6162656C3D766F696420303B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B63';
wwv_flow_imp.g_varchar2_table(22561) := '6F6E737420693D655B6E5D2C6F3D286E756C6C3D3D743F766F696420303A742E646F6D496429262660247B6E756C6C3D3D743F766F696420303A742E646F6D49647D5F247B6E7D603B757228746869732E636F6E7461696E65722C62722822612E6C6162';
wwv_flow_imp.g_varchar2_table(22562) := '656C2D6E616D65222C7B69643A6F2C22646174612D69636F6E2D6C6162656C2D636F756E74223A652E6C656E6774682C22646174612D69636F6E2D6C6162656C2D696E646578223A6E2C726F6C653A22747265656974656D227D2C6929292C6E3C652E6C';
wwv_flow_imp.g_varchar2_table(22563) := '656E6774682D312626757228746869732E636F6E7461696E65722C627228227370616E2E6C6162656C2D736570617261746F72222C766F696420302C286E756C6C3D3D743F766F696420303A742E736570617261746F72297C7C222F2229297D7D7D7D63';
wwv_flow_imp.g_varchar2_table(22564) := '6C61737320554720657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E636F6E7461696E65723D652C746869732E737570706F727449636F6E733D742C746869732E6C6162656C3D766F696420302C74';
wwv_flow_imp.g_varchar2_table(22565) := '6869732E73696E676C654C6162656C3D766F696420307D7365744C6162656C28652C74297B696628746869732E6C6162656C213D3D657C7C21776828746869732E6F7074696F6E732C742929696628746869732E6C6162656C3D652C746869732E6F7074';
wwv_flow_imp.g_varchar2_table(22566) := '696F6E733D742C22737472696E67223D3D747970656F66206529746869732E73696E676C654C6162656C7C7C28746869732E636F6E7461696E65722E696E6E6572546578743D22222C746869732E636F6E7461696E65722E636C6173734C6973742E7265';
wwv_flow_imp.g_varchar2_table(22567) := '6D6F766528226D756C7469706C6522292C746869732E73696E676C654C6162656C3D746869732E5F7265676973746572286E6577207A4728757228746869732E636F6E7461696E65722C62722822612E6C6162656C2D6E616D65222C7B69643A6E756C6C';
wwv_flow_imp.g_varchar2_table(22568) := '3D3D743F766F696420303A742E646F6D49647D29292C7B737570706F727449636F6E733A746869732E737570706F727449636F6E737D2929292C746869732E73696E676C654C6162656C2E73657428652C6E756C6C3D3D743F766F696420303A742E6D61';
wwv_flow_imp.g_varchar2_table(22569) := '74636865732C766F696420302C6E756C6C3D3D743F766F696420303A742E6C6162656C4573636170654E65774C696E6573293B656C73657B746869732E636F6E7461696E65722E696E6E6572546578743D22222C746869732E636F6E7461696E65722E63';
wwv_flow_imp.g_varchar2_table(22570) := '6C6173734C6973742E61646428226D756C7469706C6522292C746869732E73696E676C654C6162656C3D766F696420303B636F6E7374206E3D286E756C6C3D3D743F766F696420303A742E736570617261746F72297C7C222F222C693D66756E6374696F';
wwv_flow_imp.g_varchar2_table(22571) := '6E28652C742C6E297B696628216E2972657475726E3B6C657420693D303B72657475726E20652E6D61702828653D3E7B636F6E7374206F3D7B73746172743A692C656E643A692B652E6C656E6774687D2C733D6E2E6D61702828653D3E72542E696E7465';
wwv_flow_imp.g_varchar2_table(22572) := '7273656374286F2C652929292E66696C7465722828653D3E2172542E6973456D70747928652929292E6D61702828287B73746172743A652C656E643A747D293D3E287B73746172743A652D692C656E643A742D697D2929293B72657475726E20693D6F2E';
wwv_flow_imp.g_varchar2_table(22573) := '656E642B742E6C656E6774682C737D29297D28652C6E2C6E756C6C3D3D743F766F696420303A742E6D617463686573293B666F72286C6574206F3D303B6F3C652E6C656E6774683B6F2B2B297B636F6E737420733D655B6F5D2C723D693F695B6F5D3A76';
wwv_flow_imp.g_varchar2_table(22574) := '6F696420302C613D62722822612E6C6162656C2D6E616D65222C7B69643A286E756C6C3D3D743F766F696420303A742E646F6D496429262660247B6E756C6C3D3D743F766F696420303A742E646F6D49647D5F247B6F7D602C22646174612D69636F6E2D';
wwv_flow_imp.g_varchar2_table(22575) := '6C6162656C2D636F756E74223A652E6C656E6774682C22646174612D69636F6E2D6C6162656C2D696E646578223A6F2C726F6C653A22747265656974656D227D293B746869732E5F7265676973746572286E6577207A4728757228746869732E636F6E74';
wwv_flow_imp.g_varchar2_table(22576) := '61696E65722C61292C7B737570706F727449636F6E733A746869732E737570706F727449636F6E737D29292E73657428732C722C766F696420302C6E756C6C3D3D743F766F696420303A742E6C6162656C4573636170654E65774C696E6573292C6F3C65';
wwv_flow_imp.g_varchar2_table(22577) := '2E6C656E6774682D312626757228612C627228227370616E2E6C6162656C2D736570617261746F72222C766F696420302C6E29297D7D7D7D636F6E7374204B473D706328226C6162656C5365727669636522293B7661722047472C51473D66756E637469';
wwv_flow_imp.g_varchar2_table(22578) := '6F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F';
wwv_flow_imp.g_varchar2_table(22579) := '626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F7228766172';
wwv_flow_imp.g_varchar2_table(22580) := '20613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550';
wwv_flow_imp.g_varchar2_table(22581) := '726F706572747928742C6E2C72292C727D2C59473D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574205A473D636C6173737B636F6E7374727563746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(22582) := '5F7265736F6C766572536572766963653D657D6861734368696C6472656E2865297B72657475726E206520696E7374616E63656F662050477C7C6520696E7374616E63656F66204E477D6765744368696C6472656E2865297B6966286520696E7374616E';
wwv_flow_imp.g_varchar2_table(22583) := '63656F662050472972657475726E20652E67726F7570733B6966286520696E7374616E63656F66204E472972657475726E20652E7265736F6C766528746869732E5F7265736F6C76657253657276696365292E7468656E2828653D3E652E6368696C6472';
wwv_flow_imp.g_varchar2_table(22584) := '656E29293B7468726F77206E6577204572726F722822626164207472656522297D7D3B5A473D5147285B594728302C7663295D2C5A47293B636C6173732058477B67657448656967687428297B72657475726E2032337D67657454656D706C6174654964';
wwv_flow_imp.g_varchar2_table(22585) := '2865297B72657475726E206520696E7374616E63656F66204E473F6E512E69643A6F512E69647D7D6C6574204A473D636C6173737B636F6E7374727563746F722865297B746869732E5F6B657962696E64696E67536572766963653D657D6765744B6579';
wwv_flow_imp.g_varchar2_table(22586) := '626F6172644E617669676174696F6E4C6162656C2865297B76617220743B6966286520696E7374616E63656F66204D47297B636F6E7374206E3D6E756C6C3D3D3D28743D652E706172656E742E67657450726576696577286529297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(22587) := '3D3D743F766F696420303A742E7072657669657728652E72616E6765293B6966286E2972657475726E206E2E76616C75657D72657475726E20476C28652E757269297D7D3B4A473D5147285B594728302C2445295D2C4A47293B636C6173732065517B67';
wwv_flow_imp.g_varchar2_table(22588) := '657449642865297B72657475726E206520696E7374616E63656F66204D473F652E69643A652E7572697D7D6C65742074513D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6C61';
wwv_flow_imp.g_varchar2_table(22589) := '62656C536572766963653D743B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E74282264697622293B6E2E636C6173734C6973742E61646428227265666572656E63652D66696C6522292C746869732E66696C653D746869732E';
wwv_flow_imp.g_varchar2_table(22590) := '5F7265676973746572286E6577207147286E2C7B737570706F7274486967686C69676874733A21307D29292C746869732E62616467653D6E6577205647287572286E2C627228222E636F756E742229292C7B7D2C444D292C652E617070656E644368696C';
wwv_flow_imp.g_varchar2_table(22591) := '64286E297D73657428652C74297B636F6E7374206E3D596C28652E757269293B746869732E66696C652E7365744C6162656C28746869732E5F6C6162656C536572766963652E676574557269426173656E616D654C6162656C28652E757269292C746869';
wwv_flow_imp.g_varchar2_table(22592) := '732E5F6C6162656C536572766963652E6765745572694C6162656C286E2C7B72656C61746976653A21307D292C7B7469746C653A746869732E5F6C6162656C536572766963652E6765745572694C6162656C28652E757269292C6D6174636865733A747D';
wwv_flow_imp.g_varchar2_table(22593) := '293B636F6E737420693D652E6368696C6472656E2E6C656E6774683B746869732E62616467652E736574436F756E742869292C693E313F746869732E62616467652E7365745469746C65466F726D6174286228302C227B307D207265666572656E636573';
wwv_flow_imp.g_varchar2_table(22594) := '222C6929293A746869732E62616467652E7365745469746C65466F726D6174286228302C227B307D207265666572656E6365222C6929297D7D3B74513D5147285B594728312C4B47295D2C7451293B6C6574206E513D47473D636C6173737B636F6E7374';
wwv_flow_imp.g_varchar2_table(22595) := '727563746F722865297B746869732E5F696E7374616E74696174696F6E536572766963653D652C746869732E74656D706C61746549643D47472E69647D72656E64657254656D706C6174652865297B72657475726E20746869732E5F696E7374616E7469';
wwv_flow_imp.g_varchar2_table(22596) := '6174696F6E536572766963652E637265617465496E7374616E63652874512C65297D72656E646572456C656D656E7428652C742C6E297B6E2E73657428652E656C656D656E742C246128652E66696C7465724461746129297D646973706F736554656D70';
wwv_flow_imp.g_varchar2_table(22597) := '6C6174652865297B652E646973706F736528297D7D3B6E512E69643D2246696C655265666572656E63657352656E6465726572222C6E513D47473D5147285B594728302C7563295D2C6E51293B636C61737320695120657874656E6473206C747B636F6E';
wwv_flow_imp.g_varchar2_table(22598) := '7374727563746F722865297B737570657228292C746869732E6C6162656C3D746869732E5F7265676973746572286E6577207A47286529297D73657428652C74297B766172206E3B636F6E737420693D6E756C6C3D3D3D286E3D652E706172656E742E67';
wwv_flow_imp.g_varchar2_table(22599) := '657450726576696577286529297C7C766F696420303D3D3D6E3F766F696420303A6E2E7072657669657728652E72616E6765293B696628692626692E76616C7565297B636F6E73747B76616C75653A652C686967686C696768743A6E7D3D693B74262621';
wwv_flow_imp.g_varchar2_table(22600) := '736C2E697344656661756C742874293F28746869732E6C6162656C2E656C656D656E742E636C6173734C6973742E746F67676C6528227265666572656E63654D61746368222C2131292C746869732E6C6162656C2E73657428652C246128742929293A28';
wwv_flow_imp.g_varchar2_table(22601) := '746869732E6C6162656C2E656C656D656E742E636C6173734C6973742E746F67676C6528227265666572656E63654D61746368222C2130292C746869732E6C6162656C2E73657428652C5B6E5D29297D656C736520746869732E6C6162656C2E73657428';
wwv_flow_imp.g_varchar2_table(22602) := '60247B476C28652E757269297D3A247B652E72616E67652E73746172744C696E654E756D6265722B317D3A247B652E72616E67652E7374617274436F6C756D6E2B317D60297D7D636C617373206F517B636F6E7374727563746F7228297B746869732E74';
wwv_flow_imp.g_varchar2_table(22603) := '656D706C61746549643D6F512E69647D72656E64657254656D706C6174652865297B72657475726E206E65772069512865297D72656E646572456C656D656E7428652C742C6E297B6E2E73657428652E656C656D656E742C652E66696C74657244617461';
wwv_flow_imp.g_varchar2_table(22604) := '297D646973706F736554656D706C6174652865297B652E646973706F736528297D7D6F512E69643D224F6E655265666572656E636552656E6465726572223B636C6173732073517B676574576964676574417269614C6162656C28297B72657475726E20';
wwv_flow_imp.g_varchar2_table(22605) := '6228302C225265666572656E63657322297D676574417269614C6162656C2865297B72657475726E20652E617269614D6573736167657D7D7661722072513D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B7428';
wwv_flow_imp.g_varchar2_table(22606) := '6E2C692C65297D7D3B636C6173732061517B636F6E7374727563746F7228652C74297B746869732E5F656469746F723D652C746869732E5F6D6F64656C3D742C746869732E5F6465636F726174696F6E733D6E6577204D61702C746869732E5F6465636F';
wwv_flow_imp.g_varchar2_table(22607) := '726174696F6E49676E6F72655365743D6E6577205365742C746869732E5F63616C6C4F6E446973706F73653D6E65772061742C746869732E5F63616C6C4F6E4D6F64656C4368616E67653D6E65772061742C746869732E5F63616C6C4F6E446973706F73';
wwv_flow_imp.g_varchar2_table(22608) := '652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F6F6E4D6F64656C4368616E67656428292929292C746869732E5F6F6E4D6F64656C4368616E67656428297D646973706F736528297B';
wwv_flow_imp.g_varchar2_table(22609) := '746869732E5F63616C6C4F6E4D6F64656C4368616E67652E646973706F736528292C746869732E5F63616C6C4F6E446973706F73652E646973706F736528292C746869732E72656D6F76654465636F726174696F6E7328297D5F6F6E4D6F64656C436861';
wwv_flow_imp.g_varchar2_table(22610) := '6E67656428297B746869732E5F63616C6C4F6E4D6F64656C4368616E67652E636C65617228293B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B6966286529666F7228636F6E73742074206F6620746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(22611) := '656C2E7265666572656E63657329696628742E7572692E746F537472696E6728293D3D3D652E7572692E746F537472696E6728292972657475726E20766F696420746869732E5F6164644465636F726174696F6E7328742E706172656E74297D5F616464';
wwv_flow_imp.g_varchar2_table(22612) := '4465636F726174696F6E732865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B746869732E5F63616C6C4F6E4D6F64656C4368616E67652E61646428746869732E5F656469746F722E6765744D6F64656C28';
wwv_flow_imp.g_varchar2_table(22613) := '292E6F6E4469644368616E67654465636F726174696F6E73282828293D3E746869732E5F6F6E4465636F726174696F6E4368616E67656428292929293B636F6E737420743D5B5D2C6E3D5B5D3B666F72286C657420693D302C6F3D652E6368696C647265';
wwv_flow_imp.g_varchar2_table(22614) := '6E2E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D652E6368696C6472656E5B695D3B746869732E5F6465636F726174696F6E49676E6F72655365742E686173286F2E6964297C7C6F2E7572692E746F537472696E6728293D3D3D74686973';
wwv_flow_imp.g_varchar2_table(22615) := '2E5F656469746F722E6765744D6F64656C28292E7572692E746F537472696E672829262628742E70757368287B72616E67653A6F2E72616E67652C6F7074696F6E733A61512E4465636F726174696F6E4F7074696F6E737D292C6E2E7075736828692929';
wwv_flow_imp.g_varchar2_table(22616) := '7D746869732E5F656469746F722E6368616E67654465636F726174696F6E732828693D3E7B636F6E7374206F3D692E64656C74614465636F726174696F6E73285B5D2C74293B666F72286C657420743D303B743C6F2E6C656E6774683B742B2B29746869';
wwv_flow_imp.g_varchar2_table(22617) := '732E5F6465636F726174696F6E732E736574286F5B745D2C652E6368696C6472656E5B6E5B745D5D297D29297D5F6F6E4465636F726174696F6E4368616E67656428297B636F6E737420653D5B5D2C743D746869732E5F656469746F722E6765744D6F64';
wwv_flow_imp.g_varchar2_table(22618) := '656C28293B69662874297B666F7228636F6E73745B6E2C695D6F6620746869732E5F6465636F726174696F6E73297B636F6E7374206F3D742E6765744465636F726174696F6E52616E6765286E293B696628216F29636F6E74696E75653B6C657420733D';
wwv_flow_imp.g_varchar2_table(22619) := '21313B72682E657175616C7352616E6765286F2C692E72616E6765297C7C282872682E7370616E734D756C7469706C654C696E6573286F297C7C692E72616E67652E656E64436F6C756D6E2D692E72616E67652E7374617274436F6C756D6E213D6F2E65';
wwv_flow_imp.g_varchar2_table(22620) := '6E64436F6C756D6E2D6F2E7374617274436F6C756D6E29262628733D2130292C733F28746869732E5F6465636F726174696F6E49676E6F72655365742E61646428692E6964292C652E70757368286E29293A692E72616E67653D6F297D666F72286C6574';
wwv_flow_imp.g_varchar2_table(22621) := '20743D302C6E3D652E6C656E6774683B743C6E3B742B2B29746869732E5F6465636F726174696F6E732E64656C65746528655B745D293B746869732E5F656469746F722E72656D6F76654465636F726174696F6E732865297D7D72656D6F76654465636F';
wwv_flow_imp.g_varchar2_table(22622) := '726174696F6E7328297B746869732E5F656469746F722E72656D6F76654465636F726174696F6E73285B2E2E2E746869732E5F6465636F726174696F6E732E6B65797328295D292C746869732E5F6465636F726174696F6E732E636C65617228297D7D61';
wwv_flow_imp.g_varchar2_table(22623) := '512E4465636F726174696F6E4F7074696F6E733D4F432E7265676973746572287B6465736372697074696F6E3A227265666572656E63652D6465636F726174696F6E222C737469636B696E6573733A312C636C6173734E616D653A227265666572656E63';
wwv_flow_imp.g_varchar2_table(22624) := '652D6465636F726174696F6E227D293B636C617373206C517B636F6E7374727563746F7228297B746869732E726174696F3D2E372C746869732E686569676874496E4C696E65733D31387D7374617469632066726F6D4A534F4E2865297B6C657420742C';
wwv_flow_imp.g_varchar2_table(22625) := '6E3B7472797B636F6E737420693D4A534F4E2E70617273652865293B743D692E726174696F2C6E3D692E686569676874496E4C696E65737D63617463682865297B7D72657475726E7B726174696F3A747C7C2E372C686569676874496E4C696E65733A6E';
wwv_flow_imp.g_varchar2_table(22626) := '7C7C31387D7D7D636C61737320635120657874656E6473206B477B7D6C65742064513D636C61737320657874656E64732079247B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C68297B737570657228652C7B7368';
wwv_flow_imp.g_varchar2_table(22627) := '6F774672616D653A21312C73686F774172726F773A21302C6973526573697A6561626C653A21302C697341636365737369626C653A21302C737570706F72744F6E5469746C65436C69636B3A21307D2C73292C746869732E5F64656661756C7454726565';
wwv_flow_imp.g_varchar2_table(22628) := '4B6579626F617264537570706F72743D742C746869732E6C61796F7574446174613D6E2C746869732E5F746578744D6F64656C5265736F6C766572536572766963653D6F2C746869732E5F696E7374616E74696174696F6E536572766963653D732C7468';
wwv_flow_imp.g_varchar2_table(22629) := '69732E5F7065656B56696577536572766963653D722C746869732E5F7572694C6162656C3D612C746869732E5F756E646F5265646F536572766963653D6C2C746869732E5F6B657962696E64696E67536572766963653D632C746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(22630) := '616765536572766963653D642C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D682C746869732E5F646973706F73654F6E4E65774D6F64656C3D6E65772061742C746869732E5F63616C6C4F6E446973706F7365';
wwv_flow_imp.g_varchar2_table(22631) := '3D6E65772061742C746869732E5F6F6E44696453656C6563745265666572656E63653D6E65772043742C746869732E6F6E44696453656C6563745265666572656E63653D746869732E5F6F6E44696453656C6563745265666572656E63652E6576656E74';
wwv_flow_imp.g_varchar2_table(22632) := '2C746869732E5F64696D3D6E657720497328302C30292C746869732E5F6170706C795468656D6528692E676574436F6C6F725468656D652829292C746869732E5F63616C6C4F6E446973706F73652E61646428692E6F6E446964436F6C6F725468656D65';
wwv_flow_imp.g_varchar2_table(22633) := '4368616E676528746869732E5F6170706C795468656D652E62696E6428746869732929292C746869732E5F7065656B56696577536572766963652E6164644578636C757369766557696467657428652C74686973292C746869732E63726561746528297D';
wwv_flow_imp.g_varchar2_table(22634) := '646973706F736528297B746869732E7365744D6F64656C28766F69642030292C746869732E5F63616C6C4F6E446973706F73652E646973706F736528292C746869732E5F646973706F73654F6E4E65774D6F64656C2E646973706F736528292C6F742874';
wwv_flow_imp.g_varchar2_table(22635) := '6869732E5F70726576696577292C6F7428746869732E5F707265766965774E6F74417661696C61626C654D657373616765292C6F7428746869732E5F74726565292C6F7428746869732E5F707265766965774D6F64656C5265666572656E6365292C7468';
wwv_flow_imp.g_varchar2_table(22636) := '69732E5F73706C6974566965772E646973706F736528292C73757065722E646973706F736528297D5F6170706C795468656D652865297B636F6E737420743D652E676574436F6C6F72287824297C7C68752E7472616E73706172656E743B746869732E73';
wwv_flow_imp.g_varchar2_table(22637) := '74796C65287B6172726F77436F6C6F723A742C6672616D65436F6C6F723A742C6865616465724261636B67726F756E64436F6C6F723A652E676574436F6C6F72287724297C7C68752E7472616E73706172656E742C7072696D61727948656164696E6743';
wwv_flow_imp.g_varchar2_table(22638) := '6F6C6F723A652E676574436F6C6F72284324292C7365636F6E6461727948656164696E67436F6C6F723A652E676574436F6C6F72285324297D297D73686F772865297B73757065722E73686F7728652C746869732E6C61796F7574446174612E68656967';
wwv_flow_imp.g_varchar2_table(22639) := '6874496E4C696E65737C7C3138297D666F6375734F6E5265666572656E63655472656528297B746869732E5F747265652E646F6D466F63757328297D666F6375734F6E50726576696577456469746F7228297B746869732E5F707265766965772E666F63';
wwv_flow_imp.g_varchar2_table(22640) := '757328297D697350726576696577456469746F72466F637573656428297B72657475726E20746869732E5F707265766965772E68617354657874466F63757328297D5F6F6E5469746C65436C69636B2865297B746869732E5F7072657669657726267468';
wwv_flow_imp.g_varchar2_table(22641) := '69732E5F707265766965772E6765744D6F64656C28292626746869732E5F6F6E44696453656C6563745265666572656E63652E66697265287B656C656D656E743A746869732E5F676574466F63757365645265666572656E636528292C6B696E643A652E';
wwv_flow_imp.g_varchar2_table(22642) := '6374726C4B65797C7C652E6D6574614B65797C7C652E616C744B65793F2273696465223A226F70656E222C736F757263653A227469746C65227D297D5F66696C6C426F64792865297B746869732E736574437373436C61737328227265666572656E6365';
wwv_flow_imp.g_varchar2_table(22643) := '2D7A6F6E652D77696467657422292C746869732E5F6D657373616765436F6E7461696E65723D757228652C627228226469762E6D657373616765732229292C797228746869732E5F6D657373616765436F6E7461696E6572292C746869732E5F73706C69';
wwv_flow_imp.g_varchar2_table(22644) := '74566965773D6E657720422428652C7B6F7269656E746174696F6E3A317D292C746869732E5F70726576696577436F6E7461696E65723D757228652C627228226469762E707265766965772E696E6C696E652229292C746869732E5F707265766965773D';
wwv_flow_imp.g_varchar2_table(22645) := '746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652869242C746869732E5F70726576696577436F6E7461696E65722C7B7363726F6C6C4265796F6E644C6173744C696E653A21312C7363726F6C6C62';
wwv_flow_imp.g_varchar2_table(22646) := '61723A7B766572746963616C5363726F6C6C62617253697A653A31342C686F72697A6F6E74616C3A226175746F222C757365536861646F77733A21302C766572746963616C4861734172726F77733A21312C686F72697A6F6E74616C4861734172726F77';
wwv_flow_imp.g_varchar2_table(22647) := '733A21312C616C77617973436F6E73756D654D6F757365576865656C3A21307D2C6F7665727669657752756C65724C616E65733A322C66697865644F766572666C6F77576964676574733A21302C6D696E696D61703A7B656E61626C65643A21317D7D2C';
wwv_flow_imp.g_varchar2_table(22648) := '7B7D2C746869732E656469746F72292C797228746869732E5F70726576696577436F6E7461696E6572292C746869732E5F707265766965774E6F74417661696C61626C654D6573736167653D6E6577206B43286228302C226E6F20707265766965772061';
wwv_flow_imp.g_varchar2_table(22649) := '7661696C61626C6522292C55702C6B432E44454641554C545F4352454154494F4E5F4F5054494F4E532C6E756C6C2C746869732E5F756E646F5265646F536572766963652C746869732E5F6C616E6775616765536572766963652C746869732E5F6C616E';
wwv_flow_imp.g_varchar2_table(22650) := '6775616765436F6E66696775726174696F6E53657276696365292C746869732E5F74726565436F6E7461696E65723D757228652C627228226469762E7265662D747265652E696E6C696E652229293B636F6E737420743D7B6B6579626F61726453757070';
wwv_flow_imp.g_varchar2_table(22651) := '6F72743A746869732E5F64656661756C74547265654B6579626F617264537570706F72742C6163636573736962696C69747950726F76696465723A6E65772073512C6B6579626F6172644E617669676174696F6E4C6162656C50726F76696465723A7468';
wwv_flow_imp.g_varchar2_table(22652) := '69732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365284A47292C6964656E7469747950726F76696465723A6E65772065512C6F70656E4F6E53696E676C65436C69636B3A21302C73656C656374696F6E4E61';
wwv_flow_imp.g_varchar2_table(22653) := '7669676174696F6E3A21302C6F766572726964655374796C65733A7B6C6973744261636B67726F756E643A6B247D7D3B746869732E5F64656661756C74547265654B6579626F617264537570706F72742626746869732E5F63616C6C4F6E446973706F73';
wwv_flow_imp.g_varchar2_table(22654) := '652E61646428797328746869732E5F74726565436F6E7461696E65722C226B6579646F776E222C28653D3E7B652E657175616C73283929262628746869732E5F6B657962696E64696E67536572766963652E64697370617463684576656E7428652C652E';
wwv_flow_imp.g_varchar2_table(22655) := '746172676574292C652E73746F7050726F7061676174696F6E2829297D292C213029292C746869732E5F747265653D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652863512C225265666572656E';
wwv_flow_imp.g_varchar2_table(22656) := '636573576964676574222C746869732E5F74726565436F6E7461696E65722C6E65772058472C5B746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365286E51292C746869732E5F696E7374616E746961';
wwv_flow_imp.g_varchar2_table(22657) := '74696F6E536572766963652E637265617465496E7374616E6365286F51295D2C746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365285A47292C74292C746869732E5F73706C6974566965772E616464';
wwv_flow_imp.g_varchar2_table(22658) := '56696577287B6F6E4469644368616E67653A76742E4E6F6E652C656C656D656E743A746869732E5F70726576696577436F6E7461696E65722C6D696E696D756D53697A653A3230302C6D6178696D756D53697A653A4E756D6265722E4D41585F56414C55';
wwv_flow_imp.g_varchar2_table(22659) := '452C6C61796F75743A653D3E7B746869732E5F707265766965772E6C61796F7574287B6865696768743A746869732E5F64696D2E6865696768742C77696474683A657D297D7D2C46242E44697374726962757465292C746869732E5F73706C6974566965';
wwv_flow_imp.g_varchar2_table(22660) := '772E61646456696577287B6F6E4469644368616E67653A76742E4E6F6E652C656C656D656E743A746869732E5F74726565436F6E7461696E65722C6D696E696D756D53697A653A3130302C6D6178696D756D53697A653A4E756D6265722E4D41585F5641';
wwv_flow_imp.g_varchar2_table(22661) := '4C55452C6C61796F75743A653D3E7B746869732E5F74726565436F6E7461696E65722E7374796C652E6865696768743D60247B746869732E5F64696D2E6865696768747D7078602C746869732E5F74726565436F6E7461696E65722E7374796C652E7769';
wwv_flow_imp.g_varchar2_table(22662) := '6474683D60247B657D7078602C746869732E5F747265652E6C61796F757428746869732E5F64696D2E6865696768742C65297D7D2C46242E44697374726962757465292C746869732E5F646973706F7361626C65732E61646428746869732E5F73706C69';
wwv_flow_imp.g_varchar2_table(22663) := '74566965772E6F6E446964536173684368616E6765282828293D3E7B746869732E5F64696D2E7769647468262628746869732E6C61796F7574446174612E726174696F3D746869732E5F73706C6974566965772E6765745669657753697A652830292F74';
wwv_flow_imp.g_varchar2_table(22664) := '6869732E5F64696D2E7769647468297D292C766F6964203029293B636F6E7374206E3D28652C74293D3E7B6520696E7374616E63656F66204D472626282273686F77223D3D3D742626746869732E5F72657665616C5265666572656E636528652C213129';
wwv_flow_imp.g_varchar2_table(22665) := '2C746869732E5F6F6E44696453656C6563745265666572656E63652E66697265287B656C656D656E743A652C6B696E643A742C736F757263653A2274726565227D29297D3B746869732E5F747265652E6F6E4469644F70656E2828653D3E7B652E736964';
wwv_flow_imp.g_varchar2_table(22666) := '654279536964653F6E28652E656C656D656E742C227369646522293A652E656469746F724F7074696F6E732E70696E6E65643F6E28652E656C656D656E742C22676F746F22293A6E28652E656C656D656E742C2273686F7722297D29292C797228746869';
wwv_flow_imp.g_varchar2_table(22667) := '732E5F74726565436F6E7461696E6572297D5F6F6E57696474682865297B746869732E5F64696D2626746869732E5F646F4C61796F7574426F647928746869732E5F64696D2E6865696768742C65297D5F646F4C61796F7574426F647928652C74297B73';
wwv_flow_imp.g_varchar2_table(22668) := '757065722E5F646F4C61796F7574426F647928652C74292C746869732E5F64696D3D6E657720497328742C65292C746869732E6C61796F7574446174612E686569676874496E4C696E65733D746869732E5F766965775A6F6E653F746869732E5F766965';
wwv_flow_imp.g_varchar2_table(22669) := '775A6F6E652E686569676874496E4C696E65733A746869732E6C61796F7574446174612E686569676874496E4C696E65732C746869732E5F73706C6974566965772E6C61796F75742874292C746869732E5F73706C6974566965772E726573697A655669';
wwv_flow_imp.g_varchar2_table(22670) := '657728302C742A746869732E6C61796F7574446174612E726174696F297D73657453656C656374696F6E2865297B72657475726E20746869732E5F72657665616C5265666572656E636528652C2130292E7468656E282828293D3E7B746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(22671) := '64656C262628746869732E5F747265652E73657453656C656374696F6E285B655D292C746869732E5F747265652E736574466F637573285B655D29297D29297D7365744D6F64656C2865297B72657475726E20746869732E5F646973706F73654F6E4E65';
wwv_flow_imp.g_varchar2_table(22672) := '774D6F64656C2E636C65617228292C746869732E5F6D6F64656C3D652C746869732E5F6D6F64656C3F746869732E5F6F6E4E65774D6F64656C28293A50726F6D6973652E7265736F6C766528297D5F6F6E4E65774D6F64656C28297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(22673) := '6869732E5F6D6F64656C3F746869732E5F6D6F64656C2E6973456D7074793F28746869732E7365745469746C65282222292C746869732E5F6D657373616765436F6E7461696E65722E696E6E6572546578743D6228302C224E6F20726573756C74732229';
wwv_flow_imp.g_varchar2_table(22674) := '2C5F7228746869732E5F6D657373616765436F6E7461696E6572292C50726F6D6973652E7265736F6C766528766F6964203029293A28797228746869732E5F6D657373616765436F6E7461696E6572292C746869732E5F6465636F726174696F6E734D61';
wwv_flow_imp.g_varchar2_table(22675) := '6E616765723D6E657720615128746869732E5F707265766965772C746869732E5F6D6F64656C292C746869732E5F646973706F73654F6E4E65774D6F64656C2E61646428746869732E5F6465636F726174696F6E734D616E61676572292C746869732E5F';
wwv_flow_imp.g_varchar2_table(22676) := '646973706F73654F6E4E65774D6F64656C2E61646428746869732E5F6D6F64656C2E6F6E4469644368616E67655265666572656E636552616E67652828653D3E746869732E5F747265652E726572656E6465722865292929292C746869732E5F64697370';
wwv_flow_imp.g_varchar2_table(22677) := '6F73654F6E4E65774D6F64656C2E61646428746869732E5F707265766965772E6F6E4D6F757365446F776E2828653D3E7B636F6E73747B6576656E743A742C7461726765743A6E7D3D653B69662832213D3D742E64657461696C2972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(22678) := '6E737420693D746869732E5F676574466F63757365645265666572656E636528293B692626746869732E5F6F6E44696453656C6563745265666572656E63652E66697265287B656C656D656E743A7B7572693A692E7572692C72616E67653A6E2E72616E';
wwv_flow_imp.g_varchar2_table(22679) := '67657D2C6B696E643A742E6374726C4B65797C7C742E6D6574614B65797C7C742E616C744B65793F2273696465223A226F70656E222C736F757263653A22656469746F72227D297D2929292C746869732E636F6E7461696E65722E636C6173734C697374';
wwv_flow_imp.g_varchar2_table(22680) := '2E6164642822726573756C74732D6C6F6164656422292C5F7228746869732E5F74726565436F6E7461696E6572292C5F7228746869732E5F70726576696577436F6E7461696E6572292C746869732E5F73706C6974566965772E6C61796F757428746869';
wwv_flow_imp.g_varchar2_table(22681) := '732E5F64696D2E7769647468292C746869732E666F6375734F6E5265666572656E63655472656528292C746869732E5F747265652E736574496E70757428313D3D3D746869732E5F6D6F64656C2E67726F7570732E6C656E6774683F746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(22682) := '64656C2E67726F7570735B305D3A746869732E5F6D6F64656C29293A50726F6D6973652E7265736F6C766528766F69642030297D5F676574466F63757365645265666572656E636528297B636F6E73745B655D3D746869732E5F747265652E676574466F';
wwv_flow_imp.g_varchar2_table(22683) := '63757328293B72657475726E206520696E7374616E63656F66204D473F653A6520696E7374616E63656F66204E472626652E6368696C6472656E2E6C656E6774683E303F652E6368696C6472656E5B305D3A766F696420307D6173796E63207265766561';
wwv_flow_imp.g_varchar2_table(22684) := '6C5265666572656E63652865297B617761697420746869732E5F72657665616C5265666572656E636528652C2131292C746869732E5F6F6E44696453656C6563745265666572656E63652E66697265287B656C656D656E743A652C6B696E643A22676F74';
wwv_flow_imp.g_varchar2_table(22685) := '6F222C736F757263653A2274726565227D297D6173796E63205F72657665616C5265666572656E636528652C74297B696628746869732E5F72657665616C65645265666572656E63653D3D3D652972657475726E3B746869732E5F72657665616C656452';
wwv_flow_imp.g_varchar2_table(22686) := '65666572656E63653D652C652E7572692E736368656D65213D3D716F2E696E4D656D6F72793F746869732E7365745469746C65284B6C28652E757269292C746869732E5F7572694C6162656C2E6765745572694C6162656C28596C28652E757269292929';
wwv_flow_imp.g_varchar2_table(22687) := '3A746869732E7365745469746C65286228302C225265666572656E6365732229293B636F6E7374206E3D746869732E5F746578744D6F64656C5265736F6C766572536572766963652E6372656174654D6F64656C5265666572656E636528652E75726929';
wwv_flow_imp.g_varchar2_table(22688) := '3B746869732E5F747265652E676574496E70757428293D3D3D652E706172656E747C7C28742626746869732E5F747265652E72657665616C28652E706172656E74292C617761697420746869732E5F747265652E657870616E6428652E706172656E7429';
wwv_flow_imp.g_varchar2_table(22689) := '292C746869732E5F747265652E72657665616C2865293B636F6E737420693D6177616974206E3B69662821746869732E5F6D6F64656C2972657475726E20766F696420692E646973706F736528293B6F7428746869732E5F707265766965774D6F64656C';
wwv_flow_imp.g_varchar2_table(22690) := '5265666572656E6365293B636F6E7374206F3D692E6F626A6563743B6966286F297B636F6E737420743D746869732E5F707265766965772E6765744D6F64656C28293D3D3D6F2E74657874456469746F724D6F64656C3F303A312C6E3D72682E6C696674';
wwv_flow_imp.g_varchar2_table(22691) := '28652E72616E6765292E636F6C6C61707365546F537461727428293B746869732E5F707265766965774D6F64656C5265666572656E63653D692C746869732E5F707265766965772E7365744D6F64656C286F2E74657874456469746F724D6F64656C292C';
wwv_flow_imp.g_varchar2_table(22692) := '746869732E5F707265766965772E73657453656C656374696F6E286E292C746869732E5F707265766965772E72657665616C52616E6765496E43656E746572286E2C74297D656C736520746869732E5F707265766965772E7365744D6F64656C28746869';
wwv_flow_imp.g_varchar2_table(22693) := '732E5F707265766965774E6F74417661696C61626C654D657373616765292C692E646973706F736528297D7D3B64513D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E';
wwv_flow_imp.g_varchar2_table(22694) := '756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F6620526566';
wwv_flow_imp.g_varchar2_table(22695) := '6C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A';
wwv_flow_imp.g_varchar2_table(22696) := '733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B725128332C5062292C725128342C7663292C725128352C7563292C';
wwv_flow_imp.g_varchar2_table(22697) := '725128362C6624292C725128372C4B47292C725128382C6D43292C725128392C2445292C72512831302C4C75292C72512831312C6567295D2C6451293B7661722068512C75513D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(22698) := '286E2C69297B74286E2C692C65297D7D3B636F6E73742070513D6E6577206C6428227265666572656E636553656172636856697369626C65222C21312C6228302C2257686574686572207265666572656E6365207065656B2069732076697369626C652C';
wwv_flow_imp.g_varchar2_table(22699) := '206C696B6520275065656B205265666572656E63657327206F7220275065656B20446566696E6974696F6E272229293B6C65742067513D68513D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E74726962757469';
wwv_flow_imp.g_varchar2_table(22700) := '6F6E2868512E4944297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B746869732E5F64656661756C74547265654B6579626F617264537570706F72743D652C746869732E5F656469746F723D742C746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(22701) := '72536572766963653D692C746869732E5F6E6F74696669636174696F6E536572766963653D6F2C746869732E5F696E7374616E74696174696F6E536572766963653D732C746869732E5F73746F72616765536572766963653D722C746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(22702) := '66696775726174696F6E536572766963653D612C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F726571756573744964506F6F6C3D302C746869732E5F69676E6F72654D6F64656C4368616E67654576656E743D21312C74';
wwv_flow_imp.g_varchar2_table(22703) := '6869732E5F7265666572656E636553656172636856697369626C653D70512E62696E64546F286E297D646973706F736528297B76617220652C743B746869732E5F7265666572656E636553656172636856697369626C652E726573657428292C74686973';
wwv_flow_imp.g_varchar2_table(22704) := '2E5F646973706F7361626C65732E646973706F736528292C6E756C6C3D3D3D28653D746869732E5F776964676574297C7C766F696420303D3D3D657C7C652E646973706F736528292C6E756C6C3D3D3D28743D746869732E5F6D6F64656C297C7C766F69';
wwv_flow_imp.g_varchar2_table(22705) := '6420303D3D3D747C7C742E646973706F736528292C746869732E5F7769646765743D766F696420302C746869732E5F6D6F64656C3D766F696420307D746F67676C6557696467657428652C742C6E297B6C657420693B696628746869732E5F7769646765';
wwv_flow_imp.g_varchar2_table(22706) := '74262628693D746869732E5F7769646765742E706F736974696F6E292C746869732E636C6F736557696467657428292C692626652E636F6E7461696E73506F736974696F6E2869292972657475726E3B746869732E5F7065656B4D6F64653D6E2C746869';
wwv_flow_imp.g_varchar2_table(22707) := '732E5F7265666572656E636553656172636856697369626C652E736574282130292C746869732E5F646973706F7361626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E7B';
wwv_flow_imp.g_varchar2_table(22708) := '746869732E636C6F736557696467657428297D2929292C746869732E5F646973706F7361626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F69676E6F72654D6F64656C4368';
wwv_flow_imp.g_varchar2_table(22709) := '616E67654576656E747C7C746869732E636C6F736557696467657428297D2929293B636F6E7374206F3D227065656B566965774C61796F7574222C733D6C512E66726F6D4A534F4E28746869732E5F73746F72616765536572766963652E676574286F2C';
wwv_flow_imp.g_varchar2_table(22710) := '302C227B7D2229293B746869732E5F7769646765743D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652864512C746869732E5F656469746F722C746869732E5F64656661756C74547265654B6579';
wwv_flow_imp.g_varchar2_table(22711) := '626F617264537570706F72742C73292C746869732E5F7769646765742E7365745469746C65286228302C224C6F6164696E672E2E2E2229292C746869732E5F7769646765742E73686F772865292C746869732E5F646973706F7361626C65732E61646428';
wwv_flow_imp.g_varchar2_table(22712) := '746869732E5F7769646765742E6F6E446964436C6F7365282828293D3E7B742E63616E63656C28292C746869732E5F776964676574262628746869732E5F73746F72616765536572766963652E73746F7265286F2C4A534F4E2E737472696E6769667928';
wwv_flow_imp.g_varchar2_table(22713) := '746869732E5F7769646765742E6C61796F757444617461292C302C31292C746869732E5F7769646765743D766F69642030292C746869732E636C6F736557696467657428297D2929292C746869732E5F646973706F7361626C65732E6164642874686973';
wwv_flow_imp.g_varchar2_table(22714) := '2E5F7769646765742E6F6E44696453656C6563745265666572656E63652828653D3E7B636F6E73747B656C656D656E743A742C6B696E643A697D3D653B69662874297377697463682869297B63617365226F70656E223A22656469746F72223D3D3D652E';
wwv_flow_imp.g_varchar2_table(22715) := '736F757263652626746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E737461626C655065656B22297C7C746869732E6F70656E5265666572656E636528742C21312C2131293B627265616B3B';
wwv_flow_imp.g_varchar2_table(22716) := '636173652273696465223A746869732E6F70656E5265666572656E636528742C21302C2131293B627265616B3B6361736522676F746F223A6E3F746869732E5F676F746F5265666572656E636528742C2130293A746869732E6F70656E5265666572656E';
wwv_flow_imp.g_varchar2_table(22717) := '636528742C21312C2130297D7D2929293B636F6E737420723D2B2B746869732E5F726571756573744964506F6F6C3B742E7468656E2828743D3E7B766172206E3B696628723D3D3D746869732E5F726571756573744964506F6F6C2626746869732E5F77';
wwv_flow_imp.g_varchar2_table(22718) := '69646765742972657475726E206E756C6C3D3D3D286E3D746869732E5F6D6F64656C297C7C766F696420303D3D3D6E7C7C6E2E646973706F736528292C746869732E5F6D6F64656C3D742C746869732E5F7769646765742E7365744D6F64656C28746869';
wwv_flow_imp.g_varchar2_table(22719) := '732E5F6D6F64656C292E7468656E282828293D3E7B696628746869732E5F7769646765742626746869732E5F6D6F64656C2626746869732E5F656469746F722E6861734D6F64656C2829297B746869732E5F6D6F64656C2E6973456D7074793F74686973';
wwv_flow_imp.g_varchar2_table(22720) := '2E5F7769646765742E7365744D6574615469746C65282222293A746869732E5F7769646765742E7365744D6574615469746C65286228302C227B307D20287B317D29222C746869732E5F6D6F64656C2E7469746C652C746869732E5F6D6F64656C2E7265';
wwv_flow_imp.g_varchar2_table(22721) := '666572656E6365732E6C656E67746829293B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292E7572692C6E3D6E6577206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C693D7468';
wwv_flow_imp.g_varchar2_table(22722) := '69732E5F6D6F64656C2E6E6561726573745265666572656E636528742C6E293B696628692972657475726E20746869732E5F7769646765742E73657453656C656374696F6E2869292E7468656E282828293D3E7B746869732E5F77696467657426262265';
wwv_flow_imp.g_varchar2_table(22723) := '6469746F72223D3D3D746869732E5F656469746F722E6765744F7074696F6E283837292626746869732E5F7769646765742E666F6375734F6E50726576696577456469746F7228297D29297D7D29293B742E646973706F736528297D292C28653D3E7B74';
wwv_flow_imp.g_varchar2_table(22724) := '6869732E5F6E6F74696669636174696F6E536572766963652E6572726F722865297D29297D6368616E6765466F6375734265747765656E50726576696577416E645265666572656E63657328297B746869732E5F776964676574262628746869732E5F77';
wwv_flow_imp.g_varchar2_table(22725) := '69646765742E697350726576696577456469746F72466F637573656428293F746869732E5F7769646765742E666F6375734F6E5265666572656E63655472656528293A746869732E5F7769646765742E666F6375734F6E50726576696577456469746F72';
wwv_flow_imp.g_varchar2_table(22726) := '2829297D6173796E6320676F546F4E6578744F7250726576696F75735265666572656E63652865297B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F6D6F64656C7C7C21746869732E5F776964676574297265';
wwv_flow_imp.g_varchar2_table(22727) := '7475726E3B636F6E737420743D746869732E5F7769646765742E706F736974696F6E3B69662821742972657475726E3B636F6E7374206E3D746869732E5F6D6F64656C2E6E6561726573745265666572656E636528746869732E5F656469746F722E6765';
wwv_flow_imp.g_varchar2_table(22728) := '744D6F64656C28292E7572692C74293B696628216E2972657475726E3B636F6E737420693D746869732E5F6D6F64656C2E6E6578744F7250726576696F75735265666572656E6365286E2C65292C6F3D746869732E5F656469746F722E68617354657874';
wwv_flow_imp.g_varchar2_table(22729) := '466F63757328292C733D746869732E5F7769646765742E697350726576696577456469746F72466F637573656428293B617761697420746869732E5F7769646765742E73657453656C656374696F6E2869292C617761697420746869732E5F676F746F52';
wwv_flow_imp.g_varchar2_table(22730) := '65666572656E636528692C2131292C6F3F746869732E5F656469746F722E666F63757328293A746869732E5F7769646765742626732626746869732E5F7769646765742E666F6375734F6E50726576696577456469746F7228297D6173796E6320726576';
wwv_flow_imp.g_varchar2_table(22731) := '65616C5265666572656E63652865297B746869732E5F656469746F722E6861734D6F64656C28292626746869732E5F6D6F64656C2626746869732E5F7769646765742626617761697420746869732E5F7769646765742E72657665616C5265666572656E';
wwv_flow_imp.g_varchar2_table(22732) := '63652865297D636C6F736557696467657428653D2130297B76617220742C6E3B6E756C6C3D3D3D28743D746869732E5F776964676574297C7C766F696420303D3D3D747C7C742E646973706F736528292C6E756C6C3D3D3D286E3D746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(22733) := '656C297C7C766F696420303D3D3D6E7C7C6E2E646973706F736528292C746869732E5F7265666572656E636553656172636856697369626C652E726573657428292C746869732E5F646973706F7361626C65732E636C65617228292C746869732E5F7769';
wwv_flow_imp.g_varchar2_table(22734) := '646765743D766F696420302C746869732E5F6D6F64656C3D766F696420302C652626746869732E5F656469746F722E666F63757328292C746869732E5F726571756573744964506F6F6C2B3D317D5F676F746F5265666572656E636528652C74297B7661';
wwv_flow_imp.g_varchar2_table(22735) := '72206E3B6E756C6C3D3D3D286E3D746869732E5F776964676574297C7C766F696420303D3D3D6E7C7C6E2E6869646528292C746869732E5F69676E6F72654D6F64656C4368616E67654576656E743D21303B636F6E737420693D72682E6C69667428652E';
wwv_flow_imp.g_varchar2_table(22736) := '72616E6765292E636F6C6C61707365546F537461727428293B72657475726E20746869732E5F656469746F72536572766963652E6F70656E436F6465456469746F72287B7265736F757263653A652E7572692C6F7074696F6E733A7B73656C656374696F';
wwv_flow_imp.g_varchar2_table(22737) := '6E3A692C73656C656374696F6E536F757263653A22636F64652E6A756D70222C70696E6E65643A747D7D2C746869732E5F656469746F72292E7468656E2828653D3E7B76617220743B696628746869732E5F69676E6F72654D6F64656C4368616E676545';
wwv_flow_imp.g_varchar2_table(22738) := '76656E743D21312C652626746869732E5F77696467657429696628746869732E5F656469746F723D3D3D6529746869732E5F7769646765742E73686F772869292C746869732E5F7769646765742E666F6375734F6E5265666572656E6365547265652829';
wwv_flow_imp.g_varchar2_table(22739) := '3B656C73657B636F6E7374206E3D68512E6765742865292C6F3D746869732E5F6D6F64656C2E636C6F6E6528293B746869732E636C6F736557696467657428292C652E666F63757328292C6E756C6C3D3D6E7C7C6E2E746F67676C655769646765742869';
wwv_flow_imp.g_varchar2_table(22740) := '2C46742828653D3E50726F6D6973652E7265736F6C7665286F2929292C6E756C6C213D3D28743D746869732E5F7065656B4D6F6465292626766F69642030213D3D74262674297D656C736520746869732E636C6F736557696467657428297D292C28653D';
wwv_flow_imp.g_varchar2_table(22741) := '3E7B746869732E5F69676E6F72654D6F64656C4368616E67654576656E743D21312C6B652865297D29297D6F70656E5265666572656E636528652C742C6E297B747C7C746869732E636C6F736557696467657428293B636F6E73747B7572693A692C7261';
wwv_flow_imp.g_varchar2_table(22742) := '6E67653A6F7D3D653B746869732E5F656469746F72536572766963652E6F70656E436F6465456469746F72287B7265736F757263653A692C6F7074696F6E733A7B73656C656374696F6E3A6F2C73656C656374696F6E536F757263653A22636F64652E6A';
wwv_flow_imp.g_varchar2_table(22743) := '756D70222C70696E6E65643A6E7D7D2C746869732E5F656469746F722C74297D7D3B66756E6374696F6E206D5128652C74297B636F6E7374206E3D66756E6374696F6E2865297B636F6E737420743D652E676574286763292E676574466F637573656443';
wwv_flow_imp.g_varchar2_table(22744) := '6F6465456469746F7228293B72657475726E207420696E7374616E63656F662069243F742E676574506172656E74456469746F7228293A747D2865293B696628216E2972657475726E3B636F6E737420693D67512E676574286E293B692626742869297D';
wwv_flow_imp.g_varchar2_table(22745) := '67512E49443D22656469746F722E636F6E747269622E7265666572656E636573436F6E74726F6C6C6572222C67513D68513D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F74';
wwv_flow_imp.g_varchar2_table(22746) := '3A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F662052';
wwv_flow_imp.g_varchar2_table(22747) := '65666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872';
wwv_flow_imp.g_varchar2_table(22748) := '293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B755128322C6364292C755128332C6763292C755128342C7344';
wwv_flow_imp.g_varchar2_table(22749) := '292C755128352C7563292C755128362C5142292C755128372C6670295D2C6751292C43642E7265676973746572436F6D6D616E64416E644B657962696E64696E6752756C65287B69643A22746F67676C655065656B576964676574466F637573222C7765';
wwv_flow_imp.g_varchar2_table(22750) := '696768743A3130302C7072696D6172793A536528323038392C3630292C7768656E3A57632E6F722870512C76242E696E5065656B456469746F72292C68616E646C65722865297B6D5128652C28653D3E7B652E6368616E6765466F637573426574776565';
wwv_flow_imp.g_varchar2_table(22751) := '6E50726576696577416E645265666572656E63657328297D29297D7D292C43642E7265676973746572436F6D6D616E64416E644B657962696E64696E6752756C65287B69643A22676F546F4E6578745265666572656E6365222C7765696768743A39302C';
wwv_flow_imp.g_varchar2_table(22752) := '7072696D6172793A36322C7365636F6E646172793A5B37305D2C7768656E3A57632E6F722870512C76242E696E5065656B456469746F72292C68616E646C65722865297B6D5128652C28653D3E7B652E676F546F4E6578744F7250726576696F75735265';
wwv_flow_imp.g_varchar2_table(22753) := '666572656E6365282130297D29297D7D292C43642E7265676973746572436F6D6D616E64416E644B657962696E64696E6752756C65287B69643A22676F546F50726576696F75735265666572656E6365222C7765696768743A39302C7072696D6172793A';
wwv_flow_imp.g_varchar2_table(22754) := '313038362C7365636F6E646172793A5B313039345D2C7768656E3A57632E6F722870512C76242E696E5065656B456469746F72292C68616E646C65722865297B6D5128652C28653D3E7B652E676F546F4E6578744F7250726576696F7573526566657265';
wwv_flow_imp.g_varchar2_table(22755) := '6E6365282131297D29297D7D292C6B632E7265676973746572436F6D6D616E64416C6961732822676F546F4E6578745265666572656E636546726F6D456D626564646564456469746F72222C22676F546F4E6578745265666572656E636522292C6B632E';
wwv_flow_imp.g_varchar2_table(22756) := '7265676973746572436F6D6D616E64416C6961732822676F546F50726576696F75735265666572656E636546726F6D456D626564646564456469746F72222C22676F546F50726576696F75735265666572656E636522292C6B632E726567697374657243';
wwv_flow_imp.g_varchar2_table(22757) := '6F6D6D616E64416C6961732822636C6F73655265666572656E6365536561726368456469746F72222C22636C6F73655265666572656E636553656172636822292C6B632E7265676973746572436F6D6D616E642822636C6F73655265666572656E636553';
wwv_flow_imp.g_varchar2_table(22758) := '6561726368222C28653D3E6D5128652C28653D3E652E636C6F73655769646765742829292929292C43642E72656769737465724B657962696E64696E6752756C65287B69643A22636C6F73655265666572656E6365536561726368222C7765696768743A';
wwv_flow_imp.g_varchar2_table(22759) := '2D312C7072696D6172793A392C7365636F6E646172793A5B313033335D2C7768656E3A57632E616E642876242E696E5065656B456469746F722C57632E6E6F742822636F6E6669672E656469746F722E737461626C655065656B2229297D292C43642E72';
wwv_flow_imp.g_varchar2_table(22760) := '656769737465724B657962696E64696E6752756C65287B69643A22636C6F73655265666572656E6365536561726368222C7765696768743A3235302C7072696D6172793A392C7365636F6E646172793A5B313033335D2C7768656E3A57632E616E642870';
wwv_flow_imp.g_varchar2_table(22761) := '512C57632E6E6F742822636F6E6669672E656469746F722E737461626C655065656B22292C57632E6F72286C682E656469746F7254657874466F6375732C454B2E6E6567617465282929297D292C43642E7265676973746572436F6D6D616E64416E644B';
wwv_flow_imp.g_varchar2_table(22762) := '657962696E64696E6752756C65287B69643A2272657665616C5265666572656E6365222C7765696768743A3230302C7072696D6172793A332C6D61633A7B7072696D6172793A332C7365636F6E646172793A5B323036365D7D2C7768656E3A57632E616E';
wwv_flow_imp.g_varchar2_table(22763) := '642870512C504B2C7A4B2E6E656761746528292C574B2E6E65676174652829292C68616E646C65722865297B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D652E67657428544B292E6C617374466F63757365644C697374297C7C766F6964';
wwv_flow_imp.g_varchar2_table(22764) := '20303D3D3D743F766F696420303A742E676574466F63757328293B41727261792E69734172726179286E2926266E5B305D696E7374616E63656F66204D4726266D5128652C28653D3E652E72657665616C5265666572656E6365286E5B305D2929297D7D';
wwv_flow_imp.g_varchar2_table(22765) := '292C43642E7265676973746572436F6D6D616E64416E644B657962696E64696E6752756C65287B69643A226F70656E5265666572656E6365546F53696465222C7765696768743A3130302C7072696D6172793A323035312C6D61633A7B7072696D617279';
wwv_flow_imp.g_varchar2_table(22766) := '3A3235397D2C7768656E3A57632E616E642870512C504B2C7A4B2E6E656761746528292C574B2E6E65676174652829292C68616E646C65722865297B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D652E67657428544B292E6C617374466F';
wwv_flow_imp.g_varchar2_table(22767) := '63757365644C697374297C7C766F696420303D3D3D743F766F696420303A742E676574466F63757328293B41727261792E69734172726179286E2926266E5B305D696E7374616E63656F66204D4726266D5128652C28653D3E652E6F70656E5265666572';
wwv_flow_imp.g_varchar2_table(22768) := '656E6365286E5B305D2C21302C21302929297D7D292C6B632E7265676973746572436F6D6D616E6428226F70656E5265666572656E6365222C28653D3E7B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D652E67657428544B292E6C617374';
wwv_flow_imp.g_varchar2_table(22769) := '466F63757365644C697374297C7C766F696420303D3D3D743F766F696420303A742E676574466F63757328293B41727261792E69734172726179286E2926266E5B305D696E7374616E63656F66204D4726266D5128652C28653D3E652E6F70656E526566';
wwv_flow_imp.g_varchar2_table(22770) := '6572656E6365286E5B305D2C21312C21302929297D29293B7661722066513D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(22771) := '6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D52';
wwv_flow_imp.g_varchar2_table(22772) := '65666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C';
wwv_flow_imp.g_varchar2_table(22773) := '6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C76513D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65';
wwv_flow_imp.g_varchar2_table(22774) := '297D7D3B636F6E73742062513D6E6577206C64282268617353796D626F6C73222C21312C6228302C2257686574686572207468657265206172652073796D626F6C206C6F636174696F6E7320746861742063616E206265206E6176696761746564207669';
wwv_flow_imp.g_varchar2_table(22775) := '61206B6579626F6172642D6F6E6C792E2229292C5F513D706328224953796D626F6C4E617669676174696F6E5365727669636522293B6C65742079513D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(22776) := '536572766963653D742C746869732E5F6E6F74696669636174696F6E536572766963653D6E2C746869732E5F6B657962696E64696E67536572766963653D692C746869732E5F63757272656E744D6F64656C3D766F696420302C746869732E5F63757272';
wwv_flow_imp.g_varchar2_table(22777) := '656E744964783D2D312C746869732E5F69676E6F7265456469746F724368616E67653D21312C746869732E5F63747848617353796D626F6C733D62512E62696E64546F2865297D726573657428297B76617220652C743B746869732E5F63747848617353';
wwv_flow_imp.g_varchar2_table(22778) := '796D626F6C732E726573657428292C6E756C6C3D3D3D28653D746869732E5F63757272656E745374617465297C7C766F696420303D3D3D657C7C652E646973706F736528292C6E756C6C3D3D3D28743D746869732E5F63757272656E744D657373616765';
wwv_flow_imp.g_varchar2_table(22779) := '297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E5F63757272656E744D6F64656C3D766F696420302C746869732E5F63757272656E744964783D2D317D7075742865297B636F6E737420743D652E706172656E742E706172';
wwv_flow_imp.g_varchar2_table(22780) := '656E743B696628742E7265666572656E6365732E6C656E6774683C3D312972657475726E20766F696420746869732E726573657428293B746869732E5F63757272656E744D6F64656C3D742C746869732E5F63757272656E744964783D742E7265666572';
wwv_flow_imp.g_varchar2_table(22781) := '656E6365732E696E6465784F662865292C746869732E5F63747848617353796D626F6C732E736574282130292C746869732E5F73686F774D65737361676528293B636F6E7374206E3D6E657720775128746869732E5F656469746F725365727669636529';
wwv_flow_imp.g_varchar2_table(22782) := '2C693D6E2E6F6E4469644368616E67652828653D3E7B696628746869732E5F69676E6F7265456469746F724368616E67652972657475726E3B636F6E7374206E3D746869732E5F656469746F72536572766963652E676574416374697665436F64654564';
wwv_flow_imp.g_varchar2_table(22783) := '69746F7228293B696628216E2972657475726E3B636F6E737420693D6E2E6765744D6F64656C28292C6F3D6E2E676574506F736974696F6E28293B69662821697C7C216F2972657475726E3B6C657420733D21312C723D21313B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(22784) := '65206F6620742E7265666572656E63657329696628556C28652E7572692C692E7572692929733D21302C723D727C7C72682E636F6E7461696E73506F736974696F6E28652E72616E67652C6F293B656C7365206966287329627265616B3B732626727C7C';
wwv_flow_imp.g_varchar2_table(22785) := '746869732E726573657428297D29293B746869732E5F63757272656E7453746174653D7374286E2C69297D72657665616C4E6578742865297B69662821746869732E5F63757272656E744D6F64656C2972657475726E2050726F6D6973652E7265736F6C';
wwv_flow_imp.g_varchar2_table(22786) := '766528293B746869732E5F63757272656E744964782B3D312C746869732E5F63757272656E74496478253D746869732E5F63757272656E744D6F64656C2E7265666572656E6365732E6C656E6774683B636F6E737420743D746869732E5F63757272656E';
wwv_flow_imp.g_varchar2_table(22787) := '744D6F64656C2E7265666572656E6365735B746869732E5F63757272656E744964785D3B72657475726E20746869732E5F73686F774D65737361676528292C746869732E5F69676E6F7265456469746F724368616E67653D21302C746869732E5F656469';
wwv_flow_imp.g_varchar2_table(22788) := '746F72536572766963652E6F70656E436F6465456469746F72287B7265736F757263653A742E7572692C6F7074696F6E733A7B73656C656374696F6E3A72682E636F6C6C61707365546F537461727428742E72616E6765292C73656C656374696F6E5265';
wwv_flow_imp.g_varchar2_table(22789) := '7665616C547970653A337D7D2C65292E66696E616C6C79282828293D3E7B746869732E5F69676E6F7265456469746F724368616E67653D21317D29297D5F73686F774D65737361676528297B76617220653B6E756C6C3D3D3D28653D746869732E5F6375';
wwv_flow_imp.g_varchar2_table(22790) := '7272656E744D657373616765297C7C766F696420303D3D3D657C7C652E646973706F736528293B636F6E737420743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672822656469746F722E676F746F';
wwv_flow_imp.g_varchar2_table(22791) := '4E65787453796D626F6C46726F6D526573756C7422292C6E3D743F6228302C2253796D626F6C207B307D206F66207B317D2C207B327D20666F72206E657874222C746869732E5F63757272656E744964782B312C746869732E5F63757272656E744D6F64';
wwv_flow_imp.g_varchar2_table(22792) := '656C2E7265666572656E6365732E6C656E6774682C742E6765744C6162656C2829293A6228302C2253796D626F6C207B307D206F66207B317D222C746869732E5F63757272656E744964782B312C746869732E5F63757272656E744D6F64656C2E726566';
wwv_flow_imp.g_varchar2_table(22793) := '6572656E6365732E6C656E677468293B746869732E5F63757272656E744D6573736167653D746869732E5F6E6F74696669636174696F6E536572766963652E737461747573286E297D7D3B79513D6651285B765128302C6364292C765128312C6763292C';
wwv_flow_imp.g_varchar2_table(22794) := '765128322C7344292C765128332C2445295D2C7951292C7870285F512C79512C31292C5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E676F746F4E65787453';
wwv_flow_imp.g_varchar2_table(22795) := '796D626F6C46726F6D526573756C74222C707265636F6E646974696F6E3A62512C6B624F7074733A7B7765696768743A3130302C7072696D6172793A37307D7D297D72756E456469746F72436F6D6D616E6428652C74297B72657475726E20652E676574';
wwv_flow_imp.g_varchar2_table(22796) := '285F51292E72657665616C4E6578742874297D7D292C43642E7265676973746572436F6D6D616E64416E644B657962696E64696E6752756C65287B69643A22656469746F722E676F746F4E65787453796D626F6C46726F6D526573756C742E63616E6365';
wwv_flow_imp.g_varchar2_table(22797) := '6C222C7765696768743A3130302C7768656E3A62512C7072696D6172793A392C68616E646C65722865297B652E676574285F51292E726573657428297D7D293B6C65742077513D636C6173737B636F6E7374727563746F722865297B746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(22798) := '7374656E65723D6E6577204D61702C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E';
wwv_flow_imp.g_varchar2_table(22799) := '6576656E742C746869732E5F646973706F7361626C65732E61646428652E6F6E436F6465456469746F7252656D6F766528746869732E5F6F6E44696452656D6F7665456469746F722C7468697329292C746869732E5F646973706F7361626C65732E6164';
wwv_flow_imp.g_varchar2_table(22800) := '6428652E6F6E436F6465456469746F7241646428746869732E5F6F6E446964416464456469746F722C7468697329292C652E6C697374436F6465456469746F727328292E666F724561636828746869732E5F6F6E446964416464456469746F722C746869';
wwv_flow_imp.g_varchar2_table(22801) := '73297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F6F6E4469644368616E67652E646973706F736528292C6F7428746869732E5F6C697374656E65722E76616C7565732829297D5F6F6E';
wwv_flow_imp.g_varchar2_table(22802) := '446964416464456469746F722865297B746869732E5F6C697374656E65722E73657428652C737428652E6F6E4469644368616E6765437572736F72506F736974696F6E2828743D3E746869732E5F6F6E4469644368616E67652E66697265287B65646974';
wwv_flow_imp.g_varchar2_table(22803) := '6F723A657D2929292C652E6F6E4469644368616E67654D6F64656C436F6E74656E742828743D3E746869732E5F6F6E4469644368616E67652E66697265287B656469746F723A657D29292929297D5F6F6E44696452656D6F7665456469746F722865297B';
wwv_flow_imp.g_varchar2_table(22804) := '76617220743B6E756C6C3D3D3D28743D746869732E5F6C697374656E65722E676574286529297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E5F6C697374656E65722E64656C6574652865297D7D3B6173796E632066756E';
wwv_flow_imp.g_varchar2_table(22805) := '6374696F6E20435128652C742C6E2C69297B636F6E7374206F3D6E2E6F7264657265642865292E6D617028286E3D3E50726F6D6973652E7265736F6C76652869286E2C652C7429292E7468656E28766F696420302C28653D3E7B45652865297D29292929';
wwv_flow_imp.g_varchar2_table(22806) := '3B72657475726E207A68282861776169742050726F6D6973652E616C6C286F29292E666C61742829297D66756E6374696F6E20535128652C742C6E2C69297B72657475726E20435128742C6E2C652C2828652C742C6E293D3E652E70726F766964654465';
wwv_flow_imp.g_varchar2_table(22807) := '66696E6974696F6E28742C6E2C692929297D66756E6374696F6E20785128652C742C6E2C69297B72657475726E20435128742C6E2C652C2828652C742C6E293D3E652E70726F766964654465636C61726174696F6E28742C6E2C692929297D66756E6374';
wwv_flow_imp.g_varchar2_table(22808) := '696F6E206B5128652C742C6E2C69297B72657475726E20435128742C6E2C652C2828652C742C6E293D3E652E70726F76696465496D706C656D656E746174696F6E28742C6E2C692929297D66756E6374696F6E20455128652C742C6E2C69297B72657475';
wwv_flow_imp.g_varchar2_table(22809) := '726E20435128742C6E2C652C2828652C742C6E293D3E652E70726F7669646554797065446566696E6974696F6E28742C6E2C692929297D66756E6374696F6E204C5128652C742C6E2C692C6F297B72657475726E20435128742C6E2C652C286173796E63';
wwv_flow_imp.g_varchar2_table(22810) := '28652C742C6E293D3E7B636F6E737420733D617761697420652E70726F766964655265666572656E63657328742C6E2C7B696E636C7564654465636C61726174696F6E3A21307D2C6F293B69662821697C7C21737C7C32213D3D732E6C656E6774682972';
wwv_flow_imp.g_varchar2_table(22811) := '657475726E20733B636F6E737420723D617761697420652E70726F766964655265666572656E63657328742C6E2C7B696E636C7564654465636C61726174696F6E3A21317D2C6F293B72657475726E20722626313D3D3D722E6C656E6774683F723A737D';
wwv_flow_imp.g_varchar2_table(22812) := '29297D6173796E632066756E6374696F6E2044512865297B636F6E737420743D6177616974206528292C6E3D6E657720504728742C2222292C693D6E2E7265666572656E6365732E6D61702828653D3E652E6C696E6B29293B72657475726E206E2E6469';
wwv_flow_imp.g_varchar2_table(22813) := '73706F736528292C697D7661722054512C49512C4D512C41512C4E512C50512C4F512C52513B77513D6651285B765128302C6763295D2C7751292C516428225F65786563757465446566696E6974696F6E50726F7669646572222C2828652C742C6E293D';
wwv_flow_imp.g_varchar2_table(22814) := '3E7B636F6E737420693D535128652E676574287878292E646566696E6974696F6E50726F76696465722C742C6E2C4D742E4E6F6E65293B72657475726E204451282828293D3E6929297D29292C516428225F6578656375746554797065446566696E6974';
wwv_flow_imp.g_varchar2_table(22815) := '696F6E50726F7669646572222C2828652C742C6E293D3E7B636F6E737420693D455128652E676574287878292E74797065446566696E6974696F6E50726F76696465722C742C6E2C4D742E4E6F6E65293B72657475726E204451282828293D3E6929297D';
wwv_flow_imp.g_varchar2_table(22816) := '29292C516428225F657865637574654465636C61726174696F6E50726F7669646572222C2828652C742C6E293D3E7B636F6E737420693D785128652E676574287878292E6465636C61726174696F6E50726F76696465722C742C6E2C4D742E4E6F6E6529';
wwv_flow_imp.g_varchar2_table(22817) := '3B72657475726E204451282828293D3E6929297D29292C516428225F657865637574655265666572656E636550726F7669646572222C2828652C742C6E293D3E7B636F6E737420693D4C5128652E676574287878292E7265666572656E636550726F7669';
wwv_flow_imp.g_varchar2_table(22818) := '6465722C742C6E2C21312C4D742E4E6F6E65293B72657475726E204451282828293D3E6929297D29292C516428225F65786563757465496D706C656D656E746174696F6E50726F7669646572222C2828652C742C6E293D3E7B636F6E737420693D6B5128';
wwv_flow_imp.g_varchar2_table(22819) := '652E676574287878292E696D706C656D656E746174696F6E50726F76696465722C742C6E2C4D742E4E6F6E65293B72657475726E204451282828293D3E6929297D29292C49642E617070656E644D656E754974656D284C642E456469746F72436F6E7465';
wwv_flow_imp.g_varchar2_table(22820) := '78742C7B7375626D656E753A4C642E456469746F72436F6E746578745065656B2C7469746C653A6228302C225065656B22292C67726F75703A226E617669676174696F6E222C6F726465723A3130307D293B636C6173732046517B737461746963206973';
wwv_flow_imp.g_varchar2_table(22821) := '2865297B72657475726E212821657C7C226F626A65637422213D747970656F662065292626286520696E7374616E63656F662046517C7C2128216D632E697349506F736974696F6E28652E706F736974696F6E297C7C21652E6D6F64656C29297D636F6E';
wwv_flow_imp.g_varchar2_table(22822) := '7374727563746F7228652C74297B746869732E6D6F64656C3D652C746869732E706F736974696F6E3D747D7D636C61737320425120657874656E64732047647B73746174696320616C6C28297B72657475726E2042512E5F616C6C53796D626F6C4E6176';
wwv_flow_imp.g_varchar2_table(22823) := '69676174696F6E436F6D6D616E64732E76616C75657328297D737461746963205F7061746368436F6E6669672865297B636F6E737420743D7B2E2E2E652C66313A21307D3B696628742E6D656E7529666F7228636F6E7374206E206F66205A652E777261';
wwv_flow_imp.g_varchar2_table(22824) := '7028742E6D656E7529296E2E6964213D3D4C642E456469746F72436F6E7465787426266E2E6964213D3D4C642E456469746F72436F6E746578745065656B7C7C286E2E7768656E3D57632E616E6428652E707265636F6E646974696F6E2C6E2E7768656E';
wwv_flow_imp.g_varchar2_table(22825) := '29293B72657475726E20747D636F6E7374727563746F7228652C74297B73757065722842512E5F7061746368436F6E666967287429292C746869732E636F6E66696775726174696F6E3D652C42512E5F616C6C53796D626F6C4E617669676174696F6E43';
wwv_flow_imp.g_varchar2_table(22826) := '6F6D6D616E64732E73657428742E69642C74686973297D72756E456469746F72436F6D6D616E6428652C742C6E2C69297B69662821742E6861734D6F64656C28292972657475726E2050726F6D6973652E7265736F6C766528766F69642030293B636F6E';
wwv_flow_imp.g_varchar2_table(22827) := '7374206F3D652E676574287344292C733D652E676574286763292C723D652E676574285345292C613D652E676574285F51292C6C3D652E676574287878292C633D652E676574287563292C643D742E6765744D6F64656C28292C683D742E676574506F73';
wwv_flow_imp.g_varchar2_table(22828) := '6974696F6E28292C753D46512E6973286E293F6E3A6E657720465128642C68292C703D6E657720646B28742C35292C673D427428746869732E5F6765744C6F636174696F6E4D6F64656C286C2C752E6D6F64656C2C752E706F736974696F6E2C702E746F';
wwv_flow_imp.g_varchar2_table(22829) := '6B656E292C702E746F6B656E292E7468656E28286173796E6320653D3E7B766172206F3B69662821657C7C702E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6C657420723B696628587228652E61726961';
wwv_flow_imp.g_varchar2_table(22830) := '4D657373616765292C652E7265666572656E6365417428642E7572692C6829297B636F6E737420653D746869732E5F676574416C7465726E6174697665436F6D6D616E642874293B2142512E5F616374697665416C7465726E6174697665436F6D6D616E';
wwv_flow_imp.g_varchar2_table(22831) := '64732E686173286529262642512E5F616C6C53796D626F6C4E617669676174696F6E436F6D6D616E64732E686173286529262628723D42512E5F616C6C53796D626F6C4E617669676174696F6E436F6D6D616E64732E676574286529297D636F6E737420';
wwv_flow_imp.g_varchar2_table(22832) := '6C3D652E7265666572656E6365732E6C656E6774683B696628303D3D3D6C297B69662821746869732E636F6E66696775726174696F6E2E6D7574654D657373616765297B636F6E737420653D642E676574576F72644174506F736974696F6E2868293B6E';
wwv_flow_imp.g_varchar2_table(22833) := '756C6C3D3D3D286F3D62452E676574287429297C7C766F696420303D3D3D6F7C7C6F2E73686F774D65737361676528746869732E5F6765744E6F526573756C74466F756E644D6573736167652865292C68297D7D656C73657B69662831213D3D6C7C7C21';
wwv_flow_imp.g_varchar2_table(22834) := '722972657475726E20746869732E5F6F6E526573756C7428732C612C742C652C69293B42512E5F616374697665416C7465726E6174697665436F6D6D616E64732E61646428746869732E646573632E6964292C632E696E766F6B6546756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(22835) := '28653D3E722E72756E456469746F72436F6D6D616E6428652C742C6E2C69292E66696E616C6C79282828293D3E7B42512E5F616374697665416C7465726E6174697665436F6D6D616E64732E64656C65746528746869732E646573632E6964297D292929';
wwv_flow_imp.g_varchar2_table(22836) := '297D7D292C28653D3E7B6F2E6572726F722865297D29292E66696E616C6C79282828293D3E7B702E646973706F736528297D29293B72657475726E20722E73686F775768696C6528672C323530292C677D6173796E63205F6F6E526573756C7428652C74';
wwv_flow_imp.g_varchar2_table(22837) := '2C6E2C692C6F297B636F6E737420733D746869732E5F676574476F546F507265666572656E6365286E293B6966286E20696E7374616E63656F662069247C7C2128746869732E636F6E66696775726174696F6E2E6F70656E496E5065656B7C7C22706565';
wwv_flow_imp.g_varchar2_table(22838) := '6B223D3D3D732626692E7265666572656E6365732E6C656E6774683E3129297B636F6E737420723D692E66697273745265666572656E636528292C613D692E7265666572656E6365732E6C656E6774683E31262622676F746F416E645065656B223D3D3D';
wwv_flow_imp.g_varchar2_table(22839) := '732C6C3D617761697420746869732E5F6F70656E5265666572656E6365286E2C652C722C746869732E636F6E66696775726174696F6E2E6F70656E546F536964652C2161293B6126266C3F746869732E5F6F70656E496E5065656B286C2C692C6F293A69';
wwv_flow_imp.g_varchar2_table(22840) := '2E646973706F736528292C22676F746F223D3D3D732626742E7075742872297D656C736520746869732E5F6F70656E496E5065656B286E2C692C6F297D6173796E63205F6F70656E5265666572656E636528652C742C6E2C692C6F297B6C657420733B76';
wwv_flow_imp.g_varchar2_table(22841) := '617220723B69662828723D6E2926264E6F2E697355726928722E75726929262672682E69734952616E676528722E72616E67652926262872682E69734952616E676528722E6F726967696E53656C656374696F6E52616E6765297C7C72682E6973495261';
wwv_flow_imp.g_varchar2_table(22842) := '6E676528722E74617267657453656C656374696F6E52616E67652929262628733D6E2E74617267657453656C656374696F6E52616E6765292C737C7C28733D6E2E72616E6765292C21732972657475726E3B636F6E737420613D617761697420742E6F70';
wwv_flow_imp.g_varchar2_table(22843) := '656E436F6465456469746F72287B7265736F757263653A6E2E7572692C6F7074696F6E733A7B73656C656374696F6E3A72682E636F6C6C61707365546F53746172742873292C73656C656374696F6E52657665616C547970653A332C73656C656374696F';
wwv_flow_imp.g_varchar2_table(22844) := '6E536F757263653A22636F64652E6A756D70227D7D2C652C69293B69662861297B6966286F297B636F6E737420653D612E6765744D6F64656C28292C743D612E6372656174654465636F726174696F6E73436F6C6C656374696F6E285B7B72616E67653A';
wwv_flow_imp.g_varchar2_table(22845) := '732C6F7074696F6E733A7B6465736372697074696F6E3A2273796D626F6C2D6E617669676174652D616374696F6E2D686967686C69676874222C636C6173734E616D653A2273796D626F6C486967686C69676874227D7D5D293B73657454696D656F7574';
wwv_flow_imp.g_varchar2_table(22846) := '282828293D3E7B612E6765744D6F64656C28293D3D3D652626742E636C65617228297D292C333530297D72657475726E20617D7D5F6F70656E496E5065656B28652C742C6E297B636F6E737420693D67512E6765742865293B692626652E6861734D6F64';
wwv_flow_imp.g_varchar2_table(22847) := '656C28293F692E746F67676C65576964676574286E756C6C213D6E3F6E3A652E67657453656C656374696F6E28292C46742828653D3E50726F6D6973652E7265736F6C766528742929292C746869732E636F6E66696775726174696F6E2E6F70656E496E';
wwv_flow_imp.g_varchar2_table(22848) := '5065656B293A742E646973706F736528297D7D42512E5F616C6C53796D626F6C4E617669676174696F6E436F6D6D616E64733D6E6577204D61702C42512E5F616374697665416C7465726E6174697665436F6D6D616E64733D6E6577205365743B636C61';
wwv_flow_imp.g_varchar2_table(22849) := '737320565120657874656E64732042517B6173796E63205F6765744C6F636174696F6E4D6F64656C28652C742C6E2C69297B72657475726E206E657720504728617761697420535128652E646566696E6974696F6E50726F76696465722C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(22850) := '2C6228302C22446566696E6974696F6E732229297D5F6765744E6F526573756C74466F756E644D6573736167652865297B72657475726E20652626652E776F72643F6228302C224E6F20646566696E6974696F6E20666F756E6420666F7220277B307D27';
wwv_flow_imp.g_varchar2_table(22851) := '222C652E776F7264293A6228302C224E6F20646566696E6974696F6E20666F756E6422297D5F676574416C7465726E6174697665436F6D6D616E642865297B72657475726E20652E6765744F7074696F6E283538292E616C7465726E6174697665446566';
wwv_flow_imp.g_varchar2_table(22852) := '696E6974696F6E436F6D6D616E647D5F676574476F546F507265666572656E63652865297B72657475726E20652E6765744F7074696F6E283538292E6D756C7469706C65446566696E6974696F6E737D7D506428282854513D636C61737320657874656E';
wwv_flow_imp.g_varchar2_table(22853) := '64732056517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21312C6D7574654D6573736167653A21317D2C7B69643A54512E69642C7469746C653A7B2E2E2E5F28302C22476F2074';
wwv_flow_imp.g_varchar2_table(22854) := '6F20446566696E6974696F6E22292C6D6E656D6F6E69635469746C653A6228302C22476F20746F202626446566696E6974696F6E22297D2C707265636F6E646974696F6E3A6C682E686173446566696E6974696F6E50726F76696465722C6B657962696E';
wwv_flow_imp.g_varchar2_table(22855) := '64696E673A5B7B7768656E3A6C682E656469746F7254657874466F6375732C7072696D6172793A37302C7765696768743A3130307D2C7B7768656E3A57632E616E64286C682E656469746F7254657874466F6375732C784B292C7072696D6172793A3231';
wwv_flow_imp.g_varchar2_table(22856) := '31382C7765696768743A3130307D5D2C6D656E753A5B7B69643A4C642E456469746F72436F6E746578742C67726F75703A226E617669676174696F6E222C6F726465723A312E317D2C7B69643A4C642E4D656E75626172476F4D656E752C707265636F6E';
wwv_flow_imp.g_varchar2_table(22857) := '646974696F6E3A6E756C6C2C67726F75703A22345F73796D626F6C5F6E6176222C6F726465723A327D5D7D292C6B632E7265676973746572436F6D6D616E64416C6961732822656469746F722E616374696F6E2E676F546F4465636C61726174696F6E22';
wwv_flow_imp.g_varchar2_table(22858) := '2C54512E6964297D7D292E69643D22656469746F722E616374696F6E2E72657665616C446566696E6974696F6E222C545129292C506428282849513D636C61737320657874656E64732056517B636F6E7374727563746F7228297B7375706572287B6F70';
wwv_flow_imp.g_varchar2_table(22859) := '656E546F536964653A21302C6F70656E496E5065656B3A21312C6D7574654D6573736167653A21317D2C7B69643A49512E69642C7469746C653A5F28302C224F70656E20446566696E6974696F6E20746F20746865205369646522292C707265636F6E64';
wwv_flow_imp.g_varchar2_table(22860) := '6974696F6E3A57632E616E64286C682E686173446566696E6974696F6E50726F76696465722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6B657962696E64696E673A5B7B7768656E3A6C682E656469746F72';
wwv_flow_imp.g_varchar2_table(22861) := '54657874466F6375732C7072696D6172793A536528323038392C3730292C7765696768743A3130307D2C7B7768656E3A57632E616E64286C682E656469746F7254657874466F6375732C784B292C7072696D6172793A536528323038392C32313138292C';
wwv_flow_imp.g_varchar2_table(22862) := '7765696768743A3130307D5D7D292C6B632E7265676973746572436F6D6D616E64416C6961732822656469746F722E616374696F6E2E6F70656E4465636C61726174696F6E546F54686553696465222C49512E6964297D7D292E69643D22656469746F72';
wwv_flow_imp.g_varchar2_table(22863) := '2E616374696F6E2E72657665616C446566696E6974696F6E4173696465222C495129292C50642828284D513D636C61737320657874656E64732056517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E';
wwv_flow_imp.g_varchar2_table(22864) := '496E5065656B3A21302C6D7574654D6573736167653A21317D2C7B69643A4D512E69642C7469746C653A5F28302C225065656B20446566696E6974696F6E22292C707265636F6E646974696F6E3A57632E616E64286C682E686173446566696E6974696F';
wwv_flow_imp.g_varchar2_table(22865) := '6E50726F76696465722C76242E6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6B657962696E64696E673A7B7768656E3A6C682E656469746F7254657874466F6375732C';
wwv_flow_imp.g_varchar2_table(22866) := '7072696D6172793A3538322C6C696E75783A7B7072696D6172793A333134307D2C7765696768743A3130307D2C6D656E753A7B69643A4C642E456469746F72436F6E746578745065656B2C67726F75703A227065656B222C6F726465723A327D7D292C6B';
wwv_flow_imp.g_varchar2_table(22867) := '632E7265676973746572436F6D6D616E64416C6961732822656469746F722E616374696F6E2E707265766965774465636C61726174696F6E222C4D512E6964297D7D292E69643D22656469746F722E616374696F6E2E7065656B446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(22868) := '222C4D5129293B636C617373207A5120657874656E64732042517B6173796E63205F6765744C6F636174696F6E4D6F64656C28652C742C6E2C69297B72657475726E206E657720504728617761697420785128652E6465636C61726174696F6E50726F76';
wwv_flow_imp.g_varchar2_table(22869) := '696465722C742C6E2C69292C6228302C224465636C61726174696F6E732229297D5F6765744E6F526573756C74466F756E644D6573736167652865297B72657475726E20652626652E776F72643F6228302C224E6F206465636C61726174696F6E20666F';
wwv_flow_imp.g_varchar2_table(22870) := '756E6420666F7220277B307D27222C652E776F7264293A6228302C224E6F206465636C61726174696F6E20666F756E6422297D5F676574416C7465726E6174697665436F6D6D616E642865297B72657475726E20652E6765744F7074696F6E283538292E';
wwv_flow_imp.g_varchar2_table(22871) := '616C7465726E61746976654465636C61726174696F6E436F6D6D616E647D5F676574476F546F507265666572656E63652865297B72657475726E20652E6765744F7074696F6E283538292E6D756C7469706C654465636C61726174696F6E737D7D506428';
wwv_flow_imp.g_varchar2_table(22872) := '282841513D636C61737320657874656E6473207A517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21312C6D7574654D6573736167653A21317D2C7B69643A41512E69642C746974';
wwv_flow_imp.g_varchar2_table(22873) := '6C653A7B2E2E2E5F28302C22476F20746F204465636C61726174696F6E22292C6D6E656D6F6E69635469746C653A6228302C22476F20746F2026264465636C61726174696F6E22297D2C707265636F6E646974696F6E3A57632E616E64286C682E686173';
wwv_flow_imp.g_varchar2_table(22874) := '4465636C61726174696F6E50726F76696465722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6D656E753A5B7B69643A4C642E456469746F72436F6E746578742C67726F75703A226E617669676174696F6E22';
wwv_flow_imp.g_varchar2_table(22875) := '2C6F726465723A312E337D2C7B69643A4C642E4D656E75626172476F4D656E752C707265636F6E646974696F6E3A6E756C6C2C67726F75703A22345F73796D626F6C5F6E6176222C6F726465723A337D5D7D297D5F6765744E6F526573756C74466F756E';
wwv_flow_imp.g_varchar2_table(22876) := '644D6573736167652865297B72657475726E20652626652E776F72643F6228302C224E6F206465636C61726174696F6E20666F756E6420666F7220277B307D27222C652E776F7264293A6228302C224E6F206465636C61726174696F6E20666F756E6422';
wwv_flow_imp.g_varchar2_table(22877) := '297D7D292E69643D22656469746F722E616374696F6E2E72657665616C4465636C61726174696F6E222C415129292C506428636C61737320657874656E6473207A517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21';
wwv_flow_imp.g_varchar2_table(22878) := '312C6F70656E496E5065656B3A21302C6D7574654D6573736167653A21317D2C7B69643A22656469746F722E616374696F6E2E7065656B4465636C61726174696F6E222C7469746C653A5F28302C225065656B204465636C61726174696F6E22292C7072';
wwv_flow_imp.g_varchar2_table(22879) := '65636F6E646974696F6E3A57632E616E64286C682E6861734465636C61726174696F6E50726F76696465722C76242E6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6D65';
wwv_flow_imp.g_varchar2_table(22880) := '6E753A7B69643A4C642E456469746F72436F6E746578745065656B2C67726F75703A227065656B222C6F726465723A337D7D297D7D293B636C61737320485120657874656E64732042517B6173796E63205F6765744C6F636174696F6E4D6F64656C2865';
wwv_flow_imp.g_varchar2_table(22881) := '2C742C6E2C69297B72657475726E206E657720504728617761697420455128652E74797065446566696E6974696F6E50726F76696465722C742C6E2C69292C6228302C225479706520446566696E6974696F6E732229297D5F6765744E6F526573756C74';
wwv_flow_imp.g_varchar2_table(22882) := '466F756E644D6573736167652865297B72657475726E20652626652E776F72643F6228302C224E6F207479706520646566696E6974696F6E20666F756E6420666F7220277B307D27222C652E776F7264293A6228302C224E6F207479706520646566696E';
wwv_flow_imp.g_varchar2_table(22883) := '6974696F6E20666F756E6422297D5F676574416C7465726E6174697665436F6D6D616E642865297B72657475726E20652E6765744F7074696F6E283538292E616C7465726E617469766554797065446566696E6974696F6E436F6D6D616E647D5F676574';
wwv_flow_imp.g_varchar2_table(22884) := '476F546F507265666572656E63652865297B72657475726E20652E6765744F7074696F6E283538292E6D756C7469706C6554797065446566696E6974696F6E737D7D50642828284E513D636C61737320657874656E64732048517B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(22885) := '6F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21312C6D7574654D6573736167653A21317D2C7B69643A4E512E49442C7469746C653A7B2E2E2E5F28302C22476F20746F205479706520446566696E697469';
wwv_flow_imp.g_varchar2_table(22886) := '6F6E22292C6D6E656D6F6E69635469746C653A6228302C22476F20746F2026265479706520446566696E6974696F6E22297D2C707265636F6E646974696F6E3A6C682E68617354797065446566696E6974696F6E50726F76696465722C6B657962696E64';
wwv_flow_imp.g_varchar2_table(22887) := '696E673A7B7768656E3A6C682E656469746F7254657874466F6375732C7072696D6172793A302C7765696768743A3130307D2C6D656E753A5B7B69643A4C642E456469746F72436F6E746578742C67726F75703A226E617669676174696F6E222C6F7264';
wwv_flow_imp.g_varchar2_table(22888) := '65723A312E347D2C7B69643A4C642E4D656E75626172476F4D656E752C707265636F6E646974696F6E3A6E756C6C2C67726F75703A22345F73796D626F6C5F6E6176222C6F726465723A337D5D7D297D7D292E49443D22656469746F722E616374696F6E';
wwv_flow_imp.g_varchar2_table(22889) := '2E676F546F54797065446566696E6974696F6E222C4E5129292C506428282850513D636C61737320657874656E64732048517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21302C';
wwv_flow_imp.g_varchar2_table(22890) := '6D7574654D6573736167653A21317D2C7B69643A50512E49442C7469746C653A5F28302C225065656B205479706520446566696E6974696F6E22292C707265636F6E646974696F6E3A57632E616E64286C682E68617354797065446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(22891) := '50726F76696465722C76242E6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6D656E753A7B69643A4C642E456469746F72436F6E746578745065656B2C67726F75703A22';
wwv_flow_imp.g_varchar2_table(22892) := '7065656B222C6F726465723A347D7D297D7D292E49443D22656469746F722E616374696F6E2E7065656B54797065446566696E6974696F6E222C505129293B636C61737320575120657874656E64732042517B6173796E63205F6765744C6F636174696F';
wwv_flow_imp.g_varchar2_table(22893) := '6E4D6F64656C28652C742C6E2C69297B72657475726E206E6577205047286177616974206B5128652E696D706C656D656E746174696F6E50726F76696465722C742C6E2C69292C6228302C22496D706C656D656E746174696F6E732229297D5F6765744E';
wwv_flow_imp.g_varchar2_table(22894) := '6F526573756C74466F756E644D6573736167652865297B72657475726E20652626652E776F72643F6228302C224E6F20696D706C656D656E746174696F6E20666F756E6420666F7220277B307D27222C652E776F7264293A6228302C224E6F20696D706C';
wwv_flow_imp.g_varchar2_table(22895) := '656D656E746174696F6E20666F756E6422297D5F676574416C7465726E6174697665436F6D6D616E642865297B72657475726E20652E6765744F7074696F6E283538292E616C7465726E6174697665496D706C656D656E746174696F6E436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(22896) := '7D5F676574476F546F507265666572656E63652865297B72657475726E20652E6765744F7074696F6E283538292E6D756C7469706C65496D706C656D656E746174696F6E737D7D50642828284F513D636C61737320657874656E64732057517B636F6E73';
wwv_flow_imp.g_varchar2_table(22897) := '74727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21312C6D7574654D6573736167653A21317D2C7B69643A4F512E49442C7469746C653A7B2E2E2E5F28302C22476F20746F20496D706C656D656E';
wwv_flow_imp.g_varchar2_table(22898) := '746174696F6E7322292C6D6E656D6F6E69635469746C653A6228302C22476F20746F202626496D706C656D656E746174696F6E7322297D2C707265636F6E646974696F6E3A6C682E686173496D706C656D656E746174696F6E50726F76696465722C6B65';
wwv_flow_imp.g_varchar2_table(22899) := '7962696E64696E673A7B7768656E3A6C682E656469746F7254657874466F6375732C7072696D6172793A323131382C7765696768743A3130307D2C6D656E753A5B7B69643A4C642E456469746F72436F6E746578742C67726F75703A226E617669676174';
wwv_flow_imp.g_varchar2_table(22900) := '696F6E222C6F726465723A312E34357D2C7B69643A4C642E4D656E75626172476F4D656E752C707265636F6E646974696F6E3A6E756C6C2C67726F75703A22345F73796D626F6C5F6E6176222C6F726465723A347D5D7D297D7D292E49443D2265646974';
wwv_flow_imp.g_varchar2_table(22901) := '6F722E616374696F6E2E676F546F496D706C656D656E746174696F6E222C4F5129292C506428282852513D636C61737320657874656E64732057517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E49';
wwv_flow_imp.g_varchar2_table(22902) := '6E5065656B3A21302C6D7574654D6573736167653A21317D2C7B69643A52512E49442C7469746C653A5F28302C225065656B20496D706C656D656E746174696F6E7322292C707265636F6E646974696F6E3A57632E616E64286C682E686173496D706C65';
wwv_flow_imp.g_varchar2_table(22903) := '6D656E746174696F6E50726F76696465722C76242E6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6B657962696E64696E673A7B7768656E3A6C682E656469746F725465';
wwv_flow_imp.g_varchar2_table(22904) := '7874466F6375732C7072696D6172793A333134322C7765696768743A3130307D2C6D656E753A7B69643A4C642E456469746F72436F6E746578745065656B2C67726F75703A227065656B222C6F726465723A357D7D297D7D292E49443D22656469746F72';
wwv_flow_imp.g_varchar2_table(22905) := '2E616374696F6E2E7065656B496D706C656D656E746174696F6E222C525129293B636C617373206A5120657874656E64732042517B5F6765744E6F526573756C74466F756E644D6573736167652865297B72657475726E20653F6228302C224E6F207265';
wwv_flow_imp.g_varchar2_table(22906) := '666572656E63657320666F756E6420666F7220277B307D27222C652E776F7264293A6228302C224E6F207265666572656E63657320666F756E6422297D5F676574416C7465726E6174697665436F6D6D616E642865297B72657475726E20652E6765744F';
wwv_flow_imp.g_varchar2_table(22907) := '7074696F6E283538292E616C7465726E61746976655265666572656E6365436F6D6D616E647D5F676574476F546F507265666572656E63652865297B72657475726E20652E6765744F7074696F6E283538292E6D756C7469706C655265666572656E6365';
wwv_flow_imp.g_varchar2_table(22908) := '737D7D506428636C61737320657874656E6473206A517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21312C6D7574654D6573736167653A21317D2C7B69643A22656469746F722E';
wwv_flow_imp.g_varchar2_table(22909) := '616374696F6E2E676F546F5265666572656E636573222C7469746C653A7B2E2E2E5F28302C22476F20746F205265666572656E63657322292C6D6E656D6F6E69635469746C653A6228302C22476F20746F2026265265666572656E63657322297D2C7072';
wwv_flow_imp.g_varchar2_table(22910) := '65636F6E646974696F6E3A57632E616E64286C682E6861735265666572656E636550726F76696465722C76242E6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6B657962';
wwv_flow_imp.g_varchar2_table(22911) := '696E64696E673A7B7768656E3A6C682E656469746F7254657874466F6375732C7072696D6172793A313039342C7765696768743A3130307D2C6D656E753A5B7B69643A4C642E456469746F72436F6E746578742C67726F75703A226E617669676174696F';
wwv_flow_imp.g_varchar2_table(22912) := '6E222C6F726465723A312E34357D2C7B69643A4C642E4D656E75626172476F4D656E752C707265636F6E646974696F6E3A6E756C6C2C67726F75703A22345F73796D626F6C5F6E6176222C6F726465723A357D5D7D297D6173796E63205F6765744C6F63';
wwv_flow_imp.g_varchar2_table(22913) := '6174696F6E4D6F64656C28652C742C6E2C69297B72657475726E206E6577205047286177616974204C5128652E7265666572656E636550726F76696465722C742C6E2C21302C69292C6228302C225265666572656E6365732229297D7D292C506428636C';
wwv_flow_imp.g_varchar2_table(22914) := '61737320657874656E6473206A517B636F6E7374727563746F7228297B7375706572287B6F70656E546F536964653A21312C6F70656E496E5065656B3A21302C6D7574654D6573736167653A21317D2C7B69643A22656469746F722E616374696F6E2E72';
wwv_flow_imp.g_varchar2_table(22915) := '65666572656E63655365617263682E74726967676572222C7469746C653A5F28302C225065656B205265666572656E63657322292C707265636F6E646974696F6E3A57632E616E64286C682E6861735265666572656E636550726F76696465722C76242E';
wwv_flow_imp.g_varchar2_table(22916) := '6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829292C6D656E753A7B69643A4C642E456469746F72436F6E746578745065656B2C67726F75703A227065656B222C6F726465723A';
wwv_flow_imp.g_varchar2_table(22917) := '367D7D297D6173796E63205F6765744C6F636174696F6E4D6F64656C28652C742C6E2C69297B72657475726E206E6577205047286177616974204C5128652E7265666572656E636550726F76696465722C742C6E2C21312C69292C6228302C2252656665';
wwv_flow_imp.g_varchar2_table(22918) := '72656E6365732229297D7D293B636C61737320715120657874656E64732042517B636F6E7374727563746F7228652C742C6E297B737570657228652C7B69643A22656469746F722E616374696F6E2E676F546F4C6F636174696F6E222C7469746C653A5F';
wwv_flow_imp.g_varchar2_table(22919) := '28302C22476F20746F20416E792053796D626F6C22292C707265636F6E646974696F6E3A57632E616E642876242E6E6F74496E5065656B456469746F722C6C682E6973496E456D626564646564456469746F722E746F4E6567617465642829297D292C74';
wwv_flow_imp.g_varchar2_table(22920) := '6869732E5F7265666572656E6365733D742C746869732E5F676F746F4D756C7469706C654265686176696F75723D6E7D6173796E63205F6765744C6F636174696F6E4D6F64656C28652C742C6E2C69297B72657475726E206E657720504728746869732E';
wwv_flow_imp.g_varchar2_table(22921) := '5F7265666572656E6365732C6228302C224C6F636174696F6E732229297D5F6765744E6F526573756C74466F756E644D6573736167652865297B72657475726E206526266228302C224E6F20726573756C747320666F7220277B307D27222C652E776F72';
wwv_flow_imp.g_varchar2_table(22922) := '64297C7C22227D5F676574476F546F507265666572656E63652865297B76617220743B72657475726E206E756C6C213D3D28743D746869732E5F676F746F4D756C7469706C654265686176696F7572292626766F69642030213D3D743F743A652E676574';
wwv_flow_imp.g_varchar2_table(22923) := '4F7074696F6E283538292E6D756C7469706C655265666572656E6365737D5F676574416C7465726E6174697665436F6D6D616E6428297B72657475726E22227D7D6173796E632066756E6374696F6E20245128652C742C6E2C69297B766172206F3B636F';
wwv_flow_imp.g_varchar2_table(22924) := '6E737420733D652E676574287663292C723D652E676574287145292C613D652E676574287863292C6C3D652E676574287563292C633D652E676574287344293B696628617761697420692E6974656D2E7265736F6C7665284D742E4E6F6E65292C21692E';
wwv_flow_imp.g_varchar2_table(22925) := '706172742E6C6F636174696F6E2972657475726E3B636F6E737420643D692E706172742E6C6F636174696F6E2C683D5B5D2C753D6E6577205365742849642E6765744D656E754974656D73284C642E456469746F72436F6E74657874292E6D6170282865';
wwv_flow_imp.g_varchar2_table(22926) := '3D3E45642865293F652E636F6D6D616E642E69643A727828292929293B666F7228636F6E73742065206F662042512E616C6C282929752E68617328652E646573632E6964292626682E70757368286E657720626328652E646573632E69642C41642E6C61';
wwv_flow_imp.g_varchar2_table(22927) := '62656C28652E646573632C7B72656E64657253686F72745469746C653A21307D292C766F696420302C21302C286173796E6328293D3E7B636F6E7374206E3D617761697420732E6372656174654D6F64656C5265666572656E636528642E757269293B74';
wwv_flow_imp.g_varchar2_table(22928) := '72797B636F6E7374206F3D6E6577204651286E2E6F626A6563742E74657874456469746F724D6F64656C2C72682E6765745374617274506F736974696F6E28642E72616E676529292C733D692E6974656D2E616E63686F722E72616E67653B6177616974';
wwv_flow_imp.g_varchar2_table(22929) := '206C2E696E766F6B6546756E6374696F6E28652E72756E456469746F72436F6D6D616E642E62696E642865292C742C6F2C73297D66696E616C6C797B6E2E646973706F736528297D7D2929293B696628692E706172742E636F6D6D616E64297B636F6E73';
wwv_flow_imp.g_varchar2_table(22930) := '747B636F6D6D616E643A657D3D692E706172743B682E70757368286E6577207963292C682E70757368286E657720626328652E69642C652E7469746C652C766F696420302C21302C286173796E6328293D3E7B76617220743B7472797B61776169742061';
wwv_flow_imp.g_varchar2_table(22931) := '2E65786563757465436F6D6D616E6428652E69642C2E2E2E6E756C6C213D3D28743D652E617267756D656E7473292626766F69642030213D3D743F743A5B5D297D63617463682865297B632E6E6F74696679287B73657665726974793A6F442E4572726F';
wwv_flow_imp.g_varchar2_table(22932) := '722C736F757263653A692E6974656D2E70726F76696465722E646973706C61794E616D652C6D6573736167653A657D297D7D2929297D636F6E737420703D742E6765744F7074696F6E28313237293B722E73686F77436F6E746578744D656E75287B646F';
wwv_flow_imp.g_varchar2_table(22933) := '6D466F72536861646F77526F6F743A7026266E756C6C213D3D286F3D742E676574446F6D4E6F64652829292626766F69642030213D3D6F3F6F3A766F696420302C676574416E63686F723A28293D3E7B636F6E737420653D4173286E293B72657475726E';
wwv_flow_imp.g_varchar2_table(22934) := '7B783A652E6C6566742C793A652E746F702B652E6865696768742B387D7D2C676574416374696F6E733A28293D3E682C6F6E486964653A28293D3E7B742E666F63757328297D2C6175746F53656C65637446697273744974656D3A21307D297D6173796E';
wwv_flow_imp.g_varchar2_table(22935) := '632066756E6374696F6E20555128652C742C6E2C69297B636F6E7374206F3D652E676574287663292C733D6177616974206F2E6372656174654D6F64656C5265666572656E636528692E757269293B6177616974206E2E696E766F6B6557697468696E43';
wwv_flow_imp.g_varchar2_table(22936) := '6F6E7465787428286173796E6320653D3E7B636F6E7374206F3D742E686173536964654279536964654D6F6469666965722C723D652E676574286364292C613D76242E696E5065656B456469746F722E67657456616C75652872292C6C3D216F26266E2E';
wwv_flow_imp.g_varchar2_table(22937) := '6765744F7074696F6E28383829262621613B72657475726E206E6577205651287B6F70656E546F536964653A6F2C6F70656E496E5065656B3A6C2C6D7574654D6573736167653A21307D2C7B7469746C653A7B76616C75653A22222C6F726967696E616C';
wwv_flow_imp.g_varchar2_table(22938) := '3A22227D2C69643A22222C707265636F6E646974696F6E3A766F696420307D292E72756E28652C6E657720465128732E6F626A6563742E74657874456469746F724D6F64656C2C72682E6765745374617274506F736974696F6E28692E72616E67652929';
wwv_flow_imp.g_varchar2_table(22939) := '2C72682E6C69667428692E72616E676529297D29292C732E646973706F736528297D6B632E7265676973746572436F6D6D616E64287B69643A22656469746F722E616374696F6E2E676F546F4C6F636174696F6E73222C6D657461646174613A7B646573';
wwv_flow_imp.g_varchar2_table(22940) := '6372697074696F6E3A22476F20746F206C6F636174696F6E732066726F6D206120706F736974696F6E20696E20612066696C65222C617267733A5B7B6E616D653A22757269222C6465736372697074696F6E3A22546865207465787420646F63756D656E';
wwv_flow_imp.g_varchar2_table(22941) := '7420696E20776869636820746F207374617274222C636F6E73747261696E743A4E6F7D2C7B6E616D653A22706F736974696F6E222C6465736372697074696F6E3A2254686520706F736974696F6E20617420776869636820746F207374617274222C636F';
wwv_flow_imp.g_varchar2_table(22942) := '6E73747261696E743A6D632E697349506F736974696F6E7D2C7B6E616D653A226C6F636174696F6E73222C6465736372697074696F6E3A22416E206172726179206F66206C6F636174696F6E732E222C636F6E73747261696E743A41727261797D2C7B6E';
wwv_flow_imp.g_varchar2_table(22943) := '616D653A226D756C7469706C65222C6465736372697074696F6E3A22446566696E65207768617420746F20646F207768656E20686176696E67206D756C7469706C6520726573756C74732C2065697468657220607065656B602C2060676F746F416E6450';
wwv_flow_imp.g_varchar2_table(22944) := '65656B602C206F722060676F746F60227D2C7B6E616D653A226E6F526573756C74734D657373616765222C6465736372697074696F6E3A2248756D616E207265616461626C65206D65737361676520746861742073686F7773207768656E206C6F636174';
wwv_flow_imp.g_varchar2_table(22945) := '696F6E7320697320656D7074792E227D5D7D2C68616E646C65723A6173796E6328652C742C6E2C692C6F2C732C72293D3E7B796C284E6F2E6973557269287429292C796C286D632E697349506F736974696F6E286E29292C796C2841727261792E697341';
wwv_flow_imp.g_varchar2_table(22946) := '72726179286929292C796C28766F696420303D3D3D6F7C7C22737472696E67223D3D747970656F66206F292C796C28766F696420303D3D3D727C7C22626F6F6C65616E223D3D747970656F662072293B636F6E737420613D652E676574286763292C6C3D';
wwv_flow_imp.g_varchar2_table(22947) := '617761697420612E6F70656E436F6465456469746F72287B7265736F757263653A747D2C612E676574466F6375736564436F6465456469746F722829293B6966284A71286C292972657475726E206C2E736574506F736974696F6E286E292C6C2E726576';
wwv_flow_imp.g_varchar2_table(22948) := '65616C506F736974696F6E496E43656E74657249664F75747369646556696577706F7274286E2C30292C6C2E696E766F6B6557697468696E436F6E746578742828653D3E7B636F6E737420743D6E657720636C61737320657874656E64732071517B5F67';
wwv_flow_imp.g_varchar2_table(22949) := '65744E6F526573756C74466F756E644D6573736167652865297B72657475726E20737C7C73757065722E5F6765744E6F526573756C74466F756E644D6573736167652865297D7D287B6D7574654D6573736167653A21426F6F6C65616E2873292C6F7065';
wwv_flow_imp.g_varchar2_table(22950) := '6E496E5065656B3A426F6F6C65616E2872292C6F70656E546F536964653A21317D2C692C6F293B652E676574287563292E696E766F6B6546756E6374696F6E28742E72756E2E62696E642874292C6C297D29297D7D292C6B632E7265676973746572436F';
wwv_flow_imp.g_varchar2_table(22951) := '6D6D616E64287B69643A22656469746F722E616374696F6E2E7065656B4C6F636174696F6E73222C6D657461646174613A7B6465736372697074696F6E3A225065656B206C6F636174696F6E732066726F6D206120706F736974696F6E20696E20612066';
wwv_flow_imp.g_varchar2_table(22952) := '696C65222C617267733A5B7B6E616D653A22757269222C6465736372697074696F6E3A22546865207465787420646F63756D656E7420696E20776869636820746F207374617274222C636F6E73747261696E743A4E6F7D2C7B6E616D653A22706F736974';
wwv_flow_imp.g_varchar2_table(22953) := '696F6E222C6465736372697074696F6E3A2254686520706F736974696F6E20617420776869636820746F207374617274222C636F6E73747261696E743A6D632E697349506F736974696F6E7D2C7B6E616D653A226C6F636174696F6E73222C6465736372';
wwv_flow_imp.g_varchar2_table(22954) := '697074696F6E3A22416E206172726179206F66206C6F636174696F6E732E222C636F6E73747261696E743A41727261797D2C7B6E616D653A226D756C7469706C65222C6465736372697074696F6E3A22446566696E65207768617420746F20646F207768';
wwv_flow_imp.g_varchar2_table(22955) := '656E20686176696E67206D756C7469706C6520726573756C74732C2065697468657220607065656B602C2060676F746F416E645065656B602C206F722060676F746F60227D5D7D2C68616E646C65723A6173796E6328652C742C6E2C692C6F293D3E7B65';
wwv_flow_imp.g_varchar2_table(22956) := '2E676574287863292E65786563757465436F6D6D616E642822656469746F722E616374696F6E2E676F546F4C6F636174696F6E73222C742C6E2C692C6F2C766F696420302C2130297D7D292C6B632E7265676973746572436F6D6D616E64287B69643A22';
wwv_flow_imp.g_varchar2_table(22957) := '656469746F722E616374696F6E2E66696E645265666572656E636573222C68616E646C65723A28652C742C6E293D3E7B796C284E6F2E6973557269287429292C796C286D632E697349506F736974696F6E286E29293B636F6E737420693D652E67657428';
wwv_flow_imp.g_varchar2_table(22958) := '7878292C6F3D652E676574286763293B72657475726E206F2E6F70656E436F6465456469746F72287B7265736F757263653A747D2C6F2E676574466F6375736564436F6465456469746F722829292E7468656E2828653D3E7B696628214A712865297C7C';
wwv_flow_imp.g_varchar2_table(22959) := '21652E6861734D6F64656C28292972657475726E3B636F6E737420743D67512E6765742865293B69662821742972657475726E3B636F6E7374206F3D46742828743D3E4C5128692E7265666572656E636550726F76696465722C652E6765744D6F64656C';
wwv_flow_imp.g_varchar2_table(22960) := '28292C6D632E6C696674286E292C21312C74292E7468656E2828653D3E6E657720504728652C6228302C225265666572656E636573222929292929292C733D6E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C6E2E6C696E654E75';
wwv_flow_imp.g_varchar2_table(22961) := '6D6265722C6E2E636F6C756D6E293B72657475726E2050726F6D6973652E7265736F6C766528742E746F67676C6557696467657428732C6F2C213129297D29297D7D292C6B632E7265676973746572436F6D6D616E64416C6961732822656469746F722E';
wwv_flow_imp.g_varchar2_table(22962) := '616374696F6E2E73686F775265666572656E636573222C22656469746F722E616374696F6E2E7065656B4C6F636174696F6E7322293B766172204B512C47513D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74';
wwv_flow_imp.g_varchar2_table(22963) := '286E2C692C65297D7D3B636C6173732051517B636F6E7374727563746F7228297B746869732E5F656E74726965733D6E6577206161283530297D6765742865297B636F6E737420743D51512E5F6B65792865293B72657475726E20746869732E5F656E74';
wwv_flow_imp.g_varchar2_table(22964) := '726965732E6765742874297D73657428652C74297B636F6E7374206E3D51512E5F6B65792865293B746869732E5F656E74726965732E736574286E2C74297D737461746963205F6B65792865297B72657475726E60247B652E7572692E746F537472696E';
wwv_flow_imp.g_varchar2_table(22965) := '6728297D2F247B652E67657456657273696F6E496428297D607D7D636F6E73742059513D7063282249496E6C617948696E7473436163686522293B78702859512C51512C31293B636C617373205A517B636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(22966) := '732E6974656D3D652C746869732E696E6465783D747D676574207061727428297B636F6E737420653D746869732E6974656D2E68696E742E6C6162656C3B72657475726E22737472696E67223D3D747970656F6620653F7B6C6162656C3A657D3A655B74';
wwv_flow_imp.g_varchar2_table(22967) := '6869732E696E6465785D7D7D636C6173732058517B636F6E7374727563746F7228652C74297B746869732E706172743D652C746869732E686173547269676765724D6F6469666965723D747D7D6C6574204A513D4B513D636C6173737B73746174696320';
wwv_flow_imp.g_varchar2_table(22968) := '6765742865297B76617220743B72657475726E206E756C6C213D3D28743D652E676574436F6E747269627574696F6E284B512E494429292626766F69642030213D3D743F743A766F696420307D636F6E7374727563746F7228652C742C6E2C692C6F2C73';
wwv_flow_imp.g_varchar2_table(22969) := '2C72297B746869732E5F656469746F723D652C746869732E5F6C616E67756167654665617475726573536572766963653D742C746869732E5F696E6C617948696E747343616368653D692C746869732E5F636F6D6D616E64536572766963653D6F2C7468';
wwv_flow_imp.g_varchar2_table(22970) := '69732E5F6E6F74696669636174696F6E536572766963653D732C746869732E5F696E737461536572766963653D722C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F73657373696F6E446973706F7361626C65733D6E6577';
wwv_flow_imp.g_varchar2_table(22971) := '2061742C746869732E5F6465636F726174696F6E734D657461646174613D6E6577204D61702C746869732E5F72756C65466163746F72793D6E657720514128746869732E5F656469746F72292C746869732E5F61637469766552656E6465724D6F64653D';
wwv_flow_imp.g_varchar2_table(22972) := '302C746869732E5F6465626F756E6365496E666F3D6E2E666F7228742E696E6C617948696E747350726F76696465722C22496E6C617948696E74222C7B6D696E3A32357D292C746869732E5F646973706F7361626C65732E61646428742E696E6C617948';
wwv_flow_imp.g_varchar2_table(22973) := '696E747350726F76696465722E6F6E4469644368616E6765282828293D3E746869732E5F75706461746528292929292C746869732E5F646973706F7361626C65732E61646428652E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F';
wwv_flow_imp.g_varchar2_table(22974) := '75706461746528292929292C746869732E5F646973706F7361626C65732E61646428652E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E746869732E5F75706461746528292929292C746869732E5F646973706F7361626C65';
wwv_flow_imp.g_varchar2_table(22975) := '732E61646428652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E67656428313431292626746869732E5F75706461746528297D2929292C746869732E5F75706461746528297D646973706F73652829';
wwv_flow_imp.g_varchar2_table(22976) := '7B746869732E5F73657373696F6E446973706F7361626C65732E646973706F736528292C746869732E5F72656D6F7665416C6C4465636F726174696F6E7328292C746869732E5F646973706F7361626C65732E646973706F736528297D5F757064617465';
wwv_flow_imp.g_varchar2_table(22977) := '28297B746869732E5F73657373696F6E446973706F7361626C65732E636C65617228292C746869732E5F72656D6F7665416C6C4465636F726174696F6E7328293B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E2831343129';
wwv_flow_imp.g_varchar2_table(22978) := '3B696628226F6666223D3D3D652E656E61626C65642972657475726E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28293B69662821747C7C21746869732E5F6C616E67756167654665617475726573536572766963652E69';
wwv_flow_imp.g_varchar2_table(22979) := '6E6C617948696E747350726F76696465722E6861732874292972657475726E3B696628226F6E223D3D3D652E656E61626C656429746869732E5F61637469766552656E6465724D6F64653D303B656C73657B6C657420742C6E3B226F6E556E6C65737350';
wwv_flow_imp.g_varchar2_table(22980) := '726573736564223D3D3D652E656E61626C65643F28743D302C6E3D31293A28743D312C6E3D30292C746869732E5F61637469766552656E6465724D6F64653D742C746869732E5F73657373696F6E446973706F7361626C65732E616464284C722E676574';
wwv_flow_imp.g_varchar2_table(22981) := '496E7374616E636528292E6576656E742828653D3E7B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420693D652E616C744B65792626652E6374726C4B6579262621652E73686966744B6579262621';
wwv_flow_imp.g_varchar2_table(22982) := '652E6D6574614B65793F6E3A743B69662869213D3D746869732E5F61637469766552656E6465724D6F6465297B746869732E5F61637469766552656E6465724D6F64653D693B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28';
wwv_flow_imp.g_varchar2_table(22983) := '292C743D746869732E5F636F7079496E6C617948696E74735769746843757272656E74416E63686F722865293B746869732E5F75706461746548696E74734465636F7261746F7273285B652E67657446756C6C4D6F64656C52616E676528295D2C74292C';
wwv_flow_imp.g_varchar2_table(22984) := '732E7363686564756C652830297D7D2929297D636F6E7374206E3D746869732E5F696E6C617948696E747343616368652E6765742874293B6C657420693B6E2626746869732E5F75706461746548696E74734465636F7261746F7273285B742E67657446';
wwv_flow_imp.g_varchar2_table(22985) := '756C6C4D6F64656C52616E676528295D2C6E292C746869732E5F73657373696F6E446973706F7361626C65732E616464287274282828293D3E7B742E6973446973706F73656428297C7C746869732E5F636163686548696E7473466F7246617374526573';
wwv_flow_imp.g_varchar2_table(22986) := '746F72652874297D2929293B636F6E7374206F3D6E6577205365742C733D6E6577204B7428286173796E6328293D3E7B636F6E737420653D446174652E6E6F7728293B6E756C6C3D3D697C7C692E646973706F7365282130292C693D6E6577204E743B63';
wwv_flow_imp.g_varchar2_table(22987) := '6F6E7374206E3D742E6F6E57696C6C446973706F7365282828293D3E6E756C6C3D3D693F766F696420303A692E63616E63656C282929293B7472797B636F6E7374206E3D692E746F6B656E2C723D61776169742058712E63726561746528746869732E5F';
wwv_flow_imp.g_varchar2_table(22988) := '6C616E67756167654665617475726573536572766963652E696E6C617948696E747350726F76696465722C742C746869732E5F67657448696E747352616E67657328292C6E293B696628732E64656C61793D746869732E5F6465626F756E6365496E666F';
wwv_flow_imp.g_varchar2_table(22989) := '2E75706461746528742C446174652E6E6F7728292D65292C6E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E20766F696420722E646973706F736528293B666F7228636F6E73742065206F6620722E70726F766964657229';
wwv_flow_imp.g_varchar2_table(22990) := '2266756E6374696F6E22213D747970656F6620652E6F6E4469644368616E6765496E6C617948696E74737C7C6F2E6861732865297C7C286F2E6164642865292C746869732E5F73657373696F6E446973706F7361626C65732E61646428652E6F6E446964';
wwv_flow_imp.g_varchar2_table(22991) := '4368616E6765496E6C617948696E7473282828293D3E7B732E69735363686564756C656428297C7C732E7363686564756C6528297D292929293B746869732E5F73657373696F6E446973706F7361626C65732E6164642872292C746869732E5F75706461';
wwv_flow_imp.g_varchar2_table(22992) := '746548696E74734465636F7261746F727328722E72616E6765732C722E6974656D73292C746869732E5F636163686548696E7473466F7246617374526573746F72652874297D63617463682865297B6B652865297D66696E616C6C797B692E646973706F';
wwv_flow_imp.g_varchar2_table(22993) := '736528292C6E2E646973706F736528297D7D292C746869732E5F6465626F756E6365496E666F2E676574287429293B746869732E5F73657373696F6E446973706F7361626C65732E6164642873292C746869732E5F73657373696F6E446973706F736162';
wwv_flow_imp.g_varchar2_table(22994) := '6C65732E616464287274282828293D3E6E756C6C3D3D693F766F696420303A692E646973706F7365282130292929292C732E7363686564756C652830292C746869732E5F73657373696F6E446973706F7361626C65732E61646428746869732E5F656469';
wwv_flow_imp.g_varchar2_table(22995) := '746F722E6F6E4469645363726F6C6C4368616E67652828653D3E7B21652E7363726F6C6C546F704368616E6765642626732E69735363686564756C656428297C7C732E7363686564756C6528297D2929292C746869732E5F73657373696F6E446973706F';
wwv_flow_imp.g_varchar2_table(22996) := '7361626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B6E756C6C3D3D697C7C692E63616E63656C28293B636F6E737420743D4D6174682E6D617828732E64656C61792C3132';
wwv_flow_imp.g_varchar2_table(22997) := '3530293B732E7363686564756C652874297D2929292C746869732E5F73657373696F6E446973706F7361626C65732E61646428746869732E5F696E7374616C6C44626C436C69636B47657374757265282828293D3E732E7363686564756C652830292929';
wwv_flow_imp.g_varchar2_table(22998) := '292C746869732E5F73657373696F6E446973706F7361626C65732E61646428746869732E5F696E7374616C6C4C696E6B476573747572652829292C746869732E5F73657373696F6E446973706F7361626C65732E61646428746869732E5F696E7374616C';
wwv_flow_imp.g_varchar2_table(22999) := '6C436F6E746578744D656E752829297D5F696E7374616C6C4C696E6B4765737475726528297B636F6E737420653D6E65772061742C743D652E616464286E657720517128746869732E5F656469746F7229292C6E3D6E65772061743B72657475726E2065';
wwv_flow_imp.g_varchar2_table(23000) := '2E616464286E292C652E61646428742E6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E2828653D3E7B636F6E73745B745D3D652C693D746869732E5F676574496E6C617948696E744C6162656C506172742874292C6F3D74686973';
wwv_flow_imp.g_varchar2_table(23001) := '2E5F656469746F722E6765744D6F64656C28293B69662821697C7C216F2972657475726E20766F6964206E2E636C65617228293B636F6E737420733D6E6577204E743B6E2E616464287274282828293D3E732E646973706F7365282130292929292C692E';
wwv_flow_imp.g_varchar2_table(23002) := '6974656D2E7265736F6C766528732E746F6B656E292C746869732E5F616374697665496E6C617948696E74506172743D692E706172742E636F6D6D616E647C7C692E706172742E6C6F636174696F6E3F6E657720585128692C742E686173547269676765';
wwv_flow_imp.g_varchar2_table(23003) := '724D6F646966696572293A766F696420303B636F6E737420723D6F2E76616C6964617465506F736974696F6E28692E6974656D2E68696E742E706F736974696F6E292E6C696E654E756D6265722C613D6E657720726828722C312C722C6F2E6765744C69';
wwv_flow_imp.g_varchar2_table(23004) := '6E654D6178436F6C756D6E287229292C6C3D746869732E5F676574496E6C696E6548696E7473466F7252616E67652861293B746869732E5F75706461746548696E74734465636F7261746F7273285B615D2C6C292C6E2E616464287274282828293D3E7B';
wwv_flow_imp.g_varchar2_table(23005) := '746869732E5F616374697665496E6C617948696E74506172743D766F696420302C746869732E5F75706461746548696E74734465636F7261746F7273285B615D2C6C297D2929297D2929292C652E61646428742E6F6E43616E63656C282828293D3E6E2E';
wwv_flow_imp.g_varchar2_table(23006) := '636C65617228292929292C652E61646428742E6F6E4578656375746528286173796E6320653D3E7B636F6E737420743D746869732E5F676574496E6C617948696E744C6162656C506172742865293B69662874297B636F6E7374206E3D742E706172743B';
wwv_flow_imp.g_varchar2_table(23007) := '6E2E6C6F636174696F6E3F746869732E5F696E737461536572766963652E696E766F6B6546756E6374696F6E2855512C652C746869732E5F656469746F722C6E2E6C6F636174696F6E293A49772E6973286E2E636F6D6D616E6429262661776169742074';
wwv_flow_imp.g_varchar2_table(23008) := '6869732E5F696E766F6B65436F6D6D616E64286E2E636F6D6D616E642C742E6974656D297D7D2929292C657D5F676574496E6C696E6548696E7473466F7252616E67652865297B636F6E737420743D6E6577205365743B666F7228636F6E7374206E206F';
wwv_flow_imp.g_varchar2_table(23009) := '6620746869732E5F6465636F726174696F6E734D657461646174612E76616C756573282929652E636F6E7461696E7352616E6765286E2E6974656D2E616E63686F722E72616E6765292626742E616464286E2E6974656D293B72657475726E2041727261';
wwv_flow_imp.g_varchar2_table(23010) := '792E66726F6D2874297D5F696E7374616C6C44626C436C69636B476573747572652865297B72657475726E20746869732E5F656469746F722E6F6E4D6F757365557028286173796E6320743D3E7B69662832213D3D742E6576656E742E64657461696C29';
wwv_flow_imp.g_varchar2_table(23011) := '72657475726E3B636F6E7374206E3D746869732E5F676574496E6C617948696E744C6162656C506172742874293B6966286E262628742E6576656E742E70726576656E7444656661756C7428292C6177616974206E2E6974656D2E7265736F6C7665284D';
wwv_flow_imp.g_varchar2_table(23012) := '742E4E6F6E65292C6A68286E2E6974656D2E68696E742E7465787445646974732929297B636F6E737420743D6E2E6974656D2E68696E742E7465787445646974732E6D61702828653D3E6A712E7265706C6163652872682E6C69667428652E72616E6765';
wwv_flow_imp.g_varchar2_table(23013) := '292C652E746578742929293B746869732E5F656469746F722E6578656375746545646974732822696E6C617948696E742E64656661756C74222C74292C6528297D7D29297D5F696E7374616C6C436F6E746578744D656E7528297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(23014) := '69732E5F656469746F722E6F6E436F6E746578744D656E7528286173796E6320653D3E7B6966282128652E6576656E742E74617267657420696E7374616E63656F662048544D4C456C656D656E74292972657475726E3B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(23015) := '5F676574496E6C617948696E744C6162656C506172742865293B742626617761697420746869732E5F696E737461536572766963652E696E766F6B6546756E6374696F6E2824512C746869732E5F656469746F722C652E6576656E742E7461726765742C';
wwv_flow_imp.g_varchar2_table(23016) := '74297D29297D5F676574496E6C617948696E744C6162656C506172742865297B76617220743B69662836213D3D652E7461726765742E747970652972657475726E3B636F6E7374206E3D6E756C6C3D3D3D28743D652E7461726765742E64657461696C2E';
wwv_flow_imp.g_varchar2_table(23017) := '696E6A656374656454657874297C7C766F696420303D3D3D743F766F696420303A742E6F7074696F6E733B72657475726E206E20696E7374616E63656F662050432626286E756C6C3D3D6E3F766F696420303A6E2E61747461636865644461746129696E';
wwv_flow_imp.g_varchar2_table(23018) := '7374616E63656F66205A513F6E2E6174746163686564446174613A766F696420307D6173796E63205F696E766F6B65436F6D6D616E6428652C74297B766172206E3B7472797B617761697420746869732E5F636F6D6D616E64536572766963652E657865';
wwv_flow_imp.g_varchar2_table(23019) := '63757465436F6D6D616E6428652E69642C2E2E2E6E756C6C213D3D286E3D652E617267756D656E7473292626766F69642030213D3D6E3F6E3A5B5D297D63617463682865297B746869732E5F6E6F74696669636174696F6E536572766963652E6E6F7469';
wwv_flow_imp.g_varchar2_table(23020) := '6679287B73657665726974793A6F442E4572726F722C736F757263653A742E70726F76696465722E646973706C61794E616D652C6D6573736167653A657D297D7D5F636163686548696E7473466F7246617374526573746F72652865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(23021) := '743D746869732E5F636F7079496E6C617948696E74735769746843757272656E74416E63686F722865293B746869732E5F696E6C617948696E747343616368652E73657428652C74297D5F636F7079496E6C617948696E74735769746843757272656E74';
wwv_flow_imp.g_varchar2_table(23022) := '416E63686F722865297B636F6E737420743D6E6577204D61703B666F7228636F6E73745B6E2C695D6F6620746869732E5F6465636F726174696F6E734D65746164617461297B696628742E68617328692E6974656D2929636F6E74696E75653B636F6E73';
wwv_flow_imp.g_varchar2_table(23023) := '74206F3D652E6765744465636F726174696F6E52616E6765286E293B6966286F297B636F6E737420653D6E6577205971286F2C692E6974656D2E616E63686F722E646972656374696F6E292C6E3D692E6974656D2E77697468287B616E63686F723A657D';
wwv_flow_imp.g_varchar2_table(23024) := '293B742E73657428692E6974656D2C6E297D7D72657475726E2041727261792E66726F6D28742E76616C7565732829297D5F67657448696E747352616E67657328297B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C74';
wwv_flow_imp.g_varchar2_table(23025) := '3D746869732E5F656469746F722E67657456697369626C6552616E676573506C757356696577706F727441626F766542656C6F7728292C6E3D5B5D3B666F7228636F6E73742069206F6620742E736F72742872682E636F6D7061726552616E6765735573';
wwv_flow_imp.g_varchar2_table(23026) := '696E6753746172747329297B636F6E737420743D652E76616C696461746552616E6765286E657720726828692E73746172744C696E654E756D6265722D33302C692E7374617274436F6C756D6E2C692E656E644C696E654E756D6265722B33302C692E65';
wwv_flow_imp.g_varchar2_table(23027) := '6E64436F6C756D6E29293B30213D3D6E2E6C656E677468262672682E617265496E74657273656374696E674F72546F756368696E67286E5B6E2E6C656E6774682D315D2C74293F6E5B6E2E6C656E6774682D315D3D72682E706C757352616E6765286E5B';
wwv_flow_imp.g_varchar2_table(23028) := '6E2E6C656E6774682D315D2C74293A6E2E707573682874297D72657475726E206E7D5F75706461746548696E74734465636F7261746F727328652C74297B766172206E2C693B636F6E7374206F3D5B5D2C733D28652C742C6E2C692C73293D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(23029) := '737420723D7B636F6E74656E743A6E2C696E6C696E65436C6173734E616D65416666656374734C657474657253706163696E673A21302C696E6C696E65436C6173734E616D653A742E636C6173734E616D652C637572736F7253746F70733A692C617474';
wwv_flow_imp.g_varchar2_table(23030) := '6163686564446174613A737D3B6F2E70757368287B6974656D3A652C636C6173734E616D655265663A742C6465636F726174696F6E3A7B72616E67653A652E616E63686F722E72616E67652C6F7074696F6E733A7B6465736372697074696F6E3A22496E';
wwv_flow_imp.g_varchar2_table(23031) := '6C617948696E74222C73686F774966436F6C6C61707365643A652E616E63686F722E72616E67652E6973456D70747928292C636F6C6C617073654F6E5265706C616365456469743A21652E616E63686F722E72616E67652E6973456D70747928292C7374';
wwv_flow_imp.g_varchar2_table(23032) := '69636B696E6573733A302C5B652E616E63686F722E646972656374696F6E5D3A303D3D3D746869732E5F61637469766552656E6465724D6F64653F723A766F696420307D7D7D297D2C723D28652C74293D3E7B636F6E7374206E3D746869732E5F72756C';
wwv_flow_imp.g_varchar2_table(23033) := '65466163746F72792E637265617465436C6173734E616D65526566287B77696474683A28612F337C30292B227078222C646973706C61793A22696E6C696E652D626C6F636B227D293B7328652C6E2C22E2808A222C743F6B682E52696768743A6B682E4E';
wwv_flow_imp.g_varchar2_table(23034) := '6F6E65297D2C7B666F6E7453697A653A612C666F6E7446616D696C793A6C2C70616464696E673A632C6973556E69666F726D3A647D3D746869732E5F6765744C61796F7574496E666F28292C683D222D2D636F64652D656469746F72496E6C617948696E';
wwv_flow_imp.g_varchar2_table(23035) := '7473466F6E7446616D696C79223B746869732E5F656469746F722E676574436F6E7461696E6572446F6D4E6F646528292E7374796C652E73657450726F706572747928682C6C293B6C657420753D7B6C696E653A302C746F74616C4C656E3A307D3B666F';
wwv_flow_imp.g_varchar2_table(23036) := '7228636F6E73742065206F662074297B696628752E6C696E65213D3D652E616E63686F722E72616E67652E73746172744C696E654E756D626572262628753D7B6C696E653A652E616E63686F722E72616E67652E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(23037) := '746F74616C4C656E3A307D292C752E746F74616C4C656E3E4B512E5F4D41585F4C4142454C5F4C454E29636F6E74696E75653B652E68696E742E70616464696E674C65667426267228652C2131293B636F6E737420743D22737472696E67223D3D747970';
wwv_flow_imp.g_varchar2_table(23038) := '656F6620652E68696E742E6C6162656C3F5B7B6C6162656C3A652E68696E742E6C6162656C7D5D3A652E68696E742E6C6162656C3B666F72286C657420693D303B693C742E6C656E6774683B692B2B297B636F6E7374206F3D745B695D2C723D303D3D3D';
wwv_flow_imp.g_varchar2_table(23039) := '692C6C3D693D3D3D742E6C656E6774682D312C703D7B666F6E7453697A653A60247B617D7078602C666F6E7446616D696C793A6076617228247B687D292C20247B4B4C2E666F6E7446616D696C797D602C766572746963616C416C69676E3A643F226261';
wwv_flow_imp.g_varchar2_table(23040) := '73656C696E65223A226D6964646C65222C756E69636F6465426964693A2269736F6C617465227D3B6A6828652E68696E742E74657874456469747329262628702E637572736F723D2264656661756C7422292C746869732E5F66696C6C496E436F6C6F72';
wwv_flow_imp.g_varchar2_table(23041) := '7328702C652E68696E74292C286F2E636F6D6D616E647C7C6F2E6C6F636174696F6E292626286E756C6C3D3D3D286E3D746869732E5F616374697665496E6C617948696E7450617274297C7C766F696420303D3D3D6E3F766F696420303A6E2E70617274';
wwv_flow_imp.g_varchar2_table(23042) := '2E6974656D293D3D3D652626746869732E5F616374697665496E6C617948696E74506172742E706172742E696E6465783D3D3D69262628702E746578744465636F726174696F6E3D22756E6465726C696E65222C746869732E5F616374697665496E6C61';
wwv_flow_imp.g_varchar2_table(23043) := '7948696E74506172742E686173547269676765724D6F646966696572262628702E636F6C6F723D4F62286466292C702E637572736F723D22706F696E7465722229292C632626287226266C3F28702E70616464696E673D6031707820247B307C4D617468';
wwv_flow_imp.g_varchar2_table(23044) := '2E6D617828312C612F34297D7078602C702E626F726465725261646975733D28612F347C30292B22707822293A723F28702E70616464696E673D6031707820302031707820247B307C4D6174682E6D617828312C612F34297D7078602C702E626F726465';
wwv_flow_imp.g_varchar2_table(23045) := '725261646975733D60247B612F347C307D70782030203020247B612F347C307D707860293A6C3F28702E70616464696E673D6031707820247B307C4D6174682E6D617828312C612F34297D7078203170782030602C702E626F726465725261646975733D';
wwv_flow_imp.g_varchar2_table(23046) := '603020247B612F347C307D707820247B612F347C307D7078203060293A702E70616464696E673D22317078203020317078203022293B6C657420673D6F2E6C6162656C3B752E746F74616C4C656E2B3D672E6C656E6774683B6C6574206D3D21313B636F';
wwv_flow_imp.g_varchar2_table(23047) := '6E737420663D752E746F74616C4C656E2D4B512E5F4D41585F4C4142454C5F4C454E3B696628663E30262628673D672E736C69636528302C2D66292B22E280A6222C6D3D2130292C7328652C746869732E5F72756C65466163746F72792E637265617465';
wwv_flow_imp.g_varchar2_table(23048) := '436C6173734E616D655265662870292C672E7265706C616365282F5B205C745D2F672C22C2A022292C6C262621652E68696E742E70616464696E6752696768743F6B682E52696768743A6B682E4E6F6E652C6E6577205A5128652C6929292C6D29627265';
wwv_flow_imp.g_varchar2_table(23049) := '616B7D696628652E68696E742E70616464696E67526967687426267228652C2130292C6F2E6C656E6774683E4B512E5F4D41585F4445434F5241544F525329627265616B7D636F6E737420703D5B5D3B666F7228636F6E73745B742C6E5D6F6620746869';
wwv_flow_imp.g_varchar2_table(23050) := '732E5F6465636F726174696F6E734D65746164617461297B636F6E7374206F3D6E756C6C3D3D3D28693D746869732E5F656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D693F766F696420303A692E6765744465636F726174696F';
wwv_flow_imp.g_varchar2_table(23051) := '6E52616E67652874293B6F2626652E736F6D652828653D3E652E636F6E7461696E7352616E6765286F292929262628702E707573682874292C6E2E636C6173734E616D655265662E646973706F736528292C746869732E5F6465636F726174696F6E734D';
wwv_flow_imp.g_varchar2_table(23052) := '657461646174612E64656C657465287429297D636F6E737420673D48422E6361707475726528746869732E5F656469746F72293B746869732E5F656469746F722E6368616E67654465636F726174696F6E732828653D3E7B636F6E737420743D652E6465';
wwv_flow_imp.g_varchar2_table(23053) := '6C74614465636F726174696F6E7328702C6F2E6D61702828653D3E652E6465636F726174696F6E2929293B666F72286C657420653D303B653C742E6C656E6774683B652B2B297B636F6E7374206E3D6F5B655D3B746869732E5F6465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(23054) := '734D657461646174612E73657428745B655D2C6E297D7D29292C672E726573746F726528746869732E5F656469746F72297D5F66696C6C496E436F6C6F727328652C74297B742E6B696E643D3D3D4D772E506172616D657465723F28652E6261636B6772';
wwv_flow_imp.g_varchar2_table(23055) := '6F756E64436F6C6F723D4F62286B66292C652E636F6C6F723D4F6228786629293A742E6B696E643D3D3D4D772E547970653F28652E6261636B67726F756E64436F6C6F723D4F62285366292C652E636F6C6F723D4F6228436629293A28652E6261636B67';
wwv_flow_imp.g_varchar2_table(23056) := '726F756E64436F6C6F723D4F62287766292C652E636F6C6F723D4F6228796629297D5F6765744C61796F7574496E666F28297B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E28313431292C743D652E70616464696E672C6E';
wwv_flow_imp.g_varchar2_table(23057) := '3D746869732E5F656469746F722E6765744F7074696F6E283532292C693D746869732E5F656469746F722E6765744F7074696F6E283439293B6C6574206F3D652E666F6E7453697A653B28216F7C7C6F3C357C7C6F3E6E292626286F3D6E293B636F6E73';
wwv_flow_imp.g_varchar2_table(23058) := '7420733D652E666F6E7446616D696C797C7C693B72657475726E7B666F6E7453697A653A6F2C666F6E7446616D696C793A732C70616464696E673A742C6973556E69666F726D3A21742626733D3D3D6926266F3D3D3D6E7D7D5F72656D6F7665416C6C44';
wwv_flow_imp.g_varchar2_table(23059) := '65636F726174696F6E7328297B746869732E5F656469746F722E72656D6F76654465636F726174696F6E732841727261792E66726F6D28746869732E5F6465636F726174696F6E734D657461646174612E6B657973282929293B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(23060) := '65206F6620746869732E5F6465636F726174696F6E734D657461646174612E76616C756573282929652E636C6173734E616D655265662E646973706F736528293B746869732E5F6465636F726174696F6E734D657461646174612E636C65617228297D7D';
wwv_flow_imp.g_varchar2_table(23061) := '3B4A512E49443D22656469746F722E636F6E747269622E496E6C617948696E7473222C4A512E5F4D41585F4445434F5241544F52533D313530302C4A512E5F4D41585F4C4142454C5F4C454E3D34332C4A513D4B513D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(23062) := '2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D';
wwv_flow_imp.g_varchar2_table(23063) := '747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E';
wwv_flow_imp.g_varchar2_table(23064) := '6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928';
wwv_flow_imp.g_varchar2_table(23065) := '742C6E2C72292C727D285B475128312C7878292C475128322C6456292C475128332C5951292C475128342C7863292C475128352C7344292C475128362C7563295D2C4A51292C6B632E7265676973746572436F6D6D616E6428225F65786563757465496E';
wwv_flow_imp.g_varchar2_table(23066) := '6C617948696E7450726F7669646572222C286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E2C695D3D743B796C284E6F2E6973557269286E29292C796C2872682E69734952616E6765286929293B636F6E73747B696E6C617948696E74735072';
wwv_flow_imp.g_varchar2_table(23067) := '6F76696465723A6F7D3D652E676574287878292C733D617761697420652E676574287663292E6372656174654D6F64656C5265666572656E6365286E293B7472797B636F6E737420653D61776169742058712E637265617465286F2C732E6F626A656374';
wwv_flow_imp.g_varchar2_table(23068) := '2E74657874456469746F724D6F64656C2C5B72682E6C6966742869295D2C4D742E4E6F6E65292C743D652E6974656D732E6D61702828653D3E652E68696E7429293B72657475726E2073657454696D656F7574282828293D3E652E646973706F73652829';
wwv_flow_imp.g_varchar2_table(23069) := '292C30292C747D66696E616C6C797B732E646973706F736528297D7D29293B7661722065593D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C61737320745920657874656E6473';
wwv_flow_imp.g_varchar2_table(23070) := '204C717B636F6E7374727563746F7228652C742C6E2C69297B73757065722831302C742C652E6974656D2E616E63686F722E72616E67652C6E2C692C2130292C746869732E706172743D657D7D6C6574206E593D636C61737320657874656E6473207A71';
wwv_flow_imp.g_varchar2_table(23071) := '7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B737570657228652C742C6E2C732C612C692C6F292C746869732E5F7265736F6C766572536572766963653D722C746869732E686F7665724F7264696E616C3D367D7375676765';
wwv_flow_imp.g_varchar2_table(23072) := '7374486F766572416E63686F722865297B76617220743B696628214A512E67657428746869732E5F656469746F72292972657475726E206E756C6C3B69662836213D3D652E7461726765742E747970652972657475726E206E756C6C3B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(23073) := '3D6E756C6C3D3D3D28743D652E7461726765742E64657461696C2E696E6A656374656454657874297C7C766F696420303D3D3D743F766F696420303A742E6F7074696F6E733B72657475726E206E20696E7374616E63656F6620504326266E2E61747461';
wwv_flow_imp.g_varchar2_table(23074) := '636865644461746120696E7374616E63656F66205A513F6E6577207459286E2E6174746163686564446174612C746869732C652E6576656E742E706F73782C652E6576656E742E706F7379293A6E756C6C7D636F6D7075746553796E6328297B72657475';
wwv_flow_imp.g_varchar2_table(23075) := '726E5B5D7D636F6D707574654173796E6328652C742C6E297B72657475726E206520696E7374616E63656F662074593F6E657720656E28286173796E6320743D3E7B636F6E73747B706172743A697D3D653B696628617761697420692E6974656D2E7265';
wwv_flow_imp.g_varchar2_table(23076) := '736F6C7665286E292C6E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6C6574206F2C733B69662822737472696E67223D3D747970656F6620692E6974656D2E68696E742E746F6F6C7469703F6F3D286E6577206F6329';
wwv_flow_imp.g_varchar2_table(23077) := '2E617070656E645465787428692E6974656D2E68696E742E746F6F6C746970293A692E6974656D2E68696E742E746F6F6C7469702626286F3D692E6974656D2E68696E742E746F6F6C746970292C6F2626742E656D69744F6E65286E6577204271287468';
wwv_flow_imp.g_varchar2_table(23078) := '69732C652E72616E67652C5B6F5D2C21312C3029292C6A6828692E6974656D2E68696E742E746578744564697473292626742E656D69744F6E65286E657720427128746869732C652E72616E67652C5B286E6577206F63292E617070656E645465787428';
wwv_flow_imp.g_varchar2_table(23079) := '6228302C22446F75626C652D636C69636B20746F20696E736572742229295D2C21312C313030303129292C22737472696E67223D3D747970656F6620692E706172742E746F6F6C7469703F733D286E6577206F63292E617070656E645465787428692E70';
wwv_flow_imp.g_varchar2_table(23080) := '6172742E746F6F6C746970293A692E706172742E746F6F6C746970262628733D692E706172742E746F6F6C746970292C732626742E656D69744F6E65286E657720427128746869732C652E72616E67652C5B735D2C21312C3129292C692E706172742E6C';
wwv_flow_imp.g_varchar2_table(23081) := '6F636174696F6E7C7C692E706172742E636F6D6D616E64297B6C6574206E3B636F6E7374206F3D6228302C22616C744B6579223D3D3D746869732E5F656469746F722E6765744F7074696F6E283738293F713F22636D64202B20636C69636B223A226374';
wwv_flow_imp.g_varchar2_table(23082) := '726C202B20636C69636B223A713F226F7074696F6E202B20636C69636B223A22616C74202B20636C69636B22293B692E706172742E6C6F636174696F6E2626692E706172742E636F6D6D616E643F6E3D286E6577206F63292E617070656E645465787428';
wwv_flow_imp.g_varchar2_table(23083) := '6228302C22476F20746F20446566696E6974696F6E20287B307D292C20726967687420636C69636B20666F72206D6F7265222C6F29293A692E706172742E6C6F636174696F6E3F6E3D286E6577206F63292E617070656E6454657874286228302C22476F';
wwv_flow_imp.g_varchar2_table(23084) := '20746F20446566696E6974696F6E20287B307D29222C6F29293A692E706172742E636F6D6D616E642626286E3D6E6577206F6328605B247B6228302C224578656375746520436F6D6D616E6422297D5D28247B723D692E706172742E636F6D6D616E642C';
wwv_flow_imp.g_varchar2_table(23085) := '4E6F2E66726F6D287B736368656D653A716F2E636F6D6D616E642C706174683A722E69642C71756572793A722E617267756D656E74732626656E636F6465555249436F6D706F6E656E74284A534F4E2E737472696E6769667928722E617267756D656E74';
wwv_flow_imp.g_varchar2_table(23086) := '7329297D292E746F537472696E6728297D2022247B692E706172742E636F6D6D616E642E7469746C657D22292028247B6F7D29602C7B6973547275737465643A21307D29292C6E2626742E656D69744F6E65286E657720427128746869732C652E72616E';
wwv_flow_imp.g_varchar2_table(23087) := '67652C5B6E5D2C21312C31653429297D76617220723B636F6E737420613D617761697420746869732E5F7265736F6C7665496E6C617948696E744C6162656C50617274486F76657228692C6E293B666F7220617761697428636F6E73742065206F662061';
wwv_flow_imp.g_varchar2_table(23088) := '29742E656D69744F6E652865297D29293A656E2E454D5054597D6173796E63205F7265736F6C7665496E6C617948696E744C6162656C50617274486F76657228652C74297B69662821652E706172742E6C6F636174696F6E2972657475726E20656E2E45';
wwv_flow_imp.g_varchar2_table(23089) := '4D5054593B636F6E73747B7572693A6E2C72616E67653A697D3D652E706172742E6C6F636174696F6E2C6F3D617761697420746869732E5F7265736F6C766572536572766963652E6372656174654D6F64656C5265666572656E6365286E293B7472797B';
wwv_flow_imp.g_varchar2_table(23090) := '636F6E7374206E3D6F2E6F626A6563742E74657874456469746F724D6F64656C3B72657475726E20746869732E5F6C616E67756167654665617475726573536572766963652E686F76657250726F76696465722E686173286E293F4E7128746869732E5F';
wwv_flow_imp.g_varchar2_table(23091) := '6C616E67756167654665617475726573536572766963652E686F76657250726F76696465722C6E2C6E6577206D6328692E73746172744C696E654E756D6265722C692E7374617274436F6C756D6E292C74292E66696C7465722828653D3E21736328652E';
wwv_flow_imp.g_varchar2_table(23092) := '686F7665722E636F6E74656E74732929292E6D61702828743D3E6E657720427128746869732C652E6974656D2E616E63686F722E72616E67652C742E686F7665722E636F6E74656E74732C21312C322B742E6F7264696E616C2929293A656E2E454D5054';
wwv_flow_imp.g_varchar2_table(23093) := '597D66696E616C6C797B6F2E646973706F736528297D7D7D3B6E593D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E676574';
wwv_flow_imp.g_varchar2_table(23094) := '4F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C';
wwv_flow_imp.g_varchar2_table(23095) := '6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E2929';
wwv_flow_imp.g_varchar2_table(23096) := '7C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B655928312C4C75292C655928322C6445292C655928332C2445292C655928342C4971292C655928352C6670292C6559';
wwv_flow_imp.g_varchar2_table(23097) := '28362C7663292C655928372C7878295D2C6E59293B636C6173732069597B67657420616E63686F7228297B72657475726E20746869732E5F616E63686F727D73657420616E63686F722865297B746869732E5F616E63686F723D657D6765742073686F75';
wwv_flow_imp.g_varchar2_table(23098) := '6C64466F63757328297B72657475726E20746869732E5F73686F756C64466F6375737D7365742073686F756C64466F6375732865297B746869732E5F73686F756C64466F6375733D657D67657420736F7572636528297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(23099) := '736F757263657D73657420736F757263652865297B746869732E5F736F757263653D657D67657420696E736973744F6E4B656570696E67486F76657256697369626C6528297B72657475726E20746869732E5F696E736973744F6E4B656570696E67486F';
wwv_flow_imp.g_varchar2_table(23100) := '76657256697369626C657D73657420696E736973744F6E4B656570696E67486F76657256697369626C652865297B746869732E5F696E736973744F6E4B656570696E67486F76657256697369626C653D657D636F6E7374727563746F7228652C74297B74';
wwv_flow_imp.g_varchar2_table(23101) := '6869732E5F656469746F723D652C746869732E5F7061727469636970616E74733D742C746869732E5F616E63686F723D6E756C6C2C746869732E5F73686F756C64466F6375733D21312C746869732E5F736F757263653D302C746869732E5F696E736973';
wwv_flow_imp.g_varchar2_table(23102) := '744F6E4B656570696E67486F76657256697369626C653D21317D737461746963205F6765744C696E654465636F726174696F6E7328652C74297B69662831213D3D742E74797065262621742E737570706F7274734D61726B6572486F7665722972657475';
wwv_flow_imp.g_varchar2_table(23103) := '726E5B5D3B636F6E7374206E3D652E6765744D6F64656C28292C693D742E72616E67652E73746172744C696E654E756D6265723B696628693E6E2E6765744C696E65436F756E7428292972657475726E5B5D3B636F6E7374206F3D6E2E6765744C696E65';
wwv_flow_imp.g_varchar2_table(23104) := '4D6178436F6C756D6E2869293B72657475726E20652E6765744C696E654465636F726174696F6E732869292E66696C7465722828653D3E7B696628652E6F7074696F6E732E697357686F6C654C696E652972657475726E21303B636F6E7374206E3D652E';
wwv_flow_imp.g_varchar2_table(23105) := '72616E67652E73746172744C696E654E756D6265723D3D3D693F652E72616E67652E7374617274436F6C756D6E3A312C733D652E72616E67652E656E644C696E654E756D6265723D3D3D693F652E72616E67652E656E64436F6C756D6E3A6F3B69662865';
wwv_flow_imp.g_varchar2_table(23106) := '2E6F7074696F6E732E73686F774966436F6C6C6170736564297B6966286E3E742E72616E67652E7374617274436F6C756D6E2B317C7C742E72616E67652E656E64436F6C756D6E2D313E732972657475726E21317D656C7365206966286E3E742E72616E';
wwv_flow_imp.g_varchar2_table(23107) := '67652E7374617274436F6C756D6E7C7C742E72616E67652E656E64436F6C756D6E3E732972657475726E21313B72657475726E21307D29297D636F6D707574654173796E632865297B636F6E737420743D746869732E5F616E63686F723B696628217468';
wwv_flow_imp.g_varchar2_table(23108) := '69732E5F656469746F722E6861734D6F64656C28297C7C21742972657475726E20656E2E454D5054593B636F6E7374206E3D69592E5F6765744C696E654465636F726174696F6E7328746869732E5F656469746F722C74293B72657475726E20656E2E6D';
wwv_flow_imp.g_varchar2_table(23109) := '6572676528746869732E5F7061727469636970616E74732E6D61702828693D3E692E636F6D707574654173796E633F692E636F6D707574654173796E6328742C6E2C65293A656E2E454D5054592929297D636F6D7075746553796E6328297B6966282174';
wwv_flow_imp.g_varchar2_table(23110) := '6869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F616E63686F722972657475726E5B5D3B636F6E737420653D69592E5F6765744C696E654465636F726174696F6E7328746869732E5F656469746F722C746869732E5F616E63';
wwv_flow_imp.g_varchar2_table(23111) := '686F72293B6C657420743D5B5D3B666F7228636F6E7374206E206F6620746869732E5F7061727469636970616E747329743D742E636F6E636174286E2E636F6D7075746553796E6328746869732E5F616E63686F722C6529293B72657475726E207A6828';
wwv_flow_imp.g_varchar2_table(23112) := '74297D7D636C617373206F597B636F6E7374727563746F7228652C742C6E297B746869732E616E63686F723D652C746869732E6D657373616765733D742C746869732E6973436F6D706C6574653D6E7D66696C7465722865297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(23113) := '69732E6D657373616765732E66696C7465722828743D3E742E697356616C6964466F72486F766572416E63686F7228652929293B72657475726E20742E6C656E6774683D3D3D746869732E6D657373616765732E6C656E6774683F746869733A6E657720';
wwv_flow_imp.g_varchar2_table(23114) := '735928746869732C746869732E616E63686F722C742C746869732E6973436F6D706C657465297D7D636C61737320735920657874656E6473206F597B636F6E7374727563746F7228652C742C6E2C69297B737570657228742C6E2C69292C746869732E6F';
wwv_flow_imp.g_varchar2_table(23115) := '726967696E616C3D657D66696C7465722865297B72657475726E20746869732E6F726967696E616C2E66696C7465722865297D7D636C6173732072597B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C63297B746869732E69';
wwv_flow_imp.g_varchar2_table(23116) := '6E697469616C4D6F757365506F73583D652C746869732E696E697469616C4D6F757365506F73593D742C746869732E636F6C6F725069636B65723D6E2C746869732E73686F774174506F736974696F6E3D692C746869732E73686F7741745365636F6E64';
wwv_flow_imp.g_varchar2_table(23117) := '617279506F736974696F6E3D6F2C746869732E70726566657241626F76653D732C746869732E73746F6C65466F6375733D722C746869732E736F757263653D612C746869732E69734265666F7265436F6E74656E743D6C2C746869732E646973706F7361';
wwv_flow_imp.g_varchar2_table(23118) := '626C65733D632C746869732E636C6F736573744D6F75736544697374616E63653D766F696420307D7D636F6E73742061593D62723B6C6574206C593D636C61737320657874656E6473206C747B67657420686173436F6E74656E7428297B72657475726E';
wwv_flow_imp.g_varchar2_table(23119) := '20746869732E5F686173436F6E74656E747D636F6E7374727563746F722865297B737570657228292C746869732E5F6B657962696E64696E67536572766963653D652C746869732E5F686173436F6E74656E743D21312C746869732E686F766572456C65';
wwv_flow_imp.g_varchar2_table(23120) := '6D656E743D615928226469762E686F7665722D726F772E7374617475732D62617222292C746869732E686F766572456C656D656E742E746162496E6465783D302C746869732E616374696F6E73456C656D656E743D757228746869732E686F766572456C';
wwv_flow_imp.g_varchar2_table(23121) := '656D656E742C615928226469762E616374696F6E732229297D616464416374696F6E2865297B636F6E737420743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728652E636F6D6D616E644964292C';
wwv_flow_imp.g_varchar2_table(23122) := '6E3D743F742E6765744C6162656C28293A6E756C6C3B72657475726E20746869732E5F686173436F6E74656E743D21302C746869732E5F72656769737465722866712E72656E64657228746869732E616374696F6E73456C656D656E742C652C6E29297D';
wwv_flow_imp.g_varchar2_table(23123) := '617070656E642865297B636F6E737420743D757228746869732E616374696F6E73456C656D656E742C65293B72657475726E20746869732E5F686173436F6E74656E743D21302C747D7D3B6C593D66756E6374696F6E28652C742C6E2C69297B76617220';
wwv_flow_imp.g_varchar2_table(23124) := '6F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F662052';
wwv_flow_imp.g_varchar2_table(23125) := '65666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E';
wwv_flow_imp.g_varchar2_table(23126) := '3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C72';
wwv_flow_imp.g_varchar2_table(23127) := '7D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28302C2445295D2C6C59293B7661722063592C64593D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(23128) := '6E2C69297B74286E2C692C65297D7D3B6C65742068593D63593D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F656469746F723D652C746869732E5F696E7374616E746961';
wwv_flow_imp.g_varchar2_table(23129) := '74696F6E536572766963653D742C746869732E5F6B657962696E64696E67536572766963653D6E2C746869732E5F63757272656E74526573756C743D6E756C6C2C746869732E5F7769646765743D746869732E5F726567697374657228746869732E5F69';
wwv_flow_imp.g_varchar2_table(23130) := '6E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652843712C746869732E5F656469746F7229292C746869732E5F7061727469636970616E74733D5B5D3B666F7228636F6E73742065206F662044712E676574416C6C28';
wwv_flow_imp.g_varchar2_table(23131) := '29297B636F6E737420743D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528652C746869732E5F656469746F72293B7420696E7374616E63656F66207A71262621287420696E7374616E63656F66';
wwv_flow_imp.g_varchar2_table(23132) := '206E5929262628746869732E5F6D61726B646F776E486F7665725061727469636970616E743D74292C746869732E5F7061727469636970616E74732E707573682874297D746869732E5F7061727469636970616E74732E736F7274282828652C74293D3E';
wwv_flow_imp.g_varchar2_table(23133) := '652E686F7665724F7264696E616C2D742E686F7665724F7264696E616C29292C746869732E5F636F6D70757465723D6E657720695928746869732E5F656469746F722C746869732E5F7061727469636970616E7473292C746869732E5F686F7665724F70';
wwv_flow_imp.g_varchar2_table(23134) := '65726174696F6E3D746869732E5F7265676973746572286E6577206B7128746869732E5F656469746F722C746869732E5F636F6D707574657229292C746869732E5F726567697374657228746869732E5F686F7665724F7065726174696F6E2E6F6E5265';
wwv_flow_imp.g_varchar2_table(23135) := '73756C742828653D3E7B69662821746869732E5F636F6D70757465722E616E63686F722972657475726E3B636F6E737420743D652E6861734C6F6164696E674D6573736167653F746869732E5F6164644C6F6164696E674D65737361676528652E76616C';
wwv_flow_imp.g_varchar2_table(23136) := '7565293A652E76616C75653B746869732E5F77697468526573756C74286E6577206F5928746869732E5F636F6D70757465722E616E63686F722C742C652E6973436F6D706C65746529297D2929292C746869732E5F726567697374657228797328746869';
wwv_flow_imp.g_varchar2_table(23137) := '732E5F7769646765742E676574446F6D4E6F646528292C226B6579646F776E222C28653D3E7B652E657175616C732839292626746869732E6869646528297D2929292C746869732E5F72656769737465722850772E6F6E4469644368616E676528282829';
wwv_flow_imp.g_varchar2_table(23138) := '3D3E7B746869732E5F7769646765742E706F736974696F6E2626746869732E5F63757272656E74526573756C742626746869732E5F73657443757272656E74526573756C7428746869732E5F63757272656E74526573756C74297D2929297D5F73746172';
wwv_flow_imp.g_varchar2_table(23139) := '7453686F77696E674F72557064617465486F76657228652C742C6E2C692C6F297B72657475726E20746869732E5F7769646765742E706F736974696F6E2626746869732E5F63757272656E74526573756C743F746869732E5F656469746F722E6765744F';
wwv_flow_imp.g_varchar2_table(23140) := '7074696F6E283630292E737469636B7926266F2626746869732E5F7769646765742E69734D6F75736547657474696E67436C6F736572286F2E6576656E742E706F73782C6F2E6576656E742E706F7379293F28652626746869732E5F7374617274486F76';
wwv_flow_imp.g_varchar2_table(23141) := '65724F7065726174696F6E49664E656365737361727928652C742C6E2C692C2130292C2130293A653F212821657C7C21746869732E5F63757272656E74526573756C742E616E63686F722E657175616C73286529297C7C28652E63616E41646F70745669';
wwv_flow_imp.g_varchar2_table(23142) := '7369626C65486F76657228746869732E5F63757272656E74526573756C742E616E63686F722C746869732E5F7769646765742E706F736974696F6E293F28746869732E5F73657443757272656E74526573756C7428746869732E5F63757272656E745265';
wwv_flow_imp.g_varchar2_table(23143) := '73756C742E66696C746572286529292C746869732E5F7374617274486F7665724F7065726174696F6E49664E656365737361727928652C742C6E2C692C2131292C2130293A28746869732E5F73657443757272656E74526573756C74286E756C6C292C74';
wwv_flow_imp.g_varchar2_table(23144) := '6869732E5F7374617274486F7665724F7065726174696F6E49664E656365737361727928652C742C6E2C692C2131292C213029293A28746869732E5F73657443757272656E74526573756C74286E756C6C292C2131293A212165262628746869732E5F73';
wwv_flow_imp.g_varchar2_table(23145) := '74617274486F7665724F7065726174696F6E49664E656365737361727928652C742C6E2C692C2131292C2130297D5F7374617274486F7665724F7065726174696F6E49664E656365737361727928652C742C6E2C692C6F297B746869732E5F636F6D7075';
wwv_flow_imp.g_varchar2_table(23146) := '7465722E616E63686F722626746869732E5F636F6D70757465722E616E63686F722E657175616C732865297C7C28746869732E5F686F7665724F7065726174696F6E2E63616E63656C28292C746869732E5F636F6D70757465722E616E63686F723D652C';
wwv_flow_imp.g_varchar2_table(23147) := '746869732E5F636F6D70757465722E73686F756C64466F6375733D692C746869732E5F636F6D70757465722E736F757263653D6E2C746869732E5F636F6D70757465722E696E736973744F6E4B656570696E67486F76657256697369626C653D6F2C7468';
wwv_flow_imp.g_varchar2_table(23148) := '69732E5F686F7665724F7065726174696F6E2E7374617274287429297D5F73657443757272656E74526573756C742865297B746869732E5F63757272656E74526573756C74213D3D65262628652626303D3D3D652E6D657373616765732E6C656E677468';
wwv_flow_imp.g_varchar2_table(23149) := '262628653D6E756C6C292C746869732E5F63757272656E74526573756C743D652C746869732E5F63757272656E74526573756C743F746869732E5F72656E6465724D6573736167657328746869732E5F63757272656E74526573756C742E616E63686F72';
wwv_flow_imp.g_varchar2_table(23150) := '2C746869732E5F63757272656E74526573756C742E6D65737361676573293A746869732E5F7769646765742E686964652829297D5F6164644C6F6164696E674D6573736167652865297B696628746869732E5F636F6D70757465722E616E63686F722966';
wwv_flow_imp.g_varchar2_table(23151) := '6F7228636F6E73742074206F6620746869732E5F7061727469636970616E747329696628742E6372656174654C6F6164696E674D657373616765297B636F6E7374206E3D742E6372656174654C6F6164696E674D65737361676528746869732E5F636F6D';
wwv_flow_imp.g_varchar2_table(23152) := '70757465722E616E63686F72293B6966286E2972657475726E20652E736C6963652830292E636F6E636174285B6E5D297D72657475726E20657D5F77697468526573756C742865297B696628746869732E5F7769646765742E706F736974696F6E262674';
wwv_flow_imp.g_varchar2_table(23153) := '6869732E5F63757272656E74526573756C742626746869732E5F63757272656E74526573756C742E6973436F6D706C657465297B69662821652E6973436F6D706C6574652972657475726E3B696628746869732E5F636F6D70757465722E696E73697374';
wwv_flow_imp.g_varchar2_table(23154) := '4F6E4B656570696E67486F76657256697369626C652626303D3D3D652E6D657373616765732E6C656E6774682972657475726E7D746869732E5F73657443757272656E74526573756C742865297D5F72656E6465724D6573736167657328652C74297B63';
wwv_flow_imp.g_varchar2_table(23155) := '6F6E73747B73686F774174506F736974696F6E3A6E2C73686F7741745365636F6E64617279506F736974696F6E3A692C686967686C6967687452616E67653A6F7D3D63592E636F6D70757465486F76657252616E67657328746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(23156) := '2C652E72616E67652C74292C733D6E65772061742C723D732E616464286E6577206C5928746869732E5F6B657962696E64696E675365727669636529292C613D646F63756D656E742E637265617465446F63756D656E74467261676D656E7428293B6C65';
wwv_flow_imp.g_varchar2_table(23157) := '74206C3D6E756C6C3B636F6E737420633D7B667261676D656E743A612C7374617475734261723A722C736574436F6C6F725069636B65723A653D3E6C3D652C6F6E436F6E74656E74734368616E6765643A28293D3E746869732E5F7769646765742E6F6E';
wwv_flow_imp.g_varchar2_table(23158) := '436F6E74656E74734368616E67656428292C7365744D696E696D756D44696D656E73696F6E733A653D3E746869732E5F7769646765742E7365744D696E696D756D44696D656E73696F6E732865292C686964653A28293D3E746869732E6869646528297D';
wwv_flow_imp.g_varchar2_table(23159) := '3B666F7228636F6E73742065206F6620746869732E5F7061727469636970616E7473297B636F6E7374206E3D742E66696C7465722828743D3E742E6F776E65723D3D3D6529293B6E2E6C656E6774683E302626732E61646428652E72656E646572486F76';
wwv_flow_imp.g_varchar2_table(23160) := '6572506172747328632C6E29297D636F6E737420643D742E736F6D652828653D3E652E69734265666F7265436F6E74656E7429293B696628722E686173436F6E74656E742626612E617070656E644368696C6428722E686F766572456C656D656E74292C';
wwv_flow_imp.g_varchar2_table(23161) := '612E6861734368696C644E6F6465732829297B6966286F297B636F6E737420653D746869732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28293B652E736574285B7B72616E67653A6F2C6F7074696F6E733A';
wwv_flow_imp.g_varchar2_table(23162) := '63592E5F4445434F524154494F4E5F4F5054494F4E537D5D292C732E616464287274282828293D3E7B652E636C65617228297D2929297D746869732E5F7769646765742E73686F77417428612C6E657720725928652E696E697469616C4D6F757365506F';
wwv_flow_imp.g_varchar2_table(23163) := '73582C652E696E697469616C4D6F757365506F73592C6C2C6E2C692C746869732E5F656469746F722E6765744F7074696F6E283630292E61626F76652C746869732E5F636F6D70757465722E73686F756C64466F6375732C746869732E5F636F6D707574';
wwv_flow_imp.g_varchar2_table(23164) := '65722E736F757263652C642C7329297D656C736520732E646973706F736528297D73746174696320636F6D70757465486F76657252616E67657328652C742C6E297B6C657420693D313B696628652E6861734D6F64656C2829297B636F6E7374206E3D65';
wwv_flow_imp.g_varchar2_table(23165) := '2E5F676574566965774D6F64656C28292C6F3D6E2E636F6F7264696E61746573436F6E7665727465722C733D6F2E636F6E766572744D6F64656C52616E6765546F5669657752616E67652874292C723D6E6577206D6328732E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(23166) := '6D6265722C6E2E6765744C696E654D696E436F6C756D6E28732E73746172744C696E654E756D62657229293B693D6F2E636F6E7665727456696577506F736974696F6E546F4D6F64656C506F736974696F6E2872292E636F6C756D6E7D636F6E7374206F';
wwv_flow_imp.g_varchar2_table(23167) := '3D742E73746172744C696E654E756D6265723B6C657420733D742E7374617274436F6C756D6E2C723D6E5B305D2E72616E67652C613D6E756C6C3B666F7228636F6E73742065206F66206E29723D72682E706C757352616E676528722C652E72616E6765';
wwv_flow_imp.g_varchar2_table(23168) := '292C652E72616E67652E73746172744C696E654E756D6265723D3D3D6F2626652E72616E67652E656E644C696E654E756D6265723D3D3D6F262628733D4D6174682E6D6178284D6174682E6D696E28732C652E72616E67652E7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(23169) := '292C6929292C652E666F72636553686F77417452616E6765262628613D652E72616E6765293B72657475726E7B73686F774174506F736974696F6E3A613F612E6765745374617274506F736974696F6E28293A6E6577206D63286F2C742E737461727443';
wwv_flow_imp.g_varchar2_table(23170) := '6F6C756D6E292C73686F7741745365636F6E64617279506F736974696F6E3A613F612E6765745374617274506F736974696F6E28293A6E6577206D63286F2C73292C686967686C6967687452616E67653A727D7D73686F77734F7257696C6C53686F7728';
wwv_flow_imp.g_varchar2_table(23171) := '65297B696628746869732E5F7769646765742E6973526573697A696E672972657475726E21303B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620746869732E5F7061727469636970616E7473296966286E2E73756767657374486F7665';
wwv_flow_imp.g_varchar2_table(23172) := '72416E63686F72297B636F6E737420693D6E2E73756767657374486F766572416E63686F722865293B692626742E707573682869297D636F6E7374206E3D652E7461726765743B696628363D3D3D6E2E747970652626742E70757368286E657720457128';
wwv_flow_imp.g_varchar2_table(23173) := '302C6E2E72616E67652C652E6576656E742E706F73782C652E6576656E742E706F737929292C373D3D3D6E2E74797065297B636F6E737420693D746869732E5F656469746F722E6765744F7074696F6E283530292E7479706963616C48616C6677696474';
wwv_flow_imp.g_varchar2_table(23174) := '6843686172616374657257696474682F323B216E2E64657461696C2E697341667465724C696E65732626226E756D626572223D3D747970656F66206E2E64657461696C2E686F72697A6F6E74616C44697374616E6365546F5465787426266E2E64657461';
wwv_flow_imp.g_varchar2_table(23175) := '696C2E686F72697A6F6E74616C44697374616E6365546F546578743C692626742E70757368286E657720457128302C6E2E72616E67652C652E6576656E742E706F73782C652E6576656E742E706F737929297D72657475726E20303D3D3D742E6C656E67';
wwv_flow_imp.g_varchar2_table(23176) := '74683F746869732E5F737461727453686F77696E674F72557064617465486F766572286E756C6C2C302C302C21312C65293A28742E736F7274282828652C74293D3E742E7072696F726974792D652E7072696F7269747929292C746869732E5F73746172';
wwv_flow_imp.g_varchar2_table(23177) := '7453686F77696E674F72557064617465486F76657228745B305D2C302C302C21312C6529297D737461727453686F77696E67417452616E676528652C742C6E2C69297B746869732E5F737461727453686F77696E674F72557064617465486F766572286E';
wwv_flow_imp.g_varchar2_table(23178) := '657720457128302C652C766F696420302C766F69642030292C742C6E2C692C6E756C6C297D6173796E6320757064617465466F63757365644D61726B646F776E486F766572566572626F736974794C6576656C2865297B76617220743B6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(23179) := '28743D746869732E5F6D61726B646F776E486F7665725061727469636970616E74297C7C766F696420303D3D3D747C7C742E757064617465466F63757365644D61726B646F776E486F76657250617274566572626F736974794C6576656C2865297D636F';
wwv_flow_imp.g_varchar2_table(23180) := '6E7461696E734E6F64652865297B72657475726E2121652626746869732E5F7769646765742E676574446F6D4E6F646528292E636F6E7461696E732865297D666F63757328297B746869732E5F7769646765742E666F63757328297D7363726F6C6C5570';
wwv_flow_imp.g_varchar2_table(23181) := '28297B746869732E5F7769646765742E7363726F6C6C557028297D7363726F6C6C446F776E28297B746869732E5F7769646765742E7363726F6C6C446F776E28297D7363726F6C6C4C65667428297B746869732E5F7769646765742E7363726F6C6C4C65';
wwv_flow_imp.g_varchar2_table(23182) := '667428297D7363726F6C6C526967687428297B746869732E5F7769646765742E7363726F6C6C526967687428297D70616765557028297B746869732E5F7769646765742E70616765557028297D70616765446F776E28297B746869732E5F776964676574';
wwv_flow_imp.g_varchar2_table(23183) := '2E70616765446F776E28297D676F546F546F7028297B746869732E5F7769646765742E676F546F546F7028297D676F546F426F74746F6D28297B746869732E5F7769646765742E676F546F426F74746F6D28297D6869646528297B746869732E5F636F6D';
wwv_flow_imp.g_varchar2_table(23184) := '70757465722E616E63686F723D6E756C6C2C746869732E5F686F7665724F7065726174696F6E2E63616E63656C28292C746869732E5F73657443757272656E74526573756C74286E756C6C297D676574206973436F6C6F725069636B657256697369626C';
wwv_flow_imp.g_varchar2_table(23185) := '6528297B72657475726E20746869732E5F7769646765742E6973436F6C6F725069636B657256697369626C657D67657420697356697369626C6546726F6D4B6579626F61726428297B72657475726E20746869732E5F7769646765742E69735669736962';
wwv_flow_imp.g_varchar2_table(23186) := '6C6546726F6D4B6579626F6172647D67657420697356697369626C6528297B72657475726E20746869732E5F7769646765742E697356697369626C657D676574206973466F637573656428297B72657475726E20746869732E5F7769646765742E697346';
wwv_flow_imp.g_varchar2_table(23187) := '6F63757365647D676574206973526573697A696E6728297B72657475726E20746869732E5F7769646765742E6973526573697A696E677D6765742077696467657428297B72657475726E20746869732E5F7769646765747D7D3B68592E5F4445434F5241';
wwv_flow_imp.g_varchar2_table(23188) := '54494F4E5F4F5054494F4E533D4F432E7265676973746572287B6465736372697074696F6E3A22636F6E74656E742D686F7665722D686967686C69676874222C636C6173734E616D653A22686F766572486967686C69676874227D292C68593D63593D66';
wwv_flow_imp.g_varchar2_table(23189) := '756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B';
wwv_flow_imp.g_varchar2_table(23190) := '696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F';
wwv_flow_imp.g_varchar2_table(23191) := '722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E6465';
wwv_flow_imp.g_varchar2_table(23192) := '66696E6550726F706572747928742C6E2C72292C727D285B645928312C7563292C645928322C2445295D2C6859293B7661722075593D6E28323435292C70593D7B7D3B70592E7374796C655461675472616E73666F726D3D6A7228292C70592E73657441';
wwv_flow_imp.g_varchar2_table(23193) := '7474726962757465733D567228292C70592E696E736572743D467228292E62696E64286E756C6C2C226865616422292C70592E646F6D4150493D4F7228292C70592E696E736572745374796C65456C656D656E743D487228292C4E7228292875592E412C';
wwv_flow_imp.g_varchar2_table(23194) := '7059292C75592E41262675592E412E6C6F63616C73262675592E412E6C6F63616C733B636C6173732067597B676574206C696E654E756D62657228297B72657475726E20746869732E5F6C696E654E756D6265727D736574206C696E654E756D62657228';
wwv_flow_imp.g_varchar2_table(23195) := '65297B746869732E5F6C696E654E756D6265723D657D676574206C616E6528297B72657475726E20746869732E5F6C616E654F724C696E657D736574206C616E652865297B746869732E5F6C616E654F724C696E653D657D636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(23196) := '65297B746869732E5F656469746F723D652C746869732E5F6C696E654E756D6265723D2D312C746869732E5F6C616E654F724C696E653D78682E43656E7465727D636F6D7075746553796E6328297B76617220652C743B636F6E7374206E3D653D3E287B';
wwv_flow_imp.g_varchar2_table(23197) := '76616C75653A657D292C693D746869732E5F656469746F722E6765744C696E654465636F726174696F6E7328746869732E5F6C696E654E756D626572292C6F3D5B5D2C733D226C696E654E6F223D3D3D746869732E5F6C616E654F724C696E653B696628';
wwv_flow_imp.g_varchar2_table(23198) := '21692972657475726E206F3B666F7228636F6E73742072206F662069297B636F6E737420693D6E756C6C213D3D28743D6E756C6C3D3D3D28653D722E6F7074696F6E732E676C7970684D617267696E297C7C766F696420303D3D3D653F766F696420303A';
wwv_flow_imp.g_varchar2_table(23199) := '652E706F736974696F6E292626766F69642030213D3D743F743A78682E43656E7465723B6966282173262669213D3D746869732E5F6C616E654F724C696E6529636F6E74696E75653B636F6E737420613D733F722E6F7074696F6E732E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(23200) := '626572486F7665724D6573736167653A722E6F7074696F6E732E676C7970684D617267696E486F7665724D6573736167653B61262621736328612926266F2E70757368282E2E2E5A682861292E6D6170286E29297D72657475726E206F7D7D636F6E7374';
wwv_flow_imp.g_varchar2_table(23201) := '206D593D62723B636C61737320665920657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F72656E646572446973706F736561626C65733D746869732E5F7265676973746572286E6577206174';
wwv_flow_imp.g_varchar2_table(23202) := '292C746869732E5F656469746F723D652C746869732E5F697356697369626C653D21312C746869732E5F6D657373616765733D5B5D2C746869732E5F686F7665723D746869732E5F7265676973746572286E6577206D71292C746869732E5F686F766572';
wwv_flow_imp.g_varchar2_table(23203) := '2E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E746F67676C65282268696464656E222C21746869732E5F697356697369626C65292C746869732E5F6D61726B646F776E52656E64657265723D746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(23204) := '6E6577207045287B656469746F723A746869732E5F656469746F727D2C742C6E29292C746869732E5F636F6D70757465723D6E657720675928746869732E5F656469746F72292C746869732E5F686F7665724F7065726174696F6E3D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(23205) := '676973746572286E6577206B7128746869732E5F656469746F722C746869732E5F636F6D707574657229292C746869732E5F726567697374657228746869732E5F686F7665724F7065726174696F6E2E6F6E526573756C742828653D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(23206) := '77697468526573756C7428652E76616C7565297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4465636F726174696F6E73282828293D3E746869732E5F6F6E4D6F64656C4465';
wwv_flow_imp.g_varchar2_table(23207) := '636F726174696F6E734368616E67656428292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E6765642835302926267468';
wwv_flow_imp.g_varchar2_table(23208) := '69732E5F757064617465466F6E7428297D2929292C746869732E5F656469746F722E6164644F7665726C61795769646765742874686973297D646973706F736528297B746869732E5F656469746F722E72656D6F76654F7665726C617957696467657428';
wwv_flow_imp.g_varchar2_table(23209) := '74686973292C73757065722E646973706F736528297D676574496428297B72657475726E2066592E49447D676574446F6D4E6F646528297B72657475726E20746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64657D676574506F736974';
wwv_flow_imp.g_varchar2_table(23210) := '696F6E28297B72657475726E206E756C6C7D5F757064617465466F6E7428297B41727261792E70726F746F747970652E736C6963652E63616C6C28746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E676574456C656D656E74734279';
wwv_flow_imp.g_varchar2_table(23211) := '436C6173734E616D652822636F64652229292E666F72456163682828653D3E746869732E5F656469746F722E6170706C79466F6E74496E666F28652929297D5F6F6E4D6F64656C4465636F726174696F6E734368616E67656428297B746869732E5F6973';
wwv_flow_imp.g_varchar2_table(23212) := '56697369626C65262628746869732E5F686F7665724F7065726174696F6E2E63616E63656C28292C746869732E5F686F7665724F7065726174696F6E2E7374617274283029297D73686F77734F7257696C6C53686F772865297B636F6E737420743D652E';
wwv_flow_imp.g_varchar2_table(23213) := '7461726765743B72657475726E20323D3D3D742E747970652626742E64657461696C2E676C7970684D617267696E4C616E653F28746869732E5F737461727453686F77696E67417428742E706F736974696F6E2E6C696E654E756D6265722C742E646574';
wwv_flow_imp.g_varchar2_table(23214) := '61696C2E676C7970684D617267696E4C616E65292C2130293A333D3D3D742E74797065262628746869732E5F737461727453686F77696E67417428742E706F736974696F6E2E6C696E654E756D6265722C226C696E654E6F22292C2130297D5F73746172';
wwv_flow_imp.g_varchar2_table(23215) := '7453686F77696E67417428652C74297B746869732E5F636F6D70757465722E6C696E654E756D6265723D3D3D652626746869732E5F636F6D70757465722E6C616E653D3D3D747C7C28746869732E5F686F7665724F7065726174696F6E2E63616E63656C';
wwv_flow_imp.g_varchar2_table(23216) := '28292C746869732E6869646528292C746869732E5F636F6D70757465722E6C696E654E756D6265723D652C746869732E5F636F6D70757465722E6C616E653D742C746869732E5F686F7665724F7065726174696F6E2E7374617274283029297D68696465';
wwv_flow_imp.g_varchar2_table(23217) := '28297B746869732E5F636F6D70757465722E6C696E654E756D6265723D2D312C746869732E5F686F7665724F7065726174696F6E2E63616E63656C28292C746869732E5F697356697369626C65262628746869732E5F697356697369626C653D21312C74';
wwv_flow_imp.g_varchar2_table(23218) := '6869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E746F67676C65282268696464656E222C21746869732E5F697356697369626C6529297D5F77697468526573756C742865297B746869732E5F6D6573736167';
wwv_flow_imp.g_varchar2_table(23219) := '65733D652C746869732E5F6D657373616765732E6C656E6774683E303F746869732E5F72656E6465724D6573736167657328746869732E5F636F6D70757465722E6C696E654E756D6265722C746869732E5F6D65737361676573293A746869732E686964';
wwv_flow_imp.g_varchar2_table(23220) := '6528297D5F72656E6465724D6573736167657328652C74297B746869732E5F72656E646572446973706F736561626C65732E636C65617228293B636F6E7374206E3D646F63756D656E742E637265617465446F63756D656E74467261676D656E7428293B';
wwv_flow_imp.g_varchar2_table(23221) := '666F7228636F6E73742065206F662074297B636F6E737420743D6D5928226469762E686F7665722D726F772E6D61726B646F776E2D686F76657222292C693D757228742C6D5928226469762E686F7665722D636F6E74656E74732229292C6F3D74686973';
wwv_flow_imp.g_varchar2_table(23222) := '2E5F72656E646572446973706F736561626C65732E61646428746869732E5F6D61726B646F776E52656E64657265722E72656E64657228652E76616C756529293B692E617070656E644368696C64286F2E656C656D656E74292C6E2E617070656E644368';
wwv_flow_imp.g_varchar2_table(23223) := '696C642874297D746869732E5F757064617465436F6E74656E7473286E292C746869732E5F73686F7741742865297D5F757064617465436F6E74656E74732865297B746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E74657874436F';
wwv_flow_imp.g_varchar2_table(23224) := '6E74656E743D22222C746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E617070656E644368696C642865292C746869732E5F757064617465466F6E7428297D5F73686F7741742865297B746869732E5F697356697369626C657C7C28';
wwv_flow_imp.g_varchar2_table(23225) := '746869732E5F697356697369626C653D21302C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E746F67676C65282268696464656E222C21746869732E5F697356697369626C6529293B636F6E73742074';
wwv_flow_imp.g_varchar2_table(23226) := '3D746869732E5F656469746F722E6765744C61796F7574496E666F28292C6E3D746869732E5F656469746F722E676574546F70466F724C696E654E756D6265722865292C693D746869732E5F656469746F722E6765745363726F6C6C546F7028292C6F3D';
wwv_flow_imp.g_varchar2_table(23227) := '746869732E5F656469746F722E6765744F7074696F6E283637292C733D6E2D692D28746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E744865696768742D6F292F322C723D742E676C7970684D617267696E4C656674';
wwv_flow_imp.g_varchar2_table(23228) := '2B742E676C7970684D617267696E57696474682B28226C696E654E6F223D3D3D746869732E5F636F6D70757465722E6C616E653F742E6C696E654E756D6265727357696474683A30293B746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F';
wwv_flow_imp.g_varchar2_table(23229) := '64652E7374796C652E6C6566743D60247B727D7078602C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E746F703D60247B4D6174682E6D6178284D6174682E726F756E642873292C30297D7078607D7D66592E49';
wwv_flow_imp.g_varchar2_table(23230) := '443D22656469746F722E636F6E747269622E6D6F646573476C797068486F766572576964676574223B7661722076592C62593D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574';
wwv_flow_imp.g_varchar2_table(23231) := '205F593D76593D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F656469746F723D652C746869732E5F696E7374616E74696174696F6E536572766963653D742C746869732E';
wwv_flow_imp.g_varchar2_table(23232) := '5F6B657962696E64696E67536572766963653D6E2C746869732E5F6C697374656E65727353746F72653D6E65772061742C746869732E5F686F76657253746174653D7B6D6F757365446F776E3A21312C61637469766174656442794465636F7261746F72';
wwv_flow_imp.g_varchar2_table(23233) := '436C69636B3A21317D2C746869732E5F7265616374546F456469746F724D6F7573654D6F766552756E6E65723D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F7265616374546F456469746F724D6F7573654D6F7665';
wwv_flow_imp.g_varchar2_table(23234) := '28746869732E5F6D6F7573654D6F76654576656E7429292C3029292C746869732E5F686F6F6B4C697374656E65727328292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(23235) := '6F6E2828653D3E7B652E6861734368616E67656428363029262628746869732E5F756E686F6F6B4C697374656E65727328292C746869732E5F686F6F6B4C697374656E6572732829297D2929297D737461746963206765742865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(23236) := '2E676574436F6E747269627574696F6E2876592E4944297D5F686F6F6B4C697374656E65727328297B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E283630293B746869732E5F686F76657253657474696E67733D7B656E61';
wwv_flow_imp.g_varchar2_table(23237) := '626C65643A652E656E61626C65642C737469636B793A652E737469636B792C686964696E6744656C61793A652E64656C61797D2C652E656E61626C65643F28746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(23238) := '2E6F6E4D6F757365446F776E2828653D3E746869732E5F6F6E456469746F724D6F757365446F776E2865292929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4D6F7573655570282828293D3E';
wwv_flow_imp.g_varchar2_table(23239) := '746869732E5F6F6E456469746F724D6F757365557028292929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4D6F7573654D6F76652828653D3E746869732E5F6F6E456469746F724D6F757365';
wwv_flow_imp.g_varchar2_table(23240) := '4D6F76652865292929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4B6579446F776E2828653D3E746869732E5F6F6E4B6579446F776E286529292929293A28746869732E5F6C697374656E65';
wwv_flow_imp.g_varchar2_table(23241) := '727353746F72652E61646428746869732E5F656469746F722E6F6E4D6F7573654D6F76652828653D3E746869732E5F6F6E456469746F724D6F7573654D6F76652865292929292C746869732E5F6C697374656E65727353746F72652E6164642874686973';
wwv_flow_imp.g_varchar2_table(23242) := '2E5F656469746F722E6F6E4B6579446F776E2828653D3E746869732E5F6F6E4B6579446F776E286529292929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4D6F7573654C656176652828653D';
wwv_flow_imp.g_varchar2_table(23243) := '3E746869732E5F6F6E456469746F724D6F7573654C656176652865292929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F63';
wwv_flow_imp.g_varchar2_table(23244) := '616E63656C5363686564756C657228292C746869732E5F686964655769646765747328297D2929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E7465';
wwv_flow_imp.g_varchar2_table(23245) := '6E74282828293D3E746869732E5F63616E63656C5363686564756C657228292929292C746869732E5F6C697374656E65727353746F72652E61646428746869732E5F656469746F722E6F6E4469645363726F6C6C4368616E67652828653D3E746869732E';
wwv_flow_imp.g_varchar2_table(23246) := '5F6F6E456469746F725363726F6C6C4368616E6765642865292929297D5F756E686F6F6B4C697374656E65727328297B746869732E5F6C697374656E65727353746F72652E636C65617228297D5F63616E63656C5363686564756C657228297B74686973';
wwv_flow_imp.g_varchar2_table(23247) := '2E5F6D6F7573654D6F76654576656E743D766F696420302C746869732E5F7265616374546F456469746F724D6F7573654D6F766552756E6E65722E63616E63656C28297D5F6F6E456469746F725363726F6C6C4368616E6765642865297B28652E736372';
wwv_flow_imp.g_varchar2_table(23248) := '6F6C6C546F704368616E6765647C7C652E7363726F6C6C4C6566744368616E676564292626746869732E5F686964655769646765747328297D5F6F6E456469746F724D6F757365446F776E2865297B746869732E5F686F76657253746174652E6D6F7573';
wwv_flow_imp.g_varchar2_table(23249) := '65446F776E3D21302C746869732E5F73686F756C644E6F744869646543757272656E74486F7665725769646765742865297C7C746869732E5F686964655769646765747328297D5F73686F756C644E6F744869646543757272656E74486F766572576964';
wwv_flow_imp.g_varchar2_table(23250) := '6765742865297B72657475726E212128746869732E5F69734D6F7573654F6E436F6E74656E74486F7665725769646765742865297C7C746869732E5F69734D6F7573654F6E4D617267696E486F7665725769646765742865297C7C746869732E5F697343';
wwv_flow_imp.g_varchar2_table(23251) := '6F6E74656E74576964676574526573697A696E672829297D5F69734D6F7573654F6E4D617267696E486F7665725769646765742865297B636F6E737420743D652E7461726765743B72657475726E212174262631323D3D3D742E747970652626742E6465';
wwv_flow_imp.g_varchar2_table(23252) := '7461696C3D3D3D66592E49447D5F69734D6F7573654F6E436F6E74656E74486F7665725769646765742865297B636F6E737420743D652E7461726765743B72657475726E2121742626393D3D3D742E747970652626742E64657461696C3D3D3D43712E49';
wwv_flow_imp.g_varchar2_table(23253) := '447D5F6F6E456469746F724D6F757365557028297B746869732E5F686F76657253746174652E6D6F757365446F776E3D21317D5F6F6E456469746F724D6F7573654C656176652865297B746869732E5F63616E63656C5363686564756C657228292C7468';
wwv_flow_imp.g_varchar2_table(23254) := '69732E5F73686F756C644E6F744869646543757272656E74486F7665725769646765742865297C7C746869732E5F686964655769646765747328297D5F73686F756C644E6F745265636F6D7075746543757272656E74486F766572576964676574286529';
wwv_flow_imp.g_varchar2_table(23255) := '7B636F6E737420743D746869732E5F686F76657253657474696E67732E737469636B793B72657475726E2121282828652C74293D3E7B636F6E7374206E3D746869732E5F69734D6F7573654F6E4D617267696E486F7665725769646765742865293B7265';
wwv_flow_imp.g_varchar2_table(23256) := '7475726E207426266E7D2928652C74297C7C2828652C74293D3E7B636F6E7374206E3D746869732E5F69734D6F7573654F6E436F6E74656E74486F7665725769646765742865293B72657475726E207426266E7D2928652C74297C7C28653D3E7B766172';
wwv_flow_imp.g_varchar2_table(23257) := '20743B636F6E7374206E3D746869732E5F69734D6F7573654F6E436F6E74656E74486F7665725769646765742865292C693D6E756C6C3D3D3D28743D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D743F766F696420303A';
wwv_flow_imp.g_varchar2_table(23258) := '742E6973436F6C6F725069636B657256697369626C653B72657475726E206E2626697D292865297C7C2828652C74293D3E7B766172206E2C692C6F2C733B72657475726E20742626286E756C6C3D3D3D286E3D746869732E5F636F6E74656E7457696467';
wwv_flow_imp.g_varchar2_table(23259) := '6574297C7C766F696420303D3D3D6E3F766F696420303A6E2E636F6E7461696E734E6F6465286E756C6C3D3D3D28693D652E6576656E742E62726F777365724576656E742E76696577297C7C766F696420303D3D3D693F766F696420303A692E646F6375';
wwv_flow_imp.g_varchar2_table(23260) := '6D656E742E616374697665456C656D656E742929262621286E756C6C3D3D3D28733D6E756C6C3D3D3D286F3D652E6576656E742E62726F777365724576656E742E76696577297C7C766F696420303D3D3D6F3F766F696420303A6F2E67657453656C6563';
wwv_flow_imp.g_varchar2_table(23261) := '74696F6E2829297C7C766F696420303D3D3D733F766F696420303A732E6973436F6C6C6170736564297D2928652C7429297D5F6F6E456469746F724D6F7573654D6F76652865297B76617220742C6E2C692C6F3B696628746869732E5F6D6F7573654D6F';
wwv_flow_imp.g_varchar2_table(23262) := '76654576656E743D652C286E756C6C3D3D3D28743D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D743F766F696420303A742E6973466F6375736564297C7C286E756C6C3D3D3D286E3D746869732E5F636F6E74656E7457';
wwv_flow_imp.g_varchar2_table(23263) := '6964676574297C7C766F696420303D3D3D6E3F766F696420303A6E2E6973526573697A696E67292972657475726E3B636F6E737420733D746869732E5F686F76657253657474696E67732E737469636B793B696628732626286E756C6C3D3D3D28693D74';
wwv_flow_imp.g_varchar2_table(23264) := '6869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D693F766F696420303A692E697356697369626C6546726F6D4B6579626F617264292972657475726E3B696628746869732E5F73686F756C644E6F745265636F6D707574654375';
wwv_flow_imp.g_varchar2_table(23265) := '7272656E74486F7665725769646765742865292972657475726E20766F696420746869732E5F7265616374546F456469746F724D6F7573654D6F766552756E6E65722E63616E63656C28293B636F6E737420723D746869732E5F686F7665725365747469';
wwv_flow_imp.g_varchar2_table(23266) := '6E67732E686964696E6744656C61793B286E756C6C3D3D3D286F3D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D6F3F766F696420303A6F2E697356697369626C65292626732626723E303F746869732E5F726561637454';
wwv_flow_imp.g_varchar2_table(23267) := '6F456469746F724D6F7573654D6F766552756E6E65722E69735363686564756C656428297C7C746869732E5F7265616374546F456469746F724D6F7573654D6F766552756E6E65722E7363686564756C652872293A746869732E5F7265616374546F4564';
wwv_flow_imp.g_varchar2_table(23268) := '69746F724D6F7573654D6F76652865297D5F7265616374546F456469746F724D6F7573654D6F76652865297B76617220743B69662821652972657475726E3B636F6E7374206E3D6E756C6C3D3D3D28743D652E7461726765742E656C656D656E74297C7C';
wwv_flow_imp.g_varchar2_table(23269) := '766F696420303D3D3D743F766F696420303A742E636C6173734C6973742E636F6E7461696E732822636F6C6F727069636B65722D636F6C6F722D6465636F726174696F6E22292C693D746869732E5F656469746F722E6765744F7074696F6E2831343829';
wwv_flow_imp.g_varchar2_table(23270) := '2C6F3D746869732E5F686F76657253657474696E67732E656E61626C65642C733D746869732E5F686F76657253746174652E61637469766174656442794465636F7261746F72436C69636B3B6E26262822636C69636B223D3D3D69262621737C7C22686F';
wwv_flow_imp.g_varchar2_table(23271) := '766572223D3D3D692626216F7C7C22636C69636B416E64486F766572223D3D3D692626216F26262173297C7C21286E7C7C6F7C7C73293F746869732E5F686964655769646765747328293A746869732E5F74727953686F77486F76657257696467657428';
wwv_flow_imp.g_varchar2_table(23272) := '652C30297C7C746869732E5F74727953686F77486F76657257696467657428652C31297C7C746869732E5F686964655769646765747328297D5F74727953686F77486F76657257696467657428652C74297B636F6E7374206E3D746869732E5F6765744F';
wwv_flow_imp.g_varchar2_table(23273) := '72437265617465436F6E74656E7457696467657428292C693D746869732E5F6765744F72437265617465476C79706857696467657428293B6C6574206F2C733B7377697463682874297B6361736520303A6F3D6E2C733D693B627265616B3B6361736520';
wwv_flow_imp.g_varchar2_table(23274) := '313A6F3D692C733D6E3B627265616B3B64656661756C743A7468726F77206E6577204572726F722860486F7665725769646765745479706520247B747D20697320756E7265636F676E697A656460297D636F6E737420723D6F2E73686F77734F7257696C';
wwv_flow_imp.g_varchar2_table(23275) := '6C53686F772865293B72657475726E20722626732E6869646528292C727D5F6F6E4B6579446F776E2865297B76617220743B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E7374206E3D746869732E5F6B';
wwv_flow_imp.g_varchar2_table(23276) := '657962696E64696E67536572766963652E736F6674446973706174636828652C746869732E5F656469746F722E676574446F6D4E6F64652829292C693D313D3D3D6E2E6B696E647C7C323D3D3D6E2E6B696E642626286E2E636F6D6D616E6449643D3D3D';
wwv_flow_imp.g_varchar2_table(23277) := '746A7C7C6E2E636F6D6D616E6449643D3D3D6E6A7C7C6E2E636F6D6D616E6449643D3D3D696A292626286E756C6C3D3D3D28743D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D743F766F696420303A742E697356697369';
wwv_flow_imp.g_varchar2_table(23278) := '626C65293B353D3D3D652E6B6579436F64657C7C363D3D3D652E6B6579436F64657C7C35373D3D3D652E6B6579436F64657C7C343D3D3D652E6B6579436F64657C7C697C7C746869732E5F686964655769646765747328297D5F68696465576964676574';
wwv_flow_imp.g_varchar2_table(23279) := '7328297B76617220652C742C6E3B746869732E5F686F76657253746174652E6D6F757365446F776E2626286E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D653F766F696420303A652E6973436F6C';
wwv_flow_imp.g_varchar2_table(23280) := '6F725069636B657256697369626C65297C7C516A2E64726F70446F776E56697369626C657C7C28746869732E5F686F76657253746174652E61637469766174656442794465636F7261746F72436C69636B3D21312C6E756C6C3D3D3D28743D746869732E';
wwv_flow_imp.g_varchar2_table(23281) := '5F676C797068576964676574297C7C766F696420303D3D3D747C7C742E6869646528292C6E756C6C3D3D3D286E3D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D6E7C7C6E2E686964652829297D5F6765744F7243726561';
wwv_flow_imp.g_varchar2_table(23282) := '7465436F6E74656E7457696467657428297B72657475726E20746869732E5F636F6E74656E745769646765747C7C28746869732E5F636F6E74656E745769646765743D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465';
wwv_flow_imp.g_varchar2_table(23283) := '496E7374616E63652868592C746869732E5F656469746F7229292C746869732E5F636F6E74656E745769646765747D5F6765744F72437265617465476C79706857696467657428297B72657475726E20746869732E5F676C7970685769646765747C7C28';
wwv_flow_imp.g_varchar2_table(23284) := '746869732E5F676C7970685769646765743D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652866592C746869732E5F656469746F7229292C746869732E5F676C7970685769646765747D73686F77';
wwv_flow_imp.g_varchar2_table(23285) := '436F6E74656E74486F76657228652C742C6E2C692C6F3D2131297B746869732E5F686F76657253746174652E61637469766174656442794465636F7261746F72436C69636B3D6F2C746869732E5F6765744F72437265617465436F6E74656E7457696467';
wwv_flow_imp.g_varchar2_table(23286) := '657428292E737461727453686F77696E67417452616E676528652C742C6E2C69297D5F6973436F6E74656E74576964676574526573697A696E6728297B76617220653B72657475726E286E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964';
wwv_flow_imp.g_varchar2_table(23287) := '676574297C7C766F696420303D3D3D653F766F696420303A652E7769646765742E6973526573697A696E67297C7C21317D757064617465466F63757365644D61726B646F776E486F766572566572626F736974794C6576656C2865297B746869732E5F67';
wwv_flow_imp.g_varchar2_table(23288) := '65744F72437265617465436F6E74656E7457696467657428292E757064617465466F63757365644D61726B646F776E486F766572566572626F736974794C6576656C2865297D666F63757328297B76617220653B6E756C6C3D3D3D28653D746869732E5F';
wwv_flow_imp.g_varchar2_table(23289) := '636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E666F63757328297D7363726F6C6C557028297B76617220653B6E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C65';
wwv_flow_imp.g_varchar2_table(23290) := '2E7363726F6C6C557028297D7363726F6C6C446F776E28297B76617220653B6E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E7363726F6C6C446F776E28297D7363726F6C6C4C656674';
wwv_flow_imp.g_varchar2_table(23291) := '28297B76617220653B6E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E7363726F6C6C4C65667428297D7363726F6C6C526967687428297B76617220653B6E756C6C3D3D3D28653D7468';
wwv_flow_imp.g_varchar2_table(23292) := '69732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E7363726F6C6C526967687428297D70616765557028297B76617220653B6E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420';
wwv_flow_imp.g_varchar2_table(23293) := '303D3D3D657C7C652E70616765557028297D70616765446F776E28297B76617220653B6E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E70616765446F776E28297D676F546F546F7028';
wwv_flow_imp.g_varchar2_table(23294) := '297B76617220653B6E756C6C3D3D3D28653D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E676F546F546F7028297D676F546F426F74746F6D28297B76617220653B6E756C6C3D3D3D28653D746869732E5F63';
wwv_flow_imp.g_varchar2_table(23295) := '6F6E74656E74576964676574297C7C766F696420303D3D3D657C7C652E676F546F426F74746F6D28297D676574206973436F6C6F725069636B657256697369626C6528297B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F636F';
wwv_flow_imp.g_varchar2_table(23296) := '6E74656E74576964676574297C7C766F696420303D3D3D653F766F696420303A652E6973436F6C6F725069636B657256697369626C657D676574206973486F76657256697369626C6528297B76617220653B72657475726E206E756C6C3D3D3D28653D74';
wwv_flow_imp.g_varchar2_table(23297) := '6869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D653F766F696420303A652E697356697369626C657D646973706F736528297B76617220652C743B73757065722E646973706F736528292C746869732E5F756E686F6F6B4C6973';
wwv_flow_imp.g_varchar2_table(23298) := '74656E65727328292C746869732E5F6C697374656E65727353746F72652E646973706F736528292C6E756C6C3D3D3D28653D746869732E5F676C797068576964676574297C7C766F696420303D3D3D657C7C652E646973706F736528292C6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(23299) := '3D28743D746869732E5F636F6E74656E74576964676574297C7C766F696420303D3D3D747C7C742E646973706F736528297D7D3B5F592E49443D22656469746F722E636F6E747269622E686F766572222C5F593D76593D66756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(23300) := '6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D';
wwv_flow_imp.g_varchar2_table(23301) := '3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C65';
wwv_flow_imp.g_varchar2_table(23302) := '6E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F7065727479';
wwv_flow_imp.g_varchar2_table(23303) := '28742C6E2C72292C727D285B625928312C7563292C625928322C2445295D2C5F59293B636C61737320795920657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F656469746F723D652C746869732E5F72';
wwv_flow_imp.g_varchar2_table(23304) := '6567697374657228652E6F6E4D6F757365446F776E2828653D3E746869732E6F6E4D6F757365446F776E2865292929297D646973706F736528297B73757065722E646973706F736528297D6F6E4D6F757365446F776E2865297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(23305) := '69732E5F656469746F722E6765744F7074696F6E28313438293B69662822636C69636B22213D3D74262622636C69636B416E64486F76657222213D3D742972657475726E3B636F6E7374206E3D652E7461726765743B69662836213D3D6E2E7479706529';
wwv_flow_imp.g_varchar2_table(23306) := '72657475726E3B696628216E2E64657461696C2E696E6A6563746564546578742972657475726E3B6966286E2E64657461696C2E696E6A6563746564546578742E6F7074696F6E732E617474616368656444617461213D3D79572972657475726E3B6966';
wwv_flow_imp.g_varchar2_table(23307) := '28216E2E72616E67652972657475726E3B636F6E737420693D746869732E5F656469746F722E676574436F6E747269627574696F6E285F592E4944293B69662869262621692E6973436F6C6F725069636B657256697369626C65297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(23308) := '6E6577207268286E2E72616E67652E73746172744C696E654E756D6265722C6E2E72616E67652E7374617274436F6C756D6E2B312C6E2E72616E67652E656E644C696E654E756D6265722C6E2E72616E67652E656E64436F6C756D6E2B31293B692E7368';
wwv_flow_imp.g_varchar2_table(23309) := '6F77436F6E74656E74486F76657228652C312C302C21312C2130297D7D7D79592E49443D22656469746F722E636F6E747269622E636F6C6F72436F6E747269627574696F6E222C4A642879592E49442C79592C32292C44712E7265676973746572284757';
wwv_flow_imp.g_varchar2_table(23310) := '293B7661722077592C43592C53593D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F70657274794465';
wwv_flow_imp.g_varchar2_table(23311) := '7363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528';
wwv_flow_imp.g_varchar2_table(23312) := '652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E2073';
wwv_flow_imp.g_varchar2_table(23313) := '3E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C78593D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206B593D77593D636C';
wwv_flow_imp.g_varchar2_table(23314) := '61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228292C746869732E5F656469746F723D652C746869732E5F6D6F64656C536572766963653D6E2C746869732E5F6B657962696E6469';
wwv_flow_imp.g_varchar2_table(23315) := '6E67536572766963653D692C746869732E5F696E7374616E74696174696F6E536572766963653D6F2C746869732E5F6C616E677561676546656174757265536572766963653D732C746869732E5F6C616E6775616765436F6E66696775726174696F6E53';
wwv_flow_imp.g_varchar2_table(23316) := '6572766963653D722C746869732E5F7374616E64616C6F6E65436F6C6F725069636B65725769646765743D6E756C6C2C746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C653D6C682E7374616E64616C6F6E65436F6C6F';
wwv_flow_imp.g_varchar2_table(23317) := '725069636B657256697369626C652E62696E64546F2874292C746869732E5F7374616E64616C6F6E65436F6C6F725069636B6572466F63757365643D6C682E7374616E64616C6F6E65436F6C6F725069636B6572466F63757365642E62696E64546F2874';
wwv_flow_imp.g_varchar2_table(23318) := '297D73686F774F72466F63757328297B76617220653B746869732E5F656469746F722E6861734D6F64656C2829262628746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C652E67657428293F746869732E5F7374616E64';
wwv_flow_imp.g_varchar2_table(23319) := '616C6F6E65436F6C6F725069636B6572466F63757365642E67657428297C7C6E756C6C3D3D3D28653D746869732E5F7374616E64616C6F6E65436F6C6F725069636B6572576964676574297C7C766F696420303D3D3D657C7C652E666F63757328293A74';
wwv_flow_imp.g_varchar2_table(23320) := '6869732E5F7374616E64616C6F6E65436F6C6F725069636B65725769646765743D6E657720455928746869732E5F656469746F722C746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C652C746869732E5F7374616E6461';
wwv_flow_imp.g_varchar2_table(23321) := '6C6F6E65436F6C6F725069636B6572466F63757365642C746869732E5F696E7374616E74696174696F6E536572766963652C746869732E5F6D6F64656C536572766963652C746869732E5F6B657962696E64696E67536572766963652C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(23322) := '616E677561676546656174757265536572766963652C746869732E5F6C616E6775616765436F6E66696775726174696F6E5365727669636529297D6869646528297B76617220653B746869732E5F7374616E64616C6F6E65436F6C6F725069636B657246';
wwv_flow_imp.g_varchar2_table(23323) := '6F63757365642E736574282131292C746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C652E736574282131292C6E756C6C3D3D3D28653D746869732E5F7374616E64616C6F6E65436F6C6F725069636B65725769646765';
wwv_flow_imp.g_varchar2_table(23324) := '74297C7C766F696420303D3D3D657C7C652E6869646528292C746869732E5F656469746F722E666F63757328297D696E73657274436F6C6F7228297B76617220653B6E756C6C3D3D3D28653D746869732E5F7374616E64616C6F6E65436F6C6F72506963';
wwv_flow_imp.g_varchar2_table(23325) := '6B6572576964676574297C7C766F696420303D3D3D657C7C652E757064617465456469746F7228292C746869732E6869646528297D737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2877592E4944297D7D';
wwv_flow_imp.g_varchar2_table(23326) := '3B6B592E49443D22656469746F722E636F6E747269622E7374616E64616C6F6E65436F6C6F725069636B6572436F6E74726F6C6C6572222C6B593D77593D5359285B785928312C6364292C785928322C6663292C785928332C2445292C785928342C7563';
wwv_flow_imp.g_varchar2_table(23327) := '292C785928352C7878292C785928362C6567295D2C6B59292C4A64286B592E49442C6B592C31293B6C65742045593D43593D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B76617220';
wwv_flow_imp.g_varchar2_table(23328) := '6C3B737570657228292C746869732E5F656469746F723D652C746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C653D742C746869732E5F7374616E64616C6F6E65436F6C6F725069636B6572466F63757365643D6E2C74';
wwv_flow_imp.g_varchar2_table(23329) := '6869732E5F6D6F64656C536572766963653D6F2C746869732E5F6B657962696E64696E67536572766963653D732C746869732E5F6C616E67756167654665617475726573536572766963653D722C746869732E5F6C616E6775616765436F6E6669677572';
wwv_flow_imp.g_varchar2_table(23330) := '6174696F6E536572766963653D612C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E5F706F736974696F6E3D766F696420302C746869732E5F626F64793D646F63756D656E742E637265617465456C656D656E742822';
wwv_flow_imp.g_varchar2_table(23331) := '64697622292C746869732E5F636F6C6F72486F7665723D6E756C6C2C746869732E5F73656C656374696F6E536574496E456469746F723D21312C746869732E5F6F6E526573756C743D746869732E5F7265676973746572286E6577204374292C74686973';
wwv_flow_imp.g_varchar2_table(23332) := '2E6F6E526573756C743D746869732E5F6F6E526573756C742E6576656E742C746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C652E736574282130292C746869732E5F7374616E64616C6F6E65436F6C6F725069636B65';
wwv_flow_imp.g_varchar2_table(23333) := '725061727469636970616E743D692E637265617465496E7374616E63652859572C746869732E5F656469746F72292C746869732E5F706F736974696F6E3D6E756C6C3D3D3D286C3D746869732E5F656469746F722E5F676574566965774D6F64656C2829';
wwv_flow_imp.g_varchar2_table(23334) := '297C7C766F696420303D3D3D6C3F766F696420303A6C2E6765745072696D617279437572736F72537461746528292E6D6F64656C53746174652E706F736974696F6E3B636F6E737420633D746869732E5F656469746F722E67657453656C656374696F6E';
wwv_flow_imp.g_varchar2_table(23335) := '28292C643D633F7B73746172744C696E654E756D6265723A632E73746172744C696E654E756D6265722C7374617274436F6C756D6E3A632E7374617274436F6C756D6E2C656E644C696E654E756D6265723A632E656E644C696E654E756D6265722C656E';
wwv_flow_imp.g_varchar2_table(23336) := '64436F6C756D6E3A632E656E64436F6C756D6E7D3A7B73746172744C696E654E756D6265723A302C656E644C696E654E756D6265723A302C656E64436F6C756D6E3A302C7374617274436F6C756D6E3A307D2C683D746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(23337) := '687228746869732E5F626F647929293B746869732E5F726567697374657228682E6F6E446964426C75722828653D3E7B746869732E6869646528297D2929292C746869732E5F726567697374657228682E6F6E446964466F6375732828653D3E7B746869';
wwv_flow_imp.g_varchar2_table(23338) := '732E666F63757328297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E7B746869732E5F73656C656374696F6E536574496E456469746F72';
wwv_flow_imp.g_varchar2_table(23339) := '3F746869732E5F73656C656374696F6E536574496E456469746F723D21313A746869732E6869646528297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4D6F7573654D6F76652828653D3E7B76617220743B636F';
wwv_flow_imp.g_varchar2_table(23340) := '6E7374206E3D6E756C6C3D3D3D28743D652E7461726765742E656C656D656E74297C7C766F696420303D3D3D743F766F696420303A742E636C6173734C6973743B6E26266E2E636F6E7461696E732822636F6C6F727069636B65722D636F6C6F722D6465';
wwv_flow_imp.g_varchar2_table(23341) := '636F726174696F6E22292626746869732E6869646528297D2929292C746869732E5F726567697374657228746869732E6F6E526573756C742828653D3E7B746869732E5F72656E64657228652E76616C75652C652E666F756E64496E456469746F72297D';
wwv_flow_imp.g_varchar2_table(23342) := '2929292C746869732E5F73746172742864292C746869732E5F626F64792E7374796C652E7A496E6465783D223530222C746869732E5F656469746F722E616464436F6E74656E745769646765742874686973297D757064617465456469746F7228297B74';
wwv_flow_imp.g_varchar2_table(23343) := '6869732E5F636F6C6F72486F7665722626746869732E5F7374616E64616C6F6E65436F6C6F725069636B65725061727469636970616E742E757064617465456469746F724D6F64656C28746869732E5F636F6C6F72486F766572297D676574496428297B';
wwv_flow_imp.g_varchar2_table(23344) := '72657475726E2043592E49447D676574446F6D4E6F646528297B72657475726E20746869732E5F626F64797D676574506F736974696F6E28297B69662821746869732E5F706F736974696F6E2972657475726E206E756C6C3B636F6E737420653D746869';
wwv_flow_imp.g_varchar2_table(23345) := '732E5F656469746F722E6765744F7074696F6E283630292E61626F76653B72657475726E7B706F736974696F6E3A746869732E5F706F736974696F6E2C7365636F6E64617279506F736974696F6E3A746869732E5F706F736974696F6E2C707265666572';
wwv_flow_imp.g_varchar2_table(23346) := '656E63653A653F5B312C325D3A5B322C315D2C706F736974696F6E416666696E6974793A327D7D6869646528297B746869732E646973706F736528292C746869732E5F7374616E64616C6F6E65436F6C6F725069636B657256697369626C652E73657428';
wwv_flow_imp.g_varchar2_table(23347) := '2131292C746869732E5F7374616E64616C6F6E65436F6C6F725069636B6572466F63757365642E736574282131292C746869732E5F656469746F722E72656D6F7665436F6E74656E745769646765742874686973292C746869732E5F656469746F722E66';
wwv_flow_imp.g_varchar2_table(23348) := '6F63757328297D666F63757328297B746869732E5F7374616E64616C6F6E65436F6C6F725069636B6572466F63757365642E736574282130292C746869732E5F626F64792E666F63757328297D6173796E63205F73746172742865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(23349) := '3D617761697420746869732E5F636F6D707574654173796E632865293B742626746869732E5F6F6E526573756C742E66697265286E6577204C5928742E726573756C742C742E666F756E64496E456469746F7229297D6173796E63205F636F6D70757465';
wwv_flow_imp.g_varchar2_table(23350) := '4173796E632865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E206E756C6C3B636F6E737420743D7B72616E67653A652C636F6C6F723A7B7265643A302C677265656E3A302C626C75653A302C616C7068613A';
wwv_flow_imp.g_varchar2_table(23351) := '317D7D2C6E3D617761697420746869732E5F7374616E64616C6F6E65436F6C6F725069636B65725061727469636970616E742E637265617465436F6C6F72486F76657228742C6E657720635728746869732E5F6D6F64656C536572766963652C74686973';
wwv_flow_imp.g_varchar2_table(23352) := '2E5F6C616E6775616765436F6E66696775726174696F6E53657276696365292C746869732E5F6C616E67756167654665617475726573536572766963652E636F6C6F7250726F7669646572293B72657475726E206E3F7B726573756C743A6E2E636F6C6F';
wwv_flow_imp.g_varchar2_table(23353) := '72486F7665722C666F756E64496E456469746F723A6E2E666F756E64496E456469746F727D3A6E756C6C7D5F72656E64657228652C74297B636F6E7374206E3D646F63756D656E742E637265617465446F63756D656E74467261676D656E7428293B6C65';
wwv_flow_imp.g_varchar2_table(23354) := '7420693B636F6E7374206F3D7B667261676D656E743A6E2C7374617475734261723A746869732E5F7265676973746572286E6577206C5928746869732E5F6B657962696E64696E675365727669636529292C736574436F6C6F725069636B65723A653D3E';
wwv_flow_imp.g_varchar2_table(23355) := '693D652C6F6E436F6E74656E74734368616E6765643A28293D3E7B7D2C686964653A28293D3E746869732E6869646528297D3B696628746869732E5F636F6C6F72486F7665723D652C746869732E5F726567697374657228746869732E5F7374616E6461';
wwv_flow_imp.g_varchar2_table(23356) := '6C6F6E65436F6C6F725069636B65725061727469636970616E742E72656E646572486F7665725061727473286F2C5B655D29292C766F696420303D3D3D692972657475726E3B746869732E5F626F64792E636C6173734C6973742E61646428227374616E';
wwv_flow_imp.g_varchar2_table(23357) := '64616C6F6E652D636F6C6F727069636B65722D626F647922292C746869732E5F626F64792E7374796C652E6D61784865696768743D4D6174682E6D617828746869732E5F656469746F722E6765744C61796F7574496E666F28292E6865696768742F342C';
wwv_flow_imp.g_varchar2_table(23358) := '323530292B227078222C746869732E5F626F64792E7374796C652E6D617857696474683D4D6174682E6D6178282E36362A746869732E5F656469746F722E6765744C61796F7574496E666F28292E77696474682C353030292B227078222C746869732E5F';
wwv_flow_imp.g_varchar2_table(23359) := '626F64792E746162496E6465783D302C746869732E5F626F64792E617070656E644368696C64286E292C692E6C61796F757428293B636F6E737420733D692E626F64792C723D732E73617475726174696F6E426F782E646F6D4E6F64652E636C69656E74';
wwv_flow_imp.g_varchar2_table(23360) := '57696474682C613D732E646F6D4E6F64652E636C69656E7457696474682D722D32322D382C6C3D692E626F64792E656E746572427574746F6E3B6E756C6C3D3D6C7C7C6C2E6F6E436C69636B6564282828293D3E7B746869732E75706461746545646974';
wwv_flow_imp.g_varchar2_table(23361) := '6F7228292C746869732E6869646528297D29293B636F6E737420633D692E6865616465723B632E7069636B6564436F6C6F724E6F64652E7374796C652E77696474683D722B382B227078222C632E6F726967696E616C436F6C6F724E6F64652E7374796C';
wwv_flow_imp.g_varchar2_table(23362) := '652E77696474683D612B227078223B636F6E737420643D692E6865616465722E636C6F7365427574746F6E3B6E756C6C3D3D647C7C642E6F6E436C69636B6564282828293D3E7B746869732E6869646528297D29292C742626286C2626286C2E62757474';
wwv_flow_imp.g_varchar2_table(23363) := '6F6E2E74657874436F6E74656E743D225265706C61636522292C746869732E5F73656C656374696F6E536574496E456469746F723D21302C746869732E5F656469746F722E73657453656C656374696F6E28652E72616E676529292C746869732E5F6564';
wwv_flow_imp.g_varchar2_table(23364) := '69746F722E6C61796F7574436F6E74656E745769646765742874686973297D7D3B45592E49443D22656469746F722E636F6E747269622E7374616E64616C6F6E65436F6C6F725069636B6572576964676574222C45593D43593D5359285B785928332C75';
wwv_flow_imp.g_varchar2_table(23365) := '63292C785928342C6663292C785928352C2445292C785928362C7878292C785928372C6567295D2C4559293B636C617373204C597B636F6E7374727563746F7228652C74297B746869732E76616C75653D652C746869732E666F756E64496E456469746F';
wwv_flow_imp.g_varchar2_table(23366) := '723D747D7D5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E68696465436F6C6F725069636B6572222C6C6162656C3A6228302C224869646520746865';
wwv_flow_imp.g_varchar2_table(23367) := '20436F6C6F72205069636B657222292C616C6961733A22486964652074686520436F6C6F72205069636B6572222C707265636F6E646974696F6E3A6C682E7374616E64616C6F6E65436F6C6F725069636B657256697369626C652E6973457175616C546F';
wwv_flow_imp.g_varchar2_table(23368) := '282130292C6B624F7074733A7B7072696D6172793A392C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C224869646520746865207374616E64616C6F6E6520636F6C6F72207069636B65722E22297D7D29';
wwv_flow_imp.g_varchar2_table(23369) := '7D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D6B592E676574287429297C7C766F696420303D3D3D6E7C7C6E2E6869646528297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B73757065';
wwv_flow_imp.g_varchar2_table(23370) := '72287B69643A22656469746F722E616374696F6E2E696E73657274436F6C6F72576974685374616E64616C6F6E65436F6C6F725069636B6572222C6C6162656C3A6228302C22496E7365727420436F6C6F722077697468205374616E64616C6F6E652043';
wwv_flow_imp.g_varchar2_table(23371) := '6F6C6F72205069636B657222292C616C6961733A22496E7365727420436F6C6F722077697468205374616E64616C6F6E6520436F6C6F72205069636B6572222C707265636F6E646974696F6E3A6C682E7374616E64616C6F6E65436F6C6F725069636B65';
wwv_flow_imp.g_varchar2_table(23372) := '72466F63757365642E6973457175616C546F282130292C6B624F7074733A7B7072696D6172793A332C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C22496E73657274206865782F7267622F68736C2063';
wwv_flow_imp.g_varchar2_table(23373) := '6F6C6F727320776974682074686520666F6375736564207374616E64616C6F6E6520636F6C6F72207069636B65722E22297D7D297D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D6B592E676574287429297C7C766F696420303D3D3D6E';
wwv_flow_imp.g_varchar2_table(23374) := '7C7C6E2E696E73657274436F6C6F7228297D7D292C506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73686F774F72466F6375735374616E64616C6F6E';
wwv_flow_imp.g_varchar2_table(23375) := '65436F6C6F725069636B6572222C7469746C653A7B2E2E2E5F28302C2253686F77206F7220466F637573205374616E64616C6F6E6520436F6C6F72205069636B657222292C6D6E656D6F6E69635469746C653A6228302C22262653686F77206F7220466F';
wwv_flow_imp.g_varchar2_table(23376) := '637573205374616E64616C6F6E6520436F6C6F72205069636B657222297D2C707265636F6E646974696F6E3A766F696420302C6D656E753A5B7B69643A4C642E436F6D6D616E6450616C657474657D5D2C6D657461646174613A7B646573637269707469';
wwv_flow_imp.g_varchar2_table(23377) := '6F6E3A5F28302C2253686F77206F7220666F6375732061207374616E64616C6F6E6520636F6C6F72207069636B65722077686963682075736573207468652064656661756C7420636F6C6F722070726F76696465722E20497420646973706C6179732068';
wwv_flow_imp.g_varchar2_table(23378) := '65782F7267622F68736C20636F6C6F72732E22297D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B6E756C6C3D3D3D286E3D6B592E676574287429297C7C766F696420303D3D3D6E7C7C6E2E73686F774F72466F63757328';
wwv_flow_imp.g_varchar2_table(23379) := '297D7D293B636C6173732044597B636F6E7374727563746F7228652C742C6E297B746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D6E2C746869732E5F73656C656374696F6E3D652C746869732E5F696E7365727453';
wwv_flow_imp.g_varchar2_table(23380) := '706163653D742C746869732E5F75736564456E64546F6B656E3D6E756C6C7D737461746963205F686179737461636B4861734E6565646C6541744F666673657428652C742C6E297B6966286E3C302972657475726E21313B636F6E737420693D742E6C65';
wwv_flow_imp.g_varchar2_table(23381) := '6E6774683B6966286E2B693E652E6C656E6774682972657475726E21313B666F72286C6574206F3D303B6F3C693B6F2B2B297B636F6E737420693D652E63686172436F64654174286E2B6F292C733D742E63686172436F64654174286F293B6966286921';
wwv_flow_imp.g_varchar2_table(23382) := '3D3D7326262128693E3D36352626693C3D39302626692B33323D3D3D737C7C733E3D36352626733C3D39302626732B33323D3D3D69292972657475726E21317D72657475726E21307D5F6372656174654F7065726174696F6E73466F72426C6F636B436F';
wwv_flow_imp.g_varchar2_table(23383) := '6D6D656E7428652C742C6E2C692C6F2C73297B636F6E737420723D652E73746172744C696E654E756D6265722C613D652E7374617274436F6C756D6E2C6C3D652E656E644C696E654E756D6265722C633D652E656E64436F6C756D6E2C643D6F2E676574';
wwv_flow_imp.g_varchar2_table(23384) := '4C696E65436F6E74656E742872292C683D6F2E6765744C696E65436F6E74656E74286C293B6C657420752C703D642E6C617374496E6465784F6628742C612D312B742E6C656E677468292C673D682E696E6465784F66286E2C632D312D6E2E6C656E6774';
wwv_flow_imp.g_varchar2_table(23385) := '68293B6966282D31213D3D7026262D31213D3D6729696628723D3D3D6C29642E737562737472696E6728702B742E6C656E6774682C67292E696E6465784F66286E293E3D30262628703D2D312C673D2D31293B656C73657B636F6E737420653D642E7375';
wwv_flow_imp.g_varchar2_table(23386) := '62737472696E6728702B742E6C656E677468292C693D682E737562737472696E6728302C67293B28652E696E6465784F66286E293E3D307C7C692E696E6465784F66286E293E3D3029262628703D2D312C673D2D31297D2D31213D3D7026262D31213D3D';
wwv_flow_imp.g_varchar2_table(23387) := '673F28692626702B742E6C656E6774683C642E6C656E677468262633323D3D3D642E63686172436F6465417428702B742E6C656E67746829262628742B3D222022292C692626673E30262633323D3D3D682E63686172436F6465417428672D3129262628';
wwv_flow_imp.g_varchar2_table(23388) := '6E3D2220222B6E2C672D3D31292C753D44592E5F63726561746552656D6F7665426C6F636B436F6D6D656E744F7065726174696F6E73286E657720726828722C702B742E6C656E6774682B312C6C2C672B31292C742C6E29293A28753D44592E5F637265';
wwv_flow_imp.g_varchar2_table(23389) := '617465416464426C6F636B436F6D6D656E744F7065726174696F6E7328652C742C6E2C746869732E5F696E736572745370616365292C746869732E5F75736564456E64546F6B656E3D313D3D3D752E6C656E6774683F6E3A6E756C6C293B666F7228636F';
wwv_flow_imp.g_varchar2_table(23390) := '6E73742065206F66207529732E616464547261636B6564456469744F7065726174696F6E28652E72616E67652C652E74657874297D737461746963205F63726561746552656D6F7665426C6F636B436F6D6D656E744F7065726174696F6E7328652C742C';
wwv_flow_imp.g_varchar2_table(23391) := '6E297B636F6E737420693D5B5D3B72657475726E2072682E6973456D7074792865293F692E70757368286A712E64656C657465286E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2D742E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(23392) := '652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2B6E2E6C656E6774682929293A28692E70757368286A712E64656C657465286E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2D742E6C';
wwv_flow_imp.g_varchar2_table(23393) := '656E6774682C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2929292C692E70757368286A712E64656C657465286E657720726828652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E656E644C69';
wwv_flow_imp.g_varchar2_table(23394) := '6E654E756D6265722C652E656E64436F6C756D6E2B6E2E6C656E677468292929292C697D737461746963205F637265617465416464426C6F636B436F6D6D656E744F7065726174696F6E7328652C742C6E2C69297B636F6E7374206F3D5B5D3B72657475';
wwv_flow_imp.g_varchar2_table(23395) := '726E2072682E6973456D7074792865293F6F2E70757368286A712E7265706C616365286E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(23396) := '6E292C742B222020222B6E29293A286F2E70757368286A712E696E73657274286E6577206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C742B28693F2220223A22222929292C6F2E70757368286A712E696E73';
wwv_flow_imp.g_varchar2_table(23397) := '657274286E6577206D6328652E656E644C696E654E756D6265722C652E656E64436F6C756D6E292C28693F2220223A2222292B6E2929292C6F7D676574456469744F7065726174696F6E7328652C74297B636F6E7374206E3D746869732E5F73656C6563';
wwv_flow_imp.g_varchar2_table(23398) := '74696F6E2E73746172744C696E654E756D6265722C693D746869732E5F73656C656374696F6E2E7374617274436F6C756D6E3B652E746F6B656E697A6174696F6E2E746F6B656E697A6549664368656170286E293B636F6E7374206F3D652E6765744C61';
wwv_flow_imp.g_varchar2_table(23399) := '6E677561676549644174506F736974696F6E286E2C69292C733D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286F292E636F6D6D656E74733B732626';
wwv_flow_imp.g_varchar2_table(23400) := '732E626C6F636B436F6D6D656E745374617274546F6B656E2626732E626C6F636B436F6D6D656E74456E64546F6B656E2626746869732E5F6372656174654F7065726174696F6E73466F72426C6F636B436F6D6D656E7428746869732E5F73656C656374';
wwv_flow_imp.g_varchar2_table(23401) := '696F6E2C732E626C6F636B436F6D6D656E745374617274546F6B656E2C732E626C6F636B436F6D6D656E74456E64546F6B656E2C746869732E5F696E7365727453706163652C652C74297D636F6D70757465437572736F72537461746528652C74297B63';
wwv_flow_imp.g_varchar2_table(23402) := '6F6E7374206E3D742E676574496E7665727365456469744F7065726174696F6E7328293B696628323D3D3D6E2E6C656E677468297B636F6E737420653D6E5B305D2C743D6E5B315D3B72657475726E206E657720616828652E72616E67652E656E644C69';
wwv_flow_imp.g_varchar2_table(23403) := '6E654E756D6265722C652E72616E67652E656E64436F6C756D6E2C742E72616E67652E73746172744C696E654E756D6265722C742E72616E67652E7374617274436F6C756D6E297D7B636F6E737420653D6E5B305D2E72616E67652C743D746869732E5F';
wwv_flow_imp.g_varchar2_table(23404) := '75736564456E64546F6B656E3F2D746869732E5F75736564456E64546F6B656E2E6C656E6774682D313A303B72657475726E206E657720616828652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2B742C652E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(23405) := '6265722C652E656E64436F6C756D6E2B74297D7D7D636C6173732054597B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D652C746869732E5F73';
wwv_flow_imp.g_varchar2_table(23406) := '656C656374696F6E3D742C746869732E5F696E64656E7453697A653D6E2C746869732E5F747970653D692C746869732E5F696E7365727453706163653D6F2C746869732E5F73656C656374696F6E49643D6E756C6C2C746869732E5F64656C7461436F6C';
wwv_flow_imp.g_varchar2_table(23407) := '756D6E3D302C746869732E5F6D6F7665456E64506F736974696F6E446F776E3D21312C746869732E5F69676E6F7265456D7074794C696E65733D732C746869732E5F69676E6F726546697273744C696E653D727C7C21317D737461746963205F67617468';
wwv_flow_imp.g_varchar2_table(23408) := '6572507265666C69676874436F6D6D656E74537472696E677328652C742C6E2C69297B652E746F6B656E697A6174696F6E2E746F6B656E697A65496643686561702874293B636F6E7374206F3D652E6765744C616E677561676549644174506F73697469';
wwv_flow_imp.g_varchar2_table(23409) := '6F6E28742C31292C733D692E6765744C616E6775616765436F6E66696775726174696F6E286F292E636F6D6D656E74732C723D733F732E6C696E65436F6D6D656E74546F6B656E3A6E756C6C3B69662821722972657475726E206E756C6C3B636F6E7374';
wwv_flow_imp.g_varchar2_table(23410) := '20613D5B5D3B666F72286C657420653D302C693D6E2D742B313B653C693B652B2B29615B655D3D7B69676E6F72653A21312C636F6D6D656E745374723A722C636F6D6D656E745374724F66667365743A302C636F6D6D656E745374724C656E6774683A72';
wwv_flow_imp.g_varchar2_table(23411) := '2E6C656E6774687D3B72657475726E20617D737461746963205F616E616C797A654C696E657328652C742C6E2C692C6F2C732C722C61297B6C6574206C2C633D21303B6C3D303D3D3D657C7C31213D3D653B666F72286C657420613D302C643D692E6C65';
wwv_flow_imp.g_varchar2_table(23412) := '6E6774683B613C643B612B2B297B636F6E737420643D695B615D2C683D6F2B613B696628683D3D3D6F262672297B642E69676E6F72653D21303B636F6E74696E75657D636F6E737420753D6E2E6765744C696E65436F6E74656E742868292C703D6D6928';
wwv_flow_imp.g_varchar2_table(23413) := '75293B6966282D31213D3D70297B696628633D21312C642E69676E6F72653D21312C642E636F6D6D656E745374724F66667365743D702C6C26262144592E5F686179737461636B4861734E6565646C6541744F666673657428752C642E636F6D6D656E74';
wwv_flow_imp.g_varchar2_table(23414) := '5374722C7029262628303D3D3D653F6C3D21313A313D3D3D657C7C28642E69676E6F72653D213029292C6C262674297B636F6E737420653D702B642E636F6D6D656E745374724C656E6774683B653C752E6C656E677468262633323D3D3D752E63686172';
wwv_flow_imp.g_varchar2_table(23415) := '436F64654174286529262628642E636F6D6D656E745374724C656E6774682B3D31297D7D656C736520642E69676E6F72653D732C642E636F6D6D656E745374724F66667365743D752E6C656E6774687D696628303D3D3D65262663297B6C3D21313B666F';
wwv_flow_imp.g_varchar2_table(23416) := '72286C657420653D302C743D692E6C656E6774683B653C743B652B2B29695B655D2E69676E6F72653D21317D72657475726E7B737570706F727465643A21302C73686F756C6452656D6F7665436F6D6D656E74733A6C2C6C696E65733A697D7D73746174';
wwv_flow_imp.g_varchar2_table(23417) := '6963205F676174686572507265666C696768744461746128652C742C6E2C692C6F2C732C722C61297B636F6E7374206C3D54592E5F676174686572507265666C69676874436F6D6D656E74537472696E6773286E2C692C6F2C61293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(23418) := '756C6C3D3D3D6C3F7B737570706F727465643A21317D3A54592E5F616E616C797A654C696E657328652C742C6E2C6C2C692C732C722C61297D5F657865637574654C696E65436F6D6D656E747328652C742C6E2C69297B6C6574206F3B6E2E73686F756C';
wwv_flow_imp.g_varchar2_table(23419) := '6452656D6F7665436F6D6D656E74733F6F3D54592E5F63726561746552656D6F76654C696E65436F6D6D656E74734F7065726174696F6E73286E2E6C696E65732C692E73746172744C696E654E756D626572293A2854592E5F6E6F726D616C697A65496E';
wwv_flow_imp.g_varchar2_table(23420) := '73657274696F6E506F696E7428652C6E2E6C696E65732C692E73746172744C696E654E756D6265722C746869732E5F696E64656E7453697A65292C6F3D746869732E5F6372656174654164644C696E65436F6D6D656E74734F7065726174696F6E73286E';
wwv_flow_imp.g_varchar2_table(23421) := '2E6C696E65732C692E73746172744C696E654E756D62657229293B636F6E737420733D6E6577206D6328692E706F736974696F6E4C696E654E756D6265722C692E706F736974696F6E436F6C756D6E293B666F72286C6574206E3D302C693D6F2E6C656E';
wwv_flow_imp.g_varchar2_table(23422) := '6774683B6E3C693B6E2B2B29742E616464456469744F7065726174696F6E286F5B6E5D2E72616E67652C6F5B6E5D2E74657874292C72682E6973456D707479286F5B6E5D2E72616E676529262672682E6765745374617274506F736974696F6E286F5B6E';
wwv_flow_imp.g_varchar2_table(23423) := '5D2E72616E6765292E657175616C732873292626652E6765744C696E65436F6E74656E7428732E6C696E654E756D626572292E6C656E6774682B313D3D3D732E636F6C756D6E262628746869732E5F64656C7461436F6C756D6E3D286F5B6E5D2E746578';
wwv_flow_imp.g_varchar2_table(23424) := '747C7C2222292E6C656E677468293B746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E2869297D5F617474656D707452656D6F7665426C6F636B436F6D6D656E7428652C742C6E2C69297B6C6574206F3D742E737461';
wwv_flow_imp.g_varchar2_table(23425) := '72744C696E654E756D6265722C733D742E656E644C696E654E756D6265723B636F6E737420723D692E6C656E6774682B4D6174682E6D617828652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E28742E73746172744C69';
wwv_flow_imp.g_varchar2_table(23426) := '6E654E756D626572292C742E7374617274436F6C756D6E293B6C657420613D652E6765744C696E65436F6E74656E74286F292E6C617374496E6465784F66286E2C722D31292C6C3D652E6765744C696E65436F6E74656E742873292E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(23427) := '692C742E656E64436F6C756D6E2D312D6E2E6C656E677468293B72657475726E2D31213D3D6126262D313D3D3D6C2626286C3D652E6765744C696E65436F6E74656E74286F292E696E6465784F6628692C612B6E2E6C656E677468292C733D6F292C2D31';
wwv_flow_imp.g_varchar2_table(23428) := '3D3D3D6126262D31213D3D6C262628613D652E6765744C696E65436F6E74656E742873292E6C617374496E6465784F66286E2C6C292C6F3D73292C21742E6973456D70747928297C7C2D31213D3D6126262D31213D3D6C7C7C28613D652E6765744C696E';
wwv_flow_imp.g_varchar2_table(23429) := '65436F6E74656E74286F292E696E6465784F66286E292C2D31213D3D612626286C3D652E6765744C696E65436F6E74656E74286F292E696E6465784F6628692C612B6E2E6C656E6774682929292C2D31213D3D61262633323D3D3D652E6765744C696E65';
wwv_flow_imp.g_varchar2_table(23430) := '436F6E74656E74286F292E63686172436F6465417428612B6E2E6C656E677468292626286E2B3D222022292C2D31213D3D6C262633323D3D3D652E6765744C696E65436F6E74656E742873292E63686172436F64654174286C2D3129262628693D222022';
wwv_flow_imp.g_varchar2_table(23431) := '2B692C6C2D3D31292C2D31213D3D6126262D31213D3D6C3F44592E5F63726561746552656D6F7665426C6F636B436F6D6D656E744F7065726174696F6E73286E6577207268286F2C612B6E2E6C656E6774682B312C732C6C2B31292C6E2C69293A6E756C';
wwv_flow_imp.g_varchar2_table(23432) := '6C7D5F65786563757465426C6F636B436F6D6D656E7428652C742C6E297B652E746F6B656E697A6174696F6E2E746F6B656E697A6549664368656170286E2E73746172744C696E654E756D626572293B636F6E737420693D652E6765744C616E67756167';
wwv_flow_imp.g_varchar2_table(23433) := '6549644174506F736974696F6E286E2E73746172744C696E654E756D6265722C31292C6F3D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2869292E63';
wwv_flow_imp.g_varchar2_table(23434) := '6F6D6D656E74733B696628216F7C7C216F2E626C6F636B436F6D6D656E745374617274546F6B656E7C7C216F2E626C6F636B436F6D6D656E74456E64546F6B656E2972657475726E3B636F6E737420733D6F2E626C6F636B436F6D6D656E745374617274';
wwv_flow_imp.g_varchar2_table(23435) := '546F6B656E2C723D6F2E626C6F636B436F6D6D656E74456E64546F6B656E3B6C657420613D746869732E5F617474656D707452656D6F7665426C6F636B436F6D6D656E7428652C6E2C732C72293B6966282161297B6966286E2E6973456D707479282929';
wwv_flow_imp.g_varchar2_table(23436) := '7B636F6E737420743D652E6765744C696E65436F6E74656E74286E2E73746172744C696E654E756D626572293B6C657420693D6D692874293B2D313D3D3D69262628693D742E6C656E677468292C613D44592E5F637265617465416464426C6F636B436F';
wwv_flow_imp.g_varchar2_table(23437) := '6D6D656E744F7065726174696F6E73286E6577207268286E2E73746172744C696E654E756D6265722C692B312C6E2E73746172744C696E654E756D6265722C742E6C656E6774682B31292C732C722C746869732E5F696E736572745370616365297D656C';
wwv_flow_imp.g_varchar2_table(23438) := '736520613D44592E5F637265617465416464426C6F636B436F6D6D656E744F7065726174696F6E73286E6577207268286E2E73746172744C696E654E756D6265722C652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(23439) := '6E2E73746172744C696E654E756D626572292C6E2E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E286E2E656E644C696E654E756D62657229292C732C722C746869732E5F696E736572745370616365293B313D3D3D61';
wwv_flow_imp.g_varchar2_table(23440) := '2E6C656E677468262628746869732E5F64656C7461436F6C756D6E3D732E6C656E6774682B31297D746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E286E293B666F7228636F6E73742065206F66206129742E616464';
wwv_flow_imp.g_varchar2_table(23441) := '456469744F7065726174696F6E28652E72616E67652C652E74657874297D676574456469744F7065726174696F6E7328652C74297B6C6574206E3D746869732E5F73656C656374696F6E3B696628746869732E5F6D6F7665456E64506F736974696F6E44';
wwv_flow_imp.g_varchar2_table(23442) := '6F776E3D21312C6E2E73746172744C696E654E756D6265723D3D3D6E2E656E644C696E654E756D6265722626746869732E5F69676E6F726546697273744C696E652972657475726E20742E616464456469744F7065726174696F6E286E6577207268286E';
wwv_flow_imp.g_varchar2_table(23443) := '2E73746172744C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E286E2E73746172744C696E654E756D626572292C6E2E73746172744C696E654E756D6265722B312C31292C6E2E73746172744C696E654E756D6265723D3D3D652E';
wwv_flow_imp.g_varchar2_table(23444) := '6765744C696E65436F756E7428293F22223A225C6E22292C766F696428746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E286E29293B6E2E73746172744C696E654E756D6265723C6E2E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(23445) := '722626313D3D3D6E2E656E64436F6C756D6E262628746869732E5F6D6F7665456E64506F736974696F6E446F776E3D21302C6E3D6E2E736574456E64506F736974696F6E286E2E656E644C696E654E756D6265722D312C652E6765744C696E654D617843';
wwv_flow_imp.g_varchar2_table(23446) := '6F6C756D6E286E2E656E644C696E654E756D6265722D312929293B636F6E737420693D54592E5F676174686572507265666C696768744461746128746869732E5F747970652C746869732E5F696E7365727453706163652C652C6E2E73746172744C696E';
wwv_flow_imp.g_varchar2_table(23447) := '654E756D6265722C6E2E656E644C696E654E756D6265722C746869732E5F69676E6F7265456D7074794C696E65732C746869732E5F69676E6F726546697273744C696E652C746869732E6C616E6775616765436F6E66696775726174696F6E5365727669';
wwv_flow_imp.g_varchar2_table(23448) := '6365293B72657475726E20692E737570706F727465643F746869732E5F657865637574654C696E65436F6D6D656E747328652C742C692C6E293A746869732E5F65786563757465426C6F636B436F6D6D656E7428652C742C6E297D636F6D707574654375';
wwv_flow_imp.g_varchar2_table(23449) := '72736F72537461746528652C74297B6C6574206E3D742E676574547261636B656453656C656374696F6E28746869732E5F73656C656374696F6E4964293B72657475726E20746869732E5F6D6F7665456E64506F736974696F6E446F776E2626286E3D6E';
wwv_flow_imp.g_varchar2_table(23450) := '2E736574456E64506F736974696F6E286E2E656E644C696E654E756D6265722B312C3129292C6E6577206168286E2E73656C656374696F6E53746172744C696E654E756D6265722C6E2E73656C656374696F6E5374617274436F6C756D6E2B746869732E';
wwv_flow_imp.g_varchar2_table(23451) := '5F64656C7461436F6C756D6E2C6E2E706F736974696F6E4C696E654E756D6265722C6E2E706F736974696F6E436F6C756D6E2B746869732E5F64656C7461436F6C756D6E297D737461746963205F63726561746552656D6F76654C696E65436F6D6D656E';
wwv_flow_imp.g_varchar2_table(23452) := '74734F7065726174696F6E7328652C74297B636F6E7374206E3D5B5D3B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D655B695D3B6F2E69676E6F72657C7C6E2E70757368286A712E64656C657465';
wwv_flow_imp.g_varchar2_table(23453) := '286E657720726828742B692C6F2E636F6D6D656E745374724F66667365742B312C742B692C6F2E636F6D6D656E745374724F66667365742B6F2E636F6D6D656E745374724C656E6774682B312929297D72657475726E206E7D5F6372656174654164644C';
wwv_flow_imp.g_varchar2_table(23454) := '696E65436F6D6D656E74734F7065726174696F6E7328652C74297B636F6E7374206E3D5B5D2C693D746869732E5F696E7365727453706163653F2220223A22223B666F72286C6574206F3D302C733D652E6C656E6774683B6F3C733B6F2B2B297B636F6E';
wwv_flow_imp.g_varchar2_table(23455) := '737420733D655B6F5D3B732E69676E6F72657C7C6E2E70757368286A712E696E73657274286E6577206D6328742B6F2C732E636F6D6D656E745374724F66667365742B31292C732E636F6D6D656E745374722B6929297D72657475726E206E7D73746174';
wwv_flow_imp.g_varchar2_table(23456) := '6963206E65787456697369626C65436F6C756D6E28652C742C6E2C69297B72657475726E206E3F652B28742D652574293A652B697D737461746963205F6E6F726D616C697A65496E73657274696F6E506F696E7428652C742C6E2C69297B6C6574206F2C';
wwv_flow_imp.g_varchar2_table(23457) := '732C723D313037333734313832343B666F72286C6574206F3D302C733D742E6C656E6774683B6F3C733B6F2B2B297B696628745B6F5D2E69676E6F726529636F6E74696E75653B636F6E737420733D652E6765744C696E65436F6E74656E74286E2B6F29';
wwv_flow_imp.g_varchar2_table(23458) := '3B6C657420613D303B666F72286C657420653D302C6E3D745B6F5D2E636F6D6D656E745374724F66667365743B613C722626653C6E3B652B2B29613D54592E6E65787456697369626C65436F6C756D6E28612C692C393D3D3D732E63686172436F646541';
wwv_flow_imp.g_varchar2_table(23459) := '742865292C31293B613C72262628723D61297D723D4D6174682E666C6F6F7228722F69292A693B666F72286C657420613D302C6C3D742E6C656E6774683B613C6C3B612B2B297B696628745B615D2E69676E6F726529636F6E74696E75653B636F6E7374';
wwv_flow_imp.g_varchar2_table(23460) := '206C3D652E6765744C696E65436F6E74656E74286E2B61293B6C657420633D303B666F72286F3D302C733D745B615D2E636F6D6D656E745374724F66667365743B633C7226266F3C733B6F2B2B29633D54592E6E65787456697369626C65436F6C756D6E';
wwv_flow_imp.g_varchar2_table(23461) := '28632C692C393D3D3D6C2E63686172436F64654174286F292C31293B745B615D2E636F6D6D656E745374724F66667365743D633E723F6F2D313A6F7D7D7D636C61737320495920657874656E64732055647B636F6E7374727563746F7228652C74297B73';
wwv_flow_imp.g_varchar2_table(23462) := '757065722874292C746869732E5F747970653D657D72756E28652C74297B636F6E7374206E3D652E676574286567293B69662821742E6861734D6F64656C28292972657475726E3B636F6E737420693D5B5D2C6F3D742E6765744D6F64656C28292E6765';
wwv_flow_imp.g_varchar2_table(23463) := '744F7074696F6E7328292C733D742E6765744F7074696F6E283233292C723D742E67657453656C656374696F6E7328292E6D6170282828652C74293D3E287B73656C656374696F6E3A652C696E6465783A742C69676E6F726546697273744C696E653A21';
wwv_flow_imp.g_varchar2_table(23464) := '317D2929293B722E736F7274282828652C74293D3E72682E636F6D7061726552616E6765735573696E6753746172747328652E73656C656374696F6E2C742E73656C656374696F6E2929293B6C657420613D725B305D3B666F72286C657420653D313B65';
wwv_flow_imp.g_varchar2_table(23465) := '3C722E6C656E6774683B652B2B297B636F6E737420743D725B655D3B612E73656C656374696F6E2E656E644C696E654E756D6265723D3D3D742E73656C656374696F6E2E73746172744C696E654E756D626572262628612E696E6465783C742E696E6465';
wwv_flow_imp.g_varchar2_table(23466) := '783F742E69676E6F726546697273744C696E653D21303A28612E69676E6F726546697273744C696E653D21302C613D7429297D666F7228636F6E73742065206F66207229692E70757368286E6577205459286E2C652E73656C656374696F6E2C6F2E696E';
wwv_flow_imp.g_varchar2_table(23467) := '64656E7453697A652C746869732E5F747970652C732E696E7365727453706163652C732E69676E6F7265456D7074794C696E65732C652E69676E6F726546697273744C696E6529293B742E70757368556E646F53746F7028292C742E6578656375746543';
wwv_flow_imp.g_varchar2_table(23468) := '6F6D6D616E647328746869732E69642C69292C742E70757368556E646F53746F7028297D7D5A6428636C61737320657874656E64732049597B636F6E7374727563746F7228297B737570657228302C7B69643A22656469746F722E616374696F6E2E636F';
wwv_flow_imp.g_varchar2_table(23469) := '6D6D656E744C696E65222C6C6162656C3A6228302C22546F67676C65204C696E6520436F6D6D656E7422292C616C6961733A22546F67676C65204C696E6520436F6D6D656E74222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F';
wwv_flow_imp.g_varchar2_table(23470) := '7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A323133382C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F75703A2235';
wwv_flow_imp.g_varchar2_table(23471) := '5F696E73657274222C7469746C653A6228302C222626546F67676C65204C696E6520436F6D6D656E7422292C6F726465723A317D7D297D7D292C5A6428636C61737320657874656E64732049597B636F6E7374727563746F7228297B737570657228312C';
wwv_flow_imp.g_varchar2_table(23472) := '7B69643A22656469746F722E616374696F6E2E616464436F6D6D656E744C696E65222C6C6162656C3A6228302C22416464204C696E6520436F6D6D656E7422292C616C6961733A22416464204C696E6520436F6D6D656E74222C707265636F6E64697469';
wwv_flow_imp.g_varchar2_table(23473) := '6F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303831292C7765696768743A3130307D7D297D7D292C5A6428636C61737320657874';
wwv_flow_imp.g_varchar2_table(23474) := '656E64732049597B636F6E7374727563746F7228297B737570657228322C7B69643A22656469746F722E616374696F6E2E72656D6F7665436F6D6D656E744C696E65222C6C6162656C3A6228302C2252656D6F7665204C696E6520436F6D6D656E742229';
wwv_flow_imp.g_varchar2_table(23475) := '2C616C6961733A2252656D6F7665204C696E6520436F6D6D656E74222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A53652832';
wwv_flow_imp.g_varchar2_table(23476) := '3038392C32303939292C7765696768743A3130307D7D297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E626C6F636B436F6D6D656E74222C';
wwv_flow_imp.g_varchar2_table(23477) := '6C6162656C3A6228302C22546F67676C6520426C6F636B20436F6D6D656E7422292C616C6961733A22546F67676C6520426C6F636B20436F6D6D656E74222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B624578';
wwv_flow_imp.g_varchar2_table(23478) := '70723A6C682E656469746F7254657874466F6375732C7072696D6172793A313536372C6C696E75783A7B7072696D6172793A333130337D2C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E75626172456469744D';
wwv_flow_imp.g_varchar2_table(23479) := '656E752C67726F75703A22355F696E73657274222C7469746C653A6228302C22546F67676C65202626426C6F636B20436F6D6D656E7422292C6F726465723A327D7D297D72756E28652C74297B636F6E7374206E3D652E676574286567293B6966282174';
wwv_flow_imp.g_varchar2_table(23480) := '2E6861734D6F64656C28292972657475726E3B636F6E737420693D742E6765744F7074696F6E283233292C6F3D5B5D2C733D742E67657453656C656374696F6E7328293B666F7228636F6E73742065206F662073296F2E70757368286E65772044592865';
wwv_flow_imp.g_varchar2_table(23481) := '2C692E696E7365727453706163652C6E29293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C6F292C742E70757368556E646F53746F7028297D7D293B766172204D592C41593D66756E6374';
wwv_flow_imp.g_varchar2_table(23482) := '696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204E593D4D593D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E284D592E49';
wwv_flow_imp.g_varchar2_table(23483) := '44297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B746869732E5F636F6E746578744D656E75536572766963653D742C746869732E5F636F6E7465787456696577536572766963653D6E2C746869732E5F636F6E746578744B';
wwv_flow_imp.g_varchar2_table(23484) := '6579536572766963653D692C746869732E5F6B657962696E64696E67536572766963653D6F2C746869732E5F6D656E75536572766963653D732C746869732E5F636F6E66696775726174696F6E536572766963653D722C746869732E5F776F726B737061';
wwv_flow_imp.g_varchar2_table(23485) := '6365436F6E74657874536572766963653D612C746869732E5F746F446973706F73653D6E65772061742C746869732E5F636F6E746578744D656E7549734265696E6753686F776E436F756E743D302C746869732E5F656469746F723D652C746869732E5F';
wwv_flow_imp.g_varchar2_table(23486) := '746F446973706F73652E61646428746869732E5F656469746F722E6F6E436F6E746578744D656E752828653D3E746869732E5F6F6E436F6E746578744D656E752865292929292C746869732E5F746F446973706F73652E61646428746869732E5F656469';
wwv_flow_imp.g_varchar2_table(23487) := '746F722E6F6E4D6F757365576865656C2828653D3E7B696628746869732E5F636F6E746578744D656E7549734265696E6753686F776E436F756E743E30297B636F6E737420743D746869732E5F636F6E7465787456696577536572766963652E67657443';
wwv_flow_imp.g_varchar2_table(23488) := '6F6E7465787456696577456C656D656E7428292C6E3D652E737263456C656D656E743B6E2E736861646F77526F6F74262657732874293D3D3D6E2E736861646F77526F6F747C7C746869732E5F636F6E7465787456696577536572766963652E68696465';
wwv_flow_imp.g_varchar2_table(23489) := '436F6E746578745669657728297D7D2929292C746869732E5F746F446973706F73652E61646428746869732E5F656469746F722E6F6E4B6579446F776E2828653D3E7B746869732E5F656469746F722E6765744F7074696F6E28323429262635383D3D3D';
wwv_flow_imp.g_varchar2_table(23490) := '652E6B6579436F6465262628652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E73686F77436F6E746578744D656E752829297D2929297D5F6F6E436F6E746578744D656E752865297B696628';
wwv_flow_imp.g_varchar2_table(23491) := '21746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B69662821746869732E5F656469746F722E6765744F7074696F6E283234292972657475726E20746869732E5F656469746F722E666F63757328292C766F696428652E7461';
wwv_flow_imp.g_varchar2_table(23492) := '726765742E706F736974696F6E262621746869732E5F656469746F722E67657453656C656374696F6E28292E636F6E7461696E73506F736974696F6E28652E7461726765742E706F736974696F6E292626746869732E5F656469746F722E736574506F73';
wwv_flow_imp.g_varchar2_table(23493) := '6974696F6E28652E7461726765742E706F736974696F6E29293B69662831323D3D3D652E7461726765742E747970652972657475726E3B696628363D3D3D652E7461726765742E747970652626652E7461726765742E64657461696C2E696E6A65637465';
wwv_flow_imp.g_varchar2_table(23494) := '64546578742972657475726E3B696628652E6576656E742E70726576656E7444656661756C7428292C652E6576656E742E73746F7050726F7061676174696F6E28292C31313D3D3D652E7461726765742E747970652972657475726E20746869732E5F73';
wwv_flow_imp.g_varchar2_table(23495) := '686F775363726F6C6C626172436F6E746578744D656E7528652E6576656E74293B69662836213D3D652E7461726765742E74797065262637213D3D652E7461726765742E74797065262631213D3D652E7461726765742E747970652972657475726E3B69';
wwv_flow_imp.g_varchar2_table(23496) := '6628746869732E5F656469746F722E666F63757328292C652E7461726765742E706F736974696F6E297B6C657420743D21313B666F7228636F6E7374206E206F6620746869732E5F656469746F722E67657453656C656374696F6E732829296966286E2E';
wwv_flow_imp.g_varchar2_table(23497) := '636F6E7461696E73506F736974696F6E28652E7461726765742E706F736974696F6E29297B743D21303B627265616B7D747C7C746869732E5F656469746F722E736574506F736974696F6E28652E7461726765742E706F736974696F6E297D6C65742074';
wwv_flow_imp.g_varchar2_table(23498) := '3D6E756C6C3B31213D3D652E7461726765742E74797065262628743D652E6576656E74292C746869732E73686F77436F6E746578744D656E752874297D73686F77436F6E746578744D656E752865297B69662821746869732E5F656469746F722E676574';
wwv_flow_imp.g_varchar2_table(23499) := '4F7074696F6E283234292972657475726E3B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E5F6765744D656E75416374696F6E7328746869732E5F656469746F722E6765744D6F';
wwv_flow_imp.g_varchar2_table(23500) := '64656C28292C746869732E5F656469746F722E636F6E746578744D656E754964293B742E6C656E6774683E302626746869732E5F646F53686F77436F6E746578744D656E7528742C65297D5F6765744D656E75416374696F6E7328652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(23501) := '74206E3D5B5D2C693D746869732E5F6D656E75536572766963652E6372656174654D656E7528742C746869732E5F636F6E746578744B657953657276696365292C6F3D692E676574416374696F6E73287B6172673A652E7572697D293B692E646973706F';
wwv_flow_imp.g_varchar2_table(23502) := '736528293B666F7228636F6E73742074206F66206F297B636F6E73745B2C695D3D743B6C6574206F3D303B666F7228636F6E73742074206F662069296966287420696E7374616E63656F66204D64297B636F6E737420693D746869732E5F6765744D656E';
wwv_flow_imp.g_varchar2_table(23503) := '75416374696F6E7328652C742E6974656D2E7375626D656E75293B692E6C656E6774683E302626286E2E70757368286E657720776328742E69642C742E6C6162656C2C6929292C6F2B2B297D656C7365206E2E707573682874292C6F2B2B3B6F26266E2E';
wwv_flow_imp.g_varchar2_table(23504) := '70757368286E6577207963297D72657475726E206E2E6C656E67746826266E2E706F7028292C6E7D5F646F53686F77436F6E746578744D656E7528652C743D6E756C6C297B69662821746869732E5F656469746F722E6861734D6F64656C282929726574';
wwv_flow_imp.g_varchar2_table(23505) := '75726E3B636F6E7374206E3D746869732E5F656469746F722E6765744F7074696F6E283630293B746869732E5F656469746F722E7570646174654F7074696F6E73287B686F7665723A7B656E61626C65643A21317D7D293B6C657420693D743B69662821';
wwv_flow_imp.g_varchar2_table(23506) := '69297B746869732E5F656469746F722E72657665616C506F736974696F6E28746869732E5F656469746F722E676574506F736974696F6E28292C31292C746869732E5F656469746F722E72656E64657228293B636F6E737420653D746869732E5F656469';
wwv_flow_imp.g_varchar2_table(23507) := '746F722E6765745363726F6C6C656456697369626C65506F736974696F6E28746869732E5F656469746F722E676574506F736974696F6E2829292C743D417328746869732E5F656469746F722E676574446F6D4E6F64652829292C6E3D742E6C6566742B';
wwv_flow_imp.g_varchar2_table(23508) := '652E6C6566742C6F3D742E746F702B652E746F702B652E6865696768743B693D7B783A6E2C793A6F7D7D636F6E7374206F3D746869732E5F656469746F722E6765744F7074696F6E2831323729262621513B746869732E5F636F6E746578744D656E7549';
wwv_flow_imp.g_varchar2_table(23509) := '734265696E6753686F776E436F756E742B2B2C746869732E5F636F6E746578744D656E75536572766963652E73686F77436F6E746578744D656E75287B646F6D466F72536861646F77526F6F743A6F3F746869732E5F656469746F722E676574446F6D4E';
wwv_flow_imp.g_varchar2_table(23510) := '6F646528293A766F696420302C676574416E63686F723A28293D3E692C676574416374696F6E733A28293D3E652C676574416374696F6E566965774974656D3A653D3E7B636F6E737420743D746869732E5F6B657962696E64696E67466F722865293B69';
wwv_flow_imp.g_varchar2_table(23511) := '6628742972657475726E206E657720724D28652C652C7B6C6162656C3A21302C6B657962696E64696E673A742E6765744C6162656C28292C69734D656E753A21307D293B636F6E7374206E3D653B72657475726E2266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(23512) := '6F66206E2E676574416374696F6E566965774974656D3F6E2E676574416374696F6E566965774974656D28293A6E657720724D28652C652C7B69636F6E3A21302C6C6162656C3A21302C69734D656E753A21307D297D2C6765744B657942696E64696E67';
wwv_flow_imp.g_varchar2_table(23513) := '3A653D3E746869732E5F6B657962696E64696E67466F722865292C6F6E486964653A653D3E7B746869732E5F636F6E746578744D656E7549734265696E6753686F776E436F756E742D2D2C746869732E5F656469746F722E7570646174654F7074696F6E';
wwv_flow_imp.g_varchar2_table(23514) := '73287B686F7665723A6E7D297D7D297D5F73686F775363726F6C6C626172436F6E746578744D656E752865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B696628746869732E5F776F726B7370616365436F';
wwv_flow_imp.g_varchar2_table(23515) := '6E74657874536572766963652E676574576F726B737061636528292E69643D3D3D4F782972657475726E3B636F6E737420743D746869732E5F656469746F722E6765744F7074696F6E283733293B6C6574206E3D303B636F6E737420693D653D3E287B69';
wwv_flow_imp.g_varchar2_table(23516) := '643A226D656E752D616374696F6E2D222B202B2B6E2C6C6162656C3A652E6C6162656C2C746F6F6C7469703A22222C636C6173733A766F696420302C656E61626C65643A766F696420303D3D3D652E656E61626C65647C7C652E656E61626C65642C6368';
wwv_flow_imp.g_varchar2_table(23517) := '65636B65643A652E636865636B65642C72756E3A652E72756E7D292C6F3D28652C742C6F2C732C72293D3E7B69662821742972657475726E2069287B6C6162656C3A652C656E61626C65643A742C72756E3A28293D3E7B7D7D293B636F6E737420613D65';
wwv_flow_imp.g_varchar2_table(23518) := '3D3E28293D3E7B746869732E5F636F6E66696775726174696F6E536572766963652E75706461746556616C7565286F2C65297D2C6C3D5B5D3B666F7228636F6E73742065206F662072296C2E707573682869287B6C6162656C3A652E6C6162656C2C6368';
wwv_flow_imp.g_varchar2_table(23519) := '65636B65643A733D3D3D652E76616C75652C72756E3A6128652E76616C7565297D29293B72657475726E2828652C74293D3E6E657720776328226D656E752D616374696F6E2D222B202B2B6E2C652C742C766F69642030292928652C6C297D2C733D5B5D';
wwv_flow_imp.g_varchar2_table(23520) := '3B732E707573682869287B6C6162656C3A6228302C224D696E696D617022292C636865636B65643A742E656E61626C65642C72756E3A28293D3E7B746869732E5F636F6E66696775726174696F6E536572766963652E75706461746556616C7565282265';
wwv_flow_imp.g_varchar2_table(23521) := '6469746F722E6D696E696D61702E656E61626C6564222C21742E656E61626C6564297D7D29292C732E70757368286E6577207963292C732E707573682869287B6C6162656C3A6228302C2252656E646572204368617261637465727322292C656E61626C';
wwv_flow_imp.g_varchar2_table(23522) := '65643A742E656E61626C65642C636865636B65643A742E72656E646572436861726163746572732C72756E3A28293D3E7B746869732E5F636F6E66696775726174696F6E536572766963652E75706461746556616C75652822656469746F722E6D696E69';
wwv_flow_imp.g_varchar2_table(23523) := '6D61702E72656E64657243686172616374657273222C21742E72656E64657243686172616374657273297D7D29292C732E70757368286F286228302C22566572746963616C2073697A6522292C742E656E61626C65642C22656469746F722E6D696E696D';
wwv_flow_imp.g_varchar2_table(23524) := '61702E73697A65222C742E73697A652C5B7B6C6162656C3A6228302C2250726F706F7274696F6E616C22292C76616C75653A2270726F706F7274696F6E616C227D2C7B6C6162656C3A6228302C2246696C6C22292C76616C75653A2266696C6C227D2C7B';
wwv_flow_imp.g_varchar2_table(23525) := '6C6162656C3A6228302C2246697422292C76616C75653A22666974227D5D29292C732E70757368286F286228302C22536C6964657222292C742E656E61626C65642C22656469746F722E6D696E696D61702E73686F77536C69646572222C742E73686F77';
wwv_flow_imp.g_varchar2_table(23526) := '536C696465722C5B7B6C6162656C3A6228302C224D6F757365204F76657222292C76616C75653A226D6F7573656F766572227D2C7B6C6162656C3A6228302C22416C7761797322292C76616C75653A22616C77617973227D5D29293B636F6E737420723D';
wwv_flow_imp.g_varchar2_table(23527) := '746869732E5F656469746F722E6765744F7074696F6E2831323729262621513B746869732E5F636F6E746578744D656E7549734265696E6753686F776E436F756E742B2B2C746869732E5F636F6E746578744D656E75536572766963652E73686F77436F';
wwv_flow_imp.g_varchar2_table(23528) := '6E746578744D656E75287B646F6D466F72536861646F77526F6F743A723F746869732E5F656469746F722E676574446F6D4E6F646528293A766F696420302C676574416E63686F723A28293D3E652C676574416374696F6E733A28293D3E732C6F6E4869';
wwv_flow_imp.g_varchar2_table(23529) := '64653A653D3E7B746869732E5F636F6E746578744D656E7549734265696E6753686F776E436F756E742D2D2C746869732E5F656469746F722E666F63757328297D7D297D5F6B657962696E64696E67466F722865297B72657475726E20746869732E5F6B';
wwv_flow_imp.g_varchar2_table(23530) := '657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728652E6964297D646973706F736528297B746869732E5F636F6E746578744D656E7549734265696E6753686F776E436F756E743E302626746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(23531) := '7456696577536572766963652E68696465436F6E746578745669657728292C746869732E5F746F446973706F73652E646973706F736528297D7D3B4E592E49443D22656469746F722E636F6E747269622E636F6E746578746D656E75222C4E593D4D593D';
wwv_flow_imp.g_varchar2_table(23532) := '66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A69';
wwv_flow_imp.g_varchar2_table(23533) := '3B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73652066';
wwv_flow_imp.g_varchar2_table(23534) := '6F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E64';
wwv_flow_imp.g_varchar2_table(23535) := '6566696E6550726F706572747928742C6E2C72292C727D285B415928312C7145292C415928322C6A45292C415928332C6364292C415928342C2445292C415928352C4464292C415928362C6670292C415928372C4D78295D2C4E59292C4A64284E592E49';
wwv_flow_imp.g_varchar2_table(23536) := '442C4E592C32292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73686F77436F6E746578744D656E75222C6C6162656C3A6228302C2253686F7720';
wwv_flow_imp.g_varchar2_table(23537) := '456469746F7220436F6E74657874204D656E7522292C616C6961733A2253686F7720456469746F7220436F6E74657874204D656E75222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E70';
wwv_flow_imp.g_varchar2_table(23538) := '7574466F6375732C7072696D6172793A313039322C7765696768743A3130307D7D297D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D4E592E676574287429297C7C766F696420303D3D3D6E7C7C6E2E73686F77436F6E746578744D656E';
wwv_flow_imp.g_varchar2_table(23539) := '7528297D7D293B636C6173732050597B636F6E7374727563746F722865297B746869732E73656C656374696F6E733D657D657175616C732865297B636F6E737420743D746869732E73656C656374696F6E732E6C656E6774683B69662874213D3D652E73';
wwv_flow_imp.g_varchar2_table(23540) := '656C656374696F6E732E6C656E6774682972657475726E21313B666F72286C6574206E3D303B6E3C743B6E2B2B2969662821746869732E73656C656374696F6E735B6E5D2E657175616C7353656C656374696F6E28652E73656C656374696F6E735B6E5D';
wwv_flow_imp.g_varchar2_table(23541) := '292972657475726E21313B72657475726E21307D7D636C617373204F597B636F6E7374727563746F7228652C742C6E297B746869732E637572736F7253746174653D652C746869732E7363726F6C6C546F703D742C746869732E7363726F6C6C4C656674';
wwv_flow_imp.g_varchar2_table(23542) := '3D6E7D7D636C61737320525920657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2852592E4944297D636F6E7374727563746F722865297B737570657228292C746869732E5F65';
wwv_flow_imp.g_varchar2_table(23543) := '6469746F723D652C746869732E5F6973437572736F72556E646F5265646F3D21312C746869732E5F756E646F537461636B3D5B5D2C746869732E5F7265646F537461636B3D5B5D2C746869732E5F726567697374657228652E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(23544) := '4D6F64656C2828653D3E7B746869732E5F756E646F537461636B3D5B5D2C746869732E5F7265646F537461636B3D5B5D7D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B74';
wwv_flow_imp.g_varchar2_table(23545) := '6869732E5F756E646F537461636B3D5B5D2C746869732E5F7265646F537461636B3D5B5D7D2929292C746869732E5F726567697374657228652E6F6E4469644368616E6765437572736F7253656C656374696F6E2828743D3E7B696628746869732E5F69';
wwv_flow_imp.g_varchar2_table(23546) := '73437572736F72556E646F5265646F2972657475726E3B69662821742E6F6C6453656C656374696F6E732972657475726E3B696628742E6F6C644D6F64656C56657273696F6E4964213D3D742E6D6F64656C56657273696F6E49642972657475726E3B63';
wwv_flow_imp.g_varchar2_table(23547) := '6F6E7374206E3D6E657720505928742E6F6C6453656C656374696F6E73293B746869732E5F756E646F537461636B2E6C656E6774683E302626746869732E5F756E646F537461636B5B746869732E5F756E646F537461636B2E6C656E6774682D315D2E63';
wwv_flow_imp.g_varchar2_table(23548) := '7572736F7253746174652E657175616C73286E297C7C28746869732E5F756E646F537461636B2E70757368286E6577204F59286E2C652E6765745363726F6C6C546F7028292C652E6765745363726F6C6C4C656674282929292C746869732E5F7265646F';
wwv_flow_imp.g_varchar2_table(23549) := '537461636B3D5B5D2C746869732E5F756E646F537461636B2E6C656E6774683E35302626746869732E5F756E646F537461636B2E73686966742829297D2929297D637572736F72556E646F28297B746869732E5F656469746F722E6861734D6F64656C28';
wwv_flow_imp.g_varchar2_table(23550) := '29262630213D3D746869732E5F756E646F537461636B2E6C656E677468262628746869732E5F7265646F537461636B2E70757368286E6577204F59286E657720505928746869732E5F656469746F722E67657453656C656374696F6E732829292C746869';
wwv_flow_imp.g_varchar2_table(23551) := '732E5F656469746F722E6765745363726F6C6C546F7028292C746869732E5F656469746F722E6765745363726F6C6C4C656674282929292C746869732E5F6170706C79537461746528746869732E5F756E646F537461636B2E706F70282929297D637572';
wwv_flow_imp.g_varchar2_table(23552) := '736F725265646F28297B746869732E5F656469746F722E6861734D6F64656C2829262630213D3D746869732E5F7265646F537461636B2E6C656E677468262628746869732E5F756E646F537461636B2E70757368286E6577204F59286E65772050592874';
wwv_flow_imp.g_varchar2_table(23553) := '6869732E5F656469746F722E67657453656C656374696F6E732829292C746869732E5F656469746F722E6765745363726F6C6C546F7028292C746869732E5F656469746F722E6765745363726F6C6C4C656674282929292C746869732E5F6170706C7953';
wwv_flow_imp.g_varchar2_table(23554) := '7461746528746869732E5F7265646F537461636B2E706F70282929297D5F6170706C7953746174652865297B746869732E5F6973437572736F72556E646F5265646F3D21302C746869732E5F656469746F722E73657453656C656374696F6E7328652E63';
wwv_flow_imp.g_varchar2_table(23555) := '7572736F7253746174652E73656C656374696F6E73292C746869732E5F656469746F722E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A652E7363726F6C6C546F702C7363726F6C6C4C6566743A652E7363726F6C6C4C656674';
wwv_flow_imp.g_varchar2_table(23556) := '7D292C746869732E5F6973437572736F72556E646F5265646F3D21317D7D52592E49443D22656469746F722E636F6E747269622E637572736F72556E646F5265646F436F6E74726F6C6C6572222C4A642852592E49442C52592C30292C5A6428636C6173';
wwv_flow_imp.g_varchar2_table(23557) := '7320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22637572736F72556E646F222C6C6162656C3A6228302C22437572736F7220556E646F22292C616C6961733A22437572736F7220556E646F222C707265636F';
wwv_flow_imp.g_varchar2_table(23558) := '6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323039392C7765696768743A3130307D7D297D72756E28652C742C6E297B76617220693B6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(23559) := '693D52592E676574287429297C7C766F696420303D3D3D697C7C692E637572736F72556E646F28297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22637572736F725265646F22';
wwv_flow_imp.g_varchar2_table(23560) := '2C6C6162656C3A6228302C22437572736F72205265646F22292C616C6961733A22437572736F72205265646F222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C742C6E297B76617220693B6E756C6C3D3D3D28693D52592E6765';
wwv_flow_imp.g_varchar2_table(23561) := '74287429297C7C766F696420303D3D3D697C7C692E637572736F725265646F28297D7D293B7661722046593D6E2831393231292C42593D7B7D3B66756E6374696F6E20565928297B72657475726E206E6F262621216E6F2E5653434F44455F4445567D66';
wwv_flow_imp.g_varchar2_table(23562) := '756E6374696F6E207A592865297B69662856592829297B636F6E737420743D66756E6374696F6E28297B48597C7C2848593D6E657720536574293B636F6E737420653D676C6F62616C546869733B72657475726E20652E24686F7452656C6F61645F6170';
wwv_flow_imp.g_varchar2_table(23563) := '706C794E65774578706F7274737C7C28652E24686F7452656C6F61645F6170706C794E65774578706F7274733D653D3E7B636F6E737420743D7B636F6E6669673A7B6D6F64653A766F696420307D2C2E2E2E657D3B666F7228636F6E73742065206F6620';
wwv_flow_imp.g_varchar2_table(23564) := '4859297B636F6E7374206E3D652874293B6966286E2972657475726E206E7D7D292C48597D28293B72657475726E20742E6164642865292C7B646973706F736528297B742E64656C6574652865297D7D7D72657475726E7B646973706F736528297B7D7D';
wwv_flow_imp.g_varchar2_table(23565) := '7D6C65742048593B66756E6374696F6E20575928652C74297B636F6E7374206E3D6E65772061742C693D652E6372656174654465636F726174696F6E73436F6C6C656374696F6E28293B72657475726E206E2E616464287449287B64656275674E616D65';
wwv_flow_imp.g_varchar2_table(23566) := '3A28293D3E604170706C79206465636F726174696F6E732066726F6D20247B742E64656275674E616D657D607D2C28653D3E7B636F6E7374206E3D742E726561642865293B692E736574286E297D2929292C6E2E616464287B646973706F73653A28293D';
wwv_flow_imp.g_varchar2_table(23567) := '3E7B692E636C65617228297D7D292C6E7D66756E6374696F6E206A5928652C74297B72657475726E20652E617070656E644368696C642874292C7274282828293D3E7B652E72656D6F76654368696C642874297D29297D42592E7374796C655461675472';
wwv_flow_imp.g_varchar2_table(23568) := '616E73666F726D3D6A7228292C42592E736574417474726962757465733D567228292C42592E696E736572743D467228292E62696E64286E756C6C2C226865616422292C42592E646F6D4150493D4F7228292C42592E696E736572745374796C65456C65';
wwv_flow_imp.g_varchar2_table(23569) := '6D656E743D487228292C4E7228292846592E412C4259292C46592E41262646592E412E6C6F63616C73262646592E412E6C6F63616C732C5659282926267A592828287B6F6C644578706F7274733A652C6E65775372633A742C636F6E6669673A6E7D293D';
wwv_flow_imp.g_varchar2_table(23570) := '3E7B6966282270617463682D70726F746F74797065223D3D3D6E2E6D6F64652972657475726E20743D3E7B766172206E2C693B666F7228636F6E7374206F20696E2074297B636F6E737420733D745B6F5D3B696628636F6E736F6C652E6C6F6728605B68';
wwv_flow_imp.g_varchar2_table(23571) := '6F742D72656C6F61645D205061746368696E672070726F746F74797065206D6574686F6473206F662027247B6F7D27602C7B6578706F727465644974656D3A737D292C2266756E6374696F6E223D3D747970656F6620732626732E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(23572) := '297B636F6E737420723D655B6F5D3B69662872297B666F7228636F6E73742065206F66204F626A6563742E6765744F776E50726F70657274794E616D657328732E70726F746F7479706529297B636F6E737420743D4F626A6563742E6765744F776E5072';
wwv_flow_imp.g_varchar2_table(23573) := '6F706572747944657363726970746F7228732E70726F746F747970652C65292C613D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228722E70726F746F747970652C65293B286E756C6C3D3D3D286E3D6E756C6C3D3D743F';
wwv_flow_imp.g_varchar2_table(23574) := '766F696420303A742E76616C7565297C7C766F696420303D3D3D6E3F766F696420303A6E2E746F537472696E67282929213D3D286E756C6C3D3D3D28693D6E756C6C3D3D613F766F696420303A612E76616C7565297C7C766F696420303D3D3D693F766F';
wwv_flow_imp.g_varchar2_table(23575) := '696420303A692E746F537472696E672829292626636F6E736F6C652E6C6F6728605B686F742D72656C6F61645D205061746368696E672070726F746F74797065206D6574686F642027247B6F7D2E247B657D2760292C4F626A6563742E646566696E6550';
wwv_flow_imp.g_varchar2_table(23576) := '726F706572747928722E70726F746F747970652C652C74297D745B6F5D3D727D7D7D72657475726E21307D7D29293B636C61737320715920657874656E6473206C747B67657420776964746828297B72657475726E20746869732E5F77696474687D6765';
wwv_flow_imp.g_varchar2_table(23577) := '742068656967687428297B72657475726E20746869732E5F6865696768747D636F6E7374727563746F7228652C74297B737570657228292C746869732E656C656D656E7453697A654F627365727665723D746869732E5F7265676973746572286E657720';
wwv_flow_imp.g_varchar2_table(23578) := '664128652C7429292C746869732E5F77696474683D245428746869732C746869732E656C656D656E7453697A654F627365727665722E67657457696474682829292C746869732E5F6865696768743D245428746869732C746869732E656C656D656E7453';
wwv_flow_imp.g_varchar2_table(23579) := '697A654F627365727665722E6765744865696768742829292C746869732E5F726567697374657228746869732E656C656D656E7453697A654F627365727665722E6F6E4469644368616E67652828653D3E48542828653D3E7B746869732E5F7769647468';
wwv_flow_imp.g_varchar2_table(23580) := '2E73657428746869732E656C656D656E7453697A654F627365727665722E676574576964746828292C65292C746869732E5F6865696768742E73657428746869732E656C656D656E7453697A654F627365727665722E67657448656967687428292C6529';
wwv_flow_imp.g_varchar2_table(23581) := '7D29292929297D6F6273657276652865297B746869732E656C656D656E7453697A654F627365727665722E6F6273657276652865297D7365744175746F6D617469634C61796F75742865297B653F746869732E656C656D656E7453697A654F6273657276';
wwv_flow_imp.g_varchar2_table(23582) := '65722E73746172744F6273657276696E6728293A746869732E656C656D656E7453697A654F627365727665722E73746F704F6273657276696E6728297D7D66756E6374696F6E20245928652C742C6E297B6C657420693D742E67657428292C6F3D692C73';
wwv_flow_imp.g_varchar2_table(23583) := '3D693B636F6E737420723D24542822616E696D6174656456616C7565222C69293B6C657420612C6C3D2D313B66756E6374696F6E206328297B636F6E737420743D446174652E6E6F7728292D6C3B766172206E2C642C683B733D4D6174682E666C6F6F72';
wwv_flow_imp.g_varchar2_table(23584) := '2828643D6F2C683D692D6F2C286E3D74293D3D3D3330303F642B683A682A28312D4D6174682E706F7728322C2D31302A6E2F33303029292B6429292C743C3330303F613D652E72657175657374416E696D6174696F6E4672616D652863293A733D692C72';
wwv_flow_imp.g_varchar2_table(23585) := '2E73657428732C766F69642030297D72657475726E206E2E616464286E49287B637265617465456D7074794368616E676553756D6D6172793A28293D3E287B616E696D6174653A21317D292C68616E646C654368616E67653A28652C6E293D3E28652E64';
wwv_flow_imp.g_varchar2_table(23586) := '69644368616E67652874292626286E2E616E696D6174653D6E2E616E696D6174657C7C652E6368616E6765292C2130297D2C28286E2C72293D3E7B766F69642030213D3D61262628652E63616E63656C416E696D6174696F6E4672616D652861292C613D';
wwv_flow_imp.g_varchar2_table(23587) := '766F69642030292C6F3D732C693D742E72656164286E292C6C3D446174652E6E6F7728292D28722E616E696D6174653F303A333030292C6328297D2929292C727D636C61737320555920657874656E6473206C747B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(23588) := '2C6E297B737570657228292C746869732E5F7265676973746572286E657720475928652C6E29292C746869732E5F7265676973746572285159286E2C7B6865696768743A742E61637475616C4865696768742C746F703A742E61637475616C546F707D29';
wwv_flow_imp.g_varchar2_table(23589) := '297D7D636C617373204B597B6765742061667465724C696E654E756D62657228297B72657475726E20746869732E5F61667465724C696E654E756D6265722E67657428297D636F6E7374727563746F7228652C74297B746869732E5F61667465724C696E';
wwv_flow_imp.g_varchar2_table(23590) := '654E756D6265723D652C746869732E686569676874496E50783D742C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F61637475616C546F703D245428746869732C766F696420';
wwv_flow_imp.g_varchar2_table(23591) := '30292C746869732E5F61637475616C4865696768743D245428746869732C766F69642030292C746869732E61637475616C546F703D746869732E5F61637475616C546F702C746869732E61637475616C4865696768743D746869732E5F61637475616C48';
wwv_flow_imp.g_varchar2_table(23592) := '65696768742C746869732E73686F77496E48696464656E41726561733D21302C746869732E6F6E4368616E67653D746869732E5F61667465724C696E654E756D6265722C746869732E6F6E446F6D4E6F6465546F703D653D3E7B746869732E5F61637475';
wwv_flow_imp.g_varchar2_table(23593) := '616C546F702E73657428652C766F69642030297D2C746869732E6F6E436F6D70757465644865696768743D653D3E7B746869732E5F61637475616C4865696768742E73657428652C766F69642030297D7D7D636C6173732047597B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(23594) := '6F7228652C74297B746869732E5F656469746F723D652C746869732E5F646F6D456C656D656E743D742C746869732E5F6F7665726C617957696467657449643D226D616E616765644F7665726C61795769646765742D222B47592E5F636F756E7465722B';
wwv_flow_imp.g_varchar2_table(23595) := '2B2C746869732E5F6F7665726C61795769646765743D7B67657449643A28293D3E746869732E5F6F7665726C617957696467657449642C676574446F6D4E6F64653A28293D3E746869732E5F646F6D456C656D656E742C676574506F736974696F6E3A28';
wwv_flow_imp.g_varchar2_table(23596) := '293D3E6E756C6C7D2C746869732E5F656469746F722E6164644F7665726C617957696467657428746869732E5F6F7665726C6179576964676574297D646973706F736528297B746869732E5F656469746F722E72656D6F76654F7665726C617957696467';
wwv_flow_imp.g_varchar2_table(23597) := '657428746869732E5F6F7665726C6179576964676574297D7D66756E6374696F6E20515928652C74297B72657475726E20654928286E3D3E7B666F72286C65745B692C6F5D6F66204F626A6563742E656E7472696573287429296F2626226F626A656374';
wwv_flow_imp.g_varchar2_table(23598) := '223D3D747970656F66206F2626227265616422696E206F2626286F3D6F2E72656164286E29292C226E756D626572223D3D747970656F66206F2626286F3D60247B6F7D707860292C693D692E7265706C616365282F5B412D5A5D2F672C28653D3E222D22';
wwv_flow_imp.g_varchar2_table(23599) := '2B652E746F4C6F77657243617365282929292C652E7374796C655B695D3D6F7D29297D66756E6374696F6E20595928652C74297B72657475726E2066756E6374696F6E28652C74297B5659282926266349282272656C6F6164222C28743D3E7A59282828';
wwv_flow_imp.g_varchar2_table(23600) := '7B6F6C644578706F7274733A6E7D293D3E7B6966285B2E2E2E4F626A6563742E76616C756573286E295D2E736F6D652828743D3E652E696E636C7564657328742929292972657475726E20653D3E287428766F69642030292C2130297D292929292E7265';
wwv_flow_imp.g_varchar2_table(23601) := '61642874297D285B655D2C74292C657D66756E6374696F6E205A5928652C742C6E2C69297B636F6E7374206F3D6E65772061742C733D5B5D3B72657475726E206F2E6164642869492828286F2C72293D3E7B636F6E737420613D742E72656164286F292C';
wwv_flow_imp.g_varchar2_table(23602) := '6C3D6E6577204D61702C633D6E6577204D61703B6E26266E282130292C652E6368616E6765566965775A6F6E65732828653D3E7B666F7228636F6E73742074206F66207329652E72656D6F76655A6F6E652874292C6E756C6C3D3D697C7C692E64656C65';
wwv_flow_imp.g_varchar2_table(23603) := '74652874293B732E6C656E6774683D303B666F7228636F6E73742074206F662061297B636F6E7374206E3D652E6164645A6F6E652874293B742E7365745A6F6E6549642626742E7365745A6F6E654964286E292C732E70757368286E292C6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(23604) := '697C7C692E616464286E292C6C2E73657428742C6E297D7D29292C6E26266E282131292C722E616464286E49287B637265617465456D7074794368616E676553756D6D6172793A28293D3E287B7A6F6E654964733A5B5D7D292C68616E646C654368616E';
wwv_flow_imp.g_varchar2_table(23605) := '676528652C74297B636F6E7374206E3D632E67657428652E6368616E6765644F627365727661626C65293B72657475726E20766F69642030213D3D6E2626742E7A6F6E654964732E70757368286E292C21307D7D2C2828742C69293D3E7B666F7228636F';
wwv_flow_imp.g_varchar2_table(23606) := '6E73742065206F66206129652E6F6E4368616E6765262628632E73657428652E6F6E4368616E67652C6C2E676574286529292C652E6F6E4368616E67652E72656164287429293B6E26266E282130292C652E6368616E6765566965775A6F6E6573282865';
wwv_flow_imp.g_varchar2_table(23607) := '3D3E7B666F7228636F6E73742074206F6620692E7A6F6E6549647329652E6C61796F75745A6F6E652874297D29292C6E26266E282131297D2929297D2929292C6F2E616464287B646973706F736528297B6E26266E282130292C652E6368616E67655669';
wwv_flow_imp.g_varchar2_table(23608) := '65775A6F6E65732828653D3E7B666F7228636F6E73742074206F66207329652E72656D6F76655A6F6E652874297D29292C6E756C6C3D3D697C7C692E636C65617228292C6E26266E282131297D7D292C6F7D47592E5F636F756E7465723D303B636C6173';
wwv_flow_imp.g_varchar2_table(23609) := '7320585920657874656E6473204E747B646973706F736528297B73757065722E646973706F7365282130297D7D66756E6374696F6E204A5928652C74297B636F6E7374206E3D767528742C28743D3E742E6F726967696E616C2E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(23610) := '756D6265723C3D652E6C696E654E756D62657229293B696628216E2972657475726E2072682E66726F6D506F736974696F6E732865293B6966286E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653C3D652E6C696E654E';
wwv_flow_imp.g_varchar2_table(23611) := '756D626572297B636F6E737420743D652E6C696E654E756D6265722D6E2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B6E2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653B72657475';
wwv_flow_imp.g_varchar2_table(23612) := '726E2072682E66726F6D506F736974696F6E73286E6577206D6328742C652E636F6C756D6E29297D696628216E2E696E6E65724368616E6765732972657475726E2072682E66726F6D506F736974696F6E73286E6577206D63286E2E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(23613) := '2E73746172744C696E654E756D6265722C3129293B636F6E737420693D7675286E2E696E6E65724368616E6765732C28743D3E742E6F726967696E616C52616E67652E6765745374617274506F736974696F6E28292E69734265666F72654F7245717561';
wwv_flow_imp.g_varchar2_table(23614) := '6C28652929293B6966282169297B636F6E737420743D652E6C696E654E756D6265722D6E2E6F726967696E616C2E73746172744C696E654E756D6265722B6E2E6D6F6469666965642E73746172744C696E654E756D6265723B72657475726E2072682E66';
wwv_flow_imp.g_varchar2_table(23615) := '726F6D506F736974696F6E73286E6577206D6328742C652E636F6C756D6E29297D696628692E6F726967696E616C52616E67652E636F6E7461696E73506F736974696F6E2865292972657475726E20692E6D6F64696669656452616E67653B7B636F6E73';
wwv_flow_imp.g_varchar2_table(23616) := '7420743D286F3D692E6F726967696E616C52616E67652E676574456E64506F736974696F6E28292C733D652C6F2E6C696E654E756D6265723D3D3D732E6C696E654E756D6265723F6E6577206D6728302C732E636F6C756D6E2D6F2E636F6C756D6E293A';
wwv_flow_imp.g_varchar2_table(23617) := '6E6577206D6728732E6C696E654E756D6265722D6F2E6C696E654E756D6265722C732E636F6C756D6E2D3129293B72657475726E2072682E66726F6D506F736974696F6E7328742E616464546F506F736974696F6E28692E6D6F64696669656452616E67';
wwv_flow_imp.g_varchar2_table(23618) := '652E676574456E64506F736974696F6E282929297D766172206F2C737D66756E6374696F6E20655A28652C742C6E297B636F6E737420693D652E62696E64546F2874293B72657475726E207449287B64656275674E616D653A28293D3E6053657420436F';
wwv_flow_imp.g_varchar2_table(23619) := '6E74657874204B65792022247B652E6B65797D22607D2C28653D3E7B692E736574286E286529297D29297D636F6E737420745A3D706328226163636573736962696C6974795369676E616C5365727669636522293B53796D626F6C282241636B6E6F776C';
wwv_flow_imp.g_varchar2_table(23620) := '65646765446F63436F6D6D656E7473546F6B656E22293B636C617373206E5A7B7374617469632072656769737465722865297B72657475726E206E6577206E5A28652E66696C654E616D65297D636F6E7374727563746F722865297B746869732E66696C';
wwv_flow_imp.g_varchar2_table(23621) := '654E616D653D657D7D6E5A2E6572726F723D6E5A2E7265676973746572287B66696C654E616D653A226572726F722E6D7033227D292C6E5A2E7761726E696E673D6E5A2E7265676973746572287B66696C654E616D653A227761726E696E672E6D703322';
wwv_flow_imp.g_varchar2_table(23622) := '7D292C6E5A2E666F6C646564417265613D6E5A2E7265676973746572287B66696C654E616D653A22666F6C64656441726561732E6D7033227D292C6E5A2E627265616B3D6E5A2E7265676973746572287B66696C654E616D653A22627265616B2E6D7033';
wwv_flow_imp.g_varchar2_table(23623) := '227D292C6E5A2E717569636B46697865733D6E5A2E7265676973746572287B66696C654E616D653A22717569636B46697865732E6D7033227D292C6E5A2E7461736B436F6D706C657465643D6E5A2E7265676973746572287B66696C654E616D653A2274';
wwv_flow_imp.g_varchar2_table(23624) := '61736B436F6D706C657465642E6D7033227D292C6E5A2E7461736B4661696C65643D6E5A2E7265676973746572287B66696C654E616D653A227461736B4661696C65642E6D7033227D292C6E5A2E7465726D696E616C42656C6C3D6E5A2E726567697374';
wwv_flow_imp.g_varchar2_table(23625) := '6572287B66696C654E616D653A227465726D696E616C42656C6C2E6D7033227D292C6E5A2E646966664C696E65496E7365727465643D6E5A2E7265676973746572287B66696C654E616D653A22646966664C696E65496E7365727465642E6D7033227D29';
wwv_flow_imp.g_varchar2_table(23626) := '2C6E5A2E646966664C696E6544656C657465643D6E5A2E7265676973746572287B66696C654E616D653A22646966664C696E6544656C657465642E6D7033227D292C6E5A2E646966664C696E654D6F6469666965643D6E5A2E7265676973746572287B66';
wwv_flow_imp.g_varchar2_table(23627) := '696C654E616D653A22646966664C696E654D6F6469666965642E6D7033227D292C6E5A2E636861745265717565737453656E743D6E5A2E7265676973746572287B66696C654E616D653A22636861745265717565737453656E742E6D7033227D292C6E5A';
wwv_flow_imp.g_varchar2_table(23628) := '2E63686174526573706F6E73655265636569766564313D6E5A2E7265676973746572287B66696C654E616D653A2263686174526573706F6E73655265636569766564312E6D7033227D292C6E5A2E63686174526573706F6E73655265636569766564323D';
wwv_flow_imp.g_varchar2_table(23629) := '6E5A2E7265676973746572287B66696C654E616D653A2263686174526573706F6E73655265636569766564322E6D7033227D292C6E5A2E63686174526573706F6E73655265636569766564333D6E5A2E7265676973746572287B66696C654E616D653A22';
wwv_flow_imp.g_varchar2_table(23630) := '63686174526573706F6E73655265636569766564332E6D7033227D292C6E5A2E63686174526573706F6E73655265636569766564343D6E5A2E7265676973746572287B66696C654E616D653A2263686174526573706F6E73655265636569766564342E6D';
wwv_flow_imp.g_varchar2_table(23631) := '7033227D292C6E5A2E636C6561723D6E5A2E7265676973746572287B66696C654E616D653A22636C6561722E6D7033227D292C6E5A2E736176653D6E5A2E7265676973746572287B66696C654E616D653A22736176652E6D7033227D292C6E5A2E666F72';
wwv_flow_imp.g_varchar2_table(23632) := '6D61743D6E5A2E7265676973746572287B66696C654E616D653A22666F726D61742E6D7033227D292C6E5A2E766F6963655265636F7264696E67537461727465643D6E5A2E7265676973746572287B66696C654E616D653A22766F6963655265636F7264';
wwv_flow_imp.g_varchar2_table(23633) := '696E67537461727465642E6D7033227D292C6E5A2E766F6963655265636F7264696E6753746F707065643D6E5A2E7265676973746572287B66696C654E616D653A22766F6963655265636F7264696E6753746F707065642E6D7033227D292C6E5A2E7072';
wwv_flow_imp.g_varchar2_table(23634) := '6F67726573733D6E5A2E7265676973746572287B66696C654E616D653A2270726F67726573732E6D7033227D293B636C61737320695A7B636F6E7374727563746F722865297B746869732E72616E646F6D4F6E654F663D657D7D636C617373206F5A7B63';
wwv_flow_imp.g_varchar2_table(23635) := '6F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E736F756E643D652C746869732E6E616D653D742C746869732E6C6567616379536F756E6453657474696E67734B65793D6E2C746869732E73657474696E67734B65793D692C7468';
wwv_flow_imp.g_varchar2_table(23636) := '69732E6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793D6F2C746869732E616E6E6F756E63656D656E744D6573736167653D737D7374617469632072656769737465722865297B636F6E737420743D6E657720695A282272616E';
wwv_flow_imp.g_varchar2_table(23637) := '646F6D4F6E654F6622696E20652E736F756E643F652E736F756E642E72616E646F6D4F6E654F663A5B652E736F756E645D292C6E3D6E6577206F5A28742C652E6E616D652C652E6C6567616379536F756E6453657474696E67734B65792C652E73657474';
wwv_flow_imp.g_varchar2_table(23638) := '696E67734B65792C652E6C6567616379416E6E6F756E63656D656E7453657474696E67734B65792C652E616E6E6F756E63656D656E744D657373616765293B72657475726E206F5A2E5F7369676E616C732E616464286E292C6E7D7D6F5A2E5F7369676E';
wwv_flow_imp.g_varchar2_table(23639) := '616C733D6E6577205365742C6F5A2E6572726F724174506F736974696F6E3D6F5A2E7265676973746572287B6E616D653A6228302C224572726F7220617420506F736974696F6E22292C736F756E643A6E5A2E6572726F722C616E6E6F756E63656D656E';
wwv_flow_imp.g_varchar2_table(23640) := '744D6573736167653A6228302C224572726F7222292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E706F736974696F6E4861734572726F72227D292C6F5A2E7761726E696E674174506F736974696F6E3D6F5A';
wwv_flow_imp.g_varchar2_table(23641) := '2E7265676973746572287B6E616D653A6228302C225761726E696E6720617420506F736974696F6E22292C736F756E643A6E5A2E7761726E696E672C616E6E6F756E63656D656E744D6573736167653A6228302C225761726E696E6722292C7365747469';
wwv_flow_imp.g_varchar2_table(23642) := '6E67734B65793A226163636573736962696C6974792E7369676E616C732E706F736974696F6E4861735761726E696E67227D292C6F5A2E6572726F724F6E4C696E653D6F5A2E7265676973746572287B6E616D653A6228302C224572726F72206F6E204C';
wwv_flow_imp.g_varchar2_table(23643) := '696E6522292C736F756E643A6E5A2E6572726F722C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6C696E654861734572726F72222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A22';
wwv_flow_imp.g_varchar2_table(23644) := '6163636573736962696C6974792E616C6572742E6572726F72222C616E6E6F756E63656D656E744D6573736167653A6228302C224572726F72206F6E204C696E6522292C73657474696E67734B65793A226163636573736962696C6974792E7369676E61';
wwv_flow_imp.g_varchar2_table(23645) := '6C732E6C696E654861734572726F72227D292C6F5A2E7761726E696E674F6E4C696E653D6F5A2E7265676973746572287B6E616D653A6228302C225761726E696E67206F6E204C696E6522292C736F756E643A6E5A2E7761726E696E672C6C6567616379';
wwv_flow_imp.g_varchar2_table(23646) := '536F756E6453657474696E67734B65793A22617564696F437565732E6C696E654861735761726E696E67222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E7761726E69';
wwv_flow_imp.g_varchar2_table(23647) := '6E67222C616E6E6F756E63656D656E744D6573736167653A6228302C225761726E696E67206F6E204C696E6522292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E6C696E654861735761726E696E67227D292C';
wwv_flow_imp.g_varchar2_table(23648) := '6F5A2E666F6C646564417265613D6F5A2E7265676973746572287B6E616D653A6228302C22466F6C6465642041726561206F6E204C696E6522292C736F756E643A6E5A2E666F6C646564417265612C6C6567616379536F756E6453657474696E67734B65';
wwv_flow_imp.g_varchar2_table(23649) := '793A22617564696F437565732E6C696E65486173466F6C64656441726561222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E666F6C64656441726561222C616E6E6F75';
wwv_flow_imp.g_varchar2_table(23650) := '6E63656D656E744D6573736167653A6228302C22466F6C64656422292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E6C696E65486173466F6C64656441726561227D292C6F5A2E627265616B3D6F5A2E726567';
wwv_flow_imp.g_varchar2_table(23651) := '6973746572287B6E616D653A6228302C22427265616B706F696E74206F6E204C696E6522292C736F756E643A6E5A2E627265616B2C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6C696E65486173427265616B70';
wwv_flow_imp.g_varchar2_table(23652) := '6F696E74222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E627265616B706F696E74222C616E6E6F756E63656D656E744D6573736167653A6228302C22427265616B70';
wwv_flow_imp.g_varchar2_table(23653) := '6F696E7422292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E6C696E65486173427265616B706F696E74227D292C6F5A2E696E6C696E6553756767657374696F6E3D6F5A2E7265676973746572287B6E616D65';
wwv_flow_imp.g_varchar2_table(23654) := '3A6228302C22496E6C696E652053756767657374696F6E206F6E204C696E6522292C736F756E643A6E5A2E717569636B46697865732C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6C696E65486173496E6C696E';
wwv_flow_imp.g_varchar2_table(23655) := '6553756767657374696F6E222C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E6C696E65486173496E6C696E6553756767657374696F6E227D292C6F5A2E7465726D696E616C517569636B4669783D6F5A2E7265';
wwv_flow_imp.g_varchar2_table(23656) := '676973746572287B6E616D653A6228302C225465726D696E616C20517569636B2046697822292C736F756E643A6E5A2E717569636B46697865732C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E7465726D696E61';
wwv_flow_imp.g_varchar2_table(23657) := '6C517569636B466978222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E7465726D696E616C517569636B466978222C616E6E6F756E63656D656E744D6573736167653A';
wwv_flow_imp.g_varchar2_table(23658) := '6228302C22517569636B2046697822292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E7465726D696E616C517569636B466978227D292C6F5A2E6F6E4465627567427265616B3D6F5A2E726567697374657228';
wwv_flow_imp.g_varchar2_table(23659) := '7B6E616D653A6228302C2244656275676765722053746F70706564206F6E20427265616B706F696E7422292C736F756E643A6E5A2E627265616B2C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6F6E4465627567';
wwv_flow_imp.g_varchar2_table(23660) := '427265616B222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E6F6E4465627567427265616B222C616E6E6F756E63656D656E744D6573736167653A6228302C22427265';
wwv_flow_imp.g_varchar2_table(23661) := '616B706F696E7422292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E6F6E4465627567427265616B227D292C6F5A2E6E6F496E6C617948696E74733D6F5A2E7265676973746572287B6E616D653A6228302C22';
wwv_flow_imp.g_varchar2_table(23662) := '4E6F20496E6C61792048696E7473206F6E204C696E6522292C736F756E643A6E5A2E6572726F722C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6E6F496E6C617948696E7473222C6C6567616379416E6E6F756E';
wwv_flow_imp.g_varchar2_table(23663) := '63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E6E6F496E6C617948696E7473222C616E6E6F756E63656D656E744D6573736167653A6228302C224E6F20496E6C61792048696E747322292C7365747469';
wwv_flow_imp.g_varchar2_table(23664) := '6E67734B65793A226163636573736962696C6974792E7369676E616C732E6E6F496E6C617948696E7473227D292C6F5A2E7461736B436F6D706C657465643D6F5A2E7265676973746572287B6E616D653A6228302C225461736B20436F6D706C65746564';
wwv_flow_imp.g_varchar2_table(23665) := '22292C736F756E643A6E5A2E7461736B436F6D706C657465642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E7461736B436F6D706C65746564222C6C6567616379416E6E6F756E63656D656E7453657474696E67';
wwv_flow_imp.g_varchar2_table(23666) := '734B65793A226163636573736962696C6974792E616C6572742E7461736B436F6D706C65746564222C616E6E6F756E63656D656E744D6573736167653A6228302C225461736B20436F6D706C6574656422292C73657474696E67734B65793A2261636365';
wwv_flow_imp.g_varchar2_table(23667) := '73736962696C6974792E7369676E616C732E7461736B436F6D706C65746564227D292C6F5A2E7461736B4661696C65643D6F5A2E7265676973746572287B6E616D653A6228302C225461736B204661696C656422292C736F756E643A6E5A2E7461736B46';
wwv_flow_imp.g_varchar2_table(23668) := '61696C65642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E7461736B4661696C6564222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C65';
wwv_flow_imp.g_varchar2_table(23669) := '72742E7461736B4661696C6564222C616E6E6F756E63656D656E744D6573736167653A6228302C225461736B204661696C656422292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E7461736B4661696C656422';
wwv_flow_imp.g_varchar2_table(23670) := '7D292C6F5A2E7465726D696E616C436F6D6D616E644661696C65643D6F5A2E7265676973746572287B6E616D653A6228302C225465726D696E616C20436F6D6D616E64204661696C656422292C736F756E643A6E5A2E6572726F722C6C6567616379536F';
wwv_flow_imp.g_varchar2_table(23671) := '756E6453657474696E67734B65793A22617564696F437565732E7465726D696E616C436F6D6D616E644661696C6564222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E';
wwv_flow_imp.g_varchar2_table(23672) := '7465726D696E616C436F6D6D616E644661696C6564222C616E6E6F756E63656D656E744D6573736167653A6228302C22436F6D6D616E64204661696C656422292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E';
wwv_flow_imp.g_varchar2_table(23673) := '7465726D696E616C436F6D6D616E644661696C6564227D292C6F5A2E7465726D696E616C42656C6C3D6F5A2E7265676973746572287B6E616D653A6228302C225465726D696E616C2042656C6C22292C736F756E643A6E5A2E7465726D696E616C42656C';
wwv_flow_imp.g_varchar2_table(23674) := '6C2C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E7465726D696E616C42656C6C222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C657274';
wwv_flow_imp.g_varchar2_table(23675) := '2E7465726D696E616C42656C6C222C616E6E6F756E63656D656E744D6573736167653A6228302C225465726D696E616C2042656C6C22292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E7465726D696E616C42';
wwv_flow_imp.g_varchar2_table(23676) := '656C6C227D292C6F5A2E6E6F7465626F6F6B43656C6C436F6D706C657465643D6F5A2E7265676973746572287B6E616D653A6228302C224E6F7465626F6F6B2043656C6C20436F6D706C6574656422292C736F756E643A6E5A2E7461736B436F6D706C65';
wwv_flow_imp.g_varchar2_table(23677) := '7465642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6E6F7465626F6F6B43656C6C436F6D706C65746564222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962';
wwv_flow_imp.g_varchar2_table(23678) := '696C6974792E616C6572742E6E6F7465626F6F6B43656C6C436F6D706C65746564222C616E6E6F756E63656D656E744D6573736167653A6228302C224E6F7465626F6F6B2043656C6C20436F6D706C6574656422292C73657474696E67734B65793A2261';
wwv_flow_imp.g_varchar2_table(23679) := '63636573736962696C6974792E7369676E616C732E6E6F7465626F6F6B43656C6C436F6D706C65746564227D292C6F5A2E6E6F7465626F6F6B43656C6C4661696C65643D6F5A2E7265676973746572287B6E616D653A6228302C224E6F7465626F6F6B20';
wwv_flow_imp.g_varchar2_table(23680) := '43656C6C204661696C656422292C736F756E643A6E5A2E7461736B4661696C65642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E6E6F7465626F6F6B43656C6C4661696C6564222C6C6567616379416E6E6F756E';
wwv_flow_imp.g_varchar2_table(23681) := '63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E6E6F7465626F6F6B43656C6C4661696C6564222C616E6E6F756E63656D656E744D6573736167653A6228302C224E6F7465626F6F6B2043656C6C204661';
wwv_flow_imp.g_varchar2_table(23682) := '696C656422292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E6E6F7465626F6F6B43656C6C4661696C6564227D292C6F5A2E646966664C696E65496E7365727465643D6F5A2E7265676973746572287B6E616D';
wwv_flow_imp.g_varchar2_table(23683) := '653A6228302C2244696666204C696E6520496E73657274656422292C736F756E643A6E5A2E646966664C696E65496E7365727465642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E646966664C696E65496E7365';
wwv_flow_imp.g_varchar2_table(23684) := '72746564222C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E646966664C696E65496E736572746564227D292C6F5A2E646966664C696E6544656C657465643D6F5A2E7265676973746572287B6E616D653A6228';
wwv_flow_imp.g_varchar2_table(23685) := '302C2244696666204C696E652044656C6574656422292C736F756E643A6E5A2E646966664C696E6544656C657465642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E646966664C696E6544656C65746564222C73';
wwv_flow_imp.g_varchar2_table(23686) := '657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E646966664C696E6544656C65746564227D292C6F5A2E646966664C696E654D6F6469666965643D6F5A2E7265676973746572287B6E616D653A6228302C2244696666';
wwv_flow_imp.g_varchar2_table(23687) := '204C696E65204D6F64696669656422292C736F756E643A6E5A2E646966664C696E654D6F6469666965642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E646966664C696E654D6F646966696564222C7365747469';
wwv_flow_imp.g_varchar2_table(23688) := '6E67734B65793A226163636573736962696C6974792E7369676E616C732E646966664C696E654D6F646966696564227D292C6F5A2E636861745265717565737453656E743D6F5A2E7265676973746572287B6E616D653A6228302C224368617420526571';
wwv_flow_imp.g_varchar2_table(23689) := '756573742053656E7422292C736F756E643A6E5A2E636861745265717565737453656E742C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E636861745265717565737453656E74222C6C6567616379416E6E6F756E';
wwv_flow_imp.g_varchar2_table(23690) := '63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E636861745265717565737453656E74222C616E6E6F756E63656D656E744D6573736167653A6228302C224368617420526571756573742053656E742229';
wwv_flow_imp.g_varchar2_table(23691) := '2C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E636861745265717565737453656E74227D292C6F5A2E63686174526573706F6E736552656365697665643D6F5A2E7265676973746572287B6E616D653A622830';
wwv_flow_imp.g_varchar2_table(23692) := '2C224368617420526573706F6E736520526563656976656422292C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E63686174526573706F6E73655265636569766564222C736F756E643A7B72616E646F6D4F6E654F';
wwv_flow_imp.g_varchar2_table(23693) := '663A5B6E5A2E63686174526573706F6E73655265636569766564312C6E5A2E63686174526573706F6E73655265636569766564322C6E5A2E63686174526573706F6E73655265636569766564332C6E5A2E63686174526573706F6E736552656365697665';
wwv_flow_imp.g_varchar2_table(23694) := '64345D7D2C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E63686174526573706F6E73655265636569766564227D292C6F5A2E70726F67726573733D6F5A2E7265676973746572287B6E616D653A6228302C2250';
wwv_flow_imp.g_varchar2_table(23695) := '726F677265737322292C736F756E643A6E5A2E70726F67726573732C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E63686174526573706F6E736550656E64696E67222C6C6567616379416E6E6F756E63656D656E';
wwv_flow_imp.g_varchar2_table(23696) := '7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E63686174526573706F6E736550726F6772657373222C616E6E6F756E63656D656E744D6573736167653A6228302C2250726F677265737322292C73657474696E6773';
wwv_flow_imp.g_varchar2_table(23697) := '4B65793A226163636573736962696C6974792E7369676E616C732E70726F6772657373227D292C6F5A2E636C6561723D6F5A2E7265676973746572287B6E616D653A6228302C22436C65617222292C736F756E643A6E5A2E636C6561722C6C6567616379';
wwv_flow_imp.g_varchar2_table(23698) := '536F756E6453657474696E67734B65793A22617564696F437565732E636C656172222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E636C656172222C616E6E6F756E63';
wwv_flow_imp.g_varchar2_table(23699) := '656D656E744D6573736167653A6228302C22436C65617222292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E636C656172227D292C6F5A2E736176653D6F5A2E7265676973746572287B6E616D653A6228302C';
wwv_flow_imp.g_varchar2_table(23700) := '225361766522292C736F756E643A6E5A2E736176652C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E73617665222C6C6567616379416E6E6F756E63656D656E7453657474696E67734B65793A2261636365737369';
wwv_flow_imp.g_varchar2_table(23701) := '62696C6974792E616C6572742E73617665222C616E6E6F756E63656D656E744D6573736167653A6228302C225361766522292C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E73617665227D292C6F5A2E666F72';
wwv_flow_imp.g_varchar2_table(23702) := '6D61743D6F5A2E7265676973746572287B6E616D653A6228302C22466F726D617422292C736F756E643A6E5A2E666F726D61742C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E666F726D6174222C6C6567616379';
wwv_flow_imp.g_varchar2_table(23703) := '416E6E6F756E63656D656E7453657474696E67734B65793A226163636573736962696C6974792E616C6572742E666F726D6174222C616E6E6F756E63656D656E744D6573736167653A6228302C22466F726D617422292C73657474696E67734B65793A22';
wwv_flow_imp.g_varchar2_table(23704) := '6163636573736962696C6974792E7369676E616C732E666F726D6174227D292C6F5A2E766F6963655265636F7264696E67537461727465643D6F5A2E7265676973746572287B6E616D653A6228302C22566F696365205265636F7264696E672053746172';
wwv_flow_imp.g_varchar2_table(23705) := '74656422292C736F756E643A6E5A2E766F6963655265636F7264696E67537461727465642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E766F6963655265636F7264696E6753746172746564222C73657474696E';
wwv_flow_imp.g_varchar2_table(23706) := '67734B65793A226163636573736962696C6974792E7369676E616C732E766F6963655265636F7264696E6753746172746564227D292C6F5A2E766F6963655265636F7264696E6753746F707065643D6F5A2E7265676973746572287B6E616D653A622830';
wwv_flow_imp.g_varchar2_table(23707) := '2C22566F696365205265636F7264696E672053746F7070656422292C736F756E643A6E5A2E766F6963655265636F7264696E6753746F707065642C6C6567616379536F756E6453657474696E67734B65793A22617564696F437565732E766F6963655265';
wwv_flow_imp.g_varchar2_table(23708) := '636F7264696E6753746F70706564222C73657474696E67734B65793A226163636573736962696C6974792E7369676E616C732E766F6963655265636F7264696E6753746F70706564227D293B76617220735A3D6E2832313830292C725A3D7B7D3B725A2E';
wwv_flow_imp.g_varchar2_table(23709) := '7374796C655461675472616E73666F726D3D6A7228292C725A2E736574417474726962757465733D567228292C725A2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C725A2E646F6D4150493D4F7228292C725A2E696E7365';
wwv_flow_imp.g_varchar2_table(23710) := '72745374796C65456C656D656E743D487228292C4E72282928735A2E412C725A292C735A2E412626735A2E412E6C6F63616C732626735A2E412E6C6F63616C733B76617220615A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D6172';
wwv_flow_imp.g_varchar2_table(23711) := '67756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C656374';
wwv_flow_imp.g_varchar2_table(23712) := '26262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D';
wwv_flow_imp.g_varchar2_table(23713) := '29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C6C5A3D66';
wwv_flow_imp.g_varchar2_table(23714) := '756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E737420635A3D54572822646966662D7265766965772D696E73657274222C4C6C2E6164642C6228302C2249636F6E20666F722027';
wwv_flow_imp.g_varchar2_table(23715) := '496E736572742720696E2061636365737369626C652064696666207669657765722E2229292C645A3D54572822646966662D7265766965772D72656D6F7665222C4C6C2E72656D6F76652C6228302C2249636F6E20666F72202752656D6F76652720696E';
wwv_flow_imp.g_varchar2_table(23716) := '2061636365737369626C652064696666207669657765722E2229292C685A3D54572822646966662D7265766965772D636C6F7365222C4C6C2E636C6F73652C6228302C2249636F6E20666F722027436C6F73652720696E2061636365737369626C652064';
wwv_flow_imp.g_varchar2_table(23717) := '696666207669657765722E2229293B6C657420755A3D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B737570657228292C746869732E5F706172656E744E6F64653D652C746869';
wwv_flow_imp.g_varchar2_table(23718) := '732E5F76697369626C653D742C746869732E5F73657456697369626C653D6E2C746869732E5F63616E436C6F73653D692C746869732E5F77696474683D6F2C746869732E5F6865696768743D732C746869732E5F64696666733D722C746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(23719) := '64656C733D612C746869732E5F696E7374616E74696174696F6E536572766963653D6C2C746869732E5F73746174653D5A5428746869732C2828652C74293D3E7B636F6E7374206E3D746869732E5F76697369626C652E726561642865293B6966287468';
wwv_flow_imp.g_varchar2_table(23720) := '69732E5F706172656E744E6F64652E7374796C652E7669736962696C6974793D6E3F2276697369626C65223A2268696464656E222C216E2972657475726E206E756C6C3B636F6E737420693D742E61646428746869732E5F696E7374616E74696174696F';
wwv_flow_imp.g_varchar2_table(23721) := '6E536572766963652E637265617465496E7374616E636528705A2C746869732E5F64696666732C746869732E5F6D6F64656C732C746869732E5F73657456697369626C652C746869732E5F63616E436C6F736529293B72657475726E7B6D6F64656C3A69';
wwv_flow_imp.g_varchar2_table(23722) := '2C766965773A742E61646428746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528775A2C746869732E5F706172656E744E6F64652C692C746869732E5F77696474682C746869732E5F686569676874';
wwv_flow_imp.g_varchar2_table(23723) := '2C746869732E5F6D6F64656C7329297D7D29292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F7265297D6E65787428297B48542828653D3E7B636F6E737420743D746869732E5F76697369626C652E';
wwv_flow_imp.g_varchar2_table(23724) := '67657428293B746869732E5F73657456697369626C652821302C65292C742626746869732E5F73746174652E67657428292E6D6F64656C2E6E65787447726F75702865297D29297D7072657628297B48542828653D3E7B746869732E5F73657456697369';
wwv_flow_imp.g_varchar2_table(23725) := '626C652821302C65292C746869732E5F73746174652E67657428292E6D6F64656C2E70726576696F757347726F75702865297D29297D636C6F736528297B48542828653D3E7B746869732E5F73657456697369626C652821312C65297D29297D7D3B755A';
wwv_flow_imp.g_varchar2_table(23726) := '2E5F7474506F6C6963793D6545282264696666526576696577222C7B63726561746548544D4C3A653D3E657D292C755A3D615A285B6C5A28382C7563295D2C755A293B6C657420705A3D636C61737320657874656E6473206C747B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(23727) := '6F7228652C742C6E2C692C6F297B737570657228292C746869732E5F64696666733D652C746869732E5F6D6F64656C733D742C746869732E5F73657456697369626C653D6E2C746869732E63616E436C6F73653D692C746869732E5F6163636573736962';
wwv_flow_imp.g_varchar2_table(23728) := '696C6974795369676E616C536572766963653D6F2C746869732E5F67726F7570733D245428746869732C5B5D292C746869732E5F63757272656E7447726F75704964783D245428746869732C30292C746869732E5F63757272656E74456C656D656E7449';
wwv_flow_imp.g_varchar2_table(23729) := '64783D245428746869732C30292C746869732E67726F7570733D746869732E5F67726F7570732C746869732E63757272656E7447726F75703D746869732E5F63757272656E7447726F75704964782E6D6170282828652C74293D3E746869732E5F67726F';
wwv_flow_imp.g_varchar2_table(23730) := '7570732E726561642874295B655D29292C746869732E63757272656E7447726F7570496E6465783D746869732E5F63757272656E7447726F75704964782C746869732E63757272656E74456C656D656E743D746869732E5F63757272656E74456C656D65';
wwv_flow_imp.g_varchar2_table(23731) := '6E744964782E6D6170282828652C74293D3E7B766172206E3B72657475726E206E756C6C3D3D3D286E3D746869732E63757272656E7447726F75702E72656164287429297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C696E65735B655D7D29';
wwv_flow_imp.g_varchar2_table(23732) := '292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F64696666732E726561642865293B69662821742972657475726E20766F696420746869732E5F67726F7570732E736574285B5D2C766F69642030293B63';
wwv_flow_imp.g_varchar2_table(23733) := '6F6E7374206E3D66756E6374696F6E28652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E7374206F206F6620426828652C2828652C74293D3E742E6D6F6469666965642E73746172744C696E654E756D6265722D652E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(23734) := '656E644C696E654E756D6265724578636C75736976653C322A675A2929297B636F6E737420653D5B5D3B652E70757368286E657720765A293B636F6E737420733D6E6577207875284D6174682E6D617828312C6F5B305D2E6F726967696E616C2E737461';
wwv_flow_imp.g_varchar2_table(23735) := '72744C696E654E756D6265722D675A292C4D6174682E6D696E286F5B6F2E6C656E6774682D315D2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652B675A2C742B3129292C723D6E6577207875284D6174682E6D61782831';
wwv_flow_imp.g_varchar2_table(23736) := '2C6F5B305D2E6D6F6469666965642E73746172744C696E654E756D6265722D675A292C4D6174682E6D696E286F5B6F2E6C656E6774682D315D2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652B675A2C6E2B3129293B56';
wwv_flow_imp.g_varchar2_table(23737) := '68286F2C2828742C6E293D3E7B636F6E737420693D6E657720787528743F742E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976653A732E73746172744C696E654E756D6265722C6E3F6E2E6F726967696E616C2E7374617274';
wwv_flow_imp.g_varchar2_table(23738) := '4C696E654E756D6265723A732E656E644C696E654E756D6265724578636C7573697665292C6F3D6E657720787528743F742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976653A722E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(23739) := '6E3F6E2E6D6F6469666965642E73746172744C696E654E756D6265723A722E656E644C696E654E756D6265724578636C7573697665293B692E666F72456163682828743D3E7B652E70757368286E657720795A28742C6F2E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(23740) := '6265722B28742D692E73746172744C696E654E756D6265722929297D29292C6E2626286E2E6F726967696E616C2E666F72456163682828743D3E7B652E70757368286E657720625A286E2C7429297D29292C6E2E6D6F6469666965642E666F7245616368';
wwv_flow_imp.g_varchar2_table(23741) := '2828743D3E7B652E70757368286E6577205F5A286E2C7429297D2929297D29293B636F6E737420613D6F5B305D2E6D6F6469666965642E6A6F696E286F5B6F2E6C656E6774682D315D2E6D6F646966696564292C6C3D6F5B305D2E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(23742) := '6A6F696E286F5B6F2E6C656E6774682D315D2E6F726967696E616C293B692E70757368286E657720665A286E657720597A28612C6C292C6529297D72657475726E20697D28742C746869732E5F6D6F64656C732E6765744F726967696E616C4D6F64656C';
wwv_flow_imp.g_varchar2_table(23743) := '28292E6765744C696E65436F756E7428292C746869732E5F6D6F64656C732E6765744D6F6469666965644D6F64656C28292E6765744C696E65436F756E742829293B48542828653D3E7B636F6E737420743D746869732E5F6D6F64656C732E6765744D6F';
wwv_flow_imp.g_varchar2_table(23744) := '646966696564506F736974696F6E28293B69662874297B636F6E737420693D6E2E66696E64496E6465782828653D3E286E756C6C3D3D743F766F696420303A742E6C696E654E756D626572293C652E72616E67652E6D6F6469666965642E656E644C696E';
wwv_flow_imp.g_varchar2_table(23745) := '654E756D6265724578636C757369766529293B2D31213D3D692626746869732E5F63757272656E7447726F75704964782E73657428692C65297D746869732E5F67726F7570732E736574286E2C65297D29297D2929292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(23746) := '722865492828653D3E7B636F6E737420743D746869732E63757272656E74456C656D656E742E726561642865293B286E756C6C3D3D743F766F696420303A742E74797065293D3D3D6D5A2E44656C657465643F746869732E5F6163636573736962696C69';
wwv_flow_imp.g_varchar2_table(23747) := '74795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E6544656C657465642C7B736F757263653A2261636365737369626C65446966665669657765722E63757272656E74456C656D656E744368616E676564227D29';
wwv_flow_imp.g_varchar2_table(23748) := '3A286E756C6C3D3D743F766F696420303A742E74797065293D3D3D6D5A2E41646465642626746869732E5F6163636573736962696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E65496E736572746564';
wwv_flow_imp.g_varchar2_table(23749) := '2C7B736F757263653A2261636365737369626C65446966665669657765722E63757272656E74456C656D656E744368616E676564227D297D2929292C746869732E5F72656769737465722865492828653D3E7B76617220743B636F6E7374206E3D746869';
wwv_flow_imp.g_varchar2_table(23750) := '732E63757272656E74456C656D656E742E726561642865293B6966286E26266E2E74797065213D3D6D5A2E486561646572297B636F6E737420653D6E756C6C213D3D28743D6E2E6D6F6469666965644C696E654E756D626572292626766F69642030213D';
wwv_flow_imp.g_varchar2_table(23751) := '3D743F743A6E2E646966662E6D6F6469666965642E73746172744C696E654E756D6265723B746869732E5F6D6F64656C732E6D6F64696669656453657453656C656374696F6E2872682E66726F6D506F736974696F6E73286E6577206D6328652C312929';
wwv_flow_imp.g_varchar2_table(23752) := '297D7D2929297D5F676F546F47726F757044656C746128652C74297B636F6E7374206E3D746869732E67726F7570732E67657428293B216E7C7C6E2E6C656E6774683C3D317C7C6A5428742C28743D3E7B746869732E5F63757272656E7447726F757049';
wwv_flow_imp.g_varchar2_table(23753) := '64782E736574286D752E6F664C656E677468286E2E6C656E677468292E636C69704379636C696328746869732E5F63757272656E7447726F75704964782E67657428292B65292C74292C746869732E5F63757272656E74456C656D656E744964782E7365';
wwv_flow_imp.g_varchar2_table(23754) := '7428302C74297D29297D6E65787447726F75702865297B746869732E5F676F546F47726F757044656C746128312C65297D70726576696F757347726F75702865297B746869732E5F676F546F47726F757044656C7461282D312C65297D5F676F546F4C69';
wwv_flow_imp.g_varchar2_table(23755) := '6E6544656C74612865297B636F6E737420743D746869732E63757272656E7447726F75702E67657428293B21747C7C742E6C696E65732E6C656E6774683C3D317C7C485428286E3D3E7B746869732E5F63757272656E74456C656D656E744964782E7365';
wwv_flow_imp.g_varchar2_table(23756) := '74286D752E6F664C656E67746828742E6C696E65732E6C656E677468292E636C697028746869732E5F63757272656E74456C656D656E744964782E67657428292B65292C6E297D29297D676F546F4E6578744C696E6528297B746869732E5F676F546F4C';
wwv_flow_imp.g_varchar2_table(23757) := '696E6544656C74612831297D676F546F50726576696F75734C696E6528297B746869732E5F676F546F4C696E6544656C7461282D31297D676F546F4C696E652865297B636F6E737420743D746869732E63757272656E7447726F75702E67657428293B69';
wwv_flow_imp.g_varchar2_table(23758) := '662821742972657475726E3B636F6E7374206E3D742E6C696E65732E696E6465784F662865293B2D31213D3D6E262648542828653D3E7B746869732E5F63757272656E74456C656D656E744964782E736574286E2C65297D29297D72657665616C437572';
wwv_flow_imp.g_varchar2_table(23759) := '72656E74456C656D656E74496E456469746F7228297B69662821746869732E63616E436C6F73652E67657428292972657475726E3B746869732E5F73657456697369626C652821312C766F69642030293B636F6E737420653D746869732E63757272656E';
wwv_flow_imp.g_varchar2_table(23760) := '74456C656D656E742E67657428293B65262628652E747970653D3D3D6D5A2E44656C657465643F746869732E5F6D6F64656C732E6F726967696E616C52657665616C2872682E66726F6D506F736974696F6E73286E6577206D6328652E6F726967696E61';
wwv_flow_imp.g_varchar2_table(23761) := '6C4C696E654E756D6265722C312929293A746869732E5F6D6F64656C732E6D6F64696669656452657665616C28652E74797065213D3D6D5A2E4865616465723F72682E66726F6D506F736974696F6E73286E6577206D6328652E6D6F6469666965644C69';
wwv_flow_imp.g_varchar2_table(23762) := '6E654E756D6265722C3129293A766F6964203029297D636C6F736528297B746869732E63616E436C6F73652E6765742829262628746869732E5F73657456697369626C652821312C766F69642030292C746869732E5F6D6F64656C732E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(23763) := '64466F6375732829297D7D3B705A3D615A285B6C5A28342C745A295D2C705A293B636F6E737420675A3D333B766172206D5A3B2166756E6374696F6E2865297B655B652E4865616465723D305D3D22486561646572222C655B652E556E6368616E676564';
wwv_flow_imp.g_varchar2_table(23764) := '3D315D3D22556E6368616E676564222C655B652E44656C657465643D325D3D2244656C65746564222C655B652E41646465643D335D3D224164646564227D286D5A7C7C286D5A3D7B7D29293B636C61737320665A7B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(23765) := '297B746869732E72616E67653D652C746869732E6C696E65733D747D7D636C61737320765A7B636F6E7374727563746F7228297B746869732E747970653D6D5A2E4865616465727D7D636C61737320625A7B636F6E7374727563746F7228652C74297B74';
wwv_flow_imp.g_varchar2_table(23766) := '6869732E646966663D652C746869732E6F726967696E616C4C696E654E756D6265723D742C746869732E747970653D6D5A2E44656C657465642C746869732E6D6F6469666965644C696E654E756D6265723D766F696420307D7D636C617373205F5A7B63';
wwv_flow_imp.g_varchar2_table(23767) := '6F6E7374727563746F7228652C74297B746869732E646966663D652C746869732E6D6F6469666965644C696E654E756D6265723D742C746869732E747970653D6D5A2E41646465642C746869732E6F726967696E616C4C696E654E756D6265723D766F69';
wwv_flow_imp.g_varchar2_table(23768) := '6420307D7D636C61737320795A7B636F6E7374727563746F7228652C74297B746869732E6F726967696E616C4C696E654E756D6265723D652C746869732E6D6F6469666965644C696E654E756D6265723D742C746869732E747970653D6D5A2E556E6368';
wwv_flow_imp.g_varchar2_table(23769) := '616E6765647D7D6C657420775A3D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E5F656C656D656E743D652C746869732E5F6D6F64656C3D742C746869732E5F';
wwv_flow_imp.g_varchar2_table(23770) := '77696474683D6E2C746869732E5F6865696768743D692C746869732E5F6D6F64656C733D6F2C746869732E5F6C616E6775616765536572766963653D732C746869732E646F6D4E6F64653D746869732E5F656C656D656E742C746869732E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(23771) := '652E636C6173734E616D653D226D6F6E61636F2D636F6D706F6E656E7420646966662D726576696577206D6F6E61636F2D656469746F722D6261636B67726F756E64223B636F6E737420723D646F63756D656E742E637265617465456C656D656E742822';
wwv_flow_imp.g_varchar2_table(23772) := '64697622293B722E636C6173734E616D653D22646966662D7265766965772D616374696F6E73222C746869732E5F616374696F6E4261723D746869732E5F7265676973746572286E6577206C4D287229292C746869732E5F726567697374657228654928';
wwv_flow_imp.g_varchar2_table(23773) := '28653D3E7B746869732E5F616374696F6E4261722E636C65617228292C746869732E5F6D6F64656C2E63616E436C6F73652E726561642865292626746869732E5F616374696F6E4261722E70757368286E65772062632822646966667265766965772E63';
wwv_flow_imp.g_varchar2_table(23774) := '6C6F7365222C6228302C22436C6F736522292C22636C6F73652D646966662D72657669657720222B546C2E6173436C6173734E616D6528685A292C21302C286173796E6328293D3E742E636C6F7365282929292C7B6C6162656C3A21312C69636F6E3A21';
wwv_flow_imp.g_varchar2_table(23775) := '307D297D2929292C746869732E5F636F6E74656E743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F636F6E74656E742E636C6173734E616D653D22646966662D7265766965772D636F6E74656E74222C7468';
wwv_flow_imp.g_varchar2_table(23776) := '69732E5F636F6E74656E742E7365744174747269627574652822726F6C65222C22636F646522292C746869732E5F7363726F6C6C6261723D746869732E5F7265676973746572286E657720675428746869732E5F636F6E74656E742C7B7D29292C677228';
wwv_flow_imp.g_varchar2_table(23777) := '746869732E646F6D4E6F64652C746869732E5F7363726F6C6C6261722E676574446F6D4E6F646528292C72292C746869732E5F72656769737465722865492828653D3E7B746869732E5F6865696768742E726561642865292C746869732E5F7769647468';
wwv_flow_imp.g_varchar2_table(23778) := '2E726561642865292C746869732E5F7363726F6C6C6261722E7363616E446F6D4E6F646528297D2929292C746869732E5F7265676973746572287274282828293D3E7B677228746869732E646F6D4E6F6465297D2929292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(23779) := '657228515928746869732E646F6D4E6F64652C7B77696474683A746869732E5F77696474682C6865696768743A746869732E5F6865696768747D29292C746869732E5F726567697374657228515928746869732E5F636F6E74656E742C7B77696474683A';
wwv_flow_imp.g_varchar2_table(23780) := '746869732E5F77696474682C6865696768743A746869732E5F6865696768747D29292C746869732E5F7265676973746572286949282828652C74293D3E7B746869732E5F6D6F64656C2E63757272656E7447726F75702E726561642865292C746869732E';
wwv_flow_imp.g_varchar2_table(23781) := '5F72656E6465722874297D2929292C746869732E5F726567697374657228797328746869732E646F6D4E6F64652C226B6579646F776E222C28653D3E7B28652E657175616C73283138297C7C652E657175616C732832303636297C7C652E657175616C73';
wwv_flow_imp.g_varchar2_table(23782) := '283533302929262628652E70726576656E7444656661756C7428292C746869732E5F6D6F64656C2E676F546F4E6578744C696E652829292C28652E657175616C73283136297C7C652E657175616C732832303634297C7C652E657175616C732835323829';
wwv_flow_imp.g_varchar2_table(23783) := '29262628652E70726576656E7444656661756C7428292C746869732E5F6D6F64656C2E676F546F50726576696F75734C696E652829292C28652E657175616C732839297C7C652E657175616C732832303537297C7C652E657175616C7328353231297C7C';
wwv_flow_imp.g_varchar2_table(23784) := '652E657175616C7328313033332929262628652E70726576656E7444656661756C7428292C746869732E5F6D6F64656C2E636C6F73652829292C28652E657175616C73283130297C7C652E657175616C7328332929262628652E70726576656E74446566';
wwv_flow_imp.g_varchar2_table(23785) := '61756C7428292C746869732E5F6D6F64656C2E72657665616C43757272656E74456C656D656E74496E456469746F722829297D2929297D5F72656E6465722865297B636F6E737420743D746869732E5F6D6F64656C732E6765744F726967696E616C4F70';
wwv_flow_imp.g_varchar2_table(23786) := '74696F6E7328292C6E3D746869732E5F6D6F64656C732E6765744D6F6469666965644F7074696F6E7328292C693D646F63756D656E742E637265617465456C656D656E74282264697622293B692E636C6173734E616D653D22646966662D726576696577';
wwv_flow_imp.g_varchar2_table(23787) := '2D7461626C65222C692E7365744174747269627574652822726F6C65222C226C69737422292C692E7365744174747269627574652822617269612D6C6162656C222C6228302C2241636365737369626C652044696666205669657765722E205573652061';
wwv_flow_imp.g_varchar2_table(23788) := '72726F7720757020616E6420646F776E20746F206E617669676174652E2229292C724528692C6E2E67657428353029292C677228746869732E5F636F6E74656E742C69293B636F6E7374206F3D746869732E5F6D6F64656C732E6765744F726967696E61';
wwv_flow_imp.g_varchar2_table(23789) := '6C4D6F64656C28292C733D746869732E5F6D6F64656C732E6765744D6F6469666965644D6F64656C28293B696628216F7C7C21732972657475726E3B636F6E737420723D6F2E6765744F7074696F6E7328292C613D732E6765744F7074696F6E7328292C';
wwv_flow_imp.g_varchar2_table(23790) := '6C3D6E2E676574283637292C633D746869732E5F6D6F64656C2E63757272656E7447726F75702E67657428293B666F7228636F6E73742064206F66286E756C6C3D3D633F766F696420303A632E6C696E6573297C7C5B5D297B696628216329627265616B';
wwv_flow_imp.g_varchar2_table(23791) := '3B6C657420683B696628642E747970653D3D3D6D5A2E486561646572297B636F6E737420653D646F63756D656E742E637265617465456C656D656E74282264697622293B652E636C6173734E616D653D22646966662D7265766965772D726F77222C652E';
wwv_flow_imp.g_varchar2_table(23792) := '7365744174747269627574652822726F6C65222C226C6973746974656D22293B636F6E737420743D632E72616E67652C6E3D746869732E5F6D6F64656C2E63757272656E7447726F7570496E6465782E67657428292C693D746869732E5F6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(23793) := '67726F7570732E67657428292E6C656E6774682C6F3D653D3E303D3D3D653F6228302C226E6F206C696E6573206368616E67656422293A313D3D3D653F6228302C2231206C696E65206368616E67656422293A6228302C227B307D206C696E6573206368';
wwv_flow_imp.g_varchar2_table(23794) := '616E676564222C65292C733D6F28742E6F726967696E616C2E6C656E677468292C723D6F28742E6D6F6469666965642E6C656E677468293B652E7365744174747269627574652822617269612D6C6162656C222C6228302C22446966666572656E636520';
wwv_flow_imp.g_varchar2_table(23795) := '7B307D206F66207B317D3A206F726967696E616C206C696E65207B327D2C207B337D2C206D6F646966696564206C696E65207B347D2C207B357D222C6E2B312C692C742E6F726967696E616C2E73746172744C696E654E756D6265722C732C742E6D6F64';
wwv_flow_imp.g_varchar2_table(23796) := '69666965642E73746172744C696E654E756D6265722C7229293B636F6E737420613D646F63756D656E742E637265617465456C656D656E74282264697622293B612E636C6173734E616D653D22646966662D7265766965772D63656C6C20646966662D72';
wwv_flow_imp.g_varchar2_table(23797) := '65766965772D73756D6D617279222C612E617070656E644368696C6428646F63756D656E742E637265617465546578744E6F64652860247B6E2B317D2F247B697D3A204040202D247B742E6F726967696E616C2E73746172744C696E654E756D6265727D';
wwv_flow_imp.g_varchar2_table(23798) := '2C247B742E6F726967696E616C2E6C656E6774687D202B247B742E6D6F6469666965642E73746172744C696E654E756D6265727D2C247B742E6D6F6469666965642E6C656E6774687D2040406029292C652E617070656E644368696C642861292C683D65';
wwv_flow_imp.g_varchar2_table(23799) := '7D656C736520683D746869732E5F637265617465526F7728642C6C2C746869732E5F77696474682E67657428292C742C6F2C722C6E2C732C61293B692E617070656E644368696C642868293B636F6E737420753D51542828653D3E746869732E5F6D6F64';
wwv_flow_imp.g_varchar2_table(23800) := '656C2E63757272656E74456C656D656E742E726561642865293D3D3D6429293B652E6164642865492828653D3E7B636F6E737420743D752E726561642865293B682E746162496E6465783D743F303A2D312C742626682E666F63757328297D2929292C65';
wwv_flow_imp.g_varchar2_table(23801) := '2E61646428627328682C22666F637573222C2828293D3E7B746869732E5F6D6F64656C2E676F546F4C696E652864297D2929297D746869732E5F7363726F6C6C6261722E7363616E446F6D4E6F646528297D5F637265617465526F7728652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(23802) := '2C6F2C732C722C612C6C297B636F6E737420633D692E67657428313435292C643D632E676C7970684D617267696E57696474682B632E6C696E654E756D6265727357696474682C683D722E67657428313435292C753D31302B682E676C7970684D617267';
wwv_flow_imp.g_varchar2_table(23803) := '696E57696474682B682E6C696E654E756D6265727357696474683B6C657420703D22646966662D7265766965772D726F77222C673D22222C6D3D6E756C6C3B73776974636828652E74797065297B63617365206D5A2E41646465643A703D22646966662D';
wwv_flow_imp.g_varchar2_table(23804) := '7265766965772D726F77206C696E652D696E73657274222C673D2220636861722D696E73657274222C6D3D635A3B627265616B3B63617365206D5A2E44656C657465643A703D22646966662D7265766965772D726F77206C696E652D64656C657465222C';
wwv_flow_imp.g_varchar2_table(23805) := '673D2220636861722D64656C657465222C6D3D645A7D636F6E737420663D646F63756D656E742E637265617465456C656D656E74282264697622293B662E7374796C652E6D696E57696474683D6E2B227078222C662E636C6173734E616D653D702C662E';
wwv_flow_imp.g_varchar2_table(23806) := '7365744174747269627574652822726F6C65222C226C6973746974656D22292C662E617269614C6576656C3D22223B636F6E737420763D646F63756D656E742E637265617465456C656D656E74282264697622293B762E636C6173734E616D653D226469';
wwv_flow_imp.g_varchar2_table(23807) := '66662D7265766965772D63656C6C222C762E7374796C652E6865696768743D60247B747D7078602C662E617070656E644368696C642876293B636F6E7374205F3D646F63756D656E742E637265617465456C656D656E7428227370616E22293B5F2E7374';
wwv_flow_imp.g_varchar2_table(23808) := '796C652E77696474683D642B227078222C5F2E7374796C652E6D696E57696474683D642B227078222C5F2E636C6173734E616D653D22646966662D7265766965772D6C696E652D6E756D626572222B672C766F69642030213D3D652E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(23809) := '4C696E654E756D6265723F5F2E617070656E644368696C6428646F63756D656E742E637265617465546578744E6F646528537472696E6728652E6F726967696E616C4C696E654E756D6265722929293A5F2E696E6E6572546578743D22C2A0222C762E61';
wwv_flow_imp.g_varchar2_table(23810) := '7070656E644368696C64285F293B636F6E737420793D646F63756D656E742E637265617465456C656D656E7428227370616E22293B792E7374796C652E77696474683D752B227078222C792E7374796C652E6D696E57696474683D752B227078222C792E';
wwv_flow_imp.g_varchar2_table(23811) := '7374796C652E70616464696E6752696768743D2231307078222C792E636C6173734E616D653D22646966662D7265766965772D6C696E652D6E756D626572222B672C766F69642030213D3D652E6D6F6469666965644C696E654E756D6265723F792E6170';
wwv_flow_imp.g_varchar2_table(23812) := '70656E644368696C6428646F63756D656E742E637265617465546578744E6F646528537472696E6728652E6D6F6469666965644C696E654E756D6265722929293A792E696E6E6572546578743D22C2A0222C762E617070656E644368696C642879293B63';
wwv_flow_imp.g_varchar2_table(23813) := '6F6E737420773D646F63756D656E742E637265617465456C656D656E7428227370616E22293B696628772E636C6173734E616D653D22646966662D7265766965772D737061636572222C6D297B636F6E737420653D646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(23814) := '456C656D656E7428227370616E22293B652E636C6173734E616D653D546C2E6173436C6173734E616D65286D292C652E696E6E6572546578743D22C2A0C2A0222C772E617070656E644368696C642865297D656C736520772E696E6E6572546578743D22';
wwv_flow_imp.g_varchar2_table(23815) := 'C2A0C2A0223B6C657420433B696628762E617070656E644368696C642877292C766F69642030213D3D652E6D6F6469666965644C696E654E756D626572297B6C657420743D746869732E5F6765744C696E6548746D6C28612C722C6C2E74616253697A65';
wwv_flow_imp.g_varchar2_table(23816) := '2C652E6D6F6469666965644C696E654E756D6265722C746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F646563293B755A2E5F7474506F6C696379262628743D755A2E5F7474506F6C6963792E63726561746548544D';
wwv_flow_imp.g_varchar2_table(23817) := '4C287429292C762E696E7365727441646A6163656E7448544D4C28226265666F7265656E64222C74292C433D612E6765744C696E65436F6E74656E7428652E6D6F6469666965644C696E654E756D626572297D656C73657B6C657420743D746869732E5F';
wwv_flow_imp.g_varchar2_table(23818) := '6765744C696E6548746D6C286F2C692C732E74616253697A652C652E6F726967696E616C4C696E654E756D6265722C746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F646563293B755A2E5F7474506F6C6963792626';
wwv_flow_imp.g_varchar2_table(23819) := '28743D755A2E5F7474506F6C6963792E63726561746548544D4C287429292C762E696E7365727441646A6163656E7448544D4C28226265666F7265656E64222C74292C433D6F2E6765744C696E65436F6E74656E7428652E6F726967696E616C4C696E65';
wwv_flow_imp.g_varchar2_table(23820) := '4E756D626572297D303D3D3D432E6C656E677468262628433D6228302C22626C616E6B2229293B6C657420533D22223B73776974636828652E74797065297B63617365206D5A2E556E6368616E6765643A533D652E6F726967696E616C4C696E654E756D';
wwv_flow_imp.g_varchar2_table(23821) := '6265723D3D3D652E6D6F6469666965644C696E654E756D6265723F6228302C227B307D20756E6368616E676564206C696E65207B317D222C432C652E6F726967696E616C4C696E654E756D626572293A6228302C227B307D206F726967696E616C206C69';
wwv_flow_imp.g_varchar2_table(23822) := '6E65207B317D206D6F646966696564206C696E65207B327D222C432C652E6F726967696E616C4C696E654E756D6265722C652E6D6F6469666965644C696E654E756D626572293B627265616B3B63617365206D5A2E41646465643A533D6228302C222B20';
wwv_flow_imp.g_varchar2_table(23823) := '7B307D206D6F646966696564206C696E65207B317D222C432C652E6D6F6469666965644C696E654E756D626572293B627265616B3B63617365206D5A2E44656C657465643A533D6228302C222D207B307D206F726967696E616C206C696E65207B317D22';
wwv_flow_imp.g_varchar2_table(23824) := '2C432C652E6F726967696E616C4C696E654E756D626572297D72657475726E20662E7365744174747269627574652822617269612D6C6162656C222C53292C667D5F6765744C696E6548746D6C28652C742C6E2C692C6F297B636F6E737420733D652E67';
wwv_flow_imp.g_varchar2_table(23825) := '65744C696E65436F6E74656E742869292C723D742E676574283530292C613D57772E637265617465456D70747928732C6F292C6C3D784F2E69734261736963415343494928732C652E6D69676874436F6E7461696E4E6F6E426173696341534349492829';
wwv_flow_imp.g_varchar2_table(23826) := '292C633D784F2E636F6E7461696E7352544C28732C6C2C652E6D69676874436F6E7461696E52544C2829293B72657475726E20774E286E6577206D4E28722E69734D6F6E6F7370616365262621742E676574283333292C722E63616E55736548616C6677';
wwv_flow_imp.g_varchar2_table(23827) := '69647468526967687477617264734172726F772C732C21312C6C2C632C302C612C5B5D2C6E2C302C722E737061636557696474682C722E6D6964646F7457696474682C722E77736D6964646F7457696474682C742E67657428313137292C742E67657428';
wwv_flow_imp.g_varchar2_table(23828) := '3939292C742E676574283934292C742E67657428353129213D3D414C2E4F46462C6E756C6C29292E68746D6C7D7D3B775A3D615A285B6C5A28352C4C75295D2C775A293B636C61737320435A7B636F6E7374727563746F722865297B746869732E656469';
wwv_flow_imp.g_varchar2_table(23829) := '746F72733D657D6765744F726967696E616C4D6F64656C28297B72657475726E20746869732E656469746F72732E6F726967696E616C2E6765744D6F64656C28297D6765744F726967696E616C4F7074696F6E7328297B72657475726E20746869732E65';
wwv_flow_imp.g_varchar2_table(23830) := '6469746F72732E6F726967696E616C2E6765744F7074696F6E7328297D6F726967696E616C52657665616C2865297B746869732E656469746F72732E6F726967696E616C2E72657665616C52616E67652865292C746869732E656469746F72732E6F7269';
wwv_flow_imp.g_varchar2_table(23831) := '67696E616C2E73657453656C656374696F6E2865292C746869732E656469746F72732E6F726967696E616C2E666F63757328297D6765744D6F6469666965644D6F64656C28297B72657475726E20746869732E656469746F72732E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(23832) := '6765744D6F64656C28297D6765744D6F6469666965644F7074696F6E7328297B72657475726E20746869732E656469746F72732E6D6F6469666965642E6765744F7074696F6E7328297D6D6F64696669656452657665616C2865297B6526262874686973';
wwv_flow_imp.g_varchar2_table(23833) := '2E656469746F72732E6D6F6469666965642E72657665616C52616E67652865292C746869732E656469746F72732E6D6F6469666965642E73657453656C656374696F6E286529292C746869732E656469746F72732E6D6F6469666965642E666F63757328';
wwv_flow_imp.g_varchar2_table(23834) := '297D6D6F64696669656453657453656C656374696F6E2865297B746869732E656469746F72732E6D6F6469666965642E73657453656C656374696F6E2865297D6D6F646966696564466F63757328297B746869732E656469746F72732E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(23835) := '642E666F63757328297D6765744D6F646966696564506F736974696F6E28297B76617220653B72657475726E206E756C6C213D3D28653D746869732E656469746F72732E6D6F6469666965642E676574506F736974696F6E2829292626766F6964203021';
wwv_flow_imp.g_varchar2_table(23836) := '3D3D653F653A766F696420307D7D636C61737320535A20657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E5F726F6F74456C656D656E743D652C746869732E5F646966664D6F64656C';
wwv_flow_imp.g_varchar2_table(23837) := '3D742C746869732E5F6F726967696E616C456469746F724C61796F7574496E666F3D6E2C746869732E5F6D6F646966696564456469746F724C61796F7574496E666F3D692C746869732E5F656469746F72733D6F2C746869732E5F6F726967696E616C53';
wwv_flow_imp.g_varchar2_table(23838) := '63726F6C6C546F703D614928746869732E5F656469746F72732E6F726967696E616C2E6F6E4469645363726F6C6C4368616E67652C2828293D3E746869732E5F656469746F72732E6F726967696E616C2E6765745363726F6C6C546F70282929292C7468';
wwv_flow_imp.g_varchar2_table(23839) := '69732E5F6D6F6469666965645363726F6C6C546F703D614928746869732E5F656469746F72732E6D6F6469666965642E6F6E4469645363726F6C6C4368616E67652C2828293D3E746869732E5F656469746F72732E6D6F6469666965642E676574536372';
wwv_flow_imp.g_varchar2_table(23840) := '6F6C6C546F70282929292C746869732E5F766965775A6F6E65734368616E6765643D634928226F6E4469644368616E6765566965775A6F6E6573222C746869732E5F656469746F72732E6D6F6469666965642E6F6E4469644368616E6765566965775A6F';
wwv_flow_imp.g_varchar2_table(23841) := '6E6573292C746869732E77696474683D245428746869732C30292C746869732E5F6D6F646966696564566965775A6F6E65734368616E6765645369676E616C3D634928226D6F6469666965642E6F6E4469644368616E6765566965775A6F6E6573222C74';
wwv_flow_imp.g_varchar2_table(23842) := '6869732E5F656469746F72732E6D6F6469666965642E6F6E4469644368616E6765566965775A6F6E6573292C746869732E5F6F726967696E616C566965775A6F6E65734368616E6765645369676E616C3D634928226F726967696E616C2E6F6E44696443';
wwv_flow_imp.g_varchar2_table(23843) := '68616E6765566965775A6F6E6573222C746869732E5F656469746F72732E6F726967696E616C2E6F6E4469644368616E6765566965775A6F6E6573292C746869732E5F73746174653D5A5428746869732C2828652C74293D3E7B766172206E3B74686973';
wwv_flow_imp.g_varchar2_table(23844) := '2E5F656C656D656E742E7265706C6163654368696C6472656E28293B636F6E737420693D746869732E5F646966664D6F64656C2E726561642865292C6F3D6E756C6C3D3D3D286E3D6E756C6C3D3D693F766F696420303A692E646966662E726561642865';
wwv_flow_imp.g_varchar2_table(23845) := '29297C7C766F696420303D3D3D6E3F766F696420303A6E2E6D6F76656454657874733B696628216F7C7C303D3D3D6F2E6C656E6774682972657475726E20766F696420746869732E77696474682E73657428302C766F69642030293B746869732E5F7669';
wwv_flow_imp.g_varchar2_table(23846) := '65775A6F6E65734368616E6765642E726561642865293B636F6E737420733D746869732E5F6F726967696E616C456469746F724C61796F7574496E666F2E726561642865292C723D746869732E5F6D6F646966696564456469746F724C61796F7574496E';
wwv_flow_imp.g_varchar2_table(23847) := '666F2E726561642865293B69662821737C7C21722972657475726E20766F696420746869732E77696474682E73657428302C766F69642030293B746869732E5F6D6F646966696564566965775A6F6E65734368616E6765645369676E616C2E7265616428';
wwv_flow_imp.g_varchar2_table(23848) := '65292C746869732E5F6F726967696E616C566965775A6F6E65734368616E6765645369676E616C2E726561642865293B636F6E737420613D6F2E6D61702828743D3E7B66756E6374696F6E206E28652C74297B72657475726E28742E676574546F70466F';
wwv_flow_imp.g_varchar2_table(23849) := '724C696E654E756D62657228652E73746172744C696E654E756D6265722C2130292B742E676574546F70466F724C696E654E756D62657228652E656E644C696E654E756D6265724578636C75736976652C213029292F327D636F6E737420693D6E28742E';
wwv_flow_imp.g_varchar2_table(23850) := '6C696E6552616E67654D617070696E672E6F726967696E616C2C746869732E5F656469746F72732E6F726967696E616C292C6F3D746869732E5F6F726967696E616C5363726F6C6C546F702E726561642865292C733D6E28742E6C696E6552616E67654D';
wwv_flow_imp.g_varchar2_table(23851) := '617070696E672E6D6F6469666965642C746869732E5F656469746F72732E6D6F646966696564292C723D692D6F2C613D732D746869732E5F6D6F6469666965645363726F6C6C546F702E726561642865292C6C3D4D6174682E6D696E28692C73292C633D';
wwv_flow_imp.g_varchar2_table(23852) := '4D6174682E6D617828692C73293B72657475726E7B72616E67653A6E6577206D75286C2C63292C66726F6D3A722C746F3A612C66726F6D576974686F75745363726F6C6C3A692C746F576974686F75745363726F6C6C3A732C6D6F76653A747D7D29293B';
wwv_flow_imp.g_varchar2_table(23853) := '612E736F72742866756E6374696F6E282E2E2E65297B72657475726E28742C6E293D3E7B666F7228636F6E73742069206F662065297B636F6E737420653D6928742C6E293B6966282145682E69734E6569746865724C6573734F72477265617465725468';
wwv_flow_imp.g_varchar2_table(23854) := '616E2865292972657475726E20657D72657475726E2045682E6E6569746865724C6573734F72477265617465725468616E7D7D2865752828653D3E652E66726F6D576974686F75745363726F6C6C3E652E746F576974686F75745363726F6C6C292C6E75';
wwv_flow_imp.g_varchar2_table(23855) := '292C65752828653D3E652E66726F6D576974686F75745363726F6C6C3E652E746F576974686F75745363726F6C6C3F652E66726F6D576974686F75745363726F6C6C3A2D652E746F576974686F75745363726F6C6C292C74752929293B636F6E7374206C';
wwv_flow_imp.g_varchar2_table(23856) := '3D785A2E636F6D7075746528612E6D61702828653D3E652E72616E67652929292C633D732E766572746963616C5363726F6C6C62617257696474682C643D31302A286C2E676574547261636B436F756E7428292D31292B32302C683D632B642B28722E63';
wwv_flow_imp.g_varchar2_table(23857) := '6F6E74656E744C6566742D535A2E6D6F766564436F6465426C6F636B50616464696E67293B6C657420753D303B666F7228636F6E73742065206F662061297B636F6E7374206E3D632B31302B31302A6C2E676574547261636B2875292C6F3D31352C733D';
wwv_flow_imp.g_varchar2_table(23858) := '31352C613D682C643D722E676C7970684D617267696E57696474682B722E6C696E654E756D6265727357696474682C703D31382C673D646F63756D656E742E637265617465456C656D656E744E532822687474703A2F2F7777772E77332E6F72672F3230';
wwv_flow_imp.g_varchar2_table(23859) := '30302F737667222C227265637422293B672E636C6173734C6973742E61646428226172726F772D72656374616E676C6522292C672E736574417474726962757465282278222C22222B28612D6429292C672E736574417474726962757465282279222C22';
wwv_flow_imp.g_varchar2_table(23860) := '222B28652E746F2D702F3229292C672E73657441747472696275746528227769647468222C60247B647D60292C672E7365744174747269627574652822686569676874222C60247B707D60292C746869732E5F656C656D656E742E617070656E64436869';
wwv_flow_imp.g_varchar2_table(23861) := '6C642867293B636F6E7374206D3D646F63756D656E742E637265617465456C656D656E744E532822687474703A2F2F7777772E77332E6F72672F323030302F737667222C226722292C663D646F63756D656E742E637265617465456C656D656E744E5328';
wwv_flow_imp.g_varchar2_table(23862) := '22687474703A2F2F7777772E77332E6F72672F323030302F737667222C227061746822293B662E736574417474726962757465282264222C604D203020247B652E66726F6D7D204C20247B6E7D20247B652E66726F6D7D204C20247B6E7D20247B652E74';
wwv_flow_imp.g_varchar2_table(23863) := '6F7D204C20247B612D737D20247B652E746F7D60292C662E736574417474726962757465282266696C6C222C226E6F6E6522292C6D2E617070656E644368696C642866293B636F6E737420763D646F63756D656E742E637265617465456C656D656E744E';
wwv_flow_imp.g_varchar2_table(23864) := '532822687474703A2F2F7777772E77332E6F72672F323030302F737667222C22706F6C79676F6E22293B762E636C6173734C6973742E61646428226172726F7722292C742E6164642865492828743D3E7B662E636C6173734C6973742E746F67676C6528';
wwv_flow_imp.g_varchar2_table(23865) := '2263757272656E744D6F7665222C652E6D6F76653D3D3D692E6163746976654D6F766564546578742E72656164287429292C762E636C6173734C6973742E746F67676C65282263757272656E744D6F7665222C652E6D6F76653D3D3D692E616374697665';
wwv_flow_imp.g_varchar2_table(23866) := '4D6F766564546578742E72656164287429297D2929292C762E7365744174747269627574652822706F696E7473222C60247B612D737D2C247B652E746F2D6F2F327D20247B617D2C247B652E746F7D20247B612D737D2C247B652E746F2B6F2F327D6029';
wwv_flow_imp.g_varchar2_table(23867) := '2C6D2E617070656E644368696C642876292C746869732E5F656C656D656E742E617070656E644368696C64286D292C752B2B7D746869732E77696474682E73657428642C766F69642030297D29292C746869732E5F656C656D656E743D646F63756D656E';
wwv_flow_imp.g_varchar2_table(23868) := '742E637265617465456C656D656E744E532822687474703A2F2F7777772E77332E6F72672F323030302F737667222C2273766722292C746869732E5F656C656D656E742E7365744174747269627574652822636C617373222C226D6F7665642D626C6F63';
wwv_flow_imp.g_varchar2_table(23869) := '6B732D6C696E657322292C746869732E5F726F6F74456C656D656E742E617070656E644368696C6428746869732E5F656C656D656E74292C746869732E5F7265676973746572287274282828293D3E746869732E5F656C656D656E742E72656D6F766528';
wwv_flow_imp.g_varchar2_table(23870) := '292929292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F6F726967696E616C456469746F724C61796F7574496E666F2E726561642865292C6E3D746869732E5F6D6F646966696564456469746F724C6179';
wwv_flow_imp.g_varchar2_table(23871) := '6F7574496E666F2E726561642865293B7426266E262628746869732E5F656C656D656E742E7374796C652E6C6566743D742E77696474682D742E766572746963616C5363726F6C6C62617257696474682B227078222C746869732E5F656C656D656E742E';
wwv_flow_imp.g_varchar2_table(23872) := '7374796C652E6865696768743D60247B742E6865696768747D7078602C746869732E5F656C656D656E742E7374796C652E77696474683D60247B742E766572746963616C5363726F6C6C62617257696474682B742E636F6E74656E744C6566742D535A2E';
wwv_flow_imp.g_varchar2_table(23873) := '6D6F766564436F6465426C6F636B50616464696E672B746869732E77696474682E726561642865297D707860297D2929292C746869732E5F726567697374657228704928746869732E5F737461746529293B636F6E737420733D51542828653D3E7B636F';
wwv_flow_imp.g_varchar2_table(23874) := '6E737420743D746869732E5F646966664D6F64656C2E726561642865292C6E3D6E756C6C3D3D743F766F696420303A742E646966662E726561642865293B72657475726E206E3F6E2E6D6F76656454657874732E6D61702828653D3E287B6D6F76653A65';
wwv_flow_imp.g_varchar2_table(23875) := '2C6F726967696E616C3A6E6577204B5928734928652E6C696E6552616E67654D617070696E672E6F726967696E616C2E73746172744C696E654E756D6265722D31292C3138292C6D6F6469666965643A6E6577204B5928734928652E6C696E6552616E67';
wwv_flow_imp.g_varchar2_table(23876) := '654D617070696E672E6D6F6469666965642E73746172744C696E654E756D6265722D31292C3138297D2929293A5B5D7D29293B746869732E5F7265676973746572285A5928746869732E5F656469746F72732E6F726967696E616C2C732E6D6170282865';
wwv_flow_imp.g_varchar2_table(23877) := '3D3E652E6D61702828653D3E652E6F726967696E616C2929292929292C746869732E5F7265676973746572285A5928746869732E5F656469746F72732E6D6F6469666965642C732E6D61702828653D3E652E6D61702828653D3E652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(23878) := '2929292929292C746869732E5F7265676973746572286949282828652C74293D3E7B636F6E7374206E3D732E726561642865293B666F7228636F6E73742065206F66206E29742E616464286E6577206B5A28746869732E5F656469746F72732E6F726967';
wwv_flow_imp.g_varchar2_table(23879) := '696E616C2C652E6F726967696E616C2C652E6D6F76652C226F726967696E616C222C746869732E5F646966664D6F64656C2E676574282929292C742E616464286E6577206B5A28746869732E5F656469746F72732E6D6F6469666965642C652E6D6F6469';
wwv_flow_imp.g_varchar2_table(23880) := '666965642C652E6D6F76652C226D6F646966696564222C746869732E5F646966664D6F64656C2E676574282929297D2929293B636F6E737420723D634928226F726967696E616C2E6F6E446964466F637573456469746F72576964676574222C28653D3E';
wwv_flow_imp.g_varchar2_table(23881) := '746869732E5F656469746F72732E6F726967696E616C2E6F6E446964466F637573456469746F72576964676574282828293D3E73657454696D656F7574282828293D3E6528766F6964203029292C3029292929292C613D634928226D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(23882) := '6F6E446964466F637573456469746F72576964676574222C28653D3E746869732E5F656469746F72732E6D6F6469666965642E6F6E446964466F637573456469746F72576964676574282828293D3E73657454696D656F7574282828293D3E6528766F69';
wwv_flow_imp.g_varchar2_table(23883) := '64203029292C3029292929293B6C6574206C3D226D6F646966696564223B746869732E5F7265676973746572286E49287B637265617465456D7074794368616E676553756D6D6172793A28293D3E7B7D2C68616E646C654368616E67653A28652C74293D';
wwv_flow_imp.g_varchar2_table(23884) := '3E28652E6469644368616E67652872292626286C3D226F726967696E616C22292C652E6469644368616E67652861292626286C3D226D6F64696669656422292C2130297D2C28653D3E7B722E726561642865292C612E726561642865293B636F6E737420';
wwv_flow_imp.g_varchar2_table(23885) := '743D746869732E5F646966664D6F64656C2E726561642865293B69662821742972657475726E3B636F6E7374206E3D742E646966662E726561642865293B6C657420693B6966286E2626226F726967696E616C223D3D3D6C297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(23886) := '69732E5F656469746F72732E6F726967696E616C437572736F722E726561642865293B74262628693D6E2E6D6F76656454657874732E66696E642828653D3E652E6C696E6552616E67654D617070696E672E6F726967696E616C2E636F6E7461696E7328';
wwv_flow_imp.g_varchar2_table(23887) := '742E6C696E654E756D626572292929297D6966286E2626226D6F646966696564223D3D3D6C297B636F6E737420743D746869732E5F656469746F72732E6D6F646966696564437572736F722E726561642865293B74262628693D6E2E6D6F766564546578';
wwv_flow_imp.g_varchar2_table(23888) := '74732E66696E642828653D3E652E6C696E6552616E67654D617070696E672E6D6F6469666965642E636F6E7461696E7328742E6C696E654E756D626572292929297D69213D3D742E6D6F76656454657874546F436F6D706172652E67657428292626742E';
wwv_flow_imp.g_varchar2_table(23889) := '6D6F76656454657874546F436F6D706172652E73657428766F696420302C766F69642030292C742E7365744163746976654D6F766564546578742869297D2929297D7D535A2E6D6F766564436F6465426C6F636B50616464696E673D343B636C61737320';
wwv_flow_imp.g_varchar2_table(23890) := '785A7B73746174696320636F6D707574652865297B636F6E737420743D5B5D2C6E3D5B5D3B666F7228636F6E73742069206F662065297B6C657420653D742E66696E64496E6465782828653D3E21652E696E746572736563747353747269637428692929';
wwv_flow_imp.g_varchar2_table(23891) := '293B6966282D313D3D3D65297B636F6E7374206E3D363B742E6C656E6774683E3D6E3F653D537528742C65752828653D3E652E696E746572736563745769746852616E67654C656E677468286929292C747529293A28653D742E6C656E6774682C742E70';
wwv_flow_imp.g_varchar2_table(23892) := '757368286E657720667529297D745B655D2E61646452616E67652869292C6E2E707573682865297D72657475726E206E657720785A28742E6C656E6774682C6E297D636F6E7374727563746F7228652C74297B746869732E5F747261636B436F756E743D';
wwv_flow_imp.g_varchar2_table(23893) := '652C746869732E747261636B5065724C696E654964783D747D676574547261636B2865297B72657475726E20746869732E747261636B5065724C696E654964785B655D7D676574547261636B436F756E7428297B72657475726E20746869732E5F747261';
wwv_flow_imp.g_varchar2_table(23894) := '636B436F756E747D7D636C617373206B5A20657874656E64732055597B636F6E7374727563746F7228652C742C6E2C692C6F297B636F6E737420733D497228226469762E646966662D68696464656E2D6C696E65732D77696467657422293B7375706572';
wwv_flow_imp.g_varchar2_table(23895) := '28652C742C732E726F6F74292C746869732E5F656469746F723D652C746869732E5F6D6F76653D6E2C746869732E5F6B696E643D692C746869732E5F646966664D6F64656C3D6F2C746869732E5F6E6F6465733D497228226469762E646966662D6D6F76';
wwv_flow_imp.g_varchar2_table(23896) := '65642D636F64652D626C6F636B222C7B7374796C653A7B6D617267696E52696768743A22347078227D7D2C5B497228226469762E746578742D636F6E74656E744074657874436F6E74656E7422292C497228226469762E616374696F6E2D626172406163';
wwv_flow_imp.g_varchar2_table(23897) := '74696F6E42617222295D292C732E726F6F742E617070656E644368696C6428746869732E5F6E6F6465732E726F6F74293B636F6E737420723D614928746869732E5F656469746F722E6F6E4469644C61796F75744368616E67652C2828293D3E74686973';
wwv_flow_imp.g_varchar2_table(23898) := '2E5F656469746F722E6765744C61796F7574496E666F282929293B6C657420613B746869732E5F726567697374657228515928746869732E5F6E6F6465732E726F6F742C7B70616464696E6752696768743A722E6D61702828653D3E652E766572746963';
wwv_flow_imp.g_varchar2_table(23899) := '616C5363726F6C6C626172576964746829297D29292C613D6E2E6368616E6765732E6C656E6774683E303F226F726967696E616C223D3D3D746869732E5F6B696E643F6228302C22436F6465206D6F7665642077697468206368616E67657320746F206C';
wwv_flow_imp.g_varchar2_table(23900) := '696E65207B307D2D7B317D222C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D6265722C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6D6F64696669';
wwv_flow_imp.g_varchar2_table(23901) := '65642E656E644C696E654E756D6265724578636C75736976652D31293A6228302C22436F6465206D6F7665642077697468206368616E6765732066726F6D206C696E65207B307D2D7B317D222C746869732E5F6D6F76652E6C696E6552616E67654D6170';
wwv_flow_imp.g_varchar2_table(23902) := '70696E672E6F726967696E616C2E73746172744C696E654E756D6265722C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D31293A226F726967696E';
wwv_flow_imp.g_varchar2_table(23903) := '616C223D3D3D746869732E5F6B696E643F6228302C22436F6465206D6F76656420746F206C696E65207B307D2D7B317D222C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(23904) := '65722C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D31293A6228302C22436F6465206D6F7665642066726F6D206C696E65207B307D2D7B317D22';
wwv_flow_imp.g_varchar2_table(23905) := '2C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6F726967696E616C2E73746172744C696E654E756D6265722C746869732E5F6D6F76652E6C696E6552616E67654D617070696E672E6F726967696E616C2E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(23906) := '6D6265724578636C75736976652D31293B636F6E7374206C3D746869732E5F7265676973746572286E6577206C4D28746869732E5F6E6F6465732E616374696F6E4261722C7B686967686C69676874546F67676C65644974656D733A21307D29292C633D';
wwv_flow_imp.g_varchar2_table(23907) := '6E65772062632822222C612C22222C2131293B6C2E7075736828632C7B69636F6E3A21312C6C6162656C3A21307D293B636F6E737420643D6E65772062632822222C22436F6D70617265222C546C2E6173436C6173734E616D65284C6C2E636F6D706172';
wwv_flow_imp.g_varchar2_table(23908) := '654368616E676573292C21302C2828293D3E7B746869732E5F656469746F722E666F63757328292C746869732E5F646966664D6F64656C2E6D6F76656454657874546F436F6D706172652E73657428746869732E5F646966664D6F64656C2E6D6F766564';
wwv_flow_imp.g_varchar2_table(23909) := '54657874546F436F6D706172652E67657428293D3D3D6E3F766F696420303A746869732E5F6D6F76652C766F69642030297D29293B746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F646966664D6F64656C2E';
wwv_flow_imp.g_varchar2_table(23910) := '6D6F76656454657874546F436F6D706172652E726561642865293D3D3D6E3B642E636865636B65643D747D2929292C6C2E7075736828642C7B69636F6E3A21312C6C6162656C3A21307D297D7D4C6D282264696666456469746F722E6D6F76652E626F72';
wwv_flow_imp.g_varchar2_table(23911) := '646572222C7B6461726B3A22233862386238623963222C6C696768743A22233862386238623963222C68634461726B3A22233862386238623963222C68634C696768743A22233862386238623963227D2C6228302C2254686520626F7264657220636F6C';
wwv_flow_imp.g_varchar2_table(23912) := '6F7220666F722074657874207468617420676F74206D6F76656420696E20746865206469666620656469746F722E2229292C4C6D282264696666456469746F722E6D6F76654163746976652E626F72646572222C7B6461726B3A2223464641353030222C';
wwv_flow_imp.g_varchar2_table(23913) := '6C696768743A2223464641353030222C68634461726B3A2223464641353030222C68634C696768743A2223464641353030227D2C6228302C225468652061637469766520626F7264657220636F6C6F7220666F722074657874207468617420676F74206D';
wwv_flow_imp.g_varchar2_table(23914) := '6F76656420696E20746865206469666620656469746F722E2229292C4C6D282264696666456469746F722E756E6368616E676564526567696F6E536861646F77222C7B6461726B3A2223303030303030222C6C696768743A22233733373337334246222C';
wwv_flow_imp.g_varchar2_table(23915) := '68634461726B3A2223303030303030222C68634C696768743A22233733373337334246227D2C6228302C2254686520636F6C6F72206F662074686520736861646F772061726F756E6420756E6368616E67656420726567696F6E20776964676574732E22';
wwv_flow_imp.g_varchar2_table(23916) := '29293B636F6E737420455A3D54572822646966662D696E73657274222C4C6C2E6164642C6228302C224C696E65206465636F726174696F6E20666F7220696E736572747320696E20746865206469666620656469746F722E2229292C4C5A3D5457282264';
wwv_flow_imp.g_varchar2_table(23917) := '6966662D72656D6F7665222C4C6C2E72656D6F76652C6228302C224C696E65206465636F726174696F6E20666F722072656D6F76616C7320696E20746865206469666620656469746F722E2229292C445A3D4F432E7265676973746572287B636C617373';
wwv_flow_imp.g_varchar2_table(23918) := '4E616D653A226C696E652D696E73657274222C6465736372697074696F6E3A226C696E652D696E73657274222C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73436C6173734E616D653A22696E736572742D7369676E2022';
wwv_flow_imp.g_varchar2_table(23919) := '2B546C2E6173436C6173734E616D6528455A292C6D617267696E436C6173734E616D653A226775747465722D696E73657274227D292C545A3D4F432E7265676973746572287B636C6173734E616D653A226C696E652D64656C657465222C646573637269';
wwv_flow_imp.g_varchar2_table(23920) := '7074696F6E3A226C696E652D64656C657465222C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73436C6173734E616D653A2264656C6574652D7369676E20222B546C2E6173436C6173734E616D65284C5A292C6D61726769';
wwv_flow_imp.g_varchar2_table(23921) := '6E436C6173734E616D653A226775747465722D64656C657465227D292C495A3D4F432E7265676973746572287B636C6173734E616D653A226C696E652D696E73657274222C6465736372697074696F6E3A226C696E652D696E73657274222C697357686F';
wwv_flow_imp.g_varchar2_table(23922) := '6C654C696E653A21302C6D617267696E436C6173734E616D653A226775747465722D696E73657274227D292C4D5A3D4F432E7265676973746572287B636C6173734E616D653A226C696E652D64656C657465222C6465736372697074696F6E3A226C696E';
wwv_flow_imp.g_varchar2_table(23923) := '652D64656C657465222C697357686F6C654C696E653A21302C6D617267696E436C6173734E616D653A226775747465722D64656C657465227D292C415A3D4F432E7265676973746572287B636C6173734E616D653A22636861722D696E73657274222C64';
wwv_flow_imp.g_varchar2_table(23924) := '65736372697074696F6E3A22636861722D696E73657274222C73686F756C6446696C6C4C696E654F6E4C696E65427265616B3A21307D292C4E5A3D4F432E7265676973746572287B636C6173734E616D653A22636861722D696E73657274222C64657363';
wwv_flow_imp.g_varchar2_table(23925) := '72697074696F6E3A22636861722D696E73657274222C697357686F6C654C696E653A21307D292C505A3D4F432E7265676973746572287B636C6173734E616D653A22636861722D696E7365727420646966662D72616E67652D656D707479222C64657363';
wwv_flow_imp.g_varchar2_table(23926) := '72697074696F6E3A22636861722D696E7365727420646966662D72616E67652D656D707479227D292C4F5A3D4F432E7265676973746572287B636C6173734E616D653A22636861722D64656C657465222C6465736372697074696F6E3A22636861722D64';
wwv_flow_imp.g_varchar2_table(23927) := '656C657465222C73686F756C6446696C6C4C696E654F6E4C696E65427265616B3A21307D292C525A3D4F432E7265676973746572287B636C6173734E616D653A22636861722D64656C657465222C6465736372697074696F6E3A22636861722D64656C65';
wwv_flow_imp.g_varchar2_table(23928) := '7465222C697357686F6C654C696E653A21307D292C465A3D4F432E7265676973746572287B636C6173734E616D653A22636861722D64656C65746520646966662D72616E67652D656D707479222C6465736372697074696F6E3A22636861722D64656C65';
wwv_flow_imp.g_varchar2_table(23929) := '746520646966662D72616E67652D656D707479227D293B636C61737320425A20657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F656469746F72733D652C746869732E5F646966664D6F';
wwv_flow_imp.g_varchar2_table(23930) := '64656C3D742C746869732E5F6F7074696F6E733D6E2C746869732E5F6465636F726174696F6E733D515428746869732C28653D3E7B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E72656164286529';
wwv_flow_imp.g_varchar2_table(23931) := '297C7C766F696420303D3D3D743F766F696420303A742E646966662E726561642865293B696628216E2972657475726E206E756C6C3B636F6E737420693D746869732E5F646966664D6F64656C2E726561642865292E6D6F76656454657874546F436F6D';
wwv_flow_imp.g_varchar2_table(23932) := '706172652E726561642865292C6F3D746869732E5F6F7074696F6E732E72656E646572496E64696361746F72732E726561642865292C733D746869732E5F6F7074696F6E732E73686F77456D7074794465636F726174696F6E732E726561642865292C72';
wwv_flow_imp.g_varchar2_table(23933) := '3D5B5D2C613D5B5D3B696628216929666F7228636F6E73742065206F66206E2E6D617070696E677329696628652E6C696E6552616E67654D617070696E672E6F726967696E616C2E6973456D7074797C7C722E70757368287B72616E67653A652E6C696E';
wwv_flow_imp.g_varchar2_table(23934) := '6552616E67654D617070696E672E6F726967696E616C2E746F496E636C757369766552616E676528292C6F7074696F6E733A6F3F545A3A4D5A7D292C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E6973456D7074797C7C612E70';
wwv_flow_imp.g_varchar2_table(23935) := '757368287B72616E67653A652E6C696E6552616E67654D617070696E672E6D6F6469666965642E746F496E636C757369766552616E676528292C6F7074696F6E733A6F3F445A3A495A7D292C652E6C696E6552616E67654D617070696E672E6D6F646966';
wwv_flow_imp.g_varchar2_table(23936) := '6965642E6973456D7074797C7C652E6C696E6552616E67654D617070696E672E6F726967696E616C2E6973456D70747929652E6C696E6552616E67654D617070696E672E6F726967696E616C2E6973456D7074797C7C722E70757368287B72616E67653A';
wwv_flow_imp.g_varchar2_table(23937) := '652E6C696E6552616E67654D617070696E672E6F726967696E616C2E746F496E636C757369766552616E676528292C6F7074696F6E733A525A7D292C652E6C696E6552616E67654D617070696E672E6D6F6469666965642E6973456D7074797C7C612E70';
wwv_flow_imp.g_varchar2_table(23938) := '757368287B72616E67653A652E6C696E6552616E67654D617070696E672E6D6F6469666965642E746F496E636C757369766552616E676528292C6F7074696F6E733A4E5A7D293B656C736520666F7228636F6E73742074206F6620652E6C696E6552616E';
wwv_flow_imp.g_varchar2_table(23939) := '67654D617070696E672E696E6E65724368616E6765737C7C5B5D29652E6C696E6552616E67654D617070696E672E6F726967696E616C2E636F6E7461696E7328742E6F726967696E616C52616E67652E73746172744C696E654E756D626572292626722E';
wwv_flow_imp.g_varchar2_table(23940) := '70757368287B72616E67653A742E6F726967696E616C52616E67652C6F7074696F6E733A742E6F726967696E616C52616E67652E6973456D70747928292626733F465A3A4F5A7D292C652E6C696E6552616E67654D617070696E672E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(23941) := '2E636F6E7461696E7328742E6D6F64696669656452616E67652E73746172744C696E654E756D626572292626612E70757368287B72616E67653A742E6D6F64696669656452616E67652C6F7074696F6E733A742E6D6F64696669656452616E67652E6973';
wwv_flow_imp.g_varchar2_table(23942) := '456D70747928292626733F505A3A415A7D293B6966286929666F7228636F6E73742065206F6620692E6368616E676573297B636F6E737420743D652E6F726967696E616C2E746F496E636C757369766552616E676528293B742626722E70757368287B72';
wwv_flow_imp.g_varchar2_table(23943) := '616E67653A742C6F7074696F6E733A6F3F545A3A4D5A7D293B636F6E7374206E3D652E6D6F6469666965642E746F496E636C757369766552616E676528293B6E2626612E70757368287B72616E67653A6E2C6F7074696F6E733A6F3F445A3A495A7D293B';
wwv_flow_imp.g_varchar2_table(23944) := '666F7228636F6E73742074206F6620652E696E6E65724368616E6765737C7C5B5D29722E70757368287B72616E67653A742E6F726967696E616C52616E67652C6F7074696F6E733A4F5A7D292C612E70757368287B72616E67653A742E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(23945) := '6452616E67652C6F7074696F6E733A415A7D297D636F6E7374206C3D746869732E5F646966664D6F64656C2E726561642865292E6163746976654D6F766564546578742E726561642865293B666F7228636F6E73742065206F66206E2E6D6F7665645465';
wwv_flow_imp.g_varchar2_table(23946) := '78747329722E70757368287B72616E67653A652E6C696E6552616E67654D617070696E672E6F726967696E616C2E746F496E636C757369766552616E676528292C6F7074696F6E733A7B6465736372697074696F6E3A226D6F766564222C626C6F636B43';
wwv_flow_imp.g_varchar2_table(23947) := '6C6173734E616D653A226D6F7665644F726967696E616C222B28653D3D3D6C3F222063757272656E744D6F7665223A2222292C626C6F636B50616464696E673A5B535A2E6D6F766564436F6465426C6F636B50616464696E672C302C535A2E6D6F766564';
wwv_flow_imp.g_varchar2_table(23948) := '436F6465426C6F636B50616464696E672C535A2E6D6F766564436F6465426C6F636B50616464696E675D7D7D292C612E70757368287B72616E67653A652E6C696E6552616E67654D617070696E672E6D6F6469666965642E746F496E636C757369766552';
wwv_flow_imp.g_varchar2_table(23949) := '616E676528292C6F7074696F6E733A7B6465736372697074696F6E3A226D6F766564222C626C6F636B436C6173734E616D653A226D6F7665644D6F646966696564222B28653D3D3D6C3F222063757272656E744D6F7665223A2222292C626C6F636B5061';
wwv_flow_imp.g_varchar2_table(23950) := '6464696E673A5B342C302C342C345D7D7D293B72657475726E7B6F726967696E616C4465636F726174696F6E733A722C6D6F6469666965644465636F726174696F6E733A617D7D29292C746869732E5F726567697374657228575928746869732E5F6564';
wwv_flow_imp.g_varchar2_table(23951) := '69746F72732E6F726967696E616C2C746869732E5F6465636F726174696F6E732E6D61702828653D3E286E756C6C3D3D653F766F696420303A652E6F726967696E616C4465636F726174696F6E73297C7C5B5D292929292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(23952) := '657228575928746869732E5F656469746F72732E6D6F6469666965642C746869732E5F6465636F726174696F6E732E6D61702828653D3E286E756C6C3D3D653F766F696420303A652E6D6F6469666965644465636F726174696F6E73297C7C5B5D292929';
wwv_flow_imp.g_varchar2_table(23953) := '297D7D636C61737320565A20657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F6F7074696F6E733D652C746869732E5F646F6D4E6F64653D742C746869732E5F64696D656E73696F6E73';
wwv_flow_imp.g_varchar2_table(23954) := '3D6E2C746869732E5F7361736865733D692C746869732E5F73617368526174696F3D245428746869732C766F69642030292C746869732E736173684C6566743D515428746869732C28653D3E7B76617220743B636F6E7374206E3D6E756C6C213D3D2874';
wwv_flow_imp.g_varchar2_table(23955) := '3D746869732E5F73617368526174696F2E72656164286529292626766F69642030213D3D743F743A746869732E5F6F7074696F6E732E73706C69745669657744656661756C74526174696F2E726561642865293B72657475726E20746869732E5F636F6D';
wwv_flow_imp.g_varchar2_table(23956) := '70757465536173684C656674286E2C65297D29292C746869732E5F736173683D746869732E5F7265676973746572286E657720637128746869732E5F646F6D4E6F64652C7B676574566572746963616C53617368546F703A653D3E302C67657456657274';
wwv_flow_imp.g_varchar2_table(23957) := '6963616C536173684C6566743A653D3E746869732E736173684C6566742E67657428292C676574566572746963616C536173684865696768743A653D3E746869732E5F64696D656E73696F6E732E6865696768742E67657428297D2C7B6F7269656E7461';
wwv_flow_imp.g_varchar2_table(23958) := '74696F6E3A307D29292C746869732E5F737461727453617368506F736974696F6E3D766F696420302C746869732E5F726567697374657228746869732E5F736173682E6F6E4469645374617274282828293D3E7B746869732E5F73746172745361736850';
wwv_flow_imp.g_varchar2_table(23959) := '6F736974696F6E3D746869732E736173684C6566742E67657428297D2929292C746869732E5F726567697374657228746869732E5F736173682E6F6E4469644368616E67652828653D3E7B636F6E737420743D746869732E5F64696D656E73696F6E732E';
wwv_flow_imp.g_varchar2_table(23960) := '77696474682E67657428292C6E3D746869732E5F636F6D70757465536173684C6566742828746869732E5F737461727453617368506F736974696F6E2B28652E63757272656E74582D652E73746172745829292F742C766F69642030293B746869732E5F';
wwv_flow_imp.g_varchar2_table(23961) := '73617368526174696F2E736574286E2F742C766F69642030297D2929292C746869732E5F726567697374657228746869732E5F736173682E6F6E446964456E64282828293D3E746869732E5F736173682E6C61796F757428292929292C746869732E5F72';
wwv_flow_imp.g_varchar2_table(23962) := '6567697374657228746869732E5F736173682E6F6E4469645265736574282828293D3E746869732E5F73617368526174696F2E73657428766F696420302C766F69642030292929292C746869732E5F72656769737465722865492828653D3E7B636F6E73';
wwv_flow_imp.g_varchar2_table(23963) := '7420743D746869732E5F7361736865732E726561642865293B74262628746869732E5F736173682E6F7274686F676F6E616C456E64536173683D742E626F74746F6D297D2929292C746869732E5F72656769737465722865492828653D3E7B636F6E7374';
wwv_flow_imp.g_varchar2_table(23964) := '20743D746869732E5F6F7074696F6E732E656E61626C6553706C697456696577526573697A696E672E726561642865293B746869732E5F736173682E73746174653D743F333A302C746869732E736173684C6566742E726561642865292C746869732E5F';
wwv_flow_imp.g_varchar2_table(23965) := '64696D656E73696F6E732E6865696768742E726561642865292C746869732E5F736173682E6C61796F757428297D2929297D5F636F6D70757465536173684C65667428652C74297B636F6E7374206E3D746869732E5F64696D656E73696F6E732E776964';
wwv_flow_imp.g_varchar2_table(23966) := '74682E726561642874292C693D4D6174682E666C6F6F7228746869732E5F6F7074696F6E732E73706C69745669657744656661756C74526174696F2E726561642874292A6E292C6F3D746869732E5F6F7074696F6E732E656E61626C6553706C69745669';
wwv_flow_imp.g_varchar2_table(23967) := '6577526573697A696E672E726561642874293F4D6174682E666C6F6F7228652A6E293A692C733D3130303B72657475726E206E3C3D3230303F693A6F3C733F733A6F3E6E2D733F6E2D733A6F7D7D636F6E7374207A5A3D70632822656469746F72576F72';
wwv_flow_imp.g_varchar2_table(23968) := '6B65725365727669636522293B76617220485A2C575A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E5072';
wwv_flow_imp.g_varchar2_table(23969) := '6F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E64';
wwv_flow_imp.g_varchar2_table(23970) := '65636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B';
wwv_flow_imp.g_varchar2_table(23971) := '72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C6A5A3D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73';
wwv_flow_imp.g_varchar2_table(23972) := '7420715A3D706328226469666650726F7669646572466163746F72795365727669636522293B6C657420245A3D636C6173737B636F6E7374727563746F722865297B746869732E696E7374616E74696174696F6E536572766963653D657D637265617465';
wwv_flow_imp.g_varchar2_table(23973) := '4469666650726F76696465722865297B72657475726E20746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528555A2C65297D7D3B245A3D575A285B6A5A28302C7563295D2C245A292C787028715A2C24';
wwv_flow_imp.g_varchar2_table(23974) := '5A2C31293B6C657420555A3D485A3D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E656469746F72576F726B6572536572766963653D742C746869732E74656C656D65747279536572766963653D6E2C746869732E6F6E4469';
wwv_flow_imp.g_varchar2_table(23975) := '644368616E67654576656E74456D69747465723D6E65772043742C746869732E6F6E4469644368616E67653D746869732E6F6E4469644368616E67654576656E74456D69747465722E6576656E742C746869732E64696666416C676F726974686D3D2261';
wwv_flow_imp.g_varchar2_table(23976) := '6476616E636564222C746869732E64696666416C676F726974686D4F6E4469644368616E6765537562736372697074696F6E3D766F696420302C746869732E7365744F7074696F6E732865297D646973706F736528297B76617220653B6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(23977) := '28653D746869732E64696666416C676F726974686D4F6E4469644368616E6765537562736372697074696F6E297C7C766F696420303D3D3D657C7C652E646973706F736528297D6173796E6320636F6D707574654469666628652C742C6E2C69297B7661';
wwv_flow_imp.g_varchar2_table(23978) := '72206F2C733B69662822737472696E6722213D747970656F6620746869732E64696666416C676F726974686D2972657475726E20746869732E64696666416C676F726974686D2E636F6D707574654469666628652C742C6E2C69293B696628652E697344';
wwv_flow_imp.g_varchar2_table(23979) := '6973706F73656428297C7C742E6973446973706F73656428292972657475726E7B6368616E6765733A5B5D2C6964656E746963616C3A21302C717569744561726C793A21312C6D6F7665733A5B5D7D3B696628313D3D3D652E6765744C696E65436F756E';
wwv_flow_imp.g_varchar2_table(23980) := '7428292626313D3D3D652E6765744C696E654D6178436F6C756D6E2831292972657475726E20313D3D3D742E6765744C696E65436F756E7428292626313D3D3D742E6765744C696E654D6178436F6C756D6E2831293F7B6368616E6765733A5B5D2C6964';
wwv_flow_imp.g_varchar2_table(23981) := '656E746963616C3A21302C717569744561726C793A21312C6D6F7665733A5B5D7D3A7B6368616E6765733A5B6E6577205A7A286E657720787528312C32292C6E657720787528312C742E6765744C696E65436F756E7428292B31292C5B6E657720587A28';
wwv_flow_imp.g_varchar2_table(23982) := '652E67657446756C6C4D6F64656C52616E676528292C742E67657446756C6C4D6F64656C52616E67652829295D295D2C6964656E746963616C3A21312C717569744561726C793A21312C6D6F7665733A5B5D7D3B636F6E737420723D4A534F4E2E737472';
wwv_flow_imp.g_varchar2_table(23983) := '696E67696679285B652E7572692E746F537472696E6728292C742E7572692E746F537472696E6728295D292C613D4A534F4E2E737472696E67696679285B652E69642C742E69642C652E676574416C7465726E617469766556657273696F6E496428292C';
wwv_flow_imp.g_varchar2_table(23984) := '742E676574416C7465726E617469766556657273696F6E496428292C4A534F4E2E737472696E67696679286E295D292C6C3D485A2E6469666643616368652E6765742872293B6966286C26266C2E636F6E746578743D3D3D612972657475726E206C2E72';
wwv_flow_imp.g_varchar2_table(23985) := '6573756C743B636F6E737420633D66742E63726561746528292C643D617761697420746869732E656469746F72576F726B6572536572766963652E636F6D707574654469666628652E7572692C742E7572692C6E2C746869732E64696666416C676F7269';
wwv_flow_imp.g_varchar2_table(23986) := '74686D292C683D632E656C617073656428293B696628746869732E74656C656D65747279536572766963652E7075626C69634C6F6732282264696666456469746F722E636F6D7075746544696666222C7B74696D654D733A682C74696D65644F75743A6E';
wwv_flow_imp.g_varchar2_table(23987) := '756C6C3D3D3D286F3D6E756C6C3D3D643F766F696420303A642E717569744561726C79297C7C766F696420303D3D3D6F7C7C6F2C64657465637465644D6F7665733A6E2E636F6D707574654D6F7665733F6E756C6C213D3D28733D6E756C6C3D3D643F76';
wwv_flow_imp.g_varchar2_table(23988) := '6F696420303A642E6D6F7665732E6C656E677468292626766F69642030213D3D733F733A303A2D317D292C692E697343616E63656C6C6174696F6E5265717565737465642972657475726E7B6368616E6765733A5B5D2C6964656E746963616C3A21312C';
wwv_flow_imp.g_varchar2_table(23989) := '717569744561726C793A21302C6D6F7665733A5B5D7D3B6966282164297468726F77206E6577204572726F7228226E6F206469666620726573756C7420617661696C61626C6522293B72657475726E20485A2E6469666643616368652E73697A653E3130';
wwv_flow_imp.g_varchar2_table(23990) := '2626485A2E6469666643616368652E64656C65746528485A2E6469666643616368652E6B65797328292E6E65787428292E76616C7565292C485A2E6469666643616368652E73657428722C7B726573756C743A642C636F6E746578743A617D292C647D73';
wwv_flow_imp.g_varchar2_table(23991) := '65744F7074696F6E732865297B76617220743B6C6574206E3D21313B652E64696666416C676F726974686D2626746869732E64696666416C676F726974686D213D3D652E64696666416C676F726974686D2626286E756C6C3D3D3D28743D746869732E64';
wwv_flow_imp.g_varchar2_table(23992) := '696666416C676F726974686D4F6E4469644368616E6765537562736372697074696F6E297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E64696666416C676F726974686D4F6E4469644368616E6765537562736372697074';
wwv_flow_imp.g_varchar2_table(23993) := '696F6E3D766F696420302C746869732E64696666416C676F726974686D3D652E64696666416C676F726974686D2C22737472696E6722213D747970656F6620652E64696666416C676F726974686D262628746869732E64696666416C676F726974686D4F';
wwv_flow_imp.g_varchar2_table(23994) := '6E4469644368616E6765537562736372697074696F6E3D652E64696666416C676F726974686D2E6F6E4469644368616E6765282828293D3E746869732E6F6E4469644368616E67654576656E74456D69747465722E6669726528292929292C6E3D213029';
wwv_flow_imp.g_varchar2_table(23995) := '2C6E2626746869732E6F6E4469644368616E67654576656E74456D69747465722E6669726528297D7D3B555A2E6469666643616368653D6E6577204D61702C555A3D485A3D575A285B6A5A28312C7A5A292C6A5A28322C4F64295D2C555A293B6C657420';
wwv_flow_imp.g_varchar2_table(23996) := '4B5A3D636C61737320657874656E6473206C747B7365744163746976654D6F766564546578742865297B746869732E5F6163746976654D6F766564546578742E73657428652C766F69642030297D636F6E7374727563746F7228652C742C6E297B737570';
wwv_flow_imp.g_varchar2_table(23997) := '657228292C746869732E6D6F64656C3D652C746869732E5F6F7074696F6E733D742C746869732E5F6469666650726F7669646572466163746F7279536572766963653D6E2C746869732E5F6973446966665570546F446174653D245428746869732C2131';
wwv_flow_imp.g_varchar2_table(23998) := '292C746869732E6973446966665570546F446174653D746869732E5F6973446966665570546F446174652C746869732E5F646966663D245428746869732C766F69642030292C746869732E646966663D746869732E5F646966662C746869732E5F756E63';
wwv_flow_imp.g_varchar2_table(23999) := '68616E676564526567696F6E733D245428746869732C766F69642030292C746869732E756E6368616E676564526567696F6E733D515428746869732C28653D3E7B76617220742C6E3B72657475726E20746869732E5F6F7074696F6E732E68696465556E';
wwv_flow_imp.g_varchar2_table(24000) := '6368616E676564526567696F6E732E726561642865293F6E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E5F756E6368616E676564526567696F6E732E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E72656769';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(24001) := '6F6E73292626766F69642030213D3D6E3F6E3A5B5D3A2848542828653D3E7B76617220743B666F7228636F6E7374206E206F66286E756C6C3D3D3D28743D746869732E5F756E6368616E676564526567696F6E732E6765742829297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(24002) := '3D3D743F766F696420303A742E726567696F6E73297C7C5B5D296E2E636F6C6C61707365416C6C2865297D29292C5B5D297D29292C746869732E6D6F76656454657874546F436F6D706172653D245428746869732C766F69642030292C746869732E5F61';
wwv_flow_imp.g_varchar2_table(24003) := '63746976654D6F766564546578743D245428746869732C766F69642030292C746869732E5F686F76657265644D6F766564546578743D245428746869732C766F69642030292C746869732E6163746976654D6F766564546578743D515428746869732C28';
wwv_flow_imp.g_varchar2_table(24004) := '653D3E7B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C213D3D28743D746869732E6D6F76656454657874546F436F6D706172652E72656164286529292626766F69642030213D3D743F743A746869732E5F686F76657265644D';
wwv_flow_imp.g_varchar2_table(24005) := '6F766564546578742E72656164286529292626766F69642030213D3D6E3F6E3A746869732E5F6163746976654D6F766564546578742E726561642865297D29292C746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263653D6E6577204E';
wwv_flow_imp.g_varchar2_table(24006) := '742C746869732E5F6469666650726F76696465723D515428746869732C28653D3E7B636F6E737420743D746869732E5F6469666650726F7669646572466163746F7279536572766963652E6372656174654469666650726F7669646572287B6469666641';
wwv_flow_imp.g_varchar2_table(24007) := '6C676F726974686D3A746869732E5F6F7074696F6E732E64696666416C676F726974686D2E726561642865297D293B72657475726E7B6469666650726F76696465723A742C6F6E4368616E67655369676E616C3A634928226F6E4469644368616E676522';
wwv_flow_imp.g_varchar2_table(24008) := '2C742E6F6E4469644368616E6765297D7D29292C746869732E5F7265676973746572287274282828293D3E746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263652E63616E63656C28292929293B636F6E737420693D68492822636F6E';
wwv_flow_imp.g_varchar2_table(24009) := '74656E744368616E6765645369676E616C22292C6F3D746869732E5F7265676973746572286E6577204B74282828293D3E692E7472696767657228766F6964203029292C32303029293B746869732E5F72656769737465722865492828743D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(24010) := '7374206E3D746869732E5F756E6368616E676564526567696F6E732E726561642874293B696628216E7C7C6E2E726567696F6E732E736F6D652828653D3E652E6973447261676765642E7265616428742929292972657475726E3B636F6E737420693D6E';
wwv_flow_imp.g_varchar2_table(24011) := '2E6F726967696E616C4465636F726174696F6E4964732E6D61702828743D3E652E6F726967696E616C2E6765744465636F726174696F6E52616E676528742929292E6D61702828653D3E653F78752E66726F6D52616E6765496E636C7573697665286529';
wwv_flow_imp.g_varchar2_table(24012) := '3A766F6964203029292C6F3D6E2E6D6F6469666965644465636F726174696F6E4964732E6D61702828743D3E652E6D6F6469666965642E6765744465636F726174696F6E52616E676528742929292E6D61702828653D3E653F78752E66726F6D52616E67';
wwv_flow_imp.g_varchar2_table(24013) := '65496E636C75736976652865293A766F6964203029292C733D6E2E726567696F6E732E6D6170282828652C6E293D3E695B6E5D26266F5B6E5D3F6E657720595A28695B6E5D2E73746172744C696E654E756D6265722C6F5B6E5D2E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(24014) := '4E756D6265722C695B6E5D2E6C656E6774682C652E76697369626C654C696E65436F756E74546F702E726561642874292C652E76697369626C654C696E65436F756E74426F74746F6D2E72656164287429293A766F6964203029292E66696C7465722862';
wwv_flow_imp.g_varchar2_table(24015) := '6C292C723D5B5D3B6C657420613D21313B666F7228636F6E73742065206F6620426828732C2828652C6E293D3E652E67657448696464656E4D6F64696669656452616E67652874292E656E644C696E654E756D6265724578636C75736976653D3D3D6E2E';
wwv_flow_imp.g_varchar2_table(24016) := '67657448696464656E4D6F64696669656452616E67652874292E73746172744C696E654E756D626572292929696628652E6C656E6774683E31297B613D21303B636F6E737420743D652E726564756365282828652C74293D3E652B742E6C696E65436F75';
wwv_flow_imp.g_varchar2_table(24017) := '6E74292C30292C6E3D6E657720595A28655B305D2E6F726967696E616C4C696E654E756D6265722C655B305D2E6D6F6469666965644C696E654E756D6265722C742C655B305D2E76697369626C654C696E65436F756E74546F702E67657428292C655B65';
wwv_flow_imp.g_varchar2_table(24018) := '2E6C656E6774682D315D2E76697369626C654C696E65436F756E74426F74746F6D2E6765742829293B722E70757368286E297D656C736520722E7075736828655B305D293B69662861297B636F6E737420743D652E6F726967696E616C2E64656C746144';
wwv_flow_imp.g_varchar2_table(24019) := '65636F726174696F6E73286E2E6F726967696E616C4465636F726174696F6E4964732C722E6D61702828653D3E287B72616E67653A652E6F726967696E616C556E6368616E67656452616E67652E746F496E636C757369766552616E676528292C6F7074';
wwv_flow_imp.g_varchar2_table(24020) := '696F6E733A7B6465736372697074696F6E3A22756E6368616E676564227D7D292929292C693D652E6D6F6469666965642E64656C74614465636F726174696F6E73286E2E6D6F6469666965644465636F726174696F6E4964732C722E6D61702828653D3E';
wwv_flow_imp.g_varchar2_table(24021) := '287B72616E67653A652E6D6F646966696564556E6368616E67656452616E67652E746F496E636C757369766552616E676528292C6F7074696F6E733A7B6465736372697074696F6E3A22756E6368616E676564227D7D292929293B48542828653D3E7B74';
wwv_flow_imp.g_varchar2_table(24022) := '6869732E5F756E6368616E676564526567696F6E732E736574287B726567696F6E733A722C6F726967696E616C4465636F726174696F6E4964733A742C6D6F6469666965644465636F726174696F6E4964733A697D2C65297D29297D7D2929293B636F6E';
wwv_flow_imp.g_varchar2_table(24023) := '737420733D28742C6E2C69293D3E7B636F6E7374206F3D595A2E66726F6D446966667328742E6368616E6765732C652E6F726967696E616C2E6765744C696E65436F756E7428292C652E6D6F6469666965642E6765744C696E65436F756E7428292C7468';
wwv_flow_imp.g_varchar2_table(24024) := '69732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E734D696E696D756D4C696E65436F756E742E726561642869292C746869732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E73436F6E746578744C69';
wwv_flow_imp.g_varchar2_table(24025) := '6E65436F756E742E72656164286929293B6C657420733B636F6E737420723D746869732E5F756E6368616E676564526567696F6E732E67657428293B69662872297B636F6E737420743D722E6F726967696E616C4465636F726174696F6E4964732E6D61';
wwv_flow_imp.g_varchar2_table(24026) := '702828743D3E652E6F726967696E616C2E6765744465636F726174696F6E52616E676528742929292E6D61702828653D3E653F78752E66726F6D52616E6765496E636C75736976652865293A766F6964203029292C6E3D722E6D6F646966696564446563';
wwv_flow_imp.g_varchar2_table(24027) := '6F726174696F6E4964732E6D61702828743D3E652E6D6F6469666965642E6765744465636F726174696F6E52616E676528742929292E6D61702828653D3E653F78752E66726F6D52616E6765496E636C75736976652865293A766F6964203029292C6F3D';
wwv_flow_imp.g_varchar2_table(24028) := '66756E6374696F6E2865297B6C657420743B72657475726E20652E66696C7465722828653D3E7B636F6E7374206E3D2828652C74293D3E21747C7C652E6D6F6469666965644C696E654E756D6265723E3D742E6D6F6469666965644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(24029) := '722B742E6C696E65436F756E742626652E6F726967696E616C4C696E654E756D6265723E3D742E6F726967696E616C4C696E654E756D6265722B742E6C696E65436F756E742928652C74293B72657475726E20743D652C6E7D29297D28722E726567696F';
wwv_flow_imp.g_varchar2_table(24030) := '6E732E6D6170282828652C69293D3E7B69662821745B695D7C7C216E5B695D2972657475726E3B636F6E7374206F3D745B695D2E6C656E6774683B72657475726E206E657720595A28745B695D2E73746172744C696E654E756D6265722C6E5B695D2E73';
wwv_flow_imp.g_varchar2_table(24031) := '746172744C696E654E756D6265722C6F2C4D6174682E6D696E28652E76697369626C654C696E65436F756E74546F702E67657428292C6F292C4D6174682E6D696E28652E76697369626C654C696E65436F756E74426F74746F6D2E67657428292C6F2D65';
wwv_flow_imp.g_varchar2_table(24032) := '2E76697369626C654C696E65436F756E74546F702E676574282929297D29292E66696C74657228626C29293B6C657420613D6F2E6D61702828653D3E6E657720597A28652E67657448696464656E4F726967696E616C52616E67652869292C652E676574';
wwv_flow_imp.g_varchar2_table(24033) := '48696464656E4D6F64696669656452616E67652869292929293B613D597A2E636C697028612C78752E6F664C656E67746828312C652E6F726967696E616C2E6765744C696E65436F756E742829292C78752E6F664C656E67746828312C652E6D6F646966';
wwv_flow_imp.g_varchar2_table(24034) := '6965642E6765744C696E65436F756E74282929292C733D597A2E696E766572736528612C652E6F726967696E616C2E6765744C696E65436F756E7428292C652E6D6F6469666965642E6765744C696E65436F756E742829297D636F6E737420613D5B5D3B';
wwv_flow_imp.g_varchar2_table(24035) := '6966287329666F7228636F6E73742065206F66206F297B636F6E737420743D732E66696C7465722828743D3E742E6F726967696E616C2E696E746572736563747353747269637428652E6F726967696E616C556E6368616E67656452616E676529262674';
wwv_flow_imp.g_varchar2_table(24036) := '2E6D6F6469666965642E696E746572736563747353747269637428652E6D6F646966696564556E6368616E67656452616E67652929293B612E70757368282E2E2E652E73657456697369626C6552616E67657328742C6E29297D656C736520612E707573';
wwv_flow_imp.g_varchar2_table(24037) := '68282E2E2E6F293B636F6E7374206C3D652E6F726967696E616C2E64656C74614465636F726174696F6E7328286E756C6C3D3D723F766F696420303A722E6F726967696E616C4465636F726174696F6E496473297C7C5B5D2C612E6D61702828653D3E28';
wwv_flow_imp.g_varchar2_table(24038) := '7B72616E67653A652E6F726967696E616C556E6368616E67656452616E67652E746F496E636C757369766552616E676528292C6F7074696F6E733A7B6465736372697074696F6E3A22756E6368616E676564227D7D292929292C633D652E6D6F64696669';
wwv_flow_imp.g_varchar2_table(24039) := '65642E64656C74614465636F726174696F6E7328286E756C6C3D3D723F766F696420303A722E6D6F6469666965644465636F726174696F6E496473297C7C5B5D2C612E6D61702828653D3E287B72616E67653A652E6D6F646966696564556E6368616E67';
wwv_flow_imp.g_varchar2_table(24040) := '656452616E67652E746F496E636C757369766552616E676528292C6F7074696F6E733A7B6465736372697074696F6E3A22756E6368616E676564227D7D292929293B746869732E5F756E6368616E676564526567696F6E732E736574287B726567696F6E';
wwv_flow_imp.g_varchar2_table(24041) := '733A612C6F726967696E616C4465636F726174696F6E4964733A6C2C6D6F6469666965644465636F726174696F6E4964733A637D2C6E297D3B746869732E5F726567697374657228652E6D6F6469666965642E6F6E4469644368616E6765436F6E74656E';
wwv_flow_imp.g_varchar2_table(24042) := '742828743D3E7B696628746869732E5F646966662E6765742829297B49672E66726F6D4D6F64656C436F6E74656E744368616E67657328742E6368616E676573293B636F6E7374206E3D28746869732E5F6C617374446966662C652E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(24043) := '2C766F696420652E6D6F646966696564293B6E262628746869732E5F6C617374446966663D6E2C48542828653D3E7B746869732E5F646966662E73657428475A2E66726F6D44696666526573756C7428746869732E5F6C61737444696666292C65292C73';
wwv_flow_imp.g_varchar2_table(24044) := '286E2C65293B636F6E737420743D746869732E6D6F76656454657874546F436F6D706172652E67657428293B746869732E6D6F76656454657874546F436F6D706172652E73657428743F746869732E5F6C617374446966662E6D6F7665732E66696E6428';
wwv_flow_imp.g_varchar2_table(24045) := '28653D3E652E6C696E6552616E67654D617070696E672E6D6F6469666965642E696E7465727365637428742E6C696E6552616E67654D617070696E672E6D6F6469666965642929293A766F696420302C65297D2929297D746869732E5F69734469666655';
wwv_flow_imp.g_varchar2_table(24046) := '70546F446174652E7365742821312C766F69642030292C6F2E7363686564756C6528297D2929292C746869732E5F726567697374657228652E6F726967696E616C2E6F6E4469644368616E6765436F6E74656E742828743D3E7B696628746869732E5F64';
wwv_flow_imp.g_varchar2_table(24047) := '6966662E6765742829297B49672E66726F6D4D6F64656C436F6E74656E744368616E67657328742E6368616E676573293B636F6E7374206E3D28746869732E5F6C617374446966662C652E6F726967696E616C2C766F696420652E6D6F64696669656429';
wwv_flow_imp.g_varchar2_table(24048) := '3B6E262628746869732E5F6C617374446966663D6E2C48542828653D3E7B746869732E5F646966662E73657428475A2E66726F6D44696666526573756C7428746869732E5F6C61737444696666292C65292C73286E2C65293B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(24049) := '732E6D6F76656454657874546F436F6D706172652E67657428293B746869732E6D6F76656454657874546F436F6D706172652E73657428743F746869732E5F6C617374446966662E6D6F7665732E66696E642828653D3E652E6C696E6552616E67654D61';
wwv_flow_imp.g_varchar2_table(24050) := '7070696E672E6D6F6469666965642E696E7465727365637428742E6C696E6552616E67654D617070696E672E6D6F6469666965642929293A766F696420302C65297D2929297D746869732E5F6973446966665570546F446174652E7365742821312C766F';
wwv_flow_imp.g_varchar2_table(24051) := '69642030292C6F2E7363686564756C6528297D2929292C746869732E5F726567697374657228694928286173796E6328742C6E293D3E7B76617220722C613B746869732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E734D696E';
wwv_flow_imp.g_varchar2_table(24052) := '696D756D4C696E65436F756E742E726561642874292C746869732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E73436F6E746578744C696E65436F756E742E726561642874292C6F2E63616E63656C28292C692E726561642874';
wwv_flow_imp.g_varchar2_table(24053) := '293B636F6E7374206C3D746869732E5F6469666650726F76696465722E726561642874293B6C2E6F6E4368616E67655369676E616C2E726561642874292C5959284E482C74292C59592844482C74292C746869732E5F6973446966665570546F44617465';
wwv_flow_imp.g_varchar2_table(24054) := '2E7365742821312C766F69642030293B6C657420633D5B5D3B6E2E61646428652E6F726967696E616C2E6F6E4469644368616E6765436F6E74656E742828653D3E7B636F6E737420743D49672E66726F6D4D6F64656C436F6E74656E744368616E676573';
wwv_flow_imp.g_varchar2_table(24055) := '28652E6368616E676573293B633D646D28632C74297D2929293B6C657420643D5B5D3B6E2E61646428652E6D6F6469666965642E6F6E4469644368616E6765436F6E74656E742828653D3E7B636F6E737420743D49672E66726F6D4D6F64656C436F6E74';
wwv_flow_imp.g_varchar2_table(24056) := '656E744368616E67657328652E6368616E676573293B643D646D28642C74297D2929293B6C657420683D6177616974206C2E6469666650726F76696465722E636F6D707574654469666628652E6F726967696E616C2C652E6D6F6469666965642C7B6967';
wwv_flow_imp.g_varchar2_table(24057) := '6E6F72655472696D576869746573706163653A746869732E5F6F7074696F6E732E69676E6F72655472696D576869746573706163652E726561642874292C6D6178436F6D7075746174696F6E54696D654D733A746869732E5F6F7074696F6E732E6D6178';
wwv_flow_imp.g_varchar2_table(24058) := '436F6D7075746174696F6E54696D654D732E726561642874292C636F6D707574654D6F7665733A746869732E5F6F7074696F6E732E73686F774D6F7665732E726561642874297D2C746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263';
wwv_flow_imp.g_varchar2_table(24059) := '652E746F6B656E293B76617220752C702C673B746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263652E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465647C7C652E6F726967696E616C2E6973446973706F7365';
wwv_flow_imp.g_varchar2_table(24060) := '6428297C7C652E6D6F6469666965642E6973446973706F73656428297C7C28753D682C703D652E6F726967696E616C2C673D652E6D6F6469666965642C683D7B6368616E6765733A752E6368616E6765732E6D61702828653D3E6E6577205A7A28652E6F';
wwv_flow_imp.g_varchar2_table(24061) := '726967696E616C2C652E6D6F6469666965642C652E696E6E65724368616E6765733F652E696E6E65724368616E6765732E6D61702828653D3E66756E6374696F6E28652C742C6E297B6C657420693D652E6F726967696E616C52616E67652C6F3D652E6D';
wwv_flow_imp.g_varchar2_table(24062) := '6F64696669656452616E67653B72657475726E2831213D3D692E656E64436F6C756D6E7C7C31213D3D6F2E656E64436F6C756D6E292626692E656E64436F6C756D6E3D3D3D742E6765744C696E654D6178436F6C756D6E28692E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(24063) := '6265722926266F2E656E64436F6C756D6E3D3D3D6E2E6765744C696E654D6178436F6C756D6E286F2E656E644C696E654E756D626572292626692E656E644C696E654E756D6265723C742E6765744C696E65436F756E74282926266F2E656E644C696E65';
wwv_flow_imp.g_varchar2_table(24064) := '4E756D6265723C6E2E6765744C696E65436F756E742829262628693D692E736574456E64506F736974696F6E28692E656E644C696E654E756D6265722B312C31292C6F3D6F2E736574456E64506F736974696F6E286F2E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(24065) := '2B312C3129292C6E657720587A28692C6F297D28652C702C672929293A766F696420302929292C6D6F7665733A752E6D6F7665732C6964656E746963616C3A752E6964656E746963616C2C717569744561726C793A752E717569744561726C797D2C683D';
wwv_flow_imp.g_varchar2_table(24066) := '6E756C6C213D3D28652E6F726967696E616C2C723D766F696420652E6D6F646966696564292626766F69642030213D3D723F723A682C683D6E756C6C213D3D28652E6F726967696E616C2C613D766F696420652E6D6F646966696564292626766F696420';
wwv_flow_imp.g_varchar2_table(24067) := '30213D3D613F613A682C48542828653D3E7B7328682C65292C746869732E5F6C617374446966663D683B636F6E737420743D475A2E66726F6D44696666526573756C742868293B746869732E5F646966662E73657428742C65292C746869732E5F697344';
wwv_flow_imp.g_varchar2_table(24068) := '6966665570546F446174652E7365742821302C65293B636F6E7374206E3D746869732E6D6F76656454657874546F436F6D706172652E67657428293B746869732E6D6F76656454657874546F436F6D706172652E736574286E3F746869732E5F6C617374';
wwv_flow_imp.g_varchar2_table(24069) := '446966662E6D6F7665732E66696E642828653D3E652E6C696E6552616E67654D617070696E672E6D6F6469666965642E696E74657273656374286E2E6C696E6552616E67654D617070696E672E6D6F6469666965642929293A766F696420302C65297D29';
wwv_flow_imp.g_varchar2_table(24070) := '29297D2929297D656E737572654D6F6469666965644C696E65497356697369626C6528652C742C6E297B76617220692C6F3B696628303D3D3D286E756C6C3D3D3D28693D746869732E646966662E6765742829297C7C766F696420303D3D3D693F766F69';
wwv_flow_imp.g_varchar2_table(24071) := '6420303A692E6D617070696E67732E6C656E677468292972657475726E3B636F6E737420733D286E756C6C3D3D3D286F3D746869732E5F756E6368616E676564526567696F6E732E6765742829297C7C766F696420303D3D3D6F3F766F696420303A6F2E';
wwv_flow_imp.g_varchar2_table(24072) := '726567696F6E73297C7C5B5D3B666F7228636F6E73742069206F66207329696628692E67657448696464656E4D6F64696669656452616E676528766F69642030292E636F6E7461696E732865292972657475726E20766F696420692E73686F774D6F6469';
wwv_flow_imp.g_varchar2_table(24073) := '666965644C696E6528652C742C6E297D656E737572654F726967696E616C4C696E65497356697369626C6528652C742C6E297B76617220692C6F3B696628303D3D3D286E756C6C3D3D3D28693D746869732E646966662E6765742829297C7C766F696420';
wwv_flow_imp.g_varchar2_table(24074) := '303D3D3D693F766F696420303A692E6D617070696E67732E6C656E677468292972657475726E3B636F6E737420733D286E756C6C3D3D3D286F3D746869732E5F756E6368616E676564526567696F6E732E6765742829297C7C766F696420303D3D3D6F3F';
wwv_flow_imp.g_varchar2_table(24075) := '766F696420303A6F2E726567696F6E73297C7C5B5D3B666F7228636F6E73742069206F66207329696628692E67657448696464656E4F726967696E616C52616E676528766F69642030292E636F6E7461696E732865292972657475726E20766F69642069';
wwv_flow_imp.g_varchar2_table(24076) := '2E73686F774F726967696E616C4C696E6528652C742C6E297D6173796E632077616974466F724469666628297B617761697420664928746869732E6973446966665570546F446174652C28653D3E6529297D73657269616C697A65537461746528297B63';
wwv_flow_imp.g_varchar2_table(24077) := '6F6E737420653D746869732E5F756E6368616E676564526567696F6E732E67657428293B72657475726E7B636F6C6C6170736564526567696F6E733A6E756C6C3D3D653F766F696420303A652E726567696F6E732E6D61702828653D3E287B72616E6765';
wwv_flow_imp.g_varchar2_table(24078) := '3A652E67657448696464656E4D6F64696669656452616E676528766F69642030292E73657269616C697A6528297D2929297D7D726573746F726553657269616C697A656453746174652865297B76617220743B636F6E7374206E3D6E756C6C3D3D3D2874';
wwv_flow_imp.g_varchar2_table(24079) := '3D652E636F6C6C6170736564526567696F6E73297C7C766F696420303D3D3D743F766F696420303A742E6D61702828653D3E78752E646573657269616C697A6528652E72616E67652929292C693D746869732E5F756E6368616E676564526567696F6E73';
wwv_flow_imp.g_varchar2_table(24080) := '2E67657428293B6926266E262648542828653D3E7B666F7228636F6E73742074206F6620692E726567696F6E7329666F7228636F6E73742069206F66206E29696628742E6D6F646966696564556E6368616E67656452616E67652E696E74657273656374';
wwv_flow_imp.g_varchar2_table(24081) := '286929297B742E73657448696464656E4D6F64696669656452616E676528692C65293B627265616B7D7D29297D7D3B4B5A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F74';
wwv_flow_imp.g_varchar2_table(24082) := '3A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F662052';
wwv_flow_imp.g_varchar2_table(24083) := '65666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872';
wwv_flow_imp.g_varchar2_table(24084) := '293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E63';
wwv_flow_imp.g_varchar2_table(24085) := '74696F6E286E2C69297B74286E2C692C65297D7D28322C715A295D2C4B5A293B636C61737320475A7B7374617469632066726F6D44696666526573756C742865297B72657475726E206E657720475A28652E6368616E6765732E6D61702828653D3E6E65';
wwv_flow_imp.g_varchar2_table(24086) := '7720515A28652929292C652E6D6F7665737C7C5B5D2C652E6964656E746963616C2C652E717569744561726C79297D636F6E7374727563746F7228652C742C6E2C69297B746869732E6D617070696E67733D652C746869732E6D6F76656454657874733D';
wwv_flow_imp.g_varchar2_table(24087) := '742C746869732E6964656E746963616C3D6E2C746869732E717569744561726C793D697D7D636C61737320515A7B636F6E7374727563746F722865297B746869732E6C696E6552616E67654D617070696E673D657D7D636C61737320595A7B7374617469';
wwv_flow_imp.g_varchar2_table(24088) := '632066726F6D446966667328652C742C6E2C692C6F297B636F6E737420733D5A7A2E696E766572736528652C742C6E292C723D5B5D3B666F7228636F6E73742065206F662073297B6C657420733D652E6F726967696E616C2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(24089) := '6D6265722C613D652E6D6F6469666965642E73746172744C696E654E756D6265722C6C3D652E6F726967696E616C2E6C656E6774683B636F6E737420633D313D3D3D732626313D3D3D612C643D732B6C3D3D3D742B312626612B6C3D3D3D6E2B313B2863';
wwv_flow_imp.g_varchar2_table(24090) := '7C7C642926266C3E3D6F2B693F2863262621642626286C2D3D6F292C6426262163262628732B3D6F2C612B3D6F2C6C2D3D6F292C722E70757368286E657720595A28732C612C6C2C302C302929293A6C3E3D322A6F2B69262628732B3D6F2C612B3D6F2C';
wwv_flow_imp.g_varchar2_table(24091) := '6C2D3D322A6F2C722E70757368286E657720595A28732C612C6C2C302C302929297D72657475726E20727D676574206F726967696E616C556E6368616E67656452616E676528297B72657475726E2078752E6F664C656E67746828746869732E6F726967';
wwv_flow_imp.g_varchar2_table(24092) := '696E616C4C696E654E756D6265722C746869732E6C696E65436F756E74297D676574206D6F646966696564556E6368616E67656452616E676528297B72657475726E2078752E6F664C656E67746828746869732E6D6F6469666965644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(24093) := '65722C746869732E6C696E65436F756E74297D636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6F726967696E616C4C696E654E756D6265723D652C746869732E6D6F6469666965644C696E654E756D6265723D742C746869732E6C';
wwv_flow_imp.g_varchar2_table(24094) := '696E65436F756E743D6E2C746869732E5F76697369626C654C696E65436F756E74546F703D245428746869732C30292C746869732E76697369626C654C696E65436F756E74546F703D746869732E5F76697369626C654C696E65436F756E74546F702C74';
wwv_flow_imp.g_varchar2_table(24095) := '6869732E5F76697369626C654C696E65436F756E74426F74746F6D3D245428746869732C30292C746869732E76697369626C654C696E65436F756E74426F74746F6D3D746869732E5F76697369626C654C696E65436F756E74426F74746F6D2C74686973';
wwv_flow_imp.g_varchar2_table(24096) := '2E5F73686F756C6448696465436F6E74726F6C733D515428746869732C28653D3E746869732E76697369626C654C696E65436F756E74546F702E726561642865292B746869732E76697369626C654C696E65436F756E74426F74746F6D2E726561642865';
wwv_flow_imp.g_varchar2_table(24097) := '293D3D3D746869732E6C696E65436F756E74262621746869732E6973447261676765642E7265616428652929292C746869732E6973447261676765643D245428746869732C766F69642030293B636F6E737420733D4D6174682E6D6178284D6174682E6D';
wwv_flow_imp.g_varchar2_table(24098) := '696E28692C746869732E6C696E65436F756E74292C30292C723D4D6174682E6D6178284D6174682E6D696E286F2C746869732E6C696E65436F756E742D69292C30293B766428693D3D3D73292C7664286F3D3D3D72292C746869732E5F76697369626C65';
wwv_flow_imp.g_varchar2_table(24099) := '4C696E65436F756E74546F702E73657428732C766F69642030292C746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E73657428722C766F69642030297D73657456697369626C6552616E67657328652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(24100) := '5B5D2C693D6E6577206B7528652E6D61702828653D3E652E6D6F6469666965642929292E737562747261637446726F6D28746869732E6D6F646966696564556E6368616E67656452616E6765293B6C6574206F3D746869732E6F726967696E616C4C696E';
wwv_flow_imp.g_varchar2_table(24101) := '654E756D6265722C733D746869732E6D6F6469666965644C696E654E756D6265723B636F6E737420723D746869732E6D6F6469666965644C696E654E756D6265722B746869732E6C696E65436F756E743B696628303D3D3D692E72616E6765732E6C656E';
wwv_flow_imp.g_varchar2_table(24102) := '67746829746869732E73686F77416C6C2874292C6E2E707573682874686973293B656C73657B6C657420653D303B666F7228636F6E73742061206F6620692E72616E676573297B636F6E7374206C3D653D3D3D692E72616E6765732E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(24103) := '3B652B2B3B636F6E737420633D286C3F723A612E656E644C696E654E756D6265724578636C7573697665292D732C643D6E657720595A286F2C732C632C302C30293B642E73657448696464656E4D6F64696669656452616E676528612C74292C6E2E7075';
wwv_flow_imp.g_varchar2_table(24104) := '73682864292C6F3D642E6F726967696E616C556E6368616E67656452616E67652E656E644C696E654E756D6265724578636C75736976652C733D642E6D6F646966696564556E6368616E67656452616E67652E656E644C696E654E756D6265724578636C';
wwv_flow_imp.g_varchar2_table(24105) := '75736976657D7D72657475726E206E7D73686F756C6448696465436F6E74726F6C732865297B72657475726E20746869732E5F73686F756C6448696465436F6E74726F6C732E726561642865297D67657448696464656E4F726967696E616C52616E6765';
wwv_flow_imp.g_varchar2_table(24106) := '2865297B72657475726E2078752E6F664C656E67746828746869732E6F726967696E616C4C696E654E756D6265722B746869732E5F76697369626C654C696E65436F756E74546F702E726561642865292C746869732E6C696E65436F756E742D74686973';
wwv_flow_imp.g_varchar2_table(24107) := '2E5F76697369626C654C696E65436F756E74546F702E726561642865292D746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E72656164286529297D67657448696464656E4D6F64696669656452616E67652865297B72657475726E';
wwv_flow_imp.g_varchar2_table(24108) := '2078752E6F664C656E67746828746869732E6D6F6469666965644C696E654E756D6265722B746869732E5F76697369626C654C696E65436F756E74546F702E726561642865292C746869732E6C696E65436F756E742D746869732E5F76697369626C654C';
wwv_flow_imp.g_varchar2_table(24109) := '696E65436F756E74546F702E726561642865292D746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E72656164286529297D73657448696464656E4D6F64696669656452616E676528652C74297B636F6E7374206E3D652E73746172';
wwv_flow_imp.g_varchar2_table(24110) := '744C696E654E756D6265722D746869732E6D6F6469666965644C696E654E756D6265722C693D746869732E6D6F6469666965644C696E654E756D6265722B746869732E6C696E65436F756E742D652E656E644C696E654E756D6265724578636C75736976';
wwv_flow_imp.g_varchar2_table(24111) := '653B746869732E7365745374617465286E2C692C74297D6765744D617856697369626C654C696E65436F756E74546F7028297B72657475726E20746869732E6C696E65436F756E742D746869732E5F76697369626C654C696E65436F756E74426F74746F';
wwv_flow_imp.g_varchar2_table(24112) := '6D2E67657428297D6765744D617856697369626C654C696E65436F756E74426F74746F6D28297B72657475726E20746869732E6C696E65436F756E742D746869732E5F76697369626C654C696E65436F756E74546F702E67657428297D73686F774D6F72';
wwv_flow_imp.g_varchar2_table(24113) := '6541626F766528653D31302C74297B636F6E7374206E3D746869732E6765744D617856697369626C654C696E65436F756E74546F7028293B746869732E5F76697369626C654C696E65436F756E74546F702E736574284D6174682E6D696E28746869732E';
wwv_flow_imp.g_varchar2_table(24114) := '5F76697369626C654C696E65436F756E74546F702E67657428292B652C6E292C74297D73686F774D6F726542656C6F7728653D31302C74297B636F6E7374206E3D746869732E6C696E65436F756E742D746869732E5F76697369626C654C696E65436F75';
wwv_flow_imp.g_varchar2_table(24115) := '6E74546F702E67657428293B746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E736574284D6174682E6D696E28746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E67657428292B652C6E292C74297D73686F';
wwv_flow_imp.g_varchar2_table(24116) := '77416C6C2865297B746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E73657428746869732E6C696E65436F756E742D746869732E5F76697369626C654C696E65436F756E74546F702E67657428292C65297D73686F774D6F646966';
wwv_flow_imp.g_varchar2_table(24117) := '6965644C696E6528652C742C6E297B636F6E737420693D652B312D28746869732E6D6F6469666965644C696E654E756D6265722B746869732E5F76697369626C654C696E65436F756E74546F702E6765742829292C6F3D746869732E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(24118) := '4C696E654E756D6265722D746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E67657428292B746869732E6C696E65436F756E742D653B303D3D3D742626693C6F7C7C313D3D3D743F746869732E5F76697369626C654C696E65436F';
wwv_flow_imp.g_varchar2_table(24119) := '756E74546F702E73657428746869732E5F76697369626C654C696E65436F756E74546F702E67657428292B692C6E293A746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E73657428746869732E5F76697369626C654C696E65436F';
wwv_flow_imp.g_varchar2_table(24120) := '756E74426F74746F6D2E67657428292B6F2C6E297D73686F774F726967696E616C4C696E6528652C742C6E297B636F6E737420693D652D746869732E6F726967696E616C4C696E654E756D6265722C6F3D746869732E6F726967696E616C4C696E654E75';
wwv_flow_imp.g_varchar2_table(24121) := '6D6265722B746869732E6C696E65436F756E742D653B303D3D3D742626693C6F7C7C313D3D3D743F746869732E5F76697369626C654C696E65436F756E74546F702E736574284D6174682E6D696E28746869732E5F76697369626C654C696E65436F756E';
wwv_flow_imp.g_varchar2_table(24122) := '74546F702E67657428292B6F2D692C746869732E6765744D617856697369626C654C696E65436F756E74546F702829292C6E293A746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E736574284D6174682E6D696E28746869732E5F';
wwv_flow_imp.g_varchar2_table(24123) := '76697369626C654C696E65436F756E74426F74746F6D2E67657428292B692D6F2C746869732E6765744D617856697369626C654C696E65436F756E74426F74746F6D2829292C6E297D636F6C6C61707365416C6C2865297B746869732E5F76697369626C';
wwv_flow_imp.g_varchar2_table(24124) := '654C696E65436F756E74546F702E73657428302C65292C746869732E5F76697369626C654C696E65436F756E74426F74746F6D2E73657428302C65297D736574537461746528652C742C6E297B653D4D6174682E6D6178284D6174682E6D696E28652C74';
wwv_flow_imp.g_varchar2_table(24125) := '6869732E6C696E65436F756E74292C30292C743D4D6174682E6D6178284D6174682E6D696E28742C746869732E6C696E65436F756E742D65292C30292C746869732E5F76697369626C654C696E65436F756E74546F702E73657428652C6E292C74686973';
wwv_flow_imp.g_varchar2_table(24126) := '2E5F76697369626C654C696E65436F756E74426F74746F6D2E73657428742C6E297D7D636C617373205A5A20657874656E6473206C747B676574207669736962696C69747928297B72657475726E20746869732E5F7669736962696C6974797D73657420';
wwv_flow_imp.g_varchar2_table(24127) := '7669736962696C6974792865297B746869732E5F7669736962696C697479213D3D65262628746869732E5F7669736962696C6974793D652C746869732E5F64696666416374696F6E732E7374796C652E7669736962696C6974793D653F2276697369626C';
wwv_flow_imp.g_varchar2_table(24128) := '65223A2268696464656E22297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B737570657228292C746869732E5F676574566965775A6F6E6549643D652C746869732E5F6D617267696E446F6D4E6F64653D742C74686973';
wwv_flow_imp.g_varchar2_table(24129) := '2E5F6D6F646966696564456469746F723D6E2C746869732E5F646966663D692C746869732E5F656469746F723D6F2C746869732E5F766965774C696E65436F756E74733D732C746869732E5F6F726967696E616C546578744D6F64656C3D722C74686973';
wwv_flow_imp.g_varchar2_table(24130) := '2E5F636F6E746578744D656E75536572766963653D612C746869732E5F636C6970626F617264536572766963653D6C2C746869732E5F7669736962696C6974793D21312C746869732E5F6D617267696E446F6D4E6F64652E7374796C652E7A496E646578';
wwv_flow_imp.g_varchar2_table(24131) := '3D223130222C746869732E5F64696666416374696F6E733D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F64696666416374696F6E732E636C6173734E616D653D546C2E6173436C6173734E616D65284C6C2E';
wwv_flow_imp.g_varchar2_table(24132) := '6C6967687442756C62292B22206C6967687462756C622D676C797068222C746869732E5F64696666416374696F6E732E7374796C652E706F736974696F6E3D226162736F6C757465223B636F6E737420633D746869732E5F6D6F64696669656445646974';
wwv_flow_imp.g_varchar2_table(24133) := '6F722E6765744F7074696F6E283637293B746869732E5F64696666416374696F6E732E7374796C652E72696768743D22307078222C746869732E5F64696666416374696F6E732E7374796C652E7669736962696C6974793D2268696464656E222C746869';
wwv_flow_imp.g_varchar2_table(24134) := '732E5F64696666416374696F6E732E7374796C652E6865696768743D60247B637D7078602C746869732E5F64696666416374696F6E732E7374796C652E6C696E654865696768743D60247B637D7078602C746869732E5F6D617267696E446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(24135) := '2E617070656E644368696C6428746869732E5F64696666416374696F6E73293B6C657420643D303B636F6E737420683D6E2E6765744F7074696F6E2831323729262621512C753D28652C74293D3E7B766172206F3B746869732E5F636F6E746578744D65';
wwv_flow_imp.g_varchar2_table(24136) := '6E75536572766963652E73686F77436F6E746578744D656E75287B646F6D466F72536861646F77526F6F743A6826266E756C6C213D3D286F3D6E2E676574446F6D4E6F64652829292626766F69642030213D3D6F3F6F3A766F696420302C676574416E63';
wwv_flow_imp.g_varchar2_table(24137) := '686F723A28293D3E287B783A652C793A747D292C676574416374696F6E733A28293D3E7B636F6E737420653D5B5D2C743D692E6D6F6469666965642E6973456D7074793B72657475726E20652E70757368286E65772062632822646966662E636C697062';
wwv_flow_imp.g_varchar2_table(24138) := '6F6172642E636F707944656C65746564436F6E74656E74222C743F692E6F726967696E616C2E6C656E6774683E313F6228302C22436F70792064656C65746564206C696E657322293A6228302C22436F70792064656C65746564206C696E6522293A692E';
wwv_flow_imp.g_varchar2_table(24139) := '6F726967696E616C2E6C656E6774683E313F6228302C22436F7079206368616E676564206C696E657322293A6228302C22436F7079206368616E676564206C696E6522292C766F696420302C21302C286173796E6328293D3E7B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(24140) := '69732E5F6F726967696E616C546578744D6F64656C2E67657456616C7565496E52616E676528692E6F726967696E616C2E746F4578636C757369766552616E67652829293B617761697420746869732E5F636C6970626F617264536572766963652E7772';
wwv_flow_imp.g_varchar2_table(24141) := '697465546578742865297D2929292C692E6F726967696E616C2E6C656E6774683E312626652E70757368286E65772062632822646966662E636C6970626F6172642E636F707944656C657465644C696E65436F6E74656E74222C6228302C743F22436F70';
wwv_flow_imp.g_varchar2_table(24142) := '792064656C65746564206C696E6520287B307D29223A22436F7079206368616E676564206C696E6520287B307D29222C692E6F726967696E616C2E73746172744C696E654E756D6265722B64292C766F696420302C21302C286173796E6328293D3E7B6C';
wwv_flow_imp.g_varchar2_table(24143) := '657420653D746869732E5F6F726967696E616C546578744D6F64656C2E6765744C696E65436F6E74656E7428692E6F726967696E616C2E73746172744C696E654E756D6265722B64293B22223D3D3D65262628653D303D3D3D746869732E5F6F72696769';
wwv_flow_imp.g_varchar2_table(24144) := '6E616C546578744D6F64656C2E676574456E644F664C696E6553657175656E636528293F225C6E223A225C725C6E22292C617761697420746869732E5F636C6970626F617264536572766963652E7772697465546578742865297D2929292C6E2E676574';
wwv_flow_imp.g_varchar2_table(24145) := '4F7074696F6E283931297C7C652E70757368286E65772062632822646966662E696E6C696E652E7265766572744368616E6765222C6228302C225265766572742074686973206368616E676522292C766F696420302C21302C286173796E6328293D3E7B';
wwv_flow_imp.g_varchar2_table(24146) := '746869732E5F656469746F722E72657665727428746869732E5F64696666297D2929292C657D2C6175746F53656C65637446697273744974656D3A21307D297D3B746869732E5F726567697374657228797328746869732E5F64696666416374696F6E73';
wwv_flow_imp.g_varchar2_table(24147) := '2C226D6F757365646F776E222C28653D3E7B69662821652E6C656674427574746F6E2972657475726E3B636F6E73747B746F703A742C6865696768743A6E7D3D417328746869732E5F64696666416374696F6E73292C693D4D6174682E666C6F6F722863';
wwv_flow_imp.g_varchar2_table(24148) := '2F33293B652E70726576656E7444656661756C7428292C7528652E706F73782C742B6E2B69297D2929292C746869732E5F7265676973746572286E2E6F6E4D6F7573654D6F76652828653D3E7B38213D3D652E7461726765742E74797065262635213D3D';
wwv_flow_imp.g_varchar2_table(24149) := '652E7461726765742E747970657C7C652E7461726765742E64657461696C2E766965775A6F6E654964213D3D746869732E5F676574566965775A6F6E65496428293F746869732E7669736962696C6974793D21313A28643D746869732E5F757064617465';
wwv_flow_imp.g_varchar2_table(24150) := '4C6967687442756C62506F736974696F6E28746869732E5F6D617267696E446F6D4E6F64652C652E6576656E742E62726F777365724576656E742E792C63292C746869732E7669736962696C6974793D2130297D2929292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(24151) := '6572286E2E6F6E4D6F757365446F776E2828653D3E7B21652E6576656E742E6C656674427574746F6E7C7C38213D3D652E7461726765742E74797065262635213D3D652E7461726765742E747970657C7C652E7461726765742E64657461696C2E766965';
wwv_flow_imp.g_varchar2_table(24152) := '775A6F6E6549643D3D3D746869732E5F676574566965775A6F6E6549642829262628652E6576656E742E70726576656E7444656661756C7428292C643D746869732E5F7570646174654C6967687442756C62506F736974696F6E28746869732E5F6D6172';
wwv_flow_imp.g_varchar2_table(24153) := '67696E446F6D4E6F64652C652E6576656E742E62726F777365724576656E742E792C63292C7528652E6576656E742E706F73782C652E6576656E742E706F73792B6329297D2929297D5F7570646174654C6967687442756C62506F736974696F6E28652C';
wwv_flow_imp.g_varchar2_table(24154) := '742C6E297B636F6E73747B746F703A697D3D41732865292C6F3D742D692C733D4D6174682E666C6F6F72286F2F6E292C723D732A6E3B696628746869732E5F64696666416374696F6E732E7374796C652E746F703D60247B727D7078602C746869732E5F';
wwv_flow_imp.g_varchar2_table(24155) := '766965774C696E65436F756E7473297B6C657420653D303B666F72286C657420743D303B743C746869732E5F766965774C696E65436F756E74732E6C656E6774683B742B2B29696628652B3D746869732E5F766965774C696E65436F756E74735B745D2C';
wwv_flow_imp.g_varchar2_table(24156) := '733C652972657475726E20747D72657475726E20737D7D636F6E737420585A3D6545282264696666456469746F72576964676574222C7B63726561746548544D4C3A653D3E657D293B66756E6374696F6E204A5A28652C742C6E2C69297B724528692C74';
wwv_flow_imp.g_varchar2_table(24157) := '2E666F6E74496E666F293B636F6E7374206F3D6E2E6C656E6774683E302C733D6E6577206E7028316534293B6C657420723D302C613D303B636F6E7374206C3D5B5D3B666F72286C657420693D303B693C652E6C696E65546F6B656E732E6C656E677468';
wwv_flow_imp.g_varchar2_table(24158) := '3B692B2B297B636F6E737420633D692B312C643D652E6C696E65546F6B656E735B695D2C683D652E6C696E65427265616B446174615B695D2C753D634E2E66696C746572286E2C632C312C4E756D6265722E4D41585F534146455F494E5445474552293B';
wwv_flow_imp.g_varchar2_table(24159) := '69662868297B6C6574206E3D303B666F7228636F6E73742069206F6620682E627265616B4F666673657473297B636F6E7374206C3D642E736C696365416E64496E666C617465286E2C692C30293B723D4D6174682E6D617828722C6E5828612C6C2C634E';
wwv_flow_imp.g_varchar2_table(24160) := '2E657874726163745772617070656428752C6E2C69292C6F2C652E6D69676874436F6E7461696E4E6F6E426173696341534349492C652E6D69676874436F6E7461696E52544C2C742C7329292C612B2B2C6E3D697D6C2E7075736828682E627265616B4F';
wwv_flow_imp.g_varchar2_table(24161) := '6666736574732E6C656E677468297D656C7365206C2E707573682831292C723D4D6174682E6D617828722C6E5828612C642C752C6F2C652E6D69676874436F6E7461696E4E6F6E426173696341534349492C652E6D69676874436F6E7461696E52544C2C';
wwv_flow_imp.g_varchar2_table(24162) := '742C7329292C612B2B7D722B3D742E7363726F6C6C4265796F6E644C617374436F6C756D6E3B636F6E737420633D732E6275696C6428292C643D585A3F585A2E63726561746548544D4C2863293A633B72657475726E20692E696E6E657248544D4C3D64';
wwv_flow_imp.g_varchar2_table(24163) := '2C7B686569676874496E4C696E65733A612C6D696E5769647468496E50783A722A742E7479706963616C48616C66776964746843686172616374657257696474682C766965774C696E65436F756E74733A6C7D7D636C6173732065587B636F6E73747275';
wwv_flow_imp.g_varchar2_table(24164) := '63746F7228652C742C6E2C69297B746869732E6C696E65546F6B656E733D652C746869732E6C696E65427265616B446174613D742C746869732E6D69676874436F6E7461696E4E6F6E426173696341534349493D6E2C746869732E6D69676874436F6E74';
wwv_flow_imp.g_varchar2_table(24165) := '61696E52544C3D697D7D636C6173732074587B7374617469632066726F6D456469746F722865297B76617220743B636F6E7374206E3D652E6765744F7074696F6E7328292C693D6E2E676574283530292C6F3D6E2E67657428313435293B72657475726E';
wwv_flow_imp.g_varchar2_table(24166) := '206E657720745828286E756C6C3D3D3D28743D652E6765744D6F64656C2829297C7C766F696420303D3D3D743F766F696420303A742E6765744F7074696F6E7328292E74616253697A65297C7C302C692C6E2E676574283333292C692E7479706963616C';
wwv_flow_imp.g_varchar2_table(24167) := '48616C66776964746843686172616374657257696474682C6E2E67657428313034292C6E2E676574283637292C6F2E6465636F726174696F6E7357696474682C6E2E67657428313137292C6E2E676574283939292C6E2E676574283934292C6E2E676574';
wwv_flow_imp.g_varchar2_table(24168) := '28353129297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C64297B746869732E74616253697A653D652C746869732E666F6E74496E666F3D742C746869732E64697361626C654D6F6E6F73706163654F7074696D697A';
wwv_flow_imp.g_varchar2_table(24169) := '6174696F6E733D6E2C746869732E7479706963616C48616C66776964746843686172616374657257696474683D692C746869732E7363726F6C6C4265796F6E644C617374436F6C756D6E3D6F2C746869732E6C696E654865696768743D732C746869732E';
wwv_flow_imp.g_varchar2_table(24170) := '6C696E654465636F726174696F6E7357696474683D722C746869732E73746F7052656E646572696E674C696E6541667465723D612C746869732E72656E646572576869746573706163653D6C2C746869732E72656E646572436F6E74726F6C4368617261';
wwv_flow_imp.g_varchar2_table(24171) := '63746572733D632C746869732E666F6E744C69676174757265733D647D7D66756E6374696F6E206E5828652C742C6E2C692C6F2C732C722C61297B612E617070656E64537472696E6728273C64697620636C6173733D22766965772D6C696E6527292C69';
wwv_flow_imp.g_varchar2_table(24172) := '7C7C612E617070656E64537472696E67282220636861722D64656C65746522292C612E617070656E64537472696E67282722207374796C653D22746F703A27292C612E617070656E64537472696E6728537472696E6728652A722E6C696E654865696768';
wwv_flow_imp.g_varchar2_table(24173) := '7429292C612E617070656E64537472696E67282770783B77696474683A3130303030303070783B223E27293B636F6E7374206C3D742E6765744C696E65436F6E74656E7428292C633D784F2E697342617369634153434949286C2C6F292C643D784F2E63';
wwv_flow_imp.g_varchar2_table(24174) := '6F6E7461696E7352544C286C2C632C73292C683D5F4E286E6577206D4E28722E666F6E74496E666F2E69734D6F6E6F7370616365262621722E64697361626C654D6F6E6F73706163654F7074696D697A6174696F6E732C722E666F6E74496E666F2E6361';
wwv_flow_imp.g_varchar2_table(24175) := '6E55736548616C667769647468526967687477617264734172726F772C6C2C21312C632C642C302C742C6E2C722E74616253697A652C302C722E666F6E74496E666F2E737061636557696474682C722E666F6E74496E666F2E6D6964646F745769647468';
wwv_flow_imp.g_varchar2_table(24176) := '2C722E666F6E74496E666F2E77736D6964646F7457696474682C722E73746F7052656E646572696E674C696E6541667465722C722E72656E646572576869746573706163652C722E72656E646572436F6E74726F6C436861726163746572732C722E666F';
wwv_flow_imp.g_varchar2_table(24177) := '6E744C6967617475726573213D3D414C2E4F46462C6E756C6C292C61293B72657475726E20612E617070656E64537472696E6728223C2F6469763E22292C682E6368617261637465724D617070696E672E676574486F72697A6F6E74616C4F6666736574';
wwv_flow_imp.g_varchar2_table(24178) := '28682E6368617261637465724D617070696E672E6C656E677468297D7661722069583D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206F583D636C61737320657874656E64';
wwv_flow_imp.g_varchar2_table(24179) := '73206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C63297B737570657228292C746869732E5F74617267657457696E646F773D652C746869732E5F656469746F72733D742C746869732E5F646966664D6F64656C3D6E';
wwv_flow_imp.g_varchar2_table(24180) := '2C746869732E5F6F7074696F6E733D692C746869732E5F64696666456469746F725769646765743D6F2C746869732E5F63616E49676E6F7265566965775A6F6E655570646174654576656E743D732C746869732E5F6F726967566965775A6F6E6573546F';
wwv_flow_imp.g_varchar2_table(24181) := '49676E6F72653D722C746869732E5F6D6F64566965775A6F6E6573546F49676E6F72653D612C746869732E5F636C6970626F617264536572766963653D6C2C746869732E5F636F6E746578744D656E75536572766963653D632C746869732E5F6F726967';
wwv_flow_imp.g_varchar2_table(24182) := '696E616C546F7050616464696E673D245428746869732C30292C746869732E5F6F726967696E616C5363726F6C6C4F66667365743D245428746869732C30292C746869732E5F6F726967696E616C5363726F6C6C4F6666736574416E696D617465643D24';
wwv_flow_imp.g_varchar2_table(24183) := '5928746869732E5F74617267657457696E646F772C746869732E5F6F726967696E616C5363726F6C6C4F66667365742C746869732E5F73746F7265292C746869732E5F6D6F646966696564546F7050616464696E673D245428746869732C30292C746869';
wwv_flow_imp.g_varchar2_table(24184) := '732E5F6D6F6469666965645363726F6C6C4F66667365743D245428746869732C30292C746869732E5F6D6F6469666965645363726F6C6C4F6666736574416E696D617465643D245928746869732E5F74617267657457696E646F772C746869732E5F6D6F';
wwv_flow_imp.g_varchar2_table(24185) := '6469666965645363726F6C6C4F66667365742C746869732E5F73746F7265293B636F6E737420643D24542822696E76616C6964617465416C69676E6D656E74735374617465222C30292C683D746869732E5F7265676973746572286E6577204B74282828';
wwv_flow_imp.g_varchar2_table(24186) := '293D3E7B642E73657428642E67657428292B312C766F69642030297D292C3029293B746869732E5F726567697374657228746869732E5F656469746F72732E6F726967696E616C2E6F6E4469644368616E6765566965775A6F6E65732828653D3E7B7468';
wwv_flow_imp.g_varchar2_table(24187) := '69732E5F63616E49676E6F7265566965775A6F6E655570646174654576656E7428297C7C682E7363686564756C6528297D2929292C746869732E5F726567697374657228746869732E5F656469746F72732E6D6F6469666965642E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(24188) := '6765566965775A6F6E65732828653D3E7B746869732E5F63616E49676E6F7265566965775A6F6E655570646174654576656E7428297C7C682E7363686564756C6528297D2929292C746869732E5F726567697374657228746869732E5F656469746F7273';
wwv_flow_imp.g_varchar2_table(24189) := '2E6F726967696E616C2E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B28652E6861734368616E67656428313436297C7C652E6861734368616E67656428363729292626682E7363686564756C6528297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(24190) := '2E5F726567697374657228746869732E5F656469746F72732E6D6F6469666965642E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B28652E6861734368616E67656428313436297C7C652E6861734368616E67656428363729';
wwv_flow_imp.g_varchar2_table(24191) := '292626682E7363686564756C6528297D2929293B636F6E737420753D746869732E5F646966664D6F64656C2E6D61702828653D3E653F614928652E6D6F64656C2E6F726967696E616C2E6F6E4469644368616E6765546F6B656E732C2828293D3E323D3D';
wwv_flow_imp.g_varchar2_table(24192) := '3D652E6D6F64656C2E6F726967696E616C2E746F6B656E697A6174696F6E2E6261636B67726F756E64546F6B656E697A6174696F6E537461746529293A766F6964203029292E6D6170282828652C74293D3E6E756C6C3D3D653F766F696420303A652E72';
wwv_flow_imp.g_varchar2_table(24193) := '65616428742929292C703D51542828653D3E7B636F6E737420743D746869732E5F646966664D6F64656C2E726561642865292C6E3D6E756C6C3D3D743F766F696420303A742E646966662E726561642865293B69662821747C7C216E2972657475726E20';
wwv_flow_imp.g_varchar2_table(24194) := '6E756C6C3B642E726561642865293B636F6E737420693D746869732E5F6F7074696F6E732E72656E646572536964654279536964652E726561642865293B72657475726E20735828746869732E5F656469746F72732E6F726967696E616C2C746869732E';
wwv_flow_imp.g_varchar2_table(24195) := '5F656469746F72732E6D6F6469666965642C6E2E6D617070696E67732C746869732E5F6F726967566965775A6F6E6573546F49676E6F72652C746869732E5F6D6F64566965775A6F6E6573546F49676E6F72652C69297D29292C673D51542828653D3E7B';
wwv_flow_imp.g_varchar2_table(24196) := '76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6D6F76656454657874546F436F6D706172652E726561642865293B696628';
wwv_flow_imp.g_varchar2_table(24197) := '216E2972657475726E206E756C6C3B642E726561642865293B636F6E737420693D6E2E6368616E6765732E6D61702828653D3E6E657720515A28652929293B72657475726E20735828746869732E5F656469746F72732E6F726967696E616C2C74686973';
wwv_flow_imp.g_varchar2_table(24198) := '2E5F656469746F72732E6D6F6469666965642C692C746869732E5F6F726967566965775A6F6E6573546F49676E6F72652C746869732E5F6D6F64566965775A6F6E6573546F49676E6F72652C2130297D29293B66756E6374696F6E206D28297B636F6E73';
wwv_flow_imp.g_varchar2_table(24199) := '7420653D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E20652E636C6173734E616D653D22646961676F6E616C2D66696C6C222C657D636F6E737420663D746869732E5F7265676973746572286E6577206174';
wwv_flow_imp.g_varchar2_table(24200) := '293B746869732E766965775A6F6E65733D5A5428746869732C2828652C74293D3E7B766172206E2C692C732C722C612C6C2C632C643B662E636C65617228293B636F6E737420683D702E726561642865297C7C5B5D2C763D5B5D2C623D5B5D2C5F3D7468';
wwv_flow_imp.g_varchar2_table(24201) := '69732E5F6D6F646966696564546F7050616464696E672E726561642865293B5F3E302626622E70757368287B61667465724C696E654E756D6265723A302C646F6D4E6F64653A646F63756D656E742E637265617465456C656D656E74282264697622292C';
wwv_flow_imp.g_varchar2_table(24202) := '686569676874496E50783A5F2C73686F77496E48696464656E41726561733A21302C73757070726573734D6F757365446F776E3A21307D293B636F6E737420793D746869732E5F6F726967696E616C546F7050616464696E672E726561642865293B793E';
wwv_flow_imp.g_varchar2_table(24203) := '302626762E70757368287B61667465724C696E654E756D6265723A302C646F6D4E6F64653A646F63756D656E742E637265617465456C656D656E74282264697622292C686569676874496E50783A792C73686F77496E48696464656E41726561733A2130';
wwv_flow_imp.g_varchar2_table(24204) := '2C73757070726573734D6F757365446F776E3A21307D293B636F6E737420773D746869732E5F6F7074696F6E732E72656E646572536964654279536964652E726561642865292C433D777C7C6E756C6C3D3D3D286E3D746869732E5F656469746F72732E';
wwv_flow_imp.g_varchar2_table(24205) := '6D6F6469666965642E5F676574566965774D6F64656C2829297C7C766F696420303D3D3D6E3F766F696420303A6E2E6372656174654C696E65427265616B73436F6D707574657228293B69662843297B636F6E737420493D746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(24206) := '732E6F726967696E616C2E6765744D6F64656C28293B666F7228636F6E7374204D206F662068296966284D2E6469666629666F72286C657420413D4D2E6F726967696E616C52616E67652E73746172744C696E654E756D6265723B413C4D2E6F72696769';
wwv_flow_imp.g_varchar2_table(24207) := '6E616C52616E67652E656E644C696E654E756D6265724578636C75736976653B412B2B297B696628413E492E6765744C696E65436F756E7428292972657475726E7B6F7269673A762C6D6F643A627D3B6E756C6C3D3D437C7C432E616464526571756573';
wwv_flow_imp.g_varchar2_table(24208) := '7428492E6765744C696E65436F6E74656E742841292C6E756C6C2C6E756C6C297D7D636F6E737420533D6E756C6C213D3D28693D6E756C6C3D3D433F766F696420303A432E66696E616C697A652829292626766F69642030213D3D693F693A5B5D3B6C65';
wwv_flow_imp.g_varchar2_table(24209) := '7420783D303B636F6E7374206B3D746869732E5F656469746F72732E6D6F6469666965642E6765744F7074696F6E283637292C453D6E756C6C3D3D3D28733D746869732E5F646966664D6F64656C2E72656164286529297C7C766F696420303D3D3D733F';
wwv_flow_imp.g_varchar2_table(24210) := '766F696420303A732E6D6F76656454657874546F436F6D706172652E726561642865292C4C3D6E756C6C213D3D28613D6E756C6C3D3D3D28723D746869732E5F656469746F72732E6F726967696E616C2E6765744D6F64656C2829297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(24211) := '3D3D3D723F766F696420303A722E6D69676874436F6E7461696E4E6F6E426173696341534349492829292626766F69642030213D3D612626612C443D6E756C6C213D3D28633D6E756C6C3D3D3D286C3D746869732E5F656469746F72732E6F726967696E';
wwv_flow_imp.g_varchar2_table(24212) := '616C2E6765744D6F64656C2829297C7C766F696420303D3D3D6C3F766F696420303A6C2E6D69676874436F6E7461696E52544C2829292626766F69642030213D3D632626632C543D74582E66726F6D456469746F7228746869732E5F656469746F72732E';
wwv_flow_imp.g_varchar2_table(24213) := '6D6F646966696564293B666F7228636F6E7374204E206F662068296966284E2E6469666626262177297B696628214E2E6F726967696E616C52616E67652E6973456D707479297B752E726561642865293B636F6E7374204F3D646F63756D656E742E6372';
wwv_flow_imp.g_varchar2_table(24214) := '65617465456C656D656E74282264697622293B4F2E636C6173734C6973742E6164642822766965772D6C696E6573222C226C696E652D64656C657465222C226D6F6E61636F2D6D6F7573652D637572736F722D7465787422293B636F6E737420523D7468';
wwv_flow_imp.g_varchar2_table(24215) := '69732E5F656469746F72732E6F726967696E616C2E6765744D6F64656C28293B6966284E2E6F726967696E616C52616E67652E656E644C696E654E756D6265724578636C75736976652D313E522E6765744C696E65436F756E7428292972657475726E7B';
wwv_flow_imp.g_varchar2_table(24216) := '6F7269673A762C6D6F643A627D3B636F6E737420463D6E6577206558284E2E6F726967696E616C52616E67652E6D6170546F4C696E6541727261792828653D3E522E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E7328652929292C4E2E';
wwv_flow_imp.g_varchar2_table(24217) := '6F726967696E616C52616E67652E6D6170546F4C696E6541727261792828653D3E535B782B2B5D29292C4C2C44292C423D5B5D3B666F7228636F6E73742057206F66204E2E646966662E696E6E65724368616E6765737C7C5B5D29422E70757368286E65';
wwv_flow_imp.g_varchar2_table(24218) := '77206B4F28572E6F726967696E616C52616E67652E64656C7461282D284E2E646966662E6F726967696E616C2E73746172744C696E654E756D6265722D3129292C4F5A2E636C6173734E616D652C3029293B636F6E737420563D4A5A28462C542C422C4F';
wwv_flow_imp.g_varchar2_table(24219) := '292C7A3D646F63756D656E742E637265617465456C656D656E74282264697622293B6966287A2E636C6173734E616D653D22696E6C696E652D64656C657465642D6D617267696E2D766965772D7A6F6E65222C7245287A2C542E666F6E74496E666F292C';
wwv_flow_imp.g_varchar2_table(24220) := '746869732E5F6F7074696F6E732E72656E646572496E64696361746F72732E7265616428652929666F72286C6574206A3D303B6A3C562E686569676874496E4C696E65733B6A2B2B297B636F6E737420713D646F63756D656E742E637265617465456C65';
wwv_flow_imp.g_varchar2_table(24221) := '6D656E74282264697622293B712E636C6173734E616D653D6064656C6574652D7369676E20247B546C2E6173436C6173734E616D65284C5A297D602C712E73657441747472696275746528227374796C65222C60706F736974696F6E3A6162736F6C7574';
wwv_flow_imp.g_varchar2_table(24222) := '653B746F703A247B6A2A6B7D70783B77696474683A247B542E6C696E654465636F726174696F6E7357696474687D70783B6865696768743A247B6B7D70783B72696768743A303B60292C7A2E617070656E644368696C642871297D6C657420483B662E61';
wwv_flow_imp.g_varchar2_table(24223) := '6464286E6577205A5A282828293D3E776C284829292C7A2C746869732E5F656469746F72732E6D6F6469666965642C4E2E646966662C746869732E5F64696666456469746F725769646765742C562E766965774C696E65436F756E74732C746869732E5F';
wwv_flow_imp.g_varchar2_table(24224) := '656469746F72732E6F726967696E616C2E6765744D6F64656C28292C746869732E5F636F6E746578744D656E75536572766963652C746869732E5F636C6970626F6172645365727669636529293B666F72286C657420243D303B243C562E766965774C69';
wwv_flow_imp.g_varchar2_table(24225) := '6E65436F756E74732E6C656E6774683B242B2B297B636F6E737420553D562E766965774C696E65436F756E74735B245D3B553E312626762E70757368287B61667465724C696E654E756D6265723A4E2E6F726967696E616C52616E67652E73746172744C';
wwv_flow_imp.g_varchar2_table(24226) := '696E654E756D6265722B242C646F6D4E6F64653A6D28292C686569676874496E50783A28552D31292A6B2C73686F77496E48696464656E41726561733A21302C73757070726573734D6F757365446F776E3A21307D297D622E70757368287B6166746572';
wwv_flow_imp.g_varchar2_table(24227) := '4C696E654E756D6265723A4E2E6D6F64696669656452616E67652E73746172744C696E654E756D6265722D312C646F6D4E6F64653A4F2C686569676874496E50783A562E686569676874496E4C696E65732A6B2C6D696E5769647468496E50783A562E6D';
wwv_flow_imp.g_varchar2_table(24228) := '696E5769647468496E50782C6D617267696E446F6D4E6F64653A7A2C7365745A6F6E6549642865297B483D657D2C73686F77496E48696464656E41726561733A21302C73757070726573734D6F757365446F776E3A21307D297D636F6E737420503D646F';
wwv_flow_imp.g_varchar2_table(24229) := '63756D656E742E637265617465456C656D656E74282264697622293B502E636C6173734E616D653D226775747465722D64656C657465222C762E70757368287B61667465724C696E654E756D6265723A4E2E6F726967696E616C52616E67652E656E644C';
wwv_flow_imp.g_varchar2_table(24230) := '696E654E756D6265724578636C75736976652D312C646F6D4E6F64653A6D28292C686569676874496E50783A4E2E6D6F646966696564486569676874496E50782C6D617267696E446F6D4E6F64653A502C73686F77496E48696464656E41726561733A21';
wwv_flow_imp.g_varchar2_table(24231) := '302C73757070726573734D6F757365446F776E3A21307D297D656C73657B636F6E7374204B3D4E2E6D6F646966696564486569676874496E50782D4E2E6F726967696E616C486569676874496E50783B6966284B3E30297B6966286E756C6C3D3D453F76';
wwv_flow_imp.g_varchar2_table(24232) := '6F696420303A452E6C696E6552616E67654D617070696E672E6F726967696E616C2E64656C7461282D31292E64656C74614C656E6774682832292E636F6E7461696E73284E2E6F726967696E616C52616E67652E656E644C696E654E756D626572457863';
wwv_flow_imp.g_varchar2_table(24233) := '6C75736976652D312929636F6E74696E75653B762E70757368287B61667465724C696E654E756D6265723A4E2E6F726967696E616C52616E67652E656E644C696E654E756D6265724578636C75736976652D312C646F6D4E6F64653A6D28292C68656967';
wwv_flow_imp.g_varchar2_table(24234) := '6874496E50783A4B2C73686F77496E48696464656E41726561733A21302C73757070726573734D6F757365446F776E3A21307D297D656C73657B6966286E756C6C3D3D453F766F696420303A452E6C696E6552616E67654D617070696E672E6D6F646966';
wwv_flow_imp.g_varchar2_table(24235) := '6965642E64656C7461282D31292E64656C74614C656E6774682832292E636F6E7461696E73284E2E6D6F64696669656452616E67652E656E644C696E654E756D6265724578636C75736976652D312929636F6E74696E75653B66756E6374696F6E204728';
wwv_flow_imp.g_varchar2_table(24236) := '297B636F6E737420653D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E20652E636C6173734E616D653D226172726F772D7265766572742D6368616E676520222B546C2E6173436C6173734E616D65284C6C2E';
wwv_flow_imp.g_varchar2_table(24237) := '6172726F775269676874292C742E61646428627328652C226D6F757365646F776E222C28653D3E652E73746F7050726F7061676174696F6E28292929292C742E61646428627328652C22636C69636B222C28653D3E7B652E73746F7050726F7061676174';
wwv_flow_imp.g_varchar2_table(24238) := '696F6E28292C6F2E726576657274284E2E64696666297D2929292C62722822646976222C7B7D2C65297D6C657420513B4E2E6469666626264E2E646966662E6D6F6469666965642E6973456D7074792626746869732E5F6F7074696F6E732E73686F756C';
wwv_flow_imp.g_varchar2_table(24239) := '6452656E6465724F6C645265766572744172726F77732E72656164286529262628513D472829292C622E70757368287B61667465724C696E654E756D6265723A4E2E6D6F64696669656452616E67652E656E644C696E654E756D6265724578636C757369';
wwv_flow_imp.g_varchar2_table(24240) := '76652D312C646F6D4E6F64653A6D28292C686569676874496E50783A2D4B2C6D617267696E446F6D4E6F64653A512C73686F77496E48696464656E41726561733A21302C73757070726573734D6F757365446F776E3A21307D297D7D666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(24241) := '742059206F66206E756C6C213D3D28643D672E72656164286529292626766F69642030213D3D643F643A5B5D297B69662821286E756C6C3D3D453F766F696420303A452E6C696E6552616E67654D617070696E672E6F726967696E616C2E696E74657273';
wwv_flow_imp.g_varchar2_table(24242) := '65637428592E6F726967696E616C52616E676529297C7C21286E756C6C3D3D453F766F696420303A452E6C696E6552616E67654D617070696E672E6D6F6469666965642E696E7465727365637428592E6D6F64696669656452616E6765292929636F6E74';
wwv_flow_imp.g_varchar2_table(24243) := '696E75653B636F6E7374205A3D592E6D6F646966696564486569676874496E50782D592E6F726967696E616C486569676874496E50783B5A3E303F762E70757368287B61667465724C696E654E756D6265723A592E6F726967696E616C52616E67652E65';
wwv_flow_imp.g_varchar2_table(24244) := '6E644C696E654E756D6265724578636C75736976652D312C646F6D4E6F64653A6D28292C686569676874496E50783A5A2C73686F77496E48696464656E41726561733A21302C73757070726573734D6F757365446F776E3A21307D293A622E7075736828';
wwv_flow_imp.g_varchar2_table(24245) := '7B61667465724C696E654E756D6265723A592E6D6F64696669656452616E67652E656E644C696E654E756D6265724578636C75736976652D312C646F6D4E6F64653A6D28292C686569676874496E50783A2D5A2C73686F77496E48696464656E41726561';
wwv_flow_imp.g_varchar2_table(24246) := '733A21302C73757070726573734D6F757365446F776E3A21307D297D72657475726E7B6F7269673A762C6D6F643A627D7D29293B6C657420763D21313B746869732E5F726567697374657228746869732E5F656469746F72732E6F726967696E616C2E6F';
wwv_flow_imp.g_varchar2_table(24247) := '6E4469645363726F6C6C4368616E67652828653D3E7B652E7363726F6C6C4C6566744368616E67656426262176262628763D21302C746869732E5F656469746F72732E6D6F6469666965642E7365745363726F6C6C4C65667428652E7363726F6C6C4C65';
wwv_flow_imp.g_varchar2_table(24248) := '6674292C763D2131297D2929292C746869732E5F726567697374657228746869732E5F656469746F72732E6D6F6469666965642E6F6E4469645363726F6C6C4368616E67652828653D3E7B652E7363726F6C6C4C6566744368616E676564262621762626';
wwv_flow_imp.g_varchar2_table(24249) := '28763D21302C746869732E5F656469746F72732E6F726967696E616C2E7365745363726F6C6C4C65667428652E7363726F6C6C4C656674292C763D2131297D2929292C746869732E5F6F726967696E616C5363726F6C6C546F703D614928746869732E5F';
wwv_flow_imp.g_varchar2_table(24250) := '656469746F72732E6F726967696E616C2E6F6E4469645363726F6C6C4368616E67652C2828293D3E746869732E5F656469746F72732E6F726967696E616C2E6765745363726F6C6C546F70282929292C746869732E5F6D6F6469666965645363726F6C6C';
wwv_flow_imp.g_varchar2_table(24251) := '546F703D614928746869732E5F656469746F72732E6D6F6469666965642E6F6E4469645363726F6C6C4368616E67652C2828293D3E746869732E5F656469746F72732E6D6F6469666965642E6765745363726F6C6C546F70282929292C746869732E5F72';
wwv_flow_imp.g_varchar2_table(24252) := '656769737465722865492828653D3E7B636F6E737420743D746869732E5F6F726967696E616C5363726F6C6C546F702E726561642865292D28746869732E5F6F726967696E616C5363726F6C6C4F6666736574416E696D617465642E67657428292D7468';
wwv_flow_imp.g_varchar2_table(24253) := '69732E5F6D6F6469666965645363726F6C6C4F6666736574416E696D617465642E72656164286529292D28746869732E5F6F726967696E616C546F7050616464696E672E67657428292D746869732E5F6D6F646966696564546F7050616464696E672E72';
wwv_flow_imp.g_varchar2_table(24254) := '656164286529293B74213D3D746869732E5F656469746F72732E6D6F6469666965642E6765745363726F6C6C546F7028292626746869732E5F656469746F72732E6D6F6469666965642E7365745363726F6C6C546F7028742C31297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(24255) := '2E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F6D6F6469666965645363726F6C6C546F702E726561642865292D28746869732E5F6D6F6469666965645363726F6C6C4F6666736574416E696D617465642E6765742829';
wwv_flow_imp.g_varchar2_table(24256) := '2D746869732E5F6F726967696E616C5363726F6C6C4F6666736574416E696D617465642E72656164286529292D28746869732E5F6D6F646966696564546F7050616464696E672E67657428292D746869732E5F6F726967696E616C546F7050616464696E';
wwv_flow_imp.g_varchar2_table(24257) := '672E72656164286529293B74213D3D746869732E5F656469746F72732E6F726967696E616C2E6765745363726F6C6C546F7028292626746869732E5F656469746F72732E6F726967696E616C2E7365745363726F6C6C546F7028742C31297D2929292C74';
wwv_flow_imp.g_varchar2_table(24258) := '6869732E5F72656769737465722865492828653D3E7B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6D6F766564546578';
wwv_flow_imp.g_varchar2_table(24259) := '74546F436F6D706172652E726561642865293B6C657420693D303B6966286E297B636F6E737420653D746869732E5F656469746F72732E6F726967696E616C2E676574546F70466F724C696E654E756D626572286E2E6C696E6552616E67654D61707069';
wwv_flow_imp.g_varchar2_table(24260) := '6E672E6F726967696E616C2E73746172744C696E654E756D6265722C2130292D746869732E5F6F726967696E616C546F7050616464696E672E67657428293B693D746869732E5F656469746F72732E6D6F6469666965642E676574546F70466F724C696E';
wwv_flow_imp.g_varchar2_table(24261) := '654E756D626572286E2E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D6265722C2130292D746869732E5F6D6F646966696564546F7050616464696E672E67657428292D657D693E303F28746869732E5F';
wwv_flow_imp.g_varchar2_table(24262) := '6D6F646966696564546F7050616464696E672E73657428302C766F69642030292C746869732E5F6F726967696E616C546F7050616464696E672E73657428692C766F6964203029293A693C303F28746869732E5F6D6F646966696564546F705061646469';
wwv_flow_imp.g_varchar2_table(24263) := '6E672E736574282D692C766F69642030292C746869732E5F6F726967696E616C546F7050616464696E672E73657428302C766F6964203029293A73657454696D656F7574282828293D3E7B746869732E5F6D6F646966696564546F7050616464696E672E';
wwv_flow_imp.g_varchar2_table(24264) := '73657428302C766F69642030292C746869732E5F6F726967696E616C546F7050616464696E672E73657428302C766F69642030297D292C343030292C746869732E5F656469746F72732E6D6F6469666965642E68617354657874466F63757328293F7468';
wwv_flow_imp.g_varchar2_table(24265) := '69732E5F6F726967696E616C5363726F6C6C4F66667365742E73657428746869732E5F6D6F6469666965645363726F6C6C4F66667365742E67657428292D692C766F696420302C2130293A746869732E5F6D6F6469666965645363726F6C6C4F66667365';
wwv_flow_imp.g_varchar2_table(24266) := '742E73657428746869732E5F6F726967696E616C5363726F6C6C4F66667365742E67657428292B692C766F696420302C2130297D2929297D7D3B66756E6374696F6E20735828652C742C6E2C692C6F2C73297B636F6E737420723D6E6577206F75287258';
wwv_flow_imp.g_varchar2_table(24267) := '28652C6929292C613D6E6577206F7528725828742C6F29292C6C3D652E6765744F7074696F6E283637292C633D742E6765744F7074696F6E283637292C643D5B5D3B6C657420683D302C753D303B66756E6374696F6E207028652C74297B666F72283B3B';
wwv_flow_imp.g_varchar2_table(24268) := '297B6C6574206E3D722E7065656B28292C693D612E7065656B28293B6966286E26266E2E6C696E654E756D6265723E3D652626286E3D766F69642030292C692626692E6C696E654E756D6265723E3D74262628693D766F69642030292C216E2626216929';
wwv_flow_imp.g_varchar2_table(24269) := '627265616B3B636F6E7374206F3D6E3F6E2E6C696E654E756D6265722D683A4E756D6265722E4D41585F56414C55452C733D693F692E6C696E654E756D6265722D753A4E756D6265722E4D41585F56414C55453B6F3C733F28722E646571756575652829';
wwv_flow_imp.g_varchar2_table(24270) := '2C693D7B6C696E654E756D6265723A6E2E6C696E654E756D6265722D682B752C686569676874496E50783A307D293A6F3E733F28612E6465717565756528292C6E3D7B6C696E654E756D6265723A692E6C696E654E756D6265722D752B682C6865696768';
wwv_flow_imp.g_varchar2_table(24271) := '74496E50783A307D293A28722E6465717565756528292C612E646571756575652829292C642E70757368287B6F726967696E616C52616E67653A78752E6F664C656E677468286E2E6C696E654E756D6265722C31292C6D6F64696669656452616E67653A';
wwv_flow_imp.g_varchar2_table(24272) := '78752E6F664C656E67746828692E6C696E654E756D6265722C31292C6F726967696E616C486569676874496E50783A6C2B6E2E686569676874496E50782C6D6F646966696564486569676874496E50783A632B692E686569676874496E50782C64696666';
wwv_flow_imp.g_varchar2_table(24273) := '3A766F696420307D297D7D666F7228636F6E73742067206F66206E297B636F6E7374206D3D672E6C696E6552616E67654D617070696E673B70286D2E6F726967696E616C2E73746172744C696E654E756D6265722C6D2E6D6F6469666965642E73746172';
wwv_flow_imp.g_varchar2_table(24274) := '744C696E654E756D626572293B6C657420663D21302C763D6D2E6D6F6469666965642E73746172744C696E654E756D6265722C623D6D2E6F726967696E616C2E73746172744C696E654E756D6265723B66756E6374696F6E205F28652C74297B76617220';
wwv_flow_imp.g_varchar2_table(24275) := '6E2C692C6F2C733B696628653C627C7C743C762972657475726E3B6966286629663D21313B656C736520696628653D3D3D627C7C743D3D3D762972657475726E3B636F6E737420683D6E657720787528622C65292C753D6E657720787528762C74293B69';
wwv_flow_imp.g_varchar2_table(24276) := '6628682E6973456D7074792626752E6973456D7074792972657475726E3B636F6E737420703D6E756C6C213D3D28693D6E756C6C3D3D3D286E3D722E74616B655768696C652828743D3E742E6C696E654E756D6265723C652929297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(24277) := '3D3D6E3F766F696420303A6E2E726564756365282828652C74293D3E652B742E686569676874496E5078292C3029292626766F69642030213D3D693F693A302C6D3D6E756C6C213D3D28733D6E756C6C3D3D3D286F3D612E74616B655768696C65282865';
wwv_flow_imp.g_varchar2_table(24278) := '3D3E652E6C696E654E756D6265723C742929297C7C766F696420303D3D3D6F3F766F696420303A6F2E726564756365282828652C74293D3E652B742E686569676874496E5078292C3029292626766F69642030213D3D733F733A303B642E70757368287B';
wwv_flow_imp.g_varchar2_table(24279) := '6F726967696E616C52616E67653A682C6D6F64696669656452616E67653A752C6F726967696E616C486569676874496E50783A682E6C656E6774682A6C2B702C6D6F646966696564486569676874496E50783A752E6C656E6774682A632B6D2C64696666';
wwv_flow_imp.g_varchar2_table(24280) := '3A672E6C696E6552616E67654D617070696E677D292C623D652C763D747D6966287329666F7228636F6E73742079206F66206D2E696E6E65724368616E6765737C7C5B5D297B792E6F726967696E616C52616E67652E7374617274436F6C756D6E3E3126';
wwv_flow_imp.g_varchar2_table(24281) := '26792E6D6F64696669656452616E67652E7374617274436F6C756D6E3E3126265F28792E6F726967696E616C52616E67652E73746172744C696E654E756D6265722C792E6D6F64696669656452616E67652E73746172744C696E654E756D626572293B63';
wwv_flow_imp.g_varchar2_table(24282) := '6F6E737420773D652E6765744D6F64656C28292C433D792E6F726967696E616C52616E67652E656E644C696E654E756D6265723C3D772E6765744C696E65436F756E7428293F772E6765744C696E654D6178436F6C756D6E28792E6F726967696E616C52';
wwv_flow_imp.g_varchar2_table(24283) := '616E67652E656E644C696E654E756D626572293A4E756D6265722E4D41585F534146455F494E54454745523B792E6F726967696E616C52616E67652E656E64436F6C756D6E3C4326265F28792E6F726967696E616C52616E67652E656E644C696E654E75';
wwv_flow_imp.g_varchar2_table(24284) := '6D6265722C792E6D6F64696669656452616E67652E656E644C696E654E756D626572297D5F286D2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C6D2E6D6F6469666965642E656E644C696E654E756D6265724578636C';
wwv_flow_imp.g_varchar2_table(24285) := '7573697665292C683D6D2E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652C753D6D2E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976657D72657475726E2070284E756D6265722E4D41585F56';
wwv_flow_imp.g_varchar2_table(24286) := '414C55452C4E756D6265722E4D41585F56414C5545292C647D66756E6374696F6E20725828652C74297B636F6E7374206E3D5B5D2C693D5B5D2C6F3D2D31213D3D652E6765744F7074696F6E28313436292E7772617070696E67436F6C756D6E2C733D65';
wwv_flow_imp.g_varchar2_table(24287) := '2E5F676574566965774D6F64656C28292E636F6F7264696E61746573436F6E7665727465722C723D652E6765744F7074696F6E283637293B6966286F29666F72286C657420743D313B743C3D652E6765744D6F64656C28292E6765744C696E65436F756E';
wwv_flow_imp.g_varchar2_table(24288) := '7428293B742B2B297B636F6E737420653D732E6765744D6F64656C4C696E65566965774C696E65436F756E742874293B653E312626692E70757368287B6C696E654E756D6265723A742C686569676874496E50783A722A28652D31297D297D666F722863';
wwv_flow_imp.g_varchar2_table(24289) := '6F6E73742069206F6620652E67657457686974657370616365732829297B696628742E68617328692E69642929636F6E74696E75653B636F6E737420653D303D3D3D692E61667465724C696E654E756D6265723F303A732E636F6E766572745669657750';
wwv_flow_imp.g_varchar2_table(24290) := '6F736974696F6E546F4D6F64656C506F736974696F6E286E6577206D6328692E61667465724C696E654E756D6265722C3129292E6C696E654E756D6265723B6E2E70757368287B6C696E654E756D6265723A652C686569676874496E50783A692E686569';
wwv_flow_imp.g_varchar2_table(24291) := '6768747D297D72657475726E2066756E6374696F6E28652C742C6E297B696628303D3D3D652E6C656E6774682972657475726E20743B696628303D3D3D742E6C656E6774682972657475726E20653B636F6E737420693D5B5D3B6C6574206F3D302C733D';
wwv_flow_imp.g_varchar2_table(24292) := '303B666F72283B6F3C652E6C656E6774682626733C742E6C656E6774683B297B636F6E7374206C3D655B6F5D2C633D745B735D2C643D6E286C292C683D6E2863293B643C683F28692E70757368286C292C6F2B2B293A643E683F28692E70757368286329';
wwv_flow_imp.g_varchar2_table(24293) := '2C732B2B293A28692E707573682828613D632C7B6C696E654E756D6265723A28723D6C292E6C696E654E756D6265722C686569676874496E50783A722E686569676874496E50782B612E686569676874496E50787D29292C6F2B2B2C732B2B297D666F72';
wwv_flow_imp.g_varchar2_table(24294) := '2876617220722C613B6F3C652E6C656E6774683B29692E7075736828655B6F5D292C6F2B2B3B666F72283B733C742E6C656E6774683B29692E7075736828745B735D292C732B2B3B72657475726E20697D286E2C692C28653D3E652E6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(24295) := '657229297D6F583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F';
wwv_flow_imp.g_varchar2_table(24296) := '7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(24297) := '293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626722626';
wwv_flow_imp.g_varchar2_table(24298) := '4F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B695828382C7945292C695828392C7145295D2C6F58293B636C61737320615820657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B7375706572';
wwv_flow_imp.g_varchar2_table(24299) := '28292C746869732E5F656469746F723D652C746869732E5F646F6D4E6F64653D742C746869732E6974656D50726F76696465723D6E2C746869732E7363726F6C6C546F703D614928746869732E5F656469746F722E6F6E4469645363726F6C6C4368616E';
wwv_flow_imp.g_varchar2_table(24300) := '67652C28653D3E746869732E5F656469746F722E6765745363726F6C6C546F70282929292C746869732E69735363726F6C6C546F705A65726F3D746869732E7363726F6C6C546F702E6D61702828653D3E303D3D3D6529292C746869732E6D6F64656C41';
wwv_flow_imp.g_varchar2_table(24301) := '747461636865643D614928746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C2C28653D3E746869732E5F656469746F722E6861734D6F64656C282929292C746869732E656469746F724F6E4469644368616E6765566965775A6F6E';
wwv_flow_imp.g_varchar2_table(24302) := '65733D634928226F6E4469644368616E6765566965775A6F6E6573222C746869732E5F656469746F722E6F6E4469644368616E6765566965775A6F6E6573292C746869732E656469746F724F6E446964436F6E74656E7453697A654368616E67653D6349';
wwv_flow_imp.g_varchar2_table(24303) := '28226F6E446964436F6E74656E7453697A654368616E6765222C746869732E5F656469746F722E6F6E446964436F6E74656E7453697A654368616E6765292C746869732E646F6D4E6F646553697A654368616E6765643D68492822646F6D4E6F64655369';
wwv_flow_imp.g_varchar2_table(24304) := '7A654368616E67656422292C746869732E76696577733D6E6577204D61702C746869732E5F646F6D4E6F64652E636C6173734E616D653D22677574746572206D6F6E61636F2D656469746F72223B636F6E737420693D746869732E5F646F6D4E6F64652E';
wwv_flow_imp.g_varchar2_table(24305) := '617070656E644368696C6428497228226469762E7363726F6C6C2D6465636F726174696F6E222C7B726F6C653A2270726573656E746174696F6E222C6172696148696464656E3A2274727565222C7374796C653A7B77696474683A2231303025227D7D29';
wwv_flow_imp.g_varchar2_table(24306) := '2E726F6F74292C6F3D6E657720526573697A654F62736572766572282828293D3E7B48542828653D3E7B746869732E646F6D4E6F646553697A654368616E6765642E747269676765722865297D29297D29293B6F2E6F62736572766528746869732E5F64';
wwv_flow_imp.g_varchar2_table(24307) := '6F6D4E6F6465292C746869732E5F7265676973746572287274282828293D3E6F2E646973636F6E6E65637428292929292C746869732E5F72656769737465722865492828653D3E7B692E636C6173734E616D653D746869732E69735363726F6C6C546F70';
wwv_flow_imp.g_varchar2_table(24308) := '5A65726F2E726561642865293F22223A227363726F6C6C2D6465636F726174696F6E227D2929292C746869732E5F72656769737465722865492828653D3E746869732E72656E6465722865292929297D646973706F736528297B73757065722E64697370';
wwv_flow_imp.g_varchar2_table(24309) := '6F736528292C677228746869732E5F646F6D4E6F6465297D72656E6465722865297B69662821746869732E6D6F64656C41747461636865642E726561642865292972657475726E3B746869732E646F6D4E6F646553697A654368616E6765642E72656164';
wwv_flow_imp.g_varchar2_table(24310) := '2865292C746869732E656469746F724F6E4469644368616E6765566965775A6F6E65732E726561642865292C746869732E656469746F724F6E446964436F6E74656E7453697A654368616E67652E726561642865293B636F6E737420743D746869732E73';
wwv_flow_imp.g_varchar2_table(24311) := '63726F6C6C546F702E726561642865292C6E3D746869732E5F656469746F722E67657456697369626C6552616E67657328292C693D6E65772053657428746869732E76696577732E6B6579732829292C6F3D6D752E6F665374617274416E644C656E6774';
wwv_flow_imp.g_varchar2_table(24312) := '6828302C746869732E5F646F6D4E6F64652E636C69656E74486569676874293B696628216F2E6973456D70747929666F7228636F6E73742073206F66206E297B636F6E7374206E3D6E657720787528732E73746172744C696E654E756D6265722C732E65';
wwv_flow_imp.g_varchar2_table(24313) := '6E644C696E654E756D6265722B31292C723D746869732E6974656D50726F76696465722E676574496E74657273656374696E674775747465724974656D73286E2C65293B48542828653D3E7B666F7228636F6E73742073206F662072297B69662821732E';
wwv_flow_imp.g_varchar2_table(24314) := '72616E67652E696E74657273656374286E2929636F6E74696E75653B692E64656C65746528732E6964293B6C657420723D746869732E76696577732E67657428732E6964293B6966287229722E6974656D2E73657428732C65293B656C73657B636F6E73';
wwv_flow_imp.g_varchar2_table(24315) := '7420653D646F63756D656E742E637265617465456C656D656E74282264697622293B746869732E5F646F6D4E6F64652E617070656E644368696C642865293B636F6E737420743D245428226974656D222C73292C6E3D746869732E6974656D50726F7669';
wwv_flow_imp.g_varchar2_table(24316) := '6465722E6372656174655669657728742C65293B723D6E6577206C5828742C6E2C65292C746869732E76696577732E73657428732E69642C72297D636F6E737420613D732E72616E67652E73746172744C696E654E756D6265723C3D746869732E5F6564';
wwv_flow_imp.g_varchar2_table(24317) := '69746F722E6765744D6F64656C28292E6765744C696E65436F756E7428293F746869732E5F656469746F722E676574546F70466F724C696E654E756D62657228732E72616E67652E73746172744C696E654E756D6265722C2130292D743A746869732E5F';
wwv_flow_imp.g_varchar2_table(24318) := '656469746F722E676574426F74746F6D466F724C696E654E756D62657228732E72616E67652E73746172744C696E654E756D6265722D312C2131292D742C6C3D28732E72616E67652E6973456D7074793F613A746869732E5F656469746F722E67657442';
wwv_flow_imp.g_varchar2_table(24319) := '6F74746F6D466F724C696E654E756D62657228732E72616E67652E656E644C696E654E756D6265724578636C75736976652D312C2130292D74292D613B722E646F6D4E6F64652E7374796C652E746F703D60247B617D7078602C722E646F6D4E6F64652E';
wwv_flow_imp.g_varchar2_table(24320) := '7374796C652E6865696768743D60247B6C7D7078602C722E6775747465724974656D566965772E6C61796F7574286D752E6F665374617274416E644C656E67746828612C6C292C6F297D7D29297D666F7228636F6E73742065206F662069297B636F6E73';
wwv_flow_imp.g_varchar2_table(24321) := '7420743D746869732E76696577732E6765742865293B742E6775747465724974656D566965772E646973706F736528292C746869732E5F646F6D4E6F64652E72656D6F76654368696C6428742E646F6D4E6F6465292C746869732E76696577732E64656C';
wwv_flow_imp.g_varchar2_table(24322) := '6574652865297D7D7D636C617373206C587B636F6E7374727563746F7228652C742C6E297B746869732E6974656D3D652C746869732E6775747465724974656D566965773D742C746869732E646F6D4E6F64653D6E7D7D636C6173732063582065787465';
wwv_flow_imp.g_varchar2_table(24323) := '6E6473205F637B636F6E7374727563746F722865297B737570657228292C746869732E5F676574436F6E746578743D657D72756E416374696F6E28652C74297B636F6E7374206E3D746869732E5F676574436F6E7465787428293B72657475726E207375';
wwv_flow_imp.g_varchar2_table(24324) := '7065722E72756E416374696F6E28652C6E297D7D636C61737320645820657874656E647320477A7B636F6E7374727563746F722865297B737570657228292C746869732E5F746578744D6F64656C3D657D67657456616C75654F6652616E67652865297B';
wwv_flow_imp.g_varchar2_table(24325) := '72657475726E20746869732E5F746578744D6F64656C2E67657456616C7565496E52616E67652865297D676574206C656E67746828297B636F6E737420653D746869732E5F746578744D6F64656C2E6765744C696E65436F756E7428292C743D74686973';
wwv_flow_imp.g_varchar2_table(24326) := '2E5F746578744D6F64656C2E6765744C696E654C656E6774682865293B72657475726E206E6577206D6728652D312C74297D7D7661722068583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(24327) := '2C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D';
wwv_flow_imp.g_varchar2_table(24328) := '747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D';
wwv_flow_imp.g_varchar2_table(24329) := '28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C75583D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(24330) := '657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742070583D5B5D3B6C65742067583D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B76617220722C613B';
wwv_flow_imp.g_varchar2_table(24331) := '737570657228292C746869732E5F646966664D6F64656C3D742C746869732E5F656469746F72733D6E2C746869732E5F696E7374616E74696174696F6E536572766963653D692C746869732E5F636F6E746578744B6579536572766963653D6F2C746869';
wwv_flow_imp.g_varchar2_table(24332) := '732E5F6D656E75536572766963653D732C746869732E5F6D656E753D746869732E5F726567697374657228746869732E5F6D656E75536572766963652E6372656174654D656E75284C642E44696666456469746F7248756E6B546F6F6C6261722C746869';
wwv_flow_imp.g_varchar2_table(24333) := '732E5F636F6E746578744B65795365727669636529292C746869732E5F616374696F6E733D614928746869732E5F6D656E752E6F6E4469644368616E67652C2828293D3E746869732E5F6D656E752E676574416374696F6E73282929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(24334) := '686173416374696F6E733D746869732E5F616374696F6E732E6D61702828653D3E652E6C656E6774683E3029292C746869732E77696474683D515428746869732C28653D3E746869732E5F686173416374696F6E732E726561642865293F33353A302929';
wwv_flow_imp.g_varchar2_table(24335) := '2C746869732E656C656D656E74733D497228226469762E67757474657240677574746572222C7B7374796C653A7B706F736974696F6E3A226162736F6C757465222C6865696768743A2231303025222C77696474683A2233357078227D7D2C5B5D292C74';
wwv_flow_imp.g_varchar2_table(24336) := '6869732E5F63757272656E74446966663D515428746869732C28653D3E7B76617220743B636F6E7374206E3D746869732E5F646966664D6F64656C2E726561642865293B696628216E2972657475726E3B636F6E737420693D6E756C6C3D3D3D28743D6E';
wwv_flow_imp.g_varchar2_table(24337) := '2E646966662E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6D617070696E67732C6F3D746869732E5F656469746F72732E6D6F646966696564437572736F722E726561642865293B72657475726E206F3F6E756C6C3D3D69';
wwv_flow_imp.g_varchar2_table(24338) := '3F766F696420303A692E66696E642828653D3E652E6C696E6552616E67654D617070696E672E6D6F6469666965642E636F6E7461696E73286F2E6C696E654E756D6265722929293A766F696420307D29292C746869732E5F73656C656374656444696666';
wwv_flow_imp.g_varchar2_table(24339) := '733D515428746869732C28653D3E7B636F6E737420743D746869732E5F646966664D6F64656C2E726561642865292C6E3D6E756C6C3D3D743F766F696420303A742E646966662E726561642865293B696628216E2972657475726E2070583B636F6E7374';
wwv_flow_imp.g_varchar2_table(24340) := '20693D746869732E5F656469746F72732E6D6F64696669656453656C656374696F6E732E726561642865293B696628692E65766572792828653D3E652E6973456D707479282929292972657475726E2070583B636F6E7374206F3D6E6577206B7528692E';
wwv_flow_imp.g_varchar2_table(24341) := '6D61702828653D3E78752E66726F6D52616E6765496E636C75736976652865292929292C733D6E2E6D617070696E67732E66696C7465722828653D3E652E6C696E6552616E67654D617070696E672E696E6E65724368616E67657326266F2E696E746572';
wwv_flow_imp.g_varchar2_table(24342) := '736563747328652E6C696E6552616E67654D617070696E672E6D6F6469666965642929292E6D61702828653D3E287B6D617070696E673A652C72616E67654D617070696E67733A652E6C696E6552616E67654D617070696E672E696E6E65724368616E67';
wwv_flow_imp.g_varchar2_table(24343) := '65732E66696C7465722828653D3E692E736F6D652828743D3E72682E617265496E74657273656374696E6728652E6D6F64696669656452616E67652C7429292929297D2929293B72657475726E20303D3D3D732E6C656E6774687C7C732E657665727928';
wwv_flow_imp.g_varchar2_table(24344) := '28653D3E303D3D3D652E72616E67654D617070696E67732E6C656E67746829293F70583A737D29292C746869732E5F72656769737465722828723D652C613D746869732E656C656D656E74732E726F6F742C722E70726570656E642861292C7274282828';
wwv_flow_imp.g_varchar2_table(24345) := '293D3E7B722E72656D6F76654368696C642861297D292929292C746869732E5F726567697374657228627328746869732E656C656D656E74732E726F6F742C22636C69636B222C2828293D3E7B746869732E5F656469746F72732E6D6F6469666965642E';
wwv_flow_imp.g_varchar2_table(24346) := '666F63757328297D2929292C746869732E5F726567697374657228515928746869732E656C656D656E74732E726F6F742C7B646973706C61793A746869732E5F686173416374696F6E732E6D61702828653D3E653F22626C6F636B223A226E6F6E652229';
wwv_flow_imp.g_varchar2_table(24347) := '297D29292C746869732E5F7265676973746572286E657720615828746869732E5F656469746F72732E6D6F6469666965642C746869732E656C656D656E74732E726F6F742C7B676574496E74657273656374696E674775747465724974656D733A28652C';
wwv_flow_imp.g_varchar2_table(24348) := '74293D3E7B636F6E7374206E3D746869732E5F646966664D6F64656C2E726561642874293B696628216E2972657475726E5B5D3B636F6E737420693D6E2E646966662E726561642874293B69662821692972657475726E5B5D3B636F6E7374206F3D7468';
wwv_flow_imp.g_varchar2_table(24349) := '69732E5F73656C656374656444696666732E726561642874293B6966286F2E6C656E6774683E30297B636F6E737420653D5A7A2E66726F6D52616E67654D617070696E6773286F2E666C61744D61702828653D3E652E72616E67654D617070696E677329';
wwv_flow_imp.g_varchar2_table(24350) := '29293B72657475726E5B6E6577206D5828652C21302C4C642E44696666456469746F7253656C656374696F6E546F6F6C6261722C766F696420302C6E2E6D6F64656C2E6F726967696E616C2E7572692C6E2E6D6F64656C2E6D6F6469666965642E757269';
wwv_flow_imp.g_varchar2_table(24351) := '295D7D636F6E737420733D746869732E5F63757272656E74446966662E726561642874293B72657475726E20692E6D617070696E67732E6D61702828653D3E6E6577206D5828652E6C696E6552616E67654D617070696E672E77697468496E6E65724368';
wwv_flow_imp.g_varchar2_table(24352) := '616E67657346726F6D4C696E6552616E67657328292C652E6C696E6552616E67654D617070696E673D3D3D286E756C6C3D3D733F766F696420303A732E6C696E6552616E67654D617070696E67292C4C642E44696666456469746F7248756E6B546F6F6C';
wwv_flow_imp.g_varchar2_table(24353) := '6261722C766F696420302C6E2E6D6F64656C2E6F726967696E616C2E7572692C6E2E6D6F64656C2E6D6F6469666965642E7572692929297D2C637265617465566965773A28652C74293D3E746869732E5F696E7374616E74696174696F6E536572766963';
wwv_flow_imp.g_varchar2_table(24354) := '652E637265617465496E7374616E63652866582C652C742C74686973297D29292C746869732E5F726567697374657228627328746869732E656C656D656E74732E6775747465722C61722E4D4F5553455F574845454C2C28653D3E7B746869732E5F6564';
wwv_flow_imp.g_varchar2_table(24355) := '69746F72732E6D6F6469666965642E6765744F7074696F6E28313033292E68616E646C654D6F757365576865656C2626746869732E5F656469746F72732E6D6F6469666965642E64656C65676174655363726F6C6C46726F6D4D6F757365576865656C45';
wwv_flow_imp.g_varchar2_table(24356) := '76656E742865297D292C7B706173736976653A21317D29297D636F6D7075746553746167656456616C75652865297B76617220743B636F6E7374206E3D6E756C6C213D3D28743D652E696E6E65724368616E676573292626766F69642030213D3D743F74';
wwv_flow_imp.g_varchar2_table(24357) := '3A5B5D2C693D6E657720645828746869732E5F656469746F72732E6D6F6469666965644D6F64656C2E6765742829292C6F3D6E657720645828746869732E5F656469746F72732E6F726967696E616C2E6765744D6F64656C2829292C733D6E657720247A';
wwv_flow_imp.g_varchar2_table(24358) := '286E2E6D61702828653D3E652E746F54657874456469742869292929293B72657475726E20732E6170706C79286F297D6C61796F75742865297B746869732E656C656D656E74732E6775747465722E7374796C652E6C6566743D652B227078227D7D3B67';
wwv_flow_imp.g_varchar2_table(24359) := '583D6858285B755828332C7563292C755828342C6364292C755828352C4464295D2C6758293B636C617373206D587B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E6D617070696E673D652C746869732E73686F77416C7761';
wwv_flow_imp.g_varchar2_table(24360) := '79733D742C746869732E6D656E7549643D6E2C746869732E72616E67654F766572726964653D692C746869732E6F726967696E616C5572693D6F2C746869732E6D6F6469666965645572693D737D67657420696428297B72657475726E20746869732E6D';
wwv_flow_imp.g_varchar2_table(24361) := '617070696E672E6D6F6469666965642E746F537472696E6728297D6765742072616E676528297B76617220653B72657475726E206E756C6C213D3D28653D746869732E72616E67654F76657272696465292626766F69642030213D3D653F653A74686973';
wwv_flow_imp.g_varchar2_table(24362) := '2E6D617070696E672E6D6F6469666965647D7D6C65742066583D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F6974656D3D652C746869732E5F656C656D656E74733D';
wwv_flow_imp.g_varchar2_table(24363) := '497228226469762E6775747465724974656D222C7B7374796C653A7B6865696768743A2232307078222C77696474683A2233347078227D7D2C5B497228226469762E6261636B67726F756E64406261636B67726F756E64222C7B7D2C5B5D292C49722822';
wwv_flow_imp.g_varchar2_table(24364) := '6469762E627574746F6E7340627574746F6E73222C7B7D2C5B5D295D292C746869732E5F73686F77416C776179733D746869732E5F6974656D2E6D617028746869732C28653D3E652E73686F77416C7761797329292C746869732E5F6D656E7549643D74';
wwv_flow_imp.g_varchar2_table(24365) := '6869732E5F6974656D2E6D617028746869732C28653D3E652E6D656E75496429292C746869732E5F6973536D616C6C3D245428746869732C2131292C746869732E5F6C6173744974656D52616E67653D766F696420302C746869732E5F6C617374566965';
wwv_flow_imp.g_varchar2_table(24366) := '7752616E67653D766F696420303B636F6E7374206F3D746869732E5F726567697374657228692E637265617465496E7374616E6365284D712C22656C656D656E74222C21302C7B706F736974696F6E3A7B686F766572506F736974696F6E3A317D7D2929';
wwv_flow_imp.g_varchar2_table(24367) := '3B746869732E5F7265676973746572286A5928742C746869732E5F656C656D656E74732E726F6F7429292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F73686F77416C776179732E726561642865293B74';
wwv_flow_imp.g_varchar2_table(24368) := '6869732E5F656C656D656E74732E726F6F742E636C6173734C6973742E746F67676C6528226E6F5472616E736974696F6E222C2130292C746869732E5F656C656D656E74732E726F6F742E636C6173734C6973742E746F67676C65282273686F77416C77';
wwv_flow_imp.g_varchar2_table(24369) := '617973222C74292C73657454696D656F7574282828293D3E7B746869732E5F656C656D656E74732E726F6F742E636C6173734C6973742E746F67676C6528226E6F5472616E736974696F6E222C2131297D292C30297D2929292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(24370) := '73746572286949282828652C74293D3E7B746869732E5F656C656D656E74732E627574746F6E732E7265706C6163654368696C6472656E28293B636F6E737420733D742E61646428692E637265617465496E7374616E636528576A2C746869732E5F656C';
wwv_flow_imp.g_varchar2_table(24371) := '656D656E74732E627574746F6E732C746869732E5F6D656E7549642E726561642865292C7B6F7269656E746174696F6E3A312C686F76657244656C65676174653A6F2C746F6F6C6261724F7074696F6E733A7B7072696D61727947726F75703A653D3E65';
wwv_flow_imp.g_varchar2_table(24372) := '2E7374617274735769746828227072696D61727922297D2C6F766572666C6F774265686176696F723A7B6D61784974656D733A746869732E5F6973536D616C6C2E726561642865293F313A337D2C68696464656E4974656D53747261746567793A302C61';
wwv_flow_imp.g_varchar2_table(24373) := '6374696F6E52756E6E65723A6E6577206358282828293D3E7B636F6E737420653D746869732E5F6974656D2E67657428292C743D652E6D617070696E673B72657475726E7B6D617070696E673A742C6F726967696E616C576974684D6F64696669656443';
wwv_flow_imp.g_varchar2_table(24374) := '68616E6765733A6E2E636F6D7075746553746167656456616C75652874292C6F726967696E616C5572693A652E6F726967696E616C5572692C6D6F6469666965645572693A652E6D6F6469666965645572697D7D29292C6D656E754F7074696F6E733A7B';
wwv_flow_imp.g_varchar2_table(24375) := '73686F756C64466F7277617264417267733A21307D7D29293B742E61646428732E6F6E4469644368616E67654D656E754974656D73282828293D3E7B746869732E5F6C6173744974656D52616E67652626746869732E6C61796F757428746869732E5F6C';
wwv_flow_imp.g_varchar2_table(24376) := '6173744974656D52616E67652C746869732E5F6C6173745669657752616E6765297D2929297D2929297D6C61796F757428652C74297B746869732E5F6C6173744974656D52616E67653D652C746869732E5F6C6173745669657752616E67653D743B6C65';
wwv_flow_imp.g_varchar2_table(24377) := '74206E3D746869732E5F656C656D656E74732E627574746F6E732E636C69656E744865696768743B746869732E5F6973536D616C6C2E73657428313D3D3D746869732E5F6974656D2E67657428292E6D617070696E672E6F726967696E616C2E73746172';
wwv_flow_imp.g_varchar2_table(24378) := '744C696E654E756D6265722626652E6C656E6774683C33302C766F69642030292C6E3D746869732E5F656C656D656E74732E627574746F6E732E636C69656E744865696768742C746869732E5F656C656D656E74732E726F6F742E7374796C652E746F70';
wwv_flow_imp.g_varchar2_table(24379) := '3D652E73746172742B227078222C746869732E5F656C656D656E74732E726F6F742E7374796C652E6865696768743D652E6C656E6774682B227078223B636F6E737420693D652E6C656E6774682F322D6E2F322C6F3D6E3B6C657420733D652E73746172';
wwv_flow_imp.g_varchar2_table(24380) := '742B693B636F6E737420723D6D752E747279437265617465286F2C742E656E644578636C75736976652D6F2D6E292C613D6D752E74727943726561746528652E73746172742B6F2C652E656E644578636C75736976652D6E2D6F293B612626722626612E';
wwv_flow_imp.g_varchar2_table(24381) := '73746172743C612E656E644578636C7573697665262628733D722E636C69702873292C733D612E636C6970287329292C746869732E5F656C656D656E74732E627574746F6E732E7374796C652E746F703D732D652E73746172742B227078227D7D3B6658';
wwv_flow_imp.g_varchar2_table(24382) := '3D6858285B755828332C7563295D2C6658293B7661722076583B6C65742062583D76583D636C61737320657874656E6473206C747B7374617469632073657442726561646372756D6273536F75726365466163746F72792865297B746869732E5F627265';
wwv_flow_imp.g_varchar2_table(24383) := '61646372756D6273536F75726365466163746F72792E73657428652C766F69642030297D6765742069735570646174696E6748696464656E417265617328297B72657475726E20746869732E5F69735570646174696E6748696464656E41726561737D63';
wwv_flow_imp.g_varchar2_table(24384) := '6F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F656469746F72733D652C746869732E5F646966664D6F64656C3D742C746869732E5F6F7074696F6E733D6E2C746869732E5F696E7374616E74696174696F6E536572';
wwv_flow_imp.g_varchar2_table(24385) := '766963653D692C746869732E5F6D6F6469666965644F75746C696E65536F757263653D585428746869732C28653D3E7B636F6E737420743D746869732E5F656469746F72732E6D6F6469666965644D6F64656C2E726561642865292C6E3D76582E5F6272';
wwv_flow_imp.g_varchar2_table(24386) := '6561646372756D6273536F75726365466163746F72792E726561642865293B72657475726E207426266E3F6E28742C746869732E5F696E7374616E74696174696F6E53657276696365293A766F696420307D29292C746869732E5F69735570646174696E';
wwv_flow_imp.g_varchar2_table(24387) := '6748696464656E41726561733D21312C746869732E5F726567697374657228746869732E5F656469746F72732E6F726967696E616C2E6F6E4469644368616E6765437572736F72506F736974696F6E2828653D3E7B696628313D3D3D652E726561736F6E';
wwv_flow_imp.g_varchar2_table(24388) := '2972657475726E3B636F6E737420743D746869732E5F646966664D6F64656C2E67657428293B48542828653D3E7B666F7228636F6E7374206E206F6620746869732E5F656469746F72732E6F726967696E616C2E67657453656C656374696F6E7328297C';
wwv_flow_imp.g_varchar2_table(24389) := '7C5B5D296E756C6C3D3D747C7C742E656E737572654F726967696E616C4C696E65497356697369626C65286E2E6765745374617274506F736974696F6E28292E6C696E654E756D6265722C302C65292C6E756C6C3D3D747C7C742E656E737572654F7269';
wwv_flow_imp.g_varchar2_table(24390) := '67696E616C4C696E65497356697369626C65286E2E676574456E64506F736974696F6E28292E6C696E654E756D6265722C302C65297D29297D2929292C746869732E5F726567697374657228746869732E5F656469746F72732E6D6F6469666965642E6F';
wwv_flow_imp.g_varchar2_table(24391) := '6E4469644368616E6765437572736F72506F736974696F6E2828653D3E7B696628313D3D3D652E726561736F6E2972657475726E3B636F6E737420743D746869732E5F646966664D6F64656C2E67657428293B48542828653D3E7B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(24392) := '206E206F6620746869732E5F656469746F72732E6D6F6469666965642E67657453656C656374696F6E7328297C7C5B5D296E756C6C3D3D747C7C742E656E737572654D6F6469666965644C696E65497356697369626C65286E2E6765745374617274506F';
wwv_flow_imp.g_varchar2_table(24393) := '736974696F6E28292E6C696E654E756D6265722C302C65292C6E756C6C3D3D747C7C742E656E737572654D6F6469666965644C696E65497356697369626C65286E2E676574456E64506F736974696F6E28292E6C696E654E756D6265722C302C65297D29';
wwv_flow_imp.g_varchar2_table(24394) := '297D2929293B636F6E7374206F3D746869732E5F646966664D6F64656C2E6D6170282828652C74293D3E7B766172206E2C693B636F6E7374206F3D6E756C6C213D3D286E3D6E756C6C3D3D653F766F696420303A652E756E6368616E676564526567696F';
wwv_flow_imp.g_varchar2_table(24395) := '6E732E72656164287429292626766F69642030213D3D6E3F6E3A5B5D3B72657475726E20313D3D3D6F2E6C656E6774682626313D3D3D6F5B305D2E6D6F6469666965644C696E654E756D62657226266F5B305D2E6C696E65436F756E743D3D3D286E756C';
wwv_flow_imp.g_varchar2_table(24396) := '6C3D3D3D28693D746869732E5F656469746F72732E6D6F6469666965644D6F64656C2E72656164287429297C7C766F696420303D3D3D693F766F696420303A692E6765744C696E65436F756E742829293F5B5D3A6F7D29293B746869732E766965775A6F';
wwv_flow_imp.g_varchar2_table(24397) := '6E65733D5A5428746869732C2828652C74293D3E7B636F6E7374206E3D746869732E5F6D6F6469666965644F75746C696E65536F757263652E726561642865293B696628216E2972657475726E7B6F726967566965775A6F6E65733A5B5D2C6D6F645669';
wwv_flow_imp.g_varchar2_table(24398) := '65775A6F6E65733A5B5D7D3B636F6E737420693D5B5D2C733D5B5D2C723D746869732E5F6F7074696F6E732E72656E646572536964654279536964652E726561642865292C613D6F2E726561642865293B666F7228636F6E7374206F206F662061296966';
wwv_flow_imp.g_varchar2_table(24399) := '28216F2E73686F756C6448696465436F6E74726F6C73286529297B7B636F6E737420653D515428746869732C28653D3E6F2E67657448696464656E4F726967696E616C52616E67652865292E73746172744C696E654E756D6265722D3129292C733D6E65';
wwv_flow_imp.g_varchar2_table(24400) := '77204B5928652C3234293B692E707573682873292C742E616464286E6577205F5828746869732E5F656469746F72732E6F726967696E616C2C732C6F2C6F2E6F726967696E616C556E6368616E67656452616E67652C21722C6E2C28653D3E746869732E';
wwv_flow_imp.g_varchar2_table(24401) := '5F646966664D6F64656C2E67657428292E656E737572654D6F6469666965644C696E65497356697369626C6528652C322C766F6964203029292C746869732E5F6F7074696F6E7329297D7B636F6E737420653D515428746869732C28653D3E6F2E676574';
wwv_flow_imp.g_varchar2_table(24402) := '48696464656E4D6F64696669656452616E67652865292E73746172744C696E654E756D6265722D3129292C693D6E6577204B5928652C3234293B732E707573682869292C742E616464286E6577205F5828746869732E5F656469746F72732E6D6F646966';
wwv_flow_imp.g_varchar2_table(24403) := '6965642C692C6F2C6F2E6D6F646966696564556E6368616E67656452616E67652C21312C6E2C28653D3E746869732E5F646966664D6F64656C2E67657428292E656E737572654D6F6469666965644C696E65497356697369626C6528652C322C766F6964';
wwv_flow_imp.g_varchar2_table(24404) := '203029292C746869732E5F6F7074696F6E7329297D7D72657475726E7B6F726967566965775A6F6E65733A692C6D6F64566965775A6F6E65733A737D7D29293B636F6E737420733D7B6465736372697074696F6E3A22756E6368616E676564206C696E65';
wwv_flow_imp.g_varchar2_table(24405) := '73222C636C6173734E616D653A22646966662D756E6368616E6765642D6C696E6573222C697357686F6C654C696E653A21307D2C723D7B6465736372697074696F6E3A22466F6C6420556E6368616E676564222C676C7970684D617267696E486F766572';
wwv_flow_imp.g_varchar2_table(24406) := '4D6573736167653A6E6577206F6328766F696420302C7B6973547275737465643A21302C737570706F72745468656D6549636F6E733A21307D292E617070656E644D61726B646F776E286228302C22466F6C6420556E6368616E67656420526567696F6E';
wwv_flow_imp.g_varchar2_table(24407) := '2229292C676C7970684D617267696E436C6173734E616D653A22666F6C642D756E6368616E67656420222B546C2E6173436C6173734E616D65284C6C2E666F6C64292C7A496E6465783A31303030317D3B746869732E5F72656769737465722857592874';
wwv_flow_imp.g_varchar2_table(24408) := '6869732E5F656469746F72732E6F726967696E616C2C515428746869732C28653D3E7B636F6E737420743D6F2E726561642865292C6E3D742E6D61702828653D3E287B72616E67653A652E6F726967696E616C556E6368616E67656452616E67652E746F';
wwv_flow_imp.g_varchar2_table(24409) := '496E636C757369766552616E676528292C6F7074696F6E733A737D2929293B666F7228636F6E73742069206F66207429692E73686F756C6448696465436F6E74726F6C7328652926266E2E70757368287B72616E67653A72682E66726F6D506F73697469';
wwv_flow_imp.g_varchar2_table(24410) := '6F6E73286E6577206D6328692E6F726967696E616C4C696E654E756D6265722C3129292C6F7074696F6E733A727D293B72657475726E206E7D292929292C746869732E5F726567697374657228575928746869732E5F656469746F72732E6D6F64696669';
wwv_flow_imp.g_varchar2_table(24411) := '65642C515428746869732C28653D3E7B636F6E737420743D6F2E726561642865292C6E3D742E6D61702828653D3E287B72616E67653A652E6D6F646966696564556E6368616E67656452616E67652E746F496E636C757369766552616E676528292C6F70';
wwv_flow_imp.g_varchar2_table(24412) := '74696F6E733A737D2929293B666F7228636F6E73742069206F66207429692E73686F756C6448696465436F6E74726F6C7328652926266E2E70757368287B72616E67653A78752E6F664C656E67746828692E6D6F6469666965644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(24413) := '2C31292E746F496E636C757369766552616E676528292C6F7074696F6E733A727D293B72657475726E206E7D292929292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D6F2E726561642865293B746869732E5F69735570';
wwv_flow_imp.g_varchar2_table(24414) := '646174696E6748696464656E41726561733D21303B7472797B746869732E5F656469746F72732E6F726967696E616C2E73657448696464656E417265617328742E6D61702828743D3E742E67657448696464656E4F726967696E616C52616E6765286529';
wwv_flow_imp.g_varchar2_table(24415) := '2E746F496E636C757369766552616E6765282929292E66696C74657228626C29292C746869732E5F656469746F72732E6D6F6469666965642E73657448696464656E417265617328742E6D61702828743D3E742E67657448696464656E4D6F6469666965';
wwv_flow_imp.g_varchar2_table(24416) := '6452616E67652865292E746F496E636C757369766552616E6765282929292E66696C74657228626C29297D66696E616C6C797B746869732E5F69735570646174696E6748696464656E41726561733D21317D7D2929292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(24417) := '7228746869732E5F656469746F72732E6D6F6469666965642E6F6E4D6F75736555702828653D3E7B76617220743B69662821652E6576656E742E7269676874427574746F6E2626652E7461726765742E706F736974696F6E2626286E756C6C3D3D3D2874';
wwv_flow_imp.g_varchar2_table(24418) := '3D652E7461726765742E656C656D656E74297C7C766F696420303D3D3D743F766F696420303A742E636C6173734E616D652E696E636C756465732822666F6C642D756E6368616E676564222929297B636F6E737420743D652E7461726765742E706F7369';
wwv_flow_imp.g_varchar2_table(24419) := '74696F6E2E6C696E654E756D6265722C6E3D746869732E5F646966664D6F64656C2E67657428293B696628216E2972657475726E3B636F6E737420693D6E2E756E6368616E676564526567696F6E732E67657428292E66696E642828653D3E652E6D6F64';
wwv_flow_imp.g_varchar2_table(24420) := '6966696564556E6368616E67656452616E67652E696E636C7564657328742929293B69662821692972657475726E3B692E636F6C6C61707365416C6C28766F69642030292C652E6576656E742E73746F7050726F7061676174696F6E28292C652E657665';
wwv_flow_imp.g_varchar2_table(24421) := '6E742E70726576656E7444656661756C7428297D7D2929292C746869732E5F726567697374657228746869732E5F656469746F72732E6F726967696E616C2E6F6E4D6F75736555702828653D3E7B76617220743B69662821652E6576656E742E72696768';
wwv_flow_imp.g_varchar2_table(24422) := '74427574746F6E2626652E7461726765742E706F736974696F6E2626286E756C6C3D3D3D28743D652E7461726765742E656C656D656E74297C7C766F696420303D3D3D743F766F696420303A742E636C6173734E616D652E696E636C756465732822666F';
wwv_flow_imp.g_varchar2_table(24423) := '6C642D756E6368616E676564222929297B636F6E737420743D652E7461726765742E706F736974696F6E2E6C696E654E756D6265722C6E3D746869732E5F646966664D6F64656C2E67657428293B696628216E2972657475726E3B636F6E737420693D6E';
wwv_flow_imp.g_varchar2_table(24424) := '2E756E6368616E676564526567696F6E732E67657428292E66696E642828653D3E652E6F726967696E616C556E6368616E67656452616E67652E696E636C7564657328742929293B69662821692972657475726E3B692E636F6C6C61707365416C6C2876';
wwv_flow_imp.g_varchar2_table(24425) := '6F69642030292C652E6576656E742E73746F7050726F7061676174696F6E28292C652E6576656E742E70726576656E7444656661756C7428297D7D2929297D7D3B62582E5F62726561646372756D6273536F75726365466163746F72793D245428226272';
wwv_flow_imp.g_varchar2_table(24426) := '6561646372756D6273536F75726365466163746F7279222C766F69642030292C62583D76583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D';
wwv_flow_imp.g_varchar2_table(24427) := '4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F72';
wwv_flow_imp.g_varchar2_table(24428) := '61746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C';
wwv_flow_imp.g_varchar2_table(24429) := '72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B7428';
wwv_flow_imp.g_varchar2_table(24430) := '6E2C692C65297D7D28332C7563295D2C6258293B636C617373205F5820657874656E64732055597B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B636F6E7374206C3D497228226469762E646966662D68696464656E2D6C696E';
wwv_flow_imp.g_varchar2_table(24431) := '65732D77696467657422293B737570657228652C742C6C2E726F6F74292C746869732E5F656469746F723D652C746869732E5F756E6368616E676564526567696F6E3D6E2C746869732E5F756E6368616E676564526567696F6E52616E67653D692C7468';
wwv_flow_imp.g_varchar2_table(24432) := '69732E5F686964653D6F2C746869732E5F6D6F6469666965644F75746C696E65536F757263653D732C746869732E5F72657665616C4D6F64696669656448696464656E4C696E653D722C746869732E5F6F7074696F6E733D612C746869732E5F6E6F6465';
wwv_flow_imp.g_varchar2_table(24433) := '733D497228226469762E646966662D68696464656E2D6C696E6573222C5B497228226469762E746F7040746F70222C7B7469746C653A6228302C22436C69636B206F72206472616720746F2073686F77206D6F72652061626F766522297D292C49722822';
wwv_flow_imp.g_varchar2_table(24434) := '6469762E63656E74657240636F6E74656E74222C7B7374796C653A7B646973706C61793A22666C6578227D7D2C5B49722822646976406669727374222C7B7374796C653A7B646973706C61793A22666C6578222C6A757374696679436F6E74656E743A22';
wwv_flow_imp.g_varchar2_table(24435) := '63656E746572222C616C69676E4974656D733A2263656E746572222C666C6578536872696E6B3A2230227D7D2C5B6272282261222C7B7469746C653A6228302C2253686F7720556E6368616E67656420526567696F6E22292C726F6C653A22627574746F';
wwv_flow_imp.g_varchar2_table(24436) := '6E222C6F6E636C69636B3A28293D3E7B746869732E5F756E6368616E676564526567696F6E2E73686F77416C6C28766F69642030297D7D2C2E2E2E536B28222428756E666F6C64292229295D292C49722822646976406F7468657273222C7B7374796C65';
wwv_flow_imp.g_varchar2_table(24437) := '3A7B646973706C61793A22666C6578222C6A757374696679436F6E74656E743A2263656E746572222C616C69676E4974656D733A2263656E746572227D7D295D292C497228226469762E626F74746F6D40626F74746F6D222C7B7469746C653A6228302C';
wwv_flow_imp.g_varchar2_table(24438) := '22436C69636B206F72206472616720746F2073686F77206D6F72652062656C6F7722292C726F6C653A22627574746F6E227D295D292C6C2E726F6F742E617070656E644368696C6428746869732E5F6E6F6465732E726F6F74293B636F6E737420633D61';
wwv_flow_imp.g_varchar2_table(24439) := '4928746869732E5F656469746F722E6F6E4469644C61796F75744368616E67652C2828293D3E746869732E5F656469746F722E6765744C61796F7574496E666F282929293B746869732E5F686964653F677228746869732E5F6E6F6465732E6669727374';
wwv_flow_imp.g_varchar2_table(24440) := '293A746869732E5F726567697374657228515928746869732E5F6E6F6465732E66697273742C7B77696474683A632E6D61702828653D3E652E636F6E74656E744C65667429297D29292C746869732E5F72656769737465722865492828653D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(24441) := '737420743D746869732E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74546F702E726561642865292B746869732E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74426F74746F6D2E';
wwv_flow_imp.g_varchar2_table(24442) := '726561642865293D3D3D746869732E5F756E6368616E676564526567696F6E2E6C696E65436F756E743B746869732E5F6E6F6465732E626F74746F6D2E636C6173734C6973742E746F67676C65282263616E4D6F7665546F70222C2174292C746869732E';
wwv_flow_imp.g_varchar2_table(24443) := '5F6E6F6465732E626F74746F6D2E636C6173734C6973742E746F67676C65282263616E4D6F7665426F74746F6D222C746869732E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74426F74746F6D2E726561642865293E';
wwv_flow_imp.g_varchar2_table(24444) := '30292C746869732E5F6E6F6465732E746F702E636C6173734C6973742E746F67676C65282263616E4D6F7665546F70222C746869732E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74546F702E726561642865293E30';
wwv_flow_imp.g_varchar2_table(24445) := '292C746869732E5F6E6F6465732E746F702E636C6173734C6973742E746F67676C65282263616E4D6F7665426F74746F6D222C2174293B636F6E7374206E3D746869732E5F756E6368616E676564526567696F6E2E6973447261676765642E7265616428';
wwv_flow_imp.g_varchar2_table(24446) := '65292C693D746869732E5F656469746F722E676574446F6D4E6F646528293B69262628692E636C6173734C6973742E746F67676C6528226472616767696E67556E6368616E676564526567696F6E222C21216E292C22746F70223D3D3D6E3F28692E636C';
wwv_flow_imp.g_varchar2_table(24447) := '6173734C6973742E746F67676C65282263616E4D6F7665546F70222C746869732E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74546F702E726561642865293E30292C692E636C6173734C6973742E746F67676C6528';
wwv_flow_imp.g_varchar2_table(24448) := '2263616E4D6F7665426F74746F6D222C217429293A22626F74746F6D223D3D3D6E3F28692E636C6173734C6973742E746F67676C65282263616E4D6F7665546F70222C2174292C692E636C6173734C6973742E746F67676C65282263616E4D6F7665426F';
wwv_flow_imp.g_varchar2_table(24449) := '74746F6D222C746869732E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74426F74746F6D2E726561642865293E3029293A28692E636C6173734C6973742E746F67676C65282263616E4D6F7665546F70222C2131292C';
wwv_flow_imp.g_varchar2_table(24450) := '692E636C6173734C6973742E746F67676C65282263616E4D6F7665426F74746F6D222C21312929297D2929293B636F6E737420643D746869732E5F656469746F723B746869732E5F726567697374657228627328746869732E5F6E6F6465732E746F702C';
wwv_flow_imp.g_varchar2_table(24451) := '226D6F757365646F776E222C28653D3E7B69662830213D3D652E627574746F6E2972657475726E3B746869732E5F6E6F6465732E746F702E636C6173734C6973742E746F67676C6528226472616767696E67222C2130292C746869732E5F6E6F6465732E';
wwv_flow_imp.g_varchar2_table(24452) := '726F6F742E636C6173734C6973742E746F67676C6528226472616767696E67222C2130292C652E70726576656E7444656661756C7428293B636F6E737420743D652E636C69656E74593B6C6574206E3D21313B636F6E737420693D746869732E5F756E63';
wwv_flow_imp.g_varchar2_table(24453) := '68616E676564526567696F6E2E76697369626C654C696E65436F756E74546F702E67657428293B746869732E5F756E6368616E676564526567696F6E2E6973447261676765642E7365742822746F70222C766F69642030293B636F6E7374206F3D727328';
wwv_flow_imp.g_varchar2_table(24454) := '746869732E5F6E6F6465732E746F70292C733D6273286F2C226D6F7573656D6F7665222C28653D3E7B636F6E7374206F3D652E636C69656E74592D743B6E3D6E7C7C4D6174682E616273286F293E323B636F6E737420733D4D6174682E726F756E64286F';
wwv_flow_imp.g_varchar2_table(24455) := '2F642E6765744F7074696F6E28363729292C723D4D6174682E6D617828302C4D6174682E6D696E28692B732C746869732E5F756E6368616E676564526567696F6E2E6765744D617856697369626C654C696E65436F756E74546F70282929293B74686973';
wwv_flow_imp.g_varchar2_table(24456) := '2E5F756E6368616E676564526567696F6E2E76697369626C654C696E65436F756E74546F702E73657428722C766F69642030297D29292C723D6273286F2C226D6F7573657570222C28653D3E7B6E7C7C746869732E5F756E6368616E676564526567696F';
wwv_flow_imp.g_varchar2_table(24457) := '6E2E73686F774D6F726541626F766528746869732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E7352657665616C4C696E65436F756E742E67657428292C766F69642030292C746869732E5F6E6F6465732E746F702E636C6173';
wwv_flow_imp.g_varchar2_table(24458) := '734C6973742E746F67676C6528226472616767696E67222C2131292C746869732E5F6E6F6465732E726F6F742E636C6173734C6973742E746F67676C6528226472616767696E67222C2131292C746869732E5F756E6368616E676564526567696F6E2E69';
wwv_flow_imp.g_varchar2_table(24459) := '73447261676765642E73657428766F696420302C766F69642030292C732E646973706F736528292C722E646973706F736528297D29297D2929292C746869732E5F726567697374657228627328746869732E5F6E6F6465732E626F74746F6D2C226D6F75';
wwv_flow_imp.g_varchar2_table(24460) := '7365646F776E222C28653D3E7B69662830213D3D652E627574746F6E2972657475726E3B746869732E5F6E6F6465732E626F74746F6D2E636C6173734C6973742E746F67676C6528226472616767696E67222C2130292C746869732E5F6E6F6465732E72';
wwv_flow_imp.g_varchar2_table(24461) := '6F6F742E636C6173734C6973742E746F67676C6528226472616767696E67222C2130292C652E70726576656E7444656661756C7428293B636F6E737420743D652E636C69656E74593B6C6574206E3D21313B636F6E737420693D746869732E5F756E6368';
wwv_flow_imp.g_varchar2_table(24462) := '616E676564526567696F6E2E76697369626C654C696E65436F756E74426F74746F6D2E67657428293B746869732E5F756E6368616E676564526567696F6E2E6973447261676765642E7365742822626F74746F6D222C766F69642030293B636F6E737420';
wwv_flow_imp.g_varchar2_table(24463) := '6F3D727328746869732E5F6E6F6465732E626F74746F6D292C733D6273286F2C226D6F7573656D6F7665222C28653D3E7B636F6E7374206F3D652E636C69656E74592D743B6E3D6E7C7C4D6174682E616273286F293E323B636F6E737420733D4D617468';
wwv_flow_imp.g_varchar2_table(24464) := '2E726F756E64286F2F642E6765744F7074696F6E28363729292C723D4D6174682E6D617828302C4D6174682E6D696E28692D732C746869732E5F756E6368616E676564526567696F6E2E6765744D617856697369626C654C696E65436F756E74426F7474';
wwv_flow_imp.g_varchar2_table(24465) := '6F6D282929292C613D746869732E5F756E6368616E676564526567696F6E52616E67652E656E644C696E654E756D6265724578636C75736976653E642E6765744D6F64656C28292E6765744C696E65436F756E7428293F642E676574436F6E74656E7448';
wwv_flow_imp.g_varchar2_table(24466) := '656967687428293A642E676574546F70466F724C696E654E756D62657228746869732E5F756E6368616E676564526567696F6E52616E67652E656E644C696E654E756D6265724578636C7573697665293B746869732E5F756E6368616E67656452656769';
wwv_flow_imp.g_varchar2_table(24467) := '6F6E2E76697369626C654C696E65436F756E74426F74746F6D2E73657428722C766F69642030293B636F6E7374206C3D746869732E5F756E6368616E676564526567696F6E52616E67652E656E644C696E654E756D6265724578636C75736976653E642E';
wwv_flow_imp.g_varchar2_table(24468) := '6765744D6F64656C28292E6765744C696E65436F756E7428293F642E676574436F6E74656E7448656967687428293A642E676574546F70466F724C696E654E756D62657228746869732E5F756E6368616E676564526567696F6E52616E67652E656E644C';
wwv_flow_imp.g_varchar2_table(24469) := '696E654E756D6265724578636C7573697665293B642E7365745363726F6C6C546F7028642E6765745363726F6C6C546F7028292B286C2D6129297D29292C723D6273286F2C226D6F7573657570222C28653D3E7B696628746869732E5F756E6368616E67';
wwv_flow_imp.g_varchar2_table(24470) := '6564526567696F6E2E6973447261676765642E73657428766F696420302C766F69642030292C216E297B636F6E737420653D642E676574546F70466F724C696E654E756D62657228746869732E5F756E6368616E676564526567696F6E52616E67652E65';
wwv_flow_imp.g_varchar2_table(24471) := '6E644C696E654E756D6265724578636C7573697665293B746869732E5F756E6368616E676564526567696F6E2E73686F774D6F726542656C6F7728746869732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E7352657665616C4C';
wwv_flow_imp.g_varchar2_table(24472) := '696E65436F756E742E67657428292C766F69642030293B636F6E737420743D642E676574546F70466F724C696E654E756D62657228746869732E5F756E6368616E676564526567696F6E52616E67652E656E644C696E654E756D6265724578636C757369';
wwv_flow_imp.g_varchar2_table(24473) := '7665293B642E7365745363726F6C6C546F7028642E6765745363726F6C6C546F7028292B28742D6529297D746869732E5F6E6F6465732E626F74746F6D2E636C6173734C6973742E746F67676C6528226472616767696E67222C2131292C746869732E5F';
wwv_flow_imp.g_varchar2_table(24474) := '6E6F6465732E726F6F742E636C6173734C6973742E746F67676C6528226472616767696E67222C2131292C732E646973706F736528292C722E646973706F736528297D29297D2929292C746869732E5F72656769737465722865492828653D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(24475) := '737420743D5B5D3B69662821746869732E5F68696465297B636F6E737420693D6228302C227B307D2068696464656E206C696E6573222C6E2E67657448696464656E4D6F64696669656452616E67652865292E6C656E677468292C6F3D62722822737061';
wwv_flow_imp.g_varchar2_table(24476) := '6E222C7B7469746C653A6228302C22446F75626C6520636C69636B20746F20756E666F6C6422297D2C69293B6F2E6164644576656E744C697374656E6572282264626C636C69636B222C28653D3E7B303D3D3D652E627574746F6E262628652E70726576';
wwv_flow_imp.g_varchar2_table(24477) := '656E7444656661756C7428292C746869732E5F756E6368616E676564526567696F6E2E73686F77416C6C28766F6964203029297D29292C742E70757368286F293B636F6E737420733D746869732E5F756E6368616E676564526567696F6E2E6765744869';
wwv_flow_imp.g_varchar2_table(24478) := '6464656E4D6F64696669656452616E67652865292C723D746869732E5F6D6F6469666965644F75746C696E65536F757263652E67657442726561646372756D624974656D7328732C65293B696628722E6C656E6774683E30297B742E7075736828627228';
wwv_flow_imp.g_varchar2_table(24479) := '227370616E222C766F696420302C22C2A0C2A07CC2A0C2A02229293B666F72286C657420653D303B653C722E6C656E6774683B652B2B297B636F6E7374206E3D725B655D2C693D497228226469762E62726561646372756D622D6974656D222C7B737479';
wwv_flow_imp.g_varchar2_table(24480) := '6C653A7B646973706C61793A22666C6578222C616C69676E4974656D733A2263656E746572227D7D2C5B786B284C772E746F49636F6E286E2E6B696E6429292C22C2A0222C6E2E6E616D652C2E2E2E653D3D3D722E6C656E6774682D313F5B5D3A5B786B';
wwv_flow_imp.g_varchar2_table(24481) := '284C6C2E63686576726F6E5269676874295D5D292E726F6F743B742E707573682869292C692E6F6E636C69636B3D28293D3E7B746869732E5F72657665616C4D6F64696669656448696464656E4C696E65286E2E73746172744C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(24482) := '7D7D7D7D677228746869732E5F6E6F6465732E6F74686572732C2E2E2E74297D2929297D7D7661722079583B6C65742077583D79583D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B7375';
wwv_flow_imp.g_varchar2_table(24483) := '70657228292C746869732E5F656469746F72733D652C746869732E5F726F6F74456C656D656E743D742C746869732E5F646966664D6F64656C3D6E2C746869732E5F726F6F7457696474683D692C746869732E5F726F6F744865696768743D6F2C746869';
wwv_flow_imp.g_varchar2_table(24484) := '732E5F6D6F646966696564456469746F724C61796F7574496E666F3D732C746869732E5F7468656D65536572766963653D722C746869732E77696474683D79582E454E544952455F444946465F4F564552564945575F57494454483B636F6E737420613D';
wwv_flow_imp.g_varchar2_table(24485) := '614928746869732E5F7468656D65536572766963652E6F6E446964436F6C6F725468656D654368616E67652C2828293D3E746869732E5F7468656D65536572766963652E676574436F6C6F725468656D65282929292C6C3D51542828653D3E7B636F6E73';
wwv_flow_imp.g_varchar2_table(24486) := '7420743D612E726561642865293B72657475726E7B696E73657274436F6C6F723A742E676574436F6C6F72284D66297C7C28742E676574436F6C6F72285466297C7C4C66292E7472616E73706172656E742832292C72656D6F7665436F6C6F723A742E67';
wwv_flow_imp.g_varchar2_table(24487) := '6574436F6C6F72284166297C7C28742E676574436F6C6F72284966297C7C4466292E7472616E73706172656E742832297D7D29292C633D734528646F63756D656E742E637265617465456C656D656E7428226469762229293B632E736574436C6173734E';
wwv_flow_imp.g_varchar2_table(24488) := '616D6528226469666656696577706F727422292C632E736574506F736974696F6E28226162736F6C75746522293B636F6E737420643D497228226469762E646966664F76657276696577222C7B7374796C653A7B706F736974696F6E3A226162736F6C75';
wwv_flow_imp.g_varchar2_table(24489) := '7465222C746F703A22307078222C77696474683A79582E454E544952455F444946465F4F564552564945575F57494454482B227078227D7D292E726F6F743B746869732E5F7265676973746572286A5928642C632E646F6D4E6F646529292C746869732E';
wwv_flow_imp.g_varchar2_table(24490) := '5F726567697374657228797328642C61722E504F494E5445525F444F574E2C28653D3E7B746869732E5F656469746F72732E6D6F6469666965642E64656C6567617465566572746963616C5363726F6C6C626172506F696E746572446F776E2865297D29';
wwv_flow_imp.g_varchar2_table(24491) := '29292C746869732E5F726567697374657228627328642C61722E4D4F5553455F574845454C2C28653D3E7B746869732E5F656469746F72732E6D6F6469666965642E64656C65676174655363726F6C6C46726F6D4D6F757365576865656C4576656E7428';
wwv_flow_imp.g_varchar2_table(24492) := '65297D292C7B706173736976653A21317D29292C746869732E5F7265676973746572286A5928746869732E5F726F6F74456C656D656E742C6429292C746869732E5F7265676973746572286949282828652C74293D3E7B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(24493) := '5F646966664D6F64656C2E726561642865292C693D746869732E5F656469746F72732E6F726967696E616C2E6372656174654F7665727669657752756C657228226F726967696E616C20646966664F7665727669657752756C657222293B69262628742E';
wwv_flow_imp.g_varchar2_table(24494) := '6164642869292C742E616464286A5928642C692E676574446F6D4E6F646528292929293B636F6E7374206F3D746869732E5F656469746F72732E6D6F6469666965642E6372656174654F7665727669657752756C657228226D6F64696669656420646966';
wwv_flow_imp.g_varchar2_table(24495) := '664F7665727669657752756C657222293B6966286F262628742E616464286F292C742E616464286A5928642C6F2E676574446F6D4E6F646528292929292C21697C7C216F2972657475726E3B636F6E737420733D63492822766965775A6F6E654368616E';
wwv_flow_imp.g_varchar2_table(24496) := '676564222C746869732E5F656469746F72732E6F726967696E616C2E6F6E4469644368616E6765566965775A6F6E6573292C723D63492822766965775A6F6E654368616E676564222C746869732E5F656469746F72732E6D6F6469666965642E6F6E4469';
wwv_flow_imp.g_varchar2_table(24497) := '644368616E6765566965775A6F6E6573292C613D6349282268696464656E52616E6765734368616E676564222C746869732E5F656469746F72732E6F726967696E616C2E6F6E4469644368616E676548696464656E4172656173292C683D634928226869';
wwv_flow_imp.g_varchar2_table(24498) := '6464656E52616E6765734368616E676564222C746869732E5F656469746F72732E6D6F6469666965642E6F6E4469644368616E676548696464656E4172656173293B742E6164642865492828653D3E7B76617220743B732E726561642865292C722E7265';
wwv_flow_imp.g_varchar2_table(24499) := '61642865292C612E726561642865292C682E726561642865293B636F6E737420633D6C2E726561642865292C643D6E756C6C3D3D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E646966662E72656164286529297C7C766F696420303D3D3D743F76';
wwv_flow_imp.g_varchar2_table(24500) := '6F696420303A742E6D617070696E67733B66756E6374696F6E207528652C742C6E297B636F6E737420693D6E2E5F676574566965774D6F64656C28293B72657475726E20693F652E66696C7465722828653D3E652E6C656E6774683E3029292E6D617028';
wwv_flow_imp.g_varchar2_table(24501) := '28653D3E7B636F6E7374206E3D692E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328652E73746172744C696E654E756D6265722C3129292C';
wwv_flow_imp.g_varchar2_table(24502) := '6F3D692E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328652E656E644C696E654E756D6265724578636C75736976652C3129292C733D6F2E';
wwv_flow_imp.g_varchar2_table(24503) := '6C696E654E756D6265722D6E2E6C696E654E756D6265723B72657475726E206E6577205A4F286E2E6C696E654E756D6265722C6F2E6C696E654E756D6265722C732C742E746F537472696E672829297D29293A5B5D7D636F6E737420703D752828647C7C';
wwv_flow_imp.g_varchar2_table(24504) := '5B5D292E6D61702828653D3E652E6C696E6552616E67654D617070696E672E6F726967696E616C29292C632E72656D6F7665436F6C6F722C746869732E5F656469746F72732E6F726967696E616C292C673D752828647C7C5B5D292E6D61702828653D3E';
wwv_flow_imp.g_varchar2_table(24505) := '652E6C696E6552616E67654D617070696E672E6D6F64696669656429292C632E696E73657274436F6C6F722C746869732E5F656469746F72732E6D6F646966696564293B6E756C6C3D3D697C7C692E7365745A6F6E65732870292C6E756C6C3D3D6F7C7C';
wwv_flow_imp.g_varchar2_table(24506) := '6F2E7365745A6F6E65732867297D2929292C742E6164642865492828653D3E7B636F6E737420743D746869732E5F726F6F744865696768742E726561642865292C6E3D746869732E5F726F6F7457696474682E726561642865292C733D746869732E5F6D';
wwv_flow_imp.g_varchar2_table(24507) := '6F646966696564456469746F724C61796F7574496E666F2E726561642865293B69662873297B636F6E7374206E3D79582E454E544952455F444946465F4F564552564945575F57494454482D322A79582E4F4E455F4F564552564945575F57494454483B';
wwv_flow_imp.g_varchar2_table(24508) := '692E7365744C61796F7574287B746F703A302C6865696768743A742C72696768743A6E2B79582E4F4E455F4F564552564945575F57494454482C77696474683A79582E4F4E455F4F564552564945575F57494454487D292C6F2E7365744C61796F757428';
wwv_flow_imp.g_varchar2_table(24509) := '7B746F703A302C6865696768743A742C72696768743A302C77696474683A79582E4F4E455F4F564552564945575F57494454487D293B636F6E737420723D746869732E5F656469746F72732E6D6F6469666965645363726F6C6C546F702E726561642865';
wwv_flow_imp.g_varchar2_table(24510) := '292C613D746869732E5F656469746F72732E6D6F6469666965645363726F6C6C4865696768742E726561642865292C6C3D746869732E5F656469746F72732E6D6F6469666965642E6765744F7074696F6E28313033292C643D6E6577205844286C2E7665';
wwv_flow_imp.g_varchar2_table(24511) := '72746963616C4861734172726F77733F6C2E6172726F7753697A653A302C6C2E766572746963616C5363726F6C6C62617253697A652C302C732E6865696768742C612C72293B632E736574546F7028642E676574536C69646572506F736974696F6E2829';
wwv_flow_imp.g_varchar2_table(24512) := '292C632E73657448656967687428642E676574536C6964657253697A652829297D656C736520632E736574546F702830292C632E7365744865696768742830293B642E7374796C652E6865696768743D742B227078222C642E7374796C652E6C6566743D';
wwv_flow_imp.g_varchar2_table(24513) := '6E2D79582E454E544952455F444946465F4F564552564945575F57494454482B227078222C632E73657457696474682879582E454E544952455F444946465F4F564552564945575F5749445448297D2929297D2929297D7D3B77582E4F4E455F4F564552';
wwv_flow_imp.g_varchar2_table(24514) := '564945575F57494454483D31352C77582E454E544952455F444946465F4F564552564945575F57494454483D322A79582E4F4E455F4F564552564945575F57494454482C77583D79583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D';
wwv_flow_imp.g_varchar2_table(24515) := '617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65';
wwv_flow_imp.g_varchar2_table(24516) := '637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B61';
wwv_flow_imp.g_varchar2_table(24517) := '2D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66';
wwv_flow_imp.g_varchar2_table(24518) := '756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28362C5062295D2C7758293B636F6E73742043583D5B5D3B636C61737320535820657874656E6473206C747B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(24519) := '652C742C6E2C69297B737570657228292C746869732E5F656469746F72733D652C746869732E5F646966664D6F64656C3D742C746869732E5F6F7074696F6E733D6E2C746869732E5F7769646765743D692C746869732E5F73656C656374656444696666';
wwv_flow_imp.g_varchar2_table(24520) := '733D515428746869732C28653D3E7B636F6E737420743D746869732E5F646966664D6F64656C2E726561642865292C6E3D6E756C6C3D3D743F766F696420303A742E646966662E726561642865293B696628216E2972657475726E2043583B636F6E7374';
wwv_flow_imp.g_varchar2_table(24521) := '20693D746869732E5F656469746F72732E6D6F64696669656453656C656374696F6E732E726561642865293B696628692E65766572792828653D3E652E6973456D707479282929292972657475726E2043583B636F6E7374206F3D6E6577206B7528692E';
wwv_flow_imp.g_varchar2_table(24522) := '6D61702828653D3E78752E66726F6D52616E6765496E636C75736976652865292929292C733D6E2E6D617070696E67732E66696C7465722828653D3E652E6C696E6552616E67654D617070696E672E696E6E65724368616E67657326266F2E696E746572';
wwv_flow_imp.g_varchar2_table(24523) := '736563747328652E6C696E6552616E67654D617070696E672E6D6F6469666965642929292E6D61702828653D3E287B6D617070696E673A652C72616E67654D617070696E67733A652E6C696E6552616E67654D617070696E672E696E6E65724368616E67';
wwv_flow_imp.g_varchar2_table(24524) := '65732E66696C7465722828653D3E692E736F6D652828743D3E72682E617265496E74657273656374696E6728652E6D6F64696669656452616E67652C7429292929297D2929293B72657475726E20303D3D3D732E6C656E6774687C7C732E657665727928';
wwv_flow_imp.g_varchar2_table(24525) := '28653D3E303D3D3D652E72616E67654D617070696E67732E6C656E67746829293F43583A737D29292C746869732E5F7265676973746572286949282828652C74293D3E7B69662821746869732E5F6F7074696F6E732E73686F756C6452656E6465724F6C';
wwv_flow_imp.g_varchar2_table(24526) := '645265766572744172726F77732E726561642865292972657475726E3B636F6E7374206E3D746869732E5F646966664D6F64656C2E726561642865292C693D6E756C6C3D3D6E3F766F696420303A6E2E646966662E726561642865293B696628216E7C7C';
wwv_flow_imp.g_varchar2_table(24527) := '21692972657475726E3B6966286E2E6D6F76656454657874546F436F6D706172652E726561642865292972657475726E3B636F6E7374206F3D5B5D2C733D746869732E5F73656C656374656444696666732E726561642865292C723D6E65772053657428';
wwv_flow_imp.g_varchar2_table(24528) := '732E6D61702828653D3E652E6D617070696E672929293B696628732E6C656E6774683E30297B636F6E7374206E3D746869732E5F656469746F72732E6D6F64696669656453656C656374696F6E732E726561642865292C693D742E616464286E65772078';
wwv_flow_imp.g_varchar2_table(24529) := '58286E5B6E2E6C656E6774682D315D2E706F736974696F6E4C696E654E756D6265722C746869732E5F7769646765742C732E666C61744D61702828653D3E652E72616E67654D617070696E677329292C213029293B746869732E5F656469746F72732E6D';
wwv_flow_imp.g_varchar2_table(24530) := '6F6469666965642E616464476C7970684D617267696E5769646765742869292C6F2E707573682869297D666F7228636F6E73742065206F6620692E6D617070696E67732969662821722E686173286529262621652E6C696E6552616E67654D617070696E';
wwv_flow_imp.g_varchar2_table(24531) := '672E6D6F6469666965642E6973456D7074792626652E6C696E6552616E67654D617070696E672E696E6E65724368616E676573297B636F6E7374206E3D742E616464286E657720785828652E6C696E6552616E67654D617070696E672E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(24532) := '642E73746172744C696E654E756D6265722C746869732E5F7769646765742C652E6C696E6552616E67654D617070696E672C213129293B746869732E5F656469746F72732E6D6F6469666965642E616464476C7970684D617267696E576964676574286E';
wwv_flow_imp.g_varchar2_table(24533) := '292C6F2E70757368286E297D742E616464287274282828293D3E7B666F7228636F6E73742065206F66206F29746869732E5F656469746F72732E6D6F6469666965642E72656D6F7665476C7970684D617267696E5769646765742865297D2929297D2929';
wwv_flow_imp.g_varchar2_table(24534) := '297D7D636C61737320785820657874656E6473206C747B676574496428297B72657475726E20746869732E5F69647D636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F6C696E654E756D6265723D652C746869732E';
wwv_flow_imp.g_varchar2_table(24535) := '5F7769646765743D742C746869732E5F64696666733D6E2C746869732E5F72657665727453656C656374696F6E3D692C746869732E5F69643D22726576657274427574746F6E222B78582E636F756E7465722B2B2C746869732E5F646F6D4E6F64653D49';
wwv_flow_imp.g_varchar2_table(24536) := '7228226469762E726576657274427574746F6E222C7B7469746C653A746869732E5F72657665727453656C656374696F6E3F6228302C225265766572742053656C6563746564204368616E67657322293A6228302C22526576657274204368616E676522';
wwv_flow_imp.g_varchar2_table(24537) := '297D2C5B786B284C6C2E6172726F775269676874295D292E726F6F742C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C61722E4D4F5553455F444F574E2C28653D3E7B32213D3D652E627574746F6E262628652E73746F';
wwv_flow_imp.g_varchar2_table(24538) := '7050726F7061676174696F6E28292C652E70726576656E7444656661756C742829297D2929292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C61722E4D4F5553455F55502C28653D3E7B652E73746F7050726F706167';
wwv_flow_imp.g_varchar2_table(24539) := '6174696F6E28292C652E70726576656E7444656661756C7428297D2929292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C61722E434C49434B2C28653D3E7B746869732E5F646966667320696E7374616E63656F6620';
wwv_flow_imp.g_varchar2_table(24540) := '597A3F746869732E5F7769646765742E72657665727428746869732E5F6469666673293A746869732E5F7769646765742E72657665727452616E67654D617070696E677328746869732E5F6469666673292C652E73746F7050726F7061676174696F6E28';
wwv_flow_imp.g_varchar2_table(24541) := '292C652E70726576656E7444656661756C7428297D2929297D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B6C616E653A78682E52696768742C72616E67653A';
wwv_flow_imp.g_varchar2_table(24542) := '7B7374617274436F6C756D6E3A312C73746172744C696E654E756D6265723A746869732E5F6C696E654E756D6265722C656E64436F6C756D6E3A312C656E644C696E654E756D6265723A746869732E5F6C696E654E756D6265727D2C7A496E6465783A31';
wwv_flow_imp.g_varchar2_table(24543) := '303030317D7D7D78582E636F756E7465723D303B636C617373206B587B737461746963206765742865297B6C657420743D6B582E5F6D61702E6765742865293B6966282174297B743D6E6577206B582865292C6B582E5F6D61702E73657428652C74293B';
wwv_flow_imp.g_varchar2_table(24544) := '636F6E7374206E3D652E6F6E446964446973706F7365282828293D3E7B6B582E5F6D61702E64656C6574652865292C6E2E646973706F736528297D29297D72657475726E20747D636F6E7374727563746F722865297B746869732E656469746F723D652C';
wwv_flow_imp.g_varchar2_table(24545) := '746869732E6D6F64656C3D614928746869732E656469746F722E6F6E4469644368616E67654D6F64656C2C2828293D3E746869732E656469746F722E6765744D6F64656C282929297D7D6B582E5F6D61703D6E6577204D61703B7661722045583D66756E';
wwv_flow_imp.g_varchar2_table(24546) := '6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204C583D636C61737320657874656E6473206C747B676574206F6E446964436F6E74656E7453697A654368616E676528297B72657475';
wwv_flow_imp.g_varchar2_table(24547) := '726E20746869732E5F6F6E446964436F6E74656E7453697A654368616E67652E6576656E747D636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228292C746869732E6F726967696E616C456469746F72456C656D656E743D';
wwv_flow_imp.g_varchar2_table(24548) := '652C746869732E6D6F646966696564456469746F72456C656D656E743D742C746869732E5F6F7074696F6E733D6E2C746869732E5F617267436F6465456469746F725769646765744F7074696F6E733D692C746869732E5F637265617465496E6E657245';
wwv_flow_imp.g_varchar2_table(24549) := '6469746F723D6F2C746869732E5F696E7374616E74696174696F6E536572766963653D732C746869732E5F6B657962696E64696E67536572766963653D722C746869732E6F726967696E616C3D746869732E5F726567697374657228746869732E5F6372';
wwv_flow_imp.g_varchar2_table(24550) := '656174654C65667448616E6453696465456469746F7228746869732E5F6F7074696F6E732E656469746F724F7074696F6E732E67657428292C746869732E5F617267436F6465456469746F725769646765744F7074696F6E732E6F726967696E616C4564';
wwv_flow_imp.g_varchar2_table(24551) := '69746F727C7C7B7D29292C746869732E6D6F6469666965643D746869732E5F726567697374657228746869732E5F637265617465526967687448616E6453696465456469746F7228746869732E5F6F7074696F6E732E656469746F724F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(24552) := '67657428292C746869732E5F617267436F6465456469746F725769646765744F7074696F6E732E6D6F646966696564456469746F727C7C7B7D29292C746869732E5F6F6E446964436F6E74656E7453697A654368616E67653D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(24553) := '746572286E6577204374292C746869732E6D6F6469666965645363726F6C6C546F703D614928746869732E6D6F6469666965642E6F6E4469645363726F6C6C4368616E67652C2828293D3E746869732E6D6F6469666965642E6765745363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(24554) := '70282929292C746869732E6D6F6469666965645363726F6C6C4865696768743D614928746869732E6D6F6469666965642E6F6E4469645363726F6C6C4368616E67652C2828293D3E746869732E6D6F6469666965642E6765745363726F6C6C4865696768';
wwv_flow_imp.g_varchar2_table(24555) := '74282929292C746869732E6D6F6469666965644D6F64656C3D66756E6374696F6E2865297B72657475726E206B582E6765742865297D28746869732E6D6F646966696564292E6D6F64656C2C746869732E6D6F64696669656453656C656374696F6E733D';
wwv_flow_imp.g_varchar2_table(24556) := '614928746869732E6D6F6469666965642E6F6E4469644368616E6765437572736F7253656C656374696F6E2C2828293D3E7B76617220653B72657475726E206E756C6C213D3D28653D746869732E6D6F6469666965642E67657453656C656374696F6E73';
wwv_flow_imp.g_varchar2_table(24557) := '2829292626766F69642030213D3D653F653A5B5D7D29292C746869732E6D6F646966696564437572736F723D5954287B6F776E65723A746869732C657175616C73466E3A6D632E657175616C737D2C28653D3E7B76617220742C6E3B72657475726E206E';
wwv_flow_imp.g_varchar2_table(24558) := '756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E6D6F64696669656453656C656374696F6E732E726561642865295B305D297C7C766F696420303D3D3D743F766F696420303A742E676574506F736974696F6E2829292626766F69642030213D';
wwv_flow_imp.g_varchar2_table(24559) := '3D6E3F6E3A6E6577206D6328312C31297D29292C746869732E6F726967696E616C437572736F723D614928746869732E6F726967696E616C2E6F6E4469644368616E6765437572736F72506F736974696F6E2C2828293D3E7B76617220653B7265747572';
wwv_flow_imp.g_varchar2_table(24560) := '6E206E756C6C213D3D28653D746869732E6F726967696E616C2E676574506F736974696F6E2829292626766F69642030213D3D653F653A6E6577206D6328312C31297D29292C746869732E5F617267436F6465456469746F725769646765744F7074696F';
wwv_flow_imp.g_varchar2_table(24561) := '6E733D6E756C6C2C746869732E5F7265676973746572286E49287B637265617465456D7074794368616E676553756D6D6172793A28293D3E287B7D292C68616E646C654368616E67653A28652C74293D3E28652E6469644368616E6765286E2E65646974';
wwv_flow_imp.g_varchar2_table(24562) := '6F724F7074696F6E732926264F626A6563742E61737369676E28742C652E6368616E67652E6368616E6765644F7074696F6E73292C2130297D2C2828652C74293D3E7B6E2E656469746F724F7074696F6E732E726561642865292C746869732E5F6F7074';
wwv_flow_imp.g_varchar2_table(24563) := '696F6E732E72656E646572536964654279536964652E726561642865292C746869732E6D6F6469666965642E7570646174654F7074696F6E7328746869732E5F61646A7573744F7074696F6E73466F72526967687448616E645369646528652C7429292C';
wwv_flow_imp.g_varchar2_table(24564) := '746869732E6F726967696E616C2E7570646174654F7074696F6E7328746869732E5F61646A7573744F7074696F6E73466F724C65667448616E645369646528652C7429297D2929297D5F6372656174654C65667448616E6453696465456469746F722865';
wwv_flow_imp.g_varchar2_table(24565) := '2C74297B636F6E7374206E3D746869732E5F61646A7573744F7074696F6E73466F724C65667448616E645369646528766F696420302C65292C693D746869732E5F636F6E737472756374496E6E6572456469746F7228746869732E5F696E7374616E7469';
wwv_flow_imp.g_varchar2_table(24566) := '6174696F6E536572766963652C746869732E6F726967696E616C456469746F72456C656D656E742C6E2C74293B72657475726E20692E736574436F6E7465787456616C756528226973496E446966664C656674456469746F72222C2130292C697D5F6372';
wwv_flow_imp.g_varchar2_table(24567) := '65617465526967687448616E6453696465456469746F7228652C74297B636F6E7374206E3D746869732E5F61646A7573744F7074696F6E73466F72526967687448616E645369646528766F696420302C65292C693D746869732E5F636F6E737472756374';
wwv_flow_imp.g_varchar2_table(24568) := '496E6E6572456469746F7228746869732E5F696E7374616E74696174696F6E536572766963652C746869732E6D6F646966696564456469746F72456C656D656E742C6E2C74293B72657475726E20692E736574436F6E7465787456616C75652822697349';
wwv_flow_imp.g_varchar2_table(24569) := '6E446966665269676874456469746F72222C2130292C697D5F636F6E737472756374496E6E6572456469746F7228652C742C6E2C69297B636F6E7374206F3D746869732E5F637265617465496E6E6572456469746F7228652C742C6E2C69293B72657475';
wwv_flow_imp.g_varchar2_table(24570) := '726E20746869732E5F7265676973746572286F2E6F6E446964436F6E74656E7453697A654368616E67652828653D3E7B636F6E737420743D746869732E6F726967696E616C2E676574436F6E74656E74576964746828292B746869732E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(24571) := '642E676574436F6E74656E74576964746828292B77582E454E544952455F444946465F4F564552564945575F57494454482C6E3D4D6174682E6D617828746869732E6D6F6469666965642E676574436F6E74656E7448656967687428292C746869732E6F';
wwv_flow_imp.g_varchar2_table(24572) := '726967696E616C2E676574436F6E74656E744865696768742829293B746869732E5F6F6E446964436F6E74656E7453697A654368616E67652E66697265287B636F6E74656E744865696768743A6E2C636F6E74656E7457696474683A742C636F6E74656E';
wwv_flow_imp.g_varchar2_table(24573) := '744865696768744368616E6765643A652E636F6E74656E744865696768744368616E6765642C636F6E74656E7457696474684368616E6765643A652E636F6E74656E7457696474684368616E6765647D297D2929292C6F7D5F61646A7573744F7074696F';
wwv_flow_imp.g_varchar2_table(24574) := '6E73466F724C65667448616E645369646528652C74297B636F6E7374206E3D746869732E5F61646A7573744F7074696F6E73466F72537562456469746F722874293B72657475726E20746869732E5F6F7074696F6E732E72656E64657253696465427953';
wwv_flow_imp.g_varchar2_table(24575) := '6964652E67657428293F286E2E756E69636F6465486967686C696768743D746869732E5F6F7074696F6E732E656469746F724F7074696F6E732E67657428292E756E69636F6465486967686C696768747C7C7B7D2C6E2E776F7264577261704F76657272';
wwv_flow_imp.g_varchar2_table(24576) := '696465313D746869732E5F6F7074696F6E732E64696666576F7264577261702E6765742829293A286E2E776F7264577261704F76657272696465313D226F6666222C6E2E776F7264577261704F76657272696465323D226F6666222C6E2E737469636B79';
wwv_flow_imp.g_varchar2_table(24577) := '5363726F6C6C3D7B656E61626C65643A21317D2C6E2E756E69636F6465486967686C696768743D7B6E6F6E426173696341534349493A21312C616D626967756F7573436861726163746572733A21312C696E76697369626C65436861726163746572733A';
wwv_flow_imp.g_varchar2_table(24578) := '21317D292C6E2E676C7970684D617267696E3D746869732E5F6F7074696F6E732E72656E646572536964654279536964652E67657428292C742E6F726967696E616C417269614C6162656C2626286E2E617269614C6162656C3D742E6F726967696E616C';
wwv_flow_imp.g_varchar2_table(24579) := '417269614C6162656C292C6E2E617269614C6162656C3D746869732E5F757064617465417269614C6162656C286E2E617269614C6162656C292C6E2E726561644F6E6C793D21746869732E5F6F7074696F6E732E6F726967696E616C4564697461626C65';
wwv_flow_imp.g_varchar2_table(24580) := '2E67657428292C6E2E64726F70496E746F456469746F723D7B656E61626C65643A216E2E726561644F6E6C797D2C6E2E6578747261456469746F72436C6173734E616D653D226F726967696E616C2D696E2D6D6F6E61636F2D646966662D656469746F72';
wwv_flow_imp.g_varchar2_table(24581) := '222C6E7D5F61646A7573744F7074696F6E73466F72526967687448616E645369646528652C74297B636F6E7374206E3D746869732E5F61646A7573744F7074696F6E73466F72537562456469746F722874293B72657475726E20742E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(24582) := '417269614C6162656C2626286E2E617269614C6162656C3D742E6D6F646966696564417269614C6162656C292C6E2E617269614C6162656C3D746869732E5F757064617465417269614C6162656C286E2E617269614C6162656C292C6E2E776F72645772';
wwv_flow_imp.g_varchar2_table(24583) := '61704F76657272696465313D746869732E5F6F7074696F6E732E64696666576F7264577261702E67657428292C6E2E72657665616C486F72697A6F6E74616C526967687450616464696E673D594C2E72657665616C486F72697A6F6E74616C5269676874';
wwv_flow_imp.g_varchar2_table(24584) := '50616464696E672E64656661756C7456616C75652B77582E454E544952455F444946465F4F564552564945575F57494454482C6E2E7363726F6C6C6261722E766572746963616C4861734172726F77733D21312C6E2E6578747261456469746F72436C61';
wwv_flow_imp.g_varchar2_table(24585) := '73734E616D653D226D6F6469666965642D696E2D6D6F6E61636F2D646966662D656469746F72222C6E7D5F61646A7573744F7074696F6E73466F72537562456469746F722865297B636F6E737420743D7B2E2E2E652C64696D656E73696F6E3A7B686569';
wwv_flow_imp.g_varchar2_table(24586) := '6768743A302C77696474683A307D7D3B72657475726E20742E696E44696666456469746F723D21302C742E6175746F6D617469634C61796F75743D21312C742E7363726F6C6C6261723D7B2E2E2E742E7363726F6C6C6261727C7C7B7D7D2C742E666F6C';
wwv_flow_imp.g_varchar2_table(24587) := '64696E673D21312C742E636F64654C656E733D746869732E5F6F7074696F6E732E64696666436F64654C656E732E67657428292C742E66697865644F766572666C6F77576964676574733D21302C742E6D696E696D61703D7B2E2E2E742E6D696E696D61';
wwv_flow_imp.g_varchar2_table(24588) := '707C7C7B7D7D2C742E6D696E696D61702E656E61626C65643D21312C746869732E5F6F7074696F6E732E68696465556E6368616E676564526567696F6E732E67657428293F742E737469636B795363726F6C6C3D7B656E61626C65643A21317D3A742E73';
wwv_flow_imp.g_varchar2_table(24589) := '7469636B795363726F6C6C3D746869732E5F6F7074696F6E732E656469746F724F7074696F6E732E67657428292E737469636B795363726F6C6C2C747D5F757064617465417269614C6162656C2865297B76617220743B657C7C28653D2222293B636F6E';
wwv_flow_imp.g_varchar2_table(24590) := '7374206E3D6228302C2220757365207B307D20746F206F70656E20746865206163636573736962696C6974792068656C702E222C6E756C6C3D3D3D28743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E6469';
wwv_flow_imp.g_varchar2_table(24591) := '6E672822656469746F722E616374696F6E2E6163636573736962696C69747948656C702229297C7C766F696420303D3D3D743F766F696420303A742E676574417269614C6162656C2829293B72657475726E20746869732E5F6F7074696F6E732E616363';
wwv_flow_imp.g_varchar2_table(24592) := '6573736962696C697479566572626F73652E67657428293F652B6E3A653F652E7265706C616365416C6C286E2C2222293A22227D7D3B4C583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(24593) := '723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D74';
wwv_flow_imp.g_varchar2_table(24594) := '7970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28';
wwv_flow_imp.g_varchar2_table(24595) := '733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B455828352C7563292C455828362C2445295D';
wwv_flow_imp.g_varchar2_table(24596) := '2C4C58293B636C61737320445820657874656E6473206C747B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F69643D2B2B44582E6964436F756E7465722C746869732E5F6F6E446964446973706F73';
wwv_flow_imp.g_varchar2_table(24597) := '653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964446973706F73653D746869732E5F6F6E446964446973706F73652E6576656E747D676574496428297B72657475726E20746869732E676574456469746F72547970';
wwv_flow_imp.g_varchar2_table(24598) := '6528292B223A76323A222B746869732E5F69647D67657456697369626C65436F6C756D6E46726F6D506F736974696F6E2865297B72657475726E20746869732E5F746172676574456469746F722E67657456697369626C65436F6C756D6E46726F6D506F';
wwv_flow_imp.g_varchar2_table(24599) := '736974696F6E2865297D676574506F736974696F6E28297B72657475726E20746869732E5F746172676574456469746F722E676574506F736974696F6E28297D736574506F736974696F6E28652C743D2261706922297B746869732E5F74617267657445';
wwv_flow_imp.g_varchar2_table(24600) := '6469746F722E736574506F736974696F6E28652C74297D72657665616C4C696E6528652C743D30297B746869732E5F746172676574456469746F722E72657665616C4C696E6528652C74297D72657665616C4C696E65496E43656E74657228652C743D30';
wwv_flow_imp.g_varchar2_table(24601) := '297B746869732E5F746172676574456469746F722E72657665616C4C696E65496E43656E74657228652C74297D72657665616C4C696E65496E43656E74657249664F75747369646556696577706F727428652C743D30297B746869732E5F746172676574';
wwv_flow_imp.g_varchar2_table(24602) := '456469746F722E72657665616C4C696E65496E43656E74657249664F75747369646556696577706F727428652C74297D72657665616C4C696E654E656172546F7028652C743D30297B746869732E5F746172676574456469746F722E72657665616C4C69';
wwv_flow_imp.g_varchar2_table(24603) := '6E654E656172546F7028652C74297D72657665616C506F736974696F6E28652C743D30297B746869732E5F746172676574456469746F722E72657665616C506F736974696F6E28652C74297D72657665616C506F736974696F6E496E43656E7465722865';
wwv_flow_imp.g_varchar2_table(24604) := '2C743D30297B746869732E5F746172676574456469746F722E72657665616C506F736974696F6E496E43656E74657228652C74297D72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F727428652C743D30297B';
wwv_flow_imp.g_varchar2_table(24605) := '746869732E5F746172676574456469746F722E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F727428652C74297D72657665616C506F736974696F6E4E656172546F7028652C743D30297B746869732E5F74';
wwv_flow_imp.g_varchar2_table(24606) := '6172676574456469746F722E72657665616C506F736974696F6E4E656172546F7028652C74297D67657453656C656374696F6E28297B72657475726E20746869732E5F746172676574456469746F722E67657453656C656374696F6E28297D6765745365';
wwv_flow_imp.g_varchar2_table(24607) := '6C656374696F6E7328297B72657475726E20746869732E5F746172676574456469746F722E67657453656C656374696F6E7328297D73657453656C656374696F6E28652C743D2261706922297B746869732E5F746172676574456469746F722E73657453';
wwv_flow_imp.g_varchar2_table(24608) := '656C656374696F6E28652C74297D73657453656C656374696F6E7328652C743D2261706922297B746869732E5F746172676574456469746F722E73657453656C656374696F6E7328652C74297D72657665616C4C696E657328652C742C6E3D30297B7468';
wwv_flow_imp.g_varchar2_table(24609) := '69732E5F746172676574456469746F722E72657665616C4C696E657328652C742C6E297D72657665616C4C696E6573496E43656E74657228652C742C6E3D30297B746869732E5F746172676574456469746F722E72657665616C4C696E6573496E43656E';
wwv_flow_imp.g_varchar2_table(24610) := '74657228652C742C6E297D72657665616C4C696E6573496E43656E74657249664F75747369646556696577706F727428652C742C6E3D30297B746869732E5F746172676574456469746F722E72657665616C4C696E6573496E43656E74657249664F7574';
wwv_flow_imp.g_varchar2_table(24611) := '7369646556696577706F727428652C742C6E297D72657665616C4C696E65734E656172546F7028652C742C6E3D30297B746869732E5F746172676574456469746F722E72657665616C4C696E65734E656172546F7028652C742C6E297D72657665616C52';
wwv_flow_imp.g_varchar2_table(24612) := '616E676528652C743D302C6E3D21312C693D2130297B746869732E5F746172676574456469746F722E72657665616C52616E676528652C742C6E2C69297D72657665616C52616E6765496E43656E74657228652C743D30297B746869732E5F7461726765';
wwv_flow_imp.g_varchar2_table(24613) := '74456469746F722E72657665616C52616E6765496E43656E74657228652C74297D72657665616C52616E6765496E43656E74657249664F75747369646556696577706F727428652C743D30297B746869732E5F746172676574456469746F722E72657665';
wwv_flow_imp.g_varchar2_table(24614) := '616C52616E6765496E43656E74657249664F75747369646556696577706F727428652C74297D72657665616C52616E67654E656172546F7028652C743D30297B746869732E5F746172676574456469746F722E72657665616C52616E67654E656172546F';
wwv_flow_imp.g_varchar2_table(24615) := '7028652C74297D72657665616C52616E67654E656172546F7049664F75747369646556696577706F727428652C743D30297B746869732E5F746172676574456469746F722E72657665616C52616E67654E656172546F7049664F75747369646556696577';
wwv_flow_imp.g_varchar2_table(24616) := '706F727428652C74297D72657665616C52616E67654174546F7028652C743D30297B746869732E5F746172676574456469746F722E72657665616C52616E67654174546F7028652C74297D676574537570706F72746564416374696F6E7328297B726574';
wwv_flow_imp.g_varchar2_table(24617) := '75726E20746869732E5F746172676574456469746F722E676574537570706F72746564416374696F6E7328297D666F63757328297B746869732E5F746172676574456469746F722E666F63757328297D7472696767657228652C742C6E297B746869732E';
wwv_flow_imp.g_varchar2_table(24618) := '5F746172676574456469746F722E7472696767657228652C742C6E297D6372656174654465636F726174696F6E73436F6C6C656374696F6E2865297B72657475726E20746869732E5F746172676574456469746F722E6372656174654465636F72617469';
wwv_flow_imp.g_varchar2_table(24619) := '6F6E73436F6C6C656374696F6E2865297D6368616E67654465636F726174696F6E732865297B72657475726E20746869732E5F746172676574456469746F722E6368616E67654465636F726174696F6E732865297D7D44582E6964436F756E7465723D30';
wwv_flow_imp.g_varchar2_table(24620) := '3B6C65742054583D636C6173737B67657420656469746F724F7074696F6E7328297B72657475726E20746869732E5F6F7074696F6E737D636F6E7374727563746F7228652C74297B746869732E5F6163636573736962696C697479536572766963653D74';
wwv_flow_imp.g_varchar2_table(24621) := '2C746869732E5F64696666456469746F7257696474683D245428746869732C30292C746869732E5F73637265656E5265616465724D6F64653D614928746869732E5F6163636573736962696C697479536572766963652E6F6E4469644368616E67655363';
wwv_flow_imp.g_varchar2_table(24622) := '7265656E5265616465724F7074696D697A65642C2828293D3E746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A6564282929292C746869732E636F756C6453686F77496E6C696E65';
wwv_flow_imp.g_varchar2_table(24623) := '56696577426563617573654F6653697A653D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E72656E646572536964654279536964652626746869732E5F64696666456469746F7257696474682E726561642865293C';
wwv_flow_imp.g_varchar2_table(24624) := '3D746869732E5F6F7074696F6E732E726561642865292E72656E64657253696465427953696465496E6C696E65427265616B706F696E7429292C746869732E72656E6465724F7665727669657752756C65723D515428746869732C28653D3E746869732E';
wwv_flow_imp.g_varchar2_table(24625) := '5F6F7074696F6E732E726561642865292E72656E6465724F7665727669657752756C657229292C746869732E72656E646572536964654279536964653D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E72656E6465';
wwv_flow_imp.g_varchar2_table(24626) := '725369646542795369646526262128746869732E5F6F7074696F6E732E726561642865292E757365496E6C696E65566965775768656E537061636549734C696D697465642626746869732E636F756C6453686F77496E6C696E6556696577426563617573';
wwv_flow_imp.g_varchar2_table(24627) := '654F6653697A652E72656164286529262621746869732E5F73637265656E5265616465724D6F64652E726561642865292929292C746869732E726561644F6E6C793D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E';
wwv_flow_imp.g_varchar2_table(24628) := '726561644F6E6C7929292C746869732E73686F756C6452656E6465724F6C645265766572744172726F77733D515428746869732C28653D3E212821746869732E5F6F7074696F6E732E726561642865292E72656E6465724D617267696E52657665727449';
wwv_flow_imp.g_varchar2_table(24629) := '636F6E7C7C21746869732E72656E646572536964654279536964652E726561642865297C7C746869732E726561644F6E6C792E726561642865297C7C746869732E73686F756C6452656E6465724775747465724D656E752E726561642865292929292C74';
wwv_flow_imp.g_varchar2_table(24630) := '6869732E73686F756C6452656E6465724775747465724D656E753D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E72656E6465724775747465724D656E7529292C746869732E72656E646572496E64696361746F72';
wwv_flow_imp.g_varchar2_table(24631) := '733D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E72656E646572496E64696361746F727329292C746869732E656E61626C6553706C697456696577526573697A696E673D515428746869732C28653D3E74686973';
wwv_flow_imp.g_varchar2_table(24632) := '2E5F6F7074696F6E732E726561642865292E656E61626C6553706C697456696577526573697A696E6729292C746869732E73706C69745669657744656661756C74526174696F3D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561';
wwv_flow_imp.g_varchar2_table(24633) := '642865292E73706C69745669657744656661756C74526174696F29292C746869732E69676E6F72655472696D576869746573706163653D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E69676E6F72655472696D57';
wwv_flow_imp.g_varchar2_table(24634) := '68697465737061636529292C746869732E6D6178436F6D7075746174696F6E54696D654D733D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E6D6178436F6D7075746174696F6E54696D6529292C746869732E7368';
wwv_flow_imp.g_varchar2_table(24635) := '6F774D6F7665733D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E6578706572696D656E74616C2E73686F774D6F7665732626746869732E72656E646572536964654279536964652E7265616428652929292C7468';
wwv_flow_imp.g_varchar2_table(24636) := '69732E6973496E456D626564646564456469746F723D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E6973496E456D626564646564456469746F7229292C746869732E64696666576F7264577261703D5154287468';
wwv_flow_imp.g_varchar2_table(24637) := '69732C28653D3E746869732E5F6F7074696F6E732E726561642865292E64696666576F72645772617029292C746869732E6F726967696E616C4564697461626C653D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E';
wwv_flow_imp.g_varchar2_table(24638) := '6F726967696E616C4564697461626C6529292C746869732E64696666436F64654C656E733D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E64696666436F64654C656E7329292C746869732E616363657373696269';
wwv_flow_imp.g_varchar2_table(24639) := '6C697479566572626F73653D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E6163636573736962696C697479566572626F736529292C746869732E64696666416C676F726974686D3D515428746869732C28653D3E';
wwv_flow_imp.g_varchar2_table(24640) := '746869732E5F6F7074696F6E732E726561642865292E64696666416C676F726974686D29292C746869732E73686F77456D7074794465636F726174696F6E733D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E6578';
wwv_flow_imp.g_varchar2_table(24641) := '706572696D656E74616C2E73686F77456D7074794465636F726174696F6E7329292C746869732E6F6E6C7953686F7741636365737369626C65446966665669657765723D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865';
wwv_flow_imp.g_varchar2_table(24642) := '292E6F6E6C7953686F7741636365737369626C654469666656696577657229292C746869732E68696465556E6368616E676564526567696F6E733D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E68696465556E63';
wwv_flow_imp.g_varchar2_table(24643) := '68616E676564526567696F6E732E656E61626C656429292C746869732E68696465556E6368616E676564526567696F6E7352657665616C4C696E65436F756E743D515428746869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E68';
wwv_flow_imp.g_varchar2_table(24644) := '696465556E6368616E676564526567696F6E732E72657665616C4C696E65436F756E7429292C746869732E68696465556E6368616E676564526567696F6E73436F6E746578744C696E65436F756E743D515428746869732C28653D3E746869732E5F6F70';
wwv_flow_imp.g_varchar2_table(24645) := '74696F6E732E726561642865292E68696465556E6368616E676564526567696F6E732E636F6E746578744C696E65436F756E7429292C746869732E68696465556E6368616E676564526567696F6E734D696E696D756D4C696E65436F756E743D51542874';
wwv_flow_imp.g_varchar2_table(24646) := '6869732C28653D3E746869732E5F6F7074696F6E732E726561642865292E68696465556E6368616E676564526567696F6E732E6D696E696D756D4C696E65436F756E7429293B636F6E7374206E3D7B2E2E2E652C2E2E2E495828652C754C297D3B746869';
wwv_flow_imp.g_varchar2_table(24647) := '732E5F6F7074696F6E733D245428746869732C6E297D7570646174654F7074696F6E732865297B636F6E737420743D495828652C746869732E5F6F7074696F6E732E6765742829292C6E3D7B2E2E2E746869732E5F6F7074696F6E732E67657428292C2E';
wwv_flow_imp.g_varchar2_table(24648) := '2E2E652C2E2E2E747D3B746869732E5F6F7074696F6E732E736574286E2C766F696420302C7B6368616E6765644F7074696F6E733A657D297D73657457696474682865297B746869732E5F64696666456469746F7257696474682E73657428652C766F69';
wwv_flow_imp.g_varchar2_table(24649) := '642030297D7D3B66756E6374696F6E20495828652C74297B766172206E2C692C6F2C732C722C612C6C2C633B72657475726E7B656E61626C6553706C697456696577526573697A696E673A794C28652E656E61626C6553706C697456696577526573697A';
wwv_flow_imp.g_varchar2_table(24650) := '696E672C742E656E61626C6553706C697456696577526573697A696E67292C73706C69745669657744656661756C74526174696F3A784C28652E73706C69745669657744656661756C74526174696F2C2E352C2E312C2E39292C72656E64657253696465';
wwv_flow_imp.g_varchar2_table(24651) := '4279536964653A794C28652E72656E646572536964654279536964652C742E72656E64657253696465427953696465292C72656E6465724D617267696E52657665727449636F6E3A794C28652E72656E6465724D617267696E52657665727449636F6E2C';
wwv_flow_imp.g_varchar2_table(24652) := '742E72656E6465724D617267696E52657665727449636F6E292C6D6178436F6D7075746174696F6E54696D653A434C28652E6D6178436F6D7075746174696F6E54696D652C742E6D6178436F6D7075746174696F6E54696D652C302C3130373337343138';
wwv_flow_imp.g_varchar2_table(24653) := '3234292C6D617846696C6553697A653A434C28652E6D617846696C6553697A652C742E6D617846696C6553697A652C302C31303733373431383234292C69676E6F72655472696D576869746573706163653A794C28652E69676E6F72655472696D576869';
wwv_flow_imp.g_varchar2_table(24654) := '746573706163652C742E69676E6F72655472696D57686974657370616365292C72656E646572496E64696361746F72733A794C28652E72656E646572496E64696361746F72732C742E72656E646572496E64696361746F7273292C6F726967696E616C45';
wwv_flow_imp.g_varchar2_table(24655) := '64697461626C653A794C28652E6F726967696E616C4564697461626C652C742E6F726967696E616C4564697461626C65292C64696666436F64654C656E733A794C28652E64696666436F64654C656E732C742E64696666436F64654C656E73292C72656E';
wwv_flow_imp.g_varchar2_table(24656) := '6465724F7665727669657752756C65723A794C28652E72656E6465724F7665727669657752756C65722C742E72656E6465724F7665727669657752756C6572292C64696666576F7264577261703A4C4C28652E64696666576F7264577261702C742E6469';
wwv_flow_imp.g_varchar2_table(24657) := '6666576F7264577261702C5B226F6666222C226F6E222C22696E6865726974225D292C64696666416C676F726974686D3A4C4C28652E64696666416C676F726974686D2C742E64696666416C676F726974686D2C5B226C6567616379222C22616476616E';
wwv_flow_imp.g_varchar2_table(24658) := '636564225D2C7B736D6172743A226C6567616379222C6578706572696D656E74616C3A22616476616E636564227D292C6163636573736962696C697479566572626F73653A794C28652E6163636573736962696C697479566572626F73652C742E616363';
wwv_flow_imp.g_varchar2_table(24659) := '6573736962696C697479566572626F7365292C6578706572696D656E74616C3A7B73686F774D6F7665733A794C286E756C6C3D3D3D286E3D652E6578706572696D656E74616C297C7C766F696420303D3D3D6E3F766F696420303A6E2E73686F774D6F76';
wwv_flow_imp.g_varchar2_table(24660) := '65732C742E6578706572696D656E74616C2E73686F774D6F766573292C73686F77456D7074794465636F726174696F6E733A794C286E756C6C3D3D3D28693D652E6578706572696D656E74616C297C7C766F696420303D3D3D693F766F696420303A692E';
wwv_flow_imp.g_varchar2_table(24661) := '73686F77456D7074794465636F726174696F6E732C742E6578706572696D656E74616C2E73686F77456D7074794465636F726174696F6E73297D2C68696465556E6368616E676564526567696F6E733A7B656E61626C65643A794C286E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(24662) := '733D6E756C6C3D3D3D286F3D652E68696465556E6368616E676564526567696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E656E61626C6564292626766F69642030213D3D733F733A6E756C6C3D3D3D28723D652E6578706572696D65';
wwv_flow_imp.g_varchar2_table(24663) := '6E74616C297C7C766F696420303D3D3D723F766F696420303A722E636F6C6C61707365556E6368616E676564526567696F6E732C742E68696465556E6368616E676564526567696F6E732E656E61626C6564292C636F6E746578744C696E65436F756E74';
wwv_flow_imp.g_varchar2_table(24664) := '3A434C286E756C6C3D3D3D28613D652E68696465556E6368616E676564526567696F6E73297C7C766F696420303D3D3D613F766F696420303A612E636F6E746578744C696E65436F756E742C742E68696465556E6368616E676564526567696F6E732E63';
wwv_flow_imp.g_varchar2_table(24665) := '6F6E746578744C696E65436F756E742C302C31303733373431383234292C6D696E696D756D4C696E65436F756E743A434C286E756C6C3D3D3D286C3D652E68696465556E6368616E676564526567696F6E73297C7C766F696420303D3D3D6C3F766F6964';
wwv_flow_imp.g_varchar2_table(24666) := '20303A6C2E6D696E696D756D4C696E65436F756E742C742E68696465556E6368616E676564526567696F6E732E6D696E696D756D4C696E65436F756E742C302C31303733373431383234292C72657665616C4C696E65436F756E743A434C286E756C6C3D';
wwv_flow_imp.g_varchar2_table(24667) := '3D3D28633D652E68696465556E6368616E676564526567696F6E73297C7C766F696420303D3D3D633F766F696420303A632E72657665616C4C696E65436F756E742C742E68696465556E6368616E676564526567696F6E732E72657665616C4C696E6543';
wwv_flow_imp.g_varchar2_table(24668) := '6F756E742C302C31303733373431383234297D2C6973496E456D626564646564456469746F723A794C28652E6973496E456D626564646564456469746F722C742E6973496E456D626564646564456469746F72292C6F6E6C7953686F7741636365737369';
wwv_flow_imp.g_varchar2_table(24669) := '626C65446966665669657765723A794C28652E6F6E6C7953686F7741636365737369626C65446966665669657765722C742E6F6E6C7953686F7741636365737369626C6544696666566965776572292C72656E64657253696465427953696465496E6C69';
wwv_flow_imp.g_varchar2_table(24670) := '6E65427265616B706F696E743A434C28652E72656E64657253696465427953696465496E6C696E65427265616B706F696E742C742E72656E64657253696465427953696465496E6C696E65427265616B706F696E742C302C31303733373431383234292C';
wwv_flow_imp.g_varchar2_table(24671) := '757365496E6C696E65566965775768656E537061636549734C696D697465643A794C28652E757365496E6C696E65566965775768656E537061636549734C696D697465642C742E757365496E6C696E65566965775768656E537061636549734C696D6974';
wwv_flow_imp.g_varchar2_table(24672) := '6564292C72656E6465724775747465724D656E753A794C28652E72656E6465724775747465724D656E752C742E72656E6465724775747465724D656E75297D7D54583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E';
wwv_flow_imp.g_varchar2_table(24673) := '74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C6563742626226675';
wwv_flow_imp.g_varchar2_table(24674) := '6E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D65';
wwv_flow_imp.g_varchar2_table(24675) := '5B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(24676) := '28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28312C5953295D2C5458293B766172204D583D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D';
wwv_flow_imp.g_varchar2_table(24677) := '7D3B6C65742041583D636C61737320657874656E64732044587B676574206F6E446964436F6E74656E7453697A654368616E676528297B72657475726E20746869732E5F656469746F72732E6F6E446964436F6E74656E7453697A654368616E67657D63';
wwv_flow_imp.g_varchar2_table(24678) := '6F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B766172206C3B737570657228292C746869732E5F646F6D456C656D656E743D652C746869732E5F706172656E74436F6E746578744B6579536572766963653D692C746869732E5F70';
wwv_flow_imp.g_varchar2_table(24679) := '6172656E74496E7374616E74696174696F6E536572766963653D6F2C746869732E5F6163636573736962696C6974795369676E616C536572766963653D722C746869732E5F656469746F7250726F6772657373536572766963653D612C746869732E656C';
wwv_flow_imp.g_varchar2_table(24680) := '656D656E74733D497228226469762E6D6F6E61636F2D646966662D656469746F722E736964652D62792D73696465222C7B7374796C653A7B706F736974696F6E3A2272656C6174697665222C6865696768743A2231303025227D7D2C5B49722822646976';
wwv_flow_imp.g_varchar2_table(24681) := '2E656469746F722E6F726967696E616C406F726967696E616C222C7B7374796C653A7B706F736974696F6E3A226162736F6C757465222C6865696768743A2231303025227D7D292C497228226469762E656469746F722E6D6F646966696564406D6F6469';
wwv_flow_imp.g_varchar2_table(24682) := '66696564222C7B7374796C653A7B706F736974696F6E3A226162736F6C757465222C6865696768743A2231303025227D7D292C497228226469762E61636365737369626C65446966665669657765724061636365737369626C6544696666566965776572';
wwv_flow_imp.g_varchar2_table(24683) := '222C7B7374796C653A7B706F736974696F6E3A226162736F6C757465222C6865696768743A2231303025227D7D295D292C746869732E5F646966664D6F64656C3D245428746869732C766F69642030292C746869732E5F73686F756C64446973706F7365';
wwv_flow_imp.g_varchar2_table(24684) := '446966664D6F64656C3D21312C746869732E6F6E4469644368616E67654D6F64656C3D76742E66726F6D4F627365727661626C654C6967687428746869732E5F646966664D6F64656C292C746869732E5F636F6E746578744B6579536572766963653D74';
wwv_flow_imp.g_varchar2_table(24685) := '6869732E5F726567697374657228746869732E5F706172656E74436F6E746578744B6579536572766963652E63726561746553636F70656428746869732E5F646F6D456C656D656E7429292C746869732E5F696E7374616E74696174696F6E5365727669';
wwv_flow_imp.g_varchar2_table(24686) := '63653D746869732E5F706172656E74496E7374616E74696174696F6E536572766963652E6372656174654368696C64286E6577207842285B63642C746869732E5F636F6E746578744B6579536572766963655D29292C746869732E5F626F756E64617279';
wwv_flow_imp.g_varchar2_table(24687) := '5361736865733D245428746869732C766F69642030292C746869732E5F61636365737369626C654469666656696577657253686F756C64426556697369626C653D245428746869732C2131292C746869732E5F61636365737369626C6544696666566965';
wwv_flow_imp.g_varchar2_table(24688) := '77657256697369626C653D515428746869732C28653D3E2121746869732E5F6F7074696F6E732E6F6E6C7953686F7741636365737369626C65446966665669657765722E726561642865297C7C746869732E5F61636365737369626C6544696666566965';
wwv_flow_imp.g_varchar2_table(24689) := '77657253686F756C64426556697369626C652E7265616428652929292C746869732E5F6D6F766564426C6F636B734C696E6573506172743D245428746869732C766F69642030292C746869732E5F6C61796F7574496E666F3D515428746869732C28653D';
wwv_flow_imp.g_varchar2_table(24690) := '3E7B76617220742C6E2C692C6F2C733B636F6E737420723D746869732E5F726F6F7453697A654F627365727665722E77696474682E726561642865292C613D746869732E5F726F6F7453697A654F627365727665722E6865696768742E72656164286529';
wwv_flow_imp.g_varchar2_table(24691) := '2C6C3D746869732E5F736173682E726561642865292C633D746869732E5F6775747465722E726561642865292C643D6E756C6C213D3D28743D6E756C6C3D3D633F766F696420303A632E77696474682E72656164286529292626766F69642030213D3D74';
wwv_flow_imp.g_varchar2_table(24692) := '3F743A302C683D6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F6F7665727669657752756C6572506172742E72656164286529297C7C766F696420303D3D3D6E3F766F696420303A6E2E7769647468292626766F69642030213D3D693F';
wwv_flow_imp.g_varchar2_table(24693) := '693A303B6C657420752C702C672C6D2C663B6966286C297B636F6E737420743D6C2E736173684C6566742E726561642865293B753D302C703D742D642D286E756C6C213D3D28733D6E756C6C3D3D3D286F3D746869732E5F6D6F766564426C6F636B734C';
wwv_flow_imp.g_varchar2_table(24694) := '696E6573506172742E72656164286529297C7C766F696420303D3D3D6F3F766F696420303A6F2E77696474682E72656164286529292626766F69642030213D3D733F733A30292C663D742D642C673D742C6D3D722D672D687D656C736520663D302C753D';
wwv_flow_imp.g_varchar2_table(24695) := '642C703D4D6174682E6D617828352C746869732E5F656469746F72732E6F726967696E616C2E6765744C61796F7574496E666F28292E6465636F726174696F6E734C656674292C673D642B702C6D3D722D672D683B72657475726E20746869732E656C65';
wwv_flow_imp.g_varchar2_table(24696) := '6D656E74732E6F726967696E616C2E7374796C652E6C6566743D752B227078222C746869732E656C656D656E74732E6F726967696E616C2E7374796C652E77696474683D702B227078222C746869732E5F656469746F72732E6F726967696E616C2E6C61';
wwv_flow_imp.g_varchar2_table(24697) := '796F7574287B77696474683A702C6865696768743A617D2C2130292C6E756C6C3D3D637C7C632E6C61796F75742866292C746869732E656C656D656E74732E6D6F6469666965642E7374796C652E6C6566743D672B227078222C746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(24698) := '6E74732E6D6F6469666965642E7374796C652E77696474683D6D2B227078222C746869732E5F656469746F72732E6D6F6469666965642E6C61796F7574287B77696474683A6D2C6865696768743A617D2C2130292C7B6D6F646966696564456469746F72';
wwv_flow_imp.g_varchar2_table(24699) := '3A746869732E5F656469746F72732E6D6F6469666965642E6765744C61796F7574496E666F28292C6F726967696E616C456469746F723A746869732E5F656469746F72732E6F726967696E616C2E6765744C61796F7574496E666F28297D7D29292C7468';
wwv_flow_imp.g_varchar2_table(24700) := '69732E5F6469666656616C75653D746869732E5F646966664D6F64656C2E6D6170282828652C74293D3E6E756C6C3D3D653F766F696420303A652E646966662E7265616428742929292C746869732E6F6E446964557064617465446966663D76742E6672';
wwv_flow_imp.g_varchar2_table(24701) := '6F6D4F627365727661626C654C6967687428746869732E5F6469666656616C7565292C732E77696C6C43726561746544696666456469746F7228292C746869732E5F636F6E746578744B6579536572766963652E6372656174654B657928226973496E44';
wwv_flow_imp.g_varchar2_table(24702) := '696666456469746F72222C2130292C746869732E5F646F6D456C656D656E742E617070656E644368696C6428746869732E656C656D656E74732E726F6F74292C746869732E5F7265676973746572287274282828293D3E746869732E5F646F6D456C656D';
wwv_flow_imp.g_varchar2_table(24703) := '656E742E72656D6F76654368696C6428746869732E656C656D656E74732E726F6F74292929292C746869732E5F726F6F7453697A654F627365727665723D746869732E5F7265676973746572286E657720715928746869732E656C656D656E74732E726F';
wwv_flow_imp.g_varchar2_table(24704) := '6F742C742E64696D656E73696F6E29292C746869732E5F726F6F7453697A654F627365727665722E7365744175746F6D617469634C61796F7574286E756C6C213D3D286C3D742E6175746F6D617469634C61796F7574292626766F69642030213D3D6C26';
wwv_flow_imp.g_varchar2_table(24705) := '266C292C746869732E5F6F7074696F6E733D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652854582C74292C746869732E5F72656769737465722865492828653D3E7B746869732E5F6F7074696F';
wwv_flow_imp.g_varchar2_table(24706) := '6E732E736574576964746828746869732E5F726F6F7453697A654F627365727665722E77696474682E72656164286529297D2929292C746869732E5F636F6E746578744B6579536572766963652E6372656174654B6579286C682E6973456D6265646465';
wwv_flow_imp.g_varchar2_table(24707) := '6444696666456469746F722E6B65792C2131292C746869732E5F726567697374657228655A286C682E6973456D62656464656444696666456469746F722C746869732E5F636F6E746578744B6579536572766963652C28653D3E746869732E5F6F707469';
wwv_flow_imp.g_varchar2_table(24708) := '6F6E732E6973496E456D626564646564456469746F722E726561642865292929292C746869732E5F726567697374657228655A286C682E636F6D706172696E674D6F766564436F64652C746869732E5F636F6E746578744B6579536572766963652C2865';
wwv_flow_imp.g_varchar2_table(24709) := '3D3E7B76617220743B72657475726E2121286E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6D6F76656454657874546F436F6D706172652E72656164286529';
wwv_flow_imp.g_varchar2_table(24710) := '297D2929292C746869732E5F726567697374657228655A286C682E64696666456469746F7252656E64657253696465427953696465496E6C696E65427265616B706F696E74526561636865642C746869732E5F636F6E746578744B657953657276696365';
wwv_flow_imp.g_varchar2_table(24711) := '2C28653D3E746869732E5F6F7074696F6E732E636F756C6453686F77496E6C696E6556696577426563617573654F6653697A652E726561642865292929292C746869732E5F726567697374657228655A286C682E64696666456469746F72496E6C696E65';
wwv_flow_imp.g_varchar2_table(24712) := '4D6F64652C746869732E5F636F6E746578744B6579536572766963652C28653D3E21746869732E5F6F7074696F6E732E72656E646572536964654279536964652E726561642865292929292C746869732E5F726567697374657228655A286C682E686173';
wwv_flow_imp.g_varchar2_table(24713) := '4368616E6765732C746869732E5F636F6E746578744B6579536572766963652C28653D3E7B76617220742C6E2C693B72657475726E286E756C6C213D3D28693D6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E';
wwv_flow_imp.g_varchar2_table(24714) := '72656164286529297C7C766F696420303D3D3D743F766F696420303A742E646966662E72656164286529297C7C766F696420303D3D3D6E3F766F696420303A6E2E6D617070696E67732E6C656E677468292626766F69642030213D3D693F693A30293E30';
wwv_flow_imp.g_varchar2_table(24715) := '7D2929292C746869732E5F656469746F72733D746869732E5F726567697374657228746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365284C582C746869732E656C656D656E74732E6F726967696E61';
wwv_flow_imp.g_varchar2_table(24716) := '6C2C746869732E656C656D656E74732E6D6F6469666965642C746869732E5F6F7074696F6E732C6E2C2828652C742C6E2C69293D3E746869732E5F637265617465496E6E6572456469746F7228652C742C6E2C69292929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(24717) := '74657228655A286C682E64696666456469746F724F726967696E616C5772697461626C652C746869732E5F636F6E746578744B6579536572766963652C28653D3E746869732E5F6F7074696F6E732E6F726967696E616C4564697461626C652E72656164';
wwv_flow_imp.g_varchar2_table(24718) := '2865292929292C746869732E5F726567697374657228655A286C682E64696666456469746F724D6F6469666965645772697461626C652C746869732E5F636F6E746578744B6579536572766963652C28653D3E21746869732E5F6F7074696F6E732E7265';
wwv_flow_imp.g_varchar2_table(24719) := '61644F6E6C792E726561642865292929292C746869732E5F726567697374657228655A286C682E64696666456469746F724F726967696E616C5572692C746869732E5F636F6E746578744B6579536572766963652C28653D3E7B76617220742C6E3B7265';
wwv_flow_imp.g_varchar2_table(24720) := '7475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6D6F64656C2E6F726967696E616C2E7572692E746F537472696E672829';
wwv_flow_imp.g_varchar2_table(24721) := '292626766F69642030213D3D6E3F6E3A22227D2929292C746869732E5F726567697374657228655A286C682E64696666456469746F724D6F6469666965645572692C746869732E5F636F6E746578744B6579536572766963652C28653D3E7B7661722074';
wwv_flow_imp.g_varchar2_table(24722) := '2C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6D6F64656C2E6D6F6469666965642E7572692E746F537472';
wwv_flow_imp.g_varchar2_table(24723) := '696E672829292626766F69642030213D3D6E3F6E3A22227D2929292C746869732E5F6F7665727669657752756C6572506172743D585428746869732C28653D3E746869732E5F6F7074696F6E732E72656E6465724F7665727669657752756C65722E7265';
wwv_flow_imp.g_varchar2_table(24724) := '61642865293F746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652859592877582C65292C746869732E5F656469746F72732C746869732E656C656D656E74732E726F6F742C746869732E5F64696666';
wwv_flow_imp.g_varchar2_table(24725) := '4D6F64656C2C746869732E5F726F6F7453697A654F627365727665722E77696474682C746869732E5F726F6F7453697A654F627365727665722E6865696768742C746869732E5F6C61796F7574496E666F2E6D61702828653D3E652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(24726) := '456469746F722929293A766F6964203029292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F7265292C746869732E5F736173683D585428746869732C28653D3E7B636F6E737420743D746869732E5F';
wwv_flow_imp.g_varchar2_table(24727) := '6F7074696F6E732E72656E646572536964654279536964652E726561642865293B72657475726E20746869732E656C656D656E74732E726F6F742E636C6173734C6973742E746F67676C652822736964652D62792D73696465222C74292C743F6E657720';
wwv_flow_imp.g_varchar2_table(24728) := '565A28746869732E5F6F7074696F6E732C746869732E656C656D656E74732E726F6F742C7B6865696768743A746869732E5F726F6F7453697A654F627365727665722E6865696768742C77696474683A746869732E5F726F6F7453697A654F6273657276';
wwv_flow_imp.g_varchar2_table(24729) := '65722E77696474682E6D6170282828652C74293D3E7B766172206E2C693B72657475726E20652D286E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F6F7665727669657752756C6572506172742E72656164287429297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(24730) := '3D3D3D6E3F766F696420303A6E2E7769647468292626766F69642030213D3D693F693A30297D29297D2C746869732E5F626F756E64617279536173686573293A766F696420307D29292E7265636F6D70757465496E697469616C6C79416E644F6E436861';
wwv_flow_imp.g_varchar2_table(24731) := '6E676528746869732E5F73746F7265293B636F6E737420633D585428746869732C28653D3E746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652859592862582C65292C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(24732) := '732C746869732E5F646966664D6F64656C2C746869732E5F6F7074696F6E732929292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F7265293B585428746869732C28653D3E746869732E5F696E7374';
wwv_flow_imp.g_varchar2_table(24733) := '616E74696174696F6E536572766963652E637265617465496E7374616E636528595928425A2C65292C746869732E5F656469746F72732C746869732E5F646966664D6F64656C2C746869732E5F6F7074696F6E732C746869732929292E7265636F6D7075';
wwv_flow_imp.g_varchar2_table(24734) := '7465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F7265293B636F6E737420643D6E6577205365742C683D6E6577205365743B6C657420753D21313B636F6E737420703D585428746869732C28653D3E746869732E5F696E73';
wwv_flow_imp.g_varchar2_table(24735) := '74616E74696174696F6E536572766963652E637265617465496E7374616E6365285959286F582C65292C727328746869732E5F646F6D456C656D656E74292C746869732E5F656469746F72732C746869732E5F646966664D6F64656C2C746869732E5F6F';
wwv_flow_imp.g_varchar2_table(24736) := '7074696F6E732C746869732C2828293D3E757C7C632E67657428292E69735570646174696E6748696464656E4172656173292C642C682929292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F726529';
wwv_flow_imp.g_varchar2_table(24737) := '2C673D515428746869732C28653D3E7B636F6E737420743D702E726561642865292E766965775A6F6E65732E726561642865292E6F7269672C6E3D632E726561642865292E766965775A6F6E65732E726561642865292E6F726967566965775A6F6E6573';
wwv_flow_imp.g_varchar2_table(24738) := '3B72657475726E20742E636F6E636174286E297D29292C6D3D515428746869732C28653D3E7B636F6E737420743D702E726561642865292E766965775A6F6E65732E726561642865292E6D6F642C6E3D632E726561642865292E766965775A6F6E65732E';
wwv_flow_imp.g_varchar2_table(24739) := '726561642865292E6D6F64566965775A6F6E65733B72657475726E20742E636F6E636174286E297D29293B6C657420663B746869732E5F7265676973746572285A5928746869732E5F656469746F72732E6F726967696E616C2C672C28653D3E7B753D65';
wwv_flow_imp.g_varchar2_table(24740) := '7D292C6429292C746869732E5F7265676973746572285A5928746869732E5F656469746F72732E6D6F6469666965642C6D2C28653D3E7B753D652C753F663D48422E6361707475726528746869732E5F656469746F72732E6D6F646966696564293A286E';
wwv_flow_imp.g_varchar2_table(24741) := '756C6C3D3D667C7C662E726573746F726528746869732E5F656469746F72732E6D6F646966696564292C663D766F69642030297D292C6829292C746869732E5F61636365737369626C65446966665669657765723D585428746869732C28653D3E746869';
wwv_flow_imp.g_varchar2_table(24742) := '732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528595928755A2C65292C746869732E656C656D656E74732E61636365737369626C65446966665669657765722C746869732E5F61636365737369626C6544';
wwv_flow_imp.g_varchar2_table(24743) := '69666656696577657256697369626C652C2828652C74293D3E746869732E5F61636365737369626C654469666656696577657253686F756C64426556697369626C652E73657428652C7429292C746869732E5F6F7074696F6E732E6F6E6C7953686F7741';
wwv_flow_imp.g_varchar2_table(24744) := '636365737369626C65446966665669657765722E6D61702828653D3E216529292C746869732E5F726F6F7453697A654F627365727665722E77696474682C746869732E5F726F6F7453697A654F627365727665722E6865696768742C746869732E5F6469';
wwv_flow_imp.g_varchar2_table(24745) := '66664D6F64656C2E6D6170282828652C74293D3E7B766172206E3B72657475726E206E756C6C3D3D3D286E3D6E756C6C3D3D653F766F696420303A652E646966662E72656164287429297C7C766F696420303D3D3D6E3F766F696420303A6E2E6D617070';
wwv_flow_imp.g_varchar2_table(24746) := '696E67732E6D61702828653D3E652E6C696E6552616E67654D617070696E6729297D29292C6E657720435A28746869732E5F656469746F7273292929292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F7374';
wwv_flow_imp.g_varchar2_table(24747) := '6F7265293B636F6E737420763D746869732E5F61636365737369626C654469666656696577657256697369626C652E6D61702828653D3E653F2268696464656E223A2276697369626C652229293B746869732E5F72656769737465722851592874686973';
wwv_flow_imp.g_varchar2_table(24748) := '2E656C656D656E74732E6D6F6469666965642C7B7669736962696C6974793A767D29292C746869732E5F726567697374657228515928746869732E656C656D656E74732E6F726967696E616C2C7B7669736962696C6974793A767D29292C746869732E5F';
wwv_flow_imp.g_varchar2_table(24749) := '63726561746544696666456469746F72436F6E747269627574696F6E7328292C732E61646444696666456469746F722874686973292C746869732E5F6775747465723D585428746869732C28653D3E746869732E5F6F7074696F6E732E73686F756C6452';
wwv_flow_imp.g_varchar2_table(24750) := '656E6465724775747465724D656E752E726561642865293F746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652859592867582C65292C746869732E656C656D656E74732E726F6F742C746869732E5F';
wwv_flow_imp.g_varchar2_table(24751) := '646966664D6F64656C2C746869732E5F656469746F7273293A766F6964203029292C746869732E5F726567697374657228704928746869732E5F6C61796F7574496E666F29292C585428746869732C28653D3E6E657728595928535A2C65292928746869';
wwv_flow_imp.g_varchar2_table(24752) := '732E656C656D656E74732E726F6F742C746869732E5F646966664D6F64656C2C746869732E5F6C61796F7574496E666F2E6D61702828653D3E652E6F726967696E616C456469746F7229292C746869732E5F6C61796F7574496E666F2E6D61702828653D';
wwv_flow_imp.g_varchar2_table(24753) := '3E652E6D6F646966696564456469746F7229292C746869732E5F656469746F72732929292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F72652C28653D3E7B746869732E5F6D6F766564426C6F636B';
wwv_flow_imp.g_varchar2_table(24754) := '734C696E6573506172742E73657428652C766F69642030297D29292C746869732E5F72656769737465722876742E72756E416E6453756273637269626528746869732E5F656469746F72732E6D6F6469666965642E6F6E4469644368616E676543757273';
wwv_flow_imp.g_varchar2_table(24755) := '6F72506F736974696F6E2C28653D3E746869732E5F68616E646C65437572736F72506F736974696F6E4368616E676528652C2130292929292C746869732E5F72656769737465722876742E72756E416E6453756273637269626528746869732E5F656469';
wwv_flow_imp.g_varchar2_table(24756) := '746F72732E6F726967696E616C2E6F6E4469644368616E6765437572736F72506F736974696F6E2C28653D3E746869732E5F68616E646C65437572736F72506F736974696F6E4368616E676528652C2131292929293B636F6E737420623D746869732E5F';
wwv_flow_imp.g_varchar2_table(24757) := '646966664D6F64656C2E6D617028746869732C2828652C74293D3E7B696628652972657475726E20766F696420303D3D3D652E646966662E72656164287429262621652E6973446966665570546F446174652E726561642874297D29293B746869732E5F';
wwv_flow_imp.g_varchar2_table(24758) := '7265676973746572286949282828652C74293D3E7B69662821303D3D3D622E72656164286529297B636F6E737420653D746869732E5F656469746F7250726F6772657373536572766963652E73686F772821302C316533293B742E616464287274282828';
wwv_flow_imp.g_varchar2_table(24759) := '293D3E652E646F6E6528292929297D7D2929292C746869732E5F7265676973746572287274282828293D3E7B76617220653B746869732E5F73686F756C64446973706F7365446966664D6F64656C2626286E756C6C3D3D3D28653D746869732E5F646966';
wwv_flow_imp.g_varchar2_table(24760) := '664D6F64656C2E6765742829297C7C766F696420303D3D3D657C7C652E646973706F73652829297D2929292C746869732E5F7265676973746572286949282828652C74293D3E7B742E616464286E65772859592853582C65292928746869732E5F656469';
wwv_flow_imp.g_varchar2_table(24761) := '746F72732C746869732E5F646966664D6F64656C2C746869732E5F6F7074696F6E732C7468697329297D2929297D5F637265617465496E6E6572456469746F7228652C742C6E2C69297B72657475726E20652E637265617465496E7374616E6365284C42';
wwv_flow_imp.g_varchar2_table(24762) := '2C742C6E2C69297D5F63726561746544696666456469746F72436F6E747269627574696F6E7328297B636F6E737420653D65682E67657444696666456469746F72436F6E747269627574696F6E7328293B666F7228636F6E73742074206F662065297472';
wwv_flow_imp.g_varchar2_table(24763) := '797B746869732E5F726567697374657228746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528742E63746F722C7468697329297D63617463682865297B6B652865297D7D676574205F746172676574';
wwv_flow_imp.g_varchar2_table(24764) := '456469746F7228297B72657475726E20746869732E5F656469746F72732E6D6F6469666965647D676574456469746F725479706528297B72657475726E2071522E4944696666456469746F727D6C61796F75742865297B746869732E5F726F6F7453697A';
wwv_flow_imp.g_varchar2_table(24765) := '654F627365727665722E6F6273657276652865297D68617354657874466F63757328297B72657475726E20746869732E5F656469746F72732E6F726967696E616C2E68617354657874466F63757328297C7C746869732E5F656469746F72732E6D6F6469';
wwv_flow_imp.g_varchar2_table(24766) := '666965642E68617354657874466F63757328297D7361766556696577537461746528297B76617220653B72657475726E7B6F726967696E616C3A746869732E5F656469746F72732E6F726967696E616C2E7361766556696577537461746528292C6D6F64';
wwv_flow_imp.g_varchar2_table(24767) := '69666965643A746869732E5F656469746F72732E6D6F6469666965642E7361766556696577537461746528292C6D6F64656C53746174653A6E756C6C3D3D3D28653D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D65';
wwv_flow_imp.g_varchar2_table(24768) := '3F766F696420303A652E73657269616C697A65537461746528297D7D726573746F72655669657753746174652865297B76617220743B696628652626652E6F726967696E616C2626652E6D6F646966696564297B636F6E7374206E3D653B746869732E5F';
wwv_flow_imp.g_varchar2_table(24769) := '656469746F72732E6F726967696E616C2E726573746F7265566965775374617465286E2E6F726967696E616C292C746869732E5F656469746F72732E6D6F6469666965642E726573746F7265566965775374617465286E2E6D6F646966696564292C6E2E';
wwv_flow_imp.g_varchar2_table(24770) := '6D6F64656C53746174652626286E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D747C7C742E726573746F726553657269616C697A65645374617465286E2E6D6F64656C537461746529297D7D';
wwv_flow_imp.g_varchar2_table(24771) := '68616E646C65496E697469616C697A656428297B746869732E5F656469746F72732E6F726967696E616C2E68616E646C65496E697469616C697A656428292C746869732E5F656469746F72732E6D6F6469666965642E68616E646C65496E697469616C69';
wwv_flow_imp.g_varchar2_table(24772) := '7A656428297D637265617465566965774D6F64656C2865297B72657475726E20746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365284B5A2C652C746869732E5F6F7074696F6E73297D6765744D6F64';
wwv_flow_imp.g_varchar2_table(24773) := '656C28297B76617220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D653F766F696420303A652E6D6F64656C292626766F69642030213D';
wwv_flow_imp.g_varchar2_table(24774) := '3D743F743A6E756C6C7D7365744D6F64656C28652C74297B21652626746869732E5F646966664D6F64656C2E67657428292626746869732E5F61636365737369626C65446966665669657765722E67657428292E636C6F736528293B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(24775) := '653F226D6F64656C22696E20653F7B6D6F64656C3A652C73686F756C64446973706F73653A21317D3A7B6D6F64656C3A746869732E637265617465566965774D6F64656C2865292C73686F756C64446973706F73653A21307D3A766F696420303B746869';
wwv_flow_imp.g_varchar2_table(24776) := '732E5F646966664D6F64656C2E6765742829213D3D286E756C6C3D3D6E3F766F696420303A6E2E6D6F64656C2926266A5428742C28653D3E7B76617220743B61492E62617463684576656E7473476C6F62616C6C7928652C2828293D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(24777) := '656469746F72732E6F726967696E616C2E7365744D6F64656C286E3F6E2E6D6F64656C2E6D6F64656C2E6F726967696E616C3A6E756C6C292C746869732E5F656469746F72732E6D6F6469666965642E7365744D6F64656C286E3F6E2E6D6F64656C2E6D';
wwv_flow_imp.g_varchar2_table(24778) := '6F64656C2E6D6F6469666965643A6E756C6C297D29293B636F6E737420693D746869732E5F646966664D6F64656C2E67657428292C6F3D746869732E5F73686F756C64446973706F7365446966664D6F64656C3B746869732E5F73686F756C6444697370';
wwv_flow_imp.g_varchar2_table(24779) := '6F7365446966664D6F64656C3D6E756C6C213D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E73686F756C64446973706F7365292626766F69642030213D3D742626742C746869732E5F646966664D6F64656C2E736574286E756C6C3D3D6E3F766F';
wwv_flow_imp.g_varchar2_table(24780) := '696420303A6E2E6D6F64656C2C65292C6F2626286E756C6C3D3D697C7C692E646973706F73652829297D29297D7570646174654F7074696F6E732865297B746869732E5F6F7074696F6E732E7570646174654F7074696F6E732865297D676574436F6E74';
wwv_flow_imp.g_varchar2_table(24781) := '61696E6572446F6D4E6F646528297B72657475726E20746869732E5F646F6D456C656D656E747D6765744F726967696E616C456469746F7228297B72657475726E20746869732E5F656469746F72732E6F726967696E616C7D6765744D6F646966696564';
wwv_flow_imp.g_varchar2_table(24782) := '456469746F7228297B72657475726E20746869732E5F656469746F72732E6D6F6469666965647D6765744C696E654368616E67657328297B76617220653B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F646966664D6F64656C2E67657428';
wwv_flow_imp.g_varchar2_table(24783) := '29297C7C766F696420303D3D3D653F766F696420303A652E646966662E67657428293B72657475726E20743F742E6D617070696E67732E6D61702828653D3E7B636F6E737420743D652E6C696E6552616E67654D617070696E673B6C6574206E2C692C6F';
wwv_flow_imp.g_varchar2_table(24784) := '2C732C723D742E696E6E65724368616E6765733B72657475726E20742E6F726967696E616C2E6973456D7074793F286E3D742E6F726967696E616C2E73746172744C696E654E756D6265722D312C693D302C723D766F69642030293A286E3D742E6F7269';
wwv_flow_imp.g_varchar2_table(24785) := '67696E616C2E73746172744C696E654E756D6265722C693D742E6F726967696E616C2E656E644C696E654E756D6265724578636C75736976652D31292C742E6D6F6469666965642E6973456D7074793F286F3D742E6D6F6469666965642E73746172744C';
wwv_flow_imp.g_varchar2_table(24786) := '696E654E756D6265722D312C733D302C723D766F69642030293A286F3D742E6D6F6469666965642E73746172744C696E654E756D6265722C733D742E6D6F6469666965642E656E644C696E654E756D6265724578636C75736976652D31292C7B6F726967';
wwv_flow_imp.g_varchar2_table(24787) := '696E616C53746172744C696E654E756D6265723A6E2C6F726967696E616C456E644C696E654E756D6265723A692C6D6F64696669656453746172744C696E654E756D6265723A6F2C6D6F646966696564456E644C696E654E756D6265723A732C63686172';
wwv_flow_imp.g_varchar2_table(24788) := '4368616E6765733A6E756C6C3D3D723F766F696420303A722E6D61702828653D3E287B6F726967696E616C53746172744C696E654E756D6265723A652E6F726967696E616C52616E67652E73746172744C696E654E756D6265722C6F726967696E616C53';
wwv_flow_imp.g_varchar2_table(24789) := '74617274436F6C756D6E3A652E6F726967696E616C52616E67652E7374617274436F6C756D6E2C6F726967696E616C456E644C696E654E756D6265723A652E6F726967696E616C52616E67652E656E644C696E654E756D6265722C6F726967696E616C45';
wwv_flow_imp.g_varchar2_table(24790) := '6E64436F6C756D6E3A652E6F726967696E616C52616E67652E656E64436F6C756D6E2C6D6F64696669656453746172744C696E654E756D6265723A652E6D6F64696669656452616E67652E73746172744C696E654E756D6265722C6D6F64696669656453';
wwv_flow_imp.g_varchar2_table(24791) := '74617274436F6C756D6E3A652E6D6F64696669656452616E67652E7374617274436F6C756D6E2C6D6F646966696564456E644C696E654E756D6265723A652E6D6F64696669656452616E67652E656E644C696E654E756D6265722C6D6F64696669656445';
wwv_flow_imp.g_varchar2_table(24792) := '6E64436F6C756D6E3A652E6D6F64696669656452616E67652E656E64436F6C756D6E7D2929297D7D29293A6E756C6C7D7265766572742865297B636F6E737420743D746869732E5F646966664D6F64656C2E67657428293B742626742E69734469666655';
wwv_flow_imp.g_varchar2_table(24793) := '70546F446174652E67657428292626746869732E5F656469746F72732E6D6F6469666965642E657865637574654564697473282264696666456469746F72222C5B7B72616E67653A652E6D6F6469666965642E746F4578636C757369766552616E676528';
wwv_flow_imp.g_varchar2_table(24794) := '292C746578743A742E6D6F64656C2E6F726967696E616C2E67657456616C7565496E52616E676528652E6F726967696E616C2E746F4578636C757369766552616E67652829297D5D297D72657665727452616E67654D617070696E67732865297B636F6E';
wwv_flow_imp.g_varchar2_table(24795) := '737420743D746869732E5F646966664D6F64656C2E67657428293B69662821747C7C21742E6973446966665570546F446174652E67657428292972657475726E3B636F6E7374206E3D652E6D61702828653D3E287B72616E67653A652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(24796) := '6452616E67652C746578743A742E6D6F64656C2E6F726967696E616C2E67657456616C7565496E52616E676528652E6F726967696E616C52616E6765297D2929293B746869732E5F656469746F72732E6D6F6469666965642E6578656375746545646974';
wwv_flow_imp.g_varchar2_table(24797) := '73282264696666456469746F72222C6E297D5F676F546F2865297B746869732E5F656469746F72732E6D6F6469666965642E736574506F736974696F6E286E6577206D6328652E6C696E6552616E67654D617070696E672E6D6F6469666965642E737461';
wwv_flow_imp.g_varchar2_table(24798) := '72744C696E654E756D6265722C3129292C746869732E5F656469746F72732E6D6F6469666965642E72657665616C52616E6765496E43656E74657228652E6C696E6552616E67654D617070696E672E6D6F6469666965642E746F4578636C757369766552';
wwv_flow_imp.g_varchar2_table(24799) := '616E67652829297D676F546F446966662865297B76617220742C6E2C692C6F3B636F6E737420733D6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D743F766F696420';
wwv_flow_imp.g_varchar2_table(24800) := '303A742E646966662E6765742829297C7C766F696420303D3D3D6E3F766F696420303A6E2E6D617070696E67733B69662821737C7C303D3D3D732E6C656E6774682972657475726E3B636F6E737420723D746869732E5F656469746F72732E6D6F646966';
wwv_flow_imp.g_varchar2_table(24801) := '6965642E676574506F736974696F6E28292E6C696E654E756D6265723B6C657420613B613D226E657874223D3D3D653F6E756C6C213D3D28693D732E66696E642828653D3E652E6C696E6552616E67654D617070696E672E6D6F6469666965642E737461';
wwv_flow_imp.g_varchar2_table(24802) := '72744C696E654E756D6265723E722929292626766F69642030213D3D693F693A735B305D3A6E756C6C213D3D286F3D767528732C28653D3E652E6C696E6552616E67654D617070696E672E6D6F6469666965642E73746172744C696E654E756D6265723C';
wwv_flow_imp.g_varchar2_table(24803) := '722929292626766F69642030213D3D6F3F6F3A735B732E6C656E6774682D315D2C746869732E5F676F546F2861292C612E6C696E6552616E67654D617070696E672E6D6F6469666965642E6973456D7074793F746869732E5F6163636573736962696C69';
wwv_flow_imp.g_varchar2_table(24804) := '74795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E6544656C657465642C7B736F757263653A2264696666456469746F722E676F546F44696666227D293A612E6C696E6552616E67654D617070696E672E6F7269';
wwv_flow_imp.g_varchar2_table(24805) := '67696E616C2E6973456D7074793F746869732E5F6163636573736962696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E65496E7365727465642C7B736F757263653A2264696666456469746F722E676F';
wwv_flow_imp.g_varchar2_table(24806) := '546F44696666227D293A612626746869732E5F6163636573736962696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E654D6F6469666965642C7B736F757263653A2264696666456469746F722E676F54';
wwv_flow_imp.g_varchar2_table(24807) := '6F44696666227D297D72657665616C46697273744469666628297B636F6E737420653D746869732E5F646966664D6F64656C2E67657428293B652626746869732E77616974466F724469666628292E7468656E282828293D3E7B76617220743B636F6E73';
wwv_flow_imp.g_varchar2_table(24808) := '74206E3D6E756C6C3D3D3D28743D652E646966662E6765742829297C7C766F696420303D3D3D743F766F696420303A742E6D617070696E67733B6E262630213D3D6E2E6C656E6774682626746869732E5F676F546F286E5B305D297D29297D6163636573';
wwv_flow_imp.g_varchar2_table(24809) := '7369626C65446966665669657765724E65787428297B746869732E5F61636365737369626C65446966665669657765722E67657428292E6E65787428297D61636365737369626C65446966665669657765725072657628297B746869732E5F6163636573';
wwv_flow_imp.g_varchar2_table(24810) := '7369626C65446966665669657765722E67657428292E7072657628297D6173796E632077616974466F724469666628297B636F6E737420653D746869732E5F646966664D6F64656C2E67657428293B652626617761697420652E77616974466F72446966';
wwv_flow_imp.g_varchar2_table(24811) := '6628297D6D6170546F4F746865725369646528297B76617220652C743B636F6E7374206E3D746869732E5F656469746F72732E6D6F6469666965642E686173576964676574466F63757328292C693D6E3F746869732E5F656469746F72732E6D6F646966';
wwv_flow_imp.g_varchar2_table(24812) := '6965643A746869732E5F656469746F72732E6F726967696E616C2C6F3D6E3F746869732E5F656469746F72732E6F726967696E616C3A746869732E5F656469746F72732E6D6F6469666965643B6C657420733B636F6E737420723D692E67657453656C65';
wwv_flow_imp.g_varchar2_table(24813) := '6374696F6E28293B69662872297B636F6E737420693D6E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D653F766F696420303A652E646966662E6765742829297C7C76';
wwv_flow_imp.g_varchar2_table(24814) := '6F696420303D3D3D743F766F696420303A742E6D617070696E67732E6D61702828653D3E6E3F652E6C696E6552616E67654D617070696E672E666C697028293A652E6C696E6552616E67654D617070696E6729293B69662869297B636F6E737420653D4A';
wwv_flow_imp.g_varchar2_table(24815) := '5928722E6765745374617274506F736974696F6E28292C69292C743D4A5928722E676574456E64506F736974696F6E28292C69293B733D72682E706C757352616E676528652C74297D7D72657475726E7B64657374696E6174696F6E3A6F2C6465737469';
wwv_flow_imp.g_varchar2_table(24816) := '6E6174696F6E53656C656374696F6E3A737D7D7377697463685369646528297B636F6E73747B64657374696E6174696F6E3A652C64657374696E6174696F6E53656C656374696F6E3A747D3D746869732E6D6170546F4F746865725369646528293B652E';
wwv_flow_imp.g_varchar2_table(24817) := '666F63757328292C742626652E73657453656C656374696F6E2874297D65786974436F6D706172654D6F766528297B636F6E737420653D746869732E5F646966664D6F64656C2E67657428293B652626652E6D6F76656454657874546F436F6D70617265';
wwv_flow_imp.g_varchar2_table(24818) := '2E73657428766F696420302C766F69642030297D636F6C6C61707365416C6C556E6368616E676564526567696F6E7328297B76617220653B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F646966664D6F64656C2E6765742829297C7C766F';
wwv_flow_imp.g_varchar2_table(24819) := '696420303D3D3D653F766F696420303A652E756E6368616E676564526567696F6E732E67657428293B74262648542828653D3E7B666F7228636F6E7374206E206F662074296E2E636F6C6C61707365416C6C2865297D29297D73686F77416C6C556E6368';
wwv_flow_imp.g_varchar2_table(24820) := '616E676564526567696F6E7328297B76617220653B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D653F766F696420303A652E756E6368616E676564526567696F6E732E';
wwv_flow_imp.g_varchar2_table(24821) := '67657428293B74262648542828653D3E7B666F7228636F6E7374206E206F662074296E2E73686F77416C6C2865297D29297D5F68616E646C65437572736F72506F736974696F6E4368616E676528652C74297B766172206E2C693B696628333D3D3D286E';
wwv_flow_imp.g_varchar2_table(24822) := '756C6C3D3D653F766F696420303A652E726561736F6E29297B636F6E7374206F3D6E756C6C3D3D3D28693D6E756C6C3D3D3D286E3D746869732E5F646966664D6F64656C2E6765742829297C7C766F696420303D3D3D6E3F766F696420303A6E2E646966';
wwv_flow_imp.g_varchar2_table(24823) := '662E6765742829297C7C766F696420303D3D3D693F766F696420303A692E6D617070696E67732E66696E6428286E3D3E743F6E2E6C696E6552616E67654D617070696E672E6D6F6469666965642E636F6E7461696E7328652E706F736974696F6E2E6C69';
wwv_flow_imp.g_varchar2_table(24824) := '6E654E756D626572293A6E2E6C696E6552616E67654D617070696E672E6F726967696E616C2E636F6E7461696E7328652E706F736974696F6E2E6C696E654E756D6265722929293B286E756C6C3D3D6F3F766F696420303A6F2E6C696E6552616E67654D';
wwv_flow_imp.g_varchar2_table(24825) := '617070696E672E6D6F6469666965642E6973456D707479293F746869732E5F6163636573736962696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E6544656C657465642C7B736F757263653A22646966';
wwv_flow_imp.g_varchar2_table(24826) := '66456469746F722E637572736F72506F736974696F6E4368616E676564227D293A286E756C6C3D3D6F3F766F696420303A6F2E6C696E6552616E67654D617070696E672E6F726967696E616C2E6973456D707479293F746869732E5F6163636573736962';
wwv_flow_imp.g_varchar2_table(24827) := '696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E65496E7365727465642C7B736F757263653A2264696666456469746F722E637572736F72506F736974696F6E4368616E676564227D293A6F26267468';
wwv_flow_imp.g_varchar2_table(24828) := '69732E5F6163636573736962696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E646966664C696E654D6F6469666965642C7B736F757263653A2264696666456469746F722E637572736F72506F736974696F6E4368616E';
wwv_flow_imp.g_varchar2_table(24829) := '676564227D297D7D7D3B41583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363';
wwv_flow_imp.g_varchar2_table(24830) := '726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C';
wwv_flow_imp.g_varchar2_table(24831) := '742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E33';
wwv_flow_imp.g_varchar2_table(24832) := '26267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4D5828332C6364292C4D5828342C7563292C4D5828352C6763292C4D5828362C745A292C4D5828372C5345295D2C4158293B636C617373204E5820657874';
wwv_flow_imp.g_varchar2_table(24833) := '656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A2264696666456469746F722E746F67676C6553686F774D6F766564436F6465426C6F636B73222C7469746C653A5F28302C22546F67676C652053686F77204D6F76656420';
wwv_flow_imp.g_varchar2_table(24834) := '436F646520426C6F636B7322292C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222297D297D72756E28652C2E2E2E74297B636F6E7374206E3D652E676574286670292C693D216E2E67657456616C7565282264';
wwv_flow_imp.g_varchar2_table(24835) := '696666456469746F722E6578706572696D656E74616C2E73686F774D6F76657322293B6E2E75706461746556616C7565282264696666456469746F722E6578706572696D656E74616C2E73686F774D6F766573222C69297D7D636C617373205058206578';
wwv_flow_imp.g_varchar2_table(24836) := '74656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A2264696666456469746F722E746F67676C65557365496E6C696E65566965775768656E537061636549734C696D69746564222C7469746C653A5F28302C22546F67676C';
wwv_flow_imp.g_varchar2_table(24837) := '652055736520496E6C696E652056696577205768656E205370616365204973204C696D6974656422292C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222297D297D72756E28652C2E2E2E74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(24838) := '6E3D652E676574286670292C693D216E2E67657456616C7565282264696666456469746F722E757365496E6C696E65566965775768656E537061636549734C696D6974656422293B6E2E75706461746556616C7565282264696666456469746F722E7573';
wwv_flow_imp.g_varchar2_table(24839) := '65496E6C696E65566965775768656E537061636549734C696D69746564222C69297D7D636F6E7374204F583D5F28302C224469666620456469746F7222293B636C61737320525820657874656E6473204E647B636F6E7374727563746F7228297B737570';
wwv_flow_imp.g_varchar2_table(24840) := '6572287B69643A2264696666456469746F722E726576657274222C7469746C653A5F28302C2252657665727422292C66313A21312C63617465676F72793A4F587D297D72756E28652C74297B766172206E3B636F6E737420693D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(24841) := '2C742C6E297B72657475726E20652E676574286763292E6C69737444696666456469746F727328292E66696E642828653D3E7B76617220692C6F3B636F6E737420733D652E6765744D6F646966696564456469746F7228292C723D652E6765744F726967';
wwv_flow_imp.g_varchar2_table(24842) := '696E616C456469746F7228293B72657475726E20732626286E756C6C3D3D3D28693D732E6765744D6F64656C2829297C7C766F696420303D3D3D693F766F696420303A692E7572692E746F537472696E672829293D3D3D6E2E746F537472696E67282926';
wwv_flow_imp.g_varchar2_table(24843) := '26722626286E756C6C3D3D3D286F3D722E6765744D6F64656C2829297C7C766F696420303D3D3D6F3F766F696420303A6F2E7572692E746F537472696E672829293D3D3D742E746F537472696E6728297D29297C7C6E756C6C7D28652C742E6F72696769';
wwv_flow_imp.g_varchar2_table(24844) := '6E616C5572692C742E6D6F646966696564557269293B6920696E7374616E63656F662041582626692E72657665727452616E67654D617070696E6773286E756C6C213D3D286E3D742E6D617070696E672E696E6E65724368616E676573292626766F6964';
wwv_flow_imp.g_varchar2_table(24845) := '2030213D3D6E3F6E3A5B5D297D7D636F6E73742046583D5F28302C2241636365737369626C6520446966662056696577657222293B636C61737320425820657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A42582E';
wwv_flow_imp.g_varchar2_table(24846) := '69642C7469746C653A5F28302C22476F20746F204E65787420446966666572656E636522292C63617465676F72793A46582C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222292C6B657962696E64696E673A7B';
wwv_flow_imp.g_varchar2_table(24847) := '7072696D6172793A36352C7765696768743A3130307D2C66313A21307D297D72756E2865297B636F6E737420743D7A582865293B6E756C6C3D3D747C7C742E61636365737369626C65446966665669657765724E65787428297D7D42582E69643D226564';
wwv_flow_imp.g_varchar2_table(24848) := '69746F722E616374696F6E2E61636365737369626C65446966665669657765722E6E657874223B636C61737320565820657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A56582E69642C7469746C653A5F28302C22';
wwv_flow_imp.g_varchar2_table(24849) := '476F20746F2050726576696F757320446966666572656E636522292C63617465676F72793A46582C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222292C6B657962696E64696E673A7B7072696D6172793A3130';
wwv_flow_imp.g_varchar2_table(24850) := '38392C7765696768743A3130307D2C66313A21307D297D72756E2865297B636F6E737420743D7A582865293B6E756C6C3D3D747C7C742E61636365737369626C65446966665669657765725072657628297D7D66756E6374696F6E207A582865297B636F';
wwv_flow_imp.g_varchar2_table(24851) := '6E737420743D652E676574286763292E6C69737444696666456469746F727328292C6E3D6A7328293B6966286E29666F7228636F6E73742065206F66207429696628485828652E676574436F6E7461696E6572446F6D4E6F646528292C6E292972657475';
wwv_flow_imp.g_varchar2_table(24852) := '726E20653B72657475726E206E756C6C7D66756E6374696F6E20485828652C74297B6C6574206E3D743B666F72283B6E3B297B6966286E3D3D3D652972657475726E21303B6E3D6E2E706172656E74456C656D656E747D72657475726E21317D56582E69';
wwv_flow_imp.g_varchar2_table(24853) := '643D22656469746F722E616374696F6E2E61636365737369626C65446966665669657765722E70726576222C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A2264696666456469746F722E';
wwv_flow_imp.g_varchar2_table(24854) := '746F67676C65436F6C6C61707365556E6368616E676564526567696F6E73222C7469746C653A5F28302C22546F67676C6520436F6C6C6170736520556E6368616E67656420526567696F6E7322292C69636F6E3A4C6C2E6D61702C746F67676C65643A57';
wwv_flow_imp.g_varchar2_table(24855) := '632E6861732822636F6E6669672E64696666456469746F722E68696465556E6368616E676564526567696F6E732E656E61626C656422292C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222292C6D656E753A7B';
wwv_flow_imp.g_varchar2_table(24856) := '7768656E3A57632E68617328226973496E44696666456469746F7222292C69643A4C642E456469746F725469746C652C6F726465723A32322C67726F75703A226E617669676174696F6E227D7D297D72756E28652C2E2E2E74297B636F6E7374206E3D65';
wwv_flow_imp.g_varchar2_table(24857) := '2E676574286670292C693D216E2E67657456616C7565282264696666456469746F722E68696465556E6368616E676564526567696F6E732E656E61626C656422293B6E2E75706461746556616C7565282264696666456469746F722E68696465556E6368';
wwv_flow_imp.g_varchar2_table(24858) := '616E676564526567696F6E732E656E61626C6564222C69297D7D292C5064284E58292C5064285058292C49642E617070656E644D656E754974656D284C642E456469746F725469746C652C7B636F6D6D616E643A7B69643A286E6577205058292E646573';
wwv_flow_imp.g_varchar2_table(24859) := '632E69642C7469746C653A6228302C2255736520496E6C696E652056696577205768656E205370616365204973204C696D6974656422292C746F67676C65643A57632E6861732822636F6E6669672E64696666456469746F722E757365496E6C696E6556';
wwv_flow_imp.g_varchar2_table(24860) := '6965775768656E537061636549734C696D6974656422292C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222297D2C6F726465723A31312C67726F75703A22315F64696666222C7768656E3A57632E616E64286C';
wwv_flow_imp.g_varchar2_table(24861) := '682E64696666456469746F7252656E64657253696465427953696465496E6C696E65427265616B706F696E74526561636865642C57632E68617328226973496E44696666456469746F722229297D292C49642E617070656E644D656E754974656D284C64';
wwv_flow_imp.g_varchar2_table(24862) := '2E456469746F725469746C652C7B636F6D6D616E643A7B69643A286E6577204E58292E646573632E69642C7469746C653A6228302C2253686F77204D6F76656420436F646520426C6F636B7322292C69636F6E3A4C6C2E6D6F76652C746F67676C65643A';
wwv_flow_imp.g_varchar2_table(24863) := '4B632E6372656174652822636F6E6669672E64696666456469746F722E6578706572696D656E74616C2E73686F774D6F766573222C2130292C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222297D2C6F726465';
wwv_flow_imp.g_varchar2_table(24864) := '723A31302C67726F75703A22315F64696666222C7768656E3A57632E68617328226973496E44696666456469746F7222297D292C5064285258293B666F7228636F6E73742065206F665B7B69636F6E3A4C6C2E6172726F7752696768742C6B65793A6C68';
wwv_flow_imp.g_varchar2_table(24865) := '2E64696666456469746F72496E6C696E654D6F64652E746F4E65676174656428297D2C7B69636F6E3A4C6C2E646973636172642C6B65793A6C682E64696666456469746F72496E6C696E654D6F64657D5D2949642E617070656E644D656E754974656D28';
wwv_flow_imp.g_varchar2_table(24866) := '4C642E44696666456469746F7248756E6B546F6F6C6261722C7B636F6D6D616E643A7B69643A286E6577205258292E646573632E69642C7469746C653A6228302C2252657665727420426C6F636B22292C69636F6E3A652E69636F6E7D2C7768656E3A57';
wwv_flow_imp.g_varchar2_table(24867) := '632E616E64286C682E64696666456469746F724D6F6469666965645772697461626C652C652E6B6579292C6F726465723A352C67726F75703A227072696D617279227D292C49642E617070656E644D656E754974656D284C642E44696666456469746F72';
wwv_flow_imp.g_varchar2_table(24868) := '53656C656374696F6E546F6F6C6261722C7B636F6D6D616E643A7B69643A286E6577205258292E646573632E69642C7469746C653A6228302C225265766572742053656C656374696F6E22292C69636F6E3A652E69636F6E7D2C7768656E3A57632E616E';
wwv_flow_imp.g_varchar2_table(24869) := '64286C682E64696666456469746F724D6F6469666965645772697461626C652C652E6B6579292C6F726465723A352C67726F75703A227072696D617279227D293B506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B73';
wwv_flow_imp.g_varchar2_table(24870) := '75706572287B69643A2264696666456469746F722E73776974636853696465222C7469746C653A5F28302C22537769746368205369646522292C69636F6E3A4C6C2E6172726F77537761702C707265636F6E646974696F6E3A57632E6861732822697349';
wwv_flow_imp.g_varchar2_table(24871) := '6E44696666456469746F7222292C66313A21302C63617465676F72793A4F587D297D72756E456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D7A582865293B6966286920696E7374616E63656F66204158297B6966286E26266E2E';
wwv_flow_imp.g_varchar2_table(24872) := '64727952756E2972657475726E7B64657374696E6174696F6E53656C656374696F6E3A692E6D6170546F4F746865725369646528292E64657374696E6174696F6E53656C656374696F6E7D3B692E7377697463685369646528297D7D7D292C506428636C';
wwv_flow_imp.g_varchar2_table(24873) := '61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A2264696666456469746F722E65786974436F6D706172654D6F7665222C7469746C653A5F28302C224578697420436F6D70617265204D6F766522292C69';
wwv_flow_imp.g_varchar2_table(24874) := '636F6E3A4C6C2E636C6F73652C707265636F6E646974696F6E3A6C682E636F6D706172696E674D6F766564436F64652C66313A21312C63617465676F72793A4F582C6B657962696E64696E673A7B7765696768743A3165342C7072696D6172793A397D7D';
wwv_flow_imp.g_varchar2_table(24875) := '297D72756E456469746F72436F6D6D616E6428652C742C2E2E2E6E297B636F6E737420693D7A582865293B6920696E7374616E63656F662041582626692E65786974436F6D706172654D6F766528297D7D292C506428636C61737320657874656E647320';
wwv_flow_imp.g_varchar2_table(24876) := '47647B636F6E7374727563746F7228297B7375706572287B69643A2264696666456469746F722E636F6C6C61707365416C6C556E6368616E676564526567696F6E73222C7469746C653A5F28302C22436F6C6C6170736520416C6C20556E6368616E6765';
wwv_flow_imp.g_varchar2_table(24877) := '6420526567696F6E7322292C69636F6E3A4C6C2E666F6C642C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222292C66313A21302C63617465676F72793A4F587D297D72756E456469746F72436F6D6D616E6428';
wwv_flow_imp.g_varchar2_table(24878) := '652C742C2E2E2E6E297B636F6E737420693D7A582865293B6920696E7374616E63656F662041582626692E636F6C6C61707365416C6C556E6368616E676564526567696F6E7328297D7D292C506428636C61737320657874656E64732047647B636F6E73';
wwv_flow_imp.g_varchar2_table(24879) := '74727563746F7228297B7375706572287B69643A2264696666456469746F722E73686F77416C6C556E6368616E676564526567696F6E73222C7469746C653A5F28302C2253686F7720416C6C20556E6368616E67656420526567696F6E7322292C69636F';
wwv_flow_imp.g_varchar2_table(24880) := '6E3A4C6C2E756E666F6C642C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222292C66313A21302C63617465676F72793A4F587D297D72756E456469746F72436F6D6D616E6428652C742C2E2E2E6E297B636F6E';
wwv_flow_imp.g_varchar2_table(24881) := '737420693D7A582865293B6920696E7374616E63656F662041582626692E73686F77416C6C556E6368616E676564526567696F6E7328297D7D292C49642E617070656E644D656E754974656D284C642E456469746F725469746C652C7B636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(24882) := '3A7B69643A42582E69642C7469746C653A6228302C224F70656E2041636365737369626C6520446966662056696577657222292C707265636F6E646974696F6E3A57632E68617328226973496E44696666456469746F7222297D2C6F726465723A31302C';
wwv_flow_imp.g_varchar2_table(24883) := '67726F75703A22325F64696666222C7768656E3A57632E616E64286C682E61636365737369626C654469666656696577657256697369626C652E6E656761746528292C57632E68617328226973496E44696666456469746F722229297D292C6B632E7265';
wwv_flow_imp.g_varchar2_table(24884) := '676973746572436F6D6D616E64416C6961732822656469746F722E616374696F6E2E646966665265766965772E6E657874222C42582E6964292C5064284258292C6B632E7265676973746572436F6D6D616E64416C6961732822656469746F722E616374';
wwv_flow_imp.g_varchar2_table(24885) := '696F6E2E646966665265766965772E70726576222C56582E6964292C5064285658293B7661722057583D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C617373206A587B72656D';
wwv_flow_imp.g_varchar2_table(24886) := '6F766528297B76617220653B6E756C6C3D3D3D28653D746869732E706172656E74297C7C766F696420303D3D3D657C7C652E6368696C6472656E2E64656C65746528746869732E6964297D7374617469632066696E64496428652C74297B6C6574206E3B';
wwv_flow_imp.g_varchar2_table(24887) := '22737472696E67223D3D747970656F6620653F6E3D60247B742E69647D2F247B657D603A286E3D60247B742E69647D2F247B652E6E616D657D602C766F69642030213D3D742E6368696C6472656E2E676574286E292626286E3D60247B742E69647D2F24';
wwv_flow_imp.g_varchar2_table(24888) := '7B652E6E616D657D5F247B652E72616E67652E73746172744C696E654E756D6265727D5F247B652E72616E67652E7374617274436F6C756D6E7D6029293B6C657420693D6E3B666F72286C657420653D303B766F69642030213D3D742E6368696C647265';
wwv_flow_imp.g_varchar2_table(24889) := '6E2E6765742869293B652B2B29693D60247B6E7D5F247B657D603B72657475726E20697D73746174696320656D7074792865297B72657475726E20303D3D3D652E6368696C6472656E2E73697A657D7D636C61737320715820657874656E6473206A587B';
wwv_flow_imp.g_varchar2_table(24890) := '636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E69643D652C746869732E706172656E743D742C746869732E73796D626F6C3D6E2C746869732E6368696C6472656E3D6E6577204D61707D7D636C61737320245820657874';
wwv_flow_imp.g_varchar2_table(24891) := '656E6473206A587B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E69643D652C746869732E706172656E743D742C746869732E6C6162656C3D6E2C746869732E6F726465723D692C746869732E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(24892) := '3D6E6577204D61707D7D636C61737320555820657874656E6473206A587B7374617469632063726561746528652C742C6E297B636F6E737420693D6E6577204E74286E292C6F3D6E657720555828742E757269292C733D652E6F7264657265642874292C';
wwv_flow_imp.g_varchar2_table(24893) := '723D732E6D6170282828652C6E293D3E7B76617220733B636F6E737420723D6A582E66696E644964286070726F76696465725F247B6E7D602C6F292C613D6E657720245828722C6F2C6E756C6C213D3D28733D652E646973706C61794E616D6529262676';
wwv_flow_imp.g_varchar2_table(24894) := '6F69642030213D3D733F733A22556E6B6E6F776E204F75746C696E652050726F7669646572222C6E293B72657475726E2050726F6D6973652E7265736F6C766528652E70726F76696465446F63756D656E7453796D626F6C7328742C692E746F6B656E29';
wwv_flow_imp.g_varchar2_table(24895) := '292E7468656E2828653D3E7B666F7228636F6E73742074206F6620657C7C5B5D2955582E5F6D616B654F75746C696E65456C656D656E7428742C61293B72657475726E20617D292C28653D3E2845652865292C612929292E7468656E2828653D3E7B6A58';
wwv_flow_imp.g_varchar2_table(24896) := '2E656D7074792865293F652E72656D6F766528293A6F2E5F67726F7570732E73657428722C65297D29297D29292C613D652E6F6E4469644368616E6765282828293D3E7B506828652E6F7264657265642874292C73297C7C692E63616E63656C28297D29';
wwv_flow_imp.g_varchar2_table(24897) := '293B72657475726E2050726F6D6973652E616C6C2872292E7468656E282828293D3E692E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642626216E2E697343616E63656C6C6174696F6E5265717565737465643F55582E637265';
wwv_flow_imp.g_varchar2_table(24898) := '61746528652C742C6E293A6F2E5F636F6D70616374282929292E66696E616C6C79282828293D3E7B692E646973706F736528292C612E646973706F736528292C692E646973706F736528297D29297D737461746963205F6D616B654F75746C696E65456C';
wwv_flow_imp.g_varchar2_table(24899) := '656D656E7428652C74297B636F6E7374206E3D6A582E66696E64496428652C74292C693D6E6577207158286E2C742C65293B696628652E6368696C6472656E29666F7228636F6E73742074206F6620652E6368696C6472656E2955582E5F6D616B654F75';
wwv_flow_imp.g_varchar2_table(24900) := '746C696E65456C656D656E7428742C69293B742E6368696C6472656E2E73657428692E69642C69297D636F6E7374727563746F722865297B737570657228292C746869732E7572693D652C746869732E69643D22726F6F74222C746869732E706172656E';
wwv_flow_imp.g_varchar2_table(24901) := '743D766F696420302C746869732E5F67726F7570733D6E6577204D61702C746869732E6368696C6472656E3D6E6577204D61702C746869732E69643D22726F6F74222C746869732E706172656E743D766F696420307D5F636F6D7061637428297B6C6574';
wwv_flow_imp.g_varchar2_table(24902) := '20653D303B666F7228636F6E73745B742C6E5D6F6620746869732E5F67726F75707329303D3D3D6E2E6368696C6472656E2E73697A653F746869732E5F67726F7570732E64656C6574652874293A652B3D313B69662831213D3D6529746869732E636869';
wwv_flow_imp.g_varchar2_table(24903) := '6C6472656E3D746869732E5F67726F7570733B656C73657B636F6E737420653D5A652E666972737428746869732E5F67726F7570732E76616C7565732829293B666F7228636F6E73745B2C745D6F6620652E6368696C6472656E29742E706172656E743D';
wwv_flow_imp.g_varchar2_table(24904) := '746869732C746869732E6368696C6472656E2E73657428742E69642C74297D72657475726E20746869737D676574546F704C6576656C53796D626F6C7328297B636F6E737420653D5B5D3B666F7228636F6E73742074206F6620746869732E6368696C64';
wwv_flow_imp.g_varchar2_table(24905) := '72656E2E76616C7565732829297420696E7374616E63656F662071583F652E7075736828742E73796D626F6C293A652E70757368282E2E2E5A652E6D617028742E6368696C6472656E2E76616C75657328292C28653D3E652E73796D626F6C2929293B72';
wwv_flow_imp.g_varchar2_table(24906) := '657475726E20652E736F7274282828652C74293D3E72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E67652929297D61734C6973744F66446F63756D656E7453796D626F6C7328297B636F6E737420';
wwv_flow_imp.g_varchar2_table(24907) := '653D746869732E676574546F704C6576656C53796D626F6C7328292C743D5B5D3B72657475726E2055582E5F666C617474656E446F63756D656E7453796D626F6C7328742C652C2222292C742E736F7274282828652C74293D3E6D632E636F6D70617265';
wwv_flow_imp.g_varchar2_table(24908) := '2872682E6765745374617274506F736974696F6E28652E72616E6765292C72682E6765745374617274506F736974696F6E28742E72616E676529297C7C6D632E636F6D706172652872682E676574456E64506F736974696F6E28742E72616E6765292C72';
wwv_flow_imp.g_varchar2_table(24909) := '682E676574456E64506F736974696F6E28652E72616E6765292929297D737461746963205F666C617474656E446F63756D656E7453796D626F6C7328652C742C6E297B666F7228636F6E73742069206F66207429652E70757368287B6B696E643A692E6B';
wwv_flow_imp.g_varchar2_table(24910) := '696E642C746167733A692E746167732C6E616D653A692E6E616D652C64657461696C3A692E64657461696C2C636F6E7461696E65724E616D653A692E636F6E7461696E65724E616D657C7C6E2C72616E67653A692E72616E67652C73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(24911) := '52616E67653A692E73656C656374696F6E52616E67652C6368696C6472656E3A766F696420307D292C692E6368696C6472656E262655582E5F666C617474656E446F63756D656E7453796D626F6C7328652C692E6368696C6472656E2C692E6E616D6529';
wwv_flow_imp.g_varchar2_table(24912) := '7D7D636F6E7374204B583D70632822494F75746C696E654D6F64656C5365727669636522293B6C65742047583D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F6C616E67756167654665617475726573536572766963653D';
wwv_flow_imp.g_varchar2_table(24913) := '652C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F63616368653D6E65772061612831302C2E37292C746869732E5F6465626F756E6365496E666F726D6174696F6E3D742E666F7228652E646F63756D656E7453796D626F';
wwv_flow_imp.g_varchar2_table(24914) := '6C50726F76696465722C22446F63756D656E7453796D626F6C73222C7B6D696E3A3335307D292C746869732E5F646973706F7361626C65732E616464286E2E6F6E4D6F64656C52656D6F7665642828653D3E7B746869732E5F63616368652E64656C6574';
wwv_flow_imp.g_varchar2_table(24915) := '6528652E6964297D2929297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528297D6173796E63206765744F7243726561746528652C74297B636F6E7374206E3D746869732E5F6C616E67756167654665617475';
wwv_flow_imp.g_varchar2_table(24916) := '726573536572766963652E646F63756D656E7453796D626F6C50726F76696465722C693D6E2E6F7264657265642865293B6C6574206F3D746869732E5F63616368652E67657428652E6964293B696628216F7C7C6F2E76657273696F6E4964213D3D652E';
wwv_flow_imp.g_varchar2_table(24917) := '67657456657273696F6E496428297C7C215068286F2E70726F76696465722C6929297B636F6E737420743D6E6577204E743B6F3D7B76657273696F6E49643A652E67657456657273696F6E496428292C70726F76696465723A692C70726F6D697365436E';
wwv_flow_imp.g_varchar2_table(24918) := '743A302C736F757263653A742C70726F6D6973653A55582E637265617465286E2C652C742E746F6B656E292C6D6F64656C3A766F696420307D2C746869732E5F63616368652E73657428652E69642C6F293B636F6E737420733D446174652E6E6F772829';
wwv_flow_imp.g_varchar2_table(24919) := '3B6F2E70726F6D6973652E7468656E2828743D3E7B6F2E6D6F64656C3D742C746869732E5F6465626F756E6365496E666F726D6174696F6E2E75706461746528652C446174652E6E6F7728292D73297D29292E63617463682828743D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(24920) := '63616368652E64656C65746528652E6964297D29297D6966286F2E6D6F64656C2972657475726E206F2E6D6F64656C3B6F2E70726F6D697365436E742B3D313B636F6E737420733D742E6F6E43616E63656C6C6174696F6E526571756573746564282828';
wwv_flow_imp.g_varchar2_table(24921) := '293D3E7B303D3D2D2D6F2E70726F6D697365436E742626286F2E736F757263652E63616E63656C28292C746869732E5F63616368652E64656C65746528652E696429297D29293B7472797B72657475726E206177616974206F2E70726F6D6973657D6669';
wwv_flow_imp.g_varchar2_table(24922) := '6E616C6C797B732E646973706F736528297D7D7D3B47583D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50';
wwv_flow_imp.g_varchar2_table(24923) := '726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E';
wwv_flow_imp.g_varchar2_table(24924) := '6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C7229';
wwv_flow_imp.g_varchar2_table(24925) := '3B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B575828302C7878292C575828312C6456292C575828322C6663295D2C4758292C7870284B582C47582C31293B7661722051583D';
wwv_flow_imp.g_varchar2_table(24926) := '66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742059583D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869';
wwv_flow_imp.g_varchar2_table(24927) := '732E5F746578744D6F64656C3D652C746869732E5F6C616E67756167654665617475726573536572766963653D742C746869732E5F6F75746C696E654D6F64656C536572766963653D6E2C746869732E5F63757272656E744D6F64656C3D245428746869';
wwv_flow_imp.g_varchar2_table(24928) := '732C766F69642030293B636F6E737420693D63492822646F63756D656E7453796D626F6C50726F76696465722E6F6E4469644368616E6765222C746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7453796D62';
wwv_flow_imp.g_varchar2_table(24929) := '6F6C50726F76696465722E6F6E4469644368616E6765292C6F3D634928225F746578744D6F64656C2E6F6E4469644368616E6765436F6E74656E74222C76742E6465626F756E63652828653D3E746869732E5F746578744D6F64656C2E6F6E4469644368';
wwv_flow_imp.g_varchar2_table(24930) := '616E6765436F6E74656E74286529292C2828293D3E7B7D292C31303029293B746869732E5F726567697374657228694928286173796E6328652C74293D3E7B692E726561642865292C6F2E726561642865293B636F6E7374206E3D742E616464286E6577';
wwv_flow_imp.g_varchar2_table(24931) := '205859292C733D617761697420746869732E5F6F75746C696E654D6F64656C536572766963652E6765744F7243726561746528746869732E5F746578744D6F64656C2C6E2E746F6B656E293B742E6973446973706F7365647C7C746869732E5F63757272';
wwv_flow_imp.g_varchar2_table(24932) := '656E744D6F64656C2E73657428732C766F69642030297D2929297D67657442726561646372756D624974656D7328652C74297B636F6E7374206E3D746869732E5F63757272656E744D6F64656C2E726561642874293B696628216E2972657475726E5B5D';
wwv_flow_imp.g_varchar2_table(24933) := '3B636F6E737420693D6E2E61734C6973744F66446F63756D656E7453796D626F6C7328292E66696C7465722828743D3E652E636F6E7461696E7328742E72616E67652E73746172744C696E654E756D62657229262621652E636F6E7461696E7328742E72';
wwv_flow_imp.g_varchar2_table(24934) := '616E67652E656E644C696E654E756D6265722929293B72657475726E20692E736F72742869752865752828653D3E652E72616E67652E656E644C696E654E756D6265722D652E72616E67652E73746172744C696E654E756D626572292C74752929292C69';
wwv_flow_imp.g_varchar2_table(24935) := '2E6D61702828653D3E287B6E616D653A652E6E616D652C6B696E643A652E6B696E642C73746172744C696E654E756D6265723A652E72616E67652E73746172744C696E654E756D6265727D2929297D7D3B59583D66756E6374696F6E28652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(24936) := '297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D7479';
wwv_flow_imp.g_varchar2_table(24937) := '70656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(24938) := '682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C';
wwv_flow_imp.g_varchar2_table(24939) := '6E2C72292C727D285B515828312C7878292C515828322C4B58295D2C5958292C62582E73657442726561646372756D6273536F75726365466163746F7279282828652C74293D3E742E637265617465496E7374616E63652859582C652929293B76617220';
wwv_flow_imp.g_varchar2_table(24940) := '5A582C58583D6E2838333537292C4A583D7B7D3B4A582E7374796C655461675472616E73666F726D3D6A7228292C4A582E736574417474726962757465733D567228292C4A582E696E736572743D467228292E62696E64286E756C6C2C22686561642229';
wwv_flow_imp.g_varchar2_table(24941) := '2C4A582E646F6D4150493D4F7228292C4A582E696E736572745374796C65456C656D656E743D487228292C4E7228292858582E412C4A58292C58582E41262658582E412E6C6F63616C73262658582E412E6C6F63616C733B636C61737320654A7B636F6E';
wwv_flow_imp.g_varchar2_table(24942) := '7374727563746F7228652C742C6E297B746869732E73656C656374696F6E3D652C746869732E746172676574506F736974696F6E3D742C746869732E636F70793D6E2C746869732E74617267657453656C656374696F6E3D6E756C6C7D67657445646974';
wwv_flow_imp.g_varchar2_table(24943) := '4F7065726174696F6E7328652C74297B636F6E7374206E3D652E67657456616C7565496E52616E676528746869732E73656C656374696F6E293B746869732E636F70797C7C742E616464456469744F7065726174696F6E28746869732E73656C65637469';
wwv_flow_imp.g_varchar2_table(24944) := '6F6E2C6E756C6C292C742E616464456469744F7065726174696F6E286E657720726828746869732E746172676574506F736974696F6E2E6C696E654E756D6265722C746869732E746172676574506F736974696F6E2E636F6C756D6E2C746869732E7461';
wwv_flow_imp.g_varchar2_table(24945) := '72676574506F736974696F6E2E6C696E654E756D6265722C746869732E746172676574506F736974696F6E2E636F6C756D6E292C6E292C21746869732E73656C656374696F6E2E636F6E7461696E73506F736974696F6E28746869732E74617267657450';
wwv_flow_imp.g_varchar2_table(24946) := '6F736974696F6E297C7C746869732E636F7079262628746869732E73656C656374696F6E2E676574456E64506F736974696F6E28292E657175616C7328746869732E746172676574506F736974696F6E297C7C746869732E73656C656374696F6E2E6765';
wwv_flow_imp.g_varchar2_table(24947) := '745374617274506F736974696F6E28292E657175616C7328746869732E746172676574506F736974696F6E29293F746869732E636F70793F746869732E74617267657453656C656374696F6E3D6E657720616828746869732E746172676574506F736974';
wwv_flow_imp.g_varchar2_table(24948) := '696F6E2E6C696E654E756D6265722C746869732E746172676574506F736974696F6E2E636F6C756D6E2C746869732E73656C656374696F6E2E656E644C696E654E756D6265722D746869732E73656C656374696F6E2E73746172744C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(24949) := '722B746869732E746172676574506F736974696F6E2E6C696E654E756D6265722C746869732E73656C656374696F6E2E73746172744C696E654E756D6265723D3D3D746869732E73656C656374696F6E2E656E644C696E654E756D6265723F746869732E';
wwv_flow_imp.g_varchar2_table(24950) := '746172676574506F736974696F6E2E636F6C756D6E2B746869732E73656C656374696F6E2E656E64436F6C756D6E2D746869732E73656C656374696F6E2E7374617274436F6C756D6E3A746869732E73656C656374696F6E2E656E64436F6C756D6E293A';
wwv_flow_imp.g_varchar2_table(24951) := '746869732E746172676574506F736974696F6E2E6C696E654E756D6265723E746869732E73656C656374696F6E2E656E644C696E654E756D6265723F746869732E74617267657453656C656374696F6E3D6E657720616828746869732E74617267657450';
wwv_flow_imp.g_varchar2_table(24952) := '6F736974696F6E2E6C696E654E756D6265722D746869732E73656C656374696F6E2E656E644C696E654E756D6265722B746869732E73656C656374696F6E2E73746172744C696E654E756D6265722C746869732E746172676574506F736974696F6E2E63';
wwv_flow_imp.g_varchar2_table(24953) := '6F6C756D6E2C746869732E746172676574506F736974696F6E2E6C696E654E756D6265722C746869732E73656C656374696F6E2E73746172744C696E654E756D6265723D3D3D746869732E73656C656374696F6E2E656E644C696E654E756D6265723F74';
wwv_flow_imp.g_varchar2_table(24954) := '6869732E746172676574506F736974696F6E2E636F6C756D6E2B746869732E73656C656374696F6E2E656E64436F6C756D6E2D746869732E73656C656374696F6E2E7374617274436F6C756D6E3A746869732E73656C656374696F6E2E656E64436F6C75';
wwv_flow_imp.g_varchar2_table(24955) := '6D6E293A746869732E746172676574506F736974696F6E2E6C696E654E756D6265723C746869732E73656C656374696F6E2E656E644C696E654E756D6265723F746869732E74617267657453656C656374696F6E3D6E657720616828746869732E746172';
wwv_flow_imp.g_varchar2_table(24956) := '676574506F736974696F6E2E6C696E654E756D6265722C746869732E746172676574506F736974696F6E2E636F6C756D6E2C746869732E746172676574506F736974696F6E2E6C696E654E756D6265722B746869732E73656C656374696F6E2E656E644C';
wwv_flow_imp.g_varchar2_table(24957) := '696E654E756D6265722D746869732E73656C656374696F6E2E73746172744C696E654E756D6265722C746869732E73656C656374696F6E2E73746172744C696E654E756D6265723D3D3D746869732E73656C656374696F6E2E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(24958) := '65723F746869732E746172676574506F736974696F6E2E636F6C756D6E2B746869732E73656C656374696F6E2E656E64436F6C756D6E2D746869732E73656C656374696F6E2E7374617274436F6C756D6E3A746869732E73656C656374696F6E2E656E64';
wwv_flow_imp.g_varchar2_table(24959) := '436F6C756D6E293A746869732E73656C656374696F6E2E656E64436F6C756D6E3C3D746869732E746172676574506F736974696F6E2E636F6C756D6E3F746869732E74617267657453656C656374696F6E3D6E657720616828746869732E746172676574';
wwv_flow_imp.g_varchar2_table(24960) := '506F736974696F6E2E6C696E654E756D6265722D746869732E73656C656374696F6E2E656E644C696E654E756D6265722B746869732E73656C656374696F6E2E73746172744C696E654E756D6265722C28746869732E73656C656374696F6E2E73746172';
wwv_flow_imp.g_varchar2_table(24961) := '744C696E654E756D6265722C746869732E73656C656374696F6E2E656E644C696E654E756D6265722C746869732E746172676574506F736974696F6E2E636F6C756D6E2D746869732E73656C656374696F6E2E656E64436F6C756D6E2B746869732E7365';
wwv_flow_imp.g_varchar2_table(24962) := '6C656374696F6E2E7374617274436F6C756D6E292C746869732E746172676574506F736974696F6E2E6C696E654E756D6265722C746869732E73656C656374696F6E2E73746172744C696E654E756D6265723D3D3D746869732E73656C656374696F6E2E';
wwv_flow_imp.g_varchar2_table(24963) := '656E644C696E654E756D6265723F746869732E746172676574506F736974696F6E2E636F6C756D6E3A746869732E73656C656374696F6E2E656E64436F6C756D6E293A746869732E74617267657453656C656374696F6E3D6E657720616828746869732E';
wwv_flow_imp.g_varchar2_table(24964) := '746172676574506F736974696F6E2E6C696E654E756D6265722D746869732E73656C656374696F6E2E656E644C696E654E756D6265722B746869732E73656C656374696F6E2E73746172744C696E654E756D6265722C746869732E746172676574506F73';
wwv_flow_imp.g_varchar2_table(24965) := '6974696F6E2E636F6C756D6E2C746869732E746172676574506F736974696F6E2E6C696E654E756D6265722C746869732E746172676574506F736974696F6E2E636F6C756D6E2B746869732E73656C656374696F6E2E656E64436F6C756D6E2D74686973';
wwv_flow_imp.g_varchar2_table(24966) := '2E73656C656374696F6E2E7374617274436F6C756D6E293A746869732E74617267657453656C656374696F6E3D746869732E73656C656374696F6E7D636F6D70757465437572736F72537461746528652C74297B72657475726E20746869732E74617267';
wwv_flow_imp.g_varchar2_table(24967) := '657453656C656374696F6E7D7D66756E6374696F6E20744A2865297B72657475726E20713F652E616C744B65793A652E6374726C4B65797D636C617373206E4A20657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C74';
wwv_flow_imp.g_varchar2_table(24968) := '6869732E5F656469746F723D652C746869732E5F646E644465636F726174696F6E4964733D746869732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E5F726567697374657228746869732E';
wwv_flow_imp.g_varchar2_table(24969) := '5F656469746F722E6F6E4D6F757365446F776E2828653D3E746869732E5F6F6E456469746F724D6F757365446F776E2865292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4D6F75736555702828653D3E74686973';
wwv_flow_imp.g_varchar2_table(24970) := '2E5F6F6E456469746F724D6F75736555702865292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4D6F757365447261672828653D3E746869732E5F6F6E456469746F724D6F757365447261672865292929292C7468';
wwv_flow_imp.g_varchar2_table(24971) := '69732E5F726567697374657228746869732E5F656469746F722E6F6E4D6F75736544726F702828653D3E746869732E5F6F6E456469746F724D6F75736544726F702865292929292C746869732E5F726567697374657228746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(24972) := '6F6E4D6F75736544726F7043616E63656C6564282828293D3E746869732E5F6F6E456469746F724D6F75736544726F7043616E63656C656428292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4B6579446F776E28';
wwv_flow_imp.g_varchar2_table(24973) := '28653D3E746869732E6F6E456469746F724B6579446F776E2865292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4B657955702828653D3E746869732E6F6E456469746F724B657955702865292929292C74686973';
wwv_flow_imp.g_varchar2_table(24974) := '2E5F726567697374657228746869732E5F656469746F722E6F6E446964426C7572456469746F72576964676574282828293D3E746869732E6F6E456469746F72426C757228292929292C746869732E5F726567697374657228746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(24975) := '722E6F6E446964426C7572456469746F7254657874282828293D3E746869732E6F6E456469746F72426C757228292929292C746869732E5F6D6F757365446F776E3D21312C746869732E5F6D6F646966696572507265737365643D21312C746869732E5F';
wwv_flow_imp.g_varchar2_table(24976) := '6472616753656C656374696F6E3D6E756C6C7D6F6E456469746F72426C757228297B746869732E5F72656D6F76654465636F726174696F6E28292C746869732E5F6472616753656C656374696F6E3D6E756C6C2C746869732E5F6D6F757365446F776E3D';
wwv_flow_imp.g_varchar2_table(24977) := '21312C746869732E5F6D6F646966696572507265737365643D21317D6F6E456469746F724B6579446F776E2865297B746869732E5F656469746F722E6765744F7074696F6E28333529262621746869732E5F656469746F722E6765744F7074696F6E2832';
wwv_flow_imp.g_varchar2_table(24978) := '3229262628744A286529262628746869732E5F6D6F646966696572507265737365643D2130292C746869732E5F6D6F757365446F776E2626744A2865292626746869732E5F656469746F722E7570646174654F7074696F6E73287B6D6F7573655374796C';
wwv_flow_imp.g_varchar2_table(24979) := '653A22636F7079227D29297D6F6E456469746F724B657955702865297B746869732E5F656469746F722E6765744F7074696F6E28333529262621746869732E5F656469746F722E6765744F7074696F6E28323229262628744A286529262628746869732E';
wwv_flow_imp.g_varchar2_table(24980) := '5F6D6F646966696572507265737365643D2131292C746869732E5F6D6F757365446F776E2626652E6B6579436F64653D3D3D6E4A2E545249474745525F4B45595F56414C55452626746869732E5F656469746F722E7570646174654F7074696F6E73287B';
wwv_flow_imp.g_varchar2_table(24981) := '6D6F7573655374796C653A2264656661756C74227D29297D5F6F6E456469746F724D6F757365446F776E2865297B746869732E5F6D6F757365446F776E3D21307D5F6F6E456469746F724D6F75736555702865297B746869732E5F6D6F757365446F776E';
wwv_flow_imp.g_varchar2_table(24982) := '3D21312C746869732E5F656469746F722E7570646174654F7074696F6E73287B6D6F7573655374796C653A2274657874227D297D5F6F6E456469746F724D6F757365447261672865297B636F6E737420743D652E7461726765743B6966286E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(24983) := '3D746869732E5F6472616753656C656374696F6E297B636F6E737420653D28746869732E5F656469746F722E67657453656C656374696F6E7328297C7C5B5D292E66696C7465722828653D3E742E706F736974696F6E2626652E636F6E7461696E73506F';
wwv_flow_imp.g_varchar2_table(24984) := '736974696F6E28742E706F736974696F6E2929293B69662831213D3D652E6C656E6774682972657475726E3B746869732E5F6472616753656C656374696F6E3D655B305D7D744A28652E6576656E74293F746869732E5F656469746F722E757064617465';
wwv_flow_imp.g_varchar2_table(24985) := '4F7074696F6E73287B6D6F7573655374796C653A22636F7079227D293A746869732E5F656469746F722E7570646174654F7074696F6E73287B6D6F7573655374796C653A2264656661756C74227D292C742E706F736974696F6E262628746869732E5F64';
wwv_flow_imp.g_varchar2_table(24986) := '72616753656C656374696F6E2E636F6E7461696E73506F736974696F6E28742E706F736974696F6E293F746869732E5F72656D6F76654465636F726174696F6E28293A746869732E73686F77417428742E706F736974696F6E29297D5F6F6E456469746F';
wwv_flow_imp.g_varchar2_table(24987) := '724D6F75736544726F7043616E63656C656428297B746869732E5F656469746F722E7570646174654F7074696F6E73287B6D6F7573655374796C653A2274657874227D292C746869732E5F72656D6F76654465636F726174696F6E28292C746869732E5F';
wwv_flow_imp.g_varchar2_table(24988) := '6472616753656C656374696F6E3D6E756C6C2C746869732E5F6D6F757365446F776E3D21317D5F6F6E456469746F724D6F75736544726F702865297B696628652E746172676574262628746869732E5F686974436F6E74656E7428652E74617267657429';
wwv_flow_imp.g_varchar2_table(24989) := '7C7C746869732E5F6869744D617267696E28652E74617267657429292626652E7461726765742E706F736974696F6E297B636F6E737420743D6E6577206D6328652E7461726765742E706F736974696F6E2E6C696E654E756D6265722C652E7461726765';
wwv_flow_imp.g_varchar2_table(24990) := '742E706F736974696F6E2E636F6C756D6E293B6966286E756C6C3D3D3D746869732E5F6472616753656C656374696F6E297B6C6574206E3D6E756C6C3B696628652E6576656E742E73686966744B6579297B636F6E737420653D746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(24991) := '6F722E67657453656C656374696F6E28293B69662865297B636F6E73747B73656C656374696F6E53746172744C696E654E756D6265723A692C73656C656374696F6E5374617274436F6C756D6E3A6F7D3D653B6E3D5B6E657720616828692C6F2C742E6C';
wwv_flow_imp.g_varchar2_table(24992) := '696E654E756D6265722C742E636F6C756D6E295D7D7D656C7365206E3D28746869732E5F656469746F722E67657453656C656374696F6E7328297C7C5B5D292E6D61702828653D3E652E636F6E7461696E73506F736974696F6E2874293F6E6577206168';
wwv_flow_imp.g_varchar2_table(24993) := '28742E6C696E654E756D6265722C742E636F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E293A6529293B746869732E5F656469746F722E73657453656C656374696F6E73286E7C7C5B5D2C226D6F757365222C33297D656C73652821';
wwv_flow_imp.g_varchar2_table(24994) := '746869732E5F6472616753656C656374696F6E2E636F6E7461696E73506F736974696F6E2874297C7C28744A28652E6576656E74297C7C746869732E5F6D6F6469666965725072657373656429262628746869732E5F6472616753656C656374696F6E2E';
wwv_flow_imp.g_varchar2_table(24995) := '676574456E64506F736974696F6E28292E657175616C732874297C7C746869732E5F6472616753656C656374696F6E2E6765745374617274506F736974696F6E28292E657175616C732874292929262628746869732E5F656469746F722E70757368556E';
wwv_flow_imp.g_varchar2_table(24996) := '646F53746F7028292C746869732E5F656469746F722E65786563757465436F6D6D616E64286E4A2E49442C6E657720654A28746869732E5F6472616753656C656374696F6E2C742C744A28652E6576656E74297C7C746869732E5F6D6F64696669657250';
wwv_flow_imp.g_varchar2_table(24997) := '72657373656429292C746869732E5F656469746F722E70757368556E646F53746F702829297D746869732E5F656469746F722E7570646174654F7074696F6E73287B6D6F7573655374796C653A2274657874227D292C746869732E5F72656D6F76654465';
wwv_flow_imp.g_varchar2_table(24998) := '636F726174696F6E28292C746869732E5F6472616753656C656374696F6E3D6E756C6C2C746869732E5F6D6F757365446F776E3D21317D73686F7741742865297B746869732E5F646E644465636F726174696F6E4964732E736574285B7B72616E67653A';
wwv_flow_imp.g_varchar2_table(24999) := '6E657720726828652E6C696E654E756D6265722C652E636F6C756D6E2C652E6C696E654E756D6265722C652E636F6C756D6E292C6F7074696F6E733A6E4A2E5F4445434F524154494F4E5F4F5054494F4E537D5D292C746869732E5F656469746F722E72';
wwv_flow_imp.g_varchar2_table(25000) := '657665616C506F736974696F6E28652C31297D5F72656D6F76654465636F726174696F6E28297B746869732E5F646E644465636F726174696F6E4964732E636C65617228297D5F686974436F6E74656E742865297B72657475726E20363D3D3D652E7479';
wwv_flow_imp.g_varchar2_table(25001) := '70657C7C373D3D3D652E747970657D5F6869744D617267696E2865297B72657475726E20323D3D3D652E747970657C7C333D3D3D652E747970657C7C343D3D3D652E747970657D646973706F736528297B746869732E5F72656D6F76654465636F726174';
wwv_flow_imp.g_varchar2_table(25002) := '696F6E28292C746869732E5F6472616753656C656374696F6E3D6E756C6C2C746869732E5F6D6F757365446F776E3D21312C746869732E5F6D6F646966696572507265737365643D21312C73757065722E646973706F736528297D7D6E4A2E49443D2265';
wwv_flow_imp.g_varchar2_table(25003) := '6469746F722E636F6E747269622E64726167416E6444726F70222C6E4A2E545249474745525F4B45595F56414C55453D713F363A352C6E4A2E5F4445434F524154494F4E5F4F5054494F4E533D4F432E7265676973746572287B6465736372697074696F';
wwv_flow_imp.g_varchar2_table(25004) := '6E3A22646E642D746172676574222C636C6173734E616D653A22646E642D746172676574227D292C4A64286E4A2E49442C6E4A2C32292C6B632E7265676973746572436F6D6D616E6428225F65786563757465446F63756D656E7453796D626F6C50726F';
wwv_flow_imp.g_varchar2_table(25005) := '7669646572222C286173796E632066756E6374696F6E28652C2E2E2E74297B636F6E73745B6E5D3D743B796C284E6F2E6973557269286E29293B636F6E737420693D652E676574284B58292C6F3D652E676574287663292C733D6177616974206F2E6372';
wwv_flow_imp.g_varchar2_table(25006) := '656174654D6F64656C5265666572656E6365286E293B7472797B72657475726E28617761697420692E6765744F7243726561746528732E6F626A6563742E74657874456469746F724D6F64656C2C4D742E4E6F6E6529292E676574546F704C6576656C53';
wwv_flow_imp.g_varchar2_table(25007) := '796D626F6C7328297D66696E616C6C797B732E646973706F736528297D7D29292C4A64286E4C2E49442C6E4C2C30292C7257282478292C5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B';
wwv_flow_imp.g_varchar2_table(25008) := '69643A4A452C707265636F6E646974696F6E3A654C2C6B624F7074733A7B7765696768743A3130302C7072696D6172793A323133377D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B72657475726E206E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(25009) := '6E3D6E4C2E676574287429297C7C766F696420303D3D3D6E3F766F696420303A6E2E6368616E676550617374655479706528297D7D292C5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B';
wwv_flow_imp.g_varchar2_table(25010) := '69643A22656469746F722E686964655061737465576964676574222C707265636F6E646974696F6E3A654C2C6B624F7074733A7B7765696768743A3130302C7072696D6172793A397D7D297D72756E456469746F72436F6D6D616E6428652C74297B7661';
wwv_flow_imp.g_varchar2_table(25011) := '72206E3B6E756C6C3D3D3D286E3D6E4C2E676574287429297C7C766F696420303D3D3D6E7C7C6E2E636C6561725769646765747328297D7D292C5A6428285A583D636C61737320657874656E64732055647B636F6E7374727563746F7228297B73757065';
wwv_flow_imp.g_varchar2_table(25012) := '72287B69643A22656469746F722E616374696F6E2E70617374654173222C6C6162656C3A6228302C2250617374652041732E2E2E22292C616C6961733A2250617374652041732E2E2E222C707265636F6E646974696F6E3A6C682E7772697461626C652C';
wwv_flow_imp.g_varchar2_table(25013) := '6D657461646174613A7B6465736372697074696F6E3A225061737465206173222C617267733A5B7B6E616D653A2261726773222C736368656D613A5A582E61726773536368656D617D5D7D7D297D72756E28652C742C6E297B76617220693B6C6574206F';
wwv_flow_imp.g_varchar2_table(25014) := '3D22737472696E67223D3D747970656F66286E756C6C3D3D6E3F766F696420303A6E2E6B696E64293F6E2E6B696E643A766F696420303B72657475726E216F26266E2626286F3D22737472696E67223D3D747970656F66206E2E69643F6E2E69643A766F';
wwv_flow_imp.g_varchar2_table(25015) := '69642030292C6E756C6C3D3D3D28693D6E4C2E676574287429297C7C766F696420303D3D3D693F766F696420303A692E70617374654173286F3F6E6577207078286F293A766F69642030297D7D2C5A582E61726773536368656D613D7B747970653A226F';
wwv_flow_imp.g_varchar2_table(25016) := '626A656374222C70726F706572746965733A7B6B696E643A7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C22546865206B696E64206F6620746865207061737465206564697420746F20747279206170706C79696E672E20';
wwv_flow_imp.g_varchar2_table(25017) := '4966206E6F742070726F7669646564206F7220746865726520617265206D756C7469706C6520656469747320666F722074686973206B696E642C2074686520656469746F722077696C6C2073686F772061207069636B65722E22297D7D7D2C5A5829292C';
wwv_flow_imp.g_varchar2_table(25018) := '5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7061737465417354657874222C6C6162656C3A6228302C225061737465206173205465787422292C61';
wwv_flow_imp.g_varchar2_table(25019) := '6C6961733A2250617374652061732054657874222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D72756E28652C74297B766172206E3B72657475726E206E756C6C3D3D3D286E3D6E4C2E676574287429297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(25020) := '3D6E3F766F696420303A6E2E70617374654173287B70726F766964657249643A56782E69647D297D7D293B636C61737320694A7B636F6E7374727563746F722865297B746869732E6964656E7469666965723D657D7D636F6E7374206F4A3D7063282274';
wwv_flow_imp.g_varchar2_table(25021) := '7265655669657773446E645365727669636522293B7870286F4A2C636C6173737B636F6E7374727563746F7228297B746869732E5F647261674F7065726174696F6E733D6E6577204D61707D72656D6F7665447261674F7065726174696F6E5472616E73';
wwv_flow_imp.g_varchar2_table(25022) := '6665722865297B696628652626746869732E5F647261674F7065726174696F6E732E686173286529297B636F6E737420743D746869732E5F647261674F7065726174696F6E732E6765742865293B72657475726E20746869732E5F647261674F70657261';
wwv_flow_imp.g_varchar2_table(25023) := '74696F6E732E64656C6574652865292C747D7D7D2C31293B76617220734A2C724A3D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E737420614A3D22656469746F722E657870';
wwv_flow_imp.g_varchar2_table(25024) := '6572696D656E74616C2E64726F70496E746F456469746F722E64656661756C7450726F7669646572222C6C4A3D22656469746F722E6368616E676544726F7054797065222C634A3D6E6577206C64282264726F7057696467657456697369626C65222C21';
wwv_flow_imp.g_varchar2_table(25025) := '312C6228302C2257686574686572207468652064726F70207769646765742069732073686F77696E672229293B6C657420644A3D734A3D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F';
wwv_flow_imp.g_varchar2_table(25026) := '6E747269627574696F6E28734A2E4944297D636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E5F636F6E666967536572766963653D6E2C746869732E5F6C616E6775616765466561747572657353657276696365';
wwv_flow_imp.g_varchar2_table(25027) := '3D692C746869732E5F74726565566965777344726167416E6444726F70536572766963653D6F2C746869732E747265654974656D735472616E736665723D6D782E676574496E7374616E636528292C746869732E5F64726F7050726F67726573734D616E';
wwv_flow_imp.g_varchar2_table(25028) := '616765723D746869732E5F726567697374657228742E637265617465496E7374616E636528666B2C2264726F70496E746F456469746F72222C6529292C746869732E5F706F737444726F705769646765744D616E616765723D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(25029) := '74657228742E637265617465496E7374616E63652859452C2264726F70496E746F456469746F72222C652C634A2C7B69643A6C4A2C6C6162656C3A6228302C2253686F772064726F70206F7074696F6E732E2E2E22297D29292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(25030) := '7374657228652E6F6E44726F70496E746F456469746F722828743D3E746869732E6F6E44726F70496E746F456469746F7228652C742E706F736974696F6E2C742E6576656E74292929297D636C6561725769646765747328297B746869732E5F706F7374';
wwv_flow_imp.g_varchar2_table(25031) := '44726F705769646765744D616E616765722E636C65617228297D6368616E676544726F705479706528297B746869732E5F706F737444726F705769646765744D616E616765722E74727953686F7753656C6563746F7228297D6173796E63206F6E44726F';
wwv_flow_imp.g_varchar2_table(25032) := '70496E746F456469746F7228652C742C6E297B76617220693B696628216E2E646174615472616E736665727C7C21652E6861734D6F64656C28292972657475726E3B6E756C6C3D3D3D28693D746869732E5F63757272656E744F7065726174696F6E297C';
wwv_flow_imp.g_varchar2_table(25033) := '7C766F696420303D3D3D697C7C692E63616E63656C28292C652E666F63757328292C652E736574506F736974696F6E2874293B636F6E7374206F3D467428286173796E6320693D3E7B636F6E737420733D6E657720646B28652C312C766F696420302C69';
wwv_flow_imp.g_varchar2_table(25034) := '293B7472797B636F6E7374206F3D617761697420746869732E65787472616374446174615472616E7366657244617461286E293B696628303D3D3D6F2E73697A657C7C732E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972';
wwv_flow_imp.g_varchar2_table(25035) := '657475726E3B636F6E737420723D652E6765744D6F64656C28293B69662821722972657475726E3B636F6E737420613D746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7444726F704564697450726F766964';
wwv_flow_imp.g_varchar2_table(25036) := '65722E6F7264657265642872292E66696C7465722828653D3E21652E64726F704D696D6554797065737C7C652E64726F704D696D6554797065732E736F6D652828653D3E6F2E6D617463686573286529292929292C6C3D617761697420746869732E6765';
wwv_flow_imp.g_varchar2_table(25037) := '7444726F70456469747328612C722C742C6F2C73293B696628732E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6966286C2E6C656E677468297B636F6E7374206E3D746869732E676574496E697469616C';
wwv_flow_imp.g_varchar2_table(25038) := '41637469766545646974496E64657828722C6C292C6F3D22616674657244726F70223D3D3D652E6765744F7074696F6E283336292E73686F7744726F7053656C6563746F723B617761697420746869732E5F706F737444726F705769646765744D616E61';
wwv_flow_imp.g_varchar2_table(25039) := '6765722E6170706C7945646974416E6453686F7749664E6565646564285B72682E66726F6D506F736974696F6E732874295D2C7B61637469766545646974496E6465783A6E2C616C6C45646974733A6C7D2C6F2C286173796E6320653D3E65292C69297D';
wwv_flow_imp.g_varchar2_table(25040) := '7D66696E616C6C797B732E646973706F736528292C746869732E5F63757272656E744F7065726174696F6E3D3D3D6F262628746869732E5F63757272656E744F7065726174696F6E3D766F69642030297D7D29293B746869732E5F64726F7050726F6772';
wwv_flow_imp.g_varchar2_table(25041) := '6573734D616E616765722E73686F775768696C6528742C6228302C2252756E6E696E672064726F702068616E646C6572732E20436C69636B20746F2063616E63656C22292C6F292C746869732E5F63757272656E744F7065726174696F6E3D6F7D617379';
wwv_flow_imp.g_varchar2_table(25042) := '6E632067657444726F70456469747328652C742C6E2C692C6F297B636F6E737420733D61776169742042742850726F6D6973652E616C6C28652E6D617028286173796E6320653D3E7B7472797B636F6E737420733D617761697420652E70726F76696465';
wwv_flow_imp.g_varchar2_table(25043) := '446F63756D656E7444726F70456469747328742C6E2C692C6F2E746F6B656E293B72657475726E206E756C6C3D3D733F766F696420303A732E6D61702828743D3E287B2E2E2E742C70726F766964657249643A652E69647D2929297D6361746368286529';
wwv_flow_imp.g_varchar2_table(25044) := '7B636F6E736F6C652E6572726F722865297D7D2929292C6F2E746F6B656E293B72657475726E20736B287A68286E756C6C213D733F733A5B5D292E666C61742829297D676574496E697469616C41637469766545646974496E64657828652C74297B636F';
wwv_flow_imp.g_varchar2_table(25045) := '6E7374206E3D746869732E5F636F6E666967536572766963652E67657456616C756528614A2C7B7265736F757263653A652E7572697D293B666F7228636F6E73745B652C695D6F66204F626A6563742E656E7472696573286E29297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(25046) := '6E65772070782869292C6F3D742E66696E64496E6465782828743D3E6E2E76616C75653D3D3D742E70726F766964657249642626742E68616E646C65644D696D65547970652626647828652C5B742E68616E646C65644D696D65547970655D2929293B69';
wwv_flow_imp.g_varchar2_table(25047) := '66286F3E3D302972657475726E206F7D72657475726E20307D6173796E632065787472616374446174615472616E73666572446174612865297B69662821652E646174615472616E736665722972657475726E206E6577206C783B636F6E737420743D5F';
wwv_flow_imp.g_varchar2_table(25048) := '7828652E646174615472616E73666572293B696628746869732E747265654974656D735472616E736665722E6861734461746128694A2E70726F746F7479706529297B636F6E737420653D746869732E747265654974656D735472616E736665722E6765';
wwv_flow_imp.g_varchar2_table(25049) := '744461746128694A2E70726F746F74797065293B69662841727261792E6973417272617928652929666F7228636F6E7374206E206F662065297B636F6E737420653D617761697420746869732E5F74726565566965777344726167416E6444726F705365';
wwv_flow_imp.g_varchar2_table(25050) := '72766963652E72656D6F7665447261674F7065726174696F6E5472616E73666572286E2E6964656E746966696572293B6966286529666F7228636F6E73745B6E2C695D6F66206529742E7265706C616365286E2C69297D7D72657475726E20747D7D3B64';
wwv_flow_imp.g_varchar2_table(25051) := '4A2E49443D22656469746F722E636F6E747269622E64726F70496E746F456469746F72436F6E74726F6C6C6572222C644A3D734A3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C';
wwv_flow_imp.g_varchar2_table(25052) := '333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F';
wwv_flow_imp.g_varchar2_table(25053) := '66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F';
wwv_flow_imp.g_varchar2_table(25054) := '6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B724A28312C7563292C724A28322C6670292C724A2833';
wwv_flow_imp.g_varchar2_table(25055) := '2C7878292C724A28342C6F4A295D2C644A292C4A6428644A2E49442C644A2C32292C7257287178292C5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B69643A6C4A2C707265636F6E6469';
wwv_flow_imp.g_varchar2_table(25056) := '74696F6E3A634A2C6B624F7074733A7B7765696768743A3130302C7072696D6172793A323133377D7D297D72756E456469746F72436F6D6D616E6428652C742C6E297B76617220693B6E756C6C3D3D3D28693D644A2E676574287429297C7C766F696420';
wwv_flow_imp.g_varchar2_table(25057) := '303D3D3D697C7C692E6368616E676544726F705479706528297D7D292C5964286E657720636C61737320657874656E64732024647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E6869646544726F7057696467657422';
wwv_flow_imp.g_varchar2_table(25058) := '2C707265636F6E646974696F6E3A634A2C6B624F7074733A7B7765696768743A3130302C7072696D6172793A397D7D297D72756E456469746F72436F6D6D616E6428652C742C6E297B76617220693B6E756C6C3D3D3D28693D644A2E676574287429297C';
wwv_flow_imp.g_varchar2_table(25059) := '7C766F696420303D3D3D697C7C692E636C6561725769646765747328297D7D292C79642E6173285470292E7265676973746572436F6E66696775726174696F6E287B2E2E2E5A4C2C70726F706572746965733A7B5B614A5D3A7B747970653A226F626A65';
wwv_flow_imp.g_varchar2_table(25060) := '6374222C73636F70653A352C6465736372697074696F6E3A6228302C22436F6E66696775726573207468652064656661756C742064726F702070726F766964657220746F2075736520666F7220636F6E74656E74206F66206120676976656E206D696D65';
wwv_flow_imp.g_varchar2_table(25061) := '20747970652E22292C64656661756C743A7B7D2C6164646974696F6E616C50726F706572746965733A7B747970653A22737472696E67227D7D7D7D293B636C61737320684A7B636F6E7374727563746F722865297B746869732E5F656469746F723D652C';
wwv_flow_imp.g_varchar2_table(25062) := '746869732E5F6465636F726174696F6E733D5B5D2C746869732E5F6F7665727669657752756C6572417070726F78696D6174654465636F726174696F6E733D5B5D2C746869732E5F66696E6453636F70654465636F726174696F6E4964733D5B5D2C7468';
wwv_flow_imp.g_varchar2_table(25063) := '69732E5F72616E6765486967686C696768744465636F726174696F6E49643D6E756C6C2C746869732E5F686967686C6967687465644465636F726174696F6E49643D6E756C6C2C746869732E5F7374617274506F736974696F6E3D746869732E5F656469';
wwv_flow_imp.g_varchar2_table(25064) := '746F722E676574506F736974696F6E28297D646973706F736528297B746869732E5F656469746F722E72656D6F76654465636F726174696F6E7328746869732E5F616C6C4465636F726174696F6E732829292C746869732E5F6465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(25065) := '3D5B5D2C746869732E5F6F7665727669657752756C6572417070726F78696D6174654465636F726174696F6E733D5B5D2C746869732E5F66696E6453636F70654465636F726174696F6E4964733D5B5D2C746869732E5F72616E6765486967686C696768';
wwv_flow_imp.g_varchar2_table(25066) := '744465636F726174696F6E49643D6E756C6C2C746869732E5F686967686C6967687465644465636F726174696F6E49643D6E756C6C7D726573657428297B746869732E5F6465636F726174696F6E733D5B5D2C746869732E5F6F7665727669657752756C';
wwv_flow_imp.g_varchar2_table(25067) := '6572417070726F78696D6174654465636F726174696F6E733D5B5D2C746869732E5F66696E6453636F70654465636F726174696F6E4964733D5B5D2C746869732E5F72616E6765486967686C696768744465636F726174696F6E49643D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(25068) := '69732E5F686967686C6967687465644465636F726174696F6E49643D6E756C6C7D676574436F756E7428297B72657475726E20746869732E5F6465636F726174696F6E732E6C656E6774687D67657446696E6453636F706528297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(25069) := '69732E5F66696E6453636F70654465636F726174696F6E4964735B305D3F746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528746869732E5F66696E6453636F70654465636F726174696F6E4964';
wwv_flow_imp.g_varchar2_table(25070) := '735B305D293A6E756C6C7D67657446696E6453636F70657328297B696628746869732E5F66696E6453636F70654465636F726174696F6E4964732E6C656E677468297B636F6E737420653D746869732E5F66696E6453636F70654465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(25071) := '4964732E6D61702828653D3E746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528652929292E66696C7465722828653D3E21216529293B696628652E6C656E6774682972657475726E20657D7265';
wwv_flow_imp.g_varchar2_table(25072) := '7475726E206E756C6C7D6765745374617274506F736974696F6E28297B72657475726E20746869732E5F7374617274506F736974696F6E7D7365745374617274506F736974696F6E2865297B746869732E5F7374617274506F736974696F6E3D652C7468';
wwv_flow_imp.g_varchar2_table(25073) := '69732E73657443757272656E7446696E644D61746368286E756C6C297D5F6765744465636F726174696F6E496E6465782865297B636F6E737420743D746869732E5F6465636F726174696F6E732E696E6465784F662865293B72657475726E20743E3D30';
wwv_flow_imp.g_varchar2_table(25074) := '3F742B313A317D6765744465636F726174696F6E52616E676541742865297B636F6E737420743D653C746869732E5F6465636F726174696F6E732E6C656E6774683F746869732E5F6465636F726174696F6E735B655D3A6E756C6C3B72657475726E2074';
wwv_flow_imp.g_varchar2_table(25075) := '3F746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652874293A6E756C6C7D67657443757272656E744D617463686573506F736974696F6E2865297B636F6E737420743D746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(25076) := '722E6765744D6F64656C28292E6765744465636F726174696F6E73496E52616E67652865293B666F7228636F6E73742065206F662074297B636F6E737420743D652E6F7074696F6E733B696628743D3D3D684A2E5F46494E445F4D415443485F4445434F';
wwv_flow_imp.g_varchar2_table(25077) := '524154494F4E7C7C743D3D3D684A2E5F43555252454E545F46494E445F4D415443485F4445434F524154494F4E2972657475726E20746869732E5F6765744465636F726174696F6E496E64657828652E6964297D72657475726E20307D73657443757272';
wwv_flow_imp.g_varchar2_table(25078) := '656E7446696E644D617463682865297B6C657420743D6E756C6C2C6E3D303B6966286529666F72286C657420693D302C6F3D746869732E5F6465636F726174696F6E732E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D746869732E5F6564';
wwv_flow_imp.g_varchar2_table(25079) := '69746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528746869732E5F6465636F726174696F6E735B695D293B696628652E657175616C7352616E6765286F29297B743D746869732E5F6465636F726174696F6E735B695D';
wwv_flow_imp.g_varchar2_table(25080) := '2C6E3D692B313B627265616B7D7D72657475726E206E756C6C3D3D3D746869732E5F686967686C6967687465644465636F726174696F6E496426266E756C6C3D3D3D747C7C746869732E5F656469746F722E6368616E67654465636F726174696F6E7328';
wwv_flow_imp.g_varchar2_table(25081) := '28653D3E7B6966286E756C6C213D3D746869732E5F686967686C6967687465644465636F726174696F6E4964262628652E6368616E67654465636F726174696F6E4F7074696F6E7328746869732E5F686967686C6967687465644465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(25082) := '49642C684A2E5F46494E445F4D415443485F4445434F524154494F4E292C746869732E5F686967686C6967687465644465636F726174696F6E49643D6E756C6C292C6E756C6C213D3D74262628746869732E5F686967686C6967687465644465636F7261';
wwv_flow_imp.g_varchar2_table(25083) := '74696F6E49643D742C652E6368616E67654465636F726174696F6E4F7074696F6E7328746869732E5F686967686C6967687465644465636F726174696F6E49642C684A2E5F43555252454E545F46494E445F4D415443485F4445434F524154494F4E2929';
wwv_flow_imp.g_varchar2_table(25084) := '2C6E756C6C213D3D746869732E5F72616E6765486967686C696768744465636F726174696F6E4964262628652E72656D6F76654465636F726174696F6E28746869732E5F72616E6765486967686C696768744465636F726174696F6E4964292C74686973';
wwv_flow_imp.g_varchar2_table(25085) := '2E5F72616E6765486967686C696768744465636F726174696F6E49643D6E756C6C292C6E756C6C213D3D74297B6C6574206E3D746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652874293B696628';
wwv_flow_imp.g_varchar2_table(25086) := '6E2E73746172744C696E654E756D626572213D3D6E2E656E644C696E654E756D6265722626313D3D3D6E2E656E64436F6C756D6E297B636F6E737420653D6E2E656E644C696E654E756D6265722D312C743D746869732E5F656469746F722E6765744D6F';
wwv_flow_imp.g_varchar2_table(25087) := '64656C28292E6765744C696E654D6178436F6C756D6E2865293B6E3D6E6577207268286E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2C652C74297D746869732E5F72616E6765486967686C696768744465636F72617469';
wwv_flow_imp.g_varchar2_table(25088) := '6F6E49643D652E6164644465636F726174696F6E286E2C684A2E5F52414E47455F484947484C494748545F4445434F524154494F4E297D7D29292C6E7D73657428652C74297B746869732E5F656469746F722E6368616E67654465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(25089) := '28286E3D3E7B6C657420693D684A2E5F46494E445F4D415443485F4445434F524154494F4E3B636F6E7374206F3D5B5D3B696628652E6C656E6774683E316533297B693D684A2E5F46494E445F4D415443485F4E4F5F4F564552564945575F4445434F52';
wwv_flow_imp.g_varchar2_table(25090) := '4154494F4E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292E6765744C696E65436F756E7428292C6E3D746869732E5F656469746F722E6765744C61796F7574496E666F28292E6865696768742F742C733D4D6174682E';
wwv_flow_imp.g_varchar2_table(25091) := '6D617828322C4D6174682E6365696C28332F6E29293B6C657420723D655B305D2E72616E67652E73746172744C696E654E756D6265722C613D655B305D2E72616E67652E656E644C696E654E756D6265723B666F72286C657420743D312C6E3D652E6C65';
wwv_flow_imp.g_varchar2_table(25092) := '6E6774683B743C6E3B742B2B297B636F6E7374206E3D655B745D2E72616E67653B612B733E3D6E2E73746172744C696E654E756D6265723F6E2E656E644C696E654E756D6265723E61262628613D6E2E656E644C696E654E756D626572293A286F2E7075';
wwv_flow_imp.g_varchar2_table(25093) := '7368287B72616E67653A6E657720726828722C312C612C31292C6F7074696F6E733A684A2E5F46494E445F4D415443485F4F4E4C595F4F564552564945575F4445434F524154494F4E7D292C723D6E2E73746172744C696E654E756D6265722C613D6E2E';
wwv_flow_imp.g_varchar2_table(25094) := '656E644C696E654E756D626572297D6F2E70757368287B72616E67653A6E657720726828722C312C612C31292C6F7074696F6E733A684A2E5F46494E445F4D415443485F4F4E4C595F4F564552564945575F4445434F524154494F4E7D297D636F6E7374';
wwv_flow_imp.g_varchar2_table(25095) := '20733D6E657720417272617928652E6C656E677468293B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B29735B745D3D7B72616E67653A655B745D2E72616E67652C6F7074696F6E733A697D3B746869732E5F6465636F7261';
wwv_flow_imp.g_varchar2_table(25096) := '74696F6E733D6E2E64656C74614465636F726174696F6E7328746869732E5F6465636F726174696F6E732C73292C746869732E5F6F7665727669657752756C6572417070726F78696D6174654465636F726174696F6E733D6E2E64656C74614465636F72';
wwv_flow_imp.g_varchar2_table(25097) := '6174696F6E7328746869732E5F6F7665727669657752756C6572417070726F78696D6174654465636F726174696F6E732C6F292C746869732E5F72616E6765486967686C696768744465636F726174696F6E49642626286E2E72656D6F76654465636F72';
wwv_flow_imp.g_varchar2_table(25098) := '6174696F6E28746869732E5F72616E6765486967686C696768744465636F726174696F6E4964292C746869732E5F72616E6765486967686C696768744465636F726174696F6E49643D6E756C6C292C746869732E5F66696E6453636F70654465636F7261';
wwv_flow_imp.g_varchar2_table(25099) := '74696F6E4964732E6C656E677468262628746869732E5F66696E6453636F70654465636F726174696F6E4964732E666F72456163682828653D3E6E2E72656D6F76654465636F726174696F6E28652929292C746869732E5F66696E6453636F7065446563';
wwv_flow_imp.g_varchar2_table(25100) := '6F726174696F6E4964733D5B5D292C286E756C6C3D3D743F766F696420303A742E6C656E67746829262628746869732E5F66696E6453636F70654465636F726174696F6E4964733D742E6D61702828653D3E6E2E6164644465636F726174696F6E28652C';
wwv_flow_imp.g_varchar2_table(25101) := '684A2E5F46494E445F53434F50455F4445434F524154494F4E292929297D29297D6D617463684265666F7265506F736974696F6E2865297B696628303D3D3D746869732E5F6465636F726174696F6E732E6C656E6774682972657475726E206E756C6C3B';
wwv_flow_imp.g_varchar2_table(25102) := '666F72286C657420743D746869732E5F6465636F726174696F6E732E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D746869732E5F6465636F726174696F6E735B745D2C693D746869732E5F656469746F722E6765744D6F64656C28';
wwv_flow_imp.g_varchar2_table(25103) := '292E6765744465636F726174696F6E52616E6765286E293B6966286926262128692E656E644C696E654E756D6265723E652E6C696E654E756D62657229297B696628692E656E644C696E654E756D6265723C652E6C696E654E756D626572297265747572';
wwv_flow_imp.g_varchar2_table(25104) := '6E20693B6966282128692E656E64436F6C756D6E3E652E636F6C756D6E292972657475726E20697D7D72657475726E20746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E676528746869732E5F646563';
wwv_flow_imp.g_varchar2_table(25105) := '6F726174696F6E735B746869732E5F6465636F726174696F6E732E6C656E6774682D315D297D6D617463684166746572506F736974696F6E2865297B696628303D3D3D746869732E5F6465636F726174696F6E732E6C656E6774682972657475726E206E';
wwv_flow_imp.g_varchar2_table(25106) := '756C6C3B666F72286C657420743D302C6E3D746869732E5F6465636F726174696F6E732E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D746869732E5F6465636F726174696F6E735B745D2C693D746869732E5F656469746F722E6765744D';
wwv_flow_imp.g_varchar2_table(25107) := '6F64656C28292E6765744465636F726174696F6E52616E6765286E293B6966286926262128692E73746172744C696E654E756D6265723C652E6C696E654E756D62657229297B696628692E73746172744C696E654E756D6265723E652E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(25108) := '6265722972657475726E20693B6966282128692E7374617274436F6C756D6E3C652E636F6C756D6E292972657475726E20697D7D72657475726E20746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67';
wwv_flow_imp.g_varchar2_table(25109) := '6528746869732E5F6465636F726174696F6E735B305D297D5F616C6C4465636F726174696F6E7328297B6C657420653D5B5D3B72657475726E20653D652E636F6E63617428746869732E5F6465636F726174696F6E73292C653D652E636F6E6361742874';
wwv_flow_imp.g_varchar2_table(25110) := '6869732E5F6F7665727669657752756C6572417070726F78696D6174654465636F726174696F6E73292C746869732E5F66696E6453636F70654465636F726174696F6E4964732E6C656E6774682626652E70757368282E2E2E746869732E5F66696E6453';
wwv_flow_imp.g_varchar2_table(25111) := '636F70654465636F726174696F6E496473292C746869732E5F72616E6765486967686C696768744465636F726174696F6E49642626652E7075736828746869732E5F72616E6765486967686C696768744465636F726174696F6E4964292C657D7D684A2E';
wwv_flow_imp.g_varchar2_table(25112) := '5F43555252454E545F46494E445F4D415443485F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A2263757272656E742D66696E642D6D61746368222C737469636B696E6573733A312C7A496E6465783A31332C';
wwv_flow_imp.g_varchar2_table(25113) := '636C6173734E616D653A2263757272656E7446696E644D61746368222C73686F774966436F6C6C61707365643A21302C6F7665727669657752756C65723A7B636F6C6F723A4F62284766292C706F736974696F6E3A53682E43656E7465727D2C6D696E69';
wwv_flow_imp.g_varchar2_table(25114) := '6D61703A7B636F6C6F723A4F62284A66292C706F736974696F6E3A317D7D292C684A2E5F46494E445F4D415443485F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A2266696E642D6D61746368222C73746963';
wwv_flow_imp.g_varchar2_table(25115) := '6B696E6573733A312C7A496E6465783A31302C636C6173734E616D653A2266696E644D61746368222C73686F774966436F6C6C61707365643A21302C6F7665727669657752756C65723A7B636F6C6F723A4F62284766292C706F736974696F6E3A53682E';
wwv_flow_imp.g_varchar2_table(25116) := '43656E7465727D2C6D696E696D61703A7B636F6C6F723A4F62284A66292C706F736974696F6E3A317D7D292C684A2E5F46494E445F4D415443485F4E4F5F4F564552564945575F4445434F524154494F4E3D4F432E7265676973746572287B6465736372';
wwv_flow_imp.g_varchar2_table(25117) := '697074696F6E3A2266696E642D6D617463682D6E6F2D6F76657276696577222C737469636B696E6573733A312C636C6173734E616D653A2266696E644D61746368222C73686F774966436F6C6C61707365643A21307D292C684A2E5F46494E445F4D4154';
wwv_flow_imp.g_varchar2_table(25118) := '43485F4F4E4C595F4F564552564945575F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A2266696E642D6D617463682D6F6E6C792D6F76657276696577222C737469636B696E6573733A312C6F766572766965';
wwv_flow_imp.g_varchar2_table(25119) := '7752756C65723A7B636F6C6F723A4F62284766292C706F736974696F6E3A53682E43656E7465727D7D292C684A2E5F52414E47455F484947484C494748545F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22';
wwv_flow_imp.g_varchar2_table(25120) := '66696E642D72616E67652D686967686C69676874222C737469636B696E6573733A312C636C6173734E616D653A2272616E6765486967686C69676874222C697357686F6C654C696E653A21307D292C684A2E5F46494E445F53434F50455F4445434F5241';
wwv_flow_imp.g_varchar2_table(25121) := '54494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A2266696E642D73636F7065222C636C6173734E616D653A2266696E6453636F7065222C697357686F6C654C696E653A21307D293B636C61737320754A7B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(25122) := '6F7228652C742C6E297B746869732E5F656469746F7253656C656374696F6E3D652C746869732E5F72616E6765733D742C746869732E5F7265706C616365537472696E67733D6E2C746869732E5F747261636B6564456469746F7253656C656374696F6E';
wwv_flow_imp.g_varchar2_table(25123) := '49643D6E756C6C7D676574456469744F7065726174696F6E7328652C74297B696628746869732E5F72616E6765732E6C656E6774683E30297B636F6E737420653D5B5D3B666F72286C657420743D303B743C746869732E5F72616E6765732E6C656E6774';
wwv_flow_imp.g_varchar2_table(25124) := '683B742B2B29652E70757368287B72616E67653A746869732E5F72616E6765735B745D2C746578743A746869732E5F7265706C616365537472696E67735B745D7D293B652E736F7274282828652C74293D3E72682E636F6D7061726552616E6765735573';
wwv_flow_imp.g_varchar2_table(25125) := '696E6753746172747328652E72616E67652C742E72616E67652929293B636F6E7374206E3D5B5D3B6C657420693D655B305D3B666F72286C657420743D313B743C652E6C656E6774683B742B2B29692E72616E67652E656E644C696E654E756D6265723D';
wwv_flow_imp.g_varchar2_table(25126) := '3D3D655B745D2E72616E67652E73746172744C696E654E756D6265722626692E72616E67652E656E64436F6C756D6E3D3D3D655B745D2E72616E67652E7374617274436F6C756D6E3F28692E72616E67653D692E72616E67652E706C757352616E676528';
wwv_flow_imp.g_varchar2_table(25127) := '655B745D2E72616E6765292C692E746578743D692E746578742B655B745D2E74657874293A286E2E707573682869292C693D655B745D293B6E2E707573682869293B666F7228636F6E73742065206F66206E29742E616464456469744F7065726174696F';
wwv_flow_imp.g_varchar2_table(25128) := '6E28652E72616E67652C652E74657874297D746869732E5F747261636B6564456469746F7253656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F656469746F7253656C656374696F6E297D636F6D7075746543757273';
wwv_flow_imp.g_varchar2_table(25129) := '6F72537461746528652C74297B72657475726E20742E676574547261636B656453656C656374696F6E28746869732E5F747261636B6564456469746F7253656C656374696F6E4964297D7D66756E6374696F6E20704A28652C74297B6966286526262222';
wwv_flow_imp.g_varchar2_table(25130) := '213D3D655B305D297B636F6E7374206E3D674A28652C742C222D22292C693D674A28652C742C225F22293B72657475726E206E262621693F6D4A28652C742C222D22293A216E2626693F6D4A28652C742C225F22293A655B305D2E746F55707065724361';
wwv_flow_imp.g_varchar2_table(25131) := '736528293D3D3D655B305D3F742E746F55707065724361736528293A655B305D2E746F4C6F7765724361736528293D3D3D655B305D3F742E746F4C6F7765724361736528293A66756E6374696F6E28652C743D2131297B72657475726E21216526262874';
wwv_flow_imp.g_varchar2_table(25132) := '262628653D652E7265706C616365282F5C5C2E2F672C222229292C652E746F4C6F776572436173652829213D3D65297D28655B305D5B305D292626742E6C656E6774683E303F745B305D2E746F55707065724361736528292B742E737562737472283129';
wwv_flow_imp.g_varchar2_table(25133) := '3A655B305D5B305D2E746F5570706572436173652829213D3D655B305D5B305D2626742E6C656E6774683E303F745B305D2E746F4C6F7765724361736528292B742E7375627374722831293A747D72657475726E20747D66756E6374696F6E20674A2865';
wwv_flow_imp.g_varchar2_table(25134) := '2C742C6E297B72657475726E2D31213D3D655B305D2E696E6465784F66286E2926262D31213D3D742E696E6465784F66286E292626655B305D2E73706C6974286E292E6C656E6774683D3D3D742E73706C6974286E292E6C656E6774687D66756E637469';
wwv_flow_imp.g_varchar2_table(25135) := '6F6E206D4A28652C742C6E297B636F6E737420693D742E73706C6974286E292C6F3D655B305D2E73706C6974286E293B6C657420733D22223B72657475726E20692E666F7245616368282828652C74293D3E7B732B3D704A285B6F5B745D5D2C65292B6E';
wwv_flow_imp.g_varchar2_table(25136) := '7D29292C732E736C69636528302C2D31297D636C61737320664A7B636F6E7374727563746F722865297B746869732E73746174696356616C75653D652C746869732E6B696E643D307D7D636C61737320764A7B636F6E7374727563746F722865297B7468';
wwv_flow_imp.g_varchar2_table(25137) := '69732E7069656365733D652C746869732E6B696E643D317D7D636C61737320624A7B7374617469632066726F6D53746174696356616C75652865297B72657475726E206E657720624A285B5F4A2E73746174696356616C75652865295D297D6765742068';
wwv_flow_imp.g_varchar2_table(25138) := '61735265706C6163656D656E745061747465726E7328297B72657475726E20313D3D3D746869732E5F73746174652E6B696E647D636F6E7374727563746F722865297B65262630213D3D652E6C656E6774683F313D3D3D652E6C656E67746826266E756C';
wwv_flow_imp.g_varchar2_table(25139) := '6C213D3D655B305D2E73746174696356616C75653F746869732E5F73746174653D6E657720664A28655B305D2E73746174696356616C7565293A746869732E5F73746174653D6E657720764A2865293A746869732E5F73746174653D6E657720664A2822';
wwv_flow_imp.g_varchar2_table(25140) := '22297D6275696C645265706C616365537472696E6728652C74297B696628303D3D3D746869732E5F73746174652E6B696E642972657475726E20743F704A28652C746869732E5F73746174652E73746174696356616C7565293A746869732E5F73746174';
wwv_flow_imp.g_varchar2_table(25141) := '652E73746174696356616C75653B6C6574206E3D22223B666F72286C657420743D302C693D746869732E5F73746174652E7069656365732E6C656E6774683B743C693B742B2B297B636F6E737420693D746869732E5F73746174652E7069656365735B74';
wwv_flow_imp.g_varchar2_table(25142) := '5D3B6966286E756C6C213D3D692E73746174696356616C7565297B6E2B3D692E73746174696356616C75653B636F6E74696E75657D6C6574206F3D624A2E5F7375627374697475746528692E6D61746368496E6465782C65293B6966286E756C6C213D3D';
wwv_flow_imp.g_varchar2_table(25143) := '692E636173654F70732626692E636173654F70732E6C656E6774683E30297B636F6E737420653D5B5D2C743D692E636173654F70732E6C656E6774683B6C6574206E3D303B666F72286C657420733D302C723D6F2E6C656E6774683B733C723B732B2B29';
wwv_flow_imp.g_varchar2_table(25144) := '7B6966286E3E3D74297B652E70757368286F2E736C696365287329293B627265616B7D73776974636828692E636173654F70735B6E5D297B636173652255223A652E70757368286F5B735D2E746F5570706572436173652829293B627265616B3B636173';
wwv_flow_imp.g_varchar2_table(25145) := '652275223A652E70757368286F5B735D2E746F5570706572436173652829292C6E2B2B3B627265616B3B63617365224C223A652E70757368286F5B735D2E746F4C6F776572436173652829293B627265616B3B63617365226C223A652E70757368286F5B';
wwv_flow_imp.g_varchar2_table(25146) := '735D2E746F4C6F776572436173652829292C6E2B2B3B627265616B3B64656661756C743A652E70757368286F5B735D297D7D6F3D652E6A6F696E282222297D6E2B3D6F7D72657475726E206E7D737461746963205F7375627374697475746528652C7429';
wwv_flow_imp.g_varchar2_table(25147) := '7B6966286E756C6C3D3D3D742972657475726E22223B696628303D3D3D652972657475726E20745B305D3B6C6574206E3D22223B666F72283B653E303B297B696628653C742E6C656E6774682972657475726E28745B655D7C7C2222292B6E3B6E3D5374';
wwv_flow_imp.g_varchar2_table(25148) := '72696E672865253130292B6E2C653D4D6174682E666C6F6F7228652F3130297D72657475726E2224222B6E7D7D636C617373205F4A7B7374617469632073746174696356616C75652865297B72657475726E206E6577205F4A28652C2D312C6E756C6C29';
wwv_flow_imp.g_varchar2_table(25149) := '7D73746174696320636173654F707328652C74297B72657475726E206E6577205F4A286E756C6C2C652C74297D636F6E7374727563746F7228652C742C6E297B746869732E73746174696356616C75653D652C746869732E6D61746368496E6465783D74';
wwv_flow_imp.g_varchar2_table(25150) := '2C6E262630213D3D6E2E6C656E6774683F746869732E636173654F70733D6E2E736C6963652830293A746869732E636173654F70733D6E756C6C7D7D636C61737320794A7B636F6E7374727563746F722865297B746869732E5F736F757263653D652C74';
wwv_flow_imp.g_varchar2_table(25151) := '6869732E5F6C61737443686172496E6465783D302C746869732E5F726573756C743D5B5D2C746869732E5F726573756C744C656E3D302C746869732E5F63757272656E7453746174696350696563653D22227D656D6974556E6368616E6765642865297B';
wwv_flow_imp.g_varchar2_table(25152) := '746869732E5F656D697453746174696328746869732E5F736F757263652E737562737472696E6728746869732E5F6C61737443686172496E6465782C6529292C746869732E5F6C61737443686172496E6465783D657D656D697453746174696328652C74';
wwv_flow_imp.g_varchar2_table(25153) := '297B746869732E5F656D69745374617469632865292C746869732E5F6C61737443686172496E6465783D747D5F656D69745374617469632865297B30213D3D652E6C656E677468262628746869732E5F63757272656E7453746174696350696563652B3D';
wwv_flow_imp.g_varchar2_table(25154) := '65297D656D69744D61746368496E64657828652C742C6E297B30213D3D746869732E5F63757272656E7453746174696350696563652E6C656E677468262628746869732E5F726573756C745B746869732E5F726573756C744C656E2B2B5D3D5F4A2E7374';
wwv_flow_imp.g_varchar2_table(25155) := '6174696356616C756528746869732E5F63757272656E745374617469635069656365292C746869732E5F63757272656E7453746174696350696563653D2222292C746869732E5F726573756C745B746869732E5F726573756C744C656E2B2B5D3D5F4A2E';
wwv_flow_imp.g_varchar2_table(25156) := '636173654F707328652C6E292C746869732E5F6C61737443686172496E6465783D747D66696E616C697A6528297B72657475726E20746869732E656D6974556E6368616E67656428746869732E5F736F757263652E6C656E677468292C30213D3D746869';
wwv_flow_imp.g_varchar2_table(25157) := '732E5F63757272656E7453746174696350696563652E6C656E677468262628746869732E5F726573756C745B746869732E5F726573756C744C656E2B2B5D3D5F4A2E73746174696356616C756528746869732E5F63757272656E74537461746963506965';
wwv_flow_imp.g_varchar2_table(25158) := '6365292C746869732E5F63757272656E7453746174696350696563653D2222292C6E657720624A28746869732E5F726573756C74297D7D636F6E737420774A3D6E6577206C64282266696E6457696467657456697369626C65222C2131292C434A3D2877';
wwv_flow_imp.g_varchar2_table(25159) := '4A2E746F4E65676174656428292C6E6577206C64282266696E64496E707574466F637573736564222C213129292C534A3D6E6577206C6428227265706C616365496E707574466F637573736564222C2131292C784A3D7B7072696D6172793A3534352C6D';
wwv_flow_imp.g_varchar2_table(25160) := '61633A7B7072696D6172793A323539337D7D2C6B4A3D7B7072696D6172793A3536352C6D61633A7B7072696D6172793A323631337D7D2C454A3D7B7072696D6172793A3536302C6D61633A7B7072696D6172793A323630387D7D2C4C4A3D7B7072696D61';
wwv_flow_imp.g_varchar2_table(25161) := '72793A3535342C6D61633A7B7072696D6172793A323630327D7D2C444A3D7B7072696D6172793A3535382C6D61633A7B7072696D6172793A323630367D7D2C544A3D22656469746F722E616374696F6E2E6E6578744D6174636846696E64416374696F6E';
wwv_flow_imp.g_varchar2_table(25162) := '222C494A3D22656469746F722E616374696F6E2E70726576696F75734D6174636846696E64416374696F6E222C4D4A3D22636C6F736546696E64576964676574222C414A3D22746F67676C6546696E644361736553656E736974697665222C4E4A3D2274';
wwv_flow_imp.g_varchar2_table(25163) := '6F67676C6546696E6457686F6C65576F7264222C504A3D22746F67676C6546696E645265676578222C4F4A3D22746F67676C6546696E64496E53656C656374696F6E222C524A3D22746F67676C65507265736572766543617365222C464A3D2265646974';
wwv_flow_imp.g_varchar2_table(25164) := '6F722E616374696F6E2E7265706C6163654F6E65222C424A3D22656469746F722E616374696F6E2E7265706C616365416C6C222C564A3D31393939393B636C617373207A4A7B636F6E7374727563746F7228652C74297B746869732E5F746F446973706F';
wwv_flow_imp.g_varchar2_table(25165) := '73653D6E65772061742C746869732E5F656469746F723D652C746869732E5F73746174653D742C746869732E5F6973446973706F7365643D21312C746869732E5F7374617274536561726368696E6754696D65723D6E65772024742C746869732E5F6465';
wwv_flow_imp.g_varchar2_table(25166) := '636F726174696F6E733D6E657720684A2865292C746869732E5F746F446973706F73652E61646428746869732E5F6465636F726174696F6E73292C746869732E5F7570646174654465636F726174696F6E735363686564756C65723D6E6577204B742828';
wwv_flow_imp.g_varchar2_table(25167) := '28293D3E746869732E726573656172636828213129292C313030292C746869732E5F746F446973706F73652E61646428746869732E5F7570646174654465636F726174696F6E735363686564756C6572292C746869732E5F746F446973706F73652E6164';
wwv_flow_imp.g_varchar2_table(25168) := '6428746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E2828653D3E7B33213D3D652E726561736F6E262635213D3D652E726561736F6E262636213D3D652E726561736F6E7C7C746869732E5F6465636F7261';
wwv_flow_imp.g_varchar2_table(25169) := '74696F6E732E7365745374617274506F736974696F6E28746869732E5F656469746F722E676574506F736974696F6E2829297D2929292C746869732E5F69676E6F72654D6F64656C436F6E74656E744368616E6765643D21312C746869732E5F746F4469';
wwv_flow_imp.g_varchar2_table(25170) := '73706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E5F69676E6F72654D6F64656C436F6E74656E744368616E6765647C7C28652E6973466C7573682626746869';
wwv_flow_imp.g_varchar2_table(25171) := '732E5F6465636F726174696F6E732E726573657428292C746869732E5F6465636F726174696F6E732E7365745374617274506F736974696F6E28746869732E5F656469746F722E676574506F736974696F6E2829292C746869732E5F7570646174654465';
wwv_flow_imp.g_varchar2_table(25172) := '636F726174696F6E735363686564756C65722E7363686564756C652829297D2929292C746869732E5F746F446973706F73652E61646428746869732E5F73746174652E6F6E46696E645265706C61636553746174654368616E67652828653D3E74686973';
wwv_flow_imp.g_varchar2_table(25173) := '2E5F6F6E53746174654368616E6765642865292929292C746869732E72657365617263682821312C746869732E5F73746174652E73656172636853636F7065297D646973706F736528297B746869732E5F6973446973706F7365643D21302C6F74287468';
wwv_flow_imp.g_varchar2_table(25174) := '69732E5F7374617274536561726368696E6754696D6572292C746869732E5F746F446973706F73652E646973706F736528297D5F6F6E53746174654368616E6765642865297B21746869732E5F6973446973706F7365642626746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(25175) := '722E6861734D6F64656C2829262628652E736561726368537472696E677C7C652E69735265706C61636552657665616C65647C7C652E697352656765787C7C652E77686F6C65576F72647C7C652E6D61746368436173657C7C652E73656172636853636F';
wwv_flow_imp.g_varchar2_table(25176) := '706529262628746869732E5F656469746F722E6765744D6F64656C28292E6973546F6F4C61726765466F7253796E63696E6728293F28746869732E5F7374617274536561726368696E6754696D65722E63616E63656C28292C746869732E5F7374617274';
wwv_flow_imp.g_varchar2_table(25177) := '536561726368696E6754696D65722E73657449664E6F74536574282828293D3E7B652E73656172636853636F70653F746869732E726573656172636828652E6D6F7665437572736F722C746869732E5F73746174652E73656172636853636F7065293A74';
wwv_flow_imp.g_varchar2_table(25178) := '6869732E726573656172636828652E6D6F7665437572736F72297D292C32343029293A652E73656172636853636F70653F746869732E726573656172636828652E6D6F7665437572736F722C746869732E5F73746174652E73656172636853636F706529';
wwv_flow_imp.g_varchar2_table(25179) := '3A746869732E726573656172636828652E6D6F7665437572736F7229297D737461746963205F67657453656172636852616E676528652C74297B72657475726E20747C7C652E67657446756C6C4D6F64656C52616E676528297D72657365617263682865';
wwv_flow_imp.g_varchar2_table(25180) := '2C74297B6C6574206E3D6E756C6C3B766F69642030213D3D743F6E756C6C213D3D742626286E3D41727261792E697341727261792874293F743A5B745D293A6E3D746869732E5F6465636F726174696F6E732E67657446696E6453636F70657328292C6E';
wwv_flow_imp.g_varchar2_table(25181) := '756C6C213D3D6E2626286E3D6E2E6D61702828653D3E7B696628652E73746172744C696E654E756D626572213D3D652E656E644C696E654E756D626572297B6C657420743D652E656E644C696E654E756D6265723B72657475726E20313D3D3D652E656E';
wwv_flow_imp.g_varchar2_table(25182) := '64436F6C756D6E262628742D3D31292C6E657720726828652E73746172744C696E654E756D6265722C312C742C746869732E5F656469746F722E6765744D6F64656C28292E6765744C696E654D6178436F6C756D6E287429297D72657475726E20657D29';
wwv_flow_imp.g_varchar2_table(25183) := '29293B636F6E737420693D746869732E5F66696E644D617463686573286E2C21312C564A293B746869732E5F6465636F726174696F6E732E73657428692C6E293B636F6E7374206F3D746869732E5F656469746F722E67657453656C656374696F6E2829';
wwv_flow_imp.g_varchar2_table(25184) := '3B6C657420733D746869732E5F6465636F726174696F6E732E67657443757272656E744D617463686573506F736974696F6E286F293B696628303D3D3D732626692E6C656E6774683E30297B636F6E737420653D797528692E6D61702828653D3E652E72';
wwv_flow_imp.g_varchar2_table(25185) := '616E676529292C28653D3E72682E636F6D7061726552616E6765735573696E6753746172747328652C6F293E3D3029293B733D653E303F652D312B313A737D746869732E5F73746174652E6368616E67654D61746368496E666F28732C746869732E5F64';
wwv_flow_imp.g_varchar2_table(25186) := '65636F726174696F6E732E676574436F756E7428292C766F69642030292C652626746869732E5F656469746F722E6765744F7074696F6E283431292E637572736F724D6F76654F6E547970652626746869732E5F6D6F7665546F4E6578744D6174636828';
wwv_flow_imp.g_varchar2_table(25187) := '746869732E5F6465636F726174696F6E732E6765745374617274506F736974696F6E2829297D5F6861734D61746368657328297B72657475726E20746869732E5F73746174652E6D617463686573436F756E743E307D5F63616E6E6F7446696E6428297B';
wwv_flow_imp.g_varchar2_table(25188) := '69662821746869732E5F6861734D6174636865732829297B636F6E737420653D746869732E5F6465636F726174696F6E732E67657446696E6453636F706528293B72657475726E20652626746869732E5F656469746F722E72657665616C52616E676549';
wwv_flow_imp.g_varchar2_table(25189) := '6E43656E74657249664F75747369646556696577706F727428652C30292C21307D72657475726E21317D5F73657443757272656E7446696E644D617463682865297B636F6E737420743D746869732E5F6465636F726174696F6E732E7365744375727265';
wwv_flow_imp.g_varchar2_table(25190) := '6E7446696E644D617463682865293B746869732E5F73746174652E6368616E67654D61746368496E666F28742C746869732E5F6465636F726174696F6E732E676574436F756E7428292C65292C746869732E5F656469746F722E73657453656C65637469';
wwv_flow_imp.g_varchar2_table(25191) := '6F6E2865292C746869732E5F656469746F722E72657665616C52616E6765496E43656E74657249664F75747369646556696577706F727428652C30297D5F70726576536561726368506F736974696F6E2865297B636F6E737420743D746869732E5F7374';
wwv_flow_imp.g_varchar2_table(25192) := '6174652E69735265676578262628746869732E5F73746174652E736561726368537472696E672E696E6465784F6628225E22293E3D307C7C746869732E5F73746174652E736561726368537472696E672E696E6465784F6628222422293E3D30293B6C65';
wwv_flow_imp.g_varchar2_table(25193) := '747B6C696E654E756D6265723A6E2C636F6C756D6E3A697D3D653B636F6E7374206F3D746869732E5F656469746F722E6765744D6F64656C28293B72657475726E20747C7C313D3D3D693F28313D3D3D6E3F6E3D6F2E6765744C696E65436F756E742829';
wwv_flow_imp.g_varchar2_table(25194) := '3A6E2D2D2C693D6F2E6765744C696E654D6178436F6C756D6E286E29293A692D2D2C6E6577206D63286E2C69297D5F6D6F7665546F507265764D6174636828652C743D2131297B69662821746869732E5F73746174652E63616E4E617669676174654261';
wwv_flow_imp.g_varchar2_table(25195) := '636B2829297B636F6E737420743D746869732E5F6465636F726174696F6E732E6D617463684166746572506F736974696F6E2865293B72657475726E20766F696428742626746869732E5F73657443757272656E7446696E644D61746368287429297D69';
wwv_flow_imp.g_varchar2_table(25196) := '6628746869732E5F6465636F726174696F6E732E676574436F756E7428293C564A297B6C657420743D746869732E5F6465636F726174696F6E732E6D617463684265666F7265506F736974696F6E2865293B72657475726E20742626742E6973456D7074';
wwv_flow_imp.g_varchar2_table(25197) := '7928292626742E6765745374617274506F736974696F6E28292E657175616C73286529262628653D746869732E5F70726576536561726368506F736974696F6E2865292C743D746869732E5F6465636F726174696F6E732E6D617463684265666F726550';
wwv_flow_imp.g_varchar2_table(25198) := '6F736974696F6E286529292C766F696428742626746869732E5F73657443757272656E7446696E644D61746368287429297D696628746869732E5F63616E6E6F7446696E6428292972657475726E3B636F6E7374206E3D746869732E5F6465636F726174';
wwv_flow_imp.g_varchar2_table(25199) := '696F6E732E67657446696E6453636F706528292C693D7A4A2E5F67657453656172636852616E676528746869732E5F656469746F722E6765744D6F64656C28292C6E293B692E676574456E64506F736974696F6E28292E69734265666F72652865292626';
wwv_flow_imp.g_varchar2_table(25200) := '28653D692E676574456E64506F736974696F6E2829292C652E69734265666F726528692E6765745374617274506F736974696F6E282929262628653D692E676574456E64506F736974696F6E2829293B636F6E73747B6C696E654E756D6265723A6F2C63';
wwv_flow_imp.g_varchar2_table(25201) := '6F6C756D6E3A737D3D652C723D746869732E5F656469746F722E6765744D6F64656C28293B6C657420613D6E6577206D63286F2C73292C6C3D722E66696E6450726576696F75734D6174636828746869732E5F73746174652E736561726368537472696E';
wwv_flow_imp.g_varchar2_table(25202) := '672C612C746869732E5F73746174652E697352656765782C746869732E5F73746174652E6D61746368436173652C746869732E5F73746174652E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C';
wwv_flow_imp.g_varchar2_table(25203) := '2C2131293B72657475726E206C26266C2E72616E67652E6973456D707479282926266C2E72616E67652E6765745374617274506F736974696F6E28292E657175616C73286129262628613D746869732E5F70726576536561726368506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(25204) := '61292C6C3D722E66696E6450726576696F75734D6174636828746869732E5F73746174652E736561726368537472696E672C612C746869732E5F73746174652E697352656765782C746869732E5F73746174652E6D61746368436173652C746869732E5F';
wwv_flow_imp.g_varchar2_table(25205) := '73746174652E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C2C213129292C6C3F747C7C692E636F6E7461696E7352616E6765286C2E72616E6765293F766F696420746869732E5F7365744375';
wwv_flow_imp.g_varchar2_table(25206) := '7272656E7446696E644D61746368286C2E72616E6765293A746869732E5F6D6F7665546F507265764D61746368286C2E72616E67652E6765745374617274506F736974696F6E28292C2130293A766F696420307D6D6F7665546F507265764D6174636828';
wwv_flow_imp.g_varchar2_table(25207) := '297B746869732E5F6D6F7665546F507265764D6174636828746869732E5F656469746F722E67657453656C656374696F6E28292E6765745374617274506F736974696F6E2829297D5F6E657874536561726368506F736974696F6E2865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(25208) := '20743D746869732E5F73746174652E69735265676578262628746869732E5F73746174652E736561726368537472696E672E696E6465784F6628225E22293E3D307C7C746869732E5F73746174652E736561726368537472696E672E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(25209) := '222422293E3D30293B6C65747B6C696E654E756D6265723A6E2C636F6C756D6E3A697D3D653B636F6E7374206F3D746869732E5F656469746F722E6765744D6F64656C28293B72657475726E20747C7C693D3D3D6F2E6765744C696E654D6178436F6C75';
wwv_flow_imp.g_varchar2_table(25210) := '6D6E286E293F286E3D3D3D6F2E6765744C696E65436F756E7428293F6E3D313A6E2B2B2C693D31293A692B2B2C6E6577206D63286E2C69297D5F6D6F7665546F4E6578744D617463682865297B69662821746869732E5F73746174652E63616E4E617669';
wwv_flow_imp.g_varchar2_table(25211) := '67617465466F72776172642829297B636F6E737420743D746869732E5F6465636F726174696F6E732E6D617463684265666F7265506F736974696F6E2865293B72657475726E20766F696428742626746869732E5F73657443757272656E7446696E644D';
wwv_flow_imp.g_varchar2_table(25212) := '61746368287429297D696628746869732E5F6465636F726174696F6E732E676574436F756E7428293C564A297B6C657420743D746869732E5F6465636F726174696F6E732E6D617463684166746572506F736974696F6E2865293B72657475726E207426';
wwv_flow_imp.g_varchar2_table(25213) := '26742E6973456D70747928292626742E6765745374617274506F736974696F6E28292E657175616C73286529262628653D746869732E5F6E657874536561726368506F736974696F6E2865292C743D746869732E5F6465636F726174696F6E732E6D6174';
wwv_flow_imp.g_varchar2_table(25214) := '63684166746572506F736974696F6E286529292C766F696428742626746869732E5F73657443757272656E7446696E644D61746368287429297D636F6E737420743D746869732E5F6765744E6578744D6174636828652C21312C2130293B742626746869';
wwv_flow_imp.g_varchar2_table(25215) := '732E5F73657443757272656E7446696E644D6174636828742E72616E6765297D5F6765744E6578744D6174636828652C742C6E2C693D2131297B696628746869732E5F63616E6E6F7446696E6428292972657475726E206E756C6C3B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(25216) := '746869732E5F6465636F726174696F6E732E67657446696E6453636F706528292C733D7A4A2E5F67657453656172636852616E676528746869732E5F656469746F722E6765744D6F64656C28292C6F293B732E676574456E64506F736974696F6E28292E';
wwv_flow_imp.g_varchar2_table(25217) := '69734265666F7265286529262628653D732E6765745374617274506F736974696F6E2829292C652E69734265666F726528732E6765745374617274506F736974696F6E282929262628653D732E6765745374617274506F736974696F6E2829293B636F6E';
wwv_flow_imp.g_varchar2_table(25218) := '73747B6C696E654E756D6265723A722C636F6C756D6E3A617D3D652C6C3D746869732E5F656469746F722E6765744D6F64656C28293B6C657420633D6E6577206D6328722C61292C643D6C2E66696E644E6578744D6174636828746869732E5F73746174';
wwv_flow_imp.g_varchar2_table(25219) := '652E736561726368537472696E672C632C746869732E5F73746174652E697352656765782C746869732E5F73746174652E6D61746368436173652C746869732E5F73746174652E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074';
wwv_flow_imp.g_varchar2_table(25220) := '696F6E28313331293A6E756C6C2C74293B72657475726E206E2626642626642E72616E67652E6973456D70747928292626642E72616E67652E6765745374617274506F736974696F6E28292E657175616C73286329262628633D746869732E5F6E657874';
wwv_flow_imp.g_varchar2_table(25221) := '536561726368506F736974696F6E2863292C643D6C2E66696E644E6578744D6174636828746869732E5F73746174652E736561726368537472696E672C632C746869732E5F73746174652E697352656765782C746869732E5F73746174652E6D61746368';
wwv_flow_imp.g_varchar2_table(25222) := '436173652C746869732E5F73746174652E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C2C7429292C643F697C7C732E636F6E7461696E7352616E676528642E72616E6765293F643A74686973';
wwv_flow_imp.g_varchar2_table(25223) := '2E5F6765744E6578744D6174636828642E72616E67652E676574456E64506F736974696F6E28292C742C6E2C2130293A6E756C6C7D6D6F7665546F4E6578744D6174636828297B746869732E5F6D6F7665546F4E6578744D6174636828746869732E5F65';
wwv_flow_imp.g_varchar2_table(25224) := '6469746F722E67657453656C656374696F6E28292E676574456E64506F736974696F6E2829297D5F6D6F7665546F4D617463682865297B636F6E737420743D746869732E5F6465636F726174696F6E732E6765744465636F726174696F6E52616E676541';
wwv_flow_imp.g_varchar2_table(25225) := '742865293B742626746869732E5F73657443757272656E7446696E644D617463682874297D6D6F7665546F4D617463682865297B746869732E5F6D6F7665546F4D617463682865297D5F6765745265706C6163655061747465726E28297B72657475726E';
wwv_flow_imp.g_varchar2_table(25226) := '20746869732E5F73746174652E697352656765783F66756E6374696F6E2865297B69662821657C7C303D3D3D652E6C656E6774682972657475726E206E657720624A286E756C6C293B636F6E737420743D5B5D2C6E3D6E657720794A2865293B666F7228';
wwv_flow_imp.g_varchar2_table(25227) := '6C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E737420733D652E63686172436F646541742869293B6966283932213D3D73297B69662833363D3D3D73297B696628692B2B2C693E3D6F29627265616B3B636F6E737420733D';
wwv_flow_imp.g_varchar2_table(25228) := '652E63686172436F646541742869293B69662833363D3D3D73297B6E2E656D6974556E6368616E67656428692D31292C6E2E656D6974537461746963282224222C692B31293B636F6E74696E75657D69662834383D3D3D737C7C33383D3D3D73297B6E2E';
wwv_flow_imp.g_varchar2_table(25229) := '656D6974556E6368616E67656428692D31292C6E2E656D69744D61746368496E64657828302C692B312C74292C742E6C656E6774683D303B636F6E74696E75657D69662834393C3D732626733C3D3537297B6C657420723D732D34383B696628692B313C';
wwv_flow_imp.g_varchar2_table(25230) := '6F297B636F6E7374206F3D652E63686172436F6465417428692B31293B69662834383C3D6F26266F3C3D3537297B692B2B2C723D31302A722B286F2D3438292C6E2E656D6974556E6368616E67656428692D32292C6E2E656D69744D61746368496E6465';
wwv_flow_imp.g_varchar2_table(25231) := '7828722C692B312C74292C742E6C656E6774683D303B636F6E74696E75657D7D6E2E656D6974556E6368616E67656428692D31292C6E2E656D69744D61746368496E64657828722C692B312C74292C742E6C656E6774683D303B636F6E74696E75657D7D';
wwv_flow_imp.g_varchar2_table(25232) := '7D656C73657B696628692B2B2C693E3D6F29627265616B3B636F6E737420733D652E63686172436F646541742869293B7377697463682873297B636173652039323A6E2E656D6974556E6368616E67656428692D31292C6E2E656D697453746174696328';
wwv_flow_imp.g_varchar2_table(25233) := '225C5C222C692B31293B627265616B3B63617365203131303A6E2E656D6974556E6368616E67656428692D31292C6E2E656D697453746174696328225C6E222C692B31293B627265616B3B63617365203131363A6E2E656D6974556E6368616E67656428';
wwv_flow_imp.g_varchar2_table(25234) := '692D31292C6E2E656D697453746174696328225C74222C692B31293B627265616B3B63617365203131373A636173652038353A63617365203130383A636173652037363A6E2E656D6974556E6368616E67656428692D31292C6E2E656D69745374617469';
wwv_flow_imp.g_varchar2_table(25235) := '632822222C692B31292C742E7075736828537472696E672E66726F6D43686172436F6465287329297D7D7D72657475726E206E2E66696E616C697A6528297D28746869732E5F73746174652E7265706C616365537472696E67293A624A2E66726F6D5374';
wwv_flow_imp.g_varchar2_table(25236) := '6174696356616C756528746869732E5F73746174652E7265706C616365537472696E67297D7265706C61636528297B69662821746869732E5F6861734D61746368657328292972657475726E3B636F6E737420653D746869732E5F6765745265706C6163';
wwv_flow_imp.g_varchar2_table(25237) := '655061747465726E28292C743D746869732E5F656469746F722E67657453656C656374696F6E28292C6E3D746869732E5F6765744E6578744D6174636828742E6765745374617274506F736974696F6E28292C21302C2131293B6966286E29696628742E';
wwv_flow_imp.g_varchar2_table(25238) := '657175616C7352616E6765286E2E72616E676529297B636F6E737420693D652E6275696C645265706C616365537472696E67286E2E6D6174636865732C746869732E5F73746174652E707265736572766543617365292C6F3D6E6577206E5328742C6929';
wwv_flow_imp.g_varchar2_table(25239) := '3B746869732E5F65786563757465456469746F72436F6D6D616E6428227265706C616365222C6F292C746869732E5F6465636F726174696F6E732E7365745374617274506F736974696F6E286E6577206D6328742E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(25240) := '2C742E7374617274436F6C756D6E2B692E6C656E67746829292C746869732E7265736561726368282130297D656C736520746869732E5F6465636F726174696F6E732E7365745374617274506F736974696F6E28746869732E5F656469746F722E676574';
wwv_flow_imp.g_varchar2_table(25241) := '506F736974696F6E2829292C746869732E5F73657443757272656E7446696E644D61746368286E2E72616E6765297D5F66696E644D61746368657328652C742C6E297B636F6E737420693D28657C7C5B6E756C6C5D292E6D61702828653D3E7A4A2E5F67';
wwv_flow_imp.g_varchar2_table(25242) := '657453656172636852616E676528746869732E5F656469746F722E6765744D6F64656C28292C652929293B72657475726E20746869732E5F656469746F722E6765744D6F64656C28292E66696E644D61746368657328746869732E5F73746174652E7365';
wwv_flow_imp.g_varchar2_table(25243) := '61726368537472696E672C692C746869732E5F73746174652E697352656765782C746869732E5F73746174652E6D61746368436173652C746869732E5F73746174652E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28';
wwv_flow_imp.g_varchar2_table(25244) := '313331293A6E756C6C2C742C6E297D7265706C616365416C6C28297B69662821746869732E5F6861734D61746368657328292972657475726E3B636F6E737420653D746869732E5F6465636F726174696F6E732E67657446696E6453636F70657328293B';
wwv_flow_imp.g_varchar2_table(25245) := '6E756C6C3D3D3D652626746869732E5F73746174652E6D617463686573436F756E743E3D564A3F746869732E5F6C617267655265706C616365416C6C28293A746869732E5F726567756C61725265706C616365416C6C2865292C746869732E7265736561';
wwv_flow_imp.g_varchar2_table(25246) := '726368282131297D5F6C617267655265706C616365416C6C28297B636F6E737420653D6E6577205A7928746869732E5F73746174652E736561726368537472696E672C746869732E5F73746174652E697352656765782C746869732E5F73746174652E6D';
wwv_flow_imp.g_varchar2_table(25247) := '61746368436173652C746869732E5F73746174652E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C292E70617273655365617263685265717565737428293B69662821652972657475726E3B6C';
wwv_flow_imp.g_varchar2_table(25248) := '657420743D652E72656765783B69662821742E6D756C74696C696E65297B6C657420653D226D75223B742E69676E6F726543617365262628652B3D226922292C742E676C6F62616C262628652B3D226722292C743D6E65772052656745787028742E736F';
wwv_flow_imp.g_varchar2_table(25249) := '757263652C65297D636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292C693D6E2E67657456616C75652831292C6F3D6E2E67657446756C6C4D6F64656C52616E676528292C733D746869732E5F6765745265706C6163655061';
wwv_flow_imp.g_varchar2_table(25250) := '747465726E28293B6C657420723B636F6E737420613D746869732E5F73746174652E7072657365727665436173653B723D732E6861735265706C6163656D656E745061747465726E737C7C613F692E7265706C61636528742C2866756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(25251) := '7B72657475726E20732E6275696C645265706C616365537472696E6728617267756D656E74732C61297D29293A692E7265706C61636528742C732E6275696C645265706C616365537472696E67286E756C6C2C6129293B636F6E7374206C3D6E65772072';
wwv_flow_imp.g_varchar2_table(25252) := '53286F2C722C746869732E5F656469746F722E67657453656C656374696F6E2829293B746869732E5F65786563757465456469746F72436F6D6D616E6428227265706C616365416C6C222C6C297D5F726567756C61725265706C616365416C6C2865297B';
wwv_flow_imp.g_varchar2_table(25253) := '636F6E737420743D746869732E5F6765745265706C6163655061747465726E28292C6E3D746869732E5F66696E644D61746368657328652C742E6861735265706C6163656D656E745061747465726E737C7C746869732E5F73746174652E707265736572';
wwv_flow_imp.g_varchar2_table(25254) := '7665436173652C31303733373431383234292C693D5B5D3B666F72286C657420653D302C6F3D6E2E6C656E6774683B653C6F3B652B2B29695B655D3D742E6275696C645265706C616365537472696E67286E5B655D2E6D6174636865732C746869732E5F';
wwv_flow_imp.g_varchar2_table(25255) := '73746174652E707265736572766543617365293B636F6E7374206F3D6E657720754A28746869732E5F656469746F722E67657453656C656374696F6E28292C6E2E6D61702828653D3E652E72616E676529292C69293B746869732E5F6578656375746545';
wwv_flow_imp.g_varchar2_table(25256) := '6469746F72436F6D6D616E6428227265706C616365416C6C222C6F297D73656C656374416C6C4D61746368657328297B69662821746869732E5F6861734D61746368657328292972657475726E3B636F6E737420653D746869732E5F6465636F72617469';
wwv_flow_imp.g_varchar2_table(25257) := '6F6E732E67657446696E6453636F70657328293B6C657420743D746869732E5F66696E644D61746368657328652C21312C31303733373431383234292E6D61702828653D3E6E657720616828652E72616E67652E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(25258) := '652E72616E67652E7374617274436F6C756D6E2C652E72616E67652E656E644C696E654E756D6265722C652E72616E67652E656E64436F6C756D6E2929293B636F6E7374206E3D746869732E5F656469746F722E67657453656C656374696F6E28293B66';
wwv_flow_imp.g_varchar2_table(25259) := '6F72286C657420653D302C693D742E6C656E6774683B653C693B652B2B29696628745B655D2E657175616C7352616E6765286E29297B743D5B6E5D2E636F6E63617428742E736C69636528302C6529292E636F6E63617428742E736C69636528652B3129';
wwv_flow_imp.g_varchar2_table(25260) := '293B627265616B7D746869732E5F656469746F722E73657453656C656374696F6E732874297D5F65786563757465456469746F72436F6D6D616E6428652C74297B7472797B746869732E5F69676E6F72654D6F64656C436F6E74656E744368616E676564';
wwv_flow_imp.g_varchar2_table(25261) := '3D21302C746869732E5F656469746F722E70757368556E646F53746F7028292C746869732E5F656469746F722E65786563757465436F6D6D616E6428652C74292C746869732E5F656469746F722E70757368556E646F53746F7028297D66696E616C6C79';
wwv_flow_imp.g_varchar2_table(25262) := '7B746869732E5F69676E6F72654D6F64656C436F6E74656E744368616E6765643D21317D7D7D76617220484A3D6E2835363639292C574A3D7B7D3B574A2E7374796C655461675472616E73666F726D3D6A7228292C574A2E736574417474726962757465';
wwv_flow_imp.g_varchar2_table(25263) := '733D567228292C574A2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C574A2E646F6D4150493D4F7228292C574A2E696E736572745374796C65456C656D656E743D487228292C4E72282928484A2E412C574A292C484A2E41';
wwv_flow_imp.g_varchar2_table(25264) := '2626484A2E412E6C6F63616C732626484A2E412E6C6F63616C733B636C617373206A4A20657874656E64732047447B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F68696465536F6F6E3D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(25265) := '746572286E6577204B74282828293D3E746869732E5F686964652829292C32653329292C746869732E5F697356697369626C653D21312C746869732E5F656469746F723D652C746869732E5F73746174653D742C746869732E5F6B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(25266) := '536572766963653D6E2C746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D2266696E644F7074696F6E73576964676574222C7468';
wwv_flow_imp.g_varchar2_table(25267) := '69732E5F646F6D4E6F64652E7374796C652E646973706C61793D226E6F6E65222C746869732E5F646F6D4E6F64652E7374796C652E746F703D2231307078222C746869732E5F646F6D4E6F64652E7374796C652E7A496E6465783D223132222C74686973';
wwv_flow_imp.g_varchar2_table(25268) := '2E5F646F6D4E6F64652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522293B636F6E7374';
wwv_flow_imp.g_varchar2_table(25269) := '20693D7B696E7075744163746976654F7074696F6E426F726465723A786D286476292C696E7075744163746976654F7074696F6E466F726567726F756E643A786D287576292C696E7075744163746976654F7074696F6E4261636B67726F756E643A786D';
wwv_flow_imp.g_varchar2_table(25270) := '286876297D2C6F3D746869732E5F7265676973746572284F452829293B746869732E6361736553656E7369746976653D746869732E5F7265676973746572286E6577205924287B617070656E645469746C653A746869732E5F6B657962696E64696E674C';
wwv_flow_imp.g_varchar2_table(25271) := '6162656C466F7228414A292C6973436865636B65643A746869732E5F73746174652E6D61746368436173652C686F76657244656C65676174653A6F2C2E2E2E697D29292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E63';
wwv_flow_imp.g_varchar2_table(25272) := '61736553656E7369746976652E646F6D4E6F6465292C746869732E5F726567697374657228746869732E6361736553656E7369746976652E6F6E4368616E6765282828293D3E7B746869732E5F73746174652E6368616E6765287B6D6174636843617365';
wwv_flow_imp.g_varchar2_table(25273) := '3A746869732E6361736553656E7369746976652E636865636B65647D2C2131297D2929292C746869732E77686F6C65576F7264733D746869732E5F7265676973746572286E6577205A24287B617070656E645469746C653A746869732E5F6B657962696E';
wwv_flow_imp.g_varchar2_table(25274) := '64696E674C6162656C466F72284E4A292C6973436865636B65643A746869732E5F73746174652E77686F6C65576F72642C686F76657244656C65676174653A6F2C2E2E2E697D29292C746869732E5F646F6D4E6F64652E617070656E644368696C642874';
wwv_flow_imp.g_varchar2_table(25275) := '6869732E77686F6C65576F7264732E646F6D4E6F6465292C746869732E5F726567697374657228746869732E77686F6C65576F7264732E6F6E4368616E6765282828293D3E7B746869732E5F73746174652E6368616E6765287B77686F6C65576F72643A';
wwv_flow_imp.g_varchar2_table(25276) := '746869732E77686F6C65576F7264732E636865636B65647D2C2131297D2929292C746869732E72656765783D746869732E5F7265676973746572286E6577205824287B617070656E645469746C653A746869732E5F6B657962696E64696E674C6162656C';
wwv_flow_imp.g_varchar2_table(25277) := '466F7228504A292C6973436865636B65643A746869732E5F73746174652E697352656765782C686F76657244656C65676174653A6F2C2E2E2E697D29292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E72656765782E64';
wwv_flow_imp.g_varchar2_table(25278) := '6F6D4E6F6465292C746869732E5F726567697374657228746869732E72656765782E6F6E4368616E6765282828293D3E7B746869732E5F73746174652E6368616E6765287B697352656765783A746869732E72656765782E636865636B65647D2C213129';
wwv_flow_imp.g_varchar2_table(25279) := '7D2929292C746869732E5F656469746F722E6164644F7665726C61795769646765742874686973292C746869732E5F726567697374657228746869732E5F73746174652E6F6E46696E645265706C61636553746174654368616E67652828653D3E7B6C65';
wwv_flow_imp.g_varchar2_table(25280) := '7420743D21313B652E69735265676578262628746869732E72656765782E636865636B65643D746869732E5F73746174652E697352656765782C743D2130292C652E77686F6C65576F7264262628746869732E77686F6C65576F7264732E636865636B65';
wwv_flow_imp.g_varchar2_table(25281) := '643D746869732E5F73746174652E77686F6C65576F72642C743D2130292C652E6D6174636843617365262628746869732E6361736553656E7369746976652E636865636B65643D746869732E5F73746174652E6D61746368436173652C743D2130292C21';
wwv_flow_imp.g_varchar2_table(25282) := '746869732E5F73746174652E697352657665616C65642626742626746869732E5F72657665616C54656D706F726172696C7928297D2929292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C61722E4D4F5553455F4C45';
wwv_flow_imp.g_varchar2_table(25283) := '4156452C28653D3E746869732E5F6F6E4D6F7573654C6561766528292929292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C226D6F7573656F766572222C28653D3E746869732E5F6F6E4D6F7573654F766572282929';
wwv_flow_imp.g_varchar2_table(25284) := '29297D5F6B657962696E64696E674C6162656C466F722865297B636F6E737420743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672865293B72657475726E20743F602028247B742E6765744C6162';
wwv_flow_imp.g_varchar2_table(25285) := '656C28297D29603A22227D646973706F736528297B746869732E5F656469746F722E72656D6F76654F7665726C61795769646765742874686973292C73757065722E646973706F736528297D676574496428297B72657475726E206A4A2E49447D676574';
wwv_flow_imp.g_varchar2_table(25286) := '446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B707265666572656E63653A307D7D686967686C6967687446696E644F7074696F6E7328297B746869732E5F7265766561';
wwv_flow_imp.g_varchar2_table(25287) := '6C54656D706F726172696C7928297D5F72657665616C54656D706F726172696C7928297B746869732E5F73686F7728292C746869732E5F68696465536F6F6E2E7363686564756C6528297D5F6F6E4D6F7573654C6561766528297B746869732E5F686964';
wwv_flow_imp.g_varchar2_table(25288) := '65536F6F6E2E7363686564756C6528297D5F6F6E4D6F7573654F76657228297B746869732E5F68696465536F6F6E2E63616E63656C28297D5F73686F7728297B746869732E5F697356697369626C657C7C28746869732E5F697356697369626C653D2130';
wwv_flow_imp.g_varchar2_table(25289) := '2C746869732E5F646F6D4E6F64652E7374796C652E646973706C61793D22626C6F636B22297D5F6869646528297B746869732E5F697356697369626C65262628746869732E5F697356697369626C653D21312C746869732E5F646F6D4E6F64652E737479';
wwv_flow_imp.g_varchar2_table(25290) := '6C652E646973706C61793D226E6F6E6522297D7D66756E6374696F6E20714A28652C74297B72657475726E20313D3D3D657C7C32213D3D652626747D6A4A2E49443D22656469746F722E636F6E747269622E66696E644F7074696F6E7357696467657422';
wwv_flow_imp.g_varchar2_table(25291) := '3B636C61737320244A20657874656E6473206C747B67657420736561726368537472696E6728297B72657475726E20746869732E5F736561726368537472696E677D676574207265706C616365537472696E6728297B72657475726E20746869732E5F72';
wwv_flow_imp.g_varchar2_table(25292) := '65706C616365537472696E677D67657420697352657665616C656428297B72657475726E20746869732E5F697352657665616C65647D6765742069735265706C61636552657665616C656428297B72657475726E20746869732E5F69735265706C616365';
wwv_flow_imp.g_varchar2_table(25293) := '52657665616C65647D676574206973526567657828297B72657475726E20714A28746869732E5F697352656765784F766572726964652C746869732E5F69735265676578297D6765742077686F6C65576F726428297B72657475726E20714A2874686973';
wwv_flow_imp.g_varchar2_table(25294) := '2E5F77686F6C65576F72644F766572726964652C746869732E5F77686F6C65576F7264297D676574206D617463684361736528297B72657475726E20714A28746869732E5F6D61746368436173654F766572726964652C746869732E5F6D617463684361';
wwv_flow_imp.g_varchar2_table(25295) := '7365297D6765742070726573657276654361736528297B72657475726E20714A28746869732E5F7072657365727665436173654F766572726964652C746869732E5F707265736572766543617365297D6765742061637475616C4973526567657828297B';
wwv_flow_imp.g_varchar2_table(25296) := '72657475726E20746869732E5F697352656765787D6765742061637475616C57686F6C65576F726428297B72657475726E20746869732E5F77686F6C65576F72647D6765742061637475616C4D617463684361736528297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(25297) := '5F6D61746368436173657D6765742061637475616C50726573657276654361736528297B72657475726E20746869732E5F7072657365727665436173657D6765742073656172636853636F706528297B72657475726E20746869732E5F73656172636853';
wwv_flow_imp.g_varchar2_table(25298) := '636F70657D676574206D617463686573506F736974696F6E28297B72657475726E20746869732E5F6D617463686573506F736974696F6E7D676574206D617463686573436F756E7428297B72657475726E20746869732E5F6D617463686573436F756E74';
wwv_flow_imp.g_varchar2_table(25299) := '7D6765742063757272656E744D6174636828297B72657475726E20746869732E5F63757272656E744D617463687D636F6E7374727563746F7228297B737570657228292C746869732E5F6F6E46696E645265706C61636553746174654368616E67653D74';
wwv_flow_imp.g_varchar2_table(25300) := '6869732E5F7265676973746572286E6577204374292C746869732E6F6E46696E645265706C61636553746174654368616E67653D746869732E5F6F6E46696E645265706C61636553746174654368616E67652E6576656E742C746869732E5F7365617263';
wwv_flow_imp.g_varchar2_table(25301) := '68537472696E673D22222C746869732E5F7265706C616365537472696E673D22222C746869732E5F697352657665616C65643D21312C746869732E5F69735265706C61636552657665616C65643D21312C746869732E5F697352656765783D21312C7468';
wwv_flow_imp.g_varchar2_table(25302) := '69732E5F697352656765784F766572726964653D302C746869732E5F77686F6C65576F72643D21312C746869732E5F77686F6C65576F72644F766572726964653D302C746869732E5F6D61746368436173653D21312C746869732E5F6D61746368436173';
wwv_flow_imp.g_varchar2_table(25303) := '654F766572726964653D302C746869732E5F7072657365727665436173653D21312C746869732E5F7072657365727665436173654F766572726964653D302C746869732E5F73656172636853636F70653D6E756C6C2C746869732E5F6D61746368657350';
wwv_flow_imp.g_varchar2_table(25304) := '6F736974696F6E3D302C746869732E5F6D617463686573436F756E743D302C746869732E5F63757272656E744D617463683D6E756C6C2C746869732E5F6C6F6F703D21302C746869732E5F6973536561726368696E673D21312C746869732E5F66696C74';
wwv_flow_imp.g_varchar2_table(25305) := '6572733D6E756C6C7D6368616E67654D61746368496E666F28652C742C6E297B636F6E737420693D7B6D6F7665437572736F723A21312C757064617465486973746F72793A21312C736561726368537472696E673A21312C7265706C616365537472696E';
wwv_flow_imp.g_varchar2_table(25306) := '673A21312C697352657665616C65643A21312C69735265706C61636552657665616C65643A21312C697352656765783A21312C77686F6C65576F72643A21312C6D61746368436173653A21312C7072657365727665436173653A21312C73656172636853';
wwv_flow_imp.g_varchar2_table(25307) := '636F70653A21312C6D617463686573506F736974696F6E3A21312C6D617463686573436F756E743A21312C63757272656E744D617463683A21312C6C6F6F703A21312C6973536561726368696E673A21312C66696C746572733A21317D3B6C6574206F3D';
wwv_flow_imp.g_varchar2_table(25308) := '21313B303D3D3D74262628653D30292C653E74262628653D74292C746869732E5F6D617463686573506F736974696F6E213D3D65262628746869732E5F6D617463686573506F736974696F6E3D652C692E6D617463686573506F736974696F6E3D21302C';
wwv_flow_imp.g_varchar2_table(25309) := '6F3D2130292C746869732E5F6D617463686573436F756E74213D3D74262628746869732E5F6D617463686573436F756E743D742C692E6D617463686573436F756E743D21302C6F3D2130292C766F69642030213D3D6E26262872682E657175616C735261';
wwv_flow_imp.g_varchar2_table(25310) := '6E676528746869732E5F63757272656E744D617463682C6E297C7C28746869732E5F63757272656E744D617463683D6E2C692E63757272656E744D617463683D21302C6F3D213029292C6F2626746869732E5F6F6E46696E645265706C61636553746174';
wwv_flow_imp.g_varchar2_table(25311) := '654368616E67652E666972652869297D6368616E676528652C742C6E3D2130297B76617220693B636F6E7374206F3D7B6D6F7665437572736F723A742C757064617465486973746F72793A6E2C736561726368537472696E673A21312C7265706C616365';
wwv_flow_imp.g_varchar2_table(25312) := '537472696E673A21312C697352657665616C65643A21312C69735265706C61636552657665616C65643A21312C697352656765783A21312C77686F6C65576F72643A21312C6D61746368436173653A21312C7072657365727665436173653A21312C7365';
wwv_flow_imp.g_varchar2_table(25313) := '6172636853636F70653A21312C6D617463686573506F736974696F6E3A21312C6D617463686573436F756E743A21312C63757272656E744D617463683A21312C6C6F6F703A21312C6973536561726368696E673A21312C66696C746572733A21317D3B6C';
wwv_flow_imp.g_varchar2_table(25314) := '657420733D21313B636F6E737420723D746869732E697352656765782C613D746869732E77686F6C65576F72642C6C3D746869732E6D61746368436173652C633D746869732E7072657365727665436173653B766F69642030213D3D652E736561726368';
wwv_flow_imp.g_varchar2_table(25315) := '537472696E672626746869732E5F736561726368537472696E67213D3D652E736561726368537472696E67262628746869732E5F736561726368537472696E673D652E736561726368537472696E672C6F2E736561726368537472696E673D21302C733D';
wwv_flow_imp.g_varchar2_table(25316) := '2130292C766F69642030213D3D652E7265706C616365537472696E672626746869732E5F7265706C616365537472696E67213D3D652E7265706C616365537472696E67262628746869732E5F7265706C616365537472696E673D652E7265706C61636553';
wwv_flow_imp.g_varchar2_table(25317) := '7472696E672C6F2E7265706C616365537472696E673D21302C733D2130292C766F69642030213D3D652E697352657665616C65642626746869732E5F697352657665616C6564213D3D652E697352657665616C6564262628746869732E5F697352657665';
wwv_flow_imp.g_varchar2_table(25318) := '616C65643D652E697352657665616C65642C6F2E697352657665616C65643D21302C733D2130292C766F69642030213D3D652E69735265706C61636552657665616C65642626746869732E5F69735265706C61636552657665616C6564213D3D652E6973';
wwv_flow_imp.g_varchar2_table(25319) := '5265706C61636552657665616C6564262628746869732E5F69735265706C61636552657665616C65643D652E69735265706C61636552657665616C65642C6F2E69735265706C61636552657665616C65643D21302C733D2130292C766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(25320) := '652E69735265676578262628746869732E5F697352656765783D652E69735265676578292C766F69642030213D3D652E77686F6C65576F7264262628746869732E5F77686F6C65576F72643D652E77686F6C65576F7264292C766F69642030213D3D652E';
wwv_flow_imp.g_varchar2_table(25321) := '6D6174636843617365262628746869732E5F6D61746368436173653D652E6D6174636843617365292C766F69642030213D3D652E707265736572766543617365262628746869732E5F7072657365727665436173653D652E707265736572766543617365';
wwv_flow_imp.g_varchar2_table(25322) := '292C766F69642030213D3D652E73656172636853636F7065262628286E756C6C3D3D3D28693D652E73656172636853636F7065297C7C766F696420303D3D3D693F766F696420303A692E65766572792828653D3E7B76617220743B72657475726E206E75';
wwv_flow_imp.g_varchar2_table(25323) := '6C6C3D3D3D28743D746869732E5F73656172636853636F7065297C7C766F696420303D3D3D743F766F696420303A742E736F6D652828743D3E2172682E657175616C7352616E676528742C652929297D2929297C7C28746869732E5F7365617263685363';
wwv_flow_imp.g_varchar2_table(25324) := '6F70653D652E73656172636853636F70652C6F2E73656172636853636F70653D21302C733D213029292C766F69642030213D3D652E6C6F6F702626746869732E5F6C6F6F70213D3D652E6C6F6F70262628746869732E5F6C6F6F703D652E6C6F6F702C6F';
wwv_flow_imp.g_varchar2_table(25325) := '2E6C6F6F703D21302C733D2130292C766F69642030213D3D652E6973536561726368696E672626746869732E5F6973536561726368696E67213D3D652E6973536561726368696E67262628746869732E5F6973536561726368696E673D652E6973536561';
wwv_flow_imp.g_varchar2_table(25326) := '726368696E672C6F2E6973536561726368696E673D21302C733D2130292C766F69642030213D3D652E66696C74657273262628746869732E5F66696C746572733F746869732E5F66696C746572732E75706461746528652E66696C74657273293A746869';
wwv_flow_imp.g_varchar2_table(25327) := '732E5F66696C746572733D652E66696C746572732C6F2E66696C746572733D21302C733D2130292C746869732E5F697352656765784F766572726964653D766F69642030213D3D652E697352656765784F766572726964653F652E697352656765784F76';
wwv_flow_imp.g_varchar2_table(25328) := '6572726964653A302C746869732E5F77686F6C65576F72644F766572726964653D766F69642030213D3D652E77686F6C65576F72644F766572726964653F652E77686F6C65576F72644F766572726964653A302C746869732E5F6D61746368436173654F';
wwv_flow_imp.g_varchar2_table(25329) := '766572726964653D766F69642030213D3D652E6D61746368436173654F766572726964653F652E6D61746368436173654F766572726964653A302C746869732E5F7072657365727665436173654F766572726964653D766F69642030213D3D652E707265';
wwv_flow_imp.g_varchar2_table(25330) := '7365727665436173654F766572726964653F652E7072657365727665436173654F766572726964653A302C72213D3D746869732E69735265676578262628733D21302C6F2E697352656765783D2130292C61213D3D746869732E77686F6C65576F726426';
wwv_flow_imp.g_varchar2_table(25331) := '2628733D21302C6F2E77686F6C65576F72643D2130292C6C213D3D746869732E6D6174636843617365262628733D21302C6F2E6D61746368436173653D2130292C63213D3D746869732E707265736572766543617365262628733D21302C6F2E70726573';
wwv_flow_imp.g_varchar2_table(25332) := '65727665436173653D2130292C732626746869732E5F6F6E46696E645265706C61636553746174654368616E67652E66697265286F297D63616E4E617669676174654261636B28297B72657475726E20746869732E63616E4E61766967617465496E4C6F';
wwv_flow_imp.g_varchar2_table(25333) := '6F7028297C7C31213D3D746869732E6D617463686573506F736974696F6E7D63616E4E61766967617465466F727761726428297B72657475726E20746869732E63616E4E61766967617465496E4C6F6F7028297C7C746869732E6D617463686573506F73';
wwv_flow_imp.g_varchar2_table(25334) := '6974696F6E3C746869732E6D617463686573436F756E747D63616E4E61766967617465496E4C6F6F7028297B72657475726E20746869732E5F6C6F6F707C7C746869732E6D617463686573436F756E743E3D564A7D7D76617220554A3D6E283533393529';
wwv_flow_imp.g_varchar2_table(25335) := '2C4B4A3D7B7D3B4B4A2E7374796C655461675472616E73666F726D3D6A7228292C4B4A2E736574417474726962757465733D567228292C4B4A2E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4B4A2E646F6D4150493D4F72';
wwv_flow_imp.g_varchar2_table(25336) := '28292C4B4A2E696E736572745374796C65456C656D656E743D487228292C4E72282928554A2E412C4B4A292C554A2E412626554A2E412E6C6F63616C732626554A2E412E6C6F63616C733B636F6E737420474A3D6228302C22696E70757422292C514A3D';
wwv_flow_imp.g_varchar2_table(25337) := '6228302C225072657365727665204361736522293B636C61737320594A20657874656E64732055247B636F6E7374727563746F722865297B76617220743B7375706572287B69636F6E3A4C6C2E7072657365727665436173652C7469746C653A514A2B65';
wwv_flow_imp.g_varchar2_table(25338) := '2E617070656E645469746C652C6973436865636B65643A652E6973436865636B65642C686F76657244656C65676174653A6E756C6C213D3D28743D652E686F76657244656C6567617465292626766F69642030213D3D743F743A50452822656C656D656E';
wwv_flow_imp.g_varchar2_table(25339) := '7422292C696E7075744163746976654F7074696F6E426F726465723A652E696E7075744163746976654F7074696F6E426F726465722C696E7075744163746976654F7074696F6E466F726567726F756E643A652E696E7075744163746976654F7074696F';
wwv_flow_imp.g_varchar2_table(25340) := '6E466F726567726F756E642C696E7075744163746976654F7074696F6E4261636B67726F756E643A652E696E7075744163746976654F7074696F6E4261636B67726F756E647D297D7D636C617373205A4A20657874656E64732047447B636F6E73747275';
wwv_flow_imp.g_varchar2_table(25341) := '63746F7228652C742C6E2C69297B737570657228292C746869732E5F73686F774F7074696F6E427574746F6E733D6E2C746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65643D21302C746869732E6361636865644F707469';
wwv_flow_imp.g_varchar2_table(25342) := '6F6E7357696474683D302C746869732E5F6F6E4469644F7074696F6E4368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644F7074696F6E4368616E67653D746869732E5F6F6E4469644F7074696F6E4368';
wwv_flow_imp.g_varchar2_table(25343) := '616E67652E6576656E742C746869732E5F6F6E4B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4B6579446F776E3D746869732E5F6F6E4B6579446F776E2E6576656E742C746869732E5F6F6E4D6F757365';
wwv_flow_imp.g_varchar2_table(25344) := '446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E496E7075743D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E4B657955703D746869732E5F7265676973746572286E6577204374';
wwv_flow_imp.g_varchar2_table(25345) := '292C746869732E5F6F6E5072657365727665436173654B6579446F776E3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E5072657365727665436173654B6579446F776E3D746869732E5F6F6E507265736572766543617365';
wwv_flow_imp.g_varchar2_table(25346) := '4B6579446F776E2E6576656E742C746869732E636F6E746578745669657750726F76696465723D742C746869732E706C616365686F6C6465723D692E706C616365686F6C6465727C7C22222C746869732E76616C69646174696F6E3D692E76616C696461';
wwv_flow_imp.g_varchar2_table(25347) := '74696F6E2C746869732E6C6162656C3D692E6C6162656C7C7C474A3B636F6E7374206F3D692E617070656E645072657365727665436173654C6162656C7C7C22222C733D692E686973746F72797C7C5B5D2C723D2121692E666C657869626C6548656967';
wwv_flow_imp.g_varchar2_table(25348) := '68742C613D2121692E666C657869626C6557696474682C6C3D692E666C657869626C654D61784865696768743B746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(25349) := '2E636C6173734C6973742E61646428226D6F6E61636F2D66696E64496E70757422292C746869732E696E707574426F783D746869732E5F7265676973746572286E657720735528746869732E646F6D4E6F64652C746869732E636F6E7465787456696577';
wwv_flow_imp.g_varchar2_table(25350) := '50726F76696465722C7B617269614C6162656C3A746869732E6C6162656C7C7C22222C706C616365686F6C6465723A746869732E706C616365686F6C6465727C7C22222C76616C69646174696F6E4F7074696F6E733A7B76616C69646174696F6E3A7468';
wwv_flow_imp.g_varchar2_table(25351) := '69732E76616C69646174696F6E7D2C686973746F72793A732C73686F77486973746F727948696E743A692E73686F77486973746F727948696E742C666C657869626C654865696768743A722C666C657869626C6557696474683A612C666C657869626C65';
wwv_flow_imp.g_varchar2_table(25352) := '4D61784865696768743A6C2C696E707574426F785374796C65733A692E696E707574426F785374796C65737D29292C746869732E7072657365727665436173653D746869732E5F7265676973746572286E657720594A287B617070656E645469746C653A';
wwv_flow_imp.g_varchar2_table(25353) := '6F2C6973436865636B65643A21312C2E2E2E692E746F67676C655374796C65737D29292C746869732E5F726567697374657228746869732E7072657365727665436173652E6F6E4368616E67652828653D3E7B746869732E5F6F6E4469644F7074696F6E';
wwv_flow_imp.g_varchar2_table(25354) := '4368616E67652E666972652865292C21652626746869732E666978466F6375734F6E4F7074696F6E436C69636B456E61626C65642626746869732E696E707574426F782E666F63757328292C746869732E76616C696461746528297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(25355) := '2E5F726567697374657228746869732E7072657365727665436173652E6F6E4B6579446F776E2828653D3E7B746869732E5F6F6E5072657365727665436173654B6579446F776E2E666972652865297D2929292C746869732E5F73686F774F7074696F6E';
wwv_flow_imp.g_varchar2_table(25356) := '427574746F6E733F746869732E6361636865644F7074696F6E7357696474683D746869732E7072657365727665436173652E776964746828293A746869732E6361636865644F7074696F6E7357696474683D303B636F6E737420633D5B746869732E7072';
wwv_flow_imp.g_varchar2_table(25357) := '657365727665436173652E646F6D4E6F64655D3B746869732E6F6E6B6579646F776E28746869732E646F6D4E6F64652C28653D3E7B696628652E657175616C73283135297C7C652E657175616C73283137297C7C652E657175616C73283929297B636F6E';
wwv_flow_imp.g_varchar2_table(25358) := '737420743D632E696E6465784F6628746869732E646F6D4E6F64652E6F776E6572446F63756D656E742E616374697665456C656D656E74293B696628743E3D30297B6C6574206E3D2D313B652E657175616C73283137293F6E3D28742B312925632E6C65';
wwv_flow_imp.g_varchar2_table(25359) := '6E6774683A652E657175616C73283135292626286E3D303D3D3D743F632E6C656E6774682D313A742D31292C652E657175616C732839293F28635B745D2E626C757228292C746869732E696E707574426F782E666F6375732829293A6E3E3D302626635B';
wwv_flow_imp.g_varchar2_table(25360) := '6E5D2E666F63757328292C637228652C2130297D7D7D29293B636F6E737420643D646F63756D656E742E637265617465456C656D656E74282264697622293B642E636C6173734E616D653D22636F6E74726F6C73222C642E7374796C652E646973706C61';
wwv_flow_imp.g_varchar2_table(25361) := '793D746869732E5F73686F774F7074696F6E427574746F6E733F22626C6F636B223A226E6F6E65222C642E617070656E644368696C6428746869732E7072657365727665436173652E646F6D4E6F6465292C746869732E646F6D4E6F64652E617070656E';
wwv_flow_imp.g_varchar2_table(25362) := '644368696C642864292C6E756C6C3D3D657C7C652E617070656E644368696C6428746869732E646F6D4E6F6465292C746869732E6F6E6B6579646F776E28746869732E696E707574426F782E696E707574456C656D656E742C28653D3E746869732E5F6F';
wwv_flow_imp.g_varchar2_table(25363) := '6E4B6579446F776E2E6669726528652929292C746869732E6F6E6B6579757028746869732E696E707574426F782E696E707574456C656D656E742C28653D3E746869732E5F6F6E4B657955702E6669726528652929292C746869732E6F6E696E70757428';
wwv_flow_imp.g_varchar2_table(25364) := '746869732E696E707574426F782E696E707574456C656D656E742C28653D3E746869732E5F6F6E496E7075742E66697265282929292C746869732E6F6E6D6F757365646F776E28746869732E696E707574426F782E696E707574456C656D656E742C2865';
wwv_flow_imp.g_varchar2_table(25365) := '3D3E746869732E5F6F6E4D6F757365446F776E2E6669726528652929297D656E61626C6528297B746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F7665282264697361626C656422292C746869732E696E707574426F782E656E61626C';
wwv_flow_imp.g_varchar2_table(25366) := '6528292C746869732E7072657365727665436173652E656E61626C6528297D64697361626C6528297B746869732E646F6D4E6F64652E636C6173734C6973742E616464282264697361626C656422292C746869732E696E707574426F782E64697361626C';
wwv_flow_imp.g_varchar2_table(25367) := '6528292C746869732E7072657365727665436173652E64697361626C6528297D736574456E61626C65642865297B653F746869732E656E61626C6528293A746869732E64697361626C6528297D73656C65637428297B746869732E696E707574426F782E';
wwv_flow_imp.g_varchar2_table(25368) := '73656C65637428297D666F63757328297B746869732E696E707574426F782E666F63757328297D67657450726573657276654361736528297B72657475726E20746869732E7072657365727665436173652E636865636B65647D73657450726573657276';
wwv_flow_imp.g_varchar2_table(25369) := '65436173652865297B746869732E7072657365727665436173652E636865636B65643D657D666F6375734F6E507265736572766528297B746869732E7072657365727665436173652E666F63757328297D76616C696461746528297B76617220653B6E75';
wwv_flow_imp.g_varchar2_table(25370) := '6C6C3D3D3D28653D746869732E696E707574426F78297C7C766F696420303D3D3D657C7C652E76616C696461746528297D7365742077696474682865297B746869732E696E707574426F782E70616464696E6752696768743D746869732E636163686564';
wwv_flow_imp.g_varchar2_table(25371) := '4F7074696F6E7357696474682C746869732E646F6D4E6F64652E7374796C652E77696474683D652B227078227D646973706F736528297B73757065722E646973706F736528297D7D76617220584A3D66756E6374696F6E28652C742C6E2C69297B766172';
wwv_flow_imp.g_varchar2_table(25372) := '206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F6620';
wwv_flow_imp.g_varchar2_table(25373) := '5265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B61';
wwv_flow_imp.g_varchar2_table(25374) := '3E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C';
wwv_flow_imp.g_varchar2_table(25375) := '727D2C4A4A3D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742065303D6E6577206C6428227375676765737457696467657456697369626C65222C21312C6228302C2257';
wwv_flow_imp.g_varchar2_table(25376) := '6865746865722073756767657374696F6E206172652076697369626C652229292C74303D22686973746F72794E617669676174696F6E576964676574466F637573222C6E303D22686973746F72794E617669676174696F6E466F727761726473456E6162';
wwv_flow_imp.g_varchar2_table(25377) := '6C6564222C69303D22686973746F72794E617669676174696F6E4261636B7761726473456E61626C6564223B6C6574206F303B636F6E73742073303D5B5D3B66756E6374696F6E20723028652C74297B69662873302E696E636C75646573287429297468';
wwv_flow_imp.g_varchar2_table(25378) := '726F77206E6577204572726F72282243616E6E6F74207265676973746572207468652073616D6520776964676574206D756C7469706C652074696D657322293B73302E707573682874293B636F6E7374206E3D6E65772061742C693D6E6577206C642874';
wwv_flow_imp.g_varchar2_table(25379) := '302C2131292E62696E64546F2865292C6F3D6E6577206C64286E302C2130292E62696E64546F2865292C733D6E6577206C642869302C2130292E62696E64546F2865292C723D28293D3E7B692E736574282130292C6F303D747D2C613D28293D3E7B692E';
wwv_flow_imp.g_varchar2_table(25380) := '736574282131292C6F303D3D3D742626286F303D766F69642030297D3B72657475726E20717328742E656C656D656E742926267228292C6E2E61646428742E6F6E446964466F637573282828293D3E7228292929292C6E2E61646428742E6F6E44696442';
wwv_flow_imp.g_varchar2_table(25381) := '6C7572282828293D3E6128292929292C6E2E616464287274282828293D3E7B73302E73706C6963652873302E696E6465784F662874292C31292C6128297D2929292C7B686973746F72794E617669676174696F6E466F727761726473456E61626C656D65';
wwv_flow_imp.g_varchar2_table(25382) := '6E743A6F2C686973746F72794E617669676174696F6E4261636B7761726473456E61626C656D656E743A732C646973706F736528297B6E2E646973706F736528297D7D7D6C65742061303D636C61737320657874656E64732063557B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(25383) := '746F7228652C742C6E2C69297B737570657228652C742C6E293B636F6E7374206F3D746869732E5F726567697374657228692E63726561746553636F70656428746869732E696E707574426F782E656C656D656E7429293B746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(25384) := '6572287230286F2C746869732E696E707574426F7829297D7D3B61303D584A285B4A4A28332C6364295D2C6130293B6C6574206C303D636C61737320657874656E6473205A4A7B636F6E7374727563746F7228652C742C6E2C692C6F3D2131297B737570';
wwv_flow_imp.g_varchar2_table(25385) := '657228652C742C6F2C6E293B636F6E737420733D746869732E5F726567697374657228692E63726561746553636F70656428746869732E696E707574426F782E656C656D656E7429293B746869732E5F726567697374657228723028732C746869732E69';
wwv_flow_imp.g_varchar2_table(25386) := '6E707574426F7829297D7D3B66756E6374696F6E2063302865297B76617220742C6E3B72657475726E225570223D3D3D286E756C6C3D3D3D28743D652E6C6F6F6B75704B657962696E64696E672822686973746F72792E73686F7750726576696F757322';
wwv_flow_imp.g_varchar2_table(25387) := '29297C7C766F696420303D3D3D743F766F696420303A742E676574456C656374726F6E416363656C657261746F72282929262622446F776E223D3D3D286E756C6C3D3D3D286E3D652E6C6F6F6B75704B657962696E64696E672822686973746F72792E73';
wwv_flow_imp.g_varchar2_table(25388) := '686F774E6578742229297C7C766F696420303D3D3D6E3F766F696420303A6E2E676574456C656374726F6E416363656C657261746F722829297D6C303D584A285B4A4A28332C6364295D2C6C30292C43642E7265676973746572436F6D6D616E64416E64';
wwv_flow_imp.g_varchar2_table(25389) := '4B657962696E64696E6752756C65287B69643A22686973746F72792E73686F7750726576696F7573222C7765696768743A3230302C7768656E3A57632E616E642857632E686173287430292C57632E657175616C732869302C2130292C57632E6E6F7428';
wwv_flow_imp.g_varchar2_table(25390) := '226973436F6D706F73696E6722292C65302E6973457175616C546F28213129292C7072696D6172793A31362C7365636F6E646172793A5B3532385D2C68616E646C65723A653D3E7B6E756C6C3D3D6F307C7C6F302E73686F7750726576696F757356616C';
wwv_flow_imp.g_varchar2_table(25391) := '756528297D7D292C43642E7265676973746572436F6D6D616E64416E644B657962696E64696E6752756C65287B69643A22686973746F72792E73686F774E657874222C7765696768743A3230302C7768656E3A57632E616E642857632E68617328743029';
wwv_flow_imp.g_varchar2_table(25392) := '2C57632E657175616C73286E302C2130292C57632E6E6F7428226973436F6D706F73696E6722292C65302E6973457175616C546F28213129292C7072696D6172793A31382C7365636F6E646172793A5B3533305D2C68616E646C65723A653D3E7B6E756C';
wwv_flow_imp.g_varchar2_table(25393) := '6C3D3D6F307C7C6F302E73686F774E65787456616C756528297D7D293B636F6E73742064303D5457282266696E642D73656C656374696F6E222C4C6C2E73656C656374696F6E2C6228302C2249636F6E20666F72202746696E6420696E2053656C656374';
wwv_flow_imp.g_varchar2_table(25394) := '696F6E2720696E2074686520656469746F722066696E64207769646765742E2229292C68303D5457282266696E642D636F6C6C6170736564222C4C6C2E63686576726F6E52696768742C6228302C2249636F6E20746F20696E6469636174652074686174';
wwv_flow_imp.g_varchar2_table(25395) := '2074686520656469746F722066696E642077696467657420697320636F6C6C61707365642E2229292C75303D5457282266696E642D657870616E646564222C4C6C2E63686576726F6E446F776E2C6228302C2249636F6E20746F20696E64696361746520';
wwv_flow_imp.g_varchar2_table(25396) := '746861742074686520656469746F722066696E642077696467657420697320657870616E6465642E2229292C70303D5457282266696E642D7265706C616365222C4C6C2E7265706C6163652C6228302C2249636F6E20666F7220275265706C6163652720';
wwv_flow_imp.g_varchar2_table(25397) := '696E2074686520656469746F722066696E64207769646765742E2229292C67303D5457282266696E642D7265706C6163652D616C6C222C4C6C2E7265706C616365416C6C2C6228302C2249636F6E20666F7220275265706C61636520416C6C2720696E20';
wwv_flow_imp.g_varchar2_table(25398) := '74686520656469746F722066696E64207769646765742E2229292C6D303D5457282266696E642D70726576696F75732D6D61746368222C4C6C2E6172726F7755702C6228302C2249636F6E20666F72202746696E642050726576696F75732720696E2074';
wwv_flow_imp.g_varchar2_table(25399) := '686520656469746F722066696E64207769646765742E2229292C66303D5457282266696E642D6E6578742D6D61746368222C4C6C2E6172726F77446F776E2C6228302C2249636F6E20666F72202746696E64204E6578742720696E207468652065646974';
wwv_flow_imp.g_varchar2_table(25400) := '6F722066696E64207769646765742E2229292C76303D6228302C2246696E64202F205265706C61636522292C62303D6228302C2246696E6422292C5F303D6228302C2246696E6422292C79303D6228302C2250726576696F7573204D6174636822292C77';
wwv_flow_imp.g_varchar2_table(25401) := '303D6228302C224E657874204D6174636822292C43303D6228302C2246696E6420696E2053656C656374696F6E22292C53303D6228302C22436C6F736522292C78303D6228302C225265706C61636522292C6B303D6228302C225265706C61636522292C';
wwv_flow_imp.g_varchar2_table(25402) := '45303D6228302C225265706C61636522292C4C303D6228302C225265706C61636520416C6C22292C44303D6228302C22546F67676C65205265706C61636522292C54303D6228302C224F6E6C7920746865206669727374207B307D20726573756C747320';
wwv_flow_imp.g_varchar2_table(25403) := '61726520686967686C6967687465642C2062757420616C6C2066696E64206F7065726174696F6E7320776F726B206F6E2074686520656E7469726520746578742E222C564A292C49303D6228302C227B307D206F66207B317D22292C4D303D6228302C22';
wwv_flow_imp.g_varchar2_table(25404) := '4E6F20726573756C747322292C41303D3431393B6C6574204E303D36393B636F6E73742050303D226374726C456E7465725265706C616365416C6C2E77696E646F77732E646F6E6F7461736B222C4F303D713F3235363A323034383B636C617373205230';
wwv_flow_imp.g_varchar2_table(25405) := '7B636F6E7374727563746F722865297B746869732E61667465724C696E654E756D6265723D652C746869732E686569676874496E50783D33332C746869732E73757070726573734D6F757365446F776E3D21312C746869732E646F6D4E6F64653D646F63';
wwv_flow_imp.g_varchar2_table(25406) := '756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D4E6F64652E636C6173734E616D653D22646F636B2D66696E642D766965777A6F6E65227D7D66756E6374696F6E20463028652C742C6E297B636F6E737420693D21';
wwv_flow_imp.g_varchar2_table(25407) := '21742E6D61746368282F5C6E2F293B6E26266926266E2E73656C656374696F6E53746172743E302626652E73746F7050726F7061676174696F6E28297D66756E6374696F6E20423028652C742C6E297B636F6E737420693D2121742E6D61746368282F5C';
wwv_flow_imp.g_varchar2_table(25408) := '6E2F293B6E26266926266E2E73656C656374696F6E456E643C6E2E76616C75652E6C656E6774682626652E73746F7050726F7061676174696F6E28297D636C61737320563020657874656E64732047447B636F6E7374727563746F7228652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(25409) := '2C6F2C732C722C612C6C2C63297B737570657228292C746869732E5F686F766572536572766963653D632C746869732E5F6361636865644865696768743D6E756C6C2C746869732E5F72657665616C54696D656F7574733D5B5D2C746869732E5F636F64';
wwv_flow_imp.g_varchar2_table(25410) := '65456469746F723D652C746869732E5F636F6E74726F6C6C65723D742C746869732E5F73746174653D6E2C746869732E5F636F6E746578745669657750726F76696465723D692C746869732E5F6B657962696E64696E67536572766963653D6F2C746869';
wwv_flow_imp.g_varchar2_table(25411) := '732E5F636F6E746578744B6579536572766963653D732C746869732E5F73746F72616765536572766963653D612C746869732E5F6E6F74696669636174696F6E536572766963653D6C2C746869732E5F6374726C456E7465725265706C616365416C6C57';
wwv_flow_imp.g_varchar2_table(25412) := '61726E696E6750726F6D707465643D2121612E676574426F6F6C65616E2850302C30292C746869732E5F697356697369626C653D21312C746869732E5F69735265706C61636556697369626C653D21312C746869732E5F69676E6F72654368616E676545';
wwv_flow_imp.g_varchar2_table(25413) := '76656E743D21312C746869732E5F757064617465486973746F727944656C617965723D6E6577207A7428353030292C746869732E5F7265676973746572287274282828293D3E746869732E5F757064617465486973746F727944656C617965722E63616E';
wwv_flow_imp.g_varchar2_table(25414) := '63656C28292929292C746869732E5F726567697374657228746869732E5F73746174652E6F6E46696E645265706C61636553746174654368616E67652828653D3E746869732E5F6F6E53746174654368616E6765642865292929292C746869732E5F6275';
wwv_flow_imp.g_varchar2_table(25415) := '696C64446F6D4E6F646528292C746869732E5F757064617465427574746F6E7328292C746869732E5F747279557064617465576964676574576964746828292C746869732E5F66696E64496E7075742E696E707574426F782E6C61796F757428292C7468';
wwv_flow_imp.g_varchar2_table(25416) := '69732E5F726567697374657228746869732E5F636F6465456469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B696628652E6861734368616E67656428393129262628746869732E5F636F6465456469746F722E67';
wwv_flow_imp.g_varchar2_table(25417) := '65744F7074696F6E283931292626746869732E5F73746174652E6368616E6765287B69735265706C61636552657665616C65643A21317D2C2131292C746869732E5F757064617465427574746F6E732829292C652E6861734368616E6765642831343529';
wwv_flow_imp.g_varchar2_table(25418) := '2626746869732E5F747279557064617465576964676574576964746828292C652E6861734368616E6765642832292626746869732E7570646174654163636573736962696C697479537570706F727428292C652E6861734368616E67656428343129297B';
wwv_flow_imp.g_varchar2_table(25419) := '636F6E737420653D746869732E5F636F6465456469746F722E6765744F7074696F6E283431292E6C6F6F703B746869732E5F73746174652E6368616E6765287B6C6F6F703A657D2C2131293B636F6E737420743D746869732E5F636F6465456469746F72';
wwv_flow_imp.g_varchar2_table(25420) := '2E6765744F7074696F6E283431292E616464457874726153706163654F6E546F703B74262621746869732E5F766965775A6F6E65262628746869732E5F766965775A6F6E653D6E65772052302830292C746869732E5F73686F77566965775A6F6E652829';
wwv_flow_imp.g_varchar2_table(25421) := '292C21742626746869732E5F766965775A6F6E652626746869732E5F72656D6F7665566965775A6F6E6528297D7D2929292C746869732E7570646174654163636573736962696C697479537570706F727428292C746869732E5F72656769737465722874';
wwv_flow_imp.g_varchar2_table(25422) := '6869732E5F636F6465456469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E282828293D3E7B746869732E5F697356697369626C652626746869732E5F757064617465546F67676C6553656C656374696F6E46696E64427574';
wwv_flow_imp.g_varchar2_table(25423) := '746F6E28297D2929292C746869732E5F726567697374657228746869732E5F636F6465456469746F722E6F6E446964466F637573456469746F7257696467657428286173796E6328293D3E7B696628746869732E5F697356697369626C65297B636F6E73';
wwv_flow_imp.g_varchar2_table(25424) := '7420653D617761697420746869732E5F636F6E74726F6C6C65722E676574476C6F62616C4275666665725465726D28293B65262665213D3D746869732E5F73746174652E736561726368537472696E67262628746869732E5F73746174652E6368616E67';
wwv_flow_imp.g_varchar2_table(25425) := '65287B736561726368537472696E673A657D2C2131292C746869732E5F66696E64496E7075742E73656C6563742829297D7D2929292C746869732E5F66696E64496E707574466F63757365643D434A2E62696E64546F2873292C746869732E5F66696E64';
wwv_flow_imp.g_varchar2_table(25426) := '466F637573547261636B65723D746869732E5F726567697374657228687228746869732E5F66696E64496E7075742E696E707574426F782E696E707574456C656D656E7429292C746869732E5F726567697374657228746869732E5F66696E64466F6375';
wwv_flow_imp.g_varchar2_table(25427) := '73547261636B65722E6F6E446964466F637573282828293D3E7B746869732E5F66696E64496E707574466F63757365642E736574282130292C746869732E5F75706461746553656172636853636F706528297D2929292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(25428) := '7228746869732E5F66696E64466F637573547261636B65722E6F6E446964426C7572282828293D3E7B746869732E5F66696E64496E707574466F63757365642E736574282131297D2929292C746869732E5F7265706C616365496E707574466F63757365';
wwv_flow_imp.g_varchar2_table(25429) := '643D534A2E62696E64546F2873292C746869732E5F7265706C616365466F637573547261636B65723D746869732E5F726567697374657228687228746869732E5F7265706C616365496E7075742E696E707574426F782E696E707574456C656D656E7429';
wwv_flow_imp.g_varchar2_table(25430) := '292C746869732E5F726567697374657228746869732E5F7265706C616365466F637573547261636B65722E6F6E446964466F637573282828293D3E7B746869732E5F7265706C616365496E707574466F63757365642E736574282130292C746869732E5F';
wwv_flow_imp.g_varchar2_table(25431) := '75706461746553656172636853636F706528297D2929292C746869732E5F726567697374657228746869732E5F7265706C616365466F637573547261636B65722E6F6E446964426C7572282828293D3E7B746869732E5F7265706C616365496E70757446';
wwv_flow_imp.g_varchar2_table(25432) := '6F63757365642E736574282131297D2929292C746869732E5F636F6465456469746F722E6164644F7665726C61795769646765742874686973292C746869732E5F636F6465456469746F722E6765744F7074696F6E283431292E61646445787472615370';
wwv_flow_imp.g_varchar2_table(25433) := '6163654F6E546F70262628746869732E5F766965775A6F6E653D6E6577205230283029292C746869732E5F726567697374657228746869732E5F636F6465456469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F6973';
wwv_flow_imp.g_varchar2_table(25434) := '56697369626C65262628746869732E5F766965775A6F6E6549643D766F69642030297D2929292C746869732E5F726567697374657228746869732E5F636F6465456469746F722E6F6E4469645363726F6C6C4368616E67652828653D3E7B652E7363726F';
wwv_flow_imp.g_varchar2_table(25435) := '6C6C546F704368616E6765643F746869732E5F6C61796F7574566965775A6F6E6528293A73657454696D656F7574282828293D3E7B746869732E5F6C61796F7574566965775A6F6E6528297D292C30297D2929297D676574496428297B72657475726E20';
wwv_flow_imp.g_varchar2_table(25436) := '56302E49447D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B72657475726E20746869732E5F697356697369626C653F7B707265666572656E63653A307D3A6E756C6C7D5F6F6E';
wwv_flow_imp.g_varchar2_table(25437) := '53746174654368616E6765642865297B696628652E736561726368537472696E67297B7472797B746869732E5F69676E6F72654368616E67654576656E743D21302C746869732E5F66696E64496E7075742E73657456616C756528746869732E5F737461';
wwv_flow_imp.g_varchar2_table(25438) := '74652E736561726368537472696E67297D66696E616C6C797B746869732E5F69676E6F72654368616E67654576656E743D21317D746869732E5F757064617465427574746F6E7328297D696628652E7265706C616365537472696E67262628746869732E';
wwv_flow_imp.g_varchar2_table(25439) := '5F7265706C616365496E7075742E696E707574426F782E76616C75653D746869732E5F73746174652E7265706C616365537472696E67292C652E697352657665616C6564262628746869732E5F73746174652E697352657665616C65643F746869732E5F';
wwv_flow_imp.g_varchar2_table(25440) := '72657665616C28293A746869732E5F6869646528213029292C652E69735265706C61636552657665616C6564262628746869732E5F73746174652E69735265706C61636552657665616C65643F746869732E5F636F6465456469746F722E6765744F7074';
wwv_flow_imp.g_varchar2_table(25441) := '696F6E283931297C7C746869732E5F69735265706C61636556697369626C657C7C28746869732E5F69735265706C61636556697369626C653D21302C746869732E5F7265706C616365496E7075742E77696474683D507328746869732E5F66696E64496E';
wwv_flow_imp.g_varchar2_table(25442) := '7075742E646F6D4E6F6465292C746869732E5F757064617465427574746F6E7328292C746869732E5F7265706C616365496E7075742E696E707574426F782E6C61796F75742829293A746869732E5F69735265706C61636556697369626C652626287468';
wwv_flow_imp.g_varchar2_table(25443) := '69732E5F69735265706C61636556697369626C653D21312C746869732E5F757064617465427574746F6E73282929292C28652E697352657665616C65647C7C652E69735265706C61636552657665616C656429262628746869732E5F73746174652E6973';
wwv_flow_imp.g_varchar2_table(25444) := '52657665616C65647C7C746869732E5F73746174652E69735265706C61636552657665616C6564292626746869732E5F74727955706461746548656967687428292626746869732E5F73686F77566965775A6F6E6528292C652E69735265676578262674';
wwv_flow_imp.g_varchar2_table(25445) := '6869732E5F66696E64496E7075742E736574526567657828746869732E5F73746174652E69735265676578292C652E77686F6C65576F72642626746869732E5F66696E64496E7075742E73657457686F6C65576F72647328746869732E5F73746174652E';
wwv_flow_imp.g_varchar2_table(25446) := '77686F6C65576F7264292C652E6D61746368436173652626746869732E5F66696E64496E7075742E7365744361736553656E73697469766528746869732E5F73746174652E6D6174636843617365292C652E707265736572766543617365262674686973';
wwv_flow_imp.g_varchar2_table(25447) := '2E5F7265706C616365496E7075742E73657450726573657276654361736528746869732E5F73746174652E707265736572766543617365292C652E73656172636853636F7065262628746869732E5F73746174652E73656172636853636F70653F746869';
wwv_flow_imp.g_varchar2_table(25448) := '732E5F746F67676C6553656C656374696F6E46696E642E636865636B65643D21303A746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B65643D21312C746869732E5F757064617465546F67676C6553656C656374696F6E4669';
wwv_flow_imp.g_varchar2_table(25449) := '6E64427574746F6E2829292C652E736561726368537472696E677C7C652E6D617463686573436F756E747C7C652E6D617463686573506F736974696F6E297B636F6E737420653D746869732E5F73746174652E736561726368537472696E672E6C656E67';
wwv_flow_imp.g_varchar2_table(25450) := '74683E302626303D3D3D746869732E5F73746174652E6D617463686573436F756E743B746869732E5F646F6D4E6F64652E636C6173734C6973742E746F67676C6528226E6F2D726573756C7473222C65292C746869732E5F7570646174654D6174636865';
wwv_flow_imp.g_varchar2_table(25451) := '73436F756E7428292C746869732E5F757064617465427574746F6E7328297D28652E736561726368537472696E677C7C652E63757272656E744D61746368292626746869732E5F6C61796F7574566965775A6F6E6528292C652E75706461746548697374';
wwv_flow_imp.g_varchar2_table(25452) := '6F72792626746869732E5F64656C61796564557064617465486973746F727928292C652E6C6F6F702626746869732E5F757064617465427574746F6E7328297D5F64656C61796564557064617465486973746F727928297B746869732E5F757064617465';
wwv_flow_imp.g_varchar2_table(25453) := '486973746F727944656C617965722E7472696767657228746869732E5F757064617465486973746F72792E62696E64287468697329292E7468656E28766F696420302C6B65297D5F757064617465486973746F727928297B746869732E5F73746174652E';
wwv_flow_imp.g_varchar2_table(25454) := '736561726368537472696E672626746869732E5F66696E64496E7075742E696E707574426F782E616464546F486973746F727928292C746869732E5F73746174652E7265706C616365537472696E672626746869732E5F7265706C616365496E7075742E';
wwv_flow_imp.g_varchar2_table(25455) := '696E707574426F782E616464546F486973746F727928297D5F7570646174654D617463686573436F756E7428297B6C657420653B696628746869732E5F6D617463686573436F756E742E7374796C652E6D696E57696474683D4E302B227078222C746869';
wwv_flow_imp.g_varchar2_table(25456) := '732E5F73746174652E6D617463686573436F756E743E3D564A3F746869732E5F6D617463686573436F756E742E7469746C653D54303A746869732E5F6D617463686573436F756E742E7469746C653D22222C746869732E5F6D617463686573436F756E74';
wwv_flow_imp.g_varchar2_table(25457) := '2E66697273744368696C642626746869732E5F6D617463686573436F756E742E72656D6F76654368696C6428746869732E5F6D617463686573436F756E742E66697273744368696C64292C746869732E5F73746174652E6D617463686573436F756E743E';
wwv_flow_imp.g_varchar2_table(25458) := '30297B6C657420743D537472696E6728746869732E5F73746174652E6D617463686573436F756E74293B746869732E5F73746174652E6D617463686573436F756E743E3D564A262628742B3D222B22293B6C6574206E3D537472696E6728746869732E5F';
wwv_flow_imp.g_varchar2_table(25459) := '73746174652E6D617463686573506F736974696F6E293B2230223D3D3D6E2626286E3D223F22292C653D61692849302C6E2C74297D656C736520653D4D303B746869732E5F6D617463686573436F756E742E617070656E644368696C6428646F63756D65';
wwv_flow_imp.g_varchar2_table(25460) := '6E742E637265617465546578744E6F6465286529292C587228746869732E5F676574417269614C6162656C28652C746869732E5F73746174652E63757272656E744D617463682C746869732E5F73746174652E736561726368537472696E6729292C4E30';
wwv_flow_imp.g_varchar2_table(25461) := '3D4D6174682E6D6178284E302C746869732E5F6D617463686573436F756E742E636C69656E745769647468297D5F676574417269614C6162656C28652C742C6E297B696628653D3D3D4D302972657475726E22223D3D3D6E3F6228302C227B307D20666F';
wwv_flow_imp.g_varchar2_table(25462) := '756E64222C65293A6228302C227B307D20666F756E6420666F7220277B317D27222C652C6E293B69662874297B636F6E737420693D6228302C227B307D20666F756E6420666F7220277B317D272C206174207B327D222C652C6E2C742E73746172744C69';
wwv_flow_imp.g_varchar2_table(25463) := '6E654E756D6265722B223A222B742E7374617274436F6C756D6E292C6F3D746869732E5F636F6465456469746F722E6765744D6F64656C28293B72657475726E206F2626742E73746172744C696E654E756D6265723C3D6F2E6765744C696E65436F756E';
wwv_flow_imp.g_varchar2_table(25464) := '7428292626742E73746172744C696E654E756D6265723E3D313F60247B6F2E6765744C696E65436F6E74656E7428742E73746172744C696E654E756D626572297D2C20247B697D603A697D72657475726E206228302C227B307D20666F756E6420666F72';
wwv_flow_imp.g_varchar2_table(25465) := '20277B317D27222C652C6E297D5F757064617465546F67676C6553656C656374696F6E46696E64427574746F6E28297B636F6E737420653D746869732E5F636F6465456469746F722E67657453656C656374696F6E28292C743D212165262628652E7374';
wwv_flow_imp.g_varchar2_table(25466) := '6172744C696E654E756D626572213D3D652E656E644C696E654E756D6265727C7C652E7374617274436F6C756D6E213D3D652E656E64436F6C756D6E292C6E3D746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B65643B7468';
wwv_flow_imp.g_varchar2_table(25467) := '69732E5F697356697369626C652626286E7C7C74293F746869732E5F746F67676C6553656C656374696F6E46696E642E656E61626C6528293A746869732E5F746F67676C6553656C656374696F6E46696E642E64697361626C6528297D5F757064617465';
wwv_flow_imp.g_varchar2_table(25468) := '427574746F6E7328297B746869732E5F66696E64496E7075742E736574456E61626C656428746869732E5F697356697369626C65292C746869732E5F7265706C616365496E7075742E736574456E61626C656428746869732E5F697356697369626C6526';
wwv_flow_imp.g_varchar2_table(25469) := '26746869732E5F69735265706C61636556697369626C65292C746869732E5F757064617465546F67676C6553656C656374696F6E46696E64427574746F6E28292C746869732E5F636C6F736542746E2E736574456E61626C656428746869732E5F697356';
wwv_flow_imp.g_varchar2_table(25470) := '697369626C65293B636F6E737420653D746869732E5F73746174652E736561726368537472696E672E6C656E6774683E302C743D2121746869732E5F73746174652E6D617463686573436F756E743B746869732E5F7072657642746E2E736574456E6162';
wwv_flow_imp.g_varchar2_table(25471) := '6C656428746869732E5F697356697369626C652626652626742626746869732E5F73746174652E63616E4E617669676174654261636B2829292C746869732E5F6E65787442746E2E736574456E61626C656428746869732E5F697356697369626C652626';
wwv_flow_imp.g_varchar2_table(25472) := '652626742626746869732E5F73746174652E63616E4E61766967617465466F72776172642829292C746869732E5F7265706C61636542746E2E736574456E61626C656428746869732E5F697356697369626C652626746869732E5F69735265706C616365';
wwv_flow_imp.g_varchar2_table(25473) := '56697369626C65262665292C746869732E5F7265706C616365416C6C42746E2E736574456E61626C656428746869732E5F697356697369626C652626746869732E5F69735265706C61636556697369626C65262665292C746869732E5F646F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(25474) := '2E636C6173734C6973742E746F67676C6528227265706C616365546F67676C6564222C746869732E5F69735265706C61636556697369626C65292C746869732E5F746F67676C655265706C61636542746E2E736574457870616E64656428746869732E5F';
wwv_flow_imp.g_varchar2_table(25475) := '69735265706C61636556697369626C65293B636F6E7374206E3D21746869732E5F636F6465456469746F722E6765744F7074696F6E283931293B746869732E5F746F67676C655265706C61636542746E2E736574456E61626C656428746869732E5F6973';
wwv_flow_imp.g_varchar2_table(25476) := '56697369626C6526266E297D5F72657665616C28297B696628746869732E5F72657665616C54696D656F7574732E666F72456163682828653D3E7B636C65617254696D656F75742865297D29292C746869732E5F72657665616C54696D656F7574733D5B';
wwv_flow_imp.g_varchar2_table(25477) := '5D2C21746869732E5F697356697369626C65297B746869732E5F697356697369626C653D21303B636F6E737420653D746869732E5F636F6465456469746F722E67657453656C656374696F6E28293B73776974636828746869732E5F636F646545646974';
wwv_flow_imp.g_varchar2_table(25478) := '6F722E6765744F7074696F6E283431292E6175746F46696E64496E53656C656374696F6E297B6361736522616C77617973223A746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B65643D21303B627265616B3B63617365226E';
wwv_flow_imp.g_varchar2_table(25479) := '65766572223A746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B65643D21313B627265616B3B63617365226D756C74696C696E65223A7B636F6E737420743D2121652626652E73746172744C696E654E756D626572213D3D65';
wwv_flow_imp.g_varchar2_table(25480) := '2E656E644C696E654E756D6265723B746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B65643D743B627265616B7D7D746869732E5F747279557064617465576964676574576964746828292C746869732E5F75706461746542';
wwv_flow_imp.g_varchar2_table(25481) := '7574746F6E7328292C746869732E5F72657665616C54696D656F7574732E707573682873657454696D656F7574282828293D3E7B746869732E5F646F6D4E6F64652E636C6173734C6973742E616464282276697369626C6522292C746869732E5F646F6D';
wwv_flow_imp.g_varchar2_table(25482) := '4E6F64652E7365744174747269627574652822617269612D68696464656E222C2266616C736522297D292C3029292C746869732E5F72657665616C54696D656F7574732E707573682873657454696D656F7574282828293D3E7B746869732E5F66696E64';
wwv_flow_imp.g_varchar2_table(25483) := '496E7075742E76616C696461746528297D292C32303029292C746869732E5F636F6465456469746F722E6C61796F75744F7665726C61795769646765742874686973293B6C657420743D21303B696628746869732E5F636F6465456469746F722E676574';
wwv_flow_imp.g_varchar2_table(25484) := '4F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E262665297B636F6E7374206E3D746869732E5F636F6465456469746F722E676574446F6D4E6F646528293B6966286E297B636F6E737420693D417328';
wwv_flow_imp.g_varchar2_table(25485) := '6E292C6F3D746869732E5F636F6465456469746F722E6765745363726F6C6C656456697369626C65506F736974696F6E28652E6765745374617274506F736974696F6E2829292C733D692E6C6566742B286F3F6F2E6C6566743A30292C723D6F3F6F2E74';
wwv_flow_imp.g_varchar2_table(25486) := '6F703A303B696628746869732E5F766965775A6F6E652626723C746869732E5F766965775A6F6E652E686569676874496E5078297B652E656E644C696E654E756D6265723E652E73746172744C696E654E756D626572262628743D2131293B636F6E7374';
wwv_flow_imp.g_varchar2_table(25487) := '206E3D4D7328746869732E5F646F6D4E6F6465292E6C6566743B733E6E262628743D2131293B636F6E7374206F3D746869732E5F636F6465456469746F722E6765745363726F6C6C656456697369626C65506F736974696F6E28652E676574456E64506F';
wwv_flow_imp.g_varchar2_table(25488) := '736974696F6E2829293B692E6C6566742B286F3F6F2E6C6566743A30293E6E262628743D2131297D7D7D746869732E5F73686F77566965775A6F6E652874297D7D5F686964652865297B746869732E5F72657665616C54696D656F7574732E666F724561';
wwv_flow_imp.g_varchar2_table(25489) := '63682828653D3E7B636C65617254696D656F75742865297D29292C746869732E5F72657665616C54696D656F7574733D5B5D2C746869732E5F697356697369626C65262628746869732E5F697356697369626C653D21312C746869732E5F757064617465';
wwv_flow_imp.g_varchar2_table(25490) := '427574746F6E7328292C746869732E5F646F6D4E6F64652E636C6173734C6973742E72656D6F7665282276697369626C6522292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C22747275652229';
wwv_flow_imp.g_varchar2_table(25491) := '2C746869732E5F66696E64496E7075742E636C6561724D65737361676528292C652626746869732E5F636F6465456469746F722E666F63757328292C746869732E5F636F6465456469746F722E6C61796F75744F7665726C617957696467657428746869';
wwv_flow_imp.g_varchar2_table(25492) := '73292C746869732E5F72656D6F7665566965775A6F6E652829297D5F6C61796F7574566965775A6F6E652865297B69662821746869732E5F636F6465456469746F722E6765744F7074696F6E283431292E616464457874726153706163654F6E546F7029';
wwv_flow_imp.g_varchar2_table(25493) := '72657475726E20766F696420746869732E5F72656D6F7665566965775A6F6E6528293B69662821746869732E5F697356697369626C652972657475726E3B636F6E737420743D746869732E5F766965775A6F6E653B766F696420303D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(25494) := '766965775A6F6E6549642626742626746869732E5F636F6465456469746F722E6368616E6765566965775A6F6E657328286E3D3E7B742E686569676874496E50783D746869732E5F67657448656967687428292C746869732E5F766965775A6F6E654964';
wwv_flow_imp.g_varchar2_table(25495) := '3D6E2E6164645A6F6E652874292C746869732E5F636F6465456469746F722E7365745363726F6C6C546F7028657C7C746869732E5F636F6465456469746F722E6765745363726F6C6C546F7028292B742E686569676874496E5078297D29297D5F73686F';
wwv_flow_imp.g_varchar2_table(25496) := '77566965775A6F6E6528653D2130297B69662821746869732E5F697356697369626C652972657475726E3B69662821746869732E5F636F6465456469746F722E6765744F7074696F6E283431292E616464457874726153706163654F6E546F7029726574';
wwv_flow_imp.g_varchar2_table(25497) := '75726E3B766F696420303D3D3D746869732E5F766965775A6F6E65262628746869732E5F766965775A6F6E653D6E6577205230283029293B636F6E737420743D746869732E5F766965775A6F6E653B746869732E5F636F6465456469746F722E6368616E';
wwv_flow_imp.g_varchar2_table(25498) := '6765566965775A6F6E657328286E3D3E7B696628766F69642030213D3D746869732E5F766965775A6F6E654964297B636F6E737420693D746869732E5F67657448656967687428293B696628693D3D3D742E686569676874496E50782972657475726E3B';
wwv_flow_imp.g_varchar2_table(25499) := '636F6E7374206F3D692D742E686569676874496E50783B72657475726E20742E686569676874496E50783D692C6E2E6C61796F75745A6F6E6528746869732E5F766965775A6F6E654964292C766F696428652626746869732E5F636F6465456469746F72';
wwv_flow_imp.g_varchar2_table(25500) := '2E7365745363726F6C6C546F7028746869732E5F636F6465456469746F722E6765745363726F6C6C546F7028292B6F29297D7B6C657420693D746869732E5F67657448656967687428293B696628692D3D746869732E5F636F6465456469746F722E6765';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(25501) := '744F7074696F6E283834292E746F702C693C3D302972657475726E3B742E686569676874496E50783D692C746869732E5F766965775A6F6E6549643D6E2E6164645A6F6E652874292C652626746869732E5F636F6465456469746F722E7365745363726F';
wwv_flow_imp.g_varchar2_table(25502) := '6C6C546F7028746869732E5F636F6465456469746F722E6765745363726F6C6C546F7028292B69297D7D29297D5F72656D6F7665566965775A6F6E6528297B746869732E5F636F6465456469746F722E6368616E6765566965775A6F6E65732828653D3E';
wwv_flow_imp.g_varchar2_table(25503) := '7B766F69642030213D3D746869732E5F766965775A6F6E654964262628652E72656D6F76655A6F6E6528746869732E5F766965775A6F6E654964292C746869732E5F766965775A6F6E6549643D766F696420302C746869732E5F766965775A6F6E652626';
wwv_flow_imp.g_varchar2_table(25504) := '28746869732E5F636F6465456469746F722E7365745363726F6C6C546F7028746869732E5F636F6465456469746F722E6765745363726F6C6C546F7028292D746869732E5F766965775A6F6E652E686569676874496E5078292C746869732E5F76696577';
wwv_flow_imp.g_varchar2_table(25505) := '5A6F6E653D766F6964203029297D29297D5F747279557064617465576964676574576964746828297B69662821746869732E5F697356697369626C652972657475726E3B69662821746869732E5F646F6D4E6F64652E6973436F6E6E6563746564297265';
wwv_flow_imp.g_varchar2_table(25506) := '7475726E3B636F6E737420653D746869732E5F636F6465456469746F722E6765744C61796F7574496E666F28293B696628652E636F6E74656E7457696474683C3D302972657475726E20766F696420746869732E5F646F6D4E6F64652E636C6173734C69';
wwv_flow_imp.g_varchar2_table(25507) := '73742E616464282268696464656E456469746F7222293B746869732E5F646F6D4E6F64652E636C6173734C6973742E636F6E7461696E73282268696464656E456469746F7222292626746869732E5F646F6D4E6F64652E636C6173734C6973742E72656D';
wwv_flow_imp.g_varchar2_table(25508) := '6F7665282268696464656E456469746F7222293B636F6E737420743D652E77696474682C6E3D652E6D696E696D61702E6D696E696D617057696474683B6C657420693D21312C6F3D21312C733D21313B696628746869732E5F726573697A656426265073';
wwv_flow_imp.g_varchar2_table(25509) := '28746869732E5F646F6D4E6F6465293E41302972657475726E20746869732E5F646F6D4E6F64652E7374796C652E6D617857696474683D742D32382D6E2D31352B227078222C766F696428746869732E5F7265706C616365496E7075742E77696474683D';
wwv_flow_imp.g_varchar2_table(25510) := '507328746869732E5F66696E64496E7075742E646F6D4E6F646529293B6966283434372B6E3E3D742626286F3D2130292C3434372B6E2D4E303E3D74262628733D2130292C3434372B6E2D4E303E3D742B3530262628693D2130292C746869732E5F646F';
wwv_flow_imp.g_varchar2_table(25511) := '6D4E6F64652E636C6173734C6973742E746F67676C652822636F6C6C61707365642D66696E642D776964676574222C69292C746869732E5F646F6D4E6F64652E636C6173734C6973742E746F67676C6528226E6172726F772D66696E642D776964676574';
wwv_flow_imp.g_varchar2_table(25512) := '222C73292C746869732E5F646F6D4E6F64652E636C6173734C6973742E746F67676C652822726564756365642D66696E642D776964676574222C6F292C737C7C697C7C28746869732E5F646F6D4E6F64652E7374796C652E6D617857696474683D742D32';
wwv_flow_imp.g_varchar2_table(25513) := '382D6E2D31352B22707822292C746869732E5F66696E64496E7075742E6C61796F7574287B636F6C6C617073656446696E645769646765743A692C6E6172726F7746696E645769646765743A732C7265647563656446696E645769646765743A6F7D292C';
wwv_flow_imp.g_varchar2_table(25514) := '746869732E5F726573697A6564297B636F6E737420653D746869732E5F66696E64496E7075742E696E707574426F782E656C656D656E742E636C69656E7457696474683B653E30262628746869732E5F7265706C616365496E7075742E77696474683D65';
wwv_flow_imp.g_varchar2_table(25515) := '297D656C736520746869732E5F69735265706C61636556697369626C65262628746869732E5F7265706C616365496E7075742E77696474683D507328746869732E5F66696E64496E7075742E646F6D4E6F646529297D5F67657448656967687428297B6C';
wwv_flow_imp.g_varchar2_table(25516) := '657420653D303B72657475726E20652B3D342C652B3D746869732E5F66696E64496E7075742E696E707574426F782E6865696768742B322C746869732E5F69735265706C61636556697369626C65262628652B3D342C652B3D746869732E5F7265706C61';
wwv_flow_imp.g_varchar2_table(25517) := '6365496E7075742E696E707574426F782E6865696768742B32292C652B3D342C657D5F74727955706461746548656967687428297B636F6E737420653D746869732E5F67657448656967687428293B72657475726E286E756C6C3D3D3D746869732E5F63';
wwv_flow_imp.g_varchar2_table(25518) := '61636865644865696768747C7C746869732E5F636163686564486569676874213D3D6529262628746869732E5F6361636865644865696768743D652C746869732E5F646F6D4E6F64652E7374796C652E6865696768743D60247B657D7078602C2130297D';
wwv_flow_imp.g_varchar2_table(25519) := '666F63757346696E64496E70757428297B746869732E5F66696E64496E7075742E73656C65637428292C746869732E5F66696E64496E7075742E666F63757328297D666F6375735265706C616365496E70757428297B746869732E5F7265706C61636549';
wwv_flow_imp.g_varchar2_table(25520) := '6E7075742E73656C65637428292C746869732E5F7265706C616365496E7075742E666F63757328297D686967686C6967687446696E644F7074696F6E7328297B746869732E5F66696E64496E7075742E686967686C6967687446696E644F7074696F6E73';
wwv_flow_imp.g_varchar2_table(25521) := '28297D5F75706461746553656172636853636F706528297B696628746869732E5F636F6465456469746F722E6861734D6F64656C28292626746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B6564297B636F6E737420653D74';
wwv_flow_imp.g_varchar2_table(25522) := '6869732E5F636F6465456469746F722E67657453656C656374696F6E7328293B652E6D61702828653D3E7B313D3D3D652E656E64436F6C756D6E2626652E656E644C696E654E756D6265723E652E73746172744C696E654E756D626572262628653D652E';
wwv_flow_imp.g_varchar2_table(25523) := '736574456E64506F736974696F6E28652E656E644C696E654E756D6265722D312C746869732E5F636F6465456469746F722E6765744D6F64656C28292E6765744C696E654D6178436F6C756D6E28652E656E644C696E654E756D6265722D312929293B63';
wwv_flow_imp.g_varchar2_table(25524) := '6F6E737420743D746869732E5F73746174652E63757272656E744D617463683B72657475726E20652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265727C7C72682E657175616C7352616E676528652C74293F6E756C6C';
wwv_flow_imp.g_varchar2_table(25525) := '3A657D29292E66696C7465722828653D3E21216529292C652E6C656E6774682626746869732E5F73746174652E6368616E6765287B73656172636853636F70653A657D2C2130297D7D5F6F6E46696E64496E7075744D6F757365446F776E2865297B652E';
wwv_flow_imp.g_varchar2_table(25526) := '6D6964646C65427574746F6E2626652E73746F7050726F7061676174696F6E28297D5F6F6E46696E64496E7075744B6579446F776E2865297B72657475726E20652E657175616C7328337C4F30293F28746869732E5F6B657962696E64696E6753657276';
wwv_flow_imp.g_varchar2_table(25527) := '6963652E64697370617463684576656E7428652C652E746172676574297C7C746869732E5F66696E64496E7075742E696E707574426F782E696E736572744174437572736F7228225C6E22292C766F696420652E70726576656E7444656661756C742829';
wwv_flow_imp.g_varchar2_table(25528) := '293A652E657175616C732832293F28746869732E5F69735265706C61636556697369626C653F746869732E5F7265706C616365496E7075742E666F63757328293A746869732E5F66696E64496E7075742E666F6375734F6E4361736553656E7369746976';
wwv_flow_imp.g_varchar2_table(25529) := '6528292C766F696420652E70726576656E7444656661756C742829293A652E657175616C732832303636293F28746869732E5F636F6465456469746F722E666F63757328292C766F696420652E70726576656E7444656661756C742829293A652E657175';
wwv_flow_imp.g_varchar2_table(25530) := '616C73283136293F463028652C746869732E5F66696E64496E7075742E67657456616C756528292C746869732E5F66696E64496E7075742E646F6D4E6F64652E717565727953656C6563746F72282274657874617265612229293A652E657175616C7328';
wwv_flow_imp.g_varchar2_table(25531) := '3138293F423028652C746869732E5F66696E64496E7075742E67657456616C756528292C746869732E5F66696E64496E7075742E646F6D4E6F64652E717565727953656C6563746F72282274657874617265612229293A766F696420307D5F6F6E526570';
wwv_flow_imp.g_varchar2_table(25532) := '6C616365496E7075744B6579446F776E2865297B72657475726E20652E657175616C7328337C4F30293F28746869732E5F6B657962696E64696E67536572766963652E64697370617463684576656E7428652C652E746172676574297C7C286A26265526';
wwv_flow_imp.g_varchar2_table(25533) := '2621746869732E5F6374726C456E7465725265706C616365416C6C5761726E696E6750726F6D70746564262628746869732E5F6E6F74696669636174696F6E536572766963652E696E666F286228302C224374726C2B456E746572206E6F7720696E7365';
wwv_flow_imp.g_varchar2_table(25534) := '727473206C696E6520627265616B20696E7374656164206F66207265706C6163696E6720616C6C2E20596F752063616E206D6F6469667920746865206B657962696E64696E6720666F7220656469746F722E616374696F6E2E7265706C616365416C6C20';
wwv_flow_imp.g_varchar2_table(25535) := '746F206F766572726964652074686973206265686176696F722E2229292C746869732E5F6374726C456E7465725265706C616365416C6C5761726E696E6750726F6D707465643D21302C746869732E5F73746F72616765536572766963652E73746F7265';
wwv_flow_imp.g_varchar2_table(25536) := '2850302C21302C302C3029292C746869732E5F7265706C616365496E7075742E696E707574426F782E696E736572744174437572736F7228225C6E2229292C766F696420652E70726576656E7444656661756C742829293A652E657175616C732832293F';
wwv_flow_imp.g_varchar2_table(25537) := '28746869732E5F66696E64496E7075742E666F6375734F6E4361736553656E73697469766528292C766F696420652E70726576656E7444656661756C742829293A652E657175616C732831303236293F28746869732E5F66696E64496E7075742E666F63';
wwv_flow_imp.g_varchar2_table(25538) := '757328292C766F696420652E70726576656E7444656661756C742829293A652E657175616C732832303636293F28746869732E5F636F6465456469746F722E666F63757328292C766F696420652E70726576656E7444656661756C742829293A652E6571';
wwv_flow_imp.g_varchar2_table(25539) := '75616C73283136293F463028652C746869732E5F7265706C616365496E7075742E696E707574426F782E76616C75652C746869732E5F7265706C616365496E7075742E696E707574426F782E656C656D656E742E717565727953656C6563746F72282274';
wwv_flow_imp.g_varchar2_table(25540) := '657874617265612229293A652E657175616C73283138293F423028652C746869732E5F7265706C616365496E7075742E696E707574426F782E76616C75652C746869732E5F7265706C616365496E7075742E696E707574426F782E656C656D656E742E71';
wwv_flow_imp.g_varchar2_table(25541) := '7565727953656C6563746F72282274657874617265612229293A766F696420307D676574566572746963616C536173684C6566742865297B72657475726E20307D5F6B657962696E64696E674C6162656C466F722865297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(25542) := '2E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672865293B72657475726E20743F602028247B742E6765744C6162656C28297D29603A22227D5F6275696C64446F6D4E6F646528297B636F6E737420653D21302C';
wwv_flow_imp.g_varchar2_table(25543) := '743D21303B746869732E5F66696E64496E7075743D746869732E5F7265676973746572286E6577206130286E756C6C2C746869732E5F636F6E746578745669657750726F76696465722C7B77696474683A3232312C6C6162656C3A62302C706C61636568';
wwv_flow_imp.g_varchar2_table(25544) := '6F6C6465723A5F302C617070656E644361736553656E7369746976654C6162656C3A746869732E5F6B657962696E64696E674C6162656C466F7228414A292C617070656E6457686F6C65576F7264734C6162656C3A746869732E5F6B657962696E64696E';
wwv_flow_imp.g_varchar2_table(25545) := '674C6162656C466F72284E4A292C617070656E6452656765784C6162656C3A746869732E5F6B657962696E64696E674C6162656C466F7228504A292C76616C69646174696F6E3A653D3E7B696628303D3D3D652E6C656E6774687C7C21746869732E5F66';
wwv_flow_imp.g_varchar2_table(25546) := '696E64496E7075742E676574526567657828292972657475726E206E756C6C3B7472797B72657475726E206E65772052656745787028652C22677522292C6E756C6C7D63617463682865297B72657475726E7B636F6E74656E743A652E6D657373616765';
wwv_flow_imp.g_varchar2_table(25547) := '7D7D7D2C666C657869626C654865696768743A652C666C657869626C6557696474683A742C666C657869626C654D61784865696768743A3131382C73686F77436F6D6D6F6E46696E64546F67676C65733A21302C73686F77486973746F727948696E743A';
wwv_flow_imp.g_varchar2_table(25548) := '28293D3E633028746869732E5F6B657962696E64696E6753657276696365292C696E707574426F785374796C65733A454D2C746F67676C655374796C65733A6B4D7D2C746869732E5F636F6E746578744B65795365727669636529292C746869732E5F66';
wwv_flow_imp.g_varchar2_table(25549) := '696E64496E7075742E7365745265676578282121746869732E5F73746174652E69735265676578292C746869732E5F66696E64496E7075742E7365744361736553656E736974697665282121746869732E5F73746174652E6D6174636843617365292C74';
wwv_flow_imp.g_varchar2_table(25550) := '6869732E5F66696E64496E7075742E73657457686F6C65576F726473282121746869732E5F73746174652E77686F6C65576F7264292C746869732E5F726567697374657228746869732E5F66696E64496E7075742E6F6E4B6579446F776E2828653D3E74';
wwv_flow_imp.g_varchar2_table(25551) := '6869732E5F6F6E46696E64496E7075744B6579446F776E2865292929292C746869732E5F726567697374657228746869732E5F66696E64496E7075742E696E707574426F782E6F6E4469644368616E6765282828293D3E7B746869732E5F69676E6F7265';
wwv_flow_imp.g_varchar2_table(25552) := '4368616E67654576656E747C7C746869732E5F73746174652E6368616E6765287B736561726368537472696E673A746869732E5F66696E64496E7075742E67657456616C756528297D2C2130297D2929292C746869732E5F726567697374657228746869';
wwv_flow_imp.g_varchar2_table(25553) := '732E5F66696E64496E7075742E6F6E4469644F7074696F6E4368616E6765282828293D3E7B746869732E5F73746174652E6368616E6765287B697352656765783A746869732E5F66696E64496E7075742E676574526567657828292C77686F6C65576F72';
wwv_flow_imp.g_varchar2_table(25554) := '643A746869732E5F66696E64496E7075742E67657457686F6C65576F72647328292C6D61746368436173653A746869732E5F66696E64496E7075742E6765744361736553656E73697469766528297D2C2130297D2929292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(25555) := '657228746869732E5F66696E64496E7075742E6F6E4361736553656E7369746976654B6579446F776E2828653D3E7B652E657175616C732831303236292626746869732E5F69735265706C61636556697369626C65262628746869732E5F7265706C6163';
wwv_flow_imp.g_varchar2_table(25556) := '65496E7075742E666F63757328292C652E70726576656E7444656661756C742829297D2929292C746869732E5F726567697374657228746869732E5F66696E64496E7075742E6F6E52656765784B6579446F776E2828653D3E7B652E657175616C732832';
wwv_flow_imp.g_varchar2_table(25557) := '292626746869732E5F69735265706C61636556697369626C65262628746869732E5F7265706C616365496E7075742E666F6375734F6E507265736572766528292C652E70726576656E7444656661756C742829297D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(25558) := '74657228746869732E5F66696E64496E7075742E696E707574426F782E6F6E4469644865696768744368616E67652828653D3E7B746869732E5F74727955706461746548656967687428292626746869732E5F73686F77566965775A6F6E6528297D2929';
wwv_flow_imp.g_varchar2_table(25559) := '292C242626746869732E5F726567697374657228746869732E5F66696E64496E7075742E6F6E4D6F757365446F776E2828653D3E746869732E5F6F6E46696E64496E7075744D6F757365446F776E2865292929292C746869732E5F6D617463686573436F';
wwv_flow_imp.g_varchar2_table(25560) := '756E743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6D617463686573436F756E742E636C6173734E616D653D226D617463686573436F756E74222C746869732E5F7570646174654D617463686573436F75';
wwv_flow_imp.g_varchar2_table(25561) := '6E7428293B636F6E7374206E3D746869732E5F7265676973746572284F452829293B746869732E5F7072657642746E3D746869732E5F7265676973746572286E6577207A30287B6C6162656C3A79302B746869732E5F6B657962696E64696E674C616265';
wwv_flow_imp.g_varchar2_table(25562) := '6C466F7228494A292C69636F6E3A6D302C686F76657244656C65676174653A6E2C6F6E547269676765723A28293D3E7B776C28746869732E5F636F6465456469746F722E676574416374696F6E28494A29292E72756E28292E7468656E28766F69642030';
wwv_flow_imp.g_varchar2_table(25563) := '2C6B65297D7D2C746869732E5F686F7665725365727669636529292C746869732E5F6E65787442746E3D746869732E5F7265676973746572286E6577207A30287B6C6162656C3A77302B746869732E5F6B657962696E64696E674C6162656C466F722854';
wwv_flow_imp.g_varchar2_table(25564) := '4A292C69636F6E3A66302C686F76657244656C65676174653A6E2C6F6E547269676765723A28293D3E7B776C28746869732E5F636F6465456469746F722E676574416374696F6E28544A29292E72756E28292E7468656E28766F696420302C6B65297D7D';
wwv_flow_imp.g_varchar2_table(25565) := '2C746869732E5F686F7665725365727669636529293B636F6E737420693D646F63756D656E742E637265617465456C656D656E74282264697622293B692E636C6173734E616D653D2266696E642D70617274222C692E617070656E644368696C64287468';
wwv_flow_imp.g_varchar2_table(25566) := '69732E5F66696E64496E7075742E646F6D4E6F6465293B636F6E7374206F3D646F63756D656E742E637265617465456C656D656E74282264697622293B6F2E636C6173734E616D653D2266696E642D616374696F6E73222C692E617070656E644368696C';
wwv_flow_imp.g_varchar2_table(25567) := '64286F292C6F2E617070656E644368696C6428746869732E5F6D617463686573436F756E74292C6F2E617070656E644368696C6428746869732E5F7072657642746E2E646F6D4E6F6465292C6F2E617070656E644368696C6428746869732E5F6E657874';
wwv_flow_imp.g_varchar2_table(25568) := '42746E2E646F6D4E6F6465292C746869732E5F746F67676C6553656C656374696F6E46696E643D746869732E5F7265676973746572286E6577205524287B69636F6E3A64302C7469746C653A43302B746869732E5F6B657962696E64696E674C6162656C';
wwv_flow_imp.g_varchar2_table(25569) := '466F72284F4A292C6973436865636B65643A21312C686F76657244656C65676174653A6E2C696E7075744163746976654F7074696F6E4261636B67726F756E643A786D286876292C696E7075744163746976654F7074696F6E426F726465723A786D2864';
wwv_flow_imp.g_varchar2_table(25570) := '76292C696E7075744163746976654F7074696F6E466F726567726F756E643A786D287576297D29292C746869732E5F726567697374657228746869732E5F746F67676C6553656C656374696F6E46696E642E6F6E4368616E6765282828293D3E7B696628';
wwv_flow_imp.g_varchar2_table(25571) := '746869732E5F746F67676C6553656C656374696F6E46696E642E636865636B6564297B696628746869732E5F636F6465456469746F722E6861734D6F64656C2829297B6C657420653D746869732E5F636F6465456469746F722E67657453656C65637469';
wwv_flow_imp.g_varchar2_table(25572) := '6F6E7328293B653D652E6D61702828653D3E28313D3D3D652E656E64436F6C756D6E2626652E656E644C696E654E756D6265723E652E73746172744C696E654E756D626572262628653D652E736574456E64506F736974696F6E28652E656E644C696E65';
wwv_flow_imp.g_varchar2_table(25573) := '4E756D6265722D312C746869732E5F636F6465456469746F722E6765744D6F64656C28292E6765744C696E654D6178436F6C756D6E28652E656E644C696E654E756D6265722D312929292C652E6973456D70747928293F6E756C6C3A652929292E66696C';
wwv_flow_imp.g_varchar2_table(25574) := '7465722828653D3E21216529292C652E6C656E6774682626746869732E5F73746174652E6368616E6765287B73656172636853636F70653A657D2C2130297D7D656C736520746869732E5F73746174652E6368616E6765287B73656172636853636F7065';
wwv_flow_imp.g_varchar2_table(25575) := '3A6E756C6C7D2C2130297D2929292C6F2E617070656E644368696C6428746869732E5F746F67676C6553656C656374696F6E46696E642E646F6D4E6F6465292C746869732E5F636C6F736542746E3D746869732E5F7265676973746572286E6577207A30';
wwv_flow_imp.g_varchar2_table(25576) := '287B6C6162656C3A53302B746869732E5F6B657962696E64696E674C6162656C466F72284D4A292C69636F6E3A50572C686F76657244656C65676174653A6E2C6F6E547269676765723A28293D3E7B746869732E5F73746174652E6368616E6765287B69';
wwv_flow_imp.g_varchar2_table(25577) := '7352657665616C65643A21312C73656172636853636F70653A6E756C6C7D2C2131297D2C6F6E4B6579446F776E3A653D3E7B652E657175616C732832292626746869732E5F69735265706C61636556697369626C65262628746869732E5F7265706C6163';
wwv_flow_imp.g_varchar2_table(25578) := '6542746E2E6973456E61626C656428293F746869732E5F7265706C61636542746E2E666F63757328293A746869732E5F636F6465456469746F722E666F63757328292C652E70726576656E7444656661756C742829297D7D2C746869732E5F686F766572';
wwv_flow_imp.g_varchar2_table(25579) := '5365727669636529292C746869732E5F7265706C616365496E7075743D746869732E5F7265676973746572286E6577206C30286E756C6C2C766F696420302C7B6C6162656C3A78302C706C616365686F6C6465723A6B302C617070656E64507265736572';
wwv_flow_imp.g_varchar2_table(25580) := '7665436173654C6162656C3A746869732E5F6B657962696E64696E674C6162656C466F7228524A292C686973746F72793A5B5D2C666C657869626C654865696768743A652C666C657869626C6557696474683A742C666C657869626C654D617848656967';
wwv_flow_imp.g_varchar2_table(25581) := '68743A3131382C73686F77486973746F727948696E743A28293D3E633028746869732E5F6B657962696E64696E6753657276696365292C696E707574426F785374796C65733A454D2C746F67676C655374796C65733A6B4D7D2C746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(25582) := '6578744B6579536572766963652C213029292C746869732E5F7265706C616365496E7075742E736574507265736572766543617365282121746869732E5F73746174652E707265736572766543617365292C746869732E5F726567697374657228746869';
wwv_flow_imp.g_varchar2_table(25583) := '732E5F7265706C616365496E7075742E6F6E4B6579446F776E2828653D3E746869732E5F6F6E5265706C616365496E7075744B6579446F776E2865292929292C746869732E5F726567697374657228746869732E5F7265706C616365496E7075742E696E';
wwv_flow_imp.g_varchar2_table(25584) := '707574426F782E6F6E4469644368616E6765282828293D3E7B746869732E5F73746174652E6368616E6765287B7265706C616365537472696E673A746869732E5F7265706C616365496E7075742E696E707574426F782E76616C75657D2C2131297D2929';
wwv_flow_imp.g_varchar2_table(25585) := '292C746869732E5F726567697374657228746869732E5F7265706C616365496E7075742E696E707574426F782E6F6E4469644865696768744368616E67652828653D3E7B746869732E5F69735265706C61636556697369626C652626746869732E5F7472';
wwv_flow_imp.g_varchar2_table(25586) := '7955706461746548656967687428292626746869732E5F73686F77566965775A6F6E6528297D2929292C746869732E5F726567697374657228746869732E5F7265706C616365496E7075742E6F6E4469644F7074696F6E4368616E6765282828293D3E7B';
wwv_flow_imp.g_varchar2_table(25587) := '746869732E5F73746174652E6368616E6765287B7072657365727665436173653A746869732E5F7265706C616365496E7075742E67657450726573657276654361736528297D2C2130297D2929292C746869732E5F726567697374657228746869732E5F';
wwv_flow_imp.g_varchar2_table(25588) := '7265706C616365496E7075742E6F6E5072657365727665436173654B6579446F776E2828653D3E7B652E657175616C73283229262628746869732E5F7072657642746E2E6973456E61626C656428293F746869732E5F7072657642746E2E666F63757328';
wwv_flow_imp.g_varchar2_table(25589) := '293A746869732E5F6E65787442746E2E6973456E61626C656428293F746869732E5F6E65787442746E2E666F63757328293A746869732E5F746F67676C6553656C656374696F6E46696E642E656E61626C65643F746869732E5F746F67676C6553656C65';
wwv_flow_imp.g_varchar2_table(25590) := '6374696F6E46696E642E666F63757328293A746869732E5F636C6F736542746E2E6973456E61626C656428292626746869732E5F636C6F736542746E2E666F63757328292C652E70726576656E7444656661756C742829297D2929293B636F6E73742073';
wwv_flow_imp.g_varchar2_table(25591) := '3D746869732E5F7265676973746572284F452829293B746869732E5F7265706C61636542746E3D746869732E5F7265676973746572286E6577207A30287B6C6162656C3A45302B746869732E5F6B657962696E64696E674C6162656C466F7228464A292C';
wwv_flow_imp.g_varchar2_table(25592) := '69636F6E3A70302C686F76657244656C65676174653A732C6F6E547269676765723A28293D3E7B746869732E5F636F6E74726F6C6C65722E7265706C61636528297D2C6F6E4B6579446F776E3A653D3E7B652E657175616C732831303236292626287468';
wwv_flow_imp.g_varchar2_table(25593) := '69732E5F636C6F736542746E2E666F63757328292C652E70726576656E7444656661756C742829297D7D2C746869732E5F686F7665725365727669636529292C746869732E5F7265706C616365416C6C42746E3D746869732E5F7265676973746572286E';
wwv_flow_imp.g_varchar2_table(25594) := '6577207A30287B6C6162656C3A4C302B746869732E5F6B657962696E64696E674C6162656C466F7228424A292C69636F6E3A67302C686F76657244656C65676174653A732C6F6E547269676765723A28293D3E7B746869732E5F636F6E74726F6C6C6572';
wwv_flow_imp.g_varchar2_table(25595) := '2E7265706C616365416C6C28297D7D2C746869732E5F686F7665725365727669636529293B636F6E737420723D646F63756D656E742E637265617465456C656D656E74282264697622293B722E636C6173734E616D653D227265706C6163652D70617274';
wwv_flow_imp.g_varchar2_table(25596) := '222C722E617070656E644368696C6428746869732E5F7265706C616365496E7075742E646F6D4E6F6465293B636F6E737420613D646F63756D656E742E637265617465456C656D656E74282264697622293B612E636C6173734E616D653D227265706C61';
wwv_flow_imp.g_varchar2_table(25597) := '63652D616374696F6E73222C722E617070656E644368696C642861292C612E617070656E644368696C6428746869732E5F7265706C61636542746E2E646F6D4E6F6465292C612E617070656E644368696C6428746869732E5F7265706C616365416C6C42';
wwv_flow_imp.g_varchar2_table(25598) := '746E2E646F6D4E6F6465292C746869732E5F746F67676C655265706C61636542746E3D746869732E5F7265676973746572286E6577207A30287B6C6162656C3A44302C636C6173734E616D653A22636F6469636F6E20746F67676C65206C656674222C6F';
wwv_flow_imp.g_varchar2_table(25599) := '6E547269676765723A28293D3E7B746869732E5F73746174652E6368616E6765287B69735265706C61636552657665616C65643A21746869732E5F69735265706C61636556697369626C657D2C2131292C746869732E5F69735265706C61636556697369';
wwv_flow_imp.g_varchar2_table(25600) := '626C65262628746869732E5F7265706C616365496E7075742E77696474683D507328746869732E5F66696E64496E7075742E646F6D4E6F6465292C746869732E5F7265706C616365496E7075742E696E707574426F782E6C61796F75742829292C746869';
wwv_flow_imp.g_varchar2_table(25601) := '732E5F73686F77566965775A6F6E6528297D7D2C746869732E5F686F7665725365727669636529292C746869732E5F746F67676C655265706C61636542746E2E736574457870616E64656428746869732E5F69735265706C61636556697369626C65292C';
wwv_flow_imp.g_varchar2_table(25602) := '746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D22656469746F722D7769646765742066696E642D776964676574222C74686973';
wwv_flow_imp.g_varchar2_table(25603) := '2E5F646F6D4E6F64652E7365744174747269627574652822617269612D68696464656E222C227472756522292C746869732E5F646F6D4E6F64652E617269614C6162656C3D76302C746869732E5F646F6D4E6F64652E726F6C653D226469616C6F67222C';
wwv_flow_imp.g_varchar2_table(25604) := '746869732E5F646F6D4E6F64652E7374796C652E77696474683D223431397078222C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F746F67676C655265706C61636542746E2E646F6D4E6F6465292C746869732E5F646F';
wwv_flow_imp.g_varchar2_table(25605) := '6D4E6F64652E617070656E644368696C642869292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F636C6F736542746E2E646F6D4E6F6465292C746869732E5F646F6D4E6F64652E617070656E644368696C642872292C';
wwv_flow_imp.g_varchar2_table(25606) := '746869732E5F726573697A65536173683D746869732E5F7265676973746572286E657720637128746869732E5F646F6D4E6F64652C746869732C7B6F7269656E746174696F6E3A302C73697A653A327D29292C746869732E5F726573697A65643D21313B';
wwv_flow_imp.g_varchar2_table(25607) := '6C6574206C3D41303B746869732E5F726567697374657228746869732E5F726573697A65536173682E6F6E4469645374617274282828293D3E7B6C3D507328746869732E5F646F6D4E6F6465297D2929292C746869732E5F726567697374657228746869';
wwv_flow_imp.g_varchar2_table(25608) := '732E5F726573697A65536173682E6F6E4469644368616E67652828653D3E7B746869732E5F726573697A65643D21303B636F6E737420743D6C2B652E7374617274582D652E63757272656E74583B743C41307C7C743E287061727365466C6F6174284C73';
wwv_flow_imp.g_varchar2_table(25609) := '28746869732E5F646F6D4E6F6465292E6D61785769647468297C7C30297C7C28746869732E5F646F6D4E6F64652E7374796C652E77696474683D60247B747D7078602C746869732E5F69735265706C61636556697369626C65262628746869732E5F7265';
wwv_flow_imp.g_varchar2_table(25610) := '706C616365496E7075742E77696474683D507328746869732E5F66696E64496E7075742E646F6D4E6F646529292C746869732E5F66696E64496E7075742E696E707574426F782E6C61796F757428292C746869732E5F7472795570646174654865696768';
wwv_flow_imp.g_varchar2_table(25611) := '742829297D2929292C746869732E5F726567697374657228746869732E5F726573697A65536173682E6F6E4469645265736574282828293D3E7B636F6E737420653D507328746869732E5F646F6D4E6F6465293B696628653C41302972657475726E3B6C';
wwv_flow_imp.g_varchar2_table(25612) := '657420743D41303B69662821746869732E5F726573697A65647C7C653D3D3D4130297B636F6E737420653D746869732E5F636F6465456469746F722E6765744C61796F7574496E666F28293B743D652E77696474682D32382D652E6D696E696D61702E6D';
wwv_flow_imp.g_varchar2_table(25613) := '696E696D617057696474682D31352C746869732E5F726573697A65643D21307D746869732E5F646F6D4E6F64652E7374796C652E77696474683D60247B747D7078602C746869732E5F69735265706C61636556697369626C65262628746869732E5F7265';
wwv_flow_imp.g_varchar2_table(25614) := '706C616365496E7075742E77696474683D507328746869732E5F66696E64496E7075742E646F6D4E6F646529292C746869732E5F66696E64496E7075742E696E707574426F782E6C61796F757428297D2929297D7570646174654163636573736962696C';
wwv_flow_imp.g_varchar2_table(25615) := '697479537570706F727428297B636F6E737420653D746869732E5F636F6465456469746F722E6765744F7074696F6E2832293B746869732E5F66696E64496E7075742E736574466F637573496E7075744F6E4F7074696F6E436C69636B2832213D3D6529';
wwv_flow_imp.g_varchar2_table(25616) := '7D7D56302E49443D22656469746F722E636F6E747269622E66696E64576964676574223B636C617373207A3020657874656E64732047447B636F6E7374727563746F7228652C74297B766172206E3B737570657228292C746869732E5F6F7074733D653B';
wwv_flow_imp.g_varchar2_table(25617) := '6C657420693D22627574746F6E223B746869732E5F6F7074732E636C6173734E616D65262628693D692B2220222B746869732E5F6F7074732E636C6173734E616D65292C746869732E5F6F7074732E69636F6E262628693D692B2220222B546C2E617343';
wwv_flow_imp.g_varchar2_table(25618) := '6C6173734E616D6528746869732E5F6F7074732E69636F6E29292C746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E746162496E6465783D302C74686973';
wwv_flow_imp.g_varchar2_table(25619) := '2E5F646F6D4E6F64652E636C6173734E616D653D692C746869732E5F646F6D4E6F64652E7365744174747269627574652822726F6C65222C22627574746F6E22292C746869732E5F646F6D4E6F64652E7365744174747269627574652822617269612D6C';
wwv_flow_imp.g_varchar2_table(25620) := '6162656C222C746869732E5F6F7074732E6C6162656C292C746869732E5F726567697374657228742E7365747570557064617461626C65486F766572286E756C6C213D3D286E3D652E686F76657244656C6567617465292626766F69642030213D3D6E3F';
wwv_flow_imp.g_varchar2_table(25621) := '6E3A50452822656C656D656E7422292C746869732E5F646F6D4E6F64652C746869732E5F6F7074732E6C6162656C29292C746869732E6F6E636C69636B28746869732E5F646F6D4E6F64652C28653D3E7B746869732E5F6F7074732E6F6E547269676765';
wwv_flow_imp.g_varchar2_table(25622) := '7228292C652E70726576656E7444656661756C7428297D29292C746869732E6F6E6B6579646F776E28746869732E5F646F6D4E6F64652C28653D3E7B76617220742C6E3B696628652E657175616C73283130297C7C652E657175616C7328332929726574';
wwv_flow_imp.g_varchar2_table(25623) := '75726E20746869732E5F6F7074732E6F6E5472696767657228292C766F696420652E70726576656E7444656661756C7428293B6E756C6C3D3D3D286E3D28743D746869732E5F6F707473292E6F6E4B6579446F776E297C7C766F696420303D3D3D6E7C7C';
wwv_flow_imp.g_varchar2_table(25624) := '6E2E63616C6C28742C65297D29297D67657420646F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D6973456E61626C656428297B72657475726E20746869732E5F646F6D4E6F64652E746162496E6465783E3D307D666F637573';
wwv_flow_imp.g_varchar2_table(25625) := '28297B746869732E5F646F6D4E6F64652E666F63757328297D736574456E61626C65642865297B746869732E5F646F6D4E6F64652E636C6173734C6973742E746F67676C65282264697361626C6564222C2165292C746869732E5F646F6D4E6F64652E73';
wwv_flow_imp.g_varchar2_table(25626) := '65744174747269627574652822617269612D64697361626C6564222C537472696E6728216529292C746869732E5F646F6D4E6F64652E746162496E6465783D653F303A2D317D736574457870616E6465642865297B746869732E5F646F6D4E6F64652E73';
wwv_flow_imp.g_varchar2_table(25627) := '65744174747269627574652822617269612D657870616E646564222C537472696E672821216529292C653F28746869732E5F646F6D4E6F64652E636C6173734C6973742E72656D6F7665282E2E2E546C2E6173436C6173734E616D654172726179286830';
wwv_flow_imp.g_varchar2_table(25628) := '29292C746869732E5F646F6D4E6F64652E636C6173734C6973742E616464282E2E2E546C2E6173436C6173734E616D6541727261792875302929293A28746869732E5F646F6D4E6F64652E636C6173734C6973742E72656D6F7665282E2E2E546C2E6173';
wwv_flow_imp.g_varchar2_table(25629) := '436C6173734E616D65417272617928753029292C746869732E5F646F6D4E6F64652E636C6173734C6973742E616464282E2E2E546C2E6173436C6173734E616D6541727261792868302929297D7D5662282828652C74293D3E7B636F6E7374206E3D652E';
wwv_flow_imp.g_varchar2_table(25630) := '676574436F6C6F72286666293B6E2626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E66696E644D61746368207B20626F726465723A2031707820247B416228652E74797065293F22646F74746564223A22736F6C6964227D20247B';
wwv_flow_imp.g_varchar2_table(25631) := '6E7D3B20626F782D73697A696E673A20626F726465722D626F783B207D60293B636F6E737420693D652E676574436F6C6F72287666293B692626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E66696E6453636F7065207B20626F72';
wwv_flow_imp.g_varchar2_table(25632) := '6465723A2031707820247B416228652E74797065293F22646173686564223A22736F6C6964227D20247B697D3B207D60293B636F6E7374206F3D652E676574436F6C6F72287A6D293B6F2626742E61646452756C6528602E6D6F6E61636F2D656469746F';
wwv_flow_imp.g_varchar2_table(25633) := '72202E66696E642D776964676574207B20626F726465723A2031707820736F6C696420247B6F7D3B207D60297D29293B7661722048302C57303D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(25634) := '2C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D';
wwv_flow_imp.g_varchar2_table(25635) := '747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D';
wwv_flow_imp.g_varchar2_table(25636) := '28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C6A303D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(25637) := '657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E20713028652C743D2273696E676C65222C6E3D2131297B69662821652E6861734D6F64656C28292972657475726E206E756C6C3B636F6E737420693D65';
wwv_flow_imp.g_varchar2_table(25638) := '2E67657453656C656374696F6E28293B6966282273696E676C65223D3D3D742626692E73746172744C696E654E756D6265723D3D3D692E656E644C696E654E756D6265727C7C226D756C7469706C65223D3D3D7429696628692E6973456D707479282929';
wwv_flow_imp.g_varchar2_table(25639) := '7B636F6E737420743D652E676574436F6E66696775726564576F72644174506F736974696F6E28692E6765745374617274506F736974696F6E2829293B69662874262621313D3D3D6E2972657475726E20742E776F72647D656C736520696628652E6765';
wwv_flow_imp.g_varchar2_table(25640) := '744D6F64656C28292E67657456616C75654C656E677468496E52616E67652869293C3532343238382972657475726E20652E6765744D6F64656C28292E67657456616C7565496E52616E67652869293B72657475726E206E756C6C7D6C65742024303D48';
wwv_flow_imp.g_varchar2_table(25641) := '303D636C61737320657874656E6473206C747B67657420656469746F7228297B72657475726E20746869732E5F656469746F727D737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2848302E4944297D636F';
wwv_flow_imp.g_varchar2_table(25642) := '6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E5F656469746F723D652C746869732E5F66696E6457696467657456697369626C653D774A2E62696E64546F2874292C746869732E5F636F6E746578744B657953';
wwv_flow_imp.g_varchar2_table(25643) := '6572766963653D742C746869732E5F73746F72616765536572766963653D6E2C746869732E5F636C6970626F617264536572766963653D692C746869732E5F6E6F74696669636174696F6E536572766963653D6F2C746869732E5F686F76657253657276';
wwv_flow_imp.g_varchar2_table(25644) := '6963653D732C746869732E5F757064617465486973746F727944656C617965723D6E6577207A7428353030292C746869732E5F73746174653D746869732E5F7265676973746572286E657720244A292C746869732E6C6F61645175657279537461746528';
wwv_flow_imp.g_varchar2_table(25645) := '292C746869732E5F726567697374657228746869732E5F73746174652E6F6E46696E645265706C61636553746174654368616E67652828653D3E746869732E5F6F6E53746174654368616E6765642865292929292C746869732E5F6D6F64656C3D6E756C';
wwv_flow_imp.g_varchar2_table(25646) := '6C2C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292626746869732E5F73746174652E6973';
wwv_flow_imp.g_varchar2_table(25647) := '52657665616C65643B746869732E646973706F73654D6F64656C28292C746869732E5F73746174652E6368616E6765287B73656172636853636F70653A6E756C6C2C6D61746368436173653A746869732E5F73746F72616765536572766963652E676574';
wwv_flow_imp.g_varchar2_table(25648) := '426F6F6C65616E2822656469746F722E6D6174636843617365222C312C2131292C77686F6C65576F72643A746869732E5F73746F72616765536572766963652E676574426F6F6C65616E2822656469746F722E77686F6C65576F7264222C312C2131292C';
wwv_flow_imp.g_varchar2_table(25649) := '697352656765783A746869732E5F73746F72616765536572766963652E676574426F6F6C65616E2822656469746F722E69735265676578222C312C2131292C7072657365727665436173653A746869732E5F73746F72616765536572766963652E676574';
wwv_flow_imp.g_varchar2_table(25650) := '426F6F6C65616E2822656469746F722E707265736572766543617365222C312C2131297D2C2131292C652626746869732E5F7374617274287B666F72636552657665616C5265706C6163653A21312C73656564536561726368537472696E6746726F6D53';
wwv_flow_imp.g_varchar2_table(25651) := '656C656374696F6E3A226E6F6E65222C73656564536561726368537472696E6746726F6D4E6F6E456D70747953656C656374696F6E3A21312C73656564536561726368537472696E6746726F6D476C6F62616C436C6970626F6172643A21312C73686F75';
wwv_flow_imp.g_varchar2_table(25652) := '6C64466F6375733A302C73686F756C64416E696D6174653A21312C75706461746553656172636853636F70653A21312C6C6F6F703A746869732E5F656469746F722E6765744F7074696F6E283431292E6C6F6F707D297D2929297D646973706F73652829';
wwv_flow_imp.g_varchar2_table(25653) := '7B746869732E646973706F73654D6F64656C28292C73757065722E646973706F736528297D646973706F73654D6F64656C28297B746869732E5F6D6F64656C262628746869732E5F6D6F64656C2E646973706F736528292C746869732E5F6D6F64656C3D';
wwv_flow_imp.g_varchar2_table(25654) := '6E756C6C297D5F6F6E53746174654368616E6765642865297B746869732E73617665517565727953746174652865292C652E697352657665616C6564262628746869732E5F73746174652E697352657665616C65643F746869732E5F66696E6457696467';
wwv_flow_imp.g_varchar2_table(25655) := '657456697369626C652E736574282130293A28746869732E5F66696E6457696467657456697369626C652E726573657428292C746869732E646973706F73654D6F64656C282929292C652E736561726368537472696E672626746869732E736574476C6F';
wwv_flow_imp.g_varchar2_table(25656) := '62616C4275666665725465726D28746869732E5F73746174652E736561726368537472696E67297D73617665517565727953746174652865297B652E697352656765782626746869732E5F73746F72616765536572766963652E73746F72652822656469';
wwv_flow_imp.g_varchar2_table(25657) := '746F722E69735265676578222C746869732E5F73746174652E61637475616C497352656765782C312C31292C652E77686F6C65576F72642626746869732E5F73746F72616765536572766963652E73746F72652822656469746F722E77686F6C65576F72';
wwv_flow_imp.g_varchar2_table(25658) := '64222C746869732E5F73746174652E61637475616C57686F6C65576F72642C312C31292C652E6D61746368436173652626746869732E5F73746F72616765536572766963652E73746F72652822656469746F722E6D6174636843617365222C746869732E';
wwv_flow_imp.g_varchar2_table(25659) := '5F73746174652E61637475616C4D61746368436173652C312C31292C652E7072657365727665436173652626746869732E5F73746F72616765536572766963652E73746F72652822656469746F722E707265736572766543617365222C746869732E5F73';
wwv_flow_imp.g_varchar2_table(25660) := '746174652E61637475616C5072657365727665436173652C312C31297D6C6F61645175657279537461746528297B746869732E5F73746174652E6368616E6765287B6D61746368436173653A746869732E5F73746F72616765536572766963652E676574';
wwv_flow_imp.g_varchar2_table(25661) := '426F6F6C65616E2822656469746F722E6D6174636843617365222C312C746869732E5F73746174652E6D6174636843617365292C77686F6C65576F72643A746869732E5F73746F72616765536572766963652E676574426F6F6C65616E2822656469746F';
wwv_flow_imp.g_varchar2_table(25662) := '722E77686F6C65576F7264222C312C746869732E5F73746174652E77686F6C65576F7264292C697352656765783A746869732E5F73746F72616765536572766963652E676574426F6F6C65616E2822656469746F722E69735265676578222C312C746869';
wwv_flow_imp.g_varchar2_table(25663) := '732E5F73746174652E69735265676578292C7072657365727665436173653A746869732E5F73746F72616765536572766963652E676574426F6F6C65616E2822656469746F722E707265736572766543617365222C312C746869732E5F73746174652E70';
wwv_flow_imp.g_varchar2_table(25664) := '7265736572766543617365297D2C2131297D697346696E64496E707574466F637573656428297B72657475726E2121434A2E67657456616C756528746869732E5F636F6E746578744B657953657276696365297D676574537461746528297B7265747572';
wwv_flow_imp.g_varchar2_table(25665) := '6E20746869732E5F73746174657D636C6F736546696E6457696467657428297B746869732E5F73746174652E6368616E6765287B697352657665616C65643A21312C73656172636853636F70653A6E756C6C7D2C2131292C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(25666) := '2E666F63757328297D746F67676C654361736553656E73697469766528297B746869732E5F73746174652E6368616E6765287B6D61746368436173653A21746869732E5F73746174652E6D61746368436173657D2C2131292C746869732E5F7374617465';
wwv_flow_imp.g_varchar2_table(25667) := '2E697352657665616C65647C7C746869732E686967686C6967687446696E644F7074696F6E7328297D746F67676C6557686F6C65576F72647328297B746869732E5F73746174652E6368616E6765287B77686F6C65576F72643A21746869732E5F737461';
wwv_flow_imp.g_varchar2_table(25668) := '74652E77686F6C65576F72647D2C2131292C746869732E5F73746174652E697352657665616C65647C7C746869732E686967686C6967687446696E644F7074696F6E7328297D746F67676C65526567657828297B746869732E5F73746174652E6368616E';
wwv_flow_imp.g_varchar2_table(25669) := '6765287B697352656765783A21746869732E5F73746174652E697352656765787D2C2131292C746869732E5F73746174652E697352657665616C65647C7C746869732E686967686C6967687446696E644F7074696F6E7328297D746F67676C6550726573';
wwv_flow_imp.g_varchar2_table(25670) := '657276654361736528297B746869732E5F73746174652E6368616E6765287B7072657365727665436173653A21746869732E5F73746174652E7072657365727665436173657D2C2131292C746869732E5F73746174652E697352657665616C65647C7C74';
wwv_flow_imp.g_varchar2_table(25671) := '6869732E686967686C6967687446696E644F7074696F6E7328297D746F67676C6553656172636853636F706528297B696628746869732E5F73746174652E73656172636853636F706529746869732E5F73746174652E6368616E6765287B736561726368';
wwv_flow_imp.g_varchar2_table(25672) := '53636F70653A6E756C6C7D2C2130293B656C736520696628746869732E5F656469746F722E6861734D6F64656C2829297B6C657420653D746869732E5F656469746F722E67657453656C656374696F6E7328293B653D652E6D61702828653D3E28313D3D';
wwv_flow_imp.g_varchar2_table(25673) := '3D652E656E64436F6C756D6E2626652E656E644C696E654E756D6265723E652E73746172744C696E654E756D626572262628653D652E736574456E64506F736974696F6E28652E656E644C696E654E756D6265722D312C746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(25674) := '6765744D6F64656C28292E6765744C696E654D6178436F6C756D6E28652E656E644C696E654E756D6265722D312929292C652E6973456D70747928293F6E756C6C3A652929292E66696C7465722828653D3E21216529292C652E6C656E67746826267468';
wwv_flow_imp.g_varchar2_table(25675) := '69732E5F73746174652E6368616E6765287B73656172636853636F70653A657D2C2130297D7D736574536561726368537472696E672865297B746869732E5F73746174652E69735265676578262628653D6369286529292C746869732E5F73746174652E';
wwv_flow_imp.g_varchar2_table(25676) := '6368616E6765287B736561726368537472696E673A657D2C2131297D686967686C6967687446696E644F7074696F6E7328653D2131297B7D6173796E63205F737461727428652C74297B696628746869732E646973706F73654D6F64656C28292C217468';
wwv_flow_imp.g_varchar2_table(25677) := '69732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E7374206E3D7B2E2E2E742C697352657665616C65643A21307D3B6966282273696E676C65223D3D3D652E73656564536561726368537472696E6746726F6D53656C656374';
wwv_flow_imp.g_varchar2_table(25678) := '696F6E297B636F6E737420743D713028746869732E5F656469746F722C652E73656564536561726368537472696E6746726F6D53656C656374696F6E2C652E73656564536561726368537472696E6746726F6D4E6F6E456D70747953656C656374696F6E';
wwv_flow_imp.g_varchar2_table(25679) := '293B74262628746869732E5F73746174652E697352656765783F6E2E736561726368537472696E673D63692874293A6E2E736561726368537472696E673D74297D656C736520696628226D756C7469706C65223D3D3D652E736565645365617263685374';
wwv_flow_imp.g_varchar2_table(25680) := '72696E6746726F6D53656C656374696F6E262621652E75706461746553656172636853636F7065297B636F6E737420743D713028746869732E5F656469746F722C652E73656564536561726368537472696E6746726F6D53656C656374696F6E293B7426';
wwv_flow_imp.g_varchar2_table(25681) := '26286E2E736561726368537472696E673D74297D696628216E2E736561726368537472696E672626652E73656564536561726368537472696E6746726F6D476C6F62616C436C6970626F617264297B636F6E737420653D617761697420746869732E6765';
wwv_flow_imp.g_varchar2_table(25682) := '74476C6F62616C4275666665725465726D28293B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B652626286E2E736561726368537472696E673D65297D696628652E666F72636552657665616C5265706C616365';
wwv_flow_imp.g_varchar2_table(25683) := '7C7C6E2E69735265706C61636552657665616C65643F6E2E69735265706C61636552657665616C65643D21303A746869732E5F66696E6457696467657456697369626C652E67657428297C7C286E2E69735265706C61636552657665616C65643D213129';
wwv_flow_imp.g_varchar2_table(25684) := '2C652E75706461746553656172636853636F7065297B636F6E737420653D746869732E5F656469746F722E67657453656C656374696F6E7328293B652E736F6D652828653D3E21652E6973456D707479282929292626286E2E73656172636853636F7065';
wwv_flow_imp.g_varchar2_table(25685) := '3D65297D6E2E6C6F6F703D652E6C6F6F702C746869732E5F73746174652E6368616E6765286E2C2131292C746869732E5F6D6F64656C7C7C28746869732E5F6D6F64656C3D6E6577207A4A28746869732E5F656469746F722C746869732E5F7374617465';
wwv_flow_imp.g_varchar2_table(25686) := '29297D737461727428652C74297B72657475726E20746869732E5F737461727428652C74297D6D6F7665546F4E6578744D6174636828297B72657475726E2121746869732E5F6D6F64656C262628746869732E5F6D6F64656C2E6D6F7665546F4E657874';
wwv_flow_imp.g_varchar2_table(25687) := '4D6174636828292C2130297D6D6F7665546F507265764D6174636828297B72657475726E2121746869732E5F6D6F64656C262628746869732E5F6D6F64656C2E6D6F7665546F507265764D6174636828292C2130297D676F546F4D617463682865297B72';
wwv_flow_imp.g_varchar2_table(25688) := '657475726E2121746869732E5F6D6F64656C262628746869732E5F6D6F64656C2E6D6F7665546F4D617463682865292C2130297D7265706C61636528297B72657475726E2121746869732E5F6D6F64656C262628746869732E5F6D6F64656C2E7265706C';
wwv_flow_imp.g_varchar2_table(25689) := '61636528292C2130297D7265706C616365416C6C28297B76617220653B72657475726E2121746869732E5F6D6F64656C262628286E756C6C3D3D3D28653D746869732E5F656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D653F76';
wwv_flow_imp.g_varchar2_table(25690) := '6F696420303A652E6973546F6F4C61726765466F72486561704F7065726174696F6E2829293F28746869732E5F6E6F74696669636174696F6E536572766963652E7761726E286228302C225468652066696C6520697320746F6F206C6172676520746F20';
wwv_flow_imp.g_varchar2_table(25691) := '706572666F726D2061207265706C61636520616C6C206F7065726174696F6E2E2229292C2131293A28746869732E5F6D6F64656C2E7265706C616365416C6C28292C213029297D73656C656374416C6C4D61746368657328297B72657475726E21217468';
wwv_flow_imp.g_varchar2_table(25692) := '69732E5F6D6F64656C262628746869732E5F6D6F64656C2E73656C656374416C6C4D61746368657328292C746869732E5F656469746F722E666F63757328292C2130297D6173796E6320676574476C6F62616C4275666665725465726D28297B72657475';
wwv_flow_imp.g_varchar2_table(25693) := '726E20746869732E5F656469746F722E6765744F7074696F6E283431292E676C6F62616C46696E64436C6970626F6172642626746869732E5F656469746F722E6861734D6F64656C2829262621746869732E5F656469746F722E6765744D6F64656C2829';
wwv_flow_imp.g_varchar2_table(25694) := '2E6973546F6F4C61726765466F7253796E63696E6728293F746869732E5F636C6970626F617264536572766963652E7265616446696E645465787428293A22227D736574476C6F62616C4275666665725465726D2865297B746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(25695) := '2E6765744F7074696F6E283431292E676C6F62616C46696E64436C6970626F6172642626746869732E5F656469746F722E6861734D6F64656C2829262621746869732E5F656469746F722E6765744D6F64656C28292E6973546F6F4C61726765466F7253';
wwv_flow_imp.g_varchar2_table(25696) := '796E63696E6728292626746869732E5F636C6970626F617264536572766963652E777269746546696E64546578742865297D7D3B24302E49443D22656469746F722E636F6E747269622E66696E64436F6E74726F6C6C6572222C24303D48303D5730285B';
wwv_flow_imp.g_varchar2_table(25697) := '6A3028312C6364292C6A3028322C5142292C6A3028332C7945292C6A3028342C7344292C6A3028352C4971295D2C2430293B6C65742055303D636C61737320657874656E64732024307B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C';
wwv_flow_imp.g_varchar2_table(25698) := '612C6C297B737570657228652C6E2C722C612C732C6C292C746869732E5F636F6E7465787456696577536572766963653D742C746869732E5F6B657962696E64696E67536572766963653D692C746869732E5F7468656D65536572766963653D6F2C7468';
wwv_flow_imp.g_varchar2_table(25699) := '69732E5F7769646765743D6E756C6C2C746869732E5F66696E644F7074696F6E735769646765743D6E756C6C7D6173796E63205F737461727428652C74297B746869732E5F7769646765747C7C746869732E5F63726561746546696E6457696467657428';
wwv_flow_imp.g_varchar2_table(25700) := '293B636F6E7374206E3D746869732E5F656469746F722E67657453656C656374696F6E28293B6C657420693D21313B73776974636828746869732E5F656469746F722E6765744F7074696F6E283431292E6175746F46696E64496E53656C656374696F6E';
wwv_flow_imp.g_varchar2_table(25701) := '297B6361736522616C77617973223A693D21303B627265616B3B63617365226E65766572223A693D21313B627265616B3B63617365226D756C74696C696E65223A693D21216E26266E2E73746172744C696E654E756D626572213D3D6E2E656E644C696E';
wwv_flow_imp.g_varchar2_table(25702) := '654E756D6265727D652E75706461746553656172636853636F70653D652E75706461746553656172636853636F70657C7C692C61776169742073757065722E5F737461727428652C74292C746869732E5F776964676574262628323D3D3D652E73686F75';
wwv_flow_imp.g_varchar2_table(25703) := '6C64466F6375733F746869732E5F7769646765742E666F6375735265706C616365496E70757428293A313D3D3D652E73686F756C64466F6375732626746869732E5F7769646765742E666F63757346696E64496E7075742829297D686967686C69676874';
wwv_flow_imp.g_varchar2_table(25704) := '46696E644F7074696F6E7328653D2131297B746869732E5F7769646765747C7C746869732E5F63726561746546696E6457696467657428292C746869732E5F73746174652E697352657665616C6564262621653F746869732E5F7769646765742E686967';
wwv_flow_imp.g_varchar2_table(25705) := '686C6967687446696E644F7074696F6E7328293A746869732E5F66696E644F7074696F6E735769646765742E686967686C6967687446696E644F7074696F6E7328297D5F63726561746546696E6457696467657428297B746869732E5F7769646765743D';
wwv_flow_imp.g_varchar2_table(25706) := '746869732E5F7265676973746572286E657720563028746869732E5F656469746F722C746869732C746869732E5F73746174652C746869732E5F636F6E7465787456696577536572766963652C746869732E5F6B657962696E64696E6753657276696365';
wwv_flow_imp.g_varchar2_table(25707) := '2C746869732E5F636F6E746578744B6579536572766963652C746869732E5F7468656D65536572766963652C746869732E5F73746F72616765536572766963652C746869732E5F6E6F74696669636174696F6E536572766963652C746869732E5F686F76';
wwv_flow_imp.g_varchar2_table(25708) := '65725365727669636529292C746869732E5F66696E644F7074696F6E735769646765743D746869732E5F7265676973746572286E6577206A4A28746869732E5F656469746F722C746869732E5F73746174652C746869732E5F6B657962696E64696E6753';
wwv_flow_imp.g_varchar2_table(25709) := '65727669636529297D7D3B55303D5730285B6A3028312C6A45292C6A3028322C6364292C6A3028332C2445292C6A3028342C5062292C6A3028352C7344292C6A3028362C5142292C6A3028372C7945292C6A3028382C4971295D2C5530292C5864286E65';
wwv_flow_imp.g_varchar2_table(25710) := '77204B64287B69643A22616374696F6E732E66696E64222C6C6162656C3A6228302C2246696E6422292C616C6961733A2246696E64222C707265636F6E646974696F6E3A57632E6F72286C682E666F6375732C57632E6861732822656469746F7249734F';
wwv_flow_imp.g_varchar2_table(25711) := '70656E2229292C6B624F7074733A7B6B62457870723A6E756C6C2C7072696D6172793A323038342C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F75703A22335F66696E';
wwv_flow_imp.g_varchar2_table(25712) := '64222C7469746C653A6228302C22262646696E6422292C6F726465723A317D7D29292E616464496D706C656D656E746174696F6E28302C2828652C742C6E293D3E7B636F6E737420693D24302E6765742874293B72657475726E2121692626692E737461';
wwv_flow_imp.g_varchar2_table(25713) := '7274287B666F72636552657665616C5265706C6163653A21312C73656564536561726368537472696E6746726F6D53656C656374696F6E3A226E6576657222213D3D742E6765744F7074696F6E283431292E73656564536561726368537472696E674672';
wwv_flow_imp.g_varchar2_table(25714) := '6F6D53656C656374696F6E3F2273696E676C65223A226E6F6E65222C73656564536561726368537472696E6746726F6D4E6F6E456D70747953656C656374696F6E3A2273656C656374696F6E223D3D3D742E6765744F7074696F6E283431292E73656564';
wwv_flow_imp.g_varchar2_table(25715) := '536561726368537472696E6746726F6D53656C656374696F6E2C73656564536561726368537472696E6746726F6D476C6F62616C436C6970626F6172643A742E6765744F7074696F6E283431292E676C6F62616C46696E64436C6970626F6172642C7368';
wwv_flow_imp.g_varchar2_table(25716) := '6F756C64466F6375733A312C73686F756C64416E696D6174653A21302C75706461746553656172636853636F70653A21312C6C6F6F703A742E6765744F7074696F6E283431292E6C6F6F707D297D29293B636F6E7374204B303D7B646573637269707469';
wwv_flow_imp.g_varchar2_table(25717) := '6F6E3A224F70656E2061206E657720496E2D456469746F722046696E64205769646765742E222C617267733A5B7B6E616D653A224F70656E2061206E657720496E2D456469746F722046696E64205769646765742061726773222C736368656D613A7B70';
wwv_flow_imp.g_varchar2_table(25718) := '726F706572746965733A7B736561726368537472696E673A7B747970653A22737472696E67227D2C7265706C616365537472696E673A7B747970653A22737472696E67227D2C697352656765783A7B747970653A22626F6F6C65616E227D2C6D61746368';
wwv_flow_imp.g_varchar2_table(25719) := '57686F6C65576F72643A7B747970653A22626F6F6C65616E227D2C69734361736553656E7369746976653A7B747970653A22626F6F6C65616E227D2C7072657365727665436173653A7B747970653A22626F6F6C65616E227D2C66696E64496E53656C65';
wwv_flow_imp.g_varchar2_table(25720) := '6374696F6E3A7B747970653A22626F6F6C65616E227D7D7D7D5D7D3B636C61737320473020657874656E64732055647B6173796E632072756E28652C74297B636F6E7374206E3D24302E6765742874293B6E262621746869732E5F72756E286E29262628';
wwv_flow_imp.g_varchar2_table(25721) := '6177616974206E2E7374617274287B666F72636552657665616C5265706C6163653A21312C73656564536561726368537472696E6746726F6D53656C656374696F6E3A303D3D3D6E2E676574537461746528292E736561726368537472696E672E6C656E';
wwv_flow_imp.g_varchar2_table(25722) := '6774682626226E6576657222213D3D742E6765744F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E3F2273696E676C65223A226E6F6E65222C73656564536561726368537472696E6746726F6D4E6F6E';
wwv_flow_imp.g_varchar2_table(25723) := '456D70747953656C656374696F6E3A2273656C656374696F6E223D3D3D742E6765744F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E2C73656564536561726368537472696E6746726F6D476C6F6261';
wwv_flow_imp.g_varchar2_table(25724) := '6C436C6970626F6172643A21302C73686F756C64466F6375733A302C73686F756C64416E696D6174653A21302C75706461746553656172636853636F70653A21312C6C6F6F703A742E6765744F7074696F6E283431292E6C6F6F707D292C746869732E5F';
wwv_flow_imp.g_varchar2_table(25725) := '72756E286E29297D7D636C61737320513020657874656E64732055647B6173796E632072756E28652C74297B636F6E7374206E3D24302E6765742874293B696628216E2972657475726E3B636F6E737420693D713028742C2273696E676C65222C213129';
wwv_flow_imp.g_varchar2_table(25726) := '3B6926266E2E736574536561726368537472696E672869292C746869732E5F72756E286E297C7C286177616974206E2E7374617274287B666F72636552657665616C5265706C6163653A21312C73656564536561726368537472696E6746726F6D53656C';
wwv_flow_imp.g_varchar2_table(25727) := '656374696F6E3A226E6F6E65222C73656564536561726368537472696E6746726F6D4E6F6E456D70747953656C656374696F6E3A21312C73656564536561726368537472696E6746726F6D476C6F62616C436C6970626F6172643A21312C73686F756C64';
wwv_flow_imp.g_varchar2_table(25728) := '466F6375733A302C73686F756C64416E696D6174653A21302C75706461746553656172636853636F70653A21312C6C6F6F703A742E6765744F7074696F6E283431292E6C6F6F707D292C746869732E5F72756E286E29297D7D5864286E6577204B64287B';
wwv_flow_imp.g_varchar2_table(25729) := '69643A22656469746F722E616374696F6E2E737461727446696E645265706C616365416374696F6E222C6C6162656C3A6228302C225265706C61636522292C616C6961733A225265706C616365222C707265636F6E646974696F6E3A57632E6F72286C68';
wwv_flow_imp.g_varchar2_table(25730) := '2E666F6375732C57632E6861732822656469746F7249734F70656E2229292C6B624F7074733A7B6B62457870723A6E756C6C2C7072696D6172793A323038362C6D61633A7B7072696D6172793A323539367D2C7765696768743A3130307D2C6D656E754F';
wwv_flow_imp.g_varchar2_table(25731) := '7074733A7B6D656E7549643A4C642E4D656E75626172456469744D656E752C67726F75703A22335F66696E64222C7469746C653A6228302C2226265265706C61636522292C6F726465723A327D7D29292E616464496D706C656D656E746174696F6E2830';
wwv_flow_imp.g_varchar2_table(25732) := '2C2828652C742C6E293D3E7B69662821742E6861734D6F64656C28297C7C742E6765744F7074696F6E283931292972657475726E21313B636F6E737420693D24302E6765742874293B69662821692972657475726E21313B636F6E7374206F3D742E6765';
wwv_flow_imp.g_varchar2_table(25733) := '7453656C656374696F6E28292C733D692E697346696E64496E707574466F637573656428292C723D216F2E6973456D707479282926266F2E73746172744C696E654E756D6265723D3D3D6F2E656E644C696E654E756D6265722626226E6576657222213D';
wwv_flow_imp.g_varchar2_table(25734) := '3D742E6765744F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E262621732C613D737C7C723F323A313B72657475726E20692E7374617274287B666F72636552657665616C5265706C6163653A21302C';
wwv_flow_imp.g_varchar2_table(25735) := '73656564536561726368537472696E6746726F6D53656C656374696F6E3A723F2273696E676C65223A226E6F6E65222C73656564536561726368537472696E6746726F6D4E6F6E456D70747953656C656374696F6E3A2273656C656374696F6E223D3D3D';
wwv_flow_imp.g_varchar2_table(25736) := '742E6765744F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E2C73656564536561726368537472696E6746726F6D476C6F62616C436C6970626F6172643A226E6576657222213D3D742E6765744F7074';
wwv_flow_imp.g_varchar2_table(25737) := '696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E2C73686F756C64466F6375733A612C73686F756C64416E696D6174653A21302C75706461746553656172636853636F70653A21312C6C6F6F703A742E676574';
wwv_flow_imp.g_varchar2_table(25738) := '4F7074696F6E283431292E6C6F6F707D297D29292C4A642824302E49442C55302C30292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E732E66696E64';
wwv_flow_imp.g_varchar2_table(25739) := '5769746841726773222C6C6162656C3A6228302C2246696E64205769746820417267756D656E747322292C616C6961733A2246696E64205769746820417267756D656E7473222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B';
wwv_flow_imp.g_varchar2_table(25740) := '62457870723A6E756C6C2C7072696D6172793A302C7765696768743A3130307D2C6D657461646174613A4B307D297D6173796E632072756E28652C742C6E297B636F6E737420693D24302E6765742874293B69662869297B636F6E737420653D6E3F7B73';
wwv_flow_imp.g_varchar2_table(25741) := '6561726368537472696E673A6E2E736561726368537472696E672C7265706C616365537472696E673A6E2E7265706C616365537472696E672C69735265706C61636552657665616C65643A766F69642030213D3D6E2E7265706C616365537472696E672C';
wwv_flow_imp.g_varchar2_table(25742) := '697352656765783A6E2E697352656765782C77686F6C65576F72643A6E2E6D6174636857686F6C65576F72642C6D61746368436173653A6E2E69734361736553656E7369746976652C7072657365727665436173653A6E2E707265736572766543617365';
wwv_flow_imp.g_varchar2_table(25743) := '7D3A7B7D3B617761697420692E7374617274287B666F72636552657665616C5265706C6163653A21312C73656564536561726368537472696E6746726F6D53656C656374696F6E3A303D3D3D692E676574537461746528292E736561726368537472696E';
wwv_flow_imp.g_varchar2_table(25744) := '672E6C656E6774682626226E6576657222213D3D742E6765744F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E3F2273696E676C65223A226E6F6E65222C73656564536561726368537472696E674672';
wwv_flow_imp.g_varchar2_table(25745) := '6F6D4E6F6E456D70747953656C656374696F6E3A2273656C656374696F6E223D3D3D742E6765744F7074696F6E283431292E73656564536561726368537472696E6746726F6D53656C656374696F6E2C73656564536561726368537472696E6746726F6D';
wwv_flow_imp.g_varchar2_table(25746) := '476C6F62616C436C6970626F6172643A21302C73686F756C64466F6375733A312C73686F756C64416E696D6174653A21302C75706461746553656172636853636F70653A286E756C6C3D3D6E3F766F696420303A6E2E66696E64496E53656C656374696F';
wwv_flow_imp.g_varchar2_table(25747) := '6E297C7C21312C6C6F6F703A742E6765744F7074696F6E283431292E6C6F6F707D2C65292C692E736574476C6F62616C4275666665725465726D28692E676574537461746528292E736561726368537472696E67297D7D7D292C5A6428636C6173732065';
wwv_flow_imp.g_varchar2_table(25748) := '7874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22616374696F6E732E66696E645769746853656C656374696F6E222C6C6162656C3A6228302C2246696E6420576974682053656C656374696F6E22292C616C696173';
wwv_flow_imp.g_varchar2_table(25749) := '3A2246696E6420576974682053656C656374696F6E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6E756C6C2C7072696D6172793A302C6D61633A7B7072696D6172793A323038337D2C7765696768743A31';
wwv_flow_imp.g_varchar2_table(25750) := '30307D7D297D6173796E632072756E28652C74297B636F6E7374206E3D24302E6765742874293B6E2626286177616974206E2E7374617274287B666F72636552657665616C5265706C6163653A21312C73656564536561726368537472696E6746726F6D';
wwv_flow_imp.g_varchar2_table(25751) := '53656C656374696F6E3A226D756C7469706C65222C73656564536561726368537472696E6746726F6D4E6F6E456D70747953656C656374696F6E3A21312C73656564536561726368537472696E6746726F6D476C6F62616C436C6970626F6172643A2131';
wwv_flow_imp.g_varchar2_table(25752) := '2C73686F756C64466F6375733A302C73686F756C64416E696D6174653A21302C75706461746553656172636853636F70653A21312C6C6F6F703A742E6765744F7074696F6E283431292E6C6F6F707D292C6E2E736574476C6F62616C4275666665725465';
wwv_flow_imp.g_varchar2_table(25753) := '726D286E2E676574537461746528292E736561726368537472696E6729297D7D292C5A6428636C61737320657874656E64732047307B636F6E7374727563746F7228297B7375706572287B69643A544A2C6C6162656C3A6228302C2246696E64204E6578';
wwv_flow_imp.g_varchar2_table(25754) := '7422292C616C6961733A2246696E64204E657874222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A5B7B6B62457870723A6C682E666F6375732C7072696D6172793A36312C6D61633A7B7072696D6172793A323038352C7365636F';
wwv_flow_imp.g_varchar2_table(25755) := '6E646172793A5B36315D7D2C7765696768743A3130307D2C7B6B62457870723A57632E616E64286C682E666F6375732C434A292C7072696D6172793A332C7765696768743A3130307D5D7D297D5F72756E2865297B72657475726E2121652E6D6F766554';
wwv_flow_imp.g_varchar2_table(25756) := '6F4E6578744D617463682829262628652E656469746F722E70757368556E646F53746F7028292C2130297D7D292C5A6428636C61737320657874656E64732047307B636F6E7374727563746F7228297B7375706572287B69643A494A2C6C6162656C3A62';
wwv_flow_imp.g_varchar2_table(25757) := '28302C2246696E642050726576696F757322292C616C6961733A2246696E642050726576696F7573222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A5B7B6B62457870723A6C682E666F6375732C7072696D6172793A313038352C';
wwv_flow_imp.g_varchar2_table(25758) := '6D61633A7B7072696D6172793A333130392C7365636F6E646172793A5B313038355D7D2C7765696768743A3130307D2C7B6B62457870723A57632E616E64286C682E666F6375732C434A292C7072696D6172793A313032372C7765696768743A3130307D';
wwv_flow_imp.g_varchar2_table(25759) := '5D7D297D5F72756E2865297B72657475726E20652E6D6F7665546F507265764D6174636828297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E';
wwv_flow_imp.g_varchar2_table(25760) := '2E676F546F4D6174636846696E64416374696F6E222C6C6162656C3A6228302C22476F20746F204D617463682E2E2E22292C616C6961733A22476F20746F204D617463682E2E2E222C707265636F6E646974696F6E3A774A7D292C746869732E5F686967';
wwv_flow_imp.g_varchar2_table(25761) := '686C696768744465636F726174696F6E733D5B5D7D72756E28652C742C6E297B636F6E737420693D24302E6765742874293B69662821692972657475726E3B636F6E7374206F3D692E676574537461746528292E6D617463686573436F756E743B696628';
wwv_flow_imp.g_varchar2_table(25762) := '6F3C312972657475726E20766F696420652E676574287344292E6E6F74696679287B73657665726974793A6F442E5761726E696E672C6D6573736167653A6228302C224E6F206D6174636865732E2054727920736561726368696E6720666F7220736F6D';
wwv_flow_imp.g_varchar2_table(25763) := '657468696E6720656C73652E22297D293B636F6E737420733D652E676574284C45292E637265617465496E707574426F7828293B732E706C616365686F6C6465723D6228302C22547970652061206E756D62657220746F20676F20746F20612073706563';
wwv_flow_imp.g_varchar2_table(25764) := '69666963206D6174636820286265747765656E203120616E64207B307D29222C6F293B636F6E737420723D653D3E7B636F6E737420743D7061727365496E742865293B69662869734E614E2874292972657475726E3B636F6E7374206E3D692E67657453';
wwv_flow_imp.g_varchar2_table(25765) := '7461746528292E6D617463686573436F756E743B72657475726E20743E302626743C3D6E3F742D313A743C302626743E3D2D6E3F6E2B743A766F696420307D2C613D653D3E7B636F6E7374206E3D722865293B696628226E756D626572223D3D74797065';
wwv_flow_imp.g_varchar2_table(25766) := '6F66206E297B732E76616C69646174696F6E4D6573736167653D766F696420302C692E676F546F4D61746368286E293B636F6E737420653D692E676574537461746528292E63757272656E744D617463683B652626746869732E6164644465636F726174';
wwv_flow_imp.g_varchar2_table(25767) := '696F6E7328742C65297D656C736520732E76616C69646174696F6E4D6573736167653D6228302C22506C6561736520747970652061206E756D626572206265747765656E203120616E64207B307D222C692E676574537461746528292E6D617463686573';
wwv_flow_imp.g_varchar2_table(25768) := '436F756E74292C746869732E636C6561724465636F726174696F6E732874297D3B732E6F6E4469644368616E676556616C75652828653D3E7B612865297D29292C732E6F6E446964416363657074282828293D3E7B636F6E737420653D7228732E76616C';
wwv_flow_imp.g_varchar2_table(25769) := '7565293B226E756D626572223D3D747970656F6620653F28692E676F546F4D617463682865292C732E686964652829293A732E76616C69646174696F6E4D6573736167653D6228302C22506C6561736520747970652061206E756D626572206265747765';
wwv_flow_imp.g_varchar2_table(25770) := '656E203120616E64207B307D222C692E676574537461746528292E6D617463686573436F756E74297D29292C732E6F6E44696448696465282828293D3E7B746869732E636C6561724465636F726174696F6E732874292C732E646973706F736528297D29';
wwv_flow_imp.g_varchar2_table(25771) := '292C732E73686F7728297D636C6561724465636F726174696F6E732865297B652E6368616E67654465636F726174696F6E732828653D3E7B746869732E5F686967686C696768744465636F726174696F6E733D652E64656C74614465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(25772) := '7328746869732E5F686967686C696768744465636F726174696F6E732C5B5D297D29297D6164644465636F726174696F6E7328652C74297B652E6368616E67654465636F726174696F6E732828653D3E7B746869732E5F686967686C696768744465636F';
wwv_flow_imp.g_varchar2_table(25773) := '726174696F6E733D652E64656C74614465636F726174696F6E7328746869732E5F686967686C696768744465636F726174696F6E732C5B7B72616E67653A742C6F7074696F6E733A7B6465736372697074696F6E3A2266696E642D6D617463682D717569';
wwv_flow_imp.g_varchar2_table(25774) := '636B2D6163636573732D72616E67652D686967686C69676874222C636C6173734E616D653A2272616E6765486967686C69676874222C697357686F6C654C696E653A21307D7D2C7B72616E67653A742C6F7074696F6E733A7B6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(25775) := '3A2266696E642D6D617463682D717569636B2D6163636573732D72616E67652D686967686C696768742D6F76657276696577222C6F7665727669657752756C65723A7B636F6C6F723A4F6228765F292C706F736974696F6E3A53682E46756C6C7D7D7D5D';
wwv_flow_imp.g_varchar2_table(25776) := '297D29297D7D292C5A6428636C61737320657874656E64732051307B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6E65787453656C656374696F6E4D6174636846696E64416374696F6E222C6C6162';
wwv_flow_imp.g_varchar2_table(25777) := '656C3A6228302C2246696E64204E6578742053656C656374696F6E22292C616C6961733A2246696E64204E6578742053656C656374696F6E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375';
wwv_flow_imp.g_varchar2_table(25778) := '732C7072696D6172793A323130392C7765696768743A3130307D7D297D5F72756E2865297B72657475726E20652E6D6F7665546F4E6578744D6174636828297D7D292C5A6428636C61737320657874656E64732051307B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(25779) := '7B7375706572287B69643A22656469746F722E616374696F6E2E70726576696F757353656C656374696F6E4D6174636846696E64416374696F6E222C6C6162656C3A6228302C2246696E642050726576696F75732053656C656374696F6E22292C616C69';
wwv_flow_imp.g_varchar2_table(25780) := '61733A2246696E642050726576696F75732053656C656374696F6E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A333133332C7765696768743A3130307D7D297D';
wwv_flow_imp.g_varchar2_table(25781) := '5F72756E2865297B72657475726E20652E6D6F7665546F507265764D6174636828297D7D293B636F6E73742059303D24642E62696E64546F436F6E747269627574696F6E2824302E676574293B5964286E6577205930287B69643A4D4A2C707265636F6E';
wwv_flow_imp.g_varchar2_table(25782) := '646974696F6E3A774A2C68616E646C65723A653D3E652E636C6F736546696E6457696467657428292C6B624F7074733A7B7765696768743A3130352C6B62457870723A57632E616E64286C682E666F6375732C57632E6E6F7428226973436F6D706F7369';
wwv_flow_imp.g_varchar2_table(25783) := '6E672229292C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D29292C5964286E6577205930287B69643A414A2C707265636F6E646974696F6E3A766F696420302C68616E646C65723A653D3E652E746F67676C654361736553656E';
wwv_flow_imp.g_varchar2_table(25784) := '73697469766528292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072696D6172793A784A2E7072696D6172792C6D61633A784A2E6D61632C77696E3A784A2E77696E2C6C696E75783A784A2E6C696E75787D';
wwv_flow_imp.g_varchar2_table(25785) := '7D29292C5964286E6577205930287B69643A4E4A2C707265636F6E646974696F6E3A766F696420302C68616E646C65723A653D3E652E746F67676C6557686F6C65576F72647328292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C';
wwv_flow_imp.g_varchar2_table(25786) := '682E666F6375732C7072696D6172793A6B4A2E7072696D6172792C6D61633A6B4A2E6D61632C77696E3A6B4A2E77696E2C6C696E75783A6B4A2E6C696E75787D7D29292C5964286E6577205930287B69643A504A2C707265636F6E646974696F6E3A766F';
wwv_flow_imp.g_varchar2_table(25787) := '696420302C68616E646C65723A653D3E652E746F67676C65526567657828292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072696D6172793A454A2E7072696D6172792C6D61633A454A2E6D61632C77696E';
wwv_flow_imp.g_varchar2_table(25788) := '3A454A2E77696E2C6C696E75783A454A2E6C696E75787D7D29292C5964286E6577205930287B69643A4F4A2C707265636F6E646974696F6E3A766F696420302C68616E646C65723A653D3E652E746F67676C6553656172636853636F706528292C6B624F';
wwv_flow_imp.g_varchar2_table(25789) := '7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072696D6172793A4C4A2E7072696D6172792C6D61633A4C4A2E6D61632C77696E3A4C4A2E77696E2C6C696E75783A4C4A2E6C696E75787D7D29292C5964286E65772059';
wwv_flow_imp.g_varchar2_table(25790) := '30287B69643A524A2C707265636F6E646974696F6E3A766F696420302C68616E646C65723A653D3E652E746F67676C6550726573657276654361736528292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072';
wwv_flow_imp.g_varchar2_table(25791) := '696D6172793A444A2E7072696D6172792C6D61633A444A2E6D61632C77696E3A444A2E77696E2C6C696E75783A444A2E6C696E75787D7D29292C5964286E6577205930287B69643A464A2C707265636F6E646974696F6E3A774A2C68616E646C65723A65';
wwv_flow_imp.g_varchar2_table(25792) := '3D3E652E7265706C61636528292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072696D6172793A333039347D7D29292C5964286E6577205930287B69643A464A2C707265636F6E646974696F6E3A774A2C68';
wwv_flow_imp.g_varchar2_table(25793) := '616E646C65723A653D3E652E7265706C61636528292C6B624F7074733A7B7765696768743A3130352C6B62457870723A57632E616E64286C682E666F6375732C534A292C7072696D6172793A337D7D29292C5964286E6577205930287B69643A424A2C70';
wwv_flow_imp.g_varchar2_table(25794) := '7265636F6E646974696F6E3A774A2C68616E646C65723A653D3E652E7265706C616365416C6C28292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072696D6172793A323536337D7D29292C5964286E657720';
wwv_flow_imp.g_varchar2_table(25795) := '5930287B69643A424A2C707265636F6E646974696F6E3A774A2C68616E646C65723A653D3E652E7265706C616365416C6C28292C6B624F7074733A7B7765696768743A3130352C6B62457870723A57632E616E64286C682E666F6375732C534A292C7072';
wwv_flow_imp.g_varchar2_table(25796) := '696D6172793A766F696420302C6D61633A7B7072696D6172793A323035317D7D7D29292C5964286E6577205930287B69643A22656469746F722E616374696F6E2E73656C656374416C6C4D617463686573222C707265636F6E646974696F6E3A774A2C68';
wwv_flow_imp.g_varchar2_table(25797) := '616E646C65723A653D3E652E73656C656374416C6C4D61746368657328292C6B624F7074733A7B7765696768743A3130352C6B62457870723A6C682E666F6375732C7072696D6172793A3531357D7D29293B766172205A303D6E2835343035292C58303D';
wwv_flow_imp.g_varchar2_table(25798) := '7B7D3B58302E7374796C655461675472616E73666F726D3D6A7228292C58302E736574417474726962757465733D567228292C58302E696E736572743D467228292E62696E64286E756C6C2C226865616422292C58302E646F6D4150493D4F7228292C58';
wwv_flow_imp.g_varchar2_table(25799) := '302E696E736572745374796C65456C656D656E743D487228292C4E722829285A302E412C5830292C5A302E4126265A302E412E6C6F63616C7326265A302E412E6C6F63616C733B636F6E7374204A303D7B303A2220222C313A2275222C323A2272227D2C';
wwv_flow_imp.g_varchar2_table(25800) := '65313D31363737373231352C74313D343237383139303038303B636C617373206E317B636F6E7374727563746F722865297B636F6E737420743D4D6174682E6365696C28652F3332293B746869732E5F7374617465733D6E65772055696E743332417272';
wwv_flow_imp.g_varchar2_table(25801) := '61792874297D6765742865297B636F6E737420743D652F33327C302C6E3D652533323B72657475726E212128746869732E5F7374617465735B745D26313C3C6E297D73657428652C74297B636F6E7374206E3D652F33327C302C693D652533322C6F3D74';
wwv_flow_imp.g_varchar2_table(25802) := '6869732E5F7374617465735B6E5D3B746869732E5F7374617465735B6E5D3D743F6F7C313C3C693A6F267E28313C3C69297D7D636C6173732069317B636F6E7374727563746F7228652C742C6E297B696628652E6C656E677468213D3D742E6C656E6774';
wwv_flow_imp.g_varchar2_table(25803) := '687C7C652E6C656E6774683E3635353335297468726F77206E6577204572726F722822696E76616C6964207374617274496E6465786573206F7220656E64496E64657865732073697A6522293B746869732E5F7374617274496E64657865733D652C7468';
wwv_flow_imp.g_varchar2_table(25804) := '69732E5F656E64496E64657865733D742C746869732E5F636F6C6C617073655374617465733D6E6577206E3128652E6C656E677468292C746869732E5F75736572446566696E65645374617465733D6E6577206E3128652E6C656E677468292C74686973';
wwv_flow_imp.g_varchar2_table(25805) := '2E5F7265636F76657265645374617465733D6E6577206E3128652E6C656E677468292C746869732E5F74797065733D6E2C746869732E5F706172656E7473436F6D70757465643D21317D656E73757265506172656E74496E646963657328297B69662821';
wwv_flow_imp.g_varchar2_table(25806) := '746869732E5F706172656E7473436F6D7075746564297B746869732E5F706172656E7473436F6D70757465643D21303B636F6E737420653D5B5D2C743D28742C6E293D3E7B636F6E737420693D655B652E6C656E6774682D315D3B72657475726E207468';
wwv_flow_imp.g_varchar2_table(25807) := '69732E67657453746172744C696E654E756D6265722869293C3D742626746869732E676574456E644C696E654E756D6265722869293E3D6E7D3B666F72286C6574206E3D302C693D746869732E5F7374617274496E64657865732E6C656E6774683B6E3C';
wwv_flow_imp.g_varchar2_table(25808) := '693B6E2B2B297B636F6E737420693D746869732E5F7374617274496E64657865735B6E5D2C6F3D746869732E5F656E64496E64657865735B6E5D3B696628693E65317C7C6F3E6531297468726F77206E6577204572726F72282273746172744C696E654E';
wwv_flow_imp.g_varchar2_table(25809) := '756D626572206F7220656E644C696E654E756D626572206D757374206E6F742065786365656420222B6531293B666F72283B652E6C656E6774683E302626217428692C6F293B29652E706F7028293B636F6E737420733D652E6C656E6774683E303F655B';
wwv_flow_imp.g_varchar2_table(25810) := '652E6C656E6774682D315D3A2D313B652E70757368286E292C746869732E5F7374617274496E64657865735B6E5D3D692B28283235352673293C3C3234292C746869732E5F656E64496E64657865735B6E5D3D6F2B282836353238302673293C3C313629';
wwv_flow_imp.g_varchar2_table(25811) := '7D7D7D676574206C656E67746828297B72657475726E20746869732E5F7374617274496E64657865732E6C656E6774687D67657453746172744C696E654E756D6265722865297B72657475726E20746869732E5F7374617274496E64657865735B655D26';
wwv_flow_imp.g_varchar2_table(25812) := '65317D676574456E644C696E654E756D6265722865297B72657475726E20746869732E5F656E64496E64657865735B655D2665317D676574547970652865297B72657475726E20746869732E5F74797065733F746869732E5F74797065735B655D3A766F';
wwv_flow_imp.g_varchar2_table(25813) := '696420307D686173547970657328297B72657475726E2121746869732E5F74797065737D6973436F6C6C61707365642865297B72657475726E20746869732E5F636F6C6C617073655374617465732E6765742865297D736574436F6C6C61707365642865';
wwv_flow_imp.g_varchar2_table(25814) := '2C74297B746869732E5F636F6C6C617073655374617465732E73657428652C74297D697355736572446566696E65642865297B72657475726E20746869732E5F75736572446566696E65645374617465732E6765742865297D7365745573657244656669';
wwv_flow_imp.g_varchar2_table(25815) := '6E656428652C74297B72657475726E20746869732E5F75736572446566696E65645374617465732E73657428652C74297D69735265636F76657265642865297B72657475726E20746869732E5F7265636F76657265645374617465732E6765742865297D';
wwv_flow_imp.g_varchar2_table(25816) := '7365745265636F766572656428652C74297B72657475726E20746869732E5F7265636F76657265645374617465732E73657428652C74297D676574536F757263652865297B72657475726E20746869732E697355736572446566696E65642865293F313A';
wwv_flow_imp.g_varchar2_table(25817) := '746869732E69735265636F76657265642865293F323A307D736574536F7572636528652C74297B313D3D3D743F28746869732E73657455736572446566696E656428652C2130292C746869732E7365745265636F766572656428652C213129293A323D3D';
wwv_flow_imp.g_varchar2_table(25818) := '3D743F28746869732E73657455736572446566696E656428652C2131292C746869732E7365745265636F766572656428652C213029293A28746869732E73657455736572446566696E656428652C2131292C746869732E7365745265636F766572656428';
wwv_flow_imp.g_varchar2_table(25819) := '652C213129297D736574436F6C6C6170736564416C6C4F665479706528652C74297B6C6574206E3D21313B696628746869732E5F747970657329666F72286C657420693D303B693C746869732E5F74797065732E6C656E6774683B692B2B29746869732E';
wwv_flow_imp.g_varchar2_table(25820) := '5F74797065735B695D3D3D3D65262628746869732E736574436F6C6C617073656428692C74292C6E3D2130293B72657475726E206E7D746F526567696F6E2865297B72657475726E206E6577206F3128746869732C65297D676574506172656E74496E64';
wwv_flow_imp.g_varchar2_table(25821) := '65782865297B746869732E656E73757265506172656E74496E646963657328293B636F6E737420743D2828746869732E5F7374617274496E64657865735B655D267431293E3E3E3234292B2828746869732E5F656E64496E64657865735B655D26743129';
wwv_flow_imp.g_varchar2_table(25822) := '3E3E3E3136293B72657475726E2036353533353D3D3D743F2D313A747D636F6E7461696E7328652C74297B72657475726E20746869732E67657453746172744C696E654E756D6265722865293C3D742626746869732E676574456E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(25823) := '65722865293E3D747D66696E64496E6465782865297B6C657420743D302C6E3D746869732E5F7374617274496E64657865732E6C656E6774683B696628303D3D3D6E2972657475726E2D313B666F72283B743C6E3B297B636F6E737420693D4D6174682E';
wwv_flow_imp.g_varchar2_table(25824) := '666C6F6F722828742B6E292F32293B653C746869732E67657453746172744C696E654E756D6265722869293F6E3D693A743D692B317D72657475726E20742D317D66696E6452616E67652865297B6C657420743D746869732E66696E64496E6465782865';
wwv_flow_imp.g_varchar2_table(25825) := '293B696628743E3D30297B696628746869732E676574456E644C696E654E756D6265722874293E3D652972657475726E20743B666F7228743D746869732E676574506172656E74496E6465782874293B2D31213D3D743B297B696628746869732E636F6E';
wwv_flow_imp.g_varchar2_table(25826) := '7461696E7328742C65292972657475726E20743B743D746869732E676574506172656E74496E6465782874297D7D72657475726E2D317D746F537472696E6728297B636F6E737420653D5B5D3B666F72286C657420743D303B743C746869732E6C656E67';
wwv_flow_imp.g_varchar2_table(25827) := '74683B742B2B29655B745D3D605B247B4A305B746869732E676574536F757263652874295D7D247B746869732E6973436F6C6C61707365642874293F222B223A222D227D5D20247B746869732E67657453746172744C696E654E756D6265722874297D2F';
wwv_flow_imp.g_varchar2_table(25828) := '247B746869732E676574456E644C696E654E756D6265722874297D603B72657475726E20652E6A6F696E28222C2022297D746F466F6C6452616E67652865297B72657475726E7B73746172744C696E654E756D6265723A746869732E5F7374617274496E';
wwv_flow_imp.g_varchar2_table(25829) := '64657865735B655D2665312C656E644C696E654E756D6265723A746869732E5F656E64496E64657865735B655D2665312C747970653A746869732E5F74797065733F746869732E5F74797065735B655D3A766F696420302C6973436F6C6C61707365643A';
wwv_flow_imp.g_varchar2_table(25830) := '746869732E6973436F6C6C61707365642865292C736F757263653A746869732E676574536F757263652865297D7D7374617469632066726F6D466F6C6452616E6765732865297B636F6E737420743D652E6C656E6774682C6E3D6E65772055696E743332';
wwv_flow_imp.g_varchar2_table(25831) := '41727261792874292C693D6E65772055696E74333241727261792874293B6C6574206F3D5B5D2C733D21313B666F72286C657420723D303B723C743B722B2B297B636F6E737420743D655B725D3B6E5B725D3D742E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(25832) := '2C695B725D3D742E656E644C696E654E756D6265722C6F2E7075736828742E74797065292C742E74797065262628733D2130297D737C7C286F3D766F69642030293B636F6E737420723D6E6577206931286E2C692C6F293B666F72286C6574206E3D303B';
wwv_flow_imp.g_varchar2_table(25833) := '6E3C743B6E2B2B29655B6E5D2E6973436F6C6C61707365642626722E736574436F6C6C6170736564286E2C2130292C722E736574536F75726365286E2C655B6E5D2E736F75726365293B72657475726E20727D7374617469632073616E6974697A65416E';
wwv_flow_imp.g_varchar2_table(25834) := '644D6572676528652C742C6E297B6E3D6E756C6C213D6E3F6E3A4E756D6265722E4D41585F56414C55453B636F6E737420693D28652C74293D3E41727261792E697341727261792865293F6E3D3E6E3C743F655B6E5D3A766F696420303A6E3D3E6E3C74';
wwv_flow_imp.g_varchar2_table(25835) := '3F652E746F466F6C6452616E6765286E293A766F696420302C6F3D6928652C652E6C656E677468292C733D6928742C742E6C656E677468293B6C657420723D302C613D302C6C3D6F2830292C633D732830293B636F6E737420643D5B5D3B6C657420682C';
wwv_flow_imp.g_varchar2_table(25836) := '753D303B636F6E737420703D5B5D3B666F72283B6C7C7C633B297B6C657420653B69662863262628216C7C7C6C2E73746172744C696E654E756D6265723E3D632E73746172744C696E654E756D62657229296C26266C2E73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(25837) := '65723D3D3D632E73746172744C696E654E756D6265723F28313D3D3D632E736F757263653F653D633A28653D6C2C652E6973436F6C6C61707365643D632E6973436F6C6C617073656426266C2E656E644C696E654E756D6265723D3D3D632E656E644C69';
wwv_flow_imp.g_varchar2_table(25838) := '6E654E756D6265722C652E736F757263653D30292C6C3D6F282B2B7229293A28653D632C632E6973436F6C6C61707365642626303D3D3D632E736F75726365262628652E736F757263653D3229292C633D73282B2B61293B656C73657B6C657420743D61';
wwv_flow_imp.g_varchar2_table(25839) := '2C6E3D633B666F72283B3B297B696628216E7C7C6E2E73746172744C696E654E756D6265723E6C2E656E644C696E654E756D626572297B653D6C3B627265616B7D696628313D3D3D6E2E736F7572636526266E2E656E644C696E654E756D6265723E6C2E';
wwv_flow_imp.g_varchar2_table(25840) := '656E644C696E654E756D62657229627265616B3B6E3D73282B2B74297D6C3D6F282B2B72297D69662865297B666F72283B682626682E656E644C696E654E756D6265723C652E73746172744C696E654E756D6265723B29683D642E706F7028293B652E65';
wwv_flow_imp.g_varchar2_table(25841) := '6E644C696E654E756D6265723E652E73746172744C696E654E756D6265722626652E73746172744C696E654E756D6265723E752626652E656E644C696E654E756D6265723C3D6E26262821687C7C682E656E644C696E654E756D6265723E3D652E656E64';
wwv_flow_imp.g_varchar2_table(25842) := '4C696E654E756D62657229262628702E707573682865292C753D652E73746172744C696E654E756D6265722C682626642E707573682868292C683D65297D7D72657475726E20707D7D636C617373206F317B636F6E7374727563746F7228652C74297B74';
wwv_flow_imp.g_varchar2_table(25843) := '6869732E72616E6765733D652C746869732E696E6465783D747D6765742073746172744C696E654E756D62657228297B72657475726E20746869732E72616E6765732E67657453746172744C696E654E756D62657228746869732E696E646578297D6765';
wwv_flow_imp.g_varchar2_table(25844) := '7420656E644C696E654E756D62657228297B72657475726E20746869732E72616E6765732E676574456E644C696E654E756D62657228746869732E696E646578297D67657420726567696F6E496E64657828297B72657475726E20746869732E696E6465';
wwv_flow_imp.g_varchar2_table(25845) := '787D67657420706172656E74496E64657828297B72657475726E20746869732E72616E6765732E676574506172656E74496E64657828746869732E696E646578297D676574206973436F6C6C617073656428297B72657475726E20746869732E72616E67';
wwv_flow_imp.g_varchar2_table(25846) := '65732E6973436F6C6C617073656428746869732E696E646578297D636F6E7461696E656442792865297B72657475726E20652E73746172744C696E654E756D6265723C3D746869732E73746172744C696E654E756D6265722626652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(25847) := '756D6265723E3D746869732E656E644C696E654E756D6265727D636F6E7461696E734C696E652865297B72657475726E20746869732E73746172744C696E654E756D6265723C3D652626653C3D746869732E656E644C696E654E756D6265727D7D636C61';
wwv_flow_imp.g_varchar2_table(25848) := '73732073317B67657420726567696F6E7328297B72657475726E20746869732E5F726567696F6E737D67657420746578744D6F64656C28297B72657475726E20746869732E5F746578744D6F64656C7D636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(25849) := '732E5F7570646174654576656E74456D69747465723D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F7570646174654576656E74456D69747465722E6576656E742C746869732E5F746578744D6F64656C3D652C746869732E';
wwv_flow_imp.g_varchar2_table(25850) := '5F6465636F726174696F6E50726F76696465723D742C746869732E5F726567696F6E733D6E6577206931286E65772055696E74333241727261792830292C6E65772055696E7433324172726179283029292C746869732E5F656469746F724465636F7261';
wwv_flow_imp.g_varchar2_table(25851) := '74696F6E4964733D5B5D7D746F67676C65436F6C6C6170736553746174652865297B69662821652E6C656E6774682972657475726E3B653D652E736F7274282828652C74293D3E652E726567696F6E496E6465782D742E726567696F6E496E6465782929';
wwv_flow_imp.g_varchar2_table(25852) := '3B636F6E737420743D7B7D3B746869732E5F6465636F726174696F6E50726F76696465722E6368616E67654465636F726174696F6E7328286E3D3E7B6C657420693D302C6F3D2D312C733D2D313B636F6E737420723D653D3E7B666F72283B693C653B29';
wwv_flow_imp.g_varchar2_table(25853) := '7B636F6E737420653D746869732E5F726567696F6E732E676574456E644C696E654E756D6265722869292C743D746869732E5F726567696F6E732E6973436F6C6C61707365642869293B696628653C3D6F297B636F6E7374206F3D30213D3D746869732E';
wwv_flow_imp.g_varchar2_table(25854) := '726567696F6E732E676574536F757263652869293B6E2E6368616E67654465636F726174696F6E4F7074696F6E7328746869732E5F656469746F724465636F726174696F6E4964735B695D2C746869732E5F6465636F726174696F6E50726F7669646572';
wwv_flow_imp.g_varchar2_table(25855) := '2E6765744465636F726174696F6E4F7074696F6E28742C653C3D732C6F29297D742626653E73262628733D65292C692B2B7D7D3B666F7228636F6E7374206E206F662065297B636F6E737420653D6E2E726567696F6E496E6465782C693D746869732E5F';
wwv_flow_imp.g_varchar2_table(25856) := '656469746F724465636F726174696F6E4964735B655D3B69662869262621745B695D297B745B695D3D21302C722865293B636F6E7374206E3D21746869732E5F726567696F6E732E6973436F6C6C61707365642865293B746869732E5F726567696F6E73';
wwv_flow_imp.g_varchar2_table(25857) := '2E736574436F6C6C617073656428652C6E292C6F3D4D6174682E6D6178286F2C746869732E5F726567696F6E732E676574456E644C696E654E756D626572286529297D7D7228746869732E5F726567696F6E732E6C656E677468297D29292C746869732E';
wwv_flow_imp.g_varchar2_table(25858) := '5F7570646174654576656E74456D69747465722E66697265287B6D6F64656C3A746869732C636F6C6C6170736553746174654368616E6765643A657D297D72656D6F76654D616E75616C52616E6765732865297B636F6E737420743D6E65772041727261';
wwv_flow_imp.g_varchar2_table(25859) := '792C6E3D743D3E7B666F7228636F6E7374206E206F6620652969662821286E2E73746172744C696E654E756D6265723E742E656E644C696E654E756D6265727C7C742E73746172744C696E654E756D6265723E6E2E656E644C696E654E756D6265722929';
wwv_flow_imp.g_varchar2_table(25860) := '72657475726E21303B72657475726E21317D3B666F72286C657420653D303B653C746869732E5F726567696F6E732E6C656E6774683B652B2B297B636F6E737420693D746869732E5F726567696F6E732E746F466F6C6452616E67652865293B30213D3D';
wwv_flow_imp.g_varchar2_table(25861) := '692E736F7572636526266E2869297C7C742E707573682869297D746869732E757064617465506F73742869312E66726F6D466F6C6452616E676573287429297D75706461746528652C743D5B5D297B636F6E7374206E3D746869732E5F63757272656E74';
wwv_flow_imp.g_varchar2_table(25862) := '466F6C6465644F724D616E75616C52616E6765732874292C693D69312E73616E6974697A65416E644D6572676528652C6E2C746869732E5F746578744D6F64656C2E6765744C696E65436F756E742829293B746869732E757064617465506F7374286931';
wwv_flow_imp.g_varchar2_table(25863) := '2E66726F6D466F6C6452616E676573286929297D757064617465506F73742865297B636F6E737420743D5B5D3B6C6574206E3D2D313B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D652E67657453';
wwv_flow_imp.g_varchar2_table(25864) := '746172744C696E654E756D6265722869292C733D652E676574456E644C696E654E756D6265722869292C723D652E6973436F6C6C61707365642869292C613D30213D3D652E676574536F757263652869292C6C3D7B73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(25865) := '3A6F2C7374617274436F6C756D6E3A746869732E5F746578744D6F64656C2E6765744C696E654D6178436F6C756D6E286F292C656E644C696E654E756D6265723A732C656E64436F6C756D6E3A746869732E5F746578744D6F64656C2E6765744C696E65';
wwv_flow_imp.g_varchar2_table(25866) := '4D6178436F6C756D6E2873292B317D3B742E70757368287B72616E67653A6C2C6F7074696F6E733A746869732E5F6465636F726174696F6E50726F76696465722E6765744465636F726174696F6E4F7074696F6E28722C733C3D6E2C61297D292C722626';
wwv_flow_imp.g_varchar2_table(25867) := '733E6E2626286E3D73297D746869732E5F6465636F726174696F6E50726F76696465722E6368616E67654465636F726174696F6E732828653D3E746869732E5F656469746F724465636F726174696F6E4964733D652E64656C74614465636F726174696F';
wwv_flow_imp.g_varchar2_table(25868) := '6E7328746869732E5F656469746F724465636F726174696F6E4964732C742929292C746869732E5F726567696F6E733D652C746869732E5F7570646174654576656E74456D69747465722E66697265287B6D6F64656C3A746869737D297D5F6375727265';
wwv_flow_imp.g_varchar2_table(25869) := '6E74466F6C6465644F724D616E75616C52616E67657328653D5B5D297B636F6E737420743D28742C6E293D3E7B666F7228636F6E73742069206F66206529696628743C692626693C3D6E2972657475726E21303B72657475726E21317D2C6E3D5B5D3B66';
wwv_flow_imp.g_varchar2_table(25870) := '6F72286C657420653D302C693D746869732E5F726567696F6E732E6C656E6774683B653C693B652B2B297B6C657420693D746869732E726567696F6E732E6973436F6C6C61707365642865293B636F6E7374206F3D746869732E726567696F6E732E6765';
wwv_flow_imp.g_varchar2_table(25871) := '74536F757263652865293B696628697C7C30213D3D6F297B636F6E737420733D746869732E5F726567696F6E732E746F466F6C6452616E67652865292C723D746869732E5F746578744D6F64656C2E6765744465636F726174696F6E52616E6765287468';
wwv_flow_imp.g_varchar2_table(25872) := '69732E5F656469746F724465636F726174696F6E4964735B655D293B722626286926267428722E73746172744C696E654E756D6265722C722E656E644C696E654E756D62657229262628693D2131292C6E2E70757368287B73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(25873) := '6265723A722E73746172744C696E654E756D6265722C656E644C696E654E756D6265723A722E656E644C696E654E756D6265722C747970653A732E747970652C6973436F6C6C61707365643A692C736F757263653A6F7D29297D7D72657475726E206E7D';
wwv_flow_imp.g_varchar2_table(25874) := '6765744D656D656E746F28297B636F6E737420653D746869732E5F63757272656E74466F6C6465644F724D616E75616C52616E67657328292C743D5B5D2C6E3D746869732E5F746578744D6F64656C2E6765744C696E65436F756E7428293B666F72286C';
wwv_flow_imp.g_varchar2_table(25875) := '657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D655B695D3B6966286F2E73746172744C696E654E756D6265723E3D6F2E656E644C696E654E756D6265727C7C6F2E73746172744C696E654E756D6265723C317C7C';
wwv_flow_imp.g_varchar2_table(25876) := '6F2E656E644C696E654E756D6265723E6E29636F6E74696E75653B636F6E737420733D746869732E5F6765744C696E6573436865636B73756D286F2E73746172744C696E654E756D6265722B312C6F2E656E644C696E654E756D626572293B742E707573';
wwv_flow_imp.g_varchar2_table(25877) := '68287B73746172744C696E654E756D6265723A6F2E73746172744C696E654E756D6265722C656E644C696E654E756D6265723A6F2E656E644C696E654E756D6265722C6973436F6C6C61707365643A6F2E6973436F6C6C61707365642C736F757263653A';
wwv_flow_imp.g_varchar2_table(25878) := '6F2E736F757263652C636865636B73756D3A737D297D72657475726E20742E6C656E6774683E303F743A766F696420307D6170706C794D656D656E746F2865297B76617220742C6E3B6966282141727261792E697341727261792865292972657475726E';
wwv_flow_imp.g_varchar2_table(25879) := '3B636F6E737420693D5B5D2C6F3D746869732E5F746578744D6F64656C2E6765744C696E65436F756E7428293B666F7228636F6E73742073206F662065297B696628732E73746172744C696E654E756D6265723E3D732E656E644C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(25880) := '7C7C732E73746172744C696E654E756D6265723C317C7C732E656E644C696E654E756D6265723E6F29636F6E74696E75653B636F6E737420653D746869732E5F6765744C696E6573436865636B73756D28732E73746172744C696E654E756D6265722B31';
wwv_flow_imp.g_varchar2_table(25881) := '2C732E656E644C696E654E756D626572293B732E636865636B73756D262665213D3D732E636865636B73756D7C7C692E70757368287B73746172744C696E654E756D6265723A732E73746172744C696E654E756D6265722C656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(25882) := '723A732E656E644C696E654E756D6265722C747970653A766F696420302C6973436F6C6C61707365643A6E756C6C3D3D3D28743D732E6973436F6C6C6170736564297C7C766F696420303D3D3D747C7C742C736F757263653A6E756C6C213D3D286E3D73';
wwv_flow_imp.g_varchar2_table(25883) := '2E736F75726365292626766F69642030213D3D6E3F6E3A307D297D636F6E737420733D69312E73616E6974697A65416E644D6572676528746869732E5F726567696F6E732C692C6F293B746869732E757064617465506F73742869312E66726F6D466F6C';
wwv_flow_imp.g_varchar2_table(25884) := '6452616E676573287329297D5F6765744C696E6573436865636B73756D28652C74297B72657475726E205A6F28746869732E5F746578744D6F64656C2E6765744C696E65436F6E74656E742865292B746869732E5F746578744D6F64656C2E6765744C69';
wwv_flow_imp.g_varchar2_table(25885) := '6E65436F6E74656E7428742929253165367D646973706F736528297B746869732E5F6465636F726174696F6E50726F76696465722E72656D6F76654465636F726174696F6E7328746869732E5F656469746F724465636F726174696F6E496473297D6765';
wwv_flow_imp.g_varchar2_table(25886) := '74416C6C526567696F6E7341744C696E6528652C74297B636F6E7374206E3D5B5D3B696628746869732E5F726567696F6E73297B6C657420693D746869732E5F726567696F6E732E66696E6452616E67652865292C6F3D313B666F72283B693E3D303B29';
wwv_flow_imp.g_varchar2_table(25887) := '7B636F6E737420653D746869732E5F726567696F6E732E746F526567696F6E2869293B742626217428652C6F297C7C6E2E707573682865292C6F2B2B2C693D652E706172656E74496E6465787D7D72657475726E206E7D676574526567696F6E41744C69';
wwv_flow_imp.g_varchar2_table(25888) := '6E652865297B696628746869732E5F726567696F6E73297B636F6E737420743D746869732E5F726567696F6E732E66696E6452616E67652865293B696628743E3D302972657475726E20746869732E5F726567696F6E732E746F526567696F6E2874297D';
wwv_flow_imp.g_varchar2_table(25889) := '72657475726E206E756C6C7D676574526567696F6E73496E7369646528652C74297B636F6E7374206E3D5B5D2C693D653F652E726567696F6E496E6465782B313A302C6F3D653F652E656E644C696E654E756D6265723A4E756D6265722E4D41585F5641';
wwv_flow_imp.g_varchar2_table(25890) := '4C55453B696628742626323D3D3D742E6C656E677468297B636F6E737420653D5B5D3B666F72286C657420733D692C723D746869732E5F726567696F6E732E6C656E6774683B733C723B732B2B297B636F6E737420693D746869732E5F726567696F6E73';
wwv_flow_imp.g_varchar2_table(25891) := '2E746F526567696F6E2873293B6966282128746869732E5F726567696F6E732E67657453746172744C696E654E756D6265722873293C6F2929627265616B3B666F72283B652E6C656E6774683E30262621692E636F6E7461696E6564427928655B652E6C';
wwv_flow_imp.g_varchar2_table(25892) := '656E6774682D315D293B29652E706F7028293B652E707573682869292C7428692C652E6C656E6774682926266E2E707573682869297D7D656C736520666F72286C657420653D692C733D746869732E5F726567696F6E732E6C656E6774683B653C733B65';
wwv_flow_imp.g_varchar2_table(25893) := '2B2B297B636F6E737420693D746869732E5F726567696F6E732E746F526567696F6E2865293B6966282128746869732E5F726567696F6E732E67657453746172744C696E654E756D6265722865293C6F2929627265616B3B74262621742869297C7C6E2E';
wwv_flow_imp.g_varchar2_table(25894) := '707573682869297D72657475726E206E7D7D66756E6374696F6E20723128652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E7374206F206F66206E297B636F6E7374206E3D652E676574526567696F6E41744C696E65286F293B6966286E29';
wwv_flow_imp.g_varchar2_table(25895) := '7B636F6E7374206F3D216E2E6973436F6C6C61707365643B696628692E70757368286E292C743E31297B636F6E737420733D652E676574526567696F6E73496E73696465286E2C2828652C6E293D3E652E6973436F6C6C6170736564213D3D6F26266E3C';
wwv_flow_imp.g_varchar2_table(25896) := '7429293B692E70757368282E2E2E73297D7D7D652E746F67676C65436F6C6C6170736553746174652869297D66756E6374696F6E20613128652C742C6E3D4E756D6265722E4D41585F56414C55452C69297B636F6E7374206F3D5B5D3B69662869262669';
wwv_flow_imp.g_varchar2_table(25897) := '2E6C656E6774683E3029666F7228636F6E73742073206F662069297B636F6E737420693D652E676574526567696F6E41744C696E652873293B69662869262628692E6973436F6C6C6170736564213D3D7426266F2E707573682869292C6E3E3129297B63';
wwv_flow_imp.g_varchar2_table(25898) := '6F6E737420733D652E676574526567696F6E73496E7369646528692C2828652C69293D3E652E6973436F6C6C6170736564213D3D742626693C6E29293B6F2E70757368282E2E2E73297D7D656C73657B636F6E737420693D652E676574526567696F6E73';
wwv_flow_imp.g_varchar2_table(25899) := '496E73696465286E756C6C2C2828652C69293D3E652E6973436F6C6C6170736564213D3D742626693C6E29293B6F2E70757368282E2E2E69297D652E746F67676C65436F6C6C617073655374617465286F297D66756E6374696F6E206C3128652C742C6E';
wwv_flow_imp.g_varchar2_table(25900) := '2C69297B636F6E7374206F3D5B5D3B666F7228636F6E73742073206F662069297B636F6E737420693D652E676574416C6C526567696F6E7341744C696E6528732C2828652C69293D3E652E6973436F6C6C6170736564213D3D742626693C3D6E29293B6F';
wwv_flow_imp.g_varchar2_table(25901) := '2E70757368282E2E2E69297D652E746F67676C65436F6C6C617073655374617465286F297D66756E6374696F6E20633128652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E73742074206F66206E297B636F6E7374206E3D652E676574416C';
wwv_flow_imp.g_varchar2_table(25902) := '6C526567696F6E7341744C696E6528742C766F69642030293B6E2E6C656E6774683E302626692E70757368286E5B305D297D636F6E7374206F3D652E676574526567696F6E73496E73696465286E756C6C2C28653D3E692E65766572792828743D3E2174';
wwv_flow_imp.g_varchar2_table(25903) := '2E636F6E7461696E65644279286529262621652E636F6E7461696E6564427928742929292626652E6973436F6C6C6170736564213D3D7429293B652E746F67676C65436F6C6C617073655374617465286F297D66756E6374696F6E20643128652C742C6E';
wwv_flow_imp.g_varchar2_table(25904) := '297B636F6E737420693D652E746578744D6F64656C2C6F3D652E726567696F6E732C733D5B5D3B666F72286C657420653D6F2E6C656E6774682D313B653E3D303B652D2D296966286E213D3D6F2E6973436F6C6C6170736564286529297B636F6E737420';
wwv_flow_imp.g_varchar2_table(25905) := '6E3D6F2E67657453746172744C696E654E756D6265722865293B742E7465737428692E6765744C696E65436F6E74656E74286E29292626732E70757368286F2E746F526567696F6E286529297D652E746F67676C65436F6C6C6170736553746174652873';
wwv_flow_imp.g_varchar2_table(25906) := '297D66756E6374696F6E20683128652C742C6E297B636F6E737420693D652E726567696F6E732C6F3D5B5D3B666F72286C657420653D692E6C656E6774682D313B653E3D303B652D2D296E213D3D692E6973436F6C6C61707365642865292626743D3D3D';
wwv_flow_imp.g_varchar2_table(25907) := '692E6765745479706528652926266F2E7075736828692E746F526567696F6E286529293B652E746F67676C65436F6C6C617073655374617465286F297D636C6173732075317B676574206F6E4469644368616E676528297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(25908) := '5F7570646174654576656E74456D69747465722E6576656E747D6765742068696464656E52616E67657328297B72657475726E20746869732E5F68696464656E52616E6765737D636F6E7374727563746F722865297B746869732E5F7570646174654576';
wwv_flow_imp.g_varchar2_table(25909) := '656E74456D69747465723D6E65772043742C746869732E5F6861734C696E654368616E6765733D21312C746869732E5F666F6C64696E674D6F64656C3D652C746869732E5F666F6C64696E674D6F64656C4C697374656E65723D652E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(25910) := '6E67652828653D3E746869732E75706461746548696464656E52616E676573282929292C746869732E5F68696464656E52616E6765733D5B5D2C652E726567696F6E732E6C656E6774682626746869732E75706461746548696464656E52616E67657328';
wwv_flow_imp.g_varchar2_table(25911) := '297D6E6F746966794368616E67654D6F64656C436F6E74656E742865297B746869732E5F68696464656E52616E6765732E6C656E677468262621746869732E5F6861734C696E654368616E676573262628746869732E5F6861734C696E654368616E6765';
wwv_flow_imp.g_varchar2_table(25912) := '733D652E6368616E6765732E736F6D652828653D3E652E72616E67652E656E644C696E654E756D626572213D3D652E72616E67652E73746172744C696E654E756D6265727C7C30213D3D757528652E74657874295B305D2929297D757064617465486964';
wwv_flow_imp.g_varchar2_table(25913) := '64656E52616E67657328297B6C657420653D21313B636F6E737420743D5B5D3B6C6574206E3D302C693D302C6F3D4E756D6265722E4D41585F56414C55452C733D2D313B636F6E737420723D746869732E5F666F6C64696E674D6F64656C2E726567696F';
wwv_flow_imp.g_varchar2_table(25914) := '6E733B666F72283B6E3C722E6C656E6774683B6E2B2B297B69662821722E6973436F6C6C6170736564286E2929636F6E74696E75653B636F6E737420613D722E67657453746172744C696E654E756D626572286E292B312C6C3D722E676574456E644C69';
wwv_flow_imp.g_varchar2_table(25915) := '6E654E756D626572286E293B6F3C3D6126266C3C3D737C7C2821652626693C746869732E5F68696464656E52616E6765732E6C656E6774682626746869732E5F68696464656E52616E6765735B695D2E73746172744C696E654E756D6265723D3D3D6126';
wwv_flow_imp.g_varchar2_table(25916) := '26746869732E5F68696464656E52616E6765735B695D2E656E644C696E654E756D6265723D3D3D6C3F28742E7075736828746869732E5F68696464656E52616E6765735B695D292C692B2B293A28653D21302C742E70757368286E657720726828612C31';
wwv_flow_imp.g_varchar2_table(25917) := '2C6C2C312929292C6F3D612C733D6C297D28746869732E5F6861734C696E654368616E6765737C7C657C7C693C746869732E5F68696464656E52616E6765732E6C656E677468292626746869732E6170706C7948696464656E52616E6765732874297D61';
wwv_flow_imp.g_varchar2_table(25918) := '70706C7948696464656E52616E6765732865297B746869732E5F68696464656E52616E6765733D652C746869732E5F6861734C696E654368616E6765733D21312C746869732E5F7570646174654576656E74456D69747465722E666972652865297D6861';
wwv_flow_imp.g_varchar2_table(25919) := '7352616E67657328297B72657475726E20746869732E5F68696464656E52616E6765732E6C656E6774683E307D697348696464656E2865297B72657475726E206E756C6C213D3D703128746869732E5F68696464656E52616E6765732C65297D61646A75';
wwv_flow_imp.g_varchar2_table(25920) := '737453656C656374696F6E732865297B6C657420743D21313B636F6E7374206E3D746869732E5F666F6C64696E674D6F64656C2E746578744D6F64656C3B6C657420693D6E756C6C3B636F6E7374206F3D653D3E2869262666756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(25921) := '297B72657475726E20653E3D742E73746172744C696E654E756D6265722626653C3D742E656E644C696E654E756D6265727D28652C69297C7C28693D703128746869732E5F68696464656E52616E6765732C6529292C693F692E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(25922) := '756D6265722D313A6E756C6C293B666F72286C657420693D302C733D652E6C656E6774683B693C733B692B2B297B6C657420733D655B695D3B636F6E737420723D6F28732E73746172744C696E654E756D626572293B72262628733D732E736574537461';
wwv_flow_imp.g_varchar2_table(25923) := '7274506F736974696F6E28722C6E2E6765744C696E654D6178436F6C756D6E287229292C743D2130293B636F6E737420613D6F28732E656E644C696E654E756D626572293B61262628733D732E736574456E64506F736974696F6E28612C6E2E6765744C';
wwv_flow_imp.g_varchar2_table(25924) := '696E654D6178436F6C756D6E286129292C743D2130292C655B695D3D737D72657475726E20747D646973706F736528297B746869732E68696464656E52616E6765732E6C656E6774683E30262628746869732E5F68696464656E52616E6765733D5B5D2C';
wwv_flow_imp.g_varchar2_table(25925) := '746869732E5F7570646174654576656E74456D69747465722E6669726528746869732E5F68696464656E52616E67657329292C746869732E5F666F6C64696E674D6F64656C4C697374656E6572262628746869732E5F666F6C64696E674D6F64656C4C69';
wwv_flow_imp.g_varchar2_table(25926) := '7374656E65722E646973706F736528292C746869732E5F666F6C64696E674D6F64656C4C697374656E65723D6E756C6C297D7D66756E6374696F6E20703128652C74297B636F6E7374206E3D797528652C28653D3E743C652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(25927) := '6D62657229292D313B72657475726E206E3E3D302626655B6E5D2E656E644C696E654E756D6265723E3D743F655B6E5D3A6E756C6C7D636C6173732067317B636F6E7374727563746F7228652C742C6E297B746869732E656469746F724D6F64656C3D65';
wwv_flow_imp.g_varchar2_table(25928) := '2C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E666F6C64696E6752616E6765734C696D69743D6E2C746869732E69643D22696E64656E74227D646973706F736528297B7D636F6D707574652865';
wwv_flow_imp.g_varchar2_table(25929) := '297B636F6E737420743D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28746869732E656469746F724D6F64656C2E6765744C616E6775616765496428';
wwv_flow_imp.g_varchar2_table(25930) := '29292E666F6C64696E6752756C65732C6E3D7426262121742E6F6666536964652C693D742626742E6D61726B6572733B72657475726E2050726F6D6973652E7265736F6C76652866756E6374696F6E28652C742C6E2C693D6631297B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(25931) := '652E6765744F7074696F6E7328292E74616253697A652C733D6E6577206D312869293B6C657420723B6E262628723D6E657720526567457870286028247B6E2E73746172742E736F757263657D297C283F3A247B6E2E656E642E736F757263657D296029';
wwv_flow_imp.g_varchar2_table(25932) := '293B636F6E737420613D5B5D2C6C3D652E6765744C696E65436F756E7428292B313B612E70757368287B696E64656E743A2D312C656E6441626F76653A6C2C6C696E653A6C7D293B666F72286C6574206E3D652E6765744C696E65436F756E7428293B6E';
wwv_flow_imp.g_varchar2_table(25933) := '3E303B6E2D2D297B636F6E737420693D652E6765744C696E65436F6E74656E74286E292C6C3D4A5F28692C6F293B6C657420632C643D615B612E6C656E6774682D315D3B6966282D31213D3D6C297B69662872262628633D692E6D617463682872292929';
wwv_flow_imp.g_varchar2_table(25934) := '7B69662821635B315D297B612E70757368287B696E64656E743A2D322C656E6441626F76653A6E2C6C696E653A6E7D293B636F6E74696E75657D7B6C657420653D612E6C656E6774682D313B666F72283B653E3026262D32213D3D615B655D2E696E6465';
wwv_flow_imp.g_varchar2_table(25935) := '6E743B29652D2D3B696628653E30297B612E6C656E6774683D652B312C643D615B655D2C732E696E736572744669727374286E2C642E6C696E652C6C292C642E6C696E653D6E2C642E696E64656E743D6C2C642E656E6441626F76653D6E3B636F6E7469';
wwv_flow_imp.g_varchar2_table(25936) := '6E75657D7D7D696628642E696E64656E743E6C297B646F7B612E706F7028292C643D615B612E6C656E6774682D315D7D7768696C6528642E696E64656E743E6C293B636F6E737420653D642E656E6441626F76652D313B652D6E3E3D312626732E696E73';
wwv_flow_imp.g_varchar2_table(25937) := '6572744669727374286E2C652C6C297D642E696E64656E743D3D3D6C3F642E656E6441626F76653D6E3A612E70757368287B696E64656E743A6C2C656E6441626F76653A6E2C6C696E653A6E7D297D656C73652074262628642E656E6441626F76653D6E';
wwv_flow_imp.g_varchar2_table(25938) := '297D72657475726E20732E746F496E64656E7452616E6765732865297D28746869732E656469746F724D6F64656C2C6E2C692C746869732E666F6C64696E6752616E6765734C696D697429297D7D636C617373206D317B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(25939) := '297B746869732E5F7374617274496E64657865733D5B5D2C746869732E5F656E64496E64657865733D5B5D2C746869732E5F696E64656E744F6363757272656E6365733D5B5D2C746869732E5F6C656E6774683D302C746869732E5F666F6C64696E6752';
wwv_flow_imp.g_varchar2_table(25940) := '616E6765734C696D69743D657D696E73657274466972737428652C742C6E297B696628653E65317C7C743E65312972657475726E3B636F6E737420693D746869732E5F6C656E6774683B746869732E5F7374617274496E64657865735B695D3D652C7468';
wwv_flow_imp.g_varchar2_table(25941) := '69732E5F656E64496E64657865735B695D3D742C746869732E5F6C656E6774682B2B2C6E3C316533262628746869732E5F696E64656E744F6363757272656E6365735B6E5D3D28746869732E5F696E64656E744F6363757272656E6365735B6E5D7C7C30';
wwv_flow_imp.g_varchar2_table(25942) := '292B31297D746F496E64656E7452616E6765732865297B636F6E737420743D746869732E5F666F6C64696E6752616E6765734C696D69742E6C696D69743B696628746869732E5F6C656E6774683C3D74297B746869732E5F666F6C64696E6752616E6765';
wwv_flow_imp.g_varchar2_table(25943) := '734C696D69742E75706461746528746869732E5F6C656E6774682C2131293B636F6E737420653D6E65772055696E743332417272617928746869732E5F6C656E677468292C743D6E65772055696E743332417272617928746869732E5F6C656E67746829';
wwv_flow_imp.g_varchar2_table(25944) := '3B666F72286C6574206E3D746869732E5F6C656E6774682D312C693D303B6E3E3D303B6E2D2D2C692B2B29655B695D3D746869732E5F7374617274496E64657865735B6E5D2C745B695D3D746869732E5F656E64496E64657865735B6E5D3B7265747572';
wwv_flow_imp.g_varchar2_table(25945) := '6E206E657720693128652C74297D7B746869732E5F666F6C64696E6752616E6765734C696D69742E75706461746528746869732E5F6C656E6774682C74293B6C6574206E3D302C693D746869732E5F696E64656E744F6363757272656E6365732E6C656E';
wwv_flow_imp.g_varchar2_table(25946) := '6774683B666F72286C657420653D303B653C746869732E5F696E64656E744F6363757272656E6365732E6C656E6774683B652B2B297B636F6E7374206F3D746869732E5F696E64656E744F6363757272656E6365735B655D3B6966286F297B6966286F2B';
wwv_flow_imp.g_varchar2_table(25947) := '6E3E74297B693D653B627265616B7D6E2B3D6F7D7D636F6E7374206F3D652E6765744F7074696F6E7328292E74616253697A652C733D6E65772055696E74333241727261792874292C723D6E65772055696E74333241727261792874293B666F72286C65';
wwv_flow_imp.g_varchar2_table(25948) := '7420613D746869732E5F6C656E6774682D312C6C3D303B613E3D303B612D2D297B636F6E737420633D746869732E5F7374617274496E64657865735B615D2C643D4A5F28652E6765744C696E65436F6E74656E742863292C6F293B28643C697C7C643D3D';
wwv_flow_imp.g_varchar2_table(25949) := '3D6926266E2B2B3C7429262628735B6C5D3D632C725B6C5D3D746869732E5F656E64496E64657865735B615D2C6C2B2B297D72657475726E206E657720693128732C72297D7D7D636F6E73742066313D7B6C696D69743A3565332C7570646174653A2829';
wwv_flow_imp.g_varchar2_table(25950) := '3D3E7B7D7D2C76313D4C6D2822656469746F722E666F6C644261636B67726F756E64222C7B6C696768743A496D2868662C2E33292C6461726B3A496D2868662C2E33292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C2242';
wwv_flow_imp.g_varchar2_table(25951) := '61636B67726F756E6420636F6C6F7220626568696E6420666F6C6465642072616E6765732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F';
wwv_flow_imp.g_varchar2_table(25952) := '726174696F6E732E22292C2130293B4C6D2822656469746F724775747465722E666F6C64696E67436F6E74726F6C466F726567726F756E64222C7B6461726B3A426D2C6C696768743A426D2C68634461726B3A426D2C68634C696768743A426D7D2C6228';
wwv_flow_imp.g_varchar2_table(25953) := '302C22436F6C6F72206F662074686520666F6C64696E6720636F6E74726F6C20696E2074686520656469746F72206775747465722E2229293B636F6E73742062313D54572822666F6C64696E672D657870616E646564222C4C6C2E63686576726F6E446F';
wwv_flow_imp.g_varchar2_table(25954) := '776E2C6228302C2249636F6E20666F7220657870616E6465642072616E67657320696E2074686520656469746F7220676C797068206D617267696E2E2229292C5F313D54572822666F6C64696E672D636F6C6C6170736564222C4C6C2E63686576726F6E';
wwv_flow_imp.g_varchar2_table(25955) := '52696768742C6228302C2249636F6E20666F7220636F6C6C61707365642072616E67657320696E2074686520656469746F7220676C797068206D617267696E2E2229292C79313D54572822666F6C64696E672D6D616E75616C2D636F6C6C617073656422';
wwv_flow_imp.g_varchar2_table(25956) := '2C5F312C6228302C2249636F6E20666F72206D616E75616C6C7920636F6C6C61707365642072616E67657320696E2074686520656469746F7220676C797068206D617267696E2E2229292C77313D54572822666F6C64696E672D6D616E75616C2D657870';
wwv_flow_imp.g_varchar2_table(25957) := '616E646564222C62312C6228302C2249636F6E20666F72206D616E75616C6C7920657870616E6465642072616E67657320696E2074686520656469746F7220676C797068206D617267696E2E2229292C43313D7B636F6C6F723A4F62287631292C706F73';
wwv_flow_imp.g_varchar2_table(25958) := '6974696F6E3A317D2C53313D6228302C22436C69636B20746F20657870616E64207468652072616E67652E22292C78313D6228302C22436C69636B20746F20636F6C6C61707365207468652072616E67652E22293B636C617373206B317B636F6E737472';
wwv_flow_imp.g_varchar2_table(25959) := '7563746F722865297B746869732E656469746F723D652C746869732E73686F77466F6C64696E67436F6E74726F6C733D226D6F7573656F766572222C746869732E73686F77466F6C64696E67486967686C69676874733D21307D6765744465636F726174';
wwv_flow_imp.g_varchar2_table(25960) := '696F6E4F7074696F6E28652C742C6E297B72657475726E20743F6B312E48494444454E5F52414E47455F4445434F524154494F4E3A226E65766572223D3D3D746869732E73686F77466F6C64696E67436F6E74726F6C733F653F746869732E73686F7746';
wwv_flow_imp.g_varchar2_table(25961) := '6F6C64696E67486967686C69676874733F6B312E4E4F5F434F4E54524F4C535F434F4C4C41505345445F484947484C4947485445445F52414E47455F4445434F524154494F4E3A6B312E4E4F5F434F4E54524F4C535F434F4C4C41505345445F52414E47';
wwv_flow_imp.g_varchar2_table(25962) := '455F4445434F524154494F4E3A6B312E4E4F5F434F4E54524F4C535F455850414E4445445F52414E47455F4445434F524154494F4E3A653F6E3F746869732E73686F77466F6C64696E67486967686C69676874733F6B312E4D414E55414C4C595F434F4C';
wwv_flow_imp.g_varchar2_table(25963) := '4C41505345445F484947484C4947485445445F56495355414C5F4445434F524154494F4E3A6B312E4D414E55414C4C595F434F4C4C41505345445F56495355414C5F4445434F524154494F4E3A746869732E73686F77466F6C64696E67486967686C6967';
wwv_flow_imp.g_varchar2_table(25964) := '6874733F6B312E434F4C4C41505345445F484947484C4947485445445F56495355414C5F4445434F524154494F4E3A6B312E434F4C4C41505345445F56495355414C5F4445434F524154494F4E3A226D6F7573656F766572223D3D3D746869732E73686F';
wwv_flow_imp.g_varchar2_table(25965) := '77466F6C64696E67436F6E74726F6C733F6E3F6B312E4D414E55414C4C595F455850414E4445445F4155544F5F484944455F56495355414C5F4445434F524154494F4E3A6B312E455850414E4445445F4155544F5F484944455F56495355414C5F444543';
wwv_flow_imp.g_varchar2_table(25966) := '4F524154494F4E3A6E3F6B312E4D414E55414C4C595F455850414E4445445F56495355414C5F4445434F524154494F4E3A6B312E455850414E4445445F56495355414C5F4445434F524154494F4E7D6368616E67654465636F726174696F6E732865297B';
wwv_flow_imp.g_varchar2_table(25967) := '72657475726E20746869732E656469746F722E6368616E67654465636F726174696F6E732865297D72656D6F76654465636F726174696F6E732865297B746869732E656469746F722E72656D6F76654465636F726174696F6E732865297D7D6B312E434F';
wwv_flow_imp.g_varchar2_table(25968) := '4C4C41505345445F56495355414C5F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D636F6C6C61707365642D76697375616C2D6465636F726174696F6E222C737469636B696E6573733A';
wwv_flow_imp.g_varchar2_table(25969) := '302C6166746572436F6E74656E74436C6173734E616D653A22696E6C696E652D666F6C646564222C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73546F6F6C7469703A53312C66697273744C696E654465636F726174696F';
wwv_flow_imp.g_varchar2_table(25970) := '6E436C6173734E616D653A546C2E6173436C6173734E616D65285F31297D292C6B312E434F4C4C41505345445F484947484C4947485445445F56495355414C5F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(25971) := '22666F6C64696E672D636F6C6C61707365642D686967686C6967687465642D76697375616C2D6465636F726174696F6E222C737469636B696E6573733A302C6166746572436F6E74656E74436C6173734E616D653A22696E6C696E652D666F6C64656422';
wwv_flow_imp.g_varchar2_table(25972) := '2C636C6173734E616D653A22666F6C6465642D6261636B67726F756E64222C6D696E696D61703A43312C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73546F6F6C7469703A53312C66697273744C696E654465636F726174';
wwv_flow_imp.g_varchar2_table(25973) := '696F6E436C6173734E616D653A546C2E6173436C6173734E616D65285F31297D292C6B312E4D414E55414C4C595F434F4C4C41505345445F56495355414C5F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22';
wwv_flow_imp.g_varchar2_table(25974) := '666F6C64696E672D6D616E75616C6C792D636F6C6C61707365642D76697375616C2D6465636F726174696F6E222C737469636B696E6573733A302C6166746572436F6E74656E74436C6173734E616D653A22696E6C696E652D666F6C646564222C697357';
wwv_flow_imp.g_varchar2_table(25975) := '686F6C654C696E653A21302C6C696E65734465636F726174696F6E73546F6F6C7469703A53312C66697273744C696E654465636F726174696F6E436C6173734E616D653A546C2E6173436C6173734E616D65287931297D292C6B312E4D414E55414C4C59';
wwv_flow_imp.g_varchar2_table(25976) := '5F434F4C4C41505345445F484947484C4947485445445F56495355414C5F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D6D616E75616C6C792D636F6C6C61707365642D686967686C69';
wwv_flow_imp.g_varchar2_table(25977) := '67687465642D76697375616C2D6465636F726174696F6E222C737469636B696E6573733A302C6166746572436F6E74656E74436C6173734E616D653A22696E6C696E652D666F6C646564222C636C6173734E616D653A22666F6C6465642D6261636B6772';
wwv_flow_imp.g_varchar2_table(25978) := '6F756E64222C6D696E696D61703A43312C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73546F6F6C7469703A53312C66697273744C696E654465636F726174696F6E436C6173734E616D653A546C2E6173436C6173734E61';
wwv_flow_imp.g_varchar2_table(25979) := '6D65287931297D292C6B312E4E4F5F434F4E54524F4C535F434F4C4C41505345445F52414E47455F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D6E6F2D636F6E74726F6C732D72616E';
wwv_flow_imp.g_varchar2_table(25980) := '67652D6465636F726174696F6E222C737469636B696E6573733A302C6166746572436F6E74656E74436C6173734E616D653A22696E6C696E652D666F6C646564222C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73546F6F';
wwv_flow_imp.g_varchar2_table(25981) := '6C7469703A53317D292C6B312E4E4F5F434F4E54524F4C535F434F4C4C41505345445F484947484C4947485445445F52414E47455F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D6E6F';
wwv_flow_imp.g_varchar2_table(25982) := '2D636F6E74726F6C732D72616E67652D6465636F726174696F6E222C737469636B696E6573733A302C6166746572436F6E74656E74436C6173734E616D653A22696E6C696E652D666F6C646564222C636C6173734E616D653A22666F6C6465642D626163';
wwv_flow_imp.g_varchar2_table(25983) := '6B67726F756E64222C6D696E696D61703A43312C697357686F6C654C696E653A21302C6C696E65734465636F726174696F6E73546F6F6C7469703A53317D292C6B312E455850414E4445445F56495355414C5F4445434F524154494F4E3D4F432E726567';
wwv_flow_imp.g_varchar2_table(25984) := '6973746572287B6465736372697074696F6E3A22666F6C64696E672D657870616E6465642D76697375616C2D6465636F726174696F6E222C737469636B696E6573733A312C697357686F6C654C696E653A21302C66697273744C696E654465636F726174';
wwv_flow_imp.g_varchar2_table(25985) := '696F6E436C6173734E616D653A22616C7761797353686F77466F6C6449636F6E7320222B546C2E6173436C6173734E616D65286231292C6C696E65734465636F726174696F6E73546F6F6C7469703A78317D292C6B312E455850414E4445445F4155544F';
wwv_flow_imp.g_varchar2_table(25986) := '5F484944455F56495355414C5F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D657870616E6465642D6175746F2D686964652D76697375616C2D6465636F726174696F6E222C73746963';
wwv_flow_imp.g_varchar2_table(25987) := '6B696E6573733A312C697357686F6C654C696E653A21302C66697273744C696E654465636F726174696F6E436C6173734E616D653A546C2E6173436C6173734E616D65286231292C6C696E65734465636F726174696F6E73546F6F6C7469703A78317D29';
wwv_flow_imp.g_varchar2_table(25988) := '2C6B312E4D414E55414C4C595F455850414E4445445F56495355414C5F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D6D616E75616C6C792D657870616E6465642D76697375616C2D64';
wwv_flow_imp.g_varchar2_table(25989) := '65636F726174696F6E222C737469636B696E6573733A302C697357686F6C654C696E653A21302C66697273744C696E654465636F726174696F6E436C6173734E616D653A22616C7761797353686F77466F6C6449636F6E7320222B546C2E6173436C6173';
wwv_flow_imp.g_varchar2_table(25990) := '734E616D65287731292C6C696E65734465636F726174696F6E73546F6F6C7469703A78317D292C6B312E4D414E55414C4C595F455850414E4445445F4155544F5F484944455F56495355414C5F4445434F524154494F4E3D4F432E726567697374657228';
wwv_flow_imp.g_varchar2_table(25991) := '7B6465736372697074696F6E3A22666F6C64696E672D6D616E75616C6C792D657870616E6465642D6175746F2D686964652D76697375616C2D6465636F726174696F6E222C737469636B696E6573733A302C697357686F6C654C696E653A21302C666972';
wwv_flow_imp.g_varchar2_table(25992) := '73744C696E654465636F726174696F6E436C6173734E616D653A546C2E6173436C6173734E616D65287731292C6C696E65734465636F726174696F6E73546F6F6C7469703A78317D292C6B312E4E4F5F434F4E54524F4C535F455850414E4445445F5241';
wwv_flow_imp.g_varchar2_table(25993) := '4E47455F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D6E6F2D636F6E74726F6C732D72616E67652D6465636F726174696F6E222C737469636B696E6573733A302C697357686F6C654C';
wwv_flow_imp.g_varchar2_table(25994) := '696E653A21307D292C6B312E48494444454E5F52414E47455F4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22666F6C64696E672D68696464656E2D72616E67652D6465636F726174696F6E222C737469636B';
wwv_flow_imp.g_varchar2_table(25995) := '696E6573733A317D293B636F6E73742045313D7B7D3B636C617373204C317B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E656469746F724D6F64656C3D652C746869732E70726F7669646572733D742C746869732E68616E646C';
wwv_flow_imp.g_varchar2_table(25996) := '65466F6C64696E6752616E6765734368616E67653D6E2C746869732E666F6C64696E6752616E6765734C696D69743D692C746869732E66616C6C6261636B52616E676550726F76696465723D6F2C746869732E69643D2273796E746178222C746869732E';
wwv_flow_imp.g_varchar2_table(25997) := '646973706F7361626C65733D6E65772061742C6F2626746869732E646973706F7361626C65732E616464286F293B666F7228636F6E73742065206F662074292266756E6374696F6E223D3D747970656F6620652E6F6E4469644368616E67652626746869';
wwv_flow_imp.g_varchar2_table(25998) := '732E646973706F7361626C65732E61646428652E6F6E4469644368616E6765286E29297D636F6D707574652865297B72657475726E2066756E6374696F6E28652C742C6E297B6C657420693D6E756C6C3B636F6E7374206F3D652E6D6170282828652C6F';
wwv_flow_imp.g_varchar2_table(25999) := '293D3E50726F6D6973652E7265736F6C766528652E70726F76696465466F6C64696E6752616E67657328742C45312C6E29292E7468656E2828653D3E7B696628216E2E697343616E63656C6C6174696F6E526571756573746564262641727261792E6973';
wwv_flow_imp.g_varchar2_table(26000) := '4172726179286529297B41727261792E697341727261792869297C7C28693D5B5D293B636F6E7374206E3D742E6765744C696E65436F756E7428293B666F7228636F6E73742074206F66206529742E73746172743E302626742E656E643E742E73746172';
wwv_flow_imp.g_varchar2_table(26001) := '742626742E656E643C3D6E2626692E70757368287B73746172743A742E73746172742C656E643A742E656E642C72616E6B3A6F2C6B696E643A742E6B696E647D297D7D292C45652929293B72657475726E2050726F6D6973652E616C6C286F292E746865';
wwv_flow_imp.g_varchar2_table(26002) := '6E2828653D3E6929297D28746869732E70726F7669646572732C746869732E656469746F724D6F64656C2C65292E7468656E2828743D3E7B766172206E2C693B72657475726E20743F66756E6374696F6E28652C74297B636F6E7374206E3D652E736F72';
wwv_flow_imp.g_varchar2_table(26003) := '74282828652C74293D3E7B6C6574206E3D652E73746172742D742E73746172743B72657475726E20303D3D3D6E2626286E3D652E72616E6B2D742E72616E6B292C6E7D29292C693D6E65772044312874293B6C6574206F3B636F6E737420733D5B5D3B66';
wwv_flow_imp.g_varchar2_table(26004) := '6F7228636F6E73742065206F66206E296966286F297B696628652E73746172743E6F2E737461727429696628652E656E643C3D6F2E656E6429732E70757368286F292C6F3D652C692E61646428652E73746172742C652E656E642C652E6B696E64262665';
wwv_flow_imp.g_varchar2_table(26005) := '2E6B696E642E76616C75652C732E6C656E677468293B656C73657B696628652E73746172743E6F2E656E64297B646F7B6F3D732E706F7028297D7768696C65286F2626652E73746172743E6F2E656E64293B6F2626732E70757368286F292C6F3D657D69';
wwv_flow_imp.g_varchar2_table(26006) := '2E61646428652E73746172742C652E656E642C652E6B696E642626652E6B696E642E76616C75652C732E6C656E677468297D7D656C7365206F3D652C692E61646428652E73746172742C652E656E642C652E6B696E642626652E6B696E642E76616C7565';
wwv_flow_imp.g_varchar2_table(26007) := '2C732E6C656E677468293B72657475726E20692E746F496E64656E7452616E67657328297D28742C746869732E666F6C64696E6752616E6765734C696D6974293A6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E66616C6C6261636B5261';
wwv_flow_imp.g_varchar2_table(26008) := '6E676550726F7669646572297C7C766F696420303D3D3D6E3F766F696420303A6E2E636F6D70757465286529292626766F69642030213D3D693F693A6E756C6C7D29297D646973706F736528297B746869732E646973706F7361626C65732E646973706F';
wwv_flow_imp.g_varchar2_table(26009) := '736528297D7D636C6173732044317B636F6E7374727563746F722865297B746869732E5F7374617274496E64657865733D5B5D2C746869732E5F656E64496E64657865733D5B5D2C746869732E5F6E657374696E674C6576656C733D5B5D2C746869732E';
wwv_flow_imp.g_varchar2_table(26010) := '5F6E657374696E674C6576656C436F756E74733D5B5D2C746869732E5F74797065733D5B5D2C746869732E5F6C656E6774683D302C746869732E5F666F6C64696E6752616E6765734C696D69743D657D61646428652C742C6E2C69297B696628653E6531';
wwv_flow_imp.g_varchar2_table(26011) := '7C7C743E65312972657475726E3B636F6E7374206F3D746869732E5F6C656E6774683B746869732E5F7374617274496E64657865735B6F5D3D652C746869732E5F656E64496E64657865735B6F5D3D742C746869732E5F6E657374696E674C6576656C73';
wwv_flow_imp.g_varchar2_table(26012) := '5B6F5D3D692C746869732E5F74797065735B6F5D3D6E2C746869732E5F6C656E6774682B2B2C693C3330262628746869732E5F6E657374696E674C6576656C436F756E74735B695D3D28746869732E5F6E657374696E674C6576656C436F756E74735B69';
wwv_flow_imp.g_varchar2_table(26013) := '5D7C7C30292B31297D746F496E64656E7452616E67657328297B636F6E737420653D746869732E5F666F6C64696E6752616E6765734C696D69742E6C696D69743B696628746869732E5F6C656E6774683C3D65297B746869732E5F666F6C64696E675261';
wwv_flow_imp.g_varchar2_table(26014) := '6E6765734C696D69742E75706461746528746869732E5F6C656E6774682C2131293B636F6E737420653D6E65772055696E743332417272617928746869732E5F6C656E677468292C743D6E65772055696E743332417272617928746869732E5F6C656E67';
wwv_flow_imp.g_varchar2_table(26015) := '7468293B666F72286C6574206E3D303B6E3C746869732E5F6C656E6774683B6E2B2B29655B6E5D3D746869732E5F7374617274496E64657865735B6E5D2C745B6E5D3D746869732E5F656E64496E64657865735B6E5D3B72657475726E206E6577206931';
wwv_flow_imp.g_varchar2_table(26016) := '28652C742C746869732E5F7479706573297D7B746869732E5F666F6C64696E6752616E6765734C696D69742E75706461746528746869732E5F6C656E6774682C65293B6C657420743D302C6E3D746869732E5F6E657374696E674C6576656C436F756E74';
wwv_flow_imp.g_varchar2_table(26017) := '732E6C656E6774683B666F72286C657420693D303B693C746869732E5F6E657374696E674C6576656C436F756E74732E6C656E6774683B692B2B297B636F6E7374206F3D746869732E5F6E657374696E674C6576656C436F756E74735B695D3B6966286F';
wwv_flow_imp.g_varchar2_table(26018) := '297B6966286F2B743E65297B6E3D693B627265616B7D742B3D6F7D7D636F6E737420693D6E65772055696E74333241727261792865292C6F3D6E65772055696E74333241727261792865292C733D5B5D3B666F72286C657420723D302C613D303B723C74';
wwv_flow_imp.g_varchar2_table(26019) := '6869732E5F6C656E6774683B722B2B297B636F6E7374206C3D746869732E5F6E657374696E674C6576656C735B725D3B286C3C6E7C7C6C3D3D3D6E2626742B2B3C6529262628695B615D3D746869732E5F7374617274496E64657865735B725D2C6F5B61';
wwv_flow_imp.g_varchar2_table(26020) := '5D3D746869732E5F656E64496E64657865735B725D2C735B615D3D746869732E5F74797065735B725D2C612B2B297D72657475726E206E657720693128692C6F2C73297D7D7D7661722054312C49313D66756E6374696F6E28652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(26021) := '2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374204D313D6E6577206C642822666F6C64696E67456E61626C6564222C2131293B6C65742041313D54313D636C61737320657874656E6473206C747B73746174696320676574';
wwv_flow_imp.g_varchar2_table(26022) := '2865297B72657475726E20652E676574436F6E747269627574696F6E2854312E4944297D73746174696320676574466F6C64696E6752616E676550726F76696465727328652C74297B766172206E2C693B636F6E7374206F3D652E666F6C64696E675261';
wwv_flow_imp.g_varchar2_table(26023) := '6E676550726F76696465722E6F7264657265642874293B72657475726E206E756C6C213D3D28693D6E756C6C3D3D3D286E3D54312E5F666F6C64696E6752616E676553656C6563746F72297C7C766F696420303D3D3D6E3F766F696420303A6E2E63616C';
wwv_flow_imp.g_varchar2_table(26024) := '6C2854312C6F2C7429292626766F69642030213D3D693F693A6F7D636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E636F6E746578744B6579536572766963653D742C746869732E6C616E6775616765436F';
wwv_flow_imp.g_varchar2_table(26025) := '6E66696775726174696F6E536572766963653D6E2C746869732E6C616E67756167654665617475726573536572766963653D732C746869732E6C6F63616C546F446973706F73653D746869732E5F7265676973746572286E6577206174292C746869732E';
wwv_flow_imp.g_varchar2_table(26026) := '656469746F723D652C746869732E5F666F6C64696E674C696D69745265706F727465723D6E6577204E312865293B636F6E737420723D746869732E656469746F722E6765744F7074696F6E7328293B746869732E5F6973456E61626C65643D722E676574';
wwv_flow_imp.g_varchar2_table(26027) := '283433292C746869732E5F757365466F6C64696E6750726F7669646572733D22696E64656E746174696F6E22213D3D722E676574283434292C746869732E5F756E666F6C644F6E436C69636B4166746572456E644F664C696E653D722E67657428343829';
wwv_flow_imp.g_varchar2_table(26028) := '2C746869732E5F726573746F72696E675669657753746174653D21312C746869732E5F63757272656E744D6F64656C486173466F6C646564496D706F7274733D21312C746869732E5F666F6C64696E67496D706F727473427944656661756C743D722E67';
wwv_flow_imp.g_varchar2_table(26029) := '6574283436292C746869732E7570646174654465626F756E6365496E666F3D6F2E666F7228732E666F6C64696E6752616E676550726F76696465722C22466F6C64696E67222C7B6D696E3A3230307D292C746869732E666F6C64696E674D6F64656C3D6E';
wwv_flow_imp.g_varchar2_table(26030) := '756C6C2C746869732E68696464656E52616E67654D6F64656C3D6E756C6C2C746869732E72616E676550726F76696465723D6E756C6C2C746869732E666F6C64696E67526567696F6E50726F6D6973653D6E756C6C2C746869732E666F6C64696E674D6F';
wwv_flow_imp.g_varchar2_table(26031) := '64656C50726F6D6973653D6E756C6C2C746869732E7570646174655363686564756C65723D6E756C6C2C746869732E637572736F724368616E6765645363686564756C65723D6E756C6C2C746869732E6D6F757365446F776E496E666F3D6E756C6C2C74';
wwv_flow_imp.g_varchar2_table(26032) := '6869732E666F6C64696E674465636F726174696F6E50726F76696465723D6E6577206B312865292C746869732E666F6C64696E674465636F726174696F6E50726F76696465722E73686F77466F6C64696E67436F6E74726F6C733D722E67657428313130';
wwv_flow_imp.g_varchar2_table(26033) := '292C746869732E666F6C64696E674465636F726174696F6E50726F76696465722E73686F77466F6C64696E67486967686C69676874733D722E676574283435292C746869732E666F6C64696E67456E61626C65643D4D312E62696E64546F28746869732E';
wwv_flow_imp.g_varchar2_table(26034) := '636F6E746578744B657953657276696365292C746869732E666F6C64696E67456E61626C65642E73657428746869732E5F6973456E61626C6564292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E67654D6F';
wwv_flow_imp.g_varchar2_table(26035) := '64656C282828293D3E746869732E6F6E4D6F64656C4368616E67656428292929292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B696628652E68617343';
wwv_flow_imp.g_varchar2_table(26036) := '68616E67656428343329262628746869732E5F6973456E61626C65643D746869732E656469746F722E6765744F7074696F6E7328292E676574283433292C746869732E666F6C64696E67456E61626C65642E73657428746869732E5F6973456E61626C65';
wwv_flow_imp.g_varchar2_table(26037) := '64292C746869732E6F6E4D6F64656C4368616E6765642829292C652E6861734368616E676564283437292626746869732E6F6E4D6F64656C4368616E67656428292C652E6861734368616E67656428313130297C7C652E6861734368616E676564283435';
wwv_flow_imp.g_varchar2_table(26038) := '29297B636F6E737420653D746869732E656469746F722E6765744F7074696F6E7328293B746869732E666F6C64696E674465636F726174696F6E50726F76696465722E73686F77466F6C64696E67436F6E74726F6C733D652E67657428313130292C7468';
wwv_flow_imp.g_varchar2_table(26039) := '69732E666F6C64696E674465636F726174696F6E50726F76696465722E73686F77466F6C64696E67486967686C69676874733D652E676574283435292C746869732E74726967676572466F6C64696E674D6F64656C4368616E67656428297D652E686173';
wwv_flow_imp.g_varchar2_table(26040) := '4368616E67656428343429262628746869732E5F757365466F6C64696E6750726F7669646572733D22696E64656E746174696F6E22213D3D746869732E656469746F722E6765744F7074696F6E7328292E676574283434292C746869732E6F6E466F6C64';
wwv_flow_imp.g_varchar2_table(26041) := '696E6753747261746567794368616E6765642829292C652E6861734368616E67656428343829262628746869732E5F756E666F6C644F6E436C69636B4166746572456E644F664C696E653D746869732E656469746F722E6765744F7074696F6E7328292E';
wwv_flow_imp.g_varchar2_table(26042) := '67657428343829292C652E6861734368616E67656428343629262628746869732E5F666F6C64696E67496D706F727473427944656661756C743D746869732E656469746F722E6765744F7074696F6E7328292E67657428343629297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(26043) := '2E6F6E4D6F64656C4368616E67656428297D7361766556696577537461746528297B636F6E737420653D746869732E656469746F722E6765744D6F64656C28293B69662821657C7C21746869732E5F6973456E61626C65647C7C652E6973546F6F4C6172';
wwv_flow_imp.g_varchar2_table(26044) := '6765466F72546F6B656E697A6174696F6E28292972657475726E7B7D3B696628746869732E666F6C64696E674D6F64656C297B636F6E737420743D746869732E666F6C64696E674D6F64656C2E6765744D656D656E746F28292C6E3D746869732E72616E';
wwv_flow_imp.g_varchar2_table(26045) := '676550726F76696465723F746869732E72616E676550726F76696465722E69643A766F696420303B72657475726E7B636F6C6C6170736564526567696F6E733A742C6C696E65436F756E743A652E6765744C696E65436F756E7428292C70726F76696465';
wwv_flow_imp.g_varchar2_table(26046) := '723A6E2C666F6C646564496D706F7274733A746869732E5F63757272656E744D6F64656C486173466F6C646564496D706F7274737D7D7D726573746F72655669657753746174652865297B636F6E737420743D746869732E656469746F722E6765744D6F';
wwv_flow_imp.g_varchar2_table(26047) := '64656C28293B696628742626746869732E5F6973456E61626C6564262621742E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28292626746869732E68696464656E52616E67654D6F64656C262665262628746869732E5F63757272656E';
wwv_flow_imp.g_varchar2_table(26048) := '744D6F64656C486173466F6C646564496D706F7274733D2121652E666F6C646564496D706F7274732C652E636F6C6C6170736564526567696F6E732626652E636F6C6C6170736564526567696F6E732E6C656E6774683E302626746869732E666F6C6469';
wwv_flow_imp.g_varchar2_table(26049) := '6E674D6F64656C29297B746869732E5F726573746F72696E675669657753746174653D21303B7472797B746869732E666F6C64696E674D6F64656C2E6170706C794D656D656E746F28652E636F6C6C6170736564526567696F6E73297D66696E616C6C79';
wwv_flow_imp.g_varchar2_table(26050) := '7B746869732E5F726573746F72696E675669657753746174653D21317D7D7D6F6E4D6F64656C4368616E67656428297B746869732E6C6F63616C546F446973706F73652E636C65617228293B636F6E737420653D746869732E656469746F722E6765744D';
wwv_flow_imp.g_varchar2_table(26051) := '6F64656C28293B746869732E5F6973456E61626C6564262665262621652E6973546F6F4C61726765466F72546F6B656E697A6174696F6E2829262628746869732E5F63757272656E744D6F64656C486173466F6C646564496D706F7274733D21312C7468';
wwv_flow_imp.g_varchar2_table(26052) := '69732E666F6C64696E674D6F64656C3D6E657720733128652C746869732E666F6C64696E674465636F726174696F6E50726F7669646572292C746869732E6C6F63616C546F446973706F73652E61646428746869732E666F6C64696E674D6F64656C292C';
wwv_flow_imp.g_varchar2_table(26053) := '746869732E68696464656E52616E67654D6F64656C3D6E657720753128746869732E666F6C64696E674D6F64656C292C746869732E6C6F63616C546F446973706F73652E61646428746869732E68696464656E52616E67654D6F64656C292C746869732E';
wwv_flow_imp.g_varchar2_table(26054) := '6C6F63616C546F446973706F73652E61646428746869732E68696464656E52616E67654D6F64656C2E6F6E4469644368616E67652828653D3E746869732E6F6E48696464656E52616E6765734368616E6765732865292929292C746869732E7570646174';
wwv_flow_imp.g_varchar2_table(26055) := '655363686564756C65723D6E6577207A7428746869732E7570646174654465626F756E6365496E666F2E676574286529292C746869732E637572736F724368616E6765645363686564756C65723D6E6577204B74282828293D3E746869732E7265766561';
wwv_flow_imp.g_varchar2_table(26056) := '6C437572736F722829292C323030292C746869732E6C6F63616C546F446973706F73652E61646428746869732E637572736F724368616E6765645363686564756C6572292C746869732E6C6F63616C546F446973706F73652E61646428746869732E6C61';
wwv_flow_imp.g_varchar2_table(26057) := '6E67756167654665617475726573536572766963652E666F6C64696E6752616E676550726F76696465722E6F6E4469644368616E6765282828293D3E746869732E6F6E466F6C64696E6753747261746567794368616E67656428292929292C746869732E';
wwv_flow_imp.g_varchar2_table(26058) := '6C6F63616C546F446973706F73652E61646428746869732E656469746F722E6F6E4469644368616E67654D6F64656C4C616E6775616765436F6E66696775726174696F6E282828293D3E746869732E6F6E466F6C64696E6753747261746567794368616E';
wwv_flow_imp.g_varchar2_table(26059) := '67656428292929292C746869732E6C6F63616C546F446973706F73652E61646428746869732E656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E746869732E6F6E4469644368616E67654D6F64656C436F6E74656E';
wwv_flow_imp.g_varchar2_table(26060) := '742865292929292C746869732E6C6F63616C546F446973706F73652E61646428746869732E656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E746869732E6F6E437572736F72506F736974696F6E4368616E';
wwv_flow_imp.g_varchar2_table(26061) := '67656428292929292C746869732E6C6F63616C546F446973706F73652E61646428746869732E656469746F722E6F6E4D6F757365446F776E2828653D3E746869732E6F6E456469746F724D6F757365446F776E2865292929292C746869732E6C6F63616C';
wwv_flow_imp.g_varchar2_table(26062) := '546F446973706F73652E61646428746869732E656469746F722E6F6E4D6F75736555702828653D3E746869732E6F6E456469746F724D6F75736555702865292929292C746869732E6C6F63616C546F446973706F73652E616464287B646973706F73653A';
wwv_flow_imp.g_varchar2_table(26063) := '28293D3E7B76617220652C743B746869732E666F6C64696E67526567696F6E50726F6D697365262628746869732E666F6C64696E67526567696F6E50726F6D6973652E63616E63656C28292C746869732E666F6C64696E67526567696F6E50726F6D6973';
wwv_flow_imp.g_varchar2_table(26064) := '653D6E756C6C292C6E756C6C3D3D3D28653D746869732E7570646174655363686564756C6572297C7C766F696420303D3D3D657C7C652E63616E63656C28292C746869732E7570646174655363686564756C65723D6E756C6C2C746869732E666F6C6469';
wwv_flow_imp.g_varchar2_table(26065) := '6E674D6F64656C3D6E756C6C2C746869732E666F6C64696E674D6F64656C50726F6D6973653D6E756C6C2C746869732E68696464656E52616E67654D6F64656C3D6E756C6C2C746869732E637572736F724368616E6765645363686564756C65723D6E75';
wwv_flow_imp.g_varchar2_table(26066) := '6C6C2C6E756C6C3D3D3D28743D746869732E72616E676550726F7669646572297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E72616E676550726F76696465723D6E756C6C7D7D292C746869732E74726967676572466F6C';
wwv_flow_imp.g_varchar2_table(26067) := '64696E674D6F64656C4368616E6765642829297D6F6E466F6C64696E6753747261746567794368616E67656428297B76617220653B6E756C6C3D3D3D28653D746869732E72616E676550726F7669646572297C7C766F696420303D3D3D657C7C652E6469';
wwv_flow_imp.g_varchar2_table(26068) := '73706F736528292C746869732E72616E676550726F76696465723D6E756C6C2C746869732E74726967676572466F6C64696E674D6F64656C4368616E67656428297D67657452616E676550726F76696465722865297B696628746869732E72616E676550';
wwv_flow_imp.g_varchar2_table(26069) := '726F76696465722972657475726E20746869732E72616E676550726F76696465723B636F6E737420743D6E657720673128652C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652C746869732E5F666F6C64696E674C69';
wwv_flow_imp.g_varchar2_table(26070) := '6D69745265706F72746572293B696628746869732E72616E676550726F76696465723D742C746869732E5F757365466F6C64696E6750726F7669646572732626746869732E666F6C64696E674D6F64656C297B636F6E7374206E3D54312E676574466F6C';
wwv_flow_imp.g_varchar2_table(26071) := '64696E6752616E676550726F76696465727328746869732E6C616E67756167654665617475726573536572766963652C65293B6E2E6C656E6774683E30262628746869732E72616E676550726F76696465723D6E6577204C3128652C6E2C2828293D3E74';
wwv_flow_imp.g_varchar2_table(26072) := '6869732E74726967676572466F6C64696E674D6F64656C4368616E6765642829292C746869732E5F666F6C64696E674C696D69745265706F727465722C7429297D72657475726E20746869732E72616E676550726F76696465727D676574466F6C64696E';
wwv_flow_imp.g_varchar2_table(26073) := '674D6F64656C28297B72657475726E20746869732E666F6C64696E674D6F64656C50726F6D6973657D6F6E4469644368616E67654D6F64656C436F6E74656E742865297B76617220743B6E756C6C3D3D3D28743D746869732E68696464656E52616E6765';
wwv_flow_imp.g_varchar2_table(26074) := '4D6F64656C297C7C766F696420303D3D3D747C7C742E6E6F746966794368616E67654D6F64656C436F6E74656E742865292C746869732E74726967676572466F6C64696E674D6F64656C4368616E67656428297D74726967676572466F6C64696E674D6F';
wwv_flow_imp.g_varchar2_table(26075) := '64656C4368616E67656428297B746869732E7570646174655363686564756C6572262628746869732E666F6C64696E67526567696F6E50726F6D697365262628746869732E666F6C64696E67526567696F6E50726F6D6973652E63616E63656C28292C74';
wwv_flow_imp.g_varchar2_table(26076) := '6869732E666F6C64696E67526567696F6E50726F6D6973653D6E756C6C292C746869732E666F6C64696E674D6F64656C50726F6D6973653D746869732E7570646174655363686564756C65722E74726967676572282828293D3E7B636F6E737420653D74';
wwv_flow_imp.g_varchar2_table(26077) := '6869732E666F6C64696E674D6F64656C3B69662821652972657475726E206E756C6C3B636F6E737420743D6E65772066742C6E3D746869732E67657452616E676550726F766964657228652E746578744D6F64656C292C693D746869732E666F6C64696E';
wwv_flow_imp.g_varchar2_table(26078) := '67526567696F6E50726F6D6973653D46742828653D3E6E2E636F6D7075746528652929293B72657475726E20692E7468656E28286E3D3E7B6966286E2626693D3D3D746869732E666F6C64696E67526567696F6E50726F6D697365297B6C657420693B69';
wwv_flow_imp.g_varchar2_table(26079) := '6628746869732E5F666F6C64696E67496D706F727473427944656661756C74262621746869732E5F63757272656E744D6F64656C486173466F6C646564496D706F727473297B636F6E737420653D6E2E736574436F6C6C6170736564416C6C4F66547970';
wwv_flow_imp.g_varchar2_table(26080) := '652841772E496D706F7274732E76616C75652C2130293B65262628693D48422E6361707475726528746869732E656469746F72292C746869732E5F63757272656E744D6F64656C486173466F6C646564496D706F7274733D65297D636F6E7374206F3D74';
wwv_flow_imp.g_varchar2_table(26081) := '6869732E656469746F722E67657453656C656374696F6E7328292C733D6F3F6F2E6D61702828653D3E652E73746172744C696E654E756D62657229293A5B5D3B652E757064617465286E2C73292C6E756C6C3D3D697C7C692E726573746F726528746869';
wwv_flow_imp.g_varchar2_table(26082) := '732E656469746F72293B636F6E737420723D746869732E7570646174654465626F756E6365496E666F2E75706461746528652E746578744D6F64656C2C742E656C61707365642829293B746869732E7570646174655363686564756C6572262628746869';
wwv_flow_imp.g_varchar2_table(26083) := '732E7570646174655363686564756C65722E64656661756C7444656C61793D72297D72657475726E20657D29297D29292E7468656E28766F696420302C28653D3E286B652865292C6E756C6C292929297D6F6E48696464656E52616E6765734368616E67';
wwv_flow_imp.g_varchar2_table(26084) := '65732865297B696628746869732E68696464656E52616E67654D6F64656C2626652E6C656E677468262621746869732E5F726573746F72696E67566965775374617465297B636F6E737420653D746869732E656469746F722E67657453656C656374696F';
wwv_flow_imp.g_varchar2_table(26085) := '6E7328293B652626746869732E68696464656E52616E67654D6F64656C2E61646A75737453656C656374696F6E732865292626746869732E656469746F722E73657453656C656374696F6E732865297D746869732E656469746F722E7365744869646465';
wwv_flow_imp.g_varchar2_table(26086) := '6E417265617328652C74686973297D6F6E437572736F72506F736974696F6E4368616E67656428297B746869732E68696464656E52616E67654D6F64656C2626746869732E68696464656E52616E67654D6F64656C2E68617352616E6765732829262674';
wwv_flow_imp.g_varchar2_table(26087) := '6869732E637572736F724368616E6765645363686564756C65722E7363686564756C6528297D72657665616C437572736F7228297B636F6E737420653D746869732E676574466F6C64696E674D6F64656C28293B652626652E7468656E2828653D3E7B69';
wwv_flow_imp.g_varchar2_table(26088) := '662865297B636F6E737420743D746869732E656469746F722E67657453656C656374696F6E7328293B696628742626742E6C656E6774683E30297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F662074297B636F6E737420743D692E7365';
wwv_flow_imp.g_varchar2_table(26089) := '6C656374696F6E53746172744C696E654E756D6265723B746869732E68696464656E52616E67654D6F64656C2626746869732E68696464656E52616E67654D6F64656C2E697348696464656E28742926266E2E70757368282E2E2E652E676574416C6C52';
wwv_flow_imp.g_varchar2_table(26090) := '6567696F6E7341744C696E6528742C28653D3E652E6973436F6C6C61707365642626743E652E73746172744C696E654E756D6265722929297D6E2E6C656E677468262628652E746F67676C65436F6C6C617073655374617465286E292C746869732E7265';
wwv_flow_imp.g_varchar2_table(26091) := '7665616C28745B305D2E676574506F736974696F6E282929297D7D7D29292E7468656E28766F696420302C6B65297D6F6E456469746F724D6F757365446F776E2865297B696628746869732E6D6F757365446F776E496E666F3D6E756C6C2C2174686973';
wwv_flow_imp.g_varchar2_table(26092) := '2E68696464656E52616E67654D6F64656C7C7C21652E7461726765747C7C21652E7461726765742E72616E67652972657475726E3B69662821652E6576656E742E6C656674427574746F6E262621652E6576656E742E6D6964646C65427574746F6E2972';
wwv_flow_imp.g_varchar2_table(26093) := '657475726E3B636F6E737420743D652E7461726765742E72616E67653B6C6574206E3D21313B73776974636828652E7461726765742E74797065297B6361736520343A7B636F6E737420743D652E7461726765742E64657461696C2C693D652E74617267';
wwv_flow_imp.g_varchar2_table(26094) := '65742E656C656D656E742E6F66667365744C6566743B696628742E6F6666736574582D693C342972657475726E3B6E3D21303B627265616B7D6361736520373A696628746869732E5F756E666F6C644F6E436C69636B4166746572456E644F664C696E65';
wwv_flow_imp.g_varchar2_table(26095) := '2626746869732E68696464656E52616E67654D6F64656C2E68617352616E6765732829262621652E7461726765742E64657461696C2E697341667465724C696E657329627265616B3B72657475726E3B6361736520363A696628746869732E6869646465';
wwv_flow_imp.g_varchar2_table(26096) := '6E52616E67654D6F64656C2E68617352616E6765732829297B636F6E737420653D746869732E656469746F722E6765744D6F64656C28293B696628652626742E7374617274436F6C756D6E3D3D3D652E6765744C696E654D6178436F6C756D6E28742E73';
wwv_flow_imp.g_varchar2_table(26097) := '746172744C696E654E756D6265722929627265616B7D72657475726E3B64656661756C743A72657475726E7D746869732E6D6F757365446F776E496E666F3D7B6C696E654E756D6265723A742E73746172744C696E654E756D6265722C69636F6E436C69';
wwv_flow_imp.g_varchar2_table(26098) := '636B65643A6E7D7D6F6E456469746F724D6F75736555702865297B636F6E737420743D746869732E666F6C64696E674D6F64656C3B69662821747C7C21746869732E6D6F757365446F776E496E666F7C7C21652E7461726765742972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(26099) := '6E7374206E3D746869732E6D6F757365446F776E496E666F2E6C696E654E756D6265722C693D746869732E6D6F757365446F776E496E666F2E69636F6E436C69636B65642C6F3D652E7461726765742E72616E67653B696628216F7C7C6F2E7374617274';
wwv_flow_imp.g_varchar2_table(26100) := '4C696E654E756D626572213D3D6E2972657475726E3B69662869297B69662834213D3D652E7461726765742E747970652972657475726E7D656C73657B636F6E737420653D746869732E656469746F722E6765744D6F64656C28293B69662821657C7C6F';
wwv_flow_imp.g_varchar2_table(26101) := '2E7374617274436F6C756D6E213D3D652E6765744C696E654D6178436F6C756D6E286E292972657475726E7D636F6E737420733D742E676574526567696F6E41744C696E65286E293B696628732626732E73746172744C696E654E756D6265723D3D3D6E';
wwv_flow_imp.g_varchar2_table(26102) := '297B636F6E7374206F3D732E6973436F6C6C61707365643B696628697C7C6F297B6C657420693D5B5D3B696628652E6576656E742E616C744B6579297B636F6E737420653D653D3E21652E636F6E7461696E65644279287329262621732E636F6E746169';
wwv_flow_imp.g_varchar2_table(26103) := '6E656442792865292C6E3D742E676574526567696F6E73496E73696465286E756C6C2C65293B666F7228636F6E73742065206F66206E29652E6973436F6C6C61707365642626692E707573682865293B303D3D3D692E6C656E677468262628693D6E297D';
wwv_flow_imp.g_varchar2_table(26104) := '656C73657B636F6E7374206E3D652E6576656E742E6D6964646C65427574746F6E7C7C652E6576656E742E73686966744B65793B6966286E29666F7228636F6E73742065206F6620742E676574526567696F6E73496E7369646528732929652E6973436F';
wwv_flow_imp.g_varchar2_table(26105) := '6C6C61707365643D3D3D6F2626692E707573682865293B216F26266E262630213D3D692E6C656E6774687C7C692E707573682873297D742E746F67676C65436F6C6C6170736553746174652869292C746869732E72657665616C287B6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(26106) := '65723A6E2C636F6C756D6E3A317D297D7D7D72657665616C2865297B746869732E656469746F722E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F727428652C30297D7D3B41312E49443D22656469746F72';
wwv_flow_imp.g_varchar2_table(26107) := '2E636F6E747269622E666F6C64696E67222C41313D54313D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50';
wwv_flow_imp.g_varchar2_table(26108) := '726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E';
wwv_flow_imp.g_varchar2_table(26109) := '6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C7229';
wwv_flow_imp.g_varchar2_table(26110) := '3B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B493128312C6364292C493128322C6567292C493128332C7344292C493128342C6456292C493128352C7878295D2C4131293B63';
wwv_flow_imp.g_varchar2_table(26111) := '6C617373204E317B636F6E7374727563746F722865297B746869732E656469746F723D652C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E5F636F6D70757465643D302C746869732E5F6C696D697465643D21317D67657420';
wwv_flow_imp.g_varchar2_table(26112) := '6C696D697428297B72657475726E20746869732E656469746F722E6765744F7074696F6E7328292E676574283437297D75706461746528652C74297B653D3D3D746869732E5F636F6D70757465642626743D3D3D746869732E5F6C696D697465647C7C28';
wwv_flow_imp.g_varchar2_table(26113) := '746869732E5F636F6D70757465643D652C746869732E5F6C696D697465643D742C746869732E5F6F6E4469644368616E67652E666972652829297D7D636C61737320503120657874656E64732055647B72756E456469746F72436F6D6D616E6428652C74';
wwv_flow_imp.g_varchar2_table(26114) := '2C6E297B636F6E737420693D652E676574286567292C6F3D41312E6765742874293B696628216F2972657475726E3B636F6E737420733D6F2E676574466F6C64696E674D6F64656C28293B72657475726E20733F28746869732E7265706F727454656C65';
wwv_flow_imp.g_varchar2_table(26115) := '6D6574727928652C74292C732E7468656E2828653D3E7B69662865297B746869732E696E766F6B65286F2C652C742C6E2C69293B636F6E737420733D742E67657453656C656374696F6E28293B7326266F2E72657665616C28732E676574537461727450';
wwv_flow_imp.g_varchar2_table(26116) := '6F736974696F6E2829297D7D2929293A766F696420307D67657453656C65637465644C696E65732865297B636F6E737420743D652E67657453656C656374696F6E7328293B72657475726E20743F742E6D61702828653D3E652E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(26117) := '756D62657229293A5B5D7D6765744C696E654E756D6265727328652C74297B72657475726E20652626652E73656C656374696F6E4C696E65733F652E73656C656374696F6E4C696E65732E6D61702828653D3E652B3129293A746869732E67657453656C';
wwv_flow_imp.g_varchar2_table(26118) := '65637465644C696E65732874297D72756E28652C74297B7D7D66756E6374696F6E204F312865297B69662821766C286529297B69662821756C2865292972657475726E21313B636F6E737420743D653B69662821766C28742E6C6576656C732926262167';
wwv_flow_imp.g_varchar2_table(26119) := '6C28742E6C6576656C73292972657475726E21313B69662821766C28742E646972656374696F6E29262621686C28742E646972656374696F6E292972657475726E21313B6966282128766C28742E73656C656374696F6E4C696E6573297C7C4172726179';
wwv_flow_imp.g_varchar2_table(26120) := '2E6973417272617928742E73656C656374696F6E4C696E6573292626742E73656C656374696F6E4C696E65732E657665727928676C29292972657475726E21317D72657475726E21307D636C61737320523120657874656E64732050317B676574466F6C';
wwv_flow_imp.g_varchar2_table(26121) := '64696E674C6576656C28297B72657475726E207061727365496E7428746869732E69642E7375627374722852312E49445F5052454649582E6C656E67746829297D696E766F6B6528652C742C6E297B2166756E6374696F6E28652C742C6E2C69297B636F';
wwv_flow_imp.g_varchar2_table(26122) := '6E7374206F3D652E676574526567696F6E73496E73696465286E756C6C2C2828652C6E293D3E6E3D3D3D74262674727565213D3D652E6973436F6C6C6170736564262621692E736F6D652828743D3E652E636F6E7461696E734C696E6528742929292929';
wwv_flow_imp.g_varchar2_table(26123) := '3B652E746F67676C65436F6C6C617073655374617465286F297D28742C746869732E676574466F6C64696E674C6576656C28292C302C746869732E67657453656C65637465644C696E6573286E29297D7D52312E49445F5052454649583D22656469746F';
wwv_flow_imp.g_varchar2_table(26124) := '722E666F6C644C6576656C222C52312E49443D653D3E52312E49445F5052454649582B652C4A642841312E49442C41312C30292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469';
wwv_flow_imp.g_varchar2_table(26125) := '746F722E756E666F6C64222C6C6162656C3A6228302C22556E666F6C6422292C616C6961733A22556E666F6C64222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C707269';
wwv_flow_imp.g_varchar2_table(26126) := '6D6172793A333136362C6D61633A7B7072696D6172793A323635347D2C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A22556E666F6C642074686520636F6E74656E7420696E2074686520656469746F72222C6172';
wwv_flow_imp.g_varchar2_table(26127) := '67733A5B7B6E616D653A22556E666F6C6420656469746F7220617267756D656E74222C6465736372697074696F6E3A2250726F70657274792D76616C756520706169727320746861742063616E20626520706173736564207468726F7567682074686973';
wwv_flow_imp.g_varchar2_table(26128) := '20617267756D656E743A5C6E5C745C745C745C745C745C742A20276C6576656C73273A204E756D626572206F66206C6576656C7320746F20756E666F6C642E204966206E6F74207365742C2064656661756C747320746F20312E5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(26129) := '5C745C742A2027646972656374696F6E273A20496620277570272C20756E666F6C6420676976656E206E756D626572206F66206C6576656C73207570206F746865727769736520756E666F6C647320646F776E2E5C6E5C745C745C745C745C745C742A20';
wwv_flow_imp.g_varchar2_table(26130) := '2773656C656374696F6E4C696E6573273A204172726179206F6620746865207374617274206C696E65732028302D626173656429206F662074686520656469746F722073656C656374696F6E7320746F206170706C792074686520756E666F6C64206163';
wwv_flow_imp.g_varchar2_table(26131) := '74696F6E20746F2E204966206E6F74207365742C20746865206163746976652073656C656374696F6E2873292077696C6C20626520757365642E5C6E5C745C745C745C745C745C74222C636F6E73747261696E743A4F312C736368656D613A7B74797065';
wwv_flow_imp.g_varchar2_table(26132) := '3A226F626A656374222C70726F706572746965733A7B6C6576656C733A7B747970653A226E756D626572222C64656661756C743A317D2C646972656374696F6E3A7B747970653A22737472696E67222C656E756D3A5B227570222C22646F776E225D2C64';
wwv_flow_imp.g_varchar2_table(26133) := '656661756C743A22646F776E227D2C73656C656374696F6E4C696E65733A7B747970653A226172726179222C6974656D733A7B747970653A226E756D626572227D7D7D7D7D5D7D7D297D696E766F6B6528652C742C6E2C69297B636F6E7374206F3D6926';
wwv_flow_imp.g_varchar2_table(26134) := '26692E6C6576656C737C7C312C733D746869732E6765744C696E654E756D6265727328692C6E293B692626227570223D3D3D692E646972656374696F6E3F6C3128742C21312C6F2C73293A613128742C21312C6F2C73297D7D292C5A6428636C61737320';
wwv_flow_imp.g_varchar2_table(26135) := '657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E756E666F6C645265637572736976656C79222C6C6162656C3A6228302C22556E666F6C64205265637572736976656C7922292C616C6961733A';
wwv_flow_imp.g_varchar2_table(26136) := '22556E666F6C64205265637572736976656C79222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32313432292C7765696768743A';
wwv_flow_imp.g_varchar2_table(26137) := '3130307D7D297D696E766F6B6528652C742C6E2C69297B613128742C21312C4E756D6265722E4D41585F56414C55452C746869732E67657453656C65637465644C696E6573286E29297D7D292C5A6428636C61737320657874656E64732050317B636F6E';
wwv_flow_imp.g_varchar2_table(26138) := '7374727563746F7228297B7375706572287B69643A22656469746F722E666F6C64222C6C6162656C3A6228302C22466F6C6422292C616C6961733A22466F6C64222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E';
wwv_flow_imp.g_varchar2_table(26139) := '656469746F7254657874466F6375732C7072696D6172793A333136342C6D61633A7B7072696D6172793A323635327D2C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A22466F6C642074686520636F6E74656E7420';
wwv_flow_imp.g_varchar2_table(26140) := '696E2074686520656469746F72222C617267733A5B7B6E616D653A22466F6C6420656469746F7220617267756D656E74222C6465736372697074696F6E3A2250726F70657274792D76616C756520706169727320746861742063616E2062652070617373';
wwv_flow_imp.g_varchar2_table(26141) := '6564207468726F756768207468697320617267756D656E743A5C6E5C745C745C745C745C745C745C742A20276C6576656C73273A204E756D626572206F66206C6576656C7320746F20666F6C642E5C6E5C745C745C745C745C745C745C742A2027646972';
wwv_flow_imp.g_varchar2_table(26142) := '656374696F6E273A20496620277570272C20666F6C647320676976656E206E756D626572206F66206C6576656C73207570206F746865727769736520666F6C647320646F776E2E5C6E5C745C745C745C745C745C745C742A202773656C656374696F6E4C';
wwv_flow_imp.g_varchar2_table(26143) := '696E6573273A204172726179206F6620746865207374617274206C696E65732028302D626173656429206F662074686520656469746F722073656C656374696F6E7320746F206170706C792074686520666F6C6420616374696F6E20746F2E204966206E';
wwv_flow_imp.g_varchar2_table(26144) := '6F74207365742C20746865206163746976652073656C656374696F6E2873292077696C6C20626520757365642E5C6E5C745C745C745C745C745C745C744966206E6F206C6576656C73206F7220646972656374696F6E206973207365742C20666F6C6473';
wwv_flow_imp.g_varchar2_table(26145) := '2074686520726567696F6E20617420746865206C6F636174696F6E73206F7220696620616C726561647920636F6C6C61707365642C2074686520666972737420756E636F6C6C617073656420706172656E7420696E73746561642E5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(26146) := '745C745C74222C636F6E73747261696E743A4F312C736368656D613A7B747970653A226F626A656374222C70726F706572746965733A7B6C6576656C733A7B747970653A226E756D626572227D2C646972656374696F6E3A7B747970653A22737472696E';
wwv_flow_imp.g_varchar2_table(26147) := '67222C656E756D3A5B227570222C22646F776E225D7D2C73656C656374696F6E4C696E65733A7B747970653A226172726179222C6974656D733A7B747970653A226E756D626572227D7D7D7D7D5D7D7D297D696E766F6B6528652C742C6E2C69297B636F';
wwv_flow_imp.g_varchar2_table(26148) := '6E7374206F3D746869732E6765744C696E654E756D6265727328692C6E292C733D692626692E6C6576656C732C723D692626692E646972656374696F6E3B226E756D62657222213D747970656F662073262622737472696E6722213D747970656F662072';
wwv_flow_imp.g_varchar2_table(26149) := '3F66756E6374696F6E28652C742C6E297B636F6E737420693D5B5D3B666F7228636F6E73742074206F66206E297B636F6E7374206E3D652E676574416C6C526567696F6E7341744C696E6528742C28653D3E74727565213D3D652E6973436F6C6C617073';
wwv_flow_imp.g_varchar2_table(26150) := '656429293B6E2E6C656E6774683E302626692E70757368286E5B305D297D652E746F67676C65436F6C6C6170736553746174652869297D28742C302C6F293A227570223D3D3D723F6C3128742C21302C737C7C312C6F293A613128742C21302C737C7C31';
wwv_flow_imp.g_varchar2_table(26151) := '2C6F297D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E666F6C645265637572736976656C79222C6C6162656C3A6228302C22466F6C64205265637572736976';
wwv_flow_imp.g_varchar2_table(26152) := '656C7922292C616C6961733A22466F6C64205265637572736976656C79222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C323134';
wwv_flow_imp.g_varchar2_table(26153) := '30292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B636F6E737420693D746869732E67657453656C65637465644C696E6573286E293B613128742C21302C4E756D6265722E4D41585F56414C55452C69297D7D292C5A6428636C';
wwv_flow_imp.g_varchar2_table(26154) := '61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E666F6C64416C6C222C6C6162656C3A6228302C22466F6C6420416C6C22292C616C6961733A22466F6C6420416C6C222C707265636F';
wwv_flow_imp.g_varchar2_table(26155) := '6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303639292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B613128742C';
wwv_flow_imp.g_varchar2_table(26156) := '2130297D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E756E666F6C64416C6C222C6C6162656C3A6228302C22556E666F6C6420416C6C22292C616C6961733A';
wwv_flow_imp.g_varchar2_table(26157) := '22556E666F6C6420416C6C222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303838292C7765696768743A3130307D7D297D69';
wwv_flow_imp.g_varchar2_table(26158) := '6E766F6B6528652C742C6E297B613128742C2131297D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E666F6C64416C6C426C6F636B436F6D6D656E7473222C6C';
wwv_flow_imp.g_varchar2_table(26159) := '6162656C3A6228302C22466F6C6420416C6C20426C6F636B20436F6D6D656E747322292C616C6961733A22466F6C6420416C6C20426C6F636B20436F6D6D656E7473222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C';
wwv_flow_imp.g_varchar2_table(26160) := '682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32313338292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E2C692C6F297B696628742E726567696F6E732E686173547970657328292968312874';
wwv_flow_imp.g_varchar2_table(26161) := '2C41772E436F6D6D656E742E76616C75652C2130293B656C73657B636F6E737420653D6E2E6765744D6F64656C28293B69662821652972657475726E3B636F6E737420693D6F2E6765744C616E6775616765436F6E66696775726174696F6E28652E6765';
wwv_flow_imp.g_varchar2_table(26162) := '744C616E677561676549642829292E636F6D6D656E74733B692626692E626C6F636B436F6D6D656E745374617274546F6B656E2626643128742C6E65772052656745787028225E5C5C732A222B636928692E626C6F636B436F6D6D656E74537461727454';
wwv_flow_imp.g_varchar2_table(26163) := '6F6B656E29292C2130297D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E666F6C64416C6C4D61726B6572526567696F6E73222C6C6162656C3A6228302C22';
wwv_flow_imp.g_varchar2_table(26164) := '466F6C6420416C6C20526567696F6E7322292C616C6961733A22466F6C6420416C6C20526567696F6E73222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172';
wwv_flow_imp.g_varchar2_table(26165) := '793A536528323038392C32303737292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E2C692C6F297B696628742E726567696F6E732E6861735479706573282929683128742C41772E526567696F6E2E76616C75652C2130293B656C73';
wwv_flow_imp.g_varchar2_table(26166) := '657B636F6E737420653D6E2E6765744D6F64656C28293B69662821652972657475726E3B636F6E737420693D6F2E6765744C616E6775616765436F6E66696775726174696F6E28652E6765744C616E677561676549642829292E666F6C64696E6752756C';
wwv_flow_imp.g_varchar2_table(26167) := '65733B692626692E6D61726B6572732626692E6D61726B6572732E73746172742626643128742C6E65772052656745787028692E6D61726B6572732E7374617274292C2130297D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374';
wwv_flow_imp.g_varchar2_table(26168) := '727563746F7228297B7375706572287B69643A22656469746F722E756E666F6C64416C6C4D61726B6572526567696F6E73222C6C6162656C3A6228302C22556E666F6C6420416C6C20526567696F6E7322292C616C6961733A22556E666F6C6420416C6C';
wwv_flow_imp.g_varchar2_table(26169) := '20526567696F6E73222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303738292C7765696768743A3130307D7D297D696E766F';
wwv_flow_imp.g_varchar2_table(26170) := '6B6528652C742C6E2C692C6F297B696628742E726567696F6E732E6861735479706573282929683128742C41772E526567696F6E2E76616C75652C2131293B656C73657B636F6E737420653D6E2E6765744D6F64656C28293B6966282165297265747572';
wwv_flow_imp.g_varchar2_table(26171) := '6E3B636F6E737420693D6F2E6765744C616E6775616765436F6E66696775726174696F6E28652E6765744C616E677561676549642829292E666F6C64696E6752756C65733B692626692E6D61726B6572732626692E6D61726B6572732E73746172742626';
wwv_flow_imp.g_varchar2_table(26172) := '643128742C6E65772052656745787028692E6D61726B6572732E7374617274292C2131297D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E666F6C64416C6C';
wwv_flow_imp.g_varchar2_table(26173) := '457863657074222C6C6162656C3A6228302C22466F6C6420416C6C204578636570742053656C656374656422292C616C6961733A22466F6C6420416C6C204578636570742053656C6563746564222C707265636F6E646974696F6E3A4D312C6B624F7074';
wwv_flow_imp.g_varchar2_table(26174) := '733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32313336292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B633128742C21302C746869732E67657453656C6563';
wwv_flow_imp.g_varchar2_table(26175) := '7465644C696E6573286E29297D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E756E666F6C64416C6C457863657074222C6C6162656C3A6228302C22556E666F';
wwv_flow_imp.g_varchar2_table(26176) := '6C6420416C6C204578636570742053656C656374656422292C616C6961733A22556E666F6C6420416C6C204578636570742053656C6563746564222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F72';
wwv_flow_imp.g_varchar2_table(26177) := '54657874466F6375732C7072696D6172793A536528323038392C32313334292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B633128742C21312C746869732E67657453656C65637465644C696E6573286E29297D7D292C5A6428';
wwv_flow_imp.g_varchar2_table(26178) := '636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E746F67676C65466F6C64222C6C6162656C3A6228302C22546F67676C6520466F6C6422292C616C6961733A22546F67676C6520';
wwv_flow_imp.g_varchar2_table(26179) := '466F6C64222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303930292C7765696768743A3130307D7D297D696E766F6B652865';
wwv_flow_imp.g_varchar2_table(26180) := '2C742C6E297B723128742C312C746869732E67657453656C65637465644C696E6573286E29297D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E676F746F5061';
wwv_flow_imp.g_varchar2_table(26181) := '72656E74466F6C64222C6C6162656C3A6228302C22476F20746F20506172656E7420466F6C6422292C616C6961733A22476F20746F20506172656E7420466F6C64222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C68';
wwv_flow_imp.g_varchar2_table(26182) := '2E656469746F7254657874466F6375732C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B636F6E737420693D746869732E67657453656C65637465644C696E6573286E293B696628692E6C656E6774683E30297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(26183) := '3D66756E6374696F6E28652C74297B6C6574206E3D6E756C6C3B636F6E737420693D742E676574526567696F6E41744C696E652865293B6966286E756C6C213D3D692626286E3D692E73746172744C696E654E756D6265722C653D3D3D6E29297B636F6E';
wwv_flow_imp.g_varchar2_table(26184) := '737420653D692E706172656E74496E6465783B6E3D2D31213D3D653F742E726567696F6E732E67657453746172744C696E654E756D6265722865293A6E756C6C7D72657475726E206E7D28695B305D2C74293B6E756C6C213D3D6526266E2E7365745365';
wwv_flow_imp.g_varchar2_table(26185) := '6C656374696F6E287B73746172744C696E654E756D6265723A652C7374617274436F6C756D6E3A312C656E644C696E654E756D6265723A652C656E64436F6C756D6E3A317D297D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374';
wwv_flow_imp.g_varchar2_table(26186) := '727563746F7228297B7375706572287B69643A22656469746F722E676F746F50726576696F7573466F6C64222C6C6162656C3A6228302C22476F20746F2050726576696F757320466F6C64696E672052616E676522292C616C6961733A22476F20746F20';
wwv_flow_imp.g_varchar2_table(26187) := '50726576696F757320466F6C64696E672052616E6765222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7765696768743A3130307D7D297D696E766F6B6528652C742C6E';
wwv_flow_imp.g_varchar2_table(26188) := '297B636F6E737420693D746869732E67657453656C65637465644C696E6573286E293B696628692E6C656E6774683E30297B636F6E737420653D66756E6374696F6E28652C74297B6C6574206E3D742E676574526567696F6E41744C696E652865293B69';
wwv_flow_imp.g_varchar2_table(26189) := '66286E756C6C213D3D6E26266E2E73746172744C696E654E756D6265723D3D3D65297B69662865213D3D6E2E73746172744C696E654E756D6265722972657475726E206E2E73746172744C696E654E756D6265723B7B636F6E737420653D6E2E70617265';
wwv_flow_imp.g_varchar2_table(26190) := '6E74496E6465783B6C657420693D303B666F72282D31213D3D65262628693D742E726567696F6E732E67657453746172744C696E654E756D626572286E2E706172656E74496E64657829293B6E756C6C213D3D6E3B297B69662821286E2E726567696F6E';
wwv_flow_imp.g_varchar2_table(26191) := '496E6465783E30292972657475726E206E756C6C3B6966286E3D742E726567696F6E732E746F526567696F6E286E2E726567696F6E496E6465782D31292C6E2E73746172744C696E654E756D6265723C3D692972657475726E206E756C6C3B6966286E2E';
wwv_flow_imp.g_varchar2_table(26192) := '706172656E74496E6465783D3D3D652972657475726E206E2E73746172744C696E654E756D6265727D7D7D656C736520696628742E726567696F6E732E6C656E6774683E3029666F72286E3D742E726567696F6E732E746F526567696F6E28742E726567';
wwv_flow_imp.g_varchar2_table(26193) := '696F6E732E6C656E6774682D31293B6E756C6C213D3D6E3B297B6966286E2E73746172744C696E654E756D6265723C652972657475726E206E2E73746172744C696E654E756D6265723B6E3D6E2E726567696F6E496E6465783E303F742E726567696F6E';
wwv_flow_imp.g_varchar2_table(26194) := '732E746F526567696F6E286E2E726567696F6E496E6465782D31293A6E756C6C7D72657475726E206E756C6C7D28695B305D2C74293B6E756C6C213D3D6526266E2E73657453656C656374696F6E287B73746172744C696E654E756D6265723A652C7374';
wwv_flow_imp.g_varchar2_table(26195) := '617274436F6C756D6E3A312C656E644C696E654E756D6265723A652C656E64436F6C756D6E3A317D297D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E676F';
wwv_flow_imp.g_varchar2_table(26196) := '746F4E657874466F6C64222C6C6162656C3A6228302C22476F20746F204E65787420466F6C64696E672052616E676522292C616C6961733A22476F20746F204E65787420466F6C64696E672052616E6765222C707265636F6E646974696F6E3A4D312C6B';
wwv_flow_imp.g_varchar2_table(26197) := '624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B636F6E737420693D746869732E67657453656C65637465644C696E6573286E293B696628692E6C';
wwv_flow_imp.g_varchar2_table(26198) := '656E6774683E30297B636F6E737420653D66756E6374696F6E28652C74297B6C6574206E3D742E676574526567696F6E41744C696E652865293B6966286E756C6C213D3D6E26266E2E73746172744C696E654E756D6265723D3D3D65297B636F6E737420';
wwv_flow_imp.g_varchar2_table(26199) := '653D6E2E706172656E74496E6465783B6C657420693D303B6966282D31213D3D6529693D742E726567696F6E732E676574456E644C696E654E756D626572286E2E706172656E74496E646578293B656C73657B696628303D3D3D742E726567696F6E732E';
wwv_flow_imp.g_varchar2_table(26200) := '6C656E6774682972657475726E206E756C6C3B693D742E726567696F6E732E676574456E644C696E654E756D62657228742E726567696F6E732E6C656E6774682D31297D666F72283B6E756C6C213D3D6E3B297B69662821286E2E726567696F6E496E64';
wwv_flow_imp.g_varchar2_table(26201) := '65783C742E726567696F6E732E6C656E677468292972657475726E206E756C6C3B6966286E3D742E726567696F6E732E746F526567696F6E286E2E726567696F6E496E6465782B31292C6E2E73746172744C696E654E756D6265723E3D69297265747572';
wwv_flow_imp.g_varchar2_table(26202) := '6E206E756C6C3B6966286E2E706172656E74496E6465783D3D3D652972657475726E206E2E73746172744C696E654E756D6265727D7D656C736520696628742E726567696F6E732E6C656E6774683E3029666F72286E3D742E726567696F6E732E746F52';
wwv_flow_imp.g_varchar2_table(26203) := '6567696F6E2830293B6E756C6C213D3D6E3B297B6966286E2E73746172744C696E654E756D6265723E652972657475726E206E2E73746172744C696E654E756D6265723B6E3D6E2E726567696F6E496E6465783C742E726567696F6E732E6C656E677468';
wwv_flow_imp.g_varchar2_table(26204) := '3F742E726567696F6E732E746F526567696F6E286E2E726567696F6E496E6465782B31293A6E756C6C7D72657475726E206E756C6C7D28695B305D2C74293B6E756C6C213D3D6526266E2E73657453656C656374696F6E287B73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(26205) := '6D6265723A652C7374617274436F6C756D6E3A312C656E644C696E654E756D6265723A652C656E64436F6C756D6E3A317D297D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374727563746F7228297B7375706572287B69643A22';
wwv_flow_imp.g_varchar2_table(26206) := '656469746F722E637265617465466F6C64696E6752616E676546726F6D53656C656374696F6E222C6C6162656C3A6228302C2243726561746520466F6C64696E672052616E67652066726F6D2053656C656374696F6E22292C616C6961733A2243726561';
wwv_flow_imp.g_varchar2_table(26207) := '746520466F6C64696E672052616E67652066726F6D2053656C656374696F6E222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32';
wwv_flow_imp.g_varchar2_table(26208) := '313335292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B76617220693B636F6E7374206F3D5B5D2C733D6E2E67657453656C656374696F6E7328293B69662873297B666F7228636F6E73742065206F662073297B6C657420743D';
wwv_flow_imp.g_varchar2_table(26209) := '652E656E644C696E654E756D6265723B313D3D3D652E656E64436F6C756D6E26262D2D742C743E652E73746172744C696E654E756D6265722626286F2E70757368287B73746172744C696E654E756D6265723A652E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(26210) := '2C656E644C696E654E756D6265723A742C747970653A766F696420302C6973436F6C6C61707365643A21302C736F757263653A317D292C6E2E73657453656C656374696F6E287B73746172744C696E654E756D6265723A652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(26211) := '6D6265722C7374617274436F6C756D6E3A312C656E644C696E654E756D6265723A652E73746172744C696E654E756D6265722C656E64436F6C756D6E3A317D29297D6966286F2E6C656E6774683E30297B6F2E736F7274282828652C74293D3E652E7374';
wwv_flow_imp.g_varchar2_table(26212) := '6172744C696E654E756D6265722D742E73746172744C696E654E756D62657229293B636F6E737420653D69312E73616E6974697A65416E644D6572676528742E726567696F6E732C6F2C6E756C6C3D3D3D28693D6E2E6765744D6F64656C2829297C7C76';
wwv_flow_imp.g_varchar2_table(26213) := '6F696420303D3D3D693F766F696420303A692E6765744C696E65436F756E742829293B742E757064617465506F73742869312E66726F6D466F6C6452616E676573286529297D7D7D7D292C5A6428636C61737320657874656E64732050317B636F6E7374';
wwv_flow_imp.g_varchar2_table(26214) := '727563746F7228297B7375706572287B69643A22656469746F722E72656D6F76654D616E75616C466F6C64696E6752616E676573222C6C6162656C3A6228302C2252656D6F7665204D616E75616C20466F6C64696E672052616E67657322292C616C6961';
wwv_flow_imp.g_varchar2_table(26215) := '733A2252656D6F7665204D616E75616C20466F6C64696E672052616E676573222C707265636F6E646974696F6E3A4D312C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32';
wwv_flow_imp.g_varchar2_table(26216) := '313337292C7765696768743A3130307D7D297D696E766F6B6528652C742C6E297B636F6E737420693D6E2E67657453656C656374696F6E7328293B69662869297B636F6E7374206E3D5B5D3B666F7228636F6E73742065206F662069297B636F6E73747B';
wwv_flow_imp.g_varchar2_table(26217) := '73746172744C696E654E756D6265723A742C656E644C696E654E756D6265723A697D3D653B6E2E7075736828693E3D743F7B73746172744C696E654E756D6265723A742C656E644C696E654E756D6265723A697D3A7B656E644C696E654E756D6265723A';
wwv_flow_imp.g_varchar2_table(26218) := '692C73746172744C696E654E756D6265723A747D297D742E72656D6F76654D616E75616C52616E676573286E292C652E74726967676572466F6C64696E674D6F64656C4368616E67656428297D7D7D293B666F72286C657420653D313B653C3D373B652B';
wwv_flow_imp.g_varchar2_table(26219) := '2B2946313D6E6577205231287B69643A52312E49442865292C6C6162656C3A6228302C22466F6C64204C6576656C207B307D222C65292C616C6961733A60466F6C64204C6576656C20247B657D602C707265636F6E646974696F6E3A4D312C6B624F7074';
wwv_flow_imp.g_varchar2_table(26220) := '733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C323034387C32312B65292C7765696768743A3130307D7D292C74682E494E5354414E43452E7265676973746572456469746F7241637469';
wwv_flow_imp.g_varchar2_table(26221) := '6F6E284631293B7661722046313B6B632E7265676973746572436F6D6D616E6428225F65786563757465466F6C64696E6752616E676550726F7669646572222C286173796E632066756E6374696F6E28652C2E2E2E74297B636F6E73745B6E5D3D743B69';
wwv_flow_imp.g_varchar2_table(26222) := '662821286E20696E7374616E63656F66204E6F29297468726F77204D6528293B636F6E737420693D652E676574287878292C6F3D652E676574286663292E6765744D6F64656C286E293B696628216F297468726F77204D6528293B636F6E737420733D65';
wwv_flow_imp.g_varchar2_table(26223) := '2E676574286670293B69662821732E67657456616C75652822656469746F722E666F6C64696E67222C7B7265736F757263653A6E7D292972657475726E5B5D3B636F6E737420723D652E676574286567292C613D732E67657456616C7565282265646974';
wwv_flow_imp.g_varchar2_table(26224) := '6F722E666F6C64696E675374726174656779222C7B7265736F757263653A6E7D292C6C3D7B676574206C696D697428297B72657475726E20732E67657456616C75652822656469746F722E666F6C64696E674D6178696D756D526567696F6E73222C7B72';
wwv_flow_imp.g_varchar2_table(26225) := '65736F757263653A6E7D297D2C7570646174653A28652C74293D3E7B7D7D2C633D6E6577206731286F2C722C6C293B6C657420643D633B69662822696E64656E746174696F6E22213D3D61297B636F6E737420653D41312E676574466F6C64696E675261';
wwv_flow_imp.g_varchar2_table(26226) := '6E676550726F76696465727328692C6F293B652E6C656E677468262628643D6E6577204C31286F2C652C2828293D3E7B7D292C6C2C6329297D636F6E737420683D617761697420642E636F6D70757465284D742E4E6F6E65292C753D5B5D3B7472797B69';
wwv_flow_imp.g_varchar2_table(26227) := '66286829666F72286C657420653D303B653C682E6C656E6774683B652B2B297B636F6E737420743D682E676574547970652865293B752E70757368287B73746172743A682E67657453746172744C696E654E756D6265722865292C656E643A682E676574';
wwv_flow_imp.g_varchar2_table(26228) := '456E644C696E654E756D6265722865292C6B696E643A743F41772E66726F6D56616C75652874293A766F696420307D297D72657475726E20757D66696E616C6C797B642E646973706F736528297D7D29292C5A6428636C61737320657874656E64732055';
wwv_flow_imp.g_varchar2_table(26229) := '647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F6E745A6F6F6D496E222C6C6162656C3A6228302C22496E63726561736520456469746F7220466F6E742053697A6522292C616C6961733A2249';
wwv_flow_imp.g_varchar2_table(26230) := '6E63726561736520456469746F7220466F6E742053697A65222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B43412E7365745A6F6F6D4C6576656C2843412E6765745A6F6F6D4C6576656C28292B31297D7D292C5A6428';
wwv_flow_imp.g_varchar2_table(26231) := '636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F6E745A6F6F6D4F7574222C6C6162656C3A6228302C22446563726561736520456469746F7220466F6E74';
wwv_flow_imp.g_varchar2_table(26232) := '2053697A6522292C616C6961733A22446563726561736520456469746F7220466F6E742053697A65222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B43412E7365745A6F6F6D4C6576656C2843412E6765745A6F6F6D4C';
wwv_flow_imp.g_varchar2_table(26233) := '6576656C28292D31297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F6E745A6F6F6D5265736574222C6C6162656C3A6228302C225265';
wwv_flow_imp.g_varchar2_table(26234) := '73657420456469746F7220466F6E742053697A6522292C616C6961733A22526573657420456469746F7220466F6E742053697A65222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B43412E7365745A6F6F6D4C6576656C';
wwv_flow_imp.g_varchar2_table(26235) := '2830297D7D293B636C6173732042317B737461746963205F68616E646C65456F6C456469747328652C74297B6C6574206E3B636F6E737420693D5B5D3B666F7228636F6E73742065206F66207429226E756D626572223D3D747970656F6620652E656F6C';
wwv_flow_imp.g_varchar2_table(26236) := '2626286E3D652E656F6C292C652E72616E6765262622737472696E67223D3D747970656F6620652E746578742626692E707573682865293B72657475726E226E756D626572223D3D747970656F66206E2626652E6861734D6F64656C28292626652E6765';
wwv_flow_imp.g_varchar2_table(26237) := '744D6F64656C28292E70757368454F4C286E292C697D737461746963205F697346756C6C4D6F64656C5265706C6163654564697428652C74297B69662821652E6861734D6F64656C28292972657475726E21313B636F6E7374206E3D652E6765744D6F64';
wwv_flow_imp.g_varchar2_table(26238) := '656C28292C693D6E2E76616C696461746552616E676528742E72616E6765293B72657475726E206E2E67657446756C6C4D6F64656C52616E676528292E657175616C7352616E67652869297D737461746963206578656375746528652C742C6E297B6E26';
wwv_flow_imp.g_varchar2_table(26239) := '26652E70757368556E646F53746F7028293B636F6E737420693D48422E636170747572652865292C6F3D42312E5F68616E646C65456F6C456469747328652C74293B313D3D3D6F2E6C656E677468262642312E5F697346756C6C4D6F64656C5265706C61';
wwv_flow_imp.g_varchar2_table(26240) := '63654564697428652C6F5B305D293F652E6578656375746545646974732822666F726D61744564697473436F6D6D616E64222C6F2E6D61702828653D3E6A712E7265706C6163652872682E6C69667428652E72616E6765292C652E74657874292929293A';
wwv_flow_imp.g_varchar2_table(26241) := '652E6578656375746545646974732822666F726D61744564697473436F6D6D616E64222C6F2E6D61702828653D3E6A712E7265706C6163654D6F76652872682E6C69667428652E72616E6765292C652E74657874292929292C6E2626652E70757368556E';
wwv_flow_imp.g_varchar2_table(26242) := '646F53746F7028292C692E726573746F726552656C6174697665566572746963616C506F736974696F6E4F66437572736F722865297D7D636C6173732056317B636F6E7374727563746F722865297B746869732E76616C75653D652C746869732E5F6C6F';
wwv_flow_imp.g_varchar2_table(26243) := '7765723D652E746F4C6F7765724361736528297D73746174696320746F4B65792865297B72657475726E22737472696E67223D3D747970656F6620653F652E746F4C6F7765724361736528293A652E5F6C6F7765727D7D636C617373207A317B636F6E73';
wwv_flow_imp.g_varchar2_table(26244) := '74727563746F722865297B696628746869732E5F7365743D6E6577205365742C6529666F7228636F6E73742074206F66206529746869732E6164642874297D6164642865297B746869732E5F7365742E6164642856312E746F4B6579286529297D686173';
wwv_flow_imp.g_varchar2_table(26245) := '2865297B72657475726E20746869732E5F7365742E6861732856312E746F4B6579286529297D7D66756E6374696F6E20483128652C742C6E297B636F6E737420693D5B5D2C6F3D6E6577207A312C733D652E6F726465726564286E293B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(26246) := '73742065206F66207329692E707573682865292C652E657874656E73696F6E496426266F2E61646428652E657874656E73696F6E4964293B636F6E737420723D742E6F726465726564286E293B666F7228636F6E73742065206F662072297B696628652E';
wwv_flow_imp.g_varchar2_table(26247) := '657874656E73696F6E4964297B6966286F2E68617328652E657874656E73696F6E49642929636F6E74696E75653B6F2E61646428652E657874656E73696F6E4964297D692E70757368287B646973706C61794E616D653A652E646973706C61794E616D65';
wwv_flow_imp.g_varchar2_table(26248) := '2C657874656E73696F6E49643A652E657874656E73696F6E49642C70726F76696465446F63756D656E74466F726D617474696E6745646974733A28742C6E2C69293D3E652E70726F76696465446F63756D656E7452616E6765466F726D617474696E6745';
wwv_flow_imp.g_varchar2_table(26249) := '6469747328742C742E67657446756C6C4D6F64656C52616E676528292C6E2C69297D297D72657475726E20697D636C6173732057317B73746174696320736574466F726D617474657253656C6563746F722865297B72657475726E7B646973706F73653A';
wwv_flow_imp.g_varchar2_table(26250) := '57312E5F73656C6563746F72732E756E73686966742865297D7D737461746963206173796E632073656C65637428652C742C6E2C69297B696628303D3D3D652E6C656E6774682972657475726E3B636F6E7374206F3D5A652E66697273742857312E5F73';
wwv_flow_imp.g_varchar2_table(26251) := '656C6563746F7273293B72657475726E206F3F6177616974206F28652C742C6E2C69293A766F696420307D7D6173796E632066756E6374696F6E206A3128652C742C6E2C692C6F2C732C72297B636F6E737420613D652E676574287563292C7B646F6375';
wwv_flow_imp.g_varchar2_table(26252) := '6D656E7452616E6765466F726D617474696E674564697450726F76696465723A6C7D3D652E676574287878292C633D4A712874293F742E6765744D6F64656C28293A742C643D6C2E6F7264657265642863292C683D61776169742057312E73656C656374';
wwv_flow_imp.g_varchar2_table(26253) := '28642C632C692C32293B682626286F2E7265706F72742868292C617761697420612E696E766F6B6546756E6374696F6E2871312C682C742C6E2C732C7229297D6173796E632066756E6374696F6E20713128652C742C6E2C692C6F2C73297B7661722072';
wwv_flow_imp.g_varchar2_table(26254) := '2C613B636F6E7374206C3D652E676574287A5A292C633D652E676574285264292C643D652E67657428745A293B6C657420682C753B4A71286E293F28683D6E2E6765744D6F64656C28292C753D6E657720646B286E2C352C766F696420302C6F29293A28';
wwv_flow_imp.g_varchar2_table(26255) := '683D6E2C753D6E657720686B286E2C6F29293B636F6E737420703D5B5D3B6C657420673D303B666F7228636F6E73742065206F66205A682869292E736F72742872682E636F6D7061726552616E6765735573696E675374617274732929673E3026267268';
wwv_flow_imp.g_varchar2_table(26256) := '2E617265496E74657273656374696E674F72546F756368696E6728705B672D315D2C65293F705B672D315D3D72682E66726F6D506F736974696F6E7328705B672D315D2E6765745374617274506F736974696F6E28292C652E676574456E64506F736974';
wwv_flow_imp.g_varchar2_table(26257) := '696F6E2829293A673D702E707573682865293B636F6E7374206D3D6173796E6320653D3E7B766172206E2C693B632E747261636528225B666F726D61745D5B70726F76696465446F63756D656E7452616E6765466F726D617474696E6745646974735D20';
wwv_flow_imp.g_varchar2_table(26258) := '287265717565737429222C6E756C6C3D3D3D286E3D742E657874656E73696F6E4964297C7C766F696420303D3D3D6E3F766F696420303A6E2E76616C75652C65293B636F6E7374206F3D617761697420742E70726F76696465446F63756D656E7452616E';
wwv_flow_imp.g_varchar2_table(26259) := '6765466F726D617474696E67456469747328682C652C682E676574466F726D617474696E674F7074696F6E7328292C752E746F6B656E297C7C5B5D3B72657475726E20632E747261636528225B666F726D61745D5B70726F76696465446F63756D656E74';
wwv_flow_imp.g_varchar2_table(26260) := '52616E6765466F726D617474696E6745646974735D2028726573706F6E736529222C6E756C6C3D3D3D28693D742E657874656E73696F6E4964297C7C766F696420303D3D3D693F766F696420303A692E76616C75652C6F292C6F7D2C663D28652C74293D';
wwv_flow_imp.g_varchar2_table(26261) := '3E7B69662821652E6C656E6774687C7C21742E6C656E6774682972657475726E21313B636F6E7374206E3D652E726564756365282828652C74293D3E72682E706C757352616E676528652C742E72616E676529292C655B305D2E72616E6765293B696628';
wwv_flow_imp.g_varchar2_table(26262) := '21742E736F6D652828653D3E72682E696E7465727365637452616E676573286E2C652E72616E67652929292972657475726E21313B666F7228636F6E7374206E206F66206529666F7228636F6E73742065206F6620742969662872682E696E7465727365';
wwv_flow_imp.g_varchar2_table(26263) := '637452616E676573286E2E72616E67652C652E72616E6765292972657475726E21303B72657475726E21317D2C763D5B5D2C623D5B5D3B7472797B6966282266756E6374696F6E223D3D747970656F6620742E70726F76696465446F63756D656E745261';
wwv_flow_imp.g_varchar2_table(26264) := '6E676573466F726D617474696E674564697473297B632E747261636528225B666F726D61745D5B70726F76696465446F63756D656E7452616E6765466F726D617474696E6745646974735D20287265717565737429222C6E756C6C3D3D3D28723D742E65';
wwv_flow_imp.g_varchar2_table(26265) := '7874656E73696F6E4964297C7C766F696420303D3D3D723F766F696420303A722E76616C75652C70293B636F6E737420653D617761697420742E70726F76696465446F63756D656E7452616E676573466F726D617474696E67456469747328682C702C68';
wwv_flow_imp.g_varchar2_table(26266) := '2E676574466F726D617474696E674F7074696F6E7328292C752E746F6B656E297C7C5B5D3B632E747261636528225B666F726D61745D5B70726F76696465446F63756D656E7452616E6765466F726D617474696E6745646974735D2028726573706F6E73';
wwv_flow_imp.g_varchar2_table(26267) := '6529222C6E756C6C3D3D3D28613D742E657874656E73696F6E4964297C7C766F696420303D3D3D613F766F696420303A612E76616C75652C65292C622E707573682865297D656C73657B666F7228636F6E73742065206F662070297B696628752E746F6B';
wwv_flow_imp.g_varchar2_table(26268) := '656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E21303B622E70757368286177616974206D286529297D666F72286C657420653D303B653C702E6C656E6774683B2B2B6529666F72286C657420743D652B313B743C702E';
wwv_flow_imp.g_varchar2_table(26269) := '6C656E6774683B2B2B74297B696628752E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E21303B6966286628625B655D2C625B745D29297B636F6E7374206E3D72682E706C757352616E676528705B655D2C70';
wwv_flow_imp.g_varchar2_table(26270) := '5B745D292C693D6177616974206D286E293B702E73706C69636528742C31292C702E73706C69636528652C31292C702E70757368286E292C622E73706C69636528742C31292C622E73706C69636528652C31292C622E707573682869292C653D302C743D';
wwv_flow_imp.g_varchar2_table(26271) := '307D7D7D666F7228636F6E73742065206F662062297B696628752E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E21303B636F6E737420743D6177616974206C2E636F6D707574654D6F72654D696E696D616C';
wwv_flow_imp.g_varchar2_table(26272) := '456469747328682E7572692C65293B742626762E70757368282E2E2E74297D7D66696E616C6C797B752E646973706F736528297D696628303D3D3D762E6C656E6774682972657475726E21313B6966284A71286E292942312E65786563757465286E2C76';
wwv_flow_imp.g_varchar2_table(26273) := '2C2130292C6E2E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F7274286E2E676574506F736974696F6E28292C31293B656C73657B636F6E73745B7B72616E67653A657D5D3D762C743D6E65772061682865';
wwv_flow_imp.g_varchar2_table(26274) := '2E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293B682E70757368456469744F7065726174696F6E73285B745D2C762E6D61702828653D3E287B746578';
wwv_flow_imp.g_varchar2_table(26275) := '743A652E746578742C72616E67653A72682E6C69667428652E72616E6765292C666F7263654D6F76654D61726B6572733A21307D2929292C28653D3E7B666F7228636F6E73747B72616E67653A6E7D6F6620652969662872682E617265496E7465727365';
wwv_flow_imp.g_varchar2_table(26276) := '6374696E674F72546F756368696E67286E2C74292972657475726E5B6E6577206168286E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E295D3B726574';
wwv_flow_imp.g_varchar2_table(26277) := '75726E206E756C6C7D29297D72657475726E20642E706C61795369676E616C286F5A2E666F726D61742C7B75736572476573747572653A737D292C21307D6173796E632066756E6374696F6E20243128652C742C6E2C692C6F2C73297B636F6E73742072';
wwv_flow_imp.g_varchar2_table(26278) := '3D652E676574287563292C613D652E676574287878292C6C3D4A712874293F742E6765744D6F64656C28293A742C633D483128612E646F63756D656E74466F726D617474696E674564697450726F76696465722C612E646F63756D656E7452616E676546';
wwv_flow_imp.g_varchar2_table(26279) := '6F726D617474696E674564697450726F76696465722C6C292C643D61776169742057312E73656C65637428632C6C2C6E2C31293B64262628692E7265706F72742864292C617761697420722E696E766F6B6546756E6374696F6E2855312C642C742C6E2C';
wwv_flow_imp.g_varchar2_table(26280) := '6F2C7329297D6173796E632066756E6374696F6E20553128652C742C6E2C692C6F2C73297B636F6E737420723D652E676574287A5A292C613D652E67657428745A293B6C6574206C2C632C643B4A71286E293F286C3D6E2E6765744D6F64656C28292C63';
wwv_flow_imp.g_varchar2_table(26281) := '3D6E657720646B286E2C352C766F696420302C6F29293A286C3D6E2C633D6E657720686B286E2C6F29293B7472797B636F6E737420653D617761697420742E70726F76696465446F63756D656E74466F726D617474696E674564697473286C2C6C2E6765';
wwv_flow_imp.g_varchar2_table(26282) := '74466F726D617474696E674F7074696F6E7328292C632E746F6B656E293B696628643D617761697420722E636F6D707574654D6F72654D696E696D616C4564697473286C2E7572692C65292C632E746F6B656E2E697343616E63656C6C6174696F6E5265';
wwv_flow_imp.g_varchar2_table(26283) := '717565737465642972657475726E21307D66696E616C6C797B632E646973706F736528297D69662821647C7C303D3D3D642E6C656E6774682972657475726E21313B6966284A71286E292942312E65786563757465286E2C642C32213D3D69292C32213D';
wwv_flow_imp.g_varchar2_table(26284) := '3D6926266E2E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F7274286E2E676574506F736974696F6E28292C31293B656C73657B636F6E73745B7B72616E67653A657D5D3D642C743D6E657720616828652E';
wwv_flow_imp.g_varchar2_table(26285) := '73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293B6C2E70757368456469744F7065726174696F6E73285B745D2C642E6D61702828653D3E287B74657874';
wwv_flow_imp.g_varchar2_table(26286) := '3A652E746578742C72616E67653A72682E6C69667428652E72616E6765292C666F7263654D6F76654D61726B6572733A21307D2929292C28653D3E7B666F7228636F6E73747B72616E67653A6E7D6F6620652969662872682E617265496E746572736563';
wwv_flow_imp.g_varchar2_table(26287) := '74696E674F72546F756368696E67286E2C74292972657475726E5B6E6577206168286E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E295D3B72657475';
wwv_flow_imp.g_varchar2_table(26288) := '726E206E756C6C7D29297D72657475726E20612E706C61795369676E616C286F5A2E666F726D61742C7B75736572476573747572653A737D292C21307D66756E6374696F6E204B3128652C742C6E2C692C6F2C732C72297B636F6E737420613D742E6F6E';
wwv_flow_imp.g_varchar2_table(26289) := '54797065466F726D617474696E674564697450726F76696465722E6F726465726564286E293B72657475726E20303D3D3D612E6C656E6774687C7C615B305D2E6175746F466F726D617454726967676572436861726163746572732E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(26290) := '6F293C303F50726F6D6973652E7265736F6C766528766F69642030293A50726F6D6973652E7265736F6C766528615B305D2E70726F766964654F6E54797065466F726D617474696E674564697473286E2C692C6F2C732C7229292E636174636828456529';
wwv_flow_imp.g_varchar2_table(26291) := '2E7468656E2828743D3E652E636F6D707574654D6F72654D696E696D616C4564697473286E2E7572692C742929297D57312E5F73656C6563746F72733D6E65772067742C6B632E7265676973746572436F6D6D616E6428225F65786563757465466F726D';
wwv_flow_imp.g_varchar2_table(26292) := '617452616E676550726F7669646572222C286173796E632066756E6374696F6E28652C2E2E2E74297B636F6E73745B6E2C692C6F5D3D743B796C284E6F2E6973557269286E29292C796C2872682E69734952616E6765286929293B636F6E737420733D65';
wwv_flow_imp.g_varchar2_table(26293) := '2E676574287663292C723D652E676574287A5A292C613D652E676574287878292C6C3D617761697420732E6372656174654D6F64656C5265666572656E6365286E293B7472797B72657475726E206173796E632066756E6374696F6E28652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(26294) := '2C6F2C73297B636F6E737420723D742E646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722E6F726465726564286E293B666F7228636F6E73742074206F662072297B636F6E737420723D61776169742050726F6D69';
wwv_flow_imp.g_varchar2_table(26295) := '73652E7265736F6C766528742E70726F76696465446F63756D656E7452616E6765466F726D617474696E674564697473286E2C692C6F2C7329292E6361746368284565293B6966286A682872292972657475726E20617761697420652E636F6D70757465';
wwv_flow_imp.g_varchar2_table(26296) := '4D6F72654D696E696D616C4564697473286E2E7572692C72297D7D28722C612C6C2E6F626A6563742E74657874456469746F724D6F64656C2C72682E6C6966742869292C6F2C4D742E4E6F6E65297D66696E616C6C797B6C2E646973706F736528297D7D';
wwv_flow_imp.g_varchar2_table(26297) := '29292C6B632E7265676973746572436F6D6D616E6428225F65786563757465466F726D6174446F63756D656E7450726F7669646572222C286173796E632066756E6374696F6E28652C2E2E2E74297B636F6E73745B6E2C695D3D743B796C284E6F2E6973';
wwv_flow_imp.g_varchar2_table(26298) := '557269286E29293B636F6E7374206F3D652E676574287663292C733D652E676574287A5A292C723D652E676574287878292C613D6177616974206F2E6372656174654D6F64656C5265666572656E6365286E293B7472797B72657475726E206173796E63';
wwv_flow_imp.g_varchar2_table(26299) := '2066756E6374696F6E28652C742C6E2C692C6F297B636F6E737420733D483128742E646F63756D656E74466F726D617474696E674564697450726F76696465722C742E646F63756D656E7452616E6765466F726D617474696E674564697450726F766964';
wwv_flow_imp.g_varchar2_table(26300) := '65722C6E293B666F7228636F6E73742074206F662073297B636F6E737420733D61776169742050726F6D6973652E7265736F6C766528742E70726F76696465446F63756D656E74466F726D617474696E674564697473286E2C692C6F29292E6361746368';
wwv_flow_imp.g_varchar2_table(26301) := '284565293B6966286A682873292972657475726E20617761697420652E636F6D707574654D6F72654D696E696D616C4564697473286E2E7572692C73297D7D28732C722C612E6F626A6563742E74657874456469746F724D6F64656C2C692C4D742E4E6F';
wwv_flow_imp.g_varchar2_table(26302) := '6E65297D66696E616C6C797B612E646973706F736528297D7D29292C6B632E7265676973746572436F6D6D616E6428225F65786563757465466F726D61744F6E5479706550726F7669646572222C286173796E632066756E6374696F6E28652C2E2E2E74';
wwv_flow_imp.g_varchar2_table(26303) := '297B636F6E73745B6E2C692C6F2C735D3D743B796C284E6F2E6973557269286E29292C796C286D632E697349506F736974696F6E286929292C796C2822737472696E67223D3D747970656F66206F293B636F6E737420723D652E676574287663292C613D';
wwv_flow_imp.g_varchar2_table(26304) := '652E676574287A5A292C6C3D652E676574287878292C633D617761697420722E6372656174654D6F64656C5265666572656E6365286E293B7472797B72657475726E204B3128612C6C2C632E6F626A6563742E74657874456469746F724D6F64656C2C6D';
wwv_flow_imp.g_varchar2_table(26305) := '632E6C6966742869292C6F2C732C4D742E4E6F6E65297D66696E616C6C797B632E646973706F736528297D7D29293B7661722047313D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D73';
wwv_flow_imp.g_varchar2_table(26306) := '3C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(26307) := '6F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C33';
wwv_flow_imp.g_varchar2_table(26308) := '3F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C51313D66756E6374696F6E28652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(26309) := '6E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742059313D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F656469746F723D652C746869732E5F6C616E677561676546656174757265735365';
wwv_flow_imp.g_varchar2_table(26310) := '72766963653D742C746869732E5F776F726B6572536572766963653D6E2C746869732E5F6163636573736962696C6974795369676E616C536572766963653D692C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F73657373';
wwv_flow_imp.g_varchar2_table(26311) := '696F6E446973706F7361626C65733D6E65772061742C746869732E5F646973706F7361626C65732E61646428742E6F6E54797065466F726D617474696E674564697450726F76696465722E6F6E4469644368616E676528746869732E5F7570646174652C';
wwv_flow_imp.g_varchar2_table(26312) := '7468697329292C746869732E5F646973706F7361626C65732E61646428652E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F75706461746528292929292C746869732E5F646973706F7361626C65732E61646428652E6F6E446964';
wwv_flow_imp.g_varchar2_table(26313) := '4368616E67654D6F64656C4C616E6775616765282828293D3E746869732E5F75706461746528292929292C746869732E5F646973706F7361626C65732E61646428652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E68';
wwv_flow_imp.g_varchar2_table(26314) := '61734368616E676564283536292626746869732E5F75706461746528297D2929292C746869732E5F75706461746528297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F73657373696F6E';
wwv_flow_imp.g_varchar2_table(26315) := '446973706F7361626C65732E646973706F736528297D5F75706461746528297B696628746869732E5F73657373696F6E446973706F7361626C65732E636C65617228292C21746869732E5F656469746F722E6765744F7074696F6E283536292972657475';
wwv_flow_imp.g_varchar2_table(26316) := '726E3B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C5B745D3D746869732E5F6C616E6775616765466561747572657353657276';
wwv_flow_imp.g_varchar2_table(26317) := '6963652E6F6E54797065466F726D617474696E674564697450726F76696465722E6F7264657265642865293B69662821747C7C21742E6175746F466F726D617454726967676572436861726163746572732972657475726E3B636F6E7374206E3D6E6577';
wwv_flow_imp.g_varchar2_table(26318) := '204B793B666F7228636F6E73742065206F6620742E6175746F466F726D61745472696767657243686172616374657273296E2E61646428652E63686172436F64654174283029293B746869732E5F73657373696F6E446973706F7361626C65732E616464';
wwv_flow_imp.g_varchar2_table(26319) := '28746869732E5F656469746F722E6F6E446964547970652828653D3E7B636F6E737420743D652E63686172436F6465417428652E6C656E6774682D31293B6E2E6861732874292626746869732E5F7472696767657228537472696E672E66726F6D436861';
wwv_flow_imp.g_varchar2_table(26320) := '72436F6465287429297D2929297D5F747269676765722865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B696628746869732E5F656469746F722E67657453656C656374696F6E7328292E6C656E6774683E';
wwv_flow_imp.g_varchar2_table(26321) := '317C7C21746869732E5F656469746F722E67657453656C656374696F6E28292E6973456D70747928292972657475726E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292C6E3D746869732E5F656469746F722E67657450';
wwv_flow_imp.g_varchar2_table(26322) := '6F736974696F6E28292C693D6E6577204E742C6F3D746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B696628652E6973466C7573682972657475726E20692E63616E63656C28292C766F6964206F';
wwv_flow_imp.g_varchar2_table(26323) := '2E646973706F736528293B666F72286C657420743D302C733D652E6368616E6765732E6C656E6774683B743C733B742B2B29696628652E6368616E6765735B745D2E72616E67652E656E644C696E654E756D6265723C3D6E2E6C696E654E756D62657229';
wwv_flow_imp.g_varchar2_table(26324) := '72657475726E20692E63616E63656C28292C766F6964206F2E646973706F736528297D29293B4B3128746869732E5F776F726B6572536572766963652C746869732E5F6C616E67756167654665617475726573536572766963652C742C6E2C652C742E67';
wwv_flow_imp.g_varchar2_table(26325) := '6574466F726D617474696E674F7074696F6E7328292C692E746F6B656E292E7468656E2828653D3E7B692E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465647C7C6A68286529262628746869732E5F6163636573736962696C6974';
wwv_flow_imp.g_varchar2_table(26326) := '795369676E616C536572766963652E706C61795369676E616C286F5A2E666F726D61742C7B75736572476573747572653A21317D292C42312E6578656375746528746869732E5F656469746F722C652C213029297D29292E66696E616C6C79282828293D';
wwv_flow_imp.g_varchar2_table(26327) := '3E7B6F2E646973706F736528297D29297D7D3B59312E49443D22656469746F722E636F6E747269622E6175746F466F726D6174222C59313D4731285B513128312C7878292C513128322C7A5A292C513128332C745A295D2C5931293B6C6574205A313D63';
wwv_flow_imp.g_varchar2_table(26328) := '6C6173737B636F6E7374727563746F7228652C742C6E297B746869732E656469746F723D652C746869732E5F6C616E67756167654665617475726573536572766963653D742C746869732E5F696E7374616E74696174696F6E536572766963653D6E2C74';
wwv_flow_imp.g_varchar2_table(26329) := '6869732E5F63616C6C4F6E446973706F73653D6E65772061742C746869732E5F63616C6C4F6E4D6F64656C3D6E65772061742C746869732E5F63616C6C4F6E446973706F73652E61646428652E6F6E4469644368616E6765436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(26330) := '6E282828293D3E746869732E5F75706461746528292929292C746869732E5F63616C6C4F6E446973706F73652E61646428652E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F75706461746528292929292C746869732E5F63616C';
wwv_flow_imp.g_varchar2_table(26331) := '6C4F6E446973706F73652E61646428652E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E746869732E5F75706461746528292929292C746869732E5F63616C6C4F6E446973706F73652E61646428742E646F63756D656E7452';
wwv_flow_imp.g_varchar2_table(26332) := '616E6765466F726D617474696E674564697450726F76696465722E6F6E4469644368616E676528746869732E5F7570646174652C7468697329297D646973706F736528297B746869732E5F63616C6C4F6E446973706F73652E646973706F736528292C74';
wwv_flow_imp.g_varchar2_table(26333) := '6869732E5F63616C6C4F6E4D6F64656C2E646973706F736528297D5F75706461746528297B746869732E5F63616C6C4F6E4D6F64656C2E636C65617228292C746869732E656469746F722E6765744F7074696F6E283535292626746869732E656469746F';
wwv_flow_imp.g_varchar2_table(26334) := '722E6861734D6F64656C28292626746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722E68617328746869732E656469746F722E6765744D';
wwv_flow_imp.g_varchar2_table(26335) := '6F64656C2829292626746869732E5F63616C6C4F6E4D6F64656C2E61646428746869732E656469746F722E6F6E44696450617374652828287B72616E67653A657D293D3E746869732E5F747269676765722865292929297D5F747269676765722865297B';
wwv_flow_imp.g_varchar2_table(26336) := '746869732E656469746F722E6861734D6F64656C2829262628746869732E656469746F722E67657453656C656374696F6E7328292E6C656E6774683E317C7C746869732E5F696E7374616E74696174696F6E536572766963652E696E766F6B6546756E63';
wwv_flow_imp.g_varchar2_table(26337) := '74696F6E286A312C746869732E656469746F722C652C322C43452E4E6F6E652C4D742E4E6F6E652C2131292E6361746368286B6529297D7D3B5A312E49443D22656469746F722E636F6E747269622E666F726D61744F6E5061737465222C5A313D473128';
wwv_flow_imp.g_varchar2_table(26338) := '5B513128312C7878292C513128322C7563295D2C5A31292C4A642859312E49442C59312C32292C4A64285A312E49442C5A312C32292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A2265';
wwv_flow_imp.g_varchar2_table(26339) := '6469746F722E616374696F6E2E666F726D6174446F63756D656E74222C6C6162656C3A6228302C22466F726D617420446F63756D656E7422292C616C6961733A22466F726D617420446F63756D656E74222C707265636F6E646974696F6E3A57632E616E';
wwv_flow_imp.g_varchar2_table(26340) := '64286C682E6E6F74496E436F6D706F73697465456469746F722C6C682E7772697461626C652C6C682E686173446F63756D656E74466F726D617474696E6750726F7669646572292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874';
wwv_flow_imp.g_varchar2_table(26341) := '466F6375732C7072696D6172793A313537322C6C696E75783A7B7072696D6172793A333131317D2C7765696768743A3130307D2C636F6E746578744D656E754F7074733A7B67726F75703A22315F6D6F64696669636174696F6E222C6F726465723A312E';
wwv_flow_imp.g_varchar2_table(26342) := '337D7D297D6173796E632072756E28652C74297B696628742E6861734D6F64656C2829297B636F6E7374206E3D652E676574287563292C693D652E676574285345293B617761697420692E73686F775768696C65286E2E696E766F6B6546756E6374696F';
wwv_flow_imp.g_varchar2_table(26343) := '6E2824312C742C312C43452E4E6F6E652C4D742E4E6F6E652C2130292C323530297D7D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F72';
wwv_flow_imp.g_varchar2_table(26344) := '6D617453656C656374696F6E222C6C6162656C3A6228302C22466F726D61742053656C656374696F6E22292C616C6961733A22466F726D61742053656C656374696F6E222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C65';
wwv_flow_imp.g_varchar2_table(26345) := '2C6C682E686173446F63756D656E7453656C656374696F6E466F726D617474696E6750726F7669646572292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303834292C';
wwv_flow_imp.g_varchar2_table(26346) := '7765696768743A3130307D2C636F6E746578744D656E754F7074733A7B7768656E3A6C682E6861734E6F6E456D70747953656C656374696F6E2C67726F75703A22315F6D6F64696669636174696F6E222C6F726465723A312E33317D7D297D6173796E63';
wwv_flow_imp.g_varchar2_table(26347) := '2072756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E3D652E676574287563292C693D742E6765744D6F64656C28292C6F3D742E67657453656C656374696F6E7328292E6D61702828653D3E652E697345';
wwv_flow_imp.g_varchar2_table(26348) := '6D70747928293F6E657720726828652E73746172744C696E654E756D6265722C312C652E73746172744C696E654E756D6265722C692E6765744C696E654D6178436F6C756D6E28652E73746172744C696E654E756D62657229293A6529292C733D652E67';
wwv_flow_imp.g_varchar2_table(26349) := '6574285345293B617761697420732E73686F775768696C65286E2E696E766F6B6546756E6374696F6E286A312C742C6F2C312C43452E4E6F6E652C4D742E4E6F6E652C2130292C323530297D7D292C6B632E7265676973746572436F6D6D616E64282265';
wwv_flow_imp.g_varchar2_table(26350) := '6469746F722E616374696F6E2E666F726D6174222C286173796E6320653D3E7B636F6E737420743D652E676574286763292E676574466F6375736564436F6465456469746F7228293B69662821747C7C21742E6861734D6F64656C28292972657475726E';
wwv_flow_imp.g_varchar2_table(26351) := '3B636F6E7374206E3D652E676574287863293B742E67657453656C656374696F6E28292E6973456D70747928293F6177616974206E2E65786563757465436F6D6D616E642822656469746F722E616374696F6E2E666F726D6174446F63756D656E742229';
wwv_flow_imp.g_varchar2_table(26352) := '3A6177616974206E2E65786563757465436F6D6D616E642822656469746F722E616374696F6E2E666F726D617453656C656374696F6E22297D29293B7661722058313D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E';
wwv_flow_imp.g_varchar2_table(26353) := '74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C6563742626226675';
wwv_flow_imp.g_varchar2_table(26354) := '6E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D65';
wwv_flow_imp.g_varchar2_table(26355) := '5B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C4A313D66756E637469';
wwv_flow_imp.g_varchar2_table(26356) := '6F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732065327B636F6E7374727563746F7228652C742C6E297B746869732E6D61726B65723D652C746869732E696E6465783D742C746869732E';
wwv_flow_imp.g_varchar2_table(26357) := '746F74616C3D6E7D7D6C65742074323D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F6D61726B6572536572766963653D742C746869732E5F636F6E666967536572766963653D6E2C746869732E5F6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(26358) := '67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F646973706F61626C65733D6E65772061742C746869732E5F6D61726B6572733D5B5D2C746869732E5F6E65';
wwv_flow_imp.g_varchar2_table(26359) := '78744964783D2D312C4E6F2E69735572692865293F746869732E5F7265736F7572636546696C7465723D743D3E742E746F537472696E6728293D3D3D652E746F537472696E6728293A65262628746869732E5F7265736F7572636546696C7465723D6529';
wwv_flow_imp.g_varchar2_table(26360) := '3B636F6E737420693D746869732E5F636F6E666967536572766963652E67657456616C7565282270726F626C656D732E736F72744F7264657222292C6F3D28652C74293D3E7B6C6574206E3D626928652E7265736F757263652E746F537472696E672829';
wwv_flow_imp.g_varchar2_table(26361) := '2C742E7265736F757263652E746F537472696E672829293B72657475726E20303D3D3D6E2626286E3D22706F736974696F6E223D3D3D693F72682E636F6D7061726552616E6765735573696E6753746172747328652C74297C7C5A4D2E636F6D70617265';
wwv_flow_imp.g_varchar2_table(26362) := '28652E73657665726974792C742E7365766572697479293A5A4D2E636F6D7061726528652E73657665726974792C742E7365766572697479297C7C72682E636F6D7061726552616E6765735573696E6753746172747328652C7429292C6E7D2C733D2829';
wwv_flow_imp.g_varchar2_table(26363) := '3D3E7B746869732E5F6D61726B6572733D746869732E5F6D61726B6572536572766963652E72656164287B7265736F757263653A4E6F2E69735572692865293F653A766F696420302C736576657269746965733A5A4D2E4572726F727C5A4D2E5761726E';
wwv_flow_imp.g_varchar2_table(26364) := '696E677C5A4D2E496E666F7D292C2266756E6374696F6E223D3D747970656F662065262628746869732E5F6D61726B6572733D746869732E5F6D61726B6572732E66696C7465722828653D3E746869732E5F7265736F7572636546696C74657228652E72';
wwv_flow_imp.g_varchar2_table(26365) := '65736F75726365292929292C746869732E5F6D61726B6572732E736F7274286F297D3B7328292C746869732E5F646973706F61626C65732E61646428742E6F6E4D61726B65724368616E6765642828653D3E7B746869732E5F7265736F7572636546696C';
wwv_flow_imp.g_varchar2_table(26366) := '746572262621652E736F6D652828653D3E746869732E5F7265736F7572636546696C74657228652929297C7C287328292C746869732E5F6E6578744964783D2D312C746869732E5F6F6E4469644368616E67652E666972652829297D2929297D64697370';
wwv_flow_imp.g_varchar2_table(26367) := '6F736528297B746869732E5F646973706F61626C65732E646973706F736528292C746869732E5F6F6E4469644368616E67652E646973706F736528297D6D6174636865732865297B72657475726E21746869732E5F7265736F7572636546696C74657226';
wwv_flow_imp.g_varchar2_table(26368) := '2621657C7C212821746869732E5F7265736F7572636546696C7465727C7C2165292626746869732E5F7265736F7572636546696C7465722865297D6765742073656C656374656428297B636F6E737420653D746869732E5F6D61726B6572735B74686973';
wwv_flow_imp.g_varchar2_table(26369) := '2E5F6E6578744964785D3B72657475726E206526266E657720653228652C746869732E5F6E6578744964782B312C746869732E5F6D61726B6572732E6C656E677468297D5F696E697449647828652C742C6E297B6C657420693D21312C6F3D746869732E';
wwv_flow_imp.g_varchar2_table(26370) := '5F6D61726B6572732E66696E64496E6465782828743D3E742E7265736F757263652E746F537472696E6728293D3D3D652E7572692E746F537472696E67282929293B6F3C302626286F3D4F6828746869732E5F6D61726B6572732C7B7265736F75726365';
wwv_flow_imp.g_varchar2_table(26371) := '3A652E7572697D2C2828652C74293D3E626928652E7265736F757263652E746F537472696E6728292C742E7265736F757263652E746F537472696E6728292929292C6F3C302626286F3D7E6F29293B666F72286C6574206E3D6F3B6E3C746869732E5F6D';
wwv_flow_imp.g_varchar2_table(26372) := '61726B6572732E6C656E6774683B6E2B2B297B6C6574206F3D72682E6C69667428746869732E5F6D61726B6572735B6E5D293B6966286F2E6973456D7074792829297B636F6E737420743D652E676574576F72644174506F736974696F6E286F2E676574';
wwv_flow_imp.g_varchar2_table(26373) := '5374617274506F736974696F6E2829293B742626286F3D6E6577207268286F2E73746172744C696E654E756D6265722C742E7374617274436F6C756D6E2C6F2E73746172744C696E654E756D6265722C742E656E64436F6C756D6E29297D696628742626';
wwv_flow_imp.g_varchar2_table(26374) := '286F2E636F6E7461696E73506F736974696F6E2874297C7C742E69734265666F72654F72457175616C286F2E6765745374617274506F736974696F6E28292929297B746869732E5F6E6578744964783D6E2C693D21303B627265616B7D69662874686973';
wwv_flow_imp.g_varchar2_table(26375) := '2E5F6D61726B6572735B6E5D2E7265736F757263652E746F537472696E672829213D3D652E7572692E746F537472696E67282929627265616B7D697C7C28746869732E5F6E6578744964783D6E3F303A746869732E5F6D61726B6572732E6C656E677468';
wwv_flow_imp.g_varchar2_table(26376) := '2D31292C746869732E5F6E6578744964783C30262628746869732E5F6E6578744964783D746869732E5F6D61726B6572732E6C656E6774682D31297D7265736574496E64657828297B746869732E5F6E6578744964783D2D317D6D6F766528652C742C6E';
wwv_flow_imp.g_varchar2_table(26377) := '297B696628303D3D3D746869732E5F6D61726B6572732E6C656E6774682972657475726E21313B636F6E737420693D746869732E5F6E6578744964783B72657475726E2D313D3D3D746869732E5F6E6578744964783F746869732E5F696E697449647828';
wwv_flow_imp.g_varchar2_table(26378) := '742C6E2C65293A653F746869732E5F6E6578744964783D28746869732E5F6E6578744964782B312925746869732E5F6D61726B6572732E6C656E6774683A657C7C28746869732E5F6E6578744964783D28746869732E5F6E6578744964782D312B746869';
wwv_flow_imp.g_varchar2_table(26379) := '732E5F6D61726B6572732E6C656E6774682925746869732E5F6D61726B6572732E6C656E677468292C69213D3D746869732E5F6E6578744964787D66696E6428652C74297B6C6574206E3D746869732E5F6D61726B6572732E66696E64496E6465782828';
wwv_flow_imp.g_varchar2_table(26380) := '743D3E742E7265736F757263652E746F537472696E6728293D3D3D652E746F537472696E67282929293B69662821286E3C302929666F72283B6E3C746869732E5F6D61726B6572732E6C656E6774683B6E2B2B2969662872682E636F6E7461696E73506F';
wwv_flow_imp.g_varchar2_table(26381) := '736974696F6E28746869732E5F6D61726B6572735B6E5D2C74292972657475726E206E657720653228746869732E5F6D61726B6572735B6E5D2C6E2B312C746869732E5F6D61726B6572732E6C656E677468297D7D3B74323D5831285B4A3128312C4A4D';
wwv_flow_imp.g_varchar2_table(26382) := '292C4A3128322C6670295D2C7432293B636F6E7374206E323D70632822494D61726B65724E617669676174696F6E5365727669636522293B6C65742069323D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F6D61726B65725365';
wwv_flow_imp.g_varchar2_table(26383) := '72766963653D652C746869732E5F636F6E666967536572766963653D742C746869732E5F70726F76696465723D6E65772067747D6765744D61726B65724C6973742865297B666F7228636F6E73742074206F6620746869732E5F70726F7669646572297B';
wwv_flow_imp.g_varchar2_table(26384) := '636F6E7374206E3D742E6765744D61726B65724C6973742865293B6966286E2972657475726E206E7D72657475726E206E657720743228652C746869732E5F6D61726B6572536572766963652C746869732E5F636F6E66696753657276696365297D7D3B';
wwv_flow_imp.g_varchar2_table(26385) := '69323D5831285B4A3128302C4A4D292C4A3128312C6670295D2C6932292C7870286E322C69322C31293B766172206F323D6E2831373838292C73323D7B7D3B73322E7374796C655461675472616E73666F726D3D6A7228292C73322E7365744174747269';
wwv_flow_imp.g_varchar2_table(26386) := '62757465733D567228292C73322E696E736572743D467228292E62696E64286E756C6C2C226865616422292C73322E646F6D4150493D4F7228292C73322E696E736572745374796C65456C656D656E743D487228292C4E722829286F322E412C7332292C';
wwv_flow_imp.g_varchar2_table(26387) := '6F322E4126266F322E412E6C6F63616C7326266F322E412E6C6F63616C733B7661722072322C61323D6E2833373734292C6C323D7B7D3B6C322E7374796C655461675472616E73666F726D3D6A7228292C6C322E736574417474726962757465733D5672';
wwv_flow_imp.g_varchar2_table(26388) := '28292C6C322E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6C322E646F6D4150493D4F7228292C6C322E696E736572745374796C65456C656D656E743D487228292C4E7228292861322E412C6C32292C61322E4126266132';
wwv_flow_imp.g_varchar2_table(26389) := '2E412E6C6F63616C73262661322E412E6C6F63616C732C66756E6374696F6E2865297B652E636C6173734E616D653D66756E6374696F6E2865297B7377697463682865297B636173652069442E49676E6F72653A72657475726E2273657665726974792D';
wwv_flow_imp.g_varchar2_table(26390) := '69676E6F726520222B546C2E6173436C6173734E616D65284C6C2E696E666F293B636173652069442E496E666F3A72657475726E20546C2E6173436C6173734E616D65284C6C2E696E666F293B636173652069442E5761726E696E673A72657475726E20';
wwv_flow_imp.g_varchar2_table(26391) := '546C2E6173436C6173734E616D65284C6C2E7761726E696E67293B636173652069442E4572726F723A72657475726E20546C2E6173436C6173734E616D65284C6C2E6572726F72293B64656661756C743A72657475726E22227D7D7D2872327C7C287232';
wwv_flow_imp.g_varchar2_table(26392) := '3D7B7D29293B7661722063322C64323D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732068327B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F';
wwv_flow_imp.g_varchar2_table(26393) := '6F70656E6572536572766963653D692C746869732E5F6C6162656C536572766963653D6F2C746869732E5F6C696E65733D302C746869732E5F6C6F6E676573744C696E654C656E6774683D302C746869732E5F72656C61746564446961676E6F73746963';
wwv_flow_imp.g_varchar2_table(26394) := '733D6E6577205765616B4D61702C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F656469746F723D743B636F6E737420733D646F63756D656E742E637265617465456C656D656E74282264697622293B732E636C6173734E';
wwv_flow_imp.g_varchar2_table(26395) := '616D653D226465736372697074696F6E636F6E7461696E6572222C746869732E5F6D657373616765426C6F636B3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6D657373616765426C6F636B2E636C617373';
wwv_flow_imp.g_varchar2_table(26396) := '4C6973742E61646428226D65737361676522292C746869732E5F6D657373616765426C6F636B2E7365744174747269627574652822617269612D6C697665222C2261737365727469766522292C746869732E5F6D657373616765426C6F636B2E73657441';
wwv_flow_imp.g_varchar2_table(26397) := '74747269627574652822726F6C65222C22616C65727422292C732E617070656E644368696C6428746869732E5F6D657373616765426C6F636B292C746869732E5F72656C61746564426C6F636B3D646F63756D656E742E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(26398) := '282264697622292C732E617070656E644368696C6428746869732E5F72656C61746564426C6F636B292C746869732E5F646973706F7361626C65732E61646428797328746869732E5F72656C61746564426C6F636B2C22636C69636B222C28653D3E7B65';
wwv_flow_imp.g_varchar2_table(26399) := '2E70726576656E7444656661756C7428293B636F6E737420743D746869732E5F72656C61746564446961676E6F73746963732E67657428652E746172676574293B7426266E2874297D2929292C746869732E5F7363726F6C6C61626C653D6E6577207554';
wwv_flow_imp.g_varchar2_table(26400) := '28732C7B686F72697A6F6E74616C3A312C766572746963616C3A312C757365536861646F77733A21312C686F72697A6F6E74616C5363726F6C6C62617253697A653A362C766572746963616C5363726F6C6C62617253697A653A367D292C652E61707065';
wwv_flow_imp.g_varchar2_table(26401) := '6E644368696C6428746869732E5F7363726F6C6C61626C652E676574446F6D4E6F64652829292C746869732E5F646973706F7361626C65732E61646428746869732E5F7363726F6C6C61626C652E6F6E5363726F6C6C2828653D3E7B732E7374796C652E';
wwv_flow_imp.g_varchar2_table(26402) := '6C6566743D602D247B652E7363726F6C6C4C6566747D7078602C732E7374796C652E746F703D602D247B652E7363726F6C6C546F707D7078607D2929292C746869732E5F646973706F7361626C65732E61646428746869732E5F7363726F6C6C61626C65';
wwv_flow_imp.g_varchar2_table(26403) := '297D646973706F736528297B6F7428746869732E5F646973706F7361626C6573297D7570646174652865297B636F6E73747B736F757263653A742C6D6573736167653A6E2C72656C61746564496E666F726D6174696F6E3A692C636F64653A6F7D3D653B';
wwv_flow_imp.g_varchar2_table(26404) := '6C657420733D28286E756C6C3D3D743F766F696420303A742E6C656E677468297C7C30292B323B6F262628732B3D22737472696E67223D3D747970656F66206F3F6F2E6C656E6774683A6F2E76616C75652E6C656E677468293B636F6E737420723D6769';
wwv_flow_imp.g_varchar2_table(26405) := '286E293B746869732E5F6C696E65733D722E6C656E6774682C746869732E5F6C6F6E676573744C696E654C656E6774683D303B666F7228636F6E73742065206F66207229746869732E5F6C6F6E676573744C696E654C656E6774683D4D6174682E6D6178';
wwv_flow_imp.g_varchar2_table(26406) := '28652E6C656E6774682B732C746869732E5F6C6F6E676573744C696E654C656E677468293B667328746869732E5F6D657373616765426C6F636B292C746869732E5F6D657373616765426C6F636B2E7365744174747269627574652822617269612D6C61';
wwv_flow_imp.g_varchar2_table(26407) := '62656C222C746869732E676574417269614C6162656C286529292C746869732E5F656469746F722E6170706C79466F6E74496E666F28746869732E5F6D657373616765426C6F636B293B6C657420613D746869732E5F6D657373616765426C6F636B3B66';
wwv_flow_imp.g_varchar2_table(26408) := '6F7228636F6E73742065206F66207229613D646F63756D656E742E637265617465456C656D656E74282264697622292C612E696E6E6572546578743D652C22223D3D3D65262628612E7374796C652E6865696768743D746869732E5F6D65737361676542';
wwv_flow_imp.g_varchar2_table(26409) := '6C6F636B2E7374796C652E6C696E65486569676874292C746869732E5F6D657373616765426C6F636B2E617070656E644368696C642861293B696628747C7C6F297B636F6E737420653D646F63756D656E742E637265617465456C656D656E7428227370';
wwv_flow_imp.g_varchar2_table(26410) := '616E22293B696628652E636C6173734C6973742E616464282264657461696C7322292C612E617070656E644368696C642865292C74297B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E7428227370616E22293B6E2E696E6E65';
wwv_flow_imp.g_varchar2_table(26411) := '72546578743D742C6E2E636C6173734C6973742E6164642822736F7572636522292C652E617070656E644368696C64286E297D6966286F2969662822737472696E67223D3D747970656F66206F297B636F6E737420743D646F63756D656E742E63726561';
wwv_flow_imp.g_varchar2_table(26412) := '7465456C656D656E7428227370616E22293B742E696E6E6572546578743D6028247B6F7D29602C742E636C6173734C6973742E6164642822636F646522292C652E617070656E644368696C642874297D656C736520746869732E5F636F64654C696E6B3D';
wwv_flow_imp.g_varchar2_table(26413) := '62722822612E636F64652D6C696E6B22292C746869732E5F636F64654C696E6B2E736574417474726962757465282268726566222C60247B6F2E7461726765742E746F537472696E6728297D60292C746869732E5F636F64654C696E6B2E6F6E636C6963';
wwv_flow_imp.g_varchar2_table(26414) := '6B3D653D3E7B746869732E5F6F70656E6572536572766963652E6F70656E286F2E7461726765742C7B616C6C6F77436F6D6D616E64733A21307D292C652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28297D2C';
wwv_flow_imp.g_varchar2_table(26415) := '757228746869732E5F636F64654C696E6B2C627228227370616E2229292E696E6E6572546578743D6F2E76616C75652C652E617070656E644368696C6428746869732E5F636F64654C696E6B297D696628667328746869732E5F72656C61746564426C6F';
wwv_flow_imp.g_varchar2_table(26416) := '636B292C746869732E5F656469746F722E6170706C79466F6E74496E666F28746869732E5F72656C61746564426C6F636B292C6A68286929297B636F6E737420653D746869732E5F72656C61746564426C6F636B2E617070656E644368696C6428646F63';
wwv_flow_imp.g_varchar2_table(26417) := '756D656E742E637265617465456C656D656E7428226469762229293B652E7374796C652E70616464696E67546F703D60247B4D6174682E666C6F6F72282E36362A746869732E5F656469746F722E6765744F7074696F6E28363729297D7078602C746869';
wwv_flow_imp.g_varchar2_table(26418) := '732E5F6C696E65732B3D313B666F7228636F6E73742074206F662069297B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E74282264697622292C693D646F63756D656E742E637265617465456C656D656E7428226122293B692E';
wwv_flow_imp.g_varchar2_table(26419) := '636C6173734C6973742E616464282266696C656E616D6522292C692E696E6E6572546578743D60247B746869732E5F6C6162656C536572766963652E676574557269426173656E616D654C6162656C28742E7265736F75726365297D28247B742E737461';
wwv_flow_imp.g_varchar2_table(26420) := '72744C696E654E756D6265727D2C20247B742E7374617274436F6C756D6E7D293A20602C692E7469746C653D746869732E5F6C6162656C536572766963652E6765745572694C6162656C28742E7265736F75726365292C746869732E5F72656C61746564';
wwv_flow_imp.g_varchar2_table(26421) := '446961676E6F73746963732E73657428692C74293B636F6E7374206F3D646F63756D656E742E637265617465456C656D656E7428227370616E22293B6F2E696E6E6572546578743D742E6D6573736167652C6E2E617070656E644368696C642869292C6E';
wwv_flow_imp.g_varchar2_table(26422) := '2E617070656E644368696C64286F292C746869732E5F6C696E65732B3D312C652E617070656E644368696C64286E297D7D636F6E7374206C3D746869732E5F656469746F722E6765744F7074696F6E283530292C633D4D6174682E6365696C286C2E7479';
wwv_flow_imp.g_varchar2_table(26423) := '706963616C46756C6C776964746843686172616374657257696474682A746869732E5F6C6F6E676573744C696E654C656E6774682A2E3735292C643D6C2E6C696E654865696768742A746869732E5F6C696E65733B746869732E5F7363726F6C6C61626C';
wwv_flow_imp.g_varchar2_table(26424) := '652E7365745363726F6C6C44696D656E73696F6E73287B7363726F6C6C57696474683A632C7363726F6C6C4865696768743A647D297D6C61796F757428652C74297B746869732E5F7363726F6C6C61626C652E676574446F6D4E6F646528292E7374796C';
wwv_flow_imp.g_varchar2_table(26425) := '652E6865696768743D60247B657D7078602C746869732E5F7363726F6C6C61626C652E676574446F6D4E6F646528292E7374796C652E77696474683D60247B747D7078602C746869732E5F7363726F6C6C61626C652E7365745363726F6C6C44696D656E';
wwv_flow_imp.g_varchar2_table(26426) := '73696F6E73287B77696474683A742C6865696768743A657D297D676574486569676874496E4C696E657328297B72657475726E204D6174682E6D696E2831372C746869732E5F6C696E6573297D676574417269614C6162656C2865297B6C657420743D22';
wwv_flow_imp.g_varchar2_table(26427) := '223B73776974636828652E7365766572697479297B63617365205A4D2E4572726F723A743D6228302C224572726F7222293B627265616B3B63617365205A4D2E5761726E696E673A743D6228302C225761726E696E6722293B627265616B3B6361736520';
wwv_flow_imp.g_varchar2_table(26428) := '5A4D2E496E666F3A743D6228302C22496E666F22293B627265616B3B63617365205A4D2E48696E743A743D6228302C2248696E7422297D6C6574206E3D6228302C227B307D206174207B317D2E20222C742C652E73746172744C696E654E756D6265722B';
wwv_flow_imp.g_varchar2_table(26429) := '223A222B652E7374617274436F6C756D6E293B636F6E737420693D746869732E5F656469746F722E6765744D6F64656C28293B72657475726E20692626652E73746172744C696E654E756D6265723C3D692E6765744C696E65436F756E7428292626652E';
wwv_flow_imp.g_varchar2_table(26430) := '73746172744C696E654E756D6265723E3D312626286E3D60247B692E6765744C696E65436F6E74656E7428652E73746172744C696E654E756D626572297D2C20247B6E7D60292C6E7D7D6C65742075323D63323D636C61737320657874656E6473207924';
wwv_flow_imp.g_varchar2_table(26431) := '7B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228652C7B73686F774172726F773A21302C73686F774672616D653A21302C697341636365737369626C653A21302C6672616D6557696474683A317D2C6F292C74686973';
wwv_flow_imp.g_varchar2_table(26432) := '2E5F7468656D65536572766963653D742C746869732E5F6F70656E6572536572766963653D6E2C746869732E5F6D656E75536572766963653D692C746869732E5F636F6E746578744B6579536572766963653D732C746869732E5F6C6162656C53657276';
wwv_flow_imp.g_varchar2_table(26433) := '6963653D722C746869732E5F63616C6C4F6E446973706F73653D6E65772061742C746869732E5F6F6E44696453656C65637452656C61746564496E666F726D6174696F6E3D6E65772043742C746869732E6F6E44696453656C65637452656C6174656449';
wwv_flow_imp.g_varchar2_table(26434) := '6E666F726D6174696F6E3D746869732E5F6F6E44696453656C65637452656C61746564496E666F726D6174696F6E2E6576656E742C746869732E5F73657665726974793D5A4D2E5761726E696E672C746869732E5F6261636B67726F756E64436F6C6F72';
wwv_flow_imp.g_varchar2_table(26435) := '3D68752E77686974652C746869732E5F6170706C795468656D6528742E676574436F6C6F725468656D652829292C746869732E5F63616C6C4F6E446973706F73652E61646428742E6F6E446964436F6C6F725468656D654368616E676528746869732E5F';
wwv_flow_imp.g_varchar2_table(26436) := '6170706C795468656D652E62696E6428746869732929292C746869732E63726561746528297D5F6170706C795468656D652865297B746869732E5F6261636B67726F756E64436F6C6F723D652E676574436F6C6F72284332293B6C657420743D66322C6E';
wwv_flow_imp.g_varchar2_table(26437) := '3D76323B746869732E5F73657665726974793D3D3D5A4D2E5761726E696E673F28743D62322C6E3D5F32293A746869732E5F73657665726974793D3D3D5A4D2E496E666F262628743D79322C6E3D7732293B636F6E737420693D652E676574436F6C6F72';
wwv_flow_imp.g_varchar2_table(26438) := '2874292C6F3D652E676574436F6C6F72286E293B746869732E7374796C65287B6172726F77436F6C6F723A692C6672616D65436F6C6F723A692C6865616465724261636B67726F756E64436F6C6F723A6F2C7072696D61727948656164696E67436F6C6F';
wwv_flow_imp.g_varchar2_table(26439) := '723A652E676574436F6C6F72284324292C7365636F6E6461727948656164696E67436F6C6F723A652E676574436F6C6F72285324297D297D5F6170706C795374796C657328297B746869732E5F706172656E74436F6E7461696E6572262628746869732E';
wwv_flow_imp.g_varchar2_table(26440) := '5F706172656E74436F6E7461696E65722E7374796C652E6261636B67726F756E64436F6C6F723D746869732E5F6261636B67726F756E64436F6C6F723F746869732E5F6261636B67726F756E64436F6C6F722E746F537472696E6728293A2222292C7375';
wwv_flow_imp.g_varchar2_table(26441) := '7065722E5F6170706C795374796C657328297D646973706F736528297B746869732E5F63616C6C4F6E446973706F73652E646973706F736528292C73757065722E646973706F736528297D5F66696C6C486561642865297B73757065722E5F66696C6C48';
wwv_flow_imp.g_varchar2_table(26442) := '6561642865292C746869732E5F646973706F7361626C65732E61646428746869732E5F616374696F6E6261725769646765742E616374696F6E52756E6E65722E6F6E57696C6C52756E2828653D3E746869732E656469746F722E666F6375732829292929';
wwv_flow_imp.g_varchar2_table(26443) := '3B636F6E737420743D5B5D2C6E3D746869732E5F6D656E75536572766963652E6372656174654D656E752863322E5469746C654D656E752C746869732E5F636F6E746578744B657953657276696365293B626A286E2C766F696420302C74292C74686973';
wwv_flow_imp.g_varchar2_table(26444) := '2E5F616374696F6E6261725769646765742E7075736828742C7B6C6162656C3A21312C69636F6E3A21302C696E6465783A307D292C6E2E646973706F736528297D5F66696C6C5469746C6549636F6E2865297B746869732E5F69636F6E3D757228652C62';
wwv_flow_imp.g_varchar2_table(26445) := '7228222229297D5F66696C6C426F64792865297B746869732E5F706172656E74436F6E7461696E65723D652C652E636C6173734C6973742E61646428226D61726B65722D77696467657422292C746869732E5F706172656E74436F6E7461696E65722E74';
wwv_flow_imp.g_varchar2_table(26446) := '6162496E6465783D302C746869732E5F706172656E74436F6E7461696E65722E7365744174747269627574652822726F6C65222C22746F6F6C74697022292C746869732E5F636F6E7461696E65723D646F63756D656E742E637265617465456C656D656E';
wwv_flow_imp.g_varchar2_table(26447) := '74282264697622292C652E617070656E644368696C6428746869732E5F636F6E7461696E6572292C746869732E5F6D6573736167653D6E657720683228746869732E5F636F6E7461696E65722C746869732E656469746F722C28653D3E746869732E5F6F';
wwv_flow_imp.g_varchar2_table(26448) := '6E44696453656C65637452656C61746564496E666F726D6174696F6E2E66697265286529292C746869732E5F6F70656E6572536572766963652C746869732E5F6C6162656C53657276696365292C746869732E5F646973706F7361626C65732E61646428';
wwv_flow_imp.g_varchar2_table(26449) := '746869732E5F6D657373616765297D73686F7728297B7468726F77206E6577204572726F72282263616C6C2073686F7741744D61726B657222297D73686F7741744D61726B657228652C742C6E297B746869732E5F636F6E7461696E65722E636C617373';
wwv_flow_imp.g_varchar2_table(26450) := '4C6973742E72656D6F766528227374616C6522292C746869732E5F6D6573736167652E7570646174652865292C746869732E5F73657665726974793D652E73657665726974792C746869732E5F6170706C795468656D6528746869732E5F7468656D6553';
wwv_flow_imp.g_varchar2_table(26451) := '6572766963652E676574436F6C6F725468656D652829293B636F6E737420693D72682E6C6966742865292C6F3D746869732E656469746F722E676574506F736974696F6E28292C733D6F2626692E636F6E7461696E73506F736974696F6E286F293F6F3A';
wwv_flow_imp.g_varchar2_table(26452) := '692E6765745374617274506F736974696F6E28293B73757065722E73686F7728732C746869732E636F6D7075746552657175697265644865696768742829293B636F6E737420723D746869732E656469746F722E6765744D6F64656C28293B6966287229';
wwv_flow_imp.g_varchar2_table(26453) := '7B636F6E737420653D6228302C6E3E313F227B307D206F66207B317D2070726F626C656D73223A227B307D206F66207B317D2070726F626C656D222C742C6E293B746869732E7365745469746C6528476C28722E757269292C65297D746869732E5F6963';
wwv_flow_imp.g_varchar2_table(26454) := '6F6E2E636C6173734E616D653D60636F6469636F6E20247B72322E636C6173734E616D65285A4D2E746F536576657269747928746869732E5F736576657269747929297D602C746869732E656469746F722E72657665616C506F736974696F6E4E656172';
wwv_flow_imp.g_varchar2_table(26455) := '546F7028732C30292C746869732E656469746F722E666F63757328297D7570646174654D61726B65722865297B746869732E5F636F6E7461696E65722E636C6173734C6973742E72656D6F766528227374616C6522292C746869732E5F6D657373616765';
wwv_flow_imp.g_varchar2_table(26456) := '2E7570646174652865297D73686F775374616C6528297B746869732E5F636F6E7461696E65722E636C6173734C6973742E61646428227374616C6522292C746869732E5F72656C61796F757428297D5F646F4C61796F7574426F647928652C74297B7375';
wwv_flow_imp.g_varchar2_table(26457) := '7065722E5F646F4C61796F7574426F647928652C74292C746869732E5F686569676874496E506978656C3D652C746869732E5F6D6573736167652E6C61796F757428652C74292C746869732E5F636F6E7461696E65722E7374796C652E6865696768743D';
wwv_flow_imp.g_varchar2_table(26458) := '60247B657D7078607D5F6F6E57696474682865297B746869732E5F6D6573736167652E6C61796F757428746869732E5F686569676874496E506978656C2C65297D5F72656C61796F757428297B73757065722E5F72656C61796F757428746869732E636F';
wwv_flow_imp.g_varchar2_table(26459) := '6D7075746552657175697265644865696768742829297D636F6D70757465526571756972656448656967687428297B72657475726E20332B746869732E5F6D6573736167652E676574486569676874496E4C696E657328297D7D3B75322E5469746C654D';
wwv_flow_imp.g_varchar2_table(26460) := '656E753D6E6577204C642822676F746F4572726F725469746C654D656E7522292C75323D63323D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F69';
wwv_flow_imp.g_varchar2_table(26461) := '3D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F';
wwv_flow_imp.g_varchar2_table(26462) := '7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E';
wwv_flow_imp.g_varchar2_table(26463) := '2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B643228312C5062292C643228322C6445292C643228332C4464292C643228342C7563292C';
wwv_flow_imp.g_varchar2_table(26464) := '643228352C6364292C643228362C4B47295D2C7532293B636F6E73742070323D4D6D2874662C6E66292C67323D4D6D2873662C7266292C6D323D4D6D2861662C6C66292C66323D4C6D2822656469746F724D61726B65724E617669676174696F6E457272';
wwv_flow_imp.g_varchar2_table(26465) := '6F722E6261636B67726F756E64222C7B6461726B3A70322C6C696768743A70322C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22456469746F72206D61726B6572206E617669676174696F6E20776964676574206572726F7220636F';
wwv_flow_imp.g_varchar2_table(26466) := '6C6F722E2229292C76323D4C6D2822656469746F724D61726B65724E617669676174696F6E4572726F722E6865616465724261636B67726F756E64222C7B6461726B3A496D2866322C2E31292C6C696768743A496D2866322C2E31292C68634461726B3A';
wwv_flow_imp.g_varchar2_table(26467) := '6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22456469746F72206D61726B6572206E617669676174696F6E20776964676574206572726F722068656164696E67206261636B67726F756E642E2229292C62323D4C6D2822656469746F724D61';
wwv_flow_imp.g_varchar2_table(26468) := '726B65724E617669676174696F6E5761726E696E672E6261636B67726F756E64222C7B6461726B3A67322C6C696768743A67322C68634461726B3A7A6D2C68634C696768743A7A6D7D2C6228302C22456469746F72206D61726B6572206E617669676174';
wwv_flow_imp.g_varchar2_table(26469) := '696F6E20776964676574207761726E696E6720636F6C6F722E2229292C5F323D4C6D2822656469746F724D61726B65724E617669676174696F6E5761726E696E672E6865616465724261636B67726F756E64222C7B6461726B3A496D2862322C2E31292C';
wwv_flow_imp.g_varchar2_table(26470) := '6C696768743A496D2862322C2E31292C68634461726B3A2223304331343146222C68634C696768743A496D2862322C2E32297D2C6228302C22456469746F72206D61726B6572206E617669676174696F6E20776964676574207761726E696E6720686561';
wwv_flow_imp.g_varchar2_table(26471) := '64696E67206261636B67726F756E642E2229292C79323D4C6D2822656469746F724D61726B65724E617669676174696F6E496E666F2E6261636B67726F756E64222C7B6461726B3A6D322C6C696768743A6D322C68634461726B3A7A6D2C68634C696768';
wwv_flow_imp.g_varchar2_table(26472) := '743A7A6D7D2C6228302C22456469746F72206D61726B6572206E617669676174696F6E2077696467657420696E666F20636F6C6F722E2229292C77323D4C6D2822656469746F724D61726B65724E617669676174696F6E496E666F2E6865616465724261';
wwv_flow_imp.g_varchar2_table(26473) := '636B67726F756E64222C7B6461726B3A496D2879322C2E31292C6C696768743A496D2879322C2E31292C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C22456469746F72206D61726B6572206E617669676174696F6E207769';
wwv_flow_imp.g_varchar2_table(26474) := '6467657420696E666F2068656164696E67206261636B67726F756E642E2229292C43323D4C6D2822656469746F724D61726B65724E617669676174696F6E2E6261636B67726F756E64222C7B6461726B3A596D2C6C696768743A596D2C68634461726B3A';
wwv_flow_imp.g_varchar2_table(26475) := '596D2C68634C696768743A596D7D2C6228302C22456469746F72206D61726B6572206E617669676174696F6E20776964676574206261636B67726F756E642E2229293B7661722053322C78323D66756E6374696F6E28652C74297B72657475726E206675';
wwv_flow_imp.g_varchar2_table(26476) := '6E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206B323D53323D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2853322E4944297D636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(26477) := '2C6E2C692C6F297B746869732E5F6D61726B65724E617669676174696F6E536572766963653D742C746869732E5F636F6E746578744B6579536572766963653D6E2C746869732E5F656469746F72536572766963653D692C746869732E5F696E7374616E';
wwv_flow_imp.g_varchar2_table(26478) := '74696174696F6E536572766963653D6F2C746869732E5F73657373696F6E446973706F61626C65733D6E65772061742C746869732E5F656469746F723D652C746869732E5F77696467657456697369626C653D54322E62696E64546F28746869732E5F63';
wwv_flow_imp.g_varchar2_table(26479) := '6F6E746578744B657953657276696365297D646973706F736528297B746869732E5F636C65616E557028292C746869732E5F73657373696F6E446973706F61626C65732E646973706F736528297D5F636C65616E557028297B746869732E5F7769646765';
wwv_flow_imp.g_varchar2_table(26480) := '7456697369626C652E726573657428292C746869732E5F73657373696F6E446973706F61626C65732E636C65617228292C746869732E5F7769646765743D766F696420302C746869732E5F6D6F64656C3D766F696420307D5F6765744F72437265617465';
wwv_flow_imp.g_varchar2_table(26481) := '4D6F64656C2865297B696628746869732E5F6D6F64656C2626746869732E5F6D6F64656C2E6D6174636865732865292972657475726E20746869732E5F6D6F64656C3B6C657420743D21313B72657475726E20746869732E5F6D6F64656C262628743D21';
wwv_flow_imp.g_varchar2_table(26482) := '302C746869732E5F636C65616E55702829292C746869732E5F6D6F64656C3D746869732E5F6D61726B65724E617669676174696F6E536572766963652E6765744D61726B65724C6973742865292C742626746869732E5F6D6F64656C2E6D6F7665282130';
wwv_flow_imp.g_varchar2_table(26483) := '2C746869732E5F656469746F722E6765744D6F64656C28292C746869732E5F656469746F722E676574506F736974696F6E2829292C746869732E5F7769646765743D746869732E5F696E7374616E74696174696F6E536572766963652E63726561746549';
wwv_flow_imp.g_varchar2_table(26484) := '6E7374616E63652875322C746869732E5F656469746F72292C746869732E5F7769646765742E6F6E446964436C6F7365282828293D3E746869732E636C6F73652829292C746869732C746869732E5F73657373696F6E446973706F61626C6573292C7468';
wwv_flow_imp.g_varchar2_table(26485) := '69732E5F77696467657456697369626C652E736574282130292C746869732E5F73657373696F6E446973706F61626C65732E61646428746869732E5F6D6F64656C292C746869732E5F73657373696F6E446973706F61626C65732E61646428746869732E';
wwv_flow_imp.g_varchar2_table(26486) := '5F776964676574292C746869732E5F73657373696F6E446973706F61626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E2828653D3E7B76617220742C6E2C693B286E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(26487) := '743D746869732E5F6D6F64656C297C7C766F696420303D3D3D743F766F696420303A742E73656C656374656429262672682E636F6E7461696E73506F736974696F6E286E756C6C3D3D3D286E3D746869732E5F6D6F64656C297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(26488) := '6E3F766F696420303A6E2E73656C65637465642E6D61726B65722C652E706F736974696F6E297C7C6E756C6C3D3D3D28693D746869732E5F6D6F64656C297C7C766F696420303D3D3D697C7C692E7265736574496E64657828297D2929292C746869732E';
wwv_flow_imp.g_varchar2_table(26489) := '5F73657373696F6E446973706F61626C65732E61646428746869732E5F6D6F64656C2E6F6E4469644368616E6765282828293D3E7B69662821746869732E5F7769646765747C7C21746869732E5F7769646765742E706F736974696F6E7C7C2174686973';
wwv_flow_imp.g_varchar2_table(26490) := '2E5F6D6F64656C2972657475726E3B636F6E737420653D746869732E5F6D6F64656C2E66696E6428746869732E5F656469746F722E6765744D6F64656C28292E7572692C746869732E5F7769646765742E706F736974696F6E293B653F746869732E5F77';
wwv_flow_imp.g_varchar2_table(26491) := '69646765742E7570646174654D61726B657228652E6D61726B6572293A746869732E5F7769646765742E73686F775374616C6528297D2929292C746869732E5F73657373696F6E446973706F61626C65732E61646428746869732E5F7769646765742E6F';
wwv_flow_imp.g_varchar2_table(26492) := '6E44696453656C65637452656C61746564496E666F726D6174696F6E2828653D3E7B746869732E5F656469746F72536572766963652E6F70656E436F6465456469746F72287B7265736F757263653A652E7265736F757263652C6F7074696F6E733A7B70';
wwv_flow_imp.g_varchar2_table(26493) := '696E6E65643A21302C72657665616C49664F70656E65643A21302C73656C656374696F6E3A72682E6C6966742865292E636F6C6C61707365546F537461727428297D7D2C746869732E5F656469746F72292C746869732E636C6F7365282131297D292929';
wwv_flow_imp.g_varchar2_table(26494) := '2C746869732E5F73657373696F6E446973706F61626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E5F636C65616E557028292929292C746869732E5F6D6F64656C7D636C6F7365';
wwv_flow_imp.g_varchar2_table(26495) := '28653D2130297B746869732E5F636C65616E557028292C652626746869732E5F656469746F722E666F63757328297D73686F7741744D61726B65722865297B696628746869732E5F656469746F722E6861734D6F64656C2829297B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(26496) := '6869732E5F6765744F724372656174654D6F64656C28746869732E5F656469746F722E6765744D6F64656C28292E757269293B742E7265736574496E64657828292C742E6D6F76652821302C746869732E5F656469746F722E6765744D6F64656C28292C';
wwv_flow_imp.g_varchar2_table(26497) := '6E6577206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E29292C742E73656C65637465642626746869732E5F7769646765742E73686F7741744D61726B657228742E73656C65637465642E6D61726B65722C742E73';
wwv_flow_imp.g_varchar2_table(26498) := '656C65637465642E696E6465782C742E73656C65637465642E746F74616C297D7D6173796E63206E6167697661746528652C74297B766172206E2C693B696628746869732E5F656469746F722E6861734D6F64656C2829297B636F6E7374206F3D746869';
wwv_flow_imp.g_varchar2_table(26499) := '732E5F6765744F724372656174654D6F64656C28743F766F696420303A746869732E5F656469746F722E6765744D6F64656C28292E757269293B6966286F2E6D6F766528652C746869732E5F656469746F722E6765744D6F64656C28292C746869732E5F';
wwv_flow_imp.g_varchar2_table(26500) := '656469746F722E676574506F736974696F6E2829292C216F2E73656C65637465642972657475726E3B6966286F2E73656C65637465642E6D61726B65722E7265736F757263652E746F537472696E672829213D3D746869732E5F656469746F722E676574';
wwv_flow_imp.g_varchar2_table(26501) := '4D6F64656C28292E7572692E746F537472696E672829297B746869732E5F636C65616E557028293B636F6E737420733D617761697420746869732E5F656469746F72536572766963652E6F70656E436F6465456469746F72287B7265736F757263653A6F';
wwv_flow_imp.g_varchar2_table(26502) := '2E73656C65637465642E6D61726B65722E7265736F757263652C6F7074696F6E733A7B70696E6E65643A21312C72657665616C49664F70656E65643A21302C73656C656374696F6E52657665616C547970653A322C73656C656374696F6E3A6F2E73656C';
wwv_flow_imp.g_varchar2_table(26503) := '65637465642E6D61726B65727D7D2C746869732E5F656469746F72293B732626286E756C6C3D3D3D286E3D53322E676574287329297C7C766F696420303D3D3D6E7C7C6E2E636C6F736528292C6E756C6C3D3D3D28693D53322E676574287329297C7C76';
wwv_flow_imp.g_varchar2_table(26504) := '6F696420303D3D3D697C7C692E6E6167697661746528652C7429297D656C736520746869732E5F7769646765742E73686F7741744D61726B6572286F2E73656C65637465642E6D61726B65722C6F2E73656C65637465642E696E6465782C6F2E73656C65';
wwv_flow_imp.g_varchar2_table(26505) := '637465642E746F74616C297D7D7D3B6B322E49443D22656469746F722E636F6E747269622E6D61726B6572436F6E74726F6C6C6572222C6B323D53323D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E';
wwv_flow_imp.g_varchar2_table(26506) := '6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(26507) := '223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D292626';
wwv_flow_imp.g_varchar2_table(26508) := '28723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B783228312C6E32292C783228322C';
wwv_flow_imp.g_varchar2_table(26509) := '6364292C783228332C6763292C783228342C7563295D2C6B32293B636C61737320453220657874656E64732055647B636F6E7374727563746F7228652C742C6E297B7375706572286E292C746869732E5F6E6578743D652C746869732E5F6D756C746946';
wwv_flow_imp.g_varchar2_table(26510) := '696C653D747D6173796E632072756E28652C74297B766172206E3B742E6861734D6F64656C28292626286E756C6C3D3D3D286E3D6B322E676574287429297C7C766F696420303D3D3D6E7C7C6E2E6E6167697661746528746869732E5F6E6578742C7468';
wwv_flow_imp.g_varchar2_table(26511) := '69732E5F6D756C746946696C6529297D7D636C617373204C3220657874656E64732045327B636F6E7374727563746F7228297B73757065722821302C21312C7B69643A4C322E49442C6C6162656C3A4C322E4C4142454C2C616C6961733A22476F20746F';
wwv_flow_imp.g_varchar2_table(26512) := '204E6578742050726F626C656D20284572726F722C205761726E696E672C20496E666F29222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A3537382C776569676874';
wwv_flow_imp.g_varchar2_table(26513) := '3A3130307D2C6D656E754F7074733A7B6D656E7549643A75322E5469746C654D656E752C7469746C653A4C322E4C4142454C2C69636F6E3A545728226D61726B65722D6E617669676174696F6E2D6E657874222C4C6C2E6172726F77446F776E2C622830';
wwv_flow_imp.g_varchar2_table(26514) := '2C2249636F6E20666F7220676F746F206E657874206D61726B65722E2229292C67726F75703A226E617669676174696F6E222C6F726465723A317D7D297D7D4C322E49443D22656469746F722E616374696F6E2E6D61726B65722E6E657874222C4C322E';
wwv_flow_imp.g_varchar2_table(26515) := '4C4142454C3D6228302C22476F20746F204E6578742050726F626C656D20284572726F722C205761726E696E672C20496E666F2922293B636C61737320443220657874656E64732045327B636F6E7374727563746F7228297B73757065722821312C2131';
wwv_flow_imp.g_varchar2_table(26516) := '2C7B69643A44322E49442C6C6162656C3A44322E4C4142454C2C616C6961733A22476F20746F2050726576696F75732050726F626C656D20284572726F722C205761726E696E672C20496E666F29222C707265636F6E646974696F6E3A766F696420302C';
wwv_flow_imp.g_varchar2_table(26517) := '6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A313630322C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A75322E5469746C654D656E752C7469746C653A44322E4C4142454C2C69636F6E3A54';
wwv_flow_imp.g_varchar2_table(26518) := '5728226D61726B65722D6E617669676174696F6E2D70726576696F7573222C4C6C2E6172726F7755702C6228302C2249636F6E20666F7220676F746F2070726576696F7573206D61726B65722E2229292C67726F75703A226E617669676174696F6E222C';
wwv_flow_imp.g_varchar2_table(26519) := '6F726465723A327D7D297D7D44322E49443D22656469746F722E616374696F6E2E6D61726B65722E70726576222C44322E4C4142454C3D6228302C22476F20746F2050726576696F75732050726F626C656D20284572726F722C205761726E696E672C20';
wwv_flow_imp.g_varchar2_table(26520) := '496E666F2922292C4A64286B322E49442C6B322C34292C5A64284C32292C5A64284432292C5A6428636C61737320657874656E64732045327B636F6E7374727563746F7228297B73757065722821302C21302C7B69643A22656469746F722E616374696F';
wwv_flow_imp.g_varchar2_table(26521) := '6E2E6D61726B65722E6E657874496E46696C6573222C6C6162656C3A6228302C22476F20746F204E6578742050726F626C656D20696E2046696C657320284572726F722C205761726E696E672C20496E666F2922292C616C6961733A22476F20746F204E';
wwv_flow_imp.g_varchar2_table(26522) := '6578742050726F626C656D20696E2046696C657320284572726F722C205761726E696E672C20496E666F29222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A36362C';
wwv_flow_imp.g_varchar2_table(26523) := '7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E75626172476F4D656E752C7469746C653A6228302C224E65787420262650726F626C656D22292C67726F75703A22365F70726F626C656D5F6E6176222C6F726465';
wwv_flow_imp.g_varchar2_table(26524) := '723A317D7D297D7D292C5A6428636C61737320657874656E64732045327B636F6E7374727563746F7228297B73757065722821312C21302C7B69643A22656469746F722E616374696F6E2E6D61726B65722E70726576496E46696C6573222C6C6162656C';
wwv_flow_imp.g_varchar2_table(26525) := '3A6228302C22476F20746F2050726576696F75732050726F626C656D20696E2046696C657320284572726F722C205761726E696E672C20496E666F2922292C616C6961733A22476F20746F2050726576696F75732050726F626C656D20696E2046696C65';
wwv_flow_imp.g_varchar2_table(26526) := '7320284572726F722C205761726E696E672C20496E666F29222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A313039302C7765696768743A3130307D2C6D656E754F';
wwv_flow_imp.g_varchar2_table(26527) := '7074733A7B6D656E7549643A4C642E4D656E75626172476F4D656E752C7469746C653A6228302C2250726576696F757320262650726F626C656D22292C67726F75703A22365F70726F626C656D5F6E6176222C6F726465723A327D7D297D7D293B636F6E';
wwv_flow_imp.g_varchar2_table(26528) := '73742054323D6E6577206C6428226D61726B6572734E617669676174696F6E56697369626C65222C2131293B5964286E65772824642E62696E64546F436F6E747269627574696F6E286B322E6765742929287B69643A22636C6F73654D61726B6572734E';
wwv_flow_imp.g_varchar2_table(26529) := '617669676174696F6E222C707265636F6E646974696F6E3A54322C68616E646C65723A653D3E652E636C6F736528292C6B624F7074733A7B7765696768743A3135302C6B62457870723A6C682E666F6375732C7072696D6172793A392C7365636F6E6461';
wwv_flow_imp.g_varchar2_table(26530) := '72793A5B313033335D7D7D29293B636C6173732049327B636F6E7374727563746F722865297B746869732E6F7074696F6E733D652C746869732E72616E6765486967686C696768744465636F726174696F6E49643D766F696420307D70726F7669646528';
wwv_flow_imp.g_varchar2_table(26531) := '652C74297B766172206E3B636F6E737420693D6E65772061743B652E63616E416363657074496E4261636B67726F756E643D2121286E756C6C3D3D3D286E3D746869732E6F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E6361';
wwv_flow_imp.g_varchar2_table(26532) := '6E416363657074496E4261636B67726F756E64292C652E6D617463684F6E4C6162656C3D652E6D617463684F6E4465736372697074696F6E3D652E6D617463684F6E44657461696C3D652E736F727442794C6162656C3D21313B636F6E7374206F3D692E';
wwv_flow_imp.g_varchar2_table(26533) := '616464286E6577206374293B72657475726E206F2E76616C75653D746869732E646F50726F7669646528652C74292C692E61646428746869732E6F6E44696441637469766554657874456469746F72436F6E74726F6C4368616E6765282828293D3E7B6F';
wwv_flow_imp.g_varchar2_table(26534) := '2E76616C75653D766F696420302C6F2E76616C75653D746869732E646F50726F7669646528652C74297D2929292C697D646F50726F7669646528652C74297B766172206E3B636F6E737420693D6E65772061742C6F3D746869732E616374697665546578';
wwv_flow_imp.g_varchar2_table(26535) := '74456469746F72436F6E74726F6C3B6966286F2626746869732E63616E50726F766964655769746854657874456469746F72286F29297B636F6E737420733D7B656469746F723A6F7D2C723D7424286F293B69662872297B6C657420653D6E756C6C213D';
wwv_flow_imp.g_varchar2_table(26536) := '3D286E3D6F2E736176655669657753746174652829292626766F69642030213D3D6E3F6E3A766F696420303B692E61646428722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E7B76617220743B653D6E756C6C213D3D28';
wwv_flow_imp.g_varchar2_table(26537) := '743D6F2E736176655669657753746174652829292626766F69642030213D3D743F743A766F696420307D2929292C732E726573746F72655669657753746174653D28293D3E7B6526266F3D3D3D746869732E61637469766554657874456469746F72436F';
wwv_flow_imp.g_varchar2_table(26538) := '6E74726F6C26266F2E726573746F72655669657753746174652865297D2C692E61646428596528742E6F6E43616E63656C6C6174696F6E52657175657374656429282828293D3E7B76617220653B72657475726E206E756C6C3D3D3D28653D732E726573';
wwv_flow_imp.g_varchar2_table(26539) := '746F7265566965775374617465297C7C766F696420303D3D3D653F766F696420303A652E63616C6C2873297D2929297D692E616464287274282828293D3E746869732E636C6561724465636F726174696F6E73286F292929292C692E6164642874686973';
wwv_flow_imp.g_varchar2_table(26540) := '2E70726F766964655769746854657874456469746F7228732C652C7429297D656C736520692E61646428746869732E70726F76696465576974686F757454657874456469746F7228652C7429293B72657475726E20697D63616E50726F76696465576974';
wwv_flow_imp.g_varchar2_table(26541) := '6854657874456469746F722865297B72657475726E21307D676F746F4C6F636174696F6E287B656469746F723A657D2C74297B652E73657453656C656374696F6E28742E72616E67652C22636F64652E6A756D7022292C652E72657665616C52616E6765';
wwv_flow_imp.g_varchar2_table(26542) := '496E43656E74657228742E72616E67652C30292C742E7072657365727665466F6375737C7C652E666F63757328293B636F6E7374206E3D652E6765744D6F64656C28293B6E2626226765744C696E65436F6E74656E7422696E206E26264A722860247B6E';
wwv_flow_imp.g_varchar2_table(26543) := '2E6765744C696E65436F6E74656E7428742E72616E67652E73746172744C696E654E756D626572297D60297D6765744D6F64656C2865297B76617220743B72657475726E2065242865293F6E756C6C3D3D3D28743D652E6765744D6F64656C2829297C7C';
wwv_flow_imp.g_varchar2_table(26544) := '766F696420303D3D3D743F766F696420303A742E6D6F6469666965643A652E6765744D6F64656C28297D6164644465636F726174696F6E7328652C74297B652E6368616E67654465636F726174696F6E732828653D3E7B636F6E7374206E3D5B5D3B7468';
wwv_flow_imp.g_varchar2_table(26545) := '69732E72616E6765486967686C696768744465636F726174696F6E49642626286E2E7075736828746869732E72616E6765486967686C696768744465636F726174696F6E49642E6F7665727669657752756C65724465636F726174696F6E4964292C6E2E';
wwv_flow_imp.g_varchar2_table(26546) := '7075736828746869732E72616E6765486967686C696768744465636F726174696F6E49642E72616E6765486967686C696768744964292C746869732E72616E6765486967686C696768744465636F726174696F6E49643D766F69642030293B636F6E7374';
wwv_flow_imp.g_varchar2_table(26547) := '20693D5B7B72616E67653A742C6F7074696F6E733A7B6465736372697074696F6E3A22717569636B2D6163636573732D72616E67652D686967686C69676874222C636C6173734E616D653A2272616E6765486967686C69676874222C697357686F6C654C';
wwv_flow_imp.g_varchar2_table(26548) := '696E653A21307D7D2C7B72616E67653A742C6F7074696F6E733A7B6465736372697074696F6E3A22717569636B2D6163636573732D72616E67652D686967686C696768742D6F76657276696577222C6F7665727669657752756C65723A7B636F6C6F723A';
wwv_flow_imp.g_varchar2_table(26549) := '4F6228765F292C706F736974696F6E3A53682E46756C6C7D7D7D5D2C5B6F2C735D3D652E64656C74614465636F726174696F6E73286E2C69293B746869732E72616E6765486967686C696768744465636F726174696F6E49643D7B72616E676548696768';
wwv_flow_imp.g_varchar2_table(26550) := '6C6967687449643A6F2C6F7665727669657752756C65724465636F726174696F6E49643A737D7D29297D636C6561724465636F726174696F6E732865297B636F6E737420743D746869732E72616E6765486967686C696768744465636F726174696F6E49';
wwv_flow_imp.g_varchar2_table(26551) := '643B74262628652E6368616E67654465636F726174696F6E732828653D3E7B652E64656C74614465636F726174696F6E73285B742E6F7665727669657752756C65724465636F726174696F6E49642C742E72616E6765486967686C6967687449645D2C5B';
wwv_flow_imp.g_varchar2_table(26552) := '5D297D29292C746869732E72616E6765486967686C696768744465636F726174696F6E49643D766F69642030297D7D636C617373204D3220657874656E64732049327B636F6E7374727563746F7228297B7375706572287B63616E416363657074496E42';
wwv_flow_imp.g_varchar2_table(26553) := '61636B67726F756E643A21307D297D70726F76696465576974686F757454657874456469746F722865297B636F6E737420743D6228302C224F70656E2061207465787420656469746F7220666972737420746F20676F20746F2061206C696E652E22293B';
wwv_flow_imp.g_varchar2_table(26554) := '72657475726E20652E6974656D733D5B7B6C6162656C3A747D5D2C652E617269614C6162656C3D742C6C742E4E6F6E657D70726F766964655769746854657874456469746F7228652C742C6E297B636F6E737420693D652E656469746F722C6F3D6E6577';
wwv_flow_imp.g_varchar2_table(26555) := '2061743B6F2E61646428742E6F6E44696441636365707428286E3D3E7B636F6E73745B6F5D3D742E73656C65637465644974656D733B6966286F297B69662821746869732E697356616C69644C696E654E756D62657228692C6F2E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(26556) := '72292972657475726E3B746869732E676F746F4C6F636174696F6E28652C7B72616E67653A746869732E746F52616E6765286F2E6C696E654E756D6265722C6F2E636F6C756D6E292C6B65794D6F64733A742E6B65794D6F64732C707265736572766546';
wwv_flow_imp.g_varchar2_table(26557) := '6F6375733A6E2E696E4261636B67726F756E647D292C6E2E696E4261636B67726F756E647C7C742E6869646528297D7D2929293B636F6E737420733D28293D3E7B636F6E737420653D746869732E7061727365506F736974696F6E28692C742E76616C75';
wwv_flow_imp.g_varchar2_table(26558) := '652E7472696D28292E737562737472284D322E5052454649582E6C656E67746829292C6E3D746869732E6765745069636B4C6162656C28692C652E6C696E654E756D6265722C652E636F6C756D6E293B696628742E6974656D733D5B7B6C696E654E756D';
wwv_flow_imp.g_varchar2_table(26559) := '6265723A652E6C696E654E756D6265722C636F6C756D6E3A652E636F6C756D6E2C6C6162656C3A6E7D5D2C742E617269614C6162656C3D6E2C21746869732E697356616C69644C696E654E756D62657228692C652E6C696E654E756D6265722929726574';
wwv_flow_imp.g_varchar2_table(26560) := '75726E20766F696420746869732E636C6561724465636F726174696F6E732869293B636F6E7374206F3D746869732E746F52616E676528652E6C696E654E756D6265722C652E636F6C756D6E293B692E72657665616C52616E6765496E43656E74657228';
wwv_flow_imp.g_varchar2_table(26561) := '6F2C30292C746869732E6164644465636F726174696F6E7328692C6F297D3B7328292C6F2E61646428742E6F6E4469644368616E676556616C7565282828293D3E7328292929293B636F6E737420723D74242869293B72657475726E20722626323D3D3D';
wwv_flow_imp.g_varchar2_table(26562) := '722E6765744F7074696F6E7328292E676574283638292E72656E64657254797065262628722E7570646174654F7074696F6E73287B6C696E654E756D626572733A226F6E227D292C6F2E616464287274282828293D3E722E7570646174654F7074696F6E';
wwv_flow_imp.g_varchar2_table(26563) := '73287B6C696E654E756D626572733A2272656C6174697665227D29292929292C6F7D746F52616E676528653D312C743D31297B72657475726E7B73746172744C696E654E756D6265723A652C7374617274436F6C756D6E3A742C656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(26564) := '6265723A652C656E64436F6C756D6E3A747D7D7061727365506F736974696F6E28652C74297B636F6E7374206E3D742E73706C6974282F2C7C3A7C232F292E6D61702828653D3E7061727365496E7428652C31302929292E66696C7465722828653D3E21';
wwv_flow_imp.g_varchar2_table(26565) := '69734E614E28652929292C693D746869732E6C696E65436F756E742865292B313B72657475726E7B6C696E654E756D6265723A6E5B305D3E303F6E5B305D3A692B6E5B305D2C636F6C756D6E3A6E5B315D7D7D6765745069636B4C6162656C28652C742C';
wwv_flow_imp.g_varchar2_table(26566) := '6E297B696628746869732E697356616C69644C696E654E756D62657228652C74292972657475726E20746869732E697356616C6964436F6C756D6E28652C742C6E293F6228302C22476F20746F206C696E65207B307D20616E6420636861726163746572';
wwv_flow_imp.g_varchar2_table(26567) := '207B317D2E222C742C6E293A6228302C22476F20746F206C696E65207B307D2E222C74293B636F6E737420693D652E676574506F736974696F6E28297C7C7B6C696E654E756D6265723A312C636F6C756D6E3A317D2C6F3D746869732E6C696E65436F75';
wwv_flow_imp.g_varchar2_table(26568) := '6E742865293B72657475726E206F3E313F6228302C2243757272656E74204C696E653A207B307D2C204368617261637465723A207B317D2E20547970652061206C696E65206E756D626572206265747765656E203120616E64207B327D20746F206E6176';
wwv_flow_imp.g_varchar2_table(26569) := '696761746520746F2E222C692E6C696E654E756D6265722C692E636F6C756D6E2C6F293A6228302C2243757272656E74204C696E653A207B307D2C204368617261637465723A207B317D2E20547970652061206C696E65206E756D62657220746F206E61';
wwv_flow_imp.g_varchar2_table(26570) := '76696761746520746F2E222C692E6C696E654E756D6265722C692E636F6C756D6E297D697356616C69644C696E654E756D62657228652C74297B72657475726E212821747C7C226E756D62657222213D747970656F662074292626743E302626743C3D74';
wwv_flow_imp.g_varchar2_table(26571) := '6869732E6C696E65436F756E742865297D697356616C6964436F6C756D6E28652C742C6E297B696628216E7C7C226E756D62657222213D747970656F66206E2972657475726E21313B636F6E737420693D746869732E6765744D6F64656C2865293B6966';
wwv_flow_imp.g_varchar2_table(26572) := '2821692972657475726E21313B636F6E7374206F3D7B6C696E654E756D6265723A742C636F6C756D6E3A6E7D3B72657475726E20692E76616C6964617465506F736974696F6E286F292E657175616C73286F297D6C696E65436F756E742865297B766172';
wwv_flow_imp.g_varchar2_table(26573) := '20742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E6765744D6F64656C286529297C7C766F696420303D3D3D743F766F696420303A742E6765744C696E65436F756E742829292626766F69642030213D3D6E3F6E';
wwv_flow_imp.g_varchar2_table(26574) := '3A307D7D7661722041323B4D322E5052454649583D223A222C66756E6374696F6E2865297B655B652E50524553455256453D305D3D225052455345525645222C655B652E4C4153543D315D3D224C415354227D2841327C7C2841323D7B7D29293B636F6E';
wwv_flow_imp.g_varchar2_table(26575) := '7374204E323D22776F726B62656E63682E636F6E747269627574696F6E732E717569636B616363657373223B7661722050322C4F322C52322C46322C42322C56322C7A322C48323B79642E616464284E322C6E657720636C6173737B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(26576) := '746F7228297B746869732E70726F7669646572733D5B5D2C746869732E64656661756C7450726F76696465723D766F696420307D7265676973746572517569636B41636365737350726F76696465722865297B72657475726E20303D3D3D652E70726566';
wwv_flow_imp.g_varchar2_table(26577) := '69782E6C656E6774683F746869732E64656661756C7450726F76696465723D653A746869732E70726F7669646572732E707573682865292C746869732E70726F7669646572732E736F7274282828652C74293D3E742E7072656669782E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(26578) := '652E7072656669782E6C656E67746829292C7274282828293D3E7B746869732E70726F7669646572732E73706C69636528746869732E70726F7669646572732E696E6465784F662865292C31292C746869732E64656661756C7450726F76696465723D3D';
wwv_flow_imp.g_varchar2_table(26579) := '3D65262628746869732E64656661756C7450726F76696465723D766F69642030297D29297D676574517569636B41636365737350726F76696465727328297B72657475726E207A68285B746869732E64656661756C7450726F76696465722C2E2E2E7468';
wwv_flow_imp.g_varchar2_table(26580) := '69732E70726F7669646572735D297D676574517569636B41636365737350726F76696465722865297B72657475726E20652626746869732E70726F7669646572732E66696E642828743D3E652E7374617274735769746828742E7072656669782929297C';
wwv_flow_imp.g_varchar2_table(26581) := '7C746869732E64656661756C7450726F76696465727D7D292C66756E6374696F6E2865297B652E696E7370656374546F6B656E73416374696F6E3D6228302C22446576656C6F7065723A20496E737065637420546F6B656E7322297D2850327C7C285032';
wwv_flow_imp.g_varchar2_table(26582) := '3D7B7D29292C66756E6374696F6E2865297B652E676F746F4C696E65416374696F6E4C6162656C3D6228302C22476F20746F204C696E652F436F6C756D6E2E2E2E22297D284F327C7C284F323D7B7D29292C66756E6374696F6E2865297B652E68656C70';
wwv_flow_imp.g_varchar2_table(26583) := '517569636B416363657373416374696F6E4C6162656C3D6228302C2253686F7720616C6C20517569636B204163636573732050726F76696465727322297D2852327C7C2852323D7B7D29292C66756E6374696F6E2865297B652E717569636B436F6D6D61';
wwv_flow_imp.g_varchar2_table(26584) := '6E64416374696F6E4C6162656C3D6228302C22436F6D6D616E642050616C6574746522292C652E717569636B436F6D6D616E6448656C703D6228302C2253686F7720416E642052756E20436F6D6D616E647322297D2846327C7C2846323D7B7D29292C66';
wwv_flow_imp.g_varchar2_table(26585) := '756E6374696F6E2865297B652E717569636B4F75746C696E65416374696F6E4C6162656C3D6228302C22476F20746F2053796D626F6C2E2E2E22292C652E717569636B4F75746C696E65427943617465676F7279416374696F6E4C6162656C3D6228302C';
wwv_flow_imp.g_varchar2_table(26586) := '22476F20746F2053796D626F6C2062792043617465676F72792E2E2E22297D2842327C7C2842323D7B7D29292C66756E6374696F6E2865297B652E656469746F725669657741636365737369626C654C6162656C3D6228302C22456469746F7220636F6E';
wwv_flow_imp.g_varchar2_table(26587) := '74656E7422292C652E6163636573736962696C69747948656C704D6573736167653D6228302C22507265737320416C742B463120666F72204163636573736962696C697479204F7074696F6E732E22297D2856327C7C2856323D7B7D29292C66756E6374';
wwv_flow_imp.g_varchar2_table(26588) := '696F6E2865297B652E746F67676C6548696768436F6E74726173743D6228302C22546F67676C65204869676820436F6E7472617374205468656D6522297D287A327C7C287A323D7B7D29292C66756E6374696F6E2865297B652E62756C6B456469745365';
wwv_flow_imp.g_varchar2_table(26589) := '727669636553756D6D6172793D6228302C224D616465207B307D20656469747320696E207B317D2066696C657322297D2848327C7C2848323D7B7D29293B6C65742057323D636C61737320657874656E6473204D327B636F6E7374727563746F72286529';
wwv_flow_imp.g_varchar2_table(26590) := '7B737570657228292C746869732E656469746F72536572766963653D652C746869732E6F6E44696441637469766554657874456469746F72436F6E74726F6C4368616E67653D76742E4E6F6E657D6765742061637469766554657874456469746F72436F';
wwv_flow_imp.g_varchar2_table(26591) := '6E74726F6C28297B76617220653B72657475726E206E756C6C213D3D28653D746869732E656469746F72536572766963652E676574466F6375736564436F6465456469746F722829292626766F69642030213D3D653F653A766F696420307D7D3B57323D';
wwv_flow_imp.g_varchar2_table(26592) := '66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A69';
wwv_flow_imp.g_varchar2_table(26593) := '3B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73652066';
wwv_flow_imp.g_varchar2_table(26594) := '6F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E64';
wwv_flow_imp.g_varchar2_table(26595) := '6566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28302C6763295D2C5732293B636C617373206A3220657874656E64732055';
wwv_flow_imp.g_varchar2_table(26596) := '647B636F6E7374727563746F7228297B7375706572287B69643A6A322E49442C6C6162656C3A4F322E676F746F4C696E65416374696F6E4C6162656C2C616C6961733A22476F20746F204C696E652F436F6C756D6E2E2E2E222C707265636F6E64697469';
wwv_flow_imp.g_varchar2_table(26597) := '6F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A323038352C6D61633A7B7072696D6172793A3239337D2C7765696768743A3130307D7D297D72756E2865297B652E676574284C45292E71756963';
wwv_flow_imp.g_varchar2_table(26598) := '6B4163636573732E73686F772857322E505245464958297D7D6A322E49443D22656469746F722E616374696F6E2E676F746F4C696E65222C5A64286A32292C79642E6173284E32292E7265676973746572517569636B41636365737350726F7669646572';
wwv_flow_imp.g_varchar2_table(26599) := '287B63746F723A57322C7072656669783A57322E5052454649582C68656C70456E74726965733A5B7B6465736372697074696F6E3A4F322E676F746F4C696E65416374696F6E4C6162656C2C636F6D6D616E6449643A6A322E49447D5D7D293B76617220';
wwv_flow_imp.g_varchar2_table(26600) := '71323D6E2831353033292C24323D7B7D3B24322E7374796C655461675472616E73666F726D3D6A7228292C24322E736574417474726962757465733D567228292C24322E696E736572743D467228292E62696E64286E756C6C2C226865616422292C2432';
wwv_flow_imp.g_varchar2_table(26601) := '2E646F6D4150493D4F7228292C24322E696E736572745374796C65456C656D656E743D487228292C4E7228292871322E412C2432292C71322E41262671322E412E6C6F63616C73262671322E412E6C6F63616C733B7661722055322C4B323D66756E6374';
wwv_flow_imp.g_varchar2_table(26602) := '696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742047323D55323D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E746578744D6F64656C5265736F6C766572';
wwv_flow_imp.g_varchar2_table(26603) := '536572766963653D742C746869732E6C616E6775616765536572766963653D6E2C746869732E6C616E67756167654665617475726573536572766963653D692C746869732E746F556E686F6F6B3D6E65772061742C746869732E746F556E686F6F6B466F';
wwv_flow_imp.g_varchar2_table(26604) := '724B6579626F6172643D6E65772061742C746869732E63757272656E74576F72644174506F736974696F6E3D6E756C6C2C746869732E70726576696F757350726F6D6973653D6E756C6C2C746869732E656469746F723D652C746869732E6C696E6B4465';
wwv_flow_imp.g_varchar2_table(26605) := '636F726174696F6E733D746869732E656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28293B636F6E7374206F3D6E65772051712865293B746869732E746F556E686F6F6B2E616464286F292C746869732E746F556E';
wwv_flow_imp.g_varchar2_table(26606) := '686F6F6B2E616464286F2E6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E2828285B652C745D293D3E7B746869732E737461727446696E64446566696E6974696F6E46726F6D4D6F75736528652C6E756C6C213D743F743A766F69';
wwv_flow_imp.g_varchar2_table(26607) := '642030297D2929292C746869732E746F556E686F6F6B2E616464286F2E6F6E457865637574652828653D3E7B746869732E6973456E61626C65642865292626746869732E676F746F446566696E6974696F6E28652E7461726765742E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(26608) := '2C652E686173536964654279536964654D6F646966696572292E63617463682828653D3E7B6B652865297D29292E66696E616C6C79282828293D3E7B746869732E72656D6F76654C696E6B4465636F726174696F6E7328297D29297D2929292C74686973';
wwv_flow_imp.g_varchar2_table(26609) := '2E746F556E686F6F6B2E616464286F2E6F6E43616E63656C282828293D3E7B746869732E72656D6F76654C696E6B4465636F726174696F6E7328292C746869732E63757272656E74576F72644174506F736974696F6E3D6E756C6C7D2929297D73746174';
wwv_flow_imp.g_varchar2_table(26610) := '6963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2855322E4944297D6173796E6320737461727446696E64446566696E6974696F6E46726F6D437572736F722865297B617761697420746869732E737461727446696E';
wwv_flow_imp.g_varchar2_table(26611) := '64446566696E6974696F6E2865292C746869732E746F556E686F6F6B466F724B6579626F6172642E61646428746869732E656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E7B746869732E63757272656E74';
wwv_flow_imp.g_varchar2_table(26612) := '576F72644174506F736974696F6E3D6E756C6C2C746869732E72656D6F76654C696E6B4465636F726174696F6E7328292C746869732E746F556E686F6F6B466F724B6579626F6172642E636C65617228297D2929292C746869732E746F556E686F6F6B46';
wwv_flow_imp.g_varchar2_table(26613) := '6F724B6579626F6172642E61646428746869732E656469746F722E6F6E4B6579446F776E2828653D3E7B65262628746869732E63757272656E74576F72644174506F736974696F6E3D6E756C6C2C746869732E72656D6F76654C696E6B4465636F726174';
wwv_flow_imp.g_varchar2_table(26614) := '696F6E7328292C746869732E746F556E686F6F6B466F724B6579626F6172642E636C6561722829297D2929297D737461727446696E64446566696E6974696F6E46726F6D4D6F75736528652C74297B696628393D3D3D652E7461726765742E7479706526';
wwv_flow_imp.g_varchar2_table(26615) := '26746869732E6C696E6B4465636F726174696F6E732E6C656E6774683E302972657475726E3B69662821746869732E656469746F722E6861734D6F64656C28297C7C21746869732E6973456E61626C656428652C74292972657475726E20746869732E63';
wwv_flow_imp.g_varchar2_table(26616) := '757272656E74576F72644174506F736974696F6E3D6E756C6C2C766F696420746869732E72656D6F76654C696E6B4465636F726174696F6E7328293B636F6E7374206E3D652E7461726765742E706F736974696F6E3B746869732E737461727446696E64';
wwv_flow_imp.g_varchar2_table(26617) := '446566696E6974696F6E286E297D6173796E6320737461727446696E64446566696E6974696F6E2865297B76617220743B746869732E746F556E686F6F6B466F724B6579626F6172642E636C65617228293B636F6E7374206E3D653F6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(26618) := '743D746869732E656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D743F766F696420303A742E676574576F72644174506F736974696F6E2865293A6E756C6C3B696628216E2972657475726E20746869732E63757272656E74576F';
wwv_flow_imp.g_varchar2_table(26619) := '72644174506F736974696F6E3D6E756C6C2C766F696420746869732E72656D6F76654C696E6B4465636F726174696F6E7328293B696628746869732E63757272656E74576F72644174506F736974696F6E2626746869732E63757272656E74576F726441';
wwv_flow_imp.g_varchar2_table(26620) := '74506F736974696F6E2E7374617274436F6C756D6E3D3D3D6E2E7374617274436F6C756D6E2626746869732E63757272656E74576F72644174506F736974696F6E2E656E64436F6C756D6E3D3D3D6E2E656E64436F6C756D6E2626746869732E63757272';
wwv_flow_imp.g_varchar2_table(26621) := '656E74576F72644174506F736974696F6E2E776F72643D3D3D6E2E776F72642972657475726E3B746869732E63757272656E74576F72644174506F736974696F6E3D6E3B636F6E737420693D6E657720636B28746869732E656469746F722C3135293B6C';
wwv_flow_imp.g_varchar2_table(26622) := '6574206F3B746869732E70726576696F757350726F6D697365262628746869732E70726576696F757350726F6D6973652E63616E63656C28292C746869732E70726576696F757350726F6D6973653D6E756C6C292C746869732E70726576696F75735072';
wwv_flow_imp.g_varchar2_table(26623) := '6F6D6973653D46742828743D3E746869732E66696E64446566696E6974696F6E28652C742929293B7472797B6F3D617761697420746869732E70726576696F757350726F6D6973657D63617463682865297B72657475726E20766F6964206B652865297D';
wwv_flow_imp.g_varchar2_table(26624) := '696628216F7C7C216F2E6C656E6774687C7C21692E76616C696461746528746869732E656469746F72292972657475726E20766F696420746869732E72656D6F76654C696E6B4465636F726174696F6E7328293B636F6E737420733D6F5B305D2E6F7269';
wwv_flow_imp.g_varchar2_table(26625) := '67696E53656C656374696F6E52616E67653F72682E6C696674286F5B305D2E6F726967696E53656C656374696F6E52616E6765293A6E657720726828652E6C696E654E756D6265722C6E2E7374617274436F6C756D6E2C652E6C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(26626) := '6E2E656E64436F6C756D6E293B6966286F2E6C656E6774683E31297B6C657420653D733B666F7228636F6E73747B6F726967696E53656C656374696F6E52616E67653A747D6F66206F2974262628653D72682E706C757352616E676528652C7429293B74';
wwv_flow_imp.g_varchar2_table(26627) := '6869732E6164644465636F726174696F6E28652C286E6577206F63292E617070656E6454657874286228302C22436C69636B20746F2073686F77207B307D20646566696E6974696F6E732E222C6F2E6C656E6774682929297D656C73657B636F6E737420';
wwv_flow_imp.g_varchar2_table(26628) := '653D6F5B305D3B69662821652E7572692972657475726E3B746869732E746578744D6F64656C5265736F6C766572536572766963652E6372656174654D6F64656C5265666572656E636528652E757269292E7468656E2828743D3E7B69662821742E6F62';
wwv_flow_imp.g_varchar2_table(26629) := '6A6563747C7C21742E6F626A6563742E74657874456469746F724D6F64656C2972657475726E20766F696420742E646973706F736528293B636F6E73747B6F626A6563743A7B74657874456469746F724D6F64656C3A6E7D7D3D742C7B73746172744C69';
wwv_flow_imp.g_varchar2_table(26630) := '6E654E756D6265723A697D3D652E72616E67653B696628693C317C7C693E6E2E6765744C696E65436F756E7428292972657475726E20766F696420742E646973706F736528293B636F6E7374206F3D746869732E6765745072657669657756616C756528';
wwv_flow_imp.g_varchar2_table(26631) := '6E2C692C65292C723D746869732E6C616E6775616765536572766963652E67756573734C616E67756167654964427946696C65706174684F7246697273744C696E65286E2E757269293B746869732E6164644465636F726174696F6E28732C6F3F286E65';
wwv_flow_imp.g_varchar2_table(26632) := '77206F63292E617070656E64436F6465626C6F636B28727C7C22222C6F293A766F69642030292C742E646973706F736528297D29297D7D6765745072657669657756616C756528652C742C6E297B6C657420693D6E2E72616E67653B72657475726E2069';
wwv_flow_imp.g_varchar2_table(26633) := '2E656E644C696E654E756D6265722D692E73746172744C696E654E756D6265723E3D55322E4D41585F534F555243455F505245564945575F4C494E4553262628693D746869732E6765745072657669657752616E676542617365644F6E496E64656E7461';
wwv_flow_imp.g_varchar2_table(26634) := '74696F6E28652C7429292C746869732E7374726970496E64656E746174696F6E46726F6D5072657669657752616E676528652C742C69297D7374726970496E64656E746174696F6E46726F6D5072657669657752616E676528652C742C6E297B6C657420';
wwv_flow_imp.g_varchar2_table(26635) := '693D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2874293B666F72286C6574206F3D742B313B6F3C6E2E656E644C696E654E756D6265723B6F2B2B297B636F6E737420743D652E6765744C696E6546697273744E6F';
wwv_flow_imp.g_varchar2_table(26636) := '6E57686974657370616365436F6C756D6E286F293B693D4D6174682E6D696E28692C74297D72657475726E20652E67657456616C7565496E52616E6765286E292E7265706C616365286E65772052656745787028605E5C5C737B247B692D317D7D602C22';
wwv_flow_imp.g_varchar2_table(26637) := '676D22292C2222292E7472696D28297D6765745072657669657752616E676542617365644F6E496E64656E746174696F6E28652C74297B636F6E7374206E3D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2874292C';
wwv_flow_imp.g_varchar2_table(26638) := '693D4D6174682E6D696E28652E6765744C696E65436F756E7428292C742B55322E4D41585F534F555243455F505245564945575F4C494E4553293B6C6574206F3D742B313B666F72283B6F3C6926266E213D3D652E6765744C696E6546697273744E6F6E';
wwv_flow_imp.g_varchar2_table(26639) := '57686974657370616365436F6C756D6E286F293B6F2B2B293B72657475726E206E657720726828742C312C6F2B312C31297D6164644465636F726174696F6E28652C74297B636F6E7374206E3D7B72616E67653A652C6F7074696F6E733A7B6465736372';
wwv_flow_imp.g_varchar2_table(26640) := '697074696F6E3A22676F746F2D646566696E6974696F6E2D6C696E6B222C696E6C696E65436C6173734E616D653A22676F746F2D646566696E6974696F6E2D6C696E6B222C686F7665724D6573736167653A747D7D3B746869732E6C696E6B4465636F72';
wwv_flow_imp.g_varchar2_table(26641) := '6174696F6E732E736574285B6E5D297D72656D6F76654C696E6B4465636F726174696F6E7328297B746869732E6C696E6B4465636F726174696F6E732E636C65617228297D6973456E61626C656428652C74297B766172206E3B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(26642) := '732E656469746F722E6861734D6F64656C28292626652E69734C656674436C69636B2626652E69734E6F6E654F7253696E676C654D6F757365446F776E2626363D3D3D652E7461726765742E7479706526262128286E756C6C3D3D3D286E3D652E746172';
wwv_flow_imp.g_varchar2_table(26643) := '6765742E64657461696C2E696E6A656374656454657874297C7C766F696420303D3D3D6E3F766F696420303A6E2E6F7074696F6E7329696E7374616E63656F6620504329262628652E686173547269676765724D6F6469666965727C7C2121742626742E';
wwv_flow_imp.g_varchar2_table(26644) := '6B6579436F64654973547269676765724B6579292626746869732E6C616E67756167654665617475726573536572766963652E646566696E6974696F6E50726F76696465722E68617328746869732E656469746F722E6765744D6F64656C2829297D6669';
wwv_flow_imp.g_varchar2_table(26645) := '6E64446566696E6974696F6E28652C74297B636F6E7374206E3D746869732E656469746F722E6765744D6F64656C28293B72657475726E206E3F535128746869732E6C616E67756167654665617475726573536572766963652E646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(26646) := '50726F76696465722C6E2C652C74293A50726F6D6973652E7265736F6C7665286E756C6C297D676F746F446566696E6974696F6E28652C74297B72657475726E20746869732E656469746F722E736574506F736974696F6E2865292C746869732E656469';
wwv_flow_imp.g_varchar2_table(26647) := '746F722E696E766F6B6557697468696E436F6E746578742828653D3E7B636F6E7374206E3D21742626746869732E656469746F722E6765744F7074696F6E28383829262621746869732E6973496E5065656B456469746F722865293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(26648) := '6577205651287B6F70656E546F536964653A742C6F70656E496E5065656B3A6E2C6D7574654D6573736167653A21307D2C7B7469746C653A7B76616C75653A22222C6F726967696E616C3A22227D2C69643A22222C707265636F6E646974696F6E3A766F';
wwv_flow_imp.g_varchar2_table(26649) := '696420307D292E72756E2865297D29297D6973496E5065656B456469746F722865297B636F6E737420743D652E676574286364293B72657475726E2076242E696E5065656B456469746F722E67657456616C75652874297D646973706F736528297B7468';
wwv_flow_imp.g_varchar2_table(26650) := '69732E746F556E686F6F6B2E646973706F736528292C746869732E746F556E686F6F6B466F724B6579626F6172642E646973706F736528297D7D3B7661722051323B47322E49443D22656469746F722E636F6E747269622E676F746F646566696E697469';
wwv_flow_imp.g_varchar2_table(26651) := '6F6E6174706F736974696F6E222C47322E4D41585F534F555243455F505245564945575F4C494E45533D382C47323D55323D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F74';
wwv_flow_imp.g_varchar2_table(26652) := '3A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F662052';
wwv_flow_imp.g_varchar2_table(26653) := '65666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872';
wwv_flow_imp.g_varchar2_table(26654) := '293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4B3228312C7663292C4B3228322C4C75292C4B3228332C7878';
wwv_flow_imp.g_varchar2_table(26655) := '295D2C4732292C4A642847322E49442C47322C32292C66756E6374696F6E2865297B652E4E6F4175746F466F6375733D226E6F4175746F466F637573222C652E466F637573496656697369626C653D22666F637573496656697369626C65222C652E4175';
wwv_flow_imp.g_varchar2_table(26656) := '746F466F637573496D6D6564696174656C793D226175746F466F637573496D6D6564696174656C79227D2851327C7C2851323D7B7D29293B7661722059323D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B7428';
wwv_flow_imp.g_varchar2_table(26657) := '6E2C692C65297D7D3B636F6E7374205A323D62723B636C6173732058327B636F6E7374727563746F7228652C742C6E297B746869732E6F776E65723D652C746869732E72616E67653D742C746869732E6D61726B65723D6E7D697356616C6964466F7248';
wwv_flow_imp.g_varchar2_table(26658) := '6F766572416E63686F722865297B72657475726E20313D3D3D652E747970652626746869732E72616E67652E7374617274436F6C756D6E3C3D652E72616E67652E7374617274436F6C756D6E2626746869732E72616E67652E656E64436F6C756D6E3E3D';
wwv_flow_imp.g_varchar2_table(26659) := '652E72616E67652E656E64436F6C756D6E7D7D636F6E7374204A323D7B747970653A312C66696C7465723A7B696E636C7564653A72442E517569636B4669787D2C74726967676572416374696F6E3A61442E517569636B466978486F7665727D3B6C6574';
wwv_flow_imp.g_varchar2_table(26660) := '2065333D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F656469746F723D652C746869732E5F6D61726B65724465636F726174696F6E73536572766963653D742C746869732E5F6F70656E6572536572766963653D6E';
wwv_flow_imp.g_varchar2_table(26661) := '2C746869732E5F6C616E67756167654665617475726573536572766963653D692C746869732E686F7665724F7264696E616C3D312C746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F3D766F696420307D636F6D70757465';
wwv_flow_imp.g_varchar2_table(26662) := '53796E6328652C74297B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C31213D3D652E74797065262621652E737570706F7274734D61726B6572486F7665722972657475726E5B5D3B636F6E7374206E3D746869732E5F656469';
wwv_flow_imp.g_varchar2_table(26663) := '746F722E6765744D6F64656C28292C693D652E72616E67652E73746172744C696E654E756D6265722C6F3D6E2E6765744C696E654D6178436F6C756D6E2869292C733D5B5D3B666F7228636F6E73742072206F662074297B636F6E737420743D722E7261';
wwv_flow_imp.g_varchar2_table(26664) := '6E67652E73746172744C696E654E756D6265723D3D3D693F722E72616E67652E7374617274436F6C756D6E3A312C613D722E72616E67652E656E644C696E654E756D6265723D3D3D693F722E72616E67652E656E64436F6C756D6E3A6F2C6C3D74686973';
wwv_flow_imp.g_varchar2_table(26665) := '2E5F6D61726B65724465636F726174696F6E73536572766963652E6765744D61726B6572286E2E7572692C72293B696628216C29636F6E74696E75653B636F6E737420633D6E657720726828652E72616E67652E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(26666) := '742C652E72616E67652E73746172744C696E654E756D6265722C61293B732E70757368286E657720583228746869732C632C6C29297D72657475726E20737D72656E646572486F766572506172747328652C74297B69662821742E6C656E677468297265';
wwv_flow_imp.g_varchar2_table(26667) := '7475726E206C742E4E6F6E653B636F6E7374206E3D6E65772061743B742E666F72456163682828743D3E652E667261676D656E742E617070656E644368696C6428746869732E72656E6465724D61726B6572486F76657228742C6E292929293B636F6E73';
wwv_flow_imp.g_varchar2_table(26668) := '7420693D313D3D3D742E6C656E6774683F745B305D3A742E736F7274282828652C74293D3E5A4D2E636F6D7061726528652E6D61726B65722E73657665726974792C742E6D61726B65722E73657665726974792929295B305D3B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(26669) := '732E72656E6465724D61726B657253746174757362617228652C692C6E292C6E7D72656E6465724D61726B6572486F76657228652C74297B636F6E7374206E3D5A3228226469762E686F7665722D726F7722293B6E2E746162496E6465783D303B636F6E';
wwv_flow_imp.g_varchar2_table(26670) := '737420693D7572286E2C5A3228226469762E6D61726B65722E686F7665722D636F6E74656E74732229292C7B736F757263653A6F2C6D6573736167653A732C636F64653A722C72656C61746564496E666F726D6174696F6E3A617D3D652E6D61726B6572';
wwv_flow_imp.g_varchar2_table(26671) := '3B746869732E5F656469746F722E6170706C79466F6E74496E666F2869293B636F6E7374206C3D757228692C5A3228227370616E2229293B6966286C2E7374796C652E776869746553706163653D227072652D77726170222C6C2E696E6E657254657874';
wwv_flow_imp.g_varchar2_table(26672) := '3D732C6F7C7C722969662872262622737472696E6722213D747970656F662072297B636F6E737420653D5A3228227370616E22293B6F262628757228652C5A3228227370616E2229292E696E6E6572546578743D6F293B636F6E7374206E3D757228652C';
wwv_flow_imp.g_varchar2_table(26673) := '5A322822612E636F64652D6C696E6B2229293B6E2E736574417474726962757465282268726566222C722E7461726765742E746F537472696E672829292C742E616464286273286E2C22636C69636B222C28653D3E7B746869732E5F6F70656E65725365';
wwv_flow_imp.g_varchar2_table(26674) := '72766963652E6F70656E28722E7461726765742C7B616C6C6F77436F6D6D616E64733A21307D292C652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28297D2929292C7572286E2C5A3228227370616E2229292E';
wwv_flow_imp.g_varchar2_table(26675) := '696E6E6572546578743D722E76616C75653B636F6E737420733D757228692C65293B732E7374796C652E6F7061636974793D22302E36222C732E7374796C652E70616464696E674C6566743D22367078227D656C73657B636F6E737420653D757228692C';
wwv_flow_imp.g_varchar2_table(26676) := '5A3228227370616E2229293B652E7374796C652E6F7061636974793D22302E36222C652E7374796C652E70616464696E674C6566743D22367078222C652E696E6E6572546578743D6F2626723F60247B6F7D28247B727D29603A6F7C7C6028247B727D29';
wwv_flow_imp.g_varchar2_table(26677) := '607D6966286A6828612929666F7228636F6E73747B6D6573736167653A652C7265736F757263653A6E2C73746172744C696E654E756D6265723A6F2C7374617274436F6C756D6E3A737D6F662061297B636F6E737420723D757228692C5A322822646976';
wwv_flow_imp.g_varchar2_table(26678) := '2229293B722E7374796C652E6D617267696E546F703D22387078223B636F6E737420613D757228722C5A322822612229293B612E696E6E6572546578743D60247B476C286E297D28247B6F7D2C20247B737D293A20602C612E7374796C652E637572736F';
wwv_flow_imp.g_varchar2_table(26679) := '723D22706F696E746572222C742E61646428627328612C22636C69636B222C28653D3E7B652E73746F7050726F7061676174696F6E28292C652E70726576656E7444656661756C7428292C746869732E5F6F70656E657253657276696365262674686973';
wwv_flow_imp.g_varchar2_table(26680) := '2E5F6F70656E6572536572766963652E6F70656E286E2C7B66726F6D55736572476573747572653A21302C656469746F724F7074696F6E733A7B73656C656374696F6E3A7B73746172744C696E654E756D6265723A6F2C7374617274436F6C756D6E3A73';
wwv_flow_imp.g_varchar2_table(26681) := '7D7D7D292E6361746368286B65297D2929293B636F6E7374206C3D757228722C5A3228227370616E2229293B6C2E696E6E6572546578743D652C746869732E5F656469746F722E6170706C79466F6E74496E666F286C297D72657475726E206E7D72656E';
wwv_flow_imp.g_varchar2_table(26682) := '6465724D61726B657253746174757362617228652C742C6E297B696628742E6D61726B65722E73657665726974793D3D3D5A4D2E4572726F727C7C742E6D61726B65722E73657665726974793D3D3D5A4D2E5761726E696E677C7C742E6D61726B65722E';
wwv_flow_imp.g_varchar2_table(26683) := '73657665726974793D3D3D5A4D2E496E666F297B636F6E7374206E3D6B322E67657428746869732E5F656469746F72293B6E2626652E7374617475734261722E616464416374696F6E287B6C6162656C3A6228302C22566965772050726F626C656D2229';
wwv_flow_imp.g_varchar2_table(26684) := '2C636F6D6D616E6449643A4C322E49442C72756E3A28293D3E7B652E6869646528292C6E2E73686F7741744D61726B657228742E6D61726B6572292C746869732E5F656469746F722E666F63757328297D7D297D69662821746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(26685) := '2E6765744F7074696F6E28393129297B636F6E737420693D652E7374617475734261722E617070656E64285A3228226469762229293B746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F262628584D2E6D616B654B657928';
wwv_flow_imp.g_varchar2_table(26686) := '746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F2E6D61726B6572293D3D3D584D2E6D616B654B657928742E6D61726B6572293F746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F2E686173';
wwv_flow_imp.g_varchar2_table(26687) := '436F6465416374696F6E737C7C28692E74657874436F6E74656E743D6228302C224E6F20717569636B20666978657320617661696C61626C652229293A746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F3D766F69642030';
wwv_flow_imp.g_varchar2_table(26688) := '293B636F6E7374206F3D746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F262621746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F2E686173436F6465416374696F6E733F6C742E4E6F6E65';
wwv_flow_imp.g_varchar2_table(26689) := '3A6A74282828293D3E692E74657874436F6E74656E743D6228302C22436865636B696E6720666F7220717569636B2066697865732E2E2E2229292C3230302C6E293B692E74657874436F6E74656E747C7C28692E74657874436F6E74656E743D53747269';
wwv_flow_imp.g_varchar2_table(26690) := '6E672E66726F6D43686172436F64652831363029293B636F6E737420733D746869732E676574436F6465416374696F6E7328742E6D61726B6572293B6E2E616464287274282828293D3E732E63616E63656C28292929292C732E7468656E2828733D3E7B';
wwv_flow_imp.g_varchar2_table(26691) := '6966286F2E646973706F736528292C746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F3D7B6D61726B65723A742E6D61726B65722C686173436F6465416374696F6E733A732E76616C6964416374696F6E732E6C656E6774';
wwv_flow_imp.g_varchar2_table(26692) := '683E307D2C21746869732E726563656E744D61726B6572436F6465416374696F6E73496E666F2E686173436F6465416374696F6E732972657475726E20732E646973706F736528292C766F696428692E74657874436F6E74656E743D6228302C224E6F20';
wwv_flow_imp.g_varchar2_table(26693) := '717569636B20666978657320617661696C61626C652229293B692E7374796C652E646973706C61793D226E6F6E65223B6C657420723D21313B6E2E616464287274282828293D3E7B727C7C732E646973706F736528297D2929292C652E73746174757342';
wwv_flow_imp.g_varchar2_table(26694) := '61722E616464416374696F6E287B6C6162656C3A6228302C22517569636B204669782E2E2E22292C636F6D6D616E6449643A75442C72756E3A743D3E7B723D21303B636F6E7374206E3D6C412E67657428746869732E5F656469746F72292C693D417328';
wwv_flow_imp.g_varchar2_table(26695) := '74293B652E6869646528292C6E756C6C3D3D6E7C7C6E2E73686F77436F6465416374696F6E73284A322C732C7B783A692E6C6566742C793A692E746F702C77696474683A692E77696474682C6865696768743A692E6865696768747D297D7D297D292C6B';
wwv_flow_imp.g_varchar2_table(26696) := '65297D7D676574436F6465416374696F6E732865297B72657475726E2046742828743D3E794428746869732E5F6C616E67756167654665617475726573536572766963652E636F6465416374696F6E50726F76696465722C746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(26697) := '2E6765744D6F64656C28292C6E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E292C4A322C43452E4E6F6E652C742929297D7D3B6533';
wwv_flow_imp.g_varchar2_table(26698) := '3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A';
wwv_flow_imp.g_varchar2_table(26699) := '693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520';
wwv_flow_imp.g_varchar2_table(26700) := '666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E';
wwv_flow_imp.g_varchar2_table(26701) := '646566696E6550726F706572747928742C6E2C72292C727D285B593228312C7541292C593228322C6445292C593228332C7878295D2C6533292C4A64285F592E49442C5F592C32292C5A6428636C61737320657874656E64732055647B636F6E73747275';
wwv_flow_imp.g_varchar2_table(26702) := '63746F7228297B7375706572287B69643A746A2C6C6162656C3A6228302C2253686F77206F7220466F63757320486F76657222292C6D657461646174613A7B6465736372697074696F6E3A5F28302C2253686F77206F7220666F63757320746865206564';
wwv_flow_imp.g_varchar2_table(26703) := '69746F7220686F7665722077686963682073686F777320646F63756D656E746174696F6E2C207265666572656E6365732C20616E64206F7468657220636F6E74656E7420666F7220612073796D626F6C206174207468652063757272656E742063757273';
wwv_flow_imp.g_varchar2_table(26704) := '6F7220706F736974696F6E2E22292C617267733A5B7B6E616D653A2261726773222C736368656D613A7B747970653A226F626A656374222C70726F706572746965733A7B666F6375733A7B6465736372697074696F6E3A22436F6E74726F6C7320696620';
wwv_flow_imp.g_varchar2_table(26705) := '616E64207768656E2074686520686F7665722073686F756C642074616B6520666F6375732075706F6E206265696E6720747269676765726564206279207468697320616374696F6E2E222C656E756D3A5B51322E4E6F4175746F466F6375732C51322E46';
wwv_flow_imp.g_varchar2_table(26706) := '6F637573496656697369626C652C51322E4175746F466F637573496D6D6564696174656C795D2C656E756D4465736372697074696F6E733A5B6228302C2254686520686F7665722077696C6C206E6F74206175746F6D61746963616C6C792074616B6520';
wwv_flow_imp.g_varchar2_table(26707) := '666F6375732E22292C6228302C2254686520686F7665722077696C6C2074616B6520666F637573206F6E6C7920696620697420697320616C72656164792076697369626C652E22292C6228302C2254686520686F7665722077696C6C206175746F6D6174';
wwv_flow_imp.g_varchar2_table(26708) := '6963616C6C792074616B6520666F637573207768656E20697420617070656172732E22295D2C64656661756C743A51322E466F637573496656697369626C657D7D7D7D5D7D2C616C6961733A2253686F77206F7220466F63757320486F766572222C7072';
wwv_flow_imp.g_varchar2_table(26709) := '65636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32303837292C7765696768743A3130307D7D297D72756E28652C742C6E297B69';
wwv_flow_imp.g_varchar2_table(26710) := '662821742E6861734D6F64656C28292972657475726E3B636F6E737420693D5F592E6765742874293B69662821692972657475726E3B636F6E7374206F3D6E756C6C3D3D6E3F766F696420303A6E2E666F6375733B6C657420733D51322E466F63757349';
wwv_flow_imp.g_varchar2_table(26711) := '6656697369626C653B4F626A6563742E76616C756573285132292E696E636C75646573286F293F733D6F3A22626F6F6C65616E223D3D747970656F66206F26266F262628733D51322E4175746F466F637573496D6D6564696174656C79293B636F6E7374';
wwv_flow_imp.g_varchar2_table(26712) := '20723D653D3E7B636F6E7374206E3D742E676574506F736974696F6E28292C6F3D6E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F6C756D6E293B692E73686F77436F6E74656E74486F';
wwv_flow_imp.g_varchar2_table(26713) := '766572286F2C312C312C65297D2C613D323D3D3D742E6765744F7074696F6E2832293B692E6973486F76657256697369626C653F73213D3D51322E4E6F4175746F466F6375733F692E666F63757328293A722861293A7228617C7C733D3D3D51322E4175';
wwv_flow_imp.g_varchar2_table(26714) := '746F466F637573496D6D6564696174656C79297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73686F77446566696E6974696F6E50726576';
wwv_flow_imp.g_varchar2_table(26715) := '696577486F766572222C6C6162656C3A6228302C2253686F7720446566696E6974696F6E205072657669657720486F76657222292C616C6961733A2253686F7720446566696E6974696F6E205072657669657720486F766572222C707265636F6E646974';
wwv_flow_imp.g_varchar2_table(26716) := '696F6E3A766F696420302C6D657461646174613A7B6465736372697074696F6E3A5F28302C2253686F772074686520646566696E6974696F6E207072657669657720686F76657220696E2074686520656469746F722E22297D7D297D72756E28652C7429';
wwv_flow_imp.g_varchar2_table(26717) := '7B636F6E7374206E3D5F592E6765742874293B696628216E2972657475726E3B636F6E737420693D742E676574506F736974696F6E28293B69662821692972657475726E3B636F6E7374206F3D6E657720726828692E6C696E654E756D6265722C692E63';
wwv_flow_imp.g_varchar2_table(26718) := '6F6C756D6E2C692E6C696E654E756D6265722C692E636F6C756D6E292C733D47322E6765742874293B732626732E737461727446696E64446566696E6974696F6E46726F6D437572736F722869292E7468656E282828293D3E7B6E2E73686F77436F6E74';
wwv_flow_imp.g_varchar2_table(26719) := '656E74486F766572286F2C312C312C2130297D29297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7363726F6C6C5570486F766572222C6C';
wwv_flow_imp.g_varchar2_table(26720) := '6162656C3A6228302C225363726F6C6C20557020486F76657222292C616C6961733A225363726F6C6C20557020486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F63757365642C6B624F7074733A7B6B62457870723A6C682E68';
wwv_flow_imp.g_varchar2_table(26721) := '6F766572466F63757365642C7072696D6172793A31362C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C225363726F6C6C2075702074686520656469746F7220686F7665722E22297D7D297D72756E2865';
wwv_flow_imp.g_varchar2_table(26722) := '2C74297B636F6E7374206E3D5F592E6765742874293B6E26266E2E7363726F6C6C557028297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E';
wwv_flow_imp.g_varchar2_table(26723) := '7363726F6C6C446F776E486F766572222C6C6162656C3A6228302C225363726F6C6C20446F776E20486F76657222292C616C6961733A225363726F6C6C20446F776E20486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F637573';
wwv_flow_imp.g_varchar2_table(26724) := '65642C6B624F7074733A7B6B62457870723A6C682E686F766572466F63757365642C7072696D6172793A31382C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C225363726F6C6C20646F776E2074686520';
wwv_flow_imp.g_varchar2_table(26725) := '656469746F7220686F7665722E22297D7D297D72756E28652C74297B636F6E7374206E3D5F592E6765742874293B6E26266E2E7363726F6C6C446F776E28297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(26726) := '7B7375706572287B69643A22656469746F722E616374696F6E2E7363726F6C6C4C656674486F766572222C6C6162656C3A6228302C225363726F6C6C204C65667420486F76657222292C616C6961733A225363726F6C6C204C65667420486F766572222C';
wwv_flow_imp.g_varchar2_table(26727) := '707265636F6E646974696F6E3A6C682E686F766572466F63757365642C6B624F7074733A7B6B62457870723A6C682E686F766572466F63757365642C7072696D6172793A31352C7765696768743A3130307D2C6D657461646174613A7B64657363726970';
wwv_flow_imp.g_varchar2_table(26728) := '74696F6E3A5F28302C225363726F6C6C206C6566742074686520656469746F7220686F7665722E22297D7D297D72756E28652C74297B636F6E7374206E3D5F592E6765742874293B6E26266E2E7363726F6C6C4C65667428297D7D292C5A6428636C6173';
wwv_flow_imp.g_varchar2_table(26729) := '7320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7363726F6C6C5269676874486F766572222C6C6162656C3A6228302C225363726F6C6C20526967687420486F76657222';
wwv_flow_imp.g_varchar2_table(26730) := '292C616C6961733A225363726F6C6C20526967687420486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F63757365642C6B624F7074733A7B6B62457870723A6C682E686F766572466F63757365642C7072696D6172793A31372C';
wwv_flow_imp.g_varchar2_table(26731) := '7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C225363726F6C6C2072696768742074686520656469746F7220686F7665722E22297D7D297D72756E28652C74297B636F6E7374206E3D5F592E6765742874';
wwv_flow_imp.g_varchar2_table(26732) := '293B6E26266E2E7363726F6C6C526967687428297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E706167655570486F766572222C6C616265';
wwv_flow_imp.g_varchar2_table(26733) := '6C3A6228302C225061676520557020486F76657222292C616C6961733A225061676520557020486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F63757365642C6B624F7074733A7B6B62457870723A6C682E686F766572466F63';
wwv_flow_imp.g_varchar2_table(26734) := '757365642C7072696D6172793A31312C7365636F6E646172793A5B3532385D2C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C22506167652075702074686520656469746F7220686F7665722E22297D7D';
wwv_flow_imp.g_varchar2_table(26735) := '297D72756E28652C74297B636F6E7374206E3D5F592E6765742874293B6E26266E2E70616765557028297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E6163';
wwv_flow_imp.g_varchar2_table(26736) := '74696F6E2E70616765446F776E486F766572222C6C6162656C3A6228302C225061676520446F776E20486F76657222292C616C6961733A225061676520446F776E20486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F63757365';
wwv_flow_imp.g_varchar2_table(26737) := '642C6B624F7074733A7B6B62457870723A6C682E686F766572466F63757365642C7072696D6172793A31322C7365636F6E646172793A5B3533305D2C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C2250';
wwv_flow_imp.g_varchar2_table(26738) := '61676520646F776E2074686520656469746F7220686F7665722E22297D7D297D72756E28652C74297B636F6E7374206E3D5F592E6765742874293B6E26266E2E70616765446F776E28297D7D292C5A6428636C61737320657874656E64732055647B636F';
wwv_flow_imp.g_varchar2_table(26739) := '6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E676F546F546F70486F766572222C6C6162656C3A6228302C22476F20546F20546F7020486F76657222292C616C6961733A22476F20546F20426F74746F6D20';
wwv_flow_imp.g_varchar2_table(26740) := '486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F63757365642C6B624F7074733A7B6B62457870723A6C682E686F766572466F63757365642C7072696D6172793A31342C7365636F6E646172793A5B323036345D2C7765696768';
wwv_flow_imp.g_varchar2_table(26741) := '743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C22476F20746F2074686520746F70206F662074686520656469746F7220686F7665722E22297D7D297D72756E28652C74297B636F6E7374206E3D5F592E676574287429';
wwv_flow_imp.g_varchar2_table(26742) := '3B6E26266E2E676F546F546F7028297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E676F546F426F74746F6D486F766572222C6C6162656C';
wwv_flow_imp.g_varchar2_table(26743) := '3A6228302C22476F20546F20426F74746F6D20486F76657222292C616C6961733A22476F20546F20426F74746F6D20486F766572222C707265636F6E646974696F6E3A6C682E686F766572466F63757365642C6B624F7074733A7B6B62457870723A6C68';
wwv_flow_imp.g_varchar2_table(26744) := '2E686F766572466F63757365642C7072696D6172793A31332C7365636F6E646172793A5B323036365D2C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C22476F20746F2074686520626F74746F6D206F66';
wwv_flow_imp.g_varchar2_table(26745) := '2074686520656469746F7220686F7665722E22297D7D297D72756E28652C74297B636F6E7374206E3D5F592E6765742874293B6E26266E2E676F546F426F74746F6D28297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(26746) := '746F7228297B7375706572287B69643A6E6A2C6C6162656C3A6228302C22496E63726561736520486F76657220566572626F73697479204C6576656C22292C616C6961733A22496E63726561736520486F76657220566572626F73697479204C6576656C';
wwv_flow_imp.g_varchar2_table(26747) := '222C707265636F6E646974696F6E3A6C682E686F766572466F63757365647D297D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D5F592E676574287429297C7C766F696420303D3D3D6E7C7C6E2E757064617465466F63757365644D6172';
wwv_flow_imp.g_varchar2_table(26748) := '6B646F776E486F766572566572626F736974794C6576656C285F772E496E637265617365297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A696A2C6C6162656C3A6228302C2244';
wwv_flow_imp.g_varchar2_table(26749) := '6563726561736520486F76657220566572626F73697479204C6576656C22292C616C6961733A22446563726561736520486F76657220566572626F73697479204C6576656C222C707265636F6E646974696F6E3A6C682E686F766572466F63757365647D';
wwv_flow_imp.g_varchar2_table(26750) := '297D72756E28652C742C6E297B76617220693B6E756C6C3D3D3D28693D5F592E676574287429297C7C766F696420303D3D3D697C7C692E757064617465466F63757365644D61726B646F776E486F766572566572626F736974794C6576656C285F772E44';
wwv_flow_imp.g_varchar2_table(26751) := '65637265617365297D7D292C44712E7265676973746572287A71292C44712E7265676973746572286533292C5662282828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F72285F66293B6E262628742E61646452756C6528602E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(26752) := '6F2D656469746F72202E6D6F6E61636F2D686F766572202E686F7665722D726F773A6E6F74283A66697273742D6368696C64293A6E6F74283A656D70747929207B20626F726465722D746F703A2031707820736F6C696420247B6E2E7472616E73706172';
wwv_flow_imp.g_varchar2_table(26753) := '656E74282E35297D3B207D60292C742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572206872207B20626F726465722D746F703A2031707820736F6C696420247B6E2E7472616E73706172656E74282E3529';
wwv_flow_imp.g_varchar2_table(26754) := '7D3B207D60292C742E61646452756C6528602E6D6F6E61636F2D656469746F72202E6D6F6E61636F2D686F766572206872207B20626F726465722D626F74746F6D3A2030707820736F6C696420247B6E2E7472616E73706172656E74282E35297D3B207D';
wwv_flow_imp.g_varchar2_table(26755) := '6029297D29293B7661722074333D6E2839333337292C6E333D7B7D3B6E332E7374796C655461675472616E73666F726D3D6A7228292C6E332E736574417474726962757465733D567228292C6E332E696E736572743D467228292E62696E64286E756C6C';
wwv_flow_imp.g_varchar2_table(26756) := '2C226865616422292C6E332E646F6D4150493D4F7228292C6E332E696E736572745374796C65456C656D656E743D487228292C4E7228292874332E412C6E33292C74332E41262674332E412E6C6F63616C73262674332E412E6C6F63616C733B636C6173';
wwv_flow_imp.g_varchar2_table(26757) := '7320693320657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E656469746F723D652C746869732E7769646765743D6E756C6C2C51262628746869732E5F726567697374657228652E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(26758) := '6765436F6E66696775726174696F6E282828293D3E746869732E75706461746528292929292C746869732E7570646174652829297D75706461746528297B636F6E737420653D21746869732E656469746F722E6765744F7074696F6E283931293B217468';
wwv_flow_imp.g_varchar2_table(26759) := '69732E7769646765742626653F746869732E7769646765743D6E6577206F3328746869732E656469746F72293A746869732E77696467657426262165262628746869732E7769646765742E646973706F736528292C746869732E7769646765743D6E756C';
wwv_flow_imp.g_varchar2_table(26760) := '6C297D646973706F736528297B73757065722E646973706F736528292C746869732E776964676574262628746869732E7769646765742E646973706F736528292C746869732E7769646765743D6E756C6C297D7D69332E49443D22656469746F722E636F';
wwv_flow_imp.g_varchar2_table(26761) := '6E747269622E6950616453686F774B6579626F617264223B636C617373206F3320657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E656469746F723D652C746869732E5F646F6D4E6F64653D646F63756D';
wwv_flow_imp.g_varchar2_table(26762) := '656E742E637265617465456C656D656E742822746578746172656122292C746869732E5F646F6D4E6F64652E636C6173734E616D653D226950616453686F774B6579626F617264222C746869732E5F726567697374657228627328746869732E5F646F6D';
wwv_flow_imp.g_varchar2_table(26763) := '4E6F64652C22746F7563687374617274222C28653D3E7B746869732E656469746F722E666F63757328297D2929292C746869732E5F726567697374657228627328746869732E5F646F6D4E6F64652C22666F637573222C28653D3E7B746869732E656469';
wwv_flow_imp.g_varchar2_table(26764) := '746F722E666F63757328297D2929292C746869732E656469746F722E6164644F7665726C61795769646765742874686973297D646973706F736528297B746869732E656469746F722E72656D6F76654F7665726C61795769646765742874686973292C73';
wwv_flow_imp.g_varchar2_table(26765) := '757065722E646973706F736528297D676574496428297B72657475726E206F332E49447D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B707265666572656E63';
wwv_flow_imp.g_varchar2_table(26766) := '653A317D7D7D6F332E49443D22656469746F722E636F6E747269622E53686F774B6579626F617264576964676574222C4A642869332E49442C69332C33293B636C6173732073337B636F6E7374727563746F7228652C742C6E297B746869732E5F656469';
wwv_flow_imp.g_varchar2_table(26767) := '7452616E67653D652C746869732E5F6F726967696E616C53656C656374696F6E3D742C746869732E5F746578743D6E7D676574456469744F7065726174696F6E7328652C74297B742E616464547261636B6564456469744F7065726174696F6E28746869';
wwv_flow_imp.g_varchar2_table(26768) := '732E5F6564697452616E67652C746869732E5F74657874297D636F6D70757465437572736F72537461746528652C74297B636F6E7374206E3D742E676574496E7665727365456469744F7065726174696F6E7328295B305D2E72616E67653B7265747572';
wwv_flow_imp.g_varchar2_table(26769) := '6E20746869732E5F6F726967696E616C53656C656374696F6E2E6973456D70747928293F6E6577206168286E2E656E644C696E654E756D6265722C4D6174682E6D696E28746869732E5F6F726967696E616C53656C656374696F6E2E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(26770) := '436F6C756D6E2C6E2E656E64436F6C756D6E292C6E2E656E644C696E654E756D6265722C4D6174682E6D696E28746869732E5F6F726967696E616C53656C656374696F6E2E706F736974696F6E436F6C756D6E2C6E2E656E64436F6C756D6E29293A6E65';
wwv_flow_imp.g_varchar2_table(26771) := '77206168286E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E2D746869732E5F746578742E6C656E6774682C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E297D7D7661722072333D6E2836343337292C61333D7B';
wwv_flow_imp.g_varchar2_table(26772) := '7D3B61332E7374796C655461675472616E73666F726D3D6A7228292C61332E736574417474726962757465733D567228292C61332E696E736572743D467228292E62696E64286E756C6C2C226865616422292C61332E646F6D4150493D4F7228292C6133';
wwv_flow_imp.g_varchar2_table(26773) := '2E696E736572745374796C65456C656D656E743D487228292C4E7228292872332E412C6133292C72332E41262672332E412E6C6F63616C73262672332E412E6C6F63616C733B766172206C333B6C65742063333D6C333D636C6173737B73746174696320';
wwv_flow_imp.g_varchar2_table(26774) := '6765742865297B72657475726E20652E676574436F6E747269627574696F6E286C332E4944297D636F6E7374727563746F7228652C74297B746869732E656469746F723D652C746869732E656469746F72576F726B6572536572766963653D742C746869';
wwv_flow_imp.g_varchar2_table(26775) := '732E6465636F726174696F6E733D746869732E656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28297D646973706F736528297B7D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D746869732E637572';
wwv_flow_imp.g_varchar2_table(26776) := '72656E7452657175657374297C7C766F696420303D3D3D6E7C7C6E2E63616E63656C28293B636F6E737420693D746869732E656469746F722E67657453656C656374696F6E28292C6F3D746869732E656469746F722E6765744D6F64656C28293B696628';
wwv_flow_imp.g_varchar2_table(26777) := '216F7C7C21692972657475726E3B6C657420733D693B696628732E73746172744C696E654E756D626572213D3D732E656E644C696E654E756D6265722972657475726E3B636F6E737420723D6E657720636B28746869732E656469746F722C35292C613D';
wwv_flow_imp.g_varchar2_table(26778) := '6F2E7572693B72657475726E20746869732E656469746F72576F726B6572536572766963652E63616E4E6176696761746556616C75655365742861293F28746869732E63757272656E74526571756573743D46742828653D3E746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(26779) := '576F726B6572536572766963652E6E6176696761746556616C756553657428612C732C742929292C746869732E63757272656E74526571756573742E7468656E2828743D3E7B766172206E3B69662821747C7C21742E72616E67657C7C21742E76616C75';
wwv_flow_imp.g_varchar2_table(26780) := '652972657475726E3B69662821722E76616C696461746528746869732E656469746F72292972657475726E3B636F6E737420693D72682E6C69667428742E72616E6765293B6C6574206F3D742E72616E67653B636F6E737420613D742E76616C75652E6C';
wwv_flow_imp.g_varchar2_table(26781) := '656E6774682D28732E656E64436F6C756D6E2D732E7374617274436F6C756D6E293B6F3D7B73746172744C696E654E756D6265723A6F2E73746172744C696E654E756D6265722C7374617274436F6C756D6E3A6F2E7374617274436F6C756D6E2C656E64';
wwv_flow_imp.g_varchar2_table(26782) := '4C696E654E756D6265723A6F2E656E644C696E654E756D6265722C656E64436F6C756D6E3A6F2E7374617274436F6C756D6E2B742E76616C75652E6C656E6774687D2C613E31262628733D6E657720616828732E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(26783) := '732E7374617274436F6C756D6E2C732E656E644C696E654E756D6265722C732E656E64436F6C756D6E2B612D3129293B636F6E7374206C3D6E657720733328692C732C742E76616C7565293B746869732E656469746F722E70757368556E646F53746F70';
wwv_flow_imp.g_varchar2_table(26784) := '28292C746869732E656469746F722E65786563757465436F6D6D616E6428652C6C292C746869732E656469746F722E70757368556E646F53746F7028292C746869732E6465636F726174696F6E732E736574285B7B72616E67653A6F2C6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(26785) := '3A6C332E4445434F524154494F4E7D5D292C6E756C6C3D3D3D286E3D746869732E6465636F726174696F6E52656D6F766572297C7C766F696420303D3D3D6E7C7C6E2E63616E63656C28292C746869732E6465636F726174696F6E52656D6F7665723D57';
wwv_flow_imp.g_varchar2_table(26786) := '7428333530292C746869732E6465636F726174696F6E52656D6F7665722E7468656E282828293D3E746869732E6465636F726174696F6E732E636C656172282929292E6361746368286B65297D29292E6361746368286B6529293A50726F6D6973652E72';
wwv_flow_imp.g_varchar2_table(26787) := '65736F6C766528766F69642030297D7D3B66756E6374696F6E20643328652C74297B6C6574206E3D303B666F72286C657420693D303B693C652E6C656E6774683B692B2B29225C74223D3D3D652E6368617241742869293F6E2B3D743A6E2B2B3B726574';
wwv_flow_imp.g_varchar2_table(26788) := '75726E206E7D66756E6374696F6E20683328652C742C6E297B653D653C303F303A653B6C657420693D22223B696628216E297B636F6E7374206E3D4D6174682E666C6F6F7228652F74293B65253D743B666F72286C657420653D303B653C6E3B652B2B29';
wwv_flow_imp.g_varchar2_table(26789) := '692B3D225C74227D666F72286C657420743D303B743C653B742B2B29692B3D2220223B72657475726E20697D66756E6374696F6E20753328652C742C6E2C692C6F297B696628313D3D3D652E6765744C696E65436F756E7428292626313D3D3D652E6765';
wwv_flow_imp.g_varchar2_table(26790) := '744C696E654D6178436F6C756D6E2831292972657475726E5B5D3B636F6E737420733D742E6765744C616E6775616765436F6E66696775726174696F6E28652E6765744C616E677561676549642829292E696E64656E746174696F6E52756C65733B6966';
wwv_flow_imp.g_varchar2_table(26791) := '2821732972657475726E5B5D3B666F7228693D4D6174682E6D696E28692C652E6765744C696E65436F756E742829293B6E3C3D692626732E756E496E64656E7465644C696E655061747465726E3B297B636F6E737420743D652E6765744C696E65436F6E';
wwv_flow_imp.g_varchar2_table(26792) := '74656E74286E293B69662821732E756E496E64656E7465644C696E655061747465726E2E7465737428742929627265616B3B6E2B2B7D6966286E3E692D312972657475726E5B5D3B636F6E73747B74616253697A653A722C696E64656E7453697A653A61';
wwv_flow_imp.g_varchar2_table(26793) := '2C696E736572745370616365733A6C7D3D652E6765744F7074696F6E7328292C633D28652C74293D3E28743D747C7C312C79532E7368696674496E64656E7428652C652E6C656E6774682B742C722C612C6C29292C643D28652C74293D3E28743D747C7C';
wwv_flow_imp.g_varchar2_table(26794) := '312C79532E756E7368696674496E64656E7428652C652E6C656E6774682B742C722C612C6C29292C683D5B5D3B6C657420753B636F6E737420703D652E6765744C696E65436F6E74656E74286E293B6C657420673D703B6966286E756C6C213D6F297B75';
wwv_flow_imp.g_varchar2_table(26795) := '3D6F3B636F6E737420653D66692870293B673D752B702E737562737472696E6728652E6C656E677468292C732E6465637265617365496E64656E745061747465726E2626732E6465637265617365496E64656E745061747465726E2E7465737428672926';
wwv_flow_imp.g_varchar2_table(26796) := '2628753D642875292C673D752B702E737562737472696E6728652E6C656E67746829292C70213D3D672626682E70757368286A712E7265706C6163654D6F7665286E6577206168286E2C312C6E2C652E6C656E6774682B31292C677528752C612C6C2929';
wwv_flow_imp.g_varchar2_table(26797) := '297D656C736520753D66692870293B6C6574206D3D753B732E696E637265617365496E64656E745061747465726E2626732E696E637265617365496E64656E745061747465726E2E746573742867293F286D3D63286D292C753D63287529293A732E696E';
wwv_flow_imp.g_varchar2_table(26798) := '64656E744E6578744C696E655061747465726E2626732E696E64656E744E6578744C696E655061747465726E2E746573742867292626286D3D63286D29293B666F72286C657420743D2B2B6E3B743C3D693B742B2B297B636F6E7374206E3D652E676574';
wwv_flow_imp.g_varchar2_table(26799) := '4C696E65436F6E74656E742874292C693D6669286E292C6F3D6D2B6E2E737562737472696E6728692E6C656E677468293B732E6465637265617365496E64656E745061747465726E2626732E6465637265617365496E64656E745061747465726E2E7465';
wwv_flow_imp.g_varchar2_table(26800) := '7374286F292626286D3D64286D292C753D64287529292C69213D3D6D2626682E70757368286A712E7265706C6163654D6F7665286E657720616828742C312C742C692E6C656E6774682B31292C6775286D2C612C6C2929292C732E756E496E64656E7465';
wwv_flow_imp.g_varchar2_table(26801) := '644C696E655061747465726E2626732E756E496E64656E7465644C696E655061747465726E2E74657374286E297C7C28732E696E637265617365496E64656E745061747465726E2626732E696E637265617365496E64656E745061747465726E2E746573';
wwv_flow_imp.g_varchar2_table(26802) := '74286F293F28753D632875292C6D3D75293A6D3D732E696E64656E744E6578744C696E655061747465726E2626732E696E64656E744E6578744C696E655061747465726E2E74657374286F293F63286D293A75297D72657475726E20687D63332E49443D';
wwv_flow_imp.g_varchar2_table(26803) := '22656469746F722E636F6E747269622E696E506C6163655265706C616365436F6E74726F6C6C6572222C63332E4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A22696E2D706C6163652D7265706C616365222C';
wwv_flow_imp.g_varchar2_table(26804) := '636C6173734E616D653A2276616C75655365745265706C6163656D656E74227D292C63333D6C333D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F';
wwv_flow_imp.g_varchar2_table(26805) := '693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E646563';
wwv_flow_imp.g_varchar2_table(26806) := '6F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C';
wwv_flow_imp.g_varchar2_table(26807) := '6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B';
wwv_flow_imp.g_varchar2_table(26808) := '74286E2C692C65297D7D28312C7A5A295D2C6333292C4A642863332E49442C63332C34292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E506C';
wwv_flow_imp.g_varchar2_table(26809) := '6163655265706C6163652E7570222C6C6162656C3A6228302C225265706C61636520776974682050726576696F75732056616C756522292C616C6961733A225265706C61636520776974682050726576696F75732056616C7565222C707265636F6E6469';
wwv_flow_imp.g_varchar2_table(26810) := '74696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A333135392C7765696768743A3130307D7D297D72756E28652C74297B636F6E7374206E3D63332E6765';
wwv_flow_imp.g_varchar2_table(26811) := '742874293B72657475726E206E3F6E2E72756E28746869732E69642C2131293A50726F6D6973652E7265736F6C766528766F69642030297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B';
wwv_flow_imp.g_varchar2_table(26812) := '69643A22656469746F722E616374696F6E2E696E506C6163655265706C6163652E646F776E222C6C6162656C3A6228302C225265706C6163652077697468204E6578742056616C756522292C616C6961733A225265706C6163652077697468204E657874';
wwv_flow_imp.g_varchar2_table(26813) := '2056616C7565222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A333136312C7765696768743A3130307D7D297D72756E28652C';
wwv_flow_imp.g_varchar2_table(26814) := '74297B636F6E7374206E3D63332E6765742874293B72657475726E206E3F6E2E72756E28746869732E69642C2130293A50726F6D6973652E7265736F6C766528766F69642030297D7D293B636C61737320703320657874656E64732055647B636F6E7374';
wwv_flow_imp.g_varchar2_table(26815) := '727563746F7228297B7375706572287B69643A70332E49442C6C6162656C3A6228302C22436F6E7665727420496E64656E746174696F6E20746F2053706163657322292C616C6961733A22436F6E7665727420496E64656E746174696F6E20746F205370';
wwv_flow_imp.g_varchar2_table(26816) := '61636573222C707265636F6E646974696F6E3A6C682E7772697461626C652C6D657461646174613A7B6465736372697074696F6E3A5F28302C22436F6E76657274207468652074616220696E64656E746174696F6E20746F207370616365732E22297D7D';
wwv_flow_imp.g_varchar2_table(26817) := '297D72756E28652C74297B636F6E7374206E3D742E6765744D6F64656C28293B696628216E2972657475726E3B636F6E737420693D6E2E6765744F7074696F6E7328292C6F3D742E67657453656C656374696F6E28293B696628216F2972657475726E3B';
wwv_flow_imp.g_varchar2_table(26818) := '636F6E737420733D6E6577205333286F2C692E74616253697A65293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C5B735D292C742E70757368556E646F53746F7028292C6E2E7570646174';
wwv_flow_imp.g_varchar2_table(26819) := '654F7074696F6E73287B696E736572745370616365733A21307D297D7D70332E49443D22656469746F722E616374696F6E2E696E64656E746174696F6E546F537061636573223B636C61737320673320657874656E64732055647B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(26820) := '6F7228297B7375706572287B69643A67332E49442C6C6162656C3A6228302C22436F6E7665727420496E64656E746174696F6E20746F205461627322292C616C6961733A22436F6E7665727420496E64656E746174696F6E20746F2054616273222C7072';
wwv_flow_imp.g_varchar2_table(26821) := '65636F6E646974696F6E3A6C682E7772697461626C652C6D657461646174613A7B6465736372697074696F6E3A5F28302C22436F6E76657274207468652073706163657320696E64656E746174696F6E20746F20746162732E22297D7D297D72756E2865';
wwv_flow_imp.g_varchar2_table(26822) := '2C74297B636F6E7374206E3D742E6765744D6F64656C28293B696628216E2972657475726E3B636F6E737420693D6E2E6765744F7074696F6E7328292C6F3D742E67657453656C656374696F6E28293B696628216F2972657475726E3B636F6E73742073';
wwv_flow_imp.g_varchar2_table(26823) := '3D6E6577207833286F2C692E74616253697A65293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C5B735D292C742E70757368556E646F53746F7028292C6E2E7570646174654F7074696F6E';
wwv_flow_imp.g_varchar2_table(26824) := '73287B696E736572745370616365733A21317D297D7D67332E49443D22656469746F722E616374696F6E2E696E64656E746174696F6E546F54616273223B636C617373206D3320657874656E64732055647B636F6E7374727563746F7228652C742C6E29';
wwv_flow_imp.g_varchar2_table(26825) := '7B7375706572286E292C746869732E696E736572745370616365733D652C746869732E646973706C617953697A654F6E6C793D747D72756E28652C74297B636F6E7374206E3D652E676574284C45292C693D652E676574286663292C6F3D742E6765744D';
wwv_flow_imp.g_varchar2_table(26826) := '6F64656C28293B696628216F2972657475726E3B636F6E737420733D692E6765744372656174696F6E4F7074696F6E73286F2E6765744C616E6775616765496428292C6F2E7572692C6F2E6973466F7253696D706C65576964676574292C723D6F2E6765';
wwv_flow_imp.g_varchar2_table(26827) := '744F7074696F6E7328292C613D5B312C322C332C342C352C362C372C385D2E6D61702828653D3E287B69643A652E746F537472696E6728292C6C6162656C3A652E746F537472696E6728292C6465736372697074696F6E3A653D3D3D732E74616253697A';
wwv_flow_imp.g_varchar2_table(26828) := '652626653D3D3D722E74616253697A653F6228302C22436F6E66696775726564205461622053697A6522293A653D3D3D732E74616253697A653F6228302C2244656661756C74205461622053697A6522293A653D3D3D722E74616253697A653F6228302C';
wwv_flow_imp.g_varchar2_table(26829) := '2243757272656E74205461622053697A6522293A766F696420307D2929292C6C3D4D6174682E6D696E286F2E6765744F7074696F6E7328292E74616253697A652D312C37293B73657454696D656F7574282828293D3E7B6E2E7069636B28612C7B706C61';
wwv_flow_imp.g_varchar2_table(26830) := '6365486F6C6465723A6228302C2253656C656374205461622053697A6520666F722043757272656E742046696C6522292C6163746976654974656D3A615B6C5D7D292E7468656E2828653D3E7B6966286526266F2626216F2E6973446973706F73656428';
wwv_flow_imp.g_varchar2_table(26831) := '29297B636F6E737420743D7061727365496E7428652E6C6162656C2C3130293B746869732E646973706C617953697A654F6E6C793F6F2E7570646174654F7074696F6E73287B74616253697A653A747D293A6F2E7570646174654F7074696F6E73287B74';
wwv_flow_imp.g_varchar2_table(26832) := '616253697A653A742C696E64656E7453697A653A742C696E736572745370616365733A746869732E696E736572745370616365737D297D7D29297D292C3530297D7D636C61737320663320657874656E6473206D337B636F6E7374727563746F7228297B';
wwv_flow_imp.g_varchar2_table(26833) := '73757065722821312C21312C7B69643A66332E49442C6C6162656C3A6228302C22496E64656E74205573696E67205461627322292C616C6961733A22496E64656E74205573696E672054616273222C707265636F6E646974696F6E3A766F696420302C6D';
wwv_flow_imp.g_varchar2_table(26834) := '657461646174613A7B6465736372697074696F6E3A5F28302C2255736520696E64656E746174696F6E207769746820746162732E22297D7D297D7D66332E49443D22656469746F722E616374696F6E2E696E64656E745573696E6754616273223B636C61';
wwv_flow_imp.g_varchar2_table(26835) := '737320763320657874656E6473206D337B636F6E7374727563746F7228297B73757065722821302C21312C7B69643A76332E49442C6C6162656C3A6228302C22496E64656E74205573696E672053706163657322292C616C6961733A22496E64656E7420';
wwv_flow_imp.g_varchar2_table(26836) := '5573696E6720537061636573222C707265636F6E646974696F6E3A766F696420302C6D657461646174613A7B6465736372697074696F6E3A5F28302C2255736520696E64656E746174696F6E2077697468207370616365732E22297D7D297D7D76332E49';
wwv_flow_imp.g_varchar2_table(26837) := '443D22656469746F722E616374696F6E2E696E64656E745573696E67537061636573223B636C61737320623320657874656E6473206D337B636F6E7374727563746F7228297B73757065722821302C21302C7B69643A62332E49442C6C6162656C3A6228';
wwv_flow_imp.g_varchar2_table(26838) := '302C224368616E67652054616220446973706C61792053697A6522292C616C6961733A224368616E67652054616220446973706C61792053697A65222C707265636F6E646974696F6E3A766F696420302C6D657461646174613A7B646573637269707469';
wwv_flow_imp.g_varchar2_table(26839) := '6F6E3A5F28302C224368616E6765207468652073706163652073697A65206571756976616C656E74206F6620746865207461622E22297D7D297D7D62332E49443D22656469746F722E616374696F6E2E6368616E6765546162446973706C617953697A65';
wwv_flow_imp.g_varchar2_table(26840) := '223B636C617373205F3320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A5F332E49442C6C6162656C3A6228302C2244657465637420496E64656E746174696F6E2066726F6D20436F6E74656E7422292C616C69';
wwv_flow_imp.g_varchar2_table(26841) := '61733A2244657465637420496E64656E746174696F6E2066726F6D20436F6E74656E74222C707265636F6E646974696F6E3A766F696420302C6D657461646174613A7B6465736372697074696F6E3A5F28302C224465746563742074686520696E64656E';
wwv_flow_imp.g_varchar2_table(26842) := '746174696F6E2066726F6D20636F6E74656E742E22297D7D297D72756E28652C74297B636F6E7374206E3D652E676574286663292C693D742E6765744D6F64656C28293B69662821692972657475726E3B636F6E7374206F3D6E2E676574437265617469';
wwv_flow_imp.g_varchar2_table(26843) := '6F6E4F7074696F6E7328692E6765744C616E6775616765496428292C692E7572692C692E6973466F7253696D706C65576964676574293B692E646574656374496E64656E746174696F6E286F2E696E736572745370616365732C6F2E74616253697A6529';
wwv_flow_imp.g_varchar2_table(26844) := '7D7D5F332E49443D22656469746F722E616374696F6E2E646574656374496E64656E746174696F6E223B636C6173732079337B636F6E7374727563746F7228652C74297B746869732E5F696E697469616C53656C656374696F6E3D742C746869732E5F65';
wwv_flow_imp.g_varchar2_table(26845) := '646974733D5B5D2C746869732E5F73656C656374696F6E49643D6E756C6C3B666F7228636F6E73742074206F66206529742E72616E6765262622737472696E67223D3D747970656F6620742E746578742626746869732E5F65646974732E707573682874';
wwv_flow_imp.g_varchar2_table(26846) := '297D676574456469744F7065726174696F6E7328652C74297B666F7228636F6E73742065206F6620746869732E5F656469747329742E616464456469744F7065726174696F6E2872682E6C69667428652E72616E6765292C652E74657874293B6C657420';
wwv_flow_imp.g_varchar2_table(26847) := '6E3D21313B41727261792E6973417272617928746869732E5F6564697473292626313D3D3D746869732E5F65646974732E6C656E6774682626746869732E5F696E697469616C53656C656374696F6E2E6973456D7074792829262628746869732E5F6564';
wwv_flow_imp.g_varchar2_table(26848) := '6974735B305D2E72616E67652E7374617274436F6C756D6E3D3D3D746869732E5F696E697469616C53656C656374696F6E2E656E64436F6C756D6E2626746869732E5F65646974735B305D2E72616E67652E73746172744C696E654E756D6265723D3D3D';
wwv_flow_imp.g_varchar2_table(26849) := '746869732E5F696E697469616C53656C656374696F6E2E656E644C696E654E756D6265723F286E3D21302C746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F696E697469616C53656C656374696F6E';
wwv_flow_imp.g_varchar2_table(26850) := '2C213029293A746869732E5F65646974735B305D2E72616E67652E656E64436F6C756D6E3D3D3D746869732E5F696E697469616C53656C656374696F6E2E7374617274436F6C756D6E2626746869732E5F65646974735B305D2E72616E67652E656E644C';
wwv_flow_imp.g_varchar2_table(26851) := '696E654E756D6265723D3D3D746869732E5F696E697469616C53656C656374696F6E2E73746172744C696E654E756D6265722626286E3D21302C746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F69';
wwv_flow_imp.g_varchar2_table(26852) := '6E697469616C53656C656374696F6E2C21312929292C6E7C7C28746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F696E697469616C53656C656374696F6E29297D636F6D70757465437572736F7253';
wwv_flow_imp.g_varchar2_table(26853) := '7461746528652C74297B72657475726E20742E676574547261636B656453656C656374696F6E28746869732E5F73656C656374696F6E4964297D7D6C65742077333D636C6173737B636F6E7374727563746F7228652C74297B746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(26854) := '3D652C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E63616C6C4F6E446973706F73653D6E65772061742C746869732E63616C6C4F6E4D6F64656C3D6E65772061742C746869732E63616C6C4F';
wwv_flow_imp.g_varchar2_table(26855) := '6E446973706F73652E61646428652E6F6E4469644368616E6765436F6E66696775726174696F6E282828293D3E746869732E75706461746528292929292C746869732E63616C6C4F6E446973706F73652E61646428652E6F6E4469644368616E67654D6F';
wwv_flow_imp.g_varchar2_table(26856) := '64656C282828293D3E746869732E75706461746528292929292C746869732E63616C6C4F6E446973706F73652E61646428652E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E746869732E75706461746528292929297D7570';
wwv_flow_imp.g_varchar2_table(26857) := '6461746528297B746869732E63616C6C4F6E4D6F64656C2E636C65617228292C746869732E656469746F722E6765744F7074696F6E283132293C347C7C746869732E656469746F722E6765744F7074696F6E283535297C7C746869732E656469746F722E';
wwv_flow_imp.g_varchar2_table(26858) := '6861734D6F64656C28292626746869732E63616C6C4F6E4D6F64656C2E61646428746869732E656469746F722E6F6E44696450617374652828287B72616E67653A657D293D3E7B746869732E747269676765722865297D2929297D747269676765722865';
wwv_flow_imp.g_varchar2_table(26859) := '297B636F6E737420743D746869732E656469746F722E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D747C7C742E6C656E6774683E312972657475726E3B636F6E7374206E3D746869732E656469746F722E6765744D6F64656C28293B';
wwv_flow_imp.g_varchar2_table(26860) := '696628216E2972657475726E3B696628216E2E746F6B656E697A6174696F6E2E69734368656170546F546F6B656E697A6528652E6765745374617274506F736974696F6E28292E6C696E654E756D626572292972657475726E3B636F6E737420693D7468';
wwv_flow_imp.g_varchar2_table(26861) := '69732E656469746F722E6765744F7074696F6E283132292C7B74616253697A653A6F2C696E64656E7453697A653A732C696E736572745370616365733A727D3D6E2E6765744F7074696F6E7328292C613D5B5D2C6C3D7B7368696674496E64656E743A65';
wwv_flow_imp.g_varchar2_table(26862) := '3D3E79532E7368696674496E64656E7428652C652E6C656E6774682B312C6F2C732C72292C756E7368696674496E64656E743A653D3E79532E756E7368696674496E64656E7428652C652E6C656E6774682B312C6F2C732C72297D3B6C657420633D652E';
wwv_flow_imp.g_varchar2_table(26863) := '73746172744C696E654E756D6265723B666F72283B633C3D652E656E644C696E654E756D6265722626746869732E73686F756C6449676E6F72654C696E65286E2C63293B29632B2B3B696628633E652E656E644C696E654E756D6265722972657475726E';
wwv_flow_imp.g_varchar2_table(26864) := '3B6C657420643D6E2E6765744C696E65436F6E74656E742863293B696628212F5C532F2E7465737428642E737562737472696E6728302C652E7374617274436F6C756D6E2D312929297B636F6E737420653D785328692C6E2C6E2E6765744C616E677561';
wwv_flow_imp.g_varchar2_table(26865) := '6765496428292C632C6C2C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286E756C6C213D3D65297B636F6E737420743D66692864292C693D643328652C6F293B69662869213D3D643328742C6F29297B';
wwv_flow_imp.g_varchar2_table(26866) := '636F6E737420653D683328692C6F2C72293B612E70757368287B72616E67653A6E657720726828632C312C632C742E6C656E6774682B31292C746578743A657D292C643D652B642E73756273747228742E6C656E677468297D656C73657B636F6E737420';
wwv_flow_imp.g_varchar2_table(26867) := '653D6B53286E2C632C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B696628303D3D3D657C7C383D3D3D652972657475726E7D7D7D636F6E737420683D633B666F72283B633C652E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(26868) := '65722626212F5C532F2E74657374286E2E6765744C696E65436F6E74656E7428632B3129293B29632B2B3B69662863213D3D652E656E644C696E654E756D626572297B636F6E737420743D785328692C7B746F6B656E697A6174696F6E3A7B6765744C69';
wwv_flow_imp.g_varchar2_table(26869) := '6E65546F6B656E733A653D3E6E2E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732865292C6765744C616E677561676549643A28293D3E6E2E6765744C616E6775616765496428292C6765744C616E677561676549644174506F736974';
wwv_flow_imp.g_varchar2_table(26870) := '696F6E3A28652C74293D3E6E2E6765744C616E677561676549644174506F736974696F6E28652C74297D2C6765744C696E65436F6E74656E743A653D3E653D3D3D683F643A6E2E6765744C696E65436F6E74656E742865297D2C6E2E6765744C616E6775';
wwv_flow_imp.g_varchar2_table(26871) := '616765496428292C632B312C6C2C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286E756C6C213D3D74297B636F6E737420693D643328742C6F292C733D6433286669286E2E6765744C696E65436F6E74';
wwv_flow_imp.g_varchar2_table(26872) := '656E7428632B3129292C6F293B69662869213D3D73297B636F6E737420743D692D733B666F72286C657420693D632B313B693C3D652E656E644C696E654E756D6265723B692B2B297B636F6E737420653D6669286E2E6765744C696E65436F6E74656E74';
wwv_flow_imp.g_varchar2_table(26873) := '286929292C733D683328643328652C6F292B742C6F2C72293B73213D3D652626612E70757368287B72616E67653A6E657720726828692C312C692C652E6C656E6774682B31292C746578743A737D297D7D7D7D696628612E6C656E6774683E30297B7468';
wwv_flow_imp.g_varchar2_table(26874) := '69732E656469746F722E70757368556E646F53746F7028293B636F6E737420653D6E657720793328612C746869732E656469746F722E67657453656C656374696F6E2829293B746869732E656469746F722E65786563757465436F6D6D616E6428226175';
wwv_flow_imp.g_varchar2_table(26875) := '746F496E64656E744F6E5061737465222C65292C746869732E656469746F722E70757368556E646F53746F7028297D7D73686F756C6449676E6F72654C696E6528652C74297B652E746F6B656E697A6174696F6E2E666F726365546F6B656E697A617469';
wwv_flow_imp.g_varchar2_table(26876) := '6F6E2874293B636F6E7374206E3D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2874293B696628303D3D3D6E2972657475726E21303B636F6E737420693D652E746F6B656E697A6174696F6E2E6765744C696E6554';
wwv_flow_imp.g_varchar2_table(26877) := '6F6B656E732874293B696628692E676574436F756E7428293E30297B636F6E737420653D692E66696E64546F6B656E496E64657841744F6666736574286E293B696628653E3D302626313D3D3D692E6765745374616E64617264546F6B656E5479706528';
wwv_flow_imp.g_varchar2_table(26878) := '65292972657475726E21307D72657475726E21317D646973706F736528297B746869732E63616C6C4F6E446973706F73652E646973706F736528292C746869732E63616C6C4F6E4D6F64656C2E646973706F736528297D7D3B66756E6374696F6E204333';
wwv_flow_imp.g_varchar2_table(26879) := '28652C742C6E2C69297B696628313D3D3D652E6765744C696E65436F756E7428292626313D3D3D652E6765744C696E654D6178436F6C756D6E2831292972657475726E3B6C6574206F3D22223B666F72286C657420653D303B653C6E3B652B2B296F2B3D';
wwv_flow_imp.g_varchar2_table(26880) := '2220223B636F6E737420733D6E657720526567457870286F2C22676922293B666F72286C6574206E3D312C723D652E6765744C696E65436F756E7428293B6E3C3D723B6E2B2B297B6C657420723D652E6765744C696E6546697273744E6F6E5768697465';
wwv_flow_imp.g_varchar2_table(26881) := '7370616365436F6C756D6E286E293B696628303D3D3D72262628723D652E6765744C696E654D6178436F6C756D6E286E29292C313D3D3D7229636F6E74696E75653B636F6E737420613D6E6577207268286E2C312C6E2C72292C6C3D652E67657456616C';
wwv_flow_imp.g_varchar2_table(26882) := '7565496E52616E67652861292C633D693F6C2E7265706C616365282F5C742F67692C6F293A6C2E7265706C61636528732C225C7422293B742E616464456469744F7065726174696F6E28612C63297D7D77332E49443D22656469746F722E636F6E747269';
wwv_flow_imp.g_varchar2_table(26883) := '622E6175746F496E64656E744F6E5061737465222C77333D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50';
wwv_flow_imp.g_varchar2_table(26884) := '726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E';
wwv_flow_imp.g_varchar2_table(26885) := '6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C7229';
wwv_flow_imp.g_varchar2_table(26886) := '3B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28312C656729';
wwv_flow_imp.g_varchar2_table(26887) := '5D2C7733293B636C6173732053337B636F6E7374727563746F7228652C74297B746869732E73656C656374696F6E3D652C746869732E74616253697A653D742C746869732E73656C656374696F6E49643D6E756C6C7D676574456469744F706572617469';
wwv_flow_imp.g_varchar2_table(26888) := '6F6E7328652C74297B746869732E73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E73656C656374696F6E292C433328652C742C746869732E74616253697A652C2130297D636F6D70757465437572736F7253746174';
wwv_flow_imp.g_varchar2_table(26889) := '6528652C74297B72657475726E20742E676574547261636B656453656C656374696F6E28746869732E73656C656374696F6E4964297D7D636C6173732078337B636F6E7374727563746F7228652C74297B746869732E73656C656374696F6E3D652C7468';
wwv_flow_imp.g_varchar2_table(26890) := '69732E74616253697A653D742C746869732E73656C656374696F6E49643D6E756C6C7D676574456469744F7065726174696F6E7328652C74297B746869732E73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E73656C';
wwv_flow_imp.g_varchar2_table(26891) := '656374696F6E292C433328652C742C746869732E74616253697A652C2131297D636F6D70757465437572736F72537461746528652C74297B72657475726E20742E676574547261636B656453656C656374696F6E28746869732E73656C656374696F6E49';
wwv_flow_imp.g_varchar2_table(26892) := '64297D7D4A642877332E49442C77332C32292C5A64287033292C5A64286733292C5A64286633292C5A64287633292C5A64286233292C5A64285F33292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572';
wwv_flow_imp.g_varchar2_table(26893) := '287B69643A22656469746F722E616374696F6E2E7265696E64656E746C696E6573222C6C6162656C3A6228302C225265696E64656E74204C696E657322292C616C6961733A225265696E64656E74204C696E6573222C707265636F6E646974696F6E3A6C';
wwv_flow_imp.g_varchar2_table(26894) := '682E7772697461626C652C6D657461646174613A7B6465736372697074696F6E3A5F28302C225265696E64656E7420746865206C696E6573206F662074686520656469746F722E22297D7D297D72756E28652C74297B636F6E7374206E3D652E67657428';
wwv_flow_imp.g_varchar2_table(26895) := '6567292C693D742E6765744D6F64656C28293B69662821692972657475726E3B636F6E7374206F3D753328692C6E2C312C692E6765744C696E65436F756E742829293B6F2E6C656E6774683E30262628742E70757368556E646F53746F7028292C742E65';
wwv_flow_imp.g_varchar2_table(26896) := '786563757465456469747328746869732E69642C6F292C742E70757368556E646F53746F702829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E61637469';
wwv_flow_imp.g_varchar2_table(26897) := '6F6E2E7265696E64656E7473656C65637465646C696E6573222C6C6162656C3A6228302C225265696E64656E742053656C6563746564204C696E657322292C616C6961733A225265696E64656E742053656C6563746564204C696E6573222C707265636F';
wwv_flow_imp.g_varchar2_table(26898) := '6E646974696F6E3A6C682E7772697461626C652C6D657461646174613A7B6465736372697074696F6E3A5F28302C225265696E64656E74207468652073656C6563746564206C696E6573206F662074686520656469746F722E22297D7D297D72756E2865';
wwv_flow_imp.g_varchar2_table(26899) := '2C74297B636F6E7374206E3D652E676574286567292C693D742E6765744D6F64656C28293B69662821692972657475726E3B636F6E7374206F3D742E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D6F2972657475726E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(26900) := '20733D5B5D3B666F7228636F6E73742065206F66206F297B6C657420743D652E73746172744C696E654E756D6265722C6F3D652E656E644C696E654E756D6265723B69662874213D3D6F2626313D3D3D652E656E64436F6C756D6E26266F2D2D2C313D3D';
wwv_flow_imp.g_varchar2_table(26901) := '3D74297B696628743D3D3D6F29636F6E74696E75657D656C736520742D2D3B636F6E737420723D753328692C6E2C742C6F293B732E70757368282E2E2E72297D732E6C656E6774683E30262628742E70757368556E646F53746F7028292C742E65786563';
wwv_flow_imp.g_varchar2_table(26902) := '757465456469747328746869732E69642C73292C742E70757368556E646F53746F702829297D7D292C4A64284A512E49442C4A512C31292C44712E7265676973746572286E59293B636C617373206B3320657874656E6473206C747B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(26903) := '746F7228652C74297B737570657228292C746869732E636F6E746578744B6579536572766963653D652C746869732E6D6F64656C3D742C746869732E696E6C696E65436F6D706C6574696F6E56697369626C653D6B332E696E6C696E6553756767657374';
wwv_flow_imp.g_varchar2_table(26904) := '696F6E56697369626C652E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E696E6C696E65436F6D706C6574696F6E5375676765737473496E64656E746174696F6E3D6B332E696E6C696E655375676765737469';
wwv_flow_imp.g_varchar2_table(26905) := '6F6E486173496E64656E746174696F6E2E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E696E6C696E65436F6D706C6574696F6E5375676765737473496E64656E746174696F6E4C6573735468616E54616253';
wwv_flow_imp.g_varchar2_table(26906) := '697A653D6B332E696E6C696E6553756767657374696F6E486173496E64656E746174696F6E4C6573735468616E54616253697A652E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E7375707072657373537567';
wwv_flow_imp.g_varchar2_table(26907) := '67657374696F6E733D6B332E737570707265737353756767657374696F6E732E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E6D';
wwv_flow_imp.g_varchar2_table(26908) := '6F64656C2E726561642865292C6E3D6E756C6C3D3D743F766F696420303A742E73746174652E726561642865292C693D2121286E756C6C3D3D6E3F766F696420303A6E2E696E6C696E65436F6D706C6574696F6E292626766F69642030213D3D286E756C';
wwv_flow_imp.g_varchar2_table(26909) := '6C3D3D6E3F766F696420303A6E2E7072696D61727947686F73745465787429262621286E756C6C3D3D6E3F766F696420303A6E2E7072696D61727947686F7374546578742E6973456D7074792829293B746869732E696E6C696E65436F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(26910) := '6E56697369626C652E7365742869292C286E756C6C3D3D6E3F766F696420303A6E2E7072696D61727947686F737454657874292626286E756C6C3D3D6E3F766F696420303A6E2E696E6C696E65436F6D706C6574696F6E292626746869732E7375707072';
wwv_flow_imp.g_varchar2_table(26911) := '65737353756767657374696F6E732E736574286E2E696E6C696E65436F6D706C6574696F6E2E696E6C696E65436F6D706C6574696F6E2E736F757263652E696E6C696E65436F6D706C6574696F6E732E737570707265737353756767657374696F6E7329';
wwv_flow_imp.g_varchar2_table(26912) := '7D2929292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E6D6F64656C2E726561642865293B6C6574206E3D21312C693D21303B636F6E7374206F3D6E756C6C3D3D743F766F696420303A742E7072696D6172';
wwv_flow_imp.g_varchar2_table(26913) := '7947686F7374546578742E726561642865293B696628286E756C6C3D3D743F766F696420303A742E73656C6563746564537567676573744974656D2926266F26266F2E70617274732E6C656E6774683E30297B636F6E73747B636F6C756D6E3A652C6C69';
wwv_flow_imp.g_varchar2_table(26914) := '6E65733A737D3D6F2E70617274735B305D2C723D735B305D3B696628653C3D742E746578744D6F64656C2E6765744C696E65496E64656E74436F6C756D6E286F2E6C696E654E756D62657229297B6C657420653D6D692872293B2D313D3D3D6526262865';
wwv_flow_imp.g_varchar2_table(26915) := '3D722E6C656E6774682D31292C6E3D653E303B636F6E7374206F3D742E746578744D6F64656C2E6765744F7074696F6E7328292E74616253697A653B693D70752E76697369626C65436F6C756D6E46726F6D436F6C756D6E28722C652B312C6F293C6F7D';
wwv_flow_imp.g_varchar2_table(26916) := '7D746869732E696E6C696E65436F6D706C6574696F6E5375676765737473496E64656E746174696F6E2E736574286E292C746869732E696E6C696E65436F6D706C6574696F6E5375676765737473496E64656E746174696F6E4C6573735468616E546162';
wwv_flow_imp.g_varchar2_table(26917) := '53697A652E7365742869297D2929297D7D6B332E696E6C696E6553756767657374696F6E56697369626C653D6E6577206C642822696E6C696E6553756767657374696F6E56697369626C65222C21312C6228302C225768657468657220616E20696E6C69';
wwv_flow_imp.g_varchar2_table(26918) := '6E652073756767657374696F6E2069732076697369626C652229292C6B332E696E6C696E6553756767657374696F6E486173496E64656E746174696F6E3D6E6577206C642822696E6C696E6553756767657374696F6E486173496E64656E746174696F6E';
wwv_flow_imp.g_varchar2_table(26919) := '222C21312C6228302C22576865746865722074686520696E6C696E652073756767657374696F6E20737461727473207769746820776869746573706163652229292C6B332E696E6C696E6553756767657374696F6E486173496E64656E746174696F6E4C';
wwv_flow_imp.g_varchar2_table(26920) := '6573735468616E54616253697A653D6E6577206C642822696E6C696E6553756767657374696F6E486173496E64656E746174696F6E4C6573735468616E54616253697A65222C21302C6228302C22576865746865722074686520696E6C696E6520737567';
wwv_flow_imp.g_varchar2_table(26921) := '67657374696F6E20737461727473207769746820776869746573706163652074686174206973206C657373207468616E207768617420776F756C6420626520696E736572746564206279207461622229292C6B332E737570707265737353756767657374';
wwv_flow_imp.g_varchar2_table(26922) := '696F6E733D6E6577206C642822696E6C696E6553756767657374696F6E537570707265737353756767657374696F6E73222C766F696420302C6228302C22576865746865722073756767657374696F6E732073686F756C64206265207375707072657373';
wwv_flow_imp.g_varchar2_table(26923) := '656420666F72207468652063757272656E742073756767657374696F6E2229293B7661722045333D6E2838313639292C4C333D7B7D3B4C332E7374796C655461675472616E73666F726D3D6A7228292C4C332E736574417474726962757465733D567228';
wwv_flow_imp.g_varchar2_table(26924) := '292C4C332E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4C332E646F6D4150493D4F7228292C4C332E696E736572745374796C65456C656D656E743D487228292C4E7228292845332E412C4C33292C45332E41262645332E';
wwv_flow_imp.g_varchar2_table(26925) := '412E6C6F63616C73262645332E412E6C6F63616C733B636C6173732044337B636F6E7374727563746F7228652C74297B746869732E6C696E654E756D6265723D652C746869732E70617274733D747D657175616C732865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(26926) := '2E6C696E654E756D6265723D3D3D652E6C696E654E756D6265722626746869732E70617274732E6C656E6774683D3D3D652E70617274732E6C656E6774682626746869732E70617274732E6576657279282828742C6E293D3E742E657175616C7328652E';
wwv_flow_imp.g_varchar2_table(26927) := '70617274735B6E5D2929297D72656E646572466F7253637265656E5265616465722865297B696628303D3D3D746869732E70617274732E6C656E6774682972657475726E22223B636F6E737420743D746869732E70617274735B746869732E7061727473';
wwv_flow_imp.g_varchar2_table(26928) := '2E6C656E6774682D315D2C6E3D652E73756273747228302C742E636F6C756D6E2D31293B72657475726E206E657720247A285B2E2E2E746869732E70617274732E6D61702828653D3E6E657720557A2872682E66726F6D506F736974696F6E73286E6577';
wwv_flow_imp.g_varchar2_table(26929) := '206D6328312C652E636F6C756D6E29292C652E6C696E65732E6A6F696E28225C6E22292929295D292E6170706C79546F537472696E67286E292E737562737472696E6728746869732E70617274735B305D2E636F6C756D6E2D31297D6973456D70747928';
wwv_flow_imp.g_varchar2_table(26930) := '297B72657475726E20746869732E70617274732E65766572792828653D3E303D3D3D652E6C696E65732E6C656E67746829297D676574206C696E65436F756E7428297B72657475726E20312B746869732E70617274732E726564756365282828652C7429';
wwv_flow_imp.g_varchar2_table(26931) := '3D3E652B742E6C696E65732E6C656E6774682D31292C30297D7D636C6173732054337B636F6E7374727563746F7228652C742C6E297B746869732E636F6C756D6E3D652C746869732E746578743D742C746869732E707265766965773D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(26932) := '6C696E65733D676928746869732E74657874297D657175616C732865297B72657475726E20746869732E636F6C756D6E3D3D3D652E636F6C756D6E2626746869732E6C696E65732E6C656E6774683D3D3D652E6C696E65732E6C656E6774682626746869';
wwv_flow_imp.g_varchar2_table(26933) := '732E6C696E65732E6576657279282828742C6E293D3E743D3D3D652E6C696E65735B6E5D29297D7D636C6173732049337B636F6E7374727563746F7228652C742C6E2C693D30297B746869732E6C696E654E756D6265723D652C746869732E636F6C756D';
wwv_flow_imp.g_varchar2_table(26934) := '6E52616E67653D742C746869732E746578743D6E2C746869732E6164646974696F6E616C52657365727665644C696E65436F756E743D692C746869732E70617274733D5B6E657720543328746869732E636F6C756D6E52616E67652E656E64436F6C756D';
wwv_flow_imp.g_varchar2_table(26935) := '6E4578636C75736976652C746869732E746578742C2131295D2C746869732E6E65774C696E65733D676928746869732E74657874297D72656E646572466F7253637265656E5265616465722865297B72657475726E20746869732E6E65774C696E65732E';
wwv_flow_imp.g_varchar2_table(26936) := '6A6F696E28225C6E22297D676574206C696E65436F756E7428297B72657475726E20746869732E6E65774C696E65732E6C656E6774687D6973456D70747928297B72657475726E20746869732E70617274732E65766572792828653D3E303D3D3D652E6C';
wwv_flow_imp.g_varchar2_table(26937) := '696E65732E6C656E67746829297D657175616C732865297B72657475726E20746869732E6C696E654E756D6265723D3D3D652E6C696E654E756D6265722626746869732E636F6C756D6E52616E67652E657175616C7328652E636F6C756D6E52616E6765';
wwv_flow_imp.g_varchar2_table(26938) := '292626746869732E6E65774C696E65732E6C656E6774683D3D3D652E6E65774C696E65732E6C656E6774682626746869732E6E65774C696E65732E6576657279282828742C6E293D3E743D3D3D652E6E65774C696E65735B6E5D29292626746869732E61';
wwv_flow_imp.g_varchar2_table(26939) := '64646974696F6E616C52657365727665644C696E65436F756E743D3D3D652E6164646974696F6E616C52657365727665644C696E65436F756E747D7D66756E6374696F6E204D3328652C74297B72657475726E20506828652C742C4133297D66756E6374';
wwv_flow_imp.g_varchar2_table(26940) := '696F6E20413328652C74297B72657475726E20653D3D3D747C7C212821657C7C2174292626286520696E7374616E63656F6620443326267420696E7374616E63656F662044337C7C6520696E7374616E63656F6620493326267420696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(26941) := '66204933292626652E657175616C732874297D636F6E7374204E333D5B5D3B636C6173732050337B636F6E7374727563746F7228652C74297B696628746869732E7374617274436F6C756D6E3D652C746869732E656E64436F6C756D6E4578636C757369';
wwv_flow_imp.g_varchar2_table(26942) := '76653D742C653E74297468726F77206E6577204F6528607374617274436F6C756D6E20247B657D2063616E6E6F7420626520616674657220656E64436F6C756D6E4578636C757369766520247B747D60297D746F52616E67652865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(26943) := '6E657720726828652C746869732E7374617274436F6C756D6E2C652C746869732E656E64436F6C756D6E4578636C7573697665297D657175616C732865297B72657475726E20746869732E7374617274436F6C756D6E3D3D3D652E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(26944) := '6D6E2626746869732E656E64436F6C756D6E4578636C75736976653D3D3D652E656E64436F6C756D6E4578636C75736976657D7D66756E6374696F6E204F3328652C74297B636F6E7374206E3D6E65772061742C693D652E6372656174654465636F7261';
wwv_flow_imp.g_varchar2_table(26945) := '74696F6E73436F6C6C656374696F6E28293B72657475726E206E2E616464287449287B64656275674E616D653A28293D3E604170706C79206465636F726174696F6E732066726F6D20247B742E64656275674E616D657D607D2C28653D3E7B636F6E7374';
wwv_flow_imp.g_varchar2_table(26946) := '206E3D742E726561642865293B692E736574286E297D2929292C6E2E616464287B646973706F73653A28293D3E7B692E636C65617228297D7D292C6E7D66756E6374696F6E20523328652C74297B72657475726E206E6577206D6328652E6C696E654E75';
wwv_flow_imp.g_varchar2_table(26947) := '6D6265722D742E6C696E654E756D6265722B312C652E6C696E654E756D6265722D742E6C696E654E756D6265723D3D303F652E636F6C756D6E2D742E636F6C756D6E2B313A652E636F6C756D6E297D636F6E73742046333D2267686F73742D7465787422';
wwv_flow_imp.g_varchar2_table(26948) := '3B6C65742042333D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E656469746F723D652C746869732E6D6F64656C3D742C746869732E6C616E6775616765536572766963653D';
wwv_flow_imp.g_varchar2_table(26949) := '6E2C746869732E6973446973706F7365643D245428746869732C2131292C746869732E63757272656E74546578744D6F64656C3D614928746869732E656469746F722E6F6E4469644368616E67654D6F64656C2C2828293D3E746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(26950) := '2E6765744D6F64656C282929292C746869732E756953746174653D515428746869732C28653D3E7B696628746869732E6973446973706F7365642E726561642865292972657475726E3B636F6E737420743D746869732E63757272656E74546578744D6F';
wwv_flow_imp.g_varchar2_table(26951) := '64656C2E726561642865293B69662874213D3D746869732E6D6F64656C2E746172676574546578744D6F64656C2E726561642865292972657475726E3B636F6E7374206E3D746869732E6D6F64656C2E67686F7374546578742E726561642865293B6966';
wwv_flow_imp.g_varchar2_table(26952) := '28216E2972657475726E3B636F6E737420693D6E20696E7374616E63656F662049333F6E2E636F6C756D6E52616E67653A766F696420302C6F3D5B5D2C733D5B5D3B66756E6374696F6E207228652C74297B696628732E6C656E6774683E30297B636F6E';
wwv_flow_imp.g_varchar2_table(26953) := '7374206E3D735B732E6C656E6774682D315D3B7426266E2E6465636F726174696F6E732E70757368286E657720634E286E2E636F6E74656E742E6C656E6774682B312C6E2E636F6E74656E742E6C656E6774682B312B655B305D2E6C656E6774682C742C';
wwv_flow_imp.g_varchar2_table(26954) := '3029292C6E2E636F6E74656E742B3D655B305D2C653D652E736C6963652831297D666F7228636F6E7374206E206F66206529732E70757368287B636F6E74656E743A6E2C6465636F726174696F6E733A743F5B6E657720634E28312C6E2E6C656E677468';
wwv_flow_imp.g_varchar2_table(26955) := '2B312C742C30295D3A5B5D7D297D636F6E737420613D742E6765744C696E65436F6E74656E74286E2E6C696E654E756D626572293B6C6574206C2C633D303B666F7228636F6E73742065206F66206E2E7061727473297B6C657420743D652E6C696E6573';
wwv_flow_imp.g_varchar2_table(26956) := '3B766F696420303D3D3D6C3F286F2E70757368287B636F6C756D6E3A652E636F6C756D6E2C746578743A745B305D2C707265766965773A652E707265766965777D292C743D742E736C696365283129293A72285B612E737562737472696E6728632C652E';
wwv_flow_imp.g_varchar2_table(26957) := '636F6C756D6E2D31295D2C766F69642030292C742E6C656E6774683E302626287228742C4633292C766F696420303D3D3D6C2626652E636F6C756D6E3C3D612E6C656E6774682626286C3D652E636F6C756D6E29292C633D652E636F6C756D6E2D317D76';
wwv_flow_imp.g_varchar2_table(26958) := '6F69642030213D3D6C262672285B612E737562737472696E672863295D2C766F69642030293B636F6E737420643D766F69642030213D3D6C3F6E6577205033286C2C612E6C656E6774682B31293A766F696420303B72657475726E7B7265706C61636564';
wwv_flow_imp.g_varchar2_table(26959) := '52616E67653A692C696E6C696E6554657874733A6F2C6164646974696F6E616C4C696E65733A732C68696464656E52616E67653A642C6C696E654E756D6265723A6E2E6C696E654E756D6265722C6164646974696F6E616C52657365727665644C696E65';
wwv_flow_imp.g_varchar2_table(26960) := '436F756E743A746869732E6D6F64656C2E6D696E52657365727665644C696E65436F756E742E726561642865292C746172676574546578744D6F64656C3A747D7D29292C746869732E6465636F726174696F6E733D515428746869732C28653D3E7B636F';
wwv_flow_imp.g_varchar2_table(26961) := '6E737420743D746869732E756953746174652E726561642865293B69662821742972657475726E5B5D3B636F6E7374206E3D5B5D3B742E7265706C6163656452616E676526266E2E70757368287B72616E67653A742E7265706C6163656452616E67652E';
wwv_flow_imp.g_varchar2_table(26962) := '746F52616E676528742E6C696E654E756D626572292C6F7074696F6E733A7B696E6C696E65436C6173734E616D653A22696E6C696E652D636F6D706C6574696F6E2D746578742D746F2D7265706C616365222C6465736372697074696F6E3A2247686F73';
wwv_flow_imp.g_varchar2_table(26963) := '74546578745265706C6163656D656E74227D7D292C742E68696464656E52616E676526266E2E70757368287B72616E67653A742E68696464656E52616E67652E746F52616E676528742E6C696E654E756D626572292C6F7074696F6E733A7B696E6C696E';
wwv_flow_imp.g_varchar2_table(26964) := '65436C6173734E616D653A2267686F73742D746578742D68696464656E222C6465736372697074696F6E3A2267686F73742D746578742D68696464656E227D7D293B666F7228636F6E73742065206F6620742E696E6C696E655465787473296E2E707573';
wwv_flow_imp.g_varchar2_table(26965) := '68287B72616E67653A72682E66726F6D506F736974696F6E73286E6577206D6328742E6C696E654E756D6265722C652E636F6C756D6E29292C6F7074696F6E733A7B6465736372697074696F6E3A46332C61667465723A7B636F6E74656E743A652E7465';
wwv_flow_imp.g_varchar2_table(26966) := '78742C696E6C696E65436C6173734E616D653A652E707265766965773F2267686F73742D746578742D6465636F726174696F6E2D70726576696577223A2267686F73742D746578742D6465636F726174696F6E222C637572736F7253746F70733A6B682E';
wwv_flow_imp.g_varchar2_table(26967) := '4C6566747D2C73686F774966436F6C6C61707365643A21307D7D293B72657475726E206E7D29292C746869732E6164646974696F6E616C4C696E65735769646765743D746869732E5F7265676973746572286E657720563328746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(26968) := '2C746869732E6C616E6775616765536572766963652E6C616E67756167654964436F6465632C51542828653D3E7B636F6E737420743D746869732E756953746174652E726561642865293B72657475726E20743F7B6C696E654E756D6265723A742E6C69';
wwv_flow_imp.g_varchar2_table(26969) := '6E654E756D6265722C6164646974696F6E616C4C696E65733A742E6164646974696F6E616C4C696E65732C6D696E52657365727665644C696E65436F756E743A742E6164646974696F6E616C52657365727665644C696E65436F756E742C746172676574';
wwv_flow_imp.g_varchar2_table(26970) := '546578744D6F64656C3A742E746172676574546578744D6F64656C7D3A766F696420307D292929292C746869732E5F7265676973746572287274282828293D3E7B746869732E6973446973706F7365642E7365742821302C766F69642030297D2929292C';
wwv_flow_imp.g_varchar2_table(26971) := '746869732E5F7265676973746572284F3328746869732E656469746F722C746869732E6465636F726174696F6E7329297D6F776E73566965775A6F6E652865297B72657475726E20746869732E6164646974696F6E616C4C696E65735769646765742E76';
wwv_flow_imp.g_varchar2_table(26972) := '6965775A6F6E6549643D3D3D657D7D3B42333D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572';
wwv_flow_imp.g_varchar2_table(26973) := '747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F72';
wwv_flow_imp.g_varchar2_table(26974) := '61746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475';
wwv_flow_imp.g_varchar2_table(26975) := '726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28322C4C75295D2C423329';
wwv_flow_imp.g_varchar2_table(26976) := '3B636C61737320563320657874656E6473206C747B67657420766965775A6F6E65496428297B72657475726E20746869732E5F766965775A6F6E6549647D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(26977) := '3D652C746869732E6C616E67756167654964436F6465633D742C746869732E6C696E65733D6E2C746869732E5F766965775A6F6E6549643D766F696420302C746869732E656469746F724F7074696F6E734368616E6765643D63492822656469746F724F';
wwv_flow_imp.g_varchar2_table(26978) := '7074696F6E4368616E676564222C76742E66696C74657228746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C28653D3E652E6861734368616E676564283333297C7C652E6861734368616E6765642831313729';
wwv_flow_imp.g_varchar2_table(26979) := '7C7C652E6861734368616E676564283939297C7C652E6861734368616E676564283934297C7C652E6861734368616E676564283531297C7C652E6861734368616E676564283530297C7C652E6861734368616E676564283637292929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(26980) := '72656769737465722865492828653D3E7B636F6E737420743D746869732E6C696E65732E726561642865293B746869732E656469746F724F7074696F6E734368616E6765642E726561642865292C743F746869732E7570646174654C696E657328742E6C';
wwv_flow_imp.g_varchar2_table(26981) := '696E654E756D6265722C742E6164646974696F6E616C4C696E65732C742E6D696E52657365727665644C696E65436F756E74293A746869732E636C65617228297D2929297D646973706F736528297B73757065722E646973706F736528292C746869732E';
wwv_flow_imp.g_varchar2_table(26982) := '636C65617228297D636C65617228297B746869732E656469746F722E6368616E6765566965775A6F6E65732828653D3E7B746869732E5F766965775A6F6E654964262628652E72656D6F76655A6F6E6528746869732E5F766965775A6F6E654964292C74';
wwv_flow_imp.g_varchar2_table(26983) := '6869732E5F766965775A6F6E6549643D766F69642030297D29297D7570646174654C696E657328652C742C6E297B636F6E737420693D746869732E656469746F722E6765744D6F64656C28293B69662821692972657475726E3B636F6E73747B74616253';
wwv_flow_imp.g_varchar2_table(26984) := '697A653A6F7D3D692E6765744F7074696F6E7328293B746869732E656469746F722E6368616E6765566965775A6F6E65732828693D3E7B746869732E5F766965775A6F6E654964262628692E72656D6F76655A6F6E6528746869732E5F766965775A6F6E';
wwv_flow_imp.g_varchar2_table(26985) := '654964292C746869732E5F766965775A6F6E6549643D766F69642030293B636F6E737420733D4D6174682E6D617828742E6C656E6774682C6E293B696628733E30297B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E74282264';
wwv_flow_imp.g_varchar2_table(26986) := '697622293B2166756E6374696F6E28652C742C6E2C692C6F297B636F6E737420733D692E676574283333292C723D692E67657428313137292C613D692E676574283934292C6C3D692E676574283531292C633D692E676574283530292C643D692E676574';
wwv_flow_imp.g_varchar2_table(26987) := '283637292C683D6E6577206E7028316534293B682E617070656E64537472696E6728273C64697620636C6173733D22737567676573742D707265766965772D74657874223E27293B666F72286C657420653D302C693D6E2E6C656E6774683B653C693B65';
wwv_flow_imp.g_varchar2_table(26988) := '2B2B297B636F6E737420693D6E5B655D2C753D692E636F6E74656E743B682E617070656E64537472696E6728273C64697620636C6173733D22766965772D6C696E6527292C682E617070656E64537472696E67282722207374796C653D22746F703A2729';
wwv_flow_imp.g_varchar2_table(26989) := '2C682E617070656E64537472696E6728537472696E6728652A6429292C682E617070656E64537472696E67282770783B77696474683A3130303030303070783B223E27293B636F6E737420703D7A692875292C673D42692875292C6D3D57772E63726561';
wwv_flow_imp.g_varchar2_table(26990) := '7465456D70747928752C6F293B5F4E286E6577206D4E28632E69734D6F6E6F7370616365262621732C632E63616E55736548616C667769647468526967687477617264734172726F772C752C21312C702C672C302C6D2C692E6465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(26991) := '2C742C302C632E737061636557696474682C632E6D6964646F7457696474682C632E77736D6964646F7457696474682C722C226E6F6E65222C612C6C213D3D414C2E4F46462C6E756C6C292C68292C682E617070656E64537472696E6728223C2F646976';
wwv_flow_imp.g_varchar2_table(26992) := '3E22297D682E617070656E64537472696E6728223C2F6469763E22292C724528652C63293B636F6E737420753D682E6275696C6428292C703D7A333F7A332E63726561746548544D4C2875293A753B652E696E6E657248544D4C3D707D286E2C6F2C742C';
wwv_flow_imp.g_varchar2_table(26993) := '746869732E656469746F722E6765744F7074696F6E7328292C746869732E6C616E67756167654964436F646563292C746869732E5F766965775A6F6E6549643D692E6164645A6F6E65287B61667465724C696E654E756D6265723A652C68656967687449';
wwv_flow_imp.g_varchar2_table(26994) := '6E4C696E65733A732C646F6D4E6F64653A6E2C6166746572436F6C756D6E416666696E6974793A317D297D7D29297D7D636F6E7374207A333D65452822656469746F7247686F737454657874222C7B63726561746548544D4C3A653D3E657D293B636C61';
wwv_flow_imp.g_varchar2_table(26995) := '73732048337B636F6E7374727563746F722865297B746869732E6C696E65733D652C746869732E746F6B656E697A6174696F6E3D7B6765744C696E65546F6B656E733A653D3E746869732E6C696E65735B652D315D7D7D6765744C696E65436F756E7428';
wwv_flow_imp.g_varchar2_table(26996) := '297B72657475726E20746869732E6C696E65732E6C656E6774687D6765744C696E654C656E6774682865297B72657475726E20746869732E6C696E65735B652D315D2E6765744C696E65436F6E74656E7428292E6C656E6774687D7D6173796E63206675';
wwv_flow_imp.g_varchar2_table(26997) := '6E6374696F6E20573328652C742C6E2C692C6F3D4D742E4E6F6E652C73297B636F6E737420723D66756E6374696F6E28652C74297B636F6E7374206E3D742E676574576F72644174506F736974696F6E2865292C693D742E6765744C696E654D6178436F';
wwv_flow_imp.g_varchar2_table(26998) := '6C756D6E28652E6C696E654E756D626572293B72657475726E206E3F6E657720726828652E6C696E654E756D6265722C6E2E7374617274436F6C756D6E2C652E6C696E654E756D6265722C69293A72682E66726F6D506F736974696F6E7328652C652E77';
wwv_flow_imp.g_varchar2_table(26999) := '69746828766F696420302C6929297D28742C6E292C613D652E616C6C286E292C6C3D6E65772063613B666F7228636F6E73742065206F66206129652E67726F7570496426266C2E61646428652E67726F757049642C65293B66756E6374696F6E20632865';
wwv_flow_imp.g_varchar2_table(27000) := '297B69662821652E7969656C6473546F47726F75704964732972657475726E5B5D3B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620652E7969656C6473546F47726F75704964737C7C5B5D297B636F6E737420653D6C2E676574286E29';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(27001) := '3B666F7228636F6E7374206E206F66206529742E70757368286E297D72657475726E20747D636F6E737420643D6E6577204D61702C683D6E6577205365743B66756E6374696F6E207528652C74297B696628743D5B2E2E2E742C655D2C682E6861732865';
wwv_flow_imp.g_varchar2_table(27002) := '292972657475726E20743B682E6164642865293B7472797B636F6E7374206E3D632865293B666F7228636F6E73742065206F66206E297B636F6E7374206E3D7528652C74293B6966286E2972657475726E206E7D7D66696E616C6C797B682E64656C6574';
wwv_flow_imp.g_varchar2_table(27003) := '652865297D7D66756E6374696F6E20702865297B636F6E737420733D642E6765742865293B696628732972657475726E20733B636F6E737420723D7528652C5B5D293B7226264565286E6577204572726F722860496E6C696E6520636F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(27004) := '6E733A206379636C6963207969656C642D746F20646570656E64656E63792064657465637465642E20506174683A20247B722E6D61702828653D3E652E746F537472696E673F652E746F537472696E6728293A22222B6529292E6A6F696E2822202D3E20';
wwv_flow_imp.g_varchar2_table(27005) := '22297D6029293B636F6E737420613D6E65772058743B72657475726E20642E73657428652C612E70292C286173796E6328293D3E7B6966282172297B636F6E737420743D632865293B666F7228636F6E73742065206F662074297B636F6E737420743D61';
wwv_flow_imp.g_varchar2_table(27006) := '7761697420702865293B696628742626742E6974656D732E6C656E6774683E302972657475726E7D7D7472797B72657475726E20617761697420652E70726F76696465496E6C696E65436F6D706C6574696F6E73286E2C742C692C6F297D636174636828';
wwv_flow_imp.g_varchar2_table(27007) := '65297B72657475726E20766F69642045652865297D7D2928292E7468656E2828653D3E612E636F6D706C657465286529292C28653D3E612E6572726F7228652929292C612E707D636F6E737420673D61776169742050726F6D6973652E616C6C28612E6D';
wwv_flow_imp.g_varchar2_table(27008) := '617028286173796E6320653D3E287B70726F76696465723A652C636F6D706C6574696F6E733A617761697420702865297D292929292C6D3D6E6577204D61702C663D5B5D3B666F7228636F6E73742065206F662067297B636F6E737420743D652E636F6D';
wwv_flow_imp.g_varchar2_table(27009) := '706C6574696F6E733B696628217429636F6E74696E75653B636F6E737420693D6E657720713328742C652E70726F7669646572293B662E707573682869293B666F7228636F6E73742065206F6620742E6974656D73297B636F6E737420743D24332E6672';
wwv_flow_imp.g_varchar2_table(27010) := '6F6D28652C692C722C6E2C73293B6D2E73657428742E6861736828292C74297D7D72657475726E206E6577206A332841727261792E66726F6D286D2E76616C7565732829292C6E657720536574286D2E6B6579732829292C66297D636C617373206A337B';
wwv_flow_imp.g_varchar2_table(27011) := '636F6E7374727563746F7228652C742C6E297B746869732E636F6D706C6574696F6E733D652C746869732E68617368733D742C746869732E70726F7669646572526573756C74733D6E7D6861732865297B72657475726E20746869732E68617368732E68';
wwv_flow_imp.g_varchar2_table(27012) := '617328652E686173682829297D646973706F736528297B666F7228636F6E73742065206F6620746869732E70726F7669646572526573756C747329652E72656D6F766552656628297D7D636C6173732071337B636F6E7374727563746F7228652C74297B';
wwv_flow_imp.g_varchar2_table(27013) := '746869732E696E6C696E65436F6D706C6574696F6E733D652C746869732E70726F76696465723D742C746869732E726566436F756E743D317D61646452656628297B746869732E726566436F756E742B2B7D72656D6F766552656628297B746869732E72';
wwv_flow_imp.g_varchar2_table(27014) := '6566436F756E742D2D2C303D3D3D746869732E726566436F756E742626746869732E70726F76696465722E66726565496E6C696E65436F6D706C6574696F6E7328746869732E696E6C696E65436F6D706C6574696F6E73297D7D636C6173732024337B73';
wwv_flow_imp.g_varchar2_table(27015) := '74617469632066726F6D28652C742C6E2C692C6F297B6C657420732C722C613D652E72616E67653F72682E6C69667428652E72616E6765293A6E3B69662822737472696E67223D3D747970656F6620652E696E7365727454657874297B696628733D652E';
wwv_flow_imp.g_varchar2_table(27016) := '696E73657274546578742C6F2626652E636F6D706C657465427261636B65745061697273297B733D553328732C612E6765745374617274506F736974696F6E28292C692C6F293B636F6E737420743D732E6C656E6774682D652E696E7365727454657874';
wwv_flow_imp.g_varchar2_table(27017) := '2E6C656E6774683B30213D3D74262628613D6E657720726828612E73746172744C696E654E756D6265722C612E7374617274436F6C756D6E2C612E656E644C696E654E756D6265722C612E656E64436F6C756D6E2B7429297D723D766F696420307D656C';
wwv_flow_imp.g_varchar2_table(27018) := '73652069662822736E697070657422696E20652E696E7365727454657874297B636F6E737420743D652E696E73657274546578742E736E69707065742E6C656E6774683B6966286F2626652E636F6D706C657465427261636B65745061697273297B652E';
wwv_flow_imp.g_varchar2_table(27019) := '696E73657274546578742E736E69707065743D553328652E696E73657274546578742E736E69707065742C612E6765745374617274506F736974696F6E28292C692C6F293B636F6E7374206E3D652E696E73657274546578742E736E69707065742E6C65';
wwv_flow_imp.g_varchar2_table(27020) := '6E6774682D743B30213D3D6E262628613D6E657720726828612E73746172744C696E654E756D6265722C612E7374617274436F6C756D6E2C612E656E644C696E654E756D6265722C612E656E64436F6C756D6E2B6E29297D636F6E7374206E3D286E6577';
wwv_flow_imp.g_varchar2_table(27021) := '20696B292E706172736528652E696E73657274546578742E736E6970706574293B313D3D3D6E2E6368696C6472656E2E6C656E67746826266E2E6368696C6472656E5B305D696E7374616E63656F662047783F28733D6E2E6368696C6472656E5B305D2E';
wwv_flow_imp.g_varchar2_table(27022) := '76616C75652C723D766F69642030293A28733D6E2E746F537472696E6728292C723D7B736E69707065743A652E696E73657274546578742E736E69707065742C72616E67653A617D297D656C736520666428652E696E7365727454657874293B72657475';
wwv_flow_imp.g_varchar2_table(27023) := '726E206E657720243328732C652E636F6D6D616E642C612C732C722C652E6164646974696F6E616C5465787445646974737C7C4E332C652C74297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B746869732E66696C74657254';
wwv_flow_imp.g_varchar2_table(27024) := '6578743D652C746869732E636F6D6D616E643D742C746869732E72616E67653D6E2C746869732E696E73657274546578743D692C746869732E736E6970706574496E666F3D6F2C746869732E6164646974696F6E616C5465787445646974733D732C7468';
wwv_flow_imp.g_varchar2_table(27025) := '69732E736F75726365496E6C696E65436F6D706C6574696F6E3D722C746869732E736F757263653D612C693D28653D652E7265706C616365282F5C725C6E7C5C722F672C225C6E2229292E7265706C616365282F5C725C6E7C5C722F672C225C6E22297D';
wwv_flow_imp.g_varchar2_table(27026) := '7769746852616E67652865297B72657475726E206E657720243328746869732E66696C746572546578742C746869732E636F6D6D616E642C652C746869732E696E73657274546578742C746869732E736E6970706574496E666F2C746869732E61646469';
wwv_flow_imp.g_varchar2_table(27027) := '74696F6E616C5465787445646974732C746869732E736F75726365496E6C696E65436F6D706C6574696F6E2C746869732E736F75726365297D6861736828297B72657475726E204A534F4E2E737472696E67696679287B696E73657274546578743A7468';
wwv_flow_imp.g_varchar2_table(27028) := '69732E696E73657274546578742C72616E67653A746869732E72616E67652E746F537472696E6728297D297D7D66756E6374696F6E20553328652C742C6E2C69297B636F6E7374206F3D6E2E6765744C696E65436F6E74656E7428742E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(27029) := '626572292E737562737472696E6728302C742E636F6C756D6E2D31292B652C733D6E2E746F6B656E697A6174696F6E2E746F6B656E697A654C696E65576974684564697428742C6F2E6C656E6774682D28742E636F6C756D6E2D31292C65292C723D6E75';
wwv_flow_imp.g_varchar2_table(27030) := '6C6C3D3D733F766F696420303A732E736C696365416E64496E666C61746528742E636F6C756D6E2D312C6F2E6C656E6774682C30293B69662821722972657475726E20653B636F6E737420613D66756E6374696F6E28652C74297B636F6E7374206E3D6E';
wwv_flow_imp.g_varchar2_table(27031) := '65772052672C693D6E657720746D286E2C28653D3E742E6765744C616E6775616765436F6E66696775726174696F6E28652929292C6F3D6C6D286E6577205A67286E6577204833285B655D292C69292C5B5D2C766F696420302C2130293B6C657420733D';
wwv_flow_imp.g_varchar2_table(27032) := '22223B636F6E737420723D652E6765744C696E65436F6E74656E7428293B72657475726E2066756E6374696F6E206528742C6E297B696628323D3D3D742E6B696E64296966286528742E6F70656E696E67427261636B65742C6E292C6E3D7767286E2C74';
wwv_flow_imp.g_varchar2_table(27033) := '2E6F70656E696E67427261636B65742E6C656E677468292C742E6368696C642626286528742E6368696C642C6E292C6E3D7767286E2C742E6368696C642E6C656E67746829292C742E636C6F73696E67427261636B6574296528742E636C6F73696E6742';
wwv_flow_imp.g_varchar2_table(27034) := '7261636B65742C6E292C6E3D7767286E2C742E636C6F73696E67427261636B65742E6C656E677468293B656C73657B636F6E737420653D692E67657453696E676C654C616E6775616765427261636B6574546F6B656E7328742E6F70656E696E67427261';
wwv_flow_imp.g_varchar2_table(27035) := '636B65742E6C616E67756167654964292E66696E64436C6F73696E67546F6B656E5465787428742E6F70656E696E67427261636B65742E627261636B6574496473293B732B3D657D656C736520696628333D3D3D742E6B696E64293B656C736520696628';
wwv_flow_imp.g_varchar2_table(27036) := '303D3D3D742E6B696E647C7C313D3D3D742E6B696E6429732B3D722E737562737472696E67286E2C7767286E2C742E6C656E67746829293B656C736520696628343D3D3D742E6B696E6429666F7228636F6E73742069206F6620742E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(27037) := '296528692C6E292C6E3D7767286E2C692E6C656E677468297D286F2C6667292C737D28722C69293B72657475726E20617D66756E6374696F6E204B3328652C742C6E297B636F6E737420693D6E3F652E72616E67652E696E7465727365637452616E6765';
wwv_flow_imp.g_varchar2_table(27038) := '73286E293A652E72616E67653B69662821692972657475726E20653B636F6E7374206F3D742E67657456616C7565496E52616E676528692C31292C733D4C69286F2C652E74657874292C723D6D672E6F6654657874286F2E737562737472696E6728302C';
wwv_flow_imp.g_varchar2_table(27039) := '7329292E616464546F506F736974696F6E28652E72616E67652E6765745374617274506F736974696F6E2829292C613D652E746578742E737562737472696E672873292C6C3D72682E66726F6D506F736974696F6E7328722C652E72616E67652E676574';
wwv_flow_imp.g_varchar2_table(27040) := '456E64506F736974696F6E2829293B72657475726E206E657720557A286C2C61297D66756E6374696F6E20473328652C74297B72657475726E20652E746578742E7374617274735769746828742E74657874292626286E3D652E72616E67652C28693D74';
wwv_flow_imp.g_varchar2_table(27041) := '2E72616E6765292E6765745374617274506F736974696F6E28292E657175616C73286E2E6765745374617274506F736974696F6E2829292626692E676574456E64506F736974696F6E28292E69734265666F72654F72457175616C286E2E676574456E64';
wwv_flow_imp.g_varchar2_table(27042) := '506F736974696F6E282929293B766172206E2C697D66756E6374696F6E20513328652C742C6E2C692C6F3D30297B6C657420733D4B3328652C74293B696628732E72616E67652E656E644C696E654E756D626572213D3D732E72616E67652E7374617274';
wwv_flow_imp.g_varchar2_table(27043) := '4C696E654E756D6265722972657475726E3B636F6E737420723D742E6765744C696E65436F6E74656E7428732E72616E67652E73746172744C696E654E756D626572292C613D66692872292E6C656E6774683B696628732E72616E67652E737461727443';
wwv_flow_imp.g_varchar2_table(27044) := '6F6C756D6E2D313C3D61297B636F6E737420653D666928732E74657874292E6C656E6774682C743D722E737562737472696E6728732E72616E67652E7374617274436F6C756D6E2D312C61292C5B6E2C695D3D5B732E72616E67652E6765745374617274';
wwv_flow_imp.g_varchar2_table(27045) := '506F736974696F6E28292C732E72616E67652E676574456E64506F736974696F6E28295D2C6F3D6E2E636F6C756D6E2B742E6C656E6774683C3D692E636F6C756D6E3F6E2E64656C746128302C742E6C656E677468293A692C6C3D72682E66726F6D506F';
wwv_flow_imp.g_varchar2_table(27046) := '736974696F6E73286F2C69292C633D732E746578742E737461727473576974682874293F732E746578742E737562737472696E6728742E6C656E677468293A732E746578742E737562737472696E672865293B733D6E657720557A286C2C63297D636F6E';
wwv_flow_imp.g_varchar2_table(27047) := '7374206C3D742E67657456616C7565496E52616E676528732E72616E6765292C633D66756E6374696F6E28652C74297B696628286E756C6C3D3D59333F766F696420303A59332E6F726967696E616C56616C7565293D3D3D652626286E756C6C3D3D5933';
wwv_flow_imp.g_varchar2_table(27048) := '3F766F696420303A59332E6E657756616C7565293D3D3D742972657475726E206E756C6C3D3D59333F766F696420303A59332E6368616E6765733B7B6C6574206E3D583328652C742C2130293B6966286E297B636F6E737420693D5A33286E293B696628';
wwv_flow_imp.g_varchar2_table(27049) := '693E30297B636F6E7374206F3D583328652C742C2131293B6F26265A33286F293C692626286E3D6F297D7D72657475726E2059333D7B6F726967696E616C56616C75653A652C6E657756616C75653A742C6368616E6765733A6E7D2C6E7D7D286C2C732E';
wwv_flow_imp.g_varchar2_table(27050) := '74657874293B69662821632972657475726E3B636F6E737420643D732E72616E67652E73746172744C696E654E756D6265722C683D6E65772041727261793B69662822707265666978223D3D3D6E297B636F6E737420653D632E66696C7465722828653D';
wwv_flow_imp.g_varchar2_table(27051) := '3E303D3D3D652E6F726967696E616C4C656E67746829293B696628652E6C656E6774683E317C7C313D3D3D652E6C656E6774682626655B305D2E6F726967696E616C5374617274213D3D6C2E6C656E6774682972657475726E7D636F6E737420753D732E';
wwv_flow_imp.g_varchar2_table(27052) := '746578742E6C656E6774682D6F3B666F7228636F6E73742065206F662063297B636F6E737420743D732E72616E67652E7374617274436F6C756D6E2B652E6F726967696E616C53746172742B652E6F726967696E616C4C656E6774683B69662822737562';
wwv_flow_imp.g_varchar2_table(27053) := '776F7264536D617274223D3D3D6E2626692626692E6C696E654E756D6265723D3D3D732E72616E67652E73746172744C696E654E756D6265722626743C692E636F6C756D6E2972657475726E3B696628652E6F726967696E616C4C656E6774683E302972';
wwv_flow_imp.g_varchar2_table(27054) := '657475726E3B696628303D3D3D652E6D6F6469666965644C656E67746829636F6E74696E75653B636F6E7374206F3D652E6D6F64696669656453746172742B652E6D6F6469666965644C656E6774682C723D4D6174682E6D617828652E6D6F6469666965';
wwv_flow_imp.g_varchar2_table(27055) := '6453746172742C4D6174682E6D696E286F2C7529292C613D732E746578742E737562737472696E6728652E6D6F64696669656453746172742C72292C6C3D732E746578742E737562737472696E6728722C4D6174682E6D617828652E6D6F646966696564';
wwv_flow_imp.g_varchar2_table(27056) := '53746172742C6F29293B612E6C656E6774683E302626682E70757368286E657720543328742C612C213129292C6C2E6C656E6774683E302626682E70757368286E657720543328742C6C2C213029297D72657475726E206E657720443328642C68297D6C';
wwv_flow_imp.g_varchar2_table(27057) := '65742059333B66756E6374696F6E205A332865297B6C657420743D303B666F7228636F6E7374206E206F66206529742B3D6E2E6F726967696E616C4C656E6774683B72657475726E20747D66756E6374696F6E20583328652C742C6E297B696628652E6C';
wwv_flow_imp.g_varchar2_table(27058) := '656E6774683E3565337C7C742E6C656E6774683E3565332972657475726E3B66756E6374696F6E20692865297B6C657420743D303B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D652E6368617243';
wwv_flow_imp.g_varchar2_table(27059) := '6F64654174286E293B693E74262628743D69297D72657475726E20747D636F6E7374206F3D4D6174682E6D617828692865292C69287429293B66756E6374696F6E20732865297B696628653C30297468726F77206E6577204572726F722822756E657870';
wwv_flow_imp.g_varchar2_table(27060) := '656374656422293B72657475726E206F2B652B317D66756E6374696F6E20722865297B6C657420743D302C693D303B636F6E7374206F3D6E657720496E743332417272617928652E6C656E677468293B666F72286C657420723D302C613D652E6C656E67';
wwv_flow_imp.g_varchar2_table(27061) := '74683B723C613B722B2B296966286E26262228223D3D3D655B725D297B636F6E737420653D3130302A692B743B6F5B725D3D7328322A65292C742B2B7D656C7365206966286E26262229223D3D3D655B725D297B743D4D6174682E6D617828742D312C30';
wwv_flow_imp.g_varchar2_table(27062) := '293B636F6E737420653D3130302A692B743B6F5B725D3D7328322A652B31292C303D3D3D742626692B2B7D656C7365206F5B725D3D652E63686172436F646541742872293B72657475726E206F7D636F6E737420613D722865292C6C3D722874293B7265';
wwv_flow_imp.g_varchar2_table(27063) := '7475726E206E6577204656287B676574456C656D656E74733A28293D3E617D2C7B676574456C656D656E74733A28293D3E6C7D292E436F6D7075746544696666282131292E6368616E6765737D766172204A333D66756E6374696F6E28652C74297B7265';
wwv_flow_imp.g_varchar2_table(27064) := '7475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742065353D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E746578744D6F64656C3D';
wwv_flow_imp.g_varchar2_table(27065) := '652C746869732E76657273696F6E49643D742C746869732E5F6465626F756E636556616C75653D6E2C746869732E6C616E67756167654665617475726573536572766963653D692C746869732E6C616E6775616765436F6E66696775726174696F6E5365';
wwv_flow_imp.g_varchar2_table(27066) := '72766963653D6F2C746869732E5F7570646174654F7065726174696F6E3D746869732E5F7265676973746572286E6577206374292C746869732E696E6C696E65436F6D706C6574696F6E733D4B542822696E6C696E65436F6D706C6574696F6E73222C76';
wwv_flow_imp.g_varchar2_table(27067) := '6F69642030292C746869732E73756767657374576964676574496E6C696E65436F6D706C6574696F6E733D4B54282273756767657374576964676574496E6C696E65436F6D706C6574696F6E73222C766F69642030292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(27068) := '7228746869732E746578744D6F64656C2E6F6E4469644368616E6765436F6E74656E74282828293D3E7B746869732E5F7570646174654F7065726174696F6E2E636C65617228297D2929297D666574636828652C742C6E297B76617220692C6F3B636F6E';
wwv_flow_imp.g_varchar2_table(27069) := '737420733D6E657720743528652C742C746869732E746578744D6F64656C2E67657456657273696F6E49642829292C723D742E73656C656374656453756767657374696F6E496E666F3F746869732E73756767657374576964676574496E6C696E65436F';
wwv_flow_imp.g_varchar2_table(27070) := '6D706C6574696F6E733A746869732E696E6C696E65436F6D706C6574696F6E733B6966286E756C6C3D3D3D28693D746869732E5F7570646174654F7065726174696F6E2E76616C7565297C7C766F696420303D3D3D693F766F696420303A692E72657175';
wwv_flow_imp.g_varchar2_table(27071) := '6573742E7361746973666965732873292972657475726E20746869732E5F7570646174654F7065726174696F6E2E76616C75652E70726F6D6973653B6966286E756C6C3D3D3D286F3D722E6765742829297C7C766F696420303D3D3D6F3F766F69642030';
wwv_flow_imp.g_varchar2_table(27072) := '3A6F2E726571756573742E7361746973666965732873292972657475726E2050726F6D6973652E7265736F6C7665282130293B636F6E737420613D2121746869732E5F7570646174654F7065726174696F6E2E76616C75653B746869732E5F7570646174';
wwv_flow_imp.g_varchar2_table(27073) := '654F7065726174696F6E2E636C65617228293B636F6E7374206C3D6E6577204E742C633D286173796E6328293D3E7B76617220692C6F3B69662828617C7C742E747269676765724B696E643D3D3D77772E4175746F6D6174696329262661776169742869';
wwv_flow_imp.g_varchar2_table(27074) := '3D746869732E5F6465626F756E636556616C75652E67657428746869732E746578744D6F64656C292C6F3D6C2E746F6B656E2C6E65772050726F6D6973652828653D3E7B6C657420743B636F6E7374206E3D73657454696D656F7574282828293D3E7B74';
wwv_flow_imp.g_varchar2_table(27075) := '2626742E646973706F736528292C6528297D292C69293B6F262628743D6F2E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B636C65617254696D656F7574286E292C742626742E646973706F736528292C6528297D2929297D';
wwv_flow_imp.g_varchar2_table(27076) := '2929292C6C2E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465647C7C746869732E746578744D6F64656C2E67657456657273696F6E49642829213D3D732E76657273696F6E49642972657475726E21313B636F6E737420633D6E65';
wwv_flow_imp.g_varchar2_table(27077) := '7720446174652C643D617761697420573328746869732E6C616E67756167654665617475726573536572766963652E696E6C696E65436F6D706C6574696F6E7350726F76696465722C652C746869732E746578744D6F64656C2C742C6C2E746F6B656E2C';
wwv_flow_imp.g_varchar2_table(27078) := '746869732E6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286C2E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465647C7C746869732E746578744D6F64656C2E67657456657273696F6E49642829';
wwv_flow_imp.g_varchar2_table(27079) := '213D3D732E76657273696F6E49642972657475726E21313B636F6E737420683D6E657720446174653B746869732E5F6465626F756E636556616C75652E75706461746528746869732E746578744D6F64656C2C682E67657454696D6528292D632E676574';
wwv_flow_imp.g_varchar2_table(27080) := '54696D652829293B636F6E737420753D6E657720693528642C732C746869732E746578744D6F64656C2C746869732E76657273696F6E4964293B6966286E297B636F6E737420743D6E2E746F496E6C696E65436F6D706C6574696F6E28766F6964203029';
wwv_flow_imp.g_varchar2_table(27081) := '3B6E2E63616E426552657573656428746869732E746578744D6F64656C2C6529262621642E6861732874292626752E70726570656E64286E2E696E6C696E65436F6D706C6574696F6E2C742E72616E67652C2130297D72657475726E20746869732E5F75';
wwv_flow_imp.g_varchar2_table(27082) := '70646174654F7065726174696F6E2E636C65617228292C48542828653D3E7B722E73657428752C65297D29292C21307D2928292C643D6E6577206E3528732C6C2C63293B72657475726E20746869732E5F7570646174654F7065726174696F6E2E76616C';
wwv_flow_imp.g_varchar2_table(27083) := '75653D642C637D636C6561722865297B746869732E5F7570646174654F7065726174696F6E2E636C65617228292C746869732E696E6C696E65436F6D706C6574696F6E732E73657428766F696420302C65292C746869732E737567676573745769646765';
wwv_flow_imp.g_varchar2_table(27084) := '74496E6C696E65436F6D706C6574696F6E732E73657428766F696420302C65297D636C65617253756767657374576964676574496E6C696E65436F6D706C6574696F6E732865297B76617220743B286E756C6C3D3D3D28743D746869732E5F7570646174';
wwv_flow_imp.g_varchar2_table(27085) := '654F7065726174696F6E2E76616C7565297C7C766F696420303D3D3D743F766F696420303A742E726571756573742E636F6E746578742E73656C656374656453756767657374696F6E496E666F292626746869732E5F7570646174654F7065726174696F';
wwv_flow_imp.g_varchar2_table(27086) := '6E2E636C65617228292C746869732E73756767657374576964676574496E6C696E65436F6D706C6574696F6E732E73657428766F696420302C65297D63616E63656C55706461746528297B746869732E5F7570646174654F7065726174696F6E2E636C65';
wwv_flow_imp.g_varchar2_table(27087) := '617228297D7D3B65353D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970';
wwv_flow_imp.g_varchar2_table(27088) := '746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E';
wwv_flow_imp.g_varchar2_table(27089) := '2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E33262672';
wwv_flow_imp.g_varchar2_table(27090) := '26264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4A3328332C7878292C4A3328342C6567295D2C6535293B636C6173732074357B636F6E7374727563746F7228652C742C6E297B746869732E706F736974696F6E3D';
wwv_flow_imp.g_varchar2_table(27091) := '652C746869732E636F6E746578743D742C746869732E76657273696F6E49643D6E7D7361746973666965732865297B72657475726E20746869732E706F736974696F6E2E657175616C7328652E706F736974696F6E29262628743D746869732E636F6E74';
wwv_flow_imp.g_varchar2_table(27092) := '6578742E73656C656374656453756767657374696F6E496E666F2C6E3D652E636F6E746578742E73656C656374656453756767657374696F6E496E666F2C7426266E3F28693D6E2C742E657175616C73286929293A743D3D3D6E29262628652E636F6E74';
wwv_flow_imp.g_varchar2_table(27093) := '6578742E747269676765724B696E643D3D3D77772E4175746F6D617469637C7C746869732E636F6E746578742E747269676765724B696E643D3D3D77772E4578706C69636974292626746869732E76657273696F6E49643D3D3D652E76657273696F6E49';
wwv_flow_imp.g_varchar2_table(27094) := '643B76617220742C6E2C697D7D636C617373206E357B636F6E7374727563746F7228652C742C6E297B746869732E726571756573743D652C746869732E63616E63656C6C6174696F6E546F6B656E536F757263653D742C746869732E70726F6D6973653D';
wwv_flow_imp.g_varchar2_table(27095) := '6E7D646973706F736528297B746869732E63616E63656C6C6174696F6E546F6B656E536F757263652E63616E63656C28297D7D636C6173732069357B67657420696E6C696E65436F6D706C6574696F6E7328297B72657475726E20746869732E5F696E6C';
wwv_flow_imp.g_varchar2_table(27096) := '696E65436F6D706C6574696F6E737D636F6E7374727563746F7228652C742C6E2C69297B746869732E696E6C696E65436F6D706C6574696F6E50726F7669646572526573756C743D652C746869732E726571756573743D742C746869732E5F746578744D';
wwv_flow_imp.g_varchar2_table(27097) := '6F64656C3D6E2C746869732E5F76657273696F6E49643D692C746869732E5F726566436F756E743D312C746869732E5F70726570656E646564496E6C696E65436F6D706C6574696F6E4974656D733D5B5D3B636F6E7374206F3D6E2E64656C7461446563';
wwv_flow_imp.g_varchar2_table(27098) := '6F726174696F6E73285B5D2C652E636F6D706C6574696F6E732E6D61702828653D3E287B72616E67653A652E72616E67652C6F7074696F6E733A7B6465736372697074696F6E3A22696E6C696E652D636F6D706C6574696F6E2D747261636B696E672D72';
wwv_flow_imp.g_varchar2_table(27099) := '616E6765227D7D292929293B746869732E5F696E6C696E65436F6D706C6574696F6E733D652E636F6D706C6574696F6E732E6D6170282828652C74293D3E6E6577206F3528652C6F5B745D2C746869732E5F746578744D6F64656C2C746869732E5F7665';
wwv_flow_imp.g_varchar2_table(27100) := '7273696F6E49642929297D636C6F6E6528297B72657475726E20746869732E5F726566436F756E742B2B2C746869737D646973706F736528297B696628746869732E5F726566436F756E742D2D2C303D3D3D746869732E5F726566436F756E74297B7365';
wwv_flow_imp.g_varchar2_table(27101) := '7454696D656F7574282828293D3E7B746869732E5F746578744D6F64656C2E6973446973706F73656428297C7C746869732E5F746578744D6F64656C2E64656C74614465636F726174696F6E7328746869732E5F696E6C696E65436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(27102) := '732E6D61702828653D3E652E6465636F726174696F6E496429292C5B5D297D292C30292C746869732E696E6C696E65436F6D706C6574696F6E50726F7669646572526573756C742E646973706F736528293B666F7228636F6E73742065206F6620746869';
wwv_flow_imp.g_varchar2_table(27103) := '732E5F70726570656E646564496E6C696E65436F6D706C6574696F6E4974656D7329652E736F757263652E72656D6F766552656628297D7D70726570656E6428652C742C6E297B6E2626652E736F757263652E61646452656628293B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(27104) := '746869732E5F746578744D6F64656C2E64656C74614465636F726174696F6E73285B5D2C5B7B72616E67653A742C6F7074696F6E733A7B6465736372697074696F6E3A22696E6C696E652D636F6D706C6574696F6E2D747261636B696E672D72616E6765';
wwv_flow_imp.g_varchar2_table(27105) := '227D7D5D295B305D3B746869732E5F696E6C696E65436F6D706C6574696F6E732E756E7368696674286E6577206F3528652C692C746869732E5F746578744D6F64656C2C746869732E5F76657273696F6E496429292C746869732E5F70726570656E6465';
wwv_flow_imp.g_varchar2_table(27106) := '64496E6C696E65436F6D706C6574696F6E4974656D732E707573682865297D7D636C617373206F357B67657420666F7277617264537461626C6528297B76617220653B72657475726E206E756C6C213D3D28653D746869732E696E6C696E65436F6D706C';
wwv_flow_imp.g_varchar2_table(27107) := '6574696F6E2E736F757263652E696E6C696E65436F6D706C6574696F6E732E656E61626C65466F727761726453746162696C697479292626766F69642030213D3D652626657D636F6E7374727563746F7228652C742C6E2C69297B746869732E696E6C69';
wwv_flow_imp.g_varchar2_table(27108) := '6E65436F6D706C6574696F6E3D652C746869732E6465636F726174696F6E49643D742C746869732E5F746578744D6F64656C3D6E2C746869732E5F6D6F64656C56657273696F6E3D692C746869732E73656D616E74696349643D4A534F4E2E737472696E';
wwv_flow_imp.g_varchar2_table(27109) := '67696679285B746869732E696E6C696E65436F6D706C6574696F6E2E66696C746572546578742C746869732E696E6C696E65436F6D706C6574696F6E2E696E73657274546578742C746869732E696E6C696E65436F6D706C6574696F6E2E72616E67652E';
wwv_flow_imp.g_varchar2_table(27110) := '6765745374617274506F736974696F6E28292E746F537472696E6728295D292C746869732E5F7570646174656452616E67653D5954287B6F776E65723A746869732C657175616C73466E3A72682E657175616C7352616E67657D2C28653D3E2874686973';
wwv_flow_imp.g_varchar2_table(27111) := '2E5F6D6F64656C56657273696F6E2E726561642865292C746869732E5F746578744D6F64656C2E6765744465636F726174696F6E52616E676528746869732E6465636F726174696F6E4964292929297D746F496E6C696E65436F6D706C6574696F6E2865';
wwv_flow_imp.g_varchar2_table(27112) := '297B76617220743B72657475726E20746869732E696E6C696E65436F6D706C6574696F6E2E7769746852616E6765286E756C6C213D3D28743D746869732E5F7570646174656452616E67652E72656164286529292626766F69642030213D3D743F743A73';
wwv_flow_imp.g_varchar2_table(27113) := '35297D746F53696E676C6554657874456469742865297B76617220743B72657475726E206E657720557A286E756C6C213D3D28743D746869732E5F7570646174656452616E67652E72656164286529292626766F69642030213D3D743F743A73352C7468';
wwv_flow_imp.g_varchar2_table(27114) := '69732E696E6C696E65436F6D706C6574696F6E2E696E7365727454657874297D697356697369626C6528652C742C6E297B636F6E737420693D4B3328746869732E5F746F46696C746572546578745265706C6163656D656E74286E292C65292C6F3D7468';
wwv_flow_imp.g_varchar2_table(27115) := '69732E5F7570646174656452616E67652E72656164286E293B696628216F7C7C21746869732E696E6C696E65436F6D706C6574696F6E2E72616E67652E6765745374617274506F736974696F6E28292E657175616C73286F2E6765745374617274506F73';
wwv_flow_imp.g_varchar2_table(27116) := '6974696F6E2829297C7C742E6C696E654E756D626572213D3D692E72616E67652E73746172744C696E654E756D6265722972657475726E21313B636F6E737420733D652E67657456616C7565496E52616E676528692E72616E67652C31292C723D692E74';
wwv_flow_imp.g_varchar2_table(27117) := '6578742C613D4D6174682E6D617828302C742E636F6C756D6E2D692E72616E67652E7374617274436F6C756D6E293B6C6574206C3D722E737562737472696E6728302C61292C633D722E737562737472696E672861292C643D732E737562737472696E67';
wwv_flow_imp.g_varchar2_table(27118) := '28302C61292C683D732E737562737472696E672861293B636F6E737420753D652E6765744C696E65496E64656E74436F6C756D6E28692E72616E67652E73746172744C696E654E756D626572293B72657475726E20692E72616E67652E7374617274436F';
wwv_flow_imp.g_varchar2_table(27119) := '6C756D6E3C3D75262628643D642E7472696D537461727428292C303D3D3D642E6C656E677468262628683D682E7472696D53746172742829292C6C3D6C2E7472696D537461727428292C303D3D3D6C2E6C656E677468262628633D632E7472696D537461';
wwv_flow_imp.g_varchar2_table(27120) := '7274282929292C6C2E7374617274735769746828642926262121776128682C63297D63616E426552657573656428652C74297B636F6E7374206E3D746869732E5F7570646174656452616E67652E7265616428766F69642030293B72657475726E21216E';
wwv_flow_imp.g_varchar2_table(27121) := '26266E2E636F6E7461696E73506F736974696F6E2874292626746869732E697356697369626C6528652C742C766F696420302926266D672E6F6652616E6765286E292E6973477265617465725468616E4F72457175616C546F286D672E6F6652616E6765';
wwv_flow_imp.g_varchar2_table(27122) := '28746869732E696E6C696E65436F6D706C6574696F6E2E72616E676529297D5F746F46696C746572546578745265706C6163656D656E742865297B76617220743B72657475726E206E657720557A286E756C6C213D3D28743D746869732E5F7570646174';
wwv_flow_imp.g_varchar2_table(27123) := '656452616E67652E72656164286529292626766F69642030213D3D743F743A73352C746869732E696E6C696E65436F6D706C6574696F6E2E66696C74657254657874297D7D636F6E73742073353D6E657720726828312C312C312C31292C72353D7B5669';
wwv_flow_imp.g_varchar2_table(27124) := '7369626C653A65302C486173466F637573656453756767657374696F6E3A6E6577206C64282273756767657374576964676574486173466F637573656453756767657374696F6E222C21312C6228302C225768657468657220616E792073756767657374';
wwv_flow_imp.g_varchar2_table(27125) := '696F6E20697320666F63757365642229292C44657461696C7356697369626C653A6E6577206C6428227375676765737457696467657444657461696C7356697369626C65222C21312C6228302C22576865746865722073756767657374696F6E20646574';
wwv_flow_imp.g_varchar2_table(27126) := '61696C73206172652076697369626C652229292C4D756C7469706C6553756767657374696F6E733A6E6577206C642822737567676573745769646765744D756C7469706C6553756767657374696F6E73222C21312C6228302C2257686574686572207468';
wwv_flow_imp.g_varchar2_table(27127) := '65726520617265206D756C7469706C652073756767657374696F6E7320746F207069636B2066726F6D2229292C4D616B657354657874456469743A6E6577206C64282273756767657374696F6E4D616B65735465787445646974222C21302C6228302C22';
wwv_flow_imp.g_varchar2_table(27128) := '5768657468657220696E73657274696E67207468652063757272656E742073756767657374696F6E207969656C647320696E2061206368616E6765206F72206861732065766572797468696E6720616C7265616479206265656E2074797065642229292C';
wwv_flow_imp.g_varchar2_table(27129) := '41636365707453756767657374696F6E734F6E456E7465723A6E6577206C64282261636365707453756767657374696F6E4F6E456E746572222C21302C6228302C22576865746865722073756767657374696F6E732061726520696E7365727465642077';
wwv_flow_imp.g_varchar2_table(27130) := '68656E207072657373696E6720456E7465722229292C486173496E73657274416E645265706C61636552616E67653A6E6577206C64282273756767657374696F6E486173496E73657274416E645265706C61636552616E6765222C21312C6228302C2257';
wwv_flow_imp.g_varchar2_table(27131) := '686574686572207468652063757272656E742073756767657374696F6E2068617320696E7365727420616E64207265706C616365206265686176696F75722229292C496E736572744D6F64653A6E6577206C64282273756767657374696F6E496E736572';
wwv_flow_imp.g_varchar2_table(27132) := '744D6F6465222C766F696420302C7B747970653A22737472696E67222C6465736372697074696F6E3A6228302C2257686574686572207468652064656661756C74206265686176696F757220697320746F20696E73657274206F72207265706C61636522';
wwv_flow_imp.g_varchar2_table(27133) := '297D292C43616E5265736F6C76653A6E6577206C64282273756767657374696F6E43616E5265736F6C7665222C21312C6228302C2257686574686572207468652063757272656E742073756767657374696F6E20737570706F72747320746F207265736F';
wwv_flow_imp.g_varchar2_table(27134) := '6C766520667572746865722064657461696C732229297D2C61353D6E6577204C6428227375676765737457696467657453746174757342617222293B636C617373206C357B636F6E7374727563746F7228652C742C6E2C69297B766172206F3B74686973';
wwv_flow_imp.g_varchar2_table(27135) := '2E706F736974696F6E3D652C746869732E636F6D706C6574696F6E3D742C746869732E636F6E7461696E65723D6E2C746869732E70726F76696465723D692C746869732E6973496E76616C69643D21312C746869732E73636F72653D736C2E4465666175';
wwv_flow_imp.g_varchar2_table(27136) := '6C742C746869732E64697374616E63653D302C746869732E746578744C6162656C3D22737472696E67223D3D747970656F6620742E6C6162656C3F742E6C6162656C3A6E756C6C3D3D3D286F3D742E6C6162656C297C7C766F696420303D3D3D6F3F766F';
wwv_flow_imp.g_varchar2_table(27137) := '696420303A6F2E6C6162656C2C746869732E6C6162656C4C6F773D746869732E746578744C6162656C2E746F4C6F7765724361736528292C746869732E6973496E76616C69643D21746869732E746578744C6162656C2C746869732E736F727454657874';
wwv_flow_imp.g_varchar2_table(27138) := '4C6F773D742E736F7274546578742626742E736F7274546578742E746F4C6F7765724361736528292C746869732E66696C746572546578744C6F773D742E66696C746572546578742626742E66696C746572546578742E746F4C6F776572436173652829';
wwv_flow_imp.g_varchar2_table(27139) := '2C746869732E657874656E73696F6E49643D742E657874656E73696F6E49642C72682E69734952616E676528742E72616E6765293F28746869732E6564697453746172743D6E6577206D6328742E72616E67652E73746172744C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(27140) := '742E72616E67652E7374617274436F6C756D6E292C746869732E65646974496E73657274456E643D6E6577206D6328742E72616E67652E656E644C696E654E756D6265722C742E72616E67652E656E64436F6C756D6E292C746869732E65646974526570';
wwv_flow_imp.g_varchar2_table(27141) := '6C616365456E643D6E6577206D6328742E72616E67652E656E644C696E654E756D6265722C742E72616E67652E656E64436F6C756D6E292C746869732E6973496E76616C69643D746869732E6973496E76616C69647C7C72682E7370616E734D756C7469';
wwv_flow_imp.g_varchar2_table(27142) := '706C654C696E657328742E72616E6765297C7C742E72616E67652E73746172744C696E654E756D626572213D3D652E6C696E654E756D626572293A28746869732E6564697453746172743D6E6577206D6328742E72616E67652E696E736572742E737461';
wwv_flow_imp.g_varchar2_table(27143) := '72744C696E654E756D6265722C742E72616E67652E696E736572742E7374617274436F6C756D6E292C746869732E65646974496E73657274456E643D6E6577206D6328742E72616E67652E696E736572742E656E644C696E654E756D6265722C742E7261';
wwv_flow_imp.g_varchar2_table(27144) := '6E67652E696E736572742E656E64436F6C756D6E292C746869732E656469745265706C616365456E643D6E6577206D6328742E72616E67652E7265706C6163652E656E644C696E654E756D6265722C742E72616E67652E7265706C6163652E656E64436F';
wwv_flow_imp.g_varchar2_table(27145) := '6C756D6E292C746869732E6973496E76616C69643D746869732E6973496E76616C69647C7C72682E7370616E734D756C7469706C654C696E657328742E72616E67652E696E73657274297C7C72682E7370616E734D756C7469706C654C696E657328742E';
wwv_flow_imp.g_varchar2_table(27146) := '72616E67652E7265706C616365297C7C742E72616E67652E696E736572742E73746172744C696E654E756D626572213D3D652E6C696E654E756D6265727C7C742E72616E67652E7265706C6163652E73746172744C696E654E756D626572213D3D652E6C';
wwv_flow_imp.g_varchar2_table(27147) := '696E654E756D6265727C7C742E72616E67652E696E736572742E7374617274436F6C756D6E213D3D742E72616E67652E7265706C6163652E7374617274436F6C756D6E292C2266756E6374696F6E22213D747970656F6620692E7265736F6C7665436F6D';
wwv_flow_imp.g_varchar2_table(27148) := '706C6574696F6E4974656D262628746869732E5F7265736F6C766543616368653D50726F6D6973652E7265736F6C766528292C746869732E5F7265736F6C76654475726174696F6E3D30297D6765742069735265736F6C76656428297B72657475726E20';
wwv_flow_imp.g_varchar2_table(27149) := '766F69642030213D3D746869732E5F7265736F6C76654475726174696F6E7D676574207265736F6C76654475726174696F6E28297B72657475726E20766F69642030213D3D746869732E5F7265736F6C76654475726174696F6E3F746869732E5F726573';
wwv_flow_imp.g_varchar2_table(27150) := '6F6C76654475726174696F6E3A2D317D6173796E63207265736F6C76652865297B69662821746869732E5F7265736F6C76654361636865297B636F6E737420743D652E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B746869';
wwv_flow_imp.g_varchar2_table(27151) := '732E5F7265736F6C766543616368653D766F696420302C746869732E5F7265736F6C76654475726174696F6E3D766F696420307D29292C6E3D6E6577206674282130293B746869732E5F7265736F6C766543616368653D50726F6D6973652E7265736F6C';
wwv_flow_imp.g_varchar2_table(27152) := '766528746869732E70726F76696465722E7265736F6C7665436F6D706C6574696F6E4974656D28746869732E636F6D706C6574696F6E2C6529292E7468656E2828653D3E7B4F626A6563742E61737369676E28746869732E636F6D706C6574696F6E2C65';
wwv_flow_imp.g_varchar2_table(27153) := '292C746869732E5F7265736F6C76654475726174696F6E3D6E2E656C617073656428297D292C28653D3E7B5465286529262628746869732E5F7265736F6C766543616368653D766F696420302C746869732E5F7265736F6C76654475726174696F6E3D76';
wwv_flow_imp.g_varchar2_table(27154) := '6F69642030297D29292E66696E616C6C79282828293D3E7B742E646973706F736528297D29297D72657475726E20746869732E5F7265736F6C766543616368657D7D636C6173732063357B636F6E7374727563746F7228653D322C743D6E657720536574';
wwv_flow_imp.g_varchar2_table(27155) := '2C6E3D6E6577205365742C693D6E6577204D61702C6F3D2130297B746869732E736E6970706574536F72744F726465723D652C746869732E6B696E6446696C7465723D742C746869732E70726F766964657246696C7465723D6E2C746869732E70726F76';
wwv_flow_imp.g_varchar2_table(27156) := '696465724974656D73546F52657573653D692C746869732E73686F77446570726563617465643D6F7D7D63352E64656661756C743D6E65772063353B636C6173732064357B636F6E7374727563746F7228652C742C6E2C69297B746869732E6974656D73';
wwv_flow_imp.g_varchar2_table(27157) := '3D652C746869732E6E65656473436C6970626F6172643D742C746869732E6475726174696F6E733D6E2C746869732E646973706F7361626C653D697D7D6173796E632066756E6374696F6E20683528652C742C6E2C693D63352E64656661756C742C6F3D';
wwv_flow_imp.g_varchar2_table(27158) := '7B747269676765724B696E643A307D2C733D4D742E4E6F6E65297B636F6E737420723D6E65772066743B6E3D6E2E636C6F6E6528293B636F6E737420613D742E676574576F72644174506F736974696F6E286E292C6C3D613F6E6577207268286E2E6C69';
wwv_flow_imp.g_varchar2_table(27159) := '6E654E756D6265722C612E7374617274436F6C756D6E2C6E2E6C696E654E756D6265722C612E656E64436F6C756D6E293A72682E66726F6D506F736974696F6E73286E292C633D7B7265706C6163653A6C2C696E736572743A6C2E736574456E64506F73';
wwv_flow_imp.g_varchar2_table(27160) := '6974696F6E286E2E6C696E654E756D6265722C6E2E636F6C756D6E297D2C643D5B5D2C683D6E65772061742C753D5B5D3B6C657420703D21313B636F6E737420673D28652C742C6F293D3E7B76617220732C722C613B6C6574206C3D21313B6966282174';
wwv_flow_imp.g_varchar2_table(27161) := '2972657475726E206C3B666F7228636F6E7374206F206F6620742E73756767657374696F6E732969662821692E6B696E6446696C7465722E686173286F2E6B696E6429297B69662821692E73686F77446570726563617465642626286E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(27162) := '733D6E756C6C3D3D6F3F766F696420303A6F2E74616773297C7C766F696420303D3D3D733F766F696420303A732E696E636C756465732831292929636F6E74696E75653B6F2E72616E67657C7C286F2E72616E67653D63292C6F2E736F7274546578747C';
wwv_flow_imp.g_varchar2_table(27163) := '7C286F2E736F7274546578743D22737472696E67223D3D747970656F66206F2E6C6162656C3F6F2E6C6162656C3A6F2E6C6162656C2E6C6162656C292C217026266F2E696E736572745465787452756C6573262634266F2E696E73657274546578745275';
wwv_flow_imp.g_varchar2_table(27164) := '6C6573262628703D696B2E67756573734E65656473436C6970626F617264286F2E696E736572745465787429292C642E70757368286E6577206C35286E2C6F2C742C6529292C6C3D21307D72657475726E2069742874292626682E6164642874292C752E';
wwv_flow_imp.g_varchar2_table(27165) := '70757368287B70726F76696465724E616D653A6E756C6C213D3D28723D652E5F6465627567446973706C61794E616D65292626766F69642030213D3D723F723A22756E6B6E6F776E5F70726F7669646572222C656C617073656450726F76696465723A6E';
wwv_flow_imp.g_varchar2_table(27166) := '756C6C213D3D28613D742E6475726174696F6E292626766F69642030213D3D613F613A2D312C656C61707365644F766572616C6C3A6F2E656C617073656428297D292C6C7D2C6D3D286173796E6328293D3E7B7D2928293B666F7228636F6E7374207220';
wwv_flow_imp.g_varchar2_table(27167) := '6F6620652E6F72646572656447726F757073287429297B6C657420653D21313B69662861776169742050726F6D6973652E616C6C28722E6D617028286173796E6320723D3E7B696628692E70726F76696465724974656D73546F52657573652E68617328';
wwv_flow_imp.g_varchar2_table(27168) := '7229297B636F6E737420743D692E70726F76696465724974656D73546F52657573652E6765742872293B72657475726E20742E666F72456163682828653D3E642E7075736828652929292C766F696428653D657C7C742E6C656E6774683E30297D696628';
wwv_flow_imp.g_varchar2_table(27169) := '2128692E70726F766964657246696C7465722E73697A653E30297C7C692E70726F766964657246696C7465722E686173287229297472797B636F6E737420693D6E65772066742C613D617761697420722E70726F76696465436F6D706C6574696F6E4974';
wwv_flow_imp.g_varchar2_table(27170) := '656D7328742C6E2C6F2C73293B653D6728722C612C69297C7C657D63617463682865297B45652865297D7D2929292C657C7C732E697343616E63656C6C6174696F6E52657175657374656429627265616B7D72657475726E206177616974206D2C732E69';
wwv_flow_imp.g_varchar2_table(27171) := '7343616E63656C6C6174696F6E5265717565737465643F28682E646973706F736528292C50726F6D6973652E72656A656374286E657720496529293A6E657720643528642E736F72742828663D692E736E6970706574536F72744F726465722C70352E67';
wwv_flow_imp.g_varchar2_table(27172) := '657428662929292C702C7B656E74726965733A752C656C61707365643A722E656C617073656428297D2C68293B76617220667D66756E6374696F6E20753528652C74297B696628652E736F7274546578744C6F772626742E736F7274546578744C6F7729';
wwv_flow_imp.g_varchar2_table(27173) := '7B696628652E736F7274546578744C6F773C742E736F7274546578744C6F772972657475726E2D313B696628652E736F7274546578744C6F773E742E736F7274546578744C6F772972657475726E20317D72657475726E20652E746578744C6162656C3C';
wwv_flow_imp.g_varchar2_table(27174) := '742E746578744C6162656C3F2D313A652E746578744C6162656C3E742E746578744C6162656C3F313A652E636F6D706C6574696F6E2E6B696E642D742E636F6D706C6574696F6E2E6B696E647D636F6E73742070353D6E6577204D61703B70352E736574';
wwv_flow_imp.g_varchar2_table(27175) := '28302C2866756E6374696F6E28652C74297B696628652E636F6D706C6574696F6E2E6B696E64213D3D742E636F6D706C6574696F6E2E6B696E64297B69662832373D3D3D652E636F6D706C6574696F6E2E6B696E642972657475726E2D313B6966283237';
wwv_flow_imp.g_varchar2_table(27176) := '3D3D3D742E636F6D706C6574696F6E2E6B696E642972657475726E20317D72657475726E20753528652C74297D29292C70352E73657428322C2866756E6374696F6E28652C74297B696628652E636F6D706C6574696F6E2E6B696E64213D3D742E636F6D';
wwv_flow_imp.g_varchar2_table(27177) := '706C6574696F6E2E6B696E64297B69662832373D3D3D652E636F6D706C6574696F6E2E6B696E642972657475726E20313B69662832373D3D3D742E636F6D706C6574696F6E2E6B696E642972657475726E2D317D72657475726E20753528652C74297D29';
wwv_flow_imp.g_varchar2_table(27178) := '292C70352E73657428312C7535292C6B632E7265676973746572436F6D6D616E6428225F65786563757465436F6D706C6574696F6E4974656D50726F7669646572222C286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E2C692C6F2C735D3D74';
wwv_flow_imp.g_varchar2_table(27179) := '3B796C284E6F2E6973557269286E29292C796C286D632E697349506F736974696F6E286929292C796C2822737472696E67223D3D747970656F66206F7C7C216F292C796C28226E756D626572223D3D747970656F6620737C7C2173293B636F6E73747B63';
wwv_flow_imp.g_varchar2_table(27180) := '6F6D706C6574696F6E50726F76696465723A727D3D652E676574287878292C613D617761697420652E676574287663292E6372656174654D6F64656C5265666572656E6365286E293B7472797B636F6E737420653D7B696E636F6D706C6574653A21312C';
wwv_flow_imp.g_varchar2_table(27181) := '73756767657374696F6E733A5B5D7D2C743D5B5D2C6E3D612E6F626A6563742E74657874456469746F724D6F64656C2E76616C6964617465506F736974696F6E2869292C6C3D617761697420683528722C612E6F626A6563742E74657874456469746F72';
wwv_flow_imp.g_varchar2_table(27182) := '4D6F64656C2C6E2C766F696420302C7B747269676765724368617261637465723A6E756C6C213D6F3F6F3A766F696420302C747269676765724B696E643A6F3F313A307D293B666F7228636F6E7374206E206F66206C2E6974656D7329742E6C656E6774';
wwv_flow_imp.g_varchar2_table(27183) := '683C286E756C6C213D733F733A30292626742E70757368286E2E7265736F6C7665284D742E4E6F6E6529292C652E696E636F6D706C6574653D652E696E636F6D706C6574657C7C6E2E636F6E7461696E65722E696E636F6D706C6574652C652E73756767';
wwv_flow_imp.g_varchar2_table(27184) := '657374696F6E732E70757368286E2E636F6D706C6574696F6E293B7472797B72657475726E2061776169742050726F6D6973652E616C6C2874292C657D66696E616C6C797B73657454696D656F7574282828293D3E6C2E646973706F7361626C652E6469';
wwv_flow_imp.g_varchar2_table(27185) := '73706F73652829292C313030297D7D66696E616C6C797B612E646973706F736528297D7D29293B636C6173732067357B737461746963206973416C6C4F66662865297B72657475726E226F6666223D3D3D652E6F746865722626226F6666223D3D3D652E';
wwv_flow_imp.g_varchar2_table(27186) := '636F6D6D656E74732626226F6666223D3D3D652E737472696E67737D737461746963206973416C6C4F6E2865297B72657475726E226F6E223D3D3D652E6F746865722626226F6E223D3D3D652E636F6D6D656E74732626226F6E223D3D3D652E73747269';
wwv_flow_imp.g_varchar2_table(27187) := '6E67737D7374617469632076616C7565466F7228652C74297B7377697463682874297B6361736520313A72657475726E20652E636F6D6D656E74733B6361736520323A72657475726E20652E737472696E67733B64656661756C743A72657475726E2065';
wwv_flow_imp.g_varchar2_table(27188) := '2E6F746865727D7D7D766172206D353D6E283639292C66353D7B7D3B66756E6374696F6E20763528652C743D6A297B72657475726E2066756E6374696F6E28652C743D6A297B72657475726E2121742626576C28652E63686172436F6465417428302929';
wwv_flow_imp.g_varchar2_table(27189) := '262635383D3D3D652E63686172436F646541742831297D28652C74293F652E6368617241742830292E746F55707065724361736528292B652E736C6963652831293A657D66352E7374796C655461675472616E73666F726D3D6A7228292C66352E736574';
wwv_flow_imp.g_varchar2_table(27190) := '417474726962757465733D567228292C66352E696E736572743D467228292E62696E64286E756C6C2C226865616422292C66352E646F6D4150493D4F7228292C66352E696E736572745374796C65456C656D656E743D487228292C4E722829286D352E41';
wwv_flow_imp.g_varchar2_table(27191) := '2C6635292C6D352E4126266D352E412E6C6F63616C7326266D352E412E6C6F63616C732C4F626A6563742E637265617465286E756C6C293B4F626A6563742E667265657A65287B43555252454E545F594541523A21302C43555252454E545F594541525F';
wwv_flow_imp.g_varchar2_table(27192) := '53484F52543A21302C43555252454E545F4D4F4E54483A21302C43555252454E545F444154453A21302C43555252454E545F484F55523A21302C43555252454E545F4D494E5554453A21302C43555252454E545F5345434F4E443A21302C43555252454E';
wwv_flow_imp.g_varchar2_table(27193) := '545F4441595F4E414D453A21302C43555252454E545F4441595F4E414D455F53484F52543A21302C43555252454E545F4D4F4E54485F4E414D453A21302C43555252454E545F4D4F4E54485F4E414D455F53484F52543A21302C43555252454E545F5345';
wwv_flow_imp.g_varchar2_table(27194) := '434F4E44535F554E49583A21302C43555252454E545F54494D455A4F4E455F4F46465345543A21302C53454C454354494F4E3A21302C434C4950424F4152443A21302C544D5F53454C45435445445F544558543A21302C544D5F43555252454E545F4C49';
wwv_flow_imp.g_varchar2_table(27195) := '4E453A21302C544D5F43555252454E545F574F52443A21302C544D5F4C494E455F494E4445583A21302C544D5F4C494E455F4E554D4245523A21302C544D5F46494C454E414D453A21302C544D5F46494C454E414D455F424153453A21302C544D5F4449';
wwv_flow_imp.g_varchar2_table(27196) := '524543544F52593A21302C544D5F46494C45504154483A21302C435552534F525F494E4445583A21302C435552534F525F4E554D4245523A21302C52454C41544956455F46494C45504154483A21302C424C4F434B5F434F4D4D454E545F53544152543A';
wwv_flow_imp.g_varchar2_table(27197) := '21302C424C4F434B5F434F4D4D454E545F454E443A21302C4C494E455F434F4D4D454E543A21302C574F524B53504143455F4E414D453A21302C574F524B53504143455F464F4C4445523A21302C52414E444F4D3A21302C52414E444F4D5F4845583A21';
wwv_flow_imp.g_varchar2_table(27198) := '302C555549443A21307D293B636C6173732062357B636F6E7374727563746F722865297B746869732E5F64656C6567617465733D657D7265736F6C76652865297B666F7228636F6E73742074206F6620746869732E5F64656C656761746573297B636F6E';
wwv_flow_imp.g_varchar2_table(27199) := '7374206E3D742E7265736F6C76652865293B696628766F69642030213D3D6E2972657475726E206E7D7D7D636C617373205F357B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F6D6F64656C3D652C746869732E5F73656C65637469';
wwv_flow_imp.g_varchar2_table(27200) := '6F6E3D742C746869732E5F73656C656374696F6E4964783D6E2C746869732E5F6F766572747970696E6743617074757265723D697D7265736F6C76652865297B636F6E73747B6E616D653A747D3D653B6966282253454C454354494F4E223D3D3D747C7C';
wwv_flow_imp.g_varchar2_table(27201) := '22544D5F53454C45435445445F54455854223D3D3D74297B6C657420743D746869732E5F6D6F64656C2E67657456616C7565496E52616E676528746869732E5F73656C656374696F6E297C7C766F696420302C6E3D746869732E5F73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(27202) := '2E73746172744C696E654E756D626572213D3D746869732E5F73656C656374696F6E2E656E644C696E654E756D6265723B69662821742626746869732E5F6F766572747970696E674361707475726572297B636F6E737420653D746869732E5F6F766572';
wwv_flow_imp.g_varchar2_table(27203) := '747970696E6743617074757265722E6765744C6173744F7665727479706564496E666F28746869732E5F73656C656374696F6E496478293B65262628743D652E76616C75652C6E3D652E6D756C74696C696E65297D6966287426266E2626652E736E6970';
wwv_flow_imp.g_varchar2_table(27204) := '706574297B636F6E7374206E3D666928746869732E5F6D6F64656C2E6765744C696E65436F6E74656E7428746869732E5F73656C656374696F6E2E73746172744C696E654E756D626572292C302C746869732E5F73656C656374696F6E2E737461727443';
wwv_flow_imp.g_varchar2_table(27205) := '6F6C756D6E2D31293B6C657420693D6E3B652E736E69707065742E77616C6B2828743D3E74213D3D652626287420696E7374616E63656F66204778262628693D666928676928742E76616C7565292E706F70282929292C21302929293B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(27206) := '3D4C6928692C6E293B743D742E7265706C616365282F285C725C6E7C5C727C5C6E29282E2A292F672C2828652C742C6E293D3E60247B747D247B692E737562737472286F297D247B6E7D6029297D72657475726E20747D69662822544D5F43555252454E';
wwv_flow_imp.g_varchar2_table(27207) := '545F4C494E45223D3D3D742972657475726E20746869732E5F6D6F64656C2E6765744C696E65436F6E74656E7428746869732E5F73656C656374696F6E2E706F736974696F6E4C696E654E756D626572293B69662822544D5F43555252454E545F574F52';
wwv_flow_imp.g_varchar2_table(27208) := '44223D3D3D74297B636F6E737420653D746869732E5F6D6F64656C2E676574576F72644174506F736974696F6E287B6C696E654E756D6265723A746869732E5F73656C656374696F6E2E706F736974696F6E4C696E654E756D6265722C636F6C756D6E3A';
wwv_flow_imp.g_varchar2_table(27209) := '746869732E5F73656C656374696F6E2E706F736974696F6E436F6C756D6E7D293B72657475726E20652626652E776F72647C7C766F696420307D72657475726E22544D5F4C494E455F494E444558223D3D3D743F537472696E6728746869732E5F73656C';
wwv_flow_imp.g_varchar2_table(27210) := '656374696F6E2E706F736974696F6E4C696E654E756D6265722D31293A22544D5F4C494E455F4E554D424552223D3D3D743F537472696E6728746869732E5F73656C656374696F6E2E706F736974696F6E4C696E654E756D626572293A22435552534F52';
wwv_flow_imp.g_varchar2_table(27211) := '5F494E444558223D3D3D743F537472696E6728746869732E5F73656C656374696F6E496478293A22435552534F525F4E554D424552223D3D3D743F537472696E6728746869732E5F73656C656374696F6E4964782B31293A766F696420307D7D636C6173';
wwv_flow_imp.g_varchar2_table(27212) := '732079357B636F6E7374727563746F7228652C74297B746869732E5F6C6162656C536572766963653D652C746869732E5F6D6F64656C3D747D7265736F6C76652865297B636F6E73747B6E616D653A747D3D653B69662822544D5F46494C454E414D4522';
wwv_flow_imp.g_varchar2_table(27213) := '3D3D3D742972657475726E20786F28746869732E5F6D6F64656C2E7572692E667350617468293B69662822544D5F46494C454E414D455F42415345223D3D3D74297B636F6E737420653D786F28746869732E5F6D6F64656C2E7572692E66735061746829';
wwv_flow_imp.g_varchar2_table(27214) := '2C743D652E6C617374496E6465784F6628222E22293B72657475726E20743C3D303F653A652E736C69636528302C74297D72657475726E22544D5F4449524543544F5259223D3D3D743F222E223D3D3D536F28746869732E5F6D6F64656C2E7572692E66';
wwv_flow_imp.g_varchar2_table(27215) := '7350617468293F22223A746869732E5F6C6162656C536572766963652E6765745572694C6162656C28596C28746869732E5F6D6F64656C2E75726929293A22544D5F46494C4550415448223D3D3D743F746869732E5F6C6162656C536572766963652E67';
wwv_flow_imp.g_varchar2_table(27216) := '65745572694C6162656C28746869732E5F6D6F64656C2E757269293A2252454C41544956455F46494C4550415448223D3D3D743F746869732E5F6C6162656C536572766963652E6765745572694C6162656C28746869732E5F6D6F64656C2E7572692C7B';
wwv_flow_imp.g_varchar2_table(27217) := '72656C61746976653A21302C6E6F5072656669783A21307D293A766F696420307D7D636C6173732077357B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F72656164436C6970626F617264546578743D652C746869732E5F73656C65';
wwv_flow_imp.g_varchar2_table(27218) := '6374696F6E4964783D742C746869732E5F73656C656374696F6E436F756E743D6E2C746869732E5F7370726561643D697D7265736F6C76652865297B69662822434C4950424F41524422213D3D652E6E616D652972657475726E3B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(27219) := '6869732E5F72656164436C6970626F6172645465787428293B69662874297B696628746869732E5F737072656164297B636F6E737420653D742E73706C6974282F5C725C6E7C5C6E7C5C722F292E66696C7465722828653D3E21736928652929293B6966';
wwv_flow_imp.g_varchar2_table(27220) := '28652E6C656E6774683D3D3D746869732E5F73656C656374696F6E436F756E742972657475726E20655B746869732E5F73656C656374696F6E4964785D7D72657475726E20747D7D7D6C65742043353D636C6173737B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(27221) := '742C6E297B746869732E5F6D6F64656C3D652C746869732E5F73656C656374696F6E3D742C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D6E7D7265736F6C76652865297B636F6E73747B6E616D653A747D3D65';
wwv_flow_imp.g_varchar2_table(27222) := '2C6E3D746869732E5F6D6F64656C2E6765744C616E677561676549644174506F736974696F6E28746869732E5F73656C656374696F6E2E73656C656374696F6E53746172744C696E654E756D6265722C746869732E5F73656C656374696F6E2E73656C65';
wwv_flow_imp.g_varchar2_table(27223) := '6374696F6E5374617274436F6C756D6E292C693D746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286E292E636F6D6D656E74733B6966286929726574';
wwv_flow_imp.g_varchar2_table(27224) := '75726E224C494E455F434F4D4D454E54223D3D3D743F692E6C696E65436F6D6D656E74546F6B656E7C7C766F696420303A22424C4F434B5F434F4D4D454E545F5354415254223D3D3D743F692E626C6F636B436F6D6D656E745374617274546F6B656E7C';
wwv_flow_imp.g_varchar2_table(27225) := '7C766F696420303A22424C4F434B5F434F4D4D454E545F454E44223D3D3D742626692E626C6F636B436F6D6D656E74456E64546F6B656E7C7C766F696420307D7D3B43353D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D';
wwv_flow_imp.g_varchar2_table(27226) := '656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C656374262622';
wwv_flow_imp.g_varchar2_table(27227) := '66756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F';
wwv_flow_imp.g_varchar2_table(27228) := '3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E637469';
wwv_flow_imp.g_varchar2_table(27229) := '6F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28322C6567295D2C4335293B636C6173732053357B636F6E7374727563746F7228297B746869732E5F646174653D6E657720446174657D7265736F6C76';
wwv_flow_imp.g_varchar2_table(27230) := '652865297B636F6E73747B6E616D653A747D3D653B6966282243555252454E545F59454152223D3D3D742972657475726E20537472696E6728746869732E5F646174652E67657446756C6C596561722829293B6966282243555252454E545F594541525F';
wwv_flow_imp.g_varchar2_table(27231) := '53484F5254223D3D3D742972657475726E20537472696E6728746869732E5F646174652E67657446756C6C596561722829292E736C696365282D32293B6966282243555252454E545F4D4F4E5448223D3D3D742972657475726E20537472696E67287468';
wwv_flow_imp.g_varchar2_table(27232) := '69732E5F646174652E6765744D6F6E746828292E76616C75654F6628292B31292E706164537461727428322C223022293B6966282243555252454E545F44415445223D3D3D742972657475726E20537472696E6728746869732E5F646174652E67657444';
wwv_flow_imp.g_varchar2_table(27233) := '61746528292E76616C75654F662829292E706164537461727428322C223022293B6966282243555252454E545F484F5552223D3D3D742972657475726E20537472696E6728746869732E5F646174652E676574486F75727328292E76616C75654F662829';
wwv_flow_imp.g_varchar2_table(27234) := '292E706164537461727428322C223022293B6966282243555252454E545F4D494E555445223D3D3D742972657475726E20537472696E6728746869732E5F646174652E6765744D696E7574657328292E76616C75654F662829292E706164537461727428';
wwv_flow_imp.g_varchar2_table(27235) := '322C223022293B6966282243555252454E545F5345434F4E44223D3D3D742972657475726E20537472696E6728746869732E5F646174652E6765745365636F6E647328292E76616C75654F662829292E706164537461727428322C223022293B69662822';
wwv_flow_imp.g_varchar2_table(27236) := '43555252454E545F4441595F4E414D45223D3D3D742972657475726E2053352E6461794E616D65735B746869732E5F646174652E67657444617928295D3B6966282243555252454E545F4441595F4E414D455F53484F5254223D3D3D742972657475726E';
wwv_flow_imp.g_varchar2_table(27237) := '2053352E6461794E616D657353686F72745B746869732E5F646174652E67657444617928295D3B6966282243555252454E545F4D4F4E54485F4E414D45223D3D3D742972657475726E2053352E6D6F6E74684E616D65735B746869732E5F646174652E67';
wwv_flow_imp.g_varchar2_table(27238) := '65744D6F6E746828295D3B6966282243555252454E545F4D4F4E54485F4E414D455F53484F5254223D3D3D742972657475726E2053352E6D6F6E74684E616D657353686F72745B746869732E5F646174652E6765744D6F6E746828295D3B696628224355';
wwv_flow_imp.g_varchar2_table(27239) := '5252454E545F5345434F4E44535F554E4958223D3D3D742972657475726E20537472696E67284D6174682E666C6F6F7228746869732E5F646174652E67657454696D6528292F31653329293B6966282243555252454E545F54494D455A4F4E455F4F4646';
wwv_flow_imp.g_varchar2_table(27240) := '534554223D3D3D74297B636F6E737420653D746869732E5F646174652E67657454696D657A6F6E654F666673657428292C743D653E303F222D223A222B222C6E3D4D6174682E7472756E63284D6174682E61627328652F363029292C693D6E3C31303F22';
wwv_flow_imp.g_varchar2_table(27241) := '30222B6E3A6E2C6F3D4D6174682E6162732865292D36302A6E3B72657475726E20742B692B223A222B286F3C31303F2230222B6F3A6F297D7D7D53352E6461794E616D65733D5B6228302C2253756E64617922292C6228302C224D6F6E64617922292C62';
wwv_flow_imp.g_varchar2_table(27242) := '28302C225475657364617922292C6228302C225765646E657364617922292C6228302C22546875727364617922292C6228302C2246726964617922292C6228302C22536174757264617922295D2C53352E6461794E616D657353686F72743D5B6228302C';
wwv_flow_imp.g_varchar2_table(27243) := '2253756E22292C6228302C224D6F6E22292C6228302C2254756522292C6228302C2257656422292C6228302C2254687522292C6228302C2246726922292C6228302C2253617422295D2C53352E6D6F6E74684E616D65733D5B6228302C224A616E756172';
wwv_flow_imp.g_varchar2_table(27244) := '7922292C6228302C22466562727561727922292C6228302C224D6172636822292C6228302C22417072696C22292C6228302C224D617922292C6228302C224A756E6522292C6228302C224A756C7922292C6228302C2241756775737422292C6228302C22';
wwv_flow_imp.g_varchar2_table(27245) := '53657074656D62657222292C6228302C224F63746F62657222292C6228302C224E6F76656D62657222292C6228302C22446563656D62657222295D2C53352E6D6F6E74684E616D657353686F72743D5B6228302C224A616E22292C6228302C2246656222';
wwv_flow_imp.g_varchar2_table(27246) := '292C6228302C224D617222292C6228302C2241707222292C6228302C224D617922292C6228302C224A756E22292C6228302C224A756C22292C6228302C2241756722292C6228302C2253657022292C6228302C224F637422292C6228302C224E6F762229';
wwv_flow_imp.g_varchar2_table(27247) := '2C6228302C2244656322295D3B636C6173732078357B636F6E7374727563746F722865297B746869732E5F776F726B7370616365536572766963653D657D7265736F6C76652865297B69662821746869732E5F776F726B73706163655365727669636529';
wwv_flow_imp.g_varchar2_table(27248) := '72657475726E3B636F6E737420743D66756E6374696F6E2865297B69662822737472696E67223D3D747970656F6620657C7C766F696420303D3D3D652972657475726E22737472696E67223D3D747970656F6620653F7B69643A786F2865297D3A4E783B';
wwv_flow_imp.g_varchar2_table(27249) := '636F6E737420743D653B72657475726E20742E636F6E66696775726174696F6E3F7B69643A742E69642C636F6E666967506174683A742E636F6E66696775726174696F6E7D3A313D3D3D742E666F6C646572732E6C656E6774683F7B69643A742E69642C';
wwv_flow_imp.g_varchar2_table(27250) := '7572693A742E666F6C646572735B305D2E7572697D3A7B69643A742E69647D7D28746869732E5F776F726B7370616365536572766963652E676574576F726B73706163652829293B72657475726E22737472696E6722213D747970656F66286E756C6C3D';
wwv_flow_imp.g_varchar2_table(27251) := '3D286E3D74293F766F696420303A6E2E6964297C7C4178286E297C7C66756E6374696F6E2865297B636F6E737420743D653B72657475726E22737472696E67223D3D747970656F66286E756C6C3D3D743F766F696420303A742E69642926264E6F2E6973';
wwv_flow_imp.g_varchar2_table(27252) := '55726928742E636F6E66696750617468297D286E293F22574F524B53504143455F4E414D45223D3D3D652E6E616D653F746869732E5F7265736F6C7665576F726B73706163654E616D652874293A22574F524B53504143455F464F4C444552223D3D3D65';
wwv_flow_imp.g_varchar2_table(27253) := '2E6E616D653F746869732E5F7265736F7665576F726B7370616365506174682874293A766F696420303A766F696420303B766172206E7D5F7265736F6C7665576F726B73706163654E616D652865297B69662841782865292972657475726E20786F2865';
wwv_flow_imp.g_varchar2_table(27254) := '2E7572692E70617468293B6C657420743D786F28652E636F6E666967506174682E70617468293B72657475726E20742E656E6473576974682822636F64652D776F726B73706163652229262628743D742E73756273747228302C742E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(27255) := '342D3129292C747D5F7265736F7665576F726B7370616365506174682865297B69662841782865292972657475726E20763528652E7572692E667350617468293B636F6E737420743D786F28652E636F6E666967506174682E70617468293B6C6574206E';
wwv_flow_imp.g_varchar2_table(27256) := '3D652E636F6E666967506174682E6673506174683B72657475726E206E2E656E6473576974682874292626286E3D6E2E73756273747228302C6E2E6C656E6774682D742E6C656E6774682D3129292C6E3F7635286E293A222F227D7D636C617373206B35';
wwv_flow_imp.g_varchar2_table(27257) := '7B7265736F6C76652865297B636F6E73747B6E616D653A747D3D653B72657475726E2252414E444F4D223D3D3D743F4D6174682E72616E646F6D28292E746F537472696E6728292E736C696365282D36293A2252414E444F4D5F484558223D3D3D743F4D';
wwv_flow_imp.g_varchar2_table(27258) := '6174682E72616E646F6D28292E746F537472696E67283136292E736C696365282D36293A2255554944223D3D3D743F727828293A766F696420307D7D7661722045353B636C617373204C357B636F6E7374727563746F7228652C742C6E297B746869732E';
wwv_flow_imp.g_varchar2_table(27259) := '5F656469746F723D652C746869732E5F736E69707065743D742C746869732E5F736E69707065744C696E654C656164696E67576869746573706163653D6E2C746869732E5F6F66667365743D2D312C746869732E5F6E657374696E674C6576656C3D312C';
wwv_flow_imp.g_varchar2_table(27260) := '746869732E5F706C616365686F6C64657247726F7570733D466828742E706C616365686F6C646572732C59782E636F6D706172654279496E646578292C746869732E5F706C616365686F6C64657247726F7570734964783D2D317D696E697469616C697A';
wwv_flow_imp.g_varchar2_table(27261) := '652865297B746869732E5F6F66667365743D652E6E6577506F736974696F6E7D646973706F736528297B746869732E5F706C616365686F6C6465724465636F726174696F6E732626746869732E5F656469746F722E72656D6F76654465636F726174696F';
wwv_flow_imp.g_varchar2_table(27262) := '6E73285B2E2E2E746869732E5F706C616365686F6C6465724465636F726174696F6E732E76616C75657328295D292C746869732E5F706C616365686F6C64657247726F7570732E6C656E6774683D307D5F696E69744465636F726174696F6E7328297B69';
wwv_flow_imp.g_varchar2_table(27263) := '66282D313D3D3D746869732E5F6F6666736574297468726F77206E6577204572726F722822536E6970706574206E6F7420696E697469616C697A65642122293B696628746869732E5F706C616365686F6C6465724465636F726174696F6E732972657475';
wwv_flow_imp.g_varchar2_table(27264) := '726E3B746869732E5F706C616365686F6C6465724465636F726174696F6E733D6E6577204D61703B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B746869732E5F656469746F722E6368616E67654465636F726174696F';
wwv_flow_imp.g_varchar2_table(27265) := '6E732828743D3E7B666F7228636F6E7374206E206F6620746869732E5F736E69707065742E706C616365686F6C64657273297B636F6E737420693D746869732E5F736E69707065742E6F6666736574286E292C6F3D746869732E5F736E69707065742E66';
wwv_flow_imp.g_varchar2_table(27266) := '756C6C4C656E286E292C733D72682E66726F6D506F736974696F6E7328652E676574506F736974696F6E417428746869732E5F6F66667365742B69292C652E676574506F736974696F6E417428746869732E5F6F66667365742B692B6F29292C723D6E2E';
wwv_flow_imp.g_varchar2_table(27267) := '697346696E616C54616273746F703F4C352E5F6465636F722E696E61637469766546696E616C3A4C352E5F6465636F722E696E6163746976652C613D742E6164644465636F726174696F6E28732C72293B746869732E5F706C616365686F6C6465724465';
wwv_flow_imp.g_varchar2_table(27268) := '636F726174696F6E732E736574286E2C61297D7D29297D6D6F76652865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E5B5D3B696628746869732E5F696E69744465636F726174696F6E7328292C746869732E';
wwv_flow_imp.g_varchar2_table(27269) := '5F706C616365686F6C64657247726F7570734964783E3D30297B636F6E737420653D5B5D3B666F7228636F6E73742074206F6620746869732E5F706C616365686F6C64657247726F7570735B746869732E5F706C616365686F6C64657247726F75707349';
wwv_flow_imp.g_varchar2_table(27270) := '64785D29696628742E7472616E73666F726D297B636F6E7374206E3D746869732E5F706C616365686F6C6465724465636F726174696F6E732E6765742874292C693D746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174';
wwv_flow_imp.g_varchar2_table(27271) := '696F6E52616E6765286E292C6F3D746869732E5F656469746F722E6765744D6F64656C28292E67657456616C7565496E52616E67652869292C733D742E7472616E73666F726D2E7265736F6C7665286F292E73706C6974282F5C725C6E7C5C727C5C6E2F';
wwv_flow_imp.g_varchar2_table(27272) := '293B666F72286C657420653D313B653C732E6C656E6774683B652B2B29735B655D3D746869732E5F656469746F722E6765744D6F64656C28292E6E6F726D616C697A65496E64656E746174696F6E28746869732E5F736E69707065744C696E654C656164';
wwv_flow_imp.g_varchar2_table(27273) := '696E67576869746573706163652B735B655D293B652E70757368286A712E7265706C61636528692C732E6A6F696E28746869732E5F656469746F722E6765744D6F64656C28292E676574454F4C28292929297D652E6C656E6774683E302626746869732E';
wwv_flow_imp.g_varchar2_table(27274) := '5F656469746F722E6578656375746545646974732822736E69707065742E706C616365686F6C6465725472616E73666F726D222C65297D6C657420743D21313B21303D3D3D652626746869732E5F706C616365686F6C64657247726F7570734964783C74';
wwv_flow_imp.g_varchar2_table(27275) := '6869732E5F706C616365686F6C64657247726F7570732E6C656E6774682D313F28746869732E5F706C616365686F6C64657247726F7570734964782B3D312C743D2130293A21313D3D3D652626746869732E5F706C616365686F6C64657247726F757073';
wwv_flow_imp.g_varchar2_table(27276) := '4964783E30262628746869732E5F706C616365686F6C64657247726F7570734964782D3D312C743D2130293B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292E6368616E67654465636F726174696F6E732828653D3E7B63';
wwv_flow_imp.g_varchar2_table(27277) := '6F6E7374206E3D6E6577205365742C693D5B5D3B666F7228636F6E7374206F206F6620746869732E5F706C616365686F6C64657247726F7570735B746869732E5F706C616365686F6C64657247726F7570734964785D297B636F6E737420733D74686973';
wwv_flow_imp.g_varchar2_table(27278) := '2E5F706C616365686F6C6465724465636F726174696F6E732E676574286F292C723D746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652873293B692E70757368286E657720616828722E73746172';
wwv_flow_imp.g_varchar2_table(27279) := '744C696E654E756D6265722C722E7374617274436F6C756D6E2C722E656E644C696E654E756D6265722C722E656E64436F6C756D6E29292C743D742626746869732E5F686173506C616365686F6C6465724265656E436F6C6C6170736564286F292C652E';
wwv_flow_imp.g_varchar2_table(27280) := '6368616E67654465636F726174696F6E4F7074696F6E7328732C6F2E697346696E616C54616273746F703F4C352E5F6465636F722E61637469766546696E616C3A4C352E5F6465636F722E616374697665292C6E2E616464286F293B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(27281) := '742074206F6620746869732E5F736E69707065742E656E636C6F73696E67506C616365686F6C64657273286F29297B636F6E737420693D746869732E5F706C616365686F6C6465724465636F726174696F6E732E6765742874293B652E6368616E676544';
wwv_flow_imp.g_varchar2_table(27282) := '65636F726174696F6E4F7074696F6E7328692C742E697346696E616C54616273746F703F4C352E5F6465636F722E61637469766546696E616C3A4C352E5F6465636F722E616374697665292C6E2E6164642874297D7D666F7228636F6E73745B742C695D';
wwv_flow_imp.g_varchar2_table(27283) := '6F6620746869732E5F706C616365686F6C6465724465636F726174696F6E73296E2E6861732874297C7C652E6368616E67654465636F726174696F6E4F7074696F6E7328692C742E697346696E616C54616273746F703F4C352E5F6465636F722E696E61';
wwv_flow_imp.g_varchar2_table(27284) := '637469766546696E616C3A4C352E5F6465636F722E696E616374697665293B72657475726E20697D29293B72657475726E20743F746869732E6D6F76652865293A6E756C6C213D6E3F6E3A5B5D7D5F686173506C616365686F6C6465724265656E436F6C';
wwv_flow_imp.g_varchar2_table(27285) := '6C61707365642865297B6C657420743D653B666F72283B743B297B6966287420696E7374616E63656F66205978297B636F6E737420653D746869732E5F706C616365686F6C6465724465636F726174696F6E732E6765742874293B696628746869732E5F';
wwv_flow_imp.g_varchar2_table(27286) := '656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652865292E6973456D70747928292626742E746F537472696E6728292E6C656E6774683E302972657475726E21307D743D742E706172656E747D72657475726E21';
wwv_flow_imp.g_varchar2_table(27287) := '317D67657420697341744669727374506C616365686F6C64657228297B72657475726E20746869732E5F706C616365686F6C64657247726F7570734964783C3D307C7C303D3D3D746869732E5F706C616365686F6C64657247726F7570732E6C656E6774';
wwv_flow_imp.g_varchar2_table(27288) := '687D67657420697341744C617374506C616365686F6C64657228297B72657475726E20746869732E5F706C616365686F6C64657247726F7570734964783D3D3D746869732E5F706C616365686F6C64657247726F7570732E6C656E6774682D317D676574';
wwv_flow_imp.g_varchar2_table(27289) := '20686173506C616365686F6C64657228297B72657475726E20746869732E5F736E69707065742E706C616365686F6C646572732E6C656E6774683E307D6765742069735472697669616C536E697070657428297B696628303D3D3D746869732E5F736E69';
wwv_flow_imp.g_varchar2_table(27290) := '707065742E706C616365686F6C646572732E6C656E6774682972657475726E21303B696628313D3D3D746869732E5F736E69707065742E706C616365686F6C646572732E6C656E677468297B636F6E73745B655D3D746869732E5F736E69707065742E70';
wwv_flow_imp.g_varchar2_table(27291) := '6C616365686F6C646572733B696628652E697346696E616C54616273746F702626746869732E5F736E69707065742E72696768744D6F737444657363656E64616E743D3D3D652972657475726E21307D72657475726E21317D636F6D70757465506F7373';
wwv_flow_imp.g_varchar2_table(27292) := '69626C6553656C656374696F6E7328297B636F6E737420653D6E6577204D61703B666F7228636F6E73742074206F6620746869732E5F706C616365686F6C64657247726F757073297B6C6574206E3B666F7228636F6E73742069206F662074297B696628';
wwv_flow_imp.g_varchar2_table(27293) := '692E697346696E616C54616273746F7029627265616B3B6E7C7C286E3D5B5D2C652E73657428692E696E6465782C6E29293B636F6E737420743D746869732E5F706C616365686F6C6465724465636F726174696F6E732E6765742869292C6F3D74686973';
wwv_flow_imp.g_varchar2_table(27294) := '2E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652874293B696628216F297B652E64656C65746528692E696E646578293B627265616B7D6E2E70757368286F297D7D72657475726E20657D67657420616374';
wwv_flow_imp.g_varchar2_table(27295) := '69766543686F69636528297B69662821746869732E5F706C616365686F6C6465724465636F726174696F6E732972657475726E3B636F6E737420653D746869732E5F706C616365686F6C64657247726F7570735B746869732E5F706C616365686F6C6465';
wwv_flow_imp.g_varchar2_table(27296) := '7247726F7570734964785D5B305D3B69662821286E756C6C3D3D653F766F696420303A652E63686F696365292972657475726E3B636F6E737420743D746869732E5F706C616365686F6C6465724465636F726174696F6E732E6765742865293B69662821';
wwv_flow_imp.g_varchar2_table(27297) := '742972657475726E3B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292E6765744465636F726174696F6E52616E67652874293B72657475726E206E3F7B72616E67653A6E2C63686F6963653A652E63686F6963657D3A766F';
wwv_flow_imp.g_varchar2_table(27298) := '696420307D6765742068617343686F69636528297B6C657420653D21313B72657475726E20746869732E5F736E69707065742E77616C6B2828743D3E28653D7420696E7374616E63656F66205A782C21652929292C657D6D657267652865297B636F6E73';
wwv_flow_imp.g_varchar2_table(27299) := '7420743D746869732E5F656469746F722E6765744D6F64656C28293B746869732E5F6E657374696E674C6576656C2A3D31302C746869732E5F656469746F722E6368616E67654465636F726174696F6E7328286E3D3E7B666F7228636F6E73742069206F';
wwv_flow_imp.g_varchar2_table(27300) := '6620746869732E5F706C616365686F6C64657247726F7570735B746869732E5F706C616365686F6C64657247726F7570734964785D297B636F6E7374206F3D652E736869667428293B636F6E736F6C652E617373657274282D31213D3D6F2E5F6F666673';
wwv_flow_imp.g_varchar2_table(27301) := '6574292C636F6E736F6C652E61737365727428216F2E5F706C616365686F6C6465724465636F726174696F6E73293B636F6E737420733D6F2E5F736E69707065742E706C616365686F6C646572496E666F2E6C6173742E696E6465783B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(27302) := '73742065206F66206F2E5F736E69707065742E706C616365686F6C646572496E666F2E616C6C29652E697346696E616C54616273746F703F652E696E6465783D692E696E6465782B28732B31292F746869732E5F6E657374696E674C6576656C3A652E69';
wwv_flow_imp.g_varchar2_table(27303) := '6E6465783D692E696E6465782B652E696E6465782F746869732E5F6E657374696E674C6576656C3B746869732E5F736E69707065742E7265706C61636528692C6F2E5F736E69707065742E6368696C6472656E293B636F6E737420723D746869732E5F70';
wwv_flow_imp.g_varchar2_table(27304) := '6C616365686F6C6465724465636F726174696F6E732E6765742869293B6E2E72656D6F76654465636F726174696F6E2872292C746869732E5F706C616365686F6C6465724465636F726174696F6E732E64656C6574652869293B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(27305) := '65206F66206F2E5F736E69707065742E706C616365686F6C64657273297B636F6E737420693D6F2E5F736E69707065742E6F66667365742865292C733D6F2E5F736E69707065742E66756C6C4C656E2865292C723D72682E66726F6D506F736974696F6E';
wwv_flow_imp.g_varchar2_table(27306) := '7328742E676574506F736974696F6E4174286F2E5F6F66667365742B69292C742E676574506F736974696F6E4174286F2E5F6F66667365742B692B7329292C613D6E2E6164644465636F726174696F6E28722C4C352E5F6465636F722E696E6163746976';
wwv_flow_imp.g_varchar2_table(27307) := '65293B746869732E5F706C616365686F6C6465724465636F726174696F6E732E73657428652C61297D7D746869732E5F706C616365686F6C64657247726F7570733D466828746869732E5F736E69707065742E706C616365686F6C646572732C59782E63';
wwv_flow_imp.g_varchar2_table(27308) := '6F6D706172654279496E646578297D29297D7D4C352E5F6465636F723D7B6163746976653A4F432E7265676973746572287B6465736372697074696F6E3A22736E69707065742D706C616365686F6C6465722D31222C737469636B696E6573733A302C63';
wwv_flow_imp.g_varchar2_table(27309) := '6C6173734E616D653A22736E69707065742D706C616365686F6C646572227D292C696E6163746976653A4F432E7265676973746572287B6465736372697074696F6E3A22736E69707065742D706C616365686F6C6465722D32222C737469636B696E6573';
wwv_flow_imp.g_varchar2_table(27310) := '733A312C636C6173734E616D653A22736E69707065742D706C616365686F6C646572227D292C61637469766546696E616C3A4F432E7265676973746572287B6465736372697074696F6E3A22736E69707065742D706C616365686F6C6465722D33222C73';
wwv_flow_imp.g_varchar2_table(27311) := '7469636B696E6573733A312C636C6173734E616D653A2266696E6973682D736E69707065742D706C616365686F6C646572227D292C696E61637469766546696E616C3A4F432E7265676973746572287B6465736372697074696F6E3A22736E6970706574';
wwv_flow_imp.g_varchar2_table(27312) := '2D706C616365686F6C6465722D34222C737469636B696E6573733A312C636C6173734E616D653A2266696E6973682D736E69707065742D706C616365686F6C646572227D297D3B636F6E73742044353D7B6F76657277726974654265666F72653A302C6F';
wwv_flow_imp.g_varchar2_table(27313) := '766572777269746541667465723A302C61646A757374576869746573706163653A21302C636C6970626F617264546578743A766F696420302C6F766572747970696E6743617074757265723A766F696420307D3B6C65742054353D45353D636C6173737B';
wwv_flow_imp.g_varchar2_table(27314) := '7374617469632061646A7573745768697465737061636528652C742C6E2C692C6F297B636F6E737420733D666928652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292C302C742E636F6C756D6E2D31293B6C657420723B726574';
wwv_flow_imp.g_varchar2_table(27315) := '75726E20692E77616C6B2828743D3E7B69662821287420696E7374616E63656F66204778297C7C742E706172656E7420696E7374616E63656F66205A782972657475726E21303B6966286F2626216F2E6861732874292972657475726E21303B636F6E73';
wwv_flow_imp.g_varchar2_table(27316) := '7420613D742E76616C75652E73706C6974282F5C725C6E7C5C727C5C6E2F293B6966286E297B636F6E7374206E3D692E6F66667365742874293B696628303D3D3D6E29615B305D3D652E6E6F726D616C697A65496E64656E746174696F6E28615B305D29';
wwv_flow_imp.g_varchar2_table(27317) := '3B656C73657B723D6E756C6C213D723F723A692E746F537472696E6728293B636F6E737420743D722E63686172436F64654174286E2D31293B3130213D3D7426263133213D3D747C7C28615B305D3D652E6E6F726D616C697A65496E64656E746174696F';
wwv_flow_imp.g_varchar2_table(27318) := '6E28732B615B305D29297D666F72286C657420743D313B743C612E6C656E6774683B742B2B29615B745D3D652E6E6F726D616C697A65496E64656E746174696F6E28732B615B745D297D636F6E7374206C3D612E6A6F696E28652E676574454F4C282929';
wwv_flow_imp.g_varchar2_table(27319) := '3B72657475726E206C213D3D742E76616C7565262628742E706172656E742E7265706C61636528742C5B6E6577204778286C295D292C723D766F69642030292C21307D29292C737D7374617469632061646A75737453656C656374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(27320) := '2C69297B69662830213D3D6E7C7C30213D3D69297B636F6E73747B706F736974696F6E4C696E654E756D6265723A6F2C706F736974696F6E436F6C756D6E3A737D3D742C723D732D6E2C613D732B692C6C3D652E76616C696461746552616E6765287B73';
wwv_flow_imp.g_varchar2_table(27321) := '746172744C696E654E756D6265723A6F2C7374617274436F6C756D6E3A722C656E644C696E654E756D6265723A6F2C656E64436F6C756D6E3A617D293B743D61682E63726561746557697468446972656374696F6E286C2E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(27322) := '6265722C6C2E7374617274436F6C756D6E2C6C2E656E644C696E654E756D6265722C6C2E656E64436F6C756D6E2C742E676574446972656374696F6E2829297D72657475726E20747D737461746963206372656174654564697473416E64536E69707065';
wwv_flow_imp.g_varchar2_table(27323) := '747346726F6D53656C656374696F6E7328652C742C6E2C692C6F2C732C722C612C6C297B636F6E737420633D5B5D2C643D5B5D3B69662821652E6861734D6F64656C28292972657475726E7B65646974733A632C736E6970706574733A647D3B636F6E73';
wwv_flow_imp.g_varchar2_table(27324) := '7420683D652E6765744D6F64656C28292C753D652E696E766F6B6557697468696E436F6E746578742828653D3E652E676574284D782929292C703D652E696E766F6B6557697468696E436F6E746578742828653D3E6E657720793528652E676574284B47';
wwv_flow_imp.g_varchar2_table(27325) := '292C682929292C673D28293D3E722C6D3D682E67657456616C7565496E52616E67652845352E61646A75737453656C656374696F6E28682C652E67657453656C656374696F6E28292C6E2C3029292C663D682E67657456616C7565496E52616E67652845';
wwv_flow_imp.g_varchar2_table(27326) := '352E61646A75737453656C656374696F6E28682C652E67657453656C656374696F6E28292C302C6929292C763D682E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E28652E67657453656C656374696F6E28292E706F7369';
wwv_flow_imp.g_varchar2_table(27327) := '74696F6E4C696E654E756D626572292C623D652E67657453656C656374696F6E7328292E6D6170282828652C74293D3E287B73656C656374696F6E3A652C6964783A747D2929292E736F7274282828652C74293D3E72682E636F6D7061726552616E6765';
wwv_flow_imp.g_varchar2_table(27328) := '735573696E6753746172747328652E73656C656374696F6E2C742E73656C656374696F6E2929293B666F7228636F6E73747B73656C656374696F6E3A722C6964783A5F7D6F662062297B6C657420793D45352E61646A75737453656C656374696F6E2868';
wwv_flow_imp.g_varchar2_table(27329) := '2C722C6E2C30292C773D45352E61646A75737453656C656374696F6E28682C722C302C69293B6D213D3D682E67657456616C7565496E52616E6765287929262628793D72292C66213D3D682E67657456616C7565496E52616E6765287729262628773D72';
wwv_flow_imp.g_varchar2_table(27330) := '293B636F6E737420433D722E7365745374617274506F736974696F6E28792E73746172744C696E654E756D6265722C792E7374617274436F6C756D6E292E736574456E64506F736974696F6E28772E656E644C696E654E756D6265722C772E656E64436F';
wwv_flow_imp.g_varchar2_table(27331) := '6C756D6E292C533D286E657720696B292E706172736528742C21302C6F292C783D432E6765745374617274506F736974696F6E28292C6B3D45352E61646A7573745768697465737061636528682C782C737C7C5F3E30262676213D3D682E6765744C696E';
wwv_flow_imp.g_varchar2_table(27332) := '6546697273744E6F6E57686974657370616365436F6C756D6E28722E706F736974696F6E4C696E654E756D626572292C53293B532E7265736F6C76655661726961626C6573286E6577206235285B702C6E657720773528672C5F2C622E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(27333) := '22737072656164223D3D3D652E6765744F7074696F6E28373929292C6E6577205F3528682C722C5F2C61292C6E657720433528682C722C6C292C6E65772053352C6E65772078352875292C6E6577206B355D29292C635B5F5D3D6A712E7265706C616365';
wwv_flow_imp.g_varchar2_table(27334) := '28432C532E746F537472696E672829292C635B5F5D2E6964656E7469666965723D7B6D616A6F723A5F2C6D696E6F723A307D2C635B5F5D2E5F6973547261636B65643D21302C645B5F5D3D6E6577204C3528652C532C6B297D72657475726E7B65646974';
wwv_flow_imp.g_varchar2_table(27335) := '733A632C736E6970706574733A647D7D737461746963206372656174654564697473416E64536E69707065747346726F6D456469747328652C742C6E2C692C6F2C732C72297B69662821652E6861734D6F64656C28297C7C303D3D3D742E6C656E677468';
wwv_flow_imp.g_varchar2_table(27336) := '2972657475726E7B65646974733A5B5D2C736E6970706574733A5B5D7D3B636F6E737420613D5B5D2C6C3D652E6765744D6F64656C28292C633D6E657720696B2C643D6E6577206E6B2C683D6E6577206235285B652E696E766F6B6557697468696E436F';
wwv_flow_imp.g_varchar2_table(27337) := '6E746578742828653D3E6E657720793528652E676574284B47292C6C2929292C6E6577207735282828293D3E6F292C302C652E67657453656C656374696F6E7328292E6C656E6774682C22737072656164223D3D3D652E6765744F7074696F6E28373929';
wwv_flow_imp.g_varchar2_table(27338) := '292C6E6577205F35286C2C652E67657453656C656374696F6E28292C302C73292C6E6577204335286C2C652E67657453656C656374696F6E28292C72292C6E65772053352C6E657720783528652E696E766F6B6557697468696E436F6E74657874282865';
wwv_flow_imp.g_varchar2_table(27339) := '3D3E652E676574284D78292929292C6E6577206B355D293B743D742E736F7274282828652C74293D3E72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E67652929293B6C657420753D303B666F7228';
wwv_flow_imp.g_varchar2_table(27340) := '6C657420653D303B653C742E6C656E6774683B652B2B297B636F6E73747B72616E67653A6E2C74656D706C6174653A697D3D745B655D3B696628653E30297B636F6E737420693D745B652D315D2E72616E67652C6F3D72682E66726F6D506F736974696F';
wwv_flow_imp.g_varchar2_table(27341) := '6E7328692E676574456E64506F736974696F6E28292C6E2E6765745374617274506F736974696F6E2829292C733D6E6577204778286C2E67657456616C7565496E52616E6765286F29293B642E617070656E644368696C642873292C752B3D732E76616C';
wwv_flow_imp.g_varchar2_table(27342) := '75652E6C656E6774687D636F6E7374206F3D632E7061727365467261676D656E7428692C64293B45352E61646A75737457686974657370616365286C2C6E2E6765745374617274506F736974696F6E28292C21302C642C6E657720536574286F29292C64';
wwv_flow_imp.g_varchar2_table(27343) := '2E7265736F6C76655661726961626C65732868293B636F6E737420733D642E746F537472696E6728292C723D732E736C6963652875293B753D732E6C656E6774683B636F6E737420703D6A712E7265706C616365286E2C72293B702E6964656E74696669';
wwv_flow_imp.g_varchar2_table(27344) := '65723D7B6D616A6F723A652C6D696E6F723A307D2C702E5F6973547261636B65643D21302C612E707573682870297D72657475726E20632E656E7375726546696E616C54616273746F7028642C6E2C2130292C7B65646974733A612C736E697070657473';
wwv_flow_imp.g_varchar2_table(27345) := '3A5B6E6577204C3528652C642C2222295D7D7D636F6E7374727563746F7228652C742C6E3D44352C69297B746869732E5F656469746F723D652C746869732E5F74656D706C6174653D742C746869732E5F6F7074696F6E733D6E2C746869732E5F6C616E';
wwv_flow_imp.g_varchar2_table(27346) := '6775616765436F6E66696775726174696F6E536572766963653D692C746869732E5F74656D706C6174654D65726765733D5B5D2C746869732E5F736E6970706574733D5B5D7D646973706F736528297B6F7428746869732E5F736E697070657473297D5F';
wwv_flow_imp.g_varchar2_table(27347) := '6C6F67496E666F28297B72657475726E6074656D706C6174653D22247B746869732E5F74656D706C6174657D222C206D65726765645F74656D706C617465733D22247B746869732E5F74656D706C6174654D65726765732E6A6F696E2822202D3E202229';
wwv_flow_imp.g_varchar2_table(27348) := '7D22607D696E7365727428297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E73747B65646974733A652C736E6970706574733A747D3D22737472696E67223D3D747970656F6620746869732E5F74656D';
wwv_flow_imp.g_varchar2_table(27349) := '706C6174653F45352E6372656174654564697473416E64536E69707065747346726F6D53656C656374696F6E7328746869732E5F656469746F722C746869732E5F74656D706C6174652C746869732E5F6F7074696F6E732E6F7665727772697465426566';
wwv_flow_imp.g_varchar2_table(27350) := '6F72652C746869732E5F6F7074696F6E732E6F766572777269746541667465722C21312C746869732E5F6F7074696F6E732E61646A757374576869746573706163652C746869732E5F6F7074696F6E732E636C6970626F617264546578742C746869732E';
wwv_flow_imp.g_varchar2_table(27351) := '5F6F7074696F6E732E6F766572747970696E6743617074757265722C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293A45352E6372656174654564697473416E64536E69707065747346726F6D45646974732874';
wwv_flow_imp.g_varchar2_table(27352) := '6869732E5F656469746F722C746869732E5F74656D706C6174652C21312C746869732E5F6F7074696F6E732E61646A757374576869746573706163652C746869732E5F6F7074696F6E732E636C6970626F617264546578742C746869732E5F6F7074696F';
wwv_flow_imp.g_varchar2_table(27353) := '6E732E6F766572747970696E6743617074757265722C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B746869732E5F736E6970706574733D742C746869732E5F656469746F722E657865637574654564697473';
wwv_flow_imp.g_varchar2_table(27354) := '2822736E6970706574222C652C28653D3E7B636F6E7374206E3D652E66696C7465722828653D3E2121652E6964656E74696669657229293B666F72286C657420653D303B653C742E6C656E6774683B652B2B29745B655D2E696E697469616C697A65286E';
wwv_flow_imp.g_varchar2_table(27355) := '5B655D2E746578744368616E6765293B72657475726E20746869732E5F736E6970706574735B305D2E686173506C616365686F6C6465723F746869732E5F6D6F7665282130293A6E2E6D61702828653D3E61682E66726F6D506F736974696F6E7328652E';
wwv_flow_imp.g_varchar2_table(27356) := '72616E67652E676574456E64506F736974696F6E28292929297D29292C746869732E5F656469746F722E72657665616C52616E676528746869732E5F656469746F722E67657453656C656374696F6E7328295B305D297D6D6572676528652C743D443529';
wwv_flow_imp.g_varchar2_table(27357) := '7B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B746869732E5F74656D706C6174654D65726765732E70757368285B746869732E5F736E6970706574735B305D2E5F6E657374696E674C6576656C2C746869732E';
wwv_flow_imp.g_varchar2_table(27358) := '5F736E6970706574735B305D2E5F706C616365686F6C64657247726F7570734964782C655D293B636F6E73747B65646974733A6E2C736E6970706574733A697D3D45352E6372656174654564697473416E64536E69707065747346726F6D53656C656374';
wwv_flow_imp.g_varchar2_table(27359) := '696F6E7328746869732E5F656469746F722C652C742E6F76657277726974654265666F72652C742E6F766572777269746541667465722C21302C742E61646A757374576869746573706163652C742E636C6970626F617264546578742C742E6F76657274';
wwv_flow_imp.g_varchar2_table(27360) := '7970696E6743617074757265722C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B746869732E5F656469746F722E6578656375746545646974732822736E6970706574222C6E2C28653D3E7B636F6E73742074';
wwv_flow_imp.g_varchar2_table(27361) := '3D652E66696C7465722828653D3E2121652E6964656E74696669657229293B666F72286C657420653D303B653C692E6C656E6774683B652B2B29695B655D2E696E697469616C697A6528745B655D2E746578744368616E6765293B636F6E7374206E3D69';
wwv_flow_imp.g_varchar2_table(27362) := '5B305D2E69735472697669616C536E69707065743B696628216E297B666F7228636F6E73742065206F6620746869732E5F736E69707065747329652E6D657267652869293B636F6E736F6C652E61737365727428303D3D3D692E6C656E677468297D7265';
wwv_flow_imp.g_varchar2_table(27363) := '7475726E20746869732E5F736E6970706574735B305D2E686173506C616365686F6C6465722626216E3F746869732E5F6D6F766528766F69642030293A742E6D61702828653D3E61682E66726F6D506F736974696F6E7328652E72616E67652E67657445';
wwv_flow_imp.g_varchar2_table(27364) := '6E64506F736974696F6E28292929297D29297D6E65787428297B636F6E737420653D746869732E5F6D6F7665282130293B746869732E5F656469746F722E73657453656C656374696F6E732865292C746869732E5F656469746F722E72657665616C506F';
wwv_flow_imp.g_varchar2_table(27365) := '736974696F6E496E43656E74657249664F75747369646556696577706F727428655B305D2E676574506F736974696F6E2829297D7072657628297B636F6E737420653D746869732E5F6D6F7665282131293B746869732E5F656469746F722E7365745365';
wwv_flow_imp.g_varchar2_table(27366) := '6C656374696F6E732865292C746869732E5F656469746F722E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F727428655B305D2E676574506F736974696F6E2829297D5F6D6F76652865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(27367) := '743D5B5D3B666F7228636F6E7374206E206F6620746869732E5F736E697070657473297B636F6E737420693D6E2E6D6F76652865293B742E70757368282E2E2E69297D72657475726E20747D67657420697341744669727374506C616365686F6C646572';
wwv_flow_imp.g_varchar2_table(27368) := '28297B72657475726E20746869732E5F736E6970706574735B305D2E697341744669727374506C616365686F6C6465727D67657420697341744C617374506C616365686F6C64657228297B72657475726E20746869732E5F736E6970706574735B305D2E';
wwv_flow_imp.g_varchar2_table(27369) := '697341744C617374506C616365686F6C6465727D67657420686173506C616365686F6C64657228297B72657475726E20746869732E5F736E6970706574735B305D2E686173506C616365686F6C6465727D6765742068617343686F69636528297B726574';
wwv_flow_imp.g_varchar2_table(27370) := '75726E20746869732E5F736E6970706574735B305D2E68617343686F6963657D6765742061637469766543686F69636528297B72657475726E20746869732E5F736E6970706574735B305D2E61637469766543686F6963657D697353656C656374696F6E';
wwv_flow_imp.g_varchar2_table(27371) := '57697468696E506C616365686F6C6465727328297B69662821746869732E686173506C616365686F6C6465722972657475726E21313B636F6E737420653D746869732E5F656469746F722E67657453656C656374696F6E7328293B696628652E6C656E67';
wwv_flow_imp.g_varchar2_table(27372) := '74683C746869732E5F736E6970706574732E6C656E6774682972657475726E21313B636F6E737420743D6E6577204D61703B666F7228636F6E7374206E206F6620746869732E5F736E697070657473297B636F6E737420693D6E2E636F6D70757465506F';
wwv_flow_imp.g_varchar2_table(27373) := '737369626C6553656C656374696F6E7328293B696628303D3D3D742E73697A6529666F7228636F6E73745B6E2C6F5D6F662069297B6F2E736F72742872682E636F6D7061726552616E6765735573696E67537461727473293B666F7228636F6E73742069';
wwv_flow_imp.g_varchar2_table(27374) := '206F662065296966286F5B305D2E636F6E7461696E7352616E6765286929297B742E736574286E2C5B5D293B627265616B7D7D696628303D3D3D742E73697A652972657475726E21313B742E666F7245616368282828652C74293D3E7B652E7075736828';
wwv_flow_imp.g_varchar2_table(27375) := '2E2E2E692E676574287429297D29297D652E736F72742872682E636F6D7061726552616E6765735573696E67537461727473293B666F7228636F6E73745B6E2C695D6F66207429696628692E6C656E6774683D3D3D652E6C656E677468297B692E736F72';
wwv_flow_imp.g_varchar2_table(27376) := '742872682E636F6D7061726552616E6765735573696E67537461727473293B666F72286C6574206F3D303B6F3C692E6C656E6774683B6F2B2B29695B6F5D2E636F6E7461696E7352616E676528655B6F5D297C7C742E64656C657465286E297D656C7365';
wwv_flow_imp.g_varchar2_table(27377) := '20742E64656C657465286E293B72657475726E20742E73697A653E307D7D3B54353D45353D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F';
wwv_flow_imp.g_varchar2_table(27378) := '626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261';
wwv_flow_imp.g_varchar2_table(27379) := '746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72';
wwv_flow_imp.g_varchar2_table(27380) := '293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E';
wwv_flow_imp.g_varchar2_table(27381) := '2C692C65297D7D28332C6567295D2C5435293B7661722049352C4D353D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742041353D7B6F76657277726974654265666F7265';
wwv_flow_imp.g_varchar2_table(27382) := '3A302C6F766572777269746541667465723A302C756E646F53746F704265666F72653A21302C756E646F53746F7041667465723A21302C61646A757374576869746573706163653A21302C636C6970626F617264546578743A766F696420302C6F766572';
wwv_flow_imp.g_varchar2_table(27383) := '747970696E6743617074757265723A766F696420307D3B6C6574204E353D49353D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2849352E4944297D636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(27384) := '2C6E2C692C6F297B746869732E5F656469746F723D652C746869732E5F6C6F67536572766963653D742C746869732E5F6C616E67756167654665617475726573536572766963653D6E2C746869732E5F6C616E6775616765436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(27385) := '6E536572766963653D6F2C746869732E5F736E69707065744C697374656E65723D6E65772061742C746869732E5F6D6F64656C56657273696F6E49643D2D312C746869732E5F696E536E69707065743D49352E496E536E69707065744D6F64652E62696E';
wwv_flow_imp.g_varchar2_table(27386) := '64546F2869292C746869732E5F6861734E65787454616273746F703D49352E4861734E65787454616273746F702E62696E64546F2869292C746869732E5F6861735072657654616273746F703D49352E4861735072657654616273746F702E62696E6454';
wwv_flow_imp.g_varchar2_table(27387) := '6F2869297D646973706F736528297B76617220653B746869732E5F696E536E69707065742E726573657428292C746869732E5F6861735072657654616273746F702E726573657428292C746869732E5F6861734E65787454616273746F702E7265736574';
wwv_flow_imp.g_varchar2_table(27388) := '28292C6E756C6C3D3D3D28653D746869732E5F73657373696F6E297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F736E69707065744C697374656E65722E646973706F736528297D696E7365727428652C74297B747279';
wwv_flow_imp.g_varchar2_table(27389) := '7B746869732E5F646F496E7365727428652C766F696420303D3D3D743F41353A7B2E2E2E41352C2E2E2E747D297D63617463682874297B746869732E63616E63656C28292C746869732E5F6C6F67536572766963652E6572726F722874292C746869732E';
wwv_flow_imp.g_varchar2_table(27390) := '5F6C6F67536572766963652E6572726F722822736E69707065745F6572726F7222292C746869732E5F6C6F67536572766963652E6572726F722822696E736572745F74656D706C6174653D222C65292C746869732E5F6C6F67536572766963652E657272';
wwv_flow_imp.g_varchar2_table(27391) := '6F7228226578697374696E675F74656D706C6174653D222C746869732E5F73657373696F6E3F746869732E5F73657373696F6E2E5F6C6F67496E666F28293A223C6E6F5F73657373696F6E3E22297D7D5F646F496E7365727428652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(27392) := '3B696628746869732E5F656469746F722E6861734D6F64656C2829297B696628746869732E5F736E69707065744C697374656E65722E636C65617228292C742E756E646F53746F704265666F72652626746869732E5F656469746F722E6765744D6F6465';
wwv_flow_imp.g_varchar2_table(27393) := '6C28292E70757368537461636B456C656D656E7428292C746869732E5F73657373696F6E262622737472696E6722213D747970656F6620652626746869732E63616E63656C28292C746869732E5F73657373696F6E3F28796C2822737472696E67223D3D';
wwv_flow_imp.g_varchar2_table(27394) := '747970656F662065292C746869732E5F73657373696F6E2E6D6572676528652C7429293A28746869732E5F6D6F64656C56657273696F6E49643D746869732E5F656469746F722E6765744D6F64656C28292E676574416C7465726E617469766556657273';
wwv_flow_imp.g_varchar2_table(27395) := '696F6E496428292C746869732E5F73657373696F6E3D6E657720543528746869732E5F656469746F722C652C742C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365292C746869732E5F73657373696F6E2E696E7365';
wwv_flow_imp.g_varchar2_table(27396) := '72742829292C742E756E646F53746F7041667465722626746869732E5F656469746F722E6765744D6F64656C28292E70757368537461636B456C656D656E7428292C6E756C6C3D3D3D286E3D746869732E5F73657373696F6E297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(27397) := '3D6E3F766F696420303A6E2E68617343686F696365297B636F6E737420653D7B5F6465627567446973706C61794E616D653A22736E697070657443686F696365436F6D706C6574696F6E73222C70726F76696465436F6D706C6574696F6E4974656D733A';
wwv_flow_imp.g_varchar2_table(27398) := '28652C74293D3E7B69662821746869732E5F73657373696F6E7C7C65213D3D746869732E5F656469746F722E6765744D6F64656C28297C7C216D632E657175616C7328746869732E5F656469746F722E676574506F736974696F6E28292C742929726574';
wwv_flow_imp.g_varchar2_table(27399) := '75726E3B636F6E73747B61637469766543686F6963653A6E7D3D746869732E5F73657373696F6E3B696628216E7C7C303D3D3D6E2E63686F6963652E6F7074696F6E732E6C656E6774682972657475726E3B636F6E737420693D652E67657456616C7565';
wwv_flow_imp.g_varchar2_table(27400) := '496E52616E6765286E2E72616E6765292C6F3D426F6F6C65616E286E2E63686F6963652E6F7074696F6E732E66696E642828653D3E652E76616C75653D3D3D692929292C733D5B5D3B666F72286C657420653D303B653C6E2E63686F6963652E6F707469';
wwv_flow_imp.g_varchar2_table(27401) := '6F6E732E6C656E6774683B652B2B297B636F6E737420743D6E2E63686F6963652E6F7074696F6E735B655D3B732E70757368287B6B696E643A31332C6C6162656C3A742E76616C75652C696E73657274546578743A742E76616C75652C736F7274546578';
wwv_flow_imp.g_varchar2_table(27402) := '743A2261222E72657065617428652B31292C72616E67653A6E2E72616E67652C66696C746572546578743A6F3F60247B697D5F247B742E76616C75657D603A766F696420302C636F6D6D616E643A7B69643A226A756D70546F4E657874536E6970706574';
wwv_flow_imp.g_varchar2_table(27403) := '506C616365686F6C646572222C7469746C653A6228302C22476F20746F206E65787420706C616365686F6C6465722E2E2E22297D7D297D72657475726E7B73756767657374696F6E733A737D7D7D2C743D746869732E5F656469746F722E6765744D6F64';
wwv_flow_imp.g_varchar2_table(27404) := '656C28293B6C6574206E2C693D21313B636F6E7374206F3D28293D3E7B6E756C6C3D3D6E7C7C6E2E646973706F736528292C693D21317D2C733D28293D3E7B697C7C286E3D746869732E5F6C616E67756167654665617475726573536572766963652E63';
wwv_flow_imp.g_varchar2_table(27405) := '6F6D706C6574696F6E50726F76696465722E7265676973746572287B6C616E67756167653A742E6765744C616E6775616765496428292C7061747465726E3A742E7572692E6673506174682C736368656D653A742E7572692E736368656D652C6578636C';
wwv_flow_imp.g_varchar2_table(27406) := '75736976653A21307D2C65292C746869732E5F736E69707065744C697374656E65722E616464286E292C693D2130297D3B746869732E5F63686F696365436F6D706C6574696F6E733D7B70726F76696465723A652C656E61626C653A732C64697361626C';
wwv_flow_imp.g_varchar2_table(27407) := '653A6F7D7D746869732E5F757064617465537461746528292C746869732E5F736E69707065744C697374656E65722E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E652E6973466C7573';
wwv_flow_imp.g_varchar2_table(27408) := '682626746869732E63616E63656C28292929292C746869732E5F736E69707065744C697374656E65722E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E63616E63656C28292929292C7468';
wwv_flow_imp.g_varchar2_table(27409) := '69732E5F736E69707065744C697374656E65722E61646428746869732E5F656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E282828293D3E746869732E5F757064617465537461746528292929297D7D5F757064617465';
wwv_flow_imp.g_varchar2_table(27410) := '537461746528297B696628746869732E5F73657373696F6E2626746869732E5F656469746F722E6861734D6F64656C2829297B696628746869732E5F6D6F64656C56657273696F6E49643D3D3D746869732E5F656469746F722E6765744D6F64656C2829';
wwv_flow_imp.g_varchar2_table(27411) := '2E676574416C7465726E617469766556657273696F6E496428292972657475726E20746869732E63616E63656C28293B69662821746869732E5F73657373696F6E2E686173506C616365686F6C6465722972657475726E20746869732E63616E63656C28';
wwv_flow_imp.g_varchar2_table(27412) := '293B696628746869732E5F73657373696F6E2E697341744C617374506C616365686F6C6465727C7C21746869732E5F73657373696F6E2E697353656C656374696F6E57697468696E506C616365686F6C6465727328292972657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(27413) := '656469746F722E6765744D6F64656C28292E70757368537461636B456C656D656E7428292C746869732E63616E63656C28293B746869732E5F696E536E69707065742E736574282130292C746869732E5F6861735072657654616273746F702E73657428';
wwv_flow_imp.g_varchar2_table(27414) := '21746869732E5F73657373696F6E2E697341744669727374506C616365686F6C646572292C746869732E5F6861734E65787454616273746F702E7365742821746869732E5F73657373696F6E2E697341744C617374506C616365686F6C646572292C7468';
wwv_flow_imp.g_varchar2_table(27415) := '69732E5F68616E646C6543686F69636528297D7D5F68616E646C6543686F69636528297B76617220653B69662821746869732E5F73657373696F6E7C7C21746869732E5F656469746F722E6861734D6F64656C28292972657475726E20766F6964287468';
wwv_flow_imp.g_varchar2_table(27416) := '69732E5F63757272656E7443686F6963653D766F69642030293B636F6E73747B61637469766543686F6963653A747D3D746869732E5F73657373696F6E3B69662821747C7C21746869732E5F63686F696365436F6D706C6574696F6E732972657475726E';
wwv_flow_imp.g_varchar2_table(27417) := '206E756C6C3D3D3D28653D746869732E5F63686F696365436F6D706C6574696F6E73297C7C766F696420303D3D3D657C7C652E64697361626C6528292C766F696428746869732E5F63757272656E7443686F6963653D766F69642030293B746869732E5F';
wwv_flow_imp.g_varchar2_table(27418) := '63757272656E7443686F696365213D3D742E63686F696365262628746869732E5F63757272656E7443686F6963653D742E63686F6963652C746869732E5F63686F696365436F6D706C6574696F6E732E656E61626C6528292C71756575654D6963726F74';
wwv_flow_imp.g_varchar2_table(27419) := '61736B282828293D3E7B2166756E6374696F6E28652C74297B766172206E3B6E756C6C3D3D3D286E3D652E676574436F6E747269627574696F6E2822656469746F722E636F6E747269622E73756767657374436F6E74726F6C6C65722229297C7C766F69';
wwv_flow_imp.g_varchar2_table(27420) := '6420303D3D3D6E7C7C6E2E747269676765725375676765737428286E657720536574292E6164642874292C766F696420302C2130297D28746869732E5F656469746F722C746869732E5F63686F696365436F6D706C6574696F6E732E70726F7669646572';
wwv_flow_imp.g_varchar2_table(27421) := '297D2929297D66696E69736828297B666F72283B746869732E5F696E536E69707065742E67657428293B29746869732E6E65787428297D63616E63656C28653D2131297B76617220743B746869732E5F696E536E69707065742E726573657428292C7468';
wwv_flow_imp.g_varchar2_table(27422) := '69732E5F6861735072657654616273746F702E726573657428292C746869732E5F6861734E65787454616273746F702E726573657428292C746869732E5F736E69707065744C697374656E65722E636C65617228292C746869732E5F63757272656E7443';
wwv_flow_imp.g_varchar2_table(27423) := '686F6963653D766F696420302C6E756C6C3D3D3D28743D746869732E5F73657373696F6E297C7C766F696420303D3D3D747C7C742E646973706F736528292C746869732E5F73657373696F6E3D766F696420302C746869732E5F6D6F64656C5665727369';
wwv_flow_imp.g_varchar2_table(27424) := '6F6E49643D2D312C652626746869732E5F656469746F722E73657453656C656374696F6E73285B746869732E5F656469746F722E67657453656C656374696F6E28295D297D7072657628297B76617220653B6E756C6C3D3D3D28653D746869732E5F7365';
wwv_flow_imp.g_varchar2_table(27425) := '7373696F6E297C7C766F696420303D3D3D657C7C652E7072657628292C746869732E5F757064617465537461746528297D6E65787428297B76617220653B6E756C6C3D3D3D28653D746869732E5F73657373696F6E297C7C766F696420303D3D3D657C7C';
wwv_flow_imp.g_varchar2_table(27426) := '652E6E65787428292C746869732E5F757064617465537461746528297D6973496E536E697070657428297B72657475726E20426F6F6C65616E28746869732E5F696E536E69707065742E6765742829297D7D3B4E352E49443D22736E6970706574436F6E';
wwv_flow_imp.g_varchar2_table(27427) := '74726F6C6C657232222C4E352E496E536E69707065744D6F64653D6E6577206C642822696E536E69707065744D6F6465222C21312C6228302C22576865746865722074686520656469746F7220696E2063757272656E7420696E20736E6970706574206D';
wwv_flow_imp.g_varchar2_table(27428) := '6F64652229292C4E352E4861734E65787454616273746F703D6E6577206C6428226861734E65787454616273746F70222C21312C6228302C22576865746865722074686572652069732061206E657874207461622073746F70207768656E20696E20736E';
wwv_flow_imp.g_varchar2_table(27429) := '6970706574206D6F64652229292C4E352E4861735072657654616273746F703D6E6577206C6428226861735072657654616273746F70222C21312C6228302C225768657468657220746865726520697320612070726576696F7573207461622073746F70';
wwv_flow_imp.g_varchar2_table(27430) := '207768656E20696E20736E6970706574206D6F64652229292C4E353D49353D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(27431) := '6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D52';
wwv_flow_imp.g_varchar2_table(27432) := '65666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C';
wwv_flow_imp.g_varchar2_table(27433) := '6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4D3528312C5264292C4D3528322C7878292C4D3528332C6364292C4D3528342C6567295D2C4E35292C4A6428';
wwv_flow_imp.g_varchar2_table(27434) := '4E352E49442C4E352C34293B636F6E73742050353D24642E62696E64546F436F6E747269627574696F6E284E352E676574293B5964286E6577205035287B69643A226A756D70546F4E657874536E6970706574506C616365686F6C646572222C70726563';
wwv_flow_imp.g_varchar2_table(27435) := '6F6E646974696F6E3A57632E616E64284E352E496E536E69707065744D6F64652C4E352E4861734E65787454616273746F70292C68616E646C65723A653D3E652E6E65787428292C6B624F7074733A7B7765696768743A3133302C6B62457870723A6C68';
wwv_flow_imp.g_varchar2_table(27436) := '2E74657874496E707574466F6375732C7072696D6172793A327D7D29292C5964286E6577205035287B69643A226A756D70546F50726576536E6970706574506C616365686F6C646572222C707265636F6E646974696F6E3A57632E616E64284E352E496E';
wwv_flow_imp.g_varchar2_table(27437) := '536E69707065744D6F64652C4E352E4861735072657654616273746F70292C68616E646C65723A653D3E652E7072657628292C6B624F7074733A7B7765696768743A3133302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D61';
wwv_flow_imp.g_varchar2_table(27438) := '72793A313032367D7D29292C5964286E6577205035287B69643A226C65617665536E6970706574222C707265636F6E646974696F6E3A4E352E496E536E69707065744D6F64652C68616E646C65723A653D3E652E63616E63656C282130292C6B624F7074';
wwv_flow_imp.g_varchar2_table(27439) := '733A7B7765696768743A3133302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D29292C5964286E6577205035287B69643A22616363657074536E6970706574222C';
wwv_flow_imp.g_varchar2_table(27440) := '707265636F6E646974696F6E3A4E352E496E536E69707065744D6F64652C68616E646C65723A653D3E652E66696E69736828297D29293B766172204F352C52353D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B';
wwv_flow_imp.g_varchar2_table(27441) := '74286E2C692C65297D7D3B2166756E6374696F6E2865297B655B652E556E646F3D305D3D22556E646F222C655B652E5265646F3D315D3D225265646F222C655B652E416363657074576F72643D325D3D22416363657074576F7264222C655B652E4F7468';
wwv_flow_imp.g_varchar2_table(27442) := '65723D335D3D224F74686572227D284F357C7C284F353D7B7D29293B6C65742046353D636C61737320657874656E6473206C747B676574206973416363657074696E675061727469616C6C7928297B72657475726E20746869732E5F6973416363657074';
wwv_flow_imp.g_varchar2_table(27443) := '696E675061727469616C6C797D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C68297B6C657420753B737570657228292C746869732E746578744D6F64656C3D652C746869732E73656C6563746564537567676573';
wwv_flow_imp.g_varchar2_table(27444) := '744974656D3D742C746869732E746578744D6F64656C56657273696F6E49643D6E2C746869732E5F706F736974696F6E733D692C746869732E5F6465626F756E636556616C75653D6F2C746869732E5F7375676765737450726576696577456E61626C65';
wwv_flow_imp.g_varchar2_table(27445) := '643D732C746869732E5F73756767657374507265766965774D6F64653D722C746869732E5F696E6C696E65537567676573744D6F64653D612C746869732E5F656E61626C65643D6C2C746869732E5F696E7374616E74696174696F6E536572766963653D';
wwv_flow_imp.g_varchar2_table(27446) := '632C746869732E5F636F6D6D616E64536572766963653D642C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D682C746869732E5F736F757263653D746869732E5F726567697374657228746869732E5F696E7374';
wwv_flow_imp.g_varchar2_table(27447) := '616E74696174696F6E536572766963652E637265617465496E7374616E63652865352C746869732E746578744D6F64656C2C746869732E746578744D6F64656C56657273696F6E49642C746869732E5F6465626F756E636556616C756529292C74686973';
wwv_flow_imp.g_varchar2_table(27448) := '2E5F69734163746976653D245428746869732C2131292C746869732E5F666F7263655570646174654578706C696369746C795369676E616C3D68492874686973292C746869732E5F73656C6563746564496E6C696E65436F6D706C6574696F6E49643D24';
wwv_flow_imp.g_varchar2_table(27449) := '5428746869732C766F69642030292C746869732E5F7072696D617279506F736974696F6E3D515428746869732C28653D3E7B76617220743B72657475726E206E756C6C213D3D28743D746869732E5F706F736974696F6E732E726561642865295B305D29';
wwv_flow_imp.g_varchar2_table(27450) := '2626766F69642030213D3D743F743A6E6577206D6328312C31297D29292C746869732E5F6973416363657074696E675061727469616C6C793D21312C746869732E5F707265736572766543757272656E74436F6D706C6574696F6E526561736F6E733D6E';
wwv_flow_imp.g_varchar2_table(27451) := '657720536574285B4F352E5265646F2C4F352E556E646F2C4F352E416363657074576F72645D292C746869732E5F6665746368496E6C696E65436F6D706C6574696F6E7350726F6D6973653D66756E6374696F6E28652C74297B766172206E3B72657475';
wwv_flow_imp.g_varchar2_table(27452) := '726E206E6577204A54286E657720545428652E6F776E65722C652E64656275674E616D652C766F69642030292C742C652E637265617465456D7074794368616E676553756D6D6172792C652E68616E646C654368616E67652C766F696420302C6E756C6C';
wwv_flow_imp.g_varchar2_table(27453) := '213D3D286E3D652E657175616C697479436F6D7061726572292626766F69642030213D3D6E3F6E3A4C54297D287B6F776E65723A746869732C637265617465456D7074794368616E676553756D6D6172793A28293D3E287B707265736572766543757272';
wwv_flow_imp.g_varchar2_table(27454) := '656E74436F6D706C6574696F6E3A21312C696E6C696E65436F6D706C6574696F6E547269676765724B696E643A77772E4175746F6D617469637D292C68616E646C654368616E67653A28652C74293D3E28652E6469644368616E676528746869732E7465';
wwv_flow_imp.g_varchar2_table(27455) := '78744D6F64656C56657273696F6E4964292626746869732E5F707265736572766543757272656E74436F6D706C6574696F6E526561736F6E732E68617328652E6368616E6765293F742E707265736572766543757272656E74436F6D706C6574696F6E3D';
wwv_flow_imp.g_varchar2_table(27456) := '21303A652E6469644368616E676528746869732E5F666F7263655570646174654578706C696369746C795369676E616C29262628742E696E6C696E65436F6D706C6574696F6E547269676765724B696E643D77772E4578706C69636974292C2130297D2C';
wwv_flow_imp.g_varchar2_table(27457) := '2828652C74293D3E7B696628746869732E5F666F7263655570646174654578706C696369746C795369676E616C2E726561642865292C2128746869732E5F656E61626C65642E726561642865292626746869732E73656C65637465645375676765737449';
wwv_flow_imp.g_varchar2_table(27458) := '74656D2E726561642865297C7C746869732E5F69734163746976652E72656164286529292972657475726E20766F696420746869732E5F736F757263652E63616E63656C55706461746528293B746869732E746578744D6F64656C56657273696F6E4964';
wwv_flow_imp.g_varchar2_table(27459) := '2E726561642865293B636F6E7374206E3D746869732E5F736F757263652E73756767657374576964676574496E6C696E65436F6D706C6574696F6E732E67657428292C693D746869732E73656C6563746564537567676573744974656D2E726561642865';
wwv_flow_imp.g_varchar2_table(27460) := '293B6966286E26262169297B636F6E737420653D746869732E5F736F757263652E696E6C696E65436F6D706C6574696F6E732E67657428293B48542828743D3E7B2821657C7C6E2E726571756573742E76657273696F6E49643E652E726571756573742E';
wwv_flow_imp.g_varchar2_table(27461) := '76657273696F6E4964292626746869732E5F736F757263652E696E6C696E65436F6D706C6574696F6E732E736574286E2E636C6F6E6528292C74292C746869732E5F736F757263652E636C65617253756767657374576964676574496E6C696E65436F6D';
wwv_flow_imp.g_varchar2_table(27462) := '706C6574696F6E732874297D29297D636F6E7374206F3D746869732E5F7072696D617279506F736974696F6E2E726561642865292C733D7B747269676765724B696E643A742E696E6C696E65436F6D706C6574696F6E547269676765724B696E642C7365';
wwv_flow_imp.g_varchar2_table(27463) := '6C656374656453756767657374696F6E496E666F3A6E756C6C3D3D693F766F696420303A692E746F53656C656374656453756767657374696F6E496E666F28297D2C723D746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E2E6765';
wwv_flow_imp.g_varchar2_table(27464) := '7428292C613D742E707265736572766543757272656E74436F6D706C6574696F6E7C7C286E756C6C3D3D723F766F696420303A722E666F7277617264537461626C65293F723A766F696420303B72657475726E20746869732E5F736F757263652E666574';
wwv_flow_imp.g_varchar2_table(27465) := '6368286F2C732C61297D29292C746869732E5F66696C7465726564496E6C696E65436F6D706C6574696F6E4974656D733D5954287B6F776E65723A746869732C657175616C73466E3A445428297D2C28653D3E7B636F6E737420743D746869732E5F736F';
wwv_flow_imp.g_varchar2_table(27466) := '757263652E696E6C696E65436F6D706C6574696F6E732E726561642865293B69662821742972657475726E5B5D3B636F6E7374206E3D746869732E5F7072696D617279506F736974696F6E2E726561642865292C693D742E696E6C696E65436F6D706C65';
wwv_flow_imp.g_varchar2_table(27467) := '74696F6E732E66696C7465722828743D3E742E697356697369626C6528746869732E746578744D6F64656C2C6E2C652929293B72657475726E20697D29292C746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E496E6465783D5154';
wwv_flow_imp.g_varchar2_table(27468) := '28746869732C28653D3E7B636F6E737420743D746869732E5F73656C6563746564496E6C696E65436F6D706C6574696F6E49642E726561642865292C6E3D746869732E5F66696C7465726564496E6C696E65436F6D706C6574696F6E4974656D732E7265';
wwv_flow_imp.g_varchar2_table(27469) := '61642865292C693D766F696420303D3D3D746869732E5F73656C6563746564496E6C696E65436F6D706C6574696F6E49643F2D313A6E2E66696E64496E6465782828653D3E652E73656D616E74696349643D3D3D7429293B72657475726E2D313D3D3D69';
wwv_flow_imp.g_varchar2_table(27470) := '3F28746869732E5F73656C6563746564496E6C696E65436F6D706C6574696F6E49642E73657428766F696420302C766F69642030292C30293A697D29292C746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E3D515428746869732C';
wwv_flow_imp.g_varchar2_table(27471) := '28653D3E746869732E5F66696C7465726564496E6C696E65436F6D706C6574696F6E4974656D732E726561642865295B746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E496E6465782E726561642865295D29292C746869732E61';
wwv_flow_imp.g_varchar2_table(27472) := '6374697665436F6D6D616E64733D5954287B6F776E65723A746869732C657175616C73466E3A445428297D2C28653D3E7B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E73656C6563746564496E6C';
wwv_flow_imp.g_varchar2_table(27473) := '696E65436F6D706C6574696F6E2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E696E6C696E65436F6D706C6574696F6E2E736F757263652E696E6C696E65436F6D706C6574696F6E732E636F6D6D616E6473292626766F69';
wwv_flow_imp.g_varchar2_table(27474) := '642030213D3D6E3F6E3A5B5D7D29292C746869732E6C617374547269676765724B696E643D746869732E5F736F757263652E696E6C696E65436F6D706C6574696F6E732E6D617028746869732C28653D3E6E756C6C3D3D653F766F696420303A652E7265';
wwv_flow_imp.g_varchar2_table(27475) := '71756573742E636F6E746578742E747269676765724B696E6429292C746869732E696E6C696E65436F6D706C6574696F6E73436F756E743D515428746869732C28653D3E746869732E6C617374547269676765724B696E642E726561642865293D3D3D77';
wwv_flow_imp.g_varchar2_table(27476) := '772E4578706C696369743F746869732E5F66696C7465726564496E6C696E65436F6D706C6574696F6E4974656D732E726561642865292E6C656E6774683A766F6964203029292C746869732E73746174653D5954287B6F776E65723A746869732C657175';
wwv_flow_imp.g_varchar2_table(27477) := '616C73466E3A28652C74293D3E652626743F4D3328652E67686F737454657874732C742E67686F73745465787473292626652E696E6C696E65436F6D706C6574696F6E3D3D3D742E696E6C696E65436F6D706C6574696F6E2626652E7375676765737449';
wwv_flow_imp.g_varchar2_table(27478) := '74656D3D3D3D742E737567676573744974656D3A653D3D3D747D2C28653D3E7B76617220742C6E3B636F6E737420693D746869732E746578744D6F64656C2C6F3D746869732E73656C6563746564537567676573744974656D2E726561642865293B6966';
wwv_flow_imp.g_varchar2_table(27479) := '286F297B636F6E737420733D4B33286F2E746F53696E676C65546578744564697428292C69292C723D746869732E5F636F6D707574654175676D656E746174696F6E28732C65293B69662821746869732E5F7375676765737450726576696577456E6162';
wwv_flow_imp.g_varchar2_table(27480) := '6C65642E72656164286529262621722972657475726E3B636F6E737420613D6E756C6C213D3D28743D6E756C6C3D3D723F766F696420303A722E65646974292626766F69642030213D3D743F743A732C6C3D723F722E656469742E746578742E6C656E67';
wwv_flow_imp.g_varchar2_table(27481) := '74682D732E746578742E6C656E6774683A302C633D746869732E5F73756767657374507265766965774D6F64652E726561642865292C643D746869732E5F706F736974696F6E732E726561642865292C683D5B612C2E2E2E423528746869732E74657874';
wwv_flow_imp.g_varchar2_table(27482) := '4D6F64656C2C642C61295D2C753D682E6D6170282828652C74293D3E513328652C692C632C645B745D2C6C2929292E66696C74657228626C293B72657475726E7B65646974733A682C7072696D61727947686F7374546578743A6E756C6C213D3D286E3D';
wwv_flow_imp.g_varchar2_table(27483) := '755B305D292626766F69642030213D3D6E3F6E3A6E657720443328612E72616E67652E656E644C696E654E756D6265722C5B5D292C67686F737454657874733A752C696E6C696E65436F6D706C6574696F6E3A6E756C6C3D3D723F766F696420303A722E';
wwv_flow_imp.g_varchar2_table(27484) := '636F6D706C6574696F6E2C737567676573744974656D3A6F7D7D7B69662821746869732E5F69734163746976652E726561642865292972657475726E3B636F6E737420743D746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E2E72';
wwv_flow_imp.g_varchar2_table(27485) := '6561642865293B69662821742972657475726E3B636F6E7374206E3D742E746F53696E676C6554657874456469742865292C6F3D746869732E5F696E6C696E65537567676573744D6F64652E726561642865292C733D746869732E5F706F736974696F6E';
wwv_flow_imp.g_varchar2_table(27486) := '732E726561642865292C723D5B6E2C2E2E2E423528746869732E746578744D6F64656C2C732C6E295D2C613D722E6D6170282828652C74293D3E513328652C692C6F2C735B745D2C302929292E66696C74657228626C293B69662821615B305D29726574';
wwv_flow_imp.g_varchar2_table(27487) := '75726E3B72657475726E7B65646974733A722C7072696D61727947686F7374546578743A615B305D2C67686F737454657874733A612C696E6C696E65436F6D706C6574696F6E3A742C737567676573744974656D3A766F696420307D7D7D29292C746869';
wwv_flow_imp.g_varchar2_table(27488) := '732E67686F737454657874733D5954287B6F776E65723A746869732C657175616C73466E3A4D337D2C28653D3E7B636F6E737420743D746869732E73746174652E726561642865293B696628742972657475726E20742E67686F737454657874737D2929';
wwv_flow_imp.g_varchar2_table(27489) := '2C746869732E7072696D61727947686F7374546578743D5954287B6F776E65723A746869732C657175616C73466E3A41337D2C28653D3E7B636F6E737420743D746869732E73746174652E726561642865293B696628742972657475726E206E756C6C3D';
wwv_flow_imp.g_varchar2_table(27490) := '3D743F766F696420303A742E7072696D61727947686F7374546578747D29292C746869732E5F726567697374657228704928746869732E5F6665746368496E6C696E65436F6D706C6574696F6E7350726F6D69736529292C746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(27491) := '65722865492828653D3E7B76617220742C6E3B636F6E737420693D746869732E73746174652E726561642865292C6F3D6E756C6C3D3D693F766F696420303A692E696E6C696E65436F6D706C6574696F6E3B696628286E756C6C3D3D6F3F766F69642030';
wwv_flow_imp.g_varchar2_table(27492) := '3A6F2E73656D616E746963496429213D3D286E756C6C3D3D753F766F696420303A752E73656D616E746963496429262628753D6F2C6F29297B636F6E737420653D6F2E696E6C696E65436F6D706C6574696F6E2C693D652E736F757263653B6E756C6C3D';
wwv_flow_imp.g_varchar2_table(27493) := '3D3D286E3D28743D692E70726F7669646572292E68616E646C654974656D44696453686F77297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C692E696E6C696E65436F6D706C6574696F6E732C652E736F75726365496E6C696E65436F6D706C';
wwv_flow_imp.g_varchar2_table(27494) := '6574696F6E2C652E696E7365727454657874297D7D2929297D6173796E6320747269676765722865297B746869732E5F69734163746976652E7365742821302C65292C617761697420746869732E5F6665746368496E6C696E65436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(27495) := '7350726F6D6973652E67657428297D6173796E6320747269676765724578706C696369746C792865297B6A5428652C28653D3E7B746869732E5F69734163746976652E7365742821302C65292C746869732E5F666F7263655570646174654578706C6963';
wwv_flow_imp.g_varchar2_table(27496) := '69746C795369676E616C2E747269676765722865297D29292C617761697420746869732E5F6665746368496E6C696E65436F6D706C6574696F6E7350726F6D6973652E67657428297D73746F702865297B6A5428652C28653D3E7B746869732E5F697341';
wwv_flow_imp.g_varchar2_table(27497) := '63746976652E7365742821312C65292C746869732E5F736F757263652E636C6561722865297D29297D5F636F6D707574654175676D656E746174696F6E28652C74297B636F6E7374206E3D746869732E746578744D6F64656C2C693D746869732E5F736F';
wwv_flow_imp.g_varchar2_table(27498) := '757263652E73756767657374576964676574496E6C696E65436F6D706C6574696F6E732E726561642874293B72657475726E2066756E6374696F6E28652C74297B666F7228636F6E7374206E206F662065297B636F6E737420653D74286E293B69662876';
wwv_flow_imp.g_varchar2_table(27499) := '6F69642030213D3D652972657475726E20657D7D28693F692E696E6C696E65436F6D706C6574696F6E733A5B746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E2E726561642874295D2E66696C74657228626C292C28693D3E7B6C';
wwv_flow_imp.g_varchar2_table(27500) := '6574206F3D692E746F53696E676C6554657874456469742874293B72657475726E206F3D4B33286F2C6E2C72682E66726F6D506F736974696F6E73286F2E72616E67652E6765745374617274506F736974696F6E28292C652E72616E67652E676574456E';
wwv_flow_imp.g_varchar2_table(27501) := '64506F736974696F6E282929292C4733286F2C65293F7B636F6D706C6574696F6E3A692C656469743A6F7D3A766F696420307D29297D6173796E63205F64656C746153656C6563746564496E6C696E65436F6D706C6574696F6E496E6465782865297B61';
wwv_flow_imp.g_varchar2_table(27502) := '7761697420746869732E747269676765724578706C696369746C7928293B636F6E737420743D746869732E5F66696C7465726564496E6C696E65436F6D706C6574696F6E4974656D732E67657428297C7C5B5D3B696628742E6C656E6774683E30297B63';
wwv_flow_imp.g_varchar2_table(27503) := '6F6E7374206E3D28746869732E73656C6563746564496E6C696E65436F6D706C6574696F6E496E6465782E67657428292B652B742E6C656E6774682925742E6C656E6774683B746869732E5F73656C6563746564496E6C696E65436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(27504) := '49642E73657428745B6E5D2E73656D616E74696349642C766F69642030297D656C736520746869732E5F73656C6563746564496E6C696E65436F6D706C6574696F6E49642E73657428766F696420302C766F69642030297D6173796E63206E6578742829';
wwv_flow_imp.g_varchar2_table(27505) := '7B617761697420746869732E5F64656C746153656C6563746564496E6C696E65436F6D706C6574696F6E496E6465782831297D6173796E632070726576696F757328297B617761697420746869732E5F64656C746153656C6563746564496E6C696E6543';
wwv_flow_imp.g_varchar2_table(27506) := '6F6D706C6574696F6E496E646578282D31297D6173796E63206163636570742865297B76617220743B696628652E6765744D6F64656C2829213D3D746869732E746578744D6F64656C297468726F77206E6577204F653B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(27507) := '73746174652E67657428293B696628216E7C7C6E2E7072696D61727947686F7374546578742E6973456D70747928297C7C216E2E696E6C696E65436F6D706C6574696F6E2972657475726E3B636F6E737420693D6E2E696E6C696E65436F6D706C657469';
wwv_flow_imp.g_varchar2_table(27508) := '6F6E2E746F496E6C696E65436F6D706C6574696F6E28766F69642030293B696628652E70757368556E646F53746F7028292C692E736E6970706574496E666F29652E6578656375746545646974732822696E6C696E6553756767657374696F6E2E616363';
wwv_flow_imp.g_varchar2_table(27509) := '657074222C5B6A712E7265706C61636528692E72616E67652C2222292C2E2E2E692E6164646974696F6E616C5465787445646974735D292C652E736574506F736974696F6E28692E736E6970706574496E666F2E72616E67652E6765745374617274506F';
wwv_flow_imp.g_varchar2_table(27510) := '736974696F6E28292C22696E6C696E65436F6D706C6574696F6E41636365707422292C6E756C6C3D3D3D28743D4E352E676574286529297C7C766F696420303D3D3D747C7C742E696E7365727428692E736E6970706574496E666F2E736E69707065742C';
wwv_flow_imp.g_varchar2_table(27511) := '7B756E646F53746F704265666F72653A21317D293B656C73657B636F6E737420743D6E2E65646974732C6F3D56352874292E6D61702828653D3E61682E66726F6D506F736974696F6E7328652929293B652E6578656375746545646974732822696E6C69';
wwv_flow_imp.g_varchar2_table(27512) := '6E6553756767657374696F6E2E616363657074222C5B2E2E2E742E6D61702828653D3E6A712E7265706C61636528652E72616E67652C652E746578742929292C2E2E2E692E6164646974696F6E616C5465787445646974735D292C652E73657453656C65';
wwv_flow_imp.g_varchar2_table(27513) := '6374696F6E73286F2C22696E6C696E65436F6D706C6574696F6E41636365707422297D692E636F6D6D616E642626692E736F757263652E61646452656628292C48542828653D3E7B746869732E5F736F757263652E636C6561722865292C746869732E5F';
wwv_flow_imp.g_varchar2_table(27514) := '69734163746976652E7365742821312C65297D29292C692E636F6D6D616E64262628617761697420746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428692E636F6D6D616E642E69642C2E2E2E692E636F6D6D616E';
wwv_flow_imp.g_varchar2_table(27515) := '642E617267756D656E74737C7C5B5D292E7468656E28766F696420302C4565292C692E736F757263652E72656D6F76655265662829297D6173796E63206163636570744E657874576F72642865297B617761697420746869732E5F6163636570744E6578';
wwv_flow_imp.g_varchar2_table(27516) := '7428652C2828652C74293D3E7B636F6E7374206E3D746869732E746578744D6F64656C2E6765744C616E677561676549644174506F736974696F6E28652E6C696E654E756D6265722C652E636F6C756D6E292C693D746869732E5F6C616E677561676543';
wwv_flow_imp.g_varchar2_table(27517) := '6F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E286E292C6F3D6E65772052656745787028692E776F7264446566696E6974696F6E2E736F757263652C692E776F7264446566696E6974696F';
wwv_flow_imp.g_varchar2_table(27518) := '6E2E666C6167732E7265706C616365282267222C222229292C733D742E6D61746368286F293B6C657420723D303B723D732626766F69642030213D3D732E696E6465783F303D3D3D732E696E6465783F735B305D2E6C656E6774683A732E696E6465783A';
wwv_flow_imp.g_varchar2_table(27519) := '742E6C656E6774683B636F6E737420613D2F5C732B2F672E657865632874293B72657475726E20612626766F69642030213D3D612E696E6465782626612E696E6465782B615B305D2E6C656E6774683C72262628723D612E696E6465782B615B305D2E6C';
wwv_flow_imp.g_varchar2_table(27520) := '656E677468292C727D292C30297D6173796E63206163636570744E6578744C696E652865297B617761697420746869732E5F6163636570744E65787428652C2828652C74293D3E7B636F6E7374206E3D742E6D61746368282F5C6E2F293B72657475726E';
wwv_flow_imp.g_varchar2_table(27521) := '206E2626766F69642030213D3D6E2E696E6465783F6E2E696E6465782B313A742E6C656E6774687D292C31297D6173796E63205F6163636570744E65787428652C742C6E297B696628652E6765744D6F64656C2829213D3D746869732E746578744D6F64';
wwv_flow_imp.g_varchar2_table(27522) := '656C297468726F77206E6577204F653B636F6E737420693D746869732E73746174652E67657428293B69662821697C7C692E7072696D61727947686F7374546578742E6973456D70747928297C7C21692E696E6C696E65436F6D706C6574696F6E297265';
wwv_flow_imp.g_varchar2_table(27523) := '7475726E3B636F6E7374206F3D692E7072696D61727947686F7374546578742C733D692E696E6C696E65436F6D706C6574696F6E2E746F496E6C696E65436F6D706C6574696F6E28766F69642030293B696628732E736E6970706574496E666F7C7C732E';
wwv_flow_imp.g_varchar2_table(27524) := '66696C74657254657874213D3D732E696E73657274546578742972657475726E20766F696420617761697420746869732E6163636570742865293B636F6E737420723D6F2E70617274735B305D2C613D6E6577206D63286F2E6C696E654E756D6265722C';
wwv_flow_imp.g_varchar2_table(27525) := '722E636F6C756D6E292C6C3D722E746578742C633D7428612C6C293B696628633D3D3D6C2E6C656E6774682626313D3D3D6F2E70617274732E6C656E6774682972657475726E20766F696420746869732E6163636570742865293B636F6E737420643D6C';
wwv_flow_imp.g_varchar2_table(27526) := '2E737562737472696E6728302C63292C683D746869732E5F706F736974696F6E732E67657428292C753D685B305D3B732E736F757263652E61646452656628293B7472797B746869732E5F6973416363657074696E675061727469616C6C793D21303B74';
wwv_flow_imp.g_varchar2_table(27527) := '72797B652E70757368556E646F53746F7028293B636F6E737420743D72682E66726F6D506F736974696F6E7328752C61292C6E3D652E6765744D6F64656C28292E67657456616C7565496E52616E67652874292B642C693D6E657720557A28742C6E292C';
wwv_flow_imp.g_varchar2_table(27528) := '6F3D5B692C2E2E2E423528746869732E746578744D6F64656C2C682C69295D2C733D5635286F292E6D61702828653D3E61682E66726F6D506F736974696F6E7328652929293B652E6578656375746545646974732822696E6C696E655375676765737469';
wwv_flow_imp.g_varchar2_table(27529) := '6F6E2E616363657074222C6F2E6D61702828653D3E6A712E7265706C61636528652E72616E67652C652E74657874292929292C652E73657453656C656374696F6E7328732C22696E6C696E65436F6D706C6574696F6E5061727469616C41636365707422';
wwv_flow_imp.g_varchar2_table(27530) := '297D66696E616C6C797B746869732E5F6973416363657074696E675061727469616C6C793D21317D696628732E736F757263652E70726F76696465722E68616E646C655061727469616C416363657074297B636F6E737420743D72682E66726F6D506F73';
wwv_flow_imp.g_varchar2_table(27531) := '6974696F6E7328732E72616E67652E6765745374617274506F736974696F6E28292C6D672E6F66546578742864292E616464546F506F736974696F6E286129292C693D652E6765744D6F64656C28292E67657456616C7565496E52616E676528742C3129';
wwv_flow_imp.g_varchar2_table(27532) := '3B732E736F757263652E70726F76696465722E68616E646C655061727469616C41636365707428732E736F757263652E696E6C696E65436F6D706C6574696F6E732C732E736F75726365496E6C696E65436F6D706C6574696F6E2C692E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(27533) := '7B6B696E643A6E7D297D7D66696E616C6C797B732E736F757263652E72656D6F766552656628297D7D68616E646C655375676765737441636365707465642865297B76617220742C6E3B636F6E737420693D4B3328652E746F53696E676C655465787445';
wwv_flow_imp.g_varchar2_table(27534) := '64697428292C746869732E746578744D6F64656C292C6F3D746869732E5F636F6D707574654175676D656E746174696F6E28692C766F69642030293B696628216F2972657475726E3B636F6E737420733D6F2E636F6D706C6574696F6E2E696E6C696E65';
wwv_flow_imp.g_varchar2_table(27535) := '436F6D706C6574696F6E3B6E756C6C3D3D3D286E3D28743D732E736F757263652E70726F7669646572292E68616E646C655061727469616C416363657074297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C732E736F757263652E696E6C696E';
wwv_flow_imp.g_varchar2_table(27536) := '65436F6D706C6574696F6E732C732E736F75726365496E6C696E65436F6D706C6574696F6E2C692E746578742E6C656E6774682C7B6B696E643A327D297D7D3B66756E6374696F6E20423528652C742C6E297B696628313D3D3D742E6C656E6774682972';
wwv_flow_imp.g_varchar2_table(27537) := '657475726E5B5D3B636F6E737420693D745B305D2C6F3D742E736C6963652831292C733D6E2E72616E67652E6765745374617274506F736974696F6E28292C723D6E2E72616E67652E676574456E64506F736974696F6E28292C613D652E67657456616C';
wwv_flow_imp.g_varchar2_table(27538) := '7565496E52616E67652872682E66726F6D506F736974696F6E7328692C7229292C6C3D523328692C73293B6966286C2E6C696E654E756D6265723C312972657475726E206B65286E6577204F652860706F736974696F6E57697468696E54657874456469';
wwv_flow_imp.g_varchar2_table(27539) := '74206C696E65206E756D6265722073686F756C6420626520626967676572207468616E20302E5C6E5C745C745C74496E76616C6964207375627472616374696F6E206265747765656E20247B692E746F537472696E6728297D20616E6420247B732E746F';
wwv_flow_imp.g_varchar2_table(27540) := '537472696E6728297D6029292C5B5D3B636F6E737420633D66756E6374696F6E28652C74297B6C6574206E3D22223B636F6E737420693D66756E6374696F6E2865297B76617220743B636F6E7374206E3D5B5D2C693D652E73706C6974282F285C725C6E';
wwv_flow_imp.g_varchar2_table(27541) := '7C5C727C5C6E292F293B666F72286C657420653D303B653C4D6174682E6365696C28692E6C656E6774682F32293B652B2B296E2E7075736828695B322A655D2B286E756C6C213D3D28743D695B322A652B315D292626766F69642030213D3D743F743A22';
wwv_flow_imp.g_varchar2_table(27542) := '2229293B72657475726E206E7D2865293B666F72286C657420653D742E6C696E654E756D6265722D313B653C692E6C656E6774683B652B2B296E2B3D695B655D2E737562737472696E6728653D3D3D742E6C696E654E756D6265722D313F742E636F6C75';
wwv_flow_imp.g_varchar2_table(27543) := '6D6E2D313A30293B72657475726E206E7D286E2E746578742C6C293B72657475726E206F2E6D61702828743D3E7B636F6E7374206E3D28693D523328742C73292C6F3D722C6E6577206D6328692E6C696E654E756D6265722B6F2E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(27544) := '722D312C313D3D3D6F2E6C696E654E756D6265723F692E636F6C756D6E2B6F2E636F6C756D6E2D313A6F2E636F6C756D6E29293B76617220692C6F3B636F6E7374206C3D652E67657456616C7565496E52616E67652872682E66726F6D506F736974696F';
wwv_flow_imp.g_varchar2_table(27545) := '6E7328742C6E29292C643D4C6928612C6C292C683D72682E66726F6D506F736974696F6E7328742C742E64656C746128302C6429293B72657475726E206E657720557A28682C63297D29297D66756E6374696F6E2056352865297B636F6E737420743D72';
wwv_flow_imp.g_varchar2_table(27546) := '752E637265617465536F72745065726D75746174696F6E28652C2828652C74293D3E72682E636F6D7061726552616E6765735573696E6753746172747328652E72616E67652C742E72616E67652929292C6E3D6E657720247A28742E6170706C79286529';
wwv_flow_imp.g_varchar2_table(27547) := '292E6765744E657752616E67657328293B72657475726E20742E696E766572736528292E6170706C79286E292E6D61702828653D3E652E676574456E64506F736974696F6E282929297D46353D66756E6374696F6E28652C742C6E2C69297B766172206F';
wwv_flow_imp.g_varchar2_table(27548) := '2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265';
wwv_flow_imp.g_varchar2_table(27549) := '666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D';
wwv_flow_imp.g_varchar2_table(27550) := '303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D';
wwv_flow_imp.g_varchar2_table(27551) := '285B523528392C7563292C52352831302C7863292C52352831312C6567295D2C4635293B766172207A352C48353D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C617373205735';
wwv_flow_imp.g_varchar2_table(27552) := '7B636F6E7374727563746F722865297B746869732E6E616D653D657D73656C65637428652C742C6E297B696628303D3D3D6E2E6C656E6774682972657475726E20303B636F6E737420693D6E5B305D2E73636F72655B305D3B666F72286C657420653D30';
wwv_flow_imp.g_varchar2_table(27553) := '3B653C6E2E6C656E6774683B652B2B297B636F6E73747B73636F72653A742C636F6D706C6574696F6E3A6F7D3D6E5B655D3B696628745B305D213D3D6929627265616B3B6966286F2E70726573656C6563742972657475726E20657D72657475726E2030';
wwv_flow_imp.g_varchar2_table(27554) := '7D7D636C617373206A3520657874656E64732057357B636F6E7374727563746F7228297B73757065722822666972737422297D6D656D6F72697A6528652C742C6E297B7D746F4A534F4E28297B7D66726F6D4A534F4E28297B7D7D6C65742071353D7A35';
wwv_flow_imp.g_varchar2_table(27555) := '3D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F73746F72616765536572766963653D652C746869732E5F636F6E666967536572766963653D742C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F';
wwv_flow_imp.g_varchar2_table(27556) := '70657273697374536F6F6E3D6E6577204B74282828293D3E746869732E5F7361766553746174652829292C353030292C746869732E5F646973706F7361626C65732E61646428652E6F6E57696C6C5361766553746174652828653D3E7B652E726561736F';
wwv_flow_imp.g_varchar2_table(27557) := '6E3D3D3D59422E53485554444F574E2626746869732E5F73617665537461746528297D2929297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F70657273697374536F6F6E2E646973706F';
wwv_flow_imp.g_varchar2_table(27558) := '736528297D6D656D6F72697A6528652C742C6E297B746869732E5F77697468537472617465677928652C74292E6D656D6F72697A6528652C742C6E292C746869732E5F70657273697374536F6F6E2E7363686564756C6528297D73656C65637428652C74';
wwv_flow_imp.g_varchar2_table(27559) := '2C6E297B72657475726E20746869732E5F77697468537472617465677928652C74292E73656C65637428652C742C6E297D5F77697468537472617465677928652C74297B766172206E3B636F6E737420693D746869732E5F636F6E666967536572766963';
wwv_flow_imp.g_varchar2_table(27560) := '652E67657456616C75652822656469746F722E7375676765737453656C656374696F6E222C7B6F766572726964654964656E7469666965723A652E6765744C616E677561676549644174506F736974696F6E28742E6C696E654E756D6265722C742E636F';
wwv_flow_imp.g_varchar2_table(27561) := '6C756D6E292C7265736F757263653A652E7572697D293B696628286E756C6C3D3D3D286E3D746869732E5F7374726174656779297C7C766F696420303D3D3D6E3F766F696420303A6E2E6E616D6529213D3D69297B746869732E5F736176655374617465';
wwv_flow_imp.g_varchar2_table(27562) := '28293B636F6E737420653D7A352E5F737472617465677943746F72732E6765742869297C7C6A353B746869732E5F73747261746567793D6E657720653B7472797B636F6E737420653D746869732E5F636F6E666967536572766963652E67657456616C75';
wwv_flow_imp.g_varchar2_table(27563) := '652822656469746F722E737567676573742E73686172655375676765737453656C656374696F6E7322293F303A312C743D746869732E5F73746F72616765536572766963652E6765742860247B7A352E5F73746F726167655072656669787D2F247B697D';
wwv_flow_imp.g_varchar2_table(27564) := '602C65293B742626746869732E5F73747261746567792E66726F6D4A534F4E284A534F4E2E7061727365287429297D63617463682865297B7D7D72657475726E20746869732E5F73747261746567797D5F73617665537461746528297B69662874686973';
wwv_flow_imp.g_varchar2_table(27565) := '2E5F7374726174656779297B636F6E737420653D746869732E5F636F6E666967536572766963652E67657456616C75652822656469746F722E737567676573742E73686172655375676765737453656C656374696F6E7322293F303A312C743D4A534F4E';
wwv_flow_imp.g_varchar2_table(27566) := '2E737472696E6769667928746869732E5F7374726174656779293B746869732E5F73746F72616765536572766963652E73746F72652860247B7A352E5F73746F726167655072656669787D2F247B746869732E5F73747261746567792E6E616D657D602C';
wwv_flow_imp.g_varchar2_table(27567) := '742C652C31297D7D7D3B71352E5F737472617465677943746F72733D6E6577204D6170285B5B22726563656E746C79557365644279507265666978222C636C61737320657874656E64732057357B636F6E7374727563746F7228297B7375706572282272';
wwv_flow_imp.g_varchar2_table(27568) := '6563656E746C7955736564427950726566697822292C746869732E5F747269653D49782E666F72537472696E677328292C746869732E5F7365713D307D6D656D6F72697A6528652C742C6E297B636F6E73747B776F72643A697D3D652E676574576F7264';
wwv_flow_imp.g_varchar2_table(27569) := '556E74696C506F736974696F6E2874292C6F3D60247B652E6765744C616E6775616765496428297D2F247B697D603B746869732E5F747269652E736574286F2C7B747970653A6E2E636F6D706C6574696F6E2E6B696E642C696E73657274546578743A6E';
wwv_flow_imp.g_varchar2_table(27570) := '2E636F6D706C6574696F6E2E696E73657274546578742C746F7563683A746869732E5F7365712B2B7D297D73656C65637428652C742C6E297B636F6E73747B776F72643A697D3D652E676574576F7264556E74696C506F736974696F6E2874293B696628';
wwv_flow_imp.g_varchar2_table(27571) := '21692972657475726E2073757065722E73656C65637428652C742C6E293B636F6E7374206F3D60247B652E6765744C616E6775616765496428297D2F247B697D603B6C657420733D746869732E5F747269652E676574286F293B696628737C7C28733D74';
wwv_flow_imp.g_varchar2_table(27572) := '6869732E5F747269652E66696E64537562737472286F29292C7329666F72286C657420653D303B653C6E2E6C656E6774683B652B2B297B636F6E73747B6B696E643A742C696E73657274546578743A697D3D6E5B655D2E636F6D706C6574696F6E3B6966';
wwv_flow_imp.g_varchar2_table(27573) := '28743D3D3D732E747970652626693D3D3D732E696E73657274546578742972657475726E20657D72657475726E2073757065722E73656C65637428652C742C6E297D746F4A534F4E28297B636F6E737420653D5B5D3B72657475726E20746869732E5F74';
wwv_flow_imp.g_varchar2_table(27574) := '7269652E666F7245616368282828742C6E293D3E652E70757368285B6E2C745D2929292C652E736F7274282828652C74293D3E2D28655B315D2E746F7563682D745B315D2E746F7563682929292E666F7245616368282828652C74293D3E655B315D2E74';
wwv_flow_imp.g_varchar2_table(27575) := '6F7563683D7429292C652E736C69636528302C323030297D66726F6D4A534F4E2865297B696628746869732E5F747269652E636C65617228292C652E6C656E6774683E30297B746869732E5F7365713D655B305D5B315D2E746F7563682B313B666F7228';
wwv_flow_imp.g_varchar2_table(27576) := '636F6E73745B742C6E5D6F662065296E2E747970653D226E756D626572223D3D747970656F66206E2E747970653F6E2E747970653A79772E66726F6D537472696E67286E2E74797065292C746869732E5F747269652E73657428742C6E297D7D7D5D2C5B';
wwv_flow_imp.g_varchar2_table(27577) := '22726563656E746C7955736564222C636C61737320657874656E64732057357B636F6E7374727563746F7228297B73757065722822726563656E746C795573656422292C746869732E5F63616368653D6E6577206161283330302C2E3636292C74686973';
wwv_flow_imp.g_varchar2_table(27578) := '2E5F7365713D307D6D656D6F72697A6528652C742C6E297B636F6E737420693D60247B652E6765744C616E6775616765496428297D2F247B6E2E746578744C6162656C7D603B746869732E5F63616368652E73657428692C7B746F7563683A746869732E';
wwv_flow_imp.g_varchar2_table(27579) := '5F7365712B2B2C747970653A6E2E636F6D706C6574696F6E2E6B696E642C696E73657274546578743A6E2E636F6D706C6574696F6E2E696E73657274546578747D297D73656C65637428652C742C6E297B696628303D3D3D6E2E6C656E67746829726574';
wwv_flow_imp.g_varchar2_table(27580) := '75726E20303B636F6E737420693D652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292E73756273747228742E636F6C756D6E2D31302C742E636F6C756D6E2D31293B6966282F5C73242F2E746573742869292972657475726E20';
wwv_flow_imp.g_varchar2_table(27581) := '73757065722E73656C65637428652C742C6E293B636F6E7374206F3D6E5B305D2E73636F72655B305D3B6C657420733D2D312C723D2D313B666F72286C657420743D303B743C6E2E6C656E67746826266E5B745D2E73636F72655B305D3D3D3D6F3B742B';
wwv_flow_imp.g_varchar2_table(27582) := '2B297B636F6E737420693D60247B652E6765744C616E6775616765496428297D2F247B6E5B745D2E746578744C6162656C7D602C6F3D746869732E5F63616368652E7065656B2869293B6966286F26266F2E746F7563683E7226266F2E747970653D3D3D';
wwv_flow_imp.g_varchar2_table(27583) := '6E5B745D2E636F6D706C6574696F6E2E6B696E6426266F2E696E73657274546578743D3D3D6E5B745D2E636F6D706C6574696F6E2E696E7365727454657874262628723D6F2E746F7563682C733D74292C6E5B745D2E636F6D706C6574696F6E2E707265';
wwv_flow_imp.g_varchar2_table(27584) := '73656C6563742972657475726E20747D72657475726E2D31213D3D733F733A307D746F4A534F4E28297B72657475726E20746869732E5F63616368652E746F4A534F4E28297D66726F6D4A534F4E2865297B746869732E5F63616368652E636C65617228';
wwv_flow_imp.g_varchar2_table(27585) := '293B666F7228636F6E73745B742C6E5D6F662065296E2E746F7563683D302C6E2E747970653D226E756D626572223D3D747970656F66206E2E747970653F6E2E747970653A79772E66726F6D537472696E67286E2E74797065292C746869732E5F636163';
wwv_flow_imp.g_varchar2_table(27586) := '68652E73657428742C6E293B746869732E5F7365713D746869732E5F63616368652E73697A657D7D5D2C5B226669727374222C6A355D5D292C71352E5F73746F726167655072656669783D22737567676573742F6D656D6F72696573222C71353D7A353D';
wwv_flow_imp.g_varchar2_table(27587) := '66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A69';
wwv_flow_imp.g_varchar2_table(27588) := '3B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73652066';
wwv_flow_imp.g_varchar2_table(27589) := '6F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E64';
wwv_flow_imp.g_varchar2_table(27590) := '6566696E6550726F706572747928742C6E2C72292C727D285B483528302C5142292C483528312C6670295D2C7135293B636F6E73742024353D7063282249537567676573744D656D6F7269657322293B78702824352C71352C31293B7661722055353B6C';
wwv_flow_imp.g_varchar2_table(27591) := '6574204B353D55353D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F656469746F723D652C746869732E5F656E61626C65643D21312C746869732E5F636B4174456E643D55352E4174456E642E62696E64546F2874292C746869';
wwv_flow_imp.g_varchar2_table(27592) := '732E5F636F6E6669674C697374656E65723D746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E652E6861734368616E67656428313233292626746869732E5F757064617465282929292C74686973';
wwv_flow_imp.g_varchar2_table(27593) := '2E5F75706461746528297D646973706F736528297B76617220653B746869732E5F636F6E6669674C697374656E65722E646973706F736528292C6E756C6C3D3D3D28653D746869732E5F73656C656374696F6E4C697374656E6572297C7C766F69642030';
wwv_flow_imp.g_varchar2_table(27594) := '3D3D3D657C7C652E646973706F736528292C746869732E5F636B4174456E642E726573657428297D5F75706461746528297B636F6E737420653D226F6E223D3D3D746869732E5F656469746F722E6765744F7074696F6E28313233293B69662874686973';
wwv_flow_imp.g_varchar2_table(27595) := '2E5F656E61626C6564213D3D6529696628746869732E5F656E61626C65643D652C746869732E5F656E61626C6564297B636F6E737420653D28293D3E7B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E20766F6964';
wwv_flow_imp.g_varchar2_table(27596) := '20746869732E5F636B4174456E642E736574282131293B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C743D746869732E5F656469746F722E67657453656C656374696F6E28292C6E3D652E676574576F72644174506F';
wwv_flow_imp.g_varchar2_table(27597) := '736974696F6E28742E6765745374617274506F736974696F6E2829293B6E3F746869732E5F636B4174456E642E736574286E2E656E64436F6C756D6E3D3D3D742E6765745374617274506F736974696F6E28292E636F6C756D6E293A746869732E5F636B';
wwv_flow_imp.g_varchar2_table(27598) := '4174456E642E736574282131297D3B746869732E5F73656C656374696F6E4C697374656E65723D746869732E5F656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E2865292C6528297D656C736520746869732E5F73656C';
wwv_flow_imp.g_varchar2_table(27599) := '656374696F6E4C697374656E6572262628746869732E5F636B4174456E642E726573657428292C746869732E5F73656C656374696F6E4C697374656E65722E646973706F736528292C746869732E5F73656C656374696F6E4C697374656E65723D766F69';
wwv_flow_imp.g_varchar2_table(27600) := '642030297D7D3B4B352E4174456E643D6E6577206C6428226174456E644F66576F7264222C2131292C4B353D55353D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E75';
wwv_flow_imp.g_varchar2_table(27601) := '6C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C';
wwv_flow_imp.g_varchar2_table(27602) := '6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A73';
wwv_flow_imp.g_varchar2_table(27603) := '3E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F';
wwv_flow_imp.g_varchar2_table(27604) := '6E286E2C69297B74286E2C692C65297D7D28312C6364295D2C4B35293B7661722047353B6C65742051353D47353D636C6173737B636F6E7374727563746F7228652C74297B746869732E5F656469746F723D652C746869732E5F696E6465783D302C7468';
wwv_flow_imp.g_varchar2_table(27605) := '69732E5F636B4F7468657253756767657374696F6E733D47352E4F7468657253756767657374696F6E732E62696E64546F2874297D646973706F736528297B746869732E726573657428297D726573657428297B76617220653B746869732E5F636B4F74';
wwv_flow_imp.g_varchar2_table(27606) := '68657253756767657374696F6E732E726573657428292C6E756C6C3D3D3D28653D746869732E5F6C697374656E6572297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F6D6F64656C3D766F696420302C746869732E5F61';
wwv_flow_imp.g_varchar2_table(27607) := '63636570744E6578743D766F696420302C746869732E5F69676E6F72653D21317D736574287B6D6F64656C3A652C696E6465783A747D2C6E297B30213D3D652E6974656D732E6C656E677468262647352E5F6D6F7665496E6465782821302C652C742921';
wwv_flow_imp.g_varchar2_table(27608) := '3D3D743F28746869732E5F6163636570744E6578743D6E2C746869732E5F6D6F64656C3D652C746869732E5F696E6465783D742C746869732E5F6C697374656E65723D746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F73';
wwv_flow_imp.g_varchar2_table(27609) := '6974696F6E282828293D3E7B746869732E5F69676E6F72657C7C746869732E726573657428297D29292C746869732E5F636B4F7468657253756767657374696F6E732E73657428213029293A746869732E726573657428297D737461746963205F6D6F76';
wwv_flow_imp.g_varchar2_table(27610) := '65496E64657828652C742C6E297B6C657420693D6E3B666F72286C6574206F3D742E6974656D732E6C656E6774683B6F3E30262628693D28692B742E6974656D732E6C656E6774682B28653F313A2D31292925742E6974656D732E6C656E6774682C6921';
wwv_flow_imp.g_varchar2_table(27611) := '3D3D6E292626742E6974656D735B695D2E636F6D706C6574696F6E2E6164646974696F6E616C5465787445646974733B6F2D2D293B72657475726E20697D6E65787428297B746869732E5F6D6F7665282130297D7072657628297B746869732E5F6D6F76';
wwv_flow_imp.g_varchar2_table(27612) := '65282131297D5F6D6F76652865297B696628746869732E5F6D6F64656C297472797B746869732E5F69676E6F72653D21302C746869732E5F696E6465783D47352E5F6D6F7665496E64657828652C746869732E5F6D6F64656C2C746869732E5F696E6465';
wwv_flow_imp.g_varchar2_table(27613) := '78292C746869732E5F6163636570744E657874287B696E6465783A746869732E5F696E6465782C6974656D3A746869732E5F6D6F64656C2E6974656D735B746869732E5F696E6465785D2C6D6F64656C3A746869732E5F6D6F64656C7D297D66696E616C';
wwv_flow_imp.g_varchar2_table(27614) := '6C797B746869732E5F69676E6F72653D21317D7D7D3B51352E4F7468657253756767657374696F6E733D6E6577206C6428226861734F7468657253756767657374696F6E73222C2131292C51353D47353D66756E6374696F6E28652C742C6E2C69297B76';
wwv_flow_imp.g_varchar2_table(27615) := '6172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F';
wwv_flow_imp.g_varchar2_table(27616) := '66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(27617) := '3B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72';
wwv_flow_imp.g_varchar2_table(27618) := '292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28312C6364295D2C5135293B636C6173732059357B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F64';
wwv_flow_imp.g_varchar2_table(27619) := '6973706F7361626C65733D6E65772061742C746869732E5F646973706F7361626C65732E616464286E2E6F6E446964537567676573742828653D3E7B303D3D3D652E636F6D706C6574696F6E4D6F64656C2E6974656D732E6C656E677468262674686973';
wwv_flow_imp.g_varchar2_table(27620) := '2E726573657428297D2929292C746869732E5F646973706F7361626C65732E616464286E2E6F6E44696443616E63656C2828653D3E7B746869732E726573657428297D2929292C746869732E5F646973706F7361626C65732E61646428742E6F6E446964';
wwv_flow_imp.g_varchar2_table(27621) := '53686F77282828293D3E746869732E5F6F6E4974656D28742E676574466F63757365644974656D2829292929292C746869732E5F646973706F7361626C65732E61646428742E6F6E446964466F63757328746869732E5F6F6E4974656D2C746869732929';
wwv_flow_imp.g_varchar2_table(27622) := '2C746869732E5F646973706F7361626C65732E61646428742E6F6E4469644869646528746869732E72657365742C7468697329292C746869732E5F646973706F7361626C65732E61646428652E6F6E57696C6C5479706528286F3D3E7B69662874686973';
wwv_flow_imp.g_varchar2_table(27623) := '2E5F616374697665262621742E697346726F7A656E2829262630213D3D6E2E7374617465297B636F6E737420743D6F2E63686172436F64654174286F2E6C656E6774682D31293B746869732E5F6163746976652E61636365707443686172616374657273';
wwv_flow_imp.g_varchar2_table(27624) := '2E6861732874292626652E6765744F7074696F6E28302926266928746869732E5F6163746976652E6974656D297D7D2929297D5F6F6E4974656D2865297B69662821657C7C216A6828652E6974656D2E636F6D706C6574696F6E2E636F6D6D6974436861';
wwv_flow_imp.g_varchar2_table(27625) := '72616374657273292972657475726E20766F696420746869732E726573657428293B696628746869732E5F6163746976652626746869732E5F6163746976652E6974656D2E6974656D3D3D3D652E6974656D2972657475726E3B636F6E737420743D6E65';
wwv_flow_imp.g_varchar2_table(27626) := '77204B793B666F7228636F6E7374206E206F6620652E6974656D2E636F6D706C6574696F6E2E636F6D6D697443686172616374657273296E2E6C656E6774683E302626742E616464286E2E63686172436F64654174283029293B746869732E5F61637469';
wwv_flow_imp.g_varchar2_table(27627) := '76653D7B616363657074436861726163746572733A742C6974656D3A657D7D726573657428297B746869732E5F6163746976653D766F696420307D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528297D7D636C';
wwv_flow_imp.g_varchar2_table(27628) := '617373205A357B6173796E632070726F7669646553656C656374696F6E52616E67657328652C74297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F662074297B636F6E737420743D5B5D3B6E2E707573682874293B636F6E7374206F3D6E';
wwv_flow_imp.g_varchar2_table(27629) := '6577204D61703B6177616974206E65772050726F6D6973652828743D3E5A352E5F627261636B65747352696768745969656C6428742C302C652C692C6F2929292C6177616974206E65772050726F6D69736528286E3D3E5A352E5F627261636B6574734C';
wwv_flow_imp.g_varchar2_table(27630) := '6566745969656C64286E2C302C652C692C6F2C742929297D72657475726E206E7D737461746963205F627261636B65747352696768745969656C6428652C742C6E2C692C6F297B636F6E737420733D6E6577204D61702C723D446174652E6E6F7728293B';
wwv_flow_imp.g_varchar2_table(27631) := '666F72283B3B297B696628743E3D5A352E5F6D6178526F756E6473297B6528293B627265616B7D6966282169297B6528293B627265616B7D636F6E737420613D6E2E627261636B657450616972732E66696E644E657874427261636B65742869293B6966';
wwv_flow_imp.g_varchar2_table(27632) := '282161297B6528293B627265616B7D696628446174652E6E6F7728292D723E5A352E5F6D61784475726174696F6E297B73657454696D656F7574282828293D3E5A352E5F627261636B65747352696768745969656C6428652C742B312C6E2C692C6F2929';
wwv_flow_imp.g_varchar2_table(27633) := '293B627265616B7D696628612E627261636B6574496E666F2E69734F70656E696E67427261636B6574297B636F6E737420653D612E627261636B6574496E666F2E627261636B6574546578742C743D732E6861732865293F732E6765742865293A303B73';
wwv_flow_imp.g_varchar2_table(27634) := '2E73657428652C742B31297D656C73657B636F6E737420653D612E627261636B6574496E666F2E6765744F70656E696E67427261636B65747328295B305D2E627261636B6574546578743B6C657420743D732E6861732865293F732E6765742865293A30';
wwv_flow_imp.g_varchar2_table(27635) := '3B696628742D3D312C732E73657428652C4D6174682E6D617828302C7429292C743C30297B6C657420743D6F2E6765742865293B747C7C28743D6E65772067742C6F2E73657428652C7429292C742E7075736828612E72616E6765297D7D693D612E7261';
wwv_flow_imp.g_varchar2_table(27636) := '6E67652E676574456E64506F736974696F6E28297D7D737461746963205F627261636B6574734C6566745969656C6428652C742C6E2C692C6F2C73297B636F6E737420723D6E6577204D61702C613D446174652E6E6F7728293B666F72283B3B297B6966';
wwv_flow_imp.g_varchar2_table(27637) := '28743E3D5A352E5F6D6178526F756E64732626303D3D3D6F2E73697A65297B6528293B627265616B7D6966282169297B6528293B627265616B7D636F6E7374206C3D6E2E627261636B657450616972732E66696E6450726576427261636B65742869293B';
wwv_flow_imp.g_varchar2_table(27638) := '696628216C297B6528293B627265616B7D696628446174652E6E6F7728292D613E5A352E5F6D61784475726174696F6E297B73657454696D656F7574282828293D3E5A352E5F627261636B6574734C6566745969656C6428652C742B312C6E2C692C6F2C';
wwv_flow_imp.g_varchar2_table(27639) := '732929293B627265616B7D6966286C2E627261636B6574496E666F2E69734F70656E696E67427261636B6574297B636F6E737420653D6C2E627261636B6574496E666F2E627261636B6574546578743B6C657420743D722E6861732865293F722E676574';
wwv_flow_imp.g_varchar2_table(27640) := '2865293A303B696628742D3D312C722E73657428652C4D6174682E6D617828302C7429292C743C30297B636F6E737420743D6F2E6765742865293B69662874297B636F6E737420693D742E736869667428293B303D3D3D742E73697A6526266F2E64656C';
wwv_flow_imp.g_varchar2_table(27641) := '6574652865293B636F6E737420723D72682E66726F6D506F736974696F6E73286C2E72616E67652E676574456E64506F736974696F6E28292C692E6765745374617274506F736974696F6E2829292C613D72682E66726F6D506F736974696F6E73286C2E';
wwv_flow_imp.g_varchar2_table(27642) := '72616E67652E6765745374617274506F736974696F6E28292C692E676574456E64506F736974696F6E2829293B732E70757368287B72616E67653A727D292C732E70757368287B72616E67653A617D292C5A352E5F616464427261636B65744C65616469';
wwv_flow_imp.g_varchar2_table(27643) := '6E67286E2C612C73297D7D7D656C73657B636F6E737420653D6C2E627261636B6574496E666F2E6765744F70656E696E67427261636B65747328295B305D2E627261636B6574546578742C743D722E6861732865293F722E6765742865293A303B722E73';
wwv_flow_imp.g_varchar2_table(27644) := '657428652C742B31297D693D6C2E72616E67652E6765745374617274506F736974696F6E28297D7D737461746963205F616464427261636B65744C656164696E6728652C742C6E297B696628742E73746172744C696E654E756D6265723D3D3D742E656E';
wwv_flow_imp.g_varchar2_table(27645) := '644C696E654E756D6265722972657475726E3B636F6E737420693D742E73746172744C696E654E756D6265722C6F3D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2869293B30213D3D6F26266F213D3D742E737461';
wwv_flow_imp.g_varchar2_table(27646) := '7274436F6C756D6E2626286E2E70757368287B72616E67653A72682E66726F6D506F736974696F6E73286E6577206D6328692C6F292C742E676574456E64506F736974696F6E2829297D292C6E2E70757368287B72616E67653A72682E66726F6D506F73';
wwv_flow_imp.g_varchar2_table(27647) := '6974696F6E73286E6577206D6328692C31292C742E676574456E64506F736974696F6E2829297D29293B636F6E737420733D692D313B696628733E30297B636F6E737420693D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C';
wwv_flow_imp.g_varchar2_table(27648) := '756D6E2873293B693D3D3D742E7374617274436F6C756D6E262669213D3D652E6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E2873292626286E2E70757368287B72616E67653A72682E66726F6D506F736974696F6E73286E';
wwv_flow_imp.g_varchar2_table(27649) := '6577206D6328732C69292C742E676574456E64506F736974696F6E2829297D292C6E2E70757368287B72616E67653A72682E66726F6D506F736974696F6E73286E6577206D6328732C31292C742E676574456E64506F736974696F6E2829297D29297D7D';
wwv_flow_imp.g_varchar2_table(27650) := '7D5A352E5F6D61784475726174696F6E3D33302C5A352E5F6D6178526F756E64733D323B636C6173732058357B737461746963206173796E632063726561746528652C74297B69662821742E6765744F7074696F6E28313138292E6C6F63616C69747942';
wwv_flow_imp.g_varchar2_table(27651) := '6F6E75732972657475726E2058352E4E6F6E653B69662821742E6861734D6F64656C28292972657475726E2058352E4E6F6E653B636F6E7374206E3D742E6765744D6F64656C28292C693D742E676574506F736974696F6E28293B69662821652E63616E';
wwv_flow_imp.g_varchar2_table(27652) := '436F6D70757465576F726452616E676573286E2E757269292972657475726E2058352E4E6F6E653B636F6E73745B6F5D3D6177616974286E6577205A35292E70726F7669646553656C656374696F6E52616E676573286E2C5B695D293B696628303D3D3D';
wwv_flow_imp.g_varchar2_table(27653) := '6F2E6C656E6774682972657475726E2058352E4E6F6E653B636F6E737420733D617761697420652E636F6D70757465576F726452616E676573286E2E7572692C6F5B305D2E72616E6765293B69662821732972657475726E2058352E4E6F6E653B636F6E';
wwv_flow_imp.g_varchar2_table(27654) := '737420723D6E2E676574576F7264556E74696C506F736974696F6E2869293B72657475726E2064656C65746520735B722E776F72645D2C6E657720636C61737320657874656E64732058357B64697374616E636528652C6E297B69662821692E65717561';
wwv_flow_imp.g_varchar2_table(27655) := '6C7328742E676574506F736974696F6E2829292972657475726E20303B69662831373D3D3D6E2E6B696E642972657475726E20323C3C32303B636F6E737420723D22737472696E67223D3D747970656F66206E2E6C6162656C3F6E2E6C6162656C3A6E2E';
wwv_flow_imp.g_varchar2_table(27656) := '6C6162656C2E6C6162656C2C613D735B725D3B69662857682861292972657475726E20323C3C32303B636F6E7374206C3D4F6828612C72682E66726F6D506F736974696F6E732865292C72682E636F6D7061726552616E6765735573696E675374617274';
wwv_flow_imp.g_varchar2_table(27657) := '73292C633D6C3E3D303F615B6C5D3A615B4D6174682E6D617828302C7E6C2D31295D3B6C657420643D6F2E6C656E6774683B666F7228636F6E73742065206F66206F297B6966282172682E636F6E7461696E7352616E676528652E72616E67652C632929';
wwv_flow_imp.g_varchar2_table(27658) := '627265616B3B642D3D317D72657475726E20647D7D7D7D58352E4E6F6E653D6E657720636C61737320657874656E64732058357B64697374616E636528297B72657475726E20307D7D3B636C617373204A357B636F6E7374727563746F7228652C74297B';
wwv_flow_imp.g_varchar2_table(27659) := '746869732E6C656164696E674C696E65436F6E74656E743D652C746869732E636861726163746572436F756E7444656C74613D747D7D636C6173732065347B636F6E7374727563746F7228652C742C6E2C692C6F2C732C723D726C2E64656661756C742C';
wwv_flow_imp.g_varchar2_table(27660) := '613D766F69642030297B746869732E636C6970626F617264546578743D612C746869732E5F736E6970706574436F6D70617265466E3D65342E5F636F6D70617265436F6D706C6574696F6E4974656D732C746869732E5F6974656D733D652C746869732E';
wwv_flow_imp.g_varchar2_table(27661) := '5F636F6C756D6E3D742C746869732E5F776F726444697374616E63653D692C746869732E5F6F7074696F6E733D6F2C746869732E5F726566696C7465724B696E643D312C746869732E5F6C696E65436F6E746578743D6E2C746869732E5F66757A7A7953';
wwv_flow_imp.g_varchar2_table(27662) := '636F72654F7074696F6E733D722C22746F70223D3D3D733F746869732E5F736E6970706574436F6D70617265466E3D65342E5F636F6D70617265436F6D706C6574696F6E4974656D73536E69707065747355703A22626F74746F6D223D3D3D7326262874';
wwv_flow_imp.g_varchar2_table(27663) := '6869732E5F736E6970706574436F6D70617265466E3D65342E5F636F6D70617265436F6D706C6574696F6E4974656D73536E697070657473446F776E297D676574206C696E65436F6E7465787428297B72657475726E20746869732E5F6C696E65436F6E';
wwv_flow_imp.g_varchar2_table(27664) := '746578747D736574206C696E65436F6E746578742865297B746869732E5F6C696E65436F6E746578742E6C656164696E674C696E65436F6E74656E743D3D3D652E6C656164696E674C696E65436F6E74656E742626746869732E5F6C696E65436F6E7465';
wwv_flow_imp.g_varchar2_table(27665) := '78742E636861726163746572436F756E7444656C74613D3D3D652E636861726163746572436F756E7444656C74617C7C28746869732E5F726566696C7465724B696E643D746869732E5F6C696E65436F6E746578742E636861726163746572436F756E74';
wwv_flow_imp.g_varchar2_table(27666) := '44656C74613C652E636861726163746572436F756E7444656C74612626746869732E5F66696C74657265644974656D733F323A312C746869732E5F6C696E65436F6E746578743D65297D676574206974656D7328297B72657475726E20746869732E5F65';
wwv_flow_imp.g_varchar2_table(27667) := '6E73757265436163686564537461746528292C746869732E5F66696C74657265644974656D737D6765744974656D73427950726F766964657228297B72657475726E20746869732E5F656E73757265436163686564537461746528292C746869732E5F69';
wwv_flow_imp.g_varchar2_table(27668) := '74656D73427950726F76696465727D676574496E636F6D706C65746550726F766964657228297B746869732E5F656E73757265436163686564537461746528293B636F6E737420653D6E6577205365743B666F7228636F6E73745B742C6E5D6F66207468';
wwv_flow_imp.g_varchar2_table(27669) := '69732E6765744974656D73427950726F76696465722829296E2E6C656E6774683E3026266E5B305D2E636F6E7461696E65722E696E636F6D706C6574652626652E6164642874293B72657475726E20657D67657420737461747328297B72657475726E20';
wwv_flow_imp.g_varchar2_table(27670) := '746869732E5F656E73757265436163686564537461746528292C746869732E5F73746174737D5F656E73757265436163686564537461746528297B30213D3D746869732E5F726566696C7465724B696E642626746869732E5F6372656174654361636865';
wwv_flow_imp.g_varchar2_table(27671) := '64537461746528297D5F637265617465436163686564537461746528297B746869732E5F6974656D73427950726F76696465723D6E6577204D61703B636F6E737420653D5B5D2C7B6C656164696E674C696E65436F6E74656E743A742C63686172616374';
wwv_flow_imp.g_varchar2_table(27672) := '6572436F756E7444656C74613A6E7D3D746869732E5F6C696E65436F6E746578743B6C657420693D22222C6F3D22223B636F6E737420733D313D3D3D746869732E5F726566696C7465724B696E643F746869732E5F6974656D733A746869732E5F66696C';
wwv_flow_imp.g_varchar2_table(27673) := '74657265644974656D732C723D5B5D2C613D21746869732E5F6F7074696F6E732E66696C746572477261636566756C7C7C732E6C656E6774683E3265333F616C3A636C3B666F72286C6574206C3D303B6C3C732E6C656E6774683B6C2B2B297B636F6E73';
wwv_flow_imp.g_varchar2_table(27674) := '7420633D735B6C5D3B696628632E6973496E76616C696429636F6E74696E75653B636F6E737420643D746869732E5F6974656D73427950726F76696465722E67657428632E70726F7669646572293B643F642E707573682863293A746869732E5F697465';
wwv_flow_imp.g_varchar2_table(27675) := '6D73427950726F76696465722E73657428632E70726F76696465722C5B635D293B636F6E737420683D632E706F736974696F6E2E636F6C756D6E2D632E6564697453746172742E636F6C756D6E2C753D682B6E2D28632E706F736974696F6E2E636F6C75';
wwv_flow_imp.g_varchar2_table(27676) := '6D6E2D746869732E5F636F6C756D6E293B696628692E6C656E677468213D3D75262628693D303D3D3D753F22223A742E736C696365282D75292C6F3D692E746F4C6F776572436173652829292C632E776F72643D692C303D3D3D7529632E73636F72653D';
wwv_flow_imp.g_varchar2_table(27677) := '736C2E44656661756C743B656C73657B6C657420653D303B666F72283B653C683B297B636F6E737420743D692E63686172436F646541742865293B6966283332213D3D74262639213D3D7429627265616B3B652B3D317D696628653E3D7529632E73636F';
wwv_flow_imp.g_varchar2_table(27678) := '72653D736C2E44656661756C743B656C73652069662822737472696E67223D3D747970656F6620632E636F6D706C6574696F6E2E66696C74657254657874297B636F6E737420743D6128692C6F2C652C632E636F6D706C6574696F6E2E66696C74657254';
wwv_flow_imp.g_varchar2_table(27679) := '6578742C632E66696C746572546578744C6F772C302C746869732E5F66757A7A7953636F72654F7074696F6E73293B696628217429636F6E74696E75653B303D3D3D796928632E636F6D706C6574696F6E2E66696C746572546578742C632E746578744C';
wwv_flow_imp.g_varchar2_table(27680) := '6162656C293F632E73636F72653D743A28632E73636F72653D716128692C6F2C652C632E746578744C6162656C2C632E6C6162656C4C6F772C30292C632E73636F72655B305D3D745B305D297D656C73657B636F6E737420743D6128692C6F2C652C632E';
wwv_flow_imp.g_varchar2_table(27681) := '746578744C6162656C2C632E6C6162656C4C6F772C302C746869732E5F66757A7A7953636F72654F7074696F6E73293B696628217429636F6E74696E75653B632E73636F72653D747D7D632E6964783D6C2C632E64697374616E63653D746869732E5F77';
wwv_flow_imp.g_varchar2_table(27682) := '6F726444697374616E63652E64697374616E636528632E706F736974696F6E2C632E636F6D706C6574696F6E292C722E707573682863292C652E7075736828632E746578744C6162656C2E6C656E677468297D746869732E5F66696C7465726564497465';
wwv_flow_imp.g_varchar2_table(27683) := '6D733D722E736F727428746869732E5F736E6970706574436F6D70617265466E292C746869732E5F726566696C7465724B696E643D302C746869732E5F73746174733D7B704C6162656C4C656E3A652E6C656E6774683F526828652E6C656E6774682D2E';
wwv_flow_imp.g_varchar2_table(27684) := '38352C652C2828652C74293D3E652D7429293A307D7D737461746963205F636F6D70617265436F6D706C6574696F6E4974656D7328652C74297B72657475726E20652E73636F72655B305D3E742E73636F72655B305D3F2D313A652E73636F72655B305D';
wwv_flow_imp.g_varchar2_table(27685) := '3C742E73636F72655B305D3F313A652E64697374616E63653C742E64697374616E63653F2D313A652E64697374616E63653E742E64697374616E63653F313A652E6964783C742E6964783F2D313A652E6964783E742E6964783F313A307D737461746963';
wwv_flow_imp.g_varchar2_table(27686) := '205F636F6D70617265436F6D706C6574696F6E4974656D73536E697070657473446F776E28652C74297B696628652E636F6D706C6574696F6E2E6B696E64213D3D742E636F6D706C6574696F6E2E6B696E64297B69662832373D3D3D652E636F6D706C65';
wwv_flow_imp.g_varchar2_table(27687) := '74696F6E2E6B696E642972657475726E20313B69662832373D3D3D742E636F6D706C6574696F6E2E6B696E642972657475726E2D317D72657475726E2065342E5F636F6D70617265436F6D706C6574696F6E4974656D7328652C74297D73746174696320';
wwv_flow_imp.g_varchar2_table(27688) := '5F636F6D70617265436F6D706C6574696F6E4974656D73536E697070657473557028652C74297B696628652E636F6D706C6574696F6E2E6B696E64213D3D742E636F6D706C6574696F6E2E6B696E64297B69662832373D3D3D652E636F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(27689) := '6E2E6B696E642972657475726E2D313B69662832373D3D3D742E636F6D706C6574696F6E2E6B696E642972657475726E20317D72657475726E2065342E5F636F6D70617265436F6D706C6574696F6E4974656D7328652C74297D7D7661722074342C6E34';
wwv_flow_imp.g_varchar2_table(27690) := '3D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732069347B7374617469632073686F756C644175746F547269676765722865297B69662821652E6861734D6F64656C2829';
wwv_flow_imp.g_varchar2_table(27691) := '2972657475726E21313B636F6E737420743D652E6765744D6F64656C28292C6E3D652E676574506F736974696F6E28293B742E746F6B656E697A6174696F6E2E746F6B656E697A6549664368656170286E2E6C696E654E756D626572293B636F6E737420';
wwv_flow_imp.g_varchar2_table(27692) := '693D742E676574576F72644174506F736974696F6E286E293B72657475726E212821697C7C692E656E64436F6C756D6E213D3D6E2E636F6C756D6E2626692E7374617274436F6C756D6E2B31213D3D6E2E636F6C756D6E7C7C2169734E614E284E756D62';
wwv_flow_imp.g_varchar2_table(27693) := '657228692E776F72642929297D636F6E7374727563746F7228652C742C6E297B746869732E6C656164696E674C696E65436F6E74656E743D652E6765744C696E65436F6E74656E7428742E6C696E654E756D626572292E73756273747228302C742E636F';
wwv_flow_imp.g_varchar2_table(27694) := '6C756D6E2D31292C746869732E6C656164696E67576F72643D652E676574576F7264556E74696C506F736974696F6E2874292C746869732E6C696E654E756D6265723D742E6C696E654E756D6265722C746869732E636F6C756D6E3D742E636F6C756D6E';
wwv_flow_imp.g_varchar2_table(27695) := '2C746869732E747269676765724F7074696F6E733D6E7D7D6C6574206F343D74343D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B746869732E5F656469746F723D652C746869732E5F656469746F72576F';
wwv_flow_imp.g_varchar2_table(27696) := '726B6572536572766963653D742C746869732E5F636C6970626F617264536572766963653D6E2C746869732E5F74656C656D65747279536572766963653D692C746869732E5F6C6F67536572766963653D6F2C746869732E5F636F6E746578744B657953';
wwv_flow_imp.g_varchar2_table(27697) := '6572766963653D732C746869732E5F636F6E66696775726174696F6E536572766963653D722C746869732E5F6C616E67756167654665617475726573536572766963653D612C746869732E5F656E76536572766963653D6C2C746869732E5F746F446973';
wwv_flow_imp.g_varchar2_table(27698) := '706F73653D6E65772061742C746869732E5F747269676765724368617261637465724C697374656E65723D6E65772061742C746869732E5F74726967676572517569636B537567676573743D6E65772024742C746869732E5F7472696767657253746174';
wwv_flow_imp.g_varchar2_table(27699) := '653D766F696420302C746869732E5F636F6D706C6574696F6E446973706F7361626C65733D6E65772061742C746869732E5F6F6E44696443616E63656C3D6E65772043742C746869732E5F6F6E446964547269676765723D6E65772043742C746869732E';
wwv_flow_imp.g_varchar2_table(27700) := '5F6F6E446964537567676573743D6E65772043742C746869732E6F6E44696443616E63656C3D746869732E5F6F6E44696443616E63656C2E6576656E742C746869732E6F6E446964547269676765723D746869732E5F6F6E446964547269676765722E65';
wwv_flow_imp.g_varchar2_table(27701) := '76656E742C746869732E6F6E446964537567676573743D746869732E5F6F6E446964537567676573742E6576656E742C746869732E5F74656C656D65747279476174653D302C746869732E5F63757272656E7453656C656374696F6E3D746869732E5F65';
wwv_flow_imp.g_varchar2_table(27702) := '6469746F722E67657453656C656374696F6E28297C7C6E657720616828312C312C312C31292C746869732E5F746F446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(27703) := '757064617465547269676765724368617261637465727328292C746869732E63616E63656C28297D2929292C746869732E5F746F446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4C616E67756167';
wwv_flow_imp.g_varchar2_table(27704) := '65282828293D3E7B746869732E5F757064617465547269676765724368617261637465727328292C746869732E63616E63656C28297D2929292C746869732E5F746F446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(27705) := '6765436F6E66696775726174696F6E282828293D3E7B746869732E5F757064617465547269676765724368617261637465727328297D2929292C746869732E5F746F446973706F73652E61646428746869732E5F6C616E67756167654665617475726573';
wwv_flow_imp.g_varchar2_table(27706) := '536572766963652E636F6D706C6574696F6E50726F76696465722E6F6E4469644368616E6765282828293D3E7B746869732E5F757064617465547269676765724368617261637465727328292C746869732E5F7570646174654163746976655375676765';
wwv_flow_imp.g_varchar2_table(27707) := '737453657373696F6E28297D2929293B6C657420633D21313B746869732E5F746F446973706F73652E61646428746869732E5F656469746F722E6F6E446964436F6D706F736974696F6E5374617274282828293D3E7B633D21307D2929292C746869732E';
wwv_flow_imp.g_varchar2_table(27708) := '5F746F446973706F73652E61646428746869732E5F656469746F722E6F6E446964436F6D706F736974696F6E456E64282828293D3E7B633D21312C746869732E5F6F6E436F6D706F736974696F6E456E6428297D2929292C746869732E5F746F44697370';
wwv_flow_imp.g_varchar2_table(27709) := '6F73652E61646428746869732E5F656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E2828653D3E7B637C7C746869732E5F6F6E437572736F724368616E67652865297D2929292C746869732E5F746F446973706F73652E';
wwv_flow_imp.g_varchar2_table(27710) := '61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E74282828293D3E7B637C7C766F696420303D3D3D746869732E5F7472696767657253746174657C7C746869732E5F726566696C746572436F6D706C6574';
wwv_flow_imp.g_varchar2_table(27711) := '696F6E4974656D7328297D2929292C746869732E5F757064617465547269676765724368617261637465727328297D646973706F736528297B6F7428746869732E5F747269676765724368617261637465724C697374656E6572292C6F74285B74686973';
wwv_flow_imp.g_varchar2_table(27712) := '2E5F6F6E44696443616E63656C2C746869732E5F6F6E446964537567676573742C746869732E5F6F6E446964547269676765722C746869732E5F74726967676572517569636B537567676573745D292C746869732E5F746F446973706F73652E64697370';
wwv_flow_imp.g_varchar2_table(27713) := '6F736528292C746869732E5F636F6D706C6574696F6E446973706F7361626C65732E646973706F736528292C746869732E63616E63656C28297D5F757064617465547269676765724368617261637465727328297B696628746869732E5F747269676765';
wwv_flow_imp.g_varchar2_table(27714) := '724368617261637465724C697374656E65722E636C65617228292C746869732E5F656469746F722E6765744F7074696F6E283931297C7C21746869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F656469746F722E6765744F70';
wwv_flow_imp.g_varchar2_table(27715) := '74696F6E28313231292972657475726E3B636F6E737420653D6E6577204D61703B666F7228636F6E73742074206F6620746869732E5F6C616E67756167654665617475726573536572766963652E636F6D706C6574696F6E50726F76696465722E616C6C';
wwv_flow_imp.g_varchar2_table(27716) := '28746869732E5F656469746F722E6765744D6F64656C28292929666F7228636F6E7374206E206F6620742E74726967676572436861726163746572737C7C5B5D297B6C657420693D652E676574286E293B697C7C28693D6E6577205365742C692E616464';
wwv_flow_imp.g_varchar2_table(27717) := '28756E646566696E6564292C652E736574286E2C6929292C692E6164642874297D636F6E737420743D743D3E7B766172206E3B6966282166756E6374696F6E28652C74297B69662821426F6F6C65616E28742E676574436F6E746578744B657956616C75';
wwv_flow_imp.g_varchar2_table(27718) := '652822696E6C696E6553756767657374696F6E56697369626C652229292972657475726E21303B636F6E7374206E3D742E676574436F6E746578744B657956616C7565286B332E737570707265737353756767657374696F6E732E6B6579293B72657475';
wwv_flow_imp.g_varchar2_table(27719) := '726E20766F69642030213D3D6E3F216E3A21652E6765744F7074696F6E283632292E737570707265737353756767657374696F6E737D28746869732E5F656469746F722C746869732E5F636F6E746578744B6579536572766963652C746869732E5F636F';
wwv_flow_imp.g_varchar2_table(27720) := '6E66696775726174696F6E53657276696365292972657475726E3B69662869342E73686F756C644175746F5472696767657228746869732E5F656469746F72292972657475726E3B6966282174297B636F6E737420653D746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(27721) := '676574506F736974696F6E28293B743D746869732E5F656469746F722E6765744D6F64656C28292E6765744C696E65436F6E74656E7428652E6C696E654E756D626572292E73756273747228302C652E636F6C756D6E2D31297D6C657420693D22223B49';
wwv_flow_imp.g_varchar2_table(27722) := '6928742E63686172436F6465417428742E6C656E6774682D3129293F546928742E63686172436F6465417428742E6C656E6774682D322929262628693D742E73756273747228742E6C656E6774682D3229293A693D742E63686172417428742E6C656E67';
wwv_flow_imp.g_varchar2_table(27723) := '74682D31293B636F6E7374206F3D652E6765742869293B6966286F297B636F6E737420653D6E6577204D61703B696628746869732E5F636F6D706C6574696F6E4D6F64656C29666F7228636F6E73745B742C6E5D6F6620746869732E5F636F6D706C6574';
wwv_flow_imp.g_varchar2_table(27724) := '696F6E4D6F64656C2E6765744974656D73427950726F76696465722829296F2E6861732874297C7C652E73657428742C6E293B746869732E74726967676572287B6175746F3A21302C747269676765724B696E643A312C74726967676572436861726163';
wwv_flow_imp.g_varchar2_table(27725) := '7465723A692C7265747269676765723A426F6F6C65616E28746869732E5F636F6D706C6574696F6E4D6F64656C292C636C6970626F617264546578743A6E756C6C3D3D3D286E3D746869732E5F636F6D706C6574696F6E4D6F64656C297C7C766F696420';
wwv_flow_imp.g_varchar2_table(27726) := '303D3D3D6E3F766F696420303A6E2E636C6970626F617264546578742C636F6D706C6574696F6E4F7074696F6E733A7B70726F766964657246696C7465723A6F2C70726F76696465724974656D73546F52657573653A657D7D297D7D3B746869732E5F74';
wwv_flow_imp.g_varchar2_table(27727) := '7269676765724368617261637465724C697374656E65722E61646428746869732E5F656469746F722E6F6E44696454797065287429292C746869732E5F747269676765724368617261637465724C697374656E65722E61646428746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(27728) := '6F722E6F6E446964436F6D706F736974696F6E456E64282828293D3E7428292929297D67657420737461746528297B72657475726E20746869732E5F7472696767657253746174653F746869732E5F7472696767657253746174652E6175746F3F323A31';
wwv_flow_imp.g_varchar2_table(27729) := '3A307D63616E63656C28653D2131297B76617220743B766F69642030213D3D746869732E5F747269676765725374617465262628746869732E5F74726967676572517569636B537567676573742E63616E63656C28292C6E756C6C3D3D3D28743D746869';
wwv_flow_imp.g_varchar2_table(27730) := '732E5F72657175657374546F6B656E297C7C766F696420303D3D3D747C7C742E63616E63656C28292C746869732E5F72657175657374546F6B656E3D766F696420302C746869732E5F7472696767657253746174653D766F696420302C746869732E5F63';
wwv_flow_imp.g_varchar2_table(27731) := '6F6D706C6574696F6E4D6F64656C3D766F696420302C746869732E5F636F6E746578743D766F696420302C746869732E5F6F6E44696443616E63656C2E66697265287B7265747269676765723A657D29297D636C65617228297B746869732E5F636F6D70';
wwv_flow_imp.g_varchar2_table(27732) := '6C6574696F6E446973706F7361626C65732E636C65617228297D5F7570646174654163746976655375676765737453657373696F6E28297B766F69642030213D3D746869732E5F747269676765725374617465262628746869732E5F656469746F722E68';
wwv_flow_imp.g_varchar2_table(27733) := '61734D6F64656C28292626746869732E5F6C616E67756167654665617475726573536572766963652E636F6D706C6574696F6E50726F76696465722E68617328746869732E5F656469746F722E6765744D6F64656C2829293F746869732E747269676765';
wwv_flow_imp.g_varchar2_table(27734) := '72287B6175746F3A746869732E5F7472696767657253746174652E6175746F2C7265747269676765723A21307D293A746869732E63616E63656C2829297D5F6F6E437572736F724368616E67652865297B69662821746869732E5F656469746F722E6861';
wwv_flow_imp.g_varchar2_table(27735) := '734D6F64656C28292972657475726E3B636F6E737420743D746869732E5F63757272656E7453656C656374696F6E3B746869732E5F63757272656E7453656C656374696F6E3D746869732E5F656469746F722E67657453656C656374696F6E28292C2165';
wwv_flow_imp.g_varchar2_table(27736) := '2E73656C656374696F6E2E6973456D70747928297C7C30213D3D652E726561736F6E262633213D3D652E726561736F6E7C7C226B6579626F61726422213D3D652E736F7572636526262264656C6574654C65667422213D3D652E736F757263653F746869';
wwv_flow_imp.g_varchar2_table(27737) := '732E63616E63656C28293A766F696420303D3D3D746869732E5F7472696767657253746174652626303D3D3D652E726561736F6E3F28742E636F6E7461696E7352616E676528746869732E5F63757272656E7453656C656374696F6E297C7C742E676574';
wwv_flow_imp.g_varchar2_table(27738) := '456E64506F736974696F6E28292E69734265666F72654F72457175616C28746869732E5F63757272656E7453656C656374696F6E2E676574506F736974696F6E282929292626746869732E5F646F54726967676572517569636B5375676765737428293A';
wwv_flow_imp.g_varchar2_table(27739) := '766F69642030213D3D746869732E5F7472696767657253746174652626333D3D3D652E726561736F6E2626746869732E5F726566696C746572436F6D706C6574696F6E4974656D7328297D5F6F6E436F6D706F736974696F6E456E6428297B766F696420';
wwv_flow_imp.g_varchar2_table(27740) := '303D3D3D746869732E5F7472696767657253746174653F746869732E5F646F54726967676572517569636B5375676765737428293A746869732E5F726566696C746572436F6D706C6574696F6E4974656D7328297D5F646F54726967676572517569636B';
wwv_flow_imp.g_varchar2_table(27741) := '5375676765737428297B76617220653B67352E6973416C6C4F666628746869732E5F656469746F722E6765744F7074696F6E28383929297C7C746869732E5F656469746F722E6765744F7074696F6E28313138292E736E69707065747350726576656E74';
wwv_flow_imp.g_varchar2_table(27742) := '517569636B53756767657374696F6E732626286E756C6C3D3D3D28653D4E352E67657428746869732E5F656469746F7229297C7C766F696420303D3D3D653F766F696420303A652E6973496E536E69707065742829297C7C28746869732E63616E63656C';
wwv_flow_imp.g_varchar2_table(27743) := '28292C746869732E5F74726967676572517569636B537567676573742E63616E63656C416E64536574282828293D3E7B696628766F69642030213D3D746869732E5F7472696767657253746174652972657475726E3B6966282169342E73686F756C6441';
wwv_flow_imp.g_varchar2_table(27744) := '75746F5472696767657228746869732E5F656469746F72292972657475726E3B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F656469746F722E686173576964676574466F63757328292972657475726E3B63';
wwv_flow_imp.g_varchar2_table(27745) := '6F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C743D746869732E5F656469746F722E676574506F736974696F6E28292C6E3D746869732E5F656469746F722E6765744F7074696F6E283839293B6966282167352E6973416C';
wwv_flow_imp.g_varchar2_table(27746) := '6C4F6666286E29297B6966282167352E6973416C6C4F6E286E29297B652E746F6B656E697A6174696F6E2E746F6B656E697A654966436865617028742E6C696E654E756D626572293B636F6E737420693D652E746F6B656E697A6174696F6E2E6765744C';
wwv_flow_imp.g_varchar2_table(27747) := '696E65546F6B656E7328742E6C696E654E756D626572292C6F3D692E6765745374616E64617264546F6B656E5479706528692E66696E64546F6B656E496E64657841744F6666736574284D6174682E6D617828742E636F6C756D6E2D312D312C30292929';
wwv_flow_imp.g_varchar2_table(27748) := '3B696628226F6E22213D3D67352E76616C7565466F72286E2C6F292972657475726E7D2866756E6374696F6E28652C74297B69662821426F6F6C65616E28742E676574436F6E746578744B657956616C7565286B332E696E6C696E655375676765737469';
wwv_flow_imp.g_varchar2_table(27749) := '6F6E56697369626C652E6B657929292972657475726E21303B636F6E7374206E3D742E676574436F6E746578744B657956616C7565286B332E737570707265737353756767657374696F6E732E6B6579293B72657475726E20766F69642030213D3D6E3F';
wwv_flow_imp.g_varchar2_table(27750) := '216E3A21652E6765744F7074696F6E283632292E737570707265737353756767657374696F6E737D2928746869732E5F656469746F722C746869732E5F636F6E746578744B6579536572766963652C746869732E5F636F6E66696775726174696F6E5365';
wwv_flow_imp.g_varchar2_table(27751) := '7276696365292626746869732E5F6C616E67756167654665617475726573536572766963652E636F6D706C6574696F6E50726F76696465722E6861732865292626746869732E74726967676572287B6175746F3A21307D297D7D292C746869732E5F6564';
wwv_flow_imp.g_varchar2_table(27752) := '69746F722E6765744F7074696F6E2839302929297D5F726566696C746572436F6D706C6574696F6E4974656D7328297B796C28746869732E5F656469746F722E6861734D6F64656C2829292C796C28766F69642030213D3D746869732E5F747269676765';
wwv_flow_imp.g_varchar2_table(27753) := '725374617465293B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C743D746869732E5F656469746F722E676574506F736974696F6E28292C6E3D6E657720693428652C742C7B2E2E2E746869732E5F7472696767657253';
wwv_flow_imp.g_varchar2_table(27754) := '746174652C726566696C7465723A21307D293B746869732E5F6F6E4E6577436F6E74657874286E297D747269676765722865297B76617220742C6E2C692C6F2C732C723B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475';
wwv_flow_imp.g_varchar2_table(27755) := '726E3B636F6E737420613D746869732E5F656469746F722E6765744D6F64656C28292C6C3D6E657720693428612C746869732E5F656469746F722E676574506F736974696F6E28292C65293B746869732E63616E63656C28652E72657472696767657229';
wwv_flow_imp.g_varchar2_table(27756) := '2C746869732E5F7472696767657253746174653D652C746869732E5F6F6E446964547269676765722E66697265287B6175746F3A652E6175746F2C7368793A6E756C6C213D3D28743D652E736879292626766F69642030213D3D742626742C706F736974';
wwv_flow_imp.g_varchar2_table(27757) := '696F6E3A746869732E5F656469746F722E676574506F736974696F6E28297D292C746869732E5F636F6E746578743D6C3B6C657420633D7B747269676765724B696E643A6E756C6C213D3D286E3D652E747269676765724B696E64292626766F69642030';
wwv_flow_imp.g_varchar2_table(27758) := '213D3D6E3F6E3A307D3B652E74726967676572436861726163746572262628633D7B747269676765724B696E643A312C747269676765724368617261637465723A652E747269676765724368617261637465727D292C746869732E5F7265717565737454';
wwv_flow_imp.g_varchar2_table(27759) := '6F6B656E3D6E6577204E743B6C657420643D313B73776974636828746869732E5F656469746F722E6765744F7074696F6E2831313229297B6361736522746F70223A643D303B627265616B3B6361736522626F74746F6D223A643D327D636F6E73747B69';
wwv_flow_imp.g_varchar2_table(27760) := '74656D4B696E643A682C73686F77446570726563617465643A757D3D74342E6372656174655375676765737446696C74657228746869732E5F656469746F72292C703D6E657720633528642C6E756C6C213D3D286F3D6E756C6C3D3D3D28693D652E636F';
wwv_flow_imp.g_varchar2_table(27761) := '6D706C6574696F6E4F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6B696E6446696C746572292626766F69642030213D3D6F3F6F3A682C6E756C6C3D3D3D28733D652E636F6D706C6574696F6E4F7074696F6E73297C7C766F';
wwv_flow_imp.g_varchar2_table(27762) := '696420303D3D3D733F766F696420303A732E70726F766964657246696C7465722C6E756C6C3D3D3D28723D652E636F6D706C6574696F6E4F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E70726F76696465724974656D73546F';
wwv_flow_imp.g_varchar2_table(27763) := '52657573652C75292C673D58352E63726561746528746869732E5F656469746F72576F726B6572536572766963652C746869732E5F656469746F72292C6D3D683528746869732E5F6C616E67756167654665617475726573536572766963652E636F6D70';
wwv_flow_imp.g_varchar2_table(27764) := '6C6574696F6E50726F76696465722C612C746869732E5F656469746F722E676574506F736974696F6E28292C702C632C746869732E5F72657175657374546F6B656E2E746F6B656E293B50726F6D6973652E616C6C285B6D2C675D292E7468656E282861';
wwv_flow_imp.g_varchar2_table(27765) := '73796E63285B742C6E5D293D3E7B76617220693B6966286E756C6C3D3D3D28693D746869732E5F72657175657374546F6B656E297C7C766F696420303D3D3D697C7C692E646973706F736528292C21746869732E5F656469746F722E6861734D6F64656C';
wwv_flow_imp.g_varchar2_table(27766) := '28292972657475726E3B6C6574206F3D6E756C6C3D3D653F766F696420303A652E636C6970626F617264546578743B696628216F2626742E6E65656473436C6970626F6172642626286F3D617761697420746869732E5F636C6970626F61726453657276';
wwv_flow_imp.g_varchar2_table(27767) := '6963652E72656164546578742829292C766F696420303D3D3D746869732E5F7472696767657253746174652972657475726E3B636F6E737420733D746869732E5F656469746F722E6765744D6F64656C28292C723D6E657720693428732C746869732E5F';
wwv_flow_imp.g_varchar2_table(27768) := '656469746F722E676574506F736974696F6E28292C65292C613D7B2E2E2E726C2E64656661756C742C66697273744D6174636843616E42655765616B3A21746869732E5F656469746F722E6765744F7074696F6E28313138292E6D617463684F6E576F72';
wwv_flow_imp.g_varchar2_table(27769) := '6453746172744F6E6C797D3B696628746869732E5F636F6D706C6574696F6E4D6F64656C3D6E657720653428742E6974656D732C746869732E5F636F6E746578742E636F6C756D6E2C7B6C656164696E674C696E65436F6E74656E743A722E6C65616469';
wwv_flow_imp.g_varchar2_table(27770) := '6E674C696E65436F6E74656E742C636861726163746572436F756E7444656C74613A722E636F6C756D6E2D746869732E5F636F6E746578742E636F6C756D6E7D2C6E2C746869732E5F656469746F722E6765744F7074696F6E28313138292C746869732E';
wwv_flow_imp.g_varchar2_table(27771) := '5F656469746F722E6765744F7074696F6E28313132292C612C6F292C746869732E5F636F6D706C6574696F6E446973706F7361626C65732E61646428742E646973706F7361626C65292C746869732E5F6F6E4E6577436F6E746578742872292C74686973';
wwv_flow_imp.g_varchar2_table(27772) := '2E5F7265706F72744475726174696F6E7354656C656D6574727928742E6475726174696F6E73292C21746869732E5F656E76536572766963652E69734275696C747C7C746869732E5F656E76536572766963652E6973457874656E73696F6E446576656C';
wwv_flow_imp.g_varchar2_table(27773) := '6F706D656E7429666F7228636F6E73742065206F6620742E6974656D7329652E6973496E76616C69642626746869732E5F6C6F67536572766963652E7761726E28605B737567676573745D206469642049474E4F524520696E76616C696420636F6D706C';
wwv_flow_imp.g_varchar2_table(27774) := '6574696F6E206974656D2066726F6D20247B652E70726F76696465722E5F6465627567446973706C61794E616D657D602C652E636F6D706C6574696F6E297D29292E6361746368286B65297D5F7265706F72744475726174696F6E7354656C656D657472';
wwv_flow_imp.g_varchar2_table(27775) := '792865297B746869732E5F74656C656D65747279476174652B2B253233303D3D30262673657454696D656F7574282828293D3E7B746869732E5F74656C656D65747279536572766963652E7075626C69634C6F67322822737567676573742E6475726174';
wwv_flow_imp.g_varchar2_table(27776) := '696F6E732E6A736F6E222C7B646174613A4A534F4E2E737472696E676966792865297D292C746869732E5F6C6F67536572766963652E64656275672822737567676573742E6475726174696F6E732E6A736F6E222C65297D29297D737461746963206372';
wwv_flow_imp.g_varchar2_table(27777) := '656174655375676765737446696C7465722865297B636F6E737420743D6E6577205365743B226E6F6E65223D3D3D652E6765744F7074696F6E28313132292626742E616464283237293B636F6E7374206E3D652E6765744F7074696F6E28313138293B72';
wwv_flow_imp.g_varchar2_table(27778) := '657475726E206E2E73686F774D6574686F64737C7C742E6164642830292C6E2E73686F7746756E6374696F6E737C7C742E6164642831292C6E2E73686F77436F6E7374727563746F72737C7C742E6164642832292C6E2E73686F774669656C64737C7C74';
wwv_flow_imp.g_varchar2_table(27779) := '2E6164642833292C6E2E73686F775661726961626C65737C7C742E6164642834292C6E2E73686F77436C61737365737C7C742E6164642835292C6E2E73686F77537472756374737C7C742E6164642836292C6E2E73686F77496E74657266616365737C7C';
wwv_flow_imp.g_varchar2_table(27780) := '742E6164642837292C6E2E73686F774D6F64756C65737C7C742E6164642838292C6E2E73686F7750726F706572746965737C7C742E6164642839292C6E2E73686F774576656E74737C7C742E616464283130292C6E2E73686F774F70657261746F72737C';
wwv_flow_imp.g_varchar2_table(27781) := '7C742E616464283131292C6E2E73686F77556E6974737C7C742E616464283132292C6E2E73686F7756616C7565737C7C742E616464283133292C6E2E73686F77436F6E7374616E74737C7C742E616464283134292C6E2E73686F77456E756D737C7C742E';
wwv_flow_imp.g_varchar2_table(27782) := '616464283135292C6E2E73686F77456E756D4D656D626572737C7C742E616464283136292C6E2E73686F774B6579776F7264737C7C742E616464283137292C6E2E73686F77576F7264737C7C742E616464283138292C6E2E73686F77436F6C6F72737C7C';
wwv_flow_imp.g_varchar2_table(27783) := '742E616464283139292C6E2E73686F7746696C65737C7C742E616464283230292C6E2E73686F775265666572656E6365737C7C742E616464283231292C6E2E73686F77436F6C6F72737C7C742E616464283232292C6E2E73686F77466F6C646572737C7C';
wwv_flow_imp.g_varchar2_table(27784) := '742E616464283233292C6E2E73686F7754797065506172616D65746572737C7C742E616464283234292C6E2E73686F77536E6970706574737C7C742E616464283237292C6E2E73686F7755736572737C7C742E616464283235292C6E2E73686F77497373';
wwv_flow_imp.g_varchar2_table(27785) := '7565737C7C742E616464283236292C7B6974656D4B696E643A742C73686F77446570726563617465643A6E2E73686F77446570726563617465647D7D5F6F6E4E6577436F6E746578742865297B696628746869732E5F636F6E7465787429696628652E6C';
wwv_flow_imp.g_varchar2_table(27786) := '696E654E756D6265723D3D3D746869732E5F636F6E746578742E6C696E654E756D62657229696628666928652E6C656164696E674C696E65436F6E74656E74293D3D3D666928746869732E5F636F6E746578742E6C656164696E674C696E65436F6E7465';
wwv_flow_imp.g_varchar2_table(27787) := '6E7429297B696628652E636F6C756D6E3C746869732E5F636F6E746578742E636F6C756D6E29652E6C656164696E67576F72642E776F72643F746869732E74726967676572287B6175746F3A746869732E5F636F6E746578742E747269676765724F7074';
wwv_flow_imp.g_varchar2_table(27788) := '696F6E732E6175746F2C7265747269676765723A21307D293A746869732E63616E63656C28293B656C736520696628746869732E5F636F6D706C6574696F6E4D6F64656C2969662830213D3D652E6C656164696E67576F72642E776F72642E6C656E6774';
wwv_flow_imp.g_varchar2_table(27789) := '682626652E6C656164696E67576F72642E7374617274436F6C756D6E3E746869732E5F636F6E746578742E6C656164696E67576F72642E7374617274436F6C756D6E297B69662869342E73686F756C644175746F5472696767657228746869732E5F6564';
wwv_flow_imp.g_varchar2_table(27790) := '69746F72292626746869732E5F636F6E74657874297B636F6E737420653D746869732E5F636F6D706C6574696F6E4D6F64656C2E6765744974656D73427950726F766964657228293B746869732E74726967676572287B6175746F3A746869732E5F636F';
wwv_flow_imp.g_varchar2_table(27791) := '6E746578742E747269676765724F7074696F6E732E6175746F2C7265747269676765723A21302C636C6970626F617264546578743A746869732E5F636F6D706C6574696F6E4D6F64656C2E636C6970626F617264546578742C636F6D706C6574696F6E4F';
wwv_flow_imp.g_varchar2_table(27792) := '7074696F6E733A7B70726F76696465724974656D73546F52657573653A657D7D297D7D656C736520696628652E636F6C756D6E3E746869732E5F636F6E746578742E636F6C756D6E2626746869732E5F636F6D706C6574696F6E4D6F64656C2E67657449';
wwv_flow_imp.g_varchar2_table(27793) := '6E636F6D706C65746550726F766964657228292E73697A653E30262630213D3D652E6C656164696E67576F72642E776F72642E6C656E677468297B636F6E737420653D6E6577204D61702C743D6E6577205365743B666F7228636F6E73745B6E2C695D6F';
wwv_flow_imp.g_varchar2_table(27794) := '6620746869732E5F636F6D706C6574696F6E4D6F64656C2E6765744974656D73427950726F7669646572282929692E6C656E6774683E302626695B305D2E636F6E7461696E65722E696E636F6D706C6574653F742E616464286E293A652E736574286E2C';
wwv_flow_imp.g_varchar2_table(27795) := '69293B746869732E74726967676572287B6175746F3A746869732E5F636F6E746578742E747269676765724F7074696F6E732E6175746F2C747269676765724B696E643A322C7265747269676765723A21302C636C6970626F617264546578743A746869';
wwv_flow_imp.g_varchar2_table(27796) := '732E5F636F6D706C6574696F6E4D6F64656C2E636C6970626F617264546578742C636F6D706C6574696F6E4F7074696F6E733A7B70726F766964657246696C7465723A742C70726F76696465724974656D73546F52657573653A657D7D297D656C73657B';
wwv_flow_imp.g_varchar2_table(27797) := '636F6E737420743D746869732E5F636F6D706C6574696F6E4D6F64656C2E6C696E65436F6E746578743B6C6574206E3D21313B696628746869732E5F636F6D706C6574696F6E4D6F64656C2E6C696E65436F6E746578743D7B6C656164696E674C696E65';
wwv_flow_imp.g_varchar2_table(27798) := '436F6E74656E743A652E6C656164696E674C696E65436F6E74656E742C636861726163746572436F756E7444656C74613A652E636F6C756D6E2D746869732E5F636F6E746578742E636F6C756D6E7D2C303D3D3D746869732E5F636F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(27799) := '4D6F64656C2E6974656D732E6C656E677468297B636F6E737420693D69342E73686F756C644175746F5472696767657228746869732E5F656469746F72293B69662821746869732E5F636F6E746578742972657475726E20766F696420746869732E6361';
wwv_flow_imp.g_varchar2_table(27800) := '6E63656C28293B696628692626746869732E5F636F6E746578742E6C656164696E67576F72642E656E64436F6C756D6E3C652E6C656164696E67576F72642E7374617274436F6C756D6E2972657475726E20766F696420746869732E7472696767657228';
wwv_flow_imp.g_varchar2_table(27801) := '7B6175746F3A746869732E5F636F6E746578742E747269676765724F7074696F6E732E6175746F2C7265747269676765723A21307D293B696628746869732E5F636F6E746578742E747269676765724F7074696F6E732E6175746F2972657475726E2076';
wwv_flow_imp.g_varchar2_table(27802) := '6F696420746869732E63616E63656C28293B696628746869732E5F636F6D706C6574696F6E4D6F64656C2E6C696E65436F6E746578743D742C6E3D746869732E5F636F6D706C6574696F6E4D6F64656C2E6974656D732E6C656E6774683E302C6E262630';
wwv_flow_imp.g_varchar2_table(27803) := '3D3D3D652E6C656164696E67576F72642E776F72642E6C656E6774682972657475726E20766F696420746869732E63616E63656C28297D746869732E5F6F6E446964537567676573742E66697265287B636F6D706C6574696F6E4D6F64656C3A74686973';
wwv_flow_imp.g_varchar2_table(27804) := '2E5F636F6D706C6574696F6E4D6F64656C2C747269676765724F7074696F6E733A652E747269676765724F7074696F6E732C697346726F7A656E3A6E7D297D7D656C736520746869732E63616E63656C28293B656C736520746869732E63616E63656C28';
wwv_flow_imp.g_varchar2_table(27805) := '297D7D3B6F343D74343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970';
wwv_flow_imp.g_varchar2_table(27806) := '746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E';
wwv_flow_imp.g_varchar2_table(27807) := '2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E33262672';
wwv_flow_imp.g_varchar2_table(27808) := '26264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6E3428312C7A5A292C6E3428322C7945292C6E3428332C4F64292C6E3428342C5264292C6E3428352C6364292C6E3428362C6670292C6E3428372C7878292C6E34';
wwv_flow_imp.g_varchar2_table(27809) := '28382C6C56295D2C6F34293B636C6173732073347B636F6E7374727563746F7228652C74297B746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F6C6173744F76657274797065643D5B5D2C746869732E5F6C6F636B65643D21';
wwv_flow_imp.g_varchar2_table(27810) := '312C746869732E5F646973706F7361626C65732E61646428652E6F6E57696C6C54797065282828293D3E7B696628746869732E5F6C6F636B65647C7C21652E6861734D6F64656C28292972657475726E3B636F6E737420743D652E67657453656C656374';
wwv_flow_imp.g_varchar2_table(27811) := '696F6E7328292C6E3D742E6C656E6774683B6C657420693D21313B666F72286C657420653D303B653C6E3B652B2B2969662821745B655D2E6973456D7074792829297B693D21303B627265616B7D69662821692972657475726E20766F69642830213D3D';
wwv_flow_imp.g_varchar2_table(27812) := '746869732E5F6C6173744F76657274797065642E6C656E677468262628746869732E5F6C6173744F76657274797065642E6C656E6774683D3029293B746869732E5F6C6173744F76657274797065643D5B5D3B636F6E7374206F3D652E6765744D6F6465';
wwv_flow_imp.g_varchar2_table(27813) := '6C28293B666F72286C657420653D303B653C6E3B652B2B297B636F6E7374206E3D745B655D3B6966286F2E67657456616C75654C656E677468496E52616E6765286E293E73342E5F6D617853656C656374696F6E4C656E6774682972657475726E3B7468';
wwv_flow_imp.g_varchar2_table(27814) := '69732E5F6C6173744F76657274797065645B655D3D7B76616C75653A6F2E67657456616C7565496E52616E6765286E292C6D756C74696C696E653A6E2E73746172744C696E654E756D626572213D3D6E2E656E644C696E654E756D6265727D7D7D292929';
wwv_flow_imp.g_varchar2_table(27815) := '2C746869732E5F646973706F7361626C65732E61646428742E6F6E446964547269676765722828653D3E7B746869732E5F6C6F636B65643D21307D2929292C746869732E5F646973706F7361626C65732E61646428742E6F6E44696443616E63656C2828';
wwv_flow_imp.g_varchar2_table(27816) := '653D3E7B746869732E5F6C6F636B65643D21317D2929297D6765744C6173744F7665727479706564496E666F2865297B696628653E3D302626653C746869732E5F6C6173744F76657274797065642E6C656E6774682972657475726E20746869732E5F6C';
wwv_flow_imp.g_varchar2_table(27817) := '6173744F76657274797065645B655D7D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528297D7D73342E5F6D617853656C656374696F6E4C656E6774683D35313230303B7661722072343D6E2837313630292C61';
wwv_flow_imp.g_varchar2_table(27818) := '343D7B7D3B61342E7374796C655461675472616E73666F726D3D6A7228292C61342E736574417474726962757465733D567228292C61342E696E736572743D467228292E62696E64286E756C6C2C226865616422292C61342E646F6D4150493D4F722829';
wwv_flow_imp.g_varchar2_table(27819) := '2C61342E696E736572745374796C65456C656D656E743D487228292C4E7228292872342E412C6134292C72342E41262672342E412E6C6F63616C73262672342E412E6C6F63616C733B766172206C343D66756E6374696F6E28652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(27820) := '2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C61737320633420657874656E647320796A7B7570646174654C6162656C28297B636F6E737420653D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B65';
wwv_flow_imp.g_varchar2_table(27821) := '7962696E64696E6728746869732E5F616374696F6E2E69642C746869732E5F636F6E746578744B657953657276696365293B69662821652972657475726E2073757065722E7570646174654C6162656C28293B746869732E6C6162656C26262874686973';
wwv_flow_imp.g_varchar2_table(27822) := '2E6C6162656C2E74657874436F6E74656E743D6228302C227B307D20287B317D29222C746869732E5F616374696F6E2E6C6162656C2C63342E73796D626F6C5072696E74456E74657228652929297D7374617469632073796D626F6C5072696E74456E74';
wwv_flow_imp.g_varchar2_table(27823) := '65722865297B76617220743B72657475726E206E756C6C3D3D3D28743D652E6765744C6162656C2829297C7C766F696420303D3D3D743F766F696420303A742E7265706C616365282F5C62656E7465725C622F67692C22E28F8E22297D7D6C6574206434';
wwv_flow_imp.g_varchar2_table(27824) := '3D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F6D656E7549643D742C746869732E5F6D656E75536572766963653D692C746869732E5F636F6E746578744B6579536572766963653D6F2C746869732E5F6D656E';
wwv_flow_imp.g_varchar2_table(27825) := '75446973706F7361626C65733D6E65772061742C746869732E656C656D656E743D757228652C627228222E737567676573742D7374617475732D6261722229293B636F6E737420733D653D3E6520696E7374616E63656F662041643F6E2E637265617465';
wwv_flow_imp.g_varchar2_table(27826) := '496E7374616E63652863342C652C766F69642030293A766F696420303B746869732E5F6C656674416374696F6E733D6E6577206C4D28746869732E656C656D656E742C7B616374696F6E566965774974656D50726F76696465723A737D292C746869732E';
wwv_flow_imp.g_varchar2_table(27827) := '5F7269676874416374696F6E733D6E6577206C4D28746869732E656C656D656E742C7B616374696F6E566965774974656D50726F76696465723A737D292C746869732E5F6C656674416374696F6E732E646F6D4E6F64652E636C6173734C6973742E6164';
wwv_flow_imp.g_varchar2_table(27828) := '6428226C65667422292C746869732E5F7269676874416374696F6E732E646F6D4E6F64652E636C6173734C6973742E6164642822726967687422297D646973706F736528297B746869732E5F6D656E75446973706F7361626C65732E646973706F736528';
wwv_flow_imp.g_varchar2_table(27829) := '292C746869732E5F6C656674416374696F6E732E646973706F736528292C746869732E5F7269676874416374696F6E732E646973706F736528292C746869732E656C656D656E742E72656D6F766528297D73686F7728297B636F6E737420653D74686973';
wwv_flow_imp.g_varchar2_table(27830) := '2E5F6D656E75536572766963652E6372656174654D656E7528746869732E5F6D656E7549642C746869732E5F636F6E746578744B657953657276696365292C743D28293D3E7B636F6E737420743D5B5D2C6E3D5B5D3B666F7228636F6E73745B692C6F5D';
wwv_flow_imp.g_varchar2_table(27831) := '6F6620652E676574416374696F6E73282929226C656674223D3D3D693F742E70757368282E2E2E6F293A6E2E70757368282E2E2E6F293B746869732E5F6C656674416374696F6E732E636C65617228292C746869732E5F6C656674416374696F6E732E70';
wwv_flow_imp.g_varchar2_table(27832) := '7573682874292C746869732E5F7269676874416374696F6E732E636C65617228292C746869732E5F7269676874416374696F6E732E70757368286E297D3B746869732E5F6D656E75446973706F7361626C65732E61646428652E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(27833) := '65282828293D3E7428292929292C746869732E5F6D656E75446973706F7361626C65732E6164642865297D6869646528297B746869732E5F6D656E75446973706F7361626C65732E636C65617228297D7D3B64343D66756E6374696F6E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(27834) := '69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D74';
wwv_flow_imp.g_varchar2_table(27835) := '7970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E67';
wwv_flow_imp.g_varchar2_table(27836) := '74682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F70657274792874';
wwv_flow_imp.g_varchar2_table(27837) := '2C6E2C72292C727D285B6C3428322C7563292C6C3428332C4464292C6C3428342C6364295D2C6434293B66756E6374696F6E2068342865297B72657475726E2121652626426F6F6C65616E28652E636F6D706C6574696F6E2E646F63756D656E74617469';
wwv_flow_imp.g_varchar2_table(27838) := '6F6E7C7C652E636F6D706C6574696F6E2E64657461696C2626652E636F6D706C6574696F6E2E64657461696C213D3D652E636F6D706C6574696F6E2E6C6162656C297D6C65742075343D636C6173737B636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(27839) := '732E5F656469746F723D652C746869732E5F6F6E446964436C6F73653D6E65772043742C746869732E6F6E446964436C6F73653D746869732E5F6F6E446964436C6F73652E6576656E742C746869732E5F6F6E4469644368616E6765436F6E74656E7473';
wwv_flow_imp.g_varchar2_table(27840) := '3D6E65772043742C746869732E6F6E4469644368616E6765436F6E74656E74733D746869732E5F6F6E4469644368616E6765436F6E74656E74732E6576656E742C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F72656E64';
wwv_flow_imp.g_varchar2_table(27841) := '6572446973706F736561626C653D6E65772061742C746869732E5F626F7264657257696474683D312C746869732E5F73697A653D6E6577204973283333302C30292C746869732E646F6D4E6F64653D627228222E737567676573742D64657461696C7322';
wwv_flow_imp.g_varchar2_table(27842) := '292C746869732E646F6D4E6F64652E636C6173734C6973742E61646428226E6F2D646F637322292C746869732E5F6D61726B646F776E52656E64657265723D742E637265617465496E7374616E63652870452C7B656469746F723A657D292C746869732E';
wwv_flow_imp.g_varchar2_table(27843) := '5F626F64793D627228222E626F647922292C746869732E5F7363726F6C6C6261723D6E657720675428746869732E5F626F64792C7B616C77617973436F6E73756D654D6F757365576865656C3A21307D292C757228746869732E646F6D4E6F64652C7468';
wwv_flow_imp.g_varchar2_table(27844) := '69732E5F7363726F6C6C6261722E676574446F6D4E6F64652829292C746869732E5F646973706F7361626C65732E61646428746869732E5F7363726F6C6C626172292C746869732E5F6865616465723D757228746869732E5F626F64792C627228222E68';
wwv_flow_imp.g_varchar2_table(27845) := '65616465722229292C746869732E5F636C6F73653D757228746869732E5F6865616465722C627228227370616E222B546C2E617343535353656C6563746F72284C6C2E636C6F73652929292C746869732E5F636C6F73652E7469746C653D6228302C2243';
wwv_flow_imp.g_varchar2_table(27846) := '6C6F736522292C746869732E5F747970653D757228746869732E5F6865616465722C62722822702E747970652229292C746869732E5F646F63733D757228746869732E5F626F64792C62722822702E646F63732229292C746869732E5F636F6E66696775';
wwv_flow_imp.g_varchar2_table(27847) := '7265466F6E7428292C746869732E5F646973706F7361626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E676564283530292626746869732E5F636F';
wwv_flow_imp.g_varchar2_table(27848) := '6E666967757265466F6E7428297D2929297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F72656E646572446973706F736561626C652E646973706F736528297D5F636F6E666967757265';
wwv_flow_imp.g_varchar2_table(27849) := '466F6E7428297B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E7328292C743D652E676574283530292C6E3D742E6765744D61737361676564466F6E7446616D696C7928292C693D652E67657428313139297C7C742E666F6E';
wwv_flow_imp.g_varchar2_table(27850) := '7453697A652C6F3D652E67657428313230297C7C742E6C696E654865696768742C733D742E666F6E745765696768742C723D60247B697D7078602C613D60247B6F7D7078603B746869732E646F6D4E6F64652E7374796C652E666F6E7453697A653D722C';
wwv_flow_imp.g_varchar2_table(27851) := '746869732E646F6D4E6F64652E7374796C652E6C696E654865696768743D22222B6F2F692C746869732E646F6D4E6F64652E7374796C652E666F6E745765696768743D732C746869732E646F6D4E6F64652E7374796C652E666F6E744665617475726553';
wwv_flow_imp.g_varchar2_table(27852) := '657474696E67733D742E666F6E744665617475726553657474696E67732C746869732E5F747970652E7374796C652E666F6E7446616D696C793D6E2C746869732E5F636C6F73652E7374796C652E6865696768743D612C746869732E5F636C6F73652E73';
wwv_flow_imp.g_varchar2_table(27853) := '74796C652E77696474683D617D6765744C61796F7574496E666F28297B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E28313230297C7C746869732E5F656469746F722E6765744F7074696F6E283530292E6C696E65486569';
wwv_flow_imp.g_varchar2_table(27854) := '6768742C743D746869732E5F626F7264657257696474683B72657475726E7B6C696E654865696768743A652C626F7264657257696474683A742C626F726465724865696768743A322A742C766572746963616C50616464696E673A32322C686F72697A6F';
wwv_flow_imp.g_varchar2_table(27855) := '6E74616C50616464696E673A31347D7D72656E6465724C6F6164696E6728297B746869732E5F747970652E74657874436F6E74656E743D6228302C224C6F6164696E672E2E2E22292C746869732E5F646F63732E74657874436F6E74656E743D22222C74';
wwv_flow_imp.g_varchar2_table(27856) := '6869732E646F6D4E6F64652E636C6173734C6973742E72656D6F766528226E6F2D646F6373222C226E6F2D7479706522292C746869732E6C61796F757428746869732E73697A652E77696474682C322A746869732E6765744C61796F7574496E666F2829';
wwv_flow_imp.g_varchar2_table(27857) := '2E6C696E65486569676874292C746869732E5F6F6E4469644368616E6765436F6E74656E74732E666972652874686973297D72656E6465724974656D28652C74297B766172206E2C693B746869732E5F72656E646572446973706F736561626C652E636C';
wwv_flow_imp.g_varchar2_table(27858) := '65617228293B6C65747B64657461696C3A6F2C646F63756D656E746174696F6E3A737D3D652E636F6D706C6574696F6E3B69662874297B6C657420743D22223B742B3D6073636F72653A20247B652E73636F72655B305D7D5C6E602C742B3D6070726566';
wwv_flow_imp.g_varchar2_table(27859) := '69783A20247B6E756C6C213D3D286E3D652E776F7264292626766F69642030213D3D6E3F6E3A22286E6F2070726566697829227D5C6E602C742B3D60776F72643A20247B652E636F6D706C6574696F6E2E66696C746572546578743F652E636F6D706C65';
wwv_flow_imp.g_varchar2_table(27860) := '74696F6E2E66696C746572546578742B22202866696C7465725465787429223A652E746578744C6162656C7D5C6E602C742B3D6064697374616E63653A20247B652E64697374616E63657D20286C6F63616C697479426F6E75732D73657474696E67295C';
wwv_flow_imp.g_varchar2_table(27861) := '6E602C742B3D60696E6465783A20247B652E6964787D2C206261736564206F6E20247B652E636F6D706C6574696F6E2E736F727454657874262660736F7274546578743A2022247B652E636F6D706C6574696F6E2E736F7274546578747D22607C7C226C';
wwv_flow_imp.g_varchar2_table(27862) := '6162656C227D5C6E602C742B3D60636F6D6D69745F63686172733A20247B6E756C6C3D3D3D28693D652E636F6D706C6574696F6E2E636F6D6D697443686172616374657273297C7C766F696420303D3D3D693F766F696420303A692E6A6F696E28222229';
wwv_flow_imp.g_varchar2_table(27863) := '7D5C6E602C733D286E6577206F63292E617070656E64436F6465626C6F636B2822656D707479222C74292C6F3D6050726F76696465723A20247B652E70726F76696465722E5F6465627567446973706C61794E616D657D607D696628747C7C6834286529';
wwv_flow_imp.g_varchar2_table(27864) := '297B696628746869732E646F6D4E6F64652E636C6173734C6973742E72656D6F766528226E6F2D646F6373222C226E6F2D7479706522292C6F297B636F6E737420653D6F2E6C656E6774683E3165353F60247B6F2E73756273747228302C316535297DE2';
wwv_flow_imp.g_varchar2_table(27865) := '80A6603A6F3B746869732E5F747970652E74657874436F6E74656E743D652C746869732E5F747970652E7469746C653D652C5F7228746869732E5F74797065292C746869732E5F747970652E636C6173734C6973742E746F67676C6528226175746F2D77';
wwv_flow_imp.g_varchar2_table(27866) := '726170222C212F5C723F5C6E5E5C732B2F67696D2E74657374286529297D656C736520667328746869732E5F74797065292C746869732E5F747970652E7469746C653D22222C797228746869732E5F74797065292C746869732E646F6D4E6F64652E636C';
wwv_flow_imp.g_varchar2_table(27867) := '6173734C6973742E61646428226E6F2D7479706522293B696628667328746869732E5F646F6373292C22737472696E67223D3D747970656F66207329746869732E5F646F63732E636C6173734C6973742E72656D6F766528226D61726B646F776E2D646F';
wwv_flow_imp.g_varchar2_table(27868) := '637322292C746869732E5F646F63732E74657874436F6E74656E743D733B656C73652069662873297B746869732E5F646F63732E636C6173734C6973742E61646428226D61726B646F776E2D646F637322292C667328746869732E5F646F6373293B636F';
wwv_flow_imp.g_varchar2_table(27869) := '6E737420653D746869732E5F6D61726B646F776E52656E64657265722E72656E6465722873293B746869732E5F646F63732E617070656E644368696C6428652E656C656D656E74292C746869732E5F72656E646572446973706F736561626C652E616464';
wwv_flow_imp.g_varchar2_table(27870) := '2865292C746869732E5F72656E646572446973706F736561626C652E61646428746869732E5F6D61726B646F776E52656E64657265722E6F6E44696452656E6465724173796E63282828293D3E7B746869732E6C61796F757428746869732E5F73697A65';
wwv_flow_imp.g_varchar2_table(27871) := '2E77696474682C746869732E5F747970652E636C69656E744865696768742B746869732E5F646F63732E636C69656E74486569676874292C746869732E5F6F6E4469644368616E6765436F6E74656E74732E666972652874686973297D2929297D746869';
wwv_flow_imp.g_varchar2_table(27872) := '732E646F6D4E6F64652E7374796C652E7573657253656C6563743D2274657874222C746869732E646F6D4E6F64652E746162496E6465783D2D312C746869732E5F636C6F73652E6F6E6D6F757365646F776E3D653D3E7B652E70726576656E7444656661';
wwv_flow_imp.g_varchar2_table(27873) := '756C7428292C652E73746F7050726F7061676174696F6E28297D2C746869732E5F636C6F73652E6F6E636C69636B3D653D3E7B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(27874) := '64436C6F73652E6669726528297D2C746869732E5F626F64792E7363726F6C6C546F703D302C746869732E6C61796F757428746869732E5F73697A652E77696474682C746869732E5F747970652E636C69656E744865696768742B746869732E5F646F63';
wwv_flow_imp.g_varchar2_table(27875) := '732E636C69656E74486569676874292C746869732E5F6F6E4469644368616E6765436F6E74656E74732E666972652874686973297D656C736520746869732E636C656172436F6E74656E747328297D636C656172436F6E74656E747328297B746869732E';
wwv_flow_imp.g_varchar2_table(27876) := '646F6D4E6F64652E636C6173734C6973742E61646428226E6F2D646F637322292C746869732E5F747970652E74657874436F6E74656E743D22222C746869732E5F646F63732E74657874436F6E74656E743D22227D676574206973456D70747928297B72';
wwv_flow_imp.g_varchar2_table(27877) := '657475726E20746869732E646F6D4E6F64652E636C6173734C6973742E636F6E7461696E7328226E6F2D646F637322297D6765742073697A6528297B72657475726E20746869732E5F73697A657D6C61796F757428652C74297B636F6E7374206E3D6E65';
wwv_flow_imp.g_varchar2_table(27878) := '7720497328652C74293B49732E657175616C73286E2C746869732E5F73697A65297C7C28746869732E5F73697A653D6E2C66756E6374696F6E28652C742C6E297B226E756D626572223D3D747970656F662074262628652E7374796C652E77696474683D';
wwv_flow_imp.g_varchar2_table(27879) := '60247B747D707860292C226E756D626572223D3D747970656F66206E262628652E7374796C652E6865696768743D60247B6E7D707860297D28746869732E646F6D4E6F64652C652C7429292C746869732E5F7363726F6C6C6261722E7363616E446F6D4E';
wwv_flow_imp.g_varchar2_table(27880) := '6F646528297D7363726F6C6C446F776E28653D38297B746869732E5F626F64792E7363726F6C6C546F702B3D657D7363726F6C6C557028653D38297B746869732E5F626F64792E7363726F6C6C546F702D3D657D7363726F6C6C546F7028297B74686973';
wwv_flow_imp.g_varchar2_table(27881) := '2E5F626F64792E7363726F6C6C546F703D307D7363726F6C6C426F74746F6D28297B746869732E5F626F64792E7363726F6C6C546F703D746869732E5F626F64792E7363726F6C6C4865696768747D70616765446F776E28297B746869732E7363726F6C';
wwv_flow_imp.g_varchar2_table(27882) := '6C446F776E283830297D70616765557028297B746869732E7363726F6C6C5570283830297D73657420626F7264657257696474682865297B746869732E5F626F7264657257696474683D657D67657420626F72646572576964746828297B72657475726E';
wwv_flow_imp.g_varchar2_table(27883) := '20746869732E5F626F7264657257696474687D7D3B75343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50';
wwv_flow_imp.g_varchar2_table(27884) := '726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E';
wwv_flow_imp.g_varchar2_table(27885) := '6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C7229';
wwv_flow_imp.g_varchar2_table(27886) := '3B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28312C756329';
wwv_flow_imp.g_varchar2_table(27887) := '5D2C7534293B636C6173732070347B636F6E7374727563746F7228652C74297B6C6574206E2C693B746869732E7769646765743D652C746869732E5F656469746F723D742C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869';
wwv_flow_imp.g_varchar2_table(27888) := '732E5F646973706F7361626C65733D6E65772061742C746869732E5F61646465643D21312C746869732E5F707265666572416C69676E4174546F703D21302C746869732E5F726573697A61626C653D6E65772064712C746869732E5F726573697A61626C';
wwv_flow_imp.g_varchar2_table(27889) := '652E646F6D4E6F64652E636C6173734C6973742E6164642822737567676573742D64657461696C732D636F6E7461696E657222292C746869732E5F726573697A61626C652E646F6D4E6F64652E617070656E644368696C6428652E646F6D4E6F6465292C';
wwv_flow_imp.g_varchar2_table(27890) := '746869732E5F726573697A61626C652E656E61626C655361736865732821312C21302C21302C2131293B6C6574206F3D302C733D303B746869732E5F646973706F7361626C65732E61646428746869732E5F726573697A61626C652E6F6E44696457696C';
wwv_flow_imp.g_varchar2_table(27891) := '6C526573697A65282828293D3E7B6E3D746869732E5F746F704C6566742C693D746869732E5F726573697A61626C652E73697A657D2929292C746869732E5F646973706F7361626C65732E61646428746869732E5F726573697A61626C652E6F6E446964';
wwv_flow_imp.g_varchar2_table(27892) := '526573697A652828653D3E7B6966286E262669297B746869732E7769646765742E6C61796F757428652E64696D656E73696F6E2E77696474682C652E64696D656E73696F6E2E686569676874293B6C657420743D21313B652E77657374262628733D692E';
wwv_flow_imp.g_varchar2_table(27893) := '77696474682D652E64696D656E73696F6E2E77696474682C743D2130292C652E6E6F7274682626286F3D692E6865696768742D652E64696D656E73696F6E2E6865696768742C743D2130292C742626746869732E5F6170706C79546F704C656674287B74';
wwv_flow_imp.g_varchar2_table(27894) := '6F703A6E2E746F702B6F2C6C6566743A6E2E6C6566742B737D297D652E646F6E652626286E3D766F696420302C693D766F696420302C6F3D302C733D302C746869732E5F7573657253697A653D652E64696D656E73696F6E297D2929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(27895) := '646973706F7361626C65732E61646428746869732E7769646765742E6F6E4469644368616E6765436F6E74656E7473282828293D3E7B76617220653B746869732E5F616E63686F72426F782626746869732E5F706C6163654174416E63686F7228746869';
wwv_flow_imp.g_varchar2_table(27896) := '732E5F616E63686F72426F782C6E756C6C213D3D28653D746869732E5F7573657253697A65292626766F69642030213D3D653F653A746869732E7769646765742E73697A652C746869732E5F707265666572416C69676E4174546F70297D2929297D6469';
wwv_flow_imp.g_varchar2_table(27897) := '73706F736528297B746869732E5F726573697A61626C652E646973706F736528292C746869732E5F646973706F7361626C65732E646973706F736528292C746869732E6869646528297D676574496428297B72657475726E22737567676573742E646574';
wwv_flow_imp.g_varchar2_table(27898) := '61696C73227D676574446F6D4E6F646528297B72657475726E20746869732E5F726573697A61626C652E646F6D4E6F64657D676574506F736974696F6E28297B72657475726E20746869732E5F746F704C6566743F7B707265666572656E63653A746869';
wwv_flow_imp.g_varchar2_table(27899) := '732E5F746F704C6566747D3A6E756C6C7D73686F7728297B746869732E5F61646465647C7C28746869732E5F656469746F722E6164644F7665726C61795769646765742874686973292C746869732E5F61646465643D2130297D6869646528653D213129';
wwv_flow_imp.g_varchar2_table(27900) := '7B746869732E5F726573697A61626C652E636C65617253617368486F766572537461746528292C746869732E5F6164646564262628746869732E5F656469746F722E72656D6F76654F7665726C61795769646765742874686973292C746869732E5F6164';
wwv_flow_imp.g_varchar2_table(27901) := '6465643D21312C746869732E5F616E63686F72426F783D766F696420302C746869732E5F746F704C6566743D766F69642030292C65262628746869732E5F7573657253697A653D766F696420302C746869732E7769646765742E636C656172436F6E7465';
wwv_flow_imp.g_varchar2_table(27902) := '6E74732829297D706C6163654174416E63686F7228652C74297B766172206E3B636F6E737420693D652E676574426F756E64696E67436C69656E745265637428293B746869732E5F616E63686F72426F783D692C746869732E5F707265666572416C6967';
wwv_flow_imp.g_varchar2_table(27903) := '6E4174546F703D742C746869732E5F706C6163654174416E63686F7228746869732E5F616E63686F72426F782C6E756C6C213D3D286E3D746869732E5F7573657253697A65292626766F69642030213D3D6E3F6E3A746869732E7769646765742E73697A';
wwv_flow_imp.g_varchar2_table(27904) := '652C74297D5F706C6163654174416E63686F7228652C742C6E297B76617220693B636F6E7374206F3D447328746869732E676574446F6D4E6F646528292E6F776E6572446F63756D656E742E626F6479292C733D746869732E7769646765742E6765744C';
wwv_flow_imp.g_varchar2_table(27905) := '61796F7574496E666F28292C723D6E6577204973283232302C322A732E6C696E65486569676874292C613D652E746F702C6C3D66756E6374696F6E28297B636F6E7374206E3D6F2E77696474682D28652E6C6566742B652E77696474682B732E626F7264';
wwv_flow_imp.g_varchar2_table(27906) := '657257696474682B732E686F72697A6F6E74616C50616464696E67292C693D2D732E626F7264657257696474682B652E6C6566742B652E77696474682C6C3D6E6577204973286E2C6F2E6865696768742D652E746F702D732E626F726465724865696768';
wwv_flow_imp.g_varchar2_table(27907) := '742D732E766572746963616C50616464696E67292C633D6C2E7769746828766F696420302C652E746F702B652E6865696768742D732E626F726465724865696768742D732E766572746963616C50616464696E67293B72657475726E7B746F703A612C6C';
wwv_flow_imp.g_varchar2_table(27908) := '6566743A692C6669743A6E2D742E77696474682C6D617853697A65546F703A6C2C6D617853697A65426F74746F6D3A632C6D696E53697A653A722E77697468284D6174682E6D696E286E2C722E776964746829297D7D28292C633D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(27909) := '297B636F6E7374206E3D652E6C6566742D732E626F7264657257696474682D732E686F72697A6F6E74616C50616464696E672C693D4D6174682E6D617828732E686F72697A6F6E74616C50616464696E672C652E6C6566742D742E77696474682D732E62';
wwv_flow_imp.g_varchar2_table(27910) := '6F726465725769647468292C6C3D6E6577204973286E2C6F2E6865696768742D652E746F702D732E626F726465724865696768742D732E766572746963616C50616464696E67292C633D6C2E7769746828766F696420302C652E746F702B652E68656967';
wwv_flow_imp.g_varchar2_table(27911) := '68742D732E626F726465724865696768742D732E766572746963616C50616464696E67293B72657475726E7B746F703A612C6C6566743A692C6669743A6E2D742E77696474682C6D617853697A65546F703A6C2C6D617853697A65426F74746F6D3A632C';
wwv_flow_imp.g_varchar2_table(27912) := '6D696E53697A653A722E77697468284D6174682E6D696E286E2C722E776964746829297D7D28292C643D66756E6374696F6E28297B636F6E7374206E3D652E6C6566742C693D2D732E626F7264657257696474682B652E746F702B652E6865696768742C';
wwv_flow_imp.g_varchar2_table(27913) := '613D6E657720497328652E77696474682D732E626F726465724865696768742C6F2E6865696768742D652E746F702D652E6865696768742D732E766572746963616C50616464696E67293B72657475726E7B746F703A692C6C6566743A6E2C6669743A61';
wwv_flow_imp.g_varchar2_table(27914) := '2E6865696768742D742E6865696768742C6D617853697A65426F74746F6D3A612C6D617853697A65546F703A612C6D696E53697A653A722E7769746828612E7769647468297D7D28292C683D5B6C2C632C645D2C753D6E756C6C213D3D28693D682E6669';
wwv_flow_imp.g_varchar2_table(27915) := '6E642828653D3E652E6669743E3D302929292626766F69642030213D3D693F693A682E736F7274282828652C74293D3E742E6669742D652E66697429295B305D2C703D652E746F702B652E6865696768742D732E626F726465724865696768743B6C6574';
wwv_flow_imp.g_varchar2_table(27916) := '20672C6D3D742E6865696768743B636F6E737420663D4D6174682E6D617828752E6D617853697A65546F702E6865696768742C752E6D617853697A65426F74746F6D2E686569676874293B6C657420763B6D3E662626286D3D66292C6E3F6D3C3D752E6D';
wwv_flow_imp.g_varchar2_table(27917) := '617853697A65546F702E6865696768743F28673D21302C763D752E6D617853697A65546F70293A28673D21312C763D752E6D617853697A65426F74746F6D293A6D3C3D752E6D617853697A65426F74746F6D2E6865696768743F28673D21312C763D752E';
wwv_flow_imp.g_varchar2_table(27918) := '6D617853697A65426F74746F6D293A28673D21302C763D752E6D617853697A65546F70293B6C65747B746F703A622C6C6566743A5F7D3D753B216726266D3E652E686569676874262628623D702D6D293B636F6E737420793D746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(27919) := '722E676574446F6D4E6F646528293B69662879297B636F6E737420653D792E676574426F756E64696E67436C69656E745265637428293B622D3D652E746F702C5F2D3D652E6C6566747D746869732E5F6170706C79546F704C656674287B6C6566743A5F';
wwv_flow_imp.g_varchar2_table(27920) := '2C746F703A627D292C746869732E5F726573697A61626C652E656E61626C655361736865732821672C753D3D3D6C2C672C75213D3D6C292C746869732E5F726573697A61626C652E6D696E53697A653D752E6D696E53697A652C746869732E5F72657369';
wwv_flow_imp.g_varchar2_table(27921) := '7A61626C652E6D617853697A653D762C746869732E5F726573697A61626C652E6C61796F7574286D2C4D6174682E6D696E28762E77696474682C742E776964746829292C746869732E7769646765742E6C61796F757428746869732E5F726573697A6162';
wwv_flow_imp.g_varchar2_table(27922) := '6C652E73697A652E77696474682C746869732E5F726573697A61626C652E73697A652E686569676874297D5F6170706C79546F704C6566742865297B746869732E5F746F704C6566743D652C746869732E5F656469746F722E6C61796F75744F7665726C';
wwv_flow_imp.g_varchar2_table(27923) := '61795769646765742874686973297D7D7661722067343B2166756E6374696F6E2865297B655B652E46494C453D305D3D2246494C45222C655B652E464F4C4445523D315D3D22464F4C444552222C655B652E524F4F545F464F4C4445523D325D3D22524F';
wwv_flow_imp.g_varchar2_table(27924) := '4F545F464F4C444552227D2867347C7C2867343D7B7D29293B636F6E7374206D343D2F283F3A5C2F7C5E29283F3A285B5E5C2F5D2B295C2F293F285B5E5C2F5D2B29242F3B66756E6374696F6E20663428652C742C6E2C692C6F297B6966286F29726574';
wwv_flow_imp.g_varchar2_table(27925) := '75726E5B60636F6469636F6E2D247B6F2E69647D602C22707265646566696E65642D66696C652D69636F6E225D3B636F6E737420733D693D3D3D67342E524F4F545F464F4C4445523F5B22726F6F74666F6C6465722D69636F6E225D3A693D3D3D67342E';
wwv_flow_imp.g_varchar2_table(27926) := '464F4C4445523F5B22666F6C6465722D69636F6E225D3A5B2266696C652D69636F6E225D3B6966286E297B6C6574206F3B6966286E2E736368656D653D3D3D716F2E64617461296F3D69632E70617273654D65746144617461286E292E6765742869632E';
wwv_flow_imp.g_varchar2_table(27927) := '4D4554415F444154415F4C4142454C293B656C73657B636F6E737420653D6E2E706174682E6D61746368286D34293B653F286F3D763428655B325D2E746F4C6F776572436173652829292C655B315D2626732E707573682860247B763428655B315D2E74';
wwv_flow_imp.g_varchar2_table(27928) := '6F4C6F776572436173652829297D2D6E616D652D6469722D69636F6E6029293A6F3D7634286E2E617574686F726974792E746F4C6F776572436173652829297D696628693D3D3D67342E524F4F545F464F4C44455229732E707573682860247B6F7D2D72';
wwv_flow_imp.g_varchar2_table(27929) := '6F6F742D6E616D652D666F6C6465722D69636F6E60293B656C736520696628693D3D3D67342E464F4C44455229732E707573682860247B6F7D2D6E616D652D666F6C6465722D69636F6E60293B656C73657B6966286F297B696628732E70757368286024';
wwv_flow_imp.g_varchar2_table(27930) := '7B6F7D2D6E616D652D66696C652D69636F6E60292C732E7075736828226E616D652D66696C652D69636F6E22292C6F2E6C656E6774683C3D323535297B636F6E737420653D6F2E73706C697428222E22293B666F72286C657420743D313B743C652E6C65';
wwv_flow_imp.g_varchar2_table(27931) := '6E6774683B742B2B29732E707573682860247B652E736C6963652874292E6A6F696E28222E22297D2D6578742D66696C652D69636F6E60297D732E7075736828226578742D66696C652D69636F6E22297D636F6E737420693D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(27932) := '742C6E297B696628216E2972657475726E206E756C6C3B6C657420693D6E756C6C3B6966286E2E736368656D653D3D3D716F2E64617461297B636F6E737420653D69632E70617273654D65746144617461286E292E6765742869632E4D4554415F444154';
wwv_flow_imp.g_varchar2_table(27933) := '415F4D494D45293B65262628693D742E6765744C616E6775616765496442794D696D6554797065286529297D656C73657B636F6E737420743D652E6765744D6F64656C286E293B74262628693D742E6765744C616E677561676549642829297D72657475';
wwv_flow_imp.g_varchar2_table(27934) := '726E2069262669213D3D55703F693A742E67756573734C616E67756167654964427946696C65706174684F7246697273744C696E65286E297D28652C742C6E293B692626732E707573682860247B76342869297D2D6C616E672D66696C652D69636F6E60';
wwv_flow_imp.g_varchar2_table(27935) := '297D7D72657475726E20737D66756E6374696F6E2076342865297B72657475726E20652E7265706C616365282F5B5C31315C31325C31345C31355C34305D2F672C222F22297D7661722062342C5F343D66756E6374696F6E28652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(27936) := '2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E2079342865297B72657475726E60737567676573742D617269612D69643A247B657D607D636F6E73742077343D54572822737567676573742D6D6F72652D696E666F';
wwv_flow_imp.g_varchar2_table(27937) := '222C4C6C2E63686576726F6E52696768742C6228302C2249636F6E20666F72206D6F726520696E666F726D6174696F6E20696E207468652073756767657374207769646765742E2229292C43343D6E6577282862343D636C6173737B6578747261637428';
wwv_flow_imp.g_varchar2_table(27938) := '652C74297B696628652E746578744C6162656C2E6D617463682862342E5F7265676578537472696374292972657475726E20745B305D3D652E746578744C6162656C2C21303B696628652E636F6D706C6574696F6E2E64657461696C2626652E636F6D70';
wwv_flow_imp.g_varchar2_table(27939) := '6C6574696F6E2E64657461696C2E6D617463682862342E5F7265676578537472696374292972657475726E20745B305D3D652E636F6D706C6574696F6E2E64657461696C2C21303B696628652E636F6D706C6574696F6E2E646F63756D656E746174696F';
wwv_flow_imp.g_varchar2_table(27940) := '6E297B636F6E7374206E3D22737472696E67223D3D747970656F6620652E636F6D706C6574696F6E2E646F63756D656E746174696F6E3F652E636F6D706C6574696F6E2E646F63756D656E746174696F6E3A652E636F6D706C6574696F6E2E646F63756D';
wwv_flow_imp.g_varchar2_table(27941) := '656E746174696F6E2E76616C75652C693D62342E5F726567657852656C617865642E65786563286E293B69662869262628303D3D3D692E696E6465787C7C692E696E6465782B695B305D2E6C656E6774683D3D3D6E2E6C656E677468292972657475726E';
wwv_flow_imp.g_varchar2_table(27942) := '20745B305D3D695B305D2C21307D72657475726E21317D7D292E5F726567657852656C617865643D2F2823285B5C64612D66412D465D7B337D297B312C327D7C287267627C68736C29615C285C732A285C647B312C337D253F5C732A2C5C732A297B337D';
wwv_flow_imp.g_varchar2_table(27943) := '28317C303F5C2E5C642B295C297C287267627C68736C295C285C732A5C647B312C337D253F285C732A2C5C732A5C647B312C337D253F297B327D5C732A5C29292F2C62342E5F72656765785374726963743D6E65772052656745787028605E247B62342E';
wwv_flow_imp.g_varchar2_table(27944) := '5F726567657852656C617865642E736F757263657D24602C226922292C6234293B6C65742053343D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F656469746F723D652C746869732E5F6D6F64656C53657276696365';
wwv_flow_imp.g_varchar2_table(27945) := '3D742C746869732E5F6C616E6775616765536572766963653D6E2C746869732E5F7468656D65536572766963653D692C746869732E5F6F6E446964546F67676C6544657461696C733D6E65772043742C746869732E6F6E446964546F67676C6544657461';
wwv_flow_imp.g_varchar2_table(27946) := '696C733D746869732E5F6F6E446964546F67676C6544657461696C732E6576656E742C746869732E74656D706C61746549643D2273756767657374696F6E227D646973706F736528297B746869732E5F6F6E446964546F67676C6544657461696C732E64';
wwv_flow_imp.g_varchar2_table(27947) := '6973706F736528297D72656E64657254656D706C6174652865297B636F6E737420743D6E65772061742C6E3D653B6E2E636C6173734C6973742E616464282273686F772D66696C652D69636F6E7322293B636F6E737420693D757228652C627228222E69';
wwv_flow_imp.g_varchar2_table(27948) := '636F6E2229292C6F3D757228692C627228227370616E2E636F6C6F727370616E2229292C733D757228652C627228222E636F6E74656E74732229292C723D757228732C627228222E6D61696E2229292C613D757228722C627228222E69636F6E2D6C6162';
wwv_flow_imp.g_varchar2_table(27949) := '656C2E636F6469636F6E2229292C6C3D757228722C627228227370616E2E6C6566742229292C633D757228722C627228227370616E2E72696768742229292C643D6E6577207147286C2C7B737570706F7274486967686C69676874733A21302C73757070';
wwv_flow_imp.g_varchar2_table(27950) := '6F727449636F6E733A21307D293B742E6164642864293B636F6E737420683D7572286C2C627228227370616E2E7369676E61747572652D6C6162656C2229292C753D7572286C2C627228227370616E2E7175616C69666965722D6C6162656C2229292C70';
wwv_flow_imp.g_varchar2_table(27951) := '3D757228632C627228227370616E2E64657461696C732D6C6162656C2229292C673D757228632C627228227370616E2E726561644D6F7265222B546C2E617343535353656C6563746F722877342929293B72657475726E20672E7469746C653D6228302C';
wwv_flow_imp.g_varchar2_table(27952) := '2252656164204D6F726522292C7B726F6F743A6E2C6C6566743A6C2C72696768743A632C69636F6E3A692C636F6C6F727370616E3A6F2C69636F6E4C6162656C3A642C69636F6E436F6E7461696E65723A612C706172616D65746572734C6162656C3A68';
wwv_flow_imp.g_varchar2_table(27953) := '2C7175616C69666965724C6162656C3A752C64657461696C734C6162656C3A702C726561644D6F72653A672C646973706F7361626C65733A742C636F6E666967757265466F6E743A28293D3E7B636F6E737420653D746869732E5F656469746F722E6765';
wwv_flow_imp.g_varchar2_table(27954) := '744F7074696F6E7328292C743D652E676574283530292C6F3D742E6765744D61737361676564466F6E7446616D696C7928292C733D742E666F6E744665617475726553657474696E67732C613D652E67657428313139297C7C742E666F6E7453697A652C';
wwv_flow_imp.g_varchar2_table(27955) := '6C3D652E67657428313230297C7C742E6C696E654865696768742C633D742E666F6E745765696768742C643D60247B617D7078602C683D60247B6C7D7078602C753D60247B742E6C657474657253706163696E677D7078603B6E2E7374796C652E666F6E';
wwv_flow_imp.g_varchar2_table(27956) := '7453697A653D642C6E2E7374796C652E666F6E745765696768743D632C6E2E7374796C652E6C657474657253706163696E673D752C722E7374796C652E666F6E7446616D696C793D6F2C722E7374796C652E666F6E744665617475726553657474696E67';
wwv_flow_imp.g_varchar2_table(27957) := '733D732C722E7374796C652E6C696E654865696768743D682C692E7374796C652E6865696768743D682C692E7374796C652E77696474683D682C672E7374796C652E6865696768743D682C672E7374796C652E77696474683D687D7D7D72656E64657245';
wwv_flow_imp.g_varchar2_table(27958) := '6C656D656E7428652C742C6E297B6E2E636F6E666967757265466F6E7428293B636F6E73747B636F6D706C6574696F6E3A697D3D653B6E2E726F6F742E69643D79342874292C6E2E636F6C6F727370616E2E7374796C652E6261636B67726F756E64436F';
wwv_flow_imp.g_varchar2_table(27959) := '6C6F723D22223B636F6E7374206F3D7B6C6162656C4573636170654E65774C696E65733A21302C6D6174636865733A246128652E73636F7265297D2C733D5B5D3B69662831393D3D3D692E6B696E64262643342E6578747261637428652C7329296E2E69';
wwv_flow_imp.g_varchar2_table(27960) := '636F6E2E636C6173734E616D653D2269636F6E20637573746F6D636F6C6F72222C6E2E69636F6E436F6E7461696E65722E636C6173734E616D653D2269636F6E2068696465222C6E2E636F6C6F727370616E2E7374796C652E6261636B67726F756E6443';
wwv_flow_imp.g_varchar2_table(27961) := '6F6C6F723D735B305D3B656C73652069662832303D3D3D692E6B696E642626746869732E5F7468656D65536572766963652E67657446696C6549636F6E5468656D6528292E68617346696C6549636F6E73297B6E2E69636F6E2E636C6173734E616D653D';
wwv_flow_imp.g_varchar2_table(27962) := '2269636F6E2068696465222C6E2E69636F6E436F6E7461696E65722E636C6173734E616D653D2269636F6E2068696465223B636F6E737420743D663428746869732E5F6D6F64656C536572766963652C746869732E5F6C616E6775616765536572766963';
wwv_flow_imp.g_varchar2_table(27963) := '652C4E6F2E66726F6D287B736368656D653A2266616B65222C706174683A652E746578744C6162656C7D292C67342E46494C45292C733D663428746869732E5F6D6F64656C536572766963652C746869732E5F6C616E6775616765536572766963652C4E';
wwv_flow_imp.g_varchar2_table(27964) := '6F2E66726F6D287B736368656D653A2266616B65222C706174683A692E64657461696C7D292C67342E46494C45293B6F2E6578747261436C61737365733D742E6C656E6774683E732E6C656E6774683F743A737D656C73652032333D3D3D692E6B696E64';
wwv_flow_imp.g_varchar2_table(27965) := '2626746869732E5F7468656D65536572766963652E67657446696C6549636F6E5468656D6528292E686173466F6C64657249636F6E733F286E2E69636F6E2E636C6173734E616D653D2269636F6E2068696465222C6E2E69636F6E436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(27966) := '2E636C6173734E616D653D2269636F6E2068696465222C6F2E6578747261436C61737365733D5B663428746869732E5F6D6F64656C536572766963652C746869732E5F6C616E6775616765536572766963652C4E6F2E66726F6D287B736368656D653A22';
wwv_flow_imp.g_varchar2_table(27967) := '66616B65222C706174683A652E746578744C6162656C7D292C67342E464F4C444552292C663428746869732E5F6D6F64656C536572766963652C746869732E5F6C616E6775616765536572766963652C4E6F2E66726F6D287B736368656D653A2266616B';
wwv_flow_imp.g_varchar2_table(27968) := '65222C706174683A692E64657461696C7D292C67342E464F4C444552295D2E666C61742829293A286E2E69636F6E2E636C6173734E616D653D2269636F6E2068696465222C6E2E69636F6E436F6E7461696E65722E636C6173734E616D653D22222C6E2E';
wwv_flow_imp.g_varchar2_table(27969) := '69636F6E436F6E7461696E65722E636C6173734C6973742E6164642822737567676573742D69636F6E222C2E2E2E546C2E6173436C6173734E616D6541727261792879772E746F49636F6E28692E6B696E64292929293B692E746167732626692E746167';
wwv_flow_imp.g_varchar2_table(27970) := '732E696E6465784F662831293E3D302626286F2E6578747261436C61737365733D286F2E6578747261436C61737365737C7C5B5D292E636F6E636174285B2264657072656361746564225D292C6F2E6D6174636865733D5B5D292C6E2E69636F6E4C6162';
wwv_flow_imp.g_varchar2_table(27971) := '656C2E7365744C6162656C28652E746578744C6162656C2C766F696420302C6F292C22737472696E67223D3D747970656F6620692E6C6162656C3F286E2E706172616D65746572734C6162656C2E74657874436F6E74656E743D22222C6E2E6465746169';
wwv_flow_imp.g_varchar2_table(27972) := '6C734C6162656C2E74657874436F6E74656E743D783428692E64657461696C7C7C2222292C6E2E726F6F742E636C6173734C6973742E6164642822737472696E672D6C6162656C2229293A286E2E706172616D65746572734C6162656C2E74657874436F';
wwv_flow_imp.g_varchar2_table(27973) := '6E74656E743D783428692E6C6162656C2E64657461696C7C7C2222292C6E2E64657461696C734C6162656C2E74657874436F6E74656E743D783428692E6C6162656C2E6465736372697074696F6E7C7C2222292C6E2E726F6F742E636C6173734C697374';
wwv_flow_imp.g_varchar2_table(27974) := '2E72656D6F76652822737472696E672D6C6162656C2229292C746869732E5F656469746F722E6765744F7074696F6E28313138292E73686F77496E6C696E6544657461696C733F5F72286E2E64657461696C734C6162656C293A7972286E2E6465746169';
wwv_flow_imp.g_varchar2_table(27975) := '6C734C6162656C292C68342865293F286E2E72696768742E636C6173734C6973742E616464282263616E2D657870616E642D64657461696C7322292C5F72286E2E726561644D6F7265292C6E2E726561644D6F72652E6F6E6D6F757365646F776E3D653D';
wwv_flow_imp.g_varchar2_table(27976) := '3E7B652E73746F7050726F7061676174696F6E28292C652E70726576656E7444656661756C7428297D2C6E2E726561644D6F72652E6F6E636C69636B3D653D3E7B652E73746F7050726F7061676174696F6E28292C652E70726576656E7444656661756C';
wwv_flow_imp.g_varchar2_table(27977) := '7428292C746869732E5F6F6E446964546F67676C6544657461696C732E6669726528297D293A286E2E72696768742E636C6173734C6973742E72656D6F7665282263616E2D657870616E642D64657461696C7322292C7972286E2E726561644D6F726529';
wwv_flow_imp.g_varchar2_table(27978) := '2C6E2E726561644D6F72652E6F6E6D6F757365646F776E3D6E756C6C2C6E2E726561644D6F72652E6F6E636C69636B3D6E756C6C297D646973706F736554656D706C6174652865297B652E646973706F7361626C65732E646973706F736528297D7D3B66';
wwv_flow_imp.g_varchar2_table(27979) := '756E6374696F6E2078342865297B72657475726E20652E7265706C616365282F5C725C6E7C5C727C5C6E2F672C2222297D53343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C33';
wwv_flow_imp.g_varchar2_table(27980) := '3F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(27981) := '205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F';
wwv_flow_imp.g_varchar2_table(27982) := '2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B5F3428312C6663292C5F3428322C4C75292C5F3428332C';
wwv_flow_imp.g_varchar2_table(27983) := '5062295D2C5334293B766172206B342C45343D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B4C6D2822656469746F72537567676573745769646765742E6261636B67726F756E6422';
wwv_flow_imp.g_varchar2_table(27984) := '2C7B6461726B3A586D2C6C696768743A586D2C68634461726B3A586D2C68634C696768743A586D7D2C6228302C224261636B67726F756E6420636F6C6F72206F66207468652073756767657374207769646765742E2229292C4C6D2822656469746F7253';
wwv_flow_imp.g_varchar2_table(27985) := '7567676573745769646765742E626F72646572222C7B6461726B3A65662C6C696768743A65662C68634461726B3A65662C68634C696768743A65667D2C6228302C22426F7264657220636F6C6F72206F6620746865207375676765737420776964676574';
wwv_flow_imp.g_varchar2_table(27986) := '2E2229293B636F6E7374204C343D4C6D2822656469746F72537567676573745769646765742E666F726567726F756E64222C7B6461726B3A5A6D2C6C696768743A5A6D2C68634461726B3A5A6D2C68634C696768743A5A6D7D2C6228302C22466F726567';
wwv_flow_imp.g_varchar2_table(27987) := '726F756E6420636F6C6F72206F66207468652073756767657374207769646765742E2229293B4C6D2822656469746F72537567676573745769646765742E73656C6563746564466F726567726F756E64222C7B6461726B3A44622C6C696768743A44622C';
wwv_flow_imp.g_varchar2_table(27988) := '68634461726B3A44622C68634C696768743A44627D2C6228302C22466F726567726F756E6420636F6C6F72206F66207468652073656C656374656420656E74727920696E207468652073756767657374207769646765742E2229292C4C6D282265646974';
wwv_flow_imp.g_varchar2_table(27989) := '6F72537567676573745769646765742E73656C656374656449636F6E466F726567726F756E64222C7B6461726B3A54622C6C696768743A54622C68634461726B3A54622C68634C696768743A54627D2C6228302C2249636F6E20666F726567726F756E64';
wwv_flow_imp.g_varchar2_table(27990) := '20636F6C6F72206F66207468652073656C656374656420656E74727920696E207468652073756767657374207769646765742E2229293B636F6E73742044343D4C6D2822656469746F72537567676573745769646765742E73656C65637465644261636B';
wwv_flow_imp.g_varchar2_table(27991) := '67726F756E64222C7B6461726B3A49622C6C696768743A49622C68634461726B3A49622C68634C696768743A49627D2C6228302C224261636B67726F756E6420636F6C6F72206F66207468652073656C656374656420656E74727920696E207468652073';
wwv_flow_imp.g_varchar2_table(27992) := '756767657374207769646765742E2229293B4C6D2822656469746F72537567676573745769646765742E686967686C69676874466F726567726F756E64222C7B6461726B3A69622C6C696768743A69622C68634461726B3A69622C68634C696768743A69';
wwv_flow_imp.g_varchar2_table(27993) := '627D2C6228302C22436F6C6F72206F6620746865206D6174636820686967686C696768747320696E207468652073756767657374207769646765742E2229292C4C6D2822656469746F72537567676573745769646765742E666F637573486967686C6967';
wwv_flow_imp.g_varchar2_table(27994) := '6874466F726567726F756E64222C7B6461726B3A6F622C6C696768743A6F622C68634461726B3A6F622C68634C696768743A6F627D2C6228302C22436F6C6F72206F6620746865206D6174636820686967686C696768747320696E207468652073756767';
wwv_flow_imp.g_varchar2_table(27995) := '65737420776964676574207768656E20616E206974656D20697320666F63757365642E2229292C4C6D2822656469746F72537567676573745769646765745374617475732E666F726567726F756E64222C7B6461726B3A496D284C342C2E35292C6C6967';
wwv_flow_imp.g_varchar2_table(27996) := '68743A496D284C342C2E35292C68634461726B3A496D284C342C2E35292C68634C696768743A496D284C342C2E35297D2C6228302C22466F726567726F756E6420636F6C6F72206F6620746865207375676765737420776964676574207374617475732E';
wwv_flow_imp.g_varchar2_table(27997) := '2229293B636C6173732054347B636F6E7374727563746F7228652C74297B746869732E5F736572766963653D652C746869732E5F6B65793D60737567676573745769646765742E73697A652F247B742E676574456469746F725479706528297D2F247B74';
wwv_flow_imp.g_varchar2_table(27998) := '20696E7374616E63656F662069247D607D726573746F726528297B76617220653B636F6E737420743D6E756C6C213D3D28653D746869732E5F736572766963652E67657428746869732E5F6B65792C3029292626766F69642030213D3D653F653A22223B';
wwv_flow_imp.g_varchar2_table(27999) := '7472797B636F6E737420653D4A534F4E2E70617273652874293B69662849732E69732865292972657475726E2049732E6C6966742865297D63617463682865297B7D7D73746F72652865297B746869732E5F736572766963652E73746F72652874686973';
wwv_flow_imp.g_varchar2_table(28000) := '2E5F6B65792C4A534F4E2E737472696E676966792865292C302C31297D726573657428297B746869732E5F736572766963652E72656D6F766528746869732E5F6B65792C30297D7D6C65742049343D6B343D636C6173737B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(28001) := '652C742C6E2C692C6F297B746869732E656469746F723D652C746869732E5F73746F72616765536572766963653D742C746869732E5F73746174653D302C746869732E5F69734175746F3D21312C746869732E5F70656E64696E674C61796F75743D6E65';
wwv_flow_imp.g_varchar2_table(28002) := '772063742C746869732E5F70656E64696E6753686F7744657461696C733D6E65772063742C746869732E5F69676E6F7265466F6375734576656E74733D21312C746869732E5F666F72636552656E646572696E6741626F76653D21312C746869732E5F65';
wwv_flow_imp.g_varchar2_table(28003) := '78706C61696E4D6F64653D21312C746869732E5F73686F7754696D656F75743D6E65772024742C746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F6F6E44696453656C6563743D6E65772078742C746869732E5F6F6E446964';
wwv_flow_imp.g_varchar2_table(28004) := '466F6375733D6E65772078742C746869732E5F6F6E446964486964653D6E65772043742C746869732E5F6F6E44696453686F773D6E65772043742C746869732E6F6E44696453656C6563743D746869732E5F6F6E44696453656C6563742E6576656E742C';
wwv_flow_imp.g_varchar2_table(28005) := '746869732E6F6E446964466F6375733D746869732E5F6F6E446964466F6375732E6576656E742C746869732E6F6E446964486964653D746869732E5F6F6E446964486964652E6576656E742C746869732E6F6E44696453686F773D746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(28006) := '696453686F772E6576656E742C746869732E5F6F6E44657461696C734B6579646F776E3D6E65772043742C746869732E6F6E44657461696C734B6579446F776E3D746869732E5F6F6E44657461696C734B6579646F776E2E6576656E742C746869732E65';
wwv_flow_imp.g_varchar2_table(28007) := '6C656D656E743D6E65772064712C746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E6164642822656469746F722D776964676574222C22737567676573742D77696467657422292C746869732E5F636F6E74656E7457696467';
wwv_flow_imp.g_varchar2_table(28008) := '65743D6E6577204D3428746869732C65292C746869732E5F70657273697374656453697A653D6E657720543428742C65293B636C61737320737B636F6E7374727563746F7228652C742C6E3D21312C693D2131297B746869732E70657273697374656453';
wwv_flow_imp.g_varchar2_table(28009) := '697A653D652C746869732E63757272656E7453697A653D742C746869732E706572736973744865696768743D6E2C746869732E7065727369737457696474683D697D7D6C657420723B746869732E5F646973706F7361626C65732E61646428746869732E';
wwv_flow_imp.g_varchar2_table(28010) := '656C656D656E742E6F6E44696457696C6C526573697A65282828293D3E7B746869732E5F636F6E74656E745769646765742E6C6F636B507265666572656E636528292C723D6E6577207328746869732E5F70657273697374656453697A652E726573746F';
wwv_flow_imp.g_varchar2_table(28011) := '726528292C746869732E656C656D656E742E73697A65297D2929292C746869732E5F646973706F7361626C65732E61646428746869732E656C656D656E742E6F6E446964526573697A652828653D3E7B76617220742C6E2C692C6F3B696628746869732E';
wwv_flow_imp.g_varchar2_table(28012) := '5F726573697A6528652E64696D656E73696F6E2E77696474682C652E64696D656E73696F6E2E686569676874292C72262628722E706572736973744865696768743D722E706572736973744865696768747C7C2121652E6E6F7274687C7C2121652E736F';
wwv_flow_imp.g_varchar2_table(28013) := '7574682C722E7065727369737457696474683D722E7065727369737457696474687C7C2121652E656173747C7C2121652E77657374292C652E646F6E65297B69662872297B636F6E73747B6974656D4865696768743A652C64656661756C7453697A653A';
wwv_flow_imp.g_varchar2_table(28014) := '737D3D746869732E6765744C61796F7574496E666F28292C613D4D6174682E726F756E6428652F32293B6C65747B77696474683A6C2C6865696768743A637D3D746869732E656C656D656E742E73697A653B2821722E706572736973744865696768747C';
wwv_flow_imp.g_varchar2_table(28015) := '7C4D6174682E61627328722E63757272656E7453697A652E6865696768742D63293C3D6129262628633D6E756C6C213D3D286E3D6E756C6C3D3D3D28743D722E70657273697374656453697A65297C7C766F696420303D3D3D743F766F696420303A742E';
wwv_flow_imp.g_varchar2_table(28016) := '686569676874292626766F69642030213D3D6E3F6E3A732E686569676874292C2821722E7065727369737457696474687C7C4D6174682E61627328722E63757272656E7453697A652E77696474682D6C293C3D61292626286C3D6E756C6C213D3D286F3D';
wwv_flow_imp.g_varchar2_table(28017) := '6E756C6C3D3D3D28693D722E70657273697374656453697A65297C7C766F696420303D3D3D693F766F696420303A692E7769647468292626766F69642030213D3D6F3F6F3A732E7769647468292C746869732E5F70657273697374656453697A652E7374';
wwv_flow_imp.g_varchar2_table(28018) := '6F7265286E6577204973286C2C6329297D746869732E5F636F6E74656E745769646765742E756E6C6F636B507265666572656E636528292C723D766F696420307D7D2929292C746869732E5F6D657373616765456C656D656E743D757228746869732E65';
wwv_flow_imp.g_varchar2_table(28019) := '6C656D656E742E646F6D4E6F64652C627228222E6D6573736167652229292C746869732E5F6C697374456C656D656E743D757228746869732E656C656D656E742E646F6D4E6F64652C627228222E747265652229293B636F6E737420613D746869732E5F';
wwv_flow_imp.g_varchar2_table(28020) := '646973706F7361626C65732E616464286F2E637265617465496E7374616E63652875342C746869732E656469746F7229293B612E6F6E446964436C6F736528746869732E746F67676C6544657461696C732C746869732C746869732E5F646973706F7361';
wwv_flow_imp.g_varchar2_table(28021) := '626C6573292C746869732E5F64657461696C733D6E657720703428612C746869732E656469746F72293B636F6E7374206C3D28293D3E746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E746F67676C6528226E6F2D69636F6E';
wwv_flow_imp.g_varchar2_table(28022) := '73222C21746869732E656469746F722E6765744F7074696F6E28313138292E73686F7749636F6E73293B6C28293B636F6E737420633D6F2E637265617465496E7374616E63652853342C746869732E656469746F72293B746869732E5F646973706F7361';
wwv_flow_imp.g_varchar2_table(28023) := '626C65732E6164642863292C746869732E5F646973706F7361626C65732E61646428632E6F6E446964546F67676C6544657461696C73282828293D3E746869732E746F67676C6544657461696C7328292929292C746869732E5F6C6973743D6E65772055';
wwv_flow_imp.g_varchar2_table(28024) := '49282253756767657374576964676574222C746869732E5F6C697374456C656D656E742C7B6765744865696768743A653D3E746869732E6765744C61796F7574496E666F28292E6974656D4865696768742C67657454656D706C61746549643A653D3E22';
wwv_flow_imp.g_varchar2_table(28025) := '73756767657374696F6E227D2C5B635D2C7B616C77617973436F6E73756D654D6F757365576865656C3A21302C757365536861646F77733A21312C6D6F757365537570706F72743A21312C6D756C7469706C6553656C656374696F6E537570706F72743A';
wwv_flow_imp.g_varchar2_table(28026) := '21312C6163636573736962696C69747950726F76696465723A7B676574526F6C653A28293D3E226F7074696F6E222C676574576964676574417269614C6162656C3A28293D3E6228302C225375676765737422292C676574576964676574526F6C653A28';
wwv_flow_imp.g_varchar2_table(28027) := '293D3E226C697374626F78222C676574417269614C6162656C3A653D3E7B6C657420743D652E746578744C6162656C3B69662822737472696E6722213D747970656F6620652E636F6D706C6574696F6E2E6C6162656C297B636F6E73747B64657461696C';
wwv_flow_imp.g_varchar2_table(28028) := '3A6E2C6465736372697074696F6E3A697D3D652E636F6D706C6574696F6E2E6C6162656C3B6E2626693F743D6228302C227B307D207B317D2C207B327D222C742C6E2C69293A6E3F743D6228302C227B307D207B317D222C742C6E293A69262628743D62';
wwv_flow_imp.g_varchar2_table(28029) := '28302C227B307D2C207B317D222C742C6929297D69662821652E69735265736F6C7665647C7C21746869732E5F697344657461696C7356697369626C6528292972657475726E20743B636F6E73747B646F63756D656E746174696F6E3A6E2C6465746169';
wwv_flow_imp.g_varchar2_table(28030) := '6C3A697D3D652E636F6D706C6574696F6E3B72657475726E206228302C227B307D2C20646F63733A207B317D222C742C616928227B307D7B317D222C697C7C22222C6E3F22737472696E67223D3D747970656F66206E3F6E3A6E2E76616C75653A222229';
wwv_flow_imp.g_varchar2_table(28031) := '297D7D7D292C746869732E5F6C6973742E7374796C6528494D287B6C697374496E616374697665466F6375734261636B67726F756E643A44342C6C697374496E616374697665466F6375734F75746C696E653A486D7D29292C746869732E5F7374617475';
wwv_flow_imp.g_varchar2_table(28032) := '733D6F2E637265617465496E7374616E63652864342C746869732E656C656D656E742E646F6D4E6F64652C6135293B636F6E737420643D28293D3E746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E746F67676C6528227769';
wwv_flow_imp.g_varchar2_table(28033) := '74682D7374617475732D626172222C746869732E656469746F722E6765744F7074696F6E28313138292E73686F77537461747573426172293B6428292C746869732E5F646973706F7361626C65732E61646428692E6F6E446964436F6C6F725468656D65';
wwv_flow_imp.g_varchar2_table(28034) := '4368616E67652828653D3E746869732E5F6F6E5468656D654368616E67652865292929292C746869732E5F6F6E5468656D654368616E676528692E676574436F6C6F725468656D652829292C746869732E5F646973706F7361626C65732E616464287468';
wwv_flow_imp.g_varchar2_table(28035) := '69732E5F6C6973742E6F6E4D6F757365446F776E2828653D3E746869732E5F6F6E4C6973744D6F757365446F776E4F725461702865292929292C746869732E5F646973706F7361626C65732E61646428746869732E5F6C6973742E6F6E5461702828653D';
wwv_flow_imp.g_varchar2_table(28036) := '3E746869732E5F6F6E4C6973744D6F757365446F776E4F725461702865292929292C746869732E5F646973706F7361626C65732E61646428746869732E5F6C6973742E6F6E4469644368616E676553656C656374696F6E2828653D3E746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(28037) := '4C69737453656C656374696F6E2865292929292C746869732E5F646973706F7361626C65732E61646428746869732E5F6C6973742E6F6E4469644368616E6765466F6375732828653D3E746869732E5F6F6E4C697374466F6375732865292929292C7468';
wwv_flow_imp.g_varchar2_table(28038) := '69732E5F646973706F7361626C65732E61646428746869732E656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E282828293D3E746869732E5F6F6E437572736F7253656C656374696F6E4368616E67656428292929292C';
wwv_flow_imp.g_varchar2_table(28039) := '746869732E5F646973706F7361626C65732E61646428746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E67656428313138292626286428292C6C2829292C746869732E5F63';
wwv_flow_imp.g_varchar2_table(28040) := '6F6D706C6574696F6E4D6F64656C262628652E6861734368616E676564283530297C7C652E6861734368616E67656428313139297C7C652E6861734368616E6765642831323029292626746869732E5F6C6973742E73706C69636528302C746869732E5F';
wwv_flow_imp.g_varchar2_table(28041) := '6C6973742E6C656E6774682C746869732E5F636F6D706C6574696F6E4D6F64656C2E6974656D73297D2929292C746869732E5F6374785375676765737457696467657456697369626C653D72352E56697369626C652E62696E64546F286E292C74686973';
wwv_flow_imp.g_varchar2_table(28042) := '2E5F6374785375676765737457696467657444657461696C7356697369626C653D72352E44657461696C7356697369626C652E62696E64546F286E292C746869732E5F637478537567676573745769646765744D756C7469706C6553756767657374696F';
wwv_flow_imp.g_varchar2_table(28043) := '6E733D72352E4D756C7469706C6553756767657374696F6E732E62696E64546F286E292C746869732E5F63747853756767657374576964676574486173466F637573656453756767657374696F6E3D72352E486173466F63757365645375676765737469';
wwv_flow_imp.g_varchar2_table(28044) := '6F6E2E62696E64546F286E292C746869732E5F646973706F7361626C65732E61646428797328746869732E5F64657461696C732E7769646765742E646F6D4E6F64652C226B6579646F776E222C28653D3E7B746869732E5F6F6E44657461696C734B6579';
wwv_flow_imp.g_varchar2_table(28045) := '646F776E2E666972652865297D2929292C746869732E5F646973706F7361626C65732E61646428746869732E656469746F722E6F6E4D6F757365446F776E2828653D3E746869732E5F6F6E456469746F724D6F757365446F776E2865292929297D646973';
wwv_flow_imp.g_varchar2_table(28046) := '706F736528297B76617220653B746869732E5F64657461696C732E7769646765742E646973706F736528292C746869732E5F64657461696C732E646973706F736528292C746869732E5F6C6973742E646973706F736528292C746869732E5F7374617475';
wwv_flow_imp.g_varchar2_table(28047) := '732E646973706F736528292C746869732E5F646973706F7361626C65732E646973706F736528292C6E756C6C3D3D3D28653D746869732E5F6C6F6164696E6754696D656F7574297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869';
wwv_flow_imp.g_varchar2_table(28048) := '732E5F70656E64696E674C61796F75742E646973706F736528292C746869732E5F70656E64696E6753686F7744657461696C732E646973706F736528292C746869732E5F73686F7754696D656F75742E646973706F736528292C746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(28049) := '656E745769646765742E646973706F736528292C746869732E656C656D656E742E646973706F736528297D5F6F6E456469746F724D6F757365446F776E2865297B746869732E5F64657461696C732E7769646765742E646F6D4E6F64652E636F6E746169';
wwv_flow_imp.g_varchar2_table(28050) := '6E7328652E7461726765742E656C656D656E74293F746869732E5F64657461696C732E7769646765742E646F6D4E6F64652E666F63757328293A746869732E656C656D656E742E646F6D4E6F64652E636F6E7461696E7328652E7461726765742E656C65';
wwv_flow_imp.g_varchar2_table(28051) := '6D656E74292626746869732E656469746F722E666F63757328297D5F6F6E437572736F7253656C656374696F6E4368616E67656428297B30213D3D746869732E5F73746174652626746869732E5F636F6E74656E745769646765742E6C61796F75742829';
wwv_flow_imp.g_varchar2_table(28052) := '7D5F6F6E4C6973744D6F757365446F776E4F725461702865297B766F69642030213D3D652E656C656D656E742626766F69642030213D3D652E696E646578262628652E62726F777365724576656E742E70726576656E7444656661756C7428292C652E62';
wwv_flow_imp.g_varchar2_table(28053) := '726F777365724576656E742E73746F7050726F7061676174696F6E28292C746869732E5F73656C65637428652E656C656D656E742C652E696E64657829297D5F6F6E4C69737453656C656374696F6E2865297B652E656C656D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(28054) := '2626746869732E5F73656C65637428652E656C656D656E74735B305D2C652E696E64657865735B305D297D5F73656C65637428652C74297B636F6E7374206E3D746869732E5F636F6D706C6574696F6E4D6F64656C3B6E262628746869732E5F6F6E4469';
wwv_flow_imp.g_varchar2_table(28055) := '6453656C6563742E66697265287B6974656D3A652C696E6465783A742C6D6F64656C3A6E7D292C746869732E656469746F722E666F6375732829297D5F6F6E5468656D654368616E67652865297B746869732E5F64657461696C732E7769646765742E62';
wwv_flow_imp.g_varchar2_table(28056) := '6F7264657257696474683D416228652E74797065293F323A317D5F6F6E4C697374466F6375732865297B76617220743B696628746869732E5F69676E6F7265466F6375734576656E74732972657475726E3B69662821652E656C656D656E74732E6C656E';
wwv_flow_imp.g_varchar2_table(28057) := '6774682972657475726E20746869732E5F63757272656E7453756767657374696F6E44657461696C73262628746869732E5F63757272656E7453756767657374696F6E44657461696C732E63616E63656C28292C746869732E5F63757272656E74537567';
wwv_flow_imp.g_varchar2_table(28058) := '67657374696F6E44657461696C733D766F696420302C746869732E5F666F63757365644974656D3D766F69642030292C746869732E656469746F722E736574417269614F7074696F6E73287B61637469766544657363656E64616E743A766F696420307D';
wwv_flow_imp.g_varchar2_table(28059) := '292C766F696420746869732E5F63747853756767657374576964676574486173466F637573656453756767657374696F6E2E736574282131293B69662821746869732E5F636F6D706C6574696F6E4D6F64656C2972657475726E3B746869732E5F637478';
wwv_flow_imp.g_varchar2_table(28060) := '53756767657374576964676574486173466F637573656453756767657374696F6E2E736574282130293B636F6E7374206E3D652E656C656D656E74735B305D2C693D652E696E64657865735B305D3B6E213D3D746869732E5F666F63757365644974656D';
wwv_flow_imp.g_varchar2_table(28061) := '2626286E756C6C3D3D3D28743D746869732E5F63757272656E7453756767657374696F6E44657461696C73297C7C766F696420303D3D3D747C7C742E63616E63656C28292C746869732E5F63757272656E7453756767657374696F6E44657461696C733D';
wwv_flow_imp.g_varchar2_table(28062) := '766F696420302C746869732E5F666F63757365644974656D3D6E2C746869732E5F6C6973742E72657665616C2869292C746869732E5F63757272656E7453756767657374696F6E44657461696C733D467428286173796E6320653D3E7B636F6E73742074';
wwv_flow_imp.g_varchar2_table(28063) := '3D6A74282828293D3E7B746869732E5F697344657461696C7356697369626C6528292626746869732E73686F7744657461696C73282130297D292C323530292C693D652E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E742E64';
wwv_flow_imp.g_varchar2_table(28064) := '6973706F7365282929293B7472797B72657475726E206177616974206E2E7265736F6C76652865297D66696E616C6C797B742E646973706F736528292C692E646973706F736528297D7D29292C746869732E5F63757272656E7453756767657374696F6E';
wwv_flow_imp.g_varchar2_table(28065) := '44657461696C732E7468656E282828293D3E7B693E3D746869732E5F6C6973742E6C656E6774687C7C6E213D3D746869732E5F6C6973742E656C656D656E742869297C7C28746869732E5F69676E6F7265466F6375734576656E74733D21302C74686973';
wwv_flow_imp.g_varchar2_table(28066) := '2E5F6C6973742E73706C69636528692C312C5B6E5D292C746869732E5F6C6973742E736574466F637573285B695D292C746869732E5F69676E6F7265466F6375734576656E74733D21312C746869732E5F697344657461696C7356697369626C6528293F';
wwv_flow_imp.g_varchar2_table(28067) := '746869732E73686F7744657461696C73282131293A746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E72656D6F76652822646F63732D7369646522292C746869732E656469746F722E736574417269614F7074696F6E73287B';
wwv_flow_imp.g_varchar2_table(28068) := '61637469766544657363656E64616E743A79342869297D29297D29292E6361746368286B6529292C746869732E5F6F6E446964466F6375732E66697265287B6974656D3A6E2C696E6465783A692C6D6F64656C3A746869732E5F636F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(28069) := '4D6F64656C7D297D5F73657453746174652865297B696628746869732E5F7374617465213D3D652973776974636828746869732E5F73746174653D652C746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E746F67676C652822';
wwv_flow_imp.g_varchar2_table(28070) := '66726F7A656E222C343D3D3D65292C746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E72656D6F766528226D65737361676522292C65297B6361736520303A797228746869732E5F6D657373616765456C656D656E742C7468';
wwv_flow_imp.g_varchar2_table(28071) := '69732E5F6C697374456C656D656E742C746869732E5F7374617475732E656C656D656E74292C746869732E5F64657461696C732E68696465282130292C746869732E5F7374617475732E6869646528292C746869732E5F636F6E74656E74576964676574';
wwv_flow_imp.g_varchar2_table(28072) := '2E6869646528292C746869732E5F6374785375676765737457696467657456697369626C652E726573657428292C746869732E5F637478537567676573745769646765744D756C7469706C6553756767657374696F6E732E726573657428292C74686973';
wwv_flow_imp.g_varchar2_table(28073) := '2E5F63747853756767657374576964676574486173466F637573656453756767657374696F6E2E726573657428292C746869732E5F73686F7754696D656F75742E63616E63656C28292C746869732E656C656D656E742E646F6D4E6F64652E636C617373';
wwv_flow_imp.g_varchar2_table(28074) := '4C6973742E72656D6F7665282276697369626C6522292C746869732E5F6C6973742E73706C69636528302C746869732E5F6C6973742E6C656E677468292C746869732E5F666F63757365644974656D3D766F696420302C746869732E5F63617070656448';
wwv_flow_imp.g_varchar2_table(28075) := '65696768743D766F696420302C746869732E5F6578706C61696E4D6F64653D21313B627265616B3B6361736520313A746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E61646428226D65737361676522292C746869732E5F6D';
wwv_flow_imp.g_varchar2_table(28076) := '657373616765456C656D656E742E74657874436F6E74656E743D6B342E4C4F4144494E475F4D4553534147452C797228746869732E5F6C697374456C656D656E742C746869732E5F7374617475732E656C656D656E74292C5F7228746869732E5F6D6573';
wwv_flow_imp.g_varchar2_table(28077) := '73616765456C656D656E74292C746869732E5F64657461696C732E6869646528292C746869732E5F73686F7728292C746869732E5F666F63757365644974656D3D766F696420302C4A72286B342E4C4F4144494E475F4D455353414745293B627265616B';
wwv_flow_imp.g_varchar2_table(28078) := '3B6361736520323A746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E61646428226D65737361676522292C746869732E5F6D657373616765456C656D656E742E74657874436F6E74656E743D6B342E4E4F5F53554747455354';
wwv_flow_imp.g_varchar2_table(28079) := '494F4E535F4D4553534147452C797228746869732E5F6C697374456C656D656E742C746869732E5F7374617475732E656C656D656E74292C5F7228746869732E5F6D657373616765456C656D656E74292C746869732E5F64657461696C732E6869646528';
wwv_flow_imp.g_varchar2_table(28080) := '292C746869732E5F73686F7728292C746869732E5F666F63757365644974656D3D766F696420302C4A72286B342E4E4F5F53554747455354494F4E535F4D455353414745293B627265616B3B6361736520333A6361736520343A797228746869732E5F6D';
wwv_flow_imp.g_varchar2_table(28081) := '657373616765456C656D656E74292C5F7228746869732E5F6C697374456C656D656E742C746869732E5F7374617475732E656C656D656E74292C746869732E5F73686F7728293B627265616B3B6361736520353A797228746869732E5F6D657373616765';
wwv_flow_imp.g_varchar2_table(28082) := '456C656D656E74292C5F7228746869732E5F6C697374456C656D656E742C746869732E5F7374617475732E656C656D656E74292C746869732E5F64657461696C732E73686F7728292C746869732E5F73686F7728297D7D5F73686F7728297B746869732E';
wwv_flow_imp.g_varchar2_table(28083) := '5F7374617475732E73686F7728292C746869732E5F636F6E74656E745769646765742E73686F7728292C746869732E5F6C61796F757428746869732E5F70657273697374656453697A652E726573746F72652829292C746869732E5F6374785375676765';
wwv_flow_imp.g_varchar2_table(28084) := '737457696467657456697369626C652E736574282130292C746869732E5F73686F7754696D656F75742E63616E63656C416E64536574282828293D3E7B746869732E656C656D656E742E646F6D4E6F64652E636C6173734C6973742E6164642822766973';
wwv_flow_imp.g_varchar2_table(28085) := '69626C6522292C746869732E5F6F6E44696453686F772E666972652874686973297D292C313030297D73686F7754726967676572656428652C74297B303D3D3D746869732E5F7374617465262628746869732E5F636F6E74656E745769646765742E7365';
wwv_flow_imp.g_varchar2_table(28086) := '74506F736974696F6E28746869732E656469746F722E676574506F736974696F6E2829292C746869732E5F69734175746F3D2121652C746869732E5F69734175746F7C7C28746869732E5F6C6F6164696E6754696D656F75743D6A74282828293D3E7468';
wwv_flow_imp.g_varchar2_table(28087) := '69732E5F7365745374617465283129292C742929297D73686F7753756767657374696F6E7328652C742C6E2C692C6F297B76617220732C723B696628746869732E5F636F6E74656E745769646765742E736574506F736974696F6E28746869732E656469';
wwv_flow_imp.g_varchar2_table(28088) := '746F722E676574506F736974696F6E2829292C6E756C6C3D3D3D28733D746869732E5F6C6F6164696E6754696D656F7574297C7C766F696420303D3D3D737C7C732E646973706F736528292C6E756C6C3D3D3D28723D746869732E5F63757272656E7453';
wwv_flow_imp.g_varchar2_table(28089) := '756767657374696F6E44657461696C73297C7C766F696420303D3D3D727C7C722E63616E63656C28292C746869732E5F63757272656E7453756767657374696F6E44657461696C733D766F696420302C746869732E5F636F6D706C6574696F6E4D6F6465';
wwv_flow_imp.g_varchar2_table(28090) := '6C213D3D65262628746869732E5F636F6D706C6574696F6E4D6F64656C3D65292C6E262632213D3D746869732E5F7374617465262630213D3D746869732E5F73746174652972657475726E20766F696420746869732E5F73657453746174652834293B63';
wwv_flow_imp.g_varchar2_table(28091) := '6F6E737420613D746869732E5F636F6D706C6574696F6E4D6F64656C2E6974656D732E6C656E6774682C6C3D303D3D3D613B696628746869732E5F637478537567676573745769646765744D756C7469706C6553756767657374696F6E732E7365742861';
wwv_flow_imp.g_varchar2_table(28092) := '3E31292C6C2972657475726E20746869732E5F736574537461746528693F303A32292C766F696428746869732E5F636F6D706C6574696F6E4D6F64656C3D766F69642030293B746869732E5F666F63757365644974656D3D766F696420302C746869732E';
wwv_flow_imp.g_varchar2_table(28093) := '5F6F6E446964466F6375732E706175736528292C746869732E5F6F6E44696453656C6563742E706175736528293B7472797B746869732E5F6C6973742E73706C69636528302C746869732E5F6C6973742E6C656E6774682C746869732E5F636F6D706C65';
wwv_flow_imp.g_varchar2_table(28094) := '74696F6E4D6F64656C2E6974656D73292C746869732E5F7365745374617465286E3F343A33292C746869732E5F6C6973742E72657665616C28742C30292C746869732E5F6C6973742E736574466F637573286F3F5B5D3A5B745D297D66696E616C6C797B';
wwv_flow_imp.g_varchar2_table(28095) := '746869732E5F6F6E446964466F6375732E726573756D6528292C746869732E5F6F6E44696453656C6563742E726573756D6528297D746869732E5F70656E64696E674C61796F75742E76616C75653D537328727328746869732E656C656D656E742E646F';
wwv_flow_imp.g_varchar2_table(28096) := '6D4E6F6465292C2828293D3E7B746869732E5F70656E64696E674C61796F75742E636C65617228292C746869732E5F6C61796F757428746869732E656C656D656E742E73697A65292C746869732E5F64657461696C732E7769646765742E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(28097) := '652E636C6173734C6973742E72656D6F76652822666F637573656422297D29297D666F63757353656C656374656428297B746869732E5F6C6973742E6C656E6774683E302626746869732E5F6C6973742E736574466F637573285B305D297D73656C6563';
wwv_flow_imp.g_varchar2_table(28098) := '744E6578745061676528297B73776974636828746869732E5F7374617465297B6361736520303A72657475726E21313B6361736520353A72657475726E20746869732E5F64657461696C732E7769646765742E70616765446F776E28292C21303B636173';
wwv_flow_imp.g_varchar2_table(28099) := '6520313A72657475726E21746869732E5F69734175746F3B64656661756C743A72657475726E20746869732E5F6C6973742E666F6375734E6578745061676528292C21307D7D73656C6563744E65787428297B73776974636828746869732E5F73746174';
wwv_flow_imp.g_varchar2_table(28100) := '65297B6361736520303A72657475726E21313B6361736520313A72657475726E21746869732E5F69734175746F3B64656661756C743A72657475726E20746869732E5F6C6973742E666F6375734E65787428312C2130292C21307D7D73656C6563744C61';
wwv_flow_imp.g_varchar2_table(28101) := '737428297B73776974636828746869732E5F7374617465297B6361736520303A72657475726E21313B6361736520353A72657475726E20746869732E5F64657461696C732E7769646765742E7363726F6C6C426F74746F6D28292C21303B636173652031';
wwv_flow_imp.g_varchar2_table(28102) := '3A72657475726E21746869732E5F69734175746F3B64656661756C743A72657475726E20746869732E5F6C6973742E666F6375734C61737428292C21307D7D73656C65637450726576696F75735061676528297B73776974636828746869732E5F737461';
wwv_flow_imp.g_varchar2_table(28103) := '7465297B6361736520303A72657475726E21313B6361736520353A72657475726E20746869732E5F64657461696C732E7769646765742E70616765557028292C21303B6361736520313A72657475726E21746869732E5F69734175746F3B64656661756C';
wwv_flow_imp.g_varchar2_table(28104) := '743A72657475726E20746869732E5F6C6973742E666F63757350726576696F75735061676528292C21307D7D73656C65637450726576696F757328297B73776974636828746869732E5F7374617465297B6361736520303A72657475726E21313B636173';
wwv_flow_imp.g_varchar2_table(28105) := '6520313A72657475726E21746869732E5F69734175746F3B64656661756C743A72657475726E20746869732E5F6C6973742E666F63757350726576696F757328312C2130292C21317D7D73656C656374466972737428297B73776974636828746869732E';
wwv_flow_imp.g_varchar2_table(28106) := '5F7374617465297B6361736520303A72657475726E21313B6361736520353A72657475726E20746869732E5F64657461696C732E7769646765742E7363726F6C6C546F7028292C21303B6361736520313A72657475726E21746869732E5F69734175746F';
wwv_flow_imp.g_varchar2_table(28107) := '3B64656661756C743A72657475726E20746869732E5F6C6973742E666F637573466972737428292C21307D7D676574466F63757365644974656D28297B69662830213D3D746869732E5F7374617465262632213D3D746869732E5F737461746526263121';
wwv_flow_imp.g_varchar2_table(28108) := '3D3D746869732E5F73746174652626746869732E5F636F6D706C6574696F6E4D6F64656C2626746869732E5F6C6973742E676574466F63757328292E6C656E6774683E302972657475726E7B6974656D3A746869732E5F6C6973742E676574466F637573';
wwv_flow_imp.g_varchar2_table(28109) := '6564456C656D656E747328295B305D2C696E6465783A746869732E5F6C6973742E676574466F63757328295B305D2C6D6F64656C3A746869732E5F636F6D706C6574696F6E4D6F64656C7D7D746F67676C6544657461696C73466F63757328297B353D3D';
wwv_flow_imp.g_varchar2_table(28110) := '3D746869732E5F73746174653F28746869732E5F73657453746174652833292C746869732E5F64657461696C732E7769646765742E646F6D4E6F64652E636C6173734C6973742E72656D6F76652822666F63757365642229293A333D3D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(28111) := '73746174652626746869732E5F697344657461696C7356697369626C652829262628746869732E5F73657453746174652835292C746869732E5F64657461696C732E7769646765742E646F6D4E6F64652E636C6173734C6973742E6164642822666F6375';
wwv_flow_imp.g_varchar2_table(28112) := '7365642229297D746F67676C6544657461696C7328297B746869732E5F697344657461696C7356697369626C6528293F28746869732E5F70656E64696E6753686F7744657461696C732E636C65617228292C746869732E5F637478537567676573745769';
wwv_flow_imp.g_varchar2_table(28113) := '6467657444657461696C7356697369626C652E736574282131292C746869732E5F73657444657461696C7356697369626C65282131292C746869732E5F64657461696C732E6869646528292C746869732E656C656D656E742E646F6D4E6F64652E636C61';
wwv_flow_imp.g_varchar2_table(28114) := '73734C6973742E72656D6F7665282273686F77732D64657461696C732229293A21683428746869732E5F6C6973742E676574466F6375736564456C656D656E747328295B305D29262621746869732E5F6578706C61696E4D6F64657C7C33213D3D746869';
wwv_flow_imp.g_varchar2_table(28115) := '732E5F7374617465262635213D3D746869732E5F7374617465262634213D3D746869732E5F73746174657C7C28746869732E5F6374785375676765737457696467657444657461696C7356697369626C652E736574282130292C746869732E5F73657444';
wwv_flow_imp.g_varchar2_table(28116) := '657461696C7356697369626C65282130292C746869732E73686F7744657461696C7328213129297D73686F7744657461696C732865297B746869732E5F70656E64696E6753686F7744657461696C732E76616C75653D537328727328746869732E656C65';
wwv_flow_imp.g_varchar2_table(28117) := '6D656E742E646F6D4E6F6465292C2828293D3E7B746869732E5F70656E64696E6753686F7744657461696C732E636C65617228292C746869732E5F64657461696C732E73686F7728292C653F746869732E5F64657461696C732E7769646765742E72656E';
wwv_flow_imp.g_varchar2_table(28118) := '6465724C6F6164696E6728293A746869732E5F64657461696C732E7769646765742E72656E6465724974656D28746869732E5F6C6973742E676574466F6375736564456C656D656E747328295B305D2C746869732E5F6578706C61696E4D6F6465292C74';
wwv_flow_imp.g_varchar2_table(28119) := '6869732E5F64657461696C732E7769646765742E6973456D7074793F746869732E5F64657461696C732E6869646528293A28746869732E5F706F736974696F6E44657461696C7328292C746869732E656C656D656E742E646F6D4E6F64652E636C617373';
wwv_flow_imp.g_varchar2_table(28120) := '4C6973742E616464282273686F77732D64657461696C732229292C746869732E656469746F722E666F63757328297D29297D746F67676C654578706C61696E4D6F646528297B746869732E5F6C6973742E676574466F6375736564456C656D656E747328';
wwv_flow_imp.g_varchar2_table(28121) := '295B305D262628746869732E5F6578706C61696E4D6F64653D21746869732E5F6578706C61696E4D6F64652C746869732E5F697344657461696C7356697369626C6528293F746869732E73686F7744657461696C73282131293A746869732E746F67676C';
wwv_flow_imp.g_varchar2_table(28122) := '6544657461696C732829297D726573657450657273697374656453697A6528297B746869732E5F70657273697374656453697A652E726573657428297D6869646557696467657428297B76617220653B746869732E5F70656E64696E674C61796F75742E';
wwv_flow_imp.g_varchar2_table(28123) := '636C65617228292C746869732E5F70656E64696E6753686F7744657461696C732E636C65617228292C6E756C6C3D3D3D28653D746869732E5F6C6F6164696E6754696D656F7574297C7C766F696420303D3D3D657C7C652E646973706F736528292C7468';
wwv_flow_imp.g_varchar2_table(28124) := '69732E5F73657453746174652830292C746869732E5F6F6E446964486964652E666972652874686973292C746869732E656C656D656E742E636C65617253617368486F766572537461746528293B636F6E737420743D746869732E5F7065727369737465';
wwv_flow_imp.g_varchar2_table(28125) := '6453697A652E726573746F726528292C6E3D4D6174682E6365696C28342E332A746869732E6765744C61796F7574496E666F28292E6974656D486569676874293B742626742E6865696768743C6E2626746869732E5F70657273697374656453697A652E';
wwv_flow_imp.g_varchar2_table(28126) := '73746F726528742E7769746828766F696420302C6E29297D697346726F7A656E28297B72657475726E20343D3D3D746869732E5F73746174657D5F616674657252656E6465722865297B6E756C6C213D3D653F32213D3D746869732E5F73746174652626';
wwv_flow_imp.g_varchar2_table(28127) := '31213D3D746869732E5F7374617465262628746869732E5F697344657461696C7356697369626C652829262621746869732E5F64657461696C732E7769646765742E6973456D7074792626746869732E5F64657461696C732E73686F7728292C74686973';
wwv_flow_imp.g_varchar2_table(28128) := '2E5F706F736974696F6E44657461696C732829293A746869732E5F697344657461696C7356697369626C6528292626746869732E5F64657461696C732E6869646528297D5F6C61796F75742865297B76617220742C6E2C693B69662821746869732E6564';
wwv_flow_imp.g_varchar2_table(28129) := '69746F722E6861734D6F64656C28292972657475726E3B69662821746869732E656469746F722E676574446F6D4E6F646528292972657475726E3B636F6E7374206F3D447328746869732E656C656D656E742E646F6D4E6F64652E6F776E6572446F6375';
wwv_flow_imp.g_varchar2_table(28130) := '6D656E742E626F6479292C733D746869732E6765744C61796F7574496E666F28293B657C7C28653D732E64656661756C7453697A65293B6C657420723D652E6865696768742C613D652E77696474683B696628746869732E5F7374617475732E656C656D';
wwv_flow_imp.g_varchar2_table(28131) := '656E742E7374796C652E6865696768743D60247B732E6974656D4865696768747D7078602C323D3D3D746869732E5F73746174657C7C313D3D3D746869732E5F737461746529723D732E6974656D4865696768742B732E626F726465724865696768742C';
wwv_flow_imp.g_varchar2_table(28132) := '613D732E64656661756C7453697A652E77696474682F322C746869732E656C656D656E742E656E61626C655361736865732821312C21312C21312C2131292C746869732E656C656D656E742E6D696E53697A653D746869732E656C656D656E742E6D6178';
wwv_flow_imp.g_varchar2_table(28133) := '53697A653D6E657720497328612C72292C746869732E5F636F6E74656E745769646765742E736574507265666572656E63652832293B656C73657B636F6E7374206C3D6F2E77696474682D732E626F726465724865696768742D322A732E686F72697A6F';
wwv_flow_imp.g_varchar2_table(28134) := '6E74616C50616464696E673B613E6C262628613D6C293B636F6E737420633D746869732E5F636F6D706C6574696F6E4D6F64656C3F746869732E5F636F6D706C6574696F6E4D6F64656C2E73746174732E704C6162656C4C656E2A732E7479706963616C';
wwv_flow_imp.g_varchar2_table(28135) := '48616C66776964746843686172616374657257696474683A612C643D732E7374617475734261724865696768742B746869732E5F6C6973742E636F6E74656E744865696768742B732E626F726465724865696768742C683D732E6974656D486569676874';
wwv_flow_imp.g_varchar2_table(28136) := '2B732E7374617475734261724865696768742C753D417328746869732E656469746F722E676574446F6D4E6F64652829292C703D746869732E656469746F722E6765745363726F6C6C656456697369626C65506F736974696F6E28746869732E65646974';
wwv_flow_imp.g_varchar2_table(28137) := '6F722E676574506F736974696F6E2829292C673D752E746F702B702E746F702B702E6865696768742C6D3D4D6174682E6D696E286F2E6865696768742D672D732E766572746963616C50616464696E672C64292C663D752E746F702B702E746F702D732E';
wwv_flow_imp.g_varchar2_table(28138) := '766572746963616C50616464696E672C763D4D6174682E6D696E28662C64293B6C657420623D4D6174682E6D696E284D6174682E6D617828762C6D292B732E626F726465724865696768742C64293B723D3D3D286E756C6C3D3D3D28743D746869732E5F';
wwv_flow_imp.g_varchar2_table(28139) := '636170706564486569676874297C7C766F696420303D3D3D743F766F696420303A742E63617070656429262628723D746869732E5F6361707065644865696768742E77616E746564292C723C68262628723D68292C723E62262628723D62293B636F6E73';
wwv_flow_imp.g_varchar2_table(28140) := '74205F3D3135303B723E6D7C7C746869732E5F666F72636552656E646572696E6741626F76652626663E5F3F28746869732E5F636F6E74656E745769646765742E736574507265666572656E63652831292C746869732E656C656D656E742E656E61626C';
wwv_flow_imp.g_varchar2_table(28141) := '655361736865732821302C21302C21312C2131292C623D76293A28746869732E5F636F6E74656E745769646765742E736574507265666572656E63652832292C746869732E656C656D656E742E656E61626C655361736865732821312C21302C21302C21';
wwv_flow_imp.g_varchar2_table(28142) := '31292C623D6D292C746869732E656C656D656E742E70726566657272656453697A653D6E657720497328632C732E64656661756C7453697A652E686569676874292C746869732E656C656D656E742E6D617853697A653D6E6577204973286C2C62292C74';
wwv_flow_imp.g_varchar2_table(28143) := '6869732E656C656D656E742E6D696E53697A653D6E6577204973283232302C68292C746869732E5F6361707065644865696768743D723D3D3D643F7B77616E7465643A6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E5F63617070656448';
wwv_flow_imp.g_varchar2_table(28144) := '6569676874297C7C766F696420303D3D3D6E3F766F696420303A6E2E77616E746564292626766F69642030213D3D693F693A652E6865696768742C6361707065643A727D3A766F696420307D746869732E5F726573697A6528612C72297D5F726573697A';
wwv_flow_imp.g_varchar2_table(28145) := '6528652C74297B636F6E73747B77696474683A6E2C6865696768743A697D3D746869732E656C656D656E742E6D617853697A653B653D4D6174682E6D696E286E2C65292C743D4D6174682E6D696E28692C74293B636F6E73747B73746174757342617248';
wwv_flow_imp.g_varchar2_table(28146) := '65696768743A6F7D3D746869732E6765744C61796F7574496E666F28293B746869732E5F6C6973742E6C61796F757428742D6F2C65292C746869732E5F6C697374456C656D656E742E7374796C652E6865696768743D742D6F2B227078222C746869732E';
wwv_flow_imp.g_varchar2_table(28147) := '656C656D656E742E6C61796F757428742C65292C746869732E5F636F6E74656E745769646765742E6C61796F757428292C746869732E5F706F736974696F6E44657461696C7328297D5F706F736974696F6E44657461696C7328297B76617220653B7468';
wwv_flow_imp.g_varchar2_table(28148) := '69732E5F697344657461696C7356697369626C6528292626746869732E5F64657461696C732E706C6163654174416E63686F7228746869732E656C656D656E742E646F6D4E6F64652C323D3D3D286E756C6C3D3D3D28653D746869732E5F636F6E74656E';
wwv_flow_imp.g_varchar2_table(28149) := '745769646765742E676574506F736974696F6E2829297C7C766F696420303D3D3D653F766F696420303A652E707265666572656E63655B305D29297D6765744C61796F7574496E666F28297B636F6E737420653D746869732E656469746F722E6765744F';
wwv_flow_imp.g_varchar2_table(28150) := '7074696F6E283530292C743D484428746869732E656469746F722E6765744F7074696F6E28313230297C7C652E6C696E654865696768742C382C316533292C6E3D746869732E656469746F722E6765744F7074696F6E28313138292E73686F7753746174';
wwv_flow_imp.g_varchar2_table(28151) := '7573426172262632213D3D746869732E5F7374617465262631213D3D746869732E5F73746174653F743A302C693D746869732E5F64657461696C732E7769646765742E626F7264657257696474682C6F3D322A693B72657475726E7B6974656D48656967';
wwv_flow_imp.g_varchar2_table(28152) := '68743A742C7374617475734261724865696768743A6E2C626F7264657257696474683A692C626F726465724865696768743A6F2C7479706963616C48616C66776964746843686172616374657257696474683A652E7479706963616C48616C6677696474';
wwv_flow_imp.g_varchar2_table(28153) := '6843686172616374657257696474682C766572746963616C50616464696E673A32322C686F72697A6F6E74616C50616464696E673A31342C64656661756C7453697A653A6E6577204973283433302C6E2B31322A742B6F297D7D5F697344657461696C73';
wwv_flow_imp.g_varchar2_table(28154) := '56697369626C6528297B72657475726E20746869732E5F73746F72616765536572766963652E676574426F6F6C65616E2822657870616E6453756767657374696F6E446F6373222C302C2131297D5F73657444657461696C7356697369626C652865297B';
wwv_flow_imp.g_varchar2_table(28155) := '746869732E5F73746F72616765536572766963652E73746F72652822657870616E6453756767657374696F6E446F6373222C652C302C30297D666F72636552656E646572696E6741626F766528297B746869732E5F666F72636552656E646572696E6741';
wwv_flow_imp.g_varchar2_table(28156) := '626F76657C7C28746869732E5F666F72636552656E646572696E6741626F76653D21302C746869732E5F6C61796F757428746869732E5F70657273697374656453697A652E726573746F7265282929297D73746F70466F72636552656E646572696E6741';
wwv_flow_imp.g_varchar2_table(28157) := '626F766528297B746869732E5F666F72636552656E646572696E6741626F76653D21317D7D3B49342E4C4F4144494E475F4D4553534147453D6228302C224C6F6164696E672E2E2E22292C49342E4E4F5F53554747455354494F4E535F4D455353414745';
wwv_flow_imp.g_varchar2_table(28158) := '3D6228302C224E6F2073756767657374696F6E732E22292C49343D6B343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E67';
wwv_flow_imp.g_varchar2_table(28159) := '65744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265';
wwv_flow_imp.g_varchar2_table(28160) := '666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E';
wwv_flow_imp.g_varchar2_table(28161) := '29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B453428312C5142292C453428322C6364292C453428332C5062292C453428342C7563295D2C4934293B636C6173';
wwv_flow_imp.g_varchar2_table(28162) := '73204D347B636F6E7374727563746F7228652C74297B746869732E5F7769646765743D652C746869732E5F656469746F723D742C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E73757070726573734D6F757365446F';
wwv_flow_imp.g_varchar2_table(28163) := '776E3D21312C746869732E5F707265666572656E63654C6F636B65643D21312C746869732E5F61646465643D21312C746869732E5F68696464656E3D21317D646973706F736528297B746869732E5F6164646564262628746869732E5F61646465643D21';
wwv_flow_imp.g_varchar2_table(28164) := '312C746869732E5F656469746F722E72656D6F7665436F6E74656E74576964676574287468697329297D676574496428297B72657475726E22656469746F722E7769646765742E73756767657374576964676574227D676574446F6D4E6F646528297B72';
wwv_flow_imp.g_varchar2_table(28165) := '657475726E20746869732E5F7769646765742E656C656D656E742E646F6D4E6F64657D73686F7728297B746869732E5F68696464656E3D21312C746869732E5F61646465647C7C28746869732E5F61646465643D21302C746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(28166) := '616464436F6E74656E74576964676574287468697329297D6869646528297B746869732E5F68696464656E7C7C28746869732E5F68696464656E3D21302C746869732E6C61796F75742829297D6C61796F757428297B746869732E5F656469746F722E6C';
wwv_flow_imp.g_varchar2_table(28167) := '61796F7574436F6E74656E745769646765742874686973297D676574506F736974696F6E28297B72657475726E21746869732E5F68696464656E2626746869732E5F706F736974696F6E2626746869732E5F707265666572656E63653F7B706F73697469';
wwv_flow_imp.g_varchar2_table(28168) := '6F6E3A746869732E5F706F736974696F6E2C707265666572656E63653A5B746869732E5F707265666572656E63655D7D3A6E756C6C7D6265666F726552656E64657228297B636F6E73747B6865696768743A652C77696474683A747D3D746869732E5F77';
wwv_flow_imp.g_varchar2_table(28169) := '69646765742E656C656D656E742E73697A652C7B626F7264657257696474683A6E2C686F72697A6F6E74616C50616464696E673A697D3D746869732E5F7769646765742E6765744C61796F7574496E666F28293B72657475726E206E657720497328742B';
wwv_flow_imp.g_varchar2_table(28170) := '322A6E2B692C652B322A6E297D616674657252656E6465722865297B746869732E5F7769646765742E5F616674657252656E6465722865297D736574507265666572656E63652865297B746869732E5F707265666572656E63654C6F636B65647C7C2874';
wwv_flow_imp.g_varchar2_table(28171) := '6869732E5F707265666572656E63653D65297D6C6F636B507265666572656E636528297B746869732E5F707265666572656E63654C6F636B65643D21307D756E6C6F636B507265666572656E636528297B746869732E5F707265666572656E63654C6F63';
wwv_flow_imp.g_varchar2_table(28172) := '6B65643D21317D736574506F736974696F6E2865297B746869732E5F706F736974696F6E3D657D7D7661722041342C4E343D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173';
wwv_flow_imp.g_varchar2_table(28173) := '732050347B636F6E7374727563746F7228652C74297B696628746869732E5F6D6F64656C3D652C746869732E5F706F736974696F6E3D742C746869732E5F6465636F726174696F6E4F7074696F6E733D4F432E7265676973746572287B64657363726970';
wwv_flow_imp.g_varchar2_table(28174) := '74696F6E3A22737567676573742D6C696E652D737566666978222C737469636B696E6573733A317D292C652E6765744C696E654D6178436F6C756D6E28742E6C696E654E756D62657229213D3D742E636F6C756D6E297B636F6E7374206E3D652E676574';
wwv_flow_imp.g_varchar2_table(28175) := '4F666673657441742874292C693D652E676574506F736974696F6E4174286E2B31293B652E6368616E67654465636F726174696F6E732828653D3E7B746869732E5F6D61726B65722626652E72656D6F76654465636F726174696F6E28746869732E5F6D';
wwv_flow_imp.g_varchar2_table(28176) := '61726B6572292C746869732E5F6D61726B65723D652E6164644465636F726174696F6E2872682E66726F6D506F736974696F6E7328742C69292C746869732E5F6465636F726174696F6E4F7074696F6E73297D29297D7D646973706F736528297B746869';
wwv_flow_imp.g_varchar2_table(28177) := '732E5F6D61726B6572262621746869732E5F6D6F64656C2E6973446973706F73656428292626746869732E5F6D6F64656C2E6368616E67654465636F726174696F6E732828653D3E7B652E72656D6F76654465636F726174696F6E28746869732E5F6D61';
wwv_flow_imp.g_varchar2_table(28178) := '726B6572292C746869732E5F6D61726B65723D766F696420307D29297D64656C74612865297B696628746869732E5F6D6F64656C2E6973446973706F73656428297C7C746869732E5F706F736974696F6E2E6C696E654E756D626572213D3D652E6C696E';
wwv_flow_imp.g_varchar2_table(28179) := '654E756D6265722972657475726E20303B696628746869732E5F6D61726B6572297B636F6E737420743D746869732E5F6D6F64656C2E6765744465636F726174696F6E52616E676528746869732E5F6D61726B6572293B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(28180) := '6D6F64656C2E6765744F6666736574417428742E6765745374617274506F736974696F6E2829292D746869732E5F6D6F64656C2E6765744F666673657441742865297D72657475726E20746869732E5F6D6F64656C2E6765744C696E654D6178436F6C75';
wwv_flow_imp.g_varchar2_table(28181) := '6D6E28652E6C696E654E756D626572292D652E636F6C756D6E7D7D6C6574204F343D41343D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2841342E4944297D636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(28182) := '28652C742C6E2C692C6F2C732C72297B746869732E5F6D656D6F7279536572766963653D742C746869732E5F636F6D6D616E64536572766963653D6E2C746869732E5F636F6E746578744B6579536572766963653D692C746869732E5F696E7374616E74';
wwv_flow_imp.g_varchar2_table(28183) := '696174696F6E536572766963653D6F2C746869732E5F6C6F67536572766963653D732C746869732E5F74656C656D65747279536572766963653D722C746869732E5F6C696E655375666669783D6E65772063742C746869732E5F746F446973706F73653D';
wwv_flow_imp.g_varchar2_table(28184) := '6E65772061742C746869732E5F73656C6563746F72733D6E65772052342828653D3E652E7072696F7269747929292C746869732E5F6F6E57696C6C496E73657274537567676573744974656D3D6E65772043742C746869732E6F6E57696C6C496E736572';
wwv_flow_imp.g_varchar2_table(28185) := '74537567676573744974656D3D746869732E5F6F6E57696C6C496E73657274537567676573744974656D2E6576656E742C746869732E656469746F723D652C746869732E6D6F64656C3D6F2E637265617465496E7374616E6365286F342C746869732E65';
wwv_flow_imp.g_varchar2_table(28186) := '6469746F72292C746869732E5F73656C6563746F72732E7265676973746572287B7072696F726974793A302C73656C6563743A28652C742C6E293D3E746869732E5F6D656D6F7279536572766963652E73656C65637428652C742C6E297D293B636F6E73';
wwv_flow_imp.g_varchar2_table(28187) := '7420613D72352E496E736572744D6F64652E62696E64546F2869293B612E73657428652E6765744F7074696F6E28313138292E696E736572744D6F6465292C746869732E5F746F446973706F73652E61646428746869732E6D6F64656C2E6F6E44696454';
wwv_flow_imp.g_varchar2_table(28188) := '726967676572282828293D3E612E73657428652E6765744F7074696F6E28313138292E696E736572744D6F6465292929292C746869732E7769646765743D746869732E5F746F446973706F73652E616464286E657720437328727328652E676574446F6D';
wwv_flow_imp.g_varchar2_table(28189) := '4E6F64652829292C2828293D3E7B636F6E737420653D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652849342C746869732E656469746F72293B746869732E5F746F446973706F73652E61646428';
wwv_flow_imp.g_varchar2_table(28190) := '65292C746869732E5F746F446973706F73652E61646428652E6F6E44696453656C6563742828653D3E746869732E5F696E7365727453756767657374696F6E28652C3029292C7468697329293B636F6E737420743D6E657720593528746869732E656469';
wwv_flow_imp.g_varchar2_table(28191) := '746F722C652C746869732E6D6F64656C2C28653D3E746869732E5F696E7365727453756767657374696F6E28652C322929293B746869732E5F746F446973706F73652E6164642874293B636F6E7374206E3D72352E4D616B657354657874456469742E62';
wwv_flow_imp.g_varchar2_table(28192) := '696E64546F28746869732E5F636F6E746578744B657953657276696365292C693D72352E486173496E73657274416E645265706C61636552616E67652E62696E64546F28746869732E5F636F6E746578744B657953657276696365292C6F3D72352E4361';
wwv_flow_imp.g_varchar2_table(28193) := '6E5265736F6C76652E62696E64546F28746869732E5F636F6E746578744B657953657276696365293B72657475726E20746869732E5F746F446973706F73652E616464287274282828293D3E7B6E2E726573657428292C692E726573657428292C6F2E72';
wwv_flow_imp.g_varchar2_table(28194) := '6573657428297D2929292C746869732E5F746F446973706F73652E61646428652E6F6E446964466F6375732828287B6974656D3A657D293D3E7B636F6E737420743D746869732E656469746F722E676574506F736974696F6E28292C733D652E65646974';
wwv_flow_imp.g_varchar2_table(28195) := '53746172742E636F6C756D6E2C723D742E636F6C756D6E3B6C657420613D21303B22736D61727422213D3D746869732E656469746F722E6765744F7074696F6E2831297C7C32213D3D746869732E6D6F64656C2E73746174657C7C652E636F6D706C6574';
wwv_flow_imp.g_varchar2_table(28196) := '696F6E2E6164646974696F6E616C5465787445646974737C7C3426652E636F6D706C6574696F6E2E696E736572745465787452756C65737C7C722D73213D3D652E636F6D706C6574696F6E2E696E73657274546578742E6C656E6774687C7C28613D7468';
wwv_flow_imp.g_varchar2_table(28197) := '69732E656469746F722E6765744D6F64656C28292E67657456616C7565496E52616E6765287B73746172744C696E654E756D6265723A742E6C696E654E756D6265722C7374617274436F6C756D6E3A732C656E644C696E654E756D6265723A742E6C696E';
wwv_flow_imp.g_varchar2_table(28198) := '654E756D6265722C656E64436F6C756D6E3A727D29213D3D652E636F6D706C6574696F6E2E696E7365727454657874292C6E2E7365742861292C692E73657428216D632E657175616C7328652E65646974496E73657274456E642C652E65646974526570';
wwv_flow_imp.g_varchar2_table(28199) := '6C616365456E6429292C6F2E73657428426F6F6C65616E28652E70726F76696465722E7265736F6C7665436F6D706C6574696F6E4974656D297C7C426F6F6C65616E28652E636F6D706C6574696F6E2E646F63756D656E746174696F6E297C7C652E636F';
wwv_flow_imp.g_varchar2_table(28200) := '6D706C6574696F6E2E64657461696C213D3D652E636F6D706C6574696F6E2E6C6162656C297D2929292C746869732E5F746F446973706F73652E61646428652E6F6E44657461696C734B6579446F776E2828653D3E7B652E746F4B6579436F646543686F';
wwv_flow_imp.g_varchar2_table(28201) := '726428292E657175616C73286E65772042652821302C21312C21312C21312C333329297C7C712626652E746F4B6579436F646543686F726428292E657175616C73286E65772042652821312C21312C21312C21302C333329293F652E73746F7050726F70';
wwv_flow_imp.g_varchar2_table(28202) := '61676174696F6E28293A652E746F4B6579436F646543686F726428292E69734D6F6469666965724B657928297C7C746869732E656469746F722E666F63757328297D2929292C657D2929292C746869732E5F6F766572747970696E674361707475726572';
wwv_flow_imp.g_varchar2_table(28203) := '3D746869732E5F746F446973706F73652E616464286E657720437328727328652E676574446F6D4E6F64652829292C2828293D3E746869732E5F746F446973706F73652E616464286E657720733428746869732E656469746F722C746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(28204) := '6C29292929292C746869732E5F616C7465726E6174697665733D746869732E5F746F446973706F73652E616464286E657720437328727328652E676574446F6D4E6F64652829292C2828293D3E746869732E5F746F446973706F73652E616464286E6577';
wwv_flow_imp.g_varchar2_table(28205) := '20513528746869732E656469746F722C746869732E5F636F6E746578744B65795365727669636529292929292C746869732E5F746F446973706F73652E616464286F2E637265617465496E7374616E6365284B352C6529292C746869732E5F746F446973';
wwv_flow_imp.g_varchar2_table(28206) := '706F73652E61646428746869732E6D6F64656C2E6F6E446964547269676765722828653D3E7B746869732E7769646765742E76616C75652E73686F7754726967676572656428652E6175746F2C652E7368793F3235303A3530292C746869732E5F6C696E';
wwv_flow_imp.g_varchar2_table(28207) := '655375666669782E76616C75653D6E657720503428746869732E656469746F722E6765744D6F64656C28292C652E706F736974696F6E297D2929292C746869732E5F746F446973706F73652E61646428746869732E6D6F64656C2E6F6E44696453756767';
wwv_flow_imp.g_varchar2_table(28208) := '6573742828653D3E7B696628652E747269676765724F7074696F6E732E7368792972657475726E3B6C657420743D2D313B666F7228636F6E7374206E206F6620746869732E5F73656C6563746F72732E6974656D734F72646572656442795072696F7269';
wwv_flow_imp.g_varchar2_table(28209) := '74794465736329696628743D6E2E73656C65637428746869732E656469746F722E6765744D6F64656C28292C746869732E656469746F722E676574506F736974696F6E28292C652E636F6D706C6574696F6E4D6F64656C2E6974656D73292C2D31213D3D';
wwv_flow_imp.g_varchar2_table(28210) := '7429627265616B3B6966282D313D3D3D74262628743D30292C303D3D3D746869732E6D6F64656C2E73746174652972657475726E3B6C6574206E3D21313B696628652E747269676765724F7074696F6E732E6175746F297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(28211) := '2E656469746F722E6765744F7074696F6E28313138293B226E65766572223D3D3D742E73656C656374696F6E4D6F64657C7C22616C77617973223D3D3D742E73656C656374696F6E4D6F64653F6E3D226E65766572223D3D3D742E73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(28212) := '4D6F64653A227768656E54726967676572436861726163746572223D3D3D742E73656C656374696F6E4D6F64653F6E3D31213D3D652E747269676765724F7074696F6E732E747269676765724B696E643A227768656E517569636B53756767657374696F';
wwv_flow_imp.g_varchar2_table(28213) := '6E223D3D3D742E73656C656374696F6E4D6F64652626286E3D313D3D3D652E747269676765724F7074696F6E732E747269676765724B696E64262621652E747269676765724F7074696F6E732E726566696C746572297D746869732E7769646765742E76';
wwv_flow_imp.g_varchar2_table(28214) := '616C75652E73686F7753756767657374696F6E7328652E636F6D706C6574696F6E4D6F64656C2C742C652E697346726F7A656E2C652E747269676765724F7074696F6E732E6175746F2C6E297D2929292C746869732E5F746F446973706F73652E616464';
wwv_flow_imp.g_varchar2_table(28215) := '28746869732E6D6F64656C2E6F6E44696443616E63656C2828653D3E7B652E7265747269676765727C7C746869732E7769646765742E76616C75652E6869646557696467657428297D2929292C746869732E5F746F446973706F73652E61646428746869';
wwv_flow_imp.g_varchar2_table(28216) := '732E656469746F722E6F6E446964426C7572456469746F72576964676574282828293D3E7B746869732E6D6F64656C2E63616E63656C28292C746869732E6D6F64656C2E636C65617228297D2929293B636F6E7374206C3D72352E416363657074537567';
wwv_flow_imp.g_varchar2_table(28217) := '67657374696F6E734F6E456E7465722E62696E64546F2869292C633D28293D3E7B636F6E737420653D746869732E656469746F722E6765744F7074696F6E2831293B6C2E73657428226F6E223D3D3D657C7C22736D617274223D3D3D65297D3B74686973';
wwv_flow_imp.g_varchar2_table(28218) := '2E5F746F446973706F73652E61646428746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E282828293D3E6328292929292C6328297D646973706F736528297B746869732E5F616C7465726E6174697665732E6469';
wwv_flow_imp.g_varchar2_table(28219) := '73706F736528292C746869732E5F746F446973706F73652E646973706F736528292C746869732E7769646765742E646973706F736528292C746869732E6D6F64656C2E646973706F736528292C746869732E5F6C696E655375666669782E646973706F73';
wwv_flow_imp.g_varchar2_table(28220) := '6528292C746869732E5F6F6E57696C6C496E73657274537567676573744974656D2E646973706F736528297D5F696E7365727453756767657374696F6E28652C74297B69662821657C7C21652E6974656D2972657475726E20746869732E5F616C746572';
wwv_flow_imp.g_varchar2_table(28221) := '6E6174697665732E76616C75652E726573657428292C746869732E6D6F64656C2E63616E63656C28292C766F696420746869732E6D6F64656C2E636C65617228293B69662821746869732E656469746F722E6861734D6F64656C28292972657475726E3B';
wwv_flow_imp.g_varchar2_table(28222) := '636F6E7374206E3D4E352E67657428746869732E656469746F72293B696628216E2972657475726E3B746869732E5F6F6E57696C6C496E73657274537567676573744974656D2E66697265287B6974656D3A652E6974656D7D293B636F6E737420693D74';
wwv_flow_imp.g_varchar2_table(28223) := '6869732E656469746F722E6765744D6F64656C28292C6F3D692E676574416C7465726E617469766556657273696F6E496428292C7B6974656D3A737D3D652C723D5B5D2C613D6E6577204E743B3126747C7C746869732E656469746F722E70757368556E';
wwv_flow_imp.g_varchar2_table(28224) := '646F53746F7028293B636F6E7374206C3D746869732E6765744F7665727772697465496E666F28732C426F6F6C65616E2838267429293B746869732E5F6D656D6F7279536572766963652E6D656D6F72697A6528692C746869732E656469746F722E6765';
wwv_flow_imp.g_varchar2_table(28225) := '74506F736974696F6E28292C73293B636F6E737420633D732E69735265736F6C7665643B6C657420643D2D312C683D2D313B69662841727261792E6973417272617928732E636F6D706C6574696F6E2E6164646974696F6E616C54657874456469747329';
wwv_flow_imp.g_varchar2_table(28226) := '297B746869732E6D6F64656C2E63616E63656C28293B636F6E737420653D48422E6361707475726528746869732E656469746F72293B746869732E656469746F722E657865637574654564697473282273756767657374436F6E74726F6C6C65722E6164';
wwv_flow_imp.g_varchar2_table(28227) := '646974696F6E616C5465787445646974732E73796E63222C732E636F6D706C6574696F6E2E6164646974696F6E616C5465787445646974732E6D61702828653D3E7B6C657420743D72682E6C69667428652E72616E6765293B696628742E73746172744C';
wwv_flow_imp.g_varchar2_table(28228) := '696E654E756D6265723D3D3D732E706F736974696F6E2E6C696E654E756D6265722626742E7374617274436F6C756D6E3E732E706F736974696F6E2E636F6C756D6E297B636F6E737420653D746869732E656469746F722E676574506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(28229) := '292E636F6C756D6E2D732E706F736974696F6E2E636F6C756D6E2C6E3D652C693D72682E7370616E734D756C7469706C654C696E65732874293F303A653B743D6E657720726828742E73746172744C696E654E756D6265722C742E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(28230) := '6D6E2B6E2C742E656E644C696E654E756D6265722C742E656E64436F6C756D6E2B69297D72657475726E206A712E7265706C6163654D6F766528742C652E74657874297D2929292C652E726573746F726552656C6174697665566572746963616C506F73';
wwv_flow_imp.g_varchar2_table(28231) := '6974696F6E4F66437572736F7228746869732E656469746F72297D656C7365206966282163297B636F6E737420653D6E65772066743B6C6574206E3B636F6E7374206F3D692E6F6E4469644368616E6765436F6E74656E742828653D3E7B696628652E69';
wwv_flow_imp.g_varchar2_table(28232) := '73466C7573682972657475726E20612E63616E63656C28292C766F6964206F2E646973706F736528293B666F7228636F6E73742074206F6620652E6368616E676573297B636F6E737420653D72682E676574456E64506F736974696F6E28742E72616E67';
wwv_flow_imp.g_varchar2_table(28233) := '65293B6E2626216D632E69734265666F726528652C6E297C7C286E3D65297D7D29292C6C3D743B747C3D323B6C657420633D21313B636F6E737420643D746869732E656469746F722E6F6E57696C6C54797065282828293D3E7B642E646973706F736528';
wwv_flow_imp.g_varchar2_table(28234) := '292C633D21302C32266C7C7C746869732E656469746F722E70757368556E646F53746F7028297D29293B722E7075736828732E7265736F6C766528612E746F6B656E292E7468656E282828293D3E7B69662821732E636F6D706C6574696F6E2E61646469';
wwv_flow_imp.g_varchar2_table(28235) := '74696F6E616C5465787445646974737C7C612E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6966286E2626732E636F6D706C6574696F6E2E6164646974696F6E616C5465787445646974732E736F6D6528';
wwv_flow_imp.g_varchar2_table(28236) := '28653D3E6D632E69734265666F7265286E2C72682E6765745374617274506F736974696F6E28652E72616E6765292929292972657475726E21313B632626746869732E656469746F722E70757368556E646F53746F7028293B636F6E737420653D48422E';
wwv_flow_imp.g_varchar2_table(28237) := '6361707475726528746869732E656469746F72293B72657475726E20746869732E656469746F722E657865637574654564697473282273756767657374436F6E74726F6C6C65722E6164646974696F6E616C5465787445646974732E6173796E63222C73';
wwv_flow_imp.g_varchar2_table(28238) := '2E636F6D706C6574696F6E2E6164646974696F6E616C5465787445646974732E6D61702828653D3E6A712E7265706C6163654D6F76652872682E6C69667428652E72616E6765292C652E74657874292929292C652E726573746F726552656C6174697665';
wwv_flow_imp.g_varchar2_table(28239) := '566572746963616C506F736974696F6E4F66437572736F7228746869732E656469746F72292C2163262632266C7C7C746869732E656469746F722E70757368556E646F53746F7028292C21307D29292E7468656E2828743D3E7B746869732E5F6C6F6753';
wwv_flow_imp.g_varchar2_table(28240) := '6572766963652E747261636528225B737567676573745D206173796E63207265736F6C76696E67206F6620656469747320444F4E4520286D732C206170706C6965643F29222C652E656C617073656428292C74292C683D21303D3D3D743F313A21313D3D';
wwv_flow_imp.g_varchar2_table(28241) := '3D743F303A2D327D29292E66696E616C6C79282828293D3E7B6F2E646973706F736528292C642E646973706F736528297D2929297D6C65747B696E73657274546578743A757D3D732E636F6D706C6574696F6E3B6966283426732E636F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(28242) := '6E2E696E736572745465787452756C65737C7C28753D696B2E657363617065287529292C746869732E6D6F64656C2E63616E63656C28292C6E2E696E7365727428752C7B6F76657277726974654265666F72653A6C2E6F76657277726974654265666F72';
wwv_flow_imp.g_varchar2_table(28243) := '652C6F766572777269746541667465723A6C2E6F766572777269746541667465722C756E646F53746F704265666F72653A21312C756E646F53746F7041667465723A21312C61646A757374576869746573706163653A21283126732E636F6D706C657469';
wwv_flow_imp.g_varchar2_table(28244) := '6F6E2E696E736572745465787452756C6573292C636C6970626F617264546578743A652E6D6F64656C2E636C6970626F617264546578742C6F766572747970696E6743617074757265723A746869732E5F6F766572747970696E6743617074757265722E';
wwv_flow_imp.g_varchar2_table(28245) := '76616C75657D292C3226747C7C746869732E656469746F722E70757368556E646F53746F7028292C732E636F6D706C6574696F6E2E636F6D6D616E6429696628732E636F6D706C6574696F6E2E636F6D6D616E642E69643D3D3D46342E69642974686973';
wwv_flow_imp.g_varchar2_table(28246) := '2E6D6F64656C2E74726967676572287B6175746F3A21302C7265747269676765723A21307D293B656C73657B636F6E737420653D6E65772066743B722E7075736828746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E';
wwv_flow_imp.g_varchar2_table(28247) := '6428732E636F6D706C6574696F6E2E636F6D6D616E642E69642C2E2E2E732E636F6D706C6574696F6E2E636F6D6D616E642E617267756D656E74733F5B2E2E2E732E636F6D706C6574696F6E2E636F6D6D616E642E617267756D656E74735D3A5B5D292E';
wwv_flow_imp.g_varchar2_table(28248) := '63617463682828653D3E7B732E636F6D706C6574696F6E2E657874656E73696F6E49643F45652865293A6B652865297D29292E66696E616C6C79282828293D3E7B643D652E656C617073656428297D2929297D3426742626746869732E5F616C7465726E';
wwv_flow_imp.g_varchar2_table(28249) := '6174697665732E76616C75652E73657428652C28653D3E7B666F7228612E63616E63656C28293B692E63616E556E646F28293B297B6F213D3D692E676574416C7465726E617469766556657273696F6E496428292626692E756E646F28292C746869732E';
wwv_flow_imp.g_varchar2_table(28250) := '5F696E7365727453756767657374696F6E28652C337C283826743F383A3029293B627265616B7D7D29292C746869732E5F616C657274436F6D706C6574696F6E4974656D2873292C50726F6D6973652E616C6C2872292E66696E616C6C79282828293D3E';
wwv_flow_imp.g_varchar2_table(28251) := '7B746869732E5F7265706F727453756767657374696F6E416363657074656454656C656D6574727928732C692C632C642C68292C746869732E6D6F64656C2E636C65617228292C612E646973706F736528297D29297D5F7265706F727453756767657374';
wwv_flow_imp.g_varchar2_table(28252) := '696F6E416363657074656454656C656D6574727928652C742C6E2C692C6F297B76617220732C722C613B30213D3D4D6174682E666C6F6F72283130302A4D6174682E72616E646F6D2829292626746869732E5F74656C656D65747279536572766963652E';
wwv_flow_imp.g_varchar2_table(28253) := '7075626C69634C6F67322822737567676573742E616363657074656453756767657374696F6E222C7B657874656E73696F6E49643A6E756C6C213D3D28723D6E756C6C3D3D3D28733D652E657874656E73696F6E4964297C7C766F696420303D3D3D733F';
wwv_flow_imp.g_varchar2_table(28254) := '766F696420303A732E76616C7565292626766F69642030213D3D723F723A22756E6B6E6F776E222C70726F766964657249643A6E756C6C213D3D28613D652E70726F76696465722E5F6465627567446973706C61794E616D65292626766F69642030213D';
wwv_flow_imp.g_varchar2_table(28255) := '3D613F613A22756E6B6E6F776E222C6B696E643A652E636F6D706C6574696F6E2E6B696E642C626173656E616D65486173683A5A6F28476C28742E75726929292E746F537472696E67283136292C6C616E677561676549643A742E6765744C616E677561';
wwv_flow_imp.g_varchar2_table(28256) := '6765496428292C66696C65457874656E73696F6E3A516C28742E757269292C7265736F6C7665496E666F3A652E70726F76696465722E7265736F6C7665436F6D706C6574696F6E4974656D3F6E3F313A303A2D312C7265736F6C76654475726174696F6E';
wwv_flow_imp.g_varchar2_table(28257) := '3A652E7265736F6C76654475726174696F6E2C636F6D6D616E644475726174696F6E3A692C6164646974696F6E616C45646974734173796E633A6F7D297D6765744F7665727772697465496E666F28652C74297B796C28746869732E656469746F722E68';
wwv_flow_imp.g_varchar2_table(28258) := '61734D6F64656C2829293B6C6574206E3D227265706C616365223D3D3D746869732E656469746F722E6765744F7074696F6E28313138292E696E736572744D6F64653B742626286E3D216E293B636F6E737420693D652E706F736974696F6E2E636F6C75';
wwv_flow_imp.g_varchar2_table(28259) := '6D6E2D652E6564697453746172742E636F6C756D6E2C6F3D286E3F652E656469745265706C616365456E642E636F6C756D6E3A652E65646974496E73657274456E642E636F6C756D6E292D652E706F736974696F6E2E636F6C756D6E3B72657475726E7B';
wwv_flow_imp.g_varchar2_table(28260) := '6F76657277726974654265666F72653A692B28746869732E656469746F722E676574506F736974696F6E28292E636F6C756D6E2D652E706F736974696F6E2E636F6C756D6E292C6F766572777269746541667465723A6F2B28746869732E5F6C696E6553';
wwv_flow_imp.g_varchar2_table(28261) := '75666669782E76616C75653F746869732E5F6C696E655375666669782E76616C75652E64656C746128746869732E656469746F722E676574506F736974696F6E2829293A30297D7D5F616C657274436F6D706C6574696F6E4974656D2865297B6A682865';
wwv_flow_imp.g_varchar2_table(28262) := '2E636F6D706C6574696F6E2E6164646974696F6E616C5465787445646974732926265872286228302C22416363657074696E6720277B307D27206D616465207B317D206164646974696F6E616C206564697473222C652E746578744C6162656C2C652E63';
wwv_flow_imp.g_varchar2_table(28263) := '6F6D706C6574696F6E2E6164646974696F6E616C5465787445646974732E6C656E67746829297D747269676765725375676765737428652C742C6E297B746869732E656469746F722E6861734D6F64656C2829262628746869732E6D6F64656C2E747269';
wwv_flow_imp.g_varchar2_table(28264) := '67676572287B6175746F3A6E756C6C213D742626742C636F6D706C6574696F6E4F7074696F6E733A7B70726F766964657246696C7465723A652C6B696E6446696C7465723A6E3F6E6577205365743A766F696420307D7D292C746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(28265) := '2E72657665616C506F736974696F6E28746869732E656469746F722E676574506F736974696F6E28292C30292C746869732E656469746F722E666F6375732829297D7472696767657253756767657374416E64416363657074426573742865297B696628';
wwv_flow_imp.g_varchar2_table(28266) := '21746869732E656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E656469746F722E676574506F736974696F6E28292C6E3D28293D3E7B742E657175616C7328746869732E656469746F722E676574506F7369';
wwv_flow_imp.g_varchar2_table(28267) := '74696F6E2829292626746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652E66616C6C6261636B297D2C693D653D3E7B6966283426652E636F6D706C6574696F6E2E696E736572745465787452756C65737C7C65';
wwv_flow_imp.g_varchar2_table(28268) := '2E636F6D706C6574696F6E2E6164646974696F6E616C5465787445646974732972657475726E21303B636F6E737420743D746869732E656469746F722E676574506F736974696F6E28292C6E3D652E6564697453746172742E636F6C756D6E2C693D742E';
wwv_flow_imp.g_varchar2_table(28269) := '636F6C756D6E3B72657475726E20692D6E213D3D652E636F6D706C6574696F6E2E696E73657274546578742E6C656E6774687C7C746869732E656469746F722E6765744D6F64656C28292E67657456616C7565496E52616E6765287B73746172744C696E';
wwv_flow_imp.g_varchar2_table(28270) := '654E756D6265723A742E6C696E654E756D6265722C7374617274436F6C756D6E3A6E2C656E644C696E654E756D6265723A742E6C696E654E756D6265722C656E64436F6C756D6E3A697D29213D3D652E636F6D706C6574696F6E2E696E73657274546578';
wwv_flow_imp.g_varchar2_table(28271) := '747D3B76742E6F6E636528746869732E6D6F64656C2E6F6E44696454726967676572292828653D3E7B636F6E737420743D5B5D3B76742E616E7928746869732E6D6F64656C2E6F6E446964547269676765722C746869732E6D6F64656C2E6F6E44696443';
wwv_flow_imp.g_varchar2_table(28272) := '616E63656C29282828293D3E7B6F742874292C6E28297D292C766F696420302C74292C746869732E6D6F64656C2E6F6E446964537567676573742828287B636F6D706C6574696F6E4D6F64656C3A657D293D3E7B6966286F742874292C303D3D3D652E69';
wwv_flow_imp.g_varchar2_table(28273) := '74656D732E6C656E6774682972657475726E20766F6964206E28293B636F6E7374206F3D746869732E5F6D656D6F7279536572766963652E73656C65637428746869732E656469746F722E6765744D6F64656C28292C746869732E656469746F722E6765';
wwv_flow_imp.g_varchar2_table(28274) := '74506F736974696F6E28292C652E6974656D73292C733D652E6974656D735B6F5D3B692873293F28746869732E656469746F722E70757368556E646F53746F7028292C746869732E5F696E7365727453756767657374696F6E287B696E6465783A6F2C69';
wwv_flow_imp.g_varchar2_table(28275) := '74656D3A732C6D6F64656C3A657D2C3729293A6E28297D292C766F696420302C74297D29292C746869732E6D6F64656C2E74726967676572287B6175746F3A21312C7368793A21307D292C746869732E656469746F722E72657665616C506F736974696F';
wwv_flow_imp.g_varchar2_table(28276) := '6E28742C30292C746869732E656469746F722E666F63757328297D61636365707453656C656374656453756767657374696F6E28652C74297B636F6E7374206E3D746869732E7769646765742E76616C75652E676574466F63757365644974656D28293B';
wwv_flow_imp.g_varchar2_table(28277) := '6C657420693D303B65262628697C3D34292C74262628697C3D38292C746869732E5F696E7365727453756767657374696F6E286E2C69297D6163636570744E65787453756767657374696F6E28297B746869732E5F616C7465726E6174697665732E7661';
wwv_flow_imp.g_varchar2_table(28278) := '6C75652E6E65787428297D6163636570745072657653756767657374696F6E28297B746869732E5F616C7465726E6174697665732E76616C75652E7072657628297D63616E63656C5375676765737457696467657428297B746869732E6D6F64656C2E63';
wwv_flow_imp.g_varchar2_table(28279) := '616E63656C28292C746869732E6D6F64656C2E636C65617228292C746869732E7769646765742E76616C75652E6869646557696467657428297D666F63757353756767657374696F6E28297B746869732E7769646765742E76616C75652E666F63757353';
wwv_flow_imp.g_varchar2_table(28280) := '656C656374656428297D73656C6563744E65787453756767657374696F6E28297B746869732E7769646765742E76616C75652E73656C6563744E65787428297D73656C6563744E6578745061676553756767657374696F6E28297B746869732E77696467';
wwv_flow_imp.g_varchar2_table(28281) := '65742E76616C75652E73656C6563744E6578745061676528297D73656C6563744C61737453756767657374696F6E28297B746869732E7769646765742E76616C75652E73656C6563744C61737428297D73656C6563745072657653756767657374696F6E';
wwv_flow_imp.g_varchar2_table(28282) := '28297B746869732E7769646765742E76616C75652E73656C65637450726576696F757328297D73656C656374507265765061676553756767657374696F6E28297B746869732E7769646765742E76616C75652E73656C65637450726576696F7573506167';
wwv_flow_imp.g_varchar2_table(28283) := '6528297D73656C656374466972737453756767657374696F6E28297B746869732E7769646765742E76616C75652E73656C656374466972737428297D746F67676C6553756767657374696F6E44657461696C7328297B746869732E7769646765742E7661';
wwv_flow_imp.g_varchar2_table(28284) := '6C75652E746F67676C6544657461696C7328297D746F67676C654578706C61696E4D6F646528297B746869732E7769646765742E76616C75652E746F67676C654578706C61696E4D6F646528297D746F67676C6553756767657374696F6E466F63757328';
wwv_flow_imp.g_varchar2_table(28285) := '297B746869732E7769646765742E76616C75652E746F67676C6544657461696C73466F63757328297D726573657457696467657453697A6528297B746869732E7769646765742E76616C75652E726573657450657273697374656453697A6528297D666F';
wwv_flow_imp.g_varchar2_table(28286) := '72636552656E646572696E6741626F766528297B746869732E7769646765742E76616C75652E666F72636552656E646572696E6741626F766528297D73746F70466F72636552656E646572696E6741626F766528297B746869732E7769646765742E6973';
wwv_flow_imp.g_varchar2_table(28287) := '496E697469616C697A65642626746869732E7769646765742E76616C75652E73746F70466F72636552656E646572696E6741626F766528297D726567697374657253656C6563746F722865297B72657475726E20746869732E5F73656C6563746F72732E';
wwv_flow_imp.g_varchar2_table(28288) := '72656769737465722865297D7D3B4F342E49443D22656469746F722E636F6E747269622E73756767657374436F6E74726F6C6C6572222C4F343D41343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E';
wwv_flow_imp.g_varchar2_table(28289) := '6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(28290) := '223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D292626';
wwv_flow_imp.g_varchar2_table(28291) := '28723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4E3428312C2435292C4E3428322C';
wwv_flow_imp.g_varchar2_table(28292) := '7863292C4E3428332C6364292C4E3428342C7563292C4E3428352C5264292C4E3428362C4F64295D2C4F34293B636C6173732052347B636F6E7374727563746F722865297B746869732E7072696F7269747953656C6563746F723D652C746869732E5F69';
wwv_flow_imp.g_varchar2_table(28293) := '74656D733D6E65772041727261797D72656769737465722865297B6966282D31213D3D746869732E5F6974656D732E696E6465784F66286529297468726F77206E6577204572726F72282256616C756520697320616C7265616479207265676973746572';
wwv_flow_imp.g_varchar2_table(28294) := '656422293B72657475726E20746869732E5F6974656D732E707573682865292C746869732E5F6974656D732E736F7274282828652C74293D3E746869732E7072696F7269747953656C6563746F722874292D746869732E7072696F7269747953656C6563';
wwv_flow_imp.g_varchar2_table(28295) := '746F7228652929292C7B646973706F73653A28293D3E7B636F6E737420743D746869732E5F6974656D732E696E6465784F662865293B743E3D302626746869732E5F6974656D732E73706C69636528742C31297D7D7D676574206974656D734F72646572';
wwv_flow_imp.g_varchar2_table(28296) := '656442795072696F726974794465736328297B72657475726E20746869732E5F6974656D737D7D636C61737320463420657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A46342E69642C6C6162656C3A6228302C22';
wwv_flow_imp.g_varchar2_table(28297) := '54726967676572205375676765737422292C616C6961733A22547269676765722053756767657374222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6C682E686173436F6D706C6574696F6E4974656D50726F766964';
wwv_flow_imp.g_varchar2_table(28298) := '65722C72352E56697369626C652E746F4E6567617465642829292C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323035382C7365636F6E646172793A5B323038375D2C6D61633A7B7072696D61';
wwv_flow_imp.g_varchar2_table(28299) := '72793A3236362C7365636F6E646172793A5B3532312C323038375D7D2C7765696768743A3130307D7D297D72756E28652C742C6E297B636F6E737420693D4F342E6765742874293B69662821692972657475726E3B6C6574206F3B6E2626226F626A6563';
wwv_flow_imp.g_varchar2_table(28300) := '74223D3D747970656F66206E262621303D3D3D6E2E6175746F2626286F3D2130292C692E747269676765725375676765737428766F696420302C6F2C766F69642030297D7D46342E69643D22656469746F722E616374696F6E2E74726967676572537567';
wwv_flow_imp.g_varchar2_table(28301) := '67657374222C4A64284F342E49442C4F342C32292C5A64284634293B636F6E73742042343D3139302C56343D24642E62696E64546F436F6E747269627574696F6E284F342E676574293B5964286E6577205634287B69643A2261636365707453656C6563';
wwv_flow_imp.g_varchar2_table(28302) := '74656453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C72352E486173466F637573656453756767657374696F6E292C68616E646C65722865297B652E61636365707453656C65637465645375';
wwv_flow_imp.g_varchar2_table(28303) := '6767657374696F6E2821302C2131297D2C6B624F7074733A5B7B7072696D6172793A322C6B62457870723A57632E616E642872352E56697369626C652C6C682E74657874496E707574466F637573292C7765696768743A42347D2C7B7072696D6172793A';
wwv_flow_imp.g_varchar2_table(28304) := '332C6B62457870723A57632E616E642872352E56697369626C652C6C682E74657874496E707574466F6375732C72352E41636365707453756767657374696F6E734F6E456E7465722C72352E4D616B65735465787445646974292C7765696768743A4234';
wwv_flow_imp.g_varchar2_table(28305) := '7D5D2C6D656E754F7074733A5B7B6D656E7549643A61352C7469746C653A6228302C22496E7365727422292C67726F75703A226C656674222C6F726465723A312C7768656E3A72352E486173496E73657274416E645265706C61636552616E67652E746F';
wwv_flow_imp.g_varchar2_table(28306) := '4E65676174656428297D2C7B6D656E7549643A61352C7469746C653A6228302C22496E7365727422292C67726F75703A226C656674222C6F726465723A312C7768656E3A57632E616E642872352E486173496E73657274416E645265706C61636552616E';
wwv_flow_imp.g_varchar2_table(28307) := '67652C72352E496E736572744D6F64652E6973457175616C546F2822696E736572742229297D2C7B6D656E7549643A61352C7469746C653A6228302C225265706C61636522292C67726F75703A226C656674222C6F726465723A312C7768656E3A57632E';
wwv_flow_imp.g_varchar2_table(28308) := '616E642872352E486173496E73657274416E645265706C61636552616E67652C72352E496E736572744D6F64652E6973457175616C546F28227265706C6163652229297D5D7D29292C5964286E6577205634287B69643A22616363657074416C7465726E';
wwv_flow_imp.g_varchar2_table(28309) := '617469766553656C656374656453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C6C682E74657874496E707574466F6375732C72352E486173466F637573656453756767657374696F6E292C6B';
wwv_flow_imp.g_varchar2_table(28310) := '624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313032372C7365636F6E646172793A5B313032365D7D2C68616E646C65722865297B652E61636365707453656C6563746564';
wwv_flow_imp.g_varchar2_table(28311) := '53756767657374696F6E2821312C2130297D2C6D656E754F7074733A5B7B6D656E7549643A61352C67726F75703A226C656674222C6F726465723A322C7768656E3A57632E616E642872352E486173496E73657274416E645265706C61636552616E6765';
wwv_flow_imp.g_varchar2_table(28312) := '2C72352E496E736572744D6F64652E6973457175616C546F2822696E736572742229292C7469746C653A6228302C225265706C61636522297D2C7B6D656E7549643A61352C67726F75703A226C656674222C6F726465723A322C7768656E3A57632E616E';
wwv_flow_imp.g_varchar2_table(28313) := '642872352E486173496E73657274416E645265706C61636552616E67652C72352E496E736572744D6F64652E6973457175616C546F28227265706C6163652229292C7469746C653A6228302C22496E7365727422297D5D7D29292C6B632E726567697374';
wwv_flow_imp.g_varchar2_table(28314) := '6572436F6D6D616E64416C696173282261636365707453656C656374656453756767657374696F6E4F6E456E746572222C2261636365707453656C656374656453756767657374696F6E22292C5964286E6577205634287B69643A226869646553756767';
wwv_flow_imp.g_varchar2_table(28315) := '657374576964676574222C707265636F6E646974696F6E3A72352E56697369626C652C68616E646C65723A653D3E652E63616E63656C5375676765737457696467657428292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E7465';
wwv_flow_imp.g_varchar2_table(28316) := '7874496E707574466F6375732C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D29292C5964286E6577205634287B69643A2273656C6563744E65787453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E64';
wwv_flow_imp.g_varchar2_table(28317) := '2872352E56697369626C652C57632E6F722872352E4D756C7469706C6553756767657374696F6E732C72352E486173466F637573656453756767657374696F6E2E6E6567617465282929292C68616E646C65723A653D3E652E73656C6563744E65787453';
wwv_flow_imp.g_varchar2_table(28318) := '756767657374696F6E28292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31382C7365636F6E646172793A5B323036365D2C6D61633A7B7072696D6172793A31382C73';
wwv_flow_imp.g_varchar2_table(28319) := '65636F6E646172793A5B323036362C3330305D7D7D7D29292C5964286E6577205634287B69643A2273656C6563744E6578745061676553756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C57632E';
wwv_flow_imp.g_varchar2_table(28320) := '6F722872352E4D756C7469706C6553756767657374696F6E732C72352E486173466F637573656453756767657374696F6E2E6E6567617465282929292C68616E646C65723A653D3E652E73656C6563744E6578745061676553756767657374696F6E2829';
wwv_flow_imp.g_varchar2_table(28321) := '2C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31322C7365636F6E646172793A5B323036305D7D7D29292C5964286E6577205634287B69643A2273656C6563744C6173';
wwv_flow_imp.g_varchar2_table(28322) := '7453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C57632E6F722872352E4D756C7469706C6553756767657374696F6E732C72352E486173466F637573656453756767657374696F6E2E6E6567';
wwv_flow_imp.g_varchar2_table(28323) := '617465282929292C68616E646C65723A653D3E652E73656C6563744C61737453756767657374696F6E28297D29292C5964286E6577205634287B69643A2273656C6563745072657653756767657374696F6E222C707265636F6E646974696F6E3A57632E';
wwv_flow_imp.g_varchar2_table(28324) := '616E642872352E56697369626C652C57632E6F722872352E4D756C7469706C6553756767657374696F6E732C72352E486173466F637573656453756767657374696F6E2E6E6567617465282929292C68616E646C65723A653D3E652E73656C6563745072';
wwv_flow_imp.g_varchar2_table(28325) := '657653756767657374696F6E28292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31362C7365636F6E646172793A5B323036345D2C6D61633A7B7072696D6172793A31';
wwv_flow_imp.g_varchar2_table(28326) := '362C7365636F6E646172793A5B323036342C3330325D7D7D7D29292C5964286E6577205634287B69643A2273656C656374507265765061676553756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C';
wwv_flow_imp.g_varchar2_table(28327) := '57632E6F722872352E4D756C7469706C6553756767657374696F6E732C72352E486173466F637573656453756767657374696F6E2E6E6567617465282929292C68616E646C65723A653D3E652E73656C656374507265765061676553756767657374696F';
wwv_flow_imp.g_varchar2_table(28328) := '6E28292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A31312C7365636F6E646172793A5B323035395D7D7D29292C5964286E6577205634287B69643A2273656C656374';
wwv_flow_imp.g_varchar2_table(28329) := '466972737453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C57632E6F722872352E4D756C7469706C6553756767657374696F6E732C72352E486173466F637573656453756767657374696F6E';
wwv_flow_imp.g_varchar2_table(28330) := '2E6E6567617465282929292C68616E646C65723A653D3E652E73656C656374466972737453756767657374696F6E28297D29292C5964286E6577205634287B69643A22666F63757353756767657374696F6E222C707265636F6E646974696F6E3A57632E';
wwv_flow_imp.g_varchar2_table(28331) := '616E642872352E56697369626C652C72352E486173466F637573656453756767657374696F6E2E6E65676174652829292C68616E646C65723A653D3E652E666F63757353756767657374696F6E28292C6B624F7074733A7B7765696768743A42342C6B62';
wwv_flow_imp.g_varchar2_table(28332) := '457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323035382C7365636F6E646172793A5B323038375D2C6D61633A7B7072696D6172793A3236362C7365636F6E646172793A5B323038375D7D7D7D29292C5964286E65772056';
wwv_flow_imp.g_varchar2_table(28333) := '34287B69643A22666F637573416E6441636365707453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C72352E486173466F637573656453756767657374696F6E2E6E65676174652829292C6861';
wwv_flow_imp.g_varchar2_table(28334) := '6E646C65723A653D3E7B652E666F63757353756767657374696F6E28292C652E61636365707453656C656374656453756767657374696F6E2821302C2131297D7D29292C5964286E6577205634287B69643A22746F67676C6553756767657374696F6E44';
wwv_flow_imp.g_varchar2_table(28335) := '657461696C73222C707265636F6E646974696F6E3A57632E616E642872352E56697369626C652C72352E486173466F637573656453756767657374696F6E292C68616E646C65723A653D3E652E746F67676C6553756767657374696F6E44657461696C73';
wwv_flow_imp.g_varchar2_table(28336) := '28292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323035382C7365636F6E646172793A5B323038375D2C6D61633A7B7072696D6172793A3236362C7365636F6E6461';
wwv_flow_imp.g_varchar2_table(28337) := '72793A5B323038375D7D7D2C6D656E754F7074733A5B7B6D656E7549643A61352C67726F75703A227269676874222C6F726465723A312C7768656E3A57632E616E642872352E44657461696C7356697369626C652C72352E43616E5265736F6C7665292C';
wwv_flow_imp.g_varchar2_table(28338) := '7469746C653A6228302C2273686F77206C65737322297D2C7B6D656E7549643A61352C67726F75703A227269676874222C6F726465723A312C7768656E3A57632E616E642872352E44657461696C7356697369626C652E746F4E65676174656428292C72';
wwv_flow_imp.g_varchar2_table(28339) := '352E43616E5265736F6C7665292C7469746C653A6228302C2273686F77206D6F726522297D5D7D29292C5964286E6577205634287B69643A22746F67676C654578706C61696E4D6F6465222C707265636F6E646974696F6E3A72352E56697369626C652C';
wwv_flow_imp.g_varchar2_table(28340) := '68616E646C65723A653D3E652E746F67676C654578706C61696E4D6F646528292C6B624F7074733A7B7765696768743A3130302C7072696D6172793A323133387D7D29292C5964286E6577205634287B69643A22746F67676C6553756767657374696F6E';
wwv_flow_imp.g_varchar2_table(28341) := '466F637573222C707265636F6E646974696F6E3A72352E56697369626C652C68616E646C65723A653D3E652E746F67676C6553756767657374696F6E466F63757328292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874';
wwv_flow_imp.g_varchar2_table(28342) := '496E707574466F6375732C7072696D6172793A323537302C6D61633A7B7072696D6172793A3737387D7D7D29292C5964286E6577205634287B69643A22696E7365727442657374436F6D706C6574696F6E222C707265636F6E646974696F6E3A57632E61';
wwv_flow_imp.g_varchar2_table(28343) := '6E64286C682E74657874496E707574466F6375732C57632E657175616C732822636F6E6669672E656469746F722E746162436F6D706C6574696F6E222C226F6E22292C4B352E4174456E642C72352E56697369626C652E746F4E65676174656428292C51';
wwv_flow_imp.g_varchar2_table(28344) := '352E4F7468657253756767657374696F6E732E746F4E65676174656428292C4E352E496E536E69707065744D6F64652E746F4E6567617465642829292C68616E646C65723A28652C74293D3E7B652E7472696767657253756767657374416E6441636365';
wwv_flow_imp.g_varchar2_table(28345) := '70744265737428756C2874293F7B66616C6C6261636B3A22746162222C2E2E2E747D3A7B66616C6C6261636B3A22746162227D297D2C6B624F7074733A7B7765696768743A42342C7072696D6172793A327D7D29292C5964286E6577205634287B69643A';
wwv_flow_imp.g_varchar2_table(28346) := '22696E736572744E65787453756767657374696F6E222C707265636F6E646974696F6E3A57632E616E64286C682E74657874496E707574466F6375732C57632E657175616C732822636F6E6669672E656469746F722E746162436F6D706C6574696F6E22';
wwv_flow_imp.g_varchar2_table(28347) := '2C226F6E22292C51352E4F7468657253756767657374696F6E732C72352E56697369626C652E746F4E65676174656428292C4E352E496E536E69707065744D6F64652E746F4E6567617465642829292C68616E646C65723A653D3E652E6163636570744E';
wwv_flow_imp.g_varchar2_table(28348) := '65787453756767657374696F6E28292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A327D7D29292C5964286E6577205634287B69643A22696E73657274507265765375';
wwv_flow_imp.g_varchar2_table(28349) := '6767657374696F6E222C707265636F6E646974696F6E3A57632E616E64286C682E74657874496E707574466F6375732C57632E657175616C732822636F6E6669672E656469746F722E746162436F6D706C6574696F6E222C226F6E22292C51352E4F7468';
wwv_flow_imp.g_varchar2_table(28350) := '657253756767657374696F6E732C72352E56697369626C652E746F4E65676174656428292C4E352E496E536E69707065744D6F64652E746F4E6567617465642829292C68616E646C65723A653D3E652E6163636570745072657653756767657374696F6E';
wwv_flow_imp.g_varchar2_table(28351) := '28292C6B624F7074733A7B7765696768743A42342C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A313032367D7D29292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B737570';
wwv_flow_imp.g_varchar2_table(28352) := '6572287B69643A22656469746F722E616374696F6E2E72657365745375676765737453697A65222C6C6162656C3A6228302C2252657365742053756767657374205769646765742053697A6522292C616C6961733A225265736574205375676765737420';
wwv_flow_imp.g_varchar2_table(28353) := '5769646765742053697A65222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B766172206E3B6E756C6C3D3D3D286E3D4F342E676574287429297C7C766F696420303D3D3D6E7C7C6E2E726573657457696467657453697A';
wwv_flow_imp.g_varchar2_table(28354) := '6528297D7D293B636C617373207A3420657874656E6473206C747B6765742073656C65637465644974656D28297B72657475726E20746869732E5F73656C65637465644974656D7D636F6E7374727563746F7228652C742C6E2C69297B73757065722829';
wwv_flow_imp.g_varchar2_table(28355) := '2C746869732E656469746F723D652C746869732E73756767657374436F6E74726F6C6C657250726573656C6563746F723D742C746869732E636865636B4D6F64656C56657273696F6E3D6E2C746869732E6F6E57696C6C4163636570743D692C74686973';
wwv_flow_imp.g_varchar2_table(28356) := '2E69735375676765737457696467657456697369626C653D21312C746869732E697353686966744B6579507265737365643D21312C746869732E5F69734163746976653D21312C746869732E5F63757272656E74537567676573744974656D496E666F3D';
wwv_flow_imp.g_varchar2_table(28357) := '766F696420302C746869732E5F73656C65637465644974656D3D245428746869732C766F69642030292C746869732E5F726567697374657228652E6F6E4B6579446F776E2828653D3E7B652E73686966744B6579262621746869732E697353686966744B';
wwv_flow_imp.g_varchar2_table(28358) := '657950726573736564262628746869732E697353686966744B6579507265737365643D21302C746869732E75706461746528746869732E5F697341637469766529297D2929292C746869732E5F726567697374657228652E6F6E4B657955702828653D3E';
wwv_flow_imp.g_varchar2_table(28359) := '7B652E73686966744B65792626746869732E697353686966744B657950726573736564262628746869732E697353686966744B6579507265737365643D21312C746869732E75706461746528746869732E5F697341637469766529297D2929293B636F6E';
wwv_flow_imp.g_varchar2_table(28360) := '7374206F3D4F342E67657428746869732E656469746F72293B6966286F297B746869732E5F7265676973746572286F2E726567697374657253656C6563746F72287B7072696F726974793A3130302C73656C6563743A28652C742C6E293D3E7B48542828';
wwv_flow_imp.g_varchar2_table(28361) := '653D3E746869732E636865636B4D6F64656C56657273696F6E28652929293B636F6E737420693D746869732E656469746F722E6765744D6F64656C28293B69662821692972657475726E2D313B636F6E737420733D746869732E73756767657374436F6E';
wwv_flow_imp.g_varchar2_table(28362) := '74726F6C6C657250726573656C6563746F7228292C723D733F4B3328732C69293A766F696420303B69662821722972657475726E2D313B636F6E737420613D6D632E6C6966742874292C6C3D4375286E2E6D6170282828652C74293D3E7B636F6E737420';
wwv_flow_imp.g_varchar2_table(28363) := '6E3D4B332848342E66726F6D53756767657374696F6E286F2C692C612C652C746869732E697353686966744B657950726573736564292E746F53696E676C65546578744564697428292C69293B72657475726E7B696E6465783A742C76616C69643A4733';
wwv_flow_imp.g_varchar2_table(28364) := '28722C6E292C7072656669784C656E6774683A6E2E746578742E6C656E6774682C737567676573744974656D3A657D7D29292E66696C7465722828653D3E652626652E76616C69642626652E7072656669784C656E6774683E3029292C65752828653D3E';
wwv_flow_imp.g_varchar2_table(28365) := '652E7072656669784C656E677468292C747529293B72657475726E206C3F6C2E696E6465783A2D317D7D29293B6C657420653D21313B636F6E737420743D28293D3E7B657C7C28653D21302C746869732E5F7265676973746572286F2E7769646765742E';
wwv_flow_imp.g_varchar2_table(28366) := '76616C75652E6F6E44696453686F77282828293D3E7B746869732E69735375676765737457696467657456697369626C653D21302C746869732E757064617465282130297D2929292C746869732E5F7265676973746572286F2E7769646765742E76616C';
wwv_flow_imp.g_varchar2_table(28367) := '75652E6F6E44696448696465282828293D3E7B746869732E69735375676765737457696467657456697369626C653D21312C746869732E757064617465282131297D2929292C746869732E5F7265676973746572286F2E7769646765742E76616C75652E';
wwv_flow_imp.g_varchar2_table(28368) := '6F6E446964466F637573282828293D3E7B746869732E69735375676765737457696467657456697369626C653D21302C746869732E757064617465282130297D292929297D3B746869732E5F72656769737465722876742E6F6E6365286F2E6D6F64656C';
wwv_flow_imp.g_varchar2_table(28369) := '2E6F6E44696454726967676572292828653D3E7B7428297D2929292C746869732E5F7265676973746572286F2E6F6E57696C6C496E73657274537567676573744974656D2828653D3E7B636F6E737420743D746869732E656469746F722E676574506F73';
wwv_flow_imp.g_varchar2_table(28370) := '6974696F6E28292C6E3D746869732E656469746F722E6765744D6F64656C28293B69662821747C7C216E2972657475726E3B636F6E737420693D48342E66726F6D53756767657374696F6E286F2C6E2C742C652E6974656D2C746869732E697353686966';
wwv_flow_imp.g_varchar2_table(28371) := '744B657950726573736564293B746869732E6F6E57696C6C4163636570742869297D2929297D746869732E75706461746528746869732E5F6973416374697665297D7570646174652865297B636F6E737420743D746869732E6765745375676765737449';
wwv_flow_imp.g_varchar2_table(28372) := '74656D496E666F28293B766172206E2C693B746869732E5F69734163746976653D3D3D65262628286E3D746869732E5F63757272656E74537567676573744974656D496E666F293D3D3D28693D74297C7C6E26266926266E2E657175616C73286929297C';
wwv_flow_imp.g_varchar2_table(28373) := '7C28746869732E5F69734163746976653D652C746869732E5F63757272656E74537567676573744974656D496E666F3D742C48542828653D3E7B746869732E636865636B4D6F64656C56657273696F6E2865292C746869732E5F73656C65637465644974';
wwv_flow_imp.g_varchar2_table(28374) := '656D2E73657428746869732E5F69734163746976653F746869732E5F63757272656E74537567676573744974656D496E666F3A766F696420302C65297D2929297D676574537567676573744974656D496E666F28297B636F6E737420653D4F342E676574';
wwv_flow_imp.g_varchar2_table(28375) := '28746869732E656469746F72293B69662821657C7C21746869732E69735375676765737457696467657456697369626C652972657475726E3B636F6E737420743D652E7769646765742E76616C75652E676574466F63757365644974656D28292C6E3D74';
wwv_flow_imp.g_varchar2_table(28376) := '6869732E656469746F722E676574506F736974696F6E28292C693D746869732E656469746F722E6765744D6F64656C28293B72657475726E207426266E2626693F48342E66726F6D53756767657374696F6E28652C692C6E2C742E6974656D2C74686973';
wwv_flow_imp.g_varchar2_table(28377) := '2E697353686966744B657950726573736564293A766F696420307D73746F70466F72636552656E646572696E6741626F766528297B636F6E737420653D4F342E67657428746869732E656469746F72293B6E756C6C3D3D657C7C652E73746F70466F7263';
wwv_flow_imp.g_varchar2_table(28378) := '6552656E646572696E6741626F766528297D666F72636552656E646572696E6741626F766528297B636F6E737420653D4F342E67657428746869732E656469746F72293B6E756C6C3D3D657C7C652E666F72636552656E646572696E6741626F76652829';
wwv_flow_imp.g_varchar2_table(28379) := '7D7D636C6173732048347B7374617469632066726F6D53756767657374696F6E28652C742C6E2C692C6F297B6C65747B696E73657274546578743A737D3D692E636F6D706C6574696F6E2C723D21313B6966283426692E636F6D706C6574696F6E2E696E';
wwv_flow_imp.g_varchar2_table(28380) := '736572745465787452756C6573297B636F6E737420653D286E657720696B292E70617273652873293B652E6368696C6472656E2E6C656E6774683C313030262654352E61646A7573745768697465737061636528742C6E2C21302C65292C733D652E746F';
wwv_flow_imp.g_varchar2_table(28381) := '537472696E6728292C723D21307D636F6E737420613D652E6765744F7665727772697465496E666F28692C6F293B72657475726E206E65772048342872682E66726F6D506F736974696F6E73286E2E64656C746128302C2D612E6F766572777269746542';
wwv_flow_imp.g_varchar2_table(28382) := '65666F7265292C6E2E64656C746128302C4D6174682E6D617828612E6F766572777269746541667465722C302929292C732C692E636F6D706C6574696F6E2E6B696E642C72297D636F6E7374727563746F7228652C742C6E2C69297B746869732E72616E';
wwv_flow_imp.g_varchar2_table(28383) := '67653D652C746869732E696E73657274546578743D742C746869732E636F6D706C6574696F6E4974656D4B696E643D6E2C746869732E6973536E6970706574546578743D697D657175616C732865297B72657475726E20746869732E72616E67652E6571';
wwv_flow_imp.g_varchar2_table(28384) := '75616C7352616E676528652E72616E6765292626746869732E696E73657274546578743D3D3D652E696E73657274546578742626746869732E636F6D706C6574696F6E4974656D4B696E643D3D3D652E636F6D706C6574696F6E4974656D4B696E642626';
wwv_flow_imp.g_varchar2_table(28385) := '746869732E6973536E6970706574546578743D3D3D652E6973536E6970706574546578747D746F53656C656374656453756767657374696F6E496E666F28297B72657475726E206E6577206B7728746869732E72616E67652C746869732E696E73657274';
wwv_flow_imp.g_varchar2_table(28386) := '546578742C746869732E636F6D706C6574696F6E4974656D4B696E642C746869732E6973536E697070657454657874297D746F53696E676C65546578744564697428297B72657475726E206E657720557A28746869732E72616E67652C746869732E696E';
wwv_flow_imp.g_varchar2_table(28387) := '7365727454657874297D7D7661722057342C6A343D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742071343D57343D636C61737320657874656E6473206C747B737461746963';
wwv_flow_imp.g_varchar2_table(28388) := '206765742865297B72657475726E20652E676574436F6E747269627574696F6E2857342E4944297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C63297B737570657228292C746869732E656469746F723D652C746869732E';
wwv_flow_imp.g_varchar2_table(28389) := '5F696E7374616E74696174696F6E536572766963653D742C746869732E5F636F6E746578744B6579536572766963653D6E2C746869732E5F636F6E66696775726174696F6E536572766963653D692C746869732E5F636F6D6D616E64536572766963653D';
wwv_flow_imp.g_varchar2_table(28390) := '6F2C746869732E5F6465626F756E6365536572766963653D732C746869732E5F6C616E67756167654665617475726573536572766963653D722C746869732E5F6163636573736962696C6974795369676E616C536572766963653D612C746869732E5F6B';
wwv_flow_imp.g_varchar2_table(28391) := '657962696E64696E67536572766963653D6C2C746869732E5F6163636573736962696C697479536572766963653D632C746869732E6D6F64656C3D746869732E5F7265676973746572284B542822696E6C696E65436F6D706C6574696F6E4D6F64656C22';
wwv_flow_imp.g_varchar2_table(28392) := '2C766F6964203029292C746869732E5F746578744D6F64656C56657273696F6E49643D245428746869732C2D31292C746869732E5F706F736974696F6E733D66756E6374696F6E28652C74297B766172206E3B72657475726E206E6577205554286E6577';
wwv_flow_imp.g_varchar2_table(28393) := '20545428652E6F776E65722C652E64656275674E616D652C766F69642030292C742C6E756C6C213D3D286E3D652E657175616C73466E292626766F69642030213D3D6E3F6E3A4C54297D287B6F776E65723A746869732C657175616C73466E3A44542828';
wwv_flow_imp.g_varchar2_table(28394) := '28652C74293D3E652E657175616C7328742929297D2C5B6E6577206D6328312C31295D292C746869732E5F7375676765737457696467657441646170746F723D746869732E5F7265676973746572286E6577207A3428746869732E656469746F722C2828';
wwv_flow_imp.g_varchar2_table(28395) := '293D3E7B76617220652C743B72657475726E206E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D653F766F696420303A652E73656C6563746564496E6C696E65436F6D706C657469';
wwv_flow_imp.g_varchar2_table(28396) := '6F6E2E6765742829297C7C766F696420303D3D3D743F766F696420303A742E746F53696E676C65546578744564697428766F69642030297D292C28653D3E746869732E7570646174654F627365727661626C657328652C4F352E4F7468657229292C2865';
wwv_flow_imp.g_varchar2_table(28397) := '3D3E7B48542828743D3E7B766172206E3B746869732E7570646174654F627365727661626C657328742C4F352E4F74686572292C6E756C6C3D3D3D286E3D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D6E7C7C6E2E68616E646C';
wwv_flow_imp.g_varchar2_table(28398) := '655375676765737441636365707465642865297D29297D2929292C746869732E5F656E61626C6564496E436F6E6669673D614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E746869732E65';
wwv_flow_imp.g_varchar2_table(28399) := '6469746F722E6765744F7074696F6E283632292E656E61626C656429292C746869732E5F697353637265656E526561646572456E61626C65643D614928746869732E5F6163636573736962696C697479536572766963652E6F6E4469644368616E676553';
wwv_flow_imp.g_varchar2_table(28400) := '637265656E5265616465724F7074696D697A65642C2828293D3E746869732E5F6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A6564282929292C746869732E5F656469746F7244696374617469';
wwv_flow_imp.g_varchar2_table(28401) := '6F6E496E50726F67726573733D614928746869732E5F636F6E746578744B6579536572766963652E6F6E4469644368616E6765436F6E746578742C2828293D3E21303D3D3D746869732E5F636F6E746578744B6579536572766963652E676574436F6E74';
wwv_flow_imp.g_varchar2_table(28402) := '65787428746869732E656469746F722E676574446F6D4E6F64652829292E67657456616C75652822656469746F72446963746174696F6E2E696E50726F6772657373222929292C746869732E5F656E61626C65643D515428746869732C28653D3E746869';
wwv_flow_imp.g_varchar2_table(28403) := '732E5F656E61626C6564496E436F6E6669672E7265616428652926262821746869732E5F697353637265656E526561646572456E61626C65642E726561642865297C7C21746869732E5F656469746F72446963746174696F6E496E50726F67726573732E';
wwv_flow_imp.g_varchar2_table(28404) := '726561642865292929292C746869732E5F666F6E7446616D696C793D614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E746869732E656469746F722E6765744F7074696F6E283632292E66';
wwv_flow_imp.g_varchar2_table(28405) := '6F6E7446616D696C7929292C746869732E5F67686F737454657874733D515428746869732C28653D3E7B76617220743B636F6E7374206E3D746869732E6D6F64656C2E726561642865293B72657475726E206E756C6C213D3D28743D6E756C6C3D3D6E3F';
wwv_flow_imp.g_varchar2_table(28406) := '766F696420303A6E2E67686F737454657874732E72656164286529292626766F69642030213D3D743F743A5B5D7D29292C746869732E5F737461626C697A656447686F737454657874733D66756E6374696F6E28652C74297B636F6E7374206E3D245428';
wwv_flow_imp.g_varchar2_table(28407) := '22726573756C74222C5B5D292C693D5B5D3B72657475726E20742E6164642865492828743D3E7B636F6E7374206F3D652E726561642874293B48542828653D3E7B6966286F2E6C656E677468213D3D692E6C656E677468297B692E6C656E6774683D6F2E';
wwv_flow_imp.g_varchar2_table(28408) := '6C656E6774683B666F72286C657420653D303B653C692E6C656E6774683B652B2B29695B655D7C7C28695B655D3D245428226974656D222C6F5B655D29293B6E2E736574285B2E2E2E695D2C65297D692E666F7245616368282828742C6E293D3E742E73';
wwv_flow_imp.g_varchar2_table(28409) := '6574286F5B6E5D2C652929297D29297D2929292C6E7D28746869732E5F67686F737454657874732C746869732E5F73746F7265292C746869732E5F67686F737454657874576964676574733D66756E6374696F6E28652C742C6E297B6C657420693D6E65';
wwv_flow_imp.g_varchar2_table(28410) := '77206D49286E2C766F69642030293B72657475726E205954287B64656275675265666572656E6365466E3A6E2C6F776E65723A652C6F6E4C6173744F6273657276657252656D6F7665643A28293D3E7B692E646973706F736528292C693D6E6577206D49';
wwv_flow_imp.g_varchar2_table(28411) := '286E297D7D2C28653D3E28692E7365744974656D7328742E72656164286529292C692E6765744974656D7328292929297D28746869732C746869732E5F737461626C697A656447686F737454657874732C2828652C74293D3E742E61646428746869732E';
wwv_flow_imp.g_varchar2_table(28412) := '5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652842332C746869732E656469746F722C7B67686F7374546578743A652C6D696E52657365727665644C696E65436F756E743A73492830292C7461726765745465';
wwv_flow_imp.g_varchar2_table(28413) := '78744D6F64656C3A746869732E6D6F64656C2E6D61702828653D3E6E756C6C3D3D653F766F696420303A652E746578744D6F64656C29297D292929292E7265636F6D70757465496E697469616C6C79416E644F6E4368616E676528746869732E5F73746F';
wwv_flow_imp.g_varchar2_table(28414) := '7265292C746869732E5F6465626F756E636556616C75653D746869732E5F6465626F756E6365536572766963652E666F7228746869732E5F6C616E67756167654665617475726573536572766963652E696E6C696E65436F6D706C6574696F6E7350726F';
wwv_flow_imp.g_varchar2_table(28415) := '76696465722C22496E6C696E65436F6D706C6574696F6E734465626F756E6365222C7B6D696E3A35302C6D61783A35307D292C746869732E5F706C61794163636573736962696C6974795369676E616C3D68492874686973292C746869732E5F69735265';
wwv_flow_imp.g_varchar2_table(28416) := '61646F6E6C793D614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E746869732E656469746F722E6765744F7074696F6E2839312929292C746869732E5F746578744D6F64656C3D61492874';
wwv_flow_imp.g_varchar2_table(28417) := '6869732E656469746F722E6F6E4469644368616E67654D6F64656C2C2828293D3E746869732E656469746F722E6765744D6F64656C282929292C746869732E5F746578744D6F64656C49665772697461626C653D51542828653D3E746869732E5F697352';
wwv_flow_imp.g_varchar2_table(28418) := '6561646F6E6C792E726561642865293F766F696420303A746869732E5F746578744D6F64656C2E7265616428652929292C746869732E5F7265676973746572286E6577206B3328746869732E5F636F6E746578744B6579536572766963652C746869732E';
wwv_flow_imp.g_varchar2_table(28419) := '6D6F64656C29292C746869732E5F726567697374657228654928286E3D3E7B636F6E737420693D746869732E5F746578744D6F64656C49665772697461626C652E72656164286E293B485428286E3D3E7B696628746869732E6D6F64656C2E7365742876';
wwv_flow_imp.g_varchar2_table(28420) := '6F696420302C6E292C746869732E7570646174654F627365727661626C6573286E2C4F352E4F74686572292C69297B636F6E7374206F3D742E637265617465496E7374616E63652846352C692C746869732E5F7375676765737457696467657441646170';
wwv_flow_imp.g_varchar2_table(28421) := '746F722E73656C65637465644974656D2C746869732E5F746578744D6F64656C56657273696F6E49642C746869732E5F706F736974696F6E732C746869732E5F6465626F756E636556616C75652C614928652E6F6E4469644368616E6765436F6E666967';
wwv_flow_imp.g_varchar2_table(28422) := '75726174696F6E2C2828293D3E652E6765744F7074696F6E28313138292E7072657669657729292C614928652E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E652E6765744F7074696F6E28313138292E707265766965774D';
wwv_flow_imp.g_varchar2_table(28423) := '6F646529292C614928652E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E652E6765744F7074696F6E283632292E6D6F646529292C746869732E5F656E61626C6564293B746869732E6D6F64656C2E736574286F2C6E297D7D';
wwv_flow_imp.g_varchar2_table(28424) := '29297D2929293B636F6E737420643D746869732E5F72656769737465722847732829293B746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F666F6E7446616D696C792E726561642865293B642E736574537479';
wwv_flow_imp.g_varchar2_table(28425) := '6C652822223D3D3D747C7C2264656661756C74223D3D3D743F22223A605C6E2E6D6F6E61636F2D656469746F72202E67686F73742D746578742D6465636F726174696F6E2C5C6E2E6D6F6E61636F2D656469746F72202E67686F73742D746578742D6465';
wwv_flow_imp.g_varchar2_table(28426) := '636F726174696F6E2D707265766965772C5C6E2E6D6F6E61636F2D656469746F72202E67686F73742D74657874207B5C6E5C74666F6E742D66616D696C793A20247B747D3B5C6E7D60297D2929293B636F6E737420683D653D3E7B76617220743B726574';
wwv_flow_imp.g_varchar2_table(28427) := '75726E20652E6973556E646F696E673F4F352E556E646F3A652E69735265646F696E673F4F352E5265646F3A286E756C6C3D3D3D28743D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D743F766F696420303A742E697341636365';
wwv_flow_imp.g_varchar2_table(28428) := '7074696E675061727469616C6C79293F4F352E416363657074576F72643A4F352E4F746865727D3B746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E48542828743D3E746869732E757064';
wwv_flow_imp.g_varchar2_table(28429) := '6174654F627365727661626C657328742C682865292929292929292C746869732E5F726567697374657228652E6F6E4469644368616E6765437572736F72506F736974696F6E2828653D3E48542828743D3E7B766172206E3B746869732E757064617465';
wwv_flow_imp.g_varchar2_table(28430) := '4F627365727661626C657328742C4F352E4F74686572292C33213D3D652E726561736F6E26262261706922213D3D652E736F757263657C7C6E756C6C3D3D3D286E3D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D6E7C7C6E2E73';
wwv_flow_imp.g_varchar2_table(28431) := '746F702874297D29292929292C746869732E5F726567697374657228652E6F6E44696454797065282828293D3E48542828653D3E7B76617220743B746869732E7570646174654F627365727661626C657328652C4F352E4F74686572292C746869732E5F';
wwv_flow_imp.g_varchar2_table(28432) := '656E61626C65642E67657428292626286E756C6C3D3D3D28743D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D747C7C742E74726967676572286529297D29292929292C746869732E5F726567697374657228746869732E5F636F';
wwv_flow_imp.g_varchar2_table(28433) := '6D6D616E64536572766963652E6F6E44696445786563757465436F6D6D616E642828743D3E7B6E657720536574285B48532E5461622E69642C48532E44656C6574654C6566742E69642C48532E44656C65746552696768742E69642C726A2C2261636365';
wwv_flow_imp.g_varchar2_table(28434) := '707453656C656374656453756767657374696F6E225D292E68617328742E636F6D6D616E644964292626652E68617354657874466F63757328292626746869732E5F656E61626C65642E6765742829262648542828653D3E7B76617220743B6E756C6C3D';
wwv_flow_imp.g_varchar2_table(28435) := '3D3D28743D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D747C7C742E747269676765722865297D29297D2929292C746869732E5F726567697374657228746869732E656469746F722E6F6E446964426C7572456469746F725769';
wwv_flow_imp.g_varchar2_table(28436) := '64676574282828293D3E7B746869732E5F636F6E746578744B6579536572766963652E676574436F6E746578744B657956616C7565282261636365737369626C6556696577497353686F776E22297C7C746869732E5F636F6E66696775726174696F6E53';
wwv_flow_imp.g_varchar2_table(28437) := '6572766963652E67657456616C75652822656469746F722E696E6C696E65537567676573742E6B6565704F6E426C757222297C7C652E6765744F7074696F6E283632292E6B6565704F6E426C75727C7C516A2E64726F70446F776E56697369626C657C7C';
wwv_flow_imp.g_varchar2_table(28438) := '48542828653D3E7B76617220743B6E756C6C3D3D3D28743D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D747C7C742E73746F702865297D29297D2929292C746869732E5F72656769737465722865492828653D3E7B7661722074';
wwv_flow_imp.g_varchar2_table(28439) := '3B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E6D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E73746174652E726561642865293B286E756C6C3D3D6E3F766F696420303A6E2E7375676765737449';
wwv_flow_imp.g_varchar2_table(28440) := '74656D293F6E2E7072696D61727947686F7374546578742E6C696E65436F756E743E3D322626746869732E5F7375676765737457696467657441646170746F722E666F72636552656E646572696E6741626F766528293A746869732E5F73756767657374';
wwv_flow_imp.g_varchar2_table(28441) := '57696467657441646170746F722E73746F70466F72636552656E646572696E6741626F766528297D2929292C746869732E5F7265676973746572287274282828293D3E7B746869732E5F7375676765737457696467657441646170746F722E73746F7046';
wwv_flow_imp.g_varchar2_table(28442) := '6F72636552656E646572696E6741626F766528297D2929293B636F6E737420753D746869732E5F7265676973746572286E6577206174293B6C657420703B746869732E5F7265676973746572286E49287B68616E646C654368616E67653A28652C74293D';
wwv_flow_imp.g_varchar2_table(28443) := '3E28652E6469644368616E676528746869732E5F706C61794163636573736962696C6974795369676E616C29262628703D766F69642030292C2130297D2C286173796E6328652C74293D3E7B746869732E5F706C61794163636573736962696C69747953';
wwv_flow_imp.g_varchar2_table(28444) := '69676E616C2E726561642865293B636F6E7374206E3D746869732E6D6F64656C2E726561642865292C693D6E756C6C3D3D6E3F766F696420303A6E2E73746174652E726561642865293B6966286E2626692626692E696E6C696E65436F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(28445) := '6E297B696628692E696E6C696E65436F6D706C6574696F6E2E73656D616E7469634964213D3D70297B752E636C65617228292C703D692E696E6C696E65436F6D706C6574696F6E2E73656D616E74696349643B636F6E737420653D6E2E746578744D6F64';
wwv_flow_imp.g_varchar2_table(28446) := '656C2E6765744C696E65436F6E74656E7428692E7072696D61727947686F7374546578742E6C696E654E756D626572293B61776169742057742835302C5074287529292C617761697420664928746869732E5F7375676765737457696467657441646170';
wwv_flow_imp.g_varchar2_table(28447) := '746F722E73656C65637465644974656D2C766C2C2828293D3E2131292C5074287529292C617761697420746869732E5F6163636573736962696C6974795369676E616C536572766963652E706C61795369676E616C286F5A2E696E6C696E655375676765';
wwv_flow_imp.g_varchar2_table(28448) := '7374696F6E292C746869732E656469746F722E6765744F7074696F6E2838292626746869732E70726F7669646553637265656E52656164657255706461746528692E7072696D61727947686F7374546578742E72656E646572466F7253637265656E5265';
wwv_flow_imp.g_varchar2_table(28449) := '61646572286529297D7D656C736520703D766F696420307D2929292C746869732E5F7265676973746572286E657720556A28746869732E656469746F722C746869732E6D6F64656C2C746869732E5F696E7374616E74696174696F6E5365727669636529';
wwv_flow_imp.g_varchar2_table(28450) := '292C746869732E5F726567697374657228746869732E5F636F6E66696775726174696F6E536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E28226163';
wwv_flow_imp.g_varchar2_table(28451) := '636573736962696C6974792E766572626F736974792E696E6C696E65436F6D706C6574696F6E7322292626746869732E656469746F722E7570646174654F7074696F6E73287B696E6C696E65436F6D706C6574696F6E734163636573736962696C697479';
wwv_flow_imp.g_varchar2_table(28452) := '566572626F73653A746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C756528226163636573736962696C6974792E766572626F736974792E696E6C696E65436F6D706C6574696F6E7322297D297D2929292C746869732E';
wwv_flow_imp.g_varchar2_table(28453) := '656469746F722E7570646174654F7074696F6E73287B696E6C696E65436F6D706C6574696F6E734163636573736962696C697479566572626F73653A746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822616363';
wwv_flow_imp.g_varchar2_table(28454) := '6573736962696C6974792E766572626F736974792E696E6C696E65436F6D706C6574696F6E7322297D297D706C61794163636573736962696C6974795369676E616C2865297B746869732E5F706C61794163636573736962696C6974795369676E616C2E';
wwv_flow_imp.g_varchar2_table(28455) := '747269676765722865297D70726F7669646553637265656E5265616465725570646174652865297B636F6E737420743D746869732E5F636F6E746578744B6579536572766963652E676574436F6E746578744B657956616C756528226163636573736962';
wwv_flow_imp.g_varchar2_table(28456) := '6C6556696577497353686F776E22292C6E3D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672822656469746F722E616374696F6E2E61636365737369626C655669657722293B6C657420693B217426';
wwv_flow_imp.g_varchar2_table(28457) := '266E2626746869732E656469746F722E6765744F7074696F6E2831343929262628693D6228302C22496E7370656374207468697320696E207468652061636365737369626C65207669657720287B307D29222C6E2E676574417269614C6162656C282929';
wwv_flow_imp.g_varchar2_table(28458) := '292C587228693F652B222C20222B693A65297D7570646174654F627365727661626C657328652C74297B766172206E2C692C6F3B636F6E737420733D746869732E656469746F722E6765744D6F64656C28293B746869732E5F746578744D6F64656C5665';
wwv_flow_imp.g_varchar2_table(28459) := '7273696F6E49642E736574286E756C6C213D3D286E3D6E756C6C3D3D733F766F696420303A732E67657456657273696F6E49642829292626766F69642030213D3D6E3F6E3A2D312C652C74292C746869732E5F706F736974696F6E732E736574286E756C';
wwv_flow_imp.g_varchar2_table(28460) := '6C213D3D286F3D6E756C6C3D3D3D28693D746869732E656469746F722E67657453656C656374696F6E732829297C7C766F696420303D3D3D693F766F696420303A692E6D61702828653D3E652E676574506F736974696F6E28292929292626766F696420';
wwv_flow_imp.g_varchar2_table(28461) := '30213D3D6F3F6F3A5B6E6577206D6328312C31295D2C65297D73686F756C6453686F77486F76657241742865297B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E6D6F64656C2E6765742829297C7C766F696420303D3D3D743F';
wwv_flow_imp.g_varchar2_table(28462) := '766F696420303A742E7072696D61727947686F7374546578742E67657428293B72657475726E21216E26266E2E70617274732E736F6D652828743D3E652E636F6E7461696E73506F736974696F6E286E6577206D63286E2E6C696E654E756D6265722C74';
wwv_flow_imp.g_varchar2_table(28463) := '2E636F6C756D6E292929297D73686F756C6453686F77486F7665724174566965775A6F6E652865297B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E5F67686F737454657874576964676574732E67';
wwv_flow_imp.g_varchar2_table(28464) := '657428295B305D297C7C766F696420303D3D3D743F766F696420303A742E6F776E73566965775A6F6E65286529292626766F69642030213D3D6E26266E7D7D3B71342E49443D22656469746F722E636F6E747269622E696E6C696E65436F6D706C657469';
wwv_flow_imp.g_varchar2_table(28465) := '6F6E73436F6E74726F6C6C6572222C71343D57343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F70';
wwv_flow_imp.g_varchar2_table(28466) := '6572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E646563';
wwv_flow_imp.g_varchar2_table(28467) := '6F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B7265';
wwv_flow_imp.g_varchar2_table(28468) := '7475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6A3428312C7563292C6A3428322C6364292C6A3428332C6670292C6A3428342C7863292C6A3428352C6456292C6A3428362C7878292C';
wwv_flow_imp.g_varchar2_table(28469) := '6A3428372C745A292C6A3428382C2445292C6A3428392C5953295D2C7134293B636C61737320243420657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A24342E49442C6C6162656C3A6228302C2253686F77204E65';
wwv_flow_imp.g_varchar2_table(28470) := '787420496E6C696E652053756767657374696F6E22292C616C6961733A2253686F77204E65787420496E6C696E652053756767657374696F6E222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6B332E696E6C696E65';
wwv_flow_imp.g_varchar2_table(28471) := '53756767657374696F6E56697369626C65292C6B624F7074733A7B7765696768743A3130302C7072696D6172793A3630367D7D297D6173796E632072756E28652C74297B766172206E3B636F6E737420693D71342E6765742874293B6E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(28472) := '6E3D6E756C6C3D3D693F766F696420303A692E6D6F64656C2E6765742829297C7C766F696420303D3D3D6E7C7C6E2E6E65787428297D7D24342E49443D6C6A3B636C61737320553420657874656E64732055647B636F6E7374727563746F7228297B7375';
wwv_flow_imp.g_varchar2_table(28473) := '706572287B69643A55342E49442C6C6162656C3A6228302C2253686F772050726576696F757320496E6C696E652053756767657374696F6E22292C616C6961733A2253686F772050726576696F757320496E6C696E652053756767657374696F6E222C70';
wwv_flow_imp.g_varchar2_table(28474) := '7265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6B332E696E6C696E6553756767657374696F6E56697369626C65292C6B624F7074733A7B7765696768743A3130302C7072696D6172793A3630347D7D297D6173796E632072';
wwv_flow_imp.g_varchar2_table(28475) := '756E28652C74297B766172206E3B636F6E737420693D71342E6765742874293B6E756C6C3D3D3D286E3D6E756C6C3D3D693F766F696420303A692E6D6F64656C2E6765742829297C7C766F696420303D3D3D6E7C7C6E2E70726576696F757328297D7D55';
wwv_flow_imp.g_varchar2_table(28476) := '342E49443D616A3B636C617373204B3420657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A4B342E49442C6C6162656C3A6228302C224869646520496E6C696E652053756767657374696F6E22292C616C6961733A';
wwv_flow_imp.g_varchar2_table(28477) := '224869646520496E6C696E652053756767657374696F6E222C707265636F6E646974696F6E3A6B332E696E6C696E6553756767657374696F6E56697369626C652C6B624F7074733A7B7765696768743A3130302C7072696D6172793A397D7D297D617379';
wwv_flow_imp.g_varchar2_table(28478) := '6E632072756E28652C74297B636F6E7374206E3D71342E6765742874293B48542828653D3E7B76617220743B6E756C6C3D3D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E6D6F64656C2E6765742829297C7C766F696420303D3D3D747C7C742E73';
wwv_flow_imp.g_varchar2_table(28479) := '746F702865297D29297D7D4B342E49443D22656469746F722E616374696F6E2E696E6C696E65537567676573742E68696465223B636C61737320473420657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A47342E49';
wwv_flow_imp.g_varchar2_table(28480) := '442C7469746C653A6228302C22416C776179732053686F7720546F6F6C62617222292C66313A21312C707265636F6E646974696F6E3A766F696420302C6D656E753A5B7B69643A4C642E496E6C696E6553756767657374696F6E546F6F6C6261722C6772';
wwv_flow_imp.g_varchar2_table(28481) := '6F75703A227365636F6E64617279222C6F726465723A31307D5D2C746F67676C65643A57632E657175616C732822636F6E6669672E656469746F722E696E6C696E65537567676573742E73686F77546F6F6C626172222C22616C7761797322297D297D61';
wwv_flow_imp.g_varchar2_table(28482) := '73796E632072756E28652C74297B636F6E7374206E3D652E676574286670292C693D22616C77617973223D3D3D6E2E67657456616C75652822656469746F722E696E6C696E65537567676573742E73686F77546F6F6C62617222293F226F6E486F766572';
wwv_flow_imp.g_varchar2_table(28483) := '223A22616C77617973223B6E2E75706461746556616C75652822656469746F722E696E6C696E65537567676573742E73686F77546F6F6C626172222C69297D7D47342E49443D22656469746F722E616374696F6E2E696E6C696E65537567676573742E74';
wwv_flow_imp.g_varchar2_table(28484) := '6F67676C65416C7761797353686F77546F6F6C626172223B7661722051343D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732059347B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(28485) := '742C6E297B746869732E6F776E65723D652C746869732E72616E67653D742C746869732E636F6E74726F6C6C65723D6E7D697356616C6964466F72486F766572416E63686F722865297B72657475726E20313D3D3D652E747970652626746869732E7261';
wwv_flow_imp.g_varchar2_table(28486) := '6E67652E7374617274436F6C756D6E3C3D652E72616E67652E7374617274436F6C756D6E2626746869732E72616E67652E656E64436F6C756D6E3E3D652E72616E67652E656E64436F6C756D6E7D7D6C6574205A343D636C6173737B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(28487) := '746F7228652C742C6E2C692C6F2C73297B746869732E5F656469746F723D652C746869732E5F6C616E6775616765536572766963653D742C746869732E5F6F70656E6572536572766963653D6E2C746869732E6163636573736962696C69747953657276';
wwv_flow_imp.g_varchar2_table(28488) := '6963653D692C746869732E5F696E7374616E74696174696F6E536572766963653D6F2C746869732E5F74656C656D65747279536572766963653D732C746869732E686F7665724F7264696E616C3D347D73756767657374486F766572416E63686F722865';
wwv_flow_imp.g_varchar2_table(28489) := '297B636F6E737420743D71342E67657428746869732E5F656469746F72293B69662821742972657475726E206E756C6C3B636F6E7374206E3D652E7461726765743B696628383D3D3D6E2E74797065297B636F6E737420693D6E2E64657461696C3B6966';
wwv_flow_imp.g_varchar2_table(28490) := '28742E73686F756C6453686F77486F7665724174566965775A6F6E6528692E766965775A6F6E654964292972657475726E206E6577204C71283165332C746869732C72682E66726F6D506F736974696F6E7328746869732E5F656469746F722E6765744D';
wwv_flow_imp.g_varchar2_table(28491) := '6F64656C28292E76616C6964617465506F736974696F6E28692E706F736974696F6E4265666F72657C7C692E706F736974696F6E29292C652E6576656E742E706F73782C652E6576656E742E706F73792C2131297D72657475726E20373D3D3D6E2E7479';
wwv_flow_imp.g_varchar2_table(28492) := '70652626742E73686F756C6453686F77486F7665724174286E2E72616E6765297C7C363D3D3D6E2E7479706526266E2E64657461696C2E6D696768744265466F726569676E456C656D656E742626742E73686F756C6453686F77486F7665724174286E2E';
wwv_flow_imp.g_varchar2_table(28493) := '72616E6765293F6E6577204C71283165332C746869732C6E2E72616E67652C652E6576656E742E706F73782C652E6576656E742E706F73792C2131293A6E756C6C7D636F6D7075746553796E6328652C74297B696628226F6E486F76657222213D3D7468';
wwv_flow_imp.g_varchar2_table(28494) := '69732E5F656469746F722E6765744F7074696F6E283632292E73686F77546F6F6C6261722972657475726E5B5D3B636F6E7374206E3D71342E67657428746869732E5F656469746F72293B72657475726E206E26266E2E73686F756C6453686F77486F76';
wwv_flow_imp.g_varchar2_table(28495) := '6572417428652E72616E6765293F5B6E657720593428746869732C652E72616E67652C6E295D3A5B5D7D72656E646572486F766572506172747328652C74297B636F6E7374206E3D6E65772061742C693D745B305D3B746869732E5F74656C656D657472';
wwv_flow_imp.g_varchar2_table(28496) := '79536572766963652E7075626C69634C6F67322822696E6C696E65436F6D706C6574696F6E486F7665722E73686F776E22292C746869732E6163636573736962696C697479536572766963652E697353637265656E5265616465724F7074696D697A6564';
wwv_flow_imp.g_varchar2_table(28497) := '2829262621746869732E5F656469746F722E6765744F7074696F6E2838292626746869732E72656E64657253637265656E5265616465725465787428652C692C6E293B636F6E7374206F3D692E636F6E74726F6C6C65722E6D6F64656C2E67657428292C';
wwv_flow_imp.g_varchar2_table(28498) := '733D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528516A2C746869732E5F656469746F722C21312C7349286E756C6C292C6F2E73656C6563746564496E6C696E65436F6D706C6574696F6E496E';
wwv_flow_imp.g_varchar2_table(28499) := '6465782C6F2E696E6C696E65436F6D706C6574696F6E73436F756E742C6F2E616374697665436F6D6D616E6473293B72657475726E20652E667261676D656E742E617070656E644368696C6428732E676574446F6D4E6F64652829292C6F2E7472696767';
wwv_flow_imp.g_varchar2_table(28500) := '65724578706C696369746C7928292C6E2E6164642873292C6E7D72656E64657253637265656E5265616465725465787428652C742C6E297B636F6E737420693D62722C6F3D6928226469762E686F7665722D726F772E6D61726B646F776E2D686F766572';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(28501) := '22292C733D7572286F2C6928226469762E686F7665722D636F6E74656E7473222C7B22617269612D6C697665223A22617373657274697665227D29292C723D6E2E616464286E6577207045287B656469746F723A746869732E5F656469746F727D2C7468';
wwv_flow_imp.g_varchar2_table(28502) := '69732E5F6C616E6775616765536572766963652C746869732E5F6F70656E65725365727669636529293B6E2E6164642865492828693D3E7B766172206F3B636F6E737420613D6E756C6C3D3D3D286F3D742E636F6E74726F6C6C65722E6D6F64656C2E72';
wwv_flow_imp.g_varchar2_table(28503) := '656164286929297C7C766F696420303D3D3D6F3F766F696420303A6F2E7072696D61727947686F7374546578742E726561642869293B69662861297B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292E6765744C696E6543';
wwv_flow_imp.g_varchar2_table(28504) := '6F6E74656E7428612E6C696E654E756D626572293B28743D3E7B6E2E61646428722E6F6E44696452656E6465724173796E63282828293D3E7B732E636C6173734E616D653D22686F7665722D636F6E74656E747320636F64652D686F7665722D636F6E74';
wwv_flow_imp.g_varchar2_table(28505) := '656E7473222C652E6F6E436F6E74656E74734368616E67656428297D2929293B636F6E737420693D6228302C2253756767657374696F6E3A22292C6F3D6E2E61646428722E72656E64657228286E6577206F63292E617070656E64546578742869292E61';
wwv_flow_imp.g_varchar2_table(28506) := '7070656E64436F6465626C6F636B282274657874222C742929293B732E7265706C6163654368696C6472656E286F2E656C656D656E74297D2928612E72656E646572466F7253637265656E526561646572287429297D656C73652067722873297D292929';
wwv_flow_imp.g_varchar2_table(28507) := '2C652E667261676D656E742E617070656E644368696C64286F297D7D3B5A343D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A656374';
wwv_flow_imp.g_varchar2_table(28508) := '2E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D';
wwv_flow_imp.g_varchar2_table(28509) := '5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F2874';
wwv_flow_imp.g_varchar2_table(28510) := '2C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B513428312C4C75292C513428322C6445292C513428332C5953292C513428342C7563292C513428352C4F64';
wwv_flow_imp.g_varchar2_table(28511) := '295D2C5A34292C4A642871342E49442C71342C33292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E6C696E65537567676573742E7472696767';
wwv_flow_imp.g_varchar2_table(28512) := '6572222C6C6162656C3A6228302C225472696767657220496E6C696E652053756767657374696F6E22292C616C6961733A225472696767657220496E6C696E652053756767657374696F6E222C707265636F6E646974696F6E3A6C682E7772697461626C';
wwv_flow_imp.g_varchar2_table(28513) := '657D297D6173796E632072756E28652C74297B636F6E7374206E3D71342E6765742874293B6177616974206173796E632066756E6374696F6E2865297B636F6E737420743D6E657720715428652C766F69642030293B7472797B61776169742065287429';
wwv_flow_imp.g_varchar2_table(28514) := '7D66696E616C6C797B742E66696E69736828297D7D28286173796E6320653D3E7B76617220743B6177616974286E756C6C3D3D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E6D6F64656C2E6765742829297C7C766F696420303D3D3D743F766F69';
wwv_flow_imp.g_varchar2_table(28515) := '6420303A742E747269676765724578706C696369746C79286529292C6E756C6C3D3D6E7C7C6E2E706C61794163636573736962696C6974795369676E616C2865297D29297D7D292C5A64282434292C5A64285534292C5A6428636C61737320657874656E';
wwv_flow_imp.g_varchar2_table(28516) := '64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E6C696E65537567676573742E6163636570744E657874576F7264222C6C6162656C3A6228302C22416363657074204E65787420576F';
wwv_flow_imp.g_varchar2_table(28517) := '7264204F6620496E6C696E652053756767657374696F6E22292C616C6961733A22416363657074204E65787420576F7264204F6620496E6C696E652053756767657374696F6E222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461';
wwv_flow_imp.g_varchar2_table(28518) := '626C652C6B332E696E6C696E6553756767657374696F6E56697369626C65292C6B624F7074733A7B7765696768743A3130312C7072696D6172793A323036352C6B62457870723A57632E616E64286C682E7772697461626C652C6B332E696E6C696E6553';
wwv_flow_imp.g_varchar2_table(28519) := '756767657374696F6E56697369626C65297D2C6D656E754F7074733A5B7B6D656E7549643A4C642E496E6C696E6553756767657374696F6E546F6F6C6261722C7469746C653A6228302C2241636365707420576F726422292C67726F75703A227072696D';
wwv_flow_imp.g_varchar2_table(28520) := '617279222C6F726465723A327D5D7D297D6173796E632072756E28652C74297B766172206E3B636F6E737420693D71342E6765742874293B6177616974286E756C6C3D3D3D286E3D6E756C6C3D3D693F766F696420303A692E6D6F64656C2E6765742829';
wwv_flow_imp.g_varchar2_table(28521) := '297C7C766F696420303D3D3D6E3F766F696420303A6E2E6163636570744E657874576F726428692E656469746F7229297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469';
wwv_flow_imp.g_varchar2_table(28522) := '746F722E616374696F6E2E696E6C696E65537567676573742E6163636570744E6578744C696E65222C6C6162656C3A6228302C22416363657074204E657874204C696E65204F6620496E6C696E652053756767657374696F6E22292C616C6961733A2241';
wwv_flow_imp.g_varchar2_table(28523) := '6363657074204E657874204C696E65204F6620496E6C696E652053756767657374696F6E222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6B332E696E6C696E6553756767657374696F6E56697369626C65292C6B62';
wwv_flow_imp.g_varchar2_table(28524) := '4F7074733A7B7765696768743A3130317D2C6D656E754F7074733A5B7B6D656E7549643A4C642E496E6C696E6553756767657374696F6E546F6F6C6261722C7469746C653A6228302C22416363657074204C696E6522292C67726F75703A227365636F6E';
wwv_flow_imp.g_varchar2_table(28525) := '64617279222C6F726465723A327D5D7D297D6173796E632072756E28652C74297B766172206E3B636F6E737420693D71342E6765742874293B6177616974286E756C6C3D3D3D286E3D6E756C6C3D3D693F766F696420303A692E6D6F64656C2E67657428';
wwv_flow_imp.g_varchar2_table(28526) := '29297C7C766F696420303D3D3D6E3F766F696420303A6E2E6163636570744E6578744C696E6528692E656469746F7229297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A726A2C';
wwv_flow_imp.g_varchar2_table(28527) := '6C6162656C3A6228302C2241636365707420496E6C696E652053756767657374696F6E22292C616C6961733A2241636365707420496E6C696E652053756767657374696F6E222C707265636F6E646974696F6E3A6B332E696E6C696E6553756767657374';
wwv_flow_imp.g_varchar2_table(28528) := '696F6E56697369626C652C6D656E754F7074733A5B7B6D656E7549643A4C642E496E6C696E6553756767657374696F6E546F6F6C6261722C7469746C653A6228302C2241636365707422292C67726F75703A227072696D617279222C6F726465723A317D';
wwv_flow_imp.g_varchar2_table(28529) := '5D2C6B624F7074733A7B7072696D6172793A322C7765696768743A3230302C6B62457870723A57632E616E64286B332E696E6C696E6553756767657374696F6E56697369626C652C6C682E7461624D6F766573466F6375732E746F4E6567617465642829';
wwv_flow_imp.g_varchar2_table(28530) := '2C6B332E696E6C696E6553756767657374696F6E486173496E64656E746174696F6E4C6573735468616E54616253697A652C72352E56697369626C652E746F4E65676174656428292C6C682E686F766572466F63757365642E746F4E6567617465642829';
wwv_flow_imp.g_varchar2_table(28531) := '297D7D297D6173796E632072756E28652C74297B766172206E3B636F6E737420693D71342E6765742874293B692626286E756C6C3D3D3D286E3D692E6D6F64656C2E6765742829297C7C766F696420303D3D3D6E7C7C6E2E61636365707428692E656469';
wwv_flow_imp.g_varchar2_table(28532) := '746F72292C692E656469746F722E666F6375732829297D7D292C5A64284B34292C5064284734292C44712E7265676973746572285A34293B7661722058343D6E2831393335292C4A343D7B7D3B4A342E7374796C655461675472616E73666F726D3D6A72';
wwv_flow_imp.g_varchar2_table(28533) := '28292C4A342E736574417474726962757465733D567228292C4A342E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4A342E646F6D4150493D4F7228292C4A342E696E736572745374796C65456C656D656E743D487228292C';
wwv_flow_imp.g_varchar2_table(28534) := '4E7228292858342E412C4A34292C58342E41262658342E412E6C6F63616C73262658342E412E6C6F63616C733B636F6E73742065363D22696E6C696E652D65646974223B6C65742074363D636C61737320657874656E6473206C747B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(28535) := '746F7228652C742C6E297B737570657228292C746869732E656469746F723D652C746869732E6D6F64656C3D742C746869732E6C616E6775616765536572766963653D6E2C746869732E6973446973706F7365643D245428746869732C2131292C746869';
wwv_flow_imp.g_varchar2_table(28536) := '732E63757272656E74546578744D6F64656C3D614928746869732E656469746F722E6F6E4469644368616E67654D6F64656C2C2828293D3E746869732E656469746F722E6765744D6F64656C282929292C746869732E756953746174653D515428746869';
wwv_flow_imp.g_varchar2_table(28537) := '732C28653D3E7B76617220743B696628746869732E6973446973706F7365642E726561642865292972657475726E3B636F6E7374206E3D746869732E63757272656E74546578744D6F64656C2E726561642865293B6966286E213D3D746869732E6D6F64';
wwv_flow_imp.g_varchar2_table(28538) := '656C2E746172676574546578744D6F64656C2E726561642865292972657475726E3B636F6E737420693D746869732E6D6F64656C2E67686F7374546578742E726561642865293B69662821692972657475726E3B6C6574206F3D6E756C6C3D3D3D28743D';
wwv_flow_imp.g_varchar2_table(28539) := '746869732E6D6F64656C2E72616E6765297C7C766F696420303D3D3D743F766F696420303A742E726561642865293B6F26266F2E73746172744C696E654E756D6265723D3D3D6F2E656E644C696E654E756D62657226266F2E7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(28540) := '3D3D3D6F2E656E64436F6C756D6E2626286F3D766F69642030293B636F6E737420733D28216F7C7C6F2E73746172744C696E654E756D6265723D3D3D6F2E656E644C696E654E756D626572292626313D3D3D692E70617274732E6C656E6774682626313D';
wwv_flow_imp.g_varchar2_table(28541) := '3D3D692E70617274735B305D2E6C696E65732E6C656E6774682C723D313D3D3D692E70617274732E6C656E6774682626692E70617274735B305D2E6C696E65732E65766572792828653D3E303D3D3D652E6C656E67746829292C613D5B5D2C6C3D5B5D3B';
wwv_flow_imp.g_varchar2_table(28542) := '66756E6374696F6E206328652C74297B6966286C2E6C656E6774683E30297B636F6E7374206E3D6C5B6C2E6C656E6774682D315D3B7426266E2E6465636F726174696F6E732E70757368286E657720634E286E2E636F6E74656E742E6C656E6774682B31';
wwv_flow_imp.g_varchar2_table(28543) := '2C6E2E636F6E74656E742E6C656E6774682B312B655B305D2E6C656E6774682C742C3029292C6E2E636F6E74656E742B3D655B305D2C653D652E736C6963652831297D666F7228636F6E7374206E206F662065296C2E70757368287B636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(28544) := '6E2C6465636F726174696F6E733A743F5B6E657720634E28312C6E2E6C656E6774682B312C742C30295D3A5B5D7D297D636F6E737420643D6E2E6765744C696E65436F6E74656E7428692E6C696E654E756D626572293B6C657420682C753D303B696628';
wwv_flow_imp.g_varchar2_table(28545) := '2172297B666F7228636F6E73742065206F6620692E7061727473297B6C657420743D652E6C696E65733B6F262621732626286328742C6536292C743D5B5D292C766F696420303D3D3D683F28612E70757368287B636F6C756D6E3A652E636F6C756D6E2C';
wwv_flow_imp.g_varchar2_table(28546) := '746578743A745B305D2C707265766965773A652E707265766965777D292C743D742E736C696365283129293A63285B642E737562737472696E6728752C652E636F6C756D6E2D31295D2C766F69642030292C742E6C656E6774683E302626286328742C65';
wwv_flow_imp.g_varchar2_table(28547) := '36292C766F696420303D3D3D682626652E636F6C756D6E3C3D642E6C656E677468262628683D652E636F6C756D6E29292C753D652E636F6C756D6E2D317D766F69642030213D3D68262663285B642E737562737472696E672875295D2C766F6964203029';
wwv_flow_imp.g_varchar2_table(28548) := '7D636F6E737420703D766F69642030213D3D683F6E657720503328682C642E6C656E6774682B31293A766F696420302C673D737C7C216F3F692E6C696E654E756D6265723A6F2E656E644C696E654E756D6265722D313B72657475726E7B696E6C696E65';
wwv_flow_imp.g_varchar2_table(28549) := '54657874733A612C6164646974696F6E616C4C696E65733A6C2C68696464656E52616E67653A702C6C696E654E756D6265723A672C6164646974696F6E616C52657365727665644C696E65436F756E743A746869732E6D6F64656C2E6D696E5265736572';
wwv_flow_imp.g_varchar2_table(28550) := '7665644C696E65436F756E742E726561642865292C746172676574546578744D6F64656C3A6E2C72616E67653A6F2C697353696E676C654C696E653A732C69735075726552656D6F76653A722C6261636B67726F756E64436F6C6F72696E673A74686973';
wwv_flow_imp.g_varchar2_table(28551) := '2E6D6F64656C2E6261636B67726F756E64436F6C6F72696E672E726561642865297D7D29292C746869732E6465636F726174696F6E733D515428746869732C28653D3E7B636F6E737420743D746869732E756953746174652E726561642865293B696628';
wwv_flow_imp.g_varchar2_table(28552) := '21742972657475726E5B5D3B636F6E7374206E3D5B5D3B696628742E68696464656E52616E676526266E2E70757368287B72616E67653A742E68696464656E52616E67652E746F52616E676528742E6C696E654E756D626572292C6F7074696F6E733A7B';
wwv_flow_imp.g_varchar2_table(28553) := '696E6C696E65436C6173734E616D653A22696E6C696E652D656469742D68696464656E222C6465736372697074696F6E3A22696E6C696E652D656469742D68696464656E227D7D292C742E72616E6765297B636F6E737420653D5B5D3B696628742E6973';
wwv_flow_imp.g_varchar2_table(28554) := '53696E676C654C696E6529652E7075736828742E72616E6765293B656C736520696628742E69735075726552656D6F7665297B636F6E7374206E3D742E72616E67652E656E644C696E654E756D6265722D742E72616E67652E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(28555) := '6D6265723B666F72286C657420693D303B693C6E3B692B2B297B636F6E7374206E3D742E72616E67652E73746172744C696E654E756D6265722B692C6F3D742E746172676574546578744D6F64656C2E6765744C696E6546697273744E6F6E5768697465';
wwv_flow_imp.g_varchar2_table(28556) := '7370616365436F6C756D6E286E292C733D742E746172676574546578744D6F64656C2E6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E286E292C723D6E6577207268286E2C6F2C6E2C73293B652E707573682872297D7D656C';
wwv_flow_imp.g_varchar2_table(28557) := '73657B636F6E7374206E3D742E72616E67652E656E644C696E654E756D6265722D742E72616E67652E73746172744C696E654E756D6265723B666F72286C657420693D303B693C6E3B692B2B297B636F6E7374206E3D742E72616E67652E73746172744C';
wwv_flow_imp.g_varchar2_table(28558) := '696E654E756D6265722B692C6F3D742E746172676574546578744D6F64656C2E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E286E292C733D742E746172676574546578744D6F64656C2E6765744C696E654C6173744E6F';
wwv_flow_imp.g_varchar2_table(28559) := '6E57686974657370616365436F6C756D6E286E292C723D6E6577207268286E2C6F2C6E2C73293B652E707573682872297D7D636F6E737420693D742E6261636B67726F756E64436F6C6F72696E673F22696E6C696E652D656469742D72656D6F76652062';
wwv_flow_imp.g_varchar2_table(28560) := '61636B67726F756E64436F6C6F72696E67223A22696E6C696E652D656469742D72656D6F7665223B666F7228636F6E73742074206F662065296E2E70757368287B72616E67653A742C6F7074696F6E733A7B696E6C696E65436C6173734E616D653A692C';
wwv_flow_imp.g_varchar2_table(28561) := '6465736372697074696F6E3A22696E6C696E652D656469742D72656D6F7665227D7D297D666F7228636F6E73742065206F6620742E696E6C696E655465787473296E2E70757368287B72616E67653A72682E66726F6D506F736974696F6E73286E657720';
wwv_flow_imp.g_varchar2_table(28562) := '6D6328742E6C696E654E756D6265722C652E636F6C756D6E29292C6F7074696F6E733A7B6465736372697074696F6E3A65362C61667465723A7B636F6E74656E743A652E746578742C696E6C696E65436C6173734E616D653A652E707265766965773F22';
wwv_flow_imp.g_varchar2_table(28563) := '696E6C696E652D656469742D6465636F726174696F6E2D70726576696577223A22696E6C696E652D656469742D6465636F726174696F6E222C637572736F7253746F70733A6B682E4C6566747D2C73686F774966436F6C6C61707365643A21307D7D293B';
wwv_flow_imp.g_varchar2_table(28564) := '72657475726E206E7D29292C746869732E6164646974696F6E616C4C696E65735769646765743D746869732E5F7265676973746572286E657720563328746869732E656469746F722C746869732E6C616E6775616765536572766963652E6C616E677561';
wwv_flow_imp.g_varchar2_table(28565) := '67654964436F6465632C51542828653D3E7B636F6E737420743D746869732E756953746174652E726561642865293B72657475726E2074262621742E69735075726552656D6F76653F7B6C696E654E756D6265723A742E6C696E654E756D6265722C6164';
wwv_flow_imp.g_varchar2_table(28566) := '646974696F6E616C4C696E65733A742E6164646974696F6E616C4C696E65732C6D696E52657365727665644C696E65436F756E743A742E6164646974696F6E616C52657365727665644C696E65436F756E742C746172676574546578744D6F64656C3A74';
wwv_flow_imp.g_varchar2_table(28567) := '2E746172676574546578744D6F64656C7D3A766F696420307D292929292C746869732E5F7265676973746572287274282828293D3E7B746869732E6973446973706F7365642E7365742821302C766F69642030297D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(28568) := '746572284F3328746869732E656469746F722C746869732E6465636F726174696F6E7329297D6F776E73566965775A6F6E652865297B72657475726E20746869732E6164646974696F6E616C4C696E65735769646765742E766965775A6F6E6549643D3D';
wwv_flow_imp.g_varchar2_table(28569) := '3D657D7D3B74363D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F';
wwv_flow_imp.g_varchar2_table(28570) := '7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(28571) := '293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626722626';
wwv_flow_imp.g_varchar2_table(28572) := '4F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28322C4C75295D2C7436293B766172206E363D6E2835';
wwv_flow_imp.g_varchar2_table(28573) := '323639292C69363D7B7D3B69362E7374796C655461675472616E73666F726D3D6A7228292C69362E736574417474726962757465733D567228292C69362E696E736572743D467228292E62696E64286E756C6C2C226865616422292C69362E646F6D4150';
wwv_flow_imp.g_varchar2_table(28574) := '493D4F7228292C69362E696E736572745374796C65456C656D656E743D487228292C4E722829286E362E412C6936292C6E362E4126266E362E412E6C6F63616C7326266E362E412E6C6F63616C733B766172206F362C73363D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(28575) := '742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374';
wwv_flow_imp.g_varchar2_table(28576) := '223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E';
wwv_flow_imp.g_varchar2_table(28577) := '6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(28578) := '747928742C6E2C72292C727D2C72363D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742061363D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(28579) := '742C6E297B737570657228292C746869732E656469746F723D652C746869732E6D6F64656C3D742C746869732E696E7374616E74696174696F6E536572766963653D6E2C746869732E616C7761797353686F77546F6F6C6261723D614928746869732E65';
wwv_flow_imp.g_varchar2_table(28580) := '6469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E22616C77617973223D3D3D746869732E656469746F722E6765744F7074696F6E283633292E73686F77546F6F6C62617229292C746869732E73657373696F6E50';
wwv_flow_imp.g_varchar2_table(28581) := '6F736974696F6E3D766F696420302C746869732E706F736974696F6E3D515428746869732C28653D3E7B76617220742C6E2C693B636F6E7374206F3D6E756C6C3D3D3D28743D746869732E6D6F64656C2E72656164286529297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(28582) := '743F766F696420303A742E7769646765742E6D6F64656C2E67686F7374546578742E726561642865293B69662821746869732E616C7761797353686F77546F6F6C6261722E726561642865297C7C216F7C7C303D3D3D6F2E70617274732E6C656E677468';
wwv_flow_imp.g_varchar2_table(28583) := '2972657475726E20746869732E73657373696F6E506F736974696F6E3D766F696420302C6E756C6C3B636F6E737420733D6F2E70617274735B305D2E636F6C756D6E3B746869732E73657373696F6E506F736974696F6E2626746869732E73657373696F';
wwv_flow_imp.g_varchar2_table(28584) := '6E506F736974696F6E2E6C696E654E756D626572213D3D6F2E6C696E654E756D626572262628746869732E73657373696F6E506F736974696F6E3D766F69642030293B636F6E737420723D6E6577206D63286F2E6C696E654E756D6265722C4D6174682E';
wwv_flow_imp.g_varchar2_table(28585) := '6D696E28732C6E756C6C213D3D28693D6E756C6C3D3D3D286E3D746869732E73657373696F6E506F736974696F6E297C7C766F696420303D3D3D6E3F766F696420303A6E2E636F6C756D6E292626766F69642030213D3D693F693A4E756D6265722E4D41';
wwv_flow_imp.g_varchar2_table(28586) := '585F534146455F494E544547455229293B72657475726E20746869732E73657373696F6E506F736974696F6E3D722C727D29292C746869732E5F7265676973746572286949282828742C6E293D3E7B69662821746869732E6D6F64656C2E726561642874';
wwv_flow_imp.g_varchar2_table(28587) := '297C7C21746869732E616C7761797353686F77546F6F6C6261722E726561642874292972657475726E3B636F6E737420693D6E2E61646428746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365286C362C';
wwv_flow_imp.g_varchar2_table(28588) := '746869732E656469746F722C21302C746869732E706F736974696F6E29293B652E616464436F6E74656E745769646765742869292C6E2E616464287274282828293D3E652E72656D6F7665436F6E74656E745769646765742869292929297D2929297D7D';
wwv_flow_imp.g_varchar2_table(28589) := '3B61363D7336285B723628322C7563295D2C6136293B6C6574206C363D6F363D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E656469746F723D652C74686973';
wwv_flow_imp.g_varchar2_table(28590) := '2E77697468426F726465723D742C746869732E5F706F736974696F6E3D6E2C746869732E5F636F6E746578744B6579536572766963653D6F2C746869732E5F6D656E75536572766963653D732C746869732E69643D22496E6C696E654564697448696E74';
wwv_flow_imp.g_varchar2_table(28591) := '73436F6E74656E74576964676574222B6F362E69642B2B2C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E73757070726573734D6F757365446F776E3D21312C746869732E6E6F6465733D497228226469762E696E6C';
wwv_flow_imp.g_varchar2_table(28592) := '696E654564697448696E7473222C7B636C6173734E616D653A746869732E77697468426F726465723F222E77697468426F72646572223A22227D2C5B4972282264697640746F6F6C42617222295D292C746869732E696E6C696E65436F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(28593) := '6E73416374696F6E734D656E75733D746869732E5F726567697374657228746869732E5F6D656E75536572766963652E6372656174654D656E75284C642E496E6C696E6545646974416374696F6E732C746869732E5F636F6E746578744B657953657276';
wwv_flow_imp.g_varchar2_table(28594) := '69636529292C746869732E746F6F6C4261723D746869732E5F726567697374657228692E637265617465496E7374616E63652864362C746869732E6E6F6465732E746F6F6C4261722C746869732E656469746F722C4C642E496E6C696E6545646974546F';
wwv_flow_imp.g_varchar2_table(28595) := '6F6C6261722C7B6D656E754F7074696F6E733A7B72656E64657253686F72745469746C653A21307D2C746F6F6C6261724F7074696F6E733A7B7072696D61727947726F75703A653D3E652E7374617274735769746828227072696D61727922297D2C6163';
wwv_flow_imp.g_varchar2_table(28596) := '74696F6E566965774974656D50726F76696465723A28652C74293D3E7B6966286520696E7374616E63656F662041642972657475726E20692E637265617465496E7374616E63652863362C652C766F69642030297D2C74656C656D65747279536F757263';
wwv_flow_imp.g_varchar2_table(28597) := '653A22496E6C696E6545646974546F6F6C626172227D29292C746869732E5F726567697374657228746869732E746F6F6C4261722E6F6E4469644368616E676544726F70646F776E5669736962696C6974792828653D3E7B6F362E5F64726F70446F776E';
wwv_flow_imp.g_varchar2_table(28598) := '56697369626C653D657D2929292C746869732E5F72656769737465722865492828653D3E7B746869732E5F706F736974696F6E2E726561642865292C746869732E656469746F722E6C61796F7574436F6E74656E745769646765742874686973297D2929';
wwv_flow_imp.g_varchar2_table(28599) := '292C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D5B5D3B666F7228636F6E73745B652C6E5D6F6620746869732E696E6C696E65436F6D706C6574696F6E73416374696F6E734D656E75732E676574416374696F6E732829';
wwv_flow_imp.g_varchar2_table(28600) := '29666F7228636F6E73742065206F66206E296520696E7374616E63656F662041642626742E707573682865293B742E6C656E6774683E302626742E756E7368696674286E6577207963292C746869732E746F6F6C4261722E7365744164646974696F6E61';
wwv_flow_imp.g_varchar2_table(28601) := '6C5365636F6E64617279416374696F6E732874297D2929297D676574496428297B72657475726E20746869732E69647D676574446F6D4E6F646528297B72657475726E20746869732E6E6F6465732E726F6F747D676574506F736974696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(28602) := '7475726E7B706F736974696F6E3A746869732E5F706F736974696F6E2E67657428292C707265666572656E63653A5B312C325D2C706F736974696F6E416666696E6974793A337D7D7D3B6C362E5F64726F70446F776E56697369626C653D21312C6C362E';
wwv_flow_imp.g_varchar2_table(28603) := '69643D302C6C363D6F363D7336285B723628332C7563292C723628342C6364292C723628352C4464295D2C6C36293B636C61737320633620657874656E647320796A7B7570646174654C6162656C28297B636F6E737420653D746869732E5F6B65796269';
wwv_flow_imp.g_varchar2_table(28604) := '6E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728746869732E5F616374696F6E2E69642C746869732E5F636F6E746578744B657953657276696365293B69662821652972657475726E2073757065722E7570646174654C616265';
wwv_flow_imp.g_varchar2_table(28605) := '6C28293B696628746869732E6C6162656C297B636F6E737420743D497228226469762E6B657962696E64696E6722292E726F6F743B746869732E5F7265676973746572286E657720774D28742C74652C7B64697361626C655469746C653A21302C2E2E2E';
wwv_flow_imp.g_varchar2_table(28606) := '794D7D29292E7365742865292C746869732E6C6162656C2E74657874436F6E74656E743D746869732E5F616374696F6E2E6C6162656C2C746869732E6C6162656C2E617070656E644368696C642874292C746869732E6C6162656C2E636C6173734C6973';
wwv_flow_imp.g_varchar2_table(28607) := '742E6164642822696E6C696E65456469745374617475734261724974656D4C6162656C22297D7D757064617465546F6F6C74697028297B7D7D6C65742064363D636C61737320657874656E647320486A7B636F6E7374727563746F7228652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(28608) := '2C6F2C732C722C612C6C2C63297B737570657228652C7B72657365744D656E753A6E2C2E2E2E697D2C6F2C732C722C612C6C2C63292C746869732E656469746F723D742C746869732E6D656E7549643D6E2C746869732E6F7074696F6E73323D692C7468';
wwv_flow_imp.g_varchar2_table(28609) := '69732E6D656E75536572766963653D6F2C746869732E636F6E746578744B6579536572766963653D732C746869732E6D656E753D746869732E5F73746F72652E61646428746869732E6D656E75536572766963652E6372656174654D656E752874686973';
wwv_flow_imp.g_varchar2_table(28610) := '2E6D656E7549642C746869732E636F6E746578744B6579536572766963652C7B656D69744576656E7473466F725375626D656E754368616E6765733A21307D29292C746869732E6164646974696F6E616C416374696F6E733D5B5D2C746869732E707265';
wwv_flow_imp.g_varchar2_table(28611) := '70656E6465645072696D617279416374696F6E733D5B5D2C746869732E5F73746F72652E61646428746869732E6D656E752E6F6E4469644368616E6765282828293D3E746869732E757064617465546F6F6C62617228292929292C746869732E5F73746F';
wwv_flow_imp.g_varchar2_table(28612) := '72652E61646428746869732E656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E746869732E757064617465546F6F6C62617228292929292C746869732E757064617465546F6F6C62617228297D7570646174';
wwv_flow_imp.g_varchar2_table(28613) := '65546F6F6C62617228297B76617220652C742C6E2C692C6F2C732C723B636F6E737420613D5B5D2C6C3D5B5D3B626A28746869732E6D656E752C6E756C6C3D3D3D28653D746869732E6F7074696F6E7332297C7C766F696420303D3D3D653F766F696420';
wwv_flow_imp.g_varchar2_table(28614) := '303A652E6D656E754F7074696F6E732C7B7072696D6172793A612C7365636F6E646172793A6C7D2C6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E6F7074696F6E7332297C7C766F696420303D3D3D743F766F696420303A742E746F6F6C';
wwv_flow_imp.g_varchar2_table(28615) := '6261724F7074696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E7072696D61727947726F75702C6E756C6C3D3D3D286F3D6E756C6C3D3D3D28693D746869732E6F7074696F6E7332297C7C766F696420303D3D3D693F766F696420303A';
wwv_flow_imp.g_varchar2_table(28616) := '692E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E73686F756C64496E6C696E655375626D656E752C6E756C6C3D3D3D28723D6E756C6C3D3D3D28733D746869732E6F7074696F6E7332297C7C766F696420';
wwv_flow_imp.g_varchar2_table(28617) := '303D3D3D733F766F696420303A732E746F6F6C6261724F7074696F6E73297C7C766F696420303D3D3D723F766F696420303A722E757365536570617261746F7273496E5072696D617279416374696F6E73292C6C2E70757368282E2E2E746869732E6164';
wwv_flow_imp.g_varchar2_table(28618) := '646974696F6E616C416374696F6E73292C612E756E7368696674282E2E2E746869732E70726570656E6465645072696D617279416374696F6E73292C746869732E736574416374696F6E7328612C6C297D7365744164646974696F6E616C5365636F6E64';
wwv_flow_imp.g_varchar2_table(28619) := '617279416374696F6E732865297B506828746869732E6164646974696F6E616C416374696F6E732C652C2828652C74293D3E653D3D3D7429297C7C28746869732E6164646974696F6E616C416374696F6E733D652C746869732E757064617465546F6F6C';
wwv_flow_imp.g_varchar2_table(28620) := '6261722829297D7D3B64363D7336285B723628342C4464292C723628352C6364292C723628362C7145292C723628372C2445292C723628382C7863292C723628392C4F64295D2C6436293B7661722068362C75363D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(28621) := '657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732070367B636F6E7374727563746F7228652C74297B746869732E7769646765743D652C746869732E656469743D747D646973706F736528297B746869732E7769';
wwv_flow_imp.g_varchar2_table(28622) := '646765742E646973706F736528297D7D6C65742067363D68363D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2868362E4944297D636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(28623) := '28652C742C6E2C692C6F2C73297B737570657228292C746869732E656469746F723D652C746869732E696E7374616E74696174696F6E536572766963653D742C746869732E636F6E746578744B6579536572766963653D6E2C746869732E6C616E677561';
wwv_flow_imp.g_varchar2_table(28624) := '67654665617475726573536572766963653D692C746869732E5F636F6D6D616E64536572766963653D6F2C746869732E5F636F6E66696775726174696F6E536572766963653D732C746869732E5F697356697369626C65436F6E746578743D68362E696E';
wwv_flow_imp.g_varchar2_table(28625) := '6C696E654564697456697369626C65436F6E746578742E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E5F6973437572736F724174496E6C696E6545646974436F6E746578743D68362E637572736F72417449';
wwv_flow_imp.g_varchar2_table(28626) := '6E6C696E6545646974436F6E746578742E62696E64546F28746869732E636F6E746578744B657953657276696365292C746869732E5F63757272656E74456469743D746869732E5F7265676973746572284B5428746869732C766F6964203029292C7468';
wwv_flow_imp.g_varchar2_table(28627) := '69732E5F6973416363657074696E673D245428746869732C2131292C746869732E5F656E61626C65643D614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E746869732E656469746F722E67';
wwv_flow_imp.g_varchar2_table(28628) := '65744F7074696F6E283633292E656E61626C656429292C746869732E5F666F6E7446616D696C793D614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E746869732E656469746F722E676574';
wwv_flow_imp.g_varchar2_table(28629) := '4F7074696F6E283633292E666F6E7446616D696C7929292C746869732E5F6261636B67726F756E64436F6C6F72696E673D614928746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2C2828293D3E746869732E65';
wwv_flow_imp.g_varchar2_table(28630) := '6469746F722E6765744F7074696F6E283633292E6261636B67726F756E64436F6C6F72696E6729293B636F6E737420723D63492822496E6C696E6545646974436F6E74726F6C6C65722E6D6F64656C436F6E74656E744368616E6765645369676E616C22';
wwv_flow_imp.g_varchar2_table(28631) := '2C652E6F6E4469644368616E67654D6F64656C436F6E74656E74293B746869732E5F72656769737465722865492828743D3E7B746869732E5F656E61626C65642E72656164287429262628722E726561642874292C746869732E5F697341636365707469';
wwv_flow_imp.g_varchar2_table(28632) := '6E672E726561642874297C7C746869732E676574496E6C696E654564697428652C213029297D2929293B636F6E737420613D614928652E6F6E4469644368616E6765437572736F72506F736974696F6E2C2828293D3E652E676574506F736974696F6E28';
wwv_flow_imp.g_varchar2_table(28633) := '2929293B746869732E5F72656769737465722865492828653D3E7B69662821746869732E5F656E61626C65642E726561642865292972657475726E3B636F6E737420743D612E726561642865293B742626746869732E636865636B437572736F72506F73';
wwv_flow_imp.g_varchar2_table(28634) := '6974696F6E2874297D2929292C746869732E5F72656769737465722865492828743D3E7B636F6E7374206E3D746869732E5F63757272656E74456469742E726561642874293B696628746869732E5F6973437572736F724174496E6C696E654564697443';
wwv_flow_imp.g_varchar2_table(28635) := '6F6E746578742E736574282131292C216E2972657475726E20766F696420746869732E5F697356697369626C65436F6E746578742E736574282131293B746869732E5F697356697369626C65436F6E746578742E736574282130293B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(28636) := '652E676574506F736974696F6E28293B692626746869732E636865636B437572736F72506F736974696F6E2869297D2929293B636F6E7374206C3D63492822496E6C696E6545646974436F6E74726F6C6C65722E656469746F72426C75725369676E616C';
wwv_flow_imp.g_varchar2_table(28637) := '222C652E6F6E446964426C7572456469746F72576964676574293B746869732E5F726567697374657228654928286173796E6320743D3E7B766172206E3B746869732E5F656E61626C65642E726561642874292626286C2E726561642874292C74686973';
wwv_flow_imp.g_varchar2_table(28638) := '2E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E6578706572696D656E74616C496E6C696E65456469742E6B6565704F6E426C757222297C7C652E6765744F7074696F6E283633292E6B6565704F6E42';
wwv_flow_imp.g_varchar2_table(28639) := '6C75727C7C286E756C6C3D3D3D286E3D746869732E5F63757272656E7452657175657374437473297C7C766F696420303D3D3D6E7C7C6E2E646973706F7365282130292C746869732E5F63757272656E74526571756573744374733D766F696420302C61';
wwv_flow_imp.g_varchar2_table(28640) := '7761697420746869732E636C6561722821312929297D2929293B636F6E737420633D63492822496E6C696E6545646974436F6E74726F6C6C65722E656469746F72466F6375735369676E616C222C652E6F6E446964466F637573456469746F7254657874';
wwv_flow_imp.g_varchar2_table(28641) := '293B746869732E5F72656769737465722865492828743D3E7B746869732E5F656E61626C65642E72656164287429262628632E726561642874292C746869732E676574496E6C696E654564697428652C213029297D2929293B636F6E737420643D746869';
wwv_flow_imp.g_varchar2_table(28642) := '732E5F72656769737465722847732829293B746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F666F6E7446616D696C792E726561642865293B642E7365745374796C652822223D3D3D747C7C2264656661756C';
wwv_flow_imp.g_varchar2_table(28643) := '74223D3D3D743F22223A605C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D6465636F726174696F6E2C5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D656469742D6465636F726174696F6E2D70726576696577';
wwv_flow_imp.g_varchar2_table(28644) := '2C5C6E2E6D6F6E61636F2D656469746F72202E696E6C696E652D65646974207B5C6E5C74666F6E742D66616D696C793A20247B747D3B5C6E7D60297D2929292C746869732E5F7265676973746572286E657720613628746869732E656469746F722C7468';
wwv_flow_imp.g_varchar2_table(28645) := '69732E5F63757272656E74456469742C746869732E696E7374616E74696174696F6E5365727669636529297D636865636B437572736F72506F736974696F6E2865297B76617220743B69662821746869732E5F63757272656E7445646974297265747572';
wwv_flow_imp.g_varchar2_table(28646) := '6E20766F696420746869732E5F6973437572736F724174496E6C696E6545646974436F6E746578742E736574282131293B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F63757272656E74456469742E6765742829297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(28647) := '3D3D743F766F696420303A742E656469743B6E3F746869732E5F6973437572736F724174496E6C696E6545646974436F6E746578742E7365742872682E636F6E7461696E73506F736974696F6E286E2E72616E67652C6529293A746869732E5F69734375';
wwv_flow_imp.g_varchar2_table(28648) := '72736F724174496E6C696E6545646974436F6E746578742E736574282131297D76616C6964617465496E6C696E654564697428652C74297B766172206E2C693B696628742E746578742E696E636C7564657328225C6E22292626742E72616E67652E7374';
wwv_flow_imp.g_varchar2_table(28649) := '6172744C696E654E756D626572213D3D742E72616E67652E656E644C696E654E756D6265722626742E72616E67652E7374617274436F6C756D6E213D3D742E72616E67652E656E64436F6C756D6E297B69662831213D3D742E72616E67652E7374617274';
wwv_flow_imp.g_varchar2_table(28650) := '436F6C756D6E2972657475726E21313B636F6E7374206F3D742E72616E67652E656E644C696E654E756D6265723B696628742E72616E67652E656E64436F6C756D6E213D3D286E756C6C213D3D28693D6E756C6C3D3D3D286E3D652E6765744D6F64656C';
wwv_flow_imp.g_varchar2_table(28651) := '2829297C7C766F696420303D3D3D6E3F766F696420303A6E2E6765744C696E654C656E677468286F29292626766F69642030213D3D693F693A30292B312972657475726E21317D72657475726E21307D6173796E63206665746368496E6C696E65456469';
wwv_flow_imp.g_varchar2_table(28652) := '7428652C74297B746869732E5F63757272656E74526571756573744374732626746869732E5F63757272656E74526571756573744374732E646973706F7365282130293B636F6E7374206E3D652E6765744D6F64656C28293B696628216E297265747572';
wwv_flow_imp.g_varchar2_table(28653) := '6E3B636F6E737420693D6E2E67657456657273696F6E496428292C6F3D746869732E6C616E67756167654665617475726573536572766963652E696E6C696E654564697450726F76696465722E616C6C286E293B696628303D3D3D6F2E6C656E67746829';
wwv_flow_imp.g_varchar2_table(28654) := '72657475726E3B636F6E737420733D6F5B305D3B746869732E5F63757272656E74526571756573744374733D6E6577204E743B636F6E737420723D746869732E5F63757272656E74526571756573744374732E746F6B656E2C613D743F4F772E4175746F';
wwv_flow_imp.g_varchar2_table(28655) := '6D617469633A4F772E496E766F6B653B766172206C3B6966287426266177616974286C3D722C6E65772050726F6D6973652828653D3E7B6C657420743B636F6E7374206E3D73657454696D656F7574282828293D3E7B742626742E646973706F73652829';
wwv_flow_imp.g_varchar2_table(28656) := '2C6528297D292C3530293B6C262628743D6C2E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B636C65617254696D656F7574286E292C742626742E646973706F736528292C6528297D2929297D2929292C722E697343616E63';
wwv_flow_imp.g_varchar2_table(28657) := '656C6C6174696F6E5265717565737465647C7C6E2E6973446973706F73656428297C7C6E2E67657456657273696F6E49642829213D3D692972657475726E3B636F6E737420633D617761697420732E70726F76696465496E6C696E6545646974286E2C7B';
wwv_flow_imp.g_varchar2_table(28658) := '747269676765724B696E643A617D2C72293B72657475726E2063262621722E697343616E63656C6C6174696F6E5265717565737465642626216E2E6973446973706F736564282926266E2E67657456657273696F6E496428293D3D3D692626746869732E';
wwv_flow_imp.g_varchar2_table(28659) := '76616C6964617465496E6C696E654564697428652C63293F633A766F696420307D6173796E6320676574496E6C696E654564697428652C74297B766172206E3B746869732E5F6973437572736F724174496E6C696E6545646974436F6E746578742E7365';
wwv_flow_imp.g_varchar2_table(28660) := '74282131292C617761697420746869732E636C65617228293B636F6E737420693D617761697420746869732E6665746368496E6C696E654564697428652C74293B69662821692972657475726E3B636F6E7374206F3D692E72616E67652E656E644C696E';
wwv_flow_imp.g_varchar2_table(28661) := '654E756D6265722C733D692E72616E67652E656E64436F6C756D6E2C723D21692E746578742E656E64735769746828225C6E22297C7C692E72616E67652E73746172744C696E654E756D6265723D3D3D692E72616E67652E656E644C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(28662) := '722626692E72616E67652E7374617274436F6C756D6E3D3D3D692E72616E67652E656E64436F6C756D6E3F692E746578743A692E746578742E736C69636528302C2D31292C613D6E6577204433286F2C5B6E657720543328732C722C2131295D292C6C3D';
wwv_flow_imp.g_varchar2_table(28663) := '746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652874362C746869732E656469746F722C7B67686F7374546578743A73492861292C6D696E52657365727665644C696E65436F756E743A73492830292C';
wwv_flow_imp.g_varchar2_table(28664) := '746172676574546578744D6F64656C3A7349286E756C6C213D3D286E3D746869732E656469746F722E6765744D6F64656C2829292626766F69642030213D3D6E3F6E3A766F69642030292C72616E67653A734928692E72616E6765292C6261636B67726F';
wwv_flow_imp.g_varchar2_table(28665) := '756E64436F6C6F72696E673A746869732E5F6261636B67726F756E64436F6C6F72696E677D293B746869732E5F63757272656E74456469742E736574286E6577207036286C2C69292C766F69642030297D6173796E63207472696767657228297B617761';
wwv_flow_imp.g_varchar2_table(28666) := '697420746869732E676574496E6C696E654564697428746869732E656469746F722C2131297D6173796E63206A756D704261636B28297B746869732E5F6A756D704261636B506F736974696F6E262628746869732E656469746F722E736574506F736974';
wwv_flow_imp.g_varchar2_table(28667) := '696F6E28746869732E5F6A756D704261636B506F736974696F6E292C746869732E656469746F722E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F727428746869732E5F6A756D704261636B506F73697469';
wwv_flow_imp.g_varchar2_table(28668) := '6F6E29297D6173796E632061636365707428297B76617220653B746869732E5F6973416363657074696E672E7365742821302C766F69642030293B636F6E737420743D6E756C6C3D3D3D28653D746869732E5F63757272656E74456469742E6765742829';
wwv_flow_imp.g_varchar2_table(28669) := '297C7C766F696420303D3D3D653F766F696420303A652E656469743B69662821742972657475726E3B6C6574206E3D742E746578743B742E746578742E7374617274735769746828225C6E22292626286E3D742E746578742E737562737472696E672831';
wwv_flow_imp.g_varchar2_table(28670) := '29292C746869732E656469746F722E70757368556E646F53746F7028292C746869732E656469746F722E657865637574654564697473282261636365707443757272656E74222C5B6A712E7265706C6163652872682E6C69667428742E72616E6765292C';
wwv_flow_imp.g_varchar2_table(28671) := '6E295D292C742E61636365707465642626617761697420746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428742E61636365707465642E69642C2E2E2E742E61636365707465642E617267756D656E74737C7C5B5D';
wwv_flow_imp.g_varchar2_table(28672) := '292E7468656E28766F696420302C4565292C746869732E66726565456469742874292C48542828653D3E7B746869732E5F63757272656E74456469742E73657428766F696420302C65292C746869732E5F6973416363657074696E672E7365742821312C';
wwv_flow_imp.g_varchar2_table(28673) := '65297D29297D6A756D70546F43757272656E7428297B76617220652C743B746869732E5F6A756D704261636B506F736974696F6E3D6E756C6C3D3D3D28653D746869732E656469746F722E67657453656C656374696F6E2829297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(28674) := '3D653F766F696420303A652E6765745374617274506F736974696F6E28293B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F63757272656E74456469742E6765742829297C7C766F696420303D3D3D743F766F696420303A742E656469743B';
wwv_flow_imp.g_varchar2_table(28675) := '696628216E2972657475726E3B636F6E737420693D6D632E6C696674287B6C696E654E756D6265723A6E2E72616E67652E73746172744C696E654E756D6265722C636F6C756D6E3A6E2E72616E67652E7374617274436F6C756D6E7D293B746869732E65';
wwv_flow_imp.g_varchar2_table(28676) := '6469746F722E736574506F736974696F6E2869292C746869732E656469746F722E72657665616C506F736974696F6E496E43656E74657249664F75747369646556696577706F72742869297D6173796E6320636C65617228653D2130297B76617220743B';
wwv_flow_imp.g_varchar2_table(28677) := '636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F63757272656E74456469742E6765742829297C7C766F696420303D3D3D743F766F696420303A742E656469743B6E2626286E756C6C3D3D6E3F766F696420303A6E2E72656A65637465642926';
wwv_flow_imp.g_varchar2_table(28678) := '26652626617761697420746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E64286E2E72656A65637465642E69642C2E2E2E6E2E72656A65637465642E617267756D656E74737C7C5B5D292E7468656E28766F69642030';
wwv_flow_imp.g_varchar2_table(28679) := '2C4565292C6E2626746869732E6672656545646974286E292C746869732E5F63757272656E74456469742E73657428766F696420302C766F69642030297D66726565456469742865297B636F6E737420743D746869732E656469746F722E6765744D6F64';
wwv_flow_imp.g_varchar2_table(28680) := '656C28293B69662821742972657475726E3B636F6E7374206E3D746869732E6C616E67756167654665617475726573536572766963652E696E6C696E654564697450726F76696465722E616C6C2874293B30213D3D6E2E6C656E67746826266E5B305D2E';
wwv_flow_imp.g_varchar2_table(28681) := '66726565496E6C696E65456469742865297D73686F756C6453686F77486F76657241742865297B636F6E737420743D746869732E5F63757272656E74456469742E67657428293B69662821742972657475726E21313B636F6E7374206E3D742E65646974';
wwv_flow_imp.g_varchar2_table(28682) := '2C693D742E7769646765742E6D6F64656C3B69662872682E636F6E7461696E73506F736974696F6E286E2E72616E67652C652E6765745374617274506F736974696F6E2829297C7C72682E636F6E7461696E73506F736974696F6E286E2E72616E67652C';
wwv_flow_imp.g_varchar2_table(28683) := '652E676574456E64506F736974696F6E2829292972657475726E21303B636F6E7374206F3D692E67686F7374546578742E67657428293B72657475726E21216F26266F2E70617274732E736F6D652828743D3E652E636F6E7461696E73506F736974696F';
wwv_flow_imp.g_varchar2_table(28684) := '6E286E6577206D63286F2E6C696E654E756D6265722C742E636F6C756D6E292929297D73686F756C6453686F77486F7665724174566965775A6F6E652865297B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D74';
wwv_flow_imp.g_varchar2_table(28685) := '6869732E5F63757272656E74456469742E6765742829297C7C766F696420303D3D3D743F766F696420303A742E7769646765742E6F776E73566965775A6F6E65286529292626766F69642030213D3D6E26266E7D7D3B67362E49443D22656469746F722E';
wwv_flow_imp.g_varchar2_table(28686) := '636F6E747269622E696E6C696E6545646974436F6E74726F6C6C6572222C67362E696E6C696E654564697456697369626C654B65793D22696E6C696E654564697456697369626C65222C67362E696E6C696E654564697456697369626C65436F6E746578';
wwv_flow_imp.g_varchar2_table(28687) := '743D6E6577206C642868362E696E6C696E654564697456697369626C654B65792C2131292C67362E637572736F724174496E6C696E65456469744B65793D22637572736F724174496E6C696E6545646974222C67362E637572736F724174496E6C696E65';
wwv_flow_imp.g_varchar2_table(28688) := '45646974436F6E746578743D6E6577206C642868362E637572736F724174496E6C696E65456469744B65792C2131292C67363D68363D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D73';
wwv_flow_imp.g_varchar2_table(28689) := '3C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(28690) := '6F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C33';
wwv_flow_imp.g_varchar2_table(28691) := '3F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B753628312C7563292C753628322C6364292C753628';
wwv_flow_imp.g_varchar2_table(28692) := '332C7878292C753628342C7863292C753628352C6670295D2C6736293B766172206D363D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732066367B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(28693) := '6F7228652C742C6E297B746869732E6F776E65723D652C746869732E72616E67653D742C746869732E636F6E74726F6C6C65723D6E7D697356616C6964466F72486F766572416E63686F722865297B72657475726E20313D3D3D652E7479706526267468';
wwv_flow_imp.g_varchar2_table(28694) := '69732E72616E67652E7374617274436F6C756D6E3C3D652E72616E67652E7374617274436F6C756D6E2626746869732E72616E67652E656E64436F6C756D6E3E3D652E72616E67652E656E64436F6C756D6E7D7D6C65742076363D636C6173737B636F6E';
wwv_flow_imp.g_varchar2_table(28695) := '7374727563746F7228652C742C6E297B746869732E5F656469746F723D652C746869732E5F696E7374616E74696174696F6E536572766963653D742C746869732E5F74656C656D65747279536572766963653D6E2C746869732E686F7665724F7264696E';
wwv_flow_imp.g_varchar2_table(28696) := '616C3D357D73756767657374486F766572416E63686F722865297B636F6E737420743D67362E67657428746869732E5F656469746F72293B69662821742972657475726E206E756C6C3B636F6E7374206E3D652E7461726765743B696628383D3D3D6E2E';
wwv_flow_imp.g_varchar2_table(28697) := '74797065297B636F6E737420693D6E2E64657461696C3B696628742E73686F756C6453686F77486F7665724174566965775A6F6E6528692E766965775A6F6E65496429297B636F6E737420743D6E2E72616E67653B72657475726E206E6577204C712831';
wwv_flow_imp.g_varchar2_table(28698) := '65332C746869732C742C652E6576656E742E706F73782C652E6576656E742E706F73792C2131297D7D72657475726E20373D3D3D6E2E747970652626742E73686F756C6453686F77486F7665724174286E2E72616E6765297C7C363D3D3D6E2E74797065';
wwv_flow_imp.g_varchar2_table(28699) := '26266E2E64657461696C2E6D696768744265466F726569676E456C656D656E742626742E73686F756C6453686F77486F7665724174286E2E72616E6765293F6E6577204C71283165332C746869732C6E2E72616E67652C652E6576656E742E706F73782C';
wwv_flow_imp.g_varchar2_table(28700) := '652E6576656E742E706F73792C2131293A6E756C6C7D636F6D7075746553796E6328652C74297B696628226F6E486F76657222213D3D746869732E5F656469746F722E6765744F7074696F6E283633292E73686F77546F6F6C6261722972657475726E5B';
wwv_flow_imp.g_varchar2_table(28701) := '5D3B636F6E7374206E3D67362E67657428746869732E5F656469746F72293B72657475726E206E26266E2E73686F756C6453686F77486F766572417428652E72616E6765293F5B6E657720663628746869732C652E72616E67652C6E295D3A5B5D7D7265';
wwv_flow_imp.g_varchar2_table(28702) := '6E646572486F766572506172747328652C74297B636F6E7374206E3D6E65772061743B746869732E5F74656C656D65747279536572766963652E7075626C69634C6F67322822696E6C696E6545646974486F7665722E73686F776E22293B636F6E737420';
wwv_flow_imp.g_varchar2_table(28703) := '693D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365286C362C746869732E5F656469746F722C21312C7349286E756C6C29293B72657475726E20652E667261676D656E742E617070656E64436869';
wwv_flow_imp.g_varchar2_table(28704) := '6C6428692E676574446F6D4E6F64652829292C6E2E6164642869292C6E7D7D3B76363D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A';
wwv_flow_imp.g_varchar2_table(28705) := '6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F72617465';
wwv_flow_imp.g_varchar2_table(28706) := '29723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A';
wwv_flow_imp.g_varchar2_table(28707) := '6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B6D3628312C7563292C6D3628322C4F64295D2C7636292C5A6428636C61737320657874656E647320';
wwv_flow_imp.g_varchar2_table(28708) := '55647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E6C696E65456469742E616363657074222C6C6162656C3A2241636365707420496E6C696E652045646974222C616C6961733A224163636570';
wwv_flow_imp.g_varchar2_table(28709) := '7420496E6C696E652045646974222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C67362E696E6C696E654564697456697369626C65436F6E74657874292C6B624F7074733A5B7B7765696768743A3130312C7072696D';
wwv_flow_imp.g_varchar2_table(28710) := '6172793A322C6B62457870723A57632E616E64286C682E7772697461626C652C67362E696E6C696E654564697456697369626C65436F6E746578742C67362E637572736F724174496E6C696E6545646974436F6E74657874297D5D2C6D656E754F707473';
wwv_flow_imp.g_varchar2_table(28711) := '3A5B7B6D656E7549643A4C642E496E6C696E6545646974546F6F6C6261722C7469746C653A22416363657074222C67726F75703A227072696D617279222C6F726465723A317D5D7D297D6173796E632072756E28652C74297B636F6E7374206E3D67362E';
wwv_flow_imp.g_varchar2_table(28712) := '6765742874293B6177616974286E756C6C3D3D6E3F766F696420303A6E2E6163636570742829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B636F6E737420653D57632E616E64286C682E7772697461';
wwv_flow_imp.g_varchar2_table(28713) := '626C652C67362E696E6C696E654564697456697369626C65436F6E74657874293B7375706572287B69643A22656469746F722E616374696F6E2E696E6C696E65456469742E72656A656374222C6C6162656C3A2252656A65637420496E6C696E65204564';
wwv_flow_imp.g_varchar2_table(28714) := '6974222C616C6961733A2252656A65637420496E6C696E652045646974222C707265636F6E646974696F6E3A652C6B624F7074733A7B7765696768743A3130302C7072696D6172793A392C6B62457870723A657D2C6D656E754F7074733A5B7B6D656E75';
wwv_flow_imp.g_varchar2_table(28715) := '49643A4C642E496E6C696E6545646974546F6F6C6261722C7469746C653A2252656A656374222C67726F75703A227365636F6E64617279222C6F726465723A327D5D7D297D6173796E632072756E28652C74297B636F6E7374206E3D67362E6765742874';
wwv_flow_imp.g_varchar2_table(28716) := '293B6177616974286E756C6C3D3D6E3F766F696420303A6E2E636C6561722829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B636F6E737420653D57632E616E64286C682E7772697461626C652C6736';
wwv_flow_imp.g_varchar2_table(28717) := '2E696E6C696E654564697456697369626C65436F6E746578742C57632E6E6F742867362E637572736F724174496E6C696E65456469744B657929293B7375706572287B69643A22656469746F722E616374696F6E2E696E6C696E65456469742E6A756D70';
wwv_flow_imp.g_varchar2_table(28718) := '546F222C6C6162656C3A224A756D7020746F20496E6C696E652045646974222C616C6961733A224A756D7020746F20496E6C696E652045646974222C707265636F6E646974696F6E3A652C6B624F7074733A7B7765696768743A3130312C7072696D6172';
wwv_flow_imp.g_varchar2_table(28719) := '793A323634362C6B62457870723A657D2C6D656E754F7074733A5B7B6D656E7549643A4C642E496E6C696E6545646974546F6F6C6261722C7469746C653A224A756D7020546F2045646974222C67726F75703A227072696D617279222C6F726465723A33';
wwv_flow_imp.g_varchar2_table(28720) := '2C7768656E3A657D5D7D297D6173796E632072756E28652C74297B636F6E7374206E3D67362E6765742874293B6E756C6C3D3D6E7C7C6E2E6A756D70546F43757272656E7428297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374';
wwv_flow_imp.g_varchar2_table(28721) := '727563746F7228297B636F6E737420653D57632E616E64286C682E7772697461626C652C67362E637572736F724174496E6C696E6545646974436F6E74657874293B7375706572287B69643A22656469746F722E616374696F6E2E696E6C696E65456469';
wwv_flow_imp.g_varchar2_table(28722) := '742E6A756D704261636B222C6C6162656C3A224A756D70204261636B2066726F6D20496E6C696E652045646974222C616C6961733A224A756D70204261636B2066726F6D20496E6C696E652045646974222C707265636F6E646974696F6E3A652C6B624F';
wwv_flow_imp.g_varchar2_table(28723) := '7074733A7B7765696768743A3131302C7072696D6172793A323634362C6B62457870723A657D2C6D656E754F7074733A5B7B6D656E7549643A4C642E496E6C696E6545646974546F6F6C6261722C7469746C653A224A756D70204261636B222C67726F75';
wwv_flow_imp.g_varchar2_table(28724) := '703A227072696D617279222C6F726465723A332C7768656E3A657D5D7D297D6173796E632072756E28652C74297B636F6E7374206E3D67362E6765742874293B6E756C6C3D3D6E7C7C6E2E6A756D704261636B28297D7D292C5A6428636C617373206578';
wwv_flow_imp.g_varchar2_table(28725) := '74656E64732055647B636F6E7374727563746F7228297B636F6E737420653D57632E616E64286C682E7772697461626C652C57632E6E6F742867362E696E6C696E654564697456697369626C654B657929293B7375706572287B69643A22656469746F72';
wwv_flow_imp.g_varchar2_table(28726) := '2E616374696F6E2E696E6C696E65456469742E74726967676572222C6C6162656C3A225472696767657220496E6C696E652045646974222C616C6961733A225472696767657220496E6C696E652045646974222C707265636F6E646974696F6E3A652C6B';
wwv_flow_imp.g_varchar2_table(28727) := '624F7074733A7B7765696768743A3130312C7072696D6172793A323634362C6B62457870723A657D7D297D6173796E632072756E28652C74297B636F6E7374206E3D67362E6765742874293B6E756C6C3D3D6E7C7C6E2E7472696767657228297D7D292C';
wwv_flow_imp.g_varchar2_table(28728) := '4A642867362E49442C67362C33292C44712E7265676973746572287636293B7661722062363D6E2832393331292C5F363D7B7D3B5F362E7374796C655461675472616E73666F726D3D6A7228292C5F362E736574417474726962757465733D567228292C';
wwv_flow_imp.g_varchar2_table(28729) := '5F362E696E736572743D467228292E62696E64286E756C6C2C226865616422292C5F362E646F6D4150493D4F7228292C5F362E696E736572745374796C65456C656D656E743D487228292C4E7228292862362E412C5F36292C62362E41262662362E412E';
wwv_flow_imp.g_varchar2_table(28730) := '6C6F63616C73262662362E412E6C6F63616C733B636F6E73742079363D706328227468656D655365727669636522293B7661722077362C43363D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65';
wwv_flow_imp.g_varchar2_table(28731) := '297D7D3B6C65742053363D77363D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2877362E4944297D636F6E7374727563746F7228652C742C6E297B73757065';
wwv_flow_imp.g_varchar2_table(28732) := '7228292C746869732E5F656469746F723D652C746869732E5F6C616E6775616765536572766963653D6E2C746869732E5F7769646765743D6E756C6C2C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(28733) := '4D6F64656C2828653D3E746869732E73746F7028292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4C616E67756167652828653D3E746869732E73746F7028292929292C746869';
wwv_flow_imp.g_varchar2_table(28734) := '732E5F72656769737465722850772E6F6E4469644368616E67652828653D3E746869732E73746F7028292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4B657955702828653D3E393D3D3D652E6B6579436F646526';
wwv_flow_imp.g_varchar2_table(28735) := '26746869732E73746F7028292929297D646973706F736528297B746869732E73746F7028292C73757065722E646973706F736528297D6C61756E636828297B746869732E5F7769646765747C7C746869732E5F656469746F722E6861734D6F64656C2829';
wwv_flow_imp.g_varchar2_table(28736) := '262628746869732E5F7769646765743D6E657720783628746869732E5F656469746F722C746869732E5F6C616E67756167655365727669636529297D73746F7028297B746869732E5F776964676574262628746869732E5F7769646765742E646973706F';
wwv_flow_imp.g_varchar2_table(28737) := '736528292C746869732E5F7769646765743D6E756C6C297D7D3B53362E49443D22656469746F722E636F6E747269622E696E7370656374546F6B656E73222C53363D77363D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D';
wwv_flow_imp.g_varchar2_table(28738) := '656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C656374262622';
wwv_flow_imp.g_varchar2_table(28739) := '66756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F';
wwv_flow_imp.g_varchar2_table(28740) := '3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B433628312C79';
wwv_flow_imp.g_varchar2_table(28741) := '36292C433628322C4C75295D2C5336293B636C61737320783620657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(28742) := '6F723D652C746869732E5F6C616E6775616765536572766963653D742C746869732E5F6D6F64656C3D746869732E5F656469746F722E6765744D6F64656C28292C746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E';
wwv_flow_imp.g_varchar2_table(28743) := '74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D22746F6B656E732D696E73706563742D776964676574222C746869732E5F746F6B656E697A6174696F6E537570706F72743D66756E6374696F6E28652C74297B636F6E';
wwv_flow_imp.g_varchar2_table(28744) := '7374206E3D50772E6765742874293B6966286E2972657475726E206E3B636F6E737420693D652E656E636F64654C616E677561676549642874293B72657475726E7B676574496E697469616C53746174653A28293D3E52772C746F6B656E697A653A2865';
wwv_flow_imp.g_varchar2_table(28745) := '2C6E2C69293D3E467728742C69292C746F6B656E697A65456E636F6465643A28652C742C6E293D3E427728692C6E297D7D28746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632C746869732E5F6D6F64656C2E';
wwv_flow_imp.g_varchar2_table(28746) := '6765744C616E677561676549642829292C746869732E5F636F6D7075746528746869732E5F656469746F722E676574506F736974696F6E2829292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654375';
wwv_flow_imp.g_varchar2_table(28747) := '72736F72506F736974696F6E2828653D3E746869732E5F636F6D7075746528746869732E5F656469746F722E676574506F736974696F6E2829292929292C746869732E5F656469746F722E616464436F6E74656E745769646765742874686973297D6469';
wwv_flow_imp.g_varchar2_table(28748) := '73706F736528297B746869732E5F656469746F722E72656D6F7665436F6E74656E745769646765742874686973292C73757065722E646973706F736528297D676574496428297B72657475726E2078362E5F49447D5F636F6D707574652865297B636F6E';
wwv_flow_imp.g_varchar2_table(28749) := '737420743D746869732E5F676574546F6B656E7341744C696E6528652E6C696E654E756D626572293B6C6574206E3D303B666F72286C657420693D742E746F6B656E73312E6C656E6774682D313B693E3D303B692D2D297B636F6E7374206F3D742E746F';
wwv_flow_imp.g_varchar2_table(28750) := '6B656E73315B695D3B696628652E636F6C756D6E2D313E3D6F2E6F6666736574297B6E3D693B627265616B7D7D6C657420693D303B666F72286C6574206E3D742E746F6B656E73322E6C656E6774683E3E3E313B6E3E3D303B6E2D2D29696628652E636F';
wwv_flow_imp.g_varchar2_table(28751) := '6C756D6E2D313E3D742E746F6B656E73325B6E3C3C315D297B693D6E3B627265616B7D636F6E7374206F3D746869732E5F6D6F64656C2E6765744C696E65436F6E74656E7428652E6C696E654E756D626572293B6C657420733D22223B6966286E3C742E';
wwv_flow_imp.g_varchar2_table(28752) := '746F6B656E73312E6C656E677468297B636F6E737420653D742E746F6B656E73315B6E5D2E6F66667365742C693D6E2B313C742E746F6B656E73312E6C656E6774683F742E746F6B656E73315B6E2B315D2E6F66667365743A6F2E6C656E6774683B733D';
wwv_flow_imp.g_varchar2_table(28753) := '6F2E737562737472696E6728652C69297D677228746869732E5F646F6D4E6F64652C6272282268322E746D2D746F6B656E222C766F696420302C66756E6374696F6E2865297B6C657420743D22223B666F72286C6574206E3D302C693D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(28754) := '683B6E3C693B6E2B2B297B636F6E737420693D652E63686172436F64654174286E293B7377697463682869297B6361736520393A742B3D22E28692223B627265616B3B636173652033323A742B3D22C2B7223B627265616B3B64656661756C743A742B3D';
wwv_flow_imp.g_varchar2_table(28755) := '537472696E672E66726F6D43686172436F64652869297D7D72657475726E20747D2873292C627228227370616E2E746D2D746F6B656E2D6C656E677468222C766F696420302C60247B732E6C656E6774687D20247B313D3D3D732E6C656E6774683F2263';
wwv_flow_imp.g_varchar2_table(28756) := '686172223A226368617273227D602929292C757228746869732E5F646F6D4E6F64652C6272282268722E746F6B656E732D696E73706563742D736570617261746F72222C7B7374796C653A22636C6561723A626F7468227D29293B636F6E737420723D31';
wwv_flow_imp.g_varchar2_table(28757) := '2B28693C3C31293C742E746F6B656E73322E6C656E6774683F746869732E5F6465636F64654D6574616461746128742E746F6B656E73325B312B28693C3C31295D293A6E756C6C3B757228746869732E5F646F6D4E6F64652C627228227461626C652E74';
wwv_flow_imp.g_varchar2_table(28758) := '6D2D6D657461646174612D7461626C65222C766F696420302C6272282274626F6479222C766F696420302C627228227472222C766F696420302C6272282274642E746D2D6D657461646174612D6B6579222C766F696420302C226C616E67756167652229';
wwv_flow_imp.g_varchar2_table(28759) := '2C6272282274642E746D2D6D657461646174612D76616C7565222C766F696420302C60247B723F722E6C616E677561676549643A222D3F2D227D6029292C627228227472222C766F696420302C6272282274642E746D2D6D657461646174612D6B657922';
wwv_flow_imp.g_varchar2_table(28760) := '2C766F696420302C22746F6B656E207479706522292C6272282274642E746D2D6D657461646174612D76616C7565222C766F696420302C60247B723F746869732E5F746F6B656E54797065546F537472696E6728722E746F6B656E54797065293A222D3F';
wwv_flow_imp.g_varchar2_table(28761) := '2D227D6029292C627228227472222C766F696420302C6272282274642E746D2D6D657461646174612D6B6579222C766F696420302C22666F6E74207374796C6522292C6272282274642E746D2D6D657461646174612D76616C7565222C766F696420302C';
wwv_flow_imp.g_varchar2_table(28762) := '60247B723F746869732E5F666F6E745374796C65546F537472696E6728722E666F6E745374796C65293A222D3F2D227D6029292C627228227472222C766F696420302C6272282274642E746D2D6D657461646174612D6B6579222C766F696420302C2266';
wwv_flow_imp.g_varchar2_table(28763) := '6F726567726F756E6422292C6272282274642E746D2D6D657461646174612D76616C7565222C766F696420302C60247B723F68752E466F726D61742E4353532E666F726D617448657828722E666F726567726F756E64293A222D3F2D227D6029292C6272';
wwv_flow_imp.g_varchar2_table(28764) := '28227472222C766F696420302C6272282274642E746D2D6D657461646174612D6B6579222C766F696420302C226261636B67726F756E6422292C6272282274642E746D2D6D657461646174612D76616C7565222C766F696420302C60247B723F68752E46';
wwv_flow_imp.g_varchar2_table(28765) := '6F726D61742E4353532E666F726D617448657828722E6261636B67726F756E64293A222D3F2D227D6029292929292C757228746869732E5F646F6D4E6F64652C6272282268722E746F6B656E732D696E73706563742D736570617261746F722229292C6E';
wwv_flow_imp.g_varchar2_table(28766) := '3C742E746F6B656E73312E6C656E6774682626757228746869732E5F646F6D4E6F64652C627228227370616E2E746D2D746F6B656E2D74797065222C766F696420302C742E746F6B656E73315B6E5D2E7479706529292C746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(28767) := '6C61796F7574436F6E74656E745769646765742874686973297D5F6465636F64654D657461646174612865297B636F6E737420743D50772E676574436F6C6F724D617028292C6E3D51672E6765744C616E677561676549642865292C693D51672E676574';
wwv_flow_imp.g_varchar2_table(28768) := '546F6B656E547970652865292C6F3D51672E676574466F6E745374796C652865292C733D51672E676574466F726567726F756E642865292C723D51672E6765744261636B67726F756E642865293B72657475726E7B6C616E677561676549643A74686973';
wwv_flow_imp.g_varchar2_table(28769) := '2E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632E6465636F64654C616E67756167654964286E292C746F6B656E547970653A692C666F6E745374796C653A6F2C666F726567726F756E643A745B735D2C6261636B6772';
wwv_flow_imp.g_varchar2_table(28770) := '6F756E643A745B725D7D7D5F746F6B656E54797065546F537472696E672865297B7377697463682865297B6361736520303A72657475726E224F74686572223B6361736520313A72657475726E22436F6D6D656E74223B6361736520323A72657475726E';
wwv_flow_imp.g_varchar2_table(28771) := '22537472696E67223B6361736520333A72657475726E225265674578223B64656661756C743A72657475726E223F3F227D7D5F666F6E745374796C65546F537472696E672865297B6C657420743D22223B72657475726E20312665262628742B3D226974';
wwv_flow_imp.g_varchar2_table(28772) := '616C69632022292C322665262628742B3D22626F6C642022292C342665262628742B3D22756E6465726C696E652022292C382665262628742B3D22737472696B657468726F7567682022292C303D3D3D742E6C656E677468262628743D222D2D2D22292C';
wwv_flow_imp.g_varchar2_table(28773) := '747D5F676574546F6B656E7341744C696E652865297B636F6E737420743D746869732E5F67657453746174654265666F72654C696E652865292C6E3D746869732E5F746F6B656E697A6174696F6E537570706F72742E746F6B656E697A6528746869732E';
wwv_flow_imp.g_varchar2_table(28774) := '5F6D6F64656C2E6765744C696E65436F6E74656E742865292C21302C74292C693D746869732E5F746F6B656E697A6174696F6E537570706F72742E746F6B656E697A65456E636F64656428746869732E5F6D6F64656C2E6765744C696E65436F6E74656E';
wwv_flow_imp.g_varchar2_table(28775) := '742865292C21302C74293B72657475726E7B737461727453746174653A742C746F6B656E73313A6E2E746F6B656E732C746F6B656E73323A692E746F6B656E732C656E6453746174653A6E2E656E6453746174657D7D5F67657453746174654265666F72';
wwv_flow_imp.g_varchar2_table(28776) := '654C696E652865297B6C657420743D746869732E5F746F6B656E697A6174696F6E537570706F72742E676574496E697469616C537461746528293B666F72286C6574206E3D313B6E3C653B6E2B2B29743D746869732E5F746F6B656E697A6174696F6E53';
wwv_flow_imp.g_varchar2_table(28777) := '7570706F72742E746F6B656E697A6528746869732E5F6D6F64656C2E6765744C696E65436F6E74656E74286E292C21302C74292E656E6453746174653B72657475726E20747D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E';
wwv_flow_imp.g_varchar2_table(28778) := '6F64657D676574506F736974696F6E28297B72657475726E7B706F736974696F6E3A746869732E5F656469746F722E676574506F736974696F6E28292C707265666572656E63653A5B322C315D7D7D7D78362E5F49443D22656469746F722E636F6E7472';
wwv_flow_imp.g_varchar2_table(28779) := '69622E696E7370656374546F6B656E73576964676574222C4A642853362E49442C53362C34292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E';
wwv_flow_imp.g_varchar2_table(28780) := '7370656374546F6B656E73222C6C6162656C3A50322E696E7370656374546F6B656E73416374696F6E2C616C6961733A22446576656C6F7065723A20496E737065637420546F6B656E73222C707265636F6E646974696F6E3A766F696420307D297D7275';
wwv_flow_imp.g_varchar2_table(28781) := '6E28652C74297B636F6E7374206E3D53362E6765742874293B6E756C6C3D3D6E7C7C6E2E6C61756E636828297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22657870616E644C';
wwv_flow_imp.g_varchar2_table(28782) := '696E6553656C656374696F6E222C6C6162656C3A6228302C22457870616E64204C696E652053656C656374696F6E22292C616C6961733A22457870616E64204C696E652053656C656374696F6E222C707265636F6E646974696F6E3A766F696420302C6B';
wwv_flow_imp.g_varchar2_table(28783) := '624F7074733A7B7765696768743A302C6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A323039307D7D297D72756E28652C742C6E297B6966286E3D6E7C7C7B7D2C21742E6861734D6F64656C28292972657475726E3B';
wwv_flow_imp.g_varchar2_table(28784) := '636F6E737420693D742E5F676574566965774D6F64656C28293B692E6D6F64656C2E70757368537461636B456C656D656E7428292C692E736574437572736F72537461746573286E2E736F757263652C332C67532E657870616E644C696E6553656C6563';
wwv_flow_imp.g_varchar2_table(28785) := '74696F6E28692C692E676574437572736F72537461746573282929292C692E72657665616C416C6C437572736F7273286E2E736F757263652C2130297D7D293B636C617373206B367B636F6E7374727563746F7228652C742C6E297B746869732E5F7365';
wwv_flow_imp.g_varchar2_table(28786) := '6C656374696F6E3D652C746869732E5F637572736F72733D742C746869732E5F73656C656374696F6E49643D6E756C6C2C746869732E5F7472696D496E52656765786573416E64537472696E67733D6E7D676574456469744F7065726174696F6E732865';
wwv_flow_imp.g_varchar2_table(28787) := '2C74297B636F6E7374206E3D66756E6374696F6E28652C742C6E297B742E736F7274282828652C74293D3E652E6C696E654E756D6265723D3D3D742E6C696E654E756D6265723F652E636F6C756D6E2D742E636F6C756D6E3A652E6C696E654E756D6265';
wwv_flow_imp.g_varchar2_table(28788) := '722D742E6C696E654E756D62657229293B666F72286C657420653D742E6C656E6774682D323B653E3D303B652D2D29745B655D2E6C696E654E756D6265723D3D3D745B652B315D2E6C696E654E756D6265722626742E73706C69636528652C31293B636F';
wwv_flow_imp.g_varchar2_table(28789) := '6E737420693D5B5D3B6C6574206F3D302C733D303B636F6E737420723D742E6C656E6774683B666F72286C657420613D312C6C3D652E6765744C696E65436F756E7428293B613C3D6C3B612B2B297B636F6E7374206C3D652E6765744C696E65436F6E74';
wwv_flow_imp.g_varchar2_table(28790) := '656E742861292C633D6C2E6C656E6774682B313B6C657420643D303B696628733C722626745B735D2E6C696E654E756D6265723D3D3D61262628643D745B735D2E636F6C756D6E2C732B2B2C643D3D3D632929636F6E74696E75653B696628303D3D3D6C';
wwv_flow_imp.g_varchar2_table(28791) := '2E6C656E67746829636F6E74696E75653B636F6E737420683D7669286C293B6C657420753D303B6966282D313D3D3D6829753D313B656C73657B696628683D3D3D6C2E6C656E6774682D3129636F6E74696E75653B753D682B327D696628216E297B6966';
wwv_flow_imp.g_varchar2_table(28792) := '2821652E746F6B656E697A6174696F6E2E6861734163637572617465546F6B656E73466F724C696E6528612929636F6E74696E75653B636F6E737420743D652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732861292C6E3D742E6765';
wwv_flow_imp.g_varchar2_table(28793) := '745374616E64617264546F6B656E5479706528742E66696E64546F6B656E496E64657841744F6666736574287529293B696628323D3D3D6E7C7C333D3D3D6E29636F6E74696E75657D753D4D6174682E6D617828642C75292C695B6F2B2B5D3D6A712E64';
wwv_flow_imp.g_varchar2_table(28794) := '656C657465286E657720726828612C752C612C6329297D72657475726E20697D28652C746869732E5F637572736F72732C746869732E5F7472696D496E52656765786573416E64537472696E6773293B666F72286C657420653D302C693D6E2E6C656E67';
wwv_flow_imp.g_varchar2_table(28795) := '74683B653C693B652B2B297B636F6E737420693D6E5B655D3B742E616464456469744F7065726174696F6E28692E72616E67652C692E74657874297D746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E';
wwv_flow_imp.g_varchar2_table(28796) := '5F73656C656374696F6E297D636F6D70757465437572736F72537461746528652C74297B72657475726E20742E676574547261636B656453656C656374696F6E28746869732E5F73656C656374696F6E4964297D7D636C6173732045367B636F6E737472';
wwv_flow_imp.g_varchar2_table(28797) := '7563746F7228652C742C6E297B746869732E5F73656C656374696F6E3D652C746869732E5F6973436F7079696E67446F776E3D742C746869732E5F6E6F6F703D6E7C7C21312C746869732E5F73656C656374696F6E446972656374696F6E3D302C746869';
wwv_flow_imp.g_varchar2_table(28798) := '732E5F73656C656374696F6E49643D6E756C6C2C746869732E5F73746172744C696E654E756D62657244656C74613D302C746869732E5F656E644C696E654E756D62657244656C74613D307D676574456469744F7065726174696F6E7328652C74297B6C';
wwv_flow_imp.g_varchar2_table(28799) := '6574206E3D746869732E5F73656C656374696F6E3B746869732E5F73746172744C696E654E756D62657244656C74613D302C746869732E5F656E644C696E654E756D62657244656C74613D302C6E2E73746172744C696E654E756D6265723C6E2E656E64';
wwv_flow_imp.g_varchar2_table(28800) := '4C696E654E756D6265722626313D3D3D6E2E656E64436F6C756D6E262628746869732E5F656E644C696E654E756D62657244656C74613D312C6E3D6E2E736574456E64506F736974696F6E286E2E656E644C696E654E756D6265722D312C652E6765744C';
wwv_flow_imp.g_varchar2_table(28801) := '696E654D6178436F6C756D6E286E2E656E644C696E654E756D6265722D312929293B636F6E737420693D5B5D3B666F72286C657420743D6E2E73746172744C696E654E756D6265723B743C3D6E2E656E644C696E654E756D6265723B742B2B29692E7075';
wwv_flow_imp.g_varchar2_table(28802) := '736828652E6765744C696E65436F6E74656E74287429293B636F6E7374206F3D692E6A6F696E28225C6E22293B22223D3D3D6F2626746869732E5F6973436F7079696E67446F776E262628746869732E5F73746172744C696E654E756D62657244656C74';
wwv_flow_imp.g_varchar2_table(28803) := '612B2B2C746869732E5F656E644C696E654E756D62657244656C74612B2B292C746869732E5F6E6F6F703F742E616464456469744F7065726174696F6E286E6577207268286E2E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C';
wwv_flow_imp.g_varchar2_table(28804) := '756D6E286E2E656E644C696E654E756D626572292C6E2E656E644C696E654E756D6265722B312C31292C6E2E656E644C696E654E756D6265723D3D3D652E6765744C696E65436F756E7428293F22223A225C6E22293A746869732E5F6973436F7079696E';
wwv_flow_imp.g_varchar2_table(28805) := '67446F776E3F742E616464456469744F7065726174696F6E286E6577207268286E2E73746172744C696E654E756D6265722C312C6E2E73746172744C696E654E756D6265722C31292C6F2B225C6E22293A742E616464456469744F7065726174696F6E28';
wwv_flow_imp.g_varchar2_table(28806) := '6E6577207268286E2E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E286E2E656E644C696E654E756D626572292C6E2E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E286E2E656E644C';
wwv_flow_imp.g_varchar2_table(28807) := '696E654E756D62657229292C225C6E222B6F292C746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E286E292C746869732E5F73656C656374696F6E446972656374696F6E3D746869732E5F73656C656374696F6E2E67';
wwv_flow_imp.g_varchar2_table(28808) := '6574446972656374696F6E28297D636F6D70757465437572736F72537461746528652C74297B6C6574206E3D742E676574547261636B656453656C656374696F6E28746869732E5F73656C656374696F6E4964293B69662830213D3D746869732E5F7374';
wwv_flow_imp.g_varchar2_table(28809) := '6172744C696E654E756D62657244656C74617C7C30213D3D746869732E5F656E644C696E654E756D62657244656C7461297B6C657420653D6E2E73746172744C696E654E756D6265722C743D6E2E7374617274436F6C756D6E2C693D6E2E656E644C696E';
wwv_flow_imp.g_varchar2_table(28810) := '654E756D6265722C6F3D6E2E656E64436F6C756D6E3B30213D3D746869732E5F73746172744C696E654E756D62657244656C7461262628652B3D746869732E5F73746172744C696E654E756D62657244656C74612C743D31292C30213D3D746869732E5F';
wwv_flow_imp.g_varchar2_table(28811) := '656E644C696E654E756D62657244656C7461262628692B3D746869732E5F656E644C696E654E756D62657244656C74612C6F3D31292C6E3D61682E63726561746557697468446972656374696F6E28652C742C692C6F2C746869732E5F73656C65637469';
wwv_flow_imp.g_varchar2_table(28812) := '6F6E446972656374696F6E297D72657475726E206E7D7D6C6574204C363D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D692C746869732E5F';
wwv_flow_imp.g_varchar2_table(28813) := '73656C656374696F6E3D652C746869732E5F69734D6F76696E67446F776E3D742C746869732E5F6175746F496E64656E743D6E2C746869732E5F73656C656374696F6E49643D6E756C6C2C746869732E5F6D6F7665456E644C696E6553656C656374696F';
wwv_flow_imp.g_varchar2_table(28814) := '6E536872696E6B3D21317D676574456469744F7065726174696F6E7328652C74297B636F6E7374206E3D652E6765744C696E65436F756E7428293B696628746869732E5F69734D6F76696E67446F776E2626746869732E5F73656C656374696F6E2E656E';
wwv_flow_imp.g_varchar2_table(28815) := '644C696E654E756D6265723D3D3D6E2972657475726E20766F696428746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F73656C656374696F6E29293B69662821746869732E5F69734D6F76696E6744';
wwv_flow_imp.g_varchar2_table(28816) := '6F776E2626313D3D3D746869732E5F73656C656374696F6E2E73746172744C696E654E756D6265722972657475726E20766F696428746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E5F73656C656374';
wwv_flow_imp.g_varchar2_table(28817) := '696F6E29293B746869732E5F6D6F7665456E64506F736974696F6E446F776E3D21313B6C657420693D746869732E5F73656C656374696F6E3B692E73746172744C696E654E756D6265723C692E656E644C696E654E756D6265722626313D3D3D692E656E';
wwv_flow_imp.g_varchar2_table(28818) := '64436F6C756D6E262628746869732E5F6D6F7665456E64506F736974696F6E446F776E3D21302C693D692E736574456E64506F736974696F6E28692E656E644C696E654E756D6265722D312C652E6765744C696E654D6178436F6C756D6E28692E656E64';
wwv_flow_imp.g_varchar2_table(28819) := '4C696E654E756D6265722D312929293B636F6E73747B74616253697A653A6F2C696E64656E7453697A653A732C696E736572745370616365733A727D3D652E6765744F7074696F6E7328292C613D746869732E6275696C64496E64656E74436F6E766572';
wwv_flow_imp.g_varchar2_table(28820) := '746572286F2C732C72292C6C3D7B746F6B656E697A6174696F6E3A7B6765744C696E65546F6B656E733A743D3E652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732874292C6765744C616E677561676549643A28293D3E652E676574';
wwv_flow_imp.g_varchar2_table(28821) := '4C616E6775616765496428292C6765744C616E677561676549644174506F736974696F6E3A28742C6E293D3E652E6765744C616E677561676549644174506F736974696F6E28742C6E297D2C6765744C696E65436F6E74656E743A6E756C6C7D3B696628';
wwv_flow_imp.g_varchar2_table(28822) := '692E73746172744C696E654E756D6265723D3D3D692E656E644C696E654E756D6265722626313D3D3D652E6765744C696E654D6178436F6C756D6E28692E73746172744C696E654E756D62657229297B636F6E7374206E3D692E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(28823) := '756D6265722C6F3D746869732E5F69734D6F76696E67446F776E3F6E2B313A6E2D313B313D3D3D652E6765744C696E654D6178436F6C756D6E286F293F742E616464456469744F7065726174696F6E286E657720726828312C312C312C31292C6E756C6C';
wwv_flow_imp.g_varchar2_table(28824) := '293A28742E616464456469744F7065726174696F6E286E6577207268286E2C312C6E2C31292C652E6765744C696E65436F6E74656E74286F29292C742E616464456469744F7065726174696F6E286E6577207268286F2C312C6F2C652E6765744C696E65';
wwv_flow_imp.g_varchar2_table(28825) := '4D6178436F6C756D6E286F29292C6E756C6C29292C693D6E6577206168286F2C312C6F2C31297D656C73657B6C6574206E2C733B696628746869732E5F69734D6F76696E67446F776E297B6E3D692E656E644C696E654E756D6265722B312C733D652E67';
wwv_flow_imp.g_varchar2_table(28826) := '65744C696E65436F6E74656E74286E292C742E616464456469744F7065726174696F6E286E6577207268286E2D312C652E6765744C696E654D6178436F6C756D6E286E2D31292C6E2C652E6765744C696E654D6178436F6C756D6E286E29292C6E756C6C';
wwv_flow_imp.g_varchar2_table(28827) := '293B6C657420633D733B696628746869732E73686F756C644175746F496E64656E7428652C6929297B636F6E737420643D746869732E6D61746368456E74657252756C6528652C612C6F2C6E2C692E73746172744C696E654E756D6265722D31293B6966';
wwv_flow_imp.g_varchar2_table(28828) := '286E756C6C213D3D64297B636F6E737420743D683328642B643328666928652E6765744C696E65436F6E74656E74286E29292C6F292C6F2C72293B633D742B746869732E7472696D53746172742873297D656C73657B6C2E6765744C696E65436F6E7465';
wwv_flow_imp.g_varchar2_table(28829) := '6E743D743D3E743D3D3D692E73746172744C696E654E756D6265723F652E6765744C696E65436F6E74656E74286E293A652E6765744C696E65436F6E74656E742874293B636F6E737420743D785328746869732E5F6175746F496E64656E742C6C2C652E';
wwv_flow_imp.g_varchar2_table(28830) := '6765744C616E677561676549644174506F736974696F6E286E2C31292C692E73746172744C696E654E756D6265722C612C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286E756C6C213D3D74297B636F';
wwv_flow_imp.g_varchar2_table(28831) := '6E737420693D666928652E6765744C696E65436F6E74656E74286E29292C613D643328742C6F293B69662861213D3D643328692C6F29297B636F6E737420653D683328612C6F2C72293B633D652B746869732E7472696D53746172742873297D7D7D742E';
wwv_flow_imp.g_varchar2_table(28832) := '616464456469744F7065726174696F6E286E657720726828692E73746172744C696E654E756D6265722C312C692E73746172744C696E654E756D6265722C31292C632B225C6E22293B636F6E737420683D746869732E6D61746368456E74657252756C65';
wwv_flow_imp.g_varchar2_table(28833) := '4D6F76696E67446F776E28652C612C6F2C692E73746172744C696E654E756D6265722C6E2C63293B6966286E756C6C213D3D682930213D3D682626746869732E676574496E64656E7445646974734F664D6F76696E67426C6F636B28652C742C692C6F2C';
wwv_flow_imp.g_varchar2_table(28834) := '722C68293B656C73657B6C2E6765744C696E65436F6E74656E743D743D3E743D3D3D692E73746172744C696E654E756D6265723F633A743E3D692E73746172744C696E654E756D6265722B312626743C3D692E656E644C696E654E756D6265722B313F65';
wwv_flow_imp.g_varchar2_table(28835) := '2E6765744C696E65436F6E74656E7428742D31293A652E6765744C696E65436F6E74656E742874293B636F6E737420733D785328746869732E5F6175746F496E64656E742C6C2C652E6765744C616E677561676549644174506F736974696F6E286E2C31';
wwv_flow_imp.g_varchar2_table(28836) := '292C692E73746172744C696E654E756D6265722B312C612C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286E756C6C213D3D73297B636F6E7374206E3D666928652E6765744C696E65436F6E74656E74';
wwv_flow_imp.g_varchar2_table(28837) := '28692E73746172744C696E654E756D62657229292C613D643328732C6F292C6C3D6433286E2C6F293B69662861213D3D6C297B636F6E7374206E3D612D6C3B746869732E676574496E64656E7445646974734F664D6F76696E67426C6F636B28652C742C';
wwv_flow_imp.g_varchar2_table(28838) := '692C6F2C722C6E297D7D7D7D656C736520742E616464456469744F7065726174696F6E286E657720726828692E73746172744C696E654E756D6265722C312C692E73746172744C696E654E756D6265722C31292C632B225C6E22297D656C736520696628';
wwv_flow_imp.g_varchar2_table(28839) := '6E3D692E73746172744C696E654E756D6265722D312C733D652E6765744C696E65436F6E74656E74286E292C742E616464456469744F7065726174696F6E286E6577207268286E2C312C6E2B312C31292C6E756C6C292C742E616464456469744F706572';
wwv_flow_imp.g_varchar2_table(28840) := '6174696F6E286E657720726828692E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E28692E656E644C696E654E756D626572292C692E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E28';
wwv_flow_imp.g_varchar2_table(28841) := '692E656E644C696E654E756D62657229292C225C6E222B73292C746869732E73686F756C644175746F496E64656E7428652C6929297B6C2E6765744C696E65436F6E74656E743D743D3E743D3D3D6E3F652E6765744C696E65436F6E74656E7428692E73';
wwv_flow_imp.g_varchar2_table(28842) := '746172744C696E654E756D626572293A652E6765744C696E65436F6E74656E742874293B636F6E737420733D746869732E6D61746368456E74657252756C6528652C612C6F2C692E73746172744C696E654E756D6265722C692E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(28843) := '756D6265722D32293B6966286E756C6C213D3D732930213D3D732626746869732E676574496E64656E7445646974734F664D6F76696E67426C6F636B28652C742C692C6F2C722C73293B656C73657B636F6E737420733D785328746869732E5F6175746F';
wwv_flow_imp.g_varchar2_table(28844) := '496E64656E742C6C2C652E6765744C616E677561676549644174506F736974696F6E28692E73746172744C696E654E756D6265722C31292C6E2C612C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B6966286E';
wwv_flow_imp.g_varchar2_table(28845) := '756C6C213D3D73297B636F6E7374206E3D666928652E6765744C696E65436F6E74656E7428692E73746172744C696E654E756D62657229292C613D643328732C6F292C6C3D6433286E2C6F293B69662861213D3D6C297B636F6E7374206E3D612D6C3B74';
wwv_flow_imp.g_varchar2_table(28846) := '6869732E676574496E64656E7445646974734F664D6F76696E67426C6F636B28652C742C692C6F2C722C6E297D7D7D7D7D746869732E5F73656C656374696F6E49643D742E747261636B53656C656374696F6E2869297D6275696C64496E64656E74436F';
wwv_flow_imp.g_varchar2_table(28847) := '6E76657274657228652C742C6E297B72657475726E7B7368696674496E64656E743A693D3E79532E7368696674496E64656E7428692C692E6C656E6774682B312C652C742C6E292C756E7368696674496E64656E743A693D3E79532E756E736869667449';
wwv_flow_imp.g_varchar2_table(28848) := '6E64656E7428692C692E6C656E6774682B312C652C742C6E297D7D7061727365456E746572526573756C7428652C742C6E2C692C6F297B6966286F297B6C657420733D6F2E696E64656E746174696F6E3B6F2E696E64656E74416374696F6E3D3D3D5075';
wwv_flow_imp.g_varchar2_table(28849) := '2E4E6F6E657C7C6F2E696E64656E74416374696F6E3D3D3D50752E496E64656E743F733D6F2E696E64656E746174696F6E2B6F2E617070656E64546578743A6F2E696E64656E74416374696F6E3D3D3D50752E496E64656E744F757464656E743F733D6F';
wwv_flow_imp.g_varchar2_table(28850) := '2E696E64656E746174696F6E3A6F2E696E64656E74416374696F6E3D3D3D50752E4F757464656E74262628733D742E756E7368696674496E64656E74286F2E696E64656E746174696F6E292B6F2E617070656E6454657874293B636F6E737420723D652E';
wwv_flow_imp.g_varchar2_table(28851) := '6765744C696E65436F6E74656E742869293B696628746869732E7472696D53746172742872292E696E6465784F6628746869732E7472696D5374617274287329293E3D30297B636F6E7374206F3D666928652E6765744C696E65436F6E74656E74286929';
wwv_flow_imp.g_varchar2_table(28852) := '293B6C657420723D66692873293B636F6E737420613D6B5328652C692C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B72657475726E206E756C6C213D3D612626322661262628723D742E756E736869667449';
wwv_flow_imp.g_varchar2_table(28853) := '6E64656E74287229292C643328722C6E292D6433286F2C6E297D7D72657475726E206E756C6C7D6D61746368456E74657252756C654D6F76696E67446F776E28652C742C6E2C692C6F2C73297B69662876692873293E3D30297B636F6E737420733D652E';
wwv_flow_imp.g_varchar2_table(28854) := '6765744C696E654D6178436F6C756D6E286F292C723D665328746869732E5F6175746F496E64656E742C652C6E6577207268286F2C732C6F2C73292C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B72657475';
wwv_flow_imp.g_varchar2_table(28855) := '726E20746869732E7061727365456E746572526573756C7428652C742C6E2C692C72297D7B6C6574206F3D692D313B666F72283B6F3E3D3126262128766928652E6765744C696E65436F6E74656E74286F29293E3D30293B296F2D2D3B6966286F3C317C';
wwv_flow_imp.g_varchar2_table(28856) := '7C693E652E6765744C696E65436F756E7428292972657475726E206E756C6C3B636F6E737420733D652E6765744C696E654D6178436F6C756D6E286F292C723D665328746869732E5F6175746F496E64656E742C652C6E6577207268286F2C732C6F2C73';
wwv_flow_imp.g_varchar2_table(28857) := '292C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B72657475726E20746869732E7061727365456E746572526573756C7428652C742C6E2C692C72297D7D6D61746368456E74657252756C6528652C742C6E2C';
wwv_flow_imp.g_varchar2_table(28858) := '692C6F2C73297B6C657420723D6F3B666F72283B723E3D313B297B6C657420743B696628743D723D3D3D6F2626766F69642030213D3D733F733A652E6765744C696E65436F6E74656E742872292C76692874293E3D3029627265616B3B722D2D7D696628';
wwv_flow_imp.g_varchar2_table(28859) := '723C317C7C693E652E6765744C696E65436F756E7428292972657475726E206E756C6C3B636F6E737420613D652E6765744C696E654D6178436F6C756D6E2872292C6C3D665328746869732E5F6175746F496E64656E742C652C6E657720726828722C61';
wwv_flow_imp.g_varchar2_table(28860) := '2C722C61292C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276696365293B72657475726E20746869732E7061727365456E746572526573756C7428652C742C6E2C692C6C297D7472696D53746172742865297B7265747572';
wwv_flow_imp.g_varchar2_table(28861) := '6E20652E7265706C616365282F5E5C732B2F2C2222297D73686F756C644175746F496E64656E7428652C74297B696628746869732E5F6175746F496E64656E743C342972657475726E21313B69662821652E746F6B656E697A6174696F6E2E6973436865';
wwv_flow_imp.g_varchar2_table(28862) := '6170546F546F6B656E697A6528742E73746172744C696E654E756D626572292972657475726E21313B636F6E7374206E3D652E6765744C616E677561676549644174506F736974696F6E28742E73746172744C696E654E756D6265722C31293B72657475';
wwv_flow_imp.g_varchar2_table(28863) := '726E206E3D3D3D652E6765744C616E677561676549644174506F736974696F6E28742E656E644C696E654E756D6265722C312926266E756C6C213D3D746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C61';
wwv_flow_imp.g_varchar2_table(28864) := '6E6775616765436F6E66696775726174696F6E286E292E696E64656E7452756C6573537570706F72747D676574496E64656E7445646974734F664D6F76696E67426C6F636B28652C742C6E2C692C6F2C73297B666F72286C657420723D6E2E7374617274';
wwv_flow_imp.g_varchar2_table(28865) := '4C696E654E756D6265723B723C3D6E2E656E644C696E654E756D6265723B722B2B297B636F6E737420613D666928652E6765744C696E65436F6E74656E74287229292C6C3D683328643328612C69292B732C692C6F293B6C213D3D61262628742E616464';
wwv_flow_imp.g_varchar2_table(28866) := '456469744F7065726174696F6E286E657720726828722C312C722C612E6C656E6774682B31292C6C292C723D3D3D6E2E656E644C696E654E756D62657226266E2E656E64436F6C756D6E3C3D612E6C656E6774682B31262622223D3D3D6C262628746869';
wwv_flow_imp.g_varchar2_table(28867) := '732E5F6D6F7665456E644C696E6553656C656374696F6E536872696E6B3D213029297D7D636F6D70757465437572736F72537461746528652C74297B6C6574206E3D742E676574547261636B656453656C656374696F6E28746869732E5F73656C656374';
wwv_flow_imp.g_varchar2_table(28868) := '696F6E4964293B72657475726E20746869732E5F6D6F7665456E64506F736974696F6E446F776E2626286E3D6E2E736574456E64506F736974696F6E286E2E656E644C696E654E756D6265722B312C3129292C746869732E5F6D6F7665456E644C696E65';
wwv_flow_imp.g_varchar2_table(28869) := '53656C656374696F6E536872696E6B26266E2E73746172744C696E654E756D6265723C6E2E656E644C696E654E756D6265722626286E3D6E2E736574456E64506F736974696F6E286E2E656E644C696E654E756D6265722C3229292C6E7D7D3B4C363D66';
wwv_flow_imp.g_varchar2_table(28870) := '756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B';
wwv_flow_imp.g_varchar2_table(28871) := '696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F';
wwv_flow_imp.g_varchar2_table(28872) := '722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E6465';
wwv_flow_imp.g_varchar2_table(28873) := '66696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28332C6567295D2C4C36293B636C6173732044367B73746174696320676574';
wwv_flow_imp.g_varchar2_table(28874) := '436F6C6C61746F7228297B72657475726E2044362E5F434F4C4C41544F527C7C2844362E5F434F4C4C41544F523D6E657720496E746C2E436F6C6C61746F72292C44362E5F434F4C4C41544F527D636F6E7374727563746F7228652C74297B746869732E';
wwv_flow_imp.g_varchar2_table(28875) := '73656C656374696F6E3D652C746869732E64657363656E64696E673D742C746869732E73656C656374696F6E49643D6E756C6C7D676574456469744F7065726174696F6E7328652C74297B636F6E7374206E3D66756E6374696F6E28652C742C6E297B63';
wwv_flow_imp.g_varchar2_table(28876) := '6F6E737420693D543628652C742C6E293B72657475726E20693F6A712E7265706C616365286E657720726828692E73746172744C696E654E756D6265722C312C692E656E644C696E654E756D6265722C652E6765744C696E654D6178436F6C756D6E2869';
wwv_flow_imp.g_varchar2_table(28877) := '2E656E644C696E654E756D62657229292C692E61667465722E6A6F696E28225C6E2229293A6E756C6C7D28652C746869732E73656C656374696F6E2C746869732E64657363656E64696E67293B6E2626742E616464456469744F7065726174696F6E286E';
wwv_flow_imp.g_varchar2_table(28878) := '2E72616E67652C6E2E74657874292C746869732E73656C656374696F6E49643D742E747261636B53656C656374696F6E28746869732E73656C656374696F6E297D636F6D70757465437572736F72537461746528652C74297B72657475726E20742E6765';
wwv_flow_imp.g_varchar2_table(28879) := '74547261636B656453656C656374696F6E28746869732E73656C656374696F6E4964297D7374617469632063616E52756E28652C742C6E297B6966286E756C6C3D3D3D652972657475726E21313B636F6E737420693D543628652C742C6E293B69662821';
wwv_flow_imp.g_varchar2_table(28880) := '692972657475726E21313B666F72286C657420653D302C743D692E6265666F72652E6C656E6774683B653C743B652B2B29696628692E6265666F72655B655D213D3D692E61667465725B655D2972657475726E21303B72657475726E21317D7D66756E63';
wwv_flow_imp.g_varchar2_table(28881) := '74696F6E20543628652C742C6E297B636F6E737420693D742E73746172744C696E654E756D6265723B6C6574206F3D742E656E644C696E654E756D6265723B696628313D3D3D742E656E64436F6C756D6E26266F2D2D2C693E3D6F2972657475726E206E';
wwv_flow_imp.g_varchar2_table(28882) := '756C6C3B636F6E737420733D5B5D3B666F72286C657420743D693B743C3D6F3B742B2B29732E7075736828652E6765744C696E65436F6E74656E74287429293B6C657420723D732E736C6963652830293B72657475726E20722E736F72742844362E6765';
wwv_flow_imp.g_varchar2_table(28883) := '74436F6C6C61746F7228292E636F6D70617265292C21303D3D3D6E262628723D722E726576657273652829292C7B73746172744C696E654E756D6265723A692C656E644C696E654E756D6265723A6F2C6265666F72653A732C61667465723A727D7D4436';
wwv_flow_imp.g_varchar2_table(28884) := '2E5F434F4C4C41544F523D6E756C6C3B636C61737320493620657874656E64732055647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E646F776E3D657D72756E28652C74297B69662821742E6861734D6F64656C282929';
wwv_flow_imp.g_varchar2_table(28885) := '72657475726E3B636F6E7374206E3D742E67657453656C656374696F6E7328292E6D6170282828652C74293D3E287B73656C656374696F6E3A652C696E6465783A742C69676E6F72653A21317D2929293B6E2E736F7274282828652C74293D3E72682E63';
wwv_flow_imp.g_varchar2_table(28886) := '6F6D7061726552616E6765735573696E6753746172747328652E73656C656374696F6E2C742E73656C656374696F6E2929293B6C657420693D6E5B305D3B666F72286C657420653D313B653C6E2E6C656E6774683B652B2B297B636F6E737420743D6E5B';
wwv_flow_imp.g_varchar2_table(28887) := '655D3B692E73656C656374696F6E2E656E644C696E654E756D6265723D3D3D742E73656C656374696F6E2E73746172744C696E654E756D626572262628692E696E6465783C742E696E6465783F742E69676E6F72653D21303A28692E69676E6F72653D21';
wwv_flow_imp.g_varchar2_table(28888) := '302C693D7429297D636F6E7374206F3D5B5D3B666F7228636F6E73742065206F66206E296F2E70757368286E657720453628652E73656C656374696F6E2C746869732E646F776E2C652E69676E6F726529293B742E70757368556E646F53746F7028292C';
wwv_flow_imp.g_varchar2_table(28889) := '742E65786563757465436F6D6D616E647328746869732E69642C6F292C742E70757368556E646F53746F7028297D7D636C617373204D3620657874656E64732055647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E646F';
wwv_flow_imp.g_varchar2_table(28890) := '776E3D657D72756E28652C74297B636F6E7374206E3D652E676574286567292C693D5B5D2C6F3D742E67657453656C656374696F6E7328297C7C5B5D2C733D742E6765744F7074696F6E283132293B666F7228636F6E73742065206F66206F29692E7075';
wwv_flow_imp.g_varchar2_table(28891) := '7368286E6577204C3628652C746869732E646F776E2C732C6E29293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C69292C742E70757368556E646F53746F7028297D7D636C617373204136';
wwv_flow_imp.g_varchar2_table(28892) := '20657874656E64732055647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E64657363656E64696E673D657D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E3D742E67';
wwv_flow_imp.g_varchar2_table(28893) := '65744D6F64656C28293B6C657420693D742E67657453656C656374696F6E7328293B313D3D3D692E6C656E6774682626695B305D2E6973456D7074792829262628693D5B6E657720616828312C312C6E2E6765744C696E65436F756E7428292C6E2E6765';
wwv_flow_imp.g_varchar2_table(28894) := '744C696E654D6178436F6C756D6E286E2E6765744C696E65436F756E74282929295D293B666F7228636F6E73742065206F662069296966282144362E63616E52756E28742E6765744D6F64656C28292C652C746869732E64657363656E64696E67292972';
wwv_flow_imp.g_varchar2_table(28895) := '657475726E3B636F6E7374206F3D5B5D3B666F72286C657420653D302C743D692E6C656E6774683B653C743B652B2B296F5B655D3D6E657720443628695B655D2C746869732E64657363656E64696E67293B742E70757368556E646F53746F7028292C74';
wwv_flow_imp.g_varchar2_table(28896) := '2E65786563757465436F6D6D616E647328746869732E69642C6F292C742E70757368556E646F53746F7028297D7D636C617373204E3620657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A4E362E49442C6C616265';
wwv_flow_imp.g_varchar2_table(28897) := '6C3A6228302C225472696D20547261696C696E67205768697465737061636522292C616C6961733A225472696D20547261696C696E672057686974657370616365222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B';
wwv_flow_imp.g_varchar2_table(28898) := '6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A536528323038392C32313032292C7765696768743A3130307D7D297D72756E28652C742C6E297B6C657420693D5B5D3B226175746F2D73617665223D3D3D6E2E7265';
wwv_flow_imp.g_varchar2_table(28899) := '61736F6E262628693D28742E67657453656C656374696F6E7328297C7C5B5D292E6D61702828653D3E6E6577206D6328652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E292929293B636F6E7374206F3D742E';
wwv_flow_imp.g_varchar2_table(28900) := '67657453656C656374696F6E28293B6966286E756C6C3D3D3D6F2972657475726E3B636F6E737420733D652E676574286670292C723D742E6765744D6F64656C28292C613D732E67657456616C7565282266696C65732E7472696D547261696C696E6757';
wwv_flow_imp.g_varchar2_table(28901) := '686974657370616365496E5265676578416E64537472696E6773222C7B6F766572726964654964656E7469666965723A6E756C6C3D3D723F766F696420303A722E6765744C616E6775616765496428292C7265736F757263653A6E756C6C3D3D723F766F';
wwv_flow_imp.g_varchar2_table(28902) := '696420303A722E7572697D292C6C3D6E6577206B36286F2C692C61293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C5B6C5D292C742E70757368556E646F53746F7028297D7D4E362E4944';
wwv_flow_imp.g_varchar2_table(28903) := '3D22656469746F722E616374696F6E2E7472696D547261696C696E6757686974657370616365223B636C61737320503620657874656E64732055647B72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(28904) := '3D742E67657453656C656374696F6E28292C693D746869732E5F67657452616E676573546F44656C6574652874292C6F3D5B5D3B666F72286C657420653D302C743D692E6C656E6774682D313B653C743B652B2B297B636F6E737420743D695B655D2C6E';
wwv_flow_imp.g_varchar2_table(28905) := '3D695B652B315D3B6E756C6C3D3D3D72682E696E7465727365637452616E67657328742C6E293F6F2E707573682874293A695B652B315D3D72682E706C757352616E676528742C6E297D6F2E7075736828695B692E6C656E6774682D315D293B636F6E73';
wwv_flow_imp.g_varchar2_table(28906) := '7420733D746869732E5F676574456E64437572736F725374617465286E2C6F292C723D6F2E6D61702828653D3E6A712E7265706C61636528652C22222929293B742E70757368556E646F53746F7028292C742E6578656375746545646974732874686973';
wwv_flow_imp.g_varchar2_table(28907) := '2E69642C722C73292C742E70757368556E646F53746F7028297D7D636C617373204F3620657874656E64732055647B72756E28652C74297B636F6E7374206E3D742E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D6E2972657475726E';
wwv_flow_imp.g_varchar2_table(28908) := '3B636F6E737420693D742E6765744D6F64656C28293B6966286E756C6C3D3D3D692972657475726E3B636F6E7374206F3D742E6765744F7074696F6E28313331292C733D5B5D3B666F7228636F6E73742065206F66206E29696628652E6973456D707479';
wwv_flow_imp.g_varchar2_table(28909) := '2829297B636F6E7374206E3D652E6765745374617274506F736974696F6E28292C723D742E676574436F6E66696775726564576F72644174506F736974696F6E286E293B696628217229636F6E74696E75653B636F6E737420613D6E6577207268286E2E';
wwv_flow_imp.g_varchar2_table(28910) := '6C696E654E756D6265722C722E7374617274436F6C756D6E2C6E2E6C696E654E756D6265722C722E656E64436F6C756D6E292C6C3D692E67657456616C7565496E52616E67652861293B732E70757368286A712E7265706C61636528612C746869732E5F';
wwv_flow_imp.g_varchar2_table(28911) := '6D6F6469667954657874286C2C6F2929297D656C73657B636F6E737420743D692E67657456616C7565496E52616E67652865293B732E70757368286A712E7265706C61636528652C746869732E5F6D6F646966795465787428742C6F2929297D742E7075';
wwv_flow_imp.g_varchar2_table(28912) := '7368556E646F53746F7028292C742E65786563757465456469747328746869732E69642C73292C742E70757368556E646F53746F7028297D7D636C6173732052367B636F6E7374727563746F7228652C74297B746869732E5F7061747465726E3D652C74';
wwv_flow_imp.g_varchar2_table(28913) := '6869732E5F666C6167733D742C746869732E5F61637475616C3D6E756C6C2C746869732E5F6576616C75617465643D21317D67657428297B69662821746869732E5F6576616C7561746564297B746869732E5F6576616C75617465643D21303B7472797B';
wwv_flow_imp.g_varchar2_table(28914) := '746869732E5F61637475616C3D6E65772052656745787028746869732E5F7061747465726E2C746869732E5F666C616773297D63617463682865297B7D7D72657475726E20746869732E5F61637475616C7D6973537570706F7274656428297B72657475';
wwv_flow_imp.g_varchar2_table(28915) := '726E206E756C6C213D3D746869732E67657428297D7D636C61737320463620657874656E6473204F367B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7472616E73666F726D546F5469746C65636173';
wwv_flow_imp.g_varchar2_table(28916) := '65222C6C6162656C3A6228302C225472616E73666F726D20746F205469746C65204361736522292C616C6961733A225472616E73666F726D20746F205469746C652043617365222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D5F';
wwv_flow_imp.g_varchar2_table(28917) := '6D6F646966795465787428652C74297B636F6E7374206E3D46362E7469746C65426F756E646172792E67657428293B72657475726E206E3F652E746F4C6F63616C654C6F7765724361736528292E7265706C616365286E2C28653D3E652E746F4C6F6361';
wwv_flow_imp.g_varchar2_table(28918) := '6C65557070657243617365282929293A657D7D46362E7469746C65426F756E646172793D6E65772052362822285E7C5B5E5C5C707B4C7D5C5C707B4E7D275D7C28285E7C5C5C507B4C7D292729295C5C707B4C7D222C22676D7522293B636C6173732042';
wwv_flow_imp.g_varchar2_table(28919) := '3620657874656E6473204F367B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7472616E73666F726D546F536E616B6563617365222C6C6162656C3A6228302C225472616E73666F726D20746F20536E';
wwv_flow_imp.g_varchar2_table(28920) := '616B65204361736522292C616C6961733A225472616E73666F726D20746F20536E616B652043617365222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D5F6D6F646966795465787428652C74297B636F6E7374206E3D42362E6361';
wwv_flow_imp.g_varchar2_table(28921) := '7365426F756E646172792E67657428292C693D42362E73696E676C654C6574746572732E67657428293B72657475726E206E2626693F652E7265706C616365286E2C2224315F243222292E7265706C61636528692C2224315F2432243322292E746F4C6F';
wwv_flow_imp.g_varchar2_table(28922) := '63616C654C6F7765724361736528293A657D7D42362E63617365426F756E646172793D6E65772052362822285C5C707B4C6C7D29285C5C707B4C757D29222C22676D7522292C42362E73696E676C654C6574746572733D6E65772052362822285C5C707B';
wwv_flow_imp.g_varchar2_table(28923) := '4C757D7C5C5C707B4E7D29285C5C707B4C757D29285C5C707B4C6C7D29222C22676D7522293B636C61737320563620657874656E6473204F367B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E747261';
wwv_flow_imp.g_varchar2_table(28924) := '6E73666F726D546F43616D656C63617365222C6C6162656C3A6228302C225472616E73666F726D20746F2043616D656C204361736522292C616C6961733A225472616E73666F726D20746F2043616D656C2043617365222C707265636F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(28925) := '3A6C682E7772697461626C657D297D5F6D6F646966795465787428652C74297B636F6E7374206E3D56362E776F7264426F756E646172792E67657428293B696628216E2972657475726E20653B636F6E737420693D652E73706C6974286E293B72657475';
wwv_flow_imp.g_varchar2_table(28926) := '726E20692E736869667428292B692E6D61702828653D3E652E737562737472696E6728302C31292E746F4C6F63616C6555707065724361736528292B652E737562737472696E6728312929292E6A6F696E282222297D7D56362E776F7264426F756E6461';
wwv_flow_imp.g_varchar2_table(28927) := '72793D6E657720523628225B5F5C5C732D5D222C22676D22293B636C617373207A3620657874656E6473204F367B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7472616E73666F726D546F50617363';
wwv_flow_imp.g_varchar2_table(28928) := '616C63617365222C6C6162656C3A6228302C225472616E73666F726D20746F2050617363616C204361736522292C616C6961733A225472616E73666F726D20746F2050617363616C2043617365222C707265636F6E646974696F6E3A6C682E7772697461';
wwv_flow_imp.g_varchar2_table(28929) := '626C657D297D5F6D6F646966795465787428652C74297B636F6E7374206E3D7A362E776F7264426F756E646172792E67657428292C693D7A362E776F7264426F756E64617279546F4D61696E7461696E2E67657428293B72657475726E206E2626693F65';
wwv_flow_imp.g_varchar2_table(28930) := '2E73706C69742869292E6D61702828653D3E652E73706C6974286E2929292E666C617428292E6D61702828653D3E652E737562737472696E6728302C31292E746F4C6F63616C6555707065724361736528292B652E737562737472696E6728312929292E';
wwv_flow_imp.g_varchar2_table(28931) := '6A6F696E282222293A657D7D7A362E776F7264426F756E646172793D6E657720523628225B5F5C5C732D5D222C22676D22292C7A362E776F7264426F756E64617279546F4D61696E7461696E3D6E65772052362822283F3C3D5C5C2E29222C22676D2229';
wwv_flow_imp.g_varchar2_table(28932) := '3B636C61737320483620657874656E6473204F367B737461746963206973537570706F7274656428297B72657475726E5B746869732E63617365426F756E646172792C746869732E73696E676C654C6574746572732C746869732E756E64657273636F72';
wwv_flow_imp.g_varchar2_table(28933) := '65426F756E646172795D2E65766572792828653D3E652E6973537570706F72746564282929297D636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7472616E73666F726D546F4B6562616263617365222C';
wwv_flow_imp.g_varchar2_table(28934) := '6C6162656C3A6228302C225472616E73666F726D20746F204B65626162204361736522292C616C6961733A225472616E73666F726D20746F204B656261622043617365222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D5F6D6F64';
wwv_flow_imp.g_varchar2_table(28935) := '6966795465787428652C74297B636F6E7374206E3D48362E63617365426F756E646172792E67657428292C693D48362E73696E676C654C6574746572732E67657428292C6F3D48362E756E64657273636F7265426F756E646172792E67657428293B7265';
wwv_flow_imp.g_varchar2_table(28936) := '7475726E206E26266926266F3F652E7265706C616365286F2C2224312D243322292E7265706C616365286E2C2224312D243222292E7265706C61636528692C2224312D243222292E746F4C6F63616C654C6F7765724361736528293A657D7D48362E6361';
wwv_flow_imp.g_varchar2_table(28937) := '7365426F756E646172793D6E65772052362822285C5C707B4C6C7D29285C5C707B4C757D29222C22676D7522292C48362E73696E676C654C6574746572733D6E65772052362822285C5C707B4C757D7C5C5C707B4E7D29285C5C707B4C757D5C5C707B4C';
wwv_flow_imp.g_varchar2_table(28938) := '6C7D29222C22676D7522292C48362E756E64657273636F7265426F756E646172793D6E65772052362822285C5C5329285F29285C5C5329222C22676D22292C5A6428636C61737320657874656E64732049367B636F6E7374727563746F7228297B737570';
wwv_flow_imp.g_varchar2_table(28939) := '65722821312C7B69643A22656469746F722E616374696F6E2E636F70794C696E65735570416374696F6E222C6C6162656C3A6228302C22436F7079204C696E6520557022292C616C6961733A22436F7079204C696E65205570222C707265636F6E646974';
wwv_flow_imp.g_varchar2_table(28940) := '696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A313535322C6C696E75783A7B7072696D6172793A333630307D2C7765696768743A3130307D2C6D656E75';
wwv_flow_imp.g_varchar2_table(28941) := '4F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22325F6C696E65222C7469746C653A6228302C222626436F7079204C696E6520557022292C6F726465723A317D7D297D7D292C5A6428636C61';
wwv_flow_imp.g_varchar2_table(28942) := '737320657874656E64732049367B636F6E7374727563746F7228297B73757065722821302C7B69643A22656469746F722E616374696F6E2E636F70794C696E6573446F776E416374696F6E222C6C6162656C3A6228302C22436F7079204C696E6520446F';
wwv_flow_imp.g_varchar2_table(28943) := '776E22292C616C6961733A22436F7079204C696E6520446F776E222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A313535342C';
wwv_flow_imp.g_varchar2_table(28944) := '6C696E75783A7B7072696D6172793A333630327D2C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22325F6C696E65222C7469746C653A6228302C22';
wwv_flow_imp.g_varchar2_table(28945) := '436F26267079204C696E6520446F776E22292C6F726465723A327D7D297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6475706C69636174';
wwv_flow_imp.g_varchar2_table(28946) := '6553656C656374696F6E222C6C6162656C3A6228302C224475706C69636174652053656C656374696F6E22292C616C6961733A224475706C69636174652053656C656374696F6E222C707265636F6E646974696F6E3A6C682E7772697461626C652C6D65';
wwv_flow_imp.g_varchar2_table(28947) := '6E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22325F6C696E65222C7469746C653A6228302C2226264475706C69636174652053656C656374696F6E22292C6F726465723A357D7D297D';
wwv_flow_imp.g_varchar2_table(28948) := '72756E28652C742C6E297B69662821742E6861734D6F64656C28292972657475726E3B636F6E737420693D5B5D2C6F3D742E67657453656C656374696F6E7328292C733D742E6765744D6F64656C28293B666F7228636F6E73742065206F66206F296966';
wwv_flow_imp.g_varchar2_table(28949) := '28652E6973456D707479282929692E70757368286E657720453628652C213029293B656C73657B636F6E737420743D6E657720616828652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E656E644C696E654E756D6265722C652E';
wwv_flow_imp.g_varchar2_table(28950) := '656E64436F6C756D6E293B692E70757368286E657720695328742C732E67657456616C7565496E52616E676528652929297D742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C69292C742E7075';
wwv_flow_imp.g_varchar2_table(28951) := '7368556E646F53746F7028297D7D292C5A6428636C61737320657874656E6473204D367B636F6E7374727563746F7228297B73757065722821312C7B69643A22656469746F722E616374696F6E2E6D6F76654C696E65735570416374696F6E222C6C6162';
wwv_flow_imp.g_varchar2_table(28952) := '656C3A6228302C224D6F7665204C696E6520557022292C616C6961733A224D6F7665204C696E65205570222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F63';
wwv_flow_imp.g_varchar2_table(28953) := '75732C7072696D6172793A3532382C6C696E75783A7B7072696D6172793A3532387D2C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22325F6C696E';
wwv_flow_imp.g_varchar2_table(28954) := '65222C7469746C653A6228302C224D6F26267665204C696E6520557022292C6F726465723A337D7D297D7D292C5A6428636C61737320657874656E6473204D367B636F6E7374727563746F7228297B73757065722821302C7B69643A22656469746F722E';
wwv_flow_imp.g_varchar2_table(28955) := '616374696F6E2E6D6F76654C696E6573446F776E416374696F6E222C6C6162656C3A6228302C224D6F7665204C696E6520446F776E22292C616C6961733A224D6F7665204C696E6520446F776E222C707265636F6E646974696F6E3A6C682E7772697461';
wwv_flow_imp.g_varchar2_table(28956) := '626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A3533302C6C696E75783A7B7072696D6172793A3533307D2C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C';
wwv_flow_imp.g_varchar2_table(28957) := '642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22325F6C696E65222C7469746C653A6228302C224D6F76652026264C696E6520446F776E22292C6F726465723A347D7D297D7D292C5A6428636C61737320657874656E64732041';
wwv_flow_imp.g_varchar2_table(28958) := '367B636F6E7374727563746F7228297B73757065722821312C7B69643A22656469746F722E616374696F6E2E736F72744C696E6573417363656E64696E67222C6C6162656C3A6228302C22536F7274204C696E657320417363656E64696E6722292C616C';
wwv_flow_imp.g_varchar2_table(28959) := '6961733A22536F7274204C696E657320417363656E64696E67222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D7D292C5A6428636C61737320657874656E64732041367B636F6E7374727563746F7228297B73757065722821302C';
wwv_flow_imp.g_varchar2_table(28960) := '7B69643A22656469746F722E616374696F6E2E736F72744C696E657344657363656E64696E67222C6C6162656C3A6228302C22536F7274204C696E65732044657363656E64696E6722292C616C6961733A22536F7274204C696E65732044657363656E64';
wwv_flow_imp.g_varchar2_table(28961) := '696E67222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E72656D6F7665';
wwv_flow_imp.g_varchar2_table(28962) := '4475706C69636174654C696E6573222C6C6162656C3A6228302C2244656C657465204475706C6963617465204C696E657322292C616C6961733A2244656C657465204475706C6963617465204C696E6573222C707265636F6E646974696F6E3A6C682E77';
wwv_flow_imp.g_varchar2_table(28963) := '72697461626C657D297D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E3D742E6765744D6F64656C28293B696628313D3D3D6E2E6765744C696E65436F756E7428292626313D3D3D6E2E6765744C69';
wwv_flow_imp.g_varchar2_table(28964) := '6E654D6178436F6C756D6E2831292972657475726E3B636F6E737420693D5B5D2C6F3D5B5D3B6C657420733D302C723D21302C613D742E67657453656C656374696F6E7328293B313D3D3D612E6C656E6774682626615B305D2E6973456D707479282926';
wwv_flow_imp.g_varchar2_table(28965) := '2628613D5B6E657720616828312C312C6E2E6765744C696E65436F756E7428292C6E2E6765744C696E654D6178436F6C756D6E286E2E6765744C696E65436F756E74282929295D2C723D2131293B666F7228636F6E73742065206F662061297B636F6E73';
wwv_flow_imp.g_varchar2_table(28966) := '7420743D6E6577205365742C723D5B5D3B666F72286C657420693D652E73746172744C696E654E756D6265723B693C3D652E656E644C696E654E756D6265723B692B2B297B636F6E737420653D6E2E6765744C696E65436F6E74656E742869293B742E68';
wwv_flow_imp.g_varchar2_table(28967) := '61732865297C7C28722E707573682865292C742E616464286529297D636F6E737420613D6E657720616828652E73746172744C696E654E756D6265722C312C652E656E644C696E654E756D6265722C6E2E6765744C696E654D6178436F6C756D6E28652E';
wwv_flow_imp.g_varchar2_table(28968) := '656E644C696E654E756D62657229292C6C3D652E73746172744C696E654E756D6265722D732C633D6E6577206168286C2C312C6C2B722E6C656E6774682D312C725B722E6C656E6774682D315D2E6C656E677468293B692E70757368286A712E7265706C';
wwv_flow_imp.g_varchar2_table(28969) := '61636528612C722E6A6F696E28225C6E222929292C6F2E707573682863292C732B3D652E656E644C696E654E756D6265722D652E73746172744C696E654E756D6265722B312D722E6C656E6774687D742E70757368556E646F53746F7028292C742E6578';
wwv_flow_imp.g_varchar2_table(28970) := '6563757465456469747328746869732E69642C692C723F6F3A766F69642030292C742E70757368556E646F53746F7028297D7D292C5A64284E36292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B737570657228';
wwv_flow_imp.g_varchar2_table(28971) := '7B69643A22656469746F722E616374696F6E2E64656C6574654C696E6573222C6C6162656C3A6228302C2244656C657465204C696E6522292C616C6961733A2244656C657465204C696E65222C707265636F6E646974696F6E3A6C682E7772697461626C';
wwv_flow_imp.g_varchar2_table(28972) := '652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A333131332C7765696768743A3130307D7D297D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(28973) := '206E3D746869732E5F6765744C696E6573546F52656D6F76652874292C693D742E6765744D6F64656C28293B696628313D3D3D692E6765744C696E65436F756E7428292626313D3D3D692E6765744C696E654D6178436F6C756D6E283129297265747572';
wwv_flow_imp.g_varchar2_table(28974) := '6E3B6C6574206F3D303B636F6E737420733D5B5D2C723D5B5D3B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D3B6C657420613D742E73746172744C696E654E756D6265722C6C3D742E65';
wwv_flow_imp.g_varchar2_table(28975) := '6E644C696E654E756D6265722C633D312C643D692E6765744C696E654D6178436F6C756D6E286C293B6C3C692E6765744C696E65436F756E7428293F286C2B3D312C643D31293A613E31262628612D3D312C633D692E6765744C696E654D6178436F6C75';
wwv_flow_imp.g_varchar2_table(28976) := '6D6E286129292C732E70757368286A712E7265706C616365286E657720616828612C632C6C2C64292C222229292C722E70757368286E657720616828612D6F2C742E706F736974696F6E436F6C756D6E2C612D6F2C742E706F736974696F6E436F6C756D';
wwv_flow_imp.g_varchar2_table(28977) := '6E29292C6F2B3D742E656E644C696E654E756D6265722D742E73746172744C696E654E756D6265722B317D742E70757368556E646F53746F7028292C742E65786563757465456469747328746869732E69642C732C72292C742E70757368556E646F5374';
wwv_flow_imp.g_varchar2_table(28978) := '6F7028297D5F6765744C696E6573546F52656D6F76652865297B636F6E737420743D652E67657453656C656374696F6E7328292E6D61702828653D3E7B6C657420743D652E656E644C696E654E756D6265723B72657475726E20652E73746172744C696E';
wwv_flow_imp.g_varchar2_table(28979) := '654E756D6265723C652E656E644C696E654E756D6265722626313D3D3D652E656E64436F6C756D6E262628742D3D31292C7B73746172744C696E654E756D6265723A652E73746172744C696E654E756D6265722C73656C656374696F6E5374617274436F';
wwv_flow_imp.g_varchar2_table(28980) := '6C756D6E3A652E73656C656374696F6E5374617274436F6C756D6E2C656E644C696E654E756D6265723A742C706F736974696F6E436F6C756D6E3A652E706F736974696F6E436F6C756D6E7D7D29293B742E736F7274282828652C74293D3E652E737461';
wwv_flow_imp.g_varchar2_table(28981) := '72744C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F652E656E644C696E654E756D6265722D742E656E644C696E654E756D6265723A652E73746172744C696E654E756D6265722D742E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(28982) := '29293B636F6E7374206E3D5B5D3B6C657420693D745B305D3B666F72286C657420653D313B653C742E6C656E6774683B652B2B29692E656E644C696E654E756D6265722B313E3D745B655D2E73746172744C696E654E756D6265723F692E656E644C696E';
wwv_flow_imp.g_varchar2_table(28983) := '654E756D6265723D745B655D2E656E644C696E654E756D6265723A286E2E707573682869292C693D745B655D293B72657475726E206E2E707573682869292C6E7D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(28984) := '297B7375706572287B69643A22656469746F722E616374696F6E2E696E64656E744C696E6573222C6C6162656C3A6228302C22496E64656E74204C696E6522292C616C6961733A22496E64656E74204C696E65222C707265636F6E646974696F6E3A6C68';
wwv_flow_imp.g_varchar2_table(28985) := '2E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A323134322C7765696768743A3130307D7D297D72756E28652C74297B636F6E7374206E3D742E5F676574566965774D6F';
wwv_flow_imp.g_varchar2_table(28986) := '64656C28293B6E262628742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C45532E696E64656E74286E2E637572736F72436F6E6669672C742E6765744D6F64656C28292C742E67657453656C65';
wwv_flow_imp.g_varchar2_table(28987) := '6374696F6E73282929292C742E70757368556E646F53746F702829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6F757464656E744C69';
wwv_flow_imp.g_varchar2_table(28988) := '6E6573222C6C6162656C3A6228302C224F757464656E74204C696E6522292C616C6961733A224F757464656E74204C696E65222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F';
wwv_flow_imp.g_varchar2_table(28989) := '7254657874466F6375732C7072696D6172793A323134302C7765696768743A3130307D7D297D72756E28652C74297B48532E4F757464656E742E72756E456469746F72436F6D6D616E6428652C742C6E756C6C297D7D292C5A6428636C61737320657874';
wwv_flow_imp.g_varchar2_table(28990) := '656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E736572744C696E654265666F7265222C6C6162656C3A6228302C22496E73657274204C696E652041626F766522292C616C6961';
wwv_flow_imp.g_varchar2_table(28991) := '733A22496E73657274204C696E652041626F7665222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A333037352C776569676874';
wwv_flow_imp.g_varchar2_table(28992) := '3A3130307D7D297D72756E28652C74297B636F6E7374206E3D742E5F676574566965774D6F64656C28293B6E262628742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C45532E6C696E65496E73';
wwv_flow_imp.g_varchar2_table(28993) := '6572744265666F7265286E2E637572736F72436F6E6669672C742E6765744D6F64656C28292C742E67657453656C656374696F6E7328292929297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B73757065';
wwv_flow_imp.g_varchar2_table(28994) := '72287B69643A22656469746F722E616374696F6E2E696E736572744C696E654166746572222C6C6162656C3A6228302C22496E73657274204C696E652042656C6F7722292C616C6961733A22496E73657274204C696E652042656C6F77222C707265636F';
wwv_flow_imp.g_varchar2_table(28995) := '6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A323035312C7765696768743A3130307D7D297D72756E28652C74297B636F6E7374206E3D742E';
wwv_flow_imp.g_varchar2_table(28996) := '5F676574566965774D6F64656C28293B6E262628742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C45532E6C696E65496E736572744166746572286E2E637572736F72436F6E6669672C742E67';
wwv_flow_imp.g_varchar2_table(28997) := '65744D6F64656C28292C742E67657453656C656374696F6E7328292929297D7D292C5A6428636C61737320657874656E64732050367B636F6E7374727563746F7228297B7375706572287B69643A2264656C657465416C6C4C656674222C6C6162656C3A';
wwv_flow_imp.g_varchar2_table(28998) := '6228302C2244656C65746520416C6C204C65667422292C616C6961733A2244656C65746520416C6C204C656674222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E70757446';
wwv_flow_imp.g_varchar2_table(28999) := '6F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A323034397D2C7765696768743A3130307D7D297D5F676574456E64437572736F72537461746528652C74297B6C6574206E3D6E756C6C3B636F6E737420693D5B5D3B6C6574206F3D';
wwv_flow_imp.g_varchar2_table(29000) := '303B72657475726E20742E666F72456163682828743D3E7B6C657420733B696628313D3D3D742E656E64436F6C756D6E26266F3E30297B636F6E737420653D742E73746172744C696E654E756D6265722D6F3B733D6E657720616828652C742E73746172';
wwv_flow_imp.g_varchar2_table(29001) := '74436F6C756D6E2C652C742E7374617274436F6C756D6E297D656C736520733D6E657720616828742E73746172744C696E654E756D6265722C742E7374617274436F6C756D6E2C742E73746172744C696E654E756D6265722C742E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(29002) := '6D6E293B6F2B3D742E656E644C696E654E756D6265722D742E73746172744C696E654E756D6265722C742E696E7465727365637452616E6765732865293F6E3D733A692E707573682873297D29292C6E2626692E756E7368696674286E292C697D5F6765';
wwv_flow_imp.g_varchar2_table(29003) := '7452616E676573546F44656C6574652865297B636F6E737420743D652E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D742972657475726E5B5D3B6C6574206E3D743B636F6E737420693D652E6765744D6F64656C28293B7265747572';
wwv_flow_imp.g_varchar2_table(29004) := '6E206E756C6C3D3D3D693F5B5D3A286E2E736F72742872682E636F6D7061726552616E6765735573696E67537461727473292C6E3D6E2E6D61702828653D3E7B696628652E6973456D7074792829297B696628313D3D3D652E7374617274436F6C756D6E';
wwv_flow_imp.g_varchar2_table(29005) := '297B636F6E737420743D4D6174682E6D617828312C652E73746172744C696E654E756D6265722D31292C6E3D313D3D3D652E73746172744C696E654E756D6265723F313A692E6765744C696E654C656E6774682874292B313B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(29006) := '726828742C6E2C652E73746172744C696E654E756D6265722C31297D72657475726E206E657720726828652E73746172744C696E654E756D6265722C312C652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E297D7265747572';
wwv_flow_imp.g_varchar2_table(29007) := '6E206E657720726828652E73746172744C696E654E756D6265722C312C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E297D29292C6E297D7D292C5A6428636C61737320657874656E64732050367B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(29008) := '7B7375706572287B69643A2264656C657465416C6C5269676874222C6C6162656C3A6228302C2244656C65746520416C6C20526967687422292C616C6961733A2244656C65746520416C6C205269676874222C707265636F6E646974696F6E3A6C682E77';
wwv_flow_imp.g_varchar2_table(29009) := '72697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3239372C7365636F6E646172793A5B323036385D7D2C7765696768743A3130307D7D297D';
wwv_flow_imp.g_varchar2_table(29010) := '5F676574456E64437572736F72537461746528652C74297B6C6574206E3D6E756C6C3B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D742E6C656E6774682C723D303B6F3C733B6F2B2B297B636F6E737420733D745B6F5D2C613D6E6577';
wwv_flow_imp.g_varchar2_table(29011) := '20616828732E73746172744C696E654E756D6265722D722C732E7374617274436F6C756D6E2C732E73746172744C696E654E756D6265722D722C732E7374617274436F6C756D6E293B732E696E7465727365637452616E6765732865293F6E3D613A692E';
wwv_flow_imp.g_varchar2_table(29012) := '707573682861297D72657475726E206E2626692E756E7368696674286E292C697D5F67657452616E676573546F44656C6574652865297B636F6E737420743D652E6765744D6F64656C28293B6966286E756C6C3D3D3D742972657475726E5B5D3B636F6E';
wwv_flow_imp.g_varchar2_table(29013) := '7374206E3D652E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D6E2972657475726E5B5D3B636F6E737420693D6E2E6D61702828653D3E7B696628652E6973456D7074792829297B636F6E7374206E3D742E6765744C696E654D617843';
wwv_flow_imp.g_varchar2_table(29014) := '6F6C756D6E28652E73746172744C696E654E756D626572293B72657475726E20652E7374617274436F6C756D6E3D3D3D6E3F6E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E73746172744C696E65';
wwv_flow_imp.g_varchar2_table(29015) := '4E756D6265722B312C31293A6E657720726828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C652E73746172744C696E654E756D6265722C6E297D72657475726E20657D29293B72657475726E20692E736F7274287268';
wwv_flow_imp.g_varchar2_table(29016) := '2E636F6D7061726552616E6765735573696E67537461727473292C697D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6A6F696E4C696E6573';
wwv_flow_imp.g_varchar2_table(29017) := '222C6C6162656C3A6228302C224A6F696E204C696E657322292C616C6961733A224A6F696E204C696E6573222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F';
wwv_flow_imp.g_varchar2_table(29018) := '6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3239367D2C7765696768743A3130307D7D297D72756E28652C74297B636F6E7374206E3D742E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D6E2972657475726E3B';
wwv_flow_imp.g_varchar2_table(29019) := '6C657420693D742E67657453656C656374696F6E28293B6966286E756C6C3D3D3D692972657475726E3B6E2E736F72742872682E636F6D7061726552616E6765735573696E67537461727473293B636F6E7374206F3D5B5D2C733D6E2E72656475636528';
wwv_flow_imp.g_varchar2_table(29020) := '2828652C74293D3E652E6973456D70747928293F652E656E644C696E654E756D6265723D3D3D742E73746172744C696E654E756D6265723F28692E657175616C7353656C656374696F6E286529262628693D74292C74293A742E73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(29021) := '756D6265723E652E656E644C696E654E756D6265722B313F286F2E707573682865292C74293A6E657720616828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C742E656E644C696E654E756D6265722C742E656E64436F';
wwv_flow_imp.g_varchar2_table(29022) := '6C756D6E293A742E73746172744C696E654E756D6265723E652E656E644C696E654E756D6265723F286F2E707573682865292C74293A6E657720616828652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C742E656E644C69';
wwv_flow_imp.g_varchar2_table(29023) := '6E654E756D6265722C742E656E64436F6C756D6E2929293B6F2E707573682873293B636F6E737420723D742E6765744D6F64656C28293B6966286E756C6C3D3D3D722972657475726E3B636F6E737420613D5B5D2C6C3D5B5D3B6C657420633D692C643D';
wwv_flow_imp.g_varchar2_table(29024) := '303B666F72286C657420653D302C743D6F2E6C656E6774683B653C743B652B2B297B636F6E737420743D6F5B655D2C6E3D742E73746172744C696E654E756D6265722C733D313B6C657420682C752C703D303B636F6E737420673D722E6765744C696E65';
wwv_flow_imp.g_varchar2_table(29025) := '4C656E67746828742E656E644C696E654E756D626572292D742E656E64436F6C756D6E3B696628742E6973456D70747928297C7C742E73746172744C696E654E756D6265723D3D3D742E656E644C696E654E756D626572297B636F6E737420653D742E67';
wwv_flow_imp.g_varchar2_table(29026) := '65745374617274506F736974696F6E28293B652E6C696E654E756D6265723C722E6765744C696E65436F756E7428293F28683D6E2B312C753D722E6765744C696E654D6178436F6C756D6E286829293A28683D652E6C696E654E756D6265722C753D722E';
wwv_flow_imp.g_varchar2_table(29027) := '6765744C696E654D6178436F6C756D6E28652E6C696E654E756D62657229297D656C736520683D742E656E644C696E654E756D6265722C753D722E6765744C696E654D6178436F6C756D6E2868293B6C6574206D3D722E6765744C696E65436F6E74656E';
wwv_flow_imp.g_varchar2_table(29028) := '74286E293B666F72286C657420653D6E2B313B653C3D683B652B2B297B636F6E737420743D722E6765744C696E65436F6E74656E742865292C6E3D722E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E2865293B6966286E';
wwv_flow_imp.g_varchar2_table(29029) := '3E3D31297B6C657420653D21303B22223D3D3D6D262628653D2131292C21657C7C222022213D3D6D2E636861724174286D2E6C656E6774682D31292626225C7422213D3D6D2E636861724174286D2E6C656E6774682D31297C7C28653D21312C6D3D6D2E';
wwv_flow_imp.g_varchar2_table(29030) := '7265706C616365282F5B5C735C75464546465C7841305D2B242F672C22202229293B636F6E737420693D742E737562737472286E2D31293B6D2B3D28653F2220223A2222292B692C703D653F692E6C656E6774682B313A692E6C656E6774687D656C7365';
wwv_flow_imp.g_varchar2_table(29031) := '20703D307D636F6E737420663D6E6577207268286E2C732C682C75293B69662821662E6973456D7074792829297B6C657420653B742E6973456D70747928293F28612E70757368286A712E7265706C61636528662C6D29292C653D6E657720616828662E';
wwv_flow_imp.g_varchar2_table(29032) := '73746172744C696E654E756D6265722D642C6D2E6C656E6774682D702B312C6E2D642C6D2E6C656E6774682D702B3129293A742E73746172744C696E654E756D6265723D3D3D742E656E644C696E654E756D6265723F28612E70757368286A712E726570';
wwv_flow_imp.g_varchar2_table(29033) := '6C61636528662C6D29292C653D6E657720616828742E73746172744C696E654E756D6265722D642C742E7374617274436F6C756D6E2C742E656E644C696E654E756D6265722D642C742E656E64436F6C756D6E29293A28612E70757368286A712E726570';
wwv_flow_imp.g_varchar2_table(29034) := '6C61636528662C6D29292C653D6E657720616828742E73746172744C696E654E756D6265722D642C742E7374617274436F6C756D6E2C742E73746172744C696E654E756D6265722D642C6D2E6C656E6774682D6729292C6E756C6C213D3D72682E696E74';
wwv_flow_imp.g_varchar2_table(29035) := '65727365637452616E67657328662C69293F633D653A6C2E707573682865297D642B3D662E656E644C696E654E756D6265722D662E73746172744C696E654E756D6265727D6C2E756E73686966742863292C742E70757368556E646F53746F7028292C74';
wwv_flow_imp.g_varchar2_table(29036) := '2E65786563757465456469747328746869732E69642C612C6C292C742E70757368556E646F53746F7028297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E61';
wwv_flow_imp.g_varchar2_table(29037) := '6374696F6E2E7472616E73706F7365222C6C6162656C3A6228302C225472616E73706F736520436861726163746572732061726F756E642074686520437572736F7222292C616C6961733A225472616E73706F736520436861726163746572732061726F';
wwv_flow_imp.g_varchar2_table(29038) := '756E642074686520437572736F72222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D72756E28652C74297B636F6E7374206E3D742E67657453656C656374696F6E7328293B6966286E756C6C3D3D3D6E2972657475726E3B636F6E';
wwv_flow_imp.g_varchar2_table(29039) := '737420693D742E6765744D6F64656C28293B6966286E756C6C3D3D3D692972657475726E3B636F6E7374206F3D5B5D3B666F72286C657420653D302C743D6E2E6C656E6774683B653C743B652B2B297B636F6E737420743D6E5B655D3B69662821742E69';
wwv_flow_imp.g_varchar2_table(29040) := '73456D707479282929636F6E74696E75653B636F6E737420733D742E6765745374617274506F736974696F6E28292C723D692E6765744C696E654D6178436F6C756D6E28732E6C696E654E756D626572293B696628732E636F6C756D6E3E3D72297B6966';
wwv_flow_imp.g_varchar2_table(29041) := '28732E6C696E654E756D6265723D3D3D692E6765744C696E65436F756E74282929636F6E74696E75653B636F6E737420653D6E657720726828732E6C696E654E756D6265722C4D6174682E6D617828312C732E636F6C756D6E2D31292C732E6C696E654E';
wwv_flow_imp.g_varchar2_table(29042) := '756D6265722B312C31292C743D692E67657456616C7565496E52616E67652865292E73706C6974282222292E7265766572736528292E6A6F696E282222293B6F2E70757368286E6577206E53286E657720616828732E6C696E654E756D6265722C4D6174';
wwv_flow_imp.g_varchar2_table(29043) := '682E6D617828312C732E636F6C756D6E2D31292C732E6C696E654E756D6265722B312C31292C7429297D656C73657B636F6E737420653D6E657720726828732E6C696E654E756D6265722C4D6174682E6D617828312C732E636F6C756D6E2D31292C732E';
wwv_flow_imp.g_varchar2_table(29044) := '6C696E654E756D6265722C732E636F6C756D6E2B31292C743D692E67657456616C7565496E52616E67652865292E73706C6974282222292E7265766572736528292E6A6F696E282222293B6F2E70757368286E657720725328652C742C6E657720616828';
wwv_flow_imp.g_varchar2_table(29045) := '732E6C696E654E756D6265722C732E636F6C756D6E2B312C732E6C696E654E756D6265722C732E636F6C756D6E2B312929297D7D742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C6F292C742E';
wwv_flow_imp.g_varchar2_table(29046) := '70757368556E646F53746F7028297D7D292C5A6428636C61737320657874656E6473204F367B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E7472616E73666F726D546F557070657263617365222C6C';
wwv_flow_imp.g_varchar2_table(29047) := '6162656C3A6228302C225472616E73666F726D20746F2055707065726361736522292C616C6961733A225472616E73666F726D20746F20557070657263617365222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D5F6D6F64696679';
wwv_flow_imp.g_varchar2_table(29048) := '5465787428652C74297B72657475726E20652E746F4C6F63616C6555707065724361736528297D7D292C5A6428636C61737320657874656E6473204F367B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E';
wwv_flow_imp.g_varchar2_table(29049) := '2E7472616E73666F726D546F4C6F77657263617365222C6C6162656C3A6228302C225472616E73666F726D20746F204C6F7765726361736522292C616C6961733A225472616E73666F726D20746F204C6F77657263617365222C707265636F6E64697469';
wwv_flow_imp.g_varchar2_table(29050) := '6F6E3A6C682E7772697461626C657D297D5F6D6F646966795465787428652C74297B72657475726E20652E746F4C6F63616C654C6F7765724361736528297D7D292C42362E63617365426F756E646172792E6973537570706F727465642829262642362E';
wwv_flow_imp.g_varchar2_table(29051) := '73696E676C654C6574746572732E6973537570706F72746564282926265A64284236292C56362E776F7264426F756E646172792E6973537570706F72746564282926265A64285636292C7A362E776F7264426F756E646172792E6973537570706F727465';
wwv_flow_imp.g_varchar2_table(29052) := '64282926265A64287A36292C46362E7469746C65426F756E646172792E6973537570706F72746564282926265A64284636292C48362E6973537570706F72746564282926265A64284836293B7661722057363D6E2833323933292C6A363D7B7D3B6A362E';
wwv_flow_imp.g_varchar2_table(29053) := '7374796C655461675472616E73666F726D3D6A7228292C6A362E736574417474726962757465733D567228292C6A362E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6A362E646F6D4150493D4F7228292C6A362E696E7365';
wwv_flow_imp.g_varchar2_table(29054) := '72745374796C65456C656D656E743D487228292C4E7228292857362E412C6A36292C57362E41262657362E412E6C6F63616C73262657362E412E6C6F63616C733B7661722071362C24363D66756E6374696F6E28652C74297B72657475726E2066756E63';
wwv_flow_imp.g_varchar2_table(29055) := '74696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742055363D6E6577206C6428224C696E6B656445646974696E67496E70757456697369626C65222C2131293B6C6574204B363D71363D636C61737320657874656E6473206C747B73746174';
wwv_flow_imp.g_varchar2_table(29056) := '6963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2871362E4944297D636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E6C616E6775616765436F6E66696775726174696F6E53';
wwv_flow_imp.g_varchar2_table(29057) := '6572766963653D692C746869732E5F73796E6352616E676573546F6B656E3D302C746869732E5F6C6F63616C546F446973706F73653D746869732E5F7265676973746572286E6577206174292C746869732E5F656469746F723D652C746869732E5F7072';
wwv_flow_imp.g_varchar2_table(29058) := '6F7669646572733D6E2E6C696E6B656445646974696E6752616E676550726F76696465722C746869732E5F656E61626C65643D21312C746869732E5F76697369626C65436F6E746578744B65793D55362E62696E64546F2874292C746869732E5F646562';
wwv_flow_imp.g_varchar2_table(29059) := '6F756E6365496E666F726D6174696F6E3D6F2E666F7228746869732E5F70726F7669646572732C224C696E6B65642045646974696E67222C7B6D61783A3230307D292C746869732E5F63757272656E744465636F726174696F6E733D746869732E5F6564';
wwv_flow_imp.g_varchar2_table(29060) := '69746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E5F6C616E6775616765576F72645061747465726E3D6E756C6C2C746869732E5F63757272656E74576F72645061747465726E3D6E756C6C2C74686973';
wwv_flow_imp.g_varchar2_table(29061) := '2E5F69676E6F72654368616E67654576656E743D21312C746869732E5F6C6F63616C546F446973706F73653D746869732E5F7265676973746572286E6577206174292C746869732E5F72616E67655570646174655472696767657250726F6D6973653D6E';
wwv_flow_imp.g_varchar2_table(29062) := '756C6C2C746869732E5F72616E676553796E635472696767657250726F6D6973653D6E756C6C2C746869732E5F63757272656E74526571756573744374733D6E756C6C2C746869732E5F63757272656E7452657175657374506F736974696F6E3D6E756C';
wwv_flow_imp.g_varchar2_table(29063) := '6C2C746869732E5F63757272656E74526571756573744D6F64656C56657273696F6E3D6E756C6C2C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E746869732E7265696E69';
wwv_flow_imp.g_varchar2_table(29064) := '7469616C697A65282130292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B28652E6861734368616E676564283730297C7C652E686173436861';
wwv_flow_imp.g_varchar2_table(29065) := '6E67656428393329292626746869732E7265696E697469616C697A65282131297D2929292C746869732E5F726567697374657228746869732E5F70726F7669646572732E6F6E4469644368616E6765282828293D3E746869732E7265696E697469616C69';
wwv_flow_imp.g_varchar2_table(29066) := '7A65282131292929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C4C616E6775616765282828293D3E746869732E7265696E697469616C697A65282130292929292C746869732E7265';
wwv_flow_imp.g_varchar2_table(29067) := '696E697469616C697A65282130297D7265696E697469616C697A652865297B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292C6E3D6E756C6C213D3D74262628746869732E5F656469746F722E6765744F7074696F6E2837';
wwv_flow_imp.g_varchar2_table(29068) := '30297C7C746869732E5F656469746F722E6765744F7074696F6E28393329292626746869732E5F70726F7669646572732E6861732874293B6966286E3D3D3D746869732E5F656E61626C6564262621652972657475726E3B696628746869732E5F656E61';
wwv_flow_imp.g_varchar2_table(29069) := '626C65643D6E2C746869732E636C65617252616E67657328292C746869732E5F6C6F63616C546F446973706F73652E636C65617228292C216E7C7C6E756C6C3D3D3D742972657475726E3B746869732E5F6C6F63616C546F446973706F73652E61646428';
wwv_flow_imp.g_varchar2_table(29070) := '76742E72756E416E6453756273637269626528742E6F6E4469644368616E67654C616E6775616765436F6E66696775726174696F6E2C2828293D3E7B746869732E5F6C616E6775616765576F72645061747465726E3D746869732E6C616E677561676543';
wwv_flow_imp.g_varchar2_table(29071) := '6F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E28742E6765744C616E677561676549642829292E676574576F7264446566696E6974696F6E28297D2929293B636F6E737420693D6E657720';
wwv_flow_imp.g_varchar2_table(29072) := '7A7428746869732E5F6465626F756E6365496E666F726D6174696F6E2E676574287429292C6F3D28293D3E7B76617220653B746869732E5F72616E67655570646174655472696767657250726F6D6973653D692E74726967676572282828293D3E746869';
wwv_flow_imp.g_varchar2_table(29073) := '732E75706461746552616E6765732829292C6E756C6C213D3D28653D746869732E5F6465626F756E63654475726174696F6E292626766F69642030213D3D653F653A746869732E5F6465626F756E6365496E666F726D6174696F6E2E676574287429297D';
wwv_flow_imp.g_varchar2_table(29074) := '2C733D6E6577207A742830292C723D653D3E7B746869732E5F72616E676553796E635472696767657250726F6D6973653D732E74726967676572282828293D3E746869732E5F73796E6352616E67657328652929297D3B746869732E5F6C6F63616C546F';
wwv_flow_imp.g_varchar2_table(29075) := '446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E7B6F28297D2929292C746869732E5F6C6F63616C546F446973706F73652E61646428746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(29076) := '6F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B69662821746869732E5F69676E6F72654368616E67654576656E742626746869732E5F63757272656E744465636F726174696F6E732E6C656E6774683E30297B636F6E73';
wwv_flow_imp.g_varchar2_table(29077) := '7420743D746869732E5F63757272656E744465636F726174696F6E732E67657452616E67652830293B696628742626652E6368616E6765732E65766572792828653D3E742E696E7465727365637452616E67657328652E72616E67652929292972657475';
wwv_flow_imp.g_varchar2_table(29078) := '726E20766F6964207228746869732E5F73796E6352616E676573546F6B656E297D6F28297D2929292C746869732E5F6C6F63616C546F446973706F73652E616464287B646973706F73653A28293D3E7B692E646973706F736528292C732E646973706F73';
wwv_flow_imp.g_varchar2_table(29079) := '6528297D7D292C746869732E75706461746552616E67657328297D5F73796E6352616E6765732865297B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C65213D3D746869732E5F73796E6352616E676573546F6B656E7C7C303D';
wwv_flow_imp.g_varchar2_table(29080) := '3D3D746869732E5F63757272656E744465636F726174696F6E732E6C656E6774682972657475726E3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292C6E3D746869732E5F63757272656E744465636F726174696F6E732E';
wwv_flow_imp.g_varchar2_table(29081) := '67657452616E67652830293B696628216E7C7C6E2E73746172744C696E654E756D626572213D3D6E2E656E644C696E654E756D6265722972657475726E20746869732E636C65617252616E67657328293B636F6E737420693D742E67657456616C756549';
wwv_flow_imp.g_varchar2_table(29082) := '6E52616E6765286E293B696628746869732E5F63757272656E74576F72645061747465726E297B636F6E737420653D692E6D6174636828746869732E5F63757272656E74576F72645061747465726E293B69662828653F655B305D2E6C656E6774683A30';
wwv_flow_imp.g_varchar2_table(29083) := '29213D3D692E6C656E6774682972657475726E20746869732E636C65617252616E67657328297D636F6E7374206F3D5B5D3B666F72286C657420653D312C6E3D746869732E5F63757272656E744465636F726174696F6E732E6C656E6774683B653C6E3B';
wwv_flow_imp.g_varchar2_table(29084) := '652B2B297B636F6E7374206E3D746869732E5F63757272656E744465636F726174696F6E732E67657452616E67652865293B6966286E296966286E2E73746172744C696E654E756D626572213D3D6E2E656E644C696E654E756D626572296F2E70757368';
wwv_flow_imp.g_varchar2_table(29085) := '287B72616E67653A6E2C746578743A697D293B656C73657B6C657420653D742E67657456616C7565496E52616E6765286E292C733D692C723D6E2E7374617274436F6C756D6E2C613D6E2E656E64436F6C756D6E3B636F6E7374206C3D4C6928652C7329';
wwv_flow_imp.g_varchar2_table(29086) := '3B722B3D6C2C653D652E737562737472286C292C733D732E737562737472286C293B636F6E737420633D446928652C73293B612D3D632C653D652E73756273747228302C652E6C656E6774682D63292C733D732E73756273747228302C732E6C656E6774';
wwv_flow_imp.g_varchar2_table(29087) := '682D63292C723D3D3D612626303D3D3D732E6C656E6774687C7C6F2E70757368287B72616E67653A6E6577207268286E2E73746172744C696E654E756D6265722C722C6E2E656E644C696E654E756D6265722C61292C746578743A737D297D7D69662830';
wwv_flow_imp.g_varchar2_table(29088) := '213D3D6F2E6C656E677468297472797B746869732E5F656469746F722E706F70556E646F53746F7028292C746869732E5F69676E6F72654368616E67654576656E743D21303B636F6E737420653D746869732E5F656469746F722E5F676574566965774D';
wwv_flow_imp.g_varchar2_table(29089) := '6F64656C28292E67657450726576456469744F7065726174696F6E5479706528293B746869732E5F656469746F722E65786563757465456469747328226C696E6B656445646974696E67222C6F292C746869732E5F656469746F722E5F67657456696577';
wwv_flow_imp.g_varchar2_table(29090) := '4D6F64656C28292E73657450726576456469744F7065726174696F6E547970652865297D66696E616C6C797B746869732E5F69676E6F72654368616E67654576656E743D21317D7D646973706F736528297B746869732E636C65617252616E6765732829';
wwv_flow_imp.g_varchar2_table(29091) := '2C73757065722E646973706F736528297D636C65617252616E67657328297B746869732E5F76697369626C65436F6E746578744B65792E736574282131292C746869732E5F63757272656E744465636F726174696F6E732E636C65617228292C74686973';
wwv_flow_imp.g_varchar2_table(29092) := '2E5F63757272656E7452657175657374437473262628746869732E5F63757272656E74526571756573744374732E63616E63656C28292C746869732E5F63757272656E74526571756573744374733D6E756C6C2C746869732E5F63757272656E74526571';
wwv_flow_imp.g_varchar2_table(29093) := '75657374506F736974696F6E3D6E756C6C297D6173796E632075706461746552616E67657328653D2131297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E20766F696420746869732E636C65617252616E676573';
wwv_flow_imp.g_varchar2_table(29094) := '28293B636F6E737420743D746869732E5F656469746F722E676574506F736974696F6E28293B69662821746869732E5F656E61626C6564262621657C7C746869732E5F656469746F722E67657453656C656374696F6E7328292E6C656E6774683E312972';
wwv_flow_imp.g_varchar2_table(29095) := '657475726E20766F696420746869732E636C65617252616E67657328293B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292C693D6E2E67657456657273696F6E496428293B696628746869732E5F63757272656E74526571';
wwv_flow_imp.g_varchar2_table(29096) := '75657374506F736974696F6E2626746869732E5F63757272656E74526571756573744D6F64656C56657273696F6E3D3D3D69297B696628742E657175616C7328746869732E5F63757272656E7452657175657374506F736974696F6E292972657475726E';
wwv_flow_imp.g_varchar2_table(29097) := '3B696628746869732E5F63757272656E744465636F726174696F6E732E6C656E6774683E30297B636F6E737420653D746869732E5F63757272656E744465636F726174696F6E732E67657452616E67652830293B696628652626652E636F6E7461696E73';
wwv_flow_imp.g_varchar2_table(29098) := '506F736974696F6E2874292972657475726E7D7D746869732E636C65617252616E67657328292C746869732E5F63757272656E7452657175657374506F736974696F6E3D742C746869732E5F63757272656E74526571756573744D6F64656C5665727369';
wwv_flow_imp.g_varchar2_table(29099) := '6F6E3D693B636F6E7374206F3D746869732E5F63757272656E74526571756573744374733D6E6577204E743B7472797B636F6E737420653D6E6577206674282131292C733D617761697420473628746869732E5F70726F7669646572732C6E2C742C6F2E';
wwv_flow_imp.g_varchar2_table(29100) := '746F6B656E293B696628746869732E5F6465626F756E6365496E666F726D6174696F6E2E757064617465286E2C652E656C61707365642829292C6F213D3D746869732E5F63757272656E74526571756573744374732972657475726E3B69662874686973';
wwv_flow_imp.g_varchar2_table(29101) := '2E5F63757272656E74526571756573744374733D6E756C6C2C69213D3D6E2E67657456657273696F6E496428292972657475726E3B6C657420723D5B5D3B286E756C6C3D3D733F766F696420303A732E72616E67657329262628723D732E72616E676573';
wwv_flow_imp.g_varchar2_table(29102) := '292C746869732E5F63757272656E74576F72645061747465726E3D286E756C6C3D3D733F766F696420303A732E776F72645061747465726E297C7C746869732E5F6C616E6775616765576F72645061747465726E3B6C657420613D21313B666F72286C65';
wwv_flow_imp.g_varchar2_table(29103) := '7420653D302C6E3D722E6C656E6774683B653C6E3B652B2B2969662872682E636F6E7461696E73506F736974696F6E28725B655D2C7429297B696628613D21302C30213D3D65297B636F6E737420743D725B655D3B722E73706C69636528652C31292C72';
wwv_flow_imp.g_varchar2_table(29104) := '2E756E73686966742874297D627265616B7D69662821612972657475726E20766F696420746869732E636C65617252616E67657328293B636F6E7374206C3D722E6D61702828653D3E287B72616E67653A652C6F7074696F6E733A71362E4445434F5241';
wwv_flow_imp.g_varchar2_table(29105) := '54494F4E7D2929293B746869732E5F76697369626C65436F6E746578744B65792E736574282130292C746869732E5F63757272656E744465636F726174696F6E732E736574286C292C746869732E5F73796E6352616E676573546F6B656E2B2B7D636174';
wwv_flow_imp.g_varchar2_table(29106) := '63682865297B54652865297C7C6B652865292C746869732E5F63757272656E7452657175657374437473213D3D6F2626746869732E5F63757272656E74526571756573744374737C7C746869732E636C65617252616E67657328297D7D7D3B66756E6374';
wwv_flow_imp.g_varchar2_table(29107) := '696F6E20473628652C742C6E2C69297B72657475726E20717428652E6F7264657265642874292E6D61702828653D3E6173796E6328293D3E7B7472797B72657475726E20617761697420652E70726F766964654C696E6B656445646974696E6752616E67';
wwv_flow_imp.g_varchar2_table(29108) := '657328742C6E2C69297D63617463682865297B72657475726E20766F69642045652865297D7D29292C28653D3E21216526266A68286E756C6C3D3D653F766F696420303A652E72616E6765732929297D4B362E49443D22656469746F722E636F6E747269';
wwv_flow_imp.g_varchar2_table(29109) := '622E6C696E6B656445646974696E67222C4B362E4445434F524154494F4E3D4F432E7265676973746572287B6465736372697074696F6E3A226C696E6B65642D65646974696E67222C737469636B696E6573733A302C636C6173734E616D653A226C696E';
wwv_flow_imp.g_varchar2_table(29110) := '6B65642D65646974696E672D6465636F726174696F6E227D292C4B363D71363D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A656374';
wwv_flow_imp.g_varchar2_table(29111) := '2E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D';
wwv_flow_imp.g_varchar2_table(29112) := '5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F2874';
wwv_flow_imp.g_varchar2_table(29113) := '2C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B243628312C6364292C243628322C7878292C243628332C6567292C243628342C6456295D2C4B36292C5964';
wwv_flow_imp.g_varchar2_table(29114) := '286E65772824642E62696E64546F436F6E747269627574696F6E284B362E6765742929287B69643A2263616E63656C4C696E6B656445646974696E67496E707574222C707265636F6E646974696F6E3A55362C68616E646C65723A653D3E652E636C6561';
wwv_flow_imp.g_varchar2_table(29115) := '7252616E67657328292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7765696768743A3139392C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D29292C4C6D2822656469746F722E6C696E';
wwv_flow_imp.g_varchar2_table(29116) := '6B656445646974696E674261636B67726F756E64222C7B6461726B3A68752E66726F6D48657828222366303022292E7472616E73706172656E74282E33292C6C696768743A68752E66726F6D48657828222366303022292E7472616E73706172656E7428';
wwv_flow_imp.g_varchar2_table(29117) := '2E33292C68634461726B3A68752E66726F6D48657828222366303022292E7472616E73706172656E74282E33292C68634C696768743A68752E77686974657D2C6228302C224261636B67726F756E6420636F6C6F72207768656E2074686520656469746F';
wwv_flow_imp.g_varchar2_table(29118) := '72206175746F2072656E616D6573206F6E20747970652E2229292C516428225F657865637574654C696E6B656445646974696E6750726F7669646572222C2828652C742C6E293D3E7B636F6E73747B6C696E6B656445646974696E6752616E676550726F';
wwv_flow_imp.g_varchar2_table(29119) := '76696465723A697D3D652E676574287878293B72657475726E20473628692C742C6E2C4D742E4E6F6E65297D29292C4A64284B362E49442C4B362C31292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B73757065';
wwv_flow_imp.g_varchar2_table(29120) := '72287B69643A22656469746F722E616374696F6E2E6C696E6B656445646974696E67222C6C6162656C3A6228302C225374617274204C696E6B65642045646974696E6722292C616C6961733A225374617274204C696E6B65642045646974696E67222C70';
wwv_flow_imp.g_varchar2_table(29121) := '7265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6C682E68617352656E616D6550726F7669646572292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A333133322C';
wwv_flow_imp.g_varchar2_table(29122) := '7765696768743A3130307D7D297D72756E436F6D6D616E6428652C74297B636F6E7374206E3D652E676574286763292C5B692C6F5D3D41727261792E697341727261792874292626747C7C5B766F696420302C766F696420305D3B72657475726E204E6F';
wwv_flow_imp.g_varchar2_table(29123) := '2E697355726928692926266D632E697349506F736974696F6E286F293F6E2E6F70656E436F6465456469746F72287B7265736F757263653A697D2C6E2E676574416374697665436F6465456469746F722829292E7468656E2828653D3E7B65262628652E';
wwv_flow_imp.g_varchar2_table(29124) := '736574506F736974696F6E286F292C652E696E766F6B6557697468696E436F6E746578742828743D3E28746869732E7265706F727454656C656D6574727928742C65292C746869732E72756E28742C6529292929297D292C6B65293A73757065722E7275';
wwv_flow_imp.g_varchar2_table(29125) := '6E436F6D6D616E6428652C74297D72756E28652C74297B636F6E7374206E3D4B362E6765742874293B72657475726E206E3F50726F6D6973652E7265736F6C7665286E2E75706461746552616E67657328213029293A50726F6D6973652E7265736F6C76';
wwv_flow_imp.g_varchar2_table(29126) := '6528297D7D293B7661722051363D6E2831313737292C59363D7B7D3B59362E7374796C655461675472616E73666F726D3D6A7228292C59362E736574417474726962757465733D567228292C59362E696E736572743D467228292E62696E64286E756C6C';
wwv_flow_imp.g_varchar2_table(29127) := '2C226865616422292C59362E646F6D4150493D4F7228292C59362E696E736572745374796C65456C656D656E743D487228292C4E7228292851362E412C5936292C51362E41262651362E412E6C6F63616C73262651362E412E6C6F63616C733B636C6173';
wwv_flow_imp.g_varchar2_table(29128) := '73205A367B636F6E7374727563746F7228652C74297B746869732E5F6C696E6B3D652C746869732E5F70726F76696465723D747D746F4A534F4E28297B72657475726E7B72616E67653A746869732E72616E67652C75726C3A746869732E75726C2C746F';
wwv_flow_imp.g_varchar2_table(29129) := '6F6C7469703A746869732E746F6F6C7469707D7D6765742072616E676528297B72657475726E20746869732E5F6C696E6B2E72616E67657D6765742075726C28297B72657475726E20746869732E5F6C696E6B2E75726C7D67657420746F6F6C74697028';
wwv_flow_imp.g_varchar2_table(29130) := '297B72657475726E20746869732E5F6C696E6B2E746F6F6C7469707D6173796E63207265736F6C76652865297B72657475726E20746869732E5F6C696E6B2E75726C3F746869732E5F6C696E6B2E75726C3A2266756E6374696F6E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(29131) := '20746869732E5F70726F76696465722E7265736F6C76654C696E6B3F50726F6D6973652E7265736F6C766528746869732E5F70726F76696465722E7265736F6C76654C696E6B28746869732E5F6C696E6B2C6529292E7468656E2828743D3E2874686973';
wwv_flow_imp.g_varchar2_table(29132) := '2E5F6C696E6B3D747C7C746869732E5F6C696E6B2C746869732E5F6C696E6B2E75726C3F746869732E7265736F6C76652865293A50726F6D6973652E72656A656374286E6577204572726F7228226D697373696E672229292929293A50726F6D6973652E';
wwv_flow_imp.g_varchar2_table(29133) := '72656A656374286E6577204572726F7228226D697373696E672229297D7D636C6173732058367B636F6E7374727563746F722865297B746869732E5F646973706F7361626C65733D6E65772061743B6C657420743D5B5D3B666F7228636F6E73745B6E2C';
wwv_flow_imp.g_varchar2_table(29134) := '695D6F662065297B636F6E737420653D6E2E6C696E6B732E6D61702828653D3E6E6577205A3628652C692929293B743D58362E5F756E696F6E28742C65292C6974286E292626746869732E5F646973706F7361626C65732E616464286E297D746869732E';
wwv_flow_imp.g_varchar2_table(29135) := '6C696E6B733D747D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E6C696E6B732E6C656E6774683D307D737461746963205F756E696F6E28652C74297B636F6E7374206E3D5B5D3B6C657420';
wwv_flow_imp.g_varchar2_table(29136) := '692C6F2C732C723B666F7228693D302C733D302C6F3D652E6C656E6774682C723D742E6C656E6774683B693C6F2626733C723B297B636F6E7374206F3D655B695D2C723D745B735D3B72682E617265496E74657273656374696E674F72546F756368696E';
wwv_flow_imp.g_varchar2_table(29137) := '67286F2E72616E67652C722E72616E6765293F692B2B3A72682E636F6D7061726552616E6765735573696E67537461727473286F2E72616E67652C722E72616E6765293C303F286E2E70757368286F292C692B2B293A286E2E707573682872292C732B2B';
wwv_flow_imp.g_varchar2_table(29138) := '297D666F72283B693C6F3B692B2B296E2E7075736828655B695D293B666F72283B733C723B732B2B296E2E7075736828745B735D293B72657475726E206E7D7D66756E6374696F6E204A3628652C742C6E297B636F6E737420693D5B5D2C6F3D652E6F72';
wwv_flow_imp.g_varchar2_table(29139) := '64657265642874292E7265766572736528292E6D6170282828652C6F293D3E50726F6D6973652E7265736F6C766528652E70726F766964654C696E6B7328742C6E29292E7468656E2828743D3E7B74262628695B6F5D3D5B742C655D297D292C45652929';
wwv_flow_imp.g_varchar2_table(29140) := '293B72657475726E2050726F6D6973652E616C6C286F292E7468656E282828293D3E7B636F6E737420653D6E6577205836287A68286929293B72657475726E206E2E697343616E63656C6C6174696F6E5265717565737465643F28652E646973706F7365';
wwv_flow_imp.g_varchar2_table(29141) := '28292C6E6577205836285B5D29293A657D29297D6B632E7265676973746572436F6D6D616E6428225F657865637574654C696E6B50726F7669646572222C286173796E6328652C2E2E2E74293D3E7B6C65745B6E2C695D3D743B796C286E20696E737461';
wwv_flow_imp.g_varchar2_table(29142) := '6E63656F66204E6F292C226E756D62657222213D747970656F662069262628693D30293B636F6E73747B6C696E6B50726F76696465723A6F7D3D652E676574287878292C733D652E676574286663292E6765744D6F64656C286E293B6966282173297265';
wwv_flow_imp.g_varchar2_table(29143) := '7475726E5B5D3B636F6E737420723D6177616974204A36286F2C732C4D742E4E6F6E65293B69662821722972657475726E5B5D3B666F72286C657420653D303B653C4D6174682E6D696E28692C722E6C696E6B732E6C656E677468293B652B2B29617761';
wwv_flow_imp.g_varchar2_table(29144) := '697420722E6C696E6B735B655D2E7265736F6C7665284D742E4E6F6E65293B636F6E737420613D722E6C696E6B732E736C6963652830293B72657475726E20722E646973706F736528292C617D29293B7661722065372C74373D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(29145) := '2C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206E373D65373D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F';
wwv_flow_imp.g_varchar2_table(29146) := '6E2865372E4944297D636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E656469746F723D652C746869732E6F70656E6572536572766963653D742C746869732E6E6F74696669636174696F6E536572766963653D';
wwv_flow_imp.g_varchar2_table(29147) := '6E2C746869732E6C616E67756167654665617475726573536572766963653D692C746869732E70726F7669646572733D746869732E6C616E67756167654665617475726573536572766963652E6C696E6B50726F76696465722C746869732E6465626F75';
wwv_flow_imp.g_varchar2_table(29148) := '6E6365496E666F726D6174696F6E3D6F2E666F7228746869732E70726F7669646572732C224C696E6B73222C7B6D696E3A3165332C6D61783A3465337D292C746869732E636F6D707574654C696E6B733D746869732E5F7265676973746572286E657720';
wwv_flow_imp.g_varchar2_table(29149) := '4B74282828293D3E746869732E636F6D707574654C696E6B734E6F772829292C31653329292C746869732E636F6D7075746550726F6D6973653D6E756C6C2C746869732E6163746976654C696E6B734C6973743D6E756C6C2C746869732E63757272656E';
wwv_flow_imp.g_varchar2_table(29150) := '744F6363757272656E6365733D7B7D2C746869732E6163746976654C696E6B4465636F726174696F6E49643D6E756C6C3B636F6E737420733D746869732E5F7265676973746572286E6577205171286529293B746869732E5F726567697374657228732E';
wwv_flow_imp.g_varchar2_table(29151) := '6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E2828285B652C745D293D3E7B746869732E5F6F6E456469746F724D6F7573654D6F766528652C74297D2929292C746869732E5F726567697374657228732E6F6E4578656375746528';
wwv_flow_imp.g_varchar2_table(29152) := '28653D3E7B746869732E6F6E456469746F724D6F75736555702865297D2929292C746869732E5F726567697374657228732E6F6E43616E63656C2828653D3E7B746869732E636C65616E55704163746976654C696E6B4465636F726174696F6E28297D29';
wwv_flow_imp.g_varchar2_table(29153) := '29292C746869732E5F726567697374657228652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E67656428373129262628746869732E7570646174654465636F726174696F6E73285B5D292C74686973';
wwv_flow_imp.g_varchar2_table(29154) := '2E73746F7028292C746869732E636F6D707574654C696E6B732E7363686564756C65283029297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E656469746F72';
wwv_flow_imp.g_varchar2_table(29155) := '2E6861734D6F64656C28292626746869732E636F6D707574654C696E6B732E7363686564756C6528746869732E6465626F756E6365496E666F726D6174696F6E2E67657428746869732E656469746F722E6765744D6F64656C282929297D2929292C7468';
wwv_flow_imp.g_varchar2_table(29156) := '69732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C2828653D3E7B746869732E63757272656E744F6363757272656E6365733D7B7D2C746869732E6163746976654C696E6B4465636F726174696F6E49643D6E756C6C2C746869';
wwv_flow_imp.g_varchar2_table(29157) := '732E73746F7028292C746869732E636F6D707574654C696E6B732E7363686564756C652830297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C4C616E67756167652828653D3E7B746869732E73746F7028';
wwv_flow_imp.g_varchar2_table(29158) := '292C746869732E636F6D707574654C696E6B732E7363686564756C652830297D2929292C746869732E5F726567697374657228746869732E70726F7669646572732E6F6E4469644368616E67652828653D3E7B746869732E73746F7028292C746869732E';
wwv_flow_imp.g_varchar2_table(29159) := '636F6D707574654C696E6B732E7363686564756C652830297D2929292C746869732E636F6D707574654C696E6B732E7363686564756C652830297D6173796E6320636F6D707574654C696E6B734E6F7728297B69662821746869732E656469746F722E68';
wwv_flow_imp.g_varchar2_table(29160) := '61734D6F64656C28297C7C21746869732E656469746F722E6765744F7074696F6E283731292972657475726E3B636F6E737420653D746869732E656469746F722E6765744D6F64656C28293B69662821652E6973546F6F4C61726765466F7253796E6369';
wwv_flow_imp.g_varchar2_table(29161) := '6E6728292626746869732E70726F7669646572732E686173286529297B746869732E6163746976654C696E6B734C697374262628746869732E6163746976654C696E6B734C6973742E646973706F736528292C746869732E6163746976654C696E6B734C';
wwv_flow_imp.g_varchar2_table(29162) := '6973743D6E756C6C292C746869732E636F6D7075746550726F6D6973653D46742828743D3E4A3628746869732E70726F7669646572732C652C742929293B7472797B636F6E737420743D6E6577206674282131293B696628746869732E6163746976654C';
wwv_flow_imp.g_varchar2_table(29163) := '696E6B734C6973743D617761697420746869732E636F6D7075746550726F6D6973652C746869732E6465626F756E6365496E666F726D6174696F6E2E75706461746528652C742E656C61707365642829292C652E6973446973706F736564282929726574';
wwv_flow_imp.g_varchar2_table(29164) := '75726E3B746869732E7570646174654465636F726174696F6E7328746869732E6163746976654C696E6B734C6973742E6C696E6B73297D63617463682865297B6B652865297D66696E616C6C797B746869732E636F6D7075746550726F6D6973653D6E75';
wwv_flow_imp.g_varchar2_table(29165) := '6C6C7D7D7D7570646174654465636F726174696F6E732865297B636F6E737420743D22616C744B6579223D3D3D746869732E656469746F722E6765744F7074696F6E283738292C6E3D5B5D2C693D4F626A6563742E6B65797328746869732E6375727265';
wwv_flow_imp.g_varchar2_table(29166) := '6E744F6363757272656E636573293B666F7228636F6E73742065206F662069297B636F6E737420743D746869732E63757272656E744F6363757272656E6365735B655D3B6E2E7075736828742E6465636F726174696F6E4964297D636F6E7374206F3D5B';
wwv_flow_imp.g_varchar2_table(29167) := '5D3B6966286529666F7228636F6E7374206E206F662065296F2E707573682873372E6465636F726174696F6E286E2C7429293B746869732E656469746F722E6368616E67654465636F726174696F6E732828743D3E7B636F6E737420693D742E64656C74';
wwv_flow_imp.g_varchar2_table(29168) := '614465636F726174696F6E73286E2C6F293B746869732E63757272656E744F6363757272656E6365733D7B7D2C746869732E6163746976654C696E6B4465636F726174696F6E49643D6E756C6C3B666F72286C657420743D302C6E3D692E6C656E677468';
wwv_flow_imp.g_varchar2_table(29169) := '3B743C6E3B742B2B297B636F6E7374206E3D6E657720733728655B745D2C695B745D293B746869732E63757272656E744F6363757272656E6365735B6E2E6465636F726174696F6E49645D3D6E7D7D29297D5F6F6E456469746F724D6F7573654D6F7665';
wwv_flow_imp.g_varchar2_table(29170) := '28652C74297B636F6E7374206E3D22616C744B6579223D3D3D746869732E656469746F722E6765744F7074696F6E283738293B696628746869732E6973456E61626C656428652C7429297B746869732E636C65616E55704163746976654C696E6B446563';
wwv_flow_imp.g_varchar2_table(29171) := '6F726174696F6E28293B636F6E737420743D746869732E6765744C696E6B4F6363757272656E636528652E7461726765742E706F736974696F6E293B742626746869732E656469746F722E6368616E67654465636F726174696F6E732828653D3E7B742E';
wwv_flow_imp.g_varchar2_table(29172) := '616374697661746528652C6E292C746869732E6163746976654C696E6B4465636F726174696F6E49643D742E6465636F726174696F6E49647D29297D656C736520746869732E636C65616E55704163746976654C696E6B4465636F726174696F6E28297D';
wwv_flow_imp.g_varchar2_table(29173) := '636C65616E55704163746976654C696E6B4465636F726174696F6E28297B636F6E737420653D22616C744B6579223D3D3D746869732E656469746F722E6765744F7074696F6E283738293B696628746869732E6163746976654C696E6B4465636F726174';
wwv_flow_imp.g_varchar2_table(29174) := '696F6E4964297B636F6E737420743D746869732E63757272656E744F6363757272656E6365735B746869732E6163746976654C696E6B4465636F726174696F6E49645D3B742626746869732E656469746F722E6368616E67654465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(29175) := '28286E3D3E7B742E64656163746976617465286E2C65297D29292C746869732E6163746976654C696E6B4465636F726174696F6E49643D6E756C6C7D7D6F6E456469746F724D6F75736555702865297B69662821746869732E6973456E61626C65642865';
wwv_flow_imp.g_varchar2_table(29176) := '292972657475726E3B636F6E737420743D746869732E6765744C696E6B4F6363757272656E636528652E7461726765742E706F736974696F6E293B742626746869732E6F70656E4C696E6B4F6363757272656E636528742C652E68617353696465427953';
wwv_flow_imp.g_varchar2_table(29177) := '6964654D6F6469666965722C2130297D6F70656E4C696E6B4F6363757272656E636528652C742C6E3D2131297B69662821746869732E6F70656E6572536572766963652972657475726E3B636F6E73747B6C696E6B3A697D3D653B692E7265736F6C7665';
wwv_flow_imp.g_varchar2_table(29178) := '284D742E4E6F6E65292E7468656E2828653D3E7B69662822737472696E67223D3D747970656F6620652626746869732E656469746F722E6861734D6F64656C2829297B636F6E737420743D746869732E656469746F722E6765744D6F64656C28292E7572';
wwv_flow_imp.g_varchar2_table(29179) := '693B696628742E736368656D653D3D3D716F2E66696C652626652E737461727473576974682860247B716F2E66696C657D3A6029297B636F6E7374206E3D4E6F2E70617273652865293B6966286E2E736368656D653D3D3D716F2E66696C65297B636F6E';
wwv_flow_imp.g_varchar2_table(29180) := '737420693D6A6C286E293B6C6574206F3D6E756C6C3B692E7374617274735769746828222F2E2F22297C7C692E7374617274735769746828225C5C2E5C5C22293F6F3D602E247B692E7375627374722831297D603A28692E737461727473576974682822';
wwv_flow_imp.g_varchar2_table(29181) := '2F2F2E2F22297C7C692E7374617274735769746828225C5C5C5C2E5C5C2229292626286F3D602E247B692E7375627374722832297D60292C6F262628653D5A6C28742C6F29297D7D7D72657475726E20746869732E6F70656E6572536572766963652E6F';
wwv_flow_imp.g_varchar2_table(29182) := '70656E28652C7B6F70656E546F536964653A742C66726F6D55736572476573747572653A6E2C616C6C6F77436F6E74726962757465644F70656E6572733A21302C616C6C6F77436F6D6D616E64733A21302C66726F6D576F726B73706163653A21307D29';
wwv_flow_imp.g_varchar2_table(29183) := '7D292C28653D3E7B636F6E737420743D6520696E7374616E63656F66204572726F723F652E6D6573736167653A653B22696E76616C6964223D3D3D743F746869732E6E6F74696669636174696F6E536572766963652E7761726E286228302C224661696C';
wwv_flow_imp.g_varchar2_table(29184) := '656420746F206F70656E2074686973206C696E6B2062656361757365206974206973206E6F742077656C6C2D666F726D65643A207B307D222C692E75726C2E746F537472696E67282929293A226D697373696E67223D3D3D743F746869732E6E6F746966';
wwv_flow_imp.g_varchar2_table(29185) := '69636174696F6E536572766963652E7761726E286228302C224661696C656420746F206F70656E2074686973206C696E6B20626563617573652069747320746172676574206973206D697373696E672E2229293A6B652865297D29297D6765744C696E6B';
wwv_flow_imp.g_varchar2_table(29186) := '4F6363757272656E63652865297B69662821746869732E656469746F722E6861734D6F64656C28297C7C21652972657475726E206E756C6C3B636F6E737420743D746869732E656469746F722E6765744D6F64656C28292E6765744465636F726174696F';
wwv_flow_imp.g_varchar2_table(29187) := '6E73496E52616E6765287B73746172744C696E654E756D6265723A652E6C696E654E756D6265722C7374617274436F6C756D6E3A652E636F6C756D6E2C656E644C696E654E756D6265723A652E6C696E654E756D6265722C656E64436F6C756D6E3A652E';
wwv_flow_imp.g_varchar2_table(29188) := '636F6C756D6E7D2C302C2130293B666F7228636F6E73742065206F662074297B636F6E737420743D746869732E63757272656E744F6363757272656E6365735B652E69645D3B696628742972657475726E20747D72657475726E206E756C6C7D6973456E';
wwv_flow_imp.g_varchar2_table(29189) := '61626C656428652C74297B72657475726E20426F6F6C65616E28363D3D3D652E7461726765742E74797065262628652E686173547269676765724D6F6469666965727C7C742626742E6B6579436F64654973547269676765724B657929297D73746F7028';
wwv_flow_imp.g_varchar2_table(29190) := '297B76617220653B746869732E636F6D707574654C696E6B732E63616E63656C28292C746869732E6163746976654C696E6B734C6973742626286E756C6C3D3D3D28653D746869732E6163746976654C696E6B734C697374297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(29191) := '657C7C652E646973706F736528292C746869732E6163746976654C696E6B734C6973743D6E756C6C292C746869732E636F6D7075746550726F6D697365262628746869732E636F6D7075746550726F6D6973652E63616E63656C28292C746869732E636F';
wwv_flow_imp.g_varchar2_table(29192) := '6D7075746550726F6D6973653D6E756C6C297D646973706F736528297B73757065722E646973706F736528292C746869732E73746F7028297D7D3B6E372E49443D22656469746F722E6C696E6B4465746563746F72222C6E373D65373D66756E6374696F';
wwv_flow_imp.g_varchar2_table(29193) := '6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F62';
wwv_flow_imp.g_varchar2_table(29194) := '6A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220';
wwv_flow_imp.g_varchar2_table(29195) := '613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E655072';
wwv_flow_imp.g_varchar2_table(29196) := '6F706572747928742C6E2C72292C727D285B743728312C6445292C743728322C7344292C743728332C7878292C743728342C6456295D2C6E37293B636F6E73742069373D4F432E7265676973746572287B6465736372697074696F6E3A22646574656374';
wwv_flow_imp.g_varchar2_table(29197) := '65642D6C696E6B222C737469636B696E6573733A312C636F6C6C617073654F6E5265706C616365456469743A21302C696E6C696E65436C6173734E616D653A2264657465637465642D6C696E6B227D292C6F373D4F432E7265676973746572287B646573';
wwv_flow_imp.g_varchar2_table(29198) := '6372697074696F6E3A2264657465637465642D6C696E6B2D616374697665222C737469636B696E6573733A312C636F6C6C617073654F6E5265706C616365456469743A21302C696E6C696E65436C6173734E616D653A2264657465637465642D6C696E6B';
wwv_flow_imp.g_varchar2_table(29199) := '2D616374697665227D293B636C6173732073377B737461746963206465636F726174696F6E28652C74297B72657475726E7B72616E67653A652E72616E67652C6F7074696F6E733A73372E5F6765744F7074696F6E7328652C742C2131297D7D73746174';
wwv_flow_imp.g_varchar2_table(29200) := '6963205F6765744F7074696F6E7328652C742C6E297B636F6E737420693D7B2E2E2E6E3F6F373A69377D3B72657475726E20692E686F7665724D6573736167653D66756E6374696F6E28652C74297B636F6E7374206E3D652E75726C26262F5E636F6D6D';
wwv_flow_imp.g_varchar2_table(29201) := '616E643A2F692E7465737428652E75726C2E746F537472696E672829292C693D652E746F6F6C7469703F652E746F6F6C7469703A6228302C6E3F224578656375746520636F6D6D616E64223A22466F6C6C6F77206C696E6B22292C6F3D6228302C743F71';
wwv_flow_imp.g_varchar2_table(29202) := '3F22636D64202B20636C69636B223A226374726C202B20636C69636B223A713F226F7074696F6E202B20636C69636B223A22616C74202B20636C69636B22293B696628652E75726C297B6C657420743D22223B6966282F5E636F6D6D616E643A2F692E74';
wwv_flow_imp.g_varchar2_table(29203) := '65737428652E75726C2E746F537472696E67282929297B636F6E7374206E3D652E75726C2E746F537472696E6728292E6D61746368282F5E636F6D6D616E643A285B5E3F235D2B292F293B6E262628743D6228302C224578656375746520636F6D6D616E';
wwv_flow_imp.g_varchar2_table(29204) := '64207B307D222C6E5B315D29297D72657475726E206E6577206F632822222C2130292E617070656E644C696E6B28652E75726C2E746F537472696E67282130292E7265706C616365282F202F672C2225323022292C692C74292E617070656E644D61726B';
wwv_flow_imp.g_varchar2_table(29205) := '646F776E28602028247B6F7D2960297D72657475726E286E6577206F63292E617070656E64546578742860247B697D2028247B6F7D2960297D28652C74292C697D636F6E7374727563746F7228652C74297B746869732E6C696E6B3D652C746869732E64';
wwv_flow_imp.g_varchar2_table(29206) := '65636F726174696F6E49643D747D616374697661746528652C74297B652E6368616E67654465636F726174696F6E4F7074696F6E7328746869732E6465636F726174696F6E49642C73372E5F6765744F7074696F6E7328746869732E6C696E6B2C742C21';
wwv_flow_imp.g_varchar2_table(29207) := '3029297D6465616374697661746528652C74297B652E6368616E67654465636F726174696F6E4F7074696F6E7328746869732E6465636F726174696F6E49642C73372E5F6765744F7074696F6E7328746869732E6C696E6B2C742C213129297D7D4A6428';
wwv_flow_imp.g_varchar2_table(29208) := '6E372E49442C6E372C31292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6F70656E4C696E6B222C6C6162656C3A6228302C224F70656E204C696E';
wwv_flow_imp.g_varchar2_table(29209) := '6B22292C616C6961733A224F70656E204C696E6B222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B636F6E7374206E3D6E372E6765742874293B696628216E2972657475726E3B69662821742E6861734D6F64656C2829';
wwv_flow_imp.g_varchar2_table(29210) := '2972657475726E3B636F6E737420693D742E67657453656C656374696F6E7328293B666F7228636F6E73742065206F662069297B636F6E737420743D6E2E6765744C696E6B4F6363757272656E636528652E676574456E64506F736974696F6E2829293B';
wwv_flow_imp.g_varchar2_table(29211) := '7426266E2E6F70656E4C696E6B4F6363757272656E636528742C2131297D7D7D293B636C61737320723720657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F656469746F723D652C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(29212) := '67697374657228746869732E5F656469746F722E6F6E4D6F757365446F776E2828653D3E7B636F6E737420743D746869732E5F656469746F722E6765744F7074696F6E28313137293B743E3D302626363D3D3D652E7461726765742E747970652626652E';
wwv_flow_imp.g_varchar2_table(29213) := '7461726765742E706F736974696F6E2E636F6C756D6E3E3D742626746869732E5F656469746F722E7570646174654F7074696F6E73287B73746F7052656E646572696E674C696E6541667465723A2D317D297D2929297D7D72372E49443D22656469746F';
wwv_flow_imp.g_varchar2_table(29214) := '722E636F6E747269622E6C6F6E674C696E657348656C706572222C4A642872372E49442C72372C32293B7661722061373D6E2839383033292C6C373D7B7D3B6C372E7374796C655461675472616E73666F726D3D6A7228292C6C372E7365744174747269';
wwv_flow_imp.g_varchar2_table(29215) := '62757465733D567228292C6C372E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6C372E646F6D4150493D4F7228292C6C372E696E736572745374796C65456C656D656E743D487228292C4E7228292861372E412C6C37292C';
wwv_flow_imp.g_varchar2_table(29216) := '61372E41262661372E412E6C6F63616C73262661372E412E6C6F63616C733B636F6E73742063373D4C6D2822656469746F722E776F7264486967686C696768744261636B67726F756E64222C7B6461726B3A22233537353735374238222C6C696768743A';
wwv_flow_imp.g_varchar2_table(29217) := '22233537353735373430222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228302C224261636B67726F756E6420636F6C6F72206F6620612073796D626F6C20647572696E6720726561642D6163636573732C206C696B6520726561';
wwv_flow_imp.g_varchar2_table(29218) := '64696E672061207661726961626C652E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130293B4C6D28226564';
wwv_flow_imp.g_varchar2_table(29219) := '69746F722E776F7264486967686C696768745374726F6E674261636B67726F756E64222C7B6461726B3A22233030343937324238222C6C696768743A22233065363339633430222C68634461726B3A6E756C6C2C68634C696768743A6E756C6C7D2C6228';
wwv_flow_imp.g_varchar2_table(29220) := '302C224261636B67726F756E6420636F6C6F72206F6620612073796D626F6C20647572696E672077726974652D6163636573732C206C696B652077726974696E6720746F2061207661726961626C652E2054686520636F6C6F72206D757374206E6F7420';
wwv_flow_imp.g_varchar2_table(29221) := '6265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C4C6D2822656469746F722E776F7264486967686C69676874546578744261636B67726F756E64222C7B6C';
wwv_flow_imp.g_varchar2_table(29222) := '696768743A63372C6461726B3A63372C68634461726B3A63372C68634C696768743A63377D2C6228302C224261636B67726F756E6420636F6C6F72206F662061207465787475616C206F6363757272656E636520666F7220612073796D626F6C2E205468';
wwv_flow_imp.g_varchar2_table(29223) := '6520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130293B636F6E73742064373D4C6D2822656469746F722E776F726448';
wwv_flow_imp.g_varchar2_table(29224) := '6967686C69676874426F72646572222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C68634461726B3A486D2C68634C696768743A486D7D2C6228302C22426F7264657220636F6C6F72206F6620612073796D626F6C20647572696E6720726561';
wwv_flow_imp.g_varchar2_table(29225) := '642D6163636573732C206C696B652072656164696E672061207661726961626C652E2229293B4C6D2822656469746F722E776F7264486967686C696768745374726F6E67426F72646572222C7B6C696768743A6E756C6C2C6461726B3A6E756C6C2C6863';
wwv_flow_imp.g_varchar2_table(29226) := '4461726B3A486D2C68634C696768743A486D7D2C6228302C22426F7264657220636F6C6F72206F6620612073796D626F6C20647572696E672077726974652D6163636573732C206C696B652077726974696E6720746F2061207661726961626C652E2229';
wwv_flow_imp.g_varchar2_table(29227) := '292C4C6D2822656469746F722E776F7264486967686C6967687454657874426F72646572222C7B6C696768743A64372C6461726B3A64372C68634461726B3A64372C68634C696768743A64377D2C6228302C22426F7264657220636F6C6F72206F662061';
wwv_flow_imp.g_varchar2_table(29228) := '207465787475616C206F6363757272656E636520666F7220612073796D626F6C2E2229293B636F6E73742068373D4C6D2822656469746F724F7665727669657752756C65722E776F7264486967686C69676874466F726567726F756E64222C7B6461726B';
wwv_flow_imp.g_varchar2_table(29229) := '3A22234130413041304343222C6C696768743A22234130413041304343222C68634461726B3A22234130413041304343222C68634C696768743A22234130413041304343227D2C6228302C224F766572766965772072756C6572206D61726B657220636F';
wwv_flow_imp.g_varchar2_table(29230) := '6C6F7220666F722073796D626F6C20686967686C69676874732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C';
wwv_flow_imp.g_varchar2_table(29231) := '2130292C75373D4C6D2822656469746F724F7665727669657752756C65722E776F7264486967686C696768745374726F6E67466F726567726F756E64222C7B6461726B3A22234330413043304343222C6C696768743A22234330413043304343222C6863';
wwv_flow_imp.g_varchar2_table(29232) := '4461726B3A22234330413043304343222C68634C696768743A22234330413043304343227D2C6228302C224F766572766965772072756C6572206D61726B657220636F6C6F7220666F722077726974652D6163636573732073796D626F6C20686967686C';
wwv_flow_imp.g_varchar2_table(29233) := '69676874732E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E6465726C79696E67206465636F726174696F6E732E22292C2130292C70373D4C6D2822656469746F724F7665';
wwv_flow_imp.g_varchar2_table(29234) := '727669657752756C65722E776F7264486967686C6967687454657874466F726567726F756E64222C7B6461726B3A51662C6C696768743A51662C68634461726B3A51662C68634C696768743A51667D2C6228302C224F766572766965772072756C657220';
wwv_flow_imp.g_varchar2_table(29235) := '6D61726B657220636F6C6F72206F662061207465787475616C206F6363757272656E636520666F7220612073796D626F6C2E2054686520636F6C6F72206D757374206E6F74206265206F706171756520736F206173206E6F7420746F206869646520756E';
wwv_flow_imp.g_varchar2_table(29236) := '6465726C79696E67206465636F726174696F6E732E22292C2130292C67373D4F432E7265676973746572287B6465736372697074696F6E3A22776F72642D686967686C696768742D7374726F6E67222C737469636B696E6573733A312C636C6173734E61';
wwv_flow_imp.g_varchar2_table(29237) := '6D653A22776F7264486967686C696768745374726F6E67222C6F7665727669657752756C65723A7B636F6C6F723A4F62287537292C706F736974696F6E3A53682E43656E7465727D2C6D696E696D61703A7B636F6C6F723A4F62286576292C706F736974';
wwv_flow_imp.g_varchar2_table(29238) := '696F6E3A317D7D292C6D373D4F432E7265676973746572287B6465736372697074696F6E3A22776F72642D686967686C696768742D74657874222C737469636B696E6573733A312C636C6173734E616D653A22776F7264486967686C6967687454657874';
wwv_flow_imp.g_varchar2_table(29239) := '222C6F7665727669657752756C65723A7B636F6C6F723A4F62287037292C706F736974696F6E3A53682E43656E7465727D2C6D696E696D61703A7B636F6C6F723A4F62286576292C706F736974696F6E3A317D7D292C66373D4F432E7265676973746572';
wwv_flow_imp.g_varchar2_table(29240) := '287B6465736372697074696F6E3A2273656C656374696F6E2D686967686C696768742D6F76657276696577222C737469636B696E6573733A312C636C6173734E616D653A2273656C656374696F6E486967686C69676874222C6F7665727669657752756C';
wwv_flow_imp.g_varchar2_table(29241) := '65723A7B636F6C6F723A4F62285166292C706F736974696F6E3A53682E43656E7465727D2C6D696E696D61703A7B636F6C6F723A4F62286576292C706F736974696F6E3A317D7D292C76373D4F432E7265676973746572287B6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(29242) := '3A2273656C656374696F6E2D686967686C69676874222C737469636B696E6573733A312C636C6173734E616D653A2273656C656374696F6E486967686C69676874227D292C62373D4F432E7265676973746572287B6465736372697074696F6E3A22776F';
wwv_flow_imp.g_varchar2_table(29243) := '72642D686967686C69676874222C737469636B696E6573733A312C636C6173734E616D653A22776F7264486967686C69676874222C6F7665727669657752756C65723A7B636F6C6F723A4F62286837292C706F736974696F6E3A53682E43656E7465727D';
wwv_flow_imp.g_varchar2_table(29244) := '2C6D696E696D61703A7B636F6C6F723A4F62286576292C706F736974696F6E3A317D7D293B66756E6374696F6E205F372865297B72657475726E20653F76373A66377D5662282828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F72286766';
wwv_flow_imp.g_varchar2_table(29245) := '293B6E2626742E61646452756C6528602E6D6F6E61636F2D656469746F72202E73656C656374696F6E486967686C69676874207B206261636B67726F756E642D636F6C6F723A20247B6E2E7472616E73706172656E74282E35297D3B207D60297D29293B';
wwv_flow_imp.g_varchar2_table(29246) := '7661722079373B66756E6374696F6E20773728652C74297B636F6E7374206E3D742E66696C7465722828743D3E21652E66696E642828653D3E652E657175616C73287429292929293B6966286E2E6C656E6774683E3D31297B636F6E737420653D6E2E6D';
wwv_flow_imp.g_varchar2_table(29247) := '61702828653D3E606C696E6520247B652E7669657753746174652E706F736974696F6E2E6C696E654E756D6265727D20636F6C756D6E20247B652E7669657753746174652E706F736974696F6E2E636F6C756D6E7D6029292E6A6F696E28222C2022293B';
wwv_flow_imp.g_varchar2_table(29248) := '4A7228313D3D3D6E2E6C656E6774683F6228302C22437572736F722061646465643A207B307D222C65293A6228302C22437572736F72732061646465643A207B307D222C6529297D7D636C6173732043377B636F6E7374727563746F7228652C742C6E29';
wwv_flow_imp.g_varchar2_table(29249) := '7B746869732E73656C656374696F6E733D652C746869732E72657665616C52616E67653D742C746869732E72657665616C5363726F6C6C547970653D6E7D7D636C6173732053377B7374617469632063726561746528652C74297B69662821652E686173';
wwv_flow_imp.g_varchar2_table(29250) := '4D6F64656C28292972657475726E206E756C6C3B636F6E7374206E3D742E676574537461746528293B69662821652E68617354657874466F637573282926266E2E697352657665616C656426266E2E736561726368537472696E672E6C656E6774683E30';
wwv_flow_imp.g_varchar2_table(29251) := '2972657475726E206E657720533728652C742C21312C6E2E736561726368537472696E672C6E2E77686F6C65576F72642C6E2E6D61746368436173652C6E756C6C293B6C657420692C6F2C733D21313B636F6E737420723D652E67657453656C65637469';
wwv_flow_imp.g_varchar2_table(29252) := '6F6E7328293B313D3D3D722E6C656E6774682626725B305D2E6973456D70747928293F28733D21302C693D21302C6F3D2130293A28693D6E2E77686F6C65576F72642C6F3D6E2E6D6174636843617365293B636F6E737420613D652E67657453656C6563';
wwv_flow_imp.g_varchar2_table(29253) := '74696F6E28293B6C6574206C2C633D6E756C6C3B696628612E6973456D7074792829297B636F6E737420743D652E676574436F6E66696775726564576F72644174506F736974696F6E28612E6765745374617274506F736974696F6E2829293B69662821';
wwv_flow_imp.g_varchar2_table(29254) := '742972657475726E206E756C6C3B6C3D742E776F72642C633D6E657720616828612E73746172744C696E654E756D6265722C742E7374617274436F6C756D6E2C612E73746172744C696E654E756D6265722C742E656E64436F6C756D6E297D656C736520';
wwv_flow_imp.g_varchar2_table(29255) := '6C3D652E6765744D6F64656C28292E67657456616C7565496E52616E67652861292E7265706C616365282F5C725C6E2F672C225C6E22293B72657475726E206E657720533728652C742C732C6C2C692C6F2C63297D636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(29256) := '2C6E2C692C6F2C732C72297B746869732E5F656469746F723D652C746869732E66696E64436F6E74726F6C6C65723D742C746869732E6973446973636F6E6E656374656446726F6D46696E64436F6E74726F6C6C65723D6E2C746869732E736561726368';
wwv_flow_imp.g_varchar2_table(29257) := '546578743D692C746869732E77686F6C65576F72643D6F2C746869732E6D61746368436173653D732C746869732E63757272656E744D617463683D727D61646453656C656374696F6E546F4E65787446696E644D6174636828297B69662821746869732E';
wwv_flow_imp.g_varchar2_table(29258) := '5F656469746F722E6861734D6F64656C28292972657475726E206E756C6C3B636F6E737420653D746869732E5F6765744E6578744D6174636828293B69662821652972657475726E206E756C6C3B636F6E737420743D746869732E5F656469746F722E67';
wwv_flow_imp.g_varchar2_table(29259) := '657453656C656374696F6E7328293B72657475726E206E657720433728742E636F6E6361742865292C652C30297D6D6F766553656C656374696F6E546F4E65787446696E644D6174636828297B69662821746869732E5F656469746F722E6861734D6F64';
wwv_flow_imp.g_varchar2_table(29260) := '656C28292972657475726E206E756C6C3B636F6E737420653D746869732E5F6765744E6578744D6174636828293B69662821652972657475726E206E756C6C3B636F6E737420743D746869732E5F656469746F722E67657453656C656374696F6E732829';
wwv_flow_imp.g_varchar2_table(29261) := '3B72657475726E206E657720433728742E736C69636528302C742E6C656E6774682D31292E636F6E6361742865292C652C30297D5F6765744E6578744D6174636828297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475';
wwv_flow_imp.g_varchar2_table(29262) := '726E206E756C6C3B696628746869732E63757272656E744D61746368297B636F6E737420653D746869732E63757272656E744D617463683B72657475726E20746869732E63757272656E744D617463683D6E756C6C2C657D746869732E66696E64436F6E';
wwv_flow_imp.g_varchar2_table(29263) := '74726F6C6C65722E686967686C6967687446696E644F7074696F6E7328293B636F6E737420653D746869732E5F656469746F722E67657453656C656374696F6E7328292C743D655B652E6C656E6774682D315D2C6E3D746869732E5F656469746F722E67';
wwv_flow_imp.g_varchar2_table(29264) := '65744D6F64656C28292E66696E644E6578744D6174636828746869732E736561726368546578742C742E676574456E64506F736974696F6E28292C21312C746869732E6D61746368436173652C746869732E77686F6C65576F72643F746869732E5F6564';
wwv_flow_imp.g_varchar2_table(29265) := '69746F722E6765744F7074696F6E28313331293A6E756C6C2C2131293B72657475726E206E3F6E6577206168286E2E72616E67652E73746172744C696E654E756D6265722C6E2E72616E67652E7374617274436F6C756D6E2C6E2E72616E67652E656E64';
wwv_flow_imp.g_varchar2_table(29266) := '4C696E654E756D6265722C6E2E72616E67652E656E64436F6C756D6E293A6E756C6C7D61646453656C656374696F6E546F50726576696F757346696E644D6174636828297B69662821746869732E5F656469746F722E6861734D6F64656C282929726574';
wwv_flow_imp.g_varchar2_table(29267) := '75726E206E756C6C3B636F6E737420653D746869732E5F67657450726576696F75734D6174636828293B69662821652972657475726E206E756C6C3B636F6E737420743D746869732E5F656469746F722E67657453656C656374696F6E7328293B726574';
wwv_flow_imp.g_varchar2_table(29268) := '75726E206E657720433728742E636F6E6361742865292C652C30297D6D6F766553656C656374696F6E546F50726576696F757346696E644D6174636828297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E206E75';
wwv_flow_imp.g_varchar2_table(29269) := '6C6C3B636F6E737420653D746869732E5F67657450726576696F75734D6174636828293B69662821652972657475726E206E756C6C3B636F6E737420743D746869732E5F656469746F722E67657453656C656374696F6E7328293B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(29270) := '7720433728742E736C69636528302C742E6C656E6774682D31292E636F6E6361742865292C652C30297D5F67657450726576696F75734D6174636828297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(29271) := '6C3B696628746869732E63757272656E744D61746368297B636F6E737420653D746869732E63757272656E744D617463683B72657475726E20746869732E63757272656E744D617463683D6E756C6C2C657D746869732E66696E64436F6E74726F6C6C65';
wwv_flow_imp.g_varchar2_table(29272) := '722E686967686C6967687446696E644F7074696F6E7328293B636F6E737420653D746869732E5F656469746F722E67657453656C656374696F6E7328292C743D655B652E6C656E6774682D315D2C6E3D746869732E5F656469746F722E6765744D6F6465';
wwv_flow_imp.g_varchar2_table(29273) := '6C28292E66696E6450726576696F75734D6174636828746869732E736561726368546578742C742E6765745374617274506F736974696F6E28292C21312C746869732E6D61746368436173652C746869732E77686F6C65576F72643F746869732E5F6564';
wwv_flow_imp.g_varchar2_table(29274) := '69746F722E6765744F7074696F6E28313331293A6E756C6C2C2131293B72657475726E206E3F6E6577206168286E2E72616E67652E73746172744C696E654E756D6265722C6E2E72616E67652E7374617274436F6C756D6E2C6E2E72616E67652E656E64';
wwv_flow_imp.g_varchar2_table(29275) := '4C696E654E756D6265722C6E2E72616E67652E656E64436F6C756D6E293A6E756C6C7D73656C656374416C6C2865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E5B5D3B746869732E66696E64436F6E74726F';
wwv_flow_imp.g_varchar2_table(29276) := '6C6C65722E686967686C6967687446696E644F7074696F6E7328293B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28293B72657475726E20653F742E66696E644D61746368657328746869732E736561726368546578742C65';
wwv_flow_imp.g_varchar2_table(29277) := '2C21312C746869732E6D61746368436173652C746869732E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C2C21312C31303733373431383234293A742E66696E644D6174636865732874686973';
wwv_flow_imp.g_varchar2_table(29278) := '2E736561726368546578742C21302C21312C746869732E6D61746368436173652C746869732E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C2C21312C31303733373431383234297D7D636C61';
wwv_flow_imp.g_varchar2_table(29279) := '737320783720657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E2878372E4944297D636F6E7374727563746F722865297B737570657228292C746869732E5F73657373696F6E44';
wwv_flow_imp.g_varchar2_table(29280) := '6973706F73653D746869732E5F7265676973746572286E6577206174292C746869732E5F656469746F723D652C746869732E5F69676E6F726553656C656374696F6E4368616E67653D21312C746869732E5F73657373696F6E3D6E756C6C7D646973706F';
wwv_flow_imp.g_varchar2_table(29281) := '736528297B746869732E5F656E6453657373696F6E28292C73757065722E646973706F736528297D5F626567696E53657373696F6E49664E65656465642865297B69662821746869732E5F73657373696F6E297B636F6E737420743D53372E6372656174';
wwv_flow_imp.g_varchar2_table(29282) := '6528746869732E5F656469746F722C65293B69662821742972657475726E3B746869732E5F73657373696F6E3D743B636F6E7374206E3D7B736561726368537472696E673A746869732E5F73657373696F6E2E736561726368546578747D3B746869732E';
wwv_flow_imp.g_varchar2_table(29283) := '5F73657373696F6E2E6973446973636F6E6E656374656446726F6D46696E64436F6E74726F6C6C65722626286E2E77686F6C65576F72644F766572726964653D312C6E2E6D61746368436173654F766572726964653D312C6E2E697352656765784F7665';
wwv_flow_imp.g_varchar2_table(29284) := '72726964653D32292C652E676574537461746528292E6368616E6765286E2C2131292C746869732E5F73657373696F6E446973706F73652E61646428746869732E5F656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E28';
wwv_flow_imp.g_varchar2_table(29285) := '28653D3E7B746869732E5F69676E6F726553656C656374696F6E4368616E67657C7C746869732E5F656E6453657373696F6E28297D2929292C746869732E5F73657373696F6E446973706F73652E61646428746869732E5F656469746F722E6F6E446964';
wwv_flow_imp.g_varchar2_table(29286) := '426C7572456469746F7254657874282828293D3E7B746869732E5F656E6453657373696F6E28297D2929292C746869732E5F73657373696F6E446973706F73652E61646428652E676574537461746528292E6F6E46696E645265706C6163655374617465';
wwv_flow_imp.g_varchar2_table(29287) := '4368616E67652828653D3E7B28652E6D61746368436173657C7C652E77686F6C65576F7264292626746869732E5F656E6453657373696F6E28297D2929297D7D5F656E6453657373696F6E28297B696628746869732E5F73657373696F6E446973706F73';
wwv_flow_imp.g_varchar2_table(29288) := '652E636C65617228292C746869732E5F73657373696F6E2626746869732E5F73657373696F6E2E6973446973636F6E6E656374656446726F6D46696E64436F6E74726F6C6C6572297B636F6E737420653D7B77686F6C65576F72644F766572726964653A';
wwv_flow_imp.g_varchar2_table(29289) := '302C6D61746368436173654F766572726964653A302C697352656765784F766572726964653A307D3B746869732E5F73657373696F6E2E66696E64436F6E74726F6C6C65722E676574537461746528292E6368616E676528652C2131297D746869732E5F';
wwv_flow_imp.g_varchar2_table(29290) := '73657373696F6E3D6E756C6C7D5F73657453656C656374696F6E732865297B746869732E5F69676E6F726553656C656374696F6E4368616E67653D21302C746869732E5F656469746F722E73657453656C656374696F6E732865292C746869732E5F6967';
wwv_flow_imp.g_varchar2_table(29291) := '6E6F726553656C656374696F6E4368616E67653D21317D5F657870616E64456D707479546F576F726428652C74297B69662821742E6973456D70747928292972657475726E20743B636F6E7374206E3D746869732E5F656469746F722E676574436F6E66';
wwv_flow_imp.g_varchar2_table(29292) := '696775726564576F72644174506F736974696F6E28742E6765745374617274506F736974696F6E2829293B72657475726E206E3F6E657720616828742E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2C742E73746172744C69';
wwv_flow_imp.g_varchar2_table(29293) := '6E654E756D6265722C6E2E656E64436F6C756D6E293A747D5F6170706C7953657373696F6E526573756C742865297B65262628746869732E5F73657453656C656374696F6E7328652E73656C656374696F6E73292C652E72657665616C52616E67652626';
wwv_flow_imp.g_varchar2_table(29294) := '746869732E5F656469746F722E72657665616C52616E6765496E43656E74657249664F75747369646556696577706F727428652E72657665616C52616E67652C652E72657665616C5363726F6C6C5479706529297D67657453657373696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(29295) := '657475726E20746869732E5F73657373696F6E7D61646453656C656374696F6E546F4E65787446696E644D617463682865297B696628746869732E5F656469746F722E6861734D6F64656C2829297B69662821746869732E5F73657373696F6E297B636F';
wwv_flow_imp.g_varchar2_table(29296) := '6E737420743D746869732E5F656469746F722E67657453656C656374696F6E7328293B696628742E6C656E6774683E31297B636F6E7374206E3D652E676574537461746528292E6D61746368436173653B69662821443728746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(29297) := '2E6765744D6F64656C28292C742C6E29297B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28292C6E3D5B5D3B666F72286C657420693D302C6F3D742E6C656E6774683B693C6F3B692B2B296E5B695D3D746869732E5F657870';
wwv_flow_imp.g_varchar2_table(29298) := '616E64456D707479546F576F726428652C745B695D293B72657475726E20766F696420746869732E5F656469746F722E73657453656C656374696F6E73286E297D7D7D746869732E5F626567696E53657373696F6E49664E65656465642865292C746869';
wwv_flow_imp.g_varchar2_table(29299) := '732E5F73657373696F6E2626746869732E5F6170706C7953657373696F6E526573756C7428746869732E5F73657373696F6E2E61646453656C656374696F6E546F4E65787446696E644D617463682829297D7D61646453656C656374696F6E546F507265';
wwv_flow_imp.g_varchar2_table(29300) := '76696F757346696E644D617463682865297B746869732E5F626567696E53657373696F6E49664E65656465642865292C746869732E5F73657373696F6E2626746869732E5F6170706C7953657373696F6E526573756C7428746869732E5F73657373696F';
wwv_flow_imp.g_varchar2_table(29301) := '6E2E61646453656C656374696F6E546F50726576696F757346696E644D617463682829297D6D6F766553656C656374696F6E546F4E65787446696E644D617463682865297B746869732E5F626567696E53657373696F6E49664E65656465642865292C74';
wwv_flow_imp.g_varchar2_table(29302) := '6869732E5F73657373696F6E2626746869732E5F6170706C7953657373696F6E526573756C7428746869732E5F73657373696F6E2E6D6F766553656C656374696F6E546F4E65787446696E644D617463682829297D6D6F766553656C656374696F6E546F';
wwv_flow_imp.g_varchar2_table(29303) := '50726576696F757346696E644D617463682865297B746869732E5F626567696E53657373696F6E49664E65656465642865292C746869732E5F73657373696F6E2626746869732E5F6170706C7953657373696F6E526573756C7428746869732E5F736573';
wwv_flow_imp.g_varchar2_table(29304) := '73696F6E2E6D6F766553656C656374696F6E546F50726576696F757346696E644D617463682829297D73656C656374416C6C2865297B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B6C657420743D6E756C6C3B';
wwv_flow_imp.g_varchar2_table(29305) := '636F6E7374206E3D652E676574537461746528293B6966286E2E697352657665616C656426266E2E736561726368537472696E672E6C656E6774683E3026266E2E69735265676578297B636F6E737420653D746869732E5F656469746F722E6765744D6F';
wwv_flow_imp.g_varchar2_table(29306) := '64656C28293B743D6E2E73656172636853636F70653F652E66696E644D617463686573286E2E736561726368537472696E672C6E2E73656172636853636F70652C6E2E697352656765782C6E2E6D61746368436173652C6E2E77686F6C65576F72643F74';
wwv_flow_imp.g_varchar2_table(29307) := '6869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C2C21312C31303733373431383234293A652E66696E644D617463686573286E2E736561726368537472696E672C21302C6E2E697352656765782C6E2E6D6174636843617365';
wwv_flow_imp.g_varchar2_table(29308) := '2C6E2E77686F6C65576F72643F746869732E5F656469746F722E6765744F7074696F6E28313331293A6E756C6C2C21312C31303733373431383234297D656C73657B696628746869732E5F626567696E53657373696F6E49664E65656465642865292C21';
wwv_flow_imp.g_varchar2_table(29309) := '746869732E5F73657373696F6E2972657475726E3B743D746869732E5F73657373696F6E2E73656C656374416C6C286E2E73656172636853636F7065297D696628742E6C656E6774683E30297B636F6E737420653D746869732E5F656469746F722E6765';
wwv_flow_imp.g_varchar2_table(29310) := '7453656C656374696F6E28293B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D745B6E5D3B696628692E72616E67652E696E7465727365637452616E676573286529297B745B6E5D3D745B305D2C74';
wwv_flow_imp.g_varchar2_table(29311) := '5B305D3D693B627265616B7D7D746869732E5F73657453656C656374696F6E7328742E6D61702828653D3E6E657720616828652E72616E67652E73746172744C696E654E756D6265722C652E72616E67652E7374617274436F6C756D6E2C652E72616E67';
wwv_flow_imp.g_varchar2_table(29312) := '652E656E644C696E654E756D6265722C652E72616E67652E656E64436F6C756D6E292929297D7D7D78372E49443D22656469746F722E636F6E747269622E6D756C7469437572736F72436F6E74726F6C6C6572223B636C617373206B3720657874656E64';
wwv_flow_imp.g_varchar2_table(29313) := '732055647B72756E28652C74297B636F6E7374206E3D78372E6765742874293B696628216E2972657475726E3B636F6E737420693D742E5F676574566965774D6F64656C28293B69662869297B636F6E7374206F3D692E676574437572736F7253746174';
wwv_flow_imp.g_varchar2_table(29314) := '657328292C733D24302E6765742874293B6966287329746869732E5F72756E286E2C73293B656C73657B636F6E737420693D652E676574287563292E637265617465496E7374616E63652824302C74293B746869732E5F72756E286E2C69292C692E6469';
wwv_flow_imp.g_varchar2_table(29315) := '73706F736528297D7737286F2C692E676574437572736F725374617465732829297D7D7D636C6173732045377B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F6D6F64656C3D652C746869732E5F736561726368546578743D74';
wwv_flow_imp.g_varchar2_table(29316) := '2C746869732E5F6D61746368436173653D6E2C746869732E5F776F7264536570617261746F72733D692C746869732E5F6D6F64656C56657273696F6E49643D746869732E5F6D6F64656C2E67657456657273696F6E496428292C746869732E5F63616368';
wwv_flow_imp.g_varchar2_table(29317) := '656446696E644D6174636865733D6E756C6C2C6F2626746869732E5F6D6F64656C3D3D3D6F2E5F6D6F64656C2626746869732E5F736561726368546578743D3D3D6F2E5F736561726368546578742626746869732E5F6D61746368436173653D3D3D6F2E';
wwv_flow_imp.g_varchar2_table(29318) := '5F6D61746368436173652626746869732E5F776F7264536570617261746F72733D3D3D6F2E5F776F7264536570617261746F72732626746869732E5F6D6F64656C56657273696F6E49643D3D3D6F2E5F6D6F64656C56657273696F6E4964262628746869';
wwv_flow_imp.g_varchar2_table(29319) := '732E5F63616368656446696E644D6174636865733D6F2E5F63616368656446696E644D617463686573297D66696E644D61746368657328297B72657475726E206E756C6C3D3D3D746869732E5F63616368656446696E644D617463686573262628746869';
wwv_flow_imp.g_varchar2_table(29320) := '732E5F63616368656446696E644D6174636865733D746869732E5F6D6F64656C2E66696E644D61746368657328746869732E5F736561726368546578742C21302C21312C746869732E5F6D61746368436173652C746869732E5F776F7264536570617261';
wwv_flow_imp.g_varchar2_table(29321) := '746F72732C2131292E6D61702828653D3E652E72616E676529292C746869732E5F63616368656446696E644D6174636865732E736F72742872682E636F6D7061726552616E6765735573696E6753746172747329292C746869732E5F6361636865644669';
wwv_flow_imp.g_varchar2_table(29322) := '6E644D6174636865737D7D6C6574204C373D79373D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6C616E67756167654665617475726573536572766963653D742C746869732E';
wwv_flow_imp.g_varchar2_table(29323) := '656469746F723D652C746869732E5F6973456E61626C65643D652E6765744F7074696F6E28313038292C746869732E5F6465636F726174696F6E733D652E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E757064';
wwv_flow_imp.g_varchar2_table(29324) := '617465536F6F6E3D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F7570646174652829292C33303029292C746869732E73746174653D6E756C6C2C746869732E5F726567697374657228652E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(29325) := '65436F6E66696775726174696F6E2828743D3E7B746869732E5F6973456E61626C65643D652E6765744F7074696F6E28313038297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E6765437572736F7253656C656374696F6E';
wwv_flow_imp.g_varchar2_table(29326) := '2828653D3E7B746869732E5F6973456E61626C6564262628652E73656C656374696F6E2E6973456D70747928293F333D3D3D652E726561736F6E3F28746869732E73746174652626746869732E5F7365745374617465286E756C6C292C746869732E7570';
wwv_flow_imp.g_varchar2_table(29327) := '64617465536F6F6E2E7363686564756C652829293A746869732E5F7365745374617465286E756C6C293A746869732E5F7570646174652829297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C2828653D3E';
wwv_flow_imp.g_varchar2_table(29328) := '7B746869732E5F7365745374617465286E756C6C297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E5F6973456E61626C65642626746869732E757064617465';
wwv_flow_imp.g_varchar2_table(29329) := '536F6F6E2E7363686564756C6528297D2929293B636F6E7374206E3D24302E6765742865293B6E2626746869732E5F7265676973746572286E2E676574537461746528292E6F6E46696E645265706C61636553746174654368616E67652828653D3E7B74';
wwv_flow_imp.g_varchar2_table(29330) := '6869732E5F75706461746528297D2929292C746869732E757064617465536F6F6E2E7363686564756C6528297D5F75706461746528297B746869732E5F73657453746174652879372E5F637265617465537461746528746869732E73746174652C746869';
wwv_flow_imp.g_varchar2_table(29331) := '732E5F6973456E61626C65642C746869732E656469746F7229297D737461746963205F637265617465537461746528652C742C6E297B69662821742972657475726E206E756C6C3B696628216E2E6861734D6F64656C28292972657475726E206E756C6C';
wwv_flow_imp.g_varchar2_table(29332) := '3B636F6E737420693D6E2E67657453656C656374696F6E28293B696628692E73746172744C696E654E756D626572213D3D692E656E644C696E654E756D6265722972657475726E206E756C6C3B636F6E7374206F3D78372E676574286E293B696628216F';
wwv_flow_imp.g_varchar2_table(29333) := '2972657475726E206E756C6C3B636F6E737420733D24302E676574286E293B69662821732972657475726E206E756C6C3B6C657420723D6F2E67657453657373696F6E2873293B6966282172297B636F6E737420653D6E2E67657453656C656374696F6E';
wwv_flow_imp.g_varchar2_table(29334) := '7328293B696628652E6C656E6774683E31297B636F6E737420743D732E676574537461746528292E6D61746368436173653B696628214437286E2E6765744D6F64656C28292C652C74292972657475726E206E756C6C7D723D53372E637265617465286E';
wwv_flow_imp.g_varchar2_table(29335) := '2C73297D69662821722972657475726E206E756C6C3B696628722E63757272656E744D617463682972657475726E206E756C6C3B6966282F5E5B205C745D2B242F2E7465737428722E73656172636854657874292972657475726E206E756C6C3B696628';
wwv_flow_imp.g_varchar2_table(29336) := '722E736561726368546578742E6C656E6774683E3230302972657475726E206E756C6C3B636F6E737420613D732E676574537461746528292C6C3D612E6D61746368436173653B696628612E697352657665616C6564297B6C657420653D612E73656172';
wwv_flow_imp.g_varchar2_table(29337) := '6368537472696E673B6C7C7C28653D652E746F4C6F776572436173652829293B6C657420743D722E736561726368546578743B6966286C7C7C28743D742E746F4C6F776572436173652829292C653D3D3D742626722E6D61746368436173653D3D3D612E';
wwv_flow_imp.g_varchar2_table(29338) := '6D61746368436173652626722E77686F6C65576F72643D3D3D612E77686F6C65576F7264262621612E697352656765782972657475726E206E756C6C7D72657475726E206E6577204537286E2E6765744D6F64656C28292C722E73656172636854657874';
wwv_flow_imp.g_varchar2_table(29339) := '2C722E6D61746368436173652C722E77686F6C65576F72643F6E2E6765744F7074696F6E28313331293A6E756C6C2C65297D5F73657453746174652865297B696628746869732E73746174653D652C21746869732E73746174652972657475726E20766F';
wwv_flow_imp.g_varchar2_table(29340) := '696420746869732E5F6465636F726174696F6E732E636C65617228293B69662821746869732E656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E656469746F722E6765744D6F64656C28293B696628742E69';
wwv_flow_imp.g_varchar2_table(29341) := '73546F6F4C61726765466F72546F6B656E697A6174696F6E28292972657475726E3B636F6E7374206E3D746869732E73746174652E66696E644D61746368657328292C693D746869732E656469746F722E67657453656C656374696F6E7328293B692E73';
wwv_flow_imp.g_varchar2_table(29342) := '6F72742872682E636F6D7061726552616E6765735573696E67537461727473293B636F6E7374206F3D5B5D3B666F72286C657420653D302C743D302C733D6E2E6C656E6774682C723D692E6C656E6774683B653C733B297B636F6E737420733D6E5B655D';
wwv_flow_imp.g_varchar2_table(29343) := '3B696628743E3D72296F2E707573682873292C652B2B3B656C73657B636F6E7374206E3D72682E636F6D7061726552616E6765735573696E6753746172747328732C695B745D293B6E3C303F2821695B745D2E6973456D7074792829262672682E617265';
wwv_flow_imp.g_varchar2_table(29344) := '496E74657273656374696E6728732C695B745D297C7C6F2E707573682873292C652B2B293A286E3E307C7C652B2B2C742B2B297D7D636F6E737420733D226F666622213D3D746869732E656469746F722E6765744F7074696F6E283831292C723D746869';
wwv_flow_imp.g_varchar2_table(29345) := '732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E74486967686C6967687450726F76696465722E6861732874292626732C613D6F2E6D61702828653D3E287B72616E67653A652C6F7074696F6E733A5F372872297D29';
wwv_flow_imp.g_varchar2_table(29346) := '29293B746869732E5F6465636F726174696F6E732E7365742861297D646973706F736528297B746869732E5F7365745374617465286E756C6C292C73757065722E646973706F736528297D7D3B66756E6374696F6E20443728652C742C6E297B636F6E73';
wwv_flow_imp.g_varchar2_table(29347) := '7420693D543728652C745B305D2C216E293B666F72286C6574206F3D312C733D742E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D745B6F5D3B696628732E6973456D70747928292972657475726E21313B69662869213D3D543728652C73';
wwv_flow_imp.g_varchar2_table(29348) := '2C216E292972657475726E21317D72657475726E21307D66756E6374696F6E20543728652C742C6E297B636F6E737420693D652E67657456616C7565496E52616E67652874293B72657475726E206E3F692E746F4C6F7765724361736528293A697D4C37';
wwv_flow_imp.g_varchar2_table(29349) := '2E49443D22656469746F722E636F6E747269622E73656C656374696F6E486967686C696768746572222C4C373D79373D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E';
wwv_flow_imp.g_varchar2_table(29350) := '756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F6620526566';
wwv_flow_imp.g_varchar2_table(29351) := '6C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A';
wwv_flow_imp.g_varchar2_table(29352) := '733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E637469';
wwv_flow_imp.g_varchar2_table(29353) := '6F6E286E2C69297B74286E2C692C65297D7D28312C7878295D2C4C37292C4A642878372E49442C78372C34292C4A64284C372E49442C4C372C31292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B737570657228';
wwv_flow_imp.g_varchar2_table(29354) := '7B69643A22656469746F722E616374696F6E2E696E73657274437572736F7241626F7665222C6C6162656C3A6228302C2241646420437572736F722041626F766522292C616C6961733A2241646420437572736F722041626F7665222C707265636F6E64';
wwv_flow_imp.g_varchar2_table(29355) := '6974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A323537362C6C696E75783A7B7072696D6172793A313535322C7365636F6E646172793A5B333038385D7D2C7765';
wwv_flow_imp.g_varchar2_table(29356) := '696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22335F6D756C7469222C7469746C653A6228302C22262641646420437572736F722041626F766522292C6F';
wwv_flow_imp.g_varchar2_table(29357) := '726465723A327D7D297D72756E28652C742C6E297B69662821742E6861734D6F64656C28292972657475726E3B6C657420693D21303B6E262621313D3D3D6E2E6C6F676963616C4C696E65262628693D2131293B636F6E7374206F3D742E5F6765745669';
wwv_flow_imp.g_varchar2_table(29358) := '65774D6F64656C28293B6966286F2E637572736F72436F6E6669672E726561644F6E6C792972657475726E3B6F2E6D6F64656C2E70757368537461636B456C656D656E7428293B636F6E737420733D6F2E676574437572736F7253746174657328293B6F';
wwv_flow_imp.g_varchar2_table(29359) := '2E736574437572736F72537461746573286E2E736F757263652C332C67532E616464437572736F725570286F2C732C6929292C6F2E72657665616C546F704D6F7374437572736F72286E2E736F75726365292C773728732C6F2E676574437572736F7253';
wwv_flow_imp.g_varchar2_table(29360) := '74617465732829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E696E73657274437572736F7242656C6F77222C6C6162656C3A6228302C';
wwv_flow_imp.g_varchar2_table(29361) := '2241646420437572736F722042656C6F7722292C616C6961733A2241646420437572736F722042656C6F77222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C70';
wwv_flow_imp.g_varchar2_table(29362) := '72696D6172793A323537382C6C696E75783A7B7072696D6172793A313535342C7365636F6E646172793A5B333039305D7D2C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D65';
wwv_flow_imp.g_varchar2_table(29363) := '6E752C67726F75703A22335F6D756C7469222C7469746C653A6228302C22412626646420437572736F722042656C6F7722292C6F726465723A337D7D297D72756E28652C742C6E297B69662821742E6861734D6F64656C28292972657475726E3B6C6574';
wwv_flow_imp.g_varchar2_table(29364) := '20693D21303B6E262621313D3D3D6E2E6C6F676963616C4C696E65262628693D2131293B636F6E7374206F3D742E5F676574566965774D6F64656C28293B6966286F2E637572736F72436F6E6669672E726561644F6E6C792972657475726E3B6F2E6D6F';
wwv_flow_imp.g_varchar2_table(29365) := '64656C2E70757368537461636B456C656D656E7428293B636F6E737420733D6F2E676574437572736F7253746174657328293B6F2E736574437572736F72537461746573286E2E736F757263652C332C67532E616464437572736F72446F776E286F2C73';
wwv_flow_imp.g_varchar2_table(29366) := '2C6929292C6F2E72657665616C426F74746F6D4D6F7374437572736F72286E2E736F75726365292C773728732C6F2E676574437572736F725374617465732829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(29367) := '28297B7375706572287B69643A22656469746F722E616374696F6E2E696E73657274437572736F724174456E644F66456163684C696E6553656C6563746564222C6C6162656C3A6228302C2241646420437572736F727320746F204C696E6520456E6473';
wwv_flow_imp.g_varchar2_table(29368) := '22292C616C6961733A2241646420437572736F727320746F204C696E6520456E6473222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A3135';
wwv_flow_imp.g_varchar2_table(29369) := '37352C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22335F6D756C7469222C7469746C653A6228302C22416464204326267572736F727320746F20';
wwv_flow_imp.g_varchar2_table(29370) := '4C696E6520456E647322292C6F726465723A347D7D297D676574437572736F7273466F7253656C656374696F6E28652C742C6E297B69662821652E6973456D7074792829297B666F72286C657420693D652E73746172744C696E654E756D6265723B693C';
wwv_flow_imp.g_varchar2_table(29371) := '652E656E644C696E654E756D6265723B692B2B297B636F6E737420653D742E6765744C696E654D6178436F6C756D6E2869293B6E2E70757368286E657720616828692C652C692C6529297D652E656E64436F6C756D6E3E3126266E2E70757368286E6577';
wwv_flow_imp.g_varchar2_table(29372) := '20616828652E656E644C696E654E756D6265722C652E656E64436F6C756D6E2C652E656E644C696E654E756D6265722C652E656E64436F6C756D6E29297D7D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E73';
wwv_flow_imp.g_varchar2_table(29373) := '74206E3D742E6765744D6F64656C28292C693D742E67657453656C656374696F6E7328292C6F3D742E5F676574566965774D6F64656C28292C733D6F2E676574437572736F7253746174657328292C723D5B5D3B692E666F72456163682828653D3E7468';
wwv_flow_imp.g_varchar2_table(29374) := '69732E676574437572736F7273466F7253656C656374696F6E28652C6E2C722929292C722E6C656E6774683E302626742E73657453656C656374696F6E732872292C773728732C6F2E676574437572736F725374617465732829297D7D292C5A6428636C';
wwv_flow_imp.g_varchar2_table(29375) := '61737320657874656E6473206B377B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E61646453656C656374696F6E546F4E65787446696E644D61746368222C6C6162656C3A6228302C22416464205365';
wwv_flow_imp.g_varchar2_table(29376) := '6C656374696F6E20546F204E6578742046696E64204D6174636822292C616C6961733A224164642053656C656374696F6E20546F204E6578742046696E64204D61746368222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62';
wwv_flow_imp.g_varchar2_table(29377) := '457870723A6C682E666F6375732C7072696D6172793A323038322C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22335F6D756C7469222C7469746C';
wwv_flow_imp.g_varchar2_table(29378) := '653A6228302C224164642026264E657874204F6363757272656E636522292C6F726465723A357D7D297D5F72756E28652C74297B652E61646453656C656374696F6E546F4E65787446696E644D617463682874297D7D292C5A6428636C61737320657874';
wwv_flow_imp.g_varchar2_table(29379) := '656E6473206B377B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E61646453656C656374696F6E546F50726576696F757346696E644D61746368222C6C6162656C3A6228302C224164642053656C6563';
wwv_flow_imp.g_varchar2_table(29380) := '74696F6E20546F2050726576696F75732046696E64204D6174636822292C616C6961733A224164642053656C656374696F6E20546F2050726576696F75732046696E64204D61746368222C707265636F6E646974696F6E3A766F696420302C6D656E754F';
wwv_flow_imp.g_varchar2_table(29381) := '7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22335F6D756C7469222C7469746C653A6228302C2241646420502626726576696F7573204F6363757272656E636522292C6F726465723A367D7D';
wwv_flow_imp.g_varchar2_table(29382) := '297D5F72756E28652C74297B652E61646453656C656374696F6E546F50726576696F757346696E644D617463682874297D7D292C5A6428636C61737320657874656E6473206B377B636F6E7374727563746F7228297B7375706572287B69643A22656469';
wwv_flow_imp.g_varchar2_table(29383) := '746F722E616374696F6E2E6D6F766553656C656374696F6E546F4E65787446696E644D61746368222C6C6162656C3A6228302C224D6F7665204C6173742053656C656374696F6E20546F204E6578742046696E64204D6174636822292C616C6961733A22';
wwv_flow_imp.g_varchar2_table(29384) := '4D6F7665204C6173742053656C656374696F6E20546F204E6578742046696E64204D61746368222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A536528323038392C';
wwv_flow_imp.g_varchar2_table(29385) := '32303832292C7765696768743A3130307D7D297D5F72756E28652C74297B652E6D6F766553656C656374696F6E546F4E65787446696E644D617463682874297D7D292C5A6428636C61737320657874656E6473206B377B636F6E7374727563746F722829';
wwv_flow_imp.g_varchar2_table(29386) := '7B7375706572287B69643A22656469746F722E616374696F6E2E6D6F766553656C656374696F6E546F50726576696F757346696E644D61746368222C6C6162656C3A6228302C224D6F7665204C6173742053656C656374696F6E20546F2050726576696F';
wwv_flow_imp.g_varchar2_table(29387) := '75732046696E64204D6174636822292C616C6961733A224D6F7665204C6173742053656C656374696F6E20546F2050726576696F75732046696E64204D61746368222C707265636F6E646974696F6E3A766F696420307D297D5F72756E28652C74297B65';
wwv_flow_imp.g_varchar2_table(29388) := '2E6D6F766553656C656374696F6E546F50726576696F757346696E644D617463682874297D7D292C5A6428636C61737320657874656E6473206B377B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73';
wwv_flow_imp.g_varchar2_table(29389) := '656C656374486967686C6967687473222C6C6162656C3A6228302C2253656C65637420416C6C204F6363757272656E636573206F662046696E64204D6174636822292C616C6961733A2253656C65637420416C6C204F6363757272656E636573206F6620';
wwv_flow_imp.g_varchar2_table(29390) := '46696E64204D61746368222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A333131342C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C64';
wwv_flow_imp.g_varchar2_table(29391) := '2E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22335F6D756C7469222C7469746C653A6228302C2253656C65637420416C6C2026264F6363757272656E63657322292C6F726465723A377D7D297D5F72756E28652C74297B652E73';
wwv_flow_imp.g_varchar2_table(29392) := '656C656374416C6C2874297D7D292C5A6428636C61737320657874656E6473206B377B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E6368616E6765416C6C222C6C6162656C3A6228302C224368616E';
wwv_flow_imp.g_varchar2_table(29393) := '676520416C6C204F6363757272656E63657322292C616C6961733A224368616E676520416C6C204F6363757272656E636573222C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6C682E656469746F7254657874466F63';
wwv_flow_imp.g_varchar2_table(29394) := '7573292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A323130382C7765696768743A3130307D2C636F6E746578744D656E754F7074733A7B67726F75703A22315F6D6F64696669636174696F';
wwv_flow_imp.g_varchar2_table(29395) := '6E222C6F726465723A312E327D7D297D5F72756E28652C74297B652E73656C656374416C6C2874297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E61637469';
wwv_flow_imp.g_varchar2_table(29396) := '6F6E2E616464437572736F7273546F426F74746F6D222C6C6162656C3A6228302C2241646420437572736F727320546F20426F74746F6D22292C616C6961733A2241646420437572736F727320546F20426F74746F6D222C707265636F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(29397) := '3A766F696420307D297D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E3D742E67657453656C656374696F6E7328292C693D742E6765744D6F64656C28292E6765744C696E65436F756E7428292C6F';
wwv_flow_imp.g_varchar2_table(29398) := '3D5B5D3B666F72286C657420653D6E5B305D2E73746172744C696E654E756D6265723B653C3D693B652B2B296F2E70757368286E657720616828652C6E5B305D2E7374617274436F6C756D6E2C652C6E5B305D2E656E64436F6C756D6E29293B636F6E73';
wwv_flow_imp.g_varchar2_table(29399) := '7420733D742E5F676574566965774D6F64656C28292C723D732E676574437572736F7253746174657328293B6F2E6C656E6774683E302626742E73657453656C656374696F6E73286F292C773728722C732E676574437572736F72537461746573282929';
wwv_flow_imp.g_varchar2_table(29400) := '7D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E616464437572736F7273546F546F70222C6C6162656C3A6228302C2241646420437572736F';
wwv_flow_imp.g_varchar2_table(29401) := '727320546F20546F7022292C616C6961733A2241646420437572736F727320546F20546F70222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E737420';
wwv_flow_imp.g_varchar2_table(29402) := '6E3D742E67657453656C656374696F6E7328292C693D5B5D3B666F72286C657420653D6E5B305D2E73746172744C696E654E756D6265723B653E3D313B652D2D29692E70757368286E657720616828652C6E5B305D2E7374617274436F6C756D6E2C652C';
wwv_flow_imp.g_varchar2_table(29403) := '6E5B305D2E656E64436F6C756D6E29293B636F6E7374206F3D742E5F676574566965774D6F64656C28292C733D6F2E676574437572736F7253746174657328293B692E6C656E6774683E302626742E73657453656C656374696F6E732869292C77372873';
wwv_flow_imp.g_varchar2_table(29404) := '2C6F2E676574437572736F725374617465732829297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F6375734E657874437572736F7222';
wwv_flow_imp.g_varchar2_table(29405) := '2C6C6162656C3A6228302C22466F637573204E65787420437572736F7222292C6D657461646174613A7B6465736372697074696F6E3A6228302C22466F637573657320746865206E65787420637572736F7222292C617267733A5B5D7D2C616C6961733A';
wwv_flow_imp.g_varchar2_table(29406) := '22466F637573204E65787420437572736F72222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C742C6E297B69662821742E6861734D6F64656C28292972657475726E3B636F6E737420693D742E5F676574566965774D6F64656C';
wwv_flow_imp.g_varchar2_table(29407) := '28293B696628692E637572736F72436F6E6669672E726561644F6E6C792972657475726E3B692E6D6F64656C2E70757368537461636B456C656D656E7428293B636F6E7374206F3D41727261792E66726F6D28692E676574437572736F72537461746573';
wwv_flow_imp.g_varchar2_table(29408) := '2829292C733D6F2E736869667428293B732626286F2E707573682873292C692E736574437572736F72537461746573286E2E736F757263652C332C6F292C692E72657665616C5072696D617279437572736F72286E2E736F757263652C2130292C773728';
wwv_flow_imp.g_varchar2_table(29409) := '6F2C692E676574437572736F72537461746573282929297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F63757350726576696F757343';
wwv_flow_imp.g_varchar2_table(29410) := '7572736F72222C6C6162656C3A6228302C22466F6375732050726576696F757320437572736F7222292C6D657461646174613A7B6465736372697074696F6E3A6228302C22466F6375736573207468652070726576696F757320637572736F7222292C61';
wwv_flow_imp.g_varchar2_table(29411) := '7267733A5B5D7D2C616C6961733A22466F6375732050726576696F757320437572736F72222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C742C6E297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(29412) := '20693D742E5F676574566965774D6F64656C28293B696628692E637572736F72436F6E6669672E726561644F6E6C792972657475726E3B692E6D6F64656C2E70757368537461636B456C656D656E7428293B636F6E7374206F3D41727261792E66726F6D';
wwv_flow_imp.g_varchar2_table(29413) := '28692E676574437572736F725374617465732829292C733D6F2E706F7028293B732626286F2E756E73686966742873292C692E736574437572736F72537461746573286E2E736F757263652C332C6F292C692E72657665616C5072696D61727943757273';
wwv_flow_imp.g_varchar2_table(29414) := '6F72286E2E736F757263652C2130292C7737286F2C692E676574437572736F72537461746573282929297D7D293B636F6E73742049373D7B56697369626C653A6E6577206C642822706172616D6574657248696E747356697369626C65222C2131292C4D';
wwv_flow_imp.g_varchar2_table(29415) := '756C7469706C655369676E6174757265733A6E6577206C642822706172616D6574657248696E74734D756C7469706C655369676E617475726573222C2131297D3B6173796E632066756E6374696F6E204D3728652C742C6E2C692C6F297B636F6E737420';
wwv_flow_imp.g_varchar2_table(29416) := '733D652E6F7264657265642874293B666F7228636F6E73742065206F662073297472797B636F6E737420733D617761697420652E70726F766964655369676E617475726548656C7028742C6E2C6F2C69293B696628732972657475726E20737D63617463';
wwv_flow_imp.g_varchar2_table(29417) := '682865297B45652865297D7D7661722041373B6B632E7265676973746572436F6D6D616E6428225F657865637574655369676E617475726548656C7050726F7669646572222C286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E2C692C6F5D3D';
wwv_flow_imp.g_varchar2_table(29418) := '743B796C284E6F2E6973557269286E29292C796C286D632E697349506F736974696F6E286929292C796C2822737472696E67223D3D747970656F66206F7C7C216F293B636F6E737420733D652E676574287878292C723D617761697420652E6765742876';
wwv_flow_imp.g_varchar2_table(29419) := '63292E6372656174654D6F64656C5265666572656E6365286E293B7472797B636F6E737420653D6177616974204D3728732E7369676E617475726548656C7050726F76696465722C722E6F626A6563742E74657874456469746F724D6F64656C2C6D632E';
wwv_flow_imp.g_varchar2_table(29420) := '6C6966742869292C7B747269676765724B696E643A53772E496E766F6B652C69735265747269676765723A21312C747269676765724368617261637465723A6F7D2C4D742E4E6F6E65293B69662821652972657475726E3B72657475726E207365745469';
wwv_flow_imp.g_varchar2_table(29421) := '6D656F7574282828293D3E652E646973706F73652829292C30292C652E76616C75657D66696E616C6C797B722E646973706F736528297D7D29292C66756E6374696F6E2865297B652E44656661756C743D7B747970653A307D2C652E50656E64696E673D';
wwv_flow_imp.g_varchar2_table(29422) := '636C6173737B636F6E7374727563746F7228652C74297B746869732E726571756573743D652C746869732E70726576696F75736C7941637469766548696E74733D742C746869732E747970653D327D7D2C652E4163746976653D636C6173737B636F6E73';
wwv_flow_imp.g_varchar2_table(29423) := '74727563746F722865297B746869732E68696E74733D652C746869732E747970653D317D7D7D2841377C7C2841373D7B7D29293B636C617373204E3720657874656E6473206C747B636F6E7374727563746F7228652C742C6E3D4E372E44454641554C54';
wwv_flow_imp.g_varchar2_table(29424) := '5F44454C4159297B737570657228292C746869732E5F6F6E4368616E67656448696E74733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4368616E67656448696E74733D746869732E5F6F6E4368616E67656448696E7473';
wwv_flow_imp.g_varchar2_table(29425) := '2E6576656E742C746869732E747269676765724F6E547970653D21312C746869732E5F73746174653D41372E44656661756C742C746869732E5F70656E64696E6754726967676572733D5B5D2C746869732E5F6C6173745369676E617475726548656C70';
wwv_flow_imp.g_varchar2_table(29426) := '526573756C743D746869732E5F7265676973746572286E6577206374292C746869732E7472696767657243686172733D6E6577204B792C746869732E72657472696767657243686172733D6E6577204B792C746869732E7472696767657249643D302C74';
wwv_flow_imp.g_varchar2_table(29427) := '6869732E656469746F723D652C746869732E70726F7669646572733D742C746869732E7468726F74746C656444656C617965723D6E6577207A74286E292C746869732E5F726567697374657228746869732E656469746F722E6F6E446964426C75724564';
wwv_flow_imp.g_varchar2_table(29428) := '69746F72576964676574282828293D3E746869732E63616E63656C28292929292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E282828293D3E746869732E6F6E456469';
wwv_flow_imp.g_varchar2_table(29429) := '746F72436F6E66696775726174696F6E4368616E676528292929292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E67654D6F64656C2828653D3E746869732E6F6E4D6F64656C4368616E6765642829292929';
wwv_flow_imp.g_varchar2_table(29430) := '2C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E67654D6F64656C4C616E67756167652828653D3E746869732E6F6E4D6F64656C4368616E67656428292929292C746869732E5F726567697374657228746869';
wwv_flow_imp.g_varchar2_table(29431) := '732E656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E2828653D3E746869732E6F6E437572736F724368616E67652865292929292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368';
wwv_flow_imp.g_varchar2_table(29432) := '616E67654D6F64656C436F6E74656E742828653D3E746869732E6F6E4D6F64656C436F6E74656E744368616E676528292929292C746869732E5F726567697374657228746869732E70726F7669646572732E6F6E4469644368616E676528746869732E6F';
wwv_flow_imp.g_varchar2_table(29433) := '6E4D6F64656C4368616E6765642C7468697329292C746869732E5F726567697374657228746869732E656469746F722E6F6E446964547970652828653D3E746869732E6F6E446964547970652865292929292C746869732E6F6E456469746F72436F6E66';
wwv_flow_imp.g_varchar2_table(29434) := '696775726174696F6E4368616E676528292C746869732E6F6E4D6F64656C4368616E67656428297D67657420737461746528297B72657475726E20746869732E5F73746174657D7365742073746174652865297B323D3D3D746869732E5F73746174652E';
wwv_flow_imp.g_varchar2_table(29435) := '747970652626746869732E5F73746174652E726571756573742E63616E63656C28292C746869732E5F73746174653D657D63616E63656C28653D2131297B746869732E73746174653D41372E44656661756C742C746869732E7468726F74746C65644465';
wwv_flow_imp.g_varchar2_table(29436) := '6C617965722E63616E63656C28292C657C7C746869732E5F6F6E4368616E67656448696E74732E6669726528766F69642030297D7472696767657228652C74297B636F6E7374206E3D746869732E656469746F722E6765744D6F64656C28293B69662821';
wwv_flow_imp.g_varchar2_table(29437) := '6E7C7C21746869732E70726F7669646572732E686173286E292972657475726E3B636F6E737420693D2B2B746869732E7472696767657249643B746869732E5F70656E64696E6754726967676572732E707573682865292C746869732E7468726F74746C';
wwv_flow_imp.g_varchar2_table(29438) := '656444656C617965722E74726967676572282828293D3E746869732E646F54726967676572286929292C74292E6361746368286B65297D6E65787428297B69662831213D3D746869732E73746174652E747970652972657475726E3B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(29439) := '746869732E73746174652E68696E74732E7369676E6174757265732E6C656E6774682C743D746869732E73746174652E68696E74732E6163746976655369676E61747572652C6E3D7425653D3D652D312C693D746869732E656469746F722E6765744F70';
wwv_flow_imp.g_varchar2_table(29440) := '74696F6E283836292E6379636C653B2128653C327C7C6E297C7C693F746869732E7570646174654163746976655369676E6174757265286E2626693F303A742B31293A746869732E63616E63656C28297D70726576696F757328297B69662831213D3D74';
wwv_flow_imp.g_varchar2_table(29441) := '6869732E73746174652E747970652972657475726E3B636F6E737420653D746869732E73746174652E68696E74732E7369676E6174757265732E6C656E6774682C743D746869732E73746174652E68696E74732E6163746976655369676E61747572652C';
wwv_flow_imp.g_varchar2_table(29442) := '6E3D303D3D3D742C693D746869732E656469746F722E6765744F7074696F6E283836292E6379636C653B2128653C327C7C6E297C7C693F746869732E7570646174654163746976655369676E6174757265286E2626693F652D313A742D31293A74686973';
wwv_flow_imp.g_varchar2_table(29443) := '2E63616E63656C28297D7570646174654163746976655369676E61747572652865297B313D3D3D746869732E73746174652E74797065262628746869732E73746174653D6E65772041372E416374697665287B2E2E2E746869732E73746174652E68696E';
wwv_flow_imp.g_varchar2_table(29444) := '74732C6163746976655369676E61747572653A657D292C746869732E5F6F6E4368616E67656448696E74732E6669726528746869732E73746174652E68696E747329297D6173796E6320646F547269676765722865297B636F6E737420743D313D3D3D74';
wwv_flow_imp.g_varchar2_table(29445) := '6869732E73746174652E747970657C7C323D3D3D746869732E73746174652E747970652C6E3D746869732E6765744C61737441637469766548696E747328293B696628746869732E63616E63656C282130292C303D3D3D746869732E5F70656E64696E67';
wwv_flow_imp.g_varchar2_table(29446) := '54726967676572732E6C656E6774682972657475726E21313B636F6E737420693D746869732E5F70656E64696E6754726967676572732E726564756365285037293B746869732E5F70656E64696E6754726967676572733D5B5D3B636F6E7374206F3D7B';
wwv_flow_imp.g_varchar2_table(29447) := '747269676765724B696E643A692E747269676765724B696E642C747269676765724368617261637465723A692E747269676765724368617261637465722C69735265747269676765723A742C6163746976655369676E617475726548656C703A6E7D3B69';
wwv_flow_imp.g_varchar2_table(29448) := '662821746869732E656469746F722E6861734D6F64656C28292972657475726E21313B636F6E737420733D746869732E656469746F722E6765744D6F64656C28292C723D746869732E656469746F722E676574506F736974696F6E28293B746869732E73';
wwv_flow_imp.g_varchar2_table(29449) := '746174653D6E65772041372E50656E64696E672846742828653D3E4D3728746869732E70726F7669646572732C732C722C6F2C652929292C6E293B7472797B636F6E737420743D617761697420746869732E73746174652E726571756573743B72657475';
wwv_flow_imp.g_varchar2_table(29450) := '726E2065213D3D746869732E7472696767657249643F286E756C6C3D3D747C7C742E646973706F736528292C2131293A742626742E76616C75652E7369676E617475726573262630213D3D742E76616C75652E7369676E6174757265732E6C656E677468';
wwv_flow_imp.g_varchar2_table(29451) := '3F28746869732E73746174653D6E65772041372E41637469766528742E76616C7565292C746869732E5F6C6173745369676E617475726548656C70526573756C742E76616C75653D742C746869732E5F6F6E4368616E67656448696E74732E6669726528';
wwv_flow_imp.g_varchar2_table(29452) := '746869732E73746174652E68696E7473292C2130293A286E756C6C3D3D747C7C742E646973706F736528292C746869732E5F6C6173745369676E617475726548656C70526573756C742E636C65617228292C746869732E63616E63656C28292C2131297D';
wwv_flow_imp.g_varchar2_table(29453) := '63617463682874297B72657475726E20653D3D3D746869732E747269676765724964262628746869732E73746174653D41372E44656661756C74292C6B652874292C21317D7D6765744C61737441637469766548696E747328297B737769746368287468';
wwv_flow_imp.g_varchar2_table(29454) := '69732E73746174652E74797065297B6361736520313A72657475726E20746869732E73746174652E68696E74733B6361736520323A72657475726E20746869732E73746174652E70726576696F75736C7941637469766548696E74733B64656661756C74';
wwv_flow_imp.g_varchar2_table(29455) := '3A72657475726E7D7D67657420697354726967676572656428297B72657475726E20313D3D3D746869732E73746174652E747970657C7C323D3D3D746869732E73746174652E747970657C7C746869732E7468726F74746C656444656C617965722E6973';
wwv_flow_imp.g_varchar2_table(29456) := '54726967676572656428297D6F6E4D6F64656C4368616E67656428297B746869732E63616E63656C28292C746869732E7472696767657243686172732E636C65617228292C746869732E72657472696767657243686172732E636C65617228293B636F6E';
wwv_flow_imp.g_varchar2_table(29457) := '737420653D746869732E656469746F722E6765744D6F64656C28293B6966286529666F7228636F6E73742074206F6620746869732E70726F7669646572732E6F726465726564286529297B666F7228636F6E73742065206F6620742E7369676E61747572';
wwv_flow_imp.g_varchar2_table(29458) := '6548656C7054726967676572436861726163746572737C7C5B5D29696628652E6C656E677468297B636F6E737420743D652E63686172436F646541742830293B746869732E7472696767657243686172732E6164642874292C746869732E726574726967';
wwv_flow_imp.g_varchar2_table(29459) := '67657243686172732E6164642874297D666F7228636F6E73742065206F6620742E7369676E617475726548656C70526574726967676572436861726163746572737C7C5B5D29652E6C656E6774682626746869732E72657472696767657243686172732E';
wwv_flow_imp.g_varchar2_table(29460) := '61646428652E63686172436F64654174283029297D7D6F6E446964547970652865297B69662821746869732E747269676765724F6E547970652972657475726E3B636F6E737420743D652E6C656E6774682D312C6E3D652E63686172436F646541742874';
wwv_flow_imp.g_varchar2_table(29461) := '293B28746869732E7472696767657243686172732E686173286E297C7C746869732E69735472696767657265642626746869732E72657472696767657243686172732E686173286E29292626746869732E74726967676572287B747269676765724B696E';
wwv_flow_imp.g_varchar2_table(29462) := '643A53772E547269676765724368617261637465722C747269676765724368617261637465723A652E6368617241742874297D297D6F6E437572736F724368616E67652865297B226D6F757365223D3D3D652E736F757263653F746869732E63616E6365';
wwv_flow_imp.g_varchar2_table(29463) := '6C28293A746869732E69735472696767657265642626746869732E74726967676572287B747269676765724B696E643A53772E436F6E74656E744368616E67657D297D6F6E4D6F64656C436F6E74656E744368616E676528297B746869732E6973547269';
wwv_flow_imp.g_varchar2_table(29464) := '6767657265642626746869732E74726967676572287B747269676765724B696E643A53772E436F6E74656E744368616E67657D297D6F6E456469746F72436F6E66696775726174696F6E4368616E676528297B746869732E747269676765724F6E547970';
wwv_flow_imp.g_varchar2_table(29465) := '653D746869732E656469746F722E6765744F7074696F6E283836292E656E61626C65642C746869732E747269676765724F6E547970657C7C746869732E63616E63656C28297D646973706F736528297B746869732E63616E63656C282130292C73757065';
wwv_flow_imp.g_varchar2_table(29466) := '722E646973706F736528297D7D66756E6374696F6E20503728652C74297B73776974636828742E747269676765724B696E64297B636173652053772E496E766F6B653A72657475726E20743B636173652053772E436F6E74656E744368616E67653A7265';
wwv_flow_imp.g_varchar2_table(29467) := '7475726E20653B636173652053772E547269676765724368617261637465723A64656661756C743A72657475726E20747D7D4E372E44454641554C545F44454C41593D3132303B766172204F373D6E28393931292C52373D7B7D3B52372E7374796C6554';
wwv_flow_imp.g_varchar2_table(29468) := '61675472616E73666F726D3D6A7228292C52372E736574417474726962757465733D567228292C52372E696E736572743D467228292E62696E64286E756C6C2C226865616422292C52372E646F6D4150493D4F7228292C52372E696E736572745374796C';
wwv_flow_imp.g_varchar2_table(29469) := '65456C656D656E743D487228292C4E722829284F372E412C5237292C4F372E4126264F372E412E6C6F63616C7326264F372E412E6C6F63616C733B7661722046372C42373D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(29470) := '2C69297B74286E2C692C65297D7D3B636F6E73742056373D62722C7A373D54572822706172616D657465722D68696E74732D6E657874222C4C6C2E63686576726F6E446F776E2C6228302C2249636F6E20666F722073686F77206E65787420706172616D';
wwv_flow_imp.g_varchar2_table(29471) := '657465722068696E742E2229292C48373D54572822706172616D657465722D68696E74732D70726576696F7573222C4C6C2E63686576726F6E55702C6228302C2249636F6E20666F722073686F772070726576696F757320706172616D65746572206869';
wwv_flow_imp.g_varchar2_table(29472) := '6E742E2229293B6C65742057373D46373D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E656469746F723D652C746869732E6D6F64656C3D742C746869732E72656E';
wwv_flow_imp.g_varchar2_table(29473) := '646572446973706F736561626C65733D746869732E5F7265676973746572286E6577206174292C746869732E76697369626C653D21312C746869732E616E6E6F756E6365644C6162656C3D6E756C6C2C746869732E616C6C6F77456469746F724F766572';
wwv_flow_imp.g_varchar2_table(29474) := '666C6F773D21302C746869732E6D61726B646F776E52656E64657265723D746869732E5F7265676973746572286E6577207045287B656469746F723A657D2C6F2C6929292C746869732E6B657956697369626C653D49372E56697369626C652E62696E64';
wwv_flow_imp.g_varchar2_table(29475) := '546F286E292C746869732E6B65794D756C7469706C655369676E6174757265733D49372E4D756C7469706C655369676E6174757265732E62696E64546F286E297D637265617465506172616D6574657248696E74444F4D4E6F64657328297B636F6E7374';
wwv_flow_imp.g_varchar2_table(29476) := '20653D563728222E656469746F722D7769646765742E706172616D657465722D68696E74732D77696467657422292C743D757228652C563728222E7068777261707065722229293B742E746162496E6465783D2D313B636F6E7374206E3D757228742C56';
wwv_flow_imp.g_varchar2_table(29477) := '3728222E636F6E74726F6C732229292C693D7572286E2C563728222E627574746F6E222B546C2E617343535353656C6563746F722848372929292C6F3D7572286E2C563728222E6F7665726C6F6164732229292C733D7572286E2C563728222E62757474';
wwv_flow_imp.g_varchar2_table(29478) := '6F6E222B546C2E617343535353656C6563746F72287A372929293B746869732E5F726567697374657228627328692C22636C69636B222C28653D3E7B63722865292C746869732E70726576696F757328297D2929292C746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(29479) := '28627328732C22636C69636B222C28653D3E7B63722865292C746869732E6E65787428297D2929293B636F6E737420723D563728222E626F647922292C613D6E657720675428722C7B616C77617973436F6E73756D654D6F757365576865656C3A21307D';
wwv_flow_imp.g_varchar2_table(29480) := '293B746869732E5F72656769737465722861292C742E617070656E644368696C6428612E676574446F6D4E6F64652829293B636F6E7374206C3D757228722C563728222E7369676E61747572652229292C633D757228722C563728222E646F6373222929';
wwv_flow_imp.g_varchar2_table(29481) := '3B652E7374796C652E7573657253656C6563743D2274657874222C746869732E646F6D4E6F6465733D7B656C656D656E743A652C7369676E61747572653A6C2C6F7665726C6F6164733A6F2C646F63733A632C7363726F6C6C6261723A617D2C74686973';
wwv_flow_imp.g_varchar2_table(29482) := '2E656469746F722E616464436F6E74656E745769646765742874686973292C746869732E6869646528292C746869732E5F726567697374657228746869732E656469746F722E6F6E4469644368616E6765437572736F7253656C656374696F6E2828653D';
wwv_flow_imp.g_varchar2_table(29483) := '3E7B746869732E76697369626C652626746869732E656469746F722E6C61796F7574436F6E74656E745769646765742874686973297D2929293B636F6E737420643D28293D3E7B69662821746869732E646F6D4E6F6465732972657475726E3B636F6E73';
wwv_flow_imp.g_varchar2_table(29484) := '7420653D746869732E656469746F722E6765744F7074696F6E283530293B746869732E646F6D4E6F6465732E656C656D656E742E7374796C652E666F6E7453697A653D60247B652E666F6E7453697A657D7078602C746869732E646F6D4E6F6465732E65';
wwv_flow_imp.g_varchar2_table(29485) := '6C656D656E742E7374796C652E6C696E654865696768743D22222B652E6C696E654865696768742F652E666F6E7453697A657D3B6428292C746869732E5F72656769737465722876742E636861696E28746869732E656469746F722E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(29486) := '6E6765436F6E66696775726174696F6E2E62696E6428746869732E656469746F72292C28653D3E652E66696C7465722828653D3E652E6861734368616E6765642835302929292929286429292C746869732E5F726567697374657228746869732E656469';
wwv_flow_imp.g_varchar2_table(29487) := '746F722E6F6E4469644C61796F75744368616E67652828653D3E746869732E7570646174654D617848656967687428292929292C746869732E7570646174654D617848656967687428297D73686F7728297B746869732E76697369626C657C7C28746869';
wwv_flow_imp.g_varchar2_table(29488) := '732E646F6D4E6F6465737C7C746869732E637265617465506172616D6574657248696E74444F4D4E6F64657328292C746869732E6B657956697369626C652E736574282130292C746869732E76697369626C653D21302C73657454696D656F7574282828';
wwv_flow_imp.g_varchar2_table(29489) := '293D3E7B76617220653B6E756C6C3D3D3D28653D746869732E646F6D4E6F646573297C7C766F696420303D3D3D657C7C652E656C656D656E742E636C6173734C6973742E616464282276697369626C6522297D292C313030292C746869732E656469746F';
wwv_flow_imp.g_varchar2_table(29490) := '722E6C61796F7574436F6E74656E74576964676574287468697329297D6869646528297B76617220653B746869732E72656E646572446973706F736561626C65732E636C65617228292C746869732E76697369626C65262628746869732E6B6579566973';
wwv_flow_imp.g_varchar2_table(29491) := '69626C652E726573657428292C746869732E76697369626C653D21312C746869732E616E6E6F756E6365644C6162656C3D6E756C6C2C6E756C6C3D3D3D28653D746869732E646F6D4E6F646573297C7C766F696420303D3D3D657C7C652E656C656D656E';
wwv_flow_imp.g_varchar2_table(29492) := '742E636C6173734C6973742E72656D6F7665282276697369626C6522292C746869732E656469746F722E6C61796F7574436F6E74656E74576964676574287468697329297D676574506F736974696F6E28297B72657475726E20746869732E7669736962';
wwv_flow_imp.g_varchar2_table(29493) := '6C653F7B706F736974696F6E3A746869732E656469746F722E676574506F736974696F6E28292C707265666572656E63653A5B312C325D7D3A6E756C6C7D72656E6465722865297B76617220743B696628746869732E72656E646572446973706F736561';
wwv_flow_imp.g_varchar2_table(29494) := '626C65732E636C65617228292C21746869732E646F6D4E6F6465732972657475726E3B636F6E7374206E3D652E7369676E6174757265732E6C656E6774683E313B746869732E646F6D4E6F6465732E656C656D656E742E636C6173734C6973742E746F67';
wwv_flow_imp.g_varchar2_table(29495) := '676C6528226D756C7469706C65222C6E292C746869732E6B65794D756C7469706C655369676E6174757265732E736574286E292C746869732E646F6D4E6F6465732E7369676E61747572652E696E6E6572546578743D22222C746869732E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(29496) := '65732E646F63732E696E6E6572546578743D22223B636F6E737420693D652E7369676E6174757265735B652E6163746976655369676E61747572655D3B69662821692972657475726E3B636F6E7374206F3D757228746869732E646F6D4E6F6465732E73';
wwv_flow_imp.g_varchar2_table(29497) := '69676E61747572652C563728222E636F64652229292C733D746869732E656469746F722E6765744F7074696F6E283530293B6F2E7374796C652E666F6E7453697A653D60247B732E666F6E7453697A657D7078602C6F2E7374796C652E666F6E7446616D';
wwv_flow_imp.g_varchar2_table(29498) := '696C793D732E666F6E7446616D696C793B636F6E737420723D692E706172616D65746572732E6C656E6774683E302C613D6E756C6C213D3D28743D692E616374697665506172616D65746572292626766F69642030213D3D743F743A652E616374697665';
wwv_flow_imp.g_varchar2_table(29499) := '506172616D657465723B723F746869732E72656E646572506172616D6574657273286F2C692C61293A7572286F2C563728227370616E2229292E74657874436F6E74656E743D692E6C6162656C3B636F6E7374206C3D692E706172616D65746572735B61';
wwv_flow_imp.g_varchar2_table(29500) := '5D3B6966286E756C6C3D3D6C3F766F696420303A6C2E646F63756D656E746174696F6E297B636F6E737420653D563728227370616E2E646F63756D656E746174696F6E22293B69662822737472696E67223D3D747970656F66206C2E646F63756D656E74';
wwv_flow_imp.g_varchar2_table(29501) := '6174696F6E29652E74657874436F6E74656E743D6C2E646F63756D656E746174696F6E3B656C73657B636F6E737420743D746869732E72656E6465724D61726B646F776E446F6373286C2E646F63756D656E746174696F6E293B652E617070656E644368';
wwv_flow_imp.g_varchar2_table(29502) := '696C6428742E656C656D656E74297D757228746869732E646F6D4E6F6465732E646F63732C5637282270222C7B7D2C6529297D696628766F696420303D3D3D692E646F63756D656E746174696F6E293B656C73652069662822737472696E67223D3D7479';
wwv_flow_imp.g_varchar2_table(29503) := '70656F6620692E646F63756D656E746174696F6E29757228746869732E646F6D4E6F6465732E646F63732C5637282270222C7B7D2C692E646F63756D656E746174696F6E29293B656C73657B636F6E737420653D746869732E72656E6465724D61726B64';
wwv_flow_imp.g_varchar2_table(29504) := '6F776E446F637328692E646F63756D656E746174696F6E293B757228746869732E646F6D4E6F6465732E646F63732C652E656C656D656E74297D636F6E737420633D746869732E686173446F637328692C6C293B696628746869732E646F6D4E6F646573';
wwv_flow_imp.g_varchar2_table(29505) := '2E7369676E61747572652E636C6173734C6973742E746F67676C6528226861732D646F6373222C63292C746869732E646F6D4E6F6465732E646F63732E636C6173734C6973742E746F67676C652822656D707479222C2163292C746869732E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(29506) := '6465732E6F7665726C6F6164732E74657874436F6E74656E743D537472696E6728652E6163746976655369676E61747572652B31292E706164537461727428652E7369676E6174757265732E6C656E6774682E746F537472696E6728292E6C656E677468';
wwv_flow_imp.g_varchar2_table(29507) := '2C223022292B222F222B652E7369676E6174757265732E6C656E6774682C6C297B6C657420653D22223B636F6E737420743D692E706172616D65746572735B615D3B653D41727261792E6973417272617928742E6C6162656C293F692E6C6162656C2E73';
wwv_flow_imp.g_varchar2_table(29508) := '7562737472696E6728742E6C6162656C5B305D2C742E6C6162656C5B315D293A742E6C6162656C2C742E646F63756D656E746174696F6E262628652B3D22737472696E67223D3D747970656F6620742E646F63756D656E746174696F6E3F602C20247B74';
wwv_flow_imp.g_varchar2_table(29509) := '2E646F63756D656E746174696F6E7D603A602C20247B742E646F63756D656E746174696F6E2E76616C75657D60292C692E646F63756D656E746174696F6E262628652B3D22737472696E67223D3D747970656F6620692E646F63756D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(29510) := '3F602C20247B692E646F63756D656E746174696F6E7D603A602C20247B692E646F63756D656E746174696F6E2E76616C75657D60292C746869732E616E6E6F756E6365644C6162656C213D3D652626285872286228302C227B307D2C2068696E74222C65';
wwv_flow_imp.g_varchar2_table(29511) := '29292C746869732E616E6E6F756E6365644C6162656C3D65297D746869732E656469746F722E6C61796F7574436F6E74656E745769646765742874686973292C746869732E646F6D4E6F6465732E7363726F6C6C6261722E7363616E446F6D4E6F646528';
wwv_flow_imp.g_varchar2_table(29512) := '297D72656E6465724D61726B646F776E446F63732865297B636F6E737420743D746869732E72656E646572446973706F736561626C65732E61646428746869732E6D61726B646F776E52656E64657265722E72656E64657228652C7B6173796E6352656E';
wwv_flow_imp.g_varchar2_table(29513) := '64657243616C6C6261636B3A28293D3E7B76617220653B6E756C6C3D3D3D28653D746869732E646F6D4E6F646573297C7C766F696420303D3D3D657C7C652E7363726F6C6C6261722E7363616E446F6D4E6F646528297D7D29293B72657475726E20742E';
wwv_flow_imp.g_varchar2_table(29514) := '656C656D656E742E636C6173734C6973742E61646428226D61726B646F776E2D646F637322292C747D686173446F637328652C74297B72657475726E21212874262622737472696E67223D3D747970656F6620742E646F63756D656E746174696F6E2626';
wwv_flow_imp.g_varchar2_table(29515) := '776C28742E646F63756D656E746174696F6E292E6C656E6774683E307C7C742626226F626A656374223D3D747970656F6620742E646F63756D656E746174696F6E2626776C28742E646F63756D656E746174696F6E292E76616C75652E6C656E6774683E';
wwv_flow_imp.g_varchar2_table(29516) := '307C7C652E646F63756D656E746174696F6E262622737472696E67223D3D747970656F6620652E646F63756D656E746174696F6E2626776C28652E646F63756D656E746174696F6E292E6C656E6774683E307C7C652E646F63756D656E746174696F6E26';
wwv_flow_imp.g_varchar2_table(29517) := '26226F626A656374223D3D747970656F6620652E646F63756D656E746174696F6E2626776C28652E646F63756D656E746174696F6E2E76616C7565292E6C656E6774683E30297D72656E646572506172616D657465727328652C742C6E297B636F6E7374';
wwv_flow_imp.g_varchar2_table(29518) := '5B692C6F5D3D746869732E676574506172616D657465724C6162656C4F66667365747328742C6E292C733D646F63756D656E742E637265617465456C656D656E7428227370616E22293B732E74657874436F6E74656E743D742E6C6162656C2E73756273';
wwv_flow_imp.g_varchar2_table(29519) := '7472696E6728302C69293B636F6E737420723D646F63756D656E742E637265617465456C656D656E7428227370616E22293B722E74657874436F6E74656E743D742E6C6162656C2E737562737472696E6728692C6F292C722E636C6173734E616D653D22';
wwv_flow_imp.g_varchar2_table(29520) := '706172616D6574657220616374697665223B636F6E737420613D646F63756D656E742E637265617465456C656D656E7428227370616E22293B612E74657874436F6E74656E743D742E6C6162656C2E737562737472696E67286F292C757228652C732C72';
wwv_flow_imp.g_varchar2_table(29521) := '2C61297D676574506172616D657465724C6162656C4F66667365747328652C74297B636F6E7374206E3D652E706172616D65746572735B745D3B6966286E297B69662841727261792E69734172726179286E2E6C6162656C292972657475726E206E2E6C';
wwv_flow_imp.g_varchar2_table(29522) := '6162656C3B6966286E2E6C6162656C2E6C656E677468297B636F6E737420743D6E6577205265674578702860285C5C577C5E29247B6369286E2E6C6162656C297D283F3D5C5C577C2429602C226722293B742E7465737428652E6C6162656C293B636F6E';
wwv_flow_imp.g_varchar2_table(29523) := '737420693D742E6C617374496E6465782D6E2E6C6162656C2E6C656E6774683B72657475726E20693E3D303F5B692C742E6C617374496E6465785D3A5B302C305D7D72657475726E5B302C305D7D72657475726E5B302C305D7D6E65787428297B746869';
wwv_flow_imp.g_varchar2_table(29524) := '732E656469746F722E666F63757328292C746869732E6D6F64656C2E6E65787428297D70726576696F757328297B746869732E656469746F722E666F63757328292C746869732E6D6F64656C2E70726576696F757328297D676574446F6D4E6F64652829';
wwv_flow_imp.g_varchar2_table(29525) := '7B72657475726E20746869732E646F6D4E6F6465737C7C746869732E637265617465506172616D6574657248696E74444F4D4E6F64657328292C746869732E646F6D4E6F6465732E656C656D656E747D676574496428297B72657475726E2046372E4944';
wwv_flow_imp.g_varchar2_table(29526) := '7D7570646174654D617848656967687428297B69662821746869732E646F6D4E6F6465732972657475726E3B636F6E737420653D60247B4D6174682E6D617828746869732E656469746F722E6765744C61796F7574496E666F28292E6865696768742F34';
wwv_flow_imp.g_varchar2_table(29527) := '2C323530297D7078603B746869732E646F6D4E6F6465732E656C656D656E742E7374796C652E6D61784865696768743D653B636F6E737420743D746869732E646F6D4E6F6465732E656C656D656E742E676574456C656D656E74734279436C6173734E61';
wwv_flow_imp.g_varchar2_table(29528) := '6D65282270687772617070657222293B742E6C656E677468262628745B305D2E7374796C652E6D61784865696768743D65297D7D3B57372E49443D22656469746F722E7769646765742E706172616D6574657248696E7473576964676574222C57373D46';
wwv_flow_imp.g_varchar2_table(29529) := '373D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E29';
wwv_flow_imp.g_varchar2_table(29530) := '3A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C7365';
wwv_flow_imp.g_varchar2_table(29531) := '20666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A656374';
wwv_flow_imp.g_varchar2_table(29532) := '2E646566696E6550726F706572747928742C6E2C72292C727D285B423728322C6364292C423728332C6445292C423728342C4C75295D2C5737292C4C6D2822656469746F72486F7665725769646765742E686967686C69676874466F726567726F756E64';
wwv_flow_imp.g_varchar2_table(29533) := '222C7B6461726B3A69622C6C696768743A69622C68634461726B3A69622C68634C696768743A69627D2C6228302C22466F726567726F756E6420636F6C6F72206F662074686520616374697665206974656D20696E2074686520706172616D6574657220';
wwv_flow_imp.g_varchar2_table(29534) := '68696E742E2229293B766172206A372C71373D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742024373D6A373D636C61737320657874656E6473206C747B7374617469632067';
wwv_flow_imp.g_varchar2_table(29535) := '65742865297B72657475726E20652E676574436F6E747269627574696F6E286A372E4944297D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E656469746F723D652C746869732E6D6F64656C3D746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(29536) := '73746572286E6577204E3728652C6E2E7369676E617475726548656C7050726F766964657229292C746869732E5F726567697374657228746869732E6D6F64656C2E6F6E4368616E67656448696E74732828653D3E7B76617220743B653F28746869732E';
wwv_flow_imp.g_varchar2_table(29537) := '7769646765742E76616C75652E73686F7728292C746869732E7769646765742E76616C75652E72656E646572286529293A6E756C6C3D3D3D28743D746869732E7769646765742E72617756616C7565297C7C766F696420303D3D3D747C7C742E68696465';
wwv_flow_imp.g_varchar2_table(29538) := '28297D2929292C746869732E7769646765743D6E6577206969282828293D3E746869732E5F726567697374657228742E637265617465496E7374616E63652857372C746869732E656469746F722C746869732E6D6F64656C292929297D63616E63656C28';
wwv_flow_imp.g_varchar2_table(29539) := '297B746869732E6D6F64656C2E63616E63656C28297D70726576696F757328297B76617220653B6E756C6C3D3D3D28653D746869732E7769646765742E72617756616C7565297C7C766F696420303D3D3D657C7C652E70726576696F757328297D6E6578';
wwv_flow_imp.g_varchar2_table(29540) := '7428297B76617220653B6E756C6C3D3D3D28653D746869732E7769646765742E72617756616C7565297C7C766F696420303D3D3D657C7C652E6E65787428297D747269676765722865297B746869732E6D6F64656C2E7472696767657228652C30297D7D';
wwv_flow_imp.g_varchar2_table(29541) := '3B24372E49443D22656469746F722E636F6E74726F6C6C65722E706172616D6574657248696E7473222C24373D6A373D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E';
wwv_flow_imp.g_varchar2_table(29542) := '756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F6620526566';
wwv_flow_imp.g_varchar2_table(29543) := '6C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A';
wwv_flow_imp.g_varchar2_table(29544) := '733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B713728312C7563292C713728322C7878295D2C2437292C4A642824';
wwv_flow_imp.g_varchar2_table(29545) := '372E49442C24372C32292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E74726967676572506172616D6574657248696E7473222C6C6162656C3A62';
wwv_flow_imp.g_varchar2_table(29546) := '28302C225472696767657220506172616D657465722048696E747322292C616C6961733A225472696767657220506172616D657465722048696E7473222C707265636F6E646974696F6E3A6C682E6861735369676E617475726548656C7050726F766964';
wwv_flow_imp.g_varchar2_table(29547) := '65722C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A333038322C7765696768743A3130307D7D297D72756E28652C74297B636F6E7374206E3D24372E6765742874293B6E756C6C3D3D6E7C7C';
wwv_flow_imp.g_varchar2_table(29548) := '6E2E74726967676572287B747269676765724B696E643A53772E496E766F6B657D297D7D293B636F6E73742055373D24642E62696E64546F436F6E747269627574696F6E2824372E676574293B66756E6374696F6E204B3728652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(29549) := '2074262628652E737461636B7C7C652E737461636B7472616365293F6228302C227B307D3A207B317D222C51372865292C473728652E737461636B297C7C473728652E737461636B747261636529293A51372865297D66756E6374696F6E204737286529';
wwv_flow_imp.g_varchar2_table(29550) := '7B72657475726E2041727261792E697341727261792865293F652E6A6F696E28225C6E22293A657D66756E6374696F6E2051372865297B72657475726E224552525F554E435F484F53545F4E4F545F414C4C4F574544223D3D3D652E636F64653F60247B';
wwv_flow_imp.g_varchar2_table(29551) := '652E6D6573736167657D2E20506C656173652075706461746520746865202773656375726974792E616C6C6F776564554E43486F737473272073657474696E6720696620796F752077616E7420746F20616C6C6F77207468697320686F73742E603A2273';
wwv_flow_imp.g_varchar2_table(29552) := '7472696E67223D3D747970656F6620652E636F64652626226E756D626572223D3D747970656F6620652E6572726E6F262622737472696E67223D3D747970656F6620652E73797363616C6C3F6228302C22412073797374656D206572726F72206F636375';
wwv_flow_imp.g_varchar2_table(29553) := '7272656420287B307D29222C652E6D657373616765293A652E6D6573736167657C7C6228302C22416E20756E6B6E6F776E206572726F72206F636375727265642E20506C6561736520636F6E73756C7420746865206C6F6720666F72206D6F7265206465';
wwv_flow_imp.g_varchar2_table(29554) := '7461696C732E22297D66756E6374696F6E20593728653D6E756C6C2C743D2131297B69662821652972657475726E206228302C22416E20756E6B6E6F776E206572726F72206F636375727265642E20506C6561736520636F6E73756C7420746865206C6F';
wwv_flow_imp.g_varchar2_table(29555) := '6720666F72206D6F72652064657461696C732E22293B69662841727261792E69734172726179286529297B636F6E7374206E3D7A682865292C693D5937286E5B305D2C74293B72657475726E206E2E6C656E6774683E313F6228302C227B307D20287B31';
wwv_flow_imp.g_varchar2_table(29556) := '7D206572726F727320696E20746F74616C29222C692C6E2E6C656E677468293A697D696628686C2865292972657475726E20653B696628652E64657461696C297B636F6E7374206E3D652E64657461696C3B6966286E2E6572726F722972657475726E20';
wwv_flow_imp.g_varchar2_table(29557) := '4B37286E2E6572726F722C74293B6966286E2E657863657074696F6E2972657475726E204B37286E2E657863657074696F6E2C74297D72657475726E20652E737461636B3F4B3728652C74293A652E6D6573736167653F652E6D6573736167653A622830';
wwv_flow_imp.g_varchar2_table(29558) := '2C22416E20756E6B6E6F776E206572726F72206F636375727265642E20506C6561736520636F6E73756C7420746865206C6F6720666F72206D6F72652064657461696C732E22297D5964286E6577205537287B69643A22636C6F7365506172616D657465';
wwv_flow_imp.g_varchar2_table(29559) := '7248696E7473222C707265636F6E646974696F6E3A49372E56697369626C652C68616E646C65723A653D3E652E63616E63656C28292C6B624F7074733A7B7765696768743A3137352C6B62457870723A6C682E666F6375732C7072696D6172793A392C73';
wwv_flow_imp.g_varchar2_table(29560) := '65636F6E646172793A5B313033335D7D7D29292C5964286E6577205537287B69643A2273686F7750726576506172616D6574657248696E74222C707265636F6E646974696F6E3A57632E616E642849372E56697369626C652C49372E4D756C7469706C65';
wwv_flow_imp.g_varchar2_table(29561) := '5369676E617475726573292C68616E646C65723A653D3E652E70726576696F757328292C6B624F7074733A7B7765696768743A3137352C6B62457870723A6C682E666F6375732C7072696D6172793A31362C7365636F6E646172793A5B3532385D2C6D61';
wwv_flow_imp.g_varchar2_table(29562) := '633A7B7072696D6172793A31362C7365636F6E646172793A5B3532382C3330325D7D7D7D29292C5964286E6577205537287B69643A2273686F774E657874506172616D6574657248696E74222C707265636F6E646974696F6E3A57632E616E642849372E';
wwv_flow_imp.g_varchar2_table(29563) := '56697369626C652C49372E4D756C7469706C655369676E617475726573292C68616E646C65723A653D3E652E6E65787428292C6B624F7074733A7B7765696768743A3137352C6B62457870723A6C682E666F6375732C7072696D6172793A31382C736563';
wwv_flow_imp.g_varchar2_table(29564) := '6F6E646172793A5B3533305D2C6D61633A7B7072696D6172793A31382C7365636F6E646172793A5B3533302C3330305D7D7D7D29293B636C617373205A377B636F6E7374727563746F7228297B746869732E6368756E6B436F756E743D302C746869732E';
wwv_flow_imp.g_varchar2_table(29565) := '6368756E6B4F6363757272656E6365733D6E6577204D61702C746869732E646F63756D656E74733D6E6577204D61707D63616C63756C61746553636F72657328652C74297B636F6E7374206E3D746869732E636F6D70757465456D62656464696E672865';
wwv_flow_imp.g_varchar2_table(29566) := '292C693D6E6577204D61702C6F3D5B5D3B666F7228636F6E73745B652C735D6F6620746869732E646F63756D656E7473297B696628742E697343616E63656C6C6174696F6E5265717565737465642972657475726E5B5D3B666F7228636F6E7374207420';
wwv_flow_imp.g_varchar2_table(29567) := '6F6620732E6368756E6B73297B636F6E737420733D746869732E636F6D7075746553696D696C617269747953636F726528742C6E2C69293B733E3026266F2E70757368287B6B65793A652C73636F72653A737D297D7D72657475726E206F7D7374617469';
wwv_flow_imp.g_varchar2_table(29568) := '63207465726D4672657175656E636965732865297B72657475726E2066756E6374696F6E2865297B76617220743B636F6E7374206E3D6E6577204D61703B666F7228636F6E73742069206F662065296E2E73657428692C286E756C6C213D3D28743D6E2E';
wwv_flow_imp.g_varchar2_table(29569) := '676574286929292626766F69642030213D3D743F743A30292B31293B72657475726E206E7D285A372E73706C69745465726D73286529297D7374617469632A73706C69745465726D732865297B636F6E737420743D653D3E652E746F4C6F776572436173';
wwv_flow_imp.g_varchar2_table(29570) := '6528293B666F7228636F6E73745B6E5D6F6620652E6D61746368416C6C282F5C625C707B4C65747465727D5B5C707B4C65747465727D5C645D7B322C7D5C622F677529297B7969656C642074286E293B636F6E737420653D6E2E7265706C616365282F28';
wwv_flow_imp.g_varchar2_table(29571) := '5B612D7A5D29285B412D5A5D292F672C22243120243222292E73706C6974282F5C732B2F67293B696628652E6C656E6774683E3129666F7228636F6E7374206E206F662065296E2E6C656E6774683E3226262F5C707B4C65747465727D7B332C7D2F6775';
wwv_flow_imp.g_varchar2_table(29572) := '2E74657374286E292626287969656C642074286E29297D7D757064617465446F63756D656E74732865297B76617220743B666F7228636F6E73747B6B65793A747D6F66206529746869732E64656C657465446F63756D656E742874293B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(29573) := '7374206E206F662065297B636F6E737420653D5B5D3B666F7228636F6E73742069206F66206E2E746578744368756E6B73297B636F6E7374206E3D5A372E7465726D4672657175656E636965732869293B666F7228636F6E73742065206F66206E2E6B65';
wwv_flow_imp.g_varchar2_table(29574) := '7973282929746869732E6368756E6B4F6363757272656E6365732E73657428652C286E756C6C213D3D28743D746869732E6368756E6B4F6363757272656E6365732E676574286529292626766F69642030213D3D743F743A30292B31293B652E70757368';
wwv_flow_imp.g_varchar2_table(29575) := '287B746578743A692C74663A6E7D297D746869732E6368756E6B436F756E742B3D652E6C656E6774682C746869732E646F63756D656E74732E736574286E2E6B65792C7B6368756E6B733A657D297D72657475726E20746869737D64656C657465446F63';
wwv_flow_imp.g_varchar2_table(29576) := '756D656E742865297B636F6E737420743D746869732E646F63756D656E74732E6765742865293B69662874297B746869732E646F63756D656E74732E64656C6574652865292C746869732E6368756E6B436F756E742D3D742E6368756E6B732E6C656E67';
wwv_flow_imp.g_varchar2_table(29577) := '74683B666F7228636F6E73742065206F6620742E6368756E6B7329666F7228636F6E73742074206F6620652E74662E6B6579732829297B636F6E737420653D746869732E6368756E6B4F6363757272656E6365732E6765742874293B696628226E756D62';
wwv_flow_imp.g_varchar2_table(29578) := '6572223D3D747970656F662065297B636F6E7374206E3D652D313B6E3C3D303F746869732E6368756E6B4F6363757272656E6365732E64656C6574652874293A746869732E6368756E6B4F6363757272656E6365732E73657428742C6E297D7D7D7D636F';
wwv_flow_imp.g_varchar2_table(29579) := '6D7075746553696D696C617269747953636F726528652C742C6E297B6C657420693D303B666F7228636F6E73745B6F2C735D6F66204F626A6563742E656E7472696573287429297B636F6E737420743D652E74662E676574286F293B696628217429636F';
wwv_flow_imp.g_varchar2_table(29580) := '6E74696E75653B6C657420723D6E2E676574286F293B226E756D62657222213D747970656F662072262628723D746869732E636F6D70757465496466286F292C6E2E736574286F2C7229292C692B3D742A722A737D72657475726E20697D636F6D707574';
wwv_flow_imp.g_varchar2_table(29581) := '65456D62656464696E672865297B636F6E737420743D5A372E7465726D4672657175656E636965732865293B72657475726E20746869732E636F6D7075746554666964662874297D636F6D707574654964662865297B76617220743B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(29582) := '6E756C6C213D3D28743D746869732E6368756E6B4F6363757272656E6365732E676574286529292626766F69642030213D3D743F743A303B72657475726E206E3E303F4D6174682E6C6F672828746869732E6368756E6B436F756E742B31292F6E293A30';
wwv_flow_imp.g_varchar2_table(29583) := '7D636F6D7075746554666964662865297B636F6E737420743D4F626A6563742E637265617465286E756C6C293B666F7228636F6E73745B6E2C695D6F662065297B636F6E737420653D746869732E636F6D70757465496466286E293B653E30262628745B';
wwv_flow_imp.g_varchar2_table(29584) := '6E5D3D692A65297D72657475726E20747D7D636F6E73742058373D706328226469616C6F675365727669636522293B766172204A373B66756E6374696F6E2065382865297B636F6E737420743D653B72657475726E2041727261792E6973417272617928';
wwv_flow_imp.g_varchar2_table(29585) := '742E6974656D73297D66756E6374696F6E2074382865297B636F6E737420743D653B72657475726E2121742E7069636B732626742E6164646974696F6E616C5069636B7320696E7374616E63656F662050726F6D6973657D2166756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(29586) := '7B655B652E4E4F5F414354494F4E3D305D3D224E4F5F414354494F4E222C655B652E434C4F53455F5049434B45523D315D3D22434C4F53455F5049434B4552222C655B652E524546524553485F5049434B45523D325D3D22524546524553485F5049434B';
wwv_flow_imp.g_varchar2_table(29587) := '4552222C655B652E52454D4F56455F4954454D3D335D3D2252454D4F56455F4954454D227D284A377C7C284A373D7B7D29293B636C617373206E3820657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C74686973';
wwv_flow_imp.g_varchar2_table(29588) := '2E7072656669783D652C746869732E6F7074696F6E733D747D70726F7669646528652C742C6E297B76617220693B636F6E7374206F3D6E65772061743B6C657420733B652E63616E416363657074496E4261636B67726F756E643D2121286E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(29589) := '3D28693D746869732E6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E63616E416363657074496E4261636B67726F756E64292C652E6D617463684F6E4C6162656C3D652E6D617463684F6E4465736372697074696F6E3D652E';
wwv_flow_imp.g_varchar2_table(29590) := '6D617463684F6E44657461696C3D652E736F727442794C6162656C3D21313B636F6E737420723D6F2E616464286E6577206374292C613D6173796E6328293D3E7B76617220693B636F6E7374206F3D722E76616C75653D6E65772061743B6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(29591) := '737C7C732E646973706F7365282130292C652E627573793D21312C733D6E6577204E742874293B636F6E737420613D732E746F6B656E3B6C6574206C3D652E76616C75652E737562737472696E6728746869732E7072656669782E6C656E677468293B28';
wwv_flow_imp.g_varchar2_table(29592) := '6E756C6C3D3D3D28693D746869732E6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E73686F756C64536B69705472696D5069636B46696C746572297C7C286C3D6C2E7472696D2829293B636F6E737420633D746869732E5F67';
wwv_flow_imp.g_varchar2_table(29593) := '65745069636B73286C2C6F2C612C6E292C643D28742C6E293D3E7B76617220693B6C6574206F2C733B69662865382874293F286F3D742E6974656D732C733D742E616374697665293A6F3D742C303D3D3D6F2E6C656E677468297B6966286E2972657475';
wwv_flow_imp.g_varchar2_table(29594) := '726E21313B286C2E6C656E6774683E307C7C652E68696465496E707574292626286E756C6C3D3D3D28693D746869732E6F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6E6F526573756C74735069636B292626286F3D436C28';
wwv_flow_imp.g_varchar2_table(29595) := '746869732E6F7074696F6E732E6E6F526573756C74735069636B293F5B746869732E6F7074696F6E732E6E6F526573756C74735069636B286C295D3A5B746869732E6F7074696F6E732E6E6F526573756C74735069636B5D297D72657475726E20652E69';
wwv_flow_imp.g_varchar2_table(29596) := '74656D733D6F2C73262628652E6163746976654974656D733D5B735D292C21307D2C683D6173796E6320743D3E7B6C6574206E3D21312C693D21313B61776169742050726F6D6973652E616C6C285B286173796E6328293D3E7B226E756D626572223D3D';
wwv_flow_imp.g_varchar2_table(29597) := '747970656F6620742E6D6572676544656C6179262628617761697420577428742E6D6572676544656C6179292C612E697343616E63656C6C6174696F6E526571756573746564297C7C697C7C286E3D6428742E7069636B732C213029297D2928292C2861';
wwv_flow_imp.g_varchar2_table(29598) := '73796E6328293D3E7B652E627573793D21303B7472797B636F6E737420693D617761697420742E6164646974696F6E616C5069636B733B696628612E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6C6574206F2C732C72';
wwv_flow_imp.g_varchar2_table(29599) := '2C6C3B696628653828742E7069636B73293F286F3D742E7069636B732E6974656D732C733D742E7069636B732E616374697665293A6F3D742E7069636B732C65382869293F28723D692E6974656D732C6C3D692E616374697665293A723D692C722E6C65';
wwv_flow_imp.g_varchar2_table(29600) := '6E6774683E307C7C216E297B6C657420743B69662821732626216C297B636F6E7374206E3D652E6163746976654974656D735B305D3B6E26262D31213D3D6F2E696E6465784F66286E29262628743D6E297D64287B6974656D733A5B2E2E2E6F2C2E2E2E';
wwv_flow_imp.g_varchar2_table(29601) := '725D2C6163746976653A737C7C6C7C7C747D297D7D66696E616C6C797B612E697343616E63656C6C6174696F6E5265717565737465647C7C28652E627573793D2131292C693D21307D7D2928295D297D3B6966286E756C6C3D3D3D63293B656C73652069';
wwv_flow_imp.g_varchar2_table(29602) := '6628743828632929617761697420682863293B656C7365206966286320696E7374616E63656F662050726F6D697365297B652E627573793D21303B7472797B636F6E737420653D617761697420633B696628612E697343616E63656C6C6174696F6E5265';
wwv_flow_imp.g_varchar2_table(29603) := '717565737465642972657475726E3B74382865293F617761697420682865293A642865297D66696E616C6C797B612E697343616E63656C6C6174696F6E5265717565737465647C7C28652E627573793D2131297D7D656C736520642863297D3B6F2E6164';
wwv_flow_imp.g_varchar2_table(29604) := '6428652E6F6E4469644368616E676556616C7565282828293D3E6128292929292C6128292C6F2E61646428652E6F6E4469644163636570742828743D3E7B636F6E73745B6E5D3D652E73656C65637465644974656D733B2266756E6374696F6E223D3D74';
wwv_flow_imp.g_varchar2_table(29605) := '7970656F66286E756C6C3D3D6E3F766F696420303A6E2E61636365707429262628742E696E4261636B67726F756E647C7C652E6869646528292C6E2E61636365707428652E6B65794D6F64732C7429297D2929293B636F6E7374206C3D6173796E63286E';
wwv_flow_imp.g_varchar2_table(29606) := '2C69293D3E7B766172206F2C733B6966282266756E6374696F6E22213D747970656F6620692E747269676765722972657475726E3B636F6E737420723D6E756C6C213D3D28733D6E756C6C3D3D3D286F3D692E627574746F6E73297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(29607) := '3D3D6F3F766F696420303A6F2E696E6465784F66286E29292626766F69642030213D3D733F733A2D313B696628723E3D30297B636F6E7374206E3D692E7472696767657228722C652E6B65794D6F6473292C6F3D226E756D626572223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(29608) := '206E3F6E3A6177616974206E3B696628742E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B737769746368286F297B63617365204A372E4E4F5F414354494F4E3A627265616B3B63617365204A372E434C4F53455F504943';
wwv_flow_imp.g_varchar2_table(29609) := '4B45523A652E6869646528293B627265616B3B63617365204A372E524546524553485F5049434B45523A6128293B627265616B3B63617365204A372E52454D4F56455F4954454D3A7B636F6E737420743D652E6974656D732E696E6465784F662869293B';
wwv_flow_imp.g_varchar2_table(29610) := '6966282D31213D3D74297B636F6E7374206E3D652E6974656D732E736C69636528292C693D6E2E73706C69636528742C31292C6F3D652E6163746976654974656D732E66696C7465722828653D3E65213D3D695B305D29292C733D652E6B656570536372';
wwv_flow_imp.g_varchar2_table(29611) := '6F6C6C506F736974696F6E3B652E6B6565705363726F6C6C506F736974696F6E3D21302C652E6974656D733D6E2C6F262628652E6163746976654974656D733D6F292C652E6B6565705363726F6C6C506F736974696F6E3D737D627265616B7D7D7D7D3B';
wwv_flow_imp.g_varchar2_table(29612) := '72657475726E206F2E61646428652E6F6E446964547269676765724974656D427574746F6E2828287B627574746F6E3A652C6974656D3A747D293D3E6C28652C74292929292C6F2E61646428652E6F6E44696454726967676572536570617261746F7242';
wwv_flow_imp.g_varchar2_table(29613) := '7574746F6E2828287B627574746F6E3A652C736570617261746F723A747D293D3E6C28652C74292929292C6F7D7D7661722069382C6F382C73383D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774';
wwv_flow_imp.g_varchar2_table(29614) := '682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D';
wwv_flow_imp.g_varchar2_table(29615) := '3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D2926262872';
wwv_flow_imp.g_varchar2_table(29616) := '3D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C72383D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(29617) := '72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742061383D69383D636C61737320657874656E6473206E387B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B73757065722869382E5052454649582C';
wwv_flow_imp.g_varchar2_table(29618) := '65292C746869732E696E7374616E74696174696F6E536572766963653D742C746869732E6B657962696E64696E67536572766963653D6E2C746869732E636F6D6D616E64536572766963653D692C746869732E74656C656D65747279536572766963653D';
wwv_flow_imp.g_varchar2_table(29619) := '6F2C746869732E6469616C6F67536572766963653D732C746869732E636F6D6D616E6473486973746F72793D746869732E5F726567697374657228746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528';
wwv_flow_imp.g_varchar2_table(29620) := '6C3829292C746869732E6F7074696F6E733D657D6173796E63205F6765745069636B7328652C742C6E2C69297B766172206F2C732C722C613B636F6E7374206C3D617761697420746869732E676574436F6D6D616E645069636B73286E293B6966286E2E';
wwv_flow_imp.g_varchar2_table(29621) := '697343616E63656C6C6174696F6E5265717565737465642972657475726E5B5D3B636F6E737420633D5965282828293D3E7B636F6E737420743D6E6577205A373B72657475726E20742E757064617465446F63756D656E7473286C2E6D61702828653D3E';
wwv_flow_imp.g_varchar2_table(29622) := '287B6B65793A652E636F6D6D616E6449642C746578744368756E6B733A5B746869732E67657454664964664368756E6B2865295D7D292929292C66756E6374696F6E2865297B76617220742C6E3B636F6E737420693D652E736C6963652830293B692E73';
wwv_flow_imp.g_varchar2_table(29623) := '6F7274282828652C74293D3E742E73636F72652D652E73636F726529293B636F6E7374206F3D6E756C6C213D3D286E3D6E756C6C3D3D3D28743D695B305D297C7C766F696420303D3D3D743F766F696420303A742E73636F7265292626766F6964203021';
wwv_flow_imp.g_varchar2_table(29624) := '3D3D6E3F6E3A303B6966286F3E3029666F7228636F6E73742065206F66206929652E73636F72652F3D6F3B72657475726E20697D28742E63616C63756C61746553636F72657328652C6E29292E66696C7465722828653D3E652E73636F72653E69382E54';
wwv_flow_imp.g_varchar2_table(29625) := '464944465F5448524553484F4C4429292E736C69636528302C69382E54464944465F4D41585F524553554C5453297D29292C643D5B5D3B666F7228636F6E73742074206F66206C297B636F6E737420693D6E756C6C213D3D286F3D69382E574F52445F46';
wwv_flow_imp.g_varchar2_table(29626) := '494C54455228652C742E6C6162656C29292626766F69642030213D3D6F3F6F3A766F696420302C723D742E636F6D6D616E64416C69617326266E756C6C213D3D28733D69382E574F52445F46494C54455228652C742E636F6D6D616E64416C6961732929';
wwv_flow_imp.g_varchar2_table(29627) := '2626766F69642030213D3D733F733A766F696420303B696628697C7C7229742E686967686C69676874733D7B6C6162656C3A692C64657461696C3A746869732E6F7074696F6E732E73686F77416C6961733F723A766F696420307D2C642E707573682874';
wwv_flow_imp.g_varchar2_table(29628) := '293B656C736520696628653D3D3D742E636F6D6D616E64496429642E707573682874293B656C736520696628652E6C656E6774683E3D33297B636F6E737420653D6328293B6966286E2E697343616E63656C6C6174696F6E526571756573746564297265';
wwv_flow_imp.g_varchar2_table(29629) := '7475726E5B5D3B636F6E737420693D652E66696E642828653D3E652E6B65793D3D3D742E636F6D6D616E64496429293B69262628742E746649646653636F72653D692E73636F72652C642E70757368287429297D7D636F6E737420683D6E6577204D6170';
wwv_flow_imp.g_varchar2_table(29630) := '3B666F7228636F6E73742065206F662064297B636F6E737420743D682E67657428652E6C6162656C293B743F28652E6465736372697074696F6E3D652E636F6D6D616E6449642C742E6465736372697074696F6E3D742E636F6D6D616E644964293A682E';
wwv_flow_imp.g_varchar2_table(29631) := '73657428652E6C6162656C2C65297D642E736F7274282828652C74293D3E7B696628652E746649646653636F72652626742E746649646653636F72652972657475726E20652E746649646653636F72653D3D3D742E746649646653636F72653F652E6C61';
wwv_flow_imp.g_varchar2_table(29632) := '62656C2E6C6F63616C65436F6D7061726528742E6C6162656C293A742E746649646653636F72652D652E746649646653636F72653B696628652E746649646653636F72652972657475726E20313B696628742E746649646653636F72652972657475726E';
wwv_flow_imp.g_varchar2_table(29633) := '2D313B636F6E7374206E3D746869732E636F6D6D616E6473486973746F72792E7065656B28652E636F6D6D616E644964292C693D746869732E636F6D6D616E6473486973746F72792E7065656B28742E636F6D6D616E644964293B6966286E2626692972';
wwv_flow_imp.g_varchar2_table(29634) := '657475726E206E3E693F2D313A313B6966286E2972657475726E2D313B696628692972657475726E20313B696628746869732E6F7074696F6E732E737567676573746564436F6D6D616E64496473297B636F6E7374206E3D746869732E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(29635) := '2E737567676573746564436F6D6D616E644964732E68617328652E636F6D6D616E644964292C693D746869732E6F7074696F6E732E737567676573746564436F6D6D616E644964732E68617328742E636F6D6D616E644964293B6966286E262669297265';
wwv_flow_imp.g_varchar2_table(29636) := '7475726E20303B6966286E2972657475726E2D313B696628692972657475726E20317D72657475726E20652E6C6162656C2E6C6F63616C65436F6D7061726528742E6C6162656C297D29293B636F6E737420753D5B5D3B6C657420703D21312C673D2130';
wwv_flow_imp.g_varchar2_table(29637) := '2C6D3D2121746869732E6F7074696F6E732E737567676573746564436F6D6D616E644964733B666F72286C657420653D303B653C642E6C656E6774683B652B2B297B636F6E737420743D645B655D3B303D3D3D652626746869732E636F6D6D616E647348';
wwv_flow_imp.g_varchar2_table(29638) := '6973746F72792E7065656B28742E636F6D6D616E64496429262628752E70757368287B747970653A22736570617261746F72222C6C6162656C3A6228302C22726563656E746C79207573656422297D292C703D2130292C672626766F69642030213D3D74';
wwv_flow_imp.g_varchar2_table(29639) := '2E746649646653636F7265262628752E70757368287B747970653A22736570617261746F72222C6C6162656C3A6228302C2273696D696C617220636F6D6D616E647322297D292C673D2131292C6D2626766F696420303D3D3D742E746649646653636F72';
wwv_flow_imp.g_varchar2_table(29640) := '65262621746869732E636F6D6D616E6473486973746F72792E7065656B28742E636F6D6D616E644964292626286E756C6C3D3D3D28723D746869732E6F7074696F6E732E737567676573746564436F6D6D616E64496473297C7C766F696420303D3D3D72';
wwv_flow_imp.g_varchar2_table(29641) := '3F766F696420303A722E68617328742E636F6D6D616E6449642929262628752E70757368287B747970653A22736570617261746F72222C6C6162656C3A6228302C22636F6D6D6F6E6C79207573656422297D292C703D21302C6D3D2131292C21707C7C76';
wwv_flow_imp.g_varchar2_table(29642) := '6F69642030213D3D742E746649646653636F72657C7C746869732E636F6D6D616E6473486973746F72792E7065656B28742E636F6D6D616E644964297C7C286E756C6C3D3D3D28613D746869732E6F7074696F6E732E737567676573746564436F6D6D61';
wwv_flow_imp.g_varchar2_table(29643) := '6E64496473297C7C766F696420303D3D3D613F766F696420303A612E68617328742E636F6D6D616E64496429297C7C28752E70757368287B747970653A22736570617261746F72222C6C6162656C3A6228302C226F7468657220636F6D6D616E64732229';
wwv_flow_imp.g_varchar2_table(29644) := '7D292C703D2131292C752E7075736828746869732E746F436F6D6D616E645069636B28742C6929297D72657475726E20746869732E6861734164646974696F6E616C436F6D6D616E645069636B7328652C6E293F7B7069636B733A752C6164646974696F';
wwv_flow_imp.g_varchar2_table(29645) := '6E616C5069636B733A286173796E6328293D3E7B76617220743B636F6E7374206F3D617761697420746869732E6765744164646974696F6E616C436F6D6D616E645069636B73286C2C642C652C6E293B6966286E2E697343616E63656C6C6174696F6E52';
wwv_flow_imp.g_varchar2_table(29646) := '65717565737465642972657475726E5B5D3B636F6E737420733D6F2E6D61702828653D3E746869732E746F436F6D6D616E645069636B28652C692929293B72657475726E2067262622736570617261746F7222213D3D286E756C6C3D3D3D28743D735B30';
wwv_flow_imp.g_varchar2_table(29647) := '5D297C7C766F696420303D3D3D743F766F696420303A742E74797065292626732E756E7368696674287B747970653A22736570617261746F72222C6C6162656C3A6228302C2273696D696C617220636F6D6D616E647322297D292C737D2928297D3A757D';
wwv_flow_imp.g_varchar2_table(29648) := '746F436F6D6D616E645069636B28652C74297B69662822736570617261746F72223D3D3D652E747970652972657475726E20653B636F6E7374206E3D746869732E6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728';
wwv_flow_imp.g_varchar2_table(29649) := '652E636F6D6D616E644964292C693D6E3F6228302C227B307D2C207B317D222C652E6C6162656C2C6E2E676574417269614C6162656C2829293A652E6C6162656C3B72657475726E7B2E2E2E652C617269614C6162656C3A692C64657461696C3A746869';
wwv_flow_imp.g_varchar2_table(29650) := '732E6F7074696F6E732E73686F77416C6961732626652E636F6D6D616E64416C696173213D3D652E6C6162656C3F652E636F6D6D616E64416C6961733A766F696420302C6B657962696E64696E673A6E2C6163636570743A6173796E6328293D3E7B7661';
wwv_flow_imp.g_varchar2_table(29651) := '72206E2C693B746869732E636F6D6D616E6473486973746F72792E7075736828652E636F6D6D616E644964292C746869732E74656C656D65747279536572766963652E7075626C69634C6F67322822776F726B62656E6368416374696F6E457865637574';
wwv_flow_imp.g_varchar2_table(29652) := '6564222C7B69643A652E636F6D6D616E6449642C66726F6D3A6E756C6C213D3D286E3D6E756C6C3D3D743F766F696420303A742E66726F6D292626766F69642030213D3D6E3F6E3A22717569636B206F70656E227D293B7472797B286E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(29653) := '693D652E61726773297C7C766F696420303D3D3D693F766F696420303A692E6C656E677468293F617761697420746869732E636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652E636F6D6D616E6449642C2E2E2E652E617267';
wwv_flow_imp.g_varchar2_table(29654) := '73293A617761697420746869732E636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652E636F6D6D616E644964297D63617463682874297B54652874297C7C746869732E6469616C6F67536572766963652E6572726F72286228';
wwv_flow_imp.g_varchar2_table(29655) := '302C22436F6D6D616E6420277B307D2720726573756C74656420696E20616E206572726F72222C652E6C6162656C292C5937287429297D7D7D7D67657454664964664368756E6B287B6C6162656C3A652C636F6D6D616E64416C6961733A742C636F6D6D';
wwv_flow_imp.g_varchar2_table(29656) := '616E644465736372697074696F6E3A6E7D297B6C657420693D653B72657475726E2074262674213D3D65262628692B3D60202D20247B747D60292C6E26266E2E76616C7565213D3D65262628692B3D60202D20247B6E2E76616C75653D3D3D6E2E6F7269';
wwv_flow_imp.g_varchar2_table(29657) := '67696E616C3F6E2E76616C75653A60247B6E2E76616C75657D2028247B6E2E6F726967696E616C7D29607D60292C697D7D3B61382E5052454649583D223E222C61382E54464944465F5448524553484F4C443D2E352C61382E54464944465F4D41585F52';
wwv_flow_imp.g_varchar2_table(29658) := '4553554C54533D352C61382E574F52445F46494C5445523D76612862612C2866756E6374696F6E28652C742C6E3D2131297B69662821747C7C303D3D3D742E6C656E6774682972657475726E206E756C6C3B6C657420693D6E756C6C2C6F3D303B666F72';
wwv_flow_imp.g_varchar2_table(29659) := '28653D652E746F4C6F7765724361736528292C743D742E746F4C6F7765724361736528293B6F3C742E6C656E677468262628693D466128652C742C302C6F2C6E292C6E756C6C3D3D3D69293B296F3D426128742C6F2B31293B72657475726E20697D292C';
wwv_flow_imp.g_varchar2_table(29660) := '7961292C61383D69383D7338285B723828312C7563292C723828322C2445292C723828332C7863292C723828342C4F64292C723828352C5837295D2C6138293B6C6574206C383D6F383D636C61737320657874656E6473206C747B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(29661) := '6F7228652C742C6E297B737570657228292C746869732E73746F72616765536572766963653D652C746869732E636F6E66696775726174696F6E536572766963653D742C746869732E6C6F67536572766963653D6E2C746869732E636F6E666967757265';
wwv_flow_imp.g_varchar2_table(29662) := '64436F6D6D616E6473486973746F72794C656E6774683D302C746869732E757064617465436F6E66696775726174696F6E28292C746869732E6C6F616428292C746869732E72656769737465724C697374656E65727328297D72656769737465724C6973';
wwv_flow_imp.g_varchar2_table(29663) := '74656E65727328297B746869732E5F726567697374657228746869732E636F6E66696775726174696F6E536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E746869732E757064617465436F6E66696775726174';
wwv_flow_imp.g_varchar2_table(29664) := '696F6E2865292929292C746869732E5F726567697374657228746869732E73746F72616765536572766963652E6F6E57696C6C5361766553746174652828653D3E7B652E726561736F6E3D3D3D59422E53485554444F574E2626746869732E7361766553';
wwv_flow_imp.g_varchar2_table(29665) := '7461746528297D2929297D757064617465436F6E66696775726174696F6E2865297B65262621652E61666665637473436F6E66696775726174696F6E2822776F726B62656E63682E636F6D6D616E6450616C657474652E686973746F727922297C7C2874';
wwv_flow_imp.g_varchar2_table(29666) := '6869732E636F6E66696775726564436F6D6D616E6473486973746F72794C656E6774683D6F382E676574436F6E66696775726564436F6D6D616E64486973746F72794C656E67746828746869732E636F6E66696775726174696F6E53657276696365292C';
wwv_flow_imp.g_varchar2_table(29667) := '6F382E636163686526266F382E63616368652E6C696D6974213D3D746869732E636F6E66696775726564436F6D6D616E6473486973746F72794C656E6774682626286F382E63616368652E6C696D69743D746869732E636F6E66696775726564436F6D6D';
wwv_flow_imp.g_varchar2_table(29668) := '616E6473486973746F72794C656E6774682C6F382E6861734368616E6765733D213029297D6C6F616428297B636F6E737420653D746869732E73746F72616765536572766963652E676574286F382E505245465F4B45595F43414348452C30293B6C6574';
wwv_flow_imp.g_varchar2_table(29669) := '20743B69662865297472797B743D4A534F4E2E70617273652865297D63617463682865297B746869732E6C6F67536572766963652E6572726F7228605B436F6D6D616E6473486973746F72795D20696E76616C696420646174613A20247B657D60297D63';
wwv_flow_imp.g_varchar2_table(29670) := '6F6E7374206E3D6F382E63616368653D6E657720616128746869732E636F6E66696775726564436F6D6D616E6473486973746F72794C656E6774682C31293B69662874297B6C657420653B653D742E757365734C52553F742E656E74726965733A742E65';
wwv_flow_imp.g_varchar2_table(29671) := '6E74726965732E736F7274282828652C74293D3E652E76616C75652D742E76616C756529292C652E666F72456163682828653D3E6E2E73657428652E6B65792C652E76616C75652929297D6F382E636F756E7465723D746869732E73746F726167655365';
wwv_flow_imp.g_varchar2_table(29672) := '72766963652E6765744E756D626572286F382E505245465F4B45595F434F554E5445522C302C6F382E636F756E746572297D707573682865297B6F382E63616368652626286F382E63616368652E73657428652C6F382E636F756E7465722B2B292C6F38';
wwv_flow_imp.g_varchar2_table(29673) := '2E6861734368616E6765733D2130297D7065656B2865297B76617220743B72657475726E206E756C6C3D3D3D28743D6F382E6361636865297C7C766F696420303D3D3D743F766F696420303A742E7065656B2865297D73617665537461746528297B6966';
wwv_flow_imp.g_varchar2_table(29674) := '28216F382E63616368652972657475726E3B696628216F382E6861734368616E6765732972657475726E3B636F6E737420653D7B757365734C52553A21302C656E74726965733A5B5D7D3B6F382E63616368652E666F7245616368282828742C6E293D3E';
wwv_flow_imp.g_varchar2_table(29675) := '652E656E74726965732E70757368287B6B65793A6E2C76616C75653A747D2929292C746869732E73746F72616765536572766963652E73746F7265286F382E505245465F4B45595F43414348452C4A534F4E2E737472696E676966792865292C302C3029';
wwv_flow_imp.g_varchar2_table(29676) := '2C746869732E73746F72616765536572766963652E73746F7265286F382E505245465F4B45595F434F554E5445522C6F382E636F756E7465722C302C30292C6F382E6861734368616E6765733D21317D73746174696320676574436F6E66696775726564';
wwv_flow_imp.g_varchar2_table(29677) := '436F6D6D616E64486973746F72794C656E6774682865297B76617220742C6E3B636F6E737420693D6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D652E67657456616C756528292E776F726B62656E6368297C7C766F696420303D3D3D743F766F6964';
wwv_flow_imp.g_varchar2_table(29678) := '20303A742E636F6D6D616E6450616C65747465297C7C766F696420303D3D3D6E3F766F696420303A6E2E686973746F72793B72657475726E226E756D626572223D3D747970656F6620693F693A6F382E44454641554C545F434F4D4D414E44535F484953';
wwv_flow_imp.g_varchar2_table(29679) := '544F52595F4C454E4754487D7D3B6C382E44454641554C545F434F4D4D414E44535F484953544F52595F4C454E4754483D35302C6C382E505245465F4B45595F43414348453D22636F6D6D616E6450616C657474652E6D72752E6361636865222C6C382E';
wwv_flow_imp.g_varchar2_table(29680) := '505245465F4B45595F434F554E5445523D22636F6D6D616E6450616C657474652E6D72752E636F756E746572222C6C382E636F756E7465723D312C6C382E6861734368616E6765733D21312C6C383D6F383D7338285B723828302C5142292C723828312C';
wwv_flow_imp.g_varchar2_table(29681) := '6670292C723828322C5264295D2C6C38293B636C61737320633820657874656E64732061387B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228652C742C6E2C692C6F2C73297D676574436F6465456469746F72436F6D6D61';
wwv_flow_imp.g_varchar2_table(29682) := '6E645069636B7328297B76617220653B636F6E737420743D746869732E61637469766554657874456469746F72436F6E74726F6C3B69662821742972657475726E5B5D3B636F6E7374206E3D5B5D3B666F7228636F6E7374206F206F6620742E67657453';
wwv_flow_imp.g_varchar2_table(29683) := '7570706F72746564416374696F6E732829297B6C657420743B286E756C6C3D3D3D28653D6F2E6D65746164617461297C7C766F696420303D3D3D653F766F696420303A652E6465736372697074696F6E29262628743D28693D6F2E6D657461646174612E';
wwv_flow_imp.g_varchar2_table(29684) := '6465736372697074696F6E292626226F626A656374223D3D747970656F662069262622737472696E67223D3D747970656F6620692E6F726967696E616C262622737472696E67223D3D747970656F6620692E76616C75653F6F2E6D657461646174612E64';
wwv_flow_imp.g_varchar2_table(29685) := '65736372697074696F6E3A7B6F726967696E616C3A6F2E6D657461646174612E6465736372697074696F6E2C76616C75653A6F2E6D657461646174612E6465736372697074696F6E7D292C6E2E70757368287B636F6D6D616E6449643A6F2E69642C636F';
wwv_flow_imp.g_varchar2_table(29686) := '6D6D616E64416C6961733A6F2E616C6961732C636F6D6D616E644465736372697074696F6E3A742C6C6162656C3A506C286F2E6C6162656C297C7C6F2E69647D297D76617220693B72657475726E206E7D7D7661722064383D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(29687) := '74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742068383D636C61737320657874656E64732063387B6765742061637469766554657874456469746F72436F6E74726F6C28297B76617220653B7265747572';
wwv_flow_imp.g_varchar2_table(29688) := '6E206E756C6C213D3D28653D746869732E636F6465456469746F72536572766963652E676574466F6375736564436F6465456469746F722829292626766F69642030213D3D653F653A766F696420307D636F6E7374727563746F7228652C742C6E2C692C';
wwv_flow_imp.g_varchar2_table(29689) := '6F2C73297B7375706572287B73686F77416C6961733A21317D2C652C6E2C692C6F2C73292C746869732E636F6465456469746F72536572766963653D747D6173796E6320676574436F6D6D616E645069636B7328297B72657475726E20746869732E6765';
wwv_flow_imp.g_varchar2_table(29690) := '74436F6465456469746F72436F6D6D616E645069636B7328297D6861734164646974696F6E616C436F6D6D616E645069636B7328297B72657475726E21317D6173796E63206765744164646974696F6E616C436F6D6D616E645069636B7328297B726574';
wwv_flow_imp.g_varchar2_table(29691) := '75726E5B5D7D7D3B68383D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F7065727479446573637269';
wwv_flow_imp.g_varchar2_table(29692) := '70746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C';
wwv_flow_imp.g_varchar2_table(29693) := '6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626';
wwv_flow_imp.g_varchar2_table(29694) := '7226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B643828302C7563292C643828312C6763292C643828322C2445292C643828332C7863292C643828342C4F64292C643828352C5837295D2C6838293B636C617373';
wwv_flow_imp.g_varchar2_table(29695) := '20753820657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A75382E49442C6C6162656C3A46322E717569636B436F6D6D616E64416374696F6E4C6162656C2C616C6961733A22436F6D6D616E642050616C65747465';
wwv_flow_imp.g_varchar2_table(29696) := '222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A35392C7765696768743A3130307D2C636F6E746578744D656E754F7074733A7B67726F75703A227A5F636F6D6D61';
wwv_flow_imp.g_varchar2_table(29697) := '6E6473222C6F726465723A317D7D297D72756E2865297B652E676574284C45292E717569636B4163636573732E73686F772868382E505245464958297D7D75382E49443D22656469746F722E616374696F6E2E717569636B436F6D6D616E64222C5A6428';
wwv_flow_imp.g_varchar2_table(29698) := '7538292C79642E6173284E32292E7265676973746572517569636B41636365737350726F7669646572287B63746F723A68382C7072656669783A68382E5052454649582C68656C70456E74726965733A5B7B6465736372697074696F6E3A46322E717569';
wwv_flow_imp.g_varchar2_table(29699) := '636B436F6D6D616E6448656C702C636F6D6D616E6449643A75382E49447D5D7D293B7661722070382C67383D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206D383D70383D';
wwv_flow_imp.g_varchar2_table(29700) := '636C6173737B636F6E7374727563746F7228652C74297B746869732E717569636B496E707574536572766963653D652C746869732E6B657962696E64696E67536572766963653D742C746869732E72656769737472793D79642E6173284E32297D70726F';
wwv_flow_imp.g_varchar2_table(29701) := '766964652865297B636F6E737420743D6E65772061743B72657475726E20742E61646428652E6F6E446964416363657074282828293D3E7B636F6E73745B745D3D652E73656C65637465644974656D733B742626746869732E717569636B496E70757453';
wwv_flow_imp.g_varchar2_table(29702) := '6572766963652E717569636B4163636573732E73686F7728742E7072656669782C7B707265736572766556616C75653A21307D297D2929292C742E61646428652E6F6E4469644368616E676556616C75652828653D3E7B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(29703) := '72656769737472792E676574517569636B41636365737350726F766964657228652E7375627374722870382E5052454649582E6C656E67746829293B742626742E7072656669782626742E707265666978213D3D70382E5052454649582626746869732E';
wwv_flow_imp.g_varchar2_table(29704) := '717569636B496E707574536572766963652E717569636B4163636573732E73686F7728742E7072656669782C7B707265736572766556616C75653A21307D297D2929292C652E6974656D733D746869732E676574517569636B41636365737350726F7669';
wwv_flow_imp.g_varchar2_table(29705) := '6465727328292E66696C7465722828653D3E652E707265666978213D3D70382E50524546495829292C747D676574517569636B41636365737350726F76696465727328297B72657475726E20746869732E72656769737472792E676574517569636B4163';
wwv_flow_imp.g_varchar2_table(29706) := '6365737350726F76696465727328292E736F7274282828652C74293D3E652E7072656669782E6C6F63616C65436F6D7061726528742E7072656669782929292E666C61744D61702828653D3E746869732E6372656174655069636B7328652929297D6372';
wwv_flow_imp.g_varchar2_table(29707) := '656174655069636B732865297B72657475726E20652E68656C70456E74726965732E6D61702828743D3E7B636F6E7374206E3D742E7072656669787C7C652E7072656669782C693D6E7C7C22E280A6223B72657475726E7B7072656669783A6E2C6C6162';
wwv_flow_imp.g_varchar2_table(29708) := '656C3A692C6B657962696E64696E673A742E636F6D6D616E6449643F746869732E6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728742E636F6D6D616E644964293A766F696420302C617269614C6162656C3A6228';
wwv_flow_imp.g_varchar2_table(29709) := '302C227B307D2C207B317D222C692C742E6465736372697074696F6E292C6465736372697074696F6E3A742E6465736372697074696F6E7D7D29297D7D3B6D382E5052454649583D223F222C6D383D70383D66756E6374696F6E28652C742C6E2C69297B';
wwv_flow_imp.g_varchar2_table(29710) := '766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D74797065';
wwv_flow_imp.g_varchar2_table(29711) := '6F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(29712) := '313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C';
wwv_flow_imp.g_varchar2_table(29713) := '72292C727D285B673828302C4C45292C673828312C2445295D2C6D38292C79642E6173284E32292E7265676973746572517569636B41636365737350726F7669646572287B63746F723A6D382C7072656669783A22222C68656C70456E74726965733A5B';
wwv_flow_imp.g_varchar2_table(29714) := '7B6465736372697074696F6E3A52322E68656C70517569636B416363657373416374696F6E4C6162656C7D5D7D293B636F6E73742066383D5B766F696420302C5B5D5D3B66756E6374696F6E20763828652C742C6E3D302C693D30297B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(29715) := '3D743B72657475726E206F2E76616C75657326266F2E76616C7565732E6C656E6774683E313F66756E6374696F6E28652C742C6E2C69297B6C6574206F3D303B636F6E737420733D5B5D3B666F7228636F6E73742072206F662074297B636F6E73745B74';
wwv_flow_imp.g_varchar2_table(29716) := '2C615D3D623828652C722C6E2C69293B696628226E756D62657222213D747970656F6620742972657475726E2066383B6F2B3D742C732E70757368282E2E2E61297D72657475726E5B6F2C5F382873295D7D28652C6F2E76616C7565732C6E2C69293A62';
wwv_flow_imp.g_varchar2_table(29717) := '3828652C742C6E2C69297D66756E6374696F6E20623828652C742C6E2C69297B636F6E7374206F3D616C28742E6F726967696E616C2C742E6F726967696E616C4C6F776572636173652C6E2C652C652E746F4C6F7765724361736528292C692C7B666972';
wwv_flow_imp.g_varchar2_table(29718) := '73744D6174636843616E42655765616B3A21302C626F6F737446756C6C4D617463683A21307D293B72657475726E206F3F5B6F5B305D2C2461286F295D3A66387D66756E6374696F6E205F382865297B636F6E737420743D652E736F7274282828652C74';
wwv_flow_imp.g_varchar2_table(29719) := '293D3E652E73746172742D742E737461727429292C6E3D5B5D3B6C657420693B666F7228636F6E73742065206F6620742921697C7C28733D652C286F3D69292E656E643C732E73746172747C7C732E656E643C6F2E7374617274293F28693D652C6E2E70';
wwv_flow_imp.g_varchar2_table(29720) := '757368286529293A28692E73746172743D4D6174682E6D696E28692E73746172742C652E7374617274292C692E656E643D4D6174682E6D617828692E656E642C652E656E6429293B766172206F2C733B72657475726E206E7D66756E6374696F6E207938';
wwv_flow_imp.g_varchar2_table(29721) := '2865297B72657475726E20652E7374617274735769746828272227292626652E656E64735769746828272227297D4F626A6563742E667265657A65287B73636F72653A307D293B636F6E73742077383D2220223B66756E6374696F6E2043382865297B22';
wwv_flow_imp.g_varchar2_table(29722) := '737472696E6722213D747970656F662065262628653D2222293B636F6E737420743D652E746F4C6F7765724361736528292C7B706174684E6F726D616C697A65643A6E2C6E6F726D616C697A65643A692C6E6F726D616C697A65644C6F77657263617365';
wwv_flow_imp.g_varchar2_table(29723) := '3A6F7D3D53382865292C733D6E2E696E6465784F6628456F293E3D302C723D79382865293B6C657420613B636F6E7374206C3D652E73706C6974287738293B6966286C2E6C656E6774683E3129666F7228636F6E73742065206F66206C297B636F6E7374';
wwv_flow_imp.g_varchar2_table(29724) := '20743D79382865292C7B706174684E6F726D616C697A65643A6E2C6E6F726D616C697A65643A692C6E6F726D616C697A65644C6F776572636173653A6F7D3D53382865293B69262628617C7C28613D5B5D292C612E70757368287B6F726967696E616C3A';
wwv_flow_imp.g_varchar2_table(29725) := '652C6F726967696E616C4C6F776572636173653A652E746F4C6F7765724361736528292C706174684E6F726D616C697A65643A6E2C6E6F726D616C697A65643A692C6E6F726D616C697A65644C6F776572636173653A6F2C657870656374436F6E746967';
wwv_flow_imp.g_varchar2_table(29726) := '756F75734D617463683A747D29297D72657475726E7B6F726967696E616C3A652C6F726967696E616C4C6F776572636173653A742C706174684E6F726D616C697A65643A6E2C6E6F726D616C697A65643A692C6E6F726D616C697A65644C6F7765726361';
wwv_flow_imp.g_varchar2_table(29727) := '73653A6F2C76616C7565733A612C636F6E7461696E7350617468536570617261746F723A732C657870656374436F6E746967756F75734D617463683A727D7D66756E6374696F6E2053382865297B6C657420743B743D6A3F652E7265706C616365282F5C';
wwv_flow_imp.g_varchar2_table(29728) := '2F2F672C456F293A652E7265706C616365282F5C5C2F672C456F293B636F6E7374206E3D28693D742C692E7265706C616365282F5C2A2F672C222229292E7265706C616365282F5C737C222F672C2222293B76617220693B72657475726E7B706174684E';
wwv_flow_imp.g_varchar2_table(29729) := '6F726D616C697A65643A742C6E6F726D616C697A65643A6E2C6E6F726D616C697A65644C6F776572636173653A6E2E746F4C6F7765724361736528297D7D66756E6374696F6E2078382865297B72657475726E2041727261792E69734172726179286529';
wwv_flow_imp.g_varchar2_table(29730) := '3F433828652E6D61702828653D3E652E6F726967696E616C29292E6A6F696E28773829293A433828652E6F726967696E616C297D766172206B382C45383D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E';
wwv_flow_imp.g_varchar2_table(29731) := '2C692C65297D7D3B6C6574204C383D6B383D636C61737320657874656E64732049327B636F6E7374727563746F7228652C742C6E3D4F626A6563742E637265617465286E756C6C29297B7375706572286E292C746869732E5F6C616E6775616765466561';
wwv_flow_imp.g_varchar2_table(29732) := '7475726573536572766963653D652C746869732E5F6F75746C696E654D6F64656C536572766963653D742C746869732E6F7074696F6E733D6E2C746869732E6F7074696F6E732E63616E416363657074496E4261636B67726F756E643D21307D70726F76';
wwv_flow_imp.g_varchar2_table(29733) := '696465576974686F757454657874456469746F722865297B72657475726E20746869732E70726F766964654C6162656C5069636B28652C6228302C22546F20676F20746F20612073796D626F6C2C206669727374206F70656E2061207465787420656469';
wwv_flow_imp.g_varchar2_table(29734) := '746F7220776974682073796D626F6C20696E666F726D6174696F6E2E2229292C6C742E4E6F6E657D70726F766964655769746854657874456469746F7228652C742C6E297B636F6E737420693D652E656469746F722C6F3D746869732E6765744D6F6465';
wwv_flow_imp.g_varchar2_table(29735) := '6C2869293B72657475726E206F3F746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7453796D626F6C50726F76696465722E686173286F293F746869732E646F50726F7669646557697468456469746F725379';
wwv_flow_imp.g_varchar2_table(29736) := '6D626F6C7328652C6F2C742C6E293A746869732E646F50726F76696465576974686F7574456469746F7253796D626F6C7328652C6F2C742C6E293A6C742E4E6F6E657D646F50726F76696465576974686F7574456469746F7253796D626F6C7328652C74';
wwv_flow_imp.g_varchar2_table(29737) := '2C6E2C69297B636F6E7374206F3D6E65772061743B72657475726E20746869732E70726F766964654C6162656C5069636B286E2C6228302C2254686520616374697665207465787420656469746F7220646F6573206E6F742070726F766964652073796D';
wwv_flow_imp.g_varchar2_table(29738) := '626F6C20696E666F726D6174696F6E2E2229292C286173796E6328293D3E7B617761697420746869732E77616974466F724C616E677561676553796D626F6C526567697374727928742C6F29262621692E697343616E63656C6C6174696F6E5265717565';
wwv_flow_imp.g_varchar2_table(29739) := '7374656426266F2E61646428746869732E646F50726F7669646557697468456469746F7253796D626F6C7328652C742C6E2C6929297D2928292C6F7D70726F766964654C6162656C5069636B28652C74297B652E6974656D733D5B7B6C6162656C3A742C';
wwv_flow_imp.g_varchar2_table(29740) := '696E6465783A302C6B696E643A31347D5D2C652E617269614C6162656C3D747D6173796E632077616974466F724C616E677561676553796D626F6C526567697374727928652C74297B696628746869732E5F6C616E677561676546656174757265735365';
wwv_flow_imp.g_varchar2_table(29741) := '72766963652E646F63756D656E7453796D626F6C50726F76696465722E6861732865292972657475726E21303B636F6E7374206E3D6E65772058742C693D742E61646428746869732E5F6C616E67756167654665617475726573536572766963652E646F';
wwv_flow_imp.g_varchar2_table(29742) := '63756D656E7453796D626F6C50726F76696465722E6F6E4469644368616E6765282828293D3E7B746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7453796D626F6C50726F76696465722E6861732865292626';
wwv_flow_imp.g_varchar2_table(29743) := '28692E646973706F736528292C6E2E636F6D706C65746528213029297D2929293B72657475726E20742E616464287274282828293D3E6E2E636F6D706C657465282131292929292C6E2E707D646F50726F7669646557697468456469746F7253796D626F';
wwv_flow_imp.g_varchar2_table(29744) := '6C7328652C742C6E2C69297B766172206F3B636F6E737420733D652E656469746F722C723D6E65772061743B722E616464286E2E6F6E4469644163636570742828743D3E7B636F6E73745B695D3D6E2E73656C65637465644974656D733B692626692E72';
wwv_flow_imp.g_varchar2_table(29745) := '616E6765262628746869732E676F746F4C6F636174696F6E28652C7B72616E67653A692E72616E67652E73656C656374696F6E2C6B65794D6F64733A6E2E6B65794D6F64732C7072657365727665466F6375733A742E696E4261636B67726F756E647D29';
wwv_flow_imp.g_varchar2_table(29746) := '2C742E696E4261636B67726F756E647C7C6E2E686964652829297D2929292C722E616464286E2E6F6E446964547269676765724974656D427574746F6E2828287B6974656D3A747D293D3E7B742626742E72616E6765262628746869732E676F746F4C6F';
wwv_flow_imp.g_varchar2_table(29747) := '636174696F6E28652C7B72616E67653A742E72616E67652E73656C656374696F6E2C6B65794D6F64733A6E2E6B65794D6F64732C666F726365536964654279536964653A21307D292C6E2E686964652829297D2929293B636F6E737420613D746869732E';
wwv_flow_imp.g_varchar2_table(29748) := '676574446F63756D656E7453796D626F6C7328742C69293B6C6574206C3B636F6E737420633D6173796E6320653D3E7B6E756C6C3D3D6C7C7C6C2E646973706F7365282130292C6E2E627573793D21312C6C3D6E6577204E742869292C6E2E627573793D';
wwv_flow_imp.g_varchar2_table(29749) := '21303B7472797B636F6E737420743D4338286E2E76616C75652E737562737472286B382E5052454649582E6C656E677468292E7472696D2829292C6F3D617761697420746869732E646F47657453796D626F6C5069636B7328612C742C766F696420302C';
wwv_flow_imp.g_varchar2_table(29750) := '6C2E746F6B656E293B696628692E697343616E63656C6C6174696F6E5265717565737465642972657475726E3B6966286F2E6C656E6774683E30297B6966286E2E6974656D733D6F2C652626303D3D3D742E6F726967696E616C2E6C656E677468297B63';
wwv_flow_imp.g_varchar2_table(29751) := '6F6E737420743D7675286F2C28743D3E426F6F6C65616E2822736570617261746F7222213D3D742E747970652626742E72616E6765262672682E636F6E7461696E73506F736974696F6E28742E72616E67652E6465636F726174696F6E2C65292929293B';
wwv_flow_imp.g_varchar2_table(29752) := '742626286E2E6163746976654974656D733D5B745D297D7D656C736520742E6F726967696E616C2E6C656E6774683E303F746869732E70726F766964654C6162656C5069636B286E2C6228302C224E6F206D61746368696E6720656469746F722073796D';
wwv_flow_imp.g_varchar2_table(29753) := '626F6C732229293A746869732E70726F766964654C6162656C5069636B286E2C6228302C224E6F20656469746F722073796D626F6C732229297D66696E616C6C797B692E697343616E63656C6C6174696F6E5265717565737465647C7C286E2E62757379';
wwv_flow_imp.g_varchar2_table(29754) := '3D2131297D7D3B72657475726E20722E616464286E2E6F6E4469644368616E676556616C7565282828293D3E6328766F69642030292929292C63286E756C6C3D3D3D286F3D732E67657453656C656374696F6E2829297C7C766F696420303D3D3D6F3F76';
wwv_flow_imp.g_varchar2_table(29755) := '6F696420303A6F2E676574506F736974696F6E2829292C722E616464286E2E6F6E4469644368616E6765416374697665282828293D3E7B636F6E73745B655D3D6E2E6163746976654974656D733B652626652E72616E6765262628732E72657665616C52';
wwv_flow_imp.g_varchar2_table(29756) := '616E6765496E43656E74657228652E72616E67652E73656C656374696F6E2C30292C746869732E6164644465636F726174696F6E7328732C652E72616E67652E6465636F726174696F6E29297D2929292C727D6173796E6320646F47657453796D626F6C';
wwv_flow_imp.g_varchar2_table(29757) := '5069636B7328652C742C6E2C69297B766172206F2C733B636F6E737420723D617761697420653B696628692E697343616E63656C6C6174696F6E5265717565737465642972657475726E5B5D3B636F6E737420613D303D3D3D742E6F726967696E616C2E';
wwv_flow_imp.g_varchar2_table(29758) := '696E6465784F66286B382E53434F50455F505245464958292C6C3D613F313A303B6C657420632C642C683B742E76616C7565732626742E76616C7565732E6C656E6774683E313F28633D783828742E76616C7565735B305D292C643D783828742E76616C';
wwv_flow_imp.g_varchar2_table(29759) := '7565732E736C69636528312929293A633D743B636F6E737420753D6E756C6C3D3D3D28733D6E756C6C3D3D3D286F3D746869732E6F7074696F6E73297C7C766F696420303D3D3D6F3F766F696420303A6F2E6F70656E5369646542795369646544697265';
wwv_flow_imp.g_varchar2_table(29760) := '6374696F6E297C7C766F696420303D3D3D733F766F696420303A732E63616C6C286F293B75262628683D5B7B69636F6E436C6173733A227269676874223D3D3D753F546C2E6173436C6173734E616D65284C6C2E73706C6974486F72697A6F6E74616C29';
wwv_flow_imp.g_varchar2_table(29761) := '3A546C2E6173436C6173734E616D65284C6C2E73706C6974566572746963616C292C746F6F6C7469703A6228302C227269676874223D3D3D753F224F70656E20746F207468652053696465223A224F70656E20746F2074686520426F74746F6D22297D5D';
wwv_flow_imp.g_varchar2_table(29762) := '293B636F6E737420703D5B5D3B666F72286C6574205F3D303B5F3C722E6C656E6774683B5F2B2B297B636F6E737420793D725B5F5D2C773D646928792E6E616D65292C433D602428247B4C772E746F49636F6E28792E6B696E64292E69647D2920247B77';
wwv_flow_imp.g_varchar2_table(29763) := '7D602C533D432E6C656E6774682D772E6C656E6774683B6C657420782C6B2C452C4C2C443D792E636F6E7461696E65724E616D653B696628286E756C6C3D3D6E3F766F696420303A6E2E6578747261436F6E7461696E65724C6162656C29262628443D44';
wwv_flow_imp.g_varchar2_table(29764) := '3F60247B6E2E6578747261436F6E7461696E65724C6162656C7D20E280A220247B447D603A6E2E6578747261436F6E7461696E65724C6162656C292C742E6F726967696E616C2E6C656E6774683E6C297B6C657420493D21313B69662863213D3D742626';
wwv_flow_imp.g_varchar2_table(29765) := '285B782C6B5D3D763828432C7B2E2E2E742C76616C7565733A766F696420307D2C6C2C53292C226E756D626572223D3D747970656F662078262628493D213029292C226E756D62657222213D747970656F6620782626285B782C6B5D3D763828432C632C';
wwv_flow_imp.g_varchar2_table(29766) := '6C2C53292C226E756D62657222213D747970656F6620782929636F6E74696E75653B6966282149262664297B696628442626642E6F726967696E616C2E6C656E6774683E302626285B452C4C5D3D763828442C6429292C226E756D62657222213D747970';
wwv_flow_imp.g_varchar2_table(29767) := '656F66204529636F6E74696E75653B226E756D626572223D3D747970656F662078262628782B3D45297D7D636F6E737420543D792E746167732626792E746167732E696E6465784F662831293E3D303B702E70757368287B696E6465783A5F2C6B696E64';
wwv_flow_imp.g_varchar2_table(29768) := '3A792E6B696E642C73636F72653A782C6C6162656C3A432C617269614C6162656C3A28673D792E6E616D652C6D3D792E6B696E642C6228302C227B307D20287B317D29222C672C45775B6D5D29292C6465736372697074696F6E3A442C686967686C6967';
wwv_flow_imp.g_varchar2_table(29769) := '6874733A543F766F696420303A7B6C6162656C3A6B2C6465736372697074696F6E3A4C7D2C72616E67653A7B73656C656374696F6E3A72682E636F6C6C61707365546F537461727428792E73656C656374696F6E52616E6765292C6465636F726174696F';
wwv_flow_imp.g_varchar2_table(29770) := '6E3A792E72616E67657D2C737472696B657468726F7567683A542C627574746F6E733A687D297D76617220672C6D3B636F6E737420663D702E736F7274282828652C74293D3E613F746869732E636F6D7061726542794B696E64416E6453636F72652865';
wwv_flow_imp.g_varchar2_table(29771) := '2C74293A746869732E636F6D70617265427953636F726528652C742929293B6C657420763D5B5D3B69662861297B6C6574204D2C412C4E3D303B66756E6374696F6E205028297B412626226E756D626572223D3D747970656F66204D26264E3E30262628';
wwv_flow_imp.g_varchar2_table(29772) := '412E6C6162656C3D61692854385B4D5D7C7C44382C4E29297D666F7228636F6E7374204F206F662066294D213D3D4F2E6B696E643F285028292C4D3D4F2E6B696E642C4E3D312C413D7B747970653A22736570617261746F72227D2C762E707573682841';
wwv_flow_imp.g_varchar2_table(29773) := '29293A4E2B2B2C762E70757368284F293B5028297D656C736520662E6C656E6774683E30262628763D5B7B6C6162656C3A6228302C2273796D626F6C7320287B307D29222C702E6C656E677468292C747970653A22736570617261746F72227D2C2E2E2E';
wwv_flow_imp.g_varchar2_table(29774) := '665D293B72657475726E20767D636F6D70617265427953636F726528652C74297B696628226E756D62657222213D747970656F6620652E73636F72652626226E756D626572223D3D747970656F6620742E73636F72652972657475726E20313B69662822';
wwv_flow_imp.g_varchar2_table(29775) := '6E756D626572223D3D747970656F6620652E73636F72652626226E756D62657222213D747970656F6620742E73636F72652972657475726E2D313B696628226E756D626572223D3D747970656F6620652E73636F72652626226E756D626572223D3D7479';
wwv_flow_imp.g_varchar2_table(29776) := '70656F6620742E73636F7265297B696628652E73636F72653E742E73636F72652972657475726E2D313B696628652E73636F72653C742E73636F72652972657475726E20317D72657475726E20652E696E6465783C742E696E6465783F2D313A652E696E';
wwv_flow_imp.g_varchar2_table(29777) := '6465783E742E696E6465783F313A307D636F6D7061726542794B696E64416E6453636F726528652C74297B636F6E7374206E3D54385B652E6B696E645D7C7C44382C693D54385B742E6B696E645D7C7C44382C6F3D6E2E6C6F63616C65436F6D70617265';
wwv_flow_imp.g_varchar2_table(29778) := '2869293B72657475726E20303D3D3D6F3F746869732E636F6D70617265427953636F726528652C74293A6F7D6173796E6320676574446F63756D656E7453796D626F6C7328652C74297B636F6E7374206E3D617761697420746869732E5F6F75746C696E';
wwv_flow_imp.g_varchar2_table(29779) := '654D6F64656C536572766963652E6765744F7243726561746528652C74293B72657475726E20742E697343616E63656C6C6174696F6E5265717565737465643F5B5D3A6E2E61734C6973744F66446F63756D656E7453796D626F6C7328297D7D3B4C382E';
wwv_flow_imp.g_varchar2_table(29780) := '5052454649583D2240222C4C382E53434F50455F5052454649583D223A222C4C382E5052454649585F42595F43415445474F52593D60247B6B382E5052454649587D247B6B382E53434F50455F5052454649587D602C4C383D6B383D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(29781) := '28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A';
wwv_flow_imp.g_varchar2_table(29782) := '656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F72287661722061';
wwv_flow_imp.g_varchar2_table(29783) := '3D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F';
wwv_flow_imp.g_varchar2_table(29784) := '706572747928742C6E2C72292C727D285B453828302C7878292C453828312C4B58295D2C4C38293B636F6E73742044383D6228302C2270726F7065727469657320287B307D2922292C54383D7B353A6228302C226D6574686F647320287B307D2922292C';
wwv_flow_imp.g_varchar2_table(29785) := '31313A6228302C2266756E6374696F6E7320287B307D2922292C383A6228302C22636F6E7374727563746F727320287B307D2922292C31323A6228302C227661726961626C657320287B307D2922292C343A6228302C22636C617373657320287B307D29';
wwv_flow_imp.g_varchar2_table(29786) := '22292C32323A6228302C227374727563747320287B307D2922292C32333A6228302C226576656E747320287B307D2922292C32343A6228302C226F70657261746F727320287B307D2922292C31303A6228302C22696E746572666163657320287B307D29';
wwv_flow_imp.g_varchar2_table(29787) := '22292C323A6228302C226E616D6573706163657320287B307D2922292C333A6228302C227061636B6167657320287B307D2922292C32353A6228302C227479706520706172616D657465727320287B307D2922292C313A6228302C226D6F64756C657320';
wwv_flow_imp.g_varchar2_table(29788) := '287B307D2922292C363A6228302C2270726F7065727469657320287B307D2922292C393A6228302C22656E756D65726174696F6E7320287B307D2922292C32313A6228302C22656E756D65726174696F6E206D656D6265727320287B307D2922292C3134';
wwv_flow_imp.g_varchar2_table(29789) := '3A6228302C22737472696E677320287B307D2922292C303A6228302C2266696C657320287B307D2922292C31373A6228302C2261727261797320287B307D2922292C31353A6228302C226E756D6265727320287B307D2922292C31363A6228302C22626F';
wwv_flow_imp.g_varchar2_table(29790) := '6F6C65616E7320287B307D2922292C31383A6228302C226F626A6563747320287B307D2922292C31393A6228302C226B65797320287B307D2922292C373A6228302C226669656C647320287B307D2922292C31333A6228302C22636F6E7374616E747320';
wwv_flow_imp.g_varchar2_table(29791) := '287B307D2922297D3B7661722049383D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204D383D636C61737320657874656E6473204C387B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(29792) := '742C6E297B737570657228742C6E292C746869732E656469746F72536572766963653D652C746869732E6F6E44696441637469766554657874456469746F72436F6E74726F6C4368616E67653D76742E4E6F6E657D676574206163746976655465787445';
wwv_flow_imp.g_varchar2_table(29793) := '6469746F72436F6E74726F6C28297B76617220653B72657475726E206E756C6C213D3D28653D746869732E656469746F72536572766963652E676574466F6375736564436F6465456469746F722829292626766F69642030213D3D653F653A766F696420';
wwv_flow_imp.g_varchar2_table(29794) := '307D7D3B4D383D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F72';
wwv_flow_imp.g_varchar2_table(29795) := '28742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(29796) := '3B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F';
wwv_flow_imp.g_varchar2_table(29797) := '626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B493828302C6763292C493828312C7878292C493828322C4B58295D2C4D38293B636C61737320413820657874656E64732055647B636F6E7374727563746F7228297B7375';
wwv_flow_imp.g_varchar2_table(29798) := '706572287B69643A41382E49442C6C6162656C3A42322E717569636B4F75746C696E65416374696F6E4C6162656C2C616C6961733A22476F20746F2053796D626F6C2E2E2E222C707265636F6E646974696F6E3A6C682E686173446F63756D656E745379';
wwv_flow_imp.g_varchar2_table(29799) := '6D626F6C50726F76696465722C6B624F7074733A7B6B62457870723A6C682E666F6375732C7072696D6172793A333131372C7765696768743A3130307D2C636F6E746578744D656E754F7074733A7B67726F75703A226E617669676174696F6E222C6F72';
wwv_flow_imp.g_varchar2_table(29800) := '6465723A337D7D297D72756E2865297B652E676574284C45292E717569636B4163636573732E73686F77284C382E5052454649582C7B6974656D41637469766174696F6E3A45452E4E4F4E457D297D7D41382E49443D22656469746F722E616374696F6E';
wwv_flow_imp.g_varchar2_table(29801) := '2E717569636B4F75746C696E65222C5A64284138292C79642E6173284E32292E7265676973746572517569636B41636365737350726F7669646572287B63746F723A4D382C7072656669783A4C382E5052454649582C68656C70456E74726965733A5B7B';
wwv_flow_imp.g_varchar2_table(29802) := '6465736372697074696F6E3A42322E717569636B4F75746C696E65416374696F6E4C6162656C2C7072656669783A4C382E5052454649582C636F6D6D616E6449643A41382E49447D2C7B6465736372697074696F6E3A42322E717569636B4F75746C696E';
wwv_flow_imp.g_varchar2_table(29803) := '65427943617465676F7279416374696F6E4C6162656C2C7072656669783A4C382E5052454649585F42595F43415445474F52597D5D7D293B636C617373204E3820657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C74';
wwv_flow_imp.g_varchar2_table(29804) := '6869732E656469746F723D652C746869732E5F726567697374657228746869732E656469746F722E6F6E446964417474656D7074526561644F6E6C7945646974282828293D3E746869732E5F6F6E446964417474656D7074526561644F6E6C7945646974';
wwv_flow_imp.g_varchar2_table(29805) := '28292929297D5F6F6E446964417474656D7074526561644F6E6C794564697428297B636F6E737420653D62452E67657428746869732E656469746F72293B696628652626746869732E656469746F722E6861734D6F64656C2829297B6C657420743D7468';
wwv_flow_imp.g_varchar2_table(29806) := '69732E656469746F722E6765744F7074696F6E7328292E676574283932293B747C7C28743D746869732E656469746F722E697353696D706C655769646765743F6E6577206F63286228302C2243616E6E6F74206564697420696E20726561642D6F6E6C79';
wwv_flow_imp.g_varchar2_table(29807) := '20696E7075742229293A6E6577206F63286228302C2243616E6E6F74206564697420696E20726561642D6F6E6C7920656469746F72222929292C652E73686F774D65737361676528742C746869732E656469746F722E676574506F736974696F6E282929';
wwv_flow_imp.g_varchar2_table(29808) := '7D7D7D4E382E49443D22656469746F722E636F6E747269622E726561644F6E6C794D657373616765436F6E74726F6C6C6572222C4A64284E382E49442C4E382C32293B7661722050383D66756E6374696F6E28652C74297B72657475726E2066756E6374';
wwv_flow_imp.g_varchar2_table(29809) := '696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204F383D636C61737320657874656E64732067517B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B73757065722821302C652C742C6E2C692C6F2C732C72297D7D3B4F383D';
wwv_flow_imp.g_varchar2_table(29810) := '66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A69';
wwv_flow_imp.g_varchar2_table(29811) := '3B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73652066';
wwv_flow_imp.g_varchar2_table(29812) := '6F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E64';
wwv_flow_imp.g_varchar2_table(29813) := '6566696E6550726F706572747928742C6E2C72292C727D285B503828312C6364292C503828322C6763292C503828332C7344292C503828342C7563292C503828352C5142292C503828362C6670295D2C4F38292C4A642867512E49442C4F382C34293B76';
wwv_flow_imp.g_varchar2_table(29814) := '61722052383D6E2838303333292C46383D7B7D3B46382E7374796C655461675472616E73666F726D3D6A7228292C46382E736574417474726962757465733D567228292C46382E696E736572743D467228292E62696E64286E756C6C2C22686561642229';
wwv_flow_imp.g_varchar2_table(29815) := '2C46382E646F6D4150493D4F7228292C46382E696E736572745374796C65456C656D656E743D487228292C4E7228292852382E412C4638292C52382E41262652382E412E6C6F63616C73262652382E412E6C6F63616C733B7661722042383D66756E6374';
wwv_flow_imp.g_varchar2_table(29816) := '696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73742056383D6E6577206C64282272656E616D65496E70757456697369626C65222C21312C6228302C225768657468657220746865207265';
wwv_flow_imp.g_varchar2_table(29817) := '6E616D6520696E707574207769646765742069732076697369626C652229293B6E6577206C64282272656E616D65496E707574466F6375736564222C21312C6228302C2257686574686572207468652072656E616D6520696E7075742077696467657420';
wwv_flow_imp.g_varchar2_table(29818) := '697320666F63757365642229293B6C6574207A383D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E5F656469746F723D652C746869732E5F6163636570744B657962696E64696E67733D742C746869732E5F74';
wwv_flow_imp.g_varchar2_table(29819) := '68656D65536572766963653D6E2C746869732E5F6B657962696E64696E67536572766963653D692C746869732E5F6C6F67536572766963653D732C746869732E616C6C6F77456469746F724F766572666C6F773D21302C746869732E5F646973706F7361';
wwv_flow_imp.g_varchar2_table(29820) := '626C65733D6E65772061742C746869732E5F76697369626C65436F6E746578744B65793D56382E62696E64546F286F292C746869732E5F697345646974696E6752656E616D6543616E6469646174653D21312C746869732E5F6E52656E616D6553756767';
wwv_flow_imp.g_varchar2_table(29821) := '657374696F6E73496E766F636174696F6E733D302C746869732E5F6861644175746F6D6174696352656E616D6553756767657374696F6E73496E766F636174696F6E3D21312C746869732E5F63616E646964617465733D6E6577205365742C746869732E';
wwv_flow_imp.g_varchar2_table(29822) := '5F6265666F72654669727374496E7075744669656C644564697453573D6E65772066742C746869732E5F696E70757457697468427574746F6E3D6E65772057382C746869732E5F646973706F7361626C65732E61646428746869732E5F696E7075745769';
wwv_flow_imp.g_varchar2_table(29823) := '7468427574746F6E292C746869732E5F656469746F722E616464436F6E74656E745769646765742874686973292C746869732E5F646973706F7361626C65732E61646428746869732E5F656469746F722E6F6E4469644368616E6765436F6E6669677572';
wwv_flow_imp.g_varchar2_table(29824) := '6174696F6E2828653D3E7B652E6861734368616E676564283530292626746869732E5F757064617465466F6E7428297D2929292C746869732E5F646973706F7361626C65732E616464286E2E6F6E446964436F6C6F725468656D654368616E6765287468';
wwv_flow_imp.g_varchar2_table(29825) := '69732E5F7570646174655374796C65732C7468697329297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528292C746869732E5F656469746F722E72656D6F7665436F6E74656E74576964676574287468697329';
wwv_flow_imp.g_varchar2_table(29826) := '7D676574496428297B72657475726E225F5F72656E616D65496E707574576964676574227D676574446F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657C7C28746869732E5F646F6D4E6F64653D646F63756D656E742E63726561';
wwv_flow_imp.g_varchar2_table(29827) := '7465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D226D6F6E61636F2D656469746F722072656E616D652D626F78222C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F';
wwv_flow_imp.g_varchar2_table(29828) := '696E70757457697468427574746F6E2E646F6D4E6F6465292C746869732E5F72656E616D6543616E6469646174654C697374566965773D746869732E5F646973706F7361626C65732E616464286E657720483828746869732E5F646F6D4E6F64652C7B66';
wwv_flow_imp.g_varchar2_table(29829) := '6F6E74496E666F3A746869732E5F656469746F722E6765744F7074696F6E283530292C6F6E466F6375734368616E67653A653D3E7B746869732E5F696E70757457697468427574746F6E2E696E7075742E76616C75653D652C746869732E5F6973456469';
wwv_flow_imp.g_varchar2_table(29830) := '74696E6752656E616D6543616E6469646174653D21317D2C6F6E53656C656374696F6E4368616E67653A28293D3E7B746869732E5F697345646974696E6752656E616D6543616E6469646174653D21312C746869732E616363657074496E707574282131';
wwv_flow_imp.g_varchar2_table(29831) := '297D7D29292C746869732E5F646973706F7361626C65732E61646428746869732E5F696E70757457697468427574746F6E2E6F6E446964496E7075744368616E6765282828293D3E7B76617220652C742C6E2C693B766F69642030213D3D286E756C6C3D';
wwv_flow_imp.g_varchar2_table(29832) := '3D3D28653D746869732E5F72656E616D6543616E6469646174654C69737456696577297C7C766F696420303D3D3D653F766F696420303A652E666F637573656443616E64696461746529262628746869732E5F697345646974696E6752656E616D654361';
wwv_flow_imp.g_varchar2_table(29833) := '6E6469646174653D2130292C6E756C6C213D3D28743D746869732E5F74696D654265666F72654669727374496E7075744669656C6445646974292626766F69642030213D3D747C7C28746869732E5F74696D654265666F72654669727374496E70757446';
wwv_flow_imp.g_varchar2_table(29834) := '69656C64456469743D746869732E5F6265666F72654669727374496E7075744669656C644564697453572E656C61707365642829292C21313D3D3D286E756C6C3D3D3D286E3D746869732E5F72656E616D6543616E64696461746550726F766964657273';
wwv_flow_imp.g_varchar2_table(29835) := '437473297C7C766F696420303D3D3D6E3F766F696420303A6E2E746F6B656E2E697343616E63656C6C6174696F6E526571756573746564292626746869732E5F72656E616D6543616E64696461746550726F7669646572734374732E63616E63656C2829';
wwv_flow_imp.g_varchar2_table(29836) := '2C6E756C6C3D3D3D28693D746869732E5F72656E616D6543616E6469646174654C69737456696577297C7C766F696420303D3D3D697C7C692E636C656172466F63757328297D2929292C746869732E5F6C6162656C3D646F63756D656E742E6372656174';
wwv_flow_imp.g_varchar2_table(29837) := '65456C656D656E74282264697622292C746869732E5F6C6162656C2E636C6173734E616D653D2272656E616D652D6C6162656C222C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F6C6162656C292C746869732E5F7570';
wwv_flow_imp.g_varchar2_table(29838) := '64617465466F6E7428292C746869732E5F7570646174655374796C657328746869732E5F7468656D65536572766963652E676574436F6C6F725468656D65282929292C746869732E5F646F6D4E6F64657D5F7570646174655374796C65732865297B7661';
wwv_flow_imp.g_varchar2_table(29839) := '7220742C6E2C692C6F2C733B69662821746869732E5F646F6D4E6F64652972657475726E3B636F6E737420723D652E676574436F6C6F72284E66292C613D652E676574436F6C6F72285066293B746869732E5F646F6D4E6F64652E7374796C652E626163';
wwv_flow_imp.g_varchar2_table(29840) := '6B67726F756E64436F6C6F723D537472696E67286E756C6C213D3D28743D652E676574436F6C6F7228586D29292626766F69642030213D3D743F743A2222292C746869732E5F646F6D4E6F64652E7374796C652E626F78536861646F773D723F60203020';
wwv_flow_imp.g_varchar2_table(29841) := '30203870782032707820247B727D603A22222C746869732E5F646F6D4E6F64652E7374796C652E626F726465723D613F6031707820736F6C696420247B617D603A22222C746869732E5F646F6D4E6F64652E7374796C652E636F6C6F723D537472696E67';
wwv_flow_imp.g_varchar2_table(29842) := '286E756C6C213D3D286E3D652E676574436F6C6F72286C7629292626766F69642030213D3D6E3F6E3A2222293B636F6E7374206C3D652E676574436F6C6F72286376293B746869732E5F696E70757457697468427574746F6E2E646F6D4E6F64652E7374';
wwv_flow_imp.g_varchar2_table(29843) := '796C652E6261636B67726F756E64436F6C6F723D537472696E67286E756C6C213D3D28693D652E676574436F6C6F7228617629292626766F69642030213D3D693F693A2222292C746869732E5F696E70757457697468427574746F6E2E696E7075742E73';
wwv_flow_imp.g_varchar2_table(29844) := '74796C652E6261636B67726F756E64436F6C6F723D537472696E67286E756C6C213D3D286F3D652E676574436F6C6F7228617629292626766F69642030213D3D6F3F6F3A2222292C746869732E5F696E70757457697468427574746F6E2E646F6D4E6F64';
wwv_flow_imp.g_varchar2_table(29845) := '652E7374796C652E626F7264657257696474683D6C3F22317078223A22307078222C746869732E5F696E70757457697468427574746F6E2E646F6D4E6F64652E7374796C652E626F726465725374796C653D6C3F22736F6C6964223A226E6F6E65222C74';
wwv_flow_imp.g_varchar2_table(29846) := '6869732E5F696E70757457697468427574746F6E2E646F6D4E6F64652E7374796C652E626F72646572436F6C6F723D6E756C6C213D3D28733D6E756C6C3D3D6C3F766F696420303A6C2E746F537472696E672829292626766F69642030213D3D733F733A';
wwv_flow_imp.g_varchar2_table(29847) := '226E6F6E65227D5F757064617465466F6E7428297B696628766F696420303D3D3D746869732E5F646F6D4E6F64652972657475726E3B796C28766F69642030213D3D746869732E5F6C6162656C2C2252656E616D65576964676574235F75706461746546';
wwv_flow_imp.g_varchar2_table(29848) := '6F6E743A205F6C6162656C206D757374206E6F7420626520756E646566696E656420676976656E205F646F6D4E6F646520697320646566696E656422292C746869732E5F656469746F722E6170706C79466F6E74496E666F28746869732E5F696E707574';
wwv_flow_imp.g_varchar2_table(29849) := '57697468427574746F6E2E696E707574293B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E283530293B746869732E5F6C6162656C2E7374796C652E666F6E7453697A653D60247B746869732E5F636F6D707574654C616265';
wwv_flow_imp.g_varchar2_table(29850) := '6C466F6E7453697A6528652E666F6E7453697A65297D7078607D5F636F6D707574654C6162656C466F6E7453697A652865297B72657475726E2E382A657D676574506F736974696F6E28297B69662821746869732E5F76697369626C652972657475726E';
wwv_flow_imp.g_varchar2_table(29851) := '206E756C6C3B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F656469746F722E676574446F6D4E6F646528292972657475726E206E756C6C3B636F6E737420653D447328746869732E676574446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(29852) := '28292E6F776E6572446F63756D656E742E626F6479292C743D417328746869732E5F656469746F722E676574446F6D4E6F64652829292C6E3D746869732E5F676574546F70466F72506F736974696F6E28293B746869732E5F6E5078417661696C61626C';
wwv_flow_imp.g_varchar2_table(29853) := '6541626F76653D6E2B742E746F702C746869732E5F6E5078417661696C61626C6542656C6F773D652E6865696768742D746869732E5F6E5078417661696C61626C6541626F76653B636F6E737420693D746869732E5F656469746F722E6765744F707469';
wwv_flow_imp.g_varchar2_table(29854) := '6F6E283637292C7B746F74616C4865696768743A6F7D3D6A382E6765744C61796F7574496E666F287B6C696E654865696768743A697D292C733D746869732E5F6E5078417661696C61626C6542656C6F773E362A6F3F5B322C315D3A5B312C325D3B7265';
wwv_flow_imp.g_varchar2_table(29855) := '7475726E7B706F736974696F6E3A746869732E5F706F736974696F6E2C707265666572656E63653A737D7D6265666F726552656E64657228297B76617220652C743B636F6E73745B6E2C695D3D746869732E5F6163636570744B657962696E64696E6773';
wwv_flow_imp.g_varchar2_table(29856) := '3B72657475726E20746869732E5F6C6162656C2E696E6E6572546578743D6228302C227B307D20746F2052656E616D652C207B317D20746F2050726576696577222C6E756C6C3D3D3D28653D746869732E5F6B657962696E64696E67536572766963652E';
wwv_flow_imp.g_varchar2_table(29857) := '6C6F6F6B75704B657962696E64696E67286E29297C7C766F696420303D3D3D653F766F696420303A652E6765744C6162656C28292C6E756C6C3D3D3D28743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64';
wwv_flow_imp.g_varchar2_table(29858) := '696E67286929297C7C766F696420303D3D3D743F766F696420303A742E6765744C6162656C2829292C746869732E5F646F6D4E6F64652E7374796C652E6D696E57696474683D223230307078222C6E756C6C7D616674657252656E6465722865297B6966';
wwv_flow_imp.g_varchar2_table(29859) := '28746869732E5F74726163652822696E766F6B696E6720616674657252656E6465722C20706F736974696F6E3A20222C653F226E6F74206E756C6C223A226E756C6C22292C6E756C6C3D3D3D652972657475726E20766F696420746869732E63616E6365';
wwv_flow_imp.g_varchar2_table(29860) := '6C496E7075742821302C22616674657252656E64657220286265636175736520706F736974696F6E206973206E756C6C2922293B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F656469746F722E676574446F';
wwv_flow_imp.g_varchar2_table(29861) := '6D4E6F646528292972657475726E3B796C28746869732E5F72656E616D6543616E6469646174654C69737456696577292C796C28766F69642030213D3D746869732E5F6E5078417661696C61626C6541626F7665292C796C28766F69642030213D3D7468';
wwv_flow_imp.g_varchar2_table(29862) := '69732E5F6E5078417661696C61626C6542656C6F77293B636F6E737420743D467328746869732E5F696E70757457697468427574746F6E2E646F6D4E6F6465292C6E3D467328746869732E5F6C6162656C293B6C657420693B693D323D3D3D653F746869';
wwv_flow_imp.g_varchar2_table(29863) := '732E5F6E5078417661696C61626C6542656C6F773A746869732E5F6E5078417661696C61626C6541626F76652C746869732E5F72656E616D6543616E6469646174654C697374566965772E6C61796F7574287B6865696768743A692D6E2D742C77696474';
wwv_flow_imp.g_varchar2_table(29864) := '683A507328746869732E5F696E70757457697468427574746F6E2E646F6D4E6F6465297D297D616363657074496E7075742865297B76617220743B746869732E5F74726163652822696E766F6B696E6720616363657074496E70757422292C6E756C6C3D';
wwv_flow_imp.g_varchar2_table(29865) := '3D3D28743D746869732E5F63757272656E74416363657074496E707574297C7C766F696420303D3D3D747C7C742E63616C6C28746869732C65297D63616E63656C496E70757428652C74297B766172206E3B746869732E5F74726163652860696E766F6B';
wwv_flow_imp.g_varchar2_table(29866) := '696E672063616E63656C496E7075742C2063616C6C65723A20247B747D2C205F63757272656E7443616E63656C496E7075743A20247B746869732E5F63757272656E74416363657074496E7075743F226E6F7420756E646566696E6564223A22756E6465';
wwv_flow_imp.g_varchar2_table(29867) := '66696E6564227D60292C6E756C6C3D3D3D286E3D746869732E5F63757272656E7443616E63656C496E707574297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28746869732C65297D666F6375734E65787452656E616D6553756767657374696F6E28';
wwv_flow_imp.g_varchar2_table(29868) := '297B76617220653B286E756C6C3D3D3D28653D746869732E5F72656E616D6543616E6469646174654C69737456696577297C7C766F696420303D3D3D653F766F696420303A652E666F6375734E6578742829297C7C28746869732E5F696E707574576974';
wwv_flow_imp.g_varchar2_table(29869) := '68427574746F6E2E696E7075742E76616C75653D746869732E5F63757272656E744E616D65297D666F63757350726576696F757352656E616D6553756767657374696F6E28297B76617220653B286E756C6C3D3D3D28653D746869732E5F72656E616D65';
wwv_flow_imp.g_varchar2_table(29870) := '43616E6469646174654C69737456696577297C7C766F696420303D3D3D653F766F696420303A652E666F63757350726576696F75732829297C7C28746869732E5F696E70757457697468427574746F6E2E696E7075742E76616C75653D746869732E5F63';
wwv_flow_imp.g_varchar2_table(29871) := '757272656E744E616D65297D676574496E70757428652C742C6E2C692C6F297B636F6E73747B73746172743A732C656E643A727D3D746869732E5F67657453656C656374696F6E28652C74293B746869732E5F72656E616D654374733D6F3B636F6E7374';
wwv_flow_imp.g_varchar2_table(29872) := '20613D6E65772061743B746869732E5F6E52656E616D6553756767657374696F6E73496E766F636174696F6E733D302C746869732E5F6861644175746F6D6174696352656E616D6553756767657374696F6E73496E766F636174696F6E3D21312C766F69';
wwv_flow_imp.g_varchar2_table(29873) := '6420303D3D3D693F746869732E5F696E70757457697468427574746F6E2E627574746F6E2E7374796C652E646973706C61793D226E6F6E65223A28746869732E5F696E70757457697468427574746F6E2E627574746F6E2E7374796C652E646973706C61';
wwv_flow_imp.g_varchar2_table(29874) := '793D22666C6578222C746869732E5F7265717565737452656E616D6543616E646964617465734F6E63653D692C746869732E5F7265717565737452656E616D6543616E6469646174657328742C2131292C612E61646428627328746869732E5F696E7075';
wwv_flow_imp.g_varchar2_table(29875) := '7457697468427574746F6E2E627574746F6E2C22636C69636B222C2828293D3E746869732E5F7265717565737452656E616D6543616E6469646174657328742C2130292929292C612E61646428627328746869732E5F696E70757457697468427574746F';
wwv_flow_imp.g_varchar2_table(29876) := '6E2E627574746F6E2C61722E4B45595F444F574E2C28653D3E7B636F6E7374206E3D6E65772071652865293B286E2E657175616C732833297C7C6E2E657175616C7328313029292626286E2E73746F7050726F7061676174696F6E28292C6E2E70726576';
wwv_flow_imp.g_varchar2_table(29877) := '656E7444656661756C7428292C746869732E5F7265717565737452656E616D6543616E6469646174657328742C213029297D292929292C746869732E5F697345646974696E6752656E616D6543616E6469646174653D21312C746869732E5F646F6D4E6F';
wwv_flow_imp.g_varchar2_table(29878) := '64652E636C6173734C6973742E746F67676C65282270726576696577222C6E292C746869732E5F706F736974696F6E3D6E6577206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C746869732E5F63757272656E';
wwv_flow_imp.g_varchar2_table(29879) := '744E616D653D742C746869732E5F696E70757457697468427574746F6E2E696E7075742E76616C75653D742C746869732E5F696E70757457697468427574746F6E2E696E7075742E736574417474726962757465282273656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(29880) := '222C732E746F537472696E672829292C746869732E5F696E70757457697468427574746F6E2E696E7075742E736574417474726962757465282273656C656374696F6E456E64222C722E746F537472696E672829292C746869732E5F696E707574576974';
wwv_flow_imp.g_varchar2_table(29881) := '68427574746F6E2E696E7075742E73697A653D4D6174682E6D617828312E312A28652E656E64436F6C756D6E2D652E7374617274436F6C756D6E292C3230292C746869732E5F6265666F72654669727374496E7075744669656C644564697453572E7265';
wwv_flow_imp.g_varchar2_table(29882) := '73657428292C612E616464287274282828293D3E7B746869732E5F72656E616D654374733D766F696420302C6F2E646973706F7365282130297D2929292C612E616464287274282828293D3E7B766F69642030213D3D746869732E5F72656E616D654361';
wwv_flow_imp.g_varchar2_table(29883) := '6E64696461746550726F766964657273437473262628746869732E5F72656E616D6543616E64696461746550726F7669646572734374732E646973706F7365282130292C746869732E5F72656E616D6543616E64696461746550726F7669646572734374';
wwv_flow_imp.g_varchar2_table(29884) := '733D766F69642030297D2929292C612E616464287274282828293D3E746869732E5F63616E646964617465732E636C65617228292929293B636F6E7374206C3D6E65772058743B72657475726E206C2E702E66696E616C6C79282828293D3E7B612E6469';
wwv_flow_imp.g_varchar2_table(29885) := '73706F736528292C746869732E5F6869646528297D29292C746869732E5F63757272656E7443616E63656C496E7075743D653D3E7B76617220743B72657475726E20746869732E5F74726163652822696E766F6B696E67205F63757272656E7443616E63';
wwv_flow_imp.g_varchar2_table(29886) := '656C496E70757422292C746869732E5F63757272656E74416363657074496E7075743D766F696420302C746869732E5F63757272656E7443616E63656C496E7075743D766F696420302C6E756C6C3D3D3D28743D746869732E5F72656E616D6543616E64';
wwv_flow_imp.g_varchar2_table(29887) := '69646174654C69737456696577297C7C766F696420303D3D3D747C7C742E636C65617243616E6469646174657328292C6C2E636F6D706C6574652865292C21307D2C746869732E5F63757272656E74416363657074496E7075743D653D3E7B746869732E';
wwv_flow_imp.g_varchar2_table(29888) := '5F74726163652822696E766F6B696E67205F63757272656E74416363657074496E70757422292C796C28766F69642030213D3D746869732E5F72656E616D6543616E6469646174654C69737456696577293B636F6E737420693D746869732E5F72656E61';
wwv_flow_imp.g_varchar2_table(29889) := '6D6543616E6469646174654C697374566965772E6E43616E646964617465733B6C6574206F2C733B636F6E737420723D746869732E5F72656E616D6543616E6469646174654C697374566965772E666F637573656443616E6469646174653B766F696420';
wwv_flow_imp.g_varchar2_table(29890) := '30213D3D723F28746869732E5F747261636528227573696E67206E6577206E616D652066726F6D2072656E616D6553756767657374696F6E22292C6F3D722C733D7B6B3A2272656E616D6553756767657374696F6E227D293A28746869732E5F74726163';
wwv_flow_imp.g_varchar2_table(29891) := '6528227573696E67206E6577206E616D652066726F6D20696E7075744669656C6422292C6F3D746869732E5F696E70757457697468427574746F6E2E696E7075742E76616C75652C733D746869732E5F697345646974696E6752656E616D6543616E6469';
wwv_flow_imp.g_varchar2_table(29892) := '646174653F7B6B3A227573657245646974656452656E616D6553756767657374696F6E227D3A7B6B3A22696E7075744669656C64227D292C6F213D3D74262630213D3D6F2E7472696D28292E6C656E6774683F28746869732E5F63757272656E74416363';
wwv_flow_imp.g_varchar2_table(29893) := '657074496E7075743D766F696420302C746869732E5F63757272656E7443616E63656C496E7075743D766F696420302C746869732E5F72656E616D6543616E6469646174654C697374566965772E636C65617243616E6469646174657328292C6C2E636F';
wwv_flow_imp.g_varchar2_table(29894) := '6D706C657465287B6E65774E616D653A6F2C77616E7473507265766965773A6E2626652C73746174733A7B736F757263653A732C6E52656E616D6553756767657374696F6E733A692C74696D654265666F72654669727374496E7075744669656C644564';
wwv_flow_imp.g_varchar2_table(29895) := '69743A746869732E5F74696D654265666F72654669727374496E7075744669656C64456469742C6E52656E616D6553756767657374696F6E73496E766F636174696F6E733A746869732E5F6E52656E616D6553756767657374696F6E73496E766F636174';
wwv_flow_imp.g_varchar2_table(29896) := '696F6E732C6861644175746F6D6174696352656E616D6553756767657374696F6E73496E766F636174696F6E3A746869732E5F6861644175746F6D6174696352656E616D6553756767657374696F6E73496E766F636174696F6E7D7D29293A746869732E';
wwv_flow_imp.g_varchar2_table(29897) := '63616E63656C496E7075742821302C225F63757272656E74416363657074496E707574202862656361757365206E65774E616D65203D3D3D2076616C7565207C7C206E65774E616D652E7472696D28292E6C656E677468203D3D3D20302922297D2C612E';
wwv_flow_imp.g_varchar2_table(29898) := '616464286F2E746F6B656E2E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E746869732E63616E63656C496E7075742821302C226374732E746F6B656E2E6F6E43616E63656C6C6174696F6E5265717565737465642229292929';
wwv_flow_imp.g_varchar2_table(29899) := '2C612E61646428746869732E5F656469746F722E6F6E446964426C7572456469746F72576964676574282828293D3E7B76617220653B72657475726E20746869732E63616E63656C496E7075742821286E756C6C3D3D3D28653D746869732E5F646F6D4E';
wwv_flow_imp.g_varchar2_table(29900) := '6F6465297C7C766F696420303D3D3D653F766F696420303A652E6F776E6572446F63756D656E742E686173466F6375732829292C22656469746F722E6F6E446964426C7572456469746F7257696467657422297D2929292C746869732E5F73686F772829';
wwv_flow_imp.g_varchar2_table(29901) := '2C6C2E707D5F7265717565737452656E616D6543616E6469646174657328652C74297B696628766F69642030213D3D746869732E5F7265717565737452656E616D6543616E646964617465734F6E6365262628766F69642030213D3D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(29902) := '6E616D6543616E64696461746550726F7669646572734374732626746869732E5F72656E616D6543616E64696461746550726F7669646572734374732E646973706F7365282130292C796C28746869732E5F72656E616D65437473292C2273746F702221';
wwv_flow_imp.g_varchar2_table(29903) := '3D3D746869732E5F696E70757457697468427574746F6E2E627574746F6E537461746529297B746869732E5F72656E616D6543616E64696461746550726F7669646572734374733D6E6577204E743B636F6E7374206E3D743F54772E496E766F6B653A54';
wwv_flow_imp.g_varchar2_table(29904) := '772E4175746F6D617469632C693D746869732E5F7265717565737452656E616D6543616E646964617465734F6E6365286E2C746869732E5F72656E616D6543616E64696461746550726F7669646572734374732E746F6B656E293B696628303D3D3D692E';
wwv_flow_imp.g_varchar2_table(29905) := '6C656E6774682972657475726E20766F696420746869732E5F696E70757457697468427574746F6E2E736574537061726B6C65427574746F6E28293B747C7C28746869732E5F6861644175746F6D6174696352656E616D6553756767657374696F6E7349';
wwv_flow_imp.g_varchar2_table(29906) := '6E766F636174696F6E3D2130292C746869732E5F6E52656E616D6553756767657374696F6E73496E766F636174696F6E732B3D312C746869732E5F696E70757457697468427574746F6E2E73657453746F70427574746F6E28292C746869732E5F757064';
wwv_flow_imp.g_varchar2_table(29907) := '61746552656E616D6543616E6469646174657328692C652C746869732E5F72656E616D654374732E746F6B656E297D7D5F67657453656C656374696F6E28652C74297B796C28746869732E5F656469746F722E6861734D6F64656C2829293B636F6E7374';
wwv_flow_imp.g_varchar2_table(29908) := '206E3D746869732E5F656469746F722E67657453656C656374696F6E28293B6C657420693D302C6F3D742E6C656E6774683B72657475726E2072682E6973456D707479286E297C7C72682E7370616E734D756C7469706C654C696E6573286E297C7C2172';
wwv_flow_imp.g_varchar2_table(29909) := '682E636F6E7461696E7352616E676528652C6E297C7C28693D4D6174682E6D617828302C6E2E7374617274436F6C756D6E2D652E7374617274436F6C756D6E292C6F3D4D6174682E6D696E28652E656E64436F6C756D6E2C6E2E656E64436F6C756D6E29';
wwv_flow_imp.g_varchar2_table(29910) := '2D652E7374617274436F6C756D6E292C7B73746172743A692C656E643A6F7D7D5F73686F7728297B746869732E5F74726163652822696E766F6B696E67205F73686F7722292C746869732E5F656469746F722E72657665616C4C696E65496E43656E7465';
wwv_flow_imp.g_varchar2_table(29911) := '7249664F75747369646556696577706F727428746869732E5F706F736974696F6E2E6C696E654E756D6265722C30292C746869732E5F76697369626C653D21302C746869732E5F76697369626C65436F6E746578744B65792E736574282130292C746869';
wwv_flow_imp.g_varchar2_table(29912) := '732E5F656469746F722E6C61796F7574436F6E74656E745769646765742874686973292C73657454696D656F7574282828293D3E7B746869732E5F696E70757457697468427574746F6E2E696E7075742E666F63757328292C746869732E5F696E707574';
wwv_flow_imp.g_varchar2_table(29913) := '57697468427574746F6E2E696E7075742E73657453656C656374696F6E52616E6765287061727365496E7428746869732E5F696E70757457697468427574746F6E2E696E7075742E676574417474726962757465282273656C656374696F6E5374617274';
wwv_flow_imp.g_varchar2_table(29914) := '2229292C7061727365496E7428746869732E5F696E70757457697468427574746F6E2E696E7075742E676574417474726962757465282273656C656374696F6E456E64222929297D292C313030297D6173796E63205F75706461746552656E616D654361';
wwv_flow_imp.g_varchar2_table(29915) := '6E6469646174657328652C742C6E297B636F6E737420693D282E2E2E65293D3E746869732E5F747261636528225F75706461746552656E616D6543616E64696461746573222C2E2E2E65293B692822737461727422293B636F6E7374206F3D6177616974';
wwv_flow_imp.g_varchar2_table(29916) := '2042742850726F6D6973652E616C6C536574746C65642865292C6E293B696628746869732E5F696E70757457697468427574746F6E2E736574537061726B6C65427574746F6E28292C766F696420303D3D3D6F2972657475726E20766F69642069282272';
wwv_flow_imp.g_varchar2_table(29917) := '657475726E696E67206561726C79202D2072656365697665642075706461746552656E616D6543616E6469646174657320726573756C7473202D20756E646566696E656422293B636F6E737420733D6F2E666C61744D61702828653D3E2266756C66696C';
wwv_flow_imp.g_varchar2_table(29918) := '6C6564223D3D3D652E7374617475732626626C28652E76616C7565293F652E76616C75653A5B5D29293B69286072656365697665642075706461746552656E616D6543616E6469646174657320726573756C7473202D20746F74616C2028756E66696C74';
wwv_flow_imp.g_varchar2_table(29919) := '657265642920247B732E6C656E6774687D2063616E646964617465732E60293B636F6E737420723D716828732C28653D3E652E6E657753796D626F6C4E616D6529293B69286064697374696E63742063616E64696461746573202D20247B722E6C656E67';
wwv_flow_imp.g_varchar2_table(29920) := '74687D2063616E646964617465732E60293B636F6E737420613D722E66696C7465722828287B6E657753796D626F6C4E616D653A657D293D3E652E7472696D28292E6C656E6774683E30262665213D3D746869732E5F696E70757457697468427574746F';
wwv_flow_imp.g_varchar2_table(29921) := '6E2E696E7075742E76616C7565262665213D3D74262621746869732E5F63616E646964617465732E68617328652929293B69286076616C69642064697374696E63742063616E64696461746573202D20247B732E6C656E6774687D2063616E6469646174';
wwv_flow_imp.g_varchar2_table(29922) := '65732E60292C612E666F72456163682828653D3E746869732E5F63616E646964617465732E61646428652E6E657753796D626F6C4E616D652929292C612E6C656E6774683C313F69282272657475726E696E67206561726C79202D206E6F2076616C6964';
wwv_flow_imp.g_varchar2_table(29923) := '2064697374696E63742063616E6469646174657322293A2869282273657474696E672063616E6469646174657322292C746869732E5F72656E616D6543616E6469646174654C697374566965772E73657443616E646964617465732861292C6928226173';
wwv_flow_imp.g_varchar2_table(29924) := '6B696E6720656469746F7220746F2072652D6C61796F757422292C746869732E5F656469746F722E6C61796F7574436F6E74656E74576964676574287468697329297D5F6869646528297B746869732E5F74726163652822696E766F6B6564205F686964';
wwv_flow_imp.g_varchar2_table(29925) := '6522292C746869732E5F76697369626C653D21312C746869732E5F76697369626C65436F6E746578744B65792E726573657428292C746869732E5F656469746F722E6C61796F7574436F6E74656E745769646765742874686973297D5F676574546F7046';
wwv_flow_imp.g_varchar2_table(29926) := '6F72506F736974696F6E28297B636F6E737420653D746869732E5F656469746F722E67657456697369626C6552616E67657328293B6C657420743B72657475726E20652E6C656E6774683E303F743D655B305D2E73746172744C696E654E756D6265723A';
wwv_flow_imp.g_varchar2_table(29927) := '28746869732E5F6C6F67536572766963652E7761726E282252656E616D65576964676574235F676574546F70466F72506F736974696F6E3A20746869732073686F756C64206E6F742068617070656E202D2076697369626C6552616E6765732069732065';
wwv_flow_imp.g_varchar2_table(29928) := '6D70747922292C743D4D6174682E6D617828312C746869732E5F706F736974696F6E2E6C696E654E756D6265722D3529292C746869732E5F656469746F722E676574546F70466F724C696E654E756D62657228746869732E5F706F736974696F6E2E6C69';
wwv_flow_imp.g_varchar2_table(29929) := '6E654E756D626572292D746869732E5F656469746F722E676574546F70466F724C696E654E756D6265722874297D5F7472616365282E2E2E65297B746869732E5F6C6F67536572766963652E7472616365282252656E616D65576964676574222C2E2E2E';
wwv_flow_imp.g_varchar2_table(29930) := '65297D7D3B7A383D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F';
wwv_flow_imp.g_varchar2_table(29931) := '7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(29932) := '293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626722626';
wwv_flow_imp.g_varchar2_table(29933) := '4F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B423828322C5062292C423828332C2445292C423828342C6364292C423828352C5264295D2C7A38293B636C6173732048387B636F6E7374727563746F7228652C74297B';
wwv_flow_imp.g_varchar2_table(29934) := '746869732E5F646973706F7361626C65733D6E65772061742C746869732E5F617661696C61626C654865696768743D302C746869732E5F6D696E696D756D57696474683D302C746869732E5F6C696E654865696768743D742E666F6E74496E666F2E6C69';
wwv_flow_imp.g_varchar2_table(29935) := '6E654865696768742C746869732E5F7479706963616C48616C66776964746843686172616374657257696474683D742E666F6E74496E666F2E7479706963616C48616C66776964746843686172616374657257696474682C746869732E5F6C697374436F';
wwv_flow_imp.g_varchar2_table(29936) := '6E7461696E65723D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6C697374436F6E7461696E65722E636C6173734E616D653D2272656E616D652D626F782072656E616D652D63616E6469646174652D6C6973';
wwv_flow_imp.g_varchar2_table(29937) := '742D636F6E7461696E6572222C652E617070656E644368696C6428746869732E5F6C697374436F6E7461696E6572292C746869732E5F6C6973745769646765743D48382E5F6372656174654C69737457696467657428746869732E5F6C697374436F6E74';
wwv_flow_imp.g_varchar2_table(29938) := '61696E65722C746869732E5F63616E646964617465566965774865696768742C742E666F6E74496E666F292C746869732E5F6C6973745769646765742E6F6E4469644368616E6765466F6375732828653D3E7B313D3D3D652E656C656D656E74732E6C65';
wwv_flow_imp.g_varchar2_table(29939) := '6E6774682626742E6F6E466F6375734368616E676528652E656C656D656E74735B305D2E6E657753796D626F6C4E616D65297D292C746869732E5F646973706F7361626C6573292C746869732E5F6C6973745769646765742E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(29940) := '53656C656374696F6E2828653D3E7B313D3D3D652E656C656D656E74732E6C656E6774682626742E6F6E53656C656374696F6E4368616E676528297D292C746869732E5F646973706F7361626C6573292C746869732E5F646973706F7361626C65732E61';
wwv_flow_imp.g_varchar2_table(29941) := '646428746869732E5F6C6973745769646765742E6F6E446964426C75722828653D3E7B746869732E5F6C6973745769646765742E736574466F637573285B5D297D2929292C746869732E5F6C6973745769646765742E7374796C6528494D287B6C697374';
wwv_flow_imp.g_varchar2_table(29942) := '496E616374697665466F637573466F726567726F756E643A44622C6C697374496E616374697665466F6375734261636B67726F756E643A49627D29297D646973706F736528297B746869732E5F6C6973745769646765742E646973706F736528292C7468';
wwv_flow_imp.g_varchar2_table(29943) := '69732E5F646973706F7361626C65732E646973706F736528297D6C61796F7574287B6865696768743A652C77696474683A747D297B746869732E5F617661696C61626C654865696768743D652C746869732E5F6D696E696D756D57696474683D747D7365';
wwv_flow_imp.g_varchar2_table(29944) := '7443616E646964617465732865297B746869732E5F6C6973745769646765742E73706C69636528302C302C65293B636F6E737420743D746869732E5F7069636B4C69737448656967687428746869732E5F6C6973745769646765742E6C656E677468292C';
wwv_flow_imp.g_varchar2_table(29945) := '6E3D746869732E5F7069636B4C69737457696474682865293B746869732E5F6C6973745769646765742E6C61796F757428742C6E292C746869732E5F6C697374436F6E7461696E65722E7374796C652E6865696768743D60247B747D7078602C74686973';
wwv_flow_imp.g_varchar2_table(29946) := '2E5F6C697374436F6E7461696E65722E7374796C652E77696474683D60247B6E7D7078602C4A72286228302C225265636569766564207B307D2072656E616D652073756767657374696F6E73222C652E6C656E67746829297D636C65617243616E646964';
wwv_flow_imp.g_varchar2_table(29947) := '6174657328297B746869732E5F6C697374436F6E7461696E65722E7374796C652E6865696768743D22307078222C746869732E5F6C697374436F6E7461696E65722E7374796C652E77696474683D22307078222C746869732E5F6C697374576964676574';
wwv_flow_imp.g_varchar2_table(29948) := '2E73706C69636528302C746869732E5F6C6973745769646765742E6C656E6774682C5B5D297D676574206E43616E6469646174657328297B72657475726E20746869732E5F6C6973745769646765742E6C656E6774687D67657420666F63757365644361';
wwv_flow_imp.g_varchar2_table(29949) := '6E64696461746528297B696628303D3D3D746869732E5F6C6973745769646765742E6C656E6774682972657475726E3B636F6E737420653D746869732E5F6C6973745769646765742E67657453656C6563746564456C656D656E747328295B305D3B6966';
wwv_flow_imp.g_varchar2_table(29950) := '28766F69642030213D3D652972657475726E20652E6E657753796D626F6C4E616D653B636F6E737420743D746869732E5F6C6973745769646765742E676574466F6375736564456C656D656E747328295B305D3B72657475726E20766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(29951) := '743F742E6E657753796D626F6C4E616D653A766F696420307D666F6375734E65787428297B696628303D3D3D746869732E5F6C6973745769646765742E6C656E6774682972657475726E21313B636F6E737420653D746869732E5F6C6973745769646765';
wwv_flow_imp.g_varchar2_table(29952) := '742E676574466F63757328293B696628303D3D3D652E6C656E6774682972657475726E20746869732E5F6C6973745769646765742E666F637573466972737428292C746869732E5F6C6973745769646765742E72657665616C2830292C21303B69662865';
wwv_flow_imp.g_varchar2_table(29953) := '5B305D3D3D3D746869732E5F6C6973745769646765742E6C656E6774682D312972657475726E20746869732E5F6C6973745769646765742E736574466F637573285B5D292C746869732E5F6C6973745769646765742E72657665616C2830292C21313B7B';
wwv_flow_imp.g_varchar2_table(29954) := '746869732E5F6C6973745769646765742E666F6375734E65787428293B636F6E737420653D746869732E5F6C6973745769646765742E676574466F63757328295B305D3B72657475726E20746869732E5F6C6973745769646765742E72657665616C2865';
wwv_flow_imp.g_varchar2_table(29955) := '292C21307D7D666F63757350726576696F757328297B696628303D3D3D746869732E5F6C6973745769646765742E6C656E6774682972657475726E21313B636F6E737420653D746869732E5F6C6973745769646765742E676574466F63757328293B6966';
wwv_flow_imp.g_varchar2_table(29956) := '28303D3D3D652E6C656E677468297B746869732E5F6C6973745769646765742E666F6375734C61737428293B636F6E737420653D746869732E5F6C6973745769646765742E676574466F63757328295B305D3B72657475726E20746869732E5F6C697374';
wwv_flow_imp.g_varchar2_table(29957) := '5769646765742E72657665616C2865292C21307D696628303D3D3D655B305D2972657475726E20746869732E5F6C6973745769646765742E736574466F637573285B5D292C21313B7B746869732E5F6C6973745769646765742E666F6375735072657669';
wwv_flow_imp.g_varchar2_table(29958) := '6F757328293B636F6E737420653D746869732E5F6C6973745769646765742E676574466F63757328295B305D3B72657475726E20746869732E5F6C6973745769646765742E72657665616C2865292C21307D7D636C656172466F63757328297B74686973';
wwv_flow_imp.g_varchar2_table(29959) := '2E5F6C6973745769646765742E736574466F637573285B5D297D676574205F63616E6469646174655669657748656967687428297B636F6E73747B746F74616C4865696768743A657D3D6A382E6765744C61796F7574496E666F287B6C696E6548656967';
wwv_flow_imp.g_varchar2_table(29960) := '68743A746869732E5F6C696E654865696768747D293B72657475726E20657D5F7069636B4C6973744865696768742865297B636F6E737420743D746869732E5F63616E646964617465566965774865696768742A653B72657475726E204D6174682E6D69';
wwv_flow_imp.g_varchar2_table(29961) := '6E28742C746869732E5F617661696C61626C654865696768742C372A746869732E5F63616E64696461746556696577486569676874297D5F7069636B4C69737457696474682865297B636F6E737420743D4D6174682E6365696C284D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(29962) := '2E2E2E652E6D61702828653D3E652E6E657753796D626F6C4E616D652E6C656E6774682929292A746869732E5F7479706963616C48616C6677696474684368617261637465725769647468293B72657475726E204D6174682E6D617828746869732E5F6D';
wwv_flow_imp.g_varchar2_table(29963) := '696E696D756D57696474682C32352B742B3130297D737461746963205F6372656174654C69737457696467657428652C742C6E297B636F6E737420693D6E657720636C6173737B67657454656D706C61746549642865297B72657475726E2263616E6469';
wwv_flow_imp.g_varchar2_table(29964) := '64617465227D6765744865696768742865297B72657475726E20747D7D2C6F3D6E657720636C6173737B636F6E7374727563746F7228297B746869732E74656D706C61746549643D2263616E646964617465227D72656E64657254656D706C6174652865';
wwv_flow_imp.g_varchar2_table(29965) := '297B72657475726E206E6577206A3828652C6E297D72656E646572456C656D656E7428652C742C6E297B6E2E706F70756C6174652865297D646973706F736554656D706C6174652865297B652E646973706F736528297D7D3B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(29966) := '554928224E657753796D626F6C4E616D6543616E64696461746573222C652C692C5B6F5D2C7B6B6579626F617264537570706F72743A21312C6D6F757365537570706F72743A21302C6D756C7469706C6553656C656374696F6E537570706F72743A2131';
wwv_flow_imp.g_varchar2_table(29967) := '7D297D7D636C6173732057387B636F6E7374727563746F7228297B746869732E5F6F6E446964496E7075744368616E67653D6E65772043742C746869732E6F6E446964496E7075744368616E67653D746869732E5F6F6E446964496E7075744368616E67';
wwv_flow_imp.g_varchar2_table(29968) := '652E6576656E742C746869732E5F646973706F7361626C65733D6E65772061747D67657420646F6D4E6F646528297B72657475726E20746869732E5F646F6D4E6F64657C7C28746869732E5F646F6D4E6F64653D646F63756D656E742E63726561746545';
wwv_flow_imp.g_varchar2_table(29969) := '6C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D2272656E616D652D696E7075742D776974682D627574746F6E222C746869732E5F646F6D4E6F64652E7374796C652E646973706C61793D22666C6578222C';
wwv_flow_imp.g_varchar2_table(29970) := '746869732E5F646F6D4E6F64652E7374796C652E666C6578446972656374696F6E3D22726F77222C746869732E5F646F6D4E6F64652E7374796C652E616C69676E4974656D733D2263656E746572222C746869732E5F696E7075744E6F64653D646F6375';
wwv_flow_imp.g_varchar2_table(29971) := '6D656E742E637265617465456C656D656E742822696E70757422292C746869732E5F696E7075744E6F64652E636C6173734E616D653D2272656E616D652D696E707574222C746869732E5F696E7075744E6F64652E747970653D2274657874222C746869';
wwv_flow_imp.g_varchar2_table(29972) := '732E5F696E7075744E6F64652E7374796C652E626F726465723D226E6F6E65222C746869732E5F696E7075744E6F64652E7365744174747269627574652822617269612D6C6162656C222C6228302C2252656E616D6520696E7075742E2054797065206E';
wwv_flow_imp.g_varchar2_table(29973) := '6577206E616D6520616E6420707265737320456E74657220746F20636F6D6D69742E2229292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F696E7075744E6F6465292C746869732E5F627574746F6E4E6F64653D646F';
wwv_flow_imp.g_varchar2_table(29974) := '63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F627574746F6E4E6F64652E636C6173734E616D653D2272656E616D652D73756767657374696F6E732D627574746F6E222C746869732E5F627574746F6E4E6F64652E';
wwv_flow_imp.g_varchar2_table(29975) := '7365744174747269627574652822746162696E646578222C223022292C746869732E5F627574746F6E47656E486F766572546578743D6228302C2247656E6572617465206E6577206E616D652073756767657374696F6E7322292C746869732E5F627574';
wwv_flow_imp.g_varchar2_table(29976) := '746F6E43616E63656C486F766572546578743D6228302C2243616E63656C22292C746869732E5F627574746F6E486F7665723D564528292E7365747570557064617461626C65486F7665722850452822656C656D656E7422292C746869732E5F62757474';
wwv_flow_imp.g_varchar2_table(29977) := '6F6E4E6F64652C746869732E5F627574746F6E47656E486F76657254657874292C746869732E5F646973706F7361626C65732E61646428746869732E5F627574746F6E486F766572292C746869732E5F646F6D4E6F64652E617070656E644368696C6428';
wwv_flow_imp.g_varchar2_table(29978) := '746869732E5F627574746F6E4E6F6465292C746869732E5F646973706F7361626C65732E61646428627328746869732E696E7075742C61722E494E5055542C2828293D3E746869732E5F6F6E446964496E7075744368616E67652E666972652829292929';
wwv_flow_imp.g_varchar2_table(29979) := '2C746869732E5F646973706F7361626C65732E61646428627328746869732E696E7075742C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B3135213D3D742E6B6579436F646526263137213D3D742E6B6579436F';
wwv_flow_imp.g_varchar2_table(29980) := '64657C7C746869732E5F6F6E446964496E7075744368616E67652E6669726528297D2929292C746869732E5F646973706F7361626C65732E61646428627328746869732E696E7075742C61722E434C49434B2C2828293D3E746869732E5F6F6E44696449';
wwv_flow_imp.g_varchar2_table(29981) := '6E7075744368616E67652E6669726528292929292C746869732E5F646973706F7361626C65732E61646428627328746869732E696E7075742C61722E464F4355532C2828293D3E7B746869732E646F6D4E6F64652E7374796C652E6F75746C696E655769';
wwv_flow_imp.g_varchar2_table(29982) := '6474683D22317078222C746869732E646F6D4E6F64652E7374796C652E6F75746C696E655374796C653D22736F6C6964222C746869732E646F6D4E6F64652E7374796C652E6F75746C696E654F66667365743D222D317078222C746869732E646F6D4E6F';
wwv_flow_imp.g_varchar2_table(29983) := '64652E7374796C652E6F75746C696E65436F6C6F723D22766172282D2D7673636F64652D666F637573426F7264657229227D2929292C746869732E5F646973706F7361626C65732E61646428627328746869732E696E7075742C61722E424C55522C2828';
wwv_flow_imp.g_varchar2_table(29984) := '293D3E7B746869732E646F6D4E6F64652E7374796C652E6F75746C696E653D226E6F6E65227D292929292C746869732E5F646F6D4E6F64657D67657420696E70757428297B72657475726E20796C28746869732E5F696E7075744E6F6465292C74686973';
wwv_flow_imp.g_varchar2_table(29985) := '2E5F696E7075744E6F64657D67657420627574746F6E28297B72657475726E20796C28746869732E5F627574746F6E4E6F6465292C746869732E5F627574746F6E4E6F64657D67657420627574746F6E537461746528297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(29986) := '5F627574746F6E53746174657D736574537061726B6C65427574746F6E28297B76617220652C743B746869732E5F627574746F6E53746174653D22737061726B6C65222C6E756C6C213D3D28653D746869732E5F737061726B6C6549636F6E292626766F';
wwv_flow_imp.g_varchar2_table(29987) := '69642030213D3D657C7C28746869732E5F737061726B6C6549636F6E3D786B284C6C2E737061726B6C6529292C667328746869732E627574746F6E292C746869732E627574746F6E2E617070656E644368696C6428746869732E5F737061726B6C654963';
wwv_flow_imp.g_varchar2_table(29988) := '6F6E292C746869732E627574746F6E2E7365744174747269627574652822617269612D6C6162656C222C2247656E65726174696E67206E6577206E616D652073756767657374696F6E7322292C6E756C6C3D3D3D28743D746869732E5F627574746F6E48';
wwv_flow_imp.g_varchar2_table(29989) := '6F766572297C7C766F696420303D3D3D747C7C742E75706461746528746869732E5F627574746F6E47656E486F76657254657874292C746869732E696E7075742E666F63757328297D73657453746F70427574746F6E28297B76617220652C743B746869';
wwv_flow_imp.g_varchar2_table(29990) := '732E5F627574746F6E53746174653D2273746F70222C6E756C6C213D3D28653D746869732E5F73746F7049636F6E292626766F69642030213D3D657C7C28746869732E5F73746F7049636F6E3D786B284C6C2E7072696D69746976655371756172652929';
wwv_flow_imp.g_varchar2_table(29991) := '2C667328746869732E627574746F6E292C746869732E627574746F6E2E617070656E644368696C6428746869732E5F73746F7049636F6E292C746869732E627574746F6E2E7365744174747269627574652822617269612D6C6162656C222C2243616E63';
wwv_flow_imp.g_varchar2_table(29992) := '656C2067656E65726174696E67206E6577206E616D652073756767657374696F6E7322292C6E756C6C3D3D3D28743D746869732E5F627574746F6E486F766572297C7C766F696420303D3D3D747C7C742E75706461746528746869732E5F627574746F6E';
wwv_flow_imp.g_varchar2_table(29993) := '43616E63656C486F76657254657874292C746869732E696E7075742E666F63757328297D646973706F736528297B746869732E5F646973706F7361626C65732E646973706F736528297D7D636C617373206A387B636F6E7374727563746F7228652C7429';
wwv_flow_imp.g_varchar2_table(29994) := '7B746869732E5F646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F646F6D4E6F64652E636C6173734E616D653D2272656E616D652D626F782072656E616D652D63616E646964617465222C74';
wwv_flow_imp.g_varchar2_table(29995) := '6869732E5F646F6D4E6F64652E7374796C652E646973706C61793D22666C6578222C746869732E5F646F6D4E6F64652E7374796C652E636F6C756D6E4761703D22357078222C746869732E5F646F6D4E6F64652E7374796C652E616C69676E4974656D73';
wwv_flow_imp.g_varchar2_table(29996) := '3D2263656E746572222C746869732E5F646F6D4E6F64652E7374796C652E6865696768743D60247B742E6C696E654865696768747D7078602C746869732E5F646F6D4E6F64652E7374796C652E70616464696E673D60247B6A382E5F50414444494E477D';
wwv_flow_imp.g_varchar2_table(29997) := '7078603B636F6E7374206E3D646F63756D656E742E637265617465456C656D656E74282264697622293B6E2E7374796C652E646973706C61793D22666C6578222C6E2E7374796C652E616C69676E4974656D733D2263656E746572222C6E2E7374796C65';
wwv_flow_imp.g_varchar2_table(29998) := '2E77696474683D6E2E7374796C652E6865696768743D2E382A742E6C696E654865696768742B227078222C746869732E5F646F6D4E6F64652E617070656E644368696C64286E292C746869732E5F69636F6E3D786B284C6C2E737061726B6C65292C7468';
wwv_flow_imp.g_varchar2_table(29999) := '69732E5F69636F6E2E7374796C652E646973706C61793D226E6F6E65222C6E2E617070656E644368696C6428746869732E5F69636F6E292C746869732E5F6C6162656C3D646F63756D656E742E637265617465456C656D656E74282264697622292C7245';
wwv_flow_imp.g_varchar2_table(30000) := '28746869732E5F6C6162656C2C74292C746869732E5F646F6D4E6F64652E617070656E644368696C6428746869732E5F6C6162656C292C652E617070656E644368696C6428746869732E5F646F6D4E6F6465297D706F70756C6174652865297B74686973';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(30001) := '2E5F75706461746549636F6E2865292C746869732E5F7570646174654C6162656C2865297D5F75706461746549636F6E2865297B76617220743B636F6E7374206E3D2121286E756C6C3D3D3D28743D652E74616773297C7C766F696420303D3D3D743F76';
wwv_flow_imp.g_varchar2_table(30002) := '6F696420303A742E696E636C756465732844772E414947656E65726174656429293B746869732E5F69636F6E2E7374796C652E646973706C61793D6E3F22696E6865726974223A226E6F6E65227D5F7570646174654C6162656C2865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(30003) := '6C6162656C2E696E6E6572546578743D652E6E657753796D626F6C4E616D657D737461746963206765744C61796F7574496E666F287B6C696E654865696768743A657D297B72657475726E7B746F74616C4865696768743A652B322A6A382E5F50414444';
wwv_flow_imp.g_varchar2_table(30004) := '494E477D7D646973706F736528297B7D7D6A382E5F50414444494E473D323B7661722071382C24383D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173732055387B636F6E73';
wwv_flow_imp.g_varchar2_table(30005) := '74727563746F7228652C742C6E297B746869732E6D6F64656C3D652C746869732E706F736974696F6E3D742C746869732E5F70726F766964657252656E616D654964783D302C746869732E5F70726F7669646572733D6E2E6F7264657265642865297D68';
wwv_flow_imp.g_varchar2_table(30006) := '617350726F766964657228297B72657475726E20746869732E5F70726F7669646572732E6C656E6774683E307D6173796E63207265736F6C766552656E616D654C6F636174696F6E2865297B636F6E737420743D5B5D3B666F7228746869732E5F70726F';
wwv_flow_imp.g_varchar2_table(30007) := '766964657252656E616D654964783D303B746869732E5F70726F766964657252656E616D654964783C746869732E5F70726F7669646572732E6C656E6774683B746869732E5F70726F766964657252656E616D654964782B2B297B636F6E7374206E3D74';
wwv_flow_imp.g_varchar2_table(30008) := '6869732E5F70726F7669646572735B746869732E5F70726F766964657252656E616D654964785D3B696628216E2E7265736F6C766552656E616D654C6F636174696F6E29627265616B3B636F6E737420693D6177616974206E2E7265736F6C766552656E';
wwv_flow_imp.g_varchar2_table(30009) := '616D654C6F636174696F6E28746869732E6D6F64656C2C746869732E706F736974696F6E2C65293B69662869297B69662821692E72656A656374526561736F6E2972657475726E20693B742E7075736828692E72656A656374526561736F6E297D7D7468';
wwv_flow_imp.g_varchar2_table(30010) := '69732E5F70726F766964657252656E616D654964783D303B636F6E7374206E3D746869732E6D6F64656C2E676574576F72644174506F736974696F6E28746869732E706F736974696F6E293B72657475726E206E3F7B72616E67653A6E65772072682874';
wwv_flow_imp.g_varchar2_table(30011) := '6869732E706F736974696F6E2E6C696E654E756D6265722C6E2E7374617274436F6C756D6E2C746869732E706F736974696F6E2E6C696E654E756D6265722C6E2E656E64436F6C756D6E292C746578743A6E2E776F72642C72656A656374526561736F6E';
wwv_flow_imp.g_varchar2_table(30012) := '3A742E6C656E6774683E303F742E6A6F696E28225C6E22293A766F696420307D3A7B72616E67653A72682E66726F6D506F736974696F6E7328746869732E706F736974696F6E292C746578743A22222C72656A656374526561736F6E3A742E6C656E6774';
wwv_flow_imp.g_varchar2_table(30013) := '683E303F742E6A6F696E28225C6E22293A766F696420307D7D6173796E632070726F7669646552656E616D65456469747328652C74297B72657475726E20746869732E5F70726F7669646552656E616D65456469747328652C746869732E5F70726F7669';
wwv_flow_imp.g_varchar2_table(30014) := '64657252656E616D654964782C5B5D2C74297D6173796E63205F70726F7669646552656E616D65456469747328652C742C6E2C69297B636F6E7374206F3D746869732E5F70726F7669646572735B745D3B696628216F2972657475726E7B65646974733A';
wwv_flow_imp.g_varchar2_table(30015) := '5B5D2C72656A656374526561736F6E3A6E2E6A6F696E28225C6E22297D3B636F6E737420733D6177616974206F2E70726F7669646552656E616D65456469747328746869732E6D6F64656C2C746869732E706F736974696F6E2C652C69293B7265747572';
wwv_flow_imp.g_varchar2_table(30016) := '6E20733F732E72656A656374526561736F6E3F746869732E5F70726F7669646552656E616D65456469747328652C742B312C6E2E636F6E63617428732E72656A656374526561736F6E292C69293A733A746869732E5F70726F7669646552656E616D6545';
wwv_flow_imp.g_varchar2_table(30017) := '6469747328652C742B312C6E2E636F6E636174286228302C224E6F20726573756C742E2229292C69297D7D6C6574204B383D71383D636C6173737B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E287138';
wwv_flow_imp.g_varchar2_table(30018) := '2E4944297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B746869732E656469746F723D652C746869732E5F696E737461536572766963653D742C746869732E5F6E6F74696669636174696F6E536572766963653D6E2C74';
wwv_flow_imp.g_varchar2_table(30019) := '6869732E5F62756C6B45646974536572766963653D692C746869732E5F70726F6772657373536572766963653D6F2C746869732E5F6C6F67536572766963653D732C746869732E5F636F6E666967536572766963653D722C746869732E5F6C616E677561';
wwv_flow_imp.g_varchar2_table(30020) := '67654665617475726573536572766963653D612C746869732E5F74656C656D65747279536572766963653D6C2C746869732E5F646973706F7361626C6553746F72653D6E65772061742C746869732E5F6374733D6E6577204E742C746869732E5F72656E';
wwv_flow_imp.g_varchar2_table(30021) := '616D655769646765743D746869732E5F646973706F7361626C6553746F72652E61646428746869732E5F696E737461536572766963652E637265617465496E7374616E6365287A382C746869732E656469746F722C5B2261636365707452656E616D6549';
wwv_flow_imp.g_varchar2_table(30022) := '6E707574222C2261636365707452656E616D65496E7075745769746850726576696577225D29297D646973706F736528297B746869732E5F646973706F7361626C6553746F72652E646973706F736528292C746869732E5F6374732E646973706F736528';
wwv_flow_imp.g_varchar2_table(30023) := '2130297D6173796E632072756E28297B76617220652C743B636F6E7374206E3D746869732E5F6C6F67536572766963652E74726163652E62696E6428746869732E5F6C6F67536572766963652C225B72656E616D655D22293B696628746869732E5F6374';
wwv_flow_imp.g_varchar2_table(30024) := '732E646973706F7365282130292C746869732E5F6374733D6E6577204E742C21746869732E656469746F722E6861734D6F64656C28292972657475726E20766F6964206E2822656469746F7220686173206E6F206D6F64656C22293B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(30025) := '746869732E656469746F722E676574506F736974696F6E28292C6F3D6E657720553828746869732E656469746F722E6765744D6F64656C28292C692C746869732E5F6C616E67756167654665617475726573536572766963652E72656E616D6550726F76';
wwv_flow_imp.g_varchar2_table(30026) := '69646572293B696628216F2E68617350726F766964657228292972657475726E20766F6964206E2822736B656C65746F6E20686173206E6F2070726F766964657222293B636F6E737420733D6E657720646B28746869732E656469746F722C352C766F69';
wwv_flow_imp.g_varchar2_table(30027) := '6420302C746869732E5F6374732E746F6B656E293B6C657420723B7472797B6E28227265736F6C76696E672072656E616D65206C6F636174696F6E22293B636F6E737420653D6F2E7265736F6C766552656E616D654C6F636174696F6E28732E746F6B65';
wwv_flow_imp.g_varchar2_table(30028) := '6E293B746869732E5F70726F6772657373536572766963652E73686F775768696C6528652C323530292C723D617761697420652C6E28227265736F6C7665642072656E616D65206C6F636174696F6E22297D63617463682874297B72657475726E20766F';
wwv_flow_imp.g_varchar2_table(30029) := '6964287420696E7374616E63656F662049653F6E28227265736F6C76652072656E616D65206C6F636174696F6E2063616E63656C6C6564222C4A534F4E2E737472696E6769667928742C6E756C6C2C225C742229293A286E28227265736F6C7665207265';
wwv_flow_imp.g_varchar2_table(30030) := '6E616D65206C6F636174696F6E206661696C6564222C7420696E7374616E63656F66204572726F723F743A4A534F4E2E737472696E6769667928742C6E756C6C2C225C742229292C2822737472696E67223D3D747970656F6620747C7C72632874292926';
wwv_flow_imp.g_varchar2_table(30031) := '26286E756C6C3D3D3D28653D62452E67657428746869732E656469746F7229297C7C766F696420303D3D3D657C7C652E73686F774D65737361676528747C7C6228302C22416E20756E6B6E6F776E206572726F72206F63637572726564207768696C6520';
wwv_flow_imp.g_varchar2_table(30032) := '7265736F6C76696E672072656E616D65206C6F636174696F6E22292C69292929297D66696E616C6C797B732E646973706F736528297D69662821722972657475726E20766F6964206E282272657475726E696E67206561726C79202D206E6F206C6F6322';
wwv_flow_imp.g_varchar2_table(30033) := '293B696628722E72656A656374526561736F6E2972657475726E206E286072657475726E696E67206561726C79202D2072656A6563746564207769746820726561736F6E3A20247B722E72656A656374526561736F6E7D602C722E72656A656374526561';
wwv_flow_imp.g_varchar2_table(30034) := '736F6E292C766F6964286E756C6C3D3D3D28743D62452E67657428746869732E656469746F7229297C7C766F696420303D3D3D747C7C742E73686F774D65737361676528722E72656A656374526561736F6E2C6929293B696628732E746F6B656E2E6973';
wwv_flow_imp.g_varchar2_table(30035) := '43616E63656C6C6174696F6E5265717565737465642972657475726E20766F6964206E282272657475726E696E67206561726C79202D20637473312063616E63656C6C656422293B636F6E737420613D6E657720646B28746869732E656469746F722C35';
wwv_flow_imp.g_varchar2_table(30036) := '2C722E72616E67652C746869732E5F6374732E746F6B656E292C6C3D746869732E656469746F722E6765744D6F64656C28292C633D746869732E5F6C616E67756167654665617475726573536572766963652E6E657753796D626F6C4E616D657350726F';
wwv_flow_imp.g_varchar2_table(30037) := '76696465722E616C6C286C292C643D61776169742050726F6D6973652E616C6C28632E6D617028286173796E6320653D3E7B76617220743B72657475726E5B652C6E756C6C213D3D28743D617761697420652E737570706F7274734175746F6D61746963';
wwv_flow_imp.g_varchar2_table(30038) := '4E657753796D626F6C4E616D6573547269676765724B696E64292626766F69642030213D3D742626745D7D2929293B6E28226372656174696E672072656E616D6520696E707574206669656C6420616E64206177616974696E672069747320726573756C';
wwv_flow_imp.g_varchar2_table(30039) := '7422293B636F6E737420683D746869732E5F62756C6B45646974536572766963652E6861735072657669657748616E646C657228292626746869732E5F636F6E666967536572766963652E67657456616C756528746869732E656469746F722E6765744D';
wwv_flow_imp.g_varchar2_table(30040) := '6F64656C28292E7572692C22656469746F722E72656E616D652E656E61626C655072657669657722292C753D617761697420746869732E5F72656E616D655769646765742E676574496E70757428722E72616E67652C722E746578742C682C632E6C656E';
wwv_flow_imp.g_varchar2_table(30041) := '6774683E303F28652C74293D3E7B6C6574206E3D642E736C69636528293B72657475726E20653D3D3D54772E4175746F6D617469632626286E3D6E2E66696C7465722828285B652C745D293D3E742929292C6E2E6D61702828285B6E5D293D3E6E2E7072';
wwv_flow_imp.g_varchar2_table(30042) := '6F766964654E657753796D626F6C4E616D6573286C2C722E72616E67652C652C742929297D3A766F696420302C61293B6966286E2822726563656976656420726573706F6E73652066726F6D2072656E616D6520696E707574206669656C6422292C632E';
wwv_flow_imp.g_varchar2_table(30043) := '6C656E6774683E302626746869732E5F7265706F727454656C656D6574727928632E6C656E6774682C6C2E6765744C616E6775616765496428292C75292C22626F6F6C65616E223D3D747970656F6620752972657475726E206E286072657475726E696E';
wwv_flow_imp.g_varchar2_table(30044) := '67206561726C79202D2072656E616D6520696E707574206669656C6420726573706F6E7365202D20247B757D60292C752626746869732E656469746F722E666F63757328292C766F696420612E646973706F736528293B746869732E656469746F722E66';
wwv_flow_imp.g_varchar2_table(30045) := '6F63757328292C6E282272657175657374696E672072656E616D6520656469747322293B636F6E737420703D4274286F2E70726F7669646552656E616D65456469747328752E6E65774E616D652C612E746F6B656E292C612E746F6B656E292E7468656E';
wwv_flow_imp.g_varchar2_table(30046) := '28286173796E6320653D3E7B6966286529696628746869732E656469746F722E6861734D6F64656C2829297B696628652E72656A656374526561736F6E2972657475726E206E286072657475726E696E67206561726C79202D2072656A65637465642077';
wwv_flow_imp.g_varchar2_table(30047) := '69746820726561736F6E3A20247B652E72656A656374526561736F6E7D60292C766F696420746869732E5F6E6F74696669636174696F6E536572766963652E696E666F28652E72656A656374526561736F6E293B746869732E656469746F722E73657453';
wwv_flow_imp.g_varchar2_table(30048) := '656C656374696F6E2872682E66726F6D506F736974696F6E7328746869732E656469746F722E67657453656C656374696F6E28292E676574506F736974696F6E282929292C6E28226170706C79696E6720656469747322292C746869732E5F62756C6B45';
wwv_flow_imp.g_varchar2_table(30049) := '646974536572766963652E6170706C7928652C7B656469746F723A746869732E656469746F722C73686F77507265766965773A752E77616E7473507265766965772C6C6162656C3A6228302C2252656E616D696E6720277B307D2720746F20277B317D27';
wwv_flow_imp.g_varchar2_table(30050) := '222C6E756C6C3D3D723F766F696420303A722E746578742C752E6E65774E616D65292C636F64653A22756E646F7265646F2E72656E616D65222C71756F7461626C654C6162656C3A6228302C2252656E616D696E67207B307D20746F207B317D222C6E75';
wwv_flow_imp.g_varchar2_table(30051) := '6C6C3D3D723F766F696420303A722E746578742C752E6E65774E616D65292C726573706563744175746F53617665436F6E6669673A21307D292E7468656E2828653D3E7B6E28226564697473206170706C69656422292C652E6172696153756D6D617279';
wwv_flow_imp.g_varchar2_table(30052) := '26265872286228302C225375636365737366756C6C792072656E616D656420277B307D2720746F20277B317D272E2053756D6D6172793A207B327D222C722E746578742C752E6E65774E616D652C652E6172696153756D6D61727929297D29292E636174';
wwv_flow_imp.g_varchar2_table(30053) := '63682828653D3E7B6E28606572726F72207768656E206170706C79696E6720656469747320247B4A534F4E2E737472696E6769667928652C6E756C6C2C225C7422297D60292C746869732E5F6E6F74696669636174696F6E536572766963652E6572726F';
wwv_flow_imp.g_varchar2_table(30054) := '72286228302C2252656E616D65206661696C656420746F206170706C792065646974732229292C746869732E5F6C6F67536572766963652E6572726F722865297D29297D656C7365206E282272657475726E696E67206561726C79202D206E6F206D6F64';
wwv_flow_imp.g_varchar2_table(30055) := '656C2061667465722072656E616D65206564697473206172652070726F766964656422293B656C7365206E282272657475726E696E67206561726C79202D206E6F2072656E616D6520656469747320726573756C7422297D292C28653D3E7B6E28226572';
wwv_flow_imp.g_varchar2_table(30056) := '726F72207768656E2070726F766964696E672072656E616D65206564697473222C4A534F4E2E737472696E6769667928652C6E756C6C2C225C742229292C746869732E5F6E6F74696669636174696F6E536572766963652E6572726F72286228302C2252';
wwv_flow_imp.g_varchar2_table(30057) := '656E616D65206661696C656420746F20636F6D707574652065646974732229292C746869732E5F6C6F67536572766963652E6572726F722865297D29292E66696E616C6C79282828293D3E7B612E646973706F736528297D29293B72657475726E206E28';
wwv_flow_imp.g_varchar2_table(30058) := '2272657475726E696E672072656E616D65206F7065726174696F6E22292C746869732E5F70726F6772657373536572766963652E73686F775768696C6528702C323530292C707D61636365707452656E616D65496E7075742865297B746869732E5F7265';
wwv_flow_imp.g_varchar2_table(30059) := '6E616D655769646765742E616363657074496E7075742865297D63616E63656C52656E616D65496E70757428297B746869732E5F72656E616D655769646765742E63616E63656C496E7075742821302C2263616E63656C52656E616D65496E7075742063';
wwv_flow_imp.g_varchar2_table(30060) := '6F6D6D616E6422297D666F6375734E65787452656E616D6553756767657374696F6E28297B746869732E5F72656E616D655769646765742E666F6375734E65787452656E616D6553756767657374696F6E28297D666F63757350726576696F757352656E';
wwv_flow_imp.g_varchar2_table(30061) := '616D6553756767657374696F6E28297B746869732E5F72656E616D655769646765742E666F63757350726576696F757352656E616D6553756767657374696F6E28297D5F7265706F727454656C656D6574727928652C742C6E297B636F6E737420693D22';
wwv_flow_imp.g_varchar2_table(30062) := '626F6F6C65616E223D3D747970656F66206E3F7B6B696E643A2263616E63656C6C6564222C6C616E677561676549643A742C6E52656E616D6553756767657374696F6E50726F7669646572733A657D3A7B6B696E643A226163636570746564222C6C616E';
wwv_flow_imp.g_varchar2_table(30063) := '677561676549643A742C6E52656E616D6553756767657374696F6E50726F7669646572733A652C736F757263653A6E2E73746174732E736F757263652E6B2C6E52656E616D6553756767657374696F6E733A6E2E73746174732E6E52656E616D65537567';
wwv_flow_imp.g_varchar2_table(30064) := '67657374696F6E732C74696D654265666F72654669727374496E7075744669656C64456469743A6E2E73746174732E74696D654265666F72654669727374496E7075744669656C64456469742C77616E7473507265766965773A6E2E77616E7473507265';
wwv_flow_imp.g_varchar2_table(30065) := '766965772C6E52656E616D6553756767657374696F6E73496E766F636174696F6E733A6E2E73746174732E6E52656E616D6553756767657374696F6E73496E766F636174696F6E732C6861644175746F6D6174696352656E616D6553756767657374696F';
wwv_flow_imp.g_varchar2_table(30066) := '6E73496E766F636174696F6E3A6E2E73746174732E6861644175746F6D6174696352656E616D6553756767657374696F6E73496E766F636174696F6E7D3B746869732E5F74656C656D65747279536572766963652E7075626C69634C6F6732282272656E';
wwv_flow_imp.g_varchar2_table(30067) := '616D65496E766F6B65644576656E74222C69297D7D3B4B382E49443D22656469746F722E636F6E747269622E72656E616D65436F6E74726F6C6C6572222C4B383D71383D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D65';
wwv_flow_imp.g_varchar2_table(30068) := '6E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266';
wwv_flow_imp.g_varchar2_table(30069) := '756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D';
wwv_flow_imp.g_varchar2_table(30070) := '655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B243828312C7563';
wwv_flow_imp.g_varchar2_table(30071) := '292C243828322C7344292C243828332C7978292C243828342C5345292C243828352C5264292C243828362C4748292C243828372C7878292C243828382C4F64295D2C4B38292C4A64284B382E49442C4B382C34292C5A6428636C61737320657874656E64';
wwv_flow_imp.g_varchar2_table(30072) := '732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E72656E616D65222C6C6162656C3A6228302C2252656E616D652053796D626F6C22292C616C6961733A2252656E616D652053796D626F6C22';
wwv_flow_imp.g_varchar2_table(30073) := '2C707265636F6E646974696F6E3A57632E616E64286C682E7772697461626C652C6C682E68617352656E616D6550726F7669646572292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A36302C';
wwv_flow_imp.g_varchar2_table(30074) := '7765696768743A3130307D2C636F6E746578744D656E754F7074733A7B67726F75703A22315F6D6F64696669636174696F6E222C6F726465723A312E317D7D297D72756E436F6D6D616E6428652C74297B636F6E7374206E3D652E676574286763292C5B';
wwv_flow_imp.g_varchar2_table(30075) := '692C6F5D3D41727261792E697341727261792874292626747C7C5B766F696420302C766F696420305D3B72657475726E204E6F2E697355726928692926266D632E697349506F736974696F6E286F293F6E2E6F70656E436F6465456469746F72287B7265';
wwv_flow_imp.g_varchar2_table(30076) := '736F757263653A697D2C6E2E676574416374697665436F6465456469746F722829292E7468656E2828653D3E7B65262628652E736574506F736974696F6E286F292C652E696E766F6B6557697468696E436F6E746578742828743D3E28746869732E7265';
wwv_flow_imp.g_varchar2_table(30077) := '706F727454656C656D6574727928742C65292C746869732E72756E28742C6529292929297D292C6B65293A73757065722E72756E436F6D6D616E6428652C74297D72756E28652C74297B636F6E7374206E3D652E676574285264292C693D4B382E676574';
wwv_flow_imp.g_varchar2_table(30078) := '2874293B72657475726E20693F286E2E747261636528225B52656E616D65416374696F6E5D20676F7420636F6E74726F6C6C65722C2072756E6E696E672E2E2E22292C692E72756E2829293A286E2E747261636528225B52656E616D65416374696F6E5D';
wwv_flow_imp.g_varchar2_table(30079) := '2072657475726E696E67206561726C79202D20636F6E74726F6C6C6572206D697373696E6722292C50726F6D6973652E7265736F6C76652829297D7D293B636F6E73742047383D24642E62696E64546F436F6E747269627574696F6E284B382E67657429';
wwv_flow_imp.g_varchar2_table(30080) := '3B5964286E6577204738287B69643A2261636365707452656E616D65496E707574222C707265636F6E646974696F6E3A56382C68616E646C65723A653D3E652E61636365707452656E616D65496E707574282131292C6B624F7074733A7B776569676874';
wwv_flow_imp.g_varchar2_table(30081) := '3A3139392C6B62457870723A57632E616E64286C682E666F6375732C57632E6E6F7428226973436F6D706F73696E672229292C7072696D6172793A337D7D29292C5964286E6577204738287B69643A2261636365707452656E616D65496E707574576974';
wwv_flow_imp.g_varchar2_table(30082) := '6850726576696577222C707265636F6E646974696F6E3A57632E616E642856382C57632E6861732822636F6E6669672E656469746F722E72656E616D652E656E61626C65507265766965772229292C68616E646C65723A653D3E652E6163636570745265';
wwv_flow_imp.g_varchar2_table(30083) := '6E616D65496E707574282130292C6B624F7074733A7B7765696768743A3139392C6B62457870723A57632E616E64286C682E666F6375732C57632E6E6F7428226973436F6D706F73696E672229292C7072696D6172793A323035317D7D29292C5964286E';
wwv_flow_imp.g_varchar2_table(30084) := '6577204738287B69643A2263616E63656C52656E616D65496E707574222C707265636F6E646974696F6E3A56382C68616E646C65723A653D3E652E63616E63656C52656E616D65496E70757428292C6B624F7074733A7B7765696768743A3139392C6B62';
wwv_flow_imp.g_varchar2_table(30085) := '457870723A6C682E666F6375732C7072696D6172793A392C7365636F6E646172793A5B313033335D7D7D29292C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A22666F6375734E65787452';
wwv_flow_imp.g_varchar2_table(30086) := '656E616D6553756767657374696F6E222C7469746C653A7B2E2E2E5F28302C22466F637573204E6578742052656E616D652053756767657374696F6E22297D2C707265636F6E646974696F6E3A56382C6B657962696E64696E673A5B7B7072696D617279';
wwv_flow_imp.g_varchar2_table(30087) := '3A31382C7765696768743A3139397D5D7D297D72756E2865297B636F6E737420743D652E676574286763292E676574466F6375736564436F6465456469746F7228293B69662821742972657475726E3B636F6E7374206E3D4B382E6765742874293B6E26';
wwv_flow_imp.g_varchar2_table(30088) := '266E2E666F6375734E65787452656E616D6553756767657374696F6E28297D7D292C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A22666F63757350726576696F757352656E616D655375';
wwv_flow_imp.g_varchar2_table(30089) := '6767657374696F6E222C7469746C653A7B2E2E2E5F28302C22466F6375732050726576696F75732052656E616D652053756767657374696F6E22297D2C707265636F6E646974696F6E3A56382C6B657962696E64696E673A5B7B7072696D6172793A3136';
wwv_flow_imp.g_varchar2_table(30090) := '2C7765696768743A3139397D5D7D297D72756E2865297B636F6E737420743D652E676574286763292E676574466F6375736564436F6465456469746F7228293B69662821742972657475726E3B636F6E7374206E3D4B382E6765742874293B6E26266E2E';
wwv_flow_imp.g_varchar2_table(30091) := '666F63757350726576696F757352656E616D6553756767657374696F6E28297D7D292C516428225F65786563757465446F63756D656E7452656E616D6550726F7669646572222C2866756E6374696F6E28652C742C6E2C2E2E2E69297B636F6E73745B6F';
wwv_flow_imp.g_varchar2_table(30092) := '5D3D693B796C2822737472696E67223D3D747970656F66206F293B636F6E73747B72656E616D6550726F76696465723A737D3D652E676574287878293B72657475726E206173796E632066756E6374696F6E28652C742C6E2C69297B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(30093) := '6E657720553828742C6E2C65292C733D6177616974206F2E7265736F6C766552656E616D654C6F636174696F6E284D742E4E6F6E65293B72657475726E286E756C6C3D3D733F766F696420303A732E72656A656374526561736F6E293F7B65646974733A';
wwv_flow_imp.g_varchar2_table(30094) := '5B5D2C72656A656374526561736F6E3A732E72656A656374526561736F6E7D3A6F2E70726F7669646552656E616D65456469747328692C4D742E4E6F6E65297D28732C742C6E2C6F297D29292C516428225F657865637574655072657061726552656E61';
wwv_flow_imp.g_varchar2_table(30095) := '6D65222C286173796E632066756E6374696F6E28652C742C6E297B636F6E73747B72656E616D6550726F76696465723A697D3D652E676574287878292C6F3D6E657720553828742C6E2C69292C733D6177616974206F2E7265736F6C766552656E616D65';
wwv_flow_imp.g_varchar2_table(30096) := '4C6F636174696F6E284D742E4E6F6E65293B6966286E756C6C3D3D733F766F696420303A732E72656A656374526561736F6E297468726F77206E6577204572726F7228732E72656A656374526561736F6E293B72657475726E20737D29292C79642E6173';
wwv_flow_imp.g_varchar2_table(30097) := '285470292E7265676973746572436F6E66696775726174696F6E287B69643A22656469746F72222C70726F706572746965733A7B22656469746F722E72656E616D652E656E61626C6550726576696577223A7B73636F70653A352C646573637269707469';
wwv_flow_imp.g_varchar2_table(30098) := '6F6E3A6228302C22456E61626C652F64697361626C6520746865206162696C69747920746F2070726576696577206368616E676573206265666F72652072656E616D696E6722292C64656661756C743A21302C747970653A22626F6F6C65616E227D7D7D';
wwv_flow_imp.g_varchar2_table(30099) := '293B7661722051383D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742059383D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B7375';
wwv_flow_imp.g_varchar2_table(30100) := '70657228292C746869732E656469746F723D652C746869732E6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E656469746F72576F726B6572536572766963653D6E2C746869732E6465636F726174696F6E733D';
wwv_flow_imp.g_varchar2_table(30101) := '746869732E656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E6F7074696F6E733D746869732E6372656174654F7074696F6E7328652E6765744F7074696F6E28373329292C746869732E636F6D70';
wwv_flow_imp.g_varchar2_table(30102) := '75746550726F6D6973653D6E756C6C2C746869732E63757272656E744F6363757272656E6365733D7B7D2C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C2828743D3E7B746869732E63757272656E744F6363757272';
wwv_flow_imp.g_varchar2_table(30103) := '656E6365733D7B7D2C746869732E6F7074696F6E733D746869732E6372656174654F7074696F6E7328652E6765744F7074696F6E28373329292C746869732E73746F7028292C746869732E636F6D7075746553656374696F6E486561646572732E736368';
wwv_flow_imp.g_varchar2_table(30104) := '6564756C652830297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D6F64656C4C616E67756167652828743D3E7B746869732E63757272656E744F6363757272656E6365733D7B7D2C746869732E6F7074696F6E733D';
wwv_flow_imp.g_varchar2_table(30105) := '746869732E6372656174654F7074696F6E7328652E6765744F7074696F6E28373329292C746869732E73746F7028292C746869732E636F6D7075746553656374696F6E486561646572732E7363686564756C652830297D2929292C746869732E5F726567';
wwv_flow_imp.g_varchar2_table(30106) := '697374657228742E6F6E4469644368616E67652828743D3E7B766172206E3B636F6E737420693D6E756C6C3D3D3D286E3D746869732E656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D6E3F766F696420303A6E2E6765744C616E';
wwv_flow_imp.g_varchar2_table(30107) := '6775616765496428293B692626742E61666665637473286929262628746869732E63757272656E744F6363757272656E6365733D7B7D2C746869732E6F7074696F6E733D746869732E6372656174654F7074696F6E7328652E6765744F7074696F6E2837';
wwv_flow_imp.g_varchar2_table(30108) := '3329292C746869732E73746F7028292C746869732E636F6D7075746553656374696F6E486561646572732E7363686564756C65283029297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E6765436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(30109) := '6E2828743D3E7B746869732E6F7074696F6E73262621742E6861734368616E676564283733297C7C28746869732E6F7074696F6E733D746869732E6372656174654F7074696F6E7328652E6765744F7074696F6E28373329292C746869732E7570646174';
wwv_flow_imp.g_varchar2_table(30110) := '654465636F726174696F6E73285B5D292C746869732E73746F7028292C746869732E636F6D7075746553656374696F6E486561646572732E7363686564756C65283029297D2929292C746869732E5F726567697374657228746869732E656469746F722E';
wwv_flow_imp.g_varchar2_table(30111) := '6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E636F6D7075746553656374696F6E486561646572732E7363686564756C6528297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E67654D';
wwv_flow_imp.g_varchar2_table(30112) := '6F64656C546F6B656E732828653D3E7B746869732E636F6D7075746553656374696F6E486561646572732E69735363686564756C656428297C7C746869732E636F6D7075746553656374696F6E486561646572732E7363686564756C6528316533297D29';
wwv_flow_imp.g_varchar2_table(30113) := '29292C746869732E636F6D7075746553656374696F6E486561646572733D746869732E5F7265676973746572286E6577204B74282828293D3E7B746869732E66696E6453656374696F6E4865616465727328297D292C32353029292C746869732E636F6D';
wwv_flow_imp.g_varchar2_table(30114) := '7075746553656374696F6E486561646572732E7363686564756C652830297D6372656174654F7074696F6E732865297B69662821657C7C21746869732E656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E65';
wwv_flow_imp.g_varchar2_table(30115) := '6469746F722E6765744D6F64656C28292E6765744C616E6775616765496428293B69662821742972657475726E3B636F6E7374206E3D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E677561676543';
wwv_flow_imp.g_varchar2_table(30116) := '6F6E66696775726174696F6E2874292E636F6D6D656E74732C693D746869732E6C616E6775616765436F6E66696775726174696F6E536572766963652E6765744C616E6775616765436F6E66696775726174696F6E2874292E666F6C64696E6752756C65';
wwv_flow_imp.g_varchar2_table(30117) := '733B72657475726E206E7C7C286E756C6C3D3D693F766F696420303A692E6D61726B657273293F7B666F6C64696E6752756C65733A692C66696E644D61726B53656374696F6E486561646572733A652E73686F774D61726B53656374696F6E4865616465';
wwv_flow_imp.g_varchar2_table(30118) := '72732C66696E64526567696F6E53656374696F6E486561646572733A652E73686F77526567696F6E53656374696F6E486561646572737D3A766F696420307D66696E6453656374696F6E4865616465727328297B76617220652C743B6966282174686973';
wwv_flow_imp.g_varchar2_table(30119) := '2E656469746F722E6861734D6F64656C28297C7C21286E756C6C3D3D3D28653D746869732E6F7074696F6E73297C7C766F696420303D3D3D653F766F696420303A652E66696E644D61726B53656374696F6E4865616465727329262621286E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(30120) := '3D28743D746869732E6F7074696F6E73297C7C766F696420303D3D3D743F766F696420303A742E66696E64526567696F6E53656374696F6E48656164657273292972657475726E3B636F6E7374206E3D746869732E656469746F722E6765744D6F64656C';
wwv_flow_imp.g_varchar2_table(30121) := '28293B6966286E2E6973446973706F73656428297C7C6E2E6973546F6F4C61726765466F7253796E63696E6728292972657475726E3B636F6E737420693D6E2E67657456657273696F6E496428293B746869732E656469746F72576F726B657253657276';
wwv_flow_imp.g_varchar2_table(30122) := '6963652E66696E6453656374696F6E48656164657273286E2E7572692C746869732E6F7074696F6E73292E7468656E2828653D3E7B6E2E6973446973706F73656428297C7C6E2E67657456657273696F6E49642829213D3D697C7C746869732E75706461';
wwv_flow_imp.g_varchar2_table(30123) := '74654465636F726174696F6E732865297D29297D7570646174654465636F726174696F6E732865297B636F6E737420743D746869732E656469746F722E6765744D6F64656C28293B74262628653D652E66696C7465722828653D3E7B69662821652E7368';
wwv_flow_imp.g_varchar2_table(30124) := '6F756C644265496E436F6D6D656E74732972657475726E21303B636F6E7374206E3D742E76616C696461746552616E676528652E72616E6765292C693D742E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E73286E2E73746172744C696E';
wwv_flow_imp.g_varchar2_table(30125) := '654E756D626572292C6F3D692E66696E64546F6B656E496E64657841744F6666736574286E2E7374617274436F6C756D6E2D31292C733D692E6765745374616E64617264546F6B656E54797065286F293B72657475726E20692E6765744C616E67756167';
wwv_flow_imp.g_varchar2_table(30126) := '654964286F293D3D3D742E6765744C616E6775616765496428292626313D3D3D737D2929293B636F6E7374206E3D4F626A6563742E76616C75657328746869732E63757272656E744F6363757272656E636573292E6D61702828653D3E652E6465636F72';
wwv_flow_imp.g_varchar2_table(30127) := '6174696F6E496429292C693D652E6D61702828653D3E66756E6374696F6E2865297B72657475726E7B72616E67653A652E72616E67652C6F7074696F6E733A4F432E63726561746544796E616D6963287B6465736372697074696F6E3A2273656374696F';
wwv_flow_imp.g_varchar2_table(30128) := '6E2D686561646572222C737469636B696E6573733A332C636F6C6C617073654F6E5265706C616365456469743A21302C6D696E696D61703A7B636F6C6F723A766F696420302C706F736974696F6E3A312C73656374696F6E4865616465725374796C653A';
wwv_flow_imp.g_varchar2_table(30129) := '652E686173536570617261746F724C696E653F323A312C73656374696F6E486561646572546578743A652E746578747D7D297D7D28652929293B746869732E656469746F722E6368616E67654465636F726174696F6E732828743D3E7B636F6E7374206F';
wwv_flow_imp.g_varchar2_table(30130) := '3D742E64656C74614465636F726174696F6E73286E2C69293B746869732E63757272656E744F6363757272656E6365733D7B7D3B666F72286C657420743D302C6E3D6F2E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D7B73656374696F6E';
wwv_flow_imp.g_varchar2_table(30131) := '4865616465723A655B745D2C6465636F726174696F6E49643A6F5B745D7D3B746869732E63757272656E744F6363757272656E6365735B6E2E6465636F726174696F6E49645D3D6E7D7D29297D73746F7028297B746869732E636F6D7075746553656374';
wwv_flow_imp.g_varchar2_table(30132) := '696F6E486561646572732E63616E63656C28292C746869732E636F6D7075746550726F6D697365262628746869732E636F6D7075746550726F6D6973652E63616E63656C28292C746869732E636F6D7075746550726F6D6973653D6E756C6C297D646973';
wwv_flow_imp.g_varchar2_table(30133) := '706F736528297B73757065722E646973706F736528292C746869732E73746F7028292C746869732E6465636F726174696F6E732E636C65617228297D7D3B59382E49443D22656469746F722E73656374696F6E4865616465724465746563746F72222C59';
wwv_flow_imp.g_varchar2_table(30134) := '383D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E29';
wwv_flow_imp.g_varchar2_table(30135) := '3A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C7365';
wwv_flow_imp.g_varchar2_table(30136) := '20666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A656374';
wwv_flow_imp.g_varchar2_table(30137) := '2E646566696E6550726F706572747928742C6E2C72292C727D285B513828312C6567292C513828322C7A5A295D2C5938292C4A642859382E49442C59382C31293B636C617373205A387B7374617469632063726561746528652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(30138) := '6E6577205A3828652C6E6577205838287429297D6765742073746172744C696E654E756D62657228297B72657475726E20746869732E5F73746172744C696E654E756D6265727D67657420656E644C696E654E756D62657228297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(30139) := '69732E5F656E644C696E654E756D6265727D636F6E7374727563746F7228652C74297B746869732E5F73746172744C696E654E756D6265723D652C746869732E5F746F6B656E733D742C746869732E5F656E644C696E654E756D6265723D746869732E5F';
wwv_flow_imp.g_varchar2_table(30140) := '73746172744C696E654E756D6265722B746869732E5F746F6B656E732E6765744D617844656C74614C696E6528297D746F537472696E6728297B72657475726E20746869732E5F746F6B656E732E746F537472696E6728746869732E5F73746172744C69';
wwv_flow_imp.g_varchar2_table(30141) := '6E654E756D626572297D5F757064617465456E644C696E654E756D62657228297B746869732E5F656E644C696E654E756D6265723D746869732E5F73746172744C696E654E756D6265722B746869732E5F746F6B656E732E6765744D617844656C74614C';
wwv_flow_imp.g_varchar2_table(30142) := '696E6528297D6973456D70747928297B72657475726E20746869732E5F746F6B656E732E6973456D70747928297D6765744C696E65546F6B656E732865297B72657475726E20746869732E5F73746172744C696E654E756D6265723C3D652626653C3D74';
wwv_flow_imp.g_varchar2_table(30143) := '6869732E5F656E644C696E654E756D6265723F746869732E5F746F6B656E732E6765744C696E65546F6B656E7328652D746869732E5F73746172744C696E654E756D626572293A6E756C6C7D67657452616E676528297B636F6E737420653D746869732E';
wwv_flow_imp.g_varchar2_table(30144) := '5F746F6B656E732E67657452616E676528293B72657475726E20653F6E657720726828746869732E5F73746172744C696E654E756D6265722B652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E2C746869732E5F7374617274';
wwv_flow_imp.g_varchar2_table(30145) := '4C696E654E756D6265722B652E656E644C696E654E756D6265722C652E656E64436F6C756D6E293A657D72656D6F7665546F6B656E732865297B636F6E737420743D652E73746172744C696E654E756D6265722D746869732E5F73746172744C696E654E';
wwv_flow_imp.g_varchar2_table(30146) := '756D6265722C6E3D652E656E644C696E654E756D6265722D746869732E5F73746172744C696E654E756D6265723B746869732E5F73746172744C696E654E756D6265722B3D746869732E5F746F6B656E732E72656D6F7665546F6B656E7328742C652E73';
wwv_flow_imp.g_varchar2_table(30147) := '74617274436F6C756D6E2D312C6E2C652E656E64436F6C756D6E2D31292C746869732E5F757064617465456E644C696E654E756D62657228297D73706C69742865297B636F6E737420743D652E73746172744C696E654E756D6265722D746869732E5F73';
wwv_flow_imp.g_varchar2_table(30148) := '746172744C696E654E756D6265722C6E3D652E656E644C696E654E756D6265722D746869732E5F73746172744C696E654E756D6265722C5B692C6F2C735D3D746869732E5F746F6B656E732E73706C697428742C652E7374617274436F6C756D6E2D312C';
wwv_flow_imp.g_varchar2_table(30149) := '6E2C652E656E64436F6C756D6E2D31293B72657475726E5B6E6577205A3828746869732E5F73746172744C696E654E756D6265722C69292C6E6577205A3828746869732E5F73746172744C696E654E756D6265722B732C6F295D7D6170706C7945646974';
wwv_flow_imp.g_varchar2_table(30150) := '28652C74297B636F6E73745B6E2C692C6F5D3D75752874293B746869732E6163636570744564697428652C6E2C692C6F2C742E6C656E6774683E303F742E63686172436F646541742830293A30297D6163636570744564697428652C742C6E2C692C6F29';
wwv_flow_imp.g_varchar2_table(30151) := '7B746869732E5F61636365707444656C65746552616E67652865292C746869732E5F616363657074496E7365727454657874286E6577206D6328652E73746172744C696E654E756D6265722C652E7374617274436F6C756D6E292C742C6E2C692C6F292C';
wwv_flow_imp.g_varchar2_table(30152) := '746869732E5F757064617465456E644C696E654E756D62657228297D5F61636365707444656C65746552616E67652865297B696628652E73746172744C696E654E756D6265723D3D3D652E656E644C696E654E756D6265722626652E7374617274436F6C';
wwv_flow_imp.g_varchar2_table(30153) := '756D6E3D3D3D652E656E64436F6C756D6E2972657475726E3B636F6E737420743D652E73746172744C696E654E756D6265722D746869732E5F73746172744C696E654E756D6265722C6E3D652E656E644C696E654E756D6265722D746869732E5F737461';
wwv_flow_imp.g_varchar2_table(30154) := '72744C696E654E756D6265723B6966286E3C30297B636F6E737420653D6E2D743B72657475726E20766F696428746869732E5F73746172744C696E654E756D6265722D3D65297D636F6E737420693D746869732E5F746F6B656E732E6765744D61784465';
wwv_flow_imp.g_varchar2_table(30155) := '6C74614C696E6528293B6966282128743E3D692B3129297B696628743C3026266E3E3D692B312972657475726E20746869732E5F73746172744C696E654E756D6265723D302C766F696420746869732E5F746F6B656E732E636C65617228293B69662874';
wwv_flow_imp.g_varchar2_table(30156) := '3C30297B636F6E737420693D2D743B746869732E5F73746172744C696E654E756D6265722D3D692C746869732E5F746F6B656E732E61636365707444656C65746552616E676528652E7374617274436F6C756D6E2D312C302C302C6E2C652E656E64436F';
wwv_flow_imp.g_varchar2_table(30157) := '6C756D6E2D31297D656C736520746869732E5F746F6B656E732E61636365707444656C65746552616E676528302C742C652E7374617274436F6C756D6E2D312C6E2C652E656E64436F6C756D6E2D31297D7D5F616363657074496E736572745465787428';
wwv_flow_imp.g_varchar2_table(30158) := '652C742C6E2C692C6F297B696628303D3D3D742626303D3D3D6E2972657475726E3B636F6E737420733D652E6C696E654E756D6265722D746869732E5F73746172744C696E654E756D6265723B733C303F746869732E5F73746172744C696E654E756D62';
wwv_flow_imp.g_varchar2_table(30159) := '65722B3D743A733E3D746869732E5F746F6B656E732E6765744D617844656C74614C696E6528292B317C7C746869732E5F746F6B656E732E616363657074496E736572745465787428732C652E636F6C756D6E2D312C742C6E2C692C6F297D7D636C6173';
wwv_flow_imp.g_varchar2_table(30160) := '732058387B636F6E7374727563746F722865297B746869732E5F746F6B656E733D652C746869732E5F746F6B656E436F756E743D652E6C656E6774682F347D746F537472696E672865297B636F6E737420743D5B5D3B666F72286C6574206E3D303B6E3C';
wwv_flow_imp.g_varchar2_table(30161) := '746869732E5F746F6B656E436F756E743B6E2B2B29742E70757368286028247B746869732E5F67657444656C74614C696E65286E292B657D2C247B746869732E5F6765745374617274436861726163746572286E297D2D247B746869732E5F676574456E';
wwv_flow_imp.g_varchar2_table(30162) := '64436861726163746572286E297D2960293B72657475726E605B247B742E6A6F696E28222C22297D5D607D6765744D617844656C74614C696E6528297B636F6E737420653D746869732E5F676574546F6B656E436F756E7428293B72657475726E20303D';
wwv_flow_imp.g_varchar2_table(30163) := '3D3D653F2D313A746869732E5F67657444656C74614C696E6528652D31297D67657452616E676528297B636F6E737420653D746869732E5F676574546F6B656E436F756E7428293B696628303D3D3D652972657475726E206E756C6C3B636F6E73742074';
wwv_flow_imp.g_varchar2_table(30164) := '3D746869732E5F67657453746172744368617261637465722830292C6E3D746869732E5F67657444656C74614C696E6528652D31292C693D746869732E5F676574456E6443686172616374657228652D31293B72657475726E206E657720726828302C74';
wwv_flow_imp.g_varchar2_table(30165) := '2B312C6E2C692B31297D5F676574546F6B656E436F756E7428297B72657475726E20746869732E5F746F6B656E436F756E747D5F67657444656C74614C696E652865297B72657475726E20746869732E5F746F6B656E735B342A655D7D5F676574537461';
wwv_flow_imp.g_varchar2_table(30166) := '72744368617261637465722865297B72657475726E20746869732E5F746F6B656E735B342A652B315D7D5F676574456E644368617261637465722865297B72657475726E20746869732E5F746F6B656E735B342A652B325D7D6973456D70747928297B72';
wwv_flow_imp.g_varchar2_table(30167) := '657475726E20303D3D3D746869732E5F676574546F6B656E436F756E7428297D6765744C696E65546F6B656E732865297B6C657420743D302C6E3D746869732E5F676574546F6B656E436F756E7428292D313B666F72283B743C6E3B297B636F6E737420';
wwv_flow_imp.g_varchar2_table(30168) := '693D742B4D6174682E666C6F6F7228286E2D74292F32292C6F3D746869732E5F67657444656C74614C696E652869293B6966286F3C6529743D692B313B656C73657B69662821286F3E6529297B6C6574206F3D693B666F72283B6F3E742626746869732E';
wwv_flow_imp.g_varchar2_table(30169) := '5F67657444656C74614C696E65286F2D31293D3D3D653B296F2D2D3B6C657420733D693B666F72283B733C6E2626746869732E5F67657444656C74614C696E6528732B31293D3D3D653B29732B2B3B72657475726E206E6577204A3828746869732E5F74';
wwv_flow_imp.g_varchar2_table(30170) := '6F6B656E732E737562617272617928342A6F2C342A732B3429297D6E3D692D317D7D72657475726E20746869732E5F67657444656C74614C696E652874293D3D3D653F6E6577204A3828746869732E5F746F6B656E732E737562617272617928342A742C';
wwv_flow_imp.g_varchar2_table(30171) := '342A742B3429293A6E756C6C7D636C65617228297B746869732E5F746F6B656E436F756E743D307D72656D6F7665546F6B656E7328652C742C6E2C69297B636F6E7374206F3D746869732E5F746F6B656E732C733D746869732E5F746F6B656E436F756E';
wwv_flow_imp.g_varchar2_table(30172) := '743B6C657420723D302C613D21312C6C3D303B666F72286C657420633D303B633C733B632B2B297B636F6E737420733D342A632C643D6F5B735D2C683D6F5B732B315D2C753D6F5B732B325D2C703D6F5B732B335D3B69662828643E657C7C643D3D3D65';
wwv_flow_imp.g_varchar2_table(30173) := '2626753E3D7429262628643C6E7C7C643D3D3D6E2626683C3D692929613D21303B656C73657B696628303D3D3D722626286C3D64292C61297B636F6E737420653D342A723B6F5B655D3D642D6C2C6F5B652B315D3D682C6F5B652B325D3D752C6F5B652B';
wwv_flow_imp.g_varchar2_table(30174) := '335D3D707D722B2B7D7D72657475726E20746869732E5F746F6B656E436F756E743D722C6C7D73706C697428652C742C6E2C69297B636F6E7374206F3D746869732E5F746F6B656E732C733D746869732E5F746F6B656E436F756E742C723D5B5D2C613D';
wwv_flow_imp.g_varchar2_table(30175) := '5B5D3B6C6574206C3D722C633D302C643D303B666F72286C657420723D303B723C733B722B2B297B636F6E737420733D342A722C683D6F5B735D2C753D6F5B732B315D2C703D6F5B732B325D2C673D6F5B732B335D3B696628683E657C7C683D3D3D6526';
wwv_flow_imp.g_varchar2_table(30176) := '26703E3D74297B696628683C6E7C7C683D3D3D6E2626753C3D6929636F6E74696E75653B6C213D3D612626286C3D612C633D302C643D68297D6C5B632B2B5D3D682D642C6C5B632B2B5D3D752C6C5B632B2B5D3D702C6C5B632B2B5D3D677D7265747572';
wwv_flow_imp.g_varchar2_table(30177) := '6E5B6E6577205838286E65772055696E7433324172726179287229292C6E6577205838286E65772055696E7433324172726179286129292C645D7D61636365707444656C65746552616E676528652C742C6E2C692C6F297B636F6E737420733D74686973';
wwv_flow_imp.g_varchar2_table(30178) := '2E5F746F6B656E732C723D746869732E5F746F6B656E436F756E742C613D692D743B6C6574206C3D302C633D21313B666F72286C657420643D303B643C723B642B2B297B636F6E737420683D342A643B6C657420753D735B685D2C703D735B682B315D2C';
wwv_flow_imp.g_varchar2_table(30179) := '673D735B682B325D3B636F6E7374206D3D735B682B335D3B696628753C747C7C753D3D3D742626673C3D6E297B6C2B2B3B636F6E74696E75657D696628753D3D3D742626703C6E29753D3D3D692626673E6F3F672D3D6F2D6E3A673D6E3B656C73652069';
wwv_flow_imp.g_varchar2_table(30180) := '6628753D3D3D742626703D3D3D6E297B6966282128753D3D3D692626673E6F29297B633D21303B636F6E74696E75657D672D3D6F2D6E7D656C736520696628753C697C7C753D3D3D692626703C6F297B6966282128753D3D3D692626673E6F29297B633D';
wwv_flow_imp.g_varchar2_table(30181) := '21303B636F6E74696E75657D753D742C703D6E2C673D702B28672D6F297D656C736520696628753E69297B696628303D3D3D6126262163297B6C3D723B627265616B7D752D3D617D656C73657B6966282128753D3D3D692626703E3D6F29297468726F77';
wwv_flow_imp.g_varchar2_table(30182) := '206E6577204572726F7228224E6F7420706F737369626C652122293B652626303D3D3D75262628702B3D652C672B3D65292C752D3D612C702D3D6F2D6E2C672D3D6F2D6E7D636F6E737420663D342A6C3B735B665D3D752C735B662B315D3D702C735B66';
wwv_flow_imp.g_varchar2_table(30183) := '2B325D3D672C735B662B335D3D6D2C6C2B2B7D746869732E5F746F6B656E436F756E743D6C7D616363657074496E736572745465787428652C742C6E2C692C6F2C73297B636F6E737420723D303D3D3D6E2626313D3D3D69262628733E3D34382626733C';
wwv_flow_imp.g_varchar2_table(30184) := '3D35377C7C733E3D36352626733C3D39307C7C733E3D39372626733C3D313232292C613D746869732E5F746F6B656E732C6C3D746869732E5F746F6B656E436F756E743B666F72286C657420733D303B733C6C3B732B2B297B636F6E7374206C3D342A73';
wwv_flow_imp.g_varchar2_table(30185) := '3B6C657420633D615B6C5D2C643D615B6C2B315D2C683D615B6C2B325D3B6966282128633C657C7C633D3D3D652626683C7429297B696628633D3D3D652626683D3D3D74297B696628217229636F6E74696E75653B682B3D317D656C736520696628633D';
wwv_flow_imp.g_varchar2_table(30186) := '3D3D652626643C742626743C6829303D3D3D6E3F682B3D693A683D743B656C73657B696628633D3D3D652626643D3D3D7426267229636F6E74696E75653B696628633D3D3D6529696628632B3D6E2C303D3D3D6E29642B3D692C682B3D693B656C73657B';
wwv_flow_imp.g_varchar2_table(30187) := '636F6E737420653D682D643B643D6F2B28642D74292C683D642B657D656C736520632B3D6E7D615B6C5D3D632C615B6C2B315D3D642C615B6C2B325D3D687D7D7D7D636C617373204A387B636F6E7374727563746F722865297B746869732E5F746F6B65';
wwv_flow_imp.g_varchar2_table(30188) := '6E733D657D676574436F756E7428297B72657475726E20746869732E5F746F6B656E732E6C656E6774682F347D67657453746172744368617261637465722865297B72657475726E20746869732E5F746F6B656E735B342A652B315D7D676574456E6443';
wwv_flow_imp.g_varchar2_table(30189) := '68617261637465722865297B72657475726E20746869732E5F746F6B656E735B342A652B325D7D6765744D657461646174612865297B72657475726E20746869732E5F746F6B656E735B342A652B335D7D7D7661722065393D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(30190) := '74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742074393D636C6173737B636F6E7374727563746F7228652C742C6E2C69297B746869732E5F6C6567656E643D652C746869732E5F7468656D655365727669';
wwv_flow_imp.g_varchar2_table(30191) := '63653D742C746869732E5F6C616E6775616765536572766963653D6E2C746869732E5F6C6F67536572766963653D692C746869732E5F6861735761726E65644F7665726C617070696E67546F6B656E733D21312C746869732E5F6861735761726E656449';
wwv_flow_imp.g_varchar2_table(30192) := '6E76616C69644C656E677468546F6B656E733D21312C746869732E5F6861735761726E6564496E76616C69644564697453746172743D21312C746869732E5F686173685461626C653D6E6577206F397D6765744D6574616461746128652C742C6E297B63';
wwv_flow_imp.g_varchar2_table(30193) := '6F6E737420693D746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632E656E636F64654C616E67756167654964286E292C6F3D746869732E5F686173685461626C652E67657428652C742C69293B6C657420733B';
wwv_flow_imp.g_varchar2_table(30194) := '6966286F29733D6F2E6D657461646174612C746869732E5F6C6F67536572766963652E6765744C6576656C28293D3D3D46642E54726163652626746869732E5F6C6F67536572766963652E7472616365286053656D616E746963546F6B656E7350726F76';
wwv_flow_imp.g_varchar2_table(30195) := '696465725374796C696E67205B4341434845445D20247B657D202F20247B747D3A20666F726567726F756E6420247B51672E676574466F726567726F756E642873297D2C20666F6E745374796C6520247B51672E676574466F6E745374796C652873292E';
wwv_flow_imp.g_varchar2_table(30196) := '746F537472696E672832297D60293B656C73657B6C6574206F3D746869732E5F6C6567656E642E746F6B656E54797065735B655D3B636F6E737420723D5B5D3B6966286F297B6C657420653D743B666F72286C657420743D303B653E302626743C746869';
wwv_flow_imp.g_varchar2_table(30197) := '732E5F6C6567656E642E746F6B656E4D6F646966696572732E6C656E6774683B742B2B293126652626722E7075736828746869732E5F6C6567656E642E746F6B656E4D6F646966696572735B745D292C653E3E3D313B653E302626746869732E5F6C6F67';
wwv_flow_imp.g_varchar2_table(30198) := '536572766963652E6765744C6576656C28293D3D3D46642E5472616365262628746869732E5F6C6F67536572766963652E7472616365286053656D616E746963546F6B656E7350726F76696465725374796C696E673A20756E6B6E6F776E20746F6B656E';
wwv_flow_imp.g_varchar2_table(30199) := '206D6F64696669657220696E6465783A20247B742E746F537472696E672832297D20666F72206C6567656E643A20247B4A534F4E2E737472696E6769667928746869732E5F6C6567656E642E746F6B656E4D6F64696669657273297D60292C722E707573';
wwv_flow_imp.g_varchar2_table(30200) := '6828226E6F742D696E2D6C6567656E642229293B636F6E737420693D746869732E5F7468656D65536572766963652E676574436F6C6F725468656D6528292E676574546F6B656E5374796C654D65746164617461286F2C722C6E293B766F696420303D3D';
wwv_flow_imp.g_varchar2_table(30201) := '3D693F733D323134373438333634373A28733D302C766F69642030213D3D692E6974616C6963262628737C3D317C28692E6974616C69633F313A30293C3C3131292C766F69642030213D3D692E626F6C64262628737C3D327C28692E626F6C643F323A30';
wwv_flow_imp.g_varchar2_table(30202) := '293C3C3131292C766F69642030213D3D692E756E6465726C696E65262628737C3D347C28692E756E6465726C696E653F343A30293C3C3131292C766F69642030213D3D692E737472696B657468726F756768262628737C3D387C28692E737472696B6574';
wwv_flow_imp.g_varchar2_table(30203) := '68726F7567683F383A30293C3C3131292C692E666F726567726F756E64262628737C3D31367C692E666F726567726F756E643C3C3135292C303D3D3D73262628733D3231343734383336343729297D656C736520746869732E5F6C6F6753657276696365';
wwv_flow_imp.g_varchar2_table(30204) := '2E6765744C6576656C28293D3D3D46642E54726163652626746869732E5F6C6F67536572766963652E7472616365286053656D616E746963546F6B656E7350726F76696465725374796C696E673A20756E6B6E6F776E20746F6B656E207479706520696E';
wwv_flow_imp.g_varchar2_table(30205) := '6465783A20247B657D20666F72206C6567656E643A20247B4A534F4E2E737472696E6769667928746869732E5F6C6567656E642E746F6B656E5479706573297D60292C733D323134373438333634372C6F3D226E6F742D696E2D6C6567656E64223B7468';
wwv_flow_imp.g_varchar2_table(30206) := '69732E5F686173685461626C652E61646428652C742C692C73292C746869732E5F6C6F67536572766963652E6765744C6576656C28293D3D3D46642E54726163652626746869732E5F6C6F67536572766963652E7472616365286053656D616E74696354';
wwv_flow_imp.g_varchar2_table(30207) := '6F6B656E7350726F76696465725374796C696E6720247B657D2028247B6F7D29202F20247B747D2028247B722E6A6F696E28222022297D293A20666F726567726F756E6420247B51672E676574466F726567726F756E642873297D2C20666F6E74537479';
wwv_flow_imp.g_varchar2_table(30208) := '6C6520247B51672E676574466F6E745374796C652873292E746F537472696E672832297D60297D72657475726E20737D7761726E4F7665726C617070696E6753656D616E746963546F6B656E7328652C74297B746869732E5F6861735761726E65644F76';
wwv_flow_imp.g_varchar2_table(30209) := '65726C617070696E67546F6B656E737C7C28746869732E5F6861735761726E65644F7665726C617070696E67546F6B656E733D21302C746869732E5F6C6F67536572766963652E7761726E28604F7665726C617070696E672073656D616E74696320746F';
wwv_flow_imp.g_varchar2_table(30210) := '6B656E73206465746563746564206174206C696E654E756D62657220247B657D2C20636F6C756D6E20247B747D6029297D7761726E496E76616C69644C656E67746853656D616E746963546F6B656E7328652C74297B746869732E5F6861735761726E65';
wwv_flow_imp.g_varchar2_table(30211) := '64496E76616C69644C656E677468546F6B656E737C7C28746869732E5F6861735761726E6564496E76616C69644C656E677468546F6B656E733D21302C746869732E5F6C6F67536572766963652E7761726E286053656D616E74696320746F6B656E2077';
wwv_flow_imp.g_varchar2_table(30212) := '69746820696E76616C6964206C656E677468206465746563746564206174206C696E654E756D62657220247B657D2C20636F6C756D6E20247B747D6029297D7761726E496E76616C696445646974537461727428652C742C6E2C692C6F297B746869732E';
wwv_flow_imp.g_varchar2_table(30213) := '5F6861735761726E6564496E76616C69644564697453746172747C7C28746869732E5F6861735761726E6564496E76616C69644564697453746172743D21302C746869732E5F6C6F67536572766963652E7761726E2860496E76616C69642073656D616E';
wwv_flow_imp.g_varchar2_table(30214) := '74696320746F6B656E732065646974206465746563746564202870726576696F7573526573756C7449643A20247B657D2C20726573756C7449643A20247B747D2920617420656469742023247B6E7D3A205468652070726F766964656420737461727420';
wwv_flow_imp.g_varchar2_table(30215) := '6F666673657420247B697D206973206F757473696465207468652070726576696F7573206461746120286C656E67746820247B6F7D292E6029297D7D3B66756E6374696F6E206E3928652C742C6E297B636F6E737420693D652E646174612C6F3D652E64';
wwv_flow_imp.g_varchar2_table(30216) := '6174612E6C656E6774682F357C302C733D4D6174682E6D6178284D6174682E6365696C286F2F31303234292C343030292C723D5B5D3B6C657420613D302C6C3D312C633D303B666F72283B613C6F3B297B636F6E737420653D613B6C657420643D4D6174';
wwv_flow_imp.g_varchar2_table(30217) := '682E6D696E28652B732C6F293B696628643C6F297B6C657420743D643B666F72283B742D313E652626303D3D3D695B352A745D3B29742D2D3B696628742D313D3D3D65297B6C657420653D643B666F72283B652B313C6F2626303D3D3D695B352A655D3B';
wwv_flow_imp.g_varchar2_table(30218) := '29652B2B3B643D657D656C736520643D747D6C657420683D6E65772055696E743332417272617928342A28642D6529292C753D302C703D302C673D302C6D3D303B666F72283B613C643B297B636F6E737420653D352A612C6F3D695B655D2C733D695B65';
wwv_flow_imp.g_varchar2_table(30219) := '2B315D2C723D6C2B6F7C302C643D303D3D3D6F3F632B737C303A732C663D642B695B652B325D7C302C763D695B652B335D2C623D695B652B345D3B696628663C3D6429742E7761726E496E76616C69644C656E67746853656D616E746963546F6B656E73';
wwv_flow_imp.g_varchar2_table(30220) := '28722C642B31293B656C736520696628673D3D3D7226266D3E6429742E7761726E4F7665726C617070696E6753656D616E746963546F6B656E7328722C642B31293B656C73657B636F6E737420653D742E6765744D6574616461746128762C622C6E293B';
wwv_flow_imp.g_varchar2_table(30221) := '32313437343833363437213D3D65262628303D3D3D70262628703D72292C685B755D3D722D702C685B752B315D3D642C685B752B325D3D662C685B752B335D3D652C752B3D342C673D722C6D3D66297D6C3D722C633D642C612B2B7D75213D3D682E6C65';
wwv_flow_imp.g_varchar2_table(30222) := '6E677468262628683D682E737562617272617928302C7529293B636F6E737420663D5A382E63726561746528702C68293B722E707573682866297D72657475726E20727D74393D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267';
wwv_flow_imp.g_varchar2_table(30223) := '756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426';
wwv_flow_imp.g_varchar2_table(30224) := '262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29';
wwv_flow_imp.g_varchar2_table(30225) := '286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B65392831';
wwv_flow_imp.g_varchar2_table(30226) := '2C5062292C653928322C4C75292C653928332C5264295D2C7439293B636C6173732069397B636F6E7374727563746F7228652C742C6E2C69297B746869732E746F6B656E54797065496E6465783D652C746869732E746F6B656E4D6F6469666965725365';
wwv_flow_imp.g_varchar2_table(30227) := '743D742C746869732E6C616E677561676549643D6E2C746869732E6D657461646174613D692C746869732E6E6578743D6E756C6C7D7D636C617373206F397B636F6E7374727563746F7228297B746869732E5F656C656D656E7473436F756E743D302C74';
wwv_flow_imp.g_varchar2_table(30228) := '6869732E5F63757272656E744C656E677468496E6465783D302C746869732E5F63757272656E744C656E6774683D6F392E5F53495A45535B746869732E5F63757272656E744C656E677468496E6465785D2C746869732E5F67726F77436F756E743D4D61';
wwv_flow_imp.g_varchar2_table(30229) := '74682E726F756E6428746869732E5F63757272656E744C656E677468496E6465782B313C6F392E5F53495A45532E6C656E6774683F322F332A746869732E5F63757272656E744C656E6774683A30292C746869732E5F656C656D656E74733D5B5D2C6F39';
wwv_flow_imp.g_varchar2_table(30230) := '2E5F6E756C6C4F7574456E747269657328746869732E5F656C656D656E74732C746869732E5F63757272656E744C656E677468297D737461746963205F6E756C6C4F7574456E747269657328652C74297B666F72286C6574206E3D303B6E3C743B6E2B2B';
wwv_flow_imp.g_varchar2_table(30231) := '29655B6E5D3D6E756C6C7D5F686173683228652C74297B72657475726E28653C3C35292D652B747C307D5F6861736846756E6328652C742C6E297B72657475726E20746869732E5F686173683228746869732E5F686173683228652C74292C6E29257468';
wwv_flow_imp.g_varchar2_table(30232) := '69732E5F63757272656E744C656E6774687D67657428652C742C6E297B636F6E737420693D746869732E5F6861736846756E6328652C742C6E293B6C6574206F3D746869732E5F656C656D656E74735B695D3B666F72283B6F3B297B6966286F2E746F6B';
wwv_flow_imp.g_varchar2_table(30233) := '656E54797065496E6465783D3D3D6526266F2E746F6B656E4D6F6469666965725365743D3D3D7426266F2E6C616E677561676549643D3D3D6E2972657475726E206F3B6F3D6F2E6E6578747D72657475726E206E756C6C7D61646428652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(30234) := '7B696628746869732E5F656C656D656E7473436F756E742B2B2C30213D3D746869732E5F67726F77436F756E742626746869732E5F656C656D656E7473436F756E743E3D746869732E5F67726F77436F756E74297B636F6E737420653D746869732E5F65';
wwv_flow_imp.g_varchar2_table(30235) := '6C656D656E74733B746869732E5F63757272656E744C656E677468496E6465782B2B2C746869732E5F63757272656E744C656E6774683D6F392E5F53495A45535B746869732E5F63757272656E744C656E677468496E6465785D2C746869732E5F67726F';
wwv_flow_imp.g_varchar2_table(30236) := '77436F756E743D4D6174682E726F756E6428746869732E5F63757272656E744C656E677468496E6465782B313C6F392E5F53495A45532E6C656E6774683F322F332A746869732E5F63757272656E744C656E6774683A30292C746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(30237) := '6E74733D5B5D2C6F392E5F6E756C6C4F7574456E747269657328746869732E5F656C656D656E74732C746869732E5F63757272656E744C656E677468293B666F7228636F6E73742074206F662065297B6C657420653D743B666F72283B653B297B636F6E';
wwv_flow_imp.g_varchar2_table(30238) := '737420743D652E6E6578743B652E6E6578743D6E756C6C2C746869732E5F6164642865292C653D747D7D7D746869732E5F616464286E657720693928652C742C6E2C6929297D5F6164642865297B636F6E737420743D746869732E5F6861736846756E63';
wwv_flow_imp.g_varchar2_table(30239) := '28652E746F6B656E54797065496E6465782C652E746F6B656E4D6F6469666965725365742C652E6C616E67756167654964293B652E6E6578743D746869732E5F656C656D656E74735B745D2C746869732E5F656C656D656E74735B745D3D657D7D66756E';
wwv_flow_imp.g_varchar2_table(30240) := '6374696F6E2073392865297B636F6E737420743D6E65772055696E74333241727261792866756E6374696F6E2865297B6C657420743D303B696628742B3D322C2266756C6C223D3D3D652E7479706529742B3D312B652E646174612E6C656E6774683B65';
wwv_flow_imp.g_varchar2_table(30241) := '6C73657B742B3D312C742B3D332A652E64656C7461732E6C656E6774683B666F7228636F6E7374206E206F6620652E64656C746173296E2E64617461262628742B3D6E2E646174612E6C656E677468297D72657475726E20747D286529293B6C6574206E';
wwv_flow_imp.g_varchar2_table(30242) := '3D303B696628745B6E2B2B5D3D652E69642C2266756C6C223D3D3D652E7479706529745B6E2B2B5D3D312C745B6E2B2B5D3D652E646174612E6C656E6774682C742E73657428652E646174612C6E292C6E2B3D652E646174612E6C656E6774683B656C73';
wwv_flow_imp.g_varchar2_table(30243) := '657B745B6E2B2B5D3D322C745B6E2B2B5D3D652E64656C7461732E6C656E6774683B666F7228636F6E73742069206F6620652E64656C74617329745B6E2B2B5D3D692E73746172742C745B6E2B2B5D3D692E64656C657465436F756E742C692E64617461';
wwv_flow_imp.g_varchar2_table(30244) := '3F28745B6E2B2B5D3D692E646174612E6C656E6774682C742E73657428692E646174612C6E292C6E2B3D692E646174612E6C656E677468293A745B6E2B2B5D3D307D72657475726E2066756E6374696F6E2865297B636F6E737420743D6E65772055696E';
wwv_flow_imp.g_varchar2_table(30245) := '7438417272617928652E6275666665722C652E627974654F66667365742C342A652E6C656E677468293B72657475726E206F6528297C7C66756E6374696F6E2865297B666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B3D34297B';
wwv_flow_imp.g_varchar2_table(30246) := '636F6E7374206E3D655B742B305D2C693D655B742B315D2C6F3D655B742B325D2C733D655B742B335D3B655B742B305D3D732C655B742B315D3D6F2C655B742B325D3D692C655B742B335D3D6E7D7D2874292C4B752E777261702874297D2874297D6675';
wwv_flow_imp.g_varchar2_table(30247) := '6E6374696F6E2072392865297B72657475726E206526262121652E646174617D66756E6374696F6E2061392865297B72657475726E2065262641727261792E6973417272617928652E6564697473297D6F392E5F53495A45533D5B332C372C31332C3331';
wwv_flow_imp.g_varchar2_table(30248) := '2C36312C3132372C3235312C3530392C313032312C323033392C343039332C383139312C31363338312C33323734392C36353532312C3133313037312C3236323133392C3532343238372C313034383537332C323039373134335D3B636C617373206C39';
wwv_flow_imp.g_varchar2_table(30249) := '7B636F6E7374727563746F7228652C742C6E297B746869732E70726F76696465723D652C746869732E746F6B656E733D742C746869732E6572726F723D6E7D7D66756E6374696F6E20633928652C74297B72657475726E20652E6861732874297D617379';
wwv_flow_imp.g_varchar2_table(30250) := '6E632066756E6374696F6E20643928652C742C6E2C692C6F297B636F6E737420733D66756E6374696F6E28652C74297B636F6E7374206E3D652E6F72646572656447726F7570732874293B72657475726E206E2E6C656E6774683E303F6E5B305D3A5B5D';
wwv_flow_imp.g_varchar2_table(30251) := '7D28652C74292C723D61776169742050726F6D6973652E616C6C28732E6D617028286173796E6320653D3E7B6C657420732C723D6E756C6C3B7472797B733D617761697420652E70726F76696465446F63756D656E7453656D616E746963546F6B656E73';
wwv_flow_imp.g_varchar2_table(30252) := '28742C653D3D3D6E3F693A6E756C6C2C6F297D63617463682865297B723D652C733D6E756C6C7D72657475726E207326262872392873297C7C6139287329297C7C28733D6E756C6C292C6E6577206C3928652C732C72297D2929293B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(30253) := '742065206F662072297B696628652E6572726F72297468726F7720652E6572726F723B696628652E746F6B656E732972657475726E20657D72657475726E20722E6C656E6774683E303F725B305D3A6E756C6C7D636C6173732068397B636F6E73747275';
wwv_flow_imp.g_varchar2_table(30254) := '63746F7228652C74297B746869732E70726F76696465723D652C746869732E746F6B656E733D747D7D66756E6374696F6E20753928652C74297B636F6E7374206E3D652E6F72646572656447726F7570732874293B72657475726E206E2E6C656E677468';
wwv_flow_imp.g_varchar2_table(30255) := '3E303F6E5B305D3A5B5D7D6173796E632066756E6374696F6E20703928652C742C6E2C69297B636F6E7374206F3D753928652C74292C733D61776169742050726F6D6973652E616C6C286F2E6D617028286173796E6320653D3E7B6C6574206F3B747279';
wwv_flow_imp.g_varchar2_table(30256) := '7B6F3D617761697420652E70726F76696465446F63756D656E7452616E676553656D616E746963546F6B656E7328742C6E2C69297D63617463682865297B45652865292C6F3D6E756C6C7D72657475726E206F26267239286F297C7C286F3D6E756C6C29';
wwv_flow_imp.g_varchar2_table(30257) := '2C6E657720683928652C6F297D2929293B666F7228636F6E73742065206F66207329696628652E746F6B656E732972657475726E20653B72657475726E20732E6C656E6774683E303F735B305D3A6E756C6C7D6B632E7265676973746572436F6D6D616E';
wwv_flow_imp.g_varchar2_table(30258) := '6428225F70726F76696465446F63756D656E7453656D616E746963546F6B656E734C6567656E64222C286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E5D3D743B796C286E20696E7374616E63656F66204E6F293B636F6E737420693D652E67';
wwv_flow_imp.g_varchar2_table(30259) := '6574286663292E6765744D6F64656C286E293B69662821692972657475726E3B636F6E73747B646F63756D656E7453656D616E746963546F6B656E7350726F76696465723A6F7D3D652E676574287878292C733D66756E6374696F6E28652C74297B636F';
wwv_flow_imp.g_varchar2_table(30260) := '6E7374206E3D652E6F72646572656447726F7570732874293B72657475726E206E2E6C656E6774683E303F6E5B305D3A6E756C6C7D286F2C69293B72657475726E20733F735B305D2E6765744C6567656E6428293A652E676574287863292E6578656375';
wwv_flow_imp.g_varchar2_table(30261) := '7465436F6D6D616E6428225F70726F76696465446F63756D656E7452616E676553656D616E746963546F6B656E734C6567656E64222C6E297D29292C6B632E7265676973746572436F6D6D616E6428225F70726F76696465446F63756D656E7453656D61';
wwv_flow_imp.g_varchar2_table(30262) := '6E746963546F6B656E73222C286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E5D3D743B796C286E20696E7374616E63656F66204E6F293B636F6E737420693D652E676574286663292E6765744D6F64656C286E293B69662821692972657475';
wwv_flow_imp.g_varchar2_table(30263) := '726E3B636F6E73747B646F63756D656E7453656D616E746963546F6B656E7350726F76696465723A6F7D3D652E676574287878293B696628216339286F2C69292972657475726E20652E676574287863292E65786563757465436F6D6D616E6428225F70';
wwv_flow_imp.g_varchar2_table(30264) := '726F76696465446F63756D656E7452616E676553656D616E746963546F6B656E73222C6E2C692E67657446756C6C4D6F64656C52616E67652829293B636F6E737420733D6177616974206439286F2C692C6E756C6C2C6E756C6C2C4D742E4E6F6E65293B';
wwv_flow_imp.g_varchar2_table(30265) := '69662821732972657475726E3B636F6E73747B70726F76696465723A722C746F6B656E733A617D3D733B69662821617C7C2172392861292972657475726E3B636F6E7374206C3D7339287B69643A302C747970653A2266756C6C222C646174613A612E64';
wwv_flow_imp.g_varchar2_table(30266) := '6174617D293B72657475726E20612E726573756C7449642626722E72656C65617365446F63756D656E7453656D616E746963546F6B656E7328612E726573756C744964292C6C7D29292C6B632E7265676973746572436F6D6D616E6428225F70726F7669';
wwv_flow_imp.g_varchar2_table(30267) := '6465446F63756D656E7452616E676553656D616E746963546F6B656E734C6567656E64222C286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E2C695D3D743B796C286E20696E7374616E63656F66204E6F293B636F6E7374206F3D652E676574';
wwv_flow_imp.g_varchar2_table(30268) := '286663292E6765744D6F64656C286E293B696628216F2972657475726E3B636F6E73747B646F63756D656E7452616E676553656D616E746963546F6B656E7350726F76696465723A737D3D652E676574287878292C723D753928732C6F293B696628303D';
wwv_flow_imp.g_varchar2_table(30269) := '3D3D722E6C656E6774682972657475726E3B696628313D3D3D722E6C656E6774682972657475726E20725B305D2E6765744C6567656E6428293B69662821697C7C2172682E69734952616E67652869292972657475726E20636F6E736F6C652E7761726E';
wwv_flow_imp.g_varchar2_table(30270) := '282270726F76696465446F63756D656E7452616E676553656D616E746963546F6B656E734C6567656E64206D69676874206265206F75742D6F662D73796E6320776974682070726F76696465446F63756D656E7452616E676553656D616E746963546F6B';
wwv_flow_imp.g_varchar2_table(30271) := '656E7320756E6C65737320612072616E676520617267756D656E742069732070617373656420696E22292C725B305D2E6765744C6567656E6428293B636F6E737420613D617761697420703928732C6F2C72682E6C6966742869292C4D742E4E6F6E6529';
wwv_flow_imp.g_varchar2_table(30272) := '3B72657475726E20613F612E70726F76696465722E6765744C6567656E6428293A766F696420307D29292C6B632E7265676973746572436F6D6D616E6428225F70726F76696465446F63756D656E7452616E676553656D616E746963546F6B656E73222C';
wwv_flow_imp.g_varchar2_table(30273) := '286173796E6328652C2E2E2E74293D3E7B636F6E73745B6E2C695D3D743B796C286E20696E7374616E63656F66204E6F292C796C2872682E69734952616E6765286929293B636F6E7374206F3D652E676574286663292E6765744D6F64656C286E293B69';
wwv_flow_imp.g_varchar2_table(30274) := '6628216F2972657475726E3B636F6E73747B646F63756D656E7452616E676553656D616E746963546F6B656E7350726F76696465723A737D3D652E676574287878292C723D617761697420703928732C6F2C72682E6C6966742869292C4D742E4E6F6E65';
wwv_flow_imp.g_varchar2_table(30275) := '293B72657475726E20722626722E746F6B656E733F7339287B69643A302C747970653A2266756C6C222C646174613A722E746F6B656E732E646174617D293A766F696420307D29293B636F6E73742067393D7063282273656D616E746963546F6B656E73';
wwv_flow_imp.g_varchar2_table(30276) := '5374796C696E675365727669636522292C6D393D22656469746F722E73656D616E746963486967686C69676874696E67223B66756E6374696F6E20663928652C742C6E297B76617220693B636F6E7374206F3D6E756C6C3D3D3D28693D6E2E6765745661';
wwv_flow_imp.g_varchar2_table(30277) := '6C7565286D392C7B6F766572726964654964656E7469666965723A652E6765744C616E6775616765496428292C7265736F757263653A652E7572697D29297C7C766F696420303D3D3D693F766F696420303A692E656E61626C65643B72657475726E2262';
wwv_flow_imp.g_varchar2_table(30278) := '6F6F6C65616E223D3D747970656F66206F3F6F3A742E676574436F6C6F725468656D6528292E73656D616E746963486967686C69676874696E677D7661722076392C62393D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D';
wwv_flow_imp.g_varchar2_table(30279) := '656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C656374262622';
wwv_flow_imp.g_varchar2_table(30280) := '66756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F';
wwv_flow_imp.g_varchar2_table(30281) := '3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C5F393D66756E63';
wwv_flow_imp.g_varchar2_table(30282) := '74696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742079393D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C74';
wwv_flow_imp.g_varchar2_table(30283) := '6869732E5F77617463686572733D4F626A6563742E637265617465286E756C6C293B636F6E737420723D743D3E7B746869732E5F77617463686572735B742E7572692E746F537472696E6728295D3D6E657720773928742C652C6E2C6F2C73297D2C613D';
wwv_flow_imp.g_varchar2_table(30284) := '28652C74293D3E7B742E646973706F736528292C64656C65746520746869732E5F77617463686572735B652E7572692E746F537472696E6728295D7D2C6C3D28293D3E7B666F7228636F6E73742065206F6620742E6765744D6F64656C732829297B636F';
wwv_flow_imp.g_varchar2_table(30285) := '6E737420743D746869732E5F77617463686572735B652E7572692E746F537472696E6728295D3B663928652C6E2C69293F747C7C722865293A7426266128652C74297D7D3B742E6765744D6F64656C7328292E666F72456163682828653D3E7B66392865';
wwv_flow_imp.g_varchar2_table(30286) := '2C6E2C69292626722865297D29292C746869732E5F726567697374657228742E6F6E4D6F64656C41646465642828653D3E7B663928652C6E2C69292626722865297D2929292C746869732E5F726567697374657228742E6F6E4D6F64656C52656D6F7665';
wwv_flow_imp.g_varchar2_table(30287) := '642828653D3E7B636F6E737420743D746869732E5F77617463686572735B652E7572692E746F537472696E6728295D3B7426266128652C74297D2929292C746869732E5F726567697374657228692E6F6E4469644368616E6765436F6E66696775726174';
wwv_flow_imp.g_varchar2_table(30288) := '696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E286D392926266C28297D2929292C746869732E5F7265676973746572286E2E6F6E446964436F6C6F725468656D654368616E6765286C29297D646973706F736528297B666F';
wwv_flow_imp.g_varchar2_table(30289) := '7228636F6E73742065206F66204F626A6563742E76616C75657328746869732E5F77617463686572732929652E646973706F736528293B73757065722E646973706F736528297D7D3B79393D6239285B5F3928302C6739292C5F3928312C6663292C5F39';
wwv_flow_imp.g_varchar2_table(30290) := '28322C5062292C5F3928332C6670292C5F3928342C6456292C5F3928352C7878295D2C7939293B6C65742077393D76393D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869';
wwv_flow_imp.g_varchar2_table(30291) := '732E5F73656D616E746963546F6B656E735374796C696E67536572766963653D742C746869732E5F6973446973706F7365643D21312C746869732E5F6D6F64656C3D652C746869732E5F70726F76696465723D6F2E646F63756D656E7453656D616E7469';
wwv_flow_imp.g_varchar2_table(30292) := '63546F6B656E7350726F76696465722C746869732E5F6465626F756E6365496E666F726D6174696F6E3D692E666F7228746869732E5F70726F76696465722C22446F63756D656E7453656D616E746963546F6B656E73222C7B6D696E3A76392E52455155';
wwv_flow_imp.g_varchar2_table(30293) := '4553545F4D494E5F44454C41592C6D61783A76392E524551554553545F4D41585F44454C41597D292C746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E733D746869732E5F7265676973746572286E6577204B7428282829';
wwv_flow_imp.g_varchar2_table(30294) := '3D3E746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E734E6F772829292C76392E524551554553545F4D494E5F44454C415929292C746869732E5F63757272656E74446F63756D656E74526573706F6E73653D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(30295) := '746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263653D6E756C6C2C746869732E5F646F63756D656E7450726F7669646572734368616E67654C697374656E6572733D5B5D2C74';
wwv_flow_imp.g_varchar2_table(30296) := '6869732E5F70726F7669646572734368616E676564447572696E67526571756573743D21312C746869732E5F726567697374657228746869732E5F6D6F64656C2E6F6E4469644368616E6765436F6E74656E74282828293D3E7B746869732E5F66657463';
wwv_flow_imp.g_varchar2_table(30297) := '68446F63756D656E7453656D616E746963546F6B656E732E69735363686564756C656428297C7C746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E7363686564756C6528746869732E5F6465626F756E6365496E666F';
wwv_flow_imp.g_varchar2_table(30298) := '726D6174696F6E2E67657428746869732E5F6D6F64656C29297D2929292C746869732E5F726567697374657228746869732E5F6D6F64656C2E6F6E4469644368616E67654174746163686564282828293D3E7B746869732E5F6665746368446F63756D65';
wwv_flow_imp.g_varchar2_table(30299) := '6E7453656D616E746963546F6B656E732E69735363686564756C656428297C7C746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E7363686564756C6528746869732E5F6465626F756E6365496E666F726D6174696F6E';
wwv_flow_imp.g_varchar2_table(30300) := '2E67657428746869732E5F6D6F64656C29297D2929292C746869732E5F726567697374657228746869732E5F6D6F64656C2E6F6E4469644368616E67654C616E6775616765282828293D3E7B746869732E5F63757272656E74446F63756D656E74526573';
wwv_flow_imp.g_varchar2_table(30301) := '706F6E7365262628746869732E5F63757272656E74446F63756D656E74526573706F6E73652E646973706F736528292C746869732E5F63757272656E74446F63756D656E74526573706F6E73653D6E756C6C292C746869732E5F63757272656E74446F63';
wwv_flow_imp.g_varchar2_table(30302) := '756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F75726365262628746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263652E63616E63656C28292C74';
wwv_flow_imp.g_varchar2_table(30303) := '6869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263653D6E756C6C292C746869732E5F736574446F63756D656E7453656D616E746963546F6B656E73286E756C6C2C6E756C6C2C6E';
wwv_flow_imp.g_varchar2_table(30304) := '756C6C2C5B5D292C746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E7363686564756C652830297D2929293B636F6E737420733D28293D3E7B6F7428746869732E5F646F63756D656E7450726F766964657273436861';
wwv_flow_imp.g_varchar2_table(30305) := '6E67654C697374656E657273292C746869732E5F646F63756D656E7450726F7669646572734368616E67654C697374656E6572733D5B5D3B666F7228636F6E73742074206F6620746869732E5F70726F76696465722E616C6C286529292266756E637469';
wwv_flow_imp.g_varchar2_table(30306) := '6F6E223D3D747970656F6620742E6F6E4469644368616E67652626746869732E5F646F63756D656E7450726F7669646572734368616E67654C697374656E6572732E7075736828742E6F6E4469644368616E6765282828293D3E7B746869732E5F637572';
wwv_flow_imp.g_varchar2_table(30307) := '72656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263653F746869732E5F70726F7669646572734368616E676564447572696E67526571756573743D21303A746869732E5F6665746368446F63756D656E';
wwv_flow_imp.g_varchar2_table(30308) := '7453656D616E746963546F6B656E732E7363686564756C652830297D2929297D3B7328292C746869732E5F726567697374657228746869732E5F70726F76696465722E6F6E4469644368616E6765282828293D3E7B7328292C746869732E5F6665746368';
wwv_flow_imp.g_varchar2_table(30309) := '446F63756D656E7453656D616E746963546F6B656E732E7363686564756C6528746869732E5F6465626F756E6365496E666F726D6174696F6E2E67657428746869732E5F6D6F64656C29297D2929292C746869732E5F7265676973746572286E2E6F6E44';
wwv_flow_imp.g_varchar2_table(30310) := '6964436F6C6F725468656D654368616E67652828653D3E7B746869732E5F736574446F63756D656E7453656D616E746963546F6B656E73286E756C6C2C6E756C6C2C6E756C6C2C5B5D292C746869732E5F6665746368446F63756D656E7453656D616E74';
wwv_flow_imp.g_varchar2_table(30311) := '6963546F6B656E732E7363686564756C6528746869732E5F6465626F756E6365496E666F726D6174696F6E2E67657428746869732E5F6D6F64656C29297D2929292C746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E';
wwv_flow_imp.g_varchar2_table(30312) := '7363686564756C652830297D646973706F736528297B746869732E5F63757272656E74446F63756D656E74526573706F6E7365262628746869732E5F63757272656E74446F63756D656E74526573706F6E73652E646973706F736528292C746869732E5F';
wwv_flow_imp.g_varchar2_table(30313) := '63757272656E74446F63756D656E74526573706F6E73653D6E756C6C292C746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F75726365262628746869732E5F63757272656E74446F63';
wwv_flow_imp.g_varchar2_table(30314) := '756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263652E63616E63656C28292C746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263653D6E756C';
wwv_flow_imp.g_varchar2_table(30315) := '6C292C6F7428746869732E5F646F63756D656E7450726F7669646572734368616E67654C697374656E657273292C746869732E5F646F63756D656E7450726F7669646572734368616E67654C697374656E6572733D5B5D2C746869732E5F736574446F63';
wwv_flow_imp.g_varchar2_table(30316) := '756D656E7453656D616E746963546F6B656E73286E756C6C2C6E756C6C2C6E756C6C2C5B5D292C746869732E5F6973446973706F7365643D21302C73757065722E646973706F736528297D5F6665746368446F63756D656E7453656D616E746963546F6B';
wwv_flow_imp.g_varchar2_table(30317) := '656E734E6F7728297B696628746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263652972657475726E3B69662821633928746869732E5F70726F76696465722C746869732E5F6D';
wwv_flow_imp.g_varchar2_table(30318) := '6F64656C292972657475726E20766F696428746869732E5F63757272656E74446F63756D656E74526573706F6E73652626746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E73657453656D616E746963546F6B656E73286E756C6C2C213129';
wwv_flow_imp.g_varchar2_table(30319) := '293B69662821746869732E5F6D6F64656C2E69734174746163686564546F456469746F7228292972657475726E3B636F6E737420653D6E6577204E742C743D746869732E5F63757272656E74446F63756D656E74526573706F6E73653F746869732E5F63';
wwv_flow_imp.g_varchar2_table(30320) := '757272656E74446F63756D656E74526573706F6E73652E70726F76696465723A6E756C6C2C6E3D746869732E5F63757272656E74446F63756D656E74526573706F6E73652626746869732E5F63757272656E74446F63756D656E74526573706F6E73652E';
wwv_flow_imp.g_varchar2_table(30321) := '726573756C7449647C7C6E756C6C2C693D643928746869732E5F70726F76696465722C746869732E5F6D6F64656C2C742C6E2C652E746F6B656E293B746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E';
wwv_flow_imp.g_varchar2_table(30322) := '546F6B656E536F757263653D652C746869732E5F70726F7669646572734368616E676564447572696E67526571756573743D21313B636F6E7374206F3D5B5D2C733D746869732E5F6D6F64656C2E6F6E4469644368616E6765436F6E74656E742828653D';
wwv_flow_imp.g_varchar2_table(30323) := '3E7B6F2E707573682865297D29292C723D6E6577206674282131293B692E7468656E2828653D3E7B696628746869732E5F6465626F756E6365496E666F726D6174696F6E2E75706461746528746869732E5F6D6F64656C2C722E656C6170736564282929';
wwv_flow_imp.g_varchar2_table(30324) := '2C746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263653D6E756C6C2C732E646973706F736528292C65297B636F6E73747B70726F76696465723A742C746F6B656E733A6E7D3D';
wwv_flow_imp.g_varchar2_table(30325) := '652C693D746869732E5F73656D616E746963546F6B656E735374796C696E67536572766963652E6765745374796C696E672874293B746869732E5F736574446F63756D656E7453656D616E746963546F6B656E7328742C6E7C7C6E756C6C2C692C6F297D';
wwv_flow_imp.g_varchar2_table(30326) := '656C736520746869732E5F736574446F63756D656E7453656D616E746963546F6B656E73286E756C6C2C6E756C6C2C6E756C6C2C6F297D292C28653D3E7B6526262854652865297C7C22737472696E67223D3D747970656F6620652E6D65737361676526';
wwv_flow_imp.g_varchar2_table(30327) := '262D31213D3D652E6D6573736167652E696E6465784F662822627573792229297C7C6B652865292C746869732E5F63757272656E74446F63756D656E745265717565737443616E63656C6C6174696F6E546F6B656E536F757263653D6E756C6C2C732E64';
wwv_flow_imp.g_varchar2_table(30328) := '6973706F736528292C286F2E6C656E6774683E307C7C746869732E5F70726F7669646572734368616E676564447572696E675265717565737429262628746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E6973536368';
wwv_flow_imp.g_varchar2_table(30329) := '6564756C656428297C7C746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E7363686564756C6528746869732E5F6465626F756E6365496E666F726D6174696F6E2E67657428746869732E5F6D6F64656C2929297D2929';
wwv_flow_imp.g_varchar2_table(30330) := '7D737461746963205F636F707928652C742C6E2C692C6F297B6F3D4D6174682E6D696E286F2C6E2E6C656E6774682D692C652E6C656E6774682D74293B666F72286C657420733D303B733C6F3B732B2B296E5B692B735D3D655B742B735D7D5F73657444';
wwv_flow_imp.g_varchar2_table(30331) := '6F63756D656E7453656D616E746963546F6B656E7328652C742C6E2C69297B636F6E7374206F3D746869732E5F63757272656E74446F63756D656E74526573706F6E73652C733D28293D3E7B28692E6C656E6774683E307C7C746869732E5F70726F7669';
wwv_flow_imp.g_varchar2_table(30332) := '646572734368616E676564447572696E675265717565737429262621746869732E5F6665746368446F63756D656E7453656D616E746963546F6B656E732E69735363686564756C656428292626746869732E5F6665746368446F63756D656E7453656D61';
wwv_flow_imp.g_varchar2_table(30333) := '6E746963546F6B656E732E7363686564756C6528746869732E5F6465626F756E6365496E666F726D6174696F6E2E67657428746869732E5F6D6F64656C29297D3B696628746869732E5F63757272656E74446F63756D656E74526573706F6E7365262628';
wwv_flow_imp.g_varchar2_table(30334) := '746869732E5F63757272656E74446F63756D656E74526573706F6E73652E646973706F736528292C746869732E5F63757272656E74446F63756D656E74526573706F6E73653D6E756C6C292C746869732E5F6973446973706F7365642965262674262665';
wwv_flow_imp.g_varchar2_table(30335) := '2E72656C65617365446F63756D656E7453656D616E746963546F6B656E7328742E726573756C744964293B656C7365206966286526266E297B69662821742972657475726E20746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E7365745365';
wwv_flow_imp.g_varchar2_table(30336) := '6D616E746963546F6B656E73286E756C6C2C2130292C766F6964207328293B6966286139287429297B696628216F2972657475726E20766F696420746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E73657453656D616E746963546F6B656E';
wwv_flow_imp.g_varchar2_table(30337) := '73286E756C6C2C2130293B696628303D3D3D742E65646974732E6C656E67746829743D7B726573756C7449643A742E726573756C7449642C646174613A6F2E646174617D3B656C73657B6C657420653D303B666F7228636F6E7374206E206F6620742E65';
wwv_flow_imp.g_varchar2_table(30338) := '6469747329652B3D286E2E646174613F6E2E646174612E6C656E6774683A30292D6E2E64656C657465436F756E743B636F6E737420693D6F2E646174612C733D6E65772055696E743332417272617928692E6C656E6774682B65293B6C657420723D692E';
wwv_flow_imp.g_varchar2_table(30339) := '6C656E6774682C613D732E6C656E6774683B666F72286C657420653D742E65646974732E6C656E6774682D313B653E3D303B652D2D297B636F6E7374206C3D742E65646974735B655D3B6966286C2E73746172743E692E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(30340) := '206E2E7761726E496E76616C6964456469745374617274286F2E726573756C7449642C742E726573756C7449642C652C6C2E73746172742C692E6C656E677468292C766F696420746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E73657453';
wwv_flow_imp.g_varchar2_table(30341) := '656D616E746963546F6B656E73286E756C6C2C2130293B636F6E737420633D722D286C2E73746172742B6C2E64656C657465436F756E74293B633E3026262876392E5F636F707928692C722D632C732C612D632C63292C612D3D63292C6C2E6461746126';
wwv_flow_imp.g_varchar2_table(30342) := '262876392E5F636F7079286C2E646174612C302C732C612D6C2E646174612E6C656E6774682C6C2E646174612E6C656E677468292C612D3D6C2E646174612E6C656E677468292C723D6C2E73746172747D723E30262676392E5F636F707928692C302C73';
wwv_flow_imp.g_varchar2_table(30343) := '2C302C72292C743D7B726573756C7449643A742E726573756C7449642C646174613A737D7D7D6966287239287429297B746869732E5F63757272656E74446F63756D656E74526573706F6E73653D6E657720433928652C742E726573756C7449642C742E';
wwv_flow_imp.g_varchar2_table(30344) := '64617461293B636F6E7374206F3D6E3928742C6E2C746869732E5F6D6F64656C2E6765744C616E677561676549642829293B696628692E6C656E6774683E3029666F7228636F6E73742065206F66206929666F7228636F6E73742074206F66206F29666F';
wwv_flow_imp.g_varchar2_table(30345) := '7228636F6E7374206E206F6620652E6368616E67657329742E6170706C7945646974286E2E72616E67652C6E2E74657874293B746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E73657453656D616E746963546F6B656E73286F2C2130297D';
wwv_flow_imp.g_varchar2_table(30346) := '656C736520746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E73657453656D616E746963546F6B656E73286E756C6C2C2130293B7328297D656C736520746869732E5F6D6F64656C2E746F6B656E697A6174696F6E2E73657453656D616E74';
wwv_flow_imp.g_varchar2_table(30347) := '6963546F6B656E73286E756C6C2C2131297D7D3B77392E524551554553545F4D494E5F44454C41593D3330302C77392E524551554553545F4D41585F44454C41593D3265332C77393D76393D6239285B5F3928312C6739292C5F3928322C5062292C5F39';
wwv_flow_imp.g_varchar2_table(30348) := '28332C6456292C5F3928342C7878295D2C7739293B636C6173732043397B636F6E7374727563746F7228652C742C6E297B746869732E70726F76696465723D652C746869732E726573756C7449643D742C746869732E646174613D6E7D646973706F7365';
wwv_flow_imp.g_varchar2_table(30349) := '28297B746869732E70726F76696465722E72656C65617365446F63756D656E7453656D616E746963546F6B656E7328746869732E726573756C744964297D7D7257287939293B7661722053393D66756E6374696F6E28652C74297B72657475726E206675';
wwv_flow_imp.g_varchar2_table(30350) := '6E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C65742078393D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E5F73656D616E746963546F6B656E73';
wwv_flow_imp.g_varchar2_table(30351) := '5374796C696E67536572766963653D742C746869732E5F7468656D65536572766963653D6E2C746869732E5F636F6E66696775726174696F6E536572766963653D692C746869732E5F656469746F723D652C746869732E5F70726F76696465723D732E64';
wwv_flow_imp.g_varchar2_table(30352) := '6F63756D656E7452616E676553656D616E746963546F6B656E7350726F76696465722C746869732E5F6465626F756E6365496E666F726D6174696F6E3D6F2E666F7228746869732E5F70726F76696465722C22446F63756D656E7452616E676553656D61';
wwv_flow_imp.g_varchar2_table(30353) := '6E746963546F6B656E73222C7B6D696E3A3130302C6D61783A3530307D292C746869732E5F746F6B656E697A6556696577706F72743D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F746F6B656E697A655669657770';
wwv_flow_imp.g_varchar2_table(30354) := '6F72744E6F772829292C31303029292C746869732E5F6F75747374616E64696E6752657175657374733D5B5D3B636F6E737420723D28293D3E7B746869732E5F656469746F722E6861734D6F64656C28292626746869732E5F746F6B656E697A65566965';
wwv_flow_imp.g_varchar2_table(30355) := '77706F72742E7363686564756C6528746869732E5F6465626F756E6365496E666F726D6174696F6E2E67657428746869732E5F656469746F722E6765744D6F64656C282929297D3B746869732E5F726567697374657228746869732E5F656469746F722E';
wwv_flow_imp.g_varchar2_table(30356) := '6F6E4469645363726F6C6C4368616E6765282828293D3E7B7228297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F63616E63656C416C6C2829';
wwv_flow_imp.g_varchar2_table(30357) := '2C7228297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E5F63616E63656C416C6C28292C7228297D2929292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(30358) := '67697374657228746869732E5F70726F76696465722E6F6E4469644368616E6765282828293D3E7B746869732E5F63616E63656C416C6C28292C7228297D2929292C746869732E5F726567697374657228746869732E5F636F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(30359) := '536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E286D3929262628746869732E5F63616E63656C416C6C28292C722829297D2929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(30360) := '726567697374657228746869732E5F7468656D65536572766963652E6F6E446964436F6C6F725468656D654368616E6765282828293D3E7B746869732E5F63616E63656C416C6C28292C7228297D2929292C7228297D5F63616E63656C416C6C28297B66';
wwv_flow_imp.g_varchar2_table(30361) := '6F7228636F6E73742065206F6620746869732E5F6F75747374616E64696E67526571756573747329652E63616E63656C28293B746869732E5F6F75747374616E64696E6752657175657374733D5B5D7D5F72656D6F76654F75747374616E64696E675265';
wwv_flow_imp.g_varchar2_table(30362) := '71756573742865297B666F72286C657420743D302C6E3D746869732E5F6F75747374616E64696E6752657175657374732E6C656E6774683B743C6E3B742B2B29696628746869732E5F6F75747374616E64696E6752657175657374735B745D3D3D3D6529';
wwv_flow_imp.g_varchar2_table(30363) := '72657475726E20766F696420746869732E5F6F75747374616E64696E6752657175657374732E73706C69636528742C31297D5F746F6B656E697A6556696577706F72744E6F7728297B69662821746869732E5F656469746F722E6861734D6F64656C2829';
wwv_flow_imp.g_varchar2_table(30364) := '2972657475726E3B636F6E737420653D746869732E5F656469746F722E6765744D6F64656C28293B696628652E746F6B656E697A6174696F6E2E686173436F6D706C65746553656D616E746963546F6B656E7328292972657475726E3B69662821663928';
wwv_flow_imp.g_varchar2_table(30365) := '652C746869732E5F7468656D65536572766963652C746869732E5F636F6E66696775726174696F6E53657276696365292972657475726E20766F696428652E746F6B656E697A6174696F6E2E686173536F6D6553656D616E746963546F6B656E73282926';
wwv_flow_imp.g_varchar2_table(30366) := '26652E746F6B656E697A6174696F6E2E73657453656D616E746963546F6B656E73286E756C6C2C213129293B6966282166756E6374696F6E28652C74297B72657475726E20652E6861732874297D28746869732E5F70726F76696465722C652929726574';
wwv_flow_imp.g_varchar2_table(30367) := '75726E20766F696428652E746F6B656E697A6174696F6E2E686173536F6D6553656D616E746963546F6B656E7328292626652E746F6B656E697A6174696F6E2E73657453656D616E746963546F6B656E73286E756C6C2C213129293B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(30368) := '746869732E5F656469746F722E67657456697369626C6552616E676573506C757356696577706F727441626F766542656C6F7728293B746869732E5F6F75747374616E64696E6752657175657374733D746869732E5F6F75747374616E64696E67526571';
wwv_flow_imp.g_varchar2_table(30369) := '75657374732E636F6E63617428742E6D61702828743D3E746869732E5F7265717565737452616E676528652C74292929297D5F7265717565737452616E676528652C74297B636F6E7374206E3D652E67657456657273696F6E496428292C693D46742828';
wwv_flow_imp.g_varchar2_table(30370) := '6E3D3E50726F6D6973652E7265736F6C766528703928746869732E5F70726F76696465722C652C742C6E292929292C6F3D6E6577206674282131293B72657475726E20692E7468656E2828693D3E7B696628746869732E5F6465626F756E6365496E666F';
wwv_flow_imp.g_varchar2_table(30371) := '726D6174696F6E2E75706461746528652C6F2E656C61707365642829292C21697C7C21692E746F6B656E737C7C652E6973446973706F73656428297C7C652E67657456657273696F6E49642829213D3D6E2972657475726E3B636F6E73747B70726F7669';
wwv_flow_imp.g_varchar2_table(30372) := '6465723A732C746F6B656E733A727D3D692C613D746869732E5F73656D616E746963546F6B656E735374796C696E67536572766963652E6765745374796C696E672873293B652E746F6B656E697A6174696F6E2E7365745061727469616C53656D616E74';
wwv_flow_imp.g_varchar2_table(30373) := '6963546F6B656E7328742C6E3928722C612C652E6765744C616E67756167654964282929297D29292E7468656E282828293D3E746869732E5F72656D6F76654F75747374616E64696E6752657175657374286929292C2828293D3E746869732E5F72656D';
wwv_flow_imp.g_varchar2_table(30374) := '6F76654F75747374616E64696E675265717565737428692929292C697D7D3B78392E49443D22656469746F722E636F6E747269622E76696577706F727453656D616E746963546F6B656E73222C78393D66756E6374696F6E28652C742C6E2C69297B7661';
wwv_flow_imp.g_varchar2_table(30375) := '72206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(30376) := '205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B';
wwv_flow_imp.g_varchar2_table(30377) := '613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C7229';
wwv_flow_imp.g_varchar2_table(30378) := '2C727D285B533928312C6739292C533928322C5062292C533928332C6670292C533928342C6456292C533928352C7878295D2C7839292C4A642878392E49442C78392C31293B636C617373206B397B636F6E7374727563746F7228653D2130297B746869';
wwv_flow_imp.g_varchar2_table(30379) := '732E73656C656374537562776F7264733D657D70726F7669646553656C656374696F6E52616E67657328652C74297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F662074297B636F6E737420743D5B5D3B6E2E707573682874292C746869';
wwv_flow_imp.g_varchar2_table(30380) := '732E73656C656374537562776F7264732626746869732E5F616464496E576F726452616E67657328742C652C69292C746869732E5F616464576F726452616E67657328742C652C69292C746869732E5F616464576869746573706163654C696E6528742C';
wwv_flow_imp.g_varchar2_table(30381) := '652C69292C742E70757368287B72616E67653A652E67657446756C6C4D6F64656C52616E676528297D297D72657475726E206E7D5F616464496E576F726452616E67657328652C742C6E297B636F6E737420693D742E676574576F72644174506F736974';
wwv_flow_imp.g_varchar2_table(30382) := '696F6E286E293B69662821692972657475726E3B636F6E73747B776F72643A6F2C7374617274436F6C756D6E3A737D3D692C723D6E2E636F6C756D6E2D733B6C657420613D722C6C3D722C633D303B666F72283B613E3D303B612D2D297B636F6E737420';
wwv_flow_imp.g_varchar2_table(30383) := '653D6F2E63686172436F646541742861293B69662861213D3D7226262839353D3D3D657C7C34353D3D3D652929627265616B3B69662853692865292626786928632929627265616B3B633D657D666F7228612B3D313B6C3C6F2E6C656E6774683B6C2B2B';
wwv_flow_imp.g_varchar2_table(30384) := '297B636F6E737420653D6F2E63686172436F64654174286C293B69662878692865292626536928632929627265616B3B69662839353D3D3D657C7C34353D3D3D6529627265616B3B633D657D613C6C2626652E70757368287B72616E67653A6E65772072';
wwv_flow_imp.g_varchar2_table(30385) := '68286E2E6C696E654E756D6265722C732B612C6E2E6C696E654E756D6265722C732B6C297D297D5F616464576F726452616E67657328652C742C6E297B636F6E737420693D742E676574576F72644174506F736974696F6E286E293B692626652E707573';
wwv_flow_imp.g_varchar2_table(30386) := '68287B72616E67653A6E6577207268286E2E6C696E654E756D6265722C692E7374617274436F6C756D6E2C6E2E6C696E654E756D6265722C692E656E64436F6C756D6E297D297D5F616464576869746573706163654C696E6528652C742C6E297B742E67';
wwv_flow_imp.g_varchar2_table(30387) := '65744C696E654C656E677468286E2E6C696E654E756D626572293E302626303D3D3D742E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E286E2E6C696E654E756D626572292626303D3D3D742E6765744C696E654C617374';
wwv_flow_imp.g_varchar2_table(30388) := '4E6F6E57686974657370616365436F6C756D6E286E2E6C696E654E756D626572292626652E70757368287B72616E67653A6E6577207268286E2E6C696E654E756D6265722C312C6E2E6C696E654E756D6265722C742E6765744C696E654D6178436F6C75';
wwv_flow_imp.g_varchar2_table(30389) := '6D6E286E2E6C696E654E756D62657229297D297D7D7661722045393B636C617373204C397B636F6E7374727563746F7228652C74297B746869732E696E6465783D652C746869732E72616E6765733D747D6D6F762865297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(30390) := '2E696E6465782B28653F313A2D31293B696628743C307C7C743E3D746869732E72616E6765732E6C656E6774682972657475726E20746869733B636F6E7374206E3D6E6577204C3928742C746869732E72616E676573293B72657475726E206E2E72616E';
wwv_flow_imp.g_varchar2_table(30391) := '6765735B745D2E657175616C7352616E676528746869732E72616E6765735B746869732E696E6465785D293F6E2E6D6F762865293A6E7D7D6C65742044393D45393D636C6173737B737461746963206765742865297B72657475726E20652E676574436F';
wwv_flow_imp.g_varchar2_table(30392) := '6E747269627574696F6E2845392E4944297D636F6E7374727563746F7228652C74297B746869732E5F656469746F723D652C746869732E5F6C616E67756167654665617475726573536572766963653D742C746869732E5F69676E6F726553656C656374';
wwv_flow_imp.g_varchar2_table(30393) := '696F6E3D21317D646973706F736528297B76617220653B6E756C6C3D3D3D28653D746869732E5F73656C656374696F6E4C697374656E6572297C7C766F696420303D3D3D657C7C652E646973706F736528297D6173796E632072756E2865297B69662821';
wwv_flow_imp.g_varchar2_table(30394) := '746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E737420743D746869732E5F656469746F722E67657453656C656374696F6E7328292C6E3D746869732E5F656469746F722E6765744D6F64656C28293B696628746869';
wwv_flow_imp.g_varchar2_table(30395) := '732E5F73746174657C7C617761697420493928746869732E5F6C616E67756167654665617475726573536572766963652E73656C656374696F6E52616E676550726F76696465722C6E2C742E6D61702828653D3E652E676574506F736974696F6E282929';
wwv_flow_imp.g_varchar2_table(30396) := '292C746869732E5F656469746F722E6765744F7074696F6E28313133292C4D742E4E6F6E65292E7468656E2828653D3E7B766172206E3B6966286A682865292626652E6C656E6774683D3D3D742E6C656E6774682626746869732E5F656469746F722E68';
wwv_flow_imp.g_varchar2_table(30397) := '61734D6F64656C28292626506828746869732E5F656469746F722E67657453656C656374696F6E7328292C742C2828652C74293D3E652E657175616C7353656C656374696F6E2874292929297B666F72286C6574206E3D303B6E3C652E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(30398) := '6E2B2B29655B6E5D3D655B6E5D2E66696C7465722828653D3E652E636F6E7461696E73506F736974696F6E28745B6E5D2E6765745374617274506F736974696F6E2829292626652E636F6E7461696E73506F736974696F6E28745B6E5D2E676574456E64';
wwv_flow_imp.g_varchar2_table(30399) := '506F736974696F6E28292929292C655B6E5D2E756E736869667428745B6E5D293B746869732E5F73746174653D652E6D61702828653D3E6E6577204C3928302C652929292C6E756C6C3D3D3D286E3D746869732E5F73656C656374696F6E4C697374656E';
wwv_flow_imp.g_varchar2_table(30400) := '6572297C7C766F696420303D3D3D6E7C7C6E2E646973706F736528292C746869732E5F73656C656374696F6E4C697374656E65723D746869732E5F656469746F722E6F6E4469644368616E6765437572736F72506F736974696F6E282828293D3E7B7661';
wwv_flow_imp.g_varchar2_table(30401) := '7220653B746869732E5F69676E6F726553656C656374696F6E7C7C286E756C6C3D3D3D28653D746869732E5F73656C656374696F6E4C697374656E6572297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F73746174653D';
wwv_flow_imp.g_varchar2_table(30402) := '766F69642030297D29297D7D29292C21746869732E5F73746174652972657475726E3B746869732E5F73746174653D746869732E5F73746174652E6D61702828743D3E742E6D6F7628652929293B636F6E737420693D746869732E5F73746174652E6D61';
wwv_flow_imp.g_varchar2_table(30403) := '702828653D3E61682E66726F6D506F736974696F6E7328652E72616E6765735B652E696E6465785D2E6765745374617274506F736974696F6E28292C652E72616E6765735B652E696E6465785D2E676574456E64506F736974696F6E28292929293B7468';
wwv_flow_imp.g_varchar2_table(30404) := '69732E5F69676E6F726553656C656374696F6E3D21303B7472797B746869732E5F656469746F722E73657453656C656374696F6E732869297D66696E616C6C797B746869732E5F69676E6F726553656C656374696F6E3D21317D7D7D3B44392E49443D22';
wwv_flow_imp.g_varchar2_table(30405) := '656469746F722E636F6E747269622E736D61727453656C656374436F6E74726F6C6C6572222C44393D45393D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D';
wwv_flow_imp.g_varchar2_table(30406) := '3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C656374';
wwv_flow_imp.g_varchar2_table(30407) := '2E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F';
wwv_flow_imp.g_varchar2_table(30408) := '6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(30409) := '2C69297B74286E2C692C65297D7D28312C7878295D2C4439293B636C61737320543920657874656E64732055647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E5F666F72776172643D657D6173796E632072756E28652C';
wwv_flow_imp.g_varchar2_table(30410) := '74297B636F6E7374206E3D44392E6765742874293B6E26266177616974206E2E72756E28746869732E5F666F7277617264297D7D6173796E632066756E6374696F6E20493928652C742C6E2C692C6F297B636F6E737420733D652E616C6C2874292E636F';
wwv_flow_imp.g_varchar2_table(30411) := '6E636174286E6577206B3928692E73656C656374537562776F72647329293B313D3D3D732E6C656E6774682626732E756E7368696674286E6577205A35293B636F6E737420723D5B5D2C613D5B5D3B666F7228636F6E73742065206F66207329722E7075';
wwv_flow_imp.g_varchar2_table(30412) := '73682850726F6D6973652E7265736F6C766528652E70726F7669646553656C656374696F6E52616E67657328742C6E2C6F29292E7468656E2828653D3E7B6966286A682865292626652E6C656E6774683D3D3D6E2E6C656E67746829666F72286C657420';
wwv_flow_imp.g_varchar2_table(30413) := '743D303B743C6E2E6C656E6774683B742B2B297B615B745D7C7C28615B745D3D5B5D293B666F7228636F6E73742069206F6620655B745D2972682E69734952616E676528692E72616E676529262672682E636F6E7461696E73506F736974696F6E28692E';
wwv_flow_imp.g_varchar2_table(30414) := '72616E67652C6E5B745D292626615B745D2E707573682872682E6C69667428692E72616E676529297D7D292C456529293B72657475726E2061776169742050726F6D6973652E616C6C2872292C612E6D61702828653D3E7B696628303D3D3D652E6C656E';
wwv_flow_imp.g_varchar2_table(30415) := '6774682972657475726E5B5D3B652E736F7274282828652C74293D3E6D632E69734265666F726528652E6765745374617274506F736974696F6E28292C742E6765745374617274506F736974696F6E2829293F313A6D632E69734265666F726528742E67';
wwv_flow_imp.g_varchar2_table(30416) := '65745374617274506F736974696F6E28292C652E6765745374617274506F736974696F6E2829297C7C6D632E69734265666F726528652E676574456E64506F736974696F6E28292C742E676574456E64506F736974696F6E2829293F2D313A6D632E6973';
wwv_flow_imp.g_varchar2_table(30417) := '4265666F726528742E676574456E64506F736974696F6E28292C652E676574456E64506F736974696F6E2829293F313A3029293B636F6E7374206E3D5B5D3B6C6574206F3B666F7228636F6E73742074206F6620652928216F7C7C72682E636F6E746169';
wwv_flow_imp.g_varchar2_table(30418) := '6E7352616E676528742C6F2926262172682E657175616C7352616E676528742C6F29292626286E2E707573682874292C6F3D74293B69662821692E73656C6563744C656164696E67416E64547261696C696E67576869746573706163652972657475726E';
wwv_flow_imp.g_varchar2_table(30419) := '206E3B636F6E737420733D5B6E5B305D5D3B666F72286C657420653D313B653C6E2E6C656E6774683B652B2B297B636F6E737420693D6E5B652D315D2C6F3D6E5B655D3B6966286F2E73746172744C696E654E756D626572213D3D692E73746172744C69';
wwv_flow_imp.g_varchar2_table(30420) := '6E654E756D6265727C7C6F2E656E644C696E654E756D626572213D3D692E656E644C696E654E756D626572297B636F6E737420653D6E657720726828692E73746172744C696E654E756D6265722C742E6765744C696E6546697273744E6F6E5768697465';
wwv_flow_imp.g_varchar2_table(30421) := '7370616365436F6C756D6E28692E73746172744C696E654E756D626572292C692E656E644C696E654E756D6265722C742E6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E28692E656E644C696E654E756D62657229293B652E';
wwv_flow_imp.g_varchar2_table(30422) := '636F6E7461696E7352616E6765286929262621652E657175616C7352616E676528692926266F2E636F6E7461696E7352616E67652865292626216F2E657175616C7352616E67652865292626732E707573682865293B636F6E7374206E3D6E6577207268';
wwv_flow_imp.g_varchar2_table(30423) := '28692E73746172744C696E654E756D6265722C312C692E656E644C696E654E756D6265722C742E6765744C696E654D6178436F6C756D6E28692E656E644C696E654E756D62657229293B6E2E636F6E7461696E7352616E67652869292626216E2E657175';
wwv_flow_imp.g_varchar2_table(30424) := '616C7352616E676528652926266F2E636F6E7461696E7352616E6765286E292626216F2E657175616C7352616E6765286E292626732E70757368286E297D732E70757368286F297D72657475726E20737D29297D6B632E7265676973746572436F6D6D61';
wwv_flow_imp.g_varchar2_table(30425) := '6E64416C6961732822656469746F722E616374696F6E2E736D61727453656C6563742E67726F77222C22656469746F722E616374696F6E2E736D61727453656C6563742E657870616E6422292C4A642844392E49442C44392C34292C5A6428636C617373';
wwv_flow_imp.g_varchar2_table(30426) := '20657874656E64732054397B636F6E7374727563746F7228297B73757065722821302C7B69643A22656469746F722E616374696F6E2E736D61727453656C6563742E657870616E64222C6C6162656C3A6228302C22457870616E642053656C656374696F';
wwv_flow_imp.g_varchar2_table(30427) := '6E22292C616C6961733A22457870616E642053656C656374696F6E222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A313535332C6D61633A';
wwv_flow_imp.g_varchar2_table(30428) := '7B7072696D6172793A333334352C7365636F6E646172793A5B313239375D7D2C7765696768743A3130307D2C6D656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22315F626173696322';
wwv_flow_imp.g_varchar2_table(30429) := '2C7469746C653A6228302C222626457870616E642053656C656374696F6E22292C6F726465723A327D7D297D7D292C5A6428636C61737320657874656E64732054397B636F6E7374727563746F7228297B73757065722821312C7B69643A22656469746F';
wwv_flow_imp.g_varchar2_table(30430) := '722E616374696F6E2E736D61727453656C6563742E736872696E6B222C6C6162656C3A6228302C22536872696E6B2053656C656374696F6E22292C616C6961733A22536872696E6B2053656C656374696F6E222C707265636F6E646974696F6E3A766F69';
wwv_flow_imp.g_varchar2_table(30431) := '6420302C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A313535312C6D61633A7B7072696D6172793A333334332C7365636F6E646172793A5B313239355D7D2C7765696768743A3130307D2C6D';
wwv_flow_imp.g_varchar2_table(30432) := '656E754F7074733A7B6D656E7549643A4C642E4D656E7562617253656C656374696F6E4D656E752C67726F75703A22315F6261736963222C7469746C653A6228302C222626536872696E6B2053656C656374696F6E22292C6F726465723A337D7D297D7D';
wwv_flow_imp.g_varchar2_table(30433) := '292C6B632E7265676973746572436F6D6D616E6428225F6578656375746553656C656374696F6E52616E676550726F7669646572222C286173796E632066756E6374696F6E28652C2E2E2E74297B636F6E73745B6E2C695D3D743B796C284E6F2E697355';
wwv_flow_imp.g_varchar2_table(30434) := '7269286E29293B636F6E7374206F3D652E676574287878292E73656C656374696F6E52616E676550726F76696465722C733D617761697420652E676574287663292E6372656174654D6F64656C5265666572656E6365286E293B7472797B72657475726E';
wwv_flow_imp.g_varchar2_table(30435) := '204939286F2C732E6F626A6563742E74657874456469746F724D6F64656C2C692C7B73656C6563744C656164696E67416E64547261696C696E67576869746573706163653A21302C73656C656374537562776F7264733A21307D2C4D742E4E6F6E65297D';
wwv_flow_imp.g_varchar2_table(30436) := '66696E616C6C797B732E646973706F736528297D7D29293B636F6E7374204D393D4F626A6563742E667265657A65287B566965773A5F28302C225669657722292C48656C703A5F28302C2248656C7022292C546573743A5F28302C225465737422292C46';
wwv_flow_imp.g_varchar2_table(30437) := '696C653A5F28302C2246696C6522292C507265666572656E6365733A5F28302C22507265666572656E63657322292C446576656C6F7065723A5F28302C22446576656C6F70657222297D293B7661722041393D6E2837363839292C4E393D7B7D3B4E392E';
wwv_flow_imp.g_varchar2_table(30438) := '7374796C655461675472616E73666F726D3D6A7228292C4E392E736574417474726962757465733D567228292C4E392E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4E392E646F6D4150493D4F7228292C4E392E696E7365';
wwv_flow_imp.g_varchar2_table(30439) := '72745374796C65456C656D656E743D487228292C4E7228292841392E412C4E39292C41392E41262641392E412E6C6F63616C73262641392E412E6C6F63616C733B636C6173732050397B636F6E7374727563746F7228652C742C6E2C693D6E756C6C297B';
wwv_flow_imp.g_varchar2_table(30440) := '746869732E73746172744C696E654E756D626572733D652C746869732E656E644C696E654E756D626572733D742C746869732E6C6173744C696E6552656C6174697665506F736974696F6E3D6E2C746869732E73686F77456E64466F724C696E653D697D';
wwv_flow_imp.g_varchar2_table(30441) := '657175616C732865297B72657475726E2121652626746869732E6C6173744C696E6552656C6174697665506F736974696F6E3D3D3D652E6C6173744C696E6552656C6174697665506F736974696F6E2626746869732E73686F77456E64466F724C696E65';
wwv_flow_imp.g_varchar2_table(30442) := '3D3D3D652E73686F77456E64466F724C696E652626506828746869732E73746172744C696E654E756D626572732C652E73746172744C696E654E756D62657273292626506828746869732E656E644C696E654E756D626572732C652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(30443) := '756D62657273297D7D636F6E7374204F393D65452822737469636B795363726F6C6C566965774C61796572222C7B63726561746548544D4C3A653D3E657D292C52393D22646174612D737469636B792D6C696E652D696E646578222C46393D2264617461';
wwv_flow_imp.g_varchar2_table(30444) := '2D737469636B792D69732D6C696E65222C42393D22646174612D737469636B792D69732D666F6C64696E672D69636F6E223B636C61737320563920657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F65';
wwv_flow_imp.g_varchar2_table(30445) := '6469746F723D652C746869732E5F666F6C64696E6749636F6E53746F72653D6E65772061742C746869732E5F726F6F74446F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6C696E654E756D62';
wwv_flow_imp.g_varchar2_table(30446) := '657273446F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6C696E6573446F6D4E6F64655363726F6C6C61626C653D646F63756D656E742E637265617465456C656D656E74282264697622292C';
wwv_flow_imp.g_varchar2_table(30447) := '746869732E5F6C696E6573446F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E5F6C696E654865696768743D746869732E5F656469746F722E6765744F7074696F6E283637292C746869732E5F72';
wwv_flow_imp.g_varchar2_table(30448) := '656E6465726564537469636B794C696E65733D5B5D2C746869732E5F6C696E654E756D626572733D5B5D2C746869732E5F6C6173744C696E6552656C6174697665506F736974696F6E3D302C746869732E5F6D696E436F6E74656E745769647468496E50';
wwv_flow_imp.g_varchar2_table(30449) := '783D302C746869732E5F69734F6E476C7970684D617267696E3D21312C746869732E5F6C696E654E756D62657273446F6D4E6F64652E636C6173734E616D653D22737469636B792D7769646765742D6C696E652D6E756D62657273222C746869732E5F6C';
wwv_flow_imp.g_varchar2_table(30450) := '696E654E756D62657273446F6D4E6F64652E7365744174747269627574652822726F6C65222C226E6F6E6522292C746869732E5F6C696E6573446F6D4E6F64652E636C6173734E616D653D22737469636B792D7769646765742D6C696E6573222C746869';
wwv_flow_imp.g_varchar2_table(30451) := '732E5F6C696E6573446F6D4E6F64652E7365744174747269627574652822726F6C65222C226C69737422292C746869732E5F6C696E6573446F6D4E6F64655363726F6C6C61626C652E636C6173734E616D653D22737469636B792D7769646765742D6C69';
wwv_flow_imp.g_varchar2_table(30452) := '6E65732D7363726F6C6C61626C65222C746869732E5F6C696E6573446F6D4E6F64655363726F6C6C61626C652E617070656E644368696C6428746869732E5F6C696E6573446F6D4E6F6465292C746869732E5F726F6F74446F6D4E6F64652E636C617373';
wwv_flow_imp.g_varchar2_table(30453) := '4E616D653D22737469636B792D776964676574222C746869732E5F726F6F74446F6D4E6F64652E636C6173734C6973742E746F67676C6528227065656B222C6520696E7374616E63656F66206924292C746869732E5F726F6F74446F6D4E6F64652E6170';
wwv_flow_imp.g_varchar2_table(30454) := '70656E644368696C6428746869732E5F6C696E654E756D62657273446F6D4E6F6465292C746869732E5F726F6F74446F6D4E6F64652E617070656E644368696C6428746869732E5F6C696E6573446F6D4E6F64655363726F6C6C61626C65293B636F6E73';
wwv_flow_imp.g_varchar2_table(30455) := '7420743D28293D3E7B746869732E5F6C696E6573446F6D4E6F64652E7374796C652E6C6566743D746869732E5F656469746F722E6765744F7074696F6E28313135292E7363726F6C6C57697468456469746F723F602D247B746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(30456) := '2E6765745363726F6C6C4C65667428297D7078603A22307078227D3B746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E6765642831';
wwv_flow_imp.g_varchar2_table(30457) := '31352926267428292C652E6861734368616E67656428363729262628746869732E5F6C696E654865696768743D746869732E5F656469746F722E6765744F7074696F6E28363729297D2929292C746869732E5F726567697374657228746869732E5F6564';
wwv_flow_imp.g_varchar2_table(30458) := '69746F722E6F6E4469645363726F6C6C4368616E67652828653D3E7B652E7363726F6C6C4C6566744368616E67656426267428292C652E7363726F6C6C57696474684368616E6765642626746869732E5F75706461746557696467657457696474682829';
wwv_flow_imp.g_varchar2_table(30459) := '7D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B7428292C746869732E5F757064617465576964676574576964746828297D2929292C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(30460) := '7374657228746869732E5F666F6C64696E6749636F6E53746F7265292C7428292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644C61796F75744368616E67652828653D3E7B746869732E5F75706461746557696467';
wwv_flow_imp.g_varchar2_table(30461) := '6574576964746828297D2929292C746869732E5F757064617465576964676574576964746828297D676574206C696E654E756D6265727328297B72657475726E20746869732E5F6C696E654E756D626572737D676574206C696E654E756D626572436F75';
wwv_flow_imp.g_varchar2_table(30462) := '6E7428297B72657475726E20746869732E5F6C696E654E756D626572732E6C656E6774687D67657452656E6465726564537469636B794C696E652865297B72657475726E20746869732E5F72656E6465726564537469636B794C696E65732E66696E6428';
wwv_flow_imp.g_varchar2_table(30463) := '28743D3E742E6C696E654E756D6265723D3D3D6529297D67657443757272656E744C696E657328297B72657475726E20746869732E5F6C696E654E756D626572737D736574537461746528652C742C6E297B696628766F696420303D3D3D6E2626282174';
wwv_flow_imp.g_varchar2_table(30464) := '6869732E5F70726576696F75735374617465262621657C7C746869732E5F70726576696F757353746174652626746869732E5F70726576696F757353746174652E657175616C73286529292972657475726E3B636F6E737420693D746869732E5F697357';
wwv_flow_imp.g_varchar2_table(30465) := '69646765744865696768745A65726F2865292C6F3D693F766F696420303A652C733D693F303A746869732E5F66696E644C696E65546F52656275696C6457696467657446726F6D28652C6E293B746869732E5F72656E646572526F6F744E6F6465286F2C';
wwv_flow_imp.g_varchar2_table(30466) := '742C73292C746869732E5F70726576696F757353746174653D657D5F69735769646765744865696768745A65726F2865297B69662821652972657475726E21303B636F6E737420743D652E73746172744C696E654E756D626572732E6C656E6774682A74';
wwv_flow_imp.g_varchar2_table(30467) := '6869732E5F6C696E654865696768742B652E6C6173744C696E6552656C6174697665506F736974696F6E3B696628743E30297B746869732E5F6C6173744C696E6552656C6174697665506F736974696F6E3D652E6C6173744C696E6552656C6174697665';
wwv_flow_imp.g_varchar2_table(30468) := '506F736974696F6E3B636F6E737420743D5B2E2E2E652E73746172744C696E654E756D626572735D3B6E756C6C213D3D652E73686F77456E64466F724C696E65262628745B652E73686F77456E64466F724C696E655D3D652E656E644C696E654E756D62';
wwv_flow_imp.g_varchar2_table(30469) := '6572735B652E73686F77456E64466F724C696E655D292C746869732E5F6C696E654E756D626572733D747D656C736520746869732E5F6C6173744C696E6552656C6174697665506F736974696F6E3D302C746869732E5F6C696E654E756D626572733D5B';
wwv_flow_imp.g_varchar2_table(30470) := '5D3B72657475726E20303D3D3D747D5F66696E644C696E65546F52656275696C6457696467657446726F6D28652C74297B69662821657C7C21746869732E5F70726576696F757353746174652972657475726E20303B696628766F69642030213D3D7429';
wwv_flow_imp.g_varchar2_table(30471) := '72657475726E20743B636F6E7374206E3D746869732E5F70726576696F757353746174652C693D652E73746172744C696E654E756D626572732E66696E64496E6465782828653D3E216E2E73746172744C696E654E756D626572732E696E636C75646573';
wwv_flow_imp.g_varchar2_table(30472) := '28652929293B72657475726E2D313D3D3D693F303A697D5F757064617465576964676574576964746828297B636F6E737420653D746869732E5F656469746F722E6765744C61796F7574496E666F28292C743D652E636F6E74656E744C6566743B746869';
wwv_flow_imp.g_varchar2_table(30473) := '732E5F6C696E654E756D62657273446F6D4E6F64652E7374796C652E77696474683D60247B747D7078602C746869732E5F6C696E6573446F6D4E6F64655363726F6C6C61626C652E7374796C652E73657450726F706572747928222D2D7673636F64652D';
wwv_flow_imp.g_varchar2_table(30474) := '656469746F72537469636B795363726F6C6C2D7363726F6C6C61626C655769647468222C746869732E5F656469746F722E6765745363726F6C6C576964746828292D652E766572746963616C5363726F6C6C62617257696474682B22707822292C746869';
wwv_flow_imp.g_varchar2_table(30475) := '732E5F726F6F74446F6D4E6F64652E7374796C652E77696474683D652E77696474682D652E766572746963616C5363726F6C6C62617257696474682B227078227D5F636C656172537469636B794C696E657346726F6D4C696E652865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(30476) := '666F6C64696E6749636F6E53746F72652E636C65617228293B666F72286C657420743D653B743C746869732E5F72656E6465726564537469636B794C696E65732E6C656E6774683B742B2B297B636F6E737420653D746869732E5F72656E646572656453';
wwv_flow_imp.g_varchar2_table(30477) := '7469636B794C696E65735B745D3B652E6C696E654E756D626572446F6D4E6F64652E72656D6F766528292C652E6C696E65446F6D4E6F64652E72656D6F766528297D746869732E5F72656E6465726564537469636B794C696E65733D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(30478) := '6E6465726564537469636B794C696E65732E736C69636528302C65292C746869732E5F726F6F74446F6D4E6F64652E7374796C652E646973706C61793D226E6F6E65227D5F757365466F6C64696E674F7061636974795472616E736974696F6E2865297B';
wwv_flow_imp.g_varchar2_table(30479) := '746869732E5F6C696E654E756D62657273446F6D4E6F64652E7374796C652E73657450726F706572747928222D2D7673636F64652D656469746F72537469636B795363726F6C6C2D666F6C64696E674F7061636974795472616E736974696F6E222C606F';
wwv_flow_imp.g_varchar2_table(30480) := '70616369747920247B653F2E353A307D7360297D5F736574466F6C64696E6749636F6E735669736962696C6974792865297B666F7228636F6E73742074206F6620746869732E5F72656E6465726564537469636B794C696E6573297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(30481) := '742E666F6C64696E6749636F6E3B6E26266E2E73657456697369626C65282121657C7C6E2E6973436F6C6C6170736564297D7D6173796E63205F72656E646572526F6F744E6F646528652C742C6E297B696628746869732E5F636C656172537469636B79';
wwv_flow_imp.g_varchar2_table(30482) := '4C696E657346726F6D4C696E65286E292C21652972657475726E3B666F7228636F6E73742065206F6620746869732E5F72656E6465726564537469636B794C696E657329746869732E5F757064617465546F70416E645A496E6465784F66537469636B79';
wwv_flow_imp.g_varchar2_table(30483) := '4C696E652865293B636F6E737420693D746869732E5F656469746F722E6765744C61796F7574496E666F28292C6F3D746869732E5F6C696E654E756D626572732E736C696365286E293B666F7228636F6E73745B652C735D6F66206F2E656E7472696573';
wwv_flow_imp.g_varchar2_table(30484) := '2829297B636F6E7374206F3D746869732E5F72656E6465724368696C644E6F646528652B6E2C732C742C69293B6F262628746869732E5F6C696E6573446F6D4E6F64652E617070656E644368696C64286F2E6C696E65446F6D4E6F6465292C746869732E';
wwv_flow_imp.g_varchar2_table(30485) := '5F6C696E654E756D62657273446F6D4E6F64652E617070656E644368696C64286F2E6C696E654E756D626572446F6D4E6F6465292C746869732E5F72656E6465726564537469636B794C696E65732E70757368286F29297D74262628746869732E5F7365';
wwv_flow_imp.g_varchar2_table(30486) := '74466F6C64696E67486F7665724C697374656E65727328292C746869732E5F757365466F6C64696E674F7061636974795472616E736974696F6E2821746869732E5F69734F6E476C7970684D617267696E29293B636F6E737420733D746869732E5F6C69';
wwv_flow_imp.g_varchar2_table(30487) := '6E654E756D626572732E6C656E6774682A746869732E5F6C696E654865696768742B746869732E5F6C6173744C696E6552656C6174697665506F736974696F6E3B746869732E5F726F6F74446F6D4E6F64652E7374796C652E646973706C61793D22626C';
wwv_flow_imp.g_varchar2_table(30488) := '6F636B222C746869732E5F6C696E654E756D62657273446F6D4E6F64652E7374796C652E6865696768743D60247B737D7078602C746869732E5F6C696E6573446F6D4E6F64655363726F6C6C61626C652E7374796C652E6865696768743D60247B737D70';
wwv_flow_imp.g_varchar2_table(30489) := '78602C746869732E5F726F6F74446F6D4E6F64652E7374796C652E6865696768743D60247B737D7078602C746869732E5F726F6F74446F6D4E6F64652E7374796C652E6D617267696E4C6566743D22307078222C746869732E5F6D696E436F6E74656E74';
wwv_flow_imp.g_varchar2_table(30490) := '5769647468496E50783D4D6174682E6D6178282E2E2E746869732E5F72656E6465726564537469636B794C696E65732E6D61702828653D3E652E7363726F6C6C57696474682929292B692E766572746963616C5363726F6C6C62617257696474682C7468';
wwv_flow_imp.g_varchar2_table(30491) := '69732E5F656469746F722E6C61796F75744F7665726C61795769646765742874686973297D5F736574466F6C64696E67486F7665724C697374656E65727328297B226D6F7573656F766572223D3D3D746869732E5F656469746F722E6765744F7074696F';
wwv_flow_imp.g_varchar2_table(30492) := '6E2831313029262628746869732E5F666F6C64696E6749636F6E53746F72652E61646428627328746869732E5F6C696E654E756D62657273446F6D4E6F64652C61722E4D4F5553455F454E5445522C2828293D3E7B746869732E5F69734F6E476C797068';
wwv_flow_imp.g_varchar2_table(30493) := '4D617267696E3D21302C746869732E5F736574466F6C64696E6749636F6E735669736962696C697479282130297D2929292C746869732E5F666F6C64696E6749636F6E53746F72652E61646428627328746869732E5F6C696E654E756D62657273446F6D';
wwv_flow_imp.g_varchar2_table(30494) := '4E6F64652C61722E4D4F5553455F4C454156452C2828293D3E7B746869732E5F69734F6E476C7970684D617267696E3D21312C746869732E5F757365466F6C64696E674F7061636974795472616E736974696F6E282130292C746869732E5F736574466F';
wwv_flow_imp.g_varchar2_table(30495) := '6C64696E6749636F6E735669736962696C697479282131297D292929297D5F72656E6465724368696C644E6F646528652C742C6E2C69297B636F6E7374206F3D746869732E5F656469746F722E5F676574566965774D6F64656C28293B696628216F2972';
wwv_flow_imp.g_varchar2_table(30496) := '657475726E3B636F6E737420733D6F2E636F6F7264696E61746573436F6E7665727465722E636F6E766572744D6F64656C506F736974696F6E546F56696577506F736974696F6E286E6577206D6328742C3129292E6C696E654E756D6265722C723D6F2E';
wwv_flow_imp.g_varchar2_table(30497) := '676574566965774C696E6552656E646572696E67446174612873292C613D746869732E5F656469746F722E6765744F7074696F6E283638293B6C6574206C3B7472797B6C3D634E2E66696C74657228722E696E6C696E654465636F726174696F6E732C73';
wwv_flow_imp.g_varchar2_table(30498) := '2C722E6D696E436F6C756D6E2C722E6D6178436F6C756D6E297D63617463682865297B6C3D5B5D7D636F6E737420633D6E6577206D4E2821302C21302C722E636F6E74656E742C722E636F6E74696E75657357697468577261707065644C696E652C722E';
wwv_flow_imp.g_varchar2_table(30499) := '6973426173696341534349492C722E636F6E7461696E7352544C2C302C722E746F6B656E732C6C2C722E74616253697A652C722E737461727456697369626C65436F6C756D6E2C312C312C312C3530302C226E6F6E65222C21302C21302C6E756C6C292C';
wwv_flow_imp.g_varchar2_table(30500) := '643D6E6577206E7028326533292C683D5F4E28632C64293B6C657420753B753D4F393F4F392E63726561746548544D4C28642E6275696C642829293A642E6275696C6428293B636F6E737420703D646F63756D656E742E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(30501) := '28227370616E22293B702E7365744174747269627574652852392C537472696E67286529292C702E7365744174747269627574652846392C2222292C702E7365744174747269627574652822726F6C65222C226C6973746974656D22292C702E74616249';
wwv_flow_imp.g_varchar2_table(30502) := '6E6465783D302C702E636C6173734E616D653D22737469636B792D6C696E652D636F6E74656E74222C702E636C6173734C6973742E6164642860737469636B794C696E65247B747D60292C702E7374796C652E6C696E654865696768743D60247B746869';
wwv_flow_imp.g_varchar2_table(30503) := '732E5F6C696E654865696768747D7078602C702E696E6E657248544D4C3D753B636F6E737420673D646F63756D656E742E637265617465456C656D656E7428227370616E22293B672E7365744174747269627574652852392C537472696E67286529292C';
wwv_flow_imp.g_varchar2_table(30504) := '672E7365744174747269627574652822646174612D737469636B792D69732D6C696E652D6E756D626572222C2222292C672E636C6173734E616D653D22737469636B792D6C696E652D6E756D626572222C672E7374796C652E6C696E654865696768743D';
wwv_flow_imp.g_varchar2_table(30505) := '60247B746869732E5F6C696E654865696768747D7078603B636F6E7374206D3D692E636F6E74656E744C6566743B672E7374796C652E77696474683D60247B6D7D7078603B636F6E737420663D646F63756D656E742E637265617465456C656D656E7428';
wwv_flow_imp.g_varchar2_table(30506) := '227370616E22293B313D3D3D612E72656E646572547970657C7C333D3D3D612E72656E646572547970652626742531303D3D303F662E696E6E6572546578743D742E746F537472696E6728293A323D3D3D612E72656E64657254797065262628662E696E';
wwv_flow_imp.g_varchar2_table(30507) := '6E6572546578743D4D6174682E61627328742D746869732E5F656469746F722E676574506F736974696F6E28292E6C696E654E756D626572292E746F537472696E672829292C662E636C6173734E616D653D22737469636B792D6C696E652D6E756D6265';
wwv_flow_imp.g_varchar2_table(30508) := '722D696E6E6572222C662E7374796C652E6C696E654865696768743D60247B746869732E5F6C696E654865696768747D7078602C662E7374796C652E77696474683D60247B692E6C696E654E756D6265727357696474687D7078602C662E7374796C652E';
wwv_flow_imp.g_varchar2_table(30509) := '70616464696E674C6566743D60247B692E6C696E654E756D626572734C6566747D7078602C672E617070656E644368696C642866293B636F6E737420763D746869732E5F72656E646572466F6C64696E6749636F6E466F724C696E65286E2C74293B7626';
wwv_flow_imp.g_varchar2_table(30510) := '26672E617070656E644368696C6428762E646F6D4E6F6465292C746869732E5F656469746F722E6170706C79466F6E74496E666F2870292C746869732E5F656469746F722E6170706C79466F6E74496E666F2866292C672E7374796C652E6C696E654865';
wwv_flow_imp.g_varchar2_table(30511) := '696768743D60247B746869732E5F6C696E654865696768747D7078602C702E7374796C652E6C696E654865696768743D60247B746869732E5F6C696E654865696768747D7078602C672E7374796C652E6865696768743D60247B746869732E5F6C696E65';
wwv_flow_imp.g_varchar2_table(30512) := '4865696768747D7078602C702E7374796C652E6865696768743D60247B746869732E5F6C696E654865696768747D7078603B636F6E737420623D6E6577207A3928652C742C702C672C762C682E6368617261637465724D617070696E672C702E7363726F';
wwv_flow_imp.g_varchar2_table(30513) := '6C6C5769647468293B72657475726E20746869732E5F757064617465546F70416E645A496E6465784F66537469636B794C696E652862297D5F757064617465546F70416E645A496E6465784F66537469636B794C696E652865297B76617220743B636F6E';
wwv_flow_imp.g_varchar2_table(30514) := '7374206E3D652E696E6465782C693D652E6C696E65446F6D4E6F64652C6F3D652E6C696E654E756D626572446F6D4E6F64652C733D6E3D3D3D746869732E5F6C696E654E756D626572732E6C656E6774682D313B692E7374796C652E7A496E6465783D73';
wwv_flow_imp.g_varchar2_table(30515) := '3F2230223A2231222C6F2E7374796C652E7A496E6465783D733F2230223A2231223B636F6E737420723D60247B6E2A746869732E5F6C696E654865696768742B746869732E5F6C6173744C696E6552656C6174697665506F736974696F6E2B28286E756C';
wwv_flow_imp.g_varchar2_table(30516) := '6C3D3D3D28743D652E666F6C64696E6749636F6E297C7C766F696420303D3D3D743F766F696420303A742E6973436F6C6C6170736564293F313A30297D7078602C613D6E2A746869732E5F6C696E654865696768742B227078223B72657475726E20692E';
wwv_flow_imp.g_varchar2_table(30517) := '7374796C652E746F703D733F723A612C6F2E7374796C652E746F703D733F723A612C657D5F72656E646572466F6C64696E6749636F6E466F724C696E6528652C74297B636F6E7374206E3D746869732E5F656469746F722E6765744F7074696F6E283131';
wwv_flow_imp.g_varchar2_table(30518) := '30293B69662821657C7C226E65766572223D3D3D6E2972657475726E3B636F6E737420693D652E726567696F6E732C6F3D692E66696E6452616E67652874292C733D692E67657453746172744C696E654E756D626572286F293B69662874213D3D732972';
wwv_flow_imp.g_varchar2_table(30519) := '657475726E3B636F6E737420723D692E6973436F6C6C6170736564286F292C613D6E657720483928722C732C692E676574456E644C696E654E756D626572286F292C746869732E5F6C696E65486569676874293B72657475726E20612E73657456697369';
wwv_flow_imp.g_varchar2_table(30520) := '626C65282121746869732E5F69734F6E476C7970684D617267696E7C7C727C7C22616C77617973223D3D3D6E292C612E646F6D4E6F64652E7365744174747269627574652842392C2222292C617D676574496428297B72657475726E22656469746F722E';
wwv_flow_imp.g_varchar2_table(30521) := '636F6E747269622E737469636B795363726F6C6C576964676574227D676574446F6D4E6F646528297B72657475726E20746869732E5F726F6F74446F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B707265666572656E63653A6E75';
wwv_flow_imp.g_varchar2_table(30522) := '6C6C7D7D6765744D696E436F6E74656E745769647468496E507828297B72657475726E20746869732E5F6D696E436F6E74656E745769647468496E50787D666F6375734C696E6557697468496E6465782865297B303C3D652626653C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(30523) := '6E6465726564537469636B794C696E65732E6C656E6774682626746869732E5F72656E6465726564537469636B794C696E65735B655D2E6C696E65446F6D4E6F64652E666F63757328297D676574456469746F72506F736974696F6E46726F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(30524) := '2865297B69662821657C7C652E6368696C6472656E2E6C656E6774683E302972657475726E206E756C6C3B636F6E737420743D746869732E5F67657452656E6465726564537469636B794C696E6546726F6D4368696C64446F6D4E6F64652865293B6966';
wwv_flow_imp.g_varchar2_table(30525) := '2821742972657475726E206E756C6C3B636F6E7374206E3D414E28742E6368617261637465724D617070696E672C652C30293B72657475726E206E6577206D6328742E6C696E654E756D6265722C6E297D6765744C696E654E756D62657246726F6D4368';
wwv_flow_imp.g_varchar2_table(30526) := '696C64446F6D4E6F64652865297B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E5F67657452656E6465726564537469636B794C696E6546726F6D4368696C64446F6D4E6F6465286529297C7C766F';
wwv_flow_imp.g_varchar2_table(30527) := '696420303D3D3D743F766F696420303A742E6C696E654E756D626572292626766F69642030213D3D6E3F6E3A6E756C6C7D5F67657452656E6465726564537469636B794C696E6546726F6D4368696C64446F6D4E6F64652865297B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(30528) := '6869732E6765744C696E65496E64657846726F6D4368696C64446F6D4E6F64652865293B72657475726E206E756C6C3D3D3D747C7C743C307C7C743E3D746869732E5F72656E6465726564537469636B794C696E65732E6C656E6774683F6E756C6C3A74';
wwv_flow_imp.g_varchar2_table(30529) := '6869732E5F72656E6465726564537469636B794C696E65735B745D7D6765744C696E65496E64657846726F6D4368696C64446F6D4E6F64652865297B636F6E737420743D746869732E5F67657441747472696275746556616C756528652C5239293B7265';
wwv_flow_imp.g_varchar2_table(30530) := '7475726E20743F7061727365496E7428742C3130293A6E756C6C7D6973496E537469636B794C696E652865297B72657475726E20766F69642030213D3D746869732E5F67657441747472696275746556616C756528652C4639297D6973496E466F6C6469';
wwv_flow_imp.g_varchar2_table(30531) := '6E6749636F6E446F6D4E6F64652865297B72657475726E20766F69642030213D3D746869732E5F67657441747472696275746556616C756528652C4239297D5F67657441747472696275746556616C756528652C74297B666F72283B65262665213D3D74';
wwv_flow_imp.g_varchar2_table(30532) := '6869732E5F726F6F74446F6D4E6F64653B297B636F6E7374206E3D652E6765744174747269627574652874293B6966286E756C6C213D3D6E2972657475726E206E3B653D652E706172656E74456C656D656E747D7D7D636C617373207A397B636F6E7374';
wwv_flow_imp.g_varchar2_table(30533) := '727563746F7228652C742C6E2C692C6F2C732C72297B746869732E696E6465783D652C746869732E6C696E654E756D6265723D742C746869732E6C696E65446F6D4E6F64653D6E2C746869732E6C696E654E756D626572446F6D4E6F64653D692C746869';
wwv_flow_imp.g_varchar2_table(30534) := '732E666F6C64696E6749636F6E3D6F2C746869732E6368617261637465724D617070696E673D732C746869732E7363726F6C6C57696474683D727D7D636C6173732048397B636F6E7374727563746F7228652C742C6E2C69297B746869732E6973436F6C';
wwv_flow_imp.g_varchar2_table(30535) := '6C61707365643D652C746869732E666F6C64696E6753746172744C696E653D742C746869732E666F6C64696E67456E644C696E653D6E2C746869732E64696D656E73696F6E3D692C746869732E646F6D4E6F64653D646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(30536) := '456C656D656E74282264697622292C746869732E646F6D4E6F64652E7374796C652E77696474683D60247B697D7078602C746869732E646F6D4E6F64652E7374796C652E6865696768743D60247B697D7078602C746869732E646F6D4E6F64652E636C61';
wwv_flow_imp.g_varchar2_table(30537) := '73734E616D653D546C2E6173436C6173734E616D6528653F5F313A6231297D73657456697369626C652865297B746869732E646F6D4E6F64652E7374796C652E637572736F723D653F22706F696E746572223A2264656661756C74222C746869732E646F';
wwv_flow_imp.g_varchar2_table(30538) := '6D4E6F64652E7374796C652E6F7061636974793D653F2231223A2230227D7D636C6173732057397B636F6E7374727563746F7228652C74297B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D6265723D74';
wwv_flow_imp.g_varchar2_table(30539) := '7D7D636C617373206A397B636F6E7374727563746F7228652C742C6E297B746869732E72616E67653D652C746869732E6368696C6472656E3D742C746869732E706172656E743D6E7D7D636C6173732071397B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(30540) := '2C69297B746869732E7572693D652C746869732E76657273696F6E3D742C746869732E656C656D656E743D6E2C746869732E6F75746C696E6550726F766964657249643D697D7D7661722024392C55392C4B393D66756E6374696F6E28652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(30541) := '297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D7479';
wwv_flow_imp.g_varchar2_table(30542) := '70656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(30543) := '682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C';
wwv_flow_imp.g_varchar2_table(30544) := '6E2C72292C727D2C47393D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B2166756E6374696F6E2865297B652E4F55544C494E455F4D4F44454C3D226F75746C696E654D6F64656C22';
wwv_flow_imp.g_varchar2_table(30545) := '2C652E464F4C44494E475F50524F56494445525F4D4F44454C3D22666F6C64696E6750726F76696465724D6F64656C222C652E494E44454E544154494F4E5F4D4F44454C3D22696E64656E746174696F6E4D6F64656C227D2824397C7C2824393D7B7D29';
wwv_flow_imp.g_varchar2_table(30546) := '292C66756E6374696F6E2865297B655B652E56414C49443D305D3D2256414C4944222C655B652E494E56414C49443D315D3D22494E56414C4944222C655B652E43414E43454C45443D325D3D2243414E43454C4544227D2855397C7C2855393D7B7D2929';
wwv_flow_imp.g_varchar2_table(30547) := '3B6C65742051393D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B73776974636828737570657228292C746869732E5F656469746F723D652C746869732E5F6D6F64656C50726F7669646572733D5B5D2C';
wwv_flow_imp.g_varchar2_table(30548) := '746869732E5F6D6F64656C50726F6D6973653D6E756C6C2C746869732E5F7570646174655363686564756C65723D746869732E5F7265676973746572286E6577207A742833303029292C746869732E5F7570646174654F7065726174696F6E3D74686973';
wwv_flow_imp.g_varchar2_table(30549) := '2E5F7265676973746572286E6577206174292C746869732E5F656469746F722E6765744F7074696F6E28313135292E64656661756C744D6F64656C297B636173652024392E4F55544C494E455F4D4F44454C3A746869732E5F6D6F64656C50726F766964';
wwv_flow_imp.g_varchar2_table(30550) := '6572732E70757368286E6577205A3928746869732E5F656469746F722C6929293B636173652024392E464F4C44494E475F50524F56494445525F4D4F44454C3A746869732E5F6D6F64656C50726F7669646572732E70757368286E657720656565287468';
wwv_flow_imp.g_varchar2_table(30551) := '69732E5F656469746F722C742C6929293B636173652024392E494E44454E544154494F4E5F4D4F44454C3A746869732E5F6D6F64656C50726F7669646572732E70757368286E6577204A3928746869732E5F656469746F722C6E29297D7D646973706F73';
wwv_flow_imp.g_varchar2_table(30552) := '6528297B746869732E5F6D6F64656C50726F7669646572732E666F72456163682828653D3E652E646973706F7365282929292C746869732E5F7570646174654F7065726174696F6E2E636C65617228292C746869732E5F63616E63656C4D6F64656C5072';
wwv_flow_imp.g_varchar2_table(30553) := '6F6D69736528292C73757065722E646973706F736528297D5F63616E63656C4D6F64656C50726F6D69736528297B746869732E5F6D6F64656C50726F6D697365262628746869732E5F6D6F64656C50726F6D6973652E63616E63656C28292C746869732E';
wwv_flow_imp.g_varchar2_table(30554) := '5F6D6F64656C50726F6D6973653D6E756C6C297D6173796E63207570646174652865297B72657475726E20746869732E5F7570646174654F7065726174696F6E2E636C65617228292C746869732E5F7570646174654F7065726174696F6E2E616464287B';
wwv_flow_imp.g_varchar2_table(30555) := '646973706F73653A28293D3E7B746869732E5F63616E63656C4D6F64656C50726F6D69736528292C746869732E5F7570646174655363686564756C65722E63616E63656C28297D7D292C746869732E5F63616E63656C4D6F64656C50726F6D6973652829';
wwv_flow_imp.g_varchar2_table(30556) := '2C617761697420746869732E5F7570646174655363686564756C65722E7472696767657228286173796E6328293D3E7B666F7228636F6E73742074206F6620746869732E5F6D6F64656C50726F766964657273297B636F6E73747B73746174757350726F';
wwv_flow_imp.g_varchar2_table(30557) := '6D6973653A6E2C6D6F64656C50726F6D6973653A697D3D742E636F6D70757465537469636B794D6F64656C2865293B746869732E5F6D6F64656C50726F6D6973653D693B636F6E7374206F3D6177616974206E3B696628746869732E5F6D6F64656C5072';
wwv_flow_imp.g_varchar2_table(30558) := '6F6D697365213D3D692972657475726E206E756C6C3B737769746368286F297B636173652055392E43414E43454C45443A72657475726E20746869732E5F7570646174654F7065726174696F6E2E636C65617228292C6E756C6C3B636173652055392E56';
wwv_flow_imp.g_varchar2_table(30559) := '414C49443A72657475726E20742E737469636B794D6F64656C7D7D72657475726E206E756C6C7D29292E63617463682828653D3E286B652865292C6E756C6C2929297D7D3B51393D4B39285B473928322C7563292C473928332C7878295D2C5139293B63';
wwv_flow_imp.g_varchar2_table(30560) := '6C61737320593920657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F656469746F723D652C746869732E5F737469636B794D6F64656C3D6E756C6C7D67657420737469636B794D6F64656C28297B7265';
wwv_flow_imp.g_varchar2_table(30561) := '7475726E20746869732E5F737469636B794D6F64656C7D5F696E76616C696428297B72657475726E20746869732E5F737469636B794D6F64656C3D6E756C6C2C55392E494E56414C49447D636F6D70757465537469636B794D6F64656C2865297B696628';
wwv_flow_imp.g_varchar2_table(30562) := '652E697343616E63656C6C6174696F6E5265717565737465647C7C21746869732E697350726F766964657256616C696428292972657475726E7B73746174757350726F6D6973653A746869732E5F696E76616C696428292C6D6F64656C50726F6D697365';
wwv_flow_imp.g_varchar2_table(30563) := '3A6E756C6C7D3B636F6E737420743D46742828653D3E746869732E6372656174654D6F64656C46726F6D50726F766964657228652929293B72657475726E7B73746174757350726F6D6973653A742E7468656E2828743D3E746869732E69734D6F64656C';
wwv_flow_imp.g_varchar2_table(30564) := '56616C69642874293F652E697343616E63656C6C6174696F6E5265717565737465643F55392E43414E43454C45443A28746869732E5F737469636B794D6F64656C3D746869732E637265617465537469636B794D6F64656C28652C74292C55392E56414C';
wwv_flow_imp.g_varchar2_table(30565) := '4944293A746869732E5F696E76616C6964282929292E7468656E28766F696420302C28653D3E286B652865292C55392E43414E43454C45442929292C6D6F64656C50726F6D6973653A747D7D69734D6F64656C56616C69642865297B72657475726E2130';
wwv_flow_imp.g_varchar2_table(30566) := '7D697350726F766964657256616C696428297B72657475726E21307D7D6C6574205A393D636C61737320657874656E64732059397B636F6E7374727563746F7228652C74297B73757065722865292C746869732E5F6C616E677561676546656174757265';
wwv_flow_imp.g_varchar2_table(30567) := '73536572766963653D747D6372656174654D6F64656C46726F6D50726F76696465722865297B72657475726E2055582E63726561746528746869732E5F6C616E67756167654665617475726573536572766963652E646F63756D656E7453796D626F6C50';
wwv_flow_imp.g_varchar2_table(30568) := '726F76696465722C746869732E5F656469746F722E6765744D6F64656C28292C65297D637265617465537469636B794D6F64656C28652C74297B766172206E3B636F6E73747B737469636B794F75746C696E65456C656D656E743A692C70726F76696465';
wwv_flow_imp.g_varchar2_table(30569) := '7249443A6F7D3D746869732E5F737469636B794D6F64656C46726F6D4F75746C696E654D6F64656C28742C6E756C6C3D3D3D286E3D746869732E5F737469636B794D6F64656C297C7C766F696420303D3D3D6E3F766F696420303A6E2E6F75746C696E65';
wwv_flow_imp.g_varchar2_table(30570) := '50726F76696465724964292C733D746869732E5F656469746F722E6765744D6F64656C28293B72657475726E206E657720713928732E7572692C732E67657456657273696F6E496428292C692C6F297D69734D6F64656C56616C69642865297B72657475';
wwv_flow_imp.g_varchar2_table(30571) := '726E20652626652E6368696C6472656E2E73697A653E307D5F737469636B794D6F64656C46726F6D4F75746C696E654D6F64656C28652C74297B6C6574206E3B6966285A652E666972737428652E6368696C6472656E2E76616C756573282929696E7374';
wwv_flow_imp.g_varchar2_table(30572) := '616E63656F66202458297B636F6E737420693D5A652E66696E6428652E6368696C6472656E2E76616C75657328292C28653D3E652E69643D3D3D7429293B69662869296E3D692E6368696C6472656E3B656C73657B6C657420692C6F3D22222C733D2D31';
wwv_flow_imp.g_varchar2_table(30573) := '3B666F7228636F6E73745B742C6E5D6F6620652E6368696C6472656E2E656E74726965732829297B636F6E737420653D746869732E5F66696E6453756D4F6652616E6765734F6647726F7570286E293B653E73262628693D6E2C733D652C6F3D6E2E6964';
wwv_flow_imp.g_varchar2_table(30574) := '297D743D6F2C6E3D692E6368696C6472656E7D7D656C7365206E3D652E6368696C6472656E3B636F6E737420693D5B5D2C6F3D41727261792E66726F6D286E2E76616C7565732829292E736F7274282828652C74293D3E7B636F6E7374206E3D6E657720';
wwv_flow_imp.g_varchar2_table(30575) := '573928652E73796D626F6C2E72616E67652E73746172744C696E654E756D6265722C652E73796D626F6C2E72616E67652E656E644C696E654E756D626572292C693D6E657720573928742E73796D626F6C2E72616E67652E73746172744C696E654E756D';
wwv_flow_imp.g_varchar2_table(30576) := '6265722C742E73796D626F6C2E72616E67652E656E644C696E654E756D626572293B72657475726E20746869732E5F636F6D70617261746F72286E2C69297D29293B666F7228636F6E73742065206F66206F29692E7075736828746869732E5F73746963';
wwv_flow_imp.g_varchar2_table(30577) := '6B794D6F64656C46726F6D4F75746C696E65456C656D656E7428652C652E73796D626F6C2E73656C656374696F6E52616E67652E73746172744C696E654E756D62657229293B72657475726E7B737469636B794F75746C696E65456C656D656E743A6E65';
wwv_flow_imp.g_varchar2_table(30578) := '77206A3928766F696420302C692C766F69642030292C70726F766964657249443A747D7D5F737469636B794D6F64656C46726F6D4F75746C696E65456C656D656E7428652C74297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F6620652E';
wwv_flow_imp.g_varchar2_table(30579) := '6368696C6472656E2E76616C756573282929696628692E73796D626F6C2E73656C656374696F6E52616E67652E73746172744C696E654E756D626572213D3D692E73796D626F6C2E72616E67652E656E644C696E654E756D62657229696628692E73796D';
wwv_flow_imp.g_varchar2_table(30580) := '626F6C2E73656C656374696F6E52616E67652E73746172744C696E654E756D626572213D3D74296E2E7075736828746869732E5F737469636B794D6F64656C46726F6D4F75746C696E65456C656D656E7428692C692E73796D626F6C2E73656C65637469';
wwv_flow_imp.g_varchar2_table(30581) := '6F6E52616E67652E73746172744C696E654E756D62657229293B656C736520666F7228636F6E73742065206F6620692E6368696C6472656E2E76616C7565732829296E2E7075736828746869732E5F737469636B794D6F64656C46726F6D4F75746C696E';
wwv_flow_imp.g_varchar2_table(30582) := '65456C656D656E7428652C692E73796D626F6C2E73656C656374696F6E52616E67652E73746172744C696E654E756D62657229293B6E2E736F7274282828652C74293D3E746869732E5F636F6D70617261746F7228652E72616E67652C742E72616E6765';
wwv_flow_imp.g_varchar2_table(30583) := '2929293B636F6E737420693D6E657720573928652E73796D626F6C2E73656C656374696F6E52616E67652E73746172744C696E654E756D6265722C652E73796D626F6C2E72616E67652E656E644C696E654E756D626572293B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(30584) := '6A3928692C6E2C766F69642030297D5F636F6D70617261746F7228652C74297B72657475726E20652E73746172744C696E654E756D626572213D3D742E73746172744C696E654E756D6265723F652E73746172744C696E654E756D6265722D742E737461';
wwv_flow_imp.g_varchar2_table(30585) := '72744C696E654E756D6265723A742E656E644C696E654E756D6265722D652E656E644C696E654E756D6265727D5F66696E6453756D4F6652616E6765734F6647726F75702865297B6C657420743D303B666F7228636F6E7374206E206F6620652E636869';
wwv_flow_imp.g_varchar2_table(30586) := '6C6472656E2E76616C756573282929742B3D746869732E5F66696E6453756D4F6652616E6765734F6647726F7570286E293B72657475726E206520696E7374616E63656F662071583F742B652E73796D626F6C2E72616E67652E656E644C696E654E756D';
wwv_flow_imp.g_varchar2_table(30587) := '6265722D652E73796D626F6C2E73656C656374696F6E52616E67652E73746172744C696E654E756D6265723A747D7D3B5A393D4B39285B473928312C7878295D2C5A39293B636C61737320583920657874656E64732059397B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(30588) := '2865297B73757065722865292C746869732E5F666F6C64696E674C696D69745265706F727465723D6E6577204E312865297D637265617465537469636B794D6F64656C28652C74297B636F6E7374206E3D746869732E5F66726F6D466F6C64696E675265';
wwv_flow_imp.g_varchar2_table(30589) := '67696F6E732874292C693D746869732E5F656469746F722E6765744D6F64656C28293B72657475726E206E657720713928692E7572692C692E67657456657273696F6E496428292C6E2C766F69642030297D69734D6F64656C56616C69642865297B7265';
wwv_flow_imp.g_varchar2_table(30590) := '7475726E206E756C6C213D3D657D5F66726F6D466F6C64696E67526567696F6E732865297B636F6E737420743D652E6C656E6774682C6E3D5B5D2C693D6E6577206A3928766F696420302C5B5D2C766F69642030293B666F72286C6574206F3D303B6F3C';
wwv_flow_imp.g_varchar2_table(30591) := '743B6F2B2B297B636F6E737420743D652E676574506172656E74496E646578286F293B6C657420733B733D2D31213D3D743F6E5B745D3A693B636F6E737420723D6E6577206A39286E657720573928652E67657453746172744C696E654E756D62657228';
wwv_flow_imp.g_varchar2_table(30592) := '6F292C652E676574456E644C696E654E756D626572286F292B31292C5B5D2C73293B732E6368696C6472656E2E707573682872292C6E2E707573682872297D72657475726E20697D7D6C6574204A393D636C61737320657874656E64732058397B636F6E';
wwv_flow_imp.g_varchar2_table(30593) := '7374727563746F7228652C74297B73757065722865292C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D742C746869732E70726F76696465723D746869732E5F7265676973746572286E657720673128652E6765';
wwv_flow_imp.g_varchar2_table(30594) := '744D6F64656C28292C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963652C746869732E5F666F6C64696E674C696D69745265706F7274657229297D6173796E63206372656174654D6F64656C46726F6D50726F766964';
wwv_flow_imp.g_varchar2_table(30595) := '65722865297B72657475726E20746869732E70726F76696465722E636F6D707574652865297D7D3B4A393D4B39285B473928312C6567295D2C4A39293B6C6574206565653D636C61737320657874656E64732058397B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(30596) := '742C6E297B73757065722865292C746869732E5F6C616E67756167654665617475726573536572766963653D6E3B636F6E737420693D41312E676574466F6C64696E6752616E676550726F76696465727328746869732E5F6C616E677561676546656174';
wwv_flow_imp.g_varchar2_table(30597) := '75726573536572766963652C652E6765744D6F64656C2829293B692E6C656E6774683E30262628746869732E70726F76696465723D746869732E5F7265676973746572286E6577204C3128652E6765744D6F64656C28292C692C742C746869732E5F666F';
wwv_flow_imp.g_varchar2_table(30598) := '6C64696E674C696D69745265706F727465722C766F696420302929297D697350726F766964657256616C696428297B72657475726E20766F69642030213D3D746869732E70726F76696465727D6173796E63206372656174654D6F64656C46726F6D5072';
wwv_flow_imp.g_varchar2_table(30599) := '6F76696465722865297B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E70726F7669646572297C7C766F696420303D3D3D743F766F696420303A742E636F6D70757465286529292626766F69642030';
wwv_flow_imp.g_varchar2_table(30600) := '213D3D6E3F6E3A6E756C6C7D7D3B6565653D4B39285B473928322C7878295D2C656565293B766172207465653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C617373206E6565';
wwv_flow_imp.g_varchar2_table(30601) := '7B636F6E7374727563746F7228652C742C6E297B746869732E73746172744C696E654E756D6265723D652C746869732E656E644C696E654E756D6265723D742C746869732E6E657374696E6744657074683D6E7D7D6C6574206965653D636C6173732065';
wwv_flow_imp.g_varchar2_table(30602) := '7874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F6C616E67756167654665617475726573536572766963653D742C746869732E5F6C616E6775616765436F6E66696775726174696F6E53657276';
wwv_flow_imp.g_varchar2_table(30603) := '6963653D6E2C746869732E5F6F6E4469644368616E6765537469636B795363726F6C6C3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E6765537469636B795363726F6C6C3D746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(30604) := '68616E6765537469636B795363726F6C6C2E6576656E742C746869732E5F6D6F64656C3D6E756C6C2C746869732E5F6374733D6E756C6C2C746869732E5F737469636B794D6F64656C50726F76696465723D6E756C6C2C746869732E5F656469746F723D';
wwv_flow_imp.g_varchar2_table(30605) := '652C746869732E5F73657373696F6E53746F72653D746869732E5F7265676973746572286E6577206174292C746869732E5F757064617465536F6F6E3D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E75706461746528';
wwv_flow_imp.g_varchar2_table(30606) := '29292C353029292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E67656428313135292626746869732E72656164436F6E666967';
wwv_flow_imp.g_varchar2_table(30607) := '75726174696F6E28297D2929292C746869732E72656164436F6E66696775726174696F6E28297D72656164436F6E66696775726174696F6E28297B746869732E5F73657373696F6E53746F72652E636C65617228292C746869732E5F656469746F722E67';
wwv_flow_imp.g_varchar2_table(30608) := '65744F7074696F6E28313135292E656E61626C6564262628746869732E5F73657373696F6E53746F72652E61646428746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F6D6F64656C3D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(30609) := '746869732E757064617465537469636B794D6F64656C50726F766964657228292C746869732E5F6F6E4469644368616E6765537469636B795363726F6C6C2E6669726528292C746869732E75706461746528297D2929292C746869732E5F73657373696F';
wwv_flow_imp.g_varchar2_table(30610) := '6E53746F72652E61646428746869732E5F656469746F722E6F6E4469644368616E676548696464656E4172656173282828293D3E746869732E75706461746528292929292C746869732E5F73657373696F6E53746F72652E61646428746869732E5F6564';
wwv_flow_imp.g_varchar2_table(30611) := '69746F722E6F6E4469644368616E67654D6F64656C436F6E74656E74282828293D3E746869732E5F757064617465536F6F6E2E7363686564756C6528292929292C746869732E5F73657373696F6E53746F72652E61646428746869732E5F6C616E677561';
wwv_flow_imp.g_varchar2_table(30612) := '67654665617475726573536572766963652E646F63756D656E7453796D626F6C50726F76696465722E6F6E4469644368616E6765282828293D3E746869732E75706461746528292929292C746869732E5F73657373696F6E53746F72652E616464287274';
wwv_flow_imp.g_varchar2_table(30613) := '282828293D3E7B76617220653B6E756C6C3D3D3D28653D746869732E5F737469636B794D6F64656C50726F7669646572297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F737469636B794D6F64656C50726F7669646572';
wwv_flow_imp.g_varchar2_table(30614) := '3D6E756C6C7D2929292C746869732E757064617465537469636B794D6F64656C50726F766964657228292C746869732E7570646174652829297D67657456657273696F6E496428297B76617220653B72657475726E206E756C6C3D3D3D28653D74686973';
wwv_flow_imp.g_varchar2_table(30615) := '2E5F6D6F64656C297C7C766F696420303D3D3D653F766F696420303A652E76657273696F6E7D757064617465537469636B794D6F64656C50726F766964657228297B76617220653B6E756C6C3D3D3D28653D746869732E5F737469636B794D6F64656C50';
wwv_flow_imp.g_varchar2_table(30616) := '726F7669646572297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F737469636B794D6F64656C50726F76696465723D6E756C6C3B636F6E737420743D746869732E5F656469746F723B742E6861734D6F64656C28292626';
wwv_flow_imp.g_varchar2_table(30617) := '28746869732E5F737469636B794D6F64656C50726F76696465723D6E657720513928742C2828293D3E746869732E5F757064617465536F6F6E2E7363686564756C652829292C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572';
wwv_flow_imp.g_varchar2_table(30618) := '766963652C746869732E5F6C616E677561676546656174757265735365727669636529297D6173796E632075706461746528297B76617220653B6E756C6C3D3D3D28653D746869732E5F637473297C7C766F696420303D3D3D657C7C652E646973706F73';
wwv_flow_imp.g_varchar2_table(30619) := '65282130292C746869732E5F6374733D6E6577204E742C617761697420746869732E757064617465537469636B794D6F64656C28746869732E5F6374732E746F6B656E292C746869732E5F6F6E4469644368616E6765537469636B795363726F6C6C2E66';
wwv_flow_imp.g_varchar2_table(30620) := '69726528297D6173796E6320757064617465537469636B794D6F64656C2865297B69662821746869732E5F656469746F722E6861734D6F64656C28297C7C21746869732E5F737469636B794D6F64656C50726F76696465727C7C746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(30621) := '6F722E6765744D6F64656C28292E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28292972657475726E20766F696428746869732E5F6D6F64656C3D6E756C6C293B636F6E737420743D617761697420746869732E5F737469636B794D6F';
wwv_flow_imp.g_varchar2_table(30622) := '64656C50726F76696465722E7570646174652865293B652E697343616E63656C6C6174696F6E5265717565737465647C7C28746869732E5F6D6F64656C3D74297D757064617465496E6465782865297B72657475726E2D313D3D3D653F653D303A653C30';
wwv_flow_imp.g_varchar2_table(30623) := '262628653D2D652D32292C657D67657443616E646964617465537469636B794C696E6573496E74657273656374696E6746726F6D537469636B794D6F64656C28652C742C6E2C692C6F297B696628303D3D3D742E6368696C6472656E2E6C656E67746829';
wwv_flow_imp.g_varchar2_table(30624) := '72657475726E3B6C657420733D6F3B636F6E737420723D5B5D3B666F72286C657420653D303B653C742E6368696C6472656E2E6C656E6774683B652B2B297B636F6E7374206E3D742E6368696C6472656E5B655D3B6E2E72616E67652626722E70757368';
wwv_flow_imp.g_varchar2_table(30625) := '286E2E72616E67652E73746172744C696E654E756D626572297D636F6E737420613D746869732E757064617465496E646578284F6828722C652E73746172744C696E654E756D6265722C2828652C74293D3E652D742929292C6C3D746869732E75706461';
wwv_flow_imp.g_varchar2_table(30626) := '7465496E646578284F6828722C652E73746172744C696E654E756D6265722B692C2828652C74293D3E652D742929293B666F72286C657420723D613B723C3D6C3B722B2B297B636F6E737420613D742E6368696C6472656E5B725D3B6966282161297265';
wwv_flow_imp.g_varchar2_table(30627) := '7475726E3B696628612E72616E6765297B636F6E737420743D612E72616E67652E73746172744C696E654E756D6265722C6F3D612E72616E67652E656E644C696E654E756D6265723B652E73746172744C696E654E756D6265723C3D6F2B312626742D31';
wwv_flow_imp.g_varchar2_table(30628) := '3C3D652E656E644C696E654E756D626572262674213D3D73262628733D742C6E2E70757368286E6577206E656528742C6F2D312C692B3129292C746869732E67657443616E646964617465537469636B794C696E6573496E74657273656374696E674672';
wwv_flow_imp.g_varchar2_table(30629) := '6F6D537469636B794D6F64656C28652C612C6E2C692B312C7429297D656C736520746869732E67657443616E646964617465537469636B794C696E6573496E74657273656374696E6746726F6D537469636B794D6F64656C28652C612C6E2C692C6F297D';
wwv_flow_imp.g_varchar2_table(30630) := '7D67657443616E646964617465537469636B794C696E6573496E74657273656374696E672865297B76617220742C6E3B69662821286E756C6C3D3D3D28743D746869732E5F6D6F64656C297C7C766F696420303D3D3D743F766F696420303A742E656C65';
wwv_flow_imp.g_varchar2_table(30631) := '6D656E74292972657475726E5B5D3B6C657420693D5B5D3B746869732E67657443616E646964617465537469636B794C696E6573496E74657273656374696E6746726F6D537469636B794D6F64656C28652C746869732E5F6D6F64656C2E656C656D656E';
wwv_flow_imp.g_varchar2_table(30632) := '742C692C302C2D31293B636F6E7374206F3D6E756C6C3D3D3D286E3D746869732E5F656469746F722E5F676574566965774D6F64656C2829297C7C766F696420303D3D3D6E3F766F696420303A6E2E67657448696464656E417265617328293B6966286F';
wwv_flow_imp.g_varchar2_table(30633) := '29666F7228636F6E73742065206F66206F29693D692E66696C7465722828743D3E2128742E73746172744C696E654E756D6265723E3D652E73746172744C696E654E756D6265722626742E656E644C696E654E756D6265723C3D652E656E644C696E654E';
wwv_flow_imp.g_varchar2_table(30634) := '756D6265722B312929293B72657475726E20697D7D3B6965653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F77';
wwv_flow_imp.g_varchar2_table(30635) := '6E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563';
wwv_flow_imp.g_varchar2_table(30636) := '742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C';
wwv_flow_imp.g_varchar2_table(30637) := '72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B74656528312C7878292C74656528322C6567295D2C696565293B766172206F65652C7365653D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(30638) := '74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574207265653D6F65653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B737570657228292C74';
wwv_flow_imp.g_varchar2_table(30639) := '6869732E5F656469746F723D652C746869732E5F636F6E746578744D656E75536572766963653D742C746869732E5F6C616E67756167654665617475726573536572766963653D6E2C746869732E5F696E737461536572766963653D692C746869732E5F';
wwv_flow_imp.g_varchar2_table(30640) := '636F6E746578744B6579536572766963653D722C746869732E5F73657373696F6E53746F72653D6E65772061742C746869732E5F666F6C64696E674D6F64656C3D6E756C6C2C746869732E5F6D6178537469636B794C696E65733D4E756D6265722E4D41';
wwv_flow_imp.g_varchar2_table(30641) := '585F534146455F494E54454745522C746869732E5F63616E646964617465446566696E6974696F6E734C656E6774683D2D312C746869732E5F666F6375736564537469636B79456C656D656E74496E6465783D2D312C746869732E5F656E61626C65643D';
wwv_flow_imp.g_varchar2_table(30642) := '21312C746869732E5F666F63757365643D21312C746869732E5F706F736974696F6E52657665616C65643D21312C746869732E5F6F6E4D6F757365446F776E3D21312C746869732E5F656E644C696E654E756D626572733D5B5D2C746869732E5F73686F';
wwv_flow_imp.g_varchar2_table(30643) := '77456E64466F724C696E653D6E756C6C2C746869732E5F737469636B795363726F6C6C5769646765743D6E657720563928746869732E5F656469746F72292C746869732E5F737469636B794C696E6543616E64696461746550726F76696465723D6E6577';
wwv_flow_imp.g_varchar2_table(30644) := '2069656528746869732E5F656469746F722C6E2C6F292C746869732E5F726567697374657228746869732E5F737469636B795363726F6C6C576964676574292C746869732E5F726567697374657228746869732E5F737469636B794C696E6543616E6469';
wwv_flow_imp.g_varchar2_table(30645) := '6461746550726F7669646572292C746869732E5F77696467657453746174653D6E6577205039285B5D2C5B5D2C30292C746869732E5F6F6E446964526573697A6528292C746869732E5F72656164436F6E66696775726174696F6E28293B636F6E737420';
wwv_flow_imp.g_varchar2_table(30646) := '613D746869732E5F737469636B795363726F6C6C5769646765742E676574446F6D4E6F646528293B746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B7468';
wwv_flow_imp.g_varchar2_table(30647) := '69732E5F72656164436F6E66696775726174696F6E4368616E67652865297D2929292C746869732E5F726567697374657228627328612C61722E434F4E544558545F4D454E552C286173796E6320653D3E7B746869732E5F6F6E436F6E746578744D656E';
wwv_flow_imp.g_varchar2_table(30648) := '752872732861292C65297D2929292C746869732E5F737469636B795363726F6C6C466F6375736564436F6E746578744B65793D6C682E737469636B795363726F6C6C466F63757365642E62696E64546F28746869732E5F636F6E746578744B6579536572';
wwv_flow_imp.g_varchar2_table(30649) := '76696365292C746869732E5F737469636B795363726F6C6C56697369626C65436F6E746578744B65793D6C682E737469636B795363726F6C6C56697369626C652E62696E64546F28746869732E5F636F6E746578744B657953657276696365293B636F6E';
wwv_flow_imp.g_varchar2_table(30650) := '7374206C3D746869732E5F7265676973746572286872286129293B746869732E5F7265676973746572286C2E6F6E446964426C75722828653D3E7B21313D3D3D746869732E5F706F736974696F6E52657665616C65642626303D3D3D612E636C69656E74';
wwv_flow_imp.g_varchar2_table(30651) := '4865696768743F28746869732E5F666F6375736564537469636B79456C656D656E74496E6465783D2D312C746869732E666F6375732829293A746869732E5F646973706F7365466F637573537469636B795363726F6C6C53746F726528297D2929292C74';
wwv_flow_imp.g_varchar2_table(30652) := '6869732E5F7265676973746572286C2E6F6E446964466F6375732828653D3E7B746869732E666F63757328297D2929292C746869732E5F72656769737465724D6F7573654C697374656E65727328292C746869732E5F726567697374657228627328612C';
wwv_flow_imp.g_varchar2_table(30653) := '61722E4D4F5553455F444F574E2C28653D3E7B746869732E5F6F6E4D6F757365446F776E3D21307D2929297D737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E286F65652E4944297D5F646973706F736546';
wwv_flow_imp.g_varchar2_table(30654) := '6F637573537469636B795363726F6C6C53746F726528297B76617220653B746869732E5F737469636B795363726F6C6C466F6375736564436F6E746578744B65792E736574282131292C6E756C6C3D3D3D28653D746869732E5F666F637573446973706F';
wwv_flow_imp.g_varchar2_table(30655) := '7361626C6553746F7265297C7C766F696420303D3D3D657C7C652E646973706F736528292C746869732E5F666F63757365643D21312C746869732E5F706F736974696F6E52657665616C65643D21312C746869732E5F6F6E4D6F757365446F776E3D2131';
wwv_flow_imp.g_varchar2_table(30656) := '7D666F63757328297B696628746869732E5F6F6E4D6F757365446F776E2972657475726E20746869732E5F6F6E4D6F757365446F776E3D21312C766F696420746869732E5F656469746F722E666F63757328293B2130213D3D746869732E5F737469636B';
wwv_flow_imp.g_varchar2_table(30657) := '795363726F6C6C466F6375736564436F6E746578744B65792E6765742829262628746869732E5F666F63757365643D21302C746869732E5F666F637573446973706F7361626C6553746F72653D6E65772061742C746869732E5F737469636B795363726F';
wwv_flow_imp.g_varchar2_table(30658) := '6C6C466F6375736564436F6E746578744B65792E736574282130292C746869732E5F666F6375736564537469636B79456C656D656E74496E6465783D746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572732E6C656E';
wwv_flow_imp.g_varchar2_table(30659) := '6774682D312C746869732E5F737469636B795363726F6C6C5769646765742E666F6375734C696E6557697468496E64657828746869732E5F666F6375736564537469636B79456C656D656E74496E64657829297D666F6375734E65787428297B74686973';
wwv_flow_imp.g_varchar2_table(30660) := '2E5F666F6375736564537469636B79456C656D656E74496E6465783C746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572436F756E742D312626746869732E5F666F6375734E6176282130297D666F63757350726576';
wwv_flow_imp.g_varchar2_table(30661) := '696F757328297B746869732E5F666F6375736564537469636B79456C656D656E74496E6465783E302626746869732E5F666F6375734E6176282131297D73656C656374456469746F7228297B746869732E5F656469746F722E666F63757328297D5F666F';
wwv_flow_imp.g_varchar2_table(30662) := '6375734E61762865297B746869732E5F666F6375736564537469636B79456C656D656E74496E6465783D653F746869732E5F666F6375736564537469636B79456C656D656E74496E6465782B313A746869732E5F666F6375736564537469636B79456C65';
wwv_flow_imp.g_varchar2_table(30663) := '6D656E74496E6465782D312C746869732E5F737469636B795363726F6C6C5769646765742E666F6375734C696E6557697468496E64657828746869732E5F666F6375736564537469636B79456C656D656E74496E646578297D676F546F466F6375736564';
wwv_flow_imp.g_varchar2_table(30664) := '28297B636F6E737420653D746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572733B746869732E5F646973706F7365466F637573537469636B795363726F6C6C53746F726528292C746869732E5F72657665616C506F';
wwv_flow_imp.g_varchar2_table(30665) := '736974696F6E287B6C696E654E756D6265723A655B746869732E5F666F6375736564537469636B79456C656D656E74496E6465785D2C636F6C756D6E3A317D297D5F72657665616C506F736974696F6E2865297B746869732E5F7265766561496E456469';
wwv_flow_imp.g_varchar2_table(30666) := '746F7228652C2828293D3E746869732E5F656469746F722E72657665616C506F736974696F6E28652929297D5F72657665616C4C696E65496E43656E74657249664F75747369646556696577706F72742865297B746869732E5F7265766561496E456469';
wwv_flow_imp.g_varchar2_table(30667) := '746F7228652C2828293D3E746869732E5F656469746F722E72657665616C4C696E65496E43656E74657249664F75747369646556696577706F727428652E6C696E654E756D6265722C302929297D5F7265766561496E456469746F7228652C74297B7468';
wwv_flow_imp.g_varchar2_table(30668) := '69732E5F666F63757365642626746869732E5F646973706F7365466F637573537469636B795363726F6C6C53746F726528292C746869732E5F706F736974696F6E52657665616C65643D21302C7428292C746869732E5F656469746F722E73657453656C';
wwv_flow_imp.g_varchar2_table(30669) := '656374696F6E2872682E66726F6D506F736974696F6E73286529292C746869732E5F656469746F722E666F63757328297D5F72656769737465724D6F7573654C697374656E65727328297B636F6E737420653D746869732E5F7265676973746572286E65';
wwv_flow_imp.g_varchar2_table(30670) := '77206174292C743D746869732E5F7265676973746572286E657720517128746869732E5F656469746F722C7B657874726163744C696E654E756D62657246726F6D4D6F7573654576656E743A653D3E7B636F6E737420743D746869732E5F737469636B79';
wwv_flow_imp.g_varchar2_table(30671) := '5363726F6C6C5769646765742E676574456469746F72506F736974696F6E46726F6D4E6F646528652E7461726765742E656C656D656E74293B72657475726E20743F742E6C696E654E756D6265723A307D7D29292C6E3D653D3E7B69662821746869732E';
wwv_flow_imp.g_varchar2_table(30672) := '5F656469746F722E6861734D6F64656C28292972657475726E206E756C6C3B6966283132213D3D652E7461726765742E747970657C7C652E7461726765742E64657461696C213D3D746869732E5F737469636B795363726F6C6C5769646765742E676574';
wwv_flow_imp.g_varchar2_table(30673) := '496428292972657475726E206E756C6C3B636F6E737420743D652E7461726765742E656C656D656E743B69662821747C7C742E696E6E657254657874213D3D742E696E6E657248544D4C2972657475726E206E756C6C3B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(30674) := '5F737469636B795363726F6C6C5769646765742E676574456469746F72506F736974696F6E46726F6D4E6F64652874293B72657475726E206E3F7B72616E67653A6E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C6E2E6C696E65';
wwv_flow_imp.g_varchar2_table(30675) := '4E756D6265722C6E2E636F6C756D6E2B742E696E6E6572546578742E6C656E677468292C74657874456C656D656E743A747D3A6E756C6C7D2C693D746869732E5F737469636B795363726F6C6C5769646765742E676574446F6D4E6F646528293B746869';
wwv_flow_imp.g_varchar2_table(30676) := '732E5F726567697374657228797328692C61722E434C49434B2C28653D3E7B696628652E6374726C4B65797C7C652E616C744B65797C7C652E6D6574614B65792972657475726E3B69662821652E6C656674427574746F6E2972657475726E3B69662865';
wwv_flow_imp.g_varchar2_table(30677) := '2E73686966744B6579297B636F6E737420743D746869732E5F737469636B795363726F6C6C5769646765742E6765744C696E65496E64657846726F6D4368696C64446F6D4E6F646528652E746172676574293B6966286E756C6C3D3D3D74297265747572';
wwv_flow_imp.g_varchar2_table(30678) := '6E3B636F6E7374206E3D6E6577206D6328746869732E5F656E644C696E654E756D626572735B745D2C31293B72657475726E20766F696420746869732E5F72657665616C4C696E65496E43656E74657249664F75747369646556696577706F7274286E29';
wwv_flow_imp.g_varchar2_table(30679) := '7D696628746869732E5F737469636B795363726F6C6C5769646765742E6973496E466F6C64696E6749636F6E446F6D4E6F646528652E74617267657429297B636F6E737420743D746869732E5F737469636B795363726F6C6C5769646765742E6765744C';
wwv_flow_imp.g_varchar2_table(30680) := '696E654E756D62657246726F6D4368696C64446F6D4E6F646528652E746172676574293B72657475726E20766F696420746869732E5F746F67676C65466F6C64696E67526567696F6E466F724C696E652874297D69662821746869732E5F737469636B79';
wwv_flow_imp.g_varchar2_table(30681) := '5363726F6C6C5769646765742E6973496E537469636B794C696E6528652E746172676574292972657475726E3B6C657420743D746869732E5F737469636B795363726F6C6C5769646765742E676574456469746F72506F736974696F6E46726F6D4E6F64';
wwv_flow_imp.g_varchar2_table(30682) := '6528652E746172676574293B6966282174297B636F6E7374206E3D746869732E5F737469636B795363726F6C6C5769646765742E6765744C696E654E756D62657246726F6D4368696C64446F6D4E6F646528652E746172676574293B6966286E756C6C3D';
wwv_flow_imp.g_varchar2_table(30683) := '3D3D6E2972657475726E3B743D6E6577206D63286E2C31297D746869732E5F72657665616C506F736974696F6E2874297D2929292C746869732E5F726567697374657228797328692C61722E4D4F5553455F4D4F56452C28653D3E7B696628652E736869';
wwv_flow_imp.g_varchar2_table(30684) := '66744B6579297B636F6E737420743D746869732E5F737469636B795363726F6C6C5769646765742E6765744C696E65496E64657846726F6D4368696C64446F6D4E6F646528652E746172676574293B6966286E756C6C3D3D3D747C7C6E756C6C213D3D74';
wwv_flow_imp.g_varchar2_table(30685) := '6869732E5F73686F77456E64466F724C696E652626746869732E5F73686F77456E64466F724C696E653D3D3D742972657475726E3B72657475726E20746869732E5F73686F77456E64466F724C696E653D742C766F696420746869732E5F72656E646572';
wwv_flow_imp.g_varchar2_table(30686) := '537469636B795363726F6C6C28297D6E756C6C213D3D746869732E5F73686F77456E64466F724C696E65262628746869732E5F73686F77456E64466F724C696E653D6E756C6C2C746869732E5F72656E646572537469636B795363726F6C6C2829297D29';
wwv_flow_imp.g_varchar2_table(30687) := '29292C746869732E5F726567697374657228627328692C61722E4D4F5553455F4C454156452C28653D3E7B6E756C6C213D3D746869732E5F73686F77456E64466F724C696E65262628746869732E5F73686F77456E64466F724C696E653D6E756C6C2C74';
wwv_flow_imp.g_varchar2_table(30688) := '6869732E5F72656E646572537469636B795363726F6C6C2829297D2929292C746869732E5F726567697374657228742E6F6E4D6F7573654D6F76654F7252656C6576616E744B6579446F776E2828285B742C695D293D3E7B636F6E7374206F3D6E287429';
wwv_flow_imp.g_varchar2_table(30689) := '3B696628216F7C7C21742E686173547269676765724D6F6469666965727C7C21746869732E5F656469746F722E6861734D6F64656C28292972657475726E20766F696420652E636C65617228293B636F6E73747B72616E67653A732C74657874456C656D';
wwv_flow_imp.g_varchar2_table(30690) := '656E743A727D3D6F3B696628732E657175616C7352616E676528746869732E5F737469636B7952616E676550726F6A65637465644F6E456469746F7229297B69662822756E6465726C696E65223D3D3D722E7374796C652E746578744465636F72617469';
wwv_flow_imp.g_varchar2_table(30691) := '6F6E2972657475726E7D656C736520746869732E5F737469636B7952616E676550726F6A65637465644F6E456469746F723D732C652E636C65617228293B636F6E737420613D6E6577204E743B6C6574206C3B652E616464287274282828293D3E612E64';
wwv_flow_imp.g_varchar2_table(30692) := '6973706F7365282130292929292C535128746869732E5F6C616E67756167654665617475726573536572766963652E646566696E6974696F6E50726F76696465722C746869732E5F656469746F722E6765744D6F64656C28292C6E6577206D6328732E73';
wwv_flow_imp.g_varchar2_table(30693) := '746172744C696E654E756D6265722C732E7374617274436F6C756D6E2B31292C612E746F6B656E292E7468656E2828743D3E7B69662821612E746F6B656E2E697343616E63656C6C6174696F6E5265717565737465642969662830213D3D742E6C656E67';
wwv_flow_imp.g_varchar2_table(30694) := '7468297B746869732E5F63616E646964617465446566696E6974696F6E734C656E6774683D742E6C656E6774683B636F6E7374206E3D723B6C213D3D6E3F28652E636C65617228292C6C3D6E2C6C2E7374796C652E746578744465636F726174696F6E3D';
wwv_flow_imp.g_varchar2_table(30695) := '22756E6465726C696E65222C652E616464287274282828293D3E7B6C2E7374796C652E746578744465636F726174696F6E3D226E6F6E65227D292929293A6C7C7C286C3D6E2C6C2E7374796C652E746578744465636F726174696F6E3D22756E6465726C';
wwv_flow_imp.g_varchar2_table(30696) := '696E65222C652E616464287274282828293D3E7B6C2E7374796C652E746578744465636F726174696F6E3D226E6F6E65227D292929297D656C736520652E636C65617228297D29297D2929292C746869732E5F726567697374657228742E6F6E43616E63';
wwv_flow_imp.g_varchar2_table(30697) := '656C282828293D3E7B652E636C65617228297D2929292C746869732E5F726567697374657228742E6F6E4578656375746528286173796E6320653D3E7B6966283132213D3D652E7461726765742E747970657C7C652E7461726765742E64657461696C21';
wwv_flow_imp.g_varchar2_table(30698) := '3D3D746869732E5F737469636B795363726F6C6C5769646765742E676574496428292972657475726E3B636F6E737420743D746869732E5F737469636B795363726F6C6C5769646765742E676574456469746F72506F736974696F6E46726F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(30699) := '28652E7461726765742E656C656D656E74293B742626746869732E5F656469746F722E6861734D6F64656C28292626746869732E5F737469636B7952616E676550726F6A65637465644F6E456469746F72262628746869732E5F63616E64696461746544';
wwv_flow_imp.g_varchar2_table(30700) := '6566696E6974696F6E734C656E6774683E31262628746869732E5F666F63757365642626746869732E5F646973706F7365466F637573537469636B795363726F6C6C53746F726528292C746869732E5F72657665616C506F736974696F6E287B6C696E65';
wwv_flow_imp.g_varchar2_table(30701) := '4E756D6265723A742E6C696E654E756D6265722C636F6C756D6E3A317D29292C746869732E5F696E737461536572766963652E696E766F6B6546756E6374696F6E2855512C652C746869732E5F656469746F722C7B7572693A746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(30702) := '722E6765744D6F64656C28292E7572692C72616E67653A746869732E5F737469636B7952616E676550726F6A65637465644F6E456469746F727D29297D2929297D5F6F6E436F6E746578744D656E7528652C74297B636F6E7374206E3D6E657720476528';
wwv_flow_imp.g_varchar2_table(30703) := '652C74293B746869732E5F636F6E746578744D656E75536572766963652E73686F77436F6E746578744D656E75287B6D656E7549643A4C642E537469636B795363726F6C6C436F6E746578742C676574416E63686F723A28293D3E6E7D297D5F746F6767';
wwv_flow_imp.g_varchar2_table(30704) := '6C65466F6C64696E67526567696F6E466F724C696E652865297B69662821746869732E5F666F6C64696E674D6F64656C7C7C6E756C6C3D3D3D652972657475726E3B636F6E737420743D746869732E5F737469636B795363726F6C6C5769646765742E67';
wwv_flow_imp.g_varchar2_table(30705) := '657452656E6465726564537469636B794C696E652865292C6E3D6E756C6C3D3D743F766F696420303A742E666F6C64696E6749636F6E3B696628216E2972657475726E3B723128746869732E5F666F6C64696E674D6F64656C2C4E756D6265722E4D4158';
wwv_flow_imp.g_varchar2_table(30706) := '5F56414C55452C5B655D292C6E2E6973436F6C6C61707365643D216E2E6973436F6C6C61707365643B636F6E737420693D286E2E6973436F6C6C61707365643F746869732E5F656469746F722E676574546F70466F724C696E654E756D626572286E2E66';
wwv_flow_imp.g_varchar2_table(30707) := '6F6C64696E67456E644C696E65293A746869732E5F656469746F722E676574546F70466F724C696E654E756D626572286E2E666F6C64696E6753746172744C696E6529292D746869732E5F656469746F722E6765744F7074696F6E283637292A742E696E';
wwv_flow_imp.g_varchar2_table(30708) := '6465782B313B746869732E5F656469746F722E7365745363726F6C6C546F702869292C746869732E5F72656E646572537469636B795363726F6C6C2865297D5F72656164436F6E66696775726174696F6E28297B636F6E737420653D746869732E5F6564';
wwv_flow_imp.g_varchar2_table(30709) := '69746F722E6765744F7074696F6E28313135293B69662821313D3D3D652E656E61626C65642972657475726E20746869732E5F656469746F722E72656D6F76654F7665726C617957696467657428746869732E5F737469636B795363726F6C6C57696467';
wwv_flow_imp.g_varchar2_table(30710) := '6574292C746869732E5F73657373696F6E53746F72652E636C65617228292C766F696428746869732E5F656E61626C65643D2131293B652E656E61626C6564262621746869732E5F656E61626C6564262628746869732E5F656469746F722E6164644F76';
wwv_flow_imp.g_varchar2_table(30711) := '65726C617957696467657428746869732E5F737469636B795363726F6C6C576964676574292C746869732E5F73657373696F6E53746F72652E61646428746869732E5F656469746F722E6F6E4469645363726F6C6C4368616E67652828653D3E7B652E73';
wwv_flow_imp.g_varchar2_table(30712) := '63726F6C6C546F704368616E676564262628746869732E5F73686F77456E64466F724C696E653D6E756C6C2C746869732E5F72656E646572537469636B795363726F6C6C2829297D2929292C746869732E5F73657373696F6E53746F72652E6164642874';
wwv_flow_imp.g_varchar2_table(30713) := '6869732E5F656469746F722E6F6E4469644C61796F75744368616E6765282828293D3E746869732E5F6F6E446964526573697A6528292929292C746869732E5F73657373696F6E53746F72652E61646428746869732E5F656469746F722E6F6E44696443';
wwv_flow_imp.g_varchar2_table(30714) := '68616E67654D6F64656C546F6B656E732828653D3E746869732E5F6F6E546F6B656E734368616E67652865292929292C746869732E5F73657373696F6E53746F72652E61646428746869732E5F737469636B794C696E6543616E64696461746550726F76';
wwv_flow_imp.g_varchar2_table(30715) := '696465722E6F6E4469644368616E6765537469636B795363726F6C6C282828293D3E7B746869732E5F73686F77456E64466F724C696E653D6E756C6C2C746869732E5F72656E646572537469636B795363726F6C6C28297D2929292C746869732E5F656E';
wwv_flow_imp.g_varchar2_table(30716) := '61626C65643D2130292C323D3D3D746869732E5F656469746F722E6765744F7074696F6E283638292E72656E646572547970652626746869732E5F73657373696F6E53746F72652E61646428746869732E5F656469746F722E6F6E4469644368616E6765';
wwv_flow_imp.g_varchar2_table(30717) := '437572736F72506F736974696F6E282828293D3E7B746869732E5F73686F77456E64466F724C696E653D6E756C6C2C746869732E5F72656E646572537469636B795363726F6C6C2830297D2929297D5F72656164436F6E66696775726174696F6E436861';
wwv_flow_imp.g_varchar2_table(30718) := '6E67652865297B28652E6861734368616E67656428313135297C7C652E6861734368616E676564283733297C7C652E6861734368616E676564283637297C7C652E6861734368616E67656428313130297C7C652E6861734368616E676564283638292926';
wwv_flow_imp.g_varchar2_table(30719) := '26746869732E5F72656164436F6E66696775726174696F6E28292C652E6861734368616E676564283638292626746869732E5F72656E646572537469636B795363726F6C6C2830297D5F6E656564735570646174652865297B636F6E737420743D746869';
wwv_flow_imp.g_varchar2_table(30720) := '732E5F737469636B795363726F6C6C5769646765742E67657443757272656E744C696E657328293B666F7228636F6E7374206E206F66207429666F7228636F6E73742074206F6620652E72616E676573296966286E3E3D742E66726F6D4C696E654E756D';
wwv_flow_imp.g_varchar2_table(30721) := '62657226266E3C3D742E746F4C696E654E756D6265722972657475726E21303B72657475726E21317D5F6F6E546F6B656E734368616E67652865297B746869732E5F6E656564735570646174652865292626746869732E5F72656E646572537469636B79';
wwv_flow_imp.g_varchar2_table(30722) := '5363726F6C6C2830297D5F6F6E446964526573697A6528297B636F6E737420653D746869732E5F656469746F722E6765744C61796F7574496E666F28292E6865696768742F746869732E5F656469746F722E6765744F7074696F6E283637293B74686973';
wwv_flow_imp.g_varchar2_table(30723) := '2E5F6D6178537469636B794C696E65733D4D6174682E726F756E64282E32352A65297D6173796E63205F72656E646572537469636B795363726F6C6C2865297B76617220742C6E3B636F6E737420693D746869732E5F656469746F722E6765744D6F6465';
wwv_flow_imp.g_varchar2_table(30724) := '6C28293B69662821697C7C692E6973546F6F4C61726765466F72546F6B656E697A6174696F6E28292972657475726E20746869732E5F666F6C64696E674D6F64656C3D6E756C6C2C766F696420746869732E5F737469636B795363726F6C6C5769646765';
wwv_flow_imp.g_varchar2_table(30725) := '742E736574537461746528766F696420302C6E756C6C293B636F6E7374206F3D746869732E5F737469636B794C696E6543616E64696461746550726F76696465722E67657456657273696F6E496428293B696628766F696420303D3D3D6F7C7C6F3D3D3D';
wwv_flow_imp.g_varchar2_table(30726) := '692E67657456657273696F6E4964282929696628746869732E5F666F6C64696E674D6F64656C3D6E756C6C213D3D286E3D6177616974286E756C6C3D3D3D28743D41312E67657428746869732E5F656469746F7229297C7C766F696420303D3D3D743F76';
wwv_flow_imp.g_varchar2_table(30727) := '6F696420303A742E676574466F6C64696E674D6F64656C282929292626766F69642030213D3D6E3F6E3A6E756C6C2C746869732E5F77696467657453746174653D746869732E66696E645363726F6C6C576964676574537461746528292C746869732E5F';
wwv_flow_imp.g_varchar2_table(30728) := '737469636B795363726F6C6C56697369626C65436F6E746578744B65792E736574282128303D3D3D746869732E5F77696467657453746174652E73746172744C696E654E756D626572732E6C656E67746829292C746869732E5F666F6375736564296966';
wwv_flow_imp.g_varchar2_table(30729) := '282D313D3D3D746869732E5F666F6375736564537469636B79456C656D656E74496E64657829746869732E5F737469636B795363726F6C6C5769646765742E736574537461746528746869732E5F77696467657453746174652C746869732E5F666F6C64';
wwv_flow_imp.g_varchar2_table(30730) := '696E674D6F64656C2C65292C746869732E5F666F6375736564537469636B79456C656D656E74496E6465783D746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572436F756E742D312C2D31213D3D746869732E5F666F';
wwv_flow_imp.g_varchar2_table(30731) := '6375736564537469636B79456C656D656E74496E6465782626746869732E5F737469636B795363726F6C6C5769646765742E666F6375734C696E6557697468496E64657828746869732E5F666F6375736564537469636B79456C656D656E74496E646578';
wwv_flow_imp.g_varchar2_table(30732) := '293B656C73657B636F6E737420743D746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572735B746869732E5F666F6375736564537469636B79456C656D656E74496E6465785D3B746869732E5F737469636B79536372';
wwv_flow_imp.g_varchar2_table(30733) := '6F6C6C5769646765742E736574537461746528746869732E5F77696467657453746174652C746869732E5F666F6C64696E674D6F64656C2C65292C303D3D3D746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572436F';
wwv_flow_imp.g_varchar2_table(30734) := '756E743F746869732E5F666F6375736564537469636B79456C656D656E74496E6465783D2D313A28746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572732E696E636C756465732874297C7C28746869732E5F666F63';
wwv_flow_imp.g_varchar2_table(30735) := '75736564537469636B79456C656D656E74496E6465783D746869732E5F737469636B795363726F6C6C5769646765742E6C696E654E756D626572436F756E742D31292C746869732E5F737469636B795363726F6C6C5769646765742E666F6375734C696E';
wwv_flow_imp.g_varchar2_table(30736) := '6557697468496E64657828746869732E5F666F6375736564537469636B79456C656D656E74496E64657829297D656C736520746869732E5F737469636B795363726F6C6C5769646765742E736574537461746528746869732E5F77696467657453746174';
wwv_flow_imp.g_varchar2_table(30737) := '652C746869732E5F666F6C64696E674D6F64656C2C65297D66696E645363726F6C6C576964676574537461746528297B636F6E737420653D746869732E5F656469746F722E6765744F7074696F6E283637292C743D4D6174682E6D696E28746869732E5F';
wwv_flow_imp.g_varchar2_table(30738) := '6D6178537469636B794C696E65732C746869732E5F656469746F722E6765744F7074696F6E28313135292E6D61784C696E65436F756E74292C6E3D746869732E5F656469746F722E6765745363726F6C6C546F7028293B6C657420693D303B636F6E7374';
wwv_flow_imp.g_varchar2_table(30739) := '206F3D5B5D2C733D5B5D2C723D746869732E5F656469746F722E67657456697369626C6552616E67657328293B69662830213D3D722E6C656E677468297B636F6E737420613D6E657720573928725B305D2E73746172744C696E654E756D6265722C725B';
wwv_flow_imp.g_varchar2_table(30740) := '722E6C656E6774682D315D2E656E644C696E654E756D626572292C6C3D746869732E5F737469636B794C696E6543616E64696461746550726F76696465722E67657443616E646964617465537469636B794C696E6573496E74657273656374696E672861';
wwv_flow_imp.g_varchar2_table(30741) := '293B666F7228636F6E73742072206F66206C297B636F6E737420613D722E73746172744C696E654E756D6265722C6C3D722E656E644C696E654E756D6265722C633D722E6E657374696E6744657074683B6966286C2D613E30297B636F6E737420723D28';
wwv_flow_imp.g_varchar2_table(30742) := '632D31292A652C643D632A652C683D746869732E5F656469746F722E676574426F74746F6D466F724C696E654E756D6265722861292D6E2C753D746869732E5F656469746F722E676574546F70466F724C696E654E756D626572286C292D6E2C703D7468';
wwv_flow_imp.g_varchar2_table(30743) := '69732E5F656469746F722E676574426F74746F6D466F724C696E654E756D626572286C292D6E3B696628723E752626723C3D70297B6F2E707573682861292C732E70757368286C2B31292C693D702D643B627265616B7D696628643E682626643C3D7026';
wwv_flow_imp.g_varchar2_table(30744) := '26286F2E707573682861292C732E70757368286C2B3129292C6F2E6C656E6774683D3D3D7429627265616B7D7D7D72657475726E20746869732E5F656E644C696E654E756D626572733D732C6E6577205039286F2C732C692C746869732E5F73686F7745';
wwv_flow_imp.g_varchar2_table(30745) := '6E64466F724C696E65297D646973706F736528297B73757065722E646973706F736528292C746869732E5F73657373696F6E53746F72652E646973706F736528297D7D3B7265652E49443D2273746F72652E636F6E747269622E737469636B795363726F';
wwv_flow_imp.g_varchar2_table(30746) := '6C6C436F6E74726F6C6C6572222C7265653D6F65653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F';
wwv_flow_imp.g_varchar2_table(30747) := '706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465';
wwv_flow_imp.g_varchar2_table(30748) := '636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72';
wwv_flow_imp.g_varchar2_table(30749) := '657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B73656528312C7145292C73656528322C7878292C73656528332C7563292C73656528342C6567292C73656528352C6456292C736565';
wwv_flow_imp.g_varchar2_table(30750) := '28362C6364295D2C726565293B636F6E7374206165653D3130303B4A64287265652E49442C7265652C31292C506428636C61737320657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E61637469';
wwv_flow_imp.g_varchar2_table(30751) := '6F6E2E746F67676C65537469636B795363726F6C6C222C7469746C653A7B2E2E2E5F28302C22546F67676C6520456469746F7220537469636B79205363726F6C6C22292C6D6E656D6F6E69635469746C653A6228302C222626546F67676C652045646974';
wwv_flow_imp.g_varchar2_table(30752) := '6F7220537469636B79205363726F6C6C22297D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C22546F67676C652F656E61626C652074686520656469746F7220737469636B79207363726F6C6C2077686963682073686F7773207468';
wwv_flow_imp.g_varchar2_table(30753) := '65206E65737465642073636F7065732061742074686520746F70206F66207468652076696577706F727422297D2C63617465676F72793A4D392E566965772C746F67676C65643A7B636F6E646974696F6E3A57632E657175616C732822636F6E6669672E';
wwv_flow_imp.g_varchar2_table(30754) := '656469746F722E737469636B795363726F6C6C2E656E61626C6564222C2130292C7469746C653A6228302C22537469636B79205363726F6C6C22292C6D6E656D6F6E69635469746C653A6228302C222626537469636B79205363726F6C6C22297D2C6D65';
wwv_flow_imp.g_varchar2_table(30755) := '6E753A5B7B69643A4C642E436F6D6D616E6450616C657474657D2C7B69643A4C642E4D656E75626172417070656172616E63654D656E752C67726F75703A22345F656469746F72222C6F726465723A337D2C7B69643A4C642E537469636B795363726F6C';
wwv_flow_imp.g_varchar2_table(30756) := '6C436F6E746578747D5D7D297D6173796E632072756E2865297B636F6E737420743D652E676574286670292C6E3D21742E67657456616C75652822656469746F722E737469636B795363726F6C6C2E656E61626C656422293B72657475726E20742E7570';
wwv_flow_imp.g_varchar2_table(30757) := '6461746556616C75652822656469746F722E737469636B795363726F6C6C2E656E61626C6564222C6E297D7D292C506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E6163';
wwv_flow_imp.g_varchar2_table(30758) := '74696F6E2E666F637573537469636B795363726F6C6C222C7469746C653A7B2E2E2E5F28302C22466F637573206F6E2074686520656469746F7220737469636B79207363726F6C6C22292C6D6E656D6F6E69635469746C653A6228302C222626466F6375';
wwv_flow_imp.g_varchar2_table(30759) := '7320537469636B79205363726F6C6C22297D2C707265636F6E646974696F6E3A57632E616E642857632E6861732822636F6E6669672E656469746F722E737469636B795363726F6C6C2E656E61626C656422292C6C682E737469636B795363726F6C6C56';
wwv_flow_imp.g_varchar2_table(30760) := '697369626C65292C6D656E753A5B7B69643A4C642E436F6D6D616E6450616C657474657D5D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B6E756C6C3D3D3D286E3D7265652E676574287429297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(30761) := '6E7C7C6E2E666F63757328297D7D292C506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73656C65637450726576696F7573537469636B795363726F6C';
wwv_flow_imp.g_varchar2_table(30762) := '6C4C696E65222C7469746C653A5F28302C2253656C656374207468652070726576696F757320737469636B79207363726F6C6C206C696E6522292C707265636F6E646974696F6E3A6C682E737469636B795363726F6C6C466F63757365642E6973457175';
wwv_flow_imp.g_varchar2_table(30763) := '616C546F282130292C6B657962696E64696E673A7B7765696768743A6165652C7072696D6172793A31367D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B6E756C6C3D3D3D286E3D7265652E676574287429297C7C766F69';
wwv_flow_imp.g_varchar2_table(30764) := '6420303D3D3D6E7C7C6E2E666F63757350726576696F757328297D7D292C506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E73656C6563744E65787453';
wwv_flow_imp.g_varchar2_table(30765) := '7469636B795363726F6C6C4C696E65222C7469746C653A5F28302C2253656C65637420746865206E65787420656469746F7220737469636B79207363726F6C6C206C696E6522292C707265636F6E646974696F6E3A6C682E737469636B795363726F6C6C';
wwv_flow_imp.g_varchar2_table(30766) := '466F63757365642E6973457175616C546F282130292C6B657962696E64696E673A7B7765696768743A6165652C7072696D6172793A31387D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B6E756C6C3D3D3D286E3D726565';
wwv_flow_imp.g_varchar2_table(30767) := '2E676574287429297C7C766F696420303D3D3D6E7C7C6E2E666F6375734E65787428297D7D292C506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E676F';
wwv_flow_imp.g_varchar2_table(30768) := '546F466F6375736564537469636B795363726F6C6C4C696E65222C7469746C653A5F28302C22476F20746F2074686520666F637573656420737469636B79207363726F6C6C206C696E6522292C707265636F6E646974696F6E3A6C682E737469636B7953';
wwv_flow_imp.g_varchar2_table(30769) := '63726F6C6C466F63757365642E6973457175616C546F282130292C6B657962696E64696E673A7B7765696768743A6165652C7072696D6172793A337D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B6E756C6C3D3D3D286E';
wwv_flow_imp.g_varchar2_table(30770) := '3D7265652E676574287429297C7C766F696420303D3D3D6E7C7C6E2E676F546F466F637573656428297D7D292C506428636C61737320657874656E64732047647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374';
wwv_flow_imp.g_varchar2_table(30771) := '696F6E2E73656C656374456469746F72222C7469746C653A5F28302C2253656C65637420456469746F7222292C707265636F6E646974696F6E3A6C682E737469636B795363726F6C6C466F63757365642E6973457175616C546F282130292C6B65796269';
wwv_flow_imp.g_varchar2_table(30772) := '6E64696E673A7B7765696768743A6165652C7072696D6172793A397D7D297D72756E456469746F72436F6D6D616E6428652C74297B766172206E3B6E756C6C3D3D3D286E3D7265652E676574287429297C7C766F696420303D3D3D6E7C7C6E2E73656C65';
wwv_flow_imp.g_varchar2_table(30773) := '6374456469746F7228297D7D293B766172206C65653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F';
wwv_flow_imp.g_varchar2_table(30774) := '706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465';
wwv_flow_imp.g_varchar2_table(30775) := '636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72';
wwv_flow_imp.g_varchar2_table(30776) := '657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C6365653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C6173';
wwv_flow_imp.g_varchar2_table(30777) := '73206465657B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E72616E67653D652C746869732E696E73657274546578743D742C746869732E66696C746572546578743D6E2C746869732E6164646974696F6E616C5465787445';
wwv_flow_imp.g_varchar2_table(30778) := '646974733D692C746869732E636F6D6D616E643D6F2C746869732E636F6D706C6574696F6E3D737D7D6C6574206865653D636C61737320657874656E64732064747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B7375706572286F2E64';
wwv_flow_imp.g_varchar2_table(30779) := '6973706F7361626C65292C746869732E6D6F64656C3D652C746869732E6C696E653D742C746869732E776F72643D6E2C746869732E636F6D706C6574696F6E4D6F64656C3D692C746869732E5F737567676573744D656D6F7279536572766963653D737D';
wwv_flow_imp.g_varchar2_table(30780) := '63616E426552657573656428652C742C6E297B72657475726E20746869732E6D6F64656C3D3D3D652626746869732E6C696E653D3D3D742626746869732E776F72642E776F72642E6C656E6774683E302626746869732E776F72642E7374617274436F6C';
wwv_flow_imp.g_varchar2_table(30781) := '756D6E3D3D3D6E2E7374617274436F6C756D6E2626746869732E776F72642E656E64436F6C756D6E3C6E2E656E64436F6C756D6E2626303D3D3D746869732E636F6D706C6574696F6E4D6F64656C2E676574496E636F6D706C65746550726F7669646572';
wwv_flow_imp.g_varchar2_table(30782) := '28292E73697A657D676574206974656D7328297B76617220653B636F6E737420743D5B5D2C7B6974656D733A6E7D3D746869732E636F6D706C6574696F6E4D6F64656C2C693D746869732E5F737567676573744D656D6F7279536572766963652E73656C';
wwv_flow_imp.g_varchar2_table(30783) := '65637428746869732E6D6F64656C2C7B6C696E654E756D6265723A746869732E6C696E652C636F6C756D6E3A746869732E776F72642E656E64436F6C756D6E2B746869732E636F6D706C6574696F6E4D6F64656C2E6C696E65436F6E746578742E636861';
wwv_flow_imp.g_varchar2_table(30784) := '726163746572436F756E7444656C74617D2C6E292C6F3D5A652E736C696365286E2C69292C733D5A652E736C696365286E2C302C69293B6C657420723D353B666F7228636F6E7374206E206F66205A652E636F6E636174286F2C7329297B6966286E2E73';
wwv_flow_imp.g_varchar2_table(30785) := '636F72653D3D3D736C2E44656661756C7429636F6E74696E75653B636F6E737420693D6E6577207268286E2E6564697453746172742E6C696E654E756D6265722C6E2E6564697453746172742E636F6C756D6E2C6E2E65646974496E73657274456E642E';
wwv_flow_imp.g_varchar2_table(30786) := '6C696E654E756D6265722C6E2E65646974496E73657274456E642E636F6C756D6E2B746869732E636F6D706C6574696F6E4D6F64656C2E6C696E65436F6E746578742E636861726163746572436F756E7444656C7461292C6F3D6E2E636F6D706C657469';
wwv_flow_imp.g_varchar2_table(30787) := '6F6E2E696E736572745465787452756C6573262634266E2E636F6D706C6574696F6E2E696E736572745465787452756C65733F7B736E69707065743A6E2E636F6D706C6574696F6E2E696E73657274546578747D3A6E2E636F6D706C6574696F6E2E696E';
wwv_flow_imp.g_varchar2_table(30788) := '73657274546578743B742E70757368286E65772064656528692C6F2C6E756C6C213D3D28653D6E2E66696C746572546578744C6F77292626766F69642030213D3D653F653A6E2E6C6162656C4C6F772C6E2E636F6D706C6574696F6E2E6164646974696F';
wwv_flow_imp.g_varchar2_table(30789) := '6E616C5465787445646974732C6E2E636F6D706C6574696F6E2E636F6D6D616E642C6E29292C722D2D203E3D3026266E2E7265736F6C7665284D742E4E6F6E65297D72657475726E20747D7D3B6865653D6C6565285B63656528352C2435295D2C686565';
wwv_flow_imp.g_varchar2_table(30790) := '293B6C6574207565653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F6C616E677561676546656174757265536572766963653D652C746869732E5F636C6970626F61';
wwv_flow_imp.g_varchar2_table(30791) := '7264536572766963653D742C746869732E5F737567676573744D656D6F7279536572766963653D6E2C746869732E5F656469746F72536572766963653D692C746869732E5F73746F72652E61646428652E696E6C696E65436F6D706C6574696F6E735072';
wwv_flow_imp.g_varchar2_table(30792) := '6F76696465722E726567697374657228222A222C7468697329297D6173796E632070726F76696465496E6C696E65436F6D706C6574696F6E7328652C742C6E2C69297B766172206F3B6966286E2E73656C656374656453756767657374696F6E496E666F';
wwv_flow_imp.g_varchar2_table(30793) := '2972657475726E3B6C657420733B666F7228636F6E73742074206F6620746869732E5F656469746F72536572766963652E6C697374436F6465456469746F7273282929696628742E6765744D6F64656C28293D3D3D65297B733D743B627265616B7D6966';
wwv_flow_imp.g_varchar2_table(30794) := '2821732972657475726E3B636F6E737420723D732E6765744F7074696F6E283839293B69662867352E6973416C6C4F66662872292972657475726E3B652E746F6B656E697A6174696F6E2E746F6B656E697A654966436865617028742E6C696E654E756D';
wwv_flow_imp.g_varchar2_table(30795) := '626572293B636F6E737420613D652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E7328742E6C696E654E756D626572292C6C3D612E6765745374616E64617264546F6B656E5479706528612E66696E64546F6B656E496E64657841744F';
wwv_flow_imp.g_varchar2_table(30796) := '6666736574284D6174682E6D617828742E636F6C756D6E2D312D312C302929293B69662822696E6C696E6522213D3D67352E76616C7565466F7228722C6C292972657475726E3B6C657420632C642C683D652E676574576F72644174506F736974696F6E';
wwv_flow_imp.g_varchar2_table(30797) := '2874293B696628286E756C6C3D3D683F766F696420303A682E776F7264297C7C28633D746869732E5F67657454726967676572436861726163746572496E666F28652C7429292C21286E756C6C3D3D683F766F696420303A682E776F7264292626216329';
wwv_flow_imp.g_varchar2_table(30798) := '72657475726E3B696628687C7C28683D652E676574576F7264556E74696C506F736974696F6E287429292C682E656E64436F6C756D6E213D3D742E636F6C756D6E2972657475726E3B636F6E737420753D652E67657456616C7565496E52616E6765286E';
wwv_flow_imp.g_varchar2_table(30799) := '657720726828742E6C696E654E756D6265722C312C742E6C696E654E756D6265722C742E636F6C756D6E29293B69662821632626286E756C6C3D3D3D286F3D746869732E5F6C617374526573756C74297C7C766F696420303D3D3D6F3F766F696420303A';
wwv_flow_imp.g_varchar2_table(30800) := '6F2E63616E426552657573656428652C742E6C696E654E756D6265722C682929297B636F6E737420653D6E6577204A3528752C742E636F6C756D6E2D746869732E5F6C617374526573756C742E776F72642E656E64436F6C756D6E293B746869732E5F6C';
wwv_flow_imp.g_varchar2_table(30801) := '617374526573756C742E636F6D706C6574696F6E4D6F64656C2E6C696E65436F6E746578743D652C746869732E5F6C617374526573756C742E6163717569726528292C643D746869732E5F6C617374526573756C747D656C73657B636F6E7374206E3D61';
wwv_flow_imp.g_varchar2_table(30802) := '7761697420683528746869732E5F6C616E677561676546656174757265536572766963652E636F6D706C6574696F6E50726F76696465722C652C742C6E657720633528766F696420302C6F342E6372656174655375676765737446696C7465722873292E';
wwv_flow_imp.g_varchar2_table(30803) := '6974656D4B696E642C6E756C6C3D3D633F766F696420303A632E70726F766964657273292C6326267B747269676765724B696E643A312C747269676765724368617261637465723A632E63687D2C69293B6C6574206F3B6E2E6E65656473436C6970626F';
wwv_flow_imp.g_varchar2_table(30804) := '6172642626286F3D617761697420746869732E5F636C6970626F617264536572766963652E72656164546578742829293B636F6E737420723D6E6577206534286E2E6974656D732C742E636F6C756D6E2C6E6577204A3528752C30292C58352E4E6F6E65';
wwv_flow_imp.g_varchar2_table(30805) := '2C732E6765744F7074696F6E28313138292C732E6765744F7074696F6E28313132292C7B626F6F737446756C6C4D617463683A21312C66697273744D6174636843616E42655765616B3A21317D2C6F293B643D6E65772068656528652C742E6C696E654E';
wwv_flow_imp.g_varchar2_table(30806) := '756D6265722C682C722C6E2C746869732E5F737567676573744D656D6F727953657276696365297D72657475726E20746869732E5F6C617374526573756C743D642C647D68616E646C654974656D44696453686F7728652C74297B742E636F6D706C6574';
wwv_flow_imp.g_varchar2_table(30807) := '696F6E2E7265736F6C7665284D742E4E6F6E65297D66726565496E6C696E65436F6D706C6574696F6E732865297B652E72656C6561736528297D5F67657454726967676572436861726163746572496E666F28652C74297B766172206E3B636F6E737420';
wwv_flow_imp.g_varchar2_table(30808) := '693D652E67657456616C7565496E52616E67652872682E66726F6D506F736974696F6E73287B6C696E654E756D6265723A742E6C696E654E756D6265722C636F6C756D6E3A742E636F6C756D6E2D317D2C7429292C6F3D6E6577205365743B666F722863';
wwv_flow_imp.g_varchar2_table(30809) := '6F6E73742074206F6620746869732E5F6C616E677561676546656174757265536572766963652E636F6D706C6574696F6E50726F76696465722E616C6C28652929286E756C6C3D3D3D286E3D742E7472696767657243686172616374657273297C7C766F';
wwv_flow_imp.g_varchar2_table(30810) := '696420303D3D3D6E3F766F696420303A6E2E696E636C756465732869292926266F2E6164642874293B69662830213D3D6F2E73697A652972657475726E7B70726F7669646572733A6F2C63683A697D7D7D3B7565653D6C6565285B63656528302C787829';
wwv_flow_imp.g_varchar2_table(30811) := '2C63656528312C7945292C63656528322C2435292C63656528332C6763295D2C756565292C725728756565293B636C617373207065657B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E5F7061727365645468656D6552756C6542';
wwv_flow_imp.g_varchar2_table(30812) := '72616E643D766F696420302C746869732E746F6B656E3D652C746869732E696E6465783D742C746869732E666F6E745374796C653D6E2C746869732E666F726567726F756E643D692C746869732E6261636B67726F756E643D6F7D7D636F6E7374206765';
wwv_flow_imp.g_varchar2_table(30813) := '653D2F5E233F285B302D39412D46612D665D7B367D29285B302D39412D46612D665D7B327D293F242F3B636C617373206D65657B636F6E7374727563746F7228297B746869732E5F6C617374436F6C6F7249643D302C746869732E5F696432636F6C6F72';
wwv_flow_imp.g_varchar2_table(30814) := '3D5B5D2C746869732E5F636F6C6F723269643D6E6577204D61707D67657449642865297B6966286E756C6C3D3D3D652972657475726E20303B636F6E737420743D652E6D6174636828676565293B6966282174297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(30815) := '22496C6C6567616C2076616C756520666F7220746F6B656E20636F6C6F723A20222B65293B653D745B315D2E746F55707065724361736528293B6C6574206E3D746869732E5F636F6C6F723269642E6765742865293B72657475726E206E7C7C286E3D2B';
wwv_flow_imp.g_varchar2_table(30816) := '2B746869732E5F6C617374436F6C6F7249642C746869732E5F636F6C6F723269642E73657428652C6E292C746869732E5F696432636F6C6F725B6E5D3D68752E66726F6D486578282223222B65292C6E297D676574436F6C6F724D617028297B72657475';
wwv_flow_imp.g_varchar2_table(30817) := '726E20746869732E5F696432636F6C6F722E736C6963652830297D7D636C617373206665657B7374617469632063726561746546726F6D526177546F6B656E5468656D6528652C74297B72657475726E20746869732E63726561746546726F6D50617273';
wwv_flow_imp.g_varchar2_table(30818) := '6564546F6B656E5468656D652866756E6374696F6E2865297B69662821657C7C2141727261792E697341727261792865292972657475726E5B5D3B636F6E737420743D5B5D3B6C6574206E3D303B666F72286C657420693D302C6F3D652E6C656E677468';
wwv_flow_imp.g_varchar2_table(30819) := '3B693C6F3B692B2B297B636F6E7374206F3D655B695D3B6C657420733D2D313B69662822737472696E67223D3D747970656F66206F2E666F6E745374796C65297B733D303B636F6E737420653D6F2E666F6E745374796C652E73706C697428222022293B';
wwv_flow_imp.g_varchar2_table(30820) := '666F72286C657420743D302C6E3D652E6C656E6774683B743C6E3B742B2B2973776974636828655B745D297B63617365226974616C6963223A737C3D313B627265616B3B6361736522626F6C64223A737C3D323B627265616B3B6361736522756E646572';
wwv_flow_imp.g_varchar2_table(30821) := '6C696E65223A737C3D343B627265616B3B6361736522737472696B657468726F756768223A737C3D387D7D6C657420723D6E756C6C3B22737472696E67223D3D747970656F66206F2E666F726567726F756E64262628723D6F2E666F726567726F756E64';
wwv_flow_imp.g_varchar2_table(30822) := '293B6C657420613D6E756C6C3B22737472696E67223D3D747970656F66206F2E6261636B67726F756E64262628613D6F2E6261636B67726F756E64292C745B6E2B2B5D3D6E657720706565286F2E746F6B656E7C7C22222C692C732C722C61297D726574';
wwv_flow_imp.g_varchar2_table(30823) := '75726E20747D2865292C74297D7374617469632063726561746546726F6D506172736564546F6B656E5468656D6528652C74297B72657475726E2066756E6374696F6E28652C74297B652E736F7274282828652C74293D3E7B636F6E7374206E3D66756E';
wwv_flow_imp.g_varchar2_table(30824) := '6374696F6E28652C74297B72657475726E20653C743F2D313A653E743F313A307D28652E746F6B656E2C742E746F6B656E293B72657475726E2030213D3D6E3F6E3A652E696E6465782D742E696E6465787D29293B6C6574206E3D302C693D2230303030';
wwv_flow_imp.g_varchar2_table(30825) := '3030222C6F3D22666666666666223B666F72283B652E6C656E6774683E3D31262622223D3D3D655B305D2E746F6B656E3B297B636F6E737420743D652E736869667428293B2D31213D3D742E666F6E745374796C652626286E3D742E666F6E745374796C';
wwv_flow_imp.g_varchar2_table(30826) := '65292C6E756C6C213D3D742E666F726567726F756E64262628693D742E666F726567726F756E64292C6E756C6C213D3D742E6261636B67726F756E642626286F3D742E6261636B67726F756E64297D636F6E737420733D6E6577206D65653B666F722863';
wwv_flow_imp.g_varchar2_table(30827) := '6F6E73742065206F66207429732E67657449642865293B636F6E737420723D732E67657449642869292C613D732E6765744964286F292C6C3D6E657720626565286E2C722C61292C633D6E6577205F6565286C293B666F72286C657420743D302C6E3D65';
wwv_flow_imp.g_varchar2_table(30828) := '2E6C656E6774683B743C6E3B742B2B297B636F6E7374206E3D655B745D3B632E696E73657274286E2E746F6B656E2C6E2E666F6E745374796C652C732E6765744964286E2E666F726567726F756E64292C732E6765744964286E2E6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(30829) := '6429297D72657475726E206E65772066656528732C63297D28652C74297D636F6E7374727563746F7228652C74297B746869732E5F636F6C6F724D61703D652C746869732E5F726F6F743D742C746869732E5F63616368653D6E6577204D61707D676574';
wwv_flow_imp.g_varchar2_table(30830) := '436F6C6F724D617028297B72657475726E20746869732E5F636F6C6F724D61702E676574436F6C6F724D617028297D5F6D617463682865297B72657475726E20746869732E5F726F6F742E6D617463682865297D6D6174636828652C74297B6C6574206E';
wwv_flow_imp.g_varchar2_table(30831) := '3D746869732E5F63616368652E6765742874293B696628766F696420303D3D3D6E297B636F6E737420653D746869732E5F6D617463682874292C693D66756E6374696F6E2865297B636F6E737420743D652E6D6174636828766565293B69662821742972';
wwv_flow_imp.g_varchar2_table(30832) := '657475726E20303B73776974636828745B315D297B6361736522636F6D6D656E74223A72657475726E20313B6361736522737472696E67223A72657475726E20323B63617365227265676578223A6361736522726567657870223A72657475726E20337D';
wwv_flow_imp.g_varchar2_table(30833) := '7468726F77206E6577204572726F722822556E6578706563746564206D6174636820666F72207374616E6461726420746F6B656E20747970652122297D2874293B6E3D28652E6D657461646174617C693C3C38293E3E3E302C746869732E5F6361636865';
wwv_flow_imp.g_varchar2_table(30834) := '2E73657428742C6E297D72657475726E286E7C65293E3E3E307D7D636F6E7374207665653D2F5C6228636F6D6D656E747C737472696E677C72656765787C726567657870295C622F3B636C617373206265657B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(30835) := '297B746869732E5F7468656D6554726965456C656D656E7452756C654272616E643D766F696420302C746869732E5F666F6E745374796C653D652C746869732E5F666F726567726F756E643D742C746869732E5F6261636B67726F756E643D6E2C746869';
wwv_flow_imp.g_varchar2_table(30836) := '732E6D657461646174613D28746869732E5F666F6E745374796C653C3C31317C746869732E5F666F726567726F756E643C3C31357C746869732E5F6261636B67726F756E643C3C3234293E3E3E307D636C6F6E6528297B72657475726E206E6577206265';
wwv_flow_imp.g_varchar2_table(30837) := '6528746869732E5F666F6E745374796C652C746869732E5F666F726567726F756E642C746869732E5F6261636B67726F756E64297D6163636570744F766572777269746528652C742C6E297B2D31213D3D65262628746869732E5F666F6E745374796C65';
wwv_flow_imp.g_varchar2_table(30838) := '3D65292C30213D3D74262628746869732E5F666F726567726F756E643D74292C30213D3D6E262628746869732E5F6261636B67726F756E643D6E292C746869732E6D657461646174613D28746869732E5F666F6E745374796C653C3C31317C746869732E';
wwv_flow_imp.g_varchar2_table(30839) := '5F666F726567726F756E643C3C31357C746869732E5F6261636B67726F756E643C3C3234293E3E3E307D7D636C617373205F65657B636F6E7374727563746F722865297B746869732E5F7468656D6554726965456C656D656E744272616E643D766F6964';
wwv_flow_imp.g_varchar2_table(30840) := '20302C746869732E5F6D61696E52756C653D652C746869732E5F6368696C6472656E3D6E6577204D61707D6D617463682865297B69662822223D3D3D652972657475726E20746869732E5F6D61696E52756C653B636F6E737420743D652E696E6465784F';
wwv_flow_imp.g_varchar2_table(30841) := '6628222E22293B6C6574206E2C693B2D313D3D3D743F286E3D652C693D2222293A286E3D652E737562737472696E6728302C74292C693D652E737562737472696E6728742B3129293B636F6E7374206F3D746869732E5F6368696C6472656E2E67657428';
wwv_flow_imp.g_varchar2_table(30842) := '6E293B72657475726E20766F69642030213D3D6F3F6F2E6D617463682869293A746869732E5F6D61696E52756C657D696E7365727428652C742C6E2C69297B69662822223D3D3D652972657475726E20766F696420746869732E5F6D61696E52756C652E';
wwv_flow_imp.g_varchar2_table(30843) := '6163636570744F766572777269746528742C6E2C69293B636F6E7374206F3D652E696E6465784F6628222E22293B6C657420732C723B2D313D3D3D6F3F28733D652C723D2222293A28733D652E737562737472696E6728302C6F292C723D652E73756273';
wwv_flow_imp.g_varchar2_table(30844) := '7472696E67286F2B3129293B6C657420613D746869732E5F6368696C6472656E2E6765742873293B766F696420303D3D3D61262628613D6E6577205F656528746869732E5F6D61696E52756C652E636C6F6E652829292C746869732E5F6368696C647265';
wwv_flow_imp.g_varchar2_table(30845) := '6E2E73657428732C6129292C612E696E7365727428722C742C6E2C69297D7D636F6E7374207965653D7B626173653A227673222C696E68657269743A21312C72756C65733A5B7B746F6B656E3A22222C666F726567726F756E643A22303030303030222C';
wwv_flow_imp.g_varchar2_table(30846) := '6261636B67726F756E643A22666666666665227D2C7B746F6B656E3A22696E76616C6964222C666F726567726F756E643A22636433313331227D2C7B746F6B656E3A22656D706861736973222C666F6E745374796C653A226974616C6963227D2C7B746F';
wwv_flow_imp.g_varchar2_table(30847) := '6B656E3A227374726F6E67222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A227661726961626C65222C666F726567726F756E643A22303031313838227D2C7B746F6B656E3A227661726961626C652E707265646566696E6564222C66';
wwv_flow_imp.g_varchar2_table(30848) := '6F726567726F756E643A22343836344141227D2C7B746F6B656E3A22636F6E7374616E74222C666F726567726F756E643A22646430303030227D2C7B746F6B656E3A22636F6D6D656E74222C666F726567726F756E643A22303038303030227D2C7B746F';
wwv_flow_imp.g_varchar2_table(30849) := '6B656E3A226E756D626572222C666F726567726F756E643A22303938363538227D2C7B746F6B656E3A226E756D6265722E686578222C666F726567726F756E643A22333033306330227D2C7B746F6B656E3A22726567657870222C666F726567726F756E';
wwv_flow_imp.g_varchar2_table(30850) := '643A22383030303030227D2C7B746F6B656E3A22616E6E6F746174696F6E222C666F726567726F756E643A22383038303830227D2C7B746F6B656E3A2274797065222C666F726567726F756E643A22303038303830227D2C7B746F6B656E3A2264656C69';
wwv_flow_imp.g_varchar2_table(30851) := '6D69746572222C666F726567726F756E643A22303030303030227D2C7B746F6B656E3A2264656C696D697465722E68746D6C222C666F726567726F756E643A22333833383338227D2C7B746F6B656E3A2264656C696D697465722E786D6C222C666F7265';
wwv_flow_imp.g_varchar2_table(30852) := '67726F756E643A22303030304646227D2C7B746F6B656E3A22746167222C666F726567726F756E643A22383030303030227D2C7B746F6B656E3A227461672E69642E707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A22';
wwv_flow_imp.g_varchar2_table(30853) := '7461672E636C6173732E707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A226D6574612E73637373222C666F726567726F756E643A22383030303030227D2C7B746F6B656E3A226D657461746167222C666F726567726F';
wwv_flow_imp.g_varchar2_table(30854) := '756E643A22653030303030227D2C7B746F6B656E3A226D6574617461672E636F6E74656E742E68746D6C222C666F726567726F756E643A22464630303030227D2C7B746F6B656E3A226D6574617461672E68746D6C222C666F726567726F756E643A2238';
wwv_flow_imp.g_varchar2_table(30855) := '3038303830227D2C7B746F6B656E3A226D6574617461672E786D6C222C666F726567726F756E643A22383038303830227D2C7B746F6B656E3A226D6574617461672E706870222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A226B6579';
wwv_flow_imp.g_varchar2_table(30856) := '222C666F726567726F756E643A22383633423030227D2C7B746F6B656E3A22737472696E672E6B65792E6A736F6E222C666F726567726F756E643A22413331353135227D2C7B746F6B656E3A22737472696E672E76616C75652E6A736F6E222C666F7265';
wwv_flow_imp.g_varchar2_table(30857) := '67726F756E643A22303435314135227D2C7B746F6B656E3A226174747269627574652E6E616D65222C666F726567726F756E643A22464630303030227D2C7B746F6B656E3A226174747269627574652E76616C7565222C666F726567726F756E643A2230';
wwv_flow_imp.g_varchar2_table(30858) := '3435314135227D2C7B746F6B656E3A226174747269627574652E76616C75652E6E756D626572222C666F726567726F756E643A22303938363538227D2C7B746F6B656E3A226174747269627574652E76616C75652E756E6974222C666F726567726F756E';
wwv_flow_imp.g_varchar2_table(30859) := '643A22303938363538227D2C7B746F6B656E3A226174747269627574652E76616C75652E68746D6C222C666F726567726F756E643A22303030304646227D2C7B746F6B656E3A226174747269627574652E76616C75652E786D6C222C666F726567726F75';
wwv_flow_imp.g_varchar2_table(30860) := '6E643A22303030304646227D2C7B746F6B656E3A22737472696E67222C666F726567726F756E643A22413331353135227D2C7B746F6B656E3A22737472696E672E68746D6C222C666F726567726F756E643A22303030304646227D2C7B746F6B656E3A22';
wwv_flow_imp.g_varchar2_table(30861) := '737472696E672E73716C222C666F726567726F756E643A22464630303030227D2C7B746F6B656E3A22737472696E672E79616D6C222C666F726567726F756E643A22303435314135227D2C7B746F6B656E3A226B6579776F7264222C666F726567726F75';
wwv_flow_imp.g_varchar2_table(30862) := '6E643A22303030304646227D2C7B746F6B656E3A226B6579776F72642E6A736F6E222C666F726567726F756E643A22303435314135227D2C7B746F6B656E3A226B6579776F72642E666C6F77222C666F726567726F756E643A22414630304442227D2C7B';
wwv_flow_imp.g_varchar2_table(30863) := '746F6B656E3A226B6579776F72642E666C6F772E73637373222C666F726567726F756E643A22303030304646227D2C7B746F6B656E3A226F70657261746F722E73637373222C666F726567726F756E643A22363636363636227D2C7B746F6B656E3A226F';
wwv_flow_imp.g_varchar2_table(30864) := '70657261746F722E73716C222C666F726567726F756E643A22373738383939227D2C7B746F6B656E3A226F70657261746F722E7377696674222C666F726567726F756E643A22363636363636227D2C7B746F6B656E3A22707265646566696E65642E7371';
wwv_flow_imp.g_varchar2_table(30865) := '6C222C666F726567726F756E643A22433730304337227D5D2C636F6C6F72733A7B5B596D5D3A2223464646464645222C5B5A6D5D3A2223303030303030222C5B70665D3A2223453545424631222C5B4A625D3A2223443344334433222C5B735F5D3A2223';
wwv_flow_imp.g_varchar2_table(30866) := '393339333933222C5B67665D3A22234144443646463444227D7D2C7765653D7B626173653A2276732D6461726B222C696E68657269743A21312C72756C65733A5B7B746F6B656E3A22222C666F726567726F756E643A22443444344434222C6261636B67';
wwv_flow_imp.g_varchar2_table(30867) := '726F756E643A22314531453145227D2C7B746F6B656E3A22696E76616C6964222C666F726567726F756E643A22663434373437227D2C7B746F6B656E3A22656D706861736973222C666F6E745374796C653A226974616C6963227D2C7B746F6B656E3A22';
wwv_flow_imp.g_varchar2_table(30868) := '7374726F6E67222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A227661726961626C65222C666F726567726F756E643A22373442304446227D2C7B746F6B656E3A227661726961626C652E707265646566696E6564222C666F72656772';
wwv_flow_imp.g_varchar2_table(30869) := '6F756E643A22343836344141227D2C7B746F6B656E3A227661726961626C652E706172616D65746572222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A22636F6E7374616E74222C666F726567726F756E643A22353639434436';
wwv_flow_imp.g_varchar2_table(30870) := '227D2C7B746F6B656E3A22636F6D6D656E74222C666F726567726F756E643A22363038423445227D2C7B746F6B656E3A226E756D626572222C666F726567726F756E643A22423543454138227D2C7B746F6B656E3A226E756D6265722E686578222C666F';
wwv_flow_imp.g_varchar2_table(30871) := '726567726F756E643A22354242343938227D2C7B746F6B656E3A22726567657870222C666F726567726F756E643A22423436363935227D2C7B746F6B656E3A22616E6E6F746174696F6E222C666F726567726F756E643A22636336363636227D2C7B746F';
wwv_flow_imp.g_varchar2_table(30872) := '6B656E3A2274797065222C666F726567726F756E643A22334443394230227D2C7B746F6B656E3A2264656C696D69746572222C666F726567726F756E643A22444344434443227D2C7B746F6B656E3A2264656C696D697465722E68746D6C222C666F7265';
wwv_flow_imp.g_varchar2_table(30873) := '67726F756E643A22383038303830227D2C7B746F6B656E3A2264656C696D697465722E786D6C222C666F726567726F756E643A22383038303830227D2C7B746F6B656E3A22746167222C666F726567726F756E643A22353639434436227D2C7B746F6B65';
wwv_flow_imp.g_varchar2_table(30874) := '6E3A227461672E69642E707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A227461672E636C6173732E707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A226D6574612E73637373222C66';
wwv_flow_imp.g_varchar2_table(30875) := '6F726567726F756E643A22413739383733227D2C7B746F6B656E3A226D6574612E746167222C666F726567726F756E643A22434539313738227D2C7B746F6B656E3A226D657461746167222C666F726567726F756E643A22444436413646227D2C7B746F';
wwv_flow_imp.g_varchar2_table(30876) := '6B656E3A226D6574617461672E636F6E74656E742E68746D6C222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A226D6574617461672E68746D6C222C666F726567726F756E643A22353639434436227D2C7B746F6B656E3A226D';
wwv_flow_imp.g_varchar2_table(30877) := '6574617461672E786D6C222C666F726567726F756E643A22353639434436227D2C7B746F6B656E3A226D6574617461672E706870222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A226B6579222C666F726567726F756E643A22394344';
wwv_flow_imp.g_varchar2_table(30878) := '434645227D2C7B746F6B656E3A22737472696E672E6B65792E6A736F6E222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A22737472696E672E76616C75652E6A736F6E222C666F726567726F756E643A22434539313738227D2C';
wwv_flow_imp.g_varchar2_table(30879) := '7B746F6B656E3A226174747269627574652E6E616D65222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A226174747269627574652E76616C7565222C666F726567726F756E643A22434539313738227D2C7B746F6B656E3A2261';
wwv_flow_imp.g_varchar2_table(30880) := '74747269627574652E76616C75652E6E756D6265722E637373222C666F726567726F756E643A22423543454138227D2C7B746F6B656E3A226174747269627574652E76616C75652E756E69742E637373222C666F726567726F756E643A22423543454138';
wwv_flow_imp.g_varchar2_table(30881) := '227D2C7B746F6B656E3A226174747269627574652E76616C75652E6865782E637373222C666F726567726F756E643A22443444344434227D2C7B746F6B656E3A22737472696E67222C666F726567726F756E643A22434539313738227D2C7B746F6B656E';
wwv_flow_imp.g_varchar2_table(30882) := '3A22737472696E672E73716C222C666F726567726F756E643A22464630303030227D2C7B746F6B656E3A226B6579776F7264222C666F726567726F756E643A22353639434436227D2C7B746F6B656E3A226B6579776F72642E666C6F77222C666F726567';
wwv_flow_imp.g_varchar2_table(30883) := '726F756E643A22433538364330227D2C7B746F6B656E3A226B6579776F72642E6A736F6E222C666F726567726F756E643A22434539313738227D2C7B746F6B656E3A226B6579776F72642E666C6F772E73637373222C666F726567726F756E643A223536';
wwv_flow_imp.g_varchar2_table(30884) := '39434436227D2C7B746F6B656E3A226F70657261746F722E73637373222C666F726567726F756E643A22393039303930227D2C7B746F6B656E3A226F70657261746F722E73716C222C666F726567726F756E643A22373738383939227D2C7B746F6B656E';
wwv_flow_imp.g_varchar2_table(30885) := '3A226F70657261746F722E7377696674222C666F726567726F756E643A22393039303930227D2C7B746F6B656E3A22707265646566696E65642E73716C222C666F726567726F756E643A22464630304646227D5D2C636F6C6F72733A7B5B596D5D3A2223';
wwv_flow_imp.g_varchar2_table(30886) := '314531453145222C5B5A6D5D3A2223443444344434222C5B70665D3A2223334133443431222C5B4A625D3A2223343034303430222C5B735F5D3A2223373037303730222C5B67665D3A22234144443646463236227D7D2C4365653D7B626173653A226863';
wwv_flow_imp.g_varchar2_table(30887) := '2D626C61636B222C696E68657269743A21312C72756C65733A5B7B746F6B656E3A22222C666F726567726F756E643A22464646464646222C6261636B67726F756E643A22303030303030227D2C7B746F6B656E3A22696E76616C6964222C666F72656772';
wwv_flow_imp.g_varchar2_table(30888) := '6F756E643A22663434373437227D2C7B746F6B656E3A22656D706861736973222C666F6E745374796C653A226974616C6963227D2C7B746F6B656E3A227374726F6E67222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A227661726961';
wwv_flow_imp.g_varchar2_table(30889) := '626C65222C666F726567726F756E643A22314145424646227D2C7B746F6B656E3A227661726961626C652E706172616D65746572222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A22636F6E7374616E74222C666F726567726F';
wwv_flow_imp.g_varchar2_table(30890) := '756E643A22353639434436227D2C7B746F6B656E3A22636F6D6D656E74222C666F726567726F756E643A22363038423445227D2C7B746F6B656E3A226E756D626572222C666F726567726F756E643A22464646464646227D2C7B746F6B656E3A22726567';
wwv_flow_imp.g_varchar2_table(30891) := '657870222C666F726567726F756E643A22433043304330227D2C7B746F6B656E3A22616E6E6F746174696F6E222C666F726567726F756E643A22353639434436227D2C7B746F6B656E3A2274797065222C666F726567726F756E643A2233444339423022';
wwv_flow_imp.g_varchar2_table(30892) := '7D2C7B746F6B656E3A2264656C696D69746572222C666F726567726F756E643A22464646463030227D2C7B746F6B656E3A2264656C696D697465722E68746D6C222C666F726567726F756E643A22464646463030227D2C7B746F6B656E3A22746167222C';
wwv_flow_imp.g_varchar2_table(30893) := '666F726567726F756E643A22353639434436227D2C7B746F6B656E3A227461672E69642E707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A227461672E636C6173732E707567222C666F726567726F756E643A22344637';
wwv_flow_imp.g_varchar2_table(30894) := '364143227D2C7B746F6B656E3A226D657461222C666F726567726F756E643A22443444344434227D2C7B746F6B656E3A226D6574612E746167222C666F726567726F756E643A22434539313738227D2C7B746F6B656E3A226D657461746167222C666F72';
wwv_flow_imp.g_varchar2_table(30895) := '6567726F756E643A22353639434436227D2C7B746F6B656E3A226D6574617461672E636F6E74656E742E68746D6C222C666F726567726F756E643A22314145424646227D2C7B746F6B656E3A226D6574617461672E68746D6C222C666F726567726F756E';
wwv_flow_imp.g_varchar2_table(30896) := '643A22353639434436227D2C7B746F6B656E3A226D6574617461672E786D6C222C666F726567726F756E643A22353639434436227D2C7B746F6B656E3A226D6574617461672E706870222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A';
wwv_flow_imp.g_varchar2_table(30897) := '226B6579222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A22737472696E672E6B6579222C666F726567726F756E643A22394344434645227D2C7B746F6B656E3A22737472696E672E76616C7565222C666F726567726F756E64';
wwv_flow_imp.g_varchar2_table(30898) := '3A22434539313738227D2C7B746F6B656E3A226174747269627574652E6E616D65222C666F726567726F756E643A22353639434436227D2C7B746F6B656E3A226174747269627574652E76616C7565222C666F726567726F756E643A2233464632334622';
wwv_flow_imp.g_varchar2_table(30899) := '7D2C7B746F6B656E3A22737472696E67222C666F726567726F756E643A22434539313738227D2C7B746F6B656E3A22737472696E672E73716C222C666F726567726F756E643A22464630303030227D2C7B746F6B656E3A226B6579776F7264222C666F72';
wwv_flow_imp.g_varchar2_table(30900) := '6567726F756E643A22353639434436227D2C7B746F6B656E3A226B6579776F72642E666C6F77222C666F726567726F756E643A22433538364330227D2C7B746F6B656E3A226F70657261746F722E73716C222C666F726567726F756E643A223737383839';
wwv_flow_imp.g_varchar2_table(30901) := '39227D2C7B746F6B656E3A226F70657261746F722E7377696674222C666F726567726F756E643A22393039303930227D2C7B746F6B656E3A22707265646566696E65642E73716C222C666F726567726F756E643A22464630304646227D5D2C636F6C6F72';
wwv_flow_imp.g_varchar2_table(30902) := '733A7B5B596D5D3A2223303030303030222C5B5A6D5D3A2223464646464646222C5B4A625D3A2223464646464646222C5B735F5D3A2223464646464646227D7D2C5365653D7B626173653A2268632D6C69676874222C696E68657269743A21312C72756C';
wwv_flow_imp.g_varchar2_table(30903) := '65733A5B7B746F6B656E3A22222C666F726567726F756E643A22323932393239222C6261636B67726F756E643A22464646464646227D2C7B746F6B656E3A22696E76616C6964222C666F726567726F756E643A22423532303044227D2C7B746F6B656E3A';
wwv_flow_imp.g_varchar2_table(30904) := '22656D706861736973222C666F6E745374796C653A226974616C6963227D2C7B746F6B656E3A227374726F6E67222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A227661726961626C65222C666F726567726F756E643A223236344637';
wwv_flow_imp.g_varchar2_table(30905) := '30227D2C7B746F6B656E3A227661726961626C652E707265646566696E6564222C666F726567726F756E643A22343836344141227D2C7B746F6B656E3A22636F6E7374616E74222C666F726567726F756E643A22646430303030227D2C7B746F6B656E3A';
wwv_flow_imp.g_varchar2_table(30906) := '22636F6D6D656E74222C666F726567726F756E643A22303038303030227D2C7B746F6B656E3A226E756D626572222C666F726567726F756E643A22303938363538227D2C7B746F6B656E3A226E756D6265722E686578222C666F726567726F756E643A22';
wwv_flow_imp.g_varchar2_table(30907) := '333033306330227D2C7B746F6B656E3A22726567657870222C666F726567726F756E643A22383030303030227D2C7B746F6B656E3A22616E6E6F746174696F6E222C666F726567726F756E643A22383038303830227D2C7B746F6B656E3A227479706522';
wwv_flow_imp.g_varchar2_table(30908) := '2C666F726567726F756E643A22303038303830227D2C7B746F6B656E3A2264656C696D69746572222C666F726567726F756E643A22303030303030227D2C7B746F6B656E3A2264656C696D697465722E68746D6C222C666F726567726F756E643A223338';
wwv_flow_imp.g_varchar2_table(30909) := '33383338227D2C7B746F6B656E3A22746167222C666F726567726F756E643A22383030303030227D2C7B746F6B656E3A227461672E69642E707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A227461672E636C6173732E';
wwv_flow_imp.g_varchar2_table(30910) := '707567222C666F726567726F756E643A22344637364143227D2C7B746F6B656E3A226D6574612E73637373222C666F726567726F756E643A22383030303030227D2C7B746F6B656E3A226D657461746167222C666F726567726F756E643A226530303030';
wwv_flow_imp.g_varchar2_table(30911) := '30227D2C7B746F6B656E3A226D6574617461672E636F6E74656E742E68746D6C222C666F726567726F756E643A22423532303044227D2C7B746F6B656E3A226D6574617461672E68746D6C222C666F726567726F756E643A22383038303830227D2C7B74';
wwv_flow_imp.g_varchar2_table(30912) := '6F6B656E3A226D6574617461672E786D6C222C666F726567726F756E643A22383038303830227D2C7B746F6B656E3A226D6574617461672E706870222C666F6E745374796C653A22626F6C64227D2C7B746F6B656E3A226B6579222C666F726567726F75';
wwv_flow_imp.g_varchar2_table(30913) := '6E643A22383633423030227D2C7B746F6B656E3A22737472696E672E6B65792E6A736F6E222C666F726567726F756E643A22413331353135227D2C7B746F6B656E3A22737472696E672E76616C75652E6A736F6E222C666F726567726F756E643A223034';
wwv_flow_imp.g_varchar2_table(30914) := '35314135227D2C7B746F6B656E3A226174747269627574652E6E616D65222C666F726567726F756E643A22323634463738227D2C7B746F6B656E3A226174747269627574652E76616C7565222C666F726567726F756E643A22303435314135227D2C7B74';
wwv_flow_imp.g_varchar2_table(30915) := '6F6B656E3A22737472696E67222C666F726567726F756E643A22413331353135227D2C7B746F6B656E3A22737472696E672E73716C222C666F726567726F756E643A22423532303044227D2C7B746F6B656E3A226B6579776F7264222C666F726567726F';
wwv_flow_imp.g_varchar2_table(30916) := '756E643A22303030304646227D2C7B746F6B656E3A226B6579776F72642E666C6F77222C666F726567726F756E643A22414630304442227D2C7B746F6B656E3A226F70657261746F722E73716C222C666F726567726F756E643A22373738383939227D2C';
wwv_flow_imp.g_varchar2_table(30917) := '7B746F6B656E3A226F70657261746F722E7377696674222C666F726567726F756E643A22363636363636227D2C7B746F6B656E3A22707265646566696E65642E73716C222C666F726567726F756E643A22433730304337227D5D2C636F6C6F72733A7B5B';
wwv_flow_imp.g_varchar2_table(30918) := '596D5D3A2223464646464646222C5B5A6D5D3A2223323932393239222C5B4A625D3A2223323932393239222C5B735F5D3A2223323932393239227D7D3B636C617373207865657B67657449636F6E2865297B636F6E737420743D495728293B6C6574206E';
wwv_flow_imp.g_varchar2_table(30919) := '3D652E64656661756C74733B666F72283B546C2E69735468656D6549636F6E286E293B297B636F6E737420653D742E67657449636F6E286E2E6964293B69662821652972657475726E3B6E3D652E64656661756C74737D72657475726E206E7D7D636F6E';
wwv_flow_imp.g_varchar2_table(30920) := '7374206B65653D227673222C4565653D2276732D6461726B222C4C65653D2268632D626C61636B222C4465653D2268632D6C69676874222C5465653D79642E6173286B6D292C4965653D79642E6173284662293B636C617373204D65657B636F6E737472';
wwv_flow_imp.g_varchar2_table(30921) := '7563746F7228652C74297B746869732E73656D616E746963486967686C69676874696E673D21312C746869732E7468656D65446174613D743B636F6E7374206E3D742E626173653B652E6C656E6774683E303F284165652865293F746869732E69643D65';
wwv_flow_imp.g_varchar2_table(30922) := '3A746869732E69643D6E2B2220222B652C746869732E7468656D654E616D653D65293A28746869732E69643D6E2C746869732E7468656D654E616D653D6E292C746869732E636F6C6F72733D6E756C6C2C746869732E64656661756C74436F6C6F72733D';
wwv_flow_imp.g_varchar2_table(30923) := '4F626A6563742E637265617465286E756C6C292C746869732E5F746F6B656E5468656D653D6E756C6C7D676574206261736528297B72657475726E20746869732E7468656D65446174612E626173657D6E6F74696679426173655570646174656428297B';
wwv_flow_imp.g_varchar2_table(30924) := '746869732E7468656D65446174612E696E6865726974262628746869732E636F6C6F72733D6E756C6C2C746869732E5F746F6B656E5468656D653D6E756C6C297D676574436F6C6F727328297B69662821746869732E636F6C6F7273297B636F6E737420';
wwv_flow_imp.g_varchar2_table(30925) := '653D6E6577204D61703B666F7228636F6E7374207420696E20746869732E7468656D65446174612E636F6C6F727329652E73657428742C68752E66726F6D48657828746869732E7468656D65446174612E636F6C6F72735B745D29293B69662874686973';
wwv_flow_imp.g_varchar2_table(30926) := '2E7468656D65446174612E696E6865726974297B636F6E737420743D4E656528746869732E7468656D65446174612E62617365293B666F7228636F6E7374206E20696E20742E636F6C6F727329652E686173286E297C7C652E736574286E2C68752E6672';
wwv_flow_imp.g_varchar2_table(30927) := '6F6D48657828742E636F6C6F72735B6E5D29297D746869732E636F6C6F72733D657D72657475726E20746869732E636F6C6F72737D676574436F6C6F7228652C74297B72657475726E20746869732E676574436F6C6F727328292E6765742865297C7C28';
wwv_flow_imp.g_varchar2_table(30928) := '2131213D3D743F746869732E67657444656661756C742865293A766F69642030297D67657444656661756C742865297B6C657420743D746869732E64656661756C74436F6C6F72735B655D3B72657475726E20747C7C28743D5465652E7265736F6C7665';
wwv_flow_imp.g_varchar2_table(30929) := '44656661756C74436F6C6F7228652C74686973292C746869732E64656661756C74436F6C6F72735B655D3D742C74297D646566696E65732865297B72657475726E20746869732E676574436F6C6F727328292E6861732865297D67657420747970652829';
wwv_flow_imp.g_varchar2_table(30930) := '7B73776974636828746869732E62617365297B63617365206B65653A72657475726E204D622E4C494748543B63617365204C65653A72657475726E204D622E484947485F434F4E54524153545F4441524B3B63617365204465653A72657475726E204D62';
wwv_flow_imp.g_varchar2_table(30931) := '2E484947485F434F4E54524153545F4C494748543B64656661756C743A72657475726E204D622E4441524B7D7D67657420746F6B656E5468656D6528297B69662821746869732E5F746F6B656E5468656D65297B6C657420653D5B5D2C743D5B5D3B6966';
wwv_flow_imp.g_varchar2_table(30932) := '28746869732E7468656D65446174612E696E6865726974297B636F6E7374206E3D4E656528746869732E7468656D65446174612E62617365293B653D6E2E72756C65732C6E2E656E636F646564546F6B656E73436F6C6F7273262628743D6E2E656E636F';
wwv_flow_imp.g_varchar2_table(30933) := '646564546F6B656E73436F6C6F7273297D636F6E7374206E3D746869732E7468656D65446174612E636F6C6F72735B22656469746F722E666F726567726F756E64225D2C693D746869732E7468656D65446174612E636F6C6F72735B22656469746F722E';
wwv_flow_imp.g_varchar2_table(30934) := '6261636B67726F756E64225D3B6966286E7C7C69297B636F6E737420743D7B746F6B656E3A22227D3B6E262628742E666F726567726F756E643D6E292C69262628742E6261636B67726F756E643D69292C652E707573682874297D653D652E636F6E6361';
wwv_flow_imp.g_varchar2_table(30935) := '7428746869732E7468656D65446174612E72756C6573292C746869732E7468656D65446174612E656E636F646564546F6B656E73436F6C6F7273262628743D746869732E7468656D65446174612E656E636F646564546F6B656E73436F6C6F7273292C74';
wwv_flow_imp.g_varchar2_table(30936) := '6869732E5F746F6B656E5468656D653D6665652E63726561746546726F6D526177546F6B656E5468656D6528652C74297D72657475726E20746869732E5F746F6B656E5468656D657D676574546F6B656E5374796C654D6574616461746128652C742C6E';
wwv_flow_imp.g_varchar2_table(30937) := '297B636F6E737420693D746869732E746F6B656E5468656D652E5F6D61746368285B655D2E636F6E6361742874292E6A6F696E28222E2229292E6D657461646174612C6F3D51672E676574466F726567726F756E642869292C733D51672E676574466F6E';
wwv_flow_imp.g_varchar2_table(30938) := '745374796C652869293B72657475726E7B666F726567726F756E643A6F2C6974616C69633A426F6F6C65616E28312673292C626F6C643A426F6F6C65616E28322673292C756E6465726C696E653A426F6F6C65616E28342673292C737472696B65746872';
wwv_flow_imp.g_varchar2_table(30939) := '6F7567683A426F6F6C65616E28382673297D7D7D66756E6374696F6E204165652865297B72657475726E20653D3D3D6B65657C7C653D3D3D4565657C7C653D3D3D4C65657C7C653D3D3D4465657D66756E6374696F6E204E65652865297B737769746368';
wwv_flow_imp.g_varchar2_table(30940) := '2865297B63617365206B65653A72657475726E207965653B63617365204565653A72657475726E207765653B63617365204C65653A72657475726E204365653B63617365204465653A72657475726E205365657D7D66756E6374696F6E20506565286529';
wwv_flow_imp.g_varchar2_table(30941) := '7B636F6E737420743D4E65652865293B72657475726E206E6577204D656528652C74297D5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E746F67676C';
wwv_flow_imp.g_varchar2_table(30942) := '6548696768436F6E7472617374222C6C6162656C3A7A322E746F67676C6548696768436F6E74726173742C616C6961733A22546F67676C65204869676820436F6E7472617374205468656D65222C707265636F6E646974696F6E3A766F696420307D292C';
wwv_flow_imp.g_varchar2_table(30943) := '746869732E5F6F726967696E616C5468656D654E616D653D6E756C6C7D72756E28652C74297B636F6E7374206E3D652E676574287936292C693D6E2E676574436F6C6F725468656D6528293B416228692E74797065293F286E2E7365745468656D652874';
wwv_flow_imp.g_varchar2_table(30944) := '6869732E5F6F726967696E616C5468656D654E616D657C7C284E6228692E74797065293F4565653A6B656529292C746869732E5F6F726967696E616C5468656D654E616D653D6E756C6C293A286E2E7365745468656D65284E6228692E74797065293F4C';
wwv_flow_imp.g_varchar2_table(30945) := '65653A446565292C746869732E5F6F726967696E616C5468656D654E616D653D692E7468656D654E616D65297D7D293B636C617373204F656520657874656E6473204E647B636F6E7374727563746F7228297B7375706572287B69643A4F65652E49442C';
wwv_flow_imp.g_varchar2_table(30946) := '7469746C653A5F28302C22546F67676C6520546162204B6579204D6F76657320466F63757322292C707265636F6E646974696F6E3A766F696420302C6B657962696E64696E673A7B7072696D6172793A323039312C6D61633A7B7072696D6172793A3133';
wwv_flow_imp.g_varchar2_table(30947) := '32337D2C7765696768743A3130307D2C6D657461646174613A7B6465736372697074696F6E3A5F28302C2244657465726D696E657320776865746865722074686520746162206B6579206D6F76657320666F6375732061726F756E642074686520776F72';
wwv_flow_imp.g_varchar2_table(30948) := '6B62656E6368206F7220696E736572747320746865207461622063686172616374657220696E207468652063757272656E7420656469746F722E205468697320697320616C736F2063616C6C656420746162207472617070696E672C20746162206E6176';
wwv_flow_imp.g_varchar2_table(30949) := '69676174696F6E2C206F722074616220666F637573206D6F64652E22297D2C66313A21307D297D72756E28297B636F6E737420653D2141412E676574546162466F6375734D6F646528293B41412E736574546162466F6375734D6F64652865292C587228';
wwv_flow_imp.g_varchar2_table(30950) := '6228302C653F225072657373696E67205461622077696C6C206E6F77206D6F766520666F63757320746F20746865206E65787420666F63757361626C6520656C656D656E74223A225072657373696E67205461622077696C6C206E6F7720696E73657274';
wwv_flow_imp.g_varchar2_table(30951) := '2074686520746162206368617261637465722229297D7D4F65652E49443D22656469746F722E616374696F6E2E746F67676C65546162466F6375734D6F6465222C5064284F6565292C5A6428636C61737320657874656E64732055647B636F6E73747275';
wwv_flow_imp.g_varchar2_table(30952) := '63746F7228297B7375706572287B69643A22656469746F722E616374696F6E2E666F7263655265746F6B656E697A65222C6C6162656C3A6228302C22446576656C6F7065723A20466F726365205265746F6B656E697A6522292C616C6961733A22446576';
wwv_flow_imp.g_varchar2_table(30953) := '656C6F7065723A20466F726365205265746F6B656E697A65222C707265636F6E646974696F6E3A766F696420307D297D72756E28652C74297B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206E3D742E6765744D6F64656C28';
wwv_flow_imp.g_varchar2_table(30954) := '293B6E2E746F6B656E697A6174696F6E2E7265736574546F6B656E697A6174696F6E28293B636F6E737420693D6E65772066743B6E2E746F6B656E697A6174696F6E2E666F726365546F6B656E697A6174696F6E286E2E6765744C696E65436F756E7428';
wwv_flow_imp.g_varchar2_table(30955) := '29292C692E73746F7028292C636F6E736F6C652E6C6F672860746F6B656E697A6174696F6E20746F6F6B20247B692E656C617073656428297D60297D7D293B766172205265653D6E2838323435292C4665653D7B7D3B4665652E7374796C655461675472';
wwv_flow_imp.g_varchar2_table(30956) := '616E73666F726D3D6A7228292C4665652E736574417474726962757465733D567228292C4665652E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4665652E646F6D4150493D4F7228292C4665652E696E736572745374796C';
wwv_flow_imp.g_varchar2_table(30957) := '65456C656D656E743D487228292C4E722829285265652E412C466565292C5265652E4126265265652E412E6C6F63616C7326265265652E412E6C6F63616C733B766172204265653D6E2836303635292C5665653D7B7D3B5665652E7374796C6554616754';
wwv_flow_imp.g_varchar2_table(30958) := '72616E73666F726D3D6A7228292C5665652E736574417474726962757465733D567228292C5665652E696E736572743D467228292E62696E64286E756C6C2C226865616422292C5665652E646F6D4150493D4F7228292C5665652E696E73657274537479';
wwv_flow_imp.g_varchar2_table(30959) := '6C65456C656D656E743D487228292C4E722829284265652E412C566565292C4265652E4126264265652E412E6C6F63616C7326264265652E412E6C6F63616C733B766172207A65653D6E2834363436292C4865653D7B7D3B4865652E7374796C65546167';
wwv_flow_imp.g_varchar2_table(30960) := '5472616E73666F726D3D6A7228292C4865652E736574417474726962757465733D567228292C4865652E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4865652E646F6D4150493D4F7228292C4865652E696E736572745374';
wwv_flow_imp.g_varchar2_table(30961) := '796C65456C656D656E743D487228292C4E722829287A65652E412C486565292C7A65652E4126267A65652E412E6C6F63616C7326267A65652E412E6C6F63616C733B766172205765653D66756E6374696F6E28652C74297B72657475726E2066756E6374';
wwv_flow_imp.g_varchar2_table(30962) := '696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206A65653D636C61737320657874656E6473206C747B67657420656E61626C656428297B72657475726E20746869732E5F656E61626C65647D73657420656E61626C65642865297B653F287468';
wwv_flow_imp.g_varchar2_table(30963) := '69732E656C2E7365744174747269627574652822617269612D64697361626C6564222C2266616C736522292C746869732E656C2E746162496E6465783D302C746869732E656C2E7374796C652E706F696E7465724576656E74733D226175746F222C7468';
wwv_flow_imp.g_varchar2_table(30964) := '69732E656C2E7374796C652E6F7061636974793D2231222C746869732E656C2E7374796C652E637572736F723D22706F696E746572222C746869732E5F656E61626C65643D2131293A28746869732E656C2E736574417474726962757465282261726961';
wwv_flow_imp.g_varchar2_table(30965) := '2D64697361626C6564222C227472756522292C746869732E656C2E746162496E6465783D2D312C746869732E656C2E7374796C652E706F696E7465724576656E74733D226E6F6E65222C746869732E656C2E7374796C652E6F7061636974793D22302E34';
wwv_flow_imp.g_varchar2_table(30966) := '222C746869732E656C2E7374796C652E637572736F723D2264656661756C74222C746869732E5F656E61626C65643D2130292C746869732E5F656E61626C65643D657D636F6E7374727563746F7228652C742C6E3D7B7D2C692C6F297B76617220732C72';
wwv_flow_imp.g_varchar2_table(30967) := '3B737570657228292C746869732E5F6C696E6B3D742C746869732E5F686F766572536572766963653D692C746869732E5F656E61626C65643D21302C746869732E656C3D757228652C62722822612E6D6F6E61636F2D6C696E6B222C7B746162496E6465';
wwv_flow_imp.g_varchar2_table(30968) := '783A6E756C6C213D3D28733D742E746162496E646578292626766F69642030213D3D733F733A302C687265663A742E687265667D2C742E6C6162656C29292C746869732E686F76657244656C65676174653D6E756C6C213D3D28723D6E2E686F76657244';
wwv_flow_imp.g_varchar2_table(30969) := '656C6567617465292626766F69642030213D3D723F723A504528226D6F75736522292C746869732E736574546F6F6C74697028742E7469746C65292C746869732E656C2E7365744174747269627574652822726F6C65222C22627574746F6E22293B636F';
wwv_flow_imp.g_varchar2_table(30970) := '6E737420613D746869732E5F7265676973746572286E6577204B5328746869732E656C2C22636C69636B2229292C6C3D746869732E5F7265676973746572286E6577204B5328746869732E656C2C226B657970726573732229292C633D76742E63686169';
wwv_flow_imp.g_varchar2_table(30971) := '6E286C2E6576656E742C28653D3E652E6D61702828653D3E6E657720716528652929292E66696C7465722828653D3E333D3D3D652E6B6579436F6465292929292C643D746869732E5F7265676973746572286E6577204B5328746869732E656C2C54452E';
wwv_flow_imp.g_varchar2_table(30972) := '54617029292E6576656E743B746869732E5F72656769737465722849452E61646454617267657428746869732E656C29293B636F6E737420683D76742E616E7928612E6576656E742C632C64293B746869732E5F726567697374657228682828653D3E7B';
wwv_flow_imp.g_varchar2_table(30973) := '746869732E656E61626C6564262628637228652C2130292C286E756C6C3D3D6E3F766F696420303A6E2E6F70656E6572293F6E2E6F70656E657228746869732E5F6C696E6B2E68726566293A6F2E6F70656E28746869732E5F6C696E6B2E687265662C7B';
wwv_flow_imp.g_varchar2_table(30974) := '616C6C6F77436F6D6D616E64733A21307D29297D2929292C746869732E656E61626C65643D21307D736574546F6F6C7469702865297B746869732E686F76657244656C65676174652E73686F774E6174697665486F7665723F746869732E656C2E746974';
wwv_flow_imp.g_varchar2_table(30975) := '6C653D6E756C6C213D653F653A22223A21746869732E686F7665722626653F746869732E686F7665723D746869732E5F726567697374657228746869732E5F686F766572536572766963652E7365747570557064617461626C65486F7665722874686973';
wwv_flow_imp.g_varchar2_table(30976) := '2E686F76657244656C65676174652C746869732E656C2C6529293A746869732E686F7665722626746869732E686F7665722E7570646174652865297D7D3B6A65653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74';
wwv_flow_imp.g_varchar2_table(30977) := '732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E';
wwv_flow_imp.g_varchar2_table(30978) := '6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B';
wwv_flow_imp.g_varchar2_table(30979) := '615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B57656528332C497129';
wwv_flow_imp.g_varchar2_table(30980) := '2C57656528342C6445295D2C6A6565293B766172207165653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E';
wwv_flow_imp.g_varchar2_table(30981) := '50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C656374';
wwv_flow_imp.g_varchar2_table(30982) := '2E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72';
wwv_flow_imp.g_varchar2_table(30983) := '293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C2465653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C';
wwv_flow_imp.g_varchar2_table(30984) := '6574205565653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F656469746F723D652C746869732E696E7374616E74696174696F6E536572766963653D742C746869732E62616E';
wwv_flow_imp.g_varchar2_table(30985) := '6E65723D746869732E5F726567697374657228746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365284B656529297D6869646528297B746869732E5F656469746F722E73657442616E6E6572286E756C6C';
wwv_flow_imp.g_varchar2_table(30986) := '2C30292C746869732E62616E6E65722E636C65617228297D73686F772865297B746869732E62616E6E65722E73686F77287B2E2E2E652C6F6E436C6F73653A28293D3E7B76617220743B746869732E6869646528292C6E756C6C3D3D3D28743D652E6F6E';
wwv_flow_imp.g_varchar2_table(30987) := '436C6F7365297C7C766F696420303D3D3D747C7C742E63616C6C2865297D7D292C746869732E5F656469746F722E73657442616E6E657228746869732E62616E6E65722E656C656D656E742C3236297D7D3B5565653D716565285B24656528312C756329';
wwv_flow_imp.g_varchar2_table(30988) := '5D2C556565293B6C6574204B65653D636C61737320657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E696E7374616E74696174696F6E536572766963653D652C746869732E6D61726B646F776E52656E64';
wwv_flow_imp.g_varchar2_table(30989) := '657265723D746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652870452C7B7D292C746869732E656C656D656E743D627228226469762E656469746F722D62616E6E657222292C746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(30990) := '6E742E746162496E6465783D307D676574417269614C6162656C2865297B72657475726E20652E617269614C6162656C3F652E617269614C6162656C3A22737472696E67223D3D747970656F6620652E6D6573736167653F652E6D6573736167653A766F';
wwv_flow_imp.g_varchar2_table(30991) := '696420307D67657442616E6E65724D6573736167652865297B69662822737472696E67223D3D747970656F662065297B636F6E737420743D627228227370616E22293B72657475726E20742E696E6E6572546578743D652C747D72657475726E20746869';
wwv_flow_imp.g_varchar2_table(30992) := '732E6D61726B646F776E52656E64657265722E72656E6465722865292E656C656D656E747D636C65617228297B667328746869732E656C656D656E74297D73686F772865297B667328746869732E656C656D656E74293B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(30993) := '676574417269614C6162656C2865293B742626746869732E656C656D656E742E7365744174747269627574652822617269612D6C6162656C222C74293B636F6E7374206E3D757228746869732E656C656D656E742C627228226469762E69636F6E2D636F';
wwv_flow_imp.g_varchar2_table(30994) := '6E7461696E65722229293B6E2E7365744174747269627574652822617269612D68696464656E222C227472756522292C652E69636F6E26266E2E617070656E644368696C642862722860646976247B546C2E617343535353656C6563746F7228652E6963';
wwv_flow_imp.g_varchar2_table(30995) := '6F6E297D6029293B636F6E737420693D757228746869732E656C656D656E742C627228226469762E6D6573736167652D636F6E7461696E65722229293B696628692E7365744174747269627574652822617269612D68696464656E222C22747275652229';
wwv_flow_imp.g_varchar2_table(30996) := '2C692E617070656E644368696C6428746869732E67657442616E6E65724D65737361676528652E6D65737361676529292C746869732E6D657373616765416374696F6E73436F6E7461696E65723D757228746869732E656C656D656E742C627228226469';
wwv_flow_imp.g_varchar2_table(30997) := '762E6D6573736167652D616374696F6E732D636F6E7461696E65722229292C652E616374696F6E7329666F7228636F6E73742074206F6620652E616374696F6E7329746869732E5F726567697374657228746869732E696E7374616E74696174696F6E53';
wwv_flow_imp.g_varchar2_table(30998) := '6572766963652E637265617465496E7374616E6365286A65652C746869732E6D657373616765416374696F6E73436F6E7461696E65722C7B2E2E2E742C746162496E6465783A2D317D2C7B7D29293B636F6E7374206F3D757228746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(30999) := '6E742C627228226469762E616374696F6E2D636F6E7461696E65722229293B746869732E616374696F6E4261723D746869732E5F7265676973746572286E6577206C4D286F29292C746869732E616374696F6E4261722E7075736828746869732E5F7265';
wwv_flow_imp.g_varchar2_table(31000) := '676973746572286E6577206263282262616E6E65722E636C6F7365222C22436C6F73652042616E6E6572222C546C2E6173436C6173734E616D65285057292C21302C2828293D3E7B2266756E6374696F6E223D3D747970656F6620652E6F6E436C6F7365';
wwv_flow_imp.g_varchar2_table(31001) := '2626652E6F6E436C6F736528297D2929292C7B69636F6E3A21302C6C6162656C3A21317D292C746869732E616374696F6E4261722E736574466F63757361626C65282131297D7D3B4B65653D716565285B24656528302C7563295D2C4B6565293B636F6E';
wwv_flow_imp.g_varchar2_table(31002) := '7374204765653D70632822776F726B737061636554727573744D616E6167656D656E745365727669636522293B766172205165653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C';
wwv_flow_imp.g_varchar2_table(31003) := '333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F';
wwv_flow_imp.g_varchar2_table(31004) := '66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F';
wwv_flow_imp.g_varchar2_table(31005) := '6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C5965653D66756E6374696F6E28652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(31006) := '6E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374205A65653D54572822657874656E73696F6E732D7761726E696E672D6D657373616765222C4C6C2E7761726E696E672C6228302C2249636F6E2073686F776E2077697468';
wwv_flow_imp.g_varchar2_table(31007) := '2061207761726E696E67206D65737361676520696E2074686520657874656E73696F6E7320656469746F722E2229293B6C6574205865653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228';
wwv_flow_imp.g_varchar2_table(31008) := '292C746869732E5F656469746F723D652C746869732E5F656469746F72576F726B6572536572766963653D742C746869732E5F776F726B73706163655472757374536572766963653D6E2C746869732E5F686967686C6967687465723D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(31009) := '69732E5F62616E6E6572436C6F7365643D21312C746869732E5F75706461746553746174653D653D3E7B696628652626652E6861734D6F7265297B696628746869732E5F62616E6E6572436C6F7365642972657475726E3B636F6E737420743D4D617468';
wwv_flow_imp.g_varchar2_table(31010) := '2E6D617828652E616D626967756F7573436861726163746572436F756E742C652E6E6F6E42617369634173636969436861726163746572436F756E742C652E696E76697369626C65436861726163746572436F756E74293B6C6574206E3B696628652E6E';
wwv_flow_imp.g_varchar2_table(31011) := '6F6E42617369634173636969436861726163746572436F756E743E3D74296E3D7B6D6573736167653A6228302C225468697320646F63756D656E7420636F6E7461696E73206D616E79206E6F6E2D626173696320415343494920756E69636F6465206368';
wwv_flow_imp.g_varchar2_table(31012) := '617261637465727322292C636F6D6D616E643A6E6577206874657D3B656C736520696628652E616D626967756F7573436861726163746572436F756E743E3D74296E3D7B6D6573736167653A6228302C225468697320646F63756D656E7420636F6E7461';
wwv_flow_imp.g_varchar2_table(31013) := '696E73206D616E7920616D626967756F757320756E69636F6465206368617261637465727322292C636F6D6D616E643A6E6577206374657D3B656C73657B6966282128652E696E76697369626C65436861726163746572436F756E743E3D742929746872';
wwv_flow_imp.g_varchar2_table(31014) := '6F77206E6577204572726F722822556E726561636861626C6522293B6E3D7B6D6573736167653A6228302C225468697320646F63756D656E7420636F6E7461696E73206D616E7920696E76697369626C6520756E69636F64652063686172616374657273';
wwv_flow_imp.g_varchar2_table(31015) := '22292C636F6D6D616E643A6E6577206474657D7D746869732E5F62616E6E6572436F6E74726F6C6C65722E73686F77287B69643A22756E69636F6465486967686C6967687442616E6E6572222C6D6573736167653A6E2E6D6573736167652C69636F6E3A';
wwv_flow_imp.g_varchar2_table(31016) := '5A65652C616374696F6E733A5B7B6C6162656C3A6E2E636F6D6D616E642E73686F72744C6162656C2C687265663A60636F6D6D616E643A247B6E2E636F6D6D616E642E69647D607D5D2C6F6E436C6F73653A28293D3E7B746869732E5F62616E6E657243';
wwv_flow_imp.g_varchar2_table(31017) := '6C6F7365643D21307D7D297D656C736520746869732E5F62616E6E6572436F6E74726F6C6C65722E6869646528297D2C746869732E5F62616E6E6572436F6E74726F6C6C65723D746869732E5F726567697374657228692E637265617465496E7374616E';
wwv_flow_imp.g_varchar2_table(31018) := '6365285565652C6529292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F62616E6E6572436C6F7365643D21312C746869732E5F75706461746548696768';
wwv_flow_imp.g_varchar2_table(31019) := '6C69676874657228297D2929292C746869732E5F6F7074696F6E733D652E6765744F7074696F6E28313235292C746869732E5F7265676973746572286E2E6F6E4469644368616E676554727573742828653D3E7B746869732E5F75706461746548696768';
wwv_flow_imp.g_varchar2_table(31020) := '6C69676874657228297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E6765436F6E66696775726174696F6E2828743D3E7B742E6861734368616E6765642831323529262628746869732E5F6F7074696F6E733D652E676574';
wwv_flow_imp.g_varchar2_table(31021) := '4F7074696F6E28313235292C746869732E5F757064617465486967686C6967687465722829297D2929292C746869732E5F757064617465486967686C69676874657228297D646973706F736528297B746869732E5F686967686C69676874657226262874';
wwv_flow_imp.g_varchar2_table(31022) := '6869732E5F686967686C6967687465722E646973706F736528292C746869732E5F686967686C6967687465723D6E756C6C292C73757065722E646973706F736528297D5F757064617465486967686C69676874657228297B696628746869732E5F757064';
wwv_flow_imp.g_varchar2_table(31023) := '6174655374617465286E756C6C292C746869732E5F686967686C696768746572262628746869732E5F686967686C6967687465722E646973706F736528292C746869732E5F686967686C6967687465723D6E756C6C292C21746869732E5F656469746F72';
wwv_flow_imp.g_varchar2_table(31024) := '2E6861734D6F64656C28292972657475726E3B636F6E737420653D66756E6374696F6E28652C74297B72657475726E7B6E6F6E426173696341534349493A742E6E6F6E426173696341534349493D3D3D424C3F21653A742E6E6F6E426173696341534349';
wwv_flow_imp.g_varchar2_table(31025) := '492C616D626967756F7573436861726163746572733A742E616D626967756F7573436861726163746572732C696E76697369626C65436861726163746572733A742E696E76697369626C65436861726163746572732C696E636C756465436F6D6D656E74';
wwv_flow_imp.g_varchar2_table(31026) := '733A742E696E636C756465436F6D6D656E74733D3D3D424C3F21653A742E696E636C756465436F6D6D656E74732C696E636C756465537472696E67733A742E696E636C756465537472696E67733D3D3D424C3F21653A742E696E636C756465537472696E';
wwv_flow_imp.g_varchar2_table(31027) := '67732C616C6C6F776564436861726163746572733A742E616C6C6F776564436861726163746572732C616C6C6F7765644C6F63616C65733A742E616C6C6F7765644C6F63616C65737D7D28746869732E5F776F726B737061636554727573745365727669';
wwv_flow_imp.g_varchar2_table(31028) := '63652E6973576F726B73706163655472757374656428292C746869732E5F6F7074696F6E73293B6966285B652E6E6F6E426173696341534349492C652E616D626967756F7573436861726163746572732C652E696E76697369626C654368617261637465';
wwv_flow_imp.g_varchar2_table(31029) := '72735D2E65766572792828653D3E21313D3D3D6529292972657475726E3B636F6E737420743D7B6E6F6E426173696341534349493A652E6E6F6E426173696341534349492C616D626967756F7573436861726163746572733A652E616D626967756F7573';
wwv_flow_imp.g_varchar2_table(31030) := '436861726163746572732C696E76697369626C65436861726163746572733A652E696E76697369626C65436861726163746572732C696E636C756465436F6D6D656E74733A652E696E636C756465436F6D6D656E74732C696E636C756465537472696E67';
wwv_flow_imp.g_varchar2_table(31031) := '733A652E696E636C756465537472696E67732C616C6C6F776564436F6465506F696E74733A4F626A6563742E6B65797328652E616C6C6F77656443686172616374657273292E6D61702828653D3E652E636F6465506F696E74417428302929292C616C6C';
wwv_flow_imp.g_varchar2_table(31032) := '6F7765644C6F63616C65733A4F626A6563742E6B65797328652E616C6C6F7765644C6F63616C6573292E6D61702828653D3E225F6F73223D3D3D653F286E657720496E746C2E4E756D626572466F726D6174292E7265736F6C7665644F7074696F6E7328';
wwv_flow_imp.g_varchar2_table(31033) := '292E6C6F63616C653A225F7673636F6465223D3D3D653F583A6529297D3B746869732E5F656469746F72576F726B6572536572766963652E63616E436F6D70757465556E69636F6465486967686C696768747328746869732E5F656469746F722E676574';
wwv_flow_imp.g_varchar2_table(31034) := '4D6F64656C28292E757269293F746869732E5F686967686C6967687465723D6E6577204A656528746869732E5F656469746F722C742C746869732E5F75706461746553746174652C746869732E5F656469746F72576F726B657253657276696365293A74';
wwv_flow_imp.g_varchar2_table(31035) := '6869732E5F686967686C6967687465723D6E65772065746528746869732E5F656469746F722C742C746869732E5F7570646174655374617465297D6765744465636F726174696F6E496E666F2865297B72657475726E20746869732E5F686967686C6967';
wwv_flow_imp.g_varchar2_table(31036) := '687465723F746869732E5F686967686C6967687465722E6765744465636F726174696F6E496E666F2865293A6E756C6C7D7D3B5865652E49443D22656469746F722E636F6E747269622E756E69636F6465486967686C696768746572222C5865653D5165';
wwv_flow_imp.g_varchar2_table(31037) := '65285B59656528312C7A5A292C59656528322C476565292C59656528332C7563295D2C586565293B6C6574204A65653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F';
wwv_flow_imp.g_varchar2_table(31038) := '656469746F723D652C746869732E5F6F7074696F6E733D742C746869732E5F75706461746553746174653D6E2C746869732E5F656469746F72576F726B6572536572766963653D692C746869732E5F6D6F64656C3D746869732E5F656469746F722E6765';
wwv_flow_imp.g_varchar2_table(31039) := '744D6F64656C28292C746869732E5F6465636F726174696F6E733D746869732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E5F757064617465536F6F6E3D746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(31040) := '72286E6577204B74282828293D3E746869732E5F7570646174652829292C32353029292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E74282828293D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(31041) := '757064617465536F6F6E2E7363686564756C6528297D2929292C746869732E5F757064617465536F6F6E2E7363686564756C6528297D646973706F736528297B746869732E5F6465636F726174696F6E732E636C65617228292C73757065722E64697370';
wwv_flow_imp.g_varchar2_table(31042) := '6F736528297D5F75706461746528297B696628746869732E5F6D6F64656C2E6973446973706F73656428292972657475726E3B69662821746869732E5F6D6F64656C2E6D69676874436F6E7461696E4E6F6E426173696341534349492829297265747572';
wwv_flow_imp.g_varchar2_table(31043) := '6E20766F696420746869732E5F6465636F726174696F6E732E636C65617228293B636F6E737420653D746869732E5F6D6F64656C2E67657456657273696F6E496428293B746869732E5F656469746F72576F726B6572536572766963652E636F6D707574';
wwv_flow_imp.g_varchar2_table(31044) := '6564556E69636F6465486967686C696768747328746869732E5F6D6F64656C2E7572692C746869732E5F6F7074696F6E73292E7468656E2828743D3E7B696628746869732E5F6D6F64656C2E6973446973706F73656428292972657475726E3B69662874';
wwv_flow_imp.g_varchar2_table(31045) := '6869732E5F6D6F64656C2E67657456657273696F6E49642829213D3D652972657475726E3B746869732E5F75706461746553746174652874293B636F6E7374206E3D5B5D3B69662821742E6861734D6F726529666F7228636F6E73742065206F6620742E';
wwv_flow_imp.g_varchar2_table(31046) := '72616E676573296E2E70757368287B72616E67653A652C6F7074696F6E733A7274652E696E7374616E63652E6765744465636F726174696F6E46726F6D4F7074696F6E7328746869732E5F6F7074696F6E73297D293B746869732E5F6465636F72617469';
wwv_flow_imp.g_varchar2_table(31047) := '6F6E732E736574286E297D29297D6765744465636F726174696F6E496E666F2865297B69662821746869732E5F6465636F726174696F6E732E6861732865292972657475726E206E756C6C3B636F6E737420743D746869732E5F656469746F722E676574';
wwv_flow_imp.g_varchar2_table(31048) := '4D6F64656C28293B72657475726E20594628742C65293F7B726561736F6E3A73746528742E67657456616C7565496E52616E676528652E72616E6765292C746869732E5F6F7074696F6E73292C696E436F6D6D656E743A5A4628742C65292C696E537472';
wwv_flow_imp.g_varchar2_table(31049) := '696E673A584628742C65297D3A6E756C6C7D7D3B4A65653D516565285B59656528332C7A5A295D2C4A6565293B636C6173732065746520657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F65';
wwv_flow_imp.g_varchar2_table(31050) := '6469746F723D652C746869732E5F6F7074696F6E733D742C746869732E5F75706461746553746174653D6E2C746869732E5F6D6F64656C3D746869732E5F656469746F722E6765744D6F64656C28292C746869732E5F6465636F726174696F6E733D7468';
wwv_flow_imp.g_varchar2_table(31051) := '69732E5F656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E5F757064617465536F6F6E3D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E5F757064617465282929';
wwv_flow_imp.g_varchar2_table(31052) := '2C32353029292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644C61796F75744368616E6765282828293D3E7B746869732E5F757064617465536F6F6E2E7363686564756C6528297D2929292C746869732E5F726567';
wwv_flow_imp.g_varchar2_table(31053) := '697374657228746869732E5F656469746F722E6F6E4469645363726F6C6C4368616E6765282828293D3E7B746869732E5F757064617465536F6F6E2E7363686564756C6528297D2929292C746869732E5F726567697374657228746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(31054) := '6F722E6F6E4469644368616E676548696464656E4172656173282828293D3E7B746869732E5F757064617465536F6F6E2E7363686564756C6528297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(31055) := '6E67654D6F64656C436F6E74656E74282828293D3E7B746869732E5F757064617465536F6F6E2E7363686564756C6528297D2929292C746869732E5F757064617465536F6F6E2E7363686564756C6528297D646973706F736528297B746869732E5F6465';
wwv_flow_imp.g_varchar2_table(31056) := '636F726174696F6E732E636C65617228292C73757065722E646973706F736528297D5F75706461746528297B696628746869732E5F6D6F64656C2E6973446973706F73656428292972657475726E3B69662821746869732E5F6D6F64656C2E6D69676874';
wwv_flow_imp.g_varchar2_table(31057) := '436F6E7461696E4E6F6E4261736963415343494928292972657475726E20766F696420746869732E5F6465636F726174696F6E732E636C65617228293B636F6E737420653D746869732E5F656469746F722E67657456697369626C6552616E6765732829';
wwv_flow_imp.g_varchar2_table(31058) := '2C743D5B5D2C6E3D7B72616E6765733A5B5D2C616D626967756F7573436861726163746572436F756E743A302C696E76697369626C65436861726163746572436F756E743A302C6E6F6E42617369634173636969436861726163746572436F756E743A30';
wwv_flow_imp.g_varchar2_table(31059) := '2C6861734D6F72653A21317D3B666F7228636F6E73742074206F662065297B636F6E737420653D567A2E636F6D70757465556E69636F6465486967686C696768747328746869732E5F6D6F64656C2C746869732E5F6F7074696F6E732C74293B666F7228';
wwv_flow_imp.g_varchar2_table(31060) := '636F6E73742074206F6620652E72616E676573296E2E72616E6765732E707573682874293B6E2E616D626967756F7573436861726163746572436F756E742B3D6E2E616D626967756F7573436861726163746572436F756E742C6E2E696E76697369626C';
wwv_flow_imp.g_varchar2_table(31061) := '65436861726163746572436F756E742B3D6E2E696E76697369626C65436861726163746572436F756E742C6E2E6E6F6E42617369634173636969436861726163746572436F756E742B3D6E2E6E6F6E42617369634173636969436861726163746572436F';
wwv_flow_imp.g_varchar2_table(31062) := '756E742C6E2E6861734D6F72653D6E2E6861734D6F72657C7C652E6861734D6F72657D696628216E2E6861734D6F726529666F7228636F6E73742065206F66206E2E72616E67657329742E70757368287B72616E67653A652C6F7074696F6E733A727465';
wwv_flow_imp.g_varchar2_table(31063) := '2E696E7374616E63652E6765744465636F726174696F6E46726F6D4F7074696F6E7328746869732E5F6F7074696F6E73297D293B746869732E5F7570646174655374617465286E292C746869732E5F6465636F726174696F6E732E7365742874297D6765';
wwv_flow_imp.g_varchar2_table(31064) := '744465636F726174696F6E496E666F2865297B69662821746869732E5F6465636F726174696F6E732E6861732865292972657475726E206E756C6C3B636F6E737420743D746869732E5F656469746F722E6765744D6F64656C28292C6E3D742E67657456';
wwv_flow_imp.g_varchar2_table(31065) := '616C7565496E52616E676528652E72616E6765293B72657475726E20594628742C65293F7B726561736F6E3A737465286E2C746869732E5F6F7074696F6E73292C696E436F6D6D656E743A5A4628742C65292C696E537472696E673A584628742C65297D';
wwv_flow_imp.g_varchar2_table(31066) := '3A6E756C6C7D7D636F6E7374207474653D6228302C22436F6E66696775726520556E69636F646520486967686C69676874204F7074696F6E7322293B6C6574206E74653D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F65';
wwv_flow_imp.g_varchar2_table(31067) := '6469746F723D652C746869732E5F6C616E6775616765536572766963653D742C746869732E5F6F70656E6572536572766963653D6E2C746869732E686F7665724F7264696E616C3D357D636F6D7075746553796E6328652C74297B69662821746869732E';
wwv_flow_imp.g_varchar2_table(31068) := '5F656469746F722E6861734D6F64656C28297C7C31213D3D652E747970652972657475726E5B5D3B636F6E7374206E3D746869732E5F656469746F722E6765744D6F64656C28292C693D746869732E5F656469746F722E676574436F6E74726962757469';
wwv_flow_imp.g_varchar2_table(31069) := '6F6E285865652E4944293B69662821692972657475726E5B5D3B636F6E7374206F3D5B5D2C733D6E6577205365743B6C657420723D3330303B666F7228636F6E73742065206F662074297B636F6E737420743D692E6765744465636F726174696F6E496E';
wwv_flow_imp.g_varchar2_table(31070) := '666F2865293B696628217429636F6E74696E75653B636F6E737420613D6E2E67657456616C7565496E52616E676528652E72616E6765292E636F6465506F696E7441742830292C6C3D6F74652861293B6C657420633B73776974636828742E726561736F';
wwv_flow_imp.g_varchar2_table(31071) := '6E2E6B696E64297B6361736520303A633D7A6928742E726561736F6E2E636F6E66757361626C6557697468293F6228302C2254686520636861726163746572207B307D20636F756C6420626520636F6E6675736564207769746820746865204153434949';
wwv_flow_imp.g_varchar2_table(31072) := '20636861726163746572207B317D2C207768696368206973206D6F726520636F6D6D6F6E20696E20736F7572636520636F64652E222C6C2C6F746528742E726561736F6E2E636F6E66757361626C65576974682E636F6465506F696E7441742830292929';
wwv_flow_imp.g_varchar2_table(31073) := '3A6228302C2254686520636861726163746572207B307D20636F756C6420626520636F6E667573656420776974682074686520636861726163746572207B317D2C207768696368206973206D6F726520636F6D6D6F6E20696E20736F7572636520636F64';
wwv_flow_imp.g_varchar2_table(31074) := '652E222C6C2C6F746528742E726561736F6E2E636F6E66757361626C65576974682E636F6465506F696E74417428302929293B627265616B3B6361736520313A633D6228302C2254686520636861726163746572207B307D20697320696E76697369626C';
wwv_flow_imp.g_varchar2_table(31075) := '652E222C6C293B627265616B3B6361736520323A633D6228302C2254686520636861726163746572207B307D206973206E6F742061206261736963204153434949206368617261637465722E222C6C297D696628732E68617328632929636F6E74696E75';
wwv_flow_imp.g_varchar2_table(31076) := '653B732E6164642863293B636F6E737420643D7B636F6465506F696E743A612C726561736F6E3A742E726561736F6E2C696E436F6D6D656E743A742E696E436F6D6D656E742C696E537472696E673A742E696E537472696E677D2C683D6228302C224164';
wwv_flow_imp.g_varchar2_table(31077) := '6A7573742073657474696E677322292C753D60636F6D6D616E643A247B7574652E49447D3F247B656E636F6465555249436F6D706F6E656E74284A534F4E2E737472696E67696679286429297D602C703D6E6577206F632822222C2130292E617070656E';
wwv_flow_imp.g_varchar2_table(31078) := '644D61726B646F776E2863292E617070656E645465787428222022292E617070656E644C696E6B28752C682C747465293B6F2E70757368286E657720427128746869732C652E72616E67652C5B705D2C21312C722B2B29297D72657475726E206F7D7265';
wwv_flow_imp.g_varchar2_table(31079) := '6E646572486F766572506172747328652C74297B72657475726E2066756E6374696F6E28652C742C6E2C692C6F297B742E736F72742865752828653D3E652E6F7264696E616C292C747529293B636F6E737420733D6E65772061743B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(31080) := '742072206F66207429732E616464285771286E2C652E667261676D656E742C722E636F6E74656E74732C692C6F2C652E6F6E436F6E74656E74734368616E67656429293B72657475726E20737D28652C742C746869732E5F656469746F722C746869732E';
wwv_flow_imp.g_varchar2_table(31081) := '5F6C616E6775616765536572766963652C746869732E5F6F70656E657253657276696365297D7D3B66756E6374696F6E206974652865297B72657475726E60552B247B652E746F537472696E67283136292E706164537461727428342C223022297D607D';
wwv_flow_imp.g_varchar2_table(31082) := '66756E6374696F6E206F74652865297B6C657420743D605C60247B6974652865297D5C60603B72657475726E2058692E6973496E76697369626C654368617261637465722865297C7C28742B3D602022247B66756E6374696F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(31083) := '2039363D3D3D653F2260602060206060223A2260222B537472696E672E66726F6D436F6465506F696E742865292B2260227D2865297D2260292C747D66756E6374696F6E2073746528652C74297B72657475726E20567A2E636F6D70757465556E69636F';
wwv_flow_imp.g_varchar2_table(31084) := '6465486967686C69676874526561736F6E28652C74297D6E74653D516565285B59656528312C4C75292C59656528322C6445295D2C6E7465293B636C617373207274657B636F6E7374727563746F7228297B746869732E6D61703D6E6577204D61707D67';
wwv_flow_imp.g_varchar2_table(31085) := '65744465636F726174696F6E46726F6D4F7074696F6E732865297B72657475726E20746869732E6765744465636F726174696F6E2821652E696E636C756465436F6D6D656E74732C21652E696E636C756465537472696E6773297D6765744465636F7261';
wwv_flow_imp.g_varchar2_table(31086) := '74696F6E28652C74297B636F6E7374206E3D60247B657D247B747D603B6C657420693D746869732E6D61702E676574286E293B72657475726E20697C7C28693D4F432E63726561746544796E616D6963287B6465736372697074696F6E3A22756E69636F';
wwv_flow_imp.g_varchar2_table(31087) := '64652D686967686C69676874222C737469636B696E6573733A312C636C6173734E616D653A22756E69636F64652D686967686C69676874222C73686F774966436F6C6C61707365643A21302C6F7665727669657752756C65723A6E756C6C2C6D696E696D';
wwv_flow_imp.g_varchar2_table(31088) := '61703A6E756C6C2C68696465496E436F6D6D656E74546F6B656E733A652C68696465496E537472696E67546F6B656E733A747D292C746869732E6D61702E736574286E2C6929292C697D7D7274652E696E7374616E63653D6E6577207274653B636C6173';
wwv_flow_imp.g_varchar2_table(31089) := '732061746520657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A6374652E49442C6C6162656C3A6228302C2244697361626C6520686967686C69676874696E67206F66206368617261637465727320696E20636F6D';
wwv_flow_imp.g_varchar2_table(31090) := '6D656E747322292C616C6961733A2244697361626C6520686967686C69676874696E67206F66206368617261637465727320696E20636F6D6D656E7473222C707265636F6E646974696F6E3A766F696420307D292C746869732E73686F72744C6162656C';
wwv_flow_imp.g_varchar2_table(31091) := '3D6228302C2244697361626C6520486967686C6967687420496E20436F6D6D656E747322297D6173796E632072756E28652C742C6E297B636F6E737420693D6E756C6C3D3D653F766F696420303A652E676574286670293B692626746869732E72756E41';
wwv_flow_imp.g_varchar2_table(31092) := '6374696F6E2869297D6173796E632072756E416374696F6E2865297B617761697420652E75706461746556616C7565286A4C2C21312C32297D7D636C617373206C746520657874656E64732055647B636F6E7374727563746F7228297B7375706572287B';
wwv_flow_imp.g_varchar2_table(31093) := '69643A6374652E49442C6C6162656C3A6228302C2244697361626C6520686967686C69676874696E67206F66206368617261637465727320696E20737472696E677322292C616C6961733A2244697361626C6520686967686C69676874696E67206F6620';
wwv_flow_imp.g_varchar2_table(31094) := '6368617261637465727320696E20737472696E6773222C707265636F6E646974696F6E3A766F696420307D292C746869732E73686F72744C6162656C3D6228302C2244697361626C6520486967686C6967687420496E20537472696E677322297D617379';
wwv_flow_imp.g_varchar2_table(31095) := '6E632072756E28652C742C6E297B636F6E737420693D6E756C6C3D3D653F766F696420303A652E676574286670293B692626746869732E72756E416374696F6E2869297D6173796E632072756E416374696F6E2865297B617761697420652E7570646174';
wwv_flow_imp.g_varchar2_table(31096) := '6556616C756528714C2C21312C32297D7D636C6173732063746520657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A6374652E49442C6C6162656C3A6228302C2244697361626C6520686967686C69676874696E67';
wwv_flow_imp.g_varchar2_table(31097) := '206F6620616D626967756F7573206368617261637465727322292C616C6961733A2244697361626C6520686967686C69676874696E67206F6620616D626967756F75732063686172616374657273222C707265636F6E646974696F6E3A766F696420307D';
wwv_flow_imp.g_varchar2_table(31098) := '292C746869732E73686F72744C6162656C3D6228302C2244697361626C6520416D626967756F757320486967686C6967687422297D6173796E632072756E28652C742C6E297B636F6E737420693D6E756C6C3D3D653F766F696420303A652E6765742866';
wwv_flow_imp.g_varchar2_table(31099) := '70293B692626746869732E72756E416374696F6E2869297D6173796E632072756E416374696F6E2865297B617761697420652E75706461746556616C756528574C2C21312C32297D7D6374652E49443D22656469746F722E616374696F6E2E756E69636F';
wwv_flow_imp.g_varchar2_table(31100) := '6465486967686C696768742E64697361626C65486967686C69676874696E674F66416D626967756F757343686172616374657273223B636C6173732064746520657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A64';
wwv_flow_imp.g_varchar2_table(31101) := '74652E49442C6C6162656C3A6228302C2244697361626C6520686967686C69676874696E67206F6620696E76697369626C65206368617261637465727322292C616C6961733A2244697361626C6520686967686C69676874696E67206F6620696E766973';
wwv_flow_imp.g_varchar2_table(31102) := '69626C652063686172616374657273222C707265636F6E646974696F6E3A766F696420307D292C746869732E73686F72744C6162656C3D6228302C2244697361626C6520496E76697369626C6520486967686C6967687422297D6173796E632072756E28';
wwv_flow_imp.g_varchar2_table(31103) := '652C742C6E297B636F6E737420693D6E756C6C3D3D653F766F696420303A652E676574286670293B692626746869732E72756E416374696F6E2869297D6173796E632072756E416374696F6E2865297B617761697420652E75706461746556616C756528';
wwv_flow_imp.g_varchar2_table(31104) := '7A4C2C21312C32297D7D6474652E49443D22656469746F722E616374696F6E2E756E69636F6465486967686C696768742E64697361626C65486967686C69676874696E674F66496E76697369626C6543686172616374657273223B636C61737320687465';
wwv_flow_imp.g_varchar2_table(31105) := '20657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A6874652E49442C6C6162656C3A6228302C2244697361626C6520686967686C69676874696E67206F66206E6F6E20626173696320415343494920636861726163';
wwv_flow_imp.g_varchar2_table(31106) := '7465727322292C616C6961733A2244697361626C6520686967686C69676874696E67206F66206E6F6E2062617369632041534349492063686172616374657273222C707265636F6E646974696F6E3A766F696420307D292C746869732E73686F72744C61';
wwv_flow_imp.g_varchar2_table(31107) := '62656C3D6228302C2244697361626C65204E6F6E20415343494920486967686C6967687422297D6173796E632072756E28652C742C6E297B636F6E737420693D6E756C6C3D3D653F766F696420303A652E676574286670293B692626746869732E72756E';
wwv_flow_imp.g_varchar2_table(31108) := '416374696F6E2869297D6173796E632072756E416374696F6E2865297B617761697420652E75706461746556616C756528484C2C21312C32297D7D6874652E49443D22656469746F722E616374696F6E2E756E69636F6465486967686C696768742E6469';
wwv_flow_imp.g_varchar2_table(31109) := '7361626C65486967686C69676874696E674F664E6F6E4261736963417363696943686172616374657273223B636C6173732075746520657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A7574652E49442C6C616265';
wwv_flow_imp.g_varchar2_table(31110) := '6C3A6228302C2253686F77204578636C756465204F7074696F6E7322292C616C6961733A2253686F77204578636C756465204F7074696F6E73222C707265636F6E646974696F6E3A766F696420307D297D6173796E632072756E28652C742C6E297B636F';
wwv_flow_imp.g_varchar2_table(31111) := '6E73747B636F6465506F696E743A692C726561736F6E3A6F2C696E537472696E673A732C696E436F6D6D656E743A727D3D6E2C613D537472696E672E66726F6D436F6465506F696E742869292C6C3D652E676574284C45292C633D652E67657428667029';
wwv_flow_imp.g_varchar2_table(31112) := '2C643D5B5D3B696628303D3D3D6F2E6B696E6429666F7228636F6E73742065206F66206F2E6E6F74416D626967756F7573496E4C6F63616C657329642E70757368287B6C6162656C3A6228302C27416C6C6F7720756E69636F6465206368617261637465';
wwv_flow_imp.g_varchar2_table(31113) := '7273207468617420617265206D6F726520636F6D6D6F6E20696E20746865206C616E677561676520227B307D222E272C65292C72756E3A6173796E6328293D3E7B70746528632C5B655D297D7D293B696628642E70757368287B6C6162656C3A66756E63';
wwv_flow_imp.g_varchar2_table(31114) := '74696F6E2865297B72657475726E2058692E6973496E76697369626C654368617261637465722865293F6228302C224578636C756465207B307D2028696E76697369626C6520636861726163746572292066726F6D206265696E6720686967686C696768';
wwv_flow_imp.g_varchar2_table(31115) := '746564222C697465286529293A6228302C224578636C756465207B307D2066726F6D206265696E6720686967686C696768746564222C60247B6974652865297D2022247B617D2260297D2869292C72756E3A28293D3E6173796E632066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(31116) := '28652C74297B636F6E7374206E3D652E67657456616C756528564C293B6C657420693B693D226F626A656374223D3D747970656F66206E26266E3F6E3A7B7D3B666F7228636F6E73742065206F66207429695B537472696E672E66726F6D436F6465506F';
wwv_flow_imp.g_varchar2_table(31117) := '696E742865295D3D21303B617761697420652E75706461746556616C756528564C2C692C32297D28632C5B695D297D292C72297B636F6E737420653D6E6577206174653B642E70757368287B6C6162656C3A652E6C6162656C2C72756E3A6173796E6328';
wwv_flow_imp.g_varchar2_table(31118) := '293D3E652E72756E416374696F6E2863297D297D656C73652069662873297B636F6E737420653D6E6577206C74653B642E70757368287B6C6162656C3A652E6C6162656C2C72756E3A6173796E6328293D3E652E72756E416374696F6E2863297D297D69';
wwv_flow_imp.g_varchar2_table(31119) := '6628303D3D3D6F2E6B696E64297B636F6E737420653D6E6577206374653B642E70757368287B6C6162656C3A652E6C6162656C2C72756E3A6173796E6328293D3E652E72756E416374696F6E2863297D297D656C736520696628313D3D3D6F2E6B696E64';
wwv_flow_imp.g_varchar2_table(31120) := '297B636F6E737420653D6E6577206474653B642E70757368287B6C6162656C3A652E6C6162656C2C72756E3A6173796E6328293D3E652E72756E416374696F6E2863297D297D656C736520696628323D3D3D6F2E6B696E64297B636F6E737420653D6E65';
wwv_flow_imp.g_varchar2_table(31121) := '77206874653B642E70757368287B6C6162656C3A652E6C6162656C2C72756E3A6173796E6328293D3E652E72756E416374696F6E2863297D297D656C73652166756E6374696F6E2865297B7468726F77206E6577204572726F722860556E657870656374';
wwv_flow_imp.g_varchar2_table(31122) := '65642076616C75653A20247B657D60297D286F293B636F6E737420683D6177616974206C2E7069636B28642C7B7469746C653A7474657D293B682626617761697420682E72756E28297D7D6173796E632066756E6374696F6E2070746528652C74297B76';
wwv_flow_imp.g_varchar2_table(31123) := '6172206E3B636F6E737420693D6E756C6C3D3D3D286E3D652E696E737065637428244C292E75736572297C7C766F696420303D3D3D6E3F766F696420303A6E2E76616C75653B6C6574206F3B6F3D226F626A656374223D3D747970656F6620692626693F';
wwv_flow_imp.g_varchar2_table(31124) := '4F626A6563742E61737369676E287B7D2C69293A7B7D3B666F7228636F6E73742065206F662074296F5B655D3D21303B617761697420652E75706461746556616C756528244C2C6F2C32297D7574652E49443D22656469746F722E616374696F6E2E756E';
wwv_flow_imp.g_varchar2_table(31125) := '69636F6465486967686C696768742E73686F774578636C7564654F7074696F6E73222C5A6428637465292C5A6428647465292C5A6428687465292C5A6428757465292C4A64285865652E49442C5865652C31292C44712E7265676973746572286E746529';
wwv_flow_imp.g_varchar2_table(31126) := '3B766172206774653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374206D74653D2269676E6F7265556E757375616C4C696E655465726D696E61746F7273223B6C657420';
wwv_flow_imp.g_varchar2_table(31127) := '6674653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F656469746F723D652C746869732E5F6469616C6F67536572766963653D742C746869732E5F636F6465456469746F';
wwv_flow_imp.g_varchar2_table(31128) := '72536572766963653D6E2C746869732E5F697350726573656E74696E674469616C6F673D21312C746869732E5F636F6E6669673D746869732E5F656469746F722E6765744F7074696F6E28313236292C746869732E5F726567697374657228746869732E';
wwv_flow_imp.g_varchar2_table(31129) := '5F656469746F722E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E6861734368616E6765642831323629262628746869732E5F636F6E6669673D746869732E5F656469746F722E6765744F7074696F6E28313236292C74';
wwv_flow_imp.g_varchar2_table(31130) := '6869732E5F636865636B466F72556E757375616C4C696E655465726D696E61746F72732829297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C282828293D3E7B746869732E5F';
wwv_flow_imp.g_varchar2_table(31131) := '636865636B466F72556E757375616C4C696E655465726D696E61746F727328297D2929292C746869732E5F726567697374657228746869732E5F656469746F722E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B652E6973556E';
wwv_flow_imp.g_varchar2_table(31132) := '646F696E677C7C746869732E5F636865636B466F72556E757375616C4C696E655465726D696E61746F727328297D2929292C746869732E5F636865636B466F72556E757375616C4C696E655465726D696E61746F727328297D6173796E63205F63686563';
wwv_flow_imp.g_varchar2_table(31133) := '6B466F72556E757375616C4C696E655465726D696E61746F727328297B696628226F6666223D3D3D746869732E5F636F6E6669672972657475726E3B69662821746869732E5F656469746F722E6861734D6F64656C28292972657475726E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(31134) := '20653D746869732E5F656469746F722E6765744D6F64656C28293B69662821652E6D69676874436F6E7461696E556E757375616C4C696E655465726D696E61746F727328292972657475726E3B636F6E737420743D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(31135) := '657475726E20652E6765744D6F64656C50726F706572747928742E7572692C6D7465297D28746869732E5F636F6465456469746F72536572766963652C65293B69662821303D3D3D742972657475726E3B696628746869732E5F656469746F722E676574';
wwv_flow_imp.g_varchar2_table(31136) := '4F7074696F6E283931292972657475726E3B696628226175746F223D3D3D746869732E5F636F6E6669672972657475726E20766F696420652E72656D6F7665556E757375616C4C696E655465726D696E61746F727328746869732E5F656469746F722E67';
wwv_flow_imp.g_varchar2_table(31137) := '657453656C656374696F6E732829293B696628746869732E5F697350726573656E74696E674469616C6F672972657475726E3B6C6574206E3B7472797B746869732E5F697350726573656E74696E674469616C6F673D21302C6E3D617761697420746869';
wwv_flow_imp.g_varchar2_table(31138) := '732E5F6469616C6F67536572766963652E636F6E6669726D287B7469746C653A6228302C22556E757375616C204C696E65205465726D696E61746F727322292C6D6573736167653A6228302C22446574656374656420756E757375616C206C696E652074';
wwv_flow_imp.g_varchar2_table(31139) := '65726D696E61746F727322292C64657461696C3A6228302C225468652066696C6520277B307D2720636F6E7461696E73206F6E65206F72206D6F726520756E757375616C206C696E65207465726D696E61746F7220636861726163746572732C206C696B';
wwv_flow_imp.g_varchar2_table(31140) := '65204C696E6520536570617261746F7220284C5329206F722050617261677261706820536570617261746F7220285053292E5C6E5C6E4974206973207265636F6D6D656E64656420746F2072656D6F7665207468656D2066726F6D207468652066696C65';
wwv_flow_imp.g_varchar2_table(31141) := '2E20546869732063616E20626520636F6E66696775726564207669612060656469746F722E756E757375616C4C696E655465726D696E61746F7273602E222C476C28652E75726929292C7072696D617279427574746F6E3A6228302C22262652656D6F76';
wwv_flow_imp.g_varchar2_table(31142) := '6520556E757375616C204C696E65205465726D696E61746F727322292C63616E63656C427574746F6E3A6228302C2249676E6F726522297D297D66696E616C6C797B746869732E5F697350726573656E74696E674469616C6F673D21317D6E2E636F6E66';
wwv_flow_imp.g_varchar2_table(31143) := '69726D65643F652E72656D6F7665556E757375616C4C696E655465726D696E61746F727328746869732E5F656469746F722E67657453656C656374696F6E732829293A66756E6374696F6E28652C74297B652E7365744D6F64656C50726F706572747928';
wwv_flow_imp.g_varchar2_table(31144) := '742E7572692C6D74652C2130297D28746869732E5F636F6465456469746F72536572766963652C65297D7D3B6674652E49443D22656469746F722E636F6E747269622E756E757375616C4C696E655465726D696E61746F72734465746563746F72222C66';
wwv_flow_imp.g_varchar2_table(31145) := '74653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E';
wwv_flow_imp.g_varchar2_table(31146) := '293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73';
wwv_flow_imp.g_varchar2_table(31147) := '6520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563';
wwv_flow_imp.g_varchar2_table(31148) := '742E646566696E6550726F706572747928742C6E2C72292C727D285B67746528312C5837292C67746528322C6763295D2C667465292C4A64286674652E49442C6674652C31293B636F6E7374207674653D222A2A222C6274653D222F222C5F74653D225B';
wwv_flow_imp.g_varchar2_table(31149) := '2F5C5C5C5C5D222C7974653D225B5E2F5C5C5C5C5D222C7774653D2F5C2F2F673B66756E6374696F6E2043746528652C74297B7377697463682865297B6361736520303A72657475726E22223B6361736520313A72657475726E60247B7974657D2A3F60';
wwv_flow_imp.g_varchar2_table(31150) := '3B64656661756C743A72657475726E60283F3A247B5F74657D7C247B7974657D2B247B5F74657D247B743F607C247B5F74657D247B7974657D2B603A22227D292A3F607D7D66756E6374696F6E2053746528652C74297B69662821652972657475726E5B';
wwv_flow_imp.g_varchar2_table(31151) := '5D3B636F6E7374206E3D5B5D3B6C657420693D21312C6F3D21312C733D22223B666F7228636F6E73742072206F662065297B7377697463682872297B6361736520743A69662821692626216F297B6E2E707573682873292C733D22223B636F6E74696E75';
wwv_flow_imp.g_varchar2_table(31152) := '657D627265616B3B63617365227B223A693D21303B627265616B3B63617365227D223A693D21313B627265616B3B63617365225B223A6F3D21303B627265616B3B63617365225D223A6F3D21317D732B3D727D72657475726E207326266E2E7075736828';
wwv_flow_imp.g_varchar2_table(31153) := '73292C6E7D66756E6374696F6E207874652865297B69662821652972657475726E22223B6C657420743D22223B636F6E7374206E3D53746528652C627465293B6966286E2E65766572792828653D3E653D3D3D767465292929743D222E2A223B656C7365';
wwv_flow_imp.g_varchar2_table(31154) := '7B6C657420653D21313B6E2E666F7245616368282828692C6F293D3E7B696628693D3D3D767465297B696628652972657475726E3B742B3D43746528322C6F3D3D3D6E2E6C656E6774682D31297D656C73657B6C657420653D21312C733D22222C723D21';
wwv_flow_imp.g_varchar2_table(31155) := '312C613D22223B666F7228636F6E7374206E206F66206929696628227D22213D3D6E26266529732B3D6E3B656C73652069662821727C7C225D223D3D3D6E26266129737769746368286E297B63617365227B223A653D21303B636F6E74696E75653B6361';
wwv_flow_imp.g_varchar2_table(31156) := '7365225B223A723D21303B636F6E74696E75653B63617365227D223A7B636F6E7374206E3D60283F3A247B53746528732C222C22292E6D61702828653D3E78746528652929292E6A6F696E28227C22297D29603B742B3D6E2C653D21312C733D22223B62';
wwv_flow_imp.g_varchar2_table(31157) := '7265616B7D63617365225D223A742B3D225B222B612B225D222C723D21312C613D22223B627265616B3B63617365223F223A742B3D7974653B636F6E74696E75653B63617365222A223A742B3D4374652831293B636F6E74696E75653B64656661756C74';
wwv_flow_imp.g_varchar2_table(31158) := '3A742B3D6369286E297D656C73657B6C657420653B653D222D223D3D3D6E3F6E3A225E22213D3D6E2626222122213D3D6E7C7C613F6E3D3D3D6274653F22223A6369286E293A225E222C612B3D657D6F3C6E2E6C656E6774682D312626286E5B6F2B315D';
wwv_flow_imp.g_varchar2_table(31159) := '213D3D7674657C7C6F2B323C6E2E6C656E67746829262628742B3D5F7465297D653D693D3D3D7674657D29297D72657475726E20747D636F6E7374206B74653D2F5E5C2A5C2A5C2F5C2A5C2E5B5C775C2E2D5D2B242F2C4574653D2F5E5C2A5C2A5C2F28';
wwv_flow_imp.g_varchar2_table(31160) := '5B5C775C2E2D5D2B295C2F3F242F2C4C74653D2F5E7B5C2A5C2A5C2F5C2A3F5B5C775C2E2D5D2B5C2F3F282C5C2A5C2A5C2F5C2A3F5B5C775C2E2D5D2B5C2F3F292A7D242F2C4474653D2F5E7B5C2A5C2A5C2F5C2A3F5B5C775C2E2D5D2B285C2F285C2A';
wwv_flow_imp.g_varchar2_table(31161) := '5C2A293F293F282C5C2A5C2A5C2F5C2A3F5B5C775C2E2D5D2B285C2F285C2A5C2A293F293F292A7D242F2C5474653D2F5E5C2A5C2A28285C2F5B5C775C2E2D5D2B292B295C2F3F242F2C4974653D2F5E285B5C775C2E2D5D2B285C2F5B5C775C2E2D5D2B';
wwv_flow_imp.g_varchar2_table(31162) := '292A295C2F3F242F2C4D74653D6E657720616128316534292C4174653D66756E6374696F6E28297B72657475726E21317D2C4E74653D66756E6374696F6E28297B72657475726E206E756C6C7D3B66756E6374696F6E2050746528652C74297B69662821';
wwv_flow_imp.g_varchar2_table(31163) := '652972657475726E204E74653B6C6574206E3B6E3D22737472696E6722213D747970656F6620653F652E7061747465726E3A652C6E3D6E2E7472696D28293B636F6E737420693D60247B6E7D5F247B2121742E7472696D466F724578636C7573696F6E73';
wwv_flow_imp.g_varchar2_table(31164) := '7D603B6C6574206F2C733D4D74652E6765742869293B72657475726E20737C7C28733D6B74652E74657374286E293F66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B72657475726E22737472696E67223D3D7479';
wwv_flow_imp.g_varchar2_table(31165) := '70656F66206E26266E2E656E6473576974682865293F743A6E756C6C7D7D286E2E7375627374722834292C6E293A286F3D4574652E65786563284F7465286E2C742929293F66756E6374696F6E28652C74297B636F6E7374206E3D602F247B657D602C69';
wwv_flow_imp.g_varchar2_table(31166) := '3D605C5C247B657D602C6F3D66756E6374696F6E286F2C73297B72657475726E22737472696E6722213D747970656F66206F3F6E756C6C3A733F733D3D3D653F743A6E756C6C3A6F3D3D3D657C7C6F2E656E647357697468286E297C7C6F2E656E647357';
wwv_flow_imp.g_varchar2_table(31167) := '6974682869293F743A6E756C6C7D2C733D5B655D3B72657475726E206F2E626173656E616D65733D732C6F2E7061747465726E733D5B745D2C6F2E616C6C426173656E616D65733D732C6F7D286F5B315D2C6E293A28742E7472696D466F724578636C75';
wwv_flow_imp.g_varchar2_table(31168) := '73696F6E733F4474653A4C7465292E74657374286E293F66756E6374696F6E28652C74297B636F6E7374206E3D42746528652E736C69636528312C2D31292E73706C697428222C22292E6D61702828653D3E50746528652C742929292E66696C74657228';
wwv_flow_imp.g_varchar2_table(31169) := '28653D3E65213D3D4E746529292C65292C693D6E2E6C656E6774683B69662821692972657475726E204E74653B696628313D3D3D692972657475726E206E5B305D3B636F6E7374206F3D66756E6374696F6E28742C69297B666F72286C6574206F3D302C';
wwv_flow_imp.g_varchar2_table(31170) := '733D6E2E6C656E6774683B6F3C733B6F2B2B296966286E5B6F5D28742C69292972657475726E20653B72657475726E206E756C6C7D2C733D6E2E66696E642828653D3E2121652E616C6C426173656E616D657329293B732626286F2E616C6C426173656E';
wwv_flow_imp.g_varchar2_table(31171) := '616D65733D732E616C6C426173656E616D6573293B636F6E737420723D6E2E726564756365282828652C74293D3E742E616C6C50617468733F652E636F6E63617428742E616C6C5061746873293A65292C5B5D293B72657475726E20722E6C656E677468';
wwv_flow_imp.g_varchar2_table(31172) := '2626286F2E616C6C50617468733D72292C6F7D286E2C74293A286F3D5474652E65786563284F7465286E2C742929293F527465286F5B315D2E7375627374722831292C6E2C2130293A286F3D4974652E65786563284F7465286E2C742929293F52746528';
wwv_flow_imp.g_varchar2_table(31173) := '6F5B315D2C6E2C2131293A66756E6374696F6E2865297B7472797B636F6E737420743D6E65772052656745787028605E247B7874652865297D2460293B72657475726E2066756E6374696F6E286E297B72657475726E20742E6C617374496E6465783D30';
wwv_flow_imp.g_varchar2_table(31174) := '2C22737472696E67223D3D747970656F66206E2626742E74657374286E293F653A6E756C6C7D7D63617463682865297B72657475726E204E74657D7D286E292C4D74652E73657428692C7329292C66756E6374696F6E28652C74297B6966282273747269';
wwv_flow_imp.g_varchar2_table(31175) := '6E67223D3D747970656F6620742972657475726E20653B636F6E7374206E3D66756E6374696F6E286E2C69297B72657475726E20486C286E2C742E626173652C2124293F65286869286E2E73756273747228742E626173652E6C656E677468292C456F29';
wwv_flow_imp.g_varchar2_table(31176) := '2C69293A6E756C6C7D3B72657475726E206E2E616C6C426173656E616D65733D652E616C6C426173656E616D65732C6E2E616C6C50617468733D652E616C6C50617468732C6E2E626173656E616D65733D652E626173656E616D65732C6E2E7061747465';
wwv_flow_imp.g_varchar2_table(31177) := '726E733D652E7061747465726E732C6E7D28732C65297D66756E6374696F6E204F746528652C74297B72657475726E20742E7472696D466F724578636C7573696F6E732626652E656E64735769746828222F2A2A22293F652E73756273747228302C652E';
wwv_flow_imp.g_varchar2_table(31178) := '6C656E6774682D32293A657D66756E6374696F6E2052746528652C742C6E297B636F6E737420693D456F3D3D3D5F6F2E7365702C6F3D693F653A652E7265706C616365287774652C456F292C733D456F2B6F2C723D5F6F2E7365702B653B6C657420613B';
wwv_flow_imp.g_varchar2_table(31179) := '72657475726E20613D6E3F66756E6374696F6E286E2C61297B72657475726E22737472696E6722213D747970656F66206E7C7C6E213D3D6F2626216E2E656E647357697468287329262628697C7C6E213D3D652626216E2E656E64735769746828722929';
wwv_flow_imp.g_varchar2_table(31180) := '3F6E756C6C3A747D3A66756E6374696F6E286E2C73297B72657475726E22737472696E6722213D747970656F66206E7C7C6E213D3D6F262628697C7C6E213D3D65293F6E756C6C3A747D2C612E616C6C50617468733D5B286E3F222A2F223A222E2F2229';
wwv_flow_imp.g_varchar2_table(31181) := '2B655D2C617D66756E6374696F6E2046746528652C743D7B7D297B69662821652972657475726E204174653B69662822737472696E67223D3D747970656F6620657C7C66756E6374696F6E2865297B636F6E737420743D653B72657475726E2121742626';
wwv_flow_imp.g_varchar2_table(31182) := '2822737472696E67223D3D747970656F6620742E62617365262622737472696E67223D3D747970656F6620742E7061747465726E297D286529297B636F6E7374206E3D50746528652C74293B6966286E3D3D3D4E74652972657475726E204174653B636F';
wwv_flow_imp.g_varchar2_table(31183) := '6E737420693D66756E6374696F6E28652C74297B72657475726E21216E28652C74297D3B72657475726E206E2E616C6C426173656E616D6573262628692E616C6C426173656E616D65733D6E2E616C6C426173656E616D6573292C6E2E616C6C50617468';
wwv_flow_imp.g_varchar2_table(31184) := '73262628692E616C6C50617468733D6E2E616C6C5061746873292C697D72657475726E2066756E6374696F6E28652C74297B636F6E7374206E3D427465284F626A6563742E6765744F776E50726F70657274794E616D65732865292E6D617028286E3D3E';
wwv_flow_imp.g_varchar2_table(31185) := '66756E6374696F6E28652C742C6E297B69662821313D3D3D742972657475726E204E74653B636F6E737420693D50746528652C6E293B696628693D3D3D4E74652972657475726E204E74653B69662822626F6F6C65616E223D3D747970656F6620742972';
wwv_flow_imp.g_varchar2_table(31186) := '657475726E20693B69662874297B636F6E7374206E3D742E7768656E3B69662822737472696E67223D3D747970656F66206E297B636F6E737420743D28742C6F2C732C72293D3E7B69662821727C7C216928742C6F292972657475726E206E756C6C3B63';
wwv_flow_imp.g_varchar2_table(31187) := '6F6E737420613D72286E2E7265706C61636528222428626173656E616D6529222C2828293D3E732929293B72657475726E2052742861293F612E7468656E2828743D3E743F653A6E756C6C29293A613F653A6E756C6C7D3B72657475726E20742E726571';
wwv_flow_imp.g_varchar2_table(31188) := '75697265735369626C696E67733D21302C747D7D72657475726E20697D286E2C655B6E5D2C742929292E66696C7465722828653D3E65213D3D4E74652929292C693D6E2E6C656E6774683B69662821692972657475726E204E74653B696628216E2E736F';
wwv_flow_imp.g_varchar2_table(31189) := '6D652828653D3E2121652E72657175697265735369626C696E67732929297B696628313D3D3D692972657475726E206E5B305D3B636F6E737420653D66756E6374696F6E28652C74297B6C657420693B666F72286C6574206F3D302C733D6E2E6C656E67';
wwv_flow_imp.g_varchar2_table(31190) := '74683B6F3C733B6F2B2B297B636F6E737420733D6E5B6F5D28652C74293B69662822737472696E67223D3D747970656F6620732972657475726E20733B5274287329262628697C7C28693D5B5D292C692E70757368287329297D72657475726E20693F28';
wwv_flow_imp.g_varchar2_table(31191) := '6173796E6328293D3E7B666F7228636F6E73742065206F662069297B636F6E737420743D617761697420653B69662822737472696E67223D3D747970656F6620742972657475726E20747D72657475726E206E756C6C7D2928293A6E756C6C7D2C743D6E';
wwv_flow_imp.g_varchar2_table(31192) := '2E66696E642828653D3E2121652E616C6C426173656E616D657329293B74262628652E616C6C426173656E616D65733D742E616C6C426173656E616D6573293B636F6E7374206F3D6E2E726564756365282828652C74293D3E742E616C6C50617468733F';
wwv_flow_imp.g_varchar2_table(31193) := '652E636F6E63617428742E616C6C5061746873293A65292C5B5D293B72657475726E206F2E6C656E677468262628652E616C6C50617468733D6F292C657D636F6E7374206F3D66756E6374696F6E28652C742C69297B6C6574206F2C733B666F72286C65';
wwv_flow_imp.g_varchar2_table(31194) := '7420723D302C613D6E2E6C656E6774683B723C613B722B2B297B636F6E737420613D6E5B725D3B612E72657175697265735369626C696E6773262669262628747C7C28743D786F286529292C6F7C7C286F3D742E73756273747228302C742E6C656E6774';
wwv_flow_imp.g_varchar2_table(31195) := '682D6B6F2865292E6C656E6774682929293B636F6E7374206C3D6128652C742C6F2C69293B69662822737472696E67223D3D747970656F66206C2972657475726E206C3B5274286C29262628737C7C28733D5B5D292C732E70757368286C29297D726574';
wwv_flow_imp.g_varchar2_table(31196) := '75726E20733F286173796E6328293D3E7B666F7228636F6E73742065206F662073297B636F6E737420743D617761697420653B69662822737472696E67223D3D747970656F6620742972657475726E20747D72657475726E206E756C6C7D2928293A6E75';
wwv_flow_imp.g_varchar2_table(31197) := '6C6C7D2C733D6E2E66696E642828653D3E2121652E616C6C426173656E616D657329293B732626286F2E616C6C426173656E616D65733D732E616C6C426173656E616D6573293B636F6E737420723D6E2E726564756365282828652C74293D3E742E616C';
wwv_flow_imp.g_varchar2_table(31198) := '6C50617468733F652E636F6E63617428742E616C6C5061746873293A65292C5B5D293B72657475726E20722E6C656E6774682626286F2E616C6C50617468733D72292C6F7D28652C74297D66756E6374696F6E2042746528652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(31199) := '3D652E66696C7465722828653D3E2121652E626173656E616D657329293B6966286E2E6C656E6774683C322972657475726E20653B636F6E737420693D6E2E726564756365282828652C74293D3E7B636F6E7374206E3D742E626173656E616D65733B72';
wwv_flow_imp.g_varchar2_table(31200) := '657475726E206E3F652E636F6E636174286E293A657D292C5B5D293B6C6574206F3B69662874297B6F3D5B5D3B666F72286C657420653D302C6E3D692E6C656E6774683B653C6E3B652B2B296F2E707573682874297D656C7365206F3D6E2E7265647563';
wwv_flow_imp.g_varchar2_table(31201) := '65282828652C74293D3E7B636F6E7374206E3D742E7061747465726E733B72657475726E206E3F652E636F6E636174286E293A657D292C5B5D293B636F6E737420733D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F66';
wwv_flow_imp.g_varchar2_table(31202) := '20652972657475726E206E756C6C3B6966282174297B6C6574206E3B666F72286E3D652E6C656E6774683B6E3E303B6E2D2D297B636F6E737420743D652E63686172436F64654174286E2D31293B69662834373D3D3D747C7C39323D3D3D742962726561';
wwv_flow_imp.g_varchar2_table(31203) := '6B7D743D652E737562737472286E297D636F6E7374206E3D692E696E6465784F662874293B72657475726E2D31213D3D6E3F6F5B6E5D3A6E756C6C7D3B732E626173656E616D65733D692C732E7061747465726E733D6F2C732E616C6C426173656E616D';
wwv_flow_imp.g_varchar2_table(31204) := '65733D693B636F6E737420723D652E66696C7465722828653D3E21652E626173656E616D657329293B72657475726E20722E707573682873292C727D66756E6374696F6E2056746528652C742C6E2C692C6F2C73297B69662841727261792E6973417272';
wwv_flow_imp.g_varchar2_table(31205) := '6179286529297B6C657420723D303B666F7228636F6E73742061206F662065297B636F6E737420653D56746528612C742C6E2C692C6F2C73293B69662831303D3D3D652972657475726E20653B653E72262628723D65297D72657475726E20727D696628';
wwv_flow_imp.g_varchar2_table(31206) := '22737472696E67223D3D747970656F6620652972657475726E20693F222A223D3D3D653F353A653D3D3D6E3F31303A303A303B69662865297B636F6E73747B6C616E67756167653A6C2C7061747465726E3A632C736368656D653A642C68617341636365';
wwv_flow_imp.g_varchar2_table(31207) := '7373546F416C6C4D6F64656C733A682C6E6F7465626F6F6B547970653A757D3D653B6966282169262621682972657475726E20303B7526266F262628743D6F293B6C657420703D303B6966286429696628643D3D3D742E736368656D6529703D31303B65';
wwv_flow_imp.g_varchar2_table(31208) := '6C73657B696628222A22213D3D642972657475726E20303B703D357D6966286C296966286C3D3D3D6E29703D31303B656C73657B696628222A22213D3D6C2972657475726E20303B703D4D6174682E6D617828702C35297D6966287529696628753D3D3D';
wwv_flow_imp.g_varchar2_table(31209) := '7329703D31303B656C73657B696628222A22213D3D757C7C766F696420303D3D3D732972657475726E20303B703D4D6174682E6D617828702C35297D69662863297B6C657420653B696628653D22737472696E67223D3D747970656F6620633F633A7B2E';
wwv_flow_imp.g_varchar2_table(31210) := '2E2E632C626173653A796F28632E62617365297D2C65213D3D742E667350617468262628723D652C613D742E6673506174682C21727C7C22737472696E6722213D747970656F6620617C7C2146746528722928612C766F696420302C756E646566696E65';
wwv_flow_imp.g_varchar2_table(31211) := '6429292972657475726E20303B703D31307D72657475726E20707D72657475726E20303B76617220722C617D766172207A74652C4874652C5774653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E67';
wwv_flow_imp.g_varchar2_table(31212) := '74682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(31213) := '3D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628';
wwv_flow_imp.g_varchar2_table(31214) := '723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C6A74653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(31215) := '297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374207174653D6E6577206C642822686173576F7264486967686C6967687473222C2131293B66756E6374696F6E2024746528652C742C6E2C69297B726574';
wwv_flow_imp.g_varchar2_table(31216) := '75726E20717428652E6F7264657265642874292E6D61702828653D3E28293D3E50726F6D6973652E7265736F6C766528652E70726F76696465446F63756D656E74486967686C696768747328742C6E2C6929292E7468656E28766F696420302C45652929';
wwv_flow_imp.g_varchar2_table(31217) := '292C6A68292E7468656E2828653D3E7B69662865297B636F6E7374206E3D6E6577206F613B72657475726E206E2E73657428742E7572692C65292C6E7D72657475726E206E6577206F617D29297D636C617373205574657B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(31218) := '652C742C6E297B746869732E5F6D6F64656C3D652C746869732E5F73656C656374696F6E3D742C746869732E5F776F7264536570617261746F72733D6E2C746869732E5F776F726452616E67653D746869732E5F67657443757272656E74576F72645261';
wwv_flow_imp.g_varchar2_table(31219) := '6E676528652C74292C746869732E5F726573756C743D6E756C6C7D67657420726573756C7428297B72657475726E20746869732E5F726573756C747C7C28746869732E5F726573756C743D46742828653D3E746869732E5F636F6D707574652874686973';
wwv_flow_imp.g_varchar2_table(31220) := '2E5F6D6F64656C2C746869732E5F73656C656374696F6E2C746869732E5F776F7264536570617261746F72732C65292929292C746869732E5F726573756C747D5F67657443757272656E74576F726452616E676528652C74297B636F6E7374206E3D652E';
wwv_flow_imp.g_varchar2_table(31221) := '676574576F72644174506F736974696F6E28742E676574506F736974696F6E2829293B72657475726E206E3F6E657720726828742E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2C742E73746172744C696E654E756D626572';
wwv_flow_imp.g_varchar2_table(31222) := '2C6E2E656E64436F6C756D6E293A6E756C6C7D697356616C696428652C742C6E297B636F6E737420693D742E73746172744C696E654E756D6265722C6F3D742E7374617274436F6C756D6E2C733D742E656E64436F6C756D6E2C723D746869732E5F6765';
wwv_flow_imp.g_varchar2_table(31223) := '7443757272656E74576F726452616E676528652C74293B6C657420613D426F6F6C65616E28746869732E5F776F726452616E67652626746869732E5F776F726452616E67652E657175616C7352616E6765287229293B666F72286C657420653D302C743D';
wwv_flow_imp.g_varchar2_table(31224) := '6E2E6C656E6774683B21612626653C743B652B2B297B636F6E737420743D6E2E67657452616E67652865293B742626742E73746172744C696E654E756D6265723D3D3D692626742E7374617274436F6C756D6E3C3D6F2626742E656E64436F6C756D6E3E';
wwv_flow_imp.g_varchar2_table(31225) := '3D73262628613D2130297D72657475726E20617D63616E63656C28297B746869732E726573756C742E63616E63656C28297D7D636C617373204B746520657874656E6473205574657B636F6E7374727563746F7228652C742C6E2C69297B737570657228';
wwv_flow_imp.g_varchar2_table(31226) := '652C742C6E292C746869732E5F70726F7669646572733D697D5F636F6D7075746528652C742C6E2C69297B72657475726E2024746528746869732E5F70726F7669646572732C652C742E676574506F736974696F6E28292C69292E7468656E2828653D3E';
wwv_flow_imp.g_varchar2_table(31227) := '657C7C6E6577206F6129297D7D636C6173732047746520657874656E6473205574657B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228652C742C6E292C746869732E5F70726F7669646572733D692C746869732E5F6F74686572';
wwv_flow_imp.g_varchar2_table(31228) := '4D6F64656C733D6F7D5F636F6D7075746528652C742C6E2C69297B72657475726E2066756E6374696F6E28652C742C6E2C692C6F2C73297B72657475726E20717428652E6F7264657265642874292E6D61702828653D3E28293D3E7B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(31229) := '732E66696C7465722828653D3E416828652929292E66696C7465722828743D3E56746528652E73656C6563746F722C742E7572692C742E6765744C616E6775616765496428292C21302C766F696420302C766F69642030293E3029293B72657475726E20';
wwv_flow_imp.g_varchar2_table(31230) := '50726F6D6973652E7265736F6C766528652E70726F766964654D756C7469446F63756D656E74486967686C696768747328742C6E2C692C6F29292E7468656E28766F696420302C4565297D29292C28653D3E6520696E7374616E63656F66206F61262665';
wwv_flow_imp.g_varchar2_table(31231) := '2E73697A653E3029297D28746869732E5F70726F7669646572732C652C742E676574506F736974696F6E28292C302C692C746869732E5F6F746865724D6F64656C73292E7468656E2828653D3E657C7C6E6577206F6129297D7D636C6173732051746520';
wwv_flow_imp.g_varchar2_table(31232) := '657874656E6473205574657B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228652C742C69292C746869732E5F6F746865724D6F64656C733D6F2C746869732E5F73656C656374696F6E4973456D7074793D742E6973456D707479';
wwv_flow_imp.g_varchar2_table(31233) := '28292C746869732E5F776F72643D6E7D5F636F6D7075746528652C742C6E2C69297B72657475726E205774283235302C69292E7468656E282828293D3E7B636F6E737420693D6E6577206F613B6C6574206F3B6966286F3D746869732E5F776F72643F74';
wwv_flow_imp.g_varchar2_table(31234) := '6869732E5F776F72643A652E676574576F72644174506F736974696F6E28742E676574506F736974696F6E2829292C216F2972657475726E206E6577206F613B636F6E737420733D5B652C2E2E2E746869732E5F6F746865724D6F64656C735D3B666F72';
wwv_flow_imp.g_varchar2_table(31235) := '28636F6E73742065206F662073297B696628652E6973446973706F736564282929636F6E74696E75653B636F6E737420743D652E66696E644D617463686573286F2E776F72642C21302C21312C21302C6E2C2131292E6D61702828653D3E287B72616E67';
wwv_flow_imp.g_varchar2_table(31236) := '653A652E72616E67652C6B696E643A78772E546578747D2929293B742626692E73657428652E7572692C74297D72657475726E20697D29297D697356616C696428652C742C6E297B636F6E737420693D742E6973456D70747928293B72657475726E2074';
wwv_flow_imp.g_varchar2_table(31237) := '6869732E5F73656C656374696F6E4973456D7074793D3D3D69262673757065722E697356616C696428652C742C6E297D7D516428225F65786563757465446F63756D656E74486967686C6967687473222C286173796E6328652C742C6E293D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(31238) := '737420693D652E676574287878292C6F3D61776169742024746528692E646F63756D656E74486967686C6967687450726F76696465722C742C6E2C4D742E4E6F6E65293B72657475726E206E756C6C3D3D6F3F766F696420303A6F2E67657428742E7572';
wwv_flow_imp.g_varchar2_table(31239) := '69297D29293B6C6574205974653D7A74653D636C6173737B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E746F556E686F6F6B3D6E65772061742C746869732E776F726B657252657175657374546F6B656E49643D302C74686973';
wwv_flow_imp.g_varchar2_table(31240) := '2E776F726B657252657175657374436F6D706C657465643D21312C746869732E776F726B65725265717565737456616C75653D6E6577206F612C746869732E6C617374437572736F72506F736974696F6E4368616E676554696D653D302C746869732E72';
wwv_flow_imp.g_varchar2_table(31241) := '656E6465724465636F726174696F6E7354696D65723D2D312C746869732E656469746F723D652C746869732E70726F7669646572733D742C746869732E6D756C7469446F63756D656E7450726F7669646572733D6E2C746869732E636F6465456469746F';
wwv_flow_imp.g_varchar2_table(31242) := '72536572766963653D6F2C746869732E5F686173576F7264486967686C69676874733D7174652E62696E64546F2869292C746869732E5F69676E6F7265506F736974696F6E4368616E67654576656E743D21312C746869732E6F6363757272656E636573';
wwv_flow_imp.g_varchar2_table(31243) := '486967686C696768743D746869732E656469746F722E6765744F7074696F6E283831292C746869732E6D6F64656C3D746869732E656469746F722E6765744D6F64656C28292C746869732E746F556E686F6F6B2E61646428652E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(31244) := '65437572736F72506F736974696F6E2828653D3E7B746869732E5F69676E6F7265506F736974696F6E4368616E67654576656E747C7C226F666622213D3D746869732E6F6363757272656E636573486967686C696768742626746869732E5F6F6E506F73';
wwv_flow_imp.g_varchar2_table(31245) := '6974696F6E4368616E6765642865297D2929292C746869732E746F556E686F6F6B2E61646428652E6F6E446964466F637573456469746F72546578742828653D3E7B226F666622213D3D746869732E6F6363757272656E636573486967686C6967687426';
wwv_flow_imp.g_varchar2_table(31246) := '2628746869732E776F726B6572526571756573747C7C746869732E5F72756E2829297D2929292C746869732E746F556E686F6F6B2E61646428652E6F6E4469644368616E67654D6F64656C436F6E74656E742828653D3E7B746869732E5F73746F70416C';
wwv_flow_imp.g_varchar2_table(31247) := '6C28297D2929292C746869732E746F556E686F6F6B2E61646428652E6F6E4469644368616E67654D6F64656C2828653D3E7B21652E6E65774D6F64656C55726C2626652E6F6C644D6F64656C55726C3F746869732E5F73746F7053696E67756C61722829';
wwv_flow_imp.g_varchar2_table(31248) := '3A7A74652E71756572792626746869732E5F72756E28297D2929292C746869732E746F556E686F6F6B2E61646428652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B636F6E737420743D746869732E656469746F722E6765';
wwv_flow_imp.g_varchar2_table(31249) := '744F7074696F6E283831293B746869732E6F6363757272656E636573486967686C69676874213D3D74262628746869732E6F6363757272656E636573486967686C696768743D742C746869732E5F73746F70416C6C2829297D2929292C746869732E6465';
wwv_flow_imp.g_varchar2_table(31250) := '636F726174696F6E733D746869732E656469746F722E6372656174654465636F726174696F6E73436F6C6C656374696F6E28292C746869732E776F726B657252657175657374546F6B656E49643D302C746869732E776F726B6572526571756573743D6E';
wwv_flow_imp.g_varchar2_table(31251) := '756C6C2C746869732E776F726B657252657175657374436F6D706C657465643D21312C746869732E6C617374437572736F72506F736974696F6E4368616E676554696D653D302C746869732E72656E6465724465636F726174696F6E7354696D65723D2D';
wwv_flow_imp.g_varchar2_table(31252) := '312C7A74652E71756572792626746869732E5F72756E28297D6861734465636F726174696F6E7328297B72657475726E20746869732E6465636F726174696F6E732E6C656E6774683E307D726573746F726528297B226F666622213D3D746869732E6F63';
wwv_flow_imp.g_varchar2_table(31253) := '63757272656E636573486967686C696768742626746869732E5F72756E28297D5F676574536F72746564486967686C696768747328297B72657475726E20746869732E6465636F726174696F6E732E67657452616E67657328292E736F72742872682E63';
wwv_flow_imp.g_varchar2_table(31254) := '6F6D7061726552616E6765735573696E67537461727473297D6D6F76654E65787428297B636F6E737420653D746869732E5F676574536F72746564486967686C696768747328292C743D652E66696E64496E6465782828653D3E652E636F6E7461696E73';
wwv_flow_imp.g_varchar2_table(31255) := '506F736974696F6E28746869732E656469746F722E676574506F736974696F6E28292929292C6E3D28742B312925652E6C656E6774682C693D655B6E5D3B7472797B746869732E5F69676E6F7265506F736974696F6E4368616E67654576656E743D2130';
wwv_flow_imp.g_varchar2_table(31256) := '2C746869732E656469746F722E736574506F736974696F6E28692E6765745374617274506F736974696F6E2829292C746869732E656469746F722E72657665616C52616E6765496E43656E74657249664F75747369646556696577706F72742869293B63';
wwv_flow_imp.g_varchar2_table(31257) := '6F6E737420743D746869732E5F676574576F726428293B74262658722860247B746869732E656469746F722E6765744D6F64656C28292E6765744C696E65436F6E74656E7428692E73746172744C696E654E756D626572297D2C20247B6E2B317D206F66';
wwv_flow_imp.g_varchar2_table(31258) := '20247B652E6C656E6774687D20666F722027247B742E776F72647D2760297D66696E616C6C797B746869732E5F69676E6F7265506F736974696F6E4368616E67654576656E743D21317D7D6D6F76654261636B28297B636F6E737420653D746869732E5F';
wwv_flow_imp.g_varchar2_table(31259) := '676574536F72746564486967686C696768747328292C743D652E66696E64496E6465782828653D3E652E636F6E7461696E73506F736974696F6E28746869732E656469746F722E676574506F736974696F6E28292929292C6E3D28742D312B652E6C656E';
wwv_flow_imp.g_varchar2_table(31260) := '6774682925652E6C656E6774682C693D655B6E5D3B7472797B746869732E5F69676E6F7265506F736974696F6E4368616E67654576656E743D21302C746869732E656469746F722E736574506F736974696F6E28692E6765745374617274506F73697469';
wwv_flow_imp.g_varchar2_table(31261) := '6F6E2829292C746869732E656469746F722E72657665616C52616E6765496E43656E74657249664F75747369646556696577706F72742869293B636F6E737420743D746869732E5F676574576F726428293B74262658722860247B746869732E65646974';
wwv_flow_imp.g_varchar2_table(31262) := '6F722E6765744D6F64656C28292E6765744C696E65436F6E74656E7428692E73746172744C696E654E756D626572297D2C20247B6E2B317D206F6620247B652E6C656E6774687D20666F722027247B742E776F72647D2760297D66696E616C6C797B7468';
wwv_flow_imp.g_varchar2_table(31263) := '69732E5F69676E6F7265506F736974696F6E4368616E67654576656E743D21317D7D5F72656D6F766553696E676C654465636F726174696F6E7328297B69662821746869732E656469746F722E6861734D6F64656C28292972657475726E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(31264) := '20653D7A74652E73746F7265644465636F726174696F6E732E67657428746869732E656469746F722E6765744D6F64656C28292E757269293B65262628746869732E656469746F722E72656D6F76654465636F726174696F6E732865292C7A74652E7374';
wwv_flow_imp.g_varchar2_table(31265) := '6F7265644465636F726174696F6E732E64656C65746528746869732E656469746F722E6765744D6F64656C28292E757269292C746869732E6465636F726174696F6E732E6C656E6774683E30262628746869732E6465636F726174696F6E732E636C6561';
wwv_flow_imp.g_varchar2_table(31266) := '7228292C746869732E5F686173576F7264486967686C69676874732E7365742821312929297D5F72656D6F7665416C6C4465636F726174696F6E7328297B636F6E737420653D746869732E636F6465456469746F72536572766963652E6C697374436F64';
wwv_flow_imp.g_varchar2_table(31267) := '65456469746F727328292C743D5B5D3B666F7228636F6E7374206E206F662065297B696628216E2E6861734D6F64656C282929636F6E74696E75653B636F6E737420653D7A74652E73746F7265644465636F726174696F6E732E676574286E2E6765744D';
wwv_flow_imp.g_varchar2_table(31268) := '6F64656C28292E757269293B696628216529636F6E74696E75653B6E2E72656D6F76654465636F726174696F6E732865292C742E70757368286E2E6765744D6F64656C28292E757269293B636F6E737420693D5A74652E676574286E293B286E756C6C3D';
wwv_flow_imp.g_varchar2_table(31269) := '3D693F766F696420303A692E776F7264486967686C696768746572292626692E776F7264486967686C6967687465722E6465636F726174696F6E732E6C656E6774683E30262628692E776F7264486967686C6967687465722E6465636F726174696F6E73';
wwv_flow_imp.g_varchar2_table(31270) := '2E636C65617228292C692E776F7264486967686C6967687465722E776F726B6572526571756573743D6E756C6C2C692E776F7264486967686C6967687465722E5F686173576F7264486967686C69676874732E73657428213129297D666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(31271) := '742065206F662074297A74652E73746F7265644465636F726174696F6E732E64656C6574652865297D5F73746F7053696E67756C617228297B76617220652C742C6E2C693B746869732E5F72656D6F766553696E676C654465636F726174696F6E732829';
wwv_flow_imp.g_varchar2_table(31272) := '2C746869732E656469746F722E68617354657874466F6375732829262628286E756C6C3D3D3D28653D746869732E656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D653F766F696420303A652E7572692E736368656D6529213D3D';
wwv_flow_imp.g_varchar2_table(31273) := '716F2E7673636F64654E6F7465626F6F6B43656C6C2626286E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D7A74652E7175657279297C7C766F696420303D3D3D743F766F696420303A742E6D6F64656C496E666F297C7C766F696420303D3D3D6E3F76';
wwv_flow_imp.g_varchar2_table(31274) := '6F696420303A6E2E6D6F64656C2E7572692E736368656D6529213D3D716F2E7673636F64654E6F7465626F6F6B43656C6C3F287A74652E71756572793D6E756C6C2C746869732E5F72756E2829293A286E756C6C3D3D3D28693D7A74652E717565727929';
wwv_flow_imp.g_varchar2_table(31275) := '7C7C766F696420303D3D3D693F766F696420303A692E6D6F64656C496E666F292626287A74652E71756572792E6D6F64656C496E666F3D6E756C6C29292C2D31213D3D746869732E72656E6465724465636F726174696F6E7354696D6572262628636C65';
wwv_flow_imp.g_varchar2_table(31276) := '617254696D656F757428746869732E72656E6465724465636F726174696F6E7354696D6572292C746869732E72656E6465724465636F726174696F6E7354696D65723D2D31292C6E756C6C213D3D746869732E776F726B65725265717565737426262874';
wwv_flow_imp.g_varchar2_table(31277) := '6869732E776F726B6572526571756573742E63616E63656C28292C746869732E776F726B6572526571756573743D6E756C6C292C746869732E776F726B657252657175657374436F6D706C657465647C7C28746869732E776F726B657252657175657374';
wwv_flow_imp.g_varchar2_table(31278) := '546F6B656E49642B2B2C746869732E776F726B657252657175657374436F6D706C657465643D2130297D5F73746F70416C6C28297B746869732E5F72656D6F7665416C6C4465636F726174696F6E7328292C2D31213D3D746869732E72656E6465724465';
wwv_flow_imp.g_varchar2_table(31279) := '636F726174696F6E7354696D6572262628636C65617254696D656F757428746869732E72656E6465724465636F726174696F6E7354696D6572292C746869732E72656E6465724465636F726174696F6E7354696D65723D2D31292C6E756C6C213D3D7468';
wwv_flow_imp.g_varchar2_table(31280) := '69732E776F726B657252657175657374262628746869732E776F726B6572526571756573742E63616E63656C28292C746869732E776F726B6572526571756573743D6E756C6C292C746869732E776F726B657252657175657374436F6D706C657465647C';
wwv_flow_imp.g_varchar2_table(31281) := '7C28746869732E776F726B657252657175657374546F6B656E49642B2B2C746869732E776F726B657252657175657374436F6D706C657465643D2130297D5F6F6E506F736974696F6E4368616E6765642865297B76617220743B226F6666223D3D3D7468';
wwv_flow_imp.g_varchar2_table(31282) := '69732E6F6363757272656E636573486967686C696768747C7C33213D3D652E726561736F6E2626286E756C6C3D3D3D28743D746869732E656469746F722E6765744D6F64656C2829297C7C766F696420303D3D3D743F766F696420303A742E7572692E73';
wwv_flow_imp.g_varchar2_table(31283) := '6368656D6529213D3D716F2E7673636F64654E6F7465626F6F6B43656C6C3F746869732E5F73746F70416C6C28293A746869732E5F72756E28297D5F676574576F726428297B636F6E737420653D746869732E656469746F722E67657453656C65637469';
wwv_flow_imp.g_varchar2_table(31284) := '6F6E28292C743D652E73746172744C696E654E756D6265722C6E3D652E7374617274436F6C756D6E3B72657475726E20746869732E6D6F64656C2E6973446973706F73656428293F6E756C6C3A746869732E6D6F64656C2E676574576F72644174506F73';
wwv_flow_imp.g_varchar2_table(31285) := '6974696F6E287B6C696E654E756D6265723A742C636F6C756D6E3A6E7D297D6765744F746865724D6F64656C73546F486967686C696768742865297B69662821652972657475726E5B5D3B696628652E7572692E736368656D653D3D3D716F2E7673636F';
wwv_flow_imp.g_varchar2_table(31286) := '64654E6F7465626F6F6B43656C6C297B636F6E737420743D5B5D2C6E3D746869732E636F6465456469746F72536572766963652E6C697374436F6465456469746F727328293B666F7228636F6E73742069206F66206E297B636F6E7374206E3D692E6765';
wwv_flow_imp.g_varchar2_table(31287) := '744D6F64656C28293B6E26266E213D3D6526266E2E7572692E736368656D653D3D3D716F2E7673636F64654E6F7465626F6F6B43656C6C2626742E70757368286E297D72657475726E20747D636F6E737420743D5B5D2C6E3D746869732E636F64654564';
wwv_flow_imp.g_varchar2_table(31288) := '69746F72536572766963652E6C697374436F6465456469746F727328293B666F7228636F6E73742069206F66206E297B69662821652428692929636F6E74696E75653B636F6E7374206E3D692E6765744D6F64656C28293B6E2626653D3D3D6E2E6D6F64';
wwv_flow_imp.g_varchar2_table(31289) := '69666965642626742E70757368286E2E6D6F646966696564297D696628742E6C656E6774682972657475726E20743B6966282273696E676C6546696C65223D3D3D746869732E6F6363757272656E636573486967686C696768742972657475726E5B5D3B';
wwv_flow_imp.g_varchar2_table(31290) := '666F7228636F6E73742069206F66206E297B636F6E7374206E3D692E6765744D6F64656C28293B6E26266E213D3D652626742E70757368286E297D72657475726E20747D5F72756E28297B76617220653B6C657420743B696628746869732E656469746F';
wwv_flow_imp.g_varchar2_table(31291) := '722E68617354657874466F6375732829297B636F6E737420653D746869732E656469746F722E67657453656C656374696F6E28293B69662821657C7C652E73746172744C696E654E756D626572213D3D652E656E644C696E654E756D6265722972657475';
wwv_flow_imp.g_varchar2_table(31292) := '726E207A74652E71756572793D6E756C6C2C766F696420746869732E5F73746F70416C6C28293B636F6E7374206E3D652E7374617274436F6C756D6E2C693D652E656E64436F6C756D6E2C6F3D746869732E5F676574576F726428293B696628216F7C7C';
wwv_flow_imp.g_varchar2_table(31293) := '6F2E7374617274436F6C756D6E3E6E7C7C6F2E656E64436F6C756D6E3C692972657475726E207A74652E71756572793D6E756C6C2C766F696420746869732E5F73746F70416C6C28293B743D746869732E776F726B657252657175657374262674686973';
wwv_flow_imp.g_varchar2_table(31294) := '2E776F726B6572526571756573742E697356616C696428746869732E6D6F64656C2C652C746869732E6465636F726174696F6E73292C7A74652E71756572793D7B6D6F64656C496E666F3A7B6D6F64656C3A746869732E6D6F64656C2C73656C65637469';
wwv_flow_imp.g_varchar2_table(31295) := '6F6E3A657D2C776F72643A6F7D7D656C736520696628217A74652E71756572792972657475726E3B696628746869732E6C617374437572736F72506F736974696F6E4368616E676554696D653D286E65772044617465292E67657454696D6528292C7429';
wwv_flow_imp.g_varchar2_table(31296) := '746869732E776F726B657252657175657374436F6D706C6574656426262D31213D3D746869732E72656E6465724465636F726174696F6E7354696D6572262628636C65617254696D656F757428746869732E72656E6465724465636F726174696F6E7354';
wwv_flow_imp.g_varchar2_table(31297) := '696D6572292C746869732E72656E6465724465636F726174696F6E7354696D65723D2D312C746869732E5F626567696E52656E6465724465636F726174696F6E732829293B656C73657B746869732E5F73746F70416C6C28293B636F6E737420743D2B2B';
wwv_flow_imp.g_varchar2_table(31298) := '746869732E776F726B657252657175657374546F6B656E49643B746869732E776F726B657252657175657374436F6D706C657465643D21313B636F6E7374206E3D746869732E6765744F746865724D6F64656C73546F486967686C696768742874686973';
wwv_flow_imp.g_varchar2_table(31299) := '2E656469746F722E6765744D6F64656C2829293B696628217A74652E71756572792E6D6F64656C496E666F7C7C7A74652E71756572792E6D6F64656C496E666F2E6D6F64656C2E6973446973706F73656428292972657475726E3B746869732E776F726B';
wwv_flow_imp.g_varchar2_table(31300) := '6572526571756573743D746869732E636F6D70757465576974684D6F64656C287A74652E71756572792E6D6F64656C496E666F2E6D6F64656C2C7A74652E71756572792E6D6F64656C496E666F2E73656C656374696F6E2C7A74652E71756572792E776F';
wwv_flow_imp.g_varchar2_table(31301) := '72642C6E292C6E756C6C3D3D3D28653D746869732E776F726B657252657175657374297C7C766F696420303D3D3D657C7C652E726573756C742E7468656E2828653D3E7B743D3D3D746869732E776F726B657252657175657374546F6B656E4964262628';
wwv_flow_imp.g_varchar2_table(31302) := '746869732E776F726B657252657175657374436F6D706C657465643D21302C746869732E776F726B65725265717565737456616C75653D657C7C5B5D2C746869732E5F626567696E52656E6465724465636F726174696F6E732829297D292C6B65297D7D';
wwv_flow_imp.g_varchar2_table(31303) := '636F6D70757465576974684D6F64656C28652C742C6E2C69297B72657475726E20692E6C656E6774683F66756E6374696F6E28652C742C6E2C692C6F2C73297B72657475726E20652E6861732874293F6E65772047746528742C6E2C6F2C652C73293A6E';
wwv_flow_imp.g_varchar2_table(31304) := '65772051746528742C6E2C692C6F2C73297D28746869732E6D756C7469446F63756D656E7450726F7669646572732C652C742C6E2C746869732E656469746F722E6765744F7074696F6E28313331292C69293A66756E6374696F6E28652C742C6E2C692C';
wwv_flow_imp.g_varchar2_table(31305) := '6F297B72657475726E20652E6861732874293F6E6577204B746528742C6E2C6F2C65293A6E65772051746528742C6E2C692C6F2C5B5D297D28746869732E70726F7669646572732C652C742C6E2C746869732E656469746F722E6765744F7074696F6E28';
wwv_flow_imp.g_varchar2_table(31306) := '31333129297D5F626567696E52656E6465724465636F726174696F6E7328297B636F6E737420653D286E65772044617465292E67657454696D6528292C743D746869732E6C617374437572736F72506F736974696F6E4368616E676554696D652B323530';
wwv_flow_imp.g_varchar2_table(31307) := '3B653E3D743F28746869732E72656E6465724465636F726174696F6E7354696D65723D2D312C746869732E72656E6465724465636F726174696F6E732829293A746869732E72656E6465724465636F726174696F6E7354696D65723D73657454696D656F';
wwv_flow_imp.g_varchar2_table(31308) := '7574282828293D3E7B746869732E72656E6465724465636F726174696F6E7328297D292C742D65297D72656E6465724465636F726174696F6E7328297B76617220652C742C6E3B746869732E72656E6465724465636F726174696F6E7354696D65723D2D';
wwv_flow_imp.g_varchar2_table(31309) := '313B636F6E737420693D746869732E636F6465456469746F72536572766963652E6C697374436F6465456469746F727328293B666F7228636F6E73742073206F662069297B636F6E737420693D5A74652E6765742873293B696628216929636F6E74696E';
wwv_flow_imp.g_varchar2_table(31310) := '75653B636F6E737420723D5B5D2C613D6E756C6C3D3D3D28653D732E6765744D6F64656C2829297C7C766F696420303D3D3D653F766F696420303A652E7572693B696628612626746869732E776F726B65725265717565737456616C75652E6861732861';
wwv_flow_imp.g_varchar2_table(31311) := '29297B636F6E737420653D7A74652E73746F7265644465636F726174696F6E732E6765742861292C6C3D746869732E776F726B65725265717565737456616C75652E6765742861293B6966286C29666F7228636F6E73742065206F66206C29652E72616E';
wwv_flow_imp.g_varchar2_table(31312) := '67652626722E70757368287B72616E67653A652E72616E67652C6F7074696F6E733A286F3D652E6B696E642C6F3D3D3D78772E57726974653F67373A6F3D3D3D78772E546578743F6D373A6237297D293B6C657420633D5B5D3B732E6368616E67654465';
wwv_flow_imp.g_varchar2_table(31313) := '636F726174696F6E732828743D3E7B633D742E64656C74614465636F726174696F6E73286E756C6C213D653F653A5B5D2C72297D29292C7A74652E73746F7265644465636F726174696F6E733D7A74652E73746F7265644465636F726174696F6E732E73';
wwv_flow_imp.g_varchar2_table(31314) := '657428612C63292C722E6C656E6774683E302626286E756C6C3D3D3D28743D692E776F7264486967686C696768746572297C7C766F696420303D3D3D747C7C742E6465636F726174696F6E732E7365742872292C6E756C6C3D3D3D286E3D692E776F7264';
wwv_flow_imp.g_varchar2_table(31315) := '486967686C696768746572297C7C766F696420303D3D3D6E7C7C6E2E5F686173576F7264486967686C69676874732E73657428213029297D7D766172206F7D646973706F736528297B746869732E5F73746F7053696E67756C617228292C746869732E74';
wwv_flow_imp.g_varchar2_table(31316) := '6F556E686F6F6B2E646973706F736528297D7D3B5974652E73746F7265644465636F726174696F6E733D6E6577206F612C5974652E71756572793D6E756C6C2C5974653D7A74653D577465285B6A746528342C6763295D2C597465293B6C6574205A7465';
wwv_flow_imp.g_varchar2_table(31317) := '3D4874653D636C61737320657874656E6473206C747B737461746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E284874652E4944297D636F6E7374727563746F7228652C742C6E2C69297B737570657228292C7468';
wwv_flow_imp.g_varchar2_table(31318) := '69732E5F776F7264486967686C6967687465723D6E756C6C3B636F6E7374206F3D28293D3E7B652E6861734D6F64656C2829262621652E6765744D6F64656C28292E6973546F6F4C61726765466F72546F6B656E697A6174696F6E282926262874686973';
wwv_flow_imp.g_varchar2_table(31319) := '2E5F776F7264486967686C6967687465723D6E65772059746528652C6E2E646F63756D656E74486967686C6967687450726F76696465722C6E2E6D756C7469446F63756D656E74486967686C6967687450726F76696465722C742C6929297D3B74686973';
wwv_flow_imp.g_varchar2_table(31320) := '2E5F726567697374657228652E6F6E4469644368616E67654D6F64656C2828653D3E7B746869732E5F776F7264486967686C696768746572262628746869732E5F776F7264486967686C6967687465722E646973706F736528292C746869732E5F776F72';
wwv_flow_imp.g_varchar2_table(31321) := '64486967686C6967687465723D6E756C6C292C6F28297D2929292C6F28297D67657420776F7264486967686C69676874657228297B72657475726E20746869732E5F776F7264486967686C6967687465727D7361766556696577537461746528297B7265';
wwv_flow_imp.g_varchar2_table(31322) := '7475726E212821746869732E5F776F7264486967686C6967687465727C7C21746869732E5F776F7264486967686C6967687465722E6861734465636F726174696F6E732829297D6D6F76654E65787428297B76617220653B6E756C6C3D3D3D28653D7468';
wwv_flow_imp.g_varchar2_table(31323) := '69732E5F776F7264486967686C696768746572297C7C766F696420303D3D3D657C7C652E6D6F76654E65787428297D6D6F76654261636B28297B76617220653B6E756C6C3D3D3D28653D746869732E5F776F7264486967686C696768746572297C7C766F';
wwv_flow_imp.g_varchar2_table(31324) := '696420303D3D3D657C7C652E6D6F76654261636B28297D726573746F72655669657753746174652865297B746869732E5F776F7264486967686C6967687465722626652626746869732E5F776F7264486967686C6967687465722E726573746F72652829';
wwv_flow_imp.g_varchar2_table(31325) := '7D646973706F736528297B746869732E5F776F7264486967686C696768746572262628746869732E5F776F7264486967686C6967687465722E646973706F736528292C746869732E5F776F7264486967686C6967687465723D6E756C6C292C7375706572';
wwv_flow_imp.g_varchar2_table(31326) := '2E646973706F736528297D7D3B5A74652E49443D22656469746F722E636F6E747269622E776F7264486967686C696768746572222C5A74653D4874653D577465285B6A746528312C6364292C6A746528322C7878292C6A746528332C6763295D2C5A7465';
wwv_flow_imp.g_varchar2_table(31327) := '293B636C6173732058746520657874656E64732055647B636F6E7374727563746F7228652C74297B73757065722874292C746869732E5F69734E6578743D657D72756E28652C74297B636F6E7374206E3D5A74652E6765742874293B6E26262874686973';
wwv_flow_imp.g_varchar2_table(31328) := '2E5F69734E6578743F6E2E6D6F76654E65787428293A6E2E6D6F76654261636B2829297D7D4A64285A74652E49442C5A74652C30292C5A6428636C61737320657874656E6473205874657B636F6E7374727563746F7228297B73757065722821302C7B69';
wwv_flow_imp.g_varchar2_table(31329) := '643A22656469746F722E616374696F6E2E776F7264486967686C696768742E6E657874222C6C6162656C3A6228302C22476F20746F204E6578742053796D626F6C20486967686C6967687422292C616C6961733A22476F20746F204E6578742053796D62';
wwv_flow_imp.g_varchar2_table(31330) := '6F6C20486967686C69676874222C707265636F6E646974696F6E3A7174652C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A36352C7765696768743A3130307D7D297D7D292C5A6428636C6173';
wwv_flow_imp.g_varchar2_table(31331) := '7320657874656E6473205874657B636F6E7374727563746F7228297B73757065722821312C7B69643A22656469746F722E616374696F6E2E776F7264486967686C696768742E70726576222C6C6162656C3A6228302C22476F20746F2050726576696F75';
wwv_flow_imp.g_varchar2_table(31332) := '732053796D626F6C20486967686C6967687422292C616C6961733A22476F20746F2050726576696F75732053796D626F6C20486967686C69676874222C707265636F6E646974696F6E3A7174652C6B624F7074733A7B6B62457870723A6C682E65646974';
wwv_flow_imp.g_varchar2_table(31333) := '6F7254657874466F6375732C7072696D6172793A313038392C7765696768743A3130307D7D297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A22656469746F722E616374696F6E';
wwv_flow_imp.g_varchar2_table(31334) := '2E776F7264486967686C696768742E74726967676572222C6C6162656C3A6228302C22547269676765722053796D626F6C20486967686C6967687422292C616C6961733A22547269676765722053796D626F6C20486967686C69676874222C707265636F';
wwv_flow_imp.g_varchar2_table(31335) := '6E646974696F6E3A7174652E746F4E65676174656428292C6B624F7074733A7B6B62457870723A6C682E656469746F7254657874466F6375732C7072696D6172793A302C7765696768743A3130307D7D297D72756E28652C742C6E297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(31336) := '3D5A74652E6765742874293B692626692E726573746F7265566965775374617465282130297D7D293B636C617373204A746520657874656E64732024647B636F6E7374727563746F722865297B73757065722865292C746869732E5F696E53656C656374';
wwv_flow_imp.g_varchar2_table(31337) := '696F6E4D6F64653D652E696E53656C656374696F6E4D6F64652C746869732E5F776F72644E617669676174696F6E547970653D652E776F72644E617669676174696F6E547970657D72756E456469746F72436F6D6D616E6428652C742C6E297B69662821';
wwv_flow_imp.g_varchar2_table(31338) := '742E6861734D6F64656C28292972657475726E3B636F6E737420693D597928742E6765744F7074696F6E28313331292C742E6765744F7074696F6E2831333029292C6F3D742E6765744D6F64656C28292C733D742E67657453656C656374696F6E732829';
wwv_flow_imp.g_varchar2_table(31339) := '2E6D61702828653D3E7B636F6E737420743D6E6577206D6328652E706F736974696F6E4C696E654E756D6265722C652E706F736974696F6E436F6C756D6E292C6E3D746869732E5F6D6F766528692C6F2C742C746869732E5F776F72644E617669676174';
wwv_flow_imp.g_varchar2_table(31340) := '696F6E54797065293B72657475726E20746869732E5F6D6F7665546F28652C6E2C746869732E5F696E53656C656374696F6E4D6F6465297D29293B6966286F2E70757368537461636B456C656D656E7428292C742E5F676574566965774D6F64656C2829';
wwv_flow_imp.g_varchar2_table(31341) := '2E736574437572736F7253746174657328226D6F7665576F7264436F6D6D616E64222C332C732E6D61702828653D3E51432E66726F6D4D6F64656C53656C656374696F6E2865292929292C313D3D3D732E6C656E677468297B636F6E737420653D6E6577';
wwv_flow_imp.g_varchar2_table(31342) := '206D6328735B305D2E706F736974696F6E4C696E654E756D6265722C735B305D2E706F736974696F6E436F6C756D6E293B742E72657665616C506F736974696F6E28652C30297D7D5F6D6F7665546F28652C742C6E297B72657475726E206E3F6E657720';
wwv_flow_imp.g_varchar2_table(31343) := '616828652E73656C656374696F6E53746172744C696E654E756D6265722C652E73656C656374696F6E5374617274436F6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E293A6E657720616828742E6C696E654E756D6265722C742E636F';
wwv_flow_imp.g_varchar2_table(31344) := '6C756D6E2C742E6C696E654E756D6265722C742E636F6C756D6E297D7D636C61737320656E6520657874656E6473204A74657B5F6D6F766528652C742C6E2C69297B72657475726E2068532E6D6F7665576F72644C65667428652C742C6E2C69297D7D63';
wwv_flow_imp.g_varchar2_table(31345) := '6C61737320746E6520657874656E6473204A74657B5F6D6F766528652C742C6E2C69297B72657475726E2068532E6D6F7665576F7264526967687428652C742C6E2C69297D7D636C617373206E6E6520657874656E64732024647B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(31346) := '6F722865297B73757065722865292C746869732E5F77686974657370616365486575726973746963733D652E77686974657370616365486575726973746963732C746869732E5F776F72644E617669676174696F6E547970653D652E776F72644E617669';
wwv_flow_imp.g_varchar2_table(31347) := '676174696F6E547970657D72756E456469746F72436F6D6D616E6428652C742C6E297B636F6E737420693D652E676574286567293B69662821742E6861734D6F64656C28292972657475726E3B636F6E7374206F3D597928742E6765744F7074696F6E28';
wwv_flow_imp.g_varchar2_table(31348) := '313331292C742E6765744F7074696F6E2831333029292C733D742E6765744D6F64656C28292C723D742E67657453656C656374696F6E7328292C613D742E6765744F7074696F6E2836292C6C3D742E6765744F7074696F6E283131292C633D692E676574';
wwv_flow_imp.g_varchar2_table(31349) := '4C616E6775616765436F6E66696775726174696F6E28732E6765744C616E677561676549642829292E6765744175746F436C6F73696E67506169727328292C643D742E5F676574566965774D6F64656C28292C683D722E6D61702828653D3E7B636F6E73';
wwv_flow_imp.g_varchar2_table(31350) := '74206E3D746869732E5F64656C657465287B776F7264536570617261746F72733A6F2C6D6F64656C3A732C73656C656374696F6E3A652C77686974657370616365486575726973746963733A746869732E5F776869746573706163654865757269737469';
wwv_flow_imp.g_varchar2_table(31351) := '63732C6175746F436C6F73696E6744656C6574653A742E6765744F7074696F6E2839292C6175746F436C6F73696E67427261636B6574733A612C6175746F436C6F73696E6751756F7465733A6C2C6175746F436C6F73696E6750616972733A632C617574';
wwv_flow_imp.g_varchar2_table(31352) := '6F436C6F736564436861726163746572733A642E676574437572736F724175746F436C6F7365644368617261637465727328297D2C746869732E5F776F72644E617669676174696F6E54797065293B72657475726E206E6577206E53286E2C2222297D29';
wwv_flow_imp.g_varchar2_table(31353) := '293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E647328746869732E69642C68292C742E70757368556E646F53746F7028297D7D636C61737320696E6520657874656E6473206E6E657B5F64656C65746528652C7429';
wwv_flow_imp.g_varchar2_table(31354) := '7B72657475726E2068532E64656C657465576F72644C65667428652C74297C7C6E657720726828312C312C312C31297D7D636C617373206F6E6520657874656E6473206E6E657B5F64656C65746528652C74297B636F6E7374206E3D68532E64656C6574';
wwv_flow_imp.g_varchar2_table(31355) := '65576F7264526967687428652C74293B6966286E2972657475726E206E3B636F6E737420693D652E6D6F64656C2E6765744C696E65436F756E7428292C6F3D652E6D6F64656C2E6765744C696E654D6178436F6C756D6E2869293B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(31356) := '7720726828692C6F2C692C6F297D7D5964286E657720636C61737320657874656E647320656E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21312C776F72644E617669676174696F6E547970653A30';
wwv_flow_imp.g_varchar2_table(31357) := '2C69643A22637572736F72576F726453746172744C656674222C707265636F6E646974696F6E3A766F696420307D297D7D292C5964286E657720636C61737320657874656E647320656E657B636F6E7374727563746F7228297B7375706572287B696E53';
wwv_flow_imp.g_varchar2_table(31358) := '656C656374696F6E4D6F64653A21312C776F72644E617669676174696F6E547970653A322C69643A22637572736F72576F7264456E644C656674222C707265636F6E646974696F6E3A766F696420307D297D7D292C5964286E657720636C617373206578';
wwv_flow_imp.g_varchar2_table(31359) := '74656E647320656E657B636F6E7374727563746F7228297B76617220653B7375706572287B696E53656C656374696F6E4D6F64653A21312C776F72644E617669676174696F6E547970653A312C69643A22637572736F72576F72644C656674222C707265';
wwv_flow_imp.g_varchar2_table(31360) := '636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A57632E616E64286C682E74657874496E707574466F6375732C6E756C6C3D3D3D28653D57632E616E64285A532C534B29297C7C766F696420303D3D3D653F766F69642030';
wwv_flow_imp.g_varchar2_table(31361) := '3A652E6E65676174652829292C7072696D6172793A323036332C6D61633A7B7072696D6172793A3532377D2C7765696768743A3130307D7D297D7D292C5964286E657720636C61737320657874656E647320656E657B636F6E7374727563746F7228297B';
wwv_flow_imp.g_varchar2_table(31362) := '7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A302C69643A22637572736F72576F726453746172744C65667453656C656374222C707265636F6E646974696F6E3A766F696420307D297D';
wwv_flow_imp.g_varchar2_table(31363) := '7D292C5964286E657720636C61737320657874656E647320656E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A322C69643A22637572736F7257';
wwv_flow_imp.g_varchar2_table(31364) := '6F7264456E644C65667453656C656374222C707265636F6E646974696F6E3A766F696420307D297D7D292C5964286E657720636C61737320657874656E647320656E657B636F6E7374727563746F7228297B76617220653B7375706572287B696E53656C';
wwv_flow_imp.g_varchar2_table(31365) := '656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A312C69643A22637572736F72576F72644C65667453656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A57632E61';
wwv_flow_imp.g_varchar2_table(31366) := '6E64286C682E74657874496E707574466F6375732C6E756C6C3D3D3D28653D57632E616E64285A532C534B29297C7C766F696420303D3D3D653F766F696420303A652E6E65676174652829292C7072696D6172793A333038372C6D61633A7B7072696D61';
wwv_flow_imp.g_varchar2_table(31367) := '72793A313535317D2C7765696768743A3130307D7D297D7D292C5964286E657720636C61737320657874656E647320746E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21312C776F72644E61766967';
wwv_flow_imp.g_varchar2_table(31368) := '6174696F6E547970653A302C69643A22637572736F72576F726453746172745269676874222C707265636F6E646974696F6E3A766F696420307D297D7D292C5964286E657720636C61737320657874656E647320746E657B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(31369) := '297B76617220653B7375706572287B696E53656C656374696F6E4D6F64653A21312C776F72644E617669676174696F6E547970653A322C69643A22637572736F72576F7264456E645269676874222C707265636F6E646974696F6E3A766F696420302C6B';
wwv_flow_imp.g_varchar2_table(31370) := '624F7074733A7B6B62457870723A57632E616E64286C682E74657874496E707574466F6375732C6E756C6C3D3D3D28653D57632E616E64285A532C534B29297C7C766F696420303D3D3D653F766F696420303A652E6E65676174652829292C7072696D61';
wwv_flow_imp.g_varchar2_table(31371) := '72793A323036352C6D61633A7B7072696D6172793A3532397D2C7765696768743A3130307D7D297D7D292C5964286E657720636C61737320657874656E647320746E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E';
wwv_flow_imp.g_varchar2_table(31372) := '4D6F64653A21312C776F72644E617669676174696F6E547970653A322C69643A22637572736F72576F72645269676874222C707265636F6E646974696F6E3A766F696420307D297D7D292C5964286E657720636C61737320657874656E647320746E657B';
wwv_flow_imp.g_varchar2_table(31373) := '636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A302C69643A22637572736F72576F72645374617274526967687453656C656374222C707265636F6E64';
wwv_flow_imp.g_varchar2_table(31374) := '6974696F6E3A766F696420307D297D7D292C5964286E657720636C61737320657874656E647320746E657B636F6E7374727563746F7228297B76617220653B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174';
wwv_flow_imp.g_varchar2_table(31375) := '696F6E547970653A322C69643A22637572736F72576F7264456E64526967687453656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A57632E616E64286C682E74657874496E707574466F6375732C';
wwv_flow_imp.g_varchar2_table(31376) := '6E756C6C3D3D3D28653D57632E616E64285A532C534B29297C7C766F696420303D3D3D653F766F696420303A652E6E65676174652829292C7072696D6172793A333038392C6D61633A7B7072696D6172793A313535337D2C7765696768743A3130307D7D';
wwv_flow_imp.g_varchar2_table(31377) := '297D7D292C5964286E657720636C61737320657874656E647320746E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A322C69643A22637572736F';
wwv_flow_imp.g_varchar2_table(31378) := '72576F7264526967687453656C656374222C707265636F6E646974696F6E3A766F696420307D297D7D292C5964286E657720636C61737320657874656E647320656E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E';
wwv_flow_imp.g_varchar2_table(31379) := '4D6F64653A21312C776F72644E617669676174696F6E547970653A332C69643A22637572736F72576F72644163636573736962696C6974794C656674222C707265636F6E646974696F6E3A766F696420307D297D5F6D6F766528652C742C6E2C69297B72';
wwv_flow_imp.g_varchar2_table(31380) := '657475726E2073757065722E5F6D6F766528597928594C2E776F7264536570617261746F72732E64656661756C7456616C75652C652E696E746C5365676D656E7465724C6F63616C6573292C742C6E2C69297D7D292C5964286E657720636C6173732065';
wwv_flow_imp.g_varchar2_table(31381) := '7874656E647320656E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A332C69643A22637572736F72576F72644163636573736962696C6974794C';
wwv_flow_imp.g_varchar2_table(31382) := '65667453656C656374222C707265636F6E646974696F6E3A766F696420307D297D5F6D6F766528652C742C6E2C69297B72657475726E2073757065722E5F6D6F766528597928594C2E776F7264536570617261746F72732E64656661756C7456616C7565';
wwv_flow_imp.g_varchar2_table(31383) := '2C652E696E746C5365676D656E7465724C6F63616C6573292C742C6E2C69297D7D292C5964286E657720636C61737320657874656E647320746E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21312C';
wwv_flow_imp.g_varchar2_table(31384) := '776F72644E617669676174696F6E547970653A332C69643A22637572736F72576F72644163636573736962696C6974795269676874222C707265636F6E646974696F6E3A766F696420307D297D5F6D6F766528652C742C6E2C69297B72657475726E2073';
wwv_flow_imp.g_varchar2_table(31385) := '757065722E5F6D6F766528597928594C2E776F7264536570617261746F72732E64656661756C7456616C75652C652E696E746C5365676D656E7465724C6F63616C6573292C742C6E2C69297D7D292C5964286E657720636C61737320657874656E647320';
wwv_flow_imp.g_varchar2_table(31386) := '746E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A332C69643A22637572736F72576F72644163636573736962696C697479526967687453656C';
wwv_flow_imp.g_varchar2_table(31387) := '656374222C707265636F6E646974696F6E3A766F696420307D297D5F6D6F766528652C742C6E2C69297B72657475726E2073757065722E5F6D6F766528597928594C2E776F7264536570617261746F72732E64656661756C7456616C75652C652E696E74';
wwv_flow_imp.g_varchar2_table(31388) := '6C5365676D656E7465724C6F63616C6573292C742C6E2C69297D7D292C5964286E657720636C61737320657874656E647320696E657B636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A21312C77';
wwv_flow_imp.g_varchar2_table(31389) := '6F72644E617669676174696F6E547970653A302C69643A2264656C657465576F726453746172744C656674222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D7D292C5964286E657720636C61737320657874656E647320696E657B';
wwv_flow_imp.g_varchar2_table(31390) := '636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A21312C776F72644E617669676174696F6E547970653A322C69643A2264656C657465576F7264456E644C656674222C707265636F6E646974696F';
wwv_flow_imp.g_varchar2_table(31391) := '6E3A6C682E7772697461626C657D297D7D292C5964286E657720636C61737320657874656E647320696E657B636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A21302C776F72644E617669676174';
wwv_flow_imp.g_varchar2_table(31392) := '696F6E547970653A302C69643A2264656C657465576F72644C656674222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A32303439';
wwv_flow_imp.g_varchar2_table(31393) := '2C6D61633A7B7072696D6172793A3531337D2C7765696768743A3130307D7D297D7D292C5964286E657720636C61737320657874656E6473206F6E657B636F6E7374727563746F7228297B7375706572287B776869746573706163654865757269737469';
wwv_flow_imp.g_varchar2_table(31394) := '63733A21312C776F72644E617669676174696F6E547970653A302C69643A2264656C657465576F726453746172745269676874222C707265636F6E646974696F6E3A6C682E7772697461626C657D297D7D292C5964286E657720636C6173732065787465';
wwv_flow_imp.g_varchar2_table(31395) := '6E6473206F6E657B636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A21312C776F72644E617669676174696F6E547970653A322C69643A2264656C657465576F7264456E645269676874222C7072';
wwv_flow_imp.g_varchar2_table(31396) := '65636F6E646974696F6E3A6C682E7772697461626C657D297D7D292C5964286E657720636C61737320657874656E6473206F6E657B636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A21302C776F';
wwv_flow_imp.g_varchar2_table(31397) := '72644E617669676174696F6E547970653A322C69643A2264656C657465576F72645269676874222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072';
wwv_flow_imp.g_varchar2_table(31398) := '696D6172793A323036382C6D61633A7B7072696D6172793A3533327D2C7765696768743A3130307D7D297D7D292C5A6428636C61737320657874656E64732055647B636F6E7374727563746F7228297B7375706572287B69643A2264656C657465496E73';
wwv_flow_imp.g_varchar2_table(31399) := '696465576F7264222C707265636F6E646974696F6E3A6C682E7772697461626C652C6C6162656C3A6228302C2244656C65746520576F726422292C616C6961733A2244656C65746520576F7264227D297D72756E28652C742C6E297B69662821742E6861';
wwv_flow_imp.g_varchar2_table(31400) := '734D6F64656C28292972657475726E3B636F6E737420693D597928742E6765744F7074696F6E28313331292C742E6765744F7074696F6E2831333029292C6F3D742E6765744D6F64656C28292C733D742E67657453656C656374696F6E7328292E6D6170';
wwv_flow_imp.g_varchar2_table(31401) := '2828653D3E7B636F6E737420743D68532E64656C657465496E73696465576F726428692C6F2C65293B72657475726E206E6577206E5328742C2222297D29293B742E70757368556E646F53746F7028292C742E65786563757465436F6D6D616E64732874';
wwv_flow_imp.g_varchar2_table(31402) := '6869732E69642C73292C742E70757368556E646F53746F7028297D7D293B636C61737320736E6520657874656E6473204A74657B5F6D6F766528652C742C6E2C69297B72657475726E2075532E6D6F7665576F7264506172744C65667428652C742C6E29';
wwv_flow_imp.g_varchar2_table(31403) := '7D7D6B632E7265676973746572436F6D6D616E64416C6961732822637572736F72576F72645061727453746172744C656674222C22637572736F72576F7264506172744C65667422292C6B632E7265676973746572436F6D6D616E64416C696173282263';
wwv_flow_imp.g_varchar2_table(31404) := '7572736F72576F72645061727453746172744C65667453656C656374222C22637572736F72576F7264506172744C65667453656C65637422293B636C61737320726E6520657874656E6473204A74657B5F6D6F766528652C742C6E2C69297B7265747572';
wwv_flow_imp.g_varchar2_table(31405) := '6E2075532E6D6F7665576F726450617274526967687428652C742C6E297D7D5964286E657720636C61737320657874656E6473206E6E657B636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A2130';
wwv_flow_imp.g_varchar2_table(31406) := '2C776F72644E617669676174696F6E547970653A302C69643A2264656C657465576F7264506172744C656674222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F';
wwv_flow_imp.g_varchar2_table(31407) := '6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3736397D2C7765696768743A3130307D7D297D5F64656C65746528652C74297B72657475726E2075532E64656C657465576F7264506172744C6566742865297C7C6E65772072682831';
wwv_flow_imp.g_varchar2_table(31408) := '2C312C312C31297D7D292C5964286E657720636C61737320657874656E6473206E6E657B636F6E7374727563746F7228297B7375706572287B77686974657370616365486575726973746963733A21302C776F72644E617669676174696F6E547970653A';
wwv_flow_imp.g_varchar2_table(31409) := '322C69643A2264656C657465576F7264506172745269676874222C707265636F6E646974696F6E3A6C682E7772697461626C652C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B';
wwv_flow_imp.g_varchar2_table(31410) := '7072696D6172793A3738387D2C7765696768743A3130307D7D297D5F64656C65746528652C74297B636F6E7374206E3D75532E64656C657465576F72645061727452696768742865293B6966286E2972657475726E206E3B636F6E737420693D652E6D6F';
wwv_flow_imp.g_varchar2_table(31411) := '64656C2E6765744C696E65436F756E7428292C6F3D652E6D6F64656C2E6765744C696E654D6178436F6C756D6E2869293B72657475726E206E657720726828692C6F2C692C6F297D7D292C5964286E657720636C61737320657874656E647320736E657B';
wwv_flow_imp.g_varchar2_table(31412) := '636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21312C776F72644E617669676174696F6E547970653A302C69643A22637572736F72576F7264506172744C656674222C707265636F6E646974696F6E3A766F';
wwv_flow_imp.g_varchar2_table(31413) := '696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3738337D2C7765696768743A3130307D7D297D7D292C5964286E657720636C6173732065787465';
wwv_flow_imp.g_varchar2_table(31414) := '6E647320736E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A302C69643A22637572736F72576F7264506172744C65667453656C656374222C70';
wwv_flow_imp.g_varchar2_table(31415) := '7265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A313830377D2C7765696768743A3130307D7D297D7D292C5964';
wwv_flow_imp.g_varchar2_table(31416) := '286E657720636C61737320657874656E647320726E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21312C776F72644E617669676174696F6E547970653A322C69643A22637572736F72576F72645061';
wwv_flow_imp.g_varchar2_table(31417) := '72745269676874222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A3738357D2C7765696768743A313030';
wwv_flow_imp.g_varchar2_table(31418) := '7D7D297D7D292C5964286E657720636C61737320657874656E647320726E657B636F6E7374727563746F7228297B7375706572287B696E53656C656374696F6E4D6F64653A21302C776F72644E617669676174696F6E547970653A322C69643A22637572';
wwv_flow_imp.g_varchar2_table(31419) := '736F72576F726450617274526967687453656C656374222C707265636F6E646974696F6E3A766F696420302C6B624F7074733A7B6B62457870723A6C682E74657874496E707574466F6375732C7072696D6172793A302C6D61633A7B7072696D6172793A';
wwv_flow_imp.g_varchar2_table(31420) := '313830397D2C7765696768743A3130307D7D297D7D293B76617220616E653D6E2833363134292C6C6E653D7B7D3B6C6E652E7374796C655461675472616E73666F726D3D6A7228292C6C6E652E736574417474726962757465733D567228292C6C6E652E';
wwv_flow_imp.g_varchar2_table(31421) := '696E736572743D467228292E62696E64286E756C6C2C226865616422292C6C6E652E646F6D4150493D4F7228292C6C6E652E696E736572745374796C65456C656D656E743D487228292C4E72282928616E652E412C6C6E65292C616E652E412626616E65';
wwv_flow_imp.g_varchar2_table(31422) := '2E412E6C6F63616C732626616E652E412E6C6F63616C733B636C61737320636E6520657874656E6473206F577B636F6E7374727563746F7228652C742C6E297B737570657228652C6E2E6B65657049646C654D6F64656C737C7C21312C6E2E6C6162656C';
wwv_flow_imp.g_varchar2_table(31423) := '2C74292C746869732E5F666F726569676E4D6F64756C6549643D6E2E6D6F64756C6549642C746869732E5F666F726569676E4D6F64756C65437265617465446174613D6E2E637265617465446174617C7C6E756C6C2C746869732E5F666F726569676E4D';
wwv_flow_imp.g_varchar2_table(31424) := '6F64756C65486F73743D6E2E686F73747C7C6E756C6C2C746869732E5F666F726569676E50726F78793D6E756C6C7D66687228652C74297B69662821746869732E5F666F726569676E4D6F64756C65486F73747C7C2266756E6374696F6E22213D747970';
wwv_flow_imp.g_varchar2_table(31425) := '656F6620746869732E5F666F726569676E4D6F64756C65486F73745B655D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D697373696E67206D6574686F6420222B652B22206F72206D697373696E67206D61696E';
wwv_flow_imp.g_varchar2_table(31426) := '2074687265616420666F726569676E20686F73742E2229293B7472797B72657475726E2050726F6D6973652E7265736F6C766528746869732E5F666F726569676E4D6F64756C65486F73745B655D2E6170706C7928746869732E5F666F726569676E4D6F';
wwv_flow_imp.g_varchar2_table(31427) := '64756C65486F73742C7429297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D5F676574466F726569676E50726F787928297B72657475726E20746869732E5F666F726569676E50726F78797C7C28746869732E';
wwv_flow_imp.g_varchar2_table(31428) := '5F666F726569676E50726F78793D746869732E5F67657450726F787928292E7468656E2828653D3E7B636F6E737420743D746869732E5F666F726569676E4D6F64756C65486F73743F436828746869732E5F666F726569676E4D6F64756C65486F737429';
wwv_flow_imp.g_varchar2_table(31429) := '3A5B5D3B72657475726E20652E6C6F6164466F726569676E4D6F64756C6528746869732E5F666F726569676E4D6F64756C6549642C746869732E5F666F726569676E4D6F64756C65437265617465446174612C74292E7468656E2828743D3E7B74686973';
wwv_flow_imp.g_varchar2_table(31430) := '2E5F666F726569676E4D6F64756C65437265617465446174613D6E756C6C3B636F6E7374206E3D28742C6E293D3E652E666D7228742C6E292C693D28652C74293D3E66756E6374696F6E28297B636F6E7374206E3D41727261792E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(31431) := '2E736C6963652E63616C6C28617267756D656E74732C30293B72657475726E207428652C6E297D2C6F3D7B7D3B666F7228636F6E73742065206F662074296F5B655D3D6928652C6E293B72657475726E206F7D29297D2929292C746869732E5F666F7265';
wwv_flow_imp.g_varchar2_table(31432) := '69676E50726F78797D67657450726F787928297B72657475726E20746869732E5F676574466F726569676E50726F787928297D7769746853796E6365645265736F75726365732865297B72657475726E20746869732E5F7769746853796E636564526573';
wwv_flow_imp.g_varchar2_table(31433) := '6F75726365732865292E7468656E2828653D3E746869732E67657450726F7879282929297D7D66756E6374696F6E20646E652865297B72657475726E22737472696E67223D3D747970656F6620657D66756E6374696F6E20686E652865297B7265747572';
wwv_flow_imp.g_varchar2_table(31434) := '6E21646E652865297D66756E6374696F6E20756E652865297B72657475726E21657D66756E6374696F6E20706E6528652C74297B72657475726E20652E69676E6F7265436173652626743F742E746F4C6F7765724361736528293A747D66756E6374696F';
wwv_flow_imp.g_varchar2_table(31435) := '6E20676E652865297B72657475726E20652E7265706C616365282F5B263C3E27225F5D2F672C222D22297D66756E6374696F6E206D6E6528652C74297B72657475726E206E6577204572726F722860247B652E6C616E677561676549647D3A20247B747D';
wwv_flow_imp.g_varchar2_table(31436) := '60297D66756E6374696F6E20666E6528652C742C6E2C692C6F297B6C657420733D6E756C6C3B72657475726E20742E7265706C616365282F5C2428285C24297C2823297C285C645C643F297C5B73535D285C645C643F297C40285C772B29292F672C2866';
wwv_flow_imp.g_varchar2_table(31437) := '756E6374696F6E28742C722C612C6C2C632C642C682C752C70297B72657475726E20756E652861293F756E65286C293F21756E652863292626633C692E6C656E6774683F706E6528652C695B635D293A21756E65286829262665262622737472696E6722';
wwv_flow_imp.g_varchar2_table(31438) := '3D3D747970656F6620655B685D3F655B685D3A286E756C6C3D3D3D73262628733D6F2E73706C697428222E22292C732E756E7368696674286F29292C21756E652864292626643C732E6C656E6774683F706E6528652C735B645D293A2222293A706E6528';
wwv_flow_imp.g_varchar2_table(31439) := '652C6E293A2224227D29297D66756E6374696F6E20766E6528652C74297B6C6574206E3D743B666F72283B6E26266E2E6C656E6774683E303B297B636F6E737420743D652E746F6B656E697A65725B6E5D3B696628742972657475726E20743B636F6E73';
wwv_flow_imp.g_varchar2_table(31440) := '7420693D6E2E6C617374496E6465784F6628222E22293B6E3D693C303F6E756C6C3A6E2E73756273747228302C69297D72657475726E206E756C6C7D76617220626E653B636C617373205F6E657B7374617469632063726561746528652C74297B726574';
wwv_flow_imp.g_varchar2_table(31441) := '75726E20746869732E5F494E5354414E43452E63726561746528652C74297D636F6E7374727563746F722865297B746869732E5F6D6178436163686544657074683D652C746869732E5F656E74726965733D4F626A6563742E637265617465286E756C6C';
wwv_flow_imp.g_varchar2_table(31442) := '297D63726561746528652C74297B6966286E756C6C213D3D652626652E64657074683E3D746869732E5F6D6178436163686544657074682972657475726E206E657720796E6528652C74293B6C6574206E3D796E652E676574537461636B456C656D656E';
wwv_flow_imp.g_varchar2_table(31443) := '7449642865293B6E2E6C656E6774683E302626286E2B3D227C22292C6E2B3D743B6C657420693D746869732E5F656E74726965735B6E5D3B72657475726E20697C7C28693D6E657720796E6528652C74292C746869732E5F656E74726965735B6E5D3D69';
wwv_flow_imp.g_varchar2_table(31444) := '2C69297D7D5F6E652E5F494E5354414E43453D6E6577205F6E652835293B636C61737320796E657B636F6E7374727563746F7228652C74297B746869732E706172656E743D652C746869732E73746174653D742C746869732E64657074683D2874686973';
wwv_flow_imp.g_varchar2_table(31445) := '2E706172656E743F746869732E706172656E742E64657074683A30292B317D73746174696320676574537461636B456C656D656E7449642865297B6C657420743D22223B666F72283B6E756C6C213D3D653B29742E6C656E6774683E30262628742B3D22';
wwv_flow_imp.g_varchar2_table(31446) := '7C22292C742B3D652E73746174652C653D652E706172656E743B72657475726E20747D737461746963205F657175616C7328652C74297B666F72283B6E756C6C213D3D6526266E756C6C213D3D743B297B696628653D3D3D742972657475726E21303B69';
wwv_flow_imp.g_varchar2_table(31447) := '6628652E7374617465213D3D742E73746174652972657475726E21313B653D652E706172656E742C743D742E706172656E747D72657475726E206E756C6C3D3D3D6526266E756C6C3D3D3D747D657175616C732865297B72657475726E20796E652E5F65';
wwv_flow_imp.g_varchar2_table(31448) := '7175616C7328746869732C65297D707573682865297B72657475726E205F6E652E63726561746528746869732C65297D706F7028297B72657475726E20746869732E706172656E747D706F70616C6C28297B6C657420653D746869733B666F72283B652E';
wwv_flow_imp.g_varchar2_table(31449) := '706172656E743B29653D652E706172656E743B72657475726E20657D737769746368546F2865297B72657475726E205F6E652E63726561746528746869732E706172656E742C65297D7D636C61737320776E657B636F6E7374727563746F7228652C7429';
wwv_flow_imp.g_varchar2_table(31450) := '7B746869732E6C616E677561676549643D652C746869732E73746174653D747D657175616C732865297B72657475726E20746869732E6C616E677561676549643D3D3D652E6C616E677561676549642626746869732E73746174652E657175616C732865';
wwv_flow_imp.g_varchar2_table(31451) := '2E7374617465297D636C6F6E6528297B72657475726E20746869732E73746174652E636C6F6E6528293D3D3D746869732E73746174653F746869733A6E657720776E6528746869732E6C616E677561676549642C746869732E7374617465297D7D636C61';
wwv_flow_imp.g_varchar2_table(31452) := '737320436E657B7374617469632063726561746528652C74297B72657475726E20746869732E5F494E5354414E43452E63726561746528652C74297D636F6E7374727563746F722865297B746869732E5F6D6178436163686544657074683D652C746869';
wwv_flow_imp.g_varchar2_table(31453) := '732E5F656E74726965733D4F626A6563742E637265617465286E756C6C297D63726561746528652C74297B6966286E756C6C213D3D742972657475726E206E657720536E6528652C74293B6966286E756C6C213D3D652626652E64657074683E3D746869';
wwv_flow_imp.g_varchar2_table(31454) := '732E5F6D6178436163686544657074682972657475726E206E657720536E6528652C74293B636F6E7374206E3D796E652E676574537461636B456C656D656E7449642865293B6C657420693D746869732E5F656E74726965735B6E5D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(31455) := '697C7C28693D6E657720536E6528652C6E756C6C292C746869732E5F656E74726965735B6E5D3D692C69297D7D436E652E5F494E5354414E43453D6E657720436E652835293B636C61737320536E657B636F6E7374727563746F7228652C74297B746869';
wwv_flow_imp.g_varchar2_table(31456) := '732E737461636B3D652C746869732E656D6265646465644C616E6775616765446174613D747D636C6F6E6528297B72657475726E28746869732E656D6265646465644C616E6775616765446174613F746869732E656D6265646465644C616E6775616765';
wwv_flow_imp.g_varchar2_table(31457) := '446174612E636C6F6E6528293A6E756C6C293D3D3D746869732E656D6265646465644C616E6775616765446174613F746869733A436E652E63726561746528746869732E737461636B2C746869732E656D6265646465644C616E67756167654461746129';
wwv_flow_imp.g_varchar2_table(31458) := '7D657175616C732865297B72657475726E206520696E7374616E63656F6620536E6526262121746869732E737461636B2E657175616C7328652E737461636B292626286E756C6C3D3D3D746869732E656D6265646465644C616E67756167654461746126';
wwv_flow_imp.g_varchar2_table(31459) := '266E756C6C3D3D3D652E656D6265646465644C616E6775616765446174617C7C6E756C6C213D3D746869732E656D6265646465644C616E67756167654461746126266E756C6C213D3D652E656D6265646465644C616E6775616765446174612626746869';
wwv_flow_imp.g_varchar2_table(31460) := '732E656D6265646465644C616E6775616765446174612E657175616C7328652E656D6265646465644C616E67756167654461746129297D7D636C61737320786E657B636F6E7374727563746F7228297B746869732E5F746F6B656E733D5B5D2C74686973';
wwv_flow_imp.g_varchar2_table(31461) := '2E5F6C616E677561676549643D6E756C6C2C746869732E5F6C617374546F6B656E547970653D6E756C6C2C746869732E5F6C617374546F6B656E4C616E67756167653D6E756C6C7D656E7465724C616E67756167652865297B746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(31462) := '61676549643D657D656D697428652C74297B746869732E5F6C617374546F6B656E547970653D3D3D742626746869732E5F6C617374546F6B656E4C616E67756167653D3D3D746869732E5F6C616E677561676549647C7C28746869732E5F6C617374546F';
wwv_flow_imp.g_varchar2_table(31463) := '6B656E547970653D742C746869732E5F6C617374546F6B656E4C616E67756167653D746869732E5F6C616E677561676549642C746869732E5F746F6B656E732E70757368286E657720667728652C742C746869732E5F6C616E677561676549642929297D';
wwv_flow_imp.g_varchar2_table(31464) := '6E65737465644C616E6775616765546F6B656E697A6528652C742C6E2C69297B636F6E7374206F3D6E2E6C616E677561676549642C733D6E2E73746174652C723D50772E676574286F293B69662821722972657475726E20746869732E656E7465724C61';
wwv_flow_imp.g_varchar2_table(31465) := '6E6775616765286F292C746869732E656D697428692C2222292C733B636F6E737420613D722E746F6B656E697A6528652C742C73293B69662830213D3D6929666F7228636F6E73742065206F6620612E746F6B656E7329746869732E5F746F6B656E732E';
wwv_flow_imp.g_varchar2_table(31466) := '70757368286E657720667728652E6F66667365742B692C652E747970652C652E6C616E677561676529293B656C736520746869732E5F746F6B656E733D746869732E5F746F6B656E732E636F6E63617428612E746F6B656E73293B72657475726E207468';
wwv_flow_imp.g_varchar2_table(31467) := '69732E5F6C617374546F6B656E547970653D6E756C6C2C746869732E5F6C617374546F6B656E4C616E67756167653D6E756C6C2C746869732E5F6C616E677561676549643D6E756C6C2C612E656E6453746174657D66696E616C697A652865297B726574';
wwv_flow_imp.g_varchar2_table(31468) := '75726E206E657720767728746869732E5F746F6B656E732C65297D7D636C617373206B6E657B636F6E7374727563746F7228652C74297B746869732E5F6C616E6775616765536572766963653D652C746869732E5F7468656D653D742C746869732E5F70';
wwv_flow_imp.g_varchar2_table(31469) := '726570656E64546F6B656E733D6E756C6C2C746869732E5F746F6B656E733D5B5D2C746869732E5F63757272656E744C616E677561676549643D302C746869732E5F6C617374546F6B656E4D657461646174613D307D656E7465724C616E677561676528';
wwv_flow_imp.g_varchar2_table(31470) := '65297B746869732E5F63757272656E744C616E677561676549643D746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632E656E636F64654C616E677561676549642865297D656D697428652C74297B636F6E7374';
wwv_flow_imp.g_varchar2_table(31471) := '206E3D313032347C746869732E5F7468656D652E6D6174636828746869732E5F63757272656E744C616E677561676549642C74293B746869732E5F6C617374546F6B656E4D65746164617461213D3D6E262628746869732E5F6C617374546F6B656E4D65';
wwv_flow_imp.g_varchar2_table(31472) := '7461646174613D6E2C746869732E5F746F6B656E732E707573682865292C746869732E5F746F6B656E732E70757368286E29297D737461746963205F6D6572676528652C742C6E297B636F6E737420693D6E756C6C213D3D653F652E6C656E6774683A30';
wwv_flow_imp.g_varchar2_table(31473) := '2C6F3D742E6C656E6774682C733D6E756C6C213D3D6E3F6E2E6C656E6774683A303B696628303D3D3D692626303D3D3D6F2626303D3D3D732972657475726E206E65772055696E74333241727261792830293B696628303D3D3D692626303D3D3D6F2972';
wwv_flow_imp.g_varchar2_table(31474) := '657475726E206E3B696628303D3D3D6F2626303D3D3D732972657475726E20653B636F6E737420723D6E65772055696E743332417272617928692B6F2B73293B6E756C6C213D3D652626722E7365742865293B666F72286C657420653D303B653C6F3B65';
wwv_flow_imp.g_varchar2_table(31475) := '2B2B29725B692B655D3D745B655D3B72657475726E206E756C6C213D3D6E2626722E736574286E2C692B6F292C727D6E65737465644C616E6775616765546F6B656E697A6528652C742C6E2C69297B636F6E7374206F3D6E2E6C616E677561676549642C';
wwv_flow_imp.g_varchar2_table(31476) := '733D6E2E73746174652C723D50772E676574286F293B69662821722972657475726E20746869732E656E7465724C616E6775616765286F292C746869732E656D697428692C2222292C733B636F6E737420613D722E746F6B656E697A65456E636F646564';
wwv_flow_imp.g_varchar2_table(31477) := '28652C742C73293B69662830213D3D6929666F72286C657420653D302C743D612E746F6B656E732E6C656E6774683B653C743B652B3D3229612E746F6B656E735B655D2B3D693B72657475726E20746869732E5F70726570656E64546F6B656E733D6B6E';
wwv_flow_imp.g_varchar2_table(31478) := '652E5F6D6572676528746869732E5F70726570656E64546F6B656E732C746869732E5F746F6B656E732C612E746F6B656E73292C746869732E5F746F6B656E733D5B5D2C746869732E5F63757272656E744C616E677561676549643D302C746869732E5F';
wwv_flow_imp.g_varchar2_table(31479) := '6C617374546F6B656E4D657461646174613D302C612E656E6453746174657D66696E616C697A652865297B72657475726E206E6577206277286B6E652E5F6D6572676528746869732E5F70726570656E64546F6B656E732C746869732E5F746F6B656E73';
wwv_flow_imp.g_varchar2_table(31480) := '2C6E756C6C292C65297D7D6C657420456E653D626E653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E5F636F6E66696775726174696F6E536572766963653D6F2C';
wwv_flow_imp.g_varchar2_table(31481) := '746869732E5F6C616E6775616765536572766963653D652C746869732E5F7374616E64616C6F6E655468656D65536572766963653D742C746869732E5F6C616E677561676549643D6E2C746869732E5F6C657865723D692C746869732E5F656D62656464';
wwv_flow_imp.g_varchar2_table(31482) := '65644C616E6775616765733D4F626A6563742E637265617465286E756C6C292C746869732E656D6265646465644C6F616465643D50726F6D6973652E7265736F6C766528766F69642030293B6C657420733D21313B746869732E5F726567697374657228';
wwv_flow_imp.g_varchar2_table(31483) := '50772E6F6E4469644368616E67652828653D3E7B696628732972657475726E3B6C657420743D21313B666F72286C6574206E3D302C693D652E6368616E6765644C616E6775616765732E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D652E';
wwv_flow_imp.g_varchar2_table(31484) := '6368616E6765644C616E6775616765735B6E5D3B696628746869732E5F656D6265646465644C616E6775616765735B695D297B743D21303B627265616B7D7D74262628733D21302C50772E68616E646C654368616E6765285B746869732E5F6C616E6775';
wwv_flow_imp.g_varchar2_table(31485) := '61676549645D292C733D2131297D2929292C746869732E5F6D6178546F6B656E697A6174696F6E4C696E654C656E6774683D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E6D6178546F6B';
wwv_flow_imp.g_varchar2_table(31486) := '656E697A6174696F6E4C696E654C656E677468222C7B6F766572726964654964656E7469666965723A746869732E5F6C616E677561676549647D292C746869732E5F726567697374657228746869732E5F636F6E66696775726174696F6E536572766963';
wwv_flow_imp.g_varchar2_table(31487) := '652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E2822656469746F722E6D6178546F6B656E697A6174696F6E4C696E654C656E6774682229262628746869732E5F6D';
wwv_flow_imp.g_varchar2_table(31488) := '6178546F6B656E697A6174696F6E4C696E654C656E6774683D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E6D6178546F6B656E697A6174696F6E4C696E654C656E677468222C7B6F7665';
wwv_flow_imp.g_varchar2_table(31489) := '72726964654964656E7469666965723A746869732E5F6C616E677561676549647D29297D2929297D6765744C6F616453746174757328297B636F6E737420653D5B5D3B666F7228636F6E7374207420696E20746869732E5F656D6265646465644C616E67';
wwv_flow_imp.g_varchar2_table(31490) := '7561676573297B636F6E7374206E3D50772E6765742874293B6966286E297B6966286E20696E7374616E63656F6620626E65297B636F6E737420743D6E2E6765744C6F616453746174757328293B21313D3D3D742E6C6F616465642626652E7075736828';
wwv_flow_imp.g_varchar2_table(31491) := '742E70726F6D697365297D7D656C73652050772E69735265736F6C7665642874297C7C652E707573682850772E6765744F72437265617465287429297D72657475726E20303D3D3D652E6C656E6774683F7B6C6F616465643A21307D3A7B6C6F61646564';
wwv_flow_imp.g_varchar2_table(31492) := '3A21312C70726F6D6973653A50726F6D6973652E616C6C2865292E7468656E2828653D3E7B7D29297D7D676574496E697469616C537461746528297B636F6E737420653D5F6E652E637265617465286E756C6C2C746869732E5F6C657865722E73746172';
wwv_flow_imp.g_varchar2_table(31493) := '74293B72657475726E20436E652E63726561746528652C6E756C6C297D746F6B656E697A6528652C742C6E297B696628652E6C656E6774683E3D746869732E5F6D6178546F6B656E697A6174696F6E4C696E654C656E6774682972657475726E20467728';
wwv_flow_imp.g_varchar2_table(31494) := '746869732E5F6C616E677561676549642C6E293B636F6E737420693D6E657720786E652C6F3D746869732E5F746F6B656E697A6528652C742C6E2C69293B72657475726E20692E66696E616C697A65286F297D746F6B656E697A65456E636F6465642865';
wwv_flow_imp.g_varchar2_table(31495) := '2C742C6E297B696628652E6C656E6774683E3D746869732E5F6D6178546F6B656E697A6174696F6E4C696E654C656E6774682972657475726E20427728746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632E65';
wwv_flow_imp.g_varchar2_table(31496) := '6E636F64654C616E6775616765496428746869732E5F6C616E67756167654964292C6E293B636F6E737420693D6E6577206B6E6528746869732E5F6C616E6775616765536572766963652C746869732E5F7374616E64616C6F6E655468656D6553657276';
wwv_flow_imp.g_varchar2_table(31497) := '6963652E676574436F6C6F725468656D6528292E746F6B656E5468656D65292C6F3D746869732E5F746F6B656E697A6528652C742C6E2C69293B72657475726E20692E66696E616C697A65286F297D5F746F6B656E697A6528652C742C6E2C69297B7265';
wwv_flow_imp.g_varchar2_table(31498) := '7475726E206E2E656D6265646465644C616E6775616765446174613F746869732E5F6E6573746564546F6B656E697A6528652C742C6E2C302C69293A746869732E5F6D79546F6B656E697A6528652C742C6E2C302C69297D5F66696E644C656176696E67';
wwv_flow_imp.g_varchar2_table(31499) := '4E65737465644C616E67756167654F666673657428652C74297B6C6574206E3D746869732E5F6C657865722E746F6B656E697A65725B742E737461636B2E73746174655D3B696628216E2626286E3D766E6528746869732E5F6C657865722C742E737461';
wwv_flow_imp.g_varchar2_table(31500) := '636B2E7374617465292C216E29297468726F77206D6E6528746869732E5F6C657865722C22746F6B656E697A6572207374617465206973206E6F7420646566696E65643A20222B742E737461636B2E7374617465293B6C657420693D2D312C6F3D21313B';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(31501) := '666F7228636F6E73742073206F66206E297B69662821686E6528732E616374696F6E297C7C2240706F7022213D3D732E616374696F6E2E6E657874456D62656464656429636F6E74696E75653B6F3D21303B6C6574206E3D732E7265736F6C7665526567';
wwv_flow_imp.g_varchar2_table(31502) := '657828742E737461636B2E7374617465293B636F6E737420723D6E2E736F757263653B696628225E283F3A223D3D3D722E73756273747228302C342926262229223D3D3D722E73756273747228722E6C656E6774682D312C3129297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(31503) := '286E2E69676E6F7265436173653F2269223A2222292B286E2E756E69636F64653F2275223A2222293B6E3D6E65772052656745787028722E73756273747228342C722E6C656E6774682D35292C65297D636F6E737420613D652E736561726368286E293B';
wwv_flow_imp.g_varchar2_table(31504) := '2D313D3D3D617C7C30213D3D612626732E6D617463684F6E6C7941744C696E6553746172747C7C282D313D3D3D697C7C613C6929262628693D61297D696628216F297468726F77206D6E6528746869732E5F6C657865722C276E6F2072756C6520636F6E';
wwv_flow_imp.g_varchar2_table(31505) := '7461696E696E67206E657874456D6265646465643A202240706F702220696E20746F6B656E697A657220656D6265646465642073746174653A20272B742E737461636B2E7374617465293B72657475726E20697D5F6E6573746564546F6B656E697A6528';
wwv_flow_imp.g_varchar2_table(31506) := '652C742C6E2C692C6F297B636F6E737420733D746869732E5F66696E644C656176696E674E65737465644C616E67756167654F666673657428652C6E293B6966282D313D3D3D73297B636F6E737420733D6F2E6E65737465644C616E6775616765546F6B';
wwv_flow_imp.g_varchar2_table(31507) := '656E697A6528652C742C6E2E656D6265646465644C616E6775616765446174612C69293B72657475726E20436E652E637265617465286E2E737461636B2C6E657720776E65286E2E656D6265646465644C616E6775616765446174612E6C616E67756167';
wwv_flow_imp.g_varchar2_table(31508) := '6549642C7329297D636F6E737420723D652E737562737472696E6728302C73293B722E6C656E6774683E3026266F2E6E65737465644C616E6775616765546F6B656E697A6528722C21312C6E2E656D6265646465644C616E6775616765446174612C6929';
wwv_flow_imp.g_varchar2_table(31509) := '3B636F6E737420613D652E737562737472696E672873293B72657475726E20746869732E5F6D79546F6B656E697A6528612C742C6E2C692B732C6F297D5F7361666552756C654E616D652865297B72657475726E20653F652E6E616D653A2228756E6B6E';
wwv_flow_imp.g_varchar2_table(31510) := '6F776E29227D5F6D79546F6B656E697A6528652C742C6E2C692C6F297B6F2E656E7465724C616E677561676528746869732E5F6C616E67756167654964293B636F6E737420733D652E6C656E6774682C723D742626746869732E5F6C657865722E696E63';
wwv_flow_imp.g_varchar2_table(31511) := '6C7564654C463F652B225C6E223A652C613D722E6C656E6774683B6C6574206C3D6E2E656D6265646465644C616E6775616765446174612C633D6E2E737461636B2C643D302C683D6E756C6C2C753D21303B666F72283B757C7C643C613B297B636F6E73';
wwv_flow_imp.g_varchar2_table(31512) := '74206E3D642C6D3D632E64657074682C663D683F682E67726F7570732E6C656E6774683A302C763D632E73746174653B6C657420623D6E756C6C2C5F3D6E756C6C2C793D6E756C6C2C773D6E756C6C2C433D6E756C6C3B69662868297B623D682E6D6174';
wwv_flow_imp.g_varchar2_table(31513) := '636865733B636F6E737420653D682E67726F7570732E736869667428293B5F3D652E6D6174636865642C793D652E616374696F6E2C773D682E72756C652C303D3D3D682E67726F7570732E6C656E677468262628683D6E756C6C297D656C73657B696628';
wwv_flow_imp.g_varchar2_table(31514) := '21752626643E3D6129627265616B3B753D21313B6C657420653D746869732E5F6C657865722E746F6B656E697A65725B765D3B6966282165262628653D766E6528746869732E5F6C657865722C76292C216529297468726F77206D6E6528746869732E5F';
wwv_flow_imp.g_varchar2_table(31515) := '6C657865722C22746F6B656E697A6572207374617465206973206E6F7420646566696E65643A20222B76293B636F6E737420743D722E7375627374722864293B666F7228636F6E7374206E206F6620652969662828303D3D3D647C7C216E2E6D61746368';
wwv_flow_imp.g_varchar2_table(31516) := '4F6E6C7941744C696E65537461727429262628623D742E6D61746368286E2E7265736F6C76655265676578287629292C6229297B5F3D625B305D2C793D6E2E616374696F6E3B627265616B7D7D696628627C7C28623D5B22225D2C5F3D2222292C797C7C';
wwv_flow_imp.g_varchar2_table(31517) := '28643C61262628623D5B722E6368617241742864295D2C5F3D625B305D292C793D746869732E5F6C657865722E64656661756C74546F6B656E292C6E756C6C3D3D3D5F29627265616B3B666F7228642B3D5F2E6C656E6774683B2166756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(31518) := '65297B72657475726E2041727261792E697341727261792865297D2879292626686E652879292626792E746573743B29793D792E74657374285F2C622C762C643D3D3D61293B6C657420533D6E756C6C3B69662822737472696E67223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(31519) := '20797C7C41727261792E6973417272617928792929533D793B656C736520696628792E67726F757029533D792E67726F75703B656C7365206966286E756C6C213D3D792E746F6B656E2626766F69642030213D3D792E746F6B656E297B696628533D792E';
wwv_flow_imp.g_varchar2_table(31520) := '746F6B656E53756273743F666E6528746869732E5F6C657865722C792E746F6B656E2C5F2C622C76293A792E746F6B656E2C792E6E657874456D626564646564296966282240706F70223D3D3D792E6E657874456D626564646564297B696628216C2974';
wwv_flow_imp.g_varchar2_table(31521) := '68726F77206D6E6528746869732E5F6C657865722C2263616E6E6F7420706F7020656D626564646564206C616E6775616765206966206E6F7420696E73696465206F6E6522293B6C3D6E756C6C7D656C73657B6966286C297468726F77206D6E65287468';
wwv_flow_imp.g_varchar2_table(31522) := '69732E5F6C657865722C2263616E6E6F7420656E74657220656D626564646564206C616E67756167652066726F6D2077697468696E20616E20656D626564646564206C616E677561676522293B433D666E6528746869732E5F6C657865722C792E6E6578';
wwv_flow_imp.g_varchar2_table(31523) := '74456D6265646465642C5F2C622C76297D696628792E676F4261636B262628643D4D6174682E6D617828302C642D792E676F4261636B29292C792E737769746368546F262622737472696E67223D3D747970656F6620792E737769746368546F297B6C65';
wwv_flow_imp.g_varchar2_table(31524) := '7420653D666E6528746869732E5F6C657865722C792E737769746368546F2C5F2C622C76293B6966282240223D3D3D655B305D262628653D652E737562737472283129292C21766E6528746869732E5F6C657865722C6529297468726F77206D6E652874';
wwv_flow_imp.g_varchar2_table(31525) := '6869732E5F6C657865722C22747279696E6720746F2073776974636820746F20612073746174652027222B652B2227207468617420697320756E646566696E656420696E2072756C653A20222B746869732E5F7361666552756C654E616D65287729293B';
wwv_flow_imp.g_varchar2_table(31526) := '633D632E737769746368546F2865297D656C73657B696628792E7472616E73666F726D26262266756E6374696F6E223D3D747970656F6620792E7472616E73666F726D297468726F77206D6E6528746869732E5F6C657865722C22616374696F6E2E7472';
wwv_flow_imp.g_varchar2_table(31527) := '616E73666F726D206E6F7420737570706F7274656422293B696628792E6E65787429696628224070757368223D3D3D792E6E657874297B696628632E64657074683E3D746869732E5F6C657865722E6D6178537461636B297468726F77206D6E65287468';
wwv_flow_imp.g_varchar2_table(31528) := '69732E5F6C657865722C226D6178696D756D20746F6B656E697A657220737461636B2073697A6520726561636865643A205B222B632E73746174652B222C222B632E706172656E742E73746174652B222C2E2E2E5D22293B633D632E707573682876297D';
wwv_flow_imp.g_varchar2_table(31529) := '656C7365206966282240706F70223D3D3D792E6E657874297B696628632E64657074683C3D31297468726F77206D6E6528746869732E5F6C657865722C22747279696E6720746F20706F7020616E20656D70747920737461636B20696E2072756C653A20';
wwv_flow_imp.g_varchar2_table(31530) := '222B746869732E5F7361666552756C654E616D65287729293B633D632E706F7028297D656C7365206966282240706F70616C6C223D3D3D792E6E65787429633D632E706F70616C6C28293B656C73657B6C657420653D666E6528746869732E5F6C657865';
wwv_flow_imp.g_varchar2_table(31531) := '722C792E6E6578742C5F2C622C76293B6966282240223D3D3D655B305D262628653D652E737562737472283129292C21766E6528746869732E5F6C657865722C6529297468726F77206D6E6528746869732E5F6C657865722C22747279696E6720746F20';
wwv_flow_imp.g_varchar2_table(31532) := '7365742061206E6578742073746174652027222B652B2227207468617420697320756E646566696E656420696E2072756C653A20222B746869732E5F7361666552756C654E616D65287729293B633D632E707573682865297D7D792E6C6F672626227374';
wwv_flow_imp.g_varchar2_table(31533) := '72696E67223D3D747970656F6620792E6C6F67262628703D746869732E5F6C657865722C673D746869732E5F6C657865722E6C616E677561676549642B223A20222B666E6528746869732E5F6C657865722C792E6C6F672C5F2C622C76292C636F6E736F';
wwv_flow_imp.g_varchar2_table(31534) := '6C652E6C6F672860247B702E6C616E677561676549647D3A20247B677D6029297D6966286E756C6C3D3D3D53297468726F77206D6E6528746869732E5F6C657865722C226C657865722072756C6520686173206E6F2077656C6C2D646566696E65642061';
wwv_flow_imp.g_varchar2_table(31535) := '6374696F6E20696E2072756C653A20222B746869732E5F7361666552756C654E616D65287729293B636F6E737420783D6E3D3E7B636F6E737420733D746869732E5F6C616E6775616765536572766963652E6765744C616E6775616765496442794C616E';
wwv_flow_imp.g_varchar2_table(31536) := '67756167654E616D65286E297C7C746869732E5F6C616E6775616765536572766963652E6765744C616E6775616765496442794D696D6554797065286E297C7C6E2C723D746869732E5F6765744E6573746564456D6265646465644C616E677561676544';
wwv_flow_imp.g_varchar2_table(31537) := '6174612873293B696628643C61297B636F6E7374206E3D652E7375627374722864293B72657475726E20746869732E5F6E6573746564546F6B656E697A65286E2C742C436E652E63726561746528632C72292C692B642C6F297D72657475726E20436E65';
wwv_flow_imp.g_varchar2_table(31538) := '2E63726561746528632C72297D3B69662841727261792E69734172726179285329297B696628682626682E67726F7570732E6C656E6774683E30297468726F77206D6E6528746869732E5F6C657865722C2267726F7570732063616E6E6F74206265206E';
wwv_flow_imp.g_varchar2_table(31539) := '65737465643A20222B746869732E5F7361666552756C654E616D65287729293B696628622E6C656E677468213D3D532E6C656E6774682B31297468726F77206D6E6528746869732E5F6C657865722C226D617463686564206E756D626572206F66206772';
wwv_flow_imp.g_varchar2_table(31540) := '6F75707320646F6573206E6F74206D6174636820746865206E756D626572206F6620616374696F6E7320696E2072756C653A20222B746869732E5F7361666552756C654E616D65287729293B6C657420653D303B666F72286C657420743D313B743C622E';
wwv_flow_imp.g_varchar2_table(31541) := '6C656E6774683B742B2B29652B3D625B745D2E6C656E6774683B69662865213D3D5F2E6C656E677468297468726F77206D6E6528746869732E5F6C657865722C22776974682067726F7570732C20616C6C20636861726163746572732073686F756C6420';
wwv_flow_imp.g_varchar2_table(31542) := '6265206D61746368656420696E20636F6E73656375746976652067726F75707320696E2072756C653A20222B746869732E5F7361666552756C654E616D65287729293B683D7B72756C653A772C6D6174636865733A622C67726F7570733A5B5D7D3B666F';
wwv_flow_imp.g_varchar2_table(31543) := '72286C657420653D303B653C532E6C656E6774683B652B2B29682E67726F7570735B655D3D7B616374696F6E3A535B655D2C6D6174636865643A625B652B315D7D3B642D3D5F2E6C656E6774687D656C73657B7B696628224072656D61746368223D3D3D';
wwv_flow_imp.g_varchar2_table(31544) := '53262628642D3D5F2E6C656E6774682C5F3D22222C623D6E756C6C2C533D22222C6E756C6C213D3D43292972657475726E20782843293B696628303D3D3D5F2E6C656E677468297B696628303D3D3D617C7C6D213D3D632E64657074687C7C76213D3D63';
wwv_flow_imp.g_varchar2_table(31545) := '2E73746174657C7C28683F682E67726F7570732E6C656E6774683A3029213D3D6629636F6E74696E75653B7468726F77206D6E6528746869732E5F6C657865722C226E6F2070726F677265737320696E20746F6B656E697A657220696E2072756C653A20';
wwv_flow_imp.g_varchar2_table(31546) := '222B746869732E5F7361666552756C654E616D65287729297D6C657420653D6E756C6C3B696628646E652853292626303D3D3D532E696E6465784F66282240627261636B6574732229297B636F6E737420743D532E7375627374722839292C6E3D4C6E65';
wwv_flow_imp.g_varchar2_table(31547) := '28746869732E5F6C657865722C5F293B696628216E297468726F77206D6E6528746869732E5F6C657865722C2240627261636B65747320746F6B656E2072657475726E656420627574206E6F20627261636B657420646566696E65642061733A20222B5F';
wwv_flow_imp.g_varchar2_table(31548) := '293B653D676E65286E2E746F6B656E2B74297D656C736520653D676E652822223D3D3D533F22223A532B746869732E5F6C657865722E746F6B656E506F7374666978293B6E3C7326266F2E656D6974286E2B692C65297D6966286E756C6C213D3D432972';
wwv_flow_imp.g_varchar2_table(31549) := '657475726E20782843297D7D76617220702C673B72657475726E20436E652E63726561746528632C6C297D5F6765744E6573746564456D6265646465644C616E6775616765446174612865297B69662821746869732E5F6C616E67756167655365727669';
wwv_flow_imp.g_varchar2_table(31550) := '63652E6973526567697374657265644C616E677561676549642865292972657475726E206E657720776E6528652C5277293B65213D3D746869732E5F6C616E67756167654964262628746869732E5F6C616E6775616765536572766963652E7265717565';
wwv_flow_imp.g_varchar2_table(31551) := '737442617369634C616E677561676546656174757265732865292C50772E6765744F724372656174652865292C746869732E5F656D6265646465644C616E6775616765735B655D3D2130293B636F6E737420743D50772E6765742865293B72657475726E';
wwv_flow_imp.g_varchar2_table(31552) := '206E657720776E6528652C743F742E676574496E697469616C537461746528293A5277297D7D3B66756E6374696F6E204C6E6528652C74297B69662821742972657475726E206E756C6C3B743D706E6528652C74293B636F6E7374206E3D652E62726163';
wwv_flow_imp.g_varchar2_table(31553) := '6B6574733B666F7228636F6E73742065206F66206E297B696628652E6F70656E3D3D3D742972657475726E7B746F6B656E3A652E746F6B656E2C627261636B6574547970653A317D3B696628652E636C6F73653D3D3D742972657475726E7B746F6B656E';
wwv_flow_imp.g_varchar2_table(31554) := '3A652E746F6B656E2C627261636B6574547970653A2D317D7D72657475726E206E756C6C7D456E653D626E653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C';
wwv_flow_imp.g_varchar2_table(31555) := '3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563';
wwv_flow_imp.g_varchar2_table(31556) := '742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E33';
wwv_flow_imp.g_varchar2_table(31557) := '3F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(31558) := '6E2C69297B74286E2C692C65297D7D28342C6670295D2C456E65293B636F6E737420446E653D654528227374616E64616C6F6E65436F6C6F72697A6572222C7B63726561746548544D4C3A653D3E657D293B636C61737320546E657B7374617469632063';
wwv_flow_imp.g_varchar2_table(31559) := '6F6C6F72697A65456C656D656E7428652C742C6E2C69297B636F6E7374206F3D28693D697C7C7B7D292E7468656D657C7C227673222C733D692E6D696D65547970657C7C6E2E67657441747472696275746528226C616E6722297C7C6E2E676574417474';
wwv_flow_imp.g_varchar2_table(31560) := '7269627574652822646174612D6C616E6722293B69662821732972657475726E20636F6E736F6C652E6572726F7228224D6F6465206E6F7420646574656374656422292C50726F6D6973652E7265736F6C766528293B636F6E737420723D742E6765744C';
wwv_flow_imp.g_varchar2_table(31561) := '616E6775616765496442794D696D65547970652873297C7C733B652E7365745468656D65286F293B636F6E737420613D6E2E66697273744368696C643F6E2E66697273744368696C642E6E6F646556616C75653A22223B72657475726E206E2E636C6173';
wwv_flow_imp.g_varchar2_table(31562) := '734E616D652B3D2220222B6F2C746869732E636F6C6F72697A6528742C617C7C22222C722C69292E7468656E2828653D3E7B76617220743B636F6E737420693D6E756C6C213D3D28743D6E756C6C3D3D446E653F766F696420303A446E652E6372656174';
wwv_flow_imp.g_varchar2_table(31563) := '6548544D4C286529292626766F69642030213D3D743F743A653B6E2E696E6E657248544D4C3D697D292C28653D3E636F6E736F6C652E6572726F7228652929297D737461746963206173796E6320636F6C6F72697A6528652C742C6E2C69297B636F6E73';
wwv_flow_imp.g_varchar2_table(31564) := '74206F3D652E6C616E67756167654964436F6465633B6C657420733D343B692626226E756D626572223D3D747970656F6620692E74616253697A65262628733D692E74616253697A65292C5569287429262628743D742E737562737472283129293B636F';
wwv_flow_imp.g_varchar2_table(31565) := '6E737420723D67692874293B69662821652E6973526567697374657265644C616E67756167654964286E292972657475726E20496E6528722C732C6F293B636F6E737420613D61776169742050772E6765744F72437265617465286E293B72657475726E';
wwv_flow_imp.g_varchar2_table(31566) := '20613F66756E6374696F6E28652C742C6E2C69297B72657475726E206E65772050726F6D6973652828286F2C73293D3E7B636F6E737420723D28293D3E7B636F6E737420613D66756E6374696F6E28652C742C6E2C69297B6C6574206F3D5B5D2C733D6E';
wwv_flow_imp.g_varchar2_table(31567) := '2E676574496E697469616C537461746528293B666F72286C657420723D302C613D652E6C656E6774683B723C613B722B2B297B636F6E737420613D655B725D2C6C3D6E2E746F6B656E697A65456E636F64656428612C21302C73293B57772E636F6E7665';
wwv_flow_imp.g_varchar2_table(31568) := '7274546F456E644F6666736574286C2E746F6B656E732C612E6C656E677468293B636F6E737420633D6E6577205777286C2E746F6B656E732C612C69292C643D784F2E69734261736963415343494928612C2130292C683D784F2E636F6E7461696E7352';
wwv_flow_imp.g_varchar2_table(31569) := '544C28612C642C2130292C753D774E286E6577206D4E2821312C21302C612C21312C642C682C302C632E696E666C61746528292C5B5D2C742C302C302C302C302C2D312C226E6F6E65222C21312C21312C6E756C6C29293B6F3D6F2E636F6E6361742875';
wwv_flow_imp.g_varchar2_table(31570) := '2E68746D6C292C6F2E7075736828223C62722F3E22292C733D6C2E656E6453746174657D72657475726E206F2E6A6F696E282222297D28652C742C6E2C69293B6966286E20696E7374616E63656F6620456E65297B636F6E737420653D6E2E6765744C6F';
wwv_flow_imp.g_varchar2_table(31571) := '616453746174757328293B69662821313D3D3D652E6C6F616465642972657475726E20766F696420652E70726F6D6973652E7468656E28722C73297D6F2861297D3B7228297D29297D28722C732C612C6F293A496E6528722C732C6F297D737461746963';
wwv_flow_imp.g_varchar2_table(31572) := '20636F6C6F72697A654C696E6528652C742C6E2C692C6F3D34297B636F6E737420733D784F2E69734261736963415343494928652C74292C723D784F2E636F6E7461696E7352544C28652C732C6E293B72657475726E20774E286E6577206D4E2821312C';
wwv_flow_imp.g_varchar2_table(31573) := '21302C652C21312C732C722C302C692C5B5D2C6F2C302C302C302C302C2D312C226E6F6E65222C21312C21312C6E756C6C29292E68746D6C7D73746174696320636F6C6F72697A654D6F64656C4C696E6528652C742C6E3D34297B636F6E737420693D65';
wwv_flow_imp.g_varchar2_table(31574) := '2E6765744C696E65436F6E74656E742874293B652E746F6B656E697A6174696F6E2E666F726365546F6B656E697A6174696F6E2874293B636F6E7374206F3D652E746F6B656E697A6174696F6E2E6765744C696E65546F6B656E732874292E696E666C61';
wwv_flow_imp.g_varchar2_table(31575) := '746528293B72657475726E20746869732E636F6C6F72697A654C696E6528692C652E6D69676874436F6E7461696E4E6F6E4261736963415343494928292C652E6D69676874436F6E7461696E52544C28292C6F2C6E297D7D66756E6374696F6E20496E65';
wwv_flow_imp.g_varchar2_table(31576) := '28652C742C6E297B6C657420693D5B5D3B636F6E7374206F3D6E65772055696E74333241727261792832293B6F5B305D3D302C6F5B315D3D33333538373230303B666F72286C657420733D302C723D652E6C656E6774683B733C723B732B2B297B636F6E';
wwv_flow_imp.g_varchar2_table(31577) := '737420723D655B735D3B6F5B305D3D722E6C656E6774683B636F6E737420613D6E6577205777286F2C722C6E292C6C3D784F2E69734261736963415343494928722C2130292C633D784F2E636F6E7461696E7352544C28722C6C2C2130292C643D774E28';
wwv_flow_imp.g_varchar2_table(31578) := '6E6577206D4E2821312C21302C722C21312C6C2C632C302C612C5B5D2C742C302C302C302C302C2D312C226E6F6E65222C21312C21312C6E756C6C29293B693D692E636F6E63617428642E68746D6C292C692E7075736828223C62722F3E22297D726574';
wwv_flow_imp.g_varchar2_table(31579) := '75726E20692E6A6F696E282222297D6C6574204D6E653D636C61737320657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F7468656D65536572766963653D652C746869732E5F6F6E57696C6C43726561';
wwv_flow_imp.g_varchar2_table(31580) := '7465436F6465456469746F723D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E436F6465456469746F724164643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436F6465456469746F724164';
wwv_flow_imp.g_varchar2_table(31581) := '643D746869732E5F6F6E436F6465456469746F724164642E6576656E742C746869732E5F6F6E436F6465456469746F7252656D6F76653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E436F6465456469746F7252656D6F76';
wwv_flow_imp.g_varchar2_table(31582) := '653D746869732E5F6F6E436F6465456469746F7252656D6F76652E6576656E742C746869732E5F6F6E57696C6C43726561746544696666456469746F723D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E44696666456469';
wwv_flow_imp.g_varchar2_table(31583) := '746F724164643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696666456469746F724164643D746869732E5F6F6E44696666456469746F724164642E6576656E742C746869732E5F6F6E44696666456469746F7252656D';
wwv_flow_imp.g_varchar2_table(31584) := '6F76653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696666456469746F7252656D6F76653D746869732E5F6F6E44696666456469746F7252656D6F76652E6576656E742C746869732E5F6465636F726174696F6E4F70';
wwv_flow_imp.g_varchar2_table(31585) := '74696F6E50726F7669646572733D6E6577204D61702C746869732E5F636F6465456469746F724F70656E48616E646C6572733D6E65772067742C746869732E5F6D6F64656C50726F706572746965733D6E6577204D61702C746869732E5F636F64654564';
wwv_flow_imp.g_varchar2_table(31586) := '69746F72733D4F626A6563742E637265617465286E756C6C292C746869732E5F64696666456469746F72733D4F626A6563742E637265617465286E756C6C292C746869732E5F676C6F62616C5374796C6553686565743D6E756C6C7D77696C6C43726561';
wwv_flow_imp.g_varchar2_table(31587) := '7465436F6465456469746F7228297B746869732E5F6F6E57696C6C437265617465436F6465456469746F722E6669726528297D616464436F6465456469746F722865297B746869732E5F636F6465456469746F72735B652E676574496428295D3D652C74';
wwv_flow_imp.g_varchar2_table(31588) := '6869732E5F6F6E436F6465456469746F724164642E666972652865297D72656D6F7665436F6465456469746F722865297B64656C65746520746869732E5F636F6465456469746F72735B652E676574496428295D2626746869732E5F6F6E436F64654564';
wwv_flow_imp.g_varchar2_table(31589) := '69746F7252656D6F76652E666972652865297D6C697374436F6465456469746F727328297B72657475726E204F626A6563742E6B65797328746869732E5F636F6465456469746F7273292E6D61702828653D3E746869732E5F636F6465456469746F7273';
wwv_flow_imp.g_varchar2_table(31590) := '5B655D29297D77696C6C43726561746544696666456469746F7228297B746869732E5F6F6E57696C6C43726561746544696666456469746F722E6669726528297D61646444696666456469746F722865297B746869732E5F64696666456469746F72735B';
wwv_flow_imp.g_varchar2_table(31591) := '652E676574496428295D3D652C746869732E5F6F6E44696666456469746F724164642E666972652865297D6C69737444696666456469746F727328297B72657475726E204F626A6563742E6B65797328746869732E5F64696666456469746F7273292E6D';
wwv_flow_imp.g_varchar2_table(31592) := '61702828653D3E746869732E5F64696666456469746F72735B655D29297D676574466F6375736564436F6465456469746F7228297B6C657420653D6E756C6C3B636F6E737420743D746869732E6C697374436F6465456469746F727328293B666F722863';
wwv_flow_imp.g_varchar2_table(31593) := '6F6E7374206E206F662074297B6966286E2E68617354657874466F63757328292972657475726E206E3B6E2E686173576964676574466F6375732829262628653D6E297D72657475726E20657D72656D6F76654465636F726174696F6E54797065286529';
wwv_flow_imp.g_varchar2_table(31594) := '7B636F6E737420743D746869732E5F6465636F726174696F6E4F7074696F6E50726F7669646572732E6765742865293B74262628742E726566436F756E742D2D2C742E726566436F756E743C3D30262628746869732E5F6465636F726174696F6E4F7074';
wwv_flow_imp.g_varchar2_table(31595) := '696F6E50726F7669646572732E64656C6574652865292C742E646973706F736528292C746869732E6C697374436F6465456469746F727328292E666F72456163682828743D3E742E72656D6F76654465636F726174696F6E734279547970652865292929';
wwv_flow_imp.g_varchar2_table(31596) := '29297D7365744D6F64656C50726F706572747928652C742C6E297B636F6E737420693D652E746F537472696E6728293B6C6574206F3B746869732E5F6D6F64656C50726F706572746965732E6861732869293F6F3D746869732E5F6D6F64656C50726F70';
wwv_flow_imp.g_varchar2_table(31597) := '6572746965732E6765742869293A286F3D6E6577204D61702C746869732E5F6D6F64656C50726F706572746965732E73657428692C6F29292C6F2E73657428742C6E297D6765744D6F64656C50726F706572747928652C74297B636F6E7374206E3D652E';
wwv_flow_imp.g_varchar2_table(31598) := '746F537472696E6728293B696628746869732E5F6D6F64656C50726F706572746965732E686173286E292972657475726E20746869732E5F6D6F64656C50726F706572746965732E676574286E292E6765742874297D6173796E63206F70656E436F6465';
wwv_flow_imp.g_varchar2_table(31599) := '456469746F7228652C742C6E297B666F7228636F6E73742069206F6620746869732E5F636F6465456469746F724F70656E48616E646C657273297B636F6E7374206F3D6177616974206928652C742C6E293B6966286E756C6C213D3D6F2972657475726E';
wwv_flow_imp.g_varchar2_table(31600) := '206F7D72657475726E206E756C6C7D7265676973746572436F6465456469746F724F70656E48616E646C65722865297B72657475726E20727428746869732E5F636F6465456469746F724F70656E48616E646C6572732E756E7368696674286529297D7D';
wwv_flow_imp.g_varchar2_table(31601) := '3B4D6E653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F722874';
wwv_flow_imp.g_varchar2_table(31602) := '2C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B65';
wwv_flow_imp.g_varchar2_table(31603) := '6C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A';
wwv_flow_imp.g_varchar2_table(31604) := '6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28302C5062295D2C4D6E65293B76617220416E653D66756E63';
wwv_flow_imp.g_varchar2_table(31605) := '74696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204E6E653D636C61737320657874656E6473204D6E657B636F6E7374727563746F7228652C74297B73757065722874292C746869732E5F';
wwv_flow_imp.g_varchar2_table(31606) := '726567697374657228746869732E6F6E436F6465456469746F72416464282828293D3E746869732E5F636865636B436F6E746578744B657928292929292C746869732E5F726567697374657228746869732E6F6E436F6465456469746F7252656D6F7665';
wwv_flow_imp.g_varchar2_table(31607) := '282828293D3E746869732E5F636865636B436F6E746578744B657928292929292C746869732E5F656469746F7249734F70656E3D652E6372656174654B65792822656469746F7249734F70656E222C2131292C746869732E5F616374697665436F646545';
wwv_flow_imp.g_varchar2_table(31608) := '6469746F723D6E756C6C2C746869732E5F726567697374657228746869732E7265676973746572436F6465456469746F724F70656E48616E646C657228286173796E6328652C742C6E293D3E743F746869732E646F4F70656E456469746F7228742C6529';
wwv_flow_imp.g_varchar2_table(31609) := '3A6E756C6C2929297D5F636865636B436F6E746578744B657928297B6C657420653D21313B666F7228636F6E73742074206F6620746869732E6C697374436F6465456469746F727328292969662821742E697353696D706C65576964676574297B653D21';
wwv_flow_imp.g_varchar2_table(31610) := '303B627265616B7D746869732E5F656469746F7249734F70656E2E7365742865297D736574416374697665436F6465456469746F722865297B746869732E5F616374697665436F6465456469746F723D657D676574416374697665436F6465456469746F';
wwv_flow_imp.g_varchar2_table(31611) := '7228297B72657475726E20746869732E5F616374697665436F6465456469746F727D646F4F70656E456469746F7228652C74297B69662821746869732E66696E644D6F64656C28652C742E7265736F7572636529297B696628742E7265736F7572636529';
wwv_flow_imp.g_varchar2_table(31612) := '7B636F6E7374206E3D742E7265736F757263652E736368656D653B6966286E3D3D3D716F2E687474707C7C6E3D3D3D716F2E68747470732972657475726E20437228742E7265736F757263652E746F537472696E672829292C657D72657475726E206E75';
wwv_flow_imp.g_varchar2_table(31613) := '6C6C7D636F6E7374206E3D742E6F7074696F6E733F742E6F7074696F6E732E73656C656374696F6E3A6E756C6C3B6966286E29696628226E756D626572223D3D747970656F66206E2E656E644C696E654E756D6265722626226E756D626572223D3D7479';
wwv_flow_imp.g_varchar2_table(31614) := '70656F66206E2E656E64436F6C756D6E29652E73657453656C656374696F6E286E292C652E72657665616C52616E6765496E43656E746572286E2C31293B656C73657B636F6E737420743D7B6C696E654E756D6265723A6E2E73746172744C696E654E75';
wwv_flow_imp.g_varchar2_table(31615) := '6D6265722C636F6C756D6E3A6E2E7374617274436F6C756D6E7D3B652E736574506F736974696F6E2874292C652E72657665616C506F736974696F6E496E43656E74657228742C31297D72657475726E20657D66696E644D6F64656C28652C74297B636F';
wwv_flow_imp.g_varchar2_table(31616) := '6E7374206E3D652E6765744D6F64656C28293B72657475726E206E26266E2E7572692E746F537472696E672829213D3D742E746F537472696E6728293F6E756C6C3A6E7D7D3B4E6E653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D';
wwv_flow_imp.g_varchar2_table(31617) := '617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65';
wwv_flow_imp.g_varchar2_table(31618) := '637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B61';
wwv_flow_imp.g_varchar2_table(31619) := '2D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B41';
wwv_flow_imp.g_varchar2_table(31620) := '6E6528302C6364292C416E6528312C5062295D2C4E6E65292C78702867632C4E6E652C30293B636F6E737420506E653D706328226C61796F75745365727669636522293B766172204F6E653D66756E6374696F6E28652C742C6E2C69297B766172206F2C';
wwv_flow_imp.g_varchar2_table(31621) := '733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F6620526566';
wwv_flow_imp.g_varchar2_table(31622) := '6C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D30';
wwv_flow_imp.g_varchar2_table(31623) := '3B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C';
wwv_flow_imp.g_varchar2_table(31624) := '526E653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C657420466E653D636C6173737B676574206D61696E436F6E7461696E657228297B76617220652C743B72657475726E206E';
wwv_flow_imp.g_varchar2_table(31625) := '756C6C213D3D28743D6E756C6C3D3D3D28653D246828746869732E5F636F6465456469746F72536572766963652E6C697374436F6465456469746F7273282929297C7C766F696420303D3D3D653F766F696420303A652E676574436F6E7461696E657244';
wwv_flow_imp.g_varchar2_table(31626) := '6F6D4E6F64652829292626766F69642030213D3D743F743A732E646F63756D656E742E626F64797D67657420616374697665436F6E7461696E657228297B76617220652C743B636F6E7374206E3D6E756C6C213D3D28653D746869732E5F636F64654564';
wwv_flow_imp.g_varchar2_table(31627) := '69746F72536572766963652E676574466F6375736564436F6465456469746F722829292626766F69642030213D3D653F653A746869732E5F636F6465456469746F72536572766963652E676574416374697665436F6465456469746F7228293B72657475';
wwv_flow_imp.g_varchar2_table(31628) := '726E206E756C6C213D3D28743D6E756C6C3D3D6E3F766F696420303A6E2E676574436F6E7461696E6572446F6D4E6F64652829292626766F69642030213D3D743F743A746869732E6D61696E436F6E7461696E65727D676574206D61696E436F6E746169';
wwv_flow_imp.g_varchar2_table(31629) := '6E657244696D656E73696F6E28297B72657475726E20447328746869732E6D61696E436F6E7461696E6572297D67657420616374697665436F6E7461696E657244696D656E73696F6E28297B72657475726E20447328746869732E616374697665436F6E';
wwv_flow_imp.g_varchar2_table(31630) := '7461696E6572297D67657420636F6E7461696E65727328297B72657475726E207A6828746869732E5F636F6465456469746F72536572766963652E6C697374436F6465456469746F727328292E6D61702828653D3E652E676574436F6E7461696E657244';
wwv_flow_imp.g_varchar2_table(31631) := '6F6D4E6F646528292929297D676574436F6E7461696E657228297B72657475726E20746869732E616374697665436F6E7461696E65727D7768656E436F6E7461696E65725374796C65734C6F6164656428297B7D666F63757328297B76617220653B6E75';
wwv_flow_imp.g_varchar2_table(31632) := '6C6C3D3D3D28653D746869732E5F636F6465456469746F72536572766963652E676574466F6375736564436F6465456469746F722829297C7C766F696420303D3D3D657C7C652E666F63757328297D636F6E7374727563746F722865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(31633) := '636F6465456469746F72536572766963653D652C746869732E6F6E4469644C61796F75744D61696E436F6E7461696E65723D76742E4E6F6E652C746869732E6F6E4469644C61796F7574416374697665436F6E7461696E65723D76742E4E6F6E652C7468';
wwv_flow_imp.g_varchar2_table(31634) := '69732E6F6E4469644C61796F7574436F6E7461696E65723D76742E4E6F6E652C746869732E6F6E4469644368616E6765416374697665436F6E7461696E65723D76742E4E6F6E652C746869732E6F6E446964416464436F6E7461696E65723D76742E4E6F';
wwv_flow_imp.g_varchar2_table(31635) := '6E652C746869732E6D61696E436F6E7461696E65724F66667365743D7B746F703A302C717569636B5069636B546F703A307D2C746869732E616374697665436F6E7461696E65724F66667365743D7B746F703A302C717569636B5069636B546F703A307D';
wwv_flow_imp.g_varchar2_table(31636) := '7D7D3B466E653D4F6E65285B526E6528302C6763295D2C466E65293B6C657420426E653D636C61737320657874656E647320466E657B676574206D61696E436F6E7461696E657228297B72657475726E20746869732E5F636F6E7461696E65727D636F6E';
wwv_flow_imp.g_varchar2_table(31637) := '7374727563746F7228652C74297B73757065722874292C746869732E5F636F6E7461696E65723D657D7D3B426E653D4F6E65285B526E6528312C6763295D2C426E65292C787028506E652C466E652C31293B76617220566E653D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(31638) := '2C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E207A6E652865297B72657475726E20652E736368656D653D3D3D716F2E66696C653F652E6673506174683A652E706174687D6C657420486E';
wwv_flow_imp.g_varchar2_table(31639) := '653D303B636C61737320576E657B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E69643D2B2B486E652C746869732E747970653D302C746869732E61637475616C3D652C746869732E6C6162656C3D652E6C6162656C2C';
wwv_flow_imp.g_varchar2_table(31640) := '746869732E636F6E6669726D4265666F7265556E646F3D652E636F6E6669726D4265666F7265556E646F7C7C21312C746869732E7265736F757263654C6162656C3D742C746869732E7374725265736F757263653D6E2C746869732E7265736F75726365';
wwv_flow_imp.g_varchar2_table(31641) := '4C6162656C733D5B746869732E7265736F757263654C6162656C5D2C746869732E7374725265736F75726365733D5B746869732E7374725265736F757263655D2C746869732E67726F757049643D692C746869732E67726F75704F726465723D6F2C7468';
wwv_flow_imp.g_varchar2_table(31642) := '69732E736F7572636549643D732C746869732E736F757263654F726465723D722C746869732E697356616C69643D21307D73657456616C69642865297B746869732E697356616C69643D657D746F537472696E6728297B72657475726E605B69643A247B';
wwv_flow_imp.g_varchar2_table(31643) := '746869732E69647D5D205B67726F75703A247B746869732E67726F757049647D5D205B247B746869732E697356616C69643F22202056414C4944223A22494E56414C4944227D5D20247B746869732E61637475616C2E636F6E7374727563746F722E6E61';
wwv_flow_imp.g_varchar2_table(31644) := '6D657D202D20247B746869732E61637475616C7D607D7D636C617373206A6E657B636F6E7374727563746F7228652C74297B746869732E7265736F757263654C6162656C3D652C746869732E726561736F6E3D747D7D636C61737320716E657B636F6E73';
wwv_flow_imp.g_varchar2_table(31645) := '74727563746F7228297B746869732E656C656D656E74733D6E6577204D61707D6372656174654D65737361676528297B636F6E737420653D5B5D2C743D5B5D3B666F7228636F6E73745B2C6E5D6F6620746869732E656C656D656E74732928303D3D3D6E';
wwv_flow_imp.g_varchar2_table(31646) := '2E726561736F6E3F653A74292E70757368286E2E7265736F757263654C6162656C293B636F6E7374206E3D5B5D3B72657475726E20652E6C656E6774683E3026266E2E70757368286228302C2254686520666F6C6C6F77696E672066696C657320686176';
wwv_flow_imp.g_varchar2_table(31647) := '65206265656E20636C6F73656420616E64206D6F646966696564206F6E206469736B3A207B307D2E222C652E6A6F696E28222C20222929292C742E6C656E6774683E3026266E2E70757368286228302C2254686520666F6C6C6F77696E672066696C6573';
wwv_flow_imp.g_varchar2_table(31648) := '2068617665206265656E206D6F64696669656420696E20616E20696E636F6D70617469626C65207761793A207B307D2E222C742E6A6F696E28222C20222929292C6E2E6A6F696E28225C6E22297D6765742073697A6528297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(31649) := '2E656C656D656E74732E73697A657D6861732865297B72657475726E20746869732E656C656D656E74732E6861732865297D73657428652C74297B746869732E656C656D656E74732E73657428652C74297D64656C6574652865297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(31650) := '6869732E656C656D656E74732E64656C6574652865297D7D636C61737320246E657B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E69643D2B2B486E652C746869732E747970653D312C746869732E61637475616C3D65';
wwv_flow_imp.g_varchar2_table(31651) := '2C746869732E6C6162656C3D652E6C6162656C2C746869732E636F6E6669726D4265666F7265556E646F3D652E636F6E6669726D4265666F7265556E646F7C7C21312C746869732E7265736F757263654C6162656C733D742C746869732E737472526573';
wwv_flow_imp.g_varchar2_table(31652) := '6F75726365733D6E2C746869732E67726F757049643D692C746869732E67726F75704F726465723D6F2C746869732E736F7572636549643D732C746869732E736F757263654F726465723D722C746869732E72656D6F7665645265736F75726365733D6E';
wwv_flow_imp.g_varchar2_table(31653) := '756C6C2C746869732E696E76616C6964617465645265736F75726365733D6E756C6C7D63616E53706C697428297B72657475726E2266756E6374696F6E223D3D747970656F6620746869732E61637475616C2E73706C69747D72656D6F76655265736F75';
wwv_flow_imp.g_varchar2_table(31654) := '72636528652C742C6E297B746869732E72656D6F7665645265736F75726365737C7C28746869732E72656D6F7665645265736F75726365733D6E657720716E65292C746869732E72656D6F7665645265736F75726365732E6861732874297C7C74686973';
wwv_flow_imp.g_varchar2_table(31655) := '2E72656D6F7665645265736F75726365732E73657428742C6E6577206A6E6528652C6E29297D73657456616C696428652C742C6E297B6E3F746869732E696E76616C6964617465645265736F7572636573262628746869732E696E76616C696461746564';
wwv_flow_imp.g_varchar2_table(31656) := '5265736F75726365732E64656C6574652874292C303D3D3D746869732E696E76616C6964617465645265736F75726365732E73697A65262628746869732E696E76616C6964617465645265736F75726365733D6E756C6C29293A28746869732E696E7661';
wwv_flow_imp.g_varchar2_table(31657) := '6C6964617465645265736F75726365737C7C28746869732E696E76616C6964617465645265736F75726365733D6E657720716E65292C746869732E696E76616C6964617465645265736F75726365732E6861732874297C7C746869732E696E76616C6964';
wwv_flow_imp.g_varchar2_table(31658) := '617465645265736F75726365732E73657428742C6E6577206A6E6528652C302929297D746F537472696E6728297B72657475726E605B69643A247B746869732E69647D5D205B67726F75703A247B746869732E67726F757049647D5D205B247B74686973';
wwv_flow_imp.g_varchar2_table(31659) := '2E696E76616C6964617465645265736F75726365733F22494E56414C4944223A22202056414C4944227D5D20247B746869732E61637475616C2E636F6E7374727563746F722E6E616D657D202D20247B746869732E61637475616C7D607D7D636C617373';
wwv_flow_imp.g_varchar2_table(31660) := '20556E657B636F6E7374727563746F7228652C74297B746869732E7265736F757263654C6162656C3D652C746869732E7374725265736F757263653D742C746869732E5F706173743D5B5D2C746869732E5F6675747572653D5B5D2C746869732E6C6F63';
wwv_flow_imp.g_varchar2_table(31661) := '6B65643D21312C746869732E76657273696F6E49643D317D646973706F736528297B666F7228636F6E73742065206F6620746869732E5F7061737429313D3D3D652E747970652626652E72656D6F76655265736F7572636528746869732E7265736F7572';
wwv_flow_imp.g_varchar2_table(31662) := '63654C6162656C2C746869732E7374725265736F757263652C30293B666F7228636F6E73742065206F6620746869732E5F66757475726529313D3D3D652E747970652626652E72656D6F76655265736F7572636528746869732E7265736F757263654C61';
wwv_flow_imp.g_varchar2_table(31663) := '62656C2C746869732E7374725265736F757263652C30293B746869732E76657273696F6E49642B2B7D746F537472696E6728297B636F6E737420653D5B5D3B652E7075736828602A20247B746869732E7374725265736F757263657D3A60293B666F7228';
wwv_flow_imp.g_varchar2_table(31664) := '6C657420743D303B743C746869732E5F706173742E6C656E6774683B742B2B29652E7075736828602020202A205B554E444F5D20247B746869732E5F706173745B745D7D60293B666F72286C657420743D746869732E5F6675747572652E6C656E677468';
wwv_flow_imp.g_varchar2_table(31665) := '2D313B743E3D303B742D2D29652E7075736828602020202A205B5245444F5D20247B746869732E5F6675747572655B745D7D60293B72657475726E20652E6A6F696E28225C6E22297D666C757368416C6C456C656D656E747328297B746869732E5F7061';
wwv_flow_imp.g_varchar2_table(31666) := '73743D5B5D2C746869732E5F6675747572653D5B5D2C746869732E76657273696F6E49642B2B7D5F736574456C656D656E7456616C6964466C616728652C74297B313D3D3D652E747970653F652E73657456616C696428746869732E7265736F75726365';
wwv_flow_imp.g_varchar2_table(31667) := '4C6162656C2C746869732E7374725265736F757263652C74293A652E73657456616C69642874297D736574456C656D656E747356616C6964466C616728652C74297B666F7228636F6E7374206E206F6620746869732E5F706173742974286E2E61637475';
wwv_flow_imp.g_varchar2_table(31668) := '616C292626746869732E5F736574456C656D656E7456616C6964466C6167286E2C65293B666F7228636F6E7374206E206F6620746869732E5F6675747572652974286E2E61637475616C292626746869732E5F736574456C656D656E7456616C6964466C';
wwv_flow_imp.g_varchar2_table(31669) := '6167286E2C65297D70757368456C656D656E742865297B666F7228636F6E73742065206F6620746869732E5F66757475726529313D3D3D652E747970652626652E72656D6F76655265736F7572636528746869732E7265736F757263654C6162656C2C74';
wwv_flow_imp.g_varchar2_table(31670) := '6869732E7374725265736F757263652C31293B746869732E5F6675747572653D5B5D2C746869732E5F706173742E707573682865292C746869732E76657273696F6E49642B2B7D637265617465536E617073686F742865297B636F6E737420743D5B5D3B';
wwv_flow_imp.g_varchar2_table(31671) := '666F72286C657420653D302C6E3D746869732E5F706173742E6C656E6774683B653C6E3B652B2B29742E7075736828746869732E5F706173745B655D2E6964293B666F72286C657420653D746869732E5F6675747572652E6C656E6774682D313B653E3D';
wwv_flow_imp.g_varchar2_table(31672) := '303B652D2D29742E7075736828746869732E5F6675747572655B655D2E6964293B72657475726E206E657720664328652C74297D726573746F7265536E617073686F742865297B636F6E737420743D652E656C656D656E74732E6C656E6774683B6C6574';
wwv_flow_imp.g_varchar2_table(31673) := '206E3D21302C693D302C6F3D2D313B666F72286C657420733D302C723D746869732E5F706173742E6C656E6774683B733C723B732B2B2C692B2B297B636F6E737420723D746869732E5F706173745B735D3B6E262628693E3D747C7C722E6964213D3D65';
wwv_flow_imp.g_varchar2_table(31674) := '2E656C656D656E74735B695D292626286E3D21312C6F3D30292C6E7C7C31213D3D722E747970657C7C722E72656D6F76655265736F7572636528746869732E7265736F757263654C6162656C2C746869732E7374725265736F757263652C30297D6C6574';
wwv_flow_imp.g_varchar2_table(31675) := '20733D2D313B666F72286C6574206F3D746869732E5F6675747572652E6C656E6774682D313B6F3E3D303B6F2D2D2C692B2B297B636F6E737420723D746869732E5F6675747572655B6F5D3B6E262628693E3D747C7C722E6964213D3D652E656C656D65';
wwv_flow_imp.g_varchar2_table(31676) := '6E74735B695D292626286E3D21312C733D6F292C6E7C7C31213D3D722E747970657C7C722E72656D6F76655265736F7572636528746869732E7265736F757263654C6162656C2C746869732E7374725265736F757263652C30297D2D31213D3D6F262628';
wwv_flow_imp.g_varchar2_table(31677) := '746869732E5F706173743D746869732E5F706173742E736C69636528302C6F29292C2D31213D3D73262628746869732E5F6675747572653D746869732E5F6675747572652E736C69636528732B3129292C746869732E76657273696F6E49642B2B7D6765';
wwv_flow_imp.g_varchar2_table(31678) := '74456C656D656E747328297B636F6E737420653D5B5D2C743D5B5D3B666F7228636F6E73742074206F6620746869732E5F7061737429652E7075736828742E61637475616C293B666F7228636F6E73742065206F6620746869732E5F6675747572652974';
wwv_flow_imp.g_varchar2_table(31679) := '2E7075736828652E61637475616C293B72657475726E7B706173743A652C6675747572653A747D7D676574436C6F7365737450617374456C656D656E7428297B72657475726E20303D3D3D746869732E5F706173742E6C656E6774683F6E756C6C3A7468';
wwv_flow_imp.g_varchar2_table(31680) := '69732E5F706173745B746869732E5F706173742E6C656E6774682D315D7D6765745365636F6E64436C6F7365737450617374456C656D656E7428297B72657475726E20746869732E5F706173742E6C656E6774683C323F6E756C6C3A746869732E5F7061';
wwv_flow_imp.g_varchar2_table(31681) := '73745B746869732E5F706173742E6C656E6774682D325D7D676574436C6F73657374467574757265456C656D656E7428297B72657475726E20303D3D3D746869732E5F6675747572652E6C656E6774683F6E756C6C3A746869732E5F6675747572655B74';
wwv_flow_imp.g_varchar2_table(31682) := '6869732E5F6675747572652E6C656E6774682D315D7D68617350617374456C656D656E747328297B72657475726E20746869732E5F706173742E6C656E6774683E307D686173467574757265456C656D656E747328297B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(31683) := '6675747572652E6C656E6774683E307D73706C697450617374576F726B7370616365456C656D656E7428652C74297B666F72286C6574206E3D746869732E5F706173742E6C656E6774682D313B6E3E3D303B6E2D2D29696628746869732E5F706173745B';
wwv_flow_imp.g_varchar2_table(31684) := '6E5D3D3D3D65297B742E68617328746869732E7374725265736F75726365293F746869732E5F706173745B6E5D3D742E67657428746869732E7374725265736F75726365293A746869732E5F706173742E73706C696365286E2C31293B627265616B7D74';
wwv_flow_imp.g_varchar2_table(31685) := '6869732E76657273696F6E49642B2B7D73706C6974467574757265576F726B7370616365456C656D656E7428652C74297B666F72286C6574206E3D746869732E5F6675747572652E6C656E6774682D313B6E3E3D303B6E2D2D29696628746869732E5F66';
wwv_flow_imp.g_varchar2_table(31686) := '75747572655B6E5D3D3D3D65297B742E68617328746869732E7374725265736F75726365293F746869732E5F6675747572655B6E5D3D742E67657428746869732E7374725265736F75726365293A746869732E5F6675747572652E73706C696365286E2C';
wwv_flow_imp.g_varchar2_table(31687) := '31293B627265616B7D746869732E76657273696F6E49642B2B7D6D6F76654261636B776172642865297B746869732E5F706173742E706F7028292C746869732E5F6675747572652E707573682865292C746869732E76657273696F6E49642B2B7D6D6F76';
wwv_flow_imp.g_varchar2_table(31688) := '65466F72776172642865297B746869732E5F6675747572652E706F7028292C746869732E5F706173742E707573682865292C746869732E76657273696F6E49642B2B7D7D636C617373204B6E657B636F6E7374727563746F722865297B746869732E6564';
wwv_flow_imp.g_varchar2_table(31689) := '6974537461636B733D652C746869732E5F76657273696F6E4964733D5B5D3B666F72286C657420653D302C743D746869732E65646974537461636B732E6C656E6774683B653C743B652B2B29746869732E5F76657273696F6E4964735B655D3D74686973';
wwv_flow_imp.g_varchar2_table(31690) := '2E65646974537461636B735B655D2E76657273696F6E49647D697356616C696428297B666F72286C657420653D302C743D746869732E65646974537461636B732E6C656E6774683B653C743B652B2B29696628746869732E5F76657273696F6E4964735B';
wwv_flow_imp.g_varchar2_table(31691) := '655D213D3D746869732E65646974537461636B735B655D2E76657273696F6E49642972657475726E21313B72657475726E21307D7D636F6E737420476E653D6E657720556E652822222C2222293B476E652E6C6F636B65643D21303B6C657420516E653D';
wwv_flow_imp.g_varchar2_table(31692) := '636C6173737B636F6E7374727563746F7228652C74297B746869732E5F6469616C6F67536572766963653D652C746869732E5F6E6F74696669636174696F6E536572766963653D742C746869732E5F65646974537461636B733D6E6577204D61702C7468';
wwv_flow_imp.g_varchar2_table(31693) := '69732E5F757269436F6D70617269736F6E4B6579436F6D7075746572733D5B5D7D676574557269436F6D70617269736F6E4B65792865297B666F7228636F6E73742074206F6620746869732E5F757269436F6D70617269736F6E4B6579436F6D70757465';
wwv_flow_imp.g_varchar2_table(31694) := '727329696628745B305D3D3D3D652E736368656D652972657475726E20745B315D2E676574436F6D70617269736F6E4B65792865293B72657475726E20652E746F537472696E6728297D5F7072696E742865297B636F6E736F6C652E6C6F6728222D2D2D';
wwv_flow_imp.g_varchar2_table(31695) := '2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D22292C636F6E736F6C652E6C6F672860414654455220247B657D3A2060293B636F6E737420743D5B5D3B666F7228636F6E73742065206F6620746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(31696) := '537461636B7329742E7075736828655B315D2E746F537472696E672829293B636F6E736F6C652E6C6F6728742E6A6F696E28225C6E2229297D70757368456C656D656E7428652C743D76432E4E6F6E652C6E3D62432E4E6F6E65297B696628303D3D3D65';
wwv_flow_imp.g_varchar2_table(31697) := '2E74797065297B636F6E737420693D7A6E6528652E7265736F75726365292C6F3D746869732E676574557269436F6D70617269736F6E4B657928652E7265736F75726365293B746869732E5F70757368456C656D656E74286E657720576E6528652C692C';
wwv_flow_imp.g_varchar2_table(31698) := '6F2C742E69642C742E6E6578744F7264657228292C6E2E69642C6E2E6E6578744F72646572282929297D656C73657B636F6E737420693D6E6577205365742C6F3D5B5D2C733D5B5D3B666F7228636F6E73742074206F6620652E7265736F757263657329';
wwv_flow_imp.g_varchar2_table(31699) := '7B636F6E737420653D7A6E652874292C6E3D746869732E676574557269436F6D70617269736F6E4B65792874293B692E686173286E297C7C28692E616464286E292C6F2E707573682865292C732E70757368286E29297D313D3D3D6F2E6C656E6774683F';
wwv_flow_imp.g_varchar2_table(31700) := '746869732E5F70757368456C656D656E74286E657720576E6528652C6F5B305D2C735B305D2C742E69642C742E6E6578744F7264657228292C6E2E69642C6E2E6E6578744F72646572282929293A746869732E5F70757368456C656D656E74286E657720';
wwv_flow_imp.g_varchar2_table(31701) := '246E6528652C6F2C732C742E69642C742E6E6578744F7264657228292C6E2E69642C6E2E6E6578744F72646572282929297D7D5F70757368456C656D656E742865297B666F72286C657420743D302C6E3D652E7374725265736F75726365732E6C656E67';
wwv_flow_imp.g_varchar2_table(31702) := '74683B743C6E3B742B2B297B636F6E7374206E3D652E7265736F757263654C6162656C735B745D2C693D652E7374725265736F75726365735B745D3B6C6574206F3B746869732E5F65646974537461636B732E6861732869293F6F3D746869732E5F6564';
wwv_flow_imp.g_varchar2_table(31703) := '6974537461636B732E6765742869293A286F3D6E657720556E65286E2C69292C746869732E5F65646974537461636B732E73657428692C6F29292C6F2E70757368456C656D656E742865297D7D6765744C617374456C656D656E742865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(31704) := '20743D746869732E676574557269436F6D70617269736F6E4B65792865293B696628746869732E5F65646974537461636B732E686173287429297B636F6E737420653D746869732E5F65646974537461636B732E6765742874293B696628652E68617346';
wwv_flow_imp.g_varchar2_table(31705) := '7574757265456C656D656E747328292972657475726E206E756C6C3B636F6E7374206E3D652E676574436C6F7365737450617374456C656D656E7428293B72657475726E206E3F6E2E61637475616C3A6E756C6C7D72657475726E206E756C6C7D5F7370';
wwv_flow_imp.g_varchar2_table(31706) := '6C697450617374576F726B7370616365456C656D656E7428652C74297B636F6E7374206E3D652E61637475616C2E73706C697428292C693D6E6577204D61703B666F7228636F6E73742065206F66206E297B636F6E737420743D7A6E6528652E7265736F';
wwv_flow_imp.g_varchar2_table(31707) := '75726365292C6E3D746869732E676574557269436F6D70617269736F6E4B657928652E7265736F75726365292C6F3D6E657720576E6528652C742C6E2C302C302C302C30293B692E736574286F2E7374725265736F757263652C6F297D666F7228636F6E';
wwv_flow_imp.g_varchar2_table(31708) := '7374206E206F6620652E7374725265736F757263657329742626742E686173286E297C7C746869732E5F65646974537461636B732E676574286E292E73706C697450617374576F726B7370616365456C656D656E7428652C69297D5F73706C6974467574';
wwv_flow_imp.g_varchar2_table(31709) := '757265576F726B7370616365456C656D656E7428652C74297B636F6E7374206E3D652E61637475616C2E73706C697428292C693D6E6577204D61703B666F7228636F6E73742065206F66206E297B636F6E737420743D7A6E6528652E7265736F75726365';
wwv_flow_imp.g_varchar2_table(31710) := '292C6E3D746869732E676574557269436F6D70617269736F6E4B657928652E7265736F75726365292C6F3D6E657720576E6528652C742C6E2C302C302C302C30293B692E736574286F2E7374725265736F757263652C6F297D666F7228636F6E7374206E';
wwv_flow_imp.g_varchar2_table(31711) := '206F6620652E7374725265736F757263657329742626742E686173286E297C7C746869732E5F65646974537461636B732E676574286E292E73706C6974467574757265576F726B7370616365456C656D656E7428652C69297D72656D6F7665456C656D65';
wwv_flow_imp.g_varchar2_table(31712) := '6E74732865297B636F6E737420743D22737472696E67223D3D747970656F6620653F653A746869732E676574557269436F6D70617269736F6E4B65792865293B746869732E5F65646974537461636B732E686173287429262628746869732E5F65646974';
wwv_flow_imp.g_varchar2_table(31713) := '537461636B732E6765742874292E646973706F736528292C746869732E5F65646974537461636B732E64656C657465287429297D736574456C656D656E747356616C6964466C616728652C742C6E297B636F6E737420693D746869732E67657455726943';
wwv_flow_imp.g_varchar2_table(31714) := '6F6D70617269736F6E4B65792865293B746869732E5F65646974537461636B732E6861732869292626746869732E5F65646974537461636B732E6765742869292E736574456C656D656E747356616C6964466C616728742C6E297D637265617465536E61';
wwv_flow_imp.g_varchar2_table(31715) := '7073686F742865297B636F6E737420743D746869732E676574557269436F6D70617269736F6E4B65792865293B72657475726E20746869732E5F65646974537461636B732E6861732874293F746869732E5F65646974537461636B732E6765742874292E';
wwv_flow_imp.g_varchar2_table(31716) := '637265617465536E617073686F742865293A6E657720664328652C5B5D297D726573746F7265536E617073686F742865297B636F6E737420743D746869732E676574557269436F6D70617269736F6E4B657928652E7265736F75726365293B6966287468';
wwv_flow_imp.g_varchar2_table(31717) := '69732E5F65646974537461636B732E686173287429297B636F6E7374206E3D746869732E5F65646974537461636B732E6765742874293B6E2E726573746F7265536E617073686F742865292C6E2E68617350617374456C656D656E747328297C7C6E2E68';
wwv_flow_imp.g_varchar2_table(31718) := '6173467574757265456C656D656E747328297C7C286E2E646973706F736528292C746869732E5F65646974537461636B732E64656C657465287429297D7D676574456C656D656E74732865297B636F6E737420743D746869732E676574557269436F6D70';
wwv_flow_imp.g_varchar2_table(31719) := '617269736F6E4B65792865293B72657475726E20746869732E5F65646974537461636B732E6861732874293F746869732E5F65646974537461636B732E6765742874292E676574456C656D656E747328293A7B706173743A5B5D2C6675747572653A5B5D';
wwv_flow_imp.g_varchar2_table(31720) := '7D7D5F66696E64436C6F73657374556E646F456C656D656E7457697468536F757263652865297B69662821652972657475726E5B6E756C6C2C6E756C6C5D3B6C657420743D6E756C6C2C6E3D6E756C6C3B666F7228636F6E73745B692C6F5D6F66207468';
wwv_flow_imp.g_varchar2_table(31721) := '69732E5F65646974537461636B73297B636F6E737420733D6F2E676574436C6F7365737450617374456C656D656E7428293B732626732E736F7572636549643D3D3D6526262821747C7C732E736F757263654F726465723E742E736F757263654F726465';
wwv_flow_imp.g_varchar2_table(31722) := '7229262628743D732C6E3D69297D72657475726E5B742C6E5D7D63616E556E646F2865297B6966286520696E7374616E63656F66206243297B636F6E73745B2C745D3D746869732E5F66696E64436C6F73657374556E646F456C656D656E745769746853';
wwv_flow_imp.g_varchar2_table(31723) := '6F7572636528652E6964293B72657475726E2121747D636F6E737420743D746869732E676574557269436F6D70617269736F6E4B65792865293B72657475726E2121746869732E5F65646974537461636B732E6861732874292626746869732E5F656469';
wwv_flow_imp.g_varchar2_table(31724) := '74537461636B732E6765742874292E68617350617374456C656D656E747328297D5F6F6E4572726F7228652C74297B6B652865293B666F7228636F6E73742065206F6620742E7374725265736F757263657329746869732E72656D6F7665456C656D656E';
wwv_flow_imp.g_varchar2_table(31725) := '74732865293B746869732E5F6E6F74696669636174696F6E536572766963652E6572726F722865297D5F616371756972654C6F636B732865297B666F7228636F6E73742074206F6620652E65646974537461636B7329696628742E6C6F636B6564297468';
wwv_flow_imp.g_varchar2_table(31726) := '726F77206E6577204572726F72282243616E6E6F742061637175697265206564697420737461636B206C6F636B22293B666F7228636F6E73742074206F6620652E65646974537461636B7329742E6C6F636B65643D21303B72657475726E28293D3E7B66';
wwv_flow_imp.g_varchar2_table(31727) := '6F7228636F6E73742074206F6620652E65646974537461636B7329742E6C6F636B65643D21317D7D5F73616665496E766F6B65576974684C6F636B7328652C742C6E2C692C6F297B636F6E737420733D746869732E5F616371756972654C6F636B73286E';
wwv_flow_imp.g_varchar2_table(31728) := '293B6C657420723B7472797B723D7428297D63617463682874297B72657475726E207328292C692E646973706F736528292C746869732E5F6F6E4572726F7228742C65297D72657475726E20723F722E7468656E282828293D3E287328292C692E646973';
wwv_flow_imp.g_varchar2_table(31729) := '706F736528292C6F282929292C28743D3E287328292C692E646973706F736528292C746869732E5F6F6E4572726F7228742C65292929293A287328292C692E646973706F736528292C6F2829297D6173796E63205F696E766F6B65576F726B7370616365';
wwv_flow_imp.g_varchar2_table(31730) := '507265706172652865297B696628766F696420303D3D3D652E61637475616C2E70726570617265556E646F5265646F2972657475726E206C742E4E6F6E653B636F6E737420743D652E61637475616C2E70726570617265556E646F5265646F28293B7265';
wwv_flow_imp.g_varchar2_table(31731) := '7475726E20766F696420303D3D3D743F6C742E4E6F6E653A747D5F696E766F6B655265736F757263655072657061726528652C74297B69662831213D3D652E61637475616C2E747970657C7C766F696420303D3D3D652E61637475616C2E707265706172';
wwv_flow_imp.g_varchar2_table(31732) := '65556E646F5265646F2972657475726E2074286C742E4E6F6E65293B636F6E7374206E3D652E61637475616C2E70726570617265556E646F5265646F28293B72657475726E206E3F6974286E293F74286E293A6E2E7468656E2828653D3E742865292929';
wwv_flow_imp.g_varchar2_table(31733) := '3A74286C742E4E6F6E65297D5F676574416666656374656445646974537461636B732865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620652E7374725265736F757263657329742E7075736828746869732E5F6564697453746163';
wwv_flow_imp.g_varchar2_table(31734) := '6B732E676574286E297C7C476E65293B72657475726E206E6577204B6E652874297D5F747279546F53706C6974416E64556E646F28652C742C6E2C69297B696628742E63616E53706C697428292972657475726E20746869732E5F73706C697450617374';
wwv_flow_imp.g_varchar2_table(31735) := '576F726B7370616365456C656D656E7428742C6E292C746869732E5F6E6F74696669636174696F6E536572766963652E7761726E2869292C6E657720596E6528746869732E5F756E646F28652C302C213029293B666F7228636F6E73742065206F662074';
wwv_flow_imp.g_varchar2_table(31736) := '2E7374725265736F757263657329746869732E72656D6F7665456C656D656E74732865293B72657475726E20746869732E5F6E6F74696669636174696F6E536572766963652E7761726E2869292C6E657720596E657D5F636865636B576F726B73706163';
wwv_flow_imp.g_varchar2_table(31737) := '65556E646F28652C742C6E2C69297B696628742E72656D6F7665645265736F75726365732972657475726E20746869732E5F747279546F53706C6974416E64556E646F28652C742C742E72656D6F7665645265736F75726365732C6228302C22436F756C';
wwv_flow_imp.g_varchar2_table(31738) := '64206E6F7420756E646F20277B307D27206163726F737320616C6C2066696C65732E207B317D222C742E6C6162656C2C742E72656D6F7665645265736F75726365732E6372656174654D657373616765282929293B696628692626742E696E76616C6964';
wwv_flow_imp.g_varchar2_table(31739) := '617465645265736F75726365732972657475726E20746869732E5F747279546F53706C6974416E64556E646F28652C742C742E696E76616C6964617465645265736F75726365732C6228302C22436F756C64206E6F7420756E646F20277B307D27206163';
wwv_flow_imp.g_varchar2_table(31740) := '726F737320616C6C2066696C65732E207B317D222C742E6C6162656C2C742E696E76616C6964617465645265736F75726365732E6372656174654D657373616765282929293B636F6E7374206F3D5B5D3B666F7228636F6E73742065206F66206E2E6564';
wwv_flow_imp.g_varchar2_table(31741) := '6974537461636B7329652E676574436C6F7365737450617374456C656D656E742829213D3D7426266F2E7075736828652E7265736F757263654C6162656C293B6966286F2E6C656E6774683E302972657475726E20746869732E5F747279546F53706C69';
wwv_flow_imp.g_varchar2_table(31742) := '74416E64556E646F28652C742C6E756C6C2C6228302C22436F756C64206E6F7420756E646F20277B307D27206163726F737320616C6C2066696C65732062656361757365206368616E6765732077657265206D61646520746F207B317D222C742E6C6162';
wwv_flow_imp.g_varchar2_table(31743) := '656C2C6F2E6A6F696E28222C20222929293B636F6E737420733D5B5D3B666F7228636F6E73742065206F66206E2E65646974537461636B7329652E6C6F636B65642626732E7075736828652E7265736F757263654C6162656C293B72657475726E20732E';
wwv_flow_imp.g_varchar2_table(31744) := '6C656E6774683E303F746869732E5F747279546F53706C6974416E64556E646F28652C742C6E756C6C2C6228302C22436F756C64206E6F7420756E646F20277B307D27206163726F737320616C6C2066696C657320626563617573652074686572652069';
wwv_flow_imp.g_varchar2_table(31745) := '7320616C726561647920616E20756E646F206F72207265646F206F7065726174696F6E2072756E6E696E67206F6E207B317D222C742E6C6162656C2C732E6A6F696E28222C20222929293A6E2E697356616C696428293F6E756C6C3A746869732E5F7472';
wwv_flow_imp.g_varchar2_table(31746) := '79546F53706C6974416E64556E646F28652C742C6E756C6C2C6228302C22436F756C64206E6F7420756E646F20277B307D27206163726F737320616C6C2066696C6573206265636175736520616E20756E646F206F72207265646F206F7065726174696F';
wwv_flow_imp.g_varchar2_table(31747) := '6E206F6363757272656420696E20746865206D65616E74696D65222C742E6C6162656C29297D5F776F726B7370616365556E646F28652C742C6E297B636F6E737420693D746869732E5F676574416666656374656445646974537461636B732874292C6F';
wwv_flow_imp.g_varchar2_table(31748) := '3D746869732E5F636865636B576F726B7370616365556E646F28652C742C692C2131293B72657475726E206F3F6F2E72657475726E56616C75653A746869732E5F636F6E6669726D416E6445786563757465576F726B7370616365556E646F28652C742C';
wwv_flow_imp.g_varchar2_table(31749) := '692C6E297D5F6973506172744F66556E646F47726F75702865297B69662821652E67726F757049642972657475726E21313B666F7228636F6E73745B2C745D6F6620746869732E5F65646974537461636B73297B636F6E7374206E3D742E676574436C6F';
wwv_flow_imp.g_varchar2_table(31750) := '7365737450617374456C656D656E7428293B6966286E297B6966286E3D3D3D65297B636F6E7374206E3D742E6765745365636F6E64436C6F7365737450617374456C656D656E7428293B6966286E26266E2E67726F757049643D3D3D652E67726F757049';
wwv_flow_imp.g_varchar2_table(31751) := '642972657475726E21307D6966286E2E67726F757049643D3D3D652E67726F757049642972657475726E21307D7D72657475726E21317D6173796E63205F636F6E6669726D416E6445786563757465576F726B7370616365556E646F28652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(31752) := '297B696628742E63616E53706C69742829262621746869732E5F6973506172744F66556E646F47726F7570287429297B6C6574206F3B2166756E6374696F6E2865297B655B652E416C6C3D305D3D22416C6C222C655B652E546869733D315D3D22546869';
wwv_flow_imp.g_varchar2_table(31753) := '73222C655B652E43616E63656C3D325D3D2243616E63656C227D286F7C7C286F3D7B7D29293B636F6E73747B726573756C743A737D3D617761697420746869732E5F6469616C6F67536572766963652E70726F6D7074287B747970653A69442E496E666F';
wwv_flow_imp.g_varchar2_table(31754) := '2C6D6573736167653A6228302C22576F756C6420796F75206C696B6520746F20756E646F20277B307D27206163726F737320616C6C2066696C65733F222C742E6C6162656C292C627574746F6E733A5B7B6C6162656C3A6228302C222626556E646F2069';
wwv_flow_imp.g_varchar2_table(31755) := '6E207B307D2046696C6573222C6E2E65646974537461636B732E6C656E677468292C72756E3A28293D3E6F2E416C6C7D2C7B6C6162656C3A6228302C22556E646F207468697320262646696C6522292C72756E3A28293D3E6F2E546869737D5D2C63616E';
wwv_flow_imp.g_varchar2_table(31756) := '63656C427574746F6E3A7B72756E3A28293D3E6F2E43616E63656C7D7D293B696628733D3D3D6F2E43616E63656C2972657475726E3B696628733D3D3D6F2E546869732972657475726E20746869732E5F73706C697450617374576F726B737061636545';
wwv_flow_imp.g_varchar2_table(31757) := '6C656D656E7428742C6E756C6C292C746869732E5F756E646F28652C302C2130293B636F6E737420723D746869732E5F636865636B576F726B7370616365556E646F28652C742C6E2C2131293B696628722972657475726E20722E72657475726E56616C';
wwv_flow_imp.g_varchar2_table(31758) := '75653B693D21307D6C6574206F3B7472797B6F3D617761697420746869732E5F696E766F6B65576F726B7370616365507265706172652874297D63617463682865297B72657475726E20746869732E5F6F6E4572726F7228652C74297D636F6E73742073';
wwv_flow_imp.g_varchar2_table(31759) := '3D746869732E5F636865636B576F726B7370616365556E646F28652C742C6E2C2130293B696628732972657475726E206F2E646973706F736528292C732E72657475726E56616C75653B666F7228636F6E73742065206F66206E2E65646974537461636B';
wwv_flow_imp.g_varchar2_table(31760) := '7329652E6D6F76654261636B776172642874293B72657475726E20746869732E5F73616665496E766F6B65576974684C6F636B7328742C2828293D3E742E61637475616C2E756E646F2829292C6E2C6F2C2828293D3E746869732E5F636F6E74696E7565';
wwv_flow_imp.g_varchar2_table(31761) := '556E646F496E47726F757028742E67726F757049642C692929297D5F7265736F75726365556E646F28652C742C6E297B696628742E697356616C6964297B69662821652E6C6F636B65642972657475726E20746869732E5F696E766F6B655265736F7572';
wwv_flow_imp.g_varchar2_table(31762) := '63655072657061726528742C28693D3E28652E6D6F76654261636B776172642874292C746869732E5F73616665496E766F6B65576974684C6F636B7328742C2828293D3E742E61637475616C2E756E646F2829292C6E6577204B6E65285B655D292C692C';
wwv_flow_imp.g_varchar2_table(31763) := '2828293D3E746869732E5F636F6E74696E7565556E646F496E47726F757028742E67726F757049642C6E2929292929293B7B636F6E737420653D6228302C22436F756C64206E6F7420756E646F20277B307D272062656361757365207468657265206973';
wwv_flow_imp.g_varchar2_table(31764) := '20616C726561647920616E20756E646F206F72207265646F206F7065726174696F6E2072756E6E696E672E222C742E6C6162656C293B746869732E5F6E6F74696669636174696F6E536572766963652E7761726E2865297D7D656C736520652E666C7573';
wwv_flow_imp.g_varchar2_table(31765) := '68416C6C456C656D656E747328297D5F66696E64436C6F73657374556E646F456C656D656E74496E47726F75702865297B69662821652972657475726E5B6E756C6C2C6E756C6C5D3B6C657420743D6E756C6C2C6E3D6E756C6C3B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(31766) := '5B692C6F5D6F6620746869732E5F65646974537461636B73297B636F6E737420733D6F2E676574436C6F7365737450617374456C656D656E7428293B732626732E67726F757049643D3D3D6526262821747C7C732E67726F75704F726465723E742E6772';
wwv_flow_imp.g_varchar2_table(31767) := '6F75704F7264657229262628743D732C6E3D69297D72657475726E5B742C6E5D7D5F636F6E74696E7565556E646F496E47726F757028652C74297B69662821652972657475726E3B636F6E73745B2C6E5D3D746869732E5F66696E64436C6F7365737455';
wwv_flow_imp.g_varchar2_table(31768) := '6E646F456C656D656E74496E47726F75702865293B72657475726E206E3F746869732E5F756E646F286E2C302C74293A766F696420307D756E646F2865297B6966286520696E7374616E63656F66206243297B636F6E73745B2C745D3D746869732E5F66';
wwv_flow_imp.g_varchar2_table(31769) := '696E64436C6F73657374556E646F456C656D656E7457697468536F7572636528652E6964293B72657475726E20743F746869732E5F756E646F28742C652E69642C2131293A766F696420307D72657475726E22737472696E67223D3D747970656F662065';
wwv_flow_imp.g_varchar2_table(31770) := '3F746869732E5F756E646F28652C302C2131293A746869732E5F756E646F28746869732E676574557269436F6D70617269736F6E4B65792865292C302C2131297D5F756E646F28652C743D302C6E297B69662821746869732E5F65646974537461636B73';
wwv_flow_imp.g_varchar2_table(31771) := '2E6861732865292972657475726E3B636F6E737420693D746869732E5F65646974537461636B732E6765742865292C6F3D692E676574436C6F7365737450617374456C656D656E7428293B6966286F297B6966286F2E67726F75704964297B636F6E7374';
wwv_flow_imp.g_varchar2_table(31772) := '5B652C695D3D746869732E5F66696E64436C6F73657374556E646F456C656D656E74496E47726F7570286F2E67726F75704964293B6966286F213D3D652626692972657475726E20746869732E5F756E646F28692C742C6E297D696628286F2E736F7572';
wwv_flow_imp.g_varchar2_table(31773) := '63654964213D3D747C7C6F2E636F6E6669726D4265666F7265556E646F292626216E2972657475726E20746869732E5F636F6E6669726D416E64436F6E74696E7565556E646F28652C742C6F293B7472797B72657475726E20313D3D3D6F2E747970653F';
wwv_flow_imp.g_varchar2_table(31774) := '746869732E5F776F726B7370616365556E646F28652C6F2C6E293A746869732E5F7265736F75726365556E646F28692C6F2C6E297D66696E616C6C797B7D7D7D6173796E63205F636F6E6669726D416E64436F6E74696E7565556E646F28652C742C6E29';
wwv_flow_imp.g_varchar2_table(31775) := '7B69662828617761697420746869732E5F6469616C6F67536572766963652E636F6E6669726D287B6D6573736167653A6228302C22576F756C6420796F75206C696B6520746F20756E646F20277B307D273F222C6E2E6C6162656C292C7072696D617279';
wwv_flow_imp.g_varchar2_table(31776) := '427574746F6E3A6228302C22262659657322292C63616E63656C427574746F6E3A6228302C224E6F22297D29292E636F6E6669726D65642972657475726E20746869732E5F756E646F28652C742C2130297D5F66696E64436C6F736573745265646F456C';
wwv_flow_imp.g_varchar2_table(31777) := '656D656E7457697468536F757263652865297B69662821652972657475726E5B6E756C6C2C6E756C6C5D3B6C657420743D6E756C6C2C6E3D6E756C6C3B666F7228636F6E73745B692C6F5D6F6620746869732E5F65646974537461636B73297B636F6E73';
wwv_flow_imp.g_varchar2_table(31778) := '7420733D6F2E676574436C6F73657374467574757265456C656D656E7428293B732626732E736F7572636549643D3D3D6526262821747C7C732E736F757263654F726465723C742E736F757263654F7264657229262628743D732C6E3D69297D72657475';
wwv_flow_imp.g_varchar2_table(31779) := '726E5B742C6E5D7D63616E5265646F2865297B6966286520696E7374616E63656F66206243297B636F6E73745B2C745D3D746869732E5F66696E64436C6F736573745265646F456C656D656E7457697468536F7572636528652E6964293B72657475726E';
wwv_flow_imp.g_varchar2_table(31780) := '2121747D636F6E737420743D746869732E676574557269436F6D70617269736F6E4B65792865293B72657475726E2121746869732E5F65646974537461636B732E6861732874292626746869732E5F65646974537461636B732E6765742874292E686173';
wwv_flow_imp.g_varchar2_table(31781) := '467574757265456C656D656E747328297D5F747279546F53706C6974416E645265646F28652C742C6E2C69297B696628742E63616E53706C697428292972657475726E20746869732E5F73706C6974467574757265576F726B7370616365456C656D656E';
wwv_flow_imp.g_varchar2_table(31782) := '7428742C6E292C746869732E5F6E6F74696669636174696F6E536572766963652E7761726E2869292C6E657720596E6528746869732E5F7265646F286529293B666F7228636F6E73742065206F6620742E7374725265736F757263657329746869732E72';
wwv_flow_imp.g_varchar2_table(31783) := '656D6F7665456C656D656E74732865293B72657475726E20746869732E5F6E6F74696669636174696F6E536572766963652E7761726E2869292C6E657720596E657D5F636865636B576F726B73706163655265646F28652C742C6E2C69297B696628742E';
wwv_flow_imp.g_varchar2_table(31784) := '72656D6F7665645265736F75726365732972657475726E20746869732E5F747279546F53706C6974416E645265646F28652C742C742E72656D6F7665645265736F75726365732C6228302C22436F756C64206E6F74207265646F20277B307D2720616372';
wwv_flow_imp.g_varchar2_table(31785) := '6F737320616C6C2066696C65732E207B317D222C742E6C6162656C2C742E72656D6F7665645265736F75726365732E6372656174654D657373616765282929293B696628692626742E696E76616C6964617465645265736F75726365732972657475726E';
wwv_flow_imp.g_varchar2_table(31786) := '20746869732E5F747279546F53706C6974416E645265646F28652C742C742E696E76616C6964617465645265736F75726365732C6228302C22436F756C64206E6F74207265646F20277B307D27206163726F737320616C6C2066696C65732E207B317D22';
wwv_flow_imp.g_varchar2_table(31787) := '2C742E6C6162656C2C742E696E76616C6964617465645265736F75726365732E6372656174654D657373616765282929293B636F6E7374206F3D5B5D3B666F7228636F6E73742065206F66206E2E65646974537461636B7329652E676574436C6F736573';
wwv_flow_imp.g_varchar2_table(31788) := '74467574757265456C656D656E742829213D3D7426266F2E7075736828652E7265736F757263654C6162656C293B6966286F2E6C656E6774683E302972657475726E20746869732E5F747279546F53706C6974416E645265646F28652C742C6E756C6C2C';
wwv_flow_imp.g_varchar2_table(31789) := '6228302C22436F756C64206E6F74207265646F20277B307D27206163726F737320616C6C2066696C65732062656361757365206368616E6765732077657265206D61646520746F207B317D222C742E6C6162656C2C6F2E6A6F696E28222C20222929293B';
wwv_flow_imp.g_varchar2_table(31790) := '636F6E737420733D5B5D3B666F7228636F6E73742065206F66206E2E65646974537461636B7329652E6C6F636B65642626732E7075736828652E7265736F757263654C6162656C293B72657475726E20732E6C656E6774683E303F746869732E5F747279';
wwv_flow_imp.g_varchar2_table(31791) := '546F53706C6974416E645265646F28652C742C6E756C6C2C6228302C22436F756C64206E6F74207265646F20277B307D27206163726F737320616C6C2066696C6573206265636175736520746865726520697320616C726561647920616E20756E646F20';
wwv_flow_imp.g_varchar2_table(31792) := '6F72207265646F206F7065726174696F6E2072756E6E696E67206F6E207B317D222C742E6C6162656C2C732E6A6F696E28222C20222929293A6E2E697356616C696428293F6E756C6C3A746869732E5F747279546F53706C6974416E645265646F28652C';
wwv_flow_imp.g_varchar2_table(31793) := '742C6E756C6C2C6228302C22436F756C64206E6F74207265646F20277B307D27206163726F737320616C6C2066696C6573206265636175736520616E20756E646F206F72207265646F206F7065726174696F6E206F6363757272656420696E2074686520';
wwv_flow_imp.g_varchar2_table(31794) := '6D65616E74696D65222C742E6C6162656C29297D5F776F726B73706163655265646F28652C74297B636F6E7374206E3D746869732E5F676574416666656374656445646974537461636B732874292C693D746869732E5F636865636B576F726B73706163';
wwv_flow_imp.g_varchar2_table(31795) := '655265646F28652C742C6E2C2131293B72657475726E20693F692E72657475726E56616C75653A746869732E5F65786563757465576F726B73706163655265646F28652C742C6E297D6173796E63205F65786563757465576F726B73706163655265646F';
wwv_flow_imp.g_varchar2_table(31796) := '28652C742C6E297B6C657420693B7472797B693D617761697420746869732E5F696E766F6B65576F726B7370616365507265706172652874297D63617463682865297B72657475726E20746869732E5F6F6E4572726F7228652C74297D636F6E7374206F';
wwv_flow_imp.g_varchar2_table(31797) := '3D746869732E5F636865636B576F726B73706163655265646F28652C742C6E2C2130293B6966286F2972657475726E20692E646973706F736528292C6F2E72657475726E56616C75653B666F7228636F6E73742065206F66206E2E65646974537461636B';
wwv_flow_imp.g_varchar2_table(31798) := '7329652E6D6F7665466F72776172642874293B72657475726E20746869732E5F73616665496E766F6B65576974684C6F636B7328742C2828293D3E742E61637475616C2E7265646F2829292C6E2C692C2828293D3E746869732E5F636F6E74696E756552';
wwv_flow_imp.g_varchar2_table(31799) := '65646F496E47726F757028742E67726F757049642929297D5F7265736F757263655265646F28652C74297B696628742E697356616C6964297B69662821652E6C6F636B65642972657475726E20746869732E5F696E766F6B655265736F75726365507265';
wwv_flow_imp.g_varchar2_table(31800) := '7061726528742C286E3D3E28652E6D6F7665466F72776172642874292C746869732E5F73616665496E766F6B65576974684C6F636B7328742C2828293D3E742E61637475616C2E7265646F2829292C6E6577204B6E65285B655D292C6E2C2828293D3E74';
wwv_flow_imp.g_varchar2_table(31801) := '6869732E5F636F6E74696E75655265646F496E47726F757028742E67726F757049642929292929293B7B636F6E737420653D6228302C22436F756C64206E6F74207265646F20277B307D27206265636175736520746865726520697320616C7265616479';
wwv_flow_imp.g_varchar2_table(31802) := '20616E20756E646F206F72207265646F206F7065726174696F6E2072756E6E696E672E222C742E6C6162656C293B746869732E5F6E6F74696669636174696F6E536572766963652E7761726E2865297D7D656C736520652E666C757368416C6C456C656D';
wwv_flow_imp.g_varchar2_table(31803) := '656E747328297D5F66696E64436C6F736573745265646F456C656D656E74496E47726F75702865297B69662821652972657475726E5B6E756C6C2C6E756C6C5D3B6C657420743D6E756C6C2C6E3D6E756C6C3B666F7228636F6E73745B692C6F5D6F6620';
wwv_flow_imp.g_varchar2_table(31804) := '746869732E5F65646974537461636B73297B636F6E737420733D6F2E676574436C6F73657374467574757265456C656D656E7428293B732626732E67726F757049643D3D3D6526262821747C7C732E67726F75704F726465723C742E67726F75704F7264';
wwv_flow_imp.g_varchar2_table(31805) := '657229262628743D732C6E3D69297D72657475726E5B742C6E5D7D5F636F6E74696E75655265646F496E47726F75702865297B69662821652972657475726E3B636F6E73745B2C745D3D746869732E5F66696E64436C6F736573745265646F456C656D65';
wwv_flow_imp.g_varchar2_table(31806) := '6E74496E47726F75702865293B72657475726E20743F746869732E5F7265646F2874293A766F696420307D7265646F2865297B6966286520696E7374616E63656F66206243297B636F6E73745B2C745D3D746869732E5F66696E64436C6F736573745265';
wwv_flow_imp.g_varchar2_table(31807) := '646F456C656D656E7457697468536F7572636528652E6964293B72657475726E20743F746869732E5F7265646F2874293A766F696420307D72657475726E22737472696E67223D3D747970656F6620653F746869732E5F7265646F2865293A746869732E';
wwv_flow_imp.g_varchar2_table(31808) := '5F7265646F28746869732E676574557269436F6D70617269736F6E4B6579286529297D5F7265646F2865297B69662821746869732E5F65646974537461636B732E6861732865292972657475726E3B636F6E737420743D746869732E5F65646974537461';
wwv_flow_imp.g_varchar2_table(31809) := '636B732E6765742865292C6E3D742E676574436C6F73657374467574757265456C656D656E7428293B6966286E297B6966286E2E67726F75704964297B636F6E73745B652C745D3D746869732E5F66696E64436C6F736573745265646F456C656D656E74';
wwv_flow_imp.g_varchar2_table(31810) := '496E47726F7570286E2E67726F75704964293B6966286E213D3D652626742972657475726E20746869732E5F7265646F2874297D7472797B72657475726E20313D3D3D6E2E747970653F746869732E5F776F726B73706163655265646F28652C6E293A74';
wwv_flow_imp.g_varchar2_table(31811) := '6869732E5F7265736F757263655265646F28742C6E297D66696E616C6C797B7D7D7D7D3B516E653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F';
wwv_flow_imp.g_varchar2_table(31812) := '693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E646563';
wwv_flow_imp.g_varchar2_table(31813) := '6F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C';
wwv_flow_imp.g_varchar2_table(31814) := '6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B566E6528302C5837292C566E6528312C7344295D2C516E65293B636C61737320596E65';
wwv_flow_imp.g_varchar2_table(31815) := '7B636F6E7374727563746F722865297B746869732E72657475726E56616C75653D657D7D7870286D432C516E652C31293B766172205A6E653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C6529';
wwv_flow_imp.g_varchar2_table(31816) := '7D7D3B6C657420586E653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F7468656D65536572766963653D652C746869732E5F6C6F67536572766963653D742C746869732E';
wwv_flow_imp.g_varchar2_table(31817) := '5F6C616E6775616765536572766963653D6E2C746869732E5F6361636865733D6E6577205765616B4D61702C746869732E5F726567697374657228746869732E5F7468656D65536572766963652E6F6E446964436F6C6F725468656D654368616E676528';
wwv_flow_imp.g_varchar2_table(31818) := '2828293D3E7B746869732E5F6361636865733D6E6577205765616B4D61707D2929297D6765745374796C696E672865297B72657475726E20746869732E5F6361636865732E6861732865297C7C746869732E5F6361636865732E73657428652C6E657720';
wwv_flow_imp.g_varchar2_table(31819) := '743928652E6765744C6567656E6428292C746869732E5F7468656D65536572766963652C746869732E5F6C616E6775616765536572766963652C746869732E5F6C6F675365727669636529292C746869732E5F6361636865732E6765742865297D7D3B66';
wwv_flow_imp.g_varchar2_table(31820) := '756E6374696F6E204A6E652865297B72657475726E22737472696E6722213D747970656F66206526262841727261792E697341727261792865293F652E6576657279284A6E65293A2121652E6578636C7573697665297D586E653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(31821) := '652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A65';
wwv_flow_imp.g_varchar2_table(31822) := '6374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D';
wwv_flow_imp.g_varchar2_table(31823) := '652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F70';
wwv_flow_imp.g_varchar2_table(31824) := '6572747928742C6E2C72292C727D285B5A6E6528302C5062292C5A6E6528312C5264292C5A6E6528322C4C75295D2C586E65292C78702867392C586E652C31293B636C617373206569657B636F6E7374727563746F7228652C742C6E2C69297B74686973';
wwv_flow_imp.g_varchar2_table(31825) := '2E7572693D652C746869732E6C616E677561676549643D742C746869732E6E6F7465626F6F6B5572693D6E2C746869732E6E6F7465626F6F6B547970653D697D657175616C732865297B76617220742C6E3B72657475726E20746869732E6E6F7465626F';
wwv_flow_imp.g_varchar2_table(31826) := '6F6B547970653D3D3D652E6E6F7465626F6F6B547970652626746869732E6C616E677561676549643D3D3D652E6C616E677561676549642626746869732E7572692E746F537472696E6728293D3D3D652E7572692E746F537472696E6728292626286E75';
wwv_flow_imp.g_varchar2_table(31827) := '6C6C3D3D3D28743D746869732E6E6F7465626F6F6B557269297C7C766F696420303D3D3D743F766F696420303A742E746F537472696E672829293D3D3D286E756C6C3D3D3D286E3D652E6E6F7465626F6F6B557269297C7C766F696420303D3D3D6E3F76';
wwv_flow_imp.g_varchar2_table(31828) := '6F696420303A6E2E746F537472696E672829297D7D636C617373207469657B636F6E7374727563746F722865297B746869732E5F6E6F7465626F6F6B496E666F5265736F6C7665723D652C746869732E5F636C6F636B3D302C746869732E5F656E747269';
wwv_flow_imp.g_varchar2_table(31829) := '65733D5B5D2C746869732E5F6F6E4469644368616E67653D6E65772043742C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E747D726567697374657228652C74297B6C6574206E3D7B73656C6563746F';
wwv_flow_imp.g_varchar2_table(31830) := '723A652C70726F76696465723A742C5F73636F72653A2D312C5F74696D653A746869732E5F636C6F636B2B2B7D3B72657475726E20746869732E5F656E74726965732E70757368286E292C746869732E5F6C61737443616E6469646174653D766F696420';
wwv_flow_imp.g_varchar2_table(31831) := '302C746869732E5F6F6E4469644368616E67652E6669726528746869732E5F656E74726965732E6C656E677468292C7274282828293D3E7B6966286E297B636F6E737420653D746869732E5F656E74726965732E696E6465784F66286E293B653E3D3026';
wwv_flow_imp.g_varchar2_table(31832) := '2628746869732E5F656E74726965732E73706C69636528652C31292C746869732E5F6C61737443616E6469646174653D766F696420302C746869732E5F6F6E4469644368616E67652E6669726528746869732E5F656E74726965732E6C656E677468292C';
wwv_flow_imp.g_varchar2_table(31833) := '6E3D766F69642030297D7D29297D6861732865297B72657475726E20746869732E616C6C2865292E6C656E6774683E307D616C6C2865297B69662821652972657475726E5B5D3B746869732E5F75706461746553636F7265732865293B636F6E73742074';
wwv_flow_imp.g_varchar2_table(31834) := '3D5B5D3B666F7228636F6E73742065206F6620746869732E5F656E747269657329652E5F73636F72653E302626742E7075736828652E70726F7669646572293B72657475726E20747D6F7264657265642865297B636F6E737420743D5B5D3B7265747572';
wwv_flow_imp.g_varchar2_table(31835) := '6E20746869732E5F6F726465726564466F724561636828652C28653D3E742E7075736828652E70726F76696465722929292C747D6F72646572656447726F7570732865297B636F6E737420743D5B5D3B6C6574206E2C693B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(31836) := '5F6F726465726564466F724561636828652C28653D3E7B6E2626693D3D3D652E5F73636F72653F6E2E7075736828652E70726F7669646572293A28693D652E5F73636F72652C6E3D5B652E70726F76696465725D2C742E70757368286E29297D29292C74';
wwv_flow_imp.g_varchar2_table(31837) := '7D5F6F726465726564466F724561636828652C74297B746869732E5F75706461746553636F7265732865293B666F7228636F6E73742065206F6620746869732E5F656E747269657329652E5F73636F72653E302626742865297D5F75706461746553636F';
wwv_flow_imp.g_varchar2_table(31838) := '7265732865297B76617220742C6E3B636F6E737420693D6E756C6C3D3D3D28743D746869732E5F6E6F7465626F6F6B496E666F5265736F6C766572297C7C766F696420303D3D3D743F766F696420303A742E63616C6C28746869732C652E757269292C6F';
wwv_flow_imp.g_varchar2_table(31839) := '3D693F6E65772065696528652E7572692C652E6765744C616E6775616765496428292C692E7572692C692E74797065293A6E65772065696528652E7572692C652E6765744C616E6775616765496428292C766F696420302C766F69642030293B69662821';
wwv_flow_imp.g_varchar2_table(31840) := '286E756C6C3D3D3D286E3D746869732E5F6C61737443616E646964617465297C7C766F696420303D3D3D6E3F766F696420303A6E2E657175616C73286F2929297B746869732E5F6C61737443616E6469646174653D6F3B666F7228636F6E73742074206F';
wwv_flow_imp.g_varchar2_table(31841) := '6620746869732E5F656E747269657329696628742E5F73636F72653D56746528742E73656C6563746F722C6F2E7572692C6F2E6C616E677561676549642C41682865292C6F2E6E6F7465626F6F6B5572692C6F2E6E6F7465626F6F6B54797065292C4A6E';
wwv_flow_imp.g_varchar2_table(31842) := '6528742E73656C6563746F72292626742E5F73636F72653E30297B666F7228636F6E73742065206F6620746869732E5F656E747269657329652E5F73636F72653D303B742E5F73636F72653D3165333B627265616B7D746869732E5F656E74726965732E';
wwv_flow_imp.g_varchar2_table(31843) := '736F7274287469652E5F636F6D70617265427953636F7265416E6454696D65297D7D737461746963205F636F6D70617265427953636F7265416E6454696D6528652C74297B72657475726E20652E5F73636F72653C742E5F73636F72653F313A652E5F73';
wwv_flow_imp.g_varchar2_table(31844) := '636F72653E742E5F73636F72653F2D313A6E696528652E73656C6563746F72292626216E696528742E73656C6563746F72293F313A216E696528652E73656C6563746F722926266E696528742E73656C6563746F72293F2D313A652E5F74696D653C742E';
wwv_flow_imp.g_varchar2_table(31845) := '5F74696D653F313A652E5F74696D653E742E5F74696D653F2D313A307D7D66756E6374696F6E206E69652865297B72657475726E22737472696E6722213D747970656F66206526262841727261792E697341727261792865293F652E736F6D65286E6965';
wwv_flow_imp.g_varchar2_table(31846) := '293A426F6F6C65616E28652E69734275696C74696E29297D78702878782C636C6173737B636F6E7374727563746F7228297B746869732E7265666572656E636550726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468';
wwv_flow_imp.g_varchar2_table(31847) := '697329292C746869732E72656E616D6550726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E6E657753796D626F6C4E616D657350726F76696465723D6E65772074696528746869732E5F73';
wwv_flow_imp.g_varchar2_table(31848) := '636F72652E62696E64287468697329292C746869732E636F6465416374696F6E50726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E646566696E6974696F6E50726F76696465723D6E6577';
wwv_flow_imp.g_varchar2_table(31849) := '2074696528746869732E5F73636F72652E62696E64287468697329292C746869732E74797065446566696E6974696F6E50726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E6465636C6172';
wwv_flow_imp.g_varchar2_table(31850) := '6174696F6E50726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E696D706C656D656E746174696F6E50726F76696465723D6E65772074696528746869732E5F73636F72652E62696E642874';
wwv_flow_imp.g_varchar2_table(31851) := '68697329292C746869732E646F63756D656E7453796D626F6C50726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E696E6C617948696E747350726F76696465723D6E657720746965287468';
wwv_flow_imp.g_varchar2_table(31852) := '69732E5F73636F72652E62696E64287468697329292C746869732E636F6C6F7250726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E636F64654C656E7350726F76696465723D6E65772074';
wwv_flow_imp.g_varchar2_table(31853) := '696528746869732E5F73636F72652E62696E64287468697329292C746869732E646F63756D656E74466F726D617474696E674564697450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E';
wwv_flow_imp.g_varchar2_table(31854) := '646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E6F6E54797065466F726D617474696E674564697450726F76696465';
wwv_flow_imp.g_varchar2_table(31855) := '723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E7369676E617475726548656C7050726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E686F';
wwv_flow_imp.g_varchar2_table(31856) := '76657250726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E646F63756D656E74486967686C6967687450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E6428';
wwv_flow_imp.g_varchar2_table(31857) := '7468697329292C746869732E6D756C7469446F63756D656E74486967686C6967687450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E73656C656374696F6E52616E676550726F766964';
wwv_flow_imp.g_varchar2_table(31858) := '65723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E666F6C64696E6752616E676550726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E6C69';
wwv_flow_imp.g_varchar2_table(31859) := '6E6B50726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E696E6C696E65436F6D706C6574696F6E7350726F76696465723D6E65772074696528746869732E5F73636F72652E62696E642874';
wwv_flow_imp.g_varchar2_table(31860) := '68697329292C746869732E696E6C696E654564697450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E636F6D706C6574696F6E50726F76696465723D6E65772074696528746869732E5F';
wwv_flow_imp.g_varchar2_table(31861) := '73636F72652E62696E64287468697329292C746869732E6C696E6B656445646974696E6752616E676550726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E646F63756D656E7452616E6765';
wwv_flow_imp.g_varchar2_table(31862) := '53656D616E746963546F6B656E7350726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E646F63756D656E7453656D616E746963546F6B656E7350726F76696465723D6E6577207469652874';
wwv_flow_imp.g_varchar2_table(31863) := '6869732E5F73636F72652E62696E64287468697329292C746869732E646F63756D656E7444726F704564697450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329292C746869732E646F63756D656E745061';
wwv_flow_imp.g_varchar2_table(31864) := '7374654564697450726F76696465723D6E65772074696528746869732E5F73636F72652E62696E64287468697329297D5F73636F72652865297B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E5F6E6F7465626F6F6B5479706552';
wwv_flow_imp.g_varchar2_table(31865) := '65736F6C766572297C7C766F696420303D3D3D743F766F696420303A742E63616C6C28746869732C65297D7D2C31293B766172206969653D6E2833333737292C6F69653D7B7D3B6F69652E7374796C655461675472616E73666F726D3D6A7228292C6F69';
wwv_flow_imp.g_varchar2_table(31866) := '652E736574417474726962757465733D567228292C6F69652E696E736572743D467228292E62696E64286E756C6C2C226865616422292C6F69652E646F6D4150493D4F7228292C6F69652E696E736572745374796C65456C656D656E743D487228292C4E';
wwv_flow_imp.g_varchar2_table(31867) := '722829286969652E412C6F6965292C6969652E4126266969652E412E6C6F63616C7326266969652E412E6C6F63616C733B766172207369653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C6529';
wwv_flow_imp.g_varchar2_table(31868) := '7D7D3B636F6E7374207269653D62723B6C6574206169653D636C61737320657874656E64732047447B676574205F74617267657457696E646F7728297B72657475726E20727328746869732E5F7461726765742E746172676574456C656D656E74735B30';
wwv_flow_imp.g_varchar2_table(31869) := '5D297D676574205F746172676574446F63756D656E74456C656D656E7428297B72657475726E20727328746869732E5F7461726765742E746172676574456C656D656E74735B305D292E646F63756D656E742E646F63756D656E74456C656D656E747D67';
wwv_flow_imp.g_varchar2_table(31870) := '6574206973446973706F73656428297B72657475726E20746869732E5F6973446973706F7365647D6765742069734D6F757365496E28297B72657475726E20746869732E5F6C6F636B4D6F757365547261636B65722E69734D6F757365496E7D67657420';
wwv_flow_imp.g_varchar2_table(31871) := '646F6D4E6F646528297B72657475726E20746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64657D676574206F6E446973706F736528297B72657475726E20746869732E5F6F6E446973706F73652E6576656E747D676574206F6E526571';
wwv_flow_imp.g_varchar2_table(31872) := '756573744C61796F757428297B72657475726E20746869732E5F6F6E526571756573744C61796F75742E6576656E747D67657420616E63686F7228297B72657475726E20323D3D3D746869732E5F686F766572506F736974696F6E3F303A317D67657420';
wwv_flow_imp.g_varchar2_table(31873) := '7828297B72657475726E20746869732E5F787D676574207928297B72657475726E20746869732E5F797D6765742069734C6F636B656428297B72657475726E20746869732E5F69734C6F636B65647D7365742069734C6F636B65642865297B746869732E';
wwv_flow_imp.g_varchar2_table(31874) := '5F69734C6F636B6564213D3D65262628746869732E5F69734C6F636B65643D652C746869732E5F686F766572436F6E7461696E65722E636C6173734C6973742E746F67676C6528226C6F636B6564222C746869732E5F69734C6F636B656429297D636F6E';
wwv_flow_imp.g_varchar2_table(31875) := '7374727563746F7228652C742C6E2C692C6F2C73297B76617220722C612C6C2C632C642C682C752C703B737570657228292C746869732E5F6B657962696E64696E67536572766963653D742C746869732E5F636F6E66696775726174696F6E5365727669';
wwv_flow_imp.g_varchar2_table(31876) := '63653D6E2C746869732E5F6F70656E6572536572766963653D692C746869732E5F696E7374616E74696174696F6E536572766963653D6F2C746869732E5F6163636573736962696C697479536572766963653D732C746869732E5F6D6573736167654C69';
wwv_flow_imp.g_varchar2_table(31877) := '7374656E6572733D6E65772061742C746869732E5F6973446973706F7365643D21312C746869732E5F666F726365506F736974696F6E3D21312C746869732E5F783D302C746869732E5F793D302C746869732E5F69734C6F636B65643D21312C74686973';
wwv_flow_imp.g_varchar2_table(31878) := '2E5F656E61626C65466F63757354726170733D21312C746869732E5F6164646564466F637573547261703D21312C746869732E5F6F6E446973706F73653D746869732E5F7265676973746572286E6577204374292C746869732E5F6F6E52657175657374';
wwv_flow_imp.g_varchar2_table(31879) := '4C61796F75743D746869732E5F7265676973746572286E6577204374292C746869732E5F6C696E6B48616E646C65723D652E6C696E6B48616E646C65727C7C28743D3E674528746869732E5F6F70656E6572536572766963652C742C726328652E636F6E';
wwv_flow_imp.g_varchar2_table(31880) := '74656E74293F652E636F6E74656E742E6973547275737465643A766F6964203029292C746869732E5F7461726765743D22746172676574456C656D656E747322696E20652E7461726765743F652E7461726765743A6E65772063696528652E7461726765';
wwv_flow_imp.g_varchar2_table(31881) := '74292C746869732E5F686F766572506F696E7465723D286E756C6C3D3D3D28723D652E617070656172616E6365297C7C766F696420303D3D3D723F766F696420303A722E73686F77506F696E746572293F72696528226469762E776F726B62656E63682D';
wwv_flow_imp.g_varchar2_table(31882) := '686F7665722D706F696E74657222293A766F696420302C746869732E5F686F7665723D746869732E5F7265676973746572286E6577206D71292C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E616464';
wwv_flow_imp.g_varchar2_table(31883) := '2822776F726B62656E63682D686F766572222C2266616465496E22292C286E756C6C3D3D3D28613D652E617070656172616E6365297C7C766F696420303D3D3D613F766F696420303A612E636F6D70616374292626746869732E5F686F7665722E636F6E';
wwv_flow_imp.g_varchar2_table(31884) := '7461696E6572446F6D4E6F64652E636C6173734C6973742E6164642822776F726B62656E63682D686F766572222C22636F6D7061637422292C286E756C6C3D3D3D286C3D652E617070656172616E6365297C7C766F696420303D3D3D6C3F766F69642030';
wwv_flow_imp.g_varchar2_table(31885) := '3A6C2E736B697046616465496E416E696D6174696F6E292626746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E6164642822736B69702D666164652D696E22292C652E6164646974696F6E616C436C6173';
wwv_flow_imp.g_varchar2_table(31886) := '7365732626746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E616464282E2E2E652E6164646974696F6E616C436C6173736573292C286E756C6C3D3D3D28633D652E706F736974696F6E297C7C766F6964';
wwv_flow_imp.g_varchar2_table(31887) := '20303D3D3D633F766F696420303A632E666F726365506F736974696F6E29262628746869732E5F666F726365506F736974696F6E3D2130292C652E74726170466F637573262628746869732E5F656E61626C65466F63757354726170733D2130292C7468';
wwv_flow_imp.g_varchar2_table(31888) := '69732E5F686F766572506F736974696F6E3D6E756C6C213D3D28683D6E756C6C3D3D3D28643D652E706F736974696F6E297C7C766F696420303D3D3D643F766F696420303A642E686F766572506F736974696F6E292626766F69642030213D3D683F683A';
wwv_flow_imp.g_varchar2_table(31889) := '332C746869732E6F6E6D6F757365646F776E28746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652C28653D3E652E73746F7050726F7061676174696F6E282929292C746869732E6F6E6B6579646F776E28746869732E5F686F766572';
wwv_flow_imp.g_varchar2_table(31890) := '2E636F6E7461696E6572446F6D4E6F64652C28653D3E7B652E657175616C732839292626746869732E646973706F736528297D29292C746869732E5F726567697374657228627328746869732E5F74617267657457696E646F772C22626C7572222C2828';
wwv_flow_imp.g_varchar2_table(31891) := '293D3E746869732E646973706F736528292929293B636F6E737420673D72696528226469762E686F7665722D726F772E6D61726B646F776E2D686F76657222292C6D3D72696528226469762E686F7665722D636F6E74656E747322293B69662822737472';
wwv_flow_imp.g_varchar2_table(31892) := '696E67223D3D747970656F6620652E636F6E74656E74296D2E74657874436F6E74656E743D652E636F6E74656E742C6D2E7374796C652E776869746553706163653D227072652D77726170223B656C736520696628652E636F6E74656E7420696E737461';
wwv_flow_imp.g_varchar2_table(31893) := '6E63656F662048544D4C456C656D656E74296D2E617070656E644368696C6428652E636F6E74656E74292C6D2E636C6173734C6973742E616464282268746D6C2D686F7665722D636F6E74656E747322293B656C73657B636F6E737420743D652E636F6E';
wwv_flow_imp.g_varchar2_table(31894) := '74656E742C6E3D746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E63652870452C7B636F6465426C6F636B466F6E7446616D696C793A746869732E5F636F6E66696775726174696F6E536572766963652E';
wwv_flow_imp.g_varchar2_table(31895) := '67657456616C75652822656469746F7222292E666F6E7446616D696C797C7C4B4C2E666F6E7446616D696C797D292C7B656C656D656E743A697D3D6E2E72656E64657228742C7B616374696F6E48616E646C65723A7B63616C6C6261636B3A653D3E7468';
wwv_flow_imp.g_varchar2_table(31896) := '69732E5F6C696E6B48616E646C65722865292C646973706F7361626C65733A746869732E5F6D6573736167654C697374656E6572737D2C6173796E6352656E64657243616C6C6261636B3A28293D3E7B6D2E636C6173734C6973742E6164642822636F64';
wwv_flow_imp.g_varchar2_table(31897) := '652D686F7665722D636F6E74656E747322292C746869732E6C61796F757428292C746869732E5F6F6E526571756573744C61796F75742E6669726528297D7D293B6D2E617070656E644368696C642869297D696628672E617070656E644368696C64286D';
wwv_flow_imp.g_varchar2_table(31898) := '292C746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E617070656E644368696C642867292C652E616374696F6E732626652E616374696F6E732E6C656E6774683E30297B636F6E737420743D72696528226469762E686F7665722D72';
wwv_flow_imp.g_varchar2_table(31899) := '6F772E7374617475732D62617222292C6E3D72696528226469762E616374696F6E7322293B652E616374696F6E732E666F72456163682828653D3E7B636F6E737420743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B65';
wwv_flow_imp.g_varchar2_table(31900) := '7962696E64696E6728652E636F6D6D616E644964292C693D743F742E6765744C6162656C28293A6E756C6C3B66712E72656E646572286E2C7B6C6162656C3A652E6C6162656C2C636F6D6D616E6449643A652E636F6D6D616E6449642C72756E3A743D3E';
wwv_flow_imp.g_varchar2_table(31901) := '7B652E72756E2874292C746869732E646973706F736528297D2C69636F6E436C6173733A652E69636F6E436C6173737D2C69297D29292C742E617070656E644368696C64286E292C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F6465';
wwv_flow_imp.g_varchar2_table(31902) := '2E617070656E644368696C642874297D6C657420663B696628746869732E5F686F766572436F6E7461696E65723D72696528226469762E776F726B62656E63682D686F7665722D636F6E7461696E657222292C746869732E5F686F766572506F696E7465';
wwv_flow_imp.g_varchar2_table(31903) := '722626746869732E5F686F766572436F6E7461696E65722E617070656E644368696C6428746869732E5F686F766572506F696E746572292C746869732E5F686F766572436F6E7461696E65722E617070656E644368696C6428746869732E5F686F766572';
wwv_flow_imp.g_varchar2_table(31904) := '2E636F6E7461696E6572446F6D4E6F6465292C663D2128652E616374696F6E732626652E616374696F6E732E6C656E6774683E3029262628766F696420303D3D3D286E756C6C3D3D3D28753D652E70657273697374656E6365297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(31905) := '3D753F766F696420303A752E686964654F6E486F766572293F22737472696E67223D3D747970656F6620652E636F6E74656E747C7C726328652E636F6E74656E7429262621652E636F6E74656E742E76616C75652E696E636C7564657328225D28222926';
wwv_flow_imp.g_varchar2_table(31906) := '2621652E636F6E74656E742E76616C75652E696E636C7564657328223C2F613E22293A652E70657273697374656E63652E686964654F6E486F766572292C662626286E756C6C3D3D3D28703D652E617070656172616E6365297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(31907) := '703F766F696420303A702E73686F77486F76657248696E7429297B636F6E737420653D72696528226469762E686F7665722D726F772E7374617475732D62617222292C743D72696528226469762E696E666F22293B742E74657874436F6E74656E743D62';
wwv_flow_imp.g_varchar2_table(31908) := '28302C22486F6C64207B307D206B657920746F206D6F757365206F766572222C713F224F7074696F6E223A22416C7422292C652E617070656E644368696C642874292C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E61707065';
wwv_flow_imp.g_varchar2_table(31909) := '6E644368696C642865297D636F6E737420763D5B2E2E2E746869732E5F7461726765742E746172676574456C656D656E74735D3B667C7C762E7075736828746869732E5F686F766572436F6E7461696E6572293B636F6E7374205F3D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(31910) := '676973746572286E6577206C6965287629293B696628746869732E5F7265676973746572285F2E6F6E4D6F7573654F7574282828293D3E7B746869732E5F69734C6F636B65647C7C746869732E646973706F736528297D2929292C66297B636F6E737420';
wwv_flow_imp.g_varchar2_table(31911) := '653D5B2E2E2E746869732E5F7461726765742E746172676574456C656D656E74732C746869732E5F686F766572436F6E7461696E65725D3B746869732E5F6C6F636B4D6F757365547261636B65723D746869732E5F7265676973746572286E6577206C69';
wwv_flow_imp.g_varchar2_table(31912) := '65286529292C746869732E5F726567697374657228746869732E5F6C6F636B4D6F757365547261636B65722E6F6E4D6F7573654F7574282828293D3E7B746869732E5F69734C6F636B65647C7C746869732E646973706F736528297D2929297D656C7365';
wwv_flow_imp.g_varchar2_table(31913) := '20746869732E5F6C6F636B4D6F757365547261636B65723D5F7D616464466F6375735472617028297B69662821746869732E5F656E61626C65466F63757354726170737C7C746869732E5F6164646564466F637573547261702972657475726E3B746869';
wwv_flow_imp.g_varchar2_table(31914) := '732E5F6164646564466F637573547261703D21303B636F6E737420653D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652C743D746869732E66696E644C617374466F63757361626C654368696C6428746869732E5F686F7665722E';
wwv_flow_imp.g_varchar2_table(31915) := '636F6E7461696E6572446F6D4E6F6465293B69662874297B636F6E7374206E3D707228746869732E5F686F766572436F6E7461696E65722C72696528226469762229292C693D757228746869732E5F686F766572436F6E7461696E65722C726965282264';
wwv_flow_imp.g_varchar2_table(31916) := '69762229293B6E2E746162496E6465783D302C692E746162496E6465783D302C746869732E5F726567697374657228627328692C22666F637573222C28743D3E7B652E666F63757328292C742E70726576656E7444656661756C7428297D2929292C7468';
wwv_flow_imp.g_varchar2_table(31917) := '69732E5F7265676973746572286273286E2C22666F637573222C28653D3E7B742E666F63757328292C652E70726576656E7444656661756C7428297D2929297D7D66696E644C617374466F63757361626C654368696C642865297B696628652E68617343';
wwv_flow_imp.g_varchar2_table(31918) := '68696C644E6F646573282929666F72286C657420743D303B743C652E6368696C644E6F6465732E6C656E6774683B742B2B297B636F6E7374206E3D652E6368696C644E6F6465732E6974656D28652E6368696C644E6F6465732E6C656E6774682D742D31';
wwv_flow_imp.g_varchar2_table(31919) := '293B6966286E2E6E6F6465547970653D3D3D6E2E454C454D454E545F4E4F4445297B636F6E737420653D6E3B696628226E756D626572223D3D747970656F6620652E746162496E6465782626652E746162496E6465783E3D302972657475726E20657D63';
wwv_flow_imp.g_varchar2_table(31920) := '6F6E737420693D746869732E66696E644C617374466F63757361626C654368696C64286E293B696628692972657475726E20697D7D72656E6465722865297B76617220743B652E617070656E644368696C6428746869732E5F686F766572436F6E746169';
wwv_flow_imp.g_varchar2_table(31921) := '6E6572293B636F6E7374206E3D746869732E5F686F766572436F6E7461696E65722E636F6E7461696E7328746869732E5F686F766572436F6E7461696E65722E6F776E6572446F63756D656E742E616374697665456C656D656E7429262676712821303D';
wwv_flow_imp.g_varchar2_table(31922) := '3D3D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C756528226163636573736962696C6974792E766572626F736974792E686F76657222292626746869732E5F6163636573736962696C697479536572766963652E69';
wwv_flow_imp.g_varchar2_table(31923) := '7353637265656E5265616465724F7074696D697A656428292C6E756C6C3D3D3D28743D746869732E5F6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E672822656469746F722E616374696F6E2E61636365737369626C';
wwv_flow_imp.g_varchar2_table(31924) := '65566965772229297C7C766F696420303D3D3D743F766F696420303A742E676574417269614C6162656C2829293B6E26264A72286E292C746869732E6C61796F757428292C746869732E616464466F6375735472617028297D6C61796F757428297B7468';
wwv_flow_imp.g_varchar2_table(31925) := '69732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E72656D6F7665282272696768742D616C69676E656422292C746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E7374796C652E6D61784865';
wwv_flow_imp.g_varchar2_table(31926) := '696768743D22223B636F6E737420653D746869732E5F7461726765742E746172676574456C656D656E74732E6D61702828653D3E28653D3E7B636F6E737420743D4E732865292C6E3D652E676574426F756E64696E67436C69656E745265637428293B72';
wwv_flow_imp.g_varchar2_table(31927) := '657475726E7B746F703A6E2E746F702A742C626F74746F6D3A6E2E626F74746F6D2A742C72696768743A6E2E72696768742A742C6C6566743A6E2E6C6566742A747D7D2928652929292C7B746F703A742C72696768743A6E2C626F74746F6D3A692C6C65';
wwv_flow_imp.g_varchar2_table(31928) := '66743A6F7D3D655B305D2C733D6E2D6F2C723D692D742C613D7B746F703A742C72696768743A6E2C626F74746F6D3A692C6C6566743A6F2C77696474683A732C6865696768743A722C63656E7465723A7B783A6F2B732F322C793A742B722F327D7D3B69';
wwv_flow_imp.g_varchar2_table(31929) := '6628746869732E61646A757374486F72697A6F6E74616C486F766572506F736974696F6E2861292C746869732E61646A757374566572746963616C486F766572506F736974696F6E2861292C746869732E61646A757374486F7665724D61784865696768';
wwv_flow_imp.g_varchar2_table(31930) := '742861292C746869732E5F686F766572436F6E7461696E65722E7374796C652E70616464696E673D22222C746869732E5F686F766572436F6E7461696E65722E7374796C652E6D617267696E3D22222C746869732E5F686F766572506F696E746572297B';
wwv_flow_imp.g_varchar2_table(31931) := '73776974636828746869732E5F686F766572506F736974696F6E297B6361736520313A612E6C6566742B3D332C612E72696768742B3D332C746869732E5F686F766572436F6E7461696E65722E7374796C652E70616464696E674C6566743D2233707822';
wwv_flow_imp.g_varchar2_table(31932) := '2C746869732E5F686F766572436F6E7461696E65722E7374796C652E6D617267696E4C6566743D222D337078223B627265616B3B6361736520303A612E6C6566742D3D332C612E72696768742D3D332C746869732E5F686F766572436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(31933) := '2E7374796C652E70616464696E6752696768743D22337078222C746869732E5F686F766572436F6E7461696E65722E7374796C652E6D617267696E52696768743D222D337078223B627265616B3B6361736520323A612E746F702B3D332C612E626F7474';
wwv_flow_imp.g_varchar2_table(31934) := '6F6D2B3D332C746869732E5F686F766572436F6E7461696E65722E7374796C652E70616464696E67546F703D22337078222C746869732E5F686F766572436F6E7461696E65722E7374796C652E6D617267696E546F703D222D337078223B627265616B3B';
wwv_flow_imp.g_varchar2_table(31935) := '6361736520333A612E746F702D3D332C612E626F74746F6D2D3D332C746869732E5F686F766572436F6E7461696E65722E7374796C652E70616464696E67426F74746F6D3D22337078222C746869732E5F686F766572436F6E7461696E65722E7374796C';
wwv_flow_imp.g_varchar2_table(31936) := '652E6D617267696E426F74746F6D3D222D337078227D612E63656E7465722E783D612E6C6566742B732F322C612E63656E7465722E793D612E746F702B722F327D746869732E636F6D7075746558436F7264696E6174652861292C746869732E636F6D70';
wwv_flow_imp.g_varchar2_table(31937) := '75746559436F7264696E6174652861292C746869732E5F686F766572506F696E746572262628746869732E5F686F766572506F696E7465722E636C6173734C6973742E72656D6F76652822746F7022292C746869732E5F686F766572506F696E7465722E';
wwv_flow_imp.g_varchar2_table(31938) := '636C6173734C6973742E72656D6F766528226C65667422292C746869732E5F686F766572506F696E7465722E636C6173734C6973742E72656D6F76652822726967687422292C746869732E5F686F766572506F696E7465722E636C6173734C6973742E72';
wwv_flow_imp.g_varchar2_table(31939) := '656D6F76652822626F74746F6D22292C746869732E736574486F766572506F696E746572506F736974696F6E286129292C746869732E5F686F7665722E6F6E436F6E74656E74734368616E67656428297D636F6D7075746558436F7264696E6174652865';
wwv_flow_imp.g_varchar2_table(31940) := '297B636F6E737420743D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682B323B766F69642030213D3D746869732E5F7461726765742E783F746869732E5F783D746869732E5F7461726765742E783A';
wwv_flow_imp.g_varchar2_table(31941) := '313D3D3D746869732E5F686F766572506F736974696F6E3F746869732E5F783D652E72696768743A303D3D3D746869732E5F686F766572506F736974696F6E3F746869732E5F783D652E6C6566742D743A28746869732E5F686F766572506F696E746572';
wwv_flow_imp.g_varchar2_table(31942) := '3F746869732E5F783D652E63656E7465722E782D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682F323A746869732E5F783D652E6C6566742C746869732E5F782B743E3D746869732E5F7461726765';
wwv_flow_imp.g_varchar2_table(31943) := '74446F63756D656E74456C656D656E742E636C69656E745769647468262628746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C6173734C6973742E616464282272696768742D616C69676E656422292C746869732E5F783D4D';
wwv_flow_imp.g_varchar2_table(31944) := '6174682E6D617828746869732E5F746172676574446F63756D656E74456C656D656E742E636C69656E7457696474682D742D322C746869732E5F746172676574446F63756D656E74456C656D656E742E636C69656E744C6566742929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(31945) := '783C746869732E5F746172676574446F63756D656E74456C656D656E742E636C69656E744C656674262628746869732E5F783D652E6C6566742B32297D636F6D7075746559436F7264696E6174652865297B766F69642030213D3D746869732E5F746172';
wwv_flow_imp.g_varchar2_table(31946) := '6765742E793F746869732E5F793D746869732E5F7461726765742E793A333D3D3D746869732E5F686F766572506F736974696F6E3F746869732E5F793D652E746F703A323D3D3D746869732E5F686F766572506F736974696F6E3F746869732E5F793D65';
wwv_flow_imp.g_varchar2_table(31947) := '2E626F74746F6D2D323A746869732E5F686F766572506F696E7465723F746869732E5F793D652E63656E7465722E792B746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E744865696768742F323A746869732E5F793D';
wwv_flow_imp.g_varchar2_table(31948) := '652E626F74746F6D2C746869732E5F793E746869732E5F74617267657457696E646F772E696E6E6572486569676874262628746869732E5F793D652E626F74746F6D297D61646A757374486F72697A6F6E74616C486F766572506F736974696F6E286529';
wwv_flow_imp.g_varchar2_table(31949) := '7B696628766F69642030213D3D746869732E5F7461726765742E782972657475726E3B636F6E737420743D746869732E5F686F766572506F696E7465723F333A303B696628746869732E5F666F726365506F736974696F6E297B636F6E7374206E3D742B';
wwv_flow_imp.g_varchar2_table(31950) := '323B313D3D3D746869732E5F686F766572506F736974696F6E3F746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E6D617857696474683D746869732E5F746172676574446F63756D656E74456C656D656E742E636C';
wwv_flow_imp.g_varchar2_table(31951) := '69656E7457696474682D652E72696768742D6E2B227078223A303D3D3D746869732E5F686F766572506F736974696F6E262628746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E6D617857696474683D652E6C6566';
wwv_flow_imp.g_varchar2_table(31952) := '742D6E2B22707822297D656C736520313D3D3D746869732E5F686F766572506F736974696F6E3F746869732E5F746172676574446F63756D656E74456C656D656E742E636C69656E7457696474682D652E72696768743C746869732E5F686F7665722E63';
wwv_flow_imp.g_varchar2_table(31953) := '6F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682B74262628652E6C6566743E3D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682B743F746869732E5F686F766572506F73697469';
wwv_flow_imp.g_varchar2_table(31954) := '6F6E3D303A746869732E5F686F766572506F736974696F6E3D32293A303D3D3D746869732E5F686F766572506F736974696F6E262628652E6C6566743C746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474';
wwv_flow_imp.g_varchar2_table(31955) := '682B74262628746869732E5F746172676574446F63756D656E74456C656D656E742E636C69656E7457696474682D652E72696768743E3D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682B743F7468';
wwv_flow_imp.g_varchar2_table(31956) := '69732E5F686F766572506F736974696F6E3D313A746869732E5F686F766572506F736974696F6E3D32292C652E6C6566742D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474682D743C3D746869732E5F';
wwv_flow_imp.g_varchar2_table(31957) := '746172676574446F63756D656E74456C656D656E742E636C69656E744C656674262628746869732E5F686F766572506F736974696F6E3D3129297D61646A757374566572746963616C486F766572506F736974696F6E2865297B696628766F6964203021';
wwv_flow_imp.g_varchar2_table(31958) := '3D3D746869732E5F7461726765742E797C7C746869732E5F666F726365506F736974696F6E2972657475726E3B636F6E737420743D746869732E5F686F766572506F696E7465723F333A303B333D3D3D746869732E5F686F766572506F736974696F6E3F';
wwv_flow_imp.g_varchar2_table(31959) := '652E746F702D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E744865696768742D743C30262628746869732E5F686F766572506F736974696F6E3D32293A323D3D3D746869732E5F686F766572506F736974696F6E';
wwv_flow_imp.g_varchar2_table(31960) := '2626652E626F74746F6D2B746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E744865696768742B743E746869732E5F74617267657457696E646F772E696E6E6572486569676874262628746869732E5F686F76657250';
wwv_flow_imp.g_varchar2_table(31961) := '6F736974696F6E3D33297D61646A757374486F7665724D61784865696768742865297B6C657420743D746869732E5F74617267657457696E646F772E696E6E65724865696768742F323B696628746869732E5F666F726365506F736974696F6E297B636F';
wwv_flow_imp.g_varchar2_table(31962) := '6E7374206E3D322B28746869732E5F686F766572506F696E7465723F333A30293B333D3D3D746869732E5F686F766572506F736974696F6E3F743D4D6174682E6D696E28742C652E746F702D6E293A323D3D3D746869732E5F686F766572506F73697469';
wwv_flow_imp.g_varchar2_table(31963) := '6F6E262628743D4D6174682E6D696E28742C746869732E5F74617267657457696E646F772E696E6E65724865696768742D652E626F74746F6D2D6E29297D696628746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E7374796C652E';
wwv_flow_imp.g_varchar2_table(31964) := '6D61784865696768743D60247B747D7078602C746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E636C69656E744865696768743C746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E7363726F6C6C486569676874';
wwv_flow_imp.g_varchar2_table(31965) := '297B636F6E737420653D60247B746869732E5F686F7665722E7363726F6C6C6261722E6F7074696F6E732E766572746963616C5363726F6C6C62617253697A657D7078603B746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E737479';
wwv_flow_imp.g_varchar2_table(31966) := '6C652E70616464696E675269676874213D3D65262628746869732E5F686F7665722E636F6E74656E7473446F6D4E6F64652E7374796C652E70616464696E6752696768743D65297D7D736574486F766572506F696E746572506F736974696F6E2865297B';
wwv_flow_imp.g_varchar2_table(31967) := '696628746869732E5F686F766572506F696E7465722973776974636828746869732E5F686F766572506F736974696F6E297B6361736520303A6361736520313A7B746869732E5F686F766572506F696E7465722E636C6173734C6973742E61646428303D';
wwv_flow_imp.g_varchar2_table(31968) := '3D3D746869732E5F686F766572506F736974696F6E3F227269676874223A226C65667422293B636F6E737420743D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E744865696768743B743E652E6865696768743F74';
wwv_flow_imp.g_varchar2_table(31969) := '6869732E5F686F766572506F696E7465722E7374796C652E746F703D652E63656E7465722E792D28746869732E5F792D74292D332B227078223A746869732E5F686F766572506F696E7465722E7374796C652E746F703D4D6174682E726F756E6428742F';
wwv_flow_imp.g_varchar2_table(31970) := '32292D332B227078223B627265616B7D6361736520333A6361736520323A7B746869732E5F686F766572506F696E7465722E636C6173734C6973742E61646428333D3D3D746869732E5F686F766572506F736974696F6E3F22626F74746F6D223A22746F';
wwv_flow_imp.g_varchar2_table(31971) := '7022293B636F6E737420743D746869732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E636C69656E7457696474683B6C6574206E3D4D6174682E726F756E6428742F32292D333B636F6E737420693D746869732E5F782B6E3B28693C652E';
wwv_flow_imp.g_varchar2_table(31972) := '6C6566747C7C693E652E7269676874292626286E3D652E63656E7465722E782D746869732E5F782D33292C746869732E5F686F766572506F696E7465722E7374796C652E6C6566743D60247B6E7D7078603B627265616B7D7D7D666F63757328297B7468';
wwv_flow_imp.g_varchar2_table(31973) := '69732E5F686F7665722E636F6E7461696E6572446F6D4E6F64652E666F63757328297D646973706F736528297B746869732E5F6973446973706F7365647C7C28746869732E5F6F6E446973706F73652E6669726528292C746869732E5F686F766572436F';
wwv_flow_imp.g_varchar2_table(31974) := '6E7461696E65722E72656D6F766528292C746869732E5F6D6573736167654C697374656E6572732E646973706F736528292C746869732E5F7461726765742E646973706F736528292C73757065722E646973706F73652829292C746869732E5F69734469';
wwv_flow_imp.g_varchar2_table(31975) := '73706F7365643D21307D7D3B6169653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944';
wwv_flow_imp.g_varchar2_table(31976) := '657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F72617465';
wwv_flow_imp.g_varchar2_table(31977) := '28652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20';
wwv_flow_imp.g_varchar2_table(31978) := '733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B73696528312C2445292C73696528322C6670292C73696528332C6445292C73696528342C7563292C73696528352C5953295D2C616965293B636C61';
wwv_flow_imp.g_varchar2_table(31979) := '7373206C696520657874656E64732047447B676574206F6E4D6F7573654F757428297B72657475726E20746869732E5F6F6E4D6F7573654F75742E6576656E747D6765742069734D6F757365496E28297B72657475726E20746869732E5F69734D6F7573';
wwv_flow_imp.g_varchar2_table(31980) := '65496E7D636F6E7374727563746F722865297B737570657228292C746869732E5F656C656D656E74733D652C746869732E5F69734D6F757365496E3D21302C746869732E5F6F6E4D6F7573654F75743D746869732E5F7265676973746572286E65772043';
wwv_flow_imp.g_varchar2_table(31981) := '74292C746869732E5F656C656D656E74732E666F72456163682828653D3E746869732E6F6E6D6F7573656F76657228652C2828293D3E746869732E5F6F6E5461726765744D6F7573654F766572286529292929292C746869732E5F656C656D656E74732E';
wwv_flow_imp.g_varchar2_table(31982) := '666F72456163682828653D3E746869732E6F6E6D6F7573656C6561766528652C2828293D3E746869732E5F6F6E5461726765744D6F7573654C65617665286529292929297D5F6F6E5461726765744D6F7573654F7665722865297B746869732E5F69734D';
wwv_flow_imp.g_varchar2_table(31983) := '6F757365496E3D21302C746869732E5F636C6561724576616C756174654D6F757365537461746554696D656F75742865297D5F6F6E5461726765744D6F7573654C656176652865297B746869732E5F69734D6F757365496E3D21312C746869732E5F6576';
wwv_flow_imp.g_varchar2_table(31984) := '616C756174654D6F75736553746174652865297D5F6576616C756174654D6F75736553746174652865297B746869732E5F636C6561724576616C756174654D6F757365537461746554696D656F75742865292C746869732E5F6D6F75736554696D656F75';
wwv_flow_imp.g_varchar2_table(31985) := '743D72732865292E73657454696D656F7574282828293D3E746869732E5F6669726549664D6F7573654F7574736964652829292C30297D5F636C6561724576616C756174654D6F757365537461746554696D656F75742865297B746869732E5F6D6F7573';
wwv_flow_imp.g_varchar2_table(31986) := '6554696D656F757426262872732865292E636C65617254696D656F757428746869732E5F6D6F75736554696D656F7574292C746869732E5F6D6F75736554696D656F75743D766F69642030297D5F6669726549664D6F7573654F75747369646528297B74';
wwv_flow_imp.g_varchar2_table(31987) := '6869732E5F69734D6F757365496E7C7C746869732E5F6F6E4D6F7573654F75742E6669726528297D7D636C617373206369657B636F6E7374727563746F722865297B746869732E5F656C656D656E743D652C746869732E746172676574456C656D656E74';
wwv_flow_imp.g_varchar2_table(31988) := '733D5B746869732E5F656C656D656E745D7D646973706F736528297B7D7D766172206469652C6869653D6E2838393730292C7569653D7B7D3B66756E6374696F6E2070696528652C742C6E297B636F6E737420693D6E2E6D6F64653D3D3D6469652E414C';
wwv_flow_imp.g_varchar2_table(31989) := '49474E3F6E2E6F66667365743A6E2E6F66667365742B6E2E73697A652C6F3D6E2E6D6F64653D3D3D6469652E414C49474E3F6E2E6F66667365742B6E2E73697A653A6E2E6F66667365743B72657475726E20303D3D3D6E2E706F736974696F6E3F743C3D';
wwv_flow_imp.g_varchar2_table(31990) := '652D693F693A743C3D6F3F6F2D743A4D6174682E6D617828652D742C30293A743C3D6F3F6F2D743A743C3D652D693F693A307D7569652E7374796C655461675472616E73666F726D3D6A7228292C7569652E736574417474726962757465733D56722829';
wwv_flow_imp.g_varchar2_table(31991) := '2C7569652E696E736572743D467228292E62696E64286E756C6C2C226865616422292C7569652E646F6D4150493D4F7228292C7569652E696E736572745374796C65456C656D656E743D487228292C4E722829286869652E412C756965292C6869652E41';
wwv_flow_imp.g_varchar2_table(31992) := '26266869652E412E6C6F63616C7326266869652E412E6C6F63616C732C66756E6374696F6E2865297B655B652E41564F49443D305D3D2241564F4944222C655B652E414C49474E3D315D3D22414C49474E227D286469657C7C286469653D7B7D29293B63';
wwv_flow_imp.g_varchar2_table(31993) := '6C6173732067696520657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E636F6E7461696E65723D6E756C6C2C746869732E7573654669786564506F736974696F6E3D21312C746869732E7573655368';
wwv_flow_imp.g_varchar2_table(31994) := '61646F77444F4D3D21312C746869732E64656C65676174653D6E756C6C2C746869732E746F446973706F73654F6E436C65616E3D6C742E4E6F6E652C746869732E746F446973706F73654F6E536574436F6E7461696E65723D6C742E4E6F6E652C746869';
wwv_flow_imp.g_varchar2_table(31995) := '732E736861646F77526F6F743D6E756C6C2C746869732E736861646F77526F6F74486F7374456C656D656E743D6E756C6C2C746869732E766965773D627228222E636F6E746578742D7669657722292C797228746869732E76696577292C746869732E73';
wwv_flow_imp.g_varchar2_table(31996) := '6574436F6E7461696E657228652C74292C746869732E5F7265676973746572287274282828293D3E746869732E736574436F6E7461696E6572286E756C6C2C31292929297D736574436F6E7461696E657228652C74297B766172206E3B746869732E7573';
wwv_flow_imp.g_varchar2_table(31997) := '654669786564506F736974696F6E3D31213D3D743B636F6E737420693D746869732E757365536861646F77444F4D3B696628746869732E757365536861646F77444F4D3D333D3D3D742C2865213D3D746869732E636F6E7461696E65727C7C69213D3D74';
wwv_flow_imp.g_varchar2_table(31998) := '6869732E757365536861646F77444F4D29262628746869732E636F6E7461696E6572262628746869732E746F446973706F73654F6E536574436F6E7461696E65722E646973706F736528292C746869732E736861646F77526F6F743F28746869732E7368';
wwv_flow_imp.g_varchar2_table(31999) := '61646F77526F6F742E72656D6F76654368696C6428746869732E76696577292C746869732E736861646F77526F6F743D6E756C6C2C6E756C6C3D3D3D286E3D746869732E736861646F77526F6F74486F7374456C656D656E74297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(32000) := '3D6E7C7C6E2E72656D6F766528292C746869732E736861646F77526F6F74486F7374456C656D656E743D6E756C6C293A746869732E636F6E7461696E65722E72656D6F76654368696C6428746869732E76696577292C746869732E636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(32001) := '3D6E756C6C292C6529297B696628746869732E636F6E7461696E65723D652C746869732E757365536861646F77444F4D297B746869732E736861646F77526F6F74486F7374456C656D656E743D627228222E736861646F772D726F6F742D686F73742229';
wwv_flow_imp.g_varchar2_table(32002) := '2C746869732E636F6E7461696E65722E617070656E644368696C6428746869732E736861646F77526F6F74486F7374456C656D656E74292C746869732E736861646F77526F6F743D746869732E736861646F77526F6F74486F7374456C656D656E742E61';
wwv_flow_imp.g_varchar2_table(32003) := '7474616368536861646F77287B6D6F64653A226F70656E227D293B636F6E737420653D646F63756D656E742E637265617465456C656D656E7428227374796C6522293B652E74657874436F6E74656E743D6D69652C746869732E736861646F77526F6F74';
wwv_flow_imp.g_varchar2_table(32004) := '2E617070656E644368696C642865292C746869732E736861646F77526F6F742E617070656E644368696C6428746869732E76696577292C746869732E736861646F77526F6F742E617070656E644368696C642862722822736C6F742229297D656C736520';
wwv_flow_imp.g_varchar2_table(32005) := '746869732E636F6E7461696E65722E617070656E644368696C6428746869732E76696577293B636F6E737420743D6E65772061743B6769652E425542424C455F55505F4556454E54532E666F72456163682828653D3E7B742E6164642879732874686973';
wwv_flow_imp.g_varchar2_table(32006) := '2E636F6E7461696E65722C652C28653D3E7B746869732E6F6E444F4D4576656E7428652C2131297D2929297D29292C6769652E425542424C455F444F574E5F4556454E54532E666F72456163682828653D3E7B742E61646428797328746869732E636F6E';
wwv_flow_imp.g_varchar2_table(32007) := '7461696E65722C652C28653D3E7B746869732E6F6E444F4D4576656E7428652C2130297D292C213029297D29292C746869732E746F446973706F73654F6E536574436F6E7461696E65723D747D7D73686F772865297B76617220742C6E2C693B74686973';
wwv_flow_imp.g_varchar2_table(32008) := '2E697356697369626C6528292626746869732E6869646528292C667328746869732E76696577292C746869732E766965772E636C6173734E616D653D22636F6E746578742D76696577206D6F6E61636F2D636F6D706F6E656E74222C746869732E766965';
wwv_flow_imp.g_varchar2_table(32009) := '772E7374796C652E746F703D22307078222C746869732E766965772E7374796C652E6C6566743D22307078222C746869732E766965772E7374796C652E7A496E6465783D60247B323537352B286E756C6C213D3D28743D652E6C61796572292626766F69';
wwv_flow_imp.g_varchar2_table(32010) := '642030213D3D743F743A30297D602C746869732E766965772E7374796C652E706F736974696F6E3D746869732E7573654669786564506F736974696F6E3F226669786564223A226162736F6C757465222C5F7228746869732E76696577292C746869732E';
wwv_flow_imp.g_varchar2_table(32011) := '746F446973706F73654F6E436C65616E3D652E72656E64657228746869732E76696577297C7C6C742E4E6F6E652C746869732E64656C65676174653D652C746869732E646F4C61796F757428292C6E756C6C3D3D3D28693D286E3D746869732E64656C65';
wwv_flow_imp.g_varchar2_table(32012) := '67617465292E666F637573297C7C766F696420303D3D3D697C7C692E63616C6C286E297D67657456696577456C656D656E7428297B72657475726E20746869732E766965777D6C61796F757428297B76617220652C743B746869732E697356697369626C';
wwv_flow_imp.g_varchar2_table(32013) := '6528292626282131213D3D746869732E64656C65676174652E63616E52656C61796F75747C7C51262664653F286E756C6C3D3D3D28743D6E756C6C3D3D3D28653D746869732E64656C6567617465297C7C766F696420303D3D3D653F766F696420303A65';
wwv_flow_imp.g_varchar2_table(32014) := '2E6C61796F7574297C7C766F696420303D3D3D747C7C742E63616C6C2865292C746869732E646F4C61796F75742829293A746869732E686964652829297D646F4C61796F757428297B69662821746869732E697356697369626C6528292972657475726E';
wwv_flow_imp.g_varchar2_table(32015) := '3B636F6E737420653D746869732E64656C65676174652E676574416E63686F7228293B6C657420743B6966286520696E7374616E63656F662048544D4C456C656D656E74297B636F6E7374206E3D41732865292C693D4E732865293B743D7B746F703A6E';
wwv_flow_imp.g_varchar2_table(32016) := '2E746F702A692C6C6566743A6E2E6C6566742A692C77696474683A6E2E77696474682A692C6865696768743A6E2E6865696768742A697D7D656C736520743D66756E6374696F6E2865297B636F6E737420743D653B72657475726E2121742626226E756D';
wwv_flow_imp.g_varchar2_table(32017) := '626572223D3D747970656F6620742E782626226E756D626572223D3D747970656F6620742E797D2865293F7B746F703A652E792C6C6566743A652E782C77696474683A652E77696474687C7C312C6865696768743A652E6865696768747C7C327D3A7B74';
wwv_flow_imp.g_varchar2_table(32018) := '6F703A652E706F73792C6C6566743A652E706F73782C77696474683A322C6865696768743A327D3B636F6E7374206E3D507328746869732E76696577292C693D467328746869732E76696577292C6F3D746869732E64656C65676174652E616E63686F72';
wwv_flow_imp.g_varchar2_table(32019) := '506F736974696F6E7C7C302C723D746869732E64656C65676174652E616E63686F72416C69676E6D656E747C7C302C613D746869732E64656C65676174652E616E63686F7241786973416C69676E6D656E747C7C303B6C6574206C2C633B636F6E737420';
wwv_flow_imp.g_varchar2_table(32020) := '643D66756E6374696F6E28297B76617220652C743B72657475726E206E756C6C213D3D28743D6E756C6C3D3D3D28653D557328292E64656661756C7456696577297C7C766F696420303D3D3D653F766F696420303A652E77696E646F77292626766F6964';
wwv_flow_imp.g_varchar2_table(32021) := '2030213D3D743F743A737D28293B696628303D3D3D61297B636F6E737420653D7B6F66667365743A742E746F702D642E70616765594F66667365742C73697A653A742E6865696768742C706F736974696F6E3A303D3D3D6F3F303A317D2C733D7B6F6666';
wwv_flow_imp.g_varchar2_table(32022) := '7365743A742E6C6566742C73697A653A742E77696474682C706F736974696F6E3A303D3D3D723F303A312C6D6F64653A6469652E414C49474E7D3B6C3D70696528642E696E6E65724865696768742C692C65292B642E70616765594F66667365742C7254';
wwv_flow_imp.g_varchar2_table(32023) := '2E696E7465727365637473287B73746172743A6C2C656E643A6C2B697D2C7B73746172743A652E6F66667365742C656E643A652E6F66667365742B652E73697A657D29262628732E6D6F64653D6469652E41564F4944292C633D70696528642E696E6E65';
wwv_flow_imp.g_varchar2_table(32024) := '7257696474682C6E2C73297D656C73657B636F6E737420653D7B6F66667365743A742E6C6566742C73697A653A742E77696474682C706F736974696F6E3A303D3D3D723F303A317D2C733D7B6F66667365743A742E746F702C73697A653A742E68656967';
wwv_flow_imp.g_varchar2_table(32025) := '68742C706F736974696F6E3A303D3D3D6F3F303A312C6D6F64653A6469652E414C49474E7D3B633D70696528642E696E6E657257696474682C6E2C65292C72542E696E7465727365637473287B73746172743A632C656E643A632B6E7D2C7B7374617274';
wwv_flow_imp.g_varchar2_table(32026) := '3A652E6F66667365742C656E643A652E6F66667365742B652E73697A657D29262628732E6D6F64653D6469652E41564F4944292C6C3D70696528642E696E6E65724865696768742C692C73292B642E70616765594F66667365747D746869732E76696577';
wwv_flow_imp.g_varchar2_table(32027) := '2E636C6173734C6973742E72656D6F76652822746F70222C22626F74746F6D222C226C656674222C22726967687422292C746869732E766965772E636C6173734C6973742E61646428303D3D3D6F3F22626F74746F6D223A22746F7022292C746869732E';
wwv_flow_imp.g_varchar2_table(32028) := '766965772E636C6173734C6973742E61646428303D3D3D723F226C656674223A22726967687422292C746869732E766965772E636C6173734C6973742E746F67676C6528226669786564222C746869732E7573654669786564506F736974696F6E293B63';
wwv_flow_imp.g_varchar2_table(32029) := '6F6E737420683D417328746869732E636F6E7461696E6572293B746869732E766965772E7374796C652E746F703D6C2D28746869732E7573654669786564506F736974696F6E3F417328746869732E76696577292E746F703A682E746F70292B22707822';
wwv_flow_imp.g_varchar2_table(32030) := '2C746869732E766965772E7374796C652E6C6566743D632D28746869732E7573654669786564506F736974696F6E3F417328746869732E76696577292E6C6566743A682E6C656674292B227078222C746869732E766965772E7374796C652E7769647468';
wwv_flow_imp.g_varchar2_table(32031) := '3D22696E697469616C227D686964652865297B636F6E737420743D746869732E64656C65676174653B746869732E64656C65676174653D6E756C6C2C286E756C6C3D3D743F766F696420303A742E6F6E48696465292626742E6F6E486964652865292C74';
wwv_flow_imp.g_varchar2_table(32032) := '6869732E746F446973706F73654F6E436C65616E2E646973706F736528292C797228746869732E76696577297D697356697369626C6528297B72657475726E2121746869732E64656C65676174657D6F6E444F4D4576656E7428652C74297B746869732E';
wwv_flow_imp.g_varchar2_table(32033) := '64656C6567617465262628746869732E64656C65676174652E6F6E444F4D4576656E743F746869732E64656C65676174652E6F6E444F4D4576656E7428652C72732865292E646F63756D656E742E616374697665456C656D656E74293A74262621427328';
wwv_flow_imp.g_varchar2_table(32034) := '652E7461726765742C746869732E636F6E7461696E6572292626746869732E686964652829297D646973706F736528297B746869732E6869646528292C73757065722E646973706F736528297D7D6769652E425542424C455F55505F4556454E54533D5B';
wwv_flow_imp.g_varchar2_table(32035) := '22636C69636B222C226B6579646F776E222C22666F637573222C22626C7572225D2C6769652E425542424C455F444F574E5F4556454E54533D5B22636C69636B225D3B636F6E7374206D69653D275C6E5C743A686F7374207B5C6E5C745C74616C6C3A20';
wwv_flow_imp.g_varchar2_table(32036) := '696E697469616C3B202F2A203173742072756C6520736F2073756273657175656E742070726F70657274696573206172652072657365742E202A2F5C6E5C747D5C6E5C6E5C742E636F6469636F6E5B636C6173732A3D5C27636F6469636F6E2D5C275D20';
wwv_flow_imp.g_varchar2_table(32037) := '7B5C6E5C745C74666F6E743A206E6F726D616C206E6F726D616C206E6F726D616C20313670782F3120636F6469636F6E3B5C6E5C745C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C745C74746578742D6465636F726174696F6E3A20';
wwv_flow_imp.g_varchar2_table(32038) := '6E6F6E653B5C6E5C745C74746578742D72656E646572696E673A206175746F3B5C6E5C745C74746578742D616C69676E3A2063656E7465723B5C6E5C745C742D7765626B69742D666F6E742D736D6F6F7468696E673A20616E7469616C69617365643B5C';
wwv_flow_imp.g_varchar2_table(32039) := '6E5C745C742D6D6F7A2D6F73782D666F6E742D736D6F6F7468696E673A20677261797363616C653B5C6E5C745C74757365722D73656C6563743A206E6F6E653B5C6E5C745C742D7765626B69742D757365722D73656C6563743A206E6F6E653B5C6E5C74';
wwv_flow_imp.g_varchar2_table(32040) := '5C742D6D732D757365722D73656C6563743A206E6F6E653B5C6E5C747D5C6E5C6E5C743A686F7374207B5C6E5C745C74666F6E742D66616D696C793A202D6170706C652D73797374656D2C20426C696E6B4D616353797374656D466F6E742C2022536567';
wwv_flow_imp.g_varchar2_table(32041) := '6F6520575043222C20225365676F65205549222C202248656C7665746963614E6575652D4C69676874222C2073797374656D2D75692C20225562756E7475222C202244726F69642053616E73222C2073616E732D73657269663B5C6E5C747D5C6E5C6E5C';
wwv_flow_imp.g_varchar2_table(32042) := '743A686F73742D636F6E74657874282E6D616329207B20666F6E742D66616D696C793A202D6170706C652D73797374656D2C20426C696E6B4D616353797374656D466F6E742C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E746578';
wwv_flow_imp.g_varchar2_table(32043) := '74282E6D61633A6C616E67287A682D48616E732929207B20666F6E742D66616D696C793A202D6170706C652D73797374656D2C20426C696E6B4D616353797374656D466F6E742C202250696E6746616E67205343222C20224869726167696E6F2053616E';
wwv_flow_imp.g_varchar2_table(32044) := '73204742222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E6D61633A6C616E67287A682D48616E742929207B20666F6E742D66616D696C793A202D6170706C652D73797374656D2C20426C696E6B4D616353797374';
wwv_flow_imp.g_varchar2_table(32045) := '656D466F6E742C202250696E6746616E67205443222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E6D61633A6C616E67286A612929207B20666F6E742D66616D696C793A202D6170706C652D73797374656D2C2042';
wwv_flow_imp.g_varchar2_table(32046) := '6C696E6B4D616353797374656D466F6E742C20224869726167696E6F204B616B7520476F746869632050726F222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E6D61633A6C616E67286B6F2929207B20666F6E742D';
wwv_flow_imp.g_varchar2_table(32047) := '66616D696C793A202D6170706C652D73797374656D2C20426C696E6B4D616353797374656D466F6E742C20224E616E756D20476F74686963222C20224170706C6520534420476F74686963204E656F222C20224170706C65476F74686963222C2073616E';
wwv_flow_imp.g_varchar2_table(32048) := '732D73657269663B207D5C6E5C6E5C743A686F73742D636F6E74657874282E77696E646F777329207B20666F6E742D66616D696C793A20225365676F6520575043222C20225365676F65205549222C2073616E732D73657269663B207D5C6E5C743A686F';
wwv_flow_imp.g_varchar2_table(32049) := '73742D636F6E74657874282E77696E646F77733A6C616E67287A682D48616E732929207B20666F6E742D66616D696C793A20225365676F6520575043222C20225365676F65205549222C20224D6963726F736F6674205961486569222C2073616E732D73';
wwv_flow_imp.g_varchar2_table(32050) := '657269663B207D5C6E5C743A686F73742D636F6E74657874282E77696E646F77733A6C616E67287A682D48616E742929207B20666F6E742D66616D696C793A20225365676F6520575043222C20225365676F65205549222C20224D6963726F736F667420';
wwv_flow_imp.g_varchar2_table(32051) := '4A68656E67686569222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E77696E646F77733A6C616E67286A612929207B20666F6E742D66616D696C793A20225365676F6520575043222C20225365676F65205549222C';
wwv_flow_imp.g_varchar2_table(32052) := '2022597520476F74686963205549222C20224D656972796F205549222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E77696E646F77733A6C616E67286B6F2929207B20666F6E742D66616D696C793A20225365676F';
wwv_flow_imp.g_varchar2_table(32053) := '6520575043222C20225365676F65205549222C20224D616C67756E20476F74686963222C2022446F746F6D222C2073616E732D73657269663B207D5C6E5C6E5C743A686F73742D636F6E74657874282E6C696E757829207B20666F6E742D66616D696C79';
wwv_flow_imp.g_varchar2_table(32054) := '3A2073797374656D2D75692C20225562756E7475222C202244726F69642053616E73222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E6C696E75783A6C616E67287A682D48616E732929207B20666F6E742D66616D';
wwv_flow_imp.g_varchar2_table(32055) := '696C793A2073797374656D2D75692C20225562756E7475222C202244726F69642053616E73222C2022536F757263652048616E2053616E73205343222C2022536F757263652048616E2053616E7320434E222C2022536F757263652048616E2053616E73';
wwv_flow_imp.g_varchar2_table(32056) := '222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E6C696E75783A6C616E67287A682D48616E742929207B20666F6E742D66616D696C793A2073797374656D2D75692C20225562756E7475222C202244726F69642053';
wwv_flow_imp.g_varchar2_table(32057) := '616E73222C2022536F757263652048616E2053616E73205443222C2022536F757263652048616E2053616E73205457222C2022536F757263652048616E2053616E73222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E7465787428';
wwv_flow_imp.g_varchar2_table(32058) := '2E6C696E75783A6C616E67286A612929207B20666F6E742D66616D696C793A2073797374656D2D75692C20225562756E7475222C202244726F69642053616E73222C2022536F757263652048616E2053616E73204A222C2022536F757263652048616E20';
wwv_flow_imp.g_varchar2_table(32059) := '53616E73204A50222C2022536F757263652048616E2053616E73222C2073616E732D73657269663B207D5C6E5C743A686F73742D636F6E74657874282E6C696E75783A6C616E67286B6F2929207B20666F6E742D66616D696C793A2073797374656D2D75';
wwv_flow_imp.g_varchar2_table(32060) := '692C20225562756E7475222C202244726F69642053616E73222C2022536F757263652048616E2053616E73204B222C2022536F757263652048616E2053616E73204A52222C2022536F757263652048616E2053616E73222C2022556E446F74756D222C20';
wwv_flow_imp.g_varchar2_table(32061) := '22464261656B6D756B2047756C696D222C2073616E732D73657269663B207D5C6E273B6C6574206669653D636C61737320657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E6C61796F7574536572766963';
wwv_flow_imp.g_varchar2_table(32062) := '653D652C746869732E636F6E74657874566965773D746869732E5F7265676973746572286E65772067696528746869732E6C61796F7574536572766963652E6D61696E436F6E7461696E65722C3129292C746869732E6C61796F757428292C746869732E';
wwv_flow_imp.g_varchar2_table(32063) := '5F726567697374657228652E6F6E4469644C61796F7574436F6E7461696E6572282828293D3E746869732E6C61796F757428292929297D73686F77436F6E746578745669657728652C742C6E297B6C657420693B693D743F743D3D3D746869732E6C6179';
wwv_flow_imp.g_varchar2_table(32064) := '6F7574536572766963652E676574436F6E7461696E6572287273287429293F313A6E3F333A323A312C746869732E636F6E74657874566965772E736574436F6E7461696E6572286E756C6C213D743F743A746869732E6C61796F7574536572766963652E';
wwv_flow_imp.g_varchar2_table(32065) := '616374697665436F6E7461696E65722C69292C746869732E636F6E74657874566965772E73686F772865293B636F6E7374206F3D7B636C6F73653A28293D3E7B746869732E6F70656E436F6E74657874566965773D3D3D6F2626746869732E6869646543';
wwv_flow_imp.g_varchar2_table(32066) := '6F6E746578745669657728297D7D3B72657475726E20746869732E6F70656E436F6E74657874566965773D6F2C6F7D6C61796F757428297B746869732E636F6E74657874566965772E6C61796F757428297D68696465436F6E7465787456696577286529';
wwv_flow_imp.g_varchar2_table(32067) := '7B746869732E636F6E74657874566965772E686964652865292C746869732E6F70656E436F6E74657874566965773D766F696420307D7D3B6669653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E67';
wwv_flow_imp.g_varchar2_table(32068) := '74682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(32069) := '3D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628';
wwv_flow_imp.g_varchar2_table(32070) := '723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(32071) := '657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28302C506E65295D2C666965293B636C6173732076696520657874656E6473206669657B676574436F6E7465787456696577456C656D656E7428297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(32072) := '732E636F6E74657874566965772E67657456696577456C656D656E7428297D7D636C617373206269657B636F6E7374727563746F7228652C742C6E297B746869732E686F76657244656C65676174653D652C746869732E7461726765743D742C74686973';
wwv_flow_imp.g_varchar2_table(32073) := '2E66616465496E416E696D6174696F6E3D6E7D6173796E632075706461746528652C742C6E297B76617220693B696628746869732E5F63616E63656C6C6174696F6E546F6B656E536F75726365262628746869732E5F63616E63656C6C6174696F6E546F';
wwv_flow_imp.g_varchar2_table(32074) := '6B656E536F757263652E646973706F7365282130292C746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263653D766F69642030292C746869732E6973446973706F7365642972657475726E3B6C6574206F3B696628766F696420303D3D';
wwv_flow_imp.g_varchar2_table(32075) := '3D657C7C686C2865297C7C6520696E7374616E63656F662048544D4C456C656D656E74296F3D653B656C736520696628436C28652E6D61726B646F776E29297B746869732E5F686F7665725769646765747C7C746869732E73686F77286228302C224C6F';
wwv_flow_imp.g_varchar2_table(32076) := '6164696E672E2E2E22292C74292C746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263653D6E6577204E743B636F6E7374206E3D746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263652E746F6B656E3B6966286F3D';
wwv_flow_imp.g_varchar2_table(32077) := '617761697420652E6D61726B646F776E286E292C766F696420303D3D3D6F2626286F3D652E6D61726B646F776E4E6F74537570706F7274656446616C6C6261636B292C746869732E6973446973706F7365647C7C6E2E697343616E63656C6C6174696F6E';
wwv_flow_imp.g_varchar2_table(32078) := '5265717565737465642972657475726E7D656C7365206F3D6E756C6C213D3D28693D652E6D61726B646F776E292626766F69642030213D3D693F693A652E6D61726B646F776E4E6F74537570706F7274656446616C6C6261636B3B746869732E73686F77';
wwv_flow_imp.g_varchar2_table(32079) := '286F2C742C6E297D73686F7728652C742C6E297B636F6E737420693D746869732E5F686F7665725769646765743B696628746869732E686173436F6E74656E74286529297B636F6E7374206F3D7B636F6E74656E743A652C7461726765743A746869732E';
wwv_flow_imp.g_varchar2_table(32080) := '7461726765742C617070656172616E63653A7B73686F77506F696E7465723A22656C656D656E74223D3D3D746869732E686F76657244656C65676174652E706C6163656D656E742C736B697046616465496E416E696D6174696F6E3A21746869732E6661';
wwv_flow_imp.g_varchar2_table(32081) := '6465496E416E696D6174696F6E7C7C2121697D2C706F736974696F6E3A7B686F766572506F736974696F6E3A327D2C2E2E2E6E7D3B746869732E5F686F7665725769646765743D746869732E686F76657244656C65676174652E73686F77486F76657228';
wwv_flow_imp.g_varchar2_table(32082) := '6F2C74297D6E756C6C3D3D697C7C692E646973706F736528297D686173436F6E74656E742865297B72657475726E212821657C7C7263286529262621652E76616C7565297D676574206973446973706F73656428297B76617220653B72657475726E206E';
wwv_flow_imp.g_varchar2_table(32083) := '756C6C3D3D3D28653D746869732E5F686F766572576964676574297C7C766F696420303D3D3D653F766F696420303A652E6973446973706F7365647D646973706F736528297B76617220652C743B6E756C6C3D3D3D28653D746869732E5F686F76657257';
wwv_flow_imp.g_varchar2_table(32084) := '6964676574297C7C766F696420303D3D3D657C7C652E646973706F736528292C6E756C6C3D3D3D28743D746869732E5F63616E63656C6C6174696F6E546F6B656E536F75726365297C7C766F696420303D3D3D747C7C742E646973706F7365282130292C';
wwv_flow_imp.g_varchar2_table(32085) := '746869732E5F63616E63656C6C6174696F6E546F6B656E536F757263653D766F696420307D7D766172205F69653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574207969653D';
wwv_flow_imp.g_varchar2_table(32086) := '636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E5F696E7374616E74696174696F6E536572766963653D652C746869732E5F6B657962696E64696E6753657276696365';
wwv_flow_imp.g_varchar2_table(32087) := '3D6E2C746869732E5F6C61796F7574536572766963653D692C746869732E5F6163636573736962696C697479536572766963653D6F2C742E6F6E44696453686F77436F6E746578744D656E75282828293D3E746869732E68696465486F76657228292929';
wwv_flow_imp.g_varchar2_table(32088) := '2C746869732E5F636F6E746578745669657748616E646C65723D746869732E5F7265676973746572286E65772066696528746869732E5F6C61796F75745365727669636529297D73686F77486F76657228652C742C6E297B76617220692C6F2C722C613B';
wwv_flow_imp.g_varchar2_table(32089) := '69662877696528746869732E5F63757272656E74486F7665724F7074696F6E73293D3D3D7769652865292972657475726E3B696628746869732E5F63757272656E74486F7665722626286E756C6C3D3D3D286F3D6E756C6C3D3D3D28693D746869732E5F';
wwv_flow_imp.g_varchar2_table(32090) := '63757272656E74486F7665724F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E70657273697374656E6365297C7C766F696420303D3D3D6F3F766F696420303A6F2E737469636B79292972657475726E3B746869732E5F637572';
wwv_flow_imp.g_varchar2_table(32091) := '72656E74486F7665724F7074696F6E733D652C746869732E5F6C617374486F7665724F7074696F6E733D653B636F6E7374206C3D652E74726170466F6375737C7C746869732E5F6163636573736962696C697479536572766963652E697353637265656E';
wwv_flow_imp.g_varchar2_table(32092) := '5265616465724F7074696D697A656428292C633D6A7328293B6E7C7C28746869732E5F6C617374466F6375736564456C656D656E744265666F72654F70656E3D6C2626633F633A766F69642030293B636F6E737420643D6E65772061742C683D74686973';
wwv_flow_imp.g_varchar2_table(32093) := '2E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365286169652C65293B696628286E756C6C3D3D3D28723D652E70657273697374656E6365297C7C766F696420303D3D3D723F766F696420303A722E737469636B';
wwv_flow_imp.g_varchar2_table(32094) := '7929262628682E69734C6F636B65643D2130292C682E6F6E446973706F7365282828293D3E7B76617220742C6E3B286E756C6C3D3D3D28743D746869732E5F63757272656E74486F766572297C7C766F696420303D3D3D743F766F696420303A742E646F';
wwv_flow_imp.g_varchar2_table(32095) := '6D4E6F6465292626247328746869732E5F63757272656E74486F7665722E646F6D4E6F6465292626286E756C6C3D3D3D286E3D746869732E5F6C617374466F6375736564456C656D656E744265666F72654F70656E297C7C766F696420303D3D3D6E7C7C';
wwv_flow_imp.g_varchar2_table(32096) := '6E2E666F6375732829292C746869732E5F63757272656E74486F7665724F7074696F6E733D3D3D65262628746869732E5F63757272656E74486F7665724F7074696F6E733D766F69642030292C642E646973706F736528297D292C766F696420302C6429';
wwv_flow_imp.g_varchar2_table(32097) := '2C21652E636F6E7461696E6572297B636F6E737420743D652E74617267657420696E7374616E63656F662048544D4C456C656D656E743F652E7461726765743A652E7461726765742E746172676574456C656D656E74735B305D3B652E636F6E7461696E';
wwv_flow_imp.g_varchar2_table(32098) := '65723D746869732E5F6C61796F7574536572766963652E676574436F6E7461696E6572287273287429297D696628746869732E5F636F6E746578745669657748616E646C65722E73686F77436F6E7465787456696577286E65772043696528682C74292C';
wwv_flow_imp.g_varchar2_table(32099) := '652E636F6E7461696E6572292C682E6F6E526571756573744C61796F7574282828293D3E746869732E5F636F6E746578745669657748616E646C65722E6C61796F75742829292C766F696420302C64292C6E756C6C3D3D3D28613D652E70657273697374';
wwv_flow_imp.g_varchar2_table(32100) := '656E6365297C7C766F696420303D3D3D613F766F696420303A612E737469636B7929642E61646428627328727328652E636F6E7461696E6572292E646F63756D656E742C61722E4D4F5553455F444F574E2C28653D3E7B427328652E7461726765742C68';
wwv_flow_imp.g_varchar2_table(32101) := '2E646F6D4E6F6465297C7C746869732E646F48696465486F76657228297D2929293B656C73657B69662822746172676574456C656D656E747322696E20652E74617267657429666F7228636F6E73742074206F6620652E7461726765742E746172676574';
wwv_flow_imp.g_varchar2_table(32102) := '456C656D656E747329642E61646428627328742C61722E434C49434B2C2828293D3E746869732E68696465486F76657228292929293B656C736520642E61646428627328652E7461726765742C61722E434C49434B2C2828293D3E746869732E68696465';
wwv_flow_imp.g_varchar2_table(32103) := '486F76657228292929293B636F6E737420743D6A7328293B69662874297B636F6E7374206E3D72732874292E646F63756D656E743B642E61646428627328742C61722E4B45595F444F574E2C28743D3E7B766172206E3B72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(32104) := '6B6579446F776E28742C682C2121286E756C6C3D3D3D286E3D652E70657273697374656E6365297C7C766F696420303D3D3D6E3F766F696420303A6E2E686964654F6E4B6579446F776E29297D2929292C642E616464286273286E2C61722E4B45595F44';
wwv_flow_imp.g_varchar2_table(32105) := '4F574E2C28743D3E7B766172206E3B72657475726E20746869732E5F6B6579446F776E28742C682C2121286E756C6C3D3D3D286E3D652E70657273697374656E6365297C7C766F696420303D3D3D6E3F766F696420303A6E2E686964654F6E4B6579446F';
wwv_flow_imp.g_varchar2_table(32106) := '776E29297D2929292C642E61646428627328742C61722E4B45595F55502C28653D3E746869732E5F6B6579557028652C68292929292C642E616464286273286E2C61722E4B45595F55502C28653D3E746869732E5F6B6579557028652C68292929297D7D';
wwv_flow_imp.g_varchar2_table(32107) := '69662822496E74657273656374696F6E4F6273657276657222696E2073297B636F6E737420743D6E657720496E74657273656374696F6E4F627365727665722828653D3E746869732E5F696E74657273656374696F6E4368616E676528652C6829292C7B';
wwv_flow_imp.g_varchar2_table(32108) := '7468726573686F6C643A307D292C6E3D22746172676574456C656D656E747322696E20652E7461726765743F652E7461726765742E746172676574456C656D656E74735B305D3A652E7461726765743B742E6F627365727665286E292C642E6164642872';
wwv_flow_imp.g_varchar2_table(32109) := '74282828293D3E742E646973636F6E6E65637428292929297D72657475726E20746869732E5F63757272656E74486F7665723D682C687D68696465486F76657228297B76617220653B21286E756C6C3D3D3D28653D746869732E5F63757272656E74486F';
wwv_flow_imp.g_varchar2_table(32110) := '766572297C7C766F696420303D3D3D653F766F696420303A652E69734C6F636B6564292626746869732E5F63757272656E74486F7665724F7074696F6E732626746869732E646F48696465486F76657228297D646F48696465486F76657228297B746869';
wwv_flow_imp.g_varchar2_table(32111) := '732E5F63757272656E74486F7665723D766F696420302C746869732E5F63757272656E74486F7665724F7074696F6E733D766F696420302C746869732E5F636F6E746578745669657748616E646C65722E68696465436F6E746578745669657728297D5F';
wwv_flow_imp.g_varchar2_table(32112) := '696E74657273656374696F6E4368616E676528652C74297B655B652E6C656E6774682D315D2E6973496E74657273656374696E677C7C742E646973706F736528297D73686F77416E64466F6375734C617374486F76657228297B746869732E5F6C617374';
wwv_flow_imp.g_varchar2_table(32113) := '486F7665724F7074696F6E732626746869732E73686F77486F76657228746869732E5F6C617374486F7665724F7074696F6E732C21302C2130297D5F6B6579446F776E28652C742C6E297B76617220692C6F3B69662822416C74223D3D3D652E6B657929';
wwv_flow_imp.g_varchar2_table(32114) := '72657475726E20766F696428742E69734C6F636B65643D2130293B636F6E737420733D6E65772071652865293B746869732E5F6B657962696E64696E67536572766963652E7265736F6C76654B6579626F6172644576656E742873292E67657453696E67';
wwv_flow_imp.g_varchar2_table(32115) := '6C654D6F646966696572446973706174636843686F72647328292E736F6D652828653D3E21216529297C7C30213D3D746869732E5F6B657962696E64696E67536572766963652E736F6674446973706174636828732C732E746172676574292E6B696E64';
wwv_flow_imp.g_varchar2_table(32116) := '7C7C216E7C7C286E756C6C3D3D3D28693D746869732E5F63757272656E74486F7665724F7074696F6E73297C7C766F696420303D3D3D693F766F696420303A692E74726170466F63757329262622546162223D3D3D652E6B65797C7C28746869732E6869';
wwv_flow_imp.g_varchar2_table(32117) := '6465486F76657228292C6E756C6C3D3D3D286F3D746869732E5F6C617374466F6375736564456C656D656E744265666F72654F70656E297C7C766F696420303D3D3D6F7C7C6F2E666F6375732829297D5F6B6579557028652C74297B766172206E3B2241';
wwv_flow_imp.g_varchar2_table(32118) := '6C74223D3D3D652E6B6579262628742E69734C6F636B65643D21312C742E69734D6F757365496E7C7C28746869732E68696465486F76657228292C6E756C6C3D3D3D286E3D746869732E5F6C617374466F6375736564456C656D656E744265666F72654F';
wwv_flow_imp.g_varchar2_table(32119) := '70656E297C7C766F696420303D3D3D6E7C7C6E2E666F637573282929297D7365747570557064617461626C65486F76657228652C742C6E2C69297B6C6574206F2C733B742E7365744174747269627574652822637573746F6D2D686F766572222C227472';
wwv_flow_imp.g_varchar2_table(32120) := '756522292C2222213D3D742E7469746C65262628636F6E736F6C652E7761726E282248544D4C20656C656D656E7420616C7265616479206861732061207469746C65206174747269627574652C2077686963682077696C6C20636F6E666C696374207769';
wwv_flow_imp.g_varchar2_table(32121) := '74682074686520637573746F6D20686F7665722E20506C656173652072656D6F766520746865207469746C65206174747269627574652E22292C636F6E736F6C652E74726163652822537461636B2074726163653A222C742E7469746C65292C742E7469';
wwv_flow_imp.g_varchar2_table(32122) := '746C653D2222293B636F6E737420723D28742C6E293D3E7B76617220693B636F6E737420723D766F69642030213D3D733B742626286E756C6C3D3D737C7C732E646973706F736528292C733D766F69642030292C6E2626286E756C6C3D3D6F7C7C6F2E64';
wwv_flow_imp.g_varchar2_table(32123) := '6973706F736528292C6F3D766F69642030292C722626286E756C6C3D3D3D28693D652E6F6E44696448696465486F766572297C7C766F696420303D3D3D697C7C692E63616C6C2865292C733D766F69642030297D2C613D286F2C722C61293D3E6E657720';
wwv_flow_imp.g_varchar2_table(32124) := '247428286173796E6328293D3E7B73262621732E6973446973706F7365647C7C28733D6E65772062696528652C617C7C742C6F3E30292C617761697420732E757064617465282266756E6374696F6E223D3D747970656F66206E3F6E28293A6E2C722C69';
wwv_flow_imp.g_varchar2_table(32125) := '29297D292C6F293B6C6574206C3D21313B636F6E737420633D627328742C61722E4D4F5553455F444F574E2C2828293D3E7B6C3D21302C722821302C2130297D292C2130292C643D627328742C61722E4D4F5553455F55502C2828293D3E7B6C3D21317D';
wwv_flow_imp.g_varchar2_table(32126) := '292C2130292C683D627328742C61722E4D4F5553455F4C454156452C28653D3E7B6C3D21312C722821312C652E66726F6D456C656D656E743D3D3D74297D292C2130292C753D627328742C61722E4D4F5553455F4F5645522C286E3D3E7B6966286F2972';
wwv_flow_imp.g_varchar2_table(32127) := '657475726E3B636F6E737420693D6E65772061742C733D7B746172676574456C656D656E74733A5B745D2C646973706F73653A28293D3E7B7D7D3B696628766F696420303D3D3D652E706C6163656D656E747C7C226D6F757365223D3D3D652E706C6163';
wwv_flow_imp.g_varchar2_table(32128) := '656D656E74297B636F6E737420653D653D3E7B732E783D652E782B31302C652E74617267657420696E7374616E63656F662048544D4C456C656D656E74262653696528652E7461726765742C7429213D3D742626722821302C2130297D3B692E61646428';
wwv_flow_imp.g_varchar2_table(32129) := '627328742C61722E4D4F5553455F4D4F56452C652C213029297D6F3D692C6E2E74617267657420696E7374616E63656F662048544D4C456C656D656E742626536965286E2E7461726765742C7429213D3D747C7C692E616464286128652E64656C61792C';
wwv_flow_imp.g_varchar2_table(32130) := '21312C7329297D292C2130293B6C657420703B636F6E737420673D742E7461674E616D652E746F4C6F7765724361736528293B72657475726E22696E70757422213D3D67262622746578746172656122213D3D67262628703D627328742C61722E464F43';
wwv_flow_imp.g_varchar2_table(32131) := '55532C2828293D3E7B6966286C7C7C6F2972657475726E3B636F6E7374206E3D7B746172676574456C656D656E74733A5B745D2C646973706F73653A28293D3E7B7D7D2C693D6E65772061743B692E61646428627328742C61722E424C55522C2828293D';
wwv_flow_imp.g_varchar2_table(32132) := '3E722821302C213029292C213029292C692E616464286128652E64656C61792C21312C6E29292C6F3D697D292C213029292C7B73686F773A653D3E7B722821312C2130292C6128302C65297D2C686964653A28293D3E7B722821302C2130297D2C757064';
wwv_flow_imp.g_varchar2_table(32133) := '6174653A6173796E6328652C74293D3E7B6E3D652C6177616974286E756C6C3D3D733F766F696420303A732E757064617465286E2C766F696420302C7429297D2C646973706F73653A28293D3E7B752E646973706F736528292C682E646973706F736528';
wwv_flow_imp.g_varchar2_table(32134) := '292C632E646973706F736528292C642E646973706F736528292C6E756C6C3D3D707C7C702E646973706F736528292C722821302C2130297D7D7D7D3B66756E6374696F6E207769652865297B76617220743B696628766F69642030213D3D652972657475';
wwv_flow_imp.g_varchar2_table(32135) := '726E206E756C6C213D3D28743D6E756C6C3D3D653F766F696420303A652E6964292626766F69642030213D3D743F743A657D7969653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D73';
wwv_flow_imp.g_varchar2_table(32136) := '3C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(32137) := '6F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C33';
wwv_flow_imp.g_varchar2_table(32138) := '3F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B5F696528302C7563292C5F696528312C7145292C5F';
wwv_flow_imp.g_varchar2_table(32139) := '696528322C2445292C5F696528332C506E65292C5F696528342C5953295D2C796965293B636C617373204369657B67657420616E63686F72506F736974696F6E28297B72657475726E20746869732E5F686F7665722E616E63686F727D636F6E73747275';
wwv_flow_imp.g_varchar2_table(32140) := '63746F7228652C743D2131297B746869732E5F686F7665723D652C746869732E5F666F6375733D742C746869732E6C617965723D317D72656E6465722865297B72657475726E20746869732E5F686F7665722E72656E6465722865292C746869732E5F66';
wwv_flow_imp.g_varchar2_table(32141) := '6F6375732626746869732E5F686F7665722E666F63757328292C746869732E5F686F7665727D676574416E63686F7228297B72657475726E7B783A746869732E5F686F7665722E782C793A746869732E5F686F7665722E797D7D6C61796F757428297B74';
wwv_flow_imp.g_varchar2_table(32142) := '6869732E5F686F7665722E6C61796F757428297D7D66756E6374696F6E2053696528652C74297B666F7228743D6E756C6C213D743F743A72732865292E646F63756D656E742E626F64793B21652E6861734174747269627574652822637573746F6D2D68';
wwv_flow_imp.g_varchar2_table(32143) := '6F7665722229262665213D3D743B29653D652E706172656E74456C656D656E743B72657475726E20657D66756E6374696F6E207869652865297B72657475726E204F626A6563742E697346726F7A656E2865293F653A66756E6374696F6E2865297B6966';
wwv_flow_imp.g_varchar2_table(32144) := '2821657C7C226F626A65637422213D747970656F6620652972657475726E20653B636F6E737420743D5B655D3B666F72283B742E6C656E6774683E303B297B636F6E737420653D742E736869667428293B4F626A6563742E667265657A652865293B666F';
wwv_flow_imp.g_varchar2_table(32145) := '7228636F6E7374206E20696E20652969662876682E63616C6C28652C6E29297B636F6E737420693D655B6E5D3B226F626A65637422213D747970656F6620697C7C4F626A6563742E697346726F7A656E2869297C7C706C2869297C7C742E707573682869';
wwv_flow_imp.g_varchar2_table(32146) := '297D7D72657475726E20657D2865297D78702849712C7969652C31292C5662282828652C74293D3E7B636F6E7374206E3D652E676574436F6C6F72285F66293B6E262628742E61646452756C6528602E6D6F6E61636F2D776F726B62656E6368202E776F';
wwv_flow_imp.g_varchar2_table(32147) := '726B62656E63682D686F766572202E686F7665722D726F773A6E6F74283A66697273742D6368696C64293A6E6F74283A656D70747929207B20626F726465722D746F703A2031707820736F6C696420247B6E2E7472616E73706172656E74282E35297D3B';
wwv_flow_imp.g_varchar2_table(32148) := '207D60292C742E61646452756C6528602E6D6F6E61636F2D776F726B62656E6368202E776F726B62656E63682D686F766572206872207B20626F726465722D746F703A2031707820736F6C696420247B6E2E7472616E73706172656E74282E35297D3B20';
wwv_flow_imp.g_varchar2_table(32149) := '7D6029297D29293B636C617373206B69657B73746174696320637265617465456D7074794D6F64656C2865297B72657475726E206E6577206B6965287B7D2C5B5D2C5B5D2C766F696420302C65297D636F6E7374727563746F7228652C742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(32150) := '297B746869732E5F636F6E74656E74733D652C746869732E5F6B6579733D742C746869732E5F6F76657272696465733D6E2C746869732E7261773D692C746869732E6C6F67536572766963653D6F2C746869732E6F76657272696465436F6E6669677572';
wwv_flow_imp.g_varchar2_table(32151) := '6174696F6E733D6E6577204D61707D67657420726177436F6E66696775726174696F6E28297B76617220653B69662821746869732E5F726177436F6E66696775726174696F6E296966286E756C6C3D3D3D28653D746869732E726177297C7C766F696420';
wwv_flow_imp.g_varchar2_table(32152) := '303D3D3D653F766F696420303A652E6C656E677468297B636F6E737420653D746869732E7261772E6D61702828653D3E7B6966286520696E7374616E63656F66206B69652972657475726E20653B636F6E737420743D6E6577204569652822222C746869';
wwv_flow_imp.g_varchar2_table(32153) := '732E6C6F6753657276696365293B72657475726E20742E70617273655261772865292C742E636F6E66696775726174696F6E4D6F64656C7D29293B746869732E5F726177436F6E66696775726174696F6E3D652E726564756365282828652C74293D3E74';
wwv_flow_imp.g_varchar2_table(32154) := '3D3D3D653F743A652E6D65726765287429292C655B305D297D656C736520746869732E5F726177436F6E66696775726174696F6E3D746869733B72657475726E20746869732E5F726177436F6E66696775726174696F6E7D67657420636F6E74656E7473';
wwv_flow_imp.g_varchar2_table(32155) := '28297B72657475726E20746869732E5F636F6E74656E74737D676574206F766572726964657328297B72657475726E20746869732E5F6F76657272696465737D676574206B65797328297B72657475726E20746869732E5F6B6579737D6973456D707479';
wwv_flow_imp.g_varchar2_table(32156) := '28297B72657475726E20303D3D3D746869732E5F6B6579732E6C656E6774682626303D3D3D4F626A6563742E6B65797328746869732E5F636F6E74656E7473292E6C656E6774682626303D3D3D746869732E5F6F76657272696465732E6C656E6774687D';
wwv_flow_imp.g_varchar2_table(32157) := '67657456616C75652865297B72657475726E20653F777028746869732E636F6E74656E74732C65293A746869732E636F6E74656E74737D696E737065637428652C74297B636F6E7374206E3D746869733B72657475726E7B6765742076616C756528297B';
wwv_flow_imp.g_varchar2_table(32158) := '72657475726E20786965286E2E726177436F6E66696775726174696F6E2E67657456616C7565286529297D2C676574206F7665727269646528297B72657475726E20743F786965286E2E726177436F6E66696775726174696F6E2E6765744F7665727269';
wwv_flow_imp.g_varchar2_table(32159) := '646556616C756528652C7429293A766F696420307D2C676574206D657267656428297B72657475726E2078696528743F6E2E726177436F6E66696775726174696F6E2E6F766572726964652874292E67657456616C75652865293A6E2E726177436F6E66';
wwv_flow_imp.g_varchar2_table(32160) := '696775726174696F6E2E67657456616C7565286529297D2C676574206F766572726964657328297B636F6E737420743D5B5D3B666F7228636F6E73747B636F6E74656E74733A692C6964656E746966696572733A6F2C6B6579733A737D6F66206E2E7261';
wwv_flow_imp.g_varchar2_table(32161) := '77436F6E66696775726174696F6E2E6F7665727269646573297B636F6E737420723D6E6577206B696528692C732C5B5D2C766F696420302C6E2E6C6F6753657276696365292E67657456616C75652865293B766F69642030213D3D722626742E70757368';
wwv_flow_imp.g_varchar2_table(32162) := '287B6964656E746966696572733A6F2C76616C75653A727D297D72657475726E20742E6C656E6774683F7869652874293A766F696420307D7D7D6765744F7665727269646556616C756528652C74297B636F6E7374206E3D746869732E676574436F6E74';
wwv_flow_imp.g_varchar2_table(32163) := '656E7473466F724F766572726964654964656E74696665722874293B72657475726E206E3F653F7770286E2C65293A6E3A766F696420307D6F766572726964652865297B6C657420743D746869732E6F76657272696465436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(32164) := '732E6765742865293B72657475726E20747C7C28743D746869732E6372656174654F76657272696465436F6E66696775726174696F6E4D6F64656C2865292C746869732E6F76657272696465436F6E66696775726174696F6E732E73657428652C742929';
wwv_flow_imp.g_varchar2_table(32165) := '2C747D6D65726765282E2E2E65297B76617220742C6E3B636F6E737420693D666828746869732E636F6E74656E7473292C6F3D666828746869732E6F7665727269646573292C733D5B2E2E2E746869732E6B6579735D2C723D286E756C6C3D3D3D28743D';
wwv_flow_imp.g_varchar2_table(32166) := '746869732E726177297C7C766F696420303D3D3D743F766F696420303A742E6C656E677468293F5B2E2E2E746869732E7261775D3A5B746869735D3B666F7228636F6E73742074206F66206529696628722E70757368282E2E2E286E756C6C3D3D3D286E';
wwv_flow_imp.g_varchar2_table(32167) := '3D742E726177297C7C766F696420303D3D3D6E3F766F696420303A6E2E6C656E677468293F742E7261773A5B745D292C21742E6973456D7074792829297B746869732E6D65726765436F6E74656E747328692C742E636F6E74656E7473293B666F722863';
wwv_flow_imp.g_varchar2_table(32168) := '6F6E73742065206F6620742E6F7665727269646573297B636F6E73745B745D3D6F2E66696C7465722828743D3E506828742E6964656E746966696572732C652E6964656E746966696572732929293B743F28746869732E6D65726765436F6E74656E7473';
wwv_flow_imp.g_varchar2_table(32169) := '28742E636F6E74656E74732C652E636F6E74656E7473292C742E6B6579732E70757368282E2E2E652E6B657973292C742E6B6579733D716828742E6B65797329293A6F2E70757368286668286529297D666F7228636F6E73742065206F6620742E6B6579';
wwv_flow_imp.g_varchar2_table(32170) := '73292D313D3D3D732E696E6465784F662865292626732E707573682865297D72657475726E206E6577206B696528692C732C6F2C722E65766572792828653D3E6520696E7374616E63656F66206B696529293F766F696420303A722C746869732E6C6F67';
wwv_flow_imp.g_varchar2_table(32171) := '53657276696365297D6372656174654F76657272696465436F6E66696775726174696F6E4D6F64656C2865297B636F6E737420743D746869732E676574436F6E74656E7473466F724F766572726964654964656E74696665722865293B69662821747C7C';
wwv_flow_imp.g_varchar2_table(32172) := '226F626A65637422213D747970656F6620747C7C214F626A6563742E6B6579732874292E6C656E6774682972657475726E20746869733B636F6E7374206E3D7B7D3B666F7228636F6E73742065206F66207168285B2E2E2E4F626A6563742E6B65797328';
wwv_flow_imp.g_varchar2_table(32173) := '746869732E636F6E74656E7473292C2E2E2E4F626A6563742E6B6579732874295D29297B6C657420693D746869732E636F6E74656E74735B655D3B636F6E7374206F3D745B655D3B6F262628226F626A656374223D3D747970656F6620692626226F626A';
wwv_flow_imp.g_varchar2_table(32174) := '656374223D3D747970656F66206F3F28693D66682869292C746869732E6D65726765436F6E74656E747328692C6F29293A693D6F292C6E5B655D3D697D72657475726E206E6577206B6965286E2C746869732E6B6579732C746869732E6F766572726964';
wwv_flow_imp.g_varchar2_table(32175) := '65732C766F696420302C746869732E6C6F6753657276696365297D6D65726765436F6E74656E747328652C74297B666F7228636F6E7374206E206F66204F626A6563742E6B657973287429296E20696E20652626756C28655B6E5D292626756C28745B6E';
wwv_flow_imp.g_varchar2_table(32176) := '5D293F746869732E6D65726765436F6E74656E747328655B6E5D2C745B6E5D293A655B6E5D3D666828745B6E5D297D676574436F6E74656E7473466F724F766572726964654964656E74696665722865297B6C657420743D6E756C6C2C6E3D6E756C6C3B';
wwv_flow_imp.g_varchar2_table(32177) := '636F6E737420693D653D3E7B652626286E3F746869732E6D65726765436F6E74656E7473286E2C65293A6E3D6668286529297D3B666F7228636F6E7374206E206F6620746869732E6F766572726964657329313D3D3D6E2E6964656E746966696572732E';
wwv_flow_imp.g_varchar2_table(32178) := '6C656E67746826266E2E6964656E746966696572735B305D3D3D3D653F743D6E2E636F6E74656E74733A6E2E6964656E746966696572732E696E636C75646573286529262669286E2E636F6E74656E7473293B72657475726E20692874292C6E7D746F4A';
wwv_flow_imp.g_varchar2_table(32179) := '534F4E28297B72657475726E7B636F6E74656E74733A746869732E636F6E74656E74732C6F76657272696465733A746869732E6F76657272696465732C6B6579733A746869732E6B6579737D7D61646456616C756528652C74297B746869732E75706461';
wwv_flow_imp.g_varchar2_table(32180) := '746556616C756528652C742C2130297D73657456616C756528652C74297B746869732E75706461746556616C756528652C742C2131297D72656D6F766556616C75652865297B636F6E737420743D746869732E6B6579732E696E6465784F662865293B2D';
wwv_flow_imp.g_varchar2_table(32181) := '31213D3D74262628746869732E6B6579732E73706C69636528742C31292C5F7028746869732E636F6E74656E74732C65292C48702E746573742865292626746869732E6F76657272696465732E73706C69636528746869732E6F76657272696465732E66';
wwv_flow_imp.g_varchar2_table(32182) := '696E64496E6465782828743D3E506828742E6964656E746966696572732C57702865292929292C3129297D75706461746556616C756528652C742C6E297B627028746869732E636F6E74656E74732C652C742C28653D3E746869732E6C6F675365727669';
wwv_flow_imp.g_varchar2_table(32183) := '63652E6572726F7228652929292C286E3D6E7C7C2D313D3D3D746869732E6B6579732E696E6465784F66286529292626746869732E6B6579732E707573682865292C48702E746573742865292626746869732E6F76657272696465732E70757368287B69';
wwv_flow_imp.g_varchar2_table(32184) := '64656E746966696572733A57702865292C6B6579733A4F626A6563742E6B65797328746869732E636F6E74656E74735B655D292C636F6E74656E74733A767028746869732E636F6E74656E74735B655D2C28653D3E746869732E6C6F6753657276696365';
wwv_flow_imp.g_varchar2_table(32185) := '2E6572726F7228652929297D297D7D636C617373204569657B636F6E7374727563746F7228652C74297B746869732E5F6E616D653D652C746869732E6C6F67536572766963653D742C746869732E5F7261773D6E756C6C2C746869732E5F636F6E666967';
wwv_flow_imp.g_varchar2_table(32186) := '75726174696F6E4D6F64656C3D6E756C6C2C746869732E5F72657374726963746564436F6E66696775726174696F6E733D5B5D7D67657420636F6E66696775726174696F6E4D6F64656C28297B72657475726E20746869732E5F636F6E66696775726174';
wwv_flow_imp.g_varchar2_table(32187) := '696F6E4D6F64656C7C7C6B69652E637265617465456D7074794D6F64656C28746869732E6C6F6753657276696365297D706172736552617728652C74297B746869732E5F7261773D653B636F6E73747B636F6E74656E74733A6E2C6B6579733A692C6F76';
wwv_flow_imp.g_varchar2_table(32188) := '657272696465733A6F2C726573747269637465643A732C6861734578636C7564656450726F706572746965733A727D3D746869732E646F506172736552617728652C74293B746869732E5F636F6E66696775726174696F6E4D6F64656C3D6E6577206B69';
wwv_flow_imp.g_varchar2_table(32189) := '65286E2C692C6F2C723F5B655D3A766F696420302C746869732E6C6F6753657276696365292C746869732E5F72657374726963746564436F6E66696775726174696F6E733D737C7C5B5D7D646F506172736552617728652C74297B636F6E7374206E3D79';
wwv_flow_imp.g_varchar2_table(32190) := '642E6173285470292E676574436F6E66696775726174696F6E50726F7065727469657328292C693D746869732E66696C74657228652C6E2C21302C74293B72657475726E7B636F6E74656E74733A767028653D692E7261772C28653D3E746869732E6C6F';
wwv_flow_imp.g_varchar2_table(32191) := '67536572766963652E6572726F722860436F6E666C69637420696E2073657474696E67732066696C6520247B746869732E5F6E616D657D3A20247B657D602929292C6B6579733A4F626A6563742E6B6579732865292C6F76657272696465733A74686973';
wwv_flow_imp.g_varchar2_table(32192) := '2E746F4F766572726964657328652C28653D3E746869732E6C6F67536572766963652E6572726F722860436F6E666C69637420696E2073657474696E67732066696C6520247B746869732E5F6E616D657D3A20247B657D602929292C7265737472696374';
wwv_flow_imp.g_varchar2_table(32193) := '65643A692E726573747269637465642C6861734578636C7564656450726F706572746965733A692E6861734578636C7564656450726F706572746965737D7D66696C74657228652C742C6E2C69297B766172206F2C732C723B6C657420613D21313B6966';
wwv_flow_imp.g_varchar2_table(32194) := '2821286E756C6C3D3D693F766F696420303A692E73636F70657329262621286E756C6C3D3D693F766F696420303A692E736B69705265737472696374656429262621286E756C6C3D3D3D286F3D6E756C6C3D3D693F766F696420303A692E6578636C7564';
wwv_flow_imp.g_varchar2_table(32195) := '65297C7C766F696420303D3D3D6F3F766F696420303A6F2E6C656E677468292972657475726E7B7261773A652C726573747269637465643A5B5D2C6861734578636C7564656450726F706572746965733A617D3B636F6E7374206C3D7B7D2C633D5B5D3B';
wwv_flow_imp.g_varchar2_table(32196) := '666F7228636F6E7374206F20696E20652969662848702E74657374286F2926266E297B636F6E7374206E3D746869732E66696C74657228655B6F5D2C742C21312C69293B6C5B6F5D3D6E2E7261772C613D617C7C6E2E6861734578636C7564656450726F';
wwv_flow_imp.g_varchar2_table(32197) := '706572746965732C632E70757368282E2E2E6E2E72657374726963746564297D656C73657B636F6E7374206E3D745B6F5D2C643D6E3F766F69642030213D3D6E2E73636F70653F6E2E73636F70653A333A766F696420303B286E756C6C3D3D6E3F766F69';
wwv_flow_imp.g_varchar2_table(32198) := '6420303A6E2E72657374726963746564292626632E70757368286F292C286E756C6C3D3D3D28733D692E6578636C756465297C7C766F696420303D3D3D733F766F696420303A732E696E636C75646573286F29297C7C21286E756C6C3D3D3D28723D692E';
wwv_flow_imp.g_varchar2_table(32199) := '696E636C756465297C7C766F696420303D3D3D723F766F696420303A722E696E636C75646573286F2929262628766F69642030213D3D642626766F69642030213D3D692E73636F706573262621692E73636F7065732E696E636C756465732864297C7C69';
wwv_flow_imp.g_varchar2_table(32200) := '2E736B6970526573747269637465642626286E756C6C3D3D6E3F766F696420303A6E2E7265737472696374656429293F613D21303A6C5B6F5D3D655B6F5D7D72657475726E7B7261773A6C2C726573747269637465643A632C6861734578636C75646564';
wwv_flow_imp.g_varchar2_table(32201) := '50726F706572746965733A617D7D746F4F766572726964657328652C74297B636F6E7374206E3D5B5D3B666F7228636F6E73742069206F66204F626A6563742E6B6579732865292969662848702E74657374286929297B636F6E7374206F3D7B7D3B666F';
wwv_flow_imp.g_varchar2_table(32202) := '7228636F6E7374207420696E20655B695D296F5B745D3D655B695D5B745D3B6E2E70757368287B6964656E746966696572733A57702869292C6B6579733A4F626A6563742E6B657973286F292C636F6E74656E74733A7670286F2C74297D297D72657475';
wwv_flow_imp.g_varchar2_table(32203) := '726E206E7D7D636C617373204C69657B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C75297B746869732E6B65793D652C746869732E6F76657272696465733D742C746869732E5F76616C75653D6E2C746869';
wwv_flow_imp.g_varchar2_table(32204) := '732E6F766572726964654964656E746966696572733D692C746869732E64656661756C74436F6E66696775726174696F6E3D6F2C746869732E706F6C696379436F6E66696775726174696F6E3D732C746869732E6170706C69636174696F6E436F6E6669';
wwv_flow_imp.g_varchar2_table(32205) := '6775726174696F6E3D722C746869732E75736572436F6E66696775726174696F6E3D612C746869732E6C6F63616C55736572436F6E66696775726174696F6E3D6C2C746869732E72656D6F746555736572436F6E66696775726174696F6E3D632C746869';
wwv_flow_imp.g_varchar2_table(32206) := '732E776F726B7370616365436F6E66696775726174696F6E3D642C746869732E666F6C646572436F6E66696775726174696F6E4D6F64656C3D682C746869732E6D656D6F7279436F6E66696775726174696F6E4D6F64656C3D757D746F496E7370656374';
wwv_flow_imp.g_varchar2_table(32207) := '56616C75652865297B72657475726E20766F69642030213D3D286E756C6C3D3D653F766F696420303A652E76616C7565297C7C766F69642030213D3D286E756C6C3D3D653F766F696420303A652E6F76657272696465297C7C766F69642030213D3D286E';
wwv_flow_imp.g_varchar2_table(32208) := '756C6C3D3D653F766F696420303A652E6F7665727269646573293F653A766F696420307D6765742075736572496E737065637456616C756528297B72657475726E20746869732E5F75736572496E737065637456616C75657C7C28746869732E5F757365';
wwv_flow_imp.g_varchar2_table(32209) := '72496E737065637456616C75653D746869732E75736572436F6E66696775726174696F6E2E696E737065637428746869732E6B65792C746869732E6F76657272696465732E6F766572726964654964656E74696669657229292C746869732E5F75736572';
wwv_flow_imp.g_varchar2_table(32210) := '496E737065637456616C75657D676574207573657228297B72657475726E20746869732E746F496E737065637456616C756528746869732E75736572496E737065637456616C7565297D7D636C617373204469657B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(32211) := '2C6E2C692C6F2C732C722C612C6C2C63297B746869732E5F64656661756C74436F6E66696775726174696F6E3D652C746869732E5F706F6C696379436F6E66696775726174696F6E3D742C746869732E5F6170706C69636174696F6E436F6E6669677572';
wwv_flow_imp.g_varchar2_table(32212) := '6174696F6E3D6E2C746869732E5F6C6F63616C55736572436F6E66696775726174696F6E3D692C746869732E5F72656D6F746555736572436F6E66696775726174696F6E3D6F2C746869732E5F776F726B7370616365436F6E66696775726174696F6E3D';
wwv_flow_imp.g_varchar2_table(32213) := '732C746869732E5F666F6C646572436F6E66696775726174696F6E733D722C746869732E5F6D656D6F7279436F6E66696775726174696F6E3D612C746869732E5F6D656D6F7279436F6E66696775726174696F6E42795265736F757263653D6C2C746869';
wwv_flow_imp.g_varchar2_table(32214) := '732E6C6F67536572766963653D632C746869732E5F776F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E3D6E756C6C2C746869732E5F666F6C64657273436F6E736F6C696461746564436F6E66696775726174696F6E73';
wwv_flow_imp.g_varchar2_table(32215) := '3D6E6577206F612C746869732E5F75736572436F6E66696775726174696F6E3D6E756C6C7D67657456616C756528652C742C6E297B72657475726E20746869732E676574436F6E736F6C696461746564436F6E66696775726174696F6E4D6F64656C2865';
wwv_flow_imp.g_varchar2_table(32216) := '2C742C6E292E67657456616C75652865297D75706461746556616C756528652C742C6E3D7B7D297B6C657420693B6E2E7265736F757263653F28693D746869732E5F6D656D6F7279436F6E66696775726174696F6E42795265736F757263652E67657428';
wwv_flow_imp.g_varchar2_table(32217) := '6E2E7265736F75726365292C697C7C28693D6B69652E637265617465456D7074794D6F64656C28746869732E6C6F6753657276696365292C746869732E5F6D656D6F7279436F6E66696775726174696F6E42795265736F757263652E736574286E2E7265';
wwv_flow_imp.g_varchar2_table(32218) := '736F757263652C692929293A693D746869732E5F6D656D6F7279436F6E66696775726174696F6E2C766F696420303D3D3D743F692E72656D6F766556616C75652865293A692E73657456616C756528652C74292C6E2E7265736F757263657C7C28746869';
wwv_flow_imp.g_varchar2_table(32219) := '732E5F776F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E3D6E756C6C297D696E737065637428652C742C6E297B636F6E737420693D746869732E676574436F6E736F6C696461746564436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(32220) := '4D6F64656C28652C742C6E292C6F3D746869732E676574466F6C646572436F6E66696775726174696F6E4D6F64656C466F725265736F7572636528742E7265736F757263652C6E292C733D742E7265736F757263652626746869732E5F6D656D6F727943';
wwv_flow_imp.g_varchar2_table(32221) := '6F6E66696775726174696F6E42795265736F757263652E67657428742E7265736F75726365297C7C746869732E5F6D656D6F7279436F6E66696775726174696F6E2C723D6E6577205365743B666F7228636F6E73742074206F6620692E6F766572726964';
wwv_flow_imp.g_varchar2_table(32222) := '657329666F7228636F6E7374206E206F6620742E6964656E7469666965727329766F69642030213D3D692E6765744F7665727269646556616C756528652C6E292626722E616464286E293B72657475726E206E6577204C696528652C742C692E67657456';
wwv_flow_imp.g_varchar2_table(32223) := '616C75652865292C722E73697A653F5B2E2E2E725D3A766F696420302C746869732E5F64656661756C74436F6E66696775726174696F6E2C746869732E5F706F6C696379436F6E66696775726174696F6E2E6973456D70747928293F766F696420303A74';
wwv_flow_imp.g_varchar2_table(32224) := '6869732E5F706F6C696379436F6E66696775726174696F6E2C746869732E6170706C69636174696F6E436F6E66696775726174696F6E2E6973456D70747928293F766F696420303A746869732E6170706C69636174696F6E436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(32225) := '6E2C746869732E75736572436F6E66696775726174696F6E2C746869732E6C6F63616C55736572436F6E66696775726174696F6E2C746869732E72656D6F746555736572436F6E66696775726174696F6E2C6E3F746869732E5F776F726B737061636543';
wwv_flow_imp.g_varchar2_table(32226) := '6F6E66696775726174696F6E3A766F696420302C6F7C7C766F696420302C73297D676574206170706C69636174696F6E436F6E66696775726174696F6E28297B72657475726E20746869732E5F6170706C69636174696F6E436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(32227) := '6E7D6765742075736572436F6E66696775726174696F6E28297B72657475726E20746869732E5F75736572436F6E66696775726174696F6E7C7C28746869732E5F75736572436F6E66696775726174696F6E3D746869732E5F72656D6F74655573657243';
wwv_flow_imp.g_varchar2_table(32228) := '6F6E66696775726174696F6E2E6973456D70747928293F746869732E5F6C6F63616C55736572436F6E66696775726174696F6E3A746869732E5F6C6F63616C55736572436F6E66696775726174696F6E2E6D6572676528746869732E5F72656D6F746555';
wwv_flow_imp.g_varchar2_table(32229) := '736572436F6E66696775726174696F6E29292C746869732E5F75736572436F6E66696775726174696F6E7D676574206C6F63616C55736572436F6E66696775726174696F6E28297B72657475726E20746869732E5F6C6F63616C55736572436F6E666967';
wwv_flow_imp.g_varchar2_table(32230) := '75726174696F6E7D6765742072656D6F746555736572436F6E66696775726174696F6E28297B72657475726E20746869732E5F72656D6F746555736572436F6E66696775726174696F6E7D676574436F6E736F6C696461746564436F6E66696775726174';
wwv_flow_imp.g_varchar2_table(32231) := '696F6E4D6F64656C28652C742C6E297B6C657420693D746869732E676574436F6E736F6C696461746564436F6E66696775726174696F6E4D6F64656C466F725265736F7572636528742C6E293B72657475726E20742E6F766572726964654964656E7469';
wwv_flow_imp.g_varchar2_table(32232) := '66696572262628693D692E6F7665727269646528742E6F766572726964654964656E74696669657229292C746869732E5F706F6C696379436F6E66696775726174696F6E2E6973456D70747928297C7C766F696420303D3D3D746869732E5F706F6C6963';
wwv_flow_imp.g_varchar2_table(32233) := '79436F6E66696775726174696F6E2E67657456616C75652865297C7C28693D692E6D6572676528746869732E5F706F6C696379436F6E66696775726174696F6E29292C697D676574436F6E736F6C696461746564436F6E66696775726174696F6E4D6F64';
wwv_flow_imp.g_varchar2_table(32234) := '656C466F725265736F75726365287B7265736F757263653A657D2C74297B6C6574206E3D746869732E676574576F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E28293B69662874262665297B636F6E737420693D742E';
wwv_flow_imp.g_varchar2_table(32235) := '676574466F6C6465722865293B692626286E3D746869732E676574466F6C646572436F6E736F6C696461746564436F6E66696775726174696F6E28692E757269297C7C6E293B636F6E7374206F3D746869732E5F6D656D6F7279436F6E66696775726174';
wwv_flow_imp.g_varchar2_table(32236) := '696F6E42795265736F757263652E6765742865293B6F2626286E3D6E2E6D65726765286F29297D72657475726E206E7D676574576F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E28297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(32237) := '5F776F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E7C7C28746869732E5F776F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E3D746869732E5F64656661756C74436F6E6669677572';
wwv_flow_imp.g_varchar2_table(32238) := '6174696F6E2E6D6572676528746869732E6170706C69636174696F6E436F6E66696775726174696F6E2C746869732E75736572436F6E66696775726174696F6E2C746869732E5F776F726B7370616365436F6E66696775726174696F6E2C746869732E5F';
wwv_flow_imp.g_varchar2_table(32239) := '6D656D6F7279436F6E66696775726174696F6E29292C746869732E5F776F726B7370616365436F6E736F6C696461746564436F6E66696775726174696F6E7D676574466F6C646572436F6E736F6C696461746564436F6E66696775726174696F6E286529';
wwv_flow_imp.g_varchar2_table(32240) := '7B6C657420743D746869732E5F666F6C64657273436F6E736F6C696461746564436F6E66696775726174696F6E732E6765742865293B6966282174297B636F6E7374206E3D746869732E676574576F726B7370616365436F6E736F6C696461746564436F';
wwv_flow_imp.g_varchar2_table(32241) := '6E66696775726174696F6E28292C693D746869732E5F666F6C646572436F6E66696775726174696F6E732E6765742865293B693F28743D6E2E6D657267652869292C746869732E5F666F6C64657273436F6E736F6C696461746564436F6E666967757261';
wwv_flow_imp.g_varchar2_table(32242) := '74696F6E732E73657428652C7429293A743D6E7D72657475726E20747D676574466F6C646572436F6E66696775726174696F6E4D6F64656C466F725265736F7572636528652C74297B69662874262665297B636F6E7374206E3D742E676574466F6C6465';
wwv_flow_imp.g_varchar2_table(32243) := '722865293B6966286E2972657475726E20746869732E5F666F6C646572436F6E66696775726174696F6E732E676574286E2E757269297D7D746F4461746128297B72657475726E7B64656661756C74733A7B636F6E74656E74733A746869732E5F646566';
wwv_flow_imp.g_varchar2_table(32244) := '61756C74436F6E66696775726174696F6E2E636F6E74656E74732C6F76657272696465733A746869732E5F64656661756C74436F6E66696775726174696F6E2E6F76657272696465732C6B6579733A746869732E5F64656661756C74436F6E6669677572';
wwv_flow_imp.g_varchar2_table(32245) := '6174696F6E2E6B6579737D2C706F6C6963793A7B636F6E74656E74733A746869732E5F706F6C696379436F6E66696775726174696F6E2E636F6E74656E74732C6F76657272696465733A746869732E5F706F6C696379436F6E66696775726174696F6E2E';
wwv_flow_imp.g_varchar2_table(32246) := '6F76657272696465732C6B6579733A746869732E5F706F6C696379436F6E66696775726174696F6E2E6B6579737D2C6170706C69636174696F6E3A7B636F6E74656E74733A746869732E6170706C69636174696F6E436F6E66696775726174696F6E2E63';
wwv_flow_imp.g_varchar2_table(32247) := '6F6E74656E74732C6F76657272696465733A746869732E6170706C69636174696F6E436F6E66696775726174696F6E2E6F76657272696465732C6B6579733A746869732E6170706C69636174696F6E436F6E66696775726174696F6E2E6B6579737D2C75';
wwv_flow_imp.g_varchar2_table(32248) := '7365723A7B636F6E74656E74733A746869732E75736572436F6E66696775726174696F6E2E636F6E74656E74732C6F76657272696465733A746869732E75736572436F6E66696775726174696F6E2E6F76657272696465732C6B6579733A746869732E75';
wwv_flow_imp.g_varchar2_table(32249) := '736572436F6E66696775726174696F6E2E6B6579737D2C776F726B73706163653A7B636F6E74656E74733A746869732E5F776F726B7370616365436F6E66696775726174696F6E2E636F6E74656E74732C6F76657272696465733A746869732E5F776F72';
wwv_flow_imp.g_varchar2_table(32250) := '6B7370616365436F6E66696775726174696F6E2E6F76657272696465732C6B6579733A746869732E5F776F726B7370616365436F6E66696775726174696F6E2E6B6579737D2C666F6C646572733A5B2E2E2E746869732E5F666F6C646572436F6E666967';
wwv_flow_imp.g_varchar2_table(32251) := '75726174696F6E732E6B65797328295D2E726564756365282828652C74293D3E7B636F6E73747B636F6E74656E74733A6E2C6F76657272696465733A692C6B6579733A6F7D3D746869732E5F666F6C646572436F6E66696775726174696F6E732E676574';
wwv_flow_imp.g_varchar2_table(32252) := '2874293B72657475726E20652E70757368285B742C7B636F6E74656E74733A6E2C6F76657272696465733A692C6B6579733A6F7D5D292C657D292C5B5D297D7D73746174696320706172736528652C74297B636F6E7374206E3D746869732E7061727365';
wwv_flow_imp.g_varchar2_table(32253) := '436F6E66696775726174696F6E4D6F64656C28652E64656661756C74732C74292C693D746869732E7061727365436F6E66696775726174696F6E4D6F64656C28652E706F6C6963792C74292C6F3D746869732E7061727365436F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(32254) := '6E4D6F64656C28652E6170706C69636174696F6E2C74292C733D746869732E7061727365436F6E66696775726174696F6E4D6F64656C28652E757365722C74292C723D746869732E7061727365436F6E66696775726174696F6E4D6F64656C28652E776F';
wwv_flow_imp.g_varchar2_table(32255) := '726B73706163652C74292C613D652E666F6C646572732E726564756365282828652C6E293D3E28652E736574284E6F2E726576697665286E5B305D292C746869732E7061727365436F6E66696775726174696F6E4D6F64656C286E5B315D2C7429292C65';
wwv_flow_imp.g_varchar2_table(32256) := '29292C6E6577206F61293B72657475726E206E657720446965286E2C692C6F2C732C6B69652E637265617465456D7074794D6F64656C2874292C722C612C6B69652E637265617465456D7074794D6F64656C2874292C6E6577206F612C74297D73746174';
wwv_flow_imp.g_varchar2_table(32257) := '6963207061727365436F6E66696775726174696F6E4D6F64656C28652C74297B72657475726E206E6577206B696528652E636F6E74656E74732C652E6B6579732C652E6F76657272696465732C766F696420302C74297D7D636C617373205469657B636F';
wwv_flow_imp.g_varchar2_table(32258) := '6E7374727563746F7228652C742C6E2C692C6F297B746869732E6368616E67653D652C746869732E70726576696F75733D742C746869732E63757272656E74436F6E66696775726169746F6E3D6E2C746869732E63757272656E74576F726B7370616365';
wwv_flow_imp.g_varchar2_table(32259) := '3D692C746869732E6C6F67536572766963653D6F2C746869732E5F6D61726B65723D225C6E222C746869732E5F6D61726B6572436F6465313D746869732E5F6D61726B65722E63686172436F646541742830292C746869732E5F6D61726B6572436F6465';
wwv_flow_imp.g_varchar2_table(32260) := '323D222E222E63686172436F646541742830292C746869732E61666665637465644B6579733D6E6577205365742C746869732E5F70726576696F7573436F6E66696775726174696F6E3D766F696420303B666F7228636F6E73742074206F6620652E6B65';
wwv_flow_imp.g_varchar2_table(32261) := '797329746869732E61666665637465644B6579732E6164642874293B666F7228636F6E73745B2C745D6F6620652E6F766572726964657329666F7228636F6E73742065206F66207429746869732E61666665637465644B6579732E6164642865293B7468';
wwv_flow_imp.g_varchar2_table(32262) := '69732E5F61666665637473436F6E6669675374723D746869732E5F6D61726B65723B666F7228636F6E73742065206F6620746869732E61666665637465644B65797329746869732E5F61666665637473436F6E6669675374722B3D652B746869732E5F6D';
wwv_flow_imp.g_varchar2_table(32263) := '61726B65727D6765742070726576696F7573436F6E66696775726174696F6E28297B72657475726E21746869732E5F70726576696F7573436F6E66696775726174696F6E2626746869732E70726576696F7573262628746869732E5F70726576696F7573';
wwv_flow_imp.g_varchar2_table(32264) := '436F6E66696775726174696F6E3D4469652E706172736528746869732E70726576696F75732E646174612C746869732E6C6F675365727669636529292C746869732E5F70726576696F7573436F6E66696775726174696F6E7D61666665637473436F6E66';
wwv_flow_imp.g_varchar2_table(32265) := '696775726174696F6E28652C74297B766172206E3B636F6E737420693D746869732E5F6D61726B65722B652C6F3D746869732E5F61666665637473436F6E6669675374722E696E6465784F662869293B6966286F3C302972657475726E21313B636F6E73';
wwv_flow_imp.g_varchar2_table(32266) := '7420733D6F2B692E6C656E6774683B696628733E3D746869732E5F61666665637473436F6E6669675374722E6C656E6774682972657475726E21313B636F6E737420723D746869732E5F61666665637473436F6E6669675374722E63686172436F646541';
wwv_flow_imp.g_varchar2_table(32267) := '742873293B72657475726E28723D3D3D746869732E5F6D61726B6572436F6465317C7C723D3D3D746869732E5F6D61726B6572436F6465322926262821747C7C21776828746869732E70726576696F7573436F6E66696775726174696F6E3F746869732E';
wwv_flow_imp.g_varchar2_table(32268) := '70726576696F7573436F6E66696775726174696F6E2E67657456616C756528652C742C6E756C6C3D3D3D286E3D746869732E70726576696F7573297C7C766F696420303D3D3D6E3F766F696420303A6E2E776F726B7370616365293A766F696420302C74';
wwv_flow_imp.g_varchar2_table(32269) := '6869732E63757272656E74436F6E66696775726169746F6E2E67657456616C756528652C742C746869732E63757272656E74576F726B73706163652929297D7D636F6E7374204969653D7B6B696E643A307D2C4D69653D7B6B696E643A317D3B636C6173';
wwv_flow_imp.g_varchar2_table(32270) := '73204169657B636F6E7374727563746F7228652C742C6E297B76617220693B746869732E5F6C6F673D6E2C746869732E5F64656661756C744B657962696E64696E67733D652C746869732E5F64656661756C74426F756E64436F6D6D616E64733D6E6577';
wwv_flow_imp.g_varchar2_table(32271) := '204D61703B666F7228636F6E73742074206F662065297B636F6E737420653D742E636F6D6D616E643B652626222D22213D3D652E6368617241742830292626746869732E5F64656661756C74426F756E64436F6D6D616E64732E73657428652C2130297D';
wwv_flow_imp.g_varchar2_table(32272) := '746869732E5F6D61703D6E6577204D61702C746869732E5F6C6F6F6B75704D61703D6E6577204D61702C746869732E5F6B657962696E64696E67733D4169652E68616E646C6552656D6F76616C73285B5D2E636F6E6361742865292E636F6E6361742874';
wwv_flow_imp.g_varchar2_table(32273) := '29293B666F72286C657420653D302C743D746869732E5F6B657962696E64696E67732E6C656E6774683B653C743B652B2B297B636F6E737420743D746869732E5F6B657962696E64696E67735B655D3B696628303D3D3D742E63686F7264732E6C656E67';
wwv_flow_imp.g_varchar2_table(32274) := '746829636F6E74696E75653B636F6E7374206E3D6E756C6C3D3D3D28693D742E7768656E297C7C766F696420303D3D3D693F766F696420303A692E73756273746974757465436F6E7374616E747328293B6E2626303D3D3D6E2E747970657C7C74686973';
wwv_flow_imp.g_varchar2_table(32275) := '2E5F6164644B6579507265737328742E63686F7264735B305D2C74297D7D737461746963205F69735461726765746564466F7252656D6F76616C28652C742C6E297B6966287429666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B296966';
wwv_flow_imp.g_varchar2_table(32276) := '28745B6E5D213D3D652E63686F7264735B6E5D2972657475726E21313B6966286E262631213D3D6E2E74797065297B69662821652E7768656E2972657475726E21313B6966282166756E6374696F6E28652C74297B636F6E7374206E3D653F652E737562';
wwv_flow_imp.g_varchar2_table(32277) := '73746974757465436F6E7374616E747328293A766F696420302C693D743F742E73756273746974757465436F6E7374616E747328293A766F696420303B72657475726E216E262621697C7C2128216E7C7C21692926266E2E657175616C732869297D286E';
wwv_flow_imp.g_varchar2_table(32278) := '2C652E7768656E292972657475726E21317D72657475726E21307D7374617469632068616E646C6552656D6F76616C732865297B636F6E737420743D6E6577204D61703B666F72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B';
wwv_flow_imp.g_varchar2_table(32279) := '636F6E737420693D655B6E5D3B696628692E636F6D6D616E642626222D223D3D3D692E636F6D6D616E642E636861724174283029297B636F6E737420653D692E636F6D6D616E642E737562737472696E672831293B742E6861732865293F742E67657428';
wwv_flow_imp.g_varchar2_table(32280) := '65292E707573682869293A742E73657428652C5B695D297D7D696628303D3D3D742E73697A652972657475726E20653B636F6E7374206E3D5B5D3B666F72286C657420693D302C6F3D652E6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D65';
wwv_flow_imp.g_varchar2_table(32281) := '5B695D3B696628216F2E636F6D6D616E647C7C303D3D3D6F2E636F6D6D616E642E6C656E677468297B6E2E70757368286F293B636F6E74696E75657D696628222D223D3D3D6F2E636F6D6D616E642E63686172417428302929636F6E74696E75653B636F';
wwv_flow_imp.g_varchar2_table(32282) := '6E737420733D742E676574286F2E636F6D6D616E64293B69662821737C7C216F2E697344656661756C74297B6E2E70757368286F293B636F6E74696E75657D6C657420723D21313B666F7228636F6E73742065206F662073297B636F6E737420743D652E';
wwv_flow_imp.g_varchar2_table(32283) := '7768656E3B696628746869732E5F69735461726765746564466F7252656D6F76616C286F2C652E63686F7264732C7429297B723D21303B627265616B7D7D727C7C6E2E70757368286F297D72657475726E206E7D5F6164644B6579507265737328652C74';
wwv_flow_imp.g_varchar2_table(32284) := '297B636F6E7374206E3D746869732E5F6D61702E6765742865293B696628766F696420303D3D3D6E2972657475726E20746869732E5F6D61702E73657428652C5B745D292C766F696420746869732E5F616464546F4C6F6F6B75704D61702874293B666F';
wwv_flow_imp.g_varchar2_table(32285) := '72286C657420653D6E2E6C656E6774682D313B653E3D303B652D2D297B636F6E737420693D6E5B655D3B696628692E636F6D6D616E643D3D3D742E636F6D6D616E6429636F6E74696E75653B6C6574206F3D21303B666F72286C657420653D313B653C69';
wwv_flow_imp.g_varchar2_table(32286) := '2E63686F7264732E6C656E6774682626653C742E63686F7264732E6C656E6774683B652B2B29696628692E63686F7264735B655D213D3D742E63686F7264735B655D297B6F3D21313B627265616B7D6F26264169652E7768656E4973456E746972656C79';
wwv_flow_imp.g_varchar2_table(32287) := '496E636C7564656428692E7768656E2C742E7768656E292626746869732E5F72656D6F766546726F6D4C6F6F6B75704D61702869297D6E2E707573682874292C746869732E5F616464546F4C6F6F6B75704D61702874297D5F616464546F4C6F6F6B7570';
wwv_flow_imp.g_varchar2_table(32288) := '4D61702865297B69662821652E636F6D6D616E642972657475726E3B6C657420743D746869732E5F6C6F6F6B75704D61702E67657428652E636F6D6D616E64293B766F696420303D3D3D743F28743D5B655D2C746869732E5F6C6F6F6B75704D61702E73';
wwv_flow_imp.g_varchar2_table(32289) := '657428652E636F6D6D616E642C7429293A742E707573682865297D5F72656D6F766546726F6D4C6F6F6B75704D61702865297B69662821652E636F6D6D616E642972657475726E3B636F6E737420743D746869732E5F6C6F6F6B75704D61702E67657428';
wwv_flow_imp.g_varchar2_table(32290) := '652E636F6D6D616E64293B696628766F69642030213D3D7429666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B29696628745B6E5D3D3D3D652972657475726E20766F696420742E73706C696365286E2C31297D737461746963';
wwv_flow_imp.g_varchar2_table(32291) := '207768656E4973456E746972656C79496E636C7564656428652C74297B72657475726E21747C7C313D3D3D742E747970657C7C212821657C7C313D3D3D652E74797065292626756428652C74297D6765744B657962696E64696E677328297B7265747572';
wwv_flow_imp.g_varchar2_table(32292) := '6E20746869732E5F6B657962696E64696E67737D6C6F6F6B75705072696D6172794B657962696E64696E6728652C74297B636F6E7374206E3D746869732E5F6C6F6F6B75704D61702E6765742865293B696628766F696420303D3D3D6E7C7C303D3D3D6E';
wwv_flow_imp.g_varchar2_table(32293) := '2E6C656E6774682972657475726E206E756C6C3B696628313D3D3D6E2E6C656E6774682972657475726E206E5B305D3B666F72286C657420653D6E2E6C656E6774682D313B653E3D303B652D2D297B636F6E737420693D6E5B655D3B696628742E636F6E';
wwv_flow_imp.g_varchar2_table(32294) := '746578744D61746368657352756C657328692E7768656E292972657475726E20697D72657475726E206E5B6E2E6C656E6774682D315D7D7265736F6C766528652C742C6E297B636F6E737420693D5B2E2E2E742C6E5D3B746869732E5F6C6F6728607C20';
wwv_flow_imp.g_varchar2_table(32295) := '5265736F6C76696E6720247B697D60293B636F6E7374206F3D746869732E5F6D61702E67657428695B305D293B696628766F696420303D3D3D6F2972657475726E20746869732E5F6C6F6728225C5C204E6F206B657962696E64696E6720656E74726965';
wwv_flow_imp.g_varchar2_table(32296) := '732E22292C4969653B6C657420733D6E756C6C3B696628692E6C656E6774683C3229733D6F3B656C73657B733D5B5D3B666F72286C657420653D302C743D6F2E6C656E6774683B653C743B652B2B297B636F6E737420743D6F5B655D3B696628692E6C65';
wwv_flow_imp.g_varchar2_table(32297) := '6E6774683E742E63686F7264732E6C656E67746829636F6E74696E75653B6C6574206E3D21303B666F72286C657420653D313B653C692E6C656E6774683B652B2B29696628742E63686F7264735B655D213D3D695B655D297B6E3D21313B627265616B7D';
wwv_flow_imp.g_varchar2_table(32298) := '6E2626732E707573682874297D7D636F6E737420723D746869732E5F66696E64436F6D6D616E6428652C73293B72657475726E20723F692E6C656E6774683C722E63686F7264732E6C656E6774683F28746869732E5F6C6F6728605C5C2046726F6D2024';
wwv_flow_imp.g_varchar2_table(32299) := '7B732E6C656E6774687D206B657962696E64696E6720656E74726965732C206177616974696E6720247B722E63686F7264732E6C656E6774682D692E6C656E6774687D206D6F72652063686F72642873292C207768656E3A20247B4E696528722E776865';
wwv_flow_imp.g_varchar2_table(32300) := '6E297D2C20736F757263653A20247B5069652872297D2E60292C4D6965293A28746869732E5F6C6F6728605C5C2046726F6D20247B732E6C656E6774687D206B657962696E64696E6720656E74726965732C206D61746368656420247B722E636F6D6D61';
wwv_flow_imp.g_varchar2_table(32301) := '6E647D2C207768656E3A20247B4E696528722E7768656E297D2C20736F757263653A20247B5069652872297D2E60292C7B6B696E643A322C636F6D6D616E6449643A722E636F6D6D616E642C636F6D6D616E64417267733A722E636F6D6D616E64417267';
wwv_flow_imp.g_varchar2_table(32302) := '732C6973427562626C653A722E627562626C657D293A28746869732E5F6C6F6728605C5C2046726F6D20247B732E6C656E6774687D206B657962696E64696E6720656E74726965732C206E6F207768656E20636C6175736573206D617463686564207468';
wwv_flow_imp.g_varchar2_table(32303) := '6520636F6E746578742E60292C496965297D5F66696E64436F6D6D616E6428652C74297B666F72286C6574206E3D742E6C656E6774682D313B6E3E3D303B6E2D2D297B636F6E737420693D745B6E5D3B6966284169652E5F636F6E746578744D61746368';
wwv_flow_imp.g_varchar2_table(32304) := '657352756C657328652C692E7768656E292972657475726E20697D72657475726E206E756C6C7D737461746963205F636F6E746578744D61746368657352756C657328652C74297B72657475726E21747C7C742E6576616C756174652865297D7D66756E';
wwv_flow_imp.g_varchar2_table(32305) := '6374696F6E204E69652865297B72657475726E20653F60247B652E73657269616C697A6528297D603A226E6F207768656E20636F6E646974696F6E227D66756E6374696F6E205069652865297B72657475726E20652E657874656E73696F6E49643F652E';
wwv_flow_imp.g_varchar2_table(32306) := '69734275696C74696E457874656E73696F6E3F606275696C742D696E20657874656E73696F6E20247B652E657874656E73696F6E49647D603A607573657220657874656E73696F6E20247B652E657874656E73696F6E49647D603A652E69734465666175';
wwv_flow_imp.g_varchar2_table(32307) := '6C743F226275696C742D696E223A2275736572227D636F6E7374204F69653D2F5E28637572736F727C64656C6574657C756E646F7C7265646F7C7461627C656469746F725C2E616374696F6E5C2E636C6970626F617264292F3B636C6173732052696520';
wwv_flow_imp.g_varchar2_table(32308) := '657874656E6473206C747B676574206F6E4469645570646174654B657962696E64696E677328297B72657475726E20746869732E5F6F6E4469645570646174654B657962696E64696E67733F746869732E5F6F6E4469645570646174654B657962696E64';
wwv_flow_imp.g_varchar2_table(32309) := '696E67732E6576656E743A76742E4E6F6E657D67657420696E43686F72644D6F646528297B72657475726E20746869732E5F63757272656E7443686F7264732E6C656E6774683E307D636F6E7374727563746F7228652C742C6E2C692C6F297B73757065';
wwv_flow_imp.g_varchar2_table(32310) := '7228292C746869732E5F636F6E746578744B6579536572766963653D652C746869732E5F636F6D6D616E64536572766963653D742C746869732E5F74656C656D65747279536572766963653D6E2C746869732E5F6E6F74696669636174696F6E53657276';
wwv_flow_imp.g_varchar2_table(32311) := '6963653D692C746869732E5F6C6F67536572766963653D6F2C746869732E5F6F6E4469645570646174654B657962696E64696E67733D746869732E5F7265676973746572286E6577204374292C746869732E5F63757272656E7443686F7264733D5B5D2C';
wwv_flow_imp.g_varchar2_table(32312) := '746869732E5F63757272656E7443686F7264436865636B65723D6E65772055742C746869732E5F63757272656E7443686F72645374617475734D6573736167653D6E756C6C2C746869732E5F69676E6F726553696E676C654D6F646966696572733D4669';
wwv_flow_imp.g_varchar2_table(32313) := '652E454D5054592C746869732E5F63757272656E7453696E676C654D6F6469666965723D6E756C6C2C746869732E5F63757272656E7453696E676C654D6F646966696572436C65617254696D656F75743D6E65772024742C746869732E5F63757272656E';
wwv_flow_imp.g_varchar2_table(32314) := '746C794469737061746368696E67436F6D6D616E6449643D6E756C6C2C746869732E5F6C6F6767696E673D21317D646973706F736528297B73757065722E646973706F736528297D5F6C6F672865297B746869732E5F6C6F6767696E672626746869732E';
wwv_flow_imp.g_varchar2_table(32315) := '5F6C6F67536572766963652E696E666F28605B4B657962696E64696E67536572766963655D3A20247B657D60297D6765744B657962696E64696E677328297B72657475726E20746869732E5F6765745265736F6C76657228292E6765744B657962696E64';
wwv_flow_imp.g_varchar2_table(32316) := '696E677328297D6C6F6F6B75704B657962696E64696E6728652C74297B636F6E7374206E3D746869732E5F6765745265736F6C76657228292E6C6F6F6B75705072696D6172794B657962696E64696E6728652C747C7C746869732E5F636F6E746578744B';
wwv_flow_imp.g_varchar2_table(32317) := '657953657276696365293B6966286E2972657475726E206E2E7265736F6C7665644B657962696E64696E677D64697370617463684576656E7428652C74297B72657475726E20746869732E5F646973706174636828652C74297D736F6674446973706174';
wwv_flow_imp.g_varchar2_table(32318) := '636828652C74297B746869732E5F6C6F6728222F20536F6674206469737061746368696E67206B6579626F617264206576656E7422293B636F6E7374206E3D746869732E7265736F6C76654B6579626F6172644576656E742865293B6966286E2E686173';
wwv_flow_imp.g_varchar2_table(32319) := '4D756C7469706C6543686F72647328292972657475726E20636F6E736F6C652E7761726E28226B6579626F617264206576656E742073686F756C64206E6F74206265206D617070656420746F206D756C7469706C652063686F72647322292C4969653B63';
wwv_flow_imp.g_varchar2_table(32320) := '6F6E73745B695D3D6E2E676574446973706174636843686F72647328293B6966286E756C6C3D3D3D692972657475726E20746869732E5F6C6F6728225C5C204B6579626F617264206576656E742063616E6E6F7420626520646973706174636865642229';
wwv_flow_imp.g_varchar2_table(32321) := '2C4969653B636F6E7374206F3D746869732E5F636F6E746578744B6579536572766963652E676574436F6E746578742874292C733D746869732E5F63757272656E7443686F7264732E6D61702828287B6B657970726573733A657D293D3E6529293B7265';
wwv_flow_imp.g_varchar2_table(32322) := '7475726E20746869732E5F6765745265736F6C76657228292E7265736F6C7665286F2C732C69297D5F7363686564756C654C6561766543686F72644D6F646528297B636F6E737420653D446174652E6E6F7728293B746869732E5F63757272656E744368';
wwv_flow_imp.g_varchar2_table(32323) := '6F7264436865636B65722E63616E63656C416E64536574282828293D3E7B746869732E5F646F63756D656E74486173466F63757328293F446174652E6E6F7728292D653E3565332626746869732E5F6C6561766543686F72644D6F646528293A74686973';
wwv_flow_imp.g_varchar2_table(32324) := '2E5F6C6561766543686F72644D6F646528297D292C353030297D5F657870656374416E6F7468657243686F726428652C74297B73776974636828746869732E5F63757272656E7443686F7264732E70757368287B6B657970726573733A652C6C6162656C';
wwv_flow_imp.g_varchar2_table(32325) := '3A747D292C746869732E5F63757272656E7443686F7264732E6C656E677468297B6361736520303A7468726F772041652822696D706F737369626C6522293B6361736520313A746869732E5F63757272656E7443686F72645374617475734D6573736167';
wwv_flow_imp.g_varchar2_table(32326) := '653D746869732E5F6E6F74696669636174696F6E536572766963652E737461747573286228302C22287B307D292077617320707265737365642E2057616974696E6720666F72207365636F6E64206B6579206F662063686F72642E2E2E222C7429293B62';
wwv_flow_imp.g_varchar2_table(32327) := '7265616B3B64656661756C743A7B636F6E737420653D746869732E5F63757272656E7443686F7264732E6D61702828287B6C6162656C3A657D293D3E6529292E6A6F696E28222C2022293B746869732E5F63757272656E7443686F72645374617475734D';
wwv_flow_imp.g_varchar2_table(32328) := '6573736167653D746869732E5F6E6F74696669636174696F6E536572766963652E737461747573286228302C22287B307D292077617320707265737365642E2057616974696E6720666F72206E657874206B6579206F662063686F72642E2E2E222C6529';
wwv_flow_imp.g_varchar2_table(32329) := '297D7D746869732E5F7363686564756C654C6561766543686F72644D6F646528292C75502E656E61626C6564262675502E64697361626C6528297D5F6C6561766543686F72644D6F646528297B746869732E5F63757272656E7443686F72645374617475';
wwv_flow_imp.g_varchar2_table(32330) := '734D657373616765262628746869732E5F63757272656E7443686F72645374617475734D6573736167652E646973706F736528292C746869732E5F63757272656E7443686F72645374617475734D6573736167653D6E756C6C292C746869732E5F637572';
wwv_flow_imp.g_varchar2_table(32331) := '72656E7443686F7264436865636B65722E63616E63656C28292C746869732E5F63757272656E7443686F7264733D5B5D2C75502E656E61626C6528297D5F646973706174636828652C74297B72657475726E20746869732E5F646F446973706174636828';
wwv_flow_imp.g_varchar2_table(32332) := '746869732E7265736F6C76654B6579626F6172644576656E742865292C742C2131297D5F73696E676C654D6F646966696572446973706174636828652C74297B636F6E7374206E3D746869732E7265736F6C76654B6579626F6172644576656E74286529';
wwv_flow_imp.g_varchar2_table(32333) := '2C5B695D3D6E2E67657453696E676C654D6F646966696572446973706174636843686F72647328293B696628692972657475726E20746869732E5F69676E6F726553696E676C654D6F646966696572732E6861732869293F28746869732E5F6C6F672860';
wwv_flow_imp.g_varchar2_table(32334) := '2B2049676E6F72696E672073696E676C65206D6F64696669657220247B697D2064756520746F206974206265696E67207072657373656420746F6765746865722077697468206F74686572206B6579732E60292C746869732E5F69676E6F726553696E67';
wwv_flow_imp.g_varchar2_table(32335) := '6C654D6F646966696572733D4669652E454D5054592C746869732E5F63757272656E7453696E676C654D6F646966696572436C65617254696D656F75742E63616E63656C28292C746869732E5F63757272656E7453696E676C654D6F6469666965723D6E';
wwv_flow_imp.g_varchar2_table(32336) := '756C6C2C2131293A28746869732E5F69676E6F726553696E676C654D6F646966696572733D4669652E454D5054592C6E756C6C3D3D3D746869732E5F63757272656E7453696E676C654D6F6469666965723F28746869732E5F6C6F6728602B2053746F72';
wwv_flow_imp.g_varchar2_table(32337) := '696E672073696E676C65206D6F64696669657220666F7220706F737369626C652063686F726420247B697D2E60292C746869732E5F63757272656E7453696E676C654D6F6469666965723D692C746869732E5F63757272656E7453696E676C654D6F6469';
wwv_flow_imp.g_varchar2_table(32338) := '66696572436C65617254696D656F75742E63616E63656C416E64536574282828293D3E7B746869732E5F6C6F6728222B20436C656172696E672073696E676C65206D6F6469666965722064756520746F203330306D7320656C61707365642E22292C7468';
wwv_flow_imp.g_varchar2_table(32339) := '69732E5F63757272656E7453696E676C654D6F6469666965723D6E756C6C7D292C333030292C2131293A693D3D3D746869732E5F63757272656E7453696E676C654D6F6469666965723F28746869732E5F6C6F6728602F204469737061746368696E6720';
wwv_flow_imp.g_varchar2_table(32340) := '73696E676C65206D6F6469666965722063686F726420247B697D20247B697D60292C746869732E5F63757272656E7453696E676C654D6F646966696572436C65617254696D656F75742E63616E63656C28292C746869732E5F63757272656E7453696E67';
wwv_flow_imp.g_varchar2_table(32341) := '6C654D6F6469666965723D6E756C6C2C746869732E5F646F4469737061746368286E2C742C213029293A28746869732E5F6C6F6728602B20436C656172696E672073696E676C65206D6F6469666965722064756520746F206D6F646966696572206D6973';
wwv_flow_imp.g_varchar2_table(32342) := '6D617463683A20247B746869732E5F63757272656E7453696E676C654D6F6469666965727D20247B697D60292C746869732E5F63757272656E7453696E676C654D6F646966696572436C65617254696D656F75742E63616E63656C28292C746869732E5F';
wwv_flow_imp.g_varchar2_table(32343) := '63757272656E7453696E676C654D6F6469666965723D6E756C6C2C213129293B636F6E73745B6F5D3D6E2E67657443686F72647328293B72657475726E20746869732E5F69676E6F726553696E676C654D6F646966696572733D6E657720466965286F29';
wwv_flow_imp.g_varchar2_table(32344) := '2C6E756C6C213D3D746869732E5F63757272656E7453696E676C654D6F6469666965722626746869732E5F6C6F6728222B20436C656172696E672073696E676C65206D6F6469666965722064756520746F206F74686572206B65792075702E22292C7468';
wwv_flow_imp.g_varchar2_table(32345) := '69732E5F63757272656E7453696E676C654D6F646966696572436C65617254696D656F75742E63616E63656C28292C746869732E5F63757272656E7453696E676C654D6F6469666965723D6E756C6C2C21317D5F646F446973706174636828652C742C6E';
wwv_flow_imp.g_varchar2_table(32346) := '3D2131297B76617220693B6C6574206F3D21313B696628652E6861734D756C7469706C6543686F72647328292972657475726E20636F6E736F6C652E7761726E2822556E6578706563746564206B6579626F617264206576656E74206D61707065642074';
wwv_flow_imp.g_varchar2_table(32347) := '6F206D756C7469706C652063686F72647322292C21313B6C657420733D6E756C6C2C723D6E756C6C3B6966286E297B636F6E73745B745D3D652E67657453696E676C654D6F646966696572446973706174636843686F72647328293B733D742C723D743F';
wwv_flow_imp.g_varchar2_table(32348) := '5B745D3A5B5D7D656C73655B735D3D652E676574446973706174636843686F72647328292C723D746869732E5F63757272656E7443686F7264732E6D61702828287B6B657970726573733A657D293D3E6529293B6966286E756C6C3D3D3D732972657475';
wwv_flow_imp.g_varchar2_table(32349) := '726E20746869732E5F6C6F6728225C5C204B6579626F617264206576656E742063616E6E6F74206265206469737061746368656420696E206B6579646F776E2070686173652E22292C6F3B636F6E737420613D746869732E5F636F6E746578744B657953';
wwv_flow_imp.g_varchar2_table(32350) := '6572766963652E676574436F6E746578742874292C6C3D652E6765744C6162656C28292C633D746869732E5F6765745265736F6C76657228292E7265736F6C766528612C722C73293B73776974636828632E6B696E64297B6361736520303A6966287468';
wwv_flow_imp.g_varchar2_table(32351) := '69732E5F6C6F67536572766963652E747261636528224B657962696E64696E6753657276696365236469737061746368222C6C2C225B204E6F206D61746368696E67206B657962696E64696E67205D22292C746869732E696E43686F72644D6F6465297B';
wwv_flow_imp.g_varchar2_table(32352) := '636F6E737420653D746869732E5F63757272656E7443686F7264732E6D61702828287B6C6162656C3A657D293D3E6529292E6A6F696E28222C2022293B746869732E5F6C6F6728602B204C656176696E67206D756C74692D63686F7264206D6F64653A20';
wwv_flow_imp.g_varchar2_table(32353) := '4E6F7468696E6720626F756E6420746F2022247B657D2C20247B6C7D222E60292C746869732E5F6E6F74696669636174696F6E536572766963652E737461747573286228302C22546865206B657920636F6D62696E6174696F6E20287B307D2C207B317D';
wwv_flow_imp.g_varchar2_table(32354) := '29206973206E6F74206120636F6D6D616E642E222C652C6C292C7B6869646541667465723A3165347D292C746869732E5F6C6561766543686F72644D6F646528292C6F3D21307D72657475726E206F3B6361736520313A72657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(32355) := '6C6F67536572766963652E747261636528224B657962696E64696E6753657276696365236469737061746368222C6C2C225B205365766572616C206B657962696E64696E6773206D61746368202D206D6F72652063686F726473206E6565646564205D22';
wwv_flow_imp.g_varchar2_table(32356) := '292C6F3D21302C746869732E5F657870656374416E6F7468657243686F726428732C6C292C746869732E5F6C6F6728313D3D3D746869732E5F63757272656E7443686F7264732E6C656E6774683F222B20456E746572696E67206D756C74692D63686F72';
wwv_flow_imp.g_varchar2_table(32357) := '64206D6F64652E2E2E223A222B20436F6E74696E75696E67206D756C74692D63686F7264206D6F64652E2E2E22292C6F3B6361736520323A696628746869732E5F6C6F67536572766963652E747261636528224B657962696E64696E6753657276696365';
wwv_flow_imp.g_varchar2_table(32358) := '236469737061746368222C6C2C605B2057696C6C20646973706174636820636F6D6D616E6420247B632E636F6D6D616E6449647D205D60292C6E756C6C3D3D3D632E636F6D6D616E6449647C7C22223D3D3D632E636F6D6D616E644964297B6966287468';
wwv_flow_imp.g_varchar2_table(32359) := '69732E696E43686F72644D6F6465297B636F6E737420653D746869732E5F63757272656E7443686F7264732E6D61702828287B6C6162656C3A657D293D3E6529292E6A6F696E28222C2022293B746869732E5F6C6F6728602B204C656176696E67206368';
wwv_flow_imp.g_varchar2_table(32360) := '6F7264206D6F64653A204E6F7468696E6720626F756E6420746F2022247B657D2C20247B6C7D222E60292C746869732E5F6E6F74696669636174696F6E536572766963652E737461747573286228302C22546865206B657920636F6D62696E6174696F6E';
wwv_flow_imp.g_varchar2_table(32361) := '20287B307D2C207B317D29206973206E6F74206120636F6D6D616E642E222C652C6C292C7B6869646541667465723A3165347D292C746869732E5F6C6561766543686F72644D6F646528292C6F3D21307D7D656C73657B746869732E696E43686F72644D';
wwv_flow_imp.g_varchar2_table(32362) := '6F64652626746869732E5F6C6561766543686F72644D6F646528292C632E6973427562626C657C7C286F3D2130292C746869732E5F6C6F6728602B20496E766F6B696E6720636F6D6D616E6420247B632E636F6D6D616E6449647D2E60292C746869732E';
wwv_flow_imp.g_varchar2_table(32363) := '5F63757272656E746C794469737061746368696E67436F6D6D616E6449643D632E636F6D6D616E6449643B7472797B766F696420303D3D3D632E636F6D6D616E64417267733F746869732E5F636F6D6D616E64536572766963652E65786563757465436F';
wwv_flow_imp.g_varchar2_table(32364) := '6D6D616E6428632E636F6D6D616E644964292E7468656E28766F696420302C28653D3E746869732E5F6E6F74696669636174696F6E536572766963652E7761726E28652929293A746869732E5F636F6D6D616E64536572766963652E6578656375746543';
wwv_flow_imp.g_varchar2_table(32365) := '6F6D6D616E6428632E636F6D6D616E6449642C632E636F6D6D616E6441726773292E7468656E28766F696420302C28653D3E746869732E5F6E6F74696669636174696F6E536572766963652E7761726E28652929297D66696E616C6C797B746869732E5F';
wwv_flow_imp.g_varchar2_table(32366) := '63757272656E746C794469737061746368696E67436F6D6D616E6449643D6E756C6C7D4F69652E7465737428632E636F6D6D616E644964297C7C746869732E5F74656C656D65747279536572766963652E7075626C69634C6F67322822776F726B62656E';
wwv_flow_imp.g_varchar2_table(32367) := '6368416374696F6E4578656375746564222C7B69643A632E636F6D6D616E6449642C66726F6D3A226B657962696E64696E67222C64657461696C3A6E756C6C213D3D28693D652E6765745573657253657474696E67734C6162656C2829292626766F6964';
wwv_flow_imp.g_varchar2_table(32368) := '2030213D3D693F693A766F696420307D297D72657475726E206F7D7D6D6967687450726F647563655072696E7461626C654368617261637465722865297B72657475726E21652E6374726C4B6579262621652E6D6574614B6579262628652E6B6579436F';
wwv_flow_imp.g_varchar2_table(32369) := '64653E3D33312626652E6B6579436F64653C3D35367C7C652E6B6579436F64653E3D32312626652E6B6579436F64653C3D3330297D7D636C617373204669657B636F6E7374727563746F722865297B746869732E5F6374726C4B65793D2121652626652E';
wwv_flow_imp.g_varchar2_table(32370) := '6374726C4B65792C746869732E5F73686966744B65793D2121652626652E73686966744B65792C746869732E5F616C744B65793D2121652626652E616C744B65792C746869732E5F6D6574614B65793D2121652626652E6D6574614B65797D6861732865';
wwv_flow_imp.g_varchar2_table(32371) := '297B7377697463682865297B63617365226374726C223A72657475726E20746869732E5F6374726C4B65793B63617365227368696674223A72657475726E20746869732E5F73686966744B65793B6361736522616C74223A72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(32372) := '5F616C744B65793B63617365226D657461223A72657475726E20746869732E5F6D6574614B65797D7D7D4669652E454D5054593D6E657720466965286E756C6C293B636C617373204269657B636F6E7374727563746F7228652C742C6E2C692C6F2C732C';
wwv_flow_imp.g_varchar2_table(32373) := '72297B746869732E5F7265736F6C7665644B657962696E64696E674974656D4272616E643D766F696420302C746869732E7265736F6C7665644B657962696E64696E673D652C746869732E63686F7264733D653F56696528652E67657444697370617463';
wwv_flow_imp.g_varchar2_table(32374) := '6843686F7264732829293A5B5D2C652626303D3D3D746869732E63686F7264732E6C656E677468262628746869732E63686F7264733D56696528652E67657453696E676C654D6F646966696572446973706174636843686F726473282929292C74686973';
wwv_flow_imp.g_varchar2_table(32375) := '2E627562626C653D212174262639343D3D3D742E63686172436F646541742830292C746869732E636F6D6D616E643D746869732E627562626C653F742E7375627374722831293A742C746869732E636F6D6D616E64417267733D6E2C746869732E776865';
wwv_flow_imp.g_varchar2_table(32376) := '6E3D692C746869732E697344656661756C743D6F2C746869732E657874656E73696F6E49643D732C746869732E69734275696C74696E457874656E73696F6E3D727D7D66756E6374696F6E205669652865297B636F6E737420743D5B5D3B666F72286C65';
wwv_flow_imp.g_varchar2_table(32377) := '74206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B69662821692972657475726E5B5D3B742E707573682869297D72657475726E20747D636C617373207A696520657874656E64732048657B636F6E737472';
wwv_flow_imp.g_varchar2_table(32378) := '7563746F7228652C74297B696628737570657228292C303D3D3D742E6C656E677468297468726F77204D65282263686F72647322293B746869732E5F6F733D652C746869732E5F63686F7264733D747D6765744C6162656C28297B72657475726E20754D';
wwv_flow_imp.g_varchar2_table(32379) := '2E746F4C6162656C28746869732E5F6F732C746869732E5F63686F7264732C28653D3E746869732E5F6765744C6162656C28652929297D676574417269614C6162656C28297B72657475726E20704D2E746F4C6162656C28746869732E5F6F732C746869';
wwv_flow_imp.g_varchar2_table(32380) := '732E5F63686F7264732C28653D3E746869732E5F676574417269614C6162656C28652929297D676574456C656374726F6E416363656C657261746F7228297B72657475726E20746869732E5F63686F7264732E6C656E6774683E317C7C746869732E5F63';
wwv_flow_imp.g_varchar2_table(32381) := '686F7264735B305D2E69734475706C69636174654D6F6469666965724361736528293F6E756C6C3A674D2E746F4C6162656C28746869732E5F6F732C746869732E5F63686F7264732C28653D3E746869732E5F676574456C656374726F6E416363656C65';
wwv_flow_imp.g_varchar2_table(32382) := '7261746F7228652929297D6765745573657253657474696E67734C6162656C28297B72657475726E206D4D2E746F4C6162656C28746869732E5F6F732C746869732E5F63686F7264732C28653D3E746869732E5F6765745573657253657474696E67734C';
wwv_flow_imp.g_varchar2_table(32383) := '6162656C28652929297D6861734D756C7469706C6543686F72647328297B72657475726E20746869732E5F63686F7264732E6C656E6774683E317D67657443686F72647328297B72657475726E20746869732E5F63686F7264732E6D61702828653D3E74';
wwv_flow_imp.g_varchar2_table(32384) := '6869732E5F67657443686F726428652929297D5F67657443686F72642865297B72657475726E206E6577207A6528652E6374726C4B65792C652E73686966744B65792C652E616C744B65792C652E6D6574614B65792C746869732E5F6765744C6162656C';
wwv_flow_imp.g_varchar2_table(32385) := '2865292C746869732E5F676574417269614C6162656C286529297D676574446973706174636843686F72647328297B72657475726E20746869732E5F63686F7264732E6D61702828653D3E746869732E5F67657443686F72644469737061746368286529';
wwv_flow_imp.g_varchar2_table(32386) := '29297D67657453696E676C654D6F646966696572446973706174636843686F72647328297B72657475726E20746869732E5F63686F7264732E6D61702828653D3E746869732E5F67657453696E676C654D6F64696669657243686F726444697370617463';
wwv_flow_imp.g_varchar2_table(32387) := '6828652929297D7D636C6173732048696520657874656E6473207A69657B636F6E7374727563746F7228652C74297B737570657228742C65297D5F6B6579436F6465546F55494C6162656C2865297B696628323D3D3D746869732E5F6F73297377697463';
wwv_flow_imp.g_varchar2_table(32388) := '682865297B636173652031353A72657475726E22E28690223B636173652031363A72657475726E22E28691223B636173652031373A72657475726E22E28692223B636173652031383A72657475726E22E28693227D72657475726E2043652E746F537472';
wwv_flow_imp.g_varchar2_table(32389) := '696E672865297D5F6765744C6162656C2865297B72657475726E20652E69734475706C69636174654D6F6469666965724361736528293F22223A746869732E5F6B6579436F6465546F55494C6162656C28652E6B6579436F6465297D5F67657441726961';
wwv_flow_imp.g_varchar2_table(32390) := '4C6162656C2865297B72657475726E20652E69734475706C69636174654D6F6469666965724361736528293F22223A43652E746F537472696E6728652E6B6579436F6465297D5F676574456C656374726F6E416363656C657261746F722865297B726574';
wwv_flow_imp.g_varchar2_table(32391) := '75726E2043652E746F456C656374726F6E416363656C657261746F7228652E6B6579436F6465297D5F6765745573657253657474696E67734C6162656C2865297B696628652E69734475706C69636174654D6F6469666965724361736528292972657475';
wwv_flow_imp.g_varchar2_table(32392) := '726E22223B636F6E737420743D43652E746F5573657253657474696E6773555328652E6B6579436F6465293B72657475726E20743F742E746F4C6F7765724361736528293A747D5F67657443686F726444697370617463682865297B72657475726E2048';
wwv_flow_imp.g_varchar2_table(32393) := '69652E67657444697370617463685374722865297D7374617469632067657444697370617463685374722865297B696628652E69734D6F6469666965724B657928292972657475726E206E756C6C3B6C657420743D22223B72657475726E20652E637472';
wwv_flow_imp.g_varchar2_table(32394) := '6C4B6579262628742B3D226374726C2B22292C652E73686966744B6579262628742B3D2273686966742B22292C652E616C744B6579262628742B3D22616C742B22292C652E6D6574614B6579262628742B3D226D6574612B22292C742B3D43652E746F53';
wwv_flow_imp.g_varchar2_table(32395) := '7472696E6728652E6B6579436F6465292C747D5F67657453696E676C654D6F64696669657243686F726444697370617463682865297B72657475726E2035213D3D652E6B6579436F64657C7C652E73686966744B65797C7C652E616C744B65797C7C652E';
wwv_flow_imp.g_varchar2_table(32396) := '6D6574614B65793F34213D3D652E6B6579436F64657C7C652E6374726C4B65797C7C652E616C744B65797C7C652E6D6574614B65793F36213D3D652E6B6579436F64657C7C652E6374726C4B65797C7C652E73686966744B65797C7C652E6D6574614B65';
wwv_flow_imp.g_varchar2_table(32397) := '793F3537213D3D652E6B6579436F64657C7C652E6374726C4B65797C7C652E73686966744B65797C7C652E616C744B65793F6E756C6C3A226D657461223A22616C74223A227368696674223A226374726C227D737461746963205F7363616E436F646554';
wwv_flow_imp.g_varchar2_table(32398) := '6F4B6579436F64652865297B636F6E737420743D79655B655D3B6966282D31213D3D742972657475726E20743B7377697463682865297B636173652031303A72657475726E2033313B636173652031313A72657475726E2033323B636173652031323A72';
wwv_flow_imp.g_varchar2_table(32399) := '657475726E2033333B636173652031333A72657475726E2033343B636173652031343A72657475726E2033353B636173652031353A72657475726E2033363B636173652031363A72657475726E2033373B636173652031373A72657475726E2033383B63';
wwv_flow_imp.g_varchar2_table(32400) := '6173652031383A72657475726E2033393B636173652031393A72657475726E2034303B636173652032303A72657475726E2034313B636173652032313A72657475726E2034323B636173652032323A72657475726E2034333B636173652032333A726574';
wwv_flow_imp.g_varchar2_table(32401) := '75726E2034343B636173652032343A72657475726E2034353B636173652032353A72657475726E2034363B636173652032363A72657475726E2034373B636173652032373A72657475726E2034383B636173652032383A72657475726E2034393B636173';
wwv_flow_imp.g_varchar2_table(32402) := '652032393A72657475726E2035303B636173652033303A72657475726E2035313B636173652033313A72657475726E2035323B636173652033323A72657475726E2035333B636173652033333A72657475726E2035343B636173652033343A7265747572';
wwv_flow_imp.g_varchar2_table(32403) := '6E2035353B636173652033353A72657475726E2035363B636173652033363A72657475726E2032323B636173652033373A72657475726E2032333B636173652033383A72657475726E2032343B636173652033393A72657475726E2032353B6361736520';
wwv_flow_imp.g_varchar2_table(32404) := '34303A72657475726E2032363B636173652034313A72657475726E2032373B636173652034323A72657475726E2032383B636173652034333A72657475726E2032393B636173652034343A72657475726E2033303B636173652034353A72657475726E20';
wwv_flow_imp.g_varchar2_table(32405) := '32313B636173652035313A72657475726E2038383B636173652035323A72657475726E2038363B636173652035333A72657475726E2039323B636173652035343A72657475726E2039343B636173652035353A72657475726E2039333B63617365203536';
wwv_flow_imp.g_varchar2_table(32406) := '3A72657475726E20303B636173652035373A72657475726E2038353B636173652035383A72657475726E2039353B636173652035393A72657475726E2039313B636173652036303A72657475726E2038373B636173652036313A72657475726E2038393B';
wwv_flow_imp.g_varchar2_table(32407) := '636173652036323A72657475726E2039303B63617365203130363A72657475726E2039377D72657475726E20307D737461746963205F746F4B6579436F646543686F72642865297B69662821652972657475726E206E756C6C3B6966286520696E737461';
wwv_flow_imp.g_varchar2_table(32408) := '6E63656F662042652972657475726E20653B636F6E737420743D746869732E5F7363616E436F6465546F4B6579436F646528652E7363616E436F6465293B72657475726E20303D3D3D743F6E756C6C3A6E657720426528652E6374726C4B65792C652E73';
wwv_flow_imp.g_varchar2_table(32409) := '686966744B65792C652E616C744B65792C652E6D6574614B65792C74297D737461746963207265736F6C76654B657962696E64696E6728652C74297B636F6E7374206E3D56696528652E63686F7264732E6D61702828653D3E746869732E5F746F4B6579';
wwv_flow_imp.g_varchar2_table(32410) := '436F646543686F72642865292929293B72657475726E206E2E6C656E6774683E303F5B6E657720486965286E2C74295D3A5B5D7D7D6C6574205769653D5B5D2C6A69653D5B5D2C7169653D5B5D3B66756E6374696F6E2024696528652C743D2131297B21';
wwv_flow_imp.g_varchar2_table(32411) := '66756E6374696F6E28652C742C6E297B636F6E737420693D66756E6374696F6E2865297B72657475726E7B69643A652E69642C6D696D653A652E6D696D652C66696C656E616D653A652E66696C656E616D652C657874656E73696F6E3A652E657874656E';
wwv_flow_imp.g_varchar2_table(32412) := '73696F6E2C66696C657061747465726E3A652E66696C657061747465726E2C66697273746C696E653A652E66697273746C696E652C75736572436F6E666967757265643A66616C73652C66696C656E616D654C6F776572636173653A652E66696C656E61';
wwv_flow_imp.g_varchar2_table(32413) := '6D653F652E66696C656E616D652E746F4C6F7765724361736528293A766F696420302C657874656E73696F6E4C6F776572636173653A652E657874656E73696F6E3F652E657874656E73696F6E2E746F4C6F7765724361736528293A766F696420302C66';
wwv_flow_imp.g_varchar2_table(32414) := '696C657061747465726E4C6F776572636173653A652E66696C657061747465726E3F46746528652E66696C657061747465726E2E746F4C6F776572436173652829293A766F696420302C66696C657061747465726E4F6E506174683A2121652E66696C65';
wwv_flow_imp.g_varchar2_table(32415) := '7061747465726E2626652E66696C657061747465726E2E696E6465784F66285F6F2E736570293E3D307D7D2865293B5769652E707573682869292C692E75736572436F6E666967757265643F7169652E707573682869293A6A69652E707573682869292C';
wwv_flow_imp.g_varchar2_table(32416) := '6E262621692E75736572436F6E6669677572656426265769652E666F72456163682828653D3E7B652E6D696D653D3D3D692E6D696D657C7C652E75736572436F6E666967757265647C7C28692E657874656E73696F6E2626652E657874656E73696F6E3D';
wwv_flow_imp.g_varchar2_table(32417) := '3D3D692E657874656E73696F6E2626636F6E736F6C652E7761726E28604F76657277726974696E6720657874656E73696F6E203C3C247B692E657874656E73696F6E7D3E3E20746F206E6F7720706F696E7420746F206D696D65203C3C247B692E6D696D';
wwv_flow_imp.g_varchar2_table(32418) := '657D3E3E60292C692E66696C656E616D652626652E66696C656E616D653D3D3D692E66696C656E616D652626636F6E736F6C652E7761726E28604F76657277726974696E672066696C656E616D65203C3C247B692E66696C656E616D657D3E3E20746F20';
wwv_flow_imp.g_varchar2_table(32419) := '6E6F7720706F696E7420746F206D696D65203C3C247B692E6D696D657D3E3E60292C692E66696C657061747465726E2626652E66696C657061747465726E3D3D3D692E66696C657061747465726E2626636F6E736F6C652E7761726E28604F7665727772';
wwv_flow_imp.g_varchar2_table(32420) := '6974696E672066696C657061747465726E203C3C247B692E66696C657061747465726E7D3E3E20746F206E6F7720706F696E7420746F206D696D65203C3C247B692E6D696D657D3E3E60292C692E66697273746C696E652626652E66697273746C696E65';
wwv_flow_imp.g_varchar2_table(32421) := '3D3D3D692E66697273746C696E652626636F6E736F6C652E7761726E28604F76657277726974696E672066697273746C696E65203C3C247B692E66697273746C696E657D3E3E20746F206E6F7720706F696E7420746F206D696D65203C3C247B692E6D69';
wwv_flow_imp.g_varchar2_table(32422) := '6D657D3E3E6029297D29297D28652C302C74297D66756E6374696F6E2055696528652C742C6E297B76617220693B6C6574206F2C732C723B666F72286C657420613D6E2E6C656E6774682D313B613E3D303B612D2D297B636F6E7374206C3D6E5B615D3B';
wwv_flow_imp.g_varchar2_table(32423) := '696628743D3D3D6C2E66696C656E616D654C6F77657263617365297B6F3D6C3B627265616B7D6966286C2E66696C657061747465726E26262821737C7C6C2E66696C657061747465726E2E6C656E6774683E732E66696C657061747465726E2E6C656E67';
wwv_flow_imp.g_varchar2_table(32424) := '746829297B636F6E7374206E3D6C2E66696C657061747465726E4F6E506174683F653A743B286E756C6C3D3D3D28693D6C2E66696C657061747465726E4C6F77657263617365297C7C766F696420303D3D3D693F766F696420303A692E63616C6C286C2C';
wwv_flow_imp.g_varchar2_table(32425) := '6E2929262628733D6C297D6C2E657874656E73696F6E26262821727C7C6C2E657874656E73696F6E2E6C656E6774683E722E657874656E73696F6E2E6C656E677468292626742E656E647357697468286C2E657874656E73696F6E4C6F77657263617365';
wwv_flow_imp.g_varchar2_table(32426) := '29262628723D6C297D72657475726E206F7C7C737C7C727C7C766F696420307D636F6E7374204B69653D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C4769653D2276732E656469746F722E6E756C6C4C616E67756167';
wwv_flow_imp.g_varchar2_table(32427) := '65223B636C617373205169657B636F6E7374727563746F7228297B746869732E5F6C616E67756167654964546F4C616E67756167653D5B5D2C746869732E5F6C616E6775616765546F4C616E677561676549643D6E6577204D61702C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(32428) := '676973746572284769652C30292C746869732E5F72656769737465722855702C31292C746869732E5F6E6578744C616E677561676549643D327D5F726567697374657228652C74297B746869732E5F6C616E67756167654964546F4C616E67756167655B';
wwv_flow_imp.g_varchar2_table(32429) := '745D3D652C746869732E5F6C616E6775616765546F4C616E677561676549642E73657428652C74297D72656769737465722865297B696628746869732E5F6C616E6775616765546F4C616E677561676549642E6861732865292972657475726E3B636F6E';
wwv_flow_imp.g_varchar2_table(32430) := '737420743D746869732E5F6E6578744C616E677561676549642B2B3B746869732E5F726567697374657228652C74297D656E636F64654C616E677561676549642865297B72657475726E20746869732E5F6C616E6775616765546F4C616E677561676549';
wwv_flow_imp.g_varchar2_table(32431) := '642E6765742865297C7C307D6465636F64654C616E677561676549642865297B72657475726E20746869732E5F6C616E67756167654964546F4C616E67756167655B655D7C7C4769657D7D636C6173732059696520657874656E6473206C747B636F6E73';
wwv_flow_imp.g_varchar2_table(32432) := '74727563746F7228653D21302C743D2131297B737570657228292C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E';
wwv_flow_imp.g_varchar2_table(32433) := '67652E6576656E742C5969652E696E7374616E6365436F756E742B2B2C746869732E5F7761726E4F6E4F76657277726974653D742C746869732E6C616E67756167654964436F6465633D6E6577205169652C746869732E5F64796E616D69634C616E6775';
wwv_flow_imp.g_varchar2_table(32434) := '616765733D5B5D2C746869732E5F6C616E6775616765733D7B7D2C746869732E5F6D696D6554797065734D61703D7B7D2C746869732E5F6E616D654D61703D7B7D2C746869732E5F6C6F776572636173654E616D654D61703D7B7D2C6526262874686973';
wwv_flow_imp.g_varchar2_table(32435) := '2E5F696E697469616C697A6546726F6D526567697374727928292C746869732E5F72656769737465722824702E6F6E4469644368616E67654C616E6775616765732828653D3E7B746869732E5F696E697469616C697A6546726F6D526567697374727928';
wwv_flow_imp.g_varchar2_table(32436) := '297D292929297D646973706F736528297B5969652E696E7374616E6365436F756E742D2D2C73757065722E646973706F736528297D5F696E697469616C697A6546726F6D526567697374727928297B746869732E5F6C616E6775616765733D7B7D2C7468';
wwv_flow_imp.g_varchar2_table(32437) := '69732E5F6D696D6554797065734D61703D7B7D2C746869732E5F6E616D654D61703D7B7D2C746869732E5F6C6F776572636173654E616D654D61703D7B7D2C5769653D5769652E66696C7465722828653D3E652E75736572436F6E666967757265642929';
wwv_flow_imp.g_varchar2_table(32438) := '2C6A69653D5B5D3B636F6E737420653D5B5D2E636F6E6361742824702E6765744C616E6775616765732829292E636F6E63617428746869732E5F64796E616D69634C616E677561676573293B746869732E5F72656769737465724C616E67756167657328';
wwv_flow_imp.g_varchar2_table(32439) := '65297D5F72656769737465724C616E6775616765732865297B666F7228636F6E73742074206F66206529746869732E5F72656769737465724C616E67756167652874293B746869732E5F6D696D6554797065734D61703D7B7D2C746869732E5F6E616D65';
wwv_flow_imp.g_varchar2_table(32440) := '4D61703D7B7D2C746869732E5F6C6F776572636173654E616D654D61703D7B7D2C4F626A6563742E6B65797328746869732E5F6C616E677561676573292E666F72456163682828653D3E7B636F6E737420743D746869732E5F6C616E6775616765735B65';
wwv_flow_imp.g_varchar2_table(32441) := '5D3B742E6E616D65262628746869732E5F6E616D654D61705B742E6E616D655D3D742E6964656E746966696572292C742E616C69617365732E666F72456163682828653D3E7B746869732E5F6C6F776572636173654E616D654D61705B652E746F4C6F77';
wwv_flow_imp.g_varchar2_table(32442) := '65724361736528295D3D742E6964656E7469666965727D29292C742E6D696D6574797065732E666F72456163682828653D3E7B746869732E5F6D696D6554797065734D61705B655D3D742E6964656E7469666965727D29297D29292C79642E6173285470';
wwv_flow_imp.g_varchar2_table(32443) := '292E72656769737465724F766572726964654964656E7469666965727328746869732E676574526567697374657265644C616E67756167654964732829292C746869732E5F6F6E4469644368616E67652E6669726528297D5F72656769737465724C616E';
wwv_flow_imp.g_varchar2_table(32444) := '67756167652865297B636F6E737420743D652E69643B6C6574206E3B4B69652E63616C6C28746869732E5F6C616E6775616765732C74293F6E3D746869732E5F6C616E6775616765735B745D3A28746869732E6C616E67756167654964436F6465632E72';
wwv_flow_imp.g_varchar2_table(32445) := '656769737465722874292C6E3D7B6964656E7469666965723A742C6E616D653A6E756C6C2C6D696D6574797065733A5B5D2C616C69617365733A5B5D2C657874656E73696F6E733A5B5D2C66696C656E616D65733A5B5D2C636F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(32446) := '6E46696C65733A5B5D2C69636F6E733A5B5D7D2C746869732E5F6C616E6775616765735B745D3D6E292C746869732E5F6D657267654C616E6775616765286E2C65297D5F6D657267654C616E677561676528652C74297B636F6E7374206E3D742E69643B';
wwv_flow_imp.g_varchar2_table(32447) := '6C657420693D6E756C6C3B69662841727261792E6973417272617928742E6D696D657479706573292626742E6D696D6574797065732E6C656E6774683E30262628652E6D696D6574797065732E70757368282E2E2E742E6D696D657479706573292C693D';
wwv_flow_imp.g_varchar2_table(32448) := '742E6D696D6574797065735B305D292C697C7C28693D60746578742F782D247B6E7D602C652E6D696D6574797065732E70757368286929292C41727261792E6973417272617928742E657874656E73696F6E7329297B742E636F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(32449) := '6E3F652E657874656E73696F6E733D742E657874656E73696F6E732E636F6E63617428652E657874656E73696F6E73293A652E657874656E73696F6E733D652E657874656E73696F6E732E636F6E63617428742E657874656E73696F6E73293B666F7228';
wwv_flow_imp.g_varchar2_table(32450) := '636F6E73742065206F6620742E657874656E73696F6E7329246965287B69643A6E2C6D696D653A692C657874656E73696F6E3A657D2C746869732E5F7761726E4F6E4F7665727772697465297D69662841727261792E6973417272617928742E66696C65';
wwv_flow_imp.g_varchar2_table(32451) := '6E616D65732929666F7228636F6E7374206F206F6620742E66696C656E616D657329246965287B69643A6E2C6D696D653A692C66696C656E616D653A6F7D2C746869732E5F7761726E4F6E4F7665727772697465292C652E66696C656E616D65732E7075';
wwv_flow_imp.g_varchar2_table(32452) := '7368286F293B69662841727261792E6973417272617928742E66696C656E616D655061747465726E732929666F7228636F6E73742065206F6620742E66696C656E616D655061747465726E7329246965287B69643A6E2C6D696D653A692C66696C657061';
wwv_flow_imp.g_varchar2_table(32453) := '747465726E3A657D2C746869732E5F7761726E4F6E4F7665727772697465293B69662822737472696E67223D3D747970656F6620742E66697273744C696E652626742E66697273744C696E652E6C656E6774683E30297B6C657420653D742E6669727374';
wwv_flow_imp.g_varchar2_table(32454) := '4C696E653B225E22213D3D652E636861724174283029262628653D225E222B65293B7472797B636F6E737420743D6E6577205265674578702865293B225E22213D3D286F3D74292E736F757263652626225E2422213D3D6F2E736F757263652626222422';
wwv_flow_imp.g_varchar2_table(32455) := '213D3D6F2E736F757263652626225E5C5C732A2422213D3D6F2E736F7572636526266F2E65786563282222292626303D3D3D6F2E6C617374496E6465787C7C246965287B69643A6E2C6D696D653A692C66697273746C696E653A747D2C746869732E5F77';
wwv_flow_imp.g_varchar2_table(32456) := '61726E4F6E4F7665727772697465297D6361746368286E297B636F6E736F6C652E7761726E28605B247B742E69647D5D3A20496E76616C696420726567756C61722065787072657373696F6E205C60247B657D5C603A20602C6E297D7D766172206F3B65';
wwv_flow_imp.g_varchar2_table(32457) := '2E616C69617365732E70757368286E293B6C657420733D6E756C6C3B696628766F69642030213D3D742E616C6961736573262641727261792E6973417272617928742E616C696173657329262628733D303D3D3D742E616C69617365732E6C656E677468';
wwv_flow_imp.g_varchar2_table(32458) := '3F5B6E756C6C5D3A742E616C6961736573292C6E756C6C213D3D7329666F7228636F6E73742074206F6620732974262630213D3D742E6C656E6774682626652E616C69617365732E707573682874293B636F6E737420723D6E756C6C213D3D732626732E';
wwv_flow_imp.g_varchar2_table(32459) := '6C656E6774683E303B6966287226266E756C6C3D3D3D735B305D293B656C73657B636F6E737420743D28723F735B305D3A6E756C6C297C7C6E3B21722626652E6E616D657C7C28652E6E616D653D74297D742E636F6E66696775726174696F6E2626652E';
wwv_flow_imp.g_varchar2_table(32460) := '636F6E66696775726174696F6E46696C65732E7075736828742E636F6E66696775726174696F6E292C742E69636F6E2626652E69636F6E732E7075736828742E69636F6E297D6973526567697374657265644C616E677561676549642865297B72657475';
wwv_flow_imp.g_varchar2_table(32461) := '726E21216526264B69652E63616C6C28746869732E5F6C616E6775616765732C65297D676574526567697374657265644C616E677561676549647328297B72657475726E204F626A6563742E6B65797328746869732E5F6C616E677561676573297D6765';
wwv_flow_imp.g_varchar2_table(32462) := '744C616E6775616765496442794C616E67756167654E616D652865297B636F6E737420743D652E746F4C6F7765724361736528293B72657475726E204B69652E63616C6C28746869732E5F6C6F776572636173654E616D654D61702C74293F746869732E';
wwv_flow_imp.g_varchar2_table(32463) := '5F6C6F776572636173654E616D654D61705B745D3A6E756C6C7D6765744C616E6775616765496442794D696D65547970652865297B72657475726E206526264B69652E63616C6C28746869732E5F6D696D6554797065734D61702C65293F746869732E5F';
wwv_flow_imp.g_varchar2_table(32464) := '6D696D6554797065734D61705B655D3A6E756C6C7D67756573734C616E67756167654964427946696C65706174684F7246697273744C696E6528652C74297B72657475726E20657C7C743F66756E6374696F6E28652C74297B72657475726E2066756E63';
wwv_flow_imp.g_varchar2_table(32465) := '74696F6E28652C74297B6C6574206E3B696628652973776974636828652E736368656D65297B6361736520716F2E66696C653A6E3D652E6673506174683B627265616B3B6361736520716F2E646174613A6E3D69632E70617273654D6574614461746128';
wwv_flow_imp.g_varchar2_table(32466) := '65292E6765742869632E4D4554415F444154415F4C4142454C293B627265616B3B6361736520716F2E7673636F64654E6F7465626F6F6B43656C6C3A6E3D766F696420303B627265616B3B64656661756C743A6E3D652E706174687D696628216E297265';
wwv_flow_imp.g_varchar2_table(32467) := '7475726E5B7B69643A22756E6B6E6F776E222C6D696D653A45702E756E6B6E6F776E7D5D3B6E3D6E2E746F4C6F7765724361736528293B636F6E737420693D786F286E292C6F3D556965286E2C692C716965293B6966286F2972657475726E5B6F2C7B69';
wwv_flow_imp.g_varchar2_table(32468) := '643A55702C6D696D653A45702E746578747D5D3B636F6E737420733D556965286E2C692C6A6965293B696628732972657475726E5B732C7B69643A55702C6D696D653A45702E746578747D5D3B69662874297B636F6E737420653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(32469) := '65297B6966285569286529262628653D652E737562737472283129292C652E6C656E6774683E3029666F72286C657420743D5769652E6C656E6774682D313B743E3D303B742D2D297B636F6E7374206E3D5769655B745D3B696628216E2E66697273746C';
wwv_flow_imp.g_varchar2_table(32470) := '696E6529636F6E74696E75653B636F6E737420693D652E6D61746368286E2E66697273746C696E65293B696628692626692E6C656E6774683E302972657475726E206E7D7D2874293B696628652972657475726E5B652C7B69643A55702C6D696D653A45';
wwv_flow_imp.g_varchar2_table(32471) := '702E746578747D5D7D72657475726E5B7B69643A22756E6B6E6F776E222C6D696D653A45702E756E6B6E6F776E7D5D7D28652C74292E6D61702828653D3E652E696429297D28652C74293A5B5D7D7D5969652E696E7374616E6365436F756E743D303B63';
wwv_flow_imp.g_varchar2_table(32472) := '6C617373205A696520657874656E6473206C747B636F6E7374727563746F7228653D2131297B737570657228292C746869732E5F6F6E4469645265717565737442617369634C616E677561676546656174757265733D746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(32473) := '286E6577204374292C746869732E6F6E4469645265717565737442617369634C616E677561676546656174757265733D746869732E5F6F6E4469645265717565737442617369634C616E677561676546656174757265732E6576656E742C746869732E5F';
wwv_flow_imp.g_varchar2_table(32474) := '6F6E44696452657175657374526963684C616E677561676546656174757265733D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696452657175657374526963684C616E677561676546656174757265733D746869732E5F';
wwv_flow_imp.g_varchar2_table(32475) := '6F6E44696452657175657374526963684C616E677561676546656174757265732E6576656E742C746869732E5F6F6E4469644368616E67653D746869732E5F7265676973746572286E6577204374287B6C65616B5761726E696E675468726573686F6C64';
wwv_flow_imp.g_varchar2_table(32476) := '3A3230307D29292C746869732E6F6E4469644368616E67653D746869732E5F6F6E4469644368616E67652E6576656E742C746869732E5F72657175657374656442617369634C616E6775616765733D6E6577205365742C746869732E5F72657175657374';
wwv_flow_imp.g_varchar2_table(32477) := '6564526963684C616E6775616765733D6E6577205365742C5A69652E696E7374616E6365436F756E742B2B2C746869732E5F72656769737472793D746869732E5F7265676973746572286E6577205969652821302C6529292C746869732E6C616E677561';
wwv_flow_imp.g_varchar2_table(32478) := '67654964436F6465633D746869732E5F72656769737472792E6C616E67756167654964436F6465632C746869732E5F726567697374657228746869732E5F72656769737472792E6F6E4469644368616E6765282828293D3E746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(32479) := '68616E67652E6669726528292929297D646973706F736528297B5A69652E696E7374616E6365436F756E742D2D2C73757065722E646973706F736528297D6973526567697374657265644C616E677561676549642865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(32480) := '5F72656769737472792E6973526567697374657265644C616E677561676549642865297D6765744C616E6775616765496442794C616E67756167654E616D652865297B72657475726E20746869732E5F72656769737472792E6765744C616E6775616765';
wwv_flow_imp.g_varchar2_table(32481) := '496442794C616E67756167654E616D652865297D6765744C616E6775616765496442794D696D65547970652865297B72657475726E20746869732E5F72656769737472792E6765744C616E6775616765496442794D696D65547970652865297D67756573';
wwv_flow_imp.g_varchar2_table(32482) := '734C616E67756167654964427946696C65706174684F7246697273744C696E6528652C74297B72657475726E20246828746869732E5F72656769737472792E67756573734C616E67756167654964427946696C65706174684F7246697273744C696E6528';
wwv_flow_imp.g_varchar2_table(32483) := '652C74292C6E756C6C297D637265617465427949642865297B72657475726E206E65772058696528746869732E6F6E4469644368616E67652C2828293D3E746869732E5F637265617465416E644765744C616E67756167654964656E7469666965722865';
wwv_flow_imp.g_varchar2_table(32484) := '2929297D637265617465427946696C65706174684F7246697273744C696E6528652C74297B72657475726E206E65772058696528746869732E6F6E4469644368616E67652C2828293D3E7B636F6E7374206E3D746869732E67756573734C616E67756167';
wwv_flow_imp.g_varchar2_table(32485) := '654964427946696C65706174684F7246697273744C696E6528652C74293B72657475726E20746869732E5F637265617465416E644765744C616E67756167654964656E746966696572286E297D29297D5F637265617465416E644765744C616E67756167';
wwv_flow_imp.g_varchar2_table(32486) := '654964656E7469666965722865297B72657475726E20652626746869732E6973526567697374657265644C616E677561676549642865297C7C28653D5570292C657D7265717565737442617369634C616E677561676546656174757265732865297B7468';
wwv_flow_imp.g_varchar2_table(32487) := '69732E5F72657175657374656442617369634C616E6775616765732E6861732865297C7C28746869732E5F72657175657374656442617369634C616E6775616765732E6164642865292C746869732E5F6F6E4469645265717565737442617369634C616E';
wwv_flow_imp.g_varchar2_table(32488) := '677561676546656174757265732E66697265286529297D72657175657374526963684C616E677561676546656174757265732865297B746869732E5F726571756573746564526963684C616E6775616765732E6861732865297C7C28746869732E5F7265';
wwv_flow_imp.g_varchar2_table(32489) := '71756573746564526963684C616E6775616765732E6164642865292C746869732E7265717565737442617369634C616E677561676546656174757265732865292C50772E6765744F724372656174652865292C746869732E5F6F6E446964526571756573';
wwv_flow_imp.g_varchar2_table(32490) := '74526963684C616E677561676546656174757265732E66697265286529297D7D5A69652E696E7374616E6365436F756E743D303B636C617373205869657B636F6E7374727563746F7228652C74297B746869732E5F6F6E4469644368616E67654C616E67';
wwv_flow_imp.g_varchar2_table(32491) := '75616765733D652C746869732E5F73656C6563746F723D742C746869732E5F6C697374656E65723D6E756C6C2C746869732E5F656D69747465723D6E756C6C2C746869732E6C616E677561676549643D746869732E5F73656C6563746F7228297D5F6469';
wwv_flow_imp.g_varchar2_table(32492) := '73706F736528297B746869732E5F6C697374656E6572262628746869732E5F6C697374656E65722E646973706F736528292C746869732E5F6C697374656E65723D6E756C6C292C746869732E5F656D6974746572262628746869732E5F656D6974746572';
wwv_flow_imp.g_varchar2_table(32493) := '2E646973706F736528292C746869732E5F656D69747465723D6E756C6C297D676574206F6E4469644368616E676528297B72657475726E20746869732E5F6C697374656E65727C7C28746869732E5F6C697374656E65723D746869732E5F6F6E44696443';
wwv_flow_imp.g_varchar2_table(32494) := '68616E67654C616E677561676573282828293D3E746869732E5F6576616C7561746528292929292C746869732E5F656D69747465727C7C28746869732E5F656D69747465723D6E6577204374287B6F6E44696452656D6F76654C6173744C697374656E65';
wwv_flow_imp.g_varchar2_table(32495) := '723A28293D3E7B746869732E5F646973706F736528297D7D29292C746869732E5F656D69747465722E6576656E747D5F6576616C7561746528297B76617220653B636F6E737420743D746869732E5F73656C6563746F7228293B74213D3D746869732E6C';
wwv_flow_imp.g_varchar2_table(32496) := '616E67756167654964262628746869732E6C616E677561676549643D742C6E756C6C3D3D3D28653D746869732E5F656D6974746572297C7C766F696420303D3D3D657C7C652E6669726528746869732E6C616E6775616765496429297D7D636F6E737420';
wwv_flow_imp.g_varchar2_table(32497) := '4A69653D2F5C2826285B5E5C73265D295C297C285E7C5B5E265D2926285B5E5C73265D292F2C656F653D2F2826616D703B293F2826616D703B29285B5E5C73265D292F673B76617220746F652C6E6F653B2166756E6374696F6E2865297B655B652E5269';
wwv_flow_imp.g_varchar2_table(32498) := '6768743D305D3D225269676874222C655B652E4C6566743D315D3D224C656674227D28746F657C7C28746F653D7B7D29292C66756E6374696F6E2865297B655B652E41626F76653D305D3D2241626F7665222C655B652E42656C6F773D315D3D2242656C';
wwv_flow_imp.g_varchar2_table(32499) := '6F77227D286E6F657C7C286E6F653D7B7D29293B636C61737320696F6520657874656E6473206C4D7B636F6E7374727563746F7228652C742C6E2C69297B652E636C6173734C6973742E61646428226D6F6E61636F2D6D656E752D636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(32500) := '22292C652E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22293B636F6E7374206F3D646F63756D656E742E637265617465456C656D656E74282264697622293B6F2E636C6173734C6973742E61646428226D6F6E61';
wwv_flow_imp.g_varchar2_table(32501) := '636F2D6D656E7522292C6F2E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22292C7375706572286F2C7B6F7269656E746174696F6E3A312C616374696F6E566965774974656D50726F76696465723A653D3E746869';
wwv_flow_imp.g_varchar2_table(32502) := '732E646F476574416374696F6E566965774974656D28652C6E2C73292C636F6E746578743A6E2E636F6E746578742C616374696F6E52756E6E65723A6E2E616374696F6E52756E6E65722C617269614C6162656C3A6E2E617269614C6162656C2C617269';
wwv_flow_imp.g_varchar2_table(32503) := '61526F6C653A226D656E75222C666F6375734F6E6C79456E61626C65644974656D733A21302C747269676765724B6579733A7B6B6579733A5B332C2E2E2E717C7C243F5B31305D3A5B5D5D2C6B6579446F776E3A21307D7D292C746869732E6D656E7553';
wwv_flow_imp.g_varchar2_table(32504) := '74796C65733D692C746869732E6D656E75456C656D656E743D6F2C746869732E616374696F6E734C6973742E746162496E6465783D302C746869732E696E697469616C697A654F725570646174655374796C65536865657428652C69292C746869732E5F';
wwv_flow_imp.g_varchar2_table(32505) := '72656769737465722849452E616464546172676574286F29292C746869732E5F7265676973746572286273286F2C61722E4B45595F444F574E2C28653D3E7B6E65772071652865292E657175616C732832292626652E70726576656E7444656661756C74';
wwv_flow_imp.g_varchar2_table(32506) := '28297D2929292C6E2E656E61626C654D6E656D6F6E6963732626746869732E5F7265676973746572286273286F2C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D652E6B65792E746F4C6F63616C654C6F7765724361736528293B696628';
wwv_flow_imp.g_varchar2_table(32507) := '746869732E6D6E656D6F6E6963732E686173287429297B637228652C2130293B636F6E7374206E3D746869732E6D6E656D6F6E6963732E6765742874293B696628313D3D3D6E2E6C656E6774682626286E5B305D696E7374616E63656F6620736F652626';
wwv_flow_imp.g_varchar2_table(32508) := '6E5B305D2E636F6E7461696E65722626746869732E666F6375734974656D4279456C656D656E74286E5B305D2E636F6E7461696E6572292C6E5B305D2E6F6E436C69636B286529292C6E2E6C656E6774683E31297B636F6E737420653D6E2E7368696674';
wwv_flow_imp.g_varchar2_table(32509) := '28293B652626652E636F6E7461696E6572262628746869732E666F6375734974656D4279456C656D656E7428652E636F6E7461696E6572292C6E2E70757368286529292C746869732E6D6E656D6F6E6963732E73657428742C6E297D7D7D2929292C2426';
wwv_flow_imp.g_varchar2_table(32510) := '26746869732E5F7265676973746572286273286F2C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B742E657175616C73283134297C7C742E657175616C73283131293F28746869732E666F63757365644974656D';
wwv_flow_imp.g_varchar2_table(32511) := '3D746869732E766965774974656D732E6C656E6774682D312C746869732E666F6375734E65787428292C637228652C213029293A28742E657175616C73283133297C7C742E657175616C732831322929262628746869732E666F63757365644974656D3D';
wwv_flow_imp.g_varchar2_table(32512) := '302C746869732E666F63757350726576696F757328292C637228652C213029297D2929292C746869732E5F726567697374657228627328746869732E646F6D4E6F64652C61722E4D4F5553455F4F55542C28653D3E7B427328652E72656C617465645461';
wwv_flow_imp.g_varchar2_table(32513) := '726765742C746869732E646F6D4E6F6465297C7C28746869732E666F63757365644974656D3D766F696420302C746869732E757064617465466F63757328292C652E73746F7050726F7061676174696F6E2829297D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(32514) := '74657228627328746869732E616374696F6E734C6973742C61722E4D4F5553455F4F5645522C28653D3E7B6C657420743D652E7461726765743B696628742626427328742C746869732E616374696F6E734C69737429262674213D3D746869732E616374';
wwv_flow_imp.g_varchar2_table(32515) := '696F6E734C697374297B666F72283B742E706172656E74456C656D656E74213D3D746869732E616374696F6E734C69737426266E756C6C213D3D742E706172656E74456C656D656E743B29743D742E706172656E74456C656D656E743B696628742E636C';
wwv_flow_imp.g_varchar2_table(32516) := '6173734C6973742E636F6E7461696E732822616374696F6E2D6974656D2229297B636F6E737420653D746869732E666F63757365644974656D3B746869732E736574466F63757365644974656D2874292C65213D3D746869732E666F6375736564497465';
wwv_flow_imp.g_varchar2_table(32517) := '6D2626746869732E757064617465466F63757328297D7D7D2929292C746869732E5F72656769737465722849452E61646454617267657428746869732E616374696F6E734C69737429292C746869732E5F726567697374657228627328746869732E6163';
wwv_flow_imp.g_varchar2_table(32518) := '74696F6E734C6973742C54452E5461702C28653D3E7B6C657420743D652E696E697469616C5461726765743B696628742626427328742C746869732E616374696F6E734C69737429262674213D3D746869732E616374696F6E734C697374297B666F7228';
wwv_flow_imp.g_varchar2_table(32519) := '3B742E706172656E74456C656D656E74213D3D746869732E616374696F6E734C69737426266E756C6C213D3D742E706172656E74456C656D656E743B29743D742E706172656E74456C656D656E743B696628742E636C6173734C6973742E636F6E746169';
wwv_flow_imp.g_varchar2_table(32520) := '6E732822616374696F6E2D6974656D2229297B636F6E737420653D746869732E666F63757365644974656D3B746869732E736574466F63757365644974656D2874292C65213D3D746869732E666F63757365644974656D2626746869732E757064617465';
wwv_flow_imp.g_varchar2_table(32521) := '466F63757328297D7D7D2929293B636F6E737420733D7B706172656E743A746869737D3B746869732E6D6E656D6F6E6963733D6E6577204D61702C746869732E7363726F6C6C61626C65456C656D656E743D746869732E5F7265676973746572286E6577';
wwv_flow_imp.g_varchar2_table(32522) := '206754286F2C7B616C77617973436F6E73756D654D6F757365576865656C3A21302C686F72697A6F6E74616C3A322C766572746963616C3A332C766572746963616C5363726F6C6C62617253697A653A372C68616E646C654D6F757365576865656C3A21';
wwv_flow_imp.g_varchar2_table(32523) := '302C757365536861646F77733A21307D29293B636F6E737420723D746869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F646528293B722E7374796C652E706F736974696F6E3D22222C746869732E7374796C655363726F6C6C45';
wwv_flow_imp.g_varchar2_table(32524) := '6C656D656E7428722C69292C746869732E5F7265676973746572286273286F2C54452E4368616E67652C28653D3E7B637228652C2130293B636F6E737420743D746869732E7363726F6C6C61626C65456C656D656E742E6765745363726F6C6C506F7369';
wwv_flow_imp.g_varchar2_table(32525) := '74696F6E28292E7363726F6C6C546F703B746869732E7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A742D652E7472616E736C6174696F6E597D297D2929292C746869732E5F7265';
wwv_flow_imp.g_varchar2_table(32526) := '67697374657228627328722C61722E4D4F5553455F55502C28653D3E7B652E70726576656E7444656661756C7428297D2929293B636F6E737420613D72732865293B6F2E7374796C652E6D61784865696768743D60247B4D6174682E6D61782831302C61';
wwv_flow_imp.g_varchar2_table(32527) := '2E696E6E65724865696768742D652E676574426F756E64696E67436C69656E745265637428292E746F702D3335297D7078602C743D742E66696C746572282828652C69293D3E7B766172206F3B6966286E756C6C3D3D3D286F3D6E2E7375626D656E7549';
wwv_flow_imp.g_varchar2_table(32528) := '6473297C7C766F696420303D3D3D6F3F766F696420303A6F2E68617328652E6964292972657475726E20636F6E736F6C652E7761726E2860466F756E64207375626D656E75206379636C653A20247B652E69647D60292C21313B6966286520696E737461';
wwv_flow_imp.g_varchar2_table(32529) := '6E63656F66207963297B696628693D3D3D742E6C656E6774682D317C7C303D3D3D692972657475726E21313B696628745B692D315D696E7374616E63656F662079632972657475726E21317D72657475726E21307D29292C746869732E7075736828742C';
wwv_flow_imp.g_varchar2_table(32530) := '7B69636F6E3A21302C6C6162656C3A21302C69734D656E753A21307D292C652E617070656E644368696C6428746869732E7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F64652829292C746869732E7363726F6C6C61626C65456C656D';
wwv_flow_imp.g_varchar2_table(32531) := '656E742E7363616E446F6D4E6F646528292C746869732E766965774974656D732E66696C7465722828653D3E21286520696E7374616E63656F6620726F652929292E666F7245616368282828652C742C6E293D3E7B652E757064617465506F736974696F';
wwv_flow_imp.g_varchar2_table(32532) := '6E496E53657428742B312C6E2E6C656E677468297D29297D696E697469616C697A654F725570646174655374796C65536865657428652C74297B746869732E7374796C6553686565747C7C2848732865293F746869732E7374796C6553686565743D5973';
wwv_flow_imp.g_varchar2_table(32533) := '2865293A28696F652E676C6F62616C5374796C6553686565747C7C28696F652E676C6F62616C5374796C6553686565743D59732829292C746869732E7374796C6553686565743D696F652E676C6F62616C5374796C65536865657429292C746869732E73';
wwv_flow_imp.g_varchar2_table(32534) := '74796C6553686565742E74657874436F6E74656E743D66756E6374696F6E28652C74297B6C6574206E3D605C6E2E6D6F6E61636F2D6D656E75207B5C6E5C74666F6E742D73697A653A20313370783B5C6E5C74626F726465722D7261646975733A203570';
wwv_flow_imp.g_varchar2_table(32535) := '783B5C6E5C746D696E2D77696474683A2031363070783B5C6E7D5C6E5C6E247B616F65284C6C2E6D656E7553656C656374696F6E297D5C6E247B616F65284C6C2E6D656E755375626D656E75297D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(32536) := '636F2D616374696F6E2D626172207B5C6E5C74746578742D616C69676E3A2072696768743B5C6E5C746F766572666C6F773A2068696464656E3B5C6E5C7477686974652D73706163653A206E6F777261703B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E';
wwv_flow_imp.g_varchar2_table(32537) := '75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E732D636F6E7461696E6572207B5C6E5C74646973706C61793A20666C65783B5C6E5C746D617267696E3A2030206175746F3B5C6E5C7470616464696E673A20303B5C6E5C74776964';
wwv_flow_imp.g_varchar2_table(32538) := '74683A20313030253B5C6E5C746A7573746966792D636F6E74656E743A20666C65782D656E643B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E732D636F6E74';
wwv_flow_imp.g_varchar2_table(32539) := '61696E6572207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E72657665727365202E616374696F6E732D636F6E7461696E6572207B';
wwv_flow_imp.g_varchar2_table(32540) := '5C6E5C74666C65782D646972656374696F6E3A20726F772D726576657273653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D207B5C6E5C74637572736F723A20706F69';
wwv_flow_imp.g_varchar2_table(32541) := '6E7465723B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C747472616E736974696F6E3A207472616E73666F726D2035306D7320656173653B5C6E5C74706F736974696F6E3A2072656C61746976653B20202F2A20444F204E4F';
wwv_flow_imp.g_varchar2_table(32542) := '542052454D4F5645202D207468697320697320746865206B657920746F2070726576656E74696E67207468652067686F7374696E672069636F6E2062756720696E204368726F6D65203432202A2F5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D';
wwv_flow_imp.g_varchar2_table(32543) := '6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E64697361626C6564207B5C6E5C74637572736F723A2064656661756C743B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E';
wwv_flow_imp.g_varchar2_table(32544) := '616374696F6E2D6974656D202E69636F6E2C5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E636F6469636F6E207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B';
wwv_flow_imp.g_varchar2_table(32545) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D202E636F6469636F6E207B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A206365';
wwv_flow_imp.g_varchar2_table(32546) := '6E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C74666F6E742D73697A653A20313170783B5C6E5C746D617267696E2D72696768743A20347078';
wwv_flow_imp.g_varchar2_table(32547) := '3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E64697361626C6564202E616374696F6E2D6C6162656C2C5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D61';
wwv_flow_imp.g_varchar2_table(32548) := '6374696F6E2D626172202E616374696F6E2D6974656D2E64697361626C6564202E616374696F6E2D6C6162656C3A686F766572207B5C6E5C74636F6C6F723A20766172282D2D7673636F64652D64697361626C6564466F726567726F756E64293B5C6E7D';
wwv_flow_imp.g_varchar2_table(32549) := '5C6E5C6E2F2A20566572746963616C20616374696F6E73202A2F5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C207B5C6E5C74746578742D616C69676E3A206C6566743B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(32550) := '2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D207B5C6E5C74646973706C61793A20626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(32551) := '6F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C2E736570617261746F72207B5C6E5C74646973706C61793A20626C6F636B3B5C6E5C74626F726465722D626F74746F6D3A2031707820736F6C696420766172282D';
wwv_flow_imp.g_varchar2_table(32552) := '2D7673636F64652D6D656E752D736570617261746F724261636B67726F756E64293B5C6E5C7470616464696E672D746F703A203170783B5C6E5C7470616464696E673A20333070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E7365636F6E64';
wwv_flow_imp.g_varchar2_table(32553) := '6172792D616374696F6E73202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6C6162656C207B5C6E5C746D617267696E2D6C6566743A203670783B5C6E7D5C6E5C6E2F2A20416374696F6E204974656D73202A2F5C6E2E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(32554) := '6F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172202E616374696F6E2D6974656D2E73656C6563742D636F6E7461696E6572207B5C6E5C746F766572666C6F773A2068696464656E3B202F2A20736F6D65686F77207468652064726F70646F';
wwv_flow_imp.g_varchar2_table(32555) := '776E206F766572666C6F77732069747320636F6E7461696E65722C2077652070726576656E74206974206865726520746F206E6F742070757368202A2F5C6E5C74666C65783A20313B5C6E5C746D61782D77696474683A2031373070783B5C6E5C746D69';
wwv_flow_imp.g_varchar2_table(32556) := '6E2D77696474683A20363070783B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E74656E743A2063656E7465723B5C6E5C746D617267696E2D7269676874';
wwv_flow_imp.g_varchar2_table(32557) := '3A20313070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C207B5C6E5C746D617267696E2D6C6566743A20303B5C6E5C746F766572666C6F773A2076697369626C653B5C6E7D';
wwv_flow_imp.g_varchar2_table(32558) := '5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E732D636F6E7461696E6572207B5C6E5C74646973706C61793A20626C6F636B3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D';
wwv_flow_imp.g_varchar2_table(32559) := '656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D207B5C6E5C7470616464696E673A20303B5C6E5C747472616E73666F726D3A206E6F6E653B5C6E5C74646973706C61793A20666C65783B5C';
wwv_flow_imp.g_varchar2_table(32560) := '6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D2E616374697665207B5C6E5C747472616E73666F726D3A206E6F6E653B5C6E7D5C6E5C6E2E6D6F6E61';
wwv_flow_imp.g_varchar2_table(32561) := '636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6D656E752D6974656D207B5C6E5C74666C65783A20312031206175746F3B5C6E5C74646973706C61793A20666C65783B5C6E5C7468656967';
wwv_flow_imp.g_varchar2_table(32562) := '68743A2032656D3B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C74706F736974696F6E3A2072656C61746976653B5C6E5C746D617267696E3A2030203470783B5C6E5C74626F726465722D7261646975733A203470783B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(32563) := '6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6D656E752D6974656D3A686F766572202E6B657962696E64696E672C5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61';
wwv_flow_imp.g_varchar2_table(32564) := '636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6D656E752D6974656D3A666F637573202E6B657962696E64696E67207B5C6E5C746F7061636974793A20756E7365743B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E';
wwv_flow_imp.g_varchar2_table(32565) := '6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C207B5C6E5C74666C65783A20312031206175746F3B5C6E5C74746578742D6465636F726174696F6E3A206E6F6E653B5C6E5C7470616464696E673A20';
wwv_flow_imp.g_varchar2_table(32566) := '302031656D3B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C746C696E652D6865696768743A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E';
wwv_flow_imp.g_varchar2_table(32567) := '2D6261722E766572746963616C202E6B657962696E64696E672C5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E7375626D656E752D696E64696361746F72207B5C6E5C74646973706C6179';
wwv_flow_imp.g_varchar2_table(32568) := '3A20696E6C696E652D626C6F636B3B5C6E5C74666C65783A20322031206175746F3B5C6E5C7470616464696E673A20302031656D3B5C6E5C74746578742D616C69676E3A2072696768743B5C6E5C74666F6E742D73697A653A20313270783B5C6E5C746C';
wwv_flow_imp.g_varchar2_table(32569) := '696E652D6865696768743A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E7375626D656E752D696E64696361746F72207B5C6E5C746865696768743A20313030253B5C';
wwv_flow_imp.g_varchar2_table(32570) := '6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E7375626D656E752D696E64696361746F722E636F6469636F6E207B5C6E5C74666F6E742D73697A653A20313670782021696D706F';
wwv_flow_imp.g_varchar2_table(32571) := '7274616E743B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E737562';
wwv_flow_imp.g_varchar2_table(32572) := '6D656E752D696E64696361746F722E636F6469636F6E3A3A6265666F7265207B5C6E5C746D617267696E2D6C6566743A206175746F3B5C6E5C746D617267696E2D72696768743A202D323070783B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D';
wwv_flow_imp.g_varchar2_table(32573) := '6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D2E64697361626C6564202E6B657962696E64696E672C5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963';
wwv_flow_imp.g_varchar2_table(32574) := '616C202E616374696F6E2D6974656D2E64697361626C6564202E7375626D656E752D696E64696361746F72207B5C6E5C746F7061636974793A20302E343B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172';
wwv_flow_imp.g_varchar2_table(32575) := '2E766572746963616C202E616374696F6E2D6C6162656C3A6E6F74282E736570617261746F7229207B5C6E5C74646973706C61793A20696E6C696E652D626C6F636B3B5C6E5C74626F782D73697A696E673A20626F726465722D626F783B5C6E5C746D61';
wwv_flow_imp.g_varchar2_table(32576) := '7267696E3A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D207B5C6E5C74706F736974696F6E3A207374617469633B5C6E5C746F76657266';
wwv_flow_imp.g_varchar2_table(32577) := '6C6F773A2076697369626C653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D202E6D6F6E61636F2D7375626D656E75207B5C6E5C74706F736974';
wwv_flow_imp.g_varchar2_table(32578) := '696F6E3A206162736F6C7574653B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C2E736570617261746F72207B5C6E5C7477696474683A203130';
wwv_flow_imp.g_varchar2_table(32579) := '30253B5C6E5C746865696768743A203070782021696D706F7274616E743B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E';
wwv_flow_imp.g_varchar2_table(32580) := '2D6C6162656C2E736570617261746F722E74657874207B5C6E5C7470616464696E673A20302E37656D2031656D20302E31656D2031656D3B5C6E5C74666F6E742D7765696768743A20626F6C643B5C6E5C746F7061636974793A20313B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(32581) := '2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C3A686F766572207B5C6E5C74636F6C6F723A20696E68657269743B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75';
wwv_flow_imp.g_varchar2_table(32582) := '202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E6D656E752D6974656D2D636865636B207B5C6E5C74706F736974696F6E3A206162736F6C7574653B5C6E5C747669736962696C6974793A2068696464656E3B5C6E5C74776964';
wwv_flow_imp.g_varchar2_table(32583) := '74683A2031656D3B5C6E5C746865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6D656E752D6974656D2E636865636B6564202E';
wwv_flow_imp.g_varchar2_table(32584) := '6D656E752D6974656D2D636865636B207B5C6E5C747669736962696C6974793A2076697369626C653B5C6E5C74646973706C61793A20666C65783B5C6E5C74616C69676E2D6974656D733A2063656E7465723B5C6E5C746A7573746966792D636F6E7465';
wwv_flow_imp.g_varchar2_table(32585) := '6E743A2063656E7465723B5C6E7D5C6E5C6E2F2A20436F6E74657874204D656E75202A2F5C6E5C6E2E636F6E746578742D766965772E6D6F6E61636F2D6D656E752D636F6E7461696E6572207B5C6E5C746F75746C696E653A20303B5C6E5C74626F7264';
wwv_flow_imp.g_varchar2_table(32586) := '65723A206E6F6E653B5C6E5C74616E696D6174696F6E3A2066616465496E20302E30383373206C696E6561723B5C6E5C742D7765626B69742D6170702D726567696F6E3A206E6F2D647261673B5C6E7D5C6E5C6E2E636F6E746578742D766965772E6D6F';
wwv_flow_imp.g_varchar2_table(32587) := '6E61636F2D6D656E752D636F6E7461696E6572203A666F6375732C5C6E2E636F6E746578742D766965772E6D6F6E61636F2D6D656E752D636F6E7461696E6572202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C3A666F6375732C5C';
wwv_flow_imp.g_varchar2_table(32588) := '6E2E636F6E746578742D766965772E6D6F6E61636F2D6D656E752D636F6E7461696E6572202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C203A666F637573207B5C6E5C746F75746C696E653A20303B5C6E7D5C6E5C6E2E68632D62';
wwv_flow_imp.g_varchar2_table(32589) := '6C61636B202E636F6E746578742D766965772E6D6F6E61636F2D6D656E752D636F6E7461696E65722C5C6E2E68632D6C69676874202E636F6E746578742D766965772E6D6F6E61636F2D6D656E752D636F6E7461696E65722C5C6E3A686F73742D636F6E';
wwv_flow_imp.g_varchar2_table(32590) := '74657874282E68632D626C61636B29202E636F6E746578742D766965772E6D6F6E61636F2D6D656E752D636F6E7461696E65722C5C6E3A686F73742D636F6E74657874282E68632D6C6967687429202E636F6E746578742D766965772E6D6F6E61636F2D';
wwv_flow_imp.g_varchar2_table(32591) := '6D656E752D636F6E7461696E6572207B5C6E5C74626F782D736861646F773A206E6F6E653B5C6E7D5C6E5C6E2E68632D626C61636B202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E61637469';
wwv_flow_imp.g_varchar2_table(32592) := '6F6E2D6974656D2E666F63757365642C5C6E2E68632D6C69676874202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D2E666F63757365642C5C6E3A686F73742D636F';
wwv_flow_imp.g_varchar2_table(32593) := '6E74657874282E68632D626C61636B29202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D2E666F63757365642C5C6E3A686F73742D636F6E74657874282E68632D6C';
wwv_flow_imp.g_varchar2_table(32594) := '6967687429202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6974656D2E666F6375736564207B5C6E5C746261636B67726F756E643A206E6F6E653B5C6E7D5C6E5C6E2F2A20';
wwv_flow_imp.g_varchar2_table(32595) := '566572746963616C20416374696F6E20426172205374796C6573202A2F5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C207B5C6E5C7470616464696E673A2034707820303B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(32596) := '6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6D656E752D6974656D207B5C6E5C746865696768743A2032656D3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F';
wwv_flow_imp.g_varchar2_table(32597) := '6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C3A6E6F74282E736570617261746F72292C5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E6B';
wwv_flow_imp.g_varchar2_table(32598) := '657962696E64696E67207B5C6E5C74666F6E742D73697A653A20696E68657269743B5C6E5C7470616464696E673A20302032656D3B5C6E5C746D61782D6865696768743A20313030253B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E6163';
wwv_flow_imp.g_varchar2_table(32599) := '6F2D616374696F6E2D6261722E766572746963616C202E6D656E752D6974656D2D636865636B207B5C6E5C74666F6E742D73697A653A20696E68657269743B5C6E5C7477696474683A2032656D3B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D';
wwv_flow_imp.g_varchar2_table(32600) := '6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C2E736570617261746F72207B5C6E5C74666F6E742D73697A653A20696E68657269743B5C6E5C746D617267696E3A2035707820302021696D706F727461';
wwv_flow_imp.g_varchar2_table(32601) := '6E743B5C6E5C7470616464696E673A20303B5C6E5C74626F726465722D7261646975733A20303B5C6E7D5C6E5C6E2E6C696E7578202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F';
wwv_flow_imp.g_varchar2_table(32602) := '6E2D6C6162656C2E736570617261746F722C5C6E3A686F73742D636F6E74657874282E6C696E757829202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E616374696F6E2D6C6162656C2E736570';
wwv_flow_imp.g_varchar2_table(32603) := '617261746F72207B5C6E5C746D617267696E2D6C6566743A20303B5C6E5C746D617267696E2D72696768743A20303B5C6E7D5C6E5C6E2E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E7375626D';
wwv_flow_imp.g_varchar2_table(32604) := '656E752D696E64696361746F72207B5C6E5C74666F6E742D73697A653A203630253B5C6E5C7470616464696E673A203020312E38656D3B5C6E7D5C6E5C6E2E6C696E7578202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D626172';
wwv_flow_imp.g_varchar2_table(32605) := '2E766572746963616C202E7375626D656E752D696E64696361746F722C5C6E3A686F73742D636F6E74657874282E6C696E757829202E6D6F6E61636F2D6D656E75202E6D6F6E61636F2D616374696F6E2D6261722E766572746963616C202E7375626D65';
wwv_flow_imp.g_varchar2_table(32606) := '6E752D696E64696361746F72207B5C6E5C746865696768743A20313030253B5C6E5C746D61736B2D73697A653A203130707820313070783B5C6E5C742D7765626B69742D6D61736B2D73697A653A203130707820313070783B5C6E7D5C6E5C6E2E6D6F6E';
wwv_flow_imp.g_varchar2_table(32607) := '61636F2D6D656E75202E616374696F6E2D6974656D207B5C6E5C74637572736F723A2064656661756C743B5C6E7D603B69662874297B6E2B3D225C6E5C745C745C742F2A204172726F7773202A2F5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C';
wwv_flow_imp.g_varchar2_table(32608) := '61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E73637261207B5C6E5C745C745C745C74637572736F723A20706F696E7465723B5C6E5C745C745C745C74666F6E742D73697A653A20313170782021696D706F7274616E743B5C6E';
wwv_flow_imp.g_varchar2_table(32609) := '5C745C745C747D5C6E5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E76697369626C65207B5C6E5C745C745C745C746F7061636974793A20313B5C6E5C6E5C745C745C745C742F2A204261636B67726F75';
wwv_flow_imp.g_varchar2_table(32610) := '6E642072756C6520616464656420666F7220494539202D20746F20616C6C6F7720636C69636B73206F6E20646F6D206E6F6465202A2F5C6E5C745C745C745C746261636B67726F756E643A7267626128302C302C302C30293B5C6E5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(32611) := '747472616E736974696F6E3A206F706163697479203130306D73206C696E6561723B5C6E5C745C745C747D5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E696E76697369626C65207B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(32612) := '5C746F7061636974793A20303B5C6E5C745C745C745C74706F696E7465722D6576656E74733A206E6F6E653B5C6E5C745C745C747D5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E696E76697369626C65';
wwv_flow_imp.g_varchar2_table(32613) := '2E66616465207B5C6E5C745C745C745C747472616E736974696F6E3A206F706163697479203830306D73206C696E6561723B5C6E5C745C745C747D5C6E5C6E5C745C745C742F2A205363726F6C6C61626C6520436F6E74656E7420496E73657420536861';
wwv_flow_imp.g_varchar2_table(32614) := '646F77202A2F5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F77207B5C6E5C745C745C745C74706F736974696F6E3A206162736F6C7574653B5C6E5C745C745C745C74646973706C61793A20';
wwv_flow_imp.g_varchar2_table(32615) := '6E6F6E653B5C6E5C745C745C747D5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F772E746F70207B5C6E5C745C745C745C74646973706C61793A20626C6F636B3B5C6E5C745C745C745C7474';
wwv_flow_imp.g_varchar2_table(32616) := '6F703A20303B5C6E5C745C745C745C746C6566743A203370783B5C6E5C745C745C745C746865696768743A203370783B5C6E5C745C745C745C7477696474683A20313030253B5C6E5C745C745C747D5C6E5C745C745C742E6D6F6E61636F2D7363726F6C';
wwv_flow_imp.g_varchar2_table(32617) := '6C61626C652D656C656D656E74203E202E736861646F772E6C656674207B5C6E5C745C745C745C74646973706C61793A20626C6F636B3B5C6E5C745C745C745C74746F703A203370783B5C6E5C745C745C745C746C6566743A20303B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(32618) := '5C746865696768743A20313030253B5C6E5C745C745C745C7477696474683A203370783B5C6E5C745C745C747D5C6E5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F772E746F702D6C6566742D63';
wwv_flow_imp.g_varchar2_table(32619) := '6F726E6572207B5C6E5C745C745C745C74646973706C61793A20626C6F636B3B5C6E5C745C745C745C74746F703A20303B5C6E5C745C745C745C746C6566743A20303B5C6E5C745C745C745C746865696768743A203370783B5C6E5C745C745C745C7477';
wwv_flow_imp.g_varchar2_table(32620) := '696474683A203370783B5C6E5C745C745C747D5C6E5C745C74223B636F6E737420743D652E7363726F6C6C626172536861646F773B742626286E2B3D605C6E5C745C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E20';
wwv_flow_imp.g_varchar2_table(32621) := '2E736861646F772E746F70207B5C6E5C745C745C745C745C74626F782D736861646F773A20247B747D20302036707820367078202D36707820696E7365743B5C6E5C745C745C745C747D5C6E5C6E5C745C745C745C742E6D6F6E61636F2D7363726F6C6C';
wwv_flow_imp.g_varchar2_table(32622) := '61626C652D656C656D656E74203E202E736861646F772E6C656674207B5C6E5C745C745C745C745C74626F782D736861646F773A20247B747D20367078203020367078202D36707820696E7365743B5C6E5C745C745C745C747D5C6E5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(32623) := '5C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E736861646F772E746F702E6C656674207B5C6E5C745C745C745C745C74626F782D736861646F773A20247B747D203670782036707820367078202D36707820696E736574';
wwv_flow_imp.g_varchar2_table(32624) := '3B5C6E5C745C745C745C747D5C6E5C745C745C7460293B636F6E737420693D652E7363726F6C6C626172536C696465724261636B67726F756E643B692626286E2B3D605C6E5C745C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D';
wwv_flow_imp.g_varchar2_table(32625) := '656E74203E202E7363726F6C6C626172203E202E736C69646572207B5C6E5C745C745C745C745C746261636B67726F756E643A20247B697D3B5C6E5C745C745C745C747D5C6E5C745C745C7460293B636F6E7374206F3D652E7363726F6C6C626172536C';
wwv_flow_imp.g_varchar2_table(32626) := '69646572486F7665724261636B67726F756E643B6F2626286E2B3D605C6E5C745C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E736C696465723A686F766572207B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(32627) := '745C745C745C746261636B67726F756E643A20247B6F7D3B5C6E5C745C745C745C747D5C6E5C745C745C7460293B636F6E737420733D652E7363726F6C6C626172536C696465724163746976654261636B67726F756E643B732626286E2B3D605C6E5C74';
wwv_flow_imp.g_varchar2_table(32628) := '5C745C745C742E6D6F6E61636F2D7363726F6C6C61626C652D656C656D656E74203E202E7363726F6C6C626172203E202E736C696465722E616374697665207B5C6E5C745C745C745C745C746261636B67726F756E643A20247B737D3B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(32629) := '745C747D5C6E5C745C745C7460297D72657475726E206E7D28742C4873286529297D7374796C655363726F6C6C456C656D656E7428652C74297B766172206E2C693B636F6E7374206F3D6E756C6C213D3D286E3D742E666F726567726F756E64436F6C6F';
wwv_flow_imp.g_varchar2_table(32630) := '72292626766F69642030213D3D6E3F6E3A22222C733D6E756C6C213D3D28693D742E6261636B67726F756E64436F6C6F72292626766F69642030213D3D693F693A22222C723D742E626F72646572436F6C6F723F6031707820736F6C696420247B742E62';
wwv_flow_imp.g_varchar2_table(32631) := '6F72646572436F6C6F727D603A22222C613D742E736861646F77436F6C6F723F6030203270782038707820247B742E736861646F77436F6C6F727D603A22223B652E7374796C652E6F75746C696E653D722C652E7374796C652E626F7264657252616469';
wwv_flow_imp.g_varchar2_table(32632) := '75733D22357078222C652E7374796C652E636F6C6F723D6F2C652E7374796C652E6261636B67726F756E64436F6C6F723D732C652E7374796C652E626F78536861646F773D617D676574436F6E7461696E657228297B72657475726E20746869732E7363';
wwv_flow_imp.g_varchar2_table(32633) := '726F6C6C61626C65456C656D656E742E676574446F6D4E6F646528297D676574206F6E5363726F6C6C28297B72657475726E20746869732E7363726F6C6C61626C65456C656D656E742E6F6E5363726F6C6C7D666F6375734974656D4279456C656D656E';
wwv_flow_imp.g_varchar2_table(32634) := '742865297B636F6E737420743D746869732E666F63757365644974656D3B746869732E736574466F63757365644974656D2865292C74213D3D746869732E666F63757365644974656D2626746869732E757064617465466F63757328297D736574466F63';
wwv_flow_imp.g_varchar2_table(32635) := '757365644974656D2865297B666F72286C657420743D303B743C746869732E616374696F6E734C6973742E6368696C6472656E2E6C656E6774683B742B2B29696628653D3D3D746869732E616374696F6E734C6973742E6368696C6472656E5B745D297B';
wwv_flow_imp.g_varchar2_table(32636) := '746869732E666F63757365644974656D3D743B627265616B7D7D757064617465466F6375732865297B73757065722E757064617465466F63757328652C21302C2130292C766F69642030213D3D746869732E666F63757365644974656D2626746869732E';
wwv_flow_imp.g_varchar2_table(32637) := '7363726F6C6C61626C65456C656D656E742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A4D6174682E726F756E6428746869732E6D656E75456C656D656E742E7363726F6C6C546F70297D297D646F476574416374696F6E56';
wwv_flow_imp.g_varchar2_table(32638) := '6965774974656D28652C742C6E297B6966286520696E7374616E63656F662079632972657475726E206E657720726F6528742E636F6E746578742C652C7B69636F6E3A21307D2C746869732E6D656E755374796C6573293B6966286520696E7374616E63';
wwv_flow_imp.g_varchar2_table(32639) := '656F66207763297B636F6E737420693D6E657720736F6528652C652E616374696F6E732C6E2C7B2E2E2E742C7375626D656E754964733A6E657720536574285B2E2E2E742E7375626D656E754964737C7C5B5D2C652E69645D297D2C746869732E6D656E';
wwv_flow_imp.g_varchar2_table(32640) := '755374796C6573293B696628742E656E61626C654D6E656D6F6E696373297B636F6E737420653D692E6765744D6E656D6F6E696328293B696628652626692E6973456E61626C65642829297B6C657420743D5B5D3B746869732E6D6E656D6F6E6963732E';
wwv_flow_imp.g_varchar2_table(32641) := '686173286529262628743D746869732E6D6E656D6F6E6963732E676574286529292C742E707573682869292C746869732E6D6E656D6F6E6963732E73657428652C74297D7D72657475726E20697D7B636F6E7374206E3D7B656E61626C654D6E656D6F6E';
wwv_flow_imp.g_varchar2_table(32642) := '6963733A742E656E61626C654D6E656D6F6E6963732C7573654576656E744173436F6E746578743A742E7573654576656E744173436F6E746578747D3B696628742E6765744B657942696E64696E67297B636F6E737420693D742E6765744B657942696E';
wwv_flow_imp.g_varchar2_table(32643) := '64696E672865293B69662869297B636F6E737420653D692E6765744C6162656C28293B652626286E2E6B657962696E64696E673D65297D7D636F6E737420693D6E6577206F6F6528742E636F6E746578742C652C6E2C746869732E6D656E755374796C65';
wwv_flow_imp.g_varchar2_table(32644) := '73293B696628742E656E61626C654D6E656D6F6E696373297B636F6E737420653D692E6765744D6E656D6F6E696328293B696628652626692E6973456E61626C65642829297B6C657420743D5B5D3B746869732E6D6E656D6F6E6963732E686173286529';
wwv_flow_imp.g_varchar2_table(32645) := '262628743D746869732E6D6E656D6F6E6963732E676574286529292C742E707573682869292C746869732E6D6E656D6F6E6963732E73657428652C74297D7D72657475726E20697D7D7D636C617373206F6F6520657874656E647320734D7B636F6E7374';
wwv_flow_imp.g_varchar2_table(32646) := '727563746F7228652C742C6E2C69297B6966286E2E69734D656E753D21302C737570657228742C742C6E292C746869732E6D656E755374796C653D692C746869732E6F7074696F6E733D6E2C746869732E6F7074696F6E732E69636F6E3D766F69642030';
wwv_flow_imp.g_varchar2_table(32647) := '213D3D6E2E69636F6E26266E2E69636F6E2C746869732E6F7074696F6E732E6C6162656C3D766F696420303D3D3D6E2E6C6162656C7C7C6E2E6C6162656C2C746869732E637373436C6173733D22222C746869732E6F7074696F6E732E6C6162656C2626';
wwv_flow_imp.g_varchar2_table(32648) := '6E2E656E61626C654D6E656D6F6E696373297B636F6E737420653D746869732E616374696F6E2E6C6162656C3B69662865297B636F6E737420743D4A69652E657865632865293B74262628746869732E6D6E656D6F6E69633D28745B315D3F745B315D3A';
wwv_flow_imp.g_varchar2_table(32649) := '745B335D292E746F4C6F63616C654C6F776572436173652829297D7D746869732E72756E4F6E6365546F456E61626C654D6F75736555703D6E6577204B74282828293D3E7B746869732E656C656D656E74262628746869732E5F72656769737465722862';
wwv_flow_imp.g_varchar2_table(32650) := '7328746869732E656C656D656E742C61722E4D4F5553455F55502C28653D3E7B696628637228652C2130292C63297B6966286E657720476528727328746869732E656C656D656E74292C65292E7269676874427574746F6E2972657475726E3B74686973';
wwv_flow_imp.g_varchar2_table(32651) := '2E6F6E436C69636B2865297D656C73652073657454696D656F7574282828293D3E7B746869732E6F6E436C69636B2865297D292C30297D2929292C746869732E5F726567697374657228627328746869732E656C656D656E742C61722E434F4E54455854';
wwv_flow_imp.g_varchar2_table(32652) := '5F4D454E552C28653D3E7B637228652C2130297D292929297D292C313030292C746869732E5F726567697374657228746869732E72756E4F6E6365546F456E61626C654D6F7573655570297D72656E6465722865297B73757065722E72656E6465722865';
wwv_flow_imp.g_varchar2_table(32653) := '292C746869732E656C656D656E74262628746869732E636F6E7461696E65723D652C746869732E6974656D3D757228746869732E656C656D656E742C62722822612E616374696F6E2D6D656E752D6974656D2229292C746869732E5F616374696F6E2E69';
wwv_flow_imp.g_varchar2_table(32654) := '643D3D3D79632E49443F746869732E6974656D2E7365744174747269627574652822726F6C65222C2270726573656E746174696F6E22293A28746869732E6974656D2E7365744174747269627574652822726F6C65222C226D656E756974656D22292C74';
wwv_flow_imp.g_varchar2_table(32655) := '6869732E6D6E656D6F6E69632626746869732E6974656D2E7365744174747269627574652822617269612D6B657973686F727463757473222C60247B746869732E6D6E656D6F6E69637D6029292C746869732E636865636B3D757228746869732E697465';
wwv_flow_imp.g_varchar2_table(32656) := '6D2C627228227370616E2E6D656E752D6974656D2D636865636B222B546C2E617343535353656C6563746F72284C6C2E6D656E7553656C656374696F6E2929292C746869732E636865636B2E7365744174747269627574652822726F6C65222C226E6F6E';
wwv_flow_imp.g_varchar2_table(32657) := '6522292C746869732E6C6162656C3D757228746869732E6974656D2C627228227370616E2E616374696F6E2D6C6162656C2229292C746869732E6F7074696F6E732E6C6162656C2626746869732E6F7074696F6E732E6B657962696E64696E6726262875';
wwv_flow_imp.g_varchar2_table(32658) := '7228746869732E6974656D2C627228227370616E2E6B657962696E64696E672229292E74657874436F6E74656E743D746869732E6F7074696F6E732E6B657962696E64696E67292C746869732E72756E4F6E6365546F456E61626C654D6F75736555702E';
wwv_flow_imp.g_varchar2_table(32659) := '7363686564756C6528292C746869732E757064617465436C61737328292C746869732E7570646174654C6162656C28292C746869732E757064617465546F6F6C74697028292C746869732E757064617465456E61626C656428292C746869732E75706461';
wwv_flow_imp.g_varchar2_table(32660) := '7465436865636B656428292C746869732E6170706C795374796C652829297D626C757228297B73757065722E626C757228292C746869732E6170706C795374796C6528297D666F63757328297B76617220653B73757065722E666F63757328292C6E756C';
wwv_flow_imp.g_varchar2_table(32661) := '6C3D3D3D28653D746869732E6974656D297C7C766F696420303D3D3D657C7C652E666F63757328292C746869732E6170706C795374796C6528297D757064617465506F736974696F6E496E53657428652C74297B746869732E6974656D26262874686973';
wwv_flow_imp.g_varchar2_table(32662) := '2E6974656D2E7365744174747269627574652822617269612D706F73696E736574222C60247B657D60292C746869732E6974656D2E7365744174747269627574652822617269612D73657473697A65222C60247B747D6029297D7570646174654C616265';
wwv_flow_imp.g_varchar2_table(32663) := '6C28297B76617220653B696628746869732E6C6162656C2626746869732E6F7074696F6E732E6C6162656C297B667328746869732E6C6162656C293B6C657420743D506C28746869732E616374696F6E2E6C6162656C293B69662874297B636F6E737420';
wwv_flow_imp.g_varchar2_table(32664) := '6E3D66756E6374696F6E2865297B636F6E737420743D4A69652C6E3D742E657865632865293B696628216E2972657475726E20653B636F6E737420693D216E5B315D3B72657475726E20652E7265706C61636528742C693F2224322433223A2222292E74';
wwv_flow_imp.g_varchar2_table(32665) := '72696D28297D2874293B746869732E6F7074696F6E732E656E61626C654D6E656D6F6E6963737C7C28743D6E292C746869732E6C6162656C2E7365744174747269627574652822617269612D6C6162656C222C6E2E7265706C616365282F26262F672C22';
wwv_flow_imp.g_varchar2_table(32666) := '262229293B636F6E737420693D4A69652E657865632874293B69662869297B743D6C692874292C656F652E6C617374496E6465783D303B6C6574206E3D656F652E657865632874293B666F72283B6E26266E5B315D3B296E3D656F652E65786563287429';
wwv_flow_imp.g_varchar2_table(32667) := '3B636F6E7374206F3D653D3E652E7265706C616365282F26616D703B26616D703B2F672C2226616D703B22293B6E3F746869732E6C6162656C2E617070656E64286869286F28742E73756273747228302C6E2E696E64657829292C222022292C62722822';
wwv_flow_imp.g_varchar2_table(32668) := '75222C7B22617269612D68696464656E223A2274727565227D2C6E5B335D292C7569286F28742E737562737472286E2E696E6465782B6E5B305D2E6C656E67746829292C22202229293A746869732E6C6162656C2E696E6E6572546578743D6F2874292E';
wwv_flow_imp.g_varchar2_table(32669) := '7472696D28292C6E756C6C3D3D3D28653D746869732E6974656D297C7C766F696420303D3D3D657C7C652E7365744174747269627574652822617269612D6B657973686F727463757473222C28695B315D3F695B315D3A695B335D292E746F4C6F63616C';
wwv_flow_imp.g_varchar2_table(32670) := '654C6F776572436173652829297D656C736520746869732E6C6162656C2E696E6E6572546578743D742E7265706C616365282F26262F672C222622292E7472696D28297D7D7D757064617465546F6F6C74697028297B7D757064617465436C6173732829';
wwv_flow_imp.g_varchar2_table(32671) := '7B746869732E637373436C6173732626746869732E6974656D2626746869732E6974656D2E636C6173734C6973742E72656D6F7665282E2E2E746869732E637373436C6173732E73706C69742822202229292C746869732E6F7074696F6E732E69636F6E';
wwv_flow_imp.g_varchar2_table(32672) := '2626746869732E6C6162656C3F28746869732E637373436C6173733D746869732E616374696F6E2E636C6173737C7C22222C746869732E6C6162656C2E636C6173734C6973742E616464282269636F6E22292C746869732E637373436C61737326267468';
wwv_flow_imp.g_varchar2_table(32673) := '69732E6C6162656C2E636C6173734C6973742E616464282E2E2E746869732E637373436C6173732E73706C69742822202229292C746869732E757064617465456E61626C65642829293A746869732E6C6162656C2626746869732E6C6162656C2E636C61';
wwv_flow_imp.g_varchar2_table(32674) := '73734C6973742E72656D6F7665282269636F6E22297D757064617465456E61626C656428297B746869732E616374696F6E2E656E61626C65643F28746869732E656C656D656E74262628746869732E656C656D656E742E636C6173734C6973742E72656D';
wwv_flow_imp.g_varchar2_table(32675) := '6F7665282264697361626C656422292C746869732E656C656D656E742E72656D6F76654174747269627574652822617269612D64697361626C65642229292C746869732E6974656D262628746869732E6974656D2E636C6173734C6973742E72656D6F76';
wwv_flow_imp.g_varchar2_table(32676) := '65282264697361626C656422292C746869732E6974656D2E72656D6F76654174747269627574652822617269612D64697361626C656422292C746869732E6974656D2E746162496E6465783D3029293A28746869732E656C656D656E7426262874686973';
wwv_flow_imp.g_varchar2_table(32677) := '2E656C656D656E742E636C6173734C6973742E616464282264697361626C656422292C746869732E656C656D656E742E7365744174747269627574652822617269612D64697361626C6564222C22747275652229292C746869732E6974656D2626287468';
wwv_flow_imp.g_varchar2_table(32678) := '69732E6974656D2E636C6173734C6973742E616464282264697361626C656422292C746869732E6974656D2E7365744174747269627574652822617269612D64697361626C6564222C2274727565222929297D757064617465436865636B656428297B69';
wwv_flow_imp.g_varchar2_table(32679) := '662821746869732E6974656D2972657475726E3B636F6E737420653D746869732E616374696F6E2E636865636B65643B746869732E6974656D2E636C6173734C6973742E746F67676C652822636865636B6564222C212165292C766F69642030213D3D65';
wwv_flow_imp.g_varchar2_table(32680) := '3F28746869732E6974656D2E7365744174747269627574652822726F6C65222C226D656E756974656D636865636B626F7822292C746869732E6974656D2E7365744174747269627574652822617269612D636865636B6564222C653F2274727565223A22';
wwv_flow_imp.g_varchar2_table(32681) := '66616C73652229293A28746869732E6974656D2E7365744174747269627574652822726F6C65222C226D656E756974656D22292C746869732E6974656D2E7365744174747269627574652822617269612D636865636B6564222C222229297D6765744D6E';
wwv_flow_imp.g_varchar2_table(32682) := '656D6F6E696328297B72657475726E20746869732E6D6E656D6F6E69637D6170706C795374796C6528297B636F6E737420653D746869732E656C656D656E742626746869732E656C656D656E742E636C6173734C6973742E636F6E7461696E732822666F';
wwv_flow_imp.g_varchar2_table(32683) := '637573656422292C743D652626746869732E6D656E755374796C652E73656C656374696F6E466F726567726F756E64436F6C6F723F746869732E6D656E755374796C652E73656C656374696F6E466F726567726F756E64436F6C6F723A746869732E6D65';
wwv_flow_imp.g_varchar2_table(32684) := '6E755374796C652E666F726567726F756E64436F6C6F722C6E3D652626746869732E6D656E755374796C652E73656C656374696F6E4261636B67726F756E64436F6C6F723F746869732E6D656E755374796C652E73656C656374696F6E4261636B67726F';
wwv_flow_imp.g_varchar2_table(32685) := '756E64436F6C6F723A766F696420302C693D652626746869732E6D656E755374796C652E73656C656374696F6E426F72646572436F6C6F723F6031707820736F6C696420247B746869732E6D656E755374796C652E73656C656374696F6E426F72646572';
wwv_flow_imp.g_varchar2_table(32686) := '436F6C6F727D603A22222C6F3D652626746869732E6D656E755374796C652E73656C656374696F6E426F72646572436F6C6F723F222D317078223A22223B746869732E6974656D262628746869732E6974656D2E7374796C652E636F6C6F723D6E756C6C';
wwv_flow_imp.g_varchar2_table(32687) := '213D743F743A22222C746869732E6974656D2E7374796C652E6261636B67726F756E64436F6C6F723D6E756C6C213D6E3F6E3A22222C746869732E6974656D2E7374796C652E6F75746C696E653D692C746869732E6974656D2E7374796C652E6F75746C';
wwv_flow_imp.g_varchar2_table(32688) := '696E654F66667365743D6F292C746869732E636865636B262628746869732E636865636B2E7374796C652E636F6C6F723D6E756C6C213D743F743A2222297D7D636C61737320736F6520657874656E6473206F6F657B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(32689) := '742C6E2C692C6F297B737570657228652C652C692C6F292C746869732E7375626D656E75416374696F6E733D742C746869732E706172656E74446174613D6E2C746869732E7375626D656E754F7074696F6E733D692C746869732E6D797375626D656E75';
wwv_flow_imp.g_varchar2_table(32690) := '3D6E756C6C2C746869732E7375626D656E75446973706F7361626C65733D746869732E5F7265676973746572286E6577206174292C746869732E6D6F7573654F7665723D21312C746869732E657870616E64446972656374696F6E3D692626766F696420';
wwv_flow_imp.g_varchar2_table(32691) := '30213D3D692E657870616E64446972656374696F6E3F692E657870616E64446972656374696F6E3A7B686F72697A6F6E74616C3A746F652E52696768742C766572746963616C3A6E6F652E42656C6F777D2C746869732E73686F775363686564756C6572';
wwv_flow_imp.g_varchar2_table(32692) := '3D6E6577204B74282828293D3E7B746869732E6D6F7573654F766572262628746869732E636C65616E75704578697374696E675375626D656E75282131292C746869732E6372656174655375626D656E7528213129297D292C323530292C746869732E68';
wwv_flow_imp.g_varchar2_table(32693) := '6964655363686564756C65723D6E6577204B74282828293D3E7B746869732E656C656D656E742626214273286A7328292C746869732E656C656D656E74292626746869732E706172656E74446174612E7375626D656E753D3D3D746869732E6D79737562';
wwv_flow_imp.g_varchar2_table(32694) := '6D656E75262628746869732E706172656E74446174612E706172656E742E666F637573282131292C746869732E636C65616E75704578697374696E675375626D656E7528213029297D292C373530297D72656E6465722865297B73757065722E72656E64';
wwv_flow_imp.g_varchar2_table(32695) := '65722865292C746869732E656C656D656E74262628746869732E6974656D262628746869732E6974656D2E636C6173734C6973742E61646428226D6F6E61636F2D7375626D656E752D6974656D22292C746869732E6974656D2E746162496E6465783D30';
wwv_flow_imp.g_varchar2_table(32696) := '2C746869732E6974656D2E7365744174747269627574652822617269612D686173706F707570222C227472756522292C746869732E75706461746541726961457870616E646564282266616C736522292C746869732E7375626D656E75496E6469636174';
wwv_flow_imp.g_varchar2_table(32697) := '6F723D757228746869732E6974656D2C627228227370616E2E7375626D656E752D696E64696361746F72222B546C2E617343535353656C6563746F72284C6C2E6D656E755375626D656E752929292C746869732E7375626D656E75496E64696361746F72';
wwv_flow_imp.g_varchar2_table(32698) := '2E7365744174747269627574652822617269612D68696464656E222C22747275652229292C746869732E5F726567697374657228627328746869732E656C656D656E742C61722E4B45595F55502C28653D3E7B636F6E737420743D6E6577207165286529';
wwv_flow_imp.g_varchar2_table(32699) := '3B28742E657175616C73283137297C7C742E657175616C7328332929262628637228652C2130292C746869732E6372656174655375626D656E7528213029297D2929292C746869732E5F726567697374657228627328746869732E656C656D656E742C61';
wwv_flow_imp.g_varchar2_table(32700) := '722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B6A7328293D3D3D746869732E6974656D262628742E657175616C73283137297C7C742E657175616C73283329292626637228652C2130297D2929292C746869732E5F';
wwv_flow_imp.g_varchar2_table(32701) := '726567697374657228627328746869732E656C656D656E742C61722E4D4F5553455F4F5645522C28653D3E7B746869732E6D6F7573654F7665727C7C28746869732E6D6F7573654F7665723D21302C746869732E73686F775363686564756C65722E7363';
wwv_flow_imp.g_varchar2_table(32702) := '686564756C652829297D2929292C746869732E5F726567697374657228627328746869732E656C656D656E742C61722E4D4F5553455F4C454156452C28653D3E7B746869732E6D6F7573654F7665723D21317D2929292C746869732E5F72656769737465';
wwv_flow_imp.g_varchar2_table(32703) := '7228627328746869732E656C656D656E742C61722E464F4355535F4F55542C28653D3E7B746869732E656C656D656E742626214273286A7328292C746869732E656C656D656E74292626746869732E686964655363686564756C65722E7363686564756C';
wwv_flow_imp.g_varchar2_table(32704) := '6528297D2929292C746869732E5F726567697374657228746869732E706172656E74446174612E706172656E742E6F6E5363726F6C6C282828293D3E7B746869732E706172656E74446174612E7375626D656E753D3D3D746869732E6D797375626D656E';
wwv_flow_imp.g_varchar2_table(32705) := '75262628746869732E706172656E74446174612E706172656E742E666F637573282131292C746869732E636C65616E75704578697374696E675375626D656E7528213029297D292929297D757064617465456E61626C656428297B7D6F6E436C69636B28';
wwv_flow_imp.g_varchar2_table(32706) := '65297B637228652C2130292C746869732E636C65616E75704578697374696E675375626D656E75282131292C746869732E6372656174655375626D656E75282130297D636C65616E75704578697374696E675375626D656E752865297B69662874686973';
wwv_flow_imp.g_varchar2_table(32707) := '2E706172656E74446174612E7375626D656E75262628657C7C746869732E706172656E74446174612E7375626D656E75213D3D746869732E6D797375626D656E7529297B7472797B746869732E706172656E74446174612E7375626D656E752E64697370';
wwv_flow_imp.g_varchar2_table(32708) := '6F736528297D63617463682865297B7D746869732E706172656E74446174612E7375626D656E753D766F696420302C746869732E75706461746541726961457870616E646564282266616C736522292C746869732E7375626D656E75436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(32709) := '72262628746869732E7375626D656E75446973706F7361626C65732E636C65617228292C746869732E7375626D656E75436F6E7461696E65723D766F69642030297D7D63616C63756C6174655375626D656E754D656E754C61796F757428652C742C6E2C';
wwv_flow_imp.g_varchar2_table(32710) := '69297B636F6E7374206F3D7B746F703A302C6C6566743A307D3B72657475726E206F2E6C6566743D70696528652E77696474682C742E77696474682C7B706F736974696F6E3A692E686F72697A6F6E74616C3D3D3D746F652E52696768743F303A312C6F';
wwv_flow_imp.g_varchar2_table(32711) := '66667365743A6E2E6C6566742C73697A653A6E2E77696474687D292C6F2E6C6566743E3D6E2E6C65667426266F2E6C6566743C6E2E6C6566742B6E2E77696474682626286E2E6C6566742B31302B742E77696474683C3D652E77696474682626286F2E6C';
wwv_flow_imp.g_varchar2_table(32712) := '6566743D6E2E6C6566742B3130292C6E2E746F702B3D31302C6E2E6865696768743D30292C6F2E746F703D70696528652E6865696768742C742E6865696768742C7B706F736974696F6E3A302C6F66667365743A6E2E746F702C73697A653A307D292C6F';
wwv_flow_imp.g_varchar2_table(32713) := '2E746F702B742E6865696768743D3D3D6E2E746F7026266F2E746F702B6E2E6865696768742B742E6865696768743C3D652E6865696768742626286F2E746F702B3D6E2E686569676874292C6F7D6372656174655375626D656E7528653D2130297B6966';
wwv_flow_imp.g_varchar2_table(32714) := '28746869732E656C656D656E7429696628746869732E706172656E74446174612E7375626D656E7529746869732E706172656E74446174612E7375626D656E752E666F637573282131293B656C73657B746869732E75706461746541726961457870616E';
wwv_flow_imp.g_varchar2_table(32715) := '64656428227472756522292C746869732E7375626D656E75436F6E7461696E65723D757228746869732E656C656D656E742C627228226469762E6D6F6E61636F2D7375626D656E752229292C746869732E7375626D656E75436F6E7461696E65722E636C';
wwv_flow_imp.g_varchar2_table(32716) := '6173734C6973742E61646428226D656E756261722D6D656E752D6974656D732D686F6C646572222C22636F6E746578742D7669657722293B636F6E737420743D727328746869732E706172656E74446174612E706172656E742E646F6D4E6F6465292E67';
wwv_flow_imp.g_varchar2_table(32717) := '6574436F6D70757465645374796C6528746869732E706172656E74446174612E706172656E742E646F6D4E6F6465292C6E3D7061727365466C6F617428742E70616464696E67546F707C7C223022297C7C303B746869732E7375626D656E75436F6E7461';
wwv_flow_imp.g_varchar2_table(32718) := '696E65722E7374796C652E7A496E6465783D2231222C746869732E7375626D656E75436F6E7461696E65722E7374796C652E706F736974696F6E3D226669786564222C746869732E7375626D656E75436F6E7461696E65722E7374796C652E746F703D22';
wwv_flow_imp.g_varchar2_table(32719) := '30222C746869732E7375626D656E75436F6E7461696E65722E7374796C652E6C6566743D2230222C746869732E706172656E74446174612E7375626D656E753D6E657720696F6528746869732E7375626D656E75436F6E7461696E65722C746869732E73';
wwv_flow_imp.g_varchar2_table(32720) := '75626D656E75416374696F6E732E6C656E6774683F746869732E7375626D656E75416374696F6E733A5B6E65772043635D2C746869732E7375626D656E754F7074696F6E732C746869732E6D656E755374796C65293B636F6E737420693D746869732E65';
wwv_flow_imp.g_varchar2_table(32721) := '6C656D656E742E676574426F756E64696E67436C69656E745265637428292C6F3D7B746F703A692E746F702D6E2C6C6566743A692E6C6566742C6865696768743A692E6865696768742B322A6E2C77696474683A692E77696474687D2C733D746869732E';
wwv_flow_imp.g_varchar2_table(32722) := '7375626D656E75436F6E7461696E65722E676574426F756E64696E67436C69656E745265637428292C723D727328746869732E656C656D656E74292C7B746F703A612C6C6566743A6C7D3D746869732E63616C63756C6174655375626D656E754D656E75';
wwv_flow_imp.g_varchar2_table(32723) := '4C61796F7574286E657720497328722E696E6E657257696474682C722E696E6E6572486569676874292C49732E6C6966742873292C6F2C746869732E657870616E64446972656374696F6E293B746869732E7375626D656E75436F6E7461696E65722E73';
wwv_flow_imp.g_varchar2_table(32724) := '74796C652E6C6566743D6C2D732E6C6566742B227078222C746869732E7375626D656E75436F6E7461696E65722E7374796C652E746F703D612D732E746F702B227078222C746869732E7375626D656E75446973706F7361626C65732E61646428627328';
wwv_flow_imp.g_varchar2_table(32725) := '746869732E7375626D656E75436F6E7461696E65722C61722E4B45595F55502C28653D3E7B6E65772071652865292E657175616C7328313529262628637228652C2130292C746869732E706172656E74446174612E706172656E742E666F63757328292C';
wwv_flow_imp.g_varchar2_table(32726) := '746869732E636C65616E75704578697374696E675375626D656E7528213029297D2929292C746869732E7375626D656E75446973706F7361626C65732E61646428627328746869732E7375626D656E75436F6E7461696E65722C61722E4B45595F444F57';
wwv_flow_imp.g_varchar2_table(32727) := '4E2C28653D3E7B6E65772071652865292E657175616C73283135292626637228652C2130297D2929292C746869732E7375626D656E75446973706F7361626C65732E61646428746869732E706172656E74446174612E7375626D656E752E6F6E44696443';
wwv_flow_imp.g_varchar2_table(32728) := '616E63656C282828293D3E7B746869732E706172656E74446174612E706172656E742E666F63757328292C746869732E636C65616E75704578697374696E675375626D656E75282130297D2929292C746869732E706172656E74446174612E7375626D65';
wwv_flow_imp.g_varchar2_table(32729) := '6E752E666F6375732865292C746869732E6D797375626D656E753D746869732E706172656E74446174612E7375626D656E757D7D75706461746541726961457870616E6465642865297B76617220743B746869732E6974656D2626286E756C6C3D3D3D28';
wwv_flow_imp.g_varchar2_table(32730) := '743D746869732E6974656D297C7C766F696420303D3D3D747C7C742E7365744174747269627574652822617269612D657870616E646564222C6529297D6170706C795374796C6528297B73757065722E6170706C795374796C6528293B636F6E73742065';
wwv_flow_imp.g_varchar2_table(32731) := '3D746869732E656C656D656E742626746869732E656C656D656E742E636C6173734C6973742E636F6E7461696E732822666F637573656422292626746869732E6D656E755374796C652E73656C656374696F6E466F726567726F756E64436F6C6F723F74';
wwv_flow_imp.g_varchar2_table(32732) := '6869732E6D656E755374796C652E73656C656374696F6E466F726567726F756E64436F6C6F723A746869732E6D656E755374796C652E666F726567726F756E64436F6C6F723B746869732E7375626D656E75496E64696361746F72262628746869732E73';
wwv_flow_imp.g_varchar2_table(32733) := '75626D656E75496E64696361746F722E7374796C652E636F6C6F723D6E756C6C213D653F653A2222297D646973706F736528297B73757065722E646973706F736528292C746869732E686964655363686564756C65722E646973706F736528292C746869';
wwv_flow_imp.g_varchar2_table(32734) := '732E6D797375626D656E75262628746869732E6D797375626D656E752E646973706F736528292C746869732E6D797375626D656E753D6E756C6C292C746869732E7375626D656E75436F6E7461696E6572262628746869732E7375626D656E75436F6E74';
wwv_flow_imp.g_varchar2_table(32735) := '61696E65723D766F69642030297D7D636C61737320726F6520657874656E647320724D7B636F6E7374727563746F7228652C742C6E2C69297B737570657228652C742C6E292C746869732E6D656E755374796C65733D697D72656E6465722865297B7375';
wwv_flow_imp.g_varchar2_table(32736) := '7065722E72656E6465722865292C746869732E6C6162656C262628746869732E6C6162656C2E7374796C652E626F72646572426F74746F6D436F6C6F723D746869732E6D656E755374796C65732E736570617261746F72436F6C6F723F60247B74686973';
wwv_flow_imp.g_varchar2_table(32737) := '2E6D656E755374796C65732E736570617261746F72436F6C6F727D603A2222297D7D66756E6374696F6E20616F652865297B636F6E737420743D456C28295B652E69645D3B72657475726E602E636F6469636F6E2D247B652E69647D3A6265666F726520';
wwv_flow_imp.g_varchar2_table(32738) := '7B20636F6E74656E743A20275C5C247B742E746F537472696E67283136297D273B207D607D636C617373206C6F657B636F6E7374727563746F7228652C742C6E2C69297B746869732E636F6E7465787456696577536572766963653D652C746869732E74';
wwv_flow_imp.g_varchar2_table(32739) := '656C656D65747279536572766963653D742C746869732E6E6F74696669636174696F6E536572766963653D6E2C746869732E6B657962696E64696E67536572766963653D692C746869732E666F637573546F52657475726E3D6E756C6C2C746869732E6C';
wwv_flow_imp.g_varchar2_table(32740) := '617374436F6E7461696E65723D6E756C6C2C746869732E626C6F636B3D6E756C6C2C746869732E626C6F636B446973706F7361626C653D6E756C6C2C746869732E6F7074696F6E733D7B626C6F636B4D6F7573653A21307D7D636F6E6669677572652865';
wwv_flow_imp.g_varchar2_table(32741) := '297B746869732E6F7074696F6E733D657D73686F77436F6E746578744D656E752865297B636F6E737420743D652E676574416374696F6E7328293B69662821742E6C656E6774682972657475726E3B6C6574206E3B746869732E666F637573546F526574';
wwv_flow_imp.g_varchar2_table(32742) := '75726E3D6A7328293B636F6E737420693D652E646F6D466F72536861646F77526F6F7420696E7374616E63656F662048544D4C456C656D656E743F652E646F6D466F72536861646F77526F6F743A766F696420303B746869732E636F6E74657874566965';
wwv_flow_imp.g_varchar2_table(32743) := '77536572766963652E73686F77436F6E7465787456696577287B676574416E63686F723A28293D3E652E676574416E63686F7228292C63616E52656C61796F75743A21312C616E63686F72416C69676E6D656E743A652E616E63686F72416C69676E6D65';
wwv_flow_imp.g_varchar2_table(32744) := '6E742C616E63686F7241786973416C69676E6D656E743A652E616E63686F7241786973416C69676E6D656E742C72656E6465723A693D3E7B766172206F3B746869732E6C617374436F6E7461696E65723D693B636F6E737420733D652E6765744D656E75';
wwv_flow_imp.g_varchar2_table(32745) := '436C6173734E616D653F652E6765744D656E75436C6173734E616D6528293A22223B73262628692E636C6173734E616D652B3D2220222B73292C746869732E6F7074696F6E732E626C6F636B4D6F757365262628746869732E626C6F636B3D692E617070';
wwv_flow_imp.g_varchar2_table(32746) := '656E644368696C6428627228222E636F6E746578742D766965772D626C6F636B2229292C746869732E626C6F636B2E7374796C652E706F736974696F6E3D226669786564222C746869732E626C6F636B2E7374796C652E637572736F723D22696E697469';
wwv_flow_imp.g_varchar2_table(32747) := '616C222C746869732E626C6F636B2E7374796C652E6C6566743D2230222C746869732E626C6F636B2E7374796C652E746F703D2230222C746869732E626C6F636B2E7374796C652E77696474683D2231303025222C746869732E626C6F636B2E7374796C';
wwv_flow_imp.g_varchar2_table(32748) := '652E6865696768743D2231303025222C746869732E626C6F636B2E7374796C652E7A496E6465783D222D31222C6E756C6C3D3D3D286F3D746869732E626C6F636B446973706F7361626C65297C7C766F696420303D3D3D6F7C7C6F2E646973706F736528';
wwv_flow_imp.g_varchar2_table(32749) := '292C746869732E626C6F636B446973706F7361626C653D627328746869732E626C6F636B2C61722E4D4F5553455F444F574E2C28653D3E652E73746F7050726F7061676174696F6E28292929293B636F6E737420723D6E65772061742C613D652E616374';
wwv_flow_imp.g_varchar2_table(32750) := '696F6E52756E6E65727C7C6E6577205F633B612E6F6E57696C6C52756E2828743D3E746869732E6F6E416374696F6E52756E28742C21652E736B697054656C656D6574727929292C746869732C72292C612E6F6E44696452756E28746869732E6F6E4469';
wwv_flow_imp.g_varchar2_table(32751) := '64416374696F6E52756E2C746869732C72292C6E3D6E657720696F6528692C742C7B616374696F6E566965774974656D50726F76696465723A652E676574416374696F6E566965774974656D2C636F6E746578743A652E676574416374696F6E73436F6E';
wwv_flow_imp.g_varchar2_table(32752) := '746578743F652E676574416374696F6E73436F6E7465787428293A6E756C6C2C616374696F6E52756E6E65723A612C6765744B657942696E64696E673A652E6765744B657942696E64696E673F652E6765744B657942696E64696E673A653D3E74686973';
wwv_flow_imp.g_varchar2_table(32753) := '2E6B657962696E64696E67536572766963652E6C6F6F6B75704B657962696E64696E6728652E6964297D2C504D292C6E2E6F6E44696443616E63656C282828293D3E746869732E636F6E7465787456696577536572766963652E68696465436F6E746578';
wwv_flow_imp.g_varchar2_table(32754) := '745669657728213029292C6E756C6C2C72292C6E2E6F6E446964426C7572282828293D3E746869732E636F6E7465787456696577536572766963652E68696465436F6E746578745669657728213029292C6E756C6C2C72293B636F6E7374206C3D727328';
wwv_flow_imp.g_varchar2_table(32755) := '69293B72657475726E20722E616464286273286C2C61722E424C55522C2828293D3E746869732E636F6E7465787456696577536572766963652E68696465436F6E7465787456696577282130292929292C722E616464286273286C2C61722E4D4F555345';
wwv_flow_imp.g_varchar2_table(32756) := '5F444F574E2C28653D3E7B696628652E64656661756C7450726576656E7465642972657475726E3B636F6E737420743D6E6577204765286C2C65293B6C6574206E3D742E7461726765743B69662821742E7269676874427574746F6E297B666F72283B6E';
wwv_flow_imp.g_varchar2_table(32757) := '3B297B6966286E3D3D3D692972657475726E3B6E3D6E2E706172656E74456C656D656E747D746869732E636F6E7465787456696577536572766963652E68696465436F6E7465787456696577282130297D7D2929292C737428722C6E297D2C666F637573';
wwv_flow_imp.g_varchar2_table(32758) := '3A28293D3E7B6E756C6C3D3D6E7C7C6E2E666F637573282121652E6175746F53656C65637446697273744974656D297D2C6F6E486964653A743D3E7B766172206E2C692C6F3B6E756C6C3D3D3D286E3D652E6F6E48696465297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(32759) := '6E7C7C6E2E63616C6C28652C212174292C746869732E626C6F636B262628746869732E626C6F636B2E72656D6F766528292C746869732E626C6F636B3D6E756C6C292C6E756C6C3D3D3D28693D746869732E626C6F636B446973706F7361626C65297C7C';
wwv_flow_imp.g_varchar2_table(32760) := '766F696420303D3D3D697C7C692E646973706F736528292C746869732E626C6F636B446973706F7361626C653D6E756C6C2C746869732E6C617374436F6E7461696E65722626286A7328293D3D3D746869732E6C617374436F6E7461696E65727C7C4273';
wwv_flow_imp.g_varchar2_table(32761) := '286A7328292C746869732E6C617374436F6E7461696E657229292626286E756C6C3D3D3D286F3D746869732E666F637573546F52657475726E297C7C766F696420303D3D3D6F7C7C6F2E666F6375732829292C746869732E6C617374436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(32762) := '723D6E756C6C7D7D2C692C212169297D6F6E416374696F6E52756E28652C74297B742626746869732E74656C656D65747279536572766963652E7075626C69634C6F67322822776F726B62656E6368416374696F6E4578656375746564222C7B69643A65';
wwv_flow_imp.g_varchar2_table(32763) := '2E616374696F6E2E69642C66726F6D3A22636F6E746578744D656E75227D292C746869732E636F6E7465787456696577536572766963652E68696465436F6E7465787456696577282131297D6F6E446964416374696F6E52756E2865297B652E6572726F';
wwv_flow_imp.g_varchar2_table(32764) := '72262621546528652E6572726F72292626746869732E6E6F74696669636174696F6E536572766963652E6572726F7228652E6572726F72297D7D76617220636F653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C6929';
wwv_flow_imp.g_varchar2_table(32765) := '7B74286E2C692C65297D7D3B6C657420646F653D636C61737320657874656E6473206C747B67657420636F6E746578744D656E7548616E646C657228297B72657475726E20746869732E5F636F6E746578744D656E7548616E646C65727C7C2874686973';
wwv_flow_imp.g_varchar2_table(32766) := '2E5F636F6E746578744D656E7548616E646C65723D6E6577206C6F6528746869732E636F6E7465787456696577536572766963652C746869732E74656C656D65747279536572766963652C746869732E6E6F74696669636174696F6E536572766963652C';
wwv_flow_imp.g_varchar2_table(32767) := '746869732E6B657962696E64696E675365727669636529292C746869732E5F636F6E746578744D656E7548616E646C65727D636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E74656C656D65747279536572';
wwv_flow_imp.g_varchar2_table(32768) := '766963653D652C746869732E6E6F74696669636174696F6E536572766963653D742C746869732E636F6E7465787456696577536572766963653D6E2C746869732E6B657962696E64696E67536572766963653D692C746869732E6D656E75536572766963';
wwv_flow_imp.g_varchar2_table(32769) := '653D6F2C746869732E636F6E746578744B6579536572766963653D732C746869732E5F636F6E746578744D656E7548616E646C65723D766F696420302C746869732E5F6F6E44696453686F77436F6E746578744D656E753D746869732E5F73746F72652E';
wwv_flow_imp.g_varchar2_table(32770) := '616464286E6577204374292C746869732E6F6E44696453686F77436F6E746578744D656E753D746869732E5F6F6E44696453686F77436F6E746578744D656E752E6576656E742C746869732E5F6F6E44696448696465436F6E746578744D656E753D7468';
wwv_flow_imp.g_varchar2_table(32771) := '69732E5F73746F72652E616464286E6577204374297D636F6E6669677572652865297B746869732E636F6E746578744D656E7548616E646C65722E636F6E6669677572652865297D73686F77436F6E746578744D656E752865297B653D686F652E747261';
wwv_flow_imp.g_varchar2_table(32772) := '6E73666F726D28652C746869732E6D656E75536572766963652C746869732E636F6E746578744B657953657276696365292C746869732E636F6E746578744D656E7548616E646C65722E73686F77436F6E746578744D656E75287B2E2E2E652C6F6E4869';
wwv_flow_imp.g_varchar2_table(32773) := '64653A743D3E7B766172206E3B6E756C6C3D3D3D286E3D652E6F6E48696465297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28652C74292C746869732E5F6F6E44696448696465436F6E746578744D656E752E6669726528297D7D292C4C722E6765';
wwv_flow_imp.g_varchar2_table(32774) := '74496E7374616E636528292E72657365744B657953746174757328292C746869732E5F6F6E44696453686F77436F6E746578744D656E752E6669726528297D7D3B76617220686F652C756F653B646F653D66756E6374696F6E28652C742C6E2C69297B76';
wwv_flow_imp.g_varchar2_table(32775) := '6172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F';
wwv_flow_imp.g_varchar2_table(32776) := '66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(32777) := '3B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72';
wwv_flow_imp.g_varchar2_table(32778) := '292C727D285B636F6528302C4F64292C636F6528312C7344292C636F6528322C6A45292C636F6528332C2445292C636F6528342C4464292C636F6528352C6364295D2C646F65292C66756E6374696F6E2865297B652E7472616E73666F726D3D66756E63';
wwv_flow_imp.g_varchar2_table(32779) := '74696F6E28652C742C6E297B696628212828693D65292626692E6D656E75496420696E7374616E63656F66204C64292972657475726E20653B76617220693B636F6E73747B6D656E7549643A6F2C6D656E75416374696F6E4F7074696F6E733A732C636F';
wwv_flow_imp.g_varchar2_table(32780) := '6E746578744B6579536572766963653A727D3D653B72657475726E7B2E2E2E652C676574416374696F6E733A28293D3E7B636F6E737420693D5B5D3B6966286F297B636F6E737420653D742E6372656174654D656E75286F2C6E756C6C213D723F723A6E';
wwv_flow_imp.g_varchar2_table(32781) := '293B2166756E6374696F6E28652C742C6E297B636F6E737420693D652E676574416374696F6E732874292C6F3D4C722E676574496E7374616E636528293B5F6A28692C6E2C6F2E6B65795374617475732E616C744B65797C7C286A7C7C242926266F2E6B';
wwv_flow_imp.g_varchar2_table(32782) := '65795374617475732E73686966744B65792C28653D3E226E617669676174696F6E223D3D3D6529297D28652C732C69292C652E646973706F736528297D72657475726E20652E676574416374696F6E733F79632E6A6F696E28652E676574416374696F6E';
wwv_flow_imp.g_varchar2_table(32783) := '7328292C69293A697D7D7D7D28686F657C7C28686F653D7B7D29292C66756E6374696F6E2865297B655B652E4150493D305D3D22415049222C655B652E555345523D315D3D2255534552227D28756F657C7C28756F653D7B7D29293B76617220706F653D';
wwv_flow_imp.g_varchar2_table(32784) := '66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A69';
wwv_flow_imp.g_varchar2_table(32785) := '3B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C73652066';
wwv_flow_imp.g_varchar2_table(32786) := '6F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E64';
wwv_flow_imp.g_varchar2_table(32787) := '6566696E6550726F706572747928742C6E2C72292C727D2C676F653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574206D6F653D636C6173737B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(32788) := '65297B746869732E5F636F6D6D616E64536572766963653D657D6173796E63206F70656E28652C74297B69662821246F28652C716F2E636F6D6D616E64292972657475726E21313B69662821286E756C6C3D3D743F766F696420303A742E616C6C6F7743';
wwv_flow_imp.g_varchar2_table(32789) := '6F6D6D616E6473292972657475726E21303B69662822737472696E67223D3D747970656F662065262628653D4E6F2E7061727365286529292C41727261792E6973417272617928742E616C6C6F77436F6D6D616E647329262621742E616C6C6F77436F6D';
wwv_flow_imp.g_varchar2_table(32790) := '6D616E64732E696E636C7564657328652E70617468292972657475726E21303B6C6574206E3D5B5D3B7472797B6E3D546B286465636F6465555249436F6D706F6E656E7428652E717565727929297D63617463682874297B7472797B6E3D546B28652E71';
wwv_flow_imp.g_varchar2_table(32791) := '75657279297D63617463682865297B7D7D72657475726E2041727261792E69734172726179286E297C7C286E3D5B6E5D292C617761697420746869732E5F636F6D6D616E64536572766963652E65786563757465436F6D6D616E6428652E706174682C2E';
wwv_flow_imp.g_varchar2_table(32792) := '2E2E6E292C21307D7D3B6D6F653D706F65285B676F6528302C7863295D2C6D6F65293B6C657420666F653D636C6173737B636F6E7374727563746F722865297B746869732E5F656469746F72536572766963653D657D6173796E63206F70656E28652C74';
wwv_flow_imp.g_varchar2_table(32793) := '297B22737472696E67223D3D747970656F662065262628653D4E6F2E7061727365286529293B636F6E73747B73656C656374696F6E3A6E2C7572693A697D3D66756E6374696F6E2865297B6C657420743B636F6E7374206E3D2F5E4C3F285C642B29283F';
wwv_flow_imp.g_varchar2_table(32794) := '3A2C285C642B29293F282D4C3F285C642B29283F3A2C285C642B29293F293F2F2E6578656328652E667261676D656E74293B72657475726E206E262628743D7B73746172744C696E654E756D6265723A7061727365496E74286E5B315D292C7374617274';
wwv_flow_imp.g_varchar2_table(32795) := '436F6C756D6E3A6E5B325D3F7061727365496E74286E5B325D293A312C656E644C696E654E756D6265723A6E5B345D3F7061727365496E74286E5B345D293A766F696420302C656E64436F6C756D6E3A6E5B345D3F6E5B355D3F7061727365496E74286E';
wwv_flow_imp.g_varchar2_table(32796) := '5B355D293A313A766F696420307D2C653D652E77697468287B667261676D656E743A22227D29292C7B73656C656374696F6E3A742C7572693A657D7D2865293B72657475726E28653D69292E736368656D653D3D3D716F2E66696C65262628653D586C28';
wwv_flow_imp.g_varchar2_table(32797) := '6529292C617761697420746869732E5F656469746F72536572766963652E6F70656E436F6465456469746F72287B7265736F757263653A652C6F7074696F6E733A7B73656C656374696F6E3A6E2C736F757263653A286E756C6C3D3D743F766F69642030';
wwv_flow_imp.g_varchar2_table(32798) := '3A742E66726F6D5573657247657374757265293F756F652E555345523A756F652E4150492C2E2E2E6E756C6C3D3D743F766F696420303A742E656469746F724F7074696F6E737D7D2C746869732E5F656469746F72536572766963652E676574466F6375';
wwv_flow_imp.g_varchar2_table(32799) := '736564436F6465456469746F7228292C6E756C6C3D3D743F766F696420303A742E6F70656E546F53696465292C21307D7D3B666F653D706F65285B676F6528302C6763295D2C666F65293B6C657420766F653D636C6173737B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(32800) := '28652C74297B746869732E5F6F70656E6572733D6E65772067742C746869732E5F76616C696461746F72733D6E65772067742C746869732E5F7265736F6C766572733D6E65772067742C746869732E5F7265736F6C766564557269546172676574733D6E';
wwv_flow_imp.g_varchar2_table(32801) := '6577206F612828653D3E652E77697468287B706174683A6E756C6C2C667261676D656E743A6E756C6C2C71756572793A6E756C6C7D292E746F537472696E67282929292C746869732E5F65787465726E616C4F70656E6572733D6E65772067742C746869';
wwv_flow_imp.g_varchar2_table(32802) := '732E5F64656661756C7445787465726E616C4F70656E65723D7B6F70656E45787465726E616C3A6173796E6320653D3E28556F28652C716F2E687474702C716F2E6874747073293F43722865293A732E6C6F636174696F6E2E687265663D652C2130297D';
wwv_flow_imp.g_varchar2_table(32803) := '2C746869732E5F6F70656E6572732E70757368287B6F70656E3A6173796E6328652C74293D3E212821286E756C6C3D3D743F766F696420303A742E6F70656E45787465726E616C29262621556F28652C716F2E6D61696C746F2C716F2E687474702C716F';
wwv_flow_imp.g_varchar2_table(32804) := '2E68747470732C716F2E76736C73297C7C28617761697420746869732E5F646F4F70656E45787465726E616C28652C74292C3029297D292C746869732E5F6F70656E6572732E70757368286E6577206D6F65287429292C746869732E5F6F70656E657273';
wwv_flow_imp.g_varchar2_table(32805) := '2E70757368286E657720666F65286529297D72656769737465724F70656E65722865297B72657475726E7B646973706F73653A746869732E5F6F70656E6572732E756E73686966742865297D7D6173796E63206F70656E28652C74297B766172206E3B63';
wwv_flow_imp.g_varchar2_table(32806) := '6F6E737420693D22737472696E67223D3D747970656F6620653F4E6F2E70617273652865293A652C6F3D6E756C6C213D3D286E3D746869732E5F7265736F6C766564557269546172676574732E676574286929292626766F69642030213D3D6E3F6E3A65';
wwv_flow_imp.g_varchar2_table(32807) := '3B666F7228636F6E73742065206F6620746869732E5F76616C696461746F72732969662821617761697420652E73686F756C644F70656E286F2C74292972657475726E21313B666F7228636F6E7374206E206F6620746869732E5F6F70656E6572732969';
wwv_flow_imp.g_varchar2_table(32808) := '66286177616974206E2E6F70656E28652C74292972657475726E21303B72657475726E21317D6173796E63207265736F6C766545787465726E616C55726928652C74297B666F7228636F6E7374206E206F6620746869732E5F7265736F6C766572732974';
wwv_flow_imp.g_varchar2_table(32809) := '72797B636F6E737420693D6177616974206E2E7265736F6C766545787465726E616C55726928652C74293B696628692972657475726E20746869732E5F7265736F6C766564557269546172676574732E68617328692E7265736F6C766564297C7C746869';
wwv_flow_imp.g_varchar2_table(32810) := '732E5F7265736F6C766564557269546172676574732E73657428692E7265736F6C7665642C65292C697D63617463682865297B7D7468726F77206E6577204572726F722822436F756C64206E6F74207265736F6C76652065787465726E616C205552493A';
wwv_flow_imp.g_varchar2_table(32811) := '20222B652E746F537472696E672829297D6173796E63205F646F4F70656E45787465726E616C28652C74297B636F6E7374206E3D22737472696E67223D3D747970656F6620653F4E6F2E70617273652865293A653B6C657420692C6F3B7472797B693D28';
wwv_flow_imp.g_varchar2_table(32812) := '617761697420746869732E7265736F6C766545787465726E616C557269286E2C7429292E7265736F6C7665647D63617463682865297B693D6E7D6966286F3D22737472696E67223D3D747970656F66206526266E2E746F537472696E6728293D3D3D692E';
wwv_flow_imp.g_varchar2_table(32813) := '746F537472696E6728293F653A656E636F646555524928692E746F537472696E6728213029292C6E756C6C3D3D743F766F696420303A742E616C6C6F77436F6E74726962757465644F70656E657273297B636F6E737420653D22737472696E67223D3D74';
wwv_flow_imp.g_varchar2_table(32814) := '7970656F66286E756C6C3D3D743F766F696420303A742E616C6C6F77436F6E74726962757465644F70656E657273293F6E756C6C3D3D743F766F696420303A742E616C6C6F77436F6E74726962757465644F70656E6572733A766F696420303B666F7228';
wwv_flow_imp.g_varchar2_table(32815) := '636F6E73742074206F6620746869732E5F65787465726E616C4F70656E65727329696628617761697420742E6F70656E45787465726E616C286F2C7B736F757263655572693A6E2C7072656665727265644F70656E657249643A657D2C4D742E4E6F6E65';
wwv_flow_imp.g_varchar2_table(32816) := '292972657475726E21307D72657475726E20746869732E5F64656661756C7445787465726E616C4F70656E65722E6F70656E45787465726E616C286F2C7B736F757263655572693A6E7D2C4D742E4E6F6E65297D646973706F736528297B746869732E5F';
wwv_flow_imp.g_varchar2_table(32817) := '76616C696461746F72732E636C65617228297D7D3B766F653D706F65285B676F6528302C6763292C676F6528312C7863295D2C766F65293B76617220626F653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74';
wwv_flow_imp.g_varchar2_table(32818) := '286E2C692C65297D7D3B6C6574205F6F653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E5F6D61726B6572536572766963653D742C746869732E5F6F6E4469644368616E67654D';
wwv_flow_imp.g_varchar2_table(32819) := '61726B65723D746869732E5F7265676973746572286E6577204374292C746869732E5F6D61726B65724465636F726174696F6E733D6E6577206F612C652E6765744D6F64656C7328292E666F72456163682828653D3E746869732E5F6F6E4D6F64656C41';
wwv_flow_imp.g_varchar2_table(32820) := '6464656428652929292C746869732E5F726567697374657228652E6F6E4D6F64656C416464656428746869732E5F6F6E4D6F64656C41646465642C7468697329292C746869732E5F726567697374657228652E6F6E4D6F64656C52656D6F766564287468';
wwv_flow_imp.g_varchar2_table(32821) := '69732E5F6F6E4D6F64656C52656D6F7665642C7468697329292C746869732E5F726567697374657228746869732E5F6D61726B6572536572766963652E6F6E4D61726B65724368616E67656428746869732E5F68616E646C654D61726B65724368616E67';
wwv_flow_imp.g_varchar2_table(32822) := '652C7468697329297D646973706F736528297B73757065722E646973706F736528292C746869732E5F6D61726B65724465636F726174696F6E732E666F72456163682828653D3E652E646973706F7365282929292C746869732E5F6D61726B6572446563';
wwv_flow_imp.g_varchar2_table(32823) := '6F726174696F6E732E636C65617228297D6765744D61726B657228652C74297B636F6E7374206E3D746869732E5F6D61726B65724465636F726174696F6E732E6765742865293B72657475726E206E26266E2E6765744D61726B65722874297C7C6E756C';
wwv_flow_imp.g_varchar2_table(32824) := '6C7D5F68616E646C654D61726B65724368616E67652865297B652E666F72456163682828653D3E7B636F6E737420743D746869732E5F6D61726B65724465636F726174696F6E732E6765742865293B742626746869732E5F7570646174654465636F7261';
wwv_flow_imp.g_varchar2_table(32825) := '74696F6E732874297D29297D5F6F6E4D6F64656C41646465642865297B636F6E737420743D6E657720796F652865293B746869732E5F6D61726B65724465636F726174696F6E732E73657428652E7572692C74292C746869732E5F757064617465446563';
wwv_flow_imp.g_varchar2_table(32826) := '6F726174696F6E732874297D5F6F6E4D6F64656C52656D6F7665642865297B76617220743B636F6E7374206E3D746869732E5F6D61726B65724465636F726174696F6E732E67657428652E757269293B6E2626286E2E646973706F736528292C74686973';
wwv_flow_imp.g_varchar2_table(32827) := '2E5F6D61726B65724465636F726174696F6E732E64656C65746528652E75726929292C652E7572692E736368656D65213D3D716F2E696E4D656D6F72792626652E7572692E736368656D65213D3D716F2E696E7465726E616C2626652E7572692E736368';
wwv_flow_imp.g_varchar2_table(32828) := '656D65213D3D716F2E7673636F64657C7C6E756C6C3D3D3D28743D746869732E5F6D61726B657253657276696365297C7C766F696420303D3D3D747C7C742E72656164287B7265736F757263653A652E7572697D292E6D61702828653D3E652E6F776E65';
wwv_flow_imp.g_varchar2_table(32829) := '7229292E666F72456163682828743D3E746869732E5F6D61726B6572536572766963652E72656D6F766528742C5B652E7572695D2929297D5F7570646174654465636F726174696F6E732865297B636F6E737420743D746869732E5F6D61726B65725365';
wwv_flow_imp.g_varchar2_table(32830) := '72766963652E72656164287B7265736F757263653A652E6D6F64656C2E7572692C74616B653A3530307D293B652E7570646174652874292626746869732E5F6F6E4469644368616E67654D61726B65722E6669726528652E6D6F64656C297D7D3B5F6F65';
wwv_flow_imp.g_varchar2_table(32831) := '3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A';
wwv_flow_imp.g_varchar2_table(32832) := '693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520';
wwv_flow_imp.g_varchar2_table(32833) := '666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E';
wwv_flow_imp.g_varchar2_table(32834) := '646566696E6550726F706572747928742C6E2C72292C727D285B626F6528302C6663292C626F6528312C4A4D295D2C5F6F65293B636C61737320796F6520657874656E6473206C747B636F6E7374727563746F722865297B737570657228292C74686973';
wwv_flow_imp.g_varchar2_table(32835) := '2E6D6F64656C3D652C746869732E5F6D61703D6E6577206C612C746869732E5F7265676973746572287274282828293D3E7B746869732E6D6F64656C2E64656C74614465636F726174696F6E73285B2E2E2E746869732E5F6D61702E76616C7565732829';
wwv_flow_imp.g_varchar2_table(32836) := '5D2C5B5D292C746869732E5F6D61702E636C65617228297D2929297D7570646174652865297B636F6E73747B61646465643A742C72656D6F7665643A6E7D3D66756E6374696F6E28652C74297B636F6E7374206E3D5B5D2C693D5B5D3B666F7228636F6E';
wwv_flow_imp.g_varchar2_table(32837) := '73742069206F66206529742E6861732869297C7C6E2E707573682869293B666F7228636F6E7374206E206F66207429652E686173286E297C7C692E70757368286E293B72657475726E7B72656D6F7665643A6E2C61646465643A697D7D286E6577205365';
wwv_flow_imp.g_varchar2_table(32838) := '7428746869732E5F6D61702E6B6579732829292C6E657720536574286529293B696628303D3D3D742E6C656E6774682626303D3D3D6E2E6C656E6774682972657475726E21313B636F6E737420693D6E2E6D61702828653D3E746869732E5F6D61702E67';
wwv_flow_imp.g_varchar2_table(32839) := '657428652929292C6F3D742E6D61702828653D3E287B72616E67653A746869732E5F6372656174654465636F726174696F6E52616E676528746869732E6D6F64656C2C65292C6F7074696F6E733A746869732E5F6372656174654465636F726174696F6E';
wwv_flow_imp.g_varchar2_table(32840) := '4F7074696F6E2865297D2929292C733D746869732E6D6F64656C2E64656C74614465636F726174696F6E7328692C6F293B666F7228636F6E73742065206F66206E29746869732E5F6D61702E64656C6574652865293B666F72286C657420653D303B653C';
wwv_flow_imp.g_varchar2_table(32841) := '732E6C656E6774683B652B2B29746869732E5F6D61702E73657428745B655D2C735B655D293B72657475726E21307D6765744D61726B65722865297B72657475726E20746869732E5F6D61702E6765744B657928652E6964297D5F637265617465446563';
wwv_flow_imp.g_varchar2_table(32842) := '6F726174696F6E52616E676528652C74297B6C6574206E3D72682E6C6966742874293B696628742E7365766572697479213D3D5A4D2E48696E747C7C746869732E5F6861734D61726B657254616728742C31297C7C746869732E5F6861734D61726B6572';
wwv_flow_imp.g_varchar2_table(32843) := '54616728742C32297C7C286E3D6E2E736574456E64506F736974696F6E286E2E73746172744C696E654E756D6265722C6E2E7374617274436F6C756D6E2B3229292C6E3D652E76616C696461746552616E6765286E292C6E2E6973456D7074792829297B';
wwv_flow_imp.g_varchar2_table(32844) := '636F6E737420743D652E6765744C696E654C6173744E6F6E57686974657370616365436F6C756D6E286E2E73746172744C696E654E756D626572297C7C652E6765744C696E654D6178436F6C756D6E286E2E73746172744C696E654E756D626572293B69';
wwv_flow_imp.g_varchar2_table(32845) := '6628313D3D3D747C7C6E2E656E64436F6C756D6E3E3D742972657475726E206E3B636F6E737420693D652E676574576F72644174506F736974696F6E286E2E6765745374617274506F736974696F6E2829293B692626286E3D6E6577207268286E2E7374';
wwv_flow_imp.g_varchar2_table(32846) := '6172744C696E654E756D6265722C692E7374617274436F6C756D6E2C6E2E656E644C696E654E756D6265722C692E656E64436F6C756D6E29297D656C736520696628742E656E64436F6C756D6E3D3D3D4E756D6265722E4D41585F56414C55452626313D';
wwv_flow_imp.g_varchar2_table(32847) := '3D3D742E7374617274436F6C756D6E26266E2E73746172744C696E654E756D6265723D3D3D6E2E656E644C696E654E756D626572297B636F6E737420693D652E6765744C696E6546697273744E6F6E57686974657370616365436F6C756D6E28742E7374';
wwv_flow_imp.g_varchar2_table(32848) := '6172744C696E654E756D626572293B693C6E2E656E64436F6C756D6E2626286E3D6E6577207268286E2E73746172744C696E654E756D6265722C692C6E2E656E644C696E654E756D6265722C6E2E656E64436F6C756D6E292C742E7374617274436F6C75';
wwv_flow_imp.g_varchar2_table(32849) := '6D6E3D69297D72657475726E206E7D5F6372656174654465636F726174696F6E4F7074696F6E2865297B6C657420742C6E2C692C6F2C733B73776974636828652E7365766572697479297B63617365205A4D2E48696E743A743D746869732E5F6861734D';
wwv_flow_imp.g_varchar2_table(32850) := '61726B657254616728652C32293F766F696420303A746869732E5F6861734D61726B657254616728652C31293F227371756967676C792D756E6E6563657373617279223A227371756967676C792D68696E74222C693D303B627265616B3B63617365205A';
wwv_flow_imp.g_varchar2_table(32851) := '4D2E496E666F3A743D227371756967676C792D696E666F222C6E3D4F6228795F292C693D31302C733D7B636F6C6F723A4F62286E76292C706F736974696F6E3A317D3B627265616B3B63617365205A4D2E5761726E696E673A743D227371756967676C79';
wwv_flow_imp.g_varchar2_table(32852) := '2D7761726E696E67222C6E3D4F62285F5F292C693D32302C733D7B636F6C6F723A4F62286976292C706F736974696F6E3A317D3B627265616B3B63617365205A4D2E4572726F723A64656661756C743A743D227371756967676C792D6572726F72222C6E';
wwv_flow_imp.g_varchar2_table(32853) := '3D4F6228625F292C693D33302C733D7B636F6C6F723A4F62286F76292C706F736974696F6E3A317D7D72657475726E20652E746167732626282D31213D3D652E746167732E696E6465784F662831292626286F3D227371756967676C792D696E6C696E65';
wwv_flow_imp.g_varchar2_table(32854) := '2D756E6E656365737361727922292C2D31213D3D652E746167732E696E6465784F662832292626286F3D227371756967676C792D696E6C696E652D646570726563617465642229292C7B6465736372697074696F6E3A226D61726B65722D6465636F7261';
wwv_flow_imp.g_varchar2_table(32855) := '74696F6E222C737469636B696E6573733A312C636C6173734E616D653A742C73686F774966436F6C6C61707365643A21302C6F7665727669657752756C65723A7B636F6C6F723A6E2C706F736974696F6E3A53682E52696768747D2C6D696E696D61703A';
wwv_flow_imp.g_varchar2_table(32856) := '732C7A496E6465783A692C696E6C696E65436C6173734E616D653A6F7D7D5F6861734D61726B657254616728652C74297B72657475726E2121652E746167732626652E746167732E696E6465784F662874293E3D307D7D76617220776F652C436F653D66';
wwv_flow_imp.g_varchar2_table(32857) := '756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B66756E6374696F6E20536F652865297B72657475726E20652E746F537472696E6728297D636C61737320786F657B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(32858) := '6F7228652C742C6E297B746869732E6D6F64656C3D652C746869732E5F6D6F64656C4576656E744C697374656E6572733D6E65772061742C746869732E6D6F64656C3D652C746869732E5F6D6F64656C4576656E744C697374656E6572732E6164642865';
wwv_flow_imp.g_varchar2_table(32859) := '2E6F6E57696C6C446973706F7365282828293D3E742865292929292C746869732E5F6D6F64656C4576656E744C697374656E6572732E61646428652E6F6E4469644368616E67654C616E67756167652828743D3E6E28652C74292929297D646973706F73';
wwv_flow_imp.g_varchar2_table(32860) := '6528297B746869732E5F6D6F64656C4576656E744C697374656E6572732E646973706F736528297D7D636F6E7374206B6F653D247C7C713F313A323B636C61737320456F657B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C61297B74';
wwv_flow_imp.g_varchar2_table(32861) := '6869732E7572693D652C746869732E696E697469616C556E646F5265646F536E617073686F743D742C746869732E74696D653D6E2C746869732E736861726573556E646F5265646F537461636B3D692C746869732E6865617053697A653D6F2C74686973';
wwv_flow_imp.g_varchar2_table(32862) := '2E736861313D732C746869732E76657273696F6E49643D722C746869732E616C7465726E617469766556657273696F6E49643D617D7D6C6574204C6F653D776F653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(32863) := '2C692C6F297B737570657228292C746869732E5F636F6E66696775726174696F6E536572766963653D652C746869732E5F7265736F7572636550726F70657274696573536572766963653D742C746869732E5F756E646F5265646F536572766963653D6E';
wwv_flow_imp.g_varchar2_table(32864) := '2C746869732E5F6C616E6775616765536572766963653D692C746869732E5F6C616E6775616765436F6E66696775726174696F6E536572766963653D6F2C746869732E5F6F6E4D6F64656C41646465643D746869732E5F7265676973746572286E657720';
wwv_flow_imp.g_varchar2_table(32865) := '4374292C746869732E6F6E4D6F64656C41646465643D746869732E5F6F6E4D6F64656C41646465642E6576656E742C746869732E5F6F6E4D6F64656C52656D6F7665643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4D6F';
wwv_flow_imp.g_varchar2_table(32866) := '64656C52656D6F7665643D746869732E5F6F6E4D6F64656C52656D6F7665642E6576656E742C746869732E5F6F6E4D6F64656C4D6F64654368616E6765643D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4D6F64656C4C61';
wwv_flow_imp.g_varchar2_table(32867) := '6E67756167654368616E6765643D746869732E5F6F6E4D6F64656C4D6F64654368616E6765642E6576656E742C746869732E5F6D6F64656C4372656174696F6E4F7074696F6E7342794C616E6775616765416E645265736F757263653D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(32868) := '637265617465286E756C6C292C746869732E5F6D6F64656C733D7B7D2C746869732E5F646973706F7365644D6F64656C733D6E6577204D61702C746869732E5F646973706F7365644D6F64656C734865617053697A653D302C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(32869) := '74657228746869732E5F636F6E66696775726174696F6E536572766963652E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E746869732E5F7570646174654D6F64656C4F7074696F6E732865292929292C746869732E5F757064';
wwv_flow_imp.g_varchar2_table(32870) := '6174654D6F64656C4F7074696F6E7328766F69642030297D737461746963205F726561644D6F64656C4F7074696F6E7328652C74297B766172206E3B6C657420693D45752E74616253697A653B696628652E656469746F722626766F69642030213D3D65';
wwv_flow_imp.g_varchar2_table(32871) := '2E656469746F722E74616253697A65297B636F6E737420743D7061727365496E7428652E656469746F722E74616253697A652C3130293B69734E614E2874297C7C28693D74292C693C31262628693D31297D6C6574206F3D2274616253697A65223B6966';
wwv_flow_imp.g_varchar2_table(32872) := '28652E656469746F722626766F69642030213D3D652E656469746F722E696E64656E7453697A6526262274616253697A6522213D3D652E656469746F722E696E64656E7453697A65297B636F6E737420743D7061727365496E7428652E656469746F722E';
wwv_flow_imp.g_varchar2_table(32873) := '696E64656E7453697A652C3130293B69734E614E2874297C7C286F3D4D6174682E6D617828742C3129297D6C657420733D45752E696E736572745370616365733B652E656469746F722626766F69642030213D3D652E656469746F722E696E7365727453';
wwv_flow_imp.g_varchar2_table(32874) := '7061636573262628733D2266616C736522213D3D652E656469746F722E696E736572745370616365732626426F6F6C65616E28652E656469746F722E696E7365727453706163657329293B6C657420723D6B6F653B636F6E737420613D652E656F6C3B22';
wwv_flow_imp.g_varchar2_table(32875) := '5C725C6E223D3D3D613F723D323A225C6E223D3D3D61262628723D31293B6C6574206C3D45752E7472696D4175746F576869746573706163653B652E656469746F722626766F69642030213D3D652E656469746F722E7472696D4175746F576869746573';
wwv_flow_imp.g_varchar2_table(32876) := '706163652626286C3D2266616C736522213D3D652E656469746F722E7472696D4175746F576869746573706163652626426F6F6C65616E28652E656469746F722E7472696D4175746F5768697465737061636529293B6C657420633D45752E6465746563';
wwv_flow_imp.g_varchar2_table(32877) := '74496E64656E746174696F6E3B652E656469746F722626766F69642030213D3D652E656469746F722E646574656374496E64656E746174696F6E262628633D2266616C736522213D3D652E656469746F722E646574656374496E64656E746174696F6E26';
wwv_flow_imp.g_varchar2_table(32878) := '26426F6F6C65616E28652E656469746F722E646574656374496E64656E746174696F6E29293B6C657420643D45752E6C6172676546696C654F7074696D697A6174696F6E733B652E656469746F722626766F69642030213D3D652E656469746F722E6C61';
wwv_flow_imp.g_varchar2_table(32879) := '72676546696C654F7074696D697A6174696F6E73262628643D2266616C736522213D3D652E656469746F722E6C6172676546696C654F7074696D697A6174696F6E732626426F6F6C65616E28652E656469746F722E6C6172676546696C654F7074696D69';
wwv_flow_imp.g_varchar2_table(32880) := '7A6174696F6E7329293B6C657420683D45752E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E733B72657475726E286E756C6C3D3D3D286E3D652E656469746F72297C7C766F696420303D3D3D6E3F766F696420303A6E2E6272';
wwv_flow_imp.g_varchar2_table(32881) := '61636B657450616972436F6C6F72697A6174696F6E292626226F626A656374223D3D747970656F6620652E656469746F722E627261636B657450616972436F6C6F72697A6174696F6E262628683D7B656E61626C65643A2121652E656469746F722E6272';
wwv_flow_imp.g_varchar2_table(32882) := '61636B657450616972436F6C6F72697A6174696F6E2E656E61626C65642C696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970653A2121652E656469746F722E627261636B657450616972436F6C6F72697A6174696F6E2E';
wwv_flow_imp.g_varchar2_table(32883) := '696E646570656E64656E74436F6C6F72506F6F6C506572427261636B6574547970657D292C7B6973466F7253696D706C655769646765743A742C74616253697A653A692C696E64656E7453697A653A6F2C696E736572745370616365733A732C64657465';
wwv_flow_imp.g_varchar2_table(32884) := '6374496E64656E746174696F6E3A632C64656661756C74454F4C3A722C7472696D4175746F576869746573706163653A6C2C6C6172676546696C654F7074696D697A6174696F6E733A642C627261636B657450616972436F6C6F72697A6174696F6E4F70';
wwv_flow_imp.g_varchar2_table(32885) := '74696F6E733A687D7D5F676574454F4C28652C74297B696628652972657475726E20746869732E5F7265736F7572636550726F70657274696573536572766963652E676574454F4C28652C74293B636F6E7374206E3D746869732E5F636F6E6669677572';
wwv_flow_imp.g_varchar2_table(32886) := '6174696F6E536572766963652E67657456616C7565282266696C65732E656F6C222C7B6F766572726964654964656E7469666965723A747D293B72657475726E206E262622737472696E67223D3D747970656F66206E2626226175746F22213D3D6E3F6E';
wwv_flow_imp.g_varchar2_table(32887) := '3A333D3D3D74657C7C323D3D3D74653F225C6E223A225C725C6E227D5F73686F756C64526573746F7265556E646F537461636B28297B636F6E737420653D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C7565282266';
wwv_flow_imp.g_varchar2_table(32888) := '696C65732E726573746F7265556E646F537461636B22293B72657475726E22626F6F6C65616E22213D747970656F6620657C7C657D6765744372656174696F6E4F7074696F6E7328652C742C6E297B636F6E737420693D22737472696E67223D3D747970';
wwv_flow_imp.g_varchar2_table(32889) := '656F6620653F653A652E6C616E677561676549643B6C6574206F3D746869732E5F6D6F64656C4372656174696F6E4F7074696F6E7342794C616E6775616765416E645265736F757263655B692B745D3B696628216F297B636F6E737420653D746869732E';
wwv_flow_imp.g_varchar2_table(32890) := '5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F72222C7B6F766572726964654964656E7469666965723A692C7265736F757263653A747D292C733D746869732E5F676574454F4C28742C69293B6F3D776F65';
wwv_flow_imp.g_varchar2_table(32891) := '2E5F726561644D6F64656C4F7074696F6E73287B656469746F723A652C656F6C3A737D2C6E292C746869732E5F6D6F64656C4372656174696F6E4F7074696F6E7342794C616E6775616765416E645265736F757263655B692B745D3D6F7D72657475726E';
wwv_flow_imp.g_varchar2_table(32892) := '206F7D5F7570646174654D6F64656C4F7074696F6E732865297B636F6E737420743D746869732E5F6D6F64656C4372656174696F6E4F7074696F6E7342794C616E6775616765416E645265736F757263653B746869732E5F6D6F64656C4372656174696F';
wwv_flow_imp.g_varchar2_table(32893) := '6E4F7074696F6E7342794C616E6775616765416E645265736F757263653D4F626A6563742E637265617465286E756C6C293B636F6E7374206E3D4F626A6563742E6B65797328746869732E5F6D6F64656C73293B666F72286C657420693D302C6F3D6E2E';
wwv_flow_imp.g_varchar2_table(32894) := '6C656E6774683B693C6F3B692B2B297B636F6E7374206F3D6E5B695D2C733D746869732E5F6D6F64656C735B6F5D2C723D732E6D6F64656C2E6765744C616E6775616765496428292C613D732E6D6F64656C2E7572693B69662865262621652E61666665';
wwv_flow_imp.g_varchar2_table(32895) := '637473436F6E66696775726174696F6E2822656469746F72222C7B6F766572726964654964656E7469666965723A722C7265736F757263653A617D29262621652E61666665637473436F6E66696775726174696F6E282266696C65732E656F6C222C7B6F';
wwv_flow_imp.g_varchar2_table(32896) := '766572726964654964656E7469666965723A722C7265736F757263653A617D2929636F6E74696E75653B636F6E7374206C3D745B722B615D2C633D746869732E6765744372656174696F6E4F7074696F6E7328722C612C732E6D6F64656C2E6973466F72';
wwv_flow_imp.g_varchar2_table(32897) := '53696D706C65576964676574293B776F652E5F7365744D6F64656C4F7074696F6E73466F724D6F64656C28732E6D6F64656C2C632C6C297D7D737461746963205F7365744D6F64656C4F7074696F6E73466F724D6F64656C28652C742C6E297B6E26266E';
wwv_flow_imp.g_varchar2_table(32898) := '2E64656661756C74454F4C213D3D742E64656661756C74454F4C2626313D3D3D652E6765744C696E65436F756E7428292626652E736574454F4C28313D3D3D742E64656661756C74454F4C3F303A31292C6E26266E2E646574656374496E64656E746174';
wwv_flow_imp.g_varchar2_table(32899) := '696F6E3D3D3D742E646574656374496E64656E746174696F6E26266E2E696E736572745370616365733D3D3D742E696E7365727453706163657326266E2E74616253697A653D3D3D742E74616253697A6526266E2E696E64656E7453697A653D3D3D742E';
wwv_flow_imp.g_varchar2_table(32900) := '696E64656E7453697A6526266E2E7472696D4175746F576869746573706163653D3D3D742E7472696D4175746F5768697465737061636526267768286E2E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F6E732C742E627261636B';
wwv_flow_imp.g_varchar2_table(32901) := '657450616972436F6C6F72697A6174696F6E4F7074696F6E73297C7C28742E646574656374496E64656E746174696F6E3F28652E646574656374496E64656E746174696F6E28742E696E736572745370616365732C742E74616253697A65292C652E7570';
wwv_flow_imp.g_varchar2_table(32902) := '646174654F7074696F6E73287B7472696D4175746F576869746573706163653A742E7472696D4175746F576869746573706163652C627261636B6574436F6C6F72697A6174696F6E4F7074696F6E733A742E627261636B657450616972436F6C6F72697A';
wwv_flow_imp.g_varchar2_table(32903) := '6174696F6E4F7074696F6E737D29293A652E7570646174654F7074696F6E73287B696E736572745370616365733A742E696E736572745370616365732C74616253697A653A742E74616253697A652C696E64656E7453697A653A742E696E64656E745369';
wwv_flow_imp.g_varchar2_table(32904) := '7A652C7472696D4175746F576869746573706163653A742E7472696D4175746F576869746573706163652C627261636B6574436F6C6F72697A6174696F6E4F7074696F6E733A742E627261636B657450616972436F6C6F72697A6174696F6E4F7074696F';
wwv_flow_imp.g_varchar2_table(32905) := '6E737D29297D5F696E73657274446973706F7365644D6F64656C2865297B746869732E5F646973706F7365644D6F64656C732E73657428536F6528652E757269292C65292C746869732E5F646973706F7365644D6F64656C734865617053697A652B3D65';
wwv_flow_imp.g_varchar2_table(32906) := '2E6865617053697A657D5F72656D6F7665446973706F7365644D6F64656C2865297B636F6E737420743D746869732E5F646973706F7365644D6F64656C732E67657428536F65286529293B72657475726E2074262628746869732E5F646973706F736564';
wwv_flow_imp.g_varchar2_table(32907) := '4D6F64656C734865617053697A652D3D742E6865617053697A65292C746869732E5F646973706F7365644D6F64656C732E64656C65746528536F65286529292C747D5F656E73757265446973706F7365644D6F64656C734865617053697A652865297B69';
wwv_flow_imp.g_varchar2_table(32908) := '6628746869732E5F646973706F7365644D6F64656C734865617053697A653E65297B636F6E737420743D5B5D3B666F7228746869732E5F646973706F7365644D6F64656C732E666F72456163682828653D3E7B652E736861726573556E646F5265646F53';
wwv_flow_imp.g_varchar2_table(32909) := '7461636B7C7C742E707573682865297D29292C742E736F7274282828652C74293D3E652E74696D652D742E74696D6529293B742E6C656E6774683E302626746869732E5F646973706F7365644D6F64656C734865617053697A653E653B297B636F6E7374';
wwv_flow_imp.g_varchar2_table(32910) := '20653D742E736869667428293B746869732E5F72656D6F7665446973706F7365644D6F64656C28652E757269292C6E756C6C213D3D652E696E697469616C556E646F5265646F536E617073686F742626746869732E5F756E646F5265646F536572766963';
wwv_flow_imp.g_varchar2_table(32911) := '652E726573746F7265536E617073686F7428652E696E697469616C556E646F5265646F536E617073686F74297D7D7D5F6372656174654D6F64656C4461746128652C742C6E2C69297B636F6E7374206F3D746869732E6765744372656174696F6E4F7074';
wwv_flow_imp.g_varchar2_table(32912) := '696F6E7328742C6E2C69292C733D6E6577206B4328652C742C6F2C6E2C746869732E5F756E646F5265646F536572766963652C746869732E5F6C616E6775616765536572766963652C746869732E5F6C616E6775616765436F6E66696775726174696F6E';
wwv_flow_imp.g_varchar2_table(32913) := '53657276696365293B6966286E2626746869732E5F646973706F7365644D6F64656C732E68617328536F65286E2929297B636F6E737420653D746869732E5F72656D6F7665446973706F7365644D6F64656C286E292C743D746869732E5F756E646F5265';
wwv_flow_imp.g_varchar2_table(32914) := '646F536572766963652E676574456C656D656E7473286E292C693D746869732E5F67657453484131436F6D707574657228292C6F3D2121692E63616E436F6D70757465534841312873292626692E636F6D70757465534841312873293D3D3D652E736861';
wwv_flow_imp.g_varchar2_table(32915) := '313B6966286F7C7C652E736861726573556E646F5265646F537461636B297B666F7228636F6E73742065206F6620742E7061737429595F2865292626652E6D6174636865735265736F75726365286E292626652E7365744D6F64656C2873293B666F7228';
wwv_flow_imp.g_varchar2_table(32916) := '636F6E73742065206F6620742E66757475726529595F2865292626652E6D6174636865735265736F75726365286E292626652E7365744D6F64656C2873293B746869732E5F756E646F5265646F536572766963652E736574456C656D656E747356616C69';
wwv_flow_imp.g_varchar2_table(32917) := '64466C6167286E2C21302C28653D3E595F2865292626652E6D6174636865735265736F75726365286E2929292C6F262628732E5F6F766572777269746556657273696F6E496428652E76657273696F6E4964292C732E5F6F7665727772697465416C7465';
wwv_flow_imp.g_varchar2_table(32918) := '726E617469766556657273696F6E496428652E616C7465726E617469766556657273696F6E4964292C732E5F6F7665727772697465496E697469616C556E646F5265646F536E617073686F7428652E696E697469616C556E646F5265646F536E61707368';
wwv_flow_imp.g_varchar2_table(32919) := '6F7429297D656C7365206E756C6C213D3D652E696E697469616C556E646F5265646F536E617073686F742626746869732E5F756E646F5265646F536572766963652E726573746F7265536E617073686F7428652E696E697469616C556E646F5265646F53';
wwv_flow_imp.g_varchar2_table(32920) := '6E617073686F74297D636F6E737420723D536F6528732E757269293B696628746869732E5F6D6F64656C735B725D297468726F77206E6577204572726F7228224D6F64656C536572766963653A2043616E6E6F7420616464206D6F64656C206265636175';
wwv_flow_imp.g_varchar2_table(32921) := '736520697420616C7265616479206578697374732122293B636F6E737420613D6E657720786F6528732C28653D3E746869732E5F6F6E57696C6C446973706F7365286529292C2828652C74293D3E746869732E5F6F6E4469644368616E67654C616E6775';
wwv_flow_imp.g_varchar2_table(32922) := '61676528652C742929293B72657475726E20746869732E5F6D6F64656C735B725D3D612C617D6372656174654D6F64656C28652C742C6E2C693D2131297B6C6574206F3B72657475726E206F3D743F746869732E5F6372656174654D6F64656C44617461';
wwv_flow_imp.g_varchar2_table(32923) := '28652C742C6E2C69293A746869732E5F6372656174654D6F64656C4461746128652C55702C6E2C69292C746869732E5F6F6E4D6F64656C41646465642E66697265286F2E6D6F64656C292C6F2E6D6F64656C7D6765744D6F64656C7328297B636F6E7374';
wwv_flow_imp.g_varchar2_table(32924) := '20653D5B5D2C743D4F626A6563742E6B65797328746869732E5F6D6F64656C73293B666F72286C6574206E3D302C693D742E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D745B6E5D3B652E7075736828746869732E5F6D6F64656C735B69';
wwv_flow_imp.g_varchar2_table(32925) := '5D2E6D6F64656C297D72657475726E20657D6765744D6F64656C2865297B636F6E737420743D536F652865292C6E3D746869732E5F6D6F64656C735B745D3B72657475726E206E3F6E2E6D6F64656C3A6E756C6C7D5F736368656D6153686F756C644D61';
wwv_flow_imp.g_varchar2_table(32926) := '696E7461696E556E646F5265646F456C656D656E74732865297B72657475726E20652E736368656D653D3D3D716F2E66696C657C7C652E736368656D653D3D3D716F2E7673636F646552656D6F74657C7C652E736368656D653D3D3D716F2E7673636F64';
wwv_flow_imp.g_varchar2_table(32927) := '6555736572446174617C7C652E736368656D653D3D3D716F2E7673636F64654E6F7465626F6F6B43656C6C7C7C2266616B652D6673223D3D3D652E736368656D657D5F6F6E57696C6C446973706F73652865297B636F6E737420743D536F6528652E7572';
wwv_flow_imp.g_varchar2_table(32928) := '69292C6E3D746869732E5F6D6F64656C735B745D2C693D746869732E5F756E646F5265646F536572766963652E676574557269436F6D70617269736F6E4B657928652E75726929213D3D652E7572692E746F537472696E6728293B6C6574206F3D21312C';
wwv_flow_imp.g_varchar2_table(32929) := '733D303B696628697C7C746869732E5F73686F756C64526573746F7265556E646F537461636B28292626746869732E5F736368656D6153686F756C644D61696E7461696E556E646F5265646F456C656D656E747328652E75726929297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(32930) := '3D746869732E5F756E646F5265646F536572766963652E676574456C656D656E747328652E757269293B696628742E706173742E6C656E6774683E307C7C742E6675747572652E6C656E6774683E30297B666F7228636F6E7374206E206F6620742E7061';
wwv_flow_imp.g_varchar2_table(32931) := '737429595F286E2926266E2E6D6174636865735265736F7572636528652E757269292626286F3D21302C732B3D6E2E6865617053697A6528652E757269292C6E2E7365744D6F64656C28652E75726929293B666F7228636F6E7374206E206F6620742E66';
wwv_flow_imp.g_varchar2_table(32932) := '757475726529595F286E2926266E2E6D6174636865735265736F7572636528652E757269292626286F3D21302C732B3D6E2E6865617053697A6528652E757269292C6E2E7365744D6F64656C28652E75726929297D7D636F6E737420723D776F652E4D41';
wwv_flow_imp.g_varchar2_table(32933) := '585F4D454D4F52595F464F525F434C4F5345445F46494C45535F554E444F5F535441434B2C613D746869732E5F67657453484131436F6D707574657228293B6966286F29696628697C7C2128733E72292626612E63616E436F6D70757465534841312865';
wwv_flow_imp.g_varchar2_table(32934) := '2929746869732E5F656E73757265446973706F7365644D6F64656C734865617053697A6528722D73292C746869732E5F756E646F5265646F536572766963652E736574456C656D656E747356616C6964466C616728652E7572692C21312C28743D3E595F';
wwv_flow_imp.g_varchar2_table(32935) := '2874292626742E6D6174636865735265736F7572636528652E7572692929292C746869732E5F696E73657274446973706F7365644D6F64656C286E657720456F6528652E7572692C6E2E6D6F64656C2E676574496E697469616C556E646F5265646F536E';
wwv_flow_imp.g_varchar2_table(32936) := '617073686F7428292C446174652E6E6F7728292C692C732C612E636F6D70757465534841312865292C652E67657456657273696F6E496428292C652E676574416C7465726E617469766556657273696F6E4964282929293B656C73657B636F6E73742065';
wwv_flow_imp.g_varchar2_table(32937) := '3D6E2E6D6F64656C2E676574496E697469616C556E646F5265646F536E617073686F7428293B6E756C6C213D3D652626746869732E5F756E646F5265646F536572766963652E726573746F7265536E617073686F742865297D656C736520696628216929';
wwv_flow_imp.g_varchar2_table(32938) := '7B636F6E737420653D6E2E6D6F64656C2E676574496E697469616C556E646F5265646F536E617073686F7428293B6E756C6C213D3D652626746869732E5F756E646F5265646F536572766963652E726573746F7265536E617073686F742865297D64656C';
wwv_flow_imp.g_varchar2_table(32939) := '65746520746869732E5F6D6F64656C735B745D2C6E2E646973706F736528292C64656C65746520746869732E5F6D6F64656C4372656174696F6E4F7074696F6E7342794C616E6775616765416E645265736F757263655B652E6765744C616E6775616765';
wwv_flow_imp.g_varchar2_table(32940) := '496428292B652E7572695D2C746869732E5F6F6E4D6F64656C52656D6F7665642E666972652865297D5F6F6E4469644368616E67654C616E677561676528652C74297B636F6E7374206E3D742E6F6C644C616E67756167652C693D652E6765744C616E67';
wwv_flow_imp.g_varchar2_table(32941) := '75616765496428292C6F3D746869732E6765744372656174696F6E4F7074696F6E73286E2C652E7572692C652E6973466F7253696D706C65576964676574292C733D746869732E6765744372656174696F6E4F7074696F6E7328692C652E7572692C652E';
wwv_flow_imp.g_varchar2_table(32942) := '6973466F7253696D706C65576964676574293B776F652E5F7365744D6F64656C4F7074696F6E73466F724D6F64656C28652C732C6F292C746869732E5F6F6E4D6F64656C4D6F64654368616E6765642E66697265287B6D6F64656C3A652C6F6C644C616E';
wwv_flow_imp.g_varchar2_table(32943) := '677561676549643A6E7D297D5F67657453484131436F6D707574657228297B72657475726E206E657720446F657D7D3B4C6F652E4D41585F4D454D4F52595F464F525F434C4F5345445F46494C45535F554E444F5F535441434B3D32303937313532302C';
wwv_flow_imp.g_varchar2_table(32944) := '4C6F653D776F653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F';
wwv_flow_imp.g_varchar2_table(32945) := '7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(32946) := '293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E332626722626';
wwv_flow_imp.g_varchar2_table(32947) := '4F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B436F6528302C6670292C436F6528312C5148292C436F6528322C6D43292C436F6528332C4C75292C436F6528342C6567295D2C4C6F65293B636C61737320446F657B63';
wwv_flow_imp.g_varchar2_table(32948) := '616E436F6D70757465534841312865297B72657475726E20652E67657456616C75654C656E67746828293C3D446F652E4D41585F4D4F44454C5F53495A457D636F6D70757465534841312865297B636F6E737420743D6E6577206F732C6E3D652E637265';
wwv_flow_imp.g_varchar2_table(32949) := '617465536E617073686F7428293B6C657420693B666F72283B693D6E2E7265616428293B29742E7570646174652869293B72657475726E20742E64696765737428297D7D446F652E4D41585F4D4F44454C5F53495A453D31303438353736303B76617220';
wwv_flow_imp.g_varchar2_table(32950) := '546F653D6E2831343436292C496F653D7B7D3B496F652E7374796C655461675472616E73666F726D3D6A7228292C496F652E736574417474726962757465733D567228292C496F652E696E736572743D467228292E62696E64286E756C6C2C2268656164';
wwv_flow_imp.g_varchar2_table(32951) := '22292C496F652E646F6D4150493D4F7228292C496F652E696E736572745374796C65456C656D656E743D487228292C4E72282928546F652E412C496F65292C546F652E412626546F652E412E6C6F63616C732626546F652E412E6C6F63616C733B766172';
wwv_flow_imp.g_varchar2_table(32952) := '204D6F653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C657420416F653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B73757065722829';
wwv_flow_imp.g_varchar2_table(32953) := '2C746869732E717569636B496E707574536572766963653D652C746869732E696E7374616E74696174696F6E536572766963653D742C746869732E72656769737472793D79642E6173284E32292C746869732E6D617050726F7669646572546F44657363';
wwv_flow_imp.g_varchar2_table(32954) := '726970746F723D6E6577204D61702C746869732E6C61737441636365707465645069636B657256616C7565733D6E6577204D61702C746869732E76697369626C65517569636B4163636573733D766F696420307D73686F7728653D22222C74297B746869';
wwv_flow_imp.g_varchar2_table(32955) := '732E646F53686F774F725069636B28652C21312C74297D646F53686F774F725069636B28652C742C6E297B76617220692C6F2C733B636F6E73745B722C615D3D746869732E6765744F72496E7374616E746961746550726F76696465722865292C6C3D74';
wwv_flow_imp.g_varchar2_table(32956) := '6869732E76697369626C65517569636B4163636573732C633D6E756C6C3D3D6C3F766F696420303A6C2E64657363726970746F723B6966286C2626612626633D3D3D612972657475726E20653D3D3D612E7072656669787C7C286E756C6C3D3D6E3F766F';
wwv_flow_imp.g_varchar2_table(32957) := '696420303A6E2E707265736572766556616C7565297C7C286C2E7069636B65722E76616C75653D65292C766F696420746869732E61646A75737456616C756553656C656374696F6E286C2E7069636B65722C612C6E293B69662861262621286E756C6C3D';
wwv_flow_imp.g_varchar2_table(32958) := '3D6E3F766F696420303A6E2E707265736572766556616C756529297B6C657420743B6966286C262663262663213D3D61297B636F6E737420653D6C2E76616C75652E73756273747228632E7072656669782E6C656E677468293B65262628743D60247B61';
wwv_flow_imp.g_varchar2_table(32959) := '2E7072656669787D247B657D60297D6966282174297B636F6E737420653D6E756C6C3D3D723F766F696420303A722E64656661756C7446696C74657256616C75653B653D3D3D41322E4C4153543F743D746869732E6C6173744163636570746564506963';
wwv_flow_imp.g_varchar2_table(32960) := '6B657256616C7565732E6765742861293A22737472696E67223D3D747970656F662065262628743D60247B612E7072656669787D247B657D60297D22737472696E67223D3D747970656F662074262628653D74297D636F6E737420643D6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(32961) := '28693D6E756C6C3D3D6C3F766F696420303A6C2E7069636B6572297C7C766F696420303D3D3D693F766F696420303A692E76616C756553656C656374696F6E2C683D6E756C6C3D3D3D286F3D6E756C6C3D3D6C3F766F696420303A6C2E7069636B657229';
wwv_flow_imp.g_varchar2_table(32962) := '7C7C766F696420303D3D3D6F3F766F696420303A6F2E76616C75652C753D6E65772061742C703D752E61646428746869732E717569636B496E707574536572766963652E637265617465517569636B5069636B2829293B6C657420673B702E76616C7565';
wwv_flow_imp.g_varchar2_table(32963) := '3D652C746869732E61646A75737456616C756553656C656374696F6E28702C612C6E292C702E706C616365686F6C6465723D6E756C6C3D3D613F766F696420303A612E706C616365686F6C6465722C702E717569636B4E617669676174653D6E756C6C3D';
wwv_flow_imp.g_varchar2_table(32964) := '3D6E3F766F696420303A6E2E717569636B4E61766967617465436F6E66696775726174696F6E2C702E68696465496E7075743D2121702E717569636B4E617669676174652626216C2C28226E756D626572223D3D747970656F66286E756C6C3D3D6E3F76';
wwv_flow_imp.g_varchar2_table(32965) := '6F696420303A6E2E6974656D41637469766174696F6E297C7C286E756C6C3D3D6E3F766F696420303A6E2E717569636B4E61766967617465436F6E66696775726174696F6E2929262628702E6974656D41637469766174696F6E3D6E756C6C213D3D2873';
wwv_flow_imp.g_varchar2_table(32966) := '3D6E756C6C3D3D6E3F766F696420303A6E2E6974656D41637469766174696F6E292626766F69642030213D3D733F733A45452E5345434F4E44292C702E636F6E746578744B65793D6E756C6C3D3D613F766F696420303A612E636F6E746578744B65792C';
wwv_flow_imp.g_varchar2_table(32967) := '702E66696C74657256616C75653D653D3E652E737562737472696E6728613F612E7072656669782E6C656E6774683A30292C74262628673D6E65772058742C752E6164642876742E6F6E636528702E6F6E57696C6C416363657074292828653D3E7B652E';
wwv_flow_imp.g_varchar2_table(32968) := '7665746F28292C702E6869646528297D292929292C752E61646428746869732E72656769737465725069636B65724C697374656E65727328702C722C612C652C6E756C6C3D3D6E3F766F696420303A6E2E70726F76696465724F7074696F6E7329293B63';
wwv_flow_imp.g_varchar2_table(32969) := '6F6E7374206D3D752E616464286E6577204E74293B72657475726E20722626752E61646428722E70726F7669646528702C6D2E746F6B656E2C6E756C6C3D3D6E3F766F696420303A6E2E70726F76696465724F7074696F6E7329292C76742E6F6E636528';
wwv_flow_imp.g_varchar2_table(32970) := '702E6F6E4469644869646529282828293D3E7B303D3D3D702E73656C65637465644974656D732E6C656E67746826266D2E63616E63656C28292C752E646973706F736528292C6E756C6C3D3D677C7C672E636F6D706C65746528702E73656C6563746564';
wwv_flow_imp.g_varchar2_table(32971) := '4974656D732E736C696365283029297D29292C702E73686F7728292C642626683D3D3D65262628702E76616C756553656C656374696F6E3D64292C743F6E756C6C3D3D673F766F696420303A672E703A766F696420307D61646A75737456616C75655365';
wwv_flow_imp.g_varchar2_table(32972) := '6C656374696F6E28652C742C6E297B76617220693B6C6574206F3B6F3D286E756C6C3D3D6E3F766F696420303A6E2E707265736572766556616C7565293F5B652E76616C75652E6C656E6774682C652E76616C75652E6C656E6774685D3A5B6E756C6C21';
wwv_flow_imp.g_varchar2_table(32973) := '3D3D28693D6E756C6C3D3D743F766F696420303A742E7072656669782E6C656E677468292626766F69642030213D3D693F693A302C652E76616C75652E6C656E6774685D2C652E76616C756553656C656374696F6E3D6F7D72656769737465725069636B';
wwv_flow_imp.g_varchar2_table(32974) := '65724C697374656E65727328652C742C6E2C692C6F297B636F6E737420733D6E65772061742C723D746869732E76697369626C65517569636B4163636573733D7B7069636B65723A652C64657363726970746F723A6E2C76616C75653A697D3B72657475';
wwv_flow_imp.g_varchar2_table(32975) := '726E20732E616464287274282828293D3E7B723D3D3D746869732E76697369626C65517569636B416363657373262628746869732E76697369626C65517569636B4163636573733D766F69642030297D2929292C732E61646428652E6F6E446964436861';
wwv_flow_imp.g_varchar2_table(32976) := '6E676556616C75652828653D3E7B636F6E73745B6E5D3D746869732E6765744F72496E7374616E746961746550726F76696465722865293B6E213D3D743F746869732E73686F7728652C7B707265736572766556616C75653A21302C70726F7669646572';
wwv_flow_imp.g_varchar2_table(32977) := '4F7074696F6E733A6F7D293A722E76616C75653D657D2929292C6E2626732E61646428652E6F6E446964416363657074282828293D3E7B746869732E6C61737441636365707465645069636B657256616C7565732E736574286E2C652E76616C7565297D';
wwv_flow_imp.g_varchar2_table(32978) := '2929292C737D6765744F72496E7374616E746961746550726F76696465722865297B636F6E737420743D746869732E72656769737472792E676574517569636B41636365737350726F76696465722865293B69662821742972657475726E5B766F696420';
wwv_flow_imp.g_varchar2_table(32979) := '302C766F696420305D3B6C6574206E3D746869732E6D617050726F7669646572546F44657363726970746F722E6765742874293B72657475726E206E7C7C286E3D746869732E696E7374616E74696174696F6E536572766963652E637265617465496E73';
wwv_flow_imp.g_varchar2_table(32980) := '74616E636528742E63746F72292C746869732E6D617050726F7669646572546F44657363726970746F722E73657428742C6E29292C5B6E2C745D7D7D3B416F653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E7473';
wwv_flow_imp.g_varchar2_table(32981) := '2E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E63';
wwv_flow_imp.g_varchar2_table(32982) := '74696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B61';
wwv_flow_imp.g_varchar2_table(32983) := '5D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4D6F6528302C4C45292C';
wwv_flow_imp.g_varchar2_table(32984) := '4D6F6528312C7563295D2C416F65293B766172204E6F653D6E2837343932292C506F653D7B7D3B506F652E7374796C655461675472616E73666F726D3D6A7228292C506F652E736574417474726962757465733D567228292C506F652E696E736572743D';
wwv_flow_imp.g_varchar2_table(32985) := '467228292E62696E64286E756C6C2C226865616422292C506F652E646F6D4150493D4F7228292C506F652E696E736572745374796C65456C656D656E743D487228292C4E722829284E6F652E412C506F65292C4E6F652E4126264E6F652E412E6C6F6361';
wwv_flow_imp.g_varchar2_table(32986) := '6C7326264E6F652E412E6C6F63616C733B636C617373204F6F657B636F6E7374727563746F722865297B746869732E6E6F6465733D657D746F537472696E6728297B72657475726E20746869732E6E6F6465732E6D61702828653D3E22737472696E6722';
wwv_flow_imp.g_varchar2_table(32987) := '3D3D747970656F6620653F653A652E6C6162656C29292E6A6F696E282222297D7D2166756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A65';
wwv_flow_imp.g_varchar2_table(32988) := '63742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529';
wwv_flow_imp.g_varchar2_table(32989) := '723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F';
wwv_flow_imp.g_varchar2_table(32990) := '28742C6E29297C7C72293B733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72297D285B44455D2C4F6F652E70726F746F747970652C22746F537472696E67222C6E756C6C293B636F6E737420526F653D2F5C5B285B';
wwv_flow_imp.g_varchar2_table(32991) := '5E5C5D5D2B295C5D5C2828283F3A68747470733F3A5C2F5C2F7C636F6D6D616E643A7C66696C653A295B5E5C295C735D2B29283F3A20285B22275D29282E2B3F29285C3329293F5C292F67692C466F653D7B7D2C426F653D6E6577206B6B282271756963';
wwv_flow_imp.g_varchar2_table(32992) := '6B2D696E7075742D627574746F6E2D69636F6E2D22293B66756E6374696F6E20566F6528652C742C6E297B6C657420693D652E69636F6E436C6173737C7C66756E6374696F6E2865297B69662821652972657475726E3B6C657420743B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(32993) := '3D652E6461726B2E746F537472696E6728293B72657475726E20466F655B6E5D3F743D466F655B6E5D3A28743D426F652E6E657874496428292C6E7228602E247B747D2C202E68632D6C69676874202E247B747D602C606261636B67726F756E642D696D';
wwv_flow_imp.g_varchar2_table(32994) := '6167653A20247B537228652E6C696768747C7C652E6461726B297D60292C6E7228602E76732D6461726B202E247B747D2C202E68632D626C61636B202E247B747D602C606261636B67726F756E642D696D6167653A20247B537228652E6461726B297D60';
wwv_flow_imp.g_varchar2_table(32995) := '292C466F655B6E5D3D74292C747D28652E69636F6E50617468293B72657475726E20652E616C7761797356697369626C65262628693D693F60247B697D20616C776179732D76697369626C65603A22616C776179732D76697369626C6522292C7B69643A';
wwv_flow_imp.g_varchar2_table(32996) := '742C6C6162656C3A22222C746F6F6C7469703A652E746F6F6C7469707C7C22222C636C6173733A692C656E61626C65643A21302C72756E3A6E7D7D636F6E7374207A6F653D6E6577206969282828293D3E7B636F6E737420653D6E657720496E746C2E43';
wwv_flow_imp.g_varchar2_table(32997) := '6F6C6C61746F7228766F696420302C7B6E756D657269633A21302C73656E73697469766974793A2262617365227D293B72657475726E7B636F6C6C61746F723A652C636F6C6C61746F7249734E756D657269633A652E7265736F6C7665644F7074696F6E';
wwv_flow_imp.g_varchar2_table(32998) := '7328292E6E756D657269637D7D29293B6E6577206969282828293D3E287B636F6C6C61746F723A6E657720496E746C2E436F6C6C61746F7228766F696420302C7B6E756D657269633A21307D297D2929292C6E6577206969282828293D3E287B636F6C6C';
wwv_flow_imp.g_varchar2_table(32999) := '61746F723A6E657720496E746C2E436F6C6C61746F7228766F696420302C7B6E756D657269633A21302C73656E73697469766974793A22616363656E74227D297D2929293B76617220486F652C576F653D66756E6374696F6E28652C742C6E2C69297B76';
wwv_flow_imp.g_varchar2_table(33000) := '6172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(33001) := '66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(33002) := '3B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72';
wwv_flow_imp.g_varchar2_table(33003) := '292C727D2C6A6F653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E737420716F653D62723B76617220246F652C556F653B2166756E6374696F6E2865297B655B652E466972';
wwv_flow_imp.g_varchar2_table(33004) := '73743D315D3D224669727374222C655B652E5365636F6E643D325D3D225365636F6E64222C655B652E4C6173743D335D3D224C617374222C655B652E4E6578743D345D3D224E657874222C655B652E50726576696F75733D355D3D2250726576696F7573';
wwv_flow_imp.g_varchar2_table(33005) := '222C655B652E4E657874506167653D365D3D224E65787450616765222C655B652E50726576696F7573506167653D375D3D2250726576696F757350616765222C655B652E4E657874536570617261746F723D385D3D224E657874536570617261746F7222';
wwv_flow_imp.g_varchar2_table(33006) := '2C655B652E50726576696F7573536570617261746F723D395D3D2250726576696F7573536570617261746F72227D28246F657C7C28246F653D7B7D29293B636C617373204B6F657B636F6E7374727563746F7228652C742C6E297B746869732E696E6465';
wwv_flow_imp.g_varchar2_table(33007) := '783D652C746869732E686173436865636B626F783D742C746869732E5F68696464656E3D21312C746869732E5F696E69743D6E6577206969282828293D3E7B76617220653B636F6E737420743D6E756C6C213D3D28653D6E2E6C6162656C292626766F69';
wwv_flow_imp.g_varchar2_table(33008) := '642030213D3D653F653A22222C693D526C2874292E746578742E7472696D28292C6F3D6E2E617269614C6162656C7C7C5B742C746869732E73616E654465736372697074696F6E2C746869732E73616E6544657461696C5D2E6D61702828653D3E7B7265';
wwv_flow_imp.g_varchar2_table(33009) := '7475726E28743D65293F742E7265706C616365282F5C245C28282E2A3F295C292F672C2828652C74293D3E6020247B747D206029292E7472696D28293A22223B76617220747D29292E66696C7465722828653D3E21216529292E6A6F696E28222C202229';
wwv_flow_imp.g_varchar2_table(33010) := '3B72657475726E7B73616E654C6162656C3A742C73616E65536F72744C6162656C3A692C73616E65417269614C6162656C3A6F7D7D29292C746869732E5F73616E654465736372697074696F6E3D6E2E6465736372697074696F6E2C746869732E5F7361';
wwv_flow_imp.g_varchar2_table(33011) := '6E65546F6F6C7469703D6E2E746F6F6C7469707D6765742073616E654C6162656C28297B72657475726E20746869732E5F696E69742E76616C75652E73616E654C6162656C7D6765742073616E65536F72744C6162656C28297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(33012) := '732E5F696E69742E76616C75652E73616E65536F72744C6162656C7D6765742073616E65417269614C6162656C28297B72657475726E20746869732E5F696E69742E76616C75652E73616E65417269614C6162656C7D67657420656C656D656E7428297B';
wwv_flow_imp.g_varchar2_table(33013) := '72657475726E20746869732E5F656C656D656E747D73657420656C656D656E742865297B746869732E5F656C656D656E743D657D6765742068696464656E28297B72657475726E20746869732E5F68696464656E7D7365742068696464656E2865297B74';
wwv_flow_imp.g_varchar2_table(33014) := '6869732E5F68696464656E3D657D6765742073616E654465736372697074696F6E28297B72657475726E20746869732E5F73616E654465736372697074696F6E7D7365742073616E654465736372697074696F6E2865297B746869732E5F73616E654465';
wwv_flow_imp.g_varchar2_table(33015) := '736372697074696F6E3D657D6765742073616E6544657461696C28297B72657475726E20746869732E5F73616E6544657461696C7D7365742073616E6544657461696C2865297B746869732E5F73616E6544657461696C3D657D6765742073616E65546F';
wwv_flow_imp.g_varchar2_table(33016) := '6F6C74697028297B72657475726E20746869732E5F73616E65546F6F6C7469707D7365742073616E65546F6F6C7469702865297B746869732E5F73616E65546F6F6C7469703D657D676574206C6162656C486967686C696768747328297B72657475726E';
wwv_flow_imp.g_varchar2_table(33017) := '20746869732E5F6C6162656C486967686C69676874737D736574206C6162656C486967686C69676874732865297B746869732E5F6C6162656C486967686C69676874733D657D676574206465736372697074696F6E486967686C696768747328297B7265';
wwv_flow_imp.g_varchar2_table(33018) := '7475726E20746869732E5F6465736372697074696F6E486967686C69676874737D736574206465736372697074696F6E486967686C69676874732865297B746869732E5F6465736372697074696F6E486967686C69676874733D657D6765742064657461';
wwv_flow_imp.g_varchar2_table(33019) := '696C486967686C696768747328297B72657475726E20746869732E5F64657461696C486967686C69676874737D7365742064657461696C486967686C69676874732865297B746869732E5F64657461696C486967686C69676874733D657D7D636C617373';
wwv_flow_imp.g_varchar2_table(33020) := '20476F6520657874656E6473204B6F657B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B76617220722C612C6C3B737570657228652C742C6F292C746869732E66697265427574746F6E5472696767657265643D6E2C746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(33021) := '436865636B65643D692C746869732E6974656D3D6F2C746869732E5F736570617261746F723D732C746869732E5F636865636B65643D21312C746869732E6F6E436865636B65643D743F76742E6D61702876742E66696C74657228746869732E5F6F6E43';
wwv_flow_imp.g_varchar2_table(33022) := '6865636B65642E6576656E742C28653D3E652E656C656D656E743D3D3D7468697329292C28653D3E652E636865636B656429293A76742E4E6F6E652C746869732E5F73616E6544657461696C3D6F2E64657461696C2C746869732E5F6C6162656C486967';
wwv_flow_imp.g_varchar2_table(33023) := '686C69676874733D6E756C6C3D3D3D28723D6F2E686967686C6967687473297C7C766F696420303D3D3D723F766F696420303A722E6C6162656C2C746869732E5F6465736372697074696F6E486967686C69676874733D6E756C6C3D3D3D28613D6F2E68';
wwv_flow_imp.g_varchar2_table(33024) := '6967686C6967687473297C7C766F696420303D3D3D613F766F696420303A612E6465736372697074696F6E2C746869732E5F64657461696C486967686C69676874733D6E756C6C3D3D3D286C3D6F2E686967686C6967687473297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(33025) := '3D6C3F766F696420303A6C2E64657461696C7D67657420736570617261746F7228297B72657475726E20746869732E5F736570617261746F727D73657420736570617261746F722865297B746869732E5F736570617261746F723D657D67657420636865';
wwv_flow_imp.g_varchar2_table(33026) := '636B656428297B72657475726E20746869732E5F636865636B65647D73657420636865636B65642865297B65213D3D746869732E5F636865636B6564262628746869732E5F636865636B65643D652C746869732E5F6F6E436865636B65642E6669726528';
wwv_flow_imp.g_varchar2_table(33027) := '7B656C656D656E743A746869732C636865636B65643A657D29297D67657420636865636B626F7844697361626C656428297B72657475726E2121746869732E6974656D2E64697361626C65647D7D2166756E6374696F6E2865297B655B652E4E4F4E453D';
wwv_flow_imp.g_varchar2_table(33028) := '305D3D224E4F4E45222C655B652E4D4F5553455F484F5645523D315D3D224D4F5553455F484F564552222C655B652E4143544956455F4954454D3D325D3D224143544956455F4954454D227D28556F657C7C28556F653D7B7D29293B636C61737320516F';
wwv_flow_imp.g_varchar2_table(33029) := '6520657874656E6473204B6F657B636F6E7374727563746F7228652C742C6E297B737570657228652C21312C6E292C746869732E66697265536570617261746F72427574746F6E5472696767657265643D742C746869732E736570617261746F723D6E2C';
wwv_flow_imp.g_varchar2_table(33030) := '746869732E6368696C6472656E3D6E65772041727261792C746869732E666F637573496E73696465536570617261746F723D556F652E4E4F4E457D7D636C61737320596F657B6765744865696768742865297B72657475726E206520696E7374616E6365';
wwv_flow_imp.g_varchar2_table(33031) := '6F6620516F653F33303A652E73616E6544657461696C3F34343A32327D67657454656D706C61746549642865297B72657475726E206520696E7374616E63656F6620476F653F4A6F652E49443A6573652E49447D7D636C617373205A6F657B6765745769';
wwv_flow_imp.g_varchar2_table(33032) := '64676574417269614C6162656C28297B72657475726E206228302C22517569636B20496E70757422297D676574417269614C6162656C2865297B76617220743B72657475726E286E756C6C3D3D3D28743D652E736570617261746F72297C7C766F696420';
wwv_flow_imp.g_varchar2_table(33033) := '303D3D3D743F766F696420303A742E6C6162656C293F60247B652E73616E65417269614C6162656C7D2C20247B652E736570617261746F722E6C6162656C7D603A652E73616E65417269614C6162656C7D676574576964676574526F6C6528297B726574';
wwv_flow_imp.g_varchar2_table(33034) := '75726E226C697374626F78227D676574526F6C652865297B72657475726E20652E686173436865636B626F783F22636865636B626F78223A226F7074696F6E227D6973436865636B65642865297B696628652E686173436865636B626F7826266520696E';
wwv_flow_imp.g_varchar2_table(33035) := '7374616E63656F6620476F652972657475726E7B6765742076616C756528297B72657475726E20652E636865636B65647D2C6F6E4469644368616E67653A743D3E652E6F6E436865636B6564282828293D3E74282929297D7D7D636C61737320586F657B';
wwv_flow_imp.g_varchar2_table(33036) := '636F6E7374727563746F722865297B746869732E686F76657244656C65676174653D657D72656E64657254656D706C6174652865297B636F6E737420743D4F626A6563742E637265617465286E756C6C293B742E746F446973706F7365456C656D656E74';
wwv_flow_imp.g_varchar2_table(33037) := '3D6E65772061742C742E746F446973706F736554656D706C6174653D6E65772061742C742E656E7472793D757228652C716F6528222E717569636B2D696E7075742D6C6973742D656E7472792229293B636F6E7374206E3D757228742E656E7472792C71';
wwv_flow_imp.g_varchar2_table(33038) := '6F6528226C6162656C2E717569636B2D696E7075742D6C6973742D6C6162656C2229293B742E746F446973706F736554656D706C6174652E616464287973286E2C61722E434C49434B2C28653D3E7B742E636865636B626F782E6F666673657450617265';
wwv_flow_imp.g_varchar2_table(33039) := '6E747C7C652E70726576656E7444656661756C7428297D2929292C742E636865636B626F783D7572286E2C716F652822696E7075742E717569636B2D696E7075742D6C6973742D636865636B626F782229292C742E636865636B626F782E747970653D22';
wwv_flow_imp.g_varchar2_table(33040) := '636865636B626F78223B636F6E737420693D7572286E2C716F6528222E717569636B2D696E7075742D6C6973742D726F77732229292C6F3D757228692C716F6528222E717569636B2D696E7075742D6C6973742D726F772229292C733D757228692C716F';
wwv_flow_imp.g_varchar2_table(33041) := '6528222E717569636B2D696E7075742D6C6973742D726F772229293B742E6C6162656C3D6E6577207147286F2C7B737570706F7274486967686C69676874733A21302C737570706F72744465736372697074696F6E486967686C69676874733A21302C73';
wwv_flow_imp.g_varchar2_table(33042) := '7570706F727449636F6E733A21302C686F76657244656C65676174653A746869732E686F76657244656C65676174657D292C742E746F446973706F736554656D706C6174652E61646428742E6C6162656C292C742E69636F6E3D707228742E6C6162656C';
wwv_flow_imp.g_varchar2_table(33043) := '2E656C656D656E742C716F6528222E717569636B2D696E7075742D6C6973742D69636F6E2229293B636F6E737420723D7572286F2C716F6528222E717569636B2D696E7075742D6C6973742D656E7472792D6B657962696E64696E672229293B742E6B65';
wwv_flow_imp.g_varchar2_table(33044) := '7962696E64696E673D6E657720774D28722C7465292C742E746F446973706F736554656D706C6174652E61646428742E6B657962696E64696E67293B636F6E737420613D757228732C716F6528222E717569636B2D696E7075742D6C6973742D6C616265';
wwv_flow_imp.g_varchar2_table(33045) := '6C2D6D6574612229293B72657475726E20742E64657461696C3D6E657720714728612C7B737570706F7274486967686C69676874733A21302C737570706F727449636F6E733A21302C686F76657244656C65676174653A746869732E686F76657244656C';
wwv_flow_imp.g_varchar2_table(33046) := '65676174657D292C742E746F446973706F736554656D706C6174652E61646428742E64657461696C292C742E736570617261746F723D757228742E656E7472792C716F6528222E717569636B2D696E7075742D6C6973742D736570617261746F72222929';
wwv_flow_imp.g_varchar2_table(33047) := '2C742E616374696F6E4261723D6E6577206C4D28742E656E7472792C746869732E686F76657244656C65676174653F7B686F76657244656C65676174653A746869732E686F76657244656C65676174657D3A766F69642030292C742E616374696F6E4261';
wwv_flow_imp.g_varchar2_table(33048) := '722E646F6D4E6F64652E636C6173734C6973742E6164642822717569636B2D696E7075742D6C6973742D656E7472792D616374696F6E2D62617222292C742E746F446973706F736554656D706C6174652E61646428742E616374696F6E426172292C747D';
wwv_flow_imp.g_varchar2_table(33049) := '646973706F736554656D706C6174652865297B652E746F446973706F7365456C656D656E742E646973706F736528292C652E746F446973706F736554656D706C6174652E646973706F736528297D646973706F7365456C656D656E7428652C742C6E297B';
wwv_flow_imp.g_varchar2_table(33050) := '6E2E746F446973706F7365456C656D656E742E636C65617228292C6E2E616374696F6E4261722E636C65617228297D7D6C6574204A6F653D486F653D636C61737320657874656E647320586F657B636F6E7374727563746F7228652C74297B7375706572';
wwv_flow_imp.g_varchar2_table(33051) := '2865292C746869732E7468656D65536572766963653D742C746869732E5F6974656D7357697468536570617261746F72734672657175656E63793D6E6577204D61707D6765742074656D706C617465496428297B72657475726E20486F652E49447D7265';
wwv_flow_imp.g_varchar2_table(33052) := '6E64657254656D706C6174652865297B636F6E737420743D73757065722E72656E64657254656D706C6174652865293B72657475726E20742E746F446973706F736554656D706C6174652E61646428797328742E636865636B626F782C61722E4348414E';
wwv_flow_imp.g_varchar2_table(33053) := '47452C28653D3E7B742E656C656D656E742E636865636B65643D742E636865636B626F782E636865636B65647D2929292C747D72656E646572456C656D656E7428652C742C6E297B76617220692C6F2C733B636F6E737420723D652E656C656D656E743B';
wwv_flow_imp.g_varchar2_table(33054) := '6E2E656C656D656E743D722C722E656C656D656E743D6E756C6C213D3D28693D6E2E656E747279292626766F69642030213D3D693F693A766F696420303B636F6E737420613D722E6974656D3B6E2E636865636B626F782E636865636B65643D722E6368';
wwv_flow_imp.g_varchar2_table(33055) := '65636B65642C6E2E746F446973706F7365456C656D656E742E61646428722E6F6E436865636B65642828653D3E6E2E636865636B626F782E636865636B65643D652929292C6E2E636865636B626F782E64697361626C65643D722E636865636B626F7844';
wwv_flow_imp.g_varchar2_table(33056) := '697361626C65643B636F6E73747B6C6162656C486967686C69676874733A6C2C6465736372697074696F6E486967686C69676874733A632C64657461696C486967686C69676874733A647D3D723B696628612E69636F6E50617468297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(33057) := '3D4E6228746869732E7468656D65536572766963652E676574436F6C6F725468656D6528292E74797065293F612E69636F6E506174682E6461726B3A6E756C6C213D3D286F3D612E69636F6E506174682E6C69676874292626766F69642030213D3D6F3F';
wwv_flow_imp.g_varchar2_table(33058) := '6F3A612E69636F6E506174682E6461726B2C743D4E6F2E7265766976652865293B6E2E69636F6E2E636C6173734E616D653D22717569636B2D696E7075742D6C6973742D69636F6E222C6E2E69636F6E2E7374796C652E6261636B67726F756E64496D61';
wwv_flow_imp.g_varchar2_table(33059) := '67653D53722874297D656C7365206E2E69636F6E2E7374796C652E6261636B67726F756E64496D6167653D22222C6E2E69636F6E2E636C6173734E616D653D612E69636F6E436C6173733F60717569636B2D696E7075742D6C6973742D69636F6E20247B';
wwv_flow_imp.g_varchar2_table(33060) := '612E69636F6E436C6173737D603A22223B6C657420683B21722E73616E65546F6F6C7469702626722E73616E654465736372697074696F6E262628683D7B6D61726B646F776E3A7B76616C75653A722E73616E654465736372697074696F6E2C73757070';
wwv_flow_imp.g_varchar2_table(33061) := '6F72745468656D6549636F6E733A21307D2C6D61726B646F776E4E6F74537570706F7274656446616C6C6261636B3A722E73616E654465736372697074696F6E7D293B636F6E737420753D7B6D6174636865733A6C7C7C5B5D2C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(33062) := '6E5469746C653A682C6465736372697074696F6E4D6174636865733A637C7C5B5D2C6C6162656C4573636170654E65774C696E65733A21307D3B696628752E6578747261436C61737365733D612E69636F6E436C61737365732C752E6974616C69633D61';
wwv_flow_imp.g_varchar2_table(33063) := '2E6974616C69632C752E737472696B657468726F7567683D612E737472696B657468726F7567682C6E2E656E7472792E636C6173734C6973742E72656D6F76652822717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D';
wwv_flow_imp.g_varchar2_table(33064) := '22292C6E2E6C6162656C2E7365744C6162656C28722E73616E654C6162656C2C722E73616E654465736372697074696F6E2C75292C6E2E6B657962696E64696E672E73657428612E6B657962696E64696E67292C722E73616E6544657461696C297B6C65';
wwv_flow_imp.g_varchar2_table(33065) := '7420653B722E73616E65546F6F6C7469707C7C28653D7B6D61726B646F776E3A7B76616C75653A722E73616E6544657461696C2C737570706F72745468656D6549636F6E733A21307D2C6D61726B646F776E4E6F74537570706F7274656446616C6C6261';
wwv_flow_imp.g_varchar2_table(33066) := '636B3A722E73616E6544657461696C7D292C6E2E64657461696C2E656C656D656E742E7374796C652E646973706C61793D22222C6E2E64657461696C2E7365744C6162656C28722E73616E6544657461696C2C766F696420302C7B6D6174636865733A64';
wwv_flow_imp.g_varchar2_table(33067) := '2C7469746C653A652C6C6162656C4573636170654E65774C696E65733A21307D297D656C7365206E2E64657461696C2E656C656D656E742E7374796C652E646973706C61793D226E6F6E65223B286E756C6C3D3D3D28733D722E736570617261746F7229';
wwv_flow_imp.g_varchar2_table(33068) := '7C7C766F696420303D3D3D733F766F696420303A732E6C6162656C293F286E2E736570617261746F722E74657874436F6E74656E743D722E736570617261746F722E6C6162656C2C6E2E736570617261746F722E7374796C652E646973706C61793D2222';
wwv_flow_imp.g_varchar2_table(33069) := '2C746869732E6164644974656D57697468536570617261746F72287229293A6E2E736570617261746F722E7374796C652E646973706C61793D226E6F6E65222C6E2E656E7472792E636C6173734C6973742E746F67676C652822717569636B2D696E7075';
wwv_flow_imp.g_varchar2_table(33070) := '742D6C6973742D736570617261746F722D626F72646572222C2121722E736570617261746F72293B636F6E737420703D612E627574746F6E733B702626702E6C656E6774683F286E2E616374696F6E4261722E7075736828702E6D6170282828652C7429';
wwv_flow_imp.g_varchar2_table(33071) := '3D3E566F6528652C6069642D247B747D602C2828293D3E722E66697265427574746F6E547269676765726564287B627574746F6E3A652C6974656D3A722E6974656D7D29292929292C7B69636F6E3A21302C6C6162656C3A21317D292C6E2E656E747279';
wwv_flow_imp.g_varchar2_table(33072) := '2E636C6173734C6973742E61646428226861732D616374696F6E732229293A6E2E656E7472792E636C6173734C6973742E72656D6F766528226861732D616374696F6E7322297D646973706F7365456C656D656E7428652C742C6E297B746869732E7265';
wwv_flow_imp.g_varchar2_table(33073) := '6D6F76654974656D57697468536570617261746F7228652E656C656D656E74292C73757065722E646973706F7365456C656D656E7428652C742C6E297D69734974656D57697468536570617261746F7256697369626C652865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(33074) := '69732E5F6974656D7357697468536570617261746F72734672657175656E63792E6861732865297D6164644974656D57697468536570617261746F722865297B746869732E5F6974656D7357697468536570617261746F72734672657175656E63792E73';
wwv_flow_imp.g_varchar2_table(33075) := '657428652C28746869732E5F6974656D7357697468536570617261746F72734672657175656E63792E6765742865297C7C30292B31297D72656D6F76654974656D57697468536570617261746F722865297B636F6E737420743D746869732E5F6974656D';
wwv_flow_imp.g_varchar2_table(33076) := '7357697468536570617261746F72734672657175656E63792E6765742865297C7C303B743E313F746869732E5F6974656D7357697468536570617261746F72734672657175656E63792E73657428652C742D31293A746869732E5F6974656D7357697468';
wwv_flow_imp.g_varchar2_table(33077) := '536570617261746F72734672657175656E63792E64656C6574652865297D7D3B4A6F652E49443D22717569636B7069636B6974656D222C4A6F653D486F653D576F65285B6A6F6528312C5062295D2C4A6F65293B636C6173732065736520657874656E64';
wwv_flow_imp.g_varchar2_table(33078) := '7320586F657B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F76697369626C65536570617261746F72734672657175656E63793D6E6577204D61707D6765742074656D706C617465496428297B7265';
wwv_flow_imp.g_varchar2_table(33079) := '7475726E206573652E49447D6765742076697369626C65536570617261746F727328297B72657475726E5B2E2E2E746869732E5F76697369626C65536570617261746F72734672657175656E63792E6B65797328295D7D6973536570617261746F725669';
wwv_flow_imp.g_varchar2_table(33080) := '7369626C652865297B72657475726E20746869732E5F76697369626C65536570617261746F72734672657175656E63792E6861732865297D72656E646572456C656D656E7428652C742C6E297B76617220693B636F6E7374206F3D652E656C656D656E74';
wwv_flow_imp.g_varchar2_table(33081) := '3B6E2E656C656D656E743D6F2C6F2E656C656D656E743D6E756C6C213D3D28693D6E2E656E747279292626766F69642030213D3D693F693A766F696420302C6F2E656C656D656E742E636C6173734C6973742E746F67676C652822666F6375732D696E73';
wwv_flow_imp.g_varchar2_table(33082) := '696465222C21216F2E666F637573496E73696465536570617261746F72293B636F6E737420733D6F2E736570617261746F722C7B6C6162656C486967686C69676874733A722C6465736372697074696F6E486967686C69676874733A612C64657461696C';
wwv_flow_imp.g_varchar2_table(33083) := '486967686C69676874733A6C7D3D6F3B6C657420633B6E2E69636F6E2E7374796C652E6261636B67726F756E64496D6167653D22222C6E2E69636F6E2E636C6173734E616D653D22222C216F2E73616E65546F6F6C74697026266F2E73616E6544657363';
wwv_flow_imp.g_varchar2_table(33084) := '72697074696F6E262628633D7B6D61726B646F776E3A7B76616C75653A6F2E73616E654465736372697074696F6E2C737570706F72745468656D6549636F6E733A21307D2C6D61726B646F776E4E6F74537570706F7274656446616C6C6261636B3A6F2E';
wwv_flow_imp.g_varchar2_table(33085) := '73616E654465736372697074696F6E7D293B636F6E737420643D7B6D6174636865733A727C7C5B5D2C6465736372697074696F6E5469746C653A632C6465736372697074696F6E4D6174636865733A617C7C5B5D2C6C6162656C4573636170654E65774C';
wwv_flow_imp.g_varchar2_table(33086) := '696E65733A21307D3B6966286E2E656E7472792E636C6173734C6973742E6164642822717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D22292C6E2E6C6162656C2E7365744C6162656C286F2E73616E654C6162656C';
wwv_flow_imp.g_varchar2_table(33087) := '2C6F2E73616E654465736372697074696F6E2C64292C6F2E73616E6544657461696C297B6C657420653B6F2E73616E65546F6F6C7469707C7C28653D7B6D61726B646F776E3A7B76616C75653A6F2E73616E6544657461696C2C737570706F7274546865';
wwv_flow_imp.g_varchar2_table(33088) := '6D6549636F6E733A21307D2C6D61726B646F776E4E6F74537570706F7274656446616C6C6261636B3A6F2E73616E6544657461696C7D292C6E2E64657461696C2E656C656D656E742E7374796C652E646973706C61793D22222C6E2E64657461696C2E73';
wwv_flow_imp.g_varchar2_table(33089) := '65744C6162656C286F2E73616E6544657461696C2C766F696420302C7B6D6174636865733A6C2C7469746C653A652C6C6162656C4573636170654E65774C696E65733A21307D297D656C7365206E2E64657461696C2E656C656D656E742E7374796C652E';
wwv_flow_imp.g_varchar2_table(33090) := '646973706C61793D226E6F6E65223B6E2E736570617261746F722E7374796C652E646973706C61793D226E6F6E65222C6E2E656E7472792E636C6173734C6973742E6164642822717569636B2D696E7075742D6C6973742D736570617261746F722D626F';
wwv_flow_imp.g_varchar2_table(33091) := '7264657222293B636F6E737420683D732E627574746F6E733B682626682E6C656E6774683F286E2E616374696F6E4261722E7075736828682E6D6170282828652C74293D3E566F6528652C6069642D247B747D602C2828293D3E6F2E6669726553657061';
wwv_flow_imp.g_varchar2_table(33092) := '7261746F72427574746F6E547269676765726564287B627574746F6E3A652C736570617261746F723A6F2E736570617261746F727D29292929292C7B69636F6E3A21302C6C6162656C3A21317D292C6E2E656E7472792E636C6173734C6973742E616464';
wwv_flow_imp.g_varchar2_table(33093) := '28226861732D616374696F6E732229293A6E2E656E7472792E636C6173734C6973742E72656D6F766528226861732D616374696F6E7322292C746869732E616464536570617261746F72286F297D646973706F7365456C656D656E7428652C742C6E297B';
wwv_flow_imp.g_varchar2_table(33094) := '76617220693B746869732E72656D6F7665536570617261746F7228652E656C656D656E74292C746869732E6973536570617261746F7256697369626C6528652E656C656D656E74297C7C6E756C6C3D3D3D28693D652E656C656D656E742E656C656D656E';
wwv_flow_imp.g_varchar2_table(33095) := '74297C7C766F696420303D3D3D697C7C692E636C6173734C6973742E72656D6F76652822666F6375732D696E7369646522292C73757065722E646973706F7365456C656D656E7428652C742C6E297D616464536570617261746F722865297B746869732E';
wwv_flow_imp.g_varchar2_table(33096) := '5F76697369626C65536570617261746F72734672657175656E63792E73657428652C28746869732E5F76697369626C65536570617261746F72734672657175656E63792E6765742865297C7C30292B31297D72656D6F7665536570617261746F72286529';
wwv_flow_imp.g_varchar2_table(33097) := '7B636F6E737420743D746869732E5F76697369626C65536570617261746F72734672657175656E63792E6765742865297C7C303B743E313F746869732E5F76697369626C65536570617261746F72734672657175656E63792E73657428652C742D31293A';
wwv_flow_imp.g_varchar2_table(33098) := '746869732E5F76697369626C65536570617261746F72734672657175656E63792E64656C6574652865297D7D6573652E49443D22717569636B7069636B736570617261746F72223B6C6574207473653D636C61737320657874656E6473206C747B636F6E';
wwv_flow_imp.g_varchar2_table(33099) := '7374727563746F7228652C742C6E2C692C6F297B737570657228292C746869732E706172656E743D652C746869732E686F76657244656C65676174653D742C746869732E6C696E6B4F70656E657244656C65676174653D6E2C746869732E5F6F6E4B6579';
wwv_flow_imp.g_varchar2_table(33100) := '446F776E3D6E65772043742C746869732E6F6E4B6579446F776E3D746869732E5F6F6E4B6579446F776E2E6576656E742C746869732E5F6F6E4C656176653D6E65772043742C746869732E6F6E4C656176653D746869732E5F6F6E4C656176652E657665';
wwv_flow_imp.g_varchar2_table(33101) := '6E742C746869732E5F6F6E4368616E676564416C6C56697369626C65436865636B65643D6E65772043742C746869732E6F6E4368616E676564416C6C56697369626C65436865636B65643D746869732E5F6F6E4368616E676564416C6C56697369626C65';
wwv_flow_imp.g_varchar2_table(33102) := '436865636B65642E6576656E742C746869732E5F6F6E4368616E676564436865636B6564436F756E743D6E65772043742C746869732E6F6E4368616E676564436865636B6564436F756E743D746869732E5F6F6E4368616E676564436865636B6564436F';
wwv_flow_imp.g_varchar2_table(33103) := '756E742E6576656E742C746869732E5F6F6E4368616E67656456697369626C65436F756E743D6E65772043742C746869732E6F6E4368616E67656456697369626C65436F756E743D746869732E5F6F6E4368616E67656456697369626C65436F756E742E';
wwv_flow_imp.g_varchar2_table(33104) := '6576656E742C746869732E5F6F6E4368616E676564436865636B6564456C656D656E74733D6E65772043742C746869732E6F6E4368616E676564436865636B6564456C656D656E74733D746869732E5F6F6E4368616E676564436865636B6564456C656D';
wwv_flow_imp.g_varchar2_table(33105) := '656E74732E6576656E742C746869732E5F6F6E427574746F6E5472696767657265643D6E65772043742C746869732E6F6E427574746F6E5472696767657265643D746869732E5F6F6E427574746F6E5472696767657265642E6576656E742C746869732E';
wwv_flow_imp.g_varchar2_table(33106) := '5F6F6E536570617261746F72427574746F6E5472696767657265643D6E65772043742C746869732E6F6E536570617261746F72427574746F6E5472696767657265643D746869732E5F6F6E536570617261746F72427574746F6E5472696767657265642E';
wwv_flow_imp.g_varchar2_table(33107) := '6576656E742C746869732E5F6F6E54726967676572456D70747953656C656374696F6E4F72466F6375733D6E65772043742C746869732E5F656C656D656E74436865636B65643D6E65772043742C746869732E5F696E707574456C656D656E74733D6E65';
wwv_flow_imp.g_varchar2_table(33108) := '772041727261792C746869732E5F656C656D656E74547265653D6E65772041727261792C746869732E5F6974656D456C656D656E74733D6E65772041727261792C746869732E5F656C656D656E74446973706F7361626C653D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(33109) := '746572286E6577206174292C746869732E5F73686F756C6446697265436865636B65644576656E74733D21302C746869732E5F6D617463684F6E4465736372697074696F6E3D21312C746869732E5F6D617463684F6E44657461696C3D21312C74686973';
wwv_flow_imp.g_varchar2_table(33110) := '2E5F6D617463684F6E4C6162656C3D21302C746869732E5F6D617463684F6E4C6162656C4D6F64653D2266757A7A79222C746869732E5F736F727442794C6162656C3D21302C746869732E5F636F6E7461696E65723D757228746869732E706172656E74';
wwv_flow_imp.g_varchar2_table(33111) := '2C716F6528222E717569636B2D696E7075742D6C6973742229292C746869732E5F736570617261746F7252656E64657265723D6E6577206573652874292C746869732E5F6974656D52656E64657265723D6F2E637265617465496E7374616E6365284A6F';
wwv_flow_imp.g_varchar2_table(33112) := '652C74292C746869732E5F747265653D746869732E5F7265676973746572286F2E637265617465496E7374616E63652843472C22517569636B496E707574222C746869732E5F636F6E7461696E65722C6E657720596F652C5B746869732E5F6974656D52';
wwv_flow_imp.g_varchar2_table(33113) := '656E64657265722C746869732E5F736570617261746F7252656E64657265725D2C7B6163636573736962696C69747950726F76696465723A6E6577205A6F652C736574526F774C696E654865696768743A21312C6D756C7469706C6553656C656374696F';
wwv_flow_imp.g_varchar2_table(33114) := '6E537570706F72743A21312C6869646554776973746965734F664368696C646C657373456C656D656E74733A21302C72656E646572496E64656E744775696465733A62552E4E6F6E652C66696E64576964676574456E61626C65643A21312C696E64656E';
wwv_flow_imp.g_varchar2_table(33115) := '743A302C686F72697A6F6E74616C5363726F6C6C696E673A21312C616C6C6F774E6F6E436F6C6C61707369626C65506172656E74733A21302C6964656E7469747950726F76696465723A7B67657449643A653D3E7B636F6E737420743D652E6974656D7C';
wwv_flow_imp.g_varchar2_table(33116) := '7C652E736570617261746F723B696628766F696420303D3D3D742972657475726E22223B696628766F69642030213D3D742E69642972657475726E20742E69643B6C6574206E3D606C6162656C3A247B742E6C6162656C7D603B72657475726E206E2B3D';
wwv_flow_imp.g_varchar2_table(33117) := '6024246465736372697074696F6E3A247B742E6465736372697074696F6E7D602C22736570617261746F7222213D3D742E747970652626286E2B3D60242464657461696C3A247B742E64657461696C7D60292C6E7D7D2C616C77617973436F6E73756D65';
wwv_flow_imp.g_varchar2_table(33118) := '4D6F757365576865656C3A21307D29292C746869732E5F747265652E67657448544D4C456C656D656E7428292E69643D692C746869732E5F72656769737465724C697374656E65727328297D676574206F6E4469644368616E6765466F63757328297B72';
wwv_flow_imp.g_varchar2_table(33119) := '657475726E2076742E6D61702876742E616E7928746869732E5F747265652E6F6E4469644368616E6765466F6375732C746869732E5F6F6E54726967676572456D70747953656C656374696F6E4F72466F6375732E6576656E74292C28653D3E652E656C';
wwv_flow_imp.g_varchar2_table(33120) := '656D656E74732E66696C7465722828653D3E6520696E7374616E63656F6620476F6529292E6D61702828653D3E652E6974656D292929297D676574206F6E4469644368616E676553656C656374696F6E28297B72657475726E2076742E6D61702876742E';
wwv_flow_imp.g_varchar2_table(33121) := '616E7928746869732E5F747265652E6F6E4469644368616E676553656C656374696F6E2C746869732E5F6F6E54726967676572456D70747953656C656374696F6E4F72466F6375732E6576656E74292C28653D3E287B6974656D733A652E656C656D656E';
wwv_flow_imp.g_varchar2_table(33122) := '74732E66696C7465722828653D3E6520696E7374616E63656F6620476F6529292E6D61702828653D3E652E6974656D29292C6576656E743A652E62726F777365724576656E747D2929297D676574207363726F6C6C546F7028297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(33123) := '69732E5F747265652E7363726F6C6C546F707D736574207363726F6C6C546F702865297B746869732E5F747265652E7363726F6C6C546F703D657D67657420617269614C6162656C28297B72657475726E20746869732E5F747265652E617269614C6162';
wwv_flow_imp.g_varchar2_table(33124) := '656C7D73657420617269614C6162656C2865297B746869732E5F747265652E617269614C6162656C3D6E756C6C213D653F653A22227D73657420656E61626C65642865297B746869732E5F747265652E67657448544D4C456C656D656E7428292E737479';
wwv_flow_imp.g_varchar2_table(33125) := '6C652E706F696E7465724576656E74733D653F22223A226E6F6E65227D676574206D617463684F6E4465736372697074696F6E28297B72657475726E20746869732E5F6D617463684F6E4465736372697074696F6E7D736574206D617463684F6E446573';
wwv_flow_imp.g_varchar2_table(33126) := '6372697074696F6E2865297B746869732E5F6D617463684F6E4465736372697074696F6E3D657D676574206D617463684F6E44657461696C28297B72657475726E20746869732E5F6D617463684F6E44657461696C7D736574206D617463684F6E446574';
wwv_flow_imp.g_varchar2_table(33127) := '61696C2865297B746869732E5F6D617463684F6E44657461696C3D657D676574206D617463684F6E4C6162656C28297B72657475726E20746869732E5F6D617463684F6E4C6162656C7D736574206D617463684F6E4C6162656C2865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(33128) := '6D617463684F6E4C6162656C3D657D676574206D617463684F6E4C6162656C4D6F646528297B72657475726E20746869732E5F6D617463684F6E4C6162656C4D6F64657D736574206D617463684F6E4C6162656C4D6F64652865297B746869732E5F6D61';
wwv_flow_imp.g_varchar2_table(33129) := '7463684F6E4C6162656C4D6F64653D657D67657420736F727442794C6162656C28297B72657475726E20746869732E5F736F727442794C6162656C7D73657420736F727442794C6162656C2865297B746869732E5F736F727442794C6162656C3D657D5F';
wwv_flow_imp.g_varchar2_table(33130) := '72656769737465724C697374656E65727328297B746869732E5F72656769737465724F6E4B6579446F776E28292C746869732E5F72656769737465724F6E436F6E7461696E6572436C69636B28292C746869732E5F72656769737465724F6E4D6F757365';
wwv_flow_imp.g_varchar2_table(33131) := '4D6964646C65436C69636B28292C746869732E5F72656769737465724F6E456C656D656E74436865636B656428292C746869732E5F72656769737465724F6E436F6E746578744D656E7528292C746869732E5F7265676973746572486F7665724C697374';
wwv_flow_imp.g_varchar2_table(33132) := '656E65727328292C746869732E5F726567697374657253656C656374696F6E4368616E67654C697374656E657228292C746869732E5F7265676973746572536570617261746F72416374696F6E53686F77696E674C697374656E65727328297D5F726567';
wwv_flow_imp.g_varchar2_table(33133) := '69737465724F6E4B6579446F776E28297B746869732E5F726567697374657228746869732E5F747265652E6F6E4B6579446F776E2828653D3E7B636F6E737420743D6E65772071652865293B73776974636828742E6B6579436F6465297B636173652031';
wwv_flow_imp.g_varchar2_table(33134) := '303A746869732E746F67676C65436865636B626F7828293B627265616B3B636173652033313A28713F652E6D6574614B65793A652E6374726C4B6579292626746869732E5F747265652E736574466F63757328746869732E5F6974656D456C656D656E74';
wwv_flow_imp.g_varchar2_table(33135) := '73293B627265616B3B636173652031363A7B636F6E737420653D746869732E5F747265652E676574466F63757328293B313D3D3D652E6C656E6774682626655B305D3D3D3D746869732E5F6974656D456C656D656E74735B305D2626746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(33136) := '4C656176652E6669726528293B627265616B7D636173652031383A7B636F6E737420653D746869732E5F747265652E676574466F63757328293B313D3D3D652E6C656E6774682626655B305D3D3D3D746869732E5F6974656D456C656D656E74735B7468';
wwv_flow_imp.g_varchar2_table(33137) := '69732E5F6974656D456C656D656E74732E6C656E6774682D315D2626746869732E5F6F6E4C656176652E6669726528293B627265616B7D7D746869732E5F6F6E4B6579446F776E2E666972652874297D2929297D5F72656769737465724F6E436F6E7461';
wwv_flow_imp.g_varchar2_table(33138) := '696E6572436C69636B28297B746869732E5F726567697374657228627328746869732E5F636F6E7461696E65722C61722E434C49434B2C28653D3E7B28652E787C7C652E79292626746869732E5F6F6E4C656176652E6669726528297D2929297D5F7265';
wwv_flow_imp.g_varchar2_table(33139) := '6769737465724F6E4D6F7573654D6964646C65436C69636B28297B746869732E5F726567697374657228627328746869732E5F636F6E7461696E65722C61722E415558434C49434B2C28653D3E7B313D3D3D652E627574746F6E2626746869732E5F6F6E';
wwv_flow_imp.g_varchar2_table(33140) := '4C656176652E6669726528297D2929297D5F72656769737465724F6E456C656D656E74436865636B656428297B746869732E5F726567697374657228746869732E5F656C656D656E74436865636B65642E6576656E742828653D3E746869732E5F666972';
wwv_flow_imp.g_varchar2_table(33141) := '65436865636B65644576656E747328292929297D5F72656769737465724F6E436F6E746578744D656E7528297B746869732E5F726567697374657228746869732E5F747265652E6F6E436F6E746578744D656E752828653D3E7B652E656C656D656E7426';
wwv_flow_imp.g_varchar2_table(33142) := '2628652E62726F777365724576656E742E70726576656E7444656661756C7428292C746869732E5F747265652E73657453656C656374696F6E285B652E656C656D656E745D29297D2929297D5F7265676973746572486F7665724C697374656E65727328';
wwv_flow_imp.g_varchar2_table(33143) := '297B636F6E737420653D746869732E5F7265676973746572286E657720487428746869732E686F76657244656C65676174652E64656C617929293B746869732E5F726567697374657228746869732E5F747265652E6F6E4D6F7573654F76657228286173';
wwv_flow_imp.g_varchar2_table(33144) := '796E6320743D3E7B766172206E3B696628742E62726F777365724576656E742E74617267657420696E7374616E63656F662048544D4C416E63686F72456C656D656E7429652E63616E63656C28293B656C736520696628742E62726F777365724576656E';
wwv_flow_imp.g_varchar2_table(33145) := '742E72656C6174656454617267657420696E7374616E63656F662048544D4C416E63686F72456C656D656E747C7C21427328742E62726F777365724576656E742E72656C617465645461726765742C6E756C6C3D3D3D286E3D742E656C656D656E74297C';
wwv_flow_imp.g_varchar2_table(33146) := '7C766F696420303D3D3D6E3F766F696420303A6E2E656C656D656E7429297472797B617761697420652E7472696767657228286173796E6328293D3E7B742E656C656D656E7420696E7374616E63656F6620476F652626746869732E73686F77486F7665';
wwv_flow_imp.g_varchar2_table(33147) := '7228742E656C656D656E74297D29297D63617463682874297B696628215465287429297468726F7720747D7D2929292C746869732E5F726567697374657228746869732E5F747265652E6F6E4D6F7573654F75742828743D3E7B766172206E3B42732874';
wwv_flow_imp.g_varchar2_table(33148) := '2E62726F777365724576656E742E72656C617465645461726765742C6E756C6C3D3D3D286E3D742E656C656D656E74297C7C766F696420303D3D3D6E3F766F696420303A6E2E656C656D656E74297C7C652E63616E63656C28297D2929297D5F72656769';
wwv_flow_imp.g_varchar2_table(33149) := '73746572536570617261746F72416374696F6E53686F77696E674C697374656E65727328297B746869732E5F726567697374657228746869732E5F747265652E6F6E4469644368616E6765466F6375732828653D3E7B636F6E737420743D652E656C656D';
wwv_flow_imp.g_varchar2_table(33150) := '656E74735B305D3F746869732E5F747265652E676574506172656E74456C656D656E7428652E656C656D656E74735B305D293A6E756C6C3B666F7228636F6E73742065206F6620746869732E5F736570617261746F7252656E64657265722E7669736962';
wwv_flow_imp.g_varchar2_table(33151) := '6C65536570617261746F7273297B636F6E7374206E3D653D3D3D743B212128652E666F637573496E73696465536570617261746F7226556F652E4143544956455F4954454D29213D3D6E2626286E3F652E666F637573496E73696465536570617261746F';
wwv_flow_imp.g_varchar2_table(33152) := '727C3D556F652E4143544956455F4954454D3A652E666F637573496E73696465536570617261746F72263D7E556F652E4143544956455F4954454D2C746869732E5F747265652E726572656E646572286529297D7D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(33153) := '74657228746869732E5F747265652E6F6E4D6F7573654F7665722828653D3E7B636F6E737420743D652E656C656D656E743F746869732E5F747265652E676574506172656E74456C656D656E7428652E656C656D656E74293A6E756C6C3B666F7228636F';
wwv_flow_imp.g_varchar2_table(33154) := '6E73742065206F6620746869732E5F736570617261746F7252656E64657265722E76697369626C65536570617261746F727329653D3D3D74262628652E666F637573496E73696465536570617261746F7226556F652E4D4F5553455F484F5645527C7C28';
wwv_flow_imp.g_varchar2_table(33155) := '652E666F637573496E73696465536570617261746F727C3D556F652E4D4F5553455F484F5645522C746869732E5F747265652E726572656E64657228652929297D2929292C746869732E5F726567697374657228746869732E5F747265652E6F6E4D6F75';
wwv_flow_imp.g_varchar2_table(33156) := '73654F75742828653D3E7B636F6E737420743D652E656C656D656E743F746869732E5F747265652E676574506172656E74456C656D656E7428652E656C656D656E74293A6E756C6C3B666F7228636F6E73742065206F6620746869732E5F736570617261';
wwv_flow_imp.g_varchar2_table(33157) := '746F7252656E64657265722E76697369626C65536570617261746F727329653D3D3D742626652E666F637573496E73696465536570617261746F7226556F652E4D4F5553455F484F564552262628652E666F637573496E73696465536570617261746F72';
wwv_flow_imp.g_varchar2_table(33158) := '263D7E556F652E4D4F5553455F484F5645522C746869732E5F747265652E726572656E646572286529297D2929297D5F726567697374657253656C656374696F6E4368616E67654C697374656E657228297B746869732E5F726567697374657228746869';
wwv_flow_imp.g_varchar2_table(33159) := '732E5F747265652E6F6E4469644368616E676553656C656374696F6E2828653D3E7B636F6E737420743D652E656C656D656E74732E66696C7465722828653D3E6520696E7374616E63656F6620476F6529293B742E6C656E677468213D3D652E656C656D';
wwv_flow_imp.g_varchar2_table(33160) := '656E74732E6C656E677468262628313D3D3D652E656C656D656E74732E6C656E6774682626652E656C656D656E74735B305D696E7374616E63656F6620516F65262628746869732E5F747265652E736574466F637573285B652E656C656D656E74735B30';
wwv_flow_imp.g_varchar2_table(33161) := '5D2E6368696C6472656E5B305D5D292C746869732E5F747265652E72657665616C28652E656C656D656E74735B305D2C3029292C746869732E5F747265652E73657453656C656374696F6E287429297D2929297D676574416C6C56697369626C65436865';
wwv_flow_imp.g_varchar2_table(33162) := '636B656428297B72657475726E20746869732E5F616C6C56697369626C65436865636B656428746869732E5F6974656D456C656D656E74732C2131297D676574436865636B6564436F756E7428297B72657475726E20746869732E5F6974656D456C656D';
wwv_flow_imp.g_varchar2_table(33163) := '656E74732E66696C7465722828653D3E652E636865636B656429292E6C656E6774687D67657456697369626C65436F756E7428297B72657475726E20746869732E5F6974656D456C656D656E74732E66696C7465722828653D3E21652E68696464656E29';
wwv_flow_imp.g_varchar2_table(33164) := '292E6C656E6774687D736574416C6C56697369626C65436865636B65642865297B7472797B746869732E5F73686F756C6446697265436865636B65644576656E74733D21312C746869732E5F6974656D456C656D656E74732E666F72456163682828743D';
wwv_flow_imp.g_varchar2_table(33165) := '3E7B742E68696464656E7C7C742E636865636B626F7844697361626C65647C7C28742E636865636B65643D65297D29297D66696E616C6C797B746869732E5F73686F756C6446697265436865636B65644576656E74733D21302C746869732E5F66697265';
wwv_flow_imp.g_varchar2_table(33166) := '436865636B65644576656E747328297D7D736574456C656D656E74732865297B746869732E5F656C656D656E74446973706F7361626C652E636C65617228292C746869732E5F696E707574456C656D656E74733D653B636F6E737420743D746869732E70';
wwv_flow_imp.g_varchar2_table(33167) := '6172656E742E636C6173734C6973742E636F6E7461696E73282273686F772D636865636B626F78657322293B6C6574206E3B746869732E5F6974656D456C656D656E74733D6E65772041727261792C746869732E5F656C656D656E74547265653D652E72';
wwv_flow_imp.g_varchar2_table(33168) := '6564756365282828692C6F2C73293D3E7B6C657420723B69662822736570617261746F72223D3D3D6F2E74797065297B696628216F2E627574746F6E732972657475726E20693B6E3D6E657720516F6528732C28653D3E746869732E6669726553657061';
wwv_flow_imp.g_varchar2_table(33169) := '7261746F72427574746F6E547269676765726564286529292C6F292C723D6E7D656C73657B636F6E737420613D733E303F655B732D315D3A766F696420303B6C6574206C3B61262622736570617261746F72223D3D3D612E74797065262621612E627574';
wwv_flow_imp.g_varchar2_table(33170) := '746F6E732626286E3D766F696420302C6C3D61293B636F6E737420633D6E657720476F6528732C742C28653D3E746869732E66697265427574746F6E547269676765726564286529292C746869732E5F656C656D656E74436865636B65642C6F2C6C293B';
wwv_flow_imp.g_varchar2_table(33171) := '696628746869732E5F6974656D456C656D656E74732E707573682863292C6E2972657475726E206E2E6368696C6472656E2E707573682863292C693B723D637D72657475726E20692E707573682872292C697D292C6E6577204172726179293B636F6E73';
wwv_flow_imp.g_varchar2_table(33172) := '7420693D6E65772041727261793B6C6574206F3D303B666F7228636F6E73742065206F6620746869732E5F656C656D656E7454726565296520696E7374616E63656F6620516F653F28692E70757368287B656C656D656E743A652C636F6C6C6170736962';
wwv_flow_imp.g_varchar2_table(33173) := '6C653A21312C636F6C6C61707365643A21312C6368696C6472656E3A652E6368696C6472656E2E6D61702828653D3E287B656C656D656E743A652C636F6C6C61707369626C653A21312C636F6C6C61707365643A21317D2929297D292C6F2B3D652E6368';
wwv_flow_imp.g_varchar2_table(33174) := '696C6472656E2E6C656E6774682B31293A28692E70757368287B656C656D656E743A652C636F6C6C61707369626C653A21312C636F6C6C61707365643A21317D292C6F2B2B293B746869732E5F747265652E7365744368696C6472656E286E756C6C2C69';
wwv_flow_imp.g_varchar2_table(33175) := '292C746869732E5F6F6E4368616E67656456697369626C65436F756E742E66697265286F297D736574466F6375736564456C656D656E74732865297B636F6E737420743D652E6D61702828653D3E746869732E5F6974656D456C656D656E74732E66696E';
wwv_flow_imp.g_varchar2_table(33176) := '642828743D3E742E6974656D3D3D3D65292929292E66696C7465722828653D3E21216529293B696628746869732E5F747265652E736574466F6375732874292C652E6C656E6774683E30297B636F6E737420653D746869732E5F747265652E676574466F';
wwv_flow_imp.g_varchar2_table(33177) := '63757328295B305D3B652626746869732E5F747265652E72657665616C2865297D7D67657441637469766544657363656E64616E7428297B72657475726E20746869732E5F747265652E67657448544D4C456C656D656E7428292E676574417474726962';
wwv_flow_imp.g_varchar2_table(33178) := '7574652822617269612D61637469766564657363656E64616E7422297D73657453656C6563746564456C656D656E74732865297B636F6E737420743D652E6D61702828653D3E746869732E5F6974656D456C656D656E74732E66696E642828743D3E742E';
wwv_flow_imp.g_varchar2_table(33179) := '6974656D3D3D3D65292929292E66696C7465722828653D3E21216529293B746869732E5F747265652E73657453656C656374696F6E2874297D676574436865636B6564456C656D656E747328297B72657475726E20746869732E5F6974656D456C656D65';
wwv_flow_imp.g_varchar2_table(33180) := '6E74732E66696C7465722828653D3E652E636865636B656429292E6D61702828653D3E652E6974656D29297D736574436865636B6564456C656D656E74732865297B7472797B746869732E5F73686F756C6446697265436865636B65644576656E74733D';
wwv_flow_imp.g_varchar2_table(33181) := '21313B636F6E737420743D6E6577205365743B666F7228636F6E7374206E206F66206529742E616464286E293B666F7228636F6E73742065206F6620746869732E5F6974656D456C656D656E747329652E636865636B65643D742E68617328652E697465';
wwv_flow_imp.g_varchar2_table(33182) := '6D297D66696E616C6C797B746869732E5F73686F756C6446697265436865636B65644576656E74733D21302C746869732E5F66697265436865636B65644576656E747328297D7D666F6375732865297B76617220743B696628746869732E5F6974656D45';
wwv_flow_imp.g_varchar2_table(33183) := '6C656D656E74732E6C656E6774682973776974636828653D3D3D246F652E5365636F6E642626746869732E5F6974656D456C656D656E74732E6C656E6774683C32262628653D246F652E4669727374292C65297B6361736520246F652E46697273743A74';
wwv_flow_imp.g_varchar2_table(33184) := '6869732E5F747265652E7363726F6C6C546F703D302C746869732E5F747265652E666F637573466972737428766F696420302C28653D3E652E656C656D656E7420696E7374616E63656F6620476F6529293B627265616B3B6361736520246F652E536563';
wwv_flow_imp.g_varchar2_table(33185) := '6F6E643A746869732E5F747265652E7363726F6C6C546F703D302C746869732E5F747265652E736574466F637573285B746869732E5F6974656D456C656D656E74735B315D5D293B627265616B3B6361736520246F652E4C6173743A746869732E5F7472';
wwv_flow_imp.g_varchar2_table(33186) := '65652E7363726F6C6C546F703D746869732E5F747265652E7363726F6C6C4865696768742C746869732E5F747265652E736574466F637573285B746869732E5F6974656D456C656D656E74735B746869732E5F6974656D456C656D656E74732E6C656E67';
wwv_flow_imp.g_varchar2_table(33187) := '74682D315D5D293B627265616B3B6361736520246F652E4E6578743A746869732E5F747265652E666F6375734E65787428766F696420302C21302C766F696420302C28653D3E652E656C656D656E7420696E7374616E63656F6620476F65262628746869';
wwv_flow_imp.g_varchar2_table(33188) := '732E5F747265652E72657665616C28652E656C656D656E74292C21302929293B627265616B3B6361736520246F652E50726576696F75733A746869732E5F747265652E666F63757350726576696F757328766F696420302C21302C766F696420302C2865';
wwv_flow_imp.g_varchar2_table(33189) := '3D3E7B6966282128652E656C656D656E7420696E7374616E63656F6620476F65292972657475726E21313B636F6E737420743D746869732E5F747265652E676574506172656E74456C656D656E7428652E656C656D656E74293B72657475726E206E756C';
wwv_flow_imp.g_varchar2_table(33190) := '6C3D3D3D747C7C742E6368696C6472656E5B305D213D3D652E656C656D656E743F746869732E5F747265652E72657665616C28652E656C656D656E74293A746869732E5F747265652E72657665616C2874292C21307D29293B627265616B3B6361736520';
wwv_flow_imp.g_varchar2_table(33191) := '246F652E4E657874506167653A746869732E5F747265652E666F6375734E6578745061676528766F696420302C28653D3E652E656C656D656E7420696E7374616E63656F6620476F65262628746869732E5F747265652E72657665616C28652E656C656D';
wwv_flow_imp.g_varchar2_table(33192) := '656E74292C21302929293B627265616B3B6361736520246F652E50726576696F7573506167653A746869732E5F747265652E666F63757350726576696F75735061676528766F696420302C28653D3E7B6966282128652E656C656D656E7420696E737461';
wwv_flow_imp.g_varchar2_table(33193) := '6E63656F6620476F65292972657475726E21313B636F6E737420743D746869732E5F747265652E676574506172656E74456C656D656E7428652E656C656D656E74293B72657475726E206E756C6C3D3D3D747C7C742E6368696C6472656E5B305D213D3D';
wwv_flow_imp.g_varchar2_table(33194) := '652E656C656D656E743F746869732E5F747265652E72657665616C28652E656C656D656E74293A746869732E5F747265652E72657665616C2874292C21307D29293B627265616B3B6361736520246F652E4E657874536570617261746F723A7B6C657420';
wwv_flow_imp.g_varchar2_table(33195) := '653D21313B636F6E737420743D746869732E5F747265652E676574466F63757328295B305D3B746869732E5F747265652E666F6375734E65787428766F696420302C21302C766F696420302C28743D3E7B696628652972657475726E21303B696628742E';
wwv_flow_imp.g_varchar2_table(33196) := '656C656D656E7420696E7374616E63656F6620516F6529653D21302C746869732E5F736570617261746F7252656E64657265722E6973536570617261746F7256697369626C6528742E656C656D656E74293F746869732E5F747265652E72657665616C28';
wwv_flow_imp.g_varchar2_table(33197) := '742E656C656D656E742E6368696C6472656E5B305D293A746869732E5F747265652E72657665616C28742E656C656D656E742C30293B656C736520696628742E656C656D656E7420696E7374616E63656F6620476F65297B696628742E656C656D656E74';
wwv_flow_imp.g_varchar2_table(33198) := '2E736570617261746F722972657475726E20746869732E5F6974656D52656E64657265722E69734974656D57697468536570617261746F7256697369626C6528742E656C656D656E74293F746869732E5F747265652E72657665616C28742E656C656D65';
wwv_flow_imp.g_varchar2_table(33199) := '6E74293A746869732E5F747265652E72657665616C28742E656C656D656E742C30292C21303B696628742E656C656D656E743D3D3D746869732E5F656C656D656E74547265655B305D2972657475726E20746869732E5F747265652E72657665616C2874';
wwv_flow_imp.g_varchar2_table(33200) := '2E656C656D656E742C30292C21307D72657475726E21317D29292C743D3D3D746869732E5F747265652E676574466F63757328295B305D262628746869732E5F747265652E7363726F6C6C546F703D746869732E5F747265652E7363726F6C6C48656967';
wwv_flow_imp.g_varchar2_table(33201) := '68742C746869732E5F747265652E736574466F637573285B746869732E5F6974656D456C656D656E74735B746869732E5F6974656D456C656D656E74732E6C656E6774682D315D5D29293B627265616B7D6361736520246F652E50726576696F75735365';
wwv_flow_imp.g_varchar2_table(33202) := '70617261746F723A7B6C657420652C6E3D2121286E756C6C3D3D3D28743D746869732E5F747265652E676574466F63757328295B305D297C7C766F696420303D3D3D743F766F696420303A742E736570617261746F72293B746869732E5F747265652E66';
wwv_flow_imp.g_varchar2_table(33203) := '6F63757350726576696F757328766F696420302C21302C766F696420302C28743D3E7B696628742E656C656D656E7420696E7374616E63656F6620516F65296E3F657C7C28746869732E5F736570617261746F7252656E64657265722E69735365706172';
wwv_flow_imp.g_varchar2_table(33204) := '61746F7256697369626C6528742E656C656D656E74293F746869732E5F747265652E72657665616C28742E656C656D656E74293A746869732E5F747265652E72657665616C28742E656C656D656E742C30292C653D742E656C656D656E742E6368696C64';
wwv_flow_imp.g_varchar2_table(33205) := '72656E5B305D293A6E3D21303B656C736520696628742E656C656D656E7420696E7374616E63656F6620476F652626216529696628742E656C656D656E742E736570617261746F7229746869732E5F6974656D52656E64657265722E69734974656D5769';
wwv_flow_imp.g_varchar2_table(33206) := '7468536570617261746F7256697369626C6528742E656C656D656E74293F746869732E5F747265652E72657665616C28742E656C656D656E74293A746869732E5F747265652E72657665616C28742E656C656D656E742C30292C653D742E656C656D656E';
wwv_flow_imp.g_varchar2_table(33207) := '743B656C736520696628742E656C656D656E743D3D3D746869732E5F656C656D656E74547265655B305D2972657475726E20746869732E5F747265652E72657665616C28742E656C656D656E742C30292C21303B72657475726E21317D29292C65262674';
wwv_flow_imp.g_varchar2_table(33208) := '6869732E5F747265652E736574466F637573285B655D293B627265616B7D7D7D636C656172466F63757328297B746869732E5F747265652E736574466F637573285B5D297D646F6D466F63757328297B746869732E5F747265652E646F6D466F63757328';
wwv_flow_imp.g_varchar2_table(33209) := '297D6C61796F75742865297B746869732E5F747265652E67657448544D4C456C656D656E7428292E7374796C652E6D61784865696768743D653F34342A4D6174682E666C6F6F7228652F3434292B362B227078223A22222C746869732E5F747265652E6C';
wwv_flow_imp.g_varchar2_table(33210) := '61796F757428297D66696C7465722865297B6966282128746869732E5F736F727442794C6162656C7C7C746869732E5F6D617463684F6E4C6162656C7C7C746869732E5F6D617463684F6E4465736372697074696F6E7C7C746869732E5F6D617463684F';
wwv_flow_imp.g_varchar2_table(33211) := '6E44657461696C292972657475726E20746869732E5F747265652E6C61796F757428292C21313B636F6E737420743D653B69662828653D652E7472696D282929262628746869732E6D617463684F6E4C6162656C7C7C746869732E6D617463684F6E4465';
wwv_flow_imp.g_varchar2_table(33212) := '736372697074696F6E7C7C746869732E6D617463684F6E44657461696C29297B6C6574206E3B746869732E5F656C656D656E74547265652E666F72456163682828693D3E7B766172206F2C732C722C613B6C6574206C3B6C3D2266757A7A79223D3D3D74';
wwv_flow_imp.g_varchar2_table(33213) := '6869732E6D617463684F6E4C6162656C4D6F64653F746869732E6D617463684F6E4C6162656C26266E756C6C213D3D286F3D466C28652C526C28692E73616E654C6162656C2929292626766F69642030213D3D6F3F6F3A766F696420303A746869732E6D';
wwv_flow_imp.g_varchar2_table(33214) := '617463684F6E4C6162656C26266E756C6C213D3D28733D66756E6374696F6E28652C74297B636F6E73747B746578743A6E2C69636F6E4F6666736574733A697D3D743B69662821697C7C303D3D3D692E6C656E6774682972657475726E206E736528652C';
wwv_flow_imp.g_varchar2_table(33215) := '6E293B636F6E7374206F3D6869286E2C222022292C733D6E2E6C656E6774682D6F2E6C656E6774682C723D6E736528652C6F293B6966287229666F7228636F6E73742065206F662072297B636F6E737420743D695B652E73746172742B735D2B733B652E';
wwv_flow_imp.g_varchar2_table(33216) := '73746172742B3D742C652E656E642B3D747D72657475726E20727D28742C526C28692E73616E654C6162656C2929292626766F69642030213D3D733F733A766F696420303B636F6E737420633D746869732E6D617463684F6E4465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(33217) := '26266E756C6C213D3D28723D466C28652C526C28692E73616E654465736372697074696F6E7C7C22222929292626766F69642030213D3D723F723A766F696420302C643D746869732E6D617463684F6E44657461696C26266E756C6C213D3D28613D466C';
wwv_flow_imp.g_varchar2_table(33218) := '28652C526C28692E73616E6544657461696C7C7C22222929292626766F69642030213D3D613F613A766F696420303B6966286C7C7C637C7C643F28692E6C6162656C486967686C69676874733D6C2C692E6465736372697074696F6E486967686C696768';
wwv_flow_imp.g_varchar2_table(33219) := '74733D632C692E64657461696C486967686C69676874733D642C692E68696464656E3D2131293A28692E6C6162656C486967686C69676874733D766F696420302C692E6465736372697074696F6E486967686C69676874733D766F696420302C692E6465';
wwv_flow_imp.g_varchar2_table(33220) := '7461696C486967686C69676874733D766F696420302C692E68696464656E3D21692E6974656D7C7C21692E6974656D2E616C7761797353686F77292C692E6974656D3F692E736570617261746F723D766F696420303A692E736570617261746F72262628';
wwv_flow_imp.g_varchar2_table(33221) := '692E68696464656E3D2130292C21746869732E736F727442794C6162656C297B636F6E737420653D692E696E6465782626746869732E5F696E707574456C656D656E74735B692E696E6465782D315D3B6E3D65262622736570617261746F72223D3D3D65';
wwv_flow_imp.g_varchar2_table(33222) := '2E747970653F653A6E2C6E262621692E68696464656E262628692E736570617261746F723D6E2C6E3D766F69642030297D7D29297D656C736520746869732E5F6974656D456C656D656E74732E666F72456163682828653D3E7B652E6C6162656C486967';
wwv_flow_imp.g_varchar2_table(33223) := '686C69676874733D766F696420302C652E6465736372697074696F6E486967686C69676874733D766F696420302C652E64657461696C486967686C69676874733D766F696420302C652E68696464656E3D21313B636F6E737420743D652E696E64657826';
wwv_flow_imp.g_varchar2_table(33224) := '26746869732E5F696E707574456C656D656E74735B652E696E6465782D315D3B652E6974656D262628652E736570617261746F723D74262622736570617261746F72223D3D3D742E74797065262621742E627574746F6E733F743A766F69642030297D29';
wwv_flow_imp.g_varchar2_table(33225) := '293B636F6E7374206E3D746869732E5F656C656D656E74547265652E66696C7465722828653D3E21652E68696464656E29293B696628746869732E736F727442794C6162656C262665297B636F6E737420743D652E746F4C6F7765724361736528293B6E';
wwv_flow_imp.g_varchar2_table(33226) := '2E736F7274282828652C6E293D3E66756E6374696F6E28652C742C6E297B636F6E737420693D652E6C6162656C486967686C69676874737C7C5B5D2C6F3D742E6C6162656C486967686C69676874737C7C5B5D3B72657475726E20692E6C656E67746826';
wwv_flow_imp.g_varchar2_table(33227) := '26216F2E6C656E6774683F2D313A21692E6C656E67746826266F2E6C656E6774683F313A303D3D3D692E6C656E6774682626303D3D3D6F2E6C656E6774683F303A66756E6374696F6E28652C742C6E297B636F6E737420693D652E746F4C6F7765724361';
wwv_flow_imp.g_varchar2_table(33228) := '736528292C6F3D742E746F4C6F7765724361736528292C733D66756E6374696F6E28652C742C6E297B636F6E737420693D652E746F4C6F7765724361736528292C6F3D742E746F4C6F7765724361736528292C733D692E73746172747357697468286E29';
wwv_flow_imp.g_varchar2_table(33229) := '2C723D6F2E73746172747357697468286E293B69662873213D3D722972657475726E20733F2D313A313B69662873262672297B696628692E6C656E6774683C6F2E6C656E6774682972657475726E2D313B696628692E6C656E6774683E6F2E6C656E6774';
wwv_flow_imp.g_varchar2_table(33230) := '682972657475726E20317D72657475726E20307D28652C742C6E293B696628732972657475726E20733B636F6E737420723D692E656E647357697468286E293B69662872213D3D6F2E656E647357697468286E292972657475726E20723F2D313A313B63';
wwv_flow_imp.g_varchar2_table(33231) := '6F6E737420613D66756E6374696F6E28652C74297B636F6E7374206E3D657C7C22222C693D747C7C22222C6F3D7A6F652E76616C75652E636F6C6C61746F722E636F6D70617265286E2C69293B72657475726E207A6F652E76616C75652E636F6C6C6174';
wwv_flow_imp.g_varchar2_table(33232) := '6F7249734E756D657269632626303D3D3D6F26266E213D3D693F6E3C693F2D313A313A6F7D28692C6F293B72657475726E2030213D3D613F613A692E6C6F63616C65436F6D70617265286F297D28652E73616E65536F72744C6162656C2C742E73616E65';
wwv_flow_imp.g_varchar2_table(33233) := '536F72744C6162656C2C6E297D28652C6E2C742929297D6C657420693B636F6E7374206F3D6E2E726564756365282828652C742C6E293D3E287420696E7374616E63656F6620476F653F693F692E6368696C6472656E2E707573682874293A652E707573';
wwv_flow_imp.g_varchar2_table(33234) := '682874293A7420696E7374616E63656F6620516F65262628742E6368696C6472656E3D5B5D2C693D742C652E70757368287429292C6529292C6E6577204172726179292C733D6E65772041727261793B666F7228636F6E73742065206F66206F29652069';
wwv_flow_imp.g_varchar2_table(33235) := '6E7374616E63656F6620516F653F732E70757368287B656C656D656E743A652C636F6C6C61707369626C653A21312C636F6C6C61707365643A21312C6368696C6472656E3A652E6368696C6472656E2E6D61702828653D3E287B656C656D656E743A652C';
wwv_flow_imp.g_varchar2_table(33236) := '636F6C6C61707369626C653A21312C636F6C6C61707365643A21317D2929297D293A732E70757368287B656C656D656E743A652C636F6C6C61707369626C653A21312C636F6C6C61707365643A21317D293B636F6E737420723D746869732E5F74726565';
wwv_flow_imp.g_varchar2_table(33237) := '2E676574466F63757328292E6C656E6774683B72657475726E20746869732E5F747265652E7365744368696C6472656E286E756C6C2C73292C723E302626303D3D3D732E6C656E6774682626746869732E5F6F6E54726967676572456D70747953656C65';
wwv_flow_imp.g_varchar2_table(33238) := '6374696F6E4F72466F6375732E66697265287B656C656D656E74733A5B5D7D292C746869732E5F747265652E6C61796F757428292C746869732E5F6F6E4368616E676564416C6C56697369626C65436865636B65642E6669726528746869732E67657441';
wwv_flow_imp.g_varchar2_table(33239) := '6C6C56697369626C65436865636B65642829292C746869732E5F6F6E4368616E67656456697369626C65436F756E742E66697265286E2E6C656E677468292C21307D746F67676C65436865636B626F7828297B7472797B746869732E5F73686F756C6446';
wwv_flow_imp.g_varchar2_table(33240) := '697265436865636B65644576656E74733D21313B636F6E737420653D746869732E5F747265652E676574466F63757328292E66696C7465722828653D3E6520696E7374616E63656F6620476F6529292C743D746869732E5F616C6C56697369626C654368';
wwv_flow_imp.g_varchar2_table(33241) := '65636B65642865293B666F7228636F6E7374206E206F662065296E2E636865636B626F7844697361626C65647C7C286E2E636865636B65643D2174297D66696E616C6C797B746869732E5F73686F756C6446697265436865636B65644576656E74733D21';
wwv_flow_imp.g_varchar2_table(33242) := '302C746869732E5F66697265436865636B65644576656E747328297D7D646973706C61792865297B746869732E5F636F6E7461696E65722E7374796C652E646973706C61793D653F22223A226E6F6E65227D6973446973706C6179656428297B72657475';
wwv_flow_imp.g_varchar2_table(33243) := '726E226E6F6E6522213D3D746869732E5F636F6E7461696E65722E7374796C652E646973706C61797D7374796C652865297B746869732E5F747265652E7374796C652865297D746F67676C65486F76657228297B636F6E737420653D746869732E5F7472';
wwv_flow_imp.g_varchar2_table(33244) := '65652E676574466F63757328295B305D3B6966282128286E756C6C3D3D653F766F696420303A652E73616E65546F6F6C7469702926266520696E7374616E63656F6620476F65292972657475726E3B696628746869732E5F6C617374486F766572262621';
wwv_flow_imp.g_varchar2_table(33245) := '746869732E5F6C617374486F7665722E6973446973706F7365642972657475726E20766F696420746869732E5F6C617374486F7665722E646973706F736528293B746869732E73686F77486F7665722865293B636F6E737420743D6E65772061743B742E';
wwv_flow_imp.g_varchar2_table(33246) := '61646428746869732E5F747265652E6F6E4469644368616E6765466F6375732828653D3E7B652E656C656D656E74735B305D696E7374616E63656F6620476F652626746869732E73686F77486F76657228652E656C656D656E74735B305D297D2929292C';
wwv_flow_imp.g_varchar2_table(33247) := '746869732E5F6C617374486F7665722626742E61646428746869732E5F6C617374486F766572292C746869732E5F656C656D656E74446973706F7361626C652E6164642874297D5F616C6C56697369626C65436865636B656428652C743D2130297B666F';
wwv_flow_imp.g_varchar2_table(33248) := '72286C6574206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B69662821692E68696464656E297B69662821692E636865636B65642972657475726E21313B743D21307D7D72657475726E20747D5F66697265';
wwv_flow_imp.g_varchar2_table(33249) := '436865636B65644576656E747328297B746869732E5F73686F756C6446697265436865636B65644576656E7473262628746869732E5F6F6E4368616E676564416C6C56697369626C65436865636B65642E6669726528746869732E676574416C6C566973';
wwv_flow_imp.g_varchar2_table(33250) := '69626C65436865636B65642829292C746869732E5F6F6E4368616E676564436865636B6564436F756E742E6669726528746869732E676574436865636B6564436F756E742829292C746869732E5F6F6E4368616E676564436865636B6564456C656D656E';
wwv_flow_imp.g_varchar2_table(33251) := '74732E6669726528746869732E676574436865636B6564456C656D656E7473282929297D66697265427574746F6E5472696767657265642865297B746869732E5F6F6E427574746F6E5472696767657265642E666972652865297D666972655365706172';
wwv_flow_imp.g_varchar2_table(33252) := '61746F72427574746F6E5472696767657265642865297B746869732E5F6F6E536570617261746F72427574746F6E5472696767657265642E666972652865297D73686F77486F7665722865297B76617220742C6E2C693B746869732E5F6C617374486F76';
wwv_flow_imp.g_varchar2_table(33253) := '6572262621746869732E5F6C617374486F7665722E6973446973706F7365642626286E756C6C3D3D3D286E3D28743D746869732E686F76657244656C6567617465292E6F6E44696448696465486F766572297C7C766F696420303D3D3D6E7C7C6E2E6361';
wwv_flow_imp.g_varchar2_table(33254) := '6C6C2874292C6E756C6C3D3D3D28693D746869732E5F6C617374486F766572297C7C766F696420303D3D3D697C7C692E646973706F73652829292C652E656C656D656E742626652E73616E65546F6F6C746970262628746869732E5F6C617374486F7665';
wwv_flow_imp.g_varchar2_table(33255) := '723D746869732E686F76657244656C65676174652E73686F77486F766572287B636F6E74656E743A652E73616E65546F6F6C7469702C7461726765743A652E656C656D656E742C6C696E6B48616E646C65723A653D3E7B746869732E6C696E6B4F70656E';
wwv_flow_imp.g_varchar2_table(33256) := '657244656C65676174652865297D2C617070656172616E63653A7B73686F77506F696E7465723A21307D2C636F6E7461696E65723A746869732E5F636F6E7461696E65722C706F736974696F6E3A7B686F766572506F736974696F6E3A317D7D2C213129';
wwv_flow_imp.g_varchar2_table(33257) := '297D7D3B66756E6374696F6E206E736528652C74297B636F6E7374206E3D742E746F4C6F7765724361736528292E696E6465784F6628652E746F4C6F776572436173652829293B72657475726E2D31213D3D6E3F5B7B73746172743A6E2C656E643A6E2B';
wwv_flow_imp.g_varchar2_table(33258) := '652E6C656E6774687D5D3A6E756C6C7D576F65285B44455D2C7473652E70726F746F747970652C226F6E4469644368616E6765466F637573222C6E756C6C292C576F65285B44455D2C7473652E70726F746F747970652C226F6E4469644368616E676553';
wwv_flow_imp.g_varchar2_table(33259) := '656C656374696F6E222C6E756C6C292C7473653D576F65285B6A6F6528342C7563295D2C747365293B766172206973653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E7374';
wwv_flow_imp.g_varchar2_table(33260) := '206F73653D7B69636F6E436C6173733A546C2E6173436C6173734E616D65284C6C2E717569636B496E7075744261636B292C746F6F6C7469703A6228302C224261636B22292C68616E646C653A2D317D3B636C6173732073736520657874656E6473206C';
wwv_flow_imp.g_varchar2_table(33261) := '747B636F6E7374727563746F722865297B737570657228292C746869732E75693D652C746869732E5F776964676574557064617465643D21312C746869732E76697369626C653D21312C746869732E5F656E61626C65643D21302C746869732E5F627573';
wwv_flow_imp.g_varchar2_table(33262) := '793D21312C746869732E5F69676E6F7265466F6375734F75743D21312C746869732E5F627574746F6E733D5B5D2C746869732E627574746F6E73557064617465643D21312C746869732E5F746F67676C65733D5B5D2C746869732E746F67676C65735570';
wwv_flow_imp.g_varchar2_table(33263) := '64617465643D21312C746869732E6E6F56616C69646174696F6E4D6573736167653D7373652E6E6F50726F6D70744D6573736167652C746869732E5F73657665726974793D69442E49676E6F72652C746869732E6F6E4469645472696767657242757474';
wwv_flow_imp.g_varchar2_table(33264) := '6F6E456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696448696465456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E57696C6C48696465456D6974746572';
wwv_flow_imp.g_varchar2_table(33265) := '3D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446973706F7365456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E76697369626C65446973706F7361626C65733D746869732E5F72';
wwv_flow_imp.g_varchar2_table(33266) := '65676973746572286E6577206174292C746869732E6F6E446964486964653D746869732E6F6E44696448696465456D69747465722E6576656E747D676574207469746C6528297B72657475726E20746869732E5F7469746C657D736574207469746C6528';
wwv_flow_imp.g_varchar2_table(33267) := '65297B746869732E5F7469746C653D652C746869732E75706461746528297D676574206465736372697074696F6E28297B72657475726E20746869732E5F6465736372697074696F6E7D736574206465736372697074696F6E2865297B746869732E5F64';
wwv_flow_imp.g_varchar2_table(33268) := '65736372697074696F6E3D652C746869732E75706461746528297D676574207374657028297B72657475726E20746869732E5F73746570737D73657420737465702865297B746869732E5F73746570733D652C746869732E75706461746528297D676574';
wwv_flow_imp.g_varchar2_table(33269) := '20746F74616C537465707328297B72657475726E20746869732E5F746F74616C53746570737D73657420746F74616C53746570732865297B746869732E5F746F74616C53746570733D652C746869732E75706461746528297D67657420656E61626C6564';
wwv_flow_imp.g_varchar2_table(33270) := '28297B72657475726E20746869732E5F656E61626C65647D73657420656E61626C65642865297B746869732E5F656E61626C65643D652C746869732E75706461746528297D67657420636F6E746578744B657928297B72657475726E20746869732E5F63';
wwv_flow_imp.g_varchar2_table(33271) := '6F6E746578744B65797D73657420636F6E746578744B65792865297B746869732E5F636F6E746578744B65793D652C746869732E75706461746528297D676574206275737928297B72657475726E20746869732E5F627573797D73657420627573792865';
wwv_flow_imp.g_varchar2_table(33272) := '297B746869732E5F627573793D652C746869732E75706461746528297D6765742069676E6F7265466F6375734F757428297B72657475726E20746869732E5F69676E6F7265466F6375734F75747D7365742069676E6F7265466F6375734F75742865297B';
wwv_flow_imp.g_varchar2_table(33273) := '636F6E737420743D746869732E5F69676E6F7265466F6375734F7574213D3D65262621513B746869732E5F69676E6F7265466F6375734F75743D65262621512C742626746869732E75706461746528297D67657420627574746F6E7328297B7265747572';
wwv_flow_imp.g_varchar2_table(33274) := '6E20746869732E5F627574746F6E737D73657420627574746F6E732865297B746869732E5F627574746F6E733D652C746869732E627574746F6E73557064617465643D21302C746869732E75706461746528297D67657420746F67676C657328297B7265';
wwv_flow_imp.g_varchar2_table(33275) := '7475726E20746869732E5F746F67676C65737D73657420746F67676C65732865297B746869732E5F746F67676C65733D6E756C6C213D653F653A5B5D2C746869732E746F67676C6573557064617465643D21302C746869732E75706461746528297D6765';
wwv_flow_imp.g_varchar2_table(33276) := '742076616C69646174696F6E4D65737361676528297B72657475726E20746869732E5F76616C69646174696F6E4D6573736167657D7365742076616C69646174696F6E4D6573736167652865297B746869732E5F76616C69646174696F6E4D6573736167';
wwv_flow_imp.g_varchar2_table(33277) := '653D652C746869732E75706461746528297D67657420736576657269747928297B72657475726E20746869732E5F73657665726974797D7365742073657665726974792865297B746869732E5F73657665726974793D652C746869732E75706461746528';
wwv_flow_imp.g_varchar2_table(33278) := '297D73686F7728297B746869732E76697369626C657C7C28746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6F6E44696454726967676572427574746F6E2828653D3E7B2D31213D3D746869732E627574746F6E';
wwv_flow_imp.g_varchar2_table(33279) := '732E696E6465784F662865292626746869732E6F6E44696454726967676572427574746F6E456D69747465722E666972652865297D2929292C746869732E75692E73686F772874686973292C746869732E76697369626C653D21302C746869732E5F6C61';
wwv_flow_imp.g_varchar2_table(33280) := '737456616C69646174696F6E4D6573736167653D766F696420302C746869732E5F6C61737453657665726974793D766F696420302C746869732E627574746F6E732E6C656E677468262628746869732E627574746F6E73557064617465643D2130292C74';
wwv_flow_imp.g_varchar2_table(33281) := '6869732E746F67676C65732E6C656E677468262628746869732E746F67676C6573557064617465643D2130292C746869732E7570646174652829297D6869646528297B746869732E76697369626C652626746869732E75692E6869646528297D64696448';
wwv_flow_imp.g_varchar2_table(33282) := '69646528653D6B452E4F74686572297B746869732E76697369626C653D21312C746869732E76697369626C65446973706F7361626C65732E636C65617228292C746869732E6F6E44696448696465456D69747465722E66697265287B726561736F6E3A65';
wwv_flow_imp.g_varchar2_table(33283) := '7D297D77696C6C4869646528653D6B452E4F74686572297B746869732E6F6E57696C6C48696465456D69747465722E66697265287B726561736F6E3A657D297D75706461746528297B76617220652C743B69662821746869732E76697369626C65297265';
wwv_flow_imp.g_varchar2_table(33284) := '7475726E3B636F6E7374206E3D746869732E6765745469746C6528293B6E2626746869732E75692E7469746C652E74657874436F6E74656E74213D3D6E3F746869732E75692E7469746C652E74657874436F6E74656E743D6E3A6E7C7C22266E6273703B';
wwv_flow_imp.g_varchar2_table(33285) := '223D3D3D746869732E75692E7469746C652E696E6E657248544D4C7C7C28746869732E75692E7469746C652E696E6E6572546578743D22C2A022293B636F6E737420693D746869732E6765744465736372697074696F6E28293B696628746869732E7569';
wwv_flow_imp.g_varchar2_table(33286) := '2E6465736372697074696F6E312E74657874436F6E74656E74213D3D69262628746869732E75692E6465736372697074696F6E312E74657874436F6E74656E743D69292C746869732E75692E6465736372697074696F6E322E74657874436F6E74656E74';
wwv_flow_imp.g_varchar2_table(33287) := '213D3D69262628746869732E75692E6465736372697074696F6E322E74657874436F6E74656E743D69292C746869732E5F77696467657455706461746564262628746869732E5F776964676574557064617465643D21312C746869732E5F776964676574';
wwv_flow_imp.g_varchar2_table(33288) := '3F677228746869732E75692E7769646765742C746869732E5F776964676574293A677228746869732E75692E77696467657429292C746869732E62757379262621746869732E6275737944656C6179262628746869732E6275737944656C61793D6E6577';
wwv_flow_imp.g_varchar2_table(33289) := '2024742C746869732E6275737944656C61792E73657449664E6F74536574282828293D3E7B746869732E76697369626C652626746869732E75692E70726F67726573734261722E696E66696E69746528297D292C38303029292C21746869732E62757379';
wwv_flow_imp.g_varchar2_table(33290) := '2626746869732E6275737944656C6179262628746869732E75692E70726F67726573734261722E73746F7028292C746869732E6275737944656C61792E63616E63656C28292C746869732E6275737944656C61793D766F69642030292C746869732E6275';
wwv_flow_imp.g_varchar2_table(33291) := '74746F6E7355706461746564297B746869732E627574746F6E73557064617465643D21312C746869732E75692E6C656674416374696F6E4261722E636C65617228293B636F6E737420653D746869732E627574746F6E732E66696C7465722828653D3E65';
wwv_flow_imp.g_varchar2_table(33292) := '3D3D3D6F736529292E6D6170282828652C74293D3E566F6528652C6069642D247B747D602C286173796E6328293D3E746869732E6F6E44696454726967676572427574746F6E456D69747465722E66697265286529292929293B746869732E75692E6C65';
wwv_flow_imp.g_varchar2_table(33293) := '6674416374696F6E4261722E7075736828652C7B69636F6E3A21302C6C6162656C3A21317D292C746869732E75692E7269676874416374696F6E4261722E636C65617228293B636F6E737420743D746869732E627574746F6E732E66696C746572282865';
wwv_flow_imp.g_varchar2_table(33294) := '3D3E65213D3D6F736529292E6D6170282828652C74293D3E566F6528652C6069642D247B747D602C286173796E6328293D3E746869732E6F6E44696454726967676572427574746F6E456D69747465722E66697265286529292929293B746869732E7569';
wwv_flow_imp.g_varchar2_table(33295) := '2E7269676874416374696F6E4261722E7075736828742C7B69636F6E3A21302C6C6162656C3A21317D297D696628746869732E746F67676C657355706461746564297B746869732E746F67676C6573557064617465643D21313B636F6E7374206E3D6E75';
wwv_flow_imp.g_varchar2_table(33296) := '6C6C213D3D28743D6E756C6C3D3D3D28653D746869732E746F67676C6573297C7C766F696420303D3D3D653F766F696420303A652E66696C7465722828653D3E6520696E7374616E63656F662055242929292626766F69642030213D3D743F743A5B5D3B';
wwv_flow_imp.g_varchar2_table(33297) := '746869732E75692E696E707574426F782E746F67676C65733D6E7D746869732E75692E69676E6F7265466F6375734F75743D746869732E69676E6F7265466F6375734F75742C746869732E75692E736574456E61626C656428746869732E656E61626C65';
wwv_flow_imp.g_varchar2_table(33298) := '64292C746869732E75692E736574436F6E746578744B657928746869732E636F6E746578744B6579293B636F6E7374206F3D746869732E76616C69646174696F6E4D6573736167657C7C746869732E6E6F56616C69646174696F6E4D6573736167653B74';
wwv_flow_imp.g_varchar2_table(33299) := '6869732E5F6C61737456616C69646174696F6E4D657373616765213D3D6F262628746869732E5F6C61737456616C69646174696F6E4D6573736167653D6F2C677228746869732E75692E6D657373616765292C66756E6374696F6E28652C742C6E297B67';
wwv_flow_imp.g_varchar2_table(33300) := '722874293B636F6E737420693D66756E6374696F6E2865297B636F6E737420743D5B5D3B6C6574206E2C693D303B666F72283B6E3D526F652E657865632865293B297B6E2E696E6465782D693E302626742E7075736828652E737562737472696E672869';
wwv_flow_imp.g_varchar2_table(33301) := '2C6E2E696E64657829293B636F6E73745B2C6F2C732C2C725D3D6E3B723F742E70757368287B6C6162656C3A6F2C687265663A732C7469746C653A727D293A742E70757368287B6C6162656C3A6F2C687265663A737D292C693D6E2E696E6465782B6E5B';
wwv_flow_imp.g_varchar2_table(33302) := '305D2E6C656E6774687D72657475726E20693C652E6C656E6774682626742E7075736828652E737562737472696E67286929292C6E6577204F6F652874297D2865293B6C6574206F3D303B666F7228636F6E73742065206F6620692E6E6F646573296966';
wwv_flow_imp.g_varchar2_table(33303) := '2822737472696E67223D3D747970656F66206529742E617070656E64282E2E2E536B286529293B656C73657B6C657420693D652E7469746C653B21692626652E687265662E737461727473576974682822636F6D6D616E643A22293F693D6228302C2243';
wwv_flow_imp.g_varchar2_table(33304) := '6C69636B20746F206578656375746520636F6D6D616E6420277B307D27222C652E687265662E737562737472696E67283829293A697C7C28693D652E68726566293B636F6E737420733D6272282261222C7B687265663A652E687265662C7469746C653A';
wwv_flow_imp.g_varchar2_table(33305) := '692C746162496E6465783A6F2B2B7D2C652E6C6162656C293B732E7374796C652E746578744465636F726174696F6E3D22756E6465726C696E65223B636F6E737420723D743D3E7B6C722874292626637228742C2130292C6E2E63616C6C6261636B2865';
wwv_flow_imp.g_varchar2_table(33306) := '2E68726566297D2C613D6E2E646973706F7361626C65732E616464286E6577204B5328732C61722E434C49434B29292E6576656E742C6C3D6E2E646973706F7361626C65732E616464286E6577204B5328732C61722E4B45595F444F574E29292E657665';
wwv_flow_imp.g_varchar2_table(33307) := '6E742C633D76742E636861696E286C2C28653D3E652E66696C7465722828653D3E7B636F6E737420743D6E65772071652865293B72657475726E20742E657175616C73283130297C7C742E657175616C732833297D292929293B6E2E646973706F736162';
wwv_flow_imp.g_varchar2_table(33308) := '6C65732E6164642849452E616464546172676574287329293B636F6E737420643D6E2E646973706F7361626C65732E616464286E6577204B5328732C54452E54617029292E6576656E743B76742E616E7928612C642C632928722C6E756C6C2C6E2E6469';
wwv_flow_imp.g_varchar2_table(33309) := '73706F7361626C6573292C742E617070656E644368696C642873297D7D286F2C746869732E75692E6D6573736167652C7B63616C6C6261636B3A653D3E7B746869732E75692E6C696E6B4F70656E657244656C65676174652865297D2C646973706F7361';
wwv_flow_imp.g_varchar2_table(33310) := '626C65733A746869732E76697369626C65446973706F7361626C65737D29292C746869732E5F6C6173745365766572697479213D3D746869732E7365766572697479262628746869732E5F6C61737453657665726974793D746869732E73657665726974';
wwv_flow_imp.g_varchar2_table(33311) := '792C746869732E73686F774D6573736167654465636F726174696F6E28746869732E736576657269747929297D6765745469746C6528297B72657475726E20746869732E7469746C652626746869732E737465703F60247B746869732E7469746C657D20';
wwv_flow_imp.g_varchar2_table(33312) := '28247B746869732E676574537465707328297D29603A746869732E7469746C653F746869732E7469746C653A746869732E737465703F746869732E676574537465707328293A22227D6765744465736372697074696F6E28297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(33313) := '732E6465736372697074696F6E7C7C22227D676574537465707328297B72657475726E20746869732E737465702626746869732E746F74616C53746570733F6228302C227B307D2F7B317D222C746869732E737465702C746869732E746F74616C537465';
wwv_flow_imp.g_varchar2_table(33314) := '7073293A746869732E737465703F537472696E6728746869732E73746570293A22227D73686F774D6573736167654465636F726174696F6E2865297B696628746869732E75692E696E707574426F782E73686F774465636F726174696F6E2865292C6521';
wwv_flow_imp.g_varchar2_table(33315) := '3D3D69442E49676E6F7265297B636F6E737420743D746869732E75692E696E707574426F782E7374796C6573466F72547970652865293B746869732E75692E6D6573736167652E7374796C652E636F6C6F723D742E666F726567726F756E643F60247B74';
wwv_flow_imp.g_varchar2_table(33316) := '2E666F726567726F756E647D603A22222C746869732E75692E6D6573736167652E7374796C652E6261636B67726F756E64436F6C6F723D742E6261636B67726F756E643F60247B742E6261636B67726F756E647D603A22222C746869732E75692E6D6573';
wwv_flow_imp.g_varchar2_table(33317) := '736167652E7374796C652E626F726465723D742E626F726465723F6031707820736F6C696420247B742E626F726465727D603A22222C746869732E75692E6D6573736167652E7374796C652E6D617267696E426F74746F6D3D222D327078227D656C7365';
wwv_flow_imp.g_varchar2_table(33318) := '20746869732E75692E6D6573736167652E7374796C652E636F6C6F723D22222C746869732E75692E6D6573736167652E7374796C652E6261636B67726F756E64436F6C6F723D22222C746869732E75692E6D6573736167652E7374796C652E626F726465';
wwv_flow_imp.g_varchar2_table(33319) := '723D22222C746869732E75692E6D6573736167652E7374796C652E6D617267696E426F74746F6D3D22227D646973706F736528297B746869732E6869646528292C746869732E6F6E446973706F7365456D69747465722E6669726528292C73757065722E';
wwv_flow_imp.g_varchar2_table(33320) := '646973706F736528297D7D7373652E6E6F50726F6D70744D6573736167653D6228302C2250726573732027456E7465722720746F20636F6E6669726D20796F757220696E707574206F7220274573636170652720746F2063616E63656C22293B636C6173';
wwv_flow_imp.g_varchar2_table(33321) := '732072736520657874656E6473207373657B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F76616C75653D22222C746869732E6F6E4469644368616E676556616C7565456D69747465723D74686973';
wwv_flow_imp.g_varchar2_table(33322) := '2E5F7265676973746572286E6577204374292C746869732E6F6E57696C6C416363657074456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964416363657074456D69747465723D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(33323) := '6973746572286E6577204374292C746869732E6F6E446964437573746F6D456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E5F6974656D733D5B5D2C746869732E6974656D73557064617465643D21312C746869';
wwv_flow_imp.g_varchar2_table(33324) := '732E5F63616E53656C6563744D616E793D21312C746869732E5F63616E416363657074496E4261636B67726F756E643D21312C746869732E5F6D617463684F6E4465736372697074696F6E3D21312C746869732E5F6D617463684F6E44657461696C3D21';
wwv_flow_imp.g_varchar2_table(33325) := '312C746869732E5F6D617463684F6E4C6162656C3D21302C746869732E5F6D617463684F6E4C6162656C4D6F64653D2266757A7A79222C746869732E5F736F727442794C6162656C3D21302C746869732E5F6B6565705363726F6C6C506F736974696F6E';
wwv_flow_imp.g_varchar2_table(33326) := '3D21312C746869732E5F6974656D41637469766174696F6E3D45452E46495253542C746869732E5F6163746976654974656D733D5B5D2C746869732E6163746976654974656D73557064617465643D21312C746869732E6163746976654974656D73546F';
wwv_flow_imp.g_varchar2_table(33327) := '436F6E6669726D3D5B5D2C746869732E6F6E4469644368616E6765416374697665456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E5F73656C65637465644974656D733D5B5D2C746869732E73656C6563746564';
wwv_flow_imp.g_varchar2_table(33328) := '4974656D73557064617465643D21312C746869732E73656C65637465644974656D73546F436F6E6669726D3D5B5D2C746869732E6F6E4469644368616E676553656C656374696F6E456D69747465723D746869732E5F7265676973746572286E65772043';
wwv_flow_imp.g_varchar2_table(33329) := '74292C746869732E6F6E446964547269676765724974656D427574746F6E456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696454726967676572536570617261746F72427574746F6E456D6974746572';
wwv_flow_imp.g_varchar2_table(33330) := '3D746869732E5F7265676973746572286E6577204374292C746869732E76616C756553656C656374696F6E557064617465643D21302C746869732E5F6F6B3D2264656661756C74222C746869732E5F637573746F6D427574746F6E3D21312C746869732E';
wwv_flow_imp.g_varchar2_table(33331) := '66696C74657256616C75653D653D3E652C746869732E6F6E4469644368616E676556616C75653D746869732E6F6E4469644368616E676556616C7565456D69747465722E6576656E742C746869732E6F6E57696C6C4163636570743D746869732E6F6E57';
wwv_flow_imp.g_varchar2_table(33332) := '696C6C416363657074456D69747465722E6576656E742C746869732E6F6E4469644163636570743D746869732E6F6E446964416363657074456D69747465722E6576656E742C746869732E6F6E4469644368616E67654163746976653D746869732E6F6E';
wwv_flow_imp.g_varchar2_table(33333) := '4469644368616E6765416374697665456D69747465722E6576656E742C746869732E6F6E4469644368616E676553656C656374696F6E3D746869732E6F6E4469644368616E676553656C656374696F6E456D69747465722E6576656E742C746869732E6F';
wwv_flow_imp.g_varchar2_table(33334) := '6E446964547269676765724974656D427574746F6E3D746869732E6F6E446964547269676765724974656D427574746F6E456D69747465722E6576656E742C746869732E6F6E44696454726967676572536570617261746F72427574746F6E3D74686973';
wwv_flow_imp.g_varchar2_table(33335) := '2E6F6E44696454726967676572536570617261746F72427574746F6E456D69747465722E6576656E747D67657420717569636B4E6176696761746528297B72657475726E20746869732E5F717569636B4E617669676174657D73657420717569636B4E61';
wwv_flow_imp.g_varchar2_table(33336) := '7669676174652865297B746869732E5F717569636B4E617669676174653D652C746869732E75706461746528297D6765742076616C756528297B72657475726E20746869732E5F76616C75657D7365742076616C75652865297B746869732E646F536574';
wwv_flow_imp.g_varchar2_table(33337) := '56616C75652865297D646F53657456616C756528652C74297B746869732E5F76616C7565213D3D65262628746869732E5F76616C75653D652C747C7C746869732E75706461746528292C746869732E76697369626C652626746869732E75692E6C697374';
wwv_flow_imp.g_varchar2_table(33338) := '2E66696C74657228746869732E66696C74657256616C756528746869732E5F76616C756529292626746869732E74727953656C656374466972737428292C746869732E6F6E4469644368616E676556616C7565456D69747465722E666972652874686973';
wwv_flow_imp.g_varchar2_table(33339) := '2E5F76616C756529297D73657420617269614C6162656C2865297B746869732E5F617269614C6162656C3D652C746869732E75706461746528297D67657420617269614C6162656C28297B72657475726E20746869732E5F617269614C6162656C7D6765';
wwv_flow_imp.g_varchar2_table(33340) := '7420706C616365686F6C64657228297B72657475726E20746869732E5F706C616365686F6C6465727D73657420706C616365686F6C6465722865297B746869732E5F706C616365686F6C6465723D652C746869732E75706461746528297D676574206974';
wwv_flow_imp.g_varchar2_table(33341) := '656D7328297B72657475726E20746869732E5F6974656D737D676574207363726F6C6C546F7028297B72657475726E20746869732E75692E6C6973742E7363726F6C6C546F707D736574207363726F6C6C546F702865297B746869732E75692E6C697374';
wwv_flow_imp.g_varchar2_table(33342) := '2E7363726F6C6C546F703D657D736574206974656D732865297B746869732E5F6974656D733D652C746869732E6974656D73557064617465643D21302C746869732E75706461746528297D6765742063616E53656C6563744D616E7928297B7265747572';
wwv_flow_imp.g_varchar2_table(33343) := '6E20746869732E5F63616E53656C6563744D616E797D7365742063616E53656C6563744D616E792865297B746869732E5F63616E53656C6563744D616E793D652C746869732E75706461746528297D6765742063616E416363657074496E4261636B6772';
wwv_flow_imp.g_varchar2_table(33344) := '6F756E6428297B72657475726E20746869732E5F63616E416363657074496E4261636B67726F756E647D7365742063616E416363657074496E4261636B67726F756E642865297B746869732E5F63616E416363657074496E4261636B67726F756E643D65';
wwv_flow_imp.g_varchar2_table(33345) := '7D676574206D617463684F6E4465736372697074696F6E28297B72657475726E20746869732E5F6D617463684F6E4465736372697074696F6E7D736574206D617463684F6E4465736372697074696F6E2865297B746869732E5F6D617463684F6E446573';
wwv_flow_imp.g_varchar2_table(33346) := '6372697074696F6E3D652C746869732E75706461746528297D676574206D617463684F6E44657461696C28297B72657475726E20746869732E5F6D617463684F6E44657461696C7D736574206D617463684F6E44657461696C2865297B746869732E5F6D';
wwv_flow_imp.g_varchar2_table(33347) := '617463684F6E44657461696C3D652C746869732E75706461746528297D676574206D617463684F6E4C6162656C28297B72657475726E20746869732E5F6D617463684F6E4C6162656C7D736574206D617463684F6E4C6162656C2865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(33348) := '6D617463684F6E4C6162656C3D652C746869732E75706461746528297D676574206D617463684F6E4C6162656C4D6F646528297B72657475726E20746869732E5F6D617463684F6E4C6162656C4D6F64657D736574206D617463684F6E4C6162656C4D6F';
wwv_flow_imp.g_varchar2_table(33349) := '64652865297B746869732E5F6D617463684F6E4C6162656C4D6F64653D652C746869732E75706461746528297D67657420736F727442794C6162656C28297B72657475726E20746869732E5F736F727442794C6162656C7D73657420736F727442794C61';
wwv_flow_imp.g_varchar2_table(33350) := '62656C2865297B746869732E5F736F727442794C6162656C3D652C746869732E75706461746528297D676574206B6565705363726F6C6C506F736974696F6E28297B72657475726E20746869732E5F6B6565705363726F6C6C506F736974696F6E7D7365';
wwv_flow_imp.g_varchar2_table(33351) := '74206B6565705363726F6C6C506F736974696F6E2865297B746869732E5F6B6565705363726F6C6C506F736974696F6E3D657D676574206974656D41637469766174696F6E28297B72657475726E20746869732E5F6974656D41637469766174696F6E7D';
wwv_flow_imp.g_varchar2_table(33352) := '736574206974656D41637469766174696F6E2865297B746869732E5F6974656D41637469766174696F6E3D657D676574206163746976654974656D7328297B72657475726E20746869732E5F6163746976654974656D737D736574206163746976654974';
wwv_flow_imp.g_varchar2_table(33353) := '656D732865297B746869732E5F6163746976654974656D733D652C746869732E6163746976654974656D73557064617465643D21302C746869732E75706461746528297D6765742073656C65637465644974656D7328297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(33354) := '5F73656C65637465644974656D737D7365742073656C65637465644974656D732865297B746869732E5F73656C65637465644974656D733D652C746869732E73656C65637465644974656D73557064617465643D21302C746869732E7570646174652829';
wwv_flow_imp.g_varchar2_table(33355) := '7D676574206B65794D6F647328297B72657475726E20746869732E5F717569636B4E617669676174653F78453A746869732E75692E6B65794D6F64737D6765742076616C756553656C656374696F6E28297B636F6E737420653D746869732E75692E696E';
wwv_flow_imp.g_varchar2_table(33356) := '707574426F782E67657453656C656374696F6E28293B696628652972657475726E5B652E73746172742C652E656E645D7D7365742076616C756553656C656374696F6E2865297B746869732E5F76616C756553656C656374696F6E3D652C746869732E76';
wwv_flow_imp.g_varchar2_table(33357) := '616C756553656C656374696F6E557064617465643D21302C746869732E75706461746528297D67657420637573746F6D427574746F6E28297B72657475726E20746869732E5F637573746F6D427574746F6E7D73657420637573746F6D427574746F6E28';
wwv_flow_imp.g_varchar2_table(33358) := '65297B746869732E5F637573746F6D427574746F6E3D652C746869732E75706461746528297D67657420637573746F6D4C6162656C28297B72657475726E20746869732E5F637573746F6D427574746F6E4C6162656C7D73657420637573746F6D4C6162';
wwv_flow_imp.g_varchar2_table(33359) := '656C2865297B746869732E5F637573746F6D427574746F6E4C6162656C3D652C746869732E75706461746528297D67657420637573746F6D486F76657228297B72657475726E20746869732E5F637573746F6D427574746F6E486F7665727D7365742063';
wwv_flow_imp.g_varchar2_table(33360) := '7573746F6D486F7665722865297B746869732E5F637573746F6D427574746F6E486F7665723D652C746869732E75706461746528297D676574206F6B28297B72657475726E20746869732E5F6F6B7D736574206F6B2865297B746869732E5F6F6B3D652C';
wwv_flow_imp.g_varchar2_table(33361) := '746869732E75706461746528297D6765742068696465496E70757428297B72657475726E2121746869732E5F68696465496E7075747D7365742068696465496E7075742865297B746869732E5F68696465496E7075743D652C746869732E757064617465';
wwv_flow_imp.g_varchar2_table(33362) := '28297D74727953656C656374466972737428297B746869732E63616E53656C6563744D616E797C7C746869732E75692E6C6973742E666F63757328246F652E4669727374297D73686F7728297B746869732E76697369626C657C7C28746869732E766973';
wwv_flow_imp.g_varchar2_table(33363) := '69626C65446973706F7361626C65732E61646428746869732E75692E696E707574426F782E6F6E4469644368616E67652828653D3E7B746869732E646F53657456616C756528652C2130297D2929292C746869732E76697369626C65446973706F736162';
wwv_flow_imp.g_varchar2_table(33364) := '6C65732E6164642828746869732E5F68696465496E7075743F746869732E75692E6C6973743A746869732E75692E696E707574426F78292E6F6E4B6579446F776E2828653D3E7B73776974636828652E6B6579436F6465297B636173652031383A766F69';
wwv_flow_imp.g_varchar2_table(33365) := '6420303D3D3D746869732E717569636B4E61766967617465262628713F652E6D6574614B65793A652E616C744B6579293F746869732E75692E6C6973742E666F63757328246F652E4E657874536570617261746F72293A746869732E75692E6C6973742E';
wwv_flow_imp.g_varchar2_table(33366) := '666F63757328246F652E4E657874292C746869732E63616E53656C6563744D616E792626746869732E75692E6C6973742E646F6D466F63757328292C637228652C2130293B627265616B3B636173652031363A766F696420303D3D3D746869732E717569';
wwv_flow_imp.g_varchar2_table(33367) := '636B4E61766967617465262628713F652E6D6574614B65793A652E616C744B6579293F746869732E75692E6C6973742E666F63757328246F652E50726576696F7573536570617261746F72293A746869732E75692E6C6973742E666F63757328246F652E';
wwv_flow_imp.g_varchar2_table(33368) := '50726576696F7573292C746869732E63616E53656C6563744D616E792626746869732E75692E6C6973742E646F6D466F63757328292C637228652C2130293B627265616B3B636173652031323A746869732E75692E6C6973742E666F63757328246F652E';
wwv_flow_imp.g_varchar2_table(33369) := '4E65787450616765292C746869732E63616E53656C6563744D616E792626746869732E75692E6C6973742E646F6D466F63757328292C637228652C2130293B627265616B3B636173652031313A746869732E75692E6C6973742E666F63757328246F652E';
wwv_flow_imp.g_varchar2_table(33370) := '50726576696F757350616765292C746869732E63616E53656C6563744D616E792626746869732E75692E6C6973742E646F6D466F63757328292C637228652C2130293B627265616B3B636173652031373A69662821746869732E5F63616E416363657074';
wwv_flow_imp.g_varchar2_table(33371) := '496E4261636B67726F756E642972657475726E3B69662821746869732E75692E696E707574426F782E697353656C656374696F6E4174456E6428292972657475726E3B746869732E6163746976654974656D735B305D262628746869732E5F73656C6563';
wwv_flow_imp.g_varchar2_table(33372) := '7465644974656D733D5B746869732E6163746976654974656D735B305D5D2C746869732E6F6E4469644368616E676553656C656374696F6E456D69747465722E6669726528746869732E73656C65637465644974656D73292C746869732E68616E646C65';
wwv_flow_imp.g_varchar2_table(33373) := '41636365707428213029293B627265616B3B636173652031343A21652E6374726C4B6579262621652E6D6574614B65797C7C652E73686966744B65797C7C652E616C744B65797C7C28746869732E75692E6C6973742E666F63757328246F652E46697273';
wwv_flow_imp.g_varchar2_table(33374) := '74292C637228652C213029293B627265616B3B636173652031333A21652E6374726C4B6579262621652E6D6574614B65797C7C652E73686966744B65797C7C652E616C744B65797C7C28746869732E75692E6C6973742E666F63757328246F652E4C6173';
wwv_flow_imp.g_varchar2_table(33375) := '74292C637228652C213029297D7D2929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6F6E446964416363657074282828293D3E7B746869732E63616E53656C6563744D616E793F746869732E75692E6C';
wwv_flow_imp.g_varchar2_table(33376) := '6973742E676574436865636B6564456C656D656E747328292E6C656E6774687C7C28746869732E5F73656C65637465644974656D733D5B5D2C746869732E6F6E4469644368616E676553656C656374696F6E456D69747465722E6669726528746869732E';
wwv_flow_imp.g_varchar2_table(33377) := '73656C65637465644974656D7329293A746869732E6163746976654974656D735B305D262628746869732E5F73656C65637465644974656D733D5B746869732E6163746976654974656D735B305D5D2C746869732E6F6E4469644368616E676553656C65';
wwv_flow_imp.g_varchar2_table(33378) := '6374696F6E456D69747465722E6669726528746869732E73656C65637465644974656D7329292C746869732E68616E646C65416363657074282131297D2929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E7569';
wwv_flow_imp.g_varchar2_table(33379) := '2E6F6E446964437573746F6D282828293D3E7B746869732E6F6E446964437573746F6D456D69747465722E6669726528297D2929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6C6973742E6F6E446964';
wwv_flow_imp.g_varchar2_table(33380) := '4368616E6765466F6375732828653D3E7B746869732E6163746976654974656D73557064617465647C7C746869732E6163746976654974656D73546F436F6E6669726D213D3D746869732E5F6163746976654974656D732626506828652C746869732E5F';
wwv_flow_imp.g_varchar2_table(33381) := '6163746976654974656D732C2828652C74293D3E653D3D3D7429297C7C28746869732E5F6163746976654974656D733D652C746869732E6F6E4469644368616E6765416374697665456D69747465722E66697265286529297D2929292C746869732E7669';
wwv_flow_imp.g_varchar2_table(33382) := '7369626C65446973706F7361626C65732E61646428746869732E75692E6C6973742E6F6E4469644368616E676553656C656374696F6E2828287B6974656D733A652C6576656E743A747D293D3E7B746869732E63616E53656C6563744D616E793F652E6C';
wwv_flow_imp.g_varchar2_table(33383) := '656E6774682626746869732E75692E6C6973742E73657453656C6563746564456C656D656E7473285B5D293A746869732E73656C65637465644974656D73546F436F6E6669726D213D3D746869732E5F73656C65637465644974656D732626506828652C';
wwv_flow_imp.g_varchar2_table(33384) := '746869732E5F73656C65637465644974656D732C2828652C74293D3E653D3D3D7429297C7C28746869732E5F73656C65637465644974656D733D652C746869732E6F6E4469644368616E676553656C656374696F6E456D69747465722E66697265286529';
wwv_flow_imp.g_varchar2_table(33385) := '2C652E6C656E6774682626746869732E68616E646C654163636570742873722874292626313D3D3D742E627574746F6E29297D2929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6C6973742E6F6E4368';
wwv_flow_imp.g_varchar2_table(33386) := '616E676564436865636B6564456C656D656E74732828653D3E7B746869732E63616E53656C6563744D616E79262628746869732E73656C65637465644974656D73546F436F6E6669726D213D3D746869732E5F73656C65637465644974656D7326265068';
wwv_flow_imp.g_varchar2_table(33387) := '28652C746869732E5F73656C65637465644974656D732C2828652C74293D3E653D3D3D7429297C7C28746869732E5F73656C65637465644974656D733D652C746869732E6F6E4469644368616E676553656C656374696F6E456D69747465722E66697265';
wwv_flow_imp.g_varchar2_table(33388) := '28652929297D2929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6C6973742E6F6E427574746F6E5472696767657265642828653D3E746869732E6F6E446964547269676765724974656D427574746F6E';
wwv_flow_imp.g_varchar2_table(33389) := '456D69747465722E666972652865292929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6C6973742E6F6E536570617261746F72427574746F6E5472696767657265642828653D3E746869732E6F6E4469';
wwv_flow_imp.g_varchar2_table(33390) := '6454726967676572536570617261746F72427574746F6E456D69747465722E666972652865292929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E7265676973746572517569636B4E617669676174696F6E2829';
wwv_flow_imp.g_varchar2_table(33391) := '292C746869732E76616C756553656C656374696F6E557064617465643D2130292C73757065722E73686F7728297D68616E646C654163636570742865297B6C657420743D21313B746869732E6F6E57696C6C416363657074456D69747465722E66697265';
wwv_flow_imp.g_varchar2_table(33392) := '287B7665746F3A28293D3E743D21307D292C747C7C746869732E6F6E446964416363657074456D69747465722E66697265287B696E4261636B67726F756E643A657D297D7265676973746572517569636B4E617669676174696F6E28297B72657475726E';
wwv_flow_imp.g_varchar2_table(33393) := '20627328746869732E75692E636F6E7461696E65722C61722E4B45595F55502C28653D3E7B696628746869732E63616E53656C6563744D616E797C7C21746869732E5F717569636B4E617669676174652972657475726E3B636F6E737420743D6E657720';
wwv_flow_imp.g_varchar2_table(33394) := '71652865292C6E3D742E6B6579436F64653B746869732E5F717569636B4E617669676174652E6B657962696E64696E67732E736F6D652828653D3E7B636F6E737420693D652E67657443686F72647328293B72657475726E2128692E6C656E6774683E31';
wwv_flow_imp.g_varchar2_table(33395) := '7C7C28695B305D2E73686966744B65792626343D3D3D6E3F742E6374726C4B65797C7C742E616C744B65797C7C742E6D6574614B65793A2128695B305D2E616C744B65792626363D3D3D6E7C7C695B305D2E6374726C4B65792626353D3D3D6E7C7C695B';
wwv_flow_imp.g_varchar2_table(33396) := '305D2E6D6574614B6579262635373D3D3D6E2929297D2929262628746869732E6163746976654974656D735B305D262628746869732E5F73656C65637465644974656D733D5B746869732E6163746976654974656D735B305D5D2C746869732E6F6E4469';
wwv_flow_imp.g_varchar2_table(33397) := '644368616E676553656C656374696F6E456D69747465722E6669726528746869732E73656C65637465644974656D73292C746869732E68616E646C6541636365707428213129292C746869732E5F717569636B4E617669676174653D766F69642030297D';
wwv_flow_imp.g_varchar2_table(33398) := '29297D75706461746528297B69662821746869732E76697369626C652972657475726E3B636F6E737420653D746869732E6B6565705363726F6C6C506F736974696F6E3F746869732E7363726F6C6C546F703A302C743D2121746869732E646573637269';
wwv_flow_imp.g_varchar2_table(33399) := '7074696F6E2C6E3D7B7469746C653A2121746869732E7469746C657C7C2121746869732E737465707C7C2121746869732E627574746F6E732E6C656E6774682C6465736372697074696F6E3A742C636865636B416C6C3A746869732E63616E53656C6563';
wwv_flow_imp.g_varchar2_table(33400) := '744D616E79262621746869732E5F68696465436865636B416C6C2C636865636B426F783A746869732E63616E53656C6563744D616E792C696E707574426F783A21746869732E5F68696465496E7075742C70726F67726573734261723A21746869732E5F';
wwv_flow_imp.g_varchar2_table(33401) := '68696465496E7075747C7C742C76697369626C65436F756E743A21302C636F756E743A746869732E63616E53656C6563744D616E79262621746869732E5F68696465436F756E7442616467652C6F6B3A2264656661756C74223D3D3D746869732E6F6B3F';
wwv_flow_imp.g_varchar2_table(33402) := '746869732E63616E53656C6563744D616E793A746869732E6F6B2C6C6973743A21302C6D6573736167653A2121746869732E76616C69646174696F6E4D6573736167652C637573746F6D427574746F6E3A746869732E637573746F6D427574746F6E7D3B';
wwv_flow_imp.g_varchar2_table(33403) := '746869732E75692E7365745669736962696C6974696573286E292C73757065722E75706461746528292C746869732E75692E696E707574426F782E76616C7565213D3D746869732E76616C7565262628746869732E75692E696E707574426F782E76616C';
wwv_flow_imp.g_varchar2_table(33404) := '75653D746869732E76616C7565292C746869732E76616C756553656C656374696F6E55706461746564262628746869732E76616C756553656C656374696F6E557064617465643D21312C746869732E75692E696E707574426F782E73656C656374287468';
wwv_flow_imp.g_varchar2_table(33405) := '69732E5F76616C756553656C656374696F6E26267B73746172743A746869732E5F76616C756553656C656374696F6E5B305D2C656E643A746869732E5F76616C756553656C656374696F6E5B315D7D29292C746869732E75692E696E707574426F782E70';
wwv_flow_imp.g_varchar2_table(33406) := '6C616365686F6C646572213D3D28746869732E706C616365686F6C6465727C7C222229262628746869732E75692E696E707574426F782E706C616365686F6C6465723D746869732E706C616365686F6C6465727C7C2222293B6C657420693D746869732E';
wwv_flow_imp.g_varchar2_table(33407) := '617269614C6162656C3B696628216926266E2E696E707574426F78262628693D746869732E706C616365686F6C6465727C7C7273652E44454641554C545F415249415F4C4142454C2C746869732E7469746C65262628692B3D60202D20247B746869732E';
wwv_flow_imp.g_varchar2_table(33408) := '7469746C657D6029292C746869732E75692E6C6973742E617269614C6162656C213D3D69262628746869732E75692E6C6973742E617269614C6162656C3D6E756C6C213D693F693A6E756C6C292C746869732E75692E6C6973742E6D617463684F6E4465';
wwv_flow_imp.g_varchar2_table(33409) := '736372697074696F6E3D746869732E6D617463684F6E4465736372697074696F6E2C746869732E75692E6C6973742E6D617463684F6E44657461696C3D746869732E6D617463684F6E44657461696C2C746869732E75692E6C6973742E6D617463684F6E';
wwv_flow_imp.g_varchar2_table(33410) := '4C6162656C3D746869732E6D617463684F6E4C6162656C2C746869732E75692E6C6973742E6D617463684F6E4C6162656C4D6F64653D746869732E6D617463684F6E4C6162656C4D6F64652C746869732E75692E6C6973742E736F727442794C6162656C';
wwv_flow_imp.g_varchar2_table(33411) := '3D746869732E736F727442794C6162656C2C746869732E6974656D7355706461746564297B746869732E6974656D73557064617465643D21313B636F6E737420653D746869732E5F6163746976654974656D733B73776974636828746869732E75692E6C';
wwv_flow_imp.g_varchar2_table(33412) := '6973742E736574456C656D656E747328746869732E6974656D73292C746869732E75692E6C6973742E66696C74657228746869732E66696C74657256616C756528746869732E75692E696E707574426F782E76616C756529292C746869732E75692E6368';
wwv_flow_imp.g_varchar2_table(33413) := '65636B416C6C2E636865636B65643D746869732E75692E6C6973742E676574416C6C56697369626C65436865636B656428292C746869732E75692E76697369626C65436F756E742E736574436F756E7428746869732E75692E6C6973742E676574566973';
wwv_flow_imp.g_varchar2_table(33414) := '69626C65436F756E742829292C746869732E75692E636F756E742E736574436F756E7428746869732E75692E6C6973742E676574436865636B6564436F756E742829292C746869732E5F6974656D41637469766174696F6E297B636173652045452E4E4F';
wwv_flow_imp.g_varchar2_table(33415) := '4E453A652E6C656E6774683E30262628746869732E5F6163746976654974656D733D5B5D2C746869732E6F6E4469644368616E6765416374697665456D69747465722E6669726528746869732E5F6163746976654974656D7329292C746869732E5F6974';
wwv_flow_imp.g_varchar2_table(33416) := '656D41637469766174696F6E3D45452E46495253543B627265616B3B636173652045452E5345434F4E443A746869732E75692E6C6973742E666F63757328246F652E5365636F6E64292C746869732E5F6974656D41637469766174696F6E3D45452E4649';
wwv_flow_imp.g_varchar2_table(33417) := '5253543B627265616B3B636173652045452E4C4153543A746869732E75692E6C6973742E666F63757328246F652E4C617374292C746869732E5F6974656D41637469766174696F6E3D45452E46495253543B627265616B3B64656661756C743A74686973';
wwv_flow_imp.g_varchar2_table(33418) := '2E74727953656C656374466972737428297D7D746869732E75692E636F6E7461696E65722E636C6173734C6973742E636F6E7461696E73282273686F772D636865636B626F7865732229213D3D2121746869732E63616E53656C6563744D616E79262628';
wwv_flow_imp.g_varchar2_table(33419) := '746869732E63616E53656C6563744D616E793F746869732E75692E6C6973742E636C656172466F63757328293A746869732E74727953656C65637446697273742829292C746869732E6163746976654974656D7355706461746564262628746869732E61';
wwv_flow_imp.g_varchar2_table(33420) := '63746976654974656D73557064617465643D21312C746869732E6163746976654974656D73546F436F6E6669726D3D746869732E5F6163746976654974656D732C746869732E75692E6C6973742E736574466F6375736564456C656D656E747328746869';
wwv_flow_imp.g_varchar2_table(33421) := '732E6163746976654974656D73292C746869732E6163746976654974656D73546F436F6E6669726D3D3D3D746869732E5F6163746976654974656D73262628746869732E6163746976654974656D73546F436F6E6669726D3D6E756C6C29292C74686973';
wwv_flow_imp.g_varchar2_table(33422) := '2E73656C65637465644974656D7355706461746564262628746869732E73656C65637465644974656D73557064617465643D21312C746869732E73656C65637465644974656D73546F436F6E6669726D3D746869732E5F73656C65637465644974656D73';
wwv_flow_imp.g_varchar2_table(33423) := '2C746869732E63616E53656C6563744D616E793F746869732E75692E6C6973742E736574436865636B6564456C656D656E747328746869732E73656C65637465644974656D73293A746869732E75692E6C6973742E73657453656C6563746564456C656D';
wwv_flow_imp.g_varchar2_table(33424) := '656E747328746869732E73656C65637465644974656D73292C746869732E73656C65637465644974656D73546F436F6E6669726D3D3D3D746869732E5F73656C65637465644974656D73262628746869732E73656C65637465644974656D73546F436F6E';
wwv_flow_imp.g_varchar2_table(33425) := '6669726D3D6E756C6C29292C746869732E75692E637573746F6D427574746F6E2E6C6162656C3D746869732E637573746F6D4C6162656C7C7C22222C746869732E75692E637573746F6D427574746F6E2E656C656D656E742E7469746C653D746869732E';
wwv_flow_imp.g_varchar2_table(33426) := '637573746F6D486F7665727C7C22222C6E2E696E707574426F787C7C28746869732E75692E6C6973742E646F6D466F63757328292C746869732E63616E53656C6563744D616E792626746869732E75692E6C6973742E666F63757328246F652E46697273';
wwv_flow_imp.g_varchar2_table(33427) := '7429292C746869732E6B6565705363726F6C6C506F736974696F6E262628746869732E7363726F6C6C546F703D65297D7D7273652E44454641554C545F415249415F4C4142454C3D6228302C225479706520746F206E6172726F7720646F776E20726573';
wwv_flow_imp.g_varchar2_table(33428) := '756C74732E22293B636C6173732061736520657874656E6473207373657B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E5F76616C75653D22222C746869732E76616C756553656C656374696F6E5570';
wwv_flow_imp.g_varchar2_table(33429) := '64617465643D21302C746869732E5F70617373776F72643D21312C746869732E6F6E44696456616C75654368616E6765456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964416363657074456D697474';
wwv_flow_imp.g_varchar2_table(33430) := '65723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E4469644368616E676556616C75653D746869732E6F6E44696456616C75654368616E6765456D69747465722E6576656E742C746869732E6F6E4469644163636570743D';
wwv_flow_imp.g_varchar2_table(33431) := '746869732E6F6E446964416363657074456D69747465722E6576656E747D6765742076616C756528297B72657475726E20746869732E5F76616C75657D7365742076616C75652865297B746869732E5F76616C75653D657C7C22222C746869732E757064';
wwv_flow_imp.g_varchar2_table(33432) := '61746528297D67657420706C616365686F6C64657228297B72657475726E20746869732E5F706C616365686F6C6465727D73657420706C616365686F6C6465722865297B746869732E5F706C616365686F6C6465723D652C746869732E75706461746528';
wwv_flow_imp.g_varchar2_table(33433) := '297D6765742070617373776F726428297B72657475726E20746869732E5F70617373776F72647D7365742070617373776F72642865297B746869732E5F70617373776F72643D652C746869732E75706461746528297D73686F7728297B746869732E7669';
wwv_flow_imp.g_varchar2_table(33434) := '7369626C657C7C28746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E696E707574426F782E6F6E4469644368616E67652828653D3E7B65213D3D746869732E76616C7565262628746869732E5F76616C75653D65';
wwv_flow_imp.g_varchar2_table(33435) := '2C746869732E6F6E44696456616C75654368616E6765456D69747465722E66697265286529297D2929292C746869732E76697369626C65446973706F7361626C65732E61646428746869732E75692E6F6E446964416363657074282828293D3E74686973';
wwv_flow_imp.g_varchar2_table(33436) := '2E6F6E446964416363657074456D69747465722E6669726528292929292C746869732E76616C756553656C656374696F6E557064617465643D2130292C73757065722E73686F7728297D75706461746528297B69662821746869732E76697369626C6529';
wwv_flow_imp.g_varchar2_table(33437) := '72657475726E3B746869732E75692E636F6E7461696E65722E636C6173734C6973742E72656D6F7665282268696464656E2D696E70757422293B636F6E737420653D7B7469746C653A2121746869732E7469746C657C7C2121746869732E737465707C7C';
wwv_flow_imp.g_varchar2_table(33438) := '2121746869732E627574746F6E732E6C656E6774682C6465736372697074696F6E3A2121746869732E6465736372697074696F6E7C7C2121746869732E737465702C696E707574426F783A21302C6D6573736167653A21302C70726F6772657373426172';
wwv_flow_imp.g_varchar2_table(33439) := '3A21307D3B746869732E75692E7365745669736962696C69746965732865292C73757065722E75706461746528292C746869732E75692E696E707574426F782E76616C7565213D3D746869732E76616C7565262628746869732E75692E696E707574426F';
wwv_flow_imp.g_varchar2_table(33440) := '782E76616C75653D746869732E76616C7565292C746869732E76616C756553656C656374696F6E55706461746564262628746869732E76616C756553656C656374696F6E557064617465643D21312C746869732E75692E696E707574426F782E73656C65';
wwv_flow_imp.g_varchar2_table(33441) := '637428746869732E5F76616C756553656C656374696F6E26267B73746172743A746869732E5F76616C756553656C656374696F6E5B305D2C656E643A746869732E5F76616C756553656C656374696F6E5B315D7D29292C746869732E75692E696E707574';
wwv_flow_imp.g_varchar2_table(33442) := '426F782E706C616365686F6C646572213D3D28746869732E706C616365686F6C6465727C7C222229262628746869732E75692E696E707574426F782E706C616365686F6C6465723D746869732E706C616365686F6C6465727C7C2222292C746869732E75';
wwv_flow_imp.g_varchar2_table(33443) := '692E696E707574426F782E70617373776F7264213D3D746869732E70617373776F7264262628746869732E75692E696E707574426F782E70617373776F72643D746869732E70617373776F7264297D7D6C6574206C73653D636C61737320657874656E64';
wwv_flow_imp.g_varchar2_table(33444) := '73204D717B636F6E7374727563746F7228652C74297B73757065722822656C656D656E74222C21312C28653D3E746869732E6765744F766572726964654F7074696F6E73286529292C652C74297D6765744F766572726964654F7074696F6E732865297B';
wwv_flow_imp.g_varchar2_table(33445) := '76617220743B72657475726E7B70657273697374656E63653A7B686964654F6E4B6579446F776E3A21317D2C617070656172616E63653A7B73686F77486F76657248696E743A28652E636F6E74656E7420696E7374616E63656F662048544D4C456C656D';
wwv_flow_imp.g_varchar2_table(33446) := '656E743F6E756C6C213D3D28743D652E636F6E74656E742E74657874436F6E74656E74292626766F69642030213D3D743F743A22223A22737472696E67223D3D747970656F6620652E636F6E74656E743F652E636F6E74656E743A652E636F6E74656E74';
wwv_flow_imp.g_varchar2_table(33447) := '2E76616C7565292E696E636C7564657328225C6E22292C736B697046616465496E416E696D6174696F6E3A21307D7D7D7D3B6C73653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D73';
wwv_flow_imp.g_varchar2_table(33448) := '3C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(33449) := '6F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C33';
wwv_flow_imp.g_varchar2_table(33450) := '3F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B69736528302C6670292C69736528312C4971295D2C';
wwv_flow_imp.g_varchar2_table(33451) := '6C7365293B766172206373653D6E2834393738292C6473653D7B7D3B6473652E7374796C655461675472616E73666F726D3D6A7228292C6473652E736574417474726962757465733D567228292C6473652E696E736572743D467228292E62696E64286E';
wwv_flow_imp.g_varchar2_table(33452) := '756C6C2C226865616422292C6473652E646F6D4150493D4F7228292C6473652E696E736572745374796C65456C656D656E743D487228292C4E722829286373652E412C647365292C6373652E4126266373652E412E6C6F63616C7326266373652E412E6C';
wwv_flow_imp.g_varchar2_table(33453) := '6F63616C733B636F6E7374206873653D22646F6E65222C7573653D22616374697665222C7073653D22696E66696E697465222C6773653D22696E66696E6974652D6C6F6E672D72756E6E696E67222C6D73653D226469736372657465223B636C61737320';
wwv_flow_imp.g_varchar2_table(33454) := '66736520657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E70726F67726573735369676E616C3D746869732E5F7265676973746572286E6577206374292C746869732E776F726B656456616C3D302C';
wwv_flow_imp.g_varchar2_table(33455) := '746869732E73686F7744656C617965645363686564756C65723D746869732E5F7265676973746572286E6577204B74282828293D3E5F7228746869732E656C656D656E7429292C3029292C746869732E6C6F6E6752756E6E696E675363686564756C6572';
wwv_flow_imp.g_varchar2_table(33456) := '3D746869732E5F7265676973746572286E6577204B74282828293D3E746869732E696E66696E6974654C6F6E6752756E6E696E672829292C6673652E4C4F4E475F52554E4E494E475F494E46494E4954455F5448524553484F4C4429292C746869732E63';
wwv_flow_imp.g_varchar2_table(33457) := '726561746528652C74297D63726561746528652C74297B746869732E656C656D656E743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E656C656D656E742E636C6173734C6973742E61646428226D6F6E61636F';
wwv_flow_imp.g_varchar2_table(33458) := '2D70726F67726573732D636F6E7461696E657222292C746869732E656C656D656E742E7365744174747269627574652822726F6C65222C2270726F677265737362617222292C746869732E656C656D656E742E7365744174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(33459) := '612D76616C75656D696E222C223022292C652E617070656E644368696C6428746869732E656C656D656E74292C746869732E6269743D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E6269742E636C6173734C69';
wwv_flow_imp.g_varchar2_table(33460) := '73742E616464282270726F67726573732D62697422292C746869732E6269742E7374796C652E6261636B67726F756E64436F6C6F723D286E756C6C3D3D743F766F696420303A742E70726F67726573734261724261636B67726F756E64297C7C22233045';
wwv_flow_imp.g_varchar2_table(33461) := '37304330222C746869732E656C656D656E742E617070656E644368696C6428746869732E626974297D6F666628297B746869732E6269742E7374796C652E77696474683D22696E6865726974222C746869732E6269742E7374796C652E6F706163697479';
wwv_flow_imp.g_varchar2_table(33462) := '3D2231222C746869732E656C656D656E742E636C6173734C6973742E72656D6F7665287573652C7073652C6773652C6D7365292C746869732E776F726B656456616C3D302C746869732E746F74616C576F726B3D766F696420302C746869732E6C6F6E67';
wwv_flow_imp.g_varchar2_table(33463) := '52756E6E696E675363686564756C65722E63616E63656C28292C746869732E70726F67726573735369676E616C2E636C65617228297D73746F7028297B72657475726E20746869732E646F446F6E65282131297D646F446F6E652865297B72657475726E';
wwv_flow_imp.g_varchar2_table(33464) := '20746869732E656C656D656E742E636C6173734C6973742E61646428687365292C746869732E656C656D656E742E636C6173734C6973742E636F6E7461696E7328707365293F28746869732E6269742E7374796C652E6F7061636974793D2230222C653F';
wwv_flow_imp.g_varchar2_table(33465) := '73657454696D656F7574282828293D3E746869732E6F66662829292C323030293A746869732E6F66662829293A28746869732E6269742E7374796C652E77696474683D22696E6865726974222C653F73657454696D656F7574282828293D3E746869732E';
wwv_flow_imp.g_varchar2_table(33466) := '6F66662829292C323030293A746869732E6F66662829292C746869737D696E66696E69746528297B72657475726E20746869732E6269742E7374796C652E77696474683D223225222C746869732E6269742E7374796C652E6F7061636974793D2231222C';
wwv_flow_imp.g_varchar2_table(33467) := '746869732E656C656D656E742E636C6173734C6973742E72656D6F7665286D73652C6873652C677365292C746869732E656C656D656E742E636C6173734C6973742E616464287573652C707365292C746869732E6C6F6E6752756E6E696E675363686564';
wwv_flow_imp.g_varchar2_table(33468) := '756C65722E7363686564756C6528292C746869737D696E66696E6974654C6F6E6752756E6E696E6728297B746869732E656C656D656E742E636C6173734C6973742E61646428677365297D676574436F6E7461696E657228297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(33469) := '732E656C656D656E747D7D6673652E4C4F4E475F52554E4E494E475F494E46494E4954455F5448524553484F4C443D3165343B636F6E7374207673653D62723B636C6173732062736520657874656E6473206C747B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(33470) := '2C6E297B737570657228292C746869732E706172656E743D652C746869732E6F6E4B6579446F776E3D653D3E797328746869732E66696E64496E7075742E696E707574426F782E696E707574456C656D656E742C61722E4B45595F444F574E2C65292C74';
wwv_flow_imp.g_varchar2_table(33471) := '6869732E6F6E4469644368616E67653D653D3E746869732E66696E64496E7075742E6F6E4469644368616E67652865292C746869732E636F6E7461696E65723D757228746869732E706172656E742C76736528222E717569636B2D696E7075742D626F78';
wwv_flow_imp.g_varchar2_table(33472) := '2229292C746869732E66696E64496E7075743D746869732E5F7265676973746572286E657720635528746869732E636F6E7461696E65722C766F696420302C7B6C6162656C3A22222C696E707574426F785374796C65733A742C746F67676C655374796C';
wwv_flow_imp.g_varchar2_table(33473) := '65733A6E7D29293B636F6E737420693D746869732E66696E64496E7075742E696E707574426F782E696E707574456C656D656E743B692E726F6C653D22636F6D626F626F78222C692E61726961486173506F7075703D226D656E75222C692E6172696141';
wwv_flow_imp.g_varchar2_table(33474) := '75746F436F6D706C6574653D226C697374222C692E61726961457870616E6465643D2274727565227D6765742076616C756528297B72657475726E20746869732E66696E64496E7075742E67657456616C756528297D7365742076616C75652865297B74';
wwv_flow_imp.g_varchar2_table(33475) := '6869732E66696E64496E7075742E73657456616C75652865297D73656C65637428653D6E756C6C297B746869732E66696E64496E7075742E696E707574426F782E73656C6563742865297D67657453656C656374696F6E28297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(33476) := '732E66696E64496E7075742E696E707574426F782E67657453656C656374696F6E28297D697353656C656374696F6E4174456E6428297B72657475726E20746869732E66696E64496E7075742E696E707574426F782E697353656C656374696F6E417445';
wwv_flow_imp.g_varchar2_table(33477) := '6E6428297D67657420706C616365686F6C64657228297B72657475726E20746869732E66696E64496E7075742E696E707574426F782E696E707574456C656D656E742E6765744174747269627574652822706C616365686F6C64657222297C7C22227D73';
wwv_flow_imp.g_varchar2_table(33478) := '657420706C616365686F6C6465722865297B746869732E66696E64496E7075742E696E707574426F782E736574506C616365486F6C6465722865297D6765742070617373776F726428297B72657475726E2270617373776F7264223D3D3D746869732E66';
wwv_flow_imp.g_varchar2_table(33479) := '696E64496E7075742E696E707574426F782E696E707574456C656D656E742E747970657D7365742070617373776F72642865297B746869732E66696E64496E7075742E696E707574426F782E696E707574456C656D656E742E747970653D653F22706173';
wwv_flow_imp.g_varchar2_table(33480) := '73776F7264223A2274657874227D73657420656E61626C65642865297B746869732E66696E64496E7075742E696E707574426F782E696E707574456C656D656E742E746F67676C654174747269627574652822726561646F6E6C79222C2165297D736574';
wwv_flow_imp.g_varchar2_table(33481) := '20746F67676C65732865297B746869732E66696E64496E7075742E7365744164646974696F6E616C546F67676C65732865297D73657441747472696275746528652C74297B746869732E66696E64496E7075742E696E707574426F782E696E707574456C';
wwv_flow_imp.g_varchar2_table(33482) := '656D656E742E73657441747472696275746528652C74297D73686F774465636F726174696F6E2865297B653D3D3D69442E49676E6F72653F746869732E66696E64496E7075742E636C6561724D65737361676528293A746869732E66696E64496E707574';
wwv_flow_imp.g_varchar2_table(33483) := '2E73686F774D657373616765287B747970653A653D3D3D69442E496E666F3F313A653D3D3D69442E5761726E696E673F323A332C636F6E74656E743A22227D297D7374796C6573466F72547970652865297B72657475726E20746869732E66696E64496E';
wwv_flow_imp.g_varchar2_table(33484) := '7075742E696E707574426F782E7374796C6573466F725479706528653D3D3D69442E496E666F3F313A653D3D3D69442E5761726E696E673F323A33297D736574466F63757328297B746869732E66696E64496E7075742E666F63757328297D6C61796F75';
wwv_flow_imp.g_varchar2_table(33485) := '7428297B746869732E66696E64496E7075742E696E707574426F782E6C61796F757428297D7D766172205F73652C7973653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636F6E73';
wwv_flow_imp.g_varchar2_table(33486) := '74207773653D62723B6C6574204373653D5F73653D636C61737320657874656E6473206C747B67657420636F6E7461696E657228297B72657475726E20746869732E5F636F6E7461696E65727D636F6E7374727563746F7228652C742C6E297B73757065';
wwv_flow_imp.g_varchar2_table(33487) := '7228292C746869732E6F7074696F6E733D652C746869732E6C61796F7574536572766963653D742C746869732E696E7374616E74696174696F6E536572766963653D6E2C746869732E656E61626C65643D21302C746869732E6F6E446964416363657074';
wwv_flow_imp.g_varchar2_table(33488) := '456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964437573746F6D456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E44696454726967676572427574746F';
wwv_flow_imp.g_varchar2_table(33489) := '6E456D69747465723D746869732E5F7265676973746572286E6577204374292C746869732E6B65794D6F64733D7B6374726C436D643A21312C616C743A21317D2C746869732E636F6E74726F6C6C65723D6E756C6C2C746869732E6F6E53686F77456D69';
wwv_flow_imp.g_varchar2_table(33490) := '747465723D746869732E5F7265676973746572286E6577204374292C746869732E6F6E53686F773D746869732E6F6E53686F77456D69747465722E6576656E742C746869732E6F6E48696465456D69747465723D746869732E5F7265676973746572286E';
wwv_flow_imp.g_varchar2_table(33491) := '6577204374292C746869732E6F6E486964653D746869732E6F6E48696465456D69747465722E6576656E742C746869732E69645072656669783D652E69645072656669782C746869732E5F636F6E7461696E65723D652E636F6E7461696E65722C746869';
wwv_flow_imp.g_varchar2_table(33492) := '732E7374796C65733D652E7374796C65732C746869732E5F72656769737465722876742E72756E416E645375627363726962652870732C28287B77696E646F773A652C646973706F7361626C65733A747D293D3E746869732E72656769737465724B6579';
wwv_flow_imp.g_varchar2_table(33493) := '4D6F64734C697374656E65727328652C7429292C7B77696E646F773A732C646973706F7361626C65733A746869732E5F73746F72657D29292C746869732E5F72656769737465722867732828653D3E7B746869732E75692626727328746869732E75692E';
wwv_flow_imp.g_varchar2_table(33494) := '636F6E7461696E6572293D3D3D65262628746869732E7265706172656E74554928746869732E6C61796F7574536572766963652E6D61696E436F6E7461696E6572292C746869732E6C61796F757428746869732E6C61796F7574536572766963652E6D61';
wwv_flow_imp.g_varchar2_table(33495) := '696E436F6E7461696E657244696D656E73696F6E2C746869732E6C61796F7574536572766963652E6D61696E436F6E7461696E65724F66667365742E717569636B5069636B546F7029297D2929297D72656769737465724B65794D6F64734C697374656E';
wwv_flow_imp.g_varchar2_table(33496) := '65727328652C74297B636F6E7374206E3D653D3E7B746869732E6B65794D6F64732E6374726C436D643D652E6374726C4B65797C7C652E6D6574614B65792C746869732E6B65794D6F64732E616C743D652E616C744B65797D3B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(33497) := '69206F665B61722E4B45595F444F574E2C61722E4B45595F55502C61722E4D4F5553455F444F574E5D29742E61646428627328652C692C6E2C213029297D67657455492865297B696628746869732E75692972657475726E20652626727328746869732E';
wwv_flow_imp.g_varchar2_table(33498) := '5F636F6E7461696E657229213D3D727328746869732E6C61796F7574536572766963652E616374697665436F6E7461696E657229262628746869732E7265706172656E74554928746869732E6C61796F7574536572766963652E616374697665436F6E74';
wwv_flow_imp.g_varchar2_table(33499) := '61696E6572292C746869732E6C61796F757428746869732E6C61796F7574536572766963652E616374697665436F6E7461696E657244696D656E73696F6E2C746869732E6C61796F7574536572766963652E616374697665436F6E7461696E65724F6666';
wwv_flow_imp.g_varchar2_table(33500) := '7365742E717569636B5069636B546F7029292C746869732E75693B636F6E737420743D757228746869732E5F636F6E7461696E65722C77736528222E717569636B2D696E7075742D7769646765742E73686F772D66696C652D69636F6E732229293B742E';
wwv_flow_imp.g_varchar2_table(33501) := '746162496E6465783D2D312C742E7374796C652E646973706C61793D226E6F6E65223B636F6E7374206E3D59732874292C693D757228742C77736528222E717569636B2D696E7075742D7469746C656261722229292C6F3D746869732E5F726567697374';
wwv_flow_imp.g_varchar2_table(33502) := '6572286E6577206C4D28692C7B686F76657244656C65676174653A746869732E6F7074696F6E732E686F76657244656C65676174657D29293B6F2E646F6D4E6F64652E636C6173734C6973742E6164642822717569636B2D696E7075742D6C6566742D61';
wwv_flow_imp.g_varchar2_table(33503) := '6374696F6E2D62617222293B636F6E737420733D757228692C77736528222E717569636B2D696E7075742D7469746C652229292C723D746869732E5F7265676973746572286E6577206C4D28692C7B686F76657244656C65676174653A746869732E6F70';
wwv_flow_imp.g_varchar2_table(33504) := '74696F6E732E686F76657244656C65676174657D29293B722E646F6D4E6F64652E636C6173734C6973742E6164642822717569636B2D696E7075742D72696768742D616374696F6E2D62617222293B636F6E737420613D757228742C77736528222E7175';
wwv_flow_imp.g_varchar2_table(33505) := '69636B2D696E7075742D6865616465722229292C6C3D757228612C7773652822696E7075742E717569636B2D696E7075742D636865636B2D616C6C2229293B6C2E747970653D22636865636B626F78222C6C2E7365744174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(33506) := '612D6C6162656C222C6228302C22546F67676C6520616C6C20636865636B626F7865732229292C746869732E5F7265676973746572287973286C2C61722E4348414E47452C28653D3E7B636F6E737420743D6C2E636865636B65643B4C2E736574416C6C';
wwv_flow_imp.g_varchar2_table(33507) := '56697369626C65436865636B65642874297D2929292C746869732E5F7265676973746572286273286C2C61722E434C49434B2C28653D3E7B28652E787C7C652E79292626752E736574466F63757328297D2929293B636F6E737420633D757228612C7773';
wwv_flow_imp.g_varchar2_table(33508) := '6528222E717569636B2D696E7075742D6465736372697074696F6E2229292C643D757228612C77736528222E717569636B2D696E7075742D616E642D6D6573736167652229292C683D757228642C77736528222E717569636B2D696E7075742D66696C74';
wwv_flow_imp.g_varchar2_table(33509) := '65722229292C753D746869732E5F7265676973746572286E65772062736528682C746869732E7374796C65732E696E707574426F782C746869732E7374796C65732E746F67676C6529293B752E7365744174747269627574652822617269612D64657363';
wwv_flow_imp.g_varchar2_table(33510) := '72696265646279222C60247B746869732E69645072656669787D6D65737361676560293B636F6E737420703D757228682C77736528222E717569636B2D696E7075742D76697369626C652D636F756E742229293B702E7365744174747269627574652822';
wwv_flow_imp.g_varchar2_table(33511) := '617269612D6C697665222C22706F6C69746522292C702E7365744174747269627574652822617269612D61746F6D6963222C227472756522293B636F6E737420673D6E657720564728702C7B636F756E74466F726D61743A6228302C227B307D20526573';
wwv_flow_imp.g_varchar2_table(33512) := '756C747322297D2C746869732E7374796C65732E636F756E744261646765292C6D3D757228682C77736528222E717569636B2D696E7075742D636F756E742229293B6D2E7365744174747269627574652822617269612D6C697665222C22706F6C697465';
wwv_flow_imp.g_varchar2_table(33513) := '22293B636F6E737420663D6E6577205647286D2C7B636F756E74466F726D61743A6228302C227B307D2053656C656374656422297D2C746869732E7374796C65732E636F756E744261646765292C763D757228612C77736528222E717569636B2D696E70';
wwv_flow_imp.g_varchar2_table(33514) := '75742D616374696F6E2229292C5F3D746869732E5F7265676973746572286E6577207A4528762C746869732E7374796C65732E627574746F6E29293B5F2E6C6162656C3D6228302C224F4B22292C746869732E5F7265676973746572285F2E6F6E446964';
wwv_flow_imp.g_varchar2_table(33515) := '436C69636B2828653D3E7B746869732E6F6E446964416363657074456D69747465722E6669726528297D2929293B636F6E737420793D757228612C77736528222E717569636B2D696E7075742D616374696F6E2229292C773D746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(33516) := '746572286E6577207A4528792C7B2E2E2E746869732E7374796C65732E627574746F6E2C737570706F727449636F6E733A21307D29293B772E6C6162656C3D6228302C22437573746F6D22292C746869732E5F726567697374657228772E6F6E44696443';
wwv_flow_imp.g_varchar2_table(33517) := '6C69636B2828653D3E7B746869732E6F6E446964437573746F6D456D69747465722E6669726528297D2929293B636F6E737420433D757228642C777365286023247B746869732E69645072656669787D6D6573736167652E717569636B2D696E7075742D';
wwv_flow_imp.g_varchar2_table(33518) := '6D6573736167656029292C533D746869732E5F7265676973746572286E65772066736528742C746869732E7374796C65732E70726F677265737342617229293B532E676574436F6E7461696E657228292E636C6173734C6973742E616464282271756963';
wwv_flow_imp.g_varchar2_table(33519) := '6B2D696E7075742D70726F677265737322293B636F6E737420783D757228742C77736528222E717569636B2D696E7075742D68746D6C2D7769646765742229293B782E746162496E6465783D2D313B636F6E7374206B3D757228742C77736528222E7175';
wwv_flow_imp.g_varchar2_table(33520) := '69636B2D696E7075742D6465736372697074696F6E2229292C453D746869732E69645072656669782B226C697374222C4C3D746869732E5F726567697374657228746869732E696E7374616E74696174696F6E536572766963652E637265617465496E73';
wwv_flow_imp.g_varchar2_table(33521) := '74616E6365287473652C742C746869732E6F7074696F6E732E686F76657244656C65676174652C746869732E6F7074696F6E732E6C696E6B4F70656E657244656C65676174652C4529293B752E7365744174747269627574652822617269612D636F6E74';
wwv_flow_imp.g_varchar2_table(33522) := '726F6C73222C45292C746869732E5F7265676973746572284C2E6F6E4469644368616E6765466F637573282828293D3E7B76617220653B752E7365744174747269627574652822617269612D61637469766564657363656E64616E74222C6E756C6C213D';
wwv_flow_imp.g_varchar2_table(33523) := '3D28653D4C2E67657441637469766544657363656E64616E742829292626766F69642030213D3D653F653A2222297D2929292C746869732E5F7265676973746572284C2E6F6E4368616E676564416C6C56697369626C65436865636B65642828653D3E7B';
wwv_flow_imp.g_varchar2_table(33524) := '6C2E636865636B65643D657D2929292C746869732E5F7265676973746572284C2E6F6E4368616E67656456697369626C65436F756E742828653D3E7B672E736574436F756E742865297D2929292C746869732E5F7265676973746572284C2E6F6E436861';
wwv_flow_imp.g_varchar2_table(33525) := '6E676564436865636B6564436F756E742828653D3E7B662E736574436F756E742865297D2929292C746869732E5F7265676973746572284C2E6F6E4C65617665282828293D3E7B73657454696D656F7574282828293D3E7B746869732E636F6E74726F6C';
wwv_flow_imp.g_varchar2_table(33526) := '6C6572262628752E736574466F63757328292C746869732E636F6E74726F6C6C657220696E7374616E63656F66207273652626746869732E636F6E74726F6C6C65722E63616E53656C6563744D616E7926264C2E636C656172466F6375732829297D292C';
wwv_flow_imp.g_varchar2_table(33527) := '30297D2929293B636F6E737420443D68722874293B72657475726E20746869732E5F72656769737465722844292C746869732E5F726567697374657228627328742C61722E464F4355532C28653D3E7B427328652E72656C617465645461726765742C74';
wwv_flow_imp.g_varchar2_table(33528) := '297C7C28746869732E70726576696F7573466F637573456C656D656E743D652E72656C6174656454617267657420696E7374616E63656F662048544D4C456C656D656E743F652E72656C617465645461726765743A766F69642030297D292C213029292C';
wwv_flow_imp.g_varchar2_table(33529) := '746869732E5F726567697374657228442E6F6E446964426C7572282828293D3E7B746869732E676574554928292E69676E6F7265466F6375734F75747C7C746869732E6F7074696F6E732E69676E6F7265466F6375734F757428297C7C746869732E6869';
wwv_flow_imp.g_varchar2_table(33530) := '6465286B452E426C7572292C746869732E70726576696F7573466F637573456C656D656E743D766F696420307D2929292C746869732E5F726567697374657228627328742C61722E464F4355532C28653D3E7B752E736574466F63757328297D2929292C';
wwv_flow_imp.g_varchar2_table(33531) := '746869732E5F726567697374657228797328742C61722E4B45595F444F574E2C28653D3E7B69662821427328652E7461726765742C78292973776974636828652E6B6579436F6465297B6361736520333A637228652C2130292C746869732E656E61626C';
wwv_flow_imp.g_varchar2_table(33532) := '65642626746869732E6F6E446964416363657074456D69747465722E6669726528293B627265616B3B6361736520393A637228652C2130292C746869732E68696465286B452E47657374757265293B627265616B3B6361736520323A69662821652E616C';
wwv_flow_imp.g_varchar2_table(33533) := '744B6579262621652E6374726C4B6579262621652E6D6574614B6579297B636F6E7374206E3D5B222E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D616374696F6E2D626172202E616C776179732D76697369626C65222C222E71756963';
wwv_flow_imp.g_varchar2_table(33534) := '6B2D696E7075742D6C6973742D656E7472793A686F766572202E6D6F6E61636F2D616374696F6E2D626172222C222E6D6F6E61636F2D6C6973742D726F772E666F6375736564202E6D6F6E61636F2D616374696F6E2D626172225D3B696628742E636C61';
wwv_flow_imp.g_varchar2_table(33535) := '73734C6973742E636F6E7461696E73282273686F772D636865636B626F78657322293F6E2E707573682822696E70757422293A6E2E707573682822696E7075745B747970653D746578745D22292C746869732E676574554928292E6C6973742E69734469';
wwv_flow_imp.g_varchar2_table(33536) := '73706C61796564282926266E2E7075736828222E6D6F6E61636F2D6C69737422292C746869732E676574554928292E6D65737361676526266E2E7075736828222E717569636B2D696E7075742D6D657373616765206122292C746869732E676574554928';
wwv_flow_imp.g_varchar2_table(33537) := '292E776964676574297B696628427328652E7461726765742C746869732E676574554928292E7769646765742929627265616B3B6E2E7075736828222E717569636B2D696E7075742D68746D6C2D77696467657422297D636F6E737420693D742E717565';
wwv_flow_imp.g_varchar2_table(33538) := '727953656C6563746F72416C6C286E2E6A6F696E28222C202229293B652E73686966744B65792626652E7461726765743D3D3D695B305D3F28637228652C2130292C4C2E636C656172466F6375732829293A21652E73686966744B65792626427328652E';
wwv_flow_imp.g_varchar2_table(33539) := '7461726765742C695B692E6C656E6774682D315D29262628637228652C2130292C695B305D2E666F6375732829297D627265616B3B636173652031303A652E6374726C4B6579262628637228652C2130292C746869732E676574554928292E6C6973742E';
wwv_flow_imp.g_varchar2_table(33540) := '746F67676C65486F7665722829297D7D2929292C746869732E75693D7B636F6E7461696E65723A742C7374796C6553686565743A6E2C6C656674416374696F6E4261723A6F2C7469746C654261723A692C7469746C653A732C6465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(33541) := '313A6B2C6465736372697074696F6E323A632C7769646765743A782C7269676874416374696F6E4261723A722C636865636B416C6C3A6C2C696E707574436F6E7461696E65723A642C66696C746572436F6E7461696E65723A682C696E707574426F783A';
wwv_flow_imp.g_varchar2_table(33542) := '752C76697369626C65436F756E74436F6E7461696E65723A702C76697369626C65436F756E743A672C636F756E74436F6E7461696E65723A6D2C636F756E743A662C6F6B436F6E7461696E65723A762C6F6B3A5F2C6D6573736167653A432C637573746F';
wwv_flow_imp.g_varchar2_table(33543) := '6D427574746F6E436F6E7461696E65723A792C637573746F6D427574746F6E3A772C6C6973743A4C2C70726F67726573734261723A532C6F6E4469644163636570743A746869732E6F6E446964416363657074456D69747465722E6576656E742C6F6E44';
wwv_flow_imp.g_varchar2_table(33544) := '6964437573746F6D3A746869732E6F6E446964437573746F6D456D69747465722E6576656E742C6F6E44696454726967676572427574746F6E3A746869732E6F6E44696454726967676572427574746F6E456D69747465722E6576656E742C69676E6F72';
wwv_flow_imp.g_varchar2_table(33545) := '65466F6375734F75743A21312C6B65794D6F64733A746869732E6B65794D6F64732C73686F773A653D3E746869732E73686F772865292C686964653A28293D3E746869732E6869646528292C7365745669736962696C69746965733A653D3E746869732E';
wwv_flow_imp.g_varchar2_table(33546) := '7365745669736962696C69746965732865292C736574456E61626C65643A653D3E746869732E736574456E61626C65642865292C736574436F6E746578744B65793A653D3E746869732E6F7074696F6E732E736574436F6E746578744B65792865292C6C';
wwv_flow_imp.g_varchar2_table(33547) := '696E6B4F70656E657244656C65676174653A653D3E746869732E6F7074696F6E732E6C696E6B4F70656E657244656C65676174652865297D2C746869732E7570646174655374796C657328292C746869732E75697D7265706172656E7455492865297B74';
wwv_flow_imp.g_varchar2_table(33548) := '6869732E7569262628746869732E5F636F6E7461696E65723D652C757228746869732E5F636F6E7461696E65722C746869732E75692E636F6E7461696E657229297D7069636B28652C743D7B7D2C6E3D4D742E4E6F6E65297B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(33549) := '50726F6D697365282828692C6F293D3E7B6C657420733D653D3E7B766172206E3B733D692C6E756C6C3D3D3D286E3D742E6F6E4B65794D6F6473297C7C766F696420303D3D3D6E7C7C6E2E63616C6C28742C722E6B65794D6F6473292C692865297D3B69';
wwv_flow_imp.g_varchar2_table(33550) := '66286E2E697343616E63656C6C6174696F6E5265717565737465642972657475726E20766F6964207328766F69642030293B636F6E737420723D746869732E637265617465517569636B5069636B28293B6C657420613B636F6E7374206C3D5B722C722E';
wwv_flow_imp.g_varchar2_table(33551) := '6F6E446964416363657074282828293D3E7B696628722E63616E53656C6563744D616E79297328722E73656C65637465644974656D732E736C6963652829292C722E6869646528293B656C73657B636F6E737420653D722E6163746976654974656D735B';
wwv_flow_imp.g_varchar2_table(33552) := '305D3B65262628732865292C722E686964652829297D7D29292C722E6F6E4469644368616E67654163746976652828653D3E7B636F6E7374206E3D655B305D3B6E2626742E6F6E446964466F6375732626742E6F6E446964466F637573286E297D29292C';
wwv_flow_imp.g_varchar2_table(33553) := '722E6F6E4469644368616E676553656C656374696F6E2828653D3E7B69662821722E63616E53656C6563744D616E79297B636F6E737420743D655B305D3B74262628732874292C722E686964652829297D7D29292C722E6F6E4469645472696767657249';
wwv_flow_imp.g_varchar2_table(33554) := '74656D427574746F6E2828653D3E742E6F6E446964547269676765724974656D427574746F6E2626742E6F6E446964547269676765724974656D427574746F6E287B2E2E2E652C72656D6F76654974656D3A28293D3E7B636F6E737420743D722E697465';
wwv_flow_imp.g_varchar2_table(33555) := '6D732E696E6465784F6628652E6974656D293B6966282D31213D3D74297B636F6E737420653D722E6974656D732E736C69636528292C6E3D652E73706C69636528742C31292C693D722E6163746976654974656D732E66696C7465722828653D3E65213D';
wwv_flow_imp.g_varchar2_table(33556) := '3D6E5B305D29292C6F3D722E6B6565705363726F6C6C506F736974696F6E3B722E6B6565705363726F6C6C506F736974696F6E3D21302C722E6974656D733D652C69262628722E6163746976654974656D733D69292C722E6B6565705363726F6C6C506F';
wwv_flow_imp.g_varchar2_table(33557) := '736974696F6E3D6F7D7D7D2929292C722E6F6E44696454726967676572536570617261746F72427574746F6E2828653D3E7B766172206E3B72657475726E206E756C6C3D3D3D286E3D742E6F6E44696454726967676572536570617261746F7242757474';
wwv_flow_imp.g_varchar2_table(33558) := '6F6E297C7C766F696420303D3D3D6E3F766F696420303A6E2E63616C6C28742C65297D29292C722E6F6E4469644368616E676556616C75652828653D3E7B21617C7C657C7C313D3D3D722E6163746976654974656D732E6C656E6774682626722E616374';
wwv_flow_imp.g_varchar2_table(33559) := '6976654974656D735B305D3D3D3D617C7C28722E6163746976654974656D733D5B615D297D29292C6E2E6F6E43616E63656C6C6174696F6E526571756573746564282828293D3E7B722E6869646528297D29292C722E6F6E44696448696465282828293D';
wwv_flow_imp.g_varchar2_table(33560) := '3E7B6F74286C292C7328766F69642030297D29295D3B722E7469746C653D742E7469746C652C722E63616E53656C6563744D616E793D2121742E63616E5069636B4D616E792C722E706C616365686F6C6465723D742E706C616365486F6C6465722C722E';
wwv_flow_imp.g_varchar2_table(33561) := '69676E6F7265466F6375734F75743D2121742E69676E6F7265466F6375734C6F73742C722E6D617463684F6E4465736372697074696F6E3D2121742E6D617463684F6E4465736372697074696F6E2C722E6D617463684F6E44657461696C3D2121742E6D';
wwv_flow_imp.g_varchar2_table(33562) := '617463684F6E44657461696C2C722E6D617463684F6E4C6162656C3D766F696420303D3D3D742E6D617463684F6E4C6162656C7C7C742E6D617463684F6E4C6162656C2C722E717569636B4E617669676174653D742E717569636B4E617669676174652C';
wwv_flow_imp.g_varchar2_table(33563) := '722E68696465496E7075743D2121742E68696465496E7075742C722E636F6E746578744B65793D742E636F6E746578744B65792C722E627573793D21302C50726F6D6973652E616C6C285B652C742E6163746976654974656D5D292E7468656E2828285B';
wwv_flow_imp.g_varchar2_table(33564) := '652C745D293D3E7B613D742C722E627573793D21312C722E6974656D733D652C722E63616E53656C6563744D616E79262628722E73656C65637465644974656D733D652E66696C7465722828653D3E22736570617261746F7222213D3D652E7479706526';
wwv_flow_imp.g_varchar2_table(33565) := '26652E7069636B65642929292C61262628722E6163746976654974656D733D5B615D297D29292C722E73686F7728292C50726F6D6973652E7265736F6C76652865292E7468656E28766F696420302C28653D3E7B6F2865292C722E6869646528297D2929';
wwv_flow_imp.g_varchar2_table(33566) := '7D29297D637265617465517569636B5069636B28297B636F6E737420653D746869732E6765745549282130293B72657475726E206E6577207273652865297D637265617465496E707574426F7828297B636F6E737420653D746869732E67657455492821';
wwv_flow_imp.g_varchar2_table(33567) := '30293B72657475726E206E6577206173652865297D73686F772865297B636F6E737420743D746869732E6765745549282130293B746869732E6F6E53686F77456D69747465722E6669726528293B636F6E7374206E3D746869732E636F6E74726F6C6C65';
wwv_flow_imp.g_varchar2_table(33568) := '723B746869732E636F6E74726F6C6C65723D652C6E756C6C3D3D6E7C7C6E2E6469644869646528292C746869732E736574456E61626C6564282130292C742E6C656674416374696F6E4261722E636C65617228292C742E7469746C652E74657874436F6E';
wwv_flow_imp.g_varchar2_table(33569) := '74656E743D22222C742E6465736372697074696F6E312E74657874436F6E74656E743D22222C742E6465736372697074696F6E322E74657874436F6E74656E743D22222C677228742E776964676574292C742E7269676874416374696F6E4261722E636C';
wwv_flow_imp.g_varchar2_table(33570) := '65617228292C742E636865636B416C6C2E636865636B65643D21312C742E696E707574426F782E706C616365686F6C6465723D22222C742E696E707574426F782E70617373776F72643D21312C742E696E707574426F782E73686F774465636F72617469';
wwv_flow_imp.g_varchar2_table(33571) := '6F6E2869442E49676E6F7265292C742E76697369626C65436F756E742E736574436F756E742830292C742E636F756E742E736574436F756E742830292C677228742E6D657373616765292C742E70726F67726573734261722E73746F7028292C742E6C69';
wwv_flow_imp.g_varchar2_table(33572) := '73742E736574456C656D656E7473285B5D292C742E6C6973742E6D617463684F6E4465736372697074696F6E3D21312C742E6C6973742E6D617463684F6E44657461696C3D21312C742E6C6973742E6D617463684F6E4C6162656C3D21302C742E6C6973';
wwv_flow_imp.g_varchar2_table(33573) := '742E736F727442794C6162656C3D21302C742E69676E6F7265466F6375734F75743D21312C742E696E707574426F782E746F67676C65733D766F696420303B636F6E737420693D746869732E6F7074696F6E732E6261636B4B657962696E64696E674C61';
wwv_flow_imp.g_varchar2_table(33574) := '62656C28293B6F73652E746F6F6C7469703D693F6228302C224261636B20287B307D29222C69293A6228302C224261636B22292C742E636F6E7461696E65722E7374796C652E646973706C61793D22222C746869732E7570646174654C61796F75742829';
wwv_flow_imp.g_varchar2_table(33575) := '2C742E696E707574426F782E736574466F63757328297D697356697369626C6528297B72657475726E2121746869732E75692626226E6F6E6522213D3D746869732E75692E636F6E7461696E65722E7374796C652E646973706C61797D73657456697369';
wwv_flow_imp.g_varchar2_table(33576) := '62696C69746965732865297B636F6E737420743D746869732E676574554928293B742E7469746C652E7374796C652E646973706C61793D652E7469746C653F22223A226E6F6E65222C742E6465736372697074696F6E312E7374796C652E646973706C61';
wwv_flow_imp.g_varchar2_table(33577) := '793D652E6465736372697074696F6E262628652E696E707574426F787C7C652E636865636B416C6C293F22223A226E6F6E65222C742E6465736372697074696F6E322E7374796C652E646973706C61793D21652E6465736372697074696F6E7C7C652E69';
wwv_flow_imp.g_varchar2_table(33578) := '6E707574426F787C7C652E636865636B416C6C3F226E6F6E65223A22222C742E636865636B416C6C2E7374796C652E646973706C61793D652E636865636B416C6C3F22223A226E6F6E65222C742E696E707574436F6E7461696E65722E7374796C652E64';
wwv_flow_imp.g_varchar2_table(33579) := '6973706C61793D652E696E707574426F783F22223A226E6F6E65222C742E66696C746572436F6E7461696E65722E7374796C652E646973706C61793D652E696E707574426F783F22223A226E6F6E65222C742E76697369626C65436F756E74436F6E7461';
wwv_flow_imp.g_varchar2_table(33580) := '696E65722E7374796C652E646973706C61793D652E76697369626C65436F756E743F22223A226E6F6E65222C742E636F756E74436F6E7461696E65722E7374796C652E646973706C61793D652E636F756E743F22223A226E6F6E65222C742E6F6B436F6E';
wwv_flow_imp.g_varchar2_table(33581) := '7461696E65722E7374796C652E646973706C61793D652E6F6B3F22223A226E6F6E65222C742E637573746F6D427574746F6E436F6E7461696E65722E7374796C652E646973706C61793D652E637573746F6D427574746F6E3F22223A226E6F6E65222C74';
wwv_flow_imp.g_varchar2_table(33582) := '2E6D6573736167652E7374796C652E646973706C61793D652E6D6573736167653F22223A226E6F6E65222C742E70726F67726573734261722E676574436F6E7461696E657228292E7374796C652E646973706C61793D652E70726F67726573734261723F';
wwv_flow_imp.g_varchar2_table(33583) := '22223A226E6F6E65222C742E6C6973742E646973706C6179282121652E6C697374292C742E636F6E7461696E65722E636C6173734C6973742E746F67676C65282273686F772D636865636B626F786573222C2121652E636865636B426F78292C742E636F';
wwv_flow_imp.g_varchar2_table(33584) := '6E7461696E65722E636C6173734C6973742E746F67676C65282268696464656E2D696E707574222C21652E696E707574426F78262621652E6465736372697074696F6E292C746869732E7570646174654C61796F757428297D736574456E61626C656428';
wwv_flow_imp.g_varchar2_table(33585) := '65297B69662865213D3D746869732E656E61626C6564297B746869732E656E61626C65643D653B666F7228636F6E73742074206F6620746869732E676574554928292E6C656674416374696F6E4261722E766965774974656D7329742E616374696F6E2E';
wwv_flow_imp.g_varchar2_table(33586) := '656E61626C65643D653B666F7228636F6E73742074206F6620746869732E676574554928292E7269676874416374696F6E4261722E766965774974656D7329742E616374696F6E2E656E61626C65643D653B746869732E676574554928292E636865636B';
wwv_flow_imp.g_varchar2_table(33587) := '416C6C2E64697361626C65643D21652C746869732E676574554928292E696E707574426F782E656E61626C65643D652C746869732E676574554928292E6F6B2E656E61626C65643D652C746869732E676574554928292E6C6973742E656E61626C65643D';
wwv_flow_imp.g_varchar2_table(33588) := '657D7D686964652865297B76617220742C6E3B636F6E737420693D746869732E636F6E74726F6C6C65723B69662821692972657475726E3B692E77696C6C486964652865293B636F6E7374206F3D6E756C6C3D3D3D28743D746869732E7569297C7C766F';
wwv_flow_imp.g_varchar2_table(33589) := '696420303D3D3D743F766F696420303A742E636F6E7461696E65722C733D6F2626212473286F293B696628746869732E636F6E74726F6C6C65723D6E756C6C2C746869732E6F6E48696465456D69747465722E6669726528292C6F2626286F2E7374796C';
wwv_flow_imp.g_varchar2_table(33590) := '652E646973706C61793D226E6F6E6522292C2173297B6C657420653D746869732E70726576696F7573466F637573456C656D656E743B666F72283B65262621652E6F6666736574506172656E743B29653D6E756C6C213D3D286E3D652E706172656E7445';
wwv_flow_imp.g_varchar2_table(33591) := '6C656D656E74292626766F69642030213D3D6E3F6E3A766F696420303B286E756C6C3D3D653F766F696420303A652E6F6666736574506172656E74293F28652E666F63757328292C746869732E70726576696F7573466F637573456C656D656E743D766F';
wwv_flow_imp.g_varchar2_table(33592) := '69642030293A746869732E6F7074696F6E732E72657475726E466F63757328297D692E646964486964652865297D6C61796F757428652C74297B746869732E64696D656E73696F6E3D652C746869732E7469746C654261724F66667365743D742C746869';
wwv_flow_imp.g_varchar2_table(33593) := '732E7570646174654C61796F757428297D7570646174654C61796F757428297B696628746869732E75692626746869732E697356697369626C652829297B746869732E75692E636F6E7461696E65722E7374796C652E746F703D60247B746869732E7469';
wwv_flow_imp.g_varchar2_table(33594) := '746C654261724F66667365747D7078603B636F6E737420653D746869732E75692E636F6E7461696E65722E7374796C652C743D4D6174682E6D696E282E36322A746869732E64696D656E73696F6E2E77696474682C5F73652E4D41585F5749445448293B';
wwv_flow_imp.g_varchar2_table(33595) := '652E77696474683D742B227078222C652E6D617267696E4C6566743D222D222B742F322B227078222C746869732E75692E696E707574426F782E6C61796F757428292C746869732E75692E6C6973742E6C61796F757428746869732E64696D656E73696F';
wwv_flow_imp.g_varchar2_table(33596) := '6E26262E342A746869732E64696D656E73696F6E2E686569676874297D7D6170706C795374796C65732865297B746869732E7374796C65733D652C746869732E7570646174655374796C657328297D7570646174655374796C657328297B696628746869';
wwv_flow_imp.g_varchar2_table(33597) := '732E7569297B636F6E73747B717569636B496E7075745469746C654261636B67726F756E643A652C717569636B496E7075744261636B67726F756E643A742C717569636B496E707574466F726567726F756E643A6E2C776964676574426F726465723A69';
wwv_flow_imp.g_varchar2_table(33598) := '2C776964676574536861646F773A6F7D3D746869732E7374796C65732E7769646765743B746869732E75692E7469746C654261722E7374796C652E6261636B67726F756E64436F6C6F723D6E756C6C213D653F653A22222C746869732E75692E636F6E74';
wwv_flow_imp.g_varchar2_table(33599) := '61696E65722E7374796C652E6261636B67726F756E64436F6C6F723D6E756C6C213D743F743A22222C746869732E75692E636F6E7461696E65722E7374796C652E636F6C6F723D6E756C6C213D6E3F6E3A22222C746869732E75692E636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(33600) := '722E7374796C652E626F726465723D693F6031707820736F6C696420247B697D603A22222C746869732E75692E636F6E7461696E65722E7374796C652E626F78536861646F773D6F3F60302030203870782032707820247B6F7D603A22222C746869732E';
wwv_flow_imp.g_varchar2_table(33601) := '75692E6C6973742E7374796C6528746869732E7374796C65732E6C697374293B636F6E737420733D5B5D3B746869732E7374796C65732E7069636B657247726F75702E7069636B657247726F7570426F726465722626732E7075736828602E717569636B';
wwv_flow_imp.g_varchar2_table(33602) := '2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D656E747279207B20626F726465722D746F702D636F6C6F723A2020247B746869732E7374796C65732E7069636B657247726F75702E7069636B657247726F7570426F72646572';
wwv_flow_imp.g_varchar2_table(33603) := '7D3B207D60292C746869732E7374796C65732E7069636B657247726F75702E7069636B657247726F7570466F726567726F756E642626732E7075736828602E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D7365';
wwv_flow_imp.g_varchar2_table(33604) := '70617261746F72207B20636F6C6F723A2020247B746869732E7374796C65732E7069636B657247726F75702E7069636B657247726F7570466F726567726F756E647D3B207D60292C746869732E7374796C65732E7069636B657247726F75702E7069636B';
wwv_flow_imp.g_varchar2_table(33605) := '657247726F7570466F726567726F756E642626732E7075736828222E717569636B2D696E7075742D6C697374202E717569636B2D696E7075742D6C6973742D736570617261746F722D61732D6974656D207B20636F6C6F723A20766172282D2D7673636F';
wwv_flow_imp.g_varchar2_table(33606) := '64652D6465736372697074696F6E466F726567726F756E64293B207D22292C28746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C4261636B67726F756E647C7C746869732E7374796C65732E6B';
wwv_flow_imp.g_varchar2_table(33607) := '657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C426F726465727C7C746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C426F74746F6D426F726465727C7C746869732E';
wwv_flow_imp.g_varchar2_table(33608) := '7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C536861646F777C7C746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C466F726567726F756E6429';
wwv_flow_imp.g_varchar2_table(33609) := '262628732E7075736828222E717569636B2D696E7075742D6C697374202E6D6F6E61636F2D6B657962696E64696E67203E202E6D6F6E61636F2D6B657962696E64696E672D6B6579207B22292C746869732E7374796C65732E6B657962696E64696E674C';
wwv_flow_imp.g_varchar2_table(33610) := '6162656C2E6B657962696E64696E674C6162656C4261636B67726F756E642626732E7075736828606261636B67726F756E642D636F6C6F723A20247B746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C61';
wwv_flow_imp.g_varchar2_table(33611) := '62656C4261636B67726F756E647D3B60292C746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C426F726465722626732E707573682860626F726465722D636F6C6F723A20247B746869732E7374';
wwv_flow_imp.g_varchar2_table(33612) := '796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C426F726465727D3B60292C746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C426F74746F6D426F7264';
wwv_flow_imp.g_varchar2_table(33613) := '65722626732E707573682860626F726465722D626F74746F6D2D636F6C6F723A20247B746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C426F74746F6D426F726465727D3B60292C746869732E';
wwv_flow_imp.g_varchar2_table(33614) := '7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C536861646F772626732E707573682860626F782D736861646F773A20696E7365742030202D317078203020247B746869732E7374796C65732E6B65796269';
wwv_flow_imp.g_varchar2_table(33615) := '6E64696E674C6162656C2E6B657962696E64696E674C6162656C536861646F777D3B60292C746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C466F726567726F756E642626732E707573682860';
wwv_flow_imp.g_varchar2_table(33616) := '636F6C6F723A20247B746869732E7374796C65732E6B657962696E64696E674C6162656C2E6B657962696E64696E674C6162656C466F726567726F756E647D3B60292C732E7075736828227D2229293B636F6E737420723D732E6A6F696E28225C6E2229';
wwv_flow_imp.g_varchar2_table(33617) := '3B72213D3D746869732E75692E7374796C6553686565742E74657874436F6E74656E74262628746869732E75692E7374796C6553686565742E74657874436F6E74656E743D72297D7D7D3B4373652E4D41585F57494454483D3630302C4373653D5F7365';
wwv_flow_imp.g_varchar2_table(33618) := '3D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A';
wwv_flow_imp.g_varchar2_table(33619) := '693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520';
wwv_flow_imp.g_varchar2_table(33620) := '666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E';
wwv_flow_imp.g_varchar2_table(33621) := '646566696E6550726F706572747928742C6E2C72292C727D285B79736528312C506E65292C79736528322C7563295D2C437365293B766172205373653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C';
wwv_flow_imp.g_varchar2_table(33622) := '692C65297D7D3B6C6574207873653D636C61737320657874656E6473207A627B67657420636F6E74726F6C6C657228297B72657475726E20746869732E5F636F6E74726F6C6C65727C7C28746869732E5F636F6E74726F6C6C65723D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(33623) := '67697374657228746869732E637265617465436F6E74726F6C6C6572282929292C746869732E5F636F6E74726F6C6C65727D67657420686173436F6E74726F6C6C657228297B72657475726E2121746869732E5F636F6E74726F6C6C65727D6765742071';
wwv_flow_imp.g_varchar2_table(33624) := '7569636B41636365737328297B72657475726E20746869732E5F717569636B4163636573737C7C28746869732E5F717569636B4163636573733D746869732E5F726567697374657228746869732E696E7374616E74696174696F6E536572766963652E63';
wwv_flow_imp.g_varchar2_table(33625) := '7265617465496E7374616E636528416F652929292C746869732E5F717569636B4163636573737D636F6E7374727563746F7228652C742C6E2C692C6F297B7375706572286E292C746869732E696E7374616E74696174696F6E536572766963653D652C74';
wwv_flow_imp.g_varchar2_table(33626) := '6869732E636F6E746578744B6579536572766963653D742C746869732E6C61796F7574536572766963653D692C746869732E636F6E66696775726174696F6E536572766963653D6F2C746869732E5F6F6E53686F773D746869732E5F7265676973746572';
wwv_flow_imp.g_varchar2_table(33627) := '286E6577204374292C746869732E5F6F6E486964653D746869732E5F7265676973746572286E6577204374292C746869732E636F6E74657874733D6E6577204D61707D637265617465436F6E74726F6C6C657228653D746869732E6C61796F7574536572';
wwv_flow_imp.g_varchar2_table(33628) := '766963652C74297B636F6E7374206E3D7B69645072656669783A22717569636B496E7075745F222C636F6E7461696E65723A652E616374697665436F6E7461696E65722C69676E6F7265466F6375734F75743A28293D3E21312C6261636B4B657962696E';
wwv_flow_imp.g_varchar2_table(33629) := '64696E674C6162656C3A28293D3E7B7D2C736574436F6E746578744B65793A653D3E746869732E736574436F6E746578744B65792865292C6C696E6B4F70656E657244656C65676174653A653D3E7B746869732E696E7374616E74696174696F6E536572';
wwv_flow_imp.g_varchar2_table(33630) := '766963652E696E766F6B6546756E6374696F6E2828743D3E7B742E676574286445292E6F70656E28652C7B616C6C6F77436F6D6D616E64733A21302C66726F6D55736572476573747572653A21307D297D29297D2C72657475726E466F6375733A28293D';
wwv_flow_imp.g_varchar2_table(33631) := '3E652E666F63757328292C7374796C65733A746869732E636F6D707574655374796C657328292C686F76657244656C65676174653A746869732E5F726567697374657228746869732E696E7374616E74696174696F6E536572766963652E637265617465';
wwv_flow_imp.g_varchar2_table(33632) := '496E7374616E6365286C736529297D2C693D746869732E5F726567697374657228746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365284373652C7B2E2E2E6E2C2E2E2E747D29293B72657475726E2069';
wwv_flow_imp.g_varchar2_table(33633) := '2E6C61796F757428652E616374697665436F6E7461696E657244696D656E73696F6E2C652E616374697665436F6E7461696E65724F66667365742E717569636B5069636B546F70292C746869732E5F726567697374657228652E6F6E4469644C61796F75';
wwv_flow_imp.g_varchar2_table(33634) := '74416374697665436F6E7461696E65722828743D3E7B727328652E616374697665436F6E7461696E6572293D3D3D727328692E636F6E7461696E6572292626692E6C61796F757428742C652E616374697665436F6E7461696E65724F66667365742E7175';
wwv_flow_imp.g_varchar2_table(33635) := '69636B5069636B546F70297D2929292C746869732E5F726567697374657228652E6F6E4469644368616E6765416374697665436F6E7461696E6572282828293D3E7B692E697356697369626C6528297C7C692E6C61796F757428652E616374697665436F';
wwv_flow_imp.g_varchar2_table(33636) := '6E7461696E657244696D656E73696F6E2C652E616374697665436F6E7461696E65724F66667365742E717569636B5069636B546F70297D2929292C746869732E5F726567697374657228692E6F6E53686F77282828293D3E7B746869732E726573657443';
wwv_flow_imp.g_varchar2_table(33637) := '6F6E746578744B65797328292C746869732E5F6F6E53686F772E6669726528297D2929292C746869732E5F726567697374657228692E6F6E48696465282828293D3E7B746869732E7265736574436F6E746578744B65797328292C746869732E5F6F6E48';
wwv_flow_imp.g_varchar2_table(33638) := '6964652E6669726528297D2929292C697D736574436F6E746578744B65792865297B6C657420743B65262628743D746869732E636F6E74657874732E6765742865292C747C7C28743D6E6577206C6428652C2131292E62696E64546F28746869732E636F';
wwv_flow_imp.g_varchar2_table(33639) := '6E746578744B657953657276696365292C746869732E636F6E74657874732E73657428652C742929292C742626742E67657428297C7C28746869732E7265736574436F6E746578744B65797328292C6E756C6C3D3D747C7C742E73657428213029297D72';
wwv_flow_imp.g_varchar2_table(33640) := '65736574436F6E746578744B65797328297B746869732E636F6E74657874732E666F72456163682828653D3E7B652E67657428292626652E726573657428297D29297D7069636B28652C743D7B7D2C6E3D4D742E4E6F6E65297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(33641) := '732E636F6E74726F6C6C65722E7069636B28652C742C6E297D637265617465517569636B5069636B28297B72657475726E20746869732E636F6E74726F6C6C65722E637265617465517569636B5069636B28297D637265617465496E707574426F782829';
wwv_flow_imp.g_varchar2_table(33642) := '7B72657475726E20746869732E636F6E74726F6C6C65722E637265617465496E707574426F7828297D7570646174655374796C657328297B746869732E686173436F6E74726F6C6C65722626746869732E636F6E74726F6C6C65722E6170706C79537479';
wwv_flow_imp.g_varchar2_table(33643) := '6C657328746869732E636F6D707574655374796C65732829297D636F6D707574655374796C657328297B72657475726E7B7769646765743A7B717569636B496E7075744261636B67726F756E643A786D284362292C717569636B496E707574466F726567';
wwv_flow_imp.g_varchar2_table(33644) := '726F756E643A786D285362292C717569636B496E7075745469746C654261636B67726F756E643A786D287862292C776964676574426F726465723A786D285066292C776964676574536861646F773A786D284E66297D2C696E707574426F783A454D2C74';
wwv_flow_imp.g_varchar2_table(33645) := '6F67676C653A6B4D2C636F756E7442616467653A444D2C627574746F6E3A534D2C70726F67726573734261723A784D2C6B657962696E64696E674C6162656C3A434D2C6C6973743A494D287B6C6973744261636B67726F756E643A43622C6C697374466F';
wwv_flow_imp.g_varchar2_table(33646) := '6375734261636B67726F756E643A49622C6C697374466F637573466F726567726F756E643A44622C6C697374496E616374697665466F637573466F726567726F756E643A44622C6C697374496E61637469766553656C656374696F6E49636F6E466F7265';
wwv_flow_imp.g_varchar2_table(33647) := '67726F756E643A54622C6C697374496E616374697665466F6375734261636B67726F756E643A49622C6C697374466F6375734F75746C696E653A486D2C6C697374496E616374697665466F6375734F75746C696E653A486D7D292C7069636B657247726F';
wwv_flow_imp.g_varchar2_table(33648) := '75703A7B7069636B657247726F7570426F726465723A786D284562292C7069636B657247726F7570466F726567726F756E643A786D286B62297D7D7D7D3B7873653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74';
wwv_flow_imp.g_varchar2_table(33649) := '732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E';
wwv_flow_imp.g_varchar2_table(33650) := '6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B';
wwv_flow_imp.g_varchar2_table(33651) := '615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B53736528302C756329';
wwv_flow_imp.g_varchar2_table(33652) := '2C53736528312C6364292C53736528322C5062292C53736528332C506E65292C53736528342C6670295D2C787365293B766172206B73653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C72';
wwv_flow_imp.g_varchar2_table(33653) := '3D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D7479';
wwv_flow_imp.g_varchar2_table(33654) := '70656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D2873';
wwv_flow_imp.g_varchar2_table(33655) := '3C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C4573653D66756E6374696F6E28652C74297B7265';
wwv_flow_imp.g_varchar2_table(33656) := '7475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204C73653D636C61737320657874656E6473207873657B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228742C6E2C692C6E657720426E65';
wwv_flow_imp.g_varchar2_table(33657) := '28652E676574436F6E7461696E6572446F6D4E6F646528292C6F292C73292C746869732E686F73743D766F696420303B636F6E737420723D5473652E6765742865293B69662872297B636F6E737420743D722E7769646765743B746869732E686F73743D';
wwv_flow_imp.g_varchar2_table(33658) := '7B5F736572766963654272616E643A766F696420302C676574206D61696E436F6E7461696E657228297B72657475726E20742E676574446F6D4E6F646528297D2C676574436F6E7461696E65723A28293D3E742E676574446F6D4E6F646528292C776865';
wwv_flow_imp.g_varchar2_table(33659) := '6E436F6E7461696E65725374796C65734C6F6164656428297B7D2C67657420636F6E7461696E65727328297B72657475726E5B742E676574446F6D4E6F646528295D7D2C67657420616374697665436F6E7461696E657228297B72657475726E20742E67';
wwv_flow_imp.g_varchar2_table(33660) := '6574446F6D4E6F646528297D2C676574206D61696E436F6E7461696E657244696D656E73696F6E28297B72657475726E20652E6765744C61796F7574496E666F28297D2C67657420616374697665436F6E7461696E657244696D656E73696F6E28297B72';
wwv_flow_imp.g_varchar2_table(33661) := '657475726E20652E6765744C61796F7574496E666F28297D2C676574206F6E4469644C61796F75744D61696E436F6E7461696E657228297B72657475726E20652E6F6E4469644C61796F75744368616E67657D2C676574206F6E4469644C61796F757441';
wwv_flow_imp.g_varchar2_table(33662) := '6374697665436F6E7461696E657228297B72657475726E20652E6F6E4469644C61796F75744368616E67657D2C676574206F6E4469644C61796F7574436F6E7461696E657228297B72657475726E2076742E6D617028652E6F6E4469644C61796F757443';
wwv_flow_imp.g_varchar2_table(33663) := '68616E67652C28653D3E287B636F6E7461696E65723A742E676574446F6D4E6F646528292C64696D656E73696F6E3A657D2929297D2C676574206F6E4469644368616E6765416374697665436F6E7461696E657228297B72657475726E2076742E4E6F6E';
wwv_flow_imp.g_varchar2_table(33664) := '657D2C676574206F6E446964416464436F6E7461696E657228297B72657475726E2076742E4E6F6E657D2C676574206D61696E436F6E7461696E65724F666673657428297B72657475726E7B746F703A302C717569636B5069636B546F703A307D7D2C67';
wwv_flow_imp.g_varchar2_table(33665) := '657420616374697665436F6E7461696E65724F666673657428297B72657475726E7B746F703A302C717569636B5069636B546F703A307D7D2C666F6375733A28293D3E652E666F63757328297D7D656C736520746869732E686F73743D766F696420307D';
wwv_flow_imp.g_varchar2_table(33666) := '637265617465436F6E74726F6C6C657228297B72657475726E2073757065722E637265617465436F6E74726F6C6C657228746869732E686F7374297D7D3B4C73653D6B7365285B45736528312C7563292C45736528322C6364292C45736528332C506229';
wwv_flow_imp.g_varchar2_table(33667) := '2C45736528342C6763292C45736528352C6670295D2C4C7365293B6C6574204473653D636C6173737B676574206163746976655365727669636528297B636F6E737420653D746869732E636F6465456469746F72536572766963652E676574466F637573';
wwv_flow_imp.g_varchar2_table(33668) := '6564436F6465456469746F7228293B6966282165297468726F77206E6577204572726F722822517569636B20696E7075742073657276696365206E65656473206120666F637573656420656469746F7220746F20776F726B2E22293B6C657420743D7468';
wwv_flow_imp.g_varchar2_table(33669) := '69732E6D6170456469746F72546F536572766963652E6765742865293B6966282174297B636F6E7374206E3D743D746869732E696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365284C73652C65293B746869732E6D';
wwv_flow_imp.g_varchar2_table(33670) := '6170456469746F72546F536572766963652E73657428652C74292C596528652E6F6E446964446973706F736529282828293D3E7B6E2E646973706F736528292C746869732E6D6170456469746F72546F536572766963652E64656C6574652865297D2929';
wwv_flow_imp.g_varchar2_table(33671) := '7D72657475726E20747D67657420717569636B41636365737328297B72657475726E20746869732E616374697665536572766963652E717569636B4163636573737D636F6E7374727563746F7228652C74297B746869732E696E7374616E74696174696F';
wwv_flow_imp.g_varchar2_table(33672) := '6E536572766963653D652C746869732E636F6465456469746F72536572766963653D742C746869732E6D6170456469746F72546F536572766963653D6E6577204D61707D7069636B28652C743D7B7D2C6E3D4D742E4E6F6E65297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(33673) := '69732E616374697665536572766963652E7069636B28652C742C6E297D637265617465517569636B5069636B28297B72657475726E20746869732E616374697665536572766963652E637265617465517569636B5069636B28297D637265617465496E70';
wwv_flow_imp.g_varchar2_table(33674) := '7574426F7828297B72657475726E20746869732E616374697665536572766963652E637265617465496E707574426F7828297D7D3B4473653D6B7365285B45736528302C7563292C45736528312C6763295D2C447365293B636C617373205473657B7374';
wwv_flow_imp.g_varchar2_table(33675) := '61746963206765742865297B72657475726E20652E676574436F6E747269627574696F6E285473652E4944297D636F6E7374727563746F722865297B746869732E656469746F723D652C746869732E7769646765743D6E65772049736528746869732E65';
wwv_flow_imp.g_varchar2_table(33676) := '6469746F72297D646973706F736528297B746869732E7769646765742E646973706F736528297D7D5473652E49443D22656469746F722E636F6E74726F6C6C65722E717569636B496E707574223B636C617373204973657B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(33677) := '65297B746869732E636F6465456469746F723D652C746869732E646F6D4E6F64653D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E636F6465456469746F722E6164644F7665726C617957696467657428746869';
wwv_flow_imp.g_varchar2_table(33678) := '73297D676574496428297B72657475726E204973652E49447D676574446F6D4E6F646528297B72657475726E20746869732E646F6D4E6F64657D676574506F736974696F6E28297B72657475726E7B707265666572656E63653A327D7D646973706F7365';
wwv_flow_imp.g_varchar2_table(33679) := '28297B746869732E636F6465456469746F722E72656D6F76654F7665726C61795769646765742874686973297D7D4973652E49443D22656469746F722E636F6E747269622E717569636B496E707574576964676574222C4A64285473652E49442C547365';
wwv_flow_imp.g_varchar2_table(33680) := '2C34293B766172204D73653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204173653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E';
wwv_flow_imp.g_varchar2_table(33681) := '297B737570657228292C746869732E5F636F6E746578744B6579536572766963653D652C746869732E5F6C61796F7574536572766963653D742C746869732E5F636F6E66696775726174696F6E536572766963653D6E2C746869732E5F61636365737369';
wwv_flow_imp.g_varchar2_table(33682) := '62696C697479537570706F72743D302C746869732E5F6F6E4469644368616E676553637265656E5265616465724F7074696D697A65643D6E65772043742C746869732E5F6F6E4469644368616E6765526564756365644D6F74696F6E3D6E65772043742C';
wwv_flow_imp.g_varchar2_table(33683) := '746869732E5F6163636573736962696C6974794D6F6465456E61626C6564436F6E746578743D5A532E62696E64546F28746869732E5F636F6E746578744B657953657276696365293B636F6E737420693D28293D3E746869732E5F616363657373696269';
wwv_flow_imp.g_varchar2_table(33684) := '6C6974794D6F6465456E61626C6564436F6E746578742E73657428746869732E697353637265656E5265616465724F7074696D697A65642829293B746869732E5F726567697374657228746869732E5F636F6E66696775726174696F6E53657276696365';
wwv_flow_imp.g_varchar2_table(33685) := '2E6F6E4469644368616E6765436F6E66696775726174696F6E2828653D3E7B652E61666665637473436F6E66696775726174696F6E2822656469746F722E6163636573736962696C697479537570706F727422292626286928292C746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(33686) := '69644368616E676553637265656E5265616465724F7074696D697A65642E666972652829292C652E61666665637473436F6E66696775726174696F6E2822776F726B62656E63682E7265647563654D6F74696F6E2229262628746869732E5F636F6E6669';
wwv_flow_imp.g_varchar2_table(33687) := '674D6F74696F6E526564756365643D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822776F726B62656E63682E7265647563654D6F74696F6E22292C746869732E5F6F6E4469644368616E6765526564756365';
wwv_flow_imp.g_varchar2_table(33688) := '644D6F74696F6E2E666972652829297D2929292C6928292C746869732E5F726567697374657228746869732E6F6E4469644368616E676553637265656E5265616465724F7074696D697A6564282828293D3E6928292929293B636F6E7374206F3D732E6D';
wwv_flow_imp.g_varchar2_table(33689) := '617463684D65646961282228707265666572732D726564756365642D6D6F74696F6E3A207265647563652922293B746869732E5F73797374656D4D6F74696F6E526564756365643D6F2E6D6174636865732C746869732E5F636F6E6669674D6F74696F6E';
wwv_flow_imp.g_varchar2_table(33690) := '526564756365643D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822776F726B62656E63682E7265647563654D6F74696F6E22292C746869732E696E6974526564756365644D6F74696F6E4C697374656E6572';
wwv_flow_imp.g_varchar2_table(33691) := '73286F297D696E6974526564756365644D6F74696F6E4C697374656E6572732865297B746869732E5F726567697374657228627328652C226368616E6765222C2828293D3E7B746869732E5F73797374656D4D6F74696F6E526564756365643D652E6D61';
wwv_flow_imp.g_varchar2_table(33692) := '74636865732C226175746F223D3D3D746869732E5F636F6E6669674D6F74696F6E526564756365642626746869732E5F6F6E4469644368616E6765526564756365644D6F74696F6E2E6669726528297D2929293B636F6E737420743D28293D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(33693) := '737420653D746869732E69734D6F74696F6E5265647563656428293B746869732E5F6C61796F7574536572766963652E6D61696E436F6E7461696E65722E636C6173734C6973742E746F67676C6528227265647563652D6D6F74696F6E222C65292C7468';
wwv_flow_imp.g_varchar2_table(33694) := '69732E5F6C61796F7574536572766963652E6D61696E436F6E7461696E65722E636C6173734C6973742E746F67676C652822656E61626C652D6D6F74696F6E222C2165297D3B7428292C746869732E5F726567697374657228746869732E6F6E44696443';
wwv_flow_imp.g_varchar2_table(33695) := '68616E6765526564756365644D6F74696F6E282828293D3E7428292929297D676574206F6E4469644368616E676553637265656E5265616465724F7074696D697A656428297B72657475726E20746869732E5F6F6E4469644368616E676553637265656E';
wwv_flow_imp.g_varchar2_table(33696) := '5265616465724F7074696D697A65642E6576656E747D697353637265656E5265616465724F7074696D697A656428297B636F6E737420653D746869732E5F636F6E66696775726174696F6E536572766963652E67657456616C75652822656469746F722E';
wwv_flow_imp.g_varchar2_table(33697) := '6163636573736962696C697479537570706F727422293B72657475726E226F6E223D3D3D657C7C226175746F223D3D3D652626323D3D3D746869732E5F6163636573736962696C697479537570706F72747D676574206F6E4469644368616E6765526564';
wwv_flow_imp.g_varchar2_table(33698) := '756365644D6F74696F6E28297B72657475726E20746869732E5F6F6E4469644368616E6765526564756365644D6F74696F6E2E6576656E747D69734D6F74696F6E5265647563656428297B636F6E737420653D746869732E5F636F6E6669674D6F74696F';
wwv_flow_imp.g_varchar2_table(33699) := '6E526564756365643B72657475726E226F6E223D3D3D657C7C226175746F223D3D3D652626746869732E5F73797374656D4D6F74696F6E526564756365647D6765744163636573736962696C697479537570706F727428297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(33700) := '2E5F6163636573736962696C697479537570706F72747D7D3B4173653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765';
wwv_flow_imp.g_varchar2_table(33701) := '744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D526566';
wwv_flow_imp.g_varchar2_table(33702) := '6C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29';
wwv_flow_imp.g_varchar2_table(33703) := '297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B4D736528302C6364292C4D736528312C506E65292C4D736528322C6670295D2C417365293B766172204E73652C50';
wwv_flow_imp.g_varchar2_table(33704) := '73653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B6C6574204F73653D4E73653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C74297B7375706572';
wwv_flow_imp.g_varchar2_table(33705) := '28292C746869732E6C61796F7574536572766963653D652C746869732E6C6F67536572766963653D742C746869732E6D617054657874546F547970653D6E6577204D61702C746869732E66696E64546578743D22222C746869732E7265736F7572636573';
wwv_flow_imp.g_varchar2_table(33706) := '3D5B5D2C746869732E7265736F75726365735374617465486173683D766F696420302C28757C7C70292626746869732E696E7374616C6C5765624B6974577269746554657874576F726B61726F756E6428292C746869732E5F7265676973746572287674';
wwv_flow_imp.g_varchar2_table(33707) := '2E72756E416E645375627363726962652870732C28287B77696E646F773A652C646973706F7361626C65733A747D293D3E7B742E61646428627328652E646F63756D656E742C22636F7079222C2828293D3E746869732E636C6561725265736F75726365';
wwv_flow_imp.g_varchar2_table(33708) := '7328292929297D292C7B77696E646F773A732C646973706F7361626C65733A746869732E5F73746F72657D29297D696E7374616C6C5765624B6974577269746554657874576F726B61726F756E6428297B636F6E737420653D28293D3E7B636F6E737420';
wwv_flow_imp.g_varchar2_table(33709) := '653D6E65772058743B746869732E7765624B697450656E64696E67436C6970626F617264577269746550726F6D697365262621746869732E7765624B697450656E64696E67436C6970626F617264577269746550726F6D6973652E6973536574746C6564';
wwv_flow_imp.g_varchar2_table(33710) := '2626746869732E7765624B697450656E64696E67436C6970626F617264577269746550726F6D6973652E63616E63656C28292C746869732E7765624B697450656E64696E67436C6970626F617264577269746550726F6D6973653D652C6E617669676174';
wwv_flow_imp.g_varchar2_table(33711) := '6F722E636C6970626F6172642E7772697465285B6E657720436C6970626F6172644974656D287B22746578742F706C61696E223A652E707D295D292E636174636828286173796E6320743D3E7B7420696E7374616E63656F66204572726F722626224E6F';
wwv_flow_imp.g_varchar2_table(33712) := '74416C6C6F7765644572726F72223D3D3D742E6E616D652626652E697352656A65637465647C7C746869732E6C6F67536572766963652E6572726F722874297D29297D3B746869732E5F72656769737465722876742E72756E416E645375627363726962';
wwv_flow_imp.g_varchar2_table(33713) := '6528746869732E6C61796F7574536572766963652E6F6E446964416464436F6E7461696E65722C28287B636F6E7461696E65723A742C646973706F7361626C65733A6E7D293D3E7B6E2E61646428627328742C22636C69636B222C6529292C6E2E616464';
wwv_flow_imp.g_varchar2_table(33714) := '28627328742C226B6579646F776E222C6529297D292C7B636F6E7461696E65723A746869732E6C61796F7574536572766963652E6D61696E436F6E7461696E65722C646973706F7361626C65733A746869732E5F73746F72657D29297D6173796E632077';
wwv_flow_imp.g_varchar2_table(33715) := '726974655465787428652C74297B696628746869732E77726974655265736F7572636573285B5D292C7429746869732E6D617054657874546F547970652E73657428742C65293B656C73657B696628746869732E7765624B697450656E64696E67436C69';
wwv_flow_imp.g_varchar2_table(33716) := '70626F617264577269746550726F6D6973652972657475726E20746869732E7765624B697450656E64696E67436C6970626F617264577269746550726F6D6973652E636F6D706C6574652865293B7472797B72657475726E206177616974206E61766967';
wwv_flow_imp.g_varchar2_table(33717) := '61746F722E636C6970626F6172642E7772697465546578742865297D63617463682865297B636F6E736F6C652E6572726F722865297D746869732E66616C6C6261636B5772697465546578742865297D7D66616C6C6261636B5772697465546578742865';
wwv_flow_imp.g_varchar2_table(33718) := '297B636F6E737420743D557328292C6E3D742E616374697665456C656D656E742C693D742E626F64792E617070656E644368696C6428627228227465787461726561222C7B22617269612D68696464656E223A21307D29293B692E7374796C652E686569';
wwv_flow_imp.g_varchar2_table(33719) := '6768743D22317078222C692E7374796C652E77696474683D22317078222C692E7374796C652E706F736974696F6E3D226162736F6C757465222C692E76616C75653D652C692E666F63757328292C692E73656C65637428292C742E65786563436F6D6D61';
wwv_flow_imp.g_varchar2_table(33720) := '6E642822636F707922292C6E20696E7374616E63656F662048544D4C456C656D656E7426266E2E666F63757328292C742E626F64792E72656D6F76654368696C642869297D6173796E632072656164546578742865297B696628652972657475726E2074';
wwv_flow_imp.g_varchar2_table(33721) := '6869732E6D617054657874546F547970652E6765742865297C7C22223B7472797B72657475726E206177616974206E6176696761746F722E636C6970626F6172642E726561645465787428297D63617463682865297B636F6E736F6C652E6572726F7228';
wwv_flow_imp.g_varchar2_table(33722) := '65297D72657475726E22227D6173796E63207265616446696E645465787428297B72657475726E20746869732E66696E64546578747D6173796E6320777269746546696E64546578742865297B746869732E66696E64546578743D657D6173796E632077';
wwv_flow_imp.g_varchar2_table(33723) := '726974655265736F75726365732865297B303D3D3D652E6C656E6774683F746869732E636C6561725265736F757263657328293A28746869732E7265736F75726365733D652C746869732E7265736F75726365735374617465486173683D617761697420';
wwv_flow_imp.g_varchar2_table(33724) := '746869732E636F6D707574655265736F75726365735374617465486173682829297D6173796E6320726561645265736F757263657328297B636F6E737420653D617761697420746869732E636F6D707574655265736F7572636573537461746548617368';
wwv_flow_imp.g_varchar2_table(33725) := '28293B72657475726E20746869732E7265736F7572636573537461746548617368213D3D652626746869732E636C6561725265736F757263657328292C746869732E7265736F75726365737D6173796E6320636F6D707574655265736F75726365735374';
wwv_flow_imp.g_varchar2_table(33726) := '6174654861736828297B69662830213D3D746869732E7265736F75726365732E6C656E6774682972657475726E205A6F2828617761697420746869732E72656164546578742829292E737562737472696E6728302C4E73652E4D41585F5245534F555243';
wwv_flow_imp.g_varchar2_table(33727) := '455F53544154455F534F555243455F4C454E47544829297D636C6561725265736F757263657328297B746869732E7265736F75726365733D5B5D2C746869732E7265736F75726365735374617465486173683D766F696420307D7D3B4F73652E4D41585F';
wwv_flow_imp.g_varchar2_table(33728) := '5245534F555243455F53544154455F534F555243455F4C454E4754483D3165332C4F73653D4E73653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D69';
wwv_flow_imp.g_varchar2_table(33729) := '3F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465';
wwv_flow_imp.g_varchar2_table(33730) := '636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F2874';
wwv_flow_imp.g_varchar2_table(33731) := '2C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B50736528302C506E65292C50736528312C5264295D2C4F7365293B636F6E73742052';
wwv_flow_imp.g_varchar2_table(33732) := '73653D22646174612D6B657962696E64696E672D636F6E74657874223B636C617373204673657B636F6E7374727563746F7228652C74297B746869732E5F69643D652C746869732E5F706172656E743D742C746869732E5F76616C75653D4F626A656374';
wwv_flow_imp.g_varchar2_table(33733) := '2E637265617465286E756C6C292C746869732E5F76616C75652E5F636F6E7465787449643D657D6765742076616C756528297B72657475726E7B2E2E2E746869732E5F76616C75657D7D73657456616C756528652C74297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(33734) := '5F76616C75655B655D213D3D74262628746869732E5F76616C75655B655D3D742C2130297D72656D6F766556616C75652865297B72657475726E206520696E20746869732E5F76616C756526262864656C65746520746869732E5F76616C75655B655D2C';
wwv_flow_imp.g_varchar2_table(33735) := '2130297D67657456616C75652865297B636F6E737420743D746869732E5F76616C75655B655D3B72657475726E20766F696420303D3D3D742626746869732E5F706172656E743F746869732E5F706172656E742E67657456616C75652865293A747D7D63';
wwv_flow_imp.g_varchar2_table(33736) := '6C6173732042736520657874656E6473204673657B636F6E7374727563746F7228297B7375706572282D312C6E756C6C297D73657456616C756528652C74297B72657475726E21317D72656D6F766556616C75652865297B72657475726E21317D676574';
wwv_flow_imp.g_varchar2_table(33737) := '56616C75652865297B7D7D4273652E494E5354414E43453D6E6577204273653B636C6173732056736520657874656E6473204673657B636F6E7374727563746F7228652C742C6E297B737570657228652C6E756C6C292C746869732E5F636F6E66696775';
wwv_flow_imp.g_varchar2_table(33738) := '726174696F6E536572766963653D742C746869732E5F76616C7565733D49782E666F72436F6E6669674B65797328292C746869732E5F6C697374656E65723D746869732E5F636F6E66696775726174696F6E536572766963652E6F6E4469644368616E67';
wwv_flow_imp.g_varchar2_table(33739) := '65436F6E66696775726174696F6E2828653D3E7B696628373D3D3D652E736F75726365297B636F6E737420653D41727261792E66726F6D28746869732E5F76616C7565732C28285B655D293D3E6529293B746869732E5F76616C7565732E636C65617228';
wwv_flow_imp.g_varchar2_table(33740) := '292C6E2E66697265286E657720577365286529297D656C73657B636F6E737420743D5B5D3B666F7228636F6E7374206E206F6620652E61666665637465644B657973297B636F6E737420653D60636F6E6669672E247B6E7D602C693D746869732E5F7661';
wwv_flow_imp.g_varchar2_table(33741) := '6C7565732E66696E6453757065727374722865293B766F69642030213D3D69262628742E70757368282E2E2E5A652E6D617028692C28285B655D293D3E652929292C746869732E5F76616C7565732E64656C6574655375706572737472286529292C7468';
wwv_flow_imp.g_varchar2_table(33742) := '69732E5F76616C7565732E686173286529262628742E707573682865292C746869732E5F76616C7565732E64656C657465286529297D6E2E66697265286E657720577365287429297D7D29297D646973706F736528297B746869732E5F6C697374656E65';
wwv_flow_imp.g_varchar2_table(33743) := '722E646973706F736528297D67657456616C75652865297B69662830213D3D652E696E6465784F66285673652E5F6B6579507265666978292972657475726E2073757065722E67657456616C75652865293B696628746869732E5F76616C7565732E6861';
wwv_flow_imp.g_varchar2_table(33744) := '732865292972657475726E20746869732E5F76616C7565732E6765742865293B636F6E737420743D652E737562737472285673652E5F6B65795072656669782E6C656E677468292C6E3D746869732E5F636F6E66696775726174696F6E53657276696365';
wwv_flow_imp.g_varchar2_table(33745) := '2E67657456616C75652874293B6C657420693B73776974636828747970656F66206E297B63617365226E756D626572223A6361736522626F6F6C65616E223A6361736522737472696E67223A693D6E3B627265616B3B64656661756C743A693D41727261';
wwv_flow_imp.g_varchar2_table(33746) := '792E69734172726179286E293F4A534F4E2E737472696E67696679286E293A6E7D72657475726E20746869732E5F76616C7565732E73657428652C69292C697D73657456616C756528652C74297B72657475726E2073757065722E73657456616C756528';
wwv_flow_imp.g_varchar2_table(33747) := '652C74297D72656D6F766556616C75652865297B72657475726E2073757065722E72656D6F766556616C75652865297D7D5673652E5F6B65795072656669783D22636F6E6669672E223B636C617373207A73657B636F6E7374727563746F7228652C742C';
wwv_flow_imp.g_varchar2_table(33748) := '6E297B746869732E5F736572766963653D652C746869732E5F6B65793D742C746869732E5F64656661756C7456616C75653D6E2C746869732E726573657428297D7365742865297B746869732E5F736572766963652E736574436F6E7465787428746869';
wwv_flow_imp.g_varchar2_table(33749) := '732E5F6B65792C65297D726573657428297B766F696420303D3D3D746869732E5F64656661756C7456616C75653F746869732E5F736572766963652E72656D6F7665436F6E7465787428746869732E5F6B6579293A746869732E5F736572766963652E73';
wwv_flow_imp.g_varchar2_table(33750) := '6574436F6E7465787428746869732E5F6B65792C746869732E5F64656661756C7456616C7565297D67657428297B72657475726E20746869732E5F736572766963652E676574436F6E746578744B657956616C756528746869732E5F6B6579297D7D636C';
wwv_flow_imp.g_varchar2_table(33751) := '617373204873657B636F6E7374727563746F722865297B746869732E6B65793D657D61666665637473536F6D652865297B72657475726E20652E68617328746869732E6B6579297D616C6C4B657973436F6E7461696E6564496E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(33752) := '20746869732E61666665637473536F6D652865297D7D636C617373205773657B636F6E7374727563746F722865297B746869732E6B6579733D657D61666665637473536F6D652865297B666F7228636F6E73742074206F6620746869732E6B6579732969';
wwv_flow_imp.g_varchar2_table(33753) := '6628652E6861732874292972657475726E21303B72657475726E21317D616C6C4B657973436F6E7461696E6564496E2865297B72657475726E20746869732E6B6579732E65766572792828743D3E652E68617328742929297D7D636C617373206A73657B';
wwv_flow_imp.g_varchar2_table(33754) := '636F6E7374727563746F722865297B746869732E6576656E74733D657D61666665637473536F6D652865297B666F7228636F6E73742074206F6620746869732E6576656E747329696628742E61666665637473536F6D652865292972657475726E21303B';
wwv_flow_imp.g_varchar2_table(33755) := '72657475726E21317D616C6C4B657973436F6E7461696E6564496E2865297B72657475726E20746869732E6576656E74732E65766572792828743D3E742E616C6C4B657973436F6E7461696E6564496E28652929297D7D636C6173732071736520657874';
wwv_flow_imp.g_varchar2_table(33756) := '656E6473206C747B636F6E7374727563746F722865297B737570657228292C746869732E5F6F6E4469644368616E6765436F6E746578743D746869732E5F7265676973746572286E6577207874287B6D657267653A653D3E6E6577206A73652865297D29';
wwv_flow_imp.g_varchar2_table(33757) := '292C746869732E6F6E4469644368616E6765436F6E746578743D746869732E5F6F6E4469644368616E6765436F6E746578742E6576656E742C746869732E5F6973446973706F7365643D21312C746869732E5F6D79436F6E7465787449643D657D637265';
wwv_flow_imp.g_varchar2_table(33758) := '6174654B657928652C74297B696628746869732E5F6973446973706F736564297468726F77206E6577204572726F7228224162737472616374436F6E746578744B65795365727669636520686173206265656E20646973706F73656422293B7265747572';
wwv_flow_imp.g_varchar2_table(33759) := '6E206E6577207A736528746869732C652C74297D6275666665724368616E67654576656E74732865297B746869732E5F6F6E4469644368616E6765436F6E746578742E706175736528293B7472797B6528297D66696E616C6C797B746869732E5F6F6E44';
wwv_flow_imp.g_varchar2_table(33760) := '69644368616E6765436F6E746578742E726573756D6528297D7D63726561746553636F7065642865297B696628746869732E5F6973446973706F736564297468726F77206E6577204572726F7228224162737472616374436F6E746578744B6579536572';
wwv_flow_imp.g_varchar2_table(33761) := '7669636520686173206265656E20646973706F73656422293B72657475726E206E65772055736528746869732C65297D636F6E746578744D61746368657352756C65732865297B696628746869732E5F6973446973706F736564297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(33762) := '204572726F7228224162737472616374436F6E746578744B65795365727669636520686173206265656E20646973706F73656422293B636F6E737420743D746869732E676574436F6E7465787456616C756573436F6E7461696E657228746869732E5F6D';
wwv_flow_imp.g_varchar2_table(33763) := '79436F6E746578744964293B72657475726E21657C7C652E6576616C756174652874297D676574436F6E746578744B657956616C75652865297B69662821746869732E5F6973446973706F7365642972657475726E20746869732E676574436F6E746578';
wwv_flow_imp.g_varchar2_table(33764) := '7456616C756573436F6E7461696E657228746869732E5F6D79436F6E746578744964292E67657456616C75652865297D736574436F6E7465787428652C74297B696628746869732E5F6973446973706F7365642972657475726E3B636F6E7374206E3D74';
wwv_flow_imp.g_varchar2_table(33765) := '6869732E676574436F6E7465787456616C756573436F6E7461696E657228746869732E5F6D79436F6E746578744964293B6E26266E2E73657456616C756528652C74292626746869732E5F6F6E4469644368616E6765436F6E746578742E66697265286E';
wwv_flow_imp.g_varchar2_table(33766) := '657720487365286529297D72656D6F7665436F6E746578742865297B746869732E5F6973446973706F7365647C7C746869732E676574436F6E7465787456616C756573436F6E7461696E657228746869732E5F6D79436F6E746578744964292E72656D6F';
wwv_flow_imp.g_varchar2_table(33767) := '766556616C75652865292626746869732E5F6F6E4469644368616E6765436F6E746578742E66697265286E657720487365286529297D676574436F6E746578742865297B72657475726E20746869732E5F6973446973706F7365643F4273652E494E5354';
wwv_flow_imp.g_varchar2_table(33768) := '414E43453A746869732E676574436F6E7465787456616C756573436F6E7461696E65722866756E6374696F6E2865297B666F72283B653B297B696628652E6861734174747269627574652852736529297B636F6E737420743D652E676574417474726962';
wwv_flow_imp.g_varchar2_table(33769) := '75746528527365293B72657475726E20743F7061727365496E7428742C3130293A4E614E7D653D652E706172656E74456C656D656E747D72657475726E20307D286529297D646973706F736528297B73757065722E646973706F736528292C746869732E';
wwv_flow_imp.g_varchar2_table(33770) := '5F6973446973706F7365643D21307D7D6C6574202473653D636C61737320657874656E6473207173657B636F6E7374727563746F722865297B73757065722830292C746869732E5F636F6E74657874733D6E6577204D61702C746869732E5F6C61737443';
wwv_flow_imp.g_varchar2_table(33771) := '6F6E7465787449643D303B636F6E737420743D746869732E5F7265676973746572286E65772056736528746869732E5F6D79436F6E7465787449642C652C746869732E5F6F6E4469644368616E6765436F6E7465787429293B746869732E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(33772) := '7874732E73657428746869732E5F6D79436F6E7465787449642C74297D676574436F6E7465787456616C756573436F6E7461696E65722865297B72657475726E20746869732E5F6973446973706F7365643F4273652E494E5354414E43453A746869732E';
wwv_flow_imp.g_varchar2_table(33773) := '5F636F6E74657874732E6765742865297C7C4273652E494E5354414E43457D6372656174654368696C64436F6E7465787428653D746869732E5F6D79436F6E746578744964297B696628746869732E5F6973446973706F736564297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(33774) := '204572726F722822436F6E746578744B65795365727669636520686173206265656E20646973706F73656422293B636F6E737420743D2B2B746869732E5F6C617374436F6E7465787449643B72657475726E20746869732E5F636F6E74657874732E7365';
wwv_flow_imp.g_varchar2_table(33775) := '7428742C6E65772046736528742C746869732E676574436F6E7465787456616C756573436F6E7461696E657228652929292C747D646973706F7365436F6E746578742865297B746869732E5F6973446973706F7365647C7C746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(33776) := '74732E64656C6574652865297D7D3B2473653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572';
wwv_flow_imp.g_varchar2_table(33777) := '747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F72';
wwv_flow_imp.g_varchar2_table(33778) := '61746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475';
wwv_flow_imp.g_varchar2_table(33779) := '726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28302C6670295D2C247365';
wwv_flow_imp.g_varchar2_table(33780) := '293B636C6173732055736520657874656E6473207173657B636F6E7374727563746F7228652C74297B696628737570657228652E6372656174654368696C64436F6E746578742829292C746869732E5F706172656E744368616E67654C697374656E6572';
wwv_flow_imp.g_varchar2_table(33781) := '3D746869732E5F7265676973746572286E6577206374292C746869732E5F706172656E743D652C746869732E5F757064617465506172656E744368616E67654C697374656E657228292C746869732E5F646F6D4E6F64653D742C746869732E5F646F6D4E';
wwv_flow_imp.g_varchar2_table(33782) := '6F64652E6861734174747269627574652852736529297B6C657420653D22223B746869732E5F646F6D4E6F64652E636C6173734C697374262628653D41727261792E66726F6D28746869732E5F646F6D4E6F64652E636C6173734C6973742E76616C7565';
wwv_flow_imp.g_varchar2_table(33783) := '732829292E6A6F696E28222C202229292C636F6E736F6C652E6572726F722822456C656D656E7420616C72656164792068617320636F6E7465787420617474726962757465222B28653F223A20222B653A222229297D746869732E5F646F6D4E6F64652E';
wwv_flow_imp.g_varchar2_table(33784) := '736574417474726962757465285273652C537472696E6728746869732E5F6D79436F6E74657874496429297D5F757064617465506172656E744368616E67654C697374656E657228297B746869732E5F706172656E744368616E67654C697374656E6572';
wwv_flow_imp.g_varchar2_table(33785) := '2E76616C75653D746869732E5F706172656E742E6F6E4469644368616E6765436F6E746578742828653D3E7B76617220743B743D746869732E5F706172656E742E676574436F6E7465787456616C756573436F6E7461696E657228746869732E5F6D7943';
wwv_flow_imp.g_varchar2_table(33786) := '6F6E746578744964292E76616C75652C652E616C6C4B657973436F6E7461696E6564496E286E657720536574284F626A6563742E6B65797328742929297C7C746869732E5F6F6E4469644368616E6765436F6E746578742E666972652865297D29297D64';
wwv_flow_imp.g_varchar2_table(33787) := '6973706F736528297B746869732E5F6973446973706F7365647C7C28746869732E5F706172656E742E646973706F7365436F6E7465787428746869732E5F6D79436F6E746578744964292C746869732E5F646F6D4E6F64652E72656D6F76654174747269';
wwv_flow_imp.g_varchar2_table(33788) := '6275746528527365292C73757065722E646973706F73652829297D676574436F6E7465787456616C756573436F6E7461696E65722865297B72657475726E20746869732E5F6973446973706F7365643F4273652E494E5354414E43453A746869732E5F70';
wwv_flow_imp.g_varchar2_table(33789) := '6172656E742E676574436F6E7465787456616C756573436F6E7461696E65722865297D6372656174654368696C64436F6E7465787428653D746869732E5F6D79436F6E746578744964297B696628746869732E5F6973446973706F736564297468726F77';
wwv_flow_imp.g_varchar2_table(33790) := '206E6577204572726F72282253636F706564436F6E746578744B65795365727669636520686173206265656E20646973706F73656422293B72657475726E20746869732E5F706172656E742E6372656174654368696C64436F6E746578742865297D6469';
wwv_flow_imp.g_varchar2_table(33791) := '73706F7365436F6E746578742865297B746869732E5F6973446973706F7365647C7C746869732E5F706172656E742E646973706F7365436F6E746578742865297D7D6B632E7265676973746572436F6D6D616E6428225F736574436F6E74657874222C28';
wwv_flow_imp.g_varchar2_table(33792) := '66756E6374696F6E28652C742C6E297B652E676574286364292E6372656174654B657928537472696E672874292C66756E6374696F6E2865297B72657475726E20626828652C28653D3E226F626A656374223D3D747970656F6620652626313D3D3D652E';
wwv_flow_imp.g_varchar2_table(33793) := '246D69643F4E6F2E7265766976652865292E746F537472696E6728293A6520696E7374616E63656F66204E6F3F652E746F537472696E6728293A766F6964203029297D286E29297D29292C6B632E7265676973746572436F6D6D616E64287B69643A2267';
wwv_flow_imp.g_varchar2_table(33794) := '6574436F6E746578744B6579496E666F222C68616E646C65723A28293D3E5B2E2E2E6C642E616C6C28295D2E736F7274282828652C74293D3E652E6B65792E6C6F63616C65436F6D7061726528742E6B65792929292C6D657461646174613A7B64657363';
wwv_flow_imp.g_varchar2_table(33795) := '72697074696F6E3A6228302C224120636F6D6D616E6420746861742072657475726E7320696E666F726D6174696F6E2061626F757420636F6E74657874206B65797322292C617267733A5B5D7D7D292C6B632E7265676973746572436F6D6D616E642822';
wwv_flow_imp.g_varchar2_table(33796) := '5F67656E6572617465436F6E746578744B6579496E666F222C2866756E6374696F6E28297B636F6E737420653D5B5D2C743D6E6577205365743B666F7228636F6E7374206E206F66206C642E616C6C282929742E686173286E2E6B6579297C7C28742E61';
wwv_flow_imp.g_varchar2_table(33797) := '6464286E2E6B6579292C652E70757368286E29293B652E736F7274282828652C74293D3E652E6B65792E6C6F63616C65436F6D7061726528742E6B65792929292C636F6E736F6C652E6C6F67284A534F4E2E737472696E6769667928652C766F69642030';
wwv_flow_imp.g_varchar2_table(33798) := '2C3229297D29293B636C617373204B73657B636F6E7374727563746F7228652C74297B746869732E6B65793D652C746869732E646174613D742C746869732E696E636F6D696E673D6E6577204D61702C746869732E6F7574676F696E673D6E6577204D61';
wwv_flow_imp.g_varchar2_table(33799) := '707D7D636C617373204773657B636F6E7374727563746F722865297B746869732E5F68617368466E3D652C746869732E5F6E6F6465733D6E6577204D61707D726F6F747328297B636F6E737420653D5B5D3B666F7228636F6E73742074206F6620746869';
wwv_flow_imp.g_varchar2_table(33800) := '732E5F6E6F6465732E76616C756573282929303D3D3D742E6F7574676F696E672E73697A652626652E707573682874293B72657475726E20657D696E736572744564676528652C74297B636F6E7374206E3D746869732E6C6F6F6B75704F72496E736572';
wwv_flow_imp.g_varchar2_table(33801) := '744E6F64652865292C693D746869732E6C6F6F6B75704F72496E736572744E6F64652874293B6E2E6F7574676F696E672E73657428692E6B65792C69292C692E696E636F6D696E672E736574286E2E6B65792C6E297D72656D6F76654E6F64652865297B';
wwv_flow_imp.g_varchar2_table(33802) := '636F6E737420743D746869732E5F68617368466E2865293B746869732E5F6E6F6465732E64656C6574652874293B666F7228636F6E73742065206F6620746869732E5F6E6F6465732E76616C756573282929652E6F7574676F696E672E64656C65746528';
wwv_flow_imp.g_varchar2_table(33803) := '74292C652E696E636F6D696E672E64656C6574652874297D6C6F6F6B75704F72496E736572744E6F64652865297B636F6E737420743D746869732E5F68617368466E2865293B6C6574206E3D746869732E5F6E6F6465732E6765742874293B7265747572';
wwv_flow_imp.g_varchar2_table(33804) := '6E206E7C7C286E3D6E6577204B736528742C65292C746869732E5F6E6F6465732E73657428742C6E29292C6E7D6973456D70747928297B72657475726E20303D3D3D746869732E5F6E6F6465732E73697A657D746F537472696E6728297B636F6E737420';
wwv_flow_imp.g_varchar2_table(33805) := '653D5B5D3B666F7228636F6E73745B742C6E5D6F6620746869732E5F6E6F64657329652E707573682860247B747D5C6E5C74282D3E20696E636F6D696E67295B247B5B2E2E2E6E2E696E636F6D696E672E6B65797328295D2E6A6F696E28222C2022297D';
wwv_flow_imp.g_varchar2_table(33806) := '5D5C6E5C74286F7574676F696E67202D3E295B247B5B2E2E2E6E2E6F7574676F696E672E6B65797328295D2E6A6F696E28222C22297D5D5C6E60293B72657475726E20652E6A6F696E28225C6E22297D66696E644379636C65536C6F7728297B666F7228';
wwv_flow_imp.g_varchar2_table(33807) := '636F6E73745B652C745D6F6620746869732E5F6E6F646573297B636F6E7374206E3D6E657720536574285B655D292C693D746869732E5F66696E644379636C6528742C6E293B696628692972657475726E20697D7D5F66696E644379636C6528652C7429';
wwv_flow_imp.g_varchar2_table(33808) := '7B666F7228636F6E73745B6E2C695D6F6620652E6F7574676F696E67297B696628742E686173286E292972657475726E5B2E2E2E742C6E5D2E6A6F696E2822202D3E2022293B742E616464286E293B636F6E737420653D746869732E5F66696E64437963';
wwv_flow_imp.g_varchar2_table(33809) := '6C6528692C74293B696628652972657475726E20653B742E64656C657465286E297D7D7D636C6173732051736520657874656E6473204572726F727B636F6E7374727563746F722865297B76617220743B737570657228226379636C696320646570656E';
wwv_flow_imp.g_varchar2_table(33810) := '64656E6379206265747765656E20736572766963657322292C746869732E6D6573736167653D6E756C6C213D3D28743D652E66696E644379636C65536C6F772829292626766F69642030213D3D743F743A60554E41424C4520746F206465746563742063';
wwv_flow_imp.g_varchar2_table(33811) := '79636C652C2064756D70696E672067726170683A205C6E247B652E746F537472696E6728297D607D7D636C617373205973657B636F6E7374727563746F7228653D6E65772078422C743D21312C6E2C693D2131297B766172206F3B746869732E5F736572';
wwv_flow_imp.g_varchar2_table(33812) := '76696365733D652C746869732E5F7374726963743D742C746869732E5F706172656E743D6E2C746869732E5F656E61626C6554726163696E673D692C746869732E5F6973446973706F7365643D21312C746869732E5F7365727669636573546F4D617962';
wwv_flow_imp.g_varchar2_table(33813) := '65446973706F73653D6E6577205365742C746869732E5F6368696C6472656E3D6E6577205365742C746869732E5F616374697665496E7374616E74696174696F6E733D6E6577205365742C746869732E5F73657276696365732E7365742875632C746869';
wwv_flow_imp.g_varchar2_table(33814) := '73292C746869732E5F676C6F62616C47726170683D693F6E756C6C213D3D286F3D6E756C6C3D3D6E3F766F696420303A6E2E5F676C6F62616C4772617068292626766F69642030213D3D6F3F6F3A6E6577204773652828653D3E6529293A766F69642030';
wwv_flow_imp.g_varchar2_table(33815) := '7D646973706F736528297B69662821746869732E5F6973446973706F736564297B746869732E5F6973446973706F7365643D21302C6F7428746869732E5F6368696C6472656E292C746869732E5F6368696C6472656E2E636C65617228293B666F722863';
wwv_flow_imp.g_varchar2_table(33816) := '6F6E73742065206F6620746869732E5F7365727669636573546F4D61796265446973706F73652969742865292626652E646973706F736528293B746869732E5F7365727669636573546F4D61796265446973706F73652E636C65617228297D7D5F746872';
wwv_flow_imp.g_varchar2_table(33817) := '6F774966446973706F73656428297B696628746869732E5F6973446973706F736564297468726F77206E6577204572726F722822496E7374616E74696174696F6E5365727669636520686173206265656E20646973706F73656422297D63726561746543';
wwv_flow_imp.g_varchar2_table(33818) := '68696C642865297B746869732E5F7468726F774966446973706F73656428293B636F6E737420743D6E657720636C61737320657874656E6473205973657B646973706F736528297B746869732E5F6368696C6472656E2E64656C6574652874292C737570';
wwv_flow_imp.g_varchar2_table(33819) := '65722E646973706F736528297D7D28652C746869732E5F7374726963742C746869732C746869732E5F656E61626C6554726163696E67293B72657475726E20746869732E5F6368696C6472656E2E6164642874292C747D696E766F6B6546756E6374696F';
wwv_flow_imp.g_varchar2_table(33820) := '6E28652C2E2E2E74297B746869732E5F7468726F774966446973706F73656428293B636F6E7374206E3D5A73652E7472616365496E766F636174696F6E28746869732E5F656E61626C6554726163696E672C65293B6C657420693D21313B7472797B7265';
wwv_flow_imp.g_varchar2_table(33821) := '7475726E2065287B6765743A653D3E7B69662869297468726F77204165282273657276696365206163636573736F72206973206F6E6C792076616C696420647572696E672074686520696E766F636174696F6E206F662069747320746172676574206D65';
wwv_flow_imp.g_varchar2_table(33822) := '74686F6422293B636F6E737420743D746869732E5F6765744F7243726561746553657276696365496E7374616E636528652C6E293B6966282174297468726F77206E6577204572726F7228605B696E766F6B6546756E6374696F6E5D20756E6B6E6F776E';
wwv_flow_imp.g_varchar2_table(33823) := '20736572766963652027247B657D2760293B72657475726E20747D7D2C2E2E2E74297D66696E616C6C797B693D21302C6E2E73746F7028297D7D637265617465496E7374616E636528652C2E2E2E74297B6C6574206E2C693B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(33824) := '2E5F7468726F774966446973706F73656428292C6520696E7374616E63656F662043703F286E3D5A73652E74726163654372656174696F6E28746869732E5F656E61626C6554726163696E672C652E63746F72292C693D746869732E5F63726561746549';
wwv_flow_imp.g_varchar2_table(33825) := '6E7374616E636528652E63746F722C652E737461746963417267756D656E74732E636F6E6361742874292C6E29293A286E3D5A73652E74726163654372656174696F6E28746869732E5F656E61626C6554726163696E672C65292C693D746869732E5F63';
wwv_flow_imp.g_varchar2_table(33826) := '7265617465496E7374616E636528652C742C6E29292C6E2E73746F7028292C697D5F637265617465496E7374616E636528652C743D5B5D2C6E297B636F6E737420693D63632E67657453657276696365446570656E64656E636965732865292E736F7274';
wwv_flow_imp.g_varchar2_table(33827) := '282828652C74293D3E652E696E6465782D742E696E64657829292C6F3D5B5D3B666F7228636F6E73742074206F662069297B636F6E737420693D746869732E5F6765744F7243726561746553657276696365496E7374616E636528742E69642C6E293B69';
wwv_flow_imp.g_varchar2_table(33828) := '7C7C746869732E5F7468726F77496653747269637428605B637265617465496E7374616E63655D20247B652E6E616D657D20646570656E6473206F6E20554E4B4E4F574E207365727669636520247B742E69647D2E602C2131292C6F2E70757368286929';
wwv_flow_imp.g_varchar2_table(33829) := '7D636F6E737420733D692E6C656E6774683E303F695B305D2E696E6465783A742E6C656E6774683B696628742E6C656E677468213D3D73297B636F6E736F6C652E747261636528605B637265617465496E7374616E63655D204669727374207365727669';
wwv_flow_imp.g_varchar2_table(33830) := '636520646570656E64656E6379206F6620247B652E6E616D657D20617420706F736974696F6E20247B732B317D20636F6E666C69637473207769746820247B742E6C656E6774687D2073746174696320617267756D656E747360293B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(33831) := '732D742E6C656E6774683B743D6E3E303F742E636F6E636174286E6577204172726179286E29293A742E736C69636528302C73297D72657475726E205265666C6563742E636F6E73747275637428652C742E636F6E636174286F29297D5F736574437265';
wwv_flow_imp.g_varchar2_table(33832) := '6174656453657276696365496E7374616E636528652C74297B696628746869732E5F73657276696365732E676574286529696E7374616E63656F6620437029746869732E5F73657276696365732E73657428652C74293B656C73657B6966282174686973';
wwv_flow_imp.g_varchar2_table(33833) := '2E5F706172656E74297468726F77206E6577204572726F722822696C6C6567616C5374617465202D2073657474696E6720554E4B4E4F574E207365727669636520696E7374616E636522293B746869732E5F706172656E742E5F73657443726561746564';
wwv_flow_imp.g_varchar2_table(33834) := '53657276696365496E7374616E636528652C74297D7D5F67657453657276696365496E7374616E63654F7244657363726970746F722865297B636F6E737420743D746869732E5F73657276696365732E6765742865293B72657475726E21742626746869';
wwv_flow_imp.g_varchar2_table(33835) := '732E5F706172656E743F746869732E5F706172656E742E5F67657453657276696365496E7374616E63654F7244657363726970746F722865293A747D5F6765744F7243726561746553657276696365496E7374616E636528652C74297B746869732E5F67';
wwv_flow_imp.g_varchar2_table(33836) := '6C6F62616C47726170682626746869732E5F676C6F62616C4772617068496D706C69636974446570656E64656E63792626746869732E5F676C6F62616C47726170682E696E736572744564676528746869732E5F676C6F62616C4772617068496D706C69';
wwv_flow_imp.g_varchar2_table(33837) := '636974446570656E64656E63792C537472696E67286529293B636F6E7374206E3D746869732E5F67657453657276696365496E7374616E63654F7244657363726970746F722865293B72657475726E206E20696E7374616E63656F662043703F74686973';
wwv_flow_imp.g_varchar2_table(33838) := '2E5F73616665437265617465416E64436163686553657276696365496E7374616E636528652C6E2C742E6272616E636828652C213029293A28742E6272616E636828652C2131292C6E297D5F73616665437265617465416E644361636865536572766963';
wwv_flow_imp.g_varchar2_table(33839) := '65496E7374616E636528652C742C6E297B696628746869732E5F616374697665496E7374616E74696174696F6E732E686173286529297468726F77206E6577204572726F722860696C6C6567616C207374617465202D205245435552534956454C592069';
wwv_flow_imp.g_varchar2_table(33840) := '6E7374616E74696174696E6720736572766963652027247B657D2760293B746869732E5F616374697665496E7374616E74696174696F6E732E6164642865293B7472797B72657475726E20746869732E5F637265617465416E6443616368655365727669';
wwv_flow_imp.g_varchar2_table(33841) := '6365496E7374616E636528652C742C6E297D66696E616C6C797B746869732E5F616374697665496E7374616E74696174696F6E732E64656C6574652865297D7D5F637265617465416E64436163686553657276696365496E7374616E636528652C742C6E';
wwv_flow_imp.g_varchar2_table(33842) := '297B76617220693B636F6E7374206F3D6E6577204773652828653D3E652E69642E746F537472696E67282929293B6C657420733D303B636F6E737420723D5B7B69643A652C646573633A742C5F74726163653A6E7D5D3B666F72283B722E6C656E677468';
wwv_flow_imp.g_varchar2_table(33843) := '3B297B636F6E737420743D722E706F7028293B6966286F2E6C6F6F6B75704F72496E736572744E6F64652874292C732B2B3E316533297468726F77206E657720517365286F293B666F7228636F6E7374206E206F662063632E6765745365727669636544';
wwv_flow_imp.g_varchar2_table(33844) := '6570656E64656E6369657328742E646573632E63746F7229297B636F6E737420733D746869732E5F67657453657276696365496E7374616E63654F7244657363726970746F72286E2E6964293B696628737C7C746869732E5F7468726F77496653747269';
wwv_flow_imp.g_varchar2_table(33845) := '637428605B637265617465496E7374616E63655D20247B657D20646570656E6473206F6E20247B6E2E69647D207768696368206973204E4F5420726567697374657265642E602C2130292C6E756C6C3D3D3D28693D746869732E5F676C6F62616C477261';
wwv_flow_imp.g_varchar2_table(33846) := '7068297C7C766F696420303D3D3D697C7C692E696E736572744564676528537472696E6728742E6964292C537472696E67286E2E696429292C7320696E7374616E63656F66204370297B636F6E737420653D7B69643A6E2E69642C646573633A732C5F74';
wwv_flow_imp.g_varchar2_table(33847) := '726163653A742E5F74726163652E6272616E6368286E2E69642C2130297D3B6F2E696E736572744564676528742C65292C722E707573682865297D7D7D666F72283B3B297B636F6E737420653D6F2E726F6F747328293B696628303D3D3D652E6C656E67';
wwv_flow_imp.g_varchar2_table(33848) := '7468297B696628216F2E6973456D7074792829297468726F77206E657720517365286F293B627265616B7D666F7228636F6E73747B646174613A747D6F662065297B696628746869732E5F67657453657276696365496E7374616E63654F724465736372';
wwv_flow_imp.g_varchar2_table(33849) := '6970746F7228742E696429696E7374616E63656F66204370297B636F6E737420653D746869732E5F63726561746553657276696365496E7374616E6365576974684F776E657228742E69642C742E646573632E63746F722C742E646573632E7374617469';
wwv_flow_imp.g_varchar2_table(33850) := '63417267756D656E74732C742E646573632E737570706F72747344656C61796564496E7374616E74696174696F6E2C742E5F7472616365293B746869732E5F7365744372656174656453657276696365496E7374616E636528742E69642C65297D6F2E72';
wwv_flow_imp.g_varchar2_table(33851) := '656D6F76654E6F64652874297D7D72657475726E20746869732E5F67657453657276696365496E7374616E63654F7244657363726970746F722865297D5F63726561746553657276696365496E7374616E6365576974684F776E657228652C742C6E3D5B';
wwv_flow_imp.g_varchar2_table(33852) := '5D2C692C6F297B696628746869732E5F73657276696365732E676574286529696E7374616E63656F662043702972657475726E20746869732E5F63726561746553657276696365496E7374616E636528652C742C6E2C692C6F2C746869732E5F73657276';
wwv_flow_imp.g_varchar2_table(33853) := '69636573546F4D61796265446973706F7365293B696628746869732E5F706172656E742972657475726E20746869732E5F706172656E742E5F63726561746553657276696365496E7374616E6365576974684F776E657228652C742C6E2C692C6F293B74';
wwv_flow_imp.g_varchar2_table(33854) := '68726F77206E6577204572726F722860696C6C6567616C5374617465202D206372656174696E6720554E4B4E4F574E207365727669636520696E7374616E636520247B742E6E616D657D60297D5F63726561746553657276696365496E7374616E636528';
wwv_flow_imp.g_varchar2_table(33855) := '652C742C6E3D5B5D2C692C6F2C73297B69662869297B636F6E737420693D6E65772059736528766F696420302C746869732E5F7374726963742C746869732C746869732E5F656E61626C6554726163696E67293B692E5F676C6F62616C4772617068496D';
wwv_flow_imp.g_varchar2_table(33856) := '706C69636974446570656E64656E63793D537472696E672865293B636F6E737420723D6E6577204D61702C613D6E6577205A74282828293D3E7B636F6E737420653D692E5F637265617465496E7374616E636528742C6E2C6F293B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(33857) := '5B742C6E5D6F662072297B636F6E737420693D655B745D3B6966282266756E6374696F6E223D3D747970656F66206929666F7228636F6E73742074206F66206E29742E646973706F7361626C653D692E6170706C7928652C742E6C697374656E6572297D';
wwv_flow_imp.g_varchar2_table(33858) := '72657475726E20722E636C65617228292C732E6164642865292C657D29293B72657475726E206E65772050726F7879284F626A6563742E637265617465286E756C6C292C7B67657428652C74297B69662821612E6973496E697469616C697A6564262622';
wwv_flow_imp.g_varchar2_table(33859) := '737472696E67223D3D747970656F662074262628742E7374617274735769746828226F6E44696422297C7C742E7374617274735769746828226F6E57696C6C222929297B6C657420653D722E6765742874293B657C7C28653D6E65772067742C722E7365';
wwv_flow_imp.g_varchar2_table(33860) := '7428742C6529293B636F6E7374206E3D286E2C692C6F293D3E7B696628612E6973496E697469616C697A65642972657475726E20612E76616C75655B745D286E2C692C6F293B7B636F6E737420743D7B6C697374656E65723A5B6E2C692C6F5D2C646973';
wwv_flow_imp.g_varchar2_table(33861) := '706F7361626C653A766F696420307D2C733D652E707573682874292C723D7274282828293D3E7B76617220653B7328292C6E756C6C3D3D3D28653D742E646973706F7361626C65297C7C766F696420303D3D3D657C7C652E646973706F736528297D2929';
wwv_flow_imp.g_varchar2_table(33862) := '3B72657475726E20727D7D3B72657475726E206E7D6966287420696E20652972657475726E20655B745D3B636F6E7374206E3D612E76616C75653B6C657420693D6E5B745D3B72657475726E2266756E6374696F6E22213D747970656F6620697C7C2869';
wwv_flow_imp.g_varchar2_table(33863) := '3D692E62696E64286E292C655B745D3D69292C697D2C7365743A28652C742C6E293D3E28612E76616C75655B745D3D6E2C2130292C67657450726F746F747970654F663A653D3E742E70726F746F747970657D297D7B636F6E737420653D746869732E5F';
wwv_flow_imp.g_varchar2_table(33864) := '637265617465496E7374616E636528742C6E2C6F293B72657475726E20732E6164642865292C657D7D5F7468726F77496653747269637428652C74297B696628742626636F6E736F6C652E7761726E2865292C746869732E5F737472696374297468726F';
wwv_flow_imp.g_varchar2_table(33865) := '77206E6577204572726F722865297D7D636C617373205A73657B737461746963207472616365496E766F636174696F6E28652C74297B72657475726E20653F6E6577205A736528322C742E6E616D657C7C286E6577204572726F72292E737461636B2E73';
wwv_flow_imp.g_varchar2_table(33866) := '706C697428225C6E22292E736C69636528332C34292E6A6F696E28225C6E2229293A5A73652E5F4E6F6E657D7374617469632074726163654372656174696F6E28652C74297B72657475726E20653F6E6577205A736528312C742E6E616D65293A5A7365';
wwv_flow_imp.g_varchar2_table(33867) := '2E5F4E6F6E657D636F6E7374727563746F7228652C74297B746869732E747970653D652C746869732E6E616D653D742C746869732E5F73746172743D446174652E6E6F7728292C746869732E5F6465703D5B5D7D6272616E636828652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(33868) := '74206E3D6E6577205A736528332C652E746F537472696E672829293B72657475726E20746869732E5F6465702E70757368285B652C742C6E5D292C6E7D73746F7028297B636F6E737420653D446174652E6E6F7728292D746869732E5F73746172743B5A';
wwv_flow_imp.g_varchar2_table(33869) := '73652E5F746F74616C732B3D653B6C657420743D21313B636F6E7374206E3D5B60247B313D3D3D746869732E747970653F22435245415445223A2243414C4C227D20247B746869732E6E616D657D602C60247B66756E6374696F6E2065286E2C69297B63';
wwv_flow_imp.g_varchar2_table(33870) := '6F6E7374206F3D5B5D2C733D6E6577204172726179286E2B31292E6A6F696E28225C7422293B666F7228636F6E73745B722C612C6C5D6F6620692E5F646570296966286126266C297B743D21302C6F2E707573682860247B737D43524541544553202D3E';
wwv_flow_imp.g_varchar2_table(33871) := '20247B727D60293B636F6E737420693D65286E2B312C6C293B6926266F2E707573682869297D656C7365206F2E707573682860247B737D75736573202D3E20247B727D60293B72657475726E206F2E6A6F696E28225C6E22297D28312C74686973297D60';
wwv_flow_imp.g_varchar2_table(33872) := '2C60444F4E452C20746F6F6B20247B652E746F46697865642832297D6D7320286772616E6420746F74616C20247B5A73652E5F746F74616C732E746F46697865642832297D6D7329605D3B28653E327C7C742926265A73652E616C6C2E616464286E2E6A';
wwv_flow_imp.g_varchar2_table(33873) := '6F696E28225C6E2229297D7D5A73652E616C6C3D6E6577205365742C5A73652E5F4E6F6E653D6E657720636C61737320657874656E6473205A73657B636F6E7374727563746F7228297B737570657228302C6E756C6C297D73746F7028297B7D6272616E';
wwv_flow_imp.g_varchar2_table(33874) := '636828297B72657475726E20746869737D7D2C5A73652E5F746F74616C733D303B636F6E7374205873653D6E657720536574285B716F2E696E4D656D6F72792C716F2E7673636F6465536F75726365436F6E74726F6C2C716F2E77616C6B5468726F7567';
wwv_flow_imp.g_varchar2_table(33875) := '682C716F2E77616C6B5468726F756768536E69707065742C716F2E7673636F646543686174436F6465426C6F636B5D293B636C617373204A73657B636F6E7374727563746F7228297B746869732E5F62795265736F757263653D6E6577206F612C746869';
wwv_flow_imp.g_varchar2_table(33876) := '732E5F62794F776E65723D6E6577204D61707D73657428652C742C6E297B6C657420693D746869732E5F62795265736F757263652E6765742865293B697C7C28693D6E6577204D61702C746869732E5F62795265736F757263652E73657428652C692929';
wwv_flow_imp.g_varchar2_table(33877) := '2C692E73657428742C6E293B6C6574206F3D746869732E5F62794F776E65722E6765742874293B6F7C7C286F3D6E6577206F612C746869732E5F62794F776E65722E73657428742C6F29292C6F2E73657428652C6E297D67657428652C74297B636F6E73';
wwv_flow_imp.g_varchar2_table(33878) := '74206E3D746869732E5F62795265736F757263652E6765742865293B72657475726E206E756C6C3D3D6E3F766F696420303A6E2E6765742874297D64656C65746528652C74297B6C6574206E3D21312C693D21313B636F6E7374206F3D746869732E5F62';
wwv_flow_imp.g_varchar2_table(33879) := '795265736F757263652E6765742865293B6F2626286E3D6F2E64656C657465287429293B636F6E737420733D746869732E5F62794F776E65722E6765742874293B69662873262628693D732E64656C657465286529292C6E213D3D69297468726F77206E';
wwv_flow_imp.g_varchar2_table(33880) := '6577204572726F722822696C6C6567616C20737461746522293B72657475726E206E2626697D76616C7565732865297B76617220742C6E2C692C6F3B72657475726E22737472696E67223D3D747970656F6620653F6E756C6C213D3D286E3D6E756C6C3D';
wwv_flow_imp.g_varchar2_table(33881) := '3D3D28743D746869732E5F62794F776E65722E676574286529297C7C766F696420303D3D3D743F766F696420303A742E76616C7565732829292626766F69642030213D3D6E3F6E3A5A652E656D70747928293A4E6F2E69735572692865293F6E756C6C21';
wwv_flow_imp.g_varchar2_table(33882) := '3D3D286F3D6E756C6C3D3D3D28693D746869732E5F62795265736F757263652E676574286529297C7C766F696420303D3D3D693F766F696420303A692E76616C7565732829292626766F69642030213D3D6F3F6F3A5A652E656D70747928293A5A652E6D';
wwv_flow_imp.g_varchar2_table(33883) := '6170285A652E636F6E636174282E2E2E746869732E5F62794F776E65722E76616C7565732829292C28653D3E655B315D29297D7D636C617373206572657B636F6E7374727563746F722865297B746869732E6572726F72733D302C746869732E696E666F';
wwv_flow_imp.g_varchar2_table(33884) := '733D302C746869732E7761726E696E67733D302C746869732E756E6B6E6F776E733D302C746869732E5F646174613D6E6577206F612C746869732E5F736572766963653D652C746869732E5F737562736372697074696F6E3D652E6F6E4D61726B657243';
wwv_flow_imp.g_varchar2_table(33885) := '68616E67656428746869732E5F7570646174652C74686973297D646973706F736528297B746869732E5F737562736372697074696F6E2E646973706F736528297D5F7570646174652865297B666F7228636F6E73742074206F662065297B636F6E737420';
wwv_flow_imp.g_varchar2_table(33886) := '653D746869732E5F646174612E6765742874293B652626746869732E5F7375627374726163742865293B636F6E7374206E3D746869732E5F7265736F7572636553746174732874293B746869732E5F616464286E292C746869732E5F646174612E736574';
wwv_flow_imp.g_varchar2_table(33887) := '28742C6E297D7D5F7265736F7572636553746174732865297B636F6E737420743D7B6572726F72733A302C7761726E696E67733A302C696E666F733A302C756E6B6E6F776E733A307D3B6966285873652E68617328652E736368656D6529297265747572';
wwv_flow_imp.g_varchar2_table(33888) := '6E20743B666F7228636F6E73747B73657665726974793A6E7D6F6620746869732E5F736572766963652E72656164287B7265736F757263653A657D29296E3D3D3D5A4D2E4572726F723F742E6572726F72732B3D313A6E3D3D3D5A4D2E5761726E696E67';
wwv_flow_imp.g_varchar2_table(33889) := '3F742E7761726E696E67732B3D313A6E3D3D3D5A4D2E496E666F3F742E696E666F732B3D313A742E756E6B6E6F776E732B3D313B72657475726E20747D5F7375627374726163742865297B746869732E6572726F72732D3D652E6572726F72732C746869';
wwv_flow_imp.g_varchar2_table(33890) := '732E7761726E696E67732D3D652E7761726E696E67732C746869732E696E666F732D3D652E696E666F732C746869732E756E6B6E6F776E732D3D652E756E6B6E6F776E737D5F6164642865297B746869732E6572726F72732B3D652E6572726F72732C74';
wwv_flow_imp.g_varchar2_table(33891) := '6869732E7761726E696E67732B3D652E7761726E696E67732C746869732E696E666F732B3D652E696E666F732C746869732E756E6B6E6F776E732B3D652E756E6B6E6F776E737D7D636C617373207472657B636F6E7374727563746F7228297B74686973';
wwv_flow_imp.g_varchar2_table(33892) := '2E5F6F6E4D61726B65724368616E6765643D6E6577206B74287B64656C61793A302C6D657267653A7472652E5F6D657267657D292C746869732E6F6E4D61726B65724368616E6765643D746869732E5F6F6E4D61726B65724368616E6765642E6576656E';
wwv_flow_imp.g_varchar2_table(33893) := '742C746869732E5F646174613D6E6577204A73652C746869732E5F73746174733D6E6577206572652874686973297D646973706F736528297B746869732E5F73746174732E646973706F736528292C746869732E5F6F6E4D61726B65724368616E676564';
wwv_flow_imp.g_varchar2_table(33894) := '2E646973706F736528297D72656D6F766528652C74297B666F7228636F6E7374206E206F6620747C7C5B5D29746869732E6368616E67654F6E6528652C6E2C5B5D297D6368616E67654F6E6528652C742C6E297B6966285768286E2929746869732E5F64';
wwv_flow_imp.g_varchar2_table(33895) := '6174612E64656C65746528742C65292626746869732E5F6F6E4D61726B65724368616E6765642E66697265285B745D293B656C73657B636F6E737420693D5B5D3B666F7228636F6E7374206F206F66206E297B636F6E7374206E3D7472652E5F746F4D61';
wwv_flow_imp.g_varchar2_table(33896) := '726B657228652C742C6F293B6E2626692E70757368286E297D746869732E5F646174612E73657428742C652C69292C746869732E5F6F6E4D61726B65724368616E6765642E66697265285B745D297D7D737461746963205F746F4D61726B657228652C74';
wwv_flow_imp.g_varchar2_table(33897) := '2C6E297B6C65747B636F64653A692C73657665726974793A6F2C6D6573736167653A732C736F757263653A722C73746172744C696E654E756D6265723A612C7374617274436F6C756D6E3A6C2C656E644C696E654E756D6265723A632C656E64436F6C75';
wwv_flow_imp.g_varchar2_table(33898) := '6D6E3A642C72656C61746564496E666F726D6174696F6E3A682C746167733A757D3D6E3B696628732972657475726E20613D613E303F613A312C6C3D6C3E303F6C3A312C633D633E3D613F633A612C643D643E303F643A6C2C7B7265736F757263653A74';
wwv_flow_imp.g_varchar2_table(33899) := '2C6F776E65723A652C636F64653A692C73657665726974793A6F2C6D6573736167653A732C736F757263653A722C73746172744C696E654E756D6265723A612C7374617274436F6C756D6E3A6C2C656E644C696E654E756D6265723A632C656E64436F6C';
wwv_flow_imp.g_varchar2_table(33900) := '756D6E3A642C72656C61746564496E666F726D6174696F6E3A682C746167733A757D7D6368616E6765416C6C28652C74297B636F6E7374206E3D5B5D2C693D746869732E5F646174612E76616C7565732865293B6966286929666F7228636F6E73742074';
wwv_flow_imp.g_varchar2_table(33901) := '206F662069297B636F6E737420693D5A652E66697273742874293B692626286E2E7075736828692E7265736F75726365292C746869732E5F646174612E64656C65746528692E7265736F757263652C6529297D6966286A68287429297B636F6E73742069';
wwv_flow_imp.g_varchar2_table(33902) := '3D6E6577206F613B666F7228636F6E73747B7265736F757263653A6F2C6D61726B65723A737D6F662074297B636F6E737420743D7472652E5F746F4D61726B657228652C6F2C73293B696628217429636F6E74696E75653B636F6E737420723D692E6765';
wwv_flow_imp.g_varchar2_table(33903) := '74286F293B723F722E707573682874293A28692E736574286F2C5B745D292C6E2E70757368286F29297D666F7228636F6E73745B742C6E5D6F66206929746869732E5F646174612E73657428742C652C6E297D6E2E6C656E6774683E302626746869732E';
wwv_flow_imp.g_varchar2_table(33904) := '5F6F6E4D61726B65724368616E6765642E66697265286E297D7265616428653D4F626A6563742E637265617465286E756C6C29297B6C65747B6F776E65723A742C7265736F757263653A6E2C736576657269746965733A692C74616B653A6F7D3D653B69';
wwv_flow_imp.g_varchar2_table(33905) := '662828216F7C7C6F3C30292626286F3D2D31292C7426266E297B636F6E737420653D746869732E5F646174612E676574286E2C74293B69662865297B636F6E737420743D5B5D3B666F7228636F6E7374206E206F662065296966287472652E5F61636365';
wwv_flow_imp.g_varchar2_table(33906) := '7074286E2C6929297B636F6E737420653D742E70757368286E293B6966286F3E302626653D3D3D6F29627265616B7D72657475726E20747D72657475726E5B5D7D696628747C7C6E297B636F6E737420653D746869732E5F646174612E76616C75657328';
wwv_flow_imp.g_varchar2_table(33907) := '6E756C6C213D6E3F6E3A74292C733D5B5D3B666F7228636F6E73742074206F66206529666F7228636F6E73742065206F662074296966287472652E5F61636365707428652C6929297B636F6E737420743D732E707573682865293B6966286F3E30262674';
wwv_flow_imp.g_varchar2_table(33908) := '3D3D3D6F2972657475726E20737D72657475726E20737D7B636F6E737420653D5B5D3B666F7228636F6E73742074206F6620746869732E5F646174612E76616C756573282929666F7228636F6E7374206E206F662074296966287472652E5F6163636570';
wwv_flow_imp.g_varchar2_table(33909) := '74286E2C6929297B636F6E737420743D652E70757368286E293B6966286F3E302626743D3D3D6F2972657475726E20657D72657475726E20657D7D737461746963205F61636365707428652C74297B72657475726E20766F696420303D3D3D747C7C2874';
wwv_flow_imp.g_varchar2_table(33910) := '26652E7365766572697479293D3D3D652E73657665726974797D737461746963205F6D657267652865297B636F6E737420743D6E6577206F613B666F7228636F6E7374206E206F66206529666F7228636F6E73742065206F66206E29742E73657428652C';
wwv_flow_imp.g_varchar2_table(33911) := '2130293B72657475726E2041727261792E66726F6D28742E6B6579732829297D7D636C617373206E726520657874656E6473206C747B67657420636F6E66696775726174696F6E4D6F64656C28297B72657475726E20746869732E5F636F6E6669677572';
wwv_flow_imp.g_varchar2_table(33912) := '6174696F6E4D6F64656C7D636F6E7374727563746F722865297B737570657228292C746869732E6C6F67536572766963653D652C746869732E5F636F6E66696775726174696F6E4D6F64656C3D6B69652E637265617465456D7074794D6F64656C287468';
wwv_flow_imp.g_varchar2_table(33913) := '69732E6C6F6753657276696365297D72656C6F616428297B72657475726E20746869732E7265736574436F6E66696775726174696F6E4D6F64656C28292C746869732E636F6E66696775726174696F6E4D6F64656C7D676574436F6E6669677572617469';
wwv_flow_imp.g_varchar2_table(33914) := '6F6E44656661756C744F766572726964657328297B72657475726E7B7D7D7265736574436F6E66696775726174696F6E4D6F64656C28297B746869732E5F636F6E66696775726174696F6E4D6F64656C3D6B69652E637265617465456D7074794D6F6465';
wwv_flow_imp.g_varchar2_table(33915) := '6C28746869732E6C6F6753657276696365293B636F6E737420653D79642E6173285470292E676574436F6E66696775726174696F6E50726F7065727469657328293B746869732E757064617465436F6E66696775726174696F6E4D6F64656C284F626A65';
wwv_flow_imp.g_varchar2_table(33916) := '63742E6B6579732865292C65297D757064617465436F6E66696775726174696F6E4D6F64656C28652C74297B636F6E7374206E3D746869732E676574436F6E66696775726174696F6E44656661756C744F766572726964657328293B666F7228636F6E73';
wwv_flow_imp.g_varchar2_table(33917) := '742069206F662065297B636F6E737420653D6E5B695D2C6F3D745B695D3B766F69642030213D3D653F746869732E5F636F6E66696775726174696F6E4D6F64656C2E61646456616C756528692C65293A6F3F746869732E5F636F6E66696775726174696F';
wwv_flow_imp.g_varchar2_table(33918) := '6E4D6F64656C2E61646456616C756528692C6F2E64656661756C74293A746869732E5F636F6E66696775726174696F6E4D6F64656C2E72656D6F766556616C75652869297D7D7D636C6173732069726520657874656E6473206C747B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(33919) := '746F7228652C743D5B5D297B737570657228292C746869732E6C6F676765723D6E6577204864285B652C2E2E2E745D292C746869732E5F726567697374657228652E6F6E4469644368616E67654C6F674C6576656C2828653D3E746869732E7365744C65';
wwv_flow_imp.g_varchar2_table(33920) := '76656C2865292929297D676574206F6E4469644368616E67654C6F674C6576656C28297B72657475726E20746869732E6C6F676765722E6F6E4469644368616E67654C6F674C6576656C7D7365744C6576656C2865297B746869732E6C6F676765722E73';
wwv_flow_imp.g_varchar2_table(33921) := '65744C6576656C2865297D6765744C6576656C28297B72657475726E20746869732E6C6F676765722E6765744C6576656C28297D747261636528652C2E2E2E74297B746869732E6C6F676765722E747261636528652C2E2E2E74297D646562756728652C';
wwv_flow_imp.g_varchar2_table(33922) := '2E2E2E74297B746869732E6C6F676765722E646562756728652C2E2E2E74297D696E666F28652C2E2E2E74297B746869732E6C6F676765722E696E666F28652C2E2E2E74297D7761726E28652C2E2E2E74297B746869732E6C6F676765722E7761726E28';
wwv_flow_imp.g_varchar2_table(33923) := '652C2E2E2E74297D6572726F7228652C2E2E2E74297B746869732E6C6F676765722E6572726F7228652C2E2E2E74297D7D766172206F72653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(33924) := '723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D74';
wwv_flow_imp.g_varchar2_table(33925) := '7970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28';
wwv_flow_imp.g_varchar2_table(33926) := '733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C7372653D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(33927) := '657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D3B636C617373207272657B636F6E7374727563746F722865297B746869732E646973706F7365643D21312C746869732E6D6F64656C3D652C746869732E5F6F6E57696C6C4469';
wwv_flow_imp.g_varchar2_table(33928) := '73706F73653D6E65772043747D6765742074657874456469746F724D6F64656C28297B72657475726E20746869732E6D6F64656C7D646973706F736528297B746869732E646973706F7365643D21302C746869732E5F6F6E57696C6C446973706F73652E';
wwv_flow_imp.g_varchar2_table(33929) := '6669726528297D7D6C6574206172653D636C6173737B636F6E7374727563746F722865297B746869732E6D6F64656C536572766963653D657D6372656174654D6F64656C5265666572656E63652865297B636F6E737420743D746869732E6D6F64656C53';
wwv_flow_imp.g_varchar2_table(33930) := '6572766963652E6765744D6F64656C2865293B72657475726E20743F50726F6D6973652E7265736F6C7665286E6577206874286E65772072726528742929293A50726F6D6973652E72656A656374286E6577204572726F7228224D6F64656C206E6F7420';
wwv_flow_imp.g_varchar2_table(33931) := '666F756E642229297D7D3B6172653D6F7265285B73726528302C6663295D2C617265293B636C617373206C72657B73686F7728297B72657475726E206C72652E4E554C4C5F50524F47524553535F52554E4E45527D6173796E632073686F775768696C65';
wwv_flow_imp.g_varchar2_table(33932) := '28652C74297B617761697420657D7D6C72652E4E554C4C5F50524F47524553535F52554E4E45523D7B646F6E653A28293D3E7B7D2C746F74616C3A28293D3E7B7D2C776F726B65643A28293D3E7B7D7D3B636C617373206372657B696E666F2865297B72';
wwv_flow_imp.g_varchar2_table(33933) := '657475726E20746869732E6E6F74696679287B73657665726974793A69442E496E666F2C6D6573736167653A657D297D7761726E2865297B72657475726E20746869732E6E6F74696679287B73657665726974793A69442E5761726E696E672C6D657373';
wwv_flow_imp.g_varchar2_table(33934) := '6167653A657D297D6572726F722865297B72657475726E20746869732E6E6F74696679287B73657665726974793A69442E4572726F722C6D6573736167653A657D297D6E6F746966792865297B73776974636828652E7365766572697479297B63617365';
wwv_flow_imp.g_varchar2_table(33935) := '2069442E4572726F723A636F6E736F6C652E6572726F7228652E6D657373616765293B627265616B3B636173652069442E5761726E696E673A636F6E736F6C652E7761726E28652E6D657373616765293B627265616B3B64656661756C743A636F6E736F';
wwv_flow_imp.g_varchar2_table(33936) := '6C652E6C6F6728652E6D657373616765297D72657475726E206372652E4E4F5F4F507D70726F6D707428652C742C6E2C69297B72657475726E206372652E4E4F5F4F507D73746174757328652C74297B72657475726E206C742E4E6F6E657D7D6372652E';
wwv_flow_imp.g_varchar2_table(33937) := '4E4F5F4F503D6E657720636C6173737B7D3B6C6574206472653D636C6173737B636F6E7374727563746F722865297B746869732E5F6F6E57696C6C45786563757465436F6D6D616E643D6E65772043742C746869732E5F6F6E4469644578656375746543';
wwv_flow_imp.g_varchar2_table(33938) := '6F6D6D616E643D6E65772043742C746869732E6F6E44696445786563757465436F6D6D616E643D746869732E5F6F6E44696445786563757465436F6D6D616E642E6576656E742C746869732E5F696E7374616E74696174696F6E536572766963653D657D';
wwv_flow_imp.g_varchar2_table(33939) := '65786563757465436F6D6D616E6428652C2E2E2E74297B636F6E7374206E3D6B632E676574436F6D6D616E642865293B696628216E2972657475726E2050726F6D6973652E72656A656374286E6577204572726F722860636F6D6D616E642027247B657D';
wwv_flow_imp.g_varchar2_table(33940) := '27206E6F7420666F756E646029293B7472797B746869732E5F6F6E57696C6C45786563757465436F6D6D616E642E66697265287B636F6D6D616E6449643A652C617267733A747D293B636F6E737420693D746869732E5F696E7374616E74696174696F6E';
wwv_flow_imp.g_varchar2_table(33941) := '536572766963652E696E766F6B6546756E6374696F6E2E6170706C7928746869732E5F696E7374616E74696174696F6E536572766963652C5B6E2E68616E646C65722C2E2E2E745D293B72657475726E20746869732E5F6F6E4469644578656375746543';
wwv_flow_imp.g_varchar2_table(33942) := '6F6D6D616E642E66697265287B636F6D6D616E6449643A652C617267733A747D292C50726F6D6973652E7265736F6C76652869297D63617463682865297B72657475726E2050726F6D6973652E72656A6563742865297D7D7D3B6472653D6F7265285B73';
wwv_flow_imp.g_varchar2_table(33943) := '726528302C7563295D2C647265293B6C6574206872653D636C61737320657874656E6473205269657B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228652C742C6E2C692C6F292C746869732E5F6361636865645265736F6C';
wwv_flow_imp.g_varchar2_table(33944) := '7665723D6E756C6C2C746869732E5F64796E616D69634B657962696E64696E67733D5B5D2C746869732E5F646F6D4E6F64654C697374656E6572733D5B5D3B636F6E737420723D653D3E7B636F6E737420743D6E65772061743B742E6164642862732865';
wwv_flow_imp.g_varchar2_table(33945) := '2C61722E4B45595F444F574E2C28653D3E7B636F6E737420743D6E65772071652865293B746869732E5F646973706174636828742C742E74617267657429262628742E70726576656E7444656661756C7428292C742E73746F7050726F7061676174696F';
wwv_flow_imp.g_varchar2_table(33946) := '6E2829297D2929292C742E61646428627328652C61722E4B45595F55502C28653D3E7B636F6E737420743D6E65772071652865293B746869732E5F73696E676C654D6F646966696572446973706174636828742C742E746172676574292626742E707265';
wwv_flow_imp.g_varchar2_table(33947) := '76656E7444656661756C7428297D2929292C746869732E5F646F6D4E6F64654C697374656E6572732E70757368286E65772075726528652C7429297D2C613D653D3E7B666F72286C657420743D303B743C746869732E5F646F6D4E6F64654C697374656E';
wwv_flow_imp.g_varchar2_table(33948) := '6572732E6C656E6774683B742B2B297B636F6E7374206E3D746869732E5F646F6D4E6F64654C697374656E6572735B745D3B6E2E646F6D4E6F64653D3D3D65262628746869732E5F646F6D4E6F64654C697374656E6572732E73706C69636528742C3129';
wwv_flow_imp.g_varchar2_table(33949) := '2C6E2E646973706F73652829297D7D2C6C3D653D3E7B652E6765744F7074696F6E283631297C7C7228652E676574436F6E7461696E6572446F6D4E6F64652829297D3B746869732E5F726567697374657228732E6F6E436F6465456469746F7241646428';
wwv_flow_imp.g_varchar2_table(33950) := '6C29292C746869732E5F726567697374657228732E6F6E436F6465456469746F7252656D6F76652828653D3E7B652E6765744F7074696F6E283631297C7C6128652E676574436F6E7461696E6572446F6D4E6F64652829297D2929292C732E6C69737443';
wwv_flow_imp.g_varchar2_table(33951) := '6F6465456469746F727328292E666F7245616368286C293B636F6E737420633D653D3E7B7228652E676574436F6E7461696E6572446F6D4E6F64652829297D3B746869732E5F726567697374657228732E6F6E44696666456469746F7241646428632929';
wwv_flow_imp.g_varchar2_table(33952) := '2C746869732E5F726567697374657228732E6F6E44696666456469746F7252656D6F76652828653D3E7B6128652E676574436F6E7461696E6572446F6D4E6F64652829297D2929292C732E6C69737444696666456469746F727328292E666F7245616368';
wwv_flow_imp.g_varchar2_table(33953) := '2863297D61646444796E616D69634B657962696E64696E6728652C742C6E2C69297B72657475726E207374286B632E7265676973746572436F6D6D616E6428652C6E292C746869732E61646444796E616D69634B657962696E64696E6773285B7B6B6579';
wwv_flow_imp.g_varchar2_table(33954) := '62696E64696E673A742C636F6D6D616E643A652C7768656E3A697D5D29297D61646444796E616D69634B657962696E64696E67732865297B636F6E737420743D652E6D61702828653D3E7B76617220743B72657475726E7B6B657962696E64696E673A52';
wwv_flow_imp.g_varchar2_table(33955) := '6528652E6B657962696E64696E672C7465292C636F6D6D616E643A6E756C6C213D3D28743D652E636F6D6D616E64292626766F69642030213D3D743F743A6E756C6C2C636F6D6D616E64417267733A652E636F6D6D616E64417267732C7768656E3A652E';
wwv_flow_imp.g_varchar2_table(33956) := '7768656E2C776569676874313A3165332C776569676874323A302C657874656E73696F6E49643A6E756C6C2C69734275696C74696E457874656E73696F6E3A21317D7D29293B72657475726E20746869732E5F64796E616D69634B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(33957) := '733D746869732E5F64796E616D69634B657962696E64696E67732E636F6E6361742874292C746869732E7570646174655265736F6C76657228292C7274282828293D3E7B666F72286C657420653D303B653C746869732E5F64796E616D69634B65796269';
wwv_flow_imp.g_varchar2_table(33958) := '6E64696E67732E6C656E6774683B652B2B29696628746869732E5F64796E616D69634B657962696E64696E67735B655D3D3D3D745B305D2972657475726E20746869732E5F64796E616D69634B657962696E64696E67732E73706C69636528652C742E6C';
wwv_flow_imp.g_varchar2_table(33959) := '656E677468292C766F696420746869732E7570646174655265736F6C76657228297D29297D7570646174655265736F6C76657228297B746869732E5F6361636865645265736F6C7665723D6E756C6C2C746869732E5F6F6E4469645570646174654B6579';
wwv_flow_imp.g_varchar2_table(33960) := '62696E64696E67732E6669726528297D5F6765745265736F6C76657228297B69662821746869732E5F6361636865645265736F6C766572297B636F6E737420653D746869732E5F746F4E6F726D616C697A65644B657962696E64696E674974656D732843';
wwv_flow_imp.g_varchar2_table(33961) := '642E67657444656661756C744B657962696E64696E677328292C2130292C743D746869732E5F746F4E6F726D616C697A65644B657962696E64696E674974656D7328746869732E5F64796E616D69634B657962696E64696E67732C2131293B746869732E';
wwv_flow_imp.g_varchar2_table(33962) := '5F6361636865645265736F6C7665723D6E65772041696528652C742C28653D3E746869732E5F6C6F6728652929297D72657475726E20746869732E5F6361636865645265736F6C7665727D5F646F63756D656E74486173466F63757328297B7265747572';
wwv_flow_imp.g_varchar2_table(33963) := '6E20732E646F63756D656E742E686173466F63757328297D5F746F4E6F726D616C697A65644B657962696E64696E674974656D7328652C74297B636F6E7374206E3D5B5D3B6C657420693D303B666F7228636F6E7374206F206F662065297B636F6E7374';
wwv_flow_imp.g_varchar2_table(33964) := '20653D6F2E7768656E7C7C766F696420302C733D6F2E6B657962696E64696E673B69662873297B636F6E737420723D4869652E7265736F6C76654B657962696E64696E6728732C7465293B666F7228636F6E73742073206F662072296E5B692B2B5D3D6E';
wwv_flow_imp.g_varchar2_table(33965) := '65772042696528732C6F2E636F6D6D616E642C6F2E636F6D6D616E64417267732C652C742C6E756C6C2C2131297D656C7365206E5B692B2B5D3D6E65772042696528766F696420302C6F2E636F6D6D616E642C6F2E636F6D6D616E64417267732C652C74';
wwv_flow_imp.g_varchar2_table(33966) := '2C6E756C6C2C2131297D72657475726E206E7D7265736F6C76654B6579626F6172644576656E742865297B636F6E737420743D6E657720426528652E6374726C4B65792C652E73686966744B65792C652E616C744B65792C652E6D6574614B65792C652E';
wwv_flow_imp.g_varchar2_table(33967) := '6B6579436F6465293B72657475726E206E657720486965285B745D2C7465297D7D3B6872653D6F7265285B73726528302C6364292C73726528312C7863292C73726528322C4F64292C73726528332C7344292C73726528342C5264292C73726528352C67';
wwv_flow_imp.g_varchar2_table(33968) := '63295D2C687265293B636C6173732075726520657874656E6473206C747B636F6E7374727563746F7228652C74297B737570657228292C746869732E646F6D4E6F64653D652C746869732E5F72656769737465722874297D7D66756E6374696F6E207072';
wwv_flow_imp.g_varchar2_table(33969) := '652865297B72657475726E20652626226F626A656374223D3D747970656F66206526262821652E6F766572726964654964656E7469666965727C7C22737472696E67223D3D747970656F6620652E6F766572726964654964656E74696669657229262628';
wwv_flow_imp.g_varchar2_table(33970) := '21652E7265736F757263657C7C652E7265736F7572636520696E7374616E63656F66204E6F297D6C6574206772653D636C6173737B636F6E7374727563746F722865297B746869732E6C6F67536572766963653D652C746869732E5F6F6E446964436861';
wwv_flow_imp.g_varchar2_table(33971) := '6E6765436F6E66696775726174696F6E3D6E65772043742C746869732E6F6E4469644368616E6765436F6E66696775726174696F6E3D746869732E5F6F6E4469644368616E6765436F6E66696775726174696F6E2E6576656E743B636F6E737420743D6E';
wwv_flow_imp.g_varchar2_table(33972) := '6577206E72652865293B746869732E5F636F6E66696775726174696F6E3D6E65772044696528742E72656C6F616428292C6B69652E637265617465456D7074794D6F64656C2865292C6B69652E637265617465456D7074794D6F64656C2865292C6B6965';
wwv_flow_imp.g_varchar2_table(33973) := '2E637265617465456D7074794D6F64656C2865292C6B69652E637265617465456D7074794D6F64656C2865292C6B69652E637265617465456D7074794D6F64656C2865292C6E6577206F612C6B69652E637265617465456D7074794D6F64656C2865292C';
wwv_flow_imp.g_varchar2_table(33974) := '6E6577206F612C65292C742E646973706F736528297D67657456616C756528652C74297B636F6E7374206E3D22737472696E67223D3D747970656F6620653F653A766F696420302C693D7072652865293F653A7072652874293F743A7B7D3B7265747572';
wwv_flow_imp.g_varchar2_table(33975) := '6E20746869732E5F636F6E66696775726174696F6E2E67657456616C7565286E2C692C766F69642030297D75706461746556616C7565732865297B636F6E737420743D7B646174613A746869732E5F636F6E66696775726174696F6E2E746F4461746128';
wwv_flow_imp.g_varchar2_table(33976) := '297D2C6E3D5B5D3B666F7228636F6E73742074206F662065297B636F6E73745B652C695D3D743B746869732E67657456616C7565286529213D3D69262628746869732E5F636F6E66696775726174696F6E2E75706461746556616C756528652C69292C6E';
wwv_flow_imp.g_varchar2_table(33977) := '2E70757368286529297D6966286E2E6C656E6774683E30297B636F6E737420653D6E657720546965287B6B6579733A6E2C6F76657272696465733A5B5D7D2C742C746869732E5F636F6E66696775726174696F6E2C766F696420302C746869732E6C6F67';
wwv_flow_imp.g_varchar2_table(33978) := '53657276696365293B652E736F757263653D382C746869732E5F6F6E4469644368616E6765436F6E66696775726174696F6E2E666972652865297D72657475726E2050726F6D6973652E7265736F6C766528297D75706461746556616C756528652C742C';
wwv_flow_imp.g_varchar2_table(33979) := '6E2C69297B72657475726E20746869732E75706461746556616C756573285B5B652C745D5D297D696E737065637428652C743D7B7D297B72657475726E20746869732E5F636F6E66696775726174696F6E2E696E737065637428652C742C766F69642030';
wwv_flow_imp.g_varchar2_table(33980) := '297D7D3B6772653D6F7265285B73726528302C5264295D2C677265293B6C6574206D72653D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E636F6E66696775726174696F6E536572766963653D652C746869732E6D6F64656C';
wwv_flow_imp.g_varchar2_table(33981) := '536572766963653D742C746869732E6C616E6775616765536572766963653D6E2C746869732E5F6F6E4469644368616E6765436F6E66696775726174696F6E3D6E65772043742C746869732E636F6E66696775726174696F6E536572766963652E6F6E44';
wwv_flow_imp.g_varchar2_table(33982) := '69644368616E6765436F6E66696775726174696F6E2828653D3E7B746869732E5F6F6E4469644368616E6765436F6E66696775726174696F6E2E66697265287B61666665637465644B6579733A652E61666665637465644B6579732C6166666563747343';
wwv_flow_imp.g_varchar2_table(33983) := '6F6E66696775726174696F6E3A28742C6E293D3E652E61666665637473436F6E66696775726174696F6E286E297D297D29297D67657456616C756528652C742C6E297B636F6E737420693D6D632E697349506F736974696F6E2874293F743A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(33984) := '6F3D693F22737472696E67223D3D747970656F66206E3F6E3A766F696420303A22737472696E67223D3D747970656F6620743F743A766F696420302C733D653F746869732E6765744C616E677561676528652C69293A766F696420303B72657475726E20';
wwv_flow_imp.g_varchar2_table(33985) := '766F696420303D3D3D6F3F746869732E636F6E66696775726174696F6E536572766963652E67657456616C7565287B7265736F757263653A652C6F766572726964654964656E7469666965723A737D293A746869732E636F6E66696775726174696F6E53';
wwv_flow_imp.g_varchar2_table(33986) := '6572766963652E67657456616C7565286F2C7B7265736F757263653A652C6F766572726964654964656E7469666965723A737D297D6765744C616E677561676528652C74297B636F6E7374206E3D746869732E6D6F64656C536572766963652E6765744D';
wwv_flow_imp.g_varchar2_table(33987) := '6F64656C2865293B72657475726E206E3F743F6E2E6765744C616E677561676549644174506F736974696F6E28742E6C696E654E756D6265722C742E636F6C756D6E293A6E2E6765744C616E6775616765496428293A746869732E6C616E677561676553';
wwv_flow_imp.g_varchar2_table(33988) := '6572766963652E67756573734C616E67756167654964427946696C65706174684F7246697273744C696E652865297D7D3B6D72653D6F7265285B73726528302C6670292C73726528312C6663292C73726528322C4C75295D2C6D7265293B6C6574206672';
wwv_flow_imp.g_varchar2_table(33989) := '653D636C6173737B636F6E7374727563746F722865297B746869732E636F6E66696775726174696F6E536572766963653D657D676574454F4C28652C74297B636F6E7374206E3D746869732E636F6E66696775726174696F6E536572766963652E676574';
wwv_flow_imp.g_varchar2_table(33990) := '56616C7565282266696C65732E656F6C222C7B6F766572726964654964656E7469666965723A742C7265736F757263653A657D293B72657475726E206E262622737472696E67223D3D747970656F66206E2626226175746F22213D3D6E3F6E3A247C7C71';
wwv_flow_imp.g_varchar2_table(33991) := '3F225C6E223A225C725C6E227D7D3B6672653D6F7265285B73726528302C6670295D2C667265293B636C617373207672657B636F6E7374727563746F7228297B636F6E737420653D4E6F2E66726F6D287B736368656D653A7672652E534348454D452C61';
wwv_flow_imp.g_varchar2_table(33992) := '7574686F726974793A226D6F64656C222C706174683A222F227D293B746869732E776F726B73706163653D7B69643A4F782C666F6C646572733A5B6E6577205078287B7572693A652C6E616D653A22222C696E6465783A307D295D7D7D676574576F726B';
wwv_flow_imp.g_varchar2_table(33993) := '737061636528297B72657475726E20746869732E776F726B73706163657D676574576F726B7370616365466F6C6465722865297B72657475726E20652626652E736368656D653D3D3D7672652E534348454D453F746869732E776F726B73706163652E66';
wwv_flow_imp.g_varchar2_table(33994) := '6F6C646572735B305D3A6E756C6C7D7D66756E6374696F6E2062726528652C742C6E297B69662821742972657475726E3B69662821286520696E7374616E63656F6620677265292972657475726E3B636F6E737420693D5B5D3B4F626A6563742E6B6579';
wwv_flow_imp.g_varchar2_table(33995) := '732874292E666F72456163682828653D3E7B2866756E6374696F6E2865297B72657475726E20744428295B60656469746F722E247B657D605D7C7C21317D292865292626692E70757368285B60656469746F722E247B657D602C745B655D5D292C6E2626';
wwv_flow_imp.g_varchar2_table(33996) := '66756E6374696F6E2865297B72657475726E20744428295B6064696666456469746F722E247B657D605D7C7C21317D2865292626692E70757368285B6064696666456469746F722E247B657D602C745B655D5D297D29292C692E6C656E6774683E302626';
wwv_flow_imp.g_varchar2_table(33997) := '652E75706461746556616C7565732869297D7672652E534348454D453D22696E6D656D6F7279223B6C6574205F72653D636C6173737B636F6E7374727563746F722865297B746869732E5F6D6F64656C536572766963653D657D68617350726576696577';
wwv_flow_imp.g_varchar2_table(33998) := '48616E646C657228297B72657475726E21317D6173796E63206170706C7928652C74297B636F6E7374206E3D41727261792E697341727261792865293F653A77782E636F6E766572742865292C693D6E6577204D61703B666F7228636F6E73742065206F';
wwv_flow_imp.g_varchar2_table(33999) := '66206E297B69662821286520696E7374616E63656F6620437829297468726F77206E6577204572726F7228226261642065646974202D206F6E6C7920746578742065646974732061726520737570706F7274656422293B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(34000) := '5F6D6F64656C536572766963652E6765744D6F64656C28652E7265736F75726365293B6966282174297468726F77206E6577204572726F7228226261642065646974202D206D6F64656C206E6F7420666F756E6422293B696628226E756D626572223D3D';
wwv_flow_imp.g_varchar2_table(34001) := '747970656F6620652E76657273696F6E49642626742E67657456657273696F6E49642829213D3D652E76657273696F6E4964297468726F77206E6577204572726F722822626164207374617465202D206D6F64656C206368616E67656420696E20746865';
wwv_flow_imp.g_varchar2_table(34002) := '206D65616E74696D6522293B6C6574206E3D692E6765742874293B6E7C7C286E3D5B5D2C692E73657428742C6E29292C6E2E70757368286A712E7265706C6163654D6F76652872682E6C69667428652E74657874456469742E72616E6765292C652E7465';
wwv_flow_imp.g_varchar2_table(34003) := '7874456469742E7465787429297D6C6574206F3D302C733D303B666F7228636F6E73745B652C745D6F66206929652E70757368537461636B456C656D656E7428292C652E70757368456469744F7065726174696F6E73285B5D2C742C2828293D3E5B5D29';
wwv_flow_imp.g_varchar2_table(34004) := '292C652E70757368537461636B456C656D656E7428292C732B3D312C6F2B3D742E6C656E6774683B72657475726E7B6172696153756D6D6172793A61692848322E62756C6B456469745365727669636553756D6D6172792C6F2C73292C69734170706C69';
wwv_flow_imp.g_varchar2_table(34005) := '65643A6F3E307D7D7D3B5F72653D6F7265285B73726528302C6663295D2C5F7265293B6C6574207972653D636C61737320657874656E6473207669657B636F6E7374727563746F7228652C74297B73757065722865292C746869732E5F636F6465456469';
wwv_flow_imp.g_varchar2_table(34006) := '746F72536572766963653D747D73686F77436F6E746578745669657728652C742C6E297B6966282174297B636F6E737420653D746869732E5F636F6465456469746F72536572766963652E676574466F6375736564436F6465456469746F7228297C7C74';
wwv_flow_imp.g_varchar2_table(34007) := '6869732E5F636F6465456469746F72536572766963652E676574416374697665436F6465456469746F7228293B65262628743D652E676574436F6E7461696E6572446F6D4E6F64652829297D72657475726E2073757065722E73686F77436F6E74657874';
wwv_flow_imp.g_varchar2_table(34008) := '5669657728652C742C6E297D7D3B7972653D6F7265285B73726528302C506E65292C73726528312C6763295D2C797265293B6C6574207772653D636C61737320657874656E647320646F657B636F6E7374727563746F7228652C742C6E2C692C6F2C7329';
wwv_flow_imp.g_varchar2_table(34009) := '7B737570657228652C742C6E2C692C6F2C73292C746869732E636F6E666967757265287B626C6F636B4D6F7573653A21317D297D7D3B766172204372653B7772653D6F7265285B73726528302C4F64292C73726528312C7344292C73726528322C6A4529';
wwv_flow_imp.g_varchar2_table(34010) := '2C73726528332C2445292C73726528342C4464292C73726528352C6364295D2C777265292C78702852642C636C61737320657874656E6473206972657B636F6E7374727563746F7228297B7375706572286E6577207A64297D7D2C30292C78702866702C';
wwv_flow_imp.g_varchar2_table(34011) := '6772652C30292C78702847482C6D72652C30292C78702851482C6672652C30292C7870284D782C7672652C30292C7870284B472C636C6173737B6765745572694C6162656C28652C74297B72657475726E2266696C65223D3D3D652E736368656D653F65';
wwv_flow_imp.g_varchar2_table(34012) := '2E6673506174683A652E706174687D676574557269426173656E616D654C6162656C2865297B72657475726E20476C2865297D7D2C30292C7870284F642C636C6173737B7075626C69634C6F673228297B7D7D2C30292C78702858372C636C6173737B61';
wwv_flow_imp.g_varchar2_table(34013) := '73796E6320636F6E6669726D2865297B72657475726E7B636F6E6669726D65643A746869732E646F436F6E6669726D28652E6D6573736167652C652E64657461696C292C636865636B626F78436865636B65643A21317D7D646F436F6E6669726D28652C';
wwv_flow_imp.g_varchar2_table(34014) := '74297B6C6574206E3D653B72657475726E20742626286E3D6E2B225C6E5C6E222B74292C732E636F6E6669726D286E297D6173796E632070726F6D70742865297B76617220742C6E3B6C657420693B696628746869732E646F436F6E6669726D28652E6D';
wwv_flow_imp.g_varchar2_table(34015) := '6573736167652C652E64657461696C29297B636F6E7374206F3D5B2E2E2E6E756C6C213D3D28743D652E627574746F6E73292626766F69642030213D3D743F743A5B5D5D3B652E63616E63656C427574746F6E262622737472696E6722213D747970656F';
wwv_flow_imp.g_varchar2_table(34016) := '6620652E63616E63656C427574746F6E262622626F6F6C65616E22213D747970656F6620652E63616E63656C427574746F6E26266F2E7075736828652E63616E63656C427574746F6E292C693D6177616974286E756C6C3D3D3D286E3D6F5B305D297C7C';
wwv_flow_imp.g_varchar2_table(34017) := '766F696420303D3D3D6E3F766F696420303A6E2E72756E287B636865636B626F78436865636B65643A21317D29297D72657475726E7B726573756C743A697D7D6173796E63206572726F7228652C74297B617761697420746869732E70726F6D7074287B';
wwv_flow_imp.g_varchar2_table(34018) := '747970653A69442E4572726F722C6D6573736167653A652C64657461696C3A747D297D7D2C30292C7870286C562C636C6173737B636F6E7374727563746F7228297B746869732E6973457874656E73696F6E446576656C6F706D656E743D21312C746869';
wwv_flow_imp.g_varchar2_table(34019) := '732E69734275696C743D21317D7D2C30292C78702873442C6372652C30292C7870284A4D2C7472652C30292C7870284C752C636C61737320657874656E6473205A69657B636F6E7374727563746F7228297B737570657228297D7D2C30292C7870287936';
wwv_flow_imp.g_varchar2_table(34020) := '2C636C61737320657874656E6473206C747B636F6E7374727563746F7228297B737570657228292C746869732E5F6F6E436F6C6F725468656D654368616E67653D746869732E5F7265676973746572286E6577204374292C746869732E6F6E446964436F';
wwv_flow_imp.g_varchar2_table(34021) := '6C6F725468656D654368616E67653D746869732E5F6F6E436F6C6F725468656D654368616E67652E6576656E742C746869732E5F6F6E50726F6475637449636F6E5468656D654368616E67653D746869732E5F7265676973746572286E6577204374292C';
wwv_flow_imp.g_varchar2_table(34022) := '746869732E6F6E44696450726F6475637449636F6E5468656D654368616E67653D746869732E5F6F6E50726F6475637449636F6E5468656D654368616E67652E6576656E742C746869732E5F656E7669726F6E6D656E743D4F626A6563742E6372656174';
wwv_flow_imp.g_varchar2_table(34023) := '65286E756C6C292C746869732E5F6275696C74496E50726F6475637449636F6E5468656D653D6E6577207865652C746869732E5F6175746F44657465637448696768436F6E74726173743D21302C746869732E5F6B6E6F776E5468656D65733D6E657720';
wwv_flow_imp.g_varchar2_table(34024) := '4D61702C746869732E5F6B6E6F776E5468656D65732E736574286B65652C506565286B656529292C746869732E5F6B6E6F776E5468656D65732E736574284565652C5065652845656529292C746869732E5F6B6E6F776E5468656D65732E736574284C65';
wwv_flow_imp.g_varchar2_table(34025) := '652C506565284C656529292C746869732E5F6B6E6F776E5468656D65732E736574284465652C5065652844656529293B636F6E737420653D746869732E5F72656769737465722866756E6374696F6E2865297B636F6E737420743D6E65772061742C6E3D';
wwv_flow_imp.g_varchar2_table(34026) := '742E616464286E6577204374292C693D495728293B72657475726E20742E61646428692E6F6E4469644368616E6765282828293D3E6E2E6669726528292929292C652626742E61646428652E6F6E44696450726F6475637449636F6E5468656D65436861';
wwv_flow_imp.g_varchar2_table(34027) := '6E6765282828293D3E6E2E6669726528292929292C7B646973706F73653A28293D3E742E646973706F736528292C6F6E4469644368616E67653A6E2E6576656E742C67657443535328297B636F6E737420743D653F652E67657450726F6475637449636F';
wwv_flow_imp.g_varchar2_table(34028) := '6E5468656D6528293A6E6577207865652C6E3D7B7D2C6F3D5B5D2C733D5B5D3B666F7228636F6E73742065206F6620692E67657449636F6E732829297B636F6E737420693D742E67657449636F6E2865293B696628216929636F6E74696E75653B636F6E';
wwv_flow_imp.g_varchar2_table(34029) := '737420723D692E666F6E742C613D602D2D7673636F64652D69636F6E2D247B652E69647D2D666F6E742D66616D696C79602C6C3D602D2D7673636F64652D69636F6E2D247B652E69647D2D636F6E74656E74603B723F286E5B722E69645D3D722E646566';
wwv_flow_imp.g_varchar2_table(34030) := '696E6974696F6E2C732E707573682860247B617D3A20247B787228722E6964297D3B602C60247B6C7D3A2027247B692E666F6E744368617261637465727D273B60292C6F2E7075736828602E636F6469636F6E2D247B652E69647D3A6265666F7265207B';
wwv_flow_imp.g_varchar2_table(34031) := '20636F6E74656E743A2027247B692E666F6E744368617261637465727D273B20666F6E742D66616D696C793A20247B787228722E6964297D3B207D6029293A28732E707573682860247B6C7D3A2027247B692E666F6E744368617261637465727D273B20';
wwv_flow_imp.g_varchar2_table(34032) := '247B617D3A2027636F6469636F6E273B60292C6F2E7075736828602E636F6469636F6E2D247B652E69647D3A6265666F7265207B20636F6E74656E743A2027247B692E666F6E744368617261637465727D273B207D6029297D666F7228636F6E73742065';
wwv_flow_imp.g_varchar2_table(34033) := '20696E206E297B636F6E737420743D6E5B655D2C693D742E7765696768743F60666F6E742D7765696768743A20247B742E7765696768747D3B603A22222C733D742E7374796C653F60666F6E742D7374796C653A20247B742E7374796C657D3B603A2222';
wwv_flow_imp.g_varchar2_table(34034) := '2C723D742E7372632E6D61702828653D3E60247B537228652E6C6F636174696F6E297D20666F726D61742827247B652E666F726D61747D27296029292E6A6F696E28222C2022293B6F2E70757368286040666F6E742D66616365207B207372633A20247B';
wwv_flow_imp.g_varchar2_table(34035) := '727D3B20666F6E742D66616D696C793A20247B78722865297D3B247B697D247B737D20666F6E742D646973706C61793A20626C6F636B3B207D60297D72657475726E206F2E7075736828603A726F6F74207B20247B732E6A6F696E28222022297D207D60';
wwv_flow_imp.g_varchar2_table(34036) := '292C6F2E6A6F696E28225C6E22297D7D7D287468697329293B746869732E5F636F6469636F6E4353533D652E67657443535328292C746869732E5F7468656D654353533D22222C746869732E5F616C6C4353533D60247B746869732E5F636F6469636F6E';
wwv_flow_imp.g_varchar2_table(34037) := '4353537D5C6E247B746869732E5F7468656D654353537D602C746869732E5F676C6F62616C5374796C65456C656D656E743D6E756C6C2C746869732E5F7374796C65456C656D656E74733D5B5D2C746869732E5F636F6C6F724D61704F76657272696465';
wwv_flow_imp.g_varchar2_table(34038) := '3D6E756C6C2C746869732E7365745468656D65286B6565292C746869732E5F6F6E4F53536368656D654368616E67656428292C746869732E5F726567697374657228652E6F6E4469644368616E6765282828293D3E7B746869732E5F636F6469636F6E43';
wwv_flow_imp.g_varchar2_table(34039) := '53533D652E67657443535328292C746869732E5F75706461746543535328297D2929292C6128732C2228666F726365642D636F6C6F72733A2061637469766529222C2828293D3E7B746869732E5F6F6E4F53536368656D654368616E67656428297D2929';
wwv_flow_imp.g_varchar2_table(34040) := '7D7265676973746572456469746F72436F6E7461696E65722865297B72657475726E2048732865293F746869732E5F7265676973746572536861646F77446F6D436F6E7461696E65722865293A746869732E5F7265676973746572526567756C61724564';
wwv_flow_imp.g_varchar2_table(34041) := '69746F72436F6E7461696E657228297D5F7265676973746572526567756C6172456469746F72436F6E7461696E657228297B72657475726E20746869732E5F676C6F62616C5374796C65456C656D656E747C7C28746869732E5F676C6F62616C5374796C';
wwv_flow_imp.g_varchar2_table(34042) := '65456C656D656E743D597328766F696420302C28653D3E7B652E636C6173734E616D653D226D6F6E61636F2D636F6C6F7273222C652E74657874436F6E74656E743D746869732E5F616C6C4353537D29292C746869732E5F7374796C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(34043) := '732E7075736828746869732E5F676C6F62616C5374796C65456C656D656E7429292C6C742E4E6F6E657D5F7265676973746572536861646F77446F6D436F6E7461696E65722865297B636F6E737420743D597328652C28653D3E7B652E636C6173734E61';
wwv_flow_imp.g_varchar2_table(34044) := '6D653D226D6F6E61636F2D636F6C6F7273222C652E74657874436F6E74656E743D746869732E5F616C6C4353537D29293B72657475726E20746869732E5F7374796C65456C656D656E74732E707573682874292C7B646973706F73653A28293D3E7B666F';
wwv_flow_imp.g_varchar2_table(34045) := '72286C657420653D303B653C746869732E5F7374796C65456C656D656E74732E6C656E6774683B652B2B29696628746869732E5F7374796C65456C656D656E74735B655D3D3D3D742972657475726E20766F696420746869732E5F7374796C65456C656D';
wwv_flow_imp.g_varchar2_table(34046) := '656E74732E73706C69636528652C31297D7D7D646566696E655468656D6528652C74297B696628212F5E5B612D7A302D395C2D5D2B242F692E74657374286529297468726F77206E6577204572726F722822496C6C6567616C207468656D65206E616D65';
wwv_flow_imp.g_varchar2_table(34047) := '2122293B6966282141656528742E6261736529262621416565286529297468726F77206E6577204572726F722822496C6C6567616C207468656D6520626173652122293B746869732E5F6B6E6F776E5468656D65732E73657428652C6E6577204D656528';
wwv_flow_imp.g_varchar2_table(34048) := '652C7429292C4165652865292626746869732E5F6B6E6F776E5468656D65732E666F72456163682828743D3E7B742E626173653D3D3D652626742E6E6F74696679426173655570646174656428297D29292C746869732E5F7468656D652E7468656D654E';
wwv_flow_imp.g_varchar2_table(34049) := '616D653D3D3D652626746869732E7365745468656D652865297D676574436F6C6F725468656D6528297B72657475726E20746869732E5F7468656D657D736574436F6C6F724D61704F766572726964652865297B746869732E5F636F6C6F724D61704F76';
wwv_flow_imp.g_varchar2_table(34050) := '6572726964653D652C746869732E5F7570646174655468656D654F72436F6C6F724D617028297D7365745468656D652865297B6C657420743B743D746869732E5F6B6E6F776E5468656D65732E6861732865293F746869732E5F6B6E6F776E5468656D65';
wwv_flow_imp.g_varchar2_table(34051) := '732E6765742865293A746869732E5F6B6E6F776E5468656D65732E676574286B6565292C746869732E5F75706461746541637475616C5468656D652874297D5F75706461746541637475616C5468656D652865297B652626746869732E5F7468656D6521';
wwv_flow_imp.g_varchar2_table(34052) := '3D3D65262628746869732E5F7468656D653D652C746869732E5F7570646174655468656D654F72436F6C6F724D61702829297D5F6F6E4F53536368656D654368616E67656428297B696628746869732E5F6175746F44657465637448696768436F6E7472';
wwv_flow_imp.g_varchar2_table(34053) := '617374297B636F6E737420653D732E6D617463684D65646961282228666F726365642D636F6C6F72733A206163746976652922292E6D6174636865733B69662865213D3D416228746869732E5F7468656D652E7479706529297B6C657420743B743D4E62';
wwv_flow_imp.g_varchar2_table(34054) := '28746869732E5F7468656D652E74797065293F653F4C65653A4565653A653F4465653A6B65652C746869732E5F75706461746541637475616C5468656D6528746869732E5F6B6E6F776E5468656D65732E676574287429297D7D7D7365744175746F4465';
wwv_flow_imp.g_varchar2_table(34055) := '7465637448696768436F6E74726173742865297B746869732E5F6175746F44657465637448696768436F6E74726173743D652C746869732E5F6F6E4F53536368656D654368616E67656428297D5F7570646174655468656D654F72436F6C6F724D617028';
wwv_flow_imp.g_varchar2_table(34056) := '297B636F6E737420653D5B5D2C743D7B7D2C6E3D7B61646452756C653A6E3D3E7B745B6E5D7C7C28652E70757368286E292C745B6E5D3D2130297D7D3B4965652E6765745468656D696E675061727469636970616E747328292E666F7245616368282865';
wwv_flow_imp.g_varchar2_table(34057) := '3D3E6528746869732E5F7468656D652C6E2C746869732E5F656E7669726F6E6D656E742929293B636F6E737420693D5B5D3B666F7228636F6E73742065206F66205465652E676574436F6C6F72732829297B636F6E737420743D746869732E5F7468656D';
wwv_flow_imp.g_varchar2_table(34058) := '652E676574436F6C6F7228652E69642C2130293B742626692E707573682860247B536D28652E6964297D3A20247B742E746F537472696E6728297D3B60297D6E2E61646452756C6528602E6D6F6E61636F2D656469746F722C202E6D6F6E61636F2D6469';
wwv_flow_imp.g_varchar2_table(34059) := '66662D656469746F722C202E6D6F6E61636F2D636F6D706F6E656E74207B20247B692E6A6F696E28225C6E22297D207D60293B636F6E7374206F3D746869732E5F636F6C6F724D61704F766572726964657C7C746869732E5F7468656D652E746F6B656E';
wwv_flow_imp.g_varchar2_table(34060) := '5468656D652E676574436F6C6F724D617028293B6E2E61646452756C652866756E6374696F6E2865297B636F6E737420743D5B5D3B666F72286C6574206E3D312C693D652E6C656E6774683B6E3C693B6E2B2B297B636F6E737420693D655B6E5D3B745B';
wwv_flow_imp.g_varchar2_table(34061) := '6E5D3D602E6D746B247B6E7D207B20636F6C6F723A20247B697D3B207D607D72657475726E20742E7075736828222E6D746B69207B20666F6E742D7374796C653A206974616C69633B207D22292C742E7075736828222E6D746B62207B20666F6E742D77';
wwv_flow_imp.g_varchar2_table(34062) := '65696768743A20626F6C643B207D22292C742E7075736828222E6D746B75207B20746578742D6465636F726174696F6E3A20756E6465726C696E653B20746578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B207D22292C742E70';
wwv_flow_imp.g_varchar2_table(34063) := '75736828222E6D746B73207B20746578742D6465636F726174696F6E3A206C696E652D7468726F7567683B207D22292C742E7075736828222E6D746B732E6D746B75207B20746578742D6465636F726174696F6E3A20756E6465726C696E65206C696E65';
wwv_flow_imp.g_varchar2_table(34064) := '2D7468726F7567683B20746578742D756E6465726C696E652D706F736974696F6E3A20756E6465723B207D22292C742E6A6F696E28225C6E22297D286F29292C746869732E5F7468656D654353533D652E6A6F696E28225C6E22292C746869732E5F7570';
wwv_flow_imp.g_varchar2_table(34065) := '6461746543535328292C50772E736574436F6C6F724D6170286F292C746869732E5F6F6E436F6C6F725468656D654368616E67652E6669726528746869732E5F7468656D65297D5F75706461746543535328297B746869732E5F616C6C4353533D60247B';
wwv_flow_imp.g_varchar2_table(34066) := '746869732E5F636F6469636F6E4353537D5C6E247B746869732E5F7468656D654353537D602C746869732E5F7374796C65456C656D656E74732E666F72456163682828653D3E652E74657874436F6E74656E743D746869732E5F616C6C43535329297D67';
wwv_flow_imp.g_varchar2_table(34067) := '657446696C6549636F6E5468656D6528297B72657475726E7B68617346696C6549636F6E733A21312C686173466F6C64657249636F6E733A21312C68696465734578706C6F7265724172726F77733A21317D7D67657450726F6475637449636F6E546865';
wwv_flow_imp.g_varchar2_table(34068) := '6D6528297B72657475726E20746869732E5F6275696C74496E50726F6475637449636F6E5468656D657D7D2C30292C78702866632C4C6F652C30292C78702875412C5F6F652C30292C78702863642C2473652C30292C78702877452C636C6173737B7769';
wwv_flow_imp.g_varchar2_table(34069) := '746850726F677265737328652C742C6E297B72657475726E2074287B7265706F72743A28293D3E7B7D7D297D7D2C30292C78702853452C6C72652C30292C78702851422C636C61737320657874656E6473205A427B636F6E7374727563746F7228297B73';
wwv_flow_imp.g_varchar2_table(34070) := '7570657228292C746869732E6170706C69636174696F6E53746F726167653D746869732E5F7265676973746572286E6577205542286E6577204B422C7B68696E743A71422E53544F524147455F494E5F4D454D4F52597D29292C746869732E70726F6669';
wwv_flow_imp.g_varchar2_table(34071) := '6C6553746F726167653D746869732E5F7265676973746572286E6577205542286E6577204B422C7B68696E743A71422E53544F524147455F494E5F4D454D4F52597D29292C746869732E776F726B737061636553746F726167653D746869732E5F726567';
wwv_flow_imp.g_varchar2_table(34072) := '6973746572286E6577205542286E6577204B422C7B68696E743A71422E53544F524147455F494E5F4D454D4F52597D29292C746869732E5F726567697374657228746869732E776F726B737061636553746F726167652E6F6E4469644368616E67655374';
wwv_flow_imp.g_varchar2_table(34073) := '6F726167652828653D3E746869732E656D69744469644368616E676556616C756528312C65292929292C746869732E5F726567697374657228746869732E70726F66696C6553746F726167652E6F6E4469644368616E676553746F726167652828653D3E';
wwv_flow_imp.g_varchar2_table(34074) := '746869732E656D69744469644368616E676556616C756528302C65292929292C746869732E5F726567697374657228746869732E6170706C69636174696F6E53746F726167652E6F6E4469644368616E676553746F726167652828653D3E746869732E65';
wwv_flow_imp.g_varchar2_table(34075) := '6D69744469644368616E676556616C7565282D312C65292929297D67657453746F726167652865297B7377697463682865297B636173652D313A72657475726E20746869732E6170706C69636174696F6E53746F726167653B6361736520303A72657475';
wwv_flow_imp.g_varchar2_table(34076) := '726E20746869732E70726F66696C6553746F726167653B64656661756C743A72657475726E20746869732E776F726B737061636553746F726167657D7D7D2C30292C7870287A5A2C58482C30292C78702879782C5F72652C30292C7870284765652C636C';
wwv_flow_imp.g_varchar2_table(34077) := '6173737B636F6E7374727563746F7228297B746869732E5F6E65766572456D69747465723D6E65772043742C746869732E6F6E4469644368616E676554727573743D746869732E5F6E65766572456D69747465722E6576656E747D6973576F726B737061';
wwv_flow_imp.g_varchar2_table(34078) := '63655472757374656428297B72657475726E21307D7D2C30292C78702876632C6172652C30292C78702859532C4173652C30292C787028544B2C636C6173737B676574206C617374466F63757365644C69737428297B72657475726E20746869732E5F6C';
wwv_flow_imp.g_varchar2_table(34079) := '617374466F63757365645769646765747D636F6E7374727563746F7228297B746869732E646973706F7361626C65733D6E65772061742C746869732E6C697374733D5B5D2C746869732E5F6C617374466F63757365645769646765743D766F696420302C';
wwv_flow_imp.g_varchar2_table(34080) := '746869732E5F686173437265617465645374796C65436F6E74726F6C6C65723D21317D7365744C617374466F63757365644C6973742865297B76617220742C6E3B65213D3D746869732E5F6C617374466F63757365645769646765742626286E756C6C3D';
wwv_flow_imp.g_varchar2_table(34081) := '3D3D28743D746869732E5F6C617374466F6375736564576964676574297C7C766F696420303D3D3D747C7C742E67657448544D4C456C656D656E7428292E636C6173734C6973742E72656D6F766528226C6173742D666F637573656422292C746869732E';
wwv_flow_imp.g_varchar2_table(34082) := '5F6C617374466F63757365645769646765743D652C6E756C6C3D3D3D286E3D746869732E5F6C617374466F6375736564576964676574297C7C766F696420303D3D3D6E7C7C6E2E67657448544D4C456C656D656E7428292E636C6173734C6973742E6164';
wwv_flow_imp.g_varchar2_table(34083) := '6428226C6173742D666F63757365642229297D726567697374657228652C74297B696628746869732E5F686173437265617465645374796C65436F6E74726F6C6C65727C7C28746869732E5F686173437265617465645374796C65436F6E74726F6C6C65';
wwv_flow_imp.g_varchar2_table(34084) := '723D21302C6E657720424928597328292C2222292E7374796C6528544D29292C746869732E6C697374732E736F6D652828743D3E742E7769646765743D3D3D652929297468726F77206E6577204572726F72282243616E6E6F7420726567697374657220';
wwv_flow_imp.g_varchar2_table(34085) := '7468652073616D6520776964676574206D756C7469706C652074696D657322293B636F6E7374206E3D7B7769646765743A652C6578747261436F6E746578744B6579733A747D3B72657475726E20746869732E6C697374732E70757368286E292C717328';
wwv_flow_imp.g_varchar2_table(34086) := '652E67657448544D4C456C656D656E742829292626746869732E7365744C617374466F63757365644C6973742865292C737428652E6F6E446964466F637573282828293D3E746869732E7365744C617374466F63757365644C69737428652929292C7274';
wwv_flow_imp.g_varchar2_table(34087) := '282828293D3E746869732E6C697374732E73706C69636528746869732E6C697374732E696E6465784F66286E292C312929292C652E6F6E446964446973706F7365282828293D3E7B746869732E6C697374733D746869732E6C697374732E66696C746572';
wwv_flow_imp.g_varchar2_table(34088) := '2828653D3E65213D3D6E29292C746869732E5F6C617374466F63757365645769646765743D3D3D652626746869732E7365744C617374466F63757365644C69737428766F69642030297D2929297D646973706F736528297B746869732E646973706F7361';
wwv_flow_imp.g_varchar2_table(34089) := '626C65732E646973706F736528297D7D2C30292C78702878632C6472652C30292C78702824452C6872652C30292C7870284C452C4473652C30292C7870286A452C7972652C30292C78702864452C766F652C30292C78702879452C4F73652C30292C7870';
wwv_flow_imp.g_varchar2_table(34090) := '2871452C7772652C30292C78702844642C4E6A2C30292C787028745A2C636C6173737B6173796E6320706C61795369676E616C28652C74297B7D7D2C30292C66756E6374696F6E2865297B636F6E737420743D6E65772078423B666F7228636F6E73745B';
wwv_flow_imp.g_varchar2_table(34091) := '652C6E5D6F66206B70282929742E73657428652C6E293B636F6E7374206E3D6E65772059736528742C2130293B742E7365742875632C6E292C652E6765743D66756E6374696F6E2865297B697C7C73287B7D293B636F6E7374206F3D742E676574286529';
wwv_flow_imp.g_varchar2_table(34092) := '3B696628216F297468726F77206E6577204572726F7228224D697373696E67207365727669636520222B65293B72657475726E206F20696E7374616E63656F662043703F6E2E696E766F6B6546756E6374696F6E2828743D3E742E67657428652929293A';
wwv_flow_imp.g_varchar2_table(34093) := '6F7D3B6C657420693D21313B636F6E7374206F3D6E65772043743B66756E6374696F6E20732865297B696628692972657475726E206E3B693D21303B666F7228636F6E73745B652C6E5D6F66206B70282929742E6765742865297C7C742E73657428652C';
wwv_flow_imp.g_varchar2_table(34094) := '6E293B666F7228636F6E7374206E20696E206529696628652E6861734F776E50726F7065727479286E29297B636F6E737420693D7063286E293B742E676574286929696E7374616E63656F662043702626742E73657428692C655B6E5D297D636F6E7374';
wwv_flow_imp.g_varchar2_table(34095) := '20733D615728293B666F7228636F6E73742065206F662073297472797B6E2E637265617465496E7374616E63652865297D63617463682865297B6B652865297D72657475726E206F2E6669726528292C6E7D652E696E697469616C697A653D732C652E77';
wwv_flow_imp.g_varchar2_table(34096) := '69746853657276696365733D66756E6374696F6E2865297B696628692972657475726E206528293B636F6E737420743D6E65772061742C6E3D742E616464286F2E6576656E74282828293D3E7B6E2E646973706F736528292C742E61646428652829297D';
wwv_flow_imp.g_varchar2_table(34097) := '2929293B72657475726E20747D7D284372657C7C284372653D7B7D29293B766172205372653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D';
wwv_flow_imp.g_varchar2_table(34098) := '4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F72';
wwv_flow_imp.g_varchar2_table(34099) := '61746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C';
wwv_flow_imp.g_varchar2_table(34100) := '72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D2C7872653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C6929';
wwv_flow_imp.g_varchar2_table(34101) := '7B74286E2C692C65297D7D3B6C6574206B72653D302C4572653D21313B6C6574204C72653D636C61737320657874656E6473204C427B636F6E7374727563746F7228652C742C6E2C692C6F2C722C612C6C2C632C642C682C752C70297B636F6E73742067';
wwv_flow_imp.g_varchar2_table(34102) := '3D7B2E2E2E747D3B672E617269614C6162656C3D672E617269614C6162656C7C7C56322E656469746F725669657741636365737369626C654C6162656C2C672E617269614C6162656C3D672E617269614C6162656C2B223B222B56322E61636365737369';
wwv_flow_imp.g_varchar2_table(34103) := '62696C69747948656C704D6573736167652C737570657228652C672C7B7D2C6E2C692C6F2C722C632C642C682C752C70292C746869732E5F7374616E64616C6F6E654B657962696E64696E67536572766963653D6C20696E7374616E63656F6620687265';
wwv_flow_imp.g_varchar2_table(34104) := '3F6C3A6E756C6C2C66756E6374696F6E2865297B6966282165297B6966284572652972657475726E3B4572653D21307D2166756E6374696F6E2865297B4B723D646F63756D656E742E637265617465456C656D656E74282264697622292C4B722E636C61';
wwv_flow_imp.g_varchar2_table(34105) := '73734E616D653D226D6F6E61636F2D617269612D636F6E7461696E6572223B636F6E737420743D28293D3E7B636F6E737420653D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E20652E636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(34106) := '3D226D6F6E61636F2D616C657274222C652E7365744174747269627574652822726F6C65222C22616C65727422292C652E7365744174747269627574652822617269612D61746F6D6963222C227472756522292C4B722E617070656E644368696C642865';
wwv_flow_imp.g_varchar2_table(34107) := '292C657D3B47723D7428292C51723D7428293B636F6E7374206E3D28293D3E7B636F6E737420653D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E20652E636C6173734E616D653D226D6F6E61636F2D737461';
wwv_flow_imp.g_varchar2_table(34108) := '747573222C652E7365744174747269627574652822617269612D6C697665222C22706F6C69746522292C652E7365744174747269627574652822617269612D61746F6D6963222C227472756522292C4B722E617070656E644368696C642865292C657D3B';
wwv_flow_imp.g_varchar2_table(34109) := '59723D6E28292C5A723D6E28292C652E617070656E644368696C64284B72297D28657C7C732E646F63756D656E742E626F6479297D28672E61726961436F6E7461696E6572456C656D656E74292C4D453D28652C74293D3E6E2E637265617465496E7374';
wwv_flow_imp.g_varchar2_table(34110) := '616E6365284D712C652C742C7B7D292C42453D617D616464436F6D6D616E6428652C742C6E297B69662821746869732E5F7374616E64616C6F6E654B657962696E64696E67536572766963652972657475726E20636F6E736F6C652E7761726E28224361';
wwv_flow_imp.g_varchar2_table(34111) := '6E6E6F742061646420636F6D6D616E6420626563617573652074686520656469746F7220697320636F6E66696775726564207769746820616E20756E7265636F676E697A6564204B657962696E64696E675365727669636522292C6E756C6C3B636F6E73';
wwv_flow_imp.g_varchar2_table(34112) := '7420693D2244594E414D49435F222B202B2B6B72652C6F3D57632E646573657269616C697A65286E293B72657475726E20746869732E5F7374616E64616C6F6E654B657962696E64696E67536572766963652E61646444796E616D69634B657962696E64';
wwv_flow_imp.g_varchar2_table(34113) := '696E6728692C652C742C6F292C697D637265617465436F6E746578744B657928652C74297B72657475726E20746869732E5F636F6E746578744B6579536572766963652E6372656174654B657928652C74297D616464416374696F6E2865297B69662822';
wwv_flow_imp.g_varchar2_table(34114) := '737472696E6722213D747970656F6620652E69647C7C22737472696E6722213D747970656F6620652E6C6162656C7C7C2266756E6374696F6E22213D747970656F6620652E72756E297468726F77206E6577204572726F722822496E76616C6964206163';
wwv_flow_imp.g_varchar2_table(34115) := '74696F6E2064657363726970746F722C20606964602C20606C6162656C6020616E64206072756E60206172652072657175697265642070726F706572746965732122293B69662821746869732E5F7374616E64616C6F6E654B657962696E64696E675365';
wwv_flow_imp.g_varchar2_table(34116) := '72766963652972657475726E20636F6E736F6C652E7761726E282243616E6E6F7420616464206B657962696E64696E6720626563617573652074686520656469746F7220697320636F6E66696775726564207769746820616E20756E7265636F676E697A';
wwv_flow_imp.g_varchar2_table(34117) := '6564204B657962696E64696E675365727669636522292C6C742E4E6F6E653B636F6E737420743D652E69642C6E3D652E6C6162656C2C693D57632E616E642857632E657175616C732822656469746F724964222C746869732E67657449642829292C5763';
wwv_flow_imp.g_varchar2_table(34118) := '2E646573657269616C697A6528652E707265636F6E646974696F6E29292C6F3D652E6B657962696E64696E67732C733D57632E616E6428692C57632E646573657269616C697A6528652E6B657962696E64696E67436F6E7465787429292C723D652E636F';
wwv_flow_imp.g_varchar2_table(34119) := '6E746578744D656E7547726F757049647C7C6E756C6C2C613D652E636F6E746578744D656E754F726465727C7C302C6C3D28742C2E2E2E6E293D3E50726F6D6973652E7265736F6C766528652E72756E28746869732C2E2E2E6E29292C633D6E65772061';
wwv_flow_imp.g_varchar2_table(34120) := '742C643D746869732E676574496428292B223A222B743B696628632E616464286B632E7265676973746572436F6D6D616E6428642C6C29292C72297B636F6E737420653D7B636F6D6D616E643A7B69643A642C7469746C653A6E7D2C7768656E3A692C67';
wwv_flow_imp.g_varchar2_table(34121) := '726F75703A722C6F726465723A617D3B632E6164642849642E617070656E644D656E754974656D284C642E456469746F72436F6E746578742C6529297D69662841727261792E69734172726179286F2929666F7228636F6E73742065206F66206F29632E';
wwv_flow_imp.g_varchar2_table(34122) := '61646428746869732E5F7374616E64616C6F6E654B657962696E64696E67536572766963652E61646444796E616D69634B657962696E64696E6728642C652C6C2C7329293B636F6E737420683D6E6577206A5228642C6E2C6E2C766F696420302C692C28';
wwv_flow_imp.g_varchar2_table(34123) := '282E2E2E74293D3E50726F6D6973652E7265736F6C766528652E72756E28746869732C2E2E2E742929292C746869732E5F636F6E746578744B657953657276696365293B72657475726E20746869732E5F616374696F6E732E73657428742C68292C632E';
wwv_flow_imp.g_varchar2_table(34124) := '616464287274282828293D3E7B746869732E5F616374696F6E732E64656C6574652874297D2929292C637D5F74726967676572436F6D6D616E6428652C74297B696628746869732E5F636F6465456469746F725365727669636520696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(34125) := '66204E6E65297472797B746869732E5F636F6465456469746F72536572766963652E736574416374697665436F6465456469746F722874686973292C73757065722E5F74726967676572436F6D6D616E6428652C74297D66696E616C6C797B746869732E';
wwv_flow_imp.g_varchar2_table(34126) := '5F636F6465456469746F72536572766963652E736574416374697665436F6465456469746F72286E756C6C297D656C73652073757065722E5F74726967676572436F6D6D616E6428652C74297D7D3B4C72653D537265285B78726528322C7563292C7872';
wwv_flow_imp.g_varchar2_table(34127) := '6528332C6763292C78726528342C7863292C78726528352C6364292C78726528362C4971292C78726528372C2445292C78726528382C5062292C78726528392C7344292C7872652831302C5953292C7872652831312C6567292C7872652831322C787829';
wwv_flow_imp.g_varchar2_table(34128) := '5D2C4C7265293B6C6574204472653D636C61737320657874656E6473204C72657B636F6E7374727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C752C702C672C6D297B636F6E737420663D7B2E2E2E747D3B62726528642C66';
wwv_flow_imp.g_varchar2_table(34129) := '2C2131293B636F6E737420763D6C2E7265676973746572456469746F72436F6E7461696E65722865293B22737472696E67223D3D747970656F6620662E7468656D6526266C2E7365745468656D6528662E7468656D65292C766F69642030213D3D662E61';
wwv_flow_imp.g_varchar2_table(34130) := '75746F44657465637448696768436F6E747261737426266C2E7365744175746F44657465637448696768436F6E747261737428426F6F6C65616E28662E6175746F44657465637448696768436F6E747261737429293B636F6E737420623D662E6D6F6465';
wwv_flow_imp.g_varchar2_table(34131) := '6C3B6C6574205F3B69662864656C65746520662E6D6F64656C2C737570657228652C662C6E2C692C6F2C732C722C612C6C2C632C682C672C6D292C746869732E5F636F6E66696775726174696F6E536572766963653D642C746869732E5F7374616E6461';
wwv_flow_imp.g_varchar2_table(34132) := '6C6F6E655468656D65536572766963653D6C2C746869732E5F72656769737465722876292C766F696420303D3D3D62297B636F6E737420653D702E6765744C616E6775616765496442794D696D655479706528662E6C616E6775616765297C7C662E6C61';
wwv_flow_imp.g_varchar2_table(34133) := '6E67756167657C7C55703B5F3D49726528752C702C662E76616C75657C7C22222C652C766F69642030292C746869732E5F6F776E734D6F64656C3D21307D656C7365205F3D622C746869732E5F6F776E734D6F64656C3D21313B696628746869732E5F61';
wwv_flow_imp.g_varchar2_table(34134) := '74746163684D6F64656C285F292C5F297B636F6E737420653D7B6F6C644D6F64656C55726C3A6E756C6C2C6E65774D6F64656C55726C3A5F2E7572697D3B746869732E5F6F6E4469644368616E67654D6F64656C2E666972652865297D7D646973706F73';
wwv_flow_imp.g_varchar2_table(34135) := '6528297B73757065722E646973706F736528297D7570646174654F7074696F6E732865297B62726528746869732E5F636F6E66696775726174696F6E536572766963652C652C2131292C22737472696E67223D3D747970656F6620652E7468656D652626';
wwv_flow_imp.g_varchar2_table(34136) := '746869732E5F7374616E64616C6F6E655468656D65536572766963652E7365745468656D6528652E7468656D65292C766F69642030213D3D652E6175746F44657465637448696768436F6E74726173742626746869732E5F7374616E64616C6F6E655468';
wwv_flow_imp.g_varchar2_table(34137) := '656D65536572766963652E7365744175746F44657465637448696768436F6E747261737428426F6F6C65616E28652E6175746F44657465637448696768436F6E747261737429292C73757065722E7570646174654F7074696F6E732865297D5F706F7374';
wwv_flow_imp.g_varchar2_table(34138) := '4465746163684D6F64656C436C65616E75702865297B73757065722E5F706F73744465746163684D6F64656C436C65616E75702865292C652626746869732E5F6F776E734D6F64656C262628652E646973706F736528292C746869732E5F6F776E734D6F';
wwv_flow_imp.g_varchar2_table(34139) := '64656C3D2131297D7D3B4472653D537265285B78726528322C7563292C78726528332C6763292C78726528342C7863292C78726528352C6364292C78726528362C4971292C78726528372C2445292C78726528382C7936292C78726528392C7344292C78';
wwv_flow_imp.g_varchar2_table(34140) := '72652831302C6670292C7872652831312C5953292C7872652831322C6663292C7872652831332C4C75292C7872652831342C6567292C7872652831352C7878295D2C447265293B6C6574205472653D636C61737320657874656E64732041587B636F6E73';
wwv_flow_imp.g_varchar2_table(34141) := '74727563746F7228652C742C6E2C692C6F2C732C722C612C6C2C632C642C68297B636F6E737420753D7B2E2E2E747D3B62726528612C752C2130293B636F6E737420703D732E7265676973746572456469746F72436F6E7461696E65722865293B227374';
wwv_flow_imp.g_varchar2_table(34142) := '72696E67223D3D747970656F6620752E7468656D652626732E7365745468656D6528752E7468656D65292C766F69642030213D3D752E6175746F44657465637448696768436F6E74726173742626732E7365744175746F44657465637448696768436F6E';
wwv_flow_imp.g_varchar2_table(34143) := '747261737428426F6F6C65616E28752E6175746F44657465637448696768436F6E747261737429292C737570657228652C752C7B7D2C692C6E2C6F2C682C63292C746869732E5F636F6E66696775726174696F6E536572766963653D612C746869732E5F';
wwv_flow_imp.g_varchar2_table(34144) := '7374616E64616C6F6E655468656D65536572766963653D732C746869732E5F72656769737465722870297D646973706F736528297B73757065722E646973706F736528297D7570646174654F7074696F6E732865297B62726528746869732E5F636F6E66';
wwv_flow_imp.g_varchar2_table(34145) := '696775726174696F6E536572766963652C652C2130292C22737472696E67223D3D747970656F6620652E7468656D652626746869732E5F7374616E64616C6F6E655468656D65536572766963652E7365745468656D6528652E7468656D65292C766F6964';
wwv_flow_imp.g_varchar2_table(34146) := '2030213D3D652E6175746F44657465637448696768436F6E74726173742626746869732E5F7374616E64616C6F6E655468656D65536572766963652E7365744175746F44657465637448696768436F6E747261737428426F6F6C65616E28652E6175746F';
wwv_flow_imp.g_varchar2_table(34147) := '44657465637448696768436F6E747261737429292C73757065722E7570646174654F7074696F6E732865297D5F637265617465496E6E6572456469746F7228652C742C6E297B72657475726E20652E637265617465496E7374616E6365284C72652C742C';
wwv_flow_imp.g_varchar2_table(34148) := '6E297D6765744F726967696E616C456469746F7228297B72657475726E2073757065722E6765744F726967696E616C456469746F7228297D6765744D6F646966696564456469746F7228297B72657475726E2073757065722E6765744D6F646966696564';
wwv_flow_imp.g_varchar2_table(34149) := '456469746F7228297D616464436F6D6D616E6428652C742C6E297B72657475726E20746869732E6765744D6F646966696564456469746F7228292E616464436F6D6D616E6428652C742C6E297D637265617465436F6E746578744B657928652C74297B72';
wwv_flow_imp.g_varchar2_table(34150) := '657475726E20746869732E6765744D6F646966696564456469746F7228292E637265617465436F6E746578744B657928652C74297D616464416374696F6E2865297B72657475726E20746869732E6765744D6F646966696564456469746F7228292E6164';
wwv_flow_imp.g_varchar2_table(34151) := '64416374696F6E2865297D7D3B66756E6374696F6E2049726528652C742C6E2C692C6F297B6966286E3D6E7C7C22222C2169297B636F6E737420693D6E2E696E6465784F6628225C6E22293B6C657420733D6E3B72657475726E2D31213D3D6926262873';
wwv_flow_imp.g_varchar2_table(34152) := '3D6E2E737562737472696E6728302C6929292C4D726528652C6E2C742E637265617465427946696C65706174684F7246697273744C696E65286F7C7C6E756C6C2C73292C6F297D72657475726E204D726528652C6E2C742E637265617465427949642869';
wwv_flow_imp.g_varchar2_table(34153) := '292C6F297D66756E6374696F6E204D726528652C742C6E2C69297B72657475726E20652E6372656174654D6F64656C28742C6E2C69297D5472653D537265285B78726528322C7563292C78726528332C6364292C78726528342C6763292C78726528352C';
wwv_flow_imp.g_varchar2_table(34154) := '7936292C78726528362C7344292C78726528372C6670292C78726528382C7145292C78726528392C5345292C7872652831302C7945292C7872652831312C745A295D2C547265293B766172204172653D6E2836353134292C4E72653D7B7D3B4E72652E73';
wwv_flow_imp.g_varchar2_table(34155) := '74796C655461675472616E73666F726D3D6A7228292C4E72652E736574417474726962757465733D567228292C4E72652E696E736572743D467228292E62696E64286E756C6C2C226865616422292C4E72652E646F6D4150493D4F7228292C4E72652E69';
wwv_flow_imp.g_varchar2_table(34156) := '6E736572745374796C65456C656D656E743D487228292C4E722829284172652E412C4E7265292C4172652E4126264172652E412E6C6F63616C7326264172652E412E6C6F63616C733B636C617373205072657B636F6E7374727563746F7228652C74297B';
wwv_flow_imp.g_varchar2_table(34157) := '746869732E766965774D6F64656C3D652C746869732E64656C74615363726F6C6C566572746963616C3D747D676574496428297B72657475726E20746869732E766965774D6F64656C7D7D6C6574204F72653D636C61737320657874656E6473206C747B';
wwv_flow_imp.g_varchar2_table(34158) := '636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F636F6E7461696E65723D652C746869732E5F6F766572666C6F7757696467657473446F6D4E6F64653D742C746869732E5F776F726B62656E63685549456C656D65';
wwv_flow_imp.g_varchar2_table(34159) := '6E74466163746F72793D6E2C746869732E5F696E7374616E74696174696F6E536572766963653D692C746869732E5F766965774D6F64656C3D245428746869732C766F69642030292C746869732E5F636F6C6C61707365643D515428746869732C28653D';
wwv_flow_imp.g_varchar2_table(34160) := '3E7B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E5F766965774D6F64656C2E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E636F6C6C61707365642E726561642865297D29292C746869732E5F6564';
wwv_flow_imp.g_varchar2_table(34161) := '69746F72436F6E74656E744865696768743D245428746869732C353030292C746869732E636F6E74656E744865696768743D515428746869732C28653D3E28746869732E5F636F6C6C61707365642E726561642865293F303A746869732E5F656469746F';
wwv_flow_imp.g_varchar2_table(34162) := '72436F6E74656E744865696768742E72656164286529292B746869732E5F6F75746572456469746F7248656967687429292C746869732E5F6D6F646966696564436F6E74656E7457696474683D245428746869732C30292C746869732E5F6D6F64696669';
wwv_flow_imp.g_varchar2_table(34163) := '656457696474683D245428746869732C30292C746869732E5F6F726967696E616C436F6E74656E7457696474683D245428746869732C30292C746869732E5F6F726967696E616C57696474683D245428746869732C30292C746869732E6D61785363726F';
wwv_flow_imp.g_varchar2_table(34164) := '6C6C3D515428746869732C28653D3E7B636F6E737420743D746869732E5F6D6F646966696564436F6E74656E7457696474682E726561642865292D746869732E5F6D6F64696669656457696474682E726561642865292C6E3D746869732E5F6F72696769';
wwv_flow_imp.g_varchar2_table(34165) := '6E616C436F6E74656E7457696474682E726561642865292D746869732E5F6F726967696E616C57696474682E726561642865293B72657475726E20743E6E3F7B6D61785363726F6C6C3A742C77696474683A746869732E5F6D6F64696669656457696474';
wwv_flow_imp.g_varchar2_table(34166) := '682E726561642865297D3A7B6D61785363726F6C6C3A6E2C77696474683A746869732E5F6F726967696E616C57696474682E726561642865297D7D29292C746869732E5F656C656D656E74733D497228226469762E6D756C746944696666456E74727922';
wwv_flow_imp.g_varchar2_table(34167) := '2C5B497228226469762E68656164657240686561646572222C5B497228226469762E6865616465722D636F6E74656E74222C5B497228226469762E636F6C6C617073652D627574746F6E40636F6C6C61707365427574746F6E22292C497228226469762E';
wwv_flow_imp.g_varchar2_table(34168) := '66696C652D70617468222C5B497228226469762E7469746C652E6D6F6469666965642E73686F772D66696C652D69636F6E73407072696D61727950617468222C5B5D292C497228226469762E7374617475732E64656C6574656440737461747573222C5B';
wwv_flow_imp.g_varchar2_table(34169) := '2252225D292C497228226469762E7469746C652E6F726967696E616C2E73686F772D66696C652D69636F6E73407365636F6E6461727950617468222C5B5D295D292C497228226469762E616374696F6E7340616374696F6E7322295D295D292C49722822';
wwv_flow_imp.g_varchar2_table(34170) := '6469762E656469746F72506172656E74222C5B497228226469762E656469746F72436F6E7461696E657240656469746F7222295D295D292C746869732E656469746F723D746869732E5F726567697374657228746869732E5F696E7374616E7469617469';
wwv_flow_imp.g_varchar2_table(34171) := '6F6E536572766963652E637265617465496E7374616E63652841582C746869732E5F656C656D656E74732E656469746F722C7B6F766572666C6F7757696467657473446F6D4E6F64653A746869732E5F6F766572666C6F7757696467657473446F6D4E6F';
wwv_flow_imp.g_varchar2_table(34172) := '64657D2C7B7D29292C746869732E69734D6F6469666564466F63757365643D52726528746869732E656469746F722E6765744D6F646966696564456469746F722829292C746869732E69734F726967696E616C466F63757365643D52726528746869732E';
wwv_flow_imp.g_varchar2_table(34173) := '656469746F722E6765744F726967696E616C456469746F722829292C746869732E6973466F63757365643D515428746869732C28653D3E746869732E69734D6F6469666564466F63757365642E726561642865297C7C746869732E69734F726967696E61';
wwv_flow_imp.g_varchar2_table(34174) := '6C466F63757365642E7265616428652929292C746869732E5F7265736F757263654C6162656C3D746869732E5F776F726B62656E63685549456C656D656E74466163746F72792E6372656174655265736F757263654C6162656C3F746869732E5F726567';
wwv_flow_imp.g_varchar2_table(34175) := '697374657228746869732E5F776F726B62656E63685549456C656D656E74466163746F72792E6372656174655265736F757263654C6162656C28746869732E5F656C656D656E74732E7072696D6172795061746829293A766F696420302C746869732E5F';
wwv_flow_imp.g_varchar2_table(34176) := '7265736F757263654C6162656C323D746869732E5F776F726B62656E63685549456C656D656E74466163746F72792E6372656174655265736F757263654C6162656C3F746869732E5F726567697374657228746869732E5F776F726B62656E6368554945';
wwv_flow_imp.g_varchar2_table(34177) := '6C656D656E74466163746F72792E6372656174655265736F757263654C6162656C28746869732E5F656C656D656E74732E7365636F6E646172795061746829293A766F696420302C746869732E5F6461746153746F72653D6E65772061742C746869732E';
wwv_flow_imp.g_varchar2_table(34178) := '5F6865616465724865696768743D34302C746869732E5F6C6173745363726F6C6C546F703D2D312C746869732E5F697353657474696E675363726F6C6C546F703D21313B636F6E7374206F3D6E6577207A4528746869732E5F656C656D656E74732E636F';
wwv_flow_imp.g_varchar2_table(34179) := '6C6C61707365427574746F6E2C7B7D293B746869732E5F72656769737465722865492828653D3E7B6F2E656C656D656E742E636C6173734E616D653D22222C6F2E69636F6E3D746869732E5F636F6C6C61707365642E726561642865293F4C6C2E636865';
wwv_flow_imp.g_varchar2_table(34180) := '76726F6E52696768743A4C6C2E63686576726F6E446F776E7D2929292C746869732E5F7265676973746572286F2E6F6E446964436C69636B282828293D3E7B76617220653B6E756C6C3D3D3D28653D746869732E5F766965774D6F64656C2E6765742829';
wwv_flow_imp.g_varchar2_table(34181) := '297C7C766F696420303D3D3D657C7C652E636F6C6C61707365642E7365742821746869732E5F636F6C6C61707365642E67657428292C766F69642030297D2929292C746869732E5F72656769737465722865492828653D3E7B746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(34182) := '6E74732E656469746F722E7374796C652E646973706C61793D746869732E5F636F6C6C61707365642E726561642865293F226E6F6E65223A22626C6F636B227D2929292C746869732E5F726567697374657228746869732E656469746F722E6765744D6F';
wwv_flow_imp.g_varchar2_table(34183) := '646966696564456469746F7228292E6F6E4469644C61796F75744368616E67652828653D3E7B636F6E737420743D746869732E656469746F722E6765744D6F646966696564456469746F7228292E6765744C61796F7574496E666F28292E636F6E74656E';
wwv_flow_imp.g_varchar2_table(34184) := '7457696474683B746869732E5F6D6F64696669656457696474682E73657428742C766F69642030297D2929292C746869732E5F726567697374657228746869732E656469746F722E6765744F726967696E616C456469746F7228292E6F6E4469644C6179';
wwv_flow_imp.g_varchar2_table(34185) := '6F75744368616E67652828653D3E7B636F6E737420743D746869732E656469746F722E6765744F726967696E616C456469746F7228292E6765744C61796F7574496E666F28292E636F6E74656E7457696474683B746869732E5F6F726967696E616C5769';
wwv_flow_imp.g_varchar2_table(34186) := '6474682E73657428742C766F69642030297D2929292C746869732E5F726567697374657228746869732E656469746F722E6F6E446964436F6E74656E7453697A654368616E67652828653D3E7B57542828743D3E7B746869732E5F656469746F72436F6E';
wwv_flow_imp.g_varchar2_table(34187) := '74656E744865696768742E73657428652E636F6E74656E744865696768742C74292C746869732E5F6D6F646966696564436F6E74656E7457696474682E73657428746869732E656469746F722E6765744D6F646966696564456469746F7228292E676574';
wwv_flow_imp.g_varchar2_table(34188) := '436F6E74656E74576964746828292C74292C746869732E5F6F726967696E616C436F6E74656E7457696474682E73657428746869732E656469746F722E6765744F726967696E616C456469746F7228292E676574436F6E74656E74576964746828292C74';
wwv_flow_imp.g_varchar2_table(34189) := '297D29297D2929292C746869732E5F726567697374657228746869732E656469746F722E6765744F726967696E616C456469746F7228292E6F6E4469645363726F6C6C4368616E67652828653D3E7B696628746869732E5F697353657474696E67536372';
wwv_flow_imp.g_varchar2_table(34190) := '6F6C6C546F702972657475726E3B69662821652E7363726F6C6C546F704368616E6765647C7C21746869732E5F646174612972657475726E3B636F6E737420743D652E7363726F6C6C546F702D746869732E5F6C6173745363726F6C6C546F703B746869';
wwv_flow_imp.g_varchar2_table(34191) := '732E5F646174612E64656C74615363726F6C6C566572746963616C2874297D2929292C746869732E5F72656769737465722865492828653D3E7B76617220743B636F6E7374206E3D6E756C6C3D3D3D28743D746869732E5F766965774D6F64656C2E7265';
wwv_flow_imp.g_varchar2_table(34192) := '6164286529297C7C766F696420303D3D3D743F766F696420303A742E69734163746976652E726561642865293B746869732E5F656C656D656E74732E726F6F742E636C6173734C6973742E746F67676C652822616374697665222C6E297D2929292C7468';
wwv_flow_imp.g_varchar2_table(34193) := '69732E5F636F6E7461696E65722E617070656E644368696C6428746869732E5F656C656D656E74732E726F6F74292C746869732E5F6F75746572456469746F724865696768743D746869732E5F6865616465724865696768742C746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(34194) := '7374657228746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E636528576A2C746869732E5F656C656D656E74732E616374696F6E732C4C642E4D756C746944696666456469746F7246696C65546F6F6C62';
wwv_flow_imp.g_varchar2_table(34195) := '61722C7B616374696F6E52756E6E65723A746869732E5F7265676973746572286E6577206358282828293D3E7B76617220653B72657475726E206E756C6C3D3D3D28653D746869732E5F766965774D6F64656C2E6765742829297C7C766F696420303D3D';
wwv_flow_imp.g_varchar2_table(34196) := '3D653F766F696420303A652E6D6F6469666965645572697D2929292C6D656E754F7074696F6E733A7B73686F756C64466F7277617264417267733A21307D2C746F6F6C6261724F7074696F6E733A7B7072696D61727947726F75703A653D3E652E737461';
wwv_flow_imp.g_varchar2_table(34197) := '7274735769746828226E617669676174696F6E22297D2C616374696F6E566965774974656D50726F76696465723A28652C74293D3E786A28692C652C74297D29297D7365745363726F6C6C4C6566742865297B746869732E5F6D6F646966696564436F6E';
wwv_flow_imp.g_varchar2_table(34198) := '74656E7457696474682E67657428292D746869732E5F6D6F64696669656457696474682E67657428293E746869732E5F6F726967696E616C436F6E74656E7457696474682E67657428292D746869732E5F6F726967696E616C57696474682E6765742829';
wwv_flow_imp.g_varchar2_table(34199) := '3F746869732E656469746F722E6765744D6F646966696564456469746F7228292E7365745363726F6C6C4C6566742865293A746869732E656469746F722E6765744F726967696E616C456469746F7228292E7365745363726F6C6C4C6566742865297D73';
wwv_flow_imp.g_varchar2_table(34200) := '6574446174612865297B66756E6374696F6E20742865297B72657475726E7B2E2E2E652C7363726F6C6C4265796F6E644C6173744C696E653A21312C68696465556E6368616E676564526567696F6E733A7B656E61626C65643A21307D2C7363726F6C6C';
wwv_flow_imp.g_varchar2_table(34201) := '6261723A7B766572746963616C3A2268696464656E222C686F72697A6F6E74616C3A2268696464656E222C68616E646C654D6F757365576865656C3A21312C757365536861646F77733A21317D2C72656E6465724F7665727669657752756C65723A2131';
wwv_flow_imp.g_varchar2_table(34202) := '2C66697865644F766572666C6F77576964676574733A21302C6F7665727669657752756C6572426F726465723A21317D7D746869732E5F646174613D653B636F6E7374206E3D652E766965774D6F64656C2E656E7472792E76616C75653B6E2E6F6E4F70';
wwv_flow_imp.g_varchar2_table(34203) := '74696F6E734469644368616E67652626746869732E5F6461746153746F72652E616464286E2E6F6E4F7074696F6E734469644368616E6765282828293D3E7B76617220653B746869732E656469746F722E7570646174654F7074696F6E732874286E756C';
wwv_flow_imp.g_varchar2_table(34204) := '6C213D3D28653D6E2E6F7074696F6E73292626766F69642030213D3D653F653A7B7D29297D2929292C57542828693D3E7B766172206F2C732C722C613B6E756C6C3D3D3D286F3D746869732E5F7265736F757263654C6162656C297C7C766F696420303D';
wwv_flow_imp.g_varchar2_table(34205) := '3D3D6F7C7C6F2E736574557269286E756C6C213D3D28733D652E766965774D6F64656C2E6D6F646966696564557269292626766F69642030213D3D733F733A652E766965774D6F64656C2E6F726967696E616C5572692C7B737472696B657468726F7567';
wwv_flow_imp.g_varchar2_table(34206) := '683A766F696420303D3D3D652E766965774D6F64656C2E6D6F6469666965645572697D293B6C6574206C3D21312C633D21312C643D21312C683D22223B652E766965774D6F64656C2E6D6F6469666965645572692626652E766965774D6F64656C2E6F72';
wwv_flow_imp.g_varchar2_table(34207) := '6967696E616C5572692626652E766965774D6F64656C2E6D6F6469666965645572692E70617468213D3D652E766965774D6F64656C2E6F726967696E616C5572692E706174683F28683D2252222C6C3D2130293A652E766965774D6F64656C2E6D6F6469';
wwv_flow_imp.g_varchar2_table(34208) := '666965645572693F652E766965774D6F64656C2E6F726967696E616C5572697C7C28683D2241222C643D2130293A28683D2244222C633D2130292C746869732E5F656C656D656E74732E7374617475732E636C6173734C6973742E746F67676C65282272';
wwv_flow_imp.g_varchar2_table(34209) := '656E616D6564222C6C292C746869732E5F656C656D656E74732E7374617475732E636C6173734C6973742E746F67676C65282264656C65746564222C63292C746869732E5F656C656D656E74732E7374617475732E636C6173734C6973742E746F67676C';
wwv_flow_imp.g_varchar2_table(34210) := '6528226164646564222C64292C746869732E5F656C656D656E74732E7374617475732E696E6E6572546578743D682C6E756C6C3D3D3D28723D746869732E5F7265736F757263654C6162656C32297C7C766F696420303D3D3D727C7C722E736574557269';
wwv_flow_imp.g_varchar2_table(34211) := '286C3F652E766965774D6F64656C2E6F726967696E616C5572693A766F696420302C7B737472696B657468726F7567683A21307D292C746869732E5F6461746153746F72652E636C65617228292C746869732E5F766965774D6F64656C2E73657428652E';
wwv_flow_imp.g_varchar2_table(34212) := '766965774D6F64656C2C69292C746869732E656469746F722E7365744D6F64656C28652E766965774D6F64656C2E64696666456469746F72566965774D6F64656C2C69292C746869732E656469746F722E7570646174654F7074696F6E732874286E756C';
wwv_flow_imp.g_varchar2_table(34213) := '6C213D3D28613D6E2E6F7074696F6E73292626766F69642030213D3D613F613A7B7D29297D29297D72656E64657228652C742C6E2C69297B746869732E5F656C656D656E74732E726F6F742E7374796C652E7669736962696C6974793D2276697369626C';
wwv_flow_imp.g_varchar2_table(34214) := '65222C746869732E5F656C656D656E74732E726F6F742E7374796C652E746F703D60247B652E73746172747D7078602C746869732E5F656C656D656E74732E726F6F742E7374796C652E6865696768743D60247B652E6C656E6774687D7078602C746869';
wwv_flow_imp.g_varchar2_table(34215) := '732E5F656C656D656E74732E726F6F742E7374796C652E77696474683D60247B747D7078602C746869732E5F656C656D656E74732E726F6F742E7374796C652E706F736974696F6E3D226162736F6C757465223B636F6E7374206F3D652E6C656E677468';
wwv_flow_imp.g_varchar2_table(34216) := '2D746869732E5F6865616465724865696768742C733D4D6174682E6D617828302C4D6174682E6D696E28692E73746172742D652E73746172742C6F29293B746869732E5F656C656D656E74732E6865616465722E7374796C652E7472616E73666F726D3D';
wwv_flow_imp.g_varchar2_table(34217) := '607472616E736C6174655928247B737D707829602C575428286E3D3E7B746869732E656469746F722E6C61796F7574287B77696474683A742D31362D322C6865696768743A652E6C656E6774682D746869732E5F6F75746572456469746F724865696768';
wwv_flow_imp.g_varchar2_table(34218) := '747D297D29293B7472797B746869732E5F697353657474696E675363726F6C6C546F703D21302C746869732E5F6C6173745363726F6C6C546F703D6E2C746869732E656469746F722E6765744F726967696E616C456469746F7228292E7365745363726F';
wwv_flow_imp.g_varchar2_table(34219) := '6C6C546F70286E297D66696E616C6C797B746869732E5F697353657474696E675363726F6C6C546F703D21317D746869732E5F656C656D656E74732E6865616465722E636C6173734C6973742E746F67676C652822736861646F77222C733E307C7C6E3E';
wwv_flow_imp.g_varchar2_table(34220) := '30292C746869732E5F656C656D656E74732E6865616465722E636C6173734C6973742E746F67676C652822636F6C6C6170736564222C733D3D3D6F297D6869646528297B746869732E5F656C656D656E74732E726F6F742E7374796C652E746F703D222D';
wwv_flow_imp.g_varchar2_table(34221) := '3130303030307078222C746869732E5F656C656D656E74732E726F6F742E7374796C652E7669736962696C6974793D2268696464656E227D7D3B66756E6374696F6E205272652865297B72657475726E2061492828743D3E7B636F6E7374206E3D6E6577';
wwv_flow_imp.g_varchar2_table(34222) := '2061743B72657475726E206E2E61646428652E6F6E446964466F637573456469746F72576964676574282828293D3E74282130292929292C6E2E61646428652E6F6E446964426C7572456469746F72576964676574282828293D3E74282131292929292C';
wwv_flow_imp.g_varchar2_table(34223) := '6E7D292C2828293D3E652E68617354657874466F637573282929297D4F72653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A656374';
wwv_flow_imp.g_varchar2_table(34224) := '2E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D';
wwv_flow_imp.g_varchar2_table(34225) := '5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F2874';
wwv_flow_imp.g_varchar2_table(34226) := '2C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C6529';
wwv_flow_imp.g_varchar2_table(34227) := '7D7D28332C7563295D2C4F7265293B636C617373204672657B636F6E7374727563746F722865297B746869732E5F6372656174653D652C746869732E5F756E757365643D6E6577205365742C746869732E5F757365643D6E6577205365742C746869732E';
wwv_flow_imp.g_varchar2_table(34228) := '5F6974656D446174613D6E6577204D61707D676574556E757365644F626A2865297B76617220743B6C6574206E3B696628303D3D3D746869732E5F756E757365642E73697A65296E3D746869732E5F6372656174652865292C746869732E5F6974656D44';
wwv_flow_imp.g_varchar2_table(34229) := '6174612E736574286E2C65293B656C73657B636F6E737420693D5B2E2E2E746869732E5F756E757365642E76616C75657328295D3B6E3D6E756C6C213D3D28743D692E66696E642828743D3E746869732E5F6974656D446174612E6765742874292E6765';
wwv_flow_imp.g_varchar2_table(34230) := '74496428293D3D3D652E676574496428292929292626766F69642030213D3D743F743A695B305D2C746869732E5F756E757365642E64656C657465286E292C746869732E5F6974656D446174612E736574286E2C65292C6E2E736574446174612865297D';
wwv_flow_imp.g_varchar2_table(34231) := '72657475726E20746869732E5F757365642E616464286E292C7B6F626A6563743A6E2C646973706F73653A28293D3E7B746869732E5F757365642E64656C657465286E292C746869732E5F756E757365642E73697A653E353F6E2E646973706F73652829';
wwv_flow_imp.g_varchar2_table(34232) := '3A746869732E5F756E757365642E616464286E297D7D7D646973706F736528297B666F7228636F6E73742065206F6620746869732E5F7573656429652E646973706F736528293B666F7228636F6E73742065206F6620746869732E5F756E757365642965';
wwv_flow_imp.g_varchar2_table(34233) := '2E646973706F736528293B746869732E5F757365642E636C65617228292C746869732E5F756E757365642E636C65617228297D7D766172204272653D66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C69';
wwv_flow_imp.g_varchar2_table(34234) := '2C65297D7D3B6C6574205672653D636C61737320657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228292C746869732E5F656C656D656E743D652C746869732E5F64696D656E73696F6E3D742C7468';
wwv_flow_imp.g_varchar2_table(34235) := '69732E5F766965774D6F64656C3D6E2C746869732E5F776F726B62656E63685549456C656D656E74466163746F72793D692C746869732E5F706172656E74436F6E746578744B6579536572766963653D6F2C746869732E5F706172656E74496E7374616E';
wwv_flow_imp.g_varchar2_table(34236) := '74696174696F6E536572766963653D732C746869732E5F656C656D656E74733D497228226469762E6D6F6E61636F2D636F6D706F6E656E742E6D756C746944696666456469746F72222C5B4972282264697640636F6E74656E74222C7B7374796C653A7B';
wwv_flow_imp.g_varchar2_table(34237) := '6F766572666C6F773A2268696464656E227D7D292C497228226469762E6D6F6E61636F2D656469746F72406F766572666C6F7757696467657473446F6D4E6F6465222C7B7D295D292C746869732E5F73697A654F627365727665723D746869732E5F7265';
wwv_flow_imp.g_varchar2_table(34238) := '676973746572286E657720715928746869732E5F656C656D656E742C766F6964203029292C746869732E5F6F626A656374506F6F6C3D746869732E5F7265676973746572286E6577204672652828653D3E7B636F6E737420743D746869732E5F696E7374';
wwv_flow_imp.g_varchar2_table(34239) := '616E74696174696F6E536572766963652E637265617465496E7374616E6365284F72652C746869732E5F656C656D656E74732E636F6E74656E742C746869732E5F656C656D656E74732E6F766572666C6F7757696467657473446F6D4E6F64652C746869';
wwv_flow_imp.g_varchar2_table(34240) := '732E5F776F726B62656E63685549456C656D656E74466163746F7279293B72657475726E20742E736574446174612865292C747D2929292C746869732E5F7363726F6C6C61626C653D746869732E5F7265676973746572286E6577206E54287B666F7263';
wwv_flow_imp.g_varchar2_table(34241) := '65496E746567657256616C7565733A21312C7363686564756C6541744E657874416E696D6174696F6E4672616D653A653D3E787328727328746869732E5F656C656D656E74292C65292C736D6F6F74685363726F6C6C4475726174696F6E3A3130307D29';
wwv_flow_imp.g_varchar2_table(34242) := '292C746869732E5F7363726F6C6C61626C65456C656D656E743D746869732E5F7265676973746572286E657720705428746869732E5F656C656D656E74732E726F6F742C7B766572746963616C3A312C686F72697A6F6E74616C3A312C75736553686164';
wwv_flow_imp.g_varchar2_table(34243) := '6F77733A21317D2C746869732E5F7363726F6C6C61626C6529292C746869732E7363726F6C6C546F703D614928746869732E5F7363726F6C6C61626C65456C656D656E742E6F6E5363726F6C6C2C2828293D3E746869732E5F7363726F6C6C61626C6545';
wwv_flow_imp.g_varchar2_table(34244) := '6C656D656E742E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C546F7029292C746869732E7363726F6C6C4C6566743D614928746869732E5F7363726F6C6C61626C65456C656D656E742E6F6E5363726F6C6C2C2828293D3E74686973';
wwv_flow_imp.g_varchar2_table(34245) := '2E5F7363726F6C6C61626C65456C656D656E742E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C4C65667429292C746869732E5F766965774974656D73496E666F3D5A5428746869732C2828652C74293D3E7B636F6E7374206E3D7468';
wwv_flow_imp.g_varchar2_table(34246) := '69732E5F766965774D6F64656C2E726561642865293B696628216E2972657475726E7B6974656D733A5B5D2C6765744974656D3A653D3E7B7468726F77206E6577204F657D7D3B636F6E737420693D6E2E6974656D732E726561642865292C6F3D6E6577';
wwv_flow_imp.g_varchar2_table(34247) := '204D61702C733D692E6D61702828653D3E7B766172206E3B636F6E737420693D742E616464286E6577207A726528652C746869732E5F6F626A656374506F6F6C2C746869732E7363726F6C6C4C6566742C28653D3E7B746869732E5F7363726F6C6C6162';
wwv_flow_imp.g_varchar2_table(34248) := '6C65456C656D656E742E7365745363726F6C6C506F736974696F6E287B7363726F6C6C546F703A746869732E5F7363726F6C6C61626C65456C656D656E742E6765745363726F6C6C506F736974696F6E28292E7363726F6C6C546F702B657D297D292929';
wwv_flow_imp.g_varchar2_table(34249) := '2C733D6E756C6C3D3D3D286E3D746869732E5F6C617374446F63537461746573297C7C766F696420303D3D3D6E3F766F696420303A6E5B692E6765744B657928295D3B72657475726E2073262648542828653D3E7B692E73657456696577537461746528';
wwv_flow_imp.g_varchar2_table(34250) := '732C65297D29292C6F2E73657428652C69292C697D29293B72657475726E7B6974656D733A732C6765744974656D3A653D3E6F2E6765742865297D7D29292C746869732E5F766965774974656D733D746869732E5F766965774974656D73496E666F2E6D';
wwv_flow_imp.g_varchar2_table(34251) := '617028746869732C28653D3E652E6974656D7329292C746869732E5F73706163654265747765656E50783D302C746869732E5F746F74616C4865696768743D746869732E5F766965774974656D732E6D617028746869732C2828652C74293D3E652E7265';
wwv_flow_imp.g_varchar2_table(34252) := '64756365282828652C6E293D3E652B6E2E636F6E74656E744865696768742E726561642874292B746869732E5F73706163654265747765656E5078292C302929292C746869732E5F636F6E746578744B6579536572766963653D746869732E5F72656769';
wwv_flow_imp.g_varchar2_table(34253) := '7374657228746869732E5F706172656E74436F6E746578744B6579536572766963652E63726561746553636F70656428746869732E5F656C656D656E7429292C746869732E5F696E7374616E74696174696F6E536572766963653D746869732E5F706172';
wwv_flow_imp.g_varchar2_table(34254) := '656E74496E7374616E74696174696F6E536572766963652E6372656174654368696C64286E6577207842285B63642C746869732E5F636F6E746578744B6579536572766963655D29292C746869732E5F6C617374446F635374617465733D7B7D2C746869';
wwv_flow_imp.g_varchar2_table(34255) := '732E5F636F6E746578744B6579536572766963652E6372656174654B6579286C682E696E4D756C746944696666456469746F722E6B65792C2130292C746869732E5F7265676973746572286949282828652C74293D3E7B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(34256) := '5F766965774D6F64656C2E726561642865293B6966286E26266E2E636F6E746578744B65797329666F7228636F6E73745B652C695D6F66204F626A6563742E656E7472696573286E2E636F6E746578744B65797329297B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(34257) := '5F636F6E746578744B6579536572766963652E6372656174654B657928652C766F69642030293B6E2E7365742869292C742E616464287274282828293D3E6E2E726573657428292929297D7D2929293B636F6E737420723D746869732E5F706172656E74';
wwv_flow_imp.g_varchar2_table(34258) := '436F6E746578744B6579536572766963652E6372656174654B6579286C682E6D756C746944696666456469746F72416C6C436F6C6C61707365642E6B65792C2131293B746869732E5F72656769737465722865492828653D3E7B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(34259) := '69732E5F766965774D6F64656C2E726561642865293B69662874297B636F6E7374206E3D742E6974656D732E726561642865292E65766572792828743D3E742E636F6C6C61707365642E7265616428652929293B722E736574286E297D7D2929292C7468';
wwv_flow_imp.g_varchar2_table(34260) := '69732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F64696D656E73696F6E2E726561642865293B746869732E5F73697A654F627365727665722E6F6273657276652874297D2929292C746869732E5F656C656D656E74';
wwv_flow_imp.g_varchar2_table(34261) := '732E636F6E74656E742E7374796C652E706F736974696F6E3D2272656C6174697665222C746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F73697A654F627365727665722E6865696768742E72656164286529';
wwv_flow_imp.g_varchar2_table(34262) := '3B746869732E5F656C656D656E74732E726F6F742E7374796C652E6865696768743D60247B747D7078603B636F6E7374206E3D746869732E5F746F74616C4865696768742E726561642865293B746869732E5F656C656D656E74732E636F6E74656E742E';
wwv_flow_imp.g_varchar2_table(34263) := '7374796C652E6865696768743D60247B6E7D7078603B636F6E737420693D746869732E5F73697A654F627365727665722E77696474682E726561642865293B6C6574206F3D693B636F6E737420733D437528746869732E5F766965774974656D732E7265';
wwv_flow_imp.g_varchar2_table(34264) := '61642865292C65752828743D3E742E6D61785363726F6C6C2E726561642865292E6D61785363726F6C6C292C747529293B732626286F3D692B732E6D61785363726F6C6C2E726561642865292E6D61785363726F6C6C292C746869732E5F7363726F6C6C';
wwv_flow_imp.g_varchar2_table(34265) := '61626C65456C656D656E742E7365745363726F6C6C44696D656E73696F6E73287B77696474683A692C6865696768743A742C7363726F6C6C4865696768743A6E2C7363726F6C6C57696474683A6F7D297D2929292C652E7265706C6163654368696C6472';
wwv_flow_imp.g_varchar2_table(34266) := '656E28746869732E5F7363726F6C6C61626C65456C656D656E742E676574446F6D4E6F64652829292C746869732E5F7265676973746572287274282828293D3E7B652E7265706C6163654368696C6472656E28297D2929292C746869732E5F7265676973';
wwv_flow_imp.g_varchar2_table(34267) := '74657228746869732E5F72656769737465722865492828653D3E7B57542828743D3E7B746869732E72656E6465722865297D29297D292929297D72656E6465722865297B636F6E737420743D746869732E7363726F6C6C546F702E726561642865293B6C';
wwv_flow_imp.g_varchar2_table(34268) := '6574206E3D302C693D302C6F3D303B636F6E737420733D746869732E5F73697A654F627365727665722E6865696768742E726561642865292C723D6D752E6F665374617274416E644C656E67746828742C73292C613D746869732E5F73697A654F627365';
wwv_flow_imp.g_varchar2_table(34269) := '727665722E77696474682E726561642865293B666F7228636F6E7374206C206F6620746869732E5F766965774974656D732E72656164286529297B636F6E737420633D6C2E636F6E74656E744865696768742E726561642865292C643D4D6174682E6D69';
wwv_flow_imp.g_varchar2_table(34270) := '6E28632C73292C683D6D752E6F665374617274416E644C656E67746828692C64292C753D6D752E6F665374617274416E644C656E677468286F2C63293B696628752E69734265666F7265287229296E2D3D632D642C6C2E6869646528293B656C73652069';
wwv_flow_imp.g_varchar2_table(34271) := '6628752E69734166746572287229296C2E6869646528293B656C73657B636F6E737420653D4D6174682E6D617828302C4D6174682E6D696E28722E73746172742D752E73746172742C632D6429293B6E2D3D653B636F6E737420693D6D752E6F66537461';
wwv_flow_imp.g_varchar2_table(34272) := '7274416E644C656E67746828742B6E2C73293B6C2E72656E64657228682C652C612C69297D692B3D642B746869732E5F73706163654265747765656E50782C6F2B3D632B746869732E5F73706163654265747765656E50787D746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(34273) := '6E74732E636F6E74656E742E7374796C652E7472616E73666F726D3D607472616E736C6174655928247B2D28742B6E297D707829607D7D3B5672653D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D617267756D656E74732E6C656E67';
wwv_flow_imp.g_varchar2_table(34274) := '74682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C65637426262266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(34275) := '3D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B612D2D29286F3D655B615D29262628';
wwv_flow_imp.g_varchar2_table(34276) := '723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B42726528342C6364292C4272652835';
wwv_flow_imp.g_varchar2_table(34277) := '2C7563295D2C567265293B636C617373207A726520657874656E6473206C747B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E766965774D6F64656C3D652C746869732E5F6F626A656374506F6F6C3D742C746869';
wwv_flow_imp.g_varchar2_table(34278) := '732E5F7363726F6C6C4C6566743D6E2C746869732E5F64656C74615363726F6C6C566572746963616C3D692C746869732E5F74656D706C6174655265663D746869732E5F7265676973746572284B5428746869732C766F6964203029292C746869732E63';
wwv_flow_imp.g_varchar2_table(34279) := '6F6E74656E744865696768743D515428746869732C28653D3E7B76617220742C6E2C693B72657475726E206E756C6C213D3D28693D6E756C6C3D3D3D286E3D6E756C6C3D3D3D28743D746869732E5F74656D706C6174655265662E72656164286529297C';
wwv_flow_imp.g_varchar2_table(34280) := '7C766F696420303D3D3D743F766F696420303A742E6F626A6563742E636F6E74656E74486569676874297C7C766F696420303D3D3D6E3F766F696420303A6E2E72656164286529292626766F69642030213D3D693F693A746869732E766965774D6F6465';
wwv_flow_imp.g_varchar2_table(34281) := '6C2E6C61737454656D706C617465446174612E726561642865292E636F6E74656E744865696768747D29292C746869732E6D61785363726F6C6C3D515428746869732C28653D3E7B76617220742C6E3B72657475726E206E756C6C213D3D286E3D6E756C';
wwv_flow_imp.g_varchar2_table(34282) := '6C3D3D3D28743D746869732E5F74656D706C6174655265662E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6F626A6563742E6D61785363726F6C6C2E72656164286529292626766F69642030213D3D6E3F6E3A7B6D617853';
wwv_flow_imp.g_varchar2_table(34283) := '63726F6C6C3A302C7363726F6C6C57696474683A307D7D29292C746869732E74656D706C6174653D515428746869732C28653D3E7B76617220743B72657475726E206E756C6C3D3D3D28743D746869732E5F74656D706C6174655265662E726561642865';
wwv_flow_imp.g_varchar2_table(34284) := '29297C7C766F696420303D3D3D743F766F696420303A742E6F626A6563747D29292C746869732E5F697348696464656E3D245428746869732C2131292C746869732E5F6973466F63757365643D515428746869732C28653D3E7B76617220742C6E3B7265';
wwv_flow_imp.g_varchar2_table(34285) := '7475726E206E756C6C213D3D286E3D6E756C6C3D3D3D28743D746869732E74656D706C6174652E72656164286529297C7C766F696420303D3D3D743F766F696420303A742E6973466F63757365642E72656164286529292626766F69642030213D3D6E26';
wwv_flow_imp.g_varchar2_table(34286) := '266E7D29292C746869732E766965774D6F64656C2E7365744973466F637573656428746869732E5F6973466F63757365642C766F69642030292C746869732E5F72656769737465722865492828653D3E7B76617220743B636F6E7374206E3D746869732E';
wwv_flow_imp.g_varchar2_table(34287) := '5F7363726F6C6C4C6566742E726561642865293B6E756C6C3D3D3D28743D746869732E5F74656D706C6174655265662E72656164286529297C7C766F696420303D3D3D747C7C742E6F626A6563742E7365745363726F6C6C4C656674286E297D2929292C';
wwv_flow_imp.g_varchar2_table(34288) := '746869732E5F72656769737465722865492828653D3E7B636F6E737420743D746869732E5F74656D706C6174655265662E726561642865293B742626746869732E5F697348696464656E2E72656164286529262628742E6F626A6563742E6973466F6375';
wwv_flow_imp.g_varchar2_table(34289) := '7365642E726561642865297C7C746869732E5F636C6561722829297D2929297D646973706F736528297B746869732E5F636C65617228292C73757065722E646973706F736528297D746F537472696E6728297B76617220653B72657475726E6056697274';
wwv_flow_imp.g_varchar2_table(34290) := '75616C566965774974656D28247B6E756C6C3D3D3D28653D746869732E766965774D6F64656C2E656E7472792E76616C75652E6D6F646966696564297C7C766F696420303D3D3D653F766F696420303A652E7572692E746F537472696E6728297D29607D';
wwv_flow_imp.g_varchar2_table(34291) := '6765744B657928297B72657475726E20746869732E766965774D6F64656C2E6765744B657928297D73657456696577537461746528652C74297B766172206E3B746869732E766965774D6F64656C2E636F6C6C61707365642E73657428652E636F6C6C61';
wwv_flow_imp.g_varchar2_table(34292) := '707365642C74292C746869732E5F75706461746554656D706C617465446174612874293B636F6E737420693D746869732E766965774D6F64656C2E6C61737454656D706C617465446174612E67657428292C6F3D6E756C6C3D3D3D286E3D652E73656C65';
wwv_flow_imp.g_varchar2_table(34293) := '6374696F6E73297C7C766F696420303D3D3D6E3F766F696420303A6E2E6D61702861682E6C69667453656C656374696F6E293B746869732E766965774D6F64656C2E6C61737454656D706C617465446174612E736574287B2E2E2E692C73656C65637469';
wwv_flow_imp.g_varchar2_table(34294) := '6F6E733A6F7D2C74293B636F6E737420733D746869732E5F74656D706C6174655265662E67657428293B7326266F2626732E6F626A6563742E656469746F722E73657453656C656374696F6E73286F297D5F75706461746554656D706C61746544617461';
wwv_flow_imp.g_varchar2_table(34295) := '2865297B76617220743B636F6E7374206E3D746869732E5F74656D706C6174655265662E67657428293B6E2626746869732E766965774D6F64656C2E6C61737454656D706C617465446174612E736574287B636F6E74656E744865696768743A6E2E6F62';
wwv_flow_imp.g_varchar2_table(34296) := '6A6563742E636F6E74656E744865696768742E67657428292C73656C656374696F6E733A6E756C6C213D3D28743D6E2E6F626A6563742E656469746F722E67657453656C656374696F6E732829292626766F69642030213D3D743F743A766F696420307D';
wwv_flow_imp.g_varchar2_table(34297) := '2C65297D5F636C65617228297B636F6E737420653D746869732E5F74656D706C6174655265662E67657428293B65262648542828743D3E7B746869732E5F75706461746554656D706C617465446174612874292C652E6F626A6563742E6869646528292C';
wwv_flow_imp.g_varchar2_table(34298) := '746869732E5F74656D706C6174655265662E73657428766F696420302C74297D29297D6869646528297B746869732E5F697348696464656E2E7365742821302C766F69642030297D72656E64657228652C742C6E2C69297B746869732E5F697348696464';
wwv_flow_imp.g_varchar2_table(34299) := '656E2E7365742821312C766F69642030293B6C6574206F3D746869732E5F74656D706C6174655265662E67657428293B696628216F297B6F3D746869732E5F6F626A656374506F6F6C2E676574556E757365644F626A286E65772050726528746869732E';
wwv_flow_imp.g_varchar2_table(34300) := '766965774D6F64656C2C746869732E5F64656C74615363726F6C6C566572746963616C29292C746869732E5F74656D706C6174655265662E736574286F2C766F69642030293B636F6E737420653D746869732E766965774D6F64656C2E6C61737454656D';
wwv_flow_imp.g_varchar2_table(34301) := '706C617465446174612E67657428292E73656C656374696F6E733B6526266F2E6F626A6563742E656469746F722E73657453656C656374696F6E732865297D6F2E6F626A6563742E72656E64657228652C6E2C742C69297D7D4C6D28226D756C74694469';
wwv_flow_imp.g_varchar2_table(34302) := '6666456469746F722E6865616465724261636B67726F756E64222C7B6461726B3A2223323632363236222C6C696768743A227461622E696E6163746976654261636B67726F756E64222C68634461726B3A227461622E696E6163746976654261636B6772';
wwv_flow_imp.g_varchar2_table(34303) := '6F756E64222C68634C696768743A227461622E696E6163746976654261636B67726F756E64227D2C6228302C22546865206261636B67726F756E6420636F6C6F72206F6620746865206469666620656469746F722773206865616465722229292C4C6D28';
wwv_flow_imp.g_varchar2_table(34304) := '226D756C746944696666456469746F722E6261636B67726F756E64222C7B6461726B3A22656469746F724261636B67726F756E64222C6C696768743A22656469746F724261636B67726F756E64222C68634461726B3A22656469746F724261636B67726F';
wwv_flow_imp.g_varchar2_table(34305) := '756E64222C68634C696768743A22656469746F724261636B67726F756E64227D2C6228302C22546865206261636B67726F756E6420636F6C6F72206F6620746865206D756C74692066696C65206469666620656469746F722229292C4C6D28226D756C74';
wwv_flow_imp.g_varchar2_table(34306) := '6944696666456469746F722E626F72646572222C7B6461726B3A227369646542617253656374696F6E4865616465722E626F72646572222C6C696768743A2223636363636363222C68634461726B3A227369646542617253656374696F6E486561646572';
wwv_flow_imp.g_varchar2_table(34307) := '2E626F72646572222C68634C696768743A2223636363636363227D2C6228302C2254686520626F7264657220636F6C6F72206F6620746865206D756C74692066696C65206469666620656469746F722229293B6C6574204872653D636C61737320657874';
wwv_flow_imp.g_varchar2_table(34308) := '656E6473206C747B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E5F656C656D656E743D652C746869732E5F776F726B62656E63685549456C656D656E74466163746F72793D742C746869732E5F696E7374616E746961';
wwv_flow_imp.g_varchar2_table(34309) := '74696F6E536572766963653D6E2C746869732E5F64696D656E73696F6E3D245428746869732C766F69642030292C746869732E5F766965774D6F64656C3D245428746869732C766F69642030292C746869732E5F776964676574496D706C3D5A54287468';
wwv_flow_imp.g_varchar2_table(34310) := '69732C2828652C74293D3E285959284F72652C65292C742E61646428746869732E5F696E7374616E74696174696F6E536572766963652E637265617465496E7374616E6365285959285672652C65292C746869732E5F656C656D656E742C746869732E5F';
wwv_flow_imp.g_varchar2_table(34311) := '64696D656E73696F6E2C746869732E5F766965774D6F64656C2C746869732E5F776F726B62656E63685549456C656D656E74466163746F727929292929292C746869732E5F726567697374657228704928746869732E5F776964676574496D706C29297D';
wwv_flow_imp.g_varchar2_table(34312) := '7D3B66756E6374696F6E205772652865297B636F6E737420743D4372652E676574282445293B72657475726E207420696E7374616E63656F66206872653F742E61646444796E616D69634B657962696E64696E677328652E6D61702828653D3E287B6B65';
wwv_flow_imp.g_varchar2_table(34313) := '7962696E64696E673A652E6B657962696E64696E672C636F6D6D616E643A652E636F6D6D616E642C636F6D6D616E64417267733A652E636F6D6D616E64417267732C7768656E3A57632E646573657269616C697A6528652E7768656E297D292929293A28';
wwv_flow_imp.g_varchar2_table(34314) := '636F6E736F6C652E7761726E282243616E6E6F7420616464206B657962696E64696E6720626563617573652074686520656469746F7220697320636F6E66696775726564207769746820616E20756E7265636F676E697A6564204B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(34315) := '5365727669636522292C6C742E4E6F6E65297D66756E6374696F6E206A726528652C74297B72657475726E22626F6F6C65616E223D3D747970656F6620653F653A747D66756E6374696F6E2071726528652C74297B72657475726E22737472696E67223D';
wwv_flow_imp.g_varchar2_table(34316) := '3D747970656F6620653F653A747D66756E6374696F6E2024726528652C743D2131297B74262628653D652E6D6170282866756E6374696F6E2865297B72657475726E20652E746F4C6F7765724361736528297D2929293B636F6E7374206E3D66756E6374';
wwv_flow_imp.g_varchar2_table(34317) := '696F6E2865297B636F6E737420743D7B7D3B666F7228636F6E7374206E206F66206529745B6E5D3D21303B72657475726E20747D2865293B72657475726E20743F66756E6374696F6E2865297B72657475726E20766F69642030213D3D6E5B652E746F4C';
wwv_flow_imp.g_varchar2_table(34318) := '6F7765724361736528295D26266E2E6861734F776E50726F706572747928652E746F4C6F776572436173652829297D3A66756E6374696F6E2865297B72657475726E20766F69642030213D3D6E5B655D26266E2E6861734F776E50726F70657274792865';
wwv_flow_imp.g_varchar2_table(34319) := '297D7D66756E6374696F6E2055726528652C742C6E297B743D742E7265706C616365282F40402F672C220122293B6C657420692C6F3D303B646F7B693D21312C743D742E7265706C616365282F40285C772B292F672C2866756E6374696F6E286E2C6F29';
wwv_flow_imp.g_varchar2_table(34320) := '7B693D21303B6C657420733D22223B69662822737472696E67223D3D747970656F6620655B6F5D29733D655B6F5D3B656C73657B6966282128655B6F5D2626655B6F5D696E7374616E63656F662052656745787029297468726F7720766F696420303D3D';
wwv_flow_imp.g_varchar2_table(34321) := '3D655B6F5D3F6D6E6528652C226C616E677561676520646566696E6974696F6E20646F6573206E6F7420636F6E7461696E206174747269627574652027222B6F2B22272C20757365642061743A20222B74293A6D6E6528652C2261747472696275746520';
wwv_flow_imp.g_varchar2_table(34322) := '7265666572656E63652027222B6F2B2227206D757374206265206120737472696E672C20757365642061743A20222B74293B733D655B6F5D2E736F757263657D72657475726E20756E652873293F22223A22283F3A222B732B2229227D29292C6F2B2B7D';
wwv_flow_imp.g_varchar2_table(34323) := '7768696C65286926266F3C35293B743D742E7265706C616365282F5C7830312F672C224022293B636F6E737420733D28652E69676E6F7265436173653F2269223A2222292B28652E756E69636F64653F2275223A2222293B6966286E2626742E6D617463';
wwv_flow_imp.g_varchar2_table(34324) := '68282F5C245B73535D285C645C643F292F6729297B6C6574206E3D6E756C6C2C693D6E756C6C3B72657475726E206F3D3E286926266E3D3D3D6F7C7C286E3D6F2C693D6E6577205265674578702866756E6374696F6E28652C742C6E297B6C657420693D';
wwv_flow_imp.g_varchar2_table(34325) := '6E756C6C3B72657475726E20742E7265706C616365282F5C245B73535D285C645C643F292F672C2866756E6374696F6E28742C6F297B72657475726E206E756C6C3D3D3D69262628693D6E2E73706C697428222E22292C692E756E7368696674286E2929';
wwv_flow_imp.g_varchar2_table(34326) := '2C21756E65286F2926266F3C692E6C656E6774683F706E6528652C695B6F5D293A22227D29297D28652C742C6F292C7329292C69297D72657475726E206E65772052656745787028742C73297D66756E6374696F6E204B726528652C742C6E2C69297B6C';
wwv_flow_imp.g_varchar2_table(34327) := '6574206F3D2D312C733D6E2C723D6E2E6D61746368282F5E5C2428285B73535D3F29285C645C643F297C2329282E2A29242F293B72262628725B335D2626286F3D7061727365496E7428725B335D292C725B325D2626286F2B3D31303029292C733D725B';
wwv_flow_imp.g_varchar2_table(34328) := '345D293B6C657420612C6C3D227E222C633D733B69662873262630213D3D732E6C656E6774683F2F5E5C772A242F2E746573742863293F6C3D223D3D223A28723D732E6D61746368282F5E28407C21407C7E7C217E7C3D3D7C213D29282E2A29242F292C';
wwv_flow_imp.g_varchar2_table(34329) := '722626286C3D725B315D2C633D725B325D29293A286C3D22213D222C633D2222292C227E22213D3D6C262622217E22213D3D6C7C7C212F5E285C777C5C7C292A242F2E74657374286329296966282240223D3D3D6C7C7C222140223D3D3D6C297B636F6E';
wwv_flow_imp.g_varchar2_table(34330) := '7374206E3D655B635D3B696628216E297468726F77206D6E6528652C227468652040206D61746368207461726765742027222B632B2227206973206E6F7420646566696E65642C20696E2072756C653A20222B74293B6966282166756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(34331) := '2C74297B69662821742972657475726E21313B6966282141727261792E697341727261792874292972657475726E21313B666F7228636F6E73742065206F6620742969662822737472696E6722213D747970656F6620652972657475726E21313B726574';
wwv_flow_imp.g_varchar2_table(34332) := '75726E21307D28302C6E29297468726F77206D6E6528652C227468652040206D61746368207461726765742027222B632B2227206D75737420626520616E206172726179206F6620737472696E67732C20696E2072756C653A20222B74293B636F6E7374';
wwv_flow_imp.g_varchar2_table(34333) := '20693D247265286E2C652E69676E6F726543617365293B613D66756E6374696F6E2865297B72657475726E2240223D3D3D6C3F692865293A21692865297D7D656C736520696628227E223D3D3D6C7C7C22217E223D3D3D6C29696628632E696E6465784F';
wwv_flow_imp.g_varchar2_table(34334) := '6628222422293C30297B636F6E737420743D55726528652C225E222B632B2224222C2131293B613D66756E6374696F6E2865297B72657475726E227E223D3D3D6C3F742E746573742865293A21742E746573742865297D7D656C736520613D66756E6374';
wwv_flow_imp.g_varchar2_table(34335) := '696F6E28742C6E2C692C6F297B72657475726E2055726528652C225E222B666E6528652C632C6E2C692C6F292B2224222C2131292E746573742874297D3B656C736520696628632E696E6465784F6628222422293C30297B636F6E737420743D706E6528';
wwv_flow_imp.g_varchar2_table(34336) := '652C63293B613D66756E6374696F6E2865297B72657475726E223D3D223D3D3D6C3F653D3D3D743A65213D3D747D7D656C73657B636F6E737420743D706E6528652C63293B613D66756E6374696F6E286E2C692C6F2C732C72297B636F6E737420613D66';
wwv_flow_imp.g_varchar2_table(34337) := '6E6528652C742C692C6F2C73293B72657475726E223D3D223D3D3D6C3F6E3D3D3D613A6E213D3D617D7D656C73657B636F6E737420743D24726528632E73706C697428227C22292C652E69676E6F726543617365293B613D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(34338) := '72657475726E227E223D3D3D6C3F742865293A21742865297D7D72657475726E2D313D3D3D6F3F7B6E616D653A6E2C76616C75653A692C746573743A66756E6374696F6E28652C742C6E2C69297B72657475726E206128652C652C742C6E2C69297D7D3A';
wwv_flow_imp.g_varchar2_table(34339) := '7B6E616D653A6E2C76616C75653A692C746573743A66756E6374696F6E28652C742C6E2C69297B636F6E737420733D66756E6374696F6E28652C742C6E2C69297B696628693C302972657475726E20653B696628693C742E6C656E677468297265747572';
wwv_flow_imp.g_varchar2_table(34340) := '6E20745B695D3B696628693E3D313030297B692D3D3130303B636F6E737420653D6E2E73706C697428222E22293B696628652E756E7368696674286E292C693C652E6C656E6774682972657475726E20655B695D7D72657475726E206E756C6C7D28652C';
wwv_flow_imp.g_varchar2_table(34341) := '742C6E2C6F293B72657475726E206128737C7C22222C652C742C6E2C69297D7D7D66756E6374696F6E2047726528652C742C6E297B6966286E297B69662822737472696E67223D3D747970656F66206E2972657475726E206E3B6966286E2E746F6B656E';
wwv_flow_imp.g_varchar2_table(34342) := '7C7C22223D3D3D6E2E746F6B656E297B69662822737472696E6722213D747970656F66206E2E746F6B656E297468726F77206D6E6528652C22612027746F6B656E2720617474726962757465206D757374206265206F66207479706520737472696E672C';
wwv_flow_imp.g_varchar2_table(34343) := '20696E2072756C653A20222B74293B7B636F6E737420693D7B746F6B656E3A6E2E746F6B656E7D3B6966286E2E746F6B656E2E696E6465784F6628222422293E3D30262628692E746F6B656E53756273743D2130292C22737472696E67223D3D74797065';
wwv_flow_imp.g_varchar2_table(34344) := '6F66206E2E627261636B65742969662822406F70656E223D3D3D6E2E627261636B657429692E627261636B65743D313B656C73657B6966282240636C6F736522213D3D6E2E627261636B6574297468726F77206D6E6528652C22612027627261636B6574';
wwv_flow_imp.g_varchar2_table(34345) := '2720617474726962757465206D757374206265206569746865722027406F70656E27206F72202740636C6F7365272C20696E2072756C653A20222B74293B692E627261636B65743D2D317D6966286E2E6E657874297B69662822737472696E6722213D74';
wwv_flow_imp.g_varchar2_table(34346) := '7970656F66206E2E6E657874297468726F77206D6E6528652C22746865206E657874207374617465206D757374206265206120737472696E672076616C756520696E2072756C653A20222B74293B7B6C6574206F3D6E2E6E6578743B696628212F5E2840';
wwv_flow_imp.g_varchar2_table(34347) := '706F707C40707573687C40706F70616C6C29242F2E74657374286F292626282240223D3D3D6F5B305D2626286F3D6F2E737562737472283129292C6F2E696E6465784F6628222422293C3026262166756E6374696F6E28652C74297B6C6574206E3D743B';
wwv_flow_imp.g_varchar2_table(34348) := '666F72283B6E26266E2E6C656E6774683E303B297B696628652E73746174654E616D65735B6E5D2972657475726E21303B636F6E737420743D6E2E6C617374496E6465784F6628222E22293B6E3D743C303F6E756C6C3A6E2E73756273747228302C7429';
wwv_flow_imp.g_varchar2_table(34349) := '7D72657475726E21317D28652C666E6528652C6F2C22222C5B5D2C2222292929297468726F77206D6E6528652C22746865206E6578742073746174652027222B6E2E6E6578742B2227206973206E6F7420646566696E656420696E2072756C653A20222B';
wwv_flow_imp.g_varchar2_table(34350) := '74293B692E6E6578743D6F7D7D72657475726E226E756D626572223D3D747970656F66206E2E676F4261636B262628692E676F4261636B3D6E2E676F4261636B292C22737472696E67223D3D747970656F66206E2E737769746368546F262628692E7377';
wwv_flow_imp.g_varchar2_table(34351) := '69746368546F3D6E2E737769746368546F292C22737472696E67223D3D747970656F66206E2E6C6F67262628692E6C6F673D6E2E6C6F67292C22737472696E67223D3D747970656F66206E2E6E657874456D626564646564262628692E6E657874456D62';
wwv_flow_imp.g_varchar2_table(34352) := '65646465643D6E2E6E657874456D6265646465642C652E75736573456D6265646465643D2130292C697D7D69662841727261792E69734172726179286E29297B636F6E737420693D5B5D3B666F72286C6574206F3D302C733D6E2E6C656E6774683B6F3C';
wwv_flow_imp.g_varchar2_table(34353) := '733B6F2B2B29695B6F5D3D47726528652C742C6E5B6F5D293B72657475726E7B67726F75703A697D7D6966286E2E6361736573297B636F6E737420693D5B5D3B666F7228636F6E7374206F20696E206E2E6361736573296966286E2E63617365732E6861';
wwv_flow_imp.g_varchar2_table(34354) := '734F776E50726F7065727479286F29297B636F6E737420733D47726528652C742C6E2E63617365735B6F5D293B224064656661756C74223D3D3D6F7C7C2240223D3D3D6F7C7C22223D3D3D6F3F692E70757368287B746573743A766F696420302C76616C';
wwv_flow_imp.g_varchar2_table(34355) := '75653A732C6E616D653A6F7D293A2240656F73223D3D3D6F3F692E70757368287B746573743A66756E6374696F6E28652C742C6E2C69297B72657475726E20697D2C76616C75653A732C6E616D653A6F7D293A692E70757368284B726528652C742C6F2C';
wwv_flow_imp.g_varchar2_table(34356) := '7329297D636F6E7374206F3D652E64656661756C74546F6B656E3B72657475726E7B746573743A66756E6374696F6E28652C742C6E2C73297B666F7228636F6E7374206F206F66206929696628216F2E746573747C7C6F2E7465737428652C742C6E2C73';
wwv_flow_imp.g_varchar2_table(34357) := '292972657475726E206F2E76616C75653B72657475726E206F7D7D7D7468726F77206D6E6528652C22616E20616374696F6E206D757374206265206120737472696E672C20616E206F626A656374207769746820612027746F6B656E27206F7220276361';
wwv_flow_imp.g_varchar2_table(34358) := '73657327206174747269627574652C206F7220616E206172726179206F6620616374696F6E733B20696E2072756C653A20222B74297D72657475726E7B746F6B656E3A22227D7D4872653D66756E6374696F6E28652C742C6E2C69297B766172206F2C73';
wwv_flow_imp.g_varchar2_table(34359) := '3D617267756D656E74732E6C656E6774682C723D733C333F743A6E756C6C3D3D3D693F693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293A693B696628226F626A656374223D3D747970656F66205265666C';
wwv_flow_imp.g_varchar2_table(34360) := '65637426262266756E6374696F6E223D3D747970656F66205265666C6563742E6465636F7261746529723D5265666C6563742E6465636F7261746528652C742C6E2C69293B656C736520666F722876617220613D652E6C656E6774682D313B613E3D303B';
wwv_flow_imp.g_varchar2_table(34361) := '612D2D29286F3D655B615D29262628723D28733C333F6F2872293A733E333F6F28742C6E2C72293A6F28742C6E29297C7C72293B72657475726E20733E3326267226264F626A6563742E646566696E6550726F706572747928742C6E2C72292C727D285B';
wwv_flow_imp.g_varchar2_table(34362) := '66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E2C69297B74286E2C692C65297D7D28322C7563295D2C487265293B636C617373205172657B636F6E7374727563746F722865297B746869732E72656765783D6E6577205265';
wwv_flow_imp.g_varchar2_table(34363) := '67457870282222292C746869732E616374696F6E3D7B746F6B656E3A22227D2C746869732E6D617463684F6E6C7941744C696E6553746172743D21312C746869732E6E616D653D22222C746869732E6E616D653D657D736574526567657828652C74297B';
wwv_flow_imp.g_varchar2_table(34364) := '6C6574206E3B69662822737472696E67223D3D747970656F662074296E3D743B656C73657B69662821287420696E7374616E63656F662052656745787029297468726F77206D6E6528652C2272756C6573206D7573742073746172742077697468206120';
wwv_flow_imp.g_varchar2_table(34365) := '6D6174636820737472696E67206F7220726567756C61722065787072657373696F6E3A20222B746869732E6E616D65293B6E3D742E736F757263657D746869732E6D617463684F6E6C7941744C696E6553746172743D6E2E6C656E6774683E302626225E';
wwv_flow_imp.g_varchar2_table(34366) := '223D3D3D6E5B305D2C746869732E6E616D653D746869732E6E616D652B223A20222B6E2C746869732E72656765783D55726528652C225E283F3A222B28746869732E6D617463684F6E6C7941744C696E6553746172743F6E2E7375627374722831293A6E';
wwv_flow_imp.g_varchar2_table(34367) := '292B2229222C2130297D736574416374696F6E28652C74297B746869732E616374696F6E3D47726528652C746869732E6E616D652C74297D7265736F6C766552656765782865297B72657475726E20746869732E726567657820696E7374616E63656F66';
wwv_flow_imp.g_varchar2_table(34368) := '205265674578703F746869732E72656765783A746869732E72656765782865297D7D66756E6374696F6E2059726528652C74297B69662821747C7C226F626A65637422213D747970656F662074297468726F77206E6577204572726F7228224D6F6E6172';
wwv_flow_imp.g_varchar2_table(34369) := '63683A20657870656374696E672061206C616E677561676520646566696E6974696F6E206F626A65637422293B636F6E7374206E3D7B7D3B6E2E6C616E677561676549643D652C6E2E696E636C7564654C463D6A726528742E696E636C7564654C462C21';
wwv_flow_imp.g_varchar2_table(34370) := '31292C6E2E6E6F5468726F773D21312C6E2E6D6178537461636B3D3130302C6E2E73746172743D22737472696E67223D3D747970656F6620742E73746172743F742E73746172743A6E756C6C2C6E2E69676E6F7265436173653D6A726528742E69676E6F';
wwv_flow_imp.g_varchar2_table(34371) := '7265436173652C2131292C6E2E756E69636F64653D6A726528742E756E69636F64652C2131292C6E2E746F6B656E506F73746669783D71726528742E746F6B656E506F73746669782C222E222B6E2E6C616E67756167654964292C6E2E64656661756C74';
wwv_flow_imp.g_varchar2_table(34372) := '546F6B656E3D71726528742E64656661756C74546F6B656E2C22736F7572636522292C6E2E75736573456D6265646465643D21313B636F6E737420693D743B66756E6374696F6E206F28652C732C72297B666F7228636F6E73742061206F662072297B6C';
wwv_flow_imp.g_varchar2_table(34373) := '657420723D612E696E636C7564653B69662872297B69662822737472696E6722213D747970656F662072297468726F77206D6E65286E2C22616E2027696E636C7564652720617474726962757465206D757374206265206120737472696E672061743A20';
wwv_flow_imp.g_varchar2_table(34374) := '222B65293B6966282240223D3D3D725B305D262628723D722E737562737472283129292C21742E746F6B656E697A65725B725D297468726F77206D6E65286E2C22696E636C756465207461726765742027222B722B2227206973206E6F7420646566696E';
wwv_flow_imp.g_varchar2_table(34375) := '65642061743A20222B65293B6F28652B222E222B722C732C742E746F6B656E697A65725B725D297D656C73657B636F6E737420743D6E6577205172652865293B69662841727261792E697341727261792861292626612E6C656E6774683E3D312626612E';
wwv_flow_imp.g_varchar2_table(34376) := '6C656E6774683C3D3329696628742E736574526567657828692C615B305D292C612E6C656E6774683E3D332969662822737472696E67223D3D747970656F6620615B315D29742E736574416374696F6E28692C7B746F6B656E3A615B315D2C6E6578743A';
wwv_flow_imp.g_varchar2_table(34377) := '615B325D7D293B656C73657B696628226F626A65637422213D747970656F6620615B315D297468726F77206D6E65286E2C2261206E65787420737461746520617320746865206C61737420656C656D656E74206F6620612072756C652063616E206F6E6C';
wwv_flow_imp.g_varchar2_table(34378) := '7920626520676976656E2069662074686520616374696F6E2069732065697468657220616E206F626A656374206F72206120737472696E672C2061743A20222B65293B7B636F6E737420653D615B315D3B652E6E6578743D615B325D2C742E7365744163';
wwv_flow_imp.g_varchar2_table(34379) := '74696F6E28692C65297D7D656C736520742E736574416374696F6E28692C615B315D293B656C73657B69662821612E7265676578297468726F77206D6E65286E2C22612072756C65206D7573742065697468657220626520616E2061727261792C206F72';
wwv_flow_imp.g_varchar2_table(34380) := '20616E206F626A656374207769746820612027726567657827206F722027696E636C75646527206669656C642061743A20222B65293B612E6E616D65262622737472696E67223D3D747970656F6620612E6E616D65262628742E6E616D653D612E6E616D';
wwv_flow_imp.g_varchar2_table(34381) := '65292C612E6D617463684F6E6C7941745374617274262628742E6D617463684F6E6C7941744C696E6553746172743D6A726528612E6D617463684F6E6C7941744C696E6553746172742C213129292C742E736574526567657828692C612E726567657829';
wwv_flow_imp.g_varchar2_table(34382) := '2C742E736574416374696F6E28692C612E616374696F6E297D732E707573682874297D7D7D696628692E6C616E677561676549643D652C692E696E636C7564654C463D6E2E696E636C7564654C462C692E69676E6F7265436173653D6E2E69676E6F7265';
wwv_flow_imp.g_varchar2_table(34383) := '436173652C692E756E69636F64653D6E2E756E69636F64652C692E6E6F5468726F773D6E2E6E6F5468726F772C692E75736573456D6265646465643D6E2E75736573456D6265646465642C692E73746174654E616D65733D742E746F6B656E697A65722C';
wwv_flow_imp.g_varchar2_table(34384) := '692E64656661756C74546F6B656E3D6E2E64656661756C74546F6B656E2C21742E746F6B656E697A65727C7C226F626A65637422213D747970656F6620742E746F6B656E697A6572297468726F77206D6E65286E2C2261206C616E677561676520646566';
wwv_flow_imp.g_varchar2_table(34385) := '696E6974696F6E206D75737420646566696E65207468652027746F6B656E697A6572272061747472696275746520617320616E206F626A65637422293B6E2E746F6B656E697A65723D5B5D3B666F7228636F6E7374206520696E20742E746F6B656E697A';
wwv_flow_imp.g_varchar2_table(34386) := '657229696628742E746F6B656E697A65722E6861734F776E50726F7065727479286529297B6E2E73746172747C7C286E2E73746172743D65293B636F6E737420693D742E746F6B656E697A65725B655D3B6E2E746F6B656E697A65725B655D3D6E657720';
wwv_flow_imp.g_varchar2_table(34387) := '41727261792C6F2822746F6B656E697A65722E222B652C6E2E746F6B656E697A65725B655D2C69297D6966286E2E75736573456D6265646465643D692E75736573456D6265646465642C742E627261636B657473297B6966282141727261792E69734172';
wwv_flow_imp.g_varchar2_table(34388) := '72617928742E627261636B65747329297468726F77206D6E65286E2C227468652027627261636B6574732720617474726962757465206D75737420626520646566696E656420617320616E20617272617922297D656C736520742E627261636B6574733D';
wwv_flow_imp.g_varchar2_table(34389) := '5B7B6F70656E3A227B222C636C6F73653A227D222C746F6B656E3A2264656C696D697465722E6375726C79227D2C7B6F70656E3A225B222C636C6F73653A225D222C746F6B656E3A2264656C696D697465722E737175617265227D2C7B6F70656E3A2228';
wwv_flow_imp.g_varchar2_table(34390) := '222C636C6F73653A2229222C746F6B656E3A2264656C696D697465722E706172656E746865736973227D2C7B6F70656E3A223C222C636C6F73653A223E222C746F6B656E3A2264656C696D697465722E616E676C65227D5D3B636F6E737420733D5B5D3B';
wwv_flow_imp.g_varchar2_table(34391) := '666F7228636F6E73742065206F6620742E627261636B657473297B6C657420743D653B69662874262641727261792E697341727261792874292626333D3D3D742E6C656E677468262628743D7B746F6B656E3A745B325D2C6F70656E3A745B305D2C636C';
wwv_flow_imp.g_varchar2_table(34392) := '6F73653A745B315D7D292C742E6F70656E3D3D3D742E636C6F7365297468726F77206D6E65286E2C226F70656E20616E6420636C6F736520627261636B65747320696E20612027627261636B6574732720617474726962757465206D7573742062652064';
wwv_flow_imp.g_varchar2_table(34393) := '6966666572656E743A20222B742E6F70656E2B225C6E2068696E743A20757365207468652027627261636B65742720617474726962757465206966206D61746368696E67206F6E20657175616C20627261636B6574732069732072657175697265642E22';
wwv_flow_imp.g_varchar2_table(34394) := '293B69662822737472696E6722213D747970656F6620742E6F70656E7C7C22737472696E6722213D747970656F6620742E746F6B656E7C7C22737472696E6722213D747970656F6620742E636C6F7365297468726F77206D6E65286E2C22657665727920';
wwv_flow_imp.g_varchar2_table(34395) := '656C656D656E7420696E207468652027627261636B65747327206172726179206D757374206265206120277B6F70656E2C636C6F73652C746F6B656E7D27206F626A656374206F7220617272617922293B732E70757368287B746F6B656E3A742E746F6B';
wwv_flow_imp.g_varchar2_table(34396) := '656E2B6E2E746F6B656E506F73746669782C6F70656E3A706E65286E2C742E6F70656E292C636C6F73653A706E65286E2C742E636C6F7365297D297D72657475726E206E2E627261636B6574733D732C6E2E6E6F5468726F773D21302C6E7D636C617373';
wwv_flow_imp.g_varchar2_table(34397) := '205A72657B636F6E7374727563746F7228652C74297B746869732E5F6C616E677561676549643D652C746869732E5F61637475616C3D747D646973706F736528297B7D676574496E697469616C537461746528297B72657475726E20746869732E5F6163';
wwv_flow_imp.g_varchar2_table(34398) := '7475616C2E676574496E697469616C537461746528297D746F6B656E697A6528652C742C6E297B6966282266756E6374696F6E223D3D747970656F6620746869732E5F61637475616C2E746F6B656E697A652972657475726E205872652E616461707454';
wwv_flow_imp.g_varchar2_table(34399) := '6F6B656E697A6528746869732E5F6C616E677561676549642C746869732E5F61637475616C2C652C6E293B7468726F77206E6577204572726F7228224E6F7420737570706F727465642122297D746F6B656E697A65456E636F64656428652C742C6E297B';
wwv_flow_imp.g_varchar2_table(34400) := '636F6E737420693D746869732E5F61637475616C2E746F6B656E697A65456E636F64656428652C6E293B72657475726E206E657720627728692E746F6B656E732C692E656E645374617465297D7D636C617373205872657B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(34401) := '652C742C6E2C69297B746869732E5F6C616E677561676549643D652C746869732E5F61637475616C3D742C746869732E5F6C616E6775616765536572766963653D6E2C746869732E5F7374616E64616C6F6E655468656D65536572766963653D697D6469';
wwv_flow_imp.g_varchar2_table(34402) := '73706F736528297B7D676574496E697469616C537461746528297B72657475726E20746869732E5F61637475616C2E676574496E697469616C537461746528297D737461746963205F746F436C6173736963546F6B656E7328652C74297B636F6E737420';
wwv_flow_imp.g_varchar2_table(34403) := '6E3D5B5D3B6C657420693D303B666F72286C6574206F3D302C733D652E6C656E6774683B6F3C733B6F2B2B297B636F6E737420733D655B6F5D3B6C657420723D732E7374617274496E6465783B303D3D3D6F3F723D303A723C69262628723D69292C6E5B';
wwv_flow_imp.g_varchar2_table(34404) := '6F5D3D6E657720667728722C732E73636F7065732C74292C693D727D72657475726E206E7D737461746963206164617074546F6B656E697A6528652C742C6E2C69297B636F6E7374206F3D742E746F6B656E697A65286E2C69292C733D5872652E5F746F';
wwv_flow_imp.g_varchar2_table(34405) := '436C6173736963546F6B656E73286F2E746F6B656E732C65293B6C657420723B72657475726E20723D6F2E656E6453746174652E657175616C732869293F693A6F2E656E6453746174652C6E657720767728732C72297D746F6B656E697A6528652C742C';
wwv_flow_imp.g_varchar2_table(34406) := '6E297B72657475726E205872652E6164617074546F6B656E697A6528746869732E5F6C616E677561676549642C746869732E5F61637475616C2C652C6E297D5F746F42696E617279546F6B656E7328652C74297B636F6E7374206E3D652E656E636F6465';
wwv_flow_imp.g_varchar2_table(34407) := '4C616E6775616765496428746869732E5F6C616E67756167654964292C693D746869732E5F7374616E64616C6F6E655468656D65536572766963652E676574436F6C6F725468656D6528292E746F6B656E5468656D652C6F3D5B5D3B6C657420733D302C';
wwv_flow_imp.g_varchar2_table(34408) := '723D303B666F72286C657420653D302C613D742E6C656E6774683B653C613B652B2B297B636F6E737420613D745B655D2C6C3D313032347C692E6D61746368286E2C612E73636F706573293B696628733E3026266F5B732D315D3D3D3D6C29636F6E7469';
wwv_flow_imp.g_varchar2_table(34409) := '6E75653B6C657420633D612E7374617274496E6465783B303D3D3D653F633D303A633C72262628633D72292C6F5B732B2B5D3D632C6F5B732B2B5D3D6C2C723D637D636F6E737420613D6E65772055696E74333241727261792873293B666F72286C6574';
wwv_flow_imp.g_varchar2_table(34410) := '20653D303B653C733B652B2B29615B655D3D6F5B655D3B72657475726E20617D746F6B656E697A65456E636F64656428652C742C6E297B636F6E737420693D746869732E5F61637475616C2E746F6B656E697A6528652C6E292C6F3D746869732E5F746F';
wwv_flow_imp.g_varchar2_table(34411) := '42696E617279546F6B656E7328746869732E5F6C616E6775616765536572766963652E6C616E67756167654964436F6465632C692E746F6B656E73293B6C657420733B72657475726E20733D692E656E6453746174652E657175616C73286E293F6E3A69';
wwv_flow_imp.g_varchar2_table(34412) := '2E656E6453746174652C6E6577206277286F2C73297D7D66756E6374696F6E204A72652865297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E7468656E7D66756E6374696F6E2065616528652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(34413) := '66756E6374696F6E2865297B72657475726E22746F6B656E697A65456E636F64656422696E20657D2874293F6E6577205A726528652C74293A6E65772058726528652C742C4372652E676574284C75292C4372652E67657428793629297D66756E637469';
wwv_flow_imp.g_varchar2_table(34414) := '6F6E2074616528652C74297B636F6E7374206E3D6E6577204E7728286173796E6328293D3E7B636F6E7374206E3D61776169742050726F6D6973652E7265736F6C766528742E6372656174652829293B72657475726E206E3F2266756E6374696F6E223D';
wwv_flow_imp.g_varchar2_table(34415) := '3D747970656F66206E2E676574496E697469616C53746174653F65616528652C6E293A6E657720456E65284372652E676574284C75292C4372652E676574287936292C652C59726528652C6E292C4372652E67657428667029293A6E756C6C7D29293B72';
wwv_flow_imp.g_varchar2_table(34416) := '657475726E2050772E7265676973746572466163746F727928652C6E297D594C2E7772617070696E67496E64656E742E64656661756C7456616C75653D302C594C2E676C7970684D617267696E2E64656661756C7456616C75653D21312C594C2E617574';
wwv_flow_imp.g_varchar2_table(34417) := '6F496E64656E742E64656661756C7456616C75653D332C594C2E6F7665727669657752756C65724C616E65732E64656661756C7456616C75653D322C57312E736574466F726D617474657253656C6563746F72282828652C742C6E293D3E50726F6D6973';
wwv_flow_imp.g_varchar2_table(34418) := '652E7265736F6C766528655B305D2929293B636F6E7374206E61653D427A28293B6E61652E656469746F723D7B6372656174653A66756E6374696F6E28652C742C6E297B72657475726E204372652E696E697469616C697A65286E7C7C7B7D292E637265';
wwv_flow_imp.g_varchar2_table(34419) := '617465496E7374616E6365284472652C652C74297D2C676574456469746F72733A66756E6374696F6E28297B72657475726E204372652E676574286763292E6C697374436F6465456469746F727328297D2C67657444696666456469746F72733A66756E';
wwv_flow_imp.g_varchar2_table(34420) := '6374696F6E28297B72657475726E204372652E676574286763292E6C69737444696666456469746F727328297D2C6F6E446964437265617465456469746F723A66756E6374696F6E2865297B72657475726E204372652E676574286763292E6F6E436F64';
wwv_flow_imp.g_varchar2_table(34421) := '65456469746F724164642828743D3E7B652874297D29297D2C6F6E44696443726561746544696666456469746F723A66756E6374696F6E2865297B72657475726E204372652E676574286763292E6F6E44696666456469746F724164642828743D3E7B65';
wwv_flow_imp.g_varchar2_table(34422) := '2874297D29297D2C63726561746544696666456469746F723A66756E6374696F6E28652C742C6E297B72657475726E204372652E696E697469616C697A65286E7C7C7B7D292E637265617465496E7374616E6365285472652C652C74297D2C616464436F';
wwv_flow_imp.g_varchar2_table(34423) := '6D6D616E643A66756E6374696F6E2865297B69662822737472696E6722213D747970656F6620652E69647C7C2266756E6374696F6E22213D747970656F6620652E72756E297468726F77206E6577204572726F722822496E76616C696420636F6D6D616E';
wwv_flow_imp.g_varchar2_table(34424) := '642064657363726970746F722C206069646020616E64206072756E60206172652072657175697265642070726F706572746965732122293B72657475726E206B632E7265676973746572436F6D6D616E6428652E69642C652E72756E297D2C6164644564';
wwv_flow_imp.g_varchar2_table(34425) := '69746F72416374696F6E3A66756E6374696F6E2865297B69662822737472696E6722213D747970656F6620652E69647C7C22737472696E6722213D747970656F6620652E6C6162656C7C7C2266756E6374696F6E22213D747970656F6620652E72756E29';
wwv_flow_imp.g_varchar2_table(34426) := '7468726F77206E6577204572726F722822496E76616C696420616374696F6E2064657363726970746F722C20606964602C20606C6162656C6020616E64206072756E60206172652072657175697265642070726F706572746965732122293B636F6E7374';
wwv_flow_imp.g_varchar2_table(34427) := '20743D57632E646573657269616C697A6528652E707265636F6E646974696F6E292C6E3D6E65772061743B6966286E2E616464286B632E7265676973746572436F6D6D616E6428652E69642C28286E2C2E2E2E69293D3E24642E72756E456469746F7243';
wwv_flow_imp.g_varchar2_table(34428) := '6F6D6D616E64286E2C692C742C2828742C6E2C69293D3E50726F6D6973652E7265736F6C766528652E72756E286E2C2E2E2E69292929292929292C652E636F6E746578744D656E7547726F75704964297B636F6E737420693D7B636F6D6D616E643A7B69';
wwv_flow_imp.g_varchar2_table(34429) := '643A652E69642C7469746C653A652E6C6162656C7D2C7768656E3A742C67726F75703A652E636F6E746578744D656E7547726F757049642C6F726465723A652E636F6E746578744D656E754F726465727C7C307D3B6E2E6164642849642E617070656E64';
wwv_flow_imp.g_varchar2_table(34430) := '4D656E754974656D284C642E456469746F72436F6E746578742C6929297D69662841727261792E6973417272617928652E6B657962696E64696E677329297B636F6E737420693D4372652E676574282445293B6966286920696E7374616E63656F662068';
wwv_flow_imp.g_varchar2_table(34431) := '7265297B636F6E7374206F3D57632E616E6428742C57632E646573657269616C697A6528652E6B657962696E64696E67436F6E7465787429293B6E2E61646428692E61646444796E616D69634B657962696E64696E677328652E6B657962696E64696E67';
wwv_flow_imp.g_varchar2_table(34432) := '732E6D61702828743D3E287B6B657962696E64696E673A742C636F6D6D616E643A652E69642C7768656E3A6F7D29292929297D656C736520636F6E736F6C652E7761726E282243616E6E6F7420616464206B657962696E64696E67206265636175736520';
wwv_flow_imp.g_varchar2_table(34433) := '74686520656469746F7220697320636F6E66696775726564207769746820616E20756E7265636F676E697A6564204B657962696E64696E675365727669636522297D72657475726E206E7D2C6164644B657962696E64696E6752756C653A66756E637469';
wwv_flow_imp.g_varchar2_table(34434) := '6F6E2865297B72657475726E20577265285B655D297D2C6164644B657962696E64696E6752756C65733A5772652C6372656174654D6F64656C3A66756E6374696F6E28652C742C6E297B636F6E737420693D4372652E676574284C75292C6F3D692E6765';
wwv_flow_imp.g_varchar2_table(34435) := '744C616E6775616765496442794D696D65547970652874297C7C743B72657475726E20497265284372652E676574286663292C692C652C6F2C6E297D2C7365744D6F64656C4C616E67756167653A66756E6374696F6E28652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(34436) := '4372652E676574284C75292C693D6E2E6765744C616E6775616765496442794D696D65547970652874297C7C747C7C55703B652E7365744C616E6775616765286E2E63726561746542794964286929297D2C7365744D6F64656C4D61726B6572733A6675';
wwv_flow_imp.g_varchar2_table(34437) := '6E6374696F6E28652C742C6E297B6526264372652E676574284A4D292E6368616E67654F6E6528742C652E7572692C6E297D2C6765744D6F64656C4D61726B6572733A66756E6374696F6E2865297B72657475726E204372652E676574284A4D292E7265';
wwv_flow_imp.g_varchar2_table(34438) := '61642865297D2C72656D6F7665416C6C4D61726B6572733A66756E6374696F6E2865297B4372652E676574284A4D292E6368616E6765416C6C28652C5B5D297D2C6F6E4469644368616E67654D61726B6572733A66756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(34439) := '726E204372652E676574284A4D292E6F6E4D61726B65724368616E6765642865297D2C6765744D6F64656C733A66756E6374696F6E28297B72657475726E204372652E676574286663292E6765744D6F64656C7328297D2C6765744D6F64656C3A66756E';
wwv_flow_imp.g_varchar2_table(34440) := '6374696F6E2865297B72657475726E204372652E676574286663292E6765744D6F64656C2865297D2C6F6E4469644372656174654D6F64656C3A66756E6374696F6E2865297B72657475726E204372652E676574286663292E6F6E4D6F64656C41646465';
wwv_flow_imp.g_varchar2_table(34441) := '642865297D2C6F6E57696C6C446973706F73654D6F64656C3A66756E6374696F6E2865297B72657475726E204372652E676574286663292E6F6E4D6F64656C52656D6F7665642865297D2C6F6E4469644368616E67654D6F64656C4C616E67756167653A';
wwv_flow_imp.g_varchar2_table(34442) := '66756E6374696F6E2865297B72657475726E204372652E676574286663292E6F6E4D6F64656C4C616E67756167654368616E6765642828743D3E7B65287B6D6F64656C3A742E6D6F64656C2C6F6C644C616E67756167653A742E6F6C644C616E67756167';
wwv_flow_imp.g_varchar2_table(34443) := '6549647D297D29297D2C637265617465576562576F726B65723A66756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C742C6E297B72657475726E206E657720636E6528652C742C6E297D284372652E676574286663292C4372652E';
wwv_flow_imp.g_varchar2_table(34444) := '676574286567292C65297D2C636F6C6F72697A65456C656D656E743A66756E6374696F6E28652C74297B636F6E7374206E3D4372652E676574284C75292C693D4372652E676574287936293B72657475726E20546E652E636F6C6F72697A65456C656D65';
wwv_flow_imp.g_varchar2_table(34445) := '6E7428692C6E2C652C74292E7468656E282828293D3E7B692E7265676973746572456469746F72436F6E7461696E65722865297D29297D2C636F6C6F72697A653A66756E6374696F6E28652C742C6E297B636F6E737420693D4372652E676574284C7529';
wwv_flow_imp.g_varchar2_table(34446) := '3B72657475726E204372652E676574287936292E7265676973746572456469746F72436F6E7461696E657228732E646F63756D656E742E626F6479292C546E652E636F6C6F72697A6528692C652C742C6E297D2C636F6C6F72697A654D6F64656C4C696E';
wwv_flow_imp.g_varchar2_table(34447) := '653A66756E6374696F6E28652C742C6E3D34297B72657475726E204372652E676574287936292E7265676973746572456469746F72436F6E7461696E657228732E646F63756D656E742E626F6479292C546E652E636F6C6F72697A654D6F64656C4C696E';
wwv_flow_imp.g_varchar2_table(34448) := '6528652C742C6E297D2C746F6B656E697A653A66756E6374696F6E28652C74297B50772E6765744F724372656174652874293B636F6E7374206E3D66756E6374696F6E2865297B72657475726E2050772E6765742865297C7C7B676574496E697469616C';
wwv_flow_imp.g_varchar2_table(34449) := '53746174653A28293D3E52772C746F6B656E697A653A28742C6E2C69293D3E467728652C69297D7D2874292C693D67692865292C6F3D5B5D3B6C657420733D6E2E676574496E697469616C537461746528293B666F72286C657420653D302C743D692E6C';
wwv_flow_imp.g_varchar2_table(34450) := '656E6774683B653C743B652B2B297B636F6E737420743D695B655D2C723D6E2E746F6B656E697A6528742C21302C73293B6F5B655D3D722E746F6B656E732C733D722E656E6453746174657D72657475726E206F7D2C646566696E655468656D653A6675';
wwv_flow_imp.g_varchar2_table(34451) := '6E6374696F6E28652C74297B4372652E676574287936292E646566696E655468656D6528652C74297D2C7365745468656D653A66756E6374696F6E2865297B4372652E676574287936292E7365745468656D652865297D2C72656D656173757265466F6E';
wwv_flow_imp.g_varchar2_table(34452) := '74733A66756E6374696F6E28297B4C412E636C656172416C6C466F6E74496E666F7328297D2C7265676973746572436F6D6D616E643A66756E6374696F6E28652C74297B72657475726E206B632E7265676973746572436F6D6D616E64287B69643A652C';
wwv_flow_imp.g_varchar2_table(34453) := '68616E646C65723A747D297D2C72656769737465724C696E6B4F70656E65723A66756E6374696F6E2865297B72657475726E204372652E676574286445292E72656769737465724F70656E6572287B6F70656E3A6173796E6320743D3E2822737472696E';
wwv_flow_imp.g_varchar2_table(34454) := '67223D3D747970656F662074262628743D4E6F2E7061727365287429292C652E6F70656E287429297D297D2C7265676973746572456469746F724F70656E65723A66756E6374696F6E2865297B72657475726E204372652E676574286763292E72656769';
wwv_flow_imp.g_varchar2_table(34455) := '73746572436F6465456469746F724F70656E48616E646C657228286173796E6328742C6E2C69293D3E7B766172206F3B696628216E2972657475726E206E756C6C3B636F6E737420733D6E756C6C3D3D3D286F3D742E6F7074696F6E73297C7C766F6964';
wwv_flow_imp.g_varchar2_table(34456) := '20303D3D3D6F3F766F696420303A6F2E73656C656374696F6E3B6C657420723B72657475726E20732626226E756D626572223D3D747970656F6620732E656E644C696E654E756D6265722626226E756D626572223D3D747970656F6620732E656E64436F';
wwv_flow_imp.g_varchar2_table(34457) := '6C756D6E3F723D733A73262628723D7B6C696E654E756D6265723A732E73746172744C696E654E756D6265722C636F6C756D6E3A732E7374617274436F6C756D6E7D292C617761697420652E6F70656E436F6465456469746F72286E2C742E7265736F75';
wwv_flow_imp.g_varchar2_table(34458) := '7263652C72293F6E3A6E756C6C7D29297D2C4163636573736962696C697479537570706F72743A24562C436F6E74656E74576964676574506F736974696F6E507265666572656E63653A5A562C437572736F724368616E6765526561736F6E3A58562C44';
wwv_flow_imp.g_varchar2_table(34459) := '656661756C74456E644F664C696E653A4A562C456469746F724175746F496E64656E7453747261746567793A747A2C456469746F724F7074696F6E3A6E7A2C456E644F664C696E65507265666572656E63653A697A2C456E644F664C696E655365717565';
wwv_flow_imp.g_varchar2_table(34460) := '6E63653A6F7A2C4D696E696D6170506F736974696F6E3A6D7A2C4D696E696D617053656374696F6E4865616465725374796C653A667A2C4D6F757365546172676574547970653A767A2C4F7665726C6179576964676574506F736974696F6E5072656665';
wwv_flow_imp.g_varchar2_table(34461) := '72656E63653A797A2C4F7665727669657752756C65724C616E653A777A2C476C7970684D617267696E4C616E653A737A2C52656E6465724C696E654E756D62657273547970653A787A2C52656E6465724D696E696D61703A6B7A2C5363726F6C6C626172';
wwv_flow_imp.g_varchar2_table(34462) := '5669736962696C6974793A4C7A2C5363726F6C6C547970653A457A2C54657874456469746F72437572736F72426C696E6B696E675374796C653A4E7A2C54657874456469746F72437572736F725374796C653A507A2C547261636B656452616E67655374';
wwv_flow_imp.g_varchar2_table(34463) := '69636B696E6573733A4F7A2C5772617070696E67496E64656E743A527A2C496E6A656374656454657874437572736F7253746F70733A6C7A2C506F736974696F6E416666696E6974793A537A2C53686F774C6967687462756C6249636F6E4D6F64653A54';
wwv_flow_imp.g_varchar2_table(34464) := '7A2C436F6E66696775726174696F6E4368616E6765644576656E743A704C2C42617265466F6E74496E666F3A78412C466F6E74496E666F3A6B412C546578744D6F64656C5265736F6C7665644F7074696F6E733A4C682C46696E644D617463683A44682C';
wwv_flow_imp.g_varchar2_table(34465) := '4170706C79557064617465526573756C743A664C2C456469746F725A6F6F6D3A43412C6372656174654D756C746946696C6544696666456469746F723A66756E6374696F6E28652C74297B636F6E7374206E3D4372652E696E697469616C697A6528747C';
wwv_flow_imp.g_varchar2_table(34466) := '7C7B7D293B72657475726E206E65772048726528652C7B7D2C6E297D2C456469746F72547970653A71522C456469746F724F7074696F6E733A594C7D2C6E61652E6C616E6775616765733D7B72656769737465723A66756E6374696F6E2865297B24702E';
wwv_flow_imp.g_varchar2_table(34467) := '72656769737465724C616E67756167652865297D2C6765744C616E6775616765733A66756E6374696F6E28297B6C657420653D5B5D3B72657475726E20653D652E636F6E6361742824702E6765744C616E6775616765732829292C657D2C6F6E4C616E67';
wwv_flow_imp.g_varchar2_table(34468) := '756167653A66756E6374696F6E28652C74297B72657475726E204372652E776974685365727669636573282828293D3E7B636F6E7374206E3D4372652E676574284C75292E6F6E44696452657175657374526963684C616E677561676546656174757265';
wwv_flow_imp.g_varchar2_table(34469) := '732828693D3E7B693D3D3D652626286E2E646973706F736528292C742829297D29293B72657475726E206E7D29297D2C6F6E4C616E6775616765456E636F756E74657265643A66756E6374696F6E28652C74297B72657475726E204372652E7769746853';
wwv_flow_imp.g_varchar2_table(34470) := '65727669636573282828293D3E7B636F6E7374206E3D4372652E676574284C75292E6F6E4469645265717565737442617369634C616E677561676546656174757265732828693D3E7B693D3D3D652626286E2E646973706F736528292C742829297D2929';
wwv_flow_imp.g_varchar2_table(34471) := '3B72657475726E206E7D29297D2C676574456E636F6465644C616E677561676549643A66756E6374696F6E2865297B72657475726E204372652E676574284C75292E6C616E67756167654964436F6465632E656E636F64654C616E677561676549642865';
wwv_flow_imp.g_varchar2_table(34472) := '297D2C7365744C616E6775616765436F6E66696775726174696F6E3A66756E6374696F6E28652C74297B696628214372652E676574284C75292E6973526567697374657265644C616E67756167654964286529297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(34473) := '6043616E6E6F742073657420636F6E66696775726174696F6E20666F7220756E6B6E6F776E206C616E677561676520247B657D60293B72657475726E204372652E676574286567292E726567697374657228652C742C313030297D2C736574436F6C6F72';
wwv_flow_imp.g_varchar2_table(34474) := '4D61703A66756E6374696F6E2865297B636F6E737420743D4372652E676574287936293B69662865297B636F6E7374206E3D5B6E756C6C5D3B666F72286C657420743D312C693D652E6C656E6774683B743C693B742B2B296E5B745D3D68752E66726F6D';
wwv_flow_imp.g_varchar2_table(34475) := '48657828655B745D293B742E736574436F6C6F724D61704F76657272696465286E297D656C736520742E736574436F6C6F724D61704F76657272696465286E756C6C297D2C7265676973746572546F6B656E7350726F7669646572466163746F72793A74';
wwv_flow_imp.g_varchar2_table(34476) := '61652C736574546F6B656E7350726F76696465723A66756E6374696F6E28652C74297B696628214372652E676574284C75292E6973526567697374657265644C616E67756167654964286529297468726F77206E6577204572726F72286043616E6E6F74';
wwv_flow_imp.g_varchar2_table(34477) := '2073657420746F6B656E732070726F766964657220666F7220756E6B6E6F776E206C616E677561676520247B657D60293B72657475726E204A72652874293F74616528652C7B6372656174653A28293D3E747D293A50772E726567697374657228652C65';
wwv_flow_imp.g_varchar2_table(34478) := '616528652C7429297D2C7365744D6F6E61726368546F6B656E7350726F76696465723A66756E6374696F6E28652C74297B72657475726E204A72652874293F74616528652C7B6372656174653A28293D3E747D293A50772E726567697374657228652C28';
wwv_flow_imp.g_varchar2_table(34479) := '743D3E6E657720456E65284372652E676574284C75292C4372652E676574287936292C652C59726528652C74292C4372652E676574286670292929287429297D2C72656769737465725265666572656E636550726F76696465723A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(34480) := '652C74297B72657475726E204372652E676574287878292E7265666572656E636550726F76696465722E726567697374657228652C74297D2C726567697374657252656E616D6550726F76696465723A66756E6374696F6E28652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(34481) := '204372652E676574287878292E72656E616D6550726F76696465722E726567697374657228652C74297D2C72656769737465724E657753796D626F6C4E616D6550726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E6765';
wwv_flow_imp.g_varchar2_table(34482) := '74287878292E6E657753796D626F6C4E616D657350726F76696465722E726567697374657228652C74297D2C7265676973746572436F6D706C6574696F6E4974656D50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E';
wwv_flow_imp.g_varchar2_table(34483) := '676574287878292E636F6D706C6574696F6E50726F76696465722E726567697374657228652C74297D2C72656769737465725369676E617475726548656C7050726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574';
wwv_flow_imp.g_varchar2_table(34484) := '287878292E7369676E617475726548656C7050726F76696465722E726567697374657228652C74297D2C7265676973746572486F76657250726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E686F76';
wwv_flow_imp.g_varchar2_table(34485) := '657250726F76696465722E726567697374657228652C7B70726F76696465486F7665723A6173796E6328652C6E2C692C6F293D3E7B636F6E737420733D652E676574576F72644174506F736974696F6E286E293B72657475726E2050726F6D6973652E72';
wwv_flow_imp.g_varchar2_table(34486) := '65736F6C766528742E70726F76696465486F76657228652C6E2C692C6F29292E7468656E2828653D3E7B696628652972657475726E21652E72616E6765262673262628652E72616E67653D6E6577207268286E2E6C696E654E756D6265722C732E737461';
wwv_flow_imp.g_varchar2_table(34487) := '7274436F6C756D6E2C6E2E6C696E654E756D6265722C732E656E64436F6C756D6E29292C652E72616E67657C7C28652E72616E67653D6E6577207268286E2E6C696E654E756D6265722C6E2E636F6C756D6E2C6E2E6C696E654E756D6265722C6E2E636F';
wwv_flow_imp.g_varchar2_table(34488) := '6C756D6E29292C657D29297D7D297D2C7265676973746572446F63756D656E7453796D626F6C50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E646F63756D656E7453796D626F6C50726F766964';
wwv_flow_imp.g_varchar2_table(34489) := '65722E726567697374657228652C74297D2C7265676973746572446F63756D656E74486967686C6967687450726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E646F63756D656E74486967686C6967';
wwv_flow_imp.g_varchar2_table(34490) := '687450726F76696465722E726567697374657228652C74297D2C72656769737465724C696E6B656445646974696E6752616E676550726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E6C696E6B6564';
wwv_flow_imp.g_varchar2_table(34491) := '45646974696E6752616E676550726F76696465722E726567697374657228652C74297D2C7265676973746572446566696E6974696F6E50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E64656669';
wwv_flow_imp.g_varchar2_table(34492) := '6E6974696F6E50726F76696465722E726567697374657228652C74297D2C7265676973746572496D706C656D656E746174696F6E50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E696D706C656D';
wwv_flow_imp.g_varchar2_table(34493) := '656E746174696F6E50726F76696465722E726567697374657228652C74297D2C726567697374657254797065446566696E6974696F6E50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E74797065';
wwv_flow_imp.g_varchar2_table(34494) := '446566696E6974696F6E50726F76696465722E726567697374657228652C74297D2C7265676973746572436F64654C656E7350726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E636F64654C656E73';
wwv_flow_imp.g_varchar2_table(34495) := '50726F76696465722E726567697374657228652C74297D2C7265676973746572436F6465416374696F6E50726F76696465723A66756E6374696F6E28652C742C6E297B72657475726E204372652E676574287878292E636F6465416374696F6E50726F76';
wwv_flow_imp.g_varchar2_table(34496) := '696465722E726567697374657228652C7B70726F7669646564436F6465416374696F6E4B696E64733A6E756C6C3D3D6E3F766F696420303A6E2E70726F7669646564436F6465416374696F6E4B696E64732C646F63756D656E746174696F6E3A6E756C6C';
wwv_flow_imp.g_varchar2_table(34497) := '3D3D6E3F766F696420303A6E2E646F63756D656E746174696F6E2C70726F76696465436F6465416374696F6E733A28652C6E2C692C6F293D3E7B636F6E737420733D4372652E676574284A4D292E72656164287B7265736F757263653A652E7572697D29';
wwv_flow_imp.g_varchar2_table(34498) := '2E66696C7465722828653D3E72682E617265496E74657273656374696E674F72546F756368696E6728652C6E2929293B72657475726E20742E70726F76696465436F6465416374696F6E7328652C6E2C7B6D61726B6572733A732C6F6E6C793A692E6F6E';
wwv_flow_imp.g_varchar2_table(34499) := '6C792C747269676765723A692E747269676765727D2C6F297D2C7265736F6C7665436F6465416374696F6E3A742E7265736F6C7665436F6465416374696F6E7D297D2C7265676973746572446F63756D656E74466F726D617474696E674564697450726F';
wwv_flow_imp.g_varchar2_table(34500) := '76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E646F63756D656E74466F726D617474696E674564697450726F76696465722E726567697374657228652C74297D2C7265676973746572446F63756D656E';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(34501) := '7452616E6765466F726D617474696E674564697450726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E646F63756D656E7452616E6765466F726D617474696E674564697450726F76696465722E7265';
wwv_flow_imp.g_varchar2_table(34502) := '67697374657228652C74297D2C72656769737465724F6E54797065466F726D617474696E674564697450726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E6F6E54797065466F726D617474696E6745';
wwv_flow_imp.g_varchar2_table(34503) := '64697450726F76696465722E726567697374657228652C74297D2C72656769737465724C696E6B50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E6C696E6B50726F76696465722E726567697374';
wwv_flow_imp.g_varchar2_table(34504) := '657228652C74297D2C7265676973746572436F6C6F7250726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E636F6C6F7250726F76696465722E726567697374657228652C74297D2C72656769737465';
wwv_flow_imp.g_varchar2_table(34505) := '72466F6C64696E6752616E676550726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E666F6C64696E6752616E676550726F76696465722E726567697374657228652C74297D2C726567697374657244';
wwv_flow_imp.g_varchar2_table(34506) := '65636C61726174696F6E50726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E6465636C61726174696F6E50726F76696465722E726567697374657228652C74297D2C726567697374657253656C6563';
wwv_flow_imp.g_varchar2_table(34507) := '74696F6E52616E676550726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E73656C656374696F6E52616E676550726F76696465722E726567697374657228652C74297D2C7265676973746572446F63';
wwv_flow_imp.g_varchar2_table(34508) := '756D656E7453656D616E746963546F6B656E7350726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E646F63756D656E7453656D616E746963546F6B656E7350726F76696465722E7265676973746572';
wwv_flow_imp.g_varchar2_table(34509) := '28652C74297D2C7265676973746572446F63756D656E7452616E676553656D616E746963546F6B656E7350726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E646F63756D656E7452616E676553656D';
wwv_flow_imp.g_varchar2_table(34510) := '616E746963546F6B656E7350726F76696465722E726567697374657228652C74297D2C7265676973746572496E6C696E65436F6D706C6574696F6E7350726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878';
wwv_flow_imp.g_varchar2_table(34511) := '292E696E6C696E65436F6D706C6574696F6E7350726F76696465722E726567697374657228652C74297D2C7265676973746572496E6C696E654564697450726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E6765742878';
wwv_flow_imp.g_varchar2_table(34512) := '78292E696E6C696E654564697450726F76696465722E726567697374657228652C74297D2C7265676973746572496E6C617948696E747350726F76696465723A66756E6374696F6E28652C74297B72657475726E204372652E676574287878292E696E6C';
wwv_flow_imp.g_varchar2_table(34513) := '617948696E747350726F76696465722E726567697374657228652C74297D2C446F63756D656E74486967686C696768744B696E643A657A2C436F6D706C6574696F6E4974656D4B696E643A47562C436F6D706C6574696F6E4974656D5461673A51562C43';
wwv_flow_imp.g_varchar2_table(34514) := '6F6D706C6574696F6E4974656D496E736572745465787452756C653A4B562C53796D626F6C4B696E643A4D7A2C53796D626F6C5461673A417A2C496E64656E74416374696F6E3A617A2C436F6D706C6574696F6E547269676765724B696E643A59562C53';
wwv_flow_imp.g_varchar2_table(34515) := '69676E617475726548656C70547269676765724B696E643A497A2C496E6C617948696E744B696E643A637A2C496E6C696E65436F6D706C6574696F6E547269676765724B696E643A647A2C496E6C696E6545646974547269676765724B696E643A687A2C';
wwv_flow_imp.g_varchar2_table(34516) := '436F6465416374696F6E54726967676572547970653A55562C4E657753796D626F6C4E616D655461673A627A2C4E657753796D626F6C4E616D65547269676765724B696E643A5F7A2C5061727469616C416363657074547269676765724B696E643A437A';
wwv_flow_imp.g_varchar2_table(34517) := '2C486F766572566572626F73697479416374696F6E3A727A2C466F6C64696E6752616E67654B696E643A41772C53656C656374656453756767657374696F6E496E666F3A6B777D3B636F6E7374206961653D6E61652E43616E63656C6C6174696F6E546F';
wwv_flow_imp.g_varchar2_table(34518) := '6B656E536F757263652C6F61653D6E61652E456D69747465722C7361653D6E61652E4B6579436F64652C7261653D6E61652E4B65794D6F642C6161653D6E61652E506F736974696F6E2C6C61653D6E61652E52616E67652C6361653D6E61652E53656C65';
wwv_flow_imp.g_varchar2_table(34519) := '6374696F6E2C6461653D6E61652E53656C656374696F6E446972656374696F6E2C6861653D6E61652E4D61726B657253657665726974792C7561653D6E61652E4D61726B65725461672C7061653D6E61652E5572692C6761653D6E61652E546F6B656E2C';
wwv_flow_imp.g_varchar2_table(34520) := '6D61653D6E61652E656469746F722C6661653D6E61652E6C616E6775616765732C7661653D676C6F62616C546869732E4D6F6E61636F456E7669726F6E6D656E743B28286E756C6C3D3D7661653F766F696420303A7661652E676C6F62616C415049297C';
wwv_flow_imp.g_varchar2_table(34521) := '7C2266756E6374696F6E223D3D747970656F6620646566696E6526266E2E616D644F29262628676C6F62616C546869732E6D6F6E61636F3D6E6165292C766F69642030213D3D676C6F62616C546869732E7265717569726526262266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(34522) := '3D3D747970656F6620676C6F62616C546869732E726571756972652E636F6E6669672626676C6F62616C546869732E726571756972652E636F6E666967287B69676E6F72654475706C69636174654D6F64756C65733A5B227673636F64652D6C616E6775';
wwv_flow_imp.g_varchar2_table(34523) := '6167657365727665722D7479706573222C227673636F64652D6C616E67756167657365727665722D74797065732F6D61696E222C227673636F64652D6C616E67756167657365727665722D74657874646F63756D656E74222C227673636F64652D6C616E';
wwv_flow_imp.g_varchar2_table(34524) := '67756167657365727665722D74657874646F63756D656E742F6D61696E222C227673636F64652D6E6C73222C227673636F64652D6E6C732F7673636F64652D6E6C73222C226A736F6E632D706172736572222C226A736F6E632D7061727365722F6D6169';
wwv_flow_imp.g_varchar2_table(34525) := '6E222C227673636F64652D757269222C227673636F64652D7572692F696E646578222C2276732F62617369632D6C616E6775616765732F747970657363726970742F74797065736372697074225D7D293B766172206261653D4F626A6563742E64656669';
wwv_flow_imp.g_varchar2_table(34526) := '6E6550726F70657274792C5F61653D4F626A6563742E6765744F776E50726F706572747944657363726970746F722C7961653D4F626A6563742E6765744F776E50726F70657274794E616D65732C7761653D4F626A6563742E70726F746F747970652E68';
wwv_flow_imp.g_varchar2_table(34527) := '61734F776E50726F70657274792C4361653D28652C742C6E2C69293D3E7B696628742626226F626A656374223D3D747970656F6620747C7C2266756E6374696F6E223D3D747970656F66207429666F72286C6574206F206F662079616528742929776165';
wwv_flow_imp.g_varchar2_table(34528) := '2E63616C6C28652C6F297C7C6F3D3D3D6E7C7C62616528652C6F2C7B6765743A28293D3E745B6F5D2C656E756D657261626C653A2128693D5F616528742C6F29297C7C692E656E756D657261626C657D293B72657475726E20657D2C5361653D7B7D3B43';
wwv_flow_imp.g_varchar2_table(34529) := '6165285361652C6F2C2264656661756C7422293B766172207861653D7B7D2C6B61653D7B7D2C4561653D636C61737320657B737461746963206765744F724372656174652874297B72657475726E206B61655B745D7C7C286B61655B745D3D6E65772065';
wwv_flow_imp.g_varchar2_table(34530) := '287429292C6B61655B745D7D636F6E7374727563746F722865297B746869732E5F6C616E677561676549643D652C746869732E5F6C6F6164696E675472696767657265643D21312C746869732E5F6C617A794C6F616450726F6D6973653D6E6577205072';
wwv_flow_imp.g_varchar2_table(34531) := '6F6D697365282828652C74293D3E7B746869732E5F6C617A794C6F616450726F6D6973655265736F6C76653D652C746869732E5F6C617A794C6F616450726F6D69736552656A6563743D747D29297D6C6F616428297B72657475726E20746869732E5F6C';
wwv_flow_imp.g_varchar2_table(34532) := '6F6164696E675472696767657265647C7C28746869732E5F6C6F6164696E675472696767657265643D21302C7861655B746869732E5F6C616E677561676549645D2E6C6F6164657228292E7468656E2828653D3E746869732E5F6C617A794C6F61645072';
wwv_flow_imp.g_varchar2_table(34533) := '6F6D6973655265736F6C7665286529292C28653D3E746869732E5F6C617A794C6F616450726F6D69736552656A6563742865292929292C746869732E5F6C617A794C6F616450726F6D6973657D7D3B66756E6374696F6E204C61652865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(34534) := '20743D652E69643B7861655B745D3D652C5361652E6C616E6775616765732E72656769737465722865293B636F6E7374206E3D4561652E6765744F724372656174652874293B5361652E6C616E6775616765732E7265676973746572546F6B656E735072';
wwv_flow_imp.g_varchar2_table(34535) := '6F7669646572466163746F727928742C7B6372656174653A6173796E6328293D3E286177616974206E2E6C6F61642829292E6C616E67756167657D292C5361652E6C616E6775616765732E6F6E4C616E6775616765456E636F756E746572656428742C28';
wwv_flow_imp.g_varchar2_table(34536) := '6173796E6328293D3E7B636F6E737420653D6177616974206E2E6C6F616428293B5361652E6C616E6775616765732E7365744C616E6775616765436F6E66696775726174696F6E28742C652E636F6E66297D29297D4C6165287B69643A2273716C222C65';
wwv_flow_imp.g_varchar2_table(34537) := '7874656E73696F6E733A5B222E73716C225D2C616C69617365733A5B2253514C225D2C6C6F616465723A28293D3E6E2E6528393134292E7468656E286E2E62696E64286E2C3139313429297D293B766172204461653D6E657720636C6173737B636F6E73';
wwv_flow_imp.g_varchar2_table(34538) := '74727563746F7228652C742C6E297B746869732E5F6F6E4469644368616E67653D6E6577206F61652C746869732E5F6C616E677561676549643D652C746869732E736574446961676E6F73746963734F7074696F6E732874292C746869732E7365744D6F';
wwv_flow_imp.g_varchar2_table(34539) := '6465436F6E66696775726174696F6E286E297D676574206F6E4469644368616E676528297B72657475726E20746869732E5F6F6E4469644368616E67652E6576656E747D676574206C616E6775616765496428297B72657475726E20746869732E5F6C61';
wwv_flow_imp.g_varchar2_table(34540) := '6E677561676549647D676574206D6F6465436F6E66696775726174696F6E28297B72657475726E20746869732E5F6D6F6465436F6E66696775726174696F6E7D67657420646961676E6F73746963734F7074696F6E7328297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(34541) := '2E5F646961676E6F73746963734F7074696F6E737D736574446961676E6F73746963734F7074696F6E732865297B746869732E5F646961676E6F73746963734F7074696F6E733D657C7C4F626A6563742E637265617465286E756C6C292C746869732E5F';
wwv_flow_imp.g_varchar2_table(34542) := '6F6E4469644368616E67652E666972652874686973297D7365744D6F6465436F6E66696775726174696F6E2865297B746869732E5F6D6F6465436F6E66696775726174696F6E3D657C7C4F626A6563742E637265617465286E756C6C292C746869732E5F';
wwv_flow_imp.g_varchar2_table(34543) := '6F6E4469644368616E67652E666972652874686973297D7D28226A736F6E222C7B76616C69646174653A21302C616C6C6F77436F6D6D656E74733A21302C736368656D61733A5B5D2C656E61626C65536368656D61526571756573743A21312C73636865';
wwv_flow_imp.g_varchar2_table(34544) := '6D61526571756573743A227761726E696E67222C736368656D6156616C69646174696F6E3A227761726E696E67222C636F6D6D656E74733A226572726F72222C747261696C696E67436F6D6D61733A226572726F72227D2C7B646F63756D656E74466F72';
wwv_flow_imp.g_varchar2_table(34545) := '6D617474696E6745646974733A21302C646F63756D656E7452616E6765466F726D617474696E6745646974733A21302C636F6D706C6574696F6E4974656D733A21302C686F766572733A21302C646F63756D656E7453796D626F6C733A21302C746F6B65';
wwv_flow_imp.g_varchar2_table(34546) := '6E733A21302C636F6C6F72733A21302C666F6C64696E6752616E6765733A21302C646961676E6F73746963733A21302C73656C656374696F6E52616E6765733A21307D293B66756E6374696F6E2054616528297B72657475726E206E2E6528383339292E';
wwv_flow_imp.g_varchar2_table(34547) := '7468656E286E2E62696E64286E2C3438333929297D6661652E6A736F6E3D7B6A736F6E44656661756C74733A4461652C676574576F726B65723A28293D3E54616528292E7468656E2828653D3E652E676574576F726B6572282929297D2C6661652E7265';
wwv_flow_imp.g_varchar2_table(34548) := '676973746572287B69643A226A736F6E222C657874656E73696F6E733A5B222E6A736F6E222C222E626F7765727263222C222E6A7368696E747263222C222E6A7363737263222C222E65736C696E747263222C222E626162656C7263222C222E68617222';
wwv_flow_imp.g_varchar2_table(34549) := '5D2C616C69617365733A5B224A534F4E222C226A736F6E225D2C6D696D6574797065733A5B226170706C69636174696F6E2F6A736F6E225D7D292C6661652E6F6E4C616E677561676528226A736F6E222C2828293D3E7B54616528292E7468656E282865';
wwv_flow_imp.g_varchar2_table(34550) := '3D3E652E73657475704D6F6465284461652929297D29292C4C6165287B69643A2268746D6C222C657874656E73696F6E733A5B222E68746D6C222C222E68746D222C222E7368746D6C222C222E7868746D6C222C222E6D646F63222C222E6A7370222C22';
wwv_flow_imp.g_varchar2_table(34551) := '2E617370222C222E61737078222C222E6A7368746D225D2C616C69617365733A5B2248544D4C222C2268746D222C2268746D6C222C227868746D6C225D2C6D696D6574797065733A5B22746578742F68746D6C222C22746578742F782D6A7368746D222C';
wwv_flow_imp.g_varchar2_table(34552) := '22746578742F74656D706C617465222C22746578742F6E672D74656D706C617465225D2C6C6F616465723A28293D3E6E2E6528363538292E7468656E286E2E62696E64286E2C3236353829297D293B766172204961653D4F626A6563742E646566696E65';
wwv_flow_imp.g_varchar2_table(34553) := '50726F70657274792C4D61653D4F626A6563742E6765744F776E50726F706572747944657363726970746F722C4161653D4F626A6563742E6765744F776E50726F70657274794E616D65732C4E61653D4F626A6563742E70726F746F747970652E686173';
wwv_flow_imp.g_varchar2_table(34554) := '4F776E50726F70657274792C5061653D28652C742C6E2C69293D3E7B696628742626226F626A656374223D3D747970656F6620747C7C2266756E6374696F6E223D3D747970656F66207429666F72286C6574206F206F6620416165287429294E61652E63';
wwv_flow_imp.g_varchar2_table(34555) := '616C6C28652C6F297C7C6F3D3D3D6E7C7C49616528652C6F2C7B6765743A28293D3E745B6F5D2C656E756D657261626C653A2128693D4D616528742C6F29297C7C692E656E756D657261626C657D293B72657475726E20657D2C4F61653D7B7D3B282865';
wwv_flow_imp.g_varchar2_table(34556) := '2C74293D3E7B50616528652C742C2264656661756C7422297D29284F61652C6F293B766172205261653D636C6173737B636F6E7374727563746F7228652C742C6E297B746869732E5F6F6E4469644368616E67653D6E6577204F61652E456D6974746572';
wwv_flow_imp.g_varchar2_table(34557) := '2C746869732E5F6C616E677561676549643D652C746869732E7365744F7074696F6E732874292C746869732E7365744D6F6465436F6E66696775726174696F6E286E297D676574206F6E4469644368616E676528297B72657475726E20746869732E5F6F';
wwv_flow_imp.g_varchar2_table(34558) := '6E4469644368616E67652E6576656E747D676574206C616E6775616765496428297B72657475726E20746869732E5F6C616E677561676549647D676574206F7074696F6E7328297B72657475726E20746869732E5F6F7074696F6E737D676574206D6F64';
wwv_flow_imp.g_varchar2_table(34559) := '65436F6E66696775726174696F6E28297B72657475726E20746869732E5F6D6F6465436F6E66696775726174696F6E7D7365744F7074696F6E732865297B746869732E5F6F7074696F6E733D657C7C4F626A6563742E637265617465286E756C6C292C74';
wwv_flow_imp.g_varchar2_table(34560) := '6869732E5F6F6E4469644368616E67652E666972652874686973297D7365744D6F6465436F6E66696775726174696F6E2865297B746869732E5F6D6F6465436F6E66696775726174696F6E3D657C7C4F626A6563742E637265617465286E756C6C292C74';
wwv_flow_imp.g_varchar2_table(34561) := '6869732E5F6F6E4469644368616E67652E666972652874686973297D7D2C4661653D7B666F726D61743A7B74616253697A653A342C696E736572745370616365733A21312C777261704C696E654C656E6774683A3132302C756E666F726D61747465643A';
wwv_flow_imp.g_varchar2_table(34562) := '2764656661756C74223A2022612C20616262722C206163726F6E796D2C20622C2062646F2C206269672C2062722C20627574746F6E2C20636974652C20636F64652C2064666E2C20656D2C20692C20696D672C20696E7075742C206B62642C206C616265';
wwv_flow_imp.g_varchar2_table(34563) := '6C2C206D61702C206F626A6563742C20712C2073616D702C2073656C6563742C20736D616C6C2C207370616E2C207374726F6E672C207375622C207375702C2074657874617265612C2074742C20766172272C636F6E74656E74556E666F726D61747465';
wwv_flow_imp.g_varchar2_table(34564) := '643A22707265222C696E64656E74496E6E657248746D6C3A21312C70726573657276654E65774C696E65733A21302C6D617850726573657276654E65774C696E65733A766F696420302C696E64656E7448616E646C65626172733A21312C656E64576974';
wwv_flow_imp.g_varchar2_table(34565) := '684E65776C696E653A21312C65787472614C696E6572733A22686561642C20626F64792C202F68746D6C222C77726170417474726962757465733A226175746F227D2C737567676573743A7B7D2C646174613A7B75736544656661756C74446174615072';
wwv_flow_imp.g_varchar2_table(34566) := '6F76696465723A21307D7D3B66756E6374696F6E204261652865297B72657475726E7B636F6D706C6574696F6E4974656D733A21302C686F766572733A21302C646F63756D656E7453796D626F6C733A21302C6C696E6B733A21302C646F63756D656E74';
wwv_flow_imp.g_varchar2_table(34567) := '486967686C69676874733A21302C72656E616D653A21302C636F6C6F72733A21302C666F6C64696E6752616E6765733A21302C73656C656374696F6E52616E6765733A21302C646961676E6F73746963733A653D3D3D7A61652C646F63756D656E74466F';
wwv_flow_imp.g_varchar2_table(34568) := '726D617474696E6745646974733A653D3D3D7A61652C646F63756D656E7452616E6765466F726D617474696E6745646974733A653D3D3D7A61657D7D766172205661652C7A61653D2268746D6C222C4861653D2268616E646C6562617273222C5761653D';
wwv_flow_imp.g_varchar2_table(34569) := '2272617A6F72222C6A61653D516165287A61652C4661652C426165287A616529292C7161653D6A61652E64656661756C74732C2461653D516165284861652C4661652C4261652848616529292C5561653D2461652E64656661756C74732C4B61653D5161';
wwv_flow_imp.g_varchar2_table(34570) := '65285761652C4661652C4261652857616529292C4761653D4B61652E64656661756C74733B66756E6374696F6E2051616528652C743D4661652C693D426165286529297B636F6E7374206F3D6E65772052616528652C742C69293B6C657420733B636F6E';
wwv_flow_imp.g_varchar2_table(34571) := '737420723D4F61652E6C616E6775616765732E6F6E4C616E677561676528652C286173796E6328293D3E7B733D286177616974206E2E65283737292E7468656E286E2E62696E64286E2C323037372929292E73657475704D6F6465286F297D29293B7265';
wwv_flow_imp.g_varchar2_table(34572) := '7475726E7B64656661756C74733A6F2C646973706F736528297B722E646973706F736528292C733F2E646973706F736528292C733D766F696420307D7D7D4F61652E6C616E6775616765732E68746D6C3D7B68746D6C44656661756C74733A7161652C72';
wwv_flow_imp.g_varchar2_table(34573) := '617A6F7244656661756C74733A4761652C68616E646C6562617244656661756C74733A5561652C68746D6C4C616E6775616765536572766963653A6A61652C68616E646C656261724C616E6775616765536572766963653A2461652C72617A6F724C616E';
wwv_flow_imp.g_varchar2_table(34574) := '6775616765536572766963653A4B61652C726567697374657248544D4C4C616E6775616765536572766963653A5161657D2C73656C662E4D6F6E61636F456E7669726F6E6D656E743D285661653D7B656469746F72576F726B6572536572766963653A22';
wwv_flow_imp.g_varchar2_table(34575) := '656469746F722E776F726B65722E6A73222C6A736F6E3A226A736F6E2E776F726B65722E6A73222C68746D6C3A2268746D6C2E776F726B65722E6A73222C68616E646C65626172733A2268746D6C2E776F726B65722E6A73222C72617A6F723A2268746D';
wwv_flow_imp.g_varchar2_table(34576) := '6C2E776F726B65722E6A73227D2C7B676C6F62616C4150493A21312C676574576F726B657255726C3A66756E6374696F6E28652C74297B76617220693D6E2E702C6F3D28693F692E7265706C616365282F5C2F242F2C2222292B222F223A2222292B5661';
wwv_flow_imp.g_varchar2_table(34577) := '655B745D3B6966282F5E2828687474703A297C2868747470733A297C2866696C653A297C285C2F5C2F29292F2E74657374286F29297B76617220733D537472696E672877696E646F772E6C6F636174696F6E292C723D732E73756273747228302C732E6C';
wwv_flow_imp.g_varchar2_table(34578) := '656E6774682D77696E646F772E6C6F636174696F6E2E686173682E6C656E6774682D77696E646F772E6C6F636174696F6E2E7365617263682E6C656E6774682D77696E646F772E6C6F636174696F6E2E706174686E616D652E6C656E677468293B696628';
wwv_flow_imp.g_varchar2_table(34579) := '6F2E737562737472696E6728302C722E6C656E67746829213D3D72297B2F5E285C2F5C2F292F2E74657374286F292626286F3D77696E646F772E6C6F636174696F6E2E70726F746F636F6C2B6F293B76617220613D6E657720426C6F62285B222F2A222B';
wwv_flow_imp.g_varchar2_table(34580) := '742B272A2F696D706F7274536372697074732822272B6F2B2722293B275D2C7B747970653A226170706C69636174696F6E2F6A617661736372697074227D293B72657475726E2055524C2E6372656174654F626A65637455524C2861297D7D7265747572';
wwv_flow_imp.g_varchar2_table(34581) := '6E206F7D7D293B636F6E7374205961653D697D2C353037323A653D3E7B2275736520737472696374223B76617220743D5B5D3B66756E6374696F6E206E2865297B666F7228766172206E3D2D312C693D303B693C742E6C656E6774683B692B2B29696628';
wwv_flow_imp.g_varchar2_table(34582) := '745B695D2E6964656E7469666965723D3D3D65297B6E3D693B627265616B7D72657475726E206E7D66756E6374696F6E206928652C69297B666F722876617220733D7B7D2C723D5B5D2C613D303B613C652E6C656E6774683B612B2B297B766172206C3D';
wwv_flow_imp.g_varchar2_table(34583) := '655B615D2C633D692E626173653F6C5B305D2B692E626173653A6C5B305D2C643D735B635D7C7C302C683D22222E636F6E63617428632C222022292E636F6E6361742864293B735B635D3D642B313B76617220753D6E2868292C703D7B6373733A6C5B31';
wwv_flow_imp.g_varchar2_table(34584) := '5D2C6D656469613A6C5B325D2C736F757263654D61703A6C5B335D2C737570706F7274733A6C5B345D2C6C617965723A6C5B355D7D3B6966282D31213D3D7529745B755D2E7265666572656E6365732B2B2C745B755D2E757064617465722870293B656C';
wwv_flow_imp.g_varchar2_table(34585) := '73657B76617220673D6F28702C69293B692E6279496E6465783D612C742E73706C69636528612C302C7B6964656E7469666965723A682C757064617465723A672C7265666572656E6365733A317D297D722E707573682868297D72657475726E20727D66';
wwv_flow_imp.g_varchar2_table(34586) := '756E6374696F6E206F28652C74297B766172206E3D742E646F6D4150492874293B72657475726E206E2E7570646174652865292C66756E6374696F6E2874297B69662874297B696628742E6373733D3D3D652E6373732626742E6D656469613D3D3D652E';
wwv_flow_imp.g_varchar2_table(34587) := '6D656469612626742E736F757263654D61703D3D3D652E736F757263654D61702626742E737570706F7274733D3D3D652E737570706F7274732626742E6C617965723D3D3D652E6C617965722972657475726E3B6E2E75706461746528653D74297D656C';
wwv_flow_imp.g_varchar2_table(34588) := '7365206E2E72656D6F766528297D7D652E6578706F7274733D66756E6374696F6E28652C6F297B76617220733D6928653D657C7C5B5D2C6F3D6F7C7C7B7D293B72657475726E2066756E6374696F6E2865297B653D657C7C5B5D3B666F72287661722072';
wwv_flow_imp.g_varchar2_table(34589) := '3D303B723C732E6C656E6774683B722B2B297B76617220613D6E28735B725D293B745B615D2E7265666572656E6365732D2D7D666F7228766172206C3D6928652C6F292C633D303B633C732E6C656E6774683B632B2B297B76617220643D6E28735B635D';
wwv_flow_imp.g_varchar2_table(34590) := '293B303D3D3D745B645D2E7265666572656E636573262628745B645D2E7570646174657228292C742E73706C69636528642C3129297D733D6C7D7D7D2C373635393A653D3E7B2275736520737472696374223B76617220743D7B7D3B652E6578706F7274';
wwv_flow_imp.g_varchar2_table(34591) := '733D66756E6374696F6E28652C6E297B76617220693D66756E6374696F6E2865297B696628766F696420303D3D3D745B655D297B766172206E3D646F63756D656E742E717565727953656C6563746F722865293B69662877696E646F772E48544D4C4946';
wwv_flow_imp.g_varchar2_table(34592) := '72616D65456C656D656E7426266E20696E7374616E63656F662077696E646F772E48544D4C494672616D65456C656D656E74297472797B6E3D6E2E636F6E74656E74446F63756D656E742E686561647D63617463682865297B6E3D6E756C6C7D745B655D';
wwv_flow_imp.g_varchar2_table(34593) := '3D6E7D72657475726E20745B655D7D2865293B6966282169297468726F77206E6577204572726F722822436F756C646E27742066696E642061207374796C65207461726765742E20546869732070726F6261626C79206D65616E73207468617420746865';
wwv_flow_imp.g_varchar2_table(34594) := '2076616C756520666F72207468652027696E736572742720706172616D6574657220697320696E76616C69642E22293B692E617070656E644368696C64286E297D7D2C3534303A653D3E7B2275736520737472696374223B652E6578706F7274733D6675';
wwv_flow_imp.g_varchar2_table(34595) := '6E6374696F6E2865297B76617220743D646F63756D656E742E637265617465456C656D656E7428227374796C6522293B72657475726E20652E7365744174747269627574657328742C652E61747472696275746573292C652E696E7365727428742C652E';
wwv_flow_imp.g_varchar2_table(34596) := '6F7074696F6E73292C747D7D2C353035363A28652C742C6E293D3E7B2275736520737472696374223B652E6578706F7274733D66756E6374696F6E2865297B76617220743D6E2E6E633B742626652E73657441747472696275746528226E6F6E6365222C';
wwv_flow_imp.g_varchar2_table(34597) := '74297D7D2C373832353A653D3E7B2275736520737472696374223B652E6578706F7274733D66756E6374696F6E2865297B69662822756E646566696E6564223D3D747970656F6620646F63756D656E742972657475726E7B7570646174653A66756E6374';
wwv_flow_imp.g_varchar2_table(34598) := '696F6E28297B7D2C72656D6F76653A66756E6374696F6E28297B7D7D3B76617220743D652E696E736572745374796C65456C656D656E742865293B72657475726E7B7570646174653A66756E6374696F6E286E297B2166756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(34599) := '297B76617220693D22223B6E2E737570706F727473262628692B3D2240737570706F7274732028222E636F6E636174286E2E737570706F7274732C2229207B2229292C6E2E6D65646961262628692B3D22406D6564696120222E636F6E636174286E2E6D';
wwv_flow_imp.g_varchar2_table(34600) := '656469612C22207B2229293B766172206F3D766F69642030213D3D6E2E6C617965723B6F262628692B3D22406C61796572222E636F6E636174286E2E6C617965722E6C656E6774683E303F2220222E636F6E636174286E2E6C61796572293A22222C2220';
wwv_flow_imp.g_varchar2_table(34601) := '7B2229292C692B3D6E2E6373732C6F262628692B3D227D22292C6E2E6D65646961262628692B3D227D22292C6E2E737570706F727473262628692B3D227D22293B76617220733D6E2E736F757263654D61703B73262622756E646566696E656422213D74';
wwv_flow_imp.g_varchar2_table(34602) := '7970656F662062746F61262628692B3D225C6E2F2A2320736F757263654D617070696E6755524C3D646174613A6170706C69636174696F6E2F6A736F6E3B6261736536342C222E636F6E6361742862746F6128756E65736361706528656E636F64655552';
wwv_flow_imp.g_varchar2_table(34603) := '49436F6D706F6E656E74284A534F4E2E737472696E676966792873292929292C22202A2F2229292C742E7374796C655461675472616E73666F726D28692C652C742E6F7074696F6E73297D28742C652C6E297D2C72656D6F76653A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(34604) := '297B2166756E6374696F6E2865297B6966286E756C6C3D3D3D652E706172656E744E6F64652972657475726E21313B652E706172656E744E6F64652E72656D6F76654368696C642865297D2874297D7D7D7D2C313131333A653D3E7B2275736520737472';
wwv_flow_imp.g_varchar2_table(34605) := '696374223B652E6578706F7274733D66756E6374696F6E28652C74297B696628742E7374796C65536865657429742E7374796C6553686565742E637373546578743D653B656C73657B666F72283B742E66697273744368696C643B29742E72656D6F7665';
wwv_flow_imp.g_varchar2_table(34606) := '4368696C6428742E66697273744368696C64293B742E617070656E644368696C6428646F63756D656E742E637265617465546578744E6F6465286529297D7D7D2C383936383A653D3E7B2275736520737472696374223B652E6578706F7274733D226461';
wwv_flow_imp.g_varchar2_table(34607) := '74613A696D6167652F706E673B6261736536342C6956424F5277304B47676F414141414E535568455567414141415141414141454341594141414370385A352B4141414141584E535230494172733463365141414141526E51553142414143786A777638';
wwv_flow_imp.g_varchar2_table(34608) := '595155414141414A6345685A6377414144734D414141374441636476714751414141415A6445565964464E765A6E523359584A6C41484268615735304C6D356C644341304C6A41754D545A4561612F314141414148556C45515651595632505976587533';
wwv_flow_imp.g_varchar2_table(34609) := '4A416937754C69414D6159416A414754514250594C516B41612F305A6566337152737741414141415355564F524B35435949493D227D2C373538343A653D3E7B2275736520737472696374223B652E6578706F7274733D22646174613A696D6167652F73';
wwv_flow_imp.g_varchar2_table(34610) := '76672B786D6C3B6261736536342C50484E325A79423361575230614430694E544D694947686C6157646F644430694D7A596949485A705A58644362336739496A41674D4341314D79417A4E6949675A6D6C7362443069626D39755A53496765473173626E';
wwv_flow_imp.g_varchar2_table(34611) := '4D39496D6830644841364C79393364336375647A4D7562334A6E4C7A49774D44417663335A6E496A344B5047636759327870634331775958526F50534A31636D776F49324E73615841774B53492B436A78775958526F49475A7062477774636E56735A54';
wwv_flow_imp.g_varchar2_table(34612) := '30695A585A6C626D396B5A43496759327870634331796457786C50534A6C646D56756232526B4969426B50534A4E4E4467754D444D324E4341304C6A41784D445179534451754D4441334E7A6C4D4E4334774D4463334F53417A4D6934774D6A67325344';
wwv_flow_imp.g_varchar2_table(34613) := '51344C6A417A4E6A52574E4334774D5441304D6C704E4E4334774D4463334F5341774C6A41774E7A67784D6A56444D5334334F5463794D5341774C6A41774E7A67784D6A55674D4334774D4455784F4463354F5341784C6A63354F546730494441754D44';
wwv_flow_imp.g_varchar2_table(34614) := '41314D5467334F546B674E4334774D5441304D6C597A4D6934774D6A6732517A41754D4441314D5467334F546B674D7A51754D6A4D354D6941784C6A63354E7A497849444D324C6A417A4D5449674E4334774D4463334F53417A4E6934774D7A45795344';
wwv_flow_imp.g_varchar2_table(34615) := '51344C6A417A4E6A52444E5441754D6A513349444D324C6A417A4D5449674E5449754D444D3549444D304C6A497A4F5449674E5449754D444D3549444D794C6A41794F445A574E4334774D5441304D6B4D314D6934774D7A6B674D5334334F546B344E43';
wwv_flow_imp.g_varchar2_table(34616) := '41314D4334794E4463674D4334774D4463344D544931494451344C6A417A4E6A51674D4334774D4463344D544931534451754D4441334E7A6C61545467754D4445774E4449674F4334774D544D774D6B67784D6934774D544E574D5449754D4445314E6B';
wwv_flow_imp.g_varchar2_table(34617) := '67344C6A41784D445179566A67754D44457A4D444A61545449774C6A41784F4449674F4334774D544D774D6B67784E6934774D545532566A45794C6A41784E545A494D6A41754D4445344D6C59344C6A41784D7A4179576B30794E4334774D6A41344944';
wwv_flow_imp.g_varchar2_table(34618) := '67754D44457A4D444A494D6A67754D44497A4E4659784D6934774D545532534449304C6A41794D4468574F4334774D544D774D6C704E4D7A59754D4449344E6941344C6A41784D7A417953444D794C6A41794E6C59784D6934774D54553253444D324C6A';
wwv_flow_imp.g_varchar2_table(34619) := '41794F445A574F4334774D544D774D6C704E4E4441754D444D784D6941344C6A41784D7A4179534451304C6A417A4D7A6C574D5449754D4445314E6B67304D4334774D7A4579566A67754D44457A4D444A61545445324C6A41784E5459674D5459754D44';
wwv_flow_imp.g_varchar2_table(34620) := '45344D6B67344C6A41784D445179566A49774C6A41794D4468494D5459754D4445314E6C59784E6934774D546779576B30794D4334774D546779494445324C6A41784F444A494D6A51754D4449774F4659794D4334774D6A4134534449774C6A41784F44';
wwv_flow_imp.g_varchar2_table(34621) := '4A574D5459754D4445344D6C704E4D7A49754D444932494445324C6A41784F444A494D6A67754D44497A4E4659794D4334774D6A413453444D794C6A41794E6C59784E6934774D546779576B30304E4334774D7A4D35494445324C6A41784F444A574D6A';
wwv_flow_imp.g_varchar2_table(34622) := '41754D4449774F45677A4E6934774D6A6732566A45324C6A41784F444A494E4451754D444D7A4F56704E4D5449754D44457A494449304C6A41794D7A52494F4334774D5441304D6C59794F4334774D6A5A494D5449754D44457A566A49304C6A41794D7A';
wwv_flow_imp.g_varchar2_table(34623) := '5261545445324C6A41784E5459674D6A51754D44497A4E45677A4E6934774D6A6732566A49344C6A41794E6B67784E6934774D545532566A49304C6A41794D7A5261545451304C6A417A4D7A6B674D6A51754D44497A4E4567304D4334774D7A4579566A';
wwv_flow_imp.g_varchar2_table(34624) := '49344C6A41794E6B67304E4334774D7A4D35566A49304C6A41794D7A52614969426D615778735053496A4E4449304D6A51794969382B436A77765A7A344B5047526C5A6E4D2B436A786A62476C7755474630614342705A44306959327870634441695067';
wwv_flow_imp.g_varchar2_table(34625) := '6F38636D566A6443423361575230614430694E544D694947686C6157646F644430694D7A596949475A7062477739496E646F6158526C4969382B436A777659327870634642686447672B436A77765A47566D637A344B5043397A646D632B43673D3D227D';
wwv_flow_imp.g_varchar2_table(34626) := '2C363036303A653D3E7B2275736520737472696374223B652E6578706F7274733D22646174613A696D6167652F7376672B786D6C3B6261736536342C50484E325A79423361575230614430694E544D694947686C6157646F644430694D7A596949485A70';
wwv_flow_imp.g_varchar2_table(34627) := '5A58644362336739496A41674D4341314D79417A4E6949675A6D6C7362443069626D39755A53496765473173626E4D39496D6830644841364C79393364336375647A4D7562334A6E4C7A49774D44417663335A6E496A344B504763675932787063433177';
wwv_flow_imp.g_varchar2_table(34628) := '5958526F50534A31636D776F49324E73615841774B53492B436A78775958526F49475A7062477774636E56735A5430695A585A6C626D396B5A43496759327870634331796457786C50534A6C646D56756232526B4969426B50534A4E4E4467754D444D32';
wwv_flow_imp.g_varchar2_table(34629) := '4E4341304C6A41784D445179534451754D4441334E7A6C4D4E4334774D4463334F53417A4D6934774D6A6732534451344C6A417A4E6A52574E4334774D5441304D6C704E4E4334774D4463334F5341774C6A41774E7A67784D6A56444D5334334F546379';
wwv_flow_imp.g_varchar2_table(34630) := '4D5341774C6A41774E7A67784D6A55674D4334774D4455784F4463354F5341784C6A63354F546730494441754D4441314D5467334F546B674E4334774D5441304D6C597A4D6934774D6A6732517A41754D4441314D5467334F546B674D7A51754D6A4D35';
wwv_flow_imp.g_varchar2_table(34631) := '4D6941784C6A63354E7A497849444D324C6A417A4D5449674E4334774D4463334F53417A4E6934774D7A4579534451344C6A417A4E6A52444E5441754D6A513349444D324C6A417A4D5449674E5449754D444D3549444D304C6A497A4F5449674E544975';
wwv_flow_imp.g_varchar2_table(34632) := '4D444D3549444D794C6A41794F445A574E4334774D5441304D6B4D314D6934774D7A6B674D5334334F546B344E4341314D4334794E4463674D4334774D4463344D544931494451344C6A417A4E6A51674D4334774D4463344D544931534451754D444133';
wwv_flow_imp.g_varchar2_table(34633) := '4E7A6C61545467754D4445774E4449674F4334774D544D774D6B67784D6934774D544E574D5449754D4445314E6B67344C6A41784D445179566A67754D44457A4D444A61545449774C6A41784F4449674F4334774D544D774D6B67784E6934774D545532';
wwv_flow_imp.g_varchar2_table(34634) := '566A45794C6A41784E545A494D6A41754D4445344D6C59344C6A41784D7A4179576B30794E4334774D6A4134494467754D44457A4D444A494D6A67754D44497A4E4659784D6934774D545532534449304C6A41794D4468574F4334774D544D774D6C704E';
wwv_flow_imp.g_varchar2_table(34635) := '4D7A59754D4449344E6941344C6A41784D7A417953444D794C6A41794E6C59784D6934774D54553253444D324C6A41794F445A574F4334774D544D774D6C704E4E4441754D444D784D6941344C6A41784D7A4179534451304C6A417A4D7A6C574D544975';
wwv_flow_imp.g_varchar2_table(34636) := '4D4445314E6B67304D4334774D7A4579566A67754D44457A4D444A61545445324C6A41784E5459674D5459754D4445344D6B67344C6A41784D445179566A49774C6A41794D4468494D5459754D4445314E6C59784E6934774D546779576B30794D433477';
wwv_flow_imp.g_varchar2_table(34637) := '4D546779494445324C6A41784F444A494D6A51754D4449774F4659794D4334774D6A4134534449774C6A41784F444A574D5459754D4445344D6C704E4D7A49754D444932494445324C6A41784F444A494D6A67754D44497A4E4659794D4334774D6A4134';
wwv_flow_imp.g_varchar2_table(34638) := '53444D794C6A41794E6C59784E6934774D546779576B30304E4334774D7A4D35494445324C6A41784F444A574D6A41754D4449774F45677A4E6934774D6A6732566A45324C6A41784F444A494E4451754D444D7A4F56704E4D5449754D44457A49444930';
wwv_flow_imp.g_varchar2_table(34639) := '4C6A41794D7A52494F4334774D5441304D6C59794F4334774D6A5A494D5449754D44457A566A49304C6A41794D7A5261545445324C6A41784E5459674D6A51754D44497A4E45677A4E6934774D6A6732566A49344C6A41794E6B67784E6934774D545532';
wwv_flow_imp.g_varchar2_table(34640) := '566A49304C6A41794D7A5261545451304C6A417A4D7A6B674D6A51754D44497A4E4567304D4334774D7A4579566A49344C6A41794E6B67304E4334774D7A4D35566A49304C6A41794D7A52614969426D615778735053496A517A56444E554D314969382B';
wwv_flow_imp.g_varchar2_table(34641) := '436A77765A7A344B5047526C5A6E4D2B436A786A62476C7755474630614342705A443069593278706344416950676F38636D566A6443423361575230614430694E544D694947686C6157646F644430694D7A596949475A7062477739496E646F6158526C';
wwv_flow_imp.g_varchar2_table(34642) := '4969382B436A777659327870634642686447672B436A77765A47566D637A344B5043397A646D632B43673D3D227D2C313238383A28652C742C6E293D3E7B2275736520737472696374223B652E6578706F7274733D6E2E702B2261356135623039303331';
wwv_flow_imp.g_varchar2_table(34643) := '656462633136316634662E747466227D2C363934323A28652C74293D3E7B766172206E3B2166756E6374696F6E28297B2275736520737472696374223B76617220693D7B7D2E6861734F776E50726F70657274793B66756E6374696F6E206F28297B666F';
wwv_flow_imp.g_varchar2_table(34644) := '722876617220653D22222C743D303B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B6E262628653D7228652C73286E2929297D72657475726E20657D66756E6374696F6E20732865297B6966';
wwv_flow_imp.g_varchar2_table(34645) := '2822737472696E67223D3D747970656F6620657C7C226E756D626572223D3D747970656F6620652972657475726E20653B696628226F626A65637422213D747970656F6620652972657475726E22223B69662841727261792E6973417272617928652929';
wwv_flow_imp.g_varchar2_table(34646) := '72657475726E206F2E6170706C79286E756C6C2C65293B696628652E746F537472696E67213D3D4F626A6563742E70726F746F747970652E746F537472696E67262621652E746F537472696E672E746F537472696E6728292E696E636C7564657328225B';
wwv_flow_imp.g_varchar2_table(34647) := '6E617469766520636F64655D22292972657475726E20652E746F537472696E6728293B76617220743D22223B666F7228766172206E20696E206529692E63616C6C28652C6E292626655B6E5D262628743D7228742C6E29293B72657475726E20747D6675';
wwv_flow_imp.g_varchar2_table(34648) := '6E6374696F6E207228652C74297B72657475726E20743F653F652B2220222B743A652B743A657D652E6578706F7274733F286F2E64656661756C743D6F2C652E6578706F7274733D6F293A766F696420303D3D3D286E3D66756E6374696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(34649) := '7475726E206F7D2E6170706C7928742C5B5D29297C7C28652E6578706F7274733D6E297D28297D2C3630333A28652C74293D3E7B2275736520737472696374223B636F6E7374206E3D4F626A6563742E70726F746F747970652E746F537472696E672C69';
wwv_flow_imp.g_varchar2_table(34650) := '3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E206F2865297B72657475726E20766F696420303D3D3D657D66756E6374696F6E20732865297B72657475726E20766F69642030213D3D657D66756E';
wwv_flow_imp.g_varchar2_table(34651) := '6374696F6E20722865297B72657475726E206E756C6C3D3D657D66756E6374696F6E20612865297B72657475726E225B6F626A6563742041727261795D223D3D3D6E2E63616C6C2865297D66756E6374696F6E206C2865297B72657475726E225B6F626A';
wwv_flow_imp.g_varchar2_table(34652) := '656374204F626A6563745D223D3D3D6E2E63616C6C2865297D66756E6374696F6E20632865297B636F6E737420743D6E2E63616C6C2865293B72657475726E225B6F626A6563742046756E6374696F6E5D223D3D3D747C7C225B6F626A65637420417379';
wwv_flow_imp.g_varchar2_table(34653) := '6E6346756E6374696F6E5D223D3D3D747C7C225B6F626A6563742047656E657261746F7246756E6374696F6E5D223D3D3D747C7C225B6F626A656374204173796E6347656E657261746F7246756E6374696F6E5D223D3D3D747C7C225B6F626A65637420';
wwv_flow_imp.g_varchar2_table(34654) := '50726F78795D223D3D3D747D66756E6374696F6E20642865297B6966282161286529297468726F77206E6577204572726F7228226D75737420737570706C7920617272617922297D66756E6374696F6E206828652C74297B72657475726E20692E63616C';
wwv_flow_imp.g_varchar2_table(34655) := '6C28652C74297D66756E6374696F6E207528652C74297B636F6E7374206E3D432874293B6C657420693B72657475726E207028652C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D652C21317D29292C697D66756E';
wwv_flow_imp.g_varchar2_table(34656) := '6374696F6E207028652C74297B6C6574206E2C693B6966286F2865292972657475726E3B636F6E737420733D612865293F783A533B666F72286C6574206F20696E2065296966286828652C6F292626286E3D655B6F5D2C693D74286E2C73286F29292C21';
wwv_flow_imp.g_varchar2_table(34657) := '313D3D3D69292972657475726E206E7D66756E6374696F6E206728652C742C6E297B72657475726E207028652C2866756E6374696F6E28652C69297B6E3D74286E2C652C69297D29292C6E7D66756E6374696F6E206D28652C74297B72657475726E2121';
wwv_flow_imp.g_varchar2_table(34658) := '6728652C2866756E6374696F6E28652C6E2C69297B72657475726E2065262674286E2C69297D292C2130297D66756E6374696F6E206628652C74297B6C6574206E3D5B5D3B72657475726E207028652C2866756E6374696F6E28652C69297B6E2E707573';
wwv_flow_imp.g_varchar2_table(34659) := '68287428652C6929297D29292C6E7D66756E6374696F6E20762865297B72657475726E206526264F626A6563742E6B6579732865297C7C5B5D7D66756E6374696F6E206228652C742C6E3D7B7D297B72657475726E20743D772874292C7028652C286675';
wwv_flow_imp.g_varchar2_table(34660) := '6E6374696F6E2865297B6C657420693D742865297C7C225F222C6F3D6E5B695D3B6F7C7C286F3D6E5B695D3D5B5D292C6F2E707573682865297D29292C6E7D66756E6374696F6E205F28652C2E2E2E74297B653D772865293B6C6574206E3D7B7D3B7265';
wwv_flow_imp.g_varchar2_table(34661) := '7475726E207028742C28743D3E6228742C652C6E2929292C66286E2C2866756E6374696F6E28652C74297B72657475726E20655B305D7D29297D636F6E737420793D5F3B66756E6374696F6E20772865297B72657475726E20632865293F653A743D3E74';
wwv_flow_imp.g_varchar2_table(34662) := '5B655D7D66756E6374696F6E20432865297B72657475726E20632865293F653A743D3E743D3D3D657D66756E6374696F6E20532865297B72657475726E20657D66756E6374696F6E20782865297B72657475726E204E756D6265722865297D742E617373';
wwv_flow_imp.g_varchar2_table(34663) := '69676E3D66756E6374696F6E28652C2E2E2E74297B72657475726E204F626A6563742E61737369676E28652C2E2E2E74297D2C742E62696E643D66756E6374696F6E28652C74297B72657475726E20652E62696E642874297D2C742E6465626F756E6365';
wwv_flow_imp.g_varchar2_table(34664) := '3D66756E6374696F6E28652C74297B6C6574206E2C692C6F2C733B66756E6374696F6E2072286E297B6C657420723D446174652E6E6F7728292C633D6E3F303A732B742D723B696628633E302972657475726E20612863293B652E6170706C79286F2C69';
wwv_flow_imp.g_varchar2_table(34665) := '292C6C28297D66756E6374696F6E20612865297B6E3D73657454696D656F757428722C65297D66756E6374696F6E206C28297B6E2626636C65617254696D656F7574286E292C6E3D733D693D6F3D766F696420307D66756E6374696F6E2063282E2E2E65';
wwv_flow_imp.g_varchar2_table(34666) := '297B733D446174652E6E6F7728292C693D652C6F3D746869732C6E7C7C612874297D72657475726E20632E666C7573683D66756E6374696F6E28297B6E262672282130292C6C28297D2C632E63616E63656C3D6C2C637D2C742E656E7375726541727261';
wwv_flow_imp.g_varchar2_table(34667) := '793D642C742E65766572793D6D2C742E66696C7465723D66756E6374696F6E28652C74297B636F6E7374206E3D432874293B6C657420693D5B5D3B72657475726E207028652C2866756E6374696F6E28652C74297B6E28652C74292626692E7075736828';
wwv_flow_imp.g_varchar2_table(34668) := '65297D29292C697D2C742E66696E643D752C742E66696E64496E6465783D66756E6374696F6E28652C74297B636F6E7374206E3D432874293B6C657420693D612865293F2D313A766F696420303B72657475726E207028652C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(34669) := '2C74297B6966286E28652C74292972657475726E20693D742C21317D29292C697D2C742E666C617474656E3D66756E6374696F6E2865297B72657475726E2041727261792E70726F746F747970652E636F6E6361742E6170706C79285B5D2C65297D2C74';
wwv_flow_imp.g_varchar2_table(34670) := '2E666F72456163683D702C742E6765743D66756E6374696F6E28652C742C6E297B6C657420693D653B72657475726E207028742C2866756E6374696F6E2865297B696628722869292972657475726E20693D766F696420302C21313B693D695B655D7D29';
wwv_flow_imp.g_varchar2_table(34671) := '292C6F2869293F6E3A697D2C742E67726F757042793D622C742E6861733D682C742E697341727261793D612C742E6973446566696E65643D732C742E697346756E6374696F6E3D632C742E69734E696C3D722C742E69734E756D6265723D66756E637469';
wwv_flow_imp.g_varchar2_table(34672) := '6F6E2865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D6E2E63616C6C2865297D2C742E69734F626A6563743D6C2C742E6973537472696E673D66756E6374696F6E2865297B72657475726E225B6F626A65637420537472696E67';
wwv_flow_imp.g_varchar2_table(34673) := '5D223D3D3D6E2E63616C6C2865297D2C742E6973556E646566696E65643D6F2C742E6B6579733D762C742E6D61703D662C742E6D617463685061747465726E3D66756E6374696F6E2865297B72657475726E2066756E6374696F6E2874297B7265747572';
wwv_flow_imp.g_varchar2_table(34674) := '6E206D28652C2866756E6374696F6E28652C6E297B72657475726E20745B6E5D3D3D3D657D29297D7D2C742E6D657267653D66756E6374696F6E206528742C2E2E2E6E297B72657475726E206E2E6C656E6774683F2870286E2C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(34675) := '6E297B6E26266C286E29262670286E2C2866756E6374696F6E286E2C69297B696628225F5F70726F746F5F5F223D3D3D692972657475726E3B6C6574206F3D745B695D3B6C286E293F286C286F297C7C286F3D7B7D292C745B695D3D65286F2C6E29293A';
wwv_flow_imp.g_varchar2_table(34676) := '745B695D3D6E7D29297D29292C74293A747D2C742E6F6D69743D66756E6374696F6E28652C74297B6C6574206E3D7B7D3B72657475726E2070284F626A6563742865292C2866756E6374696F6E28652C69297B2D313D3D3D742E696E6465784F66286929';
wwv_flow_imp.g_varchar2_table(34677) := '2626286E5B695D3D65297D29292C6E7D2C742E7069636B3D66756E6374696F6E28652C74297B6C6574206E3D7B7D2C693D4F626A6563742865293B72657475726E207028742C2866756E6374696F6E2874297B7420696E20692626286E5B745D3D655B74';
wwv_flow_imp.g_varchar2_table(34678) := '5D297D29292C6E7D2C742E7265647563653D672C742E7365743D66756E6374696F6E28652C742C6E297B6C657420693D653B72657475726E207028742C2866756E6374696F6E28652C61297B696628226E756D62657222213D747970656F662065262622';
wwv_flow_imp.g_varchar2_table(34679) := '737472696E6722213D747970656F662065297468726F77206E6577204572726F722822696C6C6567616C206B657920747970653A20222B747970656F6620652B222E204B65792073686F756C64206265206F662074797065206E756D626572206F722073';
wwv_flow_imp.g_varchar2_table(34680) := '7472696E672E22293B69662822636F6E7374727563746F72223D3D3D65297468726F77206E6577204572726F722822696C6C6567616C206B65793A20636F6E7374727563746F7222293B696628225F5F70726F746F5F5F223D3D3D65297468726F77206E';
wwv_flow_imp.g_varchar2_table(34681) := '6577204572726F722822696C6C6567616C206B65793A205F5F70726F746F5F5F22293B6C6574206C3D745B612B315D2C633D695B655D3B73286C29262672286329262628633D695B655D3D69734E614E282B6C293F7B7D3A5B5D292C6F286C293F6F286E';
wwv_flow_imp.g_varchar2_table(34682) := '293F64656C65746520695B655D3A695B655D3D6E3A693D637D29292C657D2C742E73697A653D66756E6374696F6E2865297B72657475726E20762865292E6C656E6774687D2C742E736F6D653D66756E6374696F6E28652C74297B72657475726E212175';
wwv_flow_imp.g_varchar2_table(34683) := '28652C74297D2C742E736F727442793D66756E6374696F6E28652C74297B743D772874293B6C6574206E3D5B5D3B72657475726E207028652C2866756E6374696F6E28652C69297B6C6574206F3D7428652C69292C733D7B643A6F2C763A657D3B666F72';
wwv_flow_imp.g_varchar2_table(34684) := '2876617220723D303B723C6E2E6C656E6774683B722B2B297B6C65747B643A657D3D6E5B725D3B6966286F3C652972657475726E20766F6964206E2E73706C69636528722C302C73297D6E2E707573682873297D29292C66286E2C28653D3E652E762929';
wwv_flow_imp.g_varchar2_table(34685) := '7D2C742E7468726F74746C653D66756E6374696F6E28652C74297B6C6574206E3D21313B72657475726E2066756E6374696F6E282E2E2E69297B6E7C7C2865282E2E2E69292C6E3D21302C73657454696D656F7574282828293D3E7B6E3D21317D292C74';
wwv_flow_imp.g_varchar2_table(34686) := '29297D7D2C742E756E696F6E42793D792C742E756E6971756542793D5F2C742E76616C7565733D66756E6374696F6E2865297B72657475726E206628652C28653D3E6529297D2C742E776974686F75743D66756E6374696F6E28652C74297B6966286F28';
wwv_flow_imp.g_varchar2_table(34687) := '65292972657475726E5B5D3B642865293B636F6E7374206E3D432874293B72657475726E20652E66696C746572282866756E6374696F6E28652C74297B72657475726E216E28652C74297D29297D7D2C323233323A28652C742C6E293D3E7B2275736520';
wwv_flow_imp.g_varchar2_table(34688) := '737472696374223B66756E6374696F6E206928652C74297B72657475726E2D313D3D3D742E696E6465784F6628223A2229262628743D2262706D6E3A222B74292C2266756E6374696F6E223D3D747970656F6620652E24696E7374616E63654F663F652E';
wwv_flow_imp.g_varchar2_table(34689) := '24696E7374616E63654F662874293A652E24747970653D3D3D747D66756E6374696F6E206F28652C74297B72657475726E20742E736F6D65282866756E6374696F6E2874297B72657475726E206928652C74297D29297D6E2E722874292C6E2E6428742C';
wwv_flow_imp.g_varchar2_table(34690) := '7B69733A28293D3E692C6973416E793A28293D3E6F7D297D2C393930353A28652C742C6E293D3E7B2275736520737472696374223B66756E6374696F6E20692865297B72657475726E2041727261792E70726F746F747970652E636F6E6361742E617070';
wwv_flow_imp.g_varchar2_table(34691) := '6C79285B5D2C65297D6E2E6428742C7B247A3A28293D3E4C2C42713A28293D3E692C456A3A28293D3E6B2C45743A28293D3E682C46463A28293D3E5F2C47763A28293D3E642C48503A28293D3E782C49363A28293D3E6D2C4A743A28293D3E7A2C4B673A';
wwv_flow_imp.g_varchar2_table(34692) := '28293D3E702C4F393A28293D3E612C524B3A28293D3E542C534C3A28293D3E662C53693A28293D3E772C54533A28293D3E792C546A3A28293D3E532C546E3A28293D3E752C556C3A28293D3E492C55703A28293D3E482C62303A28293D3E722C634A3A28';
wwv_flow_imp.g_varchar2_table(34693) := '293D3E572C63793A28293D3E632C67443A28293D3E6C2C67483A28293D3E4D2C685A3A28293D3E562C6A4A3A28293D3E622C6B703A28293D3E422C6F493A28293D3E462C70443A28293D3E442C70623A28293D3E762C73673A28293D3E522C7A4E3A2829';
wwv_flow_imp.g_varchar2_table(34694) := '3D3E432C7A753A28293D3E452C7A793A28293D3E677D293B636F6E7374206F3D4F626A6563742E70726F746F747970652E746F537472696E672C733D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(34695) := '20722865297B72657475726E20766F696420303D3D3D657D66756E6374696F6E20612865297B72657475726E20766F69642030213D3D657D66756E6374696F6E206C2865297B72657475726E206E756C6C3D3D657D66756E6374696F6E20632865297B72';
wwv_flow_imp.g_varchar2_table(34696) := '657475726E225B6F626A6563742041727261795D223D3D3D6F2E63616C6C2865297D66756E6374696F6E20642865297B72657475726E225B6F626A656374204F626A6563745D223D3D3D6F2E63616C6C2865297D66756E6374696F6E20682865297B7265';
wwv_flow_imp.g_varchar2_table(34697) := '7475726E225B6F626A656374204E756D6265725D223D3D3D6F2E63616C6C2865297D66756E6374696F6E20752865297B636F6E737420743D6F2E63616C6C2865293B72657475726E225B6F626A6563742046756E6374696F6E5D223D3D3D747C7C225B6F';
wwv_flow_imp.g_varchar2_table(34698) := '626A656374204173796E6346756E6374696F6E5D223D3D3D747C7C225B6F626A6563742047656E657261746F7246756E6374696F6E5D223D3D3D747C7C225B6F626A656374204173796E6347656E657261746F7246756E6374696F6E5D223D3D3D747C7C';
wwv_flow_imp.g_varchar2_table(34699) := '225B6F626A6563742050726F78795D223D3D3D747D66756E6374696F6E20702865297B72657475726E225B6F626A65637420537472696E675D223D3D3D6F2E63616C6C2865297D66756E6374696F6E206728652C74297B72657475726E20732E63616C6C';
wwv_flow_imp.g_varchar2_table(34700) := '28652C74297D66756E6374696F6E206D28652C74297B636F6E7374206E3D4E2874293B6C657420693B72657475726E206228652C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D652C21317D29292C697D66756E63';
wwv_flow_imp.g_varchar2_table(34701) := '74696F6E206628652C74297B636F6E7374206E3D4E2874293B6C657420693D632865293F2D313A766F696420303B72657475726E206228652C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D742C21317D29292C69';
wwv_flow_imp.g_varchar2_table(34702) := '7D66756E6374696F6E207628652C74297B636F6E7374206E3D4E2874293B6C657420693D5B5D3B72657475726E206228652C2866756E6374696F6E28652C74297B6E28652C74292626692E707573682865297D29292C697D66756E6374696F6E20622865';
wwv_flow_imp.g_varchar2_table(34703) := '2C74297B6C6574206E2C693B696628722865292972657475726E3B636F6E7374206F3D632865293F4F3A503B666F72286C6574207320696E2065296966286728652C73292626286E3D655B735D2C693D74286E2C6F287329292C21313D3D3D6929297265';
wwv_flow_imp.g_varchar2_table(34704) := '7475726E206E7D66756E6374696F6E205F28652C74297B696628722865292972657475726E5B5D3B2166756E6374696F6E2865297B6966282163286529297468726F77206E6577204572726F7228226D75737420737570706C7920617272617922297D28';
wwv_flow_imp.g_varchar2_table(34705) := '65293B636F6E7374206E3D4E2874293B72657475726E20652E66696C746572282866756E6374696F6E28652C74297B72657475726E216E28652C74297D29297D66756E6374696F6E207928652C742C6E297B72657475726E206228652C2866756E637469';
wwv_flow_imp.g_varchar2_table(34706) := '6F6E28652C69297B6E3D74286E2C652C69297D29292C6E7D66756E6374696F6E207728652C74297B72657475726E21217928652C2866756E6374696F6E28652C6E2C69297B72657475726E2065262674286E2C69297D292C2130297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(34707) := '204328652C74297B72657475726E21216D28652C74297D66756E6374696F6E205328652C74297B6C6574206E3D5B5D3B72657475726E206228652C2866756E6374696F6E28652C69297B6E2E70757368287428652C6929297D29292C6E7D66756E637469';
wwv_flow_imp.g_varchar2_table(34708) := '6F6E20782865297B72657475726E206526264F626A6563742E6B6579732865297C7C5B5D7D66756E6374696F6E206B2865297B72657475726E20782865292E6C656E6774687D66756E6374696F6E20452865297B72657475726E205328652C28653D3E65';
wwv_flow_imp.g_varchar2_table(34709) := '29297D66756E6374696F6E204C28652C742C6E3D7B7D297B72657475726E20743D412874292C6228652C2866756E6374696F6E2865297B6C657420693D742865297C7C225F222C6F3D6E5B695D3B6F7C7C286F3D6E5B695D3D5B5D292C6F2E7075736828';
wwv_flow_imp.g_varchar2_table(34710) := '65297D29292C6E7D66756E6374696F6E204428652C2E2E2E74297B653D412865293B6C6574206E3D7B7D3B72657475726E206228742C28743D3E4C28742C652C6E2929292C53286E2C2866756E6374696F6E28652C74297B72657475726E20655B305D7D';
wwv_flow_imp.g_varchar2_table(34711) := '29297D636F6E737420543D443B66756E6374696F6E204928652C74297B743D412874293B6C6574206E3D5B5D3B72657475726E206228652C2866756E6374696F6E28652C69297B6C6574206F3D7428652C69292C733D7B643A6F2C763A657D3B666F7228';
wwv_flow_imp.g_varchar2_table(34712) := '76617220723D303B723C6E2E6C656E6774683B722B2B297B6C65747B643A657D3D6E5B725D3B6966286F3C652972657475726E20766F6964206E2E73706C69636528722C302C73297D6E2E707573682873297D29292C53286E2C28653D3E652E7629297D';
wwv_flow_imp.g_varchar2_table(34713) := '66756E6374696F6E204D2865297B72657475726E2066756E6374696F6E2874297B72657475726E207728652C2866756E6374696F6E28652C6E297B72657475726E20745B6E5D3D3D3D657D29297D7D66756E6374696F6E20412865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(34714) := '752865293F653A743D3E745B655D7D66756E6374696F6E204E2865297B72657475726E20752865293F653A743D3E743D3D3D657D66756E6374696F6E20502865297B72657475726E20657D66756E6374696F6E204F2865297B72657475726E204E756D62';
wwv_flow_imp.g_varchar2_table(34715) := '65722865297D66756E6374696F6E205228652C74297B6C6574206E2C692C6F2C733B66756E6374696F6E2072286E297B6C657420723D446174652E6E6F7728292C633D6E3F303A732B742D723B696628633E302972657475726E20612863293B652E6170';
wwv_flow_imp.g_varchar2_table(34716) := '706C79286F2C69292C6C28297D66756E6374696F6E20612865297B6E3D73657454696D656F757428722C65297D66756E6374696F6E206C28297B6E2626636C65617254696D656F7574286E292C6E3D733D693D6F3D766F696420307D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(34717) := '2063282E2E2E65297B733D446174652E6E6F7728292C693D652C6F3D746869732C6E7C7C612874297D72657475726E20632E666C7573683D66756E6374696F6E28297B6E262672282130292C6C28297D2C632E63616E63656C3D6C2C637D66756E637469';
wwv_flow_imp.g_varchar2_table(34718) := '6F6E204628652C74297B72657475726E20652E62696E642874297D66756E6374696F6E204228652C2E2E2E74297B72657475726E204F626A6563742E61737369676E28652C2E2E2E74297D66756E6374696F6E205628652C742C6E297B6C657420693D65';
wwv_flow_imp.g_varchar2_table(34719) := '3B72657475726E206228742C2866756E6374696F6E28652C6F297B696628226E756D62657222213D747970656F662065262622737472696E6722213D747970656F662065297468726F77206E6577204572726F722822696C6C6567616C206B6579207479';
wwv_flow_imp.g_varchar2_table(34720) := '70653A20222B747970656F6620652B222E204B65792073686F756C64206265206F662074797065206E756D626572206F7220737472696E672E22293B69662822636F6E7374727563746F72223D3D3D65297468726F77206E6577204572726F722822696C';
wwv_flow_imp.g_varchar2_table(34721) := '6C6567616C206B65793A20636F6E7374727563746F7222293B696628225F5F70726F746F5F5F223D3D3D65297468726F77206E6577204572726F722822696C6C6567616C206B65793A205F5F70726F746F5F5F22293B6C657420733D745B6F2B315D2C63';
wwv_flow_imp.g_varchar2_table(34722) := '3D695B655D3B6128732926266C286329262628633D695B655D3D69734E614E282B73293F7B7D3A5B5D292C722873293F72286E293F64656C65746520695B655D3A695B655D3D6E3A693D637D29292C657D66756E6374696F6E207A28652C742C6E297B6C';
wwv_flow_imp.g_varchar2_table(34723) := '657420693D653B72657475726E206228742C2866756E6374696F6E2865297B6966286C2869292972657475726E20693D766F696420302C21313B693D695B655D7D29292C722869293F6E3A697D66756E6374696F6E204828652C74297B6C6574206E3D7B';
wwv_flow_imp.g_varchar2_table(34724) := '7D2C693D4F626A6563742865293B72657475726E206228742C2866756E6374696F6E2874297B7420696E20692626286E5B745D3D655B745D297D29292C6E7D66756E6374696F6E205728652C74297B6C6574206E3D7B7D3B72657475726E2062284F626A';
wwv_flow_imp.g_varchar2_table(34725) := '6563742865292C2866756E6374696F6E28652C69297B2D313D3D3D742E696E6465784F662869292626286E5B695D3D65297D29292C6E7D7D2C343338373A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528';
wwv_flow_imp.g_varchar2_table(34726) := '277B227B6572726F72737D204572726F72732C207B7761726E696E67737D205761726E696E6773223A227B6572726F72737D204665686C65722C207B7761726E696E67737D205761726E756E67656E222C227B73656D616E7469637D237B736964657D20';
wwv_flow_imp.g_varchar2_table(34727) := '526566206E6F7420737065636966696564223A227B73656D616E7469637D237B736964657D20526566206E6963687420616E6765676562656E222C223C6E6F6E653E223A223C6B65696E653E222C22312D557267656E74223A22312D4472696E67656E64';
wwv_flow_imp.g_varchar2_table(34728) := '222C22322D48696768223A22322D486F6368222C22332D4D656469756D223A22332D4D697474656C222C22342D4C6F77223A22342D4E696564726967222C22352D4C6F77657374223A22352D4E696564726967737465222C224120676174657761792073';
wwv_flow_imp.g_varchar2_table(34729) := '686F756C64206E6F74206D6572676520616E642073706C6974206174207468652073616D652074696D65223A2245696E2047617465776179206B616E6E206E69636874207A75722073656C62656E205A656974205A7573616D6D656E66C3BC6872656E20';
wwv_flow_imp.g_varchar2_table(34730) := '756E64204175667465696C656E222C224163746976617465206372656174652F72656D6F766520737061636520746F6F6C223A22506C61747A2D68696E7A7566C3BC67656E2F656E746665726E656E2D546F6F6C20616B746976696572656E222C224163';
wwv_flow_imp.g_varchar2_table(34731) := '74697661746520676C6F62616C20636F6E6E65637420746F6F6C223A22476C6F62616C65732056657262696E64756E67737765726B7A65756720616B746976696572656E222C2241637469766174652068616E6420746F6F6C223A2248616E642D546F6F';
wwv_flow_imp.g_varchar2_table(34732) := '6C20616B746976696572656E222C224163746976617465206C6173736F20746F6F6C223A224C6173736F2D546F6F6C20616B746976696572656E222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A';
wwv_flow_imp.g_varchar2_table(34733) := '22506C61747A2D68696E7A7566C3BC67656E2F656E746665726E656E2D546F6F6C20616B746976696572656E222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A22476C6F62616C65732056657262696E64756E';
wwv_flow_imp.g_varchar2_table(34734) := '67737765726B7A65756720616B746976696572656E222C224163746976617465207468652068616E6420746F6F6C223A2248616E642D546F6F6C20616B746976696572656E222C22416374697661746520746865206C6173736F20746F6F6C223A224C61';
wwv_flow_imp.g_varchar2_table(34735) := '73736F2D546F6F6C20616B746976696572656E222C224163746976697479207265666572656E6365223A22416B7469766974C3A474737265666572656E7A222C2241642D686F63223A2241642D686F63222C22416464206C616E652061626F7665223A22';
wwv_flow_imp.g_varchar2_table(34736) := '4C616E65206F62657268616C622068696E7A7566C3BC67656E222C22416464206C616E652062656C6F77223A224C616E6520756E74657268616C622068696E7A7566C3BC67656E222C22416464207465787420616E6E6F746174696F6E223A2254657874';
wwv_flow_imp.g_varchar2_table(34737) := '616E6E6F746174696F6E2068696E7A7566C3BC67656E222C224166746572204D65726765223A224E616368205A7573616D6D656E66C3BC6872756E67222C224166746572205461736B223A224E6163682041756667616265222C22416C69676E20656C65';
wwv_flow_imp.g_varchar2_table(34738) := '6D656E747320626F74746F6D223A22456C656D656E746520756E74656E206175737269636874656E222C22416C69676E20656C656D656E74732063656E746572223A22456C656D656E7465207A656E7472696572656E222C22416C69676E20656C656D65';
wwv_flow_imp.g_varchar2_table(34739) := '6E7473206C656674223A22456C656D656E7465206C696E6B73206175737269636874656E222C22416C69676E20656C656D656E7473206D6964646C65223A22456C656D656E7465206D6974746967206175737269636874656E222C22416C69676E20656C';
wwv_flow_imp.g_varchar2_table(34740) := '656D656E7473207269676874223A22456C656D656E746520726563687473206175737269636874656E222C22416C69676E20656C656D656E747320746F70223A22456C656D656E7465206F62656E206175737269636874656E222C22416C69676E20656C';
wwv_flow_imp.g_varchar2_table(34741) := '656D656E7473223A22456C656D656E7465206175737269636874656E222C22416C6C6F772042696E64696E67223A2242696E64696E67207A756C617373656E222C22616C72656164792072656E6465726564207B656C656D656E747D223A227B656C656D';
wwv_flow_imp.g_varchar2_table(34742) := '656E747D206265726569747320616E67657A65696774222C224150455820417070726F76616C223A22415045582D47656E65686D6967756E67222C22415045582050616765223A2241504558205365697465222C224150455820526F6C65223A22415045';
wwv_flow_imp.g_varchar2_table(34743) := '582D526F6C6C65222C22415045582053696D706C6520466F726D223A22415045582045696E66616368657320466F726D756C6172222C22417070656E6420636F6D70656E736174696F6E206163746976697479223A224B6F6D70656E736174696F6E2068';
wwv_flow_imp.g_varchar2_table(34744) := '696E7A7566C3BC67656E222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22436F6E646974696F6E496E7465726D65646961746543617463684576656E7420616E68C3A46E67656E';
wwv_flow_imp.g_varchar2_table(34745) := '222C22417070656E6420656E64206576656E74223A22456E6465726569676E697320616E68C3A46E67656E222C22417070656E642067617465776179223A224761746577617920616E68C3A46E67656E222C22417070656E6420696E7465726D65646961';
wwv_flow_imp.g_varchar2_table(34746) := '74652F626F756E64617279206576656E74223A22416E67656865667465746573202F205A7769736368656E65726569676E697320616E68C3A46E67656E222C22417070656E64206D65737361676520696E7465726D656469617465206361746368206576';
wwv_flow_imp.g_varchar2_table(34747) := '656E74223A2245696E74726574656E646573204E6163687269636874656E2D5A7769736368656E65726569676E697320616E68C3A46E67656E222C22417070656E642072656365697665207461736B223A22456D7066616E67656E204175666761626520';
wwv_flow_imp.g_varchar2_table(34748) := '616E68C3A46E67656E222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A2245696E74726574656E646573205369676E616C2D5A7769736368656E65726569676E697320616E68C3A46E67656E22';
wwv_flow_imp.g_varchar2_table(34749) := '2C22417070656E64207461736B223A224175666761626520616E68C3A46E67656E222C22417070656E64207465787420616E6E6F746174696F6E223A2254657874616E6E6F746174696F6E20616E68C3A46E67656E222C22417070656E642074696D6572';
wwv_flow_imp.g_varchar2_table(34750) := '20696E7465726D656469617465206361746368206576656E74223A2245696E74726574656E646573205A6569742D5A7769736368656E65726569676E697320616E68C3A46E67656E222C224170706C69636174696F6E204944223A224170706C696B6174';
wwv_flow_imp.g_varchar2_table(34751) := '696F6E732D4944222C224170706C69636174696F6E223A224170706C696B6174696F6E222C2241737369676E6D656E74223A225A7577656973756E67222C224174746163686D656E74223A22416E68616E67222C224261636B67726F756E64205461736B';
wwv_flow_imp.g_varchar2_table(34752) := '2053657373696F6E223A2248696E7465726772756E642D5461736B2D53657373696F6E222C22424343223A22424343222C224265666F7265204576656E74223A22566F722045726569676E6973222C224265666F72652053706C6974223A22566F722041';
wwv_flow_imp.g_varchar2_table(34753) := '75667465696C756E67222C224265666F7265205461736B223A22566F722041756667616265222C2242696E642070616765206974656D7320286465707265636174656429223A22506167652D4974656D73207A7577656973656E2028766572616C746574';
wwv_flow_imp.g_varchar2_table(34754) := '29222C2242696E6420706172616D657465722076616C756573223A22506172616D657465727765727465207A7577656973656E222C2242696E642070726F63657373207661726961626C6573223A2250726F7A6573737661726961626C656E207A757765';
wwv_flow_imp.g_varchar2_table(34755) := '6973656E222C22426C696E6420636172626F6E20636F707920726563697069656E74287329223A22426C696E646B6F70696520456D7066C3A46E676572222C22426F64792048544D4C223A2248544D4C222C22426F64792054657874223A225465787422';
wwv_flow_imp.g_varchar2_table(34756) := '2C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A224772656E7A65726569676E6973736520626569206974657269';
wwv_flow_imp.g_varchar2_table(34757) := '6572656E64656E20556E74657270726F7A657373656E2077657264656E206465727A656974206E6963687420756E7465727374C3BC747A74222C22427573696E657373205265666572656E6365223A224765736368C3A46674737265666572656E7A222C';
wwv_flow_imp.g_varchar2_table(34758) := '22427573696E6573732072756C65207461736B223A224765736368C3A4667473726567656C2041756667616265222C22427573696E6573732052756C65205461736B223A224765736368C3A4667473726567656C2041756667616265222C22627573696E';
wwv_flow_imp.g_varchar2_table(34759) := '6573735F726566223A224765736368C3A46674737265666572656E7A222C2243616C6C206163746976697479223A22416B7469766974C3A47420617566727566656E222C2243616C6C204163746976697479223A22416B7469766974C3A4742061756672';
wwv_flow_imp.g_varchar2_table(34760) := '7566656E222C2243616C6C6564204469616772616D223A224175666765727566656E6573204469616772616D6D222C2243616E63656C20626F756E64617279206576656E74223A22416E6765686566746574657320416262727563682D5A776973636865';
wwv_flow_imp.g_varchar2_table(34761) := '6E65726569676E6973222C2243616E63656C20656E64206576656E74223A22416262727563682D456E6465726569676E6973222C2243616E63656C223A2241626272656368656E222C22436172626F6E20636F707920726563697069656E74287329223A';
wwv_flow_imp.g_varchar2_table(34762) := '224B6F70696520456D7066C3A46E676572222C2243617465676F72792056616C7565223A224B617465676F72696577657274222C224343223A224343222C224368616E676520656C656D656E74223A22456C656D656E7420C3A46E6465726E222C224368';
wwv_flow_imp.g_varchar2_table(34763) := '616E67652074797065223A2254797020C3A46E6465726E222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A2243616368652D57657274652066C3BC722053656974656E617566727566206C656572656E222C2243';
wwv_flow_imp.g_varchar2_table(34764) := '6C656172204361636865223A224361636865206C656572656E222C22436C6F62223A22436C6F62222C22436F6465223A22436F6465222C22436F6C6C61626F726174696F6E223A225A7573616D6D656E617262656974222C22436F6C6C61707365642050';
wwv_flow_imp.g_varchar2_table(34765) := '6F6F6C223A225A7567656B6C61707074657220506F6F6C222C22436F6C6C6170736564205375622050726F63657373223A225A7573616D6D656E67656661737374657220556E74657270726F7A657373222C22436F6C6C656374696F6E2054797065223A';
wwv_flow_imp.g_varchar2_table(34766) := '2253616D6D6C756E67732D547970222C22436F6C6C656374696F6E223A2253616D6D6C756E67222C22436F6D70656E7361746520456E64204576656E74223A224B6F6D70656E736174696F6E2D456E6465726569676E6973222C22436F6D70656E736174';
wwv_flow_imp.g_varchar2_table(34767) := '6520496E7465726D656469617465205468726F77204576656E74223A2253656E64656E646573204B6F6D70656E736174696F6E2D5A7769736368656E65726569676E6973222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A';
wwv_flow_imp.g_varchar2_table(34768) := '22416E67656865667465746573204B6F6D70656E736174696F6E732D5A7769736368656E65726569676E6973222C22436F6D70656E736174696F6E20656E64206576656E74223A224B6F6D70656E736174696F6E732D456E6465726569676E6973222C22';
wwv_flow_imp.g_varchar2_table(34769) := '436F6D70656E736174696F6E20696E7465726D656469617465207468726F77206576656E74223A2241757367656CC3B673746573204B6F6D70656E736174696F6E732D5A7769736368656E65726569676E6973222C22436F6D70656E736174696F6E2073';
wwv_flow_imp.g_varchar2_table(34770) := '74617274206576656E74223A224B6F6D70656E736174696F6E732D537461727465726569676E6973222C22436F6D70656E736174696F6E223A224B6F6D70656E736174696F6E222C22436F6D706C65746564223A22416267657363686C6F7373656E222C';
wwv_flow_imp.g_varchar2_table(34771) := '22436F6D706C6574696F6E20436F6E646974696F6E223A2241627363686C757373626564696E67756E67222C22436F6D706C65782067617465776179223A224B6F6D706C657865732047617465776179222C22436F6D706C65782047617465776179223A';
wwv_flow_imp.g_varchar2_table(34772) := '224B6F6D706C657865732047617465776179222C22436F6E646974696F6E2054797065223A22426564696E67756E6773747970222C22436F6E646974696F6E223A22426564696E67756E67222C22436F6E646974696F6E616C20626F756E646172792065';
wwv_flow_imp.g_varchar2_table(34773) := '76656E7420286E6F6E2D696E74657272757074696E6729223A22416E6765686566746574657320626564696E67746573205A7769736368656E65726569676E697320286E6963687420756E7465726272656368656E6429222C22436F6E646974696F6E61';
wwv_flow_imp.g_varchar2_table(34774) := '6C20626F756E64617279206576656E74223A22416E6765686566746574657320626564696E67746573205A7769736368656E65726569676E6973222C22436F6E646974696F6E616C20666C6F77223A22426564696E677465722053657175656E7A666C75';
wwv_flow_imp.g_varchar2_table(34775) := '7373222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A2245696E74726574656E64657320626564696E67746573205A7769736368656E65726569676E6973222C22436F6E646974696F6E616C20496E';
wwv_flow_imp.g_varchar2_table(34776) := '7465726D656469617465204361746368204576656E74223A2245696E74726574656E64657320626564696E67746573205A7769736368656E65726569676E6973222C22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E7465';
wwv_flow_imp.g_varchar2_table(34777) := '7272757074696E6729223A22426564696E6774657320537461727465726569676E697320286E6963687420756E7465726272656368656E6429222C22436F6E646974696F6E616C205374617274204576656E74223A22426564696E677465732053746172';
wwv_flow_imp.g_varchar2_table(34778) := '742D45726569676E6973222C22436F6E646974696F6E616C207374617274206576656E74223A22426564696E6774657320537461727465726569676E6973222C22436F6E6E65637420746F206F7468657220656C656D656E74223A224D697420616E6465';
wwv_flow_imp.g_varchar2_table(34779) := '72656D20456C656D656E742076657262696E64656E222C22436F6E6E656374207573696E67206173736F63696174696F6E223A224D6974204173736F7A696174696F6E2076657262696E64656E222C22436F6E6E656374207573696E6720646174612069';
wwv_flow_imp.g_varchar2_table(34780) := '6E707574206173736F63696174696F6E223A224D69742044617461496E7075744173736F63696174696F6E2076657262696E64656E222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63';
wwv_flow_imp.g_varchar2_table(34781) := '696174696F6E223A224D69742053657175656E7A666C7573732F4E6163687269636874656E666C757373206F646572204173736F7A696174696F6E2076657262696E64656E222C22436F707920627573696E657373207265666572656E6365223A224765';
wwv_flow_imp.g_varchar2_table(34782) := '736368C3A46674737265666572656E7A206B6F70696572656E222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A224665686C656E6465732042';
wwv_flow_imp.g_varchar2_table(34783) := '504D4E2D456C656D656E7420617566207B706C616E657D20616E207B726F6F74456C656D656E747D206B6F72726967696572656E222C22436F7272656C6174696F6E204B6579223A224B6F7272656C6174696F6E737363686CC3BC7373656C222C22436F';
wwv_flow_imp.g_varchar2_table(34784) := '7272656C6174696F6E2056616C7565223A224B6F7272656C6174696F6E7377657274222C22437265617465207B747970657D223A227B747970657D2065727374656C6C656E222C224372656174652064617461206F626A656374207265666572656E6365';
wwv_flow_imp.g_varchar2_table(34785) := '223A225265666572656E7A656E2061756620446174656E6F626A656B742065727A657567656E222C2243726561746520646174612073746F7265207265666572656E6365223A225265666572656E7A656E2061756620446174656E73706569636865726F';
wwv_flow_imp.g_varchar2_table(34786) := '626A656B742065727A657567656E222C2243726561746520446174614F626A6563745265666572656E6365223A225265666572656E7A656E2061756620446174656E6F626A656B742065727A657567656E222C22437265617465204461746153746F7265';
wwv_flow_imp.g_varchar2_table(34787) := '5265666572656E6365223A225265666572656E7A656E2061756620446174656E73706569636865726F626A656B742065727A657567656E222C2243726561746520656E64206576656E74223A22456E6465726569676E69732065727374656C6C656E222C';
wwv_flow_imp.g_varchar2_table(34788) := '2243726561746520456E644576656E74223A22456E6465726569676E69732065727374656C6C656E222C2243726561746520657870616E646564207375622D70726F63657373223A22457277656974657274656E205465696C2D50726F7A657373206572';
wwv_flow_imp.g_varchar2_table(34789) := '7374656C6C656E222C2243726561746520657870616E6465642053756250726F63657373223A22457277656974657274656E205465696C2D50726F7A6573732065727374656C6C656E222C224372656174652067617465776179223A2247617465776179';
wwv_flow_imp.g_varchar2_table(34790) := '2065727374656C6C656E222C224372656174652047617465776179223A22476174657761792065727374656C6C656E222C224372656174652067726F7570223A224772757070652065727374656C6C656E222C224372656174652047726F7570223A2247';
wwv_flow_imp.g_varchar2_table(34791) := '72757070652065727374656C6C656E222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A225A7769736368656E2D2F4772656E7A65726569676E69732065727A657567656E222C2243726561746520496E74';
wwv_flow_imp.g_varchar2_table(34792) := '65726D6564696174652F426F756E64617279204576656E74223A225A7769736368656E2D2F4772656E7A65726569676E69732065727A657567656E222C22437265617465206E6577202E2E2E223A224E65752065727374656C6C656E2E2E2E222C224372';
wwv_flow_imp.g_varchar2_table(34793) := '6561746520706F6F6C2F7061727469636970616E74223A22506F6F6C2F5465696C6E65686D65722065727A657567656E222C2243726561746520506F6F6C2F5061727469636970616E74223A22506F6F6C2F5465696C6E65686D65722065727A65756765';
wwv_flow_imp.g_varchar2_table(34794) := '6E222C22437265617465207374617274206576656E74223A2253746172742D4576656E742065727A657567656E222C224372656174652053746172742054696D6572204576656E74223A2254696D65722053746172742D4576656E742065727374656C6C';
wwv_flow_imp.g_varchar2_table(34795) := '656E222C224372656174652053746172744576656E74223A2253746172742D4576656E742065727374656C6C656E222C22437265617465205461736B223A22417566676162652065727374656C6C656E222C22437265617465207461736B223A22417566';
wwv_flow_imp.g_varchar2_table(34796) := '676162652065727A657567656E222C22437573746F6D20457874656E73696F6E223A2242656E75747A6572646566696E6965727465204572776569746572756E67222C22437573746F6D223A2242656E75747A6572646566696E69657274222C22437963';
wwv_flow_imp.g_varchar2_table(34797) := '6C65202849534F203836303129223A225A796B6C7573202849534F203836303129222C224379636C6520284F7261636C6529223A225A796B6C757320284F7261636C6529222C2244617461206F626A656374207265666572656E6365223A22446174656E';
wwv_flow_imp.g_varchar2_table(34798) := '6F626A656B747265666572656E7A222C2244617461204F626A656374205265666572656E6365223A225265666572656E7A2061756620446174656E6F626A656B74222C22446174612073746F7265207265666572656E6365223A22446174656E73706569';
wwv_flow_imp.g_varchar2_table(34799) := '636865727265666572656E7A222C22446174612053746F7265205265666572656E6365223A225265666572656E7A2061756620446174656E7370656963686572222C22446174612054797065223A22446174656E747970222C2244617465202849534F20';
wwv_flow_imp.g_varchar2_table(34800) := '3836303129223A22446174756D202849534F203836303129222C224461746520284F7261636C6529223A22446174756D20284F7261636C6529222C224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A2244';
wwv_flow_imp.g_varchar2_table(34801) := '6174756D73666F726D617420595959592D4D4D2D444420484832343A4D493A5353222C224461746520537472696E67223A22446174756D737A65696368656E666F6C6765222C2244617465223A22446174756D222C2244656661756C74204170706C6963';
wwv_flow_imp.g_varchar2_table(34802) := '6174696F6E204944223A225374616E64617264616E77656E64756E67732D4944222C2244656661756C74204170706C69636174696F6E223A225374616E64617264616E77656E64756E67222C2244656661756C7420666C6F77223A225374616E64617264';
wwv_flow_imp.g_varchar2_table(34803) := '666C757373222C2244656661756C742050616765204944223A225374616E6461726473656974656E2D4944222C2244656661756C742050616765223A225374616E646172647365697465222C2244656661756C7420557365726E616D65223A225374616E';
wwv_flow_imp.g_varchar2_table(34804) := '6461726462656E75747A65726E616D65222C2244656C657465223A224CC3B6736368656E222C224465736372697074696F6E223A22426573636872656962756E67222C2244657461696C73223A2244657461696C73222C226469616772616D206E6F7420';
wwv_flow_imp.g_varchar2_table(34805) := '70617274206F662062706D6E3A446566696E6974696F6E73223A224469616772616D6D206B65696E2042657374616E647465696C20766F6E2062706D6E3A446566696E6974696F6E73222C224469737472696275746520656C656D656E747320686F7269';
wwv_flow_imp.g_varchar2_table(34806) := '7A6F6E74616C6C79223A22456C656D656E746520686F72697A6F6E74616C207665727465696C656E222C224469737472696275746520656C656D656E747320766572746963616C6C79223A22456C656D656E74652076657274696B616C20766572746569';
wwv_flow_imp.g_varchar2_table(34807) := '6C656E222C2244697669646520696E746F207468726565206C616E6573223A22496E2064726569204261686E656E206175667465696C656E222C2244697669646520696E746F2074776F206C616E6573223A22496E207A776569204261686E656E206175';
wwv_flow_imp.g_varchar2_table(34808) := '667465696C656E222C22446F63756D656E746174696F6E223A22446F6B756D656E746174696F6E222C22447565204F6E223A2246C3A46C6C696720616D222C224475706C696361746520696E636F6D696E672073657175656E636520666C6F7773223A22';
wwv_flow_imp.g_varchar2_table(34809) := '4475706C697A69657274652065696E676568656E64652053657175656E7A666CC3BC737365222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A224475706C697A696572746520617573676568656E64652053';
wwv_flow_imp.g_varchar2_table(34810) := '657175656E7A666CC3BC737365222C224475726174696F6E202849534F203836303129223A224461756572202849534F203836303129222C224475726174696F6E20284F7261636C6529223A22446175657220284F7261636C6529222C22447572617469';
wwv_flow_imp.g_varchar2_table(34811) := '6F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C2720666F726D6174223A22446175657220696D20466F726D61742049534F2038363031206F646572204F7261636C';
wwv_flow_imp.g_varchar2_table(34812) := '6520496E74657276616C204453205C2744444420484832343A4D493A53535C27222C22652E672E2032332D4A554E2D323032372031343A31303A3030223A22426569737069656C2E2032332D4A554E2D323032372031343A31303A3030222C22652E672E';
wwv_flow_imp.g_varchar2_table(34813) := '2044442D4D4F4E2D5959595920484832343A4D493A5353223A22426569737069656C3A2054542D4D4F4E2D4A4A4A4A20484832343A4D493A5353222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B726566657265';
wwv_flow_imp.g_varchar2_table(34814) := '6E6365647D237B70726F70657274797D206E6F742079657420647261776E223A22766F6E207B7265666572656E6365647D237B70726F70657274797D207265666572656E7A69657274657320456C656D656E74207B656C656D656E747D206E6F6368206E';
wwv_flow_imp.g_varchar2_table(34815) := '696368742067657A656963686E6574222C22456C656D656E7420646F63756D656E746174696F6E223A22456C656D656E74646F6B756D656E746174696F6E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A43';
wwv_flow_imp.g_varchar2_table(34816) := '6F6D706C6578476174657761793E223A22456C656D656E742068617420756E7A756CC3A473736967656E2054797020283C62706D6E3A436F6D706C6578476174657761793E292E222C22456C656D656E742068617320646973616C6C6F77656420747970';
wwv_flow_imp.g_varchar2_table(34817) := '65203C62706D6E3A4D65737361676553746172744576656E743E223A22456C656D656E742068617420756E7A756CC3A473736967656E2054797020283C62706D6E3A4D65737361676553746172744576656E743E292E222C22456C656D656E7420686173';
wwv_flow_imp.g_varchar2_table(34818) := '20646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A22456C656D656E742068617420756E7A756CC3A473736967656E2054797020283C62706D6E3A5369676E616C53746172744576656E743E292E22';
wwv_flow_imp.g_varchar2_table(34819) := '2C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A22456C656D656E742068617420756E7A756CC3A473736967656E2054797020283C62706D6E436F6E64';
wwv_flow_imp.g_varchar2_table(34820) := '6974696F6E616C53746172744576656E743E292E222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063686172616374657273223A22456C656D656E742D4944206CC3A46E67657220616C73203530205A65696368656E222C';
wwv_flow_imp.g_varchar2_table(34821) := '22456C656D656E7420494420776173206E6F74206368616E67656420796574223A22456C656D656E742D4944207775726465206E69636874206765C3A46E64657274222C22456C656D656E7420697320616E20696D706C6963697420656E64223A22456C';
wwv_flow_imp.g_varchar2_table(34822) := '656D656E74206973742065696E20696D706C697A6974657320456E6465222C22456C656D656E7420697320616E20696D706C69636974207374617274223A22456C656D656E74206973742065696E20696D706C697A69746572205374617274222C22456C';
wwv_flow_imp.g_varchar2_table(34823) := '656D656E74206973206D697373696E67206C6162656C2F6E616D65223A22426573636872696674756E672F4E616D652066C3BC7220456C656D656E74206665686C74222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22456C656D';
wwv_flow_imp.g_varchar2_table(34824) := '656E7420697374206E696368742076657262756E64656E222C22656C656D656E74207265717569726564223A22456C656D656E742062656EC3B674696774222C22456D61696C20636F6E74656E74223A22452D4D61696C2D496E68616C74222C22456D61';
wwv_flow_imp.g_varchar2_table(34825) := '696C206F662074686520726563697069656E74287329223A22456D61696C20456D7066C3A46E676572222C22456D61696C206F66207468652073656E646572223A22456D61696C20416273656E646572222C22456D61696C207768657265207468652072';
wwv_flow_imp.g_varchar2_table(34826) := '65706C792073686F756C642062652073656E6420746F223A22416E74776F72742D416E20456D61696C204164647265737365222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F76657320636F6E74656E7429223A224C656572';
wwv_flow_imp.g_varchar2_table(34827) := '657220506F6F6C2028656E746665726E7420496E68616C7429222C22456D70747920706F6F6C2F7061727469636970616E74223A224C656572657220506F6F6C222C22456E64204576656E74223A22456E642D4576656E74222C22456E64206576656E74';
wwv_flow_imp.g_varchar2_table(34828) := '223A22456E6465726569676E6973222C22456E64706F696E74223A22456E6470756E6B74222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E223A2242656E75747A6572646566696E6965727465204572776569746572';
wwv_flow_imp.g_varchar2_table(34829) := '756E67656E20616C73204A534F4E2065696E676562656E222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A224175737A7566C3BC6872656E64656E20504C2F53514C20436F64652065696E676562';
wwv_flow_imp.g_varchar2_table(34830) := '656E2E222C224572726F7220626F756E64617279206576656E74223A22416E67656865667465746573204665686C65722D5A7769736368656E65726569676E6973222C224572726F7220456E64204576656E74223A224665686C657220456E6465726569';
wwv_flow_imp.g_varchar2_table(34831) := '676E6973222C224572726F7220656E64206576656E74223A224665686C65722D456E6465726569676E6973222C224572726F72207374617274206576656E74223A224665686C65722D537461727465726569676E6973222C224572726F72223A22466568';
wwv_flow_imp.g_varchar2_table(34832) := '6C6572222C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22416E676568656674657465732045736B616C6174696F6E732D5A7769736368656E65726569676E697320286E696368';
wwv_flow_imp.g_varchar2_table(34833) := '7420756E7465726272656368656E6429222C22457363616C6174696F6E20626F756E64617279206576656E74223A22416E676568656674657465732045736B616C6174696F6E732D5A7769736368656E65726569676E6973222C22457363616C6174696F';
wwv_flow_imp.g_varchar2_table(34834) := '6E20656E64206576656E74223A2245736B616C6174696F6E732D456E6465726569676E6973222C22457363616C6174696F6E20456E64204576656E74223A2245736B616C6174696F6E732D456E6465726569676E6973222C22457363616C6174696F6E20';
wwv_flow_imp.g_varchar2_table(34835) := '696E7465726D656469617465207468726F77206576656E74223A2241757367656CC3B6737465732045736B616C6174696F6E732D5A7769736368656E65726569676E6973222C22457363616C6174696F6E20496E7465726D656469617465205468726F77';
wwv_flow_imp.g_varchar2_table(34836) := '204576656E74223A2241757367656CC3B6737465732045736B616C6174696F6E732D5A7769736368656E65726569676E6973222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A2245736B';
wwv_flow_imp.g_varchar2_table(34837) := '616C6174696F6E732D537461727465726569676E697320286E6963687420756E7465726272656368656E6429222C22457363616C6174696F6E207374617274206576656E74223A2245736B616C6174696F6E732D537461727465726569676E6973222C22';
wwv_flow_imp.g_varchar2_table(34838) := '457363616C6174696F6E223A2245736B616C6174696F6E222C224576656E742042617365642047617465776179223A2245726569676E69736261736965727465732047617465776179222C224576656E7420686173206D756C7469706C65206576656E74';
wwv_flow_imp.g_varchar2_table(34839) := '20646566696E6974696F6E73223A2245726569676E69732062657369747A74206D6568726572652045726569676E6973646566696E6974696F6E656E222C224576656E74205375622050726F63657373223A2245726569676E69732D5465696C70726F7A';
wwv_flow_imp.g_varchar2_table(34840) := '657373222C224576656E74207375622D70726F63657373223A2245726569676E69732D5465696C70726F7A657373222C224576656E742054797065223A2245726569676E6973747970222C224576656E742D62617365642067617465776179223A224572';
wwv_flow_imp.g_varchar2_table(34841) := '6569676E69732D6261736965727465732047617465776179222C224578636C75646564205374617274696E67205573657273223A2241757367657363686C6F7373656E6520537461727462656E75747A6572222C224578636C7564656420557365727322';
wwv_flow_imp.g_varchar2_table(34842) := '3A2241757367657363686C6F7373656E652042656E75747A6572222C224578636C75736976652067617465776179223A2245786B6C7573697665732047617465776179222C224578636C75736976652047617465776179223A2245786B6C757369766573';
wwv_flow_imp.g_varchar2_table(34843) := '2047617465776179222C2245786563757461626C65223A2241757366C3BC687262617265732050726F6772616D6D222C224578656375746520504C2F53514C223A22504C2F53514C2061757366C3BC6872656E222C22457865637574696F6E223A224175';
wwv_flow_imp.g_varchar2_table(34844) := '7366C3BC6872756E67222C22457870616E64656420706F6F6C2F7061727469636970616E74223A22457277656974657274657220506F6F6C2F5465696C6E65686D6572222C22457870616E646564205375622050726F63657373223A2245727765697465';
wwv_flow_imp.g_varchar2_table(34845) := '7274657220556E74657270726F7A657373222C2245787072657373696F6E20284C656761637929223A22417573647275636B20284C656761637929222C2245787072657373696F6E2054797065223A22417573647275636B73747970222C224578707265';
wwv_flow_imp.g_varchar2_table(34846) := '7373696F6E223A22417573647275636B222C226661696C656420746F20696D706F7274207B656C656D656E747D223A22496D706F72742066C3BC72207B656C656D656E747D206665686C67657363686C6167656E222C22666C6F7720656C656D656E7473';
wwv_flow_imp.g_varchar2_table(34847) := '206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A22466C7573732D456C656D656E7465206DC3BC7373656E204B696E64657220766F6E20506F6F6C732F5465696C6E65686D65726E207365696E222C';
wwv_flow_imp.g_varchar2_table(34848) := '22466C6F772073706C69747320696D706C696369746C79223A2253657175656E7A666CC3BC7373652077657264656E20696D706C697A69742061756667657465696C74222C22466F726D2054656D706C617465204974656D204E616D65223A22456C656D';
wwv_flow_imp.g_varchar2_table(34849) := '656E742D4E616D652066C3BC7220466F726D756C6172766F726C616765222C22466F726D2054656D706C617465204974656D223A22456C656D656E742066C3BC7220466F726D756C6172766F726C616765222C22466F726D2054656D706C617465223A22';
wwv_flow_imp.g_varchar2_table(34850) := '466F726D756C6172766F726C616765222C22466F726D6174204D61736B223A22466F726D6174696572756E67736D61736B65222C22466F726D61744D61736B223A22466F726D61744D61736B222C2246726F6D223A22566F6E222C2246756E6374696F6E';
wwv_flow_imp.g_varchar2_table(34851) := '20426F647920284C656761637929223A2246756E6B74696F6E73626F647920284C656761637929222C2246756E6374696F6E20426F6479223A2246756E6B74696F6E73626F6479222C2247617465776179206973207375706572666C756F75732E204974';
wwv_flow_imp.g_varchar2_table(34852) := '206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A2247617465776179206E69636874206E6F7477656E6469672E2045732076657266C3BC6774206E757220C3BC6265722065696E65205175656C6C6520756E64206569';
wwv_flow_imp.g_varchar2_table(34853) := '6E205A69656C2E222C2247656E6572616C223A22416C6C67656D65696E222C2247656E65726174652064656661756C74206974656D73223A225374616E646172642D4974656D732067656E6572696572656E222C22476C6F62616C206572726F72207265';
wwv_flow_imp.g_varchar2_table(34854) := '666572656E6365223A22476C6F62616C65204665686C65727265666572656E7A222C22476C6F62616C20657363616C6174696F6E207265666572656E6365223A22476C6F62616C652045736B616C6174696F6E737265666572656E7A222C22476C6F6261';
wwv_flow_imp.g_varchar2_table(34855) := '6C207369676E616C207265666572656E6365223A22476C6F62616C65205369676E616C7265666572656E7A222C2247726F7570223A22477275707065222C2248544D4C2076657273696F6E206F662074686520656D61696C223A2248544D4C2056657273';
wwv_flow_imp.g_varchar2_table(34856) := '696F6E2064657320456D61696C73222C224944206D75737420626520756E697175652E223A224944206D7573732065696E646575746967207365696E2E222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A2269';
wwv_flow_imp.g_varchar2_table(34857) := '6E20466F726D6174204444442048483A4D4D3A5353222C22696E20666F726D61742059592D4D4D223A22696E20466F726D61742059592D4D4D222C22496E205661726961626C6573223A22496E2D5661726961626C65222C22496E2F4F7574204D617070';
wwv_flow_imp.g_varchar2_table(34858) := '696E67223A22496E2F4F7574204D617070696E67222C22496E2F4F7574205661726961626C6573223A22496E2F4F7574205661726961626C656E222C22496E636C75736976652067617465776179223A22496E6B6C757369766573204761746577617922';
wwv_flow_imp.g_varchar2_table(34859) := '2C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A2245696E676568656E64652053657175656E7A666CC3BC737365206E696368742076657262756E64656E222C22496E69746961746F72206F66207468697320617070726F7661';
wwv_flow_imp.g_varchar2_table(34860) := '6C207461736B223A22496E69746961746F72206469657365722047656E65686D6967756E677361756667616265222C22496E69746961746F72223A22496E69746961746F72222C22496E70757420436F6C6C656374696F6E223A2245696E676162652D53';
wwv_flow_imp.g_varchar2_table(34861) := '616D6C756E67222C22496E70757420456C656D656E74223A2245696E67616265656C656D656E74222C22496E7465726D656469617465207468726F77206576656E74223A225A7769736368656E65726569676E6973222C22496E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(34862) := '205468726F77204576656E74223A225A7769736368656E65726569676E6973222C22496E74657276616C223A22496E74657276616C6C222C2249732043616C6C61626C65223A22497374205C5C224175667275666261725C5C22222C22497320526F6C65';
wwv_flow_imp.g_varchar2_table(34863) := '223A2249737420526F6C6C65222C22497320537461727461626C65223A2249737420737461727466C3A4686967222C2249534F223A2249534F222C224974656D204E616D65223A22456C656D656E746E616D65222C224974656D2056616C7565223A2245';
wwv_flow_imp.g_varchar2_table(34864) := '6C656D656E7477657274222C224974656D223A22417274696B656C222C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F72746564223A2249746572696572656E646520417566';
wwv_flow_imp.g_varchar2_table(34865) := '727566616B7469766974C3A474656E2077657264656E206465727A656974206E6963687420756E7465727374C3BC747A74222C224A534F4E204F626A656374223A224A534F4E2D4F626A656B74222C224C616E65223A224261686E222C224C6174657374';
wwv_flow_imp.g_varchar2_table(34866) := '2076657273696F6E223A224C65747A74652056657273696F6E222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A2245696E74726574656E646573204C696E6B2D5A7769736368656E65726569676E6973222C224C696E';
wwv_flow_imp.g_varchar2_table(34867) := '6B20496E7465726D656469617465204361746368204576656E74223A2245696E74726574656E646573204C696E6B2D5A7769736368656E65726569676E6973222C224C696E6B20696E7465726D656469617465207468726F77206576656E74223A224175';
wwv_flow_imp.g_varchar2_table(34868) := '7367656CC3B673746573204C696E6B2D5A7769736368656E65726569676E6973222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A2241757367656CC3B673746573204C696E6B2D5A7769736368656E65726569676E69';
wwv_flow_imp.g_varchar2_table(34869) := '73222C224C696E6B223A225665726B6EC3BC7066756E67222C224C6F616420646566696E6564207661726961626C6573223A22446566696E6965727465205661726961626C656E206C6164656E222C224C6F6164204A534F4E223A224A534F4E206C6164';
wwv_flow_imp.g_varchar2_table(34870) := '656E222C224C6F616420506172616D6574657273223A22506172616D65746572206C6164656E222C224C6F6F70223A225363686C65696665222C224D61696C223A22456D61696C222C224D616E75616C207461736B223A224D616E75656C6C6520417566';
wwv_flow_imp.g_varchar2_table(34871) := '67616265222C224D616E75616C205461736B223A224D616E75656C6C652041756667616265222C224D61782052756E73223A224D6178696D616C652041757366C3BC6872756E67656E222C224D65737361676520626F756E64617279206576656E742028';
wwv_flow_imp.g_varchar2_table(34872) := '6E6F6E2D696E74657272757074696E6729223A22416E67656865667465746573204E6163687269636874656E2D5A7769736368656E65726569676E697320286E6963687420756E7465726272656368656E6429222C224D65737361676520626F756E6461';
wwv_flow_imp.g_varchar2_table(34873) := '7279206576656E74223A22416E67656865667465746573204E6163687269636874656E2D5A7769736368656E65726569676E6973222C224D65737361676520456E64204576656E74223A224E616368726963687420456E6465726569676E6973222C224D';
wwv_flow_imp.g_varchar2_table(34874) := '65737361676520656E64206576656E74223A224E6163687269636874656E2D456E6465726569676E6973222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A2245696E74726574656E646573204E616368726963';
wwv_flow_imp.g_varchar2_table(34875) := '6874656E2D5A7769736368656E65726569676E6973222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A2245696E74726574656E646573204E6163687269636874656E2D5A7769736368656E65726569676E6973';
wwv_flow_imp.g_varchar2_table(34876) := '222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A2241757367656CC3B673746573204E6163687269636874656E2D5A7769736368656E65726569676E6973222C224D65737361676520496E7465726D65646961';
wwv_flow_imp.g_varchar2_table(34877) := '7465205468726F77204576656E74223A2241757367656CC3B673746573204E6163687269636874656E2D5A7769736368656E65726569676E6973222C224D657373616765204E616D65223A224E6163687269636874656E6E616D65222C224D6573736167';
wwv_flow_imp.g_varchar2_table(34878) := '65207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224E6163687269636874656E2D537461727465726569676E697320286E6963687420756E7465726272656368656E6429222C224D6573736167652073746172742065';
wwv_flow_imp.g_varchar2_table(34879) := '76656E74223A224E6163687269636874656E2D537461727465726569676E6973222C224D657373616765205374617274204576656E74223A224E6163687269636874656E2D537461727465726569676E6973222C226D697373696E67207B73656D616E74';
wwv_flow_imp.g_varchar2_table(34880) := '69637D236174746163686564546F526566223A227B73656D616E7469637D236174746163686564546F526566206665686C74222C226D6F7265207468616E207B636F756E747D206368696C64206C616E6573223A226D65687220616C73207B636F756E74';
wwv_flow_imp.g_varchar2_table(34881) := '7D205465696C2D5066616465222C224D756C74692D496E7374616E6365223A224D65687266616368696E7374616E7A222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A226D65687266';
wwv_flow_imp.g_varchar2_table(34882) := '616368652049442D446566696E6974696F6E2066C3BC72207B656C656D656E747D222C224E616D65206F6620746865206469616772616D223A224E616D6520646573204469616772616D6D73222C224E616D65206F66207468652050726F636573732056';
wwv_flow_imp.g_varchar2_table(34883) := '61726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E6529223A224E616D65206465722050726F7A6573737661726961626C6520286465732054797073205C5C225A6569747374656D70656C206D6974205A';
wwv_flow_imp.g_varchar2_table(34884) := '6569747A6F6E655C5C2229222C224E616D65206F66207468652050726F63657373205661726961626C65223A224E616D65206465722050726F7A6573737661726961626C65222C224E616D65206F6620746865207661726961626C6520746F2072657475';
wwv_flow_imp.g_varchar2_table(34885) := '726E2074686520617070726F76616C20726573756C7420696E746F223A224E616D6520646572205661726961626C656E2C20696E20646965206461732047656E65686D6967756E677365726765626E6973207A7572C3BC636B6765676562656E20776972';
wwv_flow_imp.g_varchar2_table(34886) := '64222C224E616D65223A224E616D65222C224E616D65642076657273696F6E223A2242656E616E6E74652056657273696F6E222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A226B65696E2072';
wwv_flow_imp.g_varchar2_table(34887) := '65666572656E7A6965727465732042504D4E2D456C656D656E74207B656C656D656E747D222C226E6F206469616772616D20746F20646973706C6179223A226B65696E204469616772616D6D20616E7A656967626172222C226E6F20706172656E742066';
wwv_flow_imp.g_varchar2_table(34888) := '6F72207B656C656D656E747D20696E207B706172656E747D223A226B65696E20C3BC62657267656F72646E6574657320456C656D656E742066C3BC72207B656C656D656E747D20696E207B706172656E747D222C226E6F20706C616E6520666F72207B65';
wwv_flow_imp.g_varchar2_table(34889) := '6C656D656E747D223A226B65696E65204562656E652066C3BC72207B656C656D656E747D222C226E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A226B65696E2050726F7A6573732F4B6F6C6C61626F';
wwv_flow_imp.g_varchar2_table(34890) := '726174696F6E222C226E6F207368617065207479706520737065636966696564223A226B65696E20466F726D2D54797020616E6765676562656E222C224E756D626572223A225A61686C222C224F6E204576656E74223A224265692045726569676E6973';
wwv_flow_imp.g_varchar2_table(34891) := '222C224F7261636C65205363686564756C652065787072657373696F6E223A224F7261636C65205363686564756C652D417573647275636B222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A';
wwv_flow_imp.g_varchar2_table(34892) := '226175C39F657268616C6220646572204772656E7A656E222C224F7574205661726961626C6573223A224F75742D5661726961626C65222C224F757470757420436F6C6C656374696F6E223A22417573676162652D53616D6D6C756E67222C224F757470';
wwv_flow_imp.g_varchar2_table(34893) := '757420456C656D656E74223A2241757367616265656C656D656E74222C224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A225374616E64617264776572742D53657420696E2041';
wwv_flow_imp.g_varchar2_table(34894) := '7566676162656E646566696E6974696F6E20C3BC62657273636872656962656E222C2250616765204944223A2253656974656E2D4944222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C6174652072656665';
wwv_flow_imp.g_varchar2_table(34895) := '72656E6365223A2253656974656E656C656D656E742C206461732064696520466F726D756C6172766F726C6167656E7265666572656E7A20656E7468C3A46C74222C2250616765204974656D73223A2253656974656E656C656D656E7465222C22506167';
wwv_flow_imp.g_varchar2_table(34896) := '65223A225365697465222C22506172616C6C656C2067617465776179223A22506172616C6C656C65732047617465776179222C22506172616C6C656C2047617465776179223A22506172616C6C656C65732047617465776179222C22506172616C6C656C';
wwv_flow_imp.g_varchar2_table(34897) := '206D756C74692D696E7374616E6365223A22506172616C6C656C65204D756C74692D496E7374616E7A222C225061727469636970616E74204944223A225465696C6E65686D65722D4944222C225061727469636970616E74206D756C7469706C69636974';
wwv_flow_imp.g_varchar2_table(34898) := '79223A224D756C7469706C697A6974C3A47420646572205465696C6E65686D6572222C225061727469636970616E74204E616D65223A225465696C6E65686D65726E616D65222C225061727469636970616E74223A225465696C6E65686D6572222C2250';
wwv_flow_imp.g_varchar2_table(34899) := '61796C6F6164205661726961626C65223A225061796C6F61642D5661726961626C65222C225061796C6F6164223A225061796C6F6164222C22504C2F53514C20436F6465223A22504C2F53514C20436F6465222C22504C2F53514C204578707265737369';
wwv_flow_imp.g_varchar2_table(34900) := '6F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A22504C2F53514C2D417573647275636B20676962742065696E656E20626F6F6C65736368656E2057657274207A7572C3BC636B222C22504C2F53514C2045787072657373696F';
wwv_flow_imp.g_varchar2_table(34901) := '6E2072657475726E696E67206120646174652076616C7565223A22504C2F53514C2D417573647275636B20676962742065696E656E20446174756D7377657274207A7572C3BC636B222C22504C2F53514C2045787072657373696F6E2072657475726E69';
wwv_flow_imp.g_varchar2_table(34902) := '6E672061206E756D6265722076616C7565223A22504C2F53514C2D417573647275636B20676962742065696E656E205A61686C656E77657274207A7572C3BC636B222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061205469';
wwv_flow_imp.g_varchar2_table(34903) := '6D657374616D7020776974682054696D65205A6F6E652076616C7565223A22504C2F53514C2D417573647275636B20676962742065696E656E205A6569747374656D70656C206D6974205A6569747A6F6E656E77657274207A7572C3BC636B222C22504C';
wwv_flow_imp.g_varchar2_table(34904) := '2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22504C2F53514C2D417573647275636B20676962';
wwv_flow_imp.g_varchar2_table(34905) := '742065696E656E2076617263686172322D5765727420696D20466F726D6174204A4A4A4A2D4D4D2D545420484832343A4D493A535320545A52207A7572C3BC636B222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061207661';
wwv_flow_imp.g_varchar2_table(34906) := '7263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22504C2F53514C2D417573647275636B20676962742065696E656E2076617263686172322D5765727420696D20466F726D6174204A4A';
wwv_flow_imp.g_varchar2_table(34907) := '4A4A2D4D4D2D545420484832343A4D493A5353207A7572C3BC636B222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22504C2F53514C';
wwv_flow_imp.g_varchar2_table(34908) := '2D417573647275636B20676962742065696E656E2076617263686172322D5765727420696D205A61686C656E666F726D6174207A7572C3BC636B222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120766172636861723220';
wwv_flow_imp.g_varchar2_table(34909) := '76616C7565223A22504C2F53514C2D417573647275636B20676962742065696E656E2076617263686172322D57657274207A7572C3BC636B222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D657374616D7020776974';
wwv_flow_imp.g_varchar2_table(34910) := '682054696D65205A6F6E65223A22504C2F53514C2D417573647275636B2067696274205A6569747374656D70656C206D6974205A6569747A6F6E65207A7572C3BC636B222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67';
wwv_flow_imp.g_varchar2_table(34911) := '206120626F6F6C65616E2076616C7565223A22504C2F53514C2D46756E6B74696F6E73626F64792C206465722065696E656E20626F6F6C65736368656E2057657274207A7572C3BC636B67696274222C22504C2F53514C2046756E6374696F6E20426F64';
wwv_flow_imp.g_varchar2_table(34912) := '792072657475726E696E67206120646174652076616C7565223A22504C2F53514C2D46756E6B74696F6E73626F647920676962742065696E656E20446174756D7377657274207A7572C3BC636B222C22504C2F53514C2046756E6374696F6E20426F6479';
wwv_flow_imp.g_varchar2_table(34913) := '2072657475726E696E672061206E756D6265722076616C7565223A22504C2F53514C2D46756E6B74696F6E732D426F647920676962742065696E656E205A61686C656E77657274207A7572C3BC636B222C22504C2F53514C2046756E6374696F6E20426F';
wwv_flow_imp.g_varchar2_table(34914) := '64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22504C2F53514C2D46756E6B74696F6E73626F647920676962742065696E656E205A6569747374656D70656C206D6974205A656974';
wwv_flow_imp.g_varchar2_table(34915) := '7A6F6E656E77657274207A7572C3BC636B222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320';
wwv_flow_imp.g_varchar2_table(34916) := '545A52223A22504C2F53514C2D46756E6B74696F6E73626F647920676962742065696E656E2076617263686172322D5765727420696D20466F726D6174204A4A4A2D4D4D2D545420484832343A4D493A535320545A52207A7572C3BC636B222C22504C2F';
wwv_flow_imp.g_varchar2_table(34917) := '53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22504C2F53514C2D46756E6B74696F6E73626F647920';
wwv_flow_imp.g_varchar2_table(34918) := '676962742065696E656E2076617263686172322D5765727420696D20466F726D6174204A4A4A2D4D4D2D545420484832343A4D493A5353207A7572C3BC636B222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076';
wwv_flow_imp.g_varchar2_table(34919) := '617263686172322076616C756520696E206E756D62657220666F726D6174223A22504C2F53514C2D46756E6B74696F6E73626F647920676962742065696E656E2076617263686172322D5765727420696D205A61686C656E666F726D6174207A7572C3BC';
wwv_flow_imp.g_varchar2_table(34920) := '636B222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565223A22504C2F53514C2D46756E6B74696F6E73626F647920676962742065696E656E2076617263686172322D57657274';
wwv_flow_imp.g_varchar2_table(34921) := '207A7572C3BC636B222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22504C2F53514C2D46756E6B74696F6E73626F64792067696274205A65697473';
wwv_flow_imp.g_varchar2_table(34922) := '74656D70656C206D6974205A6569747A6F6E656E77657274207A7572C3BC636B222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A22506C61747A68616C746572222C22506F74656E7469616C2047726F757073223A22';
wwv_flow_imp.g_varchar2_table(34923) := '506F74656E7A69656C6C65204772757070656E222C22506F74656E7469616C205374617274657273223A22506F74656E7A69656C6C652053746172746572222C22506F74656E7469616C205374617274696E672047726F757073223A22506F74656E7A69';
wwv_flow_imp.g_varchar2_table(34924) := '656C6C652053746172746772757070656E222C22506F74656E7469616C205374617274696E67205573657273223A22506F74656E7A69656C6C6520537461727462656E75747A6572222C22506F74656E7469616C205573657273223A22506F74656E7A69';
wwv_flow_imp.g_varchar2_table(34925) := '656C6C652042656E75747A6572222C225072696F72697479223A225072696F726974C3A474222C2250726F6365737320646F63756D656E746174696F6E223A2250726F7A657373646F6B756D656E746174696F6E222C2250726F6365737320686173206D';
wwv_flow_imp.g_varchar2_table(34926) := '756C7469706C6520626C616E6B207374617274206576656E7473223A2250726F7A6573732062657369747A74206D656872657265206C6565726520537461727465726569676E69737365222C2250726F63657373204944223A2250726F7A6573732D4944';
wwv_flow_imp.g_varchar2_table(34927) := '222C2250726F63657373206973206D697373696E6720656E64206576656E74223A2250726F7A657373206665686C7420456E6465726569676E6973222C2250726F63657373206973206D697373696E67207374617274206576656E74223A225374617274';
wwv_flow_imp.g_varchar2_table(34928) := '65726569676E697320696E2050726F7A657373206665686C74222C2250726F63657373206E616D65223A2250726F7A6573736E616D65222C2250726F63657373205072696F72697479223A2250726F7A6573737072696F726974C3A474222C2250726F63';
wwv_flow_imp.g_varchar2_table(34929) := '65737320737461747573206166746572207465726D696E6174696F6E223A22566572617262656974756E6773737461747573206E616368204265656E646967756E67222C2250726F63657373205661726961626C652028417272617929223A2250726F7A';
wwv_flow_imp.g_varchar2_table(34930) := '6573737661726961626C652028417272617929222C2250726F63657373205661726961626C6520284C69737429223A2250726F7A6573737661726961626C6520284C6973746529222C2250726F63657373205661726961626C65223A2250726F7A657373';
wwv_flow_imp.g_varchar2_table(34931) := '7661726961626C65222C2250726F63657373223A2250726F7A657373222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A2257657274652066C3BC7220456D61696C2D566F726C616765222C22526563656976';
wwv_flow_imp.g_varchar2_table(34932) := '65205461736B223A224175666761626520657268616C74656E222C2252656365697665207461736B223A22456D7066616E67656E2041756667616265222C225265646F223A22576965646572686F6C656E222C2252656D6F7665223A22456E746665726E';
wwv_flow_imp.g_varchar2_table(34933) := '656E222C225265706C7920546F223A22416E74776F727420616E222C22526571756573742056616C756520666F7220506167652043616C6C223A22416E666F72646572756E67732D576572742066C3BC722053656974656E617566727566222C22526571';
wwv_flow_imp.g_varchar2_table(34934) := '75657374223A22416E6672616765222C22526573756C74205661726961626C65223A2245726765626E69737661726961626C65222C2252657475726E205061796C6F616420496E746F223A225061796C6F6164207A7572C3BC636B676562656E20696E22';
wwv_flow_imp.g_varchar2_table(34935) := '2C22526F6C65223A22526F6C6C65222C2253617665223A2253706569636865726E222C225363686564756C65722045787072657373696F6E223A225363686564756C65722D417573647275636B222C225363686564756C696E67223A22506C616E756E67';
wwv_flow_imp.g_varchar2_table(34936) := '222C22536372697074207461736B223A225363726970742041756667616265222C22536372697074205461736B223A22536B726970742D41756667616265222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65';
wwv_flow_imp.g_varchar2_table(34937) := '223A224175737761686C206F6220646965736573204469616772616D6D20737461727462617220697374222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976';
wwv_flow_imp.g_varchar2_table(34938) := '697479223A2257C3A4686C656E20536965206469657365204F7074696F6E2C2077656E6E20646965736573204469616772616D6D20696E2065696E657220417566727566616B7469766974C3A474206175666765727566656E2077657264656E20736F6C';
wwv_flow_imp.g_varchar2_table(34939) := '6C222C2253656E6420456D61696C20496D6D6564696174656C79223A22456D61696C20736F666F72742073656E64656E222C2253656E64204D61696C223A22456D61696C2073656E64656E222C2253656E64207461736B223A2241756667616265207365';
wwv_flow_imp.g_varchar2_table(34940) := '6E64656E222C2253656E64205461736B223A22417566676162652073656E64656E222C2253657175656E636520666C6F77223A2253657175656E7A666C757373222C2253657175656E6365223A2253657175656E7A222C2253657175656E6365466C6F77';
wwv_flow_imp.g_varchar2_table(34941) := '2069732061206475706C6963617465223A2253657175656E7A666C757373206973742065696E204475706C696B6174222C2253657175656E7469616C206D756C74692D696E7374616E6365223A2253657175656E7A69656C6C65204D756C74692D496E73';
wwv_flow_imp.g_varchar2_table(34942) := '74616E7A222C2253657276696365207461736B223A22536572766963652041756667616265222C2253657276696365205461736B223A22536572766963652D41756667616265222C2253657420636F6C6F72223A22466172626520666573746C6567656E';
wwv_flow_imp.g_varchar2_table(34943) := '222C225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22416E67656865667465746573205369676E616C2D5A7769736368656E65726569676E697320286E6963687420756E7465726272656368';
wwv_flow_imp.g_varchar2_table(34944) := '656E6429222C225369676E616C20626F756E64617279206576656E74223A22416E67656865667465746573205369676E616C2D5A7769736368656E65726569676E6973222C225369676E616C20656E64206576656E74223A225369676E616C2D456E6465';
wwv_flow_imp.g_varchar2_table(34945) := '726569676E6973222C225369676E616C20456E64204576656E74223A225369676E616C2D456E6465726569676E6973222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A2245696E74726574656E64657320536967';
wwv_flow_imp.g_varchar2_table(34946) := '6E616C2D5A7769736368656E65726569676E6973222C225369676E616C20496E7465726D656469617465204361746368204576656E74223A2245696E74726574656E646573205369676E616C2D5A7769736368656E65726569676E6973222C225369676E';
wwv_flow_imp.g_varchar2_table(34947) := '616C20696E7465726D656469617465207468726F77206576656E74223A2241757367656CC3B673746573205369676E616C2D5A7769736368656E65726569676E6973222C225369676E616C20496E7465726D656469617465205468726F77204576656E74';
wwv_flow_imp.g_varchar2_table(34948) := '223A2241757367656CC3B673746573205369676E616C2D5A7769736368656E65726569676E6973222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A225369676E616C2D537461727465726569676E';
wwv_flow_imp.g_varchar2_table(34949) := '697320286E6963687420756E7465726272656368656E6429222C225369676E616C207374617274206576656E74223A225369676E616C2D537461727465726569676E6973222C225369676E616C205374617274204576656E74223A225369676E616C2D53';
wwv_flow_imp.g_varchar2_table(34950) := '7461727465726569676E6973222C225369676E616C223A225369676E616C222C2253696D706C65204D657373616765223A2245696E6661636865204E6163687269636874222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69';
wwv_flow_imp.g_varchar2_table(34951) := '737429223A2253514C20416266726167652028446F7070656C70756E6B742067657472656E6E7465204C6973746529222C2253514C20717565727920284A534F4E20617272617929223A2253514C2D4162667261676520284A534F4E2D41727261792922';
wwv_flow_imp.g_varchar2_table(34952) := '2C2253514C207175657279202873696E676C652076616C756529223A2253514C2041626672616765202845696E7A656C7765727429222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A';
wwv_flow_imp.g_varchar2_table(34953) := '2253514C20416266726167652072657475726E6965727420446F7070656C70756E6B742067657472656E6E7465204C69737465222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A2253514C2D41626672616765';
wwv_flow_imp.g_varchar2_table(34954) := '2C206469652065696E204A534F4E2D4172726179207A7572C3BC636B67696274222C2253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C7565223A2253514C2D4162667261676520676962742065696E656E20';
wwv_flow_imp.g_varchar2_table(34955) := '65696E7A656C6E656E20446174756D7377657274207A7572C3BC636B222C2253514C2071756572792072657475726E696E6720612073696E676C65206E756D6265722076616C7565223A2253514C2D4162667261676520676962742065696E656E206569';
wwv_flow_imp.g_varchar2_table(34956) := '6E7A656C6E656E205A61686C656E77657274207A7572C3BC636B222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2253514C2D4162667261';
wwv_flow_imp.g_varchar2_table(34957) := '676520676962742065696E656E2065696E7A656C6E656E205A6569747374656D70656C206D6974205A6569747A6F6E656E77657274207A7572C3BC636B222C2253514C2071756572792072657475726E696E6720612073696E676C652076617263686172';
wwv_flow_imp.g_varchar2_table(34958) := '322076616C7565223A2253514C2D4162667261676520676962742065696E656E2065696E7A656C6E656E2076617263686172322D57657274207A7572C3BC636B222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974';
wwv_flow_imp.g_varchar2_table(34959) := '682054696D65205A6F6E65223A2253514C2D416266726167652067696274205A6569747374656D70656C206D6974205A6569747A6F6E656E77657274207A7572C3BC636B222C2253514C20717565727920746F20676574206174746163686D656E74223A';
wwv_flow_imp.g_varchar2_table(34960) := '2253514C20416266726167652066C3BC72206C6164656E2064657320416E68616E6773222C2253514C207175657279223A2253514C2D41626672616765222C2253514C205175657279223A2253514C2D41626672616765222C225374617274206576656E';
wwv_flow_imp.g_varchar2_table(34961) := '74206973206D697373696E67206576656E7420646566696E6974696F6E223A22537461727465726569676E6973206665686C742045726569676E6973646566696E6974696F6E222C225374617274206576656E74206D75737420626520626C616E6B223A';
wwv_flow_imp.g_varchar2_table(34962) := '22537461727465726569676E6973206D757373206C656572207365696E222C225374617274204576656E74223A2253746172742D4576656E74222C225374617274206576656E74223A22537461727465726569676E6973222C2253746174696320646174';
wwv_flow_imp.g_varchar2_table(34963) := '652076616C7565223A225374617469736368657220446174756D7377657274222C22537461746963204944223A22537461746973636865204944222C22537461746963206E756D6265722076616C7565223A2253746174697363686572205A61686C656E';
wwv_flow_imp.g_varchar2_table(34964) := '77657274222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2253746174697363686572205A6569747374656D70656C206D6974205A6569747A6F6E656E77657274222C2253746174696320766172';
wwv_flow_imp.g_varchar2_table(34965) := '63686172322076616C7565223A22537461746973636865722076617263686172322D57657274222C22537461746963223A225374617469736368222C22537472696E67223A225A65696368656E666F6C6765222C225375622070726F6365737320686173';
wwv_flow_imp.g_varchar2_table(34966) := '206D756C7469706C6520626C616E6B207374617274206576656E7473223A225465696C2D50726F7A6573732062657369747A74206D656872657265206C6565726520537461727465726569676E69737365222C225375622070726F63657373206973206D';
wwv_flow_imp.g_varchar2_table(34967) := '697373696E6720656E64206576656E74223A225465696C2D50726F7A657373206665686C7420456E6465726569676E6973222C225375622070726F63657373206973206D697373696E67207374617274206576656E74223A22537461727465726569676E';
wwv_flow_imp.g_varchar2_table(34968) := '697320696E205465696C2D50726F7A657373206665686C74222C225375622D70726F636573732028636F6C6C617073656429223A225A7567656B6C6170707465722050726F7A657373222C225375622D70726F636573732028657870616E64656429223A';
wwv_flow_imp.g_varchar2_table(34969) := '225465696C70726F7A657373202861756667656B6C6170707429222C225375622D70726F63657373223A225465696C70726F7A657373222C225375626A656374223A2242657472656666222C225461736B20446566696E6974696F6E223A224175666761';
wwv_flow_imp.g_varchar2_table(34970) := '62656E646566696E6974696F6E222C225461736B20537461746963204944223A2253746174697363686520417566676162656E2D4944222C225461736B2054797065223A22417566676162656E747970222C225461736B223A2241756667616265222C22';
wwv_flow_imp.g_varchar2_table(34971) := '54656D706C617465204944223A22566F726C6167656E2D4944222C2254656D706C617465223A22566F726C616765222C225465726D696E61746520656E64206576656E74223A225465726D696E696572756E67732D456E6465726569676E6973222C2254';
wwv_flow_imp.g_varchar2_table(34972) := '65726D696E61746520456E64204576656E74223A225465726D696E696572756E67732D456E6465726569676E6973222C225465726D696E61746564223A224265656E646574222C2254657874223A2254657874222C2254696D6520756E74696C20746865';
wwv_flow_imp.g_varchar2_table(34973) := '2074696D657220666972657320616761696E223A225A65697420626973207A756D206EC3A463687374656E204175736CC3B673656E206465732054696D657273222C2254696D6520756E74696C207468652074696D657220666972657320666972737422';
wwv_flow_imp.g_varchar2_table(34974) := '3A225A65697420626973207A756D2065727374656E204175736CC3B673656E206465732054696D657273222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22416E6765686566746574657320';
wwv_flow_imp.g_varchar2_table(34975) := '5A6569742D5A7769736368656E65726569676E697320286E6963687420756E7465726272656368656E6429222C2254696D657220626F756E64617279206576656E74223A22416E67656865667465746573205A6569742D5A7769736368656E6572656967';
wwv_flow_imp.g_varchar2_table(34976) := '6E6973222C2254696D657220446566696E6974696F6E2054797065223A2254696D657220446566696E6974696F6E73747970222C2254696D657220446566696E6974696F6E223A2254696D6572646566696E6974696F6E222C2254696D65722044757261';
wwv_flow_imp.g_varchar2_table(34977) := '74696F6E223A2254696D65722D4461756572222C2254696D657220496E7465726D656469617465204361746368204576656E74223A2245696E74726574656E6465732054696D65722D5A7769736368656E65726569676E6973222C2254696D657220696E';
wwv_flow_imp.g_varchar2_table(34978) := '7465726D656469617465206361746368206576656E74223A2245696E74726574656E646573205A6569742D5A7769736368656E65726569676E6973222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A';
wwv_flow_imp.g_varchar2_table(34979) := '225A6569742D537461727465726569676E697320286E6963687420756E7465726272656368656E6429222C2254696D6572205374617274204576656E74223A2254696D657220537461727465726569676E6973222C2254696D6572207374617274206576';
wwv_flow_imp.g_varchar2_table(34980) := '656E74223A225A6569742D537461727465726569676E6973222C2254696D6572223A2254696D6572222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D6174223A225A';
wwv_flow_imp.g_varchar2_table(34981) := '6569747374656D70656C206D6974205A6569747A6F6E6520696D2049534F20383630312D206F646572204F7261636C652D466F726D6174222C2254696D657374616D7020776974682054696D65205A6F6E65223A225A6569747374656D70656C206D6974';
wwv_flow_imp.g_varchar2_table(34982) := '205A6569747A6F6E65222C22546F223A22416E222C22546F67676C65206E6F6E2D696E74657272757074696E67223A224E6963687420756E7465726272656368656E6420756D736368616C74656E222C225472616E73616374696F6E223A225472616E73';
wwv_flow_imp.g_varchar2_table(34983) := '616B74696F6E222C22556E646F223A2252C3BC636B67C3A46E676967222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A22756E62656B616E6E746573204449207B64697D2066C3BC7220456C65';
wwv_flow_imp.g_varchar2_table(34984) := '6D656E74207B73656D616E7469637D222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A226E696368742065726B616E6E74657320466C6F772D456C65';
wwv_flow_imp.g_varchar2_table(34985) := '6D656E74207B656C656D656E747D20696D204B6F6E74657874207B636F6E746578747D222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A226E6963687420756E74';
wwv_flow_imp.g_varchar2_table(34986) := '65727374C3BC747A7465732042504D4E2D456C656D656E742066C3BC72207B706C616E657D3A207B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A2256657277656E64652041504558204D657461646174656E22';
wwv_flow_imp.g_varchar2_table(34987) := '2C225573652054656D706C617465223A22566F726C6167652076657277656E64656E222C2255736564206469616772616D2076657273696F6E223A2242656E75747A7465204469616772616D6D76657273696F6E222C2255736572205461736B223A2241';
wwv_flow_imp.g_varchar2_table(34988) := '6E77656E6465722D41756667616265222C2255736572207461736B223A2242656E75747A65722041756667616265222C2256616C7565223A2257657274222C225661726368617232223A225661726368617232222C225661726961626C65204578707265';
wwv_flow_imp.g_varchar2_table(34989) := '7373696F6E73223A225661726961626C656E6175736472C3BC636B65222C2256657273696F6E204E616D65223A2256657273696F6E736E616D65222C2256657273696F6E696E67223A2256657273696F6E696572756E67222C225761697420666F722063';
wwv_flow_imp.g_varchar2_table(34990) := '6F6D706C6574696F6E223A224175662041627363686C7573732077617274656E222C225A6F6F6D20496E223A225665726772C3B6C39F65726E222C225A6F6F6D204F7574223A225665726B6C65696E65726E227D27297D2C343431323A653D3E7B227573';
wwv_flow_imp.g_varchar2_table(34991) := '6520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D204572726F72732C207B7761726E696E67737D205761726E696E6773223A227B6572726F72737D206572726F7265732C207B7761726E696E6773';
wwv_flow_imp.g_varchar2_table(34992) := '7D20616476657274656E63696173222C227B73656D616E7469637D237B736964657D20526566206E6F7420737065636966696564223A227B73656D616E7469637D237B736964657D20526566206E6F206573706563696669636164222C223C6E6F6E653E';
wwv_flow_imp.g_varchar2_table(34993) := '223A223C6E6F6E653E222C22312D557267656E74223A2231202D20557267656E7465222C22322D48696768223A2232202D20416C7461222C22332D4D656469756D223A2233202D204D65646961222C22342D4C6F77223A2234202D2042616A61222C2235';
wwv_flow_imp.g_varchar2_table(34994) := '2D4C6F77657374223A2235202D204DC3A1732062616A6F222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073706C6974206174207468652073616D652074696D65223A22556E2067617465776179206E6F2064656265';
wwv_flow_imp.g_varchar2_table(34995) := '20667573696F6E61727365206E692064697669646972736520616C206D69736D6F207469656D706F222C224163746976617465206372656174652F72656D6F766520737061636520746F6F6C223A2241637469766172206C612068657272616D69656E74';
wwv_flow_imp.g_varchar2_table(34996) := '61206465206372656172202F20656C696D696E6172206573706163696F222C22416374697661746520676C6F62616C20636F6E6E65637420746F6F6C223A2241637469766172206C612068657272616D69656E746120646520636F6E657869C3B36E2067';
wwv_flow_imp.g_varchar2_table(34997) := '6C6F62616C222C2241637469766174652068616E6420746F6F6C223A2241637469766172206C612068657272616D69656E7461206465206D616E6F222C224163746976617465206C6173736F20746F6F6C223A2241637469766172206C61206865727261';
wwv_flow_imp.g_varchar2_table(34998) := '6D69656E7461204C617A6F222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A2241637469766172206C612068657272616D69656E746120646520637265616369C3B36E2F656C696D696E616369C3';
wwv_flow_imp.g_varchar2_table(34999) := 'B36E206465206573706163696F222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A2241637469766172206C612068657272616D69656E746120646520636F6E657869C3B36E20676C6F62616C222C2241637469';
wwv_flow_imp.g_varchar2_table(35000) := '76617465207468652068616E6420746F6F6C223A2241637469766172206C612068657272616D69656E7461206D616E75616C222C22416374697661746520746865206C6173736F20746F6F6C223A2241637469766172206C612068657272616D69656E74';
wwv_flow_imp.g_varchar2_table(35001) := '61206C6173736F222C224163746976697479207265666572656E6365223A225265666572656E63696120646520616374697669646164222C2241642D686F63223A22416420686F63222C22416464206C616E652061626F7665223A2241C3B16164697220';
wwv_flow_imp.g_varchar2_table(35002) := '63617272696C20617272696261222C22416464206C616E652062656C6F77223A22416772656761722063617272696C20646562616A6F222C22416464207465787420616E6E6F746174696F6E223A224167726567617220616E6F74616369C3B36E206465';
wwv_flow_imp.g_varchar2_table(35003) := '20746578746F222C224166746572204D65726765223A224465737075C3A9732064652066757369C3B36E222C224166746572205461736B223A224465737075C3A973206465207461726561222C22416C69676E20656C656D656E747320626F74746F6D22';
wwv_flow_imp.g_varchar2_table(35004) := '3A22416C696E65617220656C656D656E746F7320656E206C6120706172746520696E666572696F72222C22416C69676E20656C656D656E74732063656E746572223A22416C696E6561722063656E74726F20646520656C656D656E746F73222C22416C69';
wwv_flow_imp.g_varchar2_table(35005) := '676E20656C656D656E7473206C656674223A22416C696E65617220656C656D656E746F732061206C6120697A71756965726461222C22416C69676E20656C656D656E7473206D6964646C65223A22416C696E65617220656C656D656E746F7320656E2065';
wwv_flow_imp.g_varchar2_table(35006) := '6C206D6564696F222C22416C69676E20656C656D656E7473207269676874223A22416C696E65617220656C656D656E746F732061206C612064657265636861222C22416C69676E20656C656D656E747320746F70223A22416C696E65617220656C656D65';
wwv_flow_imp.g_varchar2_table(35007) := '6E746F7320617272696261222C22416C69676E20656C656D656E7473223A22416C696E65617220656C656D656E746F73222C22416C6C6F772042696E64696E67223A225065726D6974697220656E6C616365222C22616C72656164792072656E64657265';
wwv_flow_imp.g_varchar2_table(35008) := '64207B656C656D656E747D223A22796120736520686120726570726573656E7461646F207B656C656D656E747D222C224150455820417070726F76616C223A224170726F62616369C3B36E2064652041504558222C22415045582050616765223A2250C3';
wwv_flow_imp.g_varchar2_table(35009) := 'A167696E612041504558222C224150455820526F6C65223A22526F6C2064652041504558222C22415045582053696D706C6520466F726D223A22466F726D756C6172696F2073696D706C652064652041504558222C22417070656E6420636F6D70656E73';
wwv_flow_imp.g_varchar2_table(35010) := '6174696F6E206163746976697479223A22416772656761722061637469766964616420646520636F6D70656E73616369C3B36E222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22';
wwv_flow_imp.g_varchar2_table(35011) := '41677265676172206576656E746F206465206361707475726120696E7465726D6564696F20636F6E646963696F6E616C222C22417070656E6420656E64206576656E74223A2241677265676172206576656E746F2066696E616C222C22417070656E6420';
wwv_flow_imp.g_varchar2_table(35012) := '67617465776179223A224167726567617220636F6D707565727461222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A2241677265676172206576656E746F20696E7465726D6564696F2F6465206CC3AD6D';
wwv_flow_imp.g_varchar2_table(35013) := '697465222C22417070656E64206D65737361676520696E7465726D656469617465206361746368206576656E74223A2241677265676172206576656E746F206465206361707475726120696E7465726D6564696F206465206D656E73616A65222C224170';
wwv_flow_imp.g_varchar2_table(35014) := '70656E642072656365697665207461736B223A22416772656761722074617265612064652072656365706369C3B36E222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A22416772656761722065';
wwv_flow_imp.g_varchar2_table(35015) := '76656E746F206465206361707475726120696E7465726D6564696F206465207365C3B1616C222C22417070656E64207461736B223A2241677265676172207461726561222C22417070656E64207465787420616E6E6F746174696F6E223A224167726567';
wwv_flow_imp.g_varchar2_table(35016) := '617220616E6F74616369C3B36E20646520746578746F222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A2241677265676172206576656E746F206465206361707475726120696E7465726D656469';
wwv_flow_imp.g_varchar2_table(35017) := '6F2064652074656D706F72697A61646F72222C224170706C69636174696F6E204944223A2249442064652061706C6963616369C3B36E222C224170706C69636174696F6E223A2241706C6963616369C3B36E222C2241737369676E6D656E74223A224173';
wwv_flow_imp.g_varchar2_table(35018) := '69676E616369C3B36E222C224174746163686D656E74223A22416E65786F222C224261636B67726F756E64205461736B2053657373696F6E223A2253657369C3B36E20646520746172656120656E20736567756E646F20706C616E6F222C22424343223A';
wwv_flow_imp.g_varchar2_table(35019) := '2243434F222C224265666F7265204576656E74223A22416E7465732064656C206576656E746F222C224265666F72652053706C6974223A22416E74657320646520646976697369C3B36E222C224265666F7265205461736B223A22416E74657320646520';
wwv_flow_imp.g_varchar2_table(35020) := '7461726561222C2242696E642070616765206974656D7320286465707265636174656429223A22456C656D656E746F732064652070C3A167696E6120646520656E6C6163652028656E2064657375736F29222C2242696E6420706172616D657465722076';
wwv_flow_imp.g_varchar2_table(35021) := '616C756573223A2256616C6F72657320646520706172C3A16D6574726F20646520656E6C616365222C2242696E642070726F63657373207661726961626C6573223A225661726961626C65732064652070726F6365736F20646520656E6C616365222C22';
wwv_flow_imp.g_varchar2_table(35022) := '426C696E6420636172626F6E20636F707920726563697069656E74287329223A2244657374696E61746172696F7320636965676F7320646520636F7069617320646520636172626F6E6F222C22426F64792048544D4C223A2248544D4C20646520637565';
wwv_flow_imp.g_varchar2_table(35023) := '72706F222C22426F64792054657874223A22546578746F2064656C2063756572706F222C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F74207375';
wwv_flow_imp.g_varchar2_table(35024) := '70706F72746564223A2241637475616C6D656E7465206E6F20657374C3A16E20736F706F727461646F73206C6F73206576656E746F73206465206CC3AD6D69746520656E206C6F732073756270726F6365736F732064652069746572616369C3B36E222C';
wwv_flow_imp.g_varchar2_table(35025) := '22427573696E657373205265666572656E6365223A225265666572656E636961206465206E65676F63696F222C22427573696E6573732072756C65207461736B223A225461726561206465207265676C61206465206E65676F63696F222C22427573696E';
wwv_flow_imp.g_varchar2_table(35026) := '6573732052756C65205461736B223A225461726561206465207265676C61206465206E65676F63696F222C22627573696E6573735F726566223A22627573696E6573735F726566202846696E20646520637265616369C3B36E29222C2243616C6C206163';
wwv_flow_imp.g_varchar2_table(35027) := '746976697479223A22416374697669646164206465206C6C616D616461222C2243616C6C204163746976697479223A22416374697669646164206465206C6C616D616461222C2243616C6C6564204469616772616D223A224469616772616D61206C6C61';
wwv_flow_imp.g_varchar2_table(35028) := '6D61646F222C2243616E63656C20626F756E64617279206576656E74223A2243616E63656C6172206576656E746F206465206CC3AD6D697465222C2243616E63656C20656E64206576656E74223A2243616E63656C6172206576656E746F2066696E616C';
wwv_flow_imp.g_varchar2_table(35029) := '222C2243616E63656C223A2243616E63656C6172222C22436172626F6E20636F707920726563697069656E74287329223A2244657374696E61746172696F7320646520636F7069617320646520636172626F6E6F222C2243617465676F72792056616C75';
wwv_flow_imp.g_varchar2_table(35030) := '65223A2256616C6F722064652063617465676F72C3AD61222C224343223A224343222C224368616E676520656C656D656E74223A2243616D6269617220656C656D656E746F222C224368616E67652074797065223A225469706F2064652063616D62696F';
wwv_flow_imp.g_varchar2_table(35031) := '222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A22426F727261722076616C6F722064652063616368C3A92070617261206C6C616D6164612064652070C3A167696E61222C22436C656172204361636865223A22';
wwv_flow_imp.g_varchar2_table(35032) := '426F727261722063616368C3A9222C22436C6F62223A22434C4F42222C22436F6465223A2243C3B36469676F222C22436F6C6C61626F726174696F6E223A22436F6C61626F72616369C3B36E222C22436F6C6C617073656420506F6F6C223A2241677275';
wwv_flow_imp.g_varchar2_table(35033) := '70616369C3B36E207265647563696461222C22436F6C6C6170736564205375622050726F63657373223A2253756270726F6365736F20726564756369646F222C22436F6C6C656374696F6E2054797065223A225469706F20646520636F62726F222C2243';
wwv_flow_imp.g_varchar2_table(35034) := '6F6C6C656374696F6E223A225265636F70696C616369C3B36E222C22436F6D70656E7361746520456E64204576656E74223A22436F6D70656E736172206576656E746F2066696E616C222C22436F6D70656E7361746520496E7465726D65646961746520';
wwv_flow_imp.g_varchar2_table(35035) := '5468726F77204576656E74223A22436F6D70656E736172206576656E746F206465206C616E7A616D69656E746F20696E7465726D6564696F222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A224576656E746F206465206C';
wwv_flow_imp.g_varchar2_table(35036) := 'C3AD6D69746520646520636F6D70656E73616369C3B36E222C22436F6D70656E736174696F6E20656E64206576656E74223A224576656E746F2066696E616C20646520636F6D70656E73616369C3B36E222C22436F6D70656E736174696F6E20696E7465';
wwv_flow_imp.g_varchar2_table(35037) := '726D656469617465207468726F77206576656E74223A224576656E746F20696E7465726D6564696F206465206C616E7A616D69656E746F20646520636F6D70656E73616369C3B36E222C22436F6D70656E736174696F6E207374617274206576656E7422';
wwv_flow_imp.g_varchar2_table(35038) := '3A224576656E746F20646520696E6963696F20646520636F6D70656E73616369C3B36E222C22436F6D70656E736174696F6E223A22436F6D70656E73616369C3B36E222C22436F6D706C65746564223A2246696E616C697A61646F222C22436F6D706C65';
wwv_flow_imp.g_varchar2_table(35039) := '74696F6E20436F6E646974696F6E223A22436F6E64696369C3B36E2064652066696E616C697A616369C3B36E222C22436F6D706C65782067617465776179223A22436F6D70756572746120636F6D706C656A61222C22436F6D706C657820476174657761';
wwv_flow_imp.g_varchar2_table(35040) := '79223A224761746577617920436F6D706C656A6F222C22436F6E646974696F6E2054797065223A225469706F20646520636F6E64696369C3B36E222C22436F6E646974696F6E223A22436F6E64696369C3B36E222C22436F6E646974696F6E616C20626F';
wwv_flow_imp.g_varchar2_table(35041) := '756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206CC3AD6D69746520636F6E646963696F6E616C202873696E20696E7465727275706369C3B36E29222C22436F6E646974696F6E616C20626F';
wwv_flow_imp.g_varchar2_table(35042) := '756E64617279206576656E74223A224576656E746F206465206CC3AD6D69746520636F6E646963696F6E616C222C22436F6E646974696F6E616C20666C6F77223A22466C756A6F20636F6E646963696F6E616C222C22436F6E646974696F6E616C20696E';
wwv_flow_imp.g_varchar2_table(35043) := '7465726D656469617465206361746368206576656E74223A224576656E746F206465206361707475726120696E7465726D6564696120636F6E646963696F6E616C222C22436F6E646974696F6E616C20496E7465726D6564696174652043617463682045';
wwv_flow_imp.g_varchar2_table(35044) := '76656E74223A224576656E746F206465206361707475726120696E7465726D6564696F20636F6E646963696F6E616C222C22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E74';
wwv_flow_imp.g_varchar2_table(35045) := '6F20646520696E6963696F20636F6E646963696F6E616C202873696E20696E7465727275706369C3B36E29222C22436F6E646974696F6E616C207374617274206576656E74223A224576656E746F20646520696E6963696F20636F6E646963696F6E616C';
wwv_flow_imp.g_varchar2_table(35046) := '222C22436F6E646974696F6E616C205374617274204576656E74223A224576656E746F20646520696E6963696F20636F6E646963696F6E616C222C22436F6E6E65637420746F206F7468657220656C656D656E74223A22436F6E65637461722061206F74';
wwv_flow_imp.g_varchar2_table(35047) := '726F20656C656D656E746F222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22436F6E6563746172207574696C697A616E646F206C612061736F6369616369C3B36E222C22436F6E6E656374207573696E67206461746120696E';
wwv_flow_imp.g_varchar2_table(35048) := '707574206173736F63696174696F6E223A22436F6E6563746172207573616E646F206C612061736F6369616369C3B36E20646520656E7472616461206465206461746F73222C22436F6E6E656374207573696E672073657175656E63652F6D6573736167';
wwv_flow_imp.g_varchar2_table(35049) := '6520666C6F77206F72206173736F63696174696F6E223A22436F6E6563746172207574696C697A616E646F20666C756A6F2064652073656375656E636961202F206D656E73616A65206F2061736F6369616369C3B36E222C22436F707920627573696E65';
wwv_flow_imp.g_varchar2_table(35050) := '7373207265666572656E6365223A22436F70696172207265666572656E636961206465206E65676F63696F222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D';
wwv_flow_imp.g_varchar2_table(35051) := '656E747D223A22636F7272696769656E646F2062706D6E456C656D656E742066616C74616E746520656E207B706C616E657D2061207B726F6F74456C656D656E747D222C22436F7272656C6174696F6E204B6579223A22436C61766520646520636F7272';
wwv_flow_imp.g_varchar2_table(35052) := '656C616369C3B36E222C22436F7272656C6174696F6E2056616C7565223A2256616C6F7220646520636F7272656C616369C3B36E222C22437265617465207B747970657D223A224372656172207B747970657D222C224372656174652064617461206F62';
wwv_flow_imp.g_varchar2_table(35053) := '6A656374207265666572656E6365223A224372656172207265666572656E636961206465206F626A65746F206465206461746F73222C2243726561746520646174612073746F7265207265666572656E6365223A224372656172207265666572656E6369';
wwv_flow_imp.g_varchar2_table(35054) := '6120646520616C6D6163C3A96E206465206461746F73222C2243726561746520446174614F626A6563745265666572656E6365223A22437265617220446174614F626A6563745265666572656E6365222C22437265617465204461746153746F72655265';
wwv_flow_imp.g_varchar2_table(35055) := '666572656E6365223A224372656172204461746153746F72655265666572656E6365222C2243726561746520656E64206576656E74223A224372656172206576656E746F2066696E616C222C2243726561746520456E644576656E74223A224372656172';
wwv_flow_imp.g_varchar2_table(35056) := '20456E644576656E74222C2243726561746520657870616E646564207375622D70726F63657373223A2243726561722073756270726F6365736F20657870616E6469646F222C2243726561746520657870616E6465642053756250726F63657373223A22';
wwv_flow_imp.g_varchar2_table(35057) := '43726561722053756250726F6365737320616D706C6961646F222C224372656174652067617465776179223A22437265617220636F6D707565727461222C224372656174652047617465776179223A2243726561722067617465776179222C2243726561';
wwv_flow_imp.g_varchar2_table(35058) := '74652067726F7570223A22437265617220677275706F222C224372656174652047726F7570223A22437265617220677275706F222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A22437265617220657665';
wwv_flow_imp.g_varchar2_table(35059) := '6E746F20696E7465726D6564696F2F6465206CC3AD6D697465222C2243726561746520496E7465726D6564696174652F426F756E64617279204576656E74223A224372656172206576656E746F20696E7465726D6564696F2F6CC3AD6D697465222C2243';
wwv_flow_imp.g_varchar2_table(35060) := '7265617465206E6577202E2E2E223A224372656172206E7565766F2E2E2E222C2243726561746520706F6F6C2F7061727469636970616E74223A2243726561722070697363696E612F7061727469636970616E7465222C2243726561746520506F6F6C2F';
wwv_flow_imp.g_varchar2_table(35061) := '5061727469636970616E74223A22437265617220706F6F6C2F7061727469636970616E7465222C22437265617465207374617274206576656E74223A224372656172206576656E746F20696E696369616C222C224372656174652053746172742054696D';
wwv_flow_imp.g_varchar2_table(35062) := '6572204576656E74223A224372656172206576656E746F2064652074656D706F72697A61646F7220646520696E6963696F222C224372656174652053746172744576656E74223A2243726561722053746172744576656E74222C22437265617465207461';
wwv_flow_imp.g_varchar2_table(35063) := '736B223A224372656172207461726561222C22437265617465205461736B223A224372656172207461726561222C22437573746F6D20457874656E73696F6E223A22457874656E7369C3B36E20706572736F6E616C697A616461222C22437573746F6D22';
wwv_flow_imp.g_varchar2_table(35064) := '3A22506572736F6E616C697A61646F222C224379636C65202849534F203836303129223A224369636C6F202849534F203836303129222C224379636C6520284F7261636C6529223A224369636C6F20284F7261636C6529222C2244617461206F626A6563';
wwv_flow_imp.g_varchar2_table(35065) := '74207265666572656E6365223A225265666572656E636961206465206F626A65746F206465206461746F73222C2244617461204F626A656374205265666572656E6365223A225265666572656E636961206465206F626A65746F206465206461746F7322';
wwv_flow_imp.g_varchar2_table(35066) := '2C22446174612073746F7265207265666572656E6365223A225265666572656E63696120646520616C6D6163C3A96E206465206461746F73222C22446174612053746F7265205265666572656E6365223A225265666572656E63696120646520616C6D61';
wwv_flow_imp.g_varchar2_table(35067) := '63C3A96E206465206461746F73222C22446174612054797065223A225469706F206465206461746F73222C2244617465202849534F203836303129223A224665636861202849534F203836303129222C224461746520284F7261636C6529223A22466563';
wwv_flow_imp.g_varchar2_table(35068) := '686120284F7261636C6529222C224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22466563686120656E20666F726D61746F20414141412D4D4D2D444420484832343A4D493A5353222C22446174652053';
wwv_flow_imp.g_varchar2_table(35069) := '7472696E67223A22436164656E61206465206665636861222C2244617465223A224665636861222C2244656661756C74204170706C69636174696F6E204944223A2249442064652061706C6963616369C3B36E20706F72206465666563746F222C224465';
wwv_flow_imp.g_varchar2_table(35070) := '6661756C74204170706C69636174696F6E223A2241706C6963616369C3B36E20706F72206465666563746F222C2244656661756C7420666C6F77223A22466C756A6F2070726564657465726D696E61646F222C2244656661756C74205061676520494422';
wwv_flow_imp.g_varchar2_table(35071) := '3A2249442064652070C3A167696E6120706F72206465666563746F222C2244656661756C742050616765223A2250C3A167696E6120706F72206465666563746F222C2244656661756C7420557365726E616D65223A224E6F6D6272652064652075737561';
wwv_flow_imp.g_varchar2_table(35072) := '72696F20706F72206465666563746F222C2244656C657465223A2253757072696D6972222C224465736372697074696F6E223A22446573637269706369C3B36E222C2244657461696C73223A22446574616C6C6573222C226469616772616D206E6F7420';
wwv_flow_imp.g_varchar2_table(35073) := '70617274206F662062706D6E3A446566696E6974696F6E73223A22656C206469616772616D61206E6F20666F726D612070617274652064652062706D6E3A446566696E6963696F6E6573222C224469737472696275746520656C656D656E747320686F72';
wwv_flow_imp.g_varchar2_table(35074) := '697A6F6E74616C6C79223A224469737472696275697220656C656D656E746F7320646520666F726D6120686F72697A6F6E74616C222C224469737472696275746520656C656D656E747320766572746963616C6C79223A22446973747269627569722065';
wwv_flow_imp.g_varchar2_table(35075) := '6C656D656E746F7320766572746963616C6D656E7465222C2244697669646520696E746F207468726565206C616E6573223A224469766964697220656E20747265732063617272696C6573222C2244697669646520696E746F2074776F206C616E657322';
wwv_flow_imp.g_varchar2_table(35076) := '3A224469766964697220656E20646F732063617272696C6573222C22446F63756D656E746174696F6E223A22446F63756D656E74616369C3B36E222C22447565204F6E223A2256656E63696D69656E746F222C224475706C696361746520696E636F6D69';
wwv_flow_imp.g_varchar2_table(35077) := '6E672073657175656E636520666C6F7773223A224475706C6963617220666C756A6F732064652073656375656E6369617320656E7472616E746573222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A224475';
wwv_flow_imp.g_varchar2_table(35078) := '706C6963617220666C756A6F732064652073656375656E636961732073616C69656E746573222C224475726174696F6E202849534F203836303129223A22447572616369C3B36E202849534F203836303129222C224475726174696F6E20284F7261636C';
wwv_flow_imp.g_varchar2_table(35079) := '6529223A22447572616369C3B36E20284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C2720666F726D6174223A22447572';
wwv_flow_imp.g_varchar2_table(35080) := '616369C3B36E20656E20666F726D61746F2049534F20383630312075204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C27222C22652E672E2032332D4A554E2D323032372031343A31303A3030223A22706F72';
wwv_flow_imp.g_varchar2_table(35081) := '20656A656D706C6F2C2032332D4A554E2D323032372031343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A22702E20656A2E2044442D4D4F4E2D5959595920484832343A4D493A5353222C22656C656D65';
wwv_flow_imp.g_varchar2_table(35082) := '6E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E223A22656C656D656E746F207B656C656D656E747D20616C207175652068616365207265';
wwv_flow_imp.g_varchar2_table(35083) := '666572656E636961207B7265666572656E6365647D237B70726F70657274797D2061C3BA6E206E6F20646962756A61646F222C22456C656D656E7420646F63756D656E746174696F6E223A22446F63756D656E74616369C3B36E20646520656C656D656E';
wwv_flow_imp.g_varchar2_table(35084) := '746F73222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A22456C20656C656D656E746F207469656E6520756E207469706F206E6F207065726D697469646F203C6270';
wwv_flow_imp.g_varchar2_table(35085) := '6D6E3A436F6D706C6578476174657761793E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E223A22456C20656C656D656E746F206E6F2061646D69746520656C';
wwv_flow_imp.g_varchar2_table(35086) := '207469706F203C62706D6E3A4D65737361676553746172744576656E743E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A22456C20656C656D656E746F206E';
wwv_flow_imp.g_varchar2_table(35087) := '6F2061646D69746520656C207469706F203C62706D6E3A5369676E616C53746172744576656E743E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A';
wwv_flow_imp.g_varchar2_table(35088) := '22456C20656C656D656E746F207469656E6520756E207469706F206E6F207065726D697469646F203C62706D6E436F6E646974696F6E616C53746172744576656E743E222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063';
wwv_flow_imp.g_varchar2_table(35089) := '686172616374657273223A22456C20494420646520656C656D656E746F207469656E65206DC3A1732064652035302063617261637465726573222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A22456C2049442064';
wwv_flow_imp.g_varchar2_table(35090) := '6520656C656D656E746F2061C3BA6E206E6F2073652068612063616D626961646F222C22456C656D656E7420697320616E20696D706C6963697420656E64223A22456C20656C656D656E746F20657320756E2066696E616C20696D706CC3AD6369746F22';
wwv_flow_imp.g_varchar2_table(35091) := '2C22456C656D656E7420697320616E20696D706C69636974207374617274223A22456C20656C656D656E746F20657320756E20696E6963696F20696D706CC3AD6369746F222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65';
wwv_flow_imp.g_varchar2_table(35092) := '223A2246616C74612065746971756574612F6E6F6D62726520656E20656C20656C656D656E746F222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22456C20656C656D656E746F206E6F20657374C3A120636F6E65637461646F22';
wwv_flow_imp.g_varchar2_table(35093) := '2C22656C656D656E74207265717569726564223A22656C656D656E746F2072657175657269646F222C22456D61696C20636F6E74656E74223A22436F6E74656E69646F20646520636F7272656F20656C65637472C3B36E69636F222C22456D61696C206F';
wwv_flow_imp.g_varchar2_table(35094) := '662074686520726563697069656E74287329223A22436F7272656F20656C65637472C3B36E69636F206465206C6F732064657374696E61746172696F73222C22456D61696C206F66207468652073656E646572223A22436F7272656F20656C65637472C3';
wwv_flow_imp.g_varchar2_table(35095) := 'B36E69636F2064656C2072656D6974656E7465222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A22436F7272656F20656C65637472C3B36E69636F20616C2071756520736520646562652065';
wwv_flow_imp.g_varchar2_table(35096) := '6E76696172206C6120726573707565737461222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F76657320636F6E74656E7429223A2250697363696E612F7061727469636970616E746520766163C3AD6F2028656C696D696E61';
wwv_flow_imp.g_varchar2_table(35097) := '20636F6E74656E69646F29222C22456D70747920706F6F6C2F7061727469636970616E74223A2250697363696E612F7061727469636970616E746520766163C3AD6F222C22456E64206576656E74223A224576656E746F2066696E616C222C22456E6420';
wwv_flow_imp.g_varchar2_table(35098) := '4576656E74223A224576656E746F2066696E616C222C22456E64706F696E74223A2250756E746F2066696E616C222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E223A22496E74726F647563697220657874656E7369';
wwv_flow_imp.g_varchar2_table(35099) := '6F6E657320706572736F6E616C697A6164617320636F6D6F204A534F4E222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22496E74726F64757A636120656C2063C3B36469676F20504C2F53514C';
wwv_flow_imp.g_varchar2_table(35100) := '2071756520646573656120656A6563757461722E222C224572726F7220626F756E64617279206576656E74223A224576656E746F206465206CC3AD6D697465206465206572726F72222C224572726F7220456E64204576656E74223A224576656E746F20';
wwv_flow_imp.g_varchar2_table(35101) := '64652066696E616C697A616369C3B36E206465206572726F72222C224572726F7220656E64206576656E74223A224576656E746F2066696E616C206465206572726F72222C224572726F72207374617274206576656E74223A224576656E746F20646520';
wwv_flow_imp.g_varchar2_table(35102) := '696E6963696F206465206572726F72222C224572726F72223A224572726F72222C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206CC3AD6D6974652064';
wwv_flow_imp.g_varchar2_table(35103) := '6520657363616C616461202873696E20696E7465727275706369C3B36E29222C22457363616C6174696F6E20626F756E64617279206576656E74223A224576656E746F206465206CC3AD6D69746520646520657363616C616461222C22457363616C6174';
wwv_flow_imp.g_varchar2_table(35104) := '696F6E20656E64206576656E74223A224576656E746F2066696E616C20646520657363616C616461222C22457363616C6174696F6E20456E64204576656E74223A224576656E746F2066696E616C20646520657363616C616461222C22457363616C6174';
wwv_flow_imp.g_varchar2_table(35105) := '696F6E20496E7465726D656469617465205468726F77204576656E74223A224576656E746F206465206465766F6C756369C3B36E20696E7465726D6564696F20646520657363616C616461222C22457363616C6174696F6E20696E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(35106) := '65207468726F77206576656E74223A224576656E746F20696E7465726D6564696F206465206C616E7A616D69656E746F20646520657363616C616461222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074';
wwv_flow_imp.g_varchar2_table(35107) := '696E6729223A224576656E746F20646520696E6963696F20646520657363616C616461202873696E20696E7465727275706369C3B36E29222C22457363616C6174696F6E207374617274206576656E74223A224576656E746F20646520696E6963696F20';
wwv_flow_imp.g_varchar2_table(35108) := '646520657363616C616461222C22457363616C6174696F6E223A2252656D697369C3B36E20646520696E636964656E63696173222C224576656E742042617365642047617465776179223A22476174657761792062617361646F20656E206576656E746F';
wwv_flow_imp.g_varchar2_table(35109) := '73222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A22456C206576656E746F207469656E652076617269617320646566696E6963696F6E6573206465206576656E746F73222C224576656E74205375';
wwv_flow_imp.g_varchar2_table(35110) := '622050726F63657373223A2253756270726F6365736F206465206576656E746F222C224576656E74207375622D70726F63657373223A2253756270726F6365736F206465206576656E746F222C224576656E742054797065223A225469706F2064652065';
wwv_flow_imp.g_varchar2_table(35111) := '76656E746F222C224576656E742D62617365642067617465776179223A22436F6D7075657274612062617361646120656E206576656E746F73222C224578636C75646564205374617274696E67205573657273223A225573756172696F7320496E696369';
wwv_flow_imp.g_varchar2_table(35112) := '616C6573204578636C7569646F73222C224578636C75646564205573657273223A225573756172696F73206578636C7569646F73222C224578636C75736976652067617465776179223A22436F6D707565727461206578636C7573697661222C22457863';
wwv_flow_imp.g_varchar2_table(35113) := '6C75736976652047617465776179223A2247617465776179204578636C757369766F222C2245786563757461626C65223A22456A6563757461626C65222C224578656375746520504C2F53514C223A22456A65637574617220504C2F53514C222C224578';
wwv_flow_imp.g_varchar2_table(35114) := '65637574696F6E223A22456A6563756369C3B36E222C22457870616E64656420706F6F6C2F7061727469636970616E74223A22477275706F2F7061727469636970616E746520616D706C6961646F222C22457870616E646564205375622050726F636573';
wwv_flow_imp.g_varchar2_table(35115) := '73223A2253756270726F6365736F20616D706C6961646F222C2245787072657373696F6E20284C656761637929223A2245787072657369C3B36E2028686572656461646129222C2245787072657373696F6E2054797065223A225469706F206465206578';
wwv_flow_imp.g_varchar2_table(35116) := '7072657369C3B36E222C2245787072657373696F6E223A2245787072657369C3B36E222C226661696C656420746F20696D706F7274207B656C656D656E747D223A2266616C6C6F20616C20696D706F72746172207B656C656D656E747D222C22666C6F77';
wwv_flow_imp.g_varchar2_table(35117) := '20656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A226C6F7320656C656D656E746F7320646520666C756A6F20646562656E2073657220736563756E646172696F732064652070';
wwv_flow_imp.g_varchar2_table(35118) := '6F6F6C732F7061727469636970616E746573222C22466C6F772073706C69747320696D706C696369746C79223A22456C20666C756A6F2073652064697669646520696D706CC3AD636974616D656E7465222C22466F726D2054656D706C61746520497465';
wwv_flow_imp.g_varchar2_table(35119) := '6D204E616D65223A224E6F6D62726520646520C3AD74656D20646520706C616E74696C6C6120646520666F726D756C6172696F222C22466F726D2054656D706C617465204974656D223A22C38D74656D20646520706C616E74696C6C6120646520666F72';
wwv_flow_imp.g_varchar2_table(35120) := '6D756C6172696F222C22466F726D2054656D706C617465223A22506C616E74696C6C6120646520666F726D756C6172696F222C22466F726D6174204D61736B223A224DC3A1736361726120646520666F726D61746F222C22466F726D61744D61736B223A';
wwv_flow_imp.g_varchar2_table(35121) := '22466F726D61744D61736B222C2246726F6D223A224465736465222C2246756E6374696F6E20426F647920284C656761637929223A2243756572706F206465206C612066756E6369C3B36E2028686572656461646F29222C2246756E6374696F6E20426F';
wwv_flow_imp.g_varchar2_table(35122) := '6479223A2243756572706F2064652066756E6369C3B36E222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A22456C2067617465776179206573';
wwv_flow_imp.g_varchar2_table(35123) := '207375706572666C756F2E20536F6C6F207469656E6520756E206F726967656E207920756E2064657374696E6F2E222C2247656E6572616C223A2247656E6572616C222C2247656E65726174652064656661756C74206974656D73223A2247656E657261';
wwv_flow_imp.g_varchar2_table(35124) := '7220617274C3AD63756C6F7320706F72206465666563746F222C22476C6F62616C206572726F72207265666572656E6365223A225265666572656E636961206465206572726F7220676C6F62616C222C22476C6F62616C20657363616C6174696F6E2072';
wwv_flow_imp.g_varchar2_table(35125) := '65666572656E6365223A225265666572656E63696120646520657363616C61646120676C6F62616C222C22476C6F62616C207369676E616C207265666572656E6365223A225265666572656E636961206465207365C3B1616C20676C6F62616C222C2247';
wwv_flow_imp.g_varchar2_table(35126) := '726F7570223A22477275706F222C2248544D4C2076657273696F6E206F662074686520656D61696C223A225665727369C3B36E2048544D4C2064656C20636F7272656F20656C65637472C3B36E69636F222C224944206D75737420626520756E69717565';
wwv_flow_imp.g_varchar2_table(35127) := '2E223A22456C20494420646562652073657220C3BA6E69636F2E222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A22656E20666F726D61746F204444442048483A4D4D3A5353222C22696E20666F726D617420';
wwv_flow_imp.g_varchar2_table(35128) := '59592D4D4D223A22656E20666F726D61746F2059592D4D4D222C22496E205661726961626C6573223A22456E207661726961626C6573222C22496E2F4F7574204D617070696E67223A22417369676E616369C3B36E20646520656E74726164612F73616C';
wwv_flow_imp.g_varchar2_table(35129) := '696461222C22496E2F4F7574205661726961626C6573223A225661726961626C657320646520456E74726164612F53616C696461222C22496E636C75736976652067617465776179223A22436F6D70756572746120696E636C7573697661222C22496E63';
wwv_flow_imp.g_varchar2_table(35130) := '6F6D696E6720666C6F777320646F206E6F74206A6F696E223A224C6F7320666C756A6F7320656E7472616E746573206E6F20736520756E656E222C22496E69746961746F72206F66207468697320617070726F76616C207461736B223A22496E69636961';
wwv_flow_imp.g_varchar2_table(35131) := '646F722064652065737461207461726561206465206170726F62616369C3B36E222C22496E69746961746F72223A22496E69636961646F72222C22496E70757420436F6C6C656374696F6E223A225265636F70696C616369C3B36E20646520656E747261';
wwv_flow_imp.g_varchar2_table(35132) := '6461222C22496E70757420456C656D656E74223A22456C656D656E746F20646520656E7472616461222C22496E7465726D656469617465205468726F77204576656E74223A224576656E746F206465206465766F6C756369C3B36E20696E7465726D6564';
wwv_flow_imp.g_varchar2_table(35133) := '696F222C22496E7465726D656469617465207468726F77206576656E74223A224576656E746F20696E7465726D6564696F206465206C616E7A616D69656E746F222C22496E74657276616C223A22496E74657276616C6F222C2249732043616C6C61626C';
wwv_flow_imp.g_varchar2_table(35134) := '65223A225065726D697465206C6C616D616461222C22497320526F6C65223A22457320726F6C222C22497320537461727461626C65223A22457320696E69636961626C65222C2249534F223A2249534F222C224974656D204E616D65223A224E6F6D6272';
wwv_flow_imp.g_varchar2_table(35135) := '6520646520617274C3AD63756C6F222C224974656D2056616C7565223A2256616C6F7220646520617274C3AD63756C6F222C224974656D223A22417274C3AD63756C6F222C22497465726174696E672063616C6C20616374697669746573206172652063';
wwv_flow_imp.g_varchar2_table(35136) := '757272656E746C79206E6F7420737570706F72746564223A2241637475616C6D656E7465206E6F20657374C3A120736F706F7274616461206C612069746572616369C3B36E206465206C6173206163746976696461646573206465206C6C616D61646122';
wwv_flow_imp.g_varchar2_table(35137) := '2C224A534F4E204F626A656374223A224F626A65746F204A534F4E222C224C616E65223A224CC3AD6E6561222C224C61746573742076657273696F6E223A22C39A6C74696D61207665727369C3B36E222C224C696E6B20496E7465726D65646961746520';
wwv_flow_imp.g_varchar2_table(35138) := '4361746368204576656E74223A22456E6C617A6172206576656E746F206465206361707475726120696E7465726D6564696F222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A224576656E746F206465206361707475';
wwv_flow_imp.g_varchar2_table(35139) := '726120696E7465726D6564696F20646520656E6C616365222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A22456E6C617A6172206576656E746F206465206465766F6C756369C3B36E20696E7465726D6564696F222C';
wwv_flow_imp.g_varchar2_table(35140) := '224C696E6B20696E7465726D656469617465207468726F77206576656E74223A224576656E746F206465206C616E7A616D69656E746F20696E7465726D6564696F20646520656E6C616365222C224C696E6B223A22456E6C616365222C224C6F61642064';
wwv_flow_imp.g_varchar2_table(35141) := '6566696E6564207661726961626C6573223A22436172676172207661726961626C657320646566696E69646173222C224C6F6164204A534F4E223A22436172676172204A534F4E222C224C6F616420506172616D6574657273223A22506172C3A16D6574';
wwv_flow_imp.g_varchar2_table(35142) := '726F73206465206361726761222C224C6F6F70223A224275636C65222C224D61696C223A22436F7272656F222C224D616E75616C207461736B223A225461726561206D616E75616C222C224D616E75616C205461736B223A225461726561206D616E7561';
wwv_flow_imp.g_varchar2_table(35143) := '6C222C224D61782052756E73223A224DC3A178696D6F20646520656A65637563696F6E6573222C224D65737361676520626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206CC3AD6D6974';
wwv_flow_imp.g_varchar2_table(35144) := '65206465206D656E73616A65202873696E20696E7465727275706369C3B36E29222C224D65737361676520626F756E64617279206576656E74223A224576656E746F206465206CC3AD6D697465206465206D656E73616A65222C224D6573736167652065';
wwv_flow_imp.g_varchar2_table(35145) := '6E64206576656E74223A224576656E746F2066696E616C206465206D656E73616A65222C224D65737361676520456E64204576656E74223A224576656E746F2066696E616C206465206D656E73616A65222C224D65737361676520696E7465726D656469';
wwv_flow_imp.g_varchar2_table(35146) := '617465206361746368206576656E74223A224576656E746F206465206361707475726120696E7465726D65646961206465206D656E73616A65222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A224576656E74';
wwv_flow_imp.g_varchar2_table(35147) := '6F206465206361707475726120696E7465726D6564696F206465206D656E73616A65222C224D65737361676520496E7465726D656469617465205468726F77204576656E74223A224576656E746F206465206465766F6C756369C3B36E20696E7465726D';
wwv_flow_imp.g_varchar2_table(35148) := '6564696F206465206D656E73616A65222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A224576656E746F206465206C616E7A616D69656E746F20696E7465726D6564696F206465206D656E73616A65222C224D';
wwv_flow_imp.g_varchar2_table(35149) := '657373616765204E616D65223A224E6F6D627265206465206D656E73616A65222C224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520696E6963696F206465206D656E7361';
wwv_flow_imp.g_varchar2_table(35150) := '6A65202873696E20696E7465727275706369C3B36E29222C224D657373616765207374617274206576656E74223A224576656E746F20646520696E6963696F206465206D656E73616A65222C224D657373616765205374617274204576656E74223A2245';
wwv_flow_imp.g_varchar2_table(35151) := '76656E746F20646520696E6963696F206465206D656E73616A65222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A2266616C7461207B73656D616E7469637D236174746163686564546F526566222C226D6F72';
wwv_flow_imp.g_varchar2_table(35152) := '65207468616E207B636F756E747D206368696C64206C616E6573223A226DC3A173206465207B636F756E747D206CC3AD6E65617320736563756E646172696173222C224D756C74692D496E7374616E6365223A2256617269617320696E7374616E636961';
wwv_flow_imp.g_varchar2_table(35153) := '73222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A2273652068616E20646566696E69646F20766172696F7320656C656D656E746F732064652044492070617261207B656C656D656E';
wwv_flow_imp.g_varchar2_table(35154) := '747D222C224E616D65206F6620746865206469616772616D223A224E6F6D6272652064656C206469616772616D61222C224E616D65206F66207468652050726F63657373205661726961626C6520286F6620747970652054696D657374616D7020776974';
wwv_flow_imp.g_varchar2_table(35155) := '682054696D65205A6F6E6529223A224E6F6D627265206465206C61207661726961626C652064652070726F6365736F20286465207469706F20526567697374726F20646520686F726120636F6E207A6F6E6120686F726172696129222C224E616D65206F';
wwv_flow_imp.g_varchar2_table(35156) := '66207468652050726F63657373205661726961626C65223A224E6F6D627265206465206C61207661726961626C652064652070726F6365736F222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F';
wwv_flow_imp.g_varchar2_table(35157) := '76616C20726573756C7420696E746F223A224E6F6D627265206465206C61207661726961626C652061206C6120717565206465766F6C76657220656C20726573756C7461646F206465206170726F62616369C3B36E222C224E616D65223A224E6F6D6272';
wwv_flow_imp.g_varchar2_table(35158) := '65222C224E616D65642076657273696F6E223A225665727369C3B36E20636F6E206E6F6D627265222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A226E6F207365206861636520726566657265';
wwv_flow_imp.g_varchar2_table(35159) := '6E63696120612062706D6E456C656D656E7420656E207B656C656D656E747D222C226E6F206469616772616D20746F20646973706C6179223A226E6F20686179206E696E67C3BA6E206469616772616D6120717565206D6F7374726172222C226E6F2070';
wwv_flow_imp.g_varchar2_table(35160) := '6172656E7420666F72207B656C656D656E747D20696E207B706172656E747D223A226E6F20686179206E696E67C3BA6E207072696E636970616C2070617261207B656C656D656E747D20656E207B706172656E747D222C226E6F20706C616E6520666F72';
wwv_flow_imp.g_varchar2_table(35161) := '207B656C656D656E747D223A2273696E20706C616E6F2070617261207B656C656D656E747D222C226E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A226E6F20686179206E696E67C3BA6E2070726F63';
wwv_flow_imp.g_varchar2_table(35162) := '65736F206E6920636F6C61626F72616369C3B36E2070617261206D6F7374726172222C226E6F207368617065207479706520737065636966696564223A226E6F2073652068612065737065636966696361646F206E696E67C3BA6E207469706F20646520';
wwv_flow_imp.g_varchar2_table(35163) := '666F726D61222C224E756D626572223A224EC3BA6D65726F222C224F6E204576656E74223A22456E206576656E746F222C224F7261636C65205363686564756C652065787072657373696F6E223A2245787072657369C3B36E204F7261636C6520536368';
wwv_flow_imp.g_varchar2_table(35164) := '6564756C65222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A226C616E7A616D69656E746F206675657261206465206CC3AD6D69746573222C224F7574205661726961626C6573223A225661';
wwv_flow_imp.g_varchar2_table(35165) := '726961626C65732064652053616C696461222C224F757470757420436F6C6C656374696F6E223A225265636F70696C616369C3B36E2064652073616C696461222C224F757470757420456C656D656E74223A22456C656D656E746F2064652073616C6964';
wwv_flow_imp.g_varchar2_table(35166) := '61222C224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A22536F62726573637269626972206A7565676F2064652076616C6F72657320706F72206465666563746F20656E206465';
wwv_flow_imp.g_varchar2_table(35167) := '66696E696369C3B36E206465207461726561222C2250616765204944223A2249442064652070C3A167696E61222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E6365223A22456C';
wwv_flow_imp.g_varchar2_table(35168) := '656D656E746F2064652070C3A167696E612071756520636F6E7469656E65206C61207265666572656E63696120646520706C616E74696C6C6120646520666F726D756C6172696F222C2250616765204974656D73223A22456C656D656E746F7320646520';
wwv_flow_imp.g_varchar2_table(35169) := '70C3A167696E61222C2250616765223A2250C3A167696E61222C22506172616C6C656C2067617465776179223A22436F6D70756572746120706172616C656C61222C22506172616C6C656C2047617465776179223A224761746577617920706172616C65';
wwv_flow_imp.g_varchar2_table(35170) := '6C6F222C22506172616C6C656C206D756C74692D696E7374616E6365223A22496E7374616E636961206DC3BA6C7469706C6520706172616C656C61222C225061727469636970616E74204944223A224944206465207061727469636970616E7465222C22';
wwv_flow_imp.g_varchar2_table(35171) := '5061727469636970616E74206D756C7469706C6963697479223A224D756C7469706C6963696461642064656C207061727469636970616E7465222C225061727469636970616E74204E616D65223A224E6F6D627265206465207061727469636970616E74';
wwv_flow_imp.g_varchar2_table(35172) := '65222C225061727469636970616E74223A225061727469636970616E7465222C225061796C6F6164205661726961626C65223A225661726961626C6520646520636172676120C3BA74696C222C225061796C6F6164223A22436172676120C3BA74696C22';
wwv_flow_imp.g_varchar2_table(35173) := '2C22504C2F53514C20436F6465223A2243C3B36469676F20504C2F53514C222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A2245787072657369C3B36E20504C2F53514C20717565';
wwv_flow_imp.g_varchar2_table(35174) := '2064657675656C766520756E2076616C6F7220626F6F6C65616E6F222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A2245787072657369C3B36E20504C2F53514C20717565206465767565';
wwv_flow_imp.g_varchar2_table(35175) := '6C766520756E2076616C6F72206465206665636861222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061206E756D6265722076616C7565223A2245787072657369C3B36E20504C2F53514C207175652064657675656C766520';
wwv_flow_imp.g_varchar2_table(35176) := '756E2076616C6F72206E756DC3A97269636F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2245787072657369C3B36E20504C2F5351';
wwv_flow_imp.g_varchar2_table(35177) := '4C207175652064657675656C766520756E20726567697374726F20646520686F726120636F6E20656C2076616C6F72206465207A6F6E6120686F7261726961222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263';
wwv_flow_imp.g_varchar2_table(35178) := '686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A2245787072657369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F7220766172636861723220636F';
wwv_flow_imp.g_varchar2_table(35179) := '6E20656C20666F726D61746F20414141412D4D4D2D444420484832343A4D493A535320545A52222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D61742059595959';
wwv_flow_imp.g_varchar2_table(35180) := '2D4D4D2D444420484832343A4D493A5353223A2245787072657369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F7220766172636861723220636F6E20656C20666F726D61746F20414141412D4D4D2D444420484832343A';
wwv_flow_imp.g_varchar2_table(35181) := '4D493A5353222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A2245787072657369C3B36E20504C2F53514C207175652064657675656C';
wwv_flow_imp.g_varchar2_table(35182) := '766520756E2076616C6F7220766172636861723220656E20666F726D61746F206E756DC3A97269636F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A2245787072657369C3B3';
wwv_flow_imp.g_varchar2_table(35183) := '6E20504C2F53514C207175652064657675656C766520756E2076616C6F72207661726368617232222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22457870';
wwv_flow_imp.g_varchar2_table(35184) := '72657369C3B36E20504C2F53514C207175652064657675656C766520656C20726567697374726F20646520686F726120636F6E206C61207A6F6E6120686F7261726961222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67';
wwv_flow_imp.g_varchar2_table(35185) := '206120626F6F6C65616E2076616C7565223A2243756572706F206465206C612066756E6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F7220626F6F6C65616E6F222C22504C2F53514C2046756E6374696F6E20426F64';
wwv_flow_imp.g_varchar2_table(35186) := '792072657475726E696E67206120646174652076616C7565223A2243756572706F2064652046756E6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F72206465206665636861222C22504C2F53514C2046756E6374696F';
wwv_flow_imp.g_varchar2_table(35187) := '6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A2243756572706F2064652046756E6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F72206E756DC3A97269636F222C22504C2F53514C';
wwv_flow_imp.g_varchar2_table(35188) := '2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2243756572706F206465206C612046756E6369C3B36E20504C2F53514C207175652064657675656C76';
wwv_flow_imp.g_varchar2_table(35189) := '6520756E20726567697374726F20646520686F726120636F6E20656C2076616C6F72206465207A6F6E6120686F7261726961222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565';
wwv_flow_imp.g_varchar2_table(35190) := '20696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A2243756572706F2064652066756E6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F7220766172636861723220636F6E20';
wwv_flow_imp.g_varchar2_table(35191) := '656C20666F726D61746F20414141412D4D4D2D444420484832343A4D493A535320545A52222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959';
wwv_flow_imp.g_varchar2_table(35192) := '592D4D4D2D444420484832343A4D493A5353223A2243756572706F2064652046756E6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F7220766172636861723220636F6E20656C20666F726D61746F20414141412D4D4D';
wwv_flow_imp.g_varchar2_table(35193) := '2D444420484832343A4D493A5353222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A2243756572706F206465206C612046756E';
wwv_flow_imp.g_varchar2_table(35194) := '6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F7220766172636861723220656E20666F726D61746F206E756DC3A97269636F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120';
wwv_flow_imp.g_varchar2_table(35195) := '76617263686172322076616C7565223A2243756572706F206465206C612046756E6369C3B36E20504C2F53514C207175652064657675656C766520756E2076616C6F72207661726368617232222C22504C2F53514C2046756E6374696F6E20426F647920';
wwv_flow_imp.g_varchar2_table(35196) := '72657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22456C2063756572706F206465206C612066756E6369C3B36E20504C2F53514C2064657675656C766520756E20726567697374726F20646520686F726120636F';
wwv_flow_imp.g_varchar2_table(35197) := '6E206C61207A6F6E6120686F7261726961222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A224D61726361646F7220646520706F73696369C3B36E222C22506F74656E7469616C2047726F757073223A22477275706F';
wwv_flow_imp.g_varchar2_table(35198) := '7320706F74656E6369616C6573222C22506F74656E7469616C205374617274657273223A22496E696369616C657320706F74656E6369616C6573222C22506F74656E7469616C205374617274696E672047726F757073223A22477275706F732064652069';
wwv_flow_imp.g_varchar2_table(35199) := '6E6963696F20706F74656E6369616C6573222C22506F74656E7469616C205374617274696E67205573657273223A225573756172696F7320496E696369616C657320506F7369626C6573222C22506F74656E7469616C205573657273223A225573756172';
wwv_flow_imp.g_varchar2_table(35200) := '696F7320706F74656E6369616C6573222C225072696F72697479223A225072696F7269646164222C2250726F6365737320646F63756D656E746174696F6E223A22446F63756D656E74616369C3B36E2064656C2070726F6365736F222C2250726F636573';
wwv_flow_imp.g_varchar2_table(35201) := '7320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22456C2070726F6365736F207469656E6520766172696F73206576656E746F7320646520696E6963696F20656E20626C616E636F222C2250726F63657373204944';
wwv_flow_imp.g_varchar2_table(35202) := '223A2249442064652070726F6365736F222C2250726F63657373206973206D697373696E6720656E64206576656E74223A2246616C746120656C206576656E746F2066696E616C20656E20656C2070726F6365736F222C2250726F63657373206973206D';
wwv_flow_imp.g_varchar2_table(35203) := '697373696E67207374617274206576656E74223A2246616C746120656C206576656E746F20646520696E6963696F20656E20656C2070726F6365736F222C2250726F63657373206E616D65223A224E6F6D6272652064652070726F6365736F222C225072';
wwv_flow_imp.g_varchar2_table(35204) := '6F63657373205072696F72697479223A225072696F72696461642064652070726F6365736F222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E223A2245737461646F2064656C2070726F6365736F206465737075C3';
wwv_flow_imp.g_varchar2_table(35205) := 'A973206465206C61207465726D696E616369C3B36E222C2250726F63657373205661726961626C652028417272617929223A225661726961626C652064652070726F6365736F20286D617472697A29222C2250726F63657373205661726961626C652028';
wwv_flow_imp.g_varchar2_table(35206) := '4C69737429223A225661726961626C652064652070726F6365736F20286C6973746129222C2250726F63657373205661726961626C65223A225661726961626C652064652070726F6365736F222C2250726F63657373223A2250726F6365736F222C2250';
wwv_flow_imp.g_varchar2_table(35207) := '726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A2250726F706F7263696F6E61722076616C6F726573207061726120706C616E74696C6C6120646520636F7272656F20656C65637472C3B36E69636F222C2252656365';
wwv_flow_imp.g_varchar2_table(35208) := '697665205461736B223A2252656369626972207461726561222C2252656365697665207461736B223A2254617265612064652072656365706369C3B36E222C225265646F223A2252656861636572222C2252656D6F7665223A22456C696D696E6172222C';
wwv_flow_imp.g_varchar2_table(35209) := '225265706C7920546F223A22526573706F6E6465722061222C22526571756573742056616C756520666F7220506167652043616C6C223A2256616C6F7220646520736F6C6963697475642070617261206C6C616D6164612064652070C3A167696E61222C';
wwv_flow_imp.g_varchar2_table(35210) := '2252657175657374223A22536F6C696369747564222C22526573756C74205661726961626C65223A225661726961626C6520646520726573756C7461646F222C2252657475726E205061796C6F616420496E746F223A22436172676120C3BA74696C2064';
wwv_flow_imp.g_varchar2_table(35211) := '65206465766F6C756369C3B36E20656E222C22526F6C65223A22526F6C222C2253617665223A2247756172646172222C225363686564756C65722045787072657373696F6E223A2245787072657369C3B36E2064652070726F6772616D61646F72222C22';
wwv_flow_imp.g_varchar2_table(35212) := '5363686564756C696E67223A2250726F6772616D616369C3B36E222C22536372697074205461736B223A22546172656120646520677569C3B36E222C22536372697074207461736B223A22546172656120646520736372697074222C2253656C65637420';
wwv_flow_imp.g_varchar2_table(35213) := '69662074686973206469616772616D20697320737461727461626C65223A2253656C656363696F6E61722073692065737465206469616772616D6120736520707565646520696E6963696172222C2253656C656374206966207468697320646961677261';
wwv_flow_imp.g_varchar2_table(35214) := '6D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A2253656C656363696F6E652073692073652064656265206C6C616D617220612065737465206469616772616D6120656E20756E61206163746976696461';
wwv_flow_imp.g_varchar2_table(35215) := '64206465206C6C616D616461222C2253656E6420456D61696C20496D6D6564696174656C79223A22456E7669617220636F7272656F20656C65637472C3B36E69636F20696E6D6564696174616D656E7465222C2253656E64204D61696C223A22456E7669';
wwv_flow_imp.g_varchar2_table(35216) := '617220636F7272656F222C2253656E64205461736B223A22456E76696172207461726561222C2253656E64207461736B223A22546172656120646520656E76C3AD6F222C2253657175656E636520666C6F77223A22466C756A6F2064652073656375656E';
wwv_flow_imp.g_varchar2_table(35217) := '636961222C2253657175656E6365223A2253656375656E636961222C2253657175656E6365466C6F772069732061206475706C6963617465223A2253657175656E6365466C6F7720657320756E206475706C696361646F222C2253657175656E7469616C';
wwv_flow_imp.g_varchar2_table(35218) := '206D756C74692D696E7374616E6365223A22496E7374616E636961206DC3BA6C7469706C652073656375656E6369616C222C2253657276696365207461736B223A22546172656120646520736572766963696F222C2253657276696365205461736B223A';
wwv_flow_imp.g_varchar2_table(35219) := '22546172656120646520736572766963696F222C2253657420636F6C6F72223A2245737461626C6563657220636F6C6F72222C225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E74';
wwv_flow_imp.g_varchar2_table(35220) := '6F206465206CC3AD6D697465206465207365C3B1616C202873696E20696E7465727275706369C3B36E29222C225369676E616C20626F756E64617279206576656E74223A224576656E746F206465206CC3AD6D697465206465207365C3B1616C222C2253';
wwv_flow_imp.g_varchar2_table(35221) := '69676E616C20656E64206576656E74223A224576656E746F2066696E616C206465207365C3B1616C222C225369676E616C20456E64204576656E74223A224576656E746F2066696E616C206465207365C3B1616C222C225369676E616C20696E7465726D';
wwv_flow_imp.g_varchar2_table(35222) := '656469617465206361746368206576656E74223A224576656E746F206465206361707475726120696E7465726D65646961206465207365C3B1616C222C225369676E616C20496E7465726D656469617465204361746368204576656E74223A224576656E';
wwv_flow_imp.g_varchar2_table(35223) := '746F206465206361707475726120696E7465726D6564696F206465207365C3B1616C222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A224576656E746F206465206465766F6C756369C3B36E20696E7465726D65';
wwv_flow_imp.g_varchar2_table(35224) := '64696F206465207365C3B1616C222C225369676E616C20696E7465726D656469617465207468726F77206576656E74223A224576656E746F206465206C616E7A616D69656E746F20696E7465726D6564696F206465207365C3B1616C222C225369676E61';
wwv_flow_imp.g_varchar2_table(35225) := '6C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520696E6963696F206465207365C3B1616C202873696E20696E7465727275706369C3B36E29222C225369676E616C20737461727420657665';
wwv_flow_imp.g_varchar2_table(35226) := '6E74223A224576656E746F20646520696E6963696F206465207365C3B1616C222C225369676E616C205374617274204576656E74223A224576656E746F20646520696E6963696F206465207365C3B1616C222C225369676E616C223A225365C3B1616C22';
wwv_flow_imp.g_varchar2_table(35227) := '2C2253696D706C65204D657373616765223A224D656E73616A652073696D706C65222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69737429223A22436F6E73756C74612053514C20286C697374612064656C696D69746164';
wwv_flow_imp.g_varchar2_table(35228) := '6120706F7220646F732070756E746F7329222C2253514C20717565727920284A534F4E20617272617929223A22436F6E73756C74612053514C20286D617472697A4A534F4E29222C2253514C207175657279202873696E676C652076616C756529223A22';
wwv_flow_imp.g_varchar2_table(35229) := '436F6E73756C74612053514C202876616C6F7220C3BA6E69636F29222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A22436F6E73756C74612053514C207175652064657675656C7665';
wwv_flow_imp.g_varchar2_table(35230) := '20756E61206C697374612064656C696D697461646120706F7220646F732070756E746F73222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A22436F6E73756C74612053514C207175652064657675656C766520';
wwv_flow_imp.g_varchar2_table(35231) := '756E61206D617472697A204A534F4E222C2253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C7565223A22436F6E73756C74612053514C207175652064657675656C766520756E20C3BA6E69636F2076616C6F';
wwv_flow_imp.g_varchar2_table(35232) := '72206465206665636861222C2253514C2071756572792072657475726E696E6720612073696E676C65206E756D6265722076616C7565223A22436F6E73756C74612053514C207175652064657675656C766520756E2076616C6F72206E756DC3A9726963';
wwv_flow_imp.g_varchar2_table(35233) := '6F20C3BA6E69636F222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22436F6E73756C74612053514C207175652064657675656C76652075';
wwv_flow_imp.g_varchar2_table(35234) := '6E20C3BA6E69636F20726567697374726F20646520686F726120636F6E20656C2076616C6F72206465207A6F6E6120686F7261726961222C2253514C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C7565';
wwv_flow_imp.g_varchar2_table(35235) := '223A22436F6E73756C74612053514C207175652064657675656C766520756E20C3BA6E69636F2076616C6F72207661726368617232222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65';
wwv_flow_imp.g_varchar2_table(35236) := '223A22436F6E73756C74612053514C207175652064657675656C766520656C20726567697374726F20646520686F726120636F6E206C61207A6F6E6120686F7261726961222C2253514C20717565727920746F20676574206174746163686D656E74223A';
wwv_flow_imp.g_varchar2_table(35237) := '22436F6E73756C74612053514C2070617261206F6274656E657220616E65786F222C2253514C207175657279223A22436F6E73756C74612053514C222C2253514C205175657279223A22436F6E73756C74612053514C222C225374617274206576656E74';
wwv_flow_imp.g_varchar2_table(35238) := '206973206D697373696E67206576656E7420646566696E6974696F6E223A2246616C7461206C6120646566696E696369C3B36E206465206576656E746F20656E20656C206576656E746F20646520696E6963696F222C225374617274206576656E74206D';
wwv_flow_imp.g_varchar2_table(35239) := '75737420626520626C616E6B223A22456C206576656E746F20646520696E6963696F206465626520657374617220656E20626C616E636F222C225374617274206576656E74223A224576656E746F20646520696E6963696F222C22537461727420457665';
wwv_flow_imp.g_varchar2_table(35240) := '6E74223A224576656E746F20696E696369616C222C2253746174696320646174652076616C7565223A2256616C6F7220646520666563686120657374C3A174696361222C22537461746963204944223A22494420657374C3A17469636F222C2253746174';
wwv_flow_imp.g_varchar2_table(35241) := '6963206E756D6265722076616C7565223A2256616C6F72206465206EC3BA6D65726F20657374C3A17469636F222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22526567697374726F2064652068';
wwv_flow_imp.g_varchar2_table(35242) := '6F726120657374C3A17469636F20636F6E2076616C6F72206465207A6F6E6120686F7261726961222C225374617469632076617263686172322076616C7565223A2256616C6F7220766172636861723220657374C3A17469636F222C2253746174696322';
wwv_flow_imp.g_varchar2_table(35243) := '3A22457374C3A17469636F222C22537472696E67223A22436164656E61222C225375622070726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22456C2073756270726F6365736F207469656E65207661';
wwv_flow_imp.g_varchar2_table(35244) := '72696F73206576656E746F7320646520696E6963696F20656E20626C616E636F222C225375622070726F63657373206973206D697373696E6720656E64206576656E74223A2246616C746120656C206576656E746F2066696E616C20656E20656C207375';
wwv_flow_imp.g_varchar2_table(35245) := '6270726F6365736F222C225375622070726F63657373206973206D697373696E67207374617274206576656E74223A2246616C746120656C206576656E746F20646520696E6963696F20656E20656C2073756270726F6365736F222C225375622D70726F';
wwv_flow_imp.g_varchar2_table(35246) := '636573732028636F6C6C617073656429223A2253756270726F6365736F2028636F6E747261C3AD646F29222C225375622D70726F636573732028657870616E64656429223A2253756270726F6365736F2028657870616E6469646F29222C225375622D70';
wwv_flow_imp.g_varchar2_table(35247) := '726F63657373223A2253756270726F6365736F222C225375626A656374223A224173756E746F222C225461736B20446566696E6974696F6E223A22446566696E696369C3B36E206465207461726561222C225461736B20537461746963204944223A2249';
wwv_flow_imp.g_varchar2_table(35248) := '4420657374C3A17469636F206465207461726561222C225461736B2054797065223A225469706F206465207461726561222C225461736B223A225461726561222C2254656D706C617465204944223A22494420646520706C616E74696C6C61222C225465';
wwv_flow_imp.g_varchar2_table(35249) := '6D706C617465223A22506C616E74696C6C61222C225465726D696E61746520656E64206576656E74223A224576656E746F2066696E616C206465207465726D696E616369C3B36E222C225465726D696E61746520456E64204576656E74223A2246696E61';
wwv_flow_imp.g_varchar2_table(35250) := '6C697A6172206576656E746F2066696E616C222C225465726D696E61746564223A225465726D696E61646F222C2254657874223A22546578746F222C2254696D6520756E74696C207468652074696D657220666972657320616761696E223A225469656D';
wwv_flow_imp.g_varchar2_table(35251) := '706F2068617374612071756520656C2074656D706F72697A61646F72207365207675656C76652061206469737061726172222C2254696D6520756E74696C207468652074696D6572206669726573206669727374223A225469656D706F20686173746120';
wwv_flow_imp.g_varchar2_table(35252) := '71756520656C2074656D706F72697A61646F722073652064697370617261207072696D65726F222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206CC3AD6D697465';
wwv_flow_imp.g_varchar2_table(35253) := '2064652074656D706F72697A61646F72202873696E20696E7465727275706369C3B36E29222C2254696D657220626F756E64617279206576656E74223A224576656E746F206465206CC3AD6D6974652064652074656D706F72697A61646F72222C225469';
wwv_flow_imp.g_varchar2_table(35254) := '6D657220446566696E6974696F6E2054797065223A225469706F20646520646566696E696369C3B36E2064652074656D706F72697A61646F72222C2254696D657220446566696E6974696F6E223A22446566696E696369C3B36E2064652074656D706F72';
wwv_flow_imp.g_varchar2_table(35255) := '697A61646F72222C2254696D6572204475726174696F6E223A22447572616369C3B36E2064652074656D706F72697A61646F72222C2254696D657220696E7465726D656469617465206361746368206576656E74223A224576656E746F20646520636170';
wwv_flow_imp.g_varchar2_table(35256) := '7475726120696E7465726D656469612064652074656D706F72697A61646F72222C2254696D657220496E7465726D656469617465204361746368204576656E74223A224576656E746F206465206361707475726120696E7465726D6564696F2064652074';
wwv_flow_imp.g_varchar2_table(35257) := '656D706F72697A61646F72222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520696E6963696F2064652074656D706F72697A61646F72202873696E20696E74657272757063';
wwv_flow_imp.g_varchar2_table(35258) := '69C3B36E29222C2254696D6572207374617274206576656E74223A224576656E746F20646520696E6963696F2064652074656D706F72697A61646F72222C2254696D6572205374617274204576656E74223A224576656E746F20646520696E6963696F20';
wwv_flow_imp.g_varchar2_table(35259) := '64652074656D706F72697A61646F72222C2254696D6572223A2254656D706F72697A61646F72222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D6174223A22526567';
wwv_flow_imp.g_varchar2_table(35260) := '697374726F20646520686F726120636F6E207A6F6E6120686F726172696120656E20666F726D61746F2049534F20383630312075204F7261636C65222C2254696D657374616D7020776974682054696D65205A6F6E65223A22526567697374726F206465';
wwv_flow_imp.g_varchar2_table(35261) := '20686F726120636F6E207A6F6E6120686F7261726961222C22546F223A224861737461222C22546F67676C65206E6F6E2D696E74657272757074696E67223A22416C7465726E61722073696E20696E7465727275706369C3B36E222C225472616E736163';
wwv_flow_imp.g_varchar2_table(35262) := '74696F6E223A225472616E7361636369C3B36E222C22556E646F223A224465736861636572222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A226469207B64697D20646573636F6E6F6369646F';
wwv_flow_imp.g_varchar2_table(35263) := '207061726120656C20656C656D656E746F207B73656D616E7469637D222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A22666C6F77456C656D656E74';
wwv_flow_imp.g_varchar2_table(35264) := '206E6F207265636F6E6F6369646F207B656C656D656E747D20656E20656C20636F6E746578746F207B636F6E746578747D222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E';
wwv_flow_imp.g_varchar2_table(35265) := '747D223A2262706D6E456C656D656E74206E6F20636F6D70617469626C652070617261207B706C616E657D3A207B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A225574696C697A6172206D6574616461746F73';
wwv_flow_imp.g_varchar2_table(35266) := '2064652041504558222C225573652054656D706C617465223A225573617220706C616E74696C6C61222C2255736564206469616772616D2076657273696F6E223A225665727369C3B36E206465206469616772616D61207574696C697A616461222C2255';
wwv_flow_imp.g_varchar2_table(35267) := '736572207461736B223A225461726561206465207573756172696F222C2255736572205461736B223A225461726561206465207573756172696F222C2256616C7565223A2256616C6F72222C225661726368617232223A22566172636861723220284669';
wwv_flow_imp.g_varchar2_table(35268) := '6E20646520637265616369C3B36E29222C225661726961626C652045787072657373696F6E73223A22457870726573696F6E6573206465207661726961626C6573222C2256657273696F6E204E616D65223A224E6F6D627265206465207665727369C3B3';
wwv_flow_imp.g_varchar2_table(35269) := '6E222C2256657273696F6E696E67223A22436F6E74726F6C2064652076657273696F6E6573222C225761697420666F7220636F6D706C6574696F6E223A22457370657261722066696E616C697A616369C3B36E222C225A6F6F6D20496E223A2241636572';
wwv_flow_imp.g_varchar2_table(35270) := '636172222C225A6F6F6D204F7574223A22416C656A6172227D27297D2C363932383A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D204572726F72732C207B7761726E696E67';
wwv_flow_imp.g_varchar2_table(35271) := '737D205761726E696E6773223A227B6572726F72737D20457272657572732C207B7761726E696E67737D204176657274697373656D656E7473222C227B73656D616E7469637D237B736964657D20526566206E6F7420737065636966696564223A2252C3';
wwv_flow_imp.g_varchar2_table(35272) := 'A966C3A972656E6365207B73656D616E7469637D237B736964657D206E6F6E207370C3A963696669C3A965222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312D557267656E74222C22322D48696768223A22322D486967';
wwv_flow_imp.g_varchar2_table(35273) := '68222C22332D4D656469756D223A22332D4D656469756D222C22342D4C6F77223A22342D4C6F77222C22352D4C6F77657374223A22352D4C6F77657374222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073706C6974';
wwv_flow_imp.g_varchar2_table(35274) := '206174207468652073616D652074696D65223A22556E6520706173736572656C6C65206E652064657672616974207061732073652072656A6F696E6472652065742073652073C3A9706172657220656E206DC3AA6D652074656D70732E222C2241637469';
wwv_flow_imp.g_varchar2_table(35275) := '76617465206372656174652F72656D6F766520737061636520746F6F6C223A2241637469766572206C5C276F7574696C206465206372C3A96174696F6E202F207375707072657373696F6E20645C27657370616365222C22416374697661746520676C6F';
wwv_flow_imp.g_varchar2_table(35276) := '62616C20636F6E6E65637420746F6F6C223A2241637469766572206C5C276F7574696C20646520636F6E6E6578696F6E20676C6F62616C65222C2241637469766174652068616E6420746F6F6C223A2241637469766572206C5C276F7574696C20C3A020';
wwv_flow_imp.g_varchar2_table(35277) := '6D61696E222C224163746976617465206C6173736F20746F6F6C223A2241637469766572206C5C276F7574696C204C6173736F222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A22416374697665';
wwv_flow_imp.g_varchar2_table(35278) := '72206C5C276F7574696C206465206372C3A96174696F6E2F7375707072657373696F6E20645C27657370616365222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A2241637469766572206C5C276F7574696C20';
wwv_flow_imp.g_varchar2_table(35279) := '646520636F6E6E6578696F6E20676C6F62616C65222C224163746976617465207468652068616E6420746F6F6C223A2241637469766572206C5C276F7574696C20C3A0206D61696E222C22416374697661746520746865206C6173736F20746F6F6C223A';
wwv_flow_imp.g_varchar2_table(35280) := '2241637469766572206C5C276F7574696C204C6173736F222C224163746976697479207265666572656E6365223A2252C3A966C3A972656E6365206465206C5C2761637469766974C3A9222C2241642D686F63223A22416420686F63222C22416464206C';
wwv_flow_imp.g_varchar2_table(35281) := '616E652061626F7665223A22416A6F7574657220756E20636F756C6F697220617520646573737573222C22416464206C616E652062656C6F77223A22416A6F7574657220756E20636F756C6F697220656E20646573736F7573222C224164642074657874';
wwv_flow_imp.g_varchar2_table(35282) := '20616E6E6F746174696F6E223A22416A6F7574657220756E6520616E6E6F746174696F6E206465207465787465222C224166746572204D65726765223A22417072C3A873206C612072C3A9756E696F6E222C224166746572205461736B223A22417072C3';
wwv_flow_imp.g_varchar2_table(35283) := 'A873206C612074C3A2636865222C22416C69676E20656C656D656E747320626F74746F6D223A22416C69676E6572206C657320C3A96CC3A96D656E747320656E20626173222C22416C69676E20656C656D656E74732063656E746572223A2243656E7472';
wwv_flow_imp.g_varchar2_table(35284) := '6572206C657320C3A96CC3A96D656E7473222C22416C69676E20656C656D656E7473206C656674223A22416C69676E6572206C657320C3A96CC3A96D656E747320C3A020676175636865222C22416C69676E20656C656D656E7473206D6964646C65223A';
wwv_flow_imp.g_varchar2_table(35285) := '22416C69676E6572206C657320C3A96CC3A96D656E7473206175206D696C696575222C22416C69676E20656C656D656E7473207269676874223A22416C69676E6572206C657320C3A96CC3A96D656E747320C3A02064726F697465222C22416C69676E20';
wwv_flow_imp.g_varchar2_table(35286) := '656C656D656E747320746F70223A22416C69676E6572206C657320C3A96CC3A96D656E747320656E2068617574222C22416C69676E20656C656D656E7473223A22416C69676E6572206C657320C3A96CC3A96D656E7473222C22416C6C6F772042696E64';
wwv_flow_imp.g_varchar2_table(35287) := '696E67223A224175746F7269736572206C61206C696169736F6E222C22616C72656164792072656E6465726564207B656C656D656E747D223A227B656C656D656E747D2064C3A96AC3A02072656E6475222C224150455820417070726F76616C223A2241';
wwv_flow_imp.g_varchar2_table(35288) := '50455820417070726F626174696F6E222C22415045582050616765223A22506167652041504558222C224150455820526F6C65223A2252C3B46C652041504558222C22415045582053696D706C6520466F726D223A22466F726D756C616972652073696D';
wwv_flow_imp.g_varchar2_table(35289) := '706C652041504558222C22417070656E6420636F6D70656E736174696F6E206163746976697479223A22416A6F7574657220756E652061637469766974C3A9206465207479706520636F6D70656E736174696F6E222C22417070656E6420636F6E646974';
wwv_flow_imp.g_varchar2_table(35290) := '696F6E616C20696E7465726D656469617465206361746368206576656E74223A22416A6F7574657220756E20C3A976C3A96E656D656E7420636174636820696E7465726DC3A964696169726520636F6E646974696F6E6E656C222C22417070656E642065';
wwv_flow_imp.g_varchar2_table(35291) := '6E64206576656E74223A22416A6F7574657220756E20C3A976C3A96E656D656E742064652066696E222C22417070656E642067617465776179223A22416A6F7574657220756E6520706173736572656C6C65222C22417070656E6420696E7465726D6564';
wwv_flow_imp.g_varchar2_table(35292) := '696174652F626F756E64617279206576656E74223A22416A6F7574657220756E20C3A976C3A96E656D656E7420696E7465726DC3A96469616972652F66726F6E7469C3A87265222C22417070656E64206D65737361676520696E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(35293) := '206361746368206576656E74223A22416A6F7574657220756E20C3A976C3A96E656D656E7420636174636820696E7465726DC3A9646961697265206465206D657373616765222C22417070656E642072656365697665207461736B223A22416A6F757465';
wwv_flow_imp.g_varchar2_table(35294) := '7220756E652074C3A26368652064652072C3A963657074696F6E222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A22416A6F7574657220756E20C3A976C3A96E656D656E742063617463682069';
wwv_flow_imp.g_varchar2_table(35295) := '6E7465726DC3A9646961697265206465207369676E616C222C22417070656E64207461736B223A22416A6F7574657220756E652074C3A2636865222C22417070656E64207465787420616E6E6F746174696F6E223A22416A6F7574657220756E6520616E';
wwv_flow_imp.g_varchar2_table(35296) := '6E6F746174696F6E206465207465787465222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A22416A6F7574657220756E20C3A976C3A96E656D656E742064652064C3A974656374696F6E20696E74';
wwv_flow_imp.g_varchar2_table(35297) := '65726DC3A964696169726520645C27686F726C6F6765222C224170706C69636174696F6E204944223A224944206465206C5C276170706C69636174696F6E222C224170706C69636174696F6E223A224170706C69636174696F6E222C2241737369676E6D';
wwv_flow_imp.g_varchar2_table(35298) := '656E74223A224166666563746174696F6E222C224174746163686D656E74223A225069C3A86365206A6F696E7465222C224261636B67726F756E64205461736B2053657373696F6E223A2253657373696F6E2064652074C3A263686520656E2061727269';
wwv_flow_imp.g_varchar2_table(35299) := 'C3A8726520706C616E222C22424343223A22424343222C224265666F7265204576656E74223A224176616E74206C5C27C3A976C3A86E656D656E74222C224265666F72652053706C6974223A224176616E74206C61206469766973696F6E222C22426566';
wwv_flow_imp.g_varchar2_table(35300) := '6F7265205461736B223A224176616E74206C612074C3A2636865222C2242696E642070616765206974656D7320286465707265636174656429223A224C696572206C657320C3A96CC3A96D656E7473206465207061676520286F62736F6CC3A874652922';
wwv_flow_imp.g_varchar2_table(35301) := '2C2242696E6420706172616D657465722076616C756573223A2256616C6575727320646520706172616DC3A8747265206465206C696169736F6E222C2242696E642070726F63657373207661726961626C6573223A225661726961626C65732064652070';
wwv_flow_imp.g_varchar2_table(35302) := '726F636573737573206465206C696169736F6E222C22426C696E6420636172626F6E20636F707920726563697069656E74287329223A2244657374696E61746169726528732920656E20636F70696520636F6E666F726D6520696E7369626C65222C2242';
wwv_flow_imp.g_varchar2_table(35303) := '6F64792048544D4C223A2248544D4C20647520636F727073222C22426F64792054657874223A225465787465206272757420647520636F727073222C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F636573';
wwv_flow_imp.g_varchar2_table(35304) := '736573206172652063757272656E746C79206E6F7420737570706F72746564223A224C657320C3A976C3A96E656D656E7473206C696D6974657320737572206C657320736F75732D70726F63657373757320645C276974C3A9726174696F6E206E652073';
wwv_flow_imp.g_varchar2_table(35305) := '6F6E742061637475656C6C656D656E7420706173207072697320656E20636861726765222C22427573696E657373205265666572656E6365223A22427573696E657373205265666572656E6365222C22427573696E6573732072756C65207461736B223A';
wwv_flow_imp.g_varchar2_table(35306) := '2254C3A263686520646520747970652072C3A8676C65206DC3A974696572222C22427573696E6573732052756C65205461736B223A2254C3A263686520646520747970652072C3A8676C65206DC3A974696572222C22627573696E6573735F726566223A';
wwv_flow_imp.g_varchar2_table(35307) := '22627573696E6573735F726566222C2243616C6C206163746976697479223A2241637469766974C3A920617070656CC3A965222C2243616C6C204163746976697479223A2241637469766974C3A920617070656CC3A965222C2243616C6C656420446961';
wwv_flow_imp.g_varchar2_table(35308) := '6772616D223A224469616772616D6D6520617070656CC3A9222C2243616E63656C20626F756E64617279206576656E74223A22C38976C3A96E656D656E742066726F6E7469C3A87265206465207479706520616E6E756C6174696F6E222C2243616E6365';
wwv_flow_imp.g_varchar2_table(35309) := '6C20656E64206576656E74223A22C38976C3A96E656D656E742064652066696E206465207479706520616E6E756C6174696F6E222C2243616E63656C223A22416E6E756C6572222C22436172626F6E20636F707920726563697069656E74287329223A22';
wwv_flow_imp.g_varchar2_table(35310) := '44657374696E61746169726528732920656E20636F70696520636F6E666F726D65222C2243617465676F72792056616C7565223A2256616C657572206465206C6120636174C3A9676F726965222C224343223A224343222C224368616E676520656C656D';
wwv_flow_imp.g_varchar2_table(35311) := '656E74223A224D6F646966696572206C5C27C3A96CC3A96D656E74222C224368616E67652074797065223A224368616E6765722064652074797065222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A2256616C65';
wwv_flow_imp.g_varchar2_table(35312) := '7572206465206C5C276566666163656D656E7420647520636163686520706F7572206C5C27617070656C206465206C612070616765222C22436C656172204361636865223A2245666661636572206C65206361636865222C22436C6F62223A22436C6F62';
wwv_flow_imp.g_varchar2_table(35313) := '222C22436F6465223A22436F6465222C22436F6C6C61626F726174696F6E223A22436F6C6C61626F726174696F6E222C22436F6C6C617073656420506F6F6C223A2250697363696E65202872C3A9647569746529222C22436F6C6C617073656420537562';
wwv_flow_imp.g_varchar2_table(35314) := '2050726F63657373223A22536F75732D70726F6365737375732072C3A964756974222C22436F6C6C656374696F6E2054797065223A2254797065206465207265636F757672656D656E74222C22436F6C6C656374696F6E223A22436F6C6C656374696F6E';
wwv_flow_imp.g_varchar2_table(35315) := '222C22436F6D70656E7361746520456E64204576656E74223A2252C3A96D756EC3A9726572206C5C27C3A976C3A96E656D656E742066696E616C222C22436F6D70656E7361746520496E7465726D656469617465205468726F77204576656E74223A2252';
wwv_flow_imp.g_varchar2_table(35316) := 'C3A96D756EC3A972657220756E20C3A976C3A96E656D656E74206465206C616E63656D656E7420696E7465726DC3A9646961697265222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A22C38976C3A96E656D656E74206465';
wwv_flow_imp.g_varchar2_table(35317) := '2066726F6E7469C3A87265206465207479706520636F6D70656E736174696F6E222C22436F6D70656E736174696F6E20656E64206576656E74223A22C38976C3A96E656D656E742064652066696E206465207479706520636F6D70656E736174696F6E22';
wwv_flow_imp.g_varchar2_table(35318) := '2C22436F6D70656E736174696F6E20696E7465726D656469617465207468726F77206576656E74223A224576C3A86E656D656E7420696E7465726DC3A9646961697265206465207479706520636F6D70656E736174696F6E2028C3A96D697373696F6E29';
wwv_flow_imp.g_varchar2_table(35319) := '222C22436F6D70656E736174696F6E207374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A9627574206465207479706520636F6D70656E736174696F6E222C22436F6D70656E736174696F6E223A22436F6D70656E73617469';
wwv_flow_imp.g_varchar2_table(35320) := '6F6E222C22436F6D706C65746564223A225465726D696EC3A9222C22436F6D706C6574696F6E20436F6E646974696F6E223A22436F6E646974696F6E2064652066696E222C22436F6D706C65782067617465776179223A22506173736572656C6C652063';
wwv_flow_imp.g_varchar2_table(35321) := '6F6D706C657865222C22436F6D706C65782047617465776179223A22506173736572656C6C6520636F6D706C657865222C22436F6E646974696F6E2054797065223A225479706520646520636F6E646974696F6E222C22436F6E646974696F6E223A2243';
wwv_flow_imp.g_varchar2_table(35322) := '6F6E646974696F6E222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652066726F6E7469C3A87265206465207479706520636F6E64697469';
wwv_flow_imp.g_varchar2_table(35323) := '6F6E6E656C20286E6F6E20696E74657272757074696629222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A22C38976C3A96E656D656E742064652066726F6E7469C3A87265206465207479706520636F6E646974696F6E6E65';
wwv_flow_imp.g_varchar2_table(35324) := '6C222C22436F6E646974696F6E616C20666C6F77223A22466C757820636F6E646974696F6E6E656C222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22C38976C3A96E656D656E7420696E7465726D';
wwv_flow_imp.g_varchar2_table(35325) := 'C3A9646961697265206465207479706520636F6E646974696F6E6E656C202872C3A963657074696F6E29222C22436F6E646974696F6E616C20496E7465726D656469617465204361746368204576656E74223A22C38976C3A96E656D656E7420696E7465';
wwv_flow_imp.g_varchar2_table(35326) := '726DC3A9646961697265206465207479706520636F6E646974696F6E6E656C202872C3A963657074696F6E29222C22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D';
wwv_flow_imp.g_varchar2_table(35327) := '656E742064652064C3A9627574206465207479706520636F6E646974696F6E6E656C20286E6F6E20696E74657272757074696629222C22436F6E646974696F6E616C207374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A962';
wwv_flow_imp.g_varchar2_table(35328) := '7574206465207479706520636F6E646974696F6E6E656C222C22436F6E646974696F6E616C205374617274204576656E74223A22C38976C3A96E656D656E742064652064C3A9627574206465207479706520636F6E646974696F6E6E656C222C22436F6E';
wwv_flow_imp.g_varchar2_table(35329) := '6E65637420746F206F7468657220656C656D656E74223A22536520636F6E6E656374657220C3A020756E20617574726520C3A96CC3A96D656E74222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22436F6E6E656374657220C3';
wwv_flow_imp.g_varchar2_table(35330) := 'A0206C5C276169646520645C27756E65206173736F63696174696F6E222C22436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E223A22536520636F6E6E656374657220C3A0206C5C2761696465206465206C5C27';
wwv_flow_imp.g_varchar2_table(35331) := '6173736F63696174696F6E2064652073616973696520646520646F6E6EC3A96573222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A22436F6E6E656374657A2D76';
wwv_flow_imp.g_varchar2_table(35332) := '6F757320656E207574696C6973616E742053657175656E6365202F204D657373616765466C6F77206F75204173736F63696174696F6E222C22436F707920627573696E657373207265666572656E6365223A22436F70696572206C6120627573696E6573';
wwv_flow_imp.g_varchar2_table(35333) := '73207265666572656E6365222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A22636F7272656374696F6E2062706D6E456C656D656E74206D61';
wwv_flow_imp.g_varchar2_table(35334) := '6E7175616E7420737572207B706C616E657D20C3A0207B726F6F74456C656D656E747D222C22436F7272656C6174696F6E204B6579223A22436CC3A920646520636F7272C3A96C6174696F6E222C22436F7272656C6174696F6E2056616C7565223A2256';
wwv_flow_imp.g_varchar2_table(35335) := '616C65757220646520636F7272C3A96C6174696F6E222C22437265617465207B747970657D223A224372C3A96572207B747970657D222C224372656174652064617461206F626A656374207265666572656E6365223A224372C3A9657220756E652072C3';
wwv_flow_imp.g_varchar2_table(35336) := 'A966C3A972656E636520645C276F626A657420646520646F6E6EC3A96573222C2243726561746520646174612073746F7265207265666572656E6365223A224372C3A9657220756E652072C3A966C3A972656E63652064652062616E7175652064652064';
wwv_flow_imp.g_varchar2_table(35337) := '6F6E6EC3A96573222C2243726561746520446174614F626A6563745265666572656E6365223A224372C3A9657220756E206F626A657420646520646F6E6EC3A96573222C22437265617465204461746153746F72655265666572656E6365223A224372C3';
wwv_flow_imp.g_varchar2_table(35338) := 'A9657220756E652062616E71756520646520646F6E6EC3A96573222C2243726561746520656E64206576656E74223A224372C3A9657220756E20C3A976C3A96E656D656E742064652066696E222C2243726561746520456E644576656E74223A224372C3';
wwv_flow_imp.g_varchar2_table(35339) := 'A9657220756E20C3A976C3A86E656D656E742064652066696E222C2243726561746520657870616E646564207375622D70726F63657373223A224372C3A9657220756E2070726F636573737573207365636F6E646169726520C3A974656E6475222C2243';
wwv_flow_imp.g_varchar2_table(35340) := '726561746520657870616E6465642053756250726F63657373223A224372C3A9657220756E20736F75732D70726F6365737375732028C3A974656E647529222C224372656174652067617465776179223A224372C3A9657220756E652070617373657265';
wwv_flow_imp.g_varchar2_table(35341) := '6C6C65222C224372656174652047617465776179223A224372C3A9657220756E6520706173736572656C6C65222C224372656174652067726F7570223A224372C3A9657220756E2067726F757065222C224372656174652047726F7570223A224372C3A9';
wwv_flow_imp.g_varchar2_table(35342) := '657220756E2067726F757065222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A224372C3A9657220756E20C3A976C3A86E656D656E7420696E7465726DC3A96469616972652F66726F6E7469C3A8726522';
wwv_flow_imp.g_varchar2_table(35343) := '2C2243726561746520496E7465726D6564696174652F426F756E64617279204576656E74223A224372C3A9657220756E20C3A976C3A86E656D656E7420696E7465726DC3A96469616972652F66726F6E7469C3A87265222C22437265617465206E657720';
wwv_flow_imp.g_varchar2_table(35344) := '2E2E2E223A224372C3A965722E2E2E222C2243726561746520706F6F6C2F7061727469636970616E74223A224372C3A9657220756E652070697363696E652F7061727469636970616E74222C2243726561746520506F6F6C2F5061727469636970616E74';
wwv_flow_imp.g_varchar2_table(35345) := '223A224372C3A9657220756E652070697363696E652F7061727469636970616E74222C22437265617465207374617274206576656E74223A224372C3A9657220756E20C3A976C3A96E656D656E742064652064C3A9627574222C22437265617465205374';
wwv_flow_imp.g_varchar2_table(35346) := '6172742054696D6572204576656E74223A224372C3A9657220756E20C3A976C3A96E656D656E742064652064C3A96275742064652074797065206465206D696E7574657572222C224372656174652053746172744576656E74223A224372C3A965722075';
wwv_flow_imp.g_varchar2_table(35347) := '6E20C3A976C3A86E656D656E742064652064C3A9627574222C22437265617465207461736B223A224372C3A9657220756E652074C3A2636865222C22437265617465205461736B223A224372C3A9657220756E652074C3A2636865222C22437573746F6D';
wwv_flow_imp.g_varchar2_table(35348) := '20457874656E73696F6E223A22457874656E73696F6E20706572736F6E6E616C6973C3A965222C22437573746F6D223A22506572736F6E6E616C6973C3A9222C224379636C65202849534F203836303129223A224379636C65202849534F203836303129';
wwv_flow_imp.g_varchar2_table(35349) := '222C224379636C6520284F7261636C6529223A224379636C6520284F7261636C6529222C2244617461206F626A656374207265666572656E6365223A224F626A657420646520646F6E6EC3A96573222C2244617461204F626A656374205265666572656E';
wwv_flow_imp.g_varchar2_table(35350) := '6365223A224F626A657420646520646F6E6EC3A96573222C22446174612073746F7265207265666572656E6365223A2242616E71756520646520646F6E6EC3A96573222C22446174612053746F7265205265666572656E6365223A2242616E7175652064';
wwv_flow_imp.g_varchar2_table(35351) := '6520646F6E6EC3A96573222C22446174612054797065223A225479706520646520646F6E6EC3A96573222C2244617465202849534F203836303129223A2244617465202849534F203836303129222C224461746520284F7261636C6529223A2244617465';
wwv_flow_imp.g_varchar2_table(35352) := '20284F7261636C6529222C224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22466F726D6174206465206461746520595959592D4D4D2D444420484832343A4D493A5353222C224461746520537472696E';
wwv_flow_imp.g_varchar2_table(35353) := '67223A22446174652028636861696E6520646520636172616374C3A8726529222C2244617465223A2244617465222C2244656661756C74204170706C69636174696F6E204944223A224944206170706C69636174696F6E207061722064C3A96661757422';
wwv_flow_imp.g_varchar2_table(35354) := '2C2244656661756C74204170706C69636174696F6E223A224170706C69636174696F6E207061722064C3A966617574222C2244656661756C7420666C6F77223A22466C7578207061722064C3A966617574222C2244656661756C74205061676520494422';
wwv_flow_imp.g_varchar2_table(35355) := '3A2249442070616765207061722064C3A966617574222C2244656661756C742050616765223A2250616765207061722064C3A966617574222C2244656661756C7420557365726E616D65223A224E6F6D20645C277574696C697361746575722070617220';
wwv_flow_imp.g_varchar2_table(35356) := '64C3A966617574222C2244656C657465223A225375707072696D6572222C224465736372697074696F6E223A224465736372697074696F6E222C2244657461696C73223A2244C3A97461696C73222C226469616772616D206E6F742070617274206F6620';
wwv_flow_imp.g_varchar2_table(35357) := '62706D6E3A446566696E6974696F6E73223A226C65206469616772616D6D65206E65206661697420706173207061727469652064652062706D6E3A446566696E6974696F6E73222C224469737472696275746520656C656D656E747320686F72697A6F6E';
wwv_flow_imp.g_varchar2_table(35358) := '74616C6C79223A2252C3A9706172746972206C657320C3A96CC3A96D656E747320686F72697A6F6E74616C656D656E74222C224469737472696275746520656C656D656E747320766572746963616C6C79223A2244697374726962756572206C657320C3';
wwv_flow_imp.g_varchar2_table(35359) := 'A96CC3A96D656E747320766572746963616C656D656E74222C2244697669646520696E746F207468726565206C616E6573223A224469766973657220656E2074726F697320636F756C6F697273222C2244697669646520696E746F2074776F206C616E65';
wwv_flow_imp.g_varchar2_table(35360) := '73223A224469766973657220656E206465757820636F756C6F697273222C22446F63756D656E746174696F6E223A22446F63756D656E746174696F6E222C22447565204F6E223A22456368C3A9616E6365206C65222C224475706C696361746520696E63';
wwv_flow_imp.g_varchar2_table(35361) := '6F6D696E672073657175656E636520666C6F7773223A22466C75782064652073C3A97175656E636520656E7472616E747320656E20646F75626C652E222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A2246';
wwv_flow_imp.g_varchar2_table(35362) := '6C75782064652073C3A97175656E636520736F7274616E747320656E20646F75626C652E222C224475726174696F6E202849534F203836303129223A22447572C3A965202849534F203836303129222C224475726174696F6E20284F7261636C6529223A';
wwv_flow_imp.g_varchar2_table(35363) := '22447572C3A96520284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C2720666F726D6174223A22447572C3A96520617520';
wwv_flow_imp.g_varchar2_table(35364) := '666F726D61742049534F2038363031206F75204F7261636C6520496E74657276616C204453205C274444442048483234203A4D493A53535C27222C22652E672E2032332D4A554E2D323032372031343A31303A3030223A22706172206578656D706C6520';
wwv_flow_imp.g_varchar2_table(35365) := '32332D4A55494E2D323032372031343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A22506172206578656D706C652C2044442D4D4F4E2D595959592048483234203A4D493A5353222C22656C656D656E74';
wwv_flow_imp.g_varchar2_table(35366) := '207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E223A226C5C27C3A96CC3A96D656E74207B656C656D656E747D20696E64697175C3A920706172';
wwv_flow_imp.g_varchar2_table(35367) := '207B7265666572656E6365647D237B70726F70657274797D206E5C276573742070617320656E636F72652064657373696EC3A9222C22456C656D656E7420646F63756D656E746174696F6E223A22446F63756D656E746174696F6E20C3A96CC3A96D656E';
wwv_flow_imp.g_varchar2_table(35368) := '7461697265222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A224C5C27C3A96CC3A96D656E74206120756E2074797065206E6F6E206175746F726973C3A920283C62';
wwv_flow_imp.g_varchar2_table(35369) := '706D6E3A436F6D706C6578476174657761793E292E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E223A224C5C27C3A96CC3A96D656E74206120756E20747970';
wwv_flow_imp.g_varchar2_table(35370) := '65206E6F6E206175746F726973C3A920283C62706D6E3A4D65737361676553746172744576656E743E292E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A22';
wwv_flow_imp.g_varchar2_table(35371) := '4C5C27C3A96CC3A96D656E74206120756E2074797065206E6F6E206175746F726973C3A920283C62706D6E3A5369676E616C53746172744576656E743E292E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E43';
wwv_flow_imp.g_varchar2_table(35372) := '6F6E646974696F6E616C53746172744576656E743E223A224C5C27C3A96CC3A96D656E74206120756E2074797065206E6F6E206175746F726973C3A920283C62706D6E436F6E646974696F6E616C53746172744576656E743E292E222C22456C656D656E';
wwv_flow_imp.g_varchar2_table(35373) := '74204944206973206C6F6E676572207468616E2035302063686172616374657273223A224C5C274944206465206C5C27C3A96CC3A96D656E7420636F6D706F72746520706C757320646520353020636172616374C3A87265732E222C22456C656D656E74';
wwv_flow_imp.g_varchar2_table(35374) := '20494420776173206E6F74206368616E67656420796574223A224C5C274944206465206C5C27C3A96CC3A96D656E74206E5C27612070617320656E636F726520C3A974C3A9206D6F64696669C3A9222C22456C656D656E7420697320616E20696D706C69';
wwv_flow_imp.g_varchar2_table(35375) := '63697420656E64223A224C5C27C3A96CC3A96D656E742065737420756E652066696E20696D706C6963697465222C22456C656D656E7420697320616E20696D706C69636974207374617274223A224C5C27C3A96CC3A96D656E742065737420756E2064C3';
wwv_flow_imp.g_varchar2_table(35376) := 'A962757420696D706C6963697465222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65223A224C5C27C3A96CC3A96D656E74206E5C276120706173206465206C6962656C6CC3A92F6E6F6D2E222C22456C656D656E74206973';
wwv_flow_imp.g_varchar2_table(35377) := '206E6F7420636F6E6E6563746564223A224C5C27C3A96CC3A96D656E74206E5C276573742070617320636F6E6E656374C3A92E222C22656C656D656E74207265717569726564223A22C3A96CC3A96D656E7420726571756973222C22456D61696C20636F';
wwv_flow_imp.g_varchar2_table(35378) := '6E74656E74223A22436F6E74656E7520647520636F75727269656C222C22456D61696C206F662074686520726563697069656E74287329223A22436F75727269656C206475206F75206465732064657374696E61746169726573222C22456D61696C206F';
wwv_flow_imp.g_varchar2_table(35379) := '66207468652073656E646572223A22436F75727269656C206465206C5C27657870C3A9646974657572222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A22436F75727269656C206175717565';
wwv_flow_imp.g_varchar2_table(35380) := '6C20646F697420C3AA74726520616472657373C3A9206C612072C3A9706F6E7365222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F76657320636F6E74656E7429223A22506F6F6C2F7061727469636970616E742076696465';
wwv_flow_imp.g_varchar2_table(35381) := '2028656E6CC3A87665206C6520636F6E74656E7529222C22456D70747920706F6F6C2F7061727469636970616E74223A2250697363696E652F7061727469636970616E742076696465222C22456E64206576656E74223A22C38976C3A96E656D656E7420';
wwv_flow_imp.g_varchar2_table(35382) := '64652066696E222C22456E64204576656E74223A22C38976C3A96E656D656E742064652066696E222C22456E64706F696E74223A2241647265737365222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E223A22536169';
wwv_flow_imp.g_varchar2_table(35383) := '7369722064657320657874656E73696F6E7320706572736F6E6E616C6973C3A9657320617520666F726D6174204A534F4E222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22456E74726572206C';
wwv_flow_imp.g_varchar2_table(35384) := '6520636F646520504C2F53514C20C3A0206578C3A963757465722E222C224572726F7220626F756E64617279206576656E74223A22C38976C3A96E656D656E742064652066726F6E7469C3A87265206465207479706520657272657572222C224572726F';
wwv_flow_imp.g_varchar2_table(35385) := '7220656E64206576656E74223A22C38976C3A96E656D656E742064652066696E206465207479706520657272657572222C224572726F7220456E64204576656E74223A22C38976C3A96E656D656E742064652066696E2064652074797065206572726575';
wwv_flow_imp.g_varchar2_table(35386) := '72222C224572726F72207374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A9627574206465207479706520657272657572222C224572726F72223A22457272657572222C22457363616C6174696F6E20626F756E6461727920';
wwv_flow_imp.g_varchar2_table(35387) := '6576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652066726F6E7469C3A87265206465207479706520657363616C61646520286E6F6E20696E74657272757074696629222C22457363616C6174696F6E';
wwv_flow_imp.g_varchar2_table(35388) := '20626F756E64617279206576656E74223A22C38976C3A96E656D656E742064652066726F6E7469C3A87265206465207479706520657363616C616465222C22457363616C6174696F6E20656E64206576656E74223A22C38976C3A96E656D656E74206465';
wwv_flow_imp.g_varchar2_table(35389) := '2066696E206465207479706520657363616C616465222C22457363616C6174696F6E20456E64204576656E74223A22C38976C3A96E656D656E742064652066696E206465207479706520657363616C616465222C22457363616C6174696F6E20696E7465';
wwv_flow_imp.g_varchar2_table(35390) := '726D656469617465207468726F77206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A9646961697265206465207479706520657363616C6164652028C3A96D697373696F6E29222C22457363616C6174696F6E20496E7465726D6564';
wwv_flow_imp.g_varchar2_table(35391) := '69617465205468726F77204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A9646961697265206465207479706520657363616C6164652028C3A96D697373696F6E29222C22457363616C6174696F6E207374617274206576656E7420';
wwv_flow_imp.g_varchar2_table(35392) := '286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652064C3A9627574206465207479706520657363616C61646520286E6F6E20696E74657272757074696629222C22457363616C6174696F6E20737461727420657665';
wwv_flow_imp.g_varchar2_table(35393) := '6E74223A22C38976C3A96E656D656E742064652064C3A9627574206465207479706520657363616C616465222C22457363616C6174696F6E223A22457363616C616465222C224576656E742042617365642047617465776179223A22506173736572656C';
wwv_flow_imp.g_varchar2_table(35394) := '6C6520626173C3A9652073757220756E20C3A976C3A86E656D656E74222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A224C5C27C3A976C3A86E656D656E74206120706C757369657572732064C3A9';
wwv_flow_imp.g_varchar2_table(35395) := '66696E6974696F6E732E222C224576656E74205375622050726F63657373223A22536F75732D70726F63657373757320C3A976C3A86E656D656E7469656C222C224576656E74207375622D70726F63657373223A2250726F63657373757320645C27C3A9';
wwv_flow_imp.g_varchar2_table(35396) := '76C3A96E656D656E74207365636F6E6461697265222C224576656E742054797065223A225479706520645C27C3A976C3A96E656D656E74222C224576656E742D62617365642067617465776179223A224761746577617920626173C3A920737572206465';
wwv_flow_imp.g_varchar2_table(35397) := '7320C3A976C3A96E656D656E7473222C224578636C75646564205374617274696E67205573657273223A225574696C69736174657572732064652064C3A970617274206578636C7573222C224578636C75646564205573657273223A225574696C697361';
wwv_flow_imp.g_varchar2_table(35398) := '7465757273206578636C7573222C224578636C75736976652067617465776179223A22506173736572656C6C65206578636C7573697665222C224578636C75736976652047617465776179223A22506173736572656C6C65206578636C7573697665222C';
wwv_flow_imp.g_varchar2_table(35399) := '2245786563757461626C65223A224578C3A963757461626C65222C224578656375746520504C2F53514C223A224578C3A9637574657220647520636F646520504C2F53514C222C22457865637574696F6E223A224578C3A9637574696F6E222C22457870';
wwv_flow_imp.g_varchar2_table(35400) := '616E64656420706F6F6C2F7061727469636970616E74223A22506F6F6C2F7061727469636970616E7420C3A974656E6475222C22457870616E646564205375622050726F63657373223A22536F75732D70726F6365737375732064C3A976656C6F7070C3';
wwv_flow_imp.g_varchar2_table(35401) := 'A9222C2245787072657373696F6E20284C656761637929223A2245787072657373696F6E202868C3A9726974C3A96529222C2245787072657373696F6E2054797065223A225479706520645C2765787072657373696F6E222C2245787072657373696F6E';
wwv_flow_imp.g_varchar2_table(35402) := '223A2245787072657373696F6E222C226661696C656420746F20696D706F7274207B656C656D656E747D223A2265727265757220C3A0206C5C27696D706F7274206465207B656C656D656E747D222C22666C6F7720656C656D656E7473206D7573742062';
wwv_flow_imp.g_varchar2_table(35403) := '65206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A226C657320C3A96CC3A96D656E747320646520666C757820646F6976656E7420C3AA7472652064657320656E66616E7473206465732070697363696E65732F706172';
wwv_flow_imp.g_varchar2_table(35404) := '7469636970616E7473222C22466C6F772073706C69747320696D706C696369746C79223A224C6520666C75782073652073C3A97061726520696D706C69636974656D656E742E222C22466F726D2054656D706C617465204974656D204E616D65223A224E';
wwv_flow_imp.g_varchar2_table(35405) := '6F6D206465206C5C27C3A96CC3A96D656E74206465206D6F64C3A86C6520646520666F726D756C61697265222C22466F726D2054656D706C617465204974656D223A22456CC3A96D656E74206465206D6F64C3A86C6520646520666F726D756C61697265';
wwv_flow_imp.g_varchar2_table(35406) := '222C22466F726D2054656D706C617465223A224D6F64C3A86C6520646520666F726D756C61697265222C22466F726D6174204D61736B223A224D617371756520646520666F726D6174222C22466F726D61744D61736B223A22466F726D61744D61736B22';
wwv_flow_imp.g_varchar2_table(35407) := '2C2246726F6D223A224465222C2246756E6374696F6E20426F647920284C656761637929223A22436F72707320646520666F6E6374696F6E202868C3A9726974C3A929222C2246756E6374696F6E20426F6479223A22436F72707320646520666F6E6374';
wwv_flow_imp.g_varchar2_table(35408) := '696F6E222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A224C6120706173736572656C6C6520657374207375706572666C75652C20656C6C65';
wwv_flow_imp.g_varchar2_table(35409) := '206E5C27612071755C27756E6520736F7572636520657420756E65206369626C652E222C2247656E6572616C223A2247C3A96EC3A972616C222C2247656E65726174652064656661756C74206974656D73223A2247C3A96EC3A9726572206C657320C3A9';
wwv_flow_imp.g_varchar2_table(35410) := '6CC3A96D656E7473207061722064C3A966617574222C22476C6F62616C206572726F72207265666572656E6365223A2252C3A966C3A972656E636520645C2765727265757220676C6F62616C65222C22476C6F62616C20657363616C6174696F6E207265';
wwv_flow_imp.g_varchar2_table(35411) := '666572656E6365223A2252C3A966C3A972656E636520645C27657363616C61646520676C6F62616C65222C22476C6F62616C207369676E616C207265666572656E6365223A2252C3A966C3A972656E6365206475207369676E616C20676C6F62616C222C';
wwv_flow_imp.g_varchar2_table(35412) := '2247726F7570223A2247726F757065222C2248544D4C2076657273696F6E206F662074686520656D61696C223A2256657273696F6E2048544D4C20647520636F75727269656C222C224944206D75737420626520756E697175652E223A224C5C27494420';
wwv_flow_imp.g_varchar2_table(35413) := '646F697420C3AA74726520756E697175652E222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A22617520666F726D6174204444442048483A4D4D3A5353222C22696E20666F726D61742059592D4D4D223A2261';
wwv_flow_imp.g_varchar2_table(35414) := '7520666F726D61742059592D4D4D222C22496E205661726961626C6573223A225661726961626C657320645C27656E7472C3A965222C22496E2F4F7574204D617070696E67223A224D61707061676520656E7472C3A9652F736F72746965222C22496E2F';
wwv_flow_imp.g_varchar2_table(35415) := '4F7574205661726961626C6573223A225661726961626C657320656E7472616E7465732F736F7274616E746573222C22496E636C75736976652067617465776179223A22506173736572656C6C6520696E636C7573697665222C22496E636F6D696E6720';
wwv_flow_imp.g_varchar2_table(35416) := '666C6F777320646F206E6F74206A6F696E223A224C657320666C757820656E7472616E7473206E652073652072656A6F69676E656E74207061732E222C22496E69746961746F72206F66207468697320617070726F76616C207461736B223A22496E6974';
wwv_flow_imp.g_varchar2_table(35417) := '6961746575722064652063657474652074C3A263686520645C27617070726F626174696F6E222C22496E69746961746F72223A22496E6974696174657572222C22496E70757420436F6C6C656374696F6E223A22436F6C6C656374696F6E20645C27656E';
wwv_flow_imp.g_varchar2_table(35418) := '7472C3A96573222C22496E70757420456C656D656E74223A22456CC3A96D656E7420645C27656E7472C3A965222C22496E7465726D656469617465207468726F77206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A9646961697265';
wwv_flow_imp.g_varchar2_table(35419) := '2028C3A96D697373696F6E29222C22496E7465726D656469617465205468726F77204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652028C3A96D697373696F6E29222C22496E74657276616C223A22496E74657276';
wwv_flow_imp.g_varchar2_table(35420) := '616C6C65222C2249732043616C6C61626C65223A2245737420617070656C61626C65222C22497320526F6C65223A2245737420756E2072C3B46C65222C22497320537461727461626C65223A225065757420C3AA7472652064C3A96D617272C3A9222C22';
wwv_flow_imp.g_varchar2_table(35421) := '49534F223A2249534F222C224974656D204E616D65223A224E6F6D206465206C5C27C3A96CC3A96D656E74222C224974656D2056616C7565223A2256616C657572206465206C5C27C3A96CC3A96D656E74222C224974656D223A2241727469636C65222C';
wwv_flow_imp.g_varchar2_table(35422) := '22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F72746564223A224C6573206974C3A9726174696F6E7320645C2761637469766974C3A97320645C27617070656C206E6520736F';
wwv_flow_imp.g_varchar2_table(35423) := '6E742061637475656C6C656D656E74207061732070726973657320656E20636861726765222C224A534F4E204F626A656374223A224F626A6574204A534F4E222C224C616E65223A224C69676E65222C224C61746573742076657273696F6E223A224465';
wwv_flow_imp.g_varchar2_table(35424) := '726E69C3A872652076657273696F6E222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206C69656E202872C3A963657074696F';
wwv_flow_imp.g_varchar2_table(35425) := '6E29222C224C696E6B20496E7465726D656469617465204361746368204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206C69656E202872C3A963657074696F6E29222C224C696E6B20696E74';
wwv_flow_imp.g_varchar2_table(35426) := '65726D656469617465207468726F77206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206C69656E2028C3A96D697373696F6E29222C224C696E6B20496E7465726D656469617465205468726F';
wwv_flow_imp.g_varchar2_table(35427) := '77204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206C69656E2028C3A96D697373696F6E29222C224C696E6B223A224C69656E222C224C6F616420646566696E6564207661726961626C6573';
wwv_flow_imp.g_varchar2_table(35428) := '223A2243686172676572206C6573207661726961626C65732064C3A966696E696573222C224C6F6164204A534F4E223A2243686172676572204A534F4E222C224C6F616420506172616D6574657273223A2243686172676572206C657320706172616DC3';
wwv_flow_imp.g_varchar2_table(35429) := 'A874726573222C224C6F6F70223A22426F75636C65222C224D61696C223A22436F75727269656C222C224D616E75616C207461736B223A2254C3A2636865206D616E75656C6C65222C224D616E75616C205461736B223A2254C3A2636865206D616E7565';
wwv_flow_imp.g_varchar2_table(35430) := '6C6C65222C224D61782052756E73223A224E6F6D627265206D6178696D616C20645C276578C3A9637574696F6E222C224D65737361676520626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D';
wwv_flow_imp.g_varchar2_table(35431) := '656E742064652066726F6E7469C3A872652064652074797065206D65737361676520286E6F6E20696E74657272757074696629222C224D65737361676520626F756E64617279206576656E74223A22C38976C3A96E656D656E742064652066726F6E7469';
wwv_flow_imp.g_varchar2_table(35432) := 'C3A872652064652074797065206D657373616765222C224D65737361676520656E64206576656E74223A22C38976C3A96E656D656E742064652066696E2064652074797065206D657373616765222C224D65737361676520456E64204576656E74223A22';
wwv_flow_imp.g_varchar2_table(35433) := 'C38976C3A96E656D656E742064652066696E2064652074797065206D657373616765222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064';
wwv_flow_imp.g_varchar2_table(35434) := '652074797065206D657373616765202872C3A963657074696F6E29222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A9646961697265206465207479706520';
wwv_flow_imp.g_varchar2_table(35435) := '6D657373616765202872C3A963657074696F6E29222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206D657373616765';
wwv_flow_imp.g_varchar2_table(35436) := '2028C3A96D697373696F6E29222C224D65737361676520496E7465726D656469617465205468726F77204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206D6573736167652028C3A96D697373';
wwv_flow_imp.g_varchar2_table(35437) := '696F6E29222C224D657373616765204E616D65223A224E6F6D206475206D657373616765222C224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652064C3A96275';
wwv_flow_imp.g_varchar2_table(35438) := '742064652074797065206D65737361676520286E6F6E20696E74657272757074696629222C224D657373616765207374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A96275742064652074797065206D657373616765222C22';
wwv_flow_imp.g_varchar2_table(35439) := '4D657373616765205374617274204576656E74223A22C38976C3A96E656D656E742064652064C3A96275742064652074797065206D657373616765222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A227B7365';
wwv_flow_imp.g_varchar2_table(35440) := '6D616E7469637D236174746163686564546F526566206D616E7175616E74222C226D6F7265207468616E207B636F756E747D206368696C64206C616E6573223A22706C7573206465207B636F756E747D20636F756C6F69727320656E66616E7473222C22';
wwv_flow_imp.g_varchar2_table(35441) := '4D756C74692D496E7374616E6365223A22506C7573696575727320696E7374616E636573222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A224944206D756C7469706C652064C3A966';
wwv_flow_imp.g_varchar2_table(35442) := '696E6920706F7572207B656C656D656E747D222C224E616D65206F6620746865206469616772616D223A224E6F6D206475206469616772616D6D65222C224E616D65206F66207468652050726F63657373205661726961626C6520286F66207479706520';
wwv_flow_imp.g_varchar2_table(35443) := '54696D657374616D7020776974682054696D65205A6F6E6529223A224E6F6D206465206C61207661726961626C652064652070726F63657373757320286465207479706520486F726F64617461676520617665632066757365617520686F726169726529';
wwv_flow_imp.g_varchar2_table(35444) := '222C224E616D65206F66207468652050726F63657373205661726961626C65223A224E6F6D206465206C61207661726961626C652064652070726F636573737573222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074';
wwv_flow_imp.g_varchar2_table(35445) := '686520617070726F76616C20726573756C7420696E746F223A224E6F6D206465206C61207661726961626C652064616E73206C617175656C6C65207265746F75726E6572206C652072C3A973756C746174206465206C5C27617070726F626174696F6E22';
wwv_flow_imp.g_varchar2_table(35446) := '2C224E616D65223A224E6F6D222C224E616D65642076657273696F6E223A2256657273696F6E206E6F6D6DC3A965222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A227061732064652062706D';
wwv_flow_imp.g_varchar2_table(35447) := '6E456C656D656E742072C3A966C3A972656E63C3A92064616E73207B656C656D656E747D222C226E6F206469616772616D20746F20646973706C6179223A22617563756E206469616772616D6D6520C3A0206166666963686572222C226E6F2070617265';
wwv_flow_imp.g_varchar2_table(35448) := '6E7420666F72207B656C656D656E747D20696E207B706172656E747D223A2270617320646520706172656E7420706F7572207B656C656D656E747D2064616E73207B706172656E747D222C226E6F20706C616E6520666F72207B656C656D656E747D223A';
wwv_flow_imp.g_varchar2_table(35449) := '22617563756E206176696F6E20706F7572207B656C656D656E747D222C226E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A22617563756E2070726F636573737573206F7520636F6C6C61626F726174';
wwv_flow_imp.g_varchar2_table(35450) := '696F6E20C3A0206166666963686572222C226E6F207368617065207479706520737065636966696564223A22706173206465207479706520646520666F726D65207370C3A963696669C3A9222C224E756D626572223A224E756D626572222C224F6E2045';
wwv_flow_imp.g_varchar2_table(35451) := '76656E74223A2250656E64616E74206C5C27C3A976C3A86E656D656E74222C224F7261636C65205363686564756C652065787072657373696F6E223A2245787072657373696F6E2064652070726F6772616D6D6174696F6E204F7261636C65222C224F72';
wwv_flow_imp.g_varchar2_table(35452) := '61636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A226C6962C3A9726174696F6E20686F7273206C696D69746573222C224F7574205661726961626C6573223A225661726961626C657320646520736F7274';
wwv_flow_imp.g_varchar2_table(35453) := '6965222C224F757470757420436F6C6C656374696F6E223A22436F6C6C6563746520646520736F72746965222C224F757470757420456C656D656E74223A22456CC3A96D656E7420646520736F72746965222C224F76657277726974652064656661756C';
wwv_flow_imp.g_varchar2_table(35454) := '742076616C75652073657420696E207461736B20646566696E6974696F6E223A22C389637261736572206C612076616C657572207061722064C3A9666175742064C3A966696E69652064616E73206C612064C3A966696E6974696F6E206465206C612074';
wwv_flow_imp.g_varchar2_table(35455) := 'C3A2636865222C2250616765204944223A224944206465206C612070616765222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E6365223A22456CC3A96D656E7420646520706167';
wwv_flow_imp.g_varchar2_table(35456) := '6520636F6E74656E616E74206C612072C3A966C3A972656E6365206475206D6F64C3A86C6520646520666F726D756C61697265222C2250616765204974656D73223A22456CC3A96D656E74732064652070616765222C2250616765223A2250616765222C';
wwv_flow_imp.g_varchar2_table(35457) := '22506172616C6C656C2067617465776179223A22506173736572656C6C6520706172616C6CC3A86C65222C22506172616C6C656C2047617465776179223A22506173736572656C6C6520706172616C6CC3A86C65222C22506172616C6C656C206D756C74';
wwv_flow_imp.g_varchar2_table(35458) := '692D696E7374616E6365223A224D756C746920496E7374616E636520506172616C6CC3A86C65222C225061727469636970616E74204944223A224944207061727469636970616E74222C225061727469636970616E74206D756C7469706C696369747922';
wwv_flow_imp.g_varchar2_table(35459) := '3A22436F6C6C656374696F6E206465207061727469636970616E74222C225061727469636970616E74204E616D65223A224E6F6D206475207061727469636970616E74222C225061727469636970616E74223A225061727469636970616E74222C225061';
wwv_flow_imp.g_varchar2_table(35460) := '796C6F6164205661726961626C65223A225661726961626C6520646520636861726765207574696C65222C225061796C6F6164223A22436861726765207574696C65222C22504C2F53514C20436F6465223A22436F646520504C2F53514C222C22504C2F';
wwv_flow_imp.g_varchar2_table(35461) := '53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E652076616C65757220626F6F6CC3A9656E6E65222C22504C2F5351';
wwv_flow_imp.g_varchar2_table(35462) := '4C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E652076616C6575722064652064617465222C22504C2F53514C20457870726573';
wwv_flow_imp.g_varchar2_table(35463) := '73696F6E2072657475726E696E672061206E756D6265722076616C7565223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E652076616C657572206E756DC3A97269717565222C22504C2F53514C2045787072657373696F';
wwv_flow_imp.g_varchar2_table(35464) := '6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E20686F726F646174616765206176656320756E65207661';
wwv_flow_imp.g_varchar2_table(35465) := '6C6575722064652066757365617520686F7261697265222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A53';
wwv_flow_imp.g_varchar2_table(35466) := '5320545A52223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E652076616C65757220766172636861723220617520666F726D617420414141412D4D4D2D4A4A2048483234203A4D493A535320545A52222C22504C2F5351';
wwv_flow_imp.g_varchar2_table(35467) := '4C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A2245787072657373696F6E20504C2F53514C2072656E766F79616E';
wwv_flow_imp.g_varchar2_table(35468) := '7420756E652076616C65757220766172636861723220617520666F726D617420414141412D4D4D2D4A4A2048483234203A4D493A5353222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C75';
wwv_flow_imp.g_varchar2_table(35469) := '6520696E206E756D62657220666F726D6174223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E652076616C65757220766172636861723220617520666F726D6174206E756DC3A97269717565222C22504C2F53514C2045';
wwv_flow_imp.g_varchar2_table(35470) := '787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A2245787072657373696F6E20504C2F53514C2072656E766F79616E7420756E652076616C657572207661726368617232222C22504C2F53514C2045787072';
wwv_flow_imp.g_varchar2_table(35471) := '657373696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A2245787072657373696F6E20504C2F53514C2072656E766F79616E74206C5C27686F726F6461746167652061766563206C6520667573656175';
wwv_flow_imp.g_varchar2_table(35472) := '20686F7261697265222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A22466F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076616C65757220626F6F';
wwv_flow_imp.g_varchar2_table(35473) := '6CC3A9656E6E65222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120646174652076616C7565223A22436F72707320646520666F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076616C6575';
wwv_flow_imp.g_varchar2_table(35474) := '722064652064617465222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A22436F72707320646520666F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076';
wwv_flow_imp.g_varchar2_table(35475) := '616C657572206E756DC3A97269717565222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22436F72707320646520666F6E637469';
wwv_flow_imp.g_varchar2_table(35476) := '6F6E20504C2F53514C2072656E766F79616E7420756E20686F726F646174616765206176656320756E652076616C6575722064652066757365617520686F7261697265222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67';
wwv_flow_imp.g_varchar2_table(35477) := '20612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22436F72707320646520666F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076616C6575';
wwv_flow_imp.g_varchar2_table(35478) := '7220766172636861723220617520666F726D617420414141412D4D4D2D4A4A2048483234203A4D493A535320545A52222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E';
wwv_flow_imp.g_varchar2_table(35479) := '20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22436F72707320646520666F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076616C65757220766172636861723220617520666F726D617420414141';
wwv_flow_imp.g_varchar2_table(35480) := '412D4D4D2D4A4A2048483234203A4D493A5353222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22436F72707320646520666F';
wwv_flow_imp.g_varchar2_table(35481) := '6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076616C65757220766172636861723220617520666F726D6174206E756DC3A97269717565222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120';
wwv_flow_imp.g_varchar2_table(35482) := '76617263686172322076616C7565223A22436F72707320646520666F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E652076616C657572207661726368617232222C22504C2F53514C2046756E6374696F6E20426F6479207265747572';
wwv_flow_imp.g_varchar2_table(35483) := '6E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22436F72707320646520666F6E6374696F6E20504C2F53514C2072656E766F79616E7420756E20686F726F64617461676520617665632066757365617520686F7261697265';
wwv_flow_imp.g_varchar2_table(35484) := '222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A224573706163652072C3A973657276C3A9222C22506F74656E7469616C2047726F757073223A2247726F7570657320706F74656E7469656C73222C22506F74656E74';
wwv_flow_imp.g_varchar2_table(35485) := '69616C205374617274657273223A2244C3A96D61727261676520706F74656E7469656C222C22506F74656E7469616C205374617274696E672047726F757073223A2247726F757065732064652064C3A97061727420706F74656E7469656C73222C22506F';
wwv_flow_imp.g_varchar2_table(35486) := '74656E7469616C205374617274696E67205573657273223A225574696C697361746575727320696E69746961757820706F74656E7469656C73222C22506F74656E7469616C205573657273223A225574696C697361746575727320706F74656E7469656C';
wwv_flow_imp.g_varchar2_table(35487) := '73222C225072696F72697479223A225072696F726974C3A9222C2250726F6365737320646F63756D656E746174696F6E223A22446F63756D656E746174696F6E2064752070726F636573737573222C2250726F6365737320686173206D756C7469706C65';
wwv_flow_imp.g_varchar2_table(35488) := '20626C616E6B207374617274206576656E7473223A224C652070726F636573737573206120706C7573696575727320C3A976C3A96E656D656E74732064652064C3A962757420C3A020626C616E632E222C2250726F63657373204944223A224944207472';
wwv_flow_imp.g_varchar2_table(35489) := '616974656D656E74222C2250726F63657373206973206D697373696E6720656E64206576656E74223A22556E20C3A976C3A86E656D656E742064652066696E206D616E7175652061752070726F6365737375732E222C2250726F63657373206973206D69';
wwv_flow_imp.g_varchar2_table(35490) := '7373696E67207374617274206576656E74223A224C652070726F636573737573206E5C27612070617320645C27C3A976C3A86E656D656E742064652064C3A96275742E222C2250726F63657373206E616D65223A224E6F6D2064752070726F6365737375';
wwv_flow_imp.g_varchar2_table(35491) := '73222C2250726F63657373205072696F72697479223A225072696F726974C3A92064752070726F636573737573222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E223A22537461747574206475207472616974656D';
wwv_flow_imp.g_varchar2_table(35492) := '656E7420617072C3A8732066696E20646520636F6E74726174222C2250726F63657373205661726961626C652028417272617929223A225661726961626C652064652070726F63657373757320287461626C65617529222C2250726F6365737320566172';
wwv_flow_imp.g_varchar2_table(35493) := '6961626C6520284C69737429223A225661726961626C652064652070726F63657373757320286C6973746529222C2250726F63657373205661726961626C65223A225661726961626C652064652070726F636573737573222C2250726F63657373223A22';
wwv_flow_imp.g_varchar2_table(35494) := '50726F636573737573222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A22466F75726E6972206465732076616C6575727320706F7572206C65206D6F64C3A86C6520646520636F75727269656C222C225265';
wwv_flow_imp.g_varchar2_table(35495) := '6365697665207461736B223A2254C3A26368652064652072C3A963657074696F6E206465206D657373616765222C2252656365697665205461736B223A2254C3A26368652064652072C3A963657074696F6E206465206D657373616765222C225265646F';
wwv_flow_imp.g_varchar2_table(35496) := '223A2252C3A97461626C6972222C2252656D6F7665223A225375707072696D6572222C225265706C7920546F223A2252C3A9706F6E64726520C3A0222C22526571756573742056616C756520666F7220506167652043616C6C223A2256616C7565206465';
wwv_flow_imp.g_varchar2_table(35497) := '206C612072657175C3AA746520706F7572206C5C27617070656C206465206C612070616765222C2252657175657374223A2252657175C3AA7465222C22526573756C74205661726961626C65223A225661726961626C652064652072C3A973756C746174';
wwv_flow_imp.g_varchar2_table(35498) := '222C2252657475726E205061796C6F616420496E746F223A2252656E766F796572206C6120636861726765207574696C652064616E73222C22526F6C65223A2252C3B46C65222C2253617665223A22456E726567697374726572222C225363686564756C';
wwv_flow_imp.g_varchar2_table(35499) := '65722045787072657373696F6E223A2245787072657373696F6E20647520706C616E696669636174657572222C225363686564756C696E67223A22506C616E696669636174696F6E222C22536372697074207461736B223A2254C3A26368652064652073';
wwv_flow_imp.g_varchar2_table(35500) := '6372697074222C22536372697074205461736B223A2254C3A263686520646520736372697074222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A22436F6368657A206365747465206361736520736920';
wwv_flow_imp.g_varchar2_table(35501) := '6365206469616772616D6D65207065757420C3AA7472652064C3A96D617272C3A9222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A2253C3A9';
wwv_flow_imp.g_varchar2_table(35502) := '6C656374696F6E6E657A207369206365206469616772616D6D65207065757420C3AA747265207574696C6973C3A92064616E7320756E652061637469766974C3A920617070656CC3A9652E222C2253656E6420456D61696C20496D6D6564696174656C79';
wwv_flow_imp.g_varchar2_table(35503) := '223A22456E766F796572206C6520636F75727269656C20696D6DC3A964696174656D656E74222C2253656E64204D61696C223A22456E766F79657220756E20636F75727269657220C3A96C656374726F6E69717565222C2253656E64207461736B223A22';
wwv_flow_imp.g_varchar2_table(35504) := '54C3A2636865206465207479706520C3A96D697373696F6E206465206D657373616765222C2253656E64205461736B223A2254C3A2636865206465207479706520C3A96D697373696F6E206465206D657373616765222C2253657175656E636520666C6F';
wwv_flow_imp.g_varchar2_table(35505) := '77223A22466C75782064652073C3A97175656E6365222C2253657175656E6365223A2253C3A97175656E6365222C2253657175656E6365466C6F772069732061206475706C6963617465223A224C6520666C75782064652073C3A97175656E6365206573';
wwv_flow_imp.g_varchar2_table(35506) := '7420656E20646F75626C652E222C2253657175656E7469616C206D756C74692D696E7374616E6365223A224D756C74692D696E7374616E63652073C3A97175656E7469656C6C65222C2253657276696365207461736B223A2254C3A26368652064652073';
wwv_flow_imp.g_varchar2_table(35507) := '657276696365222C2253657276696365205461736B223A2254C3A26368652064652073657276696365222C2253657420636F6C6F72223A2244C3A966696E6972206C6120636F756C657572222C225369676E616C20626F756E64617279206576656E7420';
wwv_flow_imp.g_varchar2_table(35508) := '286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652066726F6E7469C3A872652064652074797065207369676E616C20286E6F6E20696E74657272757074696629222C225369676E616C20626F756E64617279206576';
wwv_flow_imp.g_varchar2_table(35509) := '656E74223A22C38976C3A96E656D656E742064652066726F6E7469C3A872652064652074797065207369676E616C222C225369676E616C20656E64206576656E74223A22C38976C3A96E656D656E742064652066696E2064652074797065207369676E61';
wwv_flow_imp.g_varchar2_table(35510) := '6C222C225369676E616C20456E64204576656E74223A22C38976C3A96E656D656E742064652066696E2064652074797065207369676E616C222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A224576C3A96E656D';
wwv_flow_imp.g_varchar2_table(35511) := '656E7420696E7465726DC3A96469616972652064652074797065207369676E616C202872C3A963657074696F6E29222C225369676E616C20496E7465726D656469617465204361746368204576656E74223A224576C3A96E656D656E7420696E7465726D';
wwv_flow_imp.g_varchar2_table(35512) := 'C3A96469616972652064652074797065207369676E616C202872C3A963657074696F6E29222C225369676E616C20696E7465726D656469617465207468726F77206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A964696169726520';
wwv_flow_imp.g_varchar2_table(35513) := '64652074797065207369676E616C2028C3A96D697373696F6E29222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065207369';
wwv_flow_imp.g_varchar2_table(35514) := '676E616C2028C3A96D697373696F6E29222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652064C3A96275742064652074797065207369676E616C20286E6F6E';
wwv_flow_imp.g_varchar2_table(35515) := '20696E74657272757074696629222C225369676E616C207374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A96275742064652074797065207369676E616C222C225369676E616C205374617274204576656E74223A22C38976';
wwv_flow_imp.g_varchar2_table(35516) := 'C3A96E656D656E742064652064C3A96275742064652074797065207369676E616C222C225369676E616C223A225369676E616C222C2253696D706C65204D657373616765223A224D6573736167652073696D706C65222C2253514C207175657279202863';
wwv_flow_imp.g_varchar2_table(35517) := '6F6C6F6E2064656C696D69746564206C69737429223A2252657175C3AA74652053514C20286C697374652073C3A9706172C3A965207061722064657320646575782D706F696E747329222C2253514C20717565727920284A534F4E20617272617929223A';
wwv_flow_imp.g_varchar2_table(35518) := '2252657175C3AA74652053514C20287461626C65617520646520646F6E6EC3A9657329222C2253514C207175657279202873696E676C652076616C756529223A2252657175C3AA74652053514C202876616C65757220756E6971756529222C2253514C20';
wwv_flow_imp.g_varchar2_table(35519) := '71756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A2252657175C3AA74652053514C207265746F75726E616E7420756E65206C697374652073C3A9706172C3A965207061722064657320646575782D706F';
wwv_flow_imp.g_varchar2_table(35520) := '696E7473222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A2252657175C3AA74652053514C2072656E766F79616E7420756E207461626C656175204A534F4E222C2253514C2071756572792072657475726E69';
wwv_flow_imp.g_varchar2_table(35521) := '6E6720612073696E676C6520646174652076616C7565223A2252657175C3AA74652053514C2072656E766F79616E7420756E652076616C657572206465206461746520756E69717565222C2253514C2071756572792072657475726E696E672061207369';
wwv_flow_imp.g_varchar2_table(35522) := '6E676C65206E756D6265722076616C7565223A2252657175C3AA74652053514C2072656E766F79616E7420756E652076616C657572206E756DC3A9726971756520756E69717565222C2253514C2071756572792072657475726E696E6720612073696E67';
wwv_flow_imp.g_varchar2_table(35523) := '6C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2252657175C3AA74652053514C2072656E766F79616E7420756E20686F726F64617461676520756E69717565206176656320756E652076616C6575722064652066';
wwv_flow_imp.g_varchar2_table(35524) := '757365617520686F7261697265222C2253514C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C7565223A2252657175C3AA74652053514C2072656E766F79616E7420756E65207365756C652076616C6575';
wwv_flow_imp.g_varchar2_table(35525) := '72207661726368617232222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A2252657175C3AA74652053514C2072656E766F79616E74206C5C27686F726F64617461676520617665';
wwv_flow_imp.g_varchar2_table(35526) := '63206C652066757365617520686F7261697265222C2253514C20717565727920746F20676574206174746163686D656E74223A2252657175C3AA74652053514C20706F7572206F6274656E6972206C6573207069C3A8636573206A6F696E746573222C22';
wwv_flow_imp.g_varchar2_table(35527) := '53514C207175657279223A2252657175C3AA74652053514C222C2253514C205175657279223A2252657175C3AA74652053514C222C225374617274206576656E74206973206D697373696E67206576656E7420646566696E6974696F6E223A224C612064';
wwv_flow_imp.g_varchar2_table(35528) := 'C3A966696E6974696F6E206465206C5C27C3A976C3A86E656D656E742064652064C3A962757420657374206D616E7175616E74652E222C225374617274206576656E74206D75737420626520626C616E6B223A224C5C27C3A976C3A86E656D656E742064';
wwv_flow_imp.g_varchar2_table(35529) := '652064C3A962757420646F697420C3AA74726520C3A020626C616E632E222C225374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A9627574222C225374617274204576656E74223A22C38976C3A96E656D656E742064652064';
wwv_flow_imp.g_varchar2_table(35530) := 'C3A9627574222C2253746174696320646174652076616C7565223A2256616C6575722064652064617465207374617469717565222C22537461746963204944223A224944207374617469717565222C22537461746963206E756D6265722076616C756522';
wwv_flow_imp.g_varchar2_table(35531) := '3A2256616C657572206E756DC3A97269717565207374617469717565222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22486F726F64617461676520737461746971756520617665632076616C65';
wwv_flow_imp.g_varchar2_table(35532) := '75722064652066757365617520686F7261697265222C225374617469632076617263686172322076616C7565223A2256616C657572207661726368617232207374617469717565222C22537461746963223A225374617469717565222C22537472696E67';
wwv_flow_imp.g_varchar2_table(35533) := '223A22436861C3AE6E6520646520636172616374C3A8726573222C225375622070726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A224C6520736F75732D70726F636573737573206120706C75736965';
wwv_flow_imp.g_varchar2_table(35534) := '75727320C3A976C3A96E656D656E74732064652064C3A962757420C3A020626C616E632E222C225375622070726F63657373206973206D697373696E6720656E64206576656E74223A22556E20C3A976C3A96E656D656E742064652066696E206D616E71';
wwv_flow_imp.g_varchar2_table(35535) := '756520617520736F75732D70726F6365737375732E222C225375622070726F63657373206973206D697373696E67207374617274206576656E74223A224C6520736F75732D70726F636573737573206E5C27612070617320645C27C3A976C3A86E656D65';
wwv_flow_imp.g_varchar2_table(35536) := '6E742064652064C3A96275742E222C225375622D70726F636573732028636F6C6C617073656429223A2250726F636573737573207365636F6E64616972652028636F6D7072657373C3A929222C225375622D70726F636573732028657870616E64656429';
wwv_flow_imp.g_varchar2_table(35537) := '223A22536F75732D70726F636573737573202876657273696F6E2064C3A976656C6F7070C3A96529222C225375622D70726F63657373223A2273756270726F63657373222C225375626A656374223A2253756A6574222C225461736B20446566696E6974';
wwv_flow_imp.g_varchar2_table(35538) := '696F6E223A2244C3A966696E6974696F6E206465206C612074C3A2636865222C225461736B20537461746963204944223A2249442073746174697175652064652074C3A2636865222C225461736B2054797065223A22547970652064652074C3A2636865';
wwv_flow_imp.g_varchar2_table(35539) := '222C225461736B223A2254C3A2636865222C2254656D706C617465204944223A224944206475206D6F64C3A86C65222C2254656D706C617465223A224D6F64C3A86C65222C225465726D696E61746520656E64206576656E74223A22C38976C3A96E656D';
wwv_flow_imp.g_varchar2_table(35540) := '656E742064652066696E2064652074797065207465726D696E6169736F6E222C225465726D696E61746520456E64204576656E74223A22C38976C3A96E656D656E742064652066696E2064652074797065207465726D696E6169736F6E222C225465726D';
wwv_flow_imp.g_varchar2_table(35541) := '696E61746564223A225465726D696EC3A9222C2254657874223A225465787465222C2254696D6520756E74696C207468652074696D657220666972657320616761696E223A22447572C3A965206176616E74206C65732064C3A9636C656E6368656D656E';
wwv_flow_imp.g_varchar2_table(35542) := '74732073756976616E7473206475206D696E7574657572222C2254696D6520756E74696C207468652074696D6572206669726573206669727374223A22447572C3A965206176616E74206C65207072656D6965722064C3A9636C656E6368656D656E7420';
wwv_flow_imp.g_varchar2_table(35543) := '6475206D696E7574657572222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22C38976C3A96E656D656E742064652066726F6E7469C3A872652064652074797065206D696E75746575722028';
wwv_flow_imp.g_varchar2_table(35544) := '6E6F6E20696E74657272757074696629222C2254696D657220626F756E64617279206576656E74223A22C38976C3A96E656D656E742064652066726F6E7469C3A872652064652074797065206D696E7574657572222C2254696D657220446566696E6974';
wwv_flow_imp.g_varchar2_table(35545) := '696F6E2054797065223A22547970652064652064C3A966696E6974696F6E206465206D696E7574657572222C2254696D657220446566696E6974696F6E223A2244C3A966696E6974696F6E206475206D696E7574657572222C2254696D65722044757261';
wwv_flow_imp.g_varchar2_table(35546) := '74696F6E223A22447572C3A965206475206D696E7574657572222C2254696D657220696E7465726D656469617465206361746368206576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206D696E75';
wwv_flow_imp.g_varchar2_table(35547) := '74657572202872C3A963657074696F6E29222C2254696D657220496E7465726D656469617465204361746368204576656E74223A22C38976C3A96E656D656E7420696E7465726DC3A96469616972652064652074797065206D696E7574657572202872C3';
wwv_flow_imp.g_varchar2_table(35548) := 'A963657074696F6E29222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576C3A96E656D656E742064652064C3A96275742064652074797065206D696E757465757220286E6F6E20696E74657272';
wwv_flow_imp.g_varchar2_table(35549) := '757074696629222C2254696D6572207374617274206576656E74223A22C38976C3A96E656D656E742064652064C3A96275742064652074797065206D696E7574657572222C2254696D6572205374617274204576656E74223A22C38976C3A96E656D656E';
wwv_flow_imp.g_varchar2_table(35550) := '742064652064C3A96275742064652074797065206D696E7574657572222C2254696D6572223A224D696E7574657572222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F72';
wwv_flow_imp.g_varchar2_table(35551) := '6D6174223A22486F726F64617461676520617665632066757365617520686F726169726520617520666F726D61742049534F2038363031206F75204F7261636C65222C2254696D657374616D7020776974682054696D65205A6F6E65223A22486F726F64';
wwv_flow_imp.g_varchar2_table(35552) := '617461676520617665632066757365617520686F7261697265222C22546F223A2241222C22546F67676C65206E6F6E2D696E74657272757074696E67223A2242617363756C65722073616E7320696E74657272757074696F6E222C225472616E73616374';
wwv_flow_imp.g_varchar2_table(35553) := '696F6E223A225472616E73616374696F6E222C22556E646F223A22416E6E756C6572222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A226469207B64697D20696E636F6E6E7520706F7572206C';
wwv_flow_imp.g_varchar2_table(35554) := '5C27C3A96CC3A96D656E74207B73656D616E7469637D222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A22666C6F77456C656D656E74207B656C656D';
wwv_flow_imp.g_varchar2_table(35555) := '656E747D206E6F6E207265636F6E6E752064616E73206C6520636F6E7465787465207B636F6E746578747D222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A2262';
wwv_flow_imp.g_varchar2_table(35556) := '706D6E456C656D656E74206E6F6E207072697320656E2063686172676520706F7572207B706C616E657D203A207B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A225574696C69736572206C6573206DC3A97461';
wwv_flow_imp.g_varchar2_table(35557) := '646F6E6EC3A965732041504558222C225573652054656D706C617465223A225574696C6973657220756E206D6F64C3A86C65222C2255736564206469616772616D2076657273696F6E223A2256657273696F6E206465206469616772616D6D6520757469';
wwv_flow_imp.g_varchar2_table(35558) := '6C6973C3A965222C2255736572207461736B223A2254C3A2636865207574696C69736174657572222C2255736572205461736B223A2254C3A2636865207574696C69736174657572222C2256616C7565223A2256616C657572222C225661726368617232';
wwv_flow_imp.g_varchar2_table(35559) := '223A225661726368617232222C225661726961626C652045787072657373696F6E73223A2245787072657373696F6E73206465207661726961626C6573222C2256657273696F6E204E616D65223A224E6F6D206465206C612076657273696F6E222C2256';
wwv_flow_imp.g_varchar2_table(35560) := '657273696F6E696E67223A2247657374696F6E206465732076657273696F6E73222C225761697420666F7220636F6D706C6574696F6E223A22417474656E647265206C612066696E206465206C5C276F70C3A9726174696F6E222C225A6F6F6D20496E22';
wwv_flow_imp.g_varchar2_table(35561) := '3A22416772616E646972222C225A6F6F6D204F7574223A2252C3A96475697265227D27297D2C383536393A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D204572726F72732C';
wwv_flow_imp.g_varchar2_table(35562) := '207B7761726E696E67737D205761726E696E6773223A227B6572726F72737D206572726F72692C207B7761726E696E67737D20617676657274656E7A65222C227B73656D616E7469637D237B736964657D20526566206E6F742073706563696669656422';
wwv_flow_imp.g_varchar2_table(35563) := '3A225269666572696D656E746F207B73656D616E7469637D237B736964657D206E6F6E20737065636966696361746F222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312D557267656E74222C22322D48696768223A2232';
wwv_flow_imp.g_varchar2_table(35564) := '2D48696768222C22332D4D656469756D223A22332D4D656469756D222C22342D4C6F77223A22342D4C6F77222C22352D4C6F77657374223A22352D4C6F77657374222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073';
wwv_flow_imp.g_varchar2_table(35565) := '706C6974206174207468652073616D652074696D65223A22556E2067617465776179206E6F6E20646F7672656262652065737365726520756E69746F2065206672617A696F6E61746F20636F6E74656D706F72616E65616D656E7465222C224163746976';
wwv_flow_imp.g_varchar2_table(35566) := '617465206372656174652F72656D6F766520737061636520746F6F6C223A224174746976617265206C6F20737472756D656E746F20646920637265617A696F6E652F72696D6F7A696F6E652064656C6C6F207370617A696F222C22416374697661746520';
wwv_flow_imp.g_varchar2_table(35567) := '676C6F62616C20636F6E6E65637420746F6F6C223A22417474697661206C6F20737472756D656E746F20646920636F6E6E657373696F6E6520676C6F62616C65222C2241637469766174652068616E6420746F6F6C223A22417474697661206C6F207374';
wwv_flow_imp.g_varchar2_table(35568) := '72756D656E746F206D616E6F222C224163746976617465206C6173736F20746F6F6C223A22417474697661206C6F20737472756D656E746F206C617A6F222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F';
wwv_flow_imp.g_varchar2_table(35569) := '6C223A224174746976617265206C6F20737472756D656E746F20646920637265617A696F6E652F72696D6F7A696F6E652064656C6C6F207370617A696F222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A2241';
wwv_flow_imp.g_varchar2_table(35570) := '7474697661206C6F20737472756D656E746F20646920636F6E6E657373696F6E6520676C6F62616C65222C224163746976617465207468652068616E6420746F6F6C223A2241747469766120737472756D656E746F206D616E6F222C2241637469766174';
wwv_flow_imp.g_varchar2_table(35571) := '6520746865206C6173736F20746F6F6C223A22417474697661206C6F20737472756D656E746F206C6173736F222C224163746976697479207265666572656E6365223A225269666572696D656E746F2061747469766974C3A0222C2241642D686F63223A';
wwv_flow_imp.g_varchar2_table(35572) := '22416420686F63222C22416464206C616E652061626F7665223A2241676769756E676920436F7273696120736F707261222C22416464206C616E652062656C6F77223A2241676769756E676920436F7273696120736F74746F222C224164642074657874';
wwv_flow_imp.g_varchar2_table(35573) := '20616E6E6F746174696F6E223A2241676769756E676920616E6E6F74617A696F6E6520746573746F222C224166746572204D65726765223A22446F706F206C5C27756E696F6E65222C224166746572205461736B223A22446F706F20696C207461736B22';
wwv_flow_imp.g_varchar2_table(35574) := '2C22416C69676E20656C656D656E747320626F74746F6D223A22416C6C696E656120656C656D656E746920696E20626173736F222C22416C69676E20656C656D656E74732063656E746572223A22416C6C696E656120696C2063656E74726F20656C656D';
wwv_flow_imp.g_varchar2_table(35575) := '656E7469222C22416C69676E20656C656D656E7473206C656674223A22416C6C696E656120656C656D656E746920612073696E6973747261222C22416C69676E20656C656D656E7473206D6964646C65223A22416C6C696E656120656C656D656E746920';
wwv_flow_imp.g_varchar2_table(35576) := '616C2063656E74726F222C22416C69676E20656C656D656E7473207269676874223A22416C6C696E656120656C656D656E7469206120646573747261222C22416C69676E20656C656D656E747320746F70223A22416C6C696E656120656C656D656E7469';
wwv_flow_imp.g_varchar2_table(35577) := '20696E20616C746F222C22416C69676E20656C656D656E7473223A22416C6C696E656120656C656D656E7469222C22416C6C6F772042696E64696E67223A22436F6E73656E7469206173736F6369617A696F6E65222C22616C72656164792072656E6465';
wwv_flow_imp.g_varchar2_table(35578) := '726564207B656C656D656E747D223A22736F74746F20696C207265706F72747C7369646520627920736964657C6E756F76612066696E6573747261222C224150455820417070726F76616C223A22417070726F76617A696F6E652041504558222C224150';
wwv_flow_imp.g_varchar2_table(35579) := '45582050616765223A22506167696E612041504558222C224150455820526F6C65223A2252756F6C6F2041504558222C22415045582053696D706C6520466F726D223A22466F726D2073656D706C6963652041504558222C22417070656E6420636F6D70';
wwv_flow_imp.g_varchar2_table(35580) := '656E736174696F6E206163746976697479223A2241676769756E67692061747469766974C3A020726574726962757A696F6E65222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22';
wwv_flow_imp.g_varchar2_table(35581) := '41676769756E6769204576656E746F206469204361747475726120496E7465726D6564696120436F6E64697A696F6E616C65222C22417070656E6420656E64206576656E74223A2241676769756E6769204576656E746F2064692046696E65222C224170';
wwv_flow_imp.g_varchar2_table(35582) := '70656E642067617465776179223A2241676769756E67692047617465776179222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A2241676769756E6769204576656E746F20496E7465726D6564696F2F4C69';
wwv_flow_imp.g_varchar2_table(35583) := '6D697465222C22417070656E64206D65737361676520696E7465726D656469617465206361746368206576656E74223A2241676769756E6769204576656E746F206469204361747475726120496E7465726D6564696120436F6E64697A696F6E616C6522';
wwv_flow_imp.g_varchar2_table(35584) := '2C22417070656E642072656365697665207461736B223A2241676769756E6769205269636576692041747469766974C3A0222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A2241676769756E67';
wwv_flow_imp.g_varchar2_table(35585) := '69205369676E616C20696E7465726D656469617465206361746368206576656E74222C22417070656E64207461736B223A2241676769756E67692041747469766974C3A0222C22417070656E64207465787420616E6E6F746174696F6E223A2241676769';
wwv_flow_imp.g_varchar2_table(35586) := '756E676920616E6E6F74617A696F6E6520646920746573746F222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A2241676769756E6769204576656E746F206469204361747475726120496E746572';
wwv_flow_imp.g_varchar2_table(35587) := '6D656469612064656C2054696D6572222C224170706C69636174696F6E204944223A224944206170706C6963617A696F6E65222C224170706C69636174696F6E223A224170706C6963617A696F6E65222C2241737369676E6D656E74223A224173736567';
wwv_flow_imp.g_varchar2_table(35588) := '6E617A696F6E65222C224174746163686D656E74223A22416C6C656761746F222C224261636B67726F756E64205461736B2053657373696F6E223A2253657373696F6E65207461736B20696E206261636B67726F756E64222C22424343223A2243636E22';
wwv_flow_imp.g_varchar2_table(35589) := '2C224265666F7265204576656E74223A225072696D612064656C6C5C276576656E746F222C224265666F72652053706C6974223A225072696D612064656C206672617A696F6E616D656E746F222C224265666F7265205461736B223A225072696D612064';
wwv_flow_imp.g_varchar2_table(35590) := '656C207461736B222C2242696E642070616765206974656D7320286465707265636174656429223A224173736F63696120656C656D656E746920706167696E6120286F62736F6C65746F29222C2242696E6420706172616D657465722076616C75657322';
wwv_flow_imp.g_varchar2_table(35591) := '3A224173736F6369612076616C6F726920706172616D65747269222C2242696E642070726F63657373207661726961626C6573223A224173736F63696120766172696162696C692070726F636573736F222C22426C696E6420636172626F6E20636F7079';
wwv_flow_imp.g_varchar2_table(35592) := '20726563697069656E74287329223A2244657374696E617461726920636F70696120636172626F6E65206E6173636F737461222C22426F64792048544D4C223A22436F72706F2048544D4C222C22426F64792054657874223A22436F72706F2064656C20';
wwv_flow_imp.g_varchar2_table(35593) := '746573746F222C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A22476C69206576656E7469206C696D6974652064';
wwv_flow_imp.g_varchar2_table(35594) := '7572616E7465206C5C2769746572617A696F6E65206465692070726F6365737369207365636F6E64617269206E6F6E20736F6E6F2061747475616C6D656E746520737570706F7274617469222C22427573696E657373205265666572656E6365223A2252';
wwv_flow_imp.g_varchar2_table(35595) := '69666572696D656E746F20617A69656E64616C65222C22427573696E6573732072756C65207461736B223A2241747469766974C3A0206469205265676F6C6520417A69656E64616C69222C22427573696E6573732052756C65205461736B223A22546173';
wwv_flow_imp.g_varchar2_table(35596) := '6B207265676F6C6120627573696E657373222C22627573696E6573735F726566223A22627573696E6573735F726566222C2243616C6C206163746976697479223A2241747469766974C3A020646920436869616D617461222C2243616C6C204163746976';
wwv_flow_imp.g_varchar2_table(35597) := '697479223A22436869616D612041747469766974C3A0222C2243616C6C6564204469616772616D223A224469616772616D6D6120636869616D61746F222C2243616E63656C20626F756E64617279206576656E74223A224576656E746F20646920416E6E';
wwv_flow_imp.g_varchar2_table(35598) := '756C6C616D656E746F2064656C204C696D697465222C2243616E63656C20656E64206576656E74223A224576656E746F20646920416E6E756C6C616D656E746F2064692046696E65222C2243616E63656C223A22416E6E756C6C61222C22436172626F6E';
wwv_flow_imp.g_varchar2_table(35599) := '20636F707920726563697069656E74287329223A2244657374696E617461726920636F70696120636172626F6E65222C2243617465676F72792056616C7565223A2256616C6F72652063617465676F726961222C224343223A224343222C224368616E67';
wwv_flow_imp.g_varchar2_table(35600) := '6520656C656D656E74223A224D6F64696669636120656C656D656E746F222C224368616E67652074797065223A225469706F206D6F646966696361222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A2243616E63';
wwv_flow_imp.g_varchar2_table(35601) := '656C6C612076616C6F72652063616368652070657220636869616D61746120646920706167696E61222C22436C656172204361636865223A2243616E63656C6C61206361636865222C22436C6F62223A22434C4F42222C22436F6465223A22436F646963';
wwv_flow_imp.g_varchar2_table(35602) := '65222C22436F6C6C61626F726174696F6E223A22436F6C6C61626F72617A696F6E65222C22436F6C6C617073656420506F6F6C223A22506F6F6C20636F6D70726573736F222C22436F6C6C6170736564205375622050726F63657373223A2250726F6365';
wwv_flow_imp.g_varchar2_table(35603) := '73736F205365636F6E646172696F20436F6D70726573736F222C22436F6C6C656374696F6E2054797065223A225469706F20526163636F6C7461222C22436F6C6C656374696F6E223A22526163636F6C7461222C22436F6D70656E7361746520456E6420';
wwv_flow_imp.g_varchar2_table(35604) := '4576656E74223A224576656E746F20646920436F6D70656E73617A696F6E652064692046696E65222C22436F6D70656E7361746520496E7465726D656469617465205468726F77204576656E74223A224576656E746F206469204C616E63696F20496E74';
wwv_flow_imp.g_varchar2_table(35605) := '65726D6564696F20646920436F6D70656E73617A696F6E65222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A224576656E746F206469204C696D69746520646920436F6D70656E73617A696F6E65222C22436F6D70656E73';
wwv_flow_imp.g_varchar2_table(35606) := '6174696F6E20656E64206576656E74223A224576656E746F20646920436F6D70656E73617A696F6E652064692046696E65222C22436F6D70656E736174696F6E20696E7465726D656469617465207468726F77206576656E74223A224576656E746F2064';
wwv_flow_imp.g_varchar2_table(35607) := '69204C616E63696F20496E7465726D6564696F20646920436F6D70656E73617A696F6E65222C22436F6D70656E736174696F6E207374617274206576656E74223A224576656E746F20646920496E697A696F20646920436F6D70656E73617A696F6E6522';
wwv_flow_imp.g_varchar2_table(35608) := '2C22436F6D70656E736174696F6E223A22436F6D70656E73617A696F6E65222C22436F6D706C65746564223A22436F6D706C657461746F222C22436F6D706C6574696F6E20436F6E646974696F6E223A6E756C6C2C22436F6D706C657820676174657761';
wwv_flow_imp.g_varchar2_table(35609) := '79223A224761746577617920436F6D706C6573736F222C22436F6D706C65782047617465776179223A224761746577617920636F6D706C6573736F222C22436F6E646974696F6E2054797065223A225469706F20636F6E64697A696F6E65222C22436F6E';
wwv_flow_imp.g_varchar2_table(35610) := '646974696F6E223A22436F6E64697A696F6E65222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A225C5C224576656E746F206469204C696D69746520436F6E64697A696F6E61';
wwv_flow_imp.g_varchar2_table(35611) := '6C65202873656E7A6120696E74657272757A696F6E6529222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A224576656E746F206469204C696D69746520436F6E64697A696F6E616C65222C22436F6E646974696F6E616C2066';
wwv_flow_imp.g_varchar2_table(35612) := '6C6F77223A22466C7573736F20636F6E64697A696F6E616C65222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A224576656E746F206469204361747475726120496E7465726D6564696120436F6E64';
wwv_flow_imp.g_varchar2_table(35613) := '697A696F6E616C65222C22436F6E646974696F6E616C20496E7465726D656469617465204361746368204576656E74223A224576656E746F20646920726563757065726F20696E7465726D6564696F20636F6E64697A696F6E616C65222C22436F6E6469';
wwv_flow_imp.g_varchar2_table(35614) := '74696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646920496E697A696F20436F6E64697A696F6E616C65202873656E7A6120696E74657272757A696F6E6529222C22436F6E64697469';
wwv_flow_imp.g_varchar2_table(35615) := '6F6E616C207374617274206576656E74223A224576656E746F20646920496E697A696F20436F6E64697A696F6E616C65222C22436F6E646974696F6E616C205374617274204576656E74223A224576656E746F20696E697A696F20636F6E64697A696F6E';
wwv_flow_imp.g_varchar2_table(35616) := '616C65222C22436F6E6E65637420746F206F7468657220656C656D656E74223A22436F6C6C65676120616420616C74726F20656C656D656E746F222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22436F6E6E65747469207472';
wwv_flow_imp.g_varchar2_table(35617) := '616D697465204173736F6369617A696F6E65222C22436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E223A22436F6E6E65747469207574696C697A7A616E646F2044617461496E7075744173736F6369617A696F';
wwv_flow_imp.g_varchar2_table(35618) := '6E65222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A22436F6E6E65747469207573616E646F2053657175656E7A612F466C7573736F64694D6573736167676920';
wwv_flow_imp.g_varchar2_table(35619) := '6F204173736F6369617A696F6E65222C22436F707920627573696E657373207265666572656E6365223A22436F706961207269666572696D656E746F20617A69656E64616C65222C22636F7272656374696E67206D697373696E672062706D6E456C656D';
wwv_flow_imp.g_varchar2_table(35620) := '656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A22636F7272657A696F6E652064656C2076616C6F72652062706D6E456C656D656E74206D616E63616E746520696E207B706C616E657D20696E207B726F6F74456C656D';
wwv_flow_imp.g_varchar2_table(35621) := '656E747D222C22436F7272656C6174696F6E204B6579223A2243686961766520636F7272656C617A696F6E65222C22436F7272656C6174696F6E2056616C7565223A2256616C6F726520636F7272656C617A696F6E65222C22437265617465207B747970';
wwv_flow_imp.g_varchar2_table(35622) := '657D223A2243726561207B747970657D222C224372656174652064617461206F626A656374207265666572656E6365223A2243726561207269666572696D656E746F2061206F67676574746F2064617469222C2243726561746520646174612073746F72';
wwv_flow_imp.g_varchar2_table(35623) := '65207265666572656E6365223A2243726561207269666572696D656E746F2061206465706F7369746F2064617469222C2243726561746520446174614F626A6563745265666572656E6365223A224372656120446174614F626A6563745265666572656E';
wwv_flow_imp.g_varchar2_table(35624) := '6365222C22437265617465204461746153746F72655265666572656E6365223A2243726561204461746153746F72655265666572656E6365222C2243726561746520656E64206576656E74223A2243726561204576656E746F2064692046696E65222C22';
wwv_flow_imp.g_varchar2_table(35625) := '43726561746520456E644576656E74223A224372656120456E644576656E74222C2243726561746520657870616E646564207375622D70726F63657373223A22437265612070726F636573736F207365636F6E646172696F20657370616E736F222C2243';
wwv_flow_imp.g_varchar2_table(35626) := '726561746520657870616E6465642053756250726F63657373223A224372656172652053756250726F6365737320657370616E736F222C224372656174652067617465776179223A22437265612047617465776179222C22437265617465204761746577';
wwv_flow_imp.g_varchar2_table(35627) := '6179223A22437265612067617465776179222C224372656174652067726F7570223A22437265612067727570706F222C224372656174652047726F7570223A22437265612067727570706F222C2243726561746520496E7465726D6564696174652F426F';
wwv_flow_imp.g_varchar2_table(35628) := '756E64617279204576656E74223A2243726561206576656E746F20696E7465726D6564696F2F6C696D697461746F222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A2243726561204576656E746F64694C';
wwv_flow_imp.g_varchar2_table(35629) := '616E63696F496E7465726D6564696F2F4576656E746F4C696D697465222C22437265617465206E6577202E2E2E223A2243726561206E756F766F20E280A6222C2243726561746520706F6F6C2F7061727469636970616E74223A224372656120506F6F6C';
wwv_flow_imp.g_varchar2_table(35630) := '2F5061727465636970616E7465222C2243726561746520506F6F6C2F5061727469636970616E74223A224372656120706F6F6C2F7061727465636970616E7465222C22437265617465207374617274206576656E74223A2243726561206576656E746F20';
wwv_flow_imp.g_varchar2_table(35631) := '6469222C224372656174652053746172742054696D6572204576656E74223A2243726561206576656E746F2074696D657220646920617676696F222C224372656174652053746172744576656E74223A2243726561206576656E746F2064692061767669';
wwv_flow_imp.g_varchar2_table(35632) := '6F222C22437265617465207461736B223A2243726561207461736B222C22437265617465205461736B223A2243726561207461736B222C22437573746F6D20457874656E73696F6E223A22457374656E73696F6E6520706572736F6E616C697A7A617461';
wwv_flow_imp.g_varchar2_table(35633) := '222C22437573746F6D223A22506572736F6E616C697A7A61746F222C224379636C65202849534F203836303129223A224369636C6F202849534F203836303129222C224379636C6520284F7261636C6529223A224369636C6F20284F7261636C6529222C';
wwv_flow_imp.g_varchar2_table(35634) := '2244617461206F626A656374207265666572656E6365223A225269666572696D656E746F206F67676574746F2064617469222C2244617461204F626A656374205265666572656E6365223A225269666572696D656E746F206F67676574746F2064617469';
wwv_flow_imp.g_varchar2_table(35635) := '222C22446174612073746F7265207265666572656E6365223A225269666572696D656E746F20646174612073746F7265222C22446174612053746F7265205265666572656E6365223A225269666572696D656E746F20646174612073746F7265222C2244';
wwv_flow_imp.g_varchar2_table(35636) := '6174612054797065223A225469706F2064692064617469222C2244617465202849534F203836303129223A2244617461202849534F203836303129222C224461746520284F7261636C6529223A224461746120284F7261636C6529222C22446174652069';
wwv_flow_imp.g_varchar2_table(35637) := '6E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A2244617461206E656C20666F726D61746F20414141412D4D4D2D474720484832343A4D493A5353222C224461746520537472696E67223A22537472696E67612064617461';
wwv_flow_imp.g_varchar2_table(35638) := '222C2244617465223A2244617461222C2244656661756C74204170706C69636174696F6E204944223A224944206170706C6963617A696F6E6520707265646566696E69746F222C2244656661756C74204170706C69636174696F6E223A224170706C6963';
wwv_flow_imp.g_varchar2_table(35639) := '617A696F6E6520707265646566696E697461222C2244656661756C7420666C6F77223A22466C7573736F20707265646566696E69746F222C2244656661756C742050616765204944223A22494420706167696E6120707265646566696E69746F222C2244';
wwv_flow_imp.g_varchar2_table(35640) := '656661756C742050616765223A22506167696E6120707265646566696E697461222C2244656661756C7420557365726E616D65223A224E6F6D65207574656E746520707265646566696E69746F222C2244656C657465223A22456C696D696E61222C2244';
wwv_flow_imp.g_varchar2_table(35641) := '65736372697074696F6E223A224465736372697A696F6E65222C2244657461696C73223A224465747461676C69222C226469616772616D206E6F742070617274206F662062706D6E3A446566696E6974696F6E73223A226469616772616D6D61206E6F6E';
wwv_flow_imp.g_varchar2_table(35642) := '20696E636C75736F20696E2062706D6E3A446566696E697A696F6E69222C224469737472696275746520656C656D656E747320686F72697A6F6E74616C6C79223A2244697374726962756973636920656C656D656E7469206F72697A7A6F6E74616C6D65';
wwv_flow_imp.g_varchar2_table(35643) := '6E7465222C224469737472696275746520656C656D656E747320766572746963616C6C79223A2244697374726962756973636920656C656D656E746920696E20766572746963616C65222C2244697669646520696E746F207468726565206C616E657322';
wwv_flow_imp.g_varchar2_table(35644) := '3A2244697669646920696E2074726520636F72736965222C2244697669646520696E746F2074776F206C616E6573223A2244697669646920696E2064756520636F72736965222C22446F63756D656E746174696F6E223A22446F63756D656E74617A696F';
wwv_flow_imp.g_varchar2_table(35645) := '6E65222C22447565204F6E223A22446174612073636164656E7A61222C224475706C696361746520696E636F6D696E672073657175656E636520666C6F7773223A224475706C69636120666C757373692073657175656E7A6120696E20656E7472617461';
wwv_flow_imp.g_varchar2_table(35646) := '222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A224475706C69636120666C757373692073657175656E7A6120696E20757363697461222C224475726174696F6E202849534F203836303129223A22447572';
wwv_flow_imp.g_varchar2_table(35647) := '617461202849534F203836303129222C224475726174696F6E20284F7261636C6529223A2244757261746120284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C27';
wwv_flow_imp.g_varchar2_table(35648) := '44444420484832343A4D493A53535C2720666F726D6174223A22447572617461206E656C20666F726D61746F2049534F2038363031206F204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C27222C22652E672E';
wwv_flow_imp.g_varchar2_table(35649) := '2032332D4A554E2D323032372031343A31303A3030223A226164206573656D70696F2032332D4749552D323032372031343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A226164206573656D70696F2044';
wwv_flow_imp.g_varchar2_table(35650) := '442D4D4F4E2D5959595920484832343A4D493A5353222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E223A22656C656D';
wwv_flow_imp.g_varchar2_table(35651) := '656E746F207B656C656D656E747D206120637569206661207269666572696D656E746F207B7265666572656E6365647D237B70726F70657274797D206E6F6E20616E636F72612064697365676E61746F222C22456C656D656E7420646F63756D656E7461';
wwv_flow_imp.g_varchar2_table(35652) := '74696F6E223A22446F63756D656E74617A696F6E652064656C6C5C27656C656D656E746F222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A224C5C27656C656D656E';
wwv_flow_imp.g_varchar2_table(35653) := '746F20686120756E207469706F206E6F6E20636F6E73656E7469746F203C62706D6E3A436F6D706C6578476174657761793E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D657373616765537461727445';
wwv_flow_imp.g_varchar2_table(35654) := '76656E743E223A224C5C27656C656D656E746F20686120756E207469706F206E6F6E20636F6E73656E7469746F203C62706D6E3A4D65737361676553746172744576656E743E222C22456C656D656E742068617320646973616C6C6F7765642074797065';
wwv_flow_imp.g_varchar2_table(35655) := '203C62706D6E3A5369676E616C53746172744576656E743E223A224C5C27656C656D656E746F20686120756E207469706F206E6F6E20636F6E73656E7469746F203C62706D6E3A5369676E616C53746172744576656E743E222C22456C656D656E742068';
wwv_flow_imp.g_varchar2_table(35656) := '617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A224C5C27656C656D656E746F20686120756E207469706F206E6F6E20636F6E73656E7469746F203C62706D6E436F6E646974696F';
wwv_flow_imp.g_varchar2_table(35657) := '6E616C53746172744576656E743E222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063686172616374657273223A224C5C27494420656C656D656E746F20C3A8207069C3B9206C756E676F20646920353020636172617474';
wwv_flow_imp.g_varchar2_table(35658) := '657269222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A224C5C27494420656C656D656E746F206E6F6E20C3A820737461746F20616E636F7261206D6F646966696361746F222C22456C656D656E7420697320616E';
wwv_flow_imp.g_varchar2_table(35659) := '20696D706C6963697420656E64223A224CE28099656C656D656E746F20C3A820756E612066696E6520696D706C6963697461222C22456C656D656E7420697320616E20696D706C69636974207374617274223A224CE28099656C656D656E746F20C3A820';
wwv_flow_imp.g_varchar2_table(35660) := '756E20696E697A696F20696D706C696369746F222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65223A224574696368657474612F6E6F6D65206D616E63616E7465206E656C6C5C27656C656D656E746F222C22456C656D65';
wwv_flow_imp.g_varchar2_table(35661) := '6E74206973206E6F7420636F6E6E6563746564223A22456C656D656E746F206E6F6E20636F6E6E6573736F222C22656C656D656E74207265717569726564223A22656C656D656E746F206F62626C696761746F72696F222C22456D61696C20636F6E7465';
wwv_flow_imp.g_varchar2_table(35662) := '6E74223A22436F6E74656E75746F20652D6D61696C222C22456D61696C206F662074686520726563697069656E74287329223A22452D6D61696C2064656C2064657374696E61746172696F206F206465692064657374696E6174617269222C22456D6169';
wwv_flow_imp.g_varchar2_table(35663) := '6C206F66207468652073656E646572223A22452D6D61696C2064656C206D697474656E7465222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A22452D6D61696C20612063756920696E766961';
wwv_flow_imp.g_varchar2_table(35664) := '7265206C6120726973706F737461222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F76657320636F6E74656E7429223A225376756F746120706F6F6C202F207061727465636970616E7465202872696D756F766520696C2063';
wwv_flow_imp.g_varchar2_table(35665) := '6F6E74656E75746F29222C22456D70747920706F6F6C2F7061727469636970616E74223A22506F6F6C202F207061727465636970616E74652076756F746F222C22456E64206576656E74223A224576656E746F2064692046696E65222C22456E64204576';
wwv_flow_imp.g_varchar2_table(35666) := '656E74223A2246696E65206576656E746F222C22456E64706F696E74223A22456E64706F696E74222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E223A22496D6D657474657265206C6520657374656E73696F6E6920';
wwv_flow_imp.g_varchar2_table(35667) := '706572736F6E616C697A7A61746520636F6D65204A534F4E222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22496D6D65747465726520696C20636F6469636520504C2F53514C20646120657365';
wwv_flow_imp.g_varchar2_table(35668) := '67756972652E222C224572726F7220626F756E64617279206576656E74223A224576656E746F206469204C696D697465206469204572726F7265222C224572726F7220456E64204576656E74223A224572726F72652046696E65204576656E746F222C22';
wwv_flow_imp.g_varchar2_table(35669) := '4572726F7220656E64206576656E74223A224576656E746F206469204572726F72652064692046696E65222C224572726F72207374617274206576656E74223A224576656E746F20646920496E697A696F206469204572726F7265222C224572726F7222';
wwv_flow_imp.g_varchar2_table(35670) := '3A224572726F7265222C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206469206C696D6974617A696F6E652064656C6C5C27457363616C617A696F6E65202873';
wwv_flow_imp.g_varchar2_table(35671) := '656E7A6120696E74657272757A696F6E6529222C22457363616C6174696F6E20626F756E64617279206576656E74223A224576656E746F206469204C696D6974652064656C6C5C27457363616C617A696F6E65222C22457363616C6174696F6E20456E64';
wwv_flow_imp.g_varchar2_table(35672) := '204576656E74223A22457363616C6174696F6E204576656E746F2046696E65222C22457363616C6174696F6E20656E64206576656E74223A224576656E746F2064692046696E652064656C6C5C27457363616C617A696F6E65222C22457363616C617469';
wwv_flow_imp.g_varchar2_table(35673) := '6F6E20496E7465726D656469617465205468726F77204576656E74223A22457363616C6174696F6E204576656E746F2064692052696C617363696F20496E7465726D6564696F222C22457363616C6174696F6E20696E7465726D65646961746520746872';
wwv_flow_imp.g_varchar2_table(35674) := '6F77206576656E74223A224576656E746F206469204C616E63696F20496E7465726D6564696F20646920457363616C617A696F6E65222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22';
wwv_flow_imp.g_varchar2_table(35675) := '4576656E746F20646920496E697A696F20646920457363616C617A696F6E65202873656E7A6120696E74657272757A696F6E6529222C22457363616C6174696F6E207374617274206576656E74223A224576656E746F20646920496E697A696F20646920';
wwv_flow_imp.g_varchar2_table(35676) := '457363616C617A696F6E65222C22457363616C6174696F6E223A22457363616C617A696F6E65222C224576656E742042617365642047617465776179223A2247617465776179206469204576656E746F222C224576656E7420686173206D756C7469706C';
wwv_flow_imp.g_varchar2_table(35677) := '65206576656E7420646566696E6974696F6E73223A224C5C276576656E746F206861207069C3B920646566696E697A696F6E69206469206576656E746F222C224576656E74205375622050726F63657373223A224576656E746F2050726F636573736F20';
wwv_flow_imp.g_varchar2_table(35678) := '5365636F6E646172696F222C224576656E74207375622D70726F63657373223A224576656E746F2064692050726F636573736F205365636F6E646172696F222C224576656E742054797065223A225469706F206469206576656E746F222C224576656E74';
wwv_flow_imp.g_varchar2_table(35679) := '2D62617365642067617465776179223A2247617465776179206469204576656E746F222C224578636C75646564205374617274696E67205573657273223A225574656E746920696E697A69616C69206573636C757369222C224578636C75646564205573';
wwv_flow_imp.g_varchar2_table(35680) := '657273223A225574656E7469206573636C757369222C224578636C75736976652067617465776179223A2247617465776179204573636C757369766F222C224578636C75736976652047617465776179223A2247617465776179206573636C757369766F';
wwv_flow_imp.g_varchar2_table(35681) := '222C2245786563757461626C65223A2245736567756962696C65222C224578656375746520504C2F53514C223A2245736567756920504C2F53514C222C22457865637574696F6E223A2245736563757A696F6E65222C22457870616E64656420706F6F6C';
wwv_flow_imp.g_varchar2_table(35682) := '2F7061727469636970616E74223A22506F6F6C202F207061727465636970616E746520657370616E736F222C22457870616E646564205375622050726F63657373223A2250726F636573736F205365636F6E646172696F20657370616E736F222C224578';
wwv_flow_imp.g_varchar2_table(35683) := '7072657373696F6E20284C656761637929223A2245737072657373696F6E652028707265636564656E746529222C2245787072657373696F6E2054797065223A225469706F2065737072657373696F6E65222C2245787072657373696F6E223A22457370';
wwv_flow_imp.g_varchar2_table(35684) := '72657373696F6E65222C226661696C656420746F20696D706F7274207B656C656D656E747D223A22696D706F7274617A696F6E65206469207B656C656D656E747D206E6F6E207269757363697461222C22666C6F7720656C656D656E7473206D75737420';
wwv_flow_imp.g_varchar2_table(35685) := '6265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A22676C6920656C656D656E746920646920666C7573736F206465766F6E6F20657373657265206669676C6920646920706F6F6C2F7061727465636970616E746922';
wwv_flow_imp.g_varchar2_table(35686) := '2C22466C6F772073706C69747320696D706C696369746C79223A224469766973696F6E6920666C7573736F20696D706C6963697465222C22466F726D2054656D706C617465204974656D204E616D65223A224E6F6D6520656C656D656E746F206D6F6465';
wwv_flow_imp.g_varchar2_table(35687) := '6C6C6F20666F726D222C22466F726D2054656D706C617465204974656D223A22456C656D656E746F206D6F64656C6C6F20666F726D222C22466F726D2054656D706C617465223A224D6F64656C6C6F206D6F64756C6F222C22466F726D6174204D61736B';
wwv_flow_imp.g_varchar2_table(35688) := '223A224D6173636865726120666F726D61746F222C22466F726D61744D61736B223A22466F726D61744D61736B222C2246726F6D223A224461222C2246756E6374696F6E20426F647920284C656761637929223A22436F72706F2066756E7A696F6E6520';
wwv_flow_imp.g_varchar2_table(35689) := '28707265636564656E746529222C2246756E6374696F6E20426F6479223A22436F72706F2066756E7A696F6E65222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E642074';
wwv_flow_imp.g_varchar2_table(35690) := '61726765742E223A2247617465776179207375706572666C756F2E20486120756E6120736F6C61206F726967696E6520652064657374696E617A696F6E652E222C2247656E6572616C223A2247656E6572616C65222C2247656E65726174652064656661';
wwv_flow_imp.g_varchar2_table(35691) := '756C74206974656D73223A2247656E6572612061727469636F6C6920707265646566696E697469222C22476C6F62616C206572726F72207265666572656E6365223A225269666572696D656E746F206572726F726520676C6F62616C65222C22476C6F62';
wwv_flow_imp.g_varchar2_table(35692) := '616C20657363616C6174696F6E207265666572656E6365223A225269666572696D656E746F20657363616C6174696F6E20676C6F62616C65222C22476C6F62616C207369676E616C207265666572656E6365223A225269666572696D656E746F20736567';
wwv_flow_imp.g_varchar2_table(35693) := '6E616C6520676C6F62616C65222C2247726F7570223A2247727570706F222C2248544D4C2076657273696F6E206F662074686520656D61696C223A2256657273696F6E652048544D4C2064656C6C5C27652D6D61696C222C224944206D75737420626520';
wwv_flow_imp.g_varchar2_table(35694) := '756E697175652E223A224C5C27494420646576652065737365726520756E69766F636F2E222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A226E656C20666F726D61746F204747472048483A4D4D3A5353222C';
wwv_flow_imp.g_varchar2_table(35695) := '22696E20666F726D61742059592D4D4D223A226E656C20666F726D61746F2041412D4D4D222C22496E205661726961626C6573223A224E656C6C6520766172696162696C69222C22496E2F4F7574204D617070696E67223A224D617070696E6720696E20';
wwv_flow_imp.g_varchar2_table(35696) := '656E74726174612F696E20757363697461222C22496E2F4F7574205661726961626C6573223A22566172696162696C6920646920656E74726174612F757363697461222C22496E636C75736976652067617465776179223A224761746577617920496E63';
wwv_flow_imp.g_varchar2_table(35697) := '6C757369766F222C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A22466C7573736920696E20656E7472617461206E6F6E20756E697469222C22496E69746961746F72206F66207468697320617070726F76616C207461736B22';
wwv_flow_imp.g_varchar2_table(35698) := '3A22526573706F6E736162696C6520617676696F2064692071756573746F207461736B20646920617070726F76617A696F6E65222C22496E69746961746F72223A22496E697A6961746F7265222C22496E70757420436F6C6C656374696F6E223A225261';
wwv_flow_imp.g_varchar2_table(35699) := '63636F6C746120696E707574222C22496E70757420456C656D656E74223A22456C656D656E746F20646920696E707574222C22496E7465726D656469617465207468726F77206576656E74223A224576656E746F206469204C616E63696F20496E746572';
wwv_flow_imp.g_varchar2_table(35700) := '6D6564696F222C22496E7465726D656469617465205468726F77204576656E74223A224576656E746F207269676120696E7465726D6564696F222C22496E74657276616C223A22496E74657276616C6C6F222C2249732043616C6C61626C65223A22C388';
wwv_flow_imp.g_varchar2_table(35701) := '20636869616D6162696C65222C22497320526F6C65223A22C3882072756F6C6F222C22497320537461727461626C65223A22C38820537461727461626C65222C2249534F223A2249534F222C224974656D204E616D65223A224E6F6D6520456C656D656E';
wwv_flow_imp.g_varchar2_table(35702) := '746F222C224974656D2056616C7565223A2256616C6F726520456C656D656E746F222C224974656D223A2241727469636F6C6F222C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570';
wwv_flow_imp.g_varchar2_table(35703) := '706F72746564223A224C5C2769746572617A696F6E652064656C6C652061747469766974C3A020646920636869616D617461206E6F6E20C3A82061747475616C6D656E746520737570706F7274617461222C224A534F4E204F626A656374223A224F6767';
wwv_flow_imp.g_varchar2_table(35704) := '6574746F204A534F4E222C224C616E65223A22436F72736961222C224C61746573742076657273696F6E223A22556C74696D612076657273696F6E65222C224C696E6B20496E7465726D656469617465204361746368204576656E74223A22436F6C6C65';
wwv_flow_imp.g_varchar2_table(35705) := '6761206576656E746F20646920726563757065726F20696E7465726D6564696F222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A224576656E746F206469204361747475726120496E7465726D65646961206469204C';
wwv_flow_imp.g_varchar2_table(35706) := '696E6B222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A22436F6C6C656761206576656E746F207269676120696E7465726D6564696F222C224C696E6B20696E7465726D656469617465207468726F77206576656E74';
wwv_flow_imp.g_varchar2_table(35707) := '223A224576656E746F206469204C616E63696F20496E7465726D6564696F206469204C696E6B222C224C696E6B223A224C696E6B222C224C6F616420646566696E6564207661726961626C6573223A2243617269636120766172696162696C6920646566';
wwv_flow_imp.g_varchar2_table(35708) := '696E697465222C224C6F6164204A534F4E223A22436172696361204A534F4E222C224C6F616420506172616D6574657273223A2243617269636120706172616D65747269222C224C6F6F70223A224C6F6F70222C224D61696C223A22506F737461222C22';
wwv_flow_imp.g_varchar2_table(35709) := '4D616E75616C207461736B223A2241747469766974C3A0204D616E75616C65222C224D616E75616C205461736B223A225461736B206D616E75616C65222C224D61782052756E73223A224E756D65726F206D617373696D6F2064692065736563757A696F';
wwv_flow_imp.g_varchar2_table(35710) := '6E69222C224D65737361676520626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206469204C696D6974652064656C204D657373616767696F202873656E7A6120696E74657272757A696F6E6529';
wwv_flow_imp.g_varchar2_table(35711) := '222C224D65737361676520626F756E64617279206576656E74223A224576656E746F206469204C696D6974652064656C204D657373616767696F222C224D65737361676520656E64206576656E74223A224576656E746F2064692046696E652064656C20';
wwv_flow_imp.g_varchar2_table(35712) := '4D657373616767696F222C224D65737361676520456E64204576656E74223A224D657373616767696F2046696E65204576656E746F222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A224576656E746F206469';
wwv_flow_imp.g_varchar2_table(35713) := '204361747475726120496E7465726D656469612064656C204D657373616767696F222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A224D657373616767696F204576656E746F20646920526563757065726F20';
wwv_flow_imp.g_varchar2_table(35714) := '496E7465726D6564696F222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A224576656E746F206469204C616E63696F20496E7465726D6564696F2064656C204D657373616767696F222C224D65737361676520';
wwv_flow_imp.g_varchar2_table(35715) := '496E7465726D656469617465205468726F77204576656E74223A224D657373616767696F204576656E746F205269676120496E7465726D6564696F222C224D657373616765204E616D65223A224E6F6D65206D657373616767696F222C224D6573736167';
wwv_flow_imp.g_varchar2_table(35716) := '65207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646920496E697A696F2064656C204D657373616767696F202873656E7A6120696E74657272757A696F6E6529222C224D65737361676520737461';
wwv_flow_imp.g_varchar2_table(35717) := '7274206576656E74223A224576656E746F20646920496E697A696F204D657373616767696F222C224D657373616765205374617274204576656E74223A224D657373616767696F20496E697A696F204576656E746F222C226D697373696E67207B73656D';
wwv_flow_imp.g_varchar2_table(35718) := '616E7469637D236174746163686564546F526566223A227B73656D616E7469637D236174746163686564546F526566206D616E63616E7465222C226D6F7265207468616E207B636F756E747D206368696C64206C616E6573223A227069C3B9206469207B';
wwv_flow_imp.g_varchar2_table(35719) := '636F756E747D20636F72736965206669676C696F222C224D756C74692D496E7374616E6365223A225069C3B920697374616E7A65222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A22';
wwv_flow_imp.g_varchar2_table(35720) := '7069C3B920656C656D656E746920444920646566696E69746920706572207B656C656D656E747D222C224E616D65206F6620746865206469616772616D223A224E6F6D652064656C206469616772616D6D61222C224E616D65206F66207468652050726F';
wwv_flow_imp.g_varchar2_table(35721) := '63657373205661726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E6529223A224E6F6D652064656C6C6120766172696162696C652064692070726F636573736F20286469207469706F20696E6469636174';
wwv_flow_imp.g_varchar2_table(35722) := '6F7265206F726172696F20636F6E206675736F206F726172696F29222C224E616D65206F66207468652050726F63657373205661726961626C65223A224E6F6D652064656C6C6120766172696162696C652064692070726F636573736F222C224E616D65';
wwv_flow_imp.g_varchar2_table(35723) := '206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C20726573756C7420696E746F223A224E6F6D652064656C6C6120766172696162696C6520696E20637569207265737469747569726520696C2072697375';
wwv_flow_imp.g_varchar2_table(35724) := '6C7461746F2064656C6C5C27617070726F76617A696F6E65222C224E616D65223A224E6F6D65222C224E616D65642076657273696F6E223A2256657273696F6E652064656E6F6D696E617461222C226E6F2062706D6E456C656D656E7420726566657265';
wwv_flow_imp.g_varchar2_table(35725) := '6E63656420696E207B656C656D656E747D223A226E657373756E2062706D6E456C656D656E74206120637569207669656E6520666174746F207269666572696D656E746F20696E207B656C656D656E747D222C226E6F206469616772616D20746F206469';
wwv_flow_imp.g_varchar2_table(35726) := '73706C6179223A226E657373756E206469616772616D6D612064612076697375616C697A7A617265222C226E6F20706172656E7420666F72207B656C656D656E747D20696E207B706172656E747D223A226E657373756E20706164726520706572207B65';
wwv_flow_imp.g_varchar2_table(35727) := '6C656D656E747D20696E207B706172656E747D222C226E6F20706C616E6520666F72207B656C656D656E747D223A226E657373756E207069616E6F20706572207B656C656D656E747D222C226E6F2070726F63657373206F7220636F6C6C61626F726174';
wwv_flow_imp.g_varchar2_table(35728) := '696F6E20746F20646973706C6179223A226E657373756E2070726F636573736F206F20636F6C6C61626F72617A696F6E652064612076697375616C697A7A617265222C226E6F207368617065207479706520737065636966696564223A226E657373756E';
wwv_flow_imp.g_varchar2_table(35729) := '207469706F20646920666F726D6120737065636966696361746F222C224E756D626572223A224E756D65726F222C224F6E204576656E74223A224E656C6C5C276576656E746F222C224F7261636C65205363686564756C652065787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(35730) := '3A2245737072657373696F6E65204F7261636C65205363686564756C65222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A2272696C617363696F2066756F7269206C696D697465222C224F75';
wwv_flow_imp.g_varchar2_table(35731) := '74205661726961626C6573223A22566172696162696C69206469206F7574707574222C224F757470757420436F6C6C656374696F6E223A22526163636F6C7461206F7574707574222C224F757470757420456C656D656E74223A22456C656D656E746F20';
wwv_flow_imp.g_varchar2_table(35732) := '6469206F7574707574222C224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A22536F767261736372697669207365742064692076616C6F726920707265646566696E69746F206E';
wwv_flow_imp.g_varchar2_table(35733) := '656C6C6120646566696E697A696F6E652064656C207461736B222C2250616765204944223A22494420706167696E61222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E6365223A';
wwv_flow_imp.g_varchar2_table(35734) := '22456C656D656E746F20706167696E6120636F6E74656E656E746520696C207269666572696D656E746F20616C206D6F64656C6C6F206469206D6F64756C6F222C2250616765204974656D73223A22456C656D656E746920706167696E61222C22506167';
wwv_flow_imp.g_varchar2_table(35735) := '65223A22506167696E61222C22506172616C6C656C2067617465776179223A224761746577617920506172616C6C656C6F222C22506172616C6C656C2047617465776179223A224761746577617920706172616C6C656C6F222C22506172616C6C656C20';
wwv_flow_imp.g_varchar2_table(35736) := '6D756C74692D696E7374616E6365223A224D756C7469697374616E7A6120506172616C6C656C61222C225061727469636970616E74204944223A224944207061727465636970616E7465222C225061727469636970616E74206D756C7469706C69636974';
wwv_flow_imp.g_varchar2_table(35737) := '79223A224D6F6C7469706C69636974C3A0207061727465636970616E7465222C225061727469636970616E74204E616D65223A224E6F6D65207061727465636970616E7465222C225061727469636970616E74223A225061727465636970616E7465222C';
wwv_flow_imp.g_varchar2_table(35738) := '225061796C6F6164205661726961626C65223A22566172696162696C65207061796C6F6164222C225061796C6F6164223A225061796C6F6164222C22504C2F53514C20436F6465223A22436F6469636520504C2F53514C222C22504C2F53514C20457870';
wwv_flow_imp.g_varchar2_table(35739) := '72657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F726520626F6F6C65616E6F222C22504C2F53514C2045';
wwv_flow_imp.g_varchar2_table(35740) := '787072657373696F6E2072657475726E696E67206120646174652076616C7565223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F72652064692064617461222C22504C2F53514C20457870';
wwv_flow_imp.g_varchar2_table(35741) := '72657373696F6E2072657475726E696E672061206E756D6265722076616C7565223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265206E756D657269636F222C22504C2F53514C204578';
wwv_flow_imp.g_varchar2_table(35742) := '7072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973636520756E20696E64696361746F';
wwv_flow_imp.g_varchar2_table(35743) := '7265206F726172696F20636F6E2076616C6F7265206675736F206F726172696F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D4444';
wwv_flow_imp.g_varchar2_table(35744) := '20484832343A4D493A535320545A52223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265207661726368617232206E656C20666F726D61746F20414141412D4D4D2D474720484832343A';
wwv_flow_imp.g_varchar2_table(35745) := '4D493A535320545A52222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A2245737072657373696F';
wwv_flow_imp.g_varchar2_table(35746) := '6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265207661726368617232206E656C20666F726D61746F20414141412D4D4D2D474720484832343A4D493A5353222C22504C2F53514C2045787072657373696F6E2072';
wwv_flow_imp.g_varchar2_table(35747) := '657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F72652076617263686172322069';
wwv_flow_imp.g_varchar2_table(35748) := '6E20666F726D61746F206E756D657269636F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A2245737072657373696F6E6520504C2F53514C2063686520726573746974756973';
wwv_flow_imp.g_varchar2_table(35749) := '636520756E2076616C6F7265207661726368617232222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A2245737072657373696F6E6520504C2F53514C206368';
wwv_flow_imp.g_varchar2_table(35750) := '6520726573746974756973636520696E64696361746F7265206F726172696F20636F6E206675736F206F726172696F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A2243';
wwv_flow_imp.g_varchar2_table(35751) := '6F72706F2066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F726520626F6F6C65616E6F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120646174652076616C75';
wwv_flow_imp.g_varchar2_table(35752) := '65223A22436F72706F2066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F72652064692064617461222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265';
wwv_flow_imp.g_varchar2_table(35753) := '722076616C7565223A22436F72706F2066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265206E756D657269636F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720';
wwv_flow_imp.g_varchar2_table(35754) := '612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22436F72706F2066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520756E20696E64696361746F7265206F726172696F20636F6E207661';
wwv_flow_imp.g_varchar2_table(35755) := '6C6F7265206675736F206F726172696F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A53532054';
wwv_flow_imp.g_varchar2_table(35756) := '5A52223A22436F72706F2064656C6C612066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265207661726368617232206E656C20666F726D61746F20414141412D4D4D2D474720484832343A4D493A53';
wwv_flow_imp.g_varchar2_table(35757) := '5320545A52222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22436F72706F2066756E7A';
wwv_flow_imp.g_varchar2_table(35758) := '696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265207661726368617232206E656C20666F726D61746F20414141412D4D4D2D474720484832343A4D493A5353222C22504C2F53514C2046756E6374696F6E2042';
wwv_flow_imp.g_varchar2_table(35759) := '6F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22436F72706F2066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520756E2076616C6F7265207661';
wwv_flow_imp.g_varchar2_table(35760) := '72636861723220696E20666F726D61746F206E756D657269636F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565223A22436F72706F2066756E7A696F6E6520504C2F53514C';
wwv_flow_imp.g_varchar2_table(35761) := '2063686520726573746974756973636520756E2076616C6F7265207661726368617232222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22436F7270';
wwv_flow_imp.g_varchar2_table(35762) := '6F2066756E7A696F6E6520504C2F53514C2063686520726573746974756973636520696E64696361746F7265206F726172696F20636F6E206675736F206F726172696F222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C64657222';
wwv_flow_imp.g_varchar2_table(35763) := '3A225365676E61706F73746F222C22506F74656E7469616C2047726F757073223A2247727570706920706F74656E7A69616C69222C22506F74656E7469616C205374617274657273223A22506F74656E7A69616C692073746172747570222C22506F7465';
wwv_flow_imp.g_varchar2_table(35764) := '6E7469616C205374617274696E672047726F757073223A2247727570706920696E697A69616C6920706F74656E7A69616C69222C22506F74656E7469616C205374617274696E67205573657273223A225574656E746920696E697A69616C6920706F7465';
wwv_flow_imp.g_varchar2_table(35765) := '6E7A69616C69222C22506F74656E7469616C205573657273223A225574656E746920706F74656E7A69616C69222C225072696F72697479223A225072696F726974C3A0222C2250726F6365737320646F63756D656E746174696F6E223A22446F63756D65';
wwv_flow_imp.g_varchar2_table(35766) := '6E74617A696F6E652064656C2070726F636573736F222C2250726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22496C2070726F636573736F206861207069C3B9206576656E74692064692061767669';
wwv_flow_imp.g_varchar2_table(35767) := '6F2076756F7469222C2250726F63657373204944223A2249442070726F636573736F222C2250726F63657373206973206D697373696E6720656E64206576656E74223A2250726F636573736F204D616E63616E74652046696E65204576656E746F222C22';
wwv_flow_imp.g_varchar2_table(35768) := '50726F63657373206973206D697373696E67207374617274206576656E74223A2250726F636573736F204D616E63616E746520496E697A696F204576656E746F222C2250726F63657373206E616D65223A224E6F6D652064656C2070726F636573736F22';
wwv_flow_imp.g_varchar2_table(35769) := '2C2250726F63657373205072696F72697479223A225072696F726974C3A02070726F636573736F222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E223A22537461746F2070726F636573736F20646F706F20636573';
wwv_flow_imp.g_varchar2_table(35770) := '73617A696F6E65222C2250726F63657373205661726961626C652028417272617929223A22566172696162696C652070726F636573736F2028617272617929222C2250726F63657373205661726961626C6520284C69737429223A22566172696162696C';
wwv_flow_imp.g_varchar2_table(35771) := '652070726F636573736F2028656C656E636F29222C2250726F63657373205661726961626C65223A22566172696162696C652070726F636573736F222C2250726F63657373223A2250726F636573736F222C2250726F766964652076616C75657320666F';
wwv_flow_imp.g_varchar2_table(35772) := '7220656D61696C2074656D706C617465223A22466F726E69726520692076616C6F72692070657220696C206D6F64656C6C6F20652D6D61696C222C2252656365697665207461736B223A225269636576692041747469766974C3A0222C22526563656976';
wwv_flow_imp.g_varchar2_table(35773) := '65205461736B223A22526963657669207461736B222C225265646F223A22526970657469222C2252656D6F7665223A2252696D756F7669222C225265706C7920546F223A22526973706F6E64692061222C22526571756573742056616C756520666F7220';
wwv_flow_imp.g_varchar2_table(35774) := '506167652043616C6C223A2256616C6F7265207269636869657374612070657220636869616D61746120706167696E61222C2252657175657374223A22526963686965737461222C22526573756C74205661726961626C65223A22566172696162696C65';
wwv_flow_imp.g_varchar2_table(35775) := '20726973756C7461746F222C2252657475726E205061796C6F616420496E746F223A225265737469747569736369207061796C6F616420696E20656E7472617461222C22526F6C65223A2252756F6C6F222C2253617665223A2253616C7661222C225363';
wwv_flow_imp.g_varchar2_table(35776) := '686564756C65722045787072657373696F6E223A2245737072657373696F6E65207363686564756C6572222C225363686564756C696E67223A225069616E69666963617A696F6E65222C22536372697074207461736B223A2241747469766974C3A02053';
wwv_flow_imp.g_varchar2_table(35777) := '6372697074222C22536372697074205461736B223A225461736B20736372697074222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A2253656C657A696F6E61726520736520696C206469616772616D6D';
wwv_flow_imp.g_varchar2_table(35778) := '6120C3A8207574696C697A7A6162696C6520636F6D65207374656C6C61222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A2253656C657A696F';
wwv_flow_imp.g_varchar2_table(35779) := '6E61726520736520696C206469616772616D6D61206465766520657373657265207269636869616D61746F20696E20756E5C2761747469766974C3A020646920636869616D617461222C2253656E6420456D61696C20496D6D6564696174656C79223A22';
wwv_flow_imp.g_varchar2_table(35780) := '496E76696120652D6D61696C20696D6D6564696174616D656E7465222C2253656E64204D61696C223A22496E76696120652D6D61696C222C2253656E64207461736B223A22496E7669612041747469766974C3A0222C2253656E64205461736B223A2249';
wwv_flow_imp.g_varchar2_table(35781) := '6E766961207461736B222C2253657175656E636520666C6F77223A22466C7573736F2073657175656E7A61222C2253657175656E6365223A2253657175656E7A61222C2253657175656E6365466C6F772069732061206475706C6963617465223A225365';
wwv_flow_imp.g_varchar2_table(35782) := '7175656E6365466C6F7720C3A820756E206475706C696361746F222C2253657175656E7469616C206D756C74692D696E7374616E6365223A224D756C7469697374616E7A612053657175656E7A69616C65222C2253657276696365207461736B223A2241';
wwv_flow_imp.g_varchar2_table(35783) := '747469766974C3A02064692053657276697A696F222C2253657276696365205461736B223A225461736B2073657276697A696F222C2253657420636F6C6F72223A22496D706F73746120636F6C6F7265222C225369676E616C20626F756E646172792065';
wwv_flow_imp.g_varchar2_table(35784) := '76656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206469205365676E616C652064656C204C696D697465202873656E7A6120696E74657272757A696F6E6529222C225369676E616C20626F756E64617279206576656E7422';
wwv_flow_imp.g_varchar2_table(35785) := '3A224576656E746F206469205365676E616C652064656C204C696D697465222C225369676E616C20656E64206576656E74223A224576656E746F206469205365676E616C652064692046696E65222C225369676E616C20456E64204576656E74223A2253';
wwv_flow_imp.g_varchar2_table(35786) := '65676E616C652046696E65204576656E746F222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A224576656E746F206469204361747475726120496E7465726D656469612064656C205365676E616C65222C225369';
wwv_flow_imp.g_varchar2_table(35787) := '676E616C20496E7465726D656469617465204361746368204576656E74223A225365676E616C65204576656E746F20526563757065726F20496E7465726D6564696F222C225369676E616C20696E7465726D656469617465207468726F77206576656E74';
wwv_flow_imp.g_varchar2_table(35788) := '223A224576656E746F206469204C616E63696F20496E7465726D6564696F2064656C205365676E616C65222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A225365676E616C65204576656E746F20526967612049';
wwv_flow_imp.g_varchar2_table(35789) := '6E7465726D6564696F222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646920496E697A696F2064656C205365676E616C65202873656E7A6120696E74657272757A696F6E65';
wwv_flow_imp.g_varchar2_table(35790) := '29222C225369676E616C207374617274206576656E74223A224576656E746F20646920496E697A696F205365676E616C65222C225369676E616C205374617274204576656E74223A225365676E616C6520496E697A696F204576656E746F222C22536967';
wwv_flow_imp.g_varchar2_table(35791) := '6E616C223A225365676E616C65222C2253696D706C65204D657373616765223A224D657373616767696F2073656D706C696365222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69737429223A2251756572792053514C2028';
wwv_flow_imp.g_varchar2_table(35792) := '656C656E636F2064656C696D697461746F2064612070756E746929222C2253514C20717565727920284A534F4E20617272617929223A2251756572792053514C202861727261794A534F4E29222C2253514C207175657279202873696E676C652076616C';
wwv_flow_imp.g_varchar2_table(35793) := '756529223A2251756572792053514C202876616C6F72652073696E676F6C6F29222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A224C612071756572792053514C2072657374697475';
wwv_flow_imp.g_varchar2_table(35794) := '6973636520756E61206C697374612064656C696D6974617461206461206475652070756E7469222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A2251756572792053514C206368652072657374697475697363';
wwv_flow_imp.g_varchar2_table(35795) := '6520756E206172726179204A534F4E222C2253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C7565223A2251756572792053514C2063686520726573746974756973636520756E2076616C6F72652064692064';
wwv_flow_imp.g_varchar2_table(35796) := '6174612073696E676F6C6F222C2253514C2071756572792072657475726E696E6720612073696E676C65206E756D6265722076616C7565223A2251756572792053514C2063686520726573746974756973636520756E2076616C6F7265206E756D657269';
wwv_flow_imp.g_varchar2_table(35797) := '636F2073696E676F6C6F222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2251756572792053514C20636865207265737469747569736365';
wwv_flow_imp.g_varchar2_table(35798) := '20756E2073696E676F6C6F20696E64696361746F7265206F726172696F20636F6E2076616C6F7265206469206675736F206F726172696F222C2253514C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C75';
wwv_flow_imp.g_varchar2_table(35799) := '65223A2251756572792053514C2063686520726573746974756973636520756E2073696E676F6C6F2076616C6F7265207661726368617232222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A';
wwv_flow_imp.g_varchar2_table(35800) := '6F6E65223A22496E64696361746F7265206F726172696F207265737469747569746F2064616C6C612071756572792053514C20636F6E206675736F206F726172696F222C2253514C20717565727920746F20676574206174746163686D656E74223A2251';
wwv_flow_imp.g_varchar2_table(35801) := '756572792053514C20706572206F7474656E657265206C5C27616C6C656761746F222C2253514C207175657279223A2251756572792053514C222C2253514C205175657279223A2251756572792053514C222C225374617274206576656E74206973206D';
wwv_flow_imp.g_varchar2_table(35802) := '697373696E67206576656E7420646566696E6974696F6E223A22446566696E697A696F6E65206576656E746F20696E697A69616C65206D616E63616E7465222C225374617274206576656E74206D75737420626520626C616E6B223A224C5C276576656E';
wwv_flow_imp.g_varchar2_table(35803) := '746F20696E697A69616C652064657665206573736572652076756F746F222C225374617274204576656E74223A224176766961206576656E746F222C225374617274206576656E74223A224576656E746F20646920496E697A696F222C22537461746963';
wwv_flow_imp.g_varchar2_table(35804) := '20646174652076616C7565223A2256616C6F726520646174612073746174696361222C22537461746963204944223A224944207374617469636F222C22537461746963206E756D6265722076616C7565223A2256616C6F7265206E756D65726F20737461';
wwv_flow_imp.g_varchar2_table(35805) := '7469636F222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22496E64696361746F7265206F726172696F207374617469636F20636F6E2076616C6F7265206675736F206F726172696F222C225374';
wwv_flow_imp.g_varchar2_table(35806) := '617469632076617263686172322076616C7565223A2256616C6F7265207661726368617232207374617469636F222C22537461746963223A225374617469636F222C22537472696E67223A22537472696E6761222C225375622070726F63657373206861';
wwv_flow_imp.g_varchar2_table(35807) := '73206D756C7469706C6520626C616E6B207374617274206576656E7473223A22496C2070726F636573736F207365636F6E646172696F20636F6E7469656E65207069C3B9206576656E746920646920617676696F2076756F7469222C225375622070726F';
wwv_flow_imp.g_varchar2_table(35808) := '63657373206973206D697373696E6720656E64206576656E74223A224576656E746F2064692066696E65206D616E63616E7465206E656C2070726F636573736F207365636F6E646172696F222C225375622070726F63657373206973206D697373696E67';
wwv_flow_imp.g_varchar2_table(35809) := '207374617274206576656E74223A224576656E746F20646920617676696F206D616E63616E7465206E656C2070726F636573736F207365636F6E646172696F222C225375622D70726F636573732028636F6C6C617073656429223A2250726F636573736F';
wwv_flow_imp.g_varchar2_table(35810) := '205365636F6E646172696F2028636F6D70726573736F29222C225375622D70726F636573732028657870616E64656429223A2250726F636573736F205365636F6E646172696F2028657370616E736F29222C225375622D70726F63657373223A2250726F';
wwv_flow_imp.g_varchar2_table(35811) := '636573736F205365636F6E646172696F222C225375626A656374223A224F67676574746F222C225461736B20446566696E6974696F6E223A22446566696E697A696F6E65207461736B222C225461736B20537461746963204944223A2249442073746174';
wwv_flow_imp.g_varchar2_table(35812) := '69636F207461736B222C225461736B2054797065223A225469706F206469207461736B222C225461736B223A225461736B222C2254656D706C617465204944223A224944206D6F64656C6C6F222C2254656D706C617465223A224D6F64656C6C6F222C22';
wwv_flow_imp.g_varchar2_table(35813) := '5465726D696E61746520656E64206576656E74223A224576656E746F206469205465726D696E617A696F6E652064692046696E65222C225465726D696E61746520456E64204576656E74223A225465726D696E61206576656E746F2066696E616C65222C';
wwv_flow_imp.g_varchar2_table(35814) := '225465726D696E61746564223A225465726D696E61746F222C2254657874223A22546573746F222C2254696D6520756E74696C207468652074696D657220666972657320616761696E223A2254656D706F2064692072696174746976617A696F6E652064';
wwv_flow_imp.g_varchar2_table(35815) := '656C2074696D6572222C2254696D6520756E74696C207468652074696D6572206669726573206669727374223A2254656D706F2066696E6F20616C207072696D6F20617676696F2064656C2074696D6572222C2254696D657220626F756E646172792065';
wwv_flow_imp.g_varchar2_table(35816) := '76656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206469204C696D6974652064656C2054696D6572202873656E7A6120696E74657272757A696F6E6529222C2254696D657220626F756E64617279206576656E74223A2245';
wwv_flow_imp.g_varchar2_table(35817) := '76656E746F206469204C696D6974652064656C2054696D6572222C2254696D657220446566696E6974696F6E2054797065223A225469706F20646566696E697A696F6E652074696D6572222C2254696D657220446566696E6974696F6E223A2244656669';
wwv_flow_imp.g_varchar2_table(35818) := '6E697A696F6E652074696D6572222C2254696D6572204475726174696F6E223A224475726174612074696D6572222C2254696D657220696E7465726D656469617465206361746368206576656E74223A224576656E746F20646920436174747572612049';
wwv_flow_imp.g_varchar2_table(35819) := '6E7465726D656469612064656C2054696D6572222C2254696D657220496E7465726D656469617465204361746368204576656E74223A224576656E746F20646920726563757065726F20696E7465726D6564696F2074696D6572222C2254696D65722073';
wwv_flow_imp.g_varchar2_table(35820) := '74617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646920496E697A696F2064656C2054696D6572202873656E7A6120696E74657272757A696F6E6529222C2254696D6572207374617274206576656E7422';
wwv_flow_imp.g_varchar2_table(35821) := '3A224576656E746F20646920496E697A696F2054696D6572222C2254696D6572205374617274204576656E74223A2254696D657220496E697A696F204576656E746F222C2254696D6572223A2254696D6572222C2254696D657374616D70207769746820';
wwv_flow_imp.g_varchar2_table(35822) := '54696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D6174223A22496E64696361746F7265206F726172696F20636F6E206675736F206F726172696F20696E20666F726D61746F2049534F2038363031206F204F7261';
wwv_flow_imp.g_varchar2_table(35823) := '636C65222C2254696D657374616D7020776974682054696D65205A6F6E65223A22496E64696361746F7265206F726172696F20636F6E206675736F206F726172696F222C22546F223A2241222C22546F67676C65206E6F6E2D696E74657272757074696E';
wwv_flow_imp.g_varchar2_table(35824) := '67223A224174746976612F6469736174746976612073656E7A6120696E74657272757A696F6E65222C225472616E73616374696F6E223A225472616E73617A696F6E65222C22556E646F223A22416E6E756C6C61222C22756E6B6E6F776E206469207B64';
wwv_flow_imp.g_varchar2_table(35825) := '697D20666F7220656C656D656E74207B73656D616E7469637D223A226469207B64697D2073636F6E6F73636975746F20706572206C5C27656C656D656E746F207B73656D616E7469637D222C22756E7265636F676E697A656420666C6F77456C656D656E';
wwv_flow_imp.g_varchar2_table(35826) := '74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A22666C6F77456C656D656E74207B656C656D656E747D206E6F6E207269636F6E6F73636975746F206E656C20636F6E746573746F207B636F6E746578747D222C2275';
wwv_flow_imp.g_varchar2_table(35827) := '6E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A2262706D6E456C656D656E74206E6F6E20737570706F727461746F20706572207B706C616E657D3A207B726F6F74456C65';
wwv_flow_imp.g_varchar2_table(35828) := '6D656E747D222C225573652041504558206D6574612064617461223A22557361206D657461646174692041504558222C225573652054656D706C617465223A22557361206D6F64656C6C6F222C2255736564206469616772616D2076657273696F6E223A';
wwv_flow_imp.g_varchar2_table(35829) := '2256657273696F6E652064656C206469616772616D6D61207574696C697A7A617461222C2255736572207461736B223A2241747469766974C3A0205574656E7465222C2255736572205461736B223A225461736B207574656E7465222C2256616C756522';
wwv_flow_imp.g_varchar2_table(35830) := '3A2256616C6F7265222C225661726368617232223A225661726368617232222C225661726961626C652045787072657373696F6E73223A22566172696162696C652045737072657373696F6E69222C2256657273696F6E204E616D65223A224E6F6D6520';
wwv_flow_imp.g_varchar2_table(35831) := '76657273696F6E65222C2256657273696F6E696E67223A22436F6E74726F6C6C6F2064656C6C652076657273696F6E69222C225761697420666F7220636F6D706C6574696F6E223A22417474656E646920636F6D706C6574616D656E746F222C225A6F6F';
wwv_flow_imp.g_varchar2_table(35832) := '6D20496E223A225A6F6F6D20496E222C225A6F6F6D204F7574223A225A6F6F6D204F7574227D27297D2C393736313A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D20457272';
wwv_flow_imp.g_varchar2_table(35833) := '6F72732C207B7761726E696E67737D205761726E696E6773223A227B6572726F72737DE382A8E383A9E383BC2C207B7761726E696E67737DE8ADA6E5918A222C227B73656D616E7469637D237B736964657D20526566206E6F7420737065636966696564';
wwv_flow_imp.g_varchar2_table(35834) := '223A227B73656D616E7469637D237B736964657DE58F82E785A7E3818CE68C87E5AE9AE38195E3828CE381A6E38184E381BEE3819BE38293222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312D20E7B78AE680A5222C22';
wwv_flow_imp.g_varchar2_table(35835) := '322D48696768223A2232202D20E9AB98E584AAE58588E5BAA6222C22332D4D656469756D223A2233202D20E4B8ADE584AAE58588E5BAA6222C22342D4C6F77223A2234202D20E4BD8EE584AAE58588E5BAA6222C22352D4C6F77657374223A2235202D20';
wwv_flow_imp.g_varchar2_table(35836) := 'E69C80E4B88BE4BD8DE584AAE58588E5BAA620222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073706C6974206174207468652073616D652074696D65223A22E382B2E383BCE38388E382A6E382A7E382A4E381AFE5';
wwv_flow_imp.g_varchar2_table(35837) := '9088E4BDB5E381A8E58886E589B2E38292E5908CE69982E381ABE381AFE8A18CE38184E381BEE3819BE38293E38082222C224163746976617465206372656174652F72656D6F766520737061636520746F6F6C223A22E382B9E3839AE383BCE382B9E8BF';
wwv_flow_imp.g_varchar2_table(35838) := 'BDE58AA0EFBC8FE5898AE999A4E38384E383BCE383ABE38292E4BD9CE58B95222C22416374697661746520676C6F62616C20636F6E6E65637420746F6F6C223A22E382B0E383ADE383BCE38390E383ABE382B3E3838DE382AFE38388E38384E383BCE383';
wwv_flow_imp.g_varchar2_table(35839) := 'ABE38292E4BD9CE58B95222C2241637469766174652068616E6420746F6F6C223A22E3838FE383B3E38389E38384E383BCE383ABE38292E4BD9CE58B95222C224163746976617465206C6173736F20746F6F6C223A22E382A8E383AAE382A2E981B8E68A';
wwv_flow_imp.g_varchar2_table(35840) := '9EE38384E383BCE383ABE38292E4BD9CE58B95222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A22E382B9E3839AE383BCE382B9E8BFBDE58AA0EFBC8FE5898AE999A4E38384E383BCE383ABE382';
wwv_flow_imp.g_varchar2_table(35841) := '92E4BD9CE58B95222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A22E382B0E383ADE383BCE38390E383ABE382B3E3838DE382AFE38388E38384E383BCE383ABE38292E4BD9CE58B95222C2241637469766174';
wwv_flow_imp.g_varchar2_table(35842) := '65207468652068616E6420746F6F6C223A22E3838FE383B3E38389E38384E383BCE383ABE38292E4BD9CE58B95222C22416374697661746520746865206C6173736F20746F6F6C223A22E382A8E383AAE382A2E981B8E68A9EE38384E383BCE383ABE382';
wwv_flow_imp.g_varchar2_table(35843) := '92E4BD9CE58B95222C224163746976697479207265666572656E6365223A22E382A2E382AFE38386E382A3E38393E38386E382A3E58F82E785A7222C2241642D686F63223A22E382A2E38389E3839BE38383E382AF222C22416464206C616E652061626F';
wwv_flow_imp.g_varchar2_table(35844) := '7665223A22E4B88AE381ABE383ACE383BCE383B3E38292E8BFBDE58AA0222C22416464206C616E652062656C6F77223A22E4B88BE381ABE383ACE383BCE383B3E38292E8BFBDE58AA0222C22416464207465787420616E6E6F746174696F6E223A22E6B3';
wwv_flow_imp.g_varchar2_table(35845) := 'A8E98788E38292E8BFBDE58AA0222C224166746572204D65726765223A22E3839EE383BCE382B8E5BE8C222C224166746572205461736B223A22E382BFE382B9E382AFE381AEE5BE8C222C22416C69676E20656C656D656E747320626F74746F6D223A22';
wwv_flow_imp.g_varchar2_table(35846) := 'E8A681E7B4A0E38292E4B88BE68F83E38188222C22416C69676E20656C656D656E74732063656E746572223A22E8A681E7B4A0E4B8ADE5A4AEE68F83E38188222C22416C69676E20656C656D656E7473206C656674223A22E8A681E7B4A0E38292E5B7A6';
wwv_flow_imp.g_varchar2_table(35847) := 'E68F83E38188222C22416C69676E20656C656D656E7473206D6964646C65223A22E8A681E7B4A0E38292E4B8ADE5A4AEE68F83E38188222C22416C69676E20656C656D656E7473207269676874223A22E8A681E7B4A0E38292E58FB3E68F83E38188222C';
wwv_flow_imp.g_varchar2_table(35848) := '22416C69676E20656C656D656E747320746F70223A22E8A681E7B4A0E38292E4B88AE68F83E38188222C22416C69676E20656C656D656E7473223A22E8A681E7B4A0E381AEE695B4E58897222C22416C6C6F772042696E64696E67223A22E38390E382A4';
wwv_flow_imp.g_varchar2_table(35849) := 'E383B3E38387E382A3E383B3E382B0E381AEE8A8B1E58FAF222C22616C72656164792072656E6465726564207B656C656D656E747D223A22E38199E381A7E381ABE383ACE383B3E38380E383AAE383B3E382B0E38195E3828CE381A6E38184E381BEE381';
wwv_flow_imp.g_varchar2_table(35850) := '997B656C656D656E747D222C224150455820417070726F76616C223A2241504558E381AEE689BFE8AA8D222C22415045582050616765223A2241504558E3839AE383BCE382B8222C224150455820526F6C65223A2241504558E383ADE383BCE383AB222C';
wwv_flow_imp.g_varchar2_table(35851) := '22415045582053696D706C6520466F726D223A2241504558E382B7E383B3E38397E383ABE383BBE38395E382A9E383BCE383A0222C22417070656E6420636F6D70656E736174696F6E206163746976697479223A22E8A39CE5849FE8A18CE782BAE38292';
wwv_flow_imp.g_varchar2_table(35852) := 'E8BFBDE58AA0222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22E69DA1E4BBB6E4BB98E3818DE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388E38292';
wwv_flow_imp.g_varchar2_table(35853) := 'E8BFBDE58AA0222C22417070656E6420656E64206576656E74223A22E7B582E4BA86E382A4E38399E383B3E38388E38292E8BFBDE58AA0222C22417070656E642067617465776179223A22E382B2E383BCE38388E382A6E382A7E382A4E38292E8BFBDE5';
wwv_flow_imp.g_varchar2_table(35854) := '8AA0222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A22E4B8ADE996932FE5A283E7958CE382A4E38399E383B3E38388E38292E8BFBDE58AA0222C22417070656E64206D65737361676520696E7465726D';
wwv_flow_imp.g_varchar2_table(35855) := '656469617465206361746368206576656E74223A22E383A1E38383E382BBE383BCE382B8E4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388E38292E8BFBDE58AA0222C22417070656E642072656365697665207461736B223A22';
wwv_flow_imp.g_varchar2_table(35856) := 'E58F97E4BFA1E382BFE382B9E382AFE38292E8BFBDE58AA0222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A22E382B7E382B0E3838AE383ABE4B8ADE99693E382ADE383A3E38383E38381E382';
wwv_flow_imp.g_varchar2_table(35857) := 'A4E38399E383B3E38388E38292E8BFBDE58AA0222C22417070656E64207461736B223A22E382BFE382B9E382AFE38292E8BFBDE58AA0222C22417070656E64207465787420616E6E6F746174696F6E223A22E6B3A8E98788E38292E8BFBDE58AA0222C22';
wwv_flow_imp.g_varchar2_table(35858) := '417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A22E382BFE382A4E3839EE383BCE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388E38292E8BFBDE58AA0222C224170706C6963';
wwv_flow_imp.g_varchar2_table(35859) := '6174696F6E204944223A22E382A2E38397E383AAE382B1E383BCE382B7E383A7E383B34944222C224170706C69636174696F6E223A22E382A2E38397E383AAE382B1E383BCE382B7E383A7E383B3222C2241737369676E6D656E74223A22E589B2E5BD93';
wwv_flow_imp.g_varchar2_table(35860) := '222C224174746163686D656E74223A22E6B7BBE4BB98E38395E382A1E382A4E383AB222C224261636B67726F756E64205461736B2053657373696F6E223A22E38390E38383E382AFE382B0E383A9E382A6E383B3E38389E382BFE382B9E382AFE382BBE3';
wwv_flow_imp.g_varchar2_table(35861) := '8383E382B7E383A7E383B3222C22424343223A22424343222C224265666F7265204576656E74223A22E382A4E38399E383B3E38388E5898D222C224265666F72652053706C6974223A22E58886E589B2E5898D222C224265666F7265205461736B223A22';
wwv_flow_imp.g_varchar2_table(35862) := 'E382BFE382B9E382AFE5898D222C2242696E642070616765206974656D7320286465707265636174656429223A22E38390E382A4E383B3E38389E383BBE3839AE383BCE382B8E383BBE382A2E382A4E38386E383A028E99D9EE68EA8E5A5A829222C2242';
wwv_flow_imp.g_varchar2_table(35863) := '696E6420706172616D657465722076616C756573223A22E38390E382A4E383B3E38389E383BBE38391E383A9E383A1E383BCE382BFE580A4222C2242696E642070726F63657373207661726961626C6573223A22E38390E382A4E383B3E38389E383BBE3';
wwv_flow_imp.g_varchar2_table(35864) := '8397E383ADE382BBE382B9E5A489E695B0222C22426C696E6420636172626F6E20636F707920726563697069656E74287329223A22E38396E383A9E382A4E383B3E38389E383BBE382ABE383BCE3839CE383B3E383BBE382B3E38394E383BCE58F97E4BF';
wwv_flow_imp.g_varchar2_table(35865) := 'A1E88085222C22426F64792048544D4C223A22E69CACE6968748544D4C222C22426F64792054657874223A22E69CACE69687E38386E382ADE382B9E38388222C22426F756E64617279206576656E7473206F6E20697465726174696E6720737562207072';
wwv_flow_imp.g_varchar2_table(35866) := '6F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A22E382B5E38396E38397E383ADE382BBE382B9E381AEE58F8DE5BEA9E381ABE996A2E38199E3828BE5A283E7958CE382A4E38399E383B3E38388E381AFE78F';
wwv_flow_imp.g_varchar2_table(35867) := 'BEE59CA8E382B5E3839DE383BCE38388E38195E3828CE381A6E38184E381BEE3819BE38293222C22427573696E657373205265666572656E6365223A22E38393E382B8E3838DE382B9E58F82E785A7222C22427573696E6573732072756C65207461736B';
wwv_flow_imp.g_varchar2_table(35868) := '223A22E38393E382B8E3838DE382B9E383ABE383BCE383ABE382BFE382B9E382AF222C22427573696E6573732052756C65205461736B223A22E38393E382B8E3838DE382B9E383ABE383BCE383ABE382BFE382B9E382AF222C22627573696E6573735F72';
wwv_flow_imp.g_varchar2_table(35869) := '6566223A22627573696E6573735F726566222C2243616C6C206163746976697479223A22E382B3E383BCE383ABE382A2E382AFE38386E382A3E38393E38386E382A3222C2243616C6C204163746976697479223A22E382B3E383BCE383ABE382A2E382AF';
wwv_flow_imp.g_varchar2_table(35870) := 'E38386E382A3E38393E38386E382A3222C2243616C6C6564204469616772616D223A22E382B3E383BCE383ABE6B888E38380E382A4E382A2E382B0E383A9E383A0222C2243616E63656C20626F756E64617279206576656E74223A22E382ADE383A3E383';
wwv_flow_imp.g_varchar2_table(35871) := 'B3E382BBE383ABE5A283E7958CE382A4E38399E383B3E38388222C2243616E63656C20656E64206576656E74223A22E7B582E4BA86E382A4E38399E383B3E38388E381AEE58F96E6B688222C2243616E63656C223A22E58F96E6B688222C22436172626F';
wwv_flow_imp.g_varchar2_table(35872) := '6E20636F707920726563697069656E74287329223A22E382ABE383BCE3839CE383B3E383BBE382B3E38394E383BCE58F97E4BFA1E88085222C2243617465676F72792056616C7565223A22E382ABE38386E382B4E383AAE580A4222C224343223A224343';
wwv_flow_imp.g_varchar2_table(35873) := '222C224368616E676520656C656D656E74223A22E8A681E7B4A0E381AEE5A489E69BB4222C224368616E67652074797065223A22E382BFE382A4E38397E381AEE5A489E69BB4222C22436C6561722043616368652056616C756520666F72205061676520';
wwv_flow_imp.g_varchar2_table(35874) := '43616C6C223A22E3839AE383BCE382B8E382B3E383BCE383ABE381AEE382ADE383A3E38383E382B7E383A5E580A4E381AEE382AFE383AAE382A2222C22436C656172204361636865223A22E382ADE383A3E38383E382B7E383A5E38292E382AFE383AAE3';
wwv_flow_imp.g_varchar2_table(35875) := '82A2222C22436C6F62223A22434C4F42222C22436F6465223A22E382B3E383BCE38389222C22436F6C6C61626F726174696F6E223A22E382B3E383A9E3839CE383ACE383BCE382B7E383A7E383B3222C22436F6C6C617073656420506F6F6C223A22E7B8';
wwv_flow_imp.g_varchar2_table(35876) := 'AEE5B08FE38397E383BCE383AB222C22436F6C6C6170736564205375622050726F63657373223A22E7B8AEE5B08FE382B5E38396E38397E383ADE382BBE382B9222C22436F6C6C656374696F6E2054797065223A22E382B3E383ACE382AFE382B7E383A7';
wwv_flow_imp.g_varchar2_table(35877) := 'E383B3222C22436F6C6C656374696F6E223A22E382B3E383ACE382AFE382B7E383A7E383B3222C22436F6D70656E7361746520456E64204576656E74223A22E8A39CE5849FE7B582E4BA86E382A4E38399E383B3E38388222C22436F6D70656E73617465';
wwv_flow_imp.g_varchar2_table(35878) := '20496E7465726D656469617465205468726F77204576656E74223A22E8A39CE5849FE4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A22E8A39CE5849F';
wwv_flow_imp.g_varchar2_table(35879) := 'E5A283E7958CE382A4E38399E383B3E38388222C22436F6D70656E736174696F6E20656E64206576656E74223A22E8A39CE5849FE7B582E4BA86E382A4E38399E383B3E38388222C22436F6D70656E736174696F6E20696E7465726D6564696174652074';
wwv_flow_imp.g_varchar2_table(35880) := '68726F77206576656E74223A22E8A39CE5849FE4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C22436F6D70656E736174696F6E207374617274206576656E74223A22E8A39CE5849FE9968BE5A78BE382A4E38399E383B3E38388';
wwv_flow_imp.g_varchar2_table(35881) := '222C22436F6D70656E736174696F6E223A22E8A39CE5849FE7B582222C22436F6D706C65746564223A22E5AE8CE4BA86222C22436F6D706C6574696F6E20436F6E646974696F6E223A22E5AE8CE4BA86E69DA1E4BBB6222C22436F6D706C657820676174';
wwv_flow_imp.g_varchar2_table(35882) := '65776179223A22E8A487E59088E382B2E383BCE38388E382A6E382A7E382A4222C22436F6D706C65782047617465776179223A22E8A487E59088E382B2E383BCE38388E382A6E382A7E382A4222C22436F6E646974696F6E2054797065223A22E69DA1E4';
wwv_flow_imp.g_varchar2_table(35883) := 'BBB6E382BFE382A4E38397222C22436F6E646974696F6E223A22E69DA1E4BBB6222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E69DA1E4BBB6E4BB98E3818DE5A283E795';
wwv_flow_imp.g_varchar2_table(35884) := '8CE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A22E69DA1E4BBB6E4BB98E3818DE5A283E7958CE382A4E38399E383B3E38388222C22436F6E64';
wwv_flow_imp.g_varchar2_table(35885) := '6974696F6E616C20666C6F77223A22E69DA1E4BBB6E4BB98E3818DE38395E383ADE383BC222C22436F6E646974696F6E616C20496E7465726D656469617465204361746368204576656E74223A22E69DA1E4BBB6E4B8ADE99693E382ADE383A3E38383E3';
wwv_flow_imp.g_varchar2_table(35886) := '8381E382A4E38399E383B3E38388222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22E69DA1E4BBB6E4BB98E3818DE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388222C';
wwv_flow_imp.g_varchar2_table(35887) := '22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E69DA1E4BBB6E4BB98E3818DE9968BE5A78BE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C22436F6E';
wwv_flow_imp.g_varchar2_table(35888) := '646974696F6E616C207374617274206576656E74223A22E69DA1E4BBB6E4BB98E3818DE9968BE5A78BE382A4E38399E383B3E38388222C22436F6E646974696F6E616C205374617274204576656E74223A22E69DA1E4BBB6E9968BE5A78BE382A4E38399';
wwv_flow_imp.g_varchar2_table(35889) := 'E383B3E38388222C22436F6E6E65637420746F206F7468657220656C656D656E74223A22E4BB96E381AEE8A681E7B4A0E381ABE68EA5E7B69A222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22E996A2E980A3E4BB98E38191';
wwv_flow_imp.g_varchar2_table(35890) := 'E38292E4BDBFE794A8E38197E381A6E68EA5E7B69A222C22436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E223A22E38387E383BCE382BFE585A5E58A9BE996A2E980A3E4BB98E38191E38292E4BDBFE794A8E3';
wwv_flow_imp.g_varchar2_table(35891) := '8197E381A6E68EA5E7B69A222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A22E382B7E383BCE382B1E383B3E382B92FE383A1E38383E382BBE383BCE382B8E383';
wwv_flow_imp.g_varchar2_table(35892) := '95E383ADE383BCE381BEE3819FE381AFE996A2E980A3E4BB98E38191E38292E4BDBFE794A8E38197E381A6E68EA5E7B69A222C22436F707920627573696E657373207265666572656E6365223A22E38393E382B8E3838DE382B9E58F82E785A7E381AEE3';
wwv_flow_imp.g_varchar2_table(35893) := '82B3E38394E383BC222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A227B706C616E657DE4B88AE381AEE6ACA0E890BDE38197E381A6E38184';
wwv_flow_imp.g_varchar2_table(35894) := 'E3828B62706D6E456C656D656E74E382927B726F6F74456C656D656E747DE381ABE4BFAEE6ADA3E38197E381A6E38184E381BEE38199222C22436F7272656C6174696F6E204B6579223A22E79BB8E996A2E382ADE383BC222C22436F7272656C6174696F';
wwv_flow_imp.g_varchar2_table(35895) := '6E2056616C7565223A22E79BB8E996A2E580A4222C22437265617465207B747970657D223A22E4BD9CE68890207B747970657D222C224372656174652064617461206F626A656374207265666572656E6365223A22E38387E383BCE382BFE382AAE38396';
wwv_flow_imp.g_varchar2_table(35896) := 'E382B8E382A7E382AFE38388E58F82E785A7E38292E4BD9CE68890222C2243726561746520646174612073746F7265207265666572656E6365223A22E38387E383BCE382BFE382B9E38388E382A2E58F82E785A7E38292E4BD9CE68890222C2243726561';
wwv_flow_imp.g_varchar2_table(35897) := '746520446174614F626A6563745265666572656E6365223A22E38387E383BCE382BFE382AAE38396E382B8E382A7E382AFE38388E38292E4BD9CE68890222C22437265617465204461746153746F72655265666572656E6365223A22E38387E383BCE382';
wwv_flow_imp.g_varchar2_table(35898) := 'BFE382B9E38388E382A2E38292E4BD9CE68890222C2243726561746520656E64206576656E74223A22E7B582E4BA86E382A4E38399E383B3E38388E38292E4BD9CE68890222C2243726561746520456E644576656E74223A22E7B582E4BA86E382A4E383';
wwv_flow_imp.g_varchar2_table(35899) := '99E383B3E38388E38292E4BD9CE68890222C2243726561746520657870616E646564207375622D70726F63657373223A22E5B195E9968BE38195E3828CE3819FE382B5E38396E38397E383ADE382BBE382B9E38292E4BD9CE68890222C22437265617465';
wwv_flow_imp.g_varchar2_table(35900) := '20657870616E6465642053756250726F63657373223A22E5B195E9968BE382B5E38396E38397E383ADE382BBE382B9E38292E4BD9CE68890222C224372656174652067617465776179223A22E382B2E383BCE38388E382A6E382A7E382A4E38292E4BD9C';
wwv_flow_imp.g_varchar2_table(35901) := 'E68890222C224372656174652047617465776179223A22E382B2E383BCE38388E382A6E382A7E382A4E38292E4BD9CE68890222C224372656174652067726F7570223A22E382B0E383ABE383BCE38397E38292E4BD9CE68890222C224372656174652047';
wwv_flow_imp.g_varchar2_table(35902) := '726F7570223A22E382B0E383ABE383BCE38397E4BD9CE68890222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A22E4B8ADE996932FE5A283E7958CE382A4E38399E383B3E38388E38292E4BD9CE6889022';
wwv_flow_imp.g_varchar2_table(35903) := '2C2243726561746520496E7465726D6564696174652F426F756E64617279204576656E74223A22E4B8ADE99693E5A283E7958CE382A4E38399E383B3E38388E38292E4BD9CE68890222C22437265617465206E6577202E2E2E223A22E696B0E8A68FE4BD';
wwv_flow_imp.g_varchar2_table(35904) := '9CE688902E2E2E222C2243726561746520706F6F6C2F7061727469636970616E74223A22E38397E383BCE383AB2FE58F82E58AA0E88085E38292E4BD9CE68890222C2243726561746520506F6F6C2F5061727469636970616E74223A22E38397E383BCE3';
wwv_flow_imp.g_varchar2_table(35905) := '83ABEFBC8FE58F82E58AA0E88085E38292E4BD9CE68890222C22437265617465207374617274206576656E74223A22E9968BE5A78BE382A4E38399E383B3E38388E38292E4BD9CE68890222C224372656174652053746172742054696D6572204576656E';
wwv_flow_imp.g_varchar2_table(35906) := '74223A22E9968BE5A78BE382BFE382A4E3839EE383BCE382A4E38399E383B3E38388E38292E4BD9CE68890222C224372656174652053746172744576656E74223A22E9968BE5A78BE382A4E38399E383B3E38388E38292E4BD9CE68890222C2243726561';
wwv_flow_imp.g_varchar2_table(35907) := '7465207461736B223A22E382BFE382B9E382AFE38292E4BD9CE68890222C22437265617465205461736B223A22E382BFE382B9E382AFE38292E4BD9CE68890222C22437573746F6D20457874656E73696F6E223A22E382ABE382B9E382BFE383A0E68BA1';
wwv_flow_imp.g_varchar2_table(35908) := 'E5BCB5222C22437573746F6D223A22E382ABE382B9E382BFE383A0222C224379636C65202849534F203836303129223A22E382B5E382A4E382AFE383AB2849534F203836303129222C224379636C6520284F7261636C6529223A22E382B5E382A4E382AF';
wwv_flow_imp.g_varchar2_table(35909) := 'E383AB284F7261636C6529222C2244617461204F626A656374205265666572656E6365223A22E38387E383BCE382BFE382AAE38396E382B8E382A7E382AFE38388222C2244617461206F626A656374207265666572656E6365223A22E38387E383BCE382';
wwv_flow_imp.g_varchar2_table(35910) := 'BFE382AAE38396E382B8E382A7E382AFE38388E58F82E785A7222C22446174612053746F7265205265666572656E6365223A22E38387E383BCE382BFE382B9E38388E382A2222C22446174612073746F7265207265666572656E6365223A22E38387E383';
wwv_flow_imp.g_varchar2_table(35911) := 'BCE382BFE382B9E38388E382A2E58F82E785A7222C22446174612054797065223A22E38387E383BCE382BFE59E8B222C2244617465202849534F203836303129223A22E697A5E4BB98EFBC8849534F2038363031EFBC89222C224461746520284F726163';
wwv_flow_imp.g_varchar2_table(35912) := '6C6529223A22E697A5E4BB98284F7261636C6529222C224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22E697A5E4BB98E69BB8E5BC8F595959592D204D4D2D20444420484832343A204D493A5353222C';
wwv_flow_imp.g_varchar2_table(35913) := '224461746520537472696E67223A22E697A5E4BB98E69687E5AD97E58897222C2244617465223A22E697A5E4BB98222C2244656661756C74204170706C69636174696F6E204944223A22E38387E38395E382A9E383ABE38388E383BBE382A2E38397E383';
wwv_flow_imp.g_varchar2_table(35914) := 'AAE382B1E383BCE382B7E383A7E383B34944222C2244656661756C74204170706C69636174696F6E223A22E38387E38395E382A9E383ABE38388E383BBE382A2E38397E383AAE382B1E383BCE382B7E383A7E383B3222C2244656661756C7420666C6F77';
wwv_flow_imp.g_varchar2_table(35915) := '223A22E38387E38395E382A9E383ABE38388E38395E383ADE383BC222C2244656661756C742050616765204944223A22E38387E38395E382A9E383ABE38388E383BBE3839AE383BCE382B84944222C2244656661756C742050616765223A22E38387E383';
wwv_flow_imp.g_varchar2_table(35916) := '95E382A9E383ABE38388E383BBE3839AE383BCE382B8222C2244656661756C7420557365726E616D65223A22E38387E38395E382A9E383ABE38388E383BBE383A6E383BCE382B6E383BCE5908D222C2244656C657465223A22E5898AE999A4222C224465';
wwv_flow_imp.g_varchar2_table(35917) := '736372697074696F6E223A22E8AAACE6988E222C2244657461696C73223A22E8A9B3E7B4B0222C226469616772616D206E6F742070617274206F662062706D6E3A446566696E6974696F6E73223A22E59BB3E381AF62706D6EE381AEE4B880E983A8E381';
wwv_flow_imp.g_varchar2_table(35918) := 'A7E381AFE38182E3828AE381BEE3819BE382933A20E5AE9AE7BEA9222C224469737472696275746520656C656D656E747320686F72697A6F6E74616C6C79223A22E8A681E7B4A0E38292E6B0B4E5B9B3E381ABE58886E695A3222C224469737472696275';
wwv_flow_imp.g_varchar2_table(35919) := '746520656C656D656E747320766572746963616C6C79223A22E8A681E7B4A0E38292E59E82E79BB4E381ABE58886E695A3222C2244697669646520696E746F207468726565206C616E6573223A2233E381A4E381AEE383ACE383BCE383B3E381ABE58886';
wwv_flow_imp.g_varchar2_table(35920) := 'E589B2222C2244697669646520696E746F2074776F206C616E6573223A2232E381A4E381AEE383ACE383BCE383B3E381ABE58886E589B2222C22446F63756D656E746174696F6E223A22E38389E382ADE383A5E383A1E383B3E38388222C22447565204F';
wwv_flow_imp.g_varchar2_table(35921) := '6E223A22E69C9FE697A5222C224475706C696361746520696E636F6D696E672073657175656E636520666C6F7773223A22E79D80E4BFA1E382B7E383BCE382B1E383B3E382B9E383BBE38395E383ADE383BCE3818CE9878DE8A487E38197E381A6E38184';
wwv_flow_imp.g_varchar2_table(35922) := 'E381BEE38199222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A22E98081E4BFA1E382B7E383BCE382B1E383B3E382B9E383BBE38395E383ADE383BCE3818CE9878DE8A487E38197E381A6E38184E381BEE3';
wwv_flow_imp.g_varchar2_table(35923) := '8199222C224475726174696F6E202849534F203836303129223A22E69C9FE996932849534F203836303129222C224475726174696F6E20284F7261636C6529223A22E69C9FE99693284F7261636C6529222C224475726174696F6E20696E2049534F2038';
wwv_flow_imp.g_varchar2_table(35924) := '363031206F72204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C2720666F726D6174223A2249534F2038363031E381BEE3819FE381AF4F7261636C6520496E74657276616C204453205C274444442048483234';
wwv_flow_imp.g_varchar2_table(35925) := '3A4D493A53535C27E5BDA2E5BC8FE381AEE69C9FE99693222C22652E672E2032332D4A554E2D323032372031343A31303A3030223A22E4BE8B3A2032303237E5B9B436E69C883233E697A531343A31303A3030222C22652E672E2044442D4D4F4E2D5959';
wwv_flow_imp.g_varchar2_table(35926) := '595920484832343A4D493A5353223A22E4BE8B3A2044442D4D4F4E2D5959595920484832343A4D493A5353222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F7065727479';
wwv_flow_imp.g_varchar2_table(35927) := '7D206E6F742079657420647261776E223A227B7265666572656E6365647D237B70726F70657274797DE381A7E58F82E785A7E38195E3828CE381A6E38184E3828BE8A681E7B4A07B656C656D656E747DE381AFE381BEE381A0E68F8FE794BBE38195E382';
wwv_flow_imp.g_varchar2_table(35928) := '8CE381A6E38184E381BEE3819BE38293222C22456C656D656E7420646F63756D656E746174696F6E223A22E382A8E383ACE383A1E383B3E38388E383BBE38389E382ADE383A5E383A1E383B3E38388222C22456C656D656E742068617320646973616C6C';
wwv_flow_imp.g_varchar2_table(35929) := '6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A22E8A681E7B4A0E381AEE382BFE382A4E383973C62706D6E3A436F6D706C6578476174657761793EE3818CE8A8B1E58FAFE38195E3828CE381A6E38184E381BEE3819B';
wwv_flow_imp.g_varchar2_table(35930) := 'E38293222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E223A223C62706D6E3A4D65737361676553746172744576656E743EE381AEE5BDA2E5BC8FE381AFE784A1';
wwv_flow_imp.g_varchar2_table(35931) := 'E58AB9E381A7E38199E38082222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A223C62706D6E3A5369676E616C53746172744576656E743EE381AEE5BDA2E5BC';
wwv_flow_imp.g_varchar2_table(35932) := '8FE381AFE784A1E58AB9E381A7E38199E38082222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A223C62706D6E436F6E646974696F6E616C53746172';
wwv_flow_imp.g_varchar2_table(35933) := '744576656E743EE381AEE5BDA2E5BC8FE381AFE784A1E58AB9E381A7E38199E38082222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063686172616374657273223A22E8A681E7B4A04944E3818C3530E69687E5AD97E4BB';
wwv_flow_imp.g_varchar2_table(35934) := 'A5E4B88AE38182E3828AE381BEE38199E38082222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A22E8A681E7B4A04944E3818CE381BEE381A0E5A489E69BB4E38195E3828CE381A6E38184E381BEE3819BE3829322';
wwv_flow_imp.g_varchar2_table(35935) := '2C22456C656D656E7420697320616E20696D706C6963697420656E64223A22E38193E381AEE382A8E383ACE383A1E383B3E38388E381AFE6988EE7A4BAE79A84E381AAE7B582E4BA86E382A4E38399E383B3E38388E38292E5BF85E8A681E381A8E3819B';
wwv_flow_imp.g_varchar2_table(35936) := 'E3819AE38081E887AAE58B95E79A84E381ABE7B582E4BA86E38197E381BEE38199222C22456C656D656E7420697320616E20696D706C69636974207374617274223A22E38193E381AEE382A8E383ACE383A1E383B3E38388E381AFE6988EE7A4BAE79A84';
wwv_flow_imp.g_varchar2_table(35937) := 'E381AAE9968BE5A78BE382A4E38399E383B3E38388E38292E5BF85E8A681E381A8E3819BE3819AE38081E887AAE58B95E79A84E381ABE9968BE5A78BE38197E381BEE38199222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D';
wwv_flow_imp.g_varchar2_table(35938) := '65223A22E8A681E7B4A0E381ABE383A9E38399E383AB2FE5908DE5898DE3818CE38182E3828AE381BEE3819BE38293222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22E8A681E7B4A0E3818CE68EA5E7B69AE38195E3828CE381';
wwv_flow_imp.g_varchar2_table(35939) := 'A6E38184E381BEE3819BE38293222C22656C656D656E74207265717569726564223A22E8A681E7B4A0E3818CE5BF85E8A681E381A7E38199222C22456D61696C20636F6E74656E74223A2245E383A1E383BCE383ABE383BBE382B3E383B3E38386E383B3';
wwv_flow_imp.g_varchar2_table(35940) := 'E38384222C22456D61696C206F662074686520726563697069656E74287329223A22E58F97E4BFA1E88085E381AEE99BBBE5AD90E383A1E383BCE383AB222C22456D61696C206F66207468652073656E646572223A22E98081E4BFA1E88085E381AEE99B';
wwv_flow_imp.g_varchar2_table(35941) := 'BBE5AD90E383A1E383BCE383AB222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A22E8BF94E4BFA1E58588E381A8E381AAE3828BE99BBBE5AD90E383A1E383BCE383AB222C22456D70747920';
wwv_flow_imp.g_varchar2_table(35942) := '706F6F6C2F7061727469636970616E74202872656D6F76657320636F6E74656E7429223A22E38397E383BCE383AB2FE58F82E58AA0E88085E38292E7A9BAE381ABE38199E3828BEFBC88E58685E5AEB9E381AFE5898AE999A4EFBC89222C22456D707479';
wwv_flow_imp.g_varchar2_table(35943) := '20706F6F6C2F7061727469636970616E74223A22E38397E383BCE383AB2FE58F82E58AA0E88085E38292E7A9BAE381ABE38199E3828B222C22456E64206576656E74223A22E7B582E4BA86E382A4E38399E383B3E38388222C22456E64204576656E7422';
wwv_flow_imp.g_varchar2_table(35944) := '3A22E7B582E4BA86E382A4E38399E383B3E38388222C22456E64706F696E74223A22E382A8E383B3E38389E3839DE382A4E383B3E38388222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E223A22E382ABE382B9E382';
wwv_flow_imp.g_varchar2_table(35945) := 'BFE383A0E68BA1E5BCB5E382924A534F4EE381A8E38197E381A6E585A5E58A9BE38197E381A6E3818FE381A0E38195E38184222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22E5AE9FE8A18CE3';
wwv_flow_imp.g_varchar2_table(35946) := '8199E3828B504C2F53514CE382B3E383BCE38389E38292E585A5E58A9BE38197E381BEE38199E38082222C224572726F7220626F756E64617279206576656E74223A22E382A8E383A9E383BCE5A283E7958CE382A4E38399E383B3E38388222C22457272';
wwv_flow_imp.g_varchar2_table(35947) := '6F7220656E64206576656E74223A22E382A8E383A9E383BCE7B582E4BA86E382A4E38399E383B3E38388222C224572726F7220456E64204576656E74223A22E382A8E383A9E383BCE7B582E4BA86E382A4E38399E383B3E38388222C224572726F722073';
wwv_flow_imp.g_varchar2_table(35948) := '74617274206576656E74223A22E382A8E383A9E383BCE9968BE5A78BE382A4E38399E383B3E38388222C224572726F72223A6E756C6C2C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729';
wwv_flow_imp.g_varchar2_table(35949) := '223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E5A283E7958CE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C22457363616C6174696F6E20626F756E64617279206576656E74223A22E382A8E382B9';
wwv_flow_imp.g_varchar2_table(35950) := 'E382ABE383ACE383BCE382B7E383A7E383B3E5A283E7958CE382A4E38399E383B3E38388222C22457363616C6174696F6E20656E64206576656E74223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E7B582E4BA86E382A4E38399E383';
wwv_flow_imp.g_varchar2_table(35951) := 'B3E38388222C22457363616C6174696F6E20456E64204576656E74223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E7B582E4BA86E382A4E38399E383B3E38388222C22457363616C6174696F6E20696E7465726D6564696174652074';
wwv_flow_imp.g_varchar2_table(35952) := '68726F77206576656E74223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C22457363616C6174696F6E20496E7465726D656469617465205468726F7720457665';
wwv_flow_imp.g_varchar2_table(35953) := '6E74223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729';
wwv_flow_imp.g_varchar2_table(35954) := '223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E9968BE5A78BE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C22457363616C6174696F6E207374617274206576656E74223A22E382A8E382B9E382AB';
wwv_flow_imp.g_varchar2_table(35955) := 'E383ACE383BCE382B7E383A7E383B3E9968BE5A78BE382A4E38399E383B3E38388222C22457363616C6174696F6E223A22E382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3222C224576656E742042617365642047617465776179223A22E382';
wwv_flow_imp.g_varchar2_table(35956) := 'A4E38399E383B3E38388E38399E383BCE382B9E382B2E383BCE38388E382A6E382A7E382A4222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A22E382A4E38399E383B3E38388E381ABE8A487E695B0';
wwv_flow_imp.g_varchar2_table(35957) := 'E381AEE382A4E38399E383B3E38388E5AE9AE7BEA9E3818CE38182E3828AE381BEE38199222C224576656E74205375622050726F63657373223A22E382A4E38399E383B3E38388E38080E382B5E38396E38397E383ADE382BBE382B9222C224576656E74';
wwv_flow_imp.g_varchar2_table(35958) := '207375622D70726F63657373223A22E382A4E38399E383B3E38388E382B5E38396E38397E383ADE382BBE382B9222C224576656E742054797065223A22E382A4E38399E383B3E38388E383BBE382BFE382A4E38397222C224576656E742D626173656420';
wwv_flow_imp.g_varchar2_table(35959) := '67617465776179223A22E382A4E38399E383B3E38388E38399E383BCE382B9E381AEE382B2E383BCE38388E382A6E382A7E382A4222C224578636C75646564205374617274696E67205573657273223A22E999A4E5A496E38195E3828CE3819FE9968BE5';
wwv_flow_imp.g_varchar2_table(35960) := 'A78BE383A6E383BCE382B6E383BC222C224578636C75646564205573657273223A22E999A4E5A496E38195E3828CE3819FE383A6E383BCE382B6E383BC222C224578636C75736976652067617465776179223A22E68E92E4BB96E382B2E383BCE38388E3';
wwv_flow_imp.g_varchar2_table(35961) := '82A6E382A7E382A4222C224578636C75736976652047617465776179223A22E68E92E4BB96E382B2E383BCE38388E382A6E382A7E382A4222C2245786563757461626C65223A22E5AE9FE8A18CE58FAFE883BDE38395E382A1E382A4E383AB222C224578';
wwv_flow_imp.g_varchar2_table(35962) := '656375746520504C2F53514C223A22504C2F53514CE381AEE5AE9FE8A18C222C22457865637574696F6E223A22E5AE9FE8A18C222C22457870616E64656420706F6F6C2F7061727469636970616E74223A22E38397E383BCE383AB2FE58F82E58AA0E880';
wwv_flow_imp.g_varchar2_table(35963) := '85E38292E5B195E9968BE38199E3828B222C22457870616E646564205375622050726F63657373223A22E68BA1E5BCB5E382B5E38396E38397E383ADE382BBE382B9222C2245787072657373696F6E20284C656761637929223A22E5BC8F28E383ACE382';
wwv_flow_imp.g_varchar2_table(35964) := 'ACE382B7E383BC29222C2245787072657373696F6E2054797065223A22E5BC8FE382BFE382A4E38397222C2245787072657373696F6E223A22E5BC8F222C226661696C656420746F20696D706F7274207B656C656D656E747D223A227B656C656D656E74';
wwv_flow_imp.g_varchar2_table(35965) := '7DE381AEE382A4E383B3E3839DE383BCE38388E381ABE5A4B1E69597E38197E381BEE38197E3819F222C22666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A22E383';
wwv_flow_imp.g_varchar2_table(35966) := '95E383ADE383BCE8A681E7B4A0E381AFE38397E383BCE383AB2FE58F82E58AA0E88085E381AEE5AD90E381A7E38182E3828BE5BF85E8A681E3818CE38182E3828AE381BEE38199222C22466C6F772073706C69747320696D706C696369746C79223A22E3';
wwv_flow_imp.g_varchar2_table(35967) := '8395E383ADE383BCE58886E589B2E3818CE382B2E383BCE38388E382A6E382A7E382A4E381AAE38197E381ABE5AE9FE8A18CE38195E3828CE381A6E38184E381BEE38199E38082222C22466F726D2054656D706C617465204974656D204E616D65223A22';
wwv_flow_imp.g_varchar2_table(35968) := 'E38395E382A9E383BCE383A0E383BBE38386E383B3E38397E383ACE383BCE38388E9A085E79BAEE5908D222C22466F726D2054656D706C617465204974656D223A22E38395E382A9E383BCE383A0E38386E383B3E38397E383ACE383BCE38388E9A085E7';
wwv_flow_imp.g_varchar2_table(35969) := '9BAE222C22466F726D2054656D706C617465223A22E38395E382A9E383BCE383A0E383BBE38386E383B3E38397E383ACE383BCE38388222C22466F726D6174204D61736B223A22E69BB8E5BC8FE3839EE382B9E382AF222C22466F726D61744D61736B22';
wwv_flow_imp.g_varchar2_table(35970) := '3A22466F726D61744D61736B222C2246726F6D223A22E5B7AEE587BAE4BABA222C2246756E6374696F6E20426F647920284C656761637929223A22E6A99FE883BDE69CACE6968728E383ACE382ACE382B7E383BC29222C2246756E6374696F6E20426F64';
wwv_flow_imp.g_varchar2_table(35971) := '79223A22E996A2E695B0E69CACE4BD93222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A22E382B2E383BCE38388E382A6E382A7E382A4E381';
wwv_flow_imp.g_varchar2_table(35972) := '8CE4B88DE58D81E58886E381A7E38199E38082E382BDE383BCE382B9E381A8E382BFE383BCE382B2E38383E38388E381AF31E381A4E381AEE381BFE381A7E38199E38082222C2247656E6572616C223A22E4B880E888AC222C2247656E65726174652064';
wwv_flow_imp.g_varchar2_table(35973) := '656661756C74206974656D73223A22E38387E38395E382A9E383ABE38388E383BBE382A2E382A4E38386E383A0E381AEE7949FE68890222C22476C6F62616C206572726F72207265666572656E6365223A22E382B0E383ADE383BCE38390E383ABE383BB';
wwv_flow_imp.g_varchar2_table(35974) := 'E382A8E383A9E383BCE58F82E785A7222C22476C6F62616C20657363616C6174696F6E207265666572656E6365223A22E382B0E383ADE383BCE38390E383ABE383BBE382A8E382B9E382ABE383ACE383BCE382B7E383A7E383B3E58F82E785A7222C2247';
wwv_flow_imp.g_varchar2_table(35975) := '6C6F62616C207369676E616C207265666572656E6365223A22E382B0E383ADE383BCE38390E383ABE4BFA1E58FB7E58F82E785A7222C2247726F7570223A22E382B0E383ABE383BCE38397222C2248544D4C2076657273696F6E206F662074686520656D';
wwv_flow_imp.g_varchar2_table(35976) := '61696C223A2248544D4CE38390E383BCE382B8E383A7E383B3E381AE45E383A1E383BCE383AB222C224944206D75737420626520756E697175652E223A224944E381AFE4B880E6848FE381A7E38182E3828BE5BF85E8A681E3818CE38182E3828AE381BE';
wwv_flow_imp.g_varchar2_table(35977) := 'E38199E38082222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A22E5BDA2E5BC8F4444442048483A4D4D3A5353222C22696E20666F726D61742059592D4D4D223A22E5BDA2E5BC8F59592D204D4D222C22496E';
wwv_flow_imp.g_varchar2_table(35978) := '205661726961626C6573223A22E5A489E695B0E58685222C22496E2F4F7574204D617070696E67223A22E585A5E587BAE58A9BE3839EE38383E38394E383B3E382B0222C22496E2F4F7574205661726961626C6573223A22E585A5E587BAE58A9BE5A489';
wwv_flow_imp.g_varchar2_table(35979) := 'E695B0222C22496E636C75736976652067617465776179223A22E58C85E590ABE382B2E383BCE38388E382A6E382A7E382A4222C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A22E58F97E4BFA1E38395E383ADE383BCE3818C';
wwv_flow_imp.g_varchar2_table(35980) := 'E7B590E59088E38197E381BEE3819BE38293222C22496E69746961746F72206F66207468697320617070726F76616C207461736B223A22E38193E381AEE689BFE8AA8DE382BFE382B9E382AFE381AEE9968BE5A78BE88085222C22496E69746961746F72';
wwv_flow_imp.g_varchar2_table(35981) := '223A22E9968BE5A78BE88085222C22496E70757420436F6C6C656374696F6E223A22E585A5E58A9BE382B3E383ACE382AFE382B7E383A7E383B3222C22496E70757420456C656D656E74223A22E585A5E58A9BE8A681E7B4A0222C22496E7465726D6564';
wwv_flow_imp.g_varchar2_table(35982) := '69617465207468726F77206576656E74223A22E4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C22496E7465726D656469617465205468726F77204576656E74223A22E4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3';
wwv_flow_imp.g_varchar2_table(35983) := 'E38388222C22496E74657276616C223A22E99693E99A94222C2249732043616C6C61626C65223A22E382B3E383BCE383ABE58FAFE883BD222C22497320526F6C65223A22E383ADE383BCE383AB222C22497320537461727461626C65223A22E9968BE5A7';
wwv_flow_imp.g_varchar2_table(35984) := '8BE58FAFE883BD222C2249534F223A2249534F222C224974656D204E616D65223A22E382A2E382A4E38386E383A0E5908D222C224974656D2056616C7565223A22E382A2E382A4E38386E383A0E580A4222C224974656D223A22E382A2E382A4E38386E3';
wwv_flow_imp.g_varchar2_table(35985) := '83A0222C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F72746564223A22E78FBEE59CA8E38081E382B3E383BCE383ABE383BBE382A2E382AFE38386E382A3E38393E38386E3';
wwv_flow_imp.g_varchar2_table(35986) := '82A3E381AEE58F8DE5BEA9E381AFE382B5E3839DE383BCE38388E38195E3828CE381A6E38184E381BEE3819BE38293222C224A534F4E204F626A656374223A224A534F4EE382AAE38396E382B8E382A7E382AFE38388222C224C616E65223A22E383ACE3';
wwv_flow_imp.g_varchar2_table(35987) := '83BCE383B3222C224C61746573742076657273696F6E223A22E69C80E696B0E38390E383BCE382B8E383A7E383B3222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A22E383AAE383B3E382AFE4B8ADE99693E382ADE3';
wwv_flow_imp.g_varchar2_table(35988) := '83A3E38383E38381E382A4E38399E383B3E38388222C224C696E6B20496E7465726D656469617465204361746368204576656E74223A22E383AAE383B3E382AFE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388222C224C696E';
wwv_flow_imp.g_varchar2_table(35989) := '6B20696E7465726D656469617465207468726F77206576656E74223A22E383AAE383B3E382AFE4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A22';
wwv_flow_imp.g_varchar2_table(35990) := 'E383AAE383B3E382AFE4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C224C696E6B223A6E756C6C2C224C6F616420646566696E6564207661726961626C6573223A22E5AE9AE7BEA9E6B888E5A489E695B0E381AEE383ADE383BC';
wwv_flow_imp.g_varchar2_table(35991) := 'E38389222C224C6F6164204A534F4E223A224A534F4EE381AEE383ADE383BCE38389222C224C6F616420506172616D6574657273223A22E38391E383A9E383A1E383BCE382BFE381AEE383ADE383BCE38389222C224C6F6F70223A22E383ABE383BCE383';
wwv_flow_imp.g_varchar2_table(35992) := '97222C224D61696C223A22E383A1E383BCE383AB222C224D616E75616C205461736B223A22E3839EE3838BE383A5E382A2E383ABE382BFE382B9E382AF222C224D616E75616C207461736B223A22E6898BE58B95E382BFE382B9E382AF222C224D617820';
wwv_flow_imp.g_varchar2_table(35993) := '52756E73223A22E69C80E5A4A7E5AE9FE8A18CE695B0222C224D65737361676520626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E383A1E38383E382BBE383BCE382B8E5A283E7958CE382A4E38399E383B3E3';
wwv_flow_imp.g_varchar2_table(35994) := '8388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C224D65737361676520626F756E64617279206576656E74223A22E383A1E38383E382BBE383BCE382B8E5A283E7958CE382A4E38399E383B3E38388222C224D65737361676520656E64206576656E';
wwv_flow_imp.g_varchar2_table(35995) := '74223A22E383A1E38383E382BBE383BCE382B8E7B582E4BA86E382A4E38399E383B3E38388222C224D65737361676520456E64204576656E74223A22E383A1E38383E382BBE383BCE382B8E7B582E4BA86E382A4E38399E383B3E38388222C224D657373';
wwv_flow_imp.g_varchar2_table(35996) := '61676520496E7465726D656469617465204361746368204576656E74223A22E383A1E38383E382BBE383BCE382B8E382ADE383A3E38383E38381E4B8ADE99693E382A4E38399E383B3E38388222C224D65737361676520696E7465726D65646961746520';
wwv_flow_imp.g_varchar2_table(35997) := '6361746368206576656E74223A22E383A1E38383E382BBE383BCE382B8E4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388222C224D65737361676520496E7465726D656469617465205468726F77204576656E74223A22E383A1';
wwv_flow_imp.g_varchar2_table(35998) := 'E38383E382BBE383BCE382B8E382ADE383A3E38383E38381E382B9E383ADE383BCE382A4E38399E383B3E38388222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A22E383A1E38383E382BBE383BCE382B8E4B8';
wwv_flow_imp.g_varchar2_table(35999) := 'ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C224D657373616765204E616D65223A22E383A1E38383E382BBE383BCE382B8E5908D222C224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E';
wwv_flow_imp.g_varchar2_table(36000) := '6729223A22E383A1E38383E382BBE383BCE382B8E9968BE5A78BE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C224D657373616765207374617274206576656E74223A22E383A1E38383E382BBE383BCE382B8E9968BE5';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(36001) := 'A78BE382A4E38399E383B3E38388222C224D657373616765205374617274204576656E74223A22E383A1E38383E382BBE383BCE382B8E9968BE5A78BE382A4E38399E383B3E38388222C226D697373696E67207B73656D616E7469637D23617474616368';
wwv_flow_imp.g_varchar2_table(36002) := '6564546F526566223A227B73656D616E7469637DE3818CE38182E3828AE381BEE3819BE38293236174746163686564546F526566222C226D6F7265207468616E207B636F756E747D206368696C64206C616E6573223A227B636F756E747DE5808BE38292';
wwv_flow_imp.g_varchar2_table(36003) := 'E8B685E38188E3828BE5AD90E383ACE383BCE383B3222C224D756C74692D496E7374616E6365223A22E3839EE383ABE38381E382A4E383B3E382B9E382BFE383B3E382B9222C226D756C7469706C6520444920656C656D656E747320646566696E656420';
wwv_flow_imp.g_varchar2_table(36004) := '666F72207B656C656D656E747D223A227B656C656D656E747DE381ABE8A487E695B0E381AE4449E8A681E7B4A0E3818CE5AE9AE7BEA9E38195E3828CE381A6E38184E381BEE38199222C224E616D65206F6620746865206469616772616D223A22E59BB3';
wwv_flow_imp.g_varchar2_table(36005) := 'E381AEE5908DE5898D222C224E616D65206F66207468652050726F63657373205661726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E6529223A22E38397E383ADE382BBE382B9E5A489E695B0E381AEE5';
wwv_flow_imp.g_varchar2_table(36006) := '908DE5898D2854696D657374616D7020776974682054696D65205A6F6E65E382BFE382A4E3839729222C224E616D65206F66207468652050726F63657373205661726961626C65223A22E38397E383ADE382BBE382B9E5A489E695B0E381AEE5908DE589';
wwv_flow_imp.g_varchar2_table(36007) := '8D222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C20726573756C7420696E746F223A22E689BFE8AA8DE7B590E69E9CE38292E8BF94E38199E5A489E695B0E381AEE5908DE5898D222C';
wwv_flow_imp.g_varchar2_table(36008) := '224E616D65223A22E5908DE5898D222C224E616D65642076657273696F6E223A22E5908DE5898DE4BB98E3818DE38390E383BCE382B8E383A7E383B3222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E74';
wwv_flow_imp.g_varchar2_table(36009) := '7D223A227B656C656D656E747DE381A7E58F82E785A7E38195E3828CE381A6E38184E3828B62706D6E456C656D656E74E3818CE38182E3828AE381BEE3819BE38293222C226E6F206469616772616D20746F20646973706C6179223A22E8A1A8E7A4BAE3';
wwv_flow_imp.g_varchar2_table(36010) := '8199E3828BE38380E382A4E382A2E382B0E383A9E383A0E3818CE38182E3828AE381BEE3819BE38293222C226E6F20706172656E7420666F72207B656C656D656E747D20696E207B706172656E747D223A227B706172656E747DE381AB7B656C656D656E';
wwv_flow_imp.g_varchar2_table(36011) := '747DE381AEE8A6AAE3818CE38182E3828AE381BEE3819BE38293222C226E6F20706C616E6520666F72207B656C656D656E747D223A227B656C656D656E747D20E381ABE5AFBEE38199E3828BE5B9B3E99DA2E3818CE38182E3828AE381BEE3819BE38293';
wwv_flow_imp.g_varchar2_table(36012) := '222C226E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A22E8A1A8E7A4BAE38199E3828BE38397E383ADE382BBE382B9E381BEE3819FE381AFE382B3E383A9E3839CE383ACE383BCE382B7E383A7E383';
wwv_flow_imp.g_varchar2_table(36013) := 'B3E3818CE38182E3828AE381BEE3819BE38293222C226E6F207368617065207479706520737065636966696564223A22E382B7E382A7E382A4E38397E383BBE382BFE382A4E38397E3818CE68C87E5AE9AE38195E3828CE381A6E38184E381BEE3819BE3';
wwv_flow_imp.g_varchar2_table(36014) := '8293222C224E756D626572223A22E795AAE58FB7222C224F6E204576656E74223A22E382A4E38399E383B3E38388E69982222C224F7261636C65205363686564756C652065787072657373696F6E223A224F7261636C65E382B9E382B1E382B8E383A5E3';
wwv_flow_imp.g_varchar2_table(36015) := '83BCE383ABE5BC8F222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A22E5A283E7958CE38292E8B68AE38188E3819FE383AAE383AAE383BCE382B9222C224F7574205661726961626C657322';
wwv_flow_imp.g_varchar2_table(36016) := '3A22E587BAE58A9BE5A489E695B0222C224F757470757420436F6C6C656374696F6E223A22E587BAE58A9BE382B3E383ACE382AFE382B7E383A7E383B3222C224F757470757420456C656D656E74223A22E587BAE58A9BE8A681E7B4A0222C224F766572';
wwv_flow_imp.g_varchar2_table(36017) := '77726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A22E382BFE382B9E382AFE5AE9AE7BEA9E381AEE38387E38395E382A9E383ABE38388E580A4E382BBE38383E38388E38292E4B88AE69BB8E3';
wwv_flow_imp.g_varchar2_table(36018) := '818DE38197E381BEE38199222C2250616765204944223A22E3839AE383BCE382B84944222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E6365223A22E38395E382A9E383BCE383';
wwv_flow_imp.g_varchar2_table(36019) := 'A0E383BBE38386E383B3E38397E383ACE383BCE38388E58F82E785A7E38292E590ABE38280E3839AE383BCE382B8E383BBE382A2E382A4E38386E383A0222C2250616765204974656D73223A22E3839AE383BCE382B8E383BBE382A2E382A4E38386E383';
wwv_flow_imp.g_varchar2_table(36020) := 'A0222C2250616765223A22E3839AE383BCE382B8222C22506172616C6C656C2067617465776179223A22E4B8A6E58897E382B2E383BCE38388E382A6E382A7E382A4222C22506172616C6C656C2047617465776179223A22E4B8A6E58897E382B2E383BC';
wwv_flow_imp.g_varchar2_table(36021) := 'E38388E382A6E382A7E382A4222C22506172616C6C656C206D756C74692D696E7374616E6365223A22E4B8A6E58897E3839EE383ABE38381E382A4E383B3E382B9E382BFE383B3E382B9222C225061727469636970616E74204944223A22E58F82E58AA0';
wwv_flow_imp.g_varchar2_table(36022) := 'E880854944222C225061727469636970616E74206D756C7469706C6963697479223A22E58AA0E585A5E88085E4B997E695B0222C225061727469636970616E74204E616D65223A22E58F82E58AA0E88085E5908D222C225061727469636970616E74223A';
wwv_flow_imp.g_varchar2_table(36023) := '22E58F82E58AA0E88085222C225061796C6F6164205661726961626C65223A22E3839AE382A4E383ADE383BCE38389E5A489E695B0222C225061796C6F6164223A22E3839AE382A4E383ADE383BCE38389222C22504C2F53514C20436F6465223A22504C';
wwv_flow_imp.g_varchar2_table(36024) := '2F53514CE382B3E383BCE38389222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A22E38396E383BCE383ABE580A4E38292E8BF94E38199504C2F53514CE5BC8F222C22504C2F5351';
wwv_flow_imp.g_varchar2_table(36025) := '4C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A22E697A5E4BB98E580A4E38292E8BF94E38199504C2F53514CE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061206E75';
wwv_flow_imp.g_varchar2_table(36026) := '6D6265722076616C7565223A22E695B0E580A4E38292E8BF94E38199504C2F53514CE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565';
wwv_flow_imp.g_varchar2_table(36027) := '223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E580A4E38292E590ABE38280E382BFE382A4E383A0E382B9E382BFE383B3E38397E38292E8BF94E38199504C2F53514CE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475';
wwv_flow_imp.g_varchar2_table(36028) := '726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A227661726368617232E580A4E38292595959592D4D4D2D4444E381AEE69BB8E5BC8FE381A7E8BF94';
wwv_flow_imp.g_varchar2_table(36029) := 'E38199504C2F53514CE5BC8F20484832343A4D493A535320545A52222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D44442048483234';
wwv_flow_imp.g_varchar2_table(36030) := '3A4D493A5353223A227661726368617232E580A4E38292595959592D4D4D2D4444E381AEE69BB8E5BC8FE381A7E8BF94E38199504C2F53514CE5BC8F20484832343A4D493A5353222C22504C2F53514C2045787072657373696F6E2072657475726E696E';
wwv_flow_imp.g_varchar2_table(36031) := '6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A227661726368617232E580A4E38292E695B0E580A4E5BDA2E5BC8FE381A7E8BF94E38199504C2F53514CE5BC8F222C22504C2F53514C204578707265737369';
wwv_flow_imp.g_varchar2_table(36032) := '6F6E2072657475726E696E6720612076617263686172322076616C7565223A227661726368617232E580A4E38292E8BF94E38199504C2F53514CE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D657374616D';
wwv_flow_imp.g_varchar2_table(36033) := '7020776974682054696D65205A6F6E65223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E38292E590ABE38280E382BFE382A4E383A0E382B9E382BFE383B3E38397E38292E8BF94E38199504C2F53514CE5BC8F222C22504C2F53514C204675';
wwv_flow_imp.g_varchar2_table(36034) := '6E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A22E38396E383BCE383ABE580A4E38292E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93222C22504C2F';
wwv_flow_imp.g_varchar2_table(36035) := '53514C2046756E6374696F6E20426F64792072657475726E696E67206120646174652076616C7565223A22E697A5E4BB98E580A4E38292E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93222C22504C2F';
wwv_flow_imp.g_varchar2_table(36036) := '53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A22E695B0E580A4E38292E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93222C22504C2F53';
wwv_flow_imp.g_varchar2_table(36037) := '514C2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E580A4E38292E590ABE38280E382BFE382';
wwv_flow_imp.g_varchar2_table(36038) := 'A4E383A0E382B9E382BFE383B3E38397E38292E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120766172636861';
wwv_flow_imp.g_varchar2_table(36039) := '72322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A227661726368617232E580A4E38292595959592D4D4D2D4444E381AEE69BB8E5BC8FE381A7E8BF94E38199504C2F53514CE38395E382';
wwv_flow_imp.g_varchar2_table(36040) := 'A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD9320484832343A4D493A535320545A52222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D6174205959';
wwv_flow_imp.g_varchar2_table(36041) := '59592D4D4D2D444420484832343A4D493A5353223A227661726368617232E580A4E38292595959592D4D4D2D4444E381AEE69BB8E5BC8FE381A7E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93484832';
wwv_flow_imp.g_varchar2_table(36042) := '343A4D493A5353222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A227661726368617232E580A4E38292E695B0E580A4E5BDA2';
wwv_flow_imp.g_varchar2_table(36043) := 'E5BC8FE381A7E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565223A227661';
wwv_flow_imp.g_varchar2_table(36044) := '726368617232E580A4E38292E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E69CACE4BD93222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D70207769746820';
wwv_flow_imp.g_varchar2_table(36045) := '54696D65205A6F6E65223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E38292E590ABE38280E382BFE382A4E383A0E382B9E382BFE383B3E38397E38292E8BF94E38199504C2F53514CE38395E382A1E383B3E382AFE382B7E383A7E383B3E6';
wwv_flow_imp.g_varchar2_table(36046) := '9CACE4BD93222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A22E38397E383ACE383BCE382B9E3839BE383ABE38380E383BC222C22506F74656E7469616C2047726F757073223A22E6BD9CE59CA8E79A84E382B0E383';
wwv_flow_imp.g_varchar2_table(36047) := 'ABE383BCE38397222C22506F74656E7469616C205374617274657273223A22E6BD9CE59CA8E79A84E382B9E382BFE383BCE382BF222C22506F74656E7469616C205374617274696E672047726F757073223A22E6BD9CE59CA8E79A84E9968BE5A78BE382';
wwv_flow_imp.g_varchar2_table(36048) := 'B0E383ABE383BCE38397222C22506F74656E7469616C205374617274696E67205573657273223A22E6BD9CE59CA8E79A84E381AAE9968BE5A78BE383A6E383BCE382B6E383BC222C22506F74656E7469616C205573657273223A22E6BD9CE59CA8E383A6';
wwv_flow_imp.g_varchar2_table(36049) := 'E383BCE382B6E383BC222C225072696F72697479223A22E584AAE58588E5BAA6222C2250726F6365737320646F63756D656E746174696F6E223A22E38397E383ADE382BBE382B9E383BBE38389E382ADE383A5E383A1E383B3E38388222C2250726F6365';
wwv_flow_imp.g_varchar2_table(36050) := '737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22E38397E383ADE382BBE382B9E381ABE8A487E695B0E381AEE7A9BAE799BDE9968BE5A78BE382A4E38399E383B3E38388E3818CE38182E3828AE381BEE38199';
wwv_flow_imp.g_varchar2_table(36051) := '222C2250726F63657373204944223A22E38397E383ADE382BBE382B94944222C2250726F63657373206973206D697373696E6720656E64206576656E74223A22E38397E383ADE382BBE382B9E381ABE7B582E4BA86E382A4E38399E383B3E38388E3818C';
wwv_flow_imp.g_varchar2_table(36052) := 'E38182E3828AE381BEE3819BE38293222C2250726F63657373206973206D697373696E67207374617274206576656E74223A22E38397E383ADE382BBE382B9E381ABE9968BE5A78BE382A4E38399E383B3E38388E3818CE38182E3828AE381BEE3819BE3';
wwv_flow_imp.g_varchar2_table(36053) := '8293222C2250726F63657373206E616D65223A22E38397E383ADE382BBE382B9E5908D222C2250726F63657373205072696F72697479223A22E38397E383ADE382BBE382B9E584AAE58588E5BAA6222C2250726F63657373207374617475732061667465';
wwv_flow_imp.g_varchar2_table(36054) := '72207465726D696E6174696F6E223A22E7B582E4BA86E5BE8CE381AEE38397E383ADE382BBE382B9E383BBE382B9E38386E383BCE382BFE382B9222C2250726F63657373205661726961626C652028417272617929223A22E38397E383ADE382BBE382B9';
wwv_flow_imp.g_varchar2_table(36055) := 'E5A489E695B028E9858DE5889729222C2250726F63657373205661726961626C6520284C69737429223A22E38397E383ADE382BBE382B9E5A489E695B028E383AAE382B9E3838829222C2250726F63657373205661726961626C65223A22E38397E383AD';
wwv_flow_imp.g_varchar2_table(36056) := 'E382BBE382B9E5A489E695B0222C2250726F63657373223A22E38397E383ADE382BBE382B9222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A2245E383A1E383BCE383ABE383BBE38386E383B3E38397E383';
wwv_flow_imp.g_varchar2_table(36057) := 'ACE383BCE38388E381AEE580A4E38292E68C87E5AE9AE38197E381A6E3818FE381A0E38195E38184222C2252656365697665207461736B223A22E58F97E4BFA1E382BFE382B9E382AF222C2252656365697665205461736B223A22E58F97E4BFA1E382BF';
wwv_flow_imp.g_varchar2_table(36058) := 'E382B9E382AF222C225265646F223A22E8A882E6ADA3222C2252656D6F7665223A22E6B688E58EBB222C225265706C7920546F223A22E8BF94E4BFA1E58588222C22526571756573742056616C756520666F7220506167652043616C6C223A22E3839AE3';
wwv_flow_imp.g_varchar2_table(36059) := '83BCE382B8E382B3E383BCE383ABE381AEE383AAE382AFE382A8E382B9E38388E580A4222C2252657175657374223A22E383AAE382AFE382A8E382B9E38388222C22526573756C74205661726961626C65223A22E7B590E69E9CE5A489E695B0222C2252';
wwv_flow_imp.g_varchar2_table(36060) := '657475726E205061796C6F616420496E746F223A22E3839AE382A4E383ADE383BCE38389E38292E688BBE38199222C22526F6C65223A22E383ADE383BCE383AB222C2253617665223A22E4BF9DE5AD98222C225363686564756C65722045787072657373';
wwv_flow_imp.g_varchar2_table(36061) := '696F6E223A22E382B9E382B1E382B8E383A5E383BCE383A9E5BC8F222C225363686564756C696E67223A22E382B9E382B1E382B8E383A5E383BCE383AAE383B3E382B0222C22536372697074207461736B223A22E382B9E382AFE383AAE38397E38388E3';
wwv_flow_imp.g_varchar2_table(36062) := '82BFE382B9E382AF222C22536372697074205461736B223A22E382B9E382AFE383AAE38397E38388E382BFE382B9E382AF222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A22E38193E381AEE38380E3';
wwv_flow_imp.g_varchar2_table(36063) := '82A4E382A2E382B0E383A9E383A0E3818C20E9968BE5A78BE381A7E3818DE3828BE5A0B4E59088E381ABE981B8E68A9EE38197E381BEE38199222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420';
wwv_flow_imp.g_varchar2_table(36064) := '696E20612043616C6C204163746976697479223A22E38193E381AEE38380E382A4E382A2E382B0E383A9E383A0E38292E382B3E383BCE383ABE383BBE382A2E382AFE38386E382A3E38393E38386E382A3E381A7E382B3E383BCE383ABE38199E3828BE5';
wwv_flow_imp.g_varchar2_table(36065) := 'BF85E8A681E3818CE38182E3828BE381A8E3818DE381ABE981B8E68A9EE38197E381BEE38199222C2253656E6420456D61696C20496D6D6564696174656C79223A22E38199E38190E381ABE99BBBE5AD90E383A1E383BCE383ABE38292E98081E4BFA122';
wwv_flow_imp.g_varchar2_table(36066) := '2C2253656E64204D61696C223A22E383A1E383BCE383ABE381AEE98081E4BFA1222C2253656E64207461736B223A22E98081E4BFA1E382BFE382B9E382AF222C2253656E64205461736B223A22E98081E4BFA1E382BFE382B9E382AF222C225365717565';
wwv_flow_imp.g_varchar2_table(36067) := '6E636520666C6F77223A22E382B7E383BCE382B1E383B3E382B9E38395E383ADE383BC222C2253657175656E6365223A22E9A086E5BA8F222C2253657175656E6365466C6F772069732061206475706C6963617465223A22E382B7E383BCE382B1E383B3';
wwv_flow_imp.g_varchar2_table(36068) := 'E382B9E38395E383ADE383BCE3818CE9878DE8A487E38197E381A6E38184E381BEE38199222C2253657175656E7469616C206D756C74692D696E7374616E6365223A22E980A3E7B69AE3839EE383ABE38381E382A4E383B3E382B9E382BFE383B3E382B9';
wwv_flow_imp.g_varchar2_table(36069) := '222C2253657276696365207461736B223A22E382B5E383BCE38393E382B9E382BFE382B9E382AF222C2253657276696365205461736B223A22E382B5E383BCE38393E382B9E382BFE382B9E382AF222C2253657420636F6C6F72223A22E889B2E38292E8';
wwv_flow_imp.g_varchar2_table(36070) := 'A8ADE5AE9A222C225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E382B7E382B0E3838AE383ABE5A283E7958CE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC8922';
wwv_flow_imp.g_varchar2_table(36071) := '2C225369676E616C20626F756E64617279206576656E74223A22E382B7E382B0E3838AE383ABE5A283E7958CE382A4E38399E383B3E38388222C225369676E616C20656E64206576656E74223A22E382B7E382B0E3838AE383ABE7B582E4BA86E382A4E3';
wwv_flow_imp.g_varchar2_table(36072) := '8399E383B3E38388222C225369676E616C20456E64204576656E74223A22E382B7E382B0E3838AE383ABE7B582E4BA86E382A4E38399E383B3E38388222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A22E382B7';
wwv_flow_imp.g_varchar2_table(36073) := 'E382B0E3838AE383ABE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388222C225369676E616C20496E7465726D656469617465204361746368204576656E74223A22E382B7E382B0E3838AE383ABE4B8ADE99693E382ADE383A3';
wwv_flow_imp.g_varchar2_table(36074) := 'E38383E38381E382A4E38399E383B3E38388222C225369676E616C20696E7465726D656469617465207468726F77206576656E74223A22E382B7E382B0E3838AE383ABE4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C22536967';
wwv_flow_imp.g_varchar2_table(36075) := '6E616C20496E7465726D656469617465205468726F77204576656E74223A22E382B7E382B0E3838AE383ABE4B8ADE99693E382B9E383ADE383BCE382A4E38399E383B3E38388222C225369676E616C207374617274206576656E7420286E6F6E2D696E74';
wwv_flow_imp.g_varchar2_table(36076) := '657272757074696E6729223A22E382B7E382B0E3838AE383ABE9968BE5A78BE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C225369676E616C207374617274206576656E74223A22E382B7E382B0E3838AE383ABE9968B';
wwv_flow_imp.g_varchar2_table(36077) := 'E5A78BE382A4E38399E383B3E38388222C225369676E616C205374617274204576656E74223A22E382B7E382B0E3838AE383ABE9968BE5A78BE382A4E38399E383B3E38388222C225369676E616C223A22E382B7E382B0E3838AE383AB222C2253696D70';
wwv_flow_imp.g_varchar2_table(36078) := '6C65204D657373616765223A22E58D98E7B494E383A1E38383E382BBE383BCE382B8222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69737429223A2253514CE5958FE59088E3819B28E382B3E383ADE383B3E58CBAE58887';
wwv_flow_imp.g_varchar2_table(36079) := 'E3828AE383AAE382B9E3838829222C2253514C20717565727920284A534F4E20617272617929223A2253514CE5958FE59088E3819B284A534F4EE9858DE5889729222C2253514C207175657279202873696E676C652076616C756529223A2253514CE595';
wwv_flow_imp.g_varchar2_table(36080) := '8FE59088E3819B28E58D98E4B880E580A429222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A22E382B3E383ADE383B3E58CBAE58887E3828AE383AAE382B9E38388E38292E8BF94E3';
wwv_flow_imp.g_varchar2_table(36081) := '819953514CE5958FE59088E3819B222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A224A534F4EE9858DE58897E38292E8BF94E3819953514CE5958FE59088E3819B222C2253514C2071756572792072657475';
wwv_flow_imp.g_varchar2_table(36082) := '726E696E6720612073696E676C6520646174652076616C7565223A22E58D98E4B880E381AEE697A5E4BB98E580A4E38292E8BF94E3819953514CE5958FE59088E3819B222C2253514C2071756572792072657475726E696E6720612073696E676C65206E';
wwv_flow_imp.g_varchar2_table(36083) := '756D6265722076616C7565223A2231E381A4E381AEE695B0E580A4E38292E8BF94E3819953514CE5958FE59088E3819B222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D6520';
wwv_flow_imp.g_varchar2_table(36084) := '5A6F6E652076616C7565223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E580A4E38292E68C81E381A4E58D98E4B880E381AEE382BFE382A4E383A0E382B9E382BFE383B3E38397E38292E8BF94E3819953514CE5958FE59088E3819B222C22';
wwv_flow_imp.g_varchar2_table(36085) := '53514C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C7565223A22E58D98E4B880E381AE7661726368617232E580A4E38292E8BF94E3819953514CE5958FE59088E3819B222C2253514C20717565727920';
wwv_flow_imp.g_varchar2_table(36086) := '72657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E38292E590ABE38280E382BFE382A4E383A0E382B9E382BFE383B3E38397E38292E8BF94E3819953514C';
wwv_flow_imp.g_varchar2_table(36087) := 'E5958FE59088E3819B222C2253514C20717565727920746F20676574206174746163686D656E74223A22E6B7BBE4BB98E58F96E5BE97E381ABE996A2E38199E3828B53514CE5958FE59088E3819B222C2253514C207175657279223A2253514CE5958FE5';
wwv_flow_imp.g_varchar2_table(36088) := '9088E3819B222C2253514C205175657279223A2253514CE5958FE59088E3819B222C225374617274206576656E74206973206D697373696E67206576656E7420646566696E6974696F6E223A22E9968BE5A78BE382A4E38399E383B3E38388E381ABE382';
wwv_flow_imp.g_varchar2_table(36089) := 'A4E38399E383B3E38388E5AE9AE7BEA9E3818CE38182E3828AE381BEE3819BE38293222C225374617274206576656E74206D75737420626520626C616E6B223A22E9968BE5A78BE382A4E38399E383B3E38388E381AFE7A9BAE799BDE381A7E381AAE381';
wwv_flow_imp.g_varchar2_table(36090) := '91E3828CE381B0E381AAE3828AE381BEE3819BE38293222C225374617274206576656E74223A22E9968BE5A78BE382A4E38399E383B3E38388222C225374617274204576656E74223A22E9968BE5A78BE382A4E38399E383B3E38388222C225374617469';
wwv_flow_imp.g_varchar2_table(36091) := '6320646174652076616C7565223A22E99D99E79A84E697A5E4BB98E580A4222C22537461746963204944223A22E99D99E79A844944222C22537461746963206E756D6265722076616C7565223A22E99D99E79A84E695B0E580A4222C2253746174696320';
wwv_flow_imp.g_varchar2_table(36092) := '54696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E580A4E38292E590ABE38280E99D99E79A84E382BFE382A4E383A0E382B9E382BFE383B3E38397222C2253746174';
wwv_flow_imp.g_varchar2_table(36093) := '69632076617263686172322076616C7565223A22E99D99E79A847661726368617232E580A4222C22537461746963223A22E99D99E79A84222C22537472696E67223A22E69687E5AD97E58897222C225375622070726F6365737320686173206D756C7469';
wwv_flow_imp.g_varchar2_table(36094) := '706C6520626C616E6B207374617274206576656E7473223A22E382B5E38396E38397E383ADE382BBE382B9E381ABE8A487E695B0E381AEE7A9BAE799BDE381AEE9968BE5A78BE382A4E38399E383B3E38388E3818CE38182E3828AE381BEE38199222C22';
wwv_flow_imp.g_varchar2_table(36095) := '5375622070726F63657373206973206D697373696E6720656E64206576656E74223A22E382B5E38396E38397E383ADE382BBE382B9E381ABE7B582E4BA86E382A4E38399E383B3E38388E3818CE38182E3828AE381BEE3819BE38293222C225375622070';
wwv_flow_imp.g_varchar2_table(36096) := '726F63657373206973206D697373696E67207374617274206576656E74223A22E382B5E38396E38397E383ADE382BBE382B9E381ABE9968BE5A78BE382A4E38399E383B3E38388E3818CE38182E3828AE381BEE3819BE38293222C225375622D70726F63';
wwv_flow_imp.g_varchar2_table(36097) := '6573732028636F6C6C617073656429223A22E382B5E38396E38397E383ADE382BBE382B9EFBC88E68A98E3828AE3819FE3819FE381BFEFBC89222C225375622D70726F636573732028657870616E64656429223A22E382B5E38396E38397E383ADE382BB';
wwv_flow_imp.g_varchar2_table(36098) := 'E382B9EFBC88E5B195E9968BEFBC89222C225375622D70726F63657373223A22E382B5E38396E38397E383ADE382BBE382B9222C225375626A656374223A22E8AAB2E9A18C222C225461736B20446566696E6974696F6E223A22E382BFE382B9E382AFE5';
wwv_flow_imp.g_varchar2_table(36099) := 'AE9AE7BEA9222C225461736B20537461746963204944223A22E382BFE382B9E382AFE99D99E79A844944222C225461736B2054797065223A22E382BFE382B9E382AFE383BBE382BFE382A4E38397222C225461736B223A22E382BFE382B9E382AF222C22';
wwv_flow_imp.g_varchar2_table(36100) := '54656D706C617465204944223A22E38386E383B3E38397E383ACE383BCE383884944222C2254656D706C617465223A22E38386E383B3E38397E383ACE383BCE38388222C225465726D696E61746520456E64204576656E74223A22E382BFE383BCE3839F';
wwv_flow_imp.g_varchar2_table(36101) := 'E3838DE383BCE38388E7B582E4BA86E382A4E38399E383B3E38388222C225465726D696E61746520656E64206576656E74223A22E7B582E4BA86E382A4E38399E383B3E38388E381AEE7B582E4BA86222C225465726D696E61746564223A22E7B582E4BA';
wwv_flow_imp.g_varchar2_table(36102) := '86E6B888222C2254657874223A22E38386E382ADE382B9E38388222C2254696D6520756E74696C207468652074696D657220666972657320616761696E223A22E382BFE382A4E3839EE383BCE3818CE5868DE381B3E8B5B7E58B95E38199E3828BE381BE';
wwv_flow_imp.g_varchar2_table(36103) := 'E381A7E381AEE69982E99693222C2254696D6520756E74696C207468652074696D6572206669726573206669727374223A22E382BFE382A4E3839EE383BCE3818CE69C80E5889DE381ABE8B5B7E58B95E38199E3828BE381BEE381A7E381AEE69982E996';
wwv_flow_imp.g_varchar2_table(36104) := '93222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E382BFE382A4E3839EE383BCE5A283E7958CE382A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C2254696D';
wwv_flow_imp.g_varchar2_table(36105) := '657220626F756E64617279206576656E74223A22E382BFE382A4E3839EE383BCE5A283E7958CE382A4E38399E383B3E38388222C2254696D657220446566696E6974696F6E2054797065223A22E382BFE382A4E3839EE383BCE5AE9AE7BEA9E382BFE382';
wwv_flow_imp.g_varchar2_table(36106) := 'A4E38397222C2254696D657220446566696E6974696F6E223A22E382BFE382A4E3839EE383BCE5AE9AE7BEA9222C2254696D6572204475726174696F6E223A22E382BFE382A4E3839EE383BCE69C9FE99693222C2254696D657220696E7465726D656469';
wwv_flow_imp.g_varchar2_table(36107) := '617465206361746368206576656E74223A22E382BFE382A4E3839EE383BCE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388222C2254696D657220496E7465726D656469617465204361746368204576656E74223A22E382BFE3';
wwv_flow_imp.g_varchar2_table(36108) := '82A4E3839EE383BCE4B8ADE99693E382ADE383A3E38383E38381E382A4E38399E383B3E38388222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E382BFE382A4E3839EE383BCE9968BE5A78BE382';
wwv_flow_imp.g_varchar2_table(36109) := 'A4E38399E383B3E38388EFBC88E4B8ADE696ADE381AAE38197EFBC89222C2254696D6572207374617274206576656E74223A22E382BFE382A4E3839EE383BCE9968BE5A78BE382A4E38399E383B3E38388222C2254696D6572205374617274204576656E';
wwv_flow_imp.g_varchar2_table(36110) := '74223A22E382BFE382A4E3839EE383BCE9968BE5A78BE382A4E38399E383B3E38388222C2254696D6572223A22E382BFE382A4E3839EE383BC222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F7220';
wwv_flow_imp.g_varchar2_table(36111) := '4F7261636C6520666F726D6174223A2249534F2038363031E381BEE3819FE381AF4F7261636C65E5BDA2E5BC8FE381AEE382BFE382A4E383A0E383BBE382BEE383BCE383B3E38292E590ABE38280E382BFE382A4E383A0E382B9E382BFE383B3E3839722';
wwv_flow_imp.g_varchar2_table(36112) := '2C2254696D657374616D7020776974682054696D65205A6F6E65223A22E382BFE382A4E383A0E383BBE382BEE383BCE383B3E4BB98E3818DE381AEE382BFE382A4E383A0E382B9E382BFE383B3E38397222C22546F223A22E5AE9BE58588222C22546F67';
wwv_flow_imp.g_varchar2_table(36113) := '676C65206E6F6E2D696E74657272757074696E67223A22E4B8ADE696ADE381AAE38197E381ABE58887E3828AE69BBFE38188222C225472616E73616374696F6E223A22E38388E383A9E383B3E382B6E382AFE382B7E383A7E383B3222C22556E646F223A';
wwv_flow_imp.g_varchar2_table(36114) := '22E58583E381ABE688BBE38199222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A227B73656D616E7469637D20E381AEE8A681E7B4A0207B64697D20E381AFE4B88DE6988EE381A7E38199222C';
wwv_flow_imp.g_varchar2_table(36115) := '22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A227B636F6E746578747D20E381AEE38395E383ADE383BCE8A681E7B4A0207B656C656D656E747D20E381';
wwv_flow_imp.g_varchar2_table(36116) := '8CE8AA8DE8AD98E38195E3828CE381BEE3819BE38293222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A227B706C616E657D20E794A8E381AEE382B5E3839DE383';
wwv_flow_imp.g_varchar2_table(36117) := 'BCE38388E38195E3828CE381A6E38184E381AAE381842062706D6E456C656D656E743A207B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A2241504558E383A1E382BFE38387E383BCE382BFE381AEE4BDBFE794';
wwv_flow_imp.g_varchar2_table(36118) := 'A8222C225573652054656D706C617465223A22E38386E383B3E38397E383ACE383BCE38388E381AEE4BDBFE794A8222C2255736564206469616772616D2076657273696F6E223A22E4BDBFE794A8E6B888E38380E382A4E382A2E382B0E383A9E383A0E3';
wwv_flow_imp.g_varchar2_table(36119) := '83BBE38390E383BCE382B8E383A7E383B3222C2255736572207461736B223A22E383A6E383BCE382B6E383BCE382BFE382B9E382AF222C2255736572205461736B223A22E383A6E383BCE382B6E383BCE382BFE382B9E382AF222C2256616C7565223A22';
wwv_flow_imp.g_varchar2_table(36120) := 'E580A4222C225661726368617232223A225661726368617232222C225661726961626C652045787072657373696F6E73223A22E5A489E695B0E5BC8F222C2256657273696F6E204E616D65223A22E38390E383BCE382B8E383A7E383B3E5908D222C2256';
wwv_flow_imp.g_varchar2_table(36121) := '657273696F6E696E67223A22E38390E383BCE382B8E383A7E3838BE383B3E382B0222C225761697420666F7220636F6D706C6574696F6E223A22E5AE8CE4BA86E5BE85E381A1222C225A6F6F6D20496E223A22E382BAE383BCE383A0E383BBE382A4E383';
wwv_flow_imp.g_varchar2_table(36122) := 'B3222C225A6F6F6D204F7574223A22E382BAE383BCE383A0E383BBE382A2E382A6E38388227D27297D2C393239343A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D20457272';
wwv_flow_imp.g_varchar2_table(36123) := '6F72732C207B7761726E696E67737D205761726E696E6773223A227B6572726F72737DEAB09C20EC98A4EBA5982C207B7761726E696E67737DEAB09C20EAB2BDEAB3A0222C227B73656D616E7469637D237B736964657D20526566206E6F742073706563';
wwv_flow_imp.g_varchar2_table(36124) := '6966696564223A227B73656D616E7469637D237B736964657D20ECB0B8ECA1B0EAB08020ECA780ECA095EB9098ECA78020EC958AEC9D8C222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312D557267656E74222C22322D';
wwv_flow_imp.g_varchar2_table(36125) := '48696768223A22322D48696768222C22332D4D656469756D223A22332D4D656469756D222C22342D4C6F77223A22342D4C6F77222C22352D4C6F77657374223A22352D4C6F77657374222C224120676174657761792073686F756C64206E6F74206D6572';
wwv_flow_imp.g_varchar2_table(36126) := '676520616E642073706C6974206174207468652073616D652074696D65223A22EAB28CEC9DB4ED8AB8EC9BA8EC9DB4EB8A9420EB8F99EC8B9CEC979020EBB391ED95A920EBB08F20EBB684ED95A0EB9098ECA78020EC958AEC9584EC95BC20ED95A9EB8B';
wwv_flow_imp.g_varchar2_table(36127) := '88EB8BA42E222C224163746976617465206372656174652F72656D6F766520737061636520746F6F6C223A22EAB3B5EAB08420EB8F84EAB5AC20EC9E91EC84B12FECA09CEAB1B020ED999CEC84B1ED9994222C22416374697661746520676C6F62616C20';
wwv_flow_imp.g_varchar2_table(36128) := '636F6E6E65637420746F6F6C223A22ECA084EC97AD20ECA091EC868D20ED88B420ED999CEC84B1ED9994222C2241637469766174652068616E6420746F6F6C223A22EC869020EB8F84EAB5AC20ED999CEC84B1ED9994222C224163746976617465206C61';
wwv_flow_imp.g_varchar2_table(36129) := '73736F20746F6F6C223A22EC98ACEAB080EBAFB820EB8F84EAB5AC20ED999CEC84B1ED9994222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A22EAB3B5EAB08420EC839DEC84B12FECA09CEAB1B0';
wwv_flow_imp.g_varchar2_table(36130) := '20EB8F84EAB5AC20ED999CEC84B1ED9994222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A22ECA084EC97AD20EC97B0EAB2B020EB8F84EAB5AC20ED999CEC84B1ED9994222C22416374697661746520746865';
wwv_flow_imp.g_varchar2_table(36131) := '2068616E6420746F6F6C223A22EC869020EB8F84EAB5AC20ED999CEC84B1ED9994222C22416374697661746520746865206C6173736F20746F6F6C223A22EC98ACEAB080EBAFB820EB8F84EAB5AC20ED999CEC84B1ED9994222C22416374697669747920';
wwv_flow_imp.g_varchar2_table(36132) := '7265666572656E6365223A22ED999CEB8F9920ECB0B8ECA1B0222C2241642D686F63223A22EC9E84EC8B9C222C22416464206C616E652061626F7665223A22EC9C84EC979020EC9AB4EC86A1EAB68CEC97AD20ECB694EAB080222C22416464206C616E65';
wwv_flow_imp.g_varchar2_table(36133) := '2062656C6F77223A22EC9584EB9E98EC979020EC9AB4EC86A1EAB68CEC97AD20ECB694EAB080222C22416464207465787420616E6E6F746174696F6E223A22ED858DEC8AA4ED8AB820ECA3BCEC849D20ECB694EAB080222C224166746572204D65726765';
wwv_flow_imp.g_varchar2_table(36134) := '223A22EBB391ED95A920ED9B84222C224166746572205461736B223A22EC9DB4ED9B8420ED839CEC8AA4ED81AC222C22416C69676E20656C656D656E747320626F74746F6D223A22EC9A94EC868C20ED9598EB8BA820ECA095EBA0AC222C22416C69676E';
wwv_flow_imp.g_varchar2_table(36135) := '20656C656D656E74732063656E746572223A22EC9A94EC868C20ECA491EC8BAC20ECA095EBA0AC222C22416C69676E20656C656D656E7473206C656674223A22EC99BCECAABDEC9CBCEBA19C20EC9A94EC868C20EBA79EECB6A4222C22416C69676E2065';
wwv_flow_imp.g_varchar2_table(36136) := '6C656D656E7473206D6964646C65223A22EC9A94EC868C20EAB080EC9AB4EB8DB020EBA79EECB6A4222C22416C69676E20656C656D656E7473207269676874223A22EC9A94EC868C20EC98A4EBA5B8ECAABD20EBA79EECB6A4222C22416C69676E20656C';
wwv_flow_imp.g_varchar2_table(36137) := '656D656E747320746F70223A22EC9A94EC868C20EC8381EB8BA820ECA095EBA0AC222C22416C69676E20656C656D656E7473223A22EC9A94EC868C20ECA095EBA0AC222C22416C6C6F772042696E64696E67223A22EBB094EC9DB8EB94A920ED9788EC9A';
wwv_flow_imp.g_varchar2_table(36138) := 'A9222C22616C72656164792072656E6465726564207B656C656D656E747D223A22EC9DB4EBAFB8207B656C656D656E747DEC9D8428EBA5BC2920EBA08CEB8D94EBA781ED9688EC8AB5EB8B88EB8BA42E222C224150455820417070726F76616C223A2241';
wwv_flow_imp.g_varchar2_table(36139) := '50455820EC8AB9EC9DB8222C22415045582050616765223A224150455820ED8E98EC9DB4ECA780222C224150455820526F6C65223A224150455820EBA1A4222C22415045582053696D706C6520466F726D223A224150455820EB8BA8EC889C20EC9691EC';
wwv_flow_imp.g_varchar2_table(36140) := '8B9D222C22417070656E6420636F6D70656E736174696F6E206163746976697479223A22EBB3B4EC838120ED999CEB8F9920ECB694EAB080222C22417070656E6420636F6E646974696F6E616C20696E7465726D65646961746520636174636820657665';
wwv_flow_imp.g_varchar2_table(36141) := '6E74223A22ECA1B0EAB1B4EBB68020ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB820ECB694EAB080222C22417070656E6420656E64206576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB820ECB694EAB080222C22417070656E642067';
wwv_flow_imp.g_varchar2_table(36142) := '617465776179223A22EAB28CEC9DB4ED8AB8EC9BA8EC9DB420ECB694EAB080222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A22ECA491EAB0842FEAB2BDEAB38420EC9DB4EBB2A4ED8AB820ECB694EAB0';
wwv_flow_imp.g_varchar2_table(36143) := '80222C22417070656E64206D65737361676520696E7465726D656469617465206361746368206576656E74223A22EBA994EC8B9CECA78020ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB820ECB694EAB080222C22417070656E64207265636569';
wwv_flow_imp.g_varchar2_table(36144) := '7665207461736B223A22EC8898EC8BA020ED839CEC8AA4ED81AC20ECB694EAB080222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A22EC8BA0ED98B820ECA491EAB08420636174636820EC9DB4';
wwv_flow_imp.g_varchar2_table(36145) := 'EBB2A4ED8AB820ECB694EAB080222C22417070656E64207461736B223A22ED839CEC8AA4ED81AC20ECB694EAB080222C22417070656E64207465787420616E6E6F746174696F6E223A22ED858DEC8AA4ED8AB820ECA3BCEC849D20ECB694EAB080222C22';
wwv_flow_imp.g_varchar2_table(36146) := '417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A22ED8380EC9DB4EBA8B820ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB820ECB694EAB080222C224170706C69636174696F6E204944223A22EC';
wwv_flow_imp.g_varchar2_table(36147) := '95A0ED948CEBA6ACECBC80EC9DB4EC8598204944222C224170706C69636174696F6E223A22EC95A0ED948CEBA6ACECBC80EC9DB4EC8598222C2241737369676E6D656E74223A22ECA780ECA095222C224174746163686D656E74223A22ECB2A8EBB68022';
wwv_flow_imp.g_varchar2_table(36148) := '2C224261636B67726F756E64205461736B2053657373696F6E223A22EBB0B1EAB7B8EB9DBCEC9AB4EB939C20ED839CEC8AA4ED81AC20EC84B8EC8598222C22424343223A22EC88A8EC9D8020ECB0B8ECA1B0222C224265666F7265204576656E74223A22';
wwv_flow_imp.g_varchar2_table(36149) := 'EC9DB4EBB2A4ED8AB820ECA084222C224265666F72652053706C6974223A22EBB684ED95A020ECA084222C224265666F7265205461736B223A22ED839CEC8AA4ED81AC20ECA084222C2242696E642070616765206974656D732028646570726563617465';
wwv_flow_imp.g_varchar2_table(36150) := '6429223A22ED8E98EC9DB4ECA78020ED95ADEBAAA920EBB094EC9DB8EB939C28EC82ACEC9AA9EB9098ECA78020EC958AEC9D8C29222C2242696E6420706172616D657465722076616C756573223A22EBA7A4EAB09CEBB380EC889820EAB09220EBB094EC';
wwv_flow_imp.g_varchar2_table(36151) := '9DB8EB939C222C2242696E642070726F63657373207661726961626C6573223A22ED9484EBA19CEC84B8EC8AA420EBB380EC889820EBB094EC9DB8EB939C222C22426C696E6420636172626F6E20636F707920726563697069656E74287329223A22EBB8';
wwv_flow_imp.g_varchar2_table(36152) := '94EB9DBCEC9DB8EB939C20ECB9B4EBB3B820EBB3B5EC82AC20EC8898EC8BA0EC9E90222C22426F64792048544D4C223A22EBB3B8EBACB82048544D4C222C22426F64792054657874223A22EBB3B8EBACB820EAB880EC9E90222C22426F756E6461727920';
wwv_flow_imp.g_varchar2_table(36153) := '6576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A22EBB098EBB3B520ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4EC979020EB8C80ED959C';
wwv_flow_imp.g_varchar2_table(36154) := '20EAB2BDEAB38420EC9DB4EBB2A4ED8AB8EB8A9420ED9884EC9EAC20ECA780EC9B90EB9098ECA78020EC958AEC8AB5EB8B88EB8BA42E222C22427573696E657373205265666572656E6365223A22EBB984ECA688EB8B88EC8AA420ECB0B8ECA1B0222C22';
wwv_flow_imp.g_varchar2_table(36155) := '427573696E6573732072756C65207461736B223A22EBB984ECA688EB8B88EC8AA420EAB79CECB99920ED839CEC8AA4ED81AC222C22427573696E6573732052756C65205461736B223A22EBB984ECA688EB8B88EC8AA420EAB79CECB99920ED839CEC8AA4';
wwv_flow_imp.g_varchar2_table(36156) := 'ED81AC222C22627573696E6573735F726566223A22627573696E6573735F726566222C2243616C6C204163746976697479223A22416374697669747920ED98B8ECB69C222C2243616C6C206163746976697479223A22ED86B5ED999420ED999CEB8F9922';
wwv_flow_imp.g_varchar2_table(36157) := '2C2243616C6C6564204469616772616D223A22ED98B8ECB69CEB909C20EB8BA4EC9DB4EC96B4EAB7B8EB9EA8222C2243616E63656C20626F756E64617279206576656E74223A22EAB2BDEAB38420EC9DB4EBB2A4ED8AB820ECB7A8EC868C222C2243616E';
wwv_flow_imp.g_varchar2_table(36158) := '63656C20656E64206576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB820ECB7A8EC868C222C2243616E63656C223A22ECB7A8EC868C222C22436172626F6E20636F707920726563697069656E74287329223A22ECB9B4EBB3B820EC82ACEBB3B8';
wwv_flow_imp.g_varchar2_table(36159) := '20EC8898EC8BA0EC9E90222C2243617465676F72792056616C7565223A22EBB294ECA3BC20EAB092222C224343223A22ECB0B8ECA1B0222C224368616E676520656C656D656E74223A22EC9A94EC868C20EBB380EAB2BD222C224368616E676520747970';
wwv_flow_imp.g_varchar2_table(36160) := '65223A22EC9CA0ED989520EBB380EAB2BD222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A22ED8E98EC9DB4ECA78020ED98B8ECB69CEC979020EB8C80ED959C20ECBA90EC8B9C20EAB09220ECA780EC9AB0EAB8';
wwv_flow_imp.g_varchar2_table(36161) := 'B0222C22436C656172204361636865223A22ECBA90EC8B9C20ECA780EC9AB0EAB8B0222C22436C6F62223A22434C4F42222C22436F6465223A22ECBD94EB939C222C22436F6C6C61626F726174696F6E223A22ED9891EC9785222C22436F6C6C61707365';
wwv_flow_imp.g_varchar2_table(36162) := '6420506F6F6C223A22ECB695EC868CEB909C20506F6F6C222C22436F6C6C6170736564205375622050726F63657373223A22ECB695EC868CEB909C20ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4222C22436F6C6C656374696F6E2054797065223A22';
wwv_flow_imp.g_varchar2_table(36163) := 'EC8898ECA79120EC9CA0ED9895222C22436F6C6C656374696F6E223A22EC8898ECA791222C22436F6D70656E7361746520456E64204576656E74223A22EBB3B4EC838120ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C22436F6D70656E7361746520496E';
wwv_flow_imp.g_varchar2_table(36164) := '7465726D656469617465205468726F77204576656E74223A22ECA491EAB08420EBB09CEC839D20EBB3B4EC838120EC9DB4EBB2A4ED8AB8222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A22EBB3B4EC838120EAB2BDEAB3';
wwv_flow_imp.g_varchar2_table(36165) := '8420EC9DB4EBB2A4ED8AB8222C22436F6D70656E736174696F6E20656E64206576656E74223A22EBB3B4EC838120ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C22436F6D70656E736174696F6E20696E7465726D656469617465207468726F7720657665';
wwv_flow_imp.g_varchar2_table(36166) := '6E74223A22EBB3B4EC838120ECA491EAB08420EBB09CEC839D20EC9DB4EBB2A4ED8AB8222C22436F6D70656E736174696F6E207374617274206576656E74223A22EBB3B4EC838120EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C22436F6D70656E736174';
wwv_flow_imp.g_varchar2_table(36167) := '696F6E223A22EBB3B4EC8381222C22436F6D706C65746564223A22EC9984EBA38CEB90A8222C22436F6D706C6574696F6E20436F6E646974696F6E223A22EC9984EBA38C20ECA1B0EAB1B4222C22436F6D706C65782067617465776179223A22EBB3B5ED';
wwv_flow_imp.g_varchar2_table(36168) := '95A920EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C22436F6D706C65782047617465776179223A22EBB3B5ED95A920EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C22436F6E646974696F6E2054797065223A22ECA1B0EAB1B420EC9CA0ED9895222C22436F6E';
wwv_flow_imp.g_varchar2_table(36169) := '646974696F6E223A22ECA1B0EAB1B4222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22ECA1B0EAB1B4EBB68020EAB2BDEAB38420EC9DB4EBB2A4ED8AB828EBB984ECA491EB';
wwv_flow_imp.g_varchar2_table(36170) := '8BA829222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A22ECA1B0EAB1B4EBB68020EAB2BDEAB38420EC9DB4EBB2A4ED8AB8222C22436F6E646974696F6E616C20666C6F77223A22ECA1B0EAB1B4EBB68020ED9D90EBA68422';
wwv_flow_imp.g_varchar2_table(36171) := '2C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22ECA1B0EAB1B4EBB68020ECA491EAB08420636174636820EC9DB4EBB2A4ED8AB8222C22436F6E646974696F6E616C20496E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(36172) := '204361746368204576656E74223A22ECA1B0EAB1B4EBB68020ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB8222C22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22ECA1B0EAB1';
wwv_flow_imp.g_varchar2_table(36173) := 'B4EBB68020EC8B9CEC9E9120EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C22436F6E646974696F6E616C207374617274206576656E74223A22ECA1B0EAB1B4EBB68020EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C22436F6E646974696F6E61';
wwv_flow_imp.g_varchar2_table(36174) := '6C205374617274204576656E74223A22ECA1B0EAB1B4EBB68020EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C22436F6E6E65637420746F206F7468657220656C656D656E74223A22EB8BA4EBA5B820EC9A94EC868CEC979020EC97B0EAB2B0222C22436F';
wwv_flow_imp.g_varchar2_table(36175) := '6E6E656374207573696E67206173736F63696174696F6E223A22EC97B0EAB480EC9D8420EC82ACEC9AA9ED9598EC97AC20ECA091EC868D222C22436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E223A22EB8DB0';
wwv_flow_imp.g_varchar2_table(36176) := 'EC9DB4ED84B020EC9E85EBA0A520EC97B0EAB480EC9D8420EC82ACEC9AA9ED9598EC97AC20ECA091EC868D222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A22EC';
wwv_flow_imp.g_varchar2_table(36177) := '8B9CED8080EC8AA42FEBA994EC8B9CECA78020ED948CEBA19CEC9AB020EB9890EB8A9420EC97B0EAB480EC9D8420EC82ACEC9AA9ED9598EC97AC20ECA091EC868D222C22436F707920627573696E657373207265666572656E6365223A22EBB984ECA688';
wwv_flow_imp.g_varchar2_table(36178) := 'EB8B88EC8AA420ECB0B8ECA1B020EBB3B5EC82AC222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A227B706C616E657DEC9790EC849C20EB88';
wwv_flow_imp.g_varchar2_table(36179) := '84EB9DBDEB909C2062706D6E456C656D656E74EBA5BC207B726F6F74456C656D656E747D28EC9CBC29EBA19C20EC8898ECA095ED9598EB8A9420ECA491222C22436F7272656C6174696F6E204B6579223A22EC8381EAB48020ED82A4222C22436F727265';
wwv_flow_imp.g_varchar2_table(36180) := '6C6174696F6E2056616C7565223A22EC8381EAB48020EAB092222C22437265617465207B747970657D223A227B747970657D20EC839DEC84B1222C224372656174652064617461206F626A656374207265666572656E6365223A22EB8DB0EC9DB4ED84B0';
wwv_flow_imp.g_varchar2_table(36181) := '20EAB09DECB2B420ECB0B8ECA1B020EC839DEC84B1222C2243726561746520646174612073746F7265207265666572656E6365223A22EB8DB0EC9DB4ED84B020ECA080EC9EA5EC868C20ECB0B8ECA1B020EC839DEC84B1222C2243726561746520446174';
wwv_flow_imp.g_varchar2_table(36182) := '614F626A6563745265666572656E6365223A22446174614F626A6563745265666572656E636520EC839DEC84B1222C22437265617465204461746153746F72655265666572656E6365223A224461746153746F72655265666572656E636520EC839DEC84';
wwv_flow_imp.g_varchar2_table(36183) := 'B1222C2243726561746520656E64206576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB820EC839DEC84B1222C2243726561746520456E644576656E74223A22456E644576656E7420EC839DEC84B1222C2243726561746520657870616E646564';
wwv_flow_imp.g_varchar2_table(36184) := '207375622D70726F63657373223A22ED9995EC9EA5EB909C20ED9598EC9C8420ED9484EBA19CEC84B8EC8AA420EC839DEC84B1222C2243726561746520657870616E6465642053756250726F63657373223A22ED9995EC9EA5EB909C2053756250726F63';
wwv_flow_imp.g_varchar2_table(36185) := '65737320EC839DEC84B1222C224372656174652067617465776179223A22EAB28CEC9DB4ED8AB8EC9BA8EC9DB420EC839DEC84B1222C224372656174652047617465776179223A22EAB28CEC9DB4ED8AB8EC9BA8EC9DB420EC839DEC84B1222C22437265';
wwv_flow_imp.g_varchar2_table(36186) := '6174652067726F7570223A22EAB7B8EBA3B920EC839DEC84B1222C224372656174652047726F7570223A22EAB7B8EBA3B920EC839DEC84B1222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A22ECA491EA';
wwv_flow_imp.g_varchar2_table(36187) := 'B0842FEAB2BDEAB38420EC9DB4EBB2A4ED8AB820EC839DEC84B1222C2243726561746520496E7465726D6564696174652F426F756E64617279204576656E74223A22ECA491EAB0842FEAB2BDEAB38420EC9DB4EBB2A4ED8AB820EC839DEC84B1222C2243';
wwv_flow_imp.g_varchar2_table(36188) := '7265617465206E6577202E2E2E223A22EC8388EBA19C20EC839DEC84B12E2E2E222C2243726561746520506F6F6C2F5061727469636970616E74223A22506F6F6C2FECB0B8EAB080EC9E9020EC839DEC84B1222C2243726561746520706F6F6C2F706172';
wwv_flow_imp.g_varchar2_table(36189) := '7469636970616E74223A22ED92802FECB0B8EAB080EC9E9020EC839DEC84B1222C22437265617465207374617274206576656E74223A22EC8B9CEC9E9120EC9DB4EBB2A4ED8AB820EC839DEC84B1222C224372656174652053746172742054696D657220';
wwv_flow_imp.g_varchar2_table(36190) := '4576656E74223A22EC8B9CEC9E9120ED8380EC9DB4EBA8B820EC9DB4EBB2A4ED8AB820EC839DEC84B1222C224372656174652053746172744576656E74223A2253746172744576656E7420EC839DEC84B1222C22437265617465207461736B223A22ED83';
wwv_flow_imp.g_varchar2_table(36191) := '9CEC8AA4ED81AC20EC839DEC84B1222C22437265617465205461736B223A22ED839CEC8AA4ED81AC20EC839DEC84B1222C22437573746F6D20457874656E73696F6E223A22EC82ACEC9AA9EC9E90ECA095EC9D9820ED9995EC9EA5222C22437573746F6D';
wwv_flow_imp.g_varchar2_table(36192) := '223A22EC82ACEC9AA9EC9E90ECA095EC9D98222C224379636C65202849534F203836303129223A22ECA3BCEAB8B02849534F203836303129222C224379636C6520284F7261636C6529223A22ECA3BCEAB8B0284F7261636C6529222C2244617461206F62';
wwv_flow_imp.g_varchar2_table(36193) := '6A656374207265666572656E6365223A22EB8DB0EC9DB4ED84B020EAB09DECB2B420ECB0B8ECA1B0222C2244617461204F626A656374205265666572656E6365223A22EB8DB0EC9DB4ED84B020EAB09DECB2B420ECB0B8ECA1B0222C2244617461207374';
wwv_flow_imp.g_varchar2_table(36194) := '6F7265207265666572656E6365223A22EB8DB0EC9DB4ED84B020ECA080EC9EA5EC868C20ECB0B8ECA1B0222C22446174612053746F7265205265666572656E6365223A22EB8DB0EC9DB4ED84B020ECA080EC9EA5EC868C20ECB0B8ECA1B0222C22446174';
wwv_flow_imp.g_varchar2_table(36195) := '612054797065223A22EB8DB0EC9DB4ED84B020EC9CA0ED9895222C2244617465202849534F203836303129223A22EC9DBCEC9E902849534F203836303129222C224461746520284F7261636C6529223A22EC9DBCEC9E90284F7261636C6529222C224461';
wwv_flow_imp.g_varchar2_table(36196) := '746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22595959592D4D4D2D444420484832343A4D493A535320ED9895EC8B9DEC9D9820EC9DBCEC9E90222C224461746520537472696E67223A22EC9DBCEC9E9020EB';
wwv_flow_imp.g_varchar2_table(36197) := 'ACB8EC9E90EC97B4222C2244617465223A22EC9DBCEC9E90222C2244656661756C74204170706C69636174696F6E204944223A22EAB8B0EBB3B820EC95A0ED948CEBA6ACECBC80EC9DB4EC8598204944222C2244656661756C74204170706C6963617469';
wwv_flow_imp.g_varchar2_table(36198) := '6F6E223A22EAB8B0EBB3B820EC95A0ED948CEBA6ACECBC80EC9DB4EC8598222C2244656661756C7420666C6F77223A22EAB8B0EBB3B820ED948CEBA19CEC9AB0222C2244656661756C742050616765204944223A22EAB8B0EBB3B820ED8E98EC9DB4ECA7';
wwv_flow_imp.g_varchar2_table(36199) := '80204944222C2244656661756C742050616765223A22EAB8B0EBB3B820ED8E98EC9DB4ECA780222C2244656661756C7420557365726E616D65223A22EAB8B0EBB3B820EC82ACEC9AA9EC9E9020EC9DB4EBA684222C2244656C657465223A22EC82ADECA0';
wwv_flow_imp.g_varchar2_table(36200) := '9C222C224465736372697074696F6E223A22EC84A4EBAA85222C2244657461696C73223A22EC84B8EBB680ECA095EBB3B4222C226469616772616D206E6F742070617274206F662062706D6E3A446566696E6974696F6E73223A2262706D6E3A44656669';
wwv_flow_imp.g_varchar2_table(36201) := '6E6974696F6E73EC9D9820EC9DBCEBB680EAB08020EC9584EB8B8C20EB8BA4EC9DB4EC96B4EAB7B8EB9EA8222C224469737472696275746520656C656D656E747320686F72697A6F6E74616C6C79223A22EC9A94EC868CEBA5BC20EAB080EBA19CEBA19C';
wwv_flow_imp.g_varchar2_table(36202) := '20EBB684EBB0B0222C224469737472696275746520656C656D656E747320766572746963616C6C79223A22EC9A94EC868CEBA5BC20EC8898ECA781EC9CBCEBA19C20EBB684EBB0B0222C2244697669646520696E746F207468726565206C616E6573223A';
wwv_flow_imp.g_varchar2_table(36203) := '22EC84B820EAB09CEC9D9820ECB0A8EC84A0EC9CBCEBA19C20EB8298EB8884EAB8B0222C2244697669646520696E746F2074776F206C616E6573223A22EB919020EAB09CEC9D9820ECB0A8EC84A0EC9CBCEBA19C20EBB684ED95A0222C22446F63756D65';
wwv_flow_imp.g_varchar2_table(36204) := '6E746174696F6E223A22EC84A4EBAA85EC849C222C22447565204F6E223A22EBA78CEAB8B020EC9DBCEC9E90222C224475706C696361746520696E636F6D696E672073657175656E636520666C6F7773223A22EC8898EC8BA02073657175656E63652066';
wwv_flow_imp.g_varchar2_table(36205) := '6C6F7720EBB3B5ECA09C222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A22EC86A1EC8BA02073657175656E636520666C6F7720EBB3B5ECA09C222C224475726174696F6E202849534F203836303129223A';
wwv_flow_imp.g_varchar2_table(36206) := '22EAB8B0EAB0842849534F203836303129222C224475726174696F6E20284F7261636C6529223A22EAB8B0EAB084284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C20445320';
wwv_flow_imp.g_varchar2_table(36207) := '5C2744444420484832343A4D493A53535C2720666F726D6174223A2249534F203836303120EB9890EB8A94204F7261636C6520EAB084EAB2A9204453205C2744444420484832343A4D493A53535C2720ED9895EC8B9DEC9D9820EAB8B0EAB084222C2265';
wwv_flow_imp.g_varchar2_table(36208) := '2E672E2032332D4A554E2D323032372031343A31303A3030223A22EC98883A2032303237EB85842036EC9B94203233EC9DBC2031343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A22EC98883A2044442D';
wwv_flow_imp.g_varchar2_table(36209) := '4D4F4E2D5959595920484832343A4D493A5353222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E223A227B7265666572';
wwv_flow_imp.g_varchar2_table(36210) := '656E6365647D237B70726F70657274797DEC9DB428EAB0802920ECB0B8ECA1B0ED9598EB8A9420EC9A94EC868C207B656C656D656E747DEC9DB428EAB0802920EC9584ECA78120EAB7B8EBA0A4ECA780ECA78020EC958AEC9598EC8AB5EB8B88EB8BA42E';
wwv_flow_imp.g_varchar2_table(36211) := '222C22456C656D656E7420646F63756D656E746174696F6E223A22EC9A94EC868C20EBACB8EC849C222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A22EC9A94EC86';
wwv_flow_imp.g_varchar2_table(36212) := '8CEC979020ED9788EC9AA9EB9098ECA78020EC958AEB8A94203C62706D6E3A436F6D706C6578476174657761793E20EC9CA0ED9895EC9DB420EC9E88EC8AB5EB8B88EB8BA42E222C22456C656D656E742068617320646973616C6C6F7765642074797065';
wwv_flow_imp.g_varchar2_table(36213) := '203C62706D6E3A4D65737361676553746172744576656E743E223A22EC9A94EC868CEC979020ED9788EC9AA9EB9098ECA78020EC958AEB8A94203C62706D6E3A4D65737361676553746172744576656E743E20EC9CA0ED9895EC9DB420EC9E88EC8AB5EB';
wwv_flow_imp.g_varchar2_table(36214) := '8B88EB8BA42E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A22EC9A94EC868CEC979020ED9788EC9AA9EB9098ECA78020EC958AEB8A94203C62706D6E3A53';
wwv_flow_imp.g_varchar2_table(36215) := '69676E616C53746172744576656E743E20EC9CA0ED9895EC9DB420EC9E88EC8AB5EB8B88EB8BA42E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A';
wwv_flow_imp.g_varchar2_table(36216) := '22EC9A94EC868CEC979020ED9788EC9AA9EB9098ECA78020EC958AEB8A9420EC9CA0ED9895203C62706D6E436F6E646974696F6E616C53746172744576656E743EEC9DB420EC9E88EC8AB5EB8B88EB8BA42E222C22456C656D656E74204944206973206C';
wwv_flow_imp.g_varchar2_table(36217) := '6F6E676572207468616E2035302063686172616374657273223A22EC9A94EC868C204944EAB080203530EC9E90EBA5BC20ECB488EAB3BCED95A9EB8B88EB8BA42E222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A';
wwv_flow_imp.g_varchar2_table(36218) := '22ED95ADEBAAA9204944EAB08020EC9584ECA78120EBB380EAB2BDEB9098ECA78020EC958AEC9598EC8AB5EB8B88EB8BA42E222C22456C656D656E7420697320616E20696D706C6963697420656E64223A22EC9A94EC868CEAB08020EC9594EC8B9CECA0';
wwv_flow_imp.g_varchar2_table(36219) := '8120EB819DEC9E84222C22456C656D656E7420697320616E20696D706C69636974207374617274223A22EC9A94EC868CEAB08020EC9594EC8B9CECA08120EC8B9CEC9E91EC9E84222C22456C656D656E74206973206D697373696E67206C6162656C2F6E';
wwv_flow_imp.g_varchar2_table(36220) := '616D65223A22EC9A94EC868CEC979020EBA088EC9DB4EBB8942FEC9DB4EBA684EC9DB420EB8884EB9DBDEB9098EC9788EC8AB5EB8B88EB8BA42E222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22EC9A94EC868CEAB08020EC97';
wwv_flow_imp.g_varchar2_table(36221) := 'B0EAB2B0EB9098ECA78020EC958AEC9598EC8AB5EB8B88EB8BA42E222C22656C656D656E74207265717569726564223A22EC9A94EC868C20ED9584EC9A94222C22456D61696C20636F6E74656E74223A22ECA084EC9E90EBA994EC9DBC20ECBD98ED8590';
wwv_flow_imp.g_varchar2_table(36222) := 'ECB8A0222C22456D61696C206F662074686520726563697069656E74287329223A22EC8898EC8BA0EC9E90EC9D9820ECA084EC9E90EBA994EC9DBC222C22456D61696C206F66207468652073656E646572223A22EBB09CEC8BA0EC9E90EC9D9820ECA084';
wwv_flow_imp.g_varchar2_table(36223) := 'EC9E90EBA994EC9DBC222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A22ED9A8CEC8BA0EC9D8420EBB3B4EB82BC20ECA084EC9E90EBA994EC9DBC222C22456D70747920706F6F6C2F706172';
wwv_flow_imp.g_varchar2_table(36224) := '7469636970616E74202872656D6F76657320636F6E74656E7429223A22EBB98820ED92802FECB0B8EAB080EC9E9028ECBD98ED8590ECB8A020ECA09CEAB1B029222C22456D70747920706F6F6C2F7061727469636970616E74223A22EBB98820ED92802F';
wwv_flow_imp.g_varchar2_table(36225) := 'ECB0B8EAB080EC9E90222C22456E64206576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C22456E64204576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C22456E64706F696E74223A22EB819DECA090222C22456E74657220';
wwv_flow_imp.g_varchar2_table(36226) := '637573746F6D20657874656E73696F6E73206173204A534F4E223A22EC82ACEC9AA9EC9E90ECA095EC9D9820ED9995EC9EA5EC9D84204A534F4EEC9CBCEBA19C20EC9E85EBA0A5ED9598EC8BADEC8B9CEC98A42E222C22456E7465722074686520504C2F';
wwv_flow_imp.g_varchar2_table(36227) := '53514C20636F646520746F2062652065786563757465642E223A22EC8BA4ED9689ED95A020504C2F53514C20ECBD94EB939CEBA5BC20EC9E85EBA0A5ED95A9EB8B88EB8BA42E222C224572726F7220626F756E64617279206576656E74223A22EC98A4EB';
wwv_flow_imp.g_varchar2_table(36228) := 'A59820EAB2BDEAB38420EC9DB4EBB2A4ED8AB8222C224572726F7220656E64206576656E74223A22EC98A4EBA59820ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C224572726F7220456E64204576656E74223A22EC98A4EBA59820ECA285EBA38C20EC9D';
wwv_flow_imp.g_varchar2_table(36229) := 'B4EBB2A4ED8AB8222C224572726F72207374617274206576656E74223A22EC98A4EBA59820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C224572726F72223A22EC98A4EBA598222C22457363616C6174696F6E20626F756E64617279206576656E742028';
wwv_flow_imp.g_varchar2_table(36230) := '6E6F6E2D696E74657272757074696E6729223A22EC9790EC8AA4ECBBACEBA088EC9DB4EC859820EAB2BDEAB38420EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C22457363616C6174696F6E20626F756E64617279206576656E74223A22EC9790';
wwv_flow_imp.g_varchar2_table(36231) := 'EC8AA4ECBBACEBA088EC9DB4EC859820EAB2BDEAB38420EC9DB4EBB2A4ED8AB8222C22457363616C6174696F6E20656E64206576656E74223A22EC9790EC8AA4ECBBACEBA088EC9DB4EC859820ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C2245736361';
wwv_flow_imp.g_varchar2_table(36232) := '6C6174696F6E20456E64204576656E74223A22EC9790EC8AA4ECBBACEBA088EC9DB4EC859820ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C22457363616C6174696F6E20696E7465726D656469617465207468726F77206576656E74223A22EC9790EC8A';
wwv_flow_imp.g_varchar2_table(36233) := 'A4ECBBACEBA088EC9DB4EC859820ECA491EAB084207468726F7720EC9DB4EBB2A4ED8AB8222C22457363616C6174696F6E20496E7465726D656469617465205468726F77204576656E74223A22EC9790EC8AA4ECBBACEBA088EC9DB4EC859820ECA491EA';
wwv_flow_imp.g_varchar2_table(36234) := 'B08420EBB09CEC839D20EC9DB4EBB2A4ED8AB8222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22EC9790EC8AA4ECBBACEBA088EC9DB4EC859820EC8B9CEC9E9120EC9DB4EBB2A4ED8A';
wwv_flow_imp.g_varchar2_table(36235) := 'B828EBB984ECA491EB8BA829222C22457363616C6174696F6E207374617274206576656E74223A22EC9790EC8AA4ECBBACEBA088EC9DB4EC859820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C22457363616C6174696F6E223A22EC9790EC8AA4ECBBAC';
wwv_flow_imp.g_varchar2_table(36236) := 'EBA088EC9DB4EC8598222C224576656E742042617365642047617465776179223A22EC9DB4EBB2A4ED8AB820EAB8B0EBB09820EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C224576656E7420686173206D756C7469706C65206576656E7420646566696E69';
wwv_flow_imp.g_varchar2_table(36237) := '74696F6E73223A22EC9DB4EBB2A4ED8AB8EC979020EB8BA4ECA49120EC9DB4EBB2A4ED8AB820ECA095EC9D98EAB08020EC9E88EC8AB5EB8B88EB8BA42E222C224576656E74205375622050726F63657373223A22EC9DB4EBB2A4ED8AB820ED9598EC9C84';
wwv_flow_imp.g_varchar2_table(36238) := '20ED9484EBA19CEC84B8EC8AA4222C224576656E74207375622D70726F63657373223A22EC9DB4EBB2A4ED8AB820ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4222C224576656E742054797065223A22EC9DB4EBB2A4ED8AB820EC9CA0ED9895222C22';
wwv_flow_imp.g_varchar2_table(36239) := '4576656E742D62617365642067617465776179223A22EC9DB4EBB2A4ED8AB820EAB8B0EBB09820EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C224578636C75646564205374617274696E67205573657273223A22ECA09CEC99B8EB909C20EC8B9CEC9E9120';
wwv_flow_imp.g_varchar2_table(36240) := 'EC82ACEC9AA9EC9E90222C224578636C75646564205573657273223A22ECA09CEC99B8EB909C20EC82ACEC9AA9EC9E90222C224578636C75736976652067617465776179223A22EBB0B0ED8380ECA08120EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C2245';
wwv_flow_imp.g_varchar2_table(36241) := '78636C75736976652047617465776179223A22EBB0B0ED8380ECA08120EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C2245786563757461626C65223A22EC8BA4ED968920ED8C8CEC9DBC222C224578656375746520504C2F53514C223A22504C2F53514C20';
wwv_flow_imp.g_varchar2_table(36242) := 'EC8BA4ED9689222C22457865637574696F6E223A22EC8BA4ED9689222C22457870616E64656420706F6F6C2F7061727469636970616E74223A22ED9995EC9EA5EB909C20ED92802FECB0B8EAB080EC9E90222C22457870616E646564205375622050726F';
wwv_flow_imp.g_varchar2_table(36243) := '63657373223A22ED9995EC9EA520ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4222C2245787072657373696F6E20284C656761637929223A22ED919CED9884EC8B9D28EBA088EAB1B0EC8B9C29222C2245787072657373696F6E2054797065223A22ED';
wwv_flow_imp.g_varchar2_table(36244) := '919CED9884EC8B9D20EC9CA0ED9895222C2245787072657373696F6E223A22ED919CED9884EC8B9D222C226661696C656420746F20696D706F7274207B656C656D656E747D223A227B656C656D656E747D20EC9E84ED8FACED8AB8EBA5BC20EC8BA4ED8C';
wwv_flow_imp.g_varchar2_table(36245) := 'A8ED9688EC8AB5EB8B88EB8BA42E222C22666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A22ED948CEBA19CEC9AB020EC9A94EC868CEB8A9420506F6F6C2FECB0B8';
wwv_flow_imp.g_varchar2_table(36246) := 'EAB080EC9E90EC9D9820ED9598EC9C84EC97ACEC95BC20ED95A9EB8B88EB8BA42E222C22466C6F772073706C69747320696D706C696369746C79223A22ED9D90EBA68420EBB684ED95A020EC9594EC8B9CECA081222C22466F726D2054656D706C617465';
wwv_flow_imp.g_varchar2_table(36247) := '204974656D204E616D65223A22EC849CEC8B9D20ED859CED948CEBA6ACED8AB820ED95ADEBAAA920EC9DB4EBA684222C22466F726D2054656D706C617465204974656D223A22EC849CEC8B9D20ED859CED948CEBA6ACED8AB820ED95ADEBAAA9222C2246';
wwv_flow_imp.g_varchar2_table(36248) := '6F726D2054656D706C617465223A22EC849CEC8B9D20ED859CED948CEBA6ACED8AB8222C22466F726D6174204D61736B223A22ED9895EC8B9D20EBA788EC8AA4ED81AC222C22466F726D61744D61736B223A22466F726D61744D61736B222C2246726F6D';
wwv_flow_imp.g_varchar2_table(36249) := '223A22EC8B9CEC9E91EC9DBC222C2246756E6374696F6E20426F647920284C656761637929223A22ED95A8EC889820EBB3B8EBACB828EBA088EAB1B0EC8B9C29222C2246756E6374696F6E20426F6479223A22ED95A8EC889820EBB3B8EBACB8222C2247';
wwv_flow_imp.g_varchar2_table(36250) := '617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A22EAB28CEC9DB4ED8AB8EC9BA8EC9DB4EAB08020EBB688ED9584EC9A94ED95A9EB8B88EB8BA42E20EC';
wwv_flow_imp.g_varchar2_table(36251) := '868CEC8AA4EC998020EB8C80EC8381EC9DB420ED9598EB8298EBA78C20EC9E88EC8AB5EB8B88EB8BA42E222C2247656E6572616C223A22EC9DBCEBB098222C2247656E65726174652064656661756C74206974656D73223A22EAB8B0EBB3B820ED95ADEB';
wwv_flow_imp.g_varchar2_table(36252) := 'AAA920EC839DEC84B1222C22476C6F62616C206572726F72207265666572656E6365223A22ECA084EC97AD20EC98A4EBA59820ECB0B8ECA1B0222C22476C6F62616C20657363616C6174696F6E207265666572656E6365223A22EAB880EBA19CEBB28C20';
wwv_flow_imp.g_varchar2_table(36253) := 'EC9790EC8AA4ECBBACEBA088EC9DB4EC859820ECB0B8ECA1B0222C22476C6F62616C207369676E616C207265666572656E6365223A22ECA084EC97AD20EC8BA0ED98B820ECB0B8ECA1B0222C2247726F7570223A22EAB7B8EBA3B9222C2248544D4C2076';
wwv_flow_imp.g_varchar2_table(36254) := '657273696F6E206F662074686520656D61696C223A22ECA084EC9E90EBA994EC9DBCEC9D982048544D4C20EBB284ECA084222C224944206D75737420626520756E697175652E223A224944EB8A9420EAB3A0EC9CA0ED95B4EC95BC20ED95A9EB8B88EB8B';
wwv_flow_imp.g_varchar2_table(36255) := 'A42E222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A224444442048483A4D4D3A535320ED9895EC8B9D222C22696E20666F726D61742059592D4D4D223A2259592D4D4D20ED9895EC8B9D222C22496E205661';
wwv_flow_imp.g_varchar2_table(36256) := '726961626C6573223A22EBB380EC8898222C22496E2F4F7574204D617070696E67223A22EC9E85EBA0A52FECB69CEBA0A520EBA7A4ED9591222C22496E2F4F7574205661726961626C6573223A22EC9E85EBA0A52FECB69CEBA0A520EBB380EC8898222C';
wwv_flow_imp.g_varchar2_table(36257) := '22496E636C75736976652067617465776179223A22ED8FACEAB484ECA08120EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A22EC8898EC8BA020ED948CEBA19CEC9AB0EAB08020ECA1';
wwv_flow_imp.g_varchar2_table(36258) := 'B0EC9DB8EB9098ECA78020EC958AEC9D8C222C22496E69746961746F72206F66207468697320617070726F76616C207461736B223A22EC9DB420EC8AB9EC9DB820ED839CEC8AA4ED81ACEC9D9820EAB09CEC8B9CEC9E90222C22496E69746961746F7222';
wwv_flow_imp.g_varchar2_table(36259) := '3A22EAB09CEC8B9CEC9E90222C22496E70757420436F6C6C656374696F6E223A22EC9E85EBA0A520EC8898ECA791222C22496E70757420456C656D656E74223A22EC9E85EBA0A520EC9A94EC868C222C22496E7465726D656469617465207468726F7720';
wwv_flow_imp.g_varchar2_table(36260) := '6576656E74223A22ECA491EAB084207468726F7720EC9DB4EBB2A4ED8AB8222C22496E7465726D656469617465205468726F77204576656E74223A22ECA491EAB08420ED88ACEC82AC20EC9DB4EBB2A4ED8AB8222C22496E74657276616C223A22EAB084';
wwv_flow_imp.g_varchar2_table(36261) := 'EAB2A9222C2249732043616C6C61626C65223A22ED98B8ECB69C20EAB080EB8AA5222C22497320526F6C65223A22EC97ADED95A0222C22497320537461727461626C65223A22EC8B9CEC9E9120EAB080EB8AA520EC97ACEBB680222C2249534F223A2249';
wwv_flow_imp.g_varchar2_table(36262) := '534F222C224974656D204E616D65223A22ED9288EBAAA920EC9DB4EBA684222C224974656D2056616C7565223A22ED9288EBAAA920EAB092222C224974656D223A22ED9288EBAAA9222C22497465726174696E672063616C6C2061637469766974657320';
wwv_flow_imp.g_varchar2_table(36263) := '6172652063757272656E746C79206E6F7420737570706F72746564223A22ED86B5ED999420ED999CEB8F9920EBB098EBB3B5EC9D8020ED9884EC9EAC20ECA780EC9B90EB9098ECA78020EC958AEC8AB5EB8B88EB8BA42E222C224A534F4E204F626A6563';
wwv_flow_imp.g_varchar2_table(36264) := '74223A224A534F4E20EAB09DECB2B4222C224C616E65223A22ED95ADEBA19C222C224C61746573742076657273696F6E223A22ECB59CEC8BA020EBB284ECA084222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A22EC';
wwv_flow_imp.g_varchar2_table(36265) := 'A491EAB08420636174636820EC9DB4EBB2A4ED8AB820EBA781ED81AC222C224C696E6B20496E7465726D656469617465204361746368204576656E74223A22ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB820EC97B0EAB2B0222C224C696E6B20';
wwv_flow_imp.g_varchar2_table(36266) := '696E7465726D656469617465207468726F77206576656E74223A22EBA781ED81AC20ECA491EAB084207468726F7720EC9DB4EBB2A4ED8AB8222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A22ECA491EAB084205468';
wwv_flow_imp.g_varchar2_table(36267) := '726F7720EC9DB4EBB2A4ED8AB820EC97B0EAB2B0222C224C696E6B223A22EBA781ED81AC222C224C6F616420646566696E6564207661726961626C6573223A22ECA095EC9D98EB909C20EBB380EC889820EBA19CEB939C222C224C6F6164204A534F4E22';
wwv_flow_imp.g_varchar2_table(36268) := '3A224A534F4E20EBA19CEB939C222C224C6F616420506172616D6574657273223A22EBA7A4EAB09CEBB380EC889820EBA19CEB939C222C224C6F6F70223A22EBA3A8ED9484222C224D61696C223A22EBA994EC9DBC222C224D616E75616C207461736B22';
wwv_flow_imp.g_varchar2_table(36269) := '3A22EC8898EB8F9920ED839CEC8AA4ED81AC222C224D616E75616C205461736B223A22EC8898EB8F9920ED839CEC8AA4ED81AC222C224D61782052756E73223A22ECB59CEB8C8020EC8BA4ED9689222C224D65737361676520626F756E64617279206576';
wwv_flow_imp.g_varchar2_table(36270) := '656E7420286E6F6E2D696E74657272757074696E6729223A22EBA994EC8B9CECA78020EAB2BDEAB38420EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C224D65737361676520626F756E64617279206576656E74223A22EBA994EC8B9CECA78020';
wwv_flow_imp.g_varchar2_table(36271) := 'EAB2BDEAB38420EC9DB4EBB2A4ED8AB8222C224D65737361676520656E64206576656E74223A22EBA994EC8B9CECA78020ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C224D65737361676520456E64204576656E74223A22EBA994EC8B9CECA78020ECA2';
wwv_flow_imp.g_varchar2_table(36272) := '85EBA38C20EC9DB4EBB2A4ED8AB8222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A22EBA994EC8B9CECA78020ECA491EAB08420636174636820EC9DB4EBB2A4ED8AB8222C224D65737361676520496E746572';
wwv_flow_imp.g_varchar2_table(36273) := '6D656469617465204361746368204576656E74223A22EBA994EC8B9CECA78020ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB8222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A22EBA994EC8B9CECA7';
wwv_flow_imp.g_varchar2_table(36274) := '8020ECA491EAB084207468726F7720EC9DB4EBB2A4ED8AB8222C224D65737361676520496E7465726D656469617465205468726F77204576656E74223A22EBA994EC8B9CECA78020ECA491EAB084205468726F7720EC9DB4EBB2A4ED8AB8222C224D6573';
wwv_flow_imp.g_varchar2_table(36275) := '73616765204E616D65223A22EBA994EC8B9CECA78020EC9DB4EBA684222C224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22EBA994EC8B9CECA78020EC8B9CEC9E9120EC9DB4EBB2A4ED8AB828EB';
wwv_flow_imp.g_varchar2_table(36276) := 'B984ECA491EB8BA829222C224D657373616765207374617274206576656E74223A22EBA994EC8B9CECA78020EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C224D657373616765205374617274204576656E74223A22EBA994EC8B9CECA78020EC8B9CEC9E';
wwv_flow_imp.g_varchar2_table(36277) := '9120EC9DB4EBB2A4ED8AB8222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A227B73656D616E7469637D236174746163686564546F52656620EB8884EB9DBD222C226D6F7265207468616E207B636F756E747D';
wwv_flow_imp.g_varchar2_table(36278) := '206368696C64206C616E6573223A227B636F756E747DEAB09C20EC9DB4EC8381EC9D9820ED9598EC9C8420EBA088EC9DB8222C224D756C74692D496E7374616E6365223A22EB8BA4ECA49120EC9DB8EC8AA4ED84B4EC8AA4222C226D756C7469706C6520';
wwv_flow_imp.g_varchar2_table(36279) := '444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A227B656C656D656E747DEC979020EB8C80ED95B420EB8BA4ECA49120444920EC9A94EC868CEAB08020ECA095EC9D98EB90A8222C224E616D65206F662074686520';
wwv_flow_imp.g_varchar2_table(36280) := '6469616772616D223A22EB8BA4EC9DB4EC96B4EAB7B8EB9EA820EC9DB4EBA684222C224E616D65206F66207468652050726F63657373205661726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E6529223A';
wwv_flow_imp.g_varchar2_table(36281) := '22EC8B9CEAB084EB8C80EAB08020EC9E88EB8A9420EC8B9CEAB08420EAB8B0EBA19D20EC9CA0ED9895EC9D9820ED9484EBA19CEC84B8EC8AA420EBB380EC889820EC9DB4EBA684222C224E616D65206F66207468652050726F6365737320566172696162';
wwv_flow_imp.g_varchar2_table(36282) := '6C65223A22ED9484EBA19CEC84B8EC8AA420EBB380EC889820EC9DB4EBA684222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C20726573756C7420696E746F223A22EC8AB9EC9DB820EA';
wwv_flow_imp.g_varchar2_table(36283) := 'B2B0EAB3BCEBA5BC20EBB098ED9998ED95A020EBB380EC889820EC9DB4EBA684222C224E616D65223A22EC9DB4EBA684222C224E616D65642076657273696F6E223A22EBAA85EBAA85EB909C20EBB284ECA084222C226E6F2062706D6E456C656D656E74';
wwv_flow_imp.g_varchar2_table(36284) := '207265666572656E63656420696E207B656C656D656E747D223A227B656C656D656E747DEC9790EC849C20ECB0B8ECA1B0EB909C2062706D6E456C656D656E7420EC9786EC9D8C222C226E6F206469616772616D20746F20646973706C6179223A22ED91';
wwv_flow_imp.g_varchar2_table(36285) := '9CEC8B9CED95A020EB8BA4EC9DB4EC96B4EAB7B8EB9EA820EC9786EC9D8C222C226E6F20706172656E7420666F72207B656C656D656E747D20696E207B706172656E747D223A227B706172656E747DEC9790207B656C656D656E747DEC979020EB8C80ED';
wwv_flow_imp.g_varchar2_table(36286) := '959C20EC8381EC9C84EAB08020EC9786EC8AB5EB8B88EB8BA42E222C226E6F20706C616E6520666F72207B656C656D656E747D223A227B656C656D656E747DEC979020EB8C80ED959C20EBB984ED9689EAB8B020EC9786EC9D8C222C226E6F2070726F63';
wwv_flow_imp.g_varchar2_table(36287) := '657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A22ED919CEC8B9CED95A020ED9484EBA19CEC84B8EC8AA420EB9890EB8A9420ED9891EC978520EC9786EC9D8C222C226E6F207368617065207479706520737065636966';
wwv_flow_imp.g_varchar2_table(36288) := '696564223A22ECA780ECA095EB909C20EAB5ACEC84B120EC9CA0ED9895EC9DB420EC9786EC8AB5EB8B88EB8BA42E222C224E756D626572223A22EBB288ED98B8222C224F6E204576656E74223A22EC9DB4EBB2A4ED8AB820EC8B9C222C224F7261636C65';
wwv_flow_imp.g_varchar2_table(36289) := '205363686564756C652065787072657373696F6E223A224F7261636C6520EC9DBCECA09520ED919CED9884EC8B9D222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A22EBB294EC9C84EBA5BC';
wwv_flow_imp.g_varchar2_table(36290) := '20EBB297EC96B4EB82A820ED95B4ECA09C222C224F7574205661726961626C6573223A22ECB69CEBA0A520EBB380EC8898222C224F757470757420436F6C6C656374696F6E223A22ECB69CEBA0A520EC8898ECA791222C224F757470757420456C656D65';
wwv_flow_imp.g_varchar2_table(36291) := '6E74223A22ECB69CEBA0A520EC9A94EC868C222C224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A22ED839CEC8AA4ED81AC20ECA095EC9D98EC979020EC84A4ECA095EB909C20';
wwv_flow_imp.g_varchar2_table(36292) := 'EAB8B0EBB3B8EAB09220EB8DAEEC96B4EC93B0EAB8B0222C2250616765204944223A22ED8E98EC9DB4ECA780204944222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E6365223A';
wwv_flow_imp.g_varchar2_table(36293) := '22EC9691EC8B9D20ED859CED948CEBA6ACED8AB820ECB0B8ECA1B0EBA5BC20ED8FACED95A8ED9598EB8A9420ED8E98EC9DB4ECA78020ED95ADEBAAA9222C2250616765204974656D73223A22ED8E98EC9DB4ECA78020ED95ADEBAAA9222C225061676522';
wwv_flow_imp.g_varchar2_table(36294) := '3A22ED8E98EC9DB4ECA780222C22506172616C6C656C2067617465776179223A22EBB391EBA0AC20EAB28CEC9DB4ED8AB8EC9BA8EC9DB4222C22506172616C6C656C2047617465776179223A22EBB391EBA0AC20EAB28CEC9DB4ED8AB8EC9BA8EC9DB422';
wwv_flow_imp.g_varchar2_table(36295) := '2C22506172616C6C656C206D756C74692D696E7374616E6365223A22EBB391EBA0AC20EB8BA4ECA49120EC9DB8EC8AA4ED84B4EC8AA4222C225061727469636970616E74204944223A22ECB0B8EAB080EC9E90204944222C225061727469636970616E74';
wwv_flow_imp.g_varchar2_table(36296) := '206D756C7469706C6963697479223A22ECB0B8EC97ACEC9E9020EB8BA4ECA491EC84B1222C225061727469636970616E74204E616D65223A22ECB0B8EAB080EC9E9020EC9DB4EBA684222C225061727469636970616E74223A22ECB0B8EAB080EC9E9022';
wwv_flow_imp.g_varchar2_table(36297) := '2C225061796C6F6164205661726961626C65223A22ED8E98EC9DB4EBA19CEB939C20EBB380EC8898222C225061796C6F6164223A22ED8E98EC9DB4EBA19CEB939C222C22504C2F53514C20436F6465223A22504C2F53514C20ECBD94EB939C222C22504C';
wwv_flow_imp.g_varchar2_table(36298) := '2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A22EBB680EC9AB820EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C20457870';
wwv_flow_imp.g_varchar2_table(36299) := '72657373696F6E2072657475726E696E67206120646174652076616C7565223A22EB82A0ECA79C20EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2045787072657373696F6E20726574';
wwv_flow_imp.g_varchar2_table(36300) := '75726E696E672061206E756D6265722076616C7565223A22EC88ABEC9E9020EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120';
wwv_flow_imp.g_varchar2_table(36301) := '54696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22EC8B9CEAB084EB8C8020EAB092EC9DB420EC9E88EB8A9420EC8B9CEAB08420EAB8B0EBA19DEC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884';
wwv_flow_imp.g_varchar2_table(36302) := 'EC8B9D222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22595959592D4D4D2D444420';
wwv_flow_imp.g_varchar2_table(36303) := '484832343A4D493A535320545A5220ED9895EC8B9DEC9CBCEBA19C20766172636861723220EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2045787072657373696F6E2072657475726E';
wwv_flow_imp.g_varchar2_table(36304) := '696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22766172636861723220EAB092EC9D8420595959592D4D4D2D444420484832343A4D493A535320ED9895EC8B9DEC';
wwv_flow_imp.g_varchar2_table(36305) := '9CBCEBA19C20EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D617422';
wwv_flow_imp.g_varchar2_table(36306) := '3A22EC88ABEC9E9020ED9895EC8B9DEC9CBCEBA19C20766172636861723220EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120';
wwv_flow_imp.g_varchar2_table(36307) := '76617263686172322076616C7565223A22766172636861723220EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D65737461';
wwv_flow_imp.g_varchar2_table(36308) := '6D7020776974682054696D65205A6F6E65223A22EC8B9CEAB084EB8C80EAB08020ED8FACED95A8EB909C20EC8B9CEAB08420EAB8B0EBA19DEC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED919CED9884EC8B9D222C22504C2F53514C2046';
wwv_flow_imp.g_varchar2_table(36309) := '756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A22EBB680EC9AB820EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C204675';
wwv_flow_imp.g_varchar2_table(36310) := '6E6374696F6E20426F64792072657475726E696E67206120646174652076616C7565223A22EC9DBCEC9E9020EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C2046756E637469';
wwv_flow_imp.g_varchar2_table(36311) := '6F6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A22EC88ABEC9E9020EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C2046756E6374696F6E';
wwv_flow_imp.g_varchar2_table(36312) := '20426F64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22EC8B9CEAB084EB8C8020EAB092EC9DB420EC9E88EB8A9420EC8B9CEAB08420EAB8B0EBA19DEC9D8420EBB098ED9998ED95';
wwv_flow_imp.g_varchar2_table(36313) := '98EB8A9420504C2F53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832';
wwv_flow_imp.g_varchar2_table(36314) := '343A4D493A535320545A52223A22595959592D4D4D2D444420484832343A4D493A535320545A5220ED9895EC8B9DEC9CBCEBA19C20766172636861723220EAB092EC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED95A8EC889820EBB3B8EB';
wwv_flow_imp.g_varchar2_table(36315) := 'ACB8222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22504C2F53514C20ED95A8EC8898';
wwv_flow_imp.g_varchar2_table(36316) := '20EBB3B8EBACB8EC9DB420595959592D4D4D2D444420484832343A4D493A535320ED9895EC8B9DEC9CBCEBA19C20766172636861723220EAB092EC9D8420EBB098ED9998ED95A9EB8B88EB8BA42E222C22504C2F53514C2046756E6374696F6E20426F64';
wwv_flow_imp.g_varchar2_table(36317) := '792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22766172636861723220EAB092EC9D8420EC88ABEC9E9020ED9895EC8B9DEC9CBCEBA19C20EBB098ED9998ED9598EB8A9420504C2F';
wwv_flow_imp.g_varchar2_table(36318) := '53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565223A22766172636861723220EAB092EC9D8420EBB098ED9998ED9598EB8A942050';
wwv_flow_imp.g_varchar2_table(36319) := '4C2F53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22EC8B9CEAB084EB8C80EAB08020ED8FACED95A8EB';
wwv_flow_imp.g_varchar2_table(36320) := '909C20EC8B9CEAB08420EAB8B0EBA19DEC9D8420EBB098ED9998ED9598EB8A9420504C2F53514C20ED95A8EC889820EBB3B8EBACB8222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A22EC9C84ECB99820ED919CEC8B';
wwv_flow_imp.g_varchar2_table(36321) := '9CEC9E90222C22506F74656E7469616C2047726F757073223A22EC9EA0EC9EACECA08120EAB7B8EBA3B9222C22506F74656E7469616C205374617274657273223A22EC9EA0EC9EACECA08120EC8B9CEC9E91222C22506F74656E7469616C205374617274';
wwv_flow_imp.g_varchar2_table(36322) := '696E672047726F757073223A22EC9EA0EC9EACECA08120EC8B9CEC9E9120EAB7B8EBA3B9222C22506F74656E7469616C205374617274696E67205573657273223A22EC9EA0EC9EACECA08120EC8B9CEC9E9120EC82ACEC9AA9EC9E90222C22506F74656E';
wwv_flow_imp.g_varchar2_table(36323) := '7469616C205573657273223A22EC9EA0EC9EAC20EC82ACEC9AA9EC9E90222C225072696F72697479223A22EC9AB0EC84A0EC889CEC9C84222C2250726F6365737320646F63756D656E746174696F6E223A22ED9484EBA19CEC84B8EC8AA420EBACB8EC84';
wwv_flow_imp.g_varchar2_table(36324) := '9CED9994222C2250726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22ED9484EBA19CEC84B8EC8AA4EC979020EBB98820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8EAB08020EC97ACEB9FAC20EAB09C20';
wwv_flow_imp.g_varchar2_table(36325) := 'EC9E88EC8AB5EB8B88EB8BA42E222C2250726F63657373204944223A22ED9484EBA19CEC84B8EC8AA4204944222C2250726F63657373206973206D697373696E6720656E64206576656E74223A22ED9484EBA19CEC84B8EC8AA4EC979020ECA285EBA38C';
wwv_flow_imp.g_varchar2_table(36326) := '20EC9DB4EBB2A4ED8AB8EAB08020EB8884EB9DBDEB9098EC9788EC8AB5EB8B88EB8BA42E222C2250726F63657373206973206D697373696E67207374617274206576656E74223A22ED9484EBA19CEC84B8EC8AA4EC979020EC8B9CEC9E9120EC9DB4EBB2';
wwv_flow_imp.g_varchar2_table(36327) := 'A4ED8AB8EAB08020EB8884EB9DBDEB9098EC9788EC8AB5EB8B88EB8BA42E222C2250726F63657373206E616D65223A22ED9484EBA19CEC84B8EC8AA420EC9DB4EBA684222C2250726F63657373205072696F72697479223A22ED9484EBA19CEC84B8EC8A';
wwv_flow_imp.g_varchar2_table(36328) := 'A420EC9AB0EC84A0EC889CEC9C84222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E223A22ECA285EBA38C20ED9B8420EC8381ED839C20ECB298EBA6AC222C2250726F63657373205661726961626C652028417272';
wwv_flow_imp.g_varchar2_table(36329) := '617929223A22ED9484EBA19CEC84B8EC8AA420EBB380EC889828EBB0B0EC97B429222C2250726F63657373205661726961626C6520284C69737429223A22ED9484EBA19CEC84B8EC8AA420EBB380EC889828EBAAA9EBA19D29222C2250726F6365737320';
wwv_flow_imp.g_varchar2_table(36330) := '5661726961626C65223A22ED9484EBA19CEC84B8EC8AA420EBB380EC8898222C2250726F63657373223A22ED9484EBA19CEC84B8EC8AA4222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A22ECA084EC9E90';
wwv_flow_imp.g_varchar2_table(36331) := 'EBA994EC9DBC20ED859CED948CEBA6ACED8AB8EC979020EB8C80ED959C20EAB09220ECA09CEAB3B5222C2252656365697665207461736B223A22ED839CEC8AA4ED81AC20EBB09BEAB8B0222C2252656365697665205461736B223A22ED839CEC8AA4ED81';
wwv_flow_imp.g_varchar2_table(36332) := 'AC20EC8898EC8BA0222C225265646F223A22EC9EACEC8BA4ED9689222C2252656D6F7665223A22ECA09CEAB1B0222C225265706C7920546F223A22ED9A8CEC8BA020EB8C80EC8381222C22526571756573742056616C756520666F722050616765204361';
wwv_flow_imp.g_varchar2_table(36333) := '6C6C223A22ED8E98EC9DB4ECA78020ED98B8ECB69CEC979020EB8C80ED959C20EC9A94ECB2AD20EAB092222C2252657175657374223A22EC9A94ECB2AD222C22526573756C74205661726961626C65223A22EAB2B0EAB3BC20EBB380EC8898222C225265';
wwv_flow_imp.g_varchar2_table(36334) := '7475726E205061796C6F616420496E746F223A22EBB098ED999820ED8E98EC9DB4EBA19CEB939C20EB8C80EC8381222C22526F6C65223A22EC97ADED95A0222C2253617665223A22ECA080EC9EA5222C225363686564756C65722045787072657373696F';
wwv_flow_imp.g_varchar2_table(36335) := '6E223A22EC8AA4ECBC80ECA484EB9FAC20ED919CED9884EC8B9D222C225363686564756C696E67223A22EC8AA4ECBC80ECA484EBA781222C22536372697074207461736B223A22EC8AA4ED81ACEBA6BDED8AB820ED839CEC8AA4ED81AC222C2253637269';
wwv_flow_imp.g_varchar2_table(36336) := '7074205461736B223A22EC8AA4ED81ACEBA6BDED8AB820ED839CEC8AA4ED81AC222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A22EC9DB420EB8BA4EC9DB4EC96B4EAB7B8EB9EA8EC9D8420EC8B9CEC';
wwv_flow_imp.g_varchar2_table(36337) := '9E91ED95A020EC889820EC9E88EB8A94ECA78020EC97ACEBB68020EC84A0ED839D222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A22EC9DB4';
wwv_flow_imp.g_varchar2_table(36338) := '20EB8BA4EC9DB4EC96B4EAB7B8EB9EA8EC9DB420ED98B8ECB69C20ED999CEB8F99EC9790EC849C20ED98B8ECB69CEB9098EC96B4EC95BC20ED9598EB8A94ECA78020EC97ACEBB680EBA5BC20EC84A0ED839DED95A9EB8B88EB8BA42E222C2253656E6420';
wwv_flow_imp.g_varchar2_table(36339) := '456D61696C20496D6D6564696174656C79223A22EC9DB4EBA994EC9DBC20ECA689EC8B9C20ECA084EC86A1222C2253656E64204D61696C223A22EBA994EC9DBC20ECA084EC86A1222C2253656E64205461736B223A22ED839CEC8AA4ED81AC20EBB09CEC';
wwv_flow_imp.g_varchar2_table(36340) := '86A1222C2253656E64207461736B223A22ED839CEC8AA4ED81AC20ECA084EC86A1222C2253657175656E636520666C6F77223A22EC8B9CED8080EC8AA420ED9D90EBA684222C2253657175656E6365223A22EC889CEC849C222C2253657175656E636546';
wwv_flow_imp.g_varchar2_table(36341) := '6C6F772069732061206475706C6963617465223A2253657175656E6365466C6F77EC9D8020ECA491EBB3B5EB90A9EB8B88EB8BA42E222C2253657175656E7469616C206D756C74692D696E7374616E6365223A22EC889CECB0A8ECA08120EB8BA4ECA491';
wwv_flow_imp.g_varchar2_table(36342) := '20EC9DB8EC8AA4ED84B4EC8AA4222C2253657276696365207461736B223A22EC849CEBB984EC8AA420ED839CEC8AA4ED81AC222C2253657276696365205461736B223A22EC849CEBB984EC8AA420ED839CEC8AA4ED81AC222C2253657420636F6C6F7222';
wwv_flow_imp.g_varchar2_table(36343) := '3A22EC8389EC838120EC84A4ECA095222C225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22EC8BA0ED98B820EAB2BDEAB38420EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C225369';
wwv_flow_imp.g_varchar2_table(36344) := '676E616C20626F756E64617279206576656E74223A22EC8BA0ED98B820EAB2BDEAB38420EC9DB4EBB2A4ED8AB8222C225369676E616C20656E64206576656E74223A22EC8BA0ED98B820ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C225369676E616C20';
wwv_flow_imp.g_varchar2_table(36345) := '456E64204576656E74223A22EC8BA0ED98B820ECA285EBA38C20EC9DB4EBB2A4ED8AB8222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A22EC8BA0ED98B820ECA491EAB08420636174636820EC9DB4EBB2A4ED8A';
wwv_flow_imp.g_varchar2_table(36346) := 'B8222C225369676E616C20496E7465726D656469617465204361746368204576656E74223A22EC8BA0ED98B820ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB8222C225369676E616C20696E7465726D656469617465207468726F77206576656E';
wwv_flow_imp.g_varchar2_table(36347) := '74223A22EC8BA0ED98B820ECA491EAB08420EB8D98ECA780EAB8B020EC9DB4EBB2A4ED8AB8222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A22EC8BA0ED98B820ECA491EAB08420EBB09CEC839D20EC9DB4EBB2';
wwv_flow_imp.g_varchar2_table(36348) := 'A4ED8AB8222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22EC8BA0ED98B820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C225369676E616C20737461727420657665';
wwv_flow_imp.g_varchar2_table(36349) := '6E74223A22EC8BA0ED98B820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C225369676E616C205374617274204576656E74223A22EC8BA0ED98B820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C225369676E616C223A22EC8BA0ED98B8222C2253696D70';
wwv_flow_imp.g_varchar2_table(36350) := '6C65204D657373616765223A22EB8BA8EC889C20EBA994EC8B9CECA780222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69737429223A2253514C20ECA788EC9D9828ECBD9CEBA1A0EC9CBCEBA19C20EAB5ACEBB684EB909C';
wwv_flow_imp.g_varchar2_table(36351) := '20EBAAA9EBA19D29222C2253514C20717565727920284A534F4E20617272617929223A2253514C20ECA788EC9D98284A534F4E20EBB0B0EC97B429222C2253514C207175657279202873696E676C652076616C756529223A2253514C20ECA788EC9D9828';
wwv_flow_imp.g_varchar2_table(36352) := 'EB8BA8EC9DBC20EAB09229222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A22ECBD9CEBA1A0EC9CBCEBA19C20EAB5ACEBB684EB909C20EBAAA9EBA19DEC9D8420EBB098ED9998ED95';
wwv_flow_imp.g_varchar2_table(36353) := '98EB8A942053514C20ECA788EC9D98222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A224A534F4E20EBB0B0EC97B4EC9D8420EBB098ED9998ED9598EB8A942053514C20ECA788EC9D98222C2253514C207175';
wwv_flow_imp.g_varchar2_table(36354) := '6572792072657475726E696E6720612073696E676C6520646174652076616C7565223A22EB8BA8EC9DBC20EB82A0ECA79C20EAB092EC9D8420EBB098ED9998ED9598EB8A942053514C20ECA788EC9D98222C2253514C2071756572792072657475726E69';
wwv_flow_imp.g_varchar2_table(36355) := '6E6720612073696E676C65206E756D6265722076616C7565223A22EB8BA8EC9DBC20EC88ABEC9E9020EAB092EC9D8420EBB098ED9998ED9598EB8A942053514C20ECA788EC9D98222C2253514C2071756572792072657475726E696E6720612073696E67';
wwv_flow_imp.g_varchar2_table(36356) := '6C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22EC8B9CEAB084EB8C8020EAB092EC9DB420EC9E88EB8A9420EB8BA8EC9DBC20EC8B9CEAB08420EAB8B0EBA19DEC9D8420EBB098ED9998ED9598EB8A942053514C';
wwv_flow_imp.g_varchar2_table(36357) := '20ECA788EC9D98222C2253514C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C7565223A22EB8BA8EC9DBC20766172636861723220EAB092EC9D8420EBB098ED9998ED9598EB8A942053514C20ECA788EC';
wwv_flow_imp.g_varchar2_table(36358) := '9D98222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22EC8B9CEAB084EB8C80EC998020ED95A8EABB9820EC8B9CEAB08420EAB8B0EBA19DEC9D8420EBB098ED9998ED9598EB8A';
wwv_flow_imp.g_varchar2_table(36359) := '942053514C20ECA788EC9D98222C2253514C20717565727920746F20676574206174746163686D656E74223A22ECB2A8EBB68020ED8C8CEC9DBCEC9D8420EAB080ECA0B8EC98A4EB8A942053514C20ECA788EC9D98222C2253514C207175657279223A22';
wwv_flow_imp.g_varchar2_table(36360) := '53514C20ECA788EC9D98222C2253514C205175657279223A2253514C20ECA788EC9D98222C225374617274206576656E74206973206D697373696E67206576656E7420646566696E6974696F6E223A22EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8EC979020';
wwv_flow_imp.g_varchar2_table(36361) := 'EC9DB4EBB2A4ED8AB820ECA095EC9D98EAB08020EB8884EB9DBDEB9098EC9788EC8AB5EB8B88EB8BA42E222C225374617274206576656E74206D75737420626520626C616E6B223A22EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8EB8A9420EBB984EC9B8C20';
wwv_flow_imp.g_varchar2_table(36362) := 'EB9190EC96B4EC95BC20ED95A9EB8B88EB8BA42E222C225374617274206576656E74223A22EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C225374617274204576656E74223A22EC9DB4EBB2A4ED8AB820EC8B9CEC9E91222C225374617469632064617465';
wwv_flow_imp.g_varchar2_table(36363) := '2076616C7565223A22ECA095ECA08120EC9DBCEC9E9020EAB092222C22537461746963204944223A22ECA095ECA081204944222C22537461746963206E756D6265722076616C7565223A22ECA095ECA08120EC88ABEC9E9020EAB092222C225374617469';
wwv_flow_imp.g_varchar2_table(36364) := '632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22EC8B9CEAB084EB8C8020EAB092EC9DB420EC9E88EB8A9420ECA095ECA08120EC8B9CEAB084EAB8B0EBA19D222C225374617469632076617263686172322076616C';
wwv_flow_imp.g_varchar2_table(36365) := '7565223A22ECA095ECA08120766172636861723220EAB092222C22537461746963223A22ECA095ECA081222C22537472696E67223A22EBACB8EC9E90EC97B4222C225375622070726F6365737320686173206D756C7469706C6520626C616E6B20737461';
wwv_flow_imp.g_varchar2_table(36366) := '7274206576656E7473223A22ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4EC979020EBB98820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8EAB08020EC97ACEB9FAC20EAB09C20EC9E88EC8AB5EB8B88EB8BA42E222C225375622070726F63657373206973';
wwv_flow_imp.g_varchar2_table(36367) := '206D697373696E6720656E64206576656E74223A22ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4EC979020ECA285EBA38C20EC9DB4EBB2A4ED8AB8EAB08020EB8884EB9DBDEB9098EC9788EC8AB5EB8B88EB8BA42E222C225375622070726F63657373';
wwv_flow_imp.g_varchar2_table(36368) := '206973206D697373696E67207374617274206576656E74223A22ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4EC979020EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8EAB08020EB8884EB9DBDEB9098EC9788EC8AB5EB8B88EB8BA42E222C225375622D7072';
wwv_flow_imp.g_varchar2_table(36369) := '6F636573732028636F6C6C617073656429223A22ED9598EC9C8420ED9484EBA19CEC84B8EC8AA428ECB695EC868CEB90A829222C225375622D70726F636573732028657870616E64656429223A22ED9598EC9C8420ED9484EBA19CEC84B8EC8AA428ED99';
wwv_flow_imp.g_varchar2_table(36370) := '95EC9EA5EB90A829222C225375622D70726F63657373223A22ED9598EC9C8420ED9484EBA19CEC84B8EC8AA4222C225375626A656374223A22ECA09CEBAAA9222C225461736B20446566696E6974696F6E223A22ED839CEC8AA4ED81AC20ECA095EC9D98';
wwv_flow_imp.g_varchar2_table(36371) := '222C225461736B20537461746963204944223A22ED839CEC8AA4ED81AC20ECA095ECA081204944222C225461736B2054797065223A22ED839CEC8AA4ED81AC20EC9CA0ED9895222C225461736B223A22ED839CEC8AA4ED81AC222C2254656D706C617465';
wwv_flow_imp.g_varchar2_table(36372) := '204944223A22ED859CED948CEBA6ACED8AB8204944222C2254656D706C617465223A22ED859CED948CEBA6ACED8AB8222C225465726D696E61746520656E64206576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB820ECA285EBA38C222C225465';
wwv_flow_imp.g_varchar2_table(36373) := '726D696E61746520456E64204576656E74223A22ECA285EBA38C20EC9DB4EBB2A4ED8AB820ECA285EBA38C222C225465726D696E61746564223A22ECA285EBA38CEB90A8222C2254657874223A22ED858DEC8AA4ED8AB8222C2254696D6520756E74696C';
wwv_flow_imp.g_varchar2_table(36374) := '207468652074696D657220666972657320616761696E223A22ED8380EC9DB4EBA8B8EAB08020EB8BA4EC8B9C20EC8BA4ED9689EB90A020EB958CEAB98CECA780EC9D9820EC8B9CEAB084222C2254696D6520756E74696C207468652074696D6572206669';
wwv_flow_imp.g_varchar2_table(36375) := '726573206669727374223A22ED8380EC9DB4EBA8B8EAB08020EBA8BCECA08020EC8BA4ED9689EB90A020EB958CEAB98CECA780EC9D9820EC8B9CEAB084222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E7465727275707469';
wwv_flow_imp.g_varchar2_table(36376) := '6E6729223A22ED8380EC9DB4EBA8B820EAB2BDEAB38420EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C2254696D657220626F756E64617279206576656E74223A22ED8380EC9DB4EBA8B820EAB2BDEAB38420EC9DB4EBB2A4ED8AB8222C225469';
wwv_flow_imp.g_varchar2_table(36377) := '6D657220446566696E6974696F6E2054797065223A22ED8380EC9DB4EBA8B820ECA095EC9D9820EC9CA0ED9895222C2254696D657220446566696E6974696F6E223A22ED8380EC9DB4EBA8B820ECA095EC9D98222C2254696D6572204475726174696F6E';
wwv_flow_imp.g_varchar2_table(36378) := '223A22ED8380EC9DB4EBA8B820EAB8B0EAB084222C2254696D657220696E7465726D656469617465206361746368206576656E74223A22ED8380EC9DB4EBA8B820ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB8222C2254696D657220496E7465';
wwv_flow_imp.g_varchar2_table(36379) := '726D656469617465204361746368204576656E74223A22ED8380EC9DB4EBA8B820ECA491EAB08420436174636820EC9DB4EBB2A4ED8AB8222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22ED8380';
wwv_flow_imp.g_varchar2_table(36380) := 'EC9DB4EBA8B820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB828EBB984ECA491EB8BA829222C2254696D6572207374617274206576656E74223A22ED8380EC9DB4EBA8B820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C2254696D6572205374617274204576';
wwv_flow_imp.g_varchar2_table(36381) := '656E74223A22ED8380EC9DB4EBA8B820EC8B9CEC9E9120EC9DB4EBB2A4ED8AB8222C2254696D6572223A22ED8380EC9DB4EBA8B8222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C';
wwv_flow_imp.g_varchar2_table(36382) := '6520666F726D6174223A2249534F203836303120EB9890EB8A94204F7261636C6520ED9895EC8B9DEC9D9820EC8B9CEAB084EB8C80EAB08020EC9E88EB8A9420EC8B9CEAB084EAB8B0EBA19D222C2254696D657374616D7020776974682054696D65205A';
wwv_flow_imp.g_varchar2_table(36383) := '6F6E65223A22EC8B9CEAB084EB8C8020ED8FACED95A820EC8B9CEAB084EAB8B0EBA19D222C22546F223A22EBB09BEB8A9420EC82ACEB9E8C222C22546F67676C65206E6F6E2D696E74657272757074696E67223A22EBB984ECA491EB8BA820ED86A0EAB8';
wwv_flow_imp.g_varchar2_table(36384) := '80222C225472616E73616374696F6E223A22ED8AB8EB9E9CEC9EADEC8598222C22556E646F223A22EC8BA4ED968920ECB7A8EC868C222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A227B7365';
wwv_flow_imp.g_varchar2_table(36385) := '6D616E7469637D20EC9A94EC868CEC979020EB8C80ED95B420EC958C20EC889820EC9786EB8A94206469207B64697D222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E';
wwv_flow_imp.g_varchar2_table(36386) := '746578747D223A227B636F6E746578747D20ECBBA8ED858DEC8AA4ED8AB8EC9790EC849C20EC9DB8EC8B9DED95A020EC889820EC9786EB8A9420666C6F77456C656D656E74207B656C656D656E747D222C22756E737570706F727465642062706D6E456C';
wwv_flow_imp.g_varchar2_table(36387) := '656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A227B706C616E657DEC979020EB8C80ED95B420ECA780EC9B90EB9098ECA78020EC958AEB8A942062706D6E456C656D656E743A207B726F6F74456C656D656E747D22';
wwv_flow_imp.g_varchar2_table(36388) := '2C225573652041504558206D6574612064617461223A224150455820EBA994ED8380EB8DB0EC9DB4ED84B020EC82ACEC9AA9222C225573652054656D706C617465223A22ED859CED948CEBA6ACED8AB820EC82ACEC9AA9222C2255736564206469616772';
wwv_flow_imp.g_varchar2_table(36389) := '616D2076657273696F6E223A22EC82ACEC9AA9EB909C20EB8BA4EC9DB4EC96B4EAB7B8EB9EA820EBB284ECA084222C2255736572207461736B223A22EC82ACEC9AA9EC9E9020ED839CEC8AA4ED81AC222C2255736572205461736B223A22EC82ACEC9AA9';
wwv_flow_imp.g_varchar2_table(36390) := 'EC9E9020ED839CEC8AA4ED81AC222C2256616C7565223A22EAB092222C225661726368617232223A225661726368617232222C225661726961626C652045787072657373696F6E73223A22EBB380EC889820ED919CED9884EC8B9D222C2256657273696F';
wwv_flow_imp.g_varchar2_table(36391) := '6E204E616D65223A22EBB284ECA08420EC9DB4EBA684222C2256657273696F6E696E67223A22EBB284ECA08420EAB480EBA6AC222C225761697420666F7220636F6D706C6574696F6E223A22EC9984EBA38C20EB8C80EAB8B0222C225A6F6F6D20496E22';
wwv_flow_imp.g_varchar2_table(36392) := '3A22ED9995EB8C80222C225A6F6F6D204F7574223A22ECB695EC868C227D27297D2C3330373A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D204572726F72732C207B776172';
wwv_flow_imp.g_varchar2_table(36393) := '6E696E67737D205761726E696E6773223A227B6572726F72737D204572726F732C207B7761726E696E67737D20416476657274C3AA6E63696173222C227B73656D616E7469637D237B736964657D20526566206E6F7420737065636966696564223A2252';
wwv_flow_imp.g_varchar2_table(36394) := '6566207B73656D616E7469637D237B736964657D206EC3A36F20657370656369666963616461222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312D557267656E7465222C22322D48696768223A22322D416C7461222C22';
wwv_flow_imp.g_varchar2_table(36395) := '332D4D656469756D223A22332D4DC3A9646961222C22342D4C6F77223A22342D4261697861222C22352D4C6F77657374223A22352D4D616973204261697861222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073706C';
wwv_flow_imp.g_varchar2_table(36396) := '6974206174207468652073616D652074696D65223A22556D20476174657761792028506F72746120646520456E747261646129206EC3A36F20706F646520756E69722065207365706172617220616F206D65736D6F2074656D706F2E222C224163746976';
wwv_flow_imp.g_varchar2_table(36397) := '617465206372656174652F72656D6F766520737061636520746F6F6C223A224174697661722061646963696F6E61722F72656D6F7665722066657272616D656E746120657370616369616C222C22416374697661746520676C6F62616C20636F6E6E6563';
wwv_flow_imp.g_varchar2_table(36398) := '7420746F6F6C223A224174697661722066657272616D656E746120646520636F6E6578C3A36F20676C6F62616C222C2241637469766174652068616E6420746F6F6C223A224174697661722066657272616D656E7461206465206DC3A36F222C22416374';
wwv_flow_imp.g_varchar2_table(36399) := '6976617465206C6173736F20746F6F6C223A224174697661722066657272616D656E7461206465206C61C3A76F222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A22417469766172206120666572';
wwv_flow_imp.g_varchar2_table(36400) := '72616D656E74612063726961722F72656D6F7665722065737061C3A76F222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A2241746976617220612066657272616D656E7461206465206C6F67696E20676C6F62';
wwv_flow_imp.g_varchar2_table(36401) := '616C222C224163746976617465207468652068616E6420746F6F6C223A2241746976617220612066657272616D656E7461206D616E75616C222C22416374697661746520746865206C6173736F20746F6F6C223A2241746976617220612066657272616D';
wwv_flow_imp.g_varchar2_table(36402) := '656E7461206C61C3A76F222C224163746976697479207265666572656E6365223A225265666572C3AA6E63696120646120617469766964616465222C2241642D686F63223A2241642D686F632028536F622044656D616E646129222C22416464206C616E';
wwv_flow_imp.g_varchar2_table(36403) := '652061626F7665223A2241646963696F6E617220766961206163696D61222C22416464206C616E652062656C6F77223A2241646963696F6E6172207669612061626169786F222C22416464207465787420616E6E6F746174696F6E223A2241646963696F';
wwv_flow_imp.g_varchar2_table(36404) := '6E617220616E6F7461C3A7C3A36F20646520746578746F222C224166746572204D65726765223A224170C3B373205265756E69C3A36F222C224166746572205461736B223A224170C3B373206120546172656661222C22416C69676E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(36405) := '7320626F74746F6D223A22416C696E68617220656C656D656E746F7320C3A020706172746520696E666572696F72222C22416C69676E20656C656D656E74732063656E746572223A22416C696E6861722063656E7472616C20646520656C656D656E746F';
wwv_flow_imp.g_varchar2_table(36406) := '73222C22416C69676E20656C656D656E7473206C656674223A22416C696E68617220656C656D656E746F7320C3A0206573717565726461222C22416C69676E20656C656D656E7473206D6964646C65223A22416C696E68617220656C656D656E746F7320';
wwv_flow_imp.g_varchar2_table(36407) := '6E6F206D65696F222C22416C69676E20656C656D656E7473207269676874223A22416C696E68617220656C656D656E746F7320C3A02064697265697461222C22416C69676E20656C656D656E747320746F70223A22416C696E68617220656C656D656E74';
wwv_flow_imp.g_varchar2_table(36408) := '6F7320C3A0207061727465207375706572696F72222C22416C69676E20656C656D656E7473223A22416C696E68617220656C656D656E746F73222C22416C6C6F772042696E64696E67223A225065726D697469722042696E64696E67222C22616C726561';
wwv_flow_imp.g_varchar2_table(36409) := '64792072656E6465726564207B656C656D656E747D223A227B656C656D656E747D206AC3A120646573656E6861646F222C224150455820417070726F76616C223A224170726F7661C3A7C3A36F2041504558222C22415045582050616765223A2250C3A1';
wwv_flow_imp.g_varchar2_table(36410) := '67696E612041504558222C224150455820526F6C65223A2241747269627569C3A7C3A36F20646F2041504558222C22415045582053696D706C6520466F726D223A22466F726D756CC3A172696F2053696D706C657320646F2041504558222C2241707065';
wwv_flow_imp.g_varchar2_table(36411) := '6E6420636F6D70656E736174696F6E206163746976697479223A22416E657861722041746976696461646520646520436F6D70656E7361C3A7C3A36F222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368';
wwv_flow_imp.g_varchar2_table(36412) := '206576656E74223A22416E65786172206576656E746F206465206361707475726120696E7465726D656469C3A172696F20636F6E646963696F6E616C222C22417070656E6420656E64206576656E74223A22416E65786172206576656E746F2064652066';
wwv_flow_imp.g_varchar2_table(36413) := '696D222C22417070656E642067617465776179223A22416E657861722047617465776179222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A22416E65786172206576656E746F20696E7465726D656469C3';
wwv_flow_imp.g_varchar2_table(36414) := 'A172696F2F66726F6E7465697261222C22417070656E64206D65737361676520696E7465726D656469617465206361746368206576656E74223A22416E65786172206576656E746F206465206361707475726120696E7465726D656469C3A172696F2064';
wwv_flow_imp.g_varchar2_table(36415) := '61206D656E736167656D222C22417070656E642072656365697665207461736B223A22416E6578617220746172656661206465207265636562696D656E746F222C22417070656E64207369676E616C20696E7465726D6564696174652063617463682065';
wwv_flow_imp.g_varchar2_table(36416) := '76656E74223A22416E65786172206576656E746F206465206361707475726120696E7465726D656469C3A172696F2064652073696E616C222C22417070656E64207461736B223A22416E6578617220746172656661222C22417070656E64207465787420';
wwv_flow_imp.g_varchar2_table(36417) := '616E6E6F746174696F6E223A22416E6578617220616E6F7461C3A7C3A36F20646520746578746F222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A22416E65786172206576656E746F2064652063';
wwv_flow_imp.g_varchar2_table(36418) := '61707475726120696E7465726D656469C3A172696F20646F2074656D706F72697A61646F72222C224170706C69636174696F6E204944223A2249442064612041706C696361C3A7C3A36F222C224170706C69636174696F6E223A2241706C696361C3A7C3';
wwv_flow_imp.g_varchar2_table(36419) := 'A36F222C2241737369676E6D656E74223A2241747269627569C3A7C3A36F222C224174746163686D656E74223A22416E65786F222C224261636B67726F756E64205461736B2053657373696F6E223A2253657373C3A36F20646120546172656661206465';
wwv_flow_imp.g_varchar2_table(36420) := '20536567756E646F20506C616E6F222C22424343223A22424343222C224265666F7265204576656E74223A22416E74657320646F204576656E746F222C224265666F72652053706C6974223A22416E746573206461204469766973C3A36F222C22426566';
wwv_flow_imp.g_varchar2_table(36421) := '6F7265205461736B223A22416E74657320646120546172656661222C2242696E642070616765206974656D7320286465707265636174656429223A2256696E63756C6172206974656E732064652070C3A167696E61202870726574657269646F29222C22';
wwv_flow_imp.g_varchar2_table(36422) := '42696E6420706172616D657465722076616C756573223A2256696E63756C61722076616C6F72657320646520706172C3A26D6574726F222C2242696E642070726F63657373207661726961626C6573223A2256696E63756C61722076617269C3A1766569';
wwv_flow_imp.g_varchar2_table(36423) := '732064652070726F636573736F222C22426C696E6420636172626F6E20636F707920726563697069656E74287329223A2244657374696E6174C3A172696F287329204F63756C746F732064652043C3B370696120436172626F6E6F222C22426F64792048';
wwv_flow_imp.g_varchar2_table(36424) := '544D4C223A22436F72706F2048544D4C222C22426F64792054657874223A22436F72706F20646F20546578746F222C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F63657373657320617265206375727265';
wwv_flow_imp.g_varchar2_table(36425) := '6E746C79206E6F7420737570706F72746564223A224576656E746F73206465206C696D69746520656D2073756270726F636573736F73206465206974657261C3A7C3A36F206EC3A36F2073C3A36F207375706F727461646F73206E6F206D6F6D656E746F';
wwv_flow_imp.g_varchar2_table(36426) := '222C22427573696E657373205265666572656E6365223A225265666572C3AA6E63696120646520204E6567C3B363696F222C22427573696E6573732072756C65207461736B223A22546172656661206465205265677261206465204E6567C3B363696F22';
wwv_flow_imp.g_varchar2_table(36427) := '2C22427573696E6573732052756C65205461736B223A22546172656661206465205265677261206465204E6567C3B363696F73222C22627573696E6573735F726566223A22627573696E6573735F726566222C2243616C6C204163746976697479223A22';
wwv_flow_imp.g_varchar2_table(36428) := '417469766964616465206465204368616D616461222C2243616C6C206163746976697479223A22417469766964616465206465204C69676172222C2243616C6C6564204469616772616D223A224469616772616D61204368616D61646F222C2243616E63';
wwv_flow_imp.g_varchar2_table(36429) := '656C20626F756E64617279206576656E74223A2243616E63656C6172206576656E746F206465206C696D697465222C2243616E63656C20656E64206576656E74223A2243616E63656C6172206576656E746F2066696E616C222C2243616E63656C223A22';
wwv_flow_imp.g_varchar2_table(36430) := '43616E63656C61646F222C22436172626F6E20636F707920726563697069656E74287329223A2244657374696E6174C3A172696F2873292064652043C3B37069617320436172626F6E6F222C2243617465676F72792056616C7565223A2256616C6F7220';
wwv_flow_imp.g_varchar2_table(36431) := '64612043617465676F726961222C224343223A224343222C224368616E676520656C656D656E74223A22416C746572617220656C656D656E746F222C224368616E67652074797065223A22416C7465726172205469706F222C22436C6561722043616368';
wwv_flow_imp.g_varchar2_table(36432) := '652056616C756520666F7220506167652043616C6C223A224C696D7061722056616C6F722064652043616368652070617261204368616D6164612064652050C3A167696E61222C22436C656172204361636865223A224C696D706172204361636865222C';
wwv_flow_imp.g_varchar2_table(36433) := '22436C6F62223A22436C6F62222C22436F6465223A2243C3B36469676F222C22436F6C6C61626F726174696F6E223A22436F6C61626F7261C3A7C3A36F222C22436F6C6C617073656420506F6F6C223A2250697363696E61204D696E696D697A61646122';
wwv_flow_imp.g_varchar2_table(36434) := '2C22436F6C6C6170736564205375622050726F63657373223A2253756270726F636573736F205265636F6C6869646F222C22436F6C6C656374696F6E2054797065223A225469706F20646520436F6C657461222C22436F6C6C656374696F6E223A22436F';
wwv_flow_imp.g_varchar2_table(36435) := '6C65C3A7C3A36F222C22436F6D70656E7361746520456E64204576656E74223A224576656E746F2046696E616C2064652052656D756E657261C3A7C3A36F222C22436F6D70656E7361746520496E7465726D656469617465205468726F77204576656E74';
wwv_flow_imp.g_varchar2_table(36436) := '223A224576656E746F206465204C616EC3A7616D656E746F20496E7465726D656469C3A172696F20646520436F6D70656E7361C3A7C3A36F222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A224576656E746F206465204C';
wwv_flow_imp.g_varchar2_table(36437) := '696D69746520646520436F6D70656E7361C3A7C3A36F222C22436F6D70656E736174696F6E20656E64206576656E74223A224576656E746F2064652046696D20646520436F6D70656E7361C3A7C3A36F222C22436F6D70656E736174696F6E20696E7465';
wwv_flow_imp.g_varchar2_table(36438) := '726D656469617465207468726F77206576656E74223A224576656E746F206465204C616EC3A7616D656E746F20496E7465726D656469C3A172696F20646520436F6D70656E7361C3A7C3A36F222C22436F6D70656E736174696F6E207374617274206576';
wwv_flow_imp.g_varchar2_table(36439) := '656E74223A224576656E746F20646520496EC3AD63696F20646120436F6D70656E7361C3A7C3A36F222C22436F6D70656E736174696F6E223A2252656D756E657261C3A7C3A36F222C22436F6D706C65746564223A22436F6E636C75C3AD646F222C2243';
wwv_flow_imp.g_varchar2_table(36440) := '6F6D706C6574696F6E20436F6E646974696F6E223A22436F6E6469C3A7C3A36F20646520436F6E636C7573C3A36F222C22436F6D706C65782047617465776179223A22476174657761792028506F72746120646520456E74726164612920646F20546970';
wwv_flow_imp.g_varchar2_table(36441) := '6F20436F6D706C65786F222C22436F6D706C65782067617465776179223A224761746577617920436F6D706C65786F222C22436F6E646974696F6E2054797065223A225469706F20646520436F6E6469C3A7C3A36F222C22436F6E646974696F6E223A22';
wwv_flow_imp.g_varchar2_table(36442) := '436F6E6469C3A7C3A36F222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206C696D69746520636F6E646963696F6E616C202873656D20696E746572';
wwv_flow_imp.g_varchar2_table(36443) := '727570C3A7C3A36F29222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A224576656E746F206465206C696D69746520636F6E646963696F6E616C222C22436F6E646974696F6E616C20666C6F77223A22466C75786F20636F6E';
wwv_flow_imp.g_varchar2_table(36444) := '646963696F6E616C222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A224576656E746F206465204361707475726120496E7465726D656469C3A172696120436F6E646963696F6E616C222C22436F6E';
wwv_flow_imp.g_varchar2_table(36445) := '646974696F6E616C20496E7465726D656469617465204361746368204576656E74223A224576656E746F20496E7465726469C3A172696F20646F205469706F20436F6E646963696F6E616C20285265636570C3A7C3A36F29222C22436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(36446) := '616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520496EC3AD63696F20436F6E646963696F6E616C202873656D2D696E746572727570C3A7C3A36F29222C22436F6E646974696F6E616C20';
wwv_flow_imp.g_varchar2_table(36447) := '7374617274206576656E74223A224576656E746F20646520496EC3AD63696F20436F6E646963696F6E616C222C22436F6E646974696F6E616C205374617274204576656E74223A224576656E746F20496EC3AD63696F20646F205469706F20436F6E6469';
wwv_flow_imp.g_varchar2_table(36448) := '63696F6E616C222C22436F6E6E65637420746F206F7468657220656C656D656E74223A22436F6E65637461722061206F7574726F20656C656D656E746F222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22436F6E6563746172';
wwv_flow_imp.g_varchar2_table(36449) := '207573616E646F206173736F636961C3A7C3A36F222C22436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E223A22436F6E6563746172207573616E646F20456E7472616461206465204461646F73206465204173';
wwv_flow_imp.g_varchar2_table(36450) := '736F636961C3A7C3A36F222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A22436F6E6563746172207573616E646F2053657175C3AA6E6369612F466C75786F2064';
wwv_flow_imp.g_varchar2_table(36451) := '65204D656E736167656D206F75204173736F636961C3A7C3A36F222C22436F707920627573696E657373207265666572656E6365223A22436F70696172207265666572C3AA6E636961206465206E6567C3B363696F222C22636F7272656374696E67206D';
wwv_flow_imp.g_varchar2_table(36452) := '697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A22636F72726967696E646F206F20656C656D656E746F2062706D6E456C656D656E7420617573656E7465206E61207B706C616E65';
wwv_flow_imp.g_varchar2_table(36453) := '7D2070617261207B726F6F74456C656D656E747D222C22436F7272656C6174696F6E204B6579223A22436861766520646520436F7272656C61C3A7C3A36F222C22436F7272656C6174696F6E2056616C7565223A2256616C6F7220646520436F7272656C';
wwv_flow_imp.g_varchar2_table(36454) := '61C3A7C3A36F222C22437265617465207B747970657D223A224372696172207B747970657D222C224372656174652064617461206F626A656374207265666572656E6365223A22437269617220446174614F626A6563745265666572656E6365222C2243';
wwv_flow_imp.g_varchar2_table(36455) := '726561746520646174612073746F7265207265666572656E6365223A224372696172204461746153746F72655265666572656E6365222C2243726561746520446174614F626A6563745265666572656E6365223A224372696172207265666572C3AA6E63';
wwv_flow_imp.g_varchar2_table(36456) := '6961206465204F626A65746F206465206461646F73222C22437265617465204461746153746F72655265666572656E6365223A224372696172207265666572C3AA6E6369612064652041726D617A656E616D656E746F206465206461646F73222C224372';
wwv_flow_imp.g_varchar2_table(36457) := '6561746520656E64206576656E74223A224372696172206576656E746F2064652066696D222C2243726561746520456E644576656E74223A22437269617220756D204576656E746F2064652046696D222C2243726561746520657870616E646564207375';
wwv_flow_imp.g_varchar2_table(36458) := '622D70726F63657373223A2243726961722073756270726F636573736F20657870616E6469646F222C2243726561746520657870616E6465642053756250726F63657373223A22437269617220537570726F636573736F20457870616E6469646F222C22';
wwv_flow_imp.g_varchar2_table(36459) := '4372656174652047617465776179223A22437269617220476174657761792028506F72746120646520456E747261646129222C224372656174652067617465776179223A2243726961722047617465776179222C224372656174652067726F7570223A22';
wwv_flow_imp.g_varchar2_table(36460) := '437269617220677275706F222C224372656174652047726F7570223A22437269617220477275706F222C2243726561746520496E7465726D6564696174652F426F756E64617279204576656E74223A224372696172204576656E746F20496E7465726D65';
wwv_flow_imp.g_varchar2_table(36461) := '6469C3A172696F202F204576656E746F206465204C696D697465206F752046726F6E7465697261222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A224372696172206576656E746F20696E7465726D6564';
wwv_flow_imp.g_varchar2_table(36462) := '69C3A172696F2F6C696D697465222C22437265617465206E6577202E2E2E223A224372696172206E6F766F2E2E2E222C2243726561746520506F6F6C2F5061727469636970616E74223A2243726961722050697363696E612F5061727469636970616E74';
wwv_flow_imp.g_varchar2_table(36463) := '65222C2243726561746520706F6F6C2F7061727469636970616E74223A22437269617220506F6F6C202F205061727469636970616E7465222C22437265617465207374617274206576656E74223A224372696172206576656E746F20646520696EC3AD63';
wwv_flow_imp.g_varchar2_table(36464) := '696F222C224372656174652053746172742054696D6572204576656E74223A224372696172204576656E746F20646520496EC3AD63696F20646F205469706F2054656D706F72697A61646F72222C224372656174652053746172744576656E74223A2243';
wwv_flow_imp.g_varchar2_table(36465) := '72696172204576656E746F20646520496EC3AD63696F222C22437265617465207461736B223A22437269617220746172656661222C22437265617465205461736B223A22437269617220546172656661222C22437573746F6D20457874656E73696F6E22';
wwv_flow_imp.g_varchar2_table(36466) := '3A22457874656E73C3A36F20506572736F6E616C697A616461222C22437573746F6D223A22506572736F6E616C697A61646F222C224379636C65202849534F203836303129223A224369636C6F2028495353203836303129222C224379636C6520284F72';
wwv_flow_imp.g_varchar2_table(36467) := '61636C6529223A224369636C6F20284F7261636C6529222C2244617461204F626A656374205265666572656E6365223A225265666572C3AA6E636961206465204F626A65746F206465204461646F73222C2244617461206F626A65637420726566657265';
wwv_flow_imp.g_varchar2_table(36468) := '6E6365223A225265666572C3AA6E63696120646F206F626A65746F206465206461646F73222C22446174612053746F7265205265666572656E6365223A225265666572C3AA6E6369612064652041726D617A656E616D656E746F206465204461646F7322';
wwv_flow_imp.g_varchar2_table(36469) := '2C22446174612073746F7265207265666572656E6365223A225265666572C3AA6E63696120646F2061726D617A656E616D656E746F206465206461646F73222C22446174612054797065223A225469706F206465204461646F222C224461746520284953';
wwv_flow_imp.g_varchar2_table(36470) := '4F203836303129223A2244617461202849534F203836303129222C224461746520284F7261636C6529223A224461746120284F7261636C6529222C224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A2246';
wwv_flow_imp.g_varchar2_table(36471) := '6F726D61746F206461204461746120595959592D4D4D2D444420484832343A4D493A5353222C224461746520537472696E67223A22446174612028436164656961206465204361726163746572657329222C2244617465223A2244617461222C22446566';
wwv_flow_imp.g_varchar2_table(36472) := '61756C74204170706C69636174696F6E204944223A22494420646F2041706C6963617469766F2050616472C3A36F222C2244656661756C74204170706C69636174696F6E223A2241706C6963617469766F2050616472C3A36F222C2244656661756C7420';
wwv_flow_imp.g_varchar2_table(36473) := '666C6F77223A22466C75786F2070616472C3A36F222C2244656661756C742050616765204944223A2249442064612050C3A167696E612050616472C3A36F222C2244656661756C742050616765223A2250C3A167696E612050616472C3A36F222C224465';
wwv_flow_imp.g_varchar2_table(36474) := '6661756C7420557365726E616D65223A224E6F6D6520646520757375C3A172696F2070616472C3A36F222C2244656C657465223A224578636C756972222C224465736372697074696F6E223A22446573637269C3A7C3A36F222C2244657461696C73223A';
wwv_flow_imp.g_varchar2_table(36475) := '22446574616C686573222C226469616772616D206E6F742070617274206F662062706D6E3A446566696E6974696F6E73223A226469616772616D61206EC3A36F2066617A2070617274652064652062706D6E3A446566696E6974696F6E73222C22446973';
wwv_flow_imp.g_varchar2_table(36476) := '7472696275746520656C656D656E747320686F72697A6F6E74616C6C79223A224469737472696275697220656C656D656E746F7320686F72697A6F6E74616C6D656E7465222C224469737472696275746520656C656D656E747320766572746963616C6C';
wwv_flow_imp.g_varchar2_table(36477) := '79223A224469737472696275697220656C656D656E746F7320766572746963616C6D656E7465222C2244697669646520696E746F207468726565206C616E6573223A224469766964697220656D207472C3AA732076696173222C2244697669646520696E';
wwv_flow_imp.g_varchar2_table(36478) := '746F2074776F206C616E6573223A224469766964697220656D20647561732076696173222C22446F63756D656E746174696F6E223A22446F63756D656E7461C3A7C3A36F222C22447565204F6E223A2256656E63696D656E746F20656D222C224475706C';
wwv_flow_imp.g_varchar2_table(36479) := '696361746520696E636F6D696E672073657175656E636520666C6F7773223A22466C75786F2064652053657175C3AA6E636961206465204F726967656D2F456E7472616461206475706C696361646F222C224475706C6963617465206F7574676F696E67';
wwv_flow_imp.g_varchar2_table(36480) := '2073657175656E636520666C6F7773223A22466C75786F2064652053657175C3AA6E6369612064652044657374696E6F2F5361C3AD6461206475706C696361646F222C224475726174696F6E202849534F203836303129223A2244757261C3A7C3A36F20';
wwv_flow_imp.g_varchar2_table(36481) := '2849534F203836303129222C224475726174696F6E20284F7261636C6529223A2244757261C3A7C3A36F284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C274444';
wwv_flow_imp.g_varchar2_table(36482) := '4420484832343A4D493A53535C2720666F726D6174223A2244757261C3A7C3A36F206E6F20666F726D61746F2049534F2038363031206F75204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C27222C22652E67';
wwv_flow_imp.g_varchar2_table(36483) := '2E2032332D4A554E2D323032372031343A31303A3030223A22706F72206578656D706C6F2C2032332D4A554E2D323032372031343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A22706F72206578656D70';
wwv_flow_imp.g_varchar2_table(36484) := '6C6F2C2044442D4DC38A532D4141414120484832343A4D493A5353222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E22';
wwv_flow_imp.g_varchar2_table(36485) := '3A22656C656D656E746F207B656C656D656E747D207265666572656E636961646F20706F72207B7265666572656E6365647D237B70726F70657274797D2061696E6461206EC3A36F20646573656E6861646F222C22456C656D656E7420646F63756D656E';
wwv_flow_imp.g_varchar2_table(36486) := '746174696F6E223A22446F63756D656E7461C3A7C3A36F20646F20656C656D656E746F222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A224F20656C656D656E746F';
wwv_flow_imp.g_varchar2_table(36487) := '206EC3A36F207065726D69746975206F207469706F203C62706D6E3A436F6D706C657820476174657761793E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E22';
wwv_flow_imp.g_varchar2_table(36488) := '3A224F20656C656D656E746F2074656D20756D207469706F20696C6567616C20283C62706D6E3A4D65737361676553746172744576656E743E29206520666F69206465736162696C697461646F2E222C22456C656D656E742068617320646973616C6C6F';
wwv_flow_imp.g_varchar2_table(36489) := '7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A224F20656C656D656E746F2074656D20756D207469706F20696C6567616C20283C62706D6E3A5369676E616C53746172744576656E743E29206520666F6920646573';
wwv_flow_imp.g_varchar2_table(36490) := '6162696C697461646F2E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A224F20656C656D656E746F2074656D20756D207469706F20696C6567616C';
wwv_flow_imp.g_varchar2_table(36491) := '20283C62706D6E436F6E646974696F6E616C53746172744576656E743E29206520666F69206465736162696C697461646F2E222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063686172616374657273223A22494420646F';
wwv_flow_imp.g_varchar2_table(36492) := '20456C656D656E746F20706F73737569206D616973207175652035302063617261637465726573222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A22494420646F20456C656D656E746F206EC3A36F20666F69206D';
wwv_flow_imp.g_varchar2_table(36493) := '6F646966696361646F2061696E6461222C22456C656D656E7420697320616E20696D706C6963697420656E64223A22456C656D656E746F20C3A920756D612065787472656D696461646520696D706CC3AD63697461222C22456C656D656E742069732061';
wwv_flow_imp.g_varchar2_table(36494) := '6E20696D706C69636974207374617274223A224F20656C656D656E746F20C3A920756D20696EC3AD63696F20696D706CC3AD6369746F222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65223A224F20656C656D656E746F20';
wwv_flow_imp.g_varchar2_table(36495) := '6EC3A36F20706F73737569204E6F6D65206F752052C3B374756C6F222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22456C656D656E746F206EC3A36F20657374C3A120636F6E65637461646F222C22656C656D656E7420726571';
wwv_flow_imp.g_varchar2_table(36496) := '7569726564223A22656C656D656E746F2072657175657269646F222C22456D61696C20636F6E74656E74223A22436F6E7465C3BA646F20646F20452D6D61696C222C22456D61696C206F662074686520726563697069656E74287329223A22456D61696C';
wwv_flow_imp.g_varchar2_table(36497) := '20646F732064657374696E6174C3A172696F73222C22456D61696C206F66207468652073656E646572223A22452D6D61696C20646F2072656D6574656E7465222C22456D61696C20776865726520746865207265706C792073686F756C64206265207365';
wwv_flow_imp.g_varchar2_table(36498) := '6E6420746F223A22452D6D61696C2070617261206F207175616C206120726573706F73746120646576652073657220656E7669616461222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F76657320636F6E74656E7429223A22';
wwv_flow_imp.g_varchar2_table(36499) := '506F6F6C2F7061727469636970616E74652076617A696F202872656D6F766520636F6E7465C3BA646F29222C22456D70747920706F6F6C2F7061727469636970616E74223A22506F6F6C206665636861646F222C22456E64204576656E74223A22457665';
wwv_flow_imp.g_varchar2_table(36500) := '6E746F2064652046696D222C22456E64206576656E74223A2246696E616C697A6172204576656E746F222C22456E64706F696E74223A22506F6E746F2046696E616C222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E';
wwv_flow_imp.g_varchar2_table(36501) := '223A2244696769746520657874656E73C3B5657320706572736F6E616C697A6164617320636F6D6F204A534F4E222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22456E74726520636F6D206F20';
wwv_flow_imp.g_varchar2_table(36502) := '43C3B36469676F20504C2F53514C2061207365722045786563757461646F222C224572726F7220626F756E64617279206576656E74223A224576656E746F206465206C696D697465206465206572726F222C224572726F7220456E64204576656E74223A';
wwv_flow_imp.g_varchar2_table(36503) := '224576656E746F2064652046696D20646F205469706F204572726F222C224572726F7220656E64206576656E74223A224576656E746F2046696E616C20646F204572726F222C224572726F72207374617274206576656E74223A224576656E746F206465';
wwv_flow_imp.g_varchar2_table(36504) := '20696EC3AD63696F206465206572726F222C224572726F72223A224572726F222C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206C696D697465206465';
wwv_flow_imp.g_varchar2_table(36505) := '20657363616C6F6E616D656E746F202873656D20696E746572727570C3A7C3A36F29222C22457363616C6174696F6E20626F756E64617279206576656E74223A224576656E746F206465206C696D69746520646520657363616C6F6E616D656E746F222C';
wwv_flow_imp.g_varchar2_table(36506) := '22457363616C6174696F6E20456E64204576656E74223A224576656E746F2064652046696D20646F205469706F20457363616C61C3A7C3A36F222C22457363616C6174696F6E20656E64206576656E74223A224576656E746F2046696E616C2064652045';
wwv_flow_imp.g_varchar2_table(36507) := '7363616C6F6E616D656E746F222C22457363616C6174696F6E20696E7465726D656469617465207468726F77206576656E74223A224576656E746F206465206C616EC3A7616D656E746F20696E7465726D656469C3A172696F20646520657363616C6F6E';
wwv_flow_imp.g_varchar2_table(36508) := '616D656E746F222C22457363616C6174696F6E20496E7465726D656469617465205468726F77204576656E74223A224576656E746F20496E7465726D656469C3A172696F20646F205469706F204469737061726F20646520457363616C61C3A7C3A36F22';
wwv_flow_imp.g_varchar2_table(36509) := '2C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20696E696369616C20646520657363616C6F6E616D656E746F202873656D2D696E746572727570C3A7C3A36F29222C22';
wwv_flow_imp.g_varchar2_table(36510) := '457363616C6174696F6E207374617274206576656E74223A224576656E746F20696E696369616C20646520657363616C6F6E616D656E746F222C22457363616C6174696F6E223A22457363616C61C3A7C3A36F222C224576656E74204261736564204761';
wwv_flow_imp.g_varchar2_table(36511) := '7465776179223A2247617465776179204261736561646F20656D204576656E746F222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A224F204576656E746F2074656D2076C3A1726961732064656669';
wwv_flow_imp.g_varchar2_table(36512) := '6E69C3A7C3B56573222C224576656E74205375622050726F63657373223A2253756270726F636573736F206465204576656E746F222C224576656E74207375622D70726F63657373223A224576656E746F2064652073756270726F636573736F222C2245';
wwv_flow_imp.g_varchar2_table(36513) := '76656E742054797065223A225469706F206465204576656E746F222C224576656E742D62617365642067617465776179223A2247617465776179206261736561646F20656D206576656E746F73222C224578636C75646564205374617274696E67205573';
wwv_flow_imp.g_varchar2_table(36514) := '657273223A22557375C3A172696F7320496E696369616973204578636C75C3AD646F73222C224578636C75646564205573657273223A22557375C3A172696F73204578636C75C3AD646F73222C224578636C75736976652047617465776179223A224761';
wwv_flow_imp.g_varchar2_table(36515) := '74657761792028506F72746120646520456E747261646129204578636C757369766F222C224578636C75736976652067617465776179223A2247617465776179204578636C757369766F222C2245786563757461626C65223A22457865637574C3A17665';
wwv_flow_imp.g_varchar2_table(36516) := '6C222C224578656375746520504C2F53514C223A2245786563757461722063C3B36469676F20504C2F53514C222C22457865637574696F6E223A224578656375C3A7C3A36F222C22457870616E64656420706F6F6C2F7061727469636970616E74223A22';
wwv_flow_imp.g_varchar2_table(36517) := '506F6F6C2F7061727469636970616E746520657870616E6469646F222C22457870616E646564205375622050726F63657373223A2253756270726F636573736F20457870616E6469646F222C2245787072657373696F6E20284C656761637929223A2245';
wwv_flow_imp.g_varchar2_table(36518) := '787072657373C3A36F20286C656761646129222C2245787072657373696F6E2054797065223A225469706F2064652045787072657373C3A36F222C2245787072657373696F6E223A2245787072657373C3A36F222C226661696C656420746F20696D706F';
wwv_flow_imp.g_varchar2_table(36519) := '7274207B656C656D656E747D223A2266616C686120616F20696D706F72746172207B656C656D656E747D222C22666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A22';
wwv_flow_imp.g_varchar2_table(36520) := '656C656D656E746F7320646520666C75786F20646576656D207365722066696C686F732064652050697363696E61732F5061727469636970616E746573222C22466C6F772073706C69747320696D706C696369746C79223A224F20466C75786F20C3A920';
wwv_flow_imp.g_varchar2_table(36521) := '646976696469646F20696D706C69636974616D656E7465222C22466F726D2054656D706C617465204974656D204E616D65223A224E6F6D6520646F204974656D20646F204D6F64656C6F20646520466F726D756CC3A172696F222C22466F726D2054656D';
wwv_flow_imp.g_varchar2_table(36522) := '706C617465204974656D223A224974656D206465206D6F64656C6F20646520666F726D756CC3A172696F222C22466F726D2054656D706C617465223A224D6F64656C6F20646520666F726D756CC3A172696F222C22466F726D6174204D61736B223A2246';
wwv_flow_imp.g_varchar2_table(36523) := '6F726D61746172204DC3A17363617261222C22466F726D61744D61736B223A22466F726D61744D61736B222C2246726F6D223A224465222C2246756E6374696F6E20426F647920284C656761637929223A22436F72706F2064612046756EC3A7C3A36F20';
wwv_flow_imp.g_varchar2_table(36524) := '284C656761646F29222C2246756E6374696F6E20426F6479223A22436F72706F2064612046756EC3A7C3A36F222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461';
wwv_flow_imp.g_varchar2_table(36525) := '726765742E223A22476174657761792028506F72746120646520456E747261646129206465736E6563657373C3A172696F2E20456C6520706F73737569206170656E617320756D61206F726967656D2F656E7472616461206520756D2064657374696E6F';
wwv_flow_imp.g_varchar2_table(36526) := '2F7361C3AD6461222C2247656E6572616C223A22476572616C222C2247656E65726174652064656661756C74206974656D73223A224765726172206974656E732070616472C3A36F222C22476C6F62616C206572726F72207265666572656E6365223A22';
wwv_flow_imp.g_varchar2_table(36527) := '5265666572C3AA6E636961206465206572726F20676C6F62616C222C22476C6F62616C20657363616C6174696F6E207265666572656E6365223A225265666572C3AA6E63696120646520657363616C61C3A7C3A36F20676C6F62616C222C22476C6F6261';
wwv_flow_imp.g_varchar2_table(36528) := '6C207369676E616C207265666572656E6365223A225265666572C3AA6E6369612064652073696E616C20676C6F62616C222C2247726F7570223A22477275706F222C2248544D4C2076657273696F6E206F662074686520656D61696C223A2256657273C3';
wwv_flow_imp.g_varchar2_table(36529) := 'A36F20646F2048544D4C20646F20452D6D61696C222C224944206D75737420626520756E697175652E223A224F204944206465766520736572206578636C757369766F2E222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D';
wwv_flow_imp.g_varchar2_table(36530) := '3A5353223A226E6F20666F726D61746F204444442048483A4D4D3A5353222C22696E20666F726D61742059592D4D4D223A226E6F20666F726D61746F2059592D4D4D222C22496E205661726961626C6573223A22456D2056617269C3A176656973222C22';
wwv_flow_imp.g_varchar2_table(36531) := '496E2F4F7574204D617070696E67223A224D617065616D656E746F20646520456E74726164612F5361C3AD6461222C22496E2F4F7574205661726961626C6573223A2256617269C3A17665697320646520456E74726164612F5361C3AD6461222C22496E';
wwv_flow_imp.g_varchar2_table(36532) := '636C75736976652067617465776179223A224761746577617920496E636C757369766F222C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A22466C75786F73206465204F726967656D2F456E7472616461206EC3A36F20736520';
wwv_flow_imp.g_varchar2_table(36533) := '6C6967616D222C22496E69746961746F72206F66207468697320617070726F76616C207461736B223A22496E69636961646F7220646573746120746172656661206465206170726F7661C3A7C3A36F222C22496E69746961746F72223A22496E69636961';
wwv_flow_imp.g_varchar2_table(36534) := '646F72222C22496E70757420436F6C6C656374696F6E223A22436F6C65746120646520456E7472616461222C22496E70757420456C656D656E74223A22456C656D656E746F20646520456E7472616461222C22496E7465726D656469617465207468726F';
wwv_flow_imp.g_varchar2_table(36535) := '77206576656E74223A224576656E746F206465204C616EC3A7616D656E746F20496E7465726D656469C3A172696F222C22496E7465726D656469617465205468726F77204576656E74223A224576656E746F20496E7465726D656469C3A172696F202844';
wwv_flow_imp.g_varchar2_table(36536) := '69737061726F29222C22496E74657276616C223A22496E74657276616C6F222C2249732043616C6C61626C65223A22C389204368616DC3A176656C222C22497320526F6C65223A22C3892066756EC3A7C3A36F222C22497320537461727461626C65223A';
wwv_flow_imp.g_varchar2_table(36537) := '22C38920537461727461626C65222C2249534F223A2249534F222C224974656D204E616D65223A224E6F6D6520646F204974656D222C224974656D2056616C7565223A2256616C6F7220646F204974656D222C224974656D223A224974656D222C224974';
wwv_flow_imp.g_varchar2_table(36538) := '65726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F72746564223A224174697661C3A7C3B56573206465206368616D616461206465206974657261C3A7C3A36F206EC3A36F2073C3A36F20';
wwv_flow_imp.g_varchar2_table(36539) := '7375706F727461646173206E6F206D6F6D656E746F222C224A534F4E204F626A656374223A224F626A65746F204A534F4E222C224C616E65223A224661697861222C224C61746573742076657273696F6E223A2256657273C3A36F206D61697320726563';
wwv_flow_imp.g_varchar2_table(36540) := '656E7465222C224C696E6B20496E7465726D656469617465204361746368204576656E74223A224576656E746F20496E7465726D6469C3A172696F207175652043617074757261206F205469706F204C696E6B222C224C696E6B20696E7465726D656469';
wwv_flow_imp.g_varchar2_table(36541) := '617465206361746368206576656E74223A224C696E6B20696E7465726D656469617465206361746368206576656E74222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A224576656E746F20496E7465726D6469C3A172';
wwv_flow_imp.g_varchar2_table(36542) := '696F207175652044697370617261206F205469706F204C696E6B222C224C696E6B20696E7465726D656469617465207468726F77206576656E74223A224C696E6B204576656E746F206465204C616EC3A7616D656E746F20496E7465726D656469C3A172';
wwv_flow_imp.g_varchar2_table(36543) := '696F222C224C696E6B223A224C696E6B222C224C6F616420646566696E6564207661726961626C6573223A2243617272656761722076617269C3A17665697320646566696E69646173222C224C6F6164204A534F4E223A224361727265676172204A534F';
wwv_flow_imp.g_varchar2_table(36544) := '4E222C224C6F616420506172616D6574657273223A22506172C3A26D6574726F73206465204361726761222C224C6F6F70223A224C6F6F7020284369636C6F29222C224D61696C223A22452D6D61696C222C224D616E75616C207461736B223A22546172';
wwv_flow_imp.g_varchar2_table(36545) := '656661204D616E75616C222C224D616E75616C205461736B223A22546172656661204D616E75616C222C224D61782052756E73223A224EC3BA6D65726F206DC3A178696D6F206465206578656375C3A7C3B56573222C224D65737361676520626F756E64';
wwv_flow_imp.g_varchar2_table(36546) := '617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465204D656E736167656D2064652046726F6E7465697261202873656D20696E746572727570C3A7C3A36F29222C224D65737361676520626F756E646172';
wwv_flow_imp.g_varchar2_table(36547) := '79206576656E74223A224576656E746F206465206D656E736167656D2064652046726F6E7465697261222C224D65737361676520656E64206576656E74223A224576656E746F2064652066696D206461206D656E736167656D222C224D65737361676520';
wwv_flow_imp.g_varchar2_table(36548) := '456E64204576656E74223A224576656E746F2064652046696D20646F205469706F204D656E736167656D222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A224576656E746F20496E7465726D6469C3A172696F';
wwv_flow_imp.g_varchar2_table(36549) := '207175652043617074757261206F205469706F204D656E736167656D222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A224D656E736167656D20496E7465726D656469C3A1726961204361746368204576656E';
wwv_flow_imp.g_varchar2_table(36550) := '74222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A224576656E746F206465204C616EC3A7616D656E746F20496E7465726D656469C3A172696F206465204D656E736167656D222C224D65737361676520496E';
wwv_flow_imp.g_varchar2_table(36551) := '7465726D656469617465205468726F77204576656E74223A224576656E746F20496E7465726D6469C3A172696F207175652044697370617261206F205469706F204D656E736167656D222C224D657373616765204E616D65223A224E6F6D65206461204D';
wwv_flow_imp.g_varchar2_table(36552) := '656E736167656D222C224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520496EC3AD63696F206461204D656E736167656D202873656D2D696E746572727570C3A7C3A36F29';
wwv_flow_imp.g_varchar2_table(36553) := '222C224D657373616765207374617274206576656E74223A224576656E746F20646520496EC3AD63696F206461204D656E736167656D222C224D657373616765205374617274204576656E74223A224576656E746F20646520496EC3AD63696F20646F20';
wwv_flow_imp.g_varchar2_table(36554) := '5469706F204D656E736167656D222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A227B73656D616E7469637D236174746163686564546F52656620617573656E7465222C226D6F7265207468616E207B636F75';
wwv_flow_imp.g_varchar2_table(36555) := '6E747D206368696C64206C616E6573223A226D61697320646F20717565207B636F756E747D2072616961732066696C686173222C224D756C74692D496E7374616E6365223A2256C3A17269617320496E7374C3A26E63696173222C226D756C7469706C65';
wwv_flow_imp.g_varchar2_table(36556) := '20444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A224944206DC3BA6C7469706C6F7320646520656C656D656E746F7320646566696E69646F732070617261207B656C656D656E747D222C224E616D65206F662074';
wwv_flow_imp.g_varchar2_table(36557) := '6865206469616772616D223A224E6F6D6520646F206469616772616D61222C224E616D65206F66207468652050726F63657373205661726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E6529223A224E6F';
wwv_flow_imp.g_varchar2_table(36558) := '6D652064612056617269C3A176656C20646F2050726F636573736F2028646F207469706F2054696D657374616D7020636F6D204675736F20486F72C3A172696F29222C224E616D65206F66207468652050726F63657373205661726961626C65223A224E';
wwv_flow_imp.g_varchar2_table(36559) := '6F6D652064612056617269C3A176656C20646F2050726F636573736F222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C20726573756C7420696E746F223A224E6F6D6520646120766172';
wwv_flow_imp.g_varchar2_table(36560) := '69C3A176656C20706172612061207175616C207265746F726E61206F20726573756C7461646F206461206170726F7661C3A7C3A36F222C224E616D65223A224E6F6D65222C224E616D65642076657273696F6E223A2256657273C3A36F206E6F6D656164';
wwv_flow_imp.g_varchar2_table(36561) := '61222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A226E656E68756D20656C656D656E746F2062706D6E207265666572656E636961646F20656D207B656C656D656E747D222C226E6F20646961';
wwv_flow_imp.g_varchar2_table(36562) := '6772616D20746F20646973706C6179223A2273656D206469616772616D61207061726120657869626972222C226E6F20706172656E7420666F72207B656C656D656E747D20696E207B706172656E747D223A227B656C656D656E747D206EC3A36F20706F';
wwv_flow_imp.g_varchar2_table(36563) := '737375692070616920656D207B706172656E747D222C226E6F20706C616E6520666F72207B656C656D656E747D223A226E656E68756D20617669C3A36F2070617261207B656C656D656E747D222C226E6F2070726F63657373206F7220636F6C6C61626F';
wwv_flow_imp.g_varchar2_table(36564) := '726174696F6E20746F20646973706C6179223A2273656D2070726F636573736F206F7520636F6C61626F7261C3A7C3A36F207061726120657869626972222C226E6F207368617065207479706520737065636966696564223A226E656E68756D20746970';
wwv_flow_imp.g_varchar2_table(36565) := '6F20646520666F726D6120657370656369666963616461222C224E756D626572223A224EC3BA6D65726F222C224F6E204576656E74223A22447572616E7465206F204576656E746F222C224F7261636C65205363686564756C652065787072657373696F';
wwv_flow_imp.g_varchar2_table(36566) := '6E223A2245787072657373C3A36F204F7261636C65205363686564756C65222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A2272656C6561736520666F726120646F73206C696D697465222C';
wwv_flow_imp.g_varchar2_table(36567) := '224F7574205661726961626C6573223A2256617269C3A1766569732045787465726E6173222C224F757470757420436F6C6C656374696F6E223A22436F6C657461206465205361C3AD6461222C224F757470757420456C656D656E74223A22456C656D65';
wwv_flow_imp.g_varchar2_table(36568) := '6E746F206465205361C3AD6461222C224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A22537562737469747569206F20636F6E6A756E746F2064652076616C6F72657320706164';
wwv_flow_imp.g_varchar2_table(36569) := '72C3A36F206E6120646566696E69C3A7C3A36F20646120746172656661222C2250616765204944223A2249442064612050C3A167696E61222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C61746520726566';
wwv_flow_imp.g_varchar2_table(36570) := '6572656E6365223A224974656D2064652070C3A167696E612071756520636F6E74C3A96D2061207265666572C3AA6E63696120646F206D6F64656C6F20646520666F726D756CC3A172696F222C2250616765204974656D73223A224974656E7320646120';
wwv_flow_imp.g_varchar2_table(36571) := '70C3A167696E61222C2250616765223A2250C3A167696E61222C22506172616C6C656C2047617465776179223A22476174657761792028506F72746120646520456E74726164612920506172616C656C6F222C22506172616C6C656C2067617465776179';
wwv_flow_imp.g_varchar2_table(36572) := '223A224761746577617920506172616C656C6F222C22506172616C6C656C206D756C74692D696E7374616E6365223A22496E7374C3A26E636961204D756C746920506172616C656C61222C225061727469636970616E74204944223A22494420646F2050';
wwv_flow_imp.g_varchar2_table(36573) := '61727469636970616E7465222C225061727469636970616E74206D756C7469706C6963697479223A224D756C7469706C6963696461646520646F207061727469636970616E7465222C225061727469636970616E74204E616D65223A224E6F6D6520646F';
wwv_flow_imp.g_varchar2_table(36574) := '205061727469636970616E7465222C225061727469636970616E74223A225061727469636970616E7465222C225061796C6F6164205661726961626C65223A2256617269C3A176656C20646520436172676120C39A74696C222C225061796C6F6164223A';
wwv_flow_imp.g_varchar2_table(36575) := '22436172676120C39A74696C222C22504C2F53514C20436F6465223A2243C3B36469676F20504C2F53514C222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A2245787072657373C3';
wwv_flow_imp.g_varchar2_table(36576) := 'A36F20504C2F53514C207265746F726E616E646F20756D2076616C6F7220626F6F6C69616E6F222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A2245787072657373C3A36F20504C2F5351';
wwv_flow_imp.g_varchar2_table(36577) := '4C20717565207265746F726E6120756D2076616C6F722064652064617461222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061206E756D6265722076616C7565223A2245787072657373C3A36F20504C2F53514C2071756520';
wwv_flow_imp.g_varchar2_table(36578) := '7265746F726E6120756D2076616C6F72206E756DC3A97269636F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2245787072657373C3';
wwv_flow_imp.g_varchar2_table(36579) := 'A36F20504C2F53514C20717565207265746F726E6120756D2054696D657374616D7020636F6D2076616C6F72206465204675736F20486F72C3A172696F222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120766172636861';
wwv_flow_imp.g_varchar2_table(36580) := '72322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A2245787072657373C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F72207661726368617232206E6F20666F';
wwv_flow_imp.g_varchar2_table(36581) := '726D61746F20414141412D4D4D2D444420484832343A4D493A535320545A52222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420';
wwv_flow_imp.g_varchar2_table(36582) := '484832343A4D493A5353223A2245787072657373C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F72207661726368617232206E6F20666F726D61746F20414141412D4D4D2D444420484832343A4D493A5353222C22504C2F53';
wwv_flow_imp.g_varchar2_table(36583) := '514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A2245787072657373C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F722076';
wwv_flow_imp.g_varchar2_table(36584) := '61726368617232206E6F20666F726D61746F206E756DC3A97269636F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A2245787072657373C3A36F20504C2F53514C2071756520';
wwv_flow_imp.g_varchar2_table(36585) := '7265746F726E6120756D2076616C6F72207661726368617232222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A2245787072657373C3A36F20504C2F53514C';
wwv_flow_imp.g_varchar2_table(36586) := '20717565207265746F726E61206F2054696D657374616D7020636F6D204675736F20486F72C3A172696F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A22436F72706F20';
wwv_flow_imp.g_varchar2_table(36587) := '64612046756EC3A7C3A36F20504C2F53514C207265746F726E616E646F20756D2076616C6F7220626F6F6C69616E6F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120646174652076616C7565223A22436F7270';
wwv_flow_imp.g_varchar2_table(36588) := '6F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F722064652064617461222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A22';
wwv_flow_imp.g_varchar2_table(36589) := '436F72706F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F72206E756DC3A97269636F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374616D70';
wwv_flow_imp.g_varchar2_table(36590) := '20776974682054696D65205A6F6E652076616C7565223A22436F72706F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F726E6120756D2054696D657374616D7020636F6D206F2076616C6F72206465204675736F20486F72C3A172';
wwv_flow_imp.g_varchar2_table(36591) := '696F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22436F72706F20646120';
wwv_flow_imp.g_varchar2_table(36592) := '46756EC3A7C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F72207661726368617232206E6F20666F726D61746F20414141412D4D4D2D444420484832343A4D493A535320545A52222C22504C2F53514C2046756E6374696F6E';
wwv_flow_imp.g_varchar2_table(36593) := '20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22436F72706F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F';
wwv_flow_imp.g_varchar2_table(36594) := '726E6120756D2076616C6F72207661726368617232206E6F20666F726D61746F20414141412D4D4D2D444420484832343A4D493A5353222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076';
wwv_flow_imp.g_varchar2_table(36595) := '616C756520696E206E756D62657220666F726D6174223A22436F72706F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F72207661726368617232206E6F20666F726D61746F206E756DC3A97269636F22';
wwv_flow_imp.g_varchar2_table(36596) := '2C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565223A22436F72706F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F726E6120756D2076616C6F72207661';
wwv_flow_imp.g_varchar2_table(36597) := '726368617232222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22436F72706F2064612046756EC3A7C3A36F20504C2F53514C20717565207265746F';
wwv_flow_imp.g_varchar2_table(36598) := '726E61206F2054696D657374616D7020636F6D206F204675736F20486F72C3A172696F222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A2245737061C3A76F2052657365727661646F222C22506F74656E7469616C20';
wwv_flow_imp.g_varchar2_table(36599) := '47726F757073223A22477275706F7320506F74656E6369616973222C22506F74656E7469616C205374617274657273223A22496E696369616E74657320656D20506F74656E6369616C222C22506F74656E7469616C205374617274696E672047726F7570';
wwv_flow_imp.g_varchar2_table(36600) := '73223A22477275706F7320496E69636961697320506F74656E6369616973222C22506F74656E7469616C205374617274696E67205573657273223A22557375C3A172696F7320496E69636961697320506F74656E6369616973222C22506F74656E746961';
wwv_flow_imp.g_varchar2_table(36601) := '6C205573657273223A22557375C3A172696F7320506F74656E6369616973222C225072696F72697479223A225072696F726964616465222C2250726F6365737320646F63756D656E746174696F6E223A22446F63756D656E7461C3A7C3A36F20646F2070';
wwv_flow_imp.g_varchar2_table(36602) := '726F636573736F222C2250726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A224F2050726F636573736F2074656D2076C3A172696F73204576656E746F7320646520496EC3AD63696F20656D20627261';
wwv_flow_imp.g_varchar2_table(36603) := '6E636F222C2250726F63657373204944223A22494420646F2050726F636573736F222C2250726F63657373206973206D697373696E6720656E64206576656E74223A224576656E746F2064652046696D206EC3A36F206C6F63616C697A61646F206E6F20';
wwv_flow_imp.g_varchar2_table(36604) := '50726F636573736F2E222C2250726F63657373206973206D697373696E67207374617274206576656E74223A224576656E746F20646520496EC3AD63696F206EC3A36F206C6F63616C697A61646F206E6F2050726F636573736F222C2250726F63657373';
wwv_flow_imp.g_varchar2_table(36605) := '206E616D65223A224E6F6D6520646F2070726F636573736F222C2250726F63657373205072696F72697479223A225072696F72696461646520646F2050726F636573736F222C2250726F6365737320737461747573206166746572207465726D696E6174';
wwv_flow_imp.g_varchar2_table(36606) := '696F6E223A2253746174757320646F2070726F636573736F206170C3B373206F206465736C6967616D656E746F222C2250726F63657373205661726961626C652028417272617929223A2256617269C3A176656C2064652050726F636573736F20284172';
wwv_flow_imp.g_varchar2_table(36607) := '72617929222C2250726F63657373205661726961626C6520284C69737429223A2256617269C3A176656C2064652050726F636573736F20284C6973746129222C2250726F63657373205661726961626C65223A2256617269C3A176656C2064652050726F';
wwv_flow_imp.g_varchar2_table(36608) := '636573736F222C2250726F63657373223A2250726F636573736F222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A22466F726E656365722076616C6F7265732070617261206F73204D6F64656C6F73202854';
wwv_flow_imp.g_varchar2_table(36609) := '656D706C617465732920646520452D6D61696C222C2252656365697665207461736B223A2252656D6F76657220546172656661222C2252656365697665205461736B223A22546172656661206465205265636562696D656E746F222C225265646F223A22';
wwv_flow_imp.g_varchar2_table(36610) := '526566617A6572222C2252656D6F7665223A2252656D6F766572222C225265706C7920546F223A22526573706F6E6465722050617261222C22526571756573742056616C756520666F7220506167652043616C6C223A2256616C6F722052657175697369';
wwv_flow_imp.g_varchar2_table(36611) := '7461646F2070617261204368616D6164612064652050C3A167696E61222C2252657175657374223A2252657175697369C3A7C3A36F222C22526573756C74205661726961626C65223A2256617269C3A176656C20646F20526573756C7461646F222C2252';
wwv_flow_imp.g_varchar2_table(36612) := '657475726E205061796C6F616420496E746F223A225265746F726E617220436172676120C39A74696C2070617261222C22526F6C65223A2246756EC3A7C3A36F222C2253617665223A2253616C766172222C225363686564756C65722045787072657373';
wwv_flow_imp.g_varchar2_table(36613) := '696F6E223A2245787072657373C3A36F20646F205363686564756C6572222C225363686564756C696E67223A2250726F6772616D61C3A7C3A36F222C22536372697074207461736B223A2254617265666120646520526F746569726F222C225363726970';
wwv_flow_imp.g_varchar2_table(36614) := '74205461736B223A2254617265666120646F205469706F20536372697074222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A2253656C6563696F6E652073652065737465206469616772616D61206573';
wwv_flow_imp.g_varchar2_table(36615) := '74C3A120656D2065737472656C61222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A2253656C6563696F6E6520736520657374652064696167';
wwv_flow_imp.g_varchar2_table(36616) := '72616D61206465766520736572206368616D61646F20656D20756D6120417469766964616465206465204368616D616461222C2253656E6420456D61696C20496D6D6564696174656C79223A22456E7669617220452D6D61696C20496D6564696174616D';
wwv_flow_imp.g_varchar2_table(36617) := '656E7465222C2253656E64204D61696C223A22456E7669617220452D6D61696C222C2253656E64207461736B223A22456E7669617220546172656661222C2253656E64205461736B223A2254617265666120646F205469706F20456E76696F222C225365';
wwv_flow_imp.g_varchar2_table(36618) := '7175656E636520666C6F77223A22466C75786F2064652073657175C3AA6E636961222C2253657175656E6365223A2253657175C3AA6E636961222C2253657175656E6365466C6F772069732061206475706C6963617465223A22466C75786F2064652053';
wwv_flow_imp.g_varchar2_table(36619) := '657175C3AA6E63696120657374C3A1206475706C696361646F222C2253657175656E7469616C206D756C74692D696E7374616E6365223A22496E7374C3A26E636961204D756C74692053657175656E6369616C222C2253657276696365205461736B223A';
wwv_flow_imp.g_varchar2_table(36620) := '22417469766964616465206465205365727669C3A76F222C2253657276696365207461736B223A2254617265666120646F207469706F205365727669C3A76F222C2253657420636F6C6F72223A22446566696E697220636F72222C225369676E616C2062';
wwv_flow_imp.g_varchar2_table(36621) := '6F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F206465206C696D6974652064652073696E616C202873656D20696E746572727570C3A7C3A36F29222C225369676E616C20626F756E646172792065';
wwv_flow_imp.g_varchar2_table(36622) := '76656E74223A224576656E746F206465206C696D6974652064652073696E616C222C225369676E616C20456E64204576656E74223A224576656E746F2064652046696D20646F205469706F2053696E616C222C225369676E616C20656E64206576656E74';
wwv_flow_imp.g_varchar2_table(36623) := '223A224576656E746F2046696E616C20646F2053696E616C222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A224576656E746F206465204572726F20496E7465726D656469C3A172696F222C225369676E616C20';
wwv_flow_imp.g_varchar2_table(36624) := '496E7465726D656469617465204361746368204576656E74223A224576656E746F20496E7465726D6469C3A172696F207175652044697370617261206F205469706F2053696E616C222C225369676E616C20696E7465726D656469617465207468726F77';
wwv_flow_imp.g_varchar2_table(36625) := '206576656E74223A224576656E746F206465204C616EC3A7616D656E746F20496E7465726D656469C3A172696F222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A224576656E746F20496E7465726D6469C3A172';
wwv_flow_imp.g_varchar2_table(36626) := '696F207175652043617074757261206F205469706F2053696E616C222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520696EC3AD63696F2064652073696E616C20287365';
wwv_flow_imp.g_varchar2_table(36627) := '6D2D696E746572727570C3A7C3A36F29222C225369676E616C207374617274206576656E74223A224576656E746F20646520696EC3AD63696F2064652073696E616C222C225369676E616C205374617274204576656E74223A224576656E746F20646520';
wwv_flow_imp.g_varchar2_table(36628) := '496EC3AD63696F20646F205469706F2053696E616C222C225369676E616C223A2253696E616C222C2253696D706C65204D657373616765223A224D656E736167656D2053696D706C6573222C2253514C2071756572792028636F6C6F6E2064656C696D69';
wwv_flow_imp.g_varchar2_table(36629) := '746564206C69737429223A22436F6E73756C74612053514C20286C697374612064656C696D697461646120706F7220646F697320706F6E746F7329222C2253514C20717565727920284A534F4E20617272617929223A22436F6E73756C74612053514C20';
wwv_flow_imp.g_varchar2_table(36630) := '2861727261794A534F4E29222C2253514C207175657279202873696E676C652076616C756529223A22436F6E73756C74612053514C202876616C6F7220C3BA6E69636F29222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064';
wwv_flow_imp.g_varchar2_table(36631) := '656C696D69746564206C697374223A22436F6E73756C74612053514C207265746F726E616E646F20756D61206C697374612064656C696D697461646120706F7220646F697320706F6E746F73222C2253514C2071756572792072657475726E696E672061';
wwv_flow_imp.g_varchar2_table(36632) := '204A534F4E206172726179223A22436F6E73756C74612053514C207265746F726E616E646F20756D61206D617472697A204A534F4E222C2253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C7565223A22436F';
wwv_flow_imp.g_varchar2_table(36633) := '6E73756C74612053514C207265746F726E616E646F20756D20C3BA6E69636F2076616C6F722064652064617461222C2253514C2071756572792072657475726E696E6720612073696E676C65206E756D6265722076616C7565223A22436F6E73756C7461';
wwv_flow_imp.g_varchar2_table(36634) := '2053514C207265746F726E616E646F20756D20C3BA6E69636F2076616C6F72206E756DC3A97269636F222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D65205A6F6E65207661';
wwv_flow_imp.g_varchar2_table(36635) := '6C7565223A22436F6E73756C74612053514C207265746F726E616E646F20756D20C3BA6E69636F2054696D657374616D7020636F6D2076616C6F72206465204675736F20486F72C3A172696F222C2253514C2071756572792072657475726E696E672061';
wwv_flow_imp.g_varchar2_table(36636) := '2073696E676C652076617263686172322076616C7565223A22436F6E73756C74612053514C207265746F726E616E646F20756D20C3BA6E69636F2076616C6F72207661726368617232222C2253514C2071756572792072657475726E696E672054696D65';
wwv_flow_imp.g_varchar2_table(36637) := '7374616D7020776974682054696D65205A6F6E65223A22436F6E73756C74612053514C207265746F726E616E646F2054696D657374616D7020636F6D204675736F20486F72C3A172696F222C2253514C20717565727920746F2067657420617474616368';
wwv_flow_imp.g_varchar2_table(36638) := '6D656E74223A22436F6E73756C74612053514C2070617261206F6274657220416E65786F73222C2253514C207175657279223A22436F6E73756C74612053514C222C2253514C205175657279223A22436F6E73756C74612053514C222C22537461727420';
wwv_flow_imp.g_varchar2_table(36639) := '6576656E74206973206D697373696E67206576656E7420646566696E6974696F6E223A2246616C7461206120646566696E69C3A7C3A36F20646520756D204576656E746F20646520496EC3AD63696F222C225374617274206576656E74206D7573742062';
wwv_flow_imp.g_varchar2_table(36640) := '6520626C616E6B223A224576656E746F20646520496EC3AD63696F206465766520666963617220656D206272616E636F222C225374617274204576656E74223A224576656E746F20646520496EC3AD63696F222C225374617274206576656E74223A2249';
wwv_flow_imp.g_varchar2_table(36641) := '6E6963696172204576656E746F222C2253746174696320646174652076616C7565223A2256616C6F72206465206461746120657374C3A174696361222C22537461746963204944223A22494420457374C3A17469636F222C22537461746963206E756D62';
wwv_flow_imp.g_varchar2_table(36642) := '65722076616C7565223A2256616C6F7220646F206EC3BA6D65726F20657374C3A17469636F222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2254696D657374616D7020457374C3A17469636F20';
wwv_flow_imp.g_varchar2_table(36643) := '636F6D2076616C6F72206465204675736F20486F72C3A172696F222C225374617469632076617263686172322076616C7565223A2256616C6F7220657374C3A17469636F207661726368617232222C22537461746963223A22457374C3A17469636F222C';
wwv_flow_imp.g_varchar2_table(36644) := '22537472696E67223A22537472696E67222C225375622070726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A224F2053756270726F636573736F2074656D2076C3A172696F73204576656E746F732064';
wwv_flow_imp.g_varchar2_table(36645) := '6520496EC3AD63696F20656D206272616E636F222C225375622070726F63657373206973206D697373696E6720656E64206576656E74223A224576656E746F2064652046696D206EC3A36F206C6F63616C697A61646F206E6F2053756270726F63657373';
wwv_flow_imp.g_varchar2_table(36646) := '6F2E222C225375622070726F63657373206973206D697373696E67207374617274206576656E74223A224576656E746F2064652046696D206EC3A36F206C6F63616C697A61646F206E6F2053756270726F636573736F2E222C225375622D70726F636573';
wwv_flow_imp.g_varchar2_table(36647) := '732028636F6C6C617073656429223A225375622050726F636573736F2028616772757061646F29222C225375622D70726F636573732028657870616E64656429223A2253756270726F636573736F2028657870616E6469646F29222C225375622D70726F';
wwv_flow_imp.g_varchar2_table(36648) := '63657373223A2253756270726F636573736F222C225375626A656374223A2254C3AD74756C6F222C225461736B20446566696E6974696F6E223A22446566696E69C3A7C3A36F20646520546172656661222C225461736B20537461746963204944223A22';
wwv_flow_imp.g_varchar2_table(36649) := '494420457374C3A17469636F20646120546172656661222C225461736B2054797065223A225469706F20646520546172656661222C225461736B223A22546172656661222C2254656D706C617465204944223A22494420646F204D6F64656C6F20285465';
wwv_flow_imp.g_varchar2_table(36650) := '6D706C61746529222C2254656D706C617465223A224D6F64656C6F202854656D706C61746529222C225465726D696E61746520456E64204576656E74223A224576656E746F2064652046696D20646F205469706F20456E63657272616D656E746F222C22';
wwv_flow_imp.g_varchar2_table(36651) := '5465726D696E61746520656E64206576656E74223A225465726D696E61746520656E64206576656E74222C225465726D696E61746564223A22456E6365727261646F222C2254657874223A22546578746F222C2254696D6520756E74696C207468652074';
wwv_flow_imp.g_varchar2_table(36652) := '696D657220666972657320616761696E223A2244757261C3A7C3A36F206174C3A9206F2074656D706F72697A61646F72206469737061726172206E6F76616D656E7465222C2254696D6520756E74696C207468652074696D657220666972657320666972';
wwv_flow_imp.g_varchar2_table(36653) := '7374223A2244757261C3A7C3A36F206174C3A9206F207072696D6569726F2074656D706F72697A61646F72206469737061726172222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22457665';
wwv_flow_imp.g_varchar2_table(36654) := '6E746F206465204C696D6974652064652054656D706F726172697A61646F72202873656D20696E746572727570C3A7C3A36F29222C2254696D657220626F756E64617279206576656E74223A224576656E746F206465204C696D6974652064652054656D';
wwv_flow_imp.g_varchar2_table(36655) := '706F726172697A61646F72222C2254696D657220446566696E6974696F6E2054797065223A225469706F20646520446566696E69C3A7C3A36F206465205465726D706F72697A61646F72222C2254696D657220446566696E6974696F6E223A2244656669';
wwv_flow_imp.g_varchar2_table(36656) := '6E69C3A7C3A36F2064652074656D706F72697A61646F72222C2254696D6572204475726174696F6E223A2244757261C3A7C3A36F20646F2054656D706F72697A61646F72222C2254696D657220496E7465726D656469617465204361746368204576656E';
wwv_flow_imp.g_varchar2_table(36657) := '74223A224576656E746F20496E7465726D656469C3A172696F207175652043617074757261206F205469706F2054656D706F72697A61646F72222C2254696D657220696E7465726D656469617465206361746368206576656E74223A2254696D65722069';
wwv_flow_imp.g_varchar2_table(36658) := '6E7465726D656469617465206361746368206576656E74222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A224576656E746F20646520496EC3AD63696F20646F2054696D6572202873656D2D696E74';
wwv_flow_imp.g_varchar2_table(36659) := '6572727570C3A7C3A36F29222C2254696D6572207374617274206576656E74223A224576656E746F20646520496EC3AD63696F20646F2054696D6572222C2254696D6572205374617274204576656E74223A224576656E746F20646520496EC3AD63696F';
wwv_flow_imp.g_varchar2_table(36660) := '20646F205469706F2054656D706F72697A61646F72222C2254696D6572223A2254656D706F72697A61646F72222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D6174';
wwv_flow_imp.g_varchar2_table(36661) := '223A2254696D657374616D7020636F6D204675736F20486F72C3A172696F206E6F20666F726D61746F2049534F2038363031206F75204F7261636C65222C2254696D657374616D7020776974682054696D65205A6F6E65223A2254696D657374616D7020';
wwv_flow_imp.g_varchar2_table(36662) := '636F6D204675736F20486F72C3A172696F222C22546F223A2250617261222C22546F67676C65206E6F6E2D696E74657272757074696E67223A22416C7465726E61722073656D20696E746572727570C3A7C3A36F222C225472616E73616374696F6E223A';
wwv_flow_imp.g_varchar2_table(36663) := '225472616E7361C3A7C3A36F222C22556E646F223A2244657366617A6572222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A226469207B64697D20646573636F6E68656369646F207061726120';
wwv_flow_imp.g_varchar2_table(36664) := '6F20656C656D656E746F207B73656D616E7469637D222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A22666C6F77456C656D656E74207B656C656D65';
wwv_flow_imp.g_varchar2_table(36665) := '6E747D206EC3A36F207265636F6E68656369646F206E6F20636F6E746578746F207B636F6E746578747D222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A226270';
wwv_flow_imp.g_varchar2_table(36666) := '6D6E456C656D656E74206EC3A36F207375706F727461646F2070617261207B706C616E657D3A207B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A2255736172204D65746164616461646F7320646F2041504558';
wwv_flow_imp.g_varchar2_table(36667) := '222C225573652054656D706C617465223A2255736172204D6F64656C6F202854656D706C61746529222C2255736564206469616772616D2076657273696F6E223A2256657273C3A36F20646F206469616772616D61207573616461222C22557365722074';
wwv_flow_imp.g_varchar2_table(36668) := '61736B223A2254617265666120646520557375C3A172696F222C2255736572205461736B223A2254617265666120646F20557375C3A172696F222C2256616C7565223A2256616C6F72222C225661726368617232223A225661726368617232222C225661';
wwv_flow_imp.g_varchar2_table(36669) := '726961626C652045787072657373696F6E73223A2245787072657373C3B565732064652056617269C3A176656C222C2256657273696F6E204E616D65223A224E6F6D652064612056657273C3A36F222C2256657273696F6E696E67223A22436F6E74726F';
wwv_flow_imp.g_varchar2_table(36670) := '6C652064652056657273C3A36F222C225761697420666F7220636F6D706C6574696F6E223A22416775617264617220636F6E636C7573C3A36F222C225A6F6F6D20496E223A22416D706C696172222C225A6F6F6D204F7574223A22526564757A6972227D';
wwv_flow_imp.g_varchar2_table(36671) := '27297D2C323232303A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D204572726F72732C207B7761726E696E67737D205761726E696E6773223A2278222C227B73656D616E74';
wwv_flow_imp.g_varchar2_table(36672) := '69637D237B736964657D20526566206E6F7420737065636966696564223A2278222C223C6E6F6E653E223A2278222C22312D557267656E74223A2278222C22322D48696768223A2278222C22332D4D656469756D223A2278222C22342D4C6F77223A2278';
wwv_flow_imp.g_varchar2_table(36673) := '222C22352D4C6F77657374223A2278222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073706C6974206174207468652073616D652074696D65223A2278222C224163746976617465206372656174652F72656D6F7665';
wwv_flow_imp.g_varchar2_table(36674) := '20737061636520746F6F6C223A2278222C22416374697661746520676C6F62616C20636F6E6E65637420746F6F6C223A2278222C2241637469766174652068616E6420746F6F6C223A2278222C224163746976617465206C6173736F20746F6F6C223A22';
wwv_flow_imp.g_varchar2_table(36675) := '78222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A2278222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A2278222C2241637469766174652074686520';
wwv_flow_imp.g_varchar2_table(36676) := '68616E6420746F6F6C223A2278222C22416374697661746520746865206C6173736F20746F6F6C223A2278222C224163746976697479207265666572656E6365223A2278222C2241642D686F63223A2278222C22416464206C616E652061626F7665223A';
wwv_flow_imp.g_varchar2_table(36677) := '2278222C22416464206C616E652062656C6F77223A2278222C22416464207465787420616E6E6F746174696F6E223A2278222C224166746572204D65726765223A2278222C224166746572205461736B223A2278222C22416C69676E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(36678) := '73223A2278222C22416C69676E20656C656D656E747320626F74746F6D223A2278222C22416C69676E20656C656D656E74732063656E746572223A2278222C22416C69676E20656C656D656E7473206C656674223A2278222C22416C69676E20656C656D';
wwv_flow_imp.g_varchar2_table(36679) := '656E7473206D6964646C65223A2278222C22416C69676E20656C656D656E7473207269676874223A2278222C22416C69676E20656C656D656E747320746F70223A2278222C22416C6C6F772042696E64696E67223A2278222C22616C7265616479207265';
wwv_flow_imp.g_varchar2_table(36680) := '6E6465726564207B656C656D656E747D223A2278222C224150455820417070726F76616C223A2278222C22415045582050616765223A2278222C224150455820526F6C65223A2278222C22415045582053696D706C6520466F726D223A2278222C224170';
wwv_flow_imp.g_varchar2_table(36681) := '70656E6420636F6D70656E736174696F6E206163746976697479223A2278222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A2278222C22417070656E6420656E64206576656E7422';
wwv_flow_imp.g_varchar2_table(36682) := '3A2278222C22417070656E642067617465776179223A2278222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A2278222C22417070656E64206D65737361676520696E7465726D6564696174652063617463';
wwv_flow_imp.g_varchar2_table(36683) := '68206576656E74223A2278222C22417070656E642072656365697665207461736B223A2278222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A2278222C22417070656E64207461736B223A2278';
wwv_flow_imp.g_varchar2_table(36684) := '222C22417070656E64207465787420616E6E6F746174696F6E223A2278222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A2278222C224170706C69636174696F6E223A2278222C224170706C6963';
wwv_flow_imp.g_varchar2_table(36685) := '6174696F6E204944223A2278222C2241737369676E6D656E74223A2278222C224174746163686D656E74223A2278222C224261636B67726F756E64205461736B2053657373696F6E223A2278222C22424343223A2278222C224265666F7265204576656E';
wwv_flow_imp.g_varchar2_table(36686) := '74223A2278222C224265666F72652053706C6974223A2278222C224265666F7265205461736B223A2278222C2242696E642070616765206974656D7320286465707265636174656429223A2278222C2242696E6420706172616D657465722076616C7565';
wwv_flow_imp.g_varchar2_table(36687) := '73223A2278222C2242696E642070726F63657373207661726961626C6573223A2278222C22426C696E6420636172626F6E20636F707920726563697069656E74287329223A2278222C22426F64792048544D4C223A2278222C22426F6479205465787422';
wwv_flow_imp.g_varchar2_table(36688) := '3A2278222C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A2278222C22427573696E657373205265666572656E63';
wwv_flow_imp.g_varchar2_table(36689) := '65223A2278222C22427573696E6573732072756C65207461736B223A2278222C22427573696E6573732052756C65205461736B223A2278222C22627573696E6573735F726566223A2278222C2243616C6C206163746976697479223A2278222C2243616C';
wwv_flow_imp.g_varchar2_table(36690) := '6C204163746976697479223A2278222C2243616C6C6564204469616772616D223A2278222C2243616E63656C223A2278222C2243616E63656C20626F756E64617279206576656E74223A2278222C2243616E63656C20656E64206576656E74223A227822';
wwv_flow_imp.g_varchar2_table(36691) := '2C22436172626F6E20636F707920726563697069656E74287329223A2278222C2243617465676F72792056616C7565223A2278222C224343223A2278222C224368616E676520656C656D656E74223A2278222C224368616E67652074797065223A227822';
wwv_flow_imp.g_varchar2_table(36692) := '2C22436C656172204361636865223A2278222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A2278222C22436C6F62223A2278222C22436F6465223A2278222C22436F6C6C61626F726174696F6E223A2278222C22';
wwv_flow_imp.g_varchar2_table(36693) := '436F6C6C617073656420506F6F6C223A2278222C22436F6C6C6170736564205375622050726F63657373223A2278222C22436F6C6C656374696F6E223A2278222C22436F6C6C656374696F6E2054797065223A2278222C22436F6D70656E736174652045';
wwv_flow_imp.g_varchar2_table(36694) := '6E64204576656E74223A2278222C22436F6D70656E7361746520496E7465726D656469617465205468726F77204576656E74223A2278222C22436F6D70656E736174696F6E223A2278222C22436F6D70656E736174696F6E20626F756E64617279206576';
wwv_flow_imp.g_varchar2_table(36695) := '656E74223A2278222C22436F6D70656E736174696F6E20656E64206576656E74223A2278222C22436F6D70656E736174696F6E20696E7465726D656469617465207468726F77206576656E74223A2278222C22436F6D70656E736174696F6E2073746172';
wwv_flow_imp.g_varchar2_table(36696) := '74206576656E74223A2278222C22436F6D706C65746564223A2278222C22436F6D706C6574696F6E20436F6E646974696F6E223A2278222C22436F6D706C65782067617465776179223A2278222C22436F6D706C65782047617465776179223A2278222C';
wwv_flow_imp.g_varchar2_table(36697) := '22436F6E646974696F6E223A2278222C22436F6E646974696F6E2054797065223A2278222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A2278222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E';
wwv_flow_imp.g_varchar2_table(36698) := '6F6E2D696E74657272757074696E6729223A2278222C22436F6E646974696F6E616C20666C6F77223A2278222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A2278222C22436F6E646974696F6E616C';
wwv_flow_imp.g_varchar2_table(36699) := '20496E7465726D656469617465204361746368204576656E74223A2278222C22436F6E646974696F6E616C207374617274206576656E74223A2278222C22436F6E646974696F6E616C205374617274204576656E74223A2278222C22436F6E646974696F';
wwv_flow_imp.g_varchar2_table(36700) := '6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C22436F6E6E65637420746F206F7468657220656C656D656E74223A2278222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22';
wwv_flow_imp.g_varchar2_table(36701) := '78222C22436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E223A2278222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A22';
wwv_flow_imp.g_varchar2_table(36702) := '78222C22436F707920627573696E657373207265666572656E6365223A2278222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A2278222C2243';
wwv_flow_imp.g_varchar2_table(36703) := '6F7272656C6174696F6E204B6579223A2278222C22436F7272656C6174696F6E2056616C7565223A2278222C22437265617465207B747970657D223A2278222C224372656174652064617461206F626A656374207265666572656E6365223A2278222C22';
wwv_flow_imp.g_varchar2_table(36704) := '43726561746520646174612073746F7265207265666572656E6365223A2278222C2243726561746520446174614F626A6563745265666572656E6365223A2278222C22437265617465204461746153746F72655265666572656E6365223A2278222C2243';
wwv_flow_imp.g_varchar2_table(36705) := '726561746520656E64206576656E74223A2278222C2243726561746520456E644576656E74223A2278222C2243726561746520657870616E646564207375622D70726F63657373223A2278222C2243726561746520657870616E6465642053756250726F';
wwv_flow_imp.g_varchar2_table(36706) := '63657373223A2278222C224372656174652067617465776179223A2278222C224372656174652047617465776179223A2278222C224372656174652067726F7570223A2278222C224372656174652047726F7570223A2278222C2243726561746520696E';
wwv_flow_imp.g_varchar2_table(36707) := '7465726D6564696174652F626F756E64617279206576656E74223A2278222C2243726561746520496E7465726D6564696174652F426F756E64617279204576656E74223A2278222C22437265617465206E6577202E2E2E223A2278222C22437265617465';
wwv_flow_imp.g_varchar2_table(36708) := '20706F6F6C2F7061727469636970616E74223A2278222C2243726561746520506F6F6C2F5061727469636970616E74223A2278222C22437265617465207374617274206576656E74223A2278222C224372656174652053746172742054696D6572204576';
wwv_flow_imp.g_varchar2_table(36709) := '656E74223A2278222C224372656174652053746172744576656E74223A2278222C22437265617465207461736B223A2278222C22437265617465205461736B223A2278222C22437573746F6D223A2278222C22437573746F6D20457874656E73696F6E22';
wwv_flow_imp.g_varchar2_table(36710) := '3A2278222C224379636C65202849534F203836303129223A2278222C224379636C6520284F7261636C6529223A2278222C2244617461206F626A656374207265666572656E6365223A2278222C2244617461204F626A656374205265666572656E636522';
wwv_flow_imp.g_varchar2_table(36711) := '3A2278222C22446174612073746F7265207265666572656E6365223A2278222C22446174612053746F7265205265666572656E6365223A2278222C22446174612054797065223A2278222C2244617465223A2278222C2244617465202849534F20383630';
wwv_flow_imp.g_varchar2_table(36712) := '3129223A2278222C224461746520284F7261636C6529223A2278222C224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A2278222C224461746520537472696E67223A2278222C2244656661756C74204170';
wwv_flow_imp.g_varchar2_table(36713) := '706C69636174696F6E223A2278222C2244656661756C74204170706C69636174696F6E204944223A2278222C2244656661756C7420666C6F77223A2278222C2244656661756C742050616765223A2278222C2244656661756C742050616765204944223A';
wwv_flow_imp.g_varchar2_table(36714) := '2278222C2244656661756C7420557365726E616D65223A2278222C2244656C657465223A2278222C224465736372697074696F6E223A2278222C2244657461696C73223A2278222C226469616772616D206E6F742070617274206F662062706D6E3A4465';
wwv_flow_imp.g_varchar2_table(36715) := '66696E6974696F6E73223A2278222C224469737472696275746520656C656D656E747320686F72697A6F6E74616C6C79223A2278222C224469737472696275746520656C656D656E747320766572746963616C6C79223A2278222C224469766964652069';
wwv_flow_imp.g_varchar2_table(36716) := '6E746F207468726565206C616E6573223A2278222C2244697669646520696E746F2074776F206C616E6573223A2278222C22446F63756D656E746174696F6E223A2278222C22447565204F6E223A2278222C224475706C696361746520696E636F6D696E';
wwv_flow_imp.g_varchar2_table(36717) := '672073657175656E636520666C6F7773223A2278222C224475706C6963617465206F7574676F696E672073657175656E636520666C6F7773223A2278222C224475726174696F6E202849534F203836303129223A2278222C224475726174696F6E20284F';
wwv_flow_imp.g_varchar2_table(36718) := '7261636C6529223A2278222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C2720666F726D6174223A2278222C22652E672E2032332D4A554E2D';
wwv_flow_imp.g_varchar2_table(36719) := '323032372031343A31303A3030223A2278222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A2278222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B';
wwv_flow_imp.g_varchar2_table(36720) := '70726F70657274797D206E6F742079657420647261776E223A2278222C22456C656D656E7420646F63756D656E746174696F6E223A2278222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C657847';
wwv_flow_imp.g_varchar2_table(36721) := '6174657761793E223A2278222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E223A2278222C22456C656D656E742068617320646973616C6C6F7765642074797065';
wwv_flow_imp.g_varchar2_table(36722) := '203C62706D6E3A5369676E616C53746172744576656E743E223A2278222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A2278222C22456C656D656E74';
wwv_flow_imp.g_varchar2_table(36723) := '204944206973206C6F6E676572207468616E2035302063686172616374657273223A2278222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A2278222C22456C656D656E7420697320616E20696D706C696369742065';
wwv_flow_imp.g_varchar2_table(36724) := '6E64223A2278222C22456C656D656E7420697320616E20696D706C69636974207374617274223A2278222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65223A2278222C22456C656D656E74206973206E6F7420636F6E6E65';
wwv_flow_imp.g_varchar2_table(36725) := '63746564223A2278222C22656C656D656E74207265717569726564223A2278222C22456D61696C20636F6E74656E74223A2278222C22456D61696C206F662074686520726563697069656E74287329223A2278222C22456D61696C206F66207468652073';
wwv_flow_imp.g_varchar2_table(36726) := '656E646572223A2278222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A2278222C22456D70747920706F6F6C2F7061727469636970616E74223A2278222C22456D70747920706F6F6C2F7061';
wwv_flow_imp.g_varchar2_table(36727) := '727469636970616E74202872656D6F76657320636F6E74656E7429223A2278222C22456E64206576656E74223A2278222C22456E64204576656E74223A2278222C22456E64706F696E74223A2278222C22456E74657220637573746F6D20657874656E73';
wwv_flow_imp.g_varchar2_table(36728) := '696F6E73206173204A534F4E223A2278222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A2278222C224572726F72223A2278222C224572726F7220626F756E64617279206576656E74223A227822';
wwv_flow_imp.g_varchar2_table(36729) := '2C224572726F7220656E64206576656E74223A2278222C224572726F7220456E64204576656E74223A2278222C224572726F72207374617274206576656E74223A2278222C22457363616C6174696F6E223A2278222C22457363616C6174696F6E20626F';
wwv_flow_imp.g_varchar2_table(36730) := '756E64617279206576656E74223A2278222C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C22457363616C6174696F6E20656E64206576656E74223A2278222C22457363';
wwv_flow_imp.g_varchar2_table(36731) := '616C6174696F6E20456E64204576656E74223A2278222C22457363616C6174696F6E20696E7465726D656469617465207468726F77206576656E74223A2278222C22457363616C6174696F6E20496E7465726D656469617465205468726F77204576656E';
wwv_flow_imp.g_varchar2_table(36732) := '74223A2278222C22457363616C6174696F6E207374617274206576656E74223A2278222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C224576656E7420426173656420476174';
wwv_flow_imp.g_varchar2_table(36733) := '65776179223A2278222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A2278222C224576656E74205375622050726F63657373223A2278222C224576656E74207375622D70726F63657373223A227822';
wwv_flow_imp.g_varchar2_table(36734) := '2C224576656E742054797065223A2278222C224576656E742D62617365642067617465776179223A2278222C224578636C75646564205374617274696E67205573657273223A2278222C224578636C75646564205573657273223A2278222C224578636C';
wwv_flow_imp.g_varchar2_table(36735) := '75736976652067617465776179223A2278222C224578636C75736976652047617465776179223A2278222C2245786563757461626C65223A2278222C224578656375746520504C2F53514C223A2278222C22457865637574696F6E223A2278222C224578';
wwv_flow_imp.g_varchar2_table(36736) := '70616E64656420706F6F6C2F7061727469636970616E74223A2278222C22457870616E646564205375622050726F63657373223A2278222C2245787072657373696F6E223A2278222C2245787072657373696F6E20284C656761637929223A2278222C22';
wwv_flow_imp.g_varchar2_table(36737) := '45787072657373696F6E2054797065223A2278222C226661696C656420746F20696D706F7274207B656C656D656E747D223A2278222C22666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469';
wwv_flow_imp.g_varchar2_table(36738) := '636970616E7473223A2278222C22466C6F772073706C69747320696D706C696369746C79223A2278222C22466F726D2054656D706C617465223A2278222C22466F726D2054656D706C617465204974656D223A2278222C22466F726D2054656D706C6174';
wwv_flow_imp.g_varchar2_table(36739) := '65204974656D204E616D65223A2278222C22466F726D6174204D61736B223A2278222C22466F726D61744D61736B223A2278222C2246726F6D223A2278222C2246756E6374696F6E20426F6479223A2278222C2246756E6374696F6E20426F647920284C';
wwv_flow_imp.g_varchar2_table(36740) := '656761637929223A2278222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A2278222C2247656E6572616C223A2278222C2247656E6572617465';
wwv_flow_imp.g_varchar2_table(36741) := '2064656661756C74206974656D73223A2278222C22476C6F62616C206572726F72207265666572656E6365223A2278222C22476C6F62616C20657363616C6174696F6E207265666572656E6365223A2278222C22476C6F62616C207369676E616C207265';
wwv_flow_imp.g_varchar2_table(36742) := '666572656E6365223A2278222C2247726F7570223A2278222C2248544D4C2076657273696F6E206F662074686520656D61696C223A2278222C224944223A2278222C224944206D75737420626520756E697175652E223A2278222C22696E20666F726D61';
wwv_flow_imp.g_varchar2_table(36743) := '74204444442048483A4D4D3A5353223A2278222C22696E20666F726D61742059592D4D4D223A2278222C22496E205661726961626C6573223A2278222C22496E2F4F7574204D617070696E67223A2278222C22496E2F4F7574205661726961626C657322';
wwv_flow_imp.g_varchar2_table(36744) := '3A2278222C22496E636C75736976652067617465776179223A2278222C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A2278222C22496E69746961746F72223A2278222C22496E69746961746F72206F66207468697320617070';
wwv_flow_imp.g_varchar2_table(36745) := '726F76616C207461736B223A2278222C22496E70757420436F6C6C656374696F6E223A2278222C22496E70757420456C656D656E74223A2278222C22496E7465726D656469617465207468726F77206576656E74223A2278222C22496E7465726D656469';
wwv_flow_imp.g_varchar2_table(36746) := '617465205468726F77204576656E74223A2278222C22496E74657276616C223A2278222C2249732043616C6C61626C65223A2278222C22497320526F6C65223A2278222C22497320537461727461626C65223A2278222C2249534F223A2278222C224974';
wwv_flow_imp.g_varchar2_table(36747) := '656D223A2278222C224974656D204E616D65223A2278222C224974656D2056616C7565223A2278222C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F72746564223A2278222C';
wwv_flow_imp.g_varchar2_table(36748) := '224A534F4E204F626A656374223A2278222C224C616E65223A2278222C224C61746573742076657273696F6E223A2278222C224C696E6B223A2278222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A2278222C224C69';
wwv_flow_imp.g_varchar2_table(36749) := '6E6B20496E7465726D656469617465204361746368204576656E74223A2278222C224C696E6B20696E7465726D656469617465207468726F77206576656E74223A2278222C224C696E6B20496E7465726D656469617465205468726F77204576656E7422';
wwv_flow_imp.g_varchar2_table(36750) := '3A2278222C224C6F616420646566696E6564207661726961626C6573223A2278222C224C6F6164204A534F4E223A2278222C224C6F616420506172616D6574657273223A2278222C224C6F6F70223A2278222C224D61696C223A2278222C224D616E7561';
wwv_flow_imp.g_varchar2_table(36751) := '6C207461736B223A2278222C224D616E75616C205461736B223A2278222C224D61782052756E73223A2278222C224D65737361676520626F756E64617279206576656E74223A2278222C224D65737361676520626F756E64617279206576656E7420286E';
wwv_flow_imp.g_varchar2_table(36752) := '6F6E2D696E74657272757074696E6729223A2278222C224D65737361676520656E64206576656E74223A2278222C224D65737361676520456E64204576656E74223A2278222C224D65737361676520696E7465726D656469617465206361746368206576';
wwv_flow_imp.g_varchar2_table(36753) := '656E74223A2278222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A2278222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A2278222C224D65737361676520496E7465';
wwv_flow_imp.g_varchar2_table(36754) := '726D656469617465205468726F77204576656E74223A2278222C224D657373616765204E616D65223A2278222C224D657373616765207374617274206576656E74223A2278222C224D657373616765205374617274204576656E74223A2278222C224D65';
wwv_flow_imp.g_varchar2_table(36755) := '7373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A2278222C226D6F7265207468616E207B636F756E747D20';
wwv_flow_imp.g_varchar2_table(36756) := '6368696C64206C616E6573223A2278222C224D756C74692D496E7374616E6365223A2278222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A2278222C224E616D65223A2278222C224E';
wwv_flow_imp.g_varchar2_table(36757) := '616D65206F6620746865206469616772616D223A2278222C224E616D65206F66207468652050726F63657373205661726961626C65223A2278222C224E616D65206F66207468652050726F63657373205661726961626C6520286F662074797065205469';
wwv_flow_imp.g_varchar2_table(36758) := '6D657374616D7020776974682054696D65205A6F6E6529223A2278222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C20726573756C7420696E746F223A2278222C224E616D6564207665';
wwv_flow_imp.g_varchar2_table(36759) := '7273696F6E223A2278222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A2278222C226E6F206469616772616D20746F20646973706C6179223A2278222C226E6F20706172656E7420666F72207B';
wwv_flow_imp.g_varchar2_table(36760) := '656C656D656E747D20696E207B706172656E747D223A2278222C226E6F20706C616E6520666F72207B656C656D656E747D223A2278222C226E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A2278222C';
wwv_flow_imp.g_varchar2_table(36761) := '226E6F207368617065207479706520737065636966696564223A2278222C224E756D626572223A2278222C224F6E204576656E74223A2278222C224F7261636C65223A2278222C224F7261636C65205363686564756C652065787072657373696F6E223A';
wwv_flow_imp.g_varchar2_table(36762) := '2278222C226F7574206F6620626F756E64732072656C65617365223A2278222C224F7574205661726961626C6573223A2278222C224F757470757420436F6C6C656374696F6E223A2278222C224F757470757420456C656D656E74223A2278222C224F76';
wwv_flow_imp.g_varchar2_table(36763) := '657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A2278222C2250616765223A2278222C2250616765204944223A2278222C2250616765204974656D20636F6E7461696E696E6720746865';
wwv_flow_imp.g_varchar2_table(36764) := '20666F726D2074656D706C617465207265666572656E6365223A2278222C2250616765204974656D73223A2278222C22506172616C6C656C2067617465776179223A2278222C22506172616C6C656C2047617465776179223A2278222C22506172616C6C';
wwv_flow_imp.g_varchar2_table(36765) := '656C206D756C74692D696E7374616E6365223A2278222C225061727469636970616E74223A2278222C225061727469636970616E74204944223A2278222C225061727469636970616E74206D756C7469706C6963697479223A2278222C22506172746963';
wwv_flow_imp.g_varchar2_table(36766) := '6970616E74204E616D65223A2278222C225061796C6F6164223A2278222C225061796C6F6164205661726961626C65223A2278222C22504C2F53514C223A2278222C22504C2F53514C20436F6465223A2278222C22504C2F53514C204578707265737369';
wwv_flow_imp.g_varchar2_table(36767) := '6F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A2278222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A2278222C22504C2F53514C2045787072657373696F6E20';
wwv_flow_imp.g_varchar2_table(36768) := '72657475726E696E672061206E756D6265722076616C7565223A2278222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2278222C22504C';
wwv_flow_imp.g_varchar2_table(36769) := '2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A2278222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F72';
wwv_flow_imp.g_varchar2_table(36770) := '6D617420595959592D4D4D2D444420484832343A4D493A5353223A2278222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D4444204848';
wwv_flow_imp.g_varchar2_table(36771) := '32343A4D493A535320545A52223A2278222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A2278222C22504C2F53514C20457870726573';
wwv_flow_imp.g_varchar2_table(36772) := '73696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A2278222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A2278222C2250';
wwv_flow_imp.g_varchar2_table(36773) := '4C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120646174652076616C7565223A2278222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A2278222C';
wwv_flow_imp.g_varchar2_table(36774) := '22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2278222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E';
wwv_flow_imp.g_varchar2_table(36775) := '6720612076617263686172322076616C7565223A2278222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D';
wwv_flow_imp.g_varchar2_table(36776) := '493A5353223A2278222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A2278222C';
wwv_flow_imp.g_varchar2_table(36777) := '22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A2278222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E69';
wwv_flow_imp.g_varchar2_table(36778) := '6E672054696D657374616D7020776974682054696D65205A6F6E65223A2278222C22506C616365686F6C646572223A2278222C22506F74656E7469616C2047726F757073223A2278222C22506F74656E7469616C205374617274657273223A2278222C22';
wwv_flow_imp.g_varchar2_table(36779) := '506F74656E7469616C205374617274696E672047726F757073223A2278222C22506F74656E7469616C205374617274696E67205573657273223A2278222C22506F74656E7469616C205573657273223A2278222C225072696F72697479223A2278222C22';
wwv_flow_imp.g_varchar2_table(36780) := '50726F63657373223A2278222C2250726F6365737320646F63756D656E746174696F6E223A2278222C2250726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A2278222C2250726F63657373204944223A';
wwv_flow_imp.g_varchar2_table(36781) := '2278222C2250726F63657373206973206D697373696E6720656E64206576656E74223A2278222C2250726F63657373206973206D697373696E67207374617274206576656E74223A2278222C2250726F63657373206E616D65223A2278222C2250726F63';
wwv_flow_imp.g_varchar2_table(36782) := '657373205072696F72697479223A2278222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E223A2278222C2250726F63657373205661726961626C65223A2278222C2250726F63657373205661726961626C65202841';
wwv_flow_imp.g_varchar2_table(36783) := '7272617929223A2278222C2250726F63657373205661726961626C6520284C69737429223A2278222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A2278222C2252656365697665207461736B223A2278222C';
wwv_flow_imp.g_varchar2_table(36784) := '2252656365697665205461736B223A2278222C225265646F223A2278222C2252656D6F7665223A2278222C225265706C7920546F223A2278222C2252657175657374223A2278222C22526571756573742056616C756520666F7220506167652043616C6C';
wwv_flow_imp.g_varchar2_table(36785) := '223A2278222C22526573756C74205661726961626C65223A2278222C2252657475726E205061796C6F616420496E746F223A2278222C22526F6C65223A2278222C2253617665223A2278222C225363686564756C65722045787072657373696F6E223A22';
wwv_flow_imp.g_varchar2_table(36786) := '78222C225363686564756C696E67223A2278222C22536372697074207461736B223A2278222C22536372697074205461736B223A2278222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A2278222C2253';
wwv_flow_imp.g_varchar2_table(36787) := '656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A2278222C2253656E6420456D61696C20496D6D6564696174656C79223A2278222C2253656E64204D61';
wwv_flow_imp.g_varchar2_table(36788) := '696C223A2278222C2253656E64207461736B223A2278222C2253656E64205461736B223A2278222C2253657175656E6365223A2278222C2253657175656E636520666C6F77223A2278222C2253657175656E6365466C6F772069732061206475706C6963';
wwv_flow_imp.g_varchar2_table(36789) := '617465223A2278222C2253657175656E7469616C206D756C74692D696E7374616E6365223A2278222C2253657276696365207461736B223A2278222C2253657276696365205461736B223A2278222C2253657420636F6C6F72223A2278222C225369676E';
wwv_flow_imp.g_varchar2_table(36790) := '616C223A2278222C225369676E616C20626F756E64617279206576656E74223A2278222C225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C225369676E616C20656E64206576656E74';
wwv_flow_imp.g_varchar2_table(36791) := '223A2278222C225369676E616C20456E64204576656E74223A2278222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A2278222C225369676E616C20496E7465726D656469617465204361746368204576656E7422';
wwv_flow_imp.g_varchar2_table(36792) := '3A2278222C225369676E616C20696E7465726D656469617465207468726F77206576656E74223A2278222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A2278222C225369676E616C207374617274206576656E74';
wwv_flow_imp.g_varchar2_table(36793) := '223A2278222C225369676E616C205374617274204576656E74223A2278222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C2253696D706C65204D657373616765223A2278222C2253514C';
wwv_flow_imp.g_varchar2_table(36794) := '207175657279223A2278222C2253514C205175657279223A2278222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69737429223A2278222C2253514C20717565727920284A534F4E20617272617929223A2278222C2253514C';
wwv_flow_imp.g_varchar2_table(36795) := '207175657279202873696E676C652076616C756529223A2278222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A2278222C2253514C2071756572792072657475726E696E672061204A';
wwv_flow_imp.g_varchar2_table(36796) := '534F4E206172726179223A2278222C2253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C7565223A2278222C2253514C2071756572792072657475726E696E6720612073696E676C65206E756D626572207661';
wwv_flow_imp.g_varchar2_table(36797) := '6C7565223A2278222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2278222C2253514C2071756572792072657475726E696E672061207369';
wwv_flow_imp.g_varchar2_table(36798) := '6E676C652076617263686172322076616C7565223A2278222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A2278222C2253514C20717565727920746F2067657420617474616368';
wwv_flow_imp.g_varchar2_table(36799) := '6D656E74223A2278222C225374617274206576656E74223A2278222C225374617274204576656E74223A2278222C225374617274206576656E74206973206D697373696E67206576656E7420646566696E6974696F6E223A2278222C2253746172742065';
wwv_flow_imp.g_varchar2_table(36800) := '76656E74206D75737420626520626C616E6B223A2278222C22537461746963223A2278222C2253746174696320646174652076616C7565223A2278222C22537461746963204944223A2278222C22537461746963206E756D6265722076616C7565223A22';
wwv_flow_imp.g_varchar2_table(36801) := '78222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A2278222C225374617469632076617263686172322076616C7565223A2278222C22537472696E67223A2278222C225375622070726F63657373';
wwv_flow_imp.g_varchar2_table(36802) := '20686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A2278222C225375622070726F63657373206973206D697373696E6720656E64206576656E74223A2278222C225375622070726F63657373206973206D697373696E67';
wwv_flow_imp.g_varchar2_table(36803) := '207374617274206576656E74223A2278222C225375622D70726F63657373223A2278222C225375622D70726F636573732028636F6C6C617073656429223A2278222C225375622D70726F636573732028657870616E64656429223A2278222C225375626A';
wwv_flow_imp.g_varchar2_table(36804) := '656374223A2278222C225461736B223A2278222C225461736B20446566696E6974696F6E223A2278222C225461736B20537461746963204944223A2278222C225461736B2054797065223A2278222C2254656D706C617465223A2278222C2254656D706C';
wwv_flow_imp.g_varchar2_table(36805) := '617465204944223A2278222C225465726D696E61746520656E64206576656E74223A2278222C225465726D696E61746520456E64204576656E74223A2278222C225465726D696E61746564223A2278222C2254657874223A2278222C2254696D6520756E';
wwv_flow_imp.g_varchar2_table(36806) := '74696C207468652074696D657220666972657320616761696E223A2278222C2254696D6520756E74696C207468652074696D6572206669726573206669727374223A2278222C2254696D6572223A2278222C2254696D657220626F756E64617279206576';
wwv_flow_imp.g_varchar2_table(36807) := '656E74223A2278222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C2254696D657220446566696E6974696F6E223A2278222C2254696D657220446566696E6974696F6E2054797065';
wwv_flow_imp.g_varchar2_table(36808) := '223A2278222C2254696D6572204475726174696F6E223A2278222C2254696D657220696E7465726D656469617465206361746368206576656E74223A2278222C2254696D657220496E7465726D656469617465204361746368204576656E74223A227822';
wwv_flow_imp.g_varchar2_table(36809) := '2C2254696D6572207374617274206576656E74223A2278222C2254696D6572205374617274204576656E74223A2278222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A2278222C2254696D65737461';
wwv_flow_imp.g_varchar2_table(36810) := '6D7020776974682054696D65205A6F6E65223A2278222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D6174223A2278222C22546F223A2278222C22546F67676C6520';
wwv_flow_imp.g_varchar2_table(36811) := '6E6F6E2D696E74657272757074696E67223A2278222C225472616E73616374696F6E223A2278222C22556E646F223A2278222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A2278222C22756E72';
wwv_flow_imp.g_varchar2_table(36812) := '65636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A2278222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F';
wwv_flow_imp.g_varchar2_table(36813) := '74456C656D656E747D223A2278222C225573652041504558206D6574612064617461223A2278222C225573652054656D706C617465223A2278222C2255736564206469616772616D2076657273696F6E223A2278222C2255736572207461736B223A2278';
wwv_flow_imp.g_varchar2_table(36814) := '222C2255736572205461736B223A2278222C2256616C7565223A2278222C225661726368617232223A2278222C225661726961626C652045787072657373696F6E73223A2278222C2256657273696F6E204E616D65223A2278222C2256657273696F6E69';
wwv_flow_imp.g_varchar2_table(36815) := '6E67223A2278222C225761697420666F7220636F6D706C6574696F6E223A2278222C225A6F6F6D20496E223A2278222C225A6F6F6D204F7574223A2278227D27297D2C383133323A653D3E7B2275736520737472696374223B652E6578706F7274733D4A';
wwv_flow_imp.g_varchar2_table(36816) := '534F4E2E706172736528277B227B6572726F72737D204572726F72732C207B7761726E696E67737D205761726E696E6773223A227B6572726F72737D20E99499E8AFAFEFBC8C7B7761726E696E67737D20E8ADA6E5918A222C227B73656D616E7469637D';
wwv_flow_imp.g_varchar2_table(36817) := '237B736964657D20526566206E6F7420737065636966696564223A22E69CAAE68C87E5AE9A207B73656D616E7469637D237B736964657D20E58F82E88083222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312DE7B4A7E6';
wwv_flow_imp.g_varchar2_table(36818) := '80A5222C22322D48696768223A22322DE9AB98222C22332D4D656469756D223A22332DE4B8AD222C22342D4C6F77223A22342DE4BD8E222C22352D4C6F77657374223A22352DE69C80E4BD8E222C224120676174657761792073686F756C64206E6F7420';
wwv_flow_imp.g_varchar2_table(36819) := '6D6572676520616E642073706C6974206174207468652073616D652074696D65223A22E7BD91E585B3E4B88DE883BDE5908CE697B6E59088E5B9B6E5928CE68B86E58886222C224163746976617465206372656174652F72656D6F766520737061636520';
wwv_flow_imp.g_varchar2_table(36820) := '746F6F6C223A22E590AFE58AA8E5889BE5BBBA2FE588A0E999A4E7A9BAE997B4E5B7A5E585B7222C22416374697661746520676C6F62616C20636F6E6E65637420746F6F6C223A22E590AFE58AA8E585A8E5B180E8BF9EE68EA5E5B7A5E585B7222C2241';
wwv_flow_imp.g_varchar2_table(36821) := '637469766174652068616E6420746F6F6C223A22E590AFE58AA8E6898BE58AA8E5B7A5E585B7222C224163746976617465206C6173736F20746F6F6C223A22E590AFE58AA8204C6173736F20E5B7A5E585B7222C22416374697661746520746865206372';
wwv_flow_imp.g_varchar2_table(36822) := '656174652F72656D6F766520737061636520746F6F6C223A22E6BF80E6B4BBE5889BE5BBBA2FE588A0E999A4E7A9BAE997B4E5B7A5E585B7222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A22E6BF80E6B4BB';
wwv_flow_imp.g_varchar2_table(36823) := 'E585A8E5B180E8BF9EE68EA5E5B7A5E585B7222C224163746976617465207468652068616E6420746F6F6C223A22E6BF80E6B4BBE6898BE5BDA2E5B7A5E585B7222C22416374697661746520746865206C6173736F20746F6F6C223A22E6BF80E6B4BB20';
wwv_flow_imp.g_varchar2_table(36824) := '6C6173736F20E5B7A5E585B7222C224163746976697479207265666572656E6365223A22E6B4BBE58AA8E58F82E88083222C2241642D686F63223A22E4B8B4E697B6222C22416464206C616E652061626F7665223A22E59CA8E4B88AE696B9E6B7BBE58A';
wwv_flow_imp.g_varchar2_table(36825) := 'A0E9809AE98193222C22416464206C616E652062656C6F77223A22E59CA8E4B88BE696B9E6B7BBE58AA0E9809AE98193222C22416464207465787420616E6E6F746174696F6E223A22E6B7BBE58AA0E69687E69CACE6B3A8E9878A222C22416674657220';
wwv_flow_imp.g_varchar2_table(36826) := '4D65726765223A22E59088E5B9B6E4B98BE5908E222C224166746572205461736B223A22E4BBBBE58AA1E4B98BE5908E222C22416C69676E20656C656D656E747320626F74746F6D223A22E5B086E58583E7B4A0E5BA95E983A8E5AFB9E9BD90222C2241';
wwv_flow_imp.g_varchar2_table(36827) := '6C69676E20656C656D656E74732063656E746572223A22E4BDBFE58583E7B4A0E5B185E4B8ADE5AFB9E9BD90222C22416C69676E20656C656D656E7473206C656674223A22E5B086E58583E7B4A0E59091E5B7A6E5AFB9E9BD90222C22416C69676E2065';
wwv_flow_imp.g_varchar2_table(36828) := '6C656D656E7473206D6964646C65223A22E5B086E58583E7B4A0E4B8ADE997B4E5AFB9E9BD90222C22416C69676E20656C656D656E7473207269676874223A22E5B086E58583E7B4A0E59091E58FB3E5AFB9E9BD90222C22416C69676E20656C656D656E';
wwv_flow_imp.g_varchar2_table(36829) := '747320746F70223A22E5B086E58583E7B4A0E9A1B6E983A8E5AFB9E9BD90222C22416C69676E20656C656D656E7473223A22E68E92E58897E58583E7B4A0222C22416C6C6F772042696E64696E67223A22E58581E8AEB8E7BB91E5AE9A222C22616C7265';
wwv_flow_imp.g_varchar2_table(36830) := '6164792072656E6465726564207B656C656D656E747D223A22E5B7B2E59188E78EB0207B656C656D656E747D222C224150455820417070726F76616C223A224150455820E5AEA1E689B9222C22415045582050616765223A224150455820E9A1B5222C22';
wwv_flow_imp.g_varchar2_table(36831) := '4150455820526F6C65223A224150455820E79A84E4BD9CE794A8222C22415045582053696D706C6520466F726D223A224150455820E7AE80E58D95E8A1A8E58D95222C22417070656E6420636F6D70656E736174696F6E206163746976697479223A22E9';
wwv_flow_imp.g_varchar2_table(36832) := '9984E58AA0E896AAE985ACE6B4BBE58AA8222C22417070656E6420636F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22E6B7BBE58AA0E4B8ADE997B4E69DA1E4BBB6E68D95E88EB7E4BA8BE4BBB6222C2241';
wwv_flow_imp.g_varchar2_table(36833) := '7070656E6420656E64206576656E74223A22E6B7BBE58AA0E7BB93E69D9FE4BA8BE4BBB6222C22417070656E642067617465776179223A22E6B7BBE58AA0E7BD91E585B3222C22417070656E6420696E7465726D6564696174652F626F756E6461727920';
wwv_flow_imp.g_varchar2_table(36834) := '6576656E74223A22E6B7BBE58AA0E4B8ADE997B42FE8BEB9E7958CE4BA8BE4BBB6222C22417070656E64206D65737361676520696E7465726D656469617465206361746368206576656E74223A22E6B7BBE58AA0E6B688E681AFE4B8ADE997B4E68D95E8';
wwv_flow_imp.g_varchar2_table(36835) := '8EB7E4BA8BE4BBB6222C22417070656E642072656365697665207461736B223A22E6B7BBE58AA0E68EA5E694B6E4BBBBE58AA1222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A22E6B7BBE58A';
wwv_flow_imp.g_varchar2_table(36836) := 'A0E4BFA1E58FB7E4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C22417070656E64207461736B223A22E6B7BBE58AA0E4BBBBE58AA1222C22417070656E64207465787420616E6E6F746174696F6E223A22E99984E58AA0E69687E69CACE6B3A8E9878A';
wwv_flow_imp.g_varchar2_table(36837) := '222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A22E6B7BBE58AA0E5AE9AE697B6E599A8E4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C224170706C69636174696F6E204944223A22E5BA94E7';
wwv_flow_imp.g_varchar2_table(36838) := '94A84944222C224170706C69636174696F6E223A22E5BA94E794A8E7A88BE5BA8F222C2241737369676E6D656E74223A22E4BBBBE58AA1222C224174746163686D656E74223A22E99984E4BBB6222C224261636B67726F756E64205461736B2053657373';
wwv_flow_imp.g_varchar2_table(36839) := '696F6E223A22E5908EE58FB0E4BBBBE58AA1E4BC9AE8AF9D222C22424343223A22E5AF86E4BBB6E68A84E98081222C224265666F7265204576656E74223A22E6B4BBE58AA8E5898D222C224265666F72652053706C6974223A22E58886E589B2E4B98BE5';
wwv_flow_imp.g_varchar2_table(36840) := '898D222C224265666F7265205461736B223A22E4BBBBE58AA1E4B98BE5898D222C2242696E642070616765206974656D7320286465707265636174656429223A22E7BB91E5AE9AE9A1B5E99DA2E9A1B9E79BAEEFBC88E5B7B2E5BC83E794A8EFBC89222C';
wwv_flow_imp.g_varchar2_table(36841) := '2242696E6420706172616D657465722076616C756573223A22E7BB91E5AE9AE58F82E695B0E580BC222C2242696E642070726F63657373207661726961626C6573223A22E7BB91E5AE9AE8BF87E7A88BE58F98E9878F222C22426C696E6420636172626F';
wwv_flow_imp.g_varchar2_table(36842) := '6E20636F707920726563697069656E74287329223A22E99A90E894BDE7A2B3E5A48DE588B6E694B6E4BBB6E4BABA222C22426F64792048544D4C223A22E6ADA3E696872048544D4C222C22426F64792054657874223A22E6ADA3E69687E69687E69CAC22';
wwv_flow_imp.g_varchar2_table(36843) := '2C22426F756E64617279206576656E7473206F6E20697465726174696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A22E5BD93E5898DE4B88DE694AFE68C81E8BFADE4BBA3E5AD90E8';
wwv_flow_imp.g_varchar2_table(36844) := 'BF9BE7A88BE4B88AE79A84E8BEB9E7958CE4BA8BE4BBB6222C22427573696E657373205265666572656E6365223A22E4B89AE58AA1E58F82E88083222C22427573696E6573732052756C65205461736B223A22E4B89AE58AA1E8A784E58899E4BBBBE58A';
wwv_flow_imp.g_varchar2_table(36845) := 'A1222C22427573696E6573732072756C65207461736B223A22E8A784E58899E4BBBBE58AA1222C22627573696E6573735F726566223A22627573696E6573735F726566222C2243616C6C204163746976697479223A22E591BCE58FABE6B4BBE58AA8222C';
wwv_flow_imp.g_varchar2_table(36846) := '2243616C6C206163746976697479223A22E5BC95E794A8E6B581E7A88B222C2243616C6C6564204469616772616D223A22E8B083E794A8E79A84E59BBEE8A1A8222C2243616E63656C20626F756E64617279206576656E74223A22E58F96E6B688E8BEB9';
wwv_flow_imp.g_varchar2_table(36847) := 'E7958CE4BA8BE4BBB6222C2243616E63656C20656E64206576656E74223A22E58F96E6B688E7BB93E69D9FE4BA8BE4BBB6222C2243616E63656C223A22E58F96E6B688222C22436172626F6E20636F707920726563697069656E74287329223A22E7A2B3';
wwv_flow_imp.g_varchar2_table(36848) := 'E5A48DE588B6E694B6E4BBB6E4BABA222C2243617465676F72792056616C7565223A22E7B1BBE588ABE580BC222C224343223A22E68A84E98081222C224368616E676520656C656D656E74223A22E58F98E58C96E59BA0E7B4A0222C224368616E676520';
wwv_flow_imp.g_varchar2_table(36849) := '74797065223A22E69BB4E694B9E7B1BBE59E8B222C22436C6561722043616368652056616C756520666F7220506167652043616C6C223A22E6B885E999A4E9A1B5E8B083E794A8E79A84E9AB98E9809FE7BC93E5AD98E580BC222C22436C656172204361';
wwv_flow_imp.g_varchar2_table(36850) := '636865223A22E6B885E999A4E7BC93E5AD98222C22436C6F62223A22436C6F62222C22436F6465223A22E4BBA3E7A081222C22436F6C6C61626F726174696F6E223A22E58D8FE4BD9C222C22436F6C6C617073656420506F6F6C223A22E68A98E58FA0E6';
wwv_flow_imp.g_varchar2_table(36851) := 'B1A0222C22436F6C6C6170736564205375622050726F63657373223A22E5B7B2E68A98E58FA0E5AD90E6B581E7A88B222C22436F6C6C656374696F6E2054797065223A22E694B6E99B86E7B1BBE59E8B222C22436F6C6C656374696F6E223A22E694B6E8';
wwv_flow_imp.g_varchar2_table(36852) := '978FE99B86222C22436F6D70656E7361746520456E64204576656E74223A22E8A1A5E581BFE7BB93E69D9FE4BA8BE4BBB6222C22436F6D70656E7361746520496E7465726D656469617465205468726F77204576656E74223A22E8A1A5E581BFE4B8ADE9';
wwv_flow_imp.g_varchar2_table(36853) := '97B4E5BC95E58F91E4BA8BE4BBB6222C22436F6D70656E736174696F6E20626F756E64617279206576656E74223A22E8A1A5E581BFE8BEB9E7958CE4BA8BE4BBB6222C22436F6D70656E736174696F6E20656E64206576656E74223A22E7BB93E69D9FE8';
wwv_flow_imp.g_varchar2_table(36854) := 'A1A5E581BFE4BA8BE4BBB6222C22436F6D70656E736174696F6E20696E7465726D656469617465207468726F77206576656E74223A22E4B8ADE997B4E8A1A5E581BFE68A9BE587BAE4BA8BE4BBB6222C22436F6D70656E736174696F6E20737461727420';
wwv_flow_imp.g_varchar2_table(36855) := '6576656E74223A22E8A1A5E581BFE590AFE58AA8E4BA8BE4BBB6222C22436F6D70656E736174696F6E223A22E896AAE985AC222C22436F6D706C65746564223A22E5B7B2E5AE8CE68890222C22436F6D706C6574696F6E20436F6E646974696F6E223A22';
wwv_flow_imp.g_varchar2_table(36856) := 'E5AE8CE68890E69DA1E4BBB6222C22436F6D706C65782067617465776179223A22E5A48DE69D82E7BD91E585B3222C22436F6D706C65782047617465776179223A22E5A48DE69D82E7BD91E585B3222C22436F6E646974696F6E2054797065223A22E69D';
wwv_flow_imp.g_varchar2_table(36857) := 'A1E4BBB6E7B1BBE59E8B222C22436F6E646974696F6E223A22E69DA1E4BBB6222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E69DA1E4BBB6E8BEB9E7958CE4BA8BE4BBB6';
wwv_flow_imp.g_varchar2_table(36858) := '2028E99D9EE4B8ADE696AD29222C22436F6E646974696F6E616C20626F756E64617279206576656E74223A22E69DA1E4BBB6E8BEB9E7958CE4BA8BE4BBB6222C22436F6E646974696F6E616C20666C6F77223A22E69DA1E4BBB6E6B581222C22436F6E64';
wwv_flow_imp.g_varchar2_table(36859) := '6974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22E4B8ADE997B4E69DA1E4BBB6E68D95E88EB7E4BA8BE4BBB6222C22436F6E646974696F6E616C20496E7465726D656469617465204361746368204576656E74223A';
wwv_flow_imp.g_varchar2_table(36860) := '22E69DA1E4BBB6E4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E69DA1E4BBB6E590AFE58AA8E4BA8BE4BBB62028E99D9EE4B8ADE6';
wwv_flow_imp.g_varchar2_table(36861) := '96AD29222C22436F6E646974696F6E616C207374617274206576656E74223A22E69DA1E4BBB6E590AFE58AA8E4BA8BE4BBB6222C22436F6E646974696F6E616C205374617274204576656E74223A22E69DA1E4BBB6E5BC80E5A78BE4BA8BE4BBB6222C22';
wwv_flow_imp.g_varchar2_table(36862) := '436F6E6E65637420746F206F7468657220656C656D656E74223A22E8BF9EE68EA5E588B0E585B6E4BB96E58583E7B4A0222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22E69687E69CACE585B3E88194222C22436F6E6E6563';
wwv_flow_imp.g_varchar2_table(36863) := '74207573696E67206461746120696E707574206173736F63696174696F6E223A22E695B0E68DAEE585B3E88194222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77206F72206173736F63696174696F6E223A';
wwv_flow_imp.g_varchar2_table(36864) := '22E6B688E681AFE585B3E88194222C22436F707920627573696E657373207265666572656E6365223A22E5A48DE588B6E4B89AE58AA1E58F82E88083222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C';
wwv_flow_imp.g_varchar2_table(36865) := '616E657D20746F207B726F6F74456C656D656E747D223A22E6ADA3E59CA8E5B086207B706C616E657D20E4B88AE7BCBAE5B091E79A842062706D6E456C656D656E7420E69BB4E6ADA3E4B8BA207B726F6F74456C656D656E747D222C22436F7272656C61';
wwv_flow_imp.g_varchar2_table(36866) := '74696F6E204B6579223A22E585B3E88194E994AE222C22436F7272656C6174696F6E2056616C7565223A22E79BB8E585B3E580BC222C22437265617465207B747970657D223A22E5889BE5BBBA207B747970657D222C224372656174652064617461206F';
wwv_flow_imp.g_varchar2_table(36867) := '626A656374207265666572656E6365223A22E5889BE5BBBAE695B0E68DAEE5AFB9E8B1A1E5BC95E794A8222C2243726561746520646174612073746F7265207265666572656E6365223A22E5889BE5BBBAE695B0E68DAEE5AD98E582A8E5BC95E794A822';
wwv_flow_imp.g_varchar2_table(36868) := '2C2243726561746520446174614F626A6563745265666572656E6365223A22E5889BE5BBBA20446174614F626A6563745265666572656E6365222C22437265617465204461746153746F72655265666572656E6365223A22E5889BE5BBBA204461746153';
wwv_flow_imp.g_varchar2_table(36869) := '746F72655265666572656E6365222C2243726561746520656E64206576656E74223A22E5889BE5BBBAE7BB93E69D9FE4BA8BE4BBB6222C2243726561746520456E644576656E74223A22E5889BE5BBBA20456E644576656E74222C224372656174652065';
wwv_flow_imp.g_varchar2_table(36870) := '7870616E646564207375622D70726F63657373223A22E5889BE5BBBAE58FAFE68A98E58FA0E5AD90E6B581E7A88B222C2243726561746520657870616E6465642053756250726F63657373223A22E5889BE5BBBAE5B195E5BC80E79A842053756250726F';
wwv_flow_imp.g_varchar2_table(36871) := '63657373222C224372656174652067617465776179223A22E5889BE5BBBAE7BD91E585B3222C224372656174652047617465776179223A22E5889BE5BBBAE7BD91E585B3222C224372656174652067726F7570223A22E5889BE5BBBAE7BB84222C224372';
wwv_flow_imp.g_varchar2_table(36872) := '656174652047726F7570223A22E5889BE5BBBAE7BB84222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A22E5889BE5BBBAE4B8ADE997B42FE8BEB9E7958CE4BA8BE4BBB6222C2243726561746520496E74';
wwv_flow_imp.g_varchar2_table(36873) := '65726D6564696174652F426F756E64617279204576656E74223A22E5889BE5BBBAE4B8ADE997B42FE8BEB9E7958CE4BA8BE4BBB6222C22437265617465206E6577202E2E2E223A22E5889BE5BBBAE696B0202E2E2E222C2243726561746520706F6F6C2F';
wwv_flow_imp.g_varchar2_table(36874) := '7061727469636970616E74223A22E5889BE5BBBAE6B1A02FE58F82E4B88EE88085222C2243726561746520506F6F6C2F5061727469636970616E74223A22E5889BE5BBBAE6B1A02FE58F82E4B88EE88085222C2243726561746520737461727420657665';
wwv_flow_imp.g_varchar2_table(36875) := '6E74223A22E5889BE5BBBAE5BC80E5A78BE4BA8BE4BBB6222C224372656174652053746172742054696D6572204576656E74223A22E5889BE5BBBAE5BC80E5A78BE8AEA1E697B6E599A8E4BA8BE4BBB6222C224372656174652053746172744576656E74';
wwv_flow_imp.g_varchar2_table(36876) := '223A22E5889BE5BBBA2053746172744576656E74222C22437265617465207461736B223A22E5889BE5BBBAE4BBBBE58AA1222C22437265617465205461736B223A22E5889BE5BBBAE4BBBBE58AA1222C22437573746F6D20457874656E73696F6E223A22';
wwv_flow_imp.g_varchar2_table(36877) := 'E887AAE5AE9AE4B989E689A9E5B195222C22437573746F6D223A22E5AE9AE588B6222C224379636C65202849534F203836303129223A22E591A8E69C9F202849534F203836303129222C224379636C6520284F7261636C6529223A22E591A8E69C9F2028';
wwv_flow_imp.g_varchar2_table(36878) := '4F7261636C6529222C2244617461204F626A656374205265666572656E6365223A22E695B0E68DAEE5AFB9E8B1A1E58F82E88083222C2244617461206F626A656374207265666572656E6365223A22E695B0E68DAEE5AFB9E8B1A1E5BC95E794A8222C22';
wwv_flow_imp.g_varchar2_table(36879) := '446174612053746F7265205265666572656E6365223A22E695B0E68DAEE5AD98E582A8E58F82E88083222C22446174612073746F7265207265666572656E6365223A22E695B0E68DAEE5AD98E582A8E5BC95E794A8222C22446174612054797065223A22';
wwv_flow_imp.g_varchar2_table(36880) := 'E695B0E68DAEE7B1BBE59E8B222C2244617465202849534F203836303129223A22E697A5E69C9F202849534F203836303129222C224461746520284F7261636C6529223A22E697A5E69C9F20284F7261636C6529222C224461746520696E20666F726D61';
wwv_flow_imp.g_varchar2_table(36881) := '7420595959592D4D4D2D444420484832343A4D493A5353223A22E697A5E69C9FE6A0BCE5BC8F20595959592D4D4D2D44442048483234EFBC9A4D493A5353222C224461746520537472696E67223A22E697A5E69C9FE5AD97E7ACA6E4B8B2222C22446174';
wwv_flow_imp.g_varchar2_table(36882) := '65223A22E697A5E69C9F222C2244656661756C74204170706C69636174696F6E204944223A22E9BB98E8AEA4E79A84E5BA94E794A8E7A88BE5BA8F4944222C2244656661756C74204170706C69636174696F6E223A22E9BB98E8AEA4E5BA94E794A8E7A8';
wwv_flow_imp.g_varchar2_table(36883) := '8BE5BA8F222C2244656661756C7420666C6F77223A22E9BB98E8AEA4E6B581222C2244656661756C742050616765204944223A22E9BB98E8AEA4E79A84E9A1B5E99DA24944222C2244656661756C742050616765223A22E9BB98E8AEA4E9A1B5E99DA222';
wwv_flow_imp.g_varchar2_table(36884) := '2C2244656661756C7420557365726E616D65223A22E9BB98E8AEA4E794A8E688B7E5908D222C2244656C657465223A22E588A0E999A4222C224465736372697074696F6E223A22E8AFB4E6988E222C2244657461696C73223A22E8AFA6E7BB86E4BFA1E6';
wwv_flow_imp.g_varchar2_table(36885) := '81AF222C226469616772616D206E6F742070617274206F662062706D6E3A446566696E6974696F6E73223A22E59BBEE4B8ADE4B88DE58C85E590AB2062706D6EEFBC9AE5AE9AE4B989222C224469737472696275746520656C656D656E747320686F7269';
wwv_flow_imp.g_varchar2_table(36886) := '7A6F6E74616C6C79223A22E6A8AAE59091E58886E5B883E58583E7B4A0222C224469737472696275746520656C656D656E747320766572746963616C6C79223A22E7BAB5E59091E58886E5B883E58583E7B4A0222C2244697669646520696E746F207468';
wwv_flow_imp.g_varchar2_table(36887) := '726565206C616E6573223A22E58886E68890E4B889E69DA1E9809AE98193222C2244697669646520696E746F2074776F206C616E6573223A22E58886E68890E4B8A4E69DA1E9809AE98193222C22446F63756D656E746174696F6E223A22E69687E6A1A3';
wwv_flow_imp.g_varchar2_table(36888) := '222C22447565204F6E223A22E588B0E69C9FE697A5222C224475706C696361746520696E636F6D696E672073657175656E636520666C6F7773223A22E4BCA0E585A5E5BA8FE58897E6B581E9878DE5A48D222C224475706C6963617465206F7574676F69';
wwv_flow_imp.g_varchar2_table(36889) := '6E672073657175656E636520666C6F7773223A22E9878DE5A48DE79A84E4BCA0E587BAE5BA8FE58897E6B581222C224475726174696F6E202849534F203836303129223A22E68C81E7BBADE697B6E997B4202849534F203836303129222C224475726174';
wwv_flow_imp.g_varchar2_table(36890) := '696F6E20284F7261636C6529223A22E68C81E7BBADE697B6E997B420284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C2744444420484832343A4D493A53535C27';
wwv_flow_imp.g_varchar2_table(36891) := '20666F726D6174223A2249534F2038363031E688964F7261636C65E997B4E99A944453EFBC88484832343A4D493A5353EFBC89E6A0BCE5BC8FE79A84E68C81E7BBADE697B6E997B4222C22652E672E2032332D4A554E2D323032372031343A31303A3030';
wwv_flow_imp.g_varchar2_table(36892) := '223A22E4BE8BE5A682EFBC9A32303237E5B9B436E69C883233E697A531343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A22E4BE8BE5A682EFBC9A44442D4D4F4E2D59595920484832343A4D493A535322';
wwv_flow_imp.g_varchar2_table(36893) := '2C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E223A22E5B09AE69CAAE7BB98E588B6207B7265666572656E6365647D23';
wwv_flow_imp.g_varchar2_table(36894) := '7B70726F70657274797D20E5BC95E794A8E79A84E58583E7B4A0207B656C656D656E747D222C22456C656D656E7420646F63756D656E746174696F6E223A22E58583E7B4A0E69687E4BBB6222C22456C656D656E742068617320646973616C6C6F776564';
wwv_flow_imp.g_varchar2_table(36895) := '2074797065203C62706D6E3A436F6D706C6578476174657761793E223A22E58583E7B4A0E585B7E69C89E4B88DE58581E8AEB8E79A84E7B1BBE59E8B203C62706D6E3A436F6D706C6578476174657761793E222C22456C656D656E742068617320646973';
wwv_flow_imp.g_varchar2_table(36896) := '616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E223A22E58583E7B4A0E585B7E69C89E4B88DE58581E8AEB8E79A84E7B1BBE59E8B203C62706D6E3A4D65737361676553746172744576656E743E222C22456C';
wwv_flow_imp.g_varchar2_table(36897) := '656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A22E58583E7B4A0E585B7E69C89E4B88DE58581E8AEB8E79A84E7B1BBE59E8B203C62706D6E3A5369676E616C5374617274';
wwv_flow_imp.g_varchar2_table(36898) := '4576656E743E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A22E58583E7B4A0E585B7E69C89E4B88DE58581E8AEB8E79A84E7B1BBE59E8B203C62';
wwv_flow_imp.g_varchar2_table(36899) := '706D6E436F6E646974696F6E616C53746172744576656E743E222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063686172616374657273223A22E58583E7B4A020494420E8B685E8BF8720353020E4B8AAE5AD97E7ACA622';
wwv_flow_imp.g_varchar2_table(36900) := '2C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A22E58583E7B4A020494420E5B09AE69CAAE69BB4E694B9222C22456C656D656E7420697320616E20696D706C6963697420656E64223A22E58583E7B4A0E698AFE99A';
wwv_flow_imp.g_varchar2_table(36901) := '90E5BC8FE7BB93E69D9F222C22456C656D656E7420697320616E20696D706C69636974207374617274223A22E58583E7B4A0E698AFE99A90E5BC8FE5BC80E5A78B222C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65223A22';
wwv_flow_imp.g_varchar2_table(36902) := 'E58583E7B4A0E7BCBAE5B091E6A087E7ADBE2FE5908DE7A7B0222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22E58583E7B4A0E69CAAE8BF9EE68EA5222C22656C656D656E74207265717569726564223A22E99C80E8A681E585';
wwv_flow_imp.g_varchar2_table(36903) := '83E7B4A0222C22456D61696C20636F6E74656E74223A22E982AEE4BBB6E58685E5AEB9222C22456D61696C206F662074686520726563697069656E74287329223A22E694B6E4BBB6E4BABA222C22456D61696C206F66207468652073656E646572223A22';
wwv_flow_imp.g_varchar2_table(36904) := 'E58F91E4BBB6E4BABA222C22456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F223A22E59B9EE5A48DE887B3222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F76657320636F';
wwv_flow_imp.g_varchar2_table(36905) := '6E74656E7429223A22E6B885E7A9BAE6B3B3E98193EFBC88E588A0E999A4E58685E5AEB9EFBC89222C22456D70747920706F6F6C2F7061727469636970616E74223A22E7A9BAE6B3B3E981935C5C22222C22456E64206576656E74223A22E7BB93E69D9F';
wwv_flow_imp.g_varchar2_table(36906) := 'E4BA8BE4BBB6222C22456E64204576656E74223A22E7BB93E69D9FE4BA8BE4BBB6222C22456E64706F696E74223A22E7ABAFE782B9222C22456E74657220637573746F6D20657874656E73696F6E73206173204A534F4E223A224A534F4EE6A0BCE5BC8F';
wwv_flow_imp.g_varchar2_table(36907) := 'E79A84E887AAE5AE9AE4B989E689A9E5B195222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22E8BE93E585A5E8A681E689A7E8A18CE79A8420504C2F53514C20E4BBA3E7A081E38082222C2245';
wwv_flow_imp.g_varchar2_table(36908) := '72726F7220626F756E64617279206576656E74223A22E99499E8AFAFE8BEB9E7958CE4BA8BE4BBB6222C224572726F7220656E64206576656E74223A22E7BB93E69D9FE99499E8AFAFE4BA8BE4BBB6222C224572726F7220456E64204576656E74223A22';
wwv_flow_imp.g_varchar2_table(36909) := 'E99499E8AFAFE7BB93E69D9FE4BA8BE4BBB6222C224572726F72207374617274206576656E74223A22E99499E8AFAFE590AFE58AA8E4BA8BE4BBB6222C224572726F72223A22E99499E8AFAF222C22457363616C6174696F6E20626F756E646172792065';
wwv_flow_imp.g_varchar2_table(36910) := '76656E7420286E6F6E2D696E74657272757074696E6729223A22E58D87E7BAA7E8BEB9E7958CE4BA8BE4BBB62028E99D9EE4B8ADE696AD29222C22457363616C6174696F6E20626F756E64617279206576656E74223A22E58D87E7BAA7E8BEB9E7958CE4';
wwv_flow_imp.g_varchar2_table(36911) := 'BA8BE4BBB6222C22457363616C6174696F6E20456E64204576656E74223A22E58D87E7BAA7E7BB93E69D9FE4BA8BE4BBB6222C22457363616C6174696F6E20656E64206576656E74223A22E7BB93E69D9FE58D87E7BAA7E4BA8BE4BBB6222C2245736361';
wwv_flow_imp.g_varchar2_table(36912) := '6C6174696F6E20696E7465726D656469617465207468726F77206576656E74223A22E4B8ADE997B4E58D87E7BAA7E68A9BE587BAE4BA8BE4BBB6222C22457363616C6174696F6E20496E7465726D656469617465205468726F77204576656E74223A22E5';
wwv_flow_imp.g_varchar2_table(36913) := '8D87E7BAA7E4B8ADE997B4E5BC95E58F91E4BA8BE4BBB6222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E58D87E7BAA7E590AFE58AA8E4BA8BE4BBB62028E99D9EE4B8ADE696AD29';
wwv_flow_imp.g_varchar2_table(36914) := '222C22457363616C6174696F6E207374617274206576656E74223A22E58D87E7BAA7E590AFE58AA8E4BA8BE4BBB6222C22457363616C6174696F6E223A22E58D87E7BAA7222C224576656E742042617365642047617465776179223A22E59FBAE4BA8EE4';
wwv_flow_imp.g_varchar2_table(36915) := 'BA8BE4BBB6E79A84E7BD91E585B3222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A22E4BA8BE4BBB6E585B7E69C89E5A49AE4B8AAE4BA8BE4BBB6E5AE9AE4B989222C224576656E74205375622050';
wwv_flow_imp.g_varchar2_table(36916) := '726F63657373223A22E4BA8BE4BBB6E5AD90E6B581E7A88B222C224576656E74207375622D70726F63657373223A22E4BA8BE4BBB6E5AD90E6B581E7A88B222C224576656E742054797065223A22E4BA8BE4BBB6E7B1BBE59E8B222C224576656E742D62';
wwv_flow_imp.g_varchar2_table(36917) := '617365642067617465776179223A22E4BA8BE4BBB6E7BD91E585B3222C224578636C75646564205374617274696E67205573657273223A22E8A2ABE68E92E999A4E79A84E8B5B7E5A78BE794A8E688B7222C224578636C75646564205573657273223A22';
wwv_flow_imp.g_varchar2_table(36918) := 'E8A2ABE68E92E999A4E79A84E794A8E688B7222C224578636C75736976652067617465776179223A22E4BA92E696A5E7BD91E585B3222C224578636C75736976652047617465776179223A22E4BA92E696A5E7BD91E585B3222C2245786563757461626C';
wwv_flow_imp.g_varchar2_table(36919) := '65223A22E58FAFE689A7E8A18C222C224578656375746520504C2F53514C223A22E689A7E8A18C20504C2F53514C222C22457865637574696F6E223A22E689A7E8A18C222C22457870616E64656420706F6F6C2F7061727469636970616E74223A22E689';
wwv_flow_imp.g_varchar2_table(36920) := 'A9E5B195E6B1A02FE58F82E4B88EE88085222C22457870616E646564205375622050726F63657373223A22E689A9E5B195E79A84E5AD90E6B581E7A88B222C2245787072657373696F6E20284C656761637929223A22E8A1A8E8BEBEEFBC88E98197E4BA';
wwv_flow_imp.g_varchar2_table(36921) := 'A7EFBC89222C2245787072657373696F6E2054797065223A22E8A1A8E8BEBEE5BC8FE7B1BBE59E8B222C2245787072657373696F6E223A22E8A1A8E8BEBEE5BC8F222C226661696C656420746F20696D706F7274207B656C656D656E747D223A22E697A0';
wwv_flow_imp.g_varchar2_table(36922) := 'E6B395E5AFBCE585A5207B656C656D656E747D222C22666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F7061727469636970616E7473223A22E6B581E7A88BE58583E7B4A0E5BF85E9A1BBE698AFE6B1';
wwv_flow_imp.g_varchar2_table(36923) := 'A02FE58F82E4B88EE88085E79A84E5AD90E58583E7B4A0222C22466C6F772073706C69747320696D706C696369746C79223A22E99A90E5BC8FE68B86E58886E6B581E7A88B222C22466F726D2054656D706C617465204974656D204E616D65223A22E8A1';
wwv_flow_imp.g_varchar2_table(36924) := 'A8E58D95E6A8A1E69DBFE9A1B9E79BAEE5908DE7A7B0222C22466F726D2054656D706C617465204974656D223A22E8A1A8E58D95E6A8A1E69DBFE9A1B9E79BAE222C22466F726D2054656D706C617465223A22E8A1A8E58D95E6A8A1E69DBF222C22466F';
wwv_flow_imp.g_varchar2_table(36925) := '726D6174204D61736B223A22E6A0BCE5BC8FE68EA9E7A081222C22466F726D61744D61736B223A22E6A0BCE5BC8FE58C96E68EA9E7A081222C2246726F6D223A22E887AA222C2246756E6374696F6E20426F647920284C656761637929223A22E58A9FE8';
wwv_flow_imp.g_varchar2_table(36926) := '83BDE4BD93EFBC88E98197E79599E997AEE9A298EFBC89222C2246756E6374696F6E20426F6479223A22E587BDE695B0E6ADA3E69687222C2247617465776179206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F75';
wwv_flow_imp.g_varchar2_table(36927) := '72636520616E64207461726765742E223A22E7BD91E585B3E5A49AE4BD99E38082E5AE83E58FAAE69C89E4B880E4B8AAE6BA90E5928CE79BAEE6A087E38082222C2247656E6572616C223A22E4B880E888AC222C2247656E65726174652064656661756C';
wwv_flow_imp.g_varchar2_table(36928) := '74206974656D73223A22E7949FE68890E9BB98E8AEA4E9A1B9E79BAE222C22476C6F62616C206572726F72207265666572656E6365223A22E585A8E5B180E99499E8AFAFE58F82E88083222C22476C6F62616C20657363616C6174696F6E207265666572';
wwv_flow_imp.g_varchar2_table(36929) := '656E6365223A22E585A8E5B180E58D87E7BAA7E58F82E88083222C22476C6F62616C207369676E616C207265666572656E6365223A22E585A8E5B180E4BFA1E58FB7E58F82E88083222C2247726F7570223A22E7BB84222C2248544D4C2076657273696F';
wwv_flow_imp.g_varchar2_table(36930) := '6E206F662074686520656D61696C223A22E794B5E5AD90E982AEE4BBB6E79A842048544D4C20E78988E69CAC222C224944206D75737420626520756E697175652E223A224944E5BF85E9A1BBE698AFE594AFE4B880E79A84E38082222C224944223A2249';
wwv_flow_imp.g_varchar2_table(36931) := '44222C22696E20666F726D6174204444442048483A4D4D3A5353223A22E6A0BCE5BC8FE4B8BA204444442048483A4D4D3A5353222C22696E20666F726D61742059592D4D4D223A22E6A0BCE5BC8FE4B8BA2059592D4D4D222C22496E205661726961626C';
wwv_flow_imp.g_varchar2_table(36932) := '6573223A22E4BCA0E585A5E58F98E9878F222C22496E2F4F7574204D617070696E67223A22E4BCA0E585A52FE8BE93E587BAE698A0E5B084222C22496E2F4F7574205661726961626C6573223A22E4BCA0E585A52FE8BE93E587BAE58F98E9878F222C22';
wwv_flow_imp.g_varchar2_table(36933) := '496E636C75736976652067617465776179223A22E58C85E5AEB9E7BD91E585B3222C22496E636F6D696E6720666C6F777320646F206E6F74206A6F696E223A22E4BCA0E585A5E6B581E7A88BE4B88DE58AA0E585A5222C22496E69746961746F72206F66';
wwv_flow_imp.g_varchar2_table(36934) := '207468697320617070726F76616C207461736B223A22E6ADA4E5AEA1E689B9E4BBBBE58AA1E79A84E58F91E8B5B7E4BABA222C22496E69746961746F72223A22E58F91E8B5B7E88085222C22496E70757420436F6C6C656374696F6E223A22E8BE93E585';
wwv_flow_imp.g_varchar2_table(36935) := 'A5E99B86E59088222C22496E70757420456C656D656E74223A22E8BE93E585A5E58583E7B4A0222C22496E7465726D656469617465205468726F77204576656E74223A22E4B8ADE997B4E5BC95E58F91E4BA8BE4BBB6222C22496E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(36936) := '65207468726F77206576656E74223A22E4B8ADE997B4E68A9BE587BAE4BA8BE4BBB6222C22496E74657276616C223A22E997B4E99A94222C2249732043616C6C61626C65223A22E58FAFE8B083E794A8222C22497320526F6C65223A22E8A792E889B2E6';
wwv_flow_imp.g_varchar2_table(36937) := '98AF222C22497320537461727461626C65223A22E698AFE58FAFE590AFE58AA8E79A84222C2249534F223A2249534F222C224974656D204E616D65223A224974656DE5908DE7A7B0222C224974656D2056616C7565223A224974656DE580BC222C224974';
wwv_flow_imp.g_varchar2_table(36938) := '656D223A224974656D222C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C79206E6F7420737570706F72746564223A22E5BD93E5898DE4B88DE694AFE68C81E9878DE5A48DE591BCE58FABE6BF80E6B4BB';
wwv_flow_imp.g_varchar2_table(36939) := '222C224A534F4E204F626A656374223A224A534F4E20E5AFB9E8B1A1222C224C616E65223A22E8B7AFE6AEB5222C224C61746573742076657273696F6E223A22E69C80E696B0E78988E69CAC222C224C696E6B20696E7465726D65646961746520636174';
wwv_flow_imp.g_varchar2_table(36940) := '6368206576656E74223A22E4B8ADE997B4E993BEE68EA5E68D95E88EB7E4BA8BE4BBB6222C224C696E6B20496E7465726D656469617465204361746368204576656E74223A22E993BEE68EA5E4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C224C696E';
wwv_flow_imp.g_varchar2_table(36941) := '6B20696E7465726D656469617465207468726F77206576656E74223A22E4B8ADE997B4E993BEE68EA5E68A9BE587BAE4BA8BE4BBB6222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A22E993BEE68EA5E4B8ADE997B4';
wwv_flow_imp.g_varchar2_table(36942) := 'E5BC95E58F91E4BA8BE4BBB6222C224C696E6B223A22E993BEE68EA5222C224C6F616420646566696E6564207661726961626C6573223A22E58AA0E8BDBDE5AE9AE4B989E79A84E58F98E9878F222C224C6F6164204A534F4E223A22E58AA0E8BDBD204A';
wwv_flow_imp.g_varchar2_table(36943) := '534F4E222C224C6F616420506172616D6574657273223A22E58AA0E8BDBDE58F82E695B0222C224C6F6F70223A22E5BEAAE78EAF222C224D61696C223A22E982AEE4BBB6222C224D616E75616C205461736B223A22E4BABAE5B7A5E4BBBBE58AA1222C22';
wwv_flow_imp.g_varchar2_table(36944) := '4D616E75616C207461736B223A22E6898BE58AA8E4BBBBE58AA1222C224D61782052756E73223A22E69C80E5A4A7E8BF90E8A18CE6ACA1E695B0222C224D65737361676520626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E';
wwv_flow_imp.g_varchar2_table(36945) := '6729223A22E6B688E681AFE8BEB9E7958CE4BA8BE4BBB62028E99D9EE4B8ADE696AD29222C224D65737361676520626F756E64617279206576656E74223A22E6B688E681AFE8BEB9E7958CE4BA8BE4BBB6222C224D65737361676520456E64204576656E';
wwv_flow_imp.g_varchar2_table(36946) := '74223A22E6B688E681AFE7BB93E69D9FE4BA8BE4BBB6222C224D65737361676520656E64206576656E74223A22E7BB93E69D9FE6B688E681AFE4BA8BE4BBB6222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A';
wwv_flow_imp.g_varchar2_table(36947) := '22E4B8ADE997B4E6B688E681AFE68D95E88EB7E4BA8BE4BBB6222C224D65737361676520496E7465726D656469617465204361746368204576656E74223A22E6B688E681AFE4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C224D65737361676520696E';
wwv_flow_imp.g_varchar2_table(36948) := '7465726D656469617465207468726F77206576656E74223A22E4B8ADE997B4E6B688E681AFE68A9BE587BAE4BA8BE4BBB6222C224D65737361676520496E7465726D656469617465205468726F77204576656E74223A22E6B688E681AFE4B8ADE997B4E5';
wwv_flow_imp.g_varchar2_table(36949) := 'BC95E58F91E4BA8BE4BBB6222C224D657373616765204E616D65223A22E4BFA1E681AFE5908DE7A7B0222C224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E6B688E681AFE590AFE58AA8E4BA8B';
wwv_flow_imp.g_varchar2_table(36950) := 'E4BBB62028E99D9EE4B8ADE696AD29222C224D657373616765207374617274206576656E74223A22E6B688E681AFE590AFE58AA8E4BA8BE4BBB6222C224D657373616765205374617274204576656E74223A22E6B688E681AFE5BC80E5A78BE4BA8BE4BB';
wwv_flow_imp.g_varchar2_table(36951) := 'B6222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A22E7BCBAE5B0917BE8AFADE4B989E5ADA67D236174746163686564546F526566222C226D6F7265207468616E207B636F756E747D206368696C64206C616E';
wwv_flow_imp.g_varchar2_table(36952) := '6573223A22E8B685E8BF87207B636F756E747D20E4B8AAE5AD90E9809AE98193222C224D756C74692D496E7374616E6365223A22E5A49AE5AE9EE4BE8B222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C';
wwv_flow_imp.g_varchar2_table(36953) := '656D656E747D223A22E4B8BA207B656C656D656E747D20E5AE9AE4B989E79A84E5A49AE4B8AA20444920E58583E7B4A0222C224E616D65206F6620746865206469616772616D223A22E59BBEE8A1A8E79A84E5908DE7A7B0222C224E616D65206F662074';
wwv_flow_imp.g_varchar2_table(36954) := '68652050726F63657373205661726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E6529223A22E8BF87E7A88BE58F98E9878FE79A84E5908DE7A7B0EFBC88E5B8A6E697B6E58CBAE79A84E697B6E997B4E6';
wwv_flow_imp.g_varchar2_table(36955) := '88B3E7B1BBE59E8BEFBC89E38082222C224E616D65206F66207468652050726F63657373205661726961626C65223A22E6B581E7A88BE58F98E9878FE79A84E5908DE7A7B0222C224E616D65206F6620746865207661726961626C6520746F2072657475';
wwv_flow_imp.g_varchar2_table(36956) := '726E2074686520617070726F76616C20726573756C7420696E746F223A22E8A681E5B086E5AEA1E689B9E7BB93E69E9CE8BF94E59B9EE588B0E79A84E58F98E9878FE5908DE7A7B0222C224E616D65223A22E5908DE7A7B0222C224E616D656420766572';
wwv_flow_imp.g_varchar2_table(36957) := '73696F6E223A22E591BDE5908DE78988E69CAC222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A227B656C656D656E747D20E4B8ADE69CAAE5BC95E794A82062706D6E456C656D656E74222C22';
wwv_flow_imp.g_varchar2_table(36958) := '6E6F206469616772616D20746F20646973706C6179223A22E6B2A1E69C89E58FAFE698BEE7A4BAE79A84E59BBEE8A1A8222C226E6F20706172656E7420666F72207B656C656D656E747D20696E207B706172656E747D223A227B706172656E747D20E4B8';
wwv_flow_imp.g_varchar2_table(36959) := 'ADE6B2A1E69C89207B656C656D656E747D20E79A84E788B6E9A1B920222C226E6F20706C616E6520666F72207B656C656D656E747D223A22E6B2A1E69C89E98082E794A8E4BA8E207B656C656D656E747D20E79A84E5B9B3E99DA2222C226E6F2070726F';
wwv_flow_imp.g_varchar2_table(36960) := '63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A22E6B2A1E69C89E58FAFE698BEE7A4BAE79A84E6B581E7A88BE68896E58D8FE4BD9C222C226E6F207368617065207479706520737065636966696564223A22E69CAA';
wwv_flow_imp.g_varchar2_table(36961) := 'E68C87E5AE9AE9858DE7BDAEE7B1BBE59E8B222C224E756D626572223A22E7BC96E58FB7222C224F6E204576656E74223A22E6B4BBE58AA8E4B8AD222C224F7261636C65205363686564756C652065787072657373696F6E223A224F7261636C65E8B083';
wwv_flow_imp.g_varchar2_table(36962) := 'E5BAA6E599A8E8A1A8E8BEBEE5BC8F222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A22E8B68AE7958CE9878AE694BE222C224F7574205661726961626C6573223A22E8BE93E587BAE58F98';
wwv_flow_imp.g_varchar2_table(36963) := 'E9878F222C224F757470757420436F6C6C656374696F6E223A22E8BE93E587BAE99B86E59088222C224F757470757420456C656D656E74223A22E8BE93E587BAE58583E7B4A0222C224F76657277726974652064656661756C742076616C756520736574';
wwv_flow_imp.g_varchar2_table(36964) := '20696E207461736B20646566696E6974696F6E223A22E8A686E79B96E4BBBBE58AA1E5AE9AE4B989E4B8ADE79A84E9BB98E8AEA4E580BCE99B86222C2250616765204944223A22E9A1B5E99DA2204944222C2250616765204974656D20636F6E7461696E';
wwv_flow_imp.g_varchar2_table(36965) := '696E672074686520666F726D2074656D706C617465207265666572656E6365223A22E58C85E590ABE8A1A8E58D95E6A8A1E69DBFE58F82E88083E79A84E9A1B5E9A1B9222C2250616765204974656D73223A22E9A1B5E99DA2E9A1B9E79BAE222C225061';
wwv_flow_imp.g_varchar2_table(36966) := '6765223A22E9A1B5E99DA2222C22506172616C6C656C2067617465776179223A22E5B9B6E8A18CE7BD91E585B3222C22506172616C6C656C2047617465776179223A22E5B9B6E8A18CE7BD91E585B3222C22506172616C6C656C206D756C74692D696E73';
wwv_flow_imp.g_varchar2_table(36967) := '74616E6365223A22E5B9B6E8A18CE5A49AE5AE9EE4BE8B222C225061727469636970616E74204944223A22E58F82E4B88EE880854944222C225061727469636970616E74206D756C7469706C6963697479223A22E58F82E4B88EE88085E5A49AE9878DE6';
wwv_flow_imp.g_varchar2_table(36968) := '80A7222C225061727469636970616E74204E616D65223A22E58F82E4B88EE88085E5A793E5908D222C225061727469636970616E74223A22E58F82E4B88EE88085222C225061796C6F6164205661726961626C65223A22E69C89E69588E8BDBDE88DB7E5';
wwv_flow_imp.g_varchar2_table(36969) := '8F98E9878F222C225061796C6F6164223A22E69C89E69588E8BDBDE88DB7222C22504C2F53514C20436F6465223A22504C2F53514C20E4BBA3E7A081222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E';
wwv_flow_imp.g_varchar2_table(36970) := '2076616C7565223A22E8BF94E59B9EE5B883E5B094E580BCE79A8420504C2F53514CE8A1A8E8BEBEE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A22E8BF94E59B9EE697A5E69C';
wwv_flow_imp.g_varchar2_table(36971) := '9FE79A84504C2F53514CE8A1A8E8BEBEE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061206E756D6265722076616C7565223A22E8BF94E59B9EE695B0E5AD97E79A84504C2F53514CE8A1A8E8BEBEE5BC8F222C22';
wwv_flow_imp.g_varchar2_table(36972) := '504C2F53514C2045787072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E8BF94E59B9EE5B8A6E697B6E58CBAE697B6E997B4E688B3E79A84504C2F53514CE8A1A8E8';
wwv_flow_imp.g_varchar2_table(36973) := 'BEBEE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22E8BF94E59B9E595959';
wwv_flow_imp.g_varchar2_table(36974) := '592D4D4D2D444420484832343A4D493A535320545A52E6A0BCE5BC8FE5AD97E7ACA6E4B8B2E79A84504C2F53514CE8A1A8E8BEBEE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C';
wwv_flow_imp.g_varchar2_table(36975) := '756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22E8BF94E59B9E595959592D4D4D2D444420484832343A4D493A5353E6A0BCE5BC8FE5AD97E7ACA6E4B8B2E79A84504C2F53514CE8A1A8E8BEBEE5BC8F222C22';
wwv_flow_imp.g_varchar2_table(36976) := '504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22E8BF94E59B9EE695B0E5AD97E5AD97E7ACA6E4B8B2E79A84504C2F53514CE8A1A8E8BEBE';
wwv_flow_imp.g_varchar2_table(36977) := 'E5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A22E8BF94E59B9EE5AD97E7ACA6E4B8B2E79A84504C2F53514CE8A1A8E8BEBEE5BC8F222C22504C2F53514C2045787072';
wwv_flow_imp.g_varchar2_table(36978) := '657373696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22E8BF94E59B9EE5B8A6E697B6E58CBAE697B6E997B4E688B3E79A84504C2F53514CE8A1A8E8BEBEE5BC8F222C22504C2F53514C2046756E63';
wwv_flow_imp.g_varchar2_table(36979) := '74696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A22E8BF94E59B9EE5B883E5B094E580BCE79A8420504C2F53514C20E587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E';
wwv_flow_imp.g_varchar2_table(36980) := '696E67206120646174652076616C7565223A22E8BF94E59B9EE697A5E69C9FE79A84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265722076616C7565223A22E8BF94';
wwv_flow_imp.g_varchar2_table(36981) := 'E59B9EE695B0E5AD97E79A84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E8BF94E59B9EE5';
wwv_flow_imp.g_varchar2_table(36982) := 'B8A6E697B6E58CBAE697B6E997B4E688B3E79A84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D';
wwv_flow_imp.g_varchar2_table(36983) := '2D444420484832343A4D493A535320545A52223A22E8BF94E59B9E595959592D4D4D2D444420484832343A4D493A535320545A52E6A0BCE5BC8FE5AD97E7ACA6E4B8B2E79A84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E';
wwv_flow_imp.g_varchar2_table(36984) := '20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22E8BF94E59B9E595959592D4D4D2D444420484832343A4D493A5353E6A0BCE5BC8F';
wwv_flow_imp.g_varchar2_table(36985) := 'E5AD97E7ACA6E4B8B2E79A84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22E8BF94E59B9E';
wwv_flow_imp.g_varchar2_table(36986) := 'E695B0E5AD97E5AD97E7ACA6E4B8B2E79A84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565223A22E8BF94E59B9EE5AD97E7ACA6E4B8B2E79A';
wwv_flow_imp.g_varchar2_table(36987) := '84504C2F53514CE587BDE695B0222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22E8BF94E59B9EE5B8A6E697B6E58CBAE697B6E997B4E688B3E79A';
wwv_flow_imp.g_varchar2_table(36988) := '84504C2F53514CE587BDE695B0222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A22E58DA0E4BD8DE7ACA6222C22506F74656E7469616C2047726F757073223A22E6BD9CE59CA8E79A84E7BEA4E4BD93222C22506F74';
wwv_flow_imp.g_varchar2_table(36989) := '656E7469616C205374617274657273223A22E6BD9CE59CA8E79A84E9A696E58F91E79083E59198222C22506F74656E7469616C205374617274696E672047726F757073223A22E6BD9CE59CA8E79A84E8B5B7E5A78BE7BEA4E4BD93222C22506F74656E74';
wwv_flow_imp.g_varchar2_table(36990) := '69616C205374617274696E67205573657273223A22E6BD9CE59CA8E79A84E8B5B7E5A78BE794A8E688B7222C22506F74656E7469616C205573657273223A22E6BD9CE59CA8E79A84E794A8E688B7222C225072696F72697479223A22E4BC98E58588E7BA';
wwv_flow_imp.g_varchar2_table(36991) := 'A7222C2250726F6365737320646F63756D656E746174696F6E223A22E6B581E7A88BE69687E4BBB6222C2250726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22E6B581E7A88BE585B7E69C89E5A49A';
wwv_flow_imp.g_varchar2_table(36992) := 'E4B8AAE7A9BAE799BDE5BC80E5A78BE4BA8BE4BBB6222C2250726F63657373204944223A22E8BF87E7A88BE6A087E8AF86222C2250726F63657373206973206D697373696E6720656E64206576656E74223A22E6B581E7A88BE7BCBAE5B091E7BB93E69D';
wwv_flow_imp.g_varchar2_table(36993) := '9FE4BA8BE4BBB6222C2250726F63657373206973206D697373696E67207374617274206576656E74223A22E6B581E7A88BE7BCBAE5B091E5BC80E5A78BE4BA8BE4BBB6222C2250726F63657373206E616D65223A22E8BF87E7A88BE5908DE7A7B0222C22';
wwv_flow_imp.g_varchar2_table(36994) := '50726F63657373205072696F72697479223A22E6B581E7A88BE4BC98E58588E7BAA7222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E223A22E7BB88E6ADA2E5908EE79A84E8BF9BE7A88BE78AB6E68081222C2250';
wwv_flow_imp.g_varchar2_table(36995) := '726F63657373205661726961626C652028417272617929223A22E8BF9BE7A88BE58F98E9878FEFBC88E695B0E7BB84EFBC89222C2250726F63657373205661726961626C6520284C69737429223A22E6B581E7A88BE58F98E9878FEFBC88E58897E8A1A8';
wwv_flow_imp.g_varchar2_table(36996) := 'EFBC89222C2250726F63657373205661726961626C65223A22E6B581E7A88BE58F98E9878F222C2250726F63657373223A22E6B581E7A88B222C2250726F766964652076616C75657320666F7220656D61696C2074656D706C617465223A22E68F90E4BE';
wwv_flow_imp.g_varchar2_table(36997) := '9BE794B5E5AD90E982AEE4BBB6E6A8A1E69DBFE79A84E580BC222C2252656365697665207461736B223A22E68EA5E58F97E4BBBBE58AA1222C2252656365697665205461736B223A22E68EA5E694B6E4BBBBE58AA1222C225265646F223A22E9878DE581';
wwv_flow_imp.g_varchar2_table(36998) := '9A222C2252656D6F7665223A22E588A0E999A4222C225265706C7920546F223A22E59B9EE5A48DE59CB0E59D80222C22526571756573742056616C756520666F7220506167652043616C6C223A22E9A1B5E8B083E794A8E79A84E8AFB7E6B182E580BC22';
wwv_flow_imp.g_varchar2_table(36999) := '2C2252657175657374223A22E8AFB7E6B182222C22526573756C74205661726961626C65223A22E7BB93E69E9CE58F98E9878F222C2252657475726E205061796C6F616420496E746F223A22E5B086E69C89E69588E8BDBDE88DB7E98081E585A5222C22';
wwv_flow_imp.g_varchar2_table(37000) := '526F6C65223A22E8A792E889B2222C2253617665223A22E4BF9DE5AD98222C225363686564756C65722045787072657373696F6E223A22E8B083E5BAA6E599A8E8A1A8E8BEBEE5BC8F222C225363686564756C696E67223A22E8B083E5BAA6E8AEA1E588';
wwv_flow_imp.g_varchar2_table(37001) := '92222C22536372697074207461736B223A22E8849AE69CACE4BBBBE58AA1222C22536372697074205461736B223A22E8849AE69CACE4BBBBE58AA1222C2253656C6563742069662074686973206469616772616D20697320737461727461626C65223A22';
wwv_flow_imp.g_varchar2_table(37002) := 'E98089E68BA9E8AFA5E59BBEE698AFE590A6E58FAFE4BBA5E590AFE58AA8222C2253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A22E98089E68BA9';
wwv_flow_imp.g_varchar2_table(37003) := 'E698AFE590A6E5BA94E59CA8E591BCE58FABE6B4BBE58AA8E4B8ADE8B083E794A8E6ADA4E59BBEE8A1A8222C2253656E6420456D61696C20496D6D6564696174656C79223A22E7AB8BE58DB3E58F91E98081E794B5E5AD90E982AEE4BBB6222C2253656E';
wwv_flow_imp.g_varchar2_table(37004) := '64204D61696C223A22E58F91E98081E982AEE4BBB6222C2253656E64207461736B223A22E58F91E98081E4BBBBE58AA1222C2253656E64205461736B223A22E58F91E98081E4BBBBE58AA1222C2253657175656E636520666C6F77223A22E9A1BAE5BA8F';
wwv_flow_imp.g_varchar2_table(37005) := 'E6B581222C2253657175656E6365223A22E5BA8FE58897222C2253657175656E6365466C6F772069732061206475706C6963617465223A22E5BA8FE58897E6B581E7A88BE698AFE9878DE5A48DE9A1B9222C2253657175656E7469616C206D756C74692D';
wwv_flow_imp.g_varchar2_table(37006) := '696E7374616E6365223A22E4B8B2E8A18CE5A49AE5AE9EE4BE8B222C2253657276696365207461736B223A22E69C8DE58AA1E4BBBBE58AA1222C2253657276696365205461736B223A22E69C8DE58AA1E4BBBBE58AA1222C2253657420636F6C6F72223A';
wwv_flow_imp.g_varchar2_table(37007) := '22E8AEBEE7BDAEE9A29CE889B2222C225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E4BFA1E58FB7E8BEB9E7958CE4BA8BE4BBB62028E99D9EE4B8ADE696AD29222C225369676E616C2062';
wwv_flow_imp.g_varchar2_table(37008) := '6F756E64617279206576656E74223A22E4BFA1E58FB7E8BEB9E7958CE4BA8BE4BBB6222C225369676E616C20456E64204576656E74223A22E4BFA1E58FB7E7BB93E69D9FE4BA8BE4BBB6222C225369676E616C20656E64206576656E74223A22E7BB93E6';
wwv_flow_imp.g_varchar2_table(37009) := '9D9FE4BFA1E58FB7E4BA8BE4BBB6222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A22E4B8ADE997B4E4BFA1E58FB7E68D95E88EB7E4BA8BE4BBB6222C225369676E616C20496E7465726D656469617465204361';
wwv_flow_imp.g_varchar2_table(37010) := '746368204576656E74223A22E4BFA1E58FB7E4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C225369676E616C20696E7465726D656469617465207468726F77206576656E74223A22E4B8ADE997B4E4BFA1E58FB7E68A9BE587BAE4BA8BE4BBB6222C22';
wwv_flow_imp.g_varchar2_table(37011) := '5369676E616C20496E7465726D656469617465205468726F77204576656E74223A22E4BFA1E58FB7E4B8ADE997B4E5BC95E58F91E4BA8BE4BBB6222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A';
wwv_flow_imp.g_varchar2_table(37012) := '22E4BFA1E58FB7E590AFE58AA8E4BA8BE4BBB62028E99D9EE4B8ADE696AD29222C225369676E616C207374617274206576656E74223A22E4BFA1E58FB7E590AFE58AA8E4BA8BE4BBB6222C225369676E616C205374617274204576656E74223A22E4BFA1';
wwv_flow_imp.g_varchar2_table(37013) := 'E58FB7E5BC80E5A78BE4BA8BE4BBB6222C225369676E616C223A22E4BFA1E58FB7222C2253696D706C65204D657373616765223A22E7AE80E58D95E79A84E4BFA1E681AF222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69';
wwv_flow_imp.g_varchar2_table(37014) := '737429223A2253514C20E69FA5E8AFA2EFBC88E4BBA5E58692E58FB7E58886E99A94E79A84E58897E8A1A8EFBC89222C2253514C20717565727920284A534F4E20617272617929223A2253514C20E69FA5E8AFA2EFBC884A534F4E20E695B0E7BB84EFBC';
wwv_flow_imp.g_varchar2_table(37015) := '89222C2253514C207175657279202873696E676C652076616C756529223A2253514C20E69FA5E8AFA2EFBC88E58D95E4B8AAE580BCEFBC89222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C6973';
wwv_flow_imp.g_varchar2_table(37016) := '74223A22E8BF94E59B9EE58692E58FB7E58886E99A94E58897E8A1A8E79A842053514C20E69FA5E8AFA2222C2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A22E8BF94E59B9E204A534F4E20E695B0E7BB84E79A';
wwv_flow_imp.g_varchar2_table(37017) := '842053514C20E69FA5E8AFA2222C2253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C7565223A22E8BF94E59B9EE58D95E4B880E697A5E69C9FE580BCE79A8453514CE69FA5E8AFA2222C2253514C20717565';
wwv_flow_imp.g_varchar2_table(37018) := '72792072657475726E696E6720612073696E676C65206E756D6265722076616C7565223A22E8BF94E59B9EE58D95E4B880E695B0E5AD97E580BCE79A8453514CE69FA5E8AFA2222C2253514C2071756572792072657475726E696E6720612073696E676C';
wwv_flow_imp.g_varchar2_table(37019) := '652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E8BF94E59B9EE585B7E69C89E697B6E58CBAE580BCE79A84E58D95E4B8AAE697B6E997B4E688B3E79A842053514C20E69FA5E8AFA2222C2253514C207175657279';
wwv_flow_imp.g_varchar2_table(37020) := '2072657475726E696E6720612073696E676C652076617263686172322076616C7565223A22E8BF94E59B9EE58D95E4B8AA20766172636861723220E580BCE79A842053514C20E69FA5E8AFA2222C2253514C2071756572792072657475726E696E672054';
wwv_flow_imp.g_varchar2_table(37021) := '696D657374616D7020776974682054696D65205A6F6E65223A22E8BF94E59B9EE5B8A6E697B6E58CBAE79A84E697B6E997B4E688B3E79A842053514C20E69FA5E8AFA2222C2253514C20717565727920746F20676574206174746163686D656E74223A22';
wwv_flow_imp.g_varchar2_table(37022) := 'E794A8E4BA8EE88EB7E58F96E99984E4BBB6E79A842053514C20E69FA5E8AFA2222C2253514C205175657279223A2253514C20E69FA5E8AFA2222C2253514C207175657279223A2253514CE69FA5E8AFA2222C225374617274206576656E74206973206D';
wwv_flow_imp.g_varchar2_table(37023) := '697373696E67206576656E7420646566696E6974696F6E223A22E5BC80E5A78BE4BA8BE4BBB6E7BCBAE5B091E4BA8BE4BBB6E5AE9AE4B989222C225374617274206576656E74206D75737420626520626C616E6B223A22E5BC80E5A78BE4BA8BE4BBB6E5';
wwv_flow_imp.g_varchar2_table(37024) := 'BF85E9A1BBE4B8BAE7A9BA222C225374617274206576656E74223A22E5BC80E5A78BE4BA8BE4BBB6222C225374617274204576656E74223A22E5BC80E5A78BE4BA8BE4BBB6222C2253746174696320646174652076616C7565223A22E99D99E68081E697';
wwv_flow_imp.g_varchar2_table(37025) := 'A5E69C9FE580BC222C22537461746963204944223A22E99D99E68081204944222C22537461746963206E756D6265722076616C7565223A22E99D99E68081E695B0E5AD97E580BC222C225374617469632054696D657374616D7020776974682054696D65';
wwv_flow_imp.g_varchar2_table(37026) := '205A6F6E652076616C7565223A22E585B7E69C89E697B6E58CBAE580BCE79A84E99D99E68081E697B6E997B4E688B3222C225374617469632076617263686172322076616C7565223A22E99D99E6808120766172636861723220E580BC222C2253746174';
wwv_flow_imp.g_varchar2_table(37027) := '6963223A22E99D99E68081222C22537472696E67223A22E5AD97E7ACA6E4B8B2222C225375622070726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576656E7473223A22E5AD90E6B581E7A88BE585B7E69C89E5A49AE4';
wwv_flow_imp.g_varchar2_table(37028) := 'B8AAE7A9BAE799BDE8B5B7E5A78BE4BA8BE4BBB6222C225375622070726F63657373206973206D697373696E6720656E64206576656E74223A22E5AD90E6B581E7A88BE7BCBAE5B091E7BB93E69D9FE4BA8BE4BBB6222C225375622070726F6365737320';
wwv_flow_imp.g_varchar2_table(37029) := '6973206D697373696E67207374617274206576656E74223A22E5AD90E6B581E7A88BE7BCBAE5B091E5BC80E5A78BE4BA8BE4BBB6222C225375622D70726F636573732028636F6C6C617073656429223A22E58FAFE68A98E58FA0E5AD90E6B581E7A88B22';
wwv_flow_imp.g_varchar2_table(37030) := '2C225375622D70726F636573732028657870616E64656429223A22E58FAFE5B195E5BC80E5AD90E6B581E7A88B222C225375622D70726F63657373223A22E5AD90E6B581E7A88B222C225375626A656374223A22E4B8BBE9A298222C225461736B204465';
wwv_flow_imp.g_varchar2_table(37031) := '66696E6974696F6E223A22E4BBBBE58AA1E5AE9AE4B989222C225461736B20537461746963204944223A22E4BBBBE58AA1E99D99E68081204944222C225461736B2054797065223A22E4BBBBE58AA1E7B1BBE59E8B222C225461736B223A22E4BBBBE58A';
wwv_flow_imp.g_varchar2_table(37032) := 'A1222C2254656D706C617465204944223A22E6A8A1E69DBF204944222C2254656D706C617465223A22E6A8A1E69DBF222C225465726D696E61746520456E64204576656E74223A22E7BB88E6ADA2E7BB93E69D9FE4BA8BE4BBB6222C225465726D696E61';
wwv_flow_imp.g_varchar2_table(37033) := '746520656E64206576656E74223A22E7BB88E6ADA2E8BEB9E7958CE4BA8BE4BBB6222C225465726D696E61746564223A22E5B7B2E7BB88E6ADA2222C2254657874223A22E69687E69CAC222C2254696D6520756E74696C207468652074696D6572206669';
wwv_flow_imp.g_varchar2_table(37034) := '72657320616761696E223A22E8AEA1E697B6E599A8E5868DE6ACA1E8A7A6E58F91E4B98BE5898DE79A84E697B6E997B4222C2254696D6520756E74696C207468652074696D6572206669726573206669727374223A22E8AEA1E697B6E599A8E9A696E6AC';
wwv_flow_imp.g_varchar2_table(37035) := 'A1E8A7A6E58F91E4B98BE5898DE79A84E697B6E997B4222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E5AE9AE697B6E8BEB9E7958CE4BA8BE4BBB62028E99D9EE4B8ADE696AD29222C22';
wwv_flow_imp.g_varchar2_table(37036) := '54696D657220626F756E64617279206576656E74223A22E5AE9AE697B6E8BEB9E7958CE4BA8BE4BBB6222C2254696D657220446566696E6974696F6E2054797065223A22E8AEA1E697B6E599A8E5AE9AE4B989E7B1BBE59E8B222C2254696D6572204465';
wwv_flow_imp.g_varchar2_table(37037) := '66696E6974696F6E223A22E8AEA1E697B6E599A8E5AE9AE4B989222C2254696D6572204475726174696F6E223A22E8AEA1E697B6E599A8E68C81E7BBADE697B6E997B4222C2254696D657220696E7465726D656469617465206361746368206576656E74';
wwv_flow_imp.g_varchar2_table(37038) := '223A22E4B8ADE997B4E5AE9AE697B6E68D95E88EB7E4BA8BE4BBB6222C2254696D657220496E7465726D656469617465204361746368204576656E74223A22E8AEA1E697B6E599A8E4B8ADE997B4E68D95E88EB7E4BA8BE4BBB6222C2254696D65722073';
wwv_flow_imp.g_varchar2_table(37039) := '74617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E5AE9AE697B6E590AFE58AA8E4BA8BE4BBB62028E99D9EE4B8ADE696AD29222C2254696D6572207374617274206576656E74223A22E5AE9AE697B6E590AFE58AA8E4BA8B';
wwv_flow_imp.g_varchar2_table(37040) := 'E4BBB6222C2254696D6572205374617274204576656E74223A22E8AEA1E697B6E599A8E5BC80E5A78BE4BA8BE4BBB6222C2254696D6572223A22E8AEA1E697B6E599A8222C2254696D657374616D7020776974682054696D65205A6F6E6520696E204953';
wwv_flow_imp.g_varchar2_table(37041) := '4F2038363031206F72204F7261636C6520666F726D6174223A2249534F203836303120E68896204F7261636C6520E6A0BCE5BC8FE79A84E697B6E58CBAE697B6E997B4E688B3222C2254696D657374616D7020776974682054696D65205A6F6E65223A22';
wwv_flow_imp.g_varchar2_table(37042) := 'E697B6E58CBAE79A84E697B6E997B4E688B3222C22546F223A22E694B6E4BBB6E4BABA222C22546F67676C65206E6F6E2D696E74657272757074696E67223A22E58887E68DA2E4B88DE4B8ADE696AD222C225472616E73616374696F6E223A22E4BA8BE5';
wwv_flow_imp.g_varchar2_table(37043) := '8AA1E5A484E79086222C22556E646F223A22E692A4E6B688222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A22E58583E7B4A0207B73656D616E7469637D20E79A84E69CAAE79FA5206469207B';
wwv_flow_imp.g_varchar2_table(37044) := '64697D222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A22E697A0E6B395E8AF86E588ABE4B88AE4B88BE69687207B636F6E746578747D20E4B8ADE7';
wwv_flow_imp.g_varchar2_table(37045) := '9A8420666C6F77456C656D656E74207B656C656D656E747D222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C616E657D3A207B726F6F74456C656D656E747D223A227B706C616E657D20E4B88DE694AFE68C81206270';
wwv_flow_imp.g_varchar2_table(37046) := '6D6E456C656D656E74EFBC9A7B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A22E4BDBFE794A8204150455820E58583E695B0E68DAE222C225573652054656D706C617465223A22E4BDBFE794A8E6A8A1E69DBF';
wwv_flow_imp.g_varchar2_table(37047) := '222C2255736564206469616772616D2076657273696F6E223A22E5B7B2E794A8E59BBEE8A1A8E78988E69CAC222C2255736572207461736B223A22E794A8E688B7E4BBBBE58AA1222C2255736572205461736B223A22E794A8E688B7E4BBBBE58AA1222C';
wwv_flow_imp.g_varchar2_table(37048) := '2256616C7565223A22E580BC222C225661726368617232223A22E5AD97E7ACA6E4B8B2222C225661726961626C652045787072657373696F6E73223A22E58F98E9878FE8A1A8E8BEBEE5BC8F222C2256657273696F6E204E616D65223A22E78988E69CAC';
wwv_flow_imp.g_varchar2_table(37049) := 'E5908DE7A7B0222C2256657273696F6E696E67223A22E78988E69CACE68EA7E588B6222C225761697420666F7220636F6D706C6574696F6E223A22E7AD89E5BE85E5AE8CE68890222C225A6F6F6D20496E223A22E694BEE5A4A7222C225A6F6F6D204F75';
wwv_flow_imp.g_varchar2_table(37050) := '74223A22E7BCA9E5B08F227D27297D2C353538383A653D3E7B2275736520737472696374223B652E6578706F7274733D4A534F4E2E706172736528277B227B6572726F72737D204572726F72732C207B7761726E696E67737D205761726E696E6773223A';
wwv_flow_imp.g_varchar2_table(37051) := '227B6572726F72737D20E5808BE98CAFE8AAA4EFBC8C7B7761726E696E67737D20E5808BE8ADA6E5918A222C227B73656D616E7469637D237B736964657D20526566206E6F7420737065636966696564223A22E69CAAE68C87E5AE9A207B73656D616E74';
wwv_flow_imp.g_varchar2_table(37052) := '69637D237B736964657D20E58F83E785A7222C223C6E6F6E653E223A223C6E6F6E653E222C22312D557267656E74223A22312DE7B78AE680A5222C22322D48696768223A22322DE9AB98222C22332D4D656469756D223A22332DE4B8AD222C22342D4C6F';
wwv_flow_imp.g_varchar2_table(37053) := '77223A22342DE4BD8E222C22352D4C6F77657374223A22352DE69C80E4BD8E222C224120676174657761792073686F756C64206E6F74206D6572676520616E642073706C6974206174207468652073616D652074696D65223A22E99698E98193E4B88DE6';
wwv_flow_imp.g_varchar2_table(37054) := '8789E8A9B2E5908CE69982E59088E4BDB5E5928CE58886E589B2222C224163746976617465206372656174652F72656D6F766520737061636520746F6F6C223A22E5959FE794A8E5BBBAE7AB8B202F20E7A7BBE999A4E7A9BAE99693E5B7A5E585B7222C';
wwv_flow_imp.g_varchar2_table(37055) := '22416374697661746520676C6F62616C20636F6E6E65637420746F6F6C223A22E5959FE794A8E585A8E59F9FE980A3E7B79AE5B7A5E585B7222C2241637469766174652068616E6420746F6F6C223A22E5959FE794A8E68E8CE59E8BE5B7A5E585B7222C';
wwv_flow_imp.g_varchar2_table(37056) := '224163746976617465206C6173736F20746F6F6C223A22E5959FE58B95206C6173736F20E5B7A5E585B7222C22416374697661746520746865206372656174652F72656D6F766520737061636520746F6F6C223A22E5959FE794A8E5BBBAE7AB8B202F20';
wwv_flow_imp.g_varchar2_table(37057) := 'E7A7BBE999A4E7A9BAE99693E5B7A5E585B7222C2241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C223A22E5959FE58B95E585A8E59F9FE980A3E7B79AE5B7A5E585B7222C224163746976617465207468652068616E64';
wwv_flow_imp.g_varchar2_table(37058) := '20746F6F6C223A22E5959FE794A8E68E8CE59E8BE5B7A5E585B7222C22416374697661746520746865206C6173736F20746F6F6C223A22E5959FE794A8206C6173736F20E5B7A5E585B7222C224163746976697479207265666572656E6365223A22E6B4';
wwv_flow_imp.g_varchar2_table(37059) := 'BBE58B95E58F83E88083222C2241642D686F63223A22E789B9E588A5222C22416464206C616E652061626F7665223A22E59CA8E4B88AE696B9E696B0E5A29EE8B7AFE5BE91222C22416464206C616E652062656C6F77223A22E59CA8E4B88BE696B9E696';
wwv_flow_imp.g_varchar2_table(37060) := 'B0E5A29EE8B7AFE5BE91222C22416464207465787420616E6E6F746174696F6E223A22E696B0E5A29EE69687E5AD97E8A8BBE8A7A3222C224166746572204D65726765223A22E59088E4BDB5E5BE8C222C224166746572205461736B223A22E4BD9CE6A5';
wwv_flow_imp.g_varchar2_table(37061) := 'ADE4B98BE5BE8C222C22416C69676E20656C656D656E747320626F74746F6D223A22E99DA0E4B88BE5B08DE9BD8AE58583E7B4A0222C22416C69676E20656C656D656E74732063656E746572223A22E58583E7B4A0E7BDAEE4B8ADE5B08DE9BD8A222C22';
wwv_flow_imp.g_varchar2_table(37062) := '416C69676E20656C656D656E7473206C656674223A22E5B087E58583E7B4A0E99DA0E5B7A6E5B08DE9BD8A222C22416C69676E20656C656D656E7473206D6964646C65223A22E5B087E58583E7B4A0E7BDAEE4B8ADE5B08DE9BD8A222C22416C69676E20';
wwv_flow_imp.g_varchar2_table(37063) := '656C656D656E7473207269676874223A22E5B087E58583E7B4A0E99DA0E58FB3E5B08DE9BD8A222C22416C69676E20656C656D656E747320746F70223A22E5B087E58583E7B4A0E99DA0E4B88AE5B08DE9BD8A222C22416C69676E20656C656D656E7473';
wwv_flow_imp.g_varchar2_table(37064) := '223A22E5B08DE9BD8AE58583E7B4A0222C22416C6C6F772042696E64696E67223A22E58581E8A8B1E980A3E7B590222C22616C72656164792072656E6465726564207B656C656D656E747D223A22E5B7B2E8BD89E8ADAF207B656C656D656E747D222C22';
wwv_flow_imp.g_varchar2_table(37065) := '4150455820417070726F76616C223A224150455820E6A0B8E58786222C22415045582050616765223A224150455820E9A081E99DA2222C224150455820526F6C65223A224150455820E8A792E889B2222C22415045582053696D706C6520466F726D223A';
wwv_flow_imp.g_varchar2_table(37066) := '224150455820E7B0A1E69893E8A1A8E596AE222C22417070656E6420636F6D70656E736174696F6E206163746976697479223A22E99984E58AA0E896AAE985ACE6B4BBE58B95222C22417070656E6420636F6E646974696F6E616C20696E7465726D6564';
wwv_flow_imp.g_varchar2_table(37067) := '69617465206361746368206576656E74223A22E99984E58AA0E6A29DE4BBB6E5BC8FE4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C22417070656E6420656E64206576656E74223A22E99984E58AA0E7B590E69D9FE4BA8BE4BBB6222C22417070656E';
wwv_flow_imp.g_varchar2_table(37068) := '642067617465776179223A22E99984E58AA0E99698E98193222C22417070656E6420696E7465726D6564696174652F626F756E64617279206576656E74223A22E99984E58AA0E4B8ADE7B9BC202F20E7958CE99990E4BA8BE4BBB6222C22417070656E64';
wwv_flow_imp.g_varchar2_table(37069) := '206D65737361676520696E7465726D656469617465206361746368206576656E74223A22E99984E58AA0E8A88AE681AFE4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C22417070656E642072656365697665207461736B223A22E99984E58AA0E68EA5';
wwv_flow_imp.g_varchar2_table(37070) := 'E694B6E5B7A5E4BD9C222C22417070656E64207369676E616C20696E7465726D656469617465206361746368206576656E74223A22E99984E58AA0E8A88AE8999FE4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C22417070656E64207461736B223A22';
wwv_flow_imp.g_varchar2_table(37071) := 'E99984E58AA0E4BBBBE58B99222C22417070656E64207465787420616E6E6F746174696F6E223A22E99984E58AA0E69687E5AD97E8A8BBE8A7A3222C22417070656E642074696D657220696E7465726D656469617465206361746368206576656E74223A';
wwv_flow_imp.g_varchar2_table(37072) := '22E99984E58AA0E8A888E69982E599A8E4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C224170706C69636174696F6E204944223A22E68789E794A8E7A88BE5BC8F204944222C224170706C69636174696F6E223A22E68789E794A8E7A88BE5BC8F222C';
wwv_flow_imp.g_varchar2_table(37073) := '2241737369676E6D656E74223A22E68C87E6B4BE222C224174746163686D656E74223A22E99984E4BBB6222C224261636B67726F756E64205461736B2053657373696F6E223A22E8838CE699AFE4BD9CE6A5ADE99A8EE6AEB5E4BD9CE6A5AD222C224243';
wwv_flow_imp.g_varchar2_table(37074) := '43223A22E5AF86E4BBB6E589AFE69CAC222C224265666F7265204576656E74223A22E4BA8BE4BBB6E4B98BE5898D222C224265666F72652053706C6974223A22E58886E589B2E5898D222C224265666F7265205461736B223A22E59CA8E4BBBBE58B99E4';
wwv_flow_imp.g_varchar2_table(37075) := 'B98BE5898D222C2242696E642070616765206974656D7320286465707265636174656429223A22E980A3E7B590E9A081E99DA2E9A085E79BAE2028E5B7B2E4B88DE5868DE4BDBFE794A829222C2242696E6420706172616D657465722076616C75657322';
wwv_flow_imp.g_varchar2_table(37076) := '3A22E980A3E7B590E58F83E695B8E580BC222C2242696E642070726F63657373207661726961626C6573223A22E980A3E7B590E89995E79086E4BD9CE6A5ADE8AE8AE695B8222C22426C696E6420636172626F6E20636F707920726563697069656E7428';
wwv_flow_imp.g_varchar2_table(37077) := '7329223A22E5AF86E4BBB6E589AFE69CACE694B6E4BBB6E88085222C22426F64792048544D4C223A22E4B8BBE9AB942048544D4C222C22426F64792054657874223A22E585A7E69687222C22426F756E64617279206576656E7473206F6E206974657261';
wwv_flow_imp.g_varchar2_table(37078) := '74696E67207375622070726F636573736573206172652063757272656E746C79206E6F7420737570706F72746564223A22E79BAEE5898DE4B88DE694AFE68FB4E9878DE8A487E5AD90E89995E79086E4B88AE79A84E7958CE99990E4BA8BE4BBB6222C22';
wwv_flow_imp.g_varchar2_table(37079) := '427573696E657373205265666572656E6365223A22E6A5ADE58B99E58F83E88083222C22427573696E6573732072756C65207461736B223A22E59586E6A5ADE8A68FE58987E5B7A5E4BD9C222C22427573696E6573732052756C65205461736B223A22E6';
wwv_flow_imp.g_varchar2_table(37080) := 'A5ADE58B99E8A68FE58987E4BBBBE58B99222C22627573696E6573735F726566223A22627573696E6573735F726566222C2243616C6C206163746976697479223A22E591BCE58FABE6B4BBE58B95222C2243616C6C204163746976697479223A22E68B9C';
wwv_flow_imp.g_varchar2_table(37081) := 'E8A8AAE6B4BBE58B95222C2243616C6C6564204469616772616D223A22E8A2ABE58FABE59C96222C2243616E63656C20626F756E64617279206576656E74223A22E58F96E6B688E7958CE99990E4BA8BE4BBB6222C2243616E63656C20656E6420657665';
wwv_flow_imp.g_varchar2_table(37082) := '6E74223A22E58F96E6B688E7B590E69D9FE4BA8BE4BBB6222C2243616E63656C223A22E58F96E6B688222C22436172626F6E20636F707920726563697069656E74287329223A22E589AFE69CACE694B6E4BBB6E88085222C2243617465676F7279205661';
wwv_flow_imp.g_varchar2_table(37083) := '6C7565223A22E58886E9A19EE580BC222C224343223A22E589AFE69CAC222C224368616E676520656C656D656E74223A22E8AE8AE69BB4E58583E7B4A0222C224368616E67652074797065223A22E8AE8AE69BB4E9A19EE59E8B222C22436C6561722043';
wwv_flow_imp.g_varchar2_table(37084) := '616368652056616C756520666F7220506167652043616C6C223A22E6B885E999A4E591BCE58FABE9A081E99DA2E79A84E5BFABE58F96E580BC222C22436C656172204361636865223A22E6B885E999A4E7BC93E5AD98222C22436C6F62223A22E69691E9';
wwv_flow_imp.g_varchar2_table(37085) := 'BB9E204E616D65222C22436F6465223A22E4BBA3E7A2BC222C22436F6C6C61626F726174696F6E223A22E58D94E4BD9C222C22436F6C6C617073656420506F6F6C223A22E694B6E59088E79A84E99B86E58D80222C22436F6C6C61707365642053756220';
wwv_flow_imp.g_varchar2_table(37086) := '50726F63657373223A22E694B6E59088E79A84E5AD90E89995E79086222C22436F6C6C656374696F6E2054797065223A22E694B6E5B8B3E9A19EE59E8B222C22436F6C6C656374696F6E223A22E99B86E59088222C22436F6D70656E7361746520456E64';
wwv_flow_imp.g_varchar2_table(37087) := '204576656E74223A22E8A39CE5849FE7B590E69D9FE4BA8BE4BBB6222C22436F6D70656E7361746520496E7465726D656469617465205468726F77204576656E74223A22E8A39CE5849FE4B8ADE7B9BCE799BCE587BAE4BA8BE4BBB6222C22436F6D7065';
wwv_flow_imp.g_varchar2_table(37088) := '6E736174696F6E20626F756E64617279206576656E74223A22E896AAE985ACE7958CE99990E4BA8BE4BBB6222C22436F6D70656E736174696F6E20656E64206576656E74223A22E896AAE985ACE7B590E69D9FE4BA8BE4BBB6222C22436F6D70656E7361';
wwv_flow_imp.g_varchar2_table(37089) := '74696F6E20696E7465726D656469617465207468726F77206576656E74223A22E5A0B1E985ACE4B8ADE7B9BCE799BCE587BAE4BA8BE4BBB6222C22436F6D70656E736174696F6E207374617274206576656E74223A22E896AAE985ACE9968BE5A78BE4BA';
wwv_flow_imp.g_varchar2_table(37090) := '8BE4BBB6222C22436F6D70656E736174696F6E223A22E896AAE985AC222C22436F6D706C65746564223A22E5B7B2E5AE8CE68890222C22436F6D706C6574696F6E20436F6E646974696F6E223A22E5AE8CE68890E6A29DE4BBB6222C22436F6D706C6578';
wwv_flow_imp.g_varchar2_table(37091) := '2067617465776179223A22E8A487E99B9CE99698E98193222C22436F6D706C65782047617465776179223A22E8A487E99B9CE99698E98193222C22436F6E646974696F6E2054797065223A22E6A29DE4BBB6E9A19EE59E8B222C22436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(37092) := '223A22E6A29DE4BBB6222C22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E6A29DE4BBB6E9828AE7958CE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C22436F6E64697469';
wwv_flow_imp.g_varchar2_table(37093) := '6F6E616C20626F756E64617279206576656E74223A22E6A29DE4BBB6E7958CE99990E4BA8BE4BBB6222C22436F6E646974696F6E616C20666C6F77223A22E6A29DE4BBB6E6B581E7A88B222C22436F6E646974696F6E616C20496E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(37094) := '65204361746368204576656E74223A22E6A29DE4BBB6E5BC8FE4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C22436F6E646974696F6E616C20696E7465726D656469617465206361746368206576656E74223A22E6A29DE4BBB6E680A7E4B8ADE7B9BC';
wwv_flow_imp.g_varchar2_table(37095) := 'E693B7E58F96E4BA8BE4BBB6222C22436F6E646974696F6E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E6A29DE4BBB6E680A7E9968BE5A78BE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C22436F6E64';
wwv_flow_imp.g_varchar2_table(37096) := '6974696F6E616C205374617274204576656E74223A22E6A29DE4BBB6E5BC8FE9968BE5A78BE4BA8BE4BBB6222C22436F6E646974696F6E616C207374617274206576656E74223A22E6A29DE4BBB6E9968BE5A78BE4BA8BE4BBB6222C22436F6E6E656374';
wwv_flow_imp.g_varchar2_table(37097) := '20746F206F7468657220656C656D656E74223A22E980A3E7B79AE588B0E585B6E5AE83E58583E7B4A0222C22436F6E6E656374207573696E67206173736F63696174696F6E223A22E4BDBFE794A8E9979CE881AFE980A3E7B79A222C22436F6E6E656374';
wwv_flow_imp.g_varchar2_table(37098) := '207573696E67206461746120696E707574206173736F63696174696F6E223A22E4BDBFE794A8E8B387E69699E8BCB8E585A5E9979CE881AFE980A3E7B79A222C22436F6E6E656374207573696E672073657175656E63652F6D65737361676520666C6F77';
wwv_flow_imp.g_varchar2_table(37099) := '206F72206173736F63696174696F6E223A22E4BDBFE794A8E5BA8FE58897202F20E8A88AE681AFE6B581E7A88BE68896E9979CE881AFE980A3E7B79A222C22436F707920627573696E657373207265666572656E6365223A22E8A487E8A3BDE6A5ADE58B';
wwv_flow_imp.g_varchar2_table(37100) := '99E58F83E88083222C22636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E207B706C616E657D20746F207B726F6F74456C656D656E747D223A22E6ADA3E59CA8E5B087207B706C616E657D20E4B88AE981BAE6BC8FE79A';
wwv_flow_imp.g_varchar2_table(37101) := '842062706D6E456C656D656E7420E69BB4E6ADA3E782BA207B726F6F74456C656D656E747D222C22436F7272656C6174696F6E204B6579223A22E9979CE881AFE7B4A2E5BC95E98DB5222C22436F7272656C6174696F6E2056616C7565223A22E9979CE8';
wwv_flow_imp.g_varchar2_table(37102) := '81AFE580BC222C22437265617465207B747970657D223A22E5BBBAE7AB8B207B747970657D222C224372656174652064617461206F626A656374207265666572656E6365223A22E5BBBAE7AB8BE8B387E69699E789A9E4BBB6E58F83E785A7222C224372';
wwv_flow_imp.g_varchar2_table(37103) := '6561746520646174612073746F7265207265666572656E6365223A22E5BBBAE7AB8BE8B387E69699E5AD98E694BEE58D80E58F83E785A7222C2243726561746520446174614F626A6563745265666572656E6365223A22E5BBBAE7AB8B20446174614F62';
wwv_flow_imp.g_varchar2_table(37104) := '6A6563745265666572656E6365222C22437265617465204461746153746F72655265666572656E6365223A22E5BBBAE7AB8B204461746153746F72655265666572656E6365222C2243726561746520656E64206576656E74223A22E5BBBAE7AB8BE7B590';
wwv_flow_imp.g_varchar2_table(37105) := 'E69D9FE4BA8BE4BBB6222C2243726561746520456E644576656E74223A22E5BBBAE7AB8B20456E644576656E74222C2243726561746520657870616E646564207375622D70726F63657373223A22E5BBBAE7AB8BE693B4E58585E5AD90E89995E7908622';
wwv_flow_imp.g_varchar2_table(37106) := '2C2243726561746520657870616E6465642053756250726F63657373223A22E5BBBAE7AB8BE693B4E58585E79A842053756250726F63657373222C224372656174652067617465776179223A22E5BBBAE7AB8BE99698E98193222C224372656174652047';
wwv_flow_imp.g_varchar2_table(37107) := '617465776179223A22E5BBBAE7AB8BE99698E98193222C224372656174652067726F7570223A22E5BBBAE7AB8BE7BEA4E7B584222C224372656174652047726F7570223A22E5BBBAE7AB8BE7BEA4E7B584222C2243726561746520496E7465726D656469';
wwv_flow_imp.g_varchar2_table(37108) := '6174652F426F756E64617279204576656E74223A22E5BBBAE7AB8BE4B8ADE4BB8B202F20E7958CE99990E4BA8BE4BBB6222C2243726561746520696E7465726D6564696174652F626F756E64617279206576656E74223A22E5BBBAE7AB8BE4B8ADE7B9BC';
wwv_flow_imp.g_varchar2_table(37109) := '202F20E7958CE99990E4BA8BE4BBB6222C22437265617465206E6577202E2E2E223A22E5BBBAE7AB8BE696B0E9A085E79BAE202E2E2E222C2243726561746520506F6F6C2F5061727469636970616E74223A22E5BBBAE7AB8BE4BABAE6898DE5BAAB202F';
wwv_flow_imp.g_varchar2_table(37110) := '20E58F83E88887E88085222C2243726561746520706F6F6C2F7061727469636970616E74223A22E5BBBAE7AB8BE99B86E58D80202F20E58F83E88887E88085222C22437265617465207374617274206576656E74223A22E5BBBAE7AB8BE9968BE5A78BE4';
wwv_flow_imp.g_varchar2_table(37111) := 'BA8BE4BBB6222C224372656174652053746172742054696D6572204576656E74223A22E5BBBAE7AB8BE9968BE5A78BE8A888E69982E599A8E4BA8BE4BBB6222C224372656174652053746172744576656E74223A22E5BBBAE7AB8B205374617274457665';
wwv_flow_imp.g_varchar2_table(37112) := '6E74222C22437265617465207461736B223A22E5BBBAE7AB8BE4BBBBE58B99222C22437265617465205461736B223A22E5BBBAE7AB8BE4BBBBE58B99222C22437573746F6D20457874656E73696F6E223A22E887AAE8A882E693B4E58585E5A597E4BBB6';
wwv_flow_imp.g_varchar2_table(37113) := '222C22437573746F6D223A22E887AAE8A882222C224379636C65202849534F203836303129223A22E980B1E69C9F202849534F203836303129222C224379636C6520284F7261636C6529223A22E980B1E69C9F20284F7261636C6529222C224461746120';
wwv_flow_imp.g_varchar2_table(37114) := '6F626A656374207265666572656E6365223A22E8B387E69699E789A9E4BBB6E58F83E785A7222C2244617461204F626A656374205265666572656E6365223A22E8B387E69699E789A9E4BBB6E58F83E88083222C22446174612073746F72652072656665';
wwv_flow_imp.g_varchar2_table(37115) := '72656E6365223A22E8B387E69699E5AD98E694BEE58D80E58F83E785A7222C22446174612053746F7265205265666572656E6365223A22E8B387E69699E5AD98E694BEE58D80E58F83E785A7222C22446174612054797065223A22E8B387E69699E9A19E';
wwv_flow_imp.g_varchar2_table(37116) := 'E59E8B222C2244617465202849534F203836303129223A22E697A5E69C9F202849534F203836303129222C224461746520284F7261636C6529223A22E697A5E69C9F20284F7261636C6529222C224461746520696E20666F726D617420595959592D4D4D';
wwv_flow_imp.g_varchar2_table(37117) := '2D444420484832343A4D493A5353223A22E6A0BCE5BC8FE782BA20595959592D4D4D2D44442048483234EFBC9A4D493A535320E79A84E697A5E69C9F222C224461746520537472696E67223A22E697A5E69C9FE5AD97E4B8B2222C2244617465223A22E6';
wwv_flow_imp.g_varchar2_table(37118) := '97A5E69C9F222C2244656661756C74204170706C69636174696F6E204944223A22E9A090E8A8ADE68789E794A8E7A88BE5BC8F204944222C2244656661756C74204170706C69636174696F6E223A22E9A090E8A8ADE68789E794A8E7A88BE5BC8F222C22';
wwv_flow_imp.g_varchar2_table(37119) := '44656661756C7420666C6F77223A22E9A090E8A8ADE6B581E7A88B222C2244656661756C742050616765204944223A22E9A090E8A8ADE9A081E99DA2204944222C2244656661756C742050616765223A22E9A090E8A8ADE9A081E99DA2222C2244656661';
wwv_flow_imp.g_varchar2_table(37120) := '756C7420557365726E616D65223A22E9A090E8A8ADE4BDBFE794A8E88085E5908DE7A8B1222C2244656C657465223A22E588AAE999A4222C224465736372697074696F6E223A22E68F8FE8BFB0222C2244657461696C73223A22E8A9B3E7B4B0E8B387E6';
wwv_flow_imp.g_varchar2_table(37121) := '9699222C226469616772616D206E6F742070617274206F662062706D6E3A446566696E6974696F6E73223A22E59C96E4B88DE698AF2062706D6EEFBC9AE5AE9AE7BEA9E79A84E4B880E983A8E58886222C224469737472696275746520656C656D656E74';
wwv_flow_imp.g_varchar2_table(37122) := '7320686F72697A6F6E74616C6C79223A22E6B0B4E5B9B3E58886E9858DE58583E7B4A0222C224469737472696275746520656C656D656E747320766572746963616C6C79223A22E59E82E79BB4E58886E9858DE58583E7B4A0222C224469766964652069';
wwv_flow_imp.g_varchar2_table(37123) := '6E746F207468726565206C616E6573223A22E58886E782BAE4B889E6A29DE8B7AFE7B79A222C2244697669646520696E746F2074776F206C616E6573223A22E58886E782BAE585A9E5808BE8B7AFE7B79A222C22446F63756D656E746174696F6E223A22';
wwv_flow_imp.g_varchar2_table(37124) := 'E69687E4BBB6222C22447565204F6E223A22E588B0E69C9FE697A5222C224475706C696361746520696E636F6D696E672073657175656E636520666C6F7773223A22E9878DE8A487E79A84E582B3E585A5E9A086E5BA8FE6B581E7A88B222C224475706C';
wwv_flow_imp.g_varchar2_table(37125) := '6963617465206F7574676F696E672073657175656E636520666C6F7773223A22E9878DE8A487E5A496E98081E9A086E5BA8FE6B581E7A88B222C224475726174696F6E202849534F203836303129223A22E68C81E7BA8CE69982E99693202849534F2038';
wwv_flow_imp.g_varchar2_table(37126) := '36303129222C224475726174696F6E20284F7261636C6529223A22E68C81E7BA8CE69982E9969320284F7261636C6529222C224475726174696F6E20696E2049534F2038363031206F72204F7261636C6520496E74657276616C204453205C2744444420';
wwv_flow_imp.g_varchar2_table(37127) := '484832343A4D493A53535C2720666F726D6174223A2249534F203836303120E68896204F7261636C6520E99693E99A94204453205C2744444420484832343A4D493A53535C2720E6A0BCE5BC8FE79A84E68C81E7BA8CE69982E99693222C22652E672E20';
wwv_flow_imp.g_varchar2_table(37128) := '32332D4A554E2D323032372031343A31303A3030223A22E4BE8BE5A682EFBC9A3230323720E5B9B4203620E69C8820323320E697A52031343A31303A3030222C22652E672E2044442D4D4F4E2D5959595920484832343A4D493A5353223A22E4BE8BE5A6';
wwv_flow_imp.g_varchar2_table(37129) := '822044442D4D4F4E2D595959592048483234EFBC9A4D493A5353222C22656C656D656E74207B656C656D656E747D207265666572656E636564206279207B7265666572656E6365647D237B70726F70657274797D206E6F742079657420647261776E223A';
wwv_flow_imp.g_varchar2_table(37130) := '22E5B09AE69CAAE7B9AAE8A3BDE794B1207B7265666572656E63657D237B70726F70657274797D20E68980E58F83E785A7E79A84E58583E7B4A0207B656C656D656E747D222C22456C656D656E7420646F63756D656E746174696F6E223A22E58583E7B4';
wwv_flow_imp.g_varchar2_table(37131) := 'A0E69687E4BBB6222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A436F6D706C6578476174657761793E223A22E58583E7B4A0E79A84E9A19EE59E8BE4B88DE58581E8A8B1203C62706D6E3A436F6D706C6578';
wwv_flow_imp.g_varchar2_table(37132) := '476174657761793E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A4D65737361676553746172744576656E743E223A22E58583E7B4A0E585B7E69C89E4B88DE58581E8A8B1E79A84E9A19EE59E8B203C6270';
wwv_flow_imp.g_varchar2_table(37133) := '6D6E3A4D65737361676553746172744576656E743E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E3A5369676E616C53746172744576656E743E223A22E58583E7B4A0E585B7E69C89E4B88DE58581E8A8B1E7';
wwv_flow_imp.g_varchar2_table(37134) := '9A84E9A19EE59E8B203C62706D6E3A5369676E616C53746172744576656E743E222C22456C656D656E742068617320646973616C6C6F7765642074797065203C62706D6E436F6E646974696F6E616C53746172744576656E743E223A22E58583E7B4A0E5';
wwv_flow_imp.g_varchar2_table(37135) := '85B7E69C89E4B88DE58581E8A8B1E79A84E9A19EE59E8B203C62706D6E436F6E646974696F6E616C53746172744576656E743E222C22456C656D656E74204944206973206C6F6E676572207468616E2035302063686172616374657273223A22E58583E7';
wwv_flow_imp.g_varchar2_table(37136) := 'B4A020494420E79A84E995B7E5BAA6E8B685E9818E20353020E5808BE5AD97E58583222C22456C656D656E7420494420776173206E6F74206368616E67656420796574223A22E5B09AE69CAAE8AE8AE69BB4E58583E7B4A0204944222C22456C656D656E';
wwv_flow_imp.g_varchar2_table(37137) := '7420697320616E20696D706C6963697420656E64223A22E58583E7B4A0E782BAE99AB1E590ABE7B590E5B0BE222C22456C656D656E7420697320616E20696D706C69636974207374617274223A22E58583E7B4A0E782BAE99AB1E590ABE9968BE9A0AD22';
wwv_flow_imp.g_varchar2_table(37138) := '2C22456C656D656E74206973206D697373696E67206C6162656C2F6E616D65223A22E58583E7B4A0E981BAE6BC8F206C6162656C2F6E616D65222C22456C656D656E74206973206E6F7420636F6E6E6563746564223A22E69CAAE980A3E68EA5E58583E7';
wwv_flow_imp.g_varchar2_table(37139) := 'B4A0222C22656C656D656E74207265717569726564223A22E5BF85E8A681E58583E7B4A0222C22456D61696C20636F6E74656E74223A22E99BBBE5AD90E983B5E4BBB6E585A7E5AEB9222C22456D61696C206F662074686520726563697069656E742873';
wwv_flow_imp.g_varchar2_table(37140) := '29223A22E694B6E4BBB6E88085E79A84E99BBBE5AD90E983B5E4BBB6E59CB0E59D80222C22456D61696C206F66207468652073656E646572223A22E5AF84E4BBB6E88085E79A84E99BBBE5AD90E983B5E4BBB6E59CB0E59D80222C22456D61696C207768';
wwv_flow_imp.g_varchar2_table(37141) := '65726520746865207265706C792073686F756C642062652073656E6420746F223A22E59B9EE8A686E79A84E5AF84E4BBB6E88085E99BBBE5AD90E983B5E4BBB6222C22456D70747920706F6F6C2F7061727469636970616E74202872656D6F7665732063';
wwv_flow_imp.g_varchar2_table(37142) := '6F6E74656E7429223A22E7A9BAE79A84E99B86E58D80202F20E58F83E88887E880852028E7A7BBE999A4E585A7E5AEB929222C22456D70747920706F6F6C2F7061727469636970616E74223A22E7A9BAE79A84E99B86E58D80202F20E58F83E88887E880';
wwv_flow_imp.g_varchar2_table(37143) := '85222C22456E64206576656E74223A22E7B590E69D9FE4BA8BE4BBB6222C22456E64204576656E74223A22E7B590E69D9FE4BA8BE4BBB6222C22456E64706F696E74223A22E7ABAFE9BB9E222C22456E74657220637573746F6D20657874656E73696F6E';
wwv_flow_imp.g_varchar2_table(37144) := '73206173204A534F4E223A22E8BCB8E585A5E887AAE8A882E693B4E58585E4BD9CE782BA204A534F4E222C22456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E223A22E8BCB8E585A5E8A681E59FB7E8A18CE7';
wwv_flow_imp.g_varchar2_table(37145) := '9A8420504C2F53514C20E7A88BE5BC8FE7A2BCE38082222C224572726F7220626F756E64617279206576656E74223A22E98CAFE8AAA4E7958CE99990E4BA8BE4BBB6222C224572726F7220656E64206576656E74223A22E98CAFE8AAA4E7B590E69D9FE4';
wwv_flow_imp.g_varchar2_table(37146) := 'BA8BE4BBB6222C224572726F7220456E64204576656E74223A22E98CAFE8AAA4E7B590E69D9FE4BA8BE4BBB6222C224572726F72207374617274206576656E74223A22E98CAFE8AAA4E9968BE5A78BE4BA8BE4BBB6222C224572726F72223A22E98CAFE8';
wwv_flow_imp.g_varchar2_table(37147) := 'AAA4222C22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E59188E5A0B1E7958CE99990E4BA8BE4BBB62028E99D9EE4B8ADE696B729222C22457363616C6174696F6E20626F756E';
wwv_flow_imp.g_varchar2_table(37148) := '64617279206576656E74223A22E59188E5A0B1E7958CE99990E4BA8BE4BBB6222C22457363616C6174696F6E20456E64204576656E74223A22E59188E5A0B1E7B590E69D9FE4BA8BE4BBB6222C22457363616C6174696F6E20656E64206576656E74223A';
wwv_flow_imp.g_varchar2_table(37149) := '22E68F90E58D87E7B590E69D9FE4BA8BE4BBB6222C22457363616C6174696F6E20696E7465726D656469617465207468726F77206576656E74223A22E59188E5A0B1E4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C22457363616C6174696F6E20496E';
wwv_flow_imp.g_varchar2_table(37150) := '7465726D656469617465205468726F77204576656E74223A22E59188E5A0B1E4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E59188E5';
wwv_flow_imp.g_varchar2_table(37151) := 'A0B1E9968BE5A78BE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C22457363616C6174696F6E207374617274206576656E74223A22E68F90E58D87E9968BE5A78BE4BA8BE4BBB6222C22457363616C6174696F6E223A22E59188E5A0B1222C22457665';
wwv_flow_imp.g_varchar2_table(37152) := '6E742042617365642047617465776179223A22E4BA8BE4BBB6E59E8BE99698E98193222C224576656E7420686173206D756C7469706C65206576656E7420646566696E6974696F6E73223A22E4BA8BE4BBB6E585B7E69C89E5A49AE5808BE4BA8BE4BBB6';
wwv_flow_imp.g_varchar2_table(37153) := 'E5AE9AE7BEA9222C224576656E74205375622050726F63657373223A22E4BA8BE4BBB6E5AD90E89995E79086222C224576656E74207375622D70726F63657373223A22E4BA8BE4BBB6E5AD90E89995E79086222C224576656E742054797065223A22E4BA';
wwv_flow_imp.g_varchar2_table(37154) := '8BE4BBB6E9A19EE59E8B222C224576656E742D62617365642067617465776179223A22E4BA8BE4BBB6E59E8BE99698E98193222C224578636C75646564205374617274696E67205573657273223A22E68E92E999A4E79A84E9968BE5A78BE4BDBFE794A8';
wwv_flow_imp.g_varchar2_table(37155) := 'E88085222C224578636C75646564205573657273223A22E68E92E999A4E79A84E4BDBFE794A8E88085222C224578636C75736976652067617465776179223A22E5B088E794A8E99698E98193222C224578636C75736976652047617465776179223A22E6';
wwv_flow_imp.g_varchar2_table(37156) := '8E92E4BB96E59E8BE99698E98193222C2245786563757461626C65223A22E59FB7E8A18CE6AA94222C224578656375746520504C2F53514C223A22E59FB7E8A18C20504C2F53514C222C22457865637574696F6E223A22E59FB7E8A18C222C2245787061';
wwv_flow_imp.g_varchar2_table(37157) := '6E64656420706F6F6C2F7061727469636970616E74223A22E5B195E9968BE79A84E99B86E58D80202F20E58F83E88887E88085222C22457870616E646564205375622050726F63657373223A22E5B195E9968BE79A84E5AD90E89995E79086222C224578';
wwv_flow_imp.g_varchar2_table(37158) := '7072657373696F6E20284C656761637929223A22E8A1A8E7A4BAE5BC8F2028E8888AE69C8929222C2245787072657373696F6E2054797065223A22E8A1A8E7A4BAE5BC8FE9A19EE59E8B222C2245787072657373696F6E223A22E8A1A8E7A4BAE5BC8F22';
wwv_flow_imp.g_varchar2_table(37159) := '2C226661696C656420746F20696D706F7274207B656C656D656E747D223A22E784A1E6B395E58CAFE585A5207B656C656D656E747D222C22666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F70617274';
wwv_flow_imp.g_varchar2_table(37160) := '69636970616E7473223A22E6B581E7A88BE58583E7B4A0E5BF85E9A088E698AFE99B86E58D80202F20E58F83E88887E88085E79A84E5AD90E9A085222C22466C6F772073706C69747320696D706C696369746C79223A22E4BBA5E99AB1E590ABE696B9E5';
wwv_flow_imp.g_varchar2_table(37161) := 'BC8FE58886E589B2E6B581E7A88B222C22466F726D2054656D706C617465204974656D204E616D65223A22E8A1A8E596AEE7AF84E69CACE9A085E79BAEE5908DE7A8B1222C22466F726D2054656D706C617465204974656D223A22E8A1A8E596AEE7AF84';
wwv_flow_imp.g_varchar2_table(37162) := 'E69CACE9A085E79BAE222C22466F726D2054656D706C617465223A22E8A1A8E596AEE7AF84E69CAC222C22466F726D6174204D61736B223A22E6A0BCE5BC8FE981AEE7BDA9222C22466F726D61744D61736B223A22466F726D61744D61736B222C224672';
wwv_flow_imp.g_varchar2_table(37163) := '6F6D223A22E8B5B7E5A78B222C2246756E6374696F6E20426F647920284C656761637929223A22E587BDE695B8E4B8BBE9AB942028E8888AE69C8929222C2246756E6374696F6E20426F6479223A22E587BDE695B8E4B8BBE9AB94222C22476174657761';
wwv_flow_imp.g_varchar2_table(37164) := '79206973207375706572666C756F75732E204974206F6E6C7920686173206F6E6520736F7572636520616E64207461726765742E223A22E99698E98193E5A49AE9A498E38082E5AE83E58FAAE69C89E4B880E5808BE4BE86E6BA90E5928CE79BAEE6A899';
wwv_flow_imp.g_varchar2_table(37165) := 'E38082222C2247656E6572616C223A22E4B880E888AC222C2247656E65726174652064656661756C74206974656D73223A22E794A2E7949FE9A090E8A8ADE9A085E79BAE222C22476C6F62616C206572726F72207265666572656E6365223A22E585A8E5';
wwv_flow_imp.g_varchar2_table(37166) := '9F9FE98CAFE8AAA4E58F83E88083222C22476C6F62616C20657363616C6174696F6E207265666572656E6365223A22E585A8E59F9FE59188E5A0B1E58F83E88083222C22476C6F62616C207369676E616C207265666572656E6365223A22E585A8E59F9F';
wwv_flow_imp.g_varchar2_table(37167) := 'E4BFA1E8999FE58F83E88083222C2247726F7570223A22E7BEA4E7B584222C2248544D4C2076657273696F6E206F662074686520656D61696C223A22E99BBBE5AD90E983B5E4BBB6E79A842048544D4C20E78988E69CAC222C224944206D757374206265';
wwv_flow_imp.g_varchar2_table(37168) := '20756E697175652E223A22494420E5BF85E9A088E698AFE594AFE4B880E79A84E38082222C224944223A224944222C22696E20666F726D6174204444442048483A4D4D3A5353223A22E6A0BCE5BC8FE782BA204444442048483A4D4D3A5353222C22696E';
wwv_flow_imp.g_varchar2_table(37169) := '20666F726D61742059592D4D4D223A22E6A0BCE5BC8FE782BA2059592D4D4D222C22496E205661726961626C6573223A22E59CA8E8AE8AE695B8E4B8AD222C22496E2F4F7574204D617070696E67223A22E8BCB8E585A5202F20E8BCB8E587BAE5B08DE6';
wwv_flow_imp.g_varchar2_table(37170) := '8789222C22496E2F4F7574205661726961626C6573223A22E8BCB8E585A5202F20E8BCB8E587BAE8AE8AE695B8222C22496E636C75736976652067617465776179223A22E58C85E590ABE59E8BE99698E98193222C22496E636F6D696E6720666C6F7773';
wwv_flow_imp.g_varchar2_table(37171) := '20646F206E6F74206A6F696E223A22E585A7E98081E6B581E7A88BE69CAAE7B590E59088222C22496E69746961746F72206F66207468697320617070726F76616C207461736B223A22E6ADA4E6A0B8E58786E4BBBBE58B99E79A84E8B5B7E5A78BE88085';
wwv_flow_imp.g_varchar2_table(37172) := '222C22496E69746961746F72223A22E5959FE58B95E599A8222C22496E70757420436F6C6C656374696F6E223A22E8BCB8E585A5E694B6E99B86222C22496E70757420456C656D656E74223A22E8BCB8E585A5E58583E7B4A0222C22496E7465726D6564';
wwv_flow_imp.g_varchar2_table(37173) := '69617465207468726F77206576656E74223A22E4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C22496E7465726D656469617465205468726F77204576656E74223A22E4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C22496E74657276616C223A22E9';
wwv_flow_imp.g_varchar2_table(37174) := '9693E99A94222C2249732043616C6C61626C65223A22E58FAFE591BCE58FAB222C22497320526F6C65223A22E698AFE8A792E889B2222C22497320537461727461626C65223A22E58FAFE5959FE58B95222C2249534F223A2249534F222C224974656D20';
wwv_flow_imp.g_varchar2_table(37175) := '4E616D65223A22E9A085E79BAEE5908DE7A8B1222C224974656D2056616C7565223A22E9A085E79BAEE580BC222C224974656D223A22E9A085E79BAE222C22497465726174696E672063616C6C20616374697669746573206172652063757272656E746C';
wwv_flow_imp.g_varchar2_table(37176) := '79206E6F7420737570706F72746564223A22E79BAEE5898DE4B88DE694AFE68FB4E58F8DE8A686E591BCE58FABE6B4BBE58B95222C224A534F4E204F626A656374223A224A534F4E20E789A9E4BBB6222C224C616E65223A22E8B7AFE7B79A222C224C61';
wwv_flow_imp.g_varchar2_table(37177) := '746573742076657273696F6E223A22E69C80E696B0E78988E69CAC222C224C696E6B20696E7465726D656469617465206361746368206576656E74223A22E980A3E7B590E4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C224C696E6B20496E7465726D';
wwv_flow_imp.g_varchar2_table(37178) := '656469617465204361746368204576656E74223A22E980A3E7B590E4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C224C696E6B20696E7465726D656469617465207468726F77206576656E74223A22E980A3E7B590E4B8ADE7B9BCE799BCE587BAE4BA';
wwv_flow_imp.g_varchar2_table(37179) := '8BE4BBB6222C224C696E6B20496E7465726D656469617465205468726F77204576656E74223A22E980A3E7B590E4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C224C696E6B223A22E980A3E7B590222C224C6F616420646566696E6564207661726961';
wwv_flow_imp.g_varchar2_table(37180) := '626C6573223A22E8BC89E585A5E5AE9AE7BEA9E8AE8AE695B8222C224C6F6164204A534F4E223A22E8BC89E585A5204A534F4E222C224C6F616420506172616D6574657273223A22E8BC89E585A5E58F83E695B8222C224C6F6F70223A22E8BFB4E59C88';
wwv_flow_imp.g_varchar2_table(37181) := '222C224D61696C223A22E983B5E4BBB6222C224D616E75616C207461736B223A22E6898BE58B95E4BBBBE58B99222C224D616E75616C205461736B223A22E6898BE58B95E4BBBBE58B99222C224D61782052756E73223A22E59FB7E8A18CE6ACA1E695B8';
wwv_flow_imp.g_varchar2_table(37182) := 'E4B88AE99990222C224D65737361676520626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E8A88AE681AFE9828AE7958CE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C224D65737361676520626F756E6461';
wwv_flow_imp.g_varchar2_table(37183) := '7279206576656E74223A22E8A88AE681AFE7958CE99990E4BA8BE4BBB6222C224D65737361676520656E64206576656E74223A22E8A88AE681AFE7B590E69D9FE4BA8BE4BBB6222C224D65737361676520456E64204576656E74223A22E8A88AE681AFE7';
wwv_flow_imp.g_varchar2_table(37184) := 'B590E69D9FE4BA8BE4BBB6222C224D65737361676520696E7465726D656469617465206361746368206576656E74223A22E8A88AE681AFE4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C224D65737361676520496E7465726D65646961746520436174';
wwv_flow_imp.g_varchar2_table(37185) := '6368204576656E74223A22E8A88AE681AFE4B8ADE99693E693B7E58F96E4BA8BE4BBB6222C224D65737361676520696E7465726D656469617465207468726F77206576656E74223A22E8A88AE681AFE4B8ADE7B9BCE799BCE587BAE4BA8BE4BBB6222C22';
wwv_flow_imp.g_varchar2_table(37186) := '4D65737361676520496E7465726D656469617465205468726F77204576656E74223A22E8A88AE681AFE4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C224D657373616765204E616D65223A22E8A88AE681AFE5908DE7A8B1222C224D65737361676520';
wwv_flow_imp.g_varchar2_table(37187) := '7374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E8A88AE681AFE9968BE5A78BE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C224D657373616765207374617274206576656E74223A22E8A88AE681AFE9968BE5A78B';
wwv_flow_imp.g_varchar2_table(37188) := 'E4BA8BE4BBB6222C224D657373616765205374617274204576656E74223A22E8A88AE681AFE9968BE5A78BE4BA8BE4BBB6222C226D697373696E67207B73656D616E7469637D236174746163686564546F526566223A22E981BAE6BC8F207B73656D616E';
wwv_flow_imp.g_varchar2_table(37189) := '7469637D236174746163686564546F526566222C226D6F7265207468616E207B636F756E747D206368696C64206C616E6573223A22E8B685E9818E207B636F756E747D20E5808BE5AD90E8B7AFE7B79A222C224D756C74692D496E7374616E6365223A22';
wwv_flow_imp.g_varchar2_table(37190) := 'E5A49AE9878DE59FB7E8A18CE89995E79086222C226D756C7469706C6520444920656C656D656E747320646566696E656420666F72207B656C656D656E747D223A22E782BA207B656C656D656E747D20E5AE9AE7BEA9E79A84E5A49AE5808B20444920E5';
wwv_flow_imp.g_varchar2_table(37191) := '8583E7B4A0222C224E616D65206F6620746865206469616772616D223A22E59C96E8A1A8E5908DE7A8B1222C224E616D65206F66207468652050726F63657373205661726961626C6520286F6620747970652054696D657374616D702077697468205469';
wwv_flow_imp.g_varchar2_table(37192) := '6D65205A6F6E6529223A22E89995E79086E8AE8AE695B8E5908DE7A8B12028E69982E688B3E9A19EE59E8BE782BAE69982E58D8029222C224E616D65206F66207468652050726F63657373205661726961626C65223A22E89995E79086E8AE8AE695B8E5';
wwv_flow_imp.g_varchar2_table(37193) := '908DE7A8B1222C224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C20726573756C7420696E746F223A22E582B3E59B9EE6A0B8E58786E7B590E69E9CE79A84E8AE8AE695B8E5908DE7A8B122';
wwv_flow_imp.g_varchar2_table(37194) := '2C224E616D65223A22E5908DE7A8B1222C224E616D65642076657273696F6E223A22E5B7B2E591BDE5908DE78988E69CAC222C226E6F2062706D6E456C656D656E74207265666572656E63656420696E207B656C656D656E747D223A227B656C656D656E';
wwv_flow_imp.g_varchar2_table(37195) := '747D20E4B8ADE69CAAE58F83E785A72062706D6E456C656D656E74222C226E6F206469616772616D20746F20646973706C6179223A22E6B292E69C89E58FAFE9A1AFE7A4BAE79A84E59C96E8A1A8222C226E6F20706172656E7420666F72207B656C656D';
wwv_flow_imp.g_varchar2_table(37196) := '656E747D20696E207B706172656E747D223A227B706172656E747D20E4B8ADE6B292E69C89207B656C656D656E747D20E79A84E788B6E9A085222C226E6F20706C616E6520666F72207B656C656D656E747D223A227B656C656D656E747D20E6B292E69C';
wwv_flow_imp.g_varchar2_table(37197) := '89E5B9B3E99DA2222C226E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C6179223A22E6B292E69C89E58FAFE9A1AFE7A4BAE79A84E89995E79086E68896E58D94E5908CE59088E4BD9C222C226E6F2073686170';
wwv_flow_imp.g_varchar2_table(37198) := '65207479706520737065636966696564223A22E69CAAE68C87E5AE9AE8B387E6BA90E9858DE7BDAEE9A19EE59E8B222C224E756D626572223A22E7B7A8E8999F222C224F6E204576656E74223A22E4BA8BE4BBB6E799BCE7949FE69982222C224F726163';
wwv_flow_imp.g_varchar2_table(37199) := '6C65205363686564756C652065787072657373696F6E223A224F7261636C65205363686564756C6520E8A1A8E7A4BAE5BC8F222C224F7261636C65223A224F7261636C65222C226F7574206F6620626F756E64732072656C65617365223A22E8B685E587';
wwv_flow_imp.g_varchar2_table(37200) := 'BAE7AF84E59C8DE9878BE694BE222C224F7574205661726961626C6573223A22E8BCB8E587BAE8AE8AE695B8222C224F757470757420436F6C6C656374696F6E223A22E8BCB8E587BAE99B86E59088222C224F757470757420456C656D656E74223A22E8';
wwv_flow_imp.g_varchar2_table(37201) := 'BCB8E587BAE58583E7B4A0222C224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E223A22E8A686E5AFABE4BBBBE58B99E5AE9AE7BEA9E4B8ADE79A84E9A090E8A8ADE580BCE99B8622';
wwv_flow_imp.g_varchar2_table(37202) := '2C2250616765204944223A22E9A081E99DA2204944222C2250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E6365223A22E58C85E590ABE8A1A8E596AEE7AF84E69CACE58F83E88083E7';
wwv_flow_imp.g_varchar2_table(37203) := '9A84E9A081E99DA2E9A085E79BAE222C2250616765204974656D73223A22E9A081E99DA2E9A085E79BAE222C2250616765223A22E9A081E99DA2222C22506172616C6C656C2067617465776179223A22E5B9B3E8A18CE99698E98193222C22506172616C';
wwv_flow_imp.g_varchar2_table(37204) := '6C656C2047617465776179223A22E5B9B3E8A18CE99698E98193222C22506172616C6C656C206D756C74692D696E7374616E6365223A22E5B9B3E8A18CE5A49AE9878DE59FB7E8A18CE89995E79086222C225061727469636970616E74204944223A22E5';
wwv_flow_imp.g_varchar2_table(37205) := '8F83E88887E88085204944222C225061727469636970616E74206D756C7469706C6963697479223A22E58F83E88887E88085E5A49AE9878DE680A7222C225061727469636970616E74204E616D65223A22E58F83E88887E88085E5908DE7A8B1222C2250';
wwv_flow_imp.g_varchar2_table(37206) := '61727469636970616E74223A22E58F83E88887E88085222C225061796C6F6164205661726961626C65223A22E69C89E69588E8B2A0E8BC89E8AE8AE695B8222C225061796C6F6164223A22E69C89E69588E8B2A0E8BC89222C22504C2F53514C20436F64';
wwv_flow_imp.g_varchar2_table(37207) := '65223A22504C2F53514C20E7A88BE5BC8FE7A2BC222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C7565223A22E582B3E59B9EE5B883E69E97E580BCE79A8420504C2F53514C20E8A1A8E7A4';
wwv_flow_imp.g_varchar2_table(37208) := 'BAE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E67206120646174652076616C7565223A22E582B3E59B9EE697A5E69C9FE580BCE79A8420504C2F53514C20E8A1A8E7A4BAE5BC8F222C22504C2F53514C204578707265';
wwv_flow_imp.g_varchar2_table(37209) := '7373696F6E2072657475726E696E672061206E756D6265722076616C7565223A22E582B3E59B9EE695B8E580BCE79A8420504C2F53514C20E8A1A8E7A4BAE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E672061205469';
wwv_flow_imp.g_varchar2_table(37210) := '6D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E582B3E59B9EE69982E58D80E580BCE69982E688B3E79A8420504C2F53514C20E8A1A8E7A4BAE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E69';
wwv_flow_imp.g_varchar2_table(37211) := '6E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22E582B3E59B9EE6A0BCE5BC8FE782BA20595959592D4D4D2D444420E79A8420766172636861723220E580';
wwv_flow_imp.g_varchar2_table(37212) := 'BCE79A8420504C2F53514C20E8A1A8E7A4BAE5BC8F2048483234EFBC9A4D493A535320545A52222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D61742059595959';
wwv_flow_imp.g_varchar2_table(37213) := '2D4D4D2D444420484832343A4D493A5353223A22E582B3E59B9EE6A0BCE5BC8FE782BA20595959592D4D4D2D444420E79A8420766172636861723220E580BCE79A8420504C2F53514C20E8A1A8E7A4BAE5BC8F2048483234EFBC9A4D493A5353222C2250';
wwv_flow_imp.g_varchar2_table(37214) := '4C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22E4BBA5E695B8E5AD97E6A0BCE5BC8FE582B3E59B9E20766172636861723220E580BCE79A84';
wwv_flow_imp.g_varchar2_table(37215) := '20504C2F53514C20E8A1A8E7A4BAE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C7565223A22E582B3E59B9E20766172636861723220E580BCE79A8420504C2F53514C20E8A1A8';
wwv_flow_imp.g_varchar2_table(37216) := 'E7A4BAE5BC8F222C22504C2F53514C2045787072657373696F6E2072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22E582B3E59B9EE69982E58D80E4B98BE69982E688B3E79A8420504C2F53514C20E8A1A8E7';
wwv_flow_imp.g_varchar2_table(37217) := 'A4BAE5BC8F222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C7565223A22E582B3E59B9EE5B883E69E97E580BCE79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C';
wwv_flow_imp.g_varchar2_table(37218) := '2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120646174652076616C7565223A22E582B3E59B9EE697A5E69C9FE580BCE79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C2F53514C2046756E6374696F6E';
wwv_flow_imp.g_varchar2_table(37219) := '20426F64792072657475726E696E672061206E756D6265722076616C7565223A22E582B3E59B9EE695B8E580BCE79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E';
wwv_flow_imp.g_varchar2_table(37220) := '6720612054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E582B3E59B9EE590ABE69982E58D80E580BCE4B98BE69982E688B3E79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C2F53514C2046756E';
wwv_flow_imp.g_varchar2_table(37221) := '6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A52223A22E582B3E59B9EE6A0BCE5BC8FE782BA20595959592D4D4D2D';
wwv_flow_imp.g_varchar2_table(37222) := '444420E79A8420766172636861723220E580BCE79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB942048483234EFBC9A4D493A535320545A52222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061207661726368';
wwv_flow_imp.g_varchar2_table(37223) := '6172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A5353223A22E582B3E59B9EE6A0BCE5BC8FE782BA20595959592D4D4D2D444420E79A8420766172636861723220E580BCE79A8420504C2F53514C20E587';
wwv_flow_imp.g_varchar2_table(37224) := 'BDE695B8E4B8BBE9AB942048483234EFBC9A4D493A5353222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D6174223A22E582B3E59B9EE6';
wwv_flow_imp.g_varchar2_table(37225) := '95B8E5AD97E6A0BCE5BC8FE4B98B20766172636861723220E580BCE79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C7565';
wwv_flow_imp.g_varchar2_table(37226) := '223A22E582B3E59B9E20766172636861723220E580BCE79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054696D65205A';
wwv_flow_imp.g_varchar2_table(37227) := '6F6E65223A22E582B3E59B9EE69982E58D80E69982E688B3E79A8420504C2F53514C20E587BDE695B8E4B8BBE9AB94222C22504C2F53514C223A22504C2F53514C222C22506C616365686F6C646572223A22E9A090E79599E4BD8DE7BDAE222C22506F74';
wwv_flow_imp.g_varchar2_table(37228) := '656E7469616C2047726F757073223A22E6BD9BE59CA8E7BEA4E7B584222C22506F74656E7469616C205374617274657273223A22E6BD9BE59CA8E585A5E99680222C22506F74656E7469616C205374617274696E672047726F757073223A22E6BD9BE59C';
wwv_flow_imp.g_varchar2_table(37229) := 'A8E9968BE5A78BE7BEA4E7B584222C22506F74656E7469616C205374617274696E67205573657273223A22E6BD9BE59CA8E9968BE5A78BE4BDBFE794A8E88085222C22506F74656E7469616C205573657273223A22E6BD9BE59CA8E4BDBFE794A8E88085';
wwv_flow_imp.g_varchar2_table(37230) := '222C225072696F72697479223A22E584AAE58588E9A086E5BA8F222C2250726F6365737320646F63756D656E746174696F6E223A22E6B581E7A88BE69687E4BBB6222C2250726F6365737320686173206D756C7469706C6520626C616E6B207374617274';
wwv_flow_imp.g_varchar2_table(37231) := '206576656E7473223A22E89995E79086E585B7E69C89E5A49AE5808BE7A9BAE799BDE79A84E9968BE5A78BE4BA8BE4BBB6222C2250726F63657373204944223A22E8BF87E7A88BE6A087E8AF86222C2250726F63657373206973206D697373696E672065';
wwv_flow_imp.g_varchar2_table(37232) := '6E64206576656E74223A22E89995E79086E981BAE6BC8FE7B590E69D9FE4BA8BE4BBB6222C2250726F63657373206973206D697373696E67207374617274206576656E74223A22E89995E79086E981BAE6BC8FE9968BE5A78BE4BA8BE4BBB6222C225072';
wwv_flow_imp.g_varchar2_table(37233) := '6F63657373206E616D65223A22E8BF87E7A88BE5908DE7A7B0222C2250726F63657373205072696F72697479223A22E89995E79086E584AAE58588E9A086E5BA8F222C2250726F6365737320737461747573206166746572207465726D696E6174696F6E';
wwv_flow_imp.g_varchar2_table(37234) := '223A22E7B582E6ADA2E5BE8CE79A84E89995E79086E78B80E6858B222C2250726F63657373205661726961626C652028417272617929223A22E89995E79086E4BD9CE6A5ADE8AE8AE695B82028E999A3E5889729222C2250726F63657373205661726961';
wwv_flow_imp.g_varchar2_table(37235) := '626C6520284C69737429223A22E89995E79086E8AE8AE695B82028E6B885E596AE29222C2250726F63657373205661726961626C65223A22E89995E79086E8AE8AE695B8222C2250726F63657373223A22E89995E79086222C2250726F76696465207661';
wwv_flow_imp.g_varchar2_table(37236) := '6C75657320666F7220656D61696C2074656D706C617465223A22E68F90E4BE9BE99BBBE5AD90E983B5E4BBB6E6A8A3E69DBFE79A84E580BC222C2252656365697665207461736B223A22E68EA5E694B6E4BBBBE58B99222C225265636569766520546173';
wwv_flow_imp.g_varchar2_table(37237) := '6B223A22E68EA5E694B6E4BBBBE58B99222C225265646F223A22E9878DE5819A222C2252656D6F7665223A22E7A7BBE999A4222C225265706C7920546F223A22E59B9EE8A686E5B08DE8B1A1222C22526571756573742056616C756520666F7220506167';
wwv_flow_imp.g_varchar2_table(37238) := '652043616C6C223A22E9A081E99DA2E591BCE58FABE8A681E6B182E580BC222C2252657175657374223A22E8A681E6B182222C22526573756C74205661726961626C65223A22E7B590E69E9CE8AE8AE695B8222C2252657475726E205061796C6F616420';
wwv_flow_imp.g_varchar2_table(37239) := '496E746F223A22E5B087E69C89E69588E8B2A0E8BC89E6ADB8E585A5222C22526F6C65223A22E8A792E889B2222C2253617665223A22E584B2E5AD98222C225363686564756C65722045787072657373696F6E223A22E68E92E7A88BE599A8E8A1A8E7A4';
wwv_flow_imp.g_varchar2_table(37240) := 'BAE5BC8F222C225363686564756C696E67223A22E68E92E7A88B222C22536372697074205461736B223A22E68C87E4BBA4E7A2BCE4BBBBE58B99222C22536372697074207461736B223A22E69687E7A8BFE5B7A5E4BD9C222C2253656C65637420696620';
wwv_flow_imp.g_varchar2_table(37241) := '74686973206469616772616D20697320737461727461626C65223A22E5A682E69E9CE6ADA4E59C96E8A1A8E698AFE58FAFE9968BE5A78BE79A84EFBC8CE8AB8BE981B8E69387E6ADA4E9A085E79BAE222C2253656C656374206966207468697320646961';
wwv_flow_imp.g_varchar2_table(37242) := '6772616D2073686F756C642062652063616C6C656420696E20612043616C6C204163746976697479223A22E5A682E69E9CE68789E8A9B2E59CA8E3808CE99BBBE8A8AAE6B4BBE58B95E3808DE4B8ADE591BCE58FABE6ADA4E59C96E8A1A8EFBC8CE8AB8B';
wwv_flow_imp.g_varchar2_table(37243) := 'E981B8E58F96222C2253656E6420456D61696C20496D6D6564696174656C79223A22E7AB8BE58DB3E582B3E98081E99BBBE5AD90E983B5E4BBB6222C2253656E64204D61696C223A22E582B3E98081E983B5E4BBB6222C2253656E64207461736B223A22';
wwv_flow_imp.g_varchar2_table(37244) := 'E582B3E98081E4BBBBE58B99222C2253656E64205461736B223A22E582B3E98081E4BBBBE58B99222C2253657175656E636520666C6F77223A22E9A086E5BA8FE6B581E7A88B222C2253657175656E6365223A22E9A086E5BA8F222C2253657175656E63';
wwv_flow_imp.g_varchar2_table(37245) := '65466C6F772069732061206475706C6963617465223A2253657175656E6365466C6F7720E9878DE8A487222C2253657175656E7469616C206D756C74692D696E7374616E6365223A22E5BEAAE5BA8FE5A49AE59FB7E8A18CE89995E79086222C22536572';
wwv_flow_imp.g_varchar2_table(37246) := '76696365207461736B223A22E69C8DE58B99E4BBBBE58B99222C2253657276696365205461736B223A22E69C8DE58B99E4BBBBE58B99222C2253657420636F6C6F72223A22E8A8ADE5AE9AE9A18FE889B2222C225369676E616C20626F756E6461727920';
wwv_flow_imp.g_varchar2_table(37247) := '6576656E7420286E6F6E2D696E74657272757074696E6729223A22E8A88AE8999FE7958CE99990E4BA8BE4BBB62028E99D9EE4B8ADE696B729222C225369676E616C20626F756E64617279206576656E74223A22E8A88AE8999FE7958CE99990E4BA8BE4';
wwv_flow_imp.g_varchar2_table(37248) := 'BBB6222C225369676E616C20656E64206576656E74223A22E8A88AE8999FE7B590E69D9FE4BA8BE4BBB6222C225369676E616C20456E64204576656E74223A22E8A88AE8999FE7B590E69D9FE4BA8BE4BBB6222C225369676E616C20496E7465726D6564';
wwv_flow_imp.g_varchar2_table(37249) := '69617465204361746368204576656E74223A22E8A88AE8999FE4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C225369676E616C20696E7465726D656469617465206361746368206576656E74223A22E8A88AE8999FE4B8ADE99693E693B7E58F96E4BA';
wwv_flow_imp.g_varchar2_table(37250) := '8BE4BBB6222C225369676E616C20496E7465726D656469617465205468726F77204576656E74223A22E8A88AE8999FE4B8ADE7B9BCE799BCE587BAE4BA8BE4BBB6222C225369676E616C20696E7465726D656469617465207468726F77206576656E7422';
wwv_flow_imp.g_varchar2_table(37251) := '3A22E8A88AE8999FE4B8ADE99693E799BCE587BAE4BA8BE4BBB6222C225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E8A88AE8999FE9968BE5A78BE4BA8BE4BBB62028E99D9EE4B8ADE696B72922';
wwv_flow_imp.g_varchar2_table(37252) := '2C225369676E616C207374617274206576656E74223A22E8A88AE8999FE9968BE5A78BE4BA8BE4BBB6222C225369676E616C205374617274204576656E74223A22E8A88AE8999FE9968BE5A78BE4BA8BE4BBB6222C225369676E616C223A22E8A88AE899';
wwv_flow_imp.g_varchar2_table(37253) := '9F222C2253696D706C65204D657373616765223A22E7B0A1E596AEE8A88AE681AF222C2253514C2071756572792028636F6C6F6E2064656C696D69746564206C69737429223A2253514C20E69FA5E8A9A22028E4BBA5E58692E8999FE58886E99A94E79A';
wwv_flow_imp.g_varchar2_table(37254) := '84E6B885E596AE29222C2253514C20717565727920284A534F4E20617272617929223A2253514C20E69FA5E8A9A220284A534F4E20E999A3E5889729222C2253514C207175657279202873696E676C652076616C756529223A2253514C20E69FA5E8A9A2';
wwv_flow_imp.g_varchar2_table(37255) := '2028E596AEE4B880E580BC29222C2253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D69746564206C697374223A22E582B3E59B9EE58692E8999FE58886E99A94E6B885E596AEE79A842053514C20E69FA5E8A9A2222C';
wwv_flow_imp.g_varchar2_table(37256) := '2253514C2071756572792072657475726E696E672061204A534F4E206172726179223A22E582B3E59B9E204A534F4E20E999A3E58897E79A842053514C20E69FA5E8A9A2222C2253514C2071756572792072657475726E696E6720612073696E676C6520';
wwv_flow_imp.g_varchar2_table(37257) := '646174652076616C7565223A22E582B3E59B9EE596AEE4B880E697A5E69C9FE580BCE79A842053514C20E69FA5E8A9A2222C2253514C2071756572792072657475726E696E6720612073696E676C65206E756D6265722076616C7565223A22E582B3E59B';
wwv_flow_imp.g_varchar2_table(37258) := '9EE596AEE4B880E695B8E580BCE79A842053514C20E69FA5E8A9A2222C2253514C2071756572792072657475726E696E6720612073696E676C652054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E582B3E59B9EE596';
wwv_flow_imp.g_varchar2_table(37259) := 'AEE4B880E69982E688B32028E590ABE69982E58D80E580BC2920E79A842053514C20E69FA5E8A9A2222C2253514C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C7565223A22E582B3E59B9EE596AEE4B8';
wwv_flow_imp.g_varchar2_table(37260) := '8020766172636861723220E580BCE79A842053514C20E69FA5E8A9A2222C2253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E65223A22E582B3E59B9EE69982E58D80E69982E688B3E79A8420';
wwv_flow_imp.g_varchar2_table(37261) := '53514C20E69FA5E8A9A2222C2253514C20717565727920746F20676574206174746163686D656E74223A22E58F96E5BE97E99984E4BBB6E79A842053514C20E69FA5E8A9A2222C2253514C207175657279223A2253514C20E69FA5E8A9A2222C2253514C';
wwv_flow_imp.g_varchar2_table(37262) := '205175657279223A2253514C20E69FA5E8A9A2222C225374617274206576656E74206973206D697373696E67206576656E7420646566696E6974696F6E223A22E9968BE5A78BE4BA8BE4BBB6E981BAE6BC8FE4BA8BE4BBB6E5AE9AE7BEA9222C22537461';
wwv_flow_imp.g_varchar2_table(37263) := '7274206576656E74206D75737420626520626C616E6B223A22E9968BE5A78BE4BA8BE4BBB6E5BF85E9A088E7A9BAE799BD222C225374617274206576656E74223A22E9968BE5A78BE4BA8BE4BBB6222C225374617274204576656E74223A22E9968BE5A7';
wwv_flow_imp.g_varchar2_table(37264) := '8BE4BA8BE4BBB6222C2253746174696320646174652076616C7565223A22E99D9CE6858BE697A5E69C9FE580BC222C22537461746963204944223A22E99D9CE6858B204944222C22537461746963206E756D6265722076616C7565223A22E99D9CE6858B';
wwv_flow_imp.g_varchar2_table(37265) := 'E695B8E580BC222C225374617469632054696D657374616D7020776974682054696D65205A6F6E652076616C7565223A22E590ABE69982E58D80E580BCE79A84E99D9CE6858BE69982E688B3222C225374617469632076617263686172322076616C7565';
wwv_flow_imp.g_varchar2_table(37266) := '223A22E99D9CE6858B20766172636861723220E580BC222C22537461746963223A22E99D9CE6858B222C22537472696E67223A22E5AD97E4B8B2222C225375622070726F6365737320686173206D756C7469706C6520626C616E6B207374617274206576';
wwv_flow_imp.g_varchar2_table(37267) := '656E7473223A22E5AD90E89995E79086E585B7E69C89E5A49AE5808BE7A9BAE799BDE79A84E9968BE5A78BE4BA8BE4BBB6222C225375622070726F63657373206973206D697373696E6720656E64206576656E74223A22E5AD90E89995E79086E981BAE6';
wwv_flow_imp.g_varchar2_table(37268) := 'BC8FE7B590E69D9FE4BA8BE4BBB6222C225375622070726F63657373206973206D697373696E67207374617274206576656E74223A22E5AD90E89995E79086E981BAE6BC8FE9968BE5A78BE4BA8BE4BBB6222C225375622D70726F636573732028636F6C';
wwv_flow_imp.g_varchar2_table(37269) := '6C617073656429223A22E5AD90E89995E790862028E694B6E5908829222C225375622D70726F636573732028657870616E64656429223A22E5AD90E89995E790862028E5B7B2E5B195E9968B29222C225375622D70726F63657373223A22E5AD90E89995';
wwv_flow_imp.g_varchar2_table(37270) := 'E79086222C225375626A656374223A22E4B8BBE697A8222C225461736B20446566696E6974696F6E223A22E4BBBBE58B99E5AE9AE7BEA9222C225461736B20537461746963204944223A22E4BBBBE58B99E99D9CE6858B204944222C225461736B205479';
wwv_flow_imp.g_varchar2_table(37271) := '7065223A22E4BBBBE58B99E9A19EE59E8B222C225461736B223A22E4BBBBE58B99222C2254656D706C617465204944223A22E7AF84E69CAC204944222C2254656D706C617465223A22E7AF84E69CAC222C225465726D696E61746520656E64206576656E';
wwv_flow_imp.g_varchar2_table(37272) := '74223A22E7B582E6ADA2E7B590E69D9FE4BA8BE4BBB6222C225465726D696E61746520456E64204576656E74223A22E7B582E6ADA2E7B590E69D9FE4BA8BE4BBB6222C225465726D696E61746564223A22E5B7B2E7B582E6ADA2222C2254657874223A22';
wwv_flow_imp.g_varchar2_table(37273) := 'E69687E5AD97222C2254696D6520756E74696C207468652074696D657220666972657320616761696E223A22E8A888E69982E599A8E5868DE5BAA6E5959FE58B95E79A84E69982E99693222C2254696D6520756E74696C207468652074696D6572206669';
wwv_flow_imp.g_varchar2_table(37274) := '726573206669727374223A22E8A888E69982E599A8E7ACACE4B880E6ACA1E8A7B8E799BCE79A84E69982E99693222C2254696D657220626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729223A22E8A888E69982E599A8E9';
wwv_flow_imp.g_varchar2_table(37275) := '828AE7958CE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C2254696D657220626F756E64617279206576656E74223A22E8A888E69982E599A8E9828AE7958CE4BA8BE4BBB6222C2254696D657220446566696E6974696F6E2054797065223A22E8A888';
wwv_flow_imp.g_varchar2_table(37276) := 'E69982E599A8E5AE9AE7BEA9E9A19EE59E8B222C2254696D657220446566696E6974696F6E223A22E8A888E69982E599A8E5AE9AE7BEA9222C2254696D6572204475726174696F6E223A22E8A888E69982E599A8E68C81E7BA8CE69982E99693222C2254';
wwv_flow_imp.g_varchar2_table(37277) := '696D657220696E7465726D656469617465206361746368206576656E74223A22E8A888E69982E599A8E4B8ADE7B9BCE693B7E58F96E4BA8BE4BBB6222C2254696D657220496E7465726D656469617465204361746368204576656E74223A22E8A888E699';
wwv_flow_imp.g_varchar2_table(37278) := '82E599A8E4B8ADE99693E693B7E58F96E4BA8BE4BBB6222C2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729223A22E8A888E69982E599A8E9968BE5A78BE4BA8BE4BBB62028E99D9EE4B8ADE696B729222C22';
wwv_flow_imp.g_varchar2_table(37279) := '54696D6572207374617274206576656E74223A22E8A888E69982E599A8E9968BE5A78BE4BA8BE4BBB6222C2254696D6572205374617274204576656E74223A22E8A888E69982E599A8E9968BE5A78BE4BA8BE4BBB6222C2254696D6572223A22E8A888E6';
wwv_flow_imp.g_varchar2_table(37280) := '9982222C2254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D6174223A22E69982E58D80E79A84E69982E688B3202849534F203836303120E68896204F7261636C6520E6A0';
wwv_flow_imp.g_varchar2_table(37281) := 'BCE5BC8F29222C2254696D657374616D7020776974682054696D65205A6F6E65223A22E590ABE69982E58D80E79A84E69982E688B3222C22546F223A22E7B582E6ADA2222C22546F67676C65206E6F6E2D696E74657272757074696E67223A22E58887E6';
wwv_flow_imp.g_varchar2_table(37282) := '8F9BE99D9EE4B8ADE696B7E6A8A1E5BC8F222C225472616E73616374696F6E223A22E4BAA4E69893222C22556E646F223A22E98284E58E9F222C22756E6B6E6F776E206469207B64697D20666F7220656C656D656E74207B73656D616E7469637D223A22';
wwv_flow_imp.g_varchar2_table(37283) := 'E58583E7B4A0207B73656D616E7469637D20E79A84206469207B64697D20E4B88DE6988E222C22756E7265636F676E697A656420666C6F77456C656D656E74207B656C656D656E747D20696E20636F6E74657874207B636F6E746578747D223A22E784A1';
wwv_flow_imp.g_varchar2_table(37284) := 'E6B395E8BEA8E8AD98E79BB8E9979CE8B387E8A88AE792B0E5A283207B636F6E746578747D20E4B8ADE79A8420666C6F77456C656D656E74207B656C656D656E747D222C22756E737570706F727465642062706D6E456C656D656E7420666F72207B706C';
wwv_flow_imp.g_varchar2_table(37285) := '616E657D3A207B726F6F74456C656D656E747D223A22E4B88DE694AFE68FB4207B706C616E657D20E79A842062706D6E456C656D656E74EFBC9A7B726F6F74456C656D656E747D222C225573652041504558206D6574612064617461223A22E4BDBFE794';
wwv_flow_imp.g_varchar2_table(37286) := 'A8204150455820E68F8FE8BFB0E8B387E69699222C225573652054656D706C617465223A22E4BDBFE794A8E7AF84E69CAC222C2255736564206469616772616D2076657273696F6E223A22E5B7B2E4BDBFE794A8E79A84E59C96E8A1A8E78988E69CAC22';
wwv_flow_imp.g_varchar2_table(37287) := '2C2255736572207461736B223A22E4BDBFE794A8E88085E4BBBBE58B99222C2255736572205461736B223A22E4BDBFE794A8E88085E4BBBBE58B99222C2256616C7565223A22E580BC222C225661726368617232223A225661726368617232222C225661';
wwv_flow_imp.g_varchar2_table(37288) := '726961626C652045787072657373696F6E73223A22E8AE8AE695B8E8A1A8E7A4BAE5BC8F222C2256657273696F6E204E616D65223A22E78988E69CACE5908DE7A8B1222C2256657273696F6E696E67223A22E78988E69CACE68EA7E588B6222C22576169';
wwv_flow_imp.g_varchar2_table(37289) := '7420666F7220636F6D706C6574696F6E223A22E7AD89E5BE85E5AE8CE68890222C225A6F6F6D20496E223A22E694BEE5A4A7222C225A6F6F6D204F7574223A22E7B8AEE5B08F227D27297D7D2C693D7B7D3B66756E6374696F6E206F2865297B76617220';
wwv_flow_imp.g_varchar2_table(37290) := '743D695B655D3B696628766F69642030213D3D742972657475726E20742E6578706F7274733B76617220733D695B655D3D7B69643A652C6578706F7274733A7B7D7D3B72657475726E206E5B655D28732C732E6578706F7274732C6F292C732E6578706F';
wwv_flow_imp.g_varchar2_table(37291) := '7274737D6F2E6D3D6E2C6F2E616D644F3D7B7D2C6F2E6E3D653D3E7B76617220743D652626652E5F5F65734D6F64756C653F28293D3E652E64656661756C743A28293D3E653B72657475726E206F2E6428742C7B613A747D292C747D2C6F2E643D28652C';
wwv_flow_imp.g_varchar2_table(37292) := '74293D3E7B666F7228766172206E20696E2074296F2E6F28742C6E292626216F2E6F28652C6E2926264F626A6563742E646566696E6550726F706572747928652C6E2C7B656E756D657261626C653A21302C6765743A745B6E5D7D297D2C6F2E663D7B7D';
wwv_flow_imp.g_varchar2_table(37293) := '2C6F2E653D653D3E50726F6D6973652E616C6C284F626A6563742E6B657973286F2E66292E726564756365282828742C6E293D3E286F2E665B6E5D28652C74292C7429292C5B5D29292C6F2E753D653D3E652B222E6D696E2E6A73222C6F2E673D66756E';
wwv_flow_imp.g_varchar2_table(37294) := '6374696F6E28297B696628226F626A656374223D3D747970656F6620676C6F62616C546869732972657475726E20676C6F62616C546869733B7472797B72657475726E20746869737C7C6E65772046756E6374696F6E282272657475726E207468697322';
wwv_flow_imp.g_varchar2_table(37295) := '2928297D63617463682865297B696628226F626A656374223D3D747970656F662077696E646F772972657475726E2077696E646F777D7D28292C6F2E6F3D28652C74293D3E4F626A6563742E70726F746F747970652E6861734F776E50726F7065727479';
wwv_flow_imp.g_varchar2_table(37296) := '2E63616C6C28652C74292C653D7B7D2C743D2262706D6E4D6F64656C65723A222C6F2E6C3D286E2C692C732C72293D3E7B696628655B6E5D29655B6E5D2E707573682869293B656C73657B76617220612C6C3B696628766F69642030213D3D7329666F72';
wwv_flow_imp.g_varchar2_table(37297) := '2876617220633D646F63756D656E742E676574456C656D656E747342795461674E616D65282273637269707422292C643D303B643C632E6C656E6774683B642B2B297B76617220683D635B645D3B696628682E6765744174747269627574652822737263';
wwv_flow_imp.g_varchar2_table(37298) := '22293D3D6E7C7C682E6765744174747269627574652822646174612D7765627061636B22293D3D742B73297B613D683B627265616B7D7D617C7C286C3D21302C28613D646F63756D656E742E637265617465456C656D656E742822736372697074222929';
wwv_flow_imp.g_varchar2_table(37299) := '2E636861727365743D227574662D38222C612E74696D656F75743D3132302C6F2E6E632626612E73657441747472696275746528226E6F6E6365222C6F2E6E63292C612E7365744174747269627574652822646174612D7765627061636B222C742B7329';
wwv_flow_imp.g_varchar2_table(37300) := '2C612E7372633D6E292C655B6E5D3D5B695D3B76617220753D28742C69293D3E7B612E6F6E6572726F723D612E6F6E6C6F61643D6E756C6C2C636C65617254696D656F75742870293B766172206F3D655B6E5D3B69662864656C65746520655B6E5D2C61';
wwv_flow_imp.g_varchar2_table(37301) := '2E706172656E744E6F64652626612E706172656E744E6F64652E72656D6F76654368696C642861292C6F26266F2E666F72456163682828653D3E6528692929292C742972657475726E20742869297D2C703D73657454696D656F757428752E62696E6428';
wwv_flow_imp.g_varchar2_table(37302) := '6E756C6C2C766F696420302C7B747970653A2274696D656F7574222C7461726765743A617D292C31326534293B612E6F6E6572726F723D752E62696E64286E756C6C2C612E6F6E6572726F72292C612E6F6E6C6F61643D752E62696E64286E756C6C2C61';
wwv_flow_imp.g_varchar2_table(37303) := '2E6F6E6C6F6164292C6C2626646F63756D656E742E686561642E617070656E644368696C642861297D7D2C6F2E723D653D3E7B22756E646566696E656422213D747970656F662053796D626F6C262653796D626F6C2E746F537472696E6754616726264F';
wwv_flow_imp.g_varchar2_table(37304) := '626A6563742E646566696E6550726F706572747928652C53796D626F6C2E746F537472696E675461672C7B76616C75653A224D6F64756C65227D292C4F626A6563742E646566696E6550726F706572747928652C225F5F65734D6F64756C65222C7B7661';
wwv_flow_imp.g_varchar2_table(37305) := '6C75653A21307D297D2C2828293D3E7B76617220653B6F2E672E696D706F727453637269707473262628653D6F2E672E6C6F636174696F6E2B2222293B76617220743D6F2E672E646F63756D656E743B6966282165262674262628742E63757272656E74';
wwv_flow_imp.g_varchar2_table(37306) := '536372697074262622534352495054223D3D3D742E63757272656E745363726970742E7461674E616D652E746F5570706572436173652829262628653D742E63757272656E745363726970742E737263292C216529297B766172206E3D742E676574456C';
wwv_flow_imp.g_varchar2_table(37307) := '656D656E747342795461674E616D65282273637269707422293B6966286E2E6C656E67746829666F722876617220693D6E2E6C656E6774682D313B693E2D3126262821657C7C212F5E6874747028733F293A2F2E74657374286529293B29653D6E5B692D';
wwv_flow_imp.g_varchar2_table(37308) := '2D5D2E7372637D6966282165297468726F77206E6577204572726F7228224175746F6D61746963207075626C696350617468206973206E6F7420737570706F7274656420696E20746869732062726F7773657222293B653D652E7265706C616365282F23';
wwv_flow_imp.g_varchar2_table(37309) := '2E2A242F2C2222292E7265706C616365282F5C3F2E2A242F2C2222292E7265706C616365282F5C2F5B5E5C2F5D2B242F2C222F22292C6F2E703D657D2928292C2828293D3E7B6F2E623D646F63756D656E742E626173655552497C7C73656C662E6C6F63';
wwv_flow_imp.g_varchar2_table(37310) := '6174696F6E2E687265663B76617220653D7B3231303A307D3B6F2E662E6A3D28742C6E293D3E7B76617220693D6F2E6F28652C74293F655B745D3A766F696420303B69662830213D3D692969662869296E2E7075736828695B325D293B656C73657B7661';
wwv_flow_imp.g_varchar2_table(37311) := '7220733D6E65772050726F6D6973652828286E2C6F293D3E693D655B745D3D5B6E2C6F5D29293B6E2E7075736828695B325D3D73293B76617220723D6F2E702B6F2E752874292C613D6E6577204572726F723B6F2E6C28722C286E3D3E7B6966286F2E6F';
wwv_flow_imp.g_varchar2_table(37312) := '28652C742926262830213D3D28693D655B745D29262628655B745D3D766F69642030292C6929297B76617220733D6E262628226C6F6164223D3D3D6E2E747970653F226D697373696E67223A6E2E74797065292C723D6E26266E2E74617267657426266E';
wwv_flow_imp.g_varchar2_table(37313) := '2E7461726765742E7372633B612E6D6573736167653D224C6F6164696E67206368756E6B20222B742B22206661696C65642E5C6E28222B732B223A20222B722B2229222C612E6E616D653D224368756E6B4C6F61644572726F72222C612E747970653D73';
wwv_flow_imp.g_varchar2_table(37314) := '2C612E726571756573743D722C695B315D2861297D7D292C226368756E6B2D222B742C74297D7D3B76617220743D28742C6E293D3E7B76617220692C732C5B722C612C6C5D3D6E2C633D303B696628722E736F6D652828743D3E30213D3D655B745D2929';
wwv_flow_imp.g_varchar2_table(37315) := '297B666F72286920696E2061296F2E6F28612C69292626286F2E6D5B695D3D615B695D293B6C26266C286F297D666F722874262674286E293B633C722E6C656E6774683B632B2B29733D725B635D2C6F2E6F28652C73292626655B735D2626655B735D5B';
wwv_flow_imp.g_varchar2_table(37316) := '305D28292C655B735D3D307D2C6E3D73656C662E7765627061636B4368756E6B62706D6E4D6F64656C65723D73656C662E7765627061636B4368756E6B62706D6E4D6F64656C65727C7C5B5D3B6E2E666F724561636828742E62696E64286E756C6C2C30';
wwv_flow_imp.g_varchar2_table(37317) := '29292C6E2E707573683D742E62696E64286E756C6C2C6E2E707573682E62696E64286E29297D2928292C6F2E6E633D766F696420303B76617220733D7B7D3B2828293D3E7B2275736520737472696374223B66756E6374696F6E206528652C74297B6966';
wwv_flow_imp.g_varchar2_table(37318) := '282165297468726F77206E6577204572726F722822636F6E6669672E6578706F72746572203D207B206E616D652C2076657273696F6E207D206E6F7420636F6E6669677572656422293B766172206E3D652E6E616D652C693D652E76657273696F6E3B69';
wwv_flow_imp.g_varchar2_table(37319) := '6628216E7C7C2169297468726F77206E6577204572726F722822636F6E6669672E6578706F72746572203D207B206E616D652C2076657273696F6E207D206D697373696E672072657175697265642070726F707322293B742E6F6E282273617665584D4C';
wwv_flow_imp.g_varchar2_table(37320) := '2E7374617274222C2866756E6374696F6E2865297B76617220743D652E646566696E6974696F6E733B742E6578706F727465723D6E2C742E6578706F7274657256657273696F6E3D697D29297D6F2E6428732C7B64656661756C743A28293D3E71517D29';
wwv_flow_imp.g_varchar2_table(37321) := '2C652E24696E6A6563743D5B22636F6E6669672E6578706F72746572222C226576656E74427573225D3B636F6E737420743D7B5F5F696E69745F5F3A5B655D7D3B766172206E3D6F2837333537292C693D6F2839393035293B4F626A6563742E70726F74';
wwv_flow_imp.g_varchar2_table(37322) := '6F747970652E746F537472696E672C4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B636F6E737420723D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E20612865297B6966282165';
wwv_flow_imp.g_varchar2_table(37323) := '7C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C697374';
wwv_flow_imp.g_varchar2_table(37324) := '7D612E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C612E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F62';
wwv_flow_imp.g_varchar2_table(37325) := '6A656374205265674578705D223D3D722E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C612E70726F746F747970652E72656D6F76654D6174636869';
wwv_flow_imp.g_varchar2_table(37326) := '6E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B7265747572';
wwv_flow_imp.g_varchar2_table(37327) := '6E20746869737D2C612E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F6767';
wwv_flow_imp.g_varchar2_table(37328) := '6C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C612E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C612E70726F746F7479';
wwv_flow_imp.g_varchar2_table(37329) := '70652E6861733D612E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B766172206C2C632C642C683D7B7D3B66756E6374696F6E207528297B6C3D';
wwv_flow_imp.g_varchar2_table(37330) := '77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C633D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C69';
wwv_flow_imp.g_varchar2_table(37331) := '7374656E6572223A226465746163684576656E74222C643D226164644576656E744C697374656E657222213D3D6C3F226F6E223A22227D682E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E206C7C7C7528292C655B6C5D2864';
wwv_flow_imp.g_varchar2_table(37332) := '2B742C6E2C697C7C2131292C6E7D2C682E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E20637C7C7528292C655B635D28642B742C6E2C697C7C2131292C6E7D3B76617220702C673D21313B22756E646566696E65642221';
wwv_flow_imp.g_varchar2_table(37333) := '3D747970656F6620646F63756D656E7426262828703D646F63756D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F6122';
wwv_flow_imp.g_varchar2_table(37334) := '3E613C2F613E3C696E70757420747970653D22636865636B626F78222F3E272C673D21702E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C703D766F69642030293B766172206D3D7B6C6567656E643A5B312C';
wwv_flow_imp.g_varchar2_table(37335) := '223C6669656C647365743E222C223C2F6669656C647365743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F6479';
wwv_flow_imp.g_varchar2_table(37336) := '3E3C636F6C67726F75703E222C223C2F636F6C67726F75703E3C2F7461626C653E225D2C5F64656661756C743A673F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B6D2E74643D6D2E74683D5B332C223C7461626C65';
wwv_flow_imp.g_varchar2_table(37337) := '3E3C74626F64793E3C74723E222C223C2F74723E3C2F74626F64793E3C2F7461626C653E225D2C6D2E6F7074696F6E3D6D2E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C65';
wwv_flow_imp.g_varchar2_table(37338) := '63743E225D2C6D2E74686561643D6D2E74626F64793D6D2E636F6C67726F75703D6D2E63617074696F6E3D6D2E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C6D2E706F6C796C696E653D6D2E656C6C697073653D6D2E70';
wwv_flow_imp.g_varchar2_table(37339) := '6F6C79676F6E3D6D2E636972636C653D6D2E746578743D6D2E6C696E653D6D2E706174683D6D2E726563743D6D2E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F6E3D';
wwv_flow_imp.g_varchar2_table(37340) := '22312E31223E272C223C2F7376673E225D3B76617220663D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870656374656422293B74';
wwv_flow_imp.g_varchar2_table(37341) := '7C7C28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F672C22';
wwv_flow_imp.g_varchar2_table(37342) := '22293B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C64293B';
wwv_flow_imp.g_varchar2_table(37343) := '766172206F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286D2C69293F6D5B695D3A6D2E5F64656661756C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E637265617465456C656D65';
wwv_flow_imp.g_varchar2_table(37344) := '6E74282264697622293B666F72286C2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E66697273744368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76654368696C64';
wwv_flow_imp.g_varchar2_table(37345) := '286C2E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273744368696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C64286C2E66697273';
wwv_flow_imp.g_varchar2_table(37346) := '744368696C6429293B72657475726E20637D3B66756E6374696F6E20762865297B72657475726E204353532E6573636170652865297D76617220623D7B2226223A2226616D703B222C223C223A22266C743B222C223E223A222667743B222C2722273A22';
wwv_flow_imp.g_varchar2_table(37347) := '2671756F743B222C2227223A22262333393B227D3B66756E6374696F6E205F2865297B72657475726E28653D22222B65292626652E7265706C616365282F5B263C3E22275D2F672C2866756E6374696F6E2865297B72657475726E20625B655D7D29297D';
wwv_flow_imp.g_varchar2_table(37348) := '76617220793D6F2839313932293B66756E6374696F6E207728652C74297B766172206E3D652E6765742822656469746F72416374696F6E73222C2131293B6E26266E2E7265676973746572287B746F67676C654C696E74696E673A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(37349) := '297B742E746F67676C6528297D7D297D772E24696E6A6563743D5B22696E6A6563746F72222C226C696E74696E67225D3B76617220433D273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D225554462D3822207374616E64616C';
wwv_flow_imp.g_varchar2_table(37350) := '6F6E653D226E6F223F3E5C6E3C7376675C6E20202076657273696F6E3D22312E31225C6E20202076696577426F783D223020302035313220353132225C6E202020786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667225C';
wwv_flow_imp.g_varchar2_table(37351) := '6E202020786D6C6E733A7376673D22687474703A2F2F7777772E77332E6F72672F323030302F737667223E5C6E20203C706174685C6E2020202020643D224D203333392E30373138332C3235362E3030303031203436332E36363731332C3133312E3430';
wwv_flow_imp.g_varchar2_table(37352) := '343720632031352E32383936312C2D31352E323839362031352E32383936312C2D34302E30373931373520302C2D35352E333831323237206C202D32372E363930362C2D32372E3639303631312063202D31352E32383936312C2D31352E323839363032';
wwv_flow_imp.g_varchar2_table(37353) := '202D34302E30373931372C2D31352E323839363032202D35352E33383132332C30204C203235362C3137322E3932383138203133312E343034372C34382E3333323836322063202D31352E323839362C2D31352E323839363032202D34302E3037393137';
wwv_flow_imp.g_varchar2_table(37354) := '372C2D31352E323839363032202D35352E3338313232382C30204C2034382E3333323836312C37362E3032333437332063202D31352E323839362C31352E32383936202D31352E323839362C34302E30373931373720302C35352E333831323237204C20';
wwv_flow_imp.g_varchar2_table(37355) := '3137322E39323831352C3235362E30303030312034382E3333323836312C3338302E35393533312063202D31352E323839362C31352E32383936202D31352E323839362C34302E303739313720302C35352E3338313233206C2032372E3639303631312C';
wwv_flow_imp.g_varchar2_table(37356) := '32372E363930363120632031352E3238393630312C31352E32383935392034302E3039313632382C31352E32383935392035352E3338313232382C30204C203235362C3333392E3037313834203338302E353935332C3436332E36363731352063203135';
wwv_flow_imp.g_varchar2_table(37357) := '2E323839362C31352E32383935392034302E30393136322C31352E32383935392035352E33383132332C30206C2032372E363930362C2D32372E363930363120632031352E32383936312C2D31352E323839362031352E32383936312C2D34302E303739';
wwv_flow_imp.g_varchar2_table(37358) := '313820302C2D35352E3338313233207A225C6E202020202066696C6C3D2263757272656E74436F6C6F7222202F3E5C6E3C2F7376673E5C6E272C533D273C7376672076657273696F6E3D22312E31222076696577426F783D223020302035313220353132';
wwv_flow_imp.g_varchar2_table(37359) := '2220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667223E5C6E20203C7061746820643D226D323536203332332E3935632D34352E35313820302D38322E3431392033342E3537362D38322E3431392037372E32323920';
wwv_flow_imp.g_varchar2_table(37360) := '302034322E3635322033362E392037372E3232392038322E3431392037372E3232392034352E35313820302038322E3431392D33342E3537372038322E3431392D37372E323320302D34322E3635322D33362E392D37372E3232392D38322E3431392D37';
wwv_flow_imp.g_varchar2_table(37361) := '372E3232397A6D2D38302E3536312D3237312E382031312E3631203230342E3335632E35343420392E33333420382E37382031362E36342031382E3735352031362E3634683130302E333963392E39373520302031382E3231312D372E3330362031382E';
wwv_flow_imp.g_varchar2_table(37362) := '3735342D31362E36346C31312E3631312D3230342E3335632E3538372D31302E3038322D372E39382D31382E35362D31382E3735342D31382E3536682D3132332E3632632D31302E37373520302D31392E333420382E3437382D31382E3735332031382E';
wwv_flow_imp.g_varchar2_table(37363) := '35367A222066696C6C3D2263757272656E74436F6C6F72222F3E5C6E3C2F7376673E5C6E272C783D273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D225554462D3822207374616E64616C6F6E653D226E6F223F3E5C6E3C7376';
wwv_flow_imp.g_varchar2_table(37364) := '675C6E20202076696577426F783D223020302035313220353132225C6E20202076657273696F6E3D22312E31225C6E202020786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667225C6E202020786D6C6E733A7376673D22';
wwv_flow_imp.g_varchar2_table(37365) := '687474703A2F2F7777772E77332E6F72672F323030302F737667223E5C6E20203C706174685C6E202020202066696C6C3D2263757272656E74436F6C6F72225C6E2020202020643D226D203137332E3839382C3433392E3430333536202D3136362E342C';
wwv_flow_imp.g_varchar2_table(37366) := '2D3136362E342063202D392E3939372C2D392E393937202D392E3939372C2D32362E32303620302C2D33362E323034206C2033362E3230332C2D33362E323034206320392E3939372C2D392E3939382032362E3230372C2D392E3939382033362E323034';
wwv_flow_imp.g_varchar2_table(37367) := '2C30204C203139322C3331322E3638393536203433322E3039352C37322E353935353632206320392E3939372C2D392E3939372032362E3230372C2D392E3939372033362E3230342C30206C2033362E3230332C33362E323033393938206320392E3939';
wwv_flow_imp.g_varchar2_table(37368) := '372C392E39393720392E3939372C32362E32303620302C33362E323034206C202D3239342E342C3239342E3430312063202D392E3939382C392E393937202D32362E3230372C392E393937202D33362E3230342C2D3130652D34207A22202F3E5C6E3C2F';
wwv_flow_imp.g_varchar2_table(37369) := '7376673E5C6E272C6B3D273C7376675C6E202076696577426F783D22332E3520332E3520392039225C6E202076657273696F6E3D22312E31225C6E2020786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667223E5C6E2020';
wwv_flow_imp.g_varchar2_table(37370) := '3C706174685C6E2020202066696C6C3D2263757272656E74436F6C6F722220643D224D362E3520372E3735412E37352E373520302030203120372E323520376831612E37352E3735203020302031202E37352E373576322E3735682E3235612E37352E37';
wwv_flow_imp.g_varchar2_table(37371) := '35203020302031203020312E35682D32612E37352E373520302030203120302D312E35682E3235762D32682D2E3235612E37352E37352030203020312D2E37352D2E37355A4D3820366131203120302031203120302D3220312031203020302031203020';
wwv_flow_imp.g_varchar2_table(37372) := '325A223E3C2F706174683E5C6E3C2F7376673E272C453D7B7265736F6C7665723A7B7265736F6C766552756C653A66756E6374696F6E28297B72657475726E206E756C6C7D7D2C636F6E6669673A7B7D7D2C4C3D7B6572726F723A432C7761726E696E67';
wwv_flow_imp.g_varchar2_table(37373) := '3A532C737563636573733A782C696E666F3A6B2C696E6163746976653A787D3B66756E6374696F6E204428652C742C6E2C692C6F2C732C72297B746869732E5F62706D6E6A733D652C746869732E5F63616E7661733D742C746869732E5F656C656D656E';
wwv_flow_imp.g_varchar2_table(37374) := '7452656769737472793D692C746869732E5F6576656E744275733D6F2C746869732E5F6F7665726C6179733D732C746869732E5F7472616E736C6174653D722C746869732E5F6973737565733D7B7D2C746869732E5F6163746976653D6E26266E2E6163';
wwv_flow_imp.g_varchar2_table(37375) := '746976657C7C21312C746869732E5F6C696E746572436F6E6669673D452C746869732E5F6F7665726C61794964733D7B7D3B76617220613D746869733B6F2E6F6E285B22696D706F72742E646F6E65222C22656C656D656E74732E6368616E676564222C';
wwv_flow_imp.g_varchar2_table(37376) := '226C696E74696E672E636F6E6669674368616E676564222C226C696E74696E672E746F67676C65225D2C3530302C2866756E6374696F6E2865297B612E75706461746528297D29292C6F2E6F6E28226C696E74696E672E746F67676C65222C2866756E63';
wwv_flow_imp.g_varchar2_table(37377) := '74696F6E2865297B652E6163746976657C7C28612E5F636C65617249737375657328292C612E5F757064617465427574746F6E2829297D29292C6F2E6F6E28226469616772616D2E636C656172222C2866756E6374696F6E28297B612E5F636C65617249';
wwv_flow_imp.g_varchar2_table(37378) := '737375657328297D29293B766172206C3D6E26266E2E62706D6E6C696E743B6C26266F2E6F6E636528226469616772616D2E696E6974222C2866756E6374696F6E28297B696628612E6765744C696E746572436F6E66696728293D3D3D45297472797B61';
wwv_flow_imp.g_varchar2_table(37379) := '2E7365744C696E746572436F6E666967286C297D63617463682865297B636F6E736F6C652E6572726F7228225B62706D6E2D6A732D62706D6E6C696E745D20496E76616C6964206C696E742072756C657320636F6E666967757265642E20506C65617365';
wwv_flow_imp.g_varchar2_table(37380) := '20646F75626C65636865636B20796F7572206C696E74696E672E62706D6E6C696E7420636F6E66696775726174696F6E2C2063662E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732D62706D6E6C696E7423636F';
wwv_flow_imp.g_varchar2_table(37381) := '6E6669677572652D6C696E742D72756C657322297D7D29292C746869732E5F696E697428297D442E70726F746F747970652E7365744C696E746572436F6E6669673D66756E6374696F6E2865297B69662821652E636F6E6669677C7C21652E7265736F6C';
wwv_flow_imp.g_varchar2_table(37382) := '766572297468726F77206E6577204572726F7228224578706563746564206C696E746572436F6E666967203D207B20636F6E6669672C207265736F6C766572207D22293B746869732E5F6C696E746572436F6E6669673D652C746869732E5F6576656E74';
wwv_flow_imp.g_varchar2_table(37383) := '4275732E6669726528226C696E74696E672E636F6E6669674368616E67656422297D2C442E70726F746F747970652E6765744C696E746572436F6E6669673D66756E6374696F6E28297B72657475726E20746869732E5F6C696E746572436F6E6669677D';
wwv_flow_imp.g_varchar2_table(37384) := '2C442E70726F746F747970652E5F696E69743D66756E6374696F6E28297B746869732E5F637265617465427574746F6E28292C746869732E5F757064617465427574746F6E28297D2C442E70726F746F747970652E69734163746976653D66756E637469';
wwv_flow_imp.g_varchar2_table(37385) := '6F6E28297B72657475726E20746869732E5F6163746976657D2C442E70726F746F747970652E5F666F726D61744973737565733D66756E6374696F6E2865297B6C657420743D746869732C6E3D28302C692E54532928652C2866756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(37386) := '742C6E297B72657475726E20652E636F6E63617428742E6D6170282866756E6374696F6E2865297B72657475726E20652E72756C653D6E2C657D2929297D292C5B5D293B636F6E7374206F3D742E5F656C656D656E7452656769737472792E66696C7465';
wwv_flow_imp.g_varchar2_table(37387) := '722828653D3E28302C792E69732928652C2262706D6E3A5061727469636970616E74222929292E6D61702828653D3E652E627573696E6573734F626A65637429293B72657475726E206E3D28302C692E546A29286E2C2866756E6374696F6E2865297B69';
wwv_flow_imp.g_varchar2_table(37388) := '662821742E5F656C656D656E7452656769737472792E67657428652E696429297B652E69734368696C6449737375653D21302C652E61637475616C456C656D656E7449643D652E69643B636F6E7374206E3D6F2E66696C7465722828743D3E742E70726F';
wwv_flow_imp.g_varchar2_table(37389) := '636573735265662626742E70726F636573735265662E69642626742E70726F636573735265662E69643D3D3D652E696429293B6E2E6C656E6774683F652E69643D6E5B305D2E69643A652E69643D742E5F63616E7661732E676574526F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(37390) := '6E7428292E69647D72657475726E20657D29292C6E3D28302C692E247A29286E2C2866756E6374696F6E2865297B72657475726E20652E69647D29292C6E7D2C442E70726F746F747970652E746F67676C653D66756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(37391) := '6E20653D766F696420303D3D3D653F21746869732E697341637469766528293A652C746869732E5F7365744163746976652865292C657D2C442E70726F746F747970652E5F7365744163746976653D66756E6374696F6E2865297B746869732E5F616374';
wwv_flow_imp.g_varchar2_table(37392) := '697665213D3D65262628746869732E5F6163746976653D652C746869732E5F6576656E744275732E6669726528226C696E74696E672E746F67676C65222C7B6163746976653A657D29297D2C442E70726F746F747970652E7570646174653D66756E6374';
wwv_flow_imp.g_varchar2_table(37393) := '696F6E28297B76617220653D746869733B696628746869732E5F62706D6E6A732E676574446566696E6974696F6E732829297B76617220743D746869732E5F6C696E7453746172743D4D6174682E72616E646F6D28293B746869732E6C696E7428292E74';
wwv_flow_imp.g_varchar2_table(37394) := '68656E282866756E6374696F6E286E297B696628652E5F6C696E7453746172743D3D3D74297B6E3D652E5F666F726D6174497373756573286E293B766172206F3D7B7D2C733D7B7D2C723D7B7D3B666F7228766172206120696E20652E5F697373756573';
wwv_flow_imp.g_varchar2_table(37395) := '296E5B615D7C7C286F5B615D3D652E5F6973737565735B615D293B666F7228766172206C20696E206E29652E5F6973737565735B6C5D3F6E5B6C5D213D3D652E5F6973737565735B6C5D262628735B6C5D3D6E5B6C5D293A725B6C5D3D6E5B6C5D3B6F3D';
wwv_flow_imp.g_varchar2_table(37396) := '28302C692E6B7029286F2C73292C723D28302C692E6B702928722C73292C652E5F636C6561724F7665726C61797328292C652E697341637469766528292626652E5F6372656174654973737565732872292C652E5F6973737565733D6E2C652E5F757064';
wwv_flow_imp.g_varchar2_table(37397) := '617465427574746F6E28292C652E5F66697265436F6D706C657465286E297D7D29297D7D2C442E70726F746F747970652E5F66697265436F6D706C6574653D66756E6374696F6E2865297B746869732E5F6576656E744275732E6669726528226C696E74';
wwv_flow_imp.g_varchar2_table(37398) := '696E672E636F6D706C65746564222C7B6973737565733A657D297D2C442E70726F746F747970652E5F6372656174654973737565733D66756E6374696F6E2865297B666F7228766172207420696E206529746869732E5F637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(37399) := '49737375657328742C655B745D297D2C442E70726F746F747970652E5F637265617465456C656D656E744973737565733D66756E6374696F6E28652C74297B766172206E3D746869732E5F656C656D656E7452656769737472792E6765742865293B6966';
wwv_flow_imp.g_varchar2_table(37400) := '286E297B766172206F2C732C723D746869732E5F656C656D656E7452656769737472792E67657428652B225F706C616E6522293B722626746869732E5F637265617465456C656D656E7449737375657328722E69642C74293B76617220613D216E2E7061';
wwv_flow_imp.g_varchar2_table(37401) := '72656E743B61262628302C792E697329286E2C2262706D6E3A50726F6365737322293F286F3D22626F74746F6D2D7269676874222C733D7B746F703A32302C6C6566743A3135307D293A61262628302C792E697329286E2C2262706D6E3A53756250726F';
wwv_flow_imp.g_varchar2_table(37402) := '6365737322293F286F3D22626F74746F6D2D7269676874222C733D7B746F703A35302C6C6566743A3135307D293A286F3D22746F702D7269676874222C733D7B746F703A2D372C6C6566743A2D377D293B766172206C3D28302C692E247A2928742C2866';
wwv_flow_imp.g_varchar2_table(37403) := '756E6374696F6E2865297B72657475726E28652E69734368696C6449737375653F226368696C64223A2222292B652E63617465676F72797D29292C633D6C2E6572726F722C643D6C2E7761726E2C683D6C2E696E666F2C753D6C2E6368696C646572726F';
wwv_flow_imp.g_varchar2_table(37404) := '722C703D6C2E6368696C647761726E2C673D6C2E6368696C64696E666F3B696628687C7C637C7C647C7C757C7C707C7C67297B766172206D3D6628273C64697620636C6173733D22626A736C2D6F7665726C617920626A736C2D6973737565732D272B6F';
wwv_flow_imp.g_varchar2_table(37405) := '2B27223E3C2F6469763E27292C763D6628637C7C753F273C64697620636C6173733D22626A736C2D69636F6E20626A736C2D69636F6E2D6572726F72223E272B432B223C2F6469763E223A647C7C703F273C64697620636C6173733D22626A736C2D6963';
wwv_flow_imp.g_varchar2_table(37406) := '6F6E20626A736C2D69636F6E2D7761726E696E67223E272B532B223C2F6469763E223A273C64697620636C6173733D22626A736C2D69636F6E20626A736C2D69636F6E2D696E666F223E272B6B2B223C2F6469763E22292C623D6628273C64697620636C';
wwv_flow_imp.g_varchar2_table(37407) := '6173733D22626A736C2D64726F70646F776E223E3C2F6469763E27292C5F3D6628273C64697620636C6173733D22626A736C2D64726F70646F776E2D636F6E74656E74223E3C2F6469763E27292C773D6628273C64697620636C6173733D22626A736C2D';
wwv_flow_imp.g_varchar2_table(37408) := '697373756573223E3C2F6469763E27292C783D6628273C64697620636C6173733D22626A736C2D63757272656E742D656C656D656E742D697373756573223E3C2F6469763E27292C453D6628223C756C3E3C2F756C3E22293B6966286D2E617070656E64';
wwv_flow_imp.g_varchar2_table(37409) := '4368696C642876292C6D2E617070656E644368696C642862292C622E617070656E644368696C64285F292C5F2E617070656E644368696C642877292C772E617070656E644368696C642878292C782E617070656E644368696C642845292C632626746869';
wwv_flow_imp.g_varchar2_table(37410) := '732E5F6164644572726F727328452C63292C642626746869732E5F6164645761726E696E677328452C64292C682626746869732E5F616464496E666F7328452C68292C757C7C707C7C67297B766172204C3D6628273C64697620636C6173733D22626A73';
wwv_flow_imp.g_varchar2_table(37411) := '6C2D6368696C642D697373756573223E3C2F6469763E27292C443D6628223C756C3E3C2F756C3E22292C543D746869732E5F7472616E736C617465282249737375657320666F72206368696C6420656C656D656E747322292C493D6628273C6120636C61';
wwv_flow_imp.g_varchar2_table(37412) := '73733D22626A736C2D69737375652D68656164696E67223E272B542B223A3C2F613E22293B696628752626746869732E5F6164644572726F727328442C75292C702626746869732E5F6164645761726E696E677328442C70292C672626746869732E5F61';
wwv_flow_imp.g_varchar2_table(37413) := '6464496E666F7328442C67292C637C7C64297B766172204D3D6628223C68722F3E22293B4C2E617070656E644368696C64284D297D4C2E617070656E644368696C642849292C4C2E617070656E644368696C642844292C772E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(37414) := '284C297D746869732E5F6F7665726C61794964735B655D3D746869732E5F6F7665726C6179732E616464286E2C226C696E74696E67222C7B706F736974696F6E3A732C68746D6C3A6D2C7363616C653A7B6D696E3A2E377D7D297D7D7D2C442E70726F74';
wwv_flow_imp.g_varchar2_table(37415) := '6F747970652E5F6164644572726F72733D66756E6374696F6E28652C74297B766172206E3D746869733B742E666F7245616368282866756E6374696F6E2874297B6E2E5F616464456E74727928652C226572726F72222C74297D29297D2C442E70726F74';
wwv_flow_imp.g_varchar2_table(37416) := '6F747970652E5F6164645761726E696E67733D66756E6374696F6E28652C74297B766172206E3D746869733B742E666F7245616368282866756E6374696F6E2874297B6E2E5F616464456E74727928652C227761726E696E67222C74297D29297D2C442E';
wwv_flow_imp.g_varchar2_table(37417) := '70726F746F747970652E5F616464496E666F733D66756E6374696F6E28652C74297B766172206E3D746869733B742E666F7245616368282866756E6374696F6E2874297B6E2E5F616464456E74727928652C22696E666F222C74297D29297D2C442E7072';
wwv_flow_imp.g_varchar2_table(37418) := '6F746F747970652E5F616464456E7472793D66756E6374696F6E28652C742C6E297B76617220693D6E2E72756C652C6F3D746869732E5F7472616E736C617465286E2E6D657373616765292C733D6E2E61637475616C456C656D656E7449642C723D6628';
wwv_flow_imp.g_varchar2_table(37419) := '273C6C6920636C6173733D22272B742B27223E3C7370616E20636C6173733D2269636F6E223E20272B4C5B745D2B273C2F7370616E3E3C61207469746C653D22272B5F2869292B223A20222B5F286F292B272220646174612D72756C653D22272B5F2869';
wwv_flow_imp.g_varchar2_table(37420) := '292B272220646174612D6D6573736167653D22272B5F286F292B27223E272B5F286F292B223C2F613E222B28733F273C6120636C6173733D22626A736C2D69642D68696E74223E3C636F64653E272B732B223C2F636F64653E3C2F613E223A2222292B22';
wwv_flow_imp.g_varchar2_table(37421) := '3C2F6C693E22293B652E617070656E644368696C642872297D2C442E70726F746F747970652E5F636C6561724F7665726C6179733D66756E6374696F6E28297B746869732E5F6F7665726C6179732E72656D6F7665287B747970653A226C696E74696E67';
wwv_flow_imp.g_varchar2_table(37422) := '227D292C746869732E5F6F7665726C61794964733D7B7D7D2C442E70726F746F747970652E5F636C6561724973737565733D66756E6374696F6E28297B746869732E5F6973737565733D7B7D2C746869732E5F636C6561724F7665726C61797328297D2C';
wwv_flow_imp.g_varchar2_table(37423) := '442E70726F746F747970652E5F736574427574746F6E53746174653D66756E6374696F6E2865297B7661727B6572726F72733A742C7761726E696E67733A6E2C696E666F733A697D3D652C6F3D746869732E5F627574746F6E2C733D28743F226572726F';
wwv_flow_imp.g_varchar2_table(37424) := '72223A6E2626227761726E696E6722297C7C2273756363657373222C723D605C6E202020203C7370616E20636C6173733D2269636F6E223E247B4C5B735D7D3C2F7370616E3E5C6E202020203C7370616E3E247B746869732E5F7472616E736C61746528';
wwv_flow_imp.g_varchar2_table(37425) := '747C7C6E3F227B6572726F72737D204572726F72732C207B7761726E696E67737D205761726E696E6773223A224E6F20497373756573222C7B6572726F72733A537472696E672874292C7761726E696E67733A537472696E67286E292C696E666F733A53';
wwv_flow_imp.g_varchar2_table(37426) := '7472696E672869297D297D3C2F7370616E3E603B733D746869732E697341637469766528293F733A22696E616374697665222C5B226572726F72222C22696E616374697665222C2273756363657373222C227761726E696E67225D2E666F724561636828';
wwv_flow_imp.g_varchar2_table(37427) := '2866756E6374696F6E2865297B733D3D3D653F6F2E636C6173734C6973742E6164642822626A736C2D627574746F6E2D222B65293A6F2E636C6173734C6973742E72656D6F76652822626A736C2D627574746F6E2D222B65297D29292C6F2E696E6E6572';
wwv_flow_imp.g_varchar2_table(37428) := '48544D4C3D727D2C442E70726F746F747970652E5F757064617465427574746F6E3D66756E6374696F6E28297B76617220653D302C743D302C6E3D303B666F7228766172206920696E20746869732E5F69737375657329746869732E5F6973737565735B';
wwv_flow_imp.g_varchar2_table(37429) := '695D2E666F7245616368282866756E6374696F6E2869297B226572726F72223D3D3D692E63617465676F72793F652B2B3A227761726E223D3D3D692E63617465676F72793F742B2B3A22696E666F223D3D3D692E63617465676F727926266E2B2B7D2929';
wwv_flow_imp.g_varchar2_table(37430) := '3B746869732E5F736574427574746F6E5374617465287B6572726F72733A652C7761726E696E67733A742C696E666F733A6E7D297D2C442E70726F746F747970652E5F637265617465427574746F6E3D66756E6374696F6E28297B76617220653D746869';
wwv_flow_imp.g_varchar2_table(37431) := '733B746869732E5F627574746F6E3D6628273C627574746F6E20636C6173733D22626A736C2D627574746F6E20626A736C2D627574746F6E2D696E61637469766522207469746C653D22272B746869732E5F7472616E736C6174652822546F67676C6520';
wwv_flow_imp.g_varchar2_table(37432) := '6C696E74696E67206F7665726C61797322292B27223E3C2F627574746F6E3E27292C746869732E5F627574746F6E2E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B652E746F67676C6528297D29292C7468';
wwv_flow_imp.g_varchar2_table(37433) := '69732E5F63616E7661732E676574436F6E7461696E657228292E617070656E644368696C6428746869732E5F627574746F6E297D2C442E70726F746F747970652E6C696E743D66756E6374696F6E28297B76617220653D746869732E5F62706D6E6A732E';
wwv_flow_imp.g_varchar2_table(37434) := '676574446566696E6974696F6E7328293B72657475726E206E6577206E2E4C696E74657228746869732E5F6C696E746572436F6E666967292E6C696E742865297D2C442E24696E6A6563743D5B2262706D6E6A73222C2263616E766173222C22636F6E66';
wwv_flow_imp.g_varchar2_table(37435) := '69672E6C696E74696E67222C22656C656D656E745265676973747279222C226576656E74427573222C226F7665726C617973222C227472616E736C617465225D3B76617220543D7B5F5F696E69745F5F3A5B226C696E74696E67222C226C696E74696E67';
wwv_flow_imp.g_varchar2_table(37436) := '456469746F72416374696F6E73225D2C6C696E74696E673A5B2274797065222C445D2C6C696E74696E67456469746F72416374696F6E733A5B2274797065222C775D7D3B66756E6374696F6E204928652C742C6E2C69297B746869732E5F636F6E746578';
wwv_flow_imp.g_varchar2_table(37437) := '745061643D652C746869732E5F706F7075704D656E753D742C746869732E5F63616E7661733D6E2C746869732E5F7472616E736C6174653D692C652E726567697374657250726F76696465722874686973297D66756E6374696F6E204D28652C74297B76';
wwv_flow_imp.g_varchar2_table(37438) := '6172206E3D652E6765745061642874292E68746D6C2E676574426F756E64696E67436C69656E745265637428293B72657475726E7B783A6E2E6C6566742C793A6E2E626F74746F6D2B357D7D492E24696E6A6563743D5B22636F6E74657874506164222C';
wwv_flow_imp.g_varchar2_table(37439) := '22706F7075704D656E75222C2263616E766173222C227472616E736C617465225D2C492E70726F746F747970652E676574436F6E74657874506164456E74726965733D66756E6374696F6E2865297B72657475726E20746869732E5F637265617465506F';
wwv_flow_imp.g_varchar2_table(37440) := '707570416374696F6E285B655D297D2C492E70726F746F747970652E6765744D756C7469456C656D656E74436F6E74657874506164456E74726965733D66756E6374696F6E2865297B72657475726E20746869732E5F637265617465506F707570416374';
wwv_flow_imp.g_varchar2_table(37441) := '696F6E2865297D2C492E70726F746F747970652E5F637265617465506F707570416374696F6E3D66756E6374696F6E2865297B636F6E737420743D746869732E5F7472616E736C6174652C6E3D746869732E5F636F6E746578745061642C693D74686973';
wwv_flow_imp.g_varchar2_table(37442) := '2E5F706F7075704D656E753B72657475726E7B227365742D636F6C6F72223A7B67726F75703A2265646974222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6C6F72222C7469746C653A74282253657420636F6C6F7222292C68746D6C3A27';
wwv_flow_imp.g_varchar2_table(37443) := '3C64697620636C6173733D22656E747279223E3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22323222206865696768743D223232222066696C6C3D2263757272656E74436F6C6F72';
wwv_flow_imp.g_varchar2_table(37444) := '223E5C6E20203C7061746820643D226D31322E3520352E352E332D2E3420332E362D332E36632E352D2E3520312E332D2E3520312E3720306C312031632E352E342E3520312E32203020312E376C2D332E3620332E362D2E342E32762E32633020312E34';
wwv_flow_imp.g_varchar2_table(37445) := '2E362032203120322E37762E366C2D312E3720312E36632D2E322E322D2E342E322D2E3620304C372E3320362E36612E342E3420302030203120302D2E366C2E332D2E332E352D2E352E382D2E38632E322D2E322E342D2E312E362030202E392E352031';
wwv_flow_imp.g_varchar2_table(37446) := '2E3520312E31203320312E317A6D2D392E39203620342E322D342E3220362E3320362E332D342E3220342E32632D2E332E332D2E392E332D312E3220306C2D2E382D2E382D2E392D2E382D322E332D322E3922202F3E5C6E3C2F7376673E3C2F6469763E';
wwv_flow_imp.g_varchar2_table(37447) := '272C616374696F6E3A7B636C69636B3A28742C6F293D3E7B76617220733D7B2E2E2E4D286E2C65292C637572736F723A7B783A742E782C793A742E797D7D3B692E6F70656E28652C22636F6C6F722D7069636B6572222C73297D7D7D7D7D3B636F6E7374';
wwv_flow_imp.g_varchar2_table(37448) := '20413D5B7B6C6162656C3A2244656661756C74222C66696C6C3A766F696420302C7374726F6B653A766F696420307D2C7B6C6162656C3A22426C7565222C66696C6C3A2223424244454642222C7374726F6B653A2223304434333732227D2C7B6C616265';
wwv_flow_imp.g_varchar2_table(37449) := '6C3A224F72616E6765222C66696C6C3A2223464645304232222C7374726F6B653A2223364233433030227D2C7B6C6162656C3A22477265656E222C66696C6C3A2223433845364339222C7374726F6B653A2223323035303232227D2C7B6C6162656C3A22';
wwv_flow_imp.g_varchar2_table(37450) := '526564222C66696C6C3A2223464643444432222C7374726F6B653A2223383331333131227D2C7B6C6162656C3A22507572706C65222C66696C6C3A2223453142454537222C7374726F6B653A2223354231373644227D5D3B66756E6374696F6E204E2865';
wwv_flow_imp.g_varchar2_table(37451) := '2C742C6E2C692C6F297B746869732E5F706F7075704D656E753D6E2C746869732E5F6D6F64656C696E673D692C746869732E5F7472616E736C6174653D6F2C746869732E5F636F6C6F72733D652626652E636F6C6F72737C7C412C746869732E5F646566';
wwv_flow_imp.g_varchar2_table(37452) := '61756C7446696C6C436F6C6F723D742626742E64656661756C7446696C6C436F6C6F727C7C227768697465222C746869732E5F64656661756C745374726F6B65436F6C6F723D742626742E64656661756C745374726F6B65436F6C6F727C7C2272676228';
wwv_flow_imp.g_varchar2_table(37453) := '33342C2033362C20343229222C746869732E5F706F7075704D656E752E726567697374657250726F76696465722822636F6C6F722D7069636B6572222C74686973297D66756E6374696F6E205028652C742C6E297B72657475726E2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(37454) := '28297B652E736574436F6C6F7228742C6E297D7D4E2E24696E6A6563743D5B22636F6E6669672E636F6C6F725069636B6572222C22636F6E6669672E62706D6E52656E6465726572222C22706F7075704D656E75222C226D6F64656C696E67222C227472';
wwv_flow_imp.g_varchar2_table(37455) := '616E736C617465225D2C4E2E70726F746F747970652E676574456E74726965733D66756E6374696F6E2865297B76617220743D746869733B72657475726E20746869732E5F636F6C6F72732E6D6170282866756E6374696F6E286E297B76617220693D27';
wwv_flow_imp.g_varchar2_table(37456) := '5C6E202020203C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076696577426F783D2230203020323520323522206865696768743D2231303025222077696474683D2231303025223E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(37457) := '203C726563742072783D22322220783D22312220793D2231222077696474683D22323222206865696768743D223232222066696C6C3D22766172282D2D66696C6C2D636F6C6F722922207374726F6B653D22766172282D2D7374726F6B652D636F6C6F72';
wwv_flow_imp.g_varchar2_table(37458) := '2922207374796C653D227374726F6B652D77696474683A32223E3C2F726563743E5C6E202020203C2F7376673E5C6E2020272E7265706C6163652822766172282D2D66696C6C2D636F6C6F7229222C6E2E66696C6C7C7C742E5F64656661756C7446696C';
wwv_flow_imp.g_varchar2_table(37459) := '6C436F6C6F72292E7265706C6163652822766172282D2D7374726F6B652D636F6C6F7229222C6E2E7374726F6B657C7C742E5F64656661756C745374726F6B65436F6C6F72293B72657475726E7B7469746C653A742E5F7472616E736C617465286E2E6C';
wwv_flow_imp.g_varchar2_table(37460) := '6162656C292C69643A6E2E6C6162656C2E746F4C6F7765724361736528292B222D636F6C6F72222C696D61676548746D6C3A692C616374696F6E3A5028742E5F6D6F64656C696E672C652C6E297D7D29297D3B636F6E7374204F3D7B5F5F696E69745F5F';
wwv_flow_imp.g_varchar2_table(37461) := '3A5B22636F6C6F72436F6E7465787450616450726F7669646572222C22636F6C6F72506F70757050726F7669646572225D2C636F6C6F72436F6E7465787450616450726F76696465723A5B2274797065222C495D2C636F6C6F72506F70757050726F7669';
wwv_flow_imp.g_varchar2_table(37462) := '6465723A5B2274797065222C4E5D7D3B66756E6374696F6E205228652C74297B74262628652E73757065725F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F747970652C7B636F6E7374727563746F723A7B76';
wwv_flow_imp.g_varchar2_table(37463) := '616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D29297D76617220462C423D2866756E6374696F6E2865297B76617220743D652E6578706F7274733D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(37464) := '2C6E297B6966286E7C7C286E3D3136292C766F696420303D3D3D65262628653D313238292C653C3D302972657475726E2230223B666F722876617220693D4D6174682E6C6F67284D6174682E706F7728322C6529292F4D6174682E6C6F67286E292C6F3D';
wwv_flow_imp.g_varchar2_table(37465) := '323B693D3D3D312F303B6F2A3D3229693D4D6174682E6C6F67284D6174682E706F7728322C652F6F29292F4D6174682E6C6F67286E292A6F3B76617220733D692D4D6174682E666C6F6F722869292C723D22223B666F72286F3D303B6F3C4D6174682E66';
wwv_flow_imp.g_varchar2_table(37466) := '6C6F6F722869293B6F2B2B29723D4D6174682E666C6F6F72284D6174682E72616E646F6D28292A6E292E746F537472696E67286E292B723B69662873297B76617220613D4D6174682E706F77286E2C73293B723D4D6174682E666C6F6F72284D6174682E';
wwv_flow_imp.g_varchar2_table(37467) := '72616E646F6D28292A61292E746F537472696E67286E292B727D766172206C3D7061727365496E7428722C6E293B72657475726E206C213D3D312F3026266C3E3D4D6174682E706F7728322C65293F7428652C6E293A727D3B742E7261636B3D66756E63';
wwv_flow_imp.g_varchar2_table(37468) := '74696F6E28652C6E2C69297B766172206F3D66756E6374696F6E286F297B76617220723D303B646F7B696628722B2B3E3130297B6966282169297468726F77206E6577204572726F722822746F6F206D616E7920494420636F6C6C6973696F6E732C2075';
wwv_flow_imp.g_varchar2_table(37469) := '7365206D6F7265206269747322293B652B3D697D76617220613D7428652C6E297D7768696C65284F626A6563742E6861734F776E50726F70657274792E63616C6C28732C6129293B72657475726E20735B615D3D6F2C617D2C733D6F2E686174733D7B7D';
wwv_flow_imp.g_varchar2_table(37470) := '3B72657475726E206F2E6765743D66756E6374696F6E2865297B72657475726E206F2E686174735B655D7D2C6F2E7365743D66756E6374696F6E28652C74297B72657475726E206F2E686174735B655D3D742C6F7D2C6F2E626974733D657C7C3132382C';
wwv_flow_imp.g_varchar2_table(37471) := '6F2E626173653D6E7C7C31362C6F7D7D28463D7B6578706F7274733A7B7D7D292C462E6578706F727473293B66756E6374696F6E20562865297B69662821287468697320696E7374616E63656F662056292972657475726E206E657720562865293B653D';
wwv_flow_imp.g_varchar2_table(37472) := '657C7C5B3132382C33362C315D2C746869732E5F736565643D652E6C656E6774683F422E7261636B28655B305D2C655B315D2C655B325D293A657D562E70726F746F747970652E6E6578743D66756E6374696F6E2865297B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(37473) := '5F7365656428657C7C2130297D2C562E70726F746F747970652E6E65787450726566697865643D66756E6374696F6E28652C74297B766172206E3B646F7B6E3D652B746869732E6E657874282130297D7768696C6528746869732E61737369676E656428';
wwv_flow_imp.g_varchar2_table(37474) := '6E29293B72657475726E20746869732E636C61696D286E2C74292C6E7D2C562E70726F746F747970652E636C61696D3D66756E6374696F6E28652C74297B746869732E5F736565642E73657428652C747C7C2130297D2C562E70726F746F747970652E61';
wwv_flow_imp.g_varchar2_table(37475) := '737369676E65643D66756E6374696F6E2865297B72657475726E20746869732E5F736565642E6765742865297C7C21317D2C562E70726F746F747970652E756E636C61696D3D66756E6374696F6E2865297B64656C65746520746869732E5F736565642E';
wwv_flow_imp.g_varchar2_table(37476) := '686174735B655D7D2C562E70726F746F747970652E636C6561723D66756E6374696F6E28297B76617220652C743D746869732E5F736565642E686174733B666F72286520696E207429746869732E756E636C61696D2865297D3B636F6E7374207A3D563B';
wwv_flow_imp.g_varchar2_table(37477) := '66756E6374696F6E204828652C74297B72657475726E20742E666F7245616368282866756E6374696F6E2874297B74262622737472696E6722213D747970656F66207426262141727261792E6973417272617928742926264F626A6563742E6B65797328';
wwv_flow_imp.g_varchar2_table(37478) := '74292E666F7245616368282866756E6374696F6E286E297B6966282264656661756C7422213D3D6E262621286E20696E206529297B76617220693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293B4F626A65';
wwv_flow_imp.g_varchar2_table(37479) := '63742E646566696E6550726F706572747928652C6E2C692E6765743F693A7B656E756D657261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20745B6E5D7D7D297D7D29297D29292C4F626A6563742E667265657A652865297D63';
wwv_flow_imp.g_varchar2_table(37480) := '6F6E737420573D4F626A6563742E70726F746F747970652E746F537472696E672C6A3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E207128652C74297B72657475726E206A2E63616C6C28652C74';
wwv_flow_imp.g_varchar2_table(37481) := '297D66756E6374696F6E202428652C74297B6C6574206E2C693B696628766F696420303D3D3D652972657475726E3B636F6E7374206F3D28733D652C225B6F626A6563742041727261795D223D3D3D572E63616C6C2873293F4B3A55293B76617220733B';
wwv_flow_imp.g_varchar2_table(37482) := '666F72286C6574207320696E2065296966287128652C73292626286E3D655B735D2C693D74286E2C6F287329292C21313D3D3D69292972657475726E206E7D66756E6374696F6E20552865297B72657475726E20657D66756E6374696F6E204B2865297B';
wwv_flow_imp.g_varchar2_table(37483) := '72657475726E204E756D6265722865297D66756E6374696F6E204728652C2E2E2E74297B636F6E7374206E3D652E7374796C653B72657475726E202428742C2866756E6374696F6E2865297B6526262428652C2866756E6374696F6E28652C74297B6E5B';
wwv_flow_imp.g_varchar2_table(37484) := '745D3D657D29297D29292C657D636F6E737420513D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E20592865297B72657475726E206E6577205A2865297D66756E6374696F6E205A2865297B69662821657C7C2165';
wwv_flow_imp.g_varchar2_table(37485) := '2E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D5A2E70';
wwv_flow_imp.g_varchar2_table(37486) := '726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C5A2E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374';
wwv_flow_imp.g_varchar2_table(37487) := '205265674578705D223D3D512E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C5A2E70726F746F747970652E72656D6F76654D61746368696E673D66';
wwv_flow_imp.g_varchar2_table(37488) := '756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E207468';
wwv_flow_imp.g_varchar2_table(37489) := '69737D2C5A2E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865';
wwv_flow_imp.g_varchar2_table(37490) := '293A746869732E6C6973742E746F67676C652865292C746869737D2C5A2E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C5A2E70726F746F747970652E68';
wwv_flow_imp.g_varchar2_table(37491) := '61733D5A2E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B76617220582C4A2C65652C74653D7B7D3B66756E6374696F6E206E6528297B583D77';
wwv_flow_imp.g_varchar2_table(37492) := '696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C4A3D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C6973';
wwv_flow_imp.g_varchar2_table(37493) := '74656E6572223A226465746163684576656E74222C65653D226164644576656E744C697374656E657222213D3D583F226F6E223A22227D7661722069652C6F653D48287B5F5F70726F746F5F5F3A6E756C6C2C62696E643A74652E62696E643D66756E63';
wwv_flow_imp.g_varchar2_table(37494) := '74696F6E28652C742C6E2C69297B72657475726E20587C7C6E6528292C655B585D2865652B742C6E2C697C7C2131292C6E7D2C756E62696E643A74652E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E204A7C7C6E652829';
wwv_flow_imp.g_varchar2_table(37495) := '2C655B4A5D2865652B742C6E2C697C7C2131292C6E7D2C64656661756C743A74657D2C5B74655D292C73653D5B22666F637573222C22626C7572225D2C72653D7B62696E643A66756E6374696F6E28652C742C6E2C692C6F297B72657475726E2D31213D';
wwv_flow_imp.g_varchar2_table(37496) := '3D73652E696E6465784F66286E292626286F3D2130292C6F652E62696E6428652C6E2C2866756E6374696F6E286E297B766172206F3D6E2E7461726765747C7C6E2E737263456C656D656E743B6E2E64656C65676174655461726765743D66756E637469';
wwv_flow_imp.g_varchar2_table(37497) := '6F6E28652C74297B766172206E3D653B72657475726E206E26262266756E6374696F6E223D3D747970656F66206E2E636C6F7365737426266E2E636C6F736573742874297C7C6E756C6C7D286F2C74292C6E2E64656C6567617465546172676574262669';
wwv_flow_imp.g_varchar2_table(37498) := '2E63616C6C28652C6E297D292C6F297D2C756E62696E643A66756E6374696F6E28652C742C6E2C69297B72657475726E2D31213D3D73652E696E6465784F66287429262628693D2130292C6F652E756E62696E6428652C742C6E2C69297D7D2C61653D21';
wwv_flow_imp.g_varchar2_table(37499) := '313B22756E646566696E656422213D747970656F6620646F63756D656E742626282869653D646F63756D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F746162';
wwv_flow_imp.g_varchar2_table(37500) := '6C653E3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D22636865636B626F78222F3E272C61653D2169652E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C69653D766F6964203029';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(37501) := '3B766172206C653D7B6C6567656E643A5B312C223C6669656C647365743E222C223C2F6669656C647365743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C74';
wwv_flow_imp.g_varchar2_table(37502) := '61626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E222C223C2F636F6C67726F75703E3C2F7461626C653E225D2C5F64656661756C743A61653F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B';
wwv_flow_imp.g_varchar2_table(37503) := '6C652E74643D6C652E74683D5B332C223C7461626C653E3C74626F64793E3C74723E222C223C2F74723E3C2F74626F64793E3C2F7461626C653E225D2C6C652E6F7074696F6E3D6C652E6F707467726F75703D5B312C273C73656C656374206D756C7469';
wwv_flow_imp.g_varchar2_table(37504) := '706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C6C652E74686561643D6C652E74626F64793D6C652E636F6C67726F75703D6C652E63617074696F6E3D6C652E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C';
wwv_flow_imp.g_varchar2_table(37505) := '653E225D2C6C652E706F6C796C696E653D6C652E656C6C697073653D6C652E706F6C79676F6E3D6C652E636972636C653D6C652E746578743D6C652E6C696E653D6C652E706174683D6C652E726563743D6C652E673D5B312C273C73766720786D6C6E73';
wwv_flow_imp.g_varchar2_table(37506) := '3D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F6E3D22312E31223E272C223C2F7376673E225D3B7661722063653D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F6620652974';
wwv_flow_imp.g_varchar2_table(37507) := '68726F77206E657720547970654572726F722822537472696E6720657870656374656422293B747C7C28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E6372656174';
wwv_flow_imp.g_varchar2_table(37508) := '65546578744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F672C2222293B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E';
wwv_flow_imp.g_varchar2_table(37509) := '696E6E657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C64293B766172206F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286C652C69293F6C655B695D3A6C652E5F6465';
wwv_flow_imp.g_varchar2_table(37510) := '6661756C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E637265617465456C656D656E74282264697622293B666F72286C2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E6669';
wwv_flow_imp.g_varchar2_table(37511) := '7273744368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76654368696C64286C2E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273';
wwv_flow_imp.g_varchar2_table(37512) := '744368696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C64286C2E66697273744368696C6429293B72657475726E20637D3B66756E6374696F6E20646528652C74297B72657475726E28743D747C7C646F63756D656E74292E';
wwv_flow_imp.g_varchar2_table(37513) := '717565727953656C6563746F722865297D66756E6374696F6E20686528652C74297B72657475726E20742E617070656E644368696C642866756E6374696F6E28652C74297B696628652E6F776E6572446F63756D656E74213D3D742E6F776E6572446F63';
wwv_flow_imp.g_varchar2_table(37514) := '756D656E74297472797B72657475726E20742E6F776E6572446F63756D656E742E696D706F72744E6F646528652C2130297D63617463682865297B7D72657475726E20657D28652C7429297D66756E6374696F6E20756528652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(37515) := '686528742C65292C657D7661722070653D322C67653D7B22616C69676E6D656E742D626173656C696E65223A312C22626173656C696E652D7368696674223A312C636C69703A312C22636C69702D70617468223A312C22636C69702D72756C65223A312C';
wwv_flow_imp.g_varchar2_table(37516) := '636F6C6F723A312C22636F6C6F722D696E746572706F6C6174696F6E223A312C22636F6C6F722D696E746572706F6C6174696F6E2D66696C74657273223A312C22636F6C6F722D70726F66696C65223A312C22636F6C6F722D72656E646572696E67223A';
wwv_flow_imp.g_varchar2_table(37517) := '312C637572736F723A312C646972656374696F6E3A312C646973706C61793A312C22646F6D696E616E742D626173656C696E65223A312C22656E61626C652D6261636B67726F756E64223A312C66696C6C3A312C2266696C6C2D6F706163697479223A31';
wwv_flow_imp.g_varchar2_table(37518) := '2C2266696C6C2D72756C65223A312C66696C7465723A312C22666C6F6F642D636F6C6F72223A312C22666C6F6F642D6F706163697479223A312C666F6E743A312C22666F6E742D66616D696C79223A312C22666F6E742D73697A65223A70652C22666F6E';
wwv_flow_imp.g_varchar2_table(37519) := '742D73697A652D61646A757374223A312C22666F6E742D73747265746368223A312C22666F6E742D7374796C65223A312C22666F6E742D76617269616E74223A312C22666F6E742D776569676874223A312C22676C7970682D6F7269656E746174696F6E';
wwv_flow_imp.g_varchar2_table(37520) := '2D686F72697A6F6E74616C223A312C22676C7970682D6F7269656E746174696F6E2D766572746963616C223A312C22696D6167652D72656E646572696E67223A312C6B65726E696E673A312C226C65747465722D73706163696E67223A312C226C696768';
wwv_flow_imp.g_varchar2_table(37521) := '74696E672D636F6C6F72223A312C6D61726B65723A312C226D61726B65722D656E64223A312C226D61726B65722D6D6964223A312C226D61726B65722D7374617274223A312C6D61736B3A312C6F7061636974793A312C6F766572666C6F773A312C2270';
wwv_flow_imp.g_varchar2_table(37522) := '6F696E7465722D6576656E7473223A312C2273686170652D72656E646572696E67223A312C2273746F702D636F6C6F72223A312C2273746F702D6F706163697479223A312C7374726F6B653A312C227374726F6B652D646173686172726179223A312C22';
wwv_flow_imp.g_varchar2_table(37523) := '7374726F6B652D646173686F6666736574223A312C227374726F6B652D6C696E65636170223A312C227374726F6B652D6C696E656A6F696E223A312C227374726F6B652D6D697465726C696D6974223A312C227374726F6B652D6F706163697479223A31';
wwv_flow_imp.g_varchar2_table(37524) := '2C227374726F6B652D7769647468223A70652C22746578742D616E63686F72223A312C22746578742D6465636F726174696F6E223A312C22746578742D72656E646572696E67223A312C22756E69636F64652D62696469223A312C7669736962696C6974';
wwv_flow_imp.g_varchar2_table(37525) := '793A312C22776F72642D73706163696E67223A312C2277726974696E672D6D6F6465223A317D3B66756E6374696F6E206D6528652C742C6E297B76617220693D742E7265706C616365282F285B612D7A5D29285B412D5A5D292F672C2224312D24322229';
wwv_flow_imp.g_varchar2_table(37526) := '2E746F4C6F7765724361736528292C6F3D67655B695D3B6F3F286F3D3D3D70652626226E756D626572223D3D747970656F66206E2626286E3D537472696E67286E292B22707822292C652E7374796C655B695D3D6E293A652E7365744174747269627574';
wwv_flow_imp.g_varchar2_table(37527) := '654E53286E756C6C2C742C6E297D66756E6374696F6E20666528652C742C6E297B69662822737472696E67223D3D747970656F662074297B696628766F696420303D3D3D6E2972657475726E2066756E6374696F6E28652C74297B72657475726E206765';
wwv_flow_imp.g_varchar2_table(37528) := '5B745D3F652E7374796C655B745D3A652E6765744174747269627574654E53286E756C6C2C74297D28652C74293B6D6528652C742C6E297D656C73652166756E6374696F6E28652C74297B766172206E2C692C6F3D4F626A6563742E6B6579732874293B';
wwv_flow_imp.g_varchar2_table(37529) := '666F72286E3D303B693D6F5B6E5D3B6E2B2B296D6528652C692C745B695D297D28652C74293B72657475726E20657D636F6E73742076653D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E2062652865297B726574';
wwv_flow_imp.g_varchar2_table(37530) := '75726E206E6577205F652865297D66756E6374696F6E205F652865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E6365206973207265717569726564';
wwv_flow_imp.g_varchar2_table(37531) := '22293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D66756E6374696F6E2079652865297B666F722876617220743B743D652E66697273744368696C643B29652E72656D6F76654368696C642874293B72657475726E20';
wwv_flow_imp.g_varchar2_table(37532) := '657D66756E6374696F6E2077652865297B72657475726E20652E636C6F6E654E6F6465282130297D5F652E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C5F';
wwv_flow_imp.g_varchar2_table(37533) := '652E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D223D3D76652E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C697374';
wwv_flow_imp.g_varchar2_table(37534) := '2E72656D6F76652865292C74686973297D2C5F652E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774';
wwv_flow_imp.g_varchar2_table(37535) := '683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C5F652E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D';
wwv_flow_imp.g_varchar2_table(37536) := '3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C5F652E70726F746F747970652E61727261793D66756E6374';
wwv_flow_imp.g_varchar2_table(37537) := '696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C5F652E70726F746F747970652E6861733D5F652E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C';
wwv_flow_imp.g_varchar2_table(37538) := '6973742E636F6E7461696E732865297D3B7661722043653D7B7376673A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D2C53653D273C73766720786D6C6E733D22272B43652E7376672B2722273B66756E6374696F6E20786528';
wwv_flow_imp.g_varchar2_table(37539) := '65297B76617220743D21313B223C737667223D3D3D652E737562737472696E6728302C34293F2D313D3D3D652E696E6465784F662843652E73766729262628653D53652B652E737562737472696E67283429293A28653D53652B223E222B652B223C2F73';
wwv_flow_imp.g_varchar2_table(37540) := '76673E222C743D2130293B766172206E3D66756E6374696F6E2865297B76617220743B72657475726E28743D6E657720444F4D506172736572292E6173796E633D21312C742E706172736546726F6D537472696E6728652C22746578742F786D6C22297D';
wwv_flow_imp.g_varchar2_table(37541) := '2865293B69662821742972657475726E206E3B666F722876617220693D646F63756D656E742E637265617465446F63756D656E74467261676D656E7428292C6F3D6E2E66697273744368696C643B6F2E66697273744368696C643B29692E617070656E64';
wwv_flow_imp.g_varchar2_table(37542) := '4368696C64286F2E66697273744368696C64293B72657475726E20697D66756E6374696F6E206B6528652C74297B766172206E3B72657475726E223C223D3D3D28653D652E7472696D2829292E6368617241742830293F286E3D78652865292E66697273';
wwv_flow_imp.g_varchar2_table(37543) := '744368696C642C6E3D646F63756D656E742E696D706F72744E6F6465286E2C213029293A6E3D646F63756D656E742E637265617465456C656D656E744E532843652E7376672C65292C7426266665286E2C74292C6E7D7661722045653D6E756C6C3B6675';
wwv_flow_imp.g_varchar2_table(37544) := '6E6374696F6E204C6528297B72657475726E206E756C6C3D3D3D456526262845653D6B6528227376672229292C45657D66756E6374696F6E20446528652C74297B766172206E2C692C6F3D4F626A6563742E6B6579732874293B666F72286E3D303B693D';
wwv_flow_imp.g_varchar2_table(37545) := '6F5B6E5D3B6E2B2B29655B695D3D745B695D3B72657475726E20657D66756E6374696F6E2054652865297B72657475726E20653F4C6528292E6372656174655356475472616E73666F726D46726F6D4D61747269782865293A4C6528292E637265617465';
wwv_flow_imp.g_varchar2_table(37546) := '5356475472616E73666F726D28297D7661722049653D2F285B263C3E5D7B317D292F672C4D653D2F285B5C6E5C72225D7B317D292F672C41653D7B2226223A2226616D703B222C223C223A22266C743B222C223E223A222667743B222C2722273A222722';
wwv_flow_imp.g_varchar2_table(37547) := '7D3B66756E6374696F6E204E6528652C74297B72657475726E20652E7265706C61636528742C2866756E6374696F6E28652C74297B72657475726E2041655B745D7C7C747D29297D66756E6374696F6E20506528652C74297B766172206E2C692C6F2C73';
wwv_flow_imp.g_varchar2_table(37548) := '2C723B73776974636828652E6E6F646554797065297B6361736520333A742E70757368284E6528652E74657874436F6E74656E742C496529293B627265616B3B6361736520313A696628742E7075736828223C222C652E7461674E616D65292C652E6861';
wwv_flow_imp.g_varchar2_table(37549) := '7341747472696275746573282929666F72286E3D302C693D286F3D652E61747472696275746573292E6C656E6774683B6E3C693B2B2B6E29733D6F2E6974656D286E292C742E70757368282220222C732E6E616D652C273D22272C4E6528732E76616C75';
wwv_flow_imp.g_varchar2_table(37550) := '652C4D65292C272227293B696628652E6861734368696C644E6F6465732829297B666F7228742E7075736828223E22292C6E3D302C693D28723D652E6368696C644E6F646573292E6C656E6774683B6E3C693B2B2B6E29506528722E6974656D286E292C';
wwv_flow_imp.g_varchar2_table(37551) := '74293B742E7075736828223C2F222C652E7461674E616D652C223E22297D656C736520742E7075736828222F3E22293B627265616B3B6361736520383A742E7075736828225C783363212D2D222C4E6528652E6E6F646556616C75652C4965292C222D2D';
wwv_flow_imp.g_varchar2_table(37552) := '5C78336522293B627265616B3B6361736520343A742E7075736828223C215B43444154415B222C652E6E6F646556616C75652C225D5D3E22293B627265616B3B64656661756C743A7468726F77206E6577204572726F722822756E61626C6520746F2068';
wwv_flow_imp.g_varchar2_table(37553) := '616E646C65206E6F646520222B652E6E6F646554797065297D72657475726E20747D66756E6374696F6E204F6528652C74297B696628766F69642030213D3D74297B7472797B2166756E6374696F6E28652C74297B766172206E3D78652874293B696628';
wwv_flow_imp.g_varchar2_table(37554) := '79652865292C74297B2866756E6374696F6E2865297B72657475726E2223646F63756D656E742D667261676D656E74223D3D3D652E6E6F64654E616D657D29286E297C7C286E3D6E2E646F63756D656E74456C656D656E74293B666F722876617220692C';
wwv_flow_imp.g_varchar2_table(37555) := '6F3D28693D6E2E6368696C644E6F6465732C41727261792E70726F746F747970652E736C6963652E63616C6C286929292C733D303B733C6F2E6C656E6774683B732B2B296865286F5B735D2C65297D7D28652C74297D63617463682865297B7468726F77';
wwv_flow_imp.g_varchar2_table(37556) := '206E6577204572726F7228226572726F722070617273696E67205356473A20222B652E6D657373616765297D72657475726E20657D72657475726E2066756E6374696F6E2865297B666F722876617220743D652E66697273744368696C642C6E3D5B5D3B';
wwv_flow_imp.g_varchar2_table(37557) := '743B29506528742C6E292C743D742E6E6578745369626C696E673B72657475726E206E2E6A6F696E282222297D2865297D66756E6374696F6E2052652865297B76617220743D652E706172656E744E6F64653B72657475726E20742626742E72656D6F76';
wwv_flow_imp.g_varchar2_table(37558) := '654368696C642865292C657D66756E6374696F6E20466528652C74297B72657475726E207420696E7374616E63656F66205356474D61747269783F652E6372656174655356475472616E73666F726D46726F6D4D61747269782874293A747D66756E6374';
wwv_flow_imp.g_varchar2_table(37559) := '696F6E20426528652C74297B766172206E3D652E7472616E73666F726D2E6261736556616C3B72657475726E207426262841727261792E697341727261792874297C7C28743D5B745D292C66756E6374696F6E28652C74297B766172206E2C693B666F72';
wwv_flow_imp.g_varchar2_table(37560) := '28652E636C65617228292C6E3D303B693D745B6E5D3B6E2B2B29652E617070656E644974656D28466528652C6929297D286E2C7429292C6E2E636F6E736F6C696461746528297D636F6E73742056653D2F5E636C6173735B207B5D2F3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(37561) := '6E207A652865297B72657475726E2041727261792E697341727261792865297D66756E6374696F6E20486528652C74297B72657475726E204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C74297D6675';
wwv_flow_imp.g_varchar2_table(37562) := '6E6374696F6E205765282E2E2E65297B313D3D3D652E6C656E67746826267A6528655B305D29262628653D655B305D293B636F6E737420743D28653D5B2E2E2E655D292E706F7028293B72657475726E20742E24696E6A6563743D652C747D636F6E7374';
wwv_flow_imp.g_varchar2_table(37563) := '206A653D2F636F6E7374727563746F725C732A5B5E285D2A5C285C732A285B5E295D2A295C292F6D2C71653D2F5E283F3A6173796E635C732B293F283F3A66756E6374696F6E5C732A5B5E285D2A293F283F3A5C285C732A285B5E295D2A295C297C285C';
wwv_flow_imp.g_varchar2_table(37564) := '772B29292F6D2C24653D2F5C2F5C2A285B5E2A5D2A295C2A5C2F2F6D3B66756E6374696F6E2055652865297B6966282266756E6374696F6E22213D747970656F662065297468726F77206E6577204572726F72286043616E6E6F7420616E6E6F74617465';
wwv_flow_imp.g_varchar2_table(37565) := '2022247B657D222E20457870656374656420612066756E6374696F6E2160293B636F6E737420743D652E746F537472696E6728292E6D617463682866756E6374696F6E2865297B72657475726E2056652E7465737428652E746F537472696E672829297D';
wwv_flow_imp.g_varchar2_table(37566) := '2865293F6A653A7165293B69662821742972657475726E5B5D3B636F6E7374206E3D745B315D7C7C745B325D3B72657475726E206E26266E2E73706C697428222C22292E6D61702828653D3E7B636F6E737420743D652E6D61746368282465293B726574';
wwv_flow_imp.g_varchar2_table(37567) := '75726E28742626745B315D7C7C65292E7472696D28297D29297C7C5B5D7D66756E6374696F6E204B6528652C74297B636F6E7374206E3D747C7C7B6765743A66756E6374696F6E28652C74297B696628692E707573682865292C21313D3D3D7429726574';
wwv_flow_imp.g_varchar2_table(37568) := '75726E206E756C6C3B7468726F77206128604E6F2070726F766964657220666F722022247B657D222160297D7D2C693D5B5D2C6F3D746869732E5F70726F7669646572733D4F626A6563742E637265617465286E2E5F70726F7669646572737C7C6E756C';
wwv_flow_imp.g_varchar2_table(37569) := '6C292C733D746869732E5F696E7374616E6365733D4F626A6563742E637265617465286E756C6C292C723D732E696E6A6563746F723D746869732C613D66756E6374696F6E2865297B636F6E737420743D692E6A6F696E2822202D3E2022293B72657475';
wwv_flow_imp.g_varchar2_table(37570) := '726E20692E6C656E6774683D302C6E6577204572726F7228743F60247B657D20285265736F6C76696E673A20247B747D29603A65297D3B66756E6374696F6E206C28652C74297B696628216F5B655D2626652E696E636C7564657328222E2229297B636F';
wwv_flow_imp.g_varchar2_table(37571) := '6E737420743D652E73706C697428222E22293B6C6574206E3D6C28742E73686966742829293B666F72283B742E6C656E6774683B296E3D6E5B742E736869667428295D3B72657475726E206E7D696628486528732C65292972657475726E20735B655D3B';
wwv_flow_imp.g_varchar2_table(37572) := '6966284865286F2C6529297B6966282D31213D3D692E696E6465784F66286529297468726F7720692E707573682865292C61282243616E6E6F74207265736F6C76652063697263756C617220646570656E64656E63792122293B72657475726E20692E70';
wwv_flow_imp.g_varchar2_table(37573) := '7573682865292C735B655D3D6F5B655D5B305D286F5B655D5B315D292C692E706F7028292C735B655D7D72657475726E206E2E67657428652C74297D66756E6374696F6E206328652C74297B696628766F696420303D3D3D74262628743D7B7D292C2266';
wwv_flow_imp.g_varchar2_table(37574) := '756E6374696F6E22213D747970656F662065297B696628217A65286529297468726F772061286043616E6E6F7420696E766F6B652022247B657D222E20457870656374656420612066756E6374696F6E2160293B653D576528652E736C6963652829297D';
wwv_flow_imp.g_varchar2_table(37575) := '72657475726E7B666E3A652C646570656E64656E636965733A28652E24696E6A6563747C7C5565286529292E6D61702828653D3E486528742C65293F745B655D3A6C28652929297D7D66756E6374696F6E20642865297B636F6E73747B666E3A742C6465';
wwv_flow_imp.g_varchar2_table(37576) := '70656E64656E636965733A6E7D3D632865293B72657475726E206E65772846756E6374696F6E2E70726F746F747970652E62696E642E63616C6C28742C6E756C6C2C2E2E2E6E29297D66756E6374696F6E206828652C742C6E297B636F6E73747B666E3A';
wwv_flow_imp.g_varchar2_table(37577) := '692C646570656E64656E636965733A6F7D3D6328652C6E293B72657475726E20692E6170706C7928742C6F297D66756E6374696F6E20752865297B72657475726E2057652828743D3E652E67657428742929297D66756E6374696F6E207028652C74297B';
wwv_flow_imp.g_varchar2_table(37578) := '696628742626742E6C656E677468297B636F6E7374206E3D4F626A6563742E637265617465286E756C6C292C693D4F626A6563742E637265617465286E756C6C292C733D5B5D2C723D5B5D2C613D5B5D3B6C6574206C2C632C642C683B666F72286C6574';
wwv_flow_imp.g_varchar2_table(37579) := '206520696E206F296C3D6F5B655D2C2D31213D3D742E696E6465784F662865292626282270726976617465223D3D3D6C5B325D3F28633D732E696E6465784F66286C5B335D292C2D313D3D3D633F28643D6C5B335D2E6372656174654368696C64285B5D';
wwv_flow_imp.g_varchar2_table(37580) := '2C74292C683D752864292C732E70757368286C5B335D292C722E707573682864292C612E707573682868292C6E5B655D3D5B682C652C2270726976617465222C645D293A6E5B655D3D5B615B635D2C652C2270726976617465222C725B635D5D293A6E5B';
wwv_flow_imp.g_varchar2_table(37581) := '655D3D5B6C5B325D2C6C5B315D5D2C695B655D3D2130292C22666163746F727922213D3D6C5B325D2626227479706522213D3D6C5B325D7C7C216C5B315D2E2473636F70657C7C742E666F72456163682828743D3E7B2D31213D3D6C5B315D2E2473636F';
wwv_flow_imp.g_varchar2_table(37582) := '70652E696E6465784F662874292626286E5B655D3D5B6C5B325D2C6C5B315D5D2C695B745D3D2130297D29293B742E666F72456163682828653D3E7B69662821695B655D297468726F77206E6577204572726F7228274E6F2070726F766964657220666F';
wwv_flow_imp.g_varchar2_table(37583) := '722022272B652B27222E2043616E6E6F74207573652070726F76696465722066726F6D2074686520706172656E742127297D29292C652E756E7368696674286E297D72657475726E206E6577204B6528652C72297D636F6E737420673D7B666163746F72';
wwv_flow_imp.g_varchar2_table(37584) := '793A682C747970653A642C76616C75653A66756E6374696F6E2865297B72657475726E20657D7D3B66756E6374696F6E206D28652C74297B636F6E7374206E3D652E5F5F696E69745F5F7C7C5B5D3B72657475726E2066756E6374696F6E28297B6E2E66';
wwv_flow_imp.g_varchar2_table(37585) := '6F72456163682828653D3E7B22737472696E67223D3D747970656F6620653F742E6765742865293A742E696E766F6B652865297D29297D7D66756E6374696F6E20662865297B636F6E737420743D652E5F5F6578706F7274735F5F3B69662874297B636F';
wwv_flow_imp.g_varchar2_table(37586) := '6E7374206E3D652E5F5F6D6F64756C65735F5F2C693D4F626A6563742E6B6579732865292E726564756365282828742C6E293D3E28225F5F6578706F7274735F5F22213D3D6E2626225F5F6D6F64756C65735F5F22213D3D6E2626225F5F696E69745F5F';
wwv_flow_imp.g_varchar2_table(37587) := '22213D3D6E2626225F5F646570656E64735F5F22213D3D6E262628745B6E5D3D655B6E5D292C7429292C4F626A6563742E637265617465286E756C6C29292C733D7028286E7C7C5B5D292E636F6E636174286929292C723D5765282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(37588) := '2865297B72657475726E20732E6765742865297D29293B742E666F7245616368282866756E6374696F6E2865297B6F5B655D3D5B722C652C2270726976617465222C735D7D29293B636F6E737420613D28652E5F5F696E69745F5F7C7C5B5D292E736C69';
wwv_flow_imp.g_varchar2_table(37589) := '636528293B72657475726E20612E756E7368696674282866756E6374696F6E28297B732E696E697428297D29292C6D28653D4F626A6563742E61737369676E287B7D2C652C7B5F5F696E69745F5F3A617D292C73297D72657475726E204F626A6563742E';
wwv_flow_imp.g_varchar2_table(37590) := '6B6579732865292E666F7245616368282866756E6374696F6E2874297B696628225F5F696E69745F5F223D3D3D747C7C225F5F646570656E64735F5F223D3D3D742972657475726E3B636F6E7374206E3D655B745D3B6966282270726976617465223D3D';
wwv_flow_imp.g_varchar2_table(37591) := '3D6E5B325D2972657475726E20766F6964286F5B745D3D6E293B636F6E737420693D6E5B305D2C733D6E5B315D3B6F5B745D3D5B675B695D2C476528692C73292C695D7D29292C6D28652C72297D66756E6374696F6E207628652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(37592) := '2D31213D3D652E696E6465784F662874297C7C2D31213D3D28653D28742E5F5F646570656E64735F5F7C7C5B5D292E72656475636528762C6529292E696E6465784F662874293F653A652E636F6E6361742874297D746869732E6765743D6C2C74686973';
wwv_flow_imp.g_varchar2_table(37593) := '2E696E766F6B653D682C746869732E696E7374616E74696174653D642C746869732E6372656174654368696C643D702C746869732E696E69743D66756E6374696F6E2865297B636F6E737420743D652E72656475636528762C5B5D292E6D61702866293B';
wwv_flow_imp.g_varchar2_table(37594) := '6C6574206E3D21313B72657475726E2066756E6374696F6E28297B6E7C7C286E3D21302C742E666F72456163682828653D3E6528292929297D7D2865297D66756E6374696F6E20476528652C74297B72657475726E2276616C756522213D3D6526267A65';
wwv_flow_imp.g_varchar2_table(37595) := '287429262628743D576528742E736C696365282929292C747D7661722051653D3165333B66756E6374696F6E20596528652C74297B766172206E3D746869733B743D747C7C51652C652E6F6E285B2272656E6465722E7368617065222C2272656E646572';
wwv_flow_imp.g_varchar2_table(37596) := '2E636F6E6E656374696F6E225D2C742C2866756E6374696F6E28652C74297B76617220693D652E747970652C6F3D742E656C656D656E742C733D742E6766782C723D742E61747472733B6966286E2E63616E52656E646572286F292972657475726E2272';
wwv_flow_imp.g_varchar2_table(37597) := '656E6465722E7368617065223D3D3D693F6E2E64726177536861706528732C6F2C72293A6E2E64726177436F6E6E656374696F6E28732C6F2C72297D29292C652E6F6E285B2272656E6465722E676574536861706550617468222C2272656E6465722E67';
wwv_flow_imp.g_varchar2_table(37598) := '6574436F6E6E656374696F6E50617468225D2C742C2866756E6374696F6E28652C74297B6966286E2E63616E52656E6465722874292972657475726E2272656E6465722E676574536861706550617468223D3D3D652E747970653F6E2E67657453686170';
wwv_flow_imp.g_varchar2_table(37599) := '65506174682874293A6E2E676574436F6E6E656374696F6E506174682874297D29297D66756E6374696F6E205A652865297B72657475726E20652E666C617428292E6A6F696E28222C22292E7265706C616365282F2C3F285B412D7A5D292C3F2F672C22';
wwv_flow_imp.g_varchar2_table(37600) := '243122297D66756E6374696F6E2058652865297B72657475726E5B224C222C652E782C652E795D7D66756E6374696F6E204A6528652C74297B636F6E7374206E3D652E6C656E6774682C693D5B286F3D655B305D2C5B224D222C6F2E782C6F2E795D295D';
wwv_flow_imp.g_varchar2_table(37601) := '3B766172206F2C732C722C613B666F72286C6574206F3D313B6F3C6E3B6F2B2B297B636F6E7374206E3D655B6F2D315D2C6C3D655B6F5D2C633D655B6F2B315D3B69662821637C7C2174297B692E70757368285865286C29293B636F6E74696E75657D63';
wwv_flow_imp.g_varchar2_table(37602) := '6F6E737420643D4D6174682E6D696E28742C7474286C2E782D6E2E782C6C2E792D6E2E79292C747428632E782D6C2E782C632E792D6C2E7929293B6966282164297B692E70757368285865286C29293B636F6E74696E75657D636F6E737420683D657428';
wwv_flow_imp.g_varchar2_table(37603) := '6C2C6E2C64292C753D6574286C2C6E2C2E352A64292C703D6574286C2C632C64292C673D6574286C2C632C2E352A64293B692E70757368285865286829292C692E707573682828723D672C613D702C5B2243222C28733D75292E782C732E792C722E782C';
wwv_flow_imp.g_varchar2_table(37604) := '722E792C612E782C612E795D29297D72657475726E20697D66756E6374696F6E20657428652C742C6E297B636F6E737420693D742E782D652E782C6F3D742E792D652E792C733D6E2F747428692C6F293B72657475726E7B783A652E782B692A732C793A';
wwv_flow_imp.g_varchar2_table(37605) := '652E792B6F2A737D7D66756E6374696F6E20747428652C74297B72657475726E204D6174682E73717274284D6174682E706F7728652C32292B4D6174682E706F7728742C3229297D66756E6374696F6E206E7428652C742C6E297B28302C692E45742928';
wwv_flow_imp.g_varchar2_table(37606) := '74292626286E3D742C743D6E756C6C292C747C7C28743D7B7D293B636F6E7374206F3D6B65282270617468222C74293B72657475726E28302C692E457429286E292626286F2E646174617365742E636F726E65725261646975733D537472696E67286E29';
wwv_flow_imp.g_varchar2_table(37607) := '292C6974286F2C65297D66756E6374696F6E20697428652C74297B72657475726E20666528652C7B643A5A65284A6528742C7061727365496E7428652E646174617365742E636F726E65725261646975732C3130297C7C3029297D292C657D66756E6374';
wwv_flow_imp.g_varchar2_table(37608) := '696F6E206F742865297B72657475726E28302C692E70622928652C2866756E6374696F6E2874297B72657475726E2128302C692E49362928652C2866756E6374696F6E2865297B72657475726E2065213D3D742626737428742C65297D29297D29297D66';
wwv_flow_imp.g_varchar2_table(37609) := '756E6374696F6E20737428652C74297B69662874297B696628653D3D3D742972657475726E20743B696628652E706172656E742972657475726E20737428652E706172656E742C74297D7D66756E6374696F6E20727428652C742C6E297B76617220693D';
wwv_flow_imp.g_varchar2_table(37610) := '216E7C7C2D313D3D3D652E696E6465784F662874293B72657475726E20692626652E707573682874292C697D66756E6374696F6E20617428652C742C6E297B6E3D6E7C7C302C28302C692E6379292865297C7C28653D5B655D292C28302C692E6A4A2928';
wwv_flow_imp.g_varchar2_table(37611) := '652C2866756E6374696F6E28652C6F297B76617220733D7428652C6F2C6E293B28302C692E6379292873292626732E6C656E6774682626617428732C742C6E2B31297D29297D66756E6374696F6E206C7428652C74297B72657475726E2066756E637469';
wwv_flow_imp.g_varchar2_table(37612) := '6F6E28652C742C6E297B76617220693D5B5D2C6F3D5B5D3B72657475726E20617428652C2866756E6374696F6E28652C732C72297B727428692C652C74293B76617220613D652E6368696C6472656E3B696628282D313D3D3D6E7C7C723C6E2926266126';
wwv_flow_imp.g_varchar2_table(37613) := '267274286F2C612C74292972657475726E20617D29292C697D28652C21742C2D31297D66756E6374696F6E20637428652C74297B766172206E2C6F2C732C723B72657475726E20743D2121742C28302C692E6379292865297C7C28653D5B655D292C2830';
wwv_flow_imp.g_varchar2_table(37614) := '2C692E6A4A2928652C2866756E6374696F6E2865297B76617220693D653B652E776179706F696E747326262174262628693D637428652E776179706F696E74732C213029293B76617220613D692E782C6C3D692E792C633D692E6865696768747C7C302C';
wwv_flow_imp.g_varchar2_table(37615) := '643D692E77696474687C7C303B28613C6E7C7C766F696420303D3D3D6E292626286E3D61292C286C3C6F7C7C766F696420303D3D3D6F292626286F3D6C292C28612B643E737C7C766F696420303D3D3D7329262628733D612B64292C286C2B633E727C7C';
wwv_flow_imp.g_varchar2_table(37616) := '766F696420303D3D3D7229262628723D6C2B63297D29292C7B783A6E2C793A6F2C6865696768743A722D6F2C77696474683A732D6E7D7D66756E6374696F6E2064742865297B72657475726E22776179706F696E747322696E20653F22636F6E6E656374';
wwv_flow_imp.g_varchar2_table(37617) := '696F6E223A227822696E20653F227368617065223A22726F6F74227D66756E6374696F6E2068742865297B72657475726E212821657C7C21652E69734672616D65297D66756E6374696F6E20757428652C74297B72657475726E28302C692E6B7029287B';
wwv_flow_imp.g_varchar2_table(37618) := '7D2C657C7C7B7D2C747C7C7B7D297D66756E6374696F6E20707428652C74297B59652E63616C6C28746869732C652C31292C746869732E434F4E4E454354494F4E5F5354594C453D742E7374796C65285B226E6F2D66696C6C225D2C7B7374726F6B6557';
wwv_flow_imp.g_varchar2_table(37619) := '696474683A352C7374726F6B653A2266756368736961227D292C746869732E53484150455F5354594C453D742E7374796C65287B66696C6C3A227768697465222C7374726F6B653A2266756368736961222C7374726F6B6557696474683A327D292C7468';
wwv_flow_imp.g_varchar2_table(37620) := '69732E4652414D455F5354594C453D742E7374796C65285B226E6F2D66696C6C225D2C7B7374726F6B653A2266756368736961222C7374726F6B654461736861727261793A342C7374726F6B6557696474683A327D297D59652E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(37621) := '63616E52656E6465723D66756E6374696F6E2865297B7D2C59652E70726F746F747970652E6472617753686170653D66756E6374696F6E28652C74297B7D2C59652E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(37622) := '652C74297B7D2C59652E70726F746F747970652E6765745368617065506174683D66756E6374696F6E2865297B7D2C59652E70726F746F747970652E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B7D2C522870742C596529';
wwv_flow_imp.g_varchar2_table(37623) := '2C70742E70726F746F747970652E63616E52656E6465723D66756E6374696F6E28297B72657475726E21307D2C70742E70726F746F747970652E6472617753686170653D66756E6374696F6E28652C742C6E297B766172206F3D6B652822726563742229';
wwv_flow_imp.g_varchar2_table(37624) := '3B72657475726E206665286F2C7B783A302C793A302C77696474683A742E77696474687C7C302C6865696768743A742E6865696768747C7C307D292C68742874293F6665286F2C28302C692E6B7029287B7D2C746869732E4652414D455F5354594C452C';
wwv_flow_imp.g_varchar2_table(37625) := '6E7C7C7B7D29293A6665286F2C28302C692E6B7029287B7D2C746869732E53484150455F5354594C452C6E7C7C7B7D29292C756528652C6F292C6F7D2C70742E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(37626) := '742C6E297B766172206F3D6E7428742E776179706F696E74732C28302C692E6B7029287B7D2C746869732E434F4E4E454354494F4E5F5354594C452C6E7C7C7B7D29293B72657475726E20756528652C6F292C6F7D2C70742E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(37627) := '65745368617065506174683D66756E6374696F6E2865297B76617220743D652E782C6E3D652E792C693D652E77696474683B72657475726E205A65285B5B224D222C742C6E5D2C5B226C222C692C305D2C5B226C222C302C652E6865696768745D2C5B22';
wwv_flow_imp.g_varchar2_table(37628) := '6C222C2D692C305D2C5B227A225D5D297D2C70742E70726F746F747970652E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B76617220742C6E2C693D652E776179706F696E74732C6F3D5B5D3B666F7228743D303B6E3D695B';
wwv_flow_imp.g_varchar2_table(37629) := '745D3B742B2B296E3D6E2E6F726967696E616C7C7C6E2C6F2E70757368285B303D3D3D743F224D223A224C222C6E2E782C6E2E795D293B72657475726E205A65286F297D2C70742E24696E6A6563743D5B226576656E74427573222C227374796C657322';
wwv_flow_imp.g_varchar2_table(37630) := '5D3B636F6E73742067743D7B5F5F696E69745F5F3A5B2264656661756C7452656E6465726572225D2C64656661756C7452656E64657265723A5B2274797065222C70745D2C7374796C65733A5B2274797065222C66756E6374696F6E28297B7661722065';
wwv_flow_imp.g_varchar2_table(37631) := '3D7B226E6F2D66696C6C223A7B66696C6C3A226E6F6E65227D2C226E6F2D626F72646572223A7B7374726F6B654F7061636974793A307D2C226E6F2D6576656E7473223A7B706F696E7465724576656E74733A226E6F6E65227D7D2C743D746869733B74';
wwv_flow_imp.g_varchar2_table(37632) := '6869732E636C733D66756E6374696F6E28652C742C6E297B766172206F3D746869732E7374796C6528742C6E293B72657475726E28302C692E6B7029286F2C7B636C6173733A657D297D2C746869732E7374796C653D66756E6374696F6E28742C6E297B';
wwv_flow_imp.g_varchar2_table(37633) := '28302C692E6379292874297C7C6E7C7C286E3D742C743D5B5D293B766172206F3D28302C692E54532928742C2866756E6374696F6E28742C6E297B72657475726E28302C692E6B702928742C655B6E5D7C7C7B7D297D292C7B7D293B72657475726E206E';
wwv_flow_imp.g_varchar2_table(37634) := '3F28302C692E6B7029286F2C6E293A6F7D2C746869732E636F6D707574655374796C653D66756E6374696F6E28652C6E2C6F297B72657475726E28302C692E637929286E297C7C286F3D6E2C6E3D5B5D292C742E7374796C65286E7C7C5B5D2C28302C69';
wwv_flow_imp.g_varchar2_table(37635) := '2E6B7029287B7D2C6F2C657C7C7B7D29297D7D5D7D3B66756E6374696F6E206D7428652C74297B72657475726E20742E666F7245616368282866756E6374696F6E2874297B74262622737472696E6722213D747970656F66207426262141727261792E69';
wwv_flow_imp.g_varchar2_table(37636) := '73417272617928742926264F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B6966282264656661756C7422213D3D6E262621286E20696E206529297B76617220693D4F626A6563742E6765744F776E50726F7065';
wwv_flow_imp.g_varchar2_table(37637) := '72747944657363726970746F7228742C6E293B4F626A6563742E646566696E6550726F706572747928652C6E2C692E6765743F693A7B656E756D657261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20745B6E5D7D7D297D7D29';
wwv_flow_imp.g_varchar2_table(37638) := '297D29292C4F626A6563742E667265657A652865297D636F6E73742066743D4F626A6563742E70726F746F747970652E746F537472696E672C76743D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(37639) := '20627428652C74297B72657475726E2076742E63616C6C28652C74297D66756E6374696F6E205F7428652C74297B6C6574206E2C693B696628766F696420303D3D3D652972657475726E3B636F6E7374206F3D28733D652C225B6F626A65637420417272';
wwv_flow_imp.g_varchar2_table(37640) := '61795D223D3D3D66742E63616C6C2873293F77743A7974293B76617220733B666F72286C6574207320696E206529696628627428652C73292626286E3D655B735D2C693D74286E2C6F287329292C21313D3D3D69292972657475726E206E7D66756E6374';
wwv_flow_imp.g_varchar2_table(37641) := '696F6E2079742865297B72657475726E20657D66756E6374696F6E2077742865297B72657475726E204E756D6265722865297D66756E6374696F6E20437428652C2E2E2E74297B636F6E7374206E3D652E7374796C653B72657475726E205F7428742C28';
wwv_flow_imp.g_varchar2_table(37642) := '66756E6374696F6E2865297B6526265F7428652C2866756E6374696F6E28652C74297B6E5B745D3D657D29297D29292C657D66756E6374696F6E20537428652C742C6E297B72657475726E20323D3D617267756D656E74732E6C656E6774683F652E6765';
wwv_flow_imp.g_varchar2_table(37643) := '744174747269627574652874293A6E756C6C3D3D3D6E3F652E72656D6F76654174747269627574652874293A28652E73657441747472696275746528742C6E292C65297D636F6E73742078743D4F626A6563742E70726F746F747970652E746F53747269';
wwv_flow_imp.g_varchar2_table(37644) := '6E673B66756E6374696F6E206B742865297B72657475726E206E65772045742865297D66756E6374696F6E2045742865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E7420';
wwv_flow_imp.g_varchar2_table(37645) := '7265666572656E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D66756E6374696F6E204C742865297B666F722876617220743B743D652E66697273744368696C643B29652E72';
wwv_flow_imp.g_varchar2_table(37646) := '656D6F76654368696C642874293B72657475726E20657D66756E6374696F6E20447428652C742C6E297B76617220693D6E3F653A652E706172656E744E6F64653B72657475726E206926262266756E6374696F6E223D3D747970656F6620692E636C6F73';
wwv_flow_imp.g_varchar2_table(37647) := '6573742626692E636C6F736573742874297C7C6E756C6C7D45742E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C45742E70726F746F747970652E72656D6F';
wwv_flow_imp.g_varchar2_table(37648) := '76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D223D3D78742E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C7468697329';
wwv_flow_imp.g_varchar2_table(37649) := '7D2C45742E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E';
wwv_flow_imp.g_varchar2_table(37650) := '5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C45742E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C697374';
wwv_flow_imp.g_varchar2_table(37651) := '2E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C45742E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E20417272';
wwv_flow_imp.g_varchar2_table(37652) := '61792E66726F6D28746869732E6C697374297D2C45742E70726F746F747970652E6861733D45742E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D';
wwv_flow_imp.g_varchar2_table(37653) := '3B7661722054742C49742C4D742C41743D7B7D3B66756E6374696F6E204E7428297B54743D77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C49743D77696E';
wwv_flow_imp.g_varchar2_table(37654) := '646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A226465746163684576656E74222C4D743D226164644576656E744C697374656E657222213D3D54743F226F6E223A22227D7661722050';
wwv_flow_imp.g_varchar2_table(37655) := '742C4F743D6D74287B5F5F70726F746F5F5F3A6E756C6C2C62696E643A41742E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2054747C7C4E7428292C655B54745D284D742B742C6E2C697C7C2131292C6E7D2C756E62696E64';
wwv_flow_imp.g_varchar2_table(37656) := '3A41742E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2049747C7C4E7428292C655B49745D284D742B742C6E2C697C7C2131292C6E7D2C64656661756C743A41747D2C5B41745D292C52743D5B22666F637573222C2262';
wwv_flow_imp.g_varchar2_table(37657) := '6C7572225D2C46743D66756E6374696F6E28652C742C6E2C692C6F297B72657475726E2D31213D3D52742E696E6465784F66286E292626286F3D2130292C4F742E62696E6428652C6E2C2866756E6374696F6E286E297B766172206F3D6E2E7461726765';
wwv_flow_imp.g_varchar2_table(37658) := '747C7C6E2E737263456C656D656E743B6E2E64656C65676174655461726765743D4474286F2C742C2130292C6E2E64656C65676174655461726765742626692E63616C6C28652C6E297D292C6F297D2C42743D66756E6374696F6E28652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(37659) := '7B72657475726E2D31213D3D52742E696E6465784F66287429262628693D2130292C4F742E756E62696E6428652C742C6E2C69297D2C56743D21313B22756E646566696E656422213D747970656F6620646F63756D656E742626282850743D646F63756D';
wwv_flow_imp.g_varchar2_table(37660) := '656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D22636865636B626F78';
wwv_flow_imp.g_varchar2_table(37661) := '222F3E272C56743D2150742E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C50743D766F69642030293B766172207A743D7B6C6567656E643A5B312C223C6669656C647365743E222C223C2F6669656C647365';
wwv_flow_imp.g_varchar2_table(37662) := '743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E222C223C2F636F6C67726F75';
wwv_flow_imp.g_varchar2_table(37663) := '703E3C2F7461626C653E225D2C5F64656661756C743A56743F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B7A742E74643D7A742E74683D5B332C223C7461626C653E3C74626F64793E3C74723E222C223C2F74723E';
wwv_flow_imp.g_varchar2_table(37664) := '3C2F74626F64793E3C2F7461626C653E225D2C7A742E6F7074696F6E3D7A742E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C7A742E74686561643D7A742E';
wwv_flow_imp.g_varchar2_table(37665) := '74626F64793D7A742E636F6C67726F75703D7A742E63617074696F6E3D7A742E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C7A742E706F6C796C696E653D7A742E656C6C697073653D7A742E706F6C79676F6E3D7A742E';
wwv_flow_imp.g_varchar2_table(37666) := '636972636C653D7A742E746578743D7A742E6C696E653D7A742E706174683D7A742E726563743D7A742E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F6E3D22312E31';
wwv_flow_imp.g_varchar2_table(37667) := '223E272C223C2F7376673E225D3B7661722048743D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870656374656422293B747C7C28';
wwv_flow_imp.g_varchar2_table(37668) := '743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F672C2222293B';
wwv_flow_imp.g_varchar2_table(37669) := '76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C64293B766172';
wwv_flow_imp.g_varchar2_table(37670) := '206F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C287A742C69293F7A745B695D3A7A742E5F64656661756C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E637265617465456C656D65';
wwv_flow_imp.g_varchar2_table(37671) := '6E74282264697622293B666F72286C2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E66697273744368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76654368696C64';
wwv_flow_imp.g_varchar2_table(37672) := '286C2E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273744368696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C64286C2E66697273';
wwv_flow_imp.g_varchar2_table(37673) := '744368696C6429293B72657475726E20637D3B66756E6374696F6E20577428652C74297B72657475726E206526262266756E6374696F6E223D3D747970656F6620652E6D6174636865732626652E6D6174636865732874297C7C21317D66756E6374696F';
wwv_flow_imp.g_varchar2_table(37674) := '6E206A7428652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F722865297D66756E6374696F6E20717428652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F';
wwv_flow_imp.g_varchar2_table(37675) := '72416C6C2865297D66756E6374696F6E2024742865297B652E706172656E744E6F64652626652E706172656E744E6F64652E72656D6F76654368696C642865297D66756E6374696F6E20557428652C74297B69662821657C7C21742972657475726E2D31';
wwv_flow_imp.g_varchar2_table(37676) := '3B766172206E3D652E696E6465784F662874293B72657475726E2D31213D3D6E2626652E73706C696365286E2C31292C6E7D66756E6374696F6E204B7428652C742C6E297B69662865262674297B226E756D62657222213D747970656F66206E2626286E';
wwv_flow_imp.g_varchar2_table(37677) := '3D2D31293B76617220693D652E696E6465784F662874293B6966282D31213D3D69297B696628693D3D3D6E2972657475726E3B6966282D313D3D3D6E2972657475726E3B652E73706C69636528692C31297D2D31213D3D6E3F652E73706C696365286E2C';
wwv_flow_imp.g_varchar2_table(37678) := '302C74293A652E707573682874297D7D66756E6374696F6E20477428652C74297B72657475726E20652626743F652E696E6465784F662874293A2D317D66756E6374696F6E20517428652C74297B72657475726E20652626743F4D6174682E7371727428';
wwv_flow_imp.g_varchar2_table(37679) := '4D6174682E706F7728652E782D742E782C32292B4D6174682E706F7728652E792D742E792C3229293A2D317D66756E6374696F6E20597428652C742C6E2C69297B696628766F696420303D3D3D69262628693D35292C21657C7C21747C7C216E29726574';
wwv_flow_imp.g_varchar2_table(37680) := '75726E21313B766172206F3D28742E782D652E78292A286E2E792D652E79292D28742E792D652E79292A286E2E782D652E78292C733D517428652C74293B72657475726E204D6174682E616273286F2F73293C3D697D766172205A743D323B66756E6374';
wwv_flow_imp.g_varchar2_table(37681) := '696F6E20587428652C74297B766172206E3D41727261792E66726F6D28617267756D656E7473292E666C617428293B636F6E737420693D7B783A2276222C793A2268227D3B666F7228636F6E73745B652C745D6F66204F626A6563742E656E7472696573';
wwv_flow_imp.g_varchar2_table(37682) := '286929296966284A7428652C6E292972657475726E20743B72657475726E21317D66756E6374696F6E204A7428652C74297B636F6E7374206E3D745B305D3B72657475726E28302C692E53692928742C2866756E6374696F6E2874297B72657475726E20';
wwv_flow_imp.g_varchar2_table(37683) := '4D6174682E616273286E5B655D2D745B655D293C3D5A747D29297D66756E6374696F6E20656E28652C742C6E297B72657475726E206E3D6E7C7C302C652E783E742E782D6E2626652E793E742E792D6E2626652E783C742E782B742E77696474682B6E26';
wwv_flow_imp.g_varchar2_table(37684) := '26652E793C742E792B742E6865696768742B6E7D66756E6374696F6E20746E28652C74297B72657475726E7B783A4D6174682E726F756E6428652E782B28742E782D652E78292F32292C793A4D6174682E726F756E6428652E792B28742E792D652E7929';
wwv_flow_imp.g_varchar2_table(37685) := '2F32297D7D766172206E6E3D2F2C3F285B612D7A5D292C3F2F67692C6F6E3D7061727365466C6F61742C736E3D4D6174682C726E3D736E2E50492C616E3D736E2E6D696E2C6C6E3D736E2E6D61782C636E3D736E2E706F772C646E3D736E2E6162732C68';
wwv_flow_imp.g_varchar2_table(37686) := '6E3D2F285B612D7A5D295B5C732C5D2A28282D3F5C642A5C2E3F5C642A283F3A655B2D2B5D3F5C642B293F5B5C735D2A2C3F5B5C735D2A292B292F67692C756E3D2F282D3F5C642A5C2E3F5C642A283F3A655B2D2B5D3F5C642B293F295B5C735D2A2C3F';
wwv_flow_imp.g_varchar2_table(37687) := '5B5C735D2A2F67692C706E3D41727261792E697341727261797C7C66756E6374696F6E2865297B72657475726E206520696E7374616E63656F662041727261797D3B66756E6374696F6E20676E28652C74297B72657475726E204F626A6563742E70726F';
wwv_flow_imp.g_varchar2_table(37688) := '746F747970652E6861734F776E50726F70657274792E63616C6C28652C74297D66756E6374696F6E206D6E2865297B6966282266756E6374696F6E223D3D747970656F6620657C7C4F626A656374286529213D3D652972657475726E20653B7661722074';
wwv_flow_imp.g_varchar2_table(37689) := '3D6E657720652E636F6E7374727563746F723B666F7228766172206E20696E206529676E28652C6E29262628745B6E5D3D6D6E28655B6E5D29293B72657475726E20747D66756E6374696F6E20666E2865297B76617220743D666E2E70733D666E2E7073';
wwv_flow_imp.g_varchar2_table(37690) := '7C7C7B7D3B72657475726E20745B655D3F745B655D2E736C6565703D3130303A745B655D3D7B736C6565703A3130307D2C73657454696D656F7574282866756E6374696F6E28297B666F7228766172206E20696E207429676E28742C6E2926266E213D65';
wwv_flow_imp.g_varchar2_table(37691) := '262628745B6E5D2E736C6565702D2D2C21745B6E5D2E736C656570262664656C65746520745B6E5D297D29292C745B655D7D66756E6374696F6E20766E28652C742C6E2C69297B72657475726E20313D3D3D617267756D656E74732E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(37692) := '28743D652E792C6E3D652E77696474682C693D652E6865696768742C653D652E78292C7B783A652C793A742C77696474683A6E2C6865696768743A692C78323A652B6E2C79323A742B697D7D66756E6374696F6E20626E28297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(37693) := '732E6A6F696E28222C22292E7265706C616365286E6E2C22243122297D66756E6374696F6E205F6E2865297B76617220743D6D6E2865293B72657475726E20742E746F537472696E673D626E2C747D66756E6374696F6E20796E28652C742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(37694) := '2C732C722C612C6C297B76617220633D312D6C2C643D636E28632C33292C683D636E28632C32292C753D6C2A6C2A6C2C703D642A742B332A682A6C2A692B332A632A6C2A6C2A732B752A613B72657475726E7B783A456E28642A652B332A682A6C2A6E2B';
wwv_flow_imp.g_varchar2_table(37695) := '332A632A6C2A6C2A6F2B752A72292C793A456E2870297D7D66756E6374696F6E20776E2865297B76617220743D66756E6374696F6E28652C742C6E2C692C6F2C732C722C61297B666F7228766172206C2C632C642C682C752C702C672C6D2C663D5B5D2C';
wwv_flow_imp.g_varchar2_table(37696) := '763D5B5B5D2C5B5D5D2C623D303B623C323B2B2B6229696628303D3D623F28633D362A652D31322A6E2B362A6F2C6C3D2D332A652B392A6E2D392A6F2B332A722C643D332A6E2D332A65293A28633D362A742D31322A692B362A732C6C3D2D332A742B39';
wwv_flow_imp.g_varchar2_table(37697) := '2A692D392A732B332A612C643D332A692D332A74292C646E286C293C31652D3132297B696628646E2863293C31652D313229636F6E74696E75653B303C28683D2D642F63292626683C312626662E707573682868297D656C736520673D632A632D342A64';
wwv_flow_imp.g_varchar2_table(37698) := '2A6C2C6D3D736E2E737172742867292C673C307C7C28303C28753D282D632B6D292F28322A6C29292626753C312626662E707573682875292C303C28703D282D632D6D292F28322A6C29292626703C312626662E70757368287029293B666F7228766172';
wwv_flow_imp.g_varchar2_table(37699) := '205F2C793D662E6C656E6774682C773D793B792D2D3B295F3D312D28683D665B795D292C765B305D5B795D3D5F2A5F2A5F2A652B332A5F2A5F2A682A6E2B332A5F2A682A682A6F2B682A682A682A722C765B315D5B795D3D5F2A5F2A5F2A742B332A5F2A';
wwv_flow_imp.g_varchar2_table(37700) := '5F2A682A692B332A5F2A682A682A732B682A682A682A613B72657475726E20765B305D5B775D3D652C765B315D5B775D3D742C765B305D5B772B315D3D722C765B315D5B772B315D3D612C765B305D2E6C656E6774683D765B315D2E6C656E6774683D77';
wwv_flow_imp.g_varchar2_table(37701) := '2B322C7B78303A616E282E2E2E765B305D292C79303A616E282E2E2E765B315D292C78313A6C6E282E2E2E765B305D292C79313A6C6E282E2E2E765B315D297D7D282E2E2E65293B72657475726E20766E28742E78302C742E79302C742E78312D742E78';
wwv_flow_imp.g_varchar2_table(37702) := '302C742E79312D742E7930297D66756E6374696F6E20436E28652C742C6E297B72657475726E20743E3D652E782626743C3D652E782B652E776964746826266E3E3D652E7926266E3C3D652E792B652E6865696768747D66756E6374696F6E20536E2865';
wwv_flow_imp.g_varchar2_table(37703) := '2C742C6E2C692C6F297B72657475726E20652A28652A282D332A742B392A6E2D392A692B332A6F292B362A742D31322A6E2B362A69292D332A742B332A6E7D66756E6374696F6E20786E28652C742C6E2C692C6F2C732C722C612C6C297B6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(37704) := '6C2626286C3D31293B666F722876617220633D286C3D6C3E313F313A6C3C303F303A6C292F322C643D5B2D2E313235322C2E313235322C2D2E333637382C2E333637382C2D2E353837332C2E353837332C2D2E373639392C2E373639392C2D2E39303431';
wwv_flow_imp.g_varchar2_table(37705) := '2C2E393034312C2D2E393831362C2E393831365D2C683D5B2E323439312C2E323439312C2E323333352C2E323333352C2E323033322C2E323033322C2E313630312C2E313630312C2E313036392C2E313036392C2E303437322C2E303437325D2C753D30';
wwv_flow_imp.g_varchar2_table(37706) := '2C703D303B703C31323B702B2B297B76617220673D632A645B705D2B632C6D3D536E28672C652C6E2C6F2C72292C663D536E28672C742C692C732C61292C763D6D2A6D2B662A663B752B3D685B705D2A736E2E737172742876297D72657475726E20632A';
wwv_flow_imp.g_varchar2_table(37707) := '757D66756E6374696F6E206B6E28652C742C6E2C692C6F2C732C722C61297B69662821286C6E28652C6E293C616E286F2C72297C7C616E28652C6E293E6C6E286F2C72297C7C6C6E28742C69293C616E28732C61297C7C616E28742C69293E6C6E28732C';
wwv_flow_imp.g_varchar2_table(37708) := '612929297B766172206C3D28652A692D742A6E292A28732D61292D28742D69292A286F2A612D732A72292C633D28652D6E292A28732D61292D28742D69292A286F2D72293B69662863297B76617220643D456E282828652A692D742A6E292A286F2D7229';
wwv_flow_imp.g_varchar2_table(37709) := '2D28652D6E292A286F2A612D732A7229292F63292C683D456E286C2F63292C753D2B642E746F46697865642832292C703D2B682E746F46697865642832293B6966282128753C2B616E28652C6E292E746F46697865642832297C7C753E2B6C6E28652C6E';
wwv_flow_imp.g_varchar2_table(37710) := '292E746F46697865642832297C7C753C2B616E286F2C72292E746F46697865642832297C7C753E2B6C6E286F2C72292E746F46697865642832297C7C703C2B616E28742C69292E746F46697865642832297C7C703E2B6C6E28742C69292E746F46697865';
wwv_flow_imp.g_varchar2_table(37711) := '642832297C7C703C2B616E28732C61292E746F46697865642832297C7C703E2B6C6E28732C61292E746F4669786564283229292972657475726E7B783A642C793A687D7D7D7D66756E6374696F6E20456E2865297B72657475726E204D6174682E726F75';
wwv_flow_imp.g_varchar2_table(37712) := '6E6428316531312A65292F316531317D66756E6374696F6E204C6E28652C742C6E297B696628693D776E2865292C6F3D776E2874292C693D766E2869292C2128436E286F3D766E286F292C692E782C692E79297C7C436E286F2C692E78322C692E79297C';
wwv_flow_imp.g_varchar2_table(37713) := '7C436E286F2C692E782C692E7932297C7C436E286F2C692E78322C692E7932297C7C436E28692C6F2E782C6F2E79297C7C436E28692C6F2E78322C6F2E79297C7C436E28692C6F2E782C6F2E7932297C7C436E28692C6F2E78322C6F2E7932297C7C2869';
wwv_flow_imp.g_varchar2_table(37714) := '2E783C6F2E78322626692E783E6F2E787C7C6F2E783C692E783226266F2E783E692E7829262628692E793C6F2E79322626692E793E6F2E797C7C6F2E793C692E793226266F2E793E692E7929292972657475726E206E3F303A5B5D3B666F722876617220';
wwv_flow_imp.g_varchar2_table(37715) := '692C6F2C733D786E282E2E2E65292C723D786E282E2E2E74292C613D496E2865293F313A7E7E28732F35297C7C312C6C3D496E2874293F313A7E7E28722F35297C7C312C633D5B5D2C643D5B5D2C683D7B7D2C753D6E3F303A5B5D2C703D303B703C612B';
wwv_flow_imp.g_varchar2_table(37716) := '313B702B2B297B76617220673D796E282E2E2E652C702F61293B632E70757368287B783A672E782C793A672E792C743A702F617D297D666F7228703D303B703C6C2B313B702B2B29673D796E282E2E2E742C702F6C292C642E70757368287B783A672E78';
wwv_flow_imp.g_varchar2_table(37717) := '2C793A672E792C743A702F6C7D293B666F7228703D303B703C613B702B2B29666F7228766172206D3D303B6D3C6C3B6D2B2B297B76617220662C763D635B705D2C623D635B702B315D2C5F3D645B6D5D2C793D645B6D2B315D2C773D646E28622E782D76';
wwv_flow_imp.g_varchar2_table(37718) := '2E78293C2E30313F2279223A2278222C433D646E28792E782D5F2E78293C2E30313F2279223A2278222C533D6B6E28762E782C762E792C622E782C622E792C5F2E782C5F2E792C792E782C792E79293B69662853297B696628685B663D532E782E746F46';
wwv_flow_imp.g_varchar2_table(37719) := '697865642839292B2223222B532E792E746F46697865642839295D29636F6E74696E75653B685B665D3D21303B76617220783D762E742B646E2828535B775D2D765B775D292F28625B775D2D765B775D29292A28622E742D762E74292C6B3D5F2E742B64';
wwv_flow_imp.g_varchar2_table(37720) := '6E2828535B435D2D5F5B435D292F28795B435D2D5F5B435D29292A28792E742D5F2E74293B783E3D302626783C3D3126266B3E3D3026266B3C3D312626286E3F752B2B3A752E70757368287B783A532E782C793A532E792C74313A782C74323A6B7D2929';
wwv_flow_imp.g_varchar2_table(37721) := '7D7D72657475726E20757D66756E6374696F6E20446E28652C742C6E297B653D506E2865292C743D506E2874293B666F722876617220692C6F2C732C722C612C6C2C632C642C682C752C703D6E3F303A5B5D2C673D302C6D3D652E6C656E6774683B673C';
wwv_flow_imp.g_varchar2_table(37722) := '6D3B672B2B297B76617220663D655B675D3B696628224D223D3D665B305D29693D613D665B315D2C6F3D6C3D665B325D3B656C73657B2243223D3D665B305D3F28693D28683D5B692C6F2C2E2E2E662E736C6963652831295D295B365D2C6F3D685B375D';
wwv_flow_imp.g_varchar2_table(37723) := '293A28683D5B692C6F2C692C6F2C612C6C2C612C6C5D2C693D612C6F3D6C293B666F722876617220763D302C623D742E6C656E6774683B763C623B762B2B297B766172205F3D745B765D3B696628224D223D3D5F5B305D29733D633D5F5B315D2C723D64';
wwv_flow_imp.g_varchar2_table(37724) := '3D5F5B325D3B656C73657B2243223D3D5F5B305D3F28733D28753D5B732C722C2E2E2E5F2E736C6963652831295D295B365D2C723D755B375D293A28753D5B732C722C732C722C632C642C632C645D2C733D632C723D64293B76617220793D4C6E28682C';
wwv_flow_imp.g_varchar2_table(37725) := '752C6E293B6966286E29702B3D793B656C73657B666F722876617220773D302C433D792E6C656E6774683B773C433B772B2B29795B775D2E7365676D656E74313D672C795B775D2E7365676D656E74323D762C795B775D2E62657A313D682C795B775D2E';
wwv_flow_imp.g_varchar2_table(37726) := '62657A323D753B703D702E636F6E6361742879297D7D7D7D7D72657475726E20707D66756E6374696F6E20546E2865297B76617220743D666E2865293B696628742E6162732972657475726E205F6E28742E616273293B696628706E2865292626706E28';
wwv_flow_imp.g_varchar2_table(37727) := '652626655B305D297C7C28653D66756E6374696F6E2865297B69662821652972657475726E206E756C6C3B76617220743D666E2865293B696628742E6172722972657475726E206D6E28742E617272293B766172206E3D7B613A372C633A362C683A312C';
wwv_flow_imp.g_varchar2_table(37728) := '6C3A322C6D3A322C713A342C733A342C743A322C763A312C7A3A307D2C693D5B5D3B72657475726E20706E2865292626706E28655B305D29262628693D6D6E286529292C692E6C656E6774687C7C537472696E672865292E7265706C61636528686E2C28';
wwv_flow_imp.g_varchar2_table(37729) := '66756E6374696F6E28652C742C6F297B76617220733D5B5D2C723D742E746F4C6F7765724361736528293B666F72286F2E7265706C61636528756E2C2866756E6374696F6E28652C74297B742626732E70757368282B74297D29292C226D223D3D722626';
wwv_flow_imp.g_varchar2_table(37730) := '732E6C656E6774683E32262628692E70757368285B742C2E2E2E732E73706C69636528302C32295D292C723D226C222C743D226D223D3D743F226C223A224C22293B732E6C656E6774683E3D6E5B725D262628692E70757368285B742C2E2E2E732E7370';
wwv_flow_imp.g_varchar2_table(37731) := '6C69636528302C6E5B725D295D292C6E5B725D293B293B7D29292C692E746F537472696E673D666E2E746F537472696E672C742E6172723D6D6E2869292C697D286529292C21657C7C21652E6C656E6774682972657475726E5B5B224D222C302C305D5D';
wwv_flow_imp.g_varchar2_table(37732) := '3B766172206E2C693D5B5D2C6F3D302C733D302C723D302C613D302C6C3D303B224D223D3D655B305D5B305D262628723D6F3D2B655B305D5B315D2C613D733D2B655B305D5B325D2C6C2B2B2C695B305D3D5B224D222C6F2C735D293B666F7228766172';
wwv_flow_imp.g_varchar2_table(37733) := '20632C642C683D6C2C753D652E6C656E6774683B683C753B682B2B297B696628692E7075736828633D5B5D292C286E3D28643D655B685D295B305D29213D6E2E746F55707065724361736528292973776974636828635B305D3D6E2E746F557070657243';
wwv_flow_imp.g_varchar2_table(37734) := '61736528292C635B305D297B636173652241223A635B315D3D645B315D2C635B325D3D645B325D2C635B335D3D645B335D2C635B345D3D645B345D2C635B355D3D645B355D2C635B365D3D2B645B365D2B6F2C635B375D3D2B645B375D2B733B62726561';
wwv_flow_imp.g_varchar2_table(37735) := '6B3B636173652256223A635B315D3D2B645B315D2B733B627265616B3B636173652248223A635B315D3D2B645B315D2B6F3B627265616B3B63617365224D223A723D2B645B315D2B6F2C613D2B645B325D2B733B64656661756C743A666F722876617220';
wwv_flow_imp.g_varchar2_table(37736) := '703D312C673D642E6C656E6774683B703C673B702B2B29635B705D3D2B645B705D2B287025323F6F3A73297D656C736520666F7228766172206D3D302C663D642E6C656E6774683B6D3C663B6D2B2B29635B6D5D3D645B6D5D3B737769746368286E3D6E';
wwv_flow_imp.g_varchar2_table(37737) := '2E746F55707065724361736528292C635B305D297B63617365225A223A6F3D2B722C733D2B613B627265616B3B636173652248223A6F3D635B315D3B627265616B3B636173652256223A733D635B315D3B627265616B3B63617365224D223A723D635B63';
wwv_flow_imp.g_varchar2_table(37738) := '2E6C656E6774682D325D2C613D635B632E6C656E6774682D315D3B64656661756C743A6F3D635B632E6C656E6774682D325D2C733D635B632E6C656E6774682D315D7D7D72657475726E20692E746F537472696E673D626E2C742E6162733D5F6E286929';
wwv_flow_imp.g_varchar2_table(37739) := '2C697D66756E6374696F6E20496E2865297B72657475726E20655B305D3D3D3D655B325D2626655B315D3D3D3D655B335D2626655B345D3D3D3D655B365D2626655B355D3D3D3D655B375D7D66756E6374696F6E204D6E28652C742C6E2C69297B726574';
wwv_flow_imp.g_varchar2_table(37740) := '75726E5B652C742C6E2C692C6E2C695D7D66756E6374696F6E20416E28652C742C6E2C692C6F2C73297B76617220723D312F332C613D322F333B72657475726E5B722A652B612A6E2C722A742B612A692C722A6F2B612A6E2C722A732B612A692C6F2C73';
wwv_flow_imp.g_varchar2_table(37741) := '5D7D66756E6374696F6E204E6E28652C742C6E2C692C6F2C732C722C612C6C2C63297B76617220642C683D3132302A726E2F3138302C753D726E2F3138302A282B6F7C7C30292C703D5B5D2C673D66756E6374696F6E206528297B76617220743D417272';
wwv_flow_imp.g_varchar2_table(37742) := '61792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C30292E6A6F696E2822E2908022292C6E3D652E63616368653D652E63616368657C7C7B7D2C693D652E636F756E743D652E636F756E747C7C5B5D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(37743) := '676E286E2C74293F2866756E6374696F6E28652C74297B666F7228766172206E3D302C693D652E6C656E6774683B6E3C693B6E2B2B29696628655B6E5D3D3D3D742972657475726E20652E7075736828652E73706C696365286E2C31295B305D297D2869';
wwv_flow_imp.g_varchar2_table(37744) := '2C74292C6E5B745D293A28692E6C656E6774683E3D316533262664656C657465206E5B692E736869667428295D2C692E707573682874292C6E5B745D3D66756E6374696F6E28652C742C6E297B72657475726E7B783A652A736E2E636F73286E292D742A';
wwv_flow_imp.g_varchar2_table(37745) := '736E2E73696E286E292C793A652A736E2E73696E286E292B742A736E2E636F73286E297D7D282E2E2E617267756D656E7473292C6E5B745D297D3B6966286329533D635B305D2C783D635B315D2C773D635B325D2C433D635B335D3B656C73657B653D28';
wwv_flow_imp.g_varchar2_table(37746) := '643D6728652C742C2D7529292E782C743D642E793B766172206D3D28652D28613D28643D6728612C6C2C2D7529292E7829292F322C663D28742D286C3D642E7929292F322C763D6D2A6D2F286E2A6E292B662A662F28692A69293B763E312626286E2A3D';
wwv_flow_imp.g_varchar2_table(37747) := '763D736E2E737172742876292C692A3D76293B76617220623D6E2A6E2C5F3D692A692C793D28733D3D723F2D313A31292A736E2E7371727428646E2828622A5F2D622A662A662D5F2A6D2A6D292F28622A662A662B5F2A6D2A6D2929292C773D792A6E2A';
wwv_flow_imp.g_varchar2_table(37748) := '662F692B28652B61292F322C433D792A2D692A6D2F6E2B28742B6C292F322C533D736E2E6173696E282828742D43292F69292E746F4669786564283929292C783D736E2E6173696E2828286C2D43292F69292E746F4669786564283929293B28533D653C';
wwv_flow_imp.g_varchar2_table(37749) := '773F726E2D533A53293C30262628533D322A726E2B53292C28783D613C773F726E2D783A78293C30262628783D322A726E2B78292C722626533E78262628532D3D322A726E292C21722626783E53262628782D3D322A726E297D766172206B3D782D533B';
wwv_flow_imp.g_varchar2_table(37750) := '696628646E286B293E68297B76617220453D782C4C3D612C443D6C3B783D532B682A28722626783E533F313A2D31292C703D4E6E28613D772B6E2A736E2E636F732878292C6C3D432B692A736E2E73696E2878292C6E2C692C6F2C302C722C4C2C442C5B';
wwv_flow_imp.g_varchar2_table(37751) := '782C452C772C435D297D6B3D782D533B76617220543D736E2E636F732853292C493D736E2E73696E2853292C4D3D736E2E636F732878292C413D736E2E73696E2878292C4E3D736E2E74616E286B2F34292C503D342F332A6E2A4E2C4F3D342F332A692A';
wwv_flow_imp.g_varchar2_table(37752) := '4E2C523D5B652C745D2C463D5B652B502A492C742D4F2A545D2C423D5B612B502A412C6C2D4F2A4D5D2C563D5B612C6C5D3B696628465B305D3D322A525B305D2D465B305D2C465B315D3D322A525B315D2D465B315D2C632972657475726E5B462C422C';
wwv_flow_imp.g_varchar2_table(37753) := '565D2E636F6E6361742870293B666F7228766172207A3D5B5D2C483D302C573D28703D5B462C422C565D2E636F6E6361742870292E6A6F696E28292E73706C697428222C2229292E6C656E6774683B483C573B482B2B297A5B485D3D4825323F6728705B';
wwv_flow_imp.g_varchar2_table(37754) := '482D315D2C705B485D2C75292E793A6728705B485D2C705B482B315D2C75292E783B72657475726E207A7D66756E6374696F6E20506E2865297B76617220743D666E2865293B696628742E63757276652972657475726E205F6E28742E6375727665293B';
wwv_flow_imp.g_varchar2_table(37755) := '666F7228766172206E3D546E2865292C693D7B783A302C793A302C62783A302C62793A302C583A302C593A302C71783A6E756C6C2C71793A6E756C6C7D2C6F3D66756E6374696F6E28652C742C6E297B76617220692C6F3B69662821652972657475726E';
wwv_flow_imp.g_varchar2_table(37756) := '5B2243222C742E782C742E792C742E782C742E792C742E782C742E795D3B737769746368282128655B305D696E7B543A312C513A317D29262628742E71783D742E71793D6E756C6C292C655B305D297B63617365224D223A742E583D655B315D2C742E59';
wwv_flow_imp.g_varchar2_table(37757) := '3D655B325D3B627265616B3B636173652241223A653D5B2243222C2E2E2E4E6E28742E782C742E792C2E2E2E652E736C696365283129295D3B627265616B3B636173652253223A2243223D3D6E7C7C2253223D3D6E3F28693D322A742E782D742E62782C';
wwv_flow_imp.g_varchar2_table(37758) := '6F3D322A742E792D742E6279293A28693D742E782C6F3D742E79292C653D5B2243222C692C6F2C2E2E2E652E736C6963652831295D3B627265616B3B636173652254223A2251223D3D6E7C7C2254223D3D6E3F28742E71783D322A742E782D742E71782C';
wwv_flow_imp.g_varchar2_table(37759) := '742E71793D322A742E792D742E7179293A28742E71783D742E782C742E71793D742E79292C653D5B2243222C2E2E2E416E28742E782C742E792C742E71782C742E71792C655B315D2C655B325D295D3B627265616B3B636173652251223A742E71783D65';
wwv_flow_imp.g_varchar2_table(37760) := '5B315D2C742E71793D655B325D2C653D5B2243222C2E2E2E416E28742E782C742E792C655B315D2C655B325D2C655B335D2C655B345D295D3B627265616B3B63617365224C223A653D5B2243222C2E2E2E4D6E28742E782C742E792C655B315D2C655B32';
wwv_flow_imp.g_varchar2_table(37761) := '5D295D3B627265616B3B636173652248223A653D5B2243222C2E2E2E4D6E28742E782C742E792C655B315D2C742E79295D3B627265616B3B636173652256223A653D5B2243222C2E2E2E4D6E28742E782C742E792C742E782C655B315D295D3B62726561';
wwv_flow_imp.g_varchar2_table(37762) := '6B3B63617365225A223A653D5B2243222C2E2E2E4D6E28742E782C742E792C742E582C742E59295D7D72657475726E20657D2C733D66756E6374696F6E28652C74297B696628655B745D2E6C656E6774683E37297B655B745D2E736869667428293B666F';
wwv_flow_imp.g_varchar2_table(37763) := '722876617220693D655B745D3B692E6C656E6774683B29725B745D3D2241222C652E73706C69636528742B2B2C302C5B2243222C2E2E2E692E73706C69636528302C36295D293B652E73706C69636528742C31292C643D6E2E6C656E6774687D7D2C723D';
wwv_flow_imp.g_varchar2_table(37764) := '5B5D2C613D22222C6C3D22222C633D302C643D6E2E6C656E6774683B633C643B632B2B297B6E5B635D262628613D6E5B635D5B305D292C224322213D61262628725B635D3D612C632626286C3D725B632D315D29292C6E5B635D3D6F286E5B635D2C692C';
wwv_flow_imp.g_varchar2_table(37765) := '6C292C224122213D725B635D26262243223D3D61262628725B635D3D224322292C73286E2C63293B76617220683D6E5B635D2C753D682E6C656E6774683B692E783D685B752D325D2C692E793D685B752D315D2C692E62783D6F6E28685B752D345D297C';
wwv_flow_imp.g_varchar2_table(37766) := '7C692E782C692E62793D6F6E28685B752D335D297C7C692E797D72657475726E20742E63757276653D5F6E286E292C6E7D66756E6374696F6E204F6E2865297B72657475726E28302C692E477629286529262628302C692E7A792928652C22776179706F';
wwv_flow_imp.g_varchar2_table(37767) := '696E747322297D66756E6374696F6E20526E2865297B72657475726E28302C692E477629286529262628302C692E7A792928652C226C6162656C54617267657422297D66756E6374696F6E20466E2865297B72657475726E7B783A4D6174682E726F756E';
wwv_flow_imp.g_varchar2_table(37768) := '6428652E78292C793A4D6174682E726F756E6428652E79292C77696474683A4D6174682E726F756E6428652E7769647468292C6865696768743A4D6174682E726F756E6428652E686569676874297D7D66756E6374696F6E20426E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(37769) := '6E7B783A4D6174682E726F756E6428652E78292C793A4D6174682E726F756E6428652E79297D7D66756E6374696F6E20566E2865297B72657475726E7B746F703A652E792C72696768743A652E782B28652E77696474687C7C30292C626F74746F6D3A65';
wwv_flow_imp.g_varchar2_table(37770) := '2E792B28652E6865696768747C7C30292C6C6566743A652E787D7D66756E6374696F6E207A6E2865297B72657475726E7B783A652E6C6566742C793A652E746F702C77696474683A652E72696768742D652E6C6566742C6865696768743A652E626F7474';
wwv_flow_imp.g_varchar2_table(37771) := '6F6D2D652E746F707D7D66756E6374696F6E20486E2865297B72657475726E204F6E2865293F66756E6374696F6E2865297B666F722876617220743D652E776179706F696E74732C6E3D742E726564756365282866756E6374696F6E28652C6E2C69297B';
wwv_flow_imp.g_varchar2_table(37772) := '766172206F3D745B692D315D3B6966286F297B76617220733D655B652E6C656E6774682D315D2C723D732626732E656E644C656E6774687C7C302C613D66756E6374696F6E28652C74297B72657475726E204D6174682E73717274284D6174682E706F77';
wwv_flow_imp.g_varchar2_table(37773) := '28652E782D742E782C32292B4D6174682E706F7728652E792D742E792C3229297D286F2C6E293B652E70757368287B73746172743A6F2C656E643A6E2C73746172744C656E6774683A722C656E644C656E6774683A722B612C6C656E6774683A617D297D';
wwv_flow_imp.g_varchar2_table(37774) := '72657475726E20657D292C5B5D292C693D6E2E726564756365282866756E6374696F6E28652C74297B72657475726E20652B742E6C656E6774687D292C30292F322C6F3D302C733D6E5B6F5D3B732E656E644C656E6774683C693B29733D6E5B2B2B6F5D';
wwv_flow_imp.g_varchar2_table(37775) := '3B76617220723D28692D732E73746172744C656E677468292F732E6C656E6774683B72657475726E7B783A732E73746172742E782B28732E656E642E782D732E73746172742E78292A722C793A732E73746172742E792B28732E656E642E792D732E7374';
wwv_flow_imp.g_varchar2_table(37776) := '6172742E79292A727D7D2865293A426E287B783A28743D65292E782B28742E77696474687C7C30292F322C793A742E792B28742E6865696768747C7C30292F327D293B76617220747D66756E6374696F6E20576E28652C742C6E297B6E3D6E7C7C302C28';
wwv_flow_imp.g_varchar2_table(37777) := '302C692E477629286E297C7C286E3D7B783A6E2C793A6E7D293B766172206F3D566E2865292C733D566E2874292C723D6F2E626F74746F6D2B6E2E793C3D732E746F702C613D6F2E6C6566742D6E2E783E3D732E72696768742C6C3D6F2E746F702D6E2E';
wwv_flow_imp.g_varchar2_table(37778) := '793E3D732E626F74746F6D2C633D723F22746F70223A6C3F22626F74746F6D223A6E756C6C2C643D6F2E72696768742B6E2E783C3D732E6C6566743F226C656674223A613F227269676874223A6E756C6C3B72657475726E20642626633F632B222D222B';
wwv_flow_imp.g_varchar2_table(37779) := '643A647C7C637C7C22696E74657273656374227D66756E6374696F6E206A6E28652C742C6E297B766172206F3D66756E6374696F6E28652C74297B72657475726E20446E28652C74297D28652C74293B72657475726E20313D3D3D6F2E6C656E6774687C';
wwv_flow_imp.g_varchar2_table(37780) := '7C323D3D3D6F2E6C656E67746826265174286F5B305D2C6F5B315D293C313F426E286F5B305D293A6F2E6C656E6774683E313F286F3D28302C692E556C29286F2C2866756E6374696F6E2865297B76617220743D4D6174682E666C6F6F72283130302A65';
wwv_flow_imp.g_varchar2_table(37781) := '2E7432297C7C313B72657475726E20743D2828743D3130302D74293C31303F2230223A2222292B742C652E7365676D656E74322B2223222B747D29292C426E286F5B6E3F303A6F2E6C656E6774682D315D29293A6E756C6C7D66756E6374696F6E20716E';
wwv_flow_imp.g_varchar2_table(37782) := '28652C74297B72657475726E204D6174682E726F756E6428652A74292F747D66756E6374696F6E20246E2865297B72657475726E28302C692E4574292865293F652B227078223A657D66756E6374696F6E20556E28652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(37783) := '6B6528226722293B62652869292E6164642874293B636F6E7374206F3D766F69642030213D3D6E3F6E3A652E6368696C644E6F6465732E6C656E6774682D313B72657475726E20652E696E736572744265666F726528692C652E6368696C644E6F646573';
wwv_flow_imp.g_varchar2_table(37784) := '5B6F5D7C7C6E756C6C292C697D636F6E7374204B6E3D7B73686170653A5B2278222C2279222C227769647468222C22686569676874225D2C636F6E6E656374696F6E3A5B22776179706F696E7473225D7D3B66756E6374696F6E20476E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(37785) := '69297B746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769737472793D692C746869732E5F6772617068696373466163746F72793D6E2C746869732E5F726F6F74734964783D302C746869732E5F6C61796572733D7B7D';
wwv_flow_imp.g_varchar2_table(37786) := '2C746869732E5F706C616E65733D5B5D2C746869732E5F726F6F74456C656D656E743D6E756C6C2C746869732E5F696E697428657C7C7B7D297D66756E6374696F6E20516E28652C74297B636F6E7374206E3D226D617472697828222B742E612B222C22';
wwv_flow_imp.g_varchar2_table(37787) := '2B742E622B222C222B742E632B222C222B742E642B222C222B742E652B222C222B742E662B2229223B652E73657441747472696275746528227472616E73666F726D222C6E297D476E2E24696E6A6563743D5B22636F6E6669672E63616E766173222C22';
wwv_flow_imp.g_varchar2_table(37788) := '6576656E74427573222C226772617068696373466163746F7279222C22656C656D656E745265676973747279225D2C476E2E70726F746F747970652E5F696E69743D66756E6374696F6E2865297B636F6E737420743D746869732E5F6576656E74427573';
wwv_flow_imp.g_varchar2_table(37789) := '2C6E3D746869732E5F636F6E7461696E65723D66756E6374696F6E2865297B636F6E737420743D28653D28302C692E6B7029287B7D2C7B77696474683A2231303025222C6865696768743A2231303025227D2C6529292E636F6E7461696E65727C7C646F';
wwv_flow_imp.g_varchar2_table(37790) := '63756D656E742E626F64792C6E3D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E206E2E7365744174747269627574652822636C617373222C22646A732D636F6E7461696E657220646A732D706172656E7422';
wwv_flow_imp.g_varchar2_table(37791) := '292C4374286E2C7B706F736974696F6E3A2272656C6174697665222C6F766572666C6F773A2268696464656E222C77696474683A246E28652E7769647468292C6865696768743A246E28652E686569676874297D292C742E617070656E644368696C6428';
wwv_flow_imp.g_varchar2_table(37792) := '6E292C6E7D2865292C6F3D746869732E5F7376673D6B65282273766722293B6665286F2C7B77696474683A2231303025222C6865696768743A2231303025227D292C7565286E2C6F293B636F6E737420733D746869732E5F76696577706F72743D556E28';
wwv_flow_imp.g_varchar2_table(37793) := '6F2C2276696577706F727422293B652E6465666572557064617465262628746869732E5F76696577626F784368616E6765643D28302C692E7367292828302C692E6F492928746869732E5F76696577626F784368616E6765642C74686973292C33303029';
wwv_flow_imp.g_varchar2_table(37794) := '292C742E6F6E28226469616772616D2E696E6974222C2828293D3E7B742E66697265282263616E7661732E696E6974222C7B7376673A6F2C76696577706F72743A737D297D29292C742E6F6E285B2273686170652E6164646564222C22636F6E6E656374';
wwv_flow_imp.g_varchar2_table(37795) := '696F6E2E6164646564222C2273686170652E72656D6F766564222C22636F6E6E656374696F6E2E72656D6F766564222C22656C656D656E74732E6368616E676564222C22726F6F742E736574225D2C2828293D3E7B64656C65746520746869732E5F6361';
wwv_flow_imp.g_varchar2_table(37796) := '6368656456696577626F787D29292C742E6F6E28226469616772616D2E64657374726F79222C3530302C746869732E5F64657374726F792C74686973292C742E6F6E28226469616772616D2E636C656172222C3530302C746869732E5F636C6561722C74';
wwv_flow_imp.g_varchar2_table(37797) := '686973297D2C476E2E70726F746F747970652E5F64657374726F793D66756E6374696F6E28297B746869732E5F6576656E744275732E66697265282263616E7661732E64657374726F79222C7B7376673A746869732E5F7376672C76696577706F72743A';
wwv_flow_imp.g_varchar2_table(37798) := '746869732E5F76696577706F72747D293B636F6E737420653D746869732E5F636F6E7461696E65722E706172656E744E6F64653B652626652E72656D6F76654368696C6428746869732E5F636F6E7461696E6572292C64656C65746520746869732E5F73';
wwv_flow_imp.g_varchar2_table(37799) := '76672C64656C65746520746869732E5F636F6E7461696E65722C64656C65746520746869732E5F6C61796572732C64656C65746520746869732E5F706C616E65732C64656C65746520746869732E5F726F6F74456C656D656E742C64656C657465207468';
wwv_flow_imp.g_varchar2_table(37800) := '69732E5F76696577706F72747D2C476E2E70726F746F747970652E5F636C6561723D66756E6374696F6E28297B746869732E5F656C656D656E7452656769737472792E676574416C6C28292E666F72456163682828653D3E7B636F6E737420743D647428';
wwv_flow_imp.g_varchar2_table(37801) := '65293B22726F6F74223D3D3D743F746869732E72656D6F7665526F6F74456C656D656E742865293A746869732E5F72656D6F7665456C656D656E7428652C74297D29292C746869732E5F706C616E65733D5B5D2C746869732E5F726F6F74456C656D656E';
wwv_flow_imp.g_varchar2_table(37802) := '743D6E756C6C2C64656C65746520746869732E5F63616368656456696577626F787D2C476E2E70726F746F747970652E67657444656661756C744C617965723D66756E6374696F6E28297B72657475726E20746869732E6765744C617965722822626173';
wwv_flow_imp.g_varchar2_table(37803) := '65222C30297D2C476E2E70726F746F747970652E6765744C617965723D66756E6374696F6E28652C74297B6966282165297468726F77206E6577204572726F7228226D75737420737065636966792061206E616D6522293B6C6574206E3D746869732E5F';
wwv_flow_imp.g_varchar2_table(37804) := '6C61796572735B655D3B6966286E7C7C286E3D746869732E5F6C61796572735B655D3D746869732E5F6372656174654C6179657228652C7429292C766F69642030213D3D7426266E2E696E646578213D3D74297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(37805) := '6C61796572203C222B652B223E20616C7265616479206372656174656420617420696E646578203C222B742B223E22293B72657475726E206E2E67726F75707D2C476E2E70726F746F747970652E5F6765744368696C64496E6465783D66756E6374696F';
wwv_flow_imp.g_varchar2_table(37806) := '6E2865297B72657475726E28302C692E54532928746869732E5F6C61796572732C2866756E6374696F6E28742C6E297B72657475726E206E2E76697369626C652626653E3D6E2E696E6465782626742B2B2C747D292C30297D2C476E2E70726F746F7479';
wwv_flow_imp.g_varchar2_table(37807) := '70652E5F6372656174654C617965723D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D31293B636F6E7374206E3D746869732E5F6765744368696C64496E6465782874293B72657475726E7B67726F75703A556E28746869732E';
wwv_flow_imp.g_varchar2_table(37808) := '5F76696577706F72742C226C617965722D222B652C6E292C696E6465783A742C76697369626C653A21307D7D2C476E2E70726F746F747970652E73686F774C617965723D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(37809) := '7228226D75737420737065636966792061206E616D6522293B636F6E737420743D746869732E5F6C61796572735B655D3B6966282174297468726F77206E6577204572726F7228226C61796572203C222B652B223E20646F6573206E6F74206578697374';
wwv_flow_imp.g_varchar2_table(37810) := '22293B636F6E7374206E3D746869732E5F76696577706F72742C693D742E67726F75702C6F3D742E696E6465783B696628742E76697369626C652972657475726E20693B636F6E737420733D746869732E5F6765744368696C64496E646578286F293B72';
wwv_flow_imp.g_varchar2_table(37811) := '657475726E206E2E696E736572744265666F726528692C6E2E6368696C644E6F6465735B735D7C7C6E756C6C292C742E76697369626C653D21302C697D2C476E2E70726F746F747970652E686964654C617965723D66756E6374696F6E2865297B696628';
wwv_flow_imp.g_varchar2_table(37812) := '2165297468726F77206E6577204572726F7228226D75737420737065636966792061206E616D6522293B636F6E737420743D746869732E5F6C61796572735B655D3B6966282174297468726F77206E6577204572726F7228226C61796572203C222B652B';
wwv_flow_imp.g_varchar2_table(37813) := '223E20646F6573206E6F7420657869737422293B636F6E7374206E3D742E67726F75703B72657475726E20742E76697369626C653F285265286E292C742E76697369626C653D21312C6E293A6E7D2C476E2E70726F746F747970652E5F72656D6F76654C';
wwv_flow_imp.g_varchar2_table(37814) := '617965723D66756E6374696F6E2865297B636F6E737420743D746869732E5F6C61796572735B655D3B7426262864656C65746520746869732E5F6C61796572735B655D2C526528742E67726F757029297D2C476E2E70726F746F747970652E6765744163';
wwv_flow_imp.g_varchar2_table(37815) := '746976654C617965723D66756E6374696F6E28297B636F6E737420653D746869732E5F66696E64506C616E65466F72526F6F7428746869732E676574526F6F74456C656D656E742829293B72657475726E20653F652E6C617965723A6E756C6C7D2C476E';
wwv_flow_imp.g_varchar2_table(37816) := '2E70726F746F747970652E66696E64526F6F743D66756E6374696F6E2865297B69662822737472696E67223D3D747970656F662065262628653D746869732E5F656C656D656E7452656769737472792E676574286529292C21652972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(37817) := '6E737420743D746869732E5F66696E64506C616E65466F72526F6F742866756E6374696F6E2865297B666F72283B652E706172656E743B29653D652E706172656E743B72657475726E20657D286529297C7C7B7D3B72657475726E20742E726F6F74456C';
wwv_flow_imp.g_varchar2_table(37818) := '656D656E747D2C476E2E70726F746F747970652E676574526F6F74456C656D656E74733D66756E6374696F6E28297B72657475726E20746869732E5F706C616E65732E6D6170282866756E6374696F6E2865297B72657475726E20652E726F6F74456C65';
wwv_flow_imp.g_varchar2_table(37819) := '6D656E747D29297D2C476E2E70726F746F747970652E5F66696E64506C616E65466F72526F6F743D66756E6374696F6E2865297B72657475726E28302C692E49362928746869732E5F706C616E65732C2866756E6374696F6E2874297B72657475726E20';
wwv_flow_imp.g_varchar2_table(37820) := '742E726F6F74456C656D656E743D3D3D657D29297D2C476E2E70726F746F747970652E676574436F6E7461696E65723D66756E6374696F6E28297B72657475726E20746869732E5F636F6E7461696E65727D2C476E2E70726F746F747970652E5F757064';
wwv_flow_imp.g_varchar2_table(37821) := '6174654D61726B65723D66756E6374696F6E28652C742C6E297B6C6574206F3B652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C652E6D61726B6572733D652E6D61726B6572737C7C6E6577205365742C';
wwv_flow_imp.g_varchar2_table(37822) := '6F3D746869732E5F656C656D656E7452656769737472792E5F656C656D656E74735B652E69645D2C6F26262828302C692E6A4A29285B6F2E6766782C6F2E7365636F6E646172794766785D2C2866756E6374696F6E2869297B692626286E3F28652E6D61';
wwv_flow_imp.g_varchar2_table(37823) := '726B6572732E6164642874292C62652869292E616464287429293A28652E6D61726B6572732E64656C6574652874292C62652869292E72656D6F766528742929297D29292C746869732E5F6576656E744275732E666972652822656C656D656E742E6D61';
wwv_flow_imp.g_varchar2_table(37824) := '726B65722E757064617465222C7B656C656D656E743A652C6766783A6F2E6766782C6D61726B65723A742C6164643A21216E7D29297D2C476E2E70726F746F747970652E6164644D61726B65723D66756E6374696F6E28652C74297B746869732E5F7570';
wwv_flow_imp.g_varchar2_table(37825) := '646174654D61726B657228652C742C2130297D2C476E2E70726F746F747970652E72656D6F76654D61726B65723D66756E6374696F6E28652C74297B746869732E5F7570646174654D61726B657228652C742C2131297D2C476E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(37826) := '2E6861734D61726B65723D66756E6374696F6E28652C74297B72657475726E20652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C2121652E6D61726B6572732626652E6D61726B6572732E686173287429';
wwv_flow_imp.g_varchar2_table(37827) := '7D2C476E2E70726F746F747970652E746F67676C654D61726B65723D66756E6374696F6E28652C74297B746869732E6861734D61726B657228652C74293F746869732E72656D6F76654D61726B657228652C74293A746869732E6164644D61726B657228';
wwv_flow_imp.g_varchar2_table(37828) := '652C74297D2C476E2E70726F746F747970652E676574526F6F74456C656D656E743D66756E6374696F6E28297B636F6E737420653D746869732E5F726F6F74456C656D656E743B72657475726E20657C7C746869732E5F706C616E65732E6C656E677468';
wwv_flow_imp.g_varchar2_table(37829) := '3F653A746869732E736574526F6F74456C656D656E7428746869732E616464526F6F74456C656D656E74286E756C6C29297D2C476E2E70726F746F747970652E616464526F6F74456C656D656E743D66756E6374696F6E2865297B636F6E737420743D74';
wwv_flow_imp.g_varchar2_table(37830) := '6869732E5F726F6F74734964782B2B3B657C7C28653D7B69643A225F5F696D706C69636974726F6F745F222B742C6368696C6472656E3A5B5D2C6973496D706C696369743A21307D293B636F6E7374206E3D652E6C617965723D22726F6F742D222B743B';
wwv_flow_imp.g_varchar2_table(37831) := '746869732E5F656E7375726556616C69642822726F6F74222C65293B636F6E737420693D746869732E6765744C61796572286E2C30293B72657475726E20746869732E686964654C61796572286E292C746869732E5F616464526F6F7428652C69292C74';
wwv_flow_imp.g_varchar2_table(37832) := '6869732E5F706C616E65732E70757368287B726F6F74456C656D656E743A652C6C617965723A697D292C657D2C476E2E70726F746F747970652E72656D6F7665526F6F74456C656D656E743D66756E6374696F6E2865297B69662822737472696E67223D';
wwv_flow_imp.g_varchar2_table(37833) := '3D747970656F662065262628653D746869732E5F656C656D656E7452656769737472792E676574286529292C746869732E5F66696E64506C616E65466F72526F6F742865292972657475726E20746869732E5F72656D6F7665526F6F742865292C746869';
wwv_flow_imp.g_varchar2_table(37834) := '732E5F72656D6F76654C6179657228652E6C61796572292C746869732E5F706C616E65733D746869732E5F706C616E65732E66696C746572282866756E6374696F6E2874297B72657475726E20742E726F6F74456C656D656E74213D3D657D29292C7468';
wwv_flow_imp.g_varchar2_table(37835) := '69732E5F726F6F74456C656D656E743D3D3D65262628746869732E5F726F6F74456C656D656E743D6E756C6C292C657D2C476E2E70726F746F747970652E736574526F6F74456C656D656E743D66756E6374696F6E2865297B696628653D3D3D74686973';
wwv_flow_imp.g_varchar2_table(37836) := '2E5F726F6F74456C656D656E742972657475726E20653B6C657420743B6966282165297468726F77206E6577204572726F722822726F6F74456C656D656E7420726571756972656422293B72657475726E20743D746869732E5F66696E64506C616E6546';
wwv_flow_imp.g_varchar2_table(37837) := '6F72526F6F742865292C747C7C28653D746869732E616464526F6F74456C656D656E74286529292C746869732E5F736574526F6F742865292C657D2C476E2E70726F746F747970652E5F72656D6F7665526F6F743D66756E6374696F6E2865297B636F6E';
wwv_flow_imp.g_varchar2_table(37838) := '737420743D746869732E5F656C656D656E7452656769737472792C6E3D746869732E5F6576656E744275733B6E2E666972652822726F6F742E72656D6F7665222C7B656C656D656E743A657D292C6E2E666972652822726F6F742E72656D6F766564222C';
wwv_flow_imp.g_varchar2_table(37839) := '7B656C656D656E743A657D292C742E72656D6F76652865297D2C476E2E70726F746F747970652E5F616464526F6F743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F656C656D656E7452656769737472792C693D746869732E5F';
wwv_flow_imp.g_varchar2_table(37840) := '6576656E744275733B692E666972652822726F6F742E616464222C7B656C656D656E743A657D292C6E2E61646428652C74292C692E666972652822726F6F742E6164646564222C7B656C656D656E743A652C6766783A747D297D2C476E2E70726F746F74';
wwv_flow_imp.g_varchar2_table(37841) := '7970652E5F736574526F6F743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F726F6F74456C656D656E743B6E262628746869732E5F656C656D656E7452656769737472792E7570646174654772617068696373286E2C6E756C6C';
wwv_flow_imp.g_varchar2_table(37842) := '2C2130292C746869732E686964654C61796572286E2E6C6179657229292C65262628747C7C28743D746869732E5F66696E64506C616E65466F72526F6F742865292E6C61796572292C746869732E5F656C656D656E7452656769737472792E7570646174';
wwv_flow_imp.g_varchar2_table(37843) := '65477261706869637328652C746869732E5F7376672C2130292C746869732E73686F774C6179657228652E6C6179657229292C746869732E5F726F6F74456C656D656E743D652C746869732E5F6576656E744275732E666972652822726F6F742E736574';
wwv_flow_imp.g_varchar2_table(37844) := '222C7B656C656D656E743A657D297D2C476E2E70726F746F747970652E5F656E7375726556616C69643D66756E6374696F6E28652C74297B69662821742E6964297468726F77206E6577204572726F722822656C656D656E74206D757374206861766520';
wwv_flow_imp.g_varchar2_table(37845) := '616E20696422293B696628746869732E5F656C656D656E7452656769737472792E67657428742E696429297468726F77206E6577204572726F722822656C656D656E74203C222B742E69642B223E20616C72656164792065786973747322293B636F6E73';
wwv_flow_imp.g_varchar2_table(37846) := '74206E3D4B6E5B655D3B6966282128302C692E536929286E2C2866756E6374696F6E2865297B72657475726E20766F69642030213D3D745B655D7D2929297468726F77206E6577204572726F7228226D75737420737570706C79207B20222B6E2E6A6F69';
wwv_flow_imp.g_varchar2_table(37847) := '6E28222C2022292B22207D207769746820222B65297D2C476E2E70726F746F747970652E5F736574506172656E743D66756E6374696F6E28652C742C6E297B4B7428742E6368696C6472656E2C652C6E292C652E706172656E743D747D2C476E2E70726F';
wwv_flow_imp.g_varchar2_table(37848) := '746F747970652E5F616464456C656D656E743D66756E6374696F6E28652C742C6E2C69297B6E3D6E7C7C746869732E676574526F6F74456C656D656E7428293B636F6E7374206F3D746869732E5F6576656E744275732C733D746869732E5F6772617068';
wwv_flow_imp.g_varchar2_table(37849) := '696373466163746F72793B746869732E5F656E7375726556616C696428652C74292C6F2E6669726528652B222E616464222C7B656C656D656E743A742C706172656E743A6E7D292C746869732E5F736574506172656E7428742C6E2C69293B636F6E7374';
wwv_flow_imp.g_varchar2_table(37850) := '20723D732E63726561746528652C742C69293B72657475726E20746869732E5F656C656D656E7452656769737472792E61646428742C72292C732E75706461746528652C742C72292C6F2E6669726528652B222E6164646564222C7B656C656D656E743A';
wwv_flow_imp.g_varchar2_table(37851) := '742C6766783A727D292C747D2C476E2E70726F746F747970652E61646453686170653D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F616464456C656D656E7428227368617065222C652C742C6E297D2C476E2E70726F746F74';
wwv_flow_imp.g_varchar2_table(37852) := '7970652E616464436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F616464456C656D656E742822636F6E6E656374696F6E222C652C742C6E297D2C476E2E70726F746F747970652E5F72656D6F766545';
wwv_flow_imp.g_varchar2_table(37853) := '6C656D656E743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F656C656D656E7452656769737472792C693D746869732E5F6772617068696373466163746F72792C6F3D746869732E5F6576656E744275733B696628653D6E2E67';
wwv_flow_imp.g_varchar2_table(37854) := '657428652E69647C7C65292972657475726E206F2E6669726528742B222E72656D6F7665222C7B656C656D656E743A657D292C692E72656D6F76652865292C557428652E706172656E742626652E706172656E742E6368696C6472656E2C65292C652E70';
wwv_flow_imp.g_varchar2_table(37855) := '6172656E743D6E756C6C2C6F2E6669726528742B222E72656D6F766564222C7B656C656D656E743A657D292C6E2E72656D6F76652865292C657D2C476E2E70726F746F747970652E72656D6F766553686170653D66756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(37856) := '726E20746869732E5F72656D6F7665456C656D656E7428652C22736861706522297D2C476E2E70726F746F747970652E72656D6F7665436F6E6E656374696F6E3D66756E6374696F6E2865297B72657475726E20746869732E5F72656D6F7665456C656D';
wwv_flow_imp.g_varchar2_table(37857) := '656E7428652C22636F6E6E656374696F6E22297D2C476E2E70726F746F747970652E67657447726170686963733D66756E6374696F6E28652C74297B72657475726E20746869732E5F656C656D656E7452656769737472792E6765744772617068696373';
wwv_flow_imp.g_varchar2_table(37858) := '28652C74297D2C476E2E70726F746F747970652E5F6368616E676556696577626F783D66756E6374696F6E2865297B746869732E5F6576656E744275732E66697265282263616E7661732E76696577626F782E6368616E67696E6722292C652E6170706C';
wwv_flow_imp.g_varchar2_table(37859) := '792874686973292C746869732E5F63616368656456696577626F783D6E756C6C2C746869732E5F76696577626F784368616E67656428297D2C476E2E70726F746F747970652E5F76696577626F784368616E6765643D66756E6374696F6E28297B746869';
wwv_flow_imp.g_varchar2_table(37860) := '732E5F6576656E744275732E66697265282263616E7661732E76696577626F782E6368616E676564222C7B76696577626F783A746869732E76696577626F7828297D297D2C476E2E70726F746F747970652E76696577626F783D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(37861) := '297B696628766F696420303D3D3D652626746869732E5F63616368656456696577626F782972657475726E20746869732E5F63616368656456696577626F783B636F6E737420743D746869732E5F76696577706F72742C6E3D746869732E67657453697A';
wwv_flow_imp.g_varchar2_table(37862) := '6528293B6C657420692C6F2C732C722C612C6C2C633B72657475726E20653F28746869732E5F6368616E676556696577626F78282866756E6374696F6E28297B613D4D6174682E6D696E286E2E77696474682F652E77696474682C6E2E6865696768742F';
wwv_flow_imp.g_varchar2_table(37863) := '652E686569676874293B636F6E737420693D746869732E5F7376672E6372656174655356474D617472697828292E7363616C652861292E7472616E736C617465282D652E782C2D652E79293B426528742C69297D29292C65293A28733D746869732E5F72';
wwv_flow_imp.g_varchar2_table(37864) := '6F6F74456C656D656E743F746869732E6765744163746976654C6179657228293A6E756C6C2C693D732626732E67657442426F7828297C7C7B7D2C723D42652874292C6F3D723F722E6D61747269783A66756E6374696F6E28652C742C6E2C692C6F2C73';
wwv_flow_imp.g_varchar2_table(37865) := '297B76617220723D4C6528292E6372656174655356474D617472697828293B73776974636828617267756D656E74732E6C656E677468297B6361736520303A72657475726E20723B6361736520313A72657475726E20446528722C65293B636173652036';
wwv_flow_imp.g_varchar2_table(37866) := '3A72657475726E20446528722C7B613A652C623A742C633A6E2C643A692C653A6F2C663A737D297D7D28292C613D716E286F2E612C316533292C6C3D716E282D6F2E657C7C302C316533292C633D716E282D6F2E667C7C302C316533292C653D74686973';
wwv_flow_imp.g_varchar2_table(37867) := '2E5F63616368656456696577626F783D7B783A6C3F6C2F613A302C793A633F632F613A302C77696474683A6E2E77696474682F612C6865696768743A6E2E6865696768742F612C7363616C653A612C696E6E65723A7B77696474683A692E77696474687C';
wwv_flow_imp.g_varchar2_table(37868) := '7C302C6865696768743A692E6865696768747C7C302C783A692E787C7C302C793A692E797C7C307D2C6F757465723A6E7D297D2C476E2E70726F746F747970652E7363726F6C6C3D66756E6374696F6E2865297B636F6E737420743D746869732E5F7669';
wwv_flow_imp.g_varchar2_table(37869) := '6577706F72743B6C6574206E3D742E67657443544D28293B72657475726E20652626746869732E5F6368616E676556696577626F78282866756E6374696F6E28297B653D28302C692E6B7029287B64783A302C64793A307D2C657C7C7B7D292C6E3D7468';
wwv_flow_imp.g_varchar2_table(37870) := '69732E5F7376672E6372656174655356474D617472697828292E7472616E736C61746528652E64782C652E6479292E6D756C7469706C79286E292C516E28742C6E297D29292C7B783A6E2E652C793A6E2E667D7D2C476E2E70726F746F747970652E7363';
wwv_flow_imp.g_varchar2_table(37871) := '726F6C6C546F456C656D656E743D66756E6374696F6E28652C74297B6C6574206E3D3130303B22737472696E67223D3D747970656F662065262628653D746869732E5F656C656D656E7452656769737472792E676574286529293B636F6E737420693D74';
wwv_flow_imp.g_varchar2_table(37872) := '6869732E66696E64526F6F742865293B69662869213D3D746869732E676574526F6F74456C656D656E7428292626746869732E736574526F6F74456C656D656E742869292C693D3D3D652972657475726E3B747C7C28743D7B7D292C226E756D62657222';
wwv_flow_imp.g_varchar2_table(37873) := '3D3D747970656F6620742626286E3D74292C743D7B746F703A742E746F707C7C6E2C72696768743A742E72696768747C7C6E2C626F74746F6D3A742E626F74746F6D7C7C6E2C6C6566743A742E6C6566747C7C6E7D3B636F6E7374206F3D63742865292C';
wwv_flow_imp.g_varchar2_table(37874) := '733D566E286F292C723D746869732E76696577626F7828292C613D746869732E7A6F6F6D28293B6C6574206C2C633B722E792B3D742E746F702F612C722E782B3D742E6C6566742F612C722E77696474682D3D28742E72696768742B742E6C656674292F';
wwv_flow_imp.g_varchar2_table(37875) := '612C722E6865696768742D3D28742E626F74746F6D2B742E746F70292F613B636F6E737420643D566E2872293B6966286F2E77696474683C722E776964746826266F2E6865696768743C722E686569676874297B636F6E737420653D4D6174682E6D6178';
wwv_flow_imp.g_varchar2_table(37876) := '28302C732E72696768742D642E7269676874292C743D4D6174682E6D696E28302C732E6C6566742D642E6C656674292C6E3D4D6174682E6D617828302C732E626F74746F6D2D642E626F74746F6D292C693D4D6174682E6D696E28302C732E746F702D64';
wwv_flow_imp.g_varchar2_table(37877) := '2E746F70293B6C3D657C7C742C633D6E7C7C697D656C7365206C3D6F2E782D722E782C633D6F2E792D722E793B746869732E7363726F6C6C287B64783A2D6C2A612C64793A2D632A617D297D2C476E2E70726F746F747970652E7A6F6F6D3D66756E6374';
wwv_flow_imp.g_varchar2_table(37878) := '696F6E28652C74297B69662821652972657475726E20746869732E76696577626F782865292E7363616C653B696628226669742D76696577706F7274223D3D3D652972657475726E20746869732E5F66697456696577706F72742874293B6C6574206E2C';
wwv_flow_imp.g_varchar2_table(37879) := '693B72657475726E20746869732E5F6368616E676556696577626F78282866756E6374696F6E28297B226F626A65637422213D747970656F6620742626286E3D746869732E76696577626F7828292E6F757465722C743D7B783A6E2E77696474682F322C';
wwv_flow_imp.g_varchar2_table(37880) := '793A6E2E6865696768742F327D292C693D746869732E5F7365745A6F6F6D28652C74297D29292C716E28692E612C316533297D2C476E2E70726F746F747970652E5F66697456696577706F72743D66756E6374696F6E2865297B636F6E737420743D7468';
wwv_flow_imp.g_varchar2_table(37881) := '69732E76696577626F7828292C6E3D742E6F757465722C693D742E696E6E65723B6C6574206F2C733B72657475726E20692E783E3D302626692E793E3D302626692E782B692E77696474683C3D6E2E77696474682626692E792B692E6865696768743C3D';
wwv_flow_imp.g_varchar2_table(37882) := '6E2E686569676874262621653F733D7B783A302C793A302C77696474683A4D6174682E6D617828692E77696474682B692E782C6E2E7769647468292C6865696768743A4D6174682E6D617828692E6865696768742B692E792C6E2E686569676874297D3A';
wwv_flow_imp.g_varchar2_table(37883) := '286F3D4D6174682E6D696E28312C6E2E77696474682F692E77696474682C6E2E6865696768742F692E686569676874292C733D7B783A692E782B28653F692E77696474682F322D6E2E77696474682F6F2F323A30292C793A692E792B28653F692E686569';
wwv_flow_imp.g_varchar2_table(37884) := '6768742F322D6E2E6865696768742F6F2F323A30292C77696474683A6E2E77696474682F6F2C6865696768743A6E2E6865696768742F6F7D292C746869732E76696577626F782873292C746869732E76696577626F78282131292E7363616C657D2C476E';
wwv_flow_imp.g_varchar2_table(37885) := '2E70726F746F747970652E5F7365745A6F6F6D3D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F7376672C6F3D746869732E5F76696577706F72742C733D6E2E6372656174655356474D617472697828292C723D6E2E6372656174';
wwv_flow_imp.g_varchar2_table(37886) := '65535647506F696E7428293B6C657420612C6C2C632C642C683B633D6F2E67657443544D28293B636F6E737420753D632E613B72657475726E20743F28613D28302C692E6B702928722C74292C6C3D612E6D61747269785472616E73666F726D28632E69';
wwv_flow_imp.g_varchar2_table(37887) := '6E76657273652829292C643D732E7472616E736C617465286C2E782C6C2E79292E7363616C6528312F752A65292E7472616E736C617465282D6C2E782C2D6C2E79292C683D632E6D756C7469706C79286429293A683D732E7363616C652865292C516E28';
wwv_flow_imp.g_varchar2_table(37888) := '746869732E5F76696577706F72742C68292C687D2C476E2E70726F746F747970652E67657453697A653D66756E6374696F6E28297B72657475726E7B77696474683A746869732E5F636F6E7461696E65722E636C69656E7457696474682C686569676874';
wwv_flow_imp.g_varchar2_table(37889) := '3A746869732E5F636F6E7461696E65722E636C69656E744865696768747D7D2C476E2E70726F746F747970652E6765744162736F6C75746542426F783D66756E6374696F6E2865297B636F6E737420743D746869732E76696577626F7828293B6C657420';
wwv_flow_imp.g_varchar2_table(37890) := '6E3B72657475726E206E3D652E776179706F696E74733F746869732E67657447726170686963732865292E67657442426F7828293A652C7B783A6E2E782A742E7363616C652D742E782A742E7363616C652C793A6E2E792A742E7363616C652D742E792A';
wwv_flow_imp.g_varchar2_table(37891) := '742E7363616C652C77696474683A6E2E77696474682A742E7363616C652C6865696768743A6E2E6865696768742A742E7363616C657D7D2C476E2E70726F746F747970652E726573697A65643D66756E6374696F6E28297B64656C65746520746869732E';
wwv_flow_imp.g_varchar2_table(37892) := '5F63616368656456696577626F782C746869732E5F6576656E744275732E66697265282263616E7661732E726573697A656422297D3B76617220596E3D22646174612D656C656D656E742D6964223B66756E6374696F6E205A6E2865297B746869732E5F';
wwv_flow_imp.g_varchar2_table(37893) := '656C656D656E74733D7B7D2C746869732E5F6576656E744275733D657D66756E6374696F6E20586E28652C742C6E297B76617220693D66756E6374696F6E28652C742C6E2C69297B766172206F3D6E2E696E76657273653B72657475726E204F626A6563';
wwv_flow_imp.g_varchar2_table(37894) := '742E646566696E6550726F706572747928652C2272656D6F7665222C7B76616C75653A66756E6374696F6E2865297B766172206E3D746869732E696E6465784F662865293B72657475726E2D31213D3D6E262628746869732E73706C696365286E2C3129';
wwv_flow_imp.g_varchar2_table(37895) := '2C742E756E73657428652C6F2C6929292C657D7D292C4F626A6563742E646566696E6550726F706572747928652C22636F6E7461696E73222C7B76616C75653A66756E6374696F6E2865297B72657475726E2D31213D3D746869732E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(37896) := '65297D7D292C4F626A6563742E646566696E6550726F706572747928652C22616464222C7B76616C75653A66756E6374696F6E28652C6E297B76617220733D746869732E696E6465784F662865293B696628766F696420303D3D3D6E297B6966282D3121';
wwv_flow_imp.g_varchar2_table(37897) := '3D3D732972657475726E3B6E3D746869732E6C656E6774687D2D31213D3D732626746869732E73706C69636528732C31292C746869732E73706C696365286E2C302C65292C2D313D3D3D732626742E73657428652C6F2C69297D7D292C4F626A6563742E';
wwv_flow_imp.g_varchar2_table(37898) := '646566696E6550726F706572747928652C225F5F726566735F636F6C6C656374696F6E222C7B76616C75653A21307D292C657D286E5B742E6E616D655D7C7C5B5D2C652C742C6E293B4F626A6563742E646566696E6550726F7065727479286E2C742E6E';
wwv_flow_imp.g_varchar2_table(37899) := '616D652C7B656E756D657261626C653A742E656E756D657261626C652C76616C75653A697D292C692E6C656E6774682626692E666F7245616368282866756E6374696F6E2869297B652E73657428692C742E696E76657273652C6E297D29297D66756E63';
wwv_flow_imp.g_varchar2_table(37900) := '74696F6E204A6E28652C74297B69662821287468697320696E7374616E63656F66204A6E292972657475726E206E6577204A6E28652C74293B652E696E76657273653D742C742E696E76657273653D652C746869732E70726F70733D7B7D2C746869732E';
wwv_flow_imp.g_varchar2_table(37901) := '70726F70735B652E6E616D655D3D652C746869732E70726F70735B742E6E616D655D3D747D5A6E2E24696E6A6563743D5B226576656E74427573225D2C5A6E2E70726F746F747970652E6164643D66756E6374696F6E28652C742C6E297B76617220693D';
wwv_flow_imp.g_varchar2_table(37902) := '652E69643B746869732E5F76616C696461746549642869292C666528742C596E2C69292C6E26266665286E2C596E2C69292C746869732E5F656C656D656E74735B695D3D7B656C656D656E743A652C6766783A742C7365636F6E646172794766783A6E7D';
wwv_flow_imp.g_varchar2_table(37903) := '7D2C5A6E2E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869732E5F656C656D656E74732C6E3D652E69647C7C652C693D6E2626745B6E5D3B69262628666528692E6766782C596E2C2222292C692E736563';
wwv_flow_imp.g_varchar2_table(37904) := '6F6E646172794766782626666528692E7365636F6E646172794766782C596E2C2222292C64656C65746520745B6E5D297D2C5A6E2E70726F746F747970652E75706461746549643D66756E6374696F6E28652C74297B746869732E5F76616C6964617465';
wwv_flow_imp.g_varchar2_table(37905) := '49642874292C22737472696E67223D3D747970656F662065262628653D746869732E676574286529292C746869732E5F6576656E744275732E666972652822656C656D656E742E7570646174654964222C7B656C656D656E743A652C6E657749643A747D';
wwv_flow_imp.g_varchar2_table(37906) := '293B766172206E3D746869732E67657447726170686963732865292C693D746869732E676574477261706869637328652C2130293B746869732E72656D6F76652865292C652E69643D742C746869732E61646428652C6E2C69297D2C5A6E2E70726F746F';
wwv_flow_imp.g_varchar2_table(37907) := '747970652E75706461746547726170686963733D66756E6374696F6E28652C742C6E297B76617220693D652E69647C7C652C6F3D746869732E5F656C656D656E74735B695D3B72657475726E206E3F6F2E7365636F6E646172794766783D743A6F2E6766';
wwv_flow_imp.g_varchar2_table(37908) := '783D742C742626666528742C596E2C69292C747D2C5A6E2E70726F746F747970652E6765743D66756E6374696F6E2865297B76617220743B743D22737472696E67223D3D747970656F6620653F653A652626666528652C596E293B766172206E3D746869';
wwv_flow_imp.g_varchar2_table(37909) := '732E5F656C656D656E74735B745D3B72657475726E206E26266E2E656C656D656E747D2C5A6E2E70726F746F747970652E66696C7465723D66756E6374696F6E2865297B76617220743D5B5D3B72657475726E20746869732E666F724561636828286675';
wwv_flow_imp.g_varchar2_table(37910) := '6E6374696F6E286E2C69297B65286E2C69292626742E70757368286E297D29292C747D2C5A6E2E70726F746F747970652E66696E643D66756E6374696F6E2865297B666F722876617220743D746869732E5F656C656D656E74732C6E3D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(37911) := '6B6579732874292C693D303B693C6E2E6C656E6774683B692B2B297B766172206F3D745B6E5B695D5D2C733D6F2E656C656D656E743B6966286528732C6F2E676678292972657475726E20737D7D2C5A6E2E70726F746F747970652E676574416C6C3D66';
wwv_flow_imp.g_varchar2_table(37912) := '756E6374696F6E28297B72657475726E20746869732E66696C746572282866756E6374696F6E2865297B72657475726E20657D29297D2C5A6E2E70726F746F747970652E666F72456163683D66756E6374696F6E2865297B76617220743D746869732E5F';
wwv_flow_imp.g_varchar2_table(37913) := '656C656D656E74733B4F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B76617220693D745B6E5D2C6F3D692E656C656D656E742C733D692E6766783B72657475726E2065286F2C73297D29297D2C5A6E2E70726F';
wwv_flow_imp.g_varchar2_table(37914) := '746F747970652E67657447726170686963733D66756E6374696F6E28652C74297B766172206E3D652E69647C7C652C693D746869732E5F656C656D656E74735B6E5D3B72657475726E2069262628743F692E7365636F6E646172794766783A692E676678';
wwv_flow_imp.g_varchar2_table(37915) := '297D2C5A6E2E70726F746F747970652E5F76616C696461746549643D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F722822656C656D656E74206D757374206861766520616E20696422293B696628746869732E5F656C';
wwv_flow_imp.g_varchar2_table(37916) := '656D656E74735B655D297468726F77206E6577204572726F722822656C656D656E74207769746820696420222B652B2220616C726561647920616464656422297D2C4A6E2E70726F746F747970652E62696E643D66756E6374696F6E28652C74297B6966';
wwv_flow_imp.g_varchar2_table(37917) := '2822737472696E67223D3D747970656F662074297B69662821746869732E70726F70735B745D297468726F77206E6577204572726F7228226E6F2070726F7065727479203C222B742B223E20696E2072656622293B743D746869732E70726F70735B745D';
wwv_flow_imp.g_varchar2_table(37918) := '7D742E636F6C6C656374696F6E3F586E28746869732C742C65293A66756E6374696F6E28652C742C6E297B76617220693D742E696E76657273652C6F3D6E5B742E6E616D655D3B4F626A6563742E646566696E6550726F7065727479286E2C742E6E616D';
wwv_flow_imp.g_varchar2_table(37919) := '652C7B636F6E666967757261626C653A742E636F6E666967757261626C652C656E756D657261626C653A742E656E756D657261626C652C6765743A66756E6374696F6E28297B72657475726E206F7D2C7365743A66756E6374696F6E2874297B69662874';
wwv_flow_imp.g_varchar2_table(37920) := '213D3D6F297B76617220733D6F3B6F3D6E756C6C2C732626652E756E73657428732C692C6E292C6F3D742C652E736574286F2C692C6E297D7D7D297D28746869732C742C65297D2C4A6E2E70726F746F747970652E656E7375726552656673436F6C6C65';
wwv_flow_imp.g_varchar2_table(37921) := '6374696F6E3D66756E6374696F6E28652C74297B766172206E3D655B742E6E616D655D3B72657475726E2066756E6374696F6E2865297B72657475726E21303D3D3D652E5F5F726566735F636F6C6C656374696F6E7D286E297C7C586E28746869732C74';
wwv_flow_imp.g_varchar2_table(37922) := '2C65292C6E7D2C4A6E2E70726F746F747970652E656E73757265426F756E643D66756E6374696F6E28652C74297B2866756E6374696F6E28652C74297B72657475726E204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E';
wwv_flow_imp.g_varchar2_table(37923) := '63616C6C28652C742E6E616D657C7C74297D2928652C74297C7C746869732E62696E6428652C74297D2C4A6E2E70726F746F747970652E756E7365743D66756E6374696F6E28652C742C6E297B65262628746869732E656E73757265426F756E6428652C';
wwv_flow_imp.g_varchar2_table(37924) := '74292C742E636F6C6C656374696F6E3F746869732E656E7375726552656673436F6C6C656374696F6E28652C74292E72656D6F7665286E293A655B742E6E616D655D3D766F69642030297D2C4A6E2E70726F746F747970652E7365743D66756E6374696F';
wwv_flow_imp.g_varchar2_table(37925) := '6E28652C742C6E297B65262628746869732E656E73757265426F756E6428652C74292C742E636F6C6C656374696F6E3F746869732E656E7375726552656673436F6C6C656374696F6E28652C74292E616464286E293A655B742E6E616D655D3D6E297D3B';
wwv_flow_imp.g_varchar2_table(37926) := '7661722065693D6E6577204A6E287B6E616D653A226368696C6472656E222C656E756D657261626C653A21302C636F6C6C656374696F6E3A21307D2C7B6E616D653A22706172656E74227D292C74693D6E6577204A6E287B6E616D653A226C6162656C73';
wwv_flow_imp.g_varchar2_table(37927) := '222C656E756D657261626C653A21302C636F6C6C656374696F6E3A21307D2C7B6E616D653A226C6162656C546172676574227D292C6E693D6E6577204A6E287B6E616D653A22617474616368657273222C636F6C6C656374696F6E3A21307D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(37928) := '653A22686F7374227D292C69693D6E6577204A6E287B6E616D653A226F7574676F696E67222C636F6C6C656374696F6E3A21307D2C7B6E616D653A22736F75726365227D292C6F693D6E6577204A6E287B6E616D653A22696E636F6D696E67222C636F6C';
wwv_flow_imp.g_varchar2_table(37929) := '6C656374696F6E3A21307D2C7B6E616D653A22746172676574227D293B66756E6374696F6E20736928297B4F626A6563742E646566696E6550726F706572747928746869732C22627573696E6573734F626A656374222C7B7772697461626C653A21307D';
wwv_flow_imp.g_varchar2_table(37930) := '292C4F626A6563742E646566696E6550726F706572747928746869732C226C6162656C222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E6C6162656C735B305D7D2C7365743A66756E6374696F6E2865297B76617220743D7468';
wwv_flow_imp.g_varchar2_table(37931) := '69732E6C6162656C2C6E3D746869732E6C6162656C733B21652626743F6E2E72656D6F76652874293A6E2E61646428652C30297D7D292C65692E62696E6428746869732C22706172656E7422292C74692E62696E6428746869732C226C6162656C732229';
wwv_flow_imp.g_varchar2_table(37932) := '2C69692E62696E6428746869732C226F7574676F696E6722292C6F692E62696E6428746869732C22696E636F6D696E6722297D66756E6374696F6E20726928297B73692E63616C6C2874686973292C65692E62696E6428746869732C226368696C647265';
wwv_flow_imp.g_varchar2_table(37933) := '6E22292C6E692E62696E6428746869732C22686F737422292C6E692E62696E6428746869732C2261747461636865727322297D66756E6374696F6E20616928297B73692E63616C6C2874686973292C65692E62696E6428746869732C226368696C647265';
wwv_flow_imp.g_varchar2_table(37934) := '6E22297D66756E6374696F6E206C6928297B72692E63616C6C2874686973292C74692E62696E6428746869732C226C6162656C54617267657422297D66756E6374696F6E20636928297B73692E63616C6C2874686973292C69692E62696E642874686973';
wwv_flow_imp.g_varchar2_table(37935) := '2C22736F7572636522292C6F692E62696E6428746869732C2274617267657422297D522872692C7369292C522861692C7269292C52286C692C7269292C522863692C7369293B7661722064693D7B636F6E6E656374696F6E3A63692C73686170653A7269';
wwv_flow_imp.g_varchar2_table(37936) := '2C6C6162656C3A6C692C726F6F743A61697D3B66756E6374696F6E20686928297B746869732E5F7569643D31327D68692E70726F746F747970652E637265617465526F6F743D66756E6374696F6E2865297B72657475726E20746869732E637265617465';
wwv_flow_imp.g_varchar2_table(37937) := '2822726F6F74222C65297D2C68692E70726F746F747970652E6372656174654C6162656C3D66756E6374696F6E2865297B72657475726E20746869732E63726561746528226C6162656C222C65297D2C68692E70726F746F747970652E63726561746553';
wwv_flow_imp.g_varchar2_table(37938) := '686170653D66756E6374696F6E2865297B72657475726E20746869732E63726561746528227368617065222C65297D2C68692E70726F746F747970652E637265617465436F6E6E656374696F6E3D66756E6374696F6E2865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(37939) := '732E6372656174652822636F6E6E656374696F6E222C65297D2C68692E70726F746F747970652E6372656174653D66756E6374696F6E28652C74297B72657475726E28743D28302C692E6B7029287B7D2C747C7C7B7D29292E69647C7C28742E69643D65';
wwv_flow_imp.g_varchar2_table(37940) := '2B225F222B746869732E5F7569642B2B292C66756E6374696F6E28652C74297B766172206E3D64695B655D3B696628216E297468726F77206E6577204572726F722822756E6B6E6F776E20747970653A203C222B652B223E22293B72657475726E28302C';
wwv_flow_imp.g_varchar2_table(37941) := '692E6B7029286E6577206E2C74297D28652C74297D3B7661722075693D225F5F666E222C70693D41727261792E70726F746F747970652E736C6963653B66756E6374696F6E20676928297B746869732E5F6C697374656E6572733D7B7D2C746869732E6F';
wwv_flow_imp.g_varchar2_table(37942) := '6E28226469616772616D2E64657374726F79222C312C746869732E5F64657374726F792C74686973297D66756E6374696F6E206D6928297B7D66756E6374696F6E2066692865297B72657475726E20652E6368696C644E6F6465735B305D7D66756E6374';
wwv_flow_imp.g_varchar2_table(37943) := '696F6E20766928652C742C6E2C692C6F297B76617220733D546528293B732E7365745472616E736C61746528742C6E293B76617220723D546528293B722E736574526F7461746528697C7C302C302C30293B76617220613D546528293B612E7365745363';
wwv_flow_imp.g_varchar2_table(37944) := '616C65286F7C7C312C6F7C7C31292C426528652C5B732C722C615D297D66756E6374696F6E20626928652C742C6E297B76617220693D546528293B692E7365745472616E736C61746528742C6E292C426528652C69297D66756E6374696F6E205F692865';
wwv_flow_imp.g_varchar2_table(37945) := '2C74297B766172206E3D546528293B6E2E736574526F7461746528742C302C30292C426528652C6E297D66756E6374696F6E20796928652C74297B746869732E5F6576656E744275733D652C746869732E5F656C656D656E7452656769737472793D747D';
wwv_flow_imp.g_varchar2_table(37946) := '66756E6374696F6E20776928652C742C6E297B76617220693D6E7C7C742E66697273744368696C643B65213D3D692626742E696E736572744265666F726528652C69297D67692E70726F746F747970652E6F6E3D66756E6374696F6E28652C742C6E2C6F';
wwv_flow_imp.g_varchar2_table(37947) := '297B696628653D28302C692E6379292865293F653A5B655D2C28302C692E546E292874292626286F3D6E2C6E3D742C743D316533292C2128302C692E457429287429297468726F77206E6577204572726F7228227072696F72697479206D757374206265';
wwv_flow_imp.g_varchar2_table(37948) := '2061206E756D62657222293B76617220733D6E3B6F26262828733D28302C692E6F4929286E2C6F29295B75695D3D6E5B75695D7C7C6E293B76617220723D746869733B652E666F7245616368282866756E6374696F6E2865297B722E5F6164644C697374';
wwv_flow_imp.g_varchar2_table(37949) := '656E657228652C7B7072696F726974793A742C63616C6C6261636B3A732C6E6578743A6E756C6C7D297D29297D2C67692E70726F746F747970652E6F6E63653D66756E6374696F6E28652C742C6E2C6F297B76617220733D746869733B69662828302C69';
wwv_flow_imp.g_varchar2_table(37950) := '2E546E292874292626286F3D6E2C6E3D742C743D316533292C2128302C692E457429287429297468726F77206E6577204572726F7228227072696F72697479206D7573742062652061206E756D62657222293B66756E6374696F6E207228297B722E5F5F';
wwv_flow_imp.g_varchar2_table(37951) := '6973546F6D623D21303B76617220743D6E2E6170706C79286F2C617267756D656E7473293B72657475726E20732E6F666628652C72292C747D725B75695D3D6E2C746869732E6F6E28652C742C72297D2C67692E70726F746F747970652E6F66663D6675';
wwv_flow_imp.g_varchar2_table(37952) := '6E6374696F6E28652C74297B653D28302C692E6379292865293F653A5B655D3B766172206E3D746869733B652E666F7245616368282866756E6374696F6E2865297B6E2E5F72656D6F76654C697374656E657228652C74297D29297D2C67692E70726F74';
wwv_flow_imp.g_varchar2_table(37953) := '6F747970652E6372656174654576656E743D66756E6374696F6E2865297B76617220743D6E6577206D693B72657475726E20742E696E69742865292C747D2C67692E70726F746F747970652E666972653D66756E6374696F6E28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(37954) := '2C692C6F2C733B696628733D70692E63616C6C28617267756D656E7473292C226F626A656374223D3D747970656F662065262628653D28743D65292E74797065292C2165297468726F77206E6577204572726F7228226E6F206576656E74207479706520';
wwv_flow_imp.g_varchar2_table(37955) := '73706563696669656422293B696628693D746869732E5F6C697374656E6572735B655D297B6E3D7420696E7374616E63656F66206D693F743A746869732E6372656174654576656E742874292C735B305D3D6E3B76617220723D6E2E747970653B65213D';
wwv_flow_imp.g_varchar2_table(37956) := '3D722626286E2E747970653D65293B7472797B6F3D746869732E5F696E766F6B654C697374656E657273286E2C732C69297D66696E616C6C797B65213D3D722626286E2E747970653D72297D72657475726E20766F696420303D3D3D6F26266E2E646566';
wwv_flow_imp.g_varchar2_table(37957) := '61756C7450726576656E7465642626286F3D2131292C6F7D7D2C67692E70726F746F747970652E68616E646C654572726F723D66756E6374696F6E2865297B72657475726E21313D3D3D746869732E6669726528226572726F72222C7B6572726F723A65';
wwv_flow_imp.g_varchar2_table(37958) := '7D297D2C67692E70726F746F747970652E5F64657374726F793D66756E6374696F6E28297B746869732E5F6C697374656E6572733D7B7D7D2C67692E70726F746F747970652E5F696E766F6B654C697374656E6572733D66756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(37959) := '6E297B666F722876617220693B6E262621652E63616E63656C427562626C653B29693D746869732E5F696E766F6B654C697374656E657228652C742C6E292C6E3D6E2E6E6578743B72657475726E20697D2C67692E70726F746F747970652E5F696E766F';
wwv_flow_imp.g_varchar2_table(37960) := '6B654C697374656E65723D66756E6374696F6E28652C742C6E297B76617220693B6966286E2E63616C6C6261636B2E5F5F6973546F6D622972657475726E20693B7472797B693D66756E6374696F6E28652C74297B72657475726E20652E6170706C7928';
wwv_flow_imp.g_varchar2_table(37961) := '6E756C6C2C74297D286E2E63616C6C6261636B2C74292C766F69642030213D3D69262628652E72657475726E56616C75653D692C652E73746F7050726F7061676174696F6E2829292C21313D3D3D692626652E70726576656E7444656661756C7428297D';
wwv_flow_imp.g_varchar2_table(37962) := '63617463682865297B69662821746869732E68616E646C654572726F72286529297468726F7720636F6E736F6C652E6572726F722822756E68616E646C6564206572726F7220696E206576656E74206C697374656E6572222C65292C657D72657475726E';
wwv_flow_imp.g_varchar2_table(37963) := '20697D2C67692E70726F746F747970652E5F6164644C697374656E65723D66756E6374696F6E28652C74297B766172206E2C693D746869732E5F6765744C697374656E6572732865293B69662869297B666F72283B693B297B696628692E7072696F7269';
wwv_flow_imp.g_varchar2_table(37964) := '74793C742E7072696F726974792972657475726E20742E6E6578743D692C766F6964286E3F6E2E6E6578743D743A746869732E5F7365744C697374656E65727328652C7429293B6E3D692C693D692E6E6578747D6E2E6E6578743D747D656C7365207468';
wwv_flow_imp.g_varchar2_table(37965) := '69732E5F7365744C697374656E65727328652C74297D2C67692E70726F746F747970652E5F6765744C697374656E6572733D66756E6374696F6E2865297B72657475726E20746869732E5F6C697374656E6572735B655D7D2C67692E70726F746F747970';
wwv_flow_imp.g_varchar2_table(37966) := '652E5F7365744C697374656E6572733D66756E6374696F6E28652C74297B746869732E5F6C697374656E6572735B655D3D747D2C67692E70726F746F747970652E5F72656D6F76654C697374656E65723D66756E6374696F6E28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(37967) := '2C692C6F2C733D746869732E5F6765744C697374656E6572732865293B6966287429666F72283B733B296E3D732E6E6578742C286F3D732E63616C6C6261636B29213D3D7426266F5B75695D213D3D747C7C28693F692E6E6578743D6E3A746869732E5F';
wwv_flow_imp.g_varchar2_table(37968) := '7365744C697374656E65727328652C6E29292C693D732C733D6E3B656C736520746869732E5F7365744C697374656E65727328652C6E756C6C297D2C6D692E70726F746F747970652E73746F7050726F7061676174696F6E3D66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(37969) := '746869732E63616E63656C427562626C653D21307D2C6D692E70726F746F747970652E70726576656E7444656661756C743D66756E6374696F6E28297B746869732E64656661756C7450726576656E7465643D21307D2C6D692E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(37970) := '696E69743D66756E6374696F6E2865297B28302C692E6B702928746869732C657C7C7B7D297D2C79692E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279225D2C79692E70726F746F747970652E5F6765744368';
wwv_flow_imp.g_varchar2_table(37971) := '696C6472656E436F6E7461696E65723D66756E6374696F6E2865297B76617220742C6E3D746869732E5F656C656D656E7452656769737472792E67657447726170686963732865293B72657475726E20652E706172656E743F28743D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(37972) := '2865297B72657475726E20652E706172656E744E6F64652E6368696C644E6F6465735B315D7D286E292C747C7C28626528743D6B652822672229292E6164642822646A732D6368696C6472656E22292C7565286E2E706172656E744E6F64652C74292929';
wwv_flow_imp.g_varchar2_table(37973) := '3A743D6E2C747D2C79692E70726F746F747970652E5F636C6561723D66756E6374696F6E2865297B76617220743D66692865293B72657475726E204C742874292C747D2C79692E70726F746F747970652E5F637265617465436F6E7461696E65723D6675';
wwv_flow_imp.g_varchar2_table(37974) := '6E6374696F6E28652C742C6E2C69297B766172206F3D6B6528226722293B6265286F292E6164642822646A732D67726F757022292C766F69642030213D3D6E3F7769286F2C742C742E6368696C644E6F6465735B6E5D293A756528742C6F293B76617220';
wwv_flow_imp.g_varchar2_table(37975) := '733D6B6528226722293B62652873292E6164642822646A732D656C656D656E7422292C62652873292E6164642822646A732D222B65292C69262662652873292E6164642822646A732D6672616D6522292C7565286F2C73293B76617220723D6B65282267';
wwv_flow_imp.g_varchar2_table(37976) := '22293B72657475726E2062652872292E6164642822646A732D76697375616C22292C756528732C72292C737D2C79692E70726F746F747970652E6372656174653D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F6765744368696C';
wwv_flow_imp.g_varchar2_table(37977) := '6472656E436F6E7461696E657228742E706172656E74293B72657475726E20746869732E5F637265617465436F6E7461696E657228652C692C6E2C6874287429297D2C79692E70726F746F747970652E757064617465436F6E7461696E6D656E74733D66';
wwv_flow_imp.g_varchar2_table(37978) := '756E6374696F6E2865297B76617220742C6E3D746869732C6F3D746869732E5F656C656D656E7452656769737472793B743D28302C692E54532928652C2866756E6374696F6E28652C74297B72657475726E20742E706172656E74262628655B742E7061';
wwv_flow_imp.g_varchar2_table(37979) := '72656E742E69645D3D742E706172656E74292C657D292C7B7D292C28302C692E6A4A2928742C2866756E6374696F6E2865297B76617220743D652E6368696C6472656E3B69662874297B76617220733D6E2E5F6765744368696C6472656E436F6E746169';
wwv_flow_imp.g_varchar2_table(37980) := '6E65722865293B28302C692E6A4A2928742E736C69636528292E7265766572736528292C2866756E6374696F6E2865297B7769286F2E67657447726170686963732865292E706172656E744E6F64652C73297D29297D7D29297D2C79692E70726F746F74';
wwv_flow_imp.g_varchar2_table(37981) := '7970652E6472617753686170653D66756E6374696F6E28652C742C6E3D7B7D297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E7368617065222C7B6766783A652C656C656D656E743A742C61747472733A6E7D';
wwv_flow_imp.g_varchar2_table(37982) := '297D2C79692E70726F746F747970652E6765745368617065506174683D66756E6374696F6E2865297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E676574536861706550617468222C65297D2C79692E70726F';
wwv_flow_imp.g_varchar2_table(37983) := '746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E3D7B7D297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E636F6E6E656374696F6E222C7B6766783A652C656C656D65';
wwv_flow_imp.g_varchar2_table(37984) := '6E743A742C61747472733A6E7D297D2C79692E70726F746F747970652E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E676574436F6E';
wwv_flow_imp.g_varchar2_table(37985) := '6E656374696F6E50617468222C65297D2C79692E70726F746F747970652E7570646174653D66756E6374696F6E28652C742C6E297B696628742E706172656E74297B76617220693D746869732E5F636C656172286E293B696628227368617065223D3D3D';
wwv_flow_imp.g_varchar2_table(37986) := '6529746869732E64726177536861706528692C74292C6269286E2C742E782C742E79293B656C73657B69662822636F6E6E656374696F6E22213D3D65297468726F77206E6577204572726F722822756E6B6E6F776E20747970653A20222B65293B746869';
wwv_flow_imp.g_varchar2_table(37987) := '732E64726177436F6E6E656374696F6E28692C74297D742E68696464656E3F6665286E2C22646973706C6179222C226E6F6E6522293A6665286E2C22646973706C6179222C22626C6F636B22297D7D2C79692E70726F746F747970652E72656D6F76653D';
wwv_flow_imp.g_varchar2_table(37988) := '66756E6374696F6E2865297B526528746869732E5F656C656D656E7452656769737472792E67657447726170686963732865292E706172656E744E6F6465297D3B636F6E73742043693D7B5F5F646570656E64735F5F3A5B67745D2C5F5F696E69745F5F';
wwv_flow_imp.g_varchar2_table(37989) := '3A5B2263616E766173225D2C63616E7661733A5B2274797065222C476E5D2C656C656D656E7452656769737472793A5B2274797065222C5A6E5D2C656C656D656E74466163746F72793A5B2274797065222C68695D2C6576656E744275733A5B22747970';
wwv_flow_imp.g_varchar2_table(37990) := '65222C67695D2C6772617068696373466163746F72793A5B2274797065222C79695D7D3B66756E6374696F6E20536928652C74297B746869732E5F696E6A6563746F723D747C7C66756E6374696F6E2865297B72657475726E20743D5B7B636F6E666967';
wwv_flow_imp.g_varchar2_table(37991) := '3A5B2276616C7565222C653D657C7C7B7D5D7D2C43695D2E636F6E63617428652E6D6F64756C65737C7C5B5D292C286E3D6E6577204B65287429292E696E697428292C6E3B76617220742C6E7D2865292C746869732E67657428226576656E7442757322';
wwv_flow_imp.g_varchar2_table(37992) := '292E6669726528226469616772616D2E696E697422297D66756E6374696F6E20786928297B7D66756E6374696F6E206B6928652C74297B746869732E6D6F64656C3D652C746869732E70726F706572746965733D747D53692E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(37993) := '65743D66756E6374696F6E28652C74297B72657475726E20746869732E5F696E6A6563746F722E67657428652C74297D2C53692E70726F746F747970652E696E766F6B653D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F696E';
wwv_flow_imp.g_varchar2_table(37994) := '6A6563746F722E696E766F6B6528652C742C6E297D2C53692E70726F746F747970652E64657374726F793D66756E6374696F6E28297B746869732E67657428226576656E7442757322292E6669726528226469616772616D2E64657374726F7922297D2C';
wwv_flow_imp.g_varchar2_table(37995) := '53692E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E67657428226576656E7442757322292E6669726528226469616772616D2E636C65617222297D2C78692E70726F746F747970652E6765743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(37996) := '65297B72657475726E20746869732E246D6F64656C2E70726F706572746965732E67657428746869732C65297D2C78692E70726F746F747970652E7365743D66756E6374696F6E28652C74297B746869732E246D6F64656C2E70726F706572746965732E';
wwv_flow_imp.g_varchar2_table(37997) := '73657428746869732C652C74297D2C6B692E70726F746F747970652E637265617465547970653D66756E6374696F6E2865297B76617220743D746869732E6D6F64656C2C6E3D746869732E70726F706572746965732C6F3D4F626A6563742E6372656174';
wwv_flow_imp.g_varchar2_table(37998) := '652878692E70726F746F74797065293B28302C692E6A4A2928652E70726F706572746965732C2866756E6374696F6E2865297B652E69734D616E797C7C766F696420303D3D3D652E64656661756C747C7C286F5B652E6E616D655D3D652E64656661756C';
wwv_flow_imp.g_varchar2_table(37999) := '74297D29292C6E2E646566696E654D6F64656C286F2C74292C6E2E646566696E6544657363726970746F72286F2C65293B76617220733D652E6E732E6E616D653B66756E6374696F6E20722865297B6E2E646566696E6528746869732C22247479706522';
wwv_flow_imp.g_varchar2_table(38000) := '2C7B76616C75653A732C656E756D657261626C653A21307D292C6E2E646566696E6528746869732C22246174747273222C7B76616C75653A7B7D7D292C6E2E646566696E6528746869732C2224706172656E74222C7B7772697461626C653A21307D292C';
wwv_flow_imp.g_varchar2_table(38001) := '28302C692E6A4A2928652C28302C692E6F4929282866756E6374696F6E28652C74297B746869732E73657428742C65297D292C7468697329297D72657475726E20722E70726F746F747970653D6F2C722E686173547970653D6F2E24696E7374616E6365';
wwv_flow_imp.g_varchar2_table(38002) := '4F663D746869732E6D6F64656C2E686173547970652C6E2E646566696E654D6F64656C28722C74292C6E2E646566696E6544657363726970746F7228722C65292C727D3B7661722045693D7B537472696E673A21302C426F6F6C65616E3A21302C496E74';
wwv_flow_imp.g_varchar2_table(38003) := '656765723A21302C5265616C3A21302C456C656D656E743A21307D2C4C693D7B537472696E673A66756E6374696F6E2865297B72657475726E20657D2C426F6F6C65616E3A66756E6374696F6E2865297B72657475726E2274727565223D3D3D657D2C49';
wwv_flow_imp.g_varchar2_table(38004) := '6E74656765723A66756E6374696F6E2865297B72657475726E207061727365496E7428652C3130297D2C5265616C3A66756E6374696F6E2865297B72657475726E207061727365466C6F61742865297D7D3B66756E6374696F6E20446928652C74297B76';
wwv_flow_imp.g_varchar2_table(38005) := '6172206E3D4C695B655D3B72657475726E206E3F6E2874293A747D66756E6374696F6E2054692865297B72657475726E212145695B655D7D66756E6374696F6E2049692865297B72657475726E21214C695B655D7D66756E6374696F6E204D6928652C74';
wwv_flow_imp.g_varchar2_table(38006) := '297B766172206E2C692C6F3D652E73706C6974282F3A2F293B696628313D3D3D6F2E6C656E677468296E3D652C693D743B656C73657B69662832213D3D6F2E6C656E677468297468726F77206E6577204572726F7228226578706563746564203C707265';
wwv_flow_imp.g_varchar2_table(38007) := '6669783A6C6F63616C4E616D653E206F72203C6C6F63616C4E616D653E2C20676F7420222B65293B6E3D6F5B315D2C693D6F5B305D7D72657475726E7B6E616D653A653D28693F692B223A223A2222292B6E2C7072656669783A692C6C6F63616C4E616D';
wwv_flow_imp.g_varchar2_table(38008) := '653A6E7D7D66756E6374696F6E2041692865297B746869732E6E733D652C746869732E6E616D653D652E6E616D652C746869732E616C6C54797065733D5B5D2C746869732E616C6C547970657342794E616D653D7B7D2C746869732E70726F7065727469';
wwv_flow_imp.g_varchar2_table(38009) := '65733D5B5D2C746869732E70726F7065727469657342794E616D653D7B7D7D66756E6374696F6E204E6928652C74297B746869732E7061636B6167654D61703D7B7D2C746869732E747970654D61703D7B7D2C746869732E7061636B616765733D5B5D2C';
wwv_flow_imp.g_varchar2_table(38010) := '746869732E70726F706572746965733D742C28302C692E6A4A2928652C28302C692E6F492928746869732E72656769737465725061636B6167652C7468697329297D66756E6374696F6E20506928652C742C6E297B76617220693D745B6E5D3B69662869';
wwv_flow_imp.g_varchar2_table(38011) := '20696E2065297468726F77206E6577204572726F7228227061636B616765207769746820222B6E2B22203C222B692B223E20616C726561647920646566696E656422297D66756E6374696F6E204F692865297B746869732E6D6F64656C3D657D66756E63';
wwv_flow_imp.g_varchar2_table(38012) := '74696F6E20526928652C742C6E297B4F626A6563742E646566696E6550726F706572747928652C742E6E616D652C7B656E756D657261626C653A21742E69735265666572656E63652C7772697461626C653A21302C76616C75653A6E2C636F6E66696775';
wwv_flow_imp.g_varchar2_table(38013) := '7261626C653A21307D297D66756E6374696F6E2046692865297B72657475726E20652E7265706C616365282F5E3A2F2C2222297D66756E6374696F6E20426928652C743D7B7D297B746869732E70726F706572746965733D6E6577204F69287468697329';
wwv_flow_imp.g_varchar2_table(38014) := '2C746869732E666163746F72793D6E6577206B6928746869732C746869732E70726F70657274696573292C746869732E72656769737472793D6E6577204E6928652C746869732E70726F70657274696573292C746869732E7479706543616368653D7B7D';
wwv_flow_imp.g_varchar2_table(38015) := '2C746869732E636F6E6669673D747D41692E70726F746F747970652E6275696C643D66756E6374696F6E28297B72657475726E28302C692E55702928746869732C5B226E73222C226E616D65222C22616C6C5479706573222C22616C6C54797065734279';
wwv_flow_imp.g_varchar2_table(38016) := '4E616D65222C2270726F70657274696573222C2270726F7065727469657342794E616D65222C22626F647950726F7065727479222C22696450726F7065727479225D297D2C41692E70726F746F747970652E61646450726F70657274793D66756E637469';
wwv_flow_imp.g_varchar2_table(38017) := '6F6E28652C742C6E297B22626F6F6C65616E223D3D747970656F6620742626286E3D742C743D766F69642030292C746869732E6164644E616D656450726F706572747928652C2131213D3D6E293B76617220693D746869732E70726F706572746965733B';
wwv_flow_imp.g_varchar2_table(38018) := '766F69642030213D3D743F692E73706C69636528742C302C65293A692E707573682865297D2C41692E70726F746F747970652E7265706C61636550726F70657274793D66756E6374696F6E28652C742C6E297B76617220693D652E6E732C6F3D74686973';
wwv_flow_imp.g_varchar2_table(38019) := '2E70726F706572746965732C733D746869732E70726F7065727469657342794E616D652C723D652E6E616D65213D3D742E6E616D653B696628652E69734964297B69662821742E69734964297468726F77206E6577204572726F72282270726F70657274';
wwv_flow_imp.g_varchar2_table(38020) := '79203C222B742E6E732E6E616D652B223E206D7573742062652069642070726F706572747920746F20726566696E65203C222B652E6E732E6E616D652B223E22293B746869732E736574496450726F706572747928742C2131297D696628652E6973426F';
wwv_flow_imp.g_varchar2_table(38021) := '6479297B69662821742E6973426F6479297468726F77206E6577204572726F72282270726F7065727479203C222B742E6E732E6E616D652B223E206D75737420626520626F64792070726F706572747920746F20726566696E65203C222B652E6E732E6E';
wwv_flow_imp.g_varchar2_table(38022) := '616D652B223E22293B746869732E736574426F647950726F706572747928742C2131297D76617220613D6F2E696E6465784F662865293B6966282D313D3D3D61297468726F77206E6577204572726F72282270726F7065727479203C222B692E6E616D65';
wwv_flow_imp.g_varchar2_table(38023) := '2B223E206E6F7420666F756E6420696E2070726F7065727479206C69737422293B6F2E73706C69636528612C31292C746869732E61646450726F706572747928742C6E3F766F696420303A612C72292C735B692E6E616D655D3D735B692E6C6F63616C4E';
wwv_flow_imp.g_varchar2_table(38024) := '616D655D3D747D2C41692E70726F746F747970652E7265646566696E6550726F70657274793D66756E6374696F6E28652C742C6E297B76617220693D652E6E732E7072656669782C6F3D742E73706C697428222322292C733D4D69286F5B305D2C69292C';
wwv_flow_imp.g_varchar2_table(38025) := '723D4D69286F5B315D2C732E707265666978292E6E616D652C613D746869732E70726F7065727469657342794E616D655B725D3B6966282161297468726F77206E6577204572726F722822726566696E65642070726F7065727479203C222B722B223E20';
wwv_flow_imp.g_varchar2_table(38026) := '6E6F7420666F756E6422293B746869732E7265706C61636550726F706572747928612C652C6E292C64656C65746520652E7265646566696E65737D2C41692E70726F746F747970652E6164644E616D656450726F70657274793D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(38027) := '2C74297B766172206E3D652E6E732C693D746869732E70726F7065727469657342794E616D653B74262628746869732E6173736572744E6F74446566696E656428652C6E2E6E616D65292C746869732E6173736572744E6F74446566696E656428652C6E';
wwv_flow_imp.g_varchar2_table(38028) := '2E6C6F63616C4E616D6529292C695B6E2E6E616D655D3D695B6E2E6C6F63616C4E616D655D3D657D2C41692E70726F746F747970652E72656D6F76654E616D656450726F70657274793D66756E6374696F6E2865297B76617220743D652E6E732C6E3D74';
wwv_flow_imp.g_varchar2_table(38029) := '6869732E70726F7065727469657342794E616D653B64656C657465206E5B742E6E616D655D2C64656C657465206E5B742E6C6F63616C4E616D655D7D2C41692E70726F746F747970652E736574426F647950726F70657274793D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(38030) := '2C74297B696628742626746869732E626F647950726F7065727479297468726F77206E6577204572726F722822626F64792070726F706572747920646566696E6564206D756C7469706C652074696D657320283C222B746869732E626F647950726F7065';
wwv_flow_imp.g_varchar2_table(38031) := '7274792E6E732E6E616D652B223E2C203C222B652E6E732E6E616D652B223E2922293B746869732E626F647950726F70657274793D657D2C41692E70726F746F747970652E736574496450726F70657274793D66756E6374696F6E28652C74297B696628';
wwv_flow_imp.g_varchar2_table(38032) := '742626746869732E696450726F7065727479297468726F77206E6577204572726F72282269642070726F706572747920646566696E6564206D756C7469706C652074696D657320283C222B746869732E696450726F70657274792E6E732E6E616D652B22';
wwv_flow_imp.g_varchar2_table(38033) := '3E2C203C222B652E6E732E6E616D652B223E2922293B746869732E696450726F70657274793D657D2C41692E70726F746F747970652E6173736572744E6F7454726169743D66756E6374696F6E2865297B69662828652E657874656E64737C7C5B5D292E';
wwv_flow_imp.g_varchar2_table(38034) := '6C656E677468297468726F77206E6577204572726F72286063616E6E6F7420637265617465203C247B652E6E616D657D3E20657874656E64696E67203C247B652E657874656E64737D3E60297D2C41692E70726F746F747970652E6173736572744E6F74';
wwv_flow_imp.g_varchar2_table(38035) := '446566696E65643D66756E6374696F6E28652C74297B766172206E3D652E6E616D652C693D746869732E70726F7065727469657342794E616D655B6E5D3B69662869297468726F77206E6577204572726F72282270726F7065727479203C222B6E2B223E';
wwv_flow_imp.g_varchar2_table(38036) := '20616C726561647920646566696E65643B206F76657272696465206F66203C222B692E646566696E656442792E6E732E6E616D652B2223222B692E6E732E6E616D652B223E206279203C222B652E646566696E656442792E6E732E6E616D652B2223222B';
wwv_flow_imp.g_varchar2_table(38037) := '652E6E732E6E616D652B223E206E6F7420616C6C6F77656420776974686F7574207265646566696E657322297D2C41692E70726F746F747970652E68617350726F70657274793D66756E6374696F6E2865297B72657475726E20746869732E70726F7065';
wwv_flow_imp.g_varchar2_table(38038) := '727469657342794E616D655B655D7D2C41692E70726F746F747970652E61646454726169743D66756E6374696F6E28652C74297B742626746869732E6173736572744E6F7454726169742865293B766172206E3D746869732E616C6C547970657342794E';
wwv_flow_imp.g_varchar2_table(38039) := '616D652C6F3D746869732E616C6C54797065732C733D652E6E616D653B7320696E206E7C7C2828302C692E6A4A2928652E70726F706572746965732C28302C692E6F4929282866756E6374696F6E286E297B6E3D28302C692E6B7029287B7D2C6E2C7B6E';
wwv_flow_imp.g_varchar2_table(38040) := '616D653A6E2E6E732E6C6F63616C4E616D652C696E686572697465643A747D292C4F626A6563742E646566696E6550726F7065727479286E2C22646566696E65644279222C7B76616C75653A657D293B766172206F3D6E2E7265706C616365732C733D6E';
wwv_flow_imp.g_varchar2_table(38041) := '2E7265646566696E65733B6F7C7C733F746869732E7265646566696E6550726F7065727479286E2C6F7C7C732C6F293A286E2E6973426F64792626746869732E736574426F647950726F7065727479286E292C6E2E697349642626746869732E73657449';
wwv_flow_imp.g_varchar2_table(38042) := '6450726F7065727479286E292C746869732E61646450726F7065727479286E29297D292C7468697329292C6F2E707573682865292C6E5B735D3D65297D2C4E692E70726F746F747970652E6765745061636B6167653D66756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(38043) := '7475726E20746869732E7061636B6167654D61705B655D7D2C4E692E70726F746F747970652E6765745061636B616765733D66756E6374696F6E28297B72657475726E20746869732E7061636B616765737D2C4E692E70726F746F747970652E72656769';
wwv_flow_imp.g_varchar2_table(38044) := '737465725061636B6167653D66756E6374696F6E2865297B653D28302C692E6B7029287B7D2C65293B76617220743D746869732E7061636B6167654D61703B506928742C652C2270726566697822292C506928742C652C2275726922292C28302C692E6A';
wwv_flow_imp.g_varchar2_table(38045) := '4A2928652E74797065732C28302C692E6F4929282866756E6374696F6E2874297B746869732E72656769737465725479706528742C65297D292C7468697329292C745B652E7572695D3D745B652E7072656669785D3D652C746869732E7061636B616765';
wwv_flow_imp.g_varchar2_table(38046) := '732E707573682865297D2C4E692E70726F746F747970652E7265676973746572547970653D66756E6374696F6E28652C74297B766172206E3D4D692828653D28302C692E6B7029287B7D2C652C7B7375706572436C6173733A28652E7375706572436C61';
wwv_flow_imp.g_varchar2_table(38047) := '73737C7C5B5D292E736C69636528292C657874656E64733A28652E657874656E64737C7C5B5D292E736C69636528292C70726F706572746965733A28652E70726F706572746965737C7C5B5D292E736C69636528292C6D6574613A28302C692E6B702928';
wwv_flow_imp.g_varchar2_table(38048) := '652E6D6574617C7C7B7D297D29292E6E616D652C742E707265666978292C6F3D6E2E6E616D652C733D7B7D3B28302C692E6A4A2928652E70726F706572746965732C28302C692E6F4929282866756E6374696F6E2865297B76617220743D4D6928652E6E';
wwv_flow_imp.g_varchar2_table(38049) := '616D652C6E2E707265666978292C6F3D742E6E616D653B546928652E74797065297C7C28652E747970653D4D6928652E747970652C742E707265666978292E6E616D65292C28302C692E6B702928652C7B6E733A742C6E616D653A6F7D292C735B6F5D3D';
wwv_flow_imp.g_varchar2_table(38050) := '657D292C7468697329292C28302C692E6B702928652C7B6E733A6E2C6E616D653A6F2C70726F7065727469657342794E616D653A737D292C28302C692E6A4A2928652E657874656E64732C28302C692E6F4929282866756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(38051) := '20743D4D6928652C6E2E707265666978292C693D746869732E747970654D61705B742E6E616D655D3B692E7472616974733D692E7472616974737C7C5B5D2C692E7472616974732E70757368286F297D292C7468697329292C746869732E646566696E65';
wwv_flow_imp.g_varchar2_table(38052) := '5061636B61676528652C74292C746869732E747970654D61705B6F5D3D657D2C4E692E70726F746F747970652E6D617054797065733D66756E6374696F6E28652C742C6E297B766172206F3D546928652E6E616D65293F7B6E616D653A652E6E616D657D';
wwv_flow_imp.g_varchar2_table(38053) := '3A746869732E747970654D61705B652E6E616D655D2C733D746869733B66756E6374696F6E2072286E2C69297B766172206F3D4D69286E2C5469286E293F22223A652E707265666978293B732E6D61705479706573286F2C742C69297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(38054) := '6E20612865297B72657475726E207228652C2130297D696628216F297468726F77206E6577204572726F722822756E6B6E6F776E2074797065203C222B652E6E616D652B223E22293B28302C692E6A4A29286F2E7375706572436C6173732C6E3F613A66';
wwv_flow_imp.g_varchar2_table(38055) := '756E6374696F6E2865297B72657475726E207228652C2131297D292C74286F2C216E292C28302C692E6A4A29286F2E7472616974732C61297D2C4E692E70726F746F747970652E67657445666665637469766544657363726970746F723D66756E637469';
wwv_flow_imp.g_varchar2_table(38056) := '6F6E2865297B76617220743D4D692865292C6E3D6E65772041692874293B746869732E6D6170547970657328742C2866756E6374696F6E28652C74297B6E2E616464547261697428652C74297D29293B76617220693D6E2E6275696C6428293B72657475';
wwv_flow_imp.g_varchar2_table(38057) := '726E20746869732E646566696E655061636B61676528692C692E616C6C54797065735B692E616C6C54797065732E6C656E6774682D315D2E24706B67292C697D2C4E692E70726F746F747970652E646566696E655061636B6167653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38058) := '28652C74297B746869732E70726F706572746965732E646566696E6528652C2224706B67222C7B76616C75653A747D297D2C4F692E70726F746F747970652E7365743D66756E6374696F6E28652C742C6E297B6966282128302C692E4B67292874297C7C';
wwv_flow_imp.g_varchar2_table(38059) := '21742E6C656E677468297468726F77206E657720547970654572726F72282270726F7065727479206E616D65206D7573742062652061206E6F6E2D656D70747920737472696E6722293B766172206F3D746869732E67657450726F706572747928652C74';
wwv_flow_imp.g_varchar2_table(38060) := '292C733D6F26266F2E6E616D653B766F696420303D3D3D6E3F6F3F64656C65746520655B735D3A64656C65746520652E2461747472735B46692874295D3A6F3F7320696E20653F655B735D3D6E3A526928652C6F2C6E293A652E2461747472735B466928';
wwv_flow_imp.g_varchar2_table(38061) := '74295D3D6E7D2C4F692E70726F746F747970652E6765743D66756E6374696F6E28652C74297B766172206E3D746869732E67657450726F706572747928652C74293B696628216E2972657475726E20652E2461747472735B46692874295D3B7661722069';
wwv_flow_imp.g_varchar2_table(38062) := '3D6E2E6E616D653B72657475726E21655B695D26266E2E69734D616E792626526928652C6E2C5B5D292C655B695D7D2C4F692E70726F746F747970652E646566696E653D66756E6374696F6E28652C742C6E297B696628216E2E7772697461626C65297B';
wwv_flow_imp.g_varchar2_table(38063) := '766172206F3D6E2E76616C75653B64656C657465286E3D28302C692E6B7029287B7D2C6E2C7B6765743A66756E6374696F6E28297B72657475726E206F7D7D29292E76616C75657D4F626A6563742E646566696E6550726F706572747928652C742C6E29';
wwv_flow_imp.g_varchar2_table(38064) := '7D2C4F692E70726F746F747970652E646566696E6544657363726970746F723D66756E6374696F6E28652C74297B746869732E646566696E6528652C222464657363726970746F72222C7B76616C75653A747D297D2C4F692E70726F746F747970652E64';
wwv_flow_imp.g_varchar2_table(38065) := '6566696E654D6F64656C3D66756E6374696F6E28652C74297B746869732E646566696E6528652C22246D6F64656C222C7B76616C75653A747D297D2C4F692E70726F746F747970652E67657450726F70657274793D66756E6374696F6E28652C74297B76';
wwv_flow_imp.g_varchar2_table(38066) := '6172206E3D746869732E6D6F64656C2C693D6E2E67657450726F706572747944657363726970746F7228652C74293B696628692972657475726E20693B696628742E696E636C7564657328223A22292972657475726E206E756C6C3B636F6E7374206F3D';
wwv_flow_imp.g_varchar2_table(38067) := '6E2E636F6E6669672E7374726963743B696628766F69642030213D3D6F297B636F6E7374206E3D6E657720547970654572726F722860756E6B6E6F776E2070726F7065727479203C247B747D3E206F6E203C247B652E24747970657D3E60293B6966286F';
wwv_flow_imp.g_varchar2_table(38068) := '297468726F77206E3B22756E646566696E656422213D747970656F6620636F6E736F6C652626636F6E736F6C652E7761726E286E297D72657475726E206E756C6C7D2C42692E70726F746F747970652E6372656174653D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(38069) := '7B766172206E3D746869732E676574547970652865293B696628216E297468726F77206E6577204572726F722822756E6B6E6F776E2074797065203C222B652B223E22293B72657475726E206E6577206E2874297D2C42692E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(38070) := '6574547970653D66756E6374696F6E2865297B76617220743D746869732E7479706543616368652C6E3D28302C692E4B67292865293F653A652E6E732E6E616D652C6F3D745B6E5D3B72657475726E206F7C7C28653D746869732E72656769737472792E';
wwv_flow_imp.g_varchar2_table(38071) := '67657445666665637469766544657363726970746F72286E292C6F3D745B6E5D3D746869732E666163746F72792E63726561746554797065286529292C6F7D2C42692E70726F746F747970652E637265617465416E793D66756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(38072) := '6E297B766172206F3D4D692865292C733D7B24747970653A652C24696E7374616E63654F663A66756E6374696F6E2865297B72657475726E20653D3D3D746869732E24747970657D2C6765743A66756E6374696F6E2865297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(38073) := '5B655D7D2C7365743A66756E6374696F6E28652C74297B28302C692E685A2928746869732C5B655D2C74297D7D2C723D7B6E616D653A652C697347656E657269633A21302C6E733A7B7072656669783A6F2E7072656669782C6C6F63616C4E616D653A6F';
wwv_flow_imp.g_varchar2_table(38074) := '2E6C6F63616C4E616D652C7572693A747D7D3B72657475726E20746869732E70726F706572746965732E646566696E6544657363726970746F7228732C72292C746869732E70726F706572746965732E646566696E654D6F64656C28732C74686973292C';
wwv_flow_imp.g_varchar2_table(38075) := '746869732E70726F706572746965732E646566696E6528732C22676574222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E6528732C22736574222C7B656E756D65726162';
wwv_flow_imp.g_varchar2_table(38076) := '6C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E6528732C2224706172656E74222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E';
wwv_flow_imp.g_varchar2_table(38077) := '646566696E6528732C2224696E7374616E63654F66222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C28302C692E6A4A29286E2C2866756E6374696F6E28652C74297B28302C692E4776292865292626766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(38078) := '652E76616C75653F735B652E6E616D655D3D652E76616C75653A735B745D3D657D29292C737D2C42692E70726F746F747970652E6765745061636B6167653D66756E6374696F6E2865297B72657475726E20746869732E72656769737472792E67657450';
wwv_flow_imp.g_varchar2_table(38079) := '61636B6167652865297D2C42692E70726F746F747970652E6765745061636B616765733D66756E6374696F6E28297B72657475726E20746869732E72656769737472792E6765745061636B6167657328297D2C42692E70726F746F747970652E67657445';
wwv_flow_imp.g_varchar2_table(38080) := '6C656D656E7444657363726970746F723D66756E6374696F6E2865297B72657475726E20652E2464657363726970746F727D2C42692E70726F746F747970652E686173547970653D66756E6374696F6E28652C74297B72657475726E20766F696420303D';
wwv_flow_imp.g_varchar2_table(38081) := '3D3D74262628743D652C653D74686973292C7420696E20652E246D6F64656C2E676574456C656D656E7444657363726970746F722865292E616C6C547970657342794E616D657D2C42692E70726F746F747970652E67657450726F706572747944657363';
wwv_flow_imp.g_varchar2_table(38082) := '726970746F723D66756E6374696F6E28652C74297B72657475726E20746869732E676574456C656D656E7444657363726970746F722865292E70726F7065727469657342794E616D655B745D7D2C42692E70726F746F747970652E676574547970654465';
wwv_flow_imp.g_varchar2_table(38083) := '7363726970746F723D66756E6374696F6E2865297B72657475726E20746869732E72656769737472792E747970654D61705B655D7D3B7661722056693D537472696E672E66726F6D43686172436F64652C7A693D4F626A6563742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(38084) := '2E6861734F776E50726F70657274792C48693D2F2623285C642B293B7C262378285B302D39612D665D2B293B7C26285C772B293B2F67692C57693D7B616D703A2226222C61706F733A2227222C67743A223E222C6C743A223C222C71756F743A2722277D';
wwv_flow_imp.g_varchar2_table(38085) := '3B66756E6374696F6E206A6928652C742C6E2C69297B72657475726E20693F7A692E63616C6C2857692C69293F57695B695D3A2226222B692B223B223A566928747C7C7061727365496E74286E2C313629297D66756E6374696F6E2071692865297B7265';
wwv_flow_imp.g_varchar2_table(38086) := '7475726E20652E6C656E6774683E3326262D31213D3D652E696E6465784F6628222622293F652E7265706C6163652848692C6A69293A657D4F626A6563742E6B657973285769292E666F7245616368282866756E6374696F6E2865297B57695B652E746F';
wwv_flow_imp.g_varchar2_table(38087) := '55707065724361736528295D3D57695B655D7D29293B7661722024693D227873693A74797065222C55693D226E6F6E2D77686974657370616365206F757473696465206F6620726F6F74206E6F6465223B66756E6374696F6E204B692865297B72657475';
wwv_flow_imp.g_varchar2_table(38088) := '726E206E6577204572726F722865297D66756E6374696F6E2047692865297B72657475726E226D697373696E67206E616D65737061636520666F7220707265666978203C222B652B223E227D66756E6374696F6E2051692865297B72657475726E7B6765';
wwv_flow_imp.g_varchar2_table(38089) := '743A652C656E756D657261626C653A21307D7D66756E6374696F6E2059692865297B76617220742C6E3D7B7D3B666F72287420696E2065296E5B745D3D655B745D3B72657475726E206E7D66756E6374696F6E205A692865297B72657475726E20652B22';
wwv_flow_imp.g_varchar2_table(38090) := '24757269227D66756E6374696F6E20586928297B72657475726E7B6C696E653A302C636F6C756D6E3A307D7D66756E6374696F6E204A692865297B7468726F7720657D66756E6374696F6E20656F2865297B69662821746869732972657475726E206E65';
wwv_flow_imp.g_varchar2_table(38091) := '7720656F2865293B76617220742C6E2C692C6F2C732C722C612C6C2C632C643D652626652E70726F78792C683D4A692C753D58692C703D21312C673D21312C6D3D6E756C6C2C663D21313B66756E6374696F6E20762865297B6520696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(38092) := '66204572726F727C7C28653D4B69286529292C6D3D652C6828652C75297D66756E6374696F6E20622865297B732626286520696E7374616E63656F66204572726F727C7C28653D4B69286529292C7328652C7529297D746869732E6F6E3D66756E637469';
wwv_flow_imp.g_varchar2_table(38093) := '6F6E28652C63297B6966282266756E6374696F6E22213D747970656F662063297468726F77204B69282272657175697265642061726773203C6E616D652C2063623E22293B7377697463682865297B63617365226F70656E546167223A6E3D633B627265';
wwv_flow_imp.g_varchar2_table(38094) := '616B3B636173652274657874223A743D633B627265616B3B6361736522636C6F7365546167223A693D633B627265616B3B63617365226572726F72223A683D633B627265616B3B63617365227761726E223A733D633B627265616B3B6361736522636461';
wwv_flow_imp.g_varchar2_table(38095) := '7461223A6F3D633B627265616B3B6361736522617474656E74696F6E223A6C3D633B627265616B3B63617365227175657374696F6E223A613D633B627265616B3B6361736522636F6D6D656E74223A723D633B627265616B3B64656661756C743A746872';
wwv_flow_imp.g_varchar2_table(38096) := '6F77204B692822756E737570706F72746564206576656E743A20222B65297D72657475726E20746869737D2C746869732E6E733D66756E6374696F6E2865297B696628766F696420303D3D3D65262628653D7B7D292C226F626A65637422213D74797065';
wwv_flow_imp.g_varchar2_table(38097) := '6F662065297468726F77204B69282272657175697265642061726773203C6E734D61703D7B7D3E22293B76617220742C6E3D7B7D3B666F72287420696E2065296E5B745D3D655B745D3B72657475726E206E5B22687474703A2F2F7777772E77332E6F72';
wwv_flow_imp.g_varchar2_table(38098) := '672F323030312F584D4C536368656D612D696E7374616E6365225D3D22787369222C673D21302C633D6E2C746869737D2C746869732E70617273653D66756E6374696F6E2865297B69662822737472696E6722213D747970656F662065297468726F7720';
wwv_flow_imp.g_varchar2_table(38099) := '4B69282272657175697265642061726773203C786D6C3D737472696E673E22293B72657475726E206D3D6E756C6C2C66756E6374696F6E2865297B76617220732C682C6D2C5F2C792C772C432C532C782C6B2C452C4C3D673F5B5D3A6E756C6C2C443D67';
wwv_flow_imp.g_varchar2_table(38100) := '3F66756E6374696F6E2865297B76617220742C6E2C693D7B7D3B666F72287420696E206529695B6E3D655B745D5D3D6E2C695B5A69286E295D3D743B72657475726E20697D2863293A6E756C6C2C543D5B5D2C493D302C4D3D21312C413D21312C4E3D30';
wwv_flow_imp.g_varchar2_table(38101) := '2C503D302C4F3D22222C523D303B66756E6374696F6E204628297B6966286E756C6C213D3D452972657475726E20453B76617220652C742C6E2C692C6F2C732C722C612C6C2C642C682C753D672626442E786D6C6E732C6D3D672626703F5B5D3A6E756C';
wwv_flow_imp.g_varchar2_table(38102) := '6C2C663D522C763D4F2C5F3D762E6C656E6774682C793D7B7D2C773D7B7D3B653A666F72283B663C5F3B662B2B296966286C3D21312C212833323D3D3D28643D762E63686172436F64654174286629297C7C643C31342626643E3829297B666F72282864';
wwv_flow_imp.g_varchar2_table(38103) := '3C36357C7C643E3132327C7C643E39302626643C39372926263935213D3D6426263538213D3D64262628622822696C6C6567616C206669727374206368617220617474726962757465206E616D6522292C6C3D2130292C683D662B313B683C5F3B682B2B';
wwv_flow_imp.g_varchar2_table(38104) := '29696628212828643D762E63686172436F64654174286829293E39362626643C3132337C7C643E36342626643C39317C7C643E34372626643C35397C7C34363D3D3D647C7C34353D3D3D647C7C39353D3D3D6429297B69662833323D3D3D647C7C643C31';
wwv_flow_imp.g_varchar2_table(38105) := '342626643E38297B6228226D697373696E67206174747269627574652076616C756522292C663D683B636F6E74696E756520657D69662836313D3D3D6429627265616B3B622822696C6C6567616C20617474726962757465206E616D6520636861722229';
wwv_flow_imp.g_varchar2_table(38106) := '2C6C3D21307D69662822786D6C6E733A786D6C6E73223D3D3D28613D762E737562737472696E6728662C682929262628622822696C6C6567616C206465636C61726174696F6E206F6620786D6C6E7322292C6C3D2130292C33343D3D3D28643D762E6368';
wwv_flow_imp.g_varchar2_table(38107) := '6172436F6465417428682B312929292D313D3D3D28683D762E696E6465784F66282722272C663D682B32292926262D31213D3D28683D762E696E6465784F66282227222C6629292626286228226174747269627574652076616C75652071756F7465206D';
wwv_flow_imp.g_varchar2_table(38108) := '6973736D6174636822292C6C3D2130293B656C73652069662833393D3D3D64292D313D3D3D28683D762E696E6465784F66282227222C663D682B32292926262D31213D3D28683D762E696E6465784F66282722272C662929262628622822617474726962';
wwv_flow_imp.g_varchar2_table(38109) := '7574652076616C75652071756F7465206D6973736D6174636822292C6C3D2130293B656C736520666F72286228226D697373696E67206174747269627574652076616C75652071756F74657322292C6C3D21302C682B3D313B683C5F2626212833323D3D';
wwv_flow_imp.g_varchar2_table(38110) := '3D28643D762E63686172436F6465417428682B3129297C7C643C31342626643E38293B682B2B293B666F72282D313D3D3D682626286228226D697373696E6720636C6F73696E672071756F74657322292C683D5F2C6C3D2130292C6C7C7C28733D762E73';
wwv_flow_imp.g_varchar2_table(38111) := '7562737472696E6728662C6829292C663D683B682B313C5F2626212833323D3D3D28643D762E63686172436F6465417428682B3129297C7C643C31342626643E38293B682B2B29663D3D3D68262628622822696C6C6567616C2063686172616374657220';
wwv_flow_imp.g_varchar2_table(38112) := '61667465722061747472696275746520656E6422292C6C3D2130293B696628663D682B312C216C296966286120696E207729622822617474726962757465203C222B612B223E20616C726561647920646566696E656422293B656C736520696628775B61';
wwv_flow_imp.g_varchar2_table(38113) := '5D3D21302C672969662870297B6966286E756C6C213D3D286F3D22786D6C6E73223D3D3D613F22786D6C6E73223A3132303D3D3D612E63686172436F64654174283029262622786D6C6E733A223D3D3D612E73756273747228302C36293F612E73756273';
wwv_flow_imp.g_varchar2_table(38114) := '74722836293A6E756C6C29297B696628653D71692873292C743D5A69286F292C2128723D635B655D29297B69662822786D6C6E73223D3D3D6F7C7C7420696E20442626445B745D213D3D6529646F7B723D226E73222B492B2B7D7768696C6528766F6964';
wwv_flow_imp.g_varchar2_table(38115) := '2030213D3D445B725D293B656C736520723D6F3B635B655D3D727D445B6F5D213D3D72262628697C7C28443D59692844292C693D2130292C445B6F5D3D722C22786D6C6E73223D3D3D6F262628445B5A692872295D3D652C753D72292C445B745D3D6529';
wwv_flow_imp.g_varchar2_table(38116) := '2C795B615D3D733B636F6E74696E75657D6D2E7075736828612C73297D656C73652D31213D3D28643D612E696E6465784F6628223A2229293F286E3D445B612E737562737472696E6728302C64295D293F2828613D753D3D3D6E3F612E73756273747228';
wwv_flow_imp.g_varchar2_table(38117) := '642B31293A6E2B612E737562737472286429293D3D3D24692626282D31213D3D28643D732E696E6465784F6628223A2229293F286E3D732E737562737472696E6728302C64292C733D286E3D445B6E5D7C7C6E292B732E737562737472696E6728642929';
wwv_flow_imp.g_varchar2_table(38118) := '3A733D752B223A222B73292C795B615D3D73293A6228476928612E737562737472696E6728302C642929293A795B615D3D733B656C736520795B615D3D737D6966287029666F7228663D302C5F3D6D2E6C656E6774683B663C5F3B662B2B297B69662861';
wwv_flow_imp.g_varchar2_table(38119) := '3D6D5B662B2B5D2C733D6D5B665D2C2D31213D3D28643D612E696E6465784F6628223A222929297B69662821286E3D445B612E737562737472696E6728302C64295D29297B6228476928612E737562737472696E6728302C642929293B636F6E74696E75';
wwv_flow_imp.g_varchar2_table(38120) := '657D28613D753D3D3D6E3F612E73756273747228642B31293A6E2B612E737562737472286429293D3D3D24692626282D31213D3D28643D732E696E6465784F6628223A2229293F286E3D732E737562737472696E6728302C64292C733D286E3D445B6E5D';
wwv_flow_imp.g_varchar2_table(38121) := '7C7C6E292B732E737562737472696E67286429293A733D752B223A222B73297D795B615D3D737D72657475726E20453D797D666F7228753D66756E6374696F6E28297B666F722876617220742C6E2C693D2F285C725C6E7C5C727C5C6E292F672C6F3D30';
wwv_flow_imp.g_varchar2_table(38122) := '2C733D302C723D302C613D503B4E3E3D72262628743D692E65786563286529292626212828613D745B305D2E6C656E6774682B742E696E646578293E4E293B296F2B3D312C723D613B72657475726E2D313D3D4E3F28733D612C6E3D652E737562737472';
wwv_flow_imp.g_varchar2_table(38123) := '696E67285029293A303D3D3D503F6E3D652E737562737472696E6728502C4E293A28733D4E2D722C6E3D2D313D3D503F652E737562737472696E67284E293A652E737562737472696E67284E2C502B3129292C7B646174613A6E2C6C696E653A6F2C636F';
wwv_flow_imp.g_varchar2_table(38124) := '6C756D6E3A737D7D2C642626286B3D4F626A6563742E637265617465287B7D2C7B6E616D653A5169282866756E6374696F6E28297B72657475726E20537D29292C6F726967696E616C4E616D653A5169282866756E6374696F6E28297B72657475726E20';
wwv_flow_imp.g_varchar2_table(38125) := '787D29292C61747472733A51692846292C6E733A5169282866756E6374696F6E28297B72657475726E20447D29297D29293B2D31213D3D503B297B6966282D313D3D3D284E3D36303D3D3D652E63686172436F646541742850293F503A652E696E646578';
wwv_flow_imp.g_varchar2_table(38126) := '4F6628223C222C5029292972657475726E20542E6C656E6774683F762822756E657870656374656420656E64206F662066696C6522293A303D3D3D503F7628226D697373696E672073746172742074616722293A766F696428503C652E6C656E67746826';
wwv_flow_imp.g_varchar2_table(38127) := '26652E737562737472696E672850292E7472696D282926266228556929293B69662850213D3D4E29696628542E6C656E677468297B696628742626287428652E737562737472696E6728502C4E292C71692C75292C66292972657475726E7D656C736520';
wwv_flow_imp.g_varchar2_table(38128) := '696628652E737562737472696E6728502C4E292E7472696D282926262862285569292C66292972657475726E3B69662833333D3D3D28793D652E63686172436F64654174284E2B312929297B69662839313D3D3D285F3D652E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(38129) := '4E2B32292926262243444154415B223D3D3D652E737562737472284E2B332C3629297B6966282D313D3D3D28503D652E696E6465784F6628225D5D3E222C4E29292972657475726E20762822756E636C6F73656420636461746122293B6966286F262628';
wwv_flow_imp.g_varchar2_table(38130) := '6F28652E737562737472696E67284E2B392C50292C75292C66292972657475726E3B502B3D333B636F6E74696E75657D69662834353D3D3D5F262634353D3D3D652E63686172436F64654174284E2B3329297B6966282D313D3D3D28503D652E696E6465';
wwv_flow_imp.g_varchar2_table(38131) := '784F6628222D2D5C783365222C4E29292972657475726E20762822756E636C6F73656420636F6D6D656E7422293B696628722626287228652E737562737472696E67284E2B342C50292C71692C75292C66292972657475726E3B502B3D333B636F6E7469';
wwv_flow_imp.g_varchar2_table(38132) := '6E75657D7D6966283633213D3D79297B666F7228683D4E2B313B3B682B2B297B696628773D652E63686172436F646541742868292C69734E614E2877292972657475726E20503D2D312C762822756E636C6F7365642074616722293B69662833343D3D3D';
wwv_flow_imp.g_varchar2_table(38133) := '7729683D2D31213D3D285F3D652E696E6465784F66282722272C682B3129293F5F3A683B656C73652069662833393D3D3D7729683D2D31213D3D285F3D652E696E6465784F66282227222C682B3129293F5F3A683B656C73652069662836323D3D3D7729';
wwv_flow_imp.g_varchar2_table(38134) := '7B503D683B627265616B7D7D6966283333213D3D79297B696628453D7B7D2C34373D3D3D79297B6966284D3D21312C413D21302C21542E6C656E6774682972657475726E207628226D697373696E67206F70656E2074616722293B696628683D533D542E';
wwv_flow_imp.g_varchar2_table(38135) := '706F7028292C5F3D4E2B322B682E6C656E6774682C652E737562737472696E67284E2B322C5F29213D3D682972657475726E20762822636C6F73696E6720746167206D69736D6174636822293B666F72283B5F3C503B5F2B2B29696628212833323D3D3D';
wwv_flow_imp.g_varchar2_table(38136) := '28793D652E63686172436F64654174285F29297C7C793E382626793C3134292972657475726E20762822636C6F73652074616722297D656C73657B69662834373D3D3D652E63686172436F6465417428502D31293F28683D533D652E737562737472696E';
wwv_flow_imp.g_varchar2_table(38137) := '67284E2B312C502D31292C4D3D21302C413D2130293A28683D533D652E737562737472696E67284E2B312C50292C4D3D21302C413D2131292C2128793E39362626793C3132337C7C793E36342626793C39317C7C39353D3D3D797C7C35383D3D3D792929';
wwv_flow_imp.g_varchar2_table(38138) := '72657475726E20762822696C6C6567616C2066697273742063686172206E6F64654E616D6522293B666F72285F3D312C6D3D682E6C656E6774683B5F3C6D3B5F2B2B29696628212828793D682E63686172436F64654174285F29293E39362626793C3132';
wwv_flow_imp.g_varchar2_table(38139) := '337C7C793E36342626793C39317C7C793E34372626793C35397C7C34353D3D3D797C7C39353D3D3D797C7C34363D3D7929297B69662833323D3D3D797C7C793C31342626793E38297B533D682E737562737472696E6728302C5F292C453D6E756C6C3B62';
wwv_flow_imp.g_varchar2_table(38140) := '7265616B7D72657475726E20762822696E76616C6964206E6F64654E616D6522297D417C7C542E707573682853297D69662867297B696628733D442C4D262628417C7C4C2E707573682873292C6E756C6C3D3D3D45262628703D2D31213D3D682E696E64';
wwv_flow_imp.g_varchar2_table(38141) := '65784F662822786D6C6E73222C5F2929262628523D5F2C4F3D682C4628292C703D213129292C783D532C2D31213D3D28793D532E696E6465784F6628223A222929297B6966282128433D445B532E737562737472696E6728302C79295D29297265747572';
wwv_flow_imp.g_varchar2_table(38142) := '6E207628226D697373696E67206E616D657370616365206F6E203C222B782B223E22293B533D532E73756273747228792B31297D656C736520433D442E786D6C6E733B43262628533D432B223A222B53297D6966284D262628523D5F2C4F3D682C6E2626';
wwv_flow_imp.g_varchar2_table(38143) := '28643F6E286B2C71692C412C75293A6E28532C462C71692C412C75292C6629292972657475726E3B69662841297B696628692626286928643F6B3A532C71692C4D2C75292C66292972657475726E3B67262628443D4D3F733A4C2E706F702829297D502B';
wwv_flow_imp.g_varchar2_table(38144) := '3D317D656C73657B6966286C2626286C28652E737562737472696E67284E2C502B31292C71692C75292C66292972657475726E3B502B3D317D7D656C73657B6966282D313D3D3D28503D652E696E6465784F6628223F3E222C4E29292972657475726E20';
wwv_flow_imp.g_varchar2_table(38145) := '762822756E636C6F736564207175657374696F6E22293B696628612626286128652E737562737472696E67284E2C502B32292C75292C66292972657475726E3B502B3D327D7D7D2865292C753D58692C663D21312C6D7D2C746869732E73746F703D6675';
wwv_flow_imp.g_varchar2_table(38146) := '6E6374696F6E28297B663D21307D7D66756E6374696F6E20746F2865297B72657475726E20652E786D6C2626226C6F77657243617365223D3D3D652E786D6C2E746167416C6961737D766172206E6F3D7B7873693A22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(38147) := '6F72672F323030312F584D4C536368656D612D696E7374616E6365222C786D6C3A22687474703A2F2F7777772E77332E6F72672F584D4C2F313939382F6E616D657370616365227D2C696F3D227873693A74797065223B66756E6374696F6E206F6F2865';
wwv_flow_imp.g_varchar2_table(38148) := '297B72657475726E20652E786D6C2626652E786D6C2E73657269616C697A657D66756E6374696F6E20736F2865297B72657475726E206F6F2865293D3D3D696F7D66756E6374696F6E20726F28652C74297B72657475726E20746F2874293F652E707265';
wwv_flow_imp.g_varchar2_table(38149) := '6669782B223A222B28286E3D652E6C6F63616C4E616D65292E6368617241742830292E746F55707065724361736528292B6E2E736C696365283129293A652E6E616D653B766172206E7D66756E6374696F6E20616F2865297B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(38150) := '4572726F722865297D66756E6374696F6E206C6F2865297B72657475726E20652E2464657363726970746F727D66756E6374696F6E20636F2865297B28302C692E6B702928746869732C65292C746869732E656C656D656E7473427949643D7B7D2C7468';
wwv_flow_imp.g_varchar2_table(38151) := '69732E7265666572656E6365733D5B5D2C746869732E7761726E696E67733D5B5D2C746869732E6164645265666572656E63653D66756E6374696F6E2865297B746869732E7265666572656E6365732E707573682865297D2C746869732E616464456C65';
wwv_flow_imp.g_varchar2_table(38152) := '6D656E743D66756E6374696F6E2865297B6966282165297468726F7720616F2822657870656374656420656C656D656E7422293B76617220742C6E3D746869732E656C656D656E7473427949642C693D6C6F2865292E696450726F70657274793B696628';
wwv_flow_imp.g_varchar2_table(38153) := '69262628743D652E67657428692E6E616D652929297B696628212F5E285B612D7A5D5B5C772D2E5D2A3A293F5B612D7A5F5D5B5C772D2E5D2A242F692E74657374287429297468726F77206E6577204572726F722822696C6C6567616C204944203C222B';
wwv_flow_imp.g_varchar2_table(38154) := '742B223E22293B6966286E5B745D297468726F7720616F28226475706C6963617465204944203C222B742B223E22293B6E5B745D3D657D7D2C746869732E6164645761726E696E673D66756E6374696F6E2865297B746869732E7761726E696E67732E70';
wwv_flow_imp.g_varchar2_table(38155) := '7573682865297D7D66756E6374696F6E20686F28297B7D66756E6374696F6E20756F28297B7D66756E6374696F6E20706F28297B7D66756E6374696F6E20676F28652C74297B746869732E70726F70657274793D652C746869732E636F6E746578743D74';
wwv_flow_imp.g_varchar2_table(38156) := '7D66756E6374696F6E206D6F28652C74297B746869732E656C656D656E743D742C746869732E70726F7065727479446573633D657D66756E6374696F6E20666F28297B7D66756E6374696F6E20766F28652C742C6E297B746869732E6D6F64656C3D652C';
wwv_flow_imp.g_varchar2_table(38157) := '746869732E747970653D652E676574547970652874292C746869732E636F6E746578743D6E7D66756E6374696F6E20626F28652C742C6E297B766F2E63616C6C28746869732C652C742C6E297D66756E6374696F6E205F6F28652C742C6E297B74686973';
wwv_flow_imp.g_varchar2_table(38158) := '2E6D6F64656C3D652C746869732E636F6E746578743D6E7D66756E6374696F6E20796F2865297B6520696E7374616E63656F66204269262628653D7B6D6F64656C3A657D292C28302C692E6B702928746869732C7B6C61783A21317D2C65297D686F2E70';
wwv_flow_imp.g_varchar2_table(38159) := '726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B7D2C686F2E70726F746F747970652E68616E646C65546578743D66756E6374696F6E28297B7D2C686F2E70726F746F747970652E68616E646C654E6F64653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(38160) := '6E28297B7D2C756F2E70726F746F747970653D4F626A6563742E63726561746528686F2E70726F746F74797065292C756F2E70726F746F747970652E68616E646C654E6F64653D66756E6374696F6E28297B72657475726E20746869737D2C706F2E7072';
wwv_flow_imp.g_varchar2_table(38161) := '6F746F747970653D4F626A6563742E63726561746528686F2E70726F746F74797065292C706F2E70726F746F747970652E68616E646C65546578743D66756E6374696F6E2865297B746869732E626F64793D28746869732E626F64797C7C2222292B657D';
wwv_flow_imp.g_varchar2_table(38162) := '2C676F2E70726F746F747970653D4F626A6563742E63726561746528706F2E70726F746F74797065292C676F2E70726F746F747970652E68616E646C654E6F64653D66756E6374696F6E2865297B696628746869732E656C656D656E74297468726F7720';
wwv_flow_imp.g_varchar2_table(38163) := '616F28226578706563746564206E6F20737562206E6F64657322293B72657475726E20746869732E656C656D656E743D746869732E6372656174655265666572656E63652865292C746869737D2C676F2E70726F746F747970652E68616E646C65456E64';
wwv_flow_imp.g_varchar2_table(38164) := '3D66756E6374696F6E28297B746869732E656C656D656E742E69643D746869732E626F64797D2C676F2E70726F746F747970652E6372656174655265666572656E63653D66756E6374696F6E2865297B72657475726E7B70726F70657274793A74686973';
wwv_flow_imp.g_varchar2_table(38165) := '2E70726F70657274792E6E732E6E616D652C69643A22227D7D2C6D6F2E70726F746F747970653D4F626A6563742E63726561746528706F2E70726F746F74797065292C6D6F2E70726F746F747970652E68616E646C65456E643D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(38166) := '7B76617220653D746869732E626F64797C7C22222C743D746869732E656C656D656E742C6E3D746869732E70726F7065727479446573633B653D4469286E2E747970652C65292C6E2E69734D616E793F742E676574286E2E6E616D65292E707573682865';
wwv_flow_imp.g_varchar2_table(38167) := '293A742E736574286E2E6E616D652C65297D2C666F2E70726F746F747970653D4F626A6563742E63726561746528706F2E70726F746F74797065292C666F2E70726F746F747970652E68616E646C654E6F64653D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(38168) := '743D746869732C6E3D746869732E656C656D656E743B72657475726E206E3F743D746869732E68616E646C654368696C642865293A286E3D746869732E656C656D656E743D746869732E637265617465456C656D656E742865292C746869732E636F6E74';
wwv_flow_imp.g_varchar2_table(38169) := '6578742E616464456C656D656E74286E29292C747D2C766F2E70726F746F747970653D4F626A6563742E63726561746528666F2E70726F746F74797065292C766F2E70726F746F747970652E6164645265666572656E63653D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(38170) := '7B746869732E636F6E746578742E6164645265666572656E63652865297D2C766F2E70726F746F747970652E68616E646C65546578743D66756E6374696F6E2865297B696628216C6F28746869732E656C656D656E74292E626F647950726F7065727479';
wwv_flow_imp.g_varchar2_table(38171) := '297468726F7720616F2822756E657870656374656420626F64792074657874203C222B652B223E22293B706F2E70726F746F747970652E68616E646C65546578742E63616C6C28746869732C65297D2C766F2E70726F746F747970652E68616E646C6545';
wwv_flow_imp.g_varchar2_table(38172) := '6E643D66756E6374696F6E28297B76617220653D746869732E626F64792C743D746869732E656C656D656E742C6E3D6C6F2874292E626F647950726F70657274793B6E2626766F69642030213D3D65262628653D4469286E2E747970652C65292C742E73';
wwv_flow_imp.g_varchar2_table(38173) := '6574286E2E6E616D652C6529297D2C766F2E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220742C6E3D652E617474726962757465732C6F3D746869732E747970652C733D6C6F286F292C723D746869';
wwv_flow_imp.g_varchar2_table(38174) := '732E636F6E746578742C613D6E6577206F287B7D292C6C3D746869732E6D6F64656C3B72657475726E28302C692E6A4A29286E2C2866756E6374696F6E28652C6E297B766172206F2C633D732E70726F7065727469657342794E616D655B6E5D3B632626';
wwv_flow_imp.g_varchar2_table(38175) := '632E69735265666572656E63653F632E69734D616E793F286F3D652E73706C697428222022292C28302C692E6A4A29286F2C2866756E6374696F6E2865297B722E6164645265666572656E6365287B656C656D656E743A612C70726F70657274793A632E';
wwv_flow_imp.g_varchar2_table(38176) := '6E732E6E616D652C69643A657D297D2929293A722E6164645265666572656E6365287B656C656D656E743A612C70726F70657274793A632E6E732E6E616D652C69643A657D293A28633F653D446928632E747970652C65293A22786D6C6E7322213D3D6E';
wwv_flow_imp.g_varchar2_table(38177) := '262628743D4D69286E2C732E6E732E707265666978292C6C2E6765745061636B61676528742E707265666978292626722E6164645761726E696E67287B6D6573736167653A22756E6B6E6F776E20617474726962757465203C222B6E2B223E222C656C65';
wwv_flow_imp.g_varchar2_table(38178) := '6D656E743A612C70726F70657274793A6E2C76616C75653A657D29292C612E736574286E2C6529297D29292C617D2C766F2E70726F746F747970652E67657450726F7065727479466F724E6F64653D66756E6374696F6E2865297B76617220742C6E2C6F';
wwv_flow_imp.g_varchar2_table(38179) := '3D4D6928652E6E616D65292C733D746869732E747970652C723D746869732E6D6F64656C2C613D6C6F2873292C6C3D6F2E6E616D652C633D612E70726F7065727469657342794E616D655B6C5D3B69662863262621632E6973417474722972657475726E';
wwv_flow_imp.g_varchar2_table(38180) := '20736F286329262628743D652E617474726962757465735B696F5D293F28743D66756E6374696F6E28652C74297B766172206E3D4D692865293B72657475726E2066756E6374696F6E28652C74297B766172206E3D652E6E616D652C693D652E6C6F6361';
wwv_flow_imp.g_varchar2_table(38181) := '6C4E616D652C6F3D742E786D6C2626742E786D6C2E747970655072656669783B72657475726E206F2626303D3D3D692E696E6465784F66286F293F652E7072656669782B223A222B692E736C696365286F2E6C656E677468293A6E7D286E2C742E676574';
wwv_flow_imp.g_varchar2_table(38182) := '5061636B616765286E2E70726566697829297D28742C72292C6E3D722E676574547970652874292C28302C692E6B7029287B7D2C632C7B656666656374697665547970653A6C6F286E292E6E616D657D29293A633B76617220643D722E6765745061636B';
wwv_flow_imp.g_varchar2_table(38183) := '616765286F2E707265666978293B69662864297B696628743D726F286F2C64292C6E3D722E676574547970652874292C633D28302C692E49362928612E70726F706572746965732C2866756E6374696F6E2865297B72657475726E21652E697356697274';
wwv_flow_imp.g_varchar2_table(38184) := '75616C262621652E69735265666572656E6365262621652E697341747472696275746526266E2E6861735479706528652E74797065297D29292C632972657475726E28302C692E6B7029287B7D2C632C7B656666656374697665547970653A6C6F286E29';
wwv_flow_imp.g_varchar2_table(38185) := '2E6E616D657D297D656C736520696628633D28302C692E49362928612E70726F706572746965732C2866756E6374696F6E2865297B72657475726E21652E69735265666572656E6365262621652E6973417474726962757465262622456C656D656E7422';
wwv_flow_imp.g_varchar2_table(38186) := '3D3D3D652E747970657D29292C632972657475726E20633B7468726F7720616F2822756E7265636F676E697A656420656C656D656E74203C222B6F2E6E616D652B223E22297D2C766F2E70726F746F747970652E746F537472696E673D66756E6374696F';
wwv_flow_imp.g_varchar2_table(38187) := '6E28297B72657475726E22456C656D656E7444657363726970746F725B222B6C6F28746869732E74797065292E6E616D652B225D227D2C766F2E70726F746F747970652E76616C756548616E646C65723D66756E6374696F6E28652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(38188) := '6E206E6577206D6F28652C74297D2C766F2E70726F746F747970652E7265666572656E636548616E646C65723D66756E6374696F6E2865297B72657475726E206E657720676F28652C746869732E636F6E74657874297D2C766F2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(38189) := '2E68616E646C65723D66756E6374696F6E2865297B72657475726E22456C656D656E74223D3D3D653F6E6577205F6F28746869732E6D6F64656C2C652C746869732E636F6E74657874293A6E657720766F28746869732E6D6F64656C2C652C746869732E';
wwv_flow_imp.g_varchar2_table(38190) := '636F6E74657874297D2C766F2E70726F746F747970652E68616E646C654368696C643D66756E6374696F6E2865297B76617220742C6E2C6F2C733B696628743D746869732E67657450726F7065727479466F724E6F64652865292C6F3D746869732E656C';
wwv_flow_imp.g_varchar2_table(38191) := '656D656E742C4969286E3D742E656666656374697665547970657C7C742E74797065292972657475726E20746869732E76616C756548616E646C657228742C6F293B76617220723D28733D742E69735265666572656E63653F746869732E726566657265';
wwv_flow_imp.g_varchar2_table(38192) := '6E636548616E646C65722874292E68616E646C654E6F64652865293A746869732E68616E646C6572286E292E68616E646C654E6F6465286529292E656C656D656E743B72657475726E20766F69642030213D3D72262628742E69734D616E793F6F2E6765';
wwv_flow_imp.g_varchar2_table(38193) := '7428742E6E616D65292E707573682872293A6F2E73657428742E6E616D652C72292C742E69735265666572656E63653F2828302C692E6B702928722C7B656C656D656E743A6F7D292C746869732E636F6E746578742E6164645265666572656E63652872';
wwv_flow_imp.g_varchar2_table(38194) := '29293A722E24706172656E743D6F292C737D2C626F2E70726F746F747970653D4F626A6563742E63726561746528766F2E70726F746F74797065292C626F2E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(38195) := '617220743D652E6E616D652C6E3D4D692874292C693D746869732E6D6F64656C2C6F3D746869732E747970652C733D692E6765745061636B616765286E2E707265666978292C723D732626726F286E2C73297C7C743B696628216F2E6861735479706528';
wwv_flow_imp.g_varchar2_table(38196) := '7229297468726F7720616F2822756E657870656374656420656C656D656E74203C222B652E6F726967696E616C4E616D652B223E22293B72657475726E20766F2E70726F746F747970652E637265617465456C656D656E742E63616C6C28746869732C65';
wwv_flow_imp.g_varchar2_table(38197) := '297D2C5F6F2E70726F746F747970653D4F626A6563742E63726561746528666F2E70726F746F74797065292C5F6F2E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220743D652E6E616D652C6E3D4D69';
wwv_flow_imp.g_varchar2_table(38198) := '2874292E7072656669782C693D652E6E735B6E2B2224757269225D2C6F3D652E617474726962757465733B72657475726E20746869732E6D6F64656C2E637265617465416E7928742C692C6F297D2C5F6F2E70726F746F747970652E68616E646C654368';
wwv_flow_imp.g_varchar2_table(38199) := '696C643D66756E6374696F6E2865297B76617220743D6E6577205F6F28746869732E6D6F64656C2C22456C656D656E74222C746869732E636F6E74657874292E68616E646C654E6F64652865292C6E3D746869732E656C656D656E742C693D742E656C65';
wwv_flow_imp.g_varchar2_table(38200) := '6D656E743B72657475726E20766F69642030213D3D69262628286E2E246368696C6472656E3D6E2E246368696C6472656E7C7C5B5D292E707573682869292C692E24706172656E743D6E292C747D2C5F6F2E70726F746F747970652E68616E646C65456E';
wwv_flow_imp.g_varchar2_table(38201) := '643D66756E6374696F6E28297B746869732E626F6479262628746869732E656C656D656E742E24626F64793D746869732E626F6479297D2C796F2E70726F746F747970652E66726F6D584D4C3D66756E6374696F6E28652C742C6E297B766172206F3D74';
wwv_flow_imp.g_varchar2_table(38202) := '2E726F6F7448616E646C65723B7420696E7374616E63656F6620766F3F286F3D742C743D7B7D293A22737472696E67223D3D747970656F6620743F286F3D746869732E68616E646C65722874292C743D7B7D293A22737472696E67223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(38203) := '206F2626286F3D746869732E68616E646C6572286F29293B76617220733D746869732E6D6F64656C2C723D746869732E6C61782C613D6E657720636F2828302C692E6B7029287B7D2C742C7B726F6F7448616E646C65723A6F7D29292C6C3D6E65772065';
wwv_flow_imp.g_varchar2_table(38204) := '6F287B70726F78793A21307D292C633D66756E6374696F6E28297B76617220653D5B5D3B72657475726E204F626A6563742E646566696E6550726F706572747928652C227065656B222C7B76616C75653A66756E6374696F6E28297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(38205) := '6869735B746869732E6C656E6774682D315D7D7D292C657D28293B66756E6374696F6E206428652C742C6E297B76617220693D7428292C6F3D692E6C696E652C733D692E636F6C756D6E2C723D692E646174613B223C223D3D3D722E6368617241742830';
wwv_flow_imp.g_varchar2_table(38206) := '2926262D31213D3D722E696E6465784F662822202229262628723D722E736C69636528302C722E696E6465784F662822202229292B223E22293B766172206C3D22756E7061727361626C6520636F6E74656E7420222B28723F722B2220223A2222292B22';
wwv_flow_imp.g_varchar2_table(38207) := '64657465637465645C6E5C746C696E653A20222B6F2B225C6E5C74636F6C756D6E3A20222B732B225C6E5C746E6573746564206572726F723A20222B652E6D6573736167653B6966286E2972657475726E20612E6164645761726E696E67287B6D657373';
wwv_flow_imp.g_varchar2_table(38208) := '6167653A6C2C6572726F723A657D292C21303B7468726F7720616F286C297D66756E6374696F6E206828652C74297B72657475726E206428652C742C2130297D6F2E636F6E746578743D612C632E70757368286F293B76617220753D2F5E3C5C3F786D6C';
wwv_flow_imp.g_varchar2_table(38209) := '202F692C703D2F20656E636F64696E673D22285B5E225D2B29222F692C673D2F5E7574662D38242F693B66756E6374696F6E206D28652C74297B7472797B632E7065656B28292E68616E646C65546578742865297D63617463682865297B6828652C7429';
wwv_flow_imp.g_varchar2_table(38210) := '7D7D76617220663D732E6765745061636B6167657328292E726564756365282866756E6374696F6E28652C74297B72657475726E20655B742E7572695D3D742E7072656669782C657D292C7B22687474703A2F2F7777772E77332E6F72672F584D4C2F31';
wwv_flow_imp.g_varchar2_table(38211) := '3939382F6E616D657370616365223A22786D6C227D293B72657475726E206C2E6E732866292E6F6E28226F70656E546167222C2866756E6374696F6E28652C742C6E2C69297B766172206F3D652E61747472737C7C7B7D2C733D4F626A6563742E6B6579';
wwv_flow_imp.g_varchar2_table(38212) := '73286F292E726564756365282866756E6374696F6E28652C6E297B76617220693D74286F5B6E5D293B72657475726E20655B6E5D3D692C657D292C7B7D293B2166756E6374696F6E28652C74297B766172206E3D632E7065656B28293B7472797B632E70';
wwv_flow_imp.g_varchar2_table(38213) := '757368286E2E68616E646C654E6F6465286529297D63617463682865297B6428652C742C72292626632E70757368286E657720756F297D7D287B6E616D653A652E6E616D652C6F726967696E616C4E616D653A652E6F726967696E616C4E616D652C6174';
wwv_flow_imp.g_varchar2_table(38214) := '74726962757465733A732C6E733A652E6E737D2C69297D29292E6F6E28227175657374696F6E222C2866756E6374696F6E2865297B696628752E74657374286529297B76617220743D702E657865632865292C6E3D742626745B315D3B6E262621672E74';
wwv_flow_imp.g_varchar2_table(38215) := '657374286E292626612E6164645761726E696E67287B6D6573736167653A22756E737570706F7274656420646F63756D656E7420656E636F64696E67203C222B6E2B223E2C2066616C6C696E67206261636B20746F205554462D38227D297D7D29292E6F';
wwv_flow_imp.g_varchar2_table(38216) := '6E2822636C6F7365546167222C2866756E6374696F6E28297B632E706F7028292E68616E646C65456E6428297D29292E6F6E28226364617461222C6D292E6F6E282274657874222C2866756E6374696F6E28652C742C6E297B2166756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(38217) := '2C74297B652E7472696D282926266D28652C74297D28742865292C6E297D29292E6F6E28226572726F72222C64292E6F6E28227761726E222C68292C6E65772050726F6D697365282866756E6374696F6E28742C6E297B76617220693B7472797B6C2E70';
wwv_flow_imp.g_varchar2_table(38218) := '617273652865292C66756E6374696F6E28297B76617220652C742C6E3D612E656C656D656E7473427949642C693D612E7265666572656E6365733B666F7228653D303B743D695B655D3B652B2B297B766172206F3D742E656C656D656E742C733D6E5B74';
wwv_flow_imp.g_varchar2_table(38219) := '2E69645D2C723D6C6F286F292E70726F7065727469657342794E616D655B742E70726F70657274795D3B696628737C7C612E6164645761726E696E67287B6D6573736167653A22756E7265736F6C766564207265666572656E6365203C222B742E69642B';
wwv_flow_imp.g_varchar2_table(38220) := '223E222C656C656D656E743A742E656C656D656E742C70726F70657274793A742E70726F70657274792C76616C75653A742E69647D292C722E69734D616E79297B766172206C3D6F2E67657428722E6E616D65292C633D6C2E696E6465784F662874293B';
wwv_flow_imp.g_varchar2_table(38221) := '2D313D3D3D63262628633D6C2E6C656E677468292C733F6C5B635D3D733A6C2E73706C69636528632C31297D656C7365206F2E73657428722E6E616D652C73297D7D28297D63617463682865297B693D657D76617220733D6F2E656C656D656E743B697C';
wwv_flow_imp.g_varchar2_table(38222) := '7C737C7C28693D616F28226661696C656420746F20706172736520646F63756D656E74206173203C222B6F2E747970652E2464657363726970746F722E6E616D652B223E2229293B76617220723D612E7761726E696E67732C633D612E7265666572656E';
wwv_flow_imp.g_varchar2_table(38223) := '6365732C643D612E656C656D656E7473427949643B72657475726E20693F28692E7761726E696E67733D722C6E286929293A74287B726F6F74456C656D656E743A732C656C656D656E7473427949643A642C7265666572656E6365733A632C7761726E69';
wwv_flow_imp.g_varchar2_table(38224) := '6E67733A727D297D29297D2C796F2E70726F746F747970652E68616E646C65723D66756E6374696F6E2865297B72657475726E206E657720626F28746869732E6D6F64656C2C65297D3B76617220776F3D2F3C7C3E7C277C227C267C5C6E5C727C5C6E2F';
wwv_flow_imp.g_varchar2_table(38225) := '672C436F3D2F3C7C3E7C262F673B66756E6374696F6E20536F2865297B76617220743D7B7D2C6E3D7B7D2C693D7B7D2C6F3D5B5D2C733D5B5D3B746869732E62795572693D66756E6374696F6E2874297B72657475726E206E5B745D7C7C652626652E62';
wwv_flow_imp.g_varchar2_table(38226) := '795572692874297D2C746869732E6164643D66756E6374696F6E28652C74297B6E5B652E7572695D3D652C743F6F2E707573682865293A732E707573682865292C746869732E6D617050726566697828652E7072656669782C652E757269297D2C746869';
wwv_flow_imp.g_varchar2_table(38227) := '732E75726942795072656669783D66756E6374696F6E2865297B72657475726E20745B657C7C22786D6C6E73225D7D2C746869732E6D61705072656669783D66756E6374696F6E28652C6E297B745B657C7C22786D6C6E73225D3D6E7D2C746869732E67';
wwv_flow_imp.g_varchar2_table(38228) := '65744E534B65793D66756E6374696F6E2865297B72657475726E20766F69642030213D3D652E7072656669783F652E7572692B227C222B652E7072656669783A652E7572697D2C746869732E6C6F67557365643D66756E6374696F6E2874297B76617220';
wwv_flow_imp.g_varchar2_table(38229) := '6E3D742E7572692C6F3D746869732E6765744E534B65792874293B695B6F5D3D746869732E6279557269286E292C652626652E6C6F67557365642874297D2C746869732E676574557365643D66756E6374696F6E2865297B76617220743D746869733B72';
wwv_flow_imp.g_varchar2_table(38230) := '657475726E5B5D2E636F6E636174286F2C73292E66696C746572282866756E6374696F6E2865297B766172206E3D742E6765744E534B65792865293B72657475726E20695B6E5D7D29297D7D66756E6374696F6E20786F28652C74297B652E7375706572';
wwv_flow_imp.g_varchar2_table(38231) := '5F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E66696775726162';
wwv_flow_imp.g_varchar2_table(38232) := '6C653A21307D7D297D66756E6374696F6E206B6F2865297B72657475726E28302C692E4B67292865293F653A28652E7072656669783F652E7072656669782B223A223A2222292B652E6C6F63616C4E616D657D76617220456F3D7B225C6E223A22233130';
wwv_flow_imp.g_varchar2_table(38233) := '222C225C6E5C72223A22233130222C2722273A22233334222C2227223A22233339222C223C223A22233630222C223E223A22233632222C2226223A22233338227D2C4C6F3D7B223C223A226C74222C223E223A226774222C2226223A22616D70227D3B66';
wwv_flow_imp.g_varchar2_table(38234) := '756E6374696F6E20446F28652C742C6E297B72657475726E28653D28302C692E4B67292865293F653A22222B65292E7265706C61636528742C2866756E6374696F6E2865297B72657475726E2226222B6E5B655D2B223B227D29297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38235) := '20546F2865297B746869732E7461674E616D653D657D66756E6374696F6E20496F28297B7D66756E6374696F6E204D6F2865297B746869732E7461674E616D653D657D66756E6374696F6E20416F28652C74297B746869732E626F64793D5B5D2C746869';
wwv_flow_imp.g_varchar2_table(38236) := '732E61747472733D5B5D2C746869732E706172656E743D652C746869732E70726F706572747944657363726970746F723D747D66756E6374696F6E204E6F28652C74297B416F2E63616C6C28746869732C652C74297D66756E6374696F6E20506F28297B';
wwv_flow_imp.g_varchar2_table(38237) := '746869732E76616C75653D22222C746869732E77726974653D66756E6374696F6E2865297B746869732E76616C75652B3D657D7D66756E6374696F6E204F6F28652C74297B766172206E3D5B22225D3B746869732E617070656E643D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38238) := '2874297B72657475726E20652E77726974652874292C746869737D2C746869732E617070656E644E65774C696E653D66756E6374696F6E28297B72657475726E20742626652E777269746528225C6E22292C746869737D2C746869732E617070656E6449';
wwv_flow_imp.g_varchar2_table(38239) := '6E64656E743D66756E6374696F6E28297B72657475726E20742626652E7772697465286E2E6A6F696E282220202229292C746869737D2C746869732E696E64656E743D66756E6374696F6E28297B72657475726E206E2E70757368282222292C74686973';
wwv_flow_imp.g_varchar2_table(38240) := '7D2C746869732E756E696E64656E743D66756E6374696F6E28297B72657475726E206E2E706F7028292C746869737D7D66756E6374696F6E20526F2865297B72657475726E20653D28302C692E6B7029287B666F726D61743A21312C707265616D626C65';
wwv_flow_imp.g_varchar2_table(38241) := '3A21307D2C657C7C7B7D292C7B746F584D4C3A66756E6374696F6E28742C6E297B76617220693D6E7C7C6E657720506F2C6F3D6E6577204F6F28692C652E666F726D6174293B696628652E707265616D626C6526266F2E617070656E6428273C3F786D6C';
wwv_flow_imp.g_varchar2_table(38242) := '2076657273696F6E3D22312E302220656E636F64696E673D225554462D38223F3E5C6E27292C286E657720416F292E6275696C642874292E73657269616C697A65546F286F292C216E2972657475726E20692E76616C75657D7D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(38243) := '466F28652C74297B42692E63616C6C28746869732C652C74297D546F2E70726F746F747970652E6275696C643D66756E6374696F6E2865297B72657475726E20746869732E656C656D656E743D652C746869737D2C546F2E70726F746F747970652E7365';
wwv_flow_imp.g_varchar2_table(38244) := '7269616C697A65546F3D66756E6374696F6E2865297B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D652B223E222B746869732E656C656D656E742E69642B223C2F222B746869732E7461674E616D65';
wwv_flow_imp.g_varchar2_table(38245) := '2B223E22292E617070656E644E65774C696E6528297D2C496F2E70726F746F747970652E73657269616C697A6556616C75653D496F2E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E6428746869';
wwv_flow_imp.g_varchar2_table(38246) := '732E6573636170653F446F28746869732E76616C75652C436F2C4C6F293A746869732E76616C7565297D2C496F2E70726F746F747970652E6275696C643D66756E6374696F6E28652C74297B72657475726E20746869732E76616C75653D742C22537472';
wwv_flow_imp.g_varchar2_table(38247) := '696E67223D3D3D652E7479706526262D31213D3D742E73656172636828436F29262628746869732E6573636170653D2130292C746869737D2C786F284D6F2C496F292C4D6F2E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38248) := '2865297B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D652B223E22292C746869732E73657269616C697A6556616C75652865292C652E617070656E6428223C2F222B746869732E7461674E616D652B';
wwv_flow_imp.g_varchar2_table(38249) := '223E22292E617070656E644E65774C696E6528297D2C416F2E70726F746F747970652E6275696C643D66756E6374696F6E2865297B746869732E656C656D656E743D653B76617220742C6E2C6F2C733D652E2464657363726970746F722C723D74686973';
wwv_flow_imp.g_varchar2_table(38250) := '2E70726F706572747944657363726970746F722C613D732E697347656E657269633B72657475726E20743D613F746869732E706172736547656E657269632865293A746869732E70617273654E73417474726962757465732865292C746869732E6E733D';
wwv_flow_imp.g_varchar2_table(38251) := '723F746869732E6E7350726F70657274795461674E616D652872293A746869732E6E735461674E616D652873292C746869732E7461674E616D653D746869732E6164645461674E616D6528746869732E6E73292C617C7C286E3D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(38252) := '297B76617220743D652E2464657363726970746F723B72657475726E28302C692E70622928742E70726F706572746965732C2866756E6374696F6E2874297B766172206E3D742E6E616D653B696628742E69735669727475616C2972657475726E21313B';
wwv_flow_imp.g_varchar2_table(38253) := '6966282128302C692E7A792928652C6E292972657475726E21313B766172206F3D655B6E5D3B72657475726E206F213D3D742E64656661756C7426266E756C6C213D3D6F26262821742E69734D616E797C7C6F2E6C656E677468297D29297D2865292C74';
wwv_flow_imp.g_varchar2_table(38254) := '6869732E70617273654174747269627574657328286F3D6E2C28302C692E706229286F2C2866756E6374696F6E2865297B72657475726E20652E6973417474727D292929292C746869732E7061727365436F6E7461696E6D656E74732866756E6374696F';
wwv_flow_imp.g_varchar2_table(38255) := '6E2865297B72657475726E28302C692E70622928652C2866756E6374696F6E2865297B72657475726E21652E6973417474727D29297D286E2929292C746869732E706172736547656E657269634174747269627574657328652C74292C746869737D2C41';
wwv_flow_imp.g_varchar2_table(38256) := '6F2E70726F746F747970652E6E735461674E616D653D66756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E20742E697347656E657269633F28302C692E6B7029287B6C6F63616C4E616D653A742E6E732E6C';
wwv_flow_imp.g_varchar2_table(38257) := '6F63616C4E616D657D2C65293A28302C692E6B7029287B6C6F63616C4E616D653A286E3D742E6E732E6C6F63616C4E616D652C6F3D742E24706B672C746F286F293F66756E6374696F6E2865297B72657475726E20652E6368617241742830292E746F4C';
wwv_flow_imp.g_varchar2_table(38258) := '6F7765724361736528292B652E736C6963652831297D286E293A6E297D2C65293B766172206E2C6F7D28746869732E6C6F674E616D6573706163655573656428652E6E73292C65297D2C416F2E70726F746F747970652E6E7350726F7065727479546167';
wwv_flow_imp.g_varchar2_table(38259) := '4E616D653D66756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E28302C692E6B7029287B6C6F63616C4E616D653A742E6E732E6C6F63616C4E616D657D2C65297D28746869732E6C6F674E616D6573706163';
wwv_flow_imp.g_varchar2_table(38260) := '655573656428652E6E73292C65297D2C416F2E70726F746F747970652E69734C6F63616C4E733D66756E6374696F6E2865297B72657475726E20652E7572693D3D3D746869732E6E732E7572697D2C416F2E70726F746F747970652E6E73417474726962';
wwv_flow_imp.g_varchar2_table(38261) := '7574654E616D653D66756E6374696F6E2865297B76617220743B696628743D28302C692E4B67292865293F4D692865293A652E6E732C652E696E686572697465642972657475726E7B6C6F63616C4E616D653A742E6C6F63616C4E616D657D3B76617220';
wwv_flow_imp.g_varchar2_table(38262) := '6E3D746869732E6C6F674E616D657370616365557365642874293B72657475726E20746869732E6765744E616D6573706163657328292E6C6F6755736564286E292C746869732E69734C6F63616C4E73286E293F7B6C6F63616C4E616D653A742E6C6F63';
wwv_flow_imp.g_varchar2_table(38263) := '616C4E616D657D3A28302C692E6B7029287B6C6F63616C4E616D653A742E6C6F63616C4E616D657D2C6E297D2C416F2E70726F746F747970652E706172736547656E657269633D66756E6374696F6E2865297B76617220743D746869732C6E3D74686973';
wwv_flow_imp.g_varchar2_table(38264) := '2E626F64792C6F3D5B5D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E28732C72297B2224626F6479223D3D3D723F6E2E7075736828286E657720496F292E6275696C64287B747970653A22537472696E67227D2C7329293A222463';
wwv_flow_imp.g_varchar2_table(38265) := '68696C6472656E223D3D3D723F28302C692E6A4A2928732C2866756E6374696F6E2865297B6E2E70757368286E657720416F2874292E6275696C64286529297D29293A30213D3D722E696E6465784F6628222422292626742E70617273654E7341747472';
wwv_flow_imp.g_varchar2_table(38266) := '696275746528652C722C732926266F2E70757368287B6E616D653A722C76616C75653A737D297D29292C6F7D2C416F2E70726F746F747970652E70617273654E734174747269627574653D66756E6374696F6E28652C742C6E297B76617220692C6F3D65';
wwv_flow_imp.g_varchar2_table(38267) := '2E246D6F64656C2C733D4D692874293B69662822786D6C6E73223D3D3D732E707265666978262628693D7B7072656669783A732E6C6F63616C4E616D652C7572693A6E7D292C732E7072656669787C7C22786D6C6E7322213D3D732E6C6F63616C4E616D';
wwv_flow_imp.g_varchar2_table(38268) := '657C7C28693D7B7572693A6E7D292C21692972657475726E7B6E616D653A742C76616C75653A6E7D3B6966286F26266F2E6765745061636B616765286E2929746869732E6C6F674E616D65737061636528692C21302C2130293B656C73657B7661722072';
wwv_flow_imp.g_varchar2_table(38269) := '3D746869732E6C6F674E616D6573706163655573656428692C2130293B746869732E6765744E616D6573706163657328292E6C6F67557365642872297D7D2C416F2E70726F746F747970652E70617273654E73417474726962757465733D66756E637469';
wwv_flow_imp.g_varchar2_table(38270) := '6F6E28652C74297B766172206E3D746869732C6F3D652E2461747472732C733D5B5D3B72657475726E28302C692E6A4A29286F2C2866756E6374696F6E28742C69297B766172206F3D6E2E70617273654E7341747472696275746528652C692C74293B6F';
wwv_flow_imp.g_varchar2_table(38271) := '2626732E70757368286F297D29292C737D2C416F2E70726F746F747970652E706172736547656E65726963417474726962757465733D66756E6374696F6E28652C74297B766172206E3D746869733B28302C692E6A4A2928742C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(38272) := '74297B696628742E6E616D65213D3D696F297472797B6E2E616464417474726962757465286E2E6E734174747269627574654E616D6528742E6E616D65292C742E76616C7565297D6361746368286E297B636F6E736F6C652E7761726E28226D69737369';
wwv_flow_imp.g_varchar2_table(38273) := '6E67206E616D65737061636520696E666F726D6174696F6E20666F7220222C742E6E616D652C223D222C742E76616C75652C226F6E222C652C6E297D7D29297D2C416F2E70726F746F747970652E7061727365436F6E7461696E6D656E74733D66756E63';
wwv_flow_imp.g_varchar2_table(38274) := '74696F6E2865297B76617220743D746869732C6E3D746869732E626F64792C6F3D746869732E656C656D656E743B28302C692E6A4A2928652C2866756E6374696F6E2865297B76617220733D6F2E67657428652E6E616D65292C723D652E697352656665';
wwv_flow_imp.g_varchar2_table(38275) := '72656E63653B696628652E69734D616E797C7C28733D5B735D292C652E6973426F6479296E2E7075736828286E657720496F292E6275696C6428652C735B305D29293B656C736520696628496928652E74797065292928302C692E6A4A2928732C286675';
wwv_flow_imp.g_varchar2_table(38276) := '6E6374696F6E2869297B6E2E70757368286E6577204D6F28742E6164645461674E616D6528742E6E7350726F70657274795461674E616D6528652929292E6275696C6428652C6929297D29293B656C736520696628722928302C692E6A4A2928732C2866';
wwv_flow_imp.g_varchar2_table(38277) := '756E6374696F6E2869297B6E2E70757368286E657720546F28742E6164645461674E616D6528742E6E7350726F70657274795461674E616D6528652929292E6275696C64286929297D29293B656C73657B76617220613D736F2865292C6C3D66756E6374';
wwv_flow_imp.g_varchar2_table(38278) := '696F6E2865297B72657475726E2270726F7065727479223D3D3D6F6F2865297D2865293B28302C692E6A4A2928732C2866756E6374696F6E2869297B766172206F3B6F3D613F6E6577204E6F28742C65293A6C3F6E657720416F28742C65293A6E657720';
wwv_flow_imp.g_varchar2_table(38279) := '416F2874292C6E2E70757368286F2E6275696C64286929297D29297D7D29297D2C416F2E70726F746F747970652E6765744E616D657370616365733D66756E6374696F6E2865297B76617220742C6E3D746869732E6E616D657370616365732C693D7468';
wwv_flow_imp.g_varchar2_table(38280) := '69732E706172656E743B72657475726E206E7C7C28743D692626692E6765744E616D6573706163657328292C657C7C21743F746869732E6E616D657370616365733D6E3D6E657720536F2874293A6E3D74292C6E7D2C416F2E70726F746F747970652E6C';
wwv_flow_imp.g_varchar2_table(38281) := '6F674E616D6573706163653D66756E6374696F6E28652C742C6E297B76617220693D746869732E6765744E616D65737061636573286E292C6F3D652E7572692C733D652E7072656669783B72657475726E20692E6279557269286F292626216E7C7C692E';
wwv_flow_imp.g_varchar2_table(38282) := '61646428652C74292C692E6D617050726566697828732C6F292C657D2C416F2E70726F746F747970652E6C6F674E616D657370616365557365643D66756E6374696F6E28652C74297B766172206E2C692C6F2C733D746869732E656C656D656E742E246D';
wwv_flow_imp.g_varchar2_table(38283) := '6F64656C2C723D746869732E6765744E616D657370616365732874292C613D652E7072656669782C6C3D652E7572693B69662821612626216C2972657475726E7B6C6F63616C4E616D653A652E6C6F63616C4E616D657D3B6966286F3D6E6F5B615D7C7C';
wwv_flow_imp.g_varchar2_table(38284) := '73262628732E6765745061636B6167652861297C7C7B7D292E7572692C21286C3D6C7C7C6F7C7C722E757269427950726566697828612929297468726F77206E6577204572726F7228226E6F206E616D6573706163652075726920676976656E20666F72';
wwv_flow_imp.g_varchar2_table(38285) := '20707265666978203C222B612B223E22293B6966282128653D722E6279557269286C2929297B666F72286E3D612C693D313B722E7572694279507265666978286E293B296E3D612B225F222B692B2B3B653D746869732E6C6F674E616D65737061636528';
wwv_flow_imp.g_varchar2_table(38286) := '7B7072656669783A6E2C7572693A6C7D2C6F3D3D3D6C297D72657475726E20612626722E6D617050726566697828612C6C292C657D2C416F2E70726F746F747970652E7061727365417474726962757465733D66756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(38287) := '3D746869732C6E3D746869732E656C656D656E743B28302C692E6A4A2928652C2866756E6374696F6E2865297B766172206F3D6E2E67657428652E6E616D65293B696628652E69735265666572656E636529696628652E69734D616E79297B7661722073';
wwv_flow_imp.g_varchar2_table(38288) := '3D5B5D3B28302C692E6A4A29286F2C2866756E6374696F6E2865297B732E7075736828652E6964297D29292C6F3D732E6A6F696E28222022297D656C7365206F3D6F2E69643B742E61646441747472696275746528742E6E734174747269627574654E61';
wwv_flow_imp.g_varchar2_table(38289) := '6D652865292C6F297D29297D2C416F2E70726F746F747970652E6164645461674E616D653D66756E6374696F6E2865297B76617220743D746869732E6C6F674E616D657370616365557365642865293B72657475726E20746869732E6765744E616D6573';
wwv_flow_imp.g_varchar2_table(38290) := '706163657328292E6C6F67557365642874292C6B6F2865297D2C416F2E70726F746F747970652E6164644174747269627574653D66756E6374696F6E28652C74297B766172206E3D746869732E61747472733B28302C692E4B6729287429262628743D44';
wwv_flow_imp.g_varchar2_table(38291) := '6F28742C776F2C456F29293B766172206F3D28302C692E534C29286E2C2866756E6374696F6E2874297B72657475726E20742E6E616D652E6C6F63616C4E616D653D3D3D652E6C6F63616C4E616D652626742E6E616D652E7572693D3D3D652E75726926';
wwv_flow_imp.g_varchar2_table(38292) := '26742E6E616D652E7072656669783D3D3D652E7072656669787D29292C733D7B6E616D653A652C76616C75653A747D3B2D31213D3D6F3F6E2E73706C696365286F2C312C73293A6E2E707573682873297D2C416F2E70726F746F747970652E7365726961';
wwv_flow_imp.g_varchar2_table(38293) := '6C697A65417474726962757465733D66756E6374696F6E2865297B76617220743D746869732E61747472732C6E3D746869732E6E616D657370616365733B6E262628743D66756E6374696F6E2865297B72657475726E20652E6765745573656428292E66';
wwv_flow_imp.g_varchar2_table(38294) := '696C746572282866756E6374696F6E2865297B72657475726E22786D6C22213D3D652E7072656669787D29292E6D6170282866756E6374696F6E2865297B72657475726E7B6E616D653A22786D6C6E73222B28652E7072656669783F223A222B652E7072';
wwv_flow_imp.g_varchar2_table(38295) := '656669783A2222292C76616C75653A652E7572697D7D29297D286E292E636F6E636174287429292C28302C692E6A4A2928742C2866756E6374696F6E2874297B652E617070656E6428222022292E617070656E64286B6F28742E6E616D6529292E617070';
wwv_flow_imp.g_varchar2_table(38296) := '656E6428273D2227292E617070656E6428742E76616C7565292E617070656E6428272227297D29297D2C416F2E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B76617220743D746869732E626F64795B305D2C6E3D';
wwv_flow_imp.g_varchar2_table(38297) := '742626742E636F6E7374727563746F72213D3D496F3B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D65292C746869732E73657269616C697A65417474726962757465732865292C652E617070656E64';
wwv_flow_imp.g_varchar2_table(38298) := '28743F223E223A22202F3E22292C742626286E2626652E617070656E644E65774C696E6528292E696E64656E7428292C28302C692E6A4A2928746869732E626F64792C2866756E6374696F6E2874297B742E73657269616C697A65546F2865297D29292C';
wwv_flow_imp.g_varchar2_table(38299) := '6E2626652E756E696E64656E7428292E617070656E64496E64656E7428292C652E617070656E6428223C2F222B746869732E7461674E616D652B223E2229292C652E617070656E644E65774C696E6528297D2C786F284E6F2C416F292C4E6F2E70726F74';
wwv_flow_imp.g_varchar2_table(38300) := '6F747970652E70617273654E73417474726962757465733D66756E6374696F6E2865297B76617220743D416F2E70726F746F747970652E70617273654E73417474726962757465732E63616C6C28746869732C65292C6E3D652E2464657363726970746F';
wwv_flow_imp.g_varchar2_table(38301) := '723B6966286E2E6E616D653D3D3D746869732E70726F706572747944657363726970746F722E747970652972657475726E20743B76617220693D746869732E747970654E733D746869732E6E735461674E616D65286E293B746869732E6765744E616D65';
wwv_flow_imp.g_varchar2_table(38302) := '73706163657328292E6C6F675573656428746869732E747970654E73293B766172206F3D652E246D6F64656C2E6765745061636B61676528692E757269292C733D6F2E786D6C26266F2E786D6C2E747970655072656669787C7C22223B72657475726E20';
wwv_flow_imp.g_varchar2_table(38303) := '746869732E61646441747472696275746528746869732E6E734174747269627574654E616D6528696F292C28692E7072656669783F692E7072656669782B223A223A2222292B732B6E2E6E732E6C6F63616C4E616D65292C747D2C4E6F2E70726F746F74';
wwv_flow_imp.g_varchar2_table(38304) := '7970652E69734C6F63616C4E733D66756E6374696F6E2865297B72657475726E20652E7572693D3D3D28746869732E747970654E737C7C746869732E6E73292E7572697D2C466F2E70726F746F747970653D4F626A6563742E6372656174652842692E70';
wwv_flow_imp.g_varchar2_table(38305) := '726F746F74797065292C466F2E70726F746F747970652E66726F6D584D4C3D66756E6374696F6E28652C742C6E297B28302C692E4B67292874297C7C286E3D742C743D2262706D6E3A446566696E6974696F6E7322293B766172206F3D6E657720796F28';
wwv_flow_imp.g_varchar2_table(38306) := '28302C692E6B7029287B6D6F64656C3A746869732C6C61783A21307D2C6E29292C733D6F2E68616E646C65722874293B72657475726E206F2E66726F6D584D4C28652C73297D2C466F2E70726F746F747970652E746F584D4C3D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(38307) := '2C74297B766172206E3D6E657720526F2874293B72657475726E206E65772050726F6D697365282866756E6374696F6E28742C69297B7472797B72657475726E2074287B786D6C3A6E2E746F584D4C2865297D297D63617463682865297B72657475726E';
wwv_flow_imp.g_varchar2_table(38308) := '20692865297D7D29297D3B76617220426F3D7B62706D6E3A7B6E616D653A2242504D4E3230222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4D4F44454C222C7072656669783A2262706D';
wwv_flow_imp.g_varchar2_table(38309) := '6E222C6173736F63696174696F6E733A5B5D2C74797065733A5B7B6E616D653A22496E74657266616365222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C69734174';
wwv_flow_imp.g_varchar2_table(38310) := '74723A21302C747970653A22537472696E67227D2C7B6E616D653A226F7065726174696F6E73222C747970653A224F7065726174696F6E222C69734D616E793A21307D2C7B6E616D653A22696D706C656D656E746174696F6E526566222C697341747472';
wwv_flow_imp.g_varchar2_table(38311) := '3A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224F7065726174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A2130';
wwv_flow_imp.g_varchar2_table(38312) := '2C747970653A22537472696E67227D2C7B6E616D653A22696E4D657373616765526566222C747970653A224D657373616765222C69735265666572656E63653A21307D2C7B6E616D653A226F75744D657373616765526566222C747970653A224D657373';
wwv_flow_imp.g_varchar2_table(38313) := '616765222C69735265666572656E63653A21307D2C7B6E616D653A226572726F72526566222C747970653A224572726F72222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22696D706C656D656E746174696F6E5265';
wwv_flow_imp.g_varchar2_table(38314) := '66222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22456E64506F696E74222C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A224175646974696E67222C7375706572436C61';
wwv_flow_imp.g_varchar2_table(38315) := '73733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22476C6F62616C5461736B222C7375706572436C6173733A5B2243616C6C61626C65456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A227265736F7572636573222C';
wwv_flow_imp.g_varchar2_table(38316) := '747970653A225265736F75726365526F6C65222C69734D616E793A21307D5D7D2C7B6E616D653A224D6F6E69746F72696E67222C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22506572666F726D6572222C7375';
wwv_flow_imp.g_varchar2_table(38317) := '706572436C6173733A5B225265736F75726365526F6C65225D7D2C7B6E616D653A2250726F63657373222C7375706572436C6173733A5B22466C6F77456C656D656E7473436F6E7461696E6572222C2243616C6C61626C65456C656D656E74225D2C7072';
wwv_flow_imp.g_varchar2_table(38318) := '6F706572746965733A5B7B6E616D653A2270726F6365737354797065222C747970653A2250726F6365737354797065222C6973417474723A21307D2C7B6E616D653A226973436C6F736564222C6973417474723A21302C747970653A22426F6F6C65616E';
wwv_flow_imp.g_varchar2_table(38319) := '227D2C7B6E616D653A226175646974696E67222C747970653A224175646974696E67227D2C7B6E616D653A226D6F6E69746F72696E67222C747970653A224D6F6E69746F72696E67227D2C7B6E616D653A2270726F70657274696573222C747970653A22';
wwv_flow_imp.g_varchar2_table(38320) := '50726F7065727479222C69734D616E793A21307D2C7B6E616D653A226C616E6553657473222C69734D616E793A21302C7265706C616365733A22466C6F77456C656D656E7473436F6E7461696E6572236C616E6553657473222C747970653A224C616E65';
wwv_flow_imp.g_varchar2_table(38321) := '536574227D2C7B6E616D653A22666C6F77456C656D656E7473222C69734D616E793A21302C7265706C616365733A22466C6F77456C656D656E7473436F6E7461696E657223666C6F77456C656D656E7473222C747970653A22466C6F77456C656D656E74';
wwv_flow_imp.g_varchar2_table(38322) := '227D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D2C7B6E616D653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C69734D616E793A21307D2C7B6E61';
wwv_flow_imp.g_varchar2_table(38323) := '6D653A22636F7272656C6174696F6E537562736372697074696F6E73222C747970653A22436F7272656C6174696F6E537562736372697074696F6E222C69734D616E793A21307D2C7B6E616D653A22737570706F727473222C747970653A2250726F6365';
wwv_flow_imp.g_varchar2_table(38324) := '7373222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22646566696E6974696F6E616C436F6C6C61626F726174696F6E526566222C747970653A22436F6C6C61626F726174696F6E222C6973417474723A21302C6973';
wwv_flow_imp.g_varchar2_table(38325) := '5265666572656E63653A21307D2C7B6E616D653A22697345786563757461626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A224C616E65536574222C7375706572436C6173733A5B2242617365456C656D';
wwv_flow_imp.g_varchar2_table(38326) := '656E74225D2C70726F706572746965733A5B7B6E616D653A226C616E6573222C747970653A224C616E65222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(38327) := '3A224C616E65222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22706172746974696F';
wwv_flow_imp.g_varchar2_table(38328) := '6E456C656D656E74526566222C747970653A2242617365456C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22706172746974696F6E456C656D656E74222C747970653A2242617365456C656D656E74';
wwv_flow_imp.g_varchar2_table(38329) := '227D2C7B6E616D653A22666C6F774E6F6465526566222C747970653A22466C6F774E6F6465222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226368696C644C616E65536574222C747970653A224C616E6553657422';
wwv_flow_imp.g_varchar2_table(38330) := '2C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A22476C6F62616C4D616E75616C5461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D7D2C7B6E616D653A224D616E75616C5461736B';
wwv_flow_imp.g_varchar2_table(38331) := '222C7375706572436C6173733A5B225461736B225D7D2C7B6E616D653A22557365725461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A2272656E646572696E6773222C747970653A2252656E';
wwv_flow_imp.g_varchar2_table(38332) := '646572696E67222C69734D616E793A21307D2C7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2252656E646572696E67222C7375706572436C6173733A5B22';
wwv_flow_imp.g_varchar2_table(38333) := '42617365456C656D656E74225D7D2C7B6E616D653A2248756D616E506572666F726D6572222C7375706572436C6173733A5B22506572666F726D6572225D7D2C7B6E616D653A22506F74656E7469616C4F776E6572222C7375706572436C6173733A5B22';
wwv_flow_imp.g_varchar2_table(38334) := '48756D616E506572666F726D6572225D7D2C7B6E616D653A22476C6F62616C557365725461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(38335) := '222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2272656E646572696E6773222C747970653A2252656E646572696E67222C69734D616E793A21307D5D7D2C7B6E616D653A2247617465776179222C6973416273747261';
wwv_flow_imp.g_varchar2_table(38336) := '63743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A2267617465776179446972656374696F6E222C747970653A2247617465776179446972656374696F6E222C64656661756C743A22';
wwv_flow_imp.g_varchar2_table(38337) := '556E737065636966696564222C6973417474723A21307D5D7D2C7B6E616D653A224576656E74426173656447617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A5B7B6E616D653A22696E7374616E';
wwv_flow_imp.g_varchar2_table(38338) := '7469617465222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226576656E744761746577617954797065222C747970653A224576656E7442617365644761746577617954797065222C6973';
wwv_flow_imp.g_varchar2_table(38339) := '417474723A21302C64656661756C743A224578636C7573697665227D5D7D2C7B6E616D653A22436F6D706C657847617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A5B7B6E616D653A2261637469';
wwv_flow_imp.g_varchar2_table(38340) := '766174696F6E436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C69';
wwv_flow_imp.g_varchar2_table(38341) := '73417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224578636C757369766547617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A5B7B6E616D653A2264656661756C';
wwv_flow_imp.g_varchar2_table(38342) := '74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22496E636C757369766547617465776179222C7375706572436C6173733A5B2247617465776179225D2C70';
wwv_flow_imp.g_varchar2_table(38343) := '726F706572746965733A5B7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22506172616C6C656C47617465776179222C73';
wwv_flow_imp.g_varchar2_table(38344) := '75706572436C6173733A5B2247617465776179225D7D2C7B6E616D653A22526F6F74456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A2252656C6174696F6E';
wwv_flow_imp.g_varchar2_table(38345) := '73686970222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2274797065222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22646972656374696F6E22';
wwv_flow_imp.g_varchar2_table(38346) := '2C747970653A2252656C6174696F6E73686970446972656374696F6E222C6973417474723A21307D2C7B6E616D653A22736F75726365222C69734D616E793A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D2C7B6E61';
wwv_flow_imp.g_varchar2_table(38347) := '6D653A22746172676574222C69734D616E793A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D5D7D2C7B6E616D653A2242617365456C656D656E74222C697341627374726163743A21302C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(38348) := '5B7B6E616D653A226964222C6973417474723A21302C747970653A22537472696E67222C697349643A21307D2C7B6E616D653A22646F63756D656E746174696F6E222C747970653A22446F63756D656E746174696F6E222C69734D616E793A21307D2C7B';
wwv_flow_imp.g_varchar2_table(38349) := '6E616D653A22657874656E73696F6E446566696E6974696F6E73222C747970653A22457874656E73696F6E446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22657874656E73696F6E456C65';
wwv_flow_imp.g_varchar2_table(38350) := '6D656E7473222C747970653A22457874656E73696F6E456C656D656E7473227D5D7D2C7B6E616D653A22457874656E73696F6E222C70726F706572746965733A5B7B6E616D653A226D757374556E6465727374616E64222C64656661756C743A21312C69';
wwv_flow_imp.g_varchar2_table(38351) := '73417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22646566696E6974696F6E222C747970653A22457874656E73696F6E446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(38352) := '6E616D653A22457874656E73696F6E446566696E6974696F6E222C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22657874656E73696F6E41747472696275';
wwv_flow_imp.g_varchar2_table(38353) := '7465446566696E6974696F6E73222C747970653A22457874656E73696F6E417474726962757465446566696E6974696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A22457874656E73696F6E417474726962757465446566696E6974696F6E22';
wwv_flow_imp.g_varchar2_table(38354) := '2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2274797065222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2269735265';
wwv_flow_imp.g_varchar2_table(38355) := '666572656E6365222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22657874656E73696F6E446566696E6974696F6E222C747970653A22457874656E73696F6E446566696E6974696F6E22';
wwv_flow_imp.g_varchar2_table(38356) := '2C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22457874656E73696F6E456C656D656E7473222C70726F706572746965733A5B7B6E616D653A2276616C7565526566222C6973417474723A21302C697352656665';
wwv_flow_imp.g_varchar2_table(38357) := '72656E63653A21302C747970653A22456C656D656E74227D2C7B6E616D653A2276616C756573222C747970653A22456C656D656E74222C69734D616E793A21307D2C7B6E616D653A22657874656E73696F6E417474726962757465446566696E6974696F';
wwv_flow_imp.g_varchar2_table(38358) := '6E222C747970653A22457874656E73696F6E417474726962757465446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446F63756D656E746174696F6E222C7375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(38359) := '5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2274657874222C747970653A22537472696E67222C6973426F64793A21307D2C7B6E616D653A2274657874466F726D6174222C64656661756C743A22746578742F70';
wwv_flow_imp.g_varchar2_table(38360) := '6C61696E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224576656E74222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465222C22496E746572616374696F6E4E6F6465';
wwv_flow_imp.g_varchar2_table(38361) := '225D2C70726F706572746965733A5B7B6E616D653A2270726F70657274696573222C747970653A2250726F7065727479222C69734D616E793A21307D5D7D2C7B6E616D653A22496E7465726D65646961746543617463684576656E74222C737570657243';
wwv_flow_imp.g_varchar2_table(38362) := '6C6173733A5B2243617463684576656E74225D7D2C7B6E616D653A22496E7465726D6564696174655468726F774576656E74222C7375706572436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A22456E644576656E74222C73757065';
wwv_flow_imp.g_varchar2_table(38363) := '72436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A2253746172744576656E74222C7375706572436C6173733A5B2243617463684576656E74225D2C70726F706572746965733A5B7B6E616D653A226973496E74657272757074696E';
wwv_flow_imp.g_varchar2_table(38364) := '67222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A225468726F774576656E74222C697341627374726163743A21302C7375706572436C6173733A5B224576656E74225D2C70726F70';
wwv_flow_imp.g_varchar2_table(38365) := '6572746965733A5B7B6E616D653A2264617461496E70757473222C747970653A2244617461496E707574222C69734D616E793A21307D2C7B6E616D653A2264617461496E7075744173736F63696174696F6E73222C747970653A2244617461496E707574';
wwv_flow_imp.g_varchar2_table(38366) := '4173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A22696E707574536574222C747970653A22496E707574536574227D2C7B6E616D653A226576656E74446566696E6974696F6E73222C747970653A224576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(38367) := '74696F6E222C69734D616E793A21307D2C7B6E616D653A226576656E74446566696E6974696F6E526566222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(38368) := '3A2243617463684576656E74222C697341627374726163743A21302C7375706572436C6173733A5B224576656E74225D2C70726F706572746965733A5B7B6E616D653A22706172616C6C656C4D756C7469706C65222C6973417474723A21302C74797065';
wwv_flow_imp.g_varchar2_table(38369) := '3A22426F6F6C65616E222C64656661756C743A21317D2C7B6E616D653A22646174614F757470757473222C747970653A22446174614F7574707574222C69734D616E793A21307D2C7B6E616D653A22646174614F75747075744173736F63696174696F6E';
wwv_flow_imp.g_varchar2_table(38370) := '73222C747970653A22446174614F75747075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A226F7574707574536574222C747970653A224F7574707574536574227D2C7B6E616D653A226576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(38371) := '6E73222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A226576656E74446566696E6974696F6E526566222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21302C6973';
wwv_flow_imp.g_varchar2_table(38372) := '5265666572656E63653A21307D5D7D2C7B6E616D653A22426F756E646172794576656E74222C7375706572436C6173733A5B2243617463684576656E74225D2C70726F706572746965733A5B7B6E616D653A2263616E63656C4163746976697479222C64';
wwv_flow_imp.g_varchar2_table(38373) := '656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226174746163686564546F526566222C747970653A224163746976697479222C6973417474723A21302C69735265666572656E63653A21307D5D';
wwv_flow_imp.g_varchar2_table(38374) := '7D2C7B6E616D653A224576656E74446566696E6974696F6E222C697341627374726163743A21302C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A2243616E63656C4576656E74446566696E6974696F6E222C7375';
wwv_flow_imp.g_varchar2_table(38375) := '706572436C6173733A5B224576656E74446566696E6974696F6E225D7D2C7B6E616D653A224572726F724576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F70657274696573';
wwv_flow_imp.g_varchar2_table(38376) := '3A5B7B6E616D653A226572726F72526566222C747970653A224572726F72222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225465726D696E6174654576656E74446566696E6974696F6E222C7375706572436C';
wwv_flow_imp.g_varchar2_table(38377) := '6173733A5B224576656E74446566696E6974696F6E225D7D2C7B6E616D653A22457363616C6174696F6E4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F70657274696573';
wwv_flow_imp.g_varchar2_table(38378) := '3A5B7B6E616D653A22657363616C6174696F6E526566222C747970653A22457363616C6174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22457363616C6174696F6E222C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(38379) := '5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A2253';
wwv_flow_imp.g_varchar2_table(38380) := '7472696E67227D2C7B6E616D653A22657363616C6174696F6E436F6465222C6973417474723A21302C747970653A22537472696E67227D5D2C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A22436F6D70656E7361';
wwv_flow_imp.g_varchar2_table(38381) := '74654576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A2277616974466F72436F6D706C6574696F6E222C6973417474723A21302C7479';
wwv_flow_imp.g_varchar2_table(38382) := '70653A22426F6F6C65616E222C64656661756C743A21307D2C7B6E616D653A226163746976697479526566222C747970653A224163746976697479222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2254696D65';
wwv_flow_imp.g_varchar2_table(38383) := '724576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A2274696D6544617465222C747970653A2245787072657373696F6E222C786D6C3A';
wwv_flow_imp.g_varchar2_table(38384) := '7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2274696D654379636C65222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2274696D6544';
wwv_flow_imp.g_varchar2_table(38385) := '75726174696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A224C696E6B4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576';
wwv_flow_imp.g_varchar2_table(38386) := '656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22746172676574222C747970653A224C696E6B4576656E7444656669';
wwv_flow_imp.g_varchar2_table(38387) := '6E6974696F6E222C69735265666572656E63653A21307D2C7B6E616D653A22736F75726365222C747970653A224C696E6B4576656E74446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38388) := '224D6573736167654576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A226D657373616765526566222C747970653A224D657373616765';
wwv_flow_imp.g_varchar2_table(38389) := '222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38390) := '22436F6E646974696F6E616C4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A22636F6E646974696F6E222C747970653A2245787072';
wwv_flow_imp.g_varchar2_table(38391) := '657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A225369676E616C4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70';
wwv_flow_imp.g_varchar2_table(38392) := '726F706572746965733A5B7B6E616D653A227369676E616C526566222C747970653A225369676E616C222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225369676E616C222C7375706572436C6173733A5B2252';
wwv_flow_imp.g_varchar2_table(38393) := '6F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38394) := '226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22496D706C696369745468726F774576656E74222C7375706572436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A224461746153';
wwv_flow_imp.g_varchar2_table(38395) := '74617465222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224974656D41776172';
wwv_flow_imp.g_varchar2_table(38396) := '65456C656D656E74222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226974656D5375626A656374526566222C747970653A224974656D446566696E6974696F6E222C697341747472';
wwv_flow_imp.g_varchar2_table(38397) := '3A21302C69735265666572656E63653A21307D2C7B6E616D653A22646174615374617465222C747970653A22446174615374617465227D5D7D2C7B6E616D653A22446174614173736F63696174696F6E222C7375706572436C6173733A5B224261736545';
wwv_flow_imp.g_varchar2_table(38398) := '6C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365526566222C747970653A224974656D4177617265456C656D656E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A2274617267';
wwv_flow_imp.g_varchar2_table(38399) := '6574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A227472616E73666F726D6174696F6E222C747970653A22466F726D616C45787072657373696F6E222C786D6C3A7B73';
wwv_flow_imp.g_varchar2_table(38400) := '657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A2261737369676E6D656E74222C747970653A2241737369676E6D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A2244617461496E707574222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(38401) := '3A5B224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C656374696F6E222C64656661756C74';
wwv_flow_imp.g_varchar2_table(38402) := '3A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22696E707574536574526566222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(38403) := '3A21307D2C7B6E616D653A22696E707574536574576974684F7074696F6E616C222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A22696E7075';
wwv_flow_imp.g_varchar2_table(38404) := '74536574576974685768696C65457865637574696E67222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446174614F7574707574222C';
wwv_flow_imp.g_varchar2_table(38405) := '7375706572436C6173733A5B224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(38406) := '6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226F7574707574536574526566222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A2130';
wwv_flow_imp.g_varchar2_table(38407) := '2C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574536574576974684F7074696F6E616C222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(38408) := '307D2C7B6E616D653A226F7574707574536574576974685768696C65457865637574696E67222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(38409) := '6D653A22496E707574536574222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226461';
wwv_flow_imp.g_varchar2_table(38410) := '7461496E70757452656673222C747970653A2244617461496E707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7074696F6E616C496E70757452656673222C747970653A2244617461496E707574222C69';
wwv_flow_imp.g_varchar2_table(38411) := '734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227768696C65457865637574696E67496E70757452656673222C747970653A2244617461496E707574222C69734D616E793A21302C69735265666572656E63653A21307D2C';
wwv_flow_imp.g_varchar2_table(38412) := '7B6E616D653A226F757470757453657452656673222C747970653A224F7574707574536574222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224F7574707574536574222C7375706572436C6173733A5B224261';
wwv_flow_imp.g_varchar2_table(38413) := '7365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22646174614F757470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226E61';
wwv_flow_imp.g_varchar2_table(38414) := '6D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E70757453657452656673222C747970653A22496E707574536574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226F';
wwv_flow_imp.g_varchar2_table(38415) := '7074696F6E616C4F757470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227768696C65457865637574696E674F757470757452656673222C74797065';
wwv_flow_imp.g_varchar2_table(38416) := '3A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2250726F7065727479222C7375706572436C6173733A5B224974656D4177617265456C656D656E74225D2C70726F706572746965';
wwv_flow_imp.g_varchar2_table(38417) := '733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2244617461496E7075744173736F63696174696F6E222C7375706572436C6173733A5B22446174614173736F63696174696F6E';
wwv_flow_imp.g_varchar2_table(38418) := '225D7D2C7B6E616D653A22446174614F75747075744173736F63696174696F6E222C7375706572436C6173733A5B22446174614173736F63696174696F6E225D7D2C7B6E616D653A22496E7075744F757470757453706563696669636174696F6E222C73';
wwv_flow_imp.g_varchar2_table(38419) := '75706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461496E70757473222C747970653A2244617461496E707574222C69734D616E793A21307D2C7B6E616D653A22646174614F757470';
wwv_flow_imp.g_varchar2_table(38420) := '757473222C747970653A22446174614F7574707574222C69734D616E793A21307D2C7B6E616D653A22696E70757453657473222C747970653A22496E707574536574222C69734D616E793A21307D2C7B6E616D653A226F757470757453657473222C7479';
wwv_flow_imp.g_varchar2_table(38421) := '70653A224F7574707574536574222C69734D616E793A21307D5D7D2C7B6E616D653A22446174614F626A656374222C7375706572436C6173733A5B22466C6F77456C656D656E74222C224974656D4177617265456C656D656E74225D2C70726F70657274';
wwv_flow_imp.g_varchar2_table(38422) := '6965733A5B7B6E616D653A226973436F6C6C656374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A22496E7075744F757470757442696E64696E67222C70726F7065727469';
wwv_flow_imp.g_varchar2_table(38423) := '65733A5B7B6E616D653A22696E70757444617461526566222C747970653A22496E707574536574222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F757470757444617461526566222C747970653A224F75747075';
wwv_flow_imp.g_varchar2_table(38424) := '74536574222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(38425) := '616D653A2241737369676E6D656E74222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2266726F6D222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A';
wwv_flow_imp.g_varchar2_table(38426) := '653A227873693A74797065227D7D2C7B6E616D653A22746F222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A224461746153746F7265222C7375706572436C61';
wwv_flow_imp.g_varchar2_table(38427) := '73733A5B22526F6F74456C656D656E74222C224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226361706163';
wwv_flow_imp.g_varchar2_table(38428) := '697479222C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226973556E6C696D69746564222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A22446174';
wwv_flow_imp.g_varchar2_table(38429) := '6153746F72655265666572656E6365222C7375706572436C6173733A5B224974656D4177617265456C656D656E74222C22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226461746153746F7265526566222C74797065';
wwv_flow_imp.g_varchar2_table(38430) := '3A224461746153746F7265222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446174614F626A6563745265666572656E6365222C7375706572436C6173733A5B224974656D4177617265456C656D656E74222C';
wwv_flow_imp.g_varchar2_table(38431) := '22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22646174614F626A656374526566222C747970653A22446174614F626A656374222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(38432) := '3A22436F6E766572736174696F6E4C696E6B222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365526566222C747970653A22496E746572616374696F6E4E6F6465222C';
wwv_flow_imp.g_varchar2_table(38433) := '6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(38434) := '6E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6E766572736174696F6E4173736F63696174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F7065727469';
wwv_flow_imp.g_varchar2_table(38435) := '65733A5B7B6E616D653A22696E6E6572436F6E766572736174696F6E4E6F6465526566222C747970653A22436F6E766572736174696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574657243';
wwv_flow_imp.g_varchar2_table(38436) := '6F6E766572736174696F6E4E6F6465526566222C747970653A22436F6E766572736174696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243616C6C436F6E766572736174696F6E222C737570';
wwv_flow_imp.g_varchar2_table(38437) := '6572436C6173733A5B22436F6E766572736174696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2263616C6C6564436F6C6C61626F726174696F6E526566222C747970653A22436F6C6C61626F726174696F6E222C6973417474723A';
wwv_flow_imp.g_varchar2_table(38438) := '21302C69735265666572656E63653A21307D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38439) := '22436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6E766572736174696F6E4E6F6465225D7D2C7B6E616D653A22537562436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6E766572736174696F6E4E6F64';
wwv_flow_imp.g_varchar2_table(38440) := '65225D2C70726F706572746965733A5B7B6E616D653A22636F6E766572736174696F6E4E6F646573222C747970653A22436F6E766572736174696F6E4E6F6465222C69734D616E793A21307D5D7D2C7B6E616D653A22436F6E766572736174696F6E4E6F';
wwv_flow_imp.g_varchar2_table(38441) := '6465222C697341627374726163743A21302C7375706572436C6173733A5B22496E746572616374696F6E4E6F6465222C2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C7479';
wwv_flow_imp.g_varchar2_table(38442) := '70653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226D657373616765466C6F7752';
wwv_flow_imp.g_varchar2_table(38443) := '656673222C747970653A224D657373616765466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D61';
wwv_flow_imp.g_varchar2_table(38444) := '6E793A21307D5D7D2C7B6E616D653A22476C6F62616C436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6C6C61626F726174696F6E225D7D2C7B6E616D653A22506172746E6572456E74697479222C7375706572436C6173733A5B';
wwv_flow_imp.g_varchar2_table(38445) := '22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A22506172746963';
wwv_flow_imp.g_varchar2_table(38446) := '6970616E74222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22506172746E6572526F6C65222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38447) := '226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D5D';
wwv_flow_imp.g_varchar2_table(38448) := '7D2C7B6E616D653A22436F7272656C6174696F6E50726F7065727479222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F6E50726F70657274795265747269';
wwv_flow_imp.g_varchar2_table(38449) := '6576616C45787072657373696F6E222C747970653A22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C74797065';
wwv_flow_imp.g_varchar2_table(38450) := '3A22537472696E67227D2C7B6E616D653A2274797065222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224572726F72222C7375706572436C6173733A5B';
wwv_flow_imp.g_varchar2_table(38451) := '22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(38452) := '653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226572726F72436F6465222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F7272656C6174696F6E4B6579';
wwv_flow_imp.g_varchar2_table(38453) := '222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F6E50726F7065727479526566222C747970653A22436F7272656C6174696F6E50726F7065727479222C69';
wwv_flow_imp.g_varchar2_table(38454) := '734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2245787072657373696F6E222C7375706572436C6173733A5B22426173';
wwv_flow_imp.g_varchar2_table(38455) := '65456C656D656E74225D2C697341627374726163743A21312C70726F706572746965733A5B7B6E616D653A22626F6479222C6973426F64793A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22466F726D616C45787072657373696F6E';
wwv_flow_imp.g_varchar2_table(38456) := '222C7375706572436C6173733A5B2245787072657373696F6E225D2C70726F706572746965733A5B7B6E616D653A226C616E6775616765222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226576616C7561746573546F';
wwv_flow_imp.g_varchar2_table(38457) := '54797065526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224D657373616765222C7375706572436C6173733A5B22526F6F74456C656D656E7422';
wwv_flow_imp.g_varchar2_table(38458) := '5D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226974656D526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C';
wwv_flow_imp.g_varchar2_table(38459) := '69735265666572656E63653A21307D5D7D2C7B6E616D653A224974656D446566696E6974696F6E222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226974656D4B696E64222C747970';
wwv_flow_imp.g_varchar2_table(38460) := '653A224974656D4B696E64222C6973417474723A21307D2C7B6E616D653A22737472756374757265526566222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C656374696F6E222C64656661756C743A21';
wwv_flow_imp.g_varchar2_table(38461) := '312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22696D706F7274222C747970653A22496D706F7274222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22466C6F77456C656D';
wwv_flow_imp.g_varchar2_table(38462) := '656E74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(38463) := '653A226175646974696E67222C747970653A224175646974696E67227D2C7B6E616D653A226D6F6E69746F72696E67222C747970653A224D6F6E69746F72696E67227D2C7B6E616D653A2263617465676F727956616C7565526566222C747970653A2243';
wwv_flow_imp.g_varchar2_table(38464) := '617465676F727956616C7565222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2253657175656E6365466C6F77222C7375706572436C6173733A5B22466C6F77456C656D656E74225D2C70726F70657274696573';
wwv_flow_imp.g_varchar2_table(38465) := '3A5B7B6E616D653A226973496D6D656469617465222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22636F6E646974696F6E45787072657373696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73';
wwv_flow_imp.g_varchar2_table(38466) := '657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22736F75726365526566222C747970653A22466C6F774E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C';
wwv_flow_imp.g_varchar2_table(38467) := '747970653A22466C6F774E6F6465222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22466C6F77456C656D656E7473436F6E7461696E6572222C697341627374726163743A21302C7375706572436C6173733A5B';
wwv_flow_imp.g_varchar2_table(38468) := '2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226C616E6553657473222C747970653A224C616E65536574222C69734D616E793A21307D2C7B6E616D653A22666C6F77456C656D656E7473222C747970653A22466C6F';
wwv_flow_imp.g_varchar2_table(38469) := '77456C656D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A2243616C6C61626C65456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B';
wwv_flow_imp.g_varchar2_table(38470) := '7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696F53706563696669636174696F6E222C747970653A22496E7075744F757470757453706563696669636174696F6E222C786D6C3A7B73';
wwv_flow_imp.g_varchar2_table(38471) := '657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A22737570706F72746564496E74657266616365526566222C747970653A22496E74657266616365222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(38472) := '3A22696F42696E64696E67222C747970653A22496E7075744F757470757442696E64696E67222C69734D616E793A21302C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D5D7D2C7B6E616D653A22466C6F774E6F6465222C69734162';
wwv_flow_imp.g_varchar2_table(38473) := '7374726163743A21302C7375706572436C6173733A5B22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22696E636F6D696E67222C747970653A2253657175656E6365466C6F77222C69734D616E793A21302C69735265';
wwv_flow_imp.g_varchar2_table(38474) := '666572656E63653A21307D2C7B6E616D653A226F7574676F696E67222C747970653A2253657175656E6365466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226C616E6573222C747970653A224C616E6522';
wwv_flow_imp.g_varchar2_table(38475) := '2C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E222C7375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(38476) := '5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226D65737361676550617468222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A226D657373616765526566222C747970653A224D65';
wwv_flow_imp.g_varchar2_table(38477) := '7373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F706572747942696E64696E67222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F';
wwv_flow_imp.g_varchar2_table(38478) := '706572746965733A5B7B6E616D653A226461746150617468222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A22636F7272656C6174696F6E50726F7065727479526566222C747970653A22436F7272656C6174696F6E50';
wwv_flow_imp.g_varchar2_table(38479) := '726F7065727479222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225265736F75726365222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(38480) := '6E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227265736F75726365506172616D6574657273222C747970653A225265736F75726365506172616D65746572222C69734D616E793A21307D5D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(38481) := '653A225265736F75726365506172616D65746572222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B';
wwv_flow_imp.g_varchar2_table(38482) := '6E616D653A2269735265717569726564222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2274797065222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(38483) := '3A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E537562736372697074696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F6E4B657952';
wwv_flow_imp.g_varchar2_table(38484) := '6566222C747970653A22436F7272656C6174696F6E4B6579222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E50726F706572747942696E64696E67222C747970653A22436F7272656C61';
wwv_flow_imp.g_varchar2_table(38485) := '74696F6E50726F706572747942696E64696E67222C69734D616E793A21307D5D7D2C7B6E616D653A224D657373616765466C6F77222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(38486) := '6E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736F75726365526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E';
wwv_flow_imp.g_varchar2_table(38487) := '616D653A22746172676574526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D657373616765526566222C747970653A224D657373616765222C69';
wwv_flow_imp.g_varchar2_table(38488) := '73417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224D657373616765466C6F774173736F63696174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(38489) := '6D653A22696E6E65724D657373616765466C6F77526566222C747970653A224D657373616765466C6F77222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F757465724D657373616765466C6F77526566222C7479';
wwv_flow_imp.g_varchar2_table(38490) := '70653A224D657373616765466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22496E746572616374696F6E4E6F6465222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D65';
wwv_flow_imp.g_varchar2_table(38491) := '3A22696E636F6D696E67436F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F';
wwv_flow_imp.g_varchar2_table(38492) := '7574676F696E67436F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061';
wwv_flow_imp.g_varchar2_table(38493) := '727469636970616E74222C7375706572436C6173733A5B22496E746572616374696F6E4E6F6465222C2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472';
wwv_flow_imp.g_varchar2_table(38494) := '696E67227D2C7B6E616D653A22696E74657266616365526566222C747970653A22496E74657266616365222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227061727469636970616E744D756C7469706C6963697479';
wwv_flow_imp.g_varchar2_table(38495) := '222C747970653A225061727469636970616E744D756C7469706C6963697479227D2C7B6E616D653A22656E64506F696E7452656673222C747970653A22456E64506F696E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E61';
wwv_flow_imp.g_varchar2_table(38496) := '6D653A2270726F63657373526566222C747970653A2250726F63657373222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061727469636970616E744173736F63696174696F6E222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(38497) := '3A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22696E6E65725061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A2130';
wwv_flow_imp.g_varchar2_table(38498) := '7D2C7B6E616D653A226F757465725061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061727469636970616E744D756C7469';
wwv_flow_imp.g_varchar2_table(38499) := '706C6963697479222C70726F706572746965733A5B7B6E616D653A226D696E696D756D222C64656661756C743A302C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226D6178696D756D222C64656661756C743A312C69';
wwv_flow_imp.g_varchar2_table(38500) := '73417474723A21302C747970653A22496E7465676572227D5D2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22436F6C6C61626F726174696F6E222C7375706572436C6173733A5B22526F6F74456C656D656E74';
wwv_flow_imp.g_varchar2_table(38501) := '225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436C6F736564222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(38502) := '653A227061727469636970616E7473222C747970653A225061727469636970616E74222C69734D616E793A21307D2C7B6E616D653A226D657373616765466C6F7773222C747970653A224D657373616765466C6F77222C69734D616E793A21307D2C7B6E';
wwv_flow_imp.g_varchar2_table(38503) := '616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D2C7B6E616D653A22636F6E766572736174696F6E73222C747970653A22436F6E766572736174696F6E4E6F6465222C69734D616E793A21307D2C';
wwv_flow_imp.g_varchar2_table(38504) := '7B6E616D653A22636F6E766572736174696F6E4173736F63696174696F6E73222C747970653A22436F6E766572736174696F6E4173736F63696174696F6E227D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970';
wwv_flow_imp.g_varchar2_table(38505) := '653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A226D657373616765466C6F774173736F63696174696F6E73222C747970653A224D657373616765466C6F774173736F63696174696F6E222C';
wwv_flow_imp.g_varchar2_table(38506) := '69734D616E793A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D616E793A21307D2C7B6E616D653A2263686F72656F677261706879526566222C747970653A224368';
wwv_flow_imp.g_varchar2_table(38507) := '6F72656F677261706879222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21307D5D7D';
wwv_flow_imp.g_varchar2_table(38508) := '2C7B6E616D653A2243686F72656F6772617068794163746976697479222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A227061727469636970616E745265';
wwv_flow_imp.g_varchar2_table(38509) := '66222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22696E6974696174696E675061727469636970616E74526566222C747970653A225061727469636970616E74222C';
wwv_flow_imp.g_varchar2_table(38510) := '6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D616E793A21307D2C7B6E616D653A226C6F6F7054797065222C';
wwv_flow_imp.g_varchar2_table(38511) := '747970653A2243686F72656F6772617068794C6F6F7054797065222C64656661756C743A224E6F6E65222C6973417474723A21307D5D7D2C7B6E616D653A2243616C6C43686F72656F677261706879222C7375706572436C6173733A5B2243686F72656F';
wwv_flow_imp.g_varchar2_table(38512) := '6772617068794163746976697479225D2C70726F706572746965733A5B7B6E616D653A2263616C6C656443686F72656F677261706879526566222C747970653A2243686F72656F677261706879222C6973417474723A21302C69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(38513) := '3A21307D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A2253756243686F72656F67726170';
wwv_flow_imp.g_varchar2_table(38514) := '6879222C7375706572436C6173733A5B2243686F72656F6772617068794163746976697479222C22466C6F77456C656D656E7473436F6E7461696E6572225D2C70726F706572746965733A5B7B6E616D653A22617274696661637473222C747970653A22';
wwv_flow_imp.g_varchar2_table(38515) := '4172746966616374222C69734D616E793A21307D5D7D2C7B6E616D653A2243686F72656F6772617068795461736B222C7375706572436C6173733A5B2243686F72656F6772617068794163746976697479225D2C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(38516) := '653A226D657373616765466C6F77526566222C747970653A224D657373616765466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243686F72656F677261706879222C7375706572436C6173733A5B22';
wwv_flow_imp.g_varchar2_table(38517) := '436F6C6C61626F726174696F6E222C22466C6F77456C656D656E7473436F6E7461696E6572225D7D2C7B6E616D653A22476C6F62616C43686F72656F6772617068795461736B222C7375706572436C6173733A5B2243686F72656F677261706879225D2C';
wwv_flow_imp.g_varchar2_table(38518) := '70726F706572746965733A5B7B6E616D653A22696E6974696174696E675061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2254';
wwv_flow_imp.g_varchar2_table(38519) := '657874416E6E6F746174696F6E222C7375706572436C6173733A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D653A2274657874222C747970653A22537472696E67227D2C7B6E616D653A2274657874466F726D6174222C6465';
wwv_flow_imp.g_varchar2_table(38520) := '6661756C743A22746578742F706C61696E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2247726F7570222C7375706572436C6173733A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(38521) := '653A2263617465676F727956616C7565526566222C747970653A2243617465676F727956616C7565222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224173736F63696174696F6E222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(38522) := '3A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D653A226173736F63696174696F6E446972656374696F6E222C747970653A224173736F63696174696F6E446972656374696F6E222C6973417474723A21307D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38523) := '22736F75726365526566222C747970653A2242617365456C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A2242617365456C656D656E74222C697341747472';
wwv_flow_imp.g_varchar2_table(38524) := '3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243617465676F7279222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2263617465676F727956616C7565222C';
wwv_flow_imp.g_varchar2_table(38525) := '747970653A2243617465676F727956616C7565222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224172746966616374222C697341627374726163743A';
wwv_flow_imp.g_varchar2_table(38526) := '21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A2243617465676F727956616C7565222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(38527) := '617465676F72697A6564466C6F77456C656D656E7473222C747970653A22466C6F77456C656D656E74222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A2276616C7565222C69734174';
wwv_flow_imp.g_varchar2_table(38528) := '74723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224163746976697479222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A22697346';
wwv_flow_imp.g_varchar2_table(38529) := '6F72436F6D70656E736174696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69';
wwv_flow_imp.g_varchar2_table(38530) := '735265666572656E63653A21307D2C7B6E616D653A22696F53706563696669636174696F6E222C747970653A22496E7075744F757470757453706563696669636174696F6E222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B';
wwv_flow_imp.g_varchar2_table(38531) := '6E616D653A22626F756E646172794576656E7452656673222C747970653A22426F756E646172794576656E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A2270726F70657274696573222C747970653A2250726F';
wwv_flow_imp.g_varchar2_table(38532) := '7065727479222C69734D616E793A21307D2C7B6E616D653A2264617461496E7075744173736F63696174696F6E73222C747970653A2244617461496E7075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A22646174614F75';
wwv_flow_imp.g_varchar2_table(38533) := '747075744173736F63696174696F6E73222C747970653A22446174614F75747075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A2273746172745175616E74697479222C64656661756C743A312C6973417474723A21302C';
wwv_flow_imp.g_varchar2_table(38534) := '747970653A22496E7465676572227D2C7B6E616D653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C69734D616E793A21307D2C7B6E616D653A22636F6D706C6574696F6E5175616E74697479222C64656661756C743A';
wwv_flow_imp.g_varchar2_table(38535) := '312C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226C6F6F70436861726163746572697374696373222C747970653A224C6F6F70436861726163746572697374696373227D5D7D2C7B6E616D653A2253657276696365';
wwv_flow_imp.g_varchar2_table(38536) := '5461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226F706572617469';
wwv_flow_imp.g_varchar2_table(38537) := '6F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2253756250726F63657373222C7375706572436C6173733A5B224163746976697479222C22466C6F7745';
wwv_flow_imp.g_varchar2_table(38538) := '6C656D656E7473436F6E7461696E6572222C22496E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2274726967676572656442794576656E74222C64656661756C743A21312C6973417474723A21302C747970653A';
wwv_flow_imp.g_varchar2_table(38539) := '22426F6F6C65616E227D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D5D7D2C7B6E616D653A224C6F6F70436861726163746572697374696373222C697341627374726163743A21302C';
wwv_flow_imp.g_varchar2_table(38540) := '7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A224D756C7469496E7374616E63654C6F6F70436861726163746572697374696373222C7375706572436C6173733A5B224C6F6F704368617261637465726973746963';
wwv_flow_imp.g_varchar2_table(38541) := '73225D2C70726F706572746965733A5B7B6E616D653A22697353657175656E7469616C222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226265686176696F72222C747970653A224D756C';
wwv_flow_imp.g_varchar2_table(38542) := '7469496E7374616E63654265686176696F72222C64656661756C743A22416C6C222C6973417474723A21307D2C7B6E616D653A226C6F6F7043617264696E616C697479222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A';
wwv_flow_imp.g_varchar2_table(38543) := '653A227873693A74797065227D7D2C7B6E616D653A226C6F6F7044617461496E707574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A226C6F6F70446174614F75747075';
wwv_flow_imp.g_varchar2_table(38544) := '74526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A22696E707574446174614974656D222C747970653A2244617461496E707574222C786D6C3A7B73657269616C697A653A';
wwv_flow_imp.g_varchar2_table(38545) := '2270726F7065727479227D7D2C7B6E616D653A226F7574707574446174614974656D222C747970653A22446174614F7574707574222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A22636F6D706C657842656861';
wwv_flow_imp.g_varchar2_table(38546) := '76696F72446566696E6974696F6E222C747970653A22436F6D706C65784265686176696F72446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A22636F6D706C6574696F6E436F6E646974696F6E222C747970653A22457870726573';
wwv_flow_imp.g_varchar2_table(38547) := '73696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A226F6E654265686176696F724576656E74526566222C747970653A224576656E74446566696E6974696F6E222C6973417474723A21302C6973526566';
wwv_flow_imp.g_varchar2_table(38548) := '6572656E63653A21307D2C7B6E616D653A226E6F6E654265686176696F724576656E74526566222C747970653A224576656E74446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225374';
wwv_flow_imp.g_varchar2_table(38549) := '616E646172644C6F6F70436861726163746572697374696373222C7375706572436C6173733A5B224C6F6F70436861726163746572697374696373225D2C70726F706572746965733A5B7B6E616D653A22746573744265666F7265222C64656661756C74';
wwv_flow_imp.g_varchar2_table(38550) := '3A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226C6F6F70436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(38551) := '616D653A226C6F6F704D6178696D756D222C747970653A22496E7465676572222C6973417474723A21307D5D7D2C7B6E616D653A2243616C6C4163746976697479222C7375706572436C6173733A5B224163746976697479222C22496E74657261637469';
wwv_flow_imp.g_varchar2_table(38552) := '6F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2263616C6C6564456C656D656E74222C747970653A22537472696E67222C6973417474723A21307D5D7D2C7B6E616D653A225461736B222C7375706572436C6173733A5B2241637469';
wwv_flow_imp.g_varchar2_table(38553) := '76697479222C22496E746572616374696F6E4E6F6465225D7D2C7B6E616D653A2253656E645461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973';
wwv_flow_imp.g_varchar2_table(38554) := '417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D6573736167';
wwv_flow_imp.g_varchar2_table(38555) := '65526566222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22526563656976655461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(38556) := '5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E7374616E7469617465222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C';
wwv_flow_imp.g_varchar2_table(38557) := '65616E227D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D657373616765526566222C747970653A224D65737361';
wwv_flow_imp.g_varchar2_table(38558) := '6765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225363726970745461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22736372697074466F726D';
wwv_flow_imp.g_varchar2_table(38559) := '6174222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736372697074222C747970653A22537472696E67227D5D7D2C7B6E616D653A22427573696E65737352756C655461736B222C7375706572436C6173733A5B2254';
wwv_flow_imp.g_varchar2_table(38560) := '61736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224164486F6353756250726F63657373222C7375706572436C61';
wwv_flow_imp.g_varchar2_table(38561) := '73733A5B2253756250726F63657373225D2C70726F706572746965733A5B7B6E616D653A22636F6D706C6574696F6E436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065';
wwv_flow_imp.g_varchar2_table(38562) := '227D7D2C7B6E616D653A226F72646572696E67222C747970653A224164486F634F72646572696E67222C6973417474723A21307D2C7B6E616D653A2263616E63656C52656D61696E696E67496E7374616E636573222C64656661756C743A21302C697341';
wwv_flow_imp.g_varchar2_table(38563) := '7474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A225472616E73616374696F6E222C7375706572436C6173733A5B2253756250726F63657373225D2C70726F706572746965733A5B7B6E616D653A2270726F746F636F6C222C';
wwv_flow_imp.g_varchar2_table(38564) := '6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226D6574686F64222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22476C6F62616C5363726970745461736B222C7375706572436C61';
wwv_flow_imp.g_varchar2_table(38565) := '73733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A227363726970744C616E6775616765222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736372697074222C6973417474723A';
wwv_flow_imp.g_varchar2_table(38566) := '21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22476C6F62616C427573696E65737352756C655461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C';
wwv_flow_imp.g_varchar2_table(38567) := '656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6D706C65784265686176696F72446566696E6974696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C';
wwv_flow_imp.g_varchar2_table(38568) := '70726F706572746965733A5B7B6E616D653A22636F6E646974696F6E222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A226576656E74222C747970653A22496D706C696369745468726F774576656E74227D5D7D2C7B6E';
wwv_flow_imp.g_varchar2_table(38569) := '616D653A225265736F75726365526F6C65222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A227265736F75726365526566222C747970653A225265736F75726365222C697352656665';
wwv_flow_imp.g_varchar2_table(38570) := '72656E63653A21307D2C7B6E616D653A227265736F75726365506172616D6574657242696E64696E6773222C747970653A225265736F75726365506172616D6574657242696E64696E67222C69734D616E793A21307D2C7B6E616D653A227265736F7572';
wwv_flow_imp.g_varchar2_table(38571) := '636541737369676E6D656E7445787072657373696F6E222C747970653A225265736F7572636541737369676E6D656E7445787072657373696F6E227D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D';
wwv_flow_imp.g_varchar2_table(38572) := '2C7B6E616D653A225265736F75726365506172616D6574657242696E64696E67222C70726F706572746965733A5B7B6E616D653A2265787072657373696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A2278';
wwv_flow_imp.g_varchar2_table(38573) := '73693A74797065227D7D2C7B6E616D653A22706172616D65746572526566222C747970653A225265736F75726365506172616D65746572222C6973417474723A21302C69735265666572656E63653A21307D5D2C7375706572436C6173733A5B22426173';
wwv_flow_imp.g_varchar2_table(38574) := '65456C656D656E74225D7D2C7B6E616D653A225265736F7572636541737369676E6D656E7445787072657373696F6E222C70726F706572746965733A5B7B6E616D653A2265787072657373696F6E222C747970653A2245787072657373696F6E222C786D';
wwv_flow_imp.g_varchar2_table(38575) := '6C3A7B73657269616C697A653A227873693A74797065227D7D5D2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22496D706F7274222C70726F706572746965733A5B7B6E616D653A22696D706F72745479706522';
wwv_flow_imp.g_varchar2_table(38576) := '2C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226C6F636174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226E616D657370616365222C6973417474723A21302C74797065';
wwv_flow_imp.g_varchar2_table(38577) := '3A22537472696E67227D5D7D2C7B6E616D653A22446566696E6974696F6E73222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A';
wwv_flow_imp.g_varchar2_table(38578) := '22537472696E67227D2C7B6E616D653A227461726765744E616D657370616365222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2265787072657373696F6E4C616E6775616765222C64656661756C743A22687474703A';
wwv_flow_imp.g_varchar2_table(38579) := '2F2F7777772E77332E6F72672F313939392F5850617468222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22747970654C616E6775616765222C64656661756C743A22687474703A2F2F7777772E77332E6F72672F3230';
wwv_flow_imp.g_varchar2_table(38580) := '30312F584D4C536368656D61222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696D706F727473222C747970653A22496D706F7274222C69734D616E793A21307D2C7B6E616D653A22657874656E73696F6E73222C74';
wwv_flow_imp.g_varchar2_table(38581) := '7970653A22457874656E73696F6E222C69734D616E793A21307D2C7B6E616D653A22726F6F74456C656D656E7473222C747970653A22526F6F74456C656D656E74222C69734D616E793A21307D2C7B6E616D653A226469616772616D73222C69734D616E';
wwv_flow_imp.g_varchar2_table(38582) := '793A21302C747970653A2262706D6E64693A42504D4E4469616772616D227D2C7B6E616D653A226578706F72746572222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2272656C6174696F6E7368697073222C74797065';
wwv_flow_imp.g_varchar2_table(38583) := '3A2252656C6174696F6E73686970222C69734D616E793A21307D2C7B6E616D653A226578706F7274657256657273696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D65726174696F6E733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(38584) := '50726F6365737354797065222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A225075626C6963227D2C7B6E616D653A2250726976617465227D5D7D2C7B6E616D653A2247617465776179446972656374696F6E';
wwv_flow_imp.g_varchar2_table(38585) := '222C6C69746572616C56616C7565733A5B7B6E616D653A22556E737065636966696564227D2C7B6E616D653A22436F6E76657267696E67227D2C7B6E616D653A22446976657267696E67227D2C7B6E616D653A224D69786564227D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38586) := '224576656E7442617365644761746577617954797065222C6C69746572616C56616C7565733A5B7B6E616D653A22506172616C6C656C227D2C7B6E616D653A224578636C7573697665227D5D7D2C7B6E616D653A2252656C6174696F6E73686970446972';
wwv_flow_imp.g_varchar2_table(38587) := '656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A22466F7277617264227D2C7B6E616D653A224261636B77617264227D2C7B6E616D653A22426F7468227D5D7D2C7B6E616D653A224974656D4B';
wwv_flow_imp.g_varchar2_table(38588) := '696E64222C6C69746572616C56616C7565733A5B7B6E616D653A22506879736963616C227D2C7B6E616D653A22496E666F726D6174696F6E227D5D7D2C7B6E616D653A2243686F72656F6772617068794C6F6F7054797065222C6C69746572616C56616C';
wwv_flow_imp.g_varchar2_table(38589) := '7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A225374616E64617264227D2C7B6E616D653A224D756C7469496E7374616E636553657175656E7469616C227D2C7B6E616D653A224D756C7469496E7374616E6365506172616C6C656C227D';
wwv_flow_imp.g_varchar2_table(38590) := '5D7D2C7B6E616D653A224173736F63696174696F6E446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A224F6E65227D2C7B6E616D653A22426F7468227D5D7D2C7B6E616D653A224D756C';
wwv_flow_imp.g_varchar2_table(38591) := '7469496E7374616E63654265686176696F72222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A224F6E65227D2C7B6E616D653A22416C6C227D2C7B6E616D653A22436F6D706C6578227D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(38592) := '224164486F634F72646572696E67222C6C69746572616C56616C7565733A5B7B6E616D653A22506172616C6C656C227D2C7B6E616D653A2253657175656E7469616C227D5D7D5D2C786D6C3A7B746167416C6961733A226C6F77657243617365222C7479';
wwv_flow_imp.g_varchar2_table(38593) := '70655072656669783A2274227D7D2C62706D6E64693A7B6E616D653A2242504D4E4449222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4449222C7072656669783A2262706D6E6469222C';
wwv_flow_imp.g_varchar2_table(38594) := '74797065733A5B7B6E616D653A2242504D4E4469616772616D222C70726F706572746965733A5B7B6E616D653A22706C616E65222C747970653A2242504D4E506C616E65222C7265646566696E65733A2264693A4469616772616D23726F6F74456C656D';
wwv_flow_imp.g_varchar2_table(38595) := '656E74227D2C7B6E616D653A226C6162656C5374796C65222C747970653A2242504D4E4C6162656C5374796C65222C69734D616E793A21307D5D2C7375706572436C6173733A5B2264693A4469616772616D225D7D2C7B6E616D653A2242504D4E506C61';
wwv_flow_imp.g_varchar2_table(38596) := '6E65222C70726F706572746965733A5B7B6E616D653A2262706D6E456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A44';
wwv_flow_imp.g_varchar2_table(38597) := '69616772616D456C656D656E74236D6F64656C456C656D656E74227D5D2C7375706572436C6173733A5B2264693A506C616E65225D7D2C7B6E616D653A2242504D4E5368617065222C70726F706572746965733A5B7B6E616D653A2262706D6E456C656D';
wwv_flow_imp.g_varchar2_table(38598) := '656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74227D2C7B6E';
wwv_flow_imp.g_varchar2_table(38599) := '616D653A226973486F72697A6F6E74616C222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226973457870616E646564222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2269734D';
wwv_flow_imp.g_varchar2_table(38600) := '61726B657256697369626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226C6162656C222C747970653A2242504D4E4C6162656C227D2C7B6E616D653A2269734D65737361676556697369626C65222C697341';
wwv_flow_imp.g_varchar2_table(38601) := '7474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A227061727469636970616E7442616E644B696E64222C747970653A225061727469636970616E7442616E644B696E64222C6973417474723A21307D2C7B6E616D653A2263686F72';
wwv_flow_imp.g_varchar2_table(38602) := '656F67726170687941637469766974795368617065222C747970653A2242504D4E5368617065222C6973417474723A21302C69735265666572656E63653A21307D5D2C7375706572436C6173733A5B2264693A4C6162656C65645368617065225D7D2C7B';
wwv_flow_imp.g_varchar2_table(38603) := '6E616D653A2242504D4E45646765222C70726F706572746965733A5B7B6E616D653A226C6162656C222C747970653A2242504D4E4C6162656C227D2C7B6E616D653A2262706D6E456C656D656E74222C6973417474723A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(38604) := '653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74227D2C7B6E616D653A22736F75726365456C656D656E74222C6973417474';
wwv_flow_imp.g_varchar2_table(38605) := '723A21302C69735265666572656E63653A21302C747970653A2264693A4469616772616D456C656D656E74222C7265646566696E65733A2264693A4564676523736F75726365227D2C7B6E616D653A22746172676574456C656D656E74222C6973417474';
wwv_flow_imp.g_varchar2_table(38606) := '723A21302C69735265666572656E63653A21302C747970653A2264693A4469616772616D456C656D656E74222C7265646566696E65733A2264693A4564676523746172676574227D2C7B6E616D653A226D65737361676556697369626C654B696E64222C';
wwv_flow_imp.g_varchar2_table(38607) := '747970653A224D65737361676556697369626C654B696E64222C6973417474723A21302C64656661756C743A22696E6974696174696E67227D5D2C7375706572436C6173733A5B2264693A4C6162656C656445646765225D7D2C7B6E616D653A2242504D';
wwv_flow_imp.g_varchar2_table(38608) := '4E4C6162656C222C70726F706572746965733A5B7B6E616D653A226C6162656C5374796C65222C747970653A2242504D4E4C6162656C5374796C65222C6973417474723A21302C69735265666572656E63653A21302C7265646566696E65733A2264693A';
wwv_flow_imp.g_varchar2_table(38609) := '4469616772616D456C656D656E74237374796C65227D5D2C7375706572436C6173733A5B2264693A4C6162656C225D7D2C7B6E616D653A2242504D4E4C6162656C5374796C65222C70726F706572746965733A5B7B6E616D653A22666F6E74222C747970';
wwv_flow_imp.g_varchar2_table(38610) := '653A2264633A466F6E74227D5D2C7375706572436C6173733A5B2264693A5374796C65225D7D5D2C656E756D65726174696F6E733A5B7B6E616D653A225061727469636970616E7442616E644B696E64222C6C69746572616C56616C7565733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(38611) := '6D653A22746F705F696E6974696174696E67227D2C7B6E616D653A226D6964646C655F696E6974696174696E67227D2C7B6E616D653A22626F74746F6D5F696E6974696174696E67227D2C7B6E616D653A22746F705F6E6F6E5F696E6974696174696E67';
wwv_flow_imp.g_varchar2_table(38612) := '227D2C7B6E616D653A226D6964646C655F6E6F6E5F696E6974696174696E67227D2C7B6E616D653A22626F74746F6D5F6E6F6E5F696E6974696174696E67227D5D7D2C7B6E616D653A224D65737361676556697369626C654B696E64222C6C6974657261';
wwv_flow_imp.g_varchar2_table(38613) := '6C56616C7565733A5B7B6E616D653A22696E6974696174696E67227D2C7B6E616D653A226E6F6E5F696E6974696174696E67227D5D7D5D2C6173736F63696174696F6E733A5B5D7D2C64633A7B6E616D653A224443222C7572693A22687474703A2F2F77';
wwv_flow_imp.g_varchar2_table(38614) := '77772E6F6D672E6F72672F737065632F44442F32303130303532342F4443222C7072656669783A226463222C74797065733A5B7B6E616D653A22426F6F6C65616E227D2C7B6E616D653A22496E7465676572227D2C7B6E616D653A225265616C227D2C7B';
wwv_flow_imp.g_varchar2_table(38615) := '6E616D653A22537472696E67227D2C7B6E616D653A22466F6E74222C70726F706572746965733A5B7B6E616D653A226E616D65222C747970653A22537472696E67222C6973417474723A21307D2C7B6E616D653A2273697A65222C747970653A22526561';
wwv_flow_imp.g_varchar2_table(38616) := '6C222C6973417474723A21307D2C7B6E616D653A226973426F6C64222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E616D653A2269734974616C6963222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E';
wwv_flow_imp.g_varchar2_table(38617) := '616D653A226973556E6465726C696E65222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E616D653A226973537472696B655468726F756768222C747970653A22426F6F6C65616E222C6973417474723A21307D5D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(38618) := '653A22506F696E74222C70726F706572746965733A5B7B6E616D653A2278222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A2279222C747970653A225265616C222C64656661756C743A223022';
wwv_flow_imp.g_varchar2_table(38619) := '2C6973417474723A21307D5D7D2C7B6E616D653A22426F756E6473222C70726F706572746965733A5B7B6E616D653A2278222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A2279222C74797065';
wwv_flow_imp.g_varchar2_table(38620) := '3A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A227769647468222C747970653A225265616C222C6973417474723A21307D2C7B6E616D653A22686569676874222C747970653A225265616C222C6973417474';
wwv_flow_imp.g_varchar2_table(38621) := '723A21307D5D7D5D2C6173736F63696174696F6E733A5B5D7D2C64693A7B6E616D653A224449222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F4449222C7072656669783A226469222C747970';
wwv_flow_imp.g_varchar2_table(38622) := '65733A5B7B6E616D653A224469616772616D456C656D656E74222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E67227D2C7B6E61';
wwv_flow_imp.g_varchar2_table(38623) := '6D653A22657874656E73696F6E222C747970653A22457874656E73696F6E227D2C7B6E616D653A226F776E696E674469616772616D222C747970653A224469616772616D222C6973526561644F6E6C793A21302C69735669727475616C3A21302C697352';
wwv_flow_imp.g_varchar2_table(38624) := '65666572656E63653A21307D2C7B6E616D653A226F776E696E67456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C';
wwv_flow_imp.g_varchar2_table(38625) := '7B6E616D653A226D6F64656C456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D2C7B6E616D653A227374796C65222C747970653A2253';
wwv_flow_imp.g_varchar2_table(38626) := '74796C65222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F776E6564456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E';
wwv_flow_imp.g_varchar2_table(38627) := '6C793A21302C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A224E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B224469616772616D456C656D656E74225D7D2C7B6E616D653A22456467';
wwv_flow_imp.g_varchar2_table(38628) := '65222C697341627374726163743A21302C7375706572436C6173733A5B224469616772616D456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365222C747970653A224469616772616D456C656D656E74222C69735265';
wwv_flow_imp.g_varchar2_table(38629) := '61644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A';
wwv_flow_imp.g_varchar2_table(38630) := '21302C69735265666572656E63653A21307D2C7B6E616D653A22776179706F696E74222C6973556E697175653A21312C69734D616E793A21302C747970653A2264633A506F696E74222C786D6C3A7B73657269616C697A653A227873693A74797065227D';
wwv_flow_imp.g_varchar2_table(38631) := '7D5D7D2C7B6E616D653A224469616772616D222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E67227D2C7B6E616D653A22726F6F';
wwv_flow_imp.g_varchar2_table(38632) := '74456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E';
wwv_flow_imp.g_varchar2_table(38633) := '616D653A22646F63756D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227265736F6C7574696F6E222C6973417474723A21302C747970653A225265616C227D2C7B6E616D653A226F776E656453';
wwv_flow_imp.g_varchar2_table(38634) := '74796C65222C747970653A225374796C65222C6973526561644F6E6C793A21302C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A225368617065222C697341627374726163743A21302C7375706572436C6173733A5B22';
wwv_flow_imp.g_varchar2_table(38635) := '4E6F6465225D2C70726F706572746965733A5B7B6E616D653A22626F756E6473222C747970653A2264633A426F756E6473227D5D7D2C7B6E616D653A22506C616E65222C697341627374726163743A21302C7375706572436C6173733A5B224E6F646522';
wwv_flow_imp.g_varchar2_table(38636) := '5D2C70726F706572746965733A5B7B6E616D653A22706C616E65456C656D656E74222C747970653A224469616772616D456C656D656E74222C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D';
wwv_flow_imp.g_varchar2_table(38637) := '656E74222C69734D616E793A21307D5D7D2C7B6E616D653A224C6162656C656445646765222C697341627374726163743A21302C7375706572436C6173733A5B2245646765225D2C70726F706572746965733A5B7B6E616D653A226F776E65644C616265';
wwv_flow_imp.g_varchar2_table(38638) := '6C222C747970653A224C6162656C222C6973526561644F6E6C793A21302C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D656E74222C69734D616E793A21302C69735669727475616C3A2130';
wwv_flow_imp.g_varchar2_table(38639) := '7D5D7D2C7B6E616D653A224C6162656C65645368617065222C697341627374726163743A21302C7375706572436C6173733A5B225368617065225D2C70726F706572746965733A5B7B6E616D653A226F776E65644C6162656C222C747970653A224C6162';
wwv_flow_imp.g_varchar2_table(38640) := '656C222C6973526561644F6E6C793A21302C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D656E74222C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A224C';
wwv_flow_imp.g_varchar2_table(38641) := '6162656C222C697341627374726163743A21302C7375706572436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22626F756E6473222C747970653A2264633A426F756E6473227D5D7D2C7B6E616D653A225374796C6522';
wwv_flow_imp.g_varchar2_table(38642) := '2C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22457874656E73696F6E222C70726F706572746965';
wwv_flow_imp.g_varchar2_table(38643) := '733A5B7B6E616D653A2276616C756573222C69734D616E793A21302C747970653A22456C656D656E74227D5D7D5D2C6173736F63696174696F6E733A5B5D2C786D6C3A7B746167416C6961733A226C6F77657243617365227D7D2C62696F633A7B6E616D';
wwv_flow_imp.g_varchar2_table(38644) := '653A2262706D6E2E696F20636F6C6F727320666F722042504D4E222C7572693A22687474703A2F2F62706D6E2E696F2F736368656D612F62706D6E2F62696F636F6C6F722F312E30222C7072656669783A2262696F63222C74797065733A5B7B6E616D65';
wwv_flow_imp.g_varchar2_table(38645) := '3A22436F6C6F7265645368617065222C657874656E64733A5B2262706D6E64693A42504D4E5368617065225D2C70726F706572746965733A5B7B6E616D653A227374726F6B65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E61';
wwv_flow_imp.g_varchar2_table(38646) := '6D653A2266696C6C222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F72656445646765222C657874656E64733A5B2262706D6E64693A42504D4E45646765225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(38647) := '6D653A227374726F6B65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2266696C6C222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D65726174696F6E733A5B5D2C6173736F6369';
wwv_flow_imp.g_varchar2_table(38648) := '6174696F6E733A5B5D7D2C636F6C6F723A7B6E616D653A2242504D4E20696E20436F6C6F72222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F6E6F6E2D6E6F726D61746976652F636F6C6F722F312E30222C7072';
wwv_flow_imp.g_varchar2_table(38649) := '656669783A22636F6C6F72222C74797065733A5B7B6E616D653A22436F6C6F7265644C6162656C222C657874656E64733A5B2262706D6E64693A42504D4E4C6162656C225D2C70726F706572746965733A5B7B6E616D653A22636F6C6F72222C69734174';
wwv_flow_imp.g_varchar2_table(38650) := '74723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F7265645368617065222C657874656E64733A5B2262706D6E64693A42504D4E5368617065225D2C70726F706572746965733A5B7B6E616D653A226261636B67726F75';
wwv_flow_imp.g_varchar2_table(38651) := '6E642D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22626F726465722D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F726564456467';
wwv_flow_imp.g_varchar2_table(38652) := '65222C657874656E64733A5B2262706D6E64693A42504D4E45646765225D2C70726F706572746965733A5B7B6E616D653A22626F726465722D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D65726174';
wwv_flow_imp.g_varchar2_table(38653) := '696F6E733A5B5D2C6173736F63696174696F6E733A5B5D7D7D3B66756E6374696F6E20566F28652C74297B72657475726E206E657720466F2828302C692E6B7029287B7D2C426F2C65292C74297D66756E6374696F6E207A6F2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(38654) := '653F223C222B652E24747970652B28652E69643F272069643D22272B652E69643A2222292B2722202F3E273A223C6E756C6C3E227D76617220486F3D22547269656420746F206163636573732064692066726F6D2074686520627573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(38655) := '6563742E2054686520646920697320617661696C61626C65207468726F75676820746865206469616772616D20656C656D656E74206F6E6C792E20466F72206D6F726520696E666F726D6174696F6E2C207365652068747470733A2F2F6769746875622E';
wwv_flow_imp.g_varchar2_table(38656) := '636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F31343732223B66756E6374696F6E20576F2865297B28302C692E7A792928652C22646922297C7C4F626A6563742E646566696E6550726F706572747928652C226469222C7B656E756D';
wwv_flow_imp.g_varchar2_table(38657) := '657261626C653A21312C6765743A66756E6374696F6E28297B7468726F77206E6577204572726F7228486F297D7D297D66756E6374696F6E206A6F28652C74297B72657475726E20652E24696E7374616E63654F662874297D66756E6374696F6E20716F';
wwv_flow_imp.g_varchar2_table(38658) := '2865297B76617220743D7B7D2C6E3D5B5D2C6F3D7B7D3B66756E6374696F6E207328652C74297B72657475726E2066756E6374696F6E286E297B65286E2C74297D7D66756E6374696F6E20722865297B745B652E69645D3D657D66756E6374696F6E2061';
wwv_flow_imp.g_varchar2_table(38659) := '28742C6E297B7472797B76617220693D6F5B742E69645D262666756E6374696F6E28742C6E297B696628742E676678297468726F77206E6577204572726F722860616C72656164792072656E646572656420247B7A6F2874297D60293B72657475726E20';
wwv_flow_imp.g_varchar2_table(38660) := '652E656C656D656E7428742C6F5B742E69645D2C6E297D28742C6E293B72657475726E20722874292C697D63617463682865297B6C28652E6D6573736167652C7B656C656D656E743A742C6572726F723A657D292C636F6E736F6C652E6572726F722860';
wwv_flow_imp.g_varchar2_table(38661) := '6661696C656420746F20696D706F727420247B7A6F2874297D602C65297D7D66756E6374696F6E206C28742C6E297B652E6572726F7228742C6E297D76617220633D746869732E726567697374657244693D66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(38662) := '652E62706D6E456C656D656E743B743F6F5B742E69645D3F6C28606D756C7469706C6520444920656C656D656E747320646566696E656420666F7220247B7A6F2874297D602C7B656C656D656E743A747D293A286F5B742E69645D3D652C576F28742929';
wwv_flow_imp.g_varchar2_table(38663) := '3A6C28606E6F2062706D6E456C656D656E74207265666572656E63656420696E20247B7A6F2865297D602C7B656C656D656E743A657D297D3B66756E6374696F6E20642865297B632865297D746869732E68616E646C65446566696E6974696F6E733D66';
wwv_flow_imp.g_varchar2_table(38664) := '756E6374696F6E28722C61297B76617220673D722E6469616772616D733B6966286126262D313D3D3D672E696E6465784F66286129297468726F77206E6577204572726F7228226469616772616D206E6F742070617274206F66203C62706D6E3A446566';
wwv_flow_imp.g_varchar2_table(38665) := '696E6974696F6E73202F3E22293B69662821612626672626672E6C656E677468262628613D675B305D292C2161297468726F77206E6577204572726F7228226E6F206469616772616D20746F20646973706C617922293B6F3D7B7D2C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38666) := '2865297B76617220743B743D652E706C616E652C632874292C28302C692E6A4A2928742E706C616E65456C656D656E742C64297D2861293B766172206D3D612E706C616E653B696628216D297468726F77206E6577204572726F7228606E6F20706C616E';
wwv_flow_imp.g_varchar2_table(38667) := '6520666F7220247B7A6F2861297D60293B76617220663D6D2E62706D6E456C656D656E743B6966282166297B696628663D66756E6374696F6E2865297B72657475726E28302C692E49362928652E726F6F74456C656D656E74732C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38668) := '2865297B72657475726E206A6F28652C2262706D6E3A50726F6365737322297C7C6A6F28652C2262706D6E3A436F6C6C61626F726174696F6E22297D29297D2872292C2166297468726F77206E6577204572726F7228226E6F2070726F63657373206F72';
wwv_flow_imp.g_varchar2_table(38669) := '20636F6C6C61626F726174696F6E20746F20646973706C617922293B6C2860636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E20247B7A6F286D297D20746F20247B7A6F2866297D60292C6D2E62706D6E456C656D656E';
wwv_flow_imp.g_varchar2_table(38670) := '743D662C63286D297D76617220762C5F2C793D66756E6374696F6E28742C6E297B72657475726E20652E726F6F7428742C6F5B742E69645D2C6E297D28662C6D293B6966286A6F28662C2262706D6E3A50726F6365737322297C7C6A6F28662C2262706D';
wwv_flow_imp.g_varchar2_table(38671) := '6E3A53756250726F636573732229297528662C79293B656C73657B696628216A6F28662C2262706D6E3A436F6C6C61626F726174696F6E2229297468726F77206E6577204572726F722860756E737570706F727465642062706D6E456C656D656E742066';
wwv_flow_imp.g_varchar2_table(38672) := '6F7220247B7A6F286D297D3A20247B7A6F2866297D60293B763D662C5F3D792C28302C692E6A4A2928762E7061727469636970616E74732C73286B2C5F29292C6228762E6172746966616374732C5F292C6E2E70757368282866756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(38673) := '2166756E6374696F6E28652C74297B28302C692E6A4A2928652C7328702C7429297D28762E6D657373616765466C6F77732C5F297D29292C66756E6374696F6E28652C6E297B766172206F3D28302C692E70622928652C2866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(38674) := '72657475726E21745B652E69645D26266A6F28652C2262706D6E3A50726F6365737322292626652E6C616E65536574737D29293B6F2E666F7245616368287328752C6E29297D28722E726F6F74456C656D656E74732C79297D68286E297D3B7661722068';
wwv_flow_imp.g_varchar2_table(38675) := '3D746869732E68616E646C6544656665727265643D66756E6374696F6E28297B666F72283B6E2E6C656E6774683B296E2E7368696674282928297D3B66756E6374696F6E207528652C74297B7828652C74292C5F28652E696F5370656369666963617469';
wwv_flow_imp.g_varchar2_table(38676) := '6F6E2C74292C6228652E6172746966616374732C74292C722865297D66756E6374696F6E207028652C74297B6128652C74297D66756E6374696F6E206728652C74297B6128652C74297D66756E6374696F6E206D28652C74297B6128652C74297D66756E';
wwv_flow_imp.g_varchar2_table(38677) := '6374696F6E206628652C74297B6128652C74297D66756E6374696F6E207628652C74297B6128652C74297D66756E6374696F6E206228652C74297B28302C692E6A4A2928652C2866756E6374696F6E2865297B6A6F28652C2262706D6E3A4173736F6369';
wwv_flow_imp.g_varchar2_table(38678) := '6174696F6E22293F6E2E70757368282866756E6374696F6E28297B7628652C74297D29293A7628652C74297D29297D66756E6374696F6E205F28652C74297B6526262828302C692E6A4A2928652E64617461496E707574732C73286D2C7429292C28302C';
wwv_flow_imp.g_varchar2_table(38679) := '692E6A4A2928652E646174614F7574707574732C7328662C742929297D76617220793D746869732E68616E646C6553756250726F636573733D66756E6374696F6E28652C74297B7828652C74292C6228652E6172746966616374732C74297D3B66756E63';
wwv_flow_imp.g_varchar2_table(38680) := '74696F6E207728652C74297B766172206F3D6128652C74293B6A6F28652C2262706D6E3A53756250726F63657373222926267928652C6F7C7C74292C6A6F28652C2262706D6E3A4163746976697479222926265F28652E696F5370656369666963617469';
wwv_flow_imp.g_varchar2_table(38681) := '6F6E2C74292C6E2E70757368282866756E6374696F6E28297B28302C692E6A4A2928652E64617461496E7075744173736F63696174696F6E732C7328672C7429292C28302C692E6A4A2928652E646174614F75747075744173736F63696174696F6E732C';
wwv_flow_imp.g_varchar2_table(38682) := '7328672C7429297D29297D66756E6374696F6E204328652C74297B6E2E70757368282866756E6374696F6E28297B766172206E3D6128652C74293B652E6368696C644C616E6553657426265328652E6368696C644C616E655365742C6E7C7C74292C6675';
wwv_flow_imp.g_varchar2_table(38683) := '6E6374696F6E2865297B28302C692E6A4A2928652E666C6F774E6F64655265662C2866756E6374696F6E2874297B766172206E3D742E67657428226C616E657322293B6E26266E2E707573682865297D29297D2865297D29297D66756E6374696F6E2053';
wwv_flow_imp.g_varchar2_table(38684) := '28652C74297B28302C692E6A4A2928652E6C616E65732C7328432C7429297D66756E6374696F6E207828652C74297B2166756E6374696F6E28652C74297B28302C692E6A4A2928652C2866756E6374696F6E2865297B6A6F28652C2262706D6E3A536571';
wwv_flow_imp.g_varchar2_table(38685) := '75656E6365466C6F7722293F6E2E70757368282866756E6374696F6E28297B2166756E6374696F6E28652C74297B6128652C74297D28652C74297D29293A6A6F28652C2262706D6E3A426F756E646172794576656E7422293F6E2E756E73686966742828';
wwv_flow_imp.g_varchar2_table(38686) := '66756E6374696F6E28297B7728652C74297D29293A6A6F28652C2262706D6E3A466C6F774E6F646522293F7728652C74293A6A6F28652C2262706D6E3A446174614F626A65637422297C7C286A6F28652C2262706D6E3A4461746153746F726552656665';
wwv_flow_imp.g_varchar2_table(38687) := '72656E636522297C7C6A6F28652C2262706D6E3A446174614F626A6563745265666572656E636522293F66756E6374696F6E28652C74297B6128652C74297D28652C74293A6C2860756E7265636F676E697A656420666C6F77456C656D656E7420247B7A';
wwv_flow_imp.g_varchar2_table(38688) := '6F2865297D20696E20636F6E7465787420247B7A6F28742626742E627573696E6573734F626A656374297D602C7B656C656D656E743A652C636F6E746578743A747D29297D29297D28652E666C6F77456C656D656E74732C74292C652E6C616E65536574';
wwv_flow_imp.g_varchar2_table(38689) := '73262666756E6374696F6E28652C74297B28302C692E6A4A2928652C7328532C7429297D28652E6C616E65536574732C74297D66756E6374696F6E206B28652C74297B766172206E3D6128652C74292C693D652E70726F636573735265663B6926267528';
wwv_flow_imp.g_varchar2_table(38690) := '692C6E7C7C74297D7D66756E6374696F6E20246F28652C742C6E297B766172206F2C732C722C613D5B5D3B66756E6374696F6E206C28652C74297B766172206E3D6E657720716F287B726F6F743A66756E6374696F6E28652C74297B72657475726E206F';
wwv_flow_imp.g_varchar2_table(38691) := '2E61646428652C74297D2C656C656D656E743A66756E6374696F6E28652C742C6E297B72657475726E206F2E61646428652C742C6E297D2C6572726F723A66756E6374696F6E28652C74297B612E70757368287B6D6573736167653A652C636F6E746578';
wwv_flow_imp.g_varchar2_table(38692) := '743A747D297D7D293B743D747C7C652E6469616772616D732626652E6469616772616D735B305D3B76617220733D66756E6374696F6E28652C74297B696628742626742E706C616E65297B766172206E2C6F3D742E706C616E652E62706D6E456C656D65';
wwv_flow_imp.g_varchar2_table(38693) := '6E742C733D6F3B28302C792E697329286F2C2262706D6E3A50726F6365737322297C7C28302C792E697329286F2C2262706D6E3A436F6C6C61626F726174696F6E22297C7C28733D66756E6374696F6E2865297B666F722876617220743D653B743B297B';
wwv_flow_imp.g_varchar2_table(38694) := '69662828302C792E69732928742C2262706D6E3A50726F6365737322292972657475726E20743B743D742E24706172656E747D7D286F29292C6E3D28302C792E69732928732C2262706D6E3A436F6C6C61626F726174696F6E22293F733A28302C692E49';
wwv_flow_imp.g_varchar2_table(38695) := '362928652E726F6F74456C656D656E74732C2866756E6374696F6E2865297B69662828302C792E69732928652C2262706D6E3A436F6C6C61626F726174696F6E22292972657475726E28302C692E49362928652E7061727469636970616E74732C286675';
wwv_flow_imp.g_varchar2_table(38696) := '6E6374696F6E2865297B72657475726E20652E70726F636573735265663D3D3D737D29297D29293B76617220723D5B735D3B6E262628723D28302C692E546A29286E2E7061727469636970616E74732C2866756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(38697) := '652E70726F636573735265667D2929292E70757368286E293B76617220613D556F2872292C6C3D5B745D2C633D5B6F5D3B72657475726E28302C692E6A4A2928652E6469616772616D732C2866756E6374696F6E2865297B696628652E706C616E65297B';
wwv_flow_imp.g_varchar2_table(38698) := '76617220743D652E706C616E652E62706D6E456C656D656E743B2D31213D3D612E696E6465784F6628742926262D313D3D3D632E696E6465784F662874292626286C2E707573682865292C632E70757368287429297D7D29292C6C7D7D28652C74293B69';
wwv_flow_imp.g_varchar2_table(38699) := '66282173297468726F77206E6577204572726F7228226E6F206469616772616D20746F20646973706C617922293B28302C692E6A4A2928732C2866756E6374696F6E2874297B6E2E68616E646C65446566696E6974696F6E7328652C74297D29293B7661';
wwv_flow_imp.g_varchar2_table(38700) := '72206C3D742E706C616E652E62706D6E456C656D656E742E69643B722E736574526F6F74456C656D656E7428722E66696E64526F6F74286C2B225F706C616E6522297C7C722E66696E64526F6F74286C29297D72657475726E206E65772050726F6D6973';
wwv_flow_imp.g_varchar2_table(38701) := '65282866756E6374696F6E28692C63297B7472797B72657475726E206F3D652E676574282262706D6E496D706F7274657222292C733D652E67657428226576656E7442757322292C723D652E676574282263616E76617322292C732E666972652822696D';
wwv_flow_imp.g_varchar2_table(38702) := '706F72742E72656E6465722E7374617274222C7B646566696E6974696F6E733A747D292C6C28742C6E292C732E666972652822696D706F72742E72656E6465722E636F6D706C657465222C7B6572726F723A766F696420302C7761726E696E67733A617D';
wwv_flow_imp.g_varchar2_table(38703) := '292C69287B7761726E696E67733A617D297D63617463682865297B72657475726E20652E7761726E696E67733D612C632865297D7D29297D66756E6374696F6E20556F2865297B76617220743D5B5D3B72657475726E28302C692E6A4A2928652C286675';
wwv_flow_imp.g_varchar2_table(38704) := '6E6374696F6E2865297B65262628742E707573682865292C743D742E636F6E63617428556F28652E666C6F77456C656D656E74732929297D29292C747D766172204B6F2C476F3D273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72';
wwv_flow_imp.g_varchar2_table(38705) := '672F323030302F737667222076696577426F783D223020302031342E303220352E3537222077696474683D22353322206865696768743D223231223E3C706174682066696C6C3D2263757272656E74436F6C6F722220643D224D312E38382E3932762E31';
wwv_flow_imp.g_varchar2_table(38706) := '346330202E34312D2E31332E36382D2E342E382E33332E31342E34362E34342E34362E3836762E33336330202E36312D2E33332E39352D2E39352E393548305630682E3935632E36352030202E39332E332E39332E39327A4D2E36332E353776312E3036';
wwv_flow_imp.g_varchar2_table(38707) := '682E3234632E32342030202E33382D2E312E33382D2E3433562E393863302D2E32382D2E312D2E342D2E33322D2E347A6D3020312E363376312E3232682E3336632E322030202E33322D2E312E33322D2E3339762D2E333563302D2E33372D2E31322D2E';
wwv_flow_imp.g_varchar2_table(38708) := '34382D2E342D2E3438482E36337A4D342E31382E3939762E35326330202E36342D2E33312E39382D2E39342E3938682D2E335634682D2E36325630682E3932632E36332030202E39342E33352E39342E39397A4D322E39342E353776312E3335682E3363';
wwv_flow_imp.g_varchar2_table(38709) := '2E322030202E332D2E30392E332D2E3337762D2E3663302D2E32392D2E312D2E33382D2E332D2E3338682D2E337A6D322E383920322E32374C362E32352030682E38387634682D2E3656312E31324C362E3120332E3939682D2E366C2D2E34362D322E38';
wwv_flow_imp.g_varchar2_table(38710) := '3276322E3832682D2E35355630682E38377A4D382E313420312E315634682D2E35365630682E37394C3920322E345630682E35367634682D2E36347A6D322E343920322E3239762E36682D2E36762D2E367A4D31322E3132203163302D2E36332E33332D';
wwv_flow_imp.g_varchar2_table(38711) := '31202E39352D31202E36312030202E39352E33372E3935203176322E30346330202E36342D2E333420312D2E393520312D2E363220302D2E39352D2E33372D2E39352D317A6D2E363220322E30386330202E32382E31332E33392E33332E3339732E3332';
wwv_flow_imp.g_varchar2_table(38712) := '2D2E312E33322D2E34562E393863302D2E32392D2E31322D2E342D2E33322D2E34732D2E33332E31312D2E33332E347A222F3E3C706174682066696C6C3D2263757272656E74436F6C6F722220643D224D3020342E35336831342E303276312E30344830';
wwv_flow_imp.g_varchar2_table(38713) := '7A4D31312E30382030682E3633762E3632682D2E36337A6D2E363320345631682D2E363376322E39387A222F3E3C2F7376673E272C516F3D7B766572746963616C416C69676E3A226D6964646C65227D2C596F3D7B636F6C6F723A222334303430343022';
wwv_flow_imp.g_varchar2_table(38714) := '7D2C5A6F3D7B7A496E6465783A2231303031222C706F736974696F6E3A226669786564222C746F703A2230222C6C6566743A2230222C72696768743A2230222C626F74746F6D3A2230227D2C586F3D7B77696474683A2231303025222C6865696768743A';
wwv_flow_imp.g_varchar2_table(38715) := '2231303025222C6261636B67726F756E643A22726762612834302C34302C34302C302E3229227D2C4A6F3D7B706F736974696F6E3A226162736F6C757465222C6C6566743A22353025222C746F703A22343025222C7472616E73666F726D3A227472616E';
wwv_flow_imp.g_varchar2_table(38716) := '736C617465282D35302529222C77696474683A223236307078222C70616464696E673A2231307078222C6261636B67726F756E643A227768697465222C626F78536861646F773A22302031707820347078207267626128302C302C302C302E3329222C66';
wwv_flow_imp.g_varchar2_table(38717) := '6F6E7446616D696C793A2248656C7665746963612C20417269616C2C2073616E732D7365726966222C666F6E7453697A653A2231347078222C646973706C61793A22666C6578222C6C696E654865696768743A22312E33227D2C65733D273C6469762063';
wwv_flow_imp.g_varchar2_table(38718) := '6C6173733D22626A732D706F77657265642D62792D6C69676874626F78223E3C64697620636C6173733D226261636B64726F70223E3C2F6469763E3C64697620636C6173733D226E6F74696365223E3C6120687265663D2268747470733A2F2F62706D6E';
wwv_flow_imp.g_varchar2_table(38719) := '2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E65722220636C6173733D226C696E6B223E272B476F2B273C2F613E3C7370616E3E5765622D626173656420746F6F6C696E6720666F722042504D4E2C20444D4E20616E64';
wwv_flow_imp.g_varchar2_table(38720) := '20666F726D7320706F7765726564206279203C6120687265663D2268747470733A2F2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E6572223E62706D6E2E696F3C2F613E2E3C2F7370616E3E3C2F6469763E';
wwv_flow_imp.g_varchar2_table(38721) := '3C2F6469763E273B66756E6374696F6E2074732865297B653D28302C692E6B7029287B7D2C69732C65292C746869732E5F6D6F64646C653D746869732E5F6372656174654D6F64646C652865292C746869732E5F636F6E7461696E65723D746869732E5F';
wwv_flow_imp.g_varchar2_table(38722) := '637265617465436F6E7461696E65722865292C66756E6374696F6E2865297B636F6E737420743D636528273C6120687265663D22687474703A2F2F62706D6E2E696F22207461726765743D225F626C616E6B2220636C6173733D22626A732D706F776572';
wwv_flow_imp.g_varchar2_table(38723) := '65642D627922207469746C653D22506F77657265642062792062706D6E2E696F22203E272B476F2B223C2F613E22293B472864652822737667222C74292C516F292C4728742C596F2C7B706F736974696F6E3A226162736F6C757465222C626F74746F6D';
wwv_flow_imp.g_varchar2_table(38724) := '3A2231357078222C72696768743A2231357078222C7A496E6465783A22313030227D292C652E617070656E644368696C642874292C6F652E62696E6428742C22636C69636B222C2866756E6374696F6E2865297B4B6F7C7C2847284B6F3D636528657329';
wwv_flow_imp.g_varchar2_table(38725) := '2C5A6F292C472864652822737667222C4B6F292C516F292C4728646528222E6261636B64726F70222C4B6F292C586F292C4728646528222E6E6F74696365222C4B6F292C4A6F292C4728646528222E6C696E6B222C4B6F292C596F2C7B6D617267696E3A';
wwv_flow_imp.g_varchar2_table(38726) := '2231357078203230707820313570782031307078222C616C69676E53656C663A2263656E746572227D292C72652E62696E64284B6F2C222E6261636B64726F70222C22636C69636B222C2866756E6374696F6E2865297B646F63756D656E742E626F6479';
wwv_flow_imp.g_varchar2_table(38727) := '2E72656D6F76654368696C64284B6F297D2929292C646F63756D656E742E626F64792E617070656E644368696C64284B6F292C652E70726576656E7444656661756C7428297D29297D28746869732E5F636F6E7461696E6572292C746869732E5F696E69';
wwv_flow_imp.g_varchar2_table(38728) := '7428746869732E5F636F6E7461696E65722C746869732E5F6D6F64646C652C65297D66756E6374696F6E206E7328652C74297B72657475726E20652E7761726E696E67733D742C657D522874732C5369292C74732E70726F746F747970652E696D706F72';
wwv_flow_imp.g_varchar2_table(38729) := '74584D4C3D6173796E632066756E6374696F6E28652C74297B636F6E7374206E3D746869733B6C657420693D5B5D3B7472797B6C657420733B653D746869732E5F656D69742822696D706F72742E70617273652E7374617274222C7B786D6C3A657D297C';
wwv_flow_imp.g_varchar2_table(38730) := '7C653B7472797B733D617761697420746869732E5F6D6F64646C652E66726F6D584D4C28652C2262706D6E3A446566696E6974696F6E7322297D63617463682865297B7468726F7720746869732E5F656D69742822696D706F72742E70617273652E636F';
wwv_flow_imp.g_varchar2_table(38731) := '6D706C657465222C7B6572726F723A657D292C657D6C657420723D732E726F6F74456C656D656E743B636F6E737420613D732E7265666572656E6365732C6C3D732E7761726E696E67732C633D732E656C656D656E7473427949643B693D692E636F6E63';
wwv_flow_imp.g_varchar2_table(38732) := '6174286C292C723D746869732E5F656D69742822696D706F72742E70617273652E636F6D706C657465222C286F3D7B6572726F723A6E756C6C2C646566696E6974696F6E733A722C656C656D656E7473427949643A632C7265666572656E6365733A612C';
wwv_flow_imp.g_varchar2_table(38733) := '7761726E696E67733A697D2C6E2E67657428226576656E7442757322292E6372656174654576656E74286F2929297C7C723B636F6E737420643D617761697420746869732E696D706F7274446566696E6974696F6E7328722C74293B72657475726E2069';
wwv_flow_imp.g_varchar2_table(38734) := '3D692E636F6E63617428642E7761726E696E6773292C746869732E5F656D69742822696D706F72742E646F6E65222C7B6572726F723A6E756C6C2C7761726E696E67733A697D292C7B7761726E696E67733A697D7D63617463682865297B6C657420743D';
wwv_flow_imp.g_varchar2_table(38735) := '653B7468726F7720693D692E636F6E63617428742E7761726E696E67737C7C5B5D292C6E7328742C69292C743D66756E6374696F6E2865297B636F6E737420743D2F756E7061727361626C6520636F6E74656E74203C285B5E3E5D2B293E206465746563';
wwv_flow_imp.g_varchar2_table(38736) := '746564285B5C735C535D2A29242F2E6578656328652E6D657373616765293B72657475726E2074262628652E6D6573736167653D22756E7061727361626C6520636F6E74656E74203C222B745B315D2B223E2064657465637465643B2074686973206D61';
wwv_flow_imp.g_varchar2_table(38737) := '7920696E64696361746520616E20696E76616C69642042504D4E20322E30206469616772616D2066696C65222B745B325D292C657D2874292C746869732E5F656D69742822696D706F72742E646F6E65222C7B6572726F723A742C7761726E696E67733A';
wwv_flow_imp.g_varchar2_table(38738) := '742E7761726E696E67737D292C747D766172206F7D2C74732E70726F746F747970652E696D706F7274446566696E6974696F6E733D6173796E632066756E6374696F6E28652C74297B72657475726E20746869732E5F736574446566696E6974696F6E73';
wwv_flow_imp.g_varchar2_table(38739) := '2865292C7B7761726E696E67733A28617761697420746869732E6F70656E287429292E7761726E696E67737D7D2C74732E70726F746F747970652E6F70656E3D6173796E632066756E6374696F6E2865297B636F6E737420743D746869732E5F64656669';
wwv_flow_imp.g_varchar2_table(38740) := '6E6974696F6E733B6C6574206E3D653B6966282174297B636F6E737420653D6E6577204572726F7228226E6F20584D4C20696D706F7274656422293B7468726F77206E7328652C5B5D292C657D69662822737472696E67223D3D747970656F6620652626';
wwv_flow_imp.g_varchar2_table(38741) := '286E3D66756E6374696F6E28652C74297B72657475726E2074262628302C692E49362928652E6469616772616D732C2866756E6374696F6E2865297B72657475726E20652E69643D3D3D747D29297C7C6E756C6C7D28742C65292C216E29297B636F6E73';
wwv_flow_imp.g_varchar2_table(38742) := '7420743D6E6577204572726F72282242504D4E4469616772616D203C222B652B223E206E6F7420666F756E6422293B7468726F77206E7328742C5B5D292C747D7472797B746869732E636C65617228297D63617463682865297B7468726F77206E732865';
wwv_flow_imp.g_varchar2_table(38743) := '2C5B5D292C657D636F6E73747B7761726E696E67733A6F7D3D617761697420246F28746869732C742C6E293B72657475726E7B7761726E696E67733A6F7D7D2C74732E70726F746F747970652E73617665584D4C3D6173796E632066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(38744) := '65297B653D657C7C7B7D3B6C657420742C6E2C693D746869732E5F646566696E6974696F6E733B7472797B6966282169297468726F77206E6577204572726F7228226E6F20646566696E6974696F6E73206C6F6164656422293B693D746869732E5F656D';
wwv_flow_imp.g_varchar2_table(38745) := '6974282273617665584D4C2E7374617274222C7B646566696E6974696F6E733A697D297C7C692C6E3D28617761697420746869732E5F6D6F64646C652E746F584D4C28692C6529292E786D6C2C6E3D746869732E5F656D6974282273617665584D4C2E73';
wwv_flow_imp.g_varchar2_table(38746) := '657269616C697A6564222C7B786D6C3A6E7D297C7C6E7D63617463682865297B743D657D636F6E7374206F3D743F7B6572726F723A747D3A7B786D6C3A6E7D3B696628746869732E5F656D6974282273617665584D4C2E646F6E65222C6F292C74297468';
wwv_flow_imp.g_varchar2_table(38747) := '726F7720743B72657475726E206F7D2C74732E70726F746F747970652E736176655356473D6173796E632066756E6374696F6E28297B6C657420652C743B746869732E5F656D69742822736176655356472E737461727422293B7472797B636F6E737420';
wwv_flow_imp.g_varchar2_table(38748) := '743D746869732E676574282263616E76617322292C6E3D742E6765744163746976654C6179657228292C693D646528223A73636F7065203E2064656673222C742E5F737667292C6F3D4F65286E292C733D693F223C646566733E222B4F652869292B223C';
wwv_flow_imp.g_varchar2_table(38749) := '2F646566733E223A22222C723D6E2E67657442426F7828293B653D273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D227574662D38223F3E5C6E5C783363212D2D206372656174656420776974682062706D6E2D6A73202F2068';
wwv_flow_imp.g_varchar2_table(38750) := '7474703A2F2F62706D6E2E696F202D2D5C7833655C6E3C21444F435459504520737667205055424C494320222D2F2F5733432F2F4454442053564720312E312F2F454E222022687474703A2F2F7777772E77332E6F72672F47726170686963732F535647';
wwv_flow_imp.g_varchar2_table(38751) := '2F312E312F4454442F73766731312E647464223E5C6E3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220786D6C6E733A786C696E6B3D22687474703A2F2F7777772E77332E6F72672F313939392F786C';
wwv_flow_imp.g_varchar2_table(38752) := '696E6B222077696474683D22272B722E77696474682B2722206865696768743D22272B722E6865696768742B27222076696577426F783D22272B722E782B2220222B722E792B2220222B722E77696474682B2220222B722E6865696768742B2722207665';
wwv_flow_imp.g_varchar2_table(38753) := '7273696F6E3D22312E31223E272B732B6F2B223C2F7376673E227D63617463682865297B743D657D696628746869732E5F656D69742822736176655356472E646F6E65222C7B6572726F723A742C7376673A657D292C74297468726F7720743B72657475';
wwv_flow_imp.g_varchar2_table(38754) := '726E7B7376673A657D7D2C74732E70726F746F747970652E5F736574446566696E6974696F6E733D66756E6374696F6E2865297B746869732E5F646566696E6974696F6E733D657D2C74732E70726F746F747970652E6765744D6F64756C65733D66756E';
wwv_flow_imp.g_varchar2_table(38755) := '6374696F6E28297B72657475726E20746869732E5F6D6F64756C65737D2C74732E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E676574446566696E6974696F6E732829262653692E70726F746F747970652E636C6561';
wwv_flow_imp.g_varchar2_table(38756) := '722E63616C6C2874686973297D2C74732E70726F746F747970652E64657374726F793D66756E6374696F6E28297B76617220653B53692E70726F746F747970652E64657374726F792E63616C6C2874686973292C28653D746869732E5F636F6E7461696E';
wwv_flow_imp.g_varchar2_table(38757) := '6572292E706172656E744E6F64652626652E706172656E744E6F64652E72656D6F76654368696C642865297D2C74732E70726F746F747970652E6F6E3D66756E6374696F6E28652C742C6E2C69297B72657475726E20746869732E67657428226576656E';
wwv_flow_imp.g_varchar2_table(38758) := '7442757322292E6F6E28652C742C6E2C69297D2C74732E70726F746F747970652E6F66663D66756E6374696F6E28652C74297B746869732E67657428226576656E7442757322292E6F666628652C74297D2C74732E70726F746F747970652E6174746163';
wwv_flow_imp.g_varchar2_table(38759) := '68546F3D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F722822706172656E744E6F646520726571756972656422293B746869732E64657461636828292C652E6765742626652E636F6E7374727563746F722E70726F74';
wwv_flow_imp.g_varchar2_table(38760) := '6F747970652E6A7175657279262628653D652E676574283029292C22737472696E67223D3D747970656F662065262628653D6465286529292C652E617070656E644368696C6428746869732E5F636F6E7461696E6572292C746869732E5F656D69742822';
wwv_flow_imp.g_varchar2_table(38761) := '617474616368222C7B7D292C746869732E676574282263616E76617322292E726573697A656428297D2C74732E70726F746F747970652E676574446566696E6974696F6E733D66756E6374696F6E28297B72657475726E20746869732E5F646566696E69';
wwv_flow_imp.g_varchar2_table(38762) := '74696F6E737D2C74732E70726F746F747970652E6465746163683D66756E6374696F6E28297B636F6E737420653D746869732E5F636F6E7461696E65722C743D652E706172656E744E6F64653B74262628746869732E5F656D6974282264657461636822';
wwv_flow_imp.g_varchar2_table(38763) := '2C7B7D292C742E72656D6F76654368696C64286529297D2C74732E70726F746F747970652E5F696E69743D66756E6374696F6E28652C742C6E297B636F6E7374206F3D6E2E6D6F64756C65737C7C746869732E6765744D6F64756C6573286E292C733D6E';
wwv_flow_imp.g_varchar2_table(38764) := '2E6164646974696F6E616C4D6F64756C65737C7C5B5D2C723D5B5D2E636F6E636174285B7B62706D6E6A733A5B2276616C7565222C746869735D2C6D6F64646C653A5B2276616C7565222C745D7D5D2C6F2C73292C613D28302C692E6B70292828302C69';
wwv_flow_imp.g_varchar2_table(38765) := '2E634A29286E2C5B226164646974696F6E616C4D6F64756C6573225D292C7B63616E7661733A28302C692E6B7029287B7D2C6E2E63616E7661732C7B636F6E7461696E65723A657D292C6D6F64756C65733A727D293B53692E63616C6C28746869732C61';
wwv_flow_imp.g_varchar2_table(38766) := '292C6E26266E2E636F6E7461696E65722626746869732E617474616368546F286E2E636F6E7461696E6572297D2C74732E70726F746F747970652E5F656D69743D66756E6374696F6E28652C74297B72657475726E20746869732E67657428226576656E';
wwv_flow_imp.g_varchar2_table(38767) := '7442757322292E6669726528652C74297D2C74732E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E6374696F6E2865297B636F6E737420743D636528273C64697620636C6173733D22626A732D636F6E7461696E6572223E3C';
wwv_flow_imp.g_varchar2_table(38768) := '2F6469763E27293B72657475726E204728742C7B77696474683A6F7328652E7769647468292C6865696768743A6F7328652E686569676874292C706F736974696F6E3A652E706F736974696F6E7D292C747D2C74732E70726F746F747970652E5F637265';
wwv_flow_imp.g_varchar2_table(38769) := '6174654D6F64646C653D66756E6374696F6E2865297B72657475726E206E657720566F2828302C692E6B7029287B7D2C746869732E5F6D6F64646C65457874656E73696F6E732C652E6D6F64646C65457874656E73696F6E7329297D2C74732E70726F74';
wwv_flow_imp.g_varchar2_table(38770) := '6F747970652E5F6D6F64756C65733D5B5D3B636F6E73742069733D7B77696474683A2231303025222C6865696768743A2231303025222C706F736974696F6E3A2272656C6174697665227D3B66756E6374696F6E206F732865297B72657475726E20652B';
wwv_flow_imp.g_varchar2_table(38771) := '2828302C692E4574292865293F227078223A2222297D66756E6374696F6E2073732865297B74732E63616C6C28746869732C65292C746869732E6F6E2822696D706F72742E70617273652E636F6D706C657465222C2866756E6374696F6E2865297B652E';
wwv_flow_imp.g_varchar2_table(38772) := '6572726F727C7C746869732E5F636F6C6C65637449647328652E646566696E6974696F6E732C652E656C656D656E747342794964297D292C74686973292C746869732E6F6E28226469616772616D2E64657374726F79222C2866756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(38773) := '746869732E67657428226D6F64646C6522292E6964732E636C65617228297D292C74686973297D522873732C7473292C73732E70726F746F747970652E5F6372656174654D6F64646C653D66756E6374696F6E2865297B76617220743D74732E70726F74';
wwv_flow_imp.g_varchar2_table(38774) := '6F747970652E5F6372656174654D6F64646C652E63616C6C28746869732C65293B72657475726E20742E6964733D6E6577207A285B33322C33362C315D292C747D2C73732E70726F746F747970652E5F636F6C6C6563744964733D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(38775) := '652C74297B766172206E2C693D652E246D6F64656C2E6964733B666F72286E20696E20692E636C65617228292C7429692E636C61696D286E2C745B6E5D297D3B7661722072733D6F2831313032292C61733D7B77696474683A39302C6865696768743A32';
wwv_flow_imp.g_varchar2_table(38776) := '307D2C6C733D31353B66756E6374696F6E2063732865297B72657475726E28302C792E69732928652C2262706D6E3A4576656E7422297C7C28302C792E69732928652C2262706D6E3A4761746577617922297C7C28302C792E69732928652C2262706D6E';
wwv_flow_imp.g_varchar2_table(38777) := '3A4461746153746F72655265666572656E636522297C7C28302C792E69732928652C2262706D6E3A446174614F626A6563745265666572656E636522297C7C28302C792E69732928652C2262706D6E3A44617461496E70757422297C7C28302C792E6973';
wwv_flow_imp.g_varchar2_table(38778) := '2928652C2262706D6E3A446174614F757470757422297C7C28302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722297C7C28302C792E69732928652C2262706D6E3A4D657373616765466C6F7722297C7C28302C792E69732928652C';
wwv_flow_imp.g_varchar2_table(38779) := '2262706D6E3A47726F757022297D66756E6374696F6E2064732865297B72657475726E20526E28652E6C6162656C297D66756E6374696F6E2068732865297B72657475726E20652E776179706F696E74733F66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(38780) := '652E6C656E6774682F322D312C6E3D655B4D6174682E666C6F6F722874295D2C693D655B4D6174682E6365696C28742B2E3031295D2C6F3D66756E6374696F6E2865297B76617220743D652E6C656E6774682F322D312C6E3D655B4D6174682E666C6F6F';
wwv_flow_imp.g_varchar2_table(38781) := '722874295D2C693D655B4D6174682E6365696C28742B2E3031295D3B72657475726E7B783A6E2E782B28692E782D6E2E78292F322C793A6E2E792B28692E792D6E2E79292F327D7D2865292C733D4D6174682E6174616E2828692E792D6E2E79292F2869';
wwv_flow_imp.g_varchar2_table(38782) := '2E782D6E2E7829292C723D6F2E782C613D6F2E793B72657475726E204D6174682E6162732873293C4D6174682E50492F323F612D3D6C733A722B3D6C732C7B783A722C793A617D7D28652E776179706F696E7473293A28302C792E69732928652C226270';
wwv_flow_imp.g_varchar2_table(38783) := '6D6E3A47726F757022293F7B783A652E782B652E77696474682F322C793A652E792B61732E6865696768742F327D3A7B783A652E782B652E77696474682F322C793A652E792B652E6865696768742B61732E6865696768742F327D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(38784) := '2075732865297B72657475726E28302C792E69732928652C2262706D6E3A466C6F77456C656D656E7422297C7C28302C792E69732928652C2262706D6E3A5061727469636970616E7422297C7C28302C792E69732928652C2262706D6E3A4C616E652229';
wwv_flow_imp.g_varchar2_table(38785) := '7C7C28302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722297C7C28302C792E69732928652C2262706D6E3A4D657373616765466C6F7722297C7C28302C792E69732928652C2262706D6E3A44617461496E70757422297C7C28302C';
wwv_flow_imp.g_varchar2_table(38786) := '792E69732928652C2262706D6E3A446174614F757470757422293F226E616D65223A28302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E22293F2274657874223A28302C792E69732928652C2262706D6E3A47726F757022293F';
wwv_flow_imp.g_varchar2_table(38787) := '2263617465676F727956616C7565526566223A766F696420307D66756E6374696F6E2070732865297B76617220743D652E627573696E6573734F626A6563742C6E3D75732874293B6966286E2972657475726E2263617465676F727956616C7565526566';
wwv_flow_imp.g_varchar2_table(38788) := '223D3D3D6E3F66756E6374696F6E2865297B76617220743D652E63617465676F727956616C75655265663B72657475726E20742626742E76616C75657C7C22227D2874293A745B6E5D7C7C22227D7661722067733D2268736C283232352C203130252C20';
wwv_flow_imp.g_varchar2_table(38789) := '31352529222C6D733D227768697465223B66756E6374696F6E20667328652C74297B72657475726E28302C692E7A4E2928652E6576656E74446566696E6974696F6E732C2866756E6374696F6E2865297B72657475726E20652E24747970653D3D3D747D';
wwv_flow_imp.g_varchar2_table(38790) := '29297D66756E6374696F6E20767328652C742C6E297B76617220693D28302C792E6765744469292865293B72657475726E206E7C7C692E6765742822636F6C6F723A6261636B67726F756E642D636F6C6F7222297C7C692E676574282262696F633A6669';
wwv_flow_imp.g_varchar2_table(38791) := '6C6C22297C7C747C7C6D737D66756E6374696F6E20627328652C742C6E297B76617220693D28302C792E6765744469292865293B72657475726E206E7C7C692E6765742822636F6C6F723A626F726465722D636F6C6F7222297C7C692E67657428226269';
wwv_flow_imp.g_varchar2_table(38792) := '6F633A7374726F6B6522297C7C747C7C67737D66756E6374696F6E205F7328652C742C6E2C69297B766172206F3D28302C792E6765744469292865292E67657428226C6162656C22293B72657475726E20697C7C6F26266F2E6765742822636F6C6F723A';
wwv_flow_imp.g_varchar2_table(38793) := '636F6C6F7222297C7C747C7C627328652C6E297D66756E6374696F6E20797328652C743D7B7D297B72657475726E7B77696474683A777328652C74292C6865696768743A437328652C74297D7D66756E6374696F6E20777328652C743D7B7D297B726574';
wwv_flow_imp.g_varchar2_table(38794) := '75726E28302C692E7A792928742C22776964746822293F742E77696474683A652E77696474687D66756E6374696F6E20437328652C743D7B7D297B72657475726E28302C692E7A792928742C2268656967687422293F742E6865696768743A652E686569';
wwv_flow_imp.g_varchar2_table(38795) := '6768747D7661722053733D6E6577207A2C78733D2E39353B66756E6374696F6E206B7328652C742C6E2C6F2C732C722C61297B59652E63616C6C28746869732C742C61293B766172206C3D652626652E64656661756C7446696C6C436F6C6F722C633D65';
wwv_flow_imp.g_varchar2_table(38796) := '2626652E64656661756C745374726F6B65436F6C6F722C643D652626652E64656661756C744C6162656C436F6C6F723B66756E6374696F6E20682865297B72657475726E206E2E636F6D707574655374796C6528652C7B7374726F6B654C696E65636170';
wwv_flow_imp.g_varchar2_table(38797) := '3A22726F756E64222C7374726F6B654C696E656A6F696E3A22726F756E64222C7374726F6B653A67732C7374726F6B6557696474683A322C66696C6C3A227768697465227D297D66756E6374696F6E20752865297B72657475726E206E2E636F6D707574';
wwv_flow_imp.g_varchar2_table(38798) := '655374796C6528652C5B226E6F2D66696C6C225D2C7B7374726F6B654C696E656361703A22726F756E64222C7374726F6B654C696E656A6F696E3A22726F756E64222C7374726F6B653A67732C7374726F6B6557696474683A327D297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(38799) := '6E207028652C74297B7661727B7265663A6E3D7B783A302C793A307D2C7363616C653A693D312C656C656D656E743A6F2C706172656E744766783A723D732E5F7376677D3D742C613D6B6528226D61726B6572222C7B69643A652C76696577426F783A22';
wwv_flow_imp.g_varchar2_table(38800) := '302030203230203230222C726566583A6E2E782C726566593A6E2E792C6D61726B657257696474683A32302A692C6D61726B65724865696768743A32302A692C6F7269656E743A226175746F227D293B756528612C6F293B766172206C3D646528223A73';
wwv_flow_imp.g_varchar2_table(38801) := '636F7065203E2064656673222C72293B6C7C7C756528722C6C3D6B652822646566732229292C7565286C2C61297D66756E6374696F6E206728652C742C6E2C69297B766172206F3D53732E6E657874507265666978656428226D61726B65722D22293B72';
wwv_flow_imp.g_varchar2_table(38802) := '657475726E2066756E6374696F6E28652C742C6E2C692C6F297B2273657175656E6365666C6F772D656E64223D3D3D6E26267028742C7B656C656D656E743A6B65282270617468222C7B643A224D20312035204C203131203130204C2031203135205A22';
wwv_flow_imp.g_varchar2_table(38803) := '2C2E2E2E68287B66696C6C3A6F2C7374726F6B653A6F2C7374726F6B6557696474683A317D297D292C7265663A7B783A31312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C226D657373616765666C6F772D7374617274223D';
wwv_flow_imp.g_varchar2_table(38804) := '3D3D6E26267028742C7B656C656D656E743A6B652822636972636C65222C7B63783A362C63793A362C723A332E352C2E2E2E68287B66696C6C3A692C7374726F6B653A6F2C7374726F6B6557696474683A312C7374726F6B654461736861727261793A5B';
wwv_flow_imp.g_varchar2_table(38805) := '3165342C315D7D297D292C7265663A7B783A362C793A367D2C706172656E744766783A657D292C226D657373616765666C6F772D656E64223D3D3D6E26267028742C7B656C656D656E743A6B65282270617468222C7B643A226D20312035206C2030202D';
wwv_flow_imp.g_varchar2_table(38806) := '33206C20372033206C202D372033207A222C2E2E2E68287B66696C6C3A692C7374726F6B653A6F2C7374726F6B6557696474683A312C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A382E352C793A357D2C7061';
wwv_flow_imp.g_varchar2_table(38807) := '72656E744766783A657D292C226173736F63696174696F6E2D7374617274223D3D3D6E26267028742C7B656C656D656E743A6B65282270617468222C7B643A224D2031312035204C2031203130204C203131203135222C2E2E2E75287B66696C6C3A226E';
wwv_flow_imp.g_varchar2_table(38808) := '6F6E65222C7374726F6B653A6F2C7374726F6B6557696474683A312E352C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C22617373';
wwv_flow_imp.g_varchar2_table(38809) := '6F63696174696F6E2D656E64223D3D3D6E26267028742C7B656C656D656E743A6B65282270617468222C7B643A224D20312035204C203131203130204C2031203135222C2E2E2E75287B66696C6C3A226E6F6E65222C7374726F6B653A6F2C7374726F6B';
wwv_flow_imp.g_varchar2_table(38810) := '6557696474683A312E352C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A31312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C22636F6E646974696F6E616C2D666C6F772D6D61726B';
wwv_flow_imp.g_varchar2_table(38811) := '6572223D3D3D6E26267028742C7B656C656D656E743A6B65282270617468222C7B643A224D2030203130204C20382036204C203136203130204C2038203134205A222C2E2E2E68287B66696C6C3A692C7374726F6B653A6F7D297D292C7265663A7B783A';
wwv_flow_imp.g_varchar2_table(38812) := '2D312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C22636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572223D3D3D6E26267028742C7B656C656D656E743A6B65282270617468222C7B643A224D20';
wwv_flow_imp.g_varchar2_table(38813) := '362034204C203130203136222C2E2E2E68287B7374726F6B653A6F2C66696C6C3A226E6F6E65227D297D292C7265663A7B783A302C793A31307D2C7363616C653A2E352C706172656E744766783A657D297D28652C6F2C742C6E2C69292C2275726C2823';
wwv_flow_imp.g_varchar2_table(38814) := '222B6F2B2229227D66756E6374696F6E206D28652C742C6E2C6F2C733D7B7D297B28302C692E477629286F29262628733D6F2C6F3D30292C6F3D6F7C7C302C733D682873293B76617220723D6B652822636972636C65222C7B63783A742F322C63793A6E';
wwv_flow_imp.g_varchar2_table(38815) := '2F322C723A4D6174682E726F756E642828742B6E292F342D6F292C2E2E2E737D293B72657475726E20756528652C72292C727D66756E6374696F6E206628652C742C6E2C6F2C732C72297B28302C692E477629287329262628723D732C733D30292C733D';
wwv_flow_imp.g_varchar2_table(38816) := '737C7C302C723D682872293B76617220613D6B65282272656374222C7B783A732C793A732C77696474683A742D322A732C6865696768743A6E2D322A732C72783A6F2C72793A6F2C2E2E2E727D293B72657475726E20756528652C61292C617D66756E63';
wwv_flow_imp.g_varchar2_table(38817) := '74696F6E207628652C742C6E2C69297B766172206F3D6E7428742C6E3D75286E292C69293B72657475726E20756528652C6F292C6F7D66756E6374696F6E206228652C742C6E297B72657475726E207628652C742C6E2C35297D66756E6374696F6E205F';
wwv_flow_imp.g_varchar2_table(38818) := '28652C742C6E297B6E3D75286E293B76617220693D6B65282270617468222C7B2E2E2E6E2C643A747D293B72657475726E20756528652C69292C697D66756E6374696F6E207728652C742C6E2C6F297B72657475726E205F28742C6E2C28302C692E6B70';
wwv_flow_imp.g_varchar2_table(38819) := '29287B22646174612D6D61726B6572223A657D2C6F29297D66756E6374696F6E20432865297B72657475726E20565B655D7D66756E6374696F6E20532865297B72657475726E2066756E6374696F6E28742C6E2C69297B72657475726E20432865292874';
wwv_flow_imp.g_varchar2_table(38820) := '2C6E2C69297D7D66756E6374696F6E207828652C742C6E3D7B7D297B76617220692C733D28302C792E676574427573696E6573734F626A656374292865292C723D2262706D6E3A496E7465726D6564696174655468726F774576656E74223D3D3D28693D';
wwv_flow_imp.g_varchar2_table(38821) := '73292E24747970657C7C2262706D6E3A456E644576656E74223D3D3D692E24747970653B72657475726E20732E67657428226576656E74446566696E6974696F6E7322292626732E67657428226576656E74446566696E6974696F6E7322292E6C656E67';
wwv_flow_imp.g_varchar2_table(38822) := '74683E313F732E6765742822706172616C6C656C4D756C7469706C6522293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F504152414C4C454C5F4D554C5449504C';
wwv_flow_imp.g_varchar2_table(38823) := '45222C7B785363616C65466163746F723A312E322C795363616C65466163746F723A312E322C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E';
wwv_flow_imp.g_varchar2_table(38824) := '3435382C6D793A2E3139347D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E293A66756E6374696F6E28652C742C6E3D7B';
wwv_flow_imp.g_varchar2_table(38825) := '7D2C69297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F4D554C5449504C45222C7B785363616C65466163746F723A312E312C795363616C65466163746F723A312E312C636F6E7461696E657257696474683A74';
wwv_flow_imp.g_varchar2_table(38826) := '2E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3232322C6D793A2E33367D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A767328742C6C2C6E2E66696C6C292C';
wwv_flow_imp.g_varchar2_table(38827) := '7374726F6B6557696474683A317D297D28742C652C6E2C72293A667328732C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C69297B72657475726E205F28652C6F2E67657453';
wwv_flow_imp.g_varchar2_table(38828) := '63616C65645061746828224556454E545F4D455353414745222C7B785363616C65466163746F723A2E392C795363616C65466163746F723A2E392C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E';
wwv_flow_imp.g_varchar2_table(38829) := '6865696768742C706F736974696F6E3A7B6D783A2E3233352C6D793A2E3331357D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A767328742C6C2C6E2E66696C6C292C7374726F6B653A693F767328742C6C2C6E2E66696C6C293A';
wwv_flow_imp.g_varchar2_table(38830) := '627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C72293A667328732C2262706D6E3A54696D65724576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B76617220';
wwv_flow_imp.g_varchar2_table(38831) := '693D6D28652C742E77696474682C742E6865696768742C2E322A742E6865696768742C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A327D293B5F28652C';
wwv_flow_imp.g_varchar2_table(38832) := '6F2E6765745363616C65645061746828224556454E545F54494D45525F5748222C7B785363616C65466163746F723A2E37352C795363616C65466163746F723A2E37352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(38833) := '4865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E357D7D292C7B7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A327D293B666F722876617220733D303B733C31323B73';
wwv_flow_imp.g_varchar2_table(38834) := '2B2B297B76617220723D6F2E6765745363616C65645061746828224556454E545F54494D45525F4C494E45222C7B785363616C65466163746F723A2E37352C795363616C65466163746F723A2E37352C636F6E7461696E657257696474683A742E776964';
wwv_flow_imp.g_varchar2_table(38835) := '74682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E357D7D292C613D742E77696474682F322C643D742E6865696768742F323B5F28652C722C7B7374726F6B6557696474683A312C73';
wwv_flow_imp.g_varchar2_table(38836) := '74726F6B653A627328742C632C6E2E7374726F6B65292C7472616E73666F726D3A22726F7461746528222B33302A732B222C222B642B222C222B612B2229227D297D72657475726E20697D28742C652C6E293A667328732C2262706D6E3A436F6E646974';
wwv_flow_imp.g_varchar2_table(38837) := '696F6E616C4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F434F4E444954494F4E414C222C7B785363616C6546616374';
wwv_flow_imp.g_varchar2_table(38838) := '6F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E3232327D7D292C7B66696C6C';
wwv_flow_imp.g_varchar2_table(38839) := '3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E293A667328732C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E22293F66';
wwv_flow_imp.g_varchar2_table(38840) := '756E6374696F6E28652C742C6E3D7B7D2C69297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F5349474E414C222C7B785363616C65466163746F723A2E392C795363616C65466163746F723A2E392C636F6E7461';
wwv_flow_imp.g_varchar2_table(38841) := '696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E327D7D292C7B7374726F6B6557696474683A312C66696C6C3A693F627328742C632C6E2E73';
wwv_flow_imp.g_varchar2_table(38842) := '74726F6B65293A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D28742C652C6E2C72293A667328732C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E22293F66756E';
wwv_flow_imp.g_varchar2_table(38843) := '6374696F6E28652C742C6E3D7B7D2C69297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F455343414C4154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461';
wwv_flow_imp.g_varchar2_table(38844) := '696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E327D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A767328742C6C2C';
wwv_flow_imp.g_varchar2_table(38845) := '6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C72293A667328732C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E22293F66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(38846) := '652C742C6E3D7B7D2C69297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F4C494E4B222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E';
wwv_flow_imp.g_varchar2_table(38847) := '77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E35372C6D793A2E3236337D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A767328742C6C2C6E2E66696C6C292C73';
wwv_flow_imp.g_varchar2_table(38848) := '74726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C72293A667328732C2262706D6E3A4572726F724576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D';
wwv_flow_imp.g_varchar2_table(38849) := '2C69297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F4552524F52222C7B785363616C65466163746F723A312E312C795363616C65466163746F723A312E312C636F6E7461696E657257696474683A742E776964';
wwv_flow_imp.g_varchar2_table(38850) := '74682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E322C6D793A2E3732327D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A767328742C6C2C6E2E66696C6C292C7374726F6B';
wwv_flow_imp.g_varchar2_table(38851) := '653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C72293A667328732C2262706D6E3A43616E63656C4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C6929';
wwv_flow_imp.g_varchar2_table(38852) := '7B76617220733D5F28652C6F2E6765745363616C65645061746828224556454E545F43414E43454C5F3435222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C63';
wwv_flow_imp.g_varchar2_table(38853) := '6F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3633382C6D793A2D2E3035357D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A226E6F6E65222C7374726F6B653A627328742C632C';
wwv_flow_imp.g_varchar2_table(38854) := '6E2E7374726F6B65292C7374726F6B6557696474683A317D293B72657475726E205F6928732C3435292C737D28742C652C6E2C72293A667328732C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22293F66756E6374696F';
wwv_flow_imp.g_varchar2_table(38855) := '6E28652C742C6E3D7B7D2C69297B72657475726E205F28652C6F2E6765745363616C65645061746828224556454E545F434F4D50454E534154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E';
wwv_flow_imp.g_varchar2_table(38856) := '657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E32322C6D793A2E357D7D292C7B66696C6C3A693F627328742C632C6E2E7374726F6B65293A767328742C6C2C6E';
wwv_flow_imp.g_varchar2_table(38857) := '2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C72293A667328732C2262706D6E3A5465726D696E6174654576656E74446566696E6974696F6E22293F66756E6374';
wwv_flow_imp.g_varchar2_table(38858) := '696F6E28652C742C6E3D7B7D297B72657475726E206D28652C742E77696474682C742E6865696768742C382C7B66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B65576964';
wwv_flow_imp.g_varchar2_table(38859) := '74683A347D297D28742C652C6E293A6E756C6C7D766172206B3D7B5061727469636970616E744D756C7469706C69636974794D61726B65723A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D777328742C6E292C733D437328742C6E293B';
wwv_flow_imp.g_varchar2_table(38860) := '7728227061727469636970616E742D6D756C7469706C6963697479222C652C6F2E6765745363616C65645061746828224D41524B45525F504152414C4C454C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E74';
wwv_flow_imp.g_varchar2_table(38861) := '61696E657257696474683A692C636F6E7461696E65724865696768743A732C706F736974696F6E3A7B6D783A28692F322D36292F692C6D793A28732D3135292F737D7D292C7B7374726F6B6557696474683A322C66696C6C3A767328742C6C2C6E2E6669';
wwv_flow_imp.g_varchar2_table(38862) := '6C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D2C53756250726F636573734D61726B65723A66756E6374696F6E28652C742C6E3D7B7D297B6269286628652C31342C31342C302C7B7374726F6B6557696474683A312C66696C';
wwv_flow_imp.g_varchar2_table(38863) := '6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D292C742E77696474682F322D372E352C742E6865696768742D3230292C7728227375622D70726F63657373222C652C6F2E6765745363616C656450';
wwv_flow_imp.g_varchar2_table(38864) := '61746828224D41524B45525F5355425F50524F43455353222C7B785363616C65466163746F723A312E352C795363616C65466163746F723A312E352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A74';
wwv_flow_imp.g_varchar2_table(38865) := '2E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322D372E35292F742E77696474682C6D793A28742E6865696768742D3230292F742E6865696768747D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B';
wwv_flow_imp.g_varchar2_table(38866) := '653A627328742C632C6E2E7374726F6B65297D297D2C506172616C6C656C4D61726B65723A66756E6374696F6E28652C742C6E297B76617220693D777328742C6E292C733D437328742C6E293B772822706172616C6C656C222C652C6F2E676574536361';
wwv_flow_imp.g_varchar2_table(38867) := '6C65645061746828224D41524B45525F504152414C4C454C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A692C636F6E7461696E65724865696768743A732C706F736974696F6E';
wwv_flow_imp.g_varchar2_table(38868) := '3A7B6D783A28692F322B6E2E706172616C6C656C292F692C6D793A28732D3230292F737D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D2C53657175656E7469616C4D6172';
wwv_flow_imp.g_varchar2_table(38869) := '6B65723A66756E6374696F6E28652C742C6E297B77282273657175656E7469616C222C652C6F2E6765745363616C65645061746828224D41524B45525F53455155454E5449414C222C7B785363616C65466163746F723A312C795363616C65466163746F';
wwv_flow_imp.g_varchar2_table(38870) := '723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322B6E2E736571292F742E77696474682C6D793A28742E686569';
wwv_flow_imp.g_varchar2_table(38871) := '6768742D3139292F742E6865696768747D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D2C436F6D70656E736174696F6E4D61726B65723A66756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(38872) := '6E297B772822636F6D70656E736174696F6E222C652C6F2E6765745363616C65645061746828224D41524B45525F434F4D50454E534154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(38873) := '57696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322B6E2E636F6D70656E736174696F6E292F742E77696474682C6D793A28742E6865696768742D';
wwv_flow_imp.g_varchar2_table(38874) := '3133292F742E6865696768747D7D292C7B7374726F6B6557696474683A312C66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D2C4C6F6F704D61726B65723A66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(38875) := '742C6E297B76617220693D777328742C6E292C733D437328742C6E293B7728226C6F6F70222C652C6F2E6765745363616C65645061746828224D41524B45525F4C4F4F50222C7B785363616C65466163746F723A312C795363616C65466163746F723A31';
wwv_flow_imp.g_varchar2_table(38876) := '2C636F6E7461696E657257696474683A692C636F6E7461696E65724865696768743A732C706F736974696F6E3A7B6D783A28692F322B6E2E6C6F6F70292F692C6D793A28732D37292F737D7D292C7B7374726F6B6557696474683A312E352C66696C6C3A';
wwv_flow_imp.g_varchar2_table(38877) := '226E6F6E65222C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B654D697465726C696D69743A2E357D297D2C4164686F634D61726B65723A66756E6374696F6E28652C742C6E297B76617220693D777328742C6E292C733D4373';
wwv_flow_imp.g_varchar2_table(38878) := '28742C6E293B7728226164686F63222C652C6F2E6765745363616C65645061746828224D41524B45525F4144484F43222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A692C636F6E';
wwv_flow_imp.g_varchar2_table(38879) := '7461696E65724865696768743A732C706F736974696F6E3A7B6D783A28692F322B6E2E6164686F63292F692C6D793A28732D3135292F737D7D292C7B7374726F6B6557696474683A312C66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F';
wwv_flow_imp.g_varchar2_table(38880) := '6B653A627328742C632C6E2E7374726F6B65297D297D7D3B66756E6374696F6E204528652C742C6E2C69297B6B5B655D28742C6E2C69297D66756E6374696F6E204C28652C742C6E2C6F3D7B7D297B6F3D7B66696C6C3A6F2E66696C6C2C7374726F6B65';
wwv_flow_imp.g_varchar2_table(38881) := '3A6F2E7374726F6B652C77696474683A777328742C6F292C6865696768743A437328742C6F297D3B76617220733D28302C792E676574427573696E6573734F626A656374292874292C723D6E26266E2E696E636C75646573282253756250726F63657373';
wwv_flow_imp.g_varchar2_table(38882) := '4D61726B657222293B6F3D723F7B2E2E2E6F2C7365713A2D32312C706172616C6C656C3A2D32322C636F6D70656E736174696F6E3A2D34322C6C6F6F703A2D31382C6164686F633A31307D3A7B2E2E2E6F2C7365713A2D352C706172616C6C656C3A2D36';
wwv_flow_imp.g_varchar2_table(38883) := '2C636F6D70656E736174696F6E3A2D32372C6C6F6F703A302C6164686F633A31307D2C28302C692E6A4A29286E2C2866756E6374696F6E286E297B45286E2C652C742C6F297D29292C732E67657428226973466F72436F6D70656E736174696F6E222926';
wwv_flow_imp.g_varchar2_table(38884) := '26452822436F6D70656E736174696F6E4D61726B6572222C652C742C6F292C28302C792E69732928732C2262706D6E3A4164486F6353756250726F63657373222926264528224164686F634D61726B6572222C652C742C6F293B76617220613D732E6765';
wwv_flow_imp.g_varchar2_table(38885) := '7428226C6F6F7043686172616374657269737469637322292C6C3D612626612E6765742822697353657175656E7469616C22293B61262628766F696420303D3D3D6C26264528224C6F6F704D61726B6572222C652C742C6F292C21313D3D3D6C26264528';
wwv_flow_imp.g_varchar2_table(38886) := '22506172616C6C656C4D61726B6572222C652C742C6F292C21303D3D3D6C262645282253657175656E7469616C4D61726B6572222C652C742C6F29297D66756E6374696F6E204428652C742C6E3D7B7D297B6E3D28302C692E6B7029287B73697A653A7B';
wwv_flow_imp.g_varchar2_table(38887) := '77696474683A3130307D7D2C6E293B766172206F3D722E6372656174655465787428747C7C22222C6E293B72657475726E206265286F292E6164642822646A732D6C6162656C22292C756528652C6F292C6F7D66756E6374696F6E205428652C742C6E2C';
wwv_flow_imp.g_varchar2_table(38888) := '693D7B7D297B766172206F3D28302C792E676574427573696E6573734F626A656374292874292C733D7973287B783A742E782C793A742E792C77696474683A742E77696474682C6865696768743A742E6865696768747D2C69293B72657475726E204428';
wwv_flow_imp.g_varchar2_table(38889) := '652C6F2E6E616D652C7B616C69676E3A6E2C626F783A732C70616464696E673A372C7374796C653A7B66696C6C3A5F7328742C642C632C692E7374726F6B65297D7D297D66756E6374696F6E204928652C742C6E2C693D7B7D297B766172206F3D28302C';
wwv_flow_imp.g_varchar2_table(38890) := '72732E246229286E292C733D4428652C742C7B626F783A7B6865696768743A33302C77696474683A6F3F4373286E2C69293A7773286E2C69297D2C616C69676E3A2263656E7465722D6D6964646C65222C7374796C653A7B66696C6C3A5F73286E2C642C';
wwv_flow_imp.g_varchar2_table(38891) := '632C692E7374726F6B65297D7D293B6F2626766928732C302C312A4373286E2C69292C323730297D66756E6374696F6E204D28652C742C6E3D7B7D297B7661727B77696474683A692C6865696768743A6F7D3D797328742C6E293B72657475726E206628';
wwv_flow_imp.g_varchar2_table(38892) := '652C692C6F2C31302C7B2E2E2E6E2C66696C6C3A767328742C6C2C6E2E66696C6C292C66696C6C4F7061636974793A78732C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D66756E6374696F6E204128652C742C6E3D7B7D297B766172';
wwv_flow_imp.g_varchar2_table(38893) := '20693D28302C792E676574427573696E6573734F626A656374292874292C6F3D767328742C6C2C6E2E66696C6C292C733D627328742C632C6E2E7374726F6B65293B72657475726E224F6E6522213D3D692E67657428226173736F63696174696F6E4469';
wwv_flow_imp.g_varchar2_table(38894) := '72656374696F6E2229262622426F746822213D3D692E67657428226173736F63696174696F6E446972656374696F6E22297C7C286E2E6D61726B6572456E643D6728652C226173736F63696174696F6E2D656E64222C6F2C7329292C22426F7468223D3D';
wwv_flow_imp.g_varchar2_table(38895) := '3D692E67657428226173736F63696174696F6E446972656374696F6E22292626286E2E6D61726B657253746172743D6728652C226173736F63696174696F6E2D7374617274222C6F2C7329292C6E3D4573286E2C5B226D61726B65725374617274222C22';
wwv_flow_imp.g_varchar2_table(38896) := '6D61726B6572456E64225D292C6228652C742E776179706F696E74732C7B2E2E2E6E2C7374726F6B653A732C7374726F6B654461736861727261793A22302C2035227D297D66756E6374696F6E204E28652C742C6E3D7B7D297B76617220693D76732874';
wwv_flow_imp.g_varchar2_table(38897) := '2C6C2C6E2E66696C6C292C733D627328742C632C6E2E7374726F6B65292C723D5F28652C6F2E6765745363616C6564506174682822444154415F4F424A4543545F50415448222C7B785363616C65466163746F723A312C795363616C65466163746F723A';
wwv_flow_imp.g_varchar2_table(38898) := '312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3437342C6D793A2E3239367D7D292C7B66696C6C3A692C66696C6C4F7061636974793A78';
wwv_flow_imp.g_varchar2_table(38899) := '732C7374726F6B653A737D293B72657475726E2066756E6374696F6E2865297B76617220743D652E646174614F626A6563745265663B72657475726E20652E6973436F6C6C656374696F6E7C7C742626742E6973436F6C6C656374696F6E7D2828302C79';
wwv_flow_imp.g_varchar2_table(38900) := '2E676574427573696E6573734F626A656374292874292926265F28652C6F2E6765745363616C6564506174682822444154415F4F424A4543545F434F4C4C454354494F4E5F50415448222C7B785363616C65466163746F723A312C795363616C65466163';
wwv_flow_imp.g_varchar2_table(38901) := '746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E33332C6D793A28742E6865696768742D3138292F742E6865696768747D7D292C';
wwv_flow_imp.g_varchar2_table(38902) := '7B7374726F6B6557696474683A322C66696C6C3A692C7374726F6B653A737D292C727D66756E6374696F6E205028652C742C6E3D7B7D297B72657475726E206D28652C742E77696474682C742E6865696768742C7B66696C6C4F7061636974793A78732C';
wwv_flow_imp.g_varchar2_table(38903) := '2E2E2E6E2C66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D66756E6374696F6E204F28652C742C6E3D7B7D297B72657475726E2066756E6374696F6E28652C742C6E2C69297B766172';
wwv_flow_imp.g_varchar2_table(38904) := '206F3D742F322C733D6E2F322C723D5B7B783A6F2C793A307D2C7B783A742C793A737D2C7B783A6F2C793A6E7D2C7B783A302C793A737D5D2E6D6170282866756E6374696F6E2865297B72657475726E20652E782B222C222B652E797D29292E6A6F696E';
wwv_flow_imp.g_varchar2_table(38905) := '28222022293B693D682869293B76617220613D6B652822706F6C79676F6E222C7B2E2E2E692C706F696E74733A727D293B72657475726E20756528652C61292C617D28652C742E77696474682C742E6865696768742C7B66696C6C3A767328742C6C2C6E';
wwv_flow_imp.g_varchar2_table(38906) := '2E66696C6C292C66696C6C4F7061636974793A78732C7374726F6B653A627328742C632C6E2E7374726F6B65297D297D66756E6374696F6E205228652C742C6E3D7B7D297B76617220693D6628652C777328742C6E292C437328742C6E292C302C7B6669';
wwv_flow_imp.g_varchar2_table(38907) := '6C6C3A767328742C6C2C6E2E66696C6C292C66696C6C4F7061636974793A6E2E66696C6C4F7061636974797C7C78732C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E357D292C6F3D28302C792E676574';
wwv_flow_imp.g_varchar2_table(38908) := '427573696E6573734F626A656374292874293B72657475726E28302C792E697329286F2C2262706D6E3A4C616E65222926264928652C6F2E67657428226E616D6522292C742C6E292C697D66756E6374696F6E204628652C742C6E3D7B7D297B76617220';
wwv_flow_imp.g_varchar2_table(38909) := '693D4D28652C742C6E293B28302C72732E5131292874292626666528692C7B7374726F6B654461736861727261793A22302C20352E35222C7374726F6B6557696474683A322E357D293B766172206F3D28302C72732E4176292874293B72657475726E20';
wwv_flow_imp.g_varchar2_table(38910) := '5428652C742C6F3F2263656E7465722D746F70223A2263656E7465722D6D6964646C65222C6E292C4C28652C742C6F3F766F696420303A5B2253756250726F636573734D61726B6572225D2C6E292C697D66756E6374696F6E204228652C742C6E3D7B7D';
wwv_flow_imp.g_varchar2_table(38911) := '297B76617220693D4D28652C742C6E293B72657475726E205428652C742C2263656E7465722D6D6964646C65222C6E292C4C28652C742C766F696420302C6E292C697D76617220563D746869732E68616E646C6572733D7B2262706D6E3A4164486F6353';
wwv_flow_imp.g_varchar2_table(38912) := '756250726F63657373223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204628652C742C6E3D28302C72732E4176292874293F4573286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A45';
wwv_flow_imp.g_varchar2_table(38913) := '73286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A4173736F63696174696F6E223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204128652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D';
wwv_flow_imp.g_varchar2_table(38914) := '29297D2C2262706D6E3A426F756E646172794576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D293B766172206F3D28';
wwv_flow_imp.g_varchar2_table(38915) := '302C792E676574427573696E6573734F626A656374292874292E676574282263616E63656C416374697669747922293B6E3D7B7374726F6B6557696474683A312E352C66696C6C3A767328742C6C2C6E2E66696C6C292C66696C6C4F7061636974793A31';
wwv_flow_imp.g_varchar2_table(38916) := '2C7374726F6B653A627328742C632C6E2E7374726F6B65297D2C6F7C7C286E2E7374726F6B654461736861727261793D223622293B76617220733D5028652C742C6E293B72657475726E206D28652C742E77696474682C742E6865696768742C332C7B2E';
wwv_flow_imp.g_varchar2_table(38917) := '2E2E6E2C66696C6C3A226E6F6E65227D292C6926267828742C652C6E292C737D2C2262706D6E3A427573696E65737352756C655461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4228652C742C6E3D4573286E2C5B2266696C';
wwv_flow_imp.g_varchar2_table(38918) := '6C222C227374726F6B65225D29293B72657475726E206665285F28652C6F2E6765745363616C65645061746828225441534B5F545950455F425553494E4553535F52554C455F4D41494E222C7B616273706F733A7B783A382C793A387D7D29292C7B6669';
wwv_flow_imp.g_varchar2_table(38919) := '6C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C6665285F28652C6F2E6765745363616C65645061746828225441534B5F545950455F425553494E455353';
wwv_flow_imp.g_varchar2_table(38920) := '5F52554C455F484541444552222C7B616273706F733A7B783A382C793A387D7D29292C7B66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C697D';
wwv_flow_imp.g_varchar2_table(38921) := '2C2262706D6E3A43616C6C4163746976697479223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D4573286E2C5B2266696C6C222C227374726F6B65225D292C4628652C742C7B7374726F6B6557696474683A352C2E2E2E6E7D29';
wwv_flow_imp.g_varchar2_table(38922) := '7D2C2262706D6E3A436F6D706C657847617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4F28652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E205F28652C6F2E6765745363';
wwv_flow_imp.g_varchar2_table(38923) := '616C6564506174682822474154455741595F434F4D504C4558222C7B785363616C65466163746F723A2E352C795363616C65466163746F723A2E352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A74';
wwv_flow_imp.g_varchar2_table(38924) := '2E6865696768742C706F736974696F6E3A7B6D783A2E34362C6D793A2E32367D7D292C7B66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C697D';
wwv_flow_imp.g_varchar2_table(38925) := '2C2262706D6E3A44617461496E707574223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D293B76617220693D6F2E676574526177506174682822444154415F4152524F5722292C733D4E28';
wwv_flow_imp.g_varchar2_table(38926) := '652C742C6E293B72657475726E205F28652C692C7B66696C6C3A226E6F6E65222C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C737D2C2262706D6E3A44617461496E7075744173736F6369617469';
wwv_flow_imp.g_varchar2_table(38927) := '6F6E223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D4573286E2C5B2266696C6C222C227374726F6B65225D292C4128652C742C7B2E2E2E6E2C6D61726B6572456E643A6728652C226173736F63696174696F6E2D656E64222C';
wwv_flow_imp.g_varchar2_table(38928) := '767328742C6C2C6E2E66696C6C292C627328742C632C6E2E7374726F6B6529297D297D2C2262706D6E3A446174614F626A656374223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204E28652C742C6E3D4573286E2C5B2266696C6C22';
wwv_flow_imp.g_varchar2_table(38929) := '2C227374726F6B65225D29297D2C2262706D6E3A446174614F626A6563745265666572656E6365223A53282262706D6E3A446174614F626A65637422292C2262706D6E3A446174614F7574707574223A66756E6374696F6E28652C742C6E3D7B7D297B6E';
wwv_flow_imp.g_varchar2_table(38930) := '3D4573286E2C5B2266696C6C222C227374726F6B65225D293B76617220693D6F2E676574526177506174682822444154415F4152524F5722292C733D4E28652C742C6E293B72657475726E205F28652C692C7B7374726F6B6557696474683A312C66696C';
wwv_flow_imp.g_varchar2_table(38931) := '6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65297D292C737D2C2262706D6E3A446174614F75747075744173736F63696174696F6E223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E';
wwv_flow_imp.g_varchar2_table(38932) := '206E3D4573286E2C5B2266696C6C222C227374726F6B65225D292C4128652C742C7B2E2E2E6E2C6D61726B6572456E643A6728652C226173736F63696174696F6E2D656E64222C767328742C6C2C6E2E66696C6C292C627328742C632C6E2E7374726F6B';
wwv_flow_imp.g_varchar2_table(38933) := '6529297D297D2C2262706D6E3A4461746153746F72655265666572656E6365223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D4573286E2C5B2266696C6C222C227374726F6B65225D292C5F28652C6F2E6765745363616C6564';
wwv_flow_imp.g_varchar2_table(38934) := '506174682822444154415F53544F5245222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F73';
wwv_flow_imp.g_varchar2_table(38935) := '6974696F6E3A7B6D783A302C6D793A2E3133337D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C66696C6C4F7061636974793A78732C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A327D297D2C';
wwv_flow_imp.g_varchar2_table(38936) := '2262706D6E3A456E644576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D293B766172206F3D5028652C742C7B2E2E2E';
wwv_flow_imp.g_varchar2_table(38937) := '6E2C7374726F6B6557696474683A347D293B72657475726E206926267828742C652C6E292C6F7D2C2262706D6E3A4576656E74426173656447617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D4573286E2C5B2266696C6C222C22';
wwv_flow_imp.g_varchar2_table(38938) := '7374726F6B65225D293B76617220693D28302C792E676574427573696E6573734F626A656374292874292C733D4F28652C742C6E293B6D28652C742E77696474682C742E6865696768742C2E322A742E6865696768742C7B66696C6C3A767328742C226E';
wwv_flow_imp.g_varchar2_table(38939) := '6F6E65222C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D293B76617220723D692E67657428226576656E74476174657761795479706522292C613D2121692E6765742822696E7374';
wwv_flow_imp.g_varchar2_table(38940) := '616E746961746522293B69662822506172616C6C656C223D3D3D72297B766172206C3D6F2E6765745363616C6564506174682822474154455741595F504152414C4C454C222C7B785363616C65466163746F723A2E342C795363616C65466163746F723A';
wwv_flow_imp.g_varchar2_table(38941) := '2E342C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3437342C6D793A2E3239367D7D293B5F28652C6C2C7B66696C6C3A226E6F6E65222C73';
wwv_flow_imp.g_varchar2_table(38942) := '74726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D656C7365224578636C7573697665223D3D3D72262628617C7C6D28652C742E77696474682C742E6865696768742C2E32362A742E6865696768742C7B66';
wwv_flow_imp.g_varchar2_table(38943) := '696C6C3A226E6F6E65222C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C66756E6374696F6E28297B76617220693D6F2E6765745363616C6564506174682822474154455741595F4556454E545F42';
wwv_flow_imp.g_varchar2_table(38944) := '41534544222C7B785363616C65466163746F723A2E31382C795363616C65466163746F723A2E31382C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D';
wwv_flow_imp.g_varchar2_table(38945) := '783A2E33362C6D793A2E34347D7D293B5F28652C692C7B66696C6C3A226E6F6E65222C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A327D297D2829293B72657475726E20737D2C2262706D6E3A4578636C75';
wwv_flow_imp.g_varchar2_table(38946) := '7369766547617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4F28652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29292C733D6F2E6765745363616C6564506174682822474154455741595F4558';
wwv_flow_imp.g_varchar2_table(38947) := '434C5553495645222C7B785363616C65466163746F723A2E342C795363616C65466163746F723A2E342C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B';
wwv_flow_imp.g_varchar2_table(38948) := '6D783A2E33322C6D793A2E337D7D293B72657475726E28302C792E6765744469292874292E676574282269734D61726B657256697369626C65222926265F28652C732C7B66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F6B653A627328';
wwv_flow_imp.g_varchar2_table(38949) := '742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C697D2C2262706D6E3A47617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204F28652C742C6E3D4573286E2C5B2266696C6C222C227374726F';
wwv_flow_imp.g_varchar2_table(38950) := '6B65225D29297D2C2262706D6E3A47726F7570223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D4573286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D292C6628652C742E77696474';
wwv_flow_imp.g_varchar2_table(38951) := '682C742E6865696768742C31302C7B7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E352C7374726F6B654461736861727261793A2231302C20362C20302C2036222C66696C6C3A226E6F6E65222C706F69';
wwv_flow_imp.g_varchar2_table(38952) := '6E7465724576656E74733A226E6F6E65222C77696474683A777328742C6E292C6865696768743A437328742C6E297D297D2C2262706D6E3A496E636C757369766547617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4F';
wwv_flow_imp.g_varchar2_table(38953) := '28652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E206D28652C742E77696474682C742E6865696768742C2E32342A742E6865696768742C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B65';
wwv_flow_imp.g_varchar2_table(38954) := '3A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A322E357D292C697D2C2262706D6E3A496E7465726D6564696174654576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D';
wwv_flow_imp.g_varchar2_table(38955) := '21307D3D6E3B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D293B766172206F3D5028652C742C7B2E2E2E6E2C7374726F6B6557696474683A312E357D293B72657475726E206D28652C742E77696474682C742E6865696768742C332C7B66';
wwv_flow_imp.g_varchar2_table(38956) := '696C6C3A226E6F6E65222C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E357D292C6926267828742C652C6E292C6F7D2C2262706D6E3A496E7465726D65646961746543617463684576656E74223A5328';
wwv_flow_imp.g_varchar2_table(38957) := '2262706D6E3A496E7465726D6564696174654576656E7422292C2262706D6E3A496E7465726D6564696174655468726F774576656E74223A53282262706D6E3A496E7465726D6564696174654576656E7422292C2262706D6E3A4C616E65223A66756E63';
wwv_flow_imp.g_varchar2_table(38958) := '74696F6E28652C742C6E3D7B7D297B72657475726E206E3D4573286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D292C5228652C742C7B2E2E2E6E2C66696C6C4F7061636974793A2E32357D297D2C2262706D';
wwv_flow_imp.g_varchar2_table(38959) := '6E3A4D616E75616C5461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4228652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E205F28652C6F2E6765745363616C6564506174682822';
wwv_flow_imp.g_varchar2_table(38960) := '5441534B5F545950455F4D414E55414C222C7B616273706F733A7B783A31372C793A31357D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D';
wwv_flow_imp.g_varchar2_table(38961) := '292C697D2C2262706D6E3A4D657373616765466C6F77223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D293B76617220693D28302C792E676574427573696E6573734F626A656374292874';
wwv_flow_imp.g_varchar2_table(38962) := '292C733D28302C792E6765744469292874292C723D767328742C6C2C6E2E66696C6C292C613D627328742C632C6E2E7374726F6B65292C643D6228652C742E776179706F696E74732C7B6D61726B6572456E643A6728652C226D657373616765666C6F77';
wwv_flow_imp.g_varchar2_table(38963) := '2D656E64222C722C61292C6D61726B657253746172743A6728652C226D657373616765666C6F772D7374617274222C722C61292C7374726F6B653A612C7374726F6B654461736861727261793A2231302C203131222C7374726F6B6557696474683A312E';
wwv_flow_imp.g_varchar2_table(38964) := '357D293B696628692E67657428226D6573736167655265662229297B76617220683D642E676574506F696E7441744C656E67746828642E676574546F74616C4C656E67746828292F32292C753D6F2E6765745363616C65645061746828224D4553534147';
wwv_flow_imp.g_varchar2_table(38965) := '455F464C4F575F4D41524B4552222C7B616273706F733A7B783A682E782C793A682E797D7D292C703D7B7374726F6B6557696474683A317D3B22696E6974696174696E67223D3D3D732E67657428226D65737361676556697369626C654B696E6422293F';
wwv_flow_imp.g_varchar2_table(38966) := '28702E66696C6C3D722C702E7374726F6B653D61293A28702E66696C6C3D612C702E7374726F6B653D72293B766172206D3D5F28652C752C70292C663D4428652C692E67657428226D65737361676552656622292E67657428226E616D6522292C7B616C';
wwv_flow_imp.g_varchar2_table(38967) := '69676E3A2263656E7465722D746F70222C666974426F783A21302C7374796C653A7B66696C6C3A617D7D292C763D6D2E67657442426F7828292C773D662E67657442426F7828293B766928662C682E782D772E77696474682F322C682E792B762E686569';
wwv_flow_imp.g_varchar2_table(38968) := '6768742F322B31302C30297D72657475726E20647D2C2262706D6E3A506172616C6C656C47617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4F28652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D';
wwv_flow_imp.g_varchar2_table(38969) := '29293B72657475726E205F28652C6F2E6765745363616C6564506174682822474154455741595F504152414C4C454C222C7B785363616C65466163746F723A2E362C795363616C65466163746F723A2E362C636F6E7461696E657257696474683A742E77';
wwv_flow_imp.g_varchar2_table(38970) := '696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E34362C6D793A2E327D7D292C7B66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F6B653A627328742C632C6E2E7374726F6B';
wwv_flow_imp.g_varchar2_table(38971) := '65292C7374726F6B6557696474683A317D292C697D2C2262706D6E3A5061727469636970616E74223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D5228652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65222C22776964';
wwv_flow_imp.g_varchar2_table(38972) := '7468222C22686569676874225D29292C6F3D28302C72732E4176292874292C733D28302C72732E2462292874292C723D28302C792E676574427573696E6573734F626A656374292874292C613D722E67657428226E616D6522293B6966286F297628652C';
wwv_flow_imp.g_varchar2_table(38973) := '733F5B7B783A33302C793A307D2C7B783A33302C793A437328742C6E297D5D3A5B7B783A302C793A33307D2C7B783A777328742C6E292C793A33307D5D2C7B7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A31';
wwv_flow_imp.g_varchar2_table(38974) := '2E357D292C4928652C612C742C6E293B656C73657B766172206C3D797328742C6E293B737C7C286C2E6865696768743D777328742C6E292C6C2E77696474683D437328742C6E29293B76617220683D4428652C612C7B626F783A6C2C616C69676E3A2263';
wwv_flow_imp.g_varchar2_table(38975) := '656E7465722D6D6964646C65222C7374796C653A7B66696C6C3A5F7328742C642C632C6E2E7374726F6B65297D7D293B737C7C766928682C302C312A437328742C6E292C323730297D72657475726E20722E67657428227061727469636970616E744D75';
wwv_flow_imp.g_varchar2_table(38976) := '6C7469706C6963697479222926264528225061727469636970616E744D756C7469706C69636974794D61726B6572222C652C742C6E292C697D2C2262706D6E3A526563656976655461736B223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D4573';
wwv_flow_imp.g_varchar2_table(38977) := '286E2C5B2266696C6C222C227374726F6B65225D293B76617220692C733D28302C792E676574427573696E6573734F626A656374292874292C723D4228652C742C6E293B72657475726E20732E6765742822696E7374616E746961746522293F286D2865';
wwv_flow_imp.g_varchar2_table(38978) := '2C32382C32382C342E342C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C693D6F2E6765745363616C65645061746828225441534B5F54595045';
wwv_flow_imp.g_varchar2_table(38979) := '5F494E5354414E54494154494E475F53454E44222C7B616273706F733A7B783A372E37372C793A392E35327D7D29293A693D6F2E6765745363616C65645061746828225441534B5F545950455F53454E44222C7B785363616C65466163746F723A2E392C';
wwv_flow_imp.g_varchar2_table(38980) := '795363616C65466163746F723A2E392C636F6E7461696E657257696474683A32312C636F6E7461696E65724865696768743A31342C706F736974696F6E3A7B6D783A2E332C6D793A2E347D7D292C5F28652C692C7B66696C6C3A767328742C6C2C6E2E66';
wwv_flow_imp.g_varchar2_table(38981) := '696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A5363726970745461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4228652C742C6E3D45';
wwv_flow_imp.g_varchar2_table(38982) := '73286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E205F28652C6F2E6765745363616C65645061746828225441534B5F545950455F534352495054222C7B616273706F733A7B783A31352C793A32307D7D292C7B66696C6C3A7673';
wwv_flow_imp.g_varchar2_table(38983) := '28742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C697D2C2262706D6E3A53656E645461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D422865';
wwv_flow_imp.g_varchar2_table(38984) := '2C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E205F28652C6F2E6765745363616C65645061746828225441534B5F545950455F53454E44222C7B785363616C65466163746F723A312C795363616C6546616374';
wwv_flow_imp.g_varchar2_table(38985) := '6F723A312C636F6E7461696E657257696474683A32312C636F6E7461696E65724865696768743A31342C706F736974696F6E3A7B6D783A2E3238352C6D793A2E3335377D7D292C7B66696C6C3A627328742C632C6E2E7374726F6B65292C7374726F6B65';
wwv_flow_imp.g_varchar2_table(38986) := '3A767328742C6C2C6E2E66696C6C292C7374726F6B6557696474683A317D292C697D2C2262706D6E3A53657175656E6365466C6F77223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D293B';
wwv_flow_imp.g_varchar2_table(38987) := '76617220693D767328742C6C2C6E2E66696C6C292C6F3D627328742C632C6E2E7374726F6B65292C733D6228652C742E776179706F696E74732C7B6D61726B6572456E643A6728652C2273657175656E6365666C6F772D656E64222C692C6F292C737472';
wwv_flow_imp.g_varchar2_table(38988) := '6F6B653A6F7D292C723D28302C792E676574427573696E6573734F626A656374292874292C7B736F757263653A617D3D743B69662861297B76617220643D28302C792E676574427573696E6573734F626A656374292861293B722E6765742822636F6E64';
wwv_flow_imp.g_varchar2_table(38989) := '6974696F6E45787072657373696F6E2229262628302C792E69732928642C2262706D6E3A416374697669747922292626666528732C7B6D61726B657253746172743A6728652C22636F6E646974696F6E616C2D666C6F772D6D61726B6572222C692C6F29';
wwv_flow_imp.g_varchar2_table(38990) := '7D292C642E676574282264656661756C74222926262828302C792E69732928642C2262706D6E3A4761746577617922297C7C28302C792E69732928642C2262706D6E3A41637469766974792229292626642E676574282264656661756C7422293D3D3D72';
wwv_flow_imp.g_varchar2_table(38991) := '2626666528732C7B6D61726B657253746172743A6728652C22636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572222C692C6F297D297D72657475726E20737D2C2262706D6E3A536572766963655461736B223A66756E637469';
wwv_flow_imp.g_varchar2_table(38992) := '6F6E28652C742C6E3D7B7D297B76617220693D4228652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E206D28652C31302C31302C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A226E6F';
wwv_flow_imp.g_varchar2_table(38993) := '6E65222C7472616E73666F726D3A227472616E736C61746528362C203629227D292C5F28652C6F2E6765745363616C65645061746828225441534B5F545950455F53455256494345222C7B616273706F733A7B783A31322C793A31387D7D292C7B66696C';
wwv_flow_imp.g_varchar2_table(38994) := '6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C6D28652C31302C31302C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A226E6F6E65';
wwv_flow_imp.g_varchar2_table(38995) := '222C7472616E73666F726D3A227472616E736C6174652831312C20313029227D292C5F28652C6F2E6765745363616C65645061746828225441534B5F545950455F53455256494345222C7B616273706F733A7B783A31372C793A32327D7D292C7B66696C';
wwv_flow_imp.g_varchar2_table(38996) := '6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C697D2C2262706D6E3A53746172744576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B766172';
wwv_flow_imp.g_varchar2_table(38997) := '7B72656E64657249636F6E3A693D21307D3D6E3B6E3D4573286E2C5B2266696C6C222C227374726F6B65225D292C28302C792E676574427573696E6573734F626A656374292874292E67657428226973496E74657272757074696E6722297C7C286E3D7B';
wwv_flow_imp.g_varchar2_table(38998) := '2E2E2E6E2C7374726F6B654461736861727261793A2236227D293B766172206F3D5028652C742C6E293B72657475726E206926267828742C652C6E292C6F7D2C2262706D6E3A53756250726F63657373223A66756E6374696F6E28652C742C6E3D7B7D29';
wwv_flow_imp.g_varchar2_table(38999) := '7B72657475726E204628652C742C6E3D28302C72732E4176292874293F4573286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A4573286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D';
wwv_flow_imp.g_varchar2_table(39000) := '6E3A5461736B223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204228652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A54657874416E6E6F746174696F6E223A66756E6374696F6E2865';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(39001) := '2C742C6E3D7B7D297B6E3D4573286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293B7661727B77696474683A692C6865696768743A737D3D797328742C6E292C723D6628652C692C732C302C302C7B66696C';
wwv_flow_imp.g_varchar2_table(39002) := '6C3A226E6F6E65222C7374726F6B653A226E6F6E65227D293B72657475726E205F28652C6F2E6765745363616C6564506174682822544558545F414E4E4F544154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A31';
wwv_flow_imp.g_varchar2_table(39003) := '2C636F6E7461696E657257696474683A692C636F6E7461696E65724865696768743A732C706F736974696F6E3A7B6D783A302C6D793A307D7D292C7B7374726F6B653A627328742C632C6E2E7374726F6B65297D292C4428652C28302C792E6765744275';
wwv_flow_imp.g_varchar2_table(39004) := '73696E6573734F626A656374292874292E67657428227465787422297C7C22222C7B616C69676E3A226C6566742D746F70222C626F783A797328742C6E292C70616464696E673A372C7374796C653A7B66696C6C3A5F7328742C642C632C6E2E7374726F';
wwv_flow_imp.g_varchar2_table(39005) := '6B65297D7D292C727D2C2262706D6E3A5472616E73616374696F6E223A66756E6374696F6E28652C742C693D7B7D297B693D28302C72732E4176292874293F457328692C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874';
wwv_flow_imp.g_varchar2_table(39006) := '225D293A457328692C5B2266696C6C222C227374726F6B65225D293B766172206F3D4628652C742C7B7374726F6B6557696474683A312E352C2E2E2E697D292C733D6E2E7374796C65285B226E6F2D66696C6C222C226E6F2D6576656E7473225D2C7B73';
wwv_flow_imp.g_varchar2_table(39007) := '74726F6B653A627328742C632C692E7374726F6B65292C7374726F6B6557696474683A312E357D293B72657475726E28302C72732E4176292874297C7C28693D7B7D292C6628652C777328742C69292C437328742C69292C372C332C73292C6F7D2C2262';
wwv_flow_imp.g_varchar2_table(39008) := '706D6E3A557365725461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4228652C742C6E3D4573286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E205F28652C6F2E6765745363616C6564506174682822';
wwv_flow_imp.g_varchar2_table(39009) := '5441534B5F545950455F555345525F31222C7B616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D';
wwv_flow_imp.g_varchar2_table(39010) := '292C5F28652C6F2E6765745363616C65645061746828225441534B5F545950455F555345525F32222C7B616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A767328742C6C2C6E2E66696C6C292C7374726F6B653A627328742C632C6E2E';
wwv_flow_imp.g_varchar2_table(39011) := '7374726F6B65292C7374726F6B6557696474683A2E357D292C5F28652C6F2E6765745363616C65645061746828225441534B5F545950455F555345525F33222C7B616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A627328742C632C6E';
wwv_flow_imp.g_varchar2_table(39012) := '2E7374726F6B65292C7374726F6B653A627328742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C697D2C6C6162656C3A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E2066756E6374696F6E28652C742C6E3D';
wwv_flow_imp.g_varchar2_table(39013) := '7B7D297B766172206F3D7B77696474683A39302C6865696768743A33302C783A742E77696474682F322B742E782C793A742E6865696768742F322B742E797D3B72657475726E204428652C70732874292C7B626F783A6F2C666974426F783A21302C7374';
wwv_flow_imp.g_varchar2_table(39014) := '796C653A28302C692E6B7029287B7D2C722E67657445787465726E616C5374796C6528292C7B66696C6C3A5F7328742C642C632C6E2E7374726F6B65297D297D297D28652C742C6E297D7D3B746869732E5F64726177506174683D5F2C746869732E5F72';
wwv_flow_imp.g_varchar2_table(39015) := '656E64657265723D437D66756E6374696F6E20457328652C743D5B5D297B72657475726E20742E726564756365282828742C6E293D3E28655B6E5D262628745B6E5D3D655B6E5D292C7429292C7B7D297D52286B732C5965292C6B732E24696E6A656374';
wwv_flow_imp.g_varchar2_table(39016) := '3D5B22636F6E6669672E62706D6E52656E6465726572222C226576656E74427573222C227374796C6573222C22706174684D6170222C2263616E766173222C227465787452656E6465726572225D2C6B732E70726F746F747970652E63616E52656E6465';
wwv_flow_imp.g_varchar2_table(39017) := '723D66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A42617365456C656D656E7422297D2C6B732E70726F746F747970652E6472617753686170653D66756E6374696F6E28652C742C6E3D7B7D297B7661727B7479';
wwv_flow_imp.g_varchar2_table(39018) := '70653A697D3D743B72657475726E20746869732E5F72656E646572657228692928652C742C6E297D2C6B732E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E3D7B7D297B7661727B747970653A697D3D';
wwv_flow_imp.g_varchar2_table(39019) := '743B72657475726E20746869732E5F72656E646572657228692928652C742C6E297D2C6B732E70726F746F747970652E6765745368617065506174683D66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A4576656E';
wwv_flow_imp.g_varchar2_table(39020) := '7422293F5A65285B5B224D222C28743D65292E782B742E77696474682F322C742E792B742E6865696768742F325D2C5B226D222C302C2D286E3D742E77696474682F32295D2C5B2261222C6E2C6E2C302C312C312C302C322A6E5D2C5B2261222C6E2C6E';
wwv_flow_imp.g_varchar2_table(39021) := '2C302C312C312C302C2D322A6E5D2C5B227A225D5D293A28302C792E69732928652C2262706D6E3A416374697669747922293F66756E6374696F6E28652C74297B766172206E3D652E782C693D652E792C6F3D652E77696474682C733D652E6865696768';
wwv_flow_imp.g_varchar2_table(39022) := '743B72657475726E205A65285B5B224D222C6E2B742C695D2C5B226C222C6F2D32302C305D2C5B2261222C742C742C302C302C312C742C745D2C5B226C222C302C732D32305D2C5B2261222C742C742C302C302C312C2D31302C745D2C5B226C222C3230';
wwv_flow_imp.g_varchar2_table(39023) := '2D6F2C305D2C5B2261222C742C742C302C302C312C2D31302C2D31305D2C5B226C222C302C32302D735D2C5B2261222C742C742C302C302C312C742C2D31305D2C5B227A225D5D297D28652C3130293A28302C792E69732928652C2262706D6E3A476174';
wwv_flow_imp.g_varchar2_table(39024) := '6577617922293F66756E6374696F6E2865297B76617220743D652E77696474682F322C6E3D652E6865696768742F323B72657475726E205A65285B5B224D222C652E782B742C652E795D2C5B226C222C742C6E5D2C5B226C222C2D742C6E5D2C5B226C22';
wwv_flow_imp.g_varchar2_table(39025) := '2C2D742C2D6E5D2C5B227A225D5D297D2865293A66756E6374696F6E2865297B76617220743D652E782C6E3D652E792C693D652E77696474683B72657475726E205A65285B5B224D222C742C6E5D2C5B226C222C692C305D2C5B226C222C302C652E6865';
wwv_flow_imp.g_varchar2_table(39026) := '696768745D2C5B226C222C2D692C305D2C5B227A225D5D297D2865293B76617220742C6E7D3B766172204C733D302C44733D7B77696474683A3135302C6865696768743A35307D3B66756E6374696F6E20547328652C74297B766172206E3B742E746578';
wwv_flow_imp.g_varchar2_table(39027) := '74436F6E74656E743D653B7472797B76617220692C6F3D22223D3D3D653B72657475726E20742E74657874436F6E74656E743D6F3F2264756D6D79223A652C693D7B77696474683A286E3D742E67657442426F782829292E77696474682B322A6E2E782C';
wwv_flow_imp.g_varchar2_table(39028) := '6865696768743A6E2E6865696768747D2C6F262628692E77696474683D30292C697D63617463682865297B72657475726E7B77696474683A302C6865696768743A307D7D7D66756E6374696F6E20497328652C742C6E297B666F722876617220692C6F3D';
wwv_flow_imp.g_varchar2_table(39029) := '652E736869667428292C733D6F3B3B297B69662828693D547328732C6E29292E77696474683D733F692E77696474683A302C2220223D3D3D737C7C22223D3D3D737C7C692E77696474683C4D6174682E726F756E642874297C7C732E6C656E6774683C32';
wwv_flow_imp.g_varchar2_table(39030) := '2972657475726E204D7328652C732C6F2C69293B733D4E7328732C692E77696474682C74297D7D66756E6374696F6E204D7328652C742C6E2C69297B696628742E6C656E6774683C6E2E6C656E677468297B766172206F3D6E2E736C69636528742E6C65';
wwv_flow_imp.g_varchar2_table(39031) := '6E677468292E7472696D28293B652E756E7368696674286F297D72657475726E7B77696474683A692E77696474682C6865696768743A692E6865696768742C746578743A747D7D7661722041733D22C2AD223B66756E6374696F6E204E7328652C742C6E';
wwv_flow_imp.g_varchar2_table(39032) := '297B76617220693D4D6174682E6D617828652E6C656E6774682A286E2F74292C31292C6F3D66756E6374696F6E28652C74297B766172206E2C693D652E73706C6974282F285C737C2D7C5C7530304144292F67292C6F3D5B5D2C733D303B696628692E6C';
wwv_flow_imp.g_varchar2_table(39033) := '656E6774683E3129666F72283B6E3D692E736869667428293B297B69662821286E2E6C656E6774682B733C7429297B222D22213D3D6E26266E213D3D41737C7C6F2E706F7028293B627265616B7D6F2E70757368286E292C732B3D6E2E6C656E6774687D';
wwv_flow_imp.g_varchar2_table(39034) := '76617220723D6F5B6F2E6C656E6774682D315D3B72657475726E20722626723D3D3D41732626286F5B6F2E6C656E6774682D315D3D222D22292C6F2E6A6F696E282222297D28652C69293B72657475726E206F7C7C286F3D652E736C69636528302C4D61';
wwv_flow_imp.g_varchar2_table(39035) := '74682E6D6178284D6174682E726F756E6428692D31292C312929292C6F7D66756E6374696F6E2050732865297B746869732E5F636F6E6669673D28302C692E6B7029287B7D2C7B73697A653A44732C70616464696E673A4C732C7374796C653A7B7D2C61';
wwv_flow_imp.g_varchar2_table(39036) := '6C69676E3A2263656E7465722D746F70227D2C657C7C7B7D297D66756E6374696F6E204F732865297B76617220743D28302C692E6B7029287B666F6E7446616D696C793A22417269616C2C2073616E732D7365726966222C666F6E7453697A653A31322C';
wwv_flow_imp.g_varchar2_table(39037) := '666F6E745765696768743A226E6F726D616C222C6C696E654865696768743A312E327D2C652626652E64656661756C745374796C657C7C7B7D292C6E3D7061727365496E7428742E666F6E7453697A652C3130292D312C6F3D28302C692E6B7029287B7D';
wwv_flow_imp.g_varchar2_table(39038) := '2C742C7B666F6E7453697A653A6E7D2C652626652E65787465726E616C5374796C657C7C7B7D292C733D6E6577205073287B7374796C653A747D293B746869732E67657445787465726E616C4C6162656C426F756E64733D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(39039) := '297B766172206E3D732E67657444696D656E73696F6E7328742C7B626F783A7B77696474683A39302C6865696768743A33307D2C7374796C653A6F7D293B72657475726E7B783A4D6174682E726F756E6428652E782B652E77696474682F322D6E2E7769';
wwv_flow_imp.g_varchar2_table(39040) := '6474682F32292C793A4D6174682E726F756E6428652E79292C77696474683A4D6174682E6365696C286E2E7769647468292C6865696768743A4D6174682E6365696C286E2E686569676874297D7D2C746869732E67657454657874416E6E6F746174696F';
wwv_flow_imp.g_varchar2_table(39041) := '6E426F756E64733D66756E6374696F6E28652C6E297B76617220693D732E67657444696D656E73696F6E73286E2C7B626F783A652C7374796C653A742C616C69676E3A226C6566742D746F70222C70616464696E673A357D293B72657475726E7B783A65';
wwv_flow_imp.g_varchar2_table(39042) := '2E782C793A652E792C77696474683A652E77696474682C6865696768743A4D6174682E6D61782833302C4D6174682E726F756E6428692E68656967687429297D7D2C746869732E637265617465546578743D66756E6374696F6E28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(39043) := '726E20732E6372656174655465787428652C747C7C7B7D297D2C746869732E67657444656661756C745374796C653D66756E6374696F6E28297B72657475726E20747D2C746869732E67657445787465726E616C5374796C653D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(39044) := '7B72657475726E206F7D7D50732E70726F746F747970652E637265617465546578743D66756E6374696F6E28652C74297B72657475726E20746869732E6C61796F75745465787428652C74292E656C656D656E747D2C50732E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(39045) := '657444696D656E73696F6E733D66756E6374696F6E28652C74297B72657475726E20746869732E6C61796F75745465787428652C74292E64696D656E73696F6E737D2C50732E70726F746F747970652E6C61796F7574546578743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(39046) := '652C74297B766172206E2C6F3D28302C692E6B7029287B7D2C746869732E5F636F6E6669672E73697A652C742E626F78292C733D28302C692E6B7029287B7D2C746869732E5F636F6E6669672E7374796C652C742E7374796C65292C723D66756E637469';
wwv_flow_imp.g_varchar2_table(39047) := '6F6E2865297B76617220743D652E73706C697428222D22293B72657475726E7B686F72697A6F6E74616C3A745B305D7C7C2263656E746572222C766572746963616C3A745B315D7C7C22746F70227D7D28742E616C69676E7C7C746869732E5F636F6E66';
wwv_flow_imp.g_varchar2_table(39048) := '69672E616C69676E292C613D66756E6374696F6E2865297B72657475726E28302C692E4776292865293F28302C692E6B7029287B746F703A302C6C6566743A302C72696768743A302C626F74746F6D3A307D2C65293A7B746F703A652C6C6566743A652C';
wwv_flow_imp.g_varchar2_table(39049) := '72696768743A652C626F74746F6D3A657D7D28766F69642030213D3D742E70616464696E673F742E70616464696E673A746869732E5F636F6E6669672E70616464696E67292C6C3D742E666974426F787C7C21312C633D66756E6374696F6E2865297B69';
wwv_flow_imp.g_varchar2_table(39050) := '662822666F6E7453697A6522696E20652626226C696E6548656967687422696E20652972657475726E20652E6C696E654865696768742A7061727365496E7428652E666F6E7453697A652C3130297D2873292C643D652E73706C6974282F5C7530304144';
wwv_flow_imp.g_varchar2_table(39051) := '3F5C723F5C6E2F292C683D5B5D2C753D6F2E77696474682D612E6C6566742D612E72696768742C703D6B6528227465787422293B666F7228666528702C7B783A302C793A307D292C666528702C73292C756528286E3D766F696420302C286E3D646F6375';
wwv_flow_imp.g_varchar2_table(39052) := '6D656E742E676574456C656D656E7442794964282268656C7065722D7376672229297C7C286665286E3D6B65282273766722292C7B69643A2268656C7065722D737667227D292C4374286E2C7B7669736962696C6974793A2268696464656E222C706F73';
wwv_flow_imp.g_varchar2_table(39053) := '6974696F6E3A226669786564222C77696474683A302C6865696768743A307D292C646F63756D656E742E626F64792E617070656E644368696C64286E29292C6E292C70293B642E6C656E6774683B29682E7075736828497328642C752C7029293B226D69';
wwv_flow_imp.g_varchar2_table(39054) := '64646C65223D3D3D722E766572746963616C262628612E746F703D612E626F74746F6D3D30293B76617220673D28302C692E54532928682C2866756E6374696F6E28652C742C6E297B72657475726E20652B28637C7C742E686569676874297D292C3029';
wwv_flow_imp.g_varchar2_table(39055) := '2B612E746F702B612E626F74746F6D2C6D3D28302C692E54532928682C2866756E6374696F6E28652C742C6E297B72657475726E20742E77696474683E653F742E77696474683A657D292C30292C663D612E746F703B226D6964646C65223D3D3D722E76';
wwv_flow_imp.g_varchar2_table(39056) := '6572746963616C262628662B3D286F2E6865696768742D67292F32292C662D3D28637C7C685B305D2E686569676874292F343B76617220763D6B6528227465787422293B72657475726E20666528762C73292C28302C692E6A4A2928682C2866756E6374';
wwv_flow_imp.g_varchar2_table(39057) := '696F6E2865297B76617220743B73776974636828662B3D637C7C652E6865696768742C722E686F72697A6F6E74616C297B63617365226C656674223A743D612E6C6566743B627265616B3B63617365227269676874223A743D286C3F6D3A75292D612E72';
wwv_flow_imp.g_varchar2_table(39058) := '696768742D652E77696474683B627265616B3B64656661756C743A743D4D6174682E6D61782828286C3F6D3A75292D652E7769647468292F322B612E6C6566742C30297D766172206E3D6B652822747370616E22293B6665286E2C7B783A742C793A667D';
wwv_flow_imp.g_varchar2_table(39059) := '292C6E2E74657874436F6E74656E743D652E746578742C756528762C6E297D29292C52652870292C7B64696D656E73696F6E733A7B77696474683A6D2C6865696768743A677D2C656C656D656E743A767D7D2C4F732E24696E6A6563743D5B22636F6E66';
wwv_flow_imp.g_varchar2_table(39060) := '69672E7465787452656E6465726572225D3B7661722052733D2F5C7B285B5E7B7D5D2B295C7D2F672C46733D2F283F3A283F3A5E7C5C2E29282E2B3F29283F3D5C5B7C5C2E7C247C5C28297C5C5B28277C2229282E2B3F295C325C5D29285C285C29293F';
wwv_flow_imp.g_varchar2_table(39061) := '2F673B636F6E73742042733D7B5F5F696E69745F5F3A5B2262706D6E52656E6465726572225D2C62706D6E52656E64657265723A5B2274797065222C6B735D2C7465787452656E64657265723A5B2274797065222C4F735D2C706174684D61703A5B2274';
wwv_flow_imp.g_varchar2_table(39062) := '797065222C66756E6374696F6E28297B746869732E706174684D61703D7B4556454E545F4D4553534147453A7B643A226D207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B65';
wwv_flow_imp.g_varchar2_table(39063) := '2E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C4556454E';
wwv_flow_imp.g_varchar2_table(39064) := '545F5349474E414C3A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78317D2C30205A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B31385D2C7769647468';
wwv_flow_imp.g_varchar2_table(39065) := '456C656D656E74733A5B31302C32305D7D2C4556454E545F455343414C4154494F4E3A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78307D2C2D7B652E79317D206C202D7B652E78307D2C7B652E7931';
wwv_flow_imp.g_varchar2_table(39066) := '7D205A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B32302C375D2C7769647468456C656D656E74733A5B385D7D2C4556454E545F434F4E444954494F4E414C3A7B643A224D207B652E78307D2C7B652E79';
wwv_flow_imp.g_varchar2_table(39067) := '307D206C207B652E78317D2C30206C20302C7B652E79327D206C202D7B652E78317D2C30205A204D207B652E78327D2C7B652E79337D206C207B652E78307D2C30204D207B652E78327D2C7B652E79347D206C207B652E78307D2C30204D207B652E7832';
wwv_flow_imp.g_varchar2_table(39068) := '7D2C7B652E79357D206C207B652E78307D2C30204D207B652E78327D2C7B652E79367D206C207B652E78307D2C30204D207B652E78327D2C7B652E79377D206C207B652E78307D2C30204D207B652E78327D2C7B652E79387D206C207B652E78307D2C30';
wwv_flow_imp.g_varchar2_table(39069) := '20222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B382E352C31342E352C31382C31312E352C31342E352C31372E352C32302E352C32332E352C32362E355D2C7769647468456C656D656E74733A5B31302E35';
wwv_flow_imp.g_varchar2_table(39070) := '2C31342E352C31322E355D7D2C4556454E545F4C494E4B3A7B643A226D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C2D7B652E79327D';
wwv_flow_imp.g_varchar2_table(39071) := '202D7B652E78307D2C2D7B652E79327D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B342E343337352C362E37352C372E383132355D2C7769647468456C656D656E74733A5B392E38343337352C3133';
wwv_flow_imp.g_varchar2_table(39072) := '2E355D7D2C4556454E545F4552524F523A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D207B652E78317D2C2D7B652E79317D207B652E78327D2C7B652E79327D207B652E78337D2C2D7B652E79337D202D7B652E78347D2C';
wwv_flow_imp.g_varchar2_table(39073) := '7B652E79347D202D7B652E78357D2C2D7B652E79357D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B2E3032332C382E3733372C382E3135312C31362E3536342C31302E3539312C382E3731345D2C77';
wwv_flow_imp.g_varchar2_table(39074) := '69647468456C656D656E74733A5B2E3038352C362E3637322C362E39372C342E3237332C352E3333372C362E3633365D7D2C4556454E545F43414E43454C5F34353A7B643A226D207B6D787D2C7B6D797D202D7B652E78317D2C3020302C7B652E78307D';
wwv_flow_imp.g_varchar2_table(39075) := '207B652E78317D2C3020302C7B652E79317D207B652E78307D2C3020302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30207A222C6865696768743A33362C';
wwv_flow_imp.g_varchar2_table(39076) := '77696474683A33362C686569676874456C656D656E74733A5B342E37352C382E355D2C7769647468456C656D656E74733A5B342E37352C382E355D7D2C4556454E545F434F4D50454E534154494F4E3A7B643A226D207B6D787D2C7B6D797D207B652E78';
wwv_flow_imp.g_varchar2_table(39077) := '307D2C2D7B652E79307D20302C7B652E79317D207A206D207B652E78317D2C2D7B652E79327D207B652E78327D2C2D7B652E79337D20302C7B652E79317D202D7B652E78327D2C2D7B652E79337D207A222C6865696768743A33362C77696474683A3336';
wwv_flow_imp.g_varchar2_table(39078) := '2C686569676874456C656D656E74733A5B362E352C31332C2E342C362E315D2C7769647468456C656D656E74733A5B392C392E332C382E375D7D2C4556454E545F54494D45525F57483A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C2D';
wwv_flow_imp.g_varchar2_table(39079) := '7B652E79307D206D202D7B652E78307D2C7B652E79307D206C207B652E78317D2C7B652E79317D20222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B31302C325D2C7769647468456C656D656E74733A5B332C';
wwv_flow_imp.g_varchar2_table(39080) := '375D7D2C4556454E545F54494D45525F4C494E453A7B643A224D207B6D787D2C7B6D797D206D207B652E78307D2C7B652E79307D206C202D7B652E78317D2C7B652E79317D20222C6865696768743A33362C77696474683A33362C686569676874456C65';
wwv_flow_imp.g_varchar2_table(39081) := '6D656E74733A5B31302C335D2C7769647468456C656D656E74733A5B302C305D7D2C4556454E545F4D554C5449504C453A7B643A226D207B6D787D2C7B6D797D207B652E78317D2C2D7B652E79307D207B652E78317D2C7B652E79307D202D7B652E7830';
wwv_flow_imp.g_varchar2_table(39082) := '7D2C7B652E79317D202D7B652E78327D2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B362E32383039392C31322E35363139395D2C7769647468456C656D656E74733A5B332E313430352C392E34';
wwv_flow_imp.g_varchar2_table(39083) := '323134392C31322E35363139385D7D2C4556454E545F504152414C4C454C5F4D554C5449504C453A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C';
wwv_flow_imp.g_varchar2_table(39084) := '3020302C7B652E79317D202D7B652E78307D2C3020302C2D7B652E79317D202D7B652E78317D2C3020302C2D7B652E79307D207B652E78317D2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B322E';
wwv_flow_imp.g_varchar2_table(39085) := '35363232382C372E36383638335D2C7769647468456C656D656E74733A5B322E35363232382C372E36383638335D7D2C474154455741595F4558434C55534956453A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78';
wwv_flow_imp.g_varchar2_table(39086) := '317D2C7B652E79307D207B652E78327D2C30207B652E78347D2C7B652E79327D207B652E78347D2C7B652E79317D207B652E78327D2C30207B652E78317D2C7B652E79337D207B652E78307D2C7B652E79337D207B652E78337D2C30207B652E78357D2C';
wwv_flow_imp.g_varchar2_table(39087) := '7B652E79317D207B652E78357D2C7B652E79327D207B652E78337D2C30207A222C6865696768743A31372E352C77696474683A31372E352C686569676874456C656D656E74733A5B382E352C362E353331322C2D362E353331322C2D382E355D2C776964';
wwv_flow_imp.g_varchar2_table(39088) := '7468456C656D656E74733A5B362E352C2D362E352C332C2D332C352C2D355D7D2C474154455741595F504152414C4C454C3A7B643A226D207B6D787D2C7B6D797D20302C7B652E79317D202D7B652E78317D2C3020302C7B652E79307D207B652E78317D';
wwv_flow_imp.g_varchar2_table(39089) := '2C3020302C7B652E79317D207B652E78307D2C3020302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30207A222C6865696768743A33302C77696474683A33';
wwv_flow_imp.g_varchar2_table(39090) := '302C686569676874456C656D656E74733A5B352C31322E355D2C7769647468456C656D656E74733A5B352C31322E355D7D2C474154455741595F4556454E545F42415345443A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D20';
wwv_flow_imp.g_varchar2_table(39091) := '7B652E78307D2C7B652E79317D207B652E78317D2C7B652E79327D207B652E78327D2C30207A222C6865696768743A31312C77696474683A31312C686569676874456C656D656E74733A5B2D362C362C31322C2D31325D2C7769647468456C656D656E74';
wwv_flow_imp.g_varchar2_table(39092) := '733A5B392C2D332C2D31325D7D2C474154455741595F434F4D504C45583A7B643A226D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C7B652E79327D207B652E78307D2C7B652E79317D20';
wwv_flow_imp.g_varchar2_table(39093) := '2D7B652E78327D2C3020302C7B652E79337D207B652E78327D2C3020202D7B652E78307D2C7B652E79317D206C207B652E78317D2C7B652E79327D207B652E78307D2C2D7B652E79317D20302C7B652E79307D207B652E78337D2C3020302C2D7B652E79';
wwv_flow_imp.g_varchar2_table(39094) := '307D207B652E78307D2C7B652E79317D207B652E78317D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79317D207B652E78327D2C3020302C2D7B652E79337D202D7B652E78327D2C30207B652E78307D2C2D7B652E79317D202D7B652E78317D2C';
wwv_flow_imp.g_varchar2_table(39095) := '2D7B652E79327D202D7B652E78307D2C7B652E79317D20302C2D7B652E79307D202D7B652E78337D2C30207A222C6865696768743A31372E3132352C77696474683A31372E3132352C686569676874456C656D656E74733A5B342E3837352C332E343337';
wwv_flow_imp.g_varchar2_table(39096) := '352C322E3132352C335D2C7769647468456C656D656E74733A5B332E343337352C322E3132352C342E3837352C335D7D2C444154415F4F424A4543545F504154483A7B643A226D20302C30207B652E78317D2C30207B652E78307D2C7B652E79307D2030';
wwv_flow_imp.g_varchar2_table(39097) := '2C7B652E79317D202D7B652E78327D2C3020302C2D7B652E79327D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C30222C6865696768743A36312C77696474683A35312C686569676874456C656D656E74733A5B31302C35302C36305D';
wwv_flow_imp.g_varchar2_table(39098) := '2C7769647468456C656D656E74733A5B31302C34302C35302C36305D7D2C444154415F4F424A4543545F434F4C4C454354494F4E5F504154483A7B643A226D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130';
wwv_flow_imp.g_varchar2_table(39099) := '206D20332C2D3130206C20302C3130222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C444154415F4152524F573A7B643A226D20352C3920392C3020302C2D';
wwv_flow_imp.g_varchar2_table(39100) := '3320352C35202D352C3520302C2D33202D392C30207A222C6865696768743A36312C77696474683A35312C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C444154415F53544F52453A7B643A226D20207B6D78';
wwv_flow_imp.g_varchar2_table(39101) := '7D2C7B6D797D206C2020302C7B652E79327D206320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C30206C2020302C2D7B652E79327D2063202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D';
wwv_flow_imp.g_varchar2_table(39102) := '7B652E79317D202D7B652E78327D2C306320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C30206D20202D7B652E78327D2C7B652E79307D6320207B652E78307D2C7B652E79317D207B652E78317D2C7B65';
wwv_flow_imp.g_varchar2_table(39103) := '2E79317D207B652E78327D2C306D20202D7B652E78327D2C7B652E79307D6320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C30222C6865696768743A36312C77696474683A36312C686569676874456C65';
wwv_flow_imp.g_varchar2_table(39104) := '6D656E74733A5B372C31302C34355D2C7769647468456C656D656E74733A5B322C35382C36305D7D2C544558545F414E4E4F544154494F4E3A7B643A226D207B6D787D2C207B6D797D206D2031302C30206C202D31302C30206C20302C7B652E79307D20';
wwv_flow_imp.g_varchar2_table(39105) := '6C2031302C30222C6865696768743A33302C77696474683A31302C686569676874456C656D656E74733A5B33305D2C7769647468456C656D656E74733A5B31305D7D2C4D41524B45525F5355425F50524F434553533A7B643A226D7B6D787D2C7B6D797D';
wwv_flow_imp.g_varchar2_table(39106) := '206D20372C32206C20302C3130206D202D352C2D35206C2031302C30222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F504152414C4C454C';
wwv_flow_imp.g_varchar2_table(39107) := '3A7B643A226D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C3130222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C776964';
wwv_flow_imp.g_varchar2_table(39108) := '7468456C656D656E74733A5B5D7D2C4D41524B45525F53455155454E5449414C3A7B643A226D7B6D787D2C7B6D797D206D20302C33206C2031302C30206D202D31302C33206C2031302C30206D202D31302C33206C2031302C30222C6865696768743A31';
wwv_flow_imp.g_varchar2_table(39109) := '302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F434F4D50454E534154494F4E3A7B643A226D207B6D787D2C7B6D797D20372C2D3520302C3130207A206D20372E31';
wwv_flow_imp.g_varchar2_table(39110) := '2C2D302E3320362E392C2D342E3720302C3130202D362E392C2D342E37207A222C6865696768743A31302C77696474683A32312C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F4C4F4F503A';
wwv_flow_imp.g_varchar2_table(39111) := '7B643A226D207B6D787D2C7B6D797D206320332E3532363937392C3020362E3338363136312C2D322E38323938353820362E3338363136312C2D362E33323036363120302C2D332E343930383036202D322E3835393138322C2D362E333230363631202D';
wwv_flow_imp.g_varchar2_table(39112) := '362E3338363136312C2D362E333230363631202D332E3532363937382C30202D362E33383631362C322E383239383535202D362E33383631362C362E33323036363120302C312E37343534303220302E3731343739372C332E33323535363720312E3837';
wwv_flow_imp.g_varchar2_table(39113) := '303436332C342E34363933383120302E3537373833342C302E35373139303820312E3236353838352C312E30333437323820322E3032393931362C312E3335343537206C202D302E3731383136332C2D332E393039373933206D20302E3731383136332C';
wwv_flow_imp.g_varchar2_table(39114) := '332E393039373933202D332E3838353231312C302E383032393032222C6865696768743A31332E392C77696474683A31332E372C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F4144484F43';
wwv_flow_imp.g_varchar2_table(39115) := '3A7B643A226D207B6D787D2C7B6D797D206D20302E38343436312C322E3634343131206320312E30353533332C2D312E323337383039393620322E36343333372C2D322E303738383220342E32393635332C2D312E393739393739393620322E30353136';
wwv_flow_imp.g_varchar2_table(39116) := '332C302E3038303520332E38353537392C312E313538303320352E37363038322C312E373931303720312E30363338352C302E333431333939393620322E32343435342C302E3134333820332E31383735392C2D302E343337363720302E36313734332C';
wwv_flow_imp.g_varchar2_table(39117) := '2D302E333336343220312E323737352C2D302E363430373820312E373534322C2D312E313735313120302C302E353630323320302C312E313230343620302C312E36383037202D302E39383730362C302E3936323337393936202D322E32393739322C31';
wwv_flow_imp.g_varchar2_table(39118) := '2E3632333933393936202D332E363931382C312E3636313831393936202D312E32343435392C302E30393237202D322E34363637312C2D302E32343931202D332E35393530352C2D302E3734383132202D312E33353738392C2D302E3535393635202D32';
wwv_flow_imp.g_varchar2_table(39119) := '2E37353133332C2D312E3333343336393936202D342E32373032372C2D312E3138313231393936202D312E33373734312C302E3134363031202D322E34313834322C312E3133363835393936202D332E34343238382C312E3936373832393936207A222C';
wwv_flow_imp.g_varchar2_table(39120) := '6865696768743A342C77696474683A31352C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C5441534B5F545950455F53454E443A7B643A226D207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B65';
wwv_flow_imp.g_varchar2_table(39121) := '2E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D222C6865696768743A31342C77696474683A32312C686569676874456C656D656E74733A5B362C31345D2C77696474';
wwv_flow_imp.g_varchar2_table(39122) := '68456C656D656E74733A5B31302E352C32315D7D2C5441534B5F545950455F5343524950543A7B643A226D207B6D787D2C7B6D797D206320392E3936363535332C2D362E3237323736202D382E3030303932362C2D372E393139333220322E3936383936';
wwv_flow_imp.g_varchar2_table(39123) := '382C2D31342E393338206C202D382E3830323732382C302063202D31302E3936393839342C372E303138363820362E3939373538352C382E3636353234202D322E3936383936372C31342E393338207A206D202D372C2D3132206C20352C30206D202D34';
wwv_flow_imp.g_varchar2_table(39124) := '2E352C33206C20342E352C30206D202D332C33206C20352C306D202D342C33206C20352C30222C6865696768743A31352C77696474683A31322E362C686569676874456C656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E';
wwv_flow_imp.g_varchar2_table(39125) := '352C32315D7D2C5441534B5F545950455F555345525F313A7B643A226D207B6D787D2C7B6D797D206320302E3930392C2D302E38343520312E3539342C2D322E30343920312E3539342C2D332E33383520302C2D322E353534202D312E3830352C2D342E';
wwv_flow_imp.g_varchar2_table(39126) := '3632313939393939202D342E3335372C2D342E3632313939393939202D322E35353139393939382C30202D342E32383739393939382C322E3036373939393939202D342E32383739393939382C342E363231393939393920302C312E33343820302E3937';
wwv_flow_imp.g_varchar2_table(39127) := '342C322E35363220312E38393539393939382C332E343035202D302E35323839393939382C302E313837202D352E3636392C322E303937202D352E3739342C342E37353630303035207620362E37313820682031372076202D362E373138206320302C2D';
wwv_flow_imp.g_varchar2_table(39128) := '322E32393830303035202D352E353237393939362C2D342E35393530303035202D362E303530393939362C2D342E37373630303035207A6D202D382C36206C20302C352E35206D2031312C30206C20302C2D35227D2C5441534B5F545950455F55534552';
wwv_flow_imp.g_varchar2_table(39129) := '5F323A7B643A226D207B6D787D2C7B6D797D206D20322E3136322C312E303039206320302C322E34343730303035202D322E3135382C342E34333130303035202D342E3832312C342E34333130303035202D322E36363439393939382C30202D342E3832';
wwv_flow_imp.g_varchar2_table(39130) := '322C2D312E393831202D342E3832322C2D342E3433313030303520227D2C5441534B5F545950455F555345525F333A7B643A226D207B6D787D2C7B6D797D206D202D362E392C2D332E3830206320302C3020322E32353039393939382C2D322E33353820';
wwv_flow_imp.g_varchar2_table(39131) := '342E32373339393939382C2D312E31373720322E3032342C312E31383120342E3232312C312E35333720342E3132342C302E393635202D302E3039382C2D302E3537202D302E3131372C2D332E3739303939393939202D342E3139312C2D342E31333539';
wwv_flow_imp.g_varchar2_table(39132) := '39393939202D332E35373439393939382C302E303031202D342E32303739393939382C332E3336363939393939202D342E32303639393939382C342E3334373939393939207A227D2C5441534B5F545950455F4D414E55414C3A7B643A226D207B6D787D';
wwv_flow_imp.g_varchar2_table(39133) := '2C7B6D797D206320302E3233342C2D302E303120352E3630342C302E30303820382E3032392C302E30303420302E3830382C3020312E3237312C2D302E31373220312E3431372C2D302E37353220302E3232372C2D302E383938202D302E3333342C2D31';
wwv_flow_imp.g_varchar2_table(39134) := '2E333134202D312E3333382C2D312E333136202D322E3436372C2D302E3031202D372E3838362C2D302E303034202D382E3130382C2D302E303034202D302E3031342C2D302E30373920302E3031362C2D302E35333320302C2D302E363120302E313935';
wwv_flow_imp.g_varchar2_table(39135) := '2C2D302E30343220382E3530372C302E30303620392E3631362C302E30303220302E3837372C2D302E30303720312E33352C2D302E34333820312E3335332C2D312E32303820302E3030332C2D302E373638202D302E3437392C2D312E3039202D312E33';
wwv_flow_imp.g_varchar2_table(39136) := '352C2D312E303931202D322E3936382C2D302E303032202D392E3631392C2D302E303133202D392E3631392C2D302E3031332076202D302E353931206320302C3020352E3035322C2D302E30313620372E3232352C2D302E30313620302E3838382C2D30';
wwv_flow_imp.g_varchar2_table(39137) := '2E30303220312E3335342C2D302E34313620312E3335312C2D312E313933202D302E3030362C2D302E373631202D302E3439322C2D312E313936202D312E3336312C2D312E313936202D332E3437332C2D302E303035202D31302E38362C2D302E303033';
wwv_flow_imp.g_varchar2_table(39138) := '202D31312E303832393939352C2D302E303033202D302E3032322C2D302E303437202D302E3034352C2D302E303934202D302E3036392C2D302E31333920302E333933393939352C2D302E33313920322E303430393939352C2D312E36323620322E3431';
wwv_flow_imp.g_varchar2_table(39139) := '34393939352C2D322E30313720302E3436392C2D302E3438373030303520302E3531392C2D312E3136353030303520302E3136322C2D312E36303430303035202D302E3431342C2D302E353131202D302E3937332C2D302E35202D312E34382C2D302E32';
wwv_flow_imp.g_varchar2_table(39140) := '3336202D312E343630393939352C302E373634202D362E353939393939352C332E36343330303035202D372E373332393939352C342E32373130303035202D302E392C302E343939202D312E3531362C312E323533202D312E3838322C322E3139202D30';
wwv_flow_imp.g_varchar2_table(39141) := '2E33373030303030322C302E3935202D302E31372C322E3031202D302E3136362C322E39373920302E3030342C302E373138202D302E32373330303030322C312E333435202D302E3035352C322E30363320302E3632392C322E30383720322E3432352C';
wwv_flow_imp.g_varchar2_table(39142) := '332E33313220342E3835392C332E33313820342E363137393939352C302E30313420392E323337393939352C2D302E3133392031332E383536393939352C2D302E31353820302E3735352C2D302E30303420312E3137312C2D302E33303120312E313832';
wwv_flow_imp.g_varchar2_table(39143) := '2C2D312E30333320302E3031322C2D302E373534202D302E3432332C2D302E393639202D312E3138332C2D302E393733202D312E3737382C2D302E3031202D352E3832342C2D302E303034202D362E30342C2D302E303034203130652D342C2D302E3038';
wwv_flow_imp.g_varchar2_table(39144) := '3420302E3030332C2D302E353836203130652D342C2D302E3637207A227D2C5441534B5F545950455F494E5354414E54494154494E475F53454E443A7B643A226D207B6D787D2C7B6D797D206C20302C382E34206C2031322E362C30206C20302C2D382E';
wwv_flow_imp.g_varchar2_table(39145) := '34207A206C20362E332C332E36206C20362E332C2D332E36227D2C5441534B5F545950455F534552564943453A7B643A226D207B6D787D2C7B6D797D2076202D312E3731333335206320302E3335323332362C2D302E3037303520302E3730333933322C';
wwv_flow_imp.g_varchar2_table(39146) := '2D302E313738333820312E3034373632382C2D302E333231333320302E3334343431362C2D302E313434363520302E3636353832322C2D302E333231333320302E3936363337372C2D302E3532313435206C20312E31393433312C312E31383030352031';
wwv_flow_imp.g_varchar2_table(39147) := '2E3536373438372C2D312E3537363838202D312E3139353032382C2D312E3138303134206320302E3430333337362C2D302E363133393420302E3638333037392C2D312E323939303820302E3832353434372C2D322E3031383234206C20312E36323231';
wwv_flow_imp.g_varchar2_table(39148) := '33332C2D302E30312076202D322E32313936206C202D312E3633363531342C302E30312063202D302E30373333332C2D302E3335313533202D302E3137383331392C2D302E3730303234202D302E3332333536342C2D312E3034333732202D302E313435';
wwv_flow_imp.g_varchar2_table(39149) := '3234342C2D302E3334343036202D302E3332313430372C2D302E36363434202D302E3532323733352C2D302E3936323137206C20312E3133313033352C2D312E3133363331202D312E3538333330352C2D312E3536323933202D312E3132393539382C31';
wwv_flow_imp.g_varchar2_table(39150) := '2E31333538392063202D302E3631343035322C2D302E3430313038202D312E3330323838332C2D302E3638303933202D322E3032323633332C2D302E3832323437206C20302E303039332C2D312E36313835322068202D322E323431313733206C20302E';
wwv_flow_imp.g_varchar2_table(39151) := '303034322C312E36333132342063202D302E3335333736332C302E30373336202D302E3730353336392C302E3137393737202D312E3034393738352C302E3332333731202D302E3334343431352C302E3134343337202D302E3636353130322C302E3332';
wwv_flow_imp.g_varchar2_table(39152) := '303932202D302E393633353030362C302E3532303436206C202D312E313639383632382C2D312E3135383233202D312E353636373639312C312E3537393220312E313638343236352C312E31353636392063202D302E343032363537332C302E36313238';
wwv_flow_imp.g_varchar2_table(39153) := '33202D302E36383330382C312E3239373937202D302E383234373238372C322E3031373133206C202D312E363538383034312C302E303033207620322E3232313734206C20312E363732343634382C2D302E303036206320302E3037333332372C302E33';
wwv_flow_imp.g_varchar2_table(39154) := '3530373720302E313739373539382C302E373032343320302E333234323835312C312E303434373220302E313435323432382C302E333434343820302E333231343036342C302E3636343420302E353232373333392C302E3936303636206C202D312E31';
wwv_flow_imp.g_varchar2_table(39155) := '3939333433312C312E313937323320312E353834303235362C312E353630313120312E313936343636382C2D312E3139333438206320302E363134303531372C302E343033343620312E333032383832372C302E363832333220322E303233333531372C';
wwv_flow_imp.g_varchar2_table(39156) := '302E3832333331206C20372E3139652D342C312E3639383932206820322E323236383438207A206D20302E3232313436322C2D332E393935372063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E36303937';
wwv_flow_imp.g_varchar2_table(39157) := '3035352C2D312E3837343338202D302E373532313036352C2D312E373833323120302E3039303539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039';
wwv_flow_imp.g_varchar2_table(39158) := '323920342E3630383938372C312E383734333720302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A227D2C5441534B5F545950455F534552564943455F46494C4C3A7B64';
wwv_flow_imp.g_varchar2_table(39159) := '3A226D207B6D787D2C7B6D797D2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036352C2D312E373833323120302E3039303539382C2D33';
wwv_flow_imp.g_varchar2_table(39160) := '2E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E3630383938372C312E383734333720302E3735323130362C312E3738313635202D302E30393036';
wwv_flow_imp.g_varchar2_table(39161) := '2C332E3834363132202D312E3837393534362C342E3539363035207A227D2C5441534B5F545950455F425553494E4553535F52554C455F4845414445523A7B643A226D207B6D787D2C7B6D797D20302C342032302C3020302C2D34207A227D2C5441534B';
wwv_flow_imp.g_varchar2_table(39162) := '5F545950455F425553494E4553535F52554C455F4D41494E3A7B643A226D207B6D787D2C7B6D797D20302C31322032302C3020302C2D3132207A6D20302C38206C2032302C30206D202D31332C2D34206C20302C38227D2C4D4553534147455F464C4F57';
wwv_flow_imp.g_varchar2_table(39163) := '5F4D41524B45523A7B643A226D207B6D787D2C7B6D797D206D202D31302E35202C2D37206C20302C3134206C2032312C30206C20302C2D3134207A206C2031302E352C36206C2031302E352C2D36227D7D2C746869732E676574526177506174683D6675';
wwv_flow_imp.g_varchar2_table(39164) := '6E6374696F6E2865297B72657475726E20746869732E706174684D61705B655D2E647D2C746869732E6765745363616C6564506174683D66756E6374696F6E28652C74297B766172206E2C692C6F3D746869732E706174684D61705B655D3B742E616273';
wwv_flow_imp.g_varchar2_table(39165) := '706F733F286E3D742E616273706F732E782C693D742E616273706F732E79293A286E3D742E636F6E7461696E657257696474682A742E706F736974696F6E2E6D782C693D742E636F6E7461696E65724865696768742A742E706F736974696F6E2E6D7929';
wwv_flow_imp.g_varchar2_table(39166) := '3B76617220732C722C613D7B7D3B696628742E706F736974696F6E297B666F7228766172206C3D742E636F6E7461696E65724865696768742F6F2E6865696768742A742E795363616C65466163746F722C633D742E636F6E7461696E657257696474682F';
wwv_flow_imp.g_varchar2_table(39167) := '6F2E77696474682A742E785363616C65466163746F722C643D303B643C6F2E686569676874456C656D656E74732E6C656E6774683B642B2B29615B2279222B645D3D6F2E686569676874456C656D656E74735B645D2A6C3B666F722876617220683D303B';
wwv_flow_imp.g_varchar2_table(39168) := '683C6F2E7769647468456C656D656E74732E6C656E6774683B682B2B29615B2278222B685D3D6F2E7769647468456C656D656E74735B685D2A637D72657475726E20733D6F2E642C723D7B6D783A6E2C6D793A692C653A617D2C537472696E672873292E';
wwv_flow_imp.g_varchar2_table(39169) := '7265706C6163652852732C2866756E6374696F6E28652C74297B72657475726E2066756E6374696F6E28652C742C6E297B76617220693D6E3B72657475726E20742E7265706C6163652846732C2866756E6374696F6E28652C742C6E2C6F2C73297B743D';
wwv_flow_imp.g_varchar2_table(39170) := '747C7C6F2C692626287420696E2069262628693D695B745D292C2266756E6374696F6E223D3D747970656F662069262673262628693D69282929297D29292C693D286E756C6C3D3D697C7C693D3D6E3F653A69292B22227D28652C742C72297D29297D7D';
wwv_flow_imp.g_varchar2_table(39171) := '5D7D2C56733D7B7472616E736C6174653A5B2276616C7565222C66756E6374696F6E28652C74297B72657475726E20743D747C7C7B7D2C652E7265706C616365282F7B285B5E7D5D2B297D2F672C2866756E6374696F6E28652C6E297B72657475726E20';
wwv_flow_imp.g_varchar2_table(39172) := '745B6E5D7C7C227B222B6E2B227D227D29297D5D7D3B66756E6374696F6E207A7328652C742C6E297B72657475726E28302C692E6B7029287B69643A652E69642C747970653A652E24747970652C627573696E6573734F626A6563743A652C64693A747D';
wwv_flow_imp.g_varchar2_table(39173) := '2C6E297D66756E6374696F6E20487328652C742C6E297B76617220693D652E776179706F696E743B72657475726E21697C7C692E6C656E6774683C323F5B486E2874292C486E286E295D3A692E6D6170282866756E6374696F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(39174) := '7B783A652E782C793A652E797D7D29297D66756E6374696F6E20577328652C742C6E297B72657475726E206E6577204572726F722860656C656D656E7420247B7A6F2874297D207265666572656E63656420627920247B7A6F2865297D23247B6E7D206E';
wwv_flow_imp.g_varchar2_table(39175) := '6F742079657420647261776E60297D66756E6374696F6E206A7328652C742C6E2C692C6F297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D742C746869732E5F656C656D656E74466163746F72793D6E2C746869732E5F65';
wwv_flow_imp.g_varchar2_table(39176) := '6C656D656E7452656769737472793D692C746869732E5F7465787452656E64657265723D6F7D6A732E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22656C656D656E74466163746F7279222C22656C656D656E745265676973';
wwv_flow_imp.g_varchar2_table(39177) := '747279222C227465787452656E6465726572225D2C6A732E70726F746F747970652E6164643D66756E6374696F6E28652C742C6E297B76617220692C6F2C733B69662828302C792E69732928742C2262706D6E64693A42504D4E506C616E652229297B76';
wwv_flow_imp.g_varchar2_table(39178) := '617220723D28302C792E69732928652C2262706D6E3A53756250726F6365737322293F7B69643A652E69642B225F706C616E65227D3A7B7D3B693D746869732E5F656C656D656E74466163746F72792E637265617465526F6F74287A7328652C742C7229';
wwv_flow_imp.g_varchar2_table(39179) := '292C746869732E5F63616E7661732E616464526F6F74456C656D656E742869297D656C73652069662828302C792E69732928742C2262706D6E64693A42504D4E53686170652229297B76617220613D2128302C72732E41762928652C74292C6C3D66756E';
wwv_flow_imp.g_varchar2_table(39180) := '6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A47726F757022297D2865293B6F3D6E2626286E2E68696464656E7C7C6E2E636F6C6C6170736564293B76617220633D742E626F756E64733B693D746869732E5F656C656D';
wwv_flow_imp.g_varchar2_table(39181) := '656E74466163746F72792E6372656174655368617065287A7328652C742C7B636F6C6C61707365643A612C68696464656E3A6F2C783A4D6174682E726F756E6428632E78292C793A4D6174682E726F756E6428632E79292C77696474683A4D6174682E72';
wwv_flow_imp.g_varchar2_table(39182) := '6F756E6428632E7769647468292C6865696768743A4D6174682E726F756E6428632E686569676874292C69734672616D653A6C7D29292C28302C792E69732928652C2262706D6E3A426F756E646172794576656E7422292626746869732E5F6174746163';
wwv_flow_imp.g_varchar2_table(39183) := '68426F756E6461727928652C69292C28302C792E69732928652C2262706D6E3A4C616E652229262628733D30292C28302C792E69732928652C2262706D6E3A4461746153746F72655265666572656E6365222926262866756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(39184) := '766172206E3D742E782C693D742E793B72657475726E206E3E3D652E7826266E3C3D652E782B652E77696474682626693E3D652E792626693C3D652E792B652E6865696768747D286E2C486E286329297C7C286E3D746869732E5F63616E7661732E6669';
wwv_flow_imp.g_varchar2_table(39185) := '6E64526F6F74286E2929292C746869732E5F63616E7661732E616464536861706528692C6E2C73297D656C73657B6966282128302C792E69732928742C2262706D6E64693A42504D4E456467652229297468726F77206E6577204572726F722860756E6B';
wwv_flow_imp.g_varchar2_table(39186) := '6E6F776E20646920247B7A6F2874297D20666F7220656C656D656E7420247B7A6F2865297D60293B76617220643D746869732E5F676574536F757263652865292C683D746869732E5F6765745461726765742865293B6F3D6E2626286E2E68696464656E';
wwv_flow_imp.g_varchar2_table(39187) := '7C7C6E2E636F6C6C6170736564292C693D746869732E5F656C656D656E74466163746F72792E637265617465436F6E6E656374696F6E287A7328652C742C7B68696464656E3A6F2C736F757263653A642C7461726765743A682C776179706F696E74733A';
wwv_flow_imp.g_varchar2_table(39188) := '487328742C642C68297D29292C28302C792E69732928652C2262706D6E3A446174614173736F63696174696F6E22292626286E3D746869732E5F63616E7661732E66696E64526F6F74286E29292C746869732E5F63616E7661732E616464436F6E6E6563';
wwv_flow_imp.g_varchar2_table(39189) := '74696F6E28692C6E2C73297D72657475726E206373286529262670732869292626746869732E6164644C6162656C28652C742C69292C746869732E5F6576656E744275732E66697265282262706D6E456C656D656E742E6164646564222C7B656C656D65';
wwv_flow_imp.g_varchar2_table(39190) := '6E743A697D292C697D2C6A732E70726F746F747970652E5F617474616368426F756E646172793D66756E6374696F6E28652C74297B766172206E3D652E6174746163686564546F5265663B696628216E297468726F77206E6577204572726F7228606D69';
wwv_flow_imp.g_varchar2_table(39191) := '7373696E6720247B7A6F2865297D236174746163686564546F52656660293B76617220693D746869732E5F656C656D656E7452656769737472792E676574286E2E6964292C6F3D692626692E6174746163686572733B6966282169297468726F77205773';
wwv_flow_imp.g_varchar2_table(39192) := '28652C6E2C226174746163686564546F52656622293B742E686F73743D692C6F7C7C28692E6174746163686572733D6F3D5B5D292C2D313D3D3D6F2E696E6465784F6628742926266F2E707573682874297D2C6A732E70726F746F747970652E6164644C';
wwv_flow_imp.g_varchar2_table(39193) := '6162656C3D66756E6374696F6E28652C742C6E297B766172206F2C732C723B72657475726E206F3D66756E6374696F6E28652C74297B766172206E2C6F2C732C723D652E6C6162656C3B72657475726E20722626722E626F756E64733F28733D722E626F';
wwv_flow_imp.g_varchar2_table(39194) := '756E64732C6F3D7B77696474683A4D6174682E6D61782861732E77696474682C732E7769647468292C6865696768743A732E6865696768747D2C6E3D7B783A732E782B732E77696474682F322C793A732E792B732E6865696768742F327D293A286E3D68';
wwv_flow_imp.g_varchar2_table(39195) := '732874292C6F3D6173292C28302C692E6B7029287B783A6E2E782D6F2E77696474682F322C793A6E2E792D6F2E6865696768742F327D2C6F297D28742C6E292C28733D7073286E29292626286F3D746869732E5F7465787452656E64657265722E676574';
wwv_flow_imp.g_varchar2_table(39196) := '45787465726E616C4C6162656C426F756E6473286F2C7329292C723D746869732E5F656C656D656E74466163746F72792E6372656174654C6162656C287A7328652C742C7B69643A652E69642B225F6C6162656C222C6C6162656C5461726765743A6E2C';
wwv_flow_imp.g_varchar2_table(39197) := '747970653A226C6162656C222C68696464656E3A6E2E68696464656E7C7C217073286E292C783A4D6174682E726F756E64286F2E78292C793A4D6174682E726F756E64286F2E79292C77696474683A4D6174682E726F756E64286F2E7769647468292C68';
wwv_flow_imp.g_varchar2_table(39198) := '65696768743A4D6174682E726F756E64286F2E686569676874297D29292C746869732E5F63616E7661732E616464536861706528722C6E2E706172656E74297D2C6A732E70726F746F747970652E5F676574436F6E6E6563746564456C656D656E743D66';
wwv_flow_imp.g_varchar2_table(39199) := '756E6374696F6E28652C74297B766172206E2C692C6F3D652E24747970653B696628693D655B742B22526566225D2C22736F75726365223D3D3D7426262262706D6E3A44617461496E7075744173736F63696174696F6E223D3D3D6F262628693D692626';
wwv_flow_imp.g_varchar2_table(39200) := '695B305D292C2822736F75726365223D3D3D7426262262706D6E3A446174614F75747075744173736F63696174696F6E223D3D3D6F7C7C22746172676574223D3D3D7426262262706D6E3A44617461496E7075744173736F63696174696F6E223D3D3D6F';
wwv_flow_imp.g_varchar2_table(39201) := '29262628693D652E24706172656E74292C6E3D692626746869732E5F676574456C656D656E742869292972657475726E206E3B7468726F7720693F577328652C692C742B2252656622293A6E6577204572726F722860247B7A6F2865297D23247B747D20';
wwv_flow_imp.g_varchar2_table(39202) := '526566206E6F742073706563696669656460297D2C6A732E70726F746F747970652E5F676574536F757263653D66756E6374696F6E2865297B72657475726E20746869732E5F676574436F6E6E6563746564456C656D656E7428652C22736F7572636522';
wwv_flow_imp.g_varchar2_table(39203) := '297D2C6A732E70726F746F747970652E5F6765745461726765743D66756E6374696F6E2865297B72657475726E20746869732E5F676574436F6E6E6563746564456C656D656E7428652C2274617267657422297D2C6A732E70726F746F747970652E5F67';
wwv_flow_imp.g_varchar2_table(39204) := '6574456C656D656E743D66756E6374696F6E2865297B72657475726E20746869732E5F656C656D656E7452656769737472792E67657428652E6964297D3B636F6E73742071733D7B5F5F646570656E64735F5F3A5B42732C7B5F5F646570656E64735F5F';
wwv_flow_imp.g_varchar2_table(39205) := '3A5B56735D2C62706D6E496D706F727465723A5B2274797065222C6A735D7D5D7D3B66756E6374696F6E2024732865297B746869732E5F636F756E7465723D302C746869732E5F7072656669783D28653F652B222D223A2222292B4D6174682E666C6F6F';
wwv_flow_imp.g_varchar2_table(39206) := '72283165392A4D6174682E72616E646F6D2829292B222D227D24732E70726F746F747970652E6E6578743D66756E6374696F6E28297B72657475726E20746869732E5F7072656669782B202B2B746869732E5F636F756E7465727D3B7661722055733D6E';
wwv_flow_imp.g_varchar2_table(39207) := '657720247328226F7622293B66756E6374696F6E204B7328652C742C6E2C6F297B76617220732C723B746869732E5F6576656E744275733D742C746869732E5F63616E7661733D6E2C746869732E5F656C656D656E7452656769737472793D6F2C746869';
wwv_flow_imp.g_varchar2_table(39208) := '732E5F6964733D55732C746869732E5F6F7665726C617944656661756C74733D28302C692E6B7029287B73686F773A6E756C6C2C7363616C653A21307D2C652626652E64656661756C7473292C746869732E5F6F7665726C6179733D7B7D2C746869732E';
wwv_flow_imp.g_varchar2_table(39209) := '5F6F7665726C6179436F6E7461696E6572733D5B5D2C746869732E5F6F7665726C6179526F6F743D28733D6E2E676574436F6E7461696E657228292C437428723D487428273C64697620636C6173733D22646A732D6F7665726C61792D636F6E7461696E';
wwv_flow_imp.g_varchar2_table(39210) := '657222202F3E27292C7B706F736974696F6E3A226162736F6C757465222C77696474683A302C6865696768743A307D292C732E696E736572744265666F726528722C732E66697273744368696C64292C72292C746869732E5F696E697428297D66756E63';
wwv_flow_imp.g_varchar2_table(39211) := '74696F6E20477328652C742C6E297B437428652C7B6C6566743A742B227078222C746F703A6E2B227078227D297D66756E6374696F6E20517328652C74297B652E7374796C652E646973706C61793D21313D3D3D743F226E6F6E65223A22227D66756E63';
wwv_flow_imp.g_varchar2_table(39212) := '74696F6E20597328652C74297B652E7374796C655B227472616E73666F726D2D6F726967696E225D3D22746F70206C656674222C5B22222C222D6D732D222C222D7765626B69742D225D2E666F7245616368282866756E6374696F6E286E297B652E7374';
wwv_flow_imp.g_varchar2_table(39213) := '796C655B6E2B227472616E73666F726D225D3D747D29297D4B732E24696E6A6563743D5B22636F6E6669672E6F7665726C617973222C226576656E74427573222C2263616E766173222C22656C656D656E745265676973747279225D2C4B732E70726F74';
wwv_flow_imp.g_varchar2_table(39214) := '6F747970652E6765743D66756E6374696F6E2865297B69662828302C692E4B6729286529262628653D7B69643A657D292C28302C692E4B672928652E656C656D656E7429262628652E656C656D656E743D746869732E5F656C656D656E74526567697374';
wwv_flow_imp.g_varchar2_table(39215) := '72792E67657428652E656C656D656E7429292C652E656C656D656E74297B76617220743D746869732E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E742C2130293B72657475726E20743F652E747970653F28302C692E706229';
wwv_flow_imp.g_varchar2_table(39216) := '28742E6F7665726C6179732C28302C692E674829287B747970653A652E747970657D29293A742E6F7665726C6179732E736C69636528293A5B5D7D72657475726E20652E747970653F28302C692E70622928746869732E5F6F7665726C6179732C28302C';
wwv_flow_imp.g_varchar2_table(39217) := '692E674829287B747970653A652E747970657D29293A652E69643F746869732E5F6F7665726C6179735B652E69645D3A6E756C6C7D2C4B732E70726F746F747970652E6164643D66756E6374696F6E28652C742C6E297B69662828302C692E4776292874';
wwv_flow_imp.g_varchar2_table(39218) := '292626286E3D742C743D6E756C6C292C652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C216E2E706F736974696F6E297468726F77206E6577204572726F7228226D757374207370656369666979206F76';
wwv_flow_imp.g_varchar2_table(39219) := '65726C617920706F736974696F6E22293B696628216E2E68746D6C297468726F77206E6577204572726F7228226D757374207370656369666979206F7665726C61792068746D6C22293B6966282165297468726F77206E6577204572726F722822696E76';
wwv_flow_imp.g_varchar2_table(39220) := '616C696420656C656D656E742073706563696669656422293B766172206F3D746869732E5F6964732E6E65787428293B72657475726E206E3D28302C692E6B7029287B7D2C746869732E5F6F7665726C617944656661756C74732C6E2C7B69643A6F2C74';
wwv_flow_imp.g_varchar2_table(39221) := '7970653A742C656C656D656E743A652C68746D6C3A6E2E68746D6C7D292C746869732E5F6164644F7665726C6179286E292C6F7D2C4B732E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869732E67657428';
wwv_flow_imp.g_varchar2_table(39222) := '65297C7C5B5D3B28302C692E6379292874297C7C28743D5B745D293B766172206E3D746869733B28302C692E6A4A2928742C2866756E6374696F6E2865297B76617220743D6E2E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E';
wwv_flow_imp.g_varchar2_table(39223) := '742C2130293B69662865262628247428652E68746D6C292C247428652E68746D6C436F6E7461696E6572292C64656C65746520652E68746D6C436F6E7461696E65722C64656C65746520652E656C656D656E742C64656C657465206E2E5F6F7665726C61';
wwv_flow_imp.g_varchar2_table(39224) := '79735B652E69645D292C74297B76617220693D742E6F7665726C6179732E696E6465784F662865293B2D31213D3D692626742E6F7665726C6179732E73706C69636528692C31297D7D29297D2C4B732E70726F746F747970652E697353686F776E3D6675';
wwv_flow_imp.g_varchar2_table(39225) := '6E6374696F6E28297B72657475726E226E6F6E6522213D3D746869732E5F6F7665726C6179526F6F742E7374796C652E646973706C61797D2C4B732E70726F746F747970652E73686F773D66756E6374696F6E28297B517328746869732E5F6F7665726C';
wwv_flow_imp.g_varchar2_table(39226) := '6179526F6F74297D2C4B732E70726F746F747970652E686964653D66756E6374696F6E28297B517328746869732E5F6F7665726C6179526F6F742C2131297D2C4B732E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E5F';
wwv_flow_imp.g_varchar2_table(39227) := '6F7665726C6179733D7B7D2C746869732E5F6F7665726C6179436F6E7461696E6572733D5B5D2C4C7428746869732E5F6F7665726C6179526F6F74297D2C4B732E70726F746F747970652E5F7570646174654F7665726C6179436F6E7461696E65723D66';
wwv_flow_imp.g_varchar2_table(39228) := '756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E68746D6C2C693D742E782C6F3D742E793B696628742E776179706F696E7473297B76617220733D63742874293B693D732E782C6F3D732E797D4773286E2C692C6F292C5374';
wwv_flow_imp.g_varchar2_table(39229) := '28652E68746D6C2C22646174612D636F6E7461696E65722D6964222C742E6964297D2C4B732E70726F746F747970652E5F7570646174654F7665726C61793D66756E6374696F6E2865297B76617220742C6E2C693D652E706F736974696F6E2C6F3D652E';
wwv_flow_imp.g_varchar2_table(39230) := '68746D6C436F6E7461696E65722C733D652E656C656D656E742C723D692E6C6566742C613D692E746F703B766F69642030213D3D692E7269676874262628743D732E776179706F696E74733F63742873292E77696474683A732E77696474682C723D2D31';
wwv_flow_imp.g_varchar2_table(39231) := '2A692E72696768742B74292C766F69642030213D3D692E626F74746F6D2626286E3D732E776179706F696E74733F63742873292E6865696768743A732E6865696768742C613D2D312A692E626F74746F6D2B6E292C4773286F2C727C7C302C617C7C3029';
wwv_flow_imp.g_varchar2_table(39232) := '2C746869732E5F7570646174654F7665726C61795669736962696C747928652C746869732E5F63616E7661732E76696577626F782829297D2C4B732E70726F746F747970652E5F6372656174654F7665726C6179436F6E7461696E65723D66756E637469';
wwv_flow_imp.g_varchar2_table(39233) := '6F6E2865297B76617220743D487428273C64697620636C6173733D22646A732D6F7665726C61797322202F3E27293B437428742C7B706F736974696F6E3A226162736F6C757465227D292C746869732E5F6F7665726C6179526F6F742E617070656E6443';
wwv_flow_imp.g_varchar2_table(39234) := '68696C642874293B766172206E3D7B68746D6C3A742C656C656D656E743A652C6F7665726C6179733A5B5D7D3B72657475726E20746869732E5F7570646174654F7665726C6179436F6E7461696E6572286E292C746869732E5F6F7665726C6179436F6E';
wwv_flow_imp.g_varchar2_table(39235) := '7461696E6572732E70757368286E292C6E7D2C4B732E70726F746F747970652E5F757064617465526F6F743D66756E6374696F6E2865297B76617220743D652E7363616C657C7C312C6E3D226D617472697828222B5B742C302C302C742C2D312A652E78';
wwv_flow_imp.g_varchar2_table(39236) := '2A742C2D312A652E792A745D2E6A6F696E28222C22292B2229223B597328746869732E5F6F7665726C6179526F6F742C6E297D2C4B732E70726F746F747970652E5F6765744F7665726C6179436F6E7461696E65723D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(39237) := '766172206E3D28302C692E49362928746869732E5F6F7665726C6179436F6E7461696E6572732C2866756E6374696F6E2874297B72657475726E20742E656C656D656E743D3D3D657D29293B72657475726E206E7C7C743F6E3A746869732E5F63726561';
wwv_flow_imp.g_varchar2_table(39238) := '74654F7665726C6179436F6E7461696E65722865297D2C4B732E70726F746F747970652E5F6164644F7665726C61793D66756E6374696F6E2865297B76617220742C6E2C6F3D652E69642C733D652E656C656D656E742C723D652E68746D6C3B722E6765';
wwv_flow_imp.g_varchar2_table(39239) := '742626722E636F6E7374727563746F722E70726F746F747970652E6A7175657279262628723D722E676574283029292C28302C692E4B6729287229262628723D4874287229292C6E3D746869732E5F6765744F7665726C6179436F6E7461696E65722873';
wwv_flow_imp.g_varchar2_table(39240) := '292C437428743D487428273C64697620636C6173733D22646A732D6F7665726C61792220646174612D6F7665726C61792D69643D22272B6F2B27223E27292C7B706F736974696F6E3A226162736F6C757465227D292C742E617070656E644368696C6428';
wwv_flow_imp.g_varchar2_table(39241) := '72292C652E7479706526266B742874292E6164642822646A732D6F7665726C61792D222B652E74797065292C517328742C746869732E5F63616E7661732E66696E64526F6F742873293D3D3D746869732E5F63616E7661732E676574526F6F74456C656D';
wwv_flow_imp.g_varchar2_table(39242) := '656E742829292C652E68746D6C436F6E7461696E65723D742C6E2E6F7665726C6179732E707573682865292C6E2E68746D6C2E617070656E644368696C642874292C746869732E5F6F7665726C6179735B6F5D3D652C746869732E5F7570646174654F76';
wwv_flow_imp.g_varchar2_table(39243) := '65726C61792865292C746869732E5F7570646174654F7665726C61795669736962696C747928652C746869732E5F63616E7661732E76696577626F782829297D2C4B732E70726F746F747970652E5F7570646174654F7665726C61795669736962696C74';
wwv_flow_imp.g_varchar2_table(39244) := '793D66756E6374696F6E28652C74297B766172206E3D652E73686F772C6F3D746869732E5F63616E7661732E66696E64526F6F7428652E656C656D656E74292C733D6E26266E2E6D696E5A6F6F6D2C723D6E26266E2E6D61785A6F6F6D2C613D652E6874';
wwv_flow_imp.g_varchar2_table(39245) := '6D6C436F6E7461696E65722C6C3D21303B286F213D3D746869732E5F63616E7661732E676574526F6F74456C656D656E7428297C7C6E26262828302C692E4F39292873292626733E742E7363616C657C7C28302C692E4F39292872292626723C742E7363';
wwv_flow_imp.g_varchar2_table(39246) := '616C6529292626286C3D2131292C517328612C6C292C746869732E5F7570646174654F7665726C61795363616C6528652C74297D2C4B732E70726F746F747970652E5F7570646174654F7665726C61795363616C653D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(39247) := '766172206E2C6F2C732C723D652E7363616C652C613D652E68746D6C436F6E7461696E65722C6C3D22223B2130213D3D7226262821313D3D3D723F286E3D312C6F3D31293A286E3D722E6D696E2C6F3D722E6D6178292C28302C692E4F3929286E292626';
wwv_flow_imp.g_varchar2_table(39248) := '742E7363616C653C6E262628733D28312F742E7363616C657C7C31292A6E292C28302C692E4F3929286F292626742E7363616C653E6F262628733D28312F742E7363616C657C7C31292A6F29292C28302C692E4F39292873292626286C3D227363616C65';
wwv_flow_imp.g_varchar2_table(39249) := '28222B732B222C222B732B222922292C597328612C6C297D2C4B732E70726F746F747970652E5F7570646174654F7665726C6179735669736962696C74793D66756E6374696F6E2865297B76617220743D746869733B28302C692E6A4A2928746869732E';
wwv_flow_imp.g_varchar2_table(39250) := '5F6F7665726C6179732C2866756E6374696F6E286E297B742E5F7570646174654F7665726C61795669736962696C7479286E2C65297D29297D2C4B732E70726F746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D746869732E5F';
wwv_flow_imp.g_varchar2_table(39251) := '6576656E744275732C743D746869733B652E6F6E282263616E7661732E76696577626F782E6368616E67696E67222C2866756E6374696F6E2865297B742E6869646528297D29292C652E6F6E282263616E7661732E76696577626F782E6368616E676564';
wwv_flow_imp.g_varchar2_table(39252) := '222C2866756E6374696F6E2865297B766172206E3B6E3D652E76696577626F782C742E5F757064617465526F6F74286E292C742E5F7570646174654F7665726C6179735669736962696C7479286E292C742E73686F7728297D29292C652E6F6E285B2273';
wwv_flow_imp.g_varchar2_table(39253) := '686170652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C2866756E6374696F6E2865297B766172206E3D652E656C656D656E742C6F3D742E676574287B656C656D656E743A6E7D293B28302C692E6A4A29286F2C2866756E63';
wwv_flow_imp.g_varchar2_table(39254) := '74696F6E2865297B742E72656D6F766528652E6964297D29293B76617220733D742E5F6765744F7665726C6179436F6E7461696E6572286E293B69662873297B247428732E68746D6C293B76617220723D742E5F6F7665726C6179436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(39255) := '732E696E6465784F662873293B2D31213D3D722626742E5F6F7665726C6179436F6E7461696E6572732E73706C69636528722C31297D7D29292C652E6F6E2822656C656D656E742E6368616E676564222C3530302C2866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(39256) := '72206E3D652E656C656D656E742C6F3D742E5F6765744F7665726C6179436F6E7461696E6572286E2C2130293B6F26262828302C692E6A4A29286F2E6F7665726C6179732C2866756E6374696F6E2865297B742E5F7570646174654F7665726C61792865';
wwv_flow_imp.g_varchar2_table(39257) := '297D29292C742E5F7570646174654F7665726C6179436F6E7461696E6572286F29297D29292C652E6F6E2822656C656D656E742E6D61726B65722E757064617465222C2866756E6374696F6E2865297B766172206E3D742E5F6765744F7665726C617943';
wwv_flow_imp.g_varchar2_table(39258) := '6F6E7461696E657228652E656C656D656E742C2130293B6E26266B74286E2E68746D6C295B652E6164643F22616464223A2272656D6F7665225D28652E6D61726B6572297D29292C652E6F6E2822726F6F742E736574222C2866756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(39259) := '742E5F7570646174654F7665726C6179735669736962696C747928742E5F63616E7661732E76696577626F782829297D29292C652E6F6E28226469616772616D2E636C656172222C746869732E636C6561722C74686973297D3B636F6E7374205A733D7B';
wwv_flow_imp.g_varchar2_table(39260) := '5F5F696E69745F5F3A5B226F7665726C617973225D2C6F7665726C6179733A5B2274797065222C4B735D7D3B66756E6374696F6E20587328652C742C6E2C69297B652E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E286929';
wwv_flow_imp.g_varchar2_table(39261) := '7B766172206F3D692E656C656D656E743B286F2E706172656E747C7C6F3D3D3D742E676574526F6F74456C656D656E74282929262628692E6766783D6E2E6765744772617068696373286F29292C692E6766782626652E66697265286474286F292B222E';
wwv_flow_imp.g_varchar2_table(39262) := '6368616E676564222C69297D29292C652E6F6E2822656C656D656E74732E6368616E676564222C2866756E6374696F6E2874297B766172206E3D742E656C656D656E74733B6E2E666F7245616368282866756E6374696F6E2874297B652E666972652822';
wwv_flow_imp.g_varchar2_table(39263) := '656C656D656E742E6368616E676564222C7B656C656D656E743A747D297D29292C692E757064617465436F6E7461696E6D656E7473286E297D29292C652E6F6E282273686170652E6368616E676564222C2866756E6374696F6E2865297B692E75706461';
wwv_flow_imp.g_varchar2_table(39264) := '746528227368617065222C652E656C656D656E742C652E676678297D29292C652E6F6E2822636F6E6E656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B692E7570646174652822636F6E6E656374696F6E222C652E656C656D656E';
wwv_flow_imp.g_varchar2_table(39265) := '742C652E676678297D29297D58732E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22656C656D656E745265676973747279222C226772617068696373466163746F7279225D3B636F6E7374204A733D7B5F5F696E69745F5F3A';
wwv_flow_imp.g_varchar2_table(39266) := '5B226368616E6765537570706F7274225D2C6368616E6765537570706F72743A5B2274797065222C58735D7D3B66756E6374696F6E2065722865297B746869732E5F6576656E744275733D657D66756E6374696F6E2074722865297B72657475726E2066';
wwv_flow_imp.g_varchar2_table(39267) := '756E6374696F6E28742C6E2C6F2C732C72297B2828302C692E546E292874297C7C28302C692E45742928742929262628723D732C733D6F2C6F3D6E2C6E3D742C743D6E756C6C292C746869732E6F6E28742C652C6E2C6F2C732C72297D7D66756E637469';
wwv_flow_imp.g_varchar2_table(39268) := '6F6E206E7228652C74297B742E696E766F6B652865722C74686973292C746869732E6578656375746564282866756E6374696F6E2874297B766172206E3D742E636F6E746578743B6E2E726F6F74456C656D656E743F652E736574526F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(39269) := '6E74286E2E726F6F74456C656D656E74293A6E2E726F6F74456C656D656E743D652E676574526F6F74456C656D656E7428297D29292C746869732E726576657274282866756E6374696F6E2874297B766172206E3D742E636F6E746578743B6E2E726F6F';
wwv_flow_imp.g_varchar2_table(39270) := '74456C656D656E742626652E736574526F6F74456C656D656E74286E2E726F6F74456C656D656E74297D29297D65722E24696E6A6563743D5B226576656E74427573225D2C65722E70726F746F747970652E6F6E3D66756E6374696F6E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(39271) := '6F2C732C72297B6966282828302C692E546E292874297C7C28302C692E45742928742929262628723D732C733D6F2C6F3D6E2C6E3D742C743D6E756C6C292C28302C692E546E29286E29262628723D732C733D6F2C6F3D6E2C6E3D316533292C28302C69';
wwv_flow_imp.g_varchar2_table(39272) := '2E477629287329262628723D732C733D2131292C2128302C692E546E29286F29297468726F77206E6577204572726F72282268616E646C6572466E206D75737420626520612066756E6374696F6E22293B28302C692E6379292865297C7C28653D5B655D';
wwv_flow_imp.g_varchar2_table(39273) := '293B76617220613D746869732E5F6576656E744275733B28302C692E6A4A2928652C2866756E6374696F6E2865297B76617220693D5B22636F6D6D616E64537461636B222C652C745D2E66696C746572282866756E6374696F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(39274) := '20657D29292E6A6F696E28222E22293B612E6F6E28692C6E2C733F66756E6374696F6E28652C74297B72657475726E2066756E6374696F6E286E297B72657475726E20652E63616C6C28747C7C6E756C6C2C6E2E636F6E746578742C6E2E636F6D6D616E';
wwv_flow_imp.g_varchar2_table(39275) := '642C6E297D7D286F2C72293A6F2C72297D29297D2C65722E70726F746F747970652E63616E457865637574653D7472282263616E4578656375746522292C65722E70726F746F747970652E707265457865637574653D7472282270726545786563757465';
wwv_flow_imp.g_varchar2_table(39276) := '22292C65722E70726F746F747970652E70726545786563757465643D74722822707265457865637574656422292C65722E70726F746F747970652E657865637574653D747228226578656375746522292C65722E70726F746F747970652E657865637574';
wwv_flow_imp.g_varchar2_table(39277) := '65643D74722822657865637574656422292C65722E70726F746F747970652E706F7374457865637574653D74722822706F73744578656375746522292C65722E70726F746F747970652E706F737445786563757465643D74722822706F73744578656375';
wwv_flow_imp.g_varchar2_table(39278) := '74656422292C65722E70726F746F747970652E7265766572743D7472282272657665727422292C65722E70726F746F747970652E72657665727465643D74722822726576657274656422292C52286E722C6572292C6E722E24696E6A6563743D5B226361';
wwv_flow_imp.g_varchar2_table(39279) := '6E766173222C22696E6A6563746F72225D3B636F6E73742069723D7B5F5F696E69745F5F3A5B22726F6F74456C656D656E74734265686176696F72225D2C726F6F74456C656D656E74734265686176696F723A5B2274797065222C6E725D7D3B76617220';
wwv_flow_imp.g_varchar2_table(39280) := '6F723D225F706C616E65223B66756E6374696F6E2073722865297B72657475726E2066756E6374696F6E2865297B72657475726E20652E7265706C616365286E657720526567457870286F722B222422292C2222297D28652E6964297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(39281) := '6E2072722865297B76617220743D652E69643B72657475726E28302C792E69732928652C2262706D6E3A53756250726F6365737322293F63722874293A747D66756E6374696F6E2061722865297B72657475726E2063722865297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(39282) := '6C722865297B76617220743D28302C792E6765744469292865293B72657475726E28302C792E69732928742C2262706D6E64693A42504D4E506C616E6522297D66756E6374696F6E2063722865297B72657475726E20652B6F727D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(39283) := '647228652C742C6E297B766172206F3D636528273C756C20636C6173733D22626A732D62726561646372756D6273223E3C2F756C3E27292C733D6E2E676574436F6E7461696E657228292C723D592873293B732E617070656E644368696C64286F293B76';
wwv_flow_imp.g_varchar2_table(39284) := '617220613D5B5D3B66756E6374696F6E206C2865297B65262628613D66756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D28302C792E676574427573696E6573734F626A656374292865293B6E3B6E3D6E2E24706172656E74292828302C';
wwv_flow_imp.g_varchar2_table(39285) := '792E697329286E2C2262706D6E3A53756250726F6365737322297C7C28302C792E697329286E2C2262706D6E3A50726F636573732229292626742E70757368286E293B72657475726E20742E7265766572736528297D286529293B76617220693D612E66';
wwv_flow_imp.g_varchar2_table(39286) := '6C61744D6170282866756E6374696F6E2865297B76617220693D6E2E66696E64526F6F74287272286529297C7C6E2E66696E64526F6F7428652E6964293B6966282169262628302C792E69732928652C2262706D6E3A50726F636573732229297B766172';
wwv_flow_imp.g_varchar2_table(39287) := '206F3D742E66696E64282866756E6374696F6E2874297B766172206E3D28302C792E676574427573696E6573734F626A656374292874293B72657475726E206E26266E2E676574282270726F6365737352656622293D3D3D657D29293B693D6F26266E2E';
wwv_flow_imp.g_varchar2_table(39288) := '66696E64526F6F74286F2E6964297D69662821692972657475726E5B5D3B76617220733D5F28652E6E616D657C7C652E6964292C723D636528273C6C693E3C7370616E20636C6173733D22626A732D6372756D62223E3C61207469746C653D22272B732B';
wwv_flow_imp.g_varchar2_table(39289) := '27223E272B732B223C2F613E3C2F7370616E3E3C2F6C693E22293B72657475726E20722E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B6E2E736574526F6F74456C656D656E742869297D29292C727D2929';
wwv_flow_imp.g_varchar2_table(39290) := '3B6F2E696E6E657248544D4C3D22223B76617220733D692E6C656E6774683E313B722E746F67676C652822626A732D62726561646372756D62732D73686F776E222C73292C692E666F7245616368282866756E6374696F6E2865297B6F2E617070656E64';
wwv_flow_imp.g_varchar2_table(39291) := '4368696C642865297D29297D652E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D28302C792E676574427573696E6573734F626A656374292874293B28302C692E4936';
wwv_flow_imp.g_varchar2_table(39292) := '2928612C2866756E6374696F6E2865297B72657475726E20653D3D3D6E7D292926266C28297D29292C652E6F6E2822726F6F742E736574222C2866756E6374696F6E2865297B6C28652E656C656D656E74297D29297D66756E6374696F6E20687228652C';
wwv_flow_imp.g_varchar2_table(39293) := '74297B766172206E3D6E756C6C2C693D6E65772075723B652E6F6E2822726F6F742E736574222C2866756E6374696F6E2865297B766172206F3D652E656C656D656E742C733D742E76696577626F7828292C723D692E676574286F293B696628692E7365';
wwv_flow_imp.g_varchar2_table(39294) := '74286E2C7B783A732E782C793A732E792C7A6F6F6D3A732E7363616C657D292C6E3D6F2C28302C792E697329286F2C2262706D6E3A53756250726F6365737322297C7C72297B723D727C7C7B783A302C793A302C7A6F6F6D3A317D3B76617220613D2873';
wwv_flow_imp.g_varchar2_table(39295) := '2E782D722E78292A732E7363616C652C6C3D28732E792D722E79292A732E7363616C653B303D3D3D612626303D3D3D6C7C7C742E7363726F6C6C287B64783A612C64793A6C7D292C722E7A6F6F6D213D3D732E7363616C652626742E7A6F6F6D28722E7A';
wwv_flow_imp.g_varchar2_table(39296) := '6F6F6D2C7B783A302C793A307D297D7D29292C652E6F6E28226469616772616D2E636C656172222C2866756E6374696F6E28297B692E636C65617228292C6E3D6E756C6C7D29297D66756E6374696F6E20757228297B746869732E5F656E74726965733D';
wwv_flow_imp.g_varchar2_table(39297) := '5B5D2C746869732E7365743D66756E6374696F6E28652C74297B766172206E3D21313B666F7228766172206920696E20746869732E5F656E747269657329696628746869732E5F656E74726965735B695D5B305D3D3D3D65297B746869732E5F656E7472';
wwv_flow_imp.g_varchar2_table(39298) := '6965735B695D5B315D3D742C6E3D21303B627265616B7D6E7C7C746869732E5F656E74726965732E70757368285B652C745D297D2C746869732E6765743D66756E6374696F6E2865297B666F7228766172207420696E20746869732E5F656E7472696573';
wwv_flow_imp.g_varchar2_table(39299) := '29696628746869732E5F656E74726965735B745D5B305D3D3D3D652972657475726E20746869732E5F656E74726965735B745D5B315D3B72657475726E206E756C6C7D2C746869732E636C6561723D66756E6374696F6E28297B746869732E5F656E7472';
wwv_flow_imp.g_varchar2_table(39300) := '6965732E6C656E6774683D307D2C746869732E72656D6F76653D66756E6374696F6E2865297B76617220743D2D313B666F7228766172206E20696E20746869732E5F656E747269657329696628746869732E5F656E74726965735B6E5D5B305D3D3D3D65';
wwv_flow_imp.g_varchar2_table(39301) := '297B743D6E3B627265616B7D2D31213D3D742626746869732E5F656E74726965732E73706C69636528742C31297D7D64722E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279222C2263616E766173225D2C6872';
wwv_flow_imp.g_varchar2_table(39302) := '2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B66756E6374696F6E20707228652C74297B746869732E5F6576656E744275733D652C746869732E5F6D6F64646C653D743B766172206E3D746869733B652E6F6E2822696D70';
wwv_flow_imp.g_varchar2_table(39303) := '6F72742E72656E6465722E7374617274222C313530302C2866756E6374696F6E28652C74297B6E2E5F68616E646C65496D706F727428742E646566696E6974696F6E73297D29297D66756E6374696F6E2067722865297B72657475726E28302C792E6973';
wwv_flow_imp.g_varchar2_table(39304) := '2928652C2262706D6E64693A42504D4E4469616772616D22293F653A677228652E24706172656E74297D70722E70726F746F747970652E5F68616E646C65496D706F72743D66756E6374696F6E2865297B696628652E6469616772616D73297B76617220';
wwv_flow_imp.g_varchar2_table(39305) := '743D746869733B746869732E5F646566696E6974696F6E733D652C746869732E5F70726F63657373546F4469616772616D4D61703D7B7D2C652E6469616772616D732E666F7245616368282866756E6374696F6E2865297B652E706C616E652626652E70';
wwv_flow_imp.g_varchar2_table(39306) := '6C616E652E62706D6E456C656D656E74262628742E5F70726F63657373546F4469616772616D4D61705B652E706C616E652E62706D6E456C656D656E742E69645D3D65297D29292C652E6469616772616D732E66696C7465722828653D3E652E706C616E';
wwv_flow_imp.g_varchar2_table(39307) := '6529292E666C61744D61702828653D3E742E5F6372656174654E65774469616772616D7328652E706C616E652929292E666F7245616368282866756E6374696F6E2865297B742E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E28652E';
wwv_flow_imp.g_varchar2_table(39308) := '706C616E65297D29297D7D2C70722E70726F746F747970652E5F6372656174654E65774469616772616D733D66756E6374696F6E2865297B76617220743D746869732C6E3D5B5D2C693D5B5D3B652E6765742822706C616E65456C656D656E7422292E66';
wwv_flow_imp.g_varchar2_table(39309) := '6F7245616368282866756E6374696F6E2874297B766172206F3D742E62706D6E456C656D656E743B6966286F297B76617220733D6F2E24706172656E743B28302C792E697329286F2C2262706D6E3A53756250726F636573732229262621742E69734578';
wwv_flow_imp.g_varchar2_table(39310) := '70616E64656426266E2E70757368286F292C66756E6374696F6E28652C74297B766172206E3D652E24706172656E743B72657475726E21282128302C792E697329286E2C2262706D6E3A53756250726F6365737322297C7C6E3D3D3D742E62706D6E456C';
wwv_flow_imp.g_varchar2_table(39311) := '656D656E742926262128302C792E6973416E792928652C5B2262706D6E3A44617461496E7075744173736F63696174696F6E222C2262706D6E3A446174614F75747075744173736F63696174696F6E225D297D286F2C65292626692E70757368287B6469';
wwv_flow_imp.g_varchar2_table(39312) := '456C656D656E743A742C706172656E743A737D297D7D29293B766172206F3D5B5D3B72657475726E206E2E666F7245616368282866756E6374696F6E2865297B69662821742E5F70726F63657373546F4469616772616D4D61705B652E69645D297B7661';
wwv_flow_imp.g_varchar2_table(39313) := '72206E3D742E5F6372656174654469616772616D2865293B742E5F70726F63657373546F4469616772616D4D61705B652E69645D3D6E2C6F2E70757368286E297D7D29292C692E666F7245616368282866756E6374696F6E2865297B666F722876617220';
wwv_flow_imp.g_varchar2_table(39314) := '693D652E6469456C656D656E742C6F3D652E706172656E743B6F26262D313D3D3D6E2E696E6465784F66286F293B296F3D6F2E24706172656E743B6966286F297B76617220733D742E5F70726F63657373546F4469616772616D4D61705B6F2E69645D3B';
wwv_flow_imp.g_varchar2_table(39315) := '742E5F6D6F7665546F4469506C616E6528692C732E706C616E65297D7D29292C6F7D2C70722E70726F746F747970652E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E3D66756E6374696F6E2865297B76617220743D652E6765742822';
wwv_flow_imp.g_varchar2_table(39316) := '706C616E65456C656D656E7422292C6E3D66756E6374696F6E2865297B76617220743D7B746F703A312F302C72696768743A2D312F302C626F74746F6D3A2D312F302C6C6566743A312F307D3B72657475726E20652E706C616E65456C656D656E742E66';
wwv_flow_imp.g_varchar2_table(39317) := '6F7245616368282866756E6374696F6E2865297B696628652E626F756E6473297B766172206E3D566E28652E626F756E6473293B742E746F703D4D6174682E6D696E286E2E746F702C742E746F70292C742E6C6566743D4D6174682E6D696E286E2E6C65';
wwv_flow_imp.g_varchar2_table(39318) := '66742C742E6C656674297D7D29292C7A6E2874297D2865292C693D6E2E782D3138302C6F3D6E2E792D3136303B742E666F7245616368282866756E6374696F6E2865297B652E776179706F696E743F652E776179706F696E742E666F7245616368282866';
wwv_flow_imp.g_varchar2_table(39319) := '756E6374696F6E2865297B652E783D652E782D692C652E793D652E792D6F7D29293A652E626F756E6473262628652E626F756E64732E783D652E626F756E64732E782D692C652E626F756E64732E793D652E626F756E64732E792D6F297D29297D2C7072';
wwv_flow_imp.g_varchar2_table(39320) := '2E70726F746F747970652E5F6D6F7665546F4469506C616E653D66756E6374696F6E28652C74297B766172206E3D67722865292E706C616E652E6765742822706C616E65456C656D656E7422293B6E2E73706C696365286E2E696E6465784F662865292C';
wwv_flow_imp.g_varchar2_table(39321) := '31292C742E6765742822706C616E65456C656D656E7422292E707573682865297D2C70722E70726F746F747970652E5F6372656174654469616772616D3D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64646C652E63726561746528';
wwv_flow_imp.g_varchar2_table(39322) := '2262706D6E64693A42504D4E506C616E65222C7B62706D6E456C656D656E743A657D292C6E3D746869732E5F6D6F64646C652E637265617465282262706D6E64693A42504D4E4469616772616D222C7B706C616E653A747D293B72657475726E20742E24';
wwv_flow_imp.g_varchar2_table(39323) := '706172656E743D6E2C742E62706D6E456C656D656E743D652C6E2E24706172656E743D746869732E5F646566696E6974696F6E732C746869732E5F646566696E6974696F6E732E6469616772616D732E70757368286E292C6E7D2C70722E24696E6A6563';
wwv_flow_imp.g_varchar2_table(39324) := '743D5B226576656E74427573222C226D6F64646C65225D3B766172206D723D3235303B66756E6374696F6E20667228652C742C6E2C692C6F297B65722E63616C6C28746869732C74292C746869732E5F63616E7661733D652C746869732E5F6576656E74';
wwv_flow_imp.g_varchar2_table(39325) := '4275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F6F7665726C6179733D692C746869732E5F7472616E736C6174653D6F3B76617220733D746869733B746869732E6578656375746564282273686170652E746F67';
wwv_flow_imp.g_varchar2_table(39326) := '676C65436F6C6C61707365222C6D722C2866756E6374696F6E2865297B76617220743D652E73686170653B732E5F63616E4472696C6C446F776E2874293F732E5F6164644F7665726C61792874293A732E5F72656D6F76654F7665726C61792874297D29';
wwv_flow_imp.g_varchar2_table(39327) := '2C2130292C746869732E7265766572746564282273686170652E746F67676C65436F6C6C61707365222C6D722C2866756E6374696F6E2865297B76617220743D652E73686170653B732E5F63616E4472696C6C446F776E2874293F732E5F6164644F7665';
wwv_flow_imp.g_varchar2_table(39328) := '726C61792874293A732E5F72656D6F76654F7665726C61792874297D292C2130292C746869732E6578656375746564285B2273686170652E637265617465222C2273686170652E6D6F7665222C2273686170652E64656C657465225D2C6D722C2866756E';
wwv_flow_imp.g_varchar2_table(39329) := '6374696F6E2865297B76617220743D652E6F6C64506172656E742C6E3D652E6E6577506172656E747C7C652E706172656E742C693D652E73686170653B732E5F63616E4472696C6C446F776E2869292626732E5F6164644F7665726C61792869292C732E';
wwv_flow_imp.g_varchar2_table(39330) := '5F7570646174654472696C6C646F776E4F7665726C61792874292C732E5F7570646174654472696C6C646F776E4F7665726C6179286E292C732E5F7570646174654472696C6C646F776E4F7665726C61792869297D292C2130292C746869732E72657665';
wwv_flow_imp.g_varchar2_table(39331) := '72746564285B2273686170652E637265617465222C2273686170652E6D6F7665222C2273686170652E64656C657465225D2C6D722C2866756E6374696F6E2865297B76617220743D652E6F6C64506172656E742C6E3D652E6E6577506172656E747C7C65';
wwv_flow_imp.g_varchar2_table(39332) := '2E706172656E742C693D652E73686170653B732E5F63616E4472696C6C446F776E2869292626732E5F6164644F7665726C61792869292C732E5F7570646174654472696C6C646F776E4F7665726C61792874292C732E5F7570646174654472696C6C646F';
wwv_flow_imp.g_varchar2_table(39333) := '776E4F7665726C6179286E292C732E5F7570646174654472696C6C646F776E4F7665726C61792869297D292C2130292C742E6F6E2822696D706F72742E72656E6465722E636F6D706C657465222C2866756E6374696F6E28297B6E2E66696C7465722828';
wwv_flow_imp.g_varchar2_table(39334) := '66756E6374696F6E2865297B72657475726E20732E5F63616E4472696C6C446F776E2865297D29292E6D6170282866756E6374696F6E2865297B732E5F6164644F7665726C61792865297D29297D29297D522866722C6572292C66722E70726F746F7479';
wwv_flow_imp.g_varchar2_table(39335) := '70652E5F7570646174654472696C6C646F776E4F7665726C61793D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661733B69662865297B766172206E3D742E66696E64526F6F742865293B6E2626746869732E5F7570646174654F';
wwv_flow_imp.g_varchar2_table(39336) := '7665726C61795669736962696C697479286E297D7D2C66722E70726F746F747970652E5F63616E4472696C6C446F776E3D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661733B72657475726E28302C792E69732928652C226270';
wwv_flow_imp.g_varchar2_table(39337) := '6D6E3A53756250726F6365737322292626742E66696E64526F6F74287272286529297D2C66722E70726F746F747970652E5F7570646174654F7665726C61795669736962696C6974793D66756E6374696F6E2865297B76617220743D746869732E5F6F76';
wwv_flow_imp.g_varchar2_table(39338) := '65726C6179732C6E3D28302C792E676574427573696E6573734F626A656374292865292C693D742E676574287B656C656D656E743A6E2E69642C747970653A226472696C6C646F776E227D295B305D3B69662869297B766172206F3D6E26266E2E676574';
wwv_flow_imp.g_varchar2_table(39339) := '2822666C6F77456C656D656E7473222926266E2E6765742822666C6F77456C656D656E747322292E6C656E6774683B5928692E68746D6C292E746F67676C652822626A732D6472696C6C646F776E2D656D707479222C216F297D7D2C66722E70726F746F';
wwv_flow_imp.g_varchar2_table(39340) := '747970652E5F6164644F7665726C61793D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732C6E3D746869732E5F6F7665726C6179732C693D28302C792E676574427573696E6573734F626A656374292865293B6E2E67657428';
wwv_flow_imp.g_varchar2_table(39341) := '7B656C656D656E743A652C747970653A226472696C6C646F776E227D292E6C656E6774682626746869732E5F72656D6F76654F7665726C61792865293B766172206F3D636528273C627574746F6E20747970653D22627574746F6E2220636C6173733D22';
wwv_flow_imp.g_varchar2_table(39342) := '626A732D6472696C6C646F776E223E3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C70';
wwv_flow_imp.g_varchar2_table(39343) := '6174682066696C6C2D72756C653D226576656E6F64642220643D224D342E38313830313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C';
wwv_flow_imp.g_varchar2_table(39344) := '342C31302E35204C392E363839363839342C31302E34393936383934204C332E37353733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37';
wwv_flow_imp.g_varchar2_table(39345) := '353733353933312C332E35303733353933312043342E30353032353235332C332E323134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E3C2F6275';
wwv_flow_imp.g_varchar2_table(39346) := '74746F6E3E27292C733D692E67657428226E616D6522297C7C692E6765742822696422292C723D746869732E5F7472616E736C61746528224F70656E207B656C656D656E747D222C7B656C656D656E743A737D293B6F2E73657441747472696275746528';
wwv_flow_imp.g_varchar2_table(39347) := '227469746C65222C72292C6F2E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B742E736574526F6F74456C656D656E7428742E66696E64526F6F7428727228652929297D29292C6E2E61646428652C226472';
wwv_flow_imp.g_varchar2_table(39348) := '696C6C646F776E222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A6F7D292C746869732E5F7570646174654F7665726C61795669736962696C6974792865297D2C66722E70726F746F747970652E5F72656D';
wwv_flow_imp.g_varchar2_table(39349) := '6F76654F7665726C61793D66756E6374696F6E2865297B746869732E5F6F7665726C6179732E72656D6F7665287B656C656D656E743A652C747970653A226472696C6C646F776E227D297D2C66722E24696E6A6563743D5B2263616E766173222C226576';
wwv_flow_imp.g_varchar2_table(39350) := '656E74427573222C22656C656D656E745265676973747279222C226F7665726C617973222C227472616E736C617465225D3B636F6E73742076723D7B5F5F646570656E64735F5F3A5B5A732C4A732C69725D2C5F5F696E69745F5F3A5B226472696C6C64';
wwv_flow_imp.g_varchar2_table(39351) := '6F776E42726561646372756D6273222C226472696C6C646F776E4F7665726C61794265686176696F72222C226472696C6C646F776E43656E746572696E67222C2273756270726F63657373436F6D7061746962696C697479225D2C6472696C6C646F776E';
wwv_flow_imp.g_varchar2_table(39352) := '42726561646372756D62733A5B2274797065222C64725D2C6472696C6C646F776E43656E746572696E673A5B2274797065222C68725D2C6472696C6C646F776E4F7665726C61794265686176696F723A5B2274797065222C66725D2C73756270726F6365';
wwv_flow_imp.g_varchar2_table(39353) := '7373436F6D7061746962696C6974793A5B2274797065222C70725D7D3B66756E6374696F6E20627228652C74297B746869732E5F6576656E744275733D652C746869732E6F66667365743D353B766172206E3D742E636C732822646A732D6F75746C696E';
wwv_flow_imp.g_varchar2_table(39354) := '65222C5B226E6F2D66696C6C225D292C6F3D746869733B66756E6374696F6E20732865297B76617220743D6B6528227265637422293B72657475726E20666528742C28302C692E6B7029287B783A302C793A302C72783A342C77696474683A3130302C68';
wwv_flow_imp.g_varchar2_table(39355) := '65696768743A3130307D2C6E29292C747D652E6F6E285B2273686170652E6164646564222C2273686170652E6368616E676564225D2C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766782C693D6A7428';
wwv_flow_imp.g_varchar2_table(39356) := '222E646A732D6F75746C696E65222C6E293B697C7C7565286E2C693D6F2E6765744F75746C696E652874297C7C732829292C6F2E75706461746553686170654F75746C696E6528692C74297D29292C652E6F6E285B22636F6E6E656374696F6E2E616464';
wwv_flow_imp.g_varchar2_table(39357) := '6564222C22636F6E6E656374696F6E2E6368616E676564225D2C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766782C693D6A7428222E646A732D6F75746C696E65222C6E293B697C7C7565286E2C693D73282929';
wwv_flow_imp.g_varchar2_table(39358) := '2C6F2E757064617465436F6E6E656374696F6E4F75746C696E6528692C74297D29297D62722E70726F746F747970652E75706461746553686170654F75746C696E653D66756E6374696F6E28652C74297B766172206E3D21312C6F3D746869732E5F6765';
wwv_flow_imp.g_varchar2_table(39359) := '7450726F76696465727328293B6F2E6C656E677468262628302C692E6A4A29286F2C2866756E6374696F6E2869297B6E3D6E7C7C692E7570646174654F75746C696E6528742C65297D29292C6E7C7C666528652C7B783A2D746869732E6F66667365742C';
wwv_flow_imp.g_varchar2_table(39360) := '793A2D746869732E6F66667365742C77696474683A742E77696474682B322A746869732E6F66667365742C6865696768743A742E6865696768742B322A746869732E6F66667365747D297D2C62722E70726F746F747970652E757064617465436F6E6E65';
wwv_flow_imp.g_varchar2_table(39361) := '6374696F6E4F75746C696E653D66756E6374696F6E28652C74297B766172206E3D63742874293B666528652C7B783A6E2E782D746869732E6F66667365742C793A6E2E792D746869732E6F66667365742C77696474683A6E2E77696474682B322A746869';
wwv_flow_imp.g_varchar2_table(39362) := '732E6F66667365742C6865696768743A6E2E6865696768742B322A746869732E6F66667365747D297D2C62722E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E28652C74297B747C7C28743D652C653D31653329';
wwv_flow_imp.g_varchar2_table(39363) := '2C746869732E5F6576656E744275732E6F6E28226F75746C696E652E67657450726F766964657273222C652C2866756E6374696F6E2865297B652E70726F7669646572732E707573682874297D29297D2C62722E70726F746F747970652E5F6765745072';
wwv_flow_imp.g_varchar2_table(39364) := '6F7669646572733D66756E6374696F6E28297B76617220653D746869732E5F6576656E744275732E6372656174654576656E74287B747970653A226F75746C696E652E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475';
wwv_flow_imp.g_varchar2_table(39365) := '726E20746869732E5F6576656E744275732E666972652865292C652E70726F7669646572737D2C62722E70726F746F747970652E6765744F75746C696E653D66756E6374696F6E2865297B76617220742C6E3D746869732E5F67657450726F7669646572';
wwv_flow_imp.g_varchar2_table(39366) := '7328293B72657475726E28302C692E6A4A29286E2C2866756E6374696F6E286E297B28302C692E546E29286E2E6765744F75746C696E6529262628743D747C7C6E2E6765744F75746C696E65286529297D29292C747D2C62722E24696E6A6563743D5B22';
wwv_flow_imp.g_varchar2_table(39367) := '6576656E74427573222C227374796C6573222C22656C656D656E745265676973747279225D3B636F6E7374205F723D7B5F5F696E69745F5F3A5B226F75746C696E65225D2C6F75746C696E653A5B2274797065222C62725D7D2C79723D7B77696474683A';
wwv_flow_imp.g_varchar2_table(39368) := '33362C6865696768743A35307D2C77723D7B77696474683A35302C6865696768743A35307D3B66756E6374696F6E20437228652C742C6E297B72657475726E206B65282270617468222C7B643A652C7374726F6B6557696474683A322C7472616E73666F';
wwv_flow_imp.g_varchar2_table(39369) := '726D3A607472616E736C61746528247B742E787D2C20247B742E797D29602C2E2E2E6E7D297D66756E6374696F6E20537228652C74297B746869732E5F7374796C65733D742C652E726567697374657250726F76696465722874686973297D66756E6374';
wwv_flow_imp.g_varchar2_table(39370) := '696F6E20787228652C74297B766172206E3B72657475726E2262706D6E3A446174614F626A6563745265666572656E6365223D3D3D743F6E3D79723A2262706D6E3A4461746153746F72655265666572656E6365223D3D3D742626286E3D7772292C652E';
wwv_flow_imp.g_varchar2_table(39371) := '77696474683D3D3D6E2E77696474682626652E6865696768743D3D3D6E2E6865696768747D53722E24696E6A6563743D5B226F75746C696E65222C227374796C6573225D2C53722E70726F746F747970652E6765744F75746C696E653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(39372) := '6E2865297B636F6E737420743D746869732E5F7374796C65732E636C732822646A732D6F75746C696E65222C5B226E6F2D66696C6C225D293B766172206E3B69662821526E2865292972657475726E28302C792E69732928652C2262706D6E3A47617465';
wwv_flow_imp.g_varchar2_table(39373) := '77617922293F286E3D6B6528227265637422292C28302C692E6B7029286E2E7374796C652C7B227472616E73666F726D2D626F78223A2266696C6C2D626F78222C7472616E73666F726D3A22726F7461746528343564656729222C227472616E73666F72';
wwv_flow_imp.g_varchar2_table(39374) := '6D2D6F726967696E223A2263656E746572227D292C6665286E2C28302C692E6B7029287B783A322C793A322C72783A342C77696474683A652E77696474682D342C6865696768743A652E6865696768742D347D2C742929293A28302C792E6973416E7929';
wwv_flow_imp.g_varchar2_table(39375) := '28652C5B2262706D6E3A5461736B222C2262706D6E3A53756250726F63657373222C2262706D6E3A47726F7570222C2262706D6E3A43616C6C4163746976697479225D293F6665286E3D6B6528227265637422292C28302C692E6B7029287B783A2D352C';
wwv_flow_imp.g_varchar2_table(39376) := '793A2D352C72783A31342C77696474683A652E77696474682B31302C6865696768743A652E6865696768742B31307D2C7429293A28302C792E69732928652C2262706D6E3A456E644576656E7422293F6665286E3D6B652822636972636C6522292C2830';
wwv_flow_imp.g_varchar2_table(39377) := '2C692E6B7029287B63783A652E77696474682F322C63793A652E6865696768742F322C723A652E77696474682F322B352B317D2C7429293A28302C792E69732928652C2262706D6E3A4576656E7422293F6665286E3D6B652822636972636C6522292C28';
wwv_flow_imp.g_varchar2_table(39378) := '302C692E6B7029287B63783A652E77696474682F322C63793A652E6865696768742F322C723A652E77696474682F322B357D2C7429293A28302C792E69732928652C2262706D6E3A446174614F626A6563745265666572656E636522292626787228652C';
wwv_flow_imp.g_varchar2_table(39379) := '2262706D6E3A446174614F626A6563745265666572656E636522293F6E3D437228224D34342E373634382031312E333236334C33362E3938393220322E36343037344333362E3034353120312E35383632382033342E3536353120302E39383837303820';
wwv_flow_imp.g_varchar2_table(39380) := '33332E3139303420302E39383837303848352E393836363743332E323236383820302E39383837303820302E39383936323420332E333438393220302E39383936323420362E32363033395635352E3032333543302E3938393632342035372E39333439';
wwv_flow_imp.g_varchar2_table(39381) := '20332E32323638382036302E3239353220352E39383636372036302E323935324834302E3936364334332E373235372036302E323935322034352E3936332035372E393334392034352E3936332035352E303233355631342E393435394334352E393633';
wwv_flow_imp.g_varchar2_table(39382) := '2031332E353939382034352E363430372031322E333034382034342E373634382031312E333236335A222C7B783A2D362C793A2D367D2C74293A28302C792E69732928652C2262706D6E3A4461746153746F72655265666572656E636522292626787228';
wwv_flow_imp.g_varchar2_table(39383) := '652C2262706D6E3A4461746153746F72655265666572656E636522292626286E3D437228224D312E30333834352034382E3133343743312E30333834352034392E3335313120312E30373239352035302E37353820312E33383334322035322E30363443';
wwv_flow_imp.g_varchar2_table(39384) := '312E36393934392035332E3339333820322E33323432382035342E3731353420332E35363338332035352E3634323843362E30323533332035372E343834312031302E313136312035382E373638352031342E383231322035392E363036374331392E35';
wwv_flow_imp.g_varchar2_table(39385) := '3737322036302E343533382032352E313338382036302E383733382033302E363833312036302E383733384333362E323237362036302E383733382034312E373839312036302E343533382034362E3534352035392E363036374335312E323530342035';
wwv_flow_imp.g_varchar2_table(39386) := '382E373638372035352E333431322035372E343834322035372E383032382035352E363432394335392E303432342035342E373135362035392E363637332035332E333933382035392E393833342035322E3036344336302E323933382035302E373537';
wwv_flow_imp.g_varchar2_table(39387) := '392036302E333238352034392E3335312036302E333238352034382E313334345631332E383431354336302E333238352031322E363234392036302E323933382031312E3231382035392E3938333420392E39313137314335392E3636373320382E3538';
wwv_flow_imp.g_varchar2_table(39388) := '3139342035392E3034323320372E323630322035372E3830323720362E33333239344335352E33343120342E34393136382035312E3235303320332E32303732332034362E35343520322E33363931344334312E3738393120312E3532322033362E3232';
wwv_flow_imp.g_varchar2_table(39389) := '373620312E31303230342033302E3638333120312E31303230354332352E3133383820312E31303230362031392E3537373220312E35323230362031342E3832313320322E33363932334331302E3131363220332E323037333420362E30323534332034';
wwv_flow_imp.g_varchar2_table(39390) := '2E343931383320332E3536333920362E333333313443322E333234333320372E323630333820312E363939353120382E353832303620312E333833343320392E393131383143312E30373239352031312E3231373920312E30333834352031322E363234';
wwv_flow_imp.g_varchar2_table(39391) := '3720312E30333834352031332E383431315634382E313334375A222C7B783A2D362C793A2D367D2C7429292C6E7D2C53722E70726F746F747970652E7570646174654F75746C696E653D66756E6374696F6E28652C74297B69662821526E286529297265';
wwv_flow_imp.g_varchar2_table(39392) := '7475726E28302C792E6973416E792928652C5B2262706D6E3A53756250726F63657373222C2262706D6E3A47726F7570225D293F28666528742C7B77696474683A652E77696474682B31302C6865696768743A652E6865696768742B31307D292C213029';
wwv_flow_imp.g_varchar2_table(39393) := '3A212128302C792E6973416E792928652C5B2262706D6E3A4576656E74222C2262706D6E3A47617465776179222C2262706D6E3A4461746153746F72655265666572656E6365222C2262706D6E3A446174614F626A6563745265666572656E6365225D29';
wwv_flow_imp.g_varchar2_table(39394) := '7D3B636F6E7374206B723D7B5F5F646570656E64735F5F3A5B5F725D2C5F5F696E69745F5F3A5B226F75746C696E6550726F7669646572225D2C6F75746C696E6550726F76696465723A5B2274797065222C53725D7D3B66756E6374696F6E2045722865';
wwv_flow_imp.g_varchar2_table(39395) := '297B6526262266756E6374696F6E223D3D747970656F6620652E73746F7050726F7061676174696F6E2626652E73746F7050726F7061676174696F6E28297D66756E6374696F6E204C722865297B72657475726E20652E6F726967696E616C4576656E74';
wwv_flow_imp.g_varchar2_table(39396) := '7C7C652E7372634576656E747D66756E6374696F6E2044722865297B45722865292C4572284C72286529297D66756E6374696F6E2054722865297B72657475726E20652E706F696E746572732626652E706F696E746572732E6C656E677468262628653D';
wwv_flow_imp.g_varchar2_table(39397) := '652E706F696E746572735B305D292C652E746F75636865732626652E746F75636865732E6C656E677468262628653D652E746F75636865735B305D292C653F7B783A652E636C69656E74582C793A652E636C69656E74597D3A6E756C6C7D66756E637469';
wwv_flow_imp.g_varchar2_table(39398) := '6F6E20497228297B72657475726E2F6D61632F692E74657374286E6176696761746F722E706C6174666F726D297D66756E6374696F6E204D7228652C74297B72657475726E284C722865297C7C65292E627574746F6E3D3D3D747D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(39399) := '41722865297B72657475726E204D7228652C30297D66756E6374696F6E204E722865297B76617220743D4C722865297C7C653B72657475726E21214172286529262628497228293F742E6D6574614B65793A742E6374726C4B6579297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(39400) := '6E2050722865297B76617220743D4C722865297C7C653B72657475726E2041722865292626742E73686966744B65797D66756E6374696F6E204F722865297B72657475726E21307D66756E6374696F6E2052722865297B72657475726E2041722865297C';
wwv_flow_imp.g_varchar2_table(39401) := '7C66756E6374696F6E2865297B72657475726E204D7228652C31297D2865297D66756E6374696F6E20467228652C742C6E297B766172206F3D746869733B66756E6374696F6E2073286E2C692C6F297B76617220732C723B2866756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(39402) := '74297B72657475726E2128635B655D7C7C4172292874297D29286E2C69297C7C286F3F723D742E6765744772617068696373286F293A28733D692E64656C65676174655461726765747C7C692E74617267657429262628723D732C6F3D742E6765742872';
wwv_flow_imp.g_varchar2_table(39403) := '29292C7226266F262621313D3D3D652E66697265286E2C7B656C656D656E743A6F2C6766783A722C6F726967696E616C4576656E743A697D29262628692E73746F7050726F7061676174696F6E28292C692E70726576656E7444656661756C7428292929';
wwv_flow_imp.g_varchar2_table(39404) := '7D76617220723D7B7D3B66756E6374696F6E20612865297B72657475726E20725B655D7D766172206C3D7B636C69636B3A22656C656D656E742E636C69636B222C636F6E746578746D656E753A22656C656D656E742E636F6E746578746D656E75222C64';
wwv_flow_imp.g_varchar2_table(39405) := '626C636C69636B3A22656C656D656E742E64626C636C69636B222C6D6F757365646F776E3A22656C656D656E742E6D6F757365646F776E222C6D6F7573656D6F76653A22656C656D656E742E6D6F7573656D6F7665222C6D6F7573656F7665723A22656C';
wwv_flow_imp.g_varchar2_table(39406) := '656D656E742E686F766572222C6D6F7573656F75743A22656C656D656E742E6F7574222C6D6F75736575703A22656C656D656E742E6D6F7573657570227D2C633D7B22656C656D656E742E636F6E746578746D656E75223A4F722C22656C656D656E742E';
wwv_flow_imp.g_varchar2_table(39407) := '6D6F757365646F776E223A52722C22656C656D656E742E6D6F7573657570223A52722C22656C656D656E742E636C69636B223A52722C22656C656D656E742E64626C636C69636B223A52727D3B66756E6374696F6E206428652C742C6E2C69297B766172';
wwv_flow_imp.g_varchar2_table(39408) := '206F3D725B6E5D3D66756E6374696F6E2865297B73286E2C65297D3B69262628635B6E5D3D69292C6F2E2464656C65676174653D467428652C227376672C202E646A732D656C656D656E74222C742C6F297D66756E6374696F6E206828652C742C6E297B';
wwv_flow_imp.g_varchar2_table(39409) := '76617220693D61286E293B692626427428652C742C692E2464656C6567617465297D652E6F6E282263616E7661732E64657374726F79222C2866756E6374696F6E2865297B2166756E6374696F6E2865297B28302C692E6A4A29286C2C2866756E637469';
wwv_flow_imp.g_varchar2_table(39410) := '6F6E28742C6E297B6828652C6E2C74297D29297D28652E737667297D29292C652E6F6E282263616E7661732E696E6974222C2866756E6374696F6E2865297B2166756E6374696F6E2865297B28302C692E6A4A29286C2C2866756E6374696F6E28742C6E';
wwv_flow_imp.g_varchar2_table(39411) := '297B6428652C6E2C74297D29297D28652E737667297D29292C652E6F6E285B2273686170652E6164646564222C22636F6E6E656374696F6E2E6164646564225D2C2866756E6374696F6E2874297B766172206E3D742E656C656D656E742C693D742E6766';
wwv_flow_imp.g_varchar2_table(39412) := '783B652E666972652822696E746572616374696F6E4576656E74732E637265617465486974222C7B656C656D656E743A6E2C6766783A697D297D29292C652E6F6E285B2273686170652E6368616E676564222C22636F6E6E656374696F6E2E6368616E67';
wwv_flow_imp.g_varchar2_table(39413) := '6564225D2C3530302C2866756E6374696F6E2874297B766172206E3D742E656C656D656E742C693D742E6766783B652E666972652822696E746572616374696F6E4576656E74732E757064617465486974222C7B656C656D656E743A6E2C6766783A697D';
wwv_flow_imp.g_varchar2_table(39414) := '297D29292C652E6F6E2822696E746572616374696F6E4576656E74732E637265617465486974222C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766783B6F2E63726561746544656661756C7448697428';
wwv_flow_imp.g_varchar2_table(39415) := '742C6E297D29292C652E6F6E2822696E746572616374696F6E4576656E74732E757064617465486974222C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766783B6F2E75706461746544656661756C744869742874';
wwv_flow_imp.g_varchar2_table(39416) := '2C6E297D29293B76617220753D6D2822646A732D68697420646A732D6869742D7374726F6B6522292C703D6D2822646A732D68697420646A732D6869742D636C69636B2D7374726F6B6522292C673D7B616C6C3A6D2822646A732D68697420646A732D68';
wwv_flow_imp.g_varchar2_table(39417) := '69742D616C6C22292C22636C69636B2D7374726F6B65223A702C7374726F6B653A752C226E6F2D6D6F7665223A6D2822646A732D68697420646A732D6869742D6E6F2D6D6F766522297D3B66756E6374696F6E206D28652C74297B72657475726E20743D';
wwv_flow_imp.g_varchar2_table(39418) := '28302C692E6B7029287B7374726F6B653A227768697465222C7374726F6B6557696474683A31357D2C747C7C7B7D292C6E2E636C7328652C5B226E6F2D66696C6C222C226E6F2D626F72646572225D2C74297D66756E6374696F6E206628652C74297B76';
wwv_flow_imp.g_varchar2_table(39419) := '6172206E3D675B745D3B696628216E297468726F77206E6577204572726F722822696E76616C6964206869742074797065203C222B742B223E22293B72657475726E20666528652C6E292C657D66756E6374696F6E207628652C74297B756528652C7429';
wwv_flow_imp.g_varchar2_table(39420) := '7D746869732E72656D6F7665486974733D66756E6374696F6E2865297B76617220743D717428222E646A732D686974222C65293B28302C692E6A4A2928742C5265297D2C746869732E63726561746544656661756C744869743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(39421) := '2C74297B766172206E2C693D652E776179706F696E74732C6F3D652E69734672616D653B72657475726E20693F746869732E637265617465576179706F696E747348697428742C69293A286E3D6F3F227374726F6B65223A22616C6C222C746869732E63';
wwv_flow_imp.g_varchar2_table(39422) := '7265617465426F7848697428742C6E2C7B77696474683A652E77696474682C6865696768743A652E6865696768747D29297D2C746869732E637265617465576179706F696E74734869743D66756E6374696F6E28652C74297B766172206E3D6E74287429';
wwv_flow_imp.g_varchar2_table(39423) := '3B72657475726E2066286E2C227374726F6B6522292C7628652C6E292C6E7D2C746869732E637265617465426F784869743D66756E6374696F6E28652C742C6E297B6E3D28302C692E6B7029287B783A302C793A307D2C6E293B766172206F3D6B652822';
wwv_flow_imp.g_varchar2_table(39424) := '7265637422293B72657475726E2066286F2C74292C6665286F2C6E292C7628652C6F292C6F7D2C746869732E75706461746544656661756C744869743D66756E6374696F6E28652C74297B766172206E3D6A7428222E646A732D686974222C74293B6966';
wwv_flow_imp.g_varchar2_table(39425) := '286E2972657475726E20652E776179706F696E74733F6974286E2C652E776179706F696E7473293A6665286E2C7B77696474683A652E77696474682C6865696768743A652E6865696768747D292C6E7D2C746869732E666972653D732C746869732E7472';
wwv_flow_imp.g_varchar2_table(39426) := '69676765724D6F7573654576656E743D66756E6374696F6E28652C742C6E297B76617220693D6C5B655D3B6966282169297468726F77206E6577204572726F722822756E6D617070656420444F4D206576656E74206E616D65203C222B652B223E22293B';
wwv_flow_imp.g_varchar2_table(39427) := '72657475726E207328692C742C6E297D2C746869732E6D6F75736548616E646C65723D612C746869732E72656769737465724576656E743D642C746869732E756E72656769737465724576656E743D687D46722E24696E6A6563743D5B226576656E7442';
wwv_flow_imp.g_varchar2_table(39428) := '7573222C22656C656D656E745265676973747279222C227374796C6573225D3B636F6E73742042723D7B5F5F696E69745F5F3A5B22696E746572616374696F6E4576656E7473225D2C696E746572616374696F6E4576656E74733A5B2274797065222C46';
wwv_flow_imp.g_varchar2_table(39429) := '725D7D3B66756E6374696F6E20567228652C74297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D742C746869732E5F73656C6563746564456C656D656E74733D5B5D3B766172206E3D746869733B652E6F6E285B22736861';
wwv_flow_imp.g_varchar2_table(39430) := '70652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B6E2E646573656C6563742874297D29292C652E6F6E285B226469616772616D2E636C656172222C';
wwv_flow_imp.g_varchar2_table(39431) := '22726F6F742E736574225D2C2866756E6374696F6E2865297B6E2E73656C656374286E756C6C297D29297D56722E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C56722E70726F746F747970652E646573656C6563743D6675';
wwv_flow_imp.g_varchar2_table(39432) := '6E6374696F6E2865297B76617220743D746869732E5F73656C6563746564456C656D656E74732C6E3D742E696E6465784F662865293B6966282D31213D3D6E297B76617220693D742E736C69636528293B742E73706C696365286E2C31292C746869732E';
wwv_flow_imp.g_varchar2_table(39433) := '5F6576656E744275732E66697265282273656C656374696F6E2E6368616E676564222C7B6F6C6453656C656374696F6E3A692C6E657753656C656374696F6E3A747D297D7D2C56722E70726F746F747970652E6765743D66756E6374696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(39434) := '7475726E20746869732E5F73656C6563746564456C656D656E74737D2C56722E70726F746F747970652E697353656C65637465643D66756E6374696F6E2865297B72657475726E2D31213D3D746869732E5F73656C6563746564456C656D656E74732E69';
wwv_flow_imp.g_varchar2_table(39435) := '6E6465784F662865297D2C56722E70726F746F747970652E73656C6563743D66756E6374696F6E28652C74297B766172206E3D746869732E5F73656C6563746564456C656D656E74732C6F3D6E2E736C69636528293B28302C692E6379292865297C7C28';
wwv_flow_imp.g_varchar2_table(39436) := '653D653F5B655D3A5B5D293B76617220733D746869732E5F63616E7661732C723D732E676574526F6F74456C656D656E7428293B653D652E66696C746572282866756E6374696F6E2865297B76617220743D732E66696E64526F6F742865293B72657475';
wwv_flow_imp.g_varchar2_table(39437) := '726E20723D3D3D747D29292C743F28302C692E6A4A2928652C2866756E6374696F6E2865297B2D313D3D3D6E2E696E6465784F6628652926266E2E707573682865297D29293A746869732E5F73656C6563746564456C656D656E74733D6E3D652E736C69';
wwv_flow_imp.g_varchar2_table(39438) := '636528292C746869732E5F6576656E744275732E66697265282273656C656374696F6E2E6368616E676564222C7B6F6C6453656C656374696F6E3A6F2C6E657753656C656374696F6E3A6E7D297D3B766172207A723D22686F766572222C48723D227365';
wwv_flow_imp.g_varchar2_table(39439) := '6C6563746564223B66756E6374696F6E20577228652C742C6E297B746869732E5F63616E7661733D653B766172206F3D746869733B66756E6374696F6E207328742C6E297B652E6164644D61726B657228742C6E297D66756E6374696F6E207228742C6E';
wwv_flow_imp.g_varchar2_table(39440) := '297B652E72656D6F76654D61726B657228742C6E297D746869732E5F6D756C746953656C656374696F6E426F783D6E756C6C2C742E6F6E2822656C656D656E742E686F766572222C2866756E6374696F6E2865297B7328652E656C656D656E742C7A7229';
wwv_flow_imp.g_varchar2_table(39441) := '7D29292C742E6F6E2822656C656D656E742E6F7574222C2866756E6374696F6E2865297B7228652E656C656D656E742C7A72297D29292C742E6F6E282273656C656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(39442) := '2E6F6C6453656C656374696F6E2C6E3D652E6E657753656C656374696F6E3B28302C692E6A4A2928742C2866756E6374696F6E2865297B2D313D3D3D6E2E696E6465784F66286529262666756E6374696F6E2865297B7228652C4872297D2865297D2929';
wwv_flow_imp.g_varchar2_table(39443) := '2C28302C692E6A4A29286E2C2866756E6374696F6E2865297B2D313D3D3D742E696E6465784F66286529262666756E6374696F6E2865297B7328652C4872297D2865297D29292C6F2E5F75706461746553656C656374696F6E4F75746C696E65286E297D';
wwv_flow_imp.g_varchar2_table(39444) := '29292C742E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E2865297B6E2E697353656C656374656428652E656C656D656E742926266F2E5F75706461746553656C656374696F6E4F75746C696E65286E2E6765742829297D29';
wwv_flow_imp.g_varchar2_table(39445) := '297D66756E6374696F6E206A7228652C742C6E2C6F297B652E6F6E28226372656174652E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C6F3D6E2E63616E457865637574652C733D6E2E656C656D656E74';
wwv_flow_imp.g_varchar2_table(39446) := '732C723D286E2E68696E74737C7C7B7D292E6175746F53656C6563743B6966286F297B69662821313D3D3D722972657475726E3B28302C692E6379292872293F742E73656C6563742872293A742E73656C65637428732E66696C74657228717229297D7D';
wwv_flow_imp.g_varchar2_table(39447) := '29292C652E6F6E2822636F6E6E6563742E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742E636F6E6E656374696F6E3B6E2626742E73656C656374286E297D29292C652E6F6E282273686170652E6D6F7665';
wwv_flow_imp.g_varchar2_table(39448) := '2E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E70726576696F757353656C656374696F6E7C7C5B5D2C733D6F2E67657428652E636F6E746578742E73686170652E6964293B28302C692E493629286E2C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(39449) := '6E2865297B72657475726E20732E69643D3D3D652E69647D29297C7C742E73656C6563742873297D29292C652E6F6E2822656C656D656E742E636C69636B222C2866756E6374696F6E2865297B6966284172286529297B76617220693D652E656C656D65';
wwv_flow_imp.g_varchar2_table(39450) := '6E743B693D3D3D6E2E676574526F6F74456C656D656E742829262628693D6E756C6C293B766172206F3D742E697353656C65637465642869292C733D742E67657428292E6C656E6774683E312C723D50722865293B6966286F2626732972657475726E20';
wwv_flow_imp.g_varchar2_table(39451) := '723F742E646573656C6563742869293A742E73656C6563742869293B6F3F742E646573656C6563742869293A742E73656C65637428692C72297D7D29297D66756E6374696F6E2071722865297B72657475726E21652E68696464656E7D57722E24696E6A';
wwv_flow_imp.g_varchar2_table(39452) := '6563743D5B2263616E766173222C226576656E74427573222C2273656C656374696F6E225D2C57722E70726F746F747970652E5F75706461746553656C656374696F6E4F75746C696E653D66756E6374696F6E2865297B76617220743D746869732E5F63';
wwv_flow_imp.g_varchar2_table(39453) := '616E7661732E6765744C61796572282273656C656374696F6E4F75746C696E6522293B79652874293B766172206E3D652E6C656E6774683E313B696628626528746869732E5F63616E7661732E676574436F6E7461696E65722829295B6E3F2261646422';
wwv_flow_imp.g_varchar2_table(39454) := '3A2272656D6F7665225D2822646A732D6D756C74692D73656C65637422292C6E297B766172206F3D66756E6374696F6E2865297B72657475726E7B783A652E782D362C793A652E792D362C77696474683A652E77696474682B31322C6865696768743A65';
wwv_flow_imp.g_varchar2_table(39455) := '2E6865696768742B31327D7D286374286529292C733D6B6528227265637422293B666528732C28302C692E6B7029287B72783A337D2C6F29292C62652873292E6164642822646A732D73656C656374696F6E2D6F75746C696E6522292C756528742C7329';
wwv_flow_imp.g_varchar2_table(39456) := '7D7D2C6A722E24696E6A6563743D5B226576656E74427573222C2273656C656374696F6E222C2263616E766173222C22656C656D656E745265676973747279225D3B636F6E73742024723D7B5F5F696E69745F5F3A5B2273656C656374696F6E56697375';
wwv_flow_imp.g_varchar2_table(39457) := '616C73222C2273656C656374696F6E4265686176696F72225D2C5F5F646570656E64735F5F3A5B42722C5F725D2C73656C656374696F6E3A5B2274797065222C56725D2C73656C656374696F6E56697375616C733A5B2274797065222C57725D2C73656C';
wwv_flow_imp.g_varchar2_table(39458) := '656374696F6E4265686176696F723A5B2274797065222C6A725D7D3B66756E6374696F6E2055722865297B74732E63616C6C28746869732C65297D522855722C7473292C55722E70726F746F747970652E5F6D6F64756C65733D5B71732C76722C6B722C';
wwv_flow_imp.g_varchar2_table(39459) := '5A732C24722C56735D2C55722E70726F746F747970652E5F6D6F64646C65457874656E73696F6E733D7B7D3B766172204B723D5B2263222C2243225D2C47723D5B2276222C2256225D2C51723D5B2279222C2259225D2C59723D5B227A222C225A225D3B';
wwv_flow_imp.g_varchar2_table(39460) := '66756E6374696F6E205A722865297B72657475726E21652E616C744B6579262628652E6374726C4B65797C7C652E6D6574614B6579297D66756E6374696F6E20587228652C74297B72657475726E2D31213D3D28653D28302C692E6379292865293F653A';
wwv_flow_imp.g_varchar2_table(39461) := '5B655D292E696E6465784F6628742E6B6579297C7C2D31213D3D652E696E6465784F6628742E636F6465297D66756E6374696F6E204A722865297B72657475726E20652E73686966744B65797D66756E6374696F6E2065612865297B72657475726E205A';
wwv_flow_imp.g_varchar2_table(39462) := '722865292626214A72286529262658722859722C65297D66756E6374696F6E2074612865297B72657475726E205A7228652926262858722851722C65297C7C58722859722C652926264A72286529297D766172206E613D226B6579626F6172642E6B6579';
wwv_flow_imp.g_varchar2_table(39463) := '646F776E222C69613D22696E7075742D68616E646C652D6D6F6469666965642D6B657973223B66756E6374696F6E206F6128652C74297B766172206E3D746869733B746869732E5F636F6E6669673D657C7C7B7D2C746869732E5F6576656E744275733D';
wwv_flow_imp.g_varchar2_table(39464) := '742C746869732E5F6B6579646F776E48616E646C65723D746869732E5F6B6579646F776E48616E646C65722E62696E642874686973292C746869732E5F6B6579757048616E646C65723D746869732E5F6B6579757048616E646C65722E62696E64287468';
wwv_flow_imp.g_varchar2_table(39465) := '6973292C742E6F6E28226469616772616D2E64657374726F79222C2866756E6374696F6E28297B6E2E5F66697265282264657374726F7922292C6E2E756E62696E6428297D29292C742E6F6E28226469616772616D2E696E6974222C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(39466) := '6E28297B6E2E5F666972652822696E697422297D29292C742E6F6E2822617474616368222C2866756E6374696F6E28297B652626652E62696E64546F26266E2E62696E6428652E62696E64546F297D29292C742E6F6E2822646574616368222C2866756E';
wwv_flow_imp.g_varchar2_table(39467) := '6374696F6E28297B6E2E756E62696E6428297D29297D6F612E24696E6A6563743D5B22636F6E6669672E6B6579626F617264222C226576656E74427573225D2C6F612E70726F746F747970652E5F6B6579646F776E48616E646C65723D66756E6374696F';
wwv_flow_imp.g_varchar2_table(39468) := '6E2865297B746869732E5F6B657948616E646C657228652C6E61297D2C6F612E70726F746F747970652E5F6B6579757048616E646C65723D66756E6374696F6E2865297B746869732E5F6B657948616E646C657228652C226B6579626F6172642E6B6579';
wwv_flow_imp.g_varchar2_table(39469) := '757022297D2C6F612E70726F746F747970652E5F6B657948616E646C65723D66756E6374696F6E28652C74297B69662821746869732E5F69734576656E7449676E6F726564286529297B766172206E3D7B6B65794576656E743A657D3B746869732E5F65';
wwv_flow_imp.g_varchar2_table(39470) := '76656E744275732E6669726528747C7C6E612C6E292626652E70726576656E7444656661756C7428297D7D2C6F612E70726F746F747970652E5F69734576656E7449676E6F7265643D66756E6374696F6E2865297B72657475726E2121652E6465666175';
wwv_flow_imp.g_varchar2_table(39471) := '6C7450726576656E7465647C7C2828743D652E74617267657429262628577428742C22696E7075742C20746578746172656122297C7C2274727565223D3D3D742E636F6E74656E744564697461626C65297C7C66756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(39472) := '6E20652626577428652C22627574746F6E2C20696E7075745B747970653D7375626D69745D2C20696E7075745B747970653D627574746F6E5D2C20615B687265665D2C205B617269612D726F6C653D627574746F6E5D22297D28652E7461726765742926';
wwv_flow_imp.g_varchar2_table(39473) := '265872285B2220222C22456E746572225D2C6529292626746869732E5F69734D6F6469666965644B657949676E6F7265642865293B76617220747D2C6F612E70726F746F747970652E5F69734D6F6469666965644B657949676E6F7265643D66756E6374';
wwv_flow_imp.g_varchar2_table(39474) := '696F6E2865297B72657475726E215A722865297C7C2D313D3D3D746869732E5F676574416C6C6F7765644D6F6469666965727328652E746172676574292E696E6465784F6628652E6B6579297D2C6F612E70726F746F747970652E5F676574416C6C6F77';
wwv_flow_imp.g_varchar2_table(39475) := '65644D6F646966696572733D66756E6374696F6E2865297B76617220743D447428652C225B222B69612B225D222C2130293B72657475726E21747C7C746869732E5F6E6F6465262621746869732E5F6E6F64652E636F6E7461696E732874293F5B5D3A74';
wwv_flow_imp.g_varchar2_table(39476) := '2E676574417474726962757465286961292E73706C697428222C22297D2C6F612E70726F746F747970652E62696E643D66756E6374696F6E2865297B746869732E756E62696E6428292C746869732E5F6E6F64653D652C4F742E62696E6428652C226B65';
wwv_flow_imp.g_varchar2_table(39477) := '79646F776E222C746869732E5F6B6579646F776E48616E646C6572292C4F742E62696E6428652C226B65797570222C746869732E5F6B6579757048616E646C6572292C746869732E5F66697265282262696E6422297D2C6F612E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(39478) := '67657442696E64696E673D66756E6374696F6E28297B72657475726E20746869732E5F6E6F64657D2C6F612E70726F746F747970652E756E62696E643D66756E6374696F6E28297B76617220653D746869732E5F6E6F64653B65262628746869732E5F66';
wwv_flow_imp.g_varchar2_table(39479) := '6972652822756E62696E6422292C4F742E756E62696E6428652C226B6579646F776E222C746869732E5F6B6579646F776E48616E646C6572292C4F742E756E62696E6428652C226B65797570222C746869732E5F6B6579757048616E646C657229292C74';
wwv_flow_imp.g_varchar2_table(39480) := '6869732E5F6E6F64653D6E756C6C7D2C6F612E70726F746F747970652E5F666972653D66756E6374696F6E2865297B746869732E5F6576656E744275732E6669726528226B6579626F6172642E222B652C7B6E6F64653A746869732E5F6E6F64657D297D';
wwv_flow_imp.g_varchar2_table(39481) := '2C6F612E70726F746F747970652E6164644C697374656E65723D66756E6374696F6E28652C742C6E297B28302C692E546E292865292626286E3D742C743D652C653D316533292C746869732E5F6576656E744275732E6F6E286E7C7C6E612C652C74297D';
wwv_flow_imp.g_varchar2_table(39482) := '2C6F612E70726F746F747970652E72656D6F76654C697374656E65723D66756E6374696F6E28652C74297B746869732E5F6576656E744275732E6F666628747C7C6E612C65297D2C6F612E70726F746F747970652E6861734D6F6469666965723D66756E';
wwv_flow_imp.g_varchar2_table(39483) := '6374696F6E2865297B72657475726E20652E6374726C4B65797C7C652E6D6574614B65797C7C652E73686966744B65797C7C652E616C744B65797D2C6F612E70726F746F747970652E6973436D643D5A722C6F612E70726F746F747970652E6973536869';
wwv_flow_imp.g_varchar2_table(39484) := '66743D4A722C6F612E70726F746F747970652E69734B65793D58723B7661722073613D3530303B66756E6374696F6E20726128652C74297B766172206E3D746869733B652E6F6E2822656469746F72416374696F6E732E696E6974222C73612C2866756E';
wwv_flow_imp.g_varchar2_table(39485) := '6374696F6E2865297B76617220693D652E656469746F72416374696F6E733B6E2E726567697374657242696E64696E677328742C69297D29297D72612E24696E6A6563743D5B226576656E74427573222C226B6579626F617264225D2C72612E70726F74';
wwv_flow_imp.g_varchar2_table(39486) := '6F747970652E726567697374657242696E64696E67733D66756E6374696F6E28652C74297B66756E6374696F6E206E286E2C69297B742E697352656769737465726564286E292626652E6164644C697374656E65722869297D6E2822756E646F222C2866';
wwv_flow_imp.g_varchar2_table(39487) := '756E6374696F6E2865297B696628656128652E6B65794576656E74292972657475726E20742E747269676765722822756E646F22292C21307D29292C6E28227265646F222C2866756E6374696F6E2865297B696628746128652E6B65794576656E742929';
wwv_flow_imp.g_varchar2_table(39488) := '72657475726E20742E7472696767657228227265646F22292C21307D29292C6E2822636F7079222C2866756E6374696F6E2865297B6966285A72286E3D652E6B65794576656E742926265872284B722C6E292972657475726E20742E7472696767657228';
wwv_flow_imp.g_varchar2_table(39489) := '22636F707922292C21303B766172206E7D29292C6E28227061737465222C2866756E6374696F6E2865297B6966285A72286E3D652E6B65794576656E7429262658722847722C6E292972657475726E20742E747269676765722822706173746522292C21';
wwv_flow_imp.g_varchar2_table(39490) := '303B766172206E7D29292C6E2822737465705A6F6F6D222C2866756E6374696F6E2865297B766172206E3D652E6B65794576656E743B6966285872285B222B222C22416464222C223D225D2C6E2926265A72286E292972657475726E20742E7472696767';
wwv_flow_imp.g_varchar2_table(39491) := '65722822737465705A6F6F6D222C7B76616C75653A317D292C21307D29292C6E2822737465705A6F6F6D222C2866756E6374696F6E2865297B766172206E3D652E6B65794576656E743B6966285872285B222D222C225375627472616374225D2C6E2926';
wwv_flow_imp.g_varchar2_table(39492) := '265A72286E292972657475726E20742E747269676765722822737465705A6F6F6D222C7B76616C75653A2D317D292C21307D29292C6E28227A6F6F6D222C2866756E6374696F6E2865297B766172206E3D652E6B65794576656E743B6966285872282230';
wwv_flow_imp.g_varchar2_table(39493) := '222C6E2926265A72286E292972657475726E20742E7472696767657228227A6F6F6D222C7B76616C75653A317D292C21307D29292C6E282272656D6F766553656C656374696F6E222C2866756E6374696F6E2865297B6966285872285B224261636B7370';
wwv_flow_imp.g_varchar2_table(39494) := '616365222C2244656C657465222C2244656C225D2C652E6B65794576656E74292972657475726E20742E74726967676572282272656D6F766553656C656374696F6E22292C21307D29297D3B636F6E73742061613D7B5F5F696E69745F5F3A5B226B6579';
wwv_flow_imp.g_varchar2_table(39495) := '626F617264222C226B6579626F61726442696E64696E6773225D2C6B6579626F6172643A5B2274797065222C6F615D2C6B6579626F61726442696E64696E67733A5B2274797065222C72615D7D3B766172206C613D7B6D6F766553706565643A35302C6D';
wwv_flow_imp.g_varchar2_table(39496) := '6F76655370656564416363656C6572617465643A3230307D3B66756E6374696F6E20636128652C742C6E297B766172206F3D746869733B746869732E5F636F6E6669673D28302C692E6B7029287B7D2C6C612C657C7C7B7D292C742E6164644C69737465';
wwv_flow_imp.g_varchar2_table(39497) := '6E6572282866756E6374696F6E2865297B766172206E3D652E6B65794576656E742C693D6F2E5F636F6E6669673B696628742E6973436D64286E292626742E69734B6579285B224172726F774C656674222C224C656674222C224172726F775570222C22';
wwv_flow_imp.g_varchar2_table(39498) := '5570222C224172726F77446F776E222C22446F776E222C224172726F775269676874222C225269676874225D2C6E29297B76617220732C723D742E69735368696674286E293F692E6D6F76655370656564416363656C6572617465643A692E6D6F766553';
wwv_flow_imp.g_varchar2_table(39499) := '706565643B737769746368286E2E6B6579297B63617365224172726F774C656674223A63617365224C656674223A733D226C656674223B627265616B3B63617365224172726F775570223A63617365225570223A733D227570223B627265616B3B636173';
wwv_flow_imp.g_varchar2_table(39500) := '65224172726F775269676874223A63617365225269676874223A733D227269676874223B627265616B3B63617365224172726F77446F776E223A6361736522446F776E223A733D22646F776E227D72657475726E206F2E6D6F766543616E766173287B73';
wwv_flow_imp.g_varchar2_table(39501) := '706565643A722C646972656374696F6E3A737D292C21307D7D29292C746869732E6D6F766543616E7661733D66756E6374696F6E2865297B76617220743D302C693D302C6F3D652E73706565642F4D6174682E6D696E284D6174682E73717274286E2E76';
wwv_flow_imp.g_varchar2_table(39502) := '696577626F7828292E7363616C65292C31293B73776974636828652E646972656374696F6E297B63617365226C656674223A743D6F3B627265616B3B63617365227570223A693D6F3B627265616B3B63617365227269676874223A743D2D6F3B62726561';
wwv_flow_imp.g_varchar2_table(39503) := '6B3B6361736522646F776E223A693D2D6F7D6E2E7363726F6C6C287B64783A742C64793A697D297D7D63612E24696E6A6563743D5B22636F6E6669672E6B6579626F6172644D6F7665222C226B6579626F617264222C2263616E766173225D3B636F6E73';
wwv_flow_imp.g_varchar2_table(39504) := '742064613D7B5F5F646570656E64735F5F3A5B61615D2C5F5F696E69745F5F3A5B226B6579626F6172644D6F7665225D2C6B6579626F6172644D6F76653A5B2274797065222C63615D7D3B7661722068613D2F5E646A732D637572736F722D2E2A242F3B';
wwv_flow_imp.g_varchar2_table(39505) := '66756E6374696F6E2075612865297B76617220743D6B7428646F63756D656E742E626F6479293B742E72656D6F76654D61746368696E67286861292C652626742E6164642822646A732D637572736F722D222B65297D66756E6374696F6E20706128297B';
wwv_flow_imp.g_varchar2_table(39506) := '7561286E756C6C297D7661722067613D3565333B66756E6374696F6E206D6128652C74297B66756E6374696F6E206E28297B72657475726E21317D72657475726E20743D747C7C22656C656D656E742E636C69636B222C652E6F6E636528742C67612C6E';
wwv_flow_imp.g_varchar2_table(39507) := '292C66756E6374696F6E28297B652E6F666628742C6E297D7D66756E6374696F6E2066612865297B72657475726E7B783A652E782B652E77696474682F322C793A652E792B652E6865696768742F327D7D66756E6374696F6E20766128652C74297B7265';
wwv_flow_imp.g_varchar2_table(39508) := '7475726E7B783A652E782D742E782C793A652E792D742E797D7D66756E6374696F6E20626128652C74297B766172206E3B66756E6374696F6E20692869297B766172206F2C733D6E2E73746172742C723D6E2E627574746F6E2C613D54722869292C6C3D';
wwv_flow_imp.g_varchar2_table(39509) := '766128612C73293B216E2E6472616767696E672626286F3D6C2C4D6174682E73717274284D6174682E706F77286F2E782C32292B4D6174682E706F77286F2E792C3229293E3135292626286E2E6472616767696E673D21302C303D3D3D7226266D612865';
wwv_flow_imp.g_varchar2_table(39510) := '292C75612822677261622229292C6E2E6472616767696E672626286C3D766128612C6E2E6C6173747C7C6E2E7374617274292C742E7363726F6C6C287B64783A6C2E782C64793A6C2E797D292C6E2E6C6173743D61292C692E70726576656E7444656661';
wwv_flow_imp.g_varchar2_table(39511) := '756C7428297D66756E6374696F6E206F2865297B4F742E756E62696E6428646F63756D656E742C226D6F7573656D6F7665222C69292C4F742E756E62696E6428646F63756D656E742C226D6F7573657570222C6F292C6E3D6E756C6C2C706128297D652E';
wwv_flow_imp.g_varchar2_table(39512) := '6F6E2822656C656D656E742E6D6F757365646F776E222C3530302C2866756E6374696F6E2865297B72657475726E2066756E6374696F6E2865297B69662821447428652E7461726765742C222E646A732D647261676761626C652229297B76617220743D';
wwv_flow_imp.g_varchar2_table(39513) := '652E627574746F6E3B6966282128743E3D327C7C652E6374726C4B65797C7C652E73686966744B65797C7C652E616C744B6579292972657475726E206E3D7B627574746F6E3A742C73746172743A54722865297D2C4F742E62696E6428646F63756D656E';
wwv_flow_imp.g_varchar2_table(39514) := '742C226D6F7573656D6F7665222C69292C4F742E62696E6428646F63756D656E742C226D6F7573657570222C6F292C21307D7D28652E6F726967696E616C4576656E74297D29292C746869732E69734163746976653D66756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(39515) := '75726E21216E7D7D62612E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E7374205F613D7B5F5F696E69745F5F3A5B226D6F766543616E766173225D2C6D6F766543616E7661733A5B2274797065222C62615D7D3B66';
wwv_flow_imp.g_varchar2_table(39516) := '756E6374696F6E2079612865297B72657475726E204D6174682E6C6F672865292F4D6174682E6C6F67283130297D66756E6374696F6E20776128652C74297B766172206E3D796128652E6D696E292C693D796128652E6D6178293B72657475726E284D61';
wwv_flow_imp.g_varchar2_table(39517) := '74682E616273286E292B4D6174682E616273286929292F747D7661722043613D4D6174682E7369676E7C7C66756E6374696F6E2865297B72657475726E20653E3D303F313A2D317D2C53613D7B6D696E3A2E322C6D61783A347D3B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(39518) := '786128652C742C6E297B653D657C7C7B7D2C746869732E5F656E61626C65643D21312C746869732E5F63616E7661733D6E2C746869732E5F636F6E7461696E65723D6E2E5F636F6E7461696E65722C746869732E5F68616E646C65576865656C3D28302C';
wwv_flow_imp.g_varchar2_table(39519) := '692E6F492928746869732E5F68616E646C65576865656C2C74686973292C746869732E5F746F74616C44656C74613D302C746869732E5F7363616C653D652E7363616C657C7C2E37353B766172206F3D746869733B742E6F6E282263616E7661732E696E';
wwv_flow_imp.g_varchar2_table(39520) := '6974222C2866756E6374696F6E2874297B6F2E5F696E6974282131213D3D652E656E61626C6564297D29297D78612E24696E6A6563743D5B22636F6E6669672E7A6F6F6D5363726F6C6C222C226576656E74427573222C2263616E766173225D2C78612E';
wwv_flow_imp.g_varchar2_table(39521) := '70726F746F747970652E7363726F6C6C3D66756E6374696F6E2865297B746869732E5F63616E7661732E7363726F6C6C2865297D2C78612E70726F746F747970652E72657365743D66756E6374696F6E28297B746869732E5F63616E7661732E7A6F6F6D';
wwv_flow_imp.g_varchar2_table(39522) := '28226669742D76696577706F727422297D2C78612E70726F746F747970652E7A6F6F6D3D66756E6374696F6E28652C74297B766172206E3D77612853612C3230293B746869732E5F746F74616C44656C74612B3D652C4D6174682E61627328746869732E';
wwv_flow_imp.g_varchar2_table(39523) := '5F746F74616C44656C7461293E2E31262628746869732E5F7A6F6F6D28652C742C6E292C746869732E5F746F74616C44656C74613D30297D2C78612E70726F746F747970652E5F68616E646C65576865656C3D66756E6374696F6E2865297B6966282144';
wwv_flow_imp.g_varchar2_table(39524) := '7428652E7461726765742C222E646A732D7363726F6C6C61626C65222C213029297B76617220743D746869732E5F636F6E7461696E65723B652E70726576656E7444656661756C7428293B766172206E2C693D652E6374726C4B65797C7C497228292626';
wwv_flow_imp.g_varchar2_table(39525) := '652E6D6574614B65792C6F3D652E73686966744B65792C733D2D312A746869732E5F7363616C653B696628732A3D693F303D3D3D652E64656C74614D6F64653F2E30323A2E33323A303D3D3D652E64656C74614D6F64653F313A31362C69297B76617220';
wwv_flow_imp.g_varchar2_table(39526) := '723D742E676574426F756E64696E67436C69656E745265637428292C613D7B783A652E636C69656E74582D722E6C6566742C793A652E636C69656E74592D722E746F707D3B6E3D4D6174682E73717274284D6174682E706F7728652E64656C7461592C32';
wwv_flow_imp.g_varchar2_table(39527) := '292B4D6174682E706F7728652E64656C7461582C3229292A436128652E64656C746159292A732C746869732E7A6F6F6D286E2C61297D656C7365206E3D6F3F7B64783A732A652E64656C7461592C64793A307D3A7B64783A732A652E64656C7461582C64';
wwv_flow_imp.g_varchar2_table(39528) := '793A732A652E64656C7461597D2C746869732E7363726F6C6C286E297D7D2C78612E70726F746F747970652E737465705A6F6F6D3D66756E6374696F6E28652C74297B766172206E3D77612853612C3130293B746869732E5F7A6F6F6D28652C742C6E29';
wwv_flow_imp.g_varchar2_table(39529) := '7D2C78612E70726F746F747970652E5F7A6F6F6D3D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F63616E7661732C6F3D653E303F313A2D312C733D796128692E7A6F6F6D2829292C723D4D6174682E726F756E6428732F6E292A';
wwv_flow_imp.g_varchar2_table(39530) := '6E3B722B3D6E2A6F3B76617220612C6C2C633D4D6174682E706F772831302C72293B692E7A6F6F6D2828613D53612C6C3D632C4D6174682E6D617828612E6D696E2C4D6174682E6D696E28612E6D61782C6C2929292C74297D2C78612E70726F746F7479';
wwv_flow_imp.g_varchar2_table(39531) := '70652E746F67676C653D66756E6374696F6E2865297B76617220743D746869732E5F636F6E7461696E65722C6E3D746869732E5F68616E646C65576865656C2C693D746869732E5F656E61626C65643B72657475726E20766F696420303D3D3D65262628';
wwv_flow_imp.g_varchar2_table(39532) := '653D2169292C69213D3D6526264F745B653F2262696E64223A22756E62696E64225D28742C22776865656C222C6E2C2131292C746869732E5F656E61626C65643D652C657D2C78612E70726F746F747970652E5F696E69743D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(39533) := '7B746869732E746F67676C652865297D3B636F6E7374206B613D7B5F5F696E69745F5F3A5B227A6F6F6D5363726F6C6C225D2C7A6F6F6D5363726F6C6C3A5B2274797065222C78615D7D3B66756E6374696F6E2045612865297B55722E63616C6C287468';
wwv_flow_imp.g_varchar2_table(39534) := '69732C65297D66756E6374696F6E204C612865297B72657475726E20652626655B652E6C656E6774682D315D7D66756E6374696F6E2044612865297B72657475726E20652E797D66756E6374696F6E2054612865297B72657475726E20652E787D522845';
wwv_flow_imp.g_varchar2_table(39535) := '612C5572292C45612E70726F746F747970652E5F6E617669676174696F6E4D6F64756C65733D5B64612C5F612C6B615D2C45612E70726F746F747970652E5F6D6F64756C65733D5B5D2E636F6E6361742855722E70726F746F747970652E5F6D6F64756C';
wwv_flow_imp.g_varchar2_table(39536) := '65732C45612E70726F746F747970652E5F6E617669676174696F6E4D6F64756C6573293B7661722049613D7B6C6566743A54612C63656E7465723A54612C72696768743A66756E6374696F6E2865297B72657475726E20652E782B652E77696474687D2C';
wwv_flow_imp.g_varchar2_table(39537) := '746F703A44612C6D6964646C653A44612C626F74746F6D3A66756E6374696F6E2865297B72657475726E20652E792B652E6865696768747D7D3B66756E6374696F6E204D6128652C74297B746869732E5F6D6F64656C696E673D652C746869732E5F7275';
wwv_flow_imp.g_varchar2_table(39538) := '6C65733D747D4D612E24696E6A6563743D5B226D6F64656C696E67222C2272756C6573225D2C4D612E70726F746F747970652E5F6765744F7269656E746174696F6E44657461696C733D66756E6374696F6E2865297B76617220743D2278222C6E3D2277';
wwv_flow_imp.g_varchar2_table(39539) := '69647468223B72657475726E2D31213D3D5B22746F70222C22626F74746F6D222C226D6964646C65225D2E696E6465784F66286529262628743D2279222C6E3D2268656967687422292C7B617869733A742C64696D656E73696F6E3A6E7D7D2C4D612E70';
wwv_flow_imp.g_varchar2_table(39540) := '726F746F747970652E5F6973547970653D66756E6374696F6E28652C74297B72657475726E2D31213D3D742E696E6465784F662865297D2C4D612E70726F746F747970652E5F616C69676E6D656E74506F736974696F6E3D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(39541) := '297B766172206E2C6F2C732C723D746869732E5F6765744F7269656E746174696F6E44657461696C732865292C613D722E617869732C6C3D722E64696D656E73696F6E2C633D7B7D2C643D7B7D2C683D21313B696628746869732E5F6973547970652865';
wwv_flow_imp.g_varchar2_table(39542) := '2C5B226C656674222C22746F70225D2929635B655D3D745B305D5B615D3B656C736520696628746869732E5F69735479706528652C5B227269676874222C22626F74746F6D225D2929733D4C612874292C635B655D3D735B615D2B735B6C5D3B656C7365';
wwv_flow_imp.g_varchar2_table(39543) := '20696628746869732E5F69735479706528652C5B2263656E746572222C226D6964646C65225D29297B69662828302C692E6A4A2928742C2866756E6374696F6E2865297B76617220743D655B615D2B4D6174682E726F756E6428655B6C5D2F32293B645B';
wwv_flow_imp.g_varchar2_table(39544) := '745D3F645B745D2E656C656D656E74732E707573682865293A645B745D3D7B656C656D656E74733A5B655D2C63656E7465723A747D7D29292C6E3D28302C692E556C2928642C2866756E6374696F6E2865297B72657475726E20652E656C656D656E7473';
wwv_flow_imp.g_varchar2_table(39545) := '2E6C656E6774683E31262628683D2130292C652E656C656D656E74732E6C656E6774687D29292C682972657475726E20635B655D3D4C61286E292E63656E7465722C633B6F3D745B305D2C733D4C6128743D28302C692E556C2928742C2866756E637469';
wwv_flow_imp.g_varchar2_table(39546) := '6F6E2865297B72657475726E20655B615D2B655B6C5D7D2929292C635B655D3D66756E6374696F6E28652C74297B72657475726E204D6174682E726F756E642828655B615D2B745B615D2B745B6C5D292F32297D286F2C73297D72657475726E20637D2C';
wwv_flow_imp.g_varchar2_table(39547) := '4D612E70726F746F747970652E747269676765723D66756E6374696F6E28652C74297B766172206E2C6F3D746869732E5F6D6F64656C696E672C733D28302C692E70622928652C2866756E6374696F6E2865297B72657475726E2128652E776179706F69';
wwv_flow_imp.g_varchar2_table(39548) := '6E74737C7C652E686F73747C7C652E6C6162656C546172676574297D29293B6966286E3D746869732E5F72756C65732E616C6C6F7765642822656C656D656E74732E616C69676E222C7B656C656D656E74733A737D292C28302C692E637929286E292626';
wwv_flow_imp.g_varchar2_table(39549) := '28733D6E292C2128732E6C656E6774683C322926266E297B76617220723D49615B745D2C613D28302C692E556C2928732C72292C6C3D746869732E5F616C69676E6D656E74506F736974696F6E28742C61293B6F2E616C69676E456C656D656E74732861';
wwv_flow_imp.g_varchar2_table(39550) := '2C6C297D7D3B636F6E73742041613D7B5F5F696E69745F5F3A5B22616C69676E456C656D656E7473225D2C616C69676E456C656D656E74733A5B2274797065222C4D615D7D2C4E613D6E65772024733B66756E6374696F6E2050612865297B746869732E';
wwv_flow_imp.g_varchar2_table(39551) := '5F7363686564756C65643D7B7D2C652E6F6E28226469616772616D2E64657374726F79222C2828293D3E7B4F626A6563742E6B65797328746869732E5F7363686564756C6564292E666F72456163682828653D3E7B746869732E63616E63656C2865297D';
wwv_flow_imp.g_varchar2_table(39552) := '29297D29297D50612E24696E6A6563743D5B226576656E74427573225D2C50612E70726F746F747970652E7363686564756C653D66756E6374696F6E28652C743D4E612E6E6578742829297B746869732E63616E63656C2874293B636F6E7374206E3D74';
wwv_flow_imp.g_varchar2_table(39553) := '6869732E5F7363686564756C6528652C74293B72657475726E20746869732E5F7363686564756C65645B745D3D6E2C6E2E70726F6D6973657D2C50612E70726F746F747970652E5F7363686564756C653D66756E6374696F6E28652C74297B636F6E7374';
wwv_flow_imp.g_varchar2_table(39554) := '7B70726F6D6973653A6E2C7265736F6C76653A692C72656A6563743A6F7D3D66756E6374696F6E28297B6C657420652C743B72657475726E7B70726F6D6973653A6E65772050726F6D6973652828286E2C69293D3E7B653D6E2C743D697D29292C726573';
wwv_flow_imp.g_varchar2_table(39555) := '6F6C76653A652C72656A6563743A747D7D28292C733D72657175657374416E696D6174696F6E4672616D65282828293D3E7B7472797B6928652829297D63617463682865297B6F2865297D7D29293B72657475726E7B657865637574696F6E49643A732C';
wwv_flow_imp.g_varchar2_table(39556) := '70726F6D6973653A6E7D7D2C50612E70726F746F747970652E63616E63656C3D66756E6374696F6E2865297B636F6E737420743D746869732E5F7363686564756C65645B655D3B74262628746869732E5F63616E63656C2874292C746869732E5F736368';
wwv_flow_imp.g_varchar2_table(39557) := '6564756C65645B655D3D6E756C6C297D2C50612E70726F746F747970652E5F63616E63656C3D66756E6374696F6E2865297B63616E63656C416E696D6174696F6E4672616D6528652E657865637574696F6E4964297D3B636F6E7374204F613D7B736368';
wwv_flow_imp.g_varchar2_table(39558) := '6564756C65723A5B2274797065222C50615D7D3B7661722052613D222E656E747279223B66756E6374696F6E20466128652C742C6E2C69297B746869732E5F63616E7661733D652C746869732E5F656C656D656E7452656769737472793D742C74686973';
wwv_flow_imp.g_varchar2_table(39559) := '2E5F6576656E744275733D6E2C746869732E5F7363686564756C65723D692C746869732E5F63757272656E743D6E756C6C2C746869732E5F696E697428297D46612E24696E6A6563743D5B2263616E766173222C22656C656D656E745265676973747279';
wwv_flow_imp.g_varchar2_table(39560) := '222C226576656E74427573222C227363686564756C6572225D2C46612E70726F746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D746869733B746869732E5F6576656E744275732E6F6E282273656C656374696F6E2E6368616E';
wwv_flow_imp.g_varchar2_table(39561) := '676564222C2866756E6374696F6E2874297B766172206E3D742E6E657753656C656374696F6E2C693D6E2E6C656E6774683F313D3D3D6E2E6C656E6774683F6E5B305D3A6E3A6E756C6C3B693F652E6F70656E28692C2130293A652E636C6F736528297D';
wwv_flow_imp.g_varchar2_table(39562) := '29292C746869732E5F6576656E744275732E6F6E2822656C656D656E74732E6368616E676564222C2866756E6374696F6E2874297B766172206E3D742E656C656D656E74732C6F3D652E5F63757272656E743B6966286F297B76617220733D6F2E746172';
wwv_flow_imp.g_varchar2_table(39563) := '6765742C723D28302C692E6379292873293F733A5B735D3B696628722E66696C746572282866756E6374696F6E2865297B72657475726E206E2E696E636C756465732865297D29292E6C656E677468297B652E636C6F736528293B76617220613D722E66';
wwv_flow_imp.g_varchar2_table(39564) := '696C746572282866756E6374696F6E2874297B72657475726E20652E5F656C656D656E7452656769737472792E67657428742E6964297D29293B612E6C656E6774682626652E5F757064617465416E644F70656E28612E6C656E6774683E313F613A615B';
wwv_flow_imp.g_varchar2_table(39565) := '305D297D7D7D29292C746869732E5F6576656E744275732E6F6E282263616E7661732E76696577626F782E6368616E676564222C2866756E6374696F6E28297B652E5F757064617465506F736974696F6E28297D29292C746869732E5F6576656E744275';
wwv_flow_imp.g_varchar2_table(39566) := '732E6F6E2822656C656D656E742E6D61726B65722E757064617465222C2866756E6374696F6E2874297B696628652E69734F70656E2829297B766172206E3D742E656C656D656E742C6F3D652E5F63757272656E743B2828302C692E637929286F2E7461';
wwv_flow_imp.g_varchar2_table(39567) := '72676574293F6F2E7461726765743A5B6F2E7461726765745D292E696E636C75646573286E292626652E5F7570646174655669736962696C69747928297D7D29292C746869732E5F636F6E7461696E65723D746869732E5F637265617465436F6E746169';
wwv_flow_imp.g_varchar2_table(39568) := '6E657228297D2C46612E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E6374696F6E28297B76617220653D487428273C64697620636C6173733D22646A732D636F6E746578742D7061642D706172656E74223E3C2F6469763E';
wwv_flow_imp.g_varchar2_table(39569) := '27293B72657475726E20746869732E5F63616E7661732E676574436F6E7461696E657228292E617070656E644368696C642865292C657D2C46612E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(39570) := '747C7C28743D652C653D316533292C746869732E5F6576656E744275732E6F6E2822636F6E746578745061642E67657450726F766964657273222C652C2866756E6374696F6E2865297B652E70726F7669646572732E707573682874297D29297D2C4661';
wwv_flow_imp.g_varchar2_table(39571) := '2E70726F746F747970652E676574456E74726965733D66756E6374696F6E2865297B76617220743D746869732E5F67657450726F76696465727328292C6E3D28302C692E6379292865293F226765744D756C7469456C656D656E74436F6E746578745061';
wwv_flow_imp.g_varchar2_table(39572) := '64456E7472696573223A22676574436F6E74657874506164456E7472696573222C6F3D7B7D3B72657475726E28302C692E6A4A2928742C2866756E6374696F6E2874297B69662828302C692E546E2928745B6E5D29297B76617220733D745B6E5D286529';
wwv_flow_imp.g_varchar2_table(39573) := '3B28302C692E546E292873293F6F3D73286F293A28302C692E6A4A2928732C2866756E6374696F6E28652C74297B6F5B745D3D657D29297D7D29292C6F7D2C46612E70726F746F747970652E747269676765723D66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(39574) := '76617220692C6F2C733D746869732C723D742E64656C65676174655461726765747C7C742E7461726765743B72657475726E20723F28693D537428722C22646174612D616374696F6E22292C6F3D742E6F726967696E616C4576656E747C7C742C226D6F';
wwv_flow_imp.g_varchar2_table(39575) := '7573656F76657222213D3D653F226D6F7573656F7574223D3D3D653F28636C65617254696D656F757428746869732E5F74696D656F7574292C766F696428746869732E5F6D6F7573656F7574262628746869732E5F6D6F7573656F757428292C74686973';
wwv_flow_imp.g_varchar2_table(39576) := '2E5F6D6F7573656F75743D6E756C6C2929293A746869732E74726967676572456E74727928692C652C6F2C6E293A766F696428746869732E5F74696D656F75743D73657454696D656F7574282866756E6374696F6E28297B732E5F6D6F7573656F75743D';
wwv_flow_imp.g_varchar2_table(39577) := '732E74726967676572456E74727928692C22686F766572222C6F2C6E297D292C3330302929293A742E70726576656E7444656661756C7428297D2C46612E70726F746F747970652E74726967676572456E7472793D66756E6374696F6E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(39578) := '6F297B696628746869732E697353686F776E2829297B76617220733D746869732E5F63757272656E742E7461726765742C723D746869732E5F63757272656E742E656E74726965735B655D3B69662872297B76617220613D722E616374696F6E3B696628';
wwv_flow_imp.g_varchar2_table(39579) := '2131213D3D746869732E5F6576656E744275732E666972652822636F6E746578745061642E74726967676572222C7B656E7472793A722C6576656E743A6E7D29297B69662828302C692E546E29286129297B69662822636C69636B223D3D3D7429726574';
wwv_flow_imp.g_varchar2_table(39580) := '75726E2061286E2C732C6F297D656C736520696628615B745D2972657475726E20615B745D286E2C732C6F293B6E2E70726576656E7444656661756C7428297D7D7D7D2C46612E70726F746F747970652E6F70656E3D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(39581) := '21742626746869732E69734F70656E2865297C7C28746869732E636C6F736528292C746869732E5F757064617465416E644F70656E286529297D2C46612E70726F746F747970652E5F67657450726F7669646572733D66756E6374696F6E28297B766172';
wwv_flow_imp.g_varchar2_table(39582) := '20653D746869732E5F6576656E744275732E6372656174654576656E74287B747970653A22636F6E746578745061642E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E66';
wwv_flow_imp.g_varchar2_table(39583) := '6972652865292C652E70726F7669646572737D2C46612E70726F746F747970652E5F757064617465416E644F70656E3D66756E6374696F6E2865297B76617220742C6E3D746869732E676574456E74726965732865292C6F3D746869732E5F6372656174';
wwv_flow_imp.g_varchar2_table(39584) := '6548746D6C2865293B28302C692E6A4A29286E2C2866756E6374696F6E28652C6E297B76617220732C722C612C6C2C633D652E67726F75707C7C2264656661756C74222C643D487428652E68746D6C7C7C273C64697620636C6173733D22656E74727922';
wwv_flow_imp.g_varchar2_table(39585) := '20647261676761626C653D2274727565223E3C2F6469763E27293B537428642C22646174612D616374696F6E222C6E292C28733D6A7428225B646174612D67726F75703D222B762863292B225D222C6F29297C7C28537428733D487428273C6469762063';
wwv_flow_imp.g_varchar2_table(39586) := '6C6173733D2267726F7570223E3C2F6469763E27292C22646174612D67726F7570222C63292C6F2E617070656E644368696C64287329292C732E617070656E644368696C642864292C652E636C6173734E616D65262628723D642C613D652E636C617373';
wwv_flow_imp.g_varchar2_table(39587) := '4E616D652C6C3D6B742872292C28613D28302C692E6379292861293F613A612E73706C6974282F5C732B2F6729292E666F7245616368282866756E6374696F6E2865297B6C2E6164642865297D2929292C652E7469746C652626537428642C227469746C';
wwv_flow_imp.g_varchar2_table(39588) := '65222C652E7469746C65292C652E696D61676555726C262628537428743D487428223C696D673E22292C22737263222C652E696D61676555726C292C742E7374796C652E77696474683D2231303025222C742E7374796C652E6865696768743D22313030';
wwv_flow_imp.g_varchar2_table(39589) := '25222C642E617070656E644368696C64287429297D29292C6B74286F292E61646428226F70656E22292C746869732E5F63757272656E743D7B656E74726965733A6E2C68746D6C3A6F2C7461726765743A657D2C746869732E5F757064617465506F7369';
wwv_flow_imp.g_varchar2_table(39590) := '74696F6E28292C746869732E5F7570646174655669736962696C69747928292C746869732E5F6576656E744275732E666972652822636F6E746578745061642E6F70656E222C7B63757272656E743A746869732E5F63757272656E747D297D2C46612E70';
wwv_flow_imp.g_varchar2_table(39591) := '726F746F747970652E5F63726561746548746D6C3D66756E6374696F6E2865297B76617220743D746869732C6E3D487428273C64697620636C6173733D22646A732D636F6E746578742D706164223E3C2F6469763E27293B72657475726E204674286E2C';
wwv_flow_imp.g_varchar2_table(39592) := '52612C22636C69636B222C2866756E6374696F6E2865297B742E747269676765722822636C69636B222C65297D29292C4674286E2C52612C22647261677374617274222C2866756E6374696F6E2865297B742E7472696767657228226472616773746172';
wwv_flow_imp.g_varchar2_table(39593) := '74222C65297D29292C4674286E2C52612C226D6F7573656F766572222C2866756E6374696F6E2865297B742E7472696767657228226D6F7573656F766572222C65297D29292C4674286E2C52612C226D6F7573656F7574222C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(39594) := '297B742E7472696767657228226D6F7573656F7574222C65297D29292C4F742E62696E64286E2C226D6F757365646F776E222C2866756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28297D29292C746869732E5F636F6E7461696E';
wwv_flow_imp.g_varchar2_table(39595) := '65722E617070656E644368696C64286E292C746869732E5F6576656E744275732E666972652822636F6E746578745061642E637265617465222C7B7461726765743A652C7061643A6E7D292C6E7D2C46612E70726F746F747970652E6765745061643D66';
wwv_flow_imp.g_varchar2_table(39596) := '756E6374696F6E2865297B6C657420743B72657475726E20636F6E736F6C652E7761726E286E6577204572726F722822436F6E7465787450616423676574506164206973206465707265636174656420616E642077696C6C2062652072656D6F76656420';
wwv_flow_imp.g_varchar2_table(39597) := '696E20667574757265206C6962726172792076657273696F6E732C2063662E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F6469616772616D2D6A732F70756C6C2F3838382229292C743D746869732E69734F70656E2829262666';
wwv_flow_imp.g_varchar2_table(39598) := '756E6374696F6E28652C74297B72657475726E20653D28302C692E6379292865293F653A5B655D2C743D28302C692E6379292874293F743A5B745D2C652E6C656E6774683D3D3D742E6C656E677468262628302C692E53692928652C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(39599) := '6E2865297B72657475726E20742E696E636C756465732865297D29297D28746869732E5F63757272656E742E7461726765742C65293F746869732E5F63757272656E742E68746D6C3A746869732E5F63726561746548746D6C2865292C7B68746D6C3A74';
wwv_flow_imp.g_varchar2_table(39600) := '7D7D2C46612E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E69734F70656E2829262628636C65617254696D656F757428746869732E5F74696D656F7574292C746869732E5F636F6E7461696E65722E696E6E65724854';
wwv_flow_imp.g_varchar2_table(39601) := '4D4C3D22222C746869732E5F6576656E744275732E666972652822636F6E746578745061642E636C6F7365222C7B63757272656E743A746869732E5F63757272656E747D292C746869732E5F63757272656E743D6E756C6C297D2C46612E70726F746F74';
wwv_flow_imp.g_varchar2_table(39602) := '7970652E69734F70656E3D66756E6374696F6E2865297B76617220743D746869732E5F63757272656E743B69662821742972657475726E21313B69662821652972657475726E21303B766172206E3D742E7461726765743B72657475726E28302C692E63';
wwv_flow_imp.g_varchar2_table(39603) := '79292865293D3D3D28302C692E637929286E2926262828302C692E6379292865293F652E6C656E6774683D3D3D6E2E6C656E677468262628302C692E53692928652C2866756E6374696F6E2865297B72657475726E206E2E696E636C756465732865297D';
wwv_flow_imp.g_varchar2_table(39604) := '29293A6E3D3D3D65297D2C46612E70726F746F747970652E697353686F776E3D66756E6374696F6E28297B72657475726E20746869732E69734F70656E282926266B7428746869732E5F63757272656E742E68746D6C292E68617328226F70656E22297D';
wwv_flow_imp.g_varchar2_table(39605) := '2C46612E70726F746F747970652E73686F773D66756E6374696F6E28297B746869732E69734F70656E28292626286B7428746869732E5F63757272656E742E68746D6C292E61646428226F70656E22292C746869732E5F757064617465506F736974696F';
wwv_flow_imp.g_varchar2_table(39606) := '6E28292C746869732E5F6576656E744275732E666972652822636F6E746578745061642E73686F77222C7B63757272656E743A746869732E5F63757272656E747D29297D2C46612E70726F746F747970652E686964653D66756E6374696F6E28297B7468';
wwv_flow_imp.g_varchar2_table(39607) := '69732E69734F70656E28292626286B7428746869732E5F63757272656E742E68746D6C292E72656D6F766528226F70656E22292C746869732E5F6576656E744275732E666972652822636F6E746578745061642E68696465222C7B63757272656E743A74';
wwv_flow_imp.g_varchar2_table(39608) := '6869732E5F63757272656E747D29297D2C46612E70726F746F747970652E5F676574506F736974696F6E3D66756E6374696F6E2865297B6966282128302C692E63792928652926264F6E286529297B76617220743D746869732E5F63616E7661732E7669';
wwv_flow_imp.g_varchar2_table(39609) := '6577626F7828292C6E3D28723D65292E776179706F696E74735B722E776179706F696E74732E6C656E6774682D315D2C6F3D6E2E782A742E7363616C652D742E782A742E7363616C652C733D6E2E792A742E7363616C652D742E792A742E7363616C653B';
wwv_flow_imp.g_varchar2_table(39610) := '72657475726E7B6C6566743A6F2B382A746869732E5F63616E7661732E7A6F6F6D28292C746F703A737D7D76617220722C613D746869732E5F63616E7661732E676574436F6E7461696E657228292E676574426F756E64696E67436C69656E7452656374';
wwv_flow_imp.g_varchar2_table(39611) := '28292C6C3D746869732E5F676574546172676574426F756E64732865293B72657475726E7B6C6566743A6C2E72696768742D612E6C6566742B382A746869732E5F63616E7661732E7A6F6F6D28292C746F703A6C2E746F702D612E746F707D7D2C46612E';
wwv_flow_imp.g_varchar2_table(39612) := '70726F746F747970652E5F757064617465506F736974696F6E3D66756E6374696F6E28297B746869732E5F7363686564756C65722E7363686564756C65282828293D3E7B696628746869732E69734F70656E2829297B76617220653D746869732E5F6375';
wwv_flow_imp.g_varchar2_table(39613) := '7272656E742E68746D6C2C743D746869732E5F676574506F736974696F6E28746869732E5F63757272656E742E746172676574293B227822696E20742626227922696E20743F28652E7374796C652E6C6566743D742E782B227078222C652E7374796C65';
wwv_flow_imp.g_varchar2_table(39614) := '2E746F703D742E792B22707822293A5B22746F70222C227269676874222C22626F74746F6D222C226C656674225D2E666F7245616368282866756E6374696F6E286E297B6E20696E2074262628652E7374796C655B6E5D3D745B6E5D2B22707822297D29';
wwv_flow_imp.g_varchar2_table(39615) := '297D7D292C22436F6E74657874506164235F757064617465506F736974696F6E22297D2C46612E70726F746F747970652E5F7570646174655669736962696C6974793D66756E6374696F6E28297B746869732E5F7363686564756C65722E736368656475';
wwv_flow_imp.g_varchar2_table(39616) := '6C65282828293D3E7B696628746869732E69734F70656E2829297B76617220653D746869732C743D746869732E5F63757272656E742E7461726765743B2828302C692E6379292874293F743A5B745D292E736F6D65282866756E6374696F6E2874297B72';
wwv_flow_imp.g_varchar2_table(39617) := '657475726E20652E5F63616E7661732E6861734D61726B657228742C22646A732D656C656D656E742D68696464656E22297D29293F652E6869646528293A652E73686F7728297D7D292C22436F6E74657874506164235F7570646174655669736962696C';
wwv_flow_imp.g_varchar2_table(39618) := '69747922297D2C46612E70726F746F747970652E5F676574546172676574426F756E64733D66756E6374696F6E2865297B76617220743D746869733B72657475726E2828302C692E6379292865293F653A5B655D292E6D6170282866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(39619) := '65297B72657475726E20742E5F63616E7661732E67657447726170686963732865297D29292E726564756365282866756E6374696F6E28652C74297B636F6E7374206E3D742E676574426F756E64696E67436C69656E745265637428293B72657475726E';
wwv_flow_imp.g_varchar2_table(39620) := '20652E746F703D4D6174682E6D696E28652E746F702C6E2E746F70292C652E72696768743D4D6174682E6D617828652E72696768742C6E2E7269676874292C652E626F74746F6D3D4D6174682E6D617828652E626F74746F6D2C6E2E626F74746F6D292C';
wwv_flow_imp.g_varchar2_table(39621) := '652E6C6566743D4D6174682E6D696E28652E6C6566742C6E2E6C656674292C652E783D652E6C6566742C652E793D652E746F702C652E77696474683D652E72696768742D652E6C6566742C652E6865696768743D652E626F74746F6D2D652E746F702C65';
wwv_flow_imp.g_varchar2_table(39622) := '7D292C7B746F703A312F302C72696768743A2D312F302C626F74746F6D3A2D312F302C6C6566743A312F307D297D3B636F6E73742042613D7B5F5F646570656E64735F5F3A5B42722C4F612C5A735D2C636F6E746578745061643A5B2274797065222C46';
wwv_flow_imp.g_varchar2_table(39623) := '615D7D3B7661722056612C7A612C48612C57612C6A612C71612C24612C55612C4B612C47612C51613D7B7D2C59613D5B5D2C5A613D2F616369747C6578283F3A737C677C6E7C707C24297C7270687C677269647C6F77737C6D6E637C6E74777C696E655B';
wwv_flow_imp.g_varchar2_table(39624) := '63685D7C7A6F6F7C5E6F72647C69746572612F692C58613D41727261792E697341727261793B66756E6374696F6E204A6128652C74297B666F7228766172206E20696E207429655B6E5D3D745B6E5D3B72657475726E20657D66756E6374696F6E20656C';
wwv_flow_imp.g_varchar2_table(39625) := '2865297B76617220743D652E706172656E744E6F64653B742626742E72656D6F76654368696C642865297D66756E6374696F6E20746C28652C742C6E297B76617220692C6F2C732C723D7B7D3B666F72287320696E207429226B6579223D3D733F693D74';
wwv_flow_imp.g_varchar2_table(39626) := '5B735D3A22726566223D3D733F6F3D745B735D3A725B735D3D745B735D3B696628617267756D656E74732E6C656E6774683E32262628722E6368696C6472656E3D617267756D656E74732E6C656E6774683E333F56612E63616C6C28617267756D656E74';
wwv_flow_imp.g_varchar2_table(39627) := '732C32293A6E292C2266756E6374696F6E223D3D747970656F66206526266E756C6C213D652E64656661756C7450726F707329666F72287320696E20652E64656661756C7450726F707329766F696420303D3D3D725B735D262628725B735D3D652E6465';
wwv_flow_imp.g_varchar2_table(39628) := '6661756C7450726F70735B735D293B72657475726E206E6C28652C722C692C6F2C6E756C6C297D66756E6374696F6E206E6C28652C742C6E2C692C6F297B76617220733D7B747970653A652C70726F70733A742C6B65793A6E2C7265663A692C5F5F6B3A';
wwv_flow_imp.g_varchar2_table(39629) := '6E756C6C2C5F5F3A6E756C6C2C5F5F623A302C5F5F653A6E756C6C2C5F5F643A766F696420302C5F5F633A6E756C6C2C636F6E7374727563746F723A766F696420302C5F5F763A6E756C6C3D3D6F3F2B2B48613A6F2C5F5F693A2D312C5F5F753A307D3B';
wwv_flow_imp.g_varchar2_table(39630) := '72657475726E206E756C6C3D3D6F26266E756C6C213D7A612E766E6F646526267A612E766E6F64652873292C737D66756E6374696F6E20696C2865297B72657475726E20652E6368696C6472656E7D66756E6374696F6E206F6C28652C74297B74686973';
wwv_flow_imp.g_varchar2_table(39631) := '2E70726F70733D652C746869732E636F6E746578743D747D66756E6374696F6E20736C28652C74297B6966286E756C6C3D3D742972657475726E20652E5F5F3F736C28652E5F5F2C652E5F5F692B31293A6E756C6C3B666F7228766172206E3B743C652E';
wwv_flow_imp.g_varchar2_table(39632) := '5F5F6B2E6C656E6774683B742B2B296966286E756C6C213D286E3D652E5F5F6B5B745D2926266E756C6C213D6E2E5F5F652972657475726E206E2E5F5F653B72657475726E2266756E6374696F6E223D3D747970656F6620652E747970653F736C286529';
wwv_flow_imp.g_varchar2_table(39633) := '3A6E756C6C7D66756E6374696F6E20726C2865297B76617220742C6E3B6966286E756C6C213D28653D652E5F5F2926266E756C6C213D652E5F5F63297B666F7228652E5F5F653D652E5F5F632E626173653D6E756C6C2C743D303B743C652E5F5F6B2E6C';
wwv_flow_imp.g_varchar2_table(39634) := '656E6774683B742B2B296966286E756C6C213D286E3D652E5F5F6B5B745D2926266E756C6C213D6E2E5F5F65297B652E5F5F653D652E5F5F632E626173653D6E2E5F5F653B627265616B7D72657475726E20726C2865297D7D66756E6374696F6E20616C';
wwv_flow_imp.g_varchar2_table(39635) := '2865297B2821652E5F5F64262628652E5F5F643D213029262657612E707573682865292626216C6C2E5F5F722B2B7C7C6A61213D3D7A612E6465626F756E636552656E646572696E6729262628286A613D7A612E6465626F756E636552656E646572696E';
wwv_flow_imp.g_varchar2_table(39636) := '67297C7C716129286C6C297D66756E6374696F6E206C6C28297B76617220652C742C6E2C692C6F2C732C722C613B666F722857612E736F7274282461293B653D57612E736869667428293B29652E5F5F64262628743D57612E6C656E6774682C693D766F';
wwv_flow_imp.g_varchar2_table(39637) := '696420302C733D286F3D286E3D65292E5F5F76292E5F5F652C723D5B5D2C613D5B5D2C6E2E5F5F5026262828693D4A61287B7D2C6F29292E5F5F763D6F2E5F5F762B312C7A612E766E6F646526267A612E766E6F64652869292C666C286E2E5F5F502C69';
wwv_flow_imp.g_varchar2_table(39638) := '2C6F2C6E2E5F5F6E2C6E2E5F5F502E6E616D6573706163655552492C3332266F2E5F5F753F5B735D3A6E756C6C2C722C6E756C6C3D3D733F736C286F293A732C2121283332266F2E5F5F75292C61292C692E5F5F763D6F2E5F5F762C692E5F5F2E5F5F6B';
wwv_flow_imp.g_varchar2_table(39639) := '5B692E5F5F695D3D692C766C28722C692C61292C692E5F5F65213D732626726C286929292C57612E6C656E6774683E74262657612E736F727428246129293B6C6C2E5F5F723D307D66756E6374696F6E20636C28652C742C6E2C692C6F2C732C722C612C';
wwv_flow_imp.g_varchar2_table(39640) := '6C2C632C64297B76617220682C752C702C672C6D2C663D692626692E5F5F6B7C7C59612C763D742E6C656E6774683B666F72286E2E5F5F643D6C2C646C286E2C742C66292C6C3D6E2E5F5F642C683D303B683C763B682B2B296E756C6C213D28703D6E2E';
wwv_flow_imp.g_varchar2_table(39641) := '5F5F6B5B685D29262622626F6F6C65616E22213D747970656F66207026262266756E6374696F6E22213D747970656F662070262628753D2D313D3D3D702E5F5F693F51613A665B702E5F5F695D7C7C51612C702E5F5F693D682C666C28652C702C752C6F';
wwv_flow_imp.g_varchar2_table(39642) := '2C732C722C612C6C2C632C64292C673D702E5F5F652C702E7265662626752E726566213D702E726566262628752E72656626265F6C28752E7265662C6E756C6C2C70292C642E7075736828702E7265662C702E5F5F637C7C672C7029292C6E756C6C3D3D';
wwv_flow_imp.g_varchar2_table(39643) := '6D26266E756C6C213D672626286D3D67292C363535333626702E5F5F757C7C752E5F5F6B3D3D3D702E5F5F6B3F6C3D686C28702C6C2C65293A2266756E6374696F6E223D3D747970656F6620702E747970652626766F69642030213D3D702E5F5F643F6C';
wwv_flow_imp.g_varchar2_table(39644) := '3D702E5F5F643A672626286C3D672E6E6578745369626C696E67292C702E5F5F643D766F696420302C702E5F5F75263D2D313936363039293B6E2E5F5F643D6C2C6E2E5F5F653D6D7D66756E6374696F6E20646C28652C742C6E297B76617220692C6F2C';
wwv_flow_imp.g_varchar2_table(39645) := '732C722C612C6C3D742E6C656E6774682C633D6E2E6C656E6774682C643D632C683D303B666F7228652E5F5F6B3D5B5D2C693D303B693C6C3B692B2B29723D692B682C6E756C6C213D286F3D652E5F5F6B5B695D3D6E756C6C3D3D286F3D745B695D297C';
wwv_flow_imp.g_varchar2_table(39646) := '7C22626F6F6C65616E223D3D747970656F66206F7C7C2266756E6374696F6E223D3D747970656F66206F3F6E756C6C3A22737472696E67223D3D747970656F66206F7C7C226E756D626572223D3D747970656F66206F7C7C22626967696E74223D3D7479';
wwv_flow_imp.g_varchar2_table(39647) := '70656F66206F7C7C6F2E636F6E7374727563746F723D3D537472696E673F6E6C286E756C6C2C6F2C6E756C6C2C6E756C6C2C6E756C6C293A5861286F293F6E6C28696C2C7B6368696C6472656E3A6F7D2C6E756C6C2C6E756C6C2C6E756C6C293A766F69';
wwv_flow_imp.g_varchar2_table(39648) := '6420303D3D3D6F2E636F6E7374727563746F7226266F2E5F5F623E303F6E6C286F2E747970652C6F2E70726F70732C6F2E6B65792C6F2E7265663F6F2E7265663A6E756C6C2C6F2E5F5F76293A6F293F286F2E5F5F3D652C6F2E5F5F623D652E5F5F622B';
wwv_flow_imp.g_varchar2_table(39649) := '312C613D756C286F2C6E2C722C64292C6F2E5F5F693D612C733D6E756C6C2C2D31213D3D61262628642D2D2C28733D6E5B615D29262628732E5F5F757C3D31333130373229292C6E756C6C3D3D737C7C6E756C6C3D3D3D732E5F5F763F282D313D3D6126';
wwv_flow_imp.g_varchar2_table(39650) := '26682D2D2C2266756E6374696F6E22213D747970656F66206F2E747970652626286F2E5F5F757C3D363535333629293A61213D3D72262628613D3D722D313F682D2D3A613D3D722B313F682B2B3A613E723F643E6C2D723F682B3D612D723A682D2D3A61';
wwv_flow_imp.g_varchar2_table(39651) := '3C72262628613D3D722D683F682D3D612D723A682B2B292C61213D3D692B682626286F2E5F5F757C3D36353533362929293A28733D6E5B725D2926266E756C6C3D3D732E6B65792626732E5F5F652626212831333130373226732E5F5F7529262628732E';
wwv_flow_imp.g_varchar2_table(39652) := '5F5F653D3D652E5F5F64262628652E5F5F643D736C287329292C796C28732C732C2131292C6E5B725D3D6E756C6C2C642D2D293B6966286429666F7228693D303B693C633B692B2B296E756C6C213D28733D6E5B695D292626212831333130373226732E';
wwv_flow_imp.g_varchar2_table(39653) := '5F5F7529262628732E5F5F653D3D652E5F5F64262628652E5F5F643D736C287329292C796C28732C7329297D66756E6374696F6E20686C28652C742C6E297B76617220692C6F3B6966282266756E6374696F6E223D3D747970656F6620652E7479706529';
wwv_flow_imp.g_varchar2_table(39654) := '7B666F7228693D652E5F5F6B2C6F3D303B6926266F3C692E6C656E6774683B6F2B2B29695B6F5D262628695B6F5D2E5F5F3D652C743D686C28695B6F5D2C742C6E29293B72657475726E20747D652E5F5F65213D74262628742626652E74797065262621';
wwv_flow_imp.g_varchar2_table(39655) := '6E2E636F6E7461696E73287429262628743D736C286529292C6E2E696E736572744265666F726528652E5F5F652C747C7C6E756C6C292C743D652E5F5F65293B646F7B743D742626742E6E6578745369626C696E677D7768696C65286E756C6C213D7426';
wwv_flow_imp.g_varchar2_table(39656) := '26383D3D3D742E6E6F646554797065293B72657475726E20747D66756E6374696F6E20756C28652C742C6E2C69297B766172206F3D652E6B65792C733D652E747970652C723D6E2D312C613D6E2B312C6C3D745B6E5D3B6966286E756C6C3D3D3D6C7C7C';
wwv_flow_imp.g_varchar2_table(39657) := '6C26266F3D3D6C2E6B65792626733D3D3D6C2E7479706526262128313331303732266C2E5F5F75292972657475726E206E3B696628693E286E756C6C3D3D6C7C7C313331303732266C2E5F5F753F303A312929666F72283B723E3D307C7C613C742E6C65';
wwv_flow_imp.g_varchar2_table(39658) := '6E6774683B297B696628723E3D30297B696628286C3D745B725D2926262128313331303732266C2E5F5F752926266F3D3D6C2E6B65792626733D3D3D6C2E747970652972657475726E20723B722D2D7D696628613C742E6C656E677468297B696628286C';
wwv_flow_imp.g_varchar2_table(39659) := '3D745B615D2926262128313331303732266C2E5F5F752926266F3D3D6C2E6B65792626733D3D3D6C2E747970652972657475726E20613B612B2B7D7D72657475726E2D317D66756E6374696F6E20706C28652C742C6E297B222D223D3D3D745B305D3F65';
wwv_flow_imp.g_varchar2_table(39660) := '2E73657450726F706572747928742C6E756C6C3D3D6E3F22223A6E293A655B745D3D6E756C6C3D3D6E3F22223A226E756D62657222213D747970656F66206E7C7C5A612E746573742874293F6E3A6E2B227078227D66756E6374696F6E20676C28652C74';
wwv_flow_imp.g_varchar2_table(39661) := '2C6E2C692C6F297B76617220733B653A696628227374796C65223D3D3D742969662822737472696E67223D3D747970656F66206E29652E7374796C652E637373546578743D6E3B656C73657B69662822737472696E67223D3D747970656F662069262628';
wwv_flow_imp.g_varchar2_table(39662) := '652E7374796C652E637373546578743D693D2222292C6929666F72287420696E2069296E26267420696E206E7C7C706C28652E7374796C652C742C2222293B6966286E29666F72287420696E206E296926266E5B745D3D3D3D695B745D7C7C706C28652E';
wwv_flow_imp.g_varchar2_table(39663) := '7374796C652C742C6E5B745D297D656C736520696628226F223D3D3D745B305D2626226E223D3D3D745B315D29733D74213D3D28743D742E7265706C616365282F28506F696E7465724361707475726529247C43617074757265242F692C222431222929';
wwv_flow_imp.g_varchar2_table(39664) := '2C743D742E746F4C6F776572436173652829696E20657C7C226F6E466F6375734F7574223D3D3D747C7C226F6E466F637573496E223D3D3D743F742E746F4C6F7765724361736528292E736C6963652832293A742E736C6963652832292C652E6C7C7C28';
wwv_flow_imp.g_varchar2_table(39665) := '652E6C3D7B7D292C652E6C5B742B735D3D6E2C6E3F693F6E2E753D692E753A286E2E753D55612C652E6164644576656E744C697374656E657228742C733F47613A4B612C7329293A652E72656D6F76654576656E744C697374656E657228742C733F4761';
wwv_flow_imp.g_varchar2_table(39666) := '3A4B612C73293B656C73657B69662822687474703A2F2F7777772E77332E6F72672F323030302F737667223D3D6F29743D742E7265706C616365282F786C696E6B28487C3A68292F2C226822292E7265706C616365282F734E616D65242F2C227322293B';
wwv_flow_imp.g_varchar2_table(39667) := '656C73652069662822776964746822213D7426262268656967687422213D742626226872656622213D742626226C69737422213D74262622666F726D22213D74262622746162496E64657822213D74262622646F776E6C6F616422213D74262622726F77';
wwv_flow_imp.g_varchar2_table(39668) := '5370616E22213D74262622636F6C5370616E22213D74262622726F6C6522213D74262622706F706F76657222213D7426267420696E2065297472797B655B745D3D6E756C6C3D3D6E3F22223A6E3B627265616B20657D63617463682865297B7D2266756E';
wwv_flow_imp.g_varchar2_table(39669) := '6374696F6E223D3D747970656F66206E7C7C286E756C6C3D3D6E7C7C21313D3D3D6E2626222D22213D3D745B345D3F652E72656D6F76654174747269627574652874293A652E73657441747472696275746528742C22706F706F766572223D3D74262631';
wwv_flow_imp.g_varchar2_table(39670) := '3D3D6E3F22223A6E29297D7D66756E6374696F6E206D6C2865297B72657475726E2066756E6374696F6E2874297B696628746869732E6C297B766172206E3D746869732E6C5B742E747970652B655D3B6966286E756C6C3D3D742E7429742E743D55612B';
wwv_flow_imp.g_varchar2_table(39671) := '2B3B656C736520696628742E743C6E2E752972657475726E3B72657475726E206E287A612E6576656E743F7A612E6576656E742874293A74297D7D7D66756E6374696F6E20666C28652C742C6E2C692C6F2C732C722C612C6C2C63297B76617220642C68';
wwv_flow_imp.g_varchar2_table(39672) := '2C752C702C672C6D2C662C762C622C5F2C792C772C432C532C782C6B2C453D742E747970653B696628766F69642030213D3D742E636F6E7374727563746F722972657475726E206E756C6C3B313238266E2E5F5F752626286C3D2121283332266E2E5F5F';
wwv_flow_imp.g_varchar2_table(39673) := '75292C733D5B613D742E5F5F653D6E2E5F5F655D292C28643D7A612E5F5F62292626642874293B653A6966282266756E6374696F6E223D3D747970656F662045297472797B696628763D742E70726F70732C623D2270726F746F7479706522696E204526';
wwv_flow_imp.g_varchar2_table(39674) := '26452E70726F746F747970652E72656E6465722C5F3D28643D452E636F6E7465787454797065292626695B642E5F5F635D2C793D643F5F3F5F2E70726F70732E76616C75653A642E5F5F3A692C6E2E5F5F633F663D28683D742E5F5F633D6E2E5F5F6329';
wwv_flow_imp.g_varchar2_table(39675) := '2E5F5F3D682E5F5F453A28623F742E5F5F633D683D6E6577204528762C79293A28742E5F5F633D683D6E6577206F6C28762C79292C682E636F6E7374727563746F723D452C682E72656E6465723D776C292C5F26265F2E7375622868292C682E70726F70';
wwv_flow_imp.g_varchar2_table(39676) := '733D762C682E73746174657C7C28682E73746174653D7B7D292C682E636F6E746578743D792C682E5F5F6E3D692C753D682E5F5F643D21302C682E5F5F683D5B5D2C682E5F73623D5B5D292C6226266E756C6C3D3D682E5F5F73262628682E5F5F733D68';
wwv_flow_imp.g_varchar2_table(39677) := '2E7374617465292C6226266E756C6C213D452E67657444657269766564537461746546726F6D50726F7073262628682E5F5F733D3D682E7374617465262628682E5F5F733D4A61287B7D2C682E5F5F7329292C4A6128682E5F5F732C452E676574446572';
wwv_flow_imp.g_varchar2_table(39678) := '69766564537461746546726F6D50726F707328762C682E5F5F732929292C703D682E70726F70732C673D682E73746174652C682E5F5F763D742C75296226266E756C6C3D3D452E67657444657269766564537461746546726F6D50726F707326266E756C';
wwv_flow_imp.g_varchar2_table(39679) := '6C213D682E636F6D706F6E656E7457696C6C4D6F756E742626682E636F6D706F6E656E7457696C6C4D6F756E7428292C6226266E756C6C213D682E636F6D706F6E656E744469644D6F756E742626682E5F5F682E7075736828682E636F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(39680) := '4469644D6F756E74293B656C73657B6966286226266E756C6C3D3D452E67657444657269766564537461746546726F6D50726F7073262676213D3D7026266E756C6C213D682E636F6D706F6E656E7457696C6C5265636569766550726F70732626682E63';
wwv_flow_imp.g_varchar2_table(39681) := '6F6D706F6E656E7457696C6C5265636569766550726F707328762C79292C21682E5F5F652626286E756C6C213D682E73686F756C64436F6D706F6E656E74557064617465262621313D3D3D682E73686F756C64436F6D706F6E656E745570646174652876';
wwv_flow_imp.g_varchar2_table(39682) := '2C682E5F5F732C79297C7C742E5F5F763D3D3D6E2E5F5F7629297B666F7228742E5F5F76213D3D6E2E5F5F76262628682E70726F70733D762C682E73746174653D682E5F5F732C682E5F5F643D2131292C742E5F5F653D6E2E5F5F652C742E5F5F6B3D6E';
wwv_flow_imp.g_varchar2_table(39683) := '2E5F5F6B2C742E5F5F6B2E666F7245616368282866756E6374696F6E2865297B65262628652E5F5F3D74297D29292C773D303B773C682E5F73622E6C656E6774683B772B2B29682E5F5F682E7075736828682E5F73625B775D293B682E5F73623D5B5D2C';
wwv_flow_imp.g_varchar2_table(39684) := '682E5F5F682E6C656E6774682626722E707573682868293B627265616B20657D6E756C6C213D682E636F6D706F6E656E7457696C6C5570646174652626682E636F6D706F6E656E7457696C6C55706461746528762C682E5F5F732C79292C6226266E756C';
wwv_flow_imp.g_varchar2_table(39685) := '6C213D682E636F6D706F6E656E744469645570646174652626682E5F5F682E70757368282866756E6374696F6E28297B682E636F6D706F6E656E7444696455706461746528702C672C6D297D29297D696628682E636F6E746578743D792C682E70726F70';
wwv_flow_imp.g_varchar2_table(39686) := '733D762C682E5F5F503D652C682E5F5F653D21312C433D7A612E5F5F722C533D302C62297B666F7228682E73746174653D682E5F5F732C682E5F5F643D21312C432626432874292C643D682E72656E64657228682E70726F70732C682E73746174652C68';
wwv_flow_imp.g_varchar2_table(39687) := '2E636F6E74657874292C783D303B783C682E5F73622E6C656E6774683B782B2B29682E5F5F682E7075736828682E5F73625B785D293B682E5F73623D5B5D7D656C736520646F7B682E5F5F643D21312C432626432874292C643D682E72656E6465722868';
wwv_flow_imp.g_varchar2_table(39688) := '2E70726F70732C682E73746174652C682E636F6E74657874292C682E73746174653D682E5F5F737D7768696C6528682E5F5F6426262B2B533C3235293B682E73746174653D682E5F5F732C6E756C6C213D682E6765744368696C64436F6E746578742626';
wwv_flow_imp.g_varchar2_table(39689) := '28693D4A61284A61287B7D2C69292C682E6765744368696C64436F6E74657874282929292C622626217526266E756C6C213D682E676574536E617073686F744265666F72655570646174652626286D3D682E676574536E617073686F744265666F726555';
wwv_flow_imp.g_varchar2_table(39690) := '706461746528702C6729292C636C28652C5861286B3D6E756C6C213D642626642E747970653D3D3D696C26266E756C6C3D3D642E6B65793F642E70726F70732E6368696C6472656E3A64293F6B3A5B6B5D2C742C6E2C692C6F2C732C722C612C6C2C6329';
wwv_flow_imp.g_varchar2_table(39691) := '2C682E626173653D742E5F5F652C742E5F5F75263D2D3136312C682E5F5F682E6C656E6774682626722E707573682868292C66262628682E5F5F453D682E5F5F3D6E756C6C297D63617463682865297B696628742E5F5F763D6E756C6C2C6C7C7C6E756C';
wwv_flow_imp.g_varchar2_table(39692) := '6C213D73297B666F7228742E5F5F757C3D6C3F3136303A33323B612626383D3D3D612E6E6F6465547970652626612E6E6578745369626C696E673B29613D612E6E6578745369626C696E673B735B732E696E6465784F662861295D3D6E756C6C2C742E5F';
wwv_flow_imp.g_varchar2_table(39693) := '5F653D617D656C736520742E5F5F653D6E2E5F5F652C742E5F5F6B3D6E2E5F5F6B3B7A612E5F5F6528652C742C6E297D656C7365206E756C6C3D3D732626742E5F5F763D3D3D6E2E5F5F763F28742E5F5F6B3D6E2E5F5F6B2C742E5F5F653D6E2E5F5F65';
wwv_flow_imp.g_varchar2_table(39694) := '293A742E5F5F653D626C286E2E5F5F652C742C6E2C692C6F2C732C722C6C2C63293B28643D7A612E646966666564292626642874297D66756E6374696F6E20766C28652C742C6E297B742E5F5F643D766F696420303B666F722876617220693D303B693C';
wwv_flow_imp.g_varchar2_table(39695) := '6E2E6C656E6774683B692B2B295F6C286E5B695D2C6E5B2B2B695D2C6E5B2B2B695D293B7A612E5F5F6326267A612E5F5F6328742C65292C652E736F6D65282866756E6374696F6E2874297B7472797B653D742E5F5F682C742E5F5F683D5B5D2C652E73';
wwv_flow_imp.g_varchar2_table(39696) := '6F6D65282866756E6374696F6E2865297B652E63616C6C2874297D29297D63617463682865297B7A612E5F5F6528652C742E5F5F76297D7D29297D66756E6374696F6E20626C28652C742C6E2C692C6F2C732C722C612C6C297B76617220632C642C682C';
wwv_flow_imp.g_varchar2_table(39697) := '752C702C672C6D2C663D6E2E70726F70732C763D742E70726F70732C623D742E747970653B69662822737667223D3D3D623F6F3D22687474703A2F2F7777772E77332E6F72672F323030302F737667223A226D617468223D3D3D623F6F3D22687474703A';
wwv_flow_imp.g_varchar2_table(39698) := '2F2F7777772E77332E6F72672F313939382F4D6174682F4D6174684D4C223A6F7C7C286F3D22687474703A2F2F7777772E77332E6F72672F313939392F7868746D6C22292C6E756C6C213D7329666F7228633D303B633C732E6C656E6774683B632B2B29';
wwv_flow_imp.g_varchar2_table(39699) := '69662828703D735B635D2926262273657441747472696275746522696E20703D3D212162262628623F702E6C6F63616C4E616D653D3D3D623A333D3D3D702E6E6F64655479706529297B653D702C735B635D3D6E756C6C3B627265616B7D6966286E756C';
wwv_flow_imp.g_varchar2_table(39700) := '6C3D3D65297B6966286E756C6C3D3D3D622972657475726E20646F63756D656E742E637265617465546578744E6F64652876293B653D646F63756D656E742E637265617465456C656D656E744E53286F2C622C762E6973262676292C733D6E756C6C2C61';
wwv_flow_imp.g_varchar2_table(39701) := '3D21317D6966286E756C6C3D3D3D6229663D3D3D767C7C612626652E646174613D3D3D767C7C28652E646174613D76293B656C73657B696628733D73262656612E63616C6C28652E6368696C644E6F646573292C663D6E2E70726F70737C7C51612C2161';
wwv_flow_imp.g_varchar2_table(39702) := '26266E756C6C213D7329666F7228663D7B7D2C633D303B633C652E617474726962757465732E6C656E6774683B632B2B29665B28703D652E617474726962757465735B635D292E6E616D655D3D702E76616C75653B666F72286320696E20662969662870';
wwv_flow_imp.g_varchar2_table(39703) := '3D665B635D2C226368696C6472656E223D3D63293B656C7365206966282264616E6765726F75736C79536574496E6E657248544D4C223D3D6329683D703B656C736520696628226B657922213D3D63262621286320696E207629297B6966282276616C75';
wwv_flow_imp.g_varchar2_table(39704) := '65223D3D6326262264656661756C7456616C756522696E20767C7C22636865636B6564223D3D6326262264656661756C74436865636B656422696E207629636F6E74696E75653B676C28652C632C6E756C6C2C702C6F297D666F72286320696E20762970';
wwv_flow_imp.g_varchar2_table(39705) := '3D765B635D2C226368696C6472656E223D3D633F753D703A2264616E6765726F75736C79536574496E6E657248544D4C223D3D633F643D703A2276616C7565223D3D633F673D703A22636865636B6564223D3D633F6D3D703A226B6579223D3D3D637C7C';
wwv_flow_imp.g_varchar2_table(39706) := '6126262266756E6374696F6E22213D747970656F6620707C7C665B635D3D3D3D707C7C676C28652C632C702C665B635D2C6F293B6966286429617C7C68262628642E5F5F68746D6C3D3D3D682E5F5F68746D6C7C7C642E5F5F68746D6C3D3D3D652E696E';
wwv_flow_imp.g_varchar2_table(39707) := '6E657248544D4C297C7C28652E696E6E657248544D4C3D642E5F5F68746D6C292C742E5F5F6B3D5B5D3B656C73652069662868262628652E696E6E657248544D4C3D2222292C636C28652C58612875293F753A5B755D2C742C6E2C692C22666F72656967';
wwv_flow_imp.g_varchar2_table(39708) := '6E4F626A656374223D3D3D623F22687474703A2F2F7777772E77332E6F72672F313939392F7868746D6C223A6F2C732C722C733F735B305D3A6E2E5F5F6B2626736C286E2C30292C612C6C292C6E756C6C213D7329666F7228633D732E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(39709) := '632D2D3B296E756C6C213D735B635D2626656C28735B635D293B617C7C28633D2276616C7565222C766F69642030213D3D6726262867213D3D655B635D7C7C2270726F6772657373223D3D3D62262621677C7C226F7074696F6E223D3D3D62262667213D';
wwv_flow_imp.g_varchar2_table(39710) := '3D665B635D292626676C28652C632C672C665B635D2C6F292C633D22636865636B6564222C766F69642030213D3D6D26266D213D3D655B635D2626676C28652C632C6D2C665B635D2C6F29297D72657475726E20657D66756E6374696F6E205F6C28652C';
wwv_flow_imp.g_varchar2_table(39711) := '742C6E297B7472797B6966282266756E6374696F6E223D3D747970656F662065297B76617220693D2266756E6374696F6E223D3D747970656F6620652E5F5F753B692626652E5F5F7528292C6926266E756C6C3D3D747C7C28652E5F5F753D6528742929';
wwv_flow_imp.g_varchar2_table(39712) := '7D656C736520652E63757272656E743D747D63617463682865297B7A612E5F5F6528652C6E297D7D66756E6374696F6E20796C28652C742C6E297B76617220692C6F3B6966287A612E756E6D6F756E7426267A612E756E6D6F756E742865292C28693D65';
wwv_flow_imp.g_varchar2_table(39713) := '2E72656629262628692E63757272656E742626692E63757272656E74213D3D652E5F5F657C7C5F6C28692C6E756C6C2C7429292C6E756C6C213D28693D652E5F5F6329297B696628692E636F6D706F6E656E7457696C6C556E6D6F756E74297472797B69';
wwv_flow_imp.g_varchar2_table(39714) := '2E636F6D706F6E656E7457696C6C556E6D6F756E7428297D63617463682865297B7A612E5F5F6528652C74297D692E626173653D692E5F5F503D6E756C6C7D696628693D652E5F5F6B29666F72286F3D303B6F3C692E6C656E6774683B6F2B2B29695B6F';
wwv_flow_imp.g_varchar2_table(39715) := '5D2626796C28695B6F5D2C742C6E7C7C2266756E6374696F6E22213D747970656F6620652E74797065293B6E7C7C6E756C6C3D3D652E5F5F657C7C656C28652E5F5F65292C652E5F5F633D652E5F5F3D652E5F5F653D652E5F5F643D766F696420307D66';
wwv_flow_imp.g_varchar2_table(39716) := '756E6374696F6E20776C28652C742C6E297B72657475726E20746869732E636F6E7374727563746F7228652C6E297D66756E6374696F6E20436C28652C742C6E297B76617220692C6F2C732C723B7A612E5F5F26267A612E5F5F28652C74292C6F3D2869';
wwv_flow_imp.g_varchar2_table(39717) := '3D2266756E6374696F6E223D3D747970656F66206E293F6E756C6C3A6E26266E2E5F5F6B7C7C742E5F5F6B2C733D5B5D2C723D5B5D2C666C28742C653D28216926266E7C7C74292E5F5F6B3D746C28696C2C6E756C6C2C5B655D292C6F7C7C51612C5161';
wwv_flow_imp.g_varchar2_table(39718) := '2C742E6E616D6573706163655552492C216926266E3F5B6E5D3A6F3F6E756C6C3A742E66697273744368696C643F56612E63616C6C28742E6368696C644E6F646573293A6E756C6C2C732C216926266E3F6E3A6F3F6F2E5F5F653A742E66697273744368';
wwv_flow_imp.g_varchar2_table(39719) := '696C642C692C72292C766C28732C652C72297D56613D59612E736C6963652C7A613D7B5F5F653A66756E6374696F6E28652C742C6E2C69297B666F7228766172206F2C732C723B743D742E5F5F3B29696628286F3D742E5F5F63292626216F2E5F5F2974';
wwv_flow_imp.g_varchar2_table(39720) := '72797B69662828733D6F2E636F6E7374727563746F722926266E756C6C213D732E67657444657269766564537461746546726F6D4572726F722626286F2E736574537461746528732E67657444657269766564537461746546726F6D4572726F72286529';
wwv_flow_imp.g_varchar2_table(39721) := '292C723D6F2E5F5F64292C6E756C6C213D6F2E636F6D706F6E656E7444696443617463682626286F2E636F6D706F6E656E74446964436174636828652C697C7C7B7D292C723D6F2E5F5F64292C722972657475726E206F2E5F5F453D6F7D636174636828';
wwv_flow_imp.g_varchar2_table(39722) := '74297B653D747D7468726F7720657D7D2C48613D302C6F6C2E70726F746F747970652E73657453746174653D66756E6374696F6E28652C74297B766172206E3B6E3D6E756C6C213D746869732E5F5F732626746869732E5F5F73213D3D746869732E7374';
wwv_flow_imp.g_varchar2_table(39723) := '6174653F746869732E5F5F733A746869732E5F5F733D4A61287B7D2C746869732E7374617465292C2266756E6374696F6E223D3D747970656F662065262628653D65284A61287B7D2C6E292C746869732E70726F707329292C6526264A61286E2C65292C';
wwv_flow_imp.g_varchar2_table(39724) := '6E756C6C213D652626746869732E5F5F76262628742626746869732E5F73622E707573682874292C616C287468697329297D2C6F6C2E70726F746F747970652E666F7263655570646174653D66756E6374696F6E2865297B746869732E5F5F7626262874';
wwv_flow_imp.g_varchar2_table(39725) := '6869732E5F5F653D21302C652626746869732E5F5F682E707573682865292C616C287468697329297D2C6F6C2E70726F746F747970652E72656E6465723D696C2C57613D5B5D2C71613D2266756E6374696F6E223D3D747970656F662050726F6D697365';
wwv_flow_imp.g_varchar2_table(39726) := '3F50726F6D6973652E70726F746F747970652E7468656E2E62696E642850726F6D6973652E7265736F6C76652829293A73657454696D656F75742C24613D66756E6374696F6E28652C74297B72657475726E20652E5F5F762E5F5F622D742E5F5F762E5F';
wwv_flow_imp.g_varchar2_table(39727) := '5F627D2C6C6C2E5F5F723D302C55613D302C4B613D6D6C282131292C47613D6D6C282130293B76617220536C2C786C2C6B6C2C456C2C4C6C3D66756E6374696F6E28652C742C6E2C69297B766172206F3B745B305D3D303B666F722876617220733D313B';
wwv_flow_imp.g_varchar2_table(39728) := '733C742E6C656E6774683B732B2B297B76617220723D745B732B2B5D2C613D745B735D3F28745B305D7C3D723F313A322C6E5B745B732B2B5D5D293A745B2B2B735D3B333D3D3D723F695B305D3D613A343D3D3D723F695B315D3D4F626A6563742E6173';
wwv_flow_imp.g_varchar2_table(39729) := '7369676E28695B315D7C7C7B7D2C61293A353D3D3D723F28695B315D3D695B315D7C7C7B7D295B745B2B2B735D5D3D613A363D3D3D723F695B315D5B745B2B2B735D5D2B3D612B22223A723F286F3D652E6170706C7928612C4C6C28652C612C6E2C5B22';
wwv_flow_imp.g_varchar2_table(39730) := '222C6E756C6C5D29292C692E70757368286F292C615B305D3F745B305D7C3D323A28745B732D325D3D302C745B735D3D6F29293A692E707573682861297D72657475726E20697D2C446C3D6E6577204D61702C546C3D66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(39731) := '7220743D446C2E6765742874686973293B72657475726E20747C7C28743D6E6577204D61702C446C2E73657428746869732C7429292C28743D4C6C28746869732C742E6765742865297C7C28742E73657428652C743D66756E6374696F6E2865297B666F';
wwv_flow_imp.g_varchar2_table(39732) := '722876617220742C6E2C693D312C6F3D22222C733D22222C723D5B305D2C613D66756E6374696F6E2865297B313D3D3D69262628657C7C286F3D6F2E7265706C616365282F5E5C732A5C6E5C732A7C5C732A5C6E5C732A242F672C22222929293F722E70';
wwv_flow_imp.g_varchar2_table(39733) := '75736828302C652C6F293A333D3D3D69262628657C7C6F293F28722E7075736828332C652C6F292C693D32293A323D3D3D692626222E2E2E223D3D3D6F2626653F722E7075736828342C652C30293A323D3D3D6926266F262621653F722E707573682835';
wwv_flow_imp.g_varchar2_table(39734) := '2C302C21302C6F293A693E3D35262628286F7C7C21652626353D3D3D6929262628722E7075736828692C302C6F2C6E292C693D36292C65262628722E7075736828692C652C302C6E292C693D3629292C6F3D22227D2C6C3D303B6C3C652E6C656E677468';
wwv_flow_imp.g_varchar2_table(39735) := '3B6C2B2B297B6C262628313D3D3D6926266128292C61286C29293B666F722876617220633D303B633C655B6C5D2E6C656E6774683B632B2B29743D655B6C5D5B635D2C313D3D3D693F223C223D3D3D743F286128292C723D5B725D2C693D33293A6F2B3D';
wwv_flow_imp.g_varchar2_table(39736) := '743A343D3D3D693F222D2D223D3D3D6F2626223E223D3D3D743F28693D312C6F3D2222293A6F3D742B6F5B305D3A733F743D3D3D733F733D22223A6F2B3D743A2722273D3D3D747C7C2227223D3D3D743F733D743A223E223D3D3D743F286128292C693D';
wwv_flow_imp.g_varchar2_table(39737) := '31293A69262628223D223D3D3D743F28693D352C6E3D6F2C6F3D2222293A222F223D3D3D74262628693C357C7C223E223D3D3D655B6C5D5B632B315D293F286128292C333D3D3D69262628723D725B305D292C693D722C28723D725B305D292E70757368';
wwv_flow_imp.g_varchar2_table(39738) := '28322C302C69292C693D30293A2220223D3D3D747C7C225C74223D3D3D747C7C225C6E223D3D3D747C7C225C72223D3D3D743F286128292C693D32293A6F2B3D74292C333D3D3D69262622212D2D223D3D3D6F262628693D342C723D725B305D297D7265';
wwv_flow_imp.g_varchar2_table(39739) := '7475726E206128292C727D286529292C74292C617267756D656E74732C5B5D29292E6C656E6774683E313F743A745B305D7D2E62696E6428746C292C496C3D302C4D6C3D5B5D2C416C3D7A612C4E6C3D416C2E5F5F622C506C3D416C2E5F5F722C4F6C3D';
wwv_flow_imp.g_varchar2_table(39740) := '416C2E6469666665642C526C3D416C2E5F5F632C466C3D416C2E756E6D6F756E742C426C3D416C2E5F5F3B66756E6374696F6E20566C28652C74297B416C2E5F5F682626416C2E5F5F6828786C2C652C496C7C7C74292C496C3D303B766172206E3D786C';
wwv_flow_imp.g_varchar2_table(39741) := '2E5F5F487C7C28786C2E5F5F483D7B5F5F3A5B5D2C5F5F683A5B5D7D293B72657475726E20653E3D6E2E5F5F2E6C656E67746826266E2E5F5F2E70757368287B7D292C6E2E5F5F5B655D7D66756E6374696F6E207A6C2865297B72657475726E20496C3D';
wwv_flow_imp.g_varchar2_table(39742) := '312C66756E6374696F6E28652C74297B766172206E3D566C28536C2B2B2C32293B6966286E2E743D652C216E2E5F5F632626286E2E5F5F3D5B586C28766F696420302C74292C66756E6374696F6E2865297B76617220743D6E2E5F5F4E3F6E2E5F5F4E5B';
wwv_flow_imp.g_varchar2_table(39743) := '305D3A6E2E5F5F5B305D2C693D6E2E7428742C65293B74213D3D692626286E2E5F5F4E3D5B692C6E2E5F5F5B315D5D2C6E2E5F5F632E7365745374617465287B7D29297D5D2C6E2E5F5F633D786C2C21786C2E7529297B76617220693D66756E6374696F';
wwv_flow_imp.g_varchar2_table(39744) := '6E28652C742C69297B696628216E2E5F5F632E5F5F482972657475726E21303B76617220733D6E2E5F5F632E5F5F482E5F5F2E66696C746572282866756E6374696F6E2865297B72657475726E2121652E5F5F637D29293B696628732E65766572792828';
wwv_flow_imp.g_varchar2_table(39745) := '66756E6374696F6E2865297B72657475726E21652E5F5F4E7D29292972657475726E216F7C7C6F2E63616C6C28746869732C652C742C69293B76617220723D21313B72657475726E20732E666F7245616368282866756E6374696F6E2865297B69662865';
wwv_flow_imp.g_varchar2_table(39746) := '2E5F5F4E297B76617220743D652E5F5F5B305D3B652E5F5F3D652E5F5F4E2C652E5F5F4E3D766F696420302C74213D3D652E5F5F5B305D262628723D2130297D7D29292C2128217226266E2E5F5F632E70726F70733D3D3D6529262628216F7C7C6F2E63';
wwv_flow_imp.g_varchar2_table(39747) := '616C6C28746869732C652C742C6929297D3B786C2E753D21303B766172206F3D786C2E73686F756C64436F6D706F6E656E745570646174652C733D786C2E636F6D706F6E656E7457696C6C5570646174653B786C2E636F6D706F6E656E7457696C6C5570';
wwv_flow_imp.g_varchar2_table(39748) := '646174653D66756E6374696F6E28652C742C6E297B696628746869732E5F5F65297B76617220723D6F3B6F3D766F696420302C6928652C742C6E292C6F3D727D732626732E63616C6C28746869732C652C742C6E297D2C786C2E73686F756C64436F6D70';
wwv_flow_imp.g_varchar2_table(39749) := '6F6E656E745570646174653D697D72657475726E206E2E5F5F4E7C7C6E2E5F5F7D28586C2C65297D66756E6374696F6E20486C28652C74297B766172206E3D566C28536C2B2B2C33293B21416C2E5F5F7326265A6C286E2E5F5F482C74292626286E2E5F';
wwv_flow_imp.g_varchar2_table(39750) := '5F3D652C6E2E693D742C786C2E5F5F482E5F5F682E70757368286E29297D66756E6374696F6E20576C28652C74297B766172206E3D566C28536C2B2B2C34293B21416C2E5F5F7326265A6C286E2E5F5F482C74292626286E2E5F5F3D652C6E2E693D742C';
wwv_flow_imp.g_varchar2_table(39751) := '786C2E5F5F682E70757368286E29297D66756E6374696F6E206A6C2865297B72657475726E20496C3D352C716C282866756E6374696F6E28297B72657475726E7B63757272656E743A657D7D292C5B5D297D66756E6374696F6E20716C28652C74297B76';
wwv_flow_imp.g_varchar2_table(39752) := '6172206E3D566C28536C2B2B2C37293B72657475726E205A6C286E2E5F5F482C74292626286E2E5F5F3D6528292C6E2E5F5F483D742C6E2E5F5F683D65292C6E2E5F5F7D66756E6374696F6E20246C28652C74297B72657475726E20496C3D382C716C28';
wwv_flow_imp.g_varchar2_table(39753) := '2866756E6374696F6E28297B72657475726E20657D292C74297D66756E6374696F6E20556C28297B666F722876617220653B653D4D6C2E736869667428293B29696628652E5F5F502626652E5F5F48297472797B652E5F5F482E5F5F682E666F72456163';
wwv_flow_imp.g_varchar2_table(39754) := '6828516C292C652E5F5F482E5F5F682E666F724561636828596C292C652E5F5F482E5F5F683D5B5D7D63617463682874297B652E5F5F482E5F5F683D5B5D2C416C2E5F5F6528742C652E5F5F76297D7D416C2E5F5F623D66756E6374696F6E2865297B78';
wwv_flow_imp.g_varchar2_table(39755) := '6C3D6E756C6C2C4E6C26264E6C2865297D2C416C2E5F5F3D66756E6374696F6E28652C74297B652626742E5F5F6B2626742E5F5F6B2E5F5F6D262628652E5F5F6D3D742E5F5F6B2E5F5F6D292C426C2626426C28652C74297D2C416C2E5F5F723D66756E';
wwv_flow_imp.g_varchar2_table(39756) := '6374696F6E2865297B506C2626506C2865292C536C3D303B76617220743D28786C3D652E5F5F63292E5F5F483B742626286B6C3D3D3D786C3F28742E5F5F683D5B5D2C786C2E5F5F683D5B5D2C742E5F5F2E666F7245616368282866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(39757) := '65297B652E5F5F4E262628652E5F5F3D652E5F5F4E292C652E693D652E5F5F4E3D766F696420307D2929293A28742E5F5F682E666F724561636828516C292C742E5F5F682E666F724561636828596C292C742E5F5F683D5B5D2C536C3D3029292C6B6C3D';
wwv_flow_imp.g_varchar2_table(39758) := '786C7D2C416C2E6469666665643D66756E6374696F6E2865297B4F6C26264F6C2865293B76617220743D652E5F5F633B742626742E5F5F48262628742E5F5F482E5F5F682E6C656E67746826262831213D3D4D6C2E707573682874292626456C3D3D3D41';
wwv_flow_imp.g_varchar2_table(39759) := '6C2E72657175657374416E696D6174696F6E4672616D657C7C2828456C3D416C2E72657175657374416E696D6174696F6E4672616D65297C7C476C2928556C29292C742E5F5F482E5F5F2E666F7245616368282866756E6374696F6E2865297B652E6926';
wwv_flow_imp.g_varchar2_table(39760) := '2628652E5F5F483D652E69292C652E693D766F696420307D2929292C6B6C3D786C3D6E756C6C7D2C416C2E5F5F633D66756E6374696F6E28652C74297B742E736F6D65282866756E6374696F6E2865297B7472797B652E5F5F682E666F72456163682851';
wwv_flow_imp.g_varchar2_table(39761) := '6C292C652E5F5F683D652E5F5F682E66696C746572282866756E6374696F6E2865297B72657475726E21652E5F5F7C7C596C2865297D29297D6361746368286E297B742E736F6D65282866756E6374696F6E2865297B652E5F5F68262628652E5F5F683D';
wwv_flow_imp.g_varchar2_table(39762) := '5B5D297D29292C743D5B5D2C416C2E5F5F65286E2C652E5F5F76297D7D29292C526C2626526C28652C74297D2C416C2E756E6D6F756E743D66756E6374696F6E2865297B466C2626466C2865293B76617220742C6E3D652E5F5F633B6E26266E2E5F5F48';
wwv_flow_imp.g_varchar2_table(39763) := '2626286E2E5F5F482E5F5F2E666F7245616368282866756E6374696F6E2865297B7472797B516C2865297D63617463682865297B743D657D7D29292C6E2E5F5F483D766F696420302C742626416C2E5F5F6528742C6E2E5F5F7629297D3B766172204B6C';
wwv_flow_imp.g_varchar2_table(39764) := '3D2266756E6374696F6E223D3D747970656F662072657175657374416E696D6174696F6E4672616D653B66756E6374696F6E20476C2865297B76617220742C6E3D66756E6374696F6E28297B636C65617254696D656F75742869292C4B6C262663616E63';
wwv_flow_imp.g_varchar2_table(39765) := '656C416E696D6174696F6E4672616D652874292C73657454696D656F75742865297D2C693D73657454696D656F7574286E2C313030293B4B6C262628743D72657175657374416E696D6174696F6E4672616D65286E29297D66756E6374696F6E20516C28';
wwv_flow_imp.g_varchar2_table(39766) := '65297B76617220743D786C2C6E3D652E5F5F633B2266756E6374696F6E223D3D747970656F66206E262628652E5F5F633D766F696420302C6E2829292C786C3D747D66756E6374696F6E20596C2865297B76617220743D786C3B652E5F5F633D652E5F5F';
wwv_flow_imp.g_varchar2_table(39767) := '28292C786C3D747D66756E6374696F6E205A6C28652C74297B72657475726E21657C7C652E6C656E677468213D3D742E6C656E6774687C7C742E736F6D65282866756E6374696F6E28742C6E297B72657475726E2074213D3D655B6E5D7D29297D66756E';
wwv_flow_imp.g_varchar2_table(39768) := '6374696F6E20586C28652C74297B72657475726E2266756E6374696F6E223D3D747970656F6620743F742865293A747D66756E6374696F6E204A6C2865297B76617220742C6E2C693D22223B69662822737472696E67223D3D747970656F6620657C7C22';
wwv_flow_imp.g_varchar2_table(39769) := '6E756D626572223D3D747970656F66206529692B3D653B656C736520696628226F626A656374223D3D747970656F6620652969662841727261792E69734172726179286529297B766172206F3D652E6C656E6774683B666F7228743D303B743C6F3B742B';
wwv_flow_imp.g_varchar2_table(39770) := '2B29655B745D2626286E3D4A6C28655B745D292926262869262628692B3D222022292C692B3D6E297D656C736520666F72286E20696E206529655B6E5D26262869262628692B3D222022292C692B3D6E293B72657475726E20697D636F6E73742065633D';
wwv_flow_imp.g_varchar2_table(39771) := '66756E6374696F6E28297B666F722876617220652C742C6E3D302C693D22222C6F3D617267756D656E74732E6C656E6774683B6E3C6F3B6E2B2B2928653D617267756D656E74735B6E5D29262628743D4A6C2865292926262869262628692B3D22202229';
wwv_flow_imp.g_varchar2_table(39772) := '2C692B3D74293B72657475726E20697D3B66756E6374696F6E2074632865297B636F6E73747B686561646572456E74726965733A742C6F6E53656C6563743A6E2C73656C6563746564456E7472793A692C73657453656C6563746564456E7472793A6F2C';
wwv_flow_imp.g_varchar2_table(39773) := '7469746C653A737D3D652C723D716C282828293D3E742E726564756365282828652C74293D3E7B636F6E7374206E3D742E67726F75707C7C2264656661756C74222C693D652E66696E642828653D3E652E69643D3D3D6E29293B72657475726E20693F69';
wwv_flow_imp.g_varchar2_table(39774) := '2E656E74726965732E707573682874293A652E70757368287B69643A6E2C656E74726965733A5B745D7D292C657D292C5B5D29292C5B745D293B72657475726E20546C600A202020203C64697620636C6173733D22646A732D706F7075702D6865616465';
wwv_flow_imp.g_varchar2_table(39775) := '72223E0A2020202020203C683320636C6173733D22646A732D706F7075702D7469746C6522207469746C653D247B737D3E247B737D3C2F68333E0A202020202020247B722E6D61702828653D3E546C600A20202020202020203C756C206B65793D247B65';
wwv_flow_imp.g_varchar2_table(39776) := '2E69647D20636C6173733D22646A732D706F7075702D6865616465722D67726F75702220646174612D6865616465722D67726F75703D247B652E69647D3E0A0A20202020202020202020247B652E656E74726965732E6D61702828653D3E546C600A2020';
wwv_flow_imp.g_varchar2_table(39777) := '202020202020202020203C6C69206B65793D247B652E69647D3E0A20202020202020202020202020203C247B652E616374696F6E3F22627574746F6E223A227370616E227D0A20202020202020202020202020202020636C6173733D247B66756E637469';
wwv_flow_imp.g_varchar2_table(39778) := '6F6E28652C74297B72657475726E2065632822656E747279222C652E636C6173734E616D652C652E6163746976653F22616374697665223A22222C652E64697361626C65643F2264697361626C6564223A22222C743F2273656C6563746564223A222229';
wwv_flow_imp.g_varchar2_table(39779) := '7D28652C653D3D3D69297D0A202020202020202020202020202020206F6E436C69636B3D247B743D3E652E616374696F6E26266E28742C65297D0A202020202020202020202020202020207469746C653D247B652E7469746C657C7C652E6C6162656C7D';
wwv_flow_imp.g_varchar2_table(39780) := '0A20202020202020202020202020202020646174612D69643D247B652E69647D0A202020202020202020202020202020206F6E4D6F757365456E7465723D247B28293D3E652E616374696F6E26266F2865297D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(39781) := '6F6E4D6F7573654C656176653D247B28293D3E652E616374696F6E26266F286E756C6C297D0A202020202020202020202020202020206F6E466F6375733D247B28293D3E652E616374696F6E26266F2865297D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(39782) := '6F6E426C75723D247B28293D3E652E616374696F6E26266F286E756C6C297D0A20202020202020202020202020203E0A20202020202020202020202020202020247B652E696D61676555726C2626546C603C696D6720636C6173733D22646A732D706F70';
wwv_flow_imp.g_varchar2_table(39783) := '75702D656E7472792D69636F6E22207372633D247B652E696D61676555726C7D20616C743D2222202F3E607C7C652E696D61676548746D6C2626546C603C64697620636C6173733D22646A732D706F7075702D656E7472792D69636F6E222064616E6765';
wwv_flow_imp.g_varchar2_table(39784) := '726F75736C79536574496E6E657248544D4C3D247B7B5F5F68746D6C3A652E696D61676548746D6C7D7D202F3E607D0A20202020202020202020202020202020247B652E6C6162656C3F546C600A2020202020202020202020202020202020203C737061';
wwv_flow_imp.g_varchar2_table(39785) := '6E20636C6173733D22646A732D706F7075702D6C6162656C223E247B652E6C6162656C7D3C2F7370616E3E0A20202020202020202020202020202020603A6E756C6C7D0A20202020202020202020202020203C2F247B652E616374696F6E3F2262757474';
wwv_flow_imp.g_varchar2_table(39786) := '6F6E223A227370616E227D3E0A2020202020202020202020203C2F6C693E0A202020202020202020206029297D0A20202020202020203C2F756C3E0A2020202020206029297D0A202020203C2F6469763E0A2020607D66756E6374696F6E206E63286529';
wwv_flow_imp.g_varchar2_table(39787) := '7B636F6E73747B656E7472793A742C73656C65637465643A6E2C6F6E4D6F757365456E7465723A692C6F6E4D6F7573654C656176653A6F2C6F6E416374696F6E3A737D3D653B72657475726E20546C600A202020203C6C690A202020202020636C617373';
wwv_flow_imp.g_varchar2_table(39788) := '3D247B65632822656E747279222C7B73656C65637465643A6E7D297D0A202020202020646174612D69643D247B742E69647D0A2020202020207469746C653D247B742E7469746C657C7C742E6C6162656C7D0A202020202020746162496E6465783D2230';
wwv_flow_imp.g_varchar2_table(39789) := '220A2020202020206F6E436C69636B3D247B737D0A2020202020206F6E466F6375733D247B697D0A2020202020206F6E426C75723D247B6F7D0A2020202020206F6E4D6F757365456E7465723D247B697D0A2020202020206F6E4D6F7573654C65617665';
wwv_flow_imp.g_varchar2_table(39790) := '3D247B6F7D0A2020202020206F6E4472616753746172743D247B653D3E7328652C742C2264726167737461727422297D0A202020202020647261676761626C653D247B21307D0A202020203E0A2020202020203C64697620636C6173733D22646A732D70';
wwv_flow_imp.g_varchar2_table(39791) := '6F7075702D656E7472792D636F6E74656E74223E0A20202020202020203C7370616E0A20202020202020202020636C6173733D247B65632822646A732D706F7075702D656E7472792D6E616D65222C742E636C6173734E616D65297D0A20202020202020';
wwv_flow_imp.g_varchar2_table(39792) := '203E0A20202020202020202020247B742E696D61676555726C2626546C603C696D6720636C6173733D22646A732D706F7075702D656E7472792D69636F6E22207372633D247B742E696D61676555726C7D20616C743D2222202F3E607C7C742E696D6167';
wwv_flow_imp.g_varchar2_table(39793) := '6548746D6C2626546C603C64697620636C6173733D22646A732D706F7075702D656E7472792D69636F6E222064616E6765726F75736C79536574496E6E657248544D4C3D247B7B5F5F68746D6C3A742E696D61676548746D6C7D7D202F3E607D0A0A2020';
wwv_flow_imp.g_varchar2_table(39794) := '2020202020202020247B742E6C6162656C3F546C600A2020202020202020202020203C7370616E20636C6173733D22646A732D706F7075702D6C6162656C223E0A2020202020202020202020202020247B742E6C6162656C7D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(39795) := '20203C2F7370616E3E0A20202020202020202020603A6E756C6C7D0A20202020202020203C2F7370616E3E0A2020202020202020247B742E6465736372697074696F6E2626546C600A202020202020202020203C7370616E0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(39796) := '20636C6173733D22646A732D706F7075702D656E7472792D6465736372697074696F6E220A2020202020202020202020207469746C653D247B742E6465736372697074696F6E7D0A202020202020202020203E0A202020202020202020202020247B742E';
wwv_flow_imp.g_varchar2_table(39797) := '6465736372697074696F6E7D0A202020202020202020203C2F7370616E3E0A2020202020202020607D0A2020202020203C2F6469763E0A202020202020247B742E646F63756D656E746174696F6E5265662626546C600A20202020202020203C64697620';
wwv_flow_imp.g_varchar2_table(39798) := '636C6173733D22646A732D706F7075702D656E7472792D646F6373223E0A202020202020202020203C610A202020202020202020202020687265663D22247B742E646F63756D656E746174696F6E5265667D220A2020202020202020202020206F6E436C';
wwv_flow_imp.g_varchar2_table(39799) := '69636B3D247B653D3E652E73746F7050726F7061676174696F6E28297D0A2020202020202020202020207469746C653D224F70656E20656C656D656E7420646F63756D656E746174696F6E220A2020202020202020202020207461726765743D225F626C';
wwv_flow_imp.g_varchar2_table(39800) := '616E6B220A20202020202020202020202072656C3D226E6F6F70656E6572220A202020202020202020203E0A2020202020202020202020203C7376672077696474683D22313222206865696768743D223132222076696577426F783D2230203020313220';
wwv_flow_imp.g_varchar2_table(39801) := '3132222066696C6C3D226E6F6E652220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667223E0A20202020202020202020202020203C706174682066696C6C2D72756C653D226576656E6F64642220636C69702D72756C';
wwv_flow_imp.g_varchar2_table(39802) := '653D226576656E6F64642220643D224D31302E363336382031302E3633373556352E39313736314831312E393939355631302E363338324331312E393939352031302E393937332031312E383632332031312E333134312031312E353837382031312E35';
wwv_flow_imp.g_varchar2_table(39803) := '3838354331312E333133342031312E3836332031302E393936362031322E303030322031302E363337352031322E3030303248312E333632363643302E3938323334352031322E3030303220302E3636303135392031312E3836383120302E3339363130';
wwv_flow_imp.g_varchar2_table(39804) := '322031312E3630343143302E3133323034342031312E333420312E3532353838652D30352031312E3031373820312E3532353838652D30352031302E3633373556312E333632363743312E3532353838652D303520302E393832333620302E3133323034';
wwv_flow_imp.g_varchar2_table(39805) := '3420302E36363031373320302E33393631303220302E33393631313643302E36363031353920302E31333230353820302E39383233343520322E3935363339652D303520312E333632363620322E3935363339652D303548352E393136323456312E3336';
wwv_flow_imp.g_varchar2_table(39806) := '32363748312E33363236365631302E363337354831302E363336385A4D3132203048372E323739344C372E323738373320312E333631393748392E36383730314C332E303635303720372E39383339314C342E303135343120382E39333432354C31302E';
wwv_flow_imp.g_varchar2_table(39807) := '3633373320322E333132333156342E373230353948313256305A222066696C6C3D2223383138373938222F3E0A2020202020202020202020203C2F7376673E0A202020202020202020203C2F613E0A20202020202020203C2F6469763E0A202020202020';
wwv_flow_imp.g_varchar2_table(39808) := '607D0A202020203C2F6C693E0A2020607D66756E6374696F6E2069632865297B636F6E73747B73656C6563746564456E7472793A742C73657453656C6563746564456E7472793A6E2C656E74726965733A692C2E2E2E6F7D3D652C733D6A6C28292C723D';
wwv_flow_imp.g_varchar2_table(39809) := '716C282828293D3E66756E6374696F6E2865297B636F6E737420743D5B5D2C6E3D653D3E742E66696E642828743D3E652E69643D3D3D742E696429293B72657475726E20652E666F72456163682828653D3E7B636F6E737420693D652E67726F75703F28';
wwv_flow_imp.g_varchar2_table(39810) := '653D3E22737472696E67223D3D747970656F6620653F7B69643A657D3A652928652E67726F7570293A7B69643A2264656661756C74227D3B28653D3E21216E286529292869293F6E2869292E656E74726965732E707573682865293A742E70757368287B';
wwv_flow_imp.g_varchar2_table(39811) := '2E2E2E692C656E74726965733A5B655D7D297D29292C747D286929292C5B695D293B72657475726E20576C282828293D3E7B636F6E737420653D732E63757272656E743B69662821652972657475726E3B636F6E737420743D652E717565727953656C65';
wwv_flow_imp.g_varchar2_table(39812) := '63746F7228222E73656C656374656422293B766172206E3B742626282266756E6374696F6E223D3D747970656F66286E3D74292E7363726F6C6C496E746F5669657749664E65656465643F6E2E7363726F6C6C496E746F5669657749664E656564656428';
wwv_flow_imp.g_varchar2_table(39813) := '293A6E2E7363726F6C6C496E746F56696577287B7363726F6C6C4D6F64653A2269662D6E6565646564222C626C6F636B3A226E656172657374227D29297D292C5B745D292C546C600A202020203C64697620636C6173733D22646A732D706F7075702D72';
wwv_flow_imp.g_varchar2_table(39814) := '6573756C747322207265663D247B737D3E0A202020202020247B722E6D61702828653D3E546C600A2020202020202020247B652E6E616D652626546C600A202020202020202020203C646976206B65793D247B652E69647D20636C6173733D22656E7472';
wwv_flow_imp.g_varchar2_table(39815) := '792D68656164657222207469746C653D247B652E6E616D657D3E0A202020202020202020202020247B652E6E616D657D0A202020202020202020203C2F6469763E0A2020202020202020607D0A20202020202020203C756C20636C6173733D22646A732D';
wwv_flow_imp.g_varchar2_table(39816) := '706F7075702D67726F75702220646174612D67726F75703D247B652E69647D3E0A20202020202020202020247B652E656E74726965732E6D61702828653D3E546C600A2020202020202020202020203C247B6E637D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(39817) := '6B65793D247B652E69647D0A2020202020202020202020202020656E7472793D247B657D0A202020202020202020202020202073656C65637465643D247B653D3D3D747D0A20202020202020202020202020206F6E4D6F757365456E7465723D247B2829';
wwv_flow_imp.g_varchar2_table(39818) := '3D3E6E2865297D0A20202020202020202020202020206F6E4D6F7573654C656176653D247B28293D3E6E286E756C6C297D0A20202020202020202020202020202E2E2E247B6F7D0A2020202020202020202020202F3E0A20202020202020202020602929';
wwv_flow_imp.g_varchar2_table(39819) := '7D0A20202020202020203C2F756C3E0A2020202020206029297D0A202020203C2F6469763E0A2020607D66756E6374696F6E206F632865297B636F6E73747B6F6E436C6F73653A742C6F6E53656C6563743A6E2C636C6173734E616D653A6F2C68656164';
wwv_flow_imp.g_varchar2_table(39820) := '6572456E74726965733A732C706F736974696F6E3A722C7469746C653A612C77696474683A6C2C7363616C653A632C7365617263683A642C656D707479506C616365686F6C6465723A682C656E74726965733A752C6F6E4F70656E65643A702C6F6E436C';
wwv_flow_imp.g_varchar2_table(39821) := '6F7365643A677D3D652C6D3D716C282828293D3E212128302C692E4F39292864292626752E6C656E6774683E35292C5B642C755D292C5B662C765D3D7A6C282222292C623D246C282828652C74293D3E6D3F652E66696C7465722828653D3E7B69662821';
wwv_flow_imp.g_varchar2_table(39822) := '742972657475726E28652E72616E6B7C7C30293E3D303B69662821313D3D3D652E73656172636861626C652972657475726E21313B636F6E7374206E3D5B652E6465736372697074696F6E7C7C22222C652E6C6162656C7C7C22222C652E736561726368';
wwv_flow_imp.g_varchar2_table(39823) := '7C7C22225D2E6D61702828653D3E652E746F4C6F77657243617365282929293B72657475726E20742E746F4C6F7765724361736528292E73706C6974282F5C732F67292E65766572792828653D3E6E2E736F6D652828743D3E742E696E636C7564657328';
wwv_flow_imp.g_varchar2_table(39824) := '6529292929297D29293A65292C5B6D5D292C5B5F2C795D3D7A6C286228752C6629292C5B772C435D3D7A6C285F5B305D292C533D246C2828653D3E7B772626652E696E636C756465732877297C7C4328655B305D292C792865297D292C5B772C792C435D';
wwv_flow_imp.g_varchar2_table(39825) := '293B486C282828293D3E7B53286228752C6629297D292C5B662C755D293B636F6E737420783D246C2828653D3E7B6C657420743D5F2E696E6465784F662877292B653B743C30262628743D5F2E6C656E6774682D31292C743E3D5F2E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(39826) := '28743D30292C43285F5B745D297D292C5B5F2C772C435D292C6B3D246C2828653D3E22456E746572223D3D3D652E6B65792626773F6E28652C77293A224172726F775570223D3D3D652E6B65793F2878282D31292C652E70726576656E7444656661756C';
wwv_flow_imp.g_varchar2_table(39827) := '742829293A224172726F77446F776E223D3D3D652E6B65793F28782831292C652E70726576656E7444656661756C742829293A766F69642030292C5B6E2C772C785D292C453D246C2828653D3E7B577428652E7461726765742C22696E70757422292626';
wwv_flow_imp.g_varchar2_table(39828) := '76282828293D3E652E7461726765742E76616C756529297D292C5B765D293B486C282828293D3E287028292C28293D3E7B6728297D29292C5B5D293B636F6E7374204C3D716C282828293D3E617C7C732E6C656E6774683E30292C5B612C735D293B7265';
wwv_flow_imp.g_varchar2_table(39829) := '7475726E20546C600A202020203C247B73637D0A2020202020206F6E436C6F73653D247B747D0A2020202020206F6E4B657975703D247B457D0A2020202020206F6E4B6579646F776E3D247B6B7D0A202020202020636C6173734E616D653D247B6F7D0A';
wwv_flow_imp.g_varchar2_table(39830) := '202020202020706F736974696F6E3D247B727D0A20202020202077696474683D247B6C7D0A2020202020207363616C653D247B637D0A202020203E0A202020202020247B4C2626546C600A20202020202020203C247B74637D0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(39831) := '686561646572456E74726965733D247B737D0A202020202020202020206F6E53656C6563743D247B6E7D0A2020202020202020202073656C6563746564456E7472793D247B777D0A2020202020202020202073657453656C6563746564456E7472793D24';
wwv_flow_imp.g_varchar2_table(39832) := '7B437D0A202020202020202020207469746C653D247B617D0A20202020202020202F3E0A202020202020607D0A202020202020247B752E6C656E6774683E302626546C600A20202020202020203C64697620636C6173733D22646A732D706F7075702D62';
wwv_flow_imp.g_varchar2_table(39833) := '6F6479223E0A0A20202020202020202020247B6D2626546C600A202020202020202020203C64697620636C6173733D22646A732D706F7075702D736561726368223E0A2020202020202020202020203C73766720636C6173733D22646A732D706F707570';
wwv_flow_imp.g_varchar2_table(39834) := '2D7365617263682D69636F6E222077696474683D22313422206865696768743D223134222076696577426F783D22302030203134203134222066696C6C3D226E6F6E652220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F73';
wwv_flow_imp.g_varchar2_table(39835) := '7667223E0A20202020202020202020202020203C706174682066696C6C2D72756C653D226576656E6F64642220636C69702D72756C653D226576656E6F64642220643D224D392E3033323520382E3548392E3632354C31332E333637352031322E32354C';
wwv_flow_imp.g_varchar2_table(39836) := '31322E32352031332E333637354C382E3520392E36323556392E303332354C382E3239373520382E3832323543372E3434323520392E3535373520362E3333323520313020352E31323520313043322E3433323520313020302E323520372E3831373520';
wwv_flow_imp.g_varchar2_table(39837) := '302E323520352E31323543302E323520322E3433323520322E3433323520302E323520352E31323520302E323543372E3831373520302E323520313020322E3433323520313020352E31323543313020362E3333323520392E3535373520372E34343235';
wwv_flow_imp.g_varchar2_table(39838) := '20382E3832323520382E323937354C392E3033323520382E355A4D312E373520352E31323543312E373520362E3939323520332E3235373520382E3520352E31323520382E3543362E3939323520382E3520382E3520362E3939323520382E3520352E31';
wwv_flow_imp.g_varchar2_table(39839) := '323543382E3520332E3235373520362E3939323520312E373520352E31323520312E373543332E3235373520312E373520312E373520332E3235373520312E373520352E3132355A222066696C6C3D2223323232343241222F3E0A202020202020202020';
wwv_flow_imp.g_varchar2_table(39840) := '2020203C2F7376673E0A2020202020202020202020203C696E70757420747970653D22746578742220617269612D6C6162656C3D22247B617D22202F3E0A202020202020202020203C2F6469763E0A20202020202020202020607D0A0A20202020202020';
wwv_flow_imp.g_varchar2_table(39841) := '2020203C247B69637D0A202020202020202020202020656E74726965733D247B5F7D0A20202020202020202020202073656C6563746564456E7472793D247B777D0A20202020202020202020202073657453656C6563746564456E7472793D247B437D0A';
wwv_flow_imp.g_varchar2_table(39842) := '2020202020202020202020206F6E416374696F6E3D247B6E7D0A202020202020202020202F3E0A20202020202020203C2F6469763E0A202020202020607D0A20202020247B682626303D3D3D5F2E6C656E6774682626546C600A2020202020203C646976';
wwv_flow_imp.g_varchar2_table(39843) := '20636C6173733D22646A732D706F7075702D6E6F2D726573756C7473223E247B28302C692E546E292868293F682866293A687D3C2F6469763E0A20202020607D0A202020203C2F247B73637D3E0A2020607D66756E6374696F6E2073632865297B636F6E';
wwv_flow_imp.g_varchar2_table(39844) := '73747B6F6E436C6F73653A742C6F6E4B6579646F776E3A6E2C6F6E4B657975703A692C636C6173734E616D653A6F2C6368696C6472656E3A732C706F736974696F6E3A727D3D652C613D6A6C28293B72657475726E20576C282828293D3E7B6966282266';
wwv_flow_imp.g_varchar2_table(39845) := '756E6374696F6E22213D747970656F6620722972657475726E3B636F6E737420653D612E63757272656E742C743D722865293B652E7374796C652E6C6566743D60247B742E787D7078602C652E7374796C652E746F703D60247B742E797D7078607D292C';
wwv_flow_imp.g_varchar2_table(39846) := '5B612E63757272656E742C725D292C576C282828293D3E7B636F6E737420653D612E63757272656E743B65262628652E717565727953656C6563746F722822696E70757422297C7C65292E666F63757328297D292C5B5D292C486C282828293D3E7B636F';
wwv_flow_imp.g_varchar2_table(39847) := '6E737420653D653D3E7B69662822457363617065223D3D3D652E6B65792972657475726E20652E70726576656E7444656661756C7428292C7428297D2C6E3D653D3E7B69662821447428652E7461726765742C222E646A732D706F707570222C21302929';
wwv_flow_imp.g_varchar2_table(39848) := '72657475726E207428297D3B72657475726E20646F63756D656E742E646F63756D656E74456C656D656E742E6164644576656E744C697374656E657228226B6579646F776E222C65292C646F63756D656E742E626F64792E6164644576656E744C697374';
wwv_flow_imp.g_varchar2_table(39849) := '656E65722822636C69636B222C6E292C28293D3E7B646F63756D656E742E646F63756D656E74456C656D656E742E72656D6F76654576656E744C697374656E657228226B6579646F776E222C65292C646F63756D656E742E626F64792E72656D6F766545';
wwv_flow_imp.g_varchar2_table(39850) := '76656E744C697374656E65722822636C69636B222C6E297D7D292C5B5D292C546C600A202020203C6469760A202020202020636C6173733D247B65632822646A732D706F707570222C6F297D0A2020202020207374796C653D247B66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(39851) := '65297B72657475726E7B7472616E73666F726D3A607363616C6528247B652E7363616C657D29602C77696474683A60247B652E77696474687D7078602C227472616E73666F726D2D6F726967696E223A22746F70206C656674227D7D2865297D0A202020';
wwv_flow_imp.g_varchar2_table(39852) := '2020206F6E4B6579646F776E3D247B6E7D0A2020202020206F6E4B657975703D247B697D0A2020202020207265663D247B617D0A202020202020746162496E6465783D222D31220A202020203E0A202020202020247B737D0A202020203C2F6469763E0A';
wwv_flow_imp.g_varchar2_table(39853) := '2020607D7661722072633D5B22636F6E746578745061642E636C6F7365222C2263616E7661732E76696577626F782E6368616E67696E67222C22636F6D6D616E64537461636B2E6368616E676564225D3B66756E6374696F6E20616328652C742C6E297B';
wwv_flow_imp.g_varchar2_table(39854) := '746869732E5F6576656E744275733D742C746869732E5F63616E7661733D6E2C746869732E5F63757272656E743D6E756C6C3B766172206F3D28302C692E4F392928652626652E7363616C65293F652E7363616C653A7B6D696E3A312C6D61783A317D3B';
wwv_flow_imp.g_varchar2_table(39855) := '746869732E5F636F6E6669673D7B7363616C653A6F7D2C742E6F6E28226469616772616D2E64657374726F79222C2828293D3E7B746869732E636C6F736528297D29292C742E6F6E2822656C656D656E742E6368616E676564222C28653D3E7B636F6E73';
wwv_flow_imp.g_varchar2_table(39856) := '7420743D746869732E69734F70656E28292626746869732E5F63757272656E742E7461726765743B652E656C656D656E743D3D3D742626746869732E7265667265736828297D29297D61632E24696E6A6563743D5B22636F6E6669672E706F7075704D65';
wwv_flow_imp.g_varchar2_table(39857) := '6E75222C226576656E74427573222C2263616E766173225D2C61632E70726F746F747970652E5F72656E6465723D66756E6374696F6E28297B636F6E73747B706F736974696F6E3A652C70726F766964657249643A742C656E74726965733A6E2C686561';
wwv_flow_imp.g_varchar2_table(39858) := '646572456E74726965733A692C656D707479506C616365686F6C6465723A6F2C6F7074696F6E733A737D3D746869732E5F63757272656E742C723D4F626A6563742E656E7472696573286E292E6D61702828285B652C745D293D3E287B69643A652C2E2E';
wwv_flow_imp.g_varchar2_table(39859) := '2E747D2929292C613D4F626A6563742E656E74726965732869292E6D61702828285B652C745D293D3E287B69643A652C2E2E2E747D2929292C6C3D65262628743D3E746869732E5F656E7375726556697369626C6528742C6529292C633D746869732E5F';
wwv_flow_imp.g_varchar2_table(39860) := '7570646174655363616C6528746869732E5F63757272656E742E636F6E7461696E6572293B436C28546C600A2020202020203C247B6F637D0A20202020202020206F6E436C6F73653D247B653D3E746869732E636C6F73652865297D0A20202020202020';
wwv_flow_imp.g_varchar2_table(39861) := '206F6E53656C6563743D247B28652C742C6E293D3E746869732E7472696767657228652C742C6E297D0A2020202020202020706F736974696F6E3D247B6C7D0A2020202020202020636C6173734E616D653D247B747D0A2020202020202020656E747269';
wwv_flow_imp.g_varchar2_table(39862) := '65733D247B727D0A2020202020202020686561646572456E74726965733D247B617D0A2020202020202020656D707479506C616365686F6C6465723D247B6F7D0A20202020202020207363616C653D247B637D0A20202020202020206F6E4F70656E6564';
wwv_flow_imp.g_varchar2_table(39863) := '3D247B746869732E5F6F6E4F70656E65642E62696E642874686973297D0A20202020202020206F6E436C6F7365643D247B746869732E5F6F6E436C6F7365642E62696E642874686973297D0A20202020202020202E2E2E247B7B2E2E2E737D7D0A202020';
wwv_flow_imp.g_varchar2_table(39864) := '2020202F3E0A20202020602C746869732E5F63757272656E742E636F6E7461696E6572297D2C61632E70726F746F747970652E6F70656E3D66756E6374696F6E28652C742C6E2C69297B6966282165297468726F77206E6577204572726F722822746172';
wwv_flow_imp.g_varchar2_table(39865) := '676574206973206D697373696E6722293B6966282174297468726F77206E6577204572726F72282270726F76696465727320666F72203C222B742B223E206E6F7420666F756E6422293B696628216E297468726F77206E6577204572726F722822706F73';
wwv_flow_imp.g_varchar2_table(39866) := '6974696F6E206973206D697373696E6722293B746869732E69734F70656E28292626746869732E636C6F736528293B636F6E73747B656E74726965733A6F2C686561646572456E74726965733A732C656D707479506C616365686F6C6465723A727D3D74';
wwv_flow_imp.g_varchar2_table(39867) := '6869732E5F676574436F6E7465787428652C74293B746869732E5F63757272656E743D7B706F736974696F6E3A6E2C70726F766964657249643A742C7461726765743A652C656E74726965733A6F2C686561646572456E74726965733A732C656D707479';
wwv_flow_imp.g_varchar2_table(39868) := '506C616365686F6C6465723A722C636F6E7461696E65723A746869732E5F637265617465436F6E7461696E6572287B70726F76696465723A747D292C6F7074696F6E733A697D2C746869732E5F656D697428226F70656E22292C746869732E5F62696E64';
wwv_flow_imp.g_varchar2_table(39869) := '4175746F436C6F736528292C746869732E5F72656E64657228297D2C61632E70726F746F747970652E726566726573683D66756E6374696F6E28297B69662821746869732E69734F70656E28292972657475726E3B636F6E73747B7461726765743A652C';
wwv_flow_imp.g_varchar2_table(39870) := '70726F766964657249643A747D3D746869732E5F63757272656E742C7B656E74726965733A6E2C686561646572456E74726965733A692C656D707479506C616365686F6C6465723A6F7D3D746869732E5F676574436F6E7465787428652C74293B746869';
wwv_flow_imp.g_varchar2_table(39871) := '732E5F63757272656E743D7B2E2E2E746869732E5F63757272656E742C656E74726965733A6E2C686561646572456E74726965733A692C656D707479506C616365686F6C6465723A6F7D2C746869732E5F656D697428227265667265736822292C746869';
wwv_flow_imp.g_varchar2_table(39872) := '732E5F72656E64657228297D2C61632E70726F746F747970652E5F676574436F6E746578743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F67657450726F7669646572732874293B696628216E7C7C216E2E6C656E6774682974';
wwv_flow_imp.g_varchar2_table(39873) := '68726F77206E6577204572726F72282270726F766964657220666F72203C222B742B223E206E6F7420666F756E6422293B636F6E737420693D746869732E5F676574456E747269657328652C6E292C6F3D746869732E5F676574486561646572456E7472';
wwv_flow_imp.g_varchar2_table(39874) := '69657328652C6E293B72657475726E7B656E74726965733A692C686561646572456E74726965733A6F2C656D707479506C616365686F6C6465723A746869732E5F676574456D707479506C616365686F6C646572286E292C656D7074793A21284F626A65';
wwv_flow_imp.g_varchar2_table(39875) := '63742E6B6579732869292E6C656E6774687C7C4F626A6563742E6B657973286F292E6C656E677468297D7D2C61632E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E69734F70656E2829262628746869732E5F656D6974';
wwv_flow_imp.g_varchar2_table(39876) := '2822636C6F736522292C746869732E726573657428292C746869732E5F63757272656E743D6E756C6C297D2C61632E70726F746F747970652E72657365743D66756E6374696F6E28297B636F6E737420653D746869732E5F63757272656E742E636F6E74';
wwv_flow_imp.g_varchar2_table(39877) := '61696E65723B436C286E756C6C2C65292C24742865297D2C61632E70726F746F747970652E5F656D69743D66756E6374696F6E28652C74297B746869732E5F6576656E744275732E666972652860706F7075704D656E752E247B657D602C74297D2C6163';
wwv_flow_imp.g_varchar2_table(39878) := '2E70726F746F747970652E5F6F6E4F70656E65643D66756E6374696F6E28297B746869732E5F656D697428226F70656E656422297D2C61632E70726F746F747970652E5F6F6E436C6F7365643D66756E6374696F6E28297B746869732E5F656D69742822';
wwv_flow_imp.g_varchar2_table(39879) := '636C6F73656422297D2C61632E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732E676574436F6E7461696E657228293B636F6E7374206E3D487428603C64';
wwv_flow_imp.g_varchar2_table(39880) := '697620636C6173733D22646A732D706F7075702D706172656E7420646A732D7363726F6C6C61626C652220646174612D706F7075703D247B652E70726F76696465727D3E3C2F6469763E60293B72657475726E20742E617070656E644368696C64286E29';
wwv_flow_imp.g_varchar2_table(39881) := '2C6E7D2C61632E70726F746F747970652E5F62696E644175746F436C6F73653D66756E6374696F6E28297B746869732E5F6576656E744275732E6F6E63652872632C746869732E636C6F73652C74686973297D2C61632E70726F746F747970652E5F756E';
wwv_flow_imp.g_varchar2_table(39882) := '62696E644175746F436C6F73653D66756E6374696F6E28297B746869732E5F6576656E744275732E6F66662872632C746869732E636C6F73652C74686973297D2C61632E70726F746F747970652E5F7570646174655363616C653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(39883) := '297B76617220652C742C6E3D746869732E5F63616E7661732E7A6F6F6D28292C6F3D746869732E5F636F6E6669672E7363616C652C733D6E3B72657475726E2130213D3D6F26262821313D3D3D6F3F28653D312C743D31293A28653D6F2E6D696E2C743D';
wwv_flow_imp.g_varchar2_table(39884) := '6F2E6D6178292C28302C692E4F392928652926266E3C65262628733D65292C28302C692E4F392928742926266E3E74262628733D7429292C737D2C61632E70726F746F747970652E5F656E7375726556697369626C653D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(39885) := '7B766172206E3D646F63756D656E742E646F63756D656E74456C656D656E742E676574426F756E64696E67436C69656E745265637428292C693D652E676574426F756E64696E67436C69656E745265637428292C6F3D7B7D2C733D742E782C723D742E79';
wwv_flow_imp.g_varchar2_table(39886) := '3B72657475726E20742E782B692E77696474683E6E2E77696474682626286F2E783D2130292C742E792B692E6865696768743E6E2E6865696768742626286F2E793D2130292C6F2E7826266F2E793F28733D742E782D692E77696474682C723D742E792D';
wwv_flow_imp.g_varchar2_table(39887) := '692E686569676874293A6F2E783F28733D742E782D692E77696474682C723D742E79293A6F2E792626742E793C692E6865696768743F28733D742E782C723D3130293A6F2E79262628733D742E782C723D742E792D692E686569676874292C742E793C6E';
wwv_flow_imp.g_varchar2_table(39888) := '2E746F70262628723D742E792B692E686569676874292C7B783A732C793A727D7D2C61632E70726F746F747970652E6973456D7074793D66756E6374696F6E28652C74297B6966282165297468726F77206E6577204572726F7228227461726765742069';
wwv_flow_imp.g_varchar2_table(39889) := '73206D697373696E6722293B6966282174297468726F77206E6577204572726F72282270726F7669646572204944206973206D697373696E6722293B636F6E7374206E3D746869732E5F67657450726F7669646572732874293B72657475726E216E7C7C';
wwv_flow_imp.g_varchar2_table(39890) := '216E2E6C656E6774687C7C746869732E5F676574436F6E7465787428652C74292E656D7074797D2C61632E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E28652C742C6E297B6E7C7C286E3D742C743D31653329';
wwv_flow_imp.g_varchar2_table(39891) := '2C746869732E5F6576656E744275732E6F6E2822706F7075704D656E752E67657450726F7669646572732E222B652C742C2866756E6374696F6E2865297B652E70726F7669646572732E70757368286E297D29297D2C61632E70726F746F747970652E5F';
wwv_flow_imp.g_varchar2_table(39892) := '67657450726F7669646572733D66756E6374696F6E2865297B76617220743D746869732E5F6576656E744275732E6372656174654576656E74287B747970653A22706F7075704D656E752E67657450726F7669646572732E222B652C70726F7669646572';
wwv_flow_imp.g_varchar2_table(39893) := '733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E666972652874292C742E70726F7669646572737D2C61632E70726F746F747970652E5F676574456E74726965733D66756E6374696F6E28652C74297B766172206E3D7B7D3B7265';
wwv_flow_imp.g_varchar2_table(39894) := '7475726E28302C692E6A4A2928742C2866756E6374696F6E2874297B696628742E676574506F7075704D656E75456E7472696573297B766172206F3D742E676574506F7075704D656E75456E74726965732865293B28302C692E546E29286F293F6E3D6F';
wwv_flow_imp.g_varchar2_table(39895) := '286E293A28302C692E6A4A29286F2C2866756E6374696F6E28652C74297B6E5B745D3D657D29297D656C736528302C692E6A4A2928742E676574456E74726965732865292C2866756E6374696F6E2865297B76617220743D652E69643B69662821742974';
wwv_flow_imp.g_varchar2_table(39896) := '68726F77206E6577204572726F722822656E747279204944206973206D697373696E6722293B6E5B745D3D28302C692E634A2928652C5B226964225D297D29297D29292C6E7D2C61632E70726F746F747970652E5F676574486561646572456E74726965';
wwv_flow_imp.g_varchar2_table(39897) := '733D66756E6374696F6E28652C74297B766172206E3D7B7D3B72657475726E28302C692E6A4A2928742C2866756E6374696F6E2874297B696628742E676574506F7075704D656E75486561646572456E7472696573297B766172206F3D742E676574506F';
wwv_flow_imp.g_varchar2_table(39898) := '7075704D656E75486561646572456E74726965732865293B28302C692E546E29286F293F6E3D6F286E293A28302C692E6A4A29286F2C2866756E6374696F6E28652C74297B6E5B745D3D657D29297D656C73657B69662821742E67657448656164657245';
wwv_flow_imp.g_varchar2_table(39899) := '6E74726965732972657475726E3B28302C692E6A4A2928742E676574486561646572456E74726965732865292C2866756E6374696F6E2865297B76617220743D652E69643B6966282174297468726F77206E6577204572726F722822656E747279204944';
wwv_flow_imp.g_varchar2_table(39900) := '206973206D697373696E6722293B6E5B745D3D28302C692E634A2928652C5B226964225D297D29297D7D29292C6E7D2C61632E70726F746F747970652E5F676574456D707479506C616365686F6C6465723D66756E6374696F6E2865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(39901) := '743D652E66696E642828653D3E28302C692E546E2928652E676574456D707479506C616365686F6C6465722929293B72657475726E20742626742E676574456D707479506C616365686F6C64657228297D2C61632E70726F746F747970652E69734F7065';
wwv_flow_imp.g_varchar2_table(39902) := '6E3D66756E6374696F6E28297B72657475726E2121746869732E5F63757272656E747D2C61632E70726F746F747970652E747269676765723D66756E6374696F6E28652C742C6E3D22636C69636B22297B696628652E70726576656E7444656661756C74';
wwv_flow_imp.g_varchar2_table(39903) := '28292C2174297B6C6574206E3D537428447428652E64656C65676174655461726765747C7C652E7461726765742C222E656E747279222C2130292C22646174612D696422293B743D7B69643A6E2C2E2E2E746869732E5F676574456E747279286E297D7D';
wwv_flow_imp.g_varchar2_table(39904) := '636F6E7374206F3D742E616374696F6E3B6966282131213D3D746869732E5F656D6974282274726967676572222C7B656E7472793A742C6576656E743A657D292969662828302C692E546E29286F29297B69662822636C69636B223D3D3D6E2972657475';
wwv_flow_imp.g_varchar2_table(39905) := '726E206F28652C74297D656C7365206966286F5B6E5D2972657475726E206F5B6E5D28652C74297D2C61632E70726F746F747970652E5F676574456E7472793D66756E6374696F6E2865297B76617220743D746869732E5F63757272656E742E656E7472';
wwv_flow_imp.g_varchar2_table(39906) := '6965735B655D7C7C746869732E5F63757272656E742E686561646572456E74726965735B655D3B6966282174297468726F77206E6577204572726F722822656E747279206E6F7420666F756E6422293B72657475726E20747D3B636F6E7374206C633D7B';
wwv_flow_imp.g_varchar2_table(39907) := '5F5F696E69745F5F3A5B22706F7075704D656E75225D2C706F7075704D656E753A5B2274797065222C61635D7D2C63633D7B616C69676E3A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220766965';
wwv_flow_imp.g_varchar2_table(39908) := '77426F783D2230203020323030302032303030223E5C6E20202020202020202020202020203C6C696E652078313D22323030222079313D22313530222078323D22323030222079323D223138353022207374796C653D227374726F6B653A63757272656E';
wwv_flow_imp.g_varchar2_table(39909) := '74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E20202020202020202020202020203C7265637420783D223530302220793D22313530222077696474683D2231333030222068';
wwv_flow_imp.g_varchar2_table(39910) := '65696768743D22373030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E20202020202020202020202020203C72';
wwv_flow_imp.g_varchar2_table(39911) := '65637420783D223530302220793D2231313530222077696474683D2237303022206865696768743D22373030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B7374';
wwv_flow_imp.g_varchar2_table(39912) := '726F6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E272C626F74746F6D3A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376';
wwv_flow_imp.g_varchar2_table(39913) := '67222076696577426F783D2230203020313830302031383030223E5C6E2020202020202020202020203C6C696E652078313D22313530222079313D2231363530222078323D2231363530222079323D223136353022207374796C653D227374726F6B653A';
wwv_flow_imp.g_varchar2_table(39914) := '63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E2020202020202020202020203C7265637420783D223135302220793D22333530222077696474683D22363030';
wwv_flow_imp.g_varchar2_table(39915) := '22206865696768743D2231333030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E202020202020202020202020';
wwv_flow_imp.g_varchar2_table(39916) := '3C7265637420783D22313035302220793D22383530222077696474683D2236303022206865696768743D22383030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B';
wwv_flow_imp.g_varchar2_table(39917) := '7374726F6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E272C63656E7465723A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F';
wwv_flow_imp.g_varchar2_table(39918) := '737667222076696577426F783D2230203020313830302031383030223E5C6E2020202020202020202020203C6C696E652078313D22393030222079313D22313530222078323D22393030222079323D223136353022207374796C653D227374726F6B653A';
wwv_flow_imp.g_varchar2_table(39919) := '63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E2020202020202020202020203C7265637420783D223235302220793D22313530222077696474683D22313330';
wwv_flow_imp.g_varchar2_table(39920) := '3022206865696768743D22363030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E202020202020202020202020';
wwv_flow_imp.g_varchar2_table(39921) := '3C7265637420783D223530302220793D2231303530222077696474683D2238303022206865696768743D22363030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B';
wwv_flow_imp.g_varchar2_table(39922) := '7374726F6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E272C6C6566743A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376';
wwv_flow_imp.g_varchar2_table(39923) := '67222076696577426F783D2230203020313830302031383030223E5C6E2020202020202020202020203C6C696E652078313D22313030222079313D22313530222078323D22313030222079323D223136353022207374796C653D227374726F6B653A6375';
wwv_flow_imp.g_varchar2_table(39924) := '7272656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E2020202020202020202020203C7265637420783D223130302220793D22313530222077696474683D223133303022';
wwv_flow_imp.g_varchar2_table(39925) := '206865696768743D22363030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E2020202020202020202020203C72';
wwv_flow_imp.g_varchar2_table(39926) := '65637420783D223130302220793D2231303530222077696474683D2238303022206865696768743D22363030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B7374';
wwv_flow_imp.g_varchar2_table(39927) := '726F6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E272C72696768743A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667';
wwv_flow_imp.g_varchar2_table(39928) := '222076696577426F783D2230203020313830302031383030223E5C6E2020202020202020202020203C6C696E652078313D2231363530222079313D22313530222078323D2231363530222079323D223136353022207374796C653D227374726F6B653A63';
wwv_flow_imp.g_varchar2_table(39929) := '757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E2020202020202020202020203C7265637420783D223335302220793D22313530222077696474683D2231333030';
wwv_flow_imp.g_varchar2_table(39930) := '22206865696768743D22363030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E2020202020202020202020203C';
wwv_flow_imp.g_varchar2_table(39931) := '7265637420783D223835302220793D2231303530222077696474683D2238303022206865696768743D22363030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B73';
wwv_flow_imp.g_varchar2_table(39932) := '74726F6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E272C746F703A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F73766722';
wwv_flow_imp.g_varchar2_table(39933) := '2076696577426F783D2230203020313830302031383030223E5C6E2020202020202020202020203C6C696E652078313D22313530222079313D22313530222078323D2231363530222079323D2231353022207374796C653D227374726F6B653A63757272';
wwv_flow_imp.g_varchar2_table(39934) := '656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E2020202020202020202020203C7265637420783D223135302220793D22313530222077696474683D2236303022206865';
wwv_flow_imp.g_varchar2_table(39935) := '696768743D2231333030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E2020202020202020202020203C726563';
wwv_flow_imp.g_varchar2_table(39936) := '7420783D22313035302220793D22313530222077696474683D2236303022206865696768743D22383030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B7374726F';
wwv_flow_imp.g_varchar2_table(39937) := '6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E272C6D6964646C653A273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F73766722';
wwv_flow_imp.g_varchar2_table(39938) := '2076696577426F783D2230203020313830302031383030223E5C6E2020202020202020202020203C6C696E652078313D22313530222079313D22393030222078323D2231363530222079323D2239303022207374796C653D227374726F6B653A63757272';
wwv_flow_imp.g_varchar2_table(39939) := '656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656361703A726F756E643B222F3E5C6E2020202020202020202020203C7265637420783D223135302220793D22323530222077696474683D2236303022206865';
wwv_flow_imp.g_varchar2_table(39940) := '696768743D2231333030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E2020202020202020202020203C726563';
wwv_flow_imp.g_varchar2_table(39941) := '7420783D22313035302220793D22353030222077696474683D2236303022206865696768743D22383030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B7374726F';
wwv_flow_imp.g_varchar2_table(39942) := '6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E202020202020202020203C2F7376673E277D3B66756E6374696F6E20646328652C742C6E2C69297B652E726567697374657250726F7669646572283930302C7468';
wwv_flow_imp.g_varchar2_table(39943) := '6973292C746869732E5F636F6E746578745061643D652C746869732E5F706F7075704D656E753D742C746869732E5F7472616E736C6174653D6E2C746869732E5F63616E7661733D697D64632E24696E6A6563743D5B22636F6E74657874506164222C22';
wwv_flow_imp.g_varchar2_table(39944) := '706F7075704D656E75222C227472616E736C617465222C2263616E766173225D2C64632E70726F746F747970652E6765744D756C7469456C656D656E74436F6E74657874506164456E74726965733D66756E6374696F6E2865297B76617220743D7B7D3B';
wwv_flow_imp.g_varchar2_table(39945) := '72657475726E20746869732E5F6973416C6C6F776564286529262628302C692E6B702928742C746869732E5F676574456E7472696573286529292C747D2C64632E70726F746F747970652E5F6973416C6C6F7765643D66756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(39946) := '7475726E21746869732E5F706F7075704D656E752E6973456D70747928652C22616C69676E2D656C656D656E747322297D2C64632E70726F746F747970652E5F676574456E74726965733D66756E6374696F6E28297B76617220653D746869733B726574';
wwv_flow_imp.g_varchar2_table(39947) := '75726E7B22616C69676E2D656C656D656E7473223A7B67726F75703A22616C69676E2D656C656D656E7473222C7469746C653A652E5F7472616E736C6174652822416C69676E20656C656D656E747322292C68746D6C3A603C64697620636C6173733D22';
wwv_flow_imp.g_varchar2_table(39948) := '656E747279223E247B63632E616C69676E7D3C2F6469763E602C616374696F6E3A7B636C69636B3A66756E6374696F6E28742C6E297B766172206F3D652E5F6765744D656E75506F736974696F6E286E293B28302C692E6B7029286F2C7B637572736F72';
wwv_flow_imp.g_varchar2_table(39949) := '3A7B783A742E782C793A742E797D7D292C652E5F706F7075704D656E752E6F70656E286E2C22616C69676E2D656C656D656E7473222C6F297D7D7D7D7D2C64632E70726F746F747970652E5F6765744D656E75506F736974696F6E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(39950) := '2865297B76617220743D746869732E5F636F6E746578745061642E6765745061642865292E68746D6C2E676574426F756E64696E67436C69656E745265637428293B72657475726E7B783A742E6C6566742C793A742E626F74746F6D2B357D7D3B766172';
wwv_flow_imp.g_varchar2_table(39951) := '2068633D5B226C656674222C2263656E746572222C227269676874222C22746F70222C226D6964646C65222C22626F74746F6D225D3B66756E6374696F6E20756328652C742C6E2C69297B746869732E5F616C69676E456C656D656E74733D742C746869';
wwv_flow_imp.g_varchar2_table(39952) := '732E5F7472616E736C6174653D6E2C746869732E5F706F7075704D656E753D652C746869732E5F72756C65733D692C652E726567697374657250726F76696465722822616C69676E2D656C656D656E7473222C74686973297D66756E6374696F6E207063';
wwv_flow_imp.g_varchar2_table(39953) := '2865297B65722E63616C6C28746869732C65292C746869732E696E697428297D66756E6374696F6E2067632865297B70632E63616C6C28746869732C65297D75632E24696E6A6563743D5B22706F7075704D656E75222C22616C69676E456C656D656E74';
wwv_flow_imp.g_varchar2_table(39954) := '73222C227472616E736C617465222C2272756C6573225D2C75632E70726F746F747970652E676574506F7075704D656E75456E74726965733D66756E6374696F6E2865297B76617220743D7B7D3B72657475726E20746869732E5F6973416C6C6F776564';
wwv_flow_imp.g_varchar2_table(39955) := '286529262628302C692E6B702928742C746869732E5F676574456E7472696573286529292C747D2C75632E70726F746F747970652E5F6973416C6C6F7765643D66756E6374696F6E2865297B72657475726E20746869732E5F72756C65732E616C6C6F77';
wwv_flow_imp.g_varchar2_table(39956) := '65642822656C656D656E74732E616C69676E222C7B656C656D656E74733A657D297D2C75632E70726F746F747970652E5F676574456E74726965733D66756E6374696F6E2865297B76617220743D746869732E5F616C69676E456C656D656E74732C6E3D';
wwv_flow_imp.g_varchar2_table(39957) := '746869732E5F7472616E736C6174652C6F3D746869732E5F706F7075704D656E752C733D7B7D3B72657475726E28302C692E6A4A292868632C2866756E6374696F6E2869297B735B22616C69676E2D656C656D656E74732D222B695D3D7B67726F75703A';
wwv_flow_imp.g_varchar2_table(39958) := '22616C69676E222C7469746C653A6E2822416C69676E20656C656D656E747320222B69292C636C6173734E616D653A22626A732D616C69676E2D656C656D656E74732D6D656E752D656E747279222C696D61676548746D6C3A63635B695D2C616374696F';
wwv_flow_imp.g_varchar2_table(39959) := '6E3A66756E6374696F6E28297B742E7472696767657228652C69292C6F2E636C6F736528297D7D7D29292C737D2C70632E24696E6A6563743D5B226576656E74427573225D2C522870632C6572292C70632E70726F746F747970652E61646452756C653D';
wwv_flow_imp.g_varchar2_table(39960) := '66756E6374696F6E28652C742C6E297B76617220693D746869733B22737472696E67223D3D747970656F662065262628653D5B655D292C652E666F7245616368282866756E6374696F6E2865297B692E63616E4578656375746528652C742C2866756E63';
wwv_flow_imp.g_varchar2_table(39961) := '74696F6E28652C742C69297B72657475726E206E2865297D292C2130297D29297D2C70632E70726F746F747970652E696E69743D66756E6374696F6E28297B7D2C67632E24696E6A6563743D5B226576656E74427573225D2C522867632C7063292C6763';
wwv_flow_imp.g_varchar2_table(39962) := '2E70726F746F747970652E696E69743D66756E6374696F6E28297B746869732E61646452756C652822656C656D656E74732E616C69676E222C2866756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D28302C692E70622928742C';
wwv_flow_imp.g_varchar2_table(39963) := '2866756E6374696F6E2865297B72657475726E2128652E776179706F696E74737C7C652E686F73747C7C652E6C6162656C546172676574297D29293B72657475726E2128286E3D6F74286E29292E6C656E6774683C322926266E7D29297D3B636F6E7374';
wwv_flow_imp.g_varchar2_table(39964) := '206D633D7B5F5F646570656E64735F5F3A5B41612C42612C6C635D2C5F5F696E69745F5F3A5B22616C69676E456C656D656E7473436F6E7465787450616450726F7669646572222C22616C69676E456C656D656E74734D656E7550726F7669646572222C';
wwv_flow_imp.g_varchar2_table(39965) := '2262706D6E416C69676E456C656D656E7473225D2C616C69676E456C656D656E7473436F6E7465787450616450726F76696465723A5B2274797065222C64635D2C616C69676E456C656D656E74734D656E7550726F76696465723A5B2274797065222C75';
wwv_flow_imp.g_varchar2_table(39966) := '635D2C62706D6E416C69676E456C656D656E74733A5B2274797065222C67635D7D3B7661722066633D31302C76633D35302C62633D3235303B66756E6374696F6E205F6328652C742C6E2C69297B666F7228766172206F3B6F3D776328652C6E2C74293B';
wwv_flow_imp.g_varchar2_table(39967) := '296E3D6928742C6E2C6F293B72657475726E206E7D66756E6374696F6E2079632865297B72657475726E2066756E6374696F6E28742C6E2C69297B766172206F3D7B783A6E2E782C793A6E2E797D3B72657475726E5B2278222C2279225D2E666F724561';
wwv_flow_imp.g_varchar2_table(39968) := '6368282866756E6374696F6E2873297B76617220723D655B735D3B69662872297B76617220613D2278223D3D3D733F227769647468223A22686569676874222C6C3D722E6D617267696E2C633D722E6D696E44697374616E63653B6F5B735D3D6C3C303F';
wwv_flow_imp.g_varchar2_table(39969) := '4D6174682E6D696E28695B735D2B6C2D745B615D2F322C6E5B735D2D632B6C293A4D6174682E6D617828695B735D2B695B615D2B6C2B745B615D2F322C6E5B735D2B632B6C297D7D29292C6F7D7D66756E6374696F6E20776328652C742C6E297B766172';
wwv_flow_imp.g_varchar2_table(39970) := '206F3D7B783A742E782D6E2E77696474682F322C793A742E792D6E2E6865696768742F322C77696474683A6E2E77696474682C6865696768743A6E2E6865696768747D2C733D66756E6374696F6E2865297B76617220743D43632865293B72657475726E';
wwv_flow_imp.g_varchar2_table(39971) := '20652E686F7374262628743D742E636F6E63617428436328652E686F73742929292C652E617474616368657273262628743D742E636F6E63617428652E6174746163686572732E726564756365282866756E6374696F6E28652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(39972) := '652E636F6E636174284363287429297D292C5B5D2929292C747D2865293B72657475726E28302C692E49362928732C2866756E6374696F6E2865297B72657475726E2065213D3D6E262622696E74657273656374223D3D3D576E28652C6F2C6663297D29';
wwv_flow_imp.g_varchar2_table(39973) := '297D66756E6374696F6E2043632865297B72657475726E28743D652C742E6F7574676F696E672E6D6170282866756E6374696F6E2865297B72657475726E20652E7461726765747D2929292E636F6E6361742866756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(39974) := '6E20652E696E636F6D696E672E6D6170282866756E6374696F6E2865297B72657475726E20652E736F757263657D29297D286529293B76617220747D66756E6374696F6E20536328297B72657475726E21307D66756E6374696F6E20786328652C742C6E';
wwv_flow_imp.g_varchar2_table(39975) := '297B652E6F6E28226175746F506C616365222C3130302C2866756E6374696F6E2865297B76617220743D652E73686170653B72657475726E2066756E6374696F6E28652C742C6E297B6E7C7C286E3D7B7D293B76617220693D6E2E64656661756C744469';
wwv_flow_imp.g_varchar2_table(39976) := '7374616E63657C7C76632C6F3D486E2865293B72657475726E7B783A566E2865292E72696768742B692B742E77696474682F322C793A6F2E797D7D28652E736F757263652C74297D29292C652E6F6E28226175746F506C6163652E656E64222C2866756E';
wwv_flow_imp.g_varchar2_table(39977) := '6374696F6E2865297B6E2E7363726F6C6C546F456C656D656E7428652E7368617065297D29292C746869732E617070656E643D66756E6374696F6E286E2C692C6F297B652E6669726528226175746F506C6163652E7374617274222C7B736F757263653A';
wwv_flow_imp.g_varchar2_table(39978) := '6E2C73686170653A697D293B76617220733D652E6669726528226175746F506C616365222C7B736F757263653A6E2C73686170653A697D292C723D742E617070656E645368617065286E2C692C732C6E2E706172656E742C6F293B72657475726E20652E';
wwv_flow_imp.g_varchar2_table(39979) := '6669726528226175746F506C6163652E656E64222C7B736F757263653A6E2C73686170653A727D292C727D7D66756E6374696F6E206B6328652C74297B652E6F6E28226175746F506C6163652E656E64222C3530302C2866756E6374696F6E2865297B74';
wwv_flow_imp.g_varchar2_table(39980) := '2E73656C65637428652E7368617065297D29297D78632E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67222C2263616E766173225D2C6B632E24696E6A6563743D5B226576656E74427573222C2273656C656374696F6E225D3B';
wwv_flow_imp.g_varchar2_table(39981) := '636F6E73742045633D7B5F5F696E69745F5F3A5B226175746F506C61636553656C656374696F6E4265686176696F72225D2C6175746F506C6163653A5B2274797065222C78635D2C6175746F506C61636553656C656374696F6E4265686176696F723A5B';
wwv_flow_imp.g_varchar2_table(39982) := '2274797065222C6B635D7D3B766172204C633D6F2839383832293B66756E6374696F6E20446328652C74297B72657475726E28302C792E69732928742C2262706D6E3A54657874416E6E6F746174696F6E22293F66756E6374696F6E28652C74297B7661';
wwv_flow_imp.g_varchar2_table(39983) := '72206E3D566E2865292C693D28302C4C632E6973446972656374696F6E486F72697A6F6E74616C292865292C6F3D693F7B783A6E2E72696768742B742E77696474682F322C793A6E2E746F702D35302D742E6865696768742F327D3A7B783A6E2E726967';
wwv_flow_imp.g_varchar2_table(39984) := '68742B35302B742E77696474682F322C793A6E2E626F74746F6D2B742E6865696768742F327D3B4F6E2865292626286F3D486E2865292C693F286F2E782B3D3130302C6F2E792D3D3530293A286F2E782B3D3130302C6F2E792B3D353029293B76617220';
wwv_flow_imp.g_varchar2_table(39985) := '733D7B6D617267696E3A693F2D33303A33302C6D696E44697374616E63653A32307D3B72657475726E205F6328652C742C6F2C796328693F7B793A737D3A7B783A737D29297D28652C74293A28302C792E6973416E792928742C5B2262706D6E3A446174';
wwv_flow_imp.g_varchar2_table(39986) := '614F626A6563745265666572656E6365222C2262706D6E3A4461746153746F72655265666572656E6365225D293F66756E6374696F6E28652C74297B766172206E3D566E2865292C693D28302C4C632E6973446972656374696F6E486F72697A6F6E7461';
wwv_flow_imp.g_varchar2_table(39987) := '6C292865292C6F3D7B6D617267696E3A33302C6D696E44697374616E63653A33307D3B72657475726E205F6328652C742C693F7B783A6E2E72696768742D31302B742E77696474682F322C793A6E2E626F74746F6D2B34302B742E77696474682F327D3A';
wwv_flow_imp.g_varchar2_table(39988) := '7B783A6E2E6C6566742D34302D742E77696474682F322C793A6E2E626F74746F6D2D31302B742E6865696768742F327D2C796328693F7B783A6F7D3A7B793A6F7D29297D28652C74293A28302C792E69732928742C2262706D6E3A466C6F774E6F646522';
wwv_flow_imp.g_varchar2_table(39989) := '293F66756E6374696F6E28652C74297B766172206E3D566E2865292C6F3D486E2865292C733D28302C4C632E6973446972656374696F6E486F72697A6F6E74616C292865292C723D733F7B646972656374696F6E48696E743A2265222C6D696E44697374';
wwv_flow_imp.g_varchar2_table(39990) := '616E63653A38302C626173654F7269656E746174696F6E3A226C656674222C626F756E646172794F7269656E746174696F6E3A22746F70222C73746172743A22746F70222C656E643A22626F74746F6D227D3A7B646972656374696F6E48696E743A2273';
wwv_flow_imp.g_varchar2_table(39991) := '222C6D696E44697374616E63653A39302C626173654F7269656E746174696F6E3A22746F70222C626F756E646172794F7269656E746174696F6E3A226C656674222C73746172743A226C656674222C656E643A227269676874227D2C613D66756E637469';
wwv_flow_imp.g_varchar2_table(39992) := '6F6E28652C74297B747C7C28743D7B7D293B766172206E3D742E64656661756C7444697374616E63657C7C76632C6F3D742E646972656374696F6E7C7C2265222C733D742E66696C7465722C723D742E6765745765696768747C7C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(39993) := '74297B72657475726E20742E736F757263653D3D3D653F313A2D317D2C613D742E6D617844697374616E63657C7C62632C6C3D742E7265666572656E63657C7C227374617274223B66756E6374696F6E206328652C74297B72657475726E226E223D3D3D';
wwv_flow_imp.g_varchar2_table(39994) := '6F3F227374617274223D3D3D6C3F566E2865292E746F702D566E2874292E626F74746F6D3A2263656E746572223D3D3D6C3F566E2865292E746F702D486E2874292E793A566E2865292E746F702D566E2874292E746F703A2277223D3D3D6F3F22737461';
wwv_flow_imp.g_varchar2_table(39995) := '7274223D3D3D6C3F566E2865292E6C6566742D566E2874292E72696768743A2263656E746572223D3D3D6C3F566E2865292E6C6566742D486E2874292E783A566E2865292E6C6566742D566E2874292E6C6566743A2273223D3D3D6F3F22737461727422';
wwv_flow_imp.g_varchar2_table(39996) := '3D3D3D6C3F566E2874292E746F702D566E2865292E626F74746F6D3A2263656E746572223D3D3D6C3F486E2874292E792D566E2865292E626F74746F6D3A566E2874292E626F74746F6D2D566E2865292E626F74746F6D3A227374617274223D3D3D6C3F';
wwv_flow_imp.g_varchar2_table(39997) := '566E2874292E6C6566742D566E2865292E72696768743A2263656E746572223D3D3D6C3F486E2874292E782D566E2865292E72696768743A566E2874292E72696768742D566E2865292E72696768747D737C7C28733D5363293B76617220643D652E696E';
wwv_flow_imp.g_varchar2_table(39998) := '636F6D696E672E66696C7465722873292E6D6170282866756E6374696F6E2874297B766172206E3D722874292C693D6E3C303F6328742E736F757263652C65293A6328652C742E736F75726365293B72657475726E7B69643A742E736F757263652E6964';
wwv_flow_imp.g_varchar2_table(39999) := '2C64697374616E63653A692C7765696768743A6E7D7D29292C683D652E6F7574676F696E672E66696C7465722873292E6D6170282866756E6374696F6E2874297B766172206E3D722874292C693D6E3E303F6328652C742E746172676574293A6328742E';
wwv_flow_imp.g_varchar2_table(40000) := '7461726765742C65293B72657475726E7B69643A742E7461726765742E69642C64697374616E63653A692C7765696768743A6E7D7D29292C753D642E636F6E6361742868292E726564756365282866756E6374696F6E28652C74297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(40001) := '5B742E69642B225F5F7765696768745F222B742E7765696768745D3D742C657D292C7B7D293B72657475726E28302C692E54532928752C2866756E6374696F6E28652C74297B766172206E3D742E64697374616E63652C693D742E7765696768743B7265';
wwv_flow_imp.g_varchar2_table(40002) := '7475726E206E3C307C7C6E3E617C7C28655B537472696E67286E295D7C7C28655B537472696E67286E295D3D30292C655B537472696E67286E295D2B3D312A692C2821652E64697374616E63657C7C655B652E64697374616E63655D3C655B537472696E';
wwv_flow_imp.g_varchar2_table(40003) := '67286E295D29262628652E64697374616E63653D6E29292C657D292C7B7D292E64697374616E63657C7C6E7D28652C7B66696C7465723A66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A53657175656E6365466C';
wwv_flow_imp.g_varchar2_table(40004) := '6F7722297D2C646972656374696F6E3A722E646972656374696F6E48696E747D292C6C3D33302C633D722E6D696E44697374616E63652C643D722E626173654F7269656E746174696F6E3B28302C792E69732928652C2262706D6E3A426F756E64617279';
wwv_flow_imp.g_varchar2_table(40005) := '4576656E74222926262D31213D3D28643D576E28652C652E686F73742C2D323529292E696E6465784F6628722E626F756E646172794F7269656E746174696F6E292626286C2A3D2D31293B76617220683D7B6D617267696E3A6C2C6D696E44697374616E';
wwv_flow_imp.g_varchar2_table(40006) := '63653A637D3B72657475726E205F6328652C742C733F7B783A6E2E72696768742B612B742E77696474682F322C793A6F2E792B546328642C632C72297D3A7B783A6F2E782B546328642C632C72292C793A6E2E626F74746F6D2B612B742E686569676874';
wwv_flow_imp.g_varchar2_table(40007) := '2F327D2C796328733F7B793A687D3A7B783A687D29297D28652C74293A766F696420307D66756E6374696F6E20546328652C742C6E297B72657475726E20652E696E636C75646573286E2E7374617274293F2D312A743A652E696E636C75646573286E2E';
wwv_flow_imp.g_varchar2_table(40008) := '656E64293F743A307D66756E6374696F6E2049632865297B652E6F6E28226175746F506C616365222C2866756E6374696F6E2865297B76617220743D652E73686170653B72657475726E20446328652E736F757263652C74297D29297D49632E24696E6A';
wwv_flow_imp.g_varchar2_table(40009) := '6563743D5B226576656E74427573225D3B636F6E7374204D633D7B5F5F646570656E64735F5F3A5B45635D2C5F5F696E69745F5F3A5B2262706D6E4175746F506C616365225D2C62706D6E4175746F506C6163653A5B2274797065222C49635D7D3B6675';
wwv_flow_imp.g_varchar2_table(40010) := '6E6374696F6E20416328652C742C6E2C6F297B65722E63616C6C28746869732C65292C746869732E5F656C656D656E7452656769737472793D742C746869732E5F6D6F64656C696E673D6E2C746869732E5F72756C65733D6F3B76617220733D74686973';
wwv_flow_imp.g_varchar2_table(40011) := '3B746869732E706F73744578656375746564285B2273686170652E637265617465225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E68696E74737C7C7B7D2C693D742E73686170652C6F3D742E706172656E747C';
wwv_flow_imp.g_varchar2_table(40012) := '7C742E6E6577506172656E743B2131213D3D6E2E6175746F526573697A652626732E5F657870616E64285B695D2C6F297D29292C746869732E706F73744578656375746564285B22656C656D656E74732E6D6F7665225D2C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(40013) := '7B76617220743D652E636F6E746578742C6E3D28302C692E4271292828302C692E7A752928742E636C6F737572652E746F704C6576656C29292C6F3D742E68696E74732C723D216F7C7C6F2E6175746F526573697A653B6966282131213D3D72297B7661';
wwv_flow_imp.g_varchar2_table(40014) := '7220613D28302C692E247A29286E2C2866756E6374696F6E2865297B72657475726E20652E706172656E742E69647D29293B28302C692E6A4A2928612C2866756E6374696F6E28652C74297B28302C692E637929287229262628653D652E66696C746572';
wwv_flow_imp.g_varchar2_table(40015) := '282866756E6374696F6E2865297B72657475726E28302C692E49362928722C28302C692E674829287B69643A652E69647D29297D2929292C732E5F657870616E6428652C74297D29297D7D29292C746869732E706F73744578656375746564285B227368';
wwv_flow_imp.g_varchar2_table(40016) := '6170652E746F67676C65436F6C6C61707365225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E68696E74732C693D742E73686170653B6E262621313D3D3D6E2E6175746F526573697A657C7C692E636F6C6C6170';
wwv_flow_imp.g_varchar2_table(40017) := '7365647C7C732E5F657870616E6428692E6368696C6472656E7C7C5B5D2C69297D29292C746869732E706F73744578656375746564285B2273686170652E726573697A65225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C';
wwv_flow_imp.g_varchar2_table(40018) := '6E3D742E68696E74732C693D742E73686170652C6F3D692E706172656E743B6E262621313D3D3D6E2E6175746F526573697A657C7C6F2626732E5F657870616E64285B695D2C6F297D29297D66756E6374696F6E204E632865297B652E696E766F6B6528';
wwv_flow_imp.g_varchar2_table(40019) := '41632C74686973297D66756E6374696F6E2050632865297B70632E63616C6C28746869732C65293B76617220743D746869733B746869732E61646452756C652822656C656D656E742E6175746F526573697A65222C2866756E6374696F6E2865297B7265';
wwv_flow_imp.g_varchar2_table(40020) := '7475726E20742E63616E526573697A6528652E656C656D656E74732C652E746172676574297D29297D66756E6374696F6E204F6328652C74297B50632E63616C6C28746869732C65292C746869732E5F6D6F64656C696E673D747D41632E24696E6A6563';
wwv_flow_imp.g_varchar2_table(40021) := '743D5B226576656E74427573222C22656C656D656E745265676973747279222C226D6F64656C696E67222C2272756C6573225D2C522841632C6572292C41632E70726F746F747970652E5F6765744F7074696D616C426F756E64733D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40022) := '28652C74297B766172206E3D746869732E6765744F66667365742874292C6F3D746869732E67657450616464696E672874292C733D566E286374286529292C723D566E2874292C613D7B7D3B72657475726E20732E746F702D722E746F703C6F2E746F70';
wwv_flow_imp.g_varchar2_table(40023) := '262628612E746F703D732E746F702D6E2E746F70292C732E6C6566742D722E6C6566743C6F2E6C656674262628612E6C6566743D732E6C6566742D6E2E6C656674292C722E72696768742D732E72696768743C6F2E7269676874262628612E7269676874';
wwv_flow_imp.g_varchar2_table(40024) := '3D732E72696768742B6E2E7269676874292C722E626F74746F6D2D732E626F74746F6D3C6F2E626F74746F6D262628612E626F74746F6D3D732E626F74746F6D2B6E2E626F74746F6D292C7A6E2828302C692E6B7029287B7D2C722C6129297D2C41632E';
wwv_flow_imp.g_varchar2_table(40025) := '70726F746F747970652E5F657870616E643D66756E6374696F6E28652C74297B69662822737472696E67223D3D747970656F662074262628743D746869732E5F656C656D656E7452656769737472792E676574287429292C746869732E5F72756C65732E';
wwv_flow_imp.g_varchar2_table(40026) := '616C6C6F7765642822656C656D656E742E6175746F526573697A65222C7B656C656D656E74733A652C7461726765743A747D29297B766172206E3D746869732E5F6765744F7074696D616C426F756E647328652C74293B69662866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(40027) := '2C74297B72657475726E20652E78213D3D742E787C7C652E79213D3D742E797C7C652E7769647468213D3D742E77696474687C7C652E686569676874213D3D742E6865696768747D286E2C7429297B766172206F3D66756E6374696F6E28652C74297B76';
wwv_flow_imp.g_varchar2_table(40028) := '6172206E3D22223B72657475726E20653D566E2865292C743D566E2874292C652E746F703E742E746F702626286E3D6E2E636F6E63617428226E2229292C652E72696768743C742E72696768742626286E3D6E2E636F6E6361742822772229292C652E62';
wwv_flow_imp.g_varchar2_table(40029) := '6F74746F6D3C742E626F74746F6D2626286E3D6E2E636F6E6361742822732229292C652E6C6566743E742E6C6566742626286E3D6E2E636F6E6361742822652229292C6E7D2828302C692E55702928742C5B2278222C2279222C227769647468222C2268';
wwv_flow_imp.g_varchar2_table(40030) := '6569676874225D292C6E293B746869732E726573697A6528742C6E2C7B6175746F526573697A653A6F7D293B76617220733D742E706172656E743B732626746869732E5F657870616E64285B745D2C73297D7D7D2C41632E70726F746F747970652E6765';
wwv_flow_imp.g_varchar2_table(40031) := '744F66667365743D66756E6374696F6E2865297B72657475726E7B746F703A36302C626F74746F6D3A36302C6C6566743A3130302C72696768743A3130307D7D2C41632E70726F746F747970652E67657450616464696E673D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(40032) := '7B72657475726E7B746F703A322C626F74746F6D3A322C6C6566743A31352C72696768743A31357D7D2C41632E70726F746F747970652E726573697A653D66756E6374696F6E28652C742C6E297B746869732E5F6D6F64656C696E672E726573697A6553';
wwv_flow_imp.g_varchar2_table(40033) := '6861706528652C742C6E756C6C2C6E297D2C4E632E24696E6A6563743D5B22696E6A6563746F72225D2C52284E632C4163292C4E632E70726F746F747970652E726573697A653D66756E6374696F6E28652C742C6E297B28302C792E69732928652C2262';
wwv_flow_imp.g_varchar2_table(40034) := '706D6E3A5061727469636970616E7422293F746869732E5F6D6F64656C696E672E726573697A654C616E6528652C742C6E756C6C2C6E293A746869732E5F6D6F64656C696E672E726573697A65536861706528652C742C6E756C6C2C6E297D2C50632E24';
wwv_flow_imp.g_varchar2_table(40035) := '696E6A6563743D5B226576656E74427573225D2C522850632C7063292C50632E70726F746F747970652E63616E526573697A653D66756E6374696F6E28652C74297B72657475726E21317D2C52284F632C5063292C4F632E24696E6A6563743D5B226576';
wwv_flow_imp.g_varchar2_table(40036) := '656E74427573222C226D6F64656C696E67225D2C4F632E70726F746F747970652E63616E526573697A653D66756E6374696F6E28652C74297B69662828302C792E69732928742E64692C2262706D6E64693A42504D4E506C616E6522292972657475726E';
wwv_flow_imp.g_varchar2_table(40037) := '21313B6966282128302C792E69732928742C2262706D6E3A5061727469636970616E74222926262128302C792E69732928742C2262706D6E3A4C616E65222926262128302C792E69732928742C2262706D6E3A53756250726F6365737322292972657475';
wwv_flow_imp.g_varchar2_table(40038) := '726E21313B766172206E3D21303B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B2828302C792E69732928652C2262706D6E3A4C616E6522297C7C526E286529292626286E3D2131297D29292C6E7D3B636F6E73742052633D';
wwv_flow_imp.g_varchar2_table(40039) := '7B5F5F696E69745F5F3A5B2262706D6E4175746F526573697A65222C2262706D6E4175746F526573697A6550726F7669646572225D2C62706D6E4175746F526573697A653A5B2274797065222C4E635D2C62706D6E4175746F526573697A6550726F7669';
wwv_flow_imp.g_varchar2_table(40040) := '6465723A5B2274797065222C4F635D7D3B66756E6374696F6E20466328652C742C6E297B76617220692C6F2C733D746869732C723D6E2E67657428226472616767696E67222C2131293B722626742E6F6E2822647261672E7374617274222C2866756E63';
wwv_flow_imp.g_varchar2_table(40041) := '74696F6E286E297B742E6F6E63652822647261672E6D6F7665222C313530302C2866756E6374696F6E2874297B2166756E6374696F6E2874297B69662821742E686F766572297B766172206E3D742E6F726967696E616C4576656E742C693D732E5F6669';
wwv_flow_imp.g_varchar2_table(40042) := '6E64546172676574476678286E292C6F3D692626652E6765742869293B6926266F262628742E73746F7050726F7061676174696F6E28292C722E686F766572287B656C656D656E743A6F2C6766783A697D292C722E6D6F7665286E29297D7D2874297D29';
wwv_flow_imp.g_varchar2_table(40043) := '297D29292C742E6F6E2822656C656D656E742E686F766572222C2866756E6374696F6E2865297B693D652E6766782C6F3D652E656C656D656E747D29292C742E6F6E2822656C656D656E742E686F766572222C313530302C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(40044) := '7B6F2626742E666972652822656C656D656E742E6F7574222C7B656C656D656E743A6F2C6766783A697D297D29292C742E6F6E2822656C656D656E742E6F7574222C2866756E6374696F6E28297B693D6E756C6C2C6F3D6E756C6C7D29292C746869732E';
wwv_flow_imp.g_varchar2_table(40045) := '5F66696E645461726765744766783D66756E6374696F6E2865297B76617220743B6966286520696E7374616E63656F66204D6F7573654576656E742972657475726E20743D54722865292C447428646F63756D656E742E656C656D656E7446726F6D506F';
wwv_flow_imp.g_varchar2_table(40046) := '696E7428742E782C742E79292C227376672C202E646A732D656C656D656E74222C2130297D7D46632E24696E6A6563743D5B22656C656D656E745265676973747279222C226576656E74427573222C22696E6A6563746F72225D3B636F6E73742042633D';
wwv_flow_imp.g_varchar2_table(40047) := '7B5F5F696E69745F5F3A5B22686F766572466978225D2C686F7665724669783A5B2274797065222C46635D7D3B7661722056633D4D6174682E726F756E642C7A633D22646A732D647261672D616374697665223B66756E6374696F6E2048632865297B65';
wwv_flow_imp.g_varchar2_table(40048) := '2E70726576656E7444656661756C7428297D66756E6374696F6E20576328652C742C6E2C6F297B76617220732C723D7B7468726573686F6C643A352C74726170436C69636B3A21307D3B66756E6374696F6E20612865297B766172206E3D742E76696577';
wwv_flow_imp.g_varchar2_table(40049) := '626F7828292C693D742E5F636F6E7461696E65722E676574426F756E64696E67436C69656E745265637428293B72657475726E7B783A6E2E782B28652E782D692E6C656674292F6E2E7363616C652C793A6E2E792B28652E792D692E746F70292F6E2E73';
wwv_flow_imp.g_varchar2_table(40050) := '63616C657D7D66756E6374696F6E206C28742C6E297B6E3D6E7C7C733B766172206F3D652E6372656174654576656E742828302C692E6B7029287B7D2C6E2E7061796C6F61642C6E2E646174612C7B6973546F7563683A6E2E6973546F7563687D29293B';
wwv_flow_imp.g_varchar2_table(40051) := '72657475726E2131213D3D652E666972652822647261672E222B742C6F292626652E66697265286E2E7072656669782B222E222B742C6F297D66756E6374696F6E206328652C6F297B76617220722C633D732E7061796C6F61642C643D732E646973706C';
wwv_flow_imp.g_varchar2_table(40052) := '6163656D656E742C683D732E676C6F62616C53746172742C753D54722865292C703D766128752C68292C673D732E6C6F63616C53746172742C6D3D612875292C763D7661286D2C67293B69662821732E6163746976652626286F7C7C28723D702C4D6174';
wwv_flow_imp.g_varchar2_table(40053) := '682E73717274284D6174682E706F7728722E782C32292B4D6174682E706F7728722E792C3229293E732E7468726573686F6C642929297B69662828302C692E6B702928632C7B783A566328672E782B642E78292C793A566328672E792B642E79292C6478';
wwv_flow_imp.g_varchar2_table(40054) := '3A302C64793A307D2C7B6F726967696E616C4576656E743A657D292C21313D3D3D6C2822737461727422292972657475726E206628293B732E6163746976653D21302C732E6B65657053656C656374696F6E7C7C28632E70726576696F757353656C6563';
wwv_flow_imp.g_varchar2_table(40055) := '74696F6E3D6E2E67657428292C6E2E73656C656374286E756C6C29292C732E637572736F722626756128732E637572736F72292C742E6164644D61726B657228742E676574526F6F74456C656D656E7428292C7A63297D44722865292C732E6163746976';
wwv_flow_imp.g_varchar2_table(40056) := '6526262828302C692E6B702928632C7B783A5663286D2E782B642E78292C793A5663286D2E792B642E79292C64783A566328762E78292C64793A566328762E79297D2C7B6F726967696E616C4576656E743A657D292C6C28226D6F76652229297D66756E';
wwv_flow_imp.g_varchar2_table(40057) := '6374696F6E20642865297B76617220743D21303B732E61637469766526262865262628732E7061796C6F61642E6F726967696E616C4576656E743D652C4472286529292C743D6C2822656E642229292C21313D3D3D7426266C282272656A656374656422';
wwv_flow_imp.g_varchar2_table(40058) := '292C6C2822656E646564222C76282130213D3D7429297D66756E6374696F6E20682865297B58722822457363617065222C652926262848632865292C662829297D66756E6374696F6E20752874297B766172206E3B732E6163746976652626286E3D6D61';
wwv_flow_imp.g_varchar2_table(40059) := '2865292C73657454696D656F7574286E2C343030292C4863287429292C642874297D66756E6374696F6E20702865297B632865297D66756E6374696F6E20672865297B76617220743D732E7061796C6F61643B742E686F7665724766783D652E6766782C';
wwv_flow_imp.g_varchar2_table(40060) := '742E686F7665723D652E656C656D656E742C6C2822686F76657222297D66756E6374696F6E206D2865297B6C28226F757422293B76617220743D732E7061796C6F61643B742E686F7665724766783D6E756C6C2C742E686F7665723D6E756C6C7D66756E';
wwv_flow_imp.g_varchar2_table(40061) := '6374696F6E20662865297B76617220743B69662873297B766172206E3D732E6163746976653B6E26266C282263616E63656C22292C743D762865292C6E26266C282263616E63656C6564222C74297D7D66756E6374696F6E20762869297B76617220722C';
wwv_flow_imp.g_varchar2_table(40062) := '613B6C2822636C65616E757022292C706128292C613D732E74726170436C69636B3F753A642C4F742E756E62696E6428646F63756D656E742C226D6F7573656D6F7665222C63292C4F742E756E62696E6428646F63756D656E742C226472616773746172';
wwv_flow_imp.g_varchar2_table(40063) := '74222C4863292C4F742E756E62696E6428646F63756D656E742C2273656C6563747374617274222C4863292C4F742E756E62696E6428646F63756D656E742C226D6F757365646F776E222C612C2130292C4F742E756E62696E6428646F63756D656E742C';
wwv_flow_imp.g_varchar2_table(40064) := '226D6F7573657570222C612C2130292C4F742E756E62696E6428646F63756D656E742C226B65797570222C68292C4F742E756E62696E6428646F63756D656E742C22746F7563687374617274222C702C2130292C4F742E756E62696E6428646F63756D65';
wwv_flow_imp.g_varchar2_table(40065) := '6E742C22746F75636863616E63656C222C662C2130292C4F742E756E62696E6428646F63756D656E742C22746F7563686D6F7665222C632C2130292C4F742E756E62696E6428646F63756D656E742C22746F756368656E64222C642C2130292C652E6F66';
wwv_flow_imp.g_varchar2_table(40066) := '662822656C656D656E742E686F766572222C67292C652E6F66662822656C656D656E742E6F7574222C6D292C742E72656D6F76654D61726B657228742E676574526F6F74456C656D656E7428292C7A63293B76617220763D732E7061796C6F61642E7072';
wwv_flow_imp.g_varchar2_table(40067) := '6576696F757353656C656374696F6E3B72657475726E2131213D3D692626762626216E2E67657428292E6C656E677468262666756E6374696F6E2865297B76617220743D652E66696C746572282866756E6374696F6E2865297B72657475726E206F2E67';
wwv_flow_imp.g_varchar2_table(40068) := '657428652E6964297D29293B742E6C656E67746826266E2E73656C6563742874297D2876292C723D732C733D6E756C6C2C727D652E6F6E28226469616772616D2E64657374726F79222C66292C746869732E696E69743D66756E6374696F6E28742C6E2C';
wwv_flow_imp.g_varchar2_table(40069) := '6F2C76297B73262666282131292C22737472696E67223D3D747970656F66206E262628763D6F2C6F3D6E2C6E3D6E756C6C293B76617220622C5F2C792C772C432C533D28763D28302C692E6B7029287B7D2C722C767C7C7B7D29292E646174617C7C7B7D';
wwv_flow_imp.g_varchar2_table(40070) := '3B773D762E74726170436C69636B3F753A642C743F28623D4C722874297C7C742C5F3D54722874292C44722874292C22647261677374617274223D3D3D622E7479706526264863286229293A28623D6E756C6C2C5F3D7B783A302C793A307D292C793D61';
wwv_flow_imp.g_varchar2_table(40071) := '285F292C6E7C7C286E3D79292C433D66756E6374696F6E2865297B72657475726E22756E646566696E656422213D747970656F6620546F7563684576656E7426266520696E7374616E63656F6620546F7563684576656E747D2862292C733D28302C692E';
wwv_flow_imp.g_varchar2_table(40072) := '6B7029287B7072656669783A6F2C646174613A532C7061796C6F61643A7B7D2C676C6F62616C53746172743A5F2C646973706C6163656D656E743A7661286E2C79292C6C6F63616C53746172743A792C6973546F7563683A437D2C76292C762E6D616E75';
wwv_flow_imp.g_varchar2_table(40073) := '616C7C7C28433F284F742E62696E6428646F63756D656E742C22746F7563687374617274222C702C2130292C4F742E62696E6428646F63756D656E742C22746F75636863616E63656C222C662C2130292C4F742E62696E6428646F63756D656E742C2274';
wwv_flow_imp.g_varchar2_table(40074) := '6F7563686D6F7665222C632C2130292C4F742E62696E6428646F63756D656E742C22746F756368656E64222C642C213029293A284F742E62696E6428646F63756D656E742C226D6F7573656D6F7665222C63292C4F742E62696E6428646F63756D656E74';
wwv_flow_imp.g_varchar2_table(40075) := '2C22647261677374617274222C4863292C4F742E62696E6428646F63756D656E742C2273656C6563747374617274222C4863292C4F742E62696E6428646F63756D656E742C226D6F757365646F776E222C772C2130292C4F742E62696E6428646F63756D';
wwv_flow_imp.g_varchar2_table(40076) := '656E742C226D6F7573657570222C772C213029292C4F742E62696E6428646F63756D656E742C226B65797570222C68292C652E6F6E2822656C656D656E742E686F766572222C67292C652E6F6E2822656C656D656E742E6F7574222C6D29292C6C282269';
wwv_flow_imp.g_varchar2_table(40077) := '6E697422292C762E6175746F416374697661746526266328742C2130297D2C746869732E6D6F76653D632C746869732E686F7665723D672C746869732E6F75743D6D2C746869732E656E643D642C746869732E63616E63656C3D662C746869732E636F6E';
wwv_flow_imp.g_varchar2_table(40078) := '746578743D66756E6374696F6E28297B72657475726E20737D2C746869732E7365744F7074696F6E733D66756E6374696F6E2865297B28302C692E6B702928722C65297D7D57632E24696E6A6563743D5B226576656E74427573222C2263616E76617322';
wwv_flow_imp.g_varchar2_table(40079) := '2C2273656C656374696F6E222C22656C656D656E745265676973747279225D3B636F6E7374206A633D7B5F5F646570656E64735F5F3A5B42632C24725D2C6472616767696E673A5B2274797065222C57635D7D3B66756E6374696F6E20716328652C742C';
wwv_flow_imp.g_varchar2_table(40080) := '6E297B746869732E5F63616E7661733D6E2C746869732E5F6F7074733D28302C692E6B7029287B7363726F6C6C5468726573686F6C64496E3A5B32302C32302C32302C32305D2C7363726F6C6C5468726573686F6C644F75743A5B302C302C302C305D2C';
wwv_flow_imp.g_varchar2_table(40081) := '7363726F6C6C52657065617454696D656F75743A31352C7363726F6C6C537465703A31307D2C65293B766172206F3D746869733B742E6F6E2822647261672E6D6F7665222C2866756E6374696F6E2865297B76617220743D6F2E5F746F426F7264657250';
wwv_flow_imp.g_varchar2_table(40082) := '6F696E742865293B6F2E73746172745363726F6C6C2874297D29292C742E6F6E285B22647261672E636C65616E7570225D2C2866756E6374696F6E28297B6F2E73746F705363726F6C6C28297D29297D71632E24696E6A6563743D5B22636F6E6669672E';
wwv_flow_imp.g_varchar2_table(40083) := '6175746F5363726F6C6C222C226576656E74427573222C2263616E766173225D2C71632E70726F746F747970652E73746172745363726F6C6C3D66756E6374696F6E2865297B76617220742C6E2C692C6F3D746869732E5F63616E7661732C733D746869';
wwv_flow_imp.g_varchar2_table(40084) := '732E5F6F7074732C723D746869732C613D6F2E676574436F6E7461696E657228292E676574426F756E64696E67436C69656E745265637428292C6C3D5B652E782C652E792C612E77696474682D652E782C612E6865696768742D652E795D3B746869732E';
wwv_flow_imp.g_varchar2_table(40085) := '73746F705363726F6C6C28293B666F722876617220633D302C643D302C683D303B683C343B682B2B29743D6C5B685D2C6E3D732E7363726F6C6C5468726573686F6C644F75745B685D2C693D732E7363726F6C6C5468726573686F6C64496E5B685D2C6E';
wwv_flow_imp.g_varchar2_table(40086) := '3C742626743C69262628303D3D3D683F633D732E7363726F6C6C537465703A313D3D683F643D732E7363726F6C6C537465703A323D3D683F633D2D732E7363726F6C6C537465703A333D3D68262628643D2D732E7363726F6C6C5374657029293B303D3D';
wwv_flow_imp.g_varchar2_table(40087) := '3D632626303D3D3D647C7C286F2E7363726F6C6C287B64783A632C64793A647D292C746869732E5F7363726F6C6C696E673D73657454696D656F7574282866756E6374696F6E28297B722E73746172745363726F6C6C2865297D292C732E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(40088) := '52657065617454696D656F757429297D2C71632E70726F746F747970652E73746F705363726F6C6C3D66756E6374696F6E28297B636C65617254696D656F757428746869732E5F7363726F6C6C696E67297D2C71632E70726F746F747970652E7365744F';
wwv_flow_imp.g_varchar2_table(40089) := '7074696F6E733D66756E6374696F6E2865297B746869732E5F6F7074733D28302C692E6B7029287B7D2C746869732E5F6F7074732C65297D2C71632E70726F746F747970652E5F746F426F72646572506F696E743D66756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(40090) := '20743D746869732E5F63616E7661732E5F636F6E7461696E65722E676574426F756E64696E67436C69656E745265637428292C6E3D547228652E6F726967696E616C4576656E74293B72657475726E7B783A6E2E782D742E6C6566742C793A6E2E792D74';
wwv_flow_imp.g_varchar2_table(40091) := '2E746F707D7D3B636F6E73742024633D7B5F5F646570656E64735F5F3A5B6A635D2C5F5F696E69745F5F3A5B226175746F5363726F6C6C225D2C6175746F5363726F6C6C3A5B2274797065222C71635D7D3B66756E6374696F6E2055632865297B746869';
wwv_flow_imp.g_varchar2_table(40092) := '732E5F636F6D6D616E64537461636B3D652E6765742822636F6D6D616E64537461636B222C2131297D55632E24696E6A6563743D5B22696E6A6563746F72225D2C55632E70726F746F747970652E616C6C6F7765643D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(40093) := '766172206E3D21302C693D746869732E5F636F6D6D616E64537461636B3B72657475726E20692626286E3D692E63616E4578656375746528652C7429292C766F696420303D3D3D6E7C7C6E7D3B636F6E7374204B633D7B5F5F696E69745F5F3A5B227275';
wwv_flow_imp.g_varchar2_table(40094) := '6C6573225D2C72756C65733A5B2274797065222C55635D7D3B7661722047633D4D6174682E726F756E642C51633D4D6174682E6D61782C59633D31303B66756E6374696F6E205A6328652C74297B72657475726E2066756E6374696F6E28652C74297B76';
wwv_flow_imp.g_varchar2_table(40095) := '6172206E2C693B666F72286E3D303B693D655B6E5D3B6E2B2B29696628517428692C74293C3D59632972657475726E7B706F696E743A655B6E5D2C62656E64706F696E743A21302C696E6465783A6E7D3B72657475726E206E756C6C7D28652C74297C7C';
wwv_flow_imp.g_varchar2_table(40096) := '66756E6374696F6E28652C74297B766172206E2C692C6F3D446E2866756E6374696F6E28652C74297B72657475726E5B5B224D222C652E782C652E795D2C5B226D222C302C2D745D2C5B2261222C742C742C302C312C312C302C322A745D2C5B2261222C';
wwv_flow_imp.g_varchar2_table(40097) := '742C742C302C312C312C302C2D322A745D2C5B227A225D5D7D28742C5963292C286E3D5B5D2C652E666F7245616368282866756E6374696F6E28652C74297B6E2E70757368285B303D3D3D743F224D223A224C222C652E782C652E795D297D29292C6E29';
wwv_flow_imp.g_varchar2_table(40098) := '292C733D6F5B305D2C723D6F5B6F2E6C656E6774682D315D3B72657475726E20733F73213D3D723F732E7365676D656E7432213D3D722E7365676D656E74323F7B706F696E743A655B693D516328732E7365676D656E74322C722E7365676D656E743229';
wwv_flow_imp.g_varchar2_table(40099) := '2D315D2C62656E64706F696E743A21302C696E6465783A697D3A7B706F696E743A7B783A476328732E782B722E78292F322C793A476328732E792B722E79292F327D2C696E6465783A732E7365676D656E74327D3A7B706F696E743A7B783A476328732E';
wwv_flow_imp.g_varchar2_table(40100) := '78292C793A476328732E79297D2C696E6465783A732E7365676D656E74327D3A6E756C6C7D28652C74297D66756E6374696F6E2058632865297B72657475726E204D6174682E73717274284D6174682E706F7728652E782C32292B4D6174682E706F7728';
wwv_flow_imp.g_varchar2_table(40101) := '652E792C3229297D66756E6374696F6E204A632865297B72657475726E204D6174682E6174616E2828655B315D2E792D655B305D2E79292F28655B315D2E782D655B305D2E7829297D66756E6374696F6E20656428652C74297B766172206E3D745B305D';
wwv_flow_imp.g_varchar2_table(40102) := '2C693D745B315D2C6F3D7B783A692E782D6E2E782C793A692E792D6E2E797D2C733D66756E6374696F6E28652C742C6E297B76617220693D5B7B6E3A655B305D2D6E5B305D2C6C616D6264613A745B305D7D2C7B6E3A655B315D2D6E5B315D2C6C616D62';
wwv_flow_imp.g_varchar2_table(40103) := '64613A745B315D7D5D3B72657475726E2D28695B305D2E6E2A745B305D2B695B315D2E6E2A745B315D292F28695B305D2E6C616D6264612A745B305D2B695B315D2E6C616D6264612A745B315D297D285B6E2E782C6E2E795D2C5B6F2E782C6F2E795D2C';
wwv_flow_imp.g_varchar2_table(40104) := '5B652E782C652E795D293B72657475726E7B783A6E2E782B732A6F2E782C793A6E2E792B732A6F2E797D7D66756E6374696F6E20746428652C74297B766172206E3D656428652C74293B72657475726E205863287B783A6E2E782D652E782C793A6E2E79';
wwv_flow_imp.g_varchar2_table(40105) := '2D652E797D297D66756E6374696F6E206E6428652C74297B72657475726E205863287B783A652E782D742E782C793A652E792D742E797D297D7661722069643D22646A732D62656E64706F696E74222C6F643D22646A732D7365676D656E742D64726167';
wwv_flow_imp.g_varchar2_table(40106) := '676572223B66756E6374696F6E20736428652C742C6E297B76617220693D66756E6374696F6E28652C74297B766172206E2C693D54722874292C6F3D652E5F636F6E7461696E65722E676574426F756E64696E67436C69656E745265637428293B6E3D7B';
wwv_flow_imp.g_varchar2_table(40107) := '783A6F2E6C6566742C793A6F2E746F707D3B76617220733D652E76696577626F7828293B72657475726E7B783A732E782B28692E782D6E2E78292F732E7363616C652C793A732E792B28692E792D6E2E79292F732E7363616C657D7D28652C6E293B7265';
wwv_flow_imp.g_varchar2_table(40108) := '7475726E205A6328742C69297D66756E6374696F6E20726428652C74297B766172206E3D6B6528226722293B6265286E292E616464286964292C756528652C6E293B76617220693D6B652822636972636C6522293B666528692C7B63783A302C63793A30';
wwv_flow_imp.g_varchar2_table(40109) := '2C723A347D292C62652869292E6164642822646A732D76697375616C22292C7565286E2C69293B766172206F3D6B652822636972636C6522293B72657475726E206665286F2C7B63783A302C63793A302C723A31307D292C6265286F292E616464282264';
wwv_flow_imp.g_varchar2_table(40110) := '6A732D68697422292C7565286E2C6F292C7426266265286E292E6164642874292C6E7D66756E6374696F6E20616428652C742C6E297B76617220693D6B6528226722292C6F3D746E28742C6E292C733D587428742C6E293B72657475726E20756528652C';
wwv_flow_imp.g_varchar2_table(40111) := '69292C66756E6374696F6E28652C742C6E2C69297B766172206F3D6B6528226722293B756528652C6F293B76617220733D66756E6374696F6E28652C742C6E297B76617220693D742E782D652E782C6F3D742E792D652E793B72657475726E206C642822';
wwv_flow_imp.g_varchar2_table(40112) := '68223D3D3D6E3F693A6F297D28742C6E2C69292C723D6B6528227265637422293B666528722C7B783A2D392C793A2D332C77696474683A31382C6865696768743A367D292C62652872292E6164642822646A732D76697375616C22292C7565286F2C7229';
wwv_flow_imp.g_varchar2_table(40113) := '3B76617220613D6B6528227265637422293B666528612C7B783A2D732F322C793A2D382E352C77696474683A732C6865696768743A31377D292C62652861292E6164642822646A732D68697422292C7565286F2C61292C5F69286F2C2276223D3D3D693F';
wwv_flow_imp.g_varchar2_table(40114) := '39303A30297D28692C742C6E2C73292C62652869292E616464286F64292C62652869292E616464282268223D3D3D733F22686F72697A6F6E74616C223A22766572746963616C22292C626928692C6F2E782C6F2E79292C697D66756E6374696F6E206C64';
wwv_flow_imp.g_varchar2_table(40115) := '2865297B72657475726E204D6174682E616273284D6174682E726F756E6428322A652F3329297D66756E6374696F6E20636428652C742C6E2C6F2C73297B66756E6374696F6E207228652C742C69297B4F742E62696E6428652C742C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(40116) := '6E2865297B6E2E747269676765724D6F7573654576656E7428742C652C69292C652E73746F7050726F7061676174696F6E28297D29297D66756E6374696F6E206128652C6E297B76617220693D742E6765744C6179657228226F7665726C61797322292C';
wwv_flow_imp.g_varchar2_table(40117) := '6F3D6A7428272E646A732D62656E64706F696E74735B646174612D656C656D656E742D69643D22272B7628652E6964292B27225D272C69293B72657475726E216F26266E2626286665286F3D6B6528226722292C7B22646174612D656C656D656E742D69';
wwv_flow_imp.g_varchar2_table(40118) := '64223A652E69647D292C6265286F292E6164642822646A732D62656E64706F696E747322292C756528692C6F292C72286F2C226D6F757365646F776E222C65292C72286F2C22636C69636B222C65292C72286F2C2264626C636C69636B222C6529292C6F';
wwv_flow_imp.g_varchar2_table(40119) := '7D66756E6374696F6E206C28652C74297B72657475726E206A7428272E646A732D7365676D656E742D647261676765725B646174612D7365676D656E742D6964783D22272B652B27225D272C74297D66756E6374696F6E206328652C74297B742E776179';
wwv_flow_imp.g_varchar2_table(40120) := '706F696E74732E666F7245616368282866756E6374696F6E28742C6E297B76617220693D72642865293B756528652C69292C626928692C742E782C742E79297D29292C726428652C22666C6F6174696E6722297D66756E6374696F6E206428652C74297B';
wwv_flow_imp.g_varchar2_table(40121) := '666F7228766172206E2C692C6F2C733D742E776179706F696E74732C613D313B613C732E6C656E6774683B612B2B295874286E3D735B612D315D2C693D735B615D292626286665286F3D616428652C6E2C69292C7B22646174612D7365676D656E742D69';
wwv_flow_imp.g_varchar2_table(40122) := '6478223A617D292C72286F2C226D6F7573656D6F7665222C7429297D66756E6374696F6E20682865297B76617220743D612865293B72657475726E20747C7C286328743D6128652C2130292C65292C6428742C6529292C747D66756E6374696F6E207528';
wwv_flow_imp.g_varchar2_table(40123) := '65297B76617220743D612865293B7426262866756E6374696F6E2865297B28302C692E6A4A2928717428222E222B6F642C65292C2866756E6374696F6E2865297B52652865297D29297D2874292C66756E6374696F6E2865297B28302C692E6A4A292871';
wwv_flow_imp.g_varchar2_table(40124) := '7428222E222B69642C65292C2866756E6374696F6E2865297B52652865297D29297D2874292C6428742C65292C6328742C6529297D652E6F6E2822636F6E6E656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B7528652E656C656D';
wwv_flow_imp.g_varchar2_table(40125) := '656E74297D29292C652E6F6E2822636F6E6E656374696F6E2E72656D6F7665222C2866756E6374696F6E2865297B76617220743D6128652E656C656D656E74293B74262652652874297D29292C652E6F6E2822656C656D656E742E6D61726B65722E7570';
wwv_flow_imp.g_varchar2_table(40126) := '64617465222C2866756E6374696F6E2865297B76617220742C6E3D652E656C656D656E743B6E2E776179706F696E7473262628743D68286E292C652E6164643F62652874292E61646428652E6D61726B6572293A62652874292E72656D6F766528652E6D';
wwv_flow_imp.g_varchar2_table(40127) := '61726B657229297D29292C652E6F6E2822656C656D656E742E6D6F7573656D6F7665222C2866756E6374696F6E2865297B766172206E2C692C6F3D652E656C656D656E742C733D6F2E776179706F696E74733B69662873297B6966286E3D61286F2C2130';
wwv_flow_imp.g_varchar2_table(40128) := '292C2128693D736428742C732C652E6F726967696E616C4576656E7429292972657475726E3B2166756E6374696F6E28652C74297B766172206E3D6A7428222E666C6F6174696E67222C65292C693D742E706F696E743B6E26266269286E2C692E782C69';
wwv_flow_imp.g_varchar2_table(40129) := '2E79297D286E2C69292C692E62656E64706F696E747C7C66756E6374696F6E28652C742C6E297B76617220692C6F2C733D6C28742E696E6465782C65292C723D6E5B742E696E6465782D315D2C613D6E5B742E696E6465785D2C633D742E706F696E742C';
wwv_flow_imp.g_varchar2_table(40130) := '643D746E28722C61292C683D587428722C61293B73262628693D66756E6374696F6E2865297B72657475726E206A7428222E646A732D76697375616C222C65297D2873292C6F3D7B783A632E782D642E782C793A632E792D642E797D2C2276223D3D3D68';
wwv_flow_imp.g_varchar2_table(40131) := '2626286F3D7B783A6F2E792C793A6F2E787D292C626928692C6F2E782C6F2E7929297D286E2C692C73297D7D29292C652E6F6E2822656C656D656E742E6D6F757365646F776E222C2866756E6374696F6E2865297B6966284172286529297B766172206E';
wwv_flow_imp.g_varchar2_table(40132) := '3D652E6F726967696E616C4576656E742C693D652E656C656D656E743B696628692E776179706F696E74732972657475726E2066756E6374696F6E28652C6E297B76617220692C723D6E2E776179706F696E74732C613D736428742C722C65293B696628';
wwv_flow_imp.g_varchar2_table(40133) := '612972657475726E20693D66756E6374696F6E28652C74297B766172206E2C692C6F3D652E776179706F696E74733B72657475726E20742E696E6465783C3D307C7C742E62656E64706F696E743F6E756C6C3A28693D587428286E3D7B73746172743A6F';
wwv_flow_imp.g_varchar2_table(40134) := '5B742E696E6465782D315D2C656E643A6F5B742E696E6465785D7D292E73746172742C6E2E656E6429293F6C64282268223D3D3D693F6E2E656E642E782D6E2E73746172742E783A6E2E656E642E792D6E2E73746172742E79292F323A6E756C6C7D286E';
wwv_flow_imp.g_varchar2_table(40135) := '2C61292C66756E6374696F6E28652C742C6E297B76617220692C6F2C732C722C612C6C2C633D652E696E6465782C643D652E706F696E743B72657475726E2128633C3D307C7C652E62656E64706F696E7429262628733D746E28693D745B632D315D2C6F';
wwv_flow_imp.g_varchar2_table(40136) := '3D745B635D292C723D587428692C6F292C613D4D6174682E61627328642E782D732E78292C6C3D4D6174682E61627328642E792D732E79292C722626613C3D6E26266C3C3D6E297D28612C722C69293F732E737461727428652C6E2C612E696E64657829';
wwv_flow_imp.g_varchar2_table(40137) := '3A6F2E737461727428652C6E2C612E696E6465782C21612E62656E64706F696E74292C21307D286E2C69297D7D29292C652E6F6E282273656C656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B76617220743D652E6E657753656C';
wwv_flow_imp.g_varchar2_table(40138) := '656374696F6E5B305D3B742626742E776179706F696E74732626682874297D29292C652E6F6E2822656C656D656E742E686F766572222C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B742E776179706F696E74732626286828';
wwv_flow_imp.g_varchar2_table(40139) := '74292C6E2E72656769737465724576656E7428652E6766782C226D6F7573656D6F7665222C22656C656D656E742E6D6F7573656D6F76652229297D29292C652E6F6E2822656C656D656E742E6F7574222C2866756E6374696F6E2865297B6E2E756E7265';
wwv_flow_imp.g_varchar2_table(40140) := '6769737465724576656E7428652E6766782C226D6F7573656D6F7665222C22656C656D656E742E6D6F7573656D6F766522297D29292C652E6F6E2822656C656D656E742E7570646174654964222C2866756E6374696F6E2865297B76617220743D652E65';
wwv_flow_imp.g_varchar2_table(40141) := '6C656D656E742C6E3D652E6E657749643B696628742E776179706F696E7473297B76617220693D612874293B692626666528692C7B22646174612D656C656D656E742D6964223A6E7D297D7D29292C746869732E61646448616E646C65733D682C746869';
wwv_flow_imp.g_varchar2_table(40142) := '732E75706461746548616E646C65733D752C746869732E67657442656E64706F696E7473436F6E7461696E65723D612C746869732E6765745365676D656E74447261676765723D6C7D63642E24696E6A6563743D5B226576656E74427573222C2263616E';
wwv_flow_imp.g_varchar2_table(40143) := '766173222C22696E746572616374696F6E4576656E7473222C2262656E64706F696E744D6F7665222C22636F6E6E656374696F6E5365676D656E744D6F7665225D3B7661722064643D4D6174682E726F756E642C68643D227265636F6E6E656374537461';
wwv_flow_imp.g_varchar2_table(40144) := '7274222C75643D227265636F6E6E656374456E64222C70643D22757064617465576179706F696E7473223B66756E6374696F6E20676428652C742C6E2C692C6F2C73297B746869732E5F696E6A6563746F723D652C746869732E73746172743D66756E63';
wwv_flow_imp.g_varchar2_table(40145) := '74696F6E28652C742C732C72297B76617220612C6C3D6E2E67657447726170686963732874292C633D742E736F757263652C643D742E7461726765742C683D742E776179706F696E74732C753D28613D727C7C30213D3D733F727C7C73213D3D682E6C65';
wwv_flow_imp.g_varchar2_table(40146) := '6E6774682D313F70643A75643A6864293D3D3D70643F22636F6E6E656374696F6E2E757064617465576179706F696E7473223A22636F6E6E656374696F6E2E7265636F6E6E656374222C703D6F2E616C6C6F77656428752C7B636F6E6E656374696F6E3A';
wwv_flow_imp.g_varchar2_table(40147) := '742C736F757263653A632C7461726765743A647D293B21313D3D3D70262628703D6F2E616C6C6F77656428752C7B636F6E6E656374696F6E3A742C736F757263653A642C7461726765743A637D29292C2131213D3D702626692E696E697428652C226265';
wwv_flow_imp.g_varchar2_table(40148) := '6E64706F696E742E6D6F7665222C7B646174613A7B636F6E6E656374696F6E3A742C636F6E6E656374696F6E4766783A6C2C636F6E746578743A7B616C6C6F7765643A702C62656E64706F696E74496E6465783A732C636F6E6E656374696F6E3A742C73';
wwv_flow_imp.g_varchar2_table(40149) := '6F757263653A632C7461726765743A642C696E736572743A722C747970653A617D7D7D297D2C742E6F6E282262656E64706F696E742E6D6F76652E686F766572222C2866756E6374696F6E2865297B76617220742C6E3D652E636F6E746578742C693D6E';
wwv_flow_imp.g_varchar2_table(40150) := '2E636F6E6E656374696F6E2C733D692E736F757263652C723D692E7461726765742C613D652E686F7665722C6C3D6E2E747970653B6966286E2E686F7665723D612C61297B76617220633D6C3D3D3D70643F22636F6E6E656374696F6E2E757064617465';
wwv_flow_imp.g_varchar2_table(40151) := '576179706F696E7473223A22636F6E6E656374696F6E2E7265636F6E6E656374223B696628743D6E2E616C6C6F7765643D6F2E616C6C6F77656428632C7B636F6E6E656374696F6E3A692C736F757263653A6C3D3D3D68643F613A732C7461726765743A';
wwv_flow_imp.g_varchar2_table(40152) := '6C3D3D3D75643F613A727D292972657475726E206E2E736F757263653D6C3D3D3D68643F613A732C766F6964286E2E7461726765743D6C3D3D3D75643F613A72293B21313D3D3D74262628743D6E2E616C6C6F7765643D6F2E616C6C6F77656428632C7B';
wwv_flow_imp.g_varchar2_table(40153) := '636F6E6E656374696F6E3A692C736F757263653A6C3D3D3D75643F613A722C7461726765743A6C3D3D3D68643F613A737D29292C742626286E2E736F757263653D6C3D3D3D75643F613A722C6E2E7461726765743D6C3D3D3D68643F613A73297D7D2929';
wwv_flow_imp.g_varchar2_table(40154) := '2C742E6F6E285B2262656E64706F696E742E6D6F76652E6F7574222C2262656E64706F696E742E6D6F76652E636C65616E7570225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E747970653B742E686F7665723D';
wwv_flow_imp.g_varchar2_table(40155) := '6E756C6C2C742E736F757263653D6E756C6C2C742E7461726765743D6E756C6C2C6E213D3D7064262628742E616C6C6F7765643D2131297D29292C742E6F6E282262656E64706F696E742E6D6F76652E656E64222C2866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(40156) := '7220743D652E636F6E746578742C6E3D742E616C6C6F7765642C693D742E62656E64706F696E74496E6465782C6F3D742E636F6E6E656374696F6E2C723D742E696E736572742C613D6F2E776179706F696E74732E736C69636528292C6C3D742E736F75';
wwv_flow_imp.g_varchar2_table(40157) := '7263652C633D742E7461726765742C643D742E747970652C683D742E68696E74737C7C7B7D2C753D7B783A646428652E78292C793A646428652E79297D3B696628216E2972657475726E21313B643D3D3D70643F28723F612E73706C69636528692C302C';
wwv_flow_imp.g_varchar2_table(40158) := '75293A615B695D3D752C682E62656E64706F696E744D6F76653D7B696E736572743A722C62656E64706F696E74496E6465783A697D2C613D746869732E63726F70576179706F696E7473286F2C61292C732E757064617465576179706F696E7473286F2C';
wwv_flow_imp.g_varchar2_table(40159) := '66756E6374696F6E2865297B653D652E736C69636528293B666F722876617220742C6E2C692C6F3D303B655B6F5D3B29743D655B6F5D2C6E3D655B6F2D315D2C303D3D3D517428742C693D655B6F2B315D297C7C5974286E2C692C74293F652E73706C69';
wwv_flow_imp.g_varchar2_table(40160) := '6365286F2C31293A6F2B2B3B72657475726E20657D2861292C6829293A28643D3D3D68643F28682E646F636B696E673D22736F75726365222C6D64287429262628682E646F636B696E673D22746172676574222C682E6E6577576179706F696E74733D61';
wwv_flow_imp.g_varchar2_table(40161) := '2E72657665727365282929293A643D3D3D7564262628682E646F636B696E673D22746172676574222C6D64287429262628682E646F636B696E673D22736F75726365222C682E6E6577576179706F696E74733D612E72657665727365282929292C732E72';
wwv_flow_imp.g_varchar2_table(40162) := '65636F6E6E656374286F2C6C2C632C752C6829297D292C74686973297D66756E6374696F6E206D642865297B76617220743D652E686F7665722C6E3D652E736F757263652C693D652E7461726765742C6F3D652E747970653B72657475726E206F3D3D3D';
wwv_flow_imp.g_varchar2_table(40163) := '68643F742626692626743D3D3D6926266E213D3D693A6F3D3D3D75643F7426266E2626743D3D3D6E26266E213D3D693A766F696420307D67642E24696E6A6563743D5B22696E6A6563746F72222C226576656E74427573222C2263616E766173222C2264';
wwv_flow_imp.g_varchar2_table(40164) := '72616767696E67222C2272756C6573222C226D6F64656C696E67225D2C67642E70726F746F747970652E63726F70576179706F696E74733D66756E6374696F6E28652C74297B766172206E3D746869732E5F696E6A6563746F722E6765742822636F6E6E';
wwv_flow_imp.g_varchar2_table(40165) := '656374696F6E446F636B696E67222C2131293B696628216E2972657475726E20743B76617220693D652E776179706F696E74733B72657475726E20652E776179706F696E74733D742C652E776179706F696E74733D6E2E67657443726F70706564576179';
wwv_flow_imp.g_varchar2_table(40166) := '706F696E74732865292C743D652E776179706F696E74732C652E776179706F696E74733D692C747D3B7661722066643D22757064617465576179706F696E7473222C76643D22636F6E6E6563742D6F6B222C62643D22636F6E6E6563742D6E6F742D6F6B';
wwv_flow_imp.g_varchar2_table(40167) := '222C5F643D22636F6E6E6563742D686F766572222C79643D22646A732D7570646174696E67222C77643D22646A732D6472616767696E67223B66756E6374696F6E20436428652C742C6E2C69297B746869732E5F696E6A6563746F723D743B766172206F';
wwv_flow_imp.g_varchar2_table(40168) := '3D742E6765742822636F6E6E656374696F6E50726576696577222C2131293B6E2E6F6E282262656E64706F696E742E6D6F76652E7374617274222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E62656E64706F696E';
wwv_flow_imp.g_varchar2_table(40169) := '74496E6465782C6F3D742E636F6E6E656374696F6E2C733D742E696E736572742C723D6F2E776179706F696E74732C613D722E736C69636528293B742E776179706F696E74733D722C732626612E73706C696365286E2C302C7B783A652E782C793A652E';
wwv_flow_imp.g_varchar2_table(40170) := '797D292C6F2E776179706F696E74733D612C626528742E647261676765724766783D726428692E6765744C6179657228226F7665726C617973222929292E6164642822646A732D6472616767696E6722292C692E6164644D61726B6572286F2C7764292C';
wwv_flow_imp.g_varchar2_table(40171) := '692E6164644D61726B6572286F2C7964297D29292C6E2E6F6E282262656E64706F696E742E6D6F76652E686F766572222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E616C6C6F7765642C6F3D742E686F7665722C';
wwv_flow_imp.g_varchar2_table(40172) := '733D742E747970653B6966286F297B696628692E6164644D61726B6572286F2C5F64292C733D3D3D66642972657475726E3B6E3F28692E72656D6F76654D61726B6572286F2C6264292C692E6164644D61726B6572286F2C766429293A21313D3D3D6E26';
wwv_flow_imp.g_varchar2_table(40173) := '2628692E72656D6F76654D61726B6572286F2C7664292C692E6164644D61726B6572286F2C626429297D7D29292C6E2E6F6E285B2262656E64706F696E742E6D6F76652E6F7574222C2262656E64706F696E742E6D6F76652E636C65616E7570225D2C31';
wwv_flow_imp.g_varchar2_table(40174) := '3130302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E686F7665722C6F3D742E7461726765743B6E262628692E72656D6F76654D61726B6572286E2C5F64292C692E72656D6F76654D61726B6572286E2C6F3F7664';
wwv_flow_imp.g_varchar2_table(40175) := '3A626429297D29292C6E2E6F6E282262656E64706F696E742E6D6F76652E6D6F7665222C2866756E6374696F6E2874297B766172206E3D742E636F6E746578742C693D6E2E616C6C6F7765642C733D6E2E62656E64706F696E74496E6465782C723D6E2E';
wwv_flow_imp.g_varchar2_table(40176) := '647261676765724766782C613D6E2E686F7665722C6C3D6E2E747970652C633D6E2E636F6E6E656374696F6E2C643D632E736F757263652C683D632E7461726765742C753D632E776179706F696E74732E736C69636528292C703D7B783A742E782C793A';
wwv_flow_imp.g_varchar2_table(40177) := '742E797D2C673D6E2E68696E74737C7C7B7D2C6D3D7B7D3B6F262628672E636F6E6E656374696F6E53746172742626286D2E636F6E6E656374696F6E53746172743D672E636F6E6E656374696F6E5374617274292C672E636F6E6E656374696F6E456E64';
wwv_flow_imp.g_varchar2_table(40178) := '2626286D2E636F6E6E656374696F6E456E643D672E636F6E6E656374696F6E456E64292C227265636F6E6E6563745374617274223D3D3D6C3F6D64286E293F286D2E636F6E6E656374696F6E456E643D6D2E636F6E6E656374696F6E456E647C7C702C6D';
wwv_flow_imp.g_varchar2_table(40179) := '2E736F757263653D682C6D2E7461726765743D617C7C642C753D752E726576657273652829293A286D2E636F6E6E656374696F6E53746172743D6D2E636F6E6E656374696F6E53746172747C7C702C6D2E736F757263653D617C7C642C6D2E7461726765';
wwv_flow_imp.g_varchar2_table(40180) := '743D68293A227265636F6E6E656374456E64223D3D3D6C3F6D64286E293F286D2E636F6E6E656374696F6E53746172743D6D2E636F6E6E656374696F6E53746172747C7C702C6D2E736F757263653D617C7C682C6D2E7461726765743D642C753D752E72';
wwv_flow_imp.g_varchar2_table(40181) := '6576657273652829293A286D2E636F6E6E656374696F6E456E643D6D2E636F6E6E656374696F6E456E647C7C702C6D2E736F757263653D642C6D2E7461726765743D617C7C68293A286D2E6E6F43726F7070696E673D21302C6D2E6E6F4C61796F75743D';
wwv_flow_imp.g_varchar2_table(40182) := '21302C755B735D3D70292C6C3D3D3D6664262628753D652E63726F70576179706F696E747328632C7529292C6D2E776179706F696E74733D752C6F2E6472617750726576696577286E2C692C6D29292C626928722C742E782C742E79297D292C74686973';
wwv_flow_imp.g_varchar2_table(40183) := '292C6E2E6F6E285B2262656E64706F696E742E6D6F76652E656E64222C2262656E64706F696E742E6D6F76652E63616E63656C225D2C313130302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E636F6E6E65637469';
wwv_flow_imp.g_varchar2_table(40184) := '6F6E2C733D742E647261676765724766782C723D742E686F7665722C613D742E7461726765742C6C3D742E776179706F696E74733B6E2E776179706F696E74733D6C2C52652873292C692E72656D6F76654D61726B6572286E2C7964292C692E72656D6F';
wwv_flow_imp.g_varchar2_table(40185) := '76654D61726B6572286E2C7764292C72262628692E72656D6F76654D61726B657228722C7664292C692E72656D6F76654D61726B657228722C613F76643A626429292C6F26266F2E636C65616E55702874297D29297D43642E24696E6A6563743D5B2262';
wwv_flow_imp.g_varchar2_table(40186) := '656E64706F696E744D6F7665222C22696E6A6563746F72222C226576656E74427573222C2263616E766173225D3B7661722053643D22636F6E6E6563742D686F766572222C78643D22646A732D7570646174696E67223B66756E6374696F6E206B642865';
wwv_flow_imp.g_varchar2_table(40187) := '2C742C6E297B72657475726E20456428652C742C655B745D2B6E297D66756E6374696F6E20456428652C742C6E297B72657475726E7B783A2278223D3D3D743F6E3A652E782C793A2279223D3D3D743F6E3A652E797D7D66756E6374696F6E204C642865';
wwv_flow_imp.g_varchar2_table(40188) := '297B72657475726E2278223D3D3D653F2279223A2278227D66756E6374696F6E20446428652C742C6E297B76617220692C6F3B72657475726E20652E6F726967696E616C3F652E6F726967696E616C3A28693D486E2874292C456428652C6F3D4C64286E';
wwv_flow_imp.g_varchar2_table(40189) := '292C695B6F5D29297D66756E6374696F6E20546428652C742C6E2C692C6F2C73297B76617220723D652E6765742822636F6E6E656374696F6E446F636B696E67222C2131293B66756E6374696F6E206128652C74297B69662821722972657475726E2074';
wwv_flow_imp.g_varchar2_table(40190) := '3B766172206E2C693D652E776179706F696E74733B72657475726E20652E776179706F696E74733D742C6E3D722E67657443726F70706564576179706F696E74732865292C652E776179706F696E74733D692C6E7D66756E6374696F6E206C2865297B6F';
wwv_flow_imp.g_varchar2_table(40191) := '2E7570646174652822636F6E6E656374696F6E222C652E636F6E6E656374696F6E2C652E636F6E6E656374696F6E476678297D746869732E73746172743D66756E6374696F6E28652C742C6F297B76617220732C722C612C6C2C633D6E2E676574477261';
wwv_flow_imp.g_varchar2_table(40192) := '70686963732874292C643D6F2D312C683D6F2C753D742E776179706F696E74732C703D755B645D2C673D755B685D2C6D3D7364286E2C752C65293B28723D587428702C672929262628613D2276223D3D3D723F2278223A2279222C303D3D3D6426262870';
wwv_flow_imp.g_varchar2_table(40193) := '3D446428702C742E736F757263652C6129292C683D3D3D752E6C656E6774682D31262628673D446428672C742E7461726765742C6129292C733D7B636F6E6E656374696F6E3A742C7365676D656E745374617274496E6465783A642C7365676D656E7445';
wwv_flow_imp.g_varchar2_table(40194) := '6E64496E6465783A682C7365676D656E7453746172743A702C7365676D656E74456E643A672C617869733A612C64726167506F736974696F6E3A6C3D6D3F6D2E706F696E743A7B783A28702E782B672E78292F322C793A28702E792B672E79292F327D7D';
wwv_flow_imp.g_varchar2_table(40195) := '2C692E696E697428652C6C2C22636F6E6E656374696F6E5365676D656E742E6D6F7665222C7B637572736F723A2278223D3D3D613F22726573697A652D6577223A22726573697A652D6E73222C646174613A7B636F6E6E656374696F6E3A742C636F6E6E';
wwv_flow_imp.g_varchar2_table(40196) := '656374696F6E4766783A632C636F6E746578743A737D7D29297D2C742E6F6E2822636F6E6E656374696F6E5365676D656E742E6D6F76652E7374617274222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D652E636F6E6E';
wwv_flow_imp.g_varchar2_table(40197) := '656374696F6E2C6F3D6E2E6765744C6179657228226F7665726C61797322293B742E6F726967696E616C576179706F696E74733D692E776179706F696E74732E736C69636528292C742E647261676765724766783D6164286F2C742E7365676D656E7453';
wwv_flow_imp.g_varchar2_table(40198) := '746172742C742E7365676D656E74456E64292C626528742E64726167676572476678292E6164642822646A732D6472616767696E6722292C6E2E6164644D61726B657228692C7864297D29292C742E6F6E2822636F6E6E656374696F6E5365676D656E74';
wwv_flow_imp.g_varchar2_table(40199) := '2E6D6F76652E6D6F7665222C2866756E6374696F6E2865297B76617220742C6E2C693D652E636F6E746578742C6F3D692E636F6E6E656374696F6E2C733D692E7365676D656E745374617274496E6465782C723D692E7365676D656E74456E64496E6465';
wwv_flow_imp.g_varchar2_table(40200) := '782C633D692E7365676D656E7453746172742C643D692E7365676D656E74456E642C683D692E617869732C753D692E6F726967696E616C576179706F696E74732E736C69636528292C703D6B6428632C682C655B2264222B685D292C673D6B6428642C68';
wwv_flow_imp.g_varchar2_table(40201) := '2C655B2264222B685D292C6D3D752E6C656E6774682C663D303B755B735D3D702C755B725D3D672C733C32262628743D576E286F2E736F757263652C70292C313D3D3D733F22696E74657273656374223D3D3D74262628752E736869667428292C755B30';
wwv_flow_imp.g_varchar2_table(40202) := '5D3D702C662D2D293A22696E7465727365637422213D3D74262628752E756E73686966742863292C662B2B29292C723E6D2D332626286E3D576E286F2E7461726765742C67292C723D3D3D6D2D323F22696E74657273656374223D3D3D6E262628752E70';
wwv_flow_imp.g_varchar2_table(40203) := '6F7028292C755B752E6C656E6774682D315D3D67293A22696E7465727365637422213D3D6E2626752E70757368286429292C692E6E6577576179706F696E74733D6F2E776179706F696E74733D61286F2C75292C66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(40204) := '76617220692C6F2C732C722C612C6C2C633D652E6E6577576179706F696E74732C643D28693D6E2C6F3D635B652E7365676D656E745374617274496E6465782B745D2C733D635B652E7365676D656E74456E64496E6465782B745D2C723D4C6428652E61';
wwv_flow_imp.g_varchar2_table(40205) := '786973292C613D4D6174682E6D6178286F5B725D2C735B725D292C6C3D4D6174682E6D696E286F5B725D2C735B725D292C4564286F2C722C4D6174682E6D696E284D6174682E6D6178286C2B32302C695B725D292C612D32302929293B626928652E6472';
wwv_flow_imp.g_varchar2_table(40206) := '61676765724766782C642E782C642E79297D28692C662C65292C692E6E65775365676D656E745374617274496E6465783D732B662C6C2865297D29292C742E6F6E2822636F6E6E656374696F6E5365676D656E742E6D6F76652E686F766572222C286675';
wwv_flow_imp.g_varchar2_table(40207) := '6E6374696F6E2865297B652E636F6E746578742E686F7665723D652E686F7665722C6E2E6164644D61726B657228652E686F7665722C5364297D29292C742E6F6E285B22636F6E6E656374696F6E5365676D656E742E6D6F76652E6F7574222C22636F6E';
wwv_flow_imp.g_varchar2_table(40208) := '6E656374696F6E5365676D656E742E6D6F76652E636C65616E7570225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E686F7665723B7426266E2E72656D6F76654D61726B657228742C5364297D29292C742E6F6E2822636F';
wwv_flow_imp.g_varchar2_table(40209) := '6E6E656374696F6E5365676D656E742E6D6F76652E636C65616E7570222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D742E636F6E6E656374696F6E3B742E647261676765724766782626526528742E64726167676572';
wwv_flow_imp.g_varchar2_table(40210) := '476678292C6E2E72656D6F76654D61726B657228692C7864297D29292C742E6F6E285B22636F6E6E656374696F6E5365676D656E742E6D6F76652E63616E63656C222C22636F6E6E656374696F6E5365676D656E742E6D6F76652E656E64225D2C286675';
wwv_flow_imp.g_varchar2_table(40211) := '6E6374696F6E2865297B76617220743D652E636F6E746578743B742E636F6E6E656374696F6E2E776179706F696E74733D742E6F726967696E616C576179706F696E74732C6C2865297D29292C742E6F6E2822636F6E6E656374696F6E5365676D656E74';
wwv_flow_imp.g_varchar2_table(40212) := '2E6D6F76652E656E64222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E636F6E6E656374696F6E2C693D742E6E6577576179706F696E74732C6F3D742E6E65775365676D656E745374617274496E6465783B693D69';
wwv_flow_imp.g_varchar2_table(40213) := '2E6D6170282866756E6374696F6E2865297B72657475726E7B6F726967696E616C3A652E6F726967696E616C2C783A4D6174682E726F756E6428652E78292C793A4D6174682E726F756E6428652E79297D7D29293B76617220723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(40214) := '652C74297B766172206E3D302C693D652E66696C746572282866756E6374696F6E28692C6F297B72657475726E21597428655B6F2D315D2C655B6F2B315D2C69297C7C286E3D6F3C3D743F6E2D313A6E2C2131297D29293B72657475726E7B776179706F';
wwv_flow_imp.g_varchar2_table(40215) := '696E74733A692C7365676D656E744F66667365743A6E7D7D28692C6F292C6C3D61286E2C722E776179706F696E7473292C633D722E7365676D656E744F66667365742C643D7B7365676D656E744D6F76653A7B7365676D656E745374617274496E646578';
wwv_flow_imp.g_varchar2_table(40216) := '3A742E7365676D656E745374617274496E6465782C6E65775365676D656E745374617274496E6465783A6F2B637D7D3B732E757064617465576179706F696E7473286E2C6C2C64297D29297D54642E24696E6A6563743D5B22696E6A6563746F72222C22';
wwv_flow_imp.g_varchar2_table(40217) := '6576656E74427573222C2263616E766173222C226472616767696E67222C226772617068696373466163746F7279222C226D6F64656C696E67225D3B7661722049643D4D6174682E6162732C4D643D4D6174682E726F756E643B66756E6374696F6E2041';
wwv_flow_imp.g_varchar2_table(40218) := '642865297B72657475726E7B783A652E782C793A652E797D7D66756E6374696F6E204E642865297B72657475726E7B783A652E782B652E77696474682C793A652E792B652E6865696768747D7D66756E6374696F6E20506428652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(40219) := '21657C7C69734E614E28652E78297C7C69734E614E28652E79293F743A7B783A4D6428652E782B652E77696474682F32292C793A4D6428652E792B652E6865696768742F32297D7D66756E6374696F6E204F6428652C74297B766172206E3D652E736E61';
wwv_flow_imp.g_varchar2_table(40220) := '707065643B72657475726E21216E26262822737472696E67223D3D747970656F6620743F6E5B745D3A6E2E7826266E2E79297D66756E6374696F6E20526428652C742C6E297B69662822737472696E6722213D747970656F662074297468726F77206E65';
wwv_flow_imp.g_varchar2_table(40221) := '77204572726F72282261786973206D75737420626520696E205B782C20795D22293B696628226E756D62657222213D747970656F66206E26262131213D3D6E297468726F77206E6577204572726F72282276616C7565206D757374206265204E756D6265';
wwv_flow_imp.g_varchar2_table(40222) := '72206F722066616C736522293B76617220692C6F3D655B745D2C733D652E736E61707065643D652E736E61707065647C7C7B7D3B72657475726E21313D3D3D6E3F735B745D3D21313A28735B745D3D21302C693D6E2D6F2C655B745D2B3D692C655B2264';
wwv_flow_imp.g_varchar2_table(40223) := '222B745D2B3D69292C6F7D66756E6374696F6E2046642865297B72657475726E20652E6368696C6472656E7C7C5B5D7D7661722042643D4D6174682E6162732C56643D4D6174682E726F756E643B66756E6374696F6E207A642865297B66756E6374696F';
wwv_flow_imp.g_varchar2_table(40224) := '6E207428652C74297B69662828302C692E637929286529297B666F7228766172206E3D652E6C656E6774683B6E2D2D3B29696628426428655B6E5D2D74293C3D31302972657475726E20655B6E5D7D656C73657B766172206F3D742528653D2B65293B69';
wwv_flow_imp.g_varchar2_table(40225) := '66286F3C31302972657475726E20742D6F3B6966286F3E652D31302972657475726E20742D6F2B657D72657475726E20747D66756E6374696F6E206E28652C74297B72657475726E20652E776179706F696E74733F28693D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(40226) := '297B666F7228766172206E2C693D742E776179706F696E74732C6F3D312F302C733D303B733C692E6C656E6774682D313B732B2B297B76617220723D746428652C5B695B735D2C695B732B315D5D293B723C6F2626286F3D722C6E3D73297D7265747572';
wwv_flow_imp.g_varchar2_table(40227) := '6E5B695B6E5D2C695B6E2B315D5D7D286E3D742C65292C6564286E2C6929293A652E77696474683F7B783A566428652E77696474682F322B652E78292C793A566428652E6865696768742F322B652E79297D3A766F696420303B766172206E2C697D652E';
wwv_flow_imp.g_varchar2_table(40228) := '6F6E2822636F6E6E656374696F6E5365676D656E742E6D6F76652E6D6F7665222C313530302C2866756E6374696F6E2865297B766172206F2C732C723D66756E6374696F6E2865297B76617220743D652E636F6E746578742C6F3D742E736E6170506F69';
wwv_flow_imp.g_varchar2_table(40229) := '6E74732C733D742E636F6E6E656374696F6E2C723D732E776179706F696E74732C613D742E7365676D656E7453746172742C6C3D742E7365676D656E745374617274496E6465782C633D742E7365676D656E74456E642C643D742E7365676D656E74456E';
wwv_flow_imp.g_varchar2_table(40230) := '64496E6465782C683D742E617869733B6966286F2972657475726E206F3B76617220753D5B725B6C2D315D2C612C632C725B642B315D5D3B72657475726E206C3C322626752E756E7368696674286E28732E736F757263652C6529292C643E722E6C656E';
wwv_flow_imp.g_varchar2_table(40231) := '6774682D332626752E756E7368696674286E28732E7461726765742C6529292C742E736E6170506F696E74733D6F3D7B686F72697A6F6E74616C3A5B5D2C766572746963616C3A5B5D7D2C28302C692E6A4A2928752C2866756E6374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(40232) := '262628653D652E6F726967696E616C7C7C652C2279223D3D3D6826266F2E686F72697A6F6E74616C2E7075736828652E79292C2278223D3D3D6826266F2E766572746963616C2E7075736828652E7829297D29292C6F7D2865292C613D652E782C6C3D65';
wwv_flow_imp.g_varchar2_table(40233) := '2E793B69662872297B76617220633D612D286F3D7428722E766572746963616C2C6129292C643D6C2D28733D7428722E686F72697A6F6E74616C2C6C29293B28302C692E6B702928652C7B64783A652E64782D632C64793A652E64792D642C783A6F2C79';
wwv_flow_imp.g_varchar2_table(40234) := '3A737D292C28637C7C2D31213D3D722E766572746963616C2E696E6465784F66286129292626526428652C2278222C6F292C28647C7C2D31213D3D722E686F72697A6F6E74616C2E696E6465784F66286C29292626526428652C2279222C73297D7D2929';
wwv_flow_imp.g_varchar2_table(40235) := '2C652E6F6E285B22636F6E6E6563742E686F766572222C22636F6E6E6563742E6D6F7665222C22636F6E6E6563742E656E64225D2C313530302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E686F7665722C693D7426266E28';
wwv_flow_imp.g_varchar2_table(40236) := '742C65293B4F6E2874292626692626692E782626692E79262628526428652C2278222C692E78292C526428652C2279222C692E7929297D29292C652E6F6E285B2262656E64706F696E742E6D6F76652E6D6F7665222C2262656E64706F696E742E6D6F76';
wwv_flow_imp.g_varchar2_table(40237) := '652E656E64225D2C313530302C2866756E6374696F6E2865297B766172206F2C732C723D652E636F6E746578742C613D66756E6374696F6E2865297B76617220743D652E736E6170506F696E74732C6E3D652E636F6E6E656374696F6E2E776179706F69';
wwv_flow_imp.g_varchar2_table(40238) := '6E74732C6F3D652E62656E64706F696E74496E6465783B696628742972657475726E20743B76617220733D5B6E5B6F2D315D2C6E5B6F2B315D5D3B72657475726E20652E736E6170506F696E74733D743D7B686F72697A6F6E74616C3A5B5D2C76657274';
wwv_flow_imp.g_varchar2_table(40239) := '6963616C3A5B5D7D2C28302C692E6A4A2928732C2866756E6374696F6E2865297B65262628653D652E6F726967696E616C7C7C652C742E686F72697A6F6E74616C2E7075736828652E79292C742E766572746963616C2E7075736828652E7829297D2929';
wwv_flow_imp.g_varchar2_table(40240) := '2C747D2872292C6C3D722E686F7665722C633D6C26266E286C2C65292C643D652E782C683D652E793B69662861297B76617220753D642D286F3D7428633F612E766572746963616C2E636F6E636174285B632E785D293A612E766572746963616C2C6429';
wwv_flow_imp.g_varchar2_table(40241) := '292C703D682D28733D7428633F612E686F72697A6F6E74616C2E636F6E636174285B632E795D293A612E686F72697A6F6E74616C2C6829293B28302C692E6B702928652C7B64783A652E64782D752C64793A652E64792D702C783A652E782D752C793A65';
wwv_flow_imp.g_varchar2_table(40242) := '2E792D707D292C28757C7C2D31213D3D612E766572746963616C2E696E6465784F66286429292626526428652C2278222C6F292C28707C7C2D31213D3D612E686F72697A6F6E74616C2E696E6465784F66286829292626526428652C2279222C73297D7D';
wwv_flow_imp.g_varchar2_table(40243) := '29297D7A642E24696E6A6563743D5B226576656E74427573225D3B636F6E73742048643D7B5F5F646570656E64735F5F3A5B6A632C4B635D2C5F5F696E69745F5F3A5B2262656E64706F696E7473222C2262656E64706F696E74536E617070696E67222C';
wwv_flow_imp.g_varchar2_table(40244) := '2262656E64706F696E744D6F766550726576696577225D2C62656E64706F696E74733A5B2274797065222C63645D2C62656E64706F696E744D6F76653A5B2274797065222C67645D2C62656E64706F696E744D6F7665507265766965773A5B2274797065';
wwv_flow_imp.g_varchar2_table(40245) := '222C43645D2C636F6E6E656374696F6E5365676D656E744D6F76653A5B2274797065222C54645D2C62656E64706F696E74536E617070696E673A5B2274797065222C7A645D7D3B66756E6374696F6E20576428652C742C6E2C6F297B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40246) := '207328652C74297B72657475726E206F2E616C6C6F7765642822636F6E6E656374696F6E2E637265617465222C7B736F757263653A652C7461726765743A747D297D652E6F6E2822636F6E6E6563742E686F766572222C2866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(40247) := '76617220742C6E3D652E636F6E746578742C6F3D6E2E73746172742C723D652E686F7665723B6966286E2E686F7665723D722C743D6E2E63616E457865637574653D73286F2C72292C2128302C692E674429287429297B6966282131213D3D7429726574';
wwv_flow_imp.g_varchar2_table(40248) := '75726E206E2E736F757263653D6F2C766F6964286E2E7461726765743D72293B743D6E2E63616E457865637574653D7328722C6F292C28302C692E6744292874297C7C2131213D3D742626286E2E736F757263653D722C6E2E7461726765743D6F297D7D';
wwv_flow_imp.g_varchar2_table(40249) := '29292C652E6F6E285B22636F6E6E6563742E6F7574222C22636F6E6E6563742E636C65616E7570225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578743B742E686F7665723D6E756C6C2C742E736F757263653D6E756C6C2C742E';
wwv_flow_imp.g_varchar2_table(40250) := '7461726765743D6E756C6C2C742E63616E457865637574653D21317D29292C652E6F6E2822636F6E6E6563742E656E64222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6F3D742E63616E457865637574652C733D742E636F';
wwv_flow_imp.g_varchar2_table(40251) := '6E6E656374696F6E53746172742C723D7B783A652E782C793A652E797D2C613D742E736F757263652C6C3D742E7461726765743B696628216F2972657475726E21313B76617220633D6E756C6C2C643D7B636F6E6E656374696F6E53746172743A6A6428';
wwv_flow_imp.g_varchar2_table(40252) := '74293F723A732C636F6E6E656374696F6E456E643A6A642874293F733A727D3B28302C692E477629286F29262628633D6F292C742E636F6E6E656374696F6E3D6E2E636F6E6E65637428612C6C2C632C64297D29292C746869732E73746172743D66756E';
wwv_flow_imp.g_varchar2_table(40253) := '6374696F6E28652C6E2C6F2C73297B28302C692E477629286F297C7C28733D6F2C6F3D486E286E29292C742E696E697428652C22636F6E6E656374222C7B6175746F41637469766174653A732C646174613A7B73686170653A6E2C636F6E746578743A7B';
wwv_flow_imp.g_varchar2_table(40254) := '73746172743A6E2C636F6E6E656374696F6E53746172743A6F7D7D7D297D7D66756E6374696F6E206A642865297B76617220743D652E686F7665722C6E3D652E736F757263652C693D652E7461726765743B72657475726E207426266E2626743D3D3D6E';
wwv_flow_imp.g_varchar2_table(40255) := '26266E213D3D697D57642E24696E6A6563743D5B226576656E74427573222C226472616767696E67222C226D6F64656C696E67222C2272756C6573225D3B7661722071643D22636F6E6E6563742D6F6B222C24643D22636F6E6E6563742D6E6F742D6F6B';
wwv_flow_imp.g_varchar2_table(40256) := '223B66756E6374696F6E20556428652C742C6E297B76617220693D652E6765742822636F6E6E656374696F6E50726576696577222C2131293B692626742E6F6E2822636F6E6E6563742E6D6F7665222C2866756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(40257) := '2E636F6E746578742C6E3D742E63616E457865637574652C6F3D742E686F7665722C733D742E736F757263652C723D742E73746172742C613D742E7374617274506F736974696F6E2C6C3D742E7461726765742C633D742E636F6E6E656374696F6E5374';
wwv_flow_imp.g_varchar2_table(40258) := '6172747C7C612C643D742E636F6E6E656374696F6E456E647C7C7B783A652E782C793A652E797D2C683D632C753D643B6A64287429262628683D642C753D63292C692E647261775072657669657728742C6E2C7B736F757263653A737C7C722C74617267';
wwv_flow_imp.g_varchar2_table(40259) := '65743A6C7C7C6F2C636F6E6E656374696F6E53746172743A682C636F6E6E656374696F6E456E643A757D297D29292C742E6F6E2822636F6E6E6563742E686F766572222C3930302C2866756E6374696F6E2865297B76617220743D652E636F6E74657874';
wwv_flow_imp.g_varchar2_table(40260) := '2C693D652E686F7665722C6F3D742E63616E457865637574653B6E756C6C213D3D6F26266E2E6164644D61726B657228692C6F3F71643A2464297D29292C742E6F6E285B22636F6E6E6563742E6F7574222C22636F6E6E6563742E636C65616E7570225D';
wwv_flow_imp.g_varchar2_table(40261) := '2C313130302C2866756E6374696F6E2865297B76617220743D652E686F7665723B742626286E2E72656D6F76654D61726B657228742C7164292C6E2E72656D6F76654D61726B657228742C246429297D29292C692626742E6F6E2822636F6E6E6563742E';
wwv_flow_imp.g_varchar2_table(40262) := '636C65616E7570222C2866756E6374696F6E2865297B692E636C65616E557028652E636F6E74657874297D29297D55642E24696E6A6563743D5B22696E6A6563746F72222C226576656E74427573222C2263616E766173225D3B636F6E7374204B643D7B';
wwv_flow_imp.g_varchar2_table(40263) := '5F5F646570656E64735F5F3A5B24722C4B632C6A635D2C5F5F696E69745F5F3A5B22636F6E6E65637450726576696577225D2C636F6E6E6563743A5B2274797065222C57645D2C636F6E6E656374507265766965773A5B2274797065222C55645D7D3B66';
wwv_flow_imp.g_varchar2_table(40264) := '756E6374696F6E20476428652C742C6E2C69297B746869732E5F63616E7661733D742C746869732E5F6772617068696373466163746F72793D6E2C746869732E5F656C656D656E74466163746F72793D692C746869732E5F636F6E6E656374696F6E446F';
wwv_flow_imp.g_varchar2_table(40265) := '636B696E673D652E6765742822636F6E6E656374696F6E446F636B696E67222C2131292C746869732E5F6C61796F757465723D652E67657428226C61796F75746572222C2131297D47642E24696E6A6563743D5B22696E6A6563746F72222C2263616E76';
wwv_flow_imp.g_varchar2_table(40266) := '6173222C226772617068696373466163746F7279222C22656C656D656E74466163746F7279225D2C47642E70726F746F747970652E64726177507265766965773D66756E6374696F6E28652C742C6E297B6E3D6E7C7C7B7D3B76617220692C6F2C732C72';
wwv_flow_imp.g_varchar2_table(40267) := '3D652E636F6E6E656374696F6E507265766965774766782C613D652E676574436F6E6E656374696F6E2C6C3D6E2E736F757263652C633D6E2E7461726765742C643D6E2E776179706F696E74732C683D6E2E636F6E6E656374696F6E53746172742C753D';
wwv_flow_imp.g_varchar2_table(40268) := '6E2E636F6E6E656374696F6E456E642C703D6E2E6E6F4C61796F75742C673D6E2E6E6F43726F7070696E672C6D3D6E2E6E6F4E6F6F702C663D746869733B727C7C28723D652E636F6E6E656374696F6E507265766965774766783D746869732E63726561';
wwv_flow_imp.g_varchar2_table(40269) := '7465436F6E6E656374696F6E507265766965774766782829292C79652872292C617C7C28613D652E676574436F6E6E656374696F6E3D286F3D66756E6374696F6E28652C742C6E297B72657475726E20662E676574436F6E6E656374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(40270) := '6E297D2C733D7B7D2C66756E6374696F6E2865297B76617220743D4A534F4E2E737472696E676966792865292C6E3D735B745D3B72657475726E206E7C7C286E3D735B745D3D6F2E6170706C79286E756C6C2C617267756D656E747329292C6E7D29292C';
wwv_flow_imp.g_varchar2_table(40271) := '74262628693D6128742C6C2C6329292C693F28692E776179706F696E74733D647C7C5B5D2C746869732E5F6C61796F7574657226262170262628692E776179706F696E74733D746869732E5F6C61796F757465722E6C61796F7574436F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(40272) := '6E28692C7B736F757263653A6C2C7461726765743A632C636F6E6E656374696F6E53746172743A682C636F6E6E656374696F6E456E643A752C776179706F696E74733A6E2E776179706F696E74737C7C692E776179706F696E74737D29292C692E776179';
wwv_flow_imp.g_varchar2_table(40273) := '706F696E74732626692E776179706F696E74732E6C656E6774687C7C28692E776179706F696E74733D5B6C3F486E286C293A682C633F486E2863293A755D292C746869732E5F636F6E6E656374696F6E446F636B696E672626286C7C7C63292626216726';
wwv_flow_imp.g_varchar2_table(40274) := '2628692E776179706F696E74733D746869732E5F636F6E6E656374696F6E446F636B696E672E67657443726F70706564576179706F696E747328692C6C2C6329292C746869732E5F6772617068696373466163746F72792E64726177436F6E6E65637469';
wwv_flow_imp.g_varchar2_table(40275) := '6F6E28722C692C7B7374726F6B653A22766172282D2D656C656D656E742D647261676765722D636F6C6F7229227D29293A216D2626746869732E647261774E6F6F705072657669657728722C6E297D2C47642E70726F746F747970652E647261774E6F6F';
wwv_flow_imp.g_varchar2_table(40276) := '70507265766965773D66756E6374696F6E28652C74297B766172206E3D742E736F757263652C693D742E7461726765742C6F3D742E636F6E6E656374696F6E53746172747C7C486E286E292C733D742E636F6E6E656374696F6E456E647C7C486E286929';
wwv_flow_imp.g_varchar2_table(40277) := '2C723D746869732E63726F70576179706F696E7473286F2C732C6E2C69293B756528652C746869732E6372656174654E6F6F70436F6E6E656374696F6E28725B305D2C725B315D29297D2C47642E70726F746F747970652E63726F70576179706F696E74';
wwv_flow_imp.g_varchar2_table(40278) := '733D66756E6374696F6E28652C742C6E2C69297B766172206F3D746869732E5F6772617068696373466163746F72792C733D6E26266F2E676574536861706550617468286E292C723D6926266F2E6765745368617065506174682869292C613D6F2E6765';
wwv_flow_imp.g_varchar2_table(40279) := '74436F6E6E656374696F6E50617468287B776179706F696E74733A5B652C745D7D293B72657475726E5B653D6E26266A6E28732C612C2130297C7C652C743D6926266A6E28722C612C2131297C7C745D7D2C47642E70726F746F747970652E636C65616E';
wwv_flow_imp.g_varchar2_table(40280) := '55703D66756E6374696F6E2865297B652626652E636F6E6E656374696F6E507265766965774766782626526528652E636F6E6E656374696F6E50726576696577476678297D2C47642E70726F746F747970652E676574436F6E6E656374696F6E3D66756E';
wwv_flow_imp.g_varchar2_table(40281) := '6374696F6E2865297B76617220743D66756E6374696F6E2865297B72657475726E28302C692E4776292865293F653A7B7D7D2865293B72657475726E20746869732E5F656C656D656E74466163746F72792E637265617465436F6E6E656374696F6E2874';
wwv_flow_imp.g_varchar2_table(40282) := '297D2C47642E70726F746F747970652E637265617465436F6E6E656374696F6E507265766965774766783D66756E6374696F6E28297B76617220653D6B6528226722293B72657475726E20666528652C7B706F696E7465724576656E74733A226E6F6E65';
wwv_flow_imp.g_varchar2_table(40283) := '227D292C62652865292E6164642822646A732D6472616767657222292C756528746869732E5F63616E7661732E6765744163746976654C6179657228292C65292C657D2C47642E70726F746F747970652E6372656174654E6F6F70436F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(40284) := '6E3D66756E6374696F6E28652C74297B72657475726E206E74285B652C745D2C7B7374726F6B653A2223333333222C7374726F6B654461736861727261793A5B315D2C7374726F6B6557696474683A322C22706F696E7465722D6576656E7473223A226E';
wwv_flow_imp.g_varchar2_table(40285) := '6F6E65227D297D3B636F6E73742051643D7B5F5F696E69745F5F3A5B22636F6E6E656374696F6E50726576696577225D2C636F6E6E656374696F6E507265766965773A5B2274797065222C47645D7D2C59643D6E65772024732822707322293B76617220';
wwv_flow_imp.g_varchar2_table(40286) := '5A643D5B226D61726B65722D7374617274222C226D61726B65722D6D6964222C226D61726B65722D656E64225D2C58643D5B22636972636C65222C22656C6C69707365222C226C696E65222C2270617468222C22706F6C79676F6E222C22706F6C796C69';
wwv_flow_imp.g_varchar2_table(40287) := '6E65222C2270617468222C2272656374225D3B66756E6374696F6E204A6428652C742C6E2C69297B746869732E5F656C656D656E7452656769737472793D652C746869732E5F63616E7661733D6E2C746869732E5F7374796C65733D697D4A642E24696E';
wwv_flow_imp.g_varchar2_table(40288) := '6A6563743D5B22656C656D656E745265676973747279222C226576656E74427573222C2263616E766173222C227374796C6573225D2C4A642E70726F746F747970652E636C65616E55703D66756E6374696F6E28297B636F6E736F6C652E7761726E2822';
wwv_flow_imp.g_varchar2_table(40289) := '50726576696577537570706F727423636C65616E5570206973206465707265636174656420616E642077696C6C2062652072656D6F76656420696E206675747572652076657273696F6E732E20596F7520646F206E6F74206E65656420746F206D616E75';
wwv_flow_imp.g_varchar2_table(40290) := '616C6C7920636C65616E20757020707265766965777320616E796D6F72652E2063662E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F6469616772616D2D6A732F70756C6C2F39303622297D2C4A642E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(40291) := '65744766783D66756E6374696F6E2865297B72657475726E20746869732E5F656C656D656E7452656769737472792E67657447726170686963732865297D2C4A642E70726F746F747970652E616464447261676765723D66756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(40292) := '6E2C693D22646A732D6472616767657222297B766172206F3D7765286E3D6E7C7C746869732E676574476678286529292C733D6E2E676574426F756E64696E67436C69656E745265637428293B72657475726E20746869732E5F636C6F6E654D61726B65';
wwv_flow_imp.g_varchar2_table(40293) := '7273286669286F292C69292C6665286F2C746869732E5F7374796C65732E636C7328692C5B5D2C7B783A732E746F702C793A732E6C6566747D29292C756528742C6F292C6665286F2C22646174612D707265766965772D737570706F72742D656C656D65';
wwv_flow_imp.g_varchar2_table(40294) := '6E742D6964222C652E6964292C6F7D2C4A642E70726F746F747970652E6164644672616D653D66756E6374696F6E28652C74297B766172206E3D6B65282272656374222C7B636C6173733A22646A732D726573697A652D6F7665726C6179222C77696474';
wwv_flow_imp.g_varchar2_table(40295) := '683A652E77696474682C6865696768743A652E6865696768742C783A652E782C793A652E797D293B72657475726E20756528742C6E292C6665286E2C22646174612D707265766965772D737570706F72742D656C656D656E742D6964222C652E6964292C';
wwv_flow_imp.g_varchar2_table(40296) := '6E7D2C4A642E70726F746F747970652E5F636C6F6E654D61726B6572733D66756E6374696F6E28652C743D22646A732D64726167676572222C6E3D65297B76617220693D746869733B696628652E6368696C644E6F64657329666F7228766172206F3D30';
wwv_flow_imp.g_varchar2_table(40297) := '3B6F3C652E6368696C644E6F6465732E6C656E6774683B6F2B2B29692E5F636C6F6E654D61726B65727328652E6368696C644E6F6465735B6F5D2C742C6E293B2866756E6374696F6E2865297B72657475726E2D31213D3D58642E696E6465784F662865';
wwv_flow_imp.g_varchar2_table(40298) := '2E6E6F64654E616D65297D2928652926265A642E666F7245616368282866756E6374696F6E286F297B696628666528652C6F29297B76617220733D66756E6374696F6E28652C742C6E297B72657475726E206A7428226D61726B657223222B666528652C';
wwv_flow_imp.g_varchar2_table(40299) := '74292E6D61746368282F75726C5C285B27225D3F23285B5E27225D2A295B27225D3F5C292F295B315D2C6E7C7C646F63756D656E74297D28652C6F2C692E5F63616E7661732E676574436F6E7461696E65722829293B732626692E5F636C6F6E654D6172';
wwv_flow_imp.g_varchar2_table(40300) := '6B6572286E2C652C732C6F2C74297D7D29297D2C4A642E70726F746F747970652E5F636C6F6E654D61726B65723D66756E6374696F6E28652C742C6E2C692C6F3D22646A732D6472616767657222297B76617220733D5B6E2E69642C6F2C59642E6E6578';
wwv_flow_imp.g_varchar2_table(40301) := '7428295D2E6A6F696E28222D22292C723D6A7428226D61726B657223222B6E2E69642C65293B653D657C7C746869732E5F63616E7661732E5F7376673B76617220613D727C7C7765286E293B612E69643D732C62652861292E616464286F293B76617220';
wwv_flow_imp.g_varchar2_table(40302) := '6C3D6A7428223A73636F7065203E2064656673222C65293B6C7C7C756528652C6C3D6B652822646566732229292C7565286C2C61293B76617220633D66756E6374696F6E2865297B72657475726E2275726C2823222B652B2229227D28612E6964293B66';
wwv_flow_imp.g_varchar2_table(40303) := '6528742C692C63297D3B636F6E73742065683D7B5F5F696E69745F5F3A5B2270726576696577537570706F7274225D2C70726576696577537570706F72743A5B2274797065222C4A645D7D2C74683D22636F6D706C65782D70726576696577223B636C61';
wwv_flow_imp.g_varchar2_table(40304) := '7373206E687B636F6E7374727563746F7228652C742C6E297B746869732E5F63616E7661733D652C746869732E5F6772617068696373466163746F72793D742C746869732E5F70726576696577537570706F72743D6E2C746869732E5F6D61726B657273';
wwv_flow_imp.g_varchar2_table(40305) := '3D5B5D7D6372656174652865297B746869732E636C65616E557028293B636F6E73747B637265617465643A743D5B5D2C6D6F7665643A6E3D5B5D2C72656D6F7665643A693D5B5D2C726573697A65643A6F3D5B5D7D3D652C733D746869732E5F63616E76';
wwv_flow_imp.g_varchar2_table(40306) := '61732E6765744C61796572287468293B742E66696C7465722828653D3E2166756E6374696F6E2865297B72657475726E20652E68696464656E7D28652929292E666F72456163682828653D3E7B6C657420743B4F6E2865293F28743D746869732E5F6772';
wwv_flow_imp.g_varchar2_table(40307) := '617068696373466163746F72792E5F637265617465436F6E7461696E65722822636F6E6E656374696F6E222C6B652822672229292C746869732E5F6772617068696373466163746F72792E64726177436F6E6E656374696F6E2866692874292C6529293A';
wwv_flow_imp.g_varchar2_table(40308) := '28743D746869732E5F6772617068696373466163746F72792E5F637265617465436F6E7461696E657228227368617065222C6B652822672229292C746869732E5F6772617068696373466163746F72792E6472617753686170652866692874292C65292C';
wwv_flow_imp.g_varchar2_table(40309) := '626928742C652E782C652E7929292C746869732E5F70726576696577537570706F72742E6164644472616767657228652C732C74297D29292C6E2E666F72456163682828287B656C656D656E743A652C64656C74613A747D293D3E7B746869732E5F7072';
wwv_flow_imp.g_varchar2_table(40310) := '6576696577537570706F72742E6164644472616767657228652C732C766F696420302C22646A732D6472616767696E6722292C746869732E5F63616E7661732E6164644D61726B657228652C22646A732D656C656D656E742D68696464656E22292C7468';
wwv_flow_imp.g_varchar2_table(40311) := '69732E5F6D61726B6572732E70757368285B652C22646A732D656C656D656E742D68696464656E225D293B636F6E7374206E3D746869732E5F70726576696577537570706F72742E6164644472616767657228652C73293B4F6E2865293F6269286E2C74';
wwv_flow_imp.g_varchar2_table(40312) := '2E782C742E79293A6269286E2C652E782B742E782C652E792B742E79297D29292C692E666F72456163682828653D3E7B746869732E5F70726576696577537570706F72742E6164644472616767657228652C732C766F696420302C22646A732D64726167';
wwv_flow_imp.g_varchar2_table(40313) := '67696E6722292C746869732E5F63616E7661732E6164644D61726B657228652C22646A732D656C656D656E742D68696464656E22292C746869732E5F6D61726B6572732E70757368285B652C22646A732D656C656D656E742D68696464656E225D297D29';
wwv_flow_imp.g_varchar2_table(40314) := '292C6F2E666F72456163682828287B73686170653A652C626F756E64733A747D293D3E7B746869732E5F63616E7661732E6164644D61726B657228652C22646A732D68696464656E22292C746869732E5F6D61726B6572732E70757368285B652C22646A';
wwv_flow_imp.g_varchar2_table(40315) := '732D68696464656E225D292C746869732E5F70726576696577537570706F72742E6164644472616767657228652C732C766F696420302C22646A732D6472616767696E6722293B636F6E7374206E3D746869732E5F6772617068696373466163746F7279';
wwv_flow_imp.g_varchar2_table(40316) := '2E5F637265617465436F6E7461696E657228227368617065222C6B652822672229293B746869732E5F6772617068696373466163746F72792E647261775368617065286669286E292C652C7B77696474683A742E77696474682C6865696768743A742E68';
wwv_flow_imp.g_varchar2_table(40317) := '65696768747D292C6269286E2C742E782C742E79292C746869732E5F70726576696577537570706F72742E6164644472616767657228652C732C6E297D29297D636C65616E557028297B796528746869732E5F63616E7661732E6765744C617965722874';
wwv_flow_imp.g_varchar2_table(40318) := '6829292C746869732E5F6D61726B6572732E666F72456163682828285B652C745D293D3E746869732E5F63616E7661732E72656D6F76654D61726B657228652C742929292C746869732E5F6D61726B6572733D5B5D7D73686F7728297B746869732E5F63';
wwv_flow_imp.g_varchar2_table(40319) := '616E7661732E73686F774C61796572287468297D6869646528297B746869732E5F63616E7661732E686964654C61796572287468297D7D6E682E24696E6A6563743D5B2263616E766173222C226772617068696373466163746F7279222C227072657669';
wwv_flow_imp.g_varchar2_table(40320) := '6577537570706F7274225D3B636F6E73742069683D7B5F5F646570656E64735F5F3A5B65685D2C5F5F696E69745F5F3A5B22636F6D706C657850726576696577225D2C636F6D706C6578507265766965773A5B2274797065222C6E685D7D3B766172206F';
wwv_flow_imp.g_varchar2_table(40321) := '683D5B22746F70222C22626F74746F6D222C226C656674222C227269676874225D3B66756E6374696F6E20736828652C74297B66756E6374696F6E206E2865297B6966286473286529297B766172206E3D66756E6374696F6E2865297B76617220743D48';
wwv_flow_imp.g_varchar2_table(40322) := '6E28652E6C6162656C292C6E3D726828486E2865292C74293B696628693D6E2C2D31213D3D6F682E696E6465784F66286929297B76617220692C6F3D66756E6374696F6E2865297B76617220743D486E2865292C6E3D5B5D2E636F6E63617428652E696E';
wwv_flow_imp.g_varchar2_table(40323) := '636F6D696E672E6D6170282866756E6374696F6E2865297B72657475726E20652E776179706F696E74735B652E776179706F696E74732E6C656E6774682D325D7D29292C652E6F7574676F696E672E6D6170282866756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(40324) := '726E20652E776179706F696E74735B315D7D2929292E6D6170282866756E6374696F6E2865297B72657475726E20726828742C65297D29293B72657475726E206E7D2865293B696628652E686F7374297B76617220733D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(40325) := '617220742C6E3D652E686F73742C693D576E28486E2865292C6E293B72657475726E20743D692E696E6465784F6628222D22293E3D303F692E73706C697428222D22293A5B695D2C6F682E66696C746572282866756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(40326) := '6E2D313D3D3D742E696E6465784F662865297D29297D2865293B6F3D6F2E636F6E6361742873297D76617220723D6F682E66696C746572282866756E6374696F6E2865297B72657475726E2D313D3D3D6F2E696E6465784F662865297D29293B6966282D';
wwv_flow_imp.g_varchar2_table(40327) := '313D3D3D722E696E6465784F66286E292972657475726E20725B305D7D7D2865293B6E262666756E6374696F6E28652C6E297B76617220693D486E2865292C6F3D652E6C6162656C2C733D486E286F293B6966286F2E706172656E74297B76617220722C';
wwv_flow_imp.g_varchar2_table(40328) := '613D566E2865293B737769746368286E297B6361736522746F70223A723D7B783A692E782C793A612E746F702D31302D6F2E6865696768742F327D3B627265616B3B63617365226C656674223A723D7B783A612E6C6566742D31302D6F2E77696474682F';
wwv_flow_imp.g_varchar2_table(40329) := '322C793A692E797D3B627265616B3B6361736522626F74746F6D223A723D7B783A692E782C793A612E626F74746F6D2B31302B6F2E6865696768742F327D3B627265616B3B63617365227269676874223A723D7B783A612E72696768742B31302B6F2E77';
wwv_flow_imp.g_varchar2_table(40330) := '696474682F322C793A692E797D7D766172206C3D766128722C73293B742E6D6F76655368617065286F2C6C297D7D28652C6E297D7D65722E63616C6C28746869732C65292C746869732E706F73744578656375746564285B22636F6E6E656374696F6E2E';
wwv_flow_imp.g_varchar2_table(40331) := '637265617465222C22636F6E6E656374696F6E2E6C61796F7574222C22636F6E6E656374696F6E2E757064617465576179706F696E7473225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D742E636F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(40332) := '6E2C6F3D692E736F757263652C733D692E7461726765743B2131213D3D28742E68696E74737C7C7B7D292E637265617465456C656D656E74734265686176696F722626286E286F292C6E287329297D29292C746869732E706F7374457865637574656428';
wwv_flow_imp.g_varchar2_table(40333) := '5B226C6162656C2E637265617465225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D742E73686170653B2131213D3D28742E68696E74737C7C7B7D292E637265617465456C656D656E74734265686176696F7226266E';
wwv_flow_imp.g_varchar2_table(40334) := '28692E6C6162656C546172676574297D29292C746869732E706F73744578656375746564285B22656C656D656E74732E637265617465225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D742E656C656D656E74733B21';
wwv_flow_imp.g_varchar2_table(40335) := '31213D3D28742E68696E74737C7C7B7D292E637265617465456C656D656E74734265686176696F722626692E666F7245616368282866756E6374696F6E2865297B6E2865297D29297D29297D66756E6374696F6E20726828652C74297B72657475726E20';
wwv_flow_imp.g_varchar2_table(40336) := '576E28742C652C35297D66756E6374696F6E2061682865297B65722E63616C6C28746869732C65292C746869732E70726545786563757465282273686170652E617070656E64222C2866756E6374696F6E2865297B76617220743D652E736F757263652C';
wwv_flow_imp.g_varchar2_table(40337) := '6E3D652E73686170653B652E706F736974696F6E7C7C2828302C792E697329286E2C2262706D6E3A54657874416E6E6F746174696F6E22293F652E706F736974696F6E3D7B783A742E782B742E77696474682F322B37352C793A742E792D35302D6E2E68';
wwv_flow_imp.g_varchar2_table(40338) := '65696768742F327D3A652E706F736974696F6E3D7B783A742E782B742E77696474682B38302B6E2E77696474682F322C793A742E792B742E6865696768742F327D297D292C2130297D66756E6374696F6E206C6828652C74297B652E696E766F6B652865';
wwv_flow_imp.g_varchar2_table(40339) := '722C74686973292C746869732E706F737445786563757465282273686170652E6D6F7665222C2866756E6374696F6E2865297B766172206E3D652E6E6577506172656E742C6F3D652E73686170652C733D28302C692E706229286F2E696E636F6D696E67';
wwv_flow_imp.g_varchar2_table(40340) := '2E636F6E636174286F2E6F7574676F696E67292C2866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A4173736F63696174696F6E22297D29293B28302C692E6A4A2928732C2866756E6374696F6E2865297B742E6D';
wwv_flow_imp.g_varchar2_table(40341) := '6F7665436F6E6E656374696F6E28652C7B783A302C793A307D2C6E297D29297D292C2130297D66756E6374696F6E20636828652C74297B742E696E766F6B652865722C74686973292C746869732E5F62706D6E5265706C6163653D653B766172206E3D74';
wwv_flow_imp.g_varchar2_table(40342) := '6869733B746869732E706F737445786563757465642822656C656D656E74732E637265617465222C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E74733B313D3D3D28743D742E66696C746572282866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(40343) := '65297B72657475726E20646828652C652E686F7374297D2929292E6C656E6774682626742E6D6170282866756E6374696F6E2865297B72657475726E20742E696E6465784F662865297D29292E666F7245616368282866756E6374696F6E2869297B7661';
wwv_flow_imp.g_varchar2_table(40344) := '72206F3D745B695D3B652E656C656D656E74735B695D3D6E2E5F7265706C616365536861706528745B695D2C6F297D29297D292C2130292C746869732E707265457865637574652822656C656D656E74732E6D6F7665222C3530302C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(40345) := '6E2865297B76617220743D652E7368617065732C693D652E6E6577486F73743B696628313D3D3D742E6C656E677468297B766172206F3D745B305D3B6468286F2C6929262628652E7368617065733D5B6E2E5F7265706C6163655368617065286F2C6929';
wwv_flow_imp.g_varchar2_table(40346) := '5D297D7D292C2130297D66756E6374696F6E20646828652C74297B72657475726E21526E286529262628302C792E6973416E792928652C5B2262706D6E3A496E7465726D6564696174655468726F774576656E74222C2262706D6E3A496E7465726D6564';
wwv_flow_imp.g_varchar2_table(40347) := '6961746543617463684576656E74225D2926262121747D66756E6374696F6E20686828652C74297B66756E6374696F6E206E2865297B72657475726E28302C692E70622928652E6174746163686572732C2866756E6374696F6E2865297B72657475726E';
wwv_flow_imp.g_varchar2_table(40348) := '28302C792E69732928652C2262706D6E3A426F756E646172794576656E7422297D29297D65722E63616C6C28746869732C65292C746869732E706F7374457865637574652822636F6E6E656374696F6E2E637265617465222C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(40349) := '297B76617220693D652E636F6E746578742E736F757263652C6F3D652E636F6E746578742E7461726765742C733D6E286F293B28302C792E69732928692C2262706D6E3A4576656E744261736564476174657761792229262628302C792E697329286F2C';
wwv_flow_imp.g_varchar2_table(40350) := '2262706D6E3A526563656976655461736B22292626732E6C656E6774683E302626742E72656D6F7665456C656D656E74732873297D29292C746869732E706F7374457865637574652822636F6E6E656374696F6E2E7265636F6E6E656374222C2866756E';
wwv_flow_imp.g_varchar2_table(40351) := '6374696F6E2865297B766172206F3D652E636F6E746578742E6F6C64536F757263652C733D652E636F6E746578742E6E6577536F757263653B28302C792E697329286F2C2262706D6E3A476174657761792229262628302C792E69732928732C2262706D';
wwv_flow_imp.g_varchar2_table(40352) := '6E3A4576656E744261736564476174657761792229262628302C692E6A4A2928732E6F7574676F696E672C2866756E6374696F6E2865297B76617220693D652E7461726765742C6F3D6E2869293B28302C792E69732928692C2262706D6E3A5265636569';
wwv_flow_imp.g_varchar2_table(40353) := '76655461736B222926266F2E6C656E6774683E302626742E72656D6F7665456C656D656E7473286F297D29297D29297D66756E6374696F6E20756828652C742C6E297B66756E6374696F6E20692865297B742E75706461746550726F7065727469657328';
wwv_flow_imp.g_varchar2_table(40354) := '652C7B6973466F72436F6D70656E736174696F6E3A21307D297D66756E6374696F6E206F2865297B742E75706461746550726F7065727469657328652C7B6973466F72436F6D70656E736174696F6E3A766F696420307D297D65722E63616C6C28746869';
wwv_flow_imp.g_varchar2_table(40355) := '732C65292C746869732E70726545786563757465282273686170652E7265706C616365222C2866756E6374696F6E2865297B636F6E73747B6E6577446174613A6E2C6F6C6453686170653A697D3D653B696628676828652E6F6C64536861706529262622';
wwv_flow_imp.g_varchar2_table(40356) := '62706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22213D3D6E2E6576656E74446566696E6974696F6E547970657C7C2262706D6E3A426F756E646172794576656E7422213D3D6E2E74797065297B636F6E737420743D692E6F75';
wwv_flow_imp.g_varchar2_table(40357) := '74676F696E672E66696E642828287B7461726765743A657D293D3E706828652929293B742626742E746172676574262628652E5F636F6E6E656374696F6E5461726765743D742E746172676574297D656C73652069662821676828652E6F6C6453686170';
wwv_flow_imp.g_varchar2_table(40358) := '652926262262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E223D3D3D6E2E6576656E74446566696E6974696F6E5479706526262262706D6E3A426F756E646172794576656E74223D3D3D6E2E74797065297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(40359) := '3D692E6F7574676F696E672E66696E642828287B7461726765743A657D293D3E6D6828652929293B6E26266E2E746172676574262628652E5F636F6E6E656374696F6E5461726765743D6E2E746172676574292C66756E6374696F6E2865297B636F6E73';
wwv_flow_imp.g_varchar2_table(40360) := '74206E3D652E6F7574676F696E672E66696C7465722828653D3E28302C792E69732928652C2262706D6E3A53657175656E6365466C6F77222929293B742E72656D6F7665456C656D656E7473286E297D2869297D7D292C2130292C746869732E706F7374';
wwv_flow_imp.g_varchar2_table(40361) := '4578656375746564282273686170652E7265706C616365222C2866756E6374696F6E2865297B636F6E73747B5F636F6E6E656374696F6E5461726765743A6E2C6E657753686170653A697D3D653B6E2626742E636F6E6E65637428692C6E297D292C2130';
wwv_flow_imp.g_varchar2_table(40362) := '292C746869732E707265457865637574652822636F6E6E656374696F6E2E637265617465222C2866756E6374696F6E2865297B636F6E7374206E3D652E636F6E6E656374696F6E2C6F3D652E736F757263652C733D652E7461726765743B6768286F2926';
wwv_flow_imp.g_varchar2_table(40363) := '266D68287329262628692873292C66756E6374696F6E28652C6E297B636F6E737420693D652E6F7574676F696E672E66696C7465722828653D3E28302C792E69732928652C2262706D6E3A4173736F63696174696F6E222929293B692E66696C74657228';
wwv_flow_imp.g_varchar2_table(40364) := '28653D3E706828652E746172676574292626216E2E696E636C7564657328652929292E666F72456163682828653D3E742E72656D6F7665436F6E6E656374696F6E28652929297D286F2C5B6E5D29297D292C2130292C746869732E706F73744578656375';
wwv_flow_imp.g_varchar2_table(40365) := '7465642822636F6E6E656374696F6E2E64656C657465222C2866756E6374696F6E2865297B636F6E737420743D652E736F757263652C6E3D652E7461726765743B676828742926267068286E2926266F286E297D292C2130292C746869732E706F737445';
wwv_flow_imp.g_varchar2_table(40366) := '786563757465642822636F6E6E656374696F6E2E7265636F6E6E656374222C2866756E6374696F6E2865297B636F6E737420743D652E6E65775461726765742C6E3D652E6F6C64536F757263652C733D652E6F6C645461726765743B69662873213D3D74';
wwv_flow_imp.g_varchar2_table(40367) := '297B636F6E737420653D6E3B706828732926266F2873292C676828652926266D682874292626692874297D7D292C2130292C746869732E706F737445786563757465642822656C656D656E742E75706461746550726F70657274696573222C2866756E63';
wwv_flow_imp.g_varchar2_table(40368) := '74696F6E2865297B636F6E73747B656C656D656E743A697D3D653B70682869293F2866756E6374696F6E2865297B666F7228636F6E73742069206F6620652E696E636F6D696E67296E2E63616E436F6E6E65637428692E736F757263652C65297C7C742E';
wwv_flow_imp.g_varchar2_table(40369) := '72656D6F7665436F6E6E656374696F6E2869293B666F7228636F6E73742069206F6620652E6F7574676F696E67296E2E63616E436F6E6E65637428652C692E746172676574297C7C742E72656D6F7665436F6E6E656374696F6E2869297D2869292C6675';
wwv_flow_imp.g_varchar2_table(40370) := '6E6374696F6E2865297B636F6E7374206E3D652E6174746163686572732E736C69636528293B6E2E6C656E6774682626742E72656D6F7665456C656D656E7473286E297D286929293A6D68286929262666756E6374696F6E2865297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(40371) := '652E696E636F6D696E672E66696C7465722828653D3E676828652E736F757263652929293B742E72656D6F7665456C656D656E7473286E297D2869297D292C2130297D66756E6374696F6E2070682865297B636F6E737420743D28302C792E6765744275';
wwv_flow_imp.g_varchar2_table(40372) := '73696E6573734F626A656374292865293B72657475726E20742626742E67657428226973466F72436F6D70656E736174696F6E22297D66756E6374696F6E2067682865297B72657475726E2065262628302C792E69732928652C2262706D6E3A426F756E';
wwv_flow_imp.g_varchar2_table(40373) := '646172794576656E742229262628302C72732E49702928652C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22297D66756E6374696F6E206D682865297B72657475726E2065262628302C792E69732928652C2262706D6E';
wwv_flow_imp.g_varchar2_table(40374) := '3A4163746976697479222926262128302C72732E5131292865297D66756E6374696F6E2066682865297B652E696E766F6B652865722C74686973292C746869732E70726545786563757465282273686170652E637265617465222C313530302C2866756E';
wwv_flow_imp.g_varchar2_table(40375) := '6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E706172656E742C693D742E73686170653B28302C792E697329286E2C2262706D6E3A4C616E65222926262128302C792E69732928692C2262706D6E3A4C616E652229262628742E';
wwv_flow_imp.g_varchar2_table(40376) := '706172656E743D28302C4C632E676574506172656E7429286E2C2262706D6E3A5061727469636970616E742229297D29297D66756E6374696F6E20766828652C74297B65722E63616C6C28746869732C65292C746869732E707265457865637574652822';
wwv_flow_imp.g_varchar2_table(40377) := '73686170652E637265617465222C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742E73686170653B69662828302C792E697329286E2C2262706D6E3A446174614F626A6563745265666572656E636522292626226C6162656C2221';
wwv_flow_imp.g_varchar2_table(40378) := '3D3D6E2E74797065297B76617220693D742E637265617465282262706D6E3A446174614F626A65637422293B6E2E627573696E6573734F626A6563742E646174614F626A6563745265663D697D7D29297D522873682C6572292C73682E24696E6A656374';
wwv_flow_imp.g_varchar2_table(40379) := '3D5B226576656E74427573222C226D6F64656C696E67225D2C522861682C6572292C61682E24696E6A6563743D5B226576656E74427573225D2C52286C682C6572292C6C682E24696E6A6563743D5B22696E6A6563746F72222C226D6F64656C696E6722';
wwv_flow_imp.g_varchar2_table(40380) := '5D2C63682E24696E6A6563743D5B2262706D6E5265706C616365222C22696E6A6563746F72225D2C522863682C6572292C63682E70726F746F747970652E5F7265706C61636553686170653D66756E6374696F6E28652C74297B766172206E2C692C6F3D';
wwv_flow_imp.g_varchar2_table(40381) := '286E3D652C28693D28302C792E676574427573696E6573734F626A65637429286E292E6576656E74446566696E6974696F6E73292626695B305D292C733D7B747970653A2262706D6E3A426F756E646172794576656E74222C686F73743A747D3B726574';
wwv_flow_imp.g_varchar2_table(40382) := '75726E206F262628732E6576656E74446566696E6974696F6E547970653D6F2E2474797065292C746869732E5F62706D6E5265706C6163652E7265706C616365456C656D656E7428652C732C7B6C61796F7574436F6E6E656374696F6E3A21317D297D2C';
wwv_flow_imp.g_varchar2_table(40383) := '68682E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C522868682C6572292C522875682C6572292C75682E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67222C2262706D6E52756C6573225D2C';
wwv_flow_imp.g_varchar2_table(40384) := '66682E24696E6A6563743D5B22696E6A6563746F72225D2C522866682C6572292C76682E24696E6A6563743D5B226576656E74427573222C2262706D6E466163746F7279225D2C522876682C6572293B7661722062683D3265333B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(40385) := '5F6828652C742C6E297B66756E6374696F6E206F28297B76617220743D652E676574526F6F74456C656D656E7428293B72657475726E28302C792E69732928742C2262706D6E3A436F6C6C61626F726174696F6E22293F743A6E2E6D616B65436F6C6C61';
wwv_flow_imp.g_varchar2_table(40386) := '626F726174696F6E28297D65722E63616C6C28746869732C74292C742E6F6E285B226372656174652E7374617274222C2273686170652E6D6F76652E7374617274225D2C62682C2866756E6374696F6E2874297B766172206E3D742E636F6E746578742C';
wwv_flow_imp.g_varchar2_table(40387) := '6F3D6E2E73686170652C733D652E676574526F6F74456C656D656E7428293B69662828302C792E697329286F2C2262706D6E3A5061727469636970616E742229262628302C792E69732928732C2262706D6E3A50726F6365737322292626732E6368696C';
wwv_flow_imp.g_varchar2_table(40388) := '6472656E2E6C656E677468297B76617220723D732E6368696C6472656E2E66696C746572282866756E6374696F6E2865297B72657475726E2128302C792E69732928652C2262706D6E3A47726F75702229262621526E2865292626214F6E2865297D2929';
wwv_flow_imp.g_varchar2_table(40389) := '3B696628722E6C656E677468297B76617220613D63742872292C6C3D66756E6374696F6E28652C74297B743D7B77696474683A742E77696474682B34302B33302C6865696768743A742E6865696768742B34307D3B766172206E3D4D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(40390) := '652E77696474682C742E7769647468292C693D4D6174682E6D617828652E6865696768742C742E686569676874293B72657475726E7B783A2D6E2F322C793A2D692F322C77696474683A6E2C6865696768743A697D7D286F2C61293B28302C692E6B7029';
wwv_flow_imp.g_varchar2_table(40391) := '286F2C6C292C6E2E637265617465436F6E73747261696E74733D66756E6374696F6E28652C74297B72657475726E7B626F74746F6D3A28743D566E287429292E746F702B652E6865696768742F322D32302C6C6566743A742E72696768742D652E776964';
wwv_flow_imp.g_varchar2_table(40392) := '74682F322B32302C746F703A742E626F74746F6D2D652E6865696768742F322B32302C72696768743A742E6C6566742B652E77696474682F322D32302D33307D7D286F2C61297D7D7D29292C742E6F6E28226372656174652E7374617274222C62682C28';
wwv_flow_imp.g_varchar2_table(40393) := '66756E6374696F6E286E297B76617220693D6E2E636F6E746578742E73686170652C6F3D652E676574526F6F74456C656D656E7428292C733D652E6765744772617068696373286F293B66756E6374696F6E20722865297B652E656C656D656E743D6F2C';
wwv_flow_imp.g_varchar2_table(40394) := '652E6766783D737D28302C792E69732928692C2262706D6E3A5061727469636970616E742229262628302C792E697329286F2C2262706D6E3A50726F636573732229262628742E6F6E2822656C656D656E742E686F766572222C62682C72292C742E6F6E';
wwv_flow_imp.g_varchar2_table(40395) := '636528226372656174652E636C65616E7570222C2866756E6374696F6E28297B742E6F66662822656C656D656E742E686F766572222C72297D2929297D29292C746869732E707265457865637574652822656C656D656E74732E637265617465222C6268';
wwv_flow_imp.g_varchar2_table(40396) := '2C2866756E6374696F6E2865297B76617220742C6E3D652E656C656D656E74732C733D652E706172656E742C723D66756E6374696F6E2865297B72657475726E28302C692E49362928652C2866756E6374696F6E2865297B72657475726E28302C792E69';
wwv_flow_imp.g_varchar2_table(40397) := '732928652C2262706D6E3A5061727469636970616E7422297D29297D286E293B72262628302C792E69732928732C2262706D6E3A50726F636573732229262628652E706172656E743D6F28292C28743D652E68696E74733D652E68696E74737C7C7B7D29';
wwv_flow_imp.g_varchar2_table(40398) := '2E7061727469636970616E743D722C742E70726F636573733D732C742E70726F636573735265663D28302C792E676574427573696E6573734F626A656374292872292E676574282270726F636573735265662229297D292C2130292C746869732E707265';
wwv_flow_imp.g_varchar2_table(40399) := '45786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E706172656E742C6E3D652E73686170653B28302C792E697329286E2C2262706D6E3A5061727469636970616E742229262628302C792E6973';
wwv_flow_imp.g_varchar2_table(40400) := '2928742C2262706D6E3A50726F636573732229262628652E706172656E743D6F28292C652E70726F636573733D742C652E70726F636573735265663D28302C792E676574427573696E6573734F626A65637429286E292E676574282270726F6365737352';
wwv_flow_imp.g_varchar2_table(40401) := '65662229297D292C2130292C746869732E65786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E68696E74737C7C7B7D2C6E3D652E70726F636573737C7C742E70726F636573732C693D652E7368';
wwv_flow_imp.g_varchar2_table(40402) := '6170652C6F3D742E7061727469636970616E743B216E7C7C6F262669213D3D6F7C7C28302C792E676574427573696E6573734F626A656374292869292E736574282270726F63657373526566222C28302C792E676574427573696E6573734F626A656374';
wwv_flow_imp.g_varchar2_table(40403) := '29286E29297D292C2130292C746869732E726576657274282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E68696E74737C7C7B7D2C6E3D652E70726F636573737C7C742E70726F636573732C693D652E70726F';
wwv_flow_imp.g_varchar2_table(40404) := '636573735265667C7C742E70726F636573735265662C6F3D652E73686170652C733D742E7061727469636970616E743B216E7C7C7326266F213D3D737C7C28302C792E676574427573696E6573734F626A65637429286F292E736574282270726F636573';
wwv_flow_imp.g_varchar2_table(40405) := '73526566222C69297D292C2130292C746869732E706F737445786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E68696E74737C7C7B7D2C693D652E70726F636573737C7C652E68696E74732E70';
wwv_flow_imp.g_varchar2_table(40406) := '726F636573732C6F3D652E73686170652C733D742E7061727469636970616E743B69662869297B76617220723D692E6368696C6472656E2E736C69636528293B733F6F3D3D3D7326266E2E6D6F7665456C656D656E747328722C7B783A302C793A307D2C';
wwv_flow_imp.g_varchar2_table(40407) := '73293A6E2E6D6F7665456C656D656E747328722C7B783A302C793A307D2C6F297D7D292C2130297D5F682E24696E6A6563743D5B2263616E766173222C226576656E74427573222C226D6F64656C696E67225D2C52285F682C6572293B7661722079683D';
wwv_flow_imp.g_varchar2_table(40408) := '225F5F7461726765745265665F706C616365686F6C646572223B66756E6374696F6E20776828652C74297B66756E6374696F6E206E28652C6E297B766172206F3D652E676574282270726F7065727469657322292C733D28302C692E493629286F2C2866';
wwv_flow_imp.g_varchar2_table(40409) := '756E6374696F6E2865297B72657475726E20652E6E616D653D3D3D79687D29293B72657475726E217326266E26264B74286F2C733D742E637265617465282262706D6E3A50726F7065727479222C7B6E616D653A79687D29292C737D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40410) := '206F28652C74297B766172206F3D6E2865293B6F26262866756E6374696F6E28652C742C6E297B766172206F3D652E676574282264617461496E7075744173736F63696174696F6E7322293B72657475726E28302C692E493629286F2C2866756E637469';
wwv_flow_imp.g_varchar2_table(40411) := '6F6E2865297B72657475726E2065213D3D6E2626652E7461726765745265663D3D3D747D29297D28652C6F2C74297C7C557428652E676574282270726F7065727469657322292C6F29297D66756E6374696F6E20732865297B76617220742C693D652E63';
wwv_flow_imp.g_varchar2_table(40412) := '6F6E746578742C733D692E636F6E6E656374696F6E2C723D732E627573696E6573734F626A6563742C613D732E7461726765742C6C3D612626612E627573696E6573734F626A6563742C633D692E6E65775461726765742C643D632626632E627573696E';
wwv_flow_imp.g_varchar2_table(40413) := '6573734F626A6563742C683D692E6F6C645461726765747C7C692E7461726765742C753D682626682E627573696E6573734F626A6563742C703D732E627573696E6573734F626A6563743B75262675213D3D6C26266F28752C72292C64262664213D3D6C';
wwv_flow_imp.g_varchar2_table(40414) := '26266F28642C72292C6C3F28743D6E286C2C2130292C702E7461726765745265663D74293A702E7461726765745265663D6E756C6C7D65722E63616C6C28746869732C65292C746869732E6578656375746564285B22636F6E6E656374696F6E2E637265';
wwv_flow_imp.g_varchar2_table(40415) := '617465222C22636F6E6E656374696F6E2E64656C657465222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E7265636F6E6E656374225D2C4368287329292C746869732E7265766572746564285B22636F6E6E656374696F6E';
wwv_flow_imp.g_varchar2_table(40416) := '2E637265617465222C22636F6E6E656374696F6E2E64656C657465222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E7265636F6E6E656374225D2C4368287329297D66756E6374696F6E2043682865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(40417) := '66756E6374696F6E2874297B766172206E3D742E636F6E746578742E636F6E6E656374696F6E3B69662828302C792E697329286E2C2262706D6E3A44617461496E7075744173736F63696174696F6E22292972657475726E20652874297D7D66756E6374';
wwv_flow_imp.g_varchar2_table(40418) := '696F6E2053682865297B746869732E5F62706D6E557064617465723D657D66756E6374696F6E20786828652C742C6E2C69297B66756E6374696F6E206F2865297B72657475726E20652E6368696C6472656E2E66696C746572282866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(40419) := '65297B72657475726E28302C792E69732928652C2262706D6E3A4461746153746F72655265666572656E63652229262621652E6C6162656C5461726765747D29297D66756E6374696F6E207328652C69297B766172206F3D652E627573696E6573734F62';
wwv_flow_imp.g_varchar2_table(40420) := '6A6563747C7C653B696628693D697C7C6E2E66696C746572282866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E742229262628302C792E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(40421) := '65292E70726F636573735265667D29295B305D297B76617220733D692E627573696E6573734F626A6563747C7C693B742E6578656375746528226461746153746F72652E757064617465436F6E7461696E6D656E74222C7B6461746153746F7265426F3A';
wwv_flow_imp.g_varchar2_table(40422) := '6F2C6461746153746F726544693A28302C792E6765744469292865292C6E657753656D616E746963506172656E743A732E70726F636573735265667C7C732C6E65774469506172656E743A28302C792E6765744469292869297D297D7D65722E63616C6C';
wwv_flow_imp.g_varchar2_table(40423) := '28746869732C69292C742E726567697374657248616E646C657228226461746153746F72652E757064617465436F6E7461696E6D656E74222C5368292C746869732E70726545786563757465282273686170652E637265617465222C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(40424) := '6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170653B28302C792E697329286E2C2262706D6E3A4461746153746F72655265666572656E636522292626226C6162656C22213D3D6E2E74797065262628742E68696E74737C7C2874';
wwv_flow_imp.g_varchar2_table(40425) := '2E68696E74733D7B7D292C742E68696E74732E6175746F526573697A653D2131297D29292C746869732E707265457865637574652822656C656D656E74732E6D6F7665222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D';
wwv_flow_imp.g_varchar2_table(40426) := '742E7368617065733B6E2E66696C746572282866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A4461746153746F72655265666572656E636522297D29292E6C656E677468262628742E68696E74737C7C28742E68';
wwv_flow_imp.g_varchar2_table(40427) := '696E74733D7B7D292C742E68696E74732E6175746F526573697A653D6E2E66696C746572282866756E6374696F6E2865297B72657475726E2128302C792E69732928652C2262706D6E3A4461746153746F72655265666572656E636522297D2929297D29';
wwv_flow_imp.g_varchar2_table(40428) := '292C746869732E706F737445786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E73686170652C6E3D742E706172656E743B28302C792E69732928742C2262706D6E3A446174';
wwv_flow_imp.g_varchar2_table(40429) := '6153746F72655265666572656E636522292626226C6162656C22213D3D742E74797065262628302C792E697329286E2C2262706D6E3A436F6C6C61626F726174696F6E22292626732874297D29292C746869732E706F7374457865637574652822736861';
wwv_flow_imp.g_varchar2_table(40430) := '70652E6D6F7665222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170652C693D742E6F6C64506172656E742C6F3D6E2E706172656E743B28302C792E69732928692C2262706D6E3A436F6C6C61626F726174';
wwv_flow_imp.g_varchar2_table(40431) := '696F6E22297C7C28302C792E697329286E2C2262706D6E3A4461746153746F72655265666572656E636522292626226C6162656C22213D3D6E2E74797065262628302C792E697329286F2C2262706D6E3A436F6C6C61626F726174696F6E222926267328';
wwv_flow_imp.g_varchar2_table(40432) := '6E2C28302C792E69732928692C2262706D6E3A5061727469636970616E7422293F693A66756E6374696F6E2865297B666F72283B652E706172656E743B297B69662828302C792E69732928652E706172656E742C2262706D6E3A5061727469636970616E';
wwv_flow_imp.g_varchar2_table(40433) := '7422292972657475726E20652E706172656E743B653D652E706172656E747D7D286929297D29292C746869732E706F737445786563757465282273686170652E64656C657465222C2866756E6374696F6E2874297B766172206E3D742E636F6E74657874';
wwv_flow_imp.g_varchar2_table(40434) := '2E73686170652C693D652E676574526F6F74456C656D656E7428293B28302C792E6973416E7929286E2C5B2262706D6E3A5061727469636970616E74222C2262706D6E3A53756250726F63657373225D29262628302C792E69732928692C2262706D6E3A';
wwv_flow_imp.g_varchar2_table(40435) := '436F6C6C61626F726174696F6E222926266F2869292E66696C746572282866756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B666F7228766172206E3D652E627573696E6573734F626A6563747C7C652C693D742E627573';
wwv_flow_imp.g_varchar2_table(40436) := '696E6573734F626A6563747C7C743B6E2E24706172656E743B297B6966286E2E24706172656E743D3D3D692E70726F636573735265667C7C692972657475726E21303B6E3D6E2E24706172656E747D72657475726E21317D28652C6E297D29292E666F72';
wwv_flow_imp.g_varchar2_table(40437) := '45616368282866756E6374696F6E2865297B732865297D29297D29292C746869732E706F737445786563757465282263616E7661732E757064617465526F6F74222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E6F';
wwv_flow_imp.g_varchar2_table(40438) := '6C64526F6F742C693D742E6E6577526F6F743B6F286E292E666F7245616368282866756E6374696F6E2865297B28302C792E69732928692C2262706D6E3A50726F63657373222926267328652C69297D29297D29297D77682E24696E6A6563743D5B2265';
wwv_flow_imp.g_varchar2_table(40439) := '76656E74427573222C2262706D6E466163746F7279225D2C522877682C6572292C53682E24696E6A6563743D5B2262706D6E55706461746572225D2C53682E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(40440) := '2E6461746153746F7265426F2C6E3D652E6461746153746F726544692C693D652E6E657753656D616E746963506172656E742C6F3D652E6E65774469506172656E743B72657475726E20652E6F6C6453656D616E746963506172656E743D742E24706172';
wwv_flow_imp.g_varchar2_table(40441) := '656E742C652E6F6C644469506172656E743D6E2E24706172656E742C746869732E5F62706D6E557064617465722E75706461746553656D616E746963506172656E7428742C69292C746869732E5F62706D6E557064617465722E75706461746544695061';
wwv_flow_imp.g_varchar2_table(40442) := '72656E74286E2C6F292C5B5D7D2C53682E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E6461746153746F7265426F2C6E3D652E6461746153746F726544692C693D652E6F6C6453656D616E746963506172';
wwv_flow_imp.g_varchar2_table(40443) := '656E742C6F3D652E6F6C644469506172656E743B72657475726E20746869732E5F62706D6E557064617465722E75706461746553656D616E746963506172656E7428742C69292C746869732E5F62706D6E557064617465722E7570646174654469506172';
wwv_flow_imp.g_varchar2_table(40444) := '656E74286E2C6F292C5B5D7D2C78682E24696E6A6563743D5B2263616E766173222C22636F6D6D616E64537461636B222C22656C656D656E745265676973747279222C226576656E74427573225D2C522878682C6572293B766172206B683D4D6174682E';
wwv_flow_imp.g_varchar2_table(40445) := '6D61782C45683D4D6174682E6D696E2C4C683D32303B66756E6374696F6E20446828652C74297B72657475726E7B746F703A652E746F702D742E746F702C72696768743A652E72696768742D742E72696768742C626F74746F6D3A652E626F74746F6D2D';
wwv_flow_imp.g_varchar2_table(40446) := '742E626F74746F6D2C6C6566743A652E6C6566742D742E6C6566747D7D66756E6374696F6E20546828652C74297B72657475726E7B783A652E782B28742E6C6566747C7C30292C793A652E792B28742E746F707C7C30292C77696474683A652E77696474';
wwv_flow_imp.g_varchar2_table(40447) := '682D28742E6C6566747C7C30292B28742E72696768747C7C30292C6865696768743A652E6865696768742D28742E746F707C7C30292B28742E626F74746F6D7C7C30297D7D66756E6374696F6E20496828652C742C6E297B766172206F3D745B655D2C73';
wwv_flow_imp.g_varchar2_table(40448) := '3D6E2E6D696E26266E2E6D696E5B655D2C723D6E2E6D617826266E2E6D61785B655D3B72657475726E28302C692E4574292873292626286F3D282F746F707C6C6566742F2E746573742865293F45683A6B6829286F2C7329292C28302C692E4574292872';
wwv_flow_imp.g_varchar2_table(40449) := '292626286F3D282F746F707C6C6566742F2E746573742865293F6B683A456829286F2C7229292C6F7D66756E6374696F6E204D6828652C74297B72657475726E20766F69642030213D3D653F653A4C687D66756E6374696F6E2041682865297B72657475';
wwv_flow_imp.g_varchar2_table(40450) := '726E21652E776179706F696E74732626226C6162656C22213D3D652E747970657D66756E6374696F6E204E6828652C74297B766172206E3B696628286E3D766F696420303D3D3D652E6C656E6774683F28302C692E70622928652E6368696C6472656E2C';
wwv_flow_imp.g_varchar2_table(40451) := '4168293A65292E6C656E6774682972657475726E2066756E6374696F6E28652C74297B766172206E2C692C6F2C733B72657475726E226F626A656374223D3D747970656F6620743F286E3D4D6828742E6C656674292C693D4D6828742E7269676874292C';
wwv_flow_imp.g_varchar2_table(40452) := '6F3D4D6828742E746F70292C733D4D6828742E626F74746F6D29293A6E3D693D6F3D733D4D682874292C7B783A652E782D6E2C793A652E792D6F2C77696474683A652E77696474682B6E2B692C6865696768743A652E6865696768742B6F2B737D7D2863';
wwv_flow_imp.g_varchar2_table(40453) := '74286E292C74297D7661722050683D4D6174682E6162732C4F683D5B2262706D6E3A5061727469636970616E74222C2262706D6E3A50726F63657373222C2262706D6E3A53756250726F63657373225D2C52683D33303B66756E6374696F6E2046682865';
wwv_flow_imp.g_varchar2_table(40454) := '2C74297B72657475726E20743D747C7C5B5D2C652E6368696C6472656E2E66696C746572282866756E6374696F6E2865297B28302C792E69732928652C2262706D6E3A4C616E652229262628466828652C74292C742E70757368286529297D29292C747D';
wwv_flow_imp.g_varchar2_table(40455) := '66756E6374696F6E2042682865297B72657475726E20652E6368696C6472656E2E66696C746572282866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A4C616E6522297D29297D66756E6374696F6E205668286529';
wwv_flow_imp.g_varchar2_table(40456) := '7B72657475726E28302C4C632E676574506172656E742928652C4F68297C7C657D66756E6374696F6E207A6828652C74297B65722E63616C6C28746869732C65292C746869732E706F73744578656375746564282273686170652E64656C657465222C35';
wwv_flow_imp.g_varchar2_table(40457) := '30302C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E68696E74732C6F3D6E2E73686170652C733D6E2E6F6C64506172656E743B28302C792E697329286F2C2262706D6E3A4C616E652229262628692626692E6E6573';
wwv_flow_imp.g_varchar2_table(40458) := '7465647C7C66756E6374696F6E28652C6E297B76617220692C6F2C732C722C612C6C3D28302C72732E2462292865292C633D4268286E292C643D5B5D2C683D5B5D2C753D5B5D2C703D5B5D3B617428632C2866756E6374696F6E2874297B72657475726E';
wwv_flow_imp.g_varchar2_table(40459) := '206C3F742E793E652E793F682E707573682874293A642E707573682874293A742E783E652E783F702E707573682874293A752E707573682874292C742E6368696C6472656E7D29292C632E6C656E677468262628693D6C3F682E6C656E6774682626642E';
wwv_flow_imp.g_varchar2_table(40460) := '6C656E6774683F652E6865696768742F323A652E6865696768743A702E6C656E6774682626752E6C656E6774683F652E77696474682F323A652E77696474682C642E6C656E6774682626286F3D742E63616C63756C61746541646A7573746D656E747328';
wwv_flow_imp.g_varchar2_table(40461) := '642C2279222C692C652E792D3130292C742E6D616B655370616365286F2E6D6F76696E675368617065732C6F2E726573697A696E675368617065732C7B783A302C793A697D2C22732229292C682E6C656E677468262628733D742E63616C63756C617465';
wwv_flow_imp.g_varchar2_table(40462) := '41646A7573746D656E747328682C2279222C2D692C652E792B652E6865696768742B3130292C742E6D616B65537061636528732E6D6F76696E675368617065732C732E726573697A696E675368617065732C7B783A302C793A2D697D2C226E2229292C75';
wwv_flow_imp.g_varchar2_table(40463) := '2E6C656E677468262628723D742E63616C63756C61746541646A7573746D656E747328752C2278222C692C652E782D3130292C742E6D616B65537061636528722E6D6F76696E675368617065732C722E726573697A696E675368617065732C7B783A692C';
wwv_flow_imp.g_varchar2_table(40464) := '793A307D2C22652229292C702E6C656E677468262628613D742E63616C63756C61746541646A7573746D656E747328702C2278222C2D692C652E782B652E77696474682B3130292C742E6D616B65537061636528612E6D6F76696E675368617065732C61';
wwv_flow_imp.g_varchar2_table(40465) := '2E726573697A696E675368617065732C7B783A2D692C793A307D2C2277222929297D286F2C7329297D29297D66756E6374696F6E20486828652C74297B742E696E766F6B652865722C74686973292C746869732E5F62706D6E5265706C6163653D653B76';
wwv_flow_imp.g_varchar2_table(40466) := '6172206E3D746869733B746869732E706F737445786563757465642822656C656D656E74732E637265617465222C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E74733B742E66696C746572282866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(40467) := '297B72657475726E20576828652C652E686F7374297D29292E6D6170282866756E6374696F6E2865297B72657475726E20742E696E6465784F662865297D29292E666F7245616368282866756E6374696F6E2869297B652E656C656D656E74735B695D3D';
wwv_flow_imp.g_varchar2_table(40468) := '6E2E5F7265706C616365536861706528745B695D297D29297D292C2130292C746869732E707265457865637574652822656C656D656E74732E6D6F7665222C3530302C2866756E6374696F6E2865297B76617220743D652E7368617065732C693D652E6E';
wwv_flow_imp.g_varchar2_table(40469) := '6577486F73743B742E666F7245616368282866756E6374696F6E28652C6F297B76617220732C723D652E686F73743B576828652C28733D722C2D31213D3D742E696E6465784F662873293F723A692929262628745B6F5D3D6E2E5F7265706C6163655368';
wwv_flow_imp.g_varchar2_table(40470) := '617065286529297D29297D292C2130297D66756E6374696F6E20576828652C74297B72657475726E21526E286529262628302C792E69732928652C2262706D6E3A426F756E646172794576656E742229262621747D66756E6374696F6E206A6828652C74';
wwv_flow_imp.g_varchar2_table(40471) := '2C6E297B66756E6374696F6E206F28652C6F2C73297B76617220722C612C6C2C632C642C682C752C702C673D6F2E776179706F696E74732C6D3D652E6F7574676F696E672E736C69636528292C663D652E696E636F6D696E672E736C69636528292C763D';
wwv_flow_imp.g_varchar2_table(40472) := '5A6328672C703D28302C692E45742928732E7769647468293F486E2873293A73293B69662876297B696628723D672E736C69636528302C762E696E646578292C613D672E736C69636528762E696E6465782B28762E62656E64706F696E743F313A302929';
wwv_flow_imp.g_varchar2_table(40473) := '2C21722E6C656E6774687C7C21612E6C656E6774682972657475726E3B6C3D762E62656E64706F696E743F675B762E696E6465785D3A702C31213D3D722E6C656E6774682626716828652C725B722E6C656E6774682D315D297C7C722E70757368282468';
wwv_flow_imp.g_varchar2_table(40474) := '286C29292C31213D3D612E6C656E6774682626716828652C615B305D297C7C612E756E7368696674282468286C29297D633D6F2E736F757263652C643D6F2E7461726765742C742E63616E436F6E6E65637428632C652C6F292626286E2E7265636F6E6E';
wwv_flow_imp.g_varchar2_table(40475) := '656374456E64286F2C652C727C7C70292C683D6F292C742E63616E436F6E6E65637428652C642C6F29262628683F753D6E2E636F6E6E65637428652C642C7B747970653A6F2E747970652C776179706F696E74733A617D293A286E2E7265636F6E6E6563';
wwv_flow_imp.g_varchar2_table(40476) := '745374617274286F2C652C617C7C70292C753D6F29293B76617220623D5B5D2E636F6E6361742868262628302C692E70622928662C2866756E6374696F6E2865297B72657475726E20652E736F757263653D3D3D682E736F757263657D29297C7C5B5D2C';
wwv_flow_imp.g_varchar2_table(40477) := '75262628302C692E706229286D2C2866756E6374696F6E2865297B72657475726E20652E7461726765743D3D3D752E7461726765747D29297C7C5B5D293B622E6C656E67746826266E2E72656D6F7665456C656D656E74732862297D65722E63616C6C28';
wwv_flow_imp.g_varchar2_table(40478) := '746869732C65292C746869732E707265457865637574652822656C656D656E74732E6D6F7665222C2866756E6374696F6E2865297B766172206E3D652E6E6577506172656E742C6F3D652E7368617065732C733D652E64656C74612C723D6F5B305D3B69';
wwv_flow_imp.g_varchar2_table(40479) := '66287226266E297B6E26266E2E776179706F696E7473262628652E6E6577506172656E743D6E3D6E2E706172656E74293B76617220613D486E2872292C6C3D7B783A612E782B732E782C793A612E792B732E797D2C633D28302C692E493629286E2E6368';
wwv_flow_imp.g_varchar2_table(40480) := '696C6472656E2C2866756E6374696F6E2865297B72657475726E20742E63616E496E73657274286F2C652926265A6328652E776179706F696E74732C6C297D29293B63262628652E746172676574466C6F773D632C652E706F736974696F6E3D6C297D7D';
wwv_flow_imp.g_varchar2_table(40481) := '292C2130292C746869732E706F737445786563757465642822656C656D656E74732E6D6F7665222C2866756E6374696F6E2865297B76617220743D652E7368617065732C6E3D652E746172676574466C6F772C693D652E706F736974696F6E3B6E26266F';
wwv_flow_imp.g_varchar2_table(40482) := '28745B305D2C6E2C69297D292C2130292C746869732E70726545786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B766172206E3D652E706172656E742C693D652E73686170653B742E63616E496E7365727428692C';
wwv_flow_imp.g_varchar2_table(40483) := '6E29262628652E746172676574466C6F773D6E2C652E706172656E743D6E2E706172656E74297D292C2130292C746869732E706F73744578656375746564282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E73';
wwv_flow_imp.g_varchar2_table(40484) := '686170652C6E3D652E746172676574466C6F772C693D652E706F736974696F6E3B6E26266F28742C6E2C69297D292C2130297D66756E6374696F6E20716828652C74297B766172206E3D742E782C693D742E793B72657475726E206E3E3D652E7826266E';
wwv_flow_imp.g_varchar2_table(40485) := '3C3D652E782B652E77696474682626693E3D652E792626693C3D652E792B652E6865696768747D66756E6374696F6E2024682865297B72657475726E28302C692E6B7029287B7D2C65297D66756E6374696F6E20556828652C74297B65722E63616C6C28';
wwv_flow_imp.g_varchar2_table(40486) := '746869732C65292C746869732E70726545786563757465642822636F6E6E656374696F6E2E637265617465222C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E636F6E6E656374696F6E2C6F3D6E2E736F757263652C';
wwv_flow_imp.g_varchar2_table(40487) := '733D6E2E7461726765742C723D6E2E68696E74733B72262621313D3D3D722E637265617465456C656D656E74734265686176696F727C7C214B682869297C7C2828302C792E697329286F2C2262706D6E3A4576656E744261736564476174657761792229';
wwv_flow_imp.g_varchar2_table(40488) := '3F732E696E636F6D696E672E66696C7465722828653D3E65213D3D6926264B6828652929293A732E696E636F6D696E672E66696C7465722828653D3E65213D3D6926264B68286529262628302C792E69732928652E736F757263652C2262706D6E3A4576';
wwv_flow_imp.g_varchar2_table(40489) := '656E7442617365644761746577617922292929292E666F7245616368282866756E6374696F6E2865297B742E72656D6F7665436F6E6E656374696F6E2865297D29297D29292C746869732E7072654578656375746564282273686170652E7265706C6163';
wwv_flow_imp.g_varchar2_table(40490) := '65222C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742E6E657753686170653B28302C792E697329286E2C2262706D6E3A4576656E74426173656447617465776179222926266E2E6F7574676F696E672E66696C746572284B6829';
wwv_flow_imp.g_varchar2_table(40491) := '2E726564756365282866756E6374696F6E28652C74297B72657475726E20652E696E636C7564657328742E746172676574293F653A652E636F6E63617428742E746172676574297D292C5B5D292E666F7245616368282866756E6374696F6E2865297B65';
wwv_flow_imp.g_varchar2_table(40492) := '2E696E636F6D696E672E66696C746572284B68292E666F7245616368282866756E6374696F6E2869297B636F6E7374206F3D652E696E636F6D696E672E66696C746572284B68292E66696C746572282866756E6374696F6E2865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(40493) := '2E736F757263653D3D3D6E7D29293B28692E736F75726365213D3D6E7C7C6F2E6C656E6774683E31292626742E72656D6F7665436F6E6E656374696F6E2869297D29297D29297D29297D66756E6374696F6E204B682865297B72657475726E28302C792E';
wwv_flow_imp.g_varchar2_table(40494) := '69732928652C2262706D6E3A53657175656E6365466C6F7722297D7A682E24696E6A6563743D5B226576656E74427573222C227370616365546F6F6C225D2C52287A682C6572292C48682E24696E6A6563743D5B2262706D6E5265706C616365222C2269';
wwv_flow_imp.g_varchar2_table(40495) := '6E6A6563746F72225D2C522848682C6572292C48682E70726F746F747970652E5F7265706C61636553686170653D66756E6374696F6E2865297B76617220742C6E2C692C6F3D286E3D652C28693D28302C792E676574427573696E6573734F626A656374';
wwv_flow_imp.g_varchar2_table(40496) := '29286E292E6576656E74446566696E6974696F6E73292626695B305D293B72657475726E20743D6F3F7B747970653A2262706D6E3A496E7465726D65646961746543617463684576656E74222C6576656E74446566696E6974696F6E547970653A6F2E24';
wwv_flow_imp.g_varchar2_table(40497) := '747970657D3A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74227D2C746869732E5F62706D6E5265706C6163652E7265706C616365456C656D656E7428652C742C7B6C61796F7574436F6E6E656374696F6E3A2131';
wwv_flow_imp.g_varchar2_table(40498) := '7D297D2C52286A682C6572292C6A682E24696E6A6563743D5B226576656E74427573222C2262706D6E52756C6573222C226D6F64656C696E67225D2C55682E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C522855682C';
wwv_flow_imp.g_varchar2_table(40499) := '6572293B7661722047683D313530303B66756E6374696F6E20516828652C742C6E297B742E6F6E285B226372656174652E686F766572222C226372656174652E6D6F7665222C226372656174652E6F7574222C226372656174652E656E64222C22736861';
wwv_flow_imp.g_varchar2_table(40500) := '70652E6D6F76652E686F766572222C2273686170652E6D6F76652E6D6F7665222C2273686170652E6D6F76652E6F7574222C2273686170652E6D6F76652E656E64225D2C47682C2866756E6374696F6E2874297B76617220693D742E636F6E746578742E';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(40501) := '73686170657C7C742E73686170652C6F3D742E686F7665723B28302C792E697329286F2C2262706D6E3A4C616E65222926262128302C792E6973416E792928692C5B2262706D6E3A4C616E65222C2262706D6E3A5061727469636970616E74225D292626';
wwv_flow_imp.g_varchar2_table(40502) := '28742E686F7665723D5668286F292C742E686F7665724766783D652E676574477261706869637328742E686F76657229293B76617220733D6E2E676574526F6F74456C656D656E7428293B6F213D3D73262628692E6C6162656C5461726765747C7C2830';
wwv_flow_imp.g_varchar2_table(40503) := '2C792E6973416E792928692C5B2262706D6E3A47726F7570222C2262706D6E3A54657874416E6E6F746174696F6E225D2929262628742E686F7665723D732C742E686F7665724766783D652E676574477261706869637328742E686F76657229297D2929';
wwv_flow_imp.g_varchar2_table(40504) := '2C742E6F6E285B22636F6E6E6563742E686F766572222C22636F6E6E6563742E6F7574222C22636F6E6E6563742E656E64222C22636F6E6E6563742E636C65616E7570222C22676C6F62616C2D636F6E6E6563742E686F766572222C22676C6F62616C2D';
wwv_flow_imp.g_varchar2_table(40505) := '636F6E6E6563742E6F7574222C22676C6F62616C2D636F6E6E6563742E656E64222C22676C6F62616C2D636F6E6E6563742E636C65616E7570225D2C47682C2866756E6374696F6E2874297B766172206E3D742E686F7665723B28302C792E697329286E';
wwv_flow_imp.g_varchar2_table(40506) := '2C2262706D6E3A4C616E652229262628742E686F7665723D5668286E297C7C6E2C742E686F7665724766783D652E676574477261706869637328742E686F76657229297D29292C742E6F6E285B2262656E64706F696E742E6D6F76652E686F766572225D';
wwv_flow_imp.g_varchar2_table(40507) := '2C47682C2866756E6374696F6E2874297B766172206E3D742E636F6E746578742C693D742E686F7665722C6F3D6E2E747970653B28302C792E69732928692C2262706D6E3A4C616E65222926262F7265636F6E6E6563742F2E74657374286F2926262874';
wwv_flow_imp.g_varchar2_table(40508) := '2E686F7665723D56682869297C7C692C742E686F7665724766783D652E676574477261706869637328742E686F76657229297D29292C742E6F6E285B22636F6E6E6563742E7374617274225D2C47682C2866756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(40509) := '2E636F6E746578742C6E3D742E73746172743B28302C792E697329286E2C2262706D6E3A4C616E652229262628742E73746172743D5668286E297C7C6E297D29292C742E6F6E282273686170652E6D6F76652E7374617274222C3265332C2866756E6374';
wwv_flow_imp.g_varchar2_table(40510) := '696F6E2865297B76617220743D652E73686170653B28302C792E69732928742C2262706D6E3A4C616E652229262628652E73686170653D56682874297C7C74297D29292C742E6F6E28227370616365546F6F6C2E6D6F7665222C3265332C2866756E6374';
wwv_flow_imp.g_varchar2_table(40511) := '696F6E2865297B76617220743D652E686F7665723B74262628302C792E69732928742C2262706D6E3A4C616E652229262628652E686F7665723D5668287429297D29297D66756E6374696F6E20596828652C742C6E2C692C6F2C73297B66756E6374696F';
wwv_flow_imp.g_varchar2_table(40512) := '6E207228652C742C69297B766172206F3D6E2E66696C746572282866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A47726F757022297D29292E66696C746572282866756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(40513) := '652E627573696E6573734F626A656374213D3D697D29293B7426262166756E6374696F6E28652C74297B72657475726E20652E736F6D65282866756E6374696F6E2865297B766172206E3D28302C792E676574427573696E6573734F626A656374292865';
wwv_flow_imp.g_varchar2_table(40514) := '293B72657475726E286E2E63617465676F727956616C756552656626266E2E63617465676F727956616C75655265662E24706172656E74293D3D3D747D29297D286F2C7429262666756E6374696F6E2865297B76617220743D652E24706172656E743B74';
wwv_flow_imp.g_varchar2_table(40515) := '262628557428742E6765742822726F6F74456C656D656E747322292C65292C652E24706172656E743D6E756C6C297D2874292C6526262166756E6374696F6E28652C74297B72657475726E20652E736F6D65282866756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(40516) := '726E28302C792E676574427573696E6573734F626A656374292865292E63617465676F727956616C75655265663D3D3D747D29297D286F2C6529262666756E6374696F6E2865297B76617220743D652E24706172656E743B74262628557428742E676574';
wwv_flow_imp.g_varchar2_table(40517) := '282263617465676F727956616C756522292C65292C652E24706172656E743D6E756C6C297D2865297D66756E6374696F6E206128652C6E297B72657475726E2066756E6374696F6E28652C742C6E297B72657475726E204B7428742E6765742822636174';
wwv_flow_imp.g_varchar2_table(40518) := '65676F727956616C756522292C65292C652E24706172656E743D742C4B74286E2E6765742822726F6F74456C656D656E747322292C74292C742E24706172656E743D6E2C657D28652C6E2C742E676574446566696E6974696F6E732829297D66756E6374';
wwv_flow_imp.g_varchar2_table(40519) := '696F6E206C286E2C69297B766172206F3D28302C792E676574427573696E6573734F626A65637429286E292C733D6F2E63617465676F727956616C75655265663B737C7C28733D6F2E63617465676F727956616C75655265663D692E63617465676F7279';
wwv_flow_imp.g_varchar2_table(40520) := '56616C75653D692E63617465676F727956616C75657C7C66756E6374696F6E2865297B72657475726E20652E637265617465282262706D6E3A43617465676F727956616C756522297D286529293B76617220723D732E24706172656E743B727C7C28723D';
wwv_flow_imp.g_varchar2_table(40521) := '732E24706172656E743D692E63617465676F72793D692E63617465676F72797C7C66756E6374696F6E2865297B72657475726E20652E637265617465282262706D6E3A43617465676F727922297D286529292C6128732C722C742E676574446566696E69';
wwv_flow_imp.g_varchar2_table(40522) := '74696F6E732829297D66756E6374696F6E206328652C74297B766172206E3D742E63617465676F72792C693D742E63617465676F727956616C75652C6F3D28302C792E676574427573696E6573734F626A656374292865293B693F286F2E63617465676F';
wwv_flow_imp.g_varchar2_table(40523) := '727956616C75655265663D6E756C6C2C7228692C6E2C6F29293A72286E756C6C2C6F2E63617465676F727956616C75655265662E24706172656E742C6F297D66756E6374696F6E206428742C6E297B76617220693D652E63726561746528742E24747970';
wwv_flow_imp.g_varchar2_table(40524) := '65293B72657475726E20732E636F7079456C656D656E7428742C692C6E756C6C2C6E297D6F2E696E766F6B652865722C74686973292C746869732E6578656375746528226C6162656C2E637265617465222C2866756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(40525) := '3D652E636F6E746578742C6E3D742E6C6162656C5461726765743B28302C792E697329286E2C2262706D6E3A47726F7570222926266C286E2C74297D29292C746869732E72657665727428226C6162656C2E637265617465222C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(40526) := '65297B76617220743D652E636F6E746578742C6E3D742E6C6162656C5461726765743B28302C792E697329286E2C2262706D6E3A47726F75702229262663286E2C74297D29292C746869732E65786563757465282273686170652E64656C657465222C28';
wwv_flow_imp.g_varchar2_table(40527) := '66756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170652C693D28302C792E676574427573696E6573734F626A65637429286E293B69662828302C792E697329286E2C2262706D6E3A47726F757022292626216E2E6C';
wwv_flow_imp.g_varchar2_table(40528) := '6162656C546172676574297B766172206F3D742E63617465676F727956616C75653D692E63617465676F727956616C75655265663B6F26262872286F2C742E63617465676F72793D6F2E24706172656E742C69292C692E63617465676F727956616C7565';
wwv_flow_imp.g_varchar2_table(40529) := '5265663D6E756C6C297D7D29292C746869732E7265766572746564282273686170652E64656C657465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170653B69662828302C792E697329286E2C2262706D';
wwv_flow_imp.g_varchar2_table(40530) := '6E3A47726F757022292626216E2E6C6162656C546172676574297B76617220693D742E63617465676F72792C6F3D742E63617465676F727956616C75652C733D28302C792E676574427573696E6573734F626A65637429286E293B6F262628732E636174';
wwv_flow_imp.g_varchar2_table(40531) := '65676F727956616C75655265663D6F2C61286F2C6929297D7D29292C746869732E65786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170653B28302C792E';
wwv_flow_imp.g_varchar2_table(40532) := '697329286E2C2262706D6E3A47726F757022292626216E2E6C6162656C546172676574262628302C792E676574427573696E6573734F626A65637429286E292E63617465676F727956616C756552656626266C286E2C74297D29292C746869732E726576';
wwv_flow_imp.g_varchar2_table(40533) := '6572746564282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170653B28302C792E697329286E2C2262706D6E3A47726F757022292626216E2E6C6162656C546172676574';
wwv_flow_imp.g_varchar2_table(40534) := '262628302C792E676574427573696E6573734F626A65637429286E292E63617465676F727956616C7565526566262663286E2C74297D29292C692E6F6E2822636F707950617374652E636F7079456C656D656E74222C3737302C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(40535) := '65297B76617220743D652E64657363726970746F722C6E3D652E656C656D656E743B69662828302C792E697329286E2C2262706D6E3A47726F757022292626216E2E6C6162656C546172676574297B76617220693D28302C792E676574427573696E6573';
wwv_flow_imp.g_varchar2_table(40536) := '734F626A65637429286E293B696628692E63617465676F727956616C7565526566297B766172206F3D692E63617465676F727956616C75655265663B742E63617465676F727956616C75653D64286F2C2130292C6F2E24706172656E74262628742E6361';
wwv_flow_imp.g_varchar2_table(40537) := '7465676F72793D64286F2E24706172656E742C213029297D7D7D29292C692E6F6E2822636F707950617374652E7061737465456C656D656E74222C3737302C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D742E62';
wwv_flow_imp.g_varchar2_table(40538) := '7573696E6573734F626A6563742C693D742E63617465676F727956616C75652C6F3D742E63617465676F72793B69262628693D6E2E63617465676F727956616C75655265663D64286929292C6F262628692E24706172656E743D64286F29292C64656C65';
wwv_flow_imp.g_varchar2_table(40539) := '746520742E63617465676F72792C64656C65746520742E63617465676F727956616C75657D29297D66756E6374696F6E205A6828652C742C6E2C69297B766172206F2C732C722C613B72657475726E20303D3D286F3D28692E792D6E2E79292A28742E78';
wwv_flow_imp.g_varchar2_table(40540) := '2D652E78292D28692E782D6E2E78292A28742E792D652E7929293F6E756C6C3A28733D652E792D6E2E792C723D652E782D6E2E782C613D2828692E782D6E2E78292A732D28692E792D6E2E79292A72292F6F2C7B783A4D6174682E726F756E6428652E78';
wwv_flow_imp.g_varchar2_table(40541) := '2B612A28742E782D652E7829292C793A4D6174682E726F756E6428652E792B612A28742E792D652E7929297D297D66756E6374696F6E2058682865297B66756E6374696F6E207428652C742C6E297B76617220692C6F3D7B783A6E2E782C793A6E2E792D';
wwv_flow_imp.g_varchar2_table(40542) := '35307D2C733D7B783A6E2E782D35302C793A6E2E797D2C723D5A6828652C742C6E2C6F292C613D5A6828652C742C6E2C73293B693D722626613F4A6828722C6E293E4A6828612C6E293F613A723A727C7C612C652E6F726967696E616C3D697D652E6F6E';
wwv_flow_imp.g_varchar2_table(40543) := '282262706D6E456C656D656E742E6164646564222C2866756E6374696F6E2865297B766172206E2C692C6F3D652E656C656D656E743B6F2E776179706F696E7473262628742828693D286E3D6F292E776179706F696E7473295B305D2C695B315D2C486E';
wwv_flow_imp.g_varchar2_table(40544) := '286E2E736F7572636529292C7428695B692E6C656E6774682D315D2C695B692E6C656E6774682D325D2C486E286E2E7461726765742929297D29297D66756E6374696F6E204A6828652C74297B72657475726E204D6174682E73717274284D6174682E70';
wwv_flow_imp.g_varchar2_table(40545) := '6F7728652E782D742E782C32292B4D6174682E706F7728652E792D742E792C3229297D66756E6374696F6E2065752865297B65722E63616C6C28746869732C65293B76617220743D5B2262706D6E3A5061727469636970616E74222C2262706D6E3A4C61';
wwv_flow_imp.g_varchar2_table(40546) := '6E65225D3B746869732E6578656375746564285B2273686170652E6D6F7665222C2273686170652E637265617465222C2273686170652E726573697A65225D2C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742E73686170652C69';
wwv_flow_imp.g_varchar2_table(40547) := '3D28302C792E676574427573696E6573734F626A65637429286E292C6F3D28302C792E676574446929286E293B69662828302C792E6973416E792928692C7429297B76617220733D6F2E67657428226973486F72697A6F6E74616C22293B766F69642030';
wwv_flow_imp.g_varchar2_table(40548) := '3D3D3D73262628733D2130292C6F2E73657428226973486F72697A6F6E74616C222C73297D7D29297D51682E24696E6A6563743D5B22656C656D656E745265676973747279222C226576656E74427573222C2263616E766173225D2C59682E24696E6A65';
wwv_flow_imp.g_varchar2_table(40549) := '63743D5B2262706D6E466163746F7279222C2262706D6E6A73222C22656C656D656E745265676973747279222C226576656E74427573222C22696E6A6563746F72222C226D6F64646C65436F7079225D2C522859682C6572292C58682E24696E6A656374';
wwv_flow_imp.g_varchar2_table(40550) := '3D5B226576656E74427573225D2C65752E24696E6A6563743D5B226576656E74427573225D2C522865752C6572293B7661722074753D4D6174682E737172742C6E753D4D6174682E6D696E2C69753D4D6174682E6D61782C6F753D4D6174682E6162733B';
wwv_flow_imp.g_varchar2_table(40551) := '66756E6374696F6E2073752865297B72657475726E204D6174682E706F7728652C32297D66756E6374696F6E20727528652C74297B72657475726E20747528737528652E782D742E78292B737528652E792D742E7929297D66756E6374696F6E20617528';
wwv_flow_imp.g_varchar2_table(40552) := '652C742C6E2C69297B766172206F3D742E782D652E782C733D742E792D652E792C723D6E2E782D652E782C613D6E2E792D652E792C6C3D6F2A6F2B732A732C633D286F2A722B732A61292F6C2C643D632A632D28722A722B612A612D692A69292F6C3B69';
wwv_flow_imp.g_varchar2_table(40553) := '6628643C302626643E2D31652D36262628643D30292C643C302972657475726E5B5D3B76617220683D74752864292C753D2D632B682C703D2D632D682C673D7B783A652E782D6F2A752C793A652E792D732A757D3B72657475726E20303D3D3D643F5B67';
wwv_flow_imp.g_varchar2_table(40554) := '5D3A5B672C7B783A652E782D6F2A702C793A652E792D732A707D5D2E66696C746572282866756E6374696F6E286E297B72657475726E2066756E6374696F6E28652C742C6E297B72657475726E206C7528652E782C742E782C6E2E782926266C7528652E';
wwv_flow_imp.g_varchar2_table(40555) := '792C742E792C6E2E79297D286E2C652C74297D29297D66756E6374696F6E206C7528652C742C6E297B72657475726E20653E3D6E7528742C6E292D63752626653C3D697528742C6E292B63757D7661722063753D2E313B66756E6374696F6E2064752865';
wwv_flow_imp.g_varchar2_table(40556) := '2C74297B72657475726E206F7528652E782D742E78293C3D637526266F7528652E792D742E79293C3D63757D66756E6374696F6E20687528652C742C6E2C69297B766172206F3D302C733D302C723D7B706F696E743A652C64656C74613A7B783A302C79';
wwv_flow_imp.g_varchar2_table(40557) := '3A307D7D2C613D66756E6374696F6E28652C74297B766172206E2C692C6F2C732C722C612C6C2C632C642C682C752C702C673D303B666F7228673D303B673C742E6C656E6774682D313B672B2B297B6966286475286E3D745B675D2C693D745B672B315D';
wwv_flow_imp.g_varchar2_table(40558) := '293F613D5B6E5D3A286F3D727528652C6E292C733D727528652C69292C613D6175286E2C692C652C6E75286F2C732929292C612E6C656E6774683C31297468726F77206E6577204572726F7228226578706563746564206265747765656E205B312C2032';
wwv_flow_imp.g_varchar2_table(40559) := '5D20636972636C65202D3E206C696E6520696E74657273656374696F6E7322293B313D3D3D612E6C656E6774682626286C3D7B747970653A2262656E64706F696E74222C706F736974696F6E3A615B305D2C7365676D656E74496E6465783A672C62656E';
wwv_flow_imp.g_varchar2_table(40560) := '64706F696E74496E6465783A6475286E2C615B305D293F673A672B317D292C323D3D3D612E6C656E677468262628753D615B305D2C703D615B315D2C6C3D7B747970653A227365676D656E74222C706F736974696F6E3A723D7B783A28752E782B702E78';
wwv_flow_imp.g_varchar2_table(40561) := '292F322C793A28752E792B702E79292F327D2C7365676D656E74496E6465783A672C72656C61746976654C6F636174696F6E3A7275286E2C72292F7275286E2C69297D292C633D7275286C2E706F736974696F6E2C65292C2821687C7C643E6329262628';
wwv_flow_imp.g_varchar2_table(40562) := '683D6C2C643D63297D72657475726E20687D28652C6E292C6C3D612E7365676D656E74496E6465782C633D66756E6374696F6E28652C742C6E2C69297B766172206F3D6E2E7365676D656E74496E6465782C733D742E6C656E6774682D652E6C656E6774';
wwv_flow_imp.g_varchar2_table(40563) := '683B696628692E7365676D656E744D6F7665297B76617220723D692E7365676D656E744D6F76652E7365676D656E745374617274496E6465782C613D692E7365676D656E744D6F76652E6E65775365676D656E745374617274496E6465783B7265747572';
wwv_flow_imp.g_varchar2_table(40564) := '6E206F3D3D3D723F613A6F3E3D613F6F2B733C613F613A6F2B733A6F7D696628692E62656E64706F696E744D6F7665297B766172206C2C633D692E62656E64706F696E744D6F76652E696E736572742C643D692E62656E64706F696E744D6F76652E6265';
wwv_flow_imp.g_varchar2_table(40565) := '6E64706F696E74496E6465783B72657475726E20303D3D3D733F6F3A286F3E3D642626286C3D633F6F2B313A6F2D31292C6F3C642626286C3D6F2C6326262262656E64706F696E7422213D3D6E2E747970652626642D313D3D3D6F2626757528742C6429';
wwv_flow_imp.g_varchar2_table(40566) := '3C6E2E72656C61746976654C6F636174696F6E26266C2B2B292C6C297D72657475726E20303D3D3D733F6F3A692E636F6E6E656374696F6E53746172742626303D3D3D6F3F303A692E636F6E6E656374696F6E456E6426266F3D3D3D652E6C656E677468';
wwv_flow_imp.g_varchar2_table(40567) := '2D323F742E6C656E6774682D323A4D6174682E666C6F6F722828742E6C656E6774682D32292F32297D286E2C742C612C69293B696628633C307C7C633E742E6C656E6774682D327C7C6E756C6C3D3D3D632972657475726E20723B76617220642C682C75';
wwv_flow_imp.g_varchar2_table(40568) := '2C702C672C6D2C663D7075286E2C6C292C763D707528742C63292C623D612E706F736974696F6E2C5F3D28703D622C673D6E642828753D66295B305D2C755B315D292C6D3D6E6428755B305D2C70292C303D3D3D673F303A6D2F67292C793D28643D762C';
wwv_flow_imp.g_varchar2_table(40569) := '683D4A632866292C4A632864292D68293B6966282262656E64706F696E74223D3D3D612E74797065297B76617220773D742E6C656E6774682D6E2E6C656E6774682C433D612E62656E64706F696E74496E6465782C533D6E5B435D3B6966282D31213D3D';
wwv_flow_imp.g_varchar2_table(40570) := '742E696E6465784F662853292972657475726E20723B696628303D3D3D77297B76617220783D745B435D3B72657475726E7B64656C74613A7B783A6F3D782E782D612E706F736974696F6E2E782C793A733D782E792D612E706F736974696F6E2E797D2C';
wwv_flow_imp.g_varchar2_table(40571) := '706F696E743A7B783A652E782B6F2C793A652E792B737D7D7D773C30262630213D3D432626433C6E2E6C656E6774682D312626285F3D7575286E2C4329297D766172206B2C452C4C3D7B783A28765B315D2E782D765B305D2E78292A5F2B765B305D2E78';
wwv_flow_imp.g_varchar2_table(40572) := '2C793A28765B315D2E792D765B305D2E79292A5F2B765B305D2E797D2C443D286B3D7B783A652E782D622E782C793A652E792D622E797D2C28453D79293F7B783A4D6174682E636F732845292A6B2E782D4D6174682E73696E2845292A6B2E792C793A4D';
wwv_flow_imp.g_varchar2_table(40573) := '6174682E73696E2845292A6B2E782B4D6174682E636F732845292A6B2E797D3A6B293B72657475726E206F3D4C2E782B442E782D652E782C733D4C2E792B442E792D652E792C7B706F696E743A426E284C292C64656C74613A426E287B783A6F2C793A73';
wwv_flow_imp.g_varchar2_table(40574) := '7D297D7D66756E6374696F6E20757528652C74297B766172206E3D6E6428655B742D315D2C655B745D293B72657475726E206E2F286E2B6E6428655B745D2C655B742B315D29297D66756E6374696F6E20707528652C74297B72657475726E5B655B745D';
wwv_flow_imp.g_varchar2_table(40575) := '2C655B742B315D5D7D66756E6374696F6E20677528652C742C6E297B76617220693D66612874292C6F3D6661286E292C733D766128652C69292C723D732E782A286E2E77696474682F742E7769647468292C613D732E792A286E2E6865696768742F742E';
wwv_flow_imp.g_varchar2_table(40576) := '686569676874293B72657475726E20426E287B783A6F2E782B722C793A6F2E792B617D297D66756E6374696F6E206D7528652C742C6E297B76617220693D66612865292C6F3D66612874292C733D6661286E292C723D766128652C69292C613D76612869';
wwv_flow_imp.g_varchar2_table(40577) := '2C6F292C6C3D66756E6374696F6E28652C742C6E297B76617220693D566E2874292C6F3D566E286E293B69662866756E6374696F6E28652C74297B72657475726E2066756E6374696F6E28652C74297B72657475726E20652E7269676874213D3D742E72';
wwv_flow_imp.g_varchar2_table(40578) := '696768742626652E6C656674213D3D742E6C6566747D28652C74297C7C66756E6374696F6E28652C74297B72657475726E20652E746F70213D3D742E746F702626652E626F74746F6D213D3D742E626F74746F6D7D28652C74297D28692C6F2929726574';
wwv_flow_imp.g_varchar2_table(40579) := '75726E206E756C6C3B76617220732C723D576E28742C65293B69662822746F70223D3D3D7229733D7B783A302C793A6F2E626F74746F6D2D692E626F74746F6D7D3B656C73652069662822626F74746F6D223D3D3D7229733D7B783A302C793A6F2E746F';
wwv_flow_imp.g_varchar2_table(40580) := '702D692E746F707D3B656C736520696628227269676874223D3D3D7229733D7B783A6F2E6C6566742D692E6C6566742C793A307D3B656C73657B696628226C65667422213D3D722972657475726E206E756C6C3B733D7B783A6F2E72696768742D692E72';
wwv_flow_imp.g_varchar2_table(40581) := '696768742C793A307D7D72657475726E20576E286E2C7B783A652E782B732E782C793A652E792B732E797D29213D3D723F6E756C6C3A737D28692C742C6E293B6966286C2972657475726E206C3B76617220633D612E782A286E2E77696474682F742E77';
wwv_flow_imp.g_varchar2_table(40582) := '69647468292C643D612E792A286E2E6865696768742F742E686569676874292C683D732E782B632C753D732E792B643B72657475726E20426E287B783A682B722E782D652E782C793A752B722E792D652E797D297D7661722066753D226E616D65222C76';
wwv_flow_imp.g_varchar2_table(40583) := '753D2274657874223B66756E6374696F6E20627528652C742C6E2C6F297B66756E6374696F6E20732865297B766172206E3D652E636F6E746578742C693D6E2E656C656D656E742C733D6E2E70726F706572746965733B696628667520696E2073262674';
wwv_flow_imp.g_varchar2_table(40584) := '2E7570646174654C6162656C28692C735B66755D292C767520696E2073262628302C792E69732928692C2262706D6E3A54657874416E6E6F746174696F6E2229297B76617220723D6F2E67657454657874416E6E6F746174696F6E426F756E6473287B78';
wwv_flow_imp.g_varchar2_table(40585) := '3A692E782C793A692E792C77696474683A692E77696474682C6865696768743A692E6865696768747D2C735B76755D7C7C2222293B742E7570646174654C6162656C28692C732E746578742C72297D7D65722E63616C6C28746869732C65292C74686973';
wwv_flow_imp.g_varchar2_table(40586) := '2E706F7374457865637574652822656C656D656E742E75706461746550726F70657274696573222C73292C746869732E706F7374457865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C28653D3E7B2830';
wwv_flow_imp.g_varchar2_table(40587) := '2C792E676574427573696E6573734F626A6563742928652E636F6E746578742E656C656D656E74293D3D3D652E636F6E746578742E6D6F64646C65456C656D656E742626732865297D29292C746869732E706F737445786563757465285B227368617065';
wwv_flow_imp.g_varchar2_table(40588) := '2E637265617465222C22636F6E6E656374696F6E2E637265617465225D2C2866756E6374696F6E2865297B766172206E3D652E636F6E746578743B6966282131213D3D286E2E68696E74737C7C7B7D292E637265617465456C656D656E74734265686176';
wwv_flow_imp.g_varchar2_table(40589) := '696F72297B76617220693D6E2E73686170657C7C6E2E636F6E6E656374696F6E3B21526E28692926266373286929262670732869292626742E7570646174654C6162656C28692C7073286929297D7D29292C746869732E706F7374457865637574652822';
wwv_flow_imp.g_varchar2_table(40590) := '73686170652E64656C657465222C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E6C6162656C5461726765742C6F3D6E2E68696E74737C7C7B7D3B6926262131213D3D6F2E756E7365744C6162656C2626742E757064';
wwv_flow_imp.g_varchar2_table(40591) := '6174654C6162656C28692C6E756C6C2C6E756C6C2C7B72656D6F766553686170653A21317D297D29292C746869732E706F737445786563757465285B22636F6E6E656374696F6E2E6C61796F7574222C22636F6E6E656374696F6E2E7570646174655761';
wwv_flow_imp.g_varchar2_table(40592) := '79706F696E7473225D2C2866756E6374696F6E2865297B766172206E3D652E636F6E746578743B6966282131213D3D286E2E68696E74737C7C7B7D292E6C6162656C4265686176696F72297B766172206F2C733D6E2E636F6E6E656374696F6E2E6C6162';
wwv_flow_imp.g_varchar2_table(40593) := '656C3B732626732E706172656E742626286F3D66756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E636F6E6E656374696F6E2C6F3D6E2E6C6162656C2C733D28302C692E6B7029287B7D2C742E68696E7473292C723D742E6E';
wwv_flow_imp.g_varchar2_table(40594) := '6577576179706F696E74737C7C6E2E776179706F696E74732C613D742E6F6C64576179706F696E74733B72657475726E20766F696420303D3D3D732E73746172744368616E676564262628732E73746172744368616E6765643D2121732E636F6E6E6563';
wwv_flow_imp.g_varchar2_table(40595) := '74696F6E5374617274292C766F696420303D3D3D732E656E644368616E676564262628732E656E644368616E6765643D2121732E636F6E6E656374696F6E456E64292C66756E6374696F6E28652C742C6E2C69297B72657475726E20687528486E286529';
wwv_flow_imp.g_varchar2_table(40596) := '2C742C6E2C69292E64656C74617D286F2C722C612C73297D2865292C742E6D6F7665536861706528732C6F29297D7D29292C746869732E706F737445786563757465285B2273686170652E7265706C616365225D2C2866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(40597) := '7220743D652E636F6E746578742C6E3D742E6E657753686170652C693D742E6F6C6453686170652C6F3D28302C792E676574427573696E6573734F626A65637429286E293B6F26266373286F292626692E6C6162656C26266E2E6C6162656C2626286E2E';
wwv_flow_imp.g_varchar2_table(40598) := '6C6162656C2E783D692E6C6162656C2E782C6E2E6C6162656C2E793D692E6C6162656C2E79297D29292C746869732E706F737445786563757465282273686170652E726573697A65222C2866756E6374696F6E2865297B766172206E2C6F3D652E636F6E';
wwv_flow_imp.g_varchar2_table(40599) := '746578742C733D6F2E73686170652C723D6F2E6E6577426F756E64732C613D6F2E6F6C64426F756E64733B6966286473287329297B766172206C3D732E6C6162656C2C633D66756E6374696F6E28652C74297B696628742E6C656E677468297B76617220';
wwv_flow_imp.g_varchar2_table(40600) := '6E3D66756E6374696F6E28652C74297B766172206E3D742E6D6170282866756E6374696F6E2874297B72657475726E7B6C696E653A742C64697374616E63653A746428652C74297D7D29293B72657475726E28302C692E556C29286E2C2264697374616E';
wwv_flow_imp.g_varchar2_table(40601) := '636522295B305D2E6C696E657D28652C74293B72657475726E20656428652C6E297D7D28486E286C292C5B5B7B783A286E3D61292E782C793A6E2E797D2C7B783A6E2E782B286E2E77696474687C7C30292C793A6E2E797D5D2C5B7B783A6E2E782B286E';
wwv_flow_imp.g_varchar2_table(40602) := '2E77696474687C7C30292C793A6E2E797D2C7B783A6E2E782B286E2E77696474687C7C30292C793A6E2E792B286E2E6865696768747C7C30297D5D2C5B7B783A6E2E782C793A6E2E792B286E2E6865696768747C7C30297D2C7B783A6E2E782B286E2E77';
wwv_flow_imp.g_varchar2_table(40603) := '696474687C7C30292C793A6E2E792B286E2E6865696768747C7C30297D5D2C5B7B783A6E2E782C793A6E2E797D2C7B783A6E2E782C793A6E2E792B286E2E6865696768747C7C30297D5D5D292C643D66756E6374696F6E28652C742C6E297B7265747572';
wwv_flow_imp.g_varchar2_table(40604) := '6E20426E28766128677528652C742C6E292C6529297D28632C612C72293B742E6D6F76655368617065286C2C64297D7D29297D66756E6374696F6E205F7528652C74297B66756E6374696F6E206E28652C74297B766172206E3D652E636F6E746578742C';
wwv_flow_imp.g_varchar2_table(40605) := '6F3D6E2E636F6E6E656374696F6E2C733D28302C692E6B7029287B7D2C6E2E68696E7473292C723D6E2E6E6577576179706F696E74737C7C6F2E776179706F696E74732C613D6E2E6F6C64576179706F696E74733B72657475726E20766F696420303D3D';
wwv_flow_imp.g_varchar2_table(40606) := '3D732E73746172744368616E676564262628732E73746172744368616E6765643D2121732E636F6E6E656374696F6E5374617274292C766F696420303D3D3D732E656E644368616E676564262628732E656E644368616E6765643D2121732E636F6E6E65';
wwv_flow_imp.g_varchar2_table(40607) := '6374696F6E456E64292C66756E6374696F6E28652C742C6E2C69297B72657475726E20687528652C742C6E2C69292E706F696E747D28742C722C612C73297D65722E63616C6C28746869732C65292C746869732E706F737445786563757465285B22636F';
wwv_flow_imp.g_varchar2_table(40608) := '6E6E656374696F6E2E6C61796F7574222C22636F6E6E656374696F6E2E757064617465576179706F696E7473225D2C2866756E6374696F6E2865297B76617220693D652E636F6E746578742E636F6E6E656374696F6E2C6F3D692E6F7574676F696E673B';
wwv_flow_imp.g_varchar2_table(40609) := '692E696E636F6D696E672E666F7245616368282866756E6374696F6E2869297B766172206F3D692E776179706F696E74735B692E776179706F696E74732E6C656E6774682D315D2C733D6E28652C6F292C723D5B5D2E636F6E63617428692E776179706F';
wwv_flow_imp.g_varchar2_table(40610) := '696E74732E736C69636528302C2D31292C5B735D293B742E757064617465576179706F696E747328692C72297D29292C6F2E666F7245616368282866756E6374696F6E2869297B766172206F3D692E776179706F696E74735B305D2C733D6E28652C6F29';
wwv_flow_imp.g_varchar2_table(40611) := '2C723D5B5D2E636F6E636174285B735D2C692E776179706F696E74732E736C696365283129293B742E757064617465576179706F696E747328692C72297D29297D29292C746869732E706F737445786563757465285B22636F6E6E656374696F6E2E6D6F';
wwv_flow_imp.g_varchar2_table(40612) := '7665225D2C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E636F6E6E656374696F6E2C6F3D692E6F7574676F696E672C733D692E696E636F6D696E672C723D6E2E64656C74613B732E666F7245616368282866756E63';
wwv_flow_imp.g_varchar2_table(40613) := '74696F6E2865297B766172206E3D652E776179706F696E74735B652E776179706F696E74732E6C656E6774682D315D2C693D7B783A6E2E782B722E782C793A6E2E792B722E797D2C6F3D5B5D2E636F6E63617428652E776179706F696E74732E736C6963';
wwv_flow_imp.g_varchar2_table(40614) := '6528302C2D31292C5B695D293B742E757064617465576179706F696E747328652C6F297D29292C6F2E666F7245616368282866756E6374696F6E2865297B766172206E3D652E776179706F696E74735B305D2C693D7B783A6E2E782B722E782C793A6E2E';
wwv_flow_imp.g_varchar2_table(40615) := '792B722E797D2C6F3D5B5D2E636F6E636174285B695D2C652E776179706F696E74732E736C696365283129293B742E757064617465576179706F696E747328652C6F297D29297D29297D66756E6374696F6E20797528652C742C6E297B76617220693D6B';
wwv_flow_imp.g_varchar2_table(40616) := '752865292C6F3D457528692C74292C733D695B305D3B72657475726E206F2E6C656E6774683F6F5B6F2E6C656E6774682D315D3A677528732E6F726967696E616C7C7C732C6E2C74297D66756E6374696F6E20777528652C742C6E297B76617220693D6B';
wwv_flow_imp.g_varchar2_table(40617) := '752865292C6F3D457528692C74292C733D695B692E6C656E6774682D315D3B72657475726E206F2E6C656E6774683F6F5B305D3A677528732E6F726967696E616C7C7C732C6E2C74297D66756E6374696F6E20437528652C742C6E297B76617220693D6B';
wwv_flow_imp.g_varchar2_table(40618) := '752865292C6F3D787528742C6E292C733D695B305D3B72657475726E20677528732E6F726967696E616C7C7C732C6F2C74297D66756E6374696F6E20537528652C742C6E297B76617220693D6B752865292C6F3D787528742C6E292C733D695B692E6C65';
wwv_flow_imp.g_varchar2_table(40619) := '6E6774682D315D3B72657475726E20677528732E6F726967696E616C7C7C732C6F2C74297D66756E6374696F6E20787528652C74297B72657475726E7B783A652E782D742E782C793A652E792D742E792C77696474683A652E77696474682C6865696768';
wwv_flow_imp.g_varchar2_table(40620) := '743A652E6865696768747D7D66756E6374696F6E206B752865297B76617220743D652E776179706F696E74733B69662821742E6C656E677468297468726F77206E6577204572726F722822636F6E6E656374696F6E23222B652E69642B223A206E6F2077';
wwv_flow_imp.g_varchar2_table(40621) := '6179706F696E747322293B72657475726E20747D66756E6374696F6E20457528652C74297B766172206E3D28302C692E546A2928652C4C75293B72657475726E28302C692E706229286E2C2866756E6374696F6E2865297B72657475726E2066756E6374';
wwv_flow_imp.g_varchar2_table(40622) := '696F6E28652C74297B72657475726E22696E74657273656374223D3D3D576E28742C652C31297D28652C74297D29297D66756E6374696F6E204C752865297B72657475726E20652E6F726967696E616C7C7C657D66756E6374696F6E20447528652C7429';
wwv_flow_imp.g_varchar2_table(40623) := '7B65722E63616C6C28746869732C65292C746869732E706F737445786563757465282273686170652E7265706C616365222C2866756E6374696F6E2865297B766172206E3D652E6F6C6453686170652C693D652E6E657753686170653B69662866756E63';
wwv_flow_imp.g_varchar2_table(40624) := '74696F6E28652C74297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E742229262628302C72732E417629286529262628302C792E69732928742C2262706D6E3A5061727469636970616E74222926262128302C7273';
wwv_flow_imp.g_varchar2_table(40625) := '2E4176292874297D286E2C6929297B766172206F2C732C722C612C6C3D28733D6C74285B6F3D6E5D2C2131292C723D5B5D2C613D5B5D2C732E666F7245616368282866756E6374696F6E2865297B65213D3D6F262628652E696E636F6D696E672E666F72';
wwv_flow_imp.g_varchar2_table(40626) := '45616368282866756E6374696F6E2865297B28302C792E69732928652C2262706D6E3A4D657373616765466C6F7722292626722E707573682865297D29292C652E6F7574676F696E672E666F7245616368282866756E6374696F6E2865297B28302C792E';
wwv_flow_imp.g_varchar2_table(40627) := '69732928652C2262706D6E3A4D657373616765466C6F7722292626612E707573682865297D2929297D292C5B5D292C7B696E636F6D696E673A722C6F7574676F696E673A617D293B6C2E696E636F6D696E672E666F7245616368282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40628) := '2865297B766172206F3D777528652C692C6E293B742E7265636F6E6E656374456E6428652C692C6F297D29292C6C2E6F7574676F696E672E666F7245616368282866756E6374696F6E2865297B766172206F3D797528652C692C6E293B742E7265636F6E';
wwv_flow_imp.g_varchar2_table(40629) := '6E656374537461727428652C692C6F297D29297D7D292C2130297D522862752C6572292C62752E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67222C2262706D6E466163746F7279222C227465787452656E6465726572225D2C';
wwv_flow_imp.g_varchar2_table(40630) := '52285F752C6572292C5F752E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C44752E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C522844752C6572293B636F6E73742054753D5B2262';
wwv_flow_imp.g_varchar2_table(40631) := '706D6E3A4D6573736167654576656E74446566696E6974696F6E222C2262706D6E3A54696D65724576656E74446566696E6974696F6E222C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E222C2262706D6E3A436F6E6469';
wwv_flow_imp.g_varchar2_table(40632) := '74696F6E616C4576656E74446566696E6974696F6E222C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E225D3B66756E6374696F6E2049752865297B636F6E737420743D28302C792E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(40633) := '65293B696628212828302C792E69732928742C2262706D6E3A426F756E646172794576656E7422297C7C28302C792E69732928742C2262706D6E3A53746172744576656E742229262628302C72732E51312928742E24706172656E742929297265747572';
wwv_flow_imp.g_varchar2_table(40634) := '6E21313B636F6E7374206E3D742E67657428226576656E74446566696E6974696F6E7322293B72657475726E2128216E7C7C216E2E6C656E67746829262654752E736F6D652828653D3E28302C792E697329286E5B305D2C652929297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(40635) := '6E204D752865297B72657475726E28302C792E69732928652C2262706D6E3A426F756E646172794576656E7422293F2263616E63656C4163746976697479223A226973496E74657272757074696E67227D66756E6374696F6E20417528652C74297B652E';
wwv_flow_imp.g_varchar2_table(40636) := '696E766F6B652865722C74686973292C746869732E706F73744578656375746564282273686170652E7265706C616365222C2866756E6374696F6E2865297B636F6E7374206E3D652E636F6E746578742E6F6C6453686170652C693D652E636F6E746578';
wwv_flow_imp.g_varchar2_table(40637) := '742E6E657753686170652C6F3D652E636F6E746578742E68696E74733B6966282149752869292972657475726E3B636F6E737420733D4D752869293B6966286F2E746172676574456C656D656E742626766F69642030213D3D6F2E746172676574456C65';
wwv_flow_imp.g_varchar2_table(40638) := '6D656E745B735D2972657475726E3B636F6E737420723D28302C792E676574427573696E6573734F626A65637429286E292E6765742873293B72213D3D28302C792E676574427573696E6573734F626A656374292869292E6765742873292626742E7570';
wwv_flow_imp.g_varchar2_table(40639) := '6461746550726F7065727469657328692C7B5B735D3A727D297D29297D66756E6374696F6E204E7528652C74297B65722E63616C6C28746869732C65292C746869732E70726545786563757465282273686170652E726573697A65222C2866756E637469';
wwv_flow_imp.g_varchar2_table(40640) := '6F6E2865297B766172206E3D652E73686170652C693D28302C792E676574446929286E292C6F3D692626692E67657428226C6162656C22293B6F26266F2E6765742822626F756E647322292626742E7570646174654D6F64646C6550726F706572746965';
wwv_flow_imp.g_varchar2_table(40641) := '73286E2C6F2C7B626F756E64733A766F696420307D297D292C2130297D66756E6374696F6E20507528652C742C6E297B65722E63616C6C28746869732C65292C746869732E70726545786563757465282273686170652E64656C657465222C2866756E63';
wwv_flow_imp.g_varchar2_table(40642) := '74696F6E2865297B76617220692C6F2C732C723D652E636F6E746578742E73686170653B696628313D3D3D722E696E636F6D696E672E6C656E6774682626313D3D3D722E6F7574676F696E672E6C656E677468297B76617220613D722E696E636F6D696E';
wwv_flow_imp.g_varchar2_table(40643) := '675B305D2C6C3D722E6F7574676F696E675B305D3B69662828302C792E69732928612C2262706D6E3A53657175656E6365466C6F772229262628302C792E697329286C2C2262706D6E3A53657175656E6365466C6F7722292626742E63616E436F6E6E65';
wwv_flow_imp.g_varchar2_table(40644) := '637428612E736F757263652C6C2E7461726765742C6129297B76617220633D28693D612E776179706F696E74732C6F3D6C2E776179706F696E74732C28733D5A68284F7528695B692E6C656E6774682D325D292C4F7528695B692E6C656E6774682D315D';
wwv_flow_imp.g_varchar2_table(40645) := '292C4F75286F5B315D292C4F75286F5B305D2929293F5B5D2E636F6E63617428692E736C69636528302C692E6C656E6774682D31292C5B735D2C6F2E736C696365283129293A5B4F7528695B305D292C4F75286F5B6F2E6C656E6774682D315D295D293B';
wwv_flow_imp.g_varchar2_table(40646) := '6E2E7265636F6E6E656374456E6428612C6C2E7461726765742C63297D7D7D29297D66756E6374696F6E204F752865297B72657475726E20652E6F726967696E616C7C7C657D66756E6374696F6E20527528652C74297B65722E63616C6C28746869732C';
wwv_flow_imp.g_varchar2_table(40647) := '65292C746869732E70726545786563757465282273686170652E64656C657465222C2866756E6374696F6E2865297B76617220743D652E73686170652C6E3D742E706172656E743B28302C792E69732928742C2262706D6E3A5061727469636970616E74';
wwv_flow_imp.g_varchar2_table(40648) := '2229262628652E636F6C6C61626F726174696F6E526F6F743D6E297D292C2130292C746869732E706F737445786563757465282273686170652E64656C657465222C2866756E6374696F6E2865297B766172206E3D652E636F6C6C61626F726174696F6E';
wwv_flow_imp.g_varchar2_table(40649) := '526F6F743B6966286E2626216E2E627573696E6573734F626A6563742E7061727469636970616E74732E6C656E677468297B76617220693D742E6D616B6550726F6365737328292C6F3D6E2E6368696C6472656E2E736C69636528293B742E6D6F766545';
wwv_flow_imp.g_varchar2_table(40650) := '6C656D656E7473286F2C7B783A302C793A307D2C69297D7D292C2130297D66756E6374696F6E20467528652C742C6E2C6F297B65722E63616C6C28746869732C65293B76617220733D6F2E67657428226472616767696E67222C2131293B66756E637469';
wwv_flow_imp.g_varchar2_table(40651) := '6F6E20722865297B76617220692C6F2C733D652E736F757263652C723D652E7461726765743B652E706172656E7426262828302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722292626286E2E63616E436F6E6E6563745365717565';
wwv_flow_imp.g_varchar2_table(40652) := '6E6365466C6F7728732C72297C7C286F3D2130292C6E2E63616E436F6E6E6563744D657373616765466C6F7728732C7229262628693D2262706D6E3A4D657373616765466C6F772229292C28302C792E69732928652C2262706D6E3A4D65737361676546';
wwv_flow_imp.g_varchar2_table(40653) := '6C6F7722292626286E2E63616E436F6E6E6563744D657373616765466C6F7728732C72297C7C286F3D2130292C6E2E63616E436F6E6E65637453657175656E6365466C6F7728732C7229262628693D2262706D6E3A53657175656E6365466C6F77222929';
wwv_flow_imp.g_varchar2_table(40654) := '2C6F2626742E72656D6F7665436F6E6E656374696F6E2865292C692626742E636F6E6E65637428732C722C7B747970653A692C776179706F696E74733A652E776179706F696E74732E736C69636528297D29297D746869732E706F737445786563757465';
wwv_flow_imp.g_varchar2_table(40655) := '642822656C656D656E74732E6D6F7665222C2866756E6374696F6E2865297B76617220743D652E636C6F737572652E616C6C436F6E6E656374696F6E733B28302C692E6A4A2928742C72297D292C2130292C746869732E70726545786563757465282263';
wwv_flow_imp.g_varchar2_table(40656) := '6F6E6E656374696F6E2E7265636F6E6E656374222C2866756E6374696F6E2865297B76617220692C6F2C723D652E636F6E746578742C613D722E636F6E6E656374696F6E2C6C3D722E6E6577536F757263657C7C612E736F757263652C633D722E6E6577';
wwv_flow_imp.g_varchar2_table(40657) := '5461726765747C7C612E7461726765743B28693D6E2E63616E436F6E6E656374286C2C6329292626692E74797065213D3D612E747970652626286F3D742E636F6E6E656374286C2C632C7B747970653A692E747970652C6173736F63696174696F6E4469';
wwv_flow_imp.g_varchar2_table(40658) := '72656374696F6E3A692E6173736F63696174696F6E446972656374696F6E2C776179706F696E74733A612E776179706F696E74732E736C69636528297D292C612E706172656E742626742E72656D6F7665436F6E6E656374696F6E2861292C722E636F6E';
wwv_flow_imp.g_varchar2_table(40659) := '6E656374696F6E3D6F2C73262666756E6374696F6E28652C74297B766172206E2C693D732E636F6E7465787428292C6F3D692626692E7061796C6F61642E70726576696F757353656C656374696F6E3B6F26266F2E6C656E67746826262D31213D3D286E';
wwv_flow_imp.g_varchar2_table(40660) := '3D6F2E696E6465784F662865292926266F2E73706C696365286E2C312C74297D28612C6F29297D29292C746869732E706F737445786563757465642822656C656D656E742E75706461746550726F70657274696573222C2866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(40661) := '766172206E2C6F3D652E636F6E746578742C733D6F2E70726F706572746965732C723D6F2E656C656D656E742C613D722E627573696E6573734F626A6563743B732E64656661756C742626286E3D28302C692E49362928722E6F7574676F696E672C2830';
wwv_flow_imp.g_varchar2_table(40662) := '2C692E674829287B69643A722E627573696E6573734F626A6563742E64656661756C742E69647D2929292626742E75706461746550726F70657274696573286E2C7B636F6E646974696F6E45787072657373696F6E3A766F696420307D292C732E636F6E';
wwv_flow_imp.g_varchar2_table(40663) := '646974696F6E45787072657373696F6E2626612E736F757263655265662E64656661756C743D3D3D612626742E75706461746550726F7065727469657328722E736F757263652C7B64656661756C743A766F696420307D297D29297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40664) := '20427528652C742C6E2C6F2C732C72297B6F2E696E766F6B652865722C74686973292C746869732E5F62706D6E5265706C6163653D652C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F73656C656374696F6E3D722C746869';
wwv_flow_imp.g_varchar2_table(40665) := '732E706F73744578656375746564285B22656C656D656E74732E637265617465225D2C3530302C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C6F3D6E2E706172656E742C733D6E2E656C656D656E74732C723D28302C692E54';
wwv_flow_imp.g_varchar2_table(40666) := '532928732C2866756E6374696F6E28652C6E297B76617220693D742E63616E5265706C616365285B6E5D2C6E2E686F73747C7C6E2E706172656E747C7C6F293B72657475726E20693F652E636F6E63617428692E7265706C6163656D656E7473293A657D';
wwv_flow_imp.g_varchar2_table(40667) := '292C5B5D293B722E6C656E6774682626746869732E5F7265706C616365456C656D656E747328732C72297D292C74686973292C746869732E706F73744578656375746564285B22656C656D656E74732E6D6F7665225D2C3530302C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40668) := '2865297B766172206E3D652E636F6E746578742C6F3D6E2E6E6577506172656E742C733D6E2E6E6577486F73742C723D5B5D3B28302C692E6A4A29286E2E636C6F737572652E746F704C6576656C2C2866756E6374696F6E2865297B723D28302C72732E';
wwv_flow_imp.g_varchar2_table(40669) := '5131292865293F722E636F6E63617428652E6368696C6472656E293A722E636F6E6361742865297D29292C313D3D3D722E6C656E6774682626732626286F3D73293B76617220613D742E63616E5265706C61636528722C6F293B612626746869732E5F72';
wwv_flow_imp.g_varchar2_table(40670) := '65706C616365456C656D656E747328722C612E7265706C6163656D656E74732C73297D292C74686973292C746869732E706F737445786563757465285B2273686170652E7265706C616365225D2C313530302C2866756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(40671) := '6E2C693D652E636F6E746578742C6F3D692E6F6C6453686170652C733D692E6E657753686170652C723D6F2E6174746163686572733B722626722E6C656E6774682626286E3D742E63616E5265706C61636528722C73292C746869732E5F7265706C6163';
wwv_flow_imp.g_varchar2_table(40672) := '65456C656D656E747328722C6E2E7265706C6163656D656E747329297D292C74686973292C746869732E706F73744578656375746564285B2273686170652E7265706C616365225D2C313530302C2866756E6374696F6E2865297B76617220743D652E63';
wwv_flow_imp.g_varchar2_table(40673) := '6F6E746578742C6E3D742E6F6C6453686170652C693D742E6E657753686170653B732E756E636C61696D4964286E2E627573696E6573734F626A6563742E69642C6E2E627573696E6573734F626A656374292C732E75706461746550726F706572746965';
wwv_flow_imp.g_varchar2_table(40674) := '7328692C7B69643A6E2E69647D297D29297D41752E24696E6A6563743D5B22696E6A6563746F72222C226D6F64656C696E67225D2C522841752C6572292C52284E752C6572292C4E752E24696E6A6563743D5B226576656E74427573222C226D6F64656C';
wwv_flow_imp.g_varchar2_table(40675) := '696E67225D2C522850752C6572292C50752E24696E6A6563743D5B226576656E74427573222C2262706D6E52756C6573222C226D6F64656C696E67225D2C52752E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C522852';
wwv_flow_imp.g_varchar2_table(40676) := '752C6572292C522846752C6572292C46752E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67222C2262706D6E52756C6573222C22696E6A6563746F72225D2C522842752C6572292C42752E70726F746F747970652E5F7265706C';
wwv_flow_imp.g_varchar2_table(40677) := '616365456C656D656E74733D66756E6374696F6E28652C74297B766172206E3D746869732E5F656C656D656E7452656769737472792C6F3D746869732E5F62706D6E5265706C6163652C733D746869732E5F73656C656374696F6E3B28302C692E6A4A29';
wwv_flow_imp.g_varchar2_table(40678) := '28742C2866756E6374696F6E2874297B76617220693D7B747970653A742E6E6577456C656D656E74547970657D2C733D6E2E67657428742E6F6C64456C656D656E744964292C723D652E696E6465784F662873293B655B725D3D6F2E7265706C61636545';
wwv_flow_imp.g_varchar2_table(40679) := '6C656D656E7428732C692C7B73656C6563743A21317D297D29292C742626732E73656C6563742865297D2C42752E24696E6A6563743D5B2262706D6E5265706C616365222C2262706D6E52756C6573222C22656C656D656E745265676973747279222C22';
wwv_flow_imp.g_varchar2_table(40680) := '696E6A6563746F72222C226D6F64656C696E67222C2273656C656374696F6E225D3B7661722056753D7B77696474683A3134302C6865696768743A3132307D2C7A753D7B77696474683A3330302C6865696768743A36307D2C48753D7B77696474683A36';
wwv_flow_imp.g_varchar2_table(40681) := '302C6865696768743A3330307D2C57753D7B77696474683A3330302C6865696768743A3135307D2C6A753D7B77696474683A3135302C6865696768743A3330307D2C71753D7B77696474683A3134302C6865696768743A3132307D2C24753D7B77696474';
wwv_flow_imp.g_varchar2_table(40682) := '683A35302C6865696768743A33307D3B66756E6374696F6E2055752865297B652E6F6E2822726573697A652E7374617274222C313530302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170652C693D742E64';
wwv_flow_imp.g_varchar2_table(40683) := '6972656374696F6E2C6F3D742E62616C616E6365643B2828302C792E697329286E2C2262706D6E3A4C616E6522297C7C28302C792E697329286E2C2262706D6E3A5061727469636970616E74222929262628742E726573697A65436F6E73747261696E74';
wwv_flow_imp.g_varchar2_table(40684) := '733D66756E6374696F6E28652C742C6E297B76617220693D56682865292C6F3D21302C733D21302C723D466828692C5B695D292C613D566E2865292C6C3D7B7D2C633D7B7D2C643D28302C72732E2462292865292C683D643F7A753A48753B2F6E2F2E74';
wwv_flow_imp.g_varchar2_table(40685) := '6573742874293F632E746F703D612E626F74746F6D2D682E6865696768743A2F652F2E746573742874293F632E72696768743D612E6C6566742B682E77696474683A2F732F2E746573742874293F632E626F74746F6D3D612E746F702B682E6865696768';
wwv_flow_imp.g_varchar2_table(40686) := '743A2F772F2E74657374287429262628632E6C6566743D612E72696768742D682E7769647468292C722E666F7245616368282866756E6374696F6E2865297B76617220693D566E2865293B2F6E2F2E74657374287429262628642626692E746F703C612E';
wwv_flow_imp.g_varchar2_table(40687) := '746F702D31302626286F3D2131292C6E26264B7528612E746F702D692E626F74746F6D293C313026265875286C2C22746F70222C692E746F702B682E686569676874292C4B7528612E746F702D692E746F70293C3526265A7528632C22746F70222C692E';
wwv_flow_imp.g_varchar2_table(40688) := '626F74746F6D2D682E68656967687429292C2F652F2E7465737428742926262821642626692E72696768743E612E72696768742B3130262628733D2131292C6E26264B7528612E72696768742D692E6C656674293C313026265A75286C2C227269676874';
wwv_flow_imp.g_varchar2_table(40689) := '222C692E72696768742D682E7769647468292C4B7528612E72696768742D692E7269676874293C352626587528632C227269676874222C692E6C6566742B682E776964746829292C2F732F2E74657374287429262628642626692E626F74746F6D3E612E';
wwv_flow_imp.g_varchar2_table(40690) := '626F74746F6D2B3130262628733D2131292C6E26264B7528612E626F74746F6D2D692E746F70293C313026265A75286C2C22626F74746F6D222C692E626F74746F6D2D682E686569676874292C4B7528612E626F74746F6D2D692E626F74746F6D293C35';
wwv_flow_imp.g_varchar2_table(40691) := '2626587528632C22626F74746F6D222C692E746F702B682E68656967687429292C2F772F2E7465737428742926262821642626692E6C6566743C612E6C6566742D31302626286F3D2131292C6E26264B7528612E6C6566742D692E7269676874293C3130';
wwv_flow_imp.g_varchar2_table(40692) := '26265875286C2C226C656674222C692E6C6566742B682E7769647468292C4B7528612E6C6566742D692E6C656674293C3526265A7528632C226C656674222C692E72696768742D682E776964746829297D29293B76617220753D692E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(40693) := '2E66696C746572282866756E6374696F6E2865297B72657475726E21652E68696464656E262621652E776179706F696E747326262828302C792E69732928652C2262706D6E3A466C6F77456C656D656E7422297C7C28302C792E69732928652C2262706D';
wwv_flow_imp.g_varchar2_table(40694) := '6E3A41727469666163742229297D29292C703D643F4A753A65703B72657475726E20752E666F7245616368282866756E6374696F6E2865297B766172206E3D566E2865293B6F26262F6E2F2E7465737428742926265A7528632C22746F70222C6E2E746F';
wwv_flow_imp.g_varchar2_table(40695) := '702D702E746F70292C7326262F652F2E746573742874292626587528632C227269676874222C6E2E72696768742B702E7269676874292C7326262F732F2E746573742874292626587528632C22626F74746F6D222C6E2E626F74746F6D2B702E626F7474';
wwv_flow_imp.g_varchar2_table(40696) := '6F6D292C6F26262F772F2E7465737428742926265A7528632C226C656674222C6E2E6C6566742D702E6C656674297D29292C7B6D696E3A632C6D61783A6C7D7D286E2C692C6F29292C28302C792E697329286E2C2262706D6E3A53756250726F63657373';
wwv_flow_imp.g_varchar2_table(40697) := '2229262628302C72732E417629286E29262628742E6D696E44696D656E73696F6E733D7175292C28302C792E697329286E2C2262706D6E3A54657874416E6E6F746174696F6E2229262628742E6D696E44696D656E73696F6E733D2475297D29297D5575';
wwv_flow_imp.g_varchar2_table(40698) := '2E24696E6A6563743D5B226576656E74427573225D3B766172204B753D4D6174682E6162732C47753D4D6174682E6D696E2C51753D4D6174682E6D61783B66756E6374696F6E20597528652C742C6E2C69297B766172206F3D655B745D3B655B745D3D76';
wwv_flow_imp.g_varchar2_table(40699) := '6F696420303D3D3D6F3F6E3A69286E2C6F297D66756E6374696F6E205A7528652C742C6E297B72657475726E20597528652C742C6E2C4775297D66756E6374696F6E20587528652C742C6E297B72657475726E20597528652C742C6E2C5175297D766172';
wwv_flow_imp.g_varchar2_table(40700) := '204A753D7B746F703A32302C6C6566743A35302C72696768743A32302C626F74746F6D3A32307D2C65703D7B746F703A35302C6C6566743A32302C72696768743A32302C626F74746F6D3A32307D3B66756E6374696F6E20747028652C74297B652E6F6E';
wwv_flow_imp.g_varchar2_table(40701) := '2822726573697A652E7374617274222C313530312C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170653B2828302C792E697329286E2C2262706D6E3A4C616E6522297C7C28302C792E697329286E2C226270';
wwv_flow_imp.g_varchar2_table(40702) := '6D6E3A5061727469636970616E74222929262628742E62616C616E6365643D214E72286529297D29292C652E6F6E2822726573697A652E656E64222C313030312C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E7368';
wwv_flow_imp.g_varchar2_table(40703) := '6170652C6F3D6E2E63616E457865637574652C733D6E2E6E6577426F756E64733B69662828302C792E69732928692C2262706D6E3A4C616E6522297C7C28302C792E69732928692C2262706D6E3A5061727469636970616E7422292972657475726E206F';
wwv_flow_imp.g_varchar2_table(40704) := '262628733D466E2873292C742E726573697A654C616E6528692C732C6E2E62616C616E63656429292C21317D29297D66756E6374696F6E206E7028652C742C6E2C6F2C73297B66756E6374696F6E20722865297B72657475726E28302C792E6973416E79';
wwv_flow_imp.g_varchar2_table(40705) := '2928652C5B2262706D6E3A526563656976655461736B222C2262706D6E3A53656E645461736B225D297C7C66756E6374696F6E28652C74297B72657475726E28302C692E6379292874297C7C28743D5B745D292C28302C692E7A4E2928742C2866756E63';
wwv_flow_imp.g_varchar2_table(40706) := '74696F6E2874297B72657475726E28302C72732E49702928652C74297D29297D28652C5B2262706D6E3A4572726F724576656E74446566696E6974696F6E222C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E222C226270';
wwv_flow_imp.g_varchar2_table(40707) := '6D6E3A4D6573736167654576656E74446566696E6974696F6E222C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E225D297D66756E6374696F6E20612874297B766172206E3D652E676574446566696E6974696F6E7328292E676574';
wwv_flow_imp.g_varchar2_table(40708) := '2822726F6F74456C656D656E747322293B72657475726E212128302C692E493629286E2C28302C692E674829287B69643A742E69647D29297D66756E6374696F6E206C2865297B72657475726E28302C792E69732928652C2262706D6E3A4572726F7245';
wwv_flow_imp.g_varchar2_table(40709) := '76656E74446566696E6974696F6E22293F226572726F72526566223A28302C792E69732928652C2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E22293F22657363616C6174696F6E526566223A28302C792E69732928652C';
wwv_flow_imp.g_varchar2_table(40710) := '2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22293F226D657373616765526566223A28302C792E69732928652C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E22293F227369676E616C526566223A766F69';
wwv_flow_imp.g_varchar2_table(40711) := '6420307D66756E6374696F6E20632865297B69662828302C792E6973416E792928652C5B2262706D6E3A526563656976655461736B222C2262706D6E3A53656E645461736B225D292972657475726E20652E67657428226D65737361676552656622293B';
wwv_flow_imp.g_varchar2_table(40712) := '76617220743D652E67657428226576656E74446566696E6974696F6E7322295B305D3B72657475726E20742E676574286C287429297D6E2E696E766F6B652865722C74686973292C746869732E6578656375746564285B2273686170652E637265617465';
wwv_flow_imp.g_varchar2_table(40713) := '222C22656C656D656E742E75706461746550726F70657274696573222C22656C656D656E742E7570646174654D6F64646C6550726F70657274696573225D2C2866756E6374696F6E2874297B766172206E3D742E73686170657C7C742E656C656D656E74';
wwv_flow_imp.g_varchar2_table(40714) := '3B69662872286E29297B76617220693D632828302C792E676574427573696E6573734F626A65637429286E29293B69262621612869292626284B7428652E676574446566696E6974696F6E7328292E6765742822726F6F74456C656D656E747322292C69';
wwv_flow_imp.g_varchar2_table(40715) := '292C742E6164646564526F6F74456C656D656E743D69297D7D292C2130292C746869732E7265766572746564285B2273686170652E637265617465222C22656C656D656E742E75706461746550726F70657274696573222C22656C656D656E742E757064';
wwv_flow_imp.g_varchar2_table(40716) := '6174654D6F64646C6550726F70657274696573225D2C2866756E6374696F6E2874297B766172206E3D742E6164646564526F6F74456C656D656E743B6E2626557428652E676574446566696E6974696F6E7328292E6765742822726F6F74456C656D656E';
wwv_flow_imp.g_varchar2_table(40717) := '747322292C6E297D292C2130292C742E6F6E2822636F707950617374652E636F7079456C656D656E74222C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D652E656C656D656E743B696628216E2E6C6162656C5461';
wwv_flow_imp.g_varchar2_table(40718) := '72676574262672286E29297B76617220693D632828302C792E676574427573696E6573734F626A65637429286E29293B69262628742E7265666572656E636564526F6F74456C656D656E743D69297D7D29292C742E6F6E2822636F707950617374652E70';
wwv_flow_imp.g_varchar2_table(40719) := '61737465456C656D656E74222C3530302C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D742E627573696E6573734F626A6563742C693D742E7265666572656E636564526F6F74456C656D656E743B692626286128';
wwv_flow_imp.g_varchar2_table(40720) := '69297C7C28693D6F2E636F7079456C656D656E7428692C732E63726561746528692E24747970652929292C66756E6374696F6E28652C74297B69662828302C792E6973416E792928652C5B2262706D6E3A526563656976655461736B222C2262706D6E3A';
wwv_flow_imp.g_varchar2_table(40721) := '53656E645461736B225D292972657475726E20652E73657428226D657373616765526566222C74293B766172206E3D652E67657428226576656E74446566696E6974696F6E7322295B305D3B6E2E736574286C286E292C74297D286E2C69292C64656C65';
wwv_flow_imp.g_varchar2_table(40722) := '746520742E7265666572656E636564526F6F74456C656D656E74297D29297D74702E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C6E702E24696E6A6563743D5B2262706D6E6A73222C226576656E74427573222C2269';
wwv_flow_imp.g_varchar2_table(40723) := '6E6A6563746F72222C226D6F64646C65436F7079222C2262706D6E466163746F7279225D2C52286E702C6572293B7661722069703D4D6174682E6D61783B66756E6374696F6E206F702865297B652E6F6E28227370616365546F6F6C2E6765744D696E44';
wwv_flow_imp.g_varchar2_table(40724) := '696D656E73696F6E73222C2866756E6374696F6E2865297B76617220743D652E7368617065732C6E3D652E617869732C6F3D652E73746172742C733D7B7D3B72657475726E28302C692E6A4A2928742C2866756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(40725) := '2E69643B28302C792E69732928652C2262706D6E3A5061727469636970616E742229262628735B745D3D66756E6374696F6E28652C742C6E297B76617220693D28302C72732E2462292865293B6966282142682865292E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(40726) := '20693F57753A6A753B766172206F3D66756E6374696F6E2865297B72657475726E2278223D3D3D657D2874293B72657475726E206F3F693F57753A7B77696474683A727028652C6E2C6F292C6865696768743A6A752E6865696768747D3A693F7B776964';
wwv_flow_imp.g_varchar2_table(40727) := '74683A57752E77696474682C6865696768743A737028652C6E2C6F297D3A6A757D28652C6E2C6F29292C28302C792E69732928652C2262706D6E3A4C616E652229262628735B745D3D28302C72732E2462292865293F7A753A4875292C28302C792E6973';
wwv_flow_imp.g_varchar2_table(40728) := '2928652C2262706D6E3A53756250726F636573732229262628302C72732E417629286529262628735B745D3D7175292C28302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E2229262628735B745D3D2475292C28302C792E6973';
wwv_flow_imp.g_varchar2_table(40729) := '2928652C2262706D6E3A47726F75702229262628735B745D3D5675297D29292C737D29297D66756E6374696F6E20737028652C742C6E297B76617220693B72657475726E20693D66756E6374696F6E28652C742C6E297B76617220693B72657475726E20';
wwv_flow_imp.g_varchar2_table(40730) := '693D61702842682865292C742C6E292C652E6865696768742D692E6865696768742B7A752E6865696768747D28652C742C6E292C69702857752E6865696768742C69297D66756E6374696F6E20727028652C742C6E297B76617220693B72657475726E20';
wwv_flow_imp.g_varchar2_table(40731) := '693D66756E6374696F6E28652C742C6E297B76617220693B72657475726E20693D61702842682865292C742C6E292C652E77696474682D692E77696474682B48752E77696474687D28652C742C6E292C6970286A752E77696474682C69297D66756E6374';
wwv_flow_imp.g_varchar2_table(40732) := '696F6E20617028652C742C6E297B76617220692C6F2C733B666F7228693D303B693C652E6C656E6774683B692B2B296966286F3D655B695D2C216E2626743E3D6F2E792626743C3D6F2E792B6F2E6865696768747C7C6E2626743E3D6F2E782626743C3D';
wwv_flow_imp.g_varchar2_table(40733) := '6F2E782B6F2E77696474682972657475726E28733D4268286F29292E6C656E6774683F617028732C742C6E293A6F7D6F702E24696E6A6563743D5B226576656E74427573225D3B66756E6374696F6E206C7028652C742C6E2C6F2C732C722C61297B6572';
wwv_flow_imp.g_varchar2_table(40734) := '2E63616C6C28746869732C74292C746869732E5F63616E7661733D652C746869732E5F6576656E744275733D742C746869732E5F6D6F64656C696E673D6E2C746869732E5F656C656D656E74466163746F72793D6F2C746869732E5F62706D6E46616374';
wwv_flow_imp.g_varchar2_table(40735) := '6F72793D732C746869732E5F62706D6E6A733D722C746869732E5F656C656D656E7452656769737472793D613B766172206C3D746869733B66756E6374696F6E20632865297B72657475726E28302C792E69732928652C2262706D6E3A53756250726F63';
wwv_flow_imp.g_varchar2_table(40736) := '657373222926262128302C72732E4176292865297D66756E6374696F6E20642874297B766172206E3D742E73686170652C693D742E6E6577526F6F74456C656D656E742C6F3D28302C792E676574427573696E6573734F626A65637429286E293B693D6C';
wwv_flow_imp.g_varchar2_table(40737) := '2E5F6164644469616772616D28697C7C6F292C742E6E6577526F6F74456C656D656E743D652E616464526F6F74456C656D656E742869297D66756E6374696F6E20682874297B766172206E3D742E73686170652C693D28302C792E676574427573696E65';
wwv_flow_imp.g_varchar2_table(40738) := '73734F626A65637429286E293B6C2E5F72656D6F76654469616772616D2869293B766172206F3D742E6E6577526F6F74456C656D656E743D612E676574287272286929293B652E72656D6F7665526F6F74456C656D656E74286F297D746869732E657865';
wwv_flow_imp.g_varchar2_table(40739) := '6375746564282273686170652E637265617465222C2866756E6374696F6E2865297B6328652E7368617065292626642865297D292C2130292C746869732E706F73744578656375746564282273686170652E637265617465222C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(40740) := '65297B76617220743D652E73686170652C6E3D652E6E6577526F6F74456C656D656E743B6E2626742E6368696C6472656E2626286C2E5F73686F775265637572736976656C7928742E6368696C6472656E292C6C2E5F6D6F76654368696C6472656E546F';
wwv_flow_imp.g_varchar2_table(40741) := '536861706528742C6E29297D292C2130292C746869732E7265766572746564282273686170652E637265617465222C2866756E6374696F6E2865297B6328652E7368617065292626682865297D292C2130292C746869732E707265457865637574656428';
wwv_flow_imp.g_varchar2_table(40742) := '2273686170652E64656C657465222C2866756E6374696F6E2865297B76617220743D652E73686170653B69662863287429297B76617220693D612E676574287272287429293B6926266E2E72656D6F7665456C656D656E747328692E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(40743) := '2E736C6963652829297D7D292C2130292C746869732E6578656375746564282273686170652E64656C657465222C2866756E6374696F6E2865297B6328652E7368617065292626682865297D292C2130292C746869732E72657665727465642822736861';
wwv_flow_imp.g_varchar2_table(40744) := '70652E64656C657465222C2866756E6374696F6E2865297B6328652E7368617065292626642865297D292C2130292C746869732E7072654578656375746564282273686170652E7265706C616365222C2866756E6374696F6E2874297B766172206E3D74';
wwv_flow_imp.g_varchar2_table(40745) := '2E6F6C6453686170652C693D742E6E657753686170653B63286E29262663286929262628742E6F6C64526F6F743D652E72656D6F7665526F6F74456C656D656E74287272286E2929297D292C2130292C746869732E706F73744578656375746564282273';
wwv_flow_imp.g_varchar2_table(40746) := '686170652E7265706C616365222C2866756E6374696F6E2874297B76617220693D742E6E657753686170652C6F3D742E6F6C64526F6F742C733D652E66696E64526F6F74287272286929293B6966286F262673297B76617220723D6F2E6368696C647265';
wwv_flow_imp.g_varchar2_table(40747) := '6E3B6E2E6D6F7665456C656D656E747328722C7B783A302C793A307D2C73297D7D292C2130292C746869732E65786563757465642822656C656D656E742E75706461746550726F70657274696573222C2866756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(40748) := '2E656C656D656E743B69662828302C792E69732928742C2262706D6E3A53756250726F636573732229297B766172206E3D652E70726F706572746965732C693D652E6F6C6450726F706572746965732E69642C6F3D6E2E69643B69662869213D3D6F297B';
wwv_flow_imp.g_varchar2_table(40749) := '6966286C722874292972657475726E20612E757064617465496428742C6172286F29292C766F696420612E757064617465496428692C6F293B612E676574286172286929292626612E75706461746549642861722869292C6172286F29297D7D7D292C21';
wwv_flow_imp.g_varchar2_table(40750) := '30292C746869732E72657665727465642822656C656D656E742E75706461746550726F70657274696573222C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B69662828302C792E69732928742C2262706D6E3A53756250726F63';
wwv_flow_imp.g_varchar2_table(40751) := '6573732229297B766172206E3D652E70726F706572746965732C693D652E6F6C6450726F706572746965732E69642C6F3D6E2E69643B69662869213D3D6F297B6966286C722874292972657475726E20612E757064617465496428742C6172286929292C';
wwv_flow_imp.g_varchar2_table(40752) := '766F696420612E7570646174654964286F2C69293B76617220733D612E676574286172286F29293B732626612E757064617465496428732C6172286929297D7D7D292C2130292C742E6F6E2822656C656D656E742E6368616E676564222C2866756E6374';
wwv_flow_imp.g_varchar2_table(40753) := '696F6E2865297B766172206E3D652E656C656D656E743B6966286C72286E29297B76617220693D6E2C6F3D612E676574287372286929293B6F26266F213D3D692626742E666972652822656C656D656E742E6368616E676564222C7B656C656D656E743A';
wwv_flow_imp.g_varchar2_table(40754) := '6F7D297D7D29292C746869732E6578656375746564282273686170652E746F67676C65436F6C6C61707365222C3430302C2866756E6374696F6E2865297B76617220743D652E73686170653B28302C792E69732928742C2262706D6E3A53756250726F63';
wwv_flow_imp.g_varchar2_table(40755) := '657373222926262828302C72732E4176292874293F682865293A28642865292C6C2E5F73686F775265637572736976656C7928742E6368696C6472656E2929297D292C2130292C746869732E7265766572746564282273686170652E746F67676C65436F';
wwv_flow_imp.g_varchar2_table(40756) := '6C6C61707365222C3430302C2866756E6374696F6E2865297B76617220743D652E73686170653B28302C792E69732928742C2262706D6E3A53756250726F63657373222926262828302C72732E4176292874293F682865293A28642865292C6C2E5F7368';
wwv_flow_imp.g_varchar2_table(40757) := '6F775265637572736976656C7928742E6368696C6472656E2929297D292C2130292C746869732E706F73744578656375746564282273686170652E746F67676C65436F6C6C61707365222C3630302C2866756E6374696F6E2865297B76617220743D652E';
wwv_flow_imp.g_varchar2_table(40758) := '73686170653B69662828302C792E69732928742C2262706D6E3A53756250726F636573732229297B766172206E3D652E6E6577526F6F74456C656D656E743B6E26262828302C72732E4176292874293F6C2E5F6D6F76654368696C6472656E546F536861';
wwv_flow_imp.g_varchar2_table(40759) := '7065286E2C74293A6C2E5F6D6F76654368696C6472656E546F536861706528742C6E29297D7D292C2130292C742E6F6E2822636F707950617374652E63726561746554726565222C2866756E6374696F6E2865297B76617220743D652E656C656D656E74';
wwv_flow_imp.g_varchar2_table(40760) := '2C6E3D652E6368696C6472656E3B69662863287429297B76617220693D72722874292C6F3D612E6765742869293B6F26266E2E707573682E6170706C79286E2C6F2E6368696C6472656E297D7D29292C742E6F6E2822636F707950617374652E636F7079';
wwv_flow_imp.g_varchar2_table(40761) := '456C656D656E74222C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D652E656C656D656E742C6F3D652E656C656D656E74732C733D6E2E706172656E743B69662828302C792E6973292828302C792E676574446929';
wwv_flow_imp.g_varchar2_table(40762) := '2873292C2262706D6E64693A42504D4E506C616E652229297B76617220723D73722873292C613D28302C692E493629286F2C2866756E6374696F6E2865297B72657475726E20652E69643D3D3D727D29293B61262628742E706172656E743D612E696429';
wwv_flow_imp.g_varchar2_table(40763) := '7D7D29292C742E6F6E2822636F707950617374652E7061737465456C656D656E74222C2866756E6374696F6E2865297B76617220743D652E64657363726970746F723B742E706172656E742626286328742E706172656E74297C7C742E706172656E742E';
wwv_flow_imp.g_varchar2_table(40764) := '68696464656E29262628742E68696464656E3D2130297D29297D66756E6374696F6E20637028652C74297B652E696E766F6B652865722C74686973292C746869732E706F73744578656375746564282273686170652E7265706C616365222C2866756E63';
wwv_flow_imp.g_varchar2_table(40765) := '74696F6E2865297B766172206E3D652E636F6E746578742E6F6C6453686170652C693D652E636F6E746578742E6E657753686170653B69662828302C792E69732928692C2262706D6E3A53756250726F63657373222926262828302C792E697329286E2C';
wwv_flow_imp.g_varchar2_table(40766) := '2262706D6E3A5461736B22297C7C28302C792E697329286E2C2262706D6E3A43616C6C4163746976697479222929262628302C72732E417629286929297B766172206F2C733D7B783A286F3D69292E782B6F2E77696474682F362C793A6F2E792B6F2E68';
wwv_flow_imp.g_varchar2_table(40767) := '65696768742F327D3B742E6372656174655368617065287B747970653A2262706D6E3A53746172744576656E74227D2C732C69297D7D29297D66756E6374696F6E2064702865297B65722E63616C6C28746869732C65292C746869732E70726545786563';
wwv_flow_imp.g_varchar2_table(40768) := '7574652822636F6E6E656374696F6E2E637265617465222C2866756E6374696F6E2865297B636F6E73747B7461726765743A747D3D653B28302C792E69732928742C2262706D6E3A54657874416E6E6F746174696F6E2229262628652E706172656E743D';
wwv_flow_imp.g_varchar2_table(40769) := '742E706172656E74297D292C2130292C746869732E70726545786563757465285B2273686170652E637265617465222C2273686170652E726573697A65222C22656C656D656E74732E6D6F7665225D2C2866756E6374696F6E2865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(40770) := '3D652E7368617065737C7C5B652E73686170655D3B313D3D3D742E6C656E677468262628302C792E69732928745B305D2C2262706D6E3A54657874416E6E6F746174696F6E2229262628652E68696E74733D652E68696E74737C7C7B7D2C652E68696E74';
wwv_flow_imp.g_varchar2_table(40771) := '732E6175746F526573697A653D2131297D292C2130297D66756E6374696F6E20687028652C74297B65722E63616C6C28746869732C65292C746869732E706F73744578656375746564282273686170652E746F67676C65436F6C6C61707365222C313530';
wwv_flow_imp.g_varchar2_table(40772) := '302C2866756E6374696F6E2865297B766172206E3D652E73686170653B6966282128302C72732E417629286E29297B766172206F3D6C74286E293B6F2E666F7245616368282866756E6374696F6E2865297B76617220743D652E696E636F6D696E672E73';
wwv_flow_imp.g_varchar2_table(40773) := '6C69636528292C6E3D652E6F7574676F696E672E736C69636528293B28302C692E6A4A2928742C2866756E6374696F6E2865297B7328652C2130297D29292C28302C692E6A4A29286E2C2866756E6374696F6E2865297B7328652C2131297D29297D2929';
wwv_flow_imp.g_varchar2_table(40774) := '7D66756E6374696F6E207328652C69297B2D31213D3D6F2E696E6465784F6628652E736F757263652926262D31213D3D6F2E696E6465784F6628652E746172676574297C7C28693F742E7265636F6E6E656374456E6428652C6E2C486E286E29293A742E';
wwv_flow_imp.g_varchar2_table(40775) := '7265636F6E6E656374537461727428652C6E2C486E286E2929297D7D292C2130297D66756E6374696F6E20757028652C742C6E297B65722E63616C6C28746869732C65292C746869732E6578656375746564285B2273686170652E746F67676C65436F6C';
wwv_flow_imp.g_varchar2_table(40776) := '6C61707365225D2C3530302C2866756E6374696F6E2865297B76617220742C6E3D652E636F6E746578742E73686170653B28302C792E697329286E2C2262706D6E3A53756250726F6365737322292626286E2E636F6C6C61707365643F28302C792E6765';
wwv_flow_imp.g_varchar2_table(40777) := '74446929286E292E6973457870616E6465643D21313A2828743D6E2E6368696C6472656E292E6C656E6774682626742E666F7245616368282866756E6374696F6E2865297B226C6162656C22213D3D652E747970657C7C652E627573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(40778) := '6563742E6E616D657C7C28652E68696464656E3D2130297D29292C28302C792E676574446929286E292E6973457870616E6465643D213029297D29292C746869732E7265766572746564285B2273686170652E746F67676C65436F6C6C61707365225D2C';
wwv_flow_imp.g_varchar2_table(40779) := '3530302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E73686170653B742E636F6C6C61707365643F28302C792E6765744469292874292E6973457870616E6465643D21313A28302C792E6765744469292874292E6973457870';
wwv_flow_imp.g_varchar2_table(40780) := '616E6465643D21307D29292C746869732E706F73744578656375746564285B2273686170652E746F67676C65436F6C6C61707365225D2C3530302C2866756E6374696F6E2865297B76617220692C6F3D652E636F6E746578742E73686170652C733D742E';
wwv_flow_imp.g_varchar2_table(40781) := '67657444656661756C7453697A65286F293B693D6F2E636F6C6C61707365643F66756E6374696F6E28652C74297B72657475726E7B783A652E782B28652E77696474682D742E7769647468292F322C793A652E792B28652E6865696768742D742E686569';
wwv_flow_imp.g_varchar2_table(40782) := '676874292F322C77696474683A742E77696474682C6865696768743A742E6865696768747D7D286F2C73293A66756E6374696F6E28652C74297B766172206E2C692C6F2C733D743B72657475726E206E3D286F3D652E6368696C6472656E2C6F2E66696C';
wwv_flow_imp.g_varchar2_table(40783) := '746572282866756E6374696F6E2865297B72657475726E21652E68696464656E7D2929292E636F6E636174285B655D292C28693D4E68286E29293F28732E77696474683D4D6174682E6D617828692E77696474682C732E7769647468292C732E68656967';
wwv_flow_imp.g_varchar2_table(40784) := '68743D4D6174682E6D617828692E6865696768742C732E686569676874292C732E783D692E782B28692E77696474682D732E7769647468292F322C732E793D692E792B28692E6865696768742D732E686569676874292F32293A28732E783D652E782B28';
wwv_flow_imp.g_varchar2_table(40785) := '652E77696474682D732E7769647468292F322C732E793D652E792B28652E6865696768742D732E686569676874292F32292C737D286F2C73292C6E2E726573697A655368617065286F2C692C6E756C6C2C7B6175746F526573697A653A216F2E636F6C6C';
wwv_flow_imp.g_varchar2_table(40786) := '61707365642626226E777365227D297D29297D66756E6374696F6E20707028652C742C6E2C69297B742E696E766F6B652865722C74686973292C746869732E70726545786563757465282273686170652E64656C657465222C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(40787) := '297B76617220743D652E636F6E746578742E73686170652C6F3D742E627573696E6573734F626A6563743B526E2874297C7C2828302C792E69732928742C2262706D6E3A5061727469636970616E742229262628302C72732E41762928742926266E2E69';
wwv_flow_imp.g_varchar2_table(40788) := '64732E756E636C61696D286F2E70726F636573735265662E6964292C692E756E636C61696D4964286F2E69642C6F29297D29292C746869732E707265457865637574652822636F6E6E656374696F6E2E64656C657465222C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(40789) := '7B76617220743D652E636F6E746578742E636F6E6E656374696F6E2E627573696E6573734F626A6563743B692E756E636C61696D496428742E69642C74297D29292C746869732E70726545786563757465282263616E7661732E757064617465526F6F74';
wwv_flow_imp.g_varchar2_table(40790) := '222C2866756E6374696F6E28297B76617220743D652E676574526F6F74456C656D656E7428292C693D742E627573696E6573734F626A6563743B28302C792E69732928742C2262706D6E3A436F6C6C61626F726174696F6E222926266E2E6964732E756E';
wwv_flow_imp.g_varchar2_table(40791) := '636C61696D28692E6964297D29297D66756E6374696F6E20677028652C74297B65722E63616C6C28746869732C65292C746869732E707265457865637574652822636F6E6E656374696F6E2E64656C657465222C2866756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(40792) := '206E3D652E636F6E746578742E636F6E6E656374696F6E2C693D6E2E736F757263653B2866756E6374696F6E28652C74297B6966282128302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722292972657475726E21313B766172206E';
wwv_flow_imp.g_varchar2_table(40793) := '3D28302C792E676574427573696E6573734F626A656374292874292C693D28302C792E676574427573696E6573734F626A656374292865293B72657475726E206E2E676574282264656661756C7422293D3D3D697D29286E2C69292626742E7570646174';
wwv_flow_imp.g_varchar2_table(40794) := '6550726F7065727469657328692C7B64656661756C743A6E756C6C7D297D29297D66756E6374696F6E206D7028652C74297B766172206E3B65722E63616C6C28746869732C65293B76617220693D5B227370616365546F6F6C222C226C616E652E616464';
wwv_flow_imp.g_varchar2_table(40795) := '222C226C616E652E726573697A65222C226C616E652E73706C6974222C22656C656D656E74732E637265617465222C22656C656D656E74732E64656C657465222C22656C656D656E74732E6D6F7665222C2273686170652E637265617465222C22736861';
wwv_flow_imp.g_varchar2_table(40796) := '70652E64656C657465222C2273686170652E6D6F7665222C2273686170652E726573697A65225D3B746869732E7072654578656375746528692C3565332C2866756E6374696F6E2865297B286E3D6E7C7C6E6577206670292E656E74657228297D29292C';
wwv_flow_imp.g_varchar2_table(40797) := '746869732E706F7374457865637574656428692C3530302C2866756E6374696F6E2865297B2166756E6374696F6E28297B696628216E297468726F77206E6577204572726F7228226F7574206F6620626F756E64732072656C6561736522293B6E2E6C65';
wwv_flow_imp.g_varchar2_table(40798) := '6176652829262628742E7570646174654C616E6552656673286E2E666C6F774E6F6465732C6E2E6C616E6573292C6E3D6E756C6C297D28297D29292C746869732E70726545786563757465285B2273686170652E637265617465222C2273686170652E6D';
wwv_flow_imp.g_varchar2_table(40799) := '6F7665222C2273686170652E64656C657465222C2273686170652E726573697A65225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E73686170652C693D66756E6374696F6E28297B696628216E297468726F77206E657720';
wwv_flow_imp.g_varchar2_table(40800) := '4572726F7228226F7574206F6620626F756E64732072656C6561736522293B72657475726E206E7D28293B742E6C6162656C5461726765747C7C2828302C792E69732928742C2262706D6E3A4C616E6522292626692E6164644C616E652874292C28302C';
wwv_flow_imp.g_varchar2_table(40801) := '792E69732928742C2262706D6E3A466C6F774E6F646522292626692E616464466C6F774E6F6465287429297D29297D66756E6374696F6E20667028297B746869732E666C6F774E6F6465733D5B5D2C746869732E6C616E65733D5B5D2C746869732E636F';
wwv_flow_imp.g_varchar2_table(40802) := '756E7465723D302C746869732E6164644C616E653D66756E6374696F6E2865297B746869732E6C616E65732E707573682865297D2C746869732E616464466C6F774E6F64653D66756E6374696F6E2865297B746869732E666C6F774E6F6465732E707573';
wwv_flow_imp.g_varchar2_table(40803) := '682865297D2C746869732E656E7465723D66756E6374696F6E28297B746869732E636F756E7465722B2B7D2C746869732E6C656176653D66756E6374696F6E28297B72657475726E20746869732E636F756E7465722D2D2C21746869732E636F756E7465';
wwv_flow_imp.g_varchar2_table(40804) := '727D7D52286C702C6572292C6C702E70726F746F747970652E5F6D6F76654368696C6472656E546F53686170653D66756E6374696F6E28652C74297B766172206E2C693D746869732E5F6D6F64656C696E672C6F3D652E6368696C6472656E3B6966286F';
wwv_flow_imp.g_varchar2_table(40805) := '297B76617220733D286F3D6F2E636F6E636174286F2E726564756365282866756E6374696F6E28742C6E297B72657475726E206E2E6C6162656C26266E2E6C6162656C2E706172656E74213D3D653F742E636F6E636174286E2E6C6162656C293A747D29';
wwv_flow_imp.g_varchar2_table(40806) := '2C5B5D2929292E66696C746572282866756E6374696F6E2865297B72657475726E21652E68696464656E7D29293B696628732E6C656E677468297B76617220723D63742873293B696628742E78297B76617220613D486E2874292C6C3D486E2872293B6E';
wwv_flow_imp.g_varchar2_table(40807) := '3D7B783A612E782D6C2E782C793A612E792D6C2E797D7D656C7365206E3D7B783A3138302D722E782C793A3136302D722E797D3B692E6D6F7665456C656D656E7473286F2C6E2C742C7B6175746F526573697A653A21317D297D656C736520692E6D6F76';
wwv_flow_imp.g_varchar2_table(40808) := '65456C656D656E7473286F2C7B783A302C793A307D2C742C7B6175746F526573697A653A21317D297D7D2C6C702E70726F746F747970652E5F73686F775265637572736976656C793D66756E6374696F6E28652C74297B766172206E3D746869732C693D';
wwv_flow_imp.g_varchar2_table(40809) := '5B5D3B72657475726E20652E666F7245616368282866756E6374696F6E2865297B652E68696464656E3D2121742C693D692E636F6E6361742865292C652E6368696C6472656E262628693D692E636F6E636174286E2E5F73686F77526563757273697665';
wwv_flow_imp.g_varchar2_table(40810) := '6C7928652E6368696C6472656E2C652E636F6C6C61707365647C7C742929297D29292C697D2C6C702E70726F746F747970652E5F6164644469616772616D3D66756E6374696F6E2865297B76617220743D746869732E5F62706D6E6A732E676574446566';
wwv_flow_imp.g_varchar2_table(40811) := '696E6974696F6E7328292E6469616772616D733B72657475726E20652E627573696E6573734F626A6563747C7C28653D746869732E5F6372656174654E65774469616772616D286529292C742E7075736828652E64692E24706172656E74292C657D2C6C';
wwv_flow_imp.g_varchar2_table(40812) := '702E70726F746F747970652E5F6372656174654E65774469616772616D3D66756E6374696F6E2865297B76617220743D746869732E5F62706D6E466163746F72792C6E3D746869732E5F656C656D656E74466163746F72792C693D742E63726561746528';
wwv_flow_imp.g_varchar2_table(40813) := '2262706D6E64693A42504D4E506C616E65222C7B62706D6E456C656D656E743A657D292C6F3D742E637265617465282262706D6E64693A42504D4E4469616772616D222C7B706C616E653A697D293B72657475726E20692E24706172656E743D6F2C6E2E';
wwv_flow_imp.g_varchar2_table(40814) := '637265617465526F6F74287B69643A72722865292C747970653A652E24747970652C64693A692C627573696E6573734F626A6563743A652C636F6C6C61707365643A21307D297D2C6C702E70726F746F747970652E5F72656D6F76654469616772616D3D';
wwv_flow_imp.g_varchar2_table(40815) := '66756E6374696F6E2865297B76617220743D746869732E5F62706D6E6A732E676574446566696E6974696F6E7328292E6469616772616D732C6E3D28302C692E49362928742C2866756E6374696F6E2874297B72657475726E20742E706C616E652E6270';
wwv_flow_imp.g_varchar2_table(40816) := '6D6E456C656D656E742E69643D3D3D652E69647D29293B72657475726E20742E73706C69636528742E696E6465784F66286E292C31292C6E7D2C6C702E24696E6A6563743D5B2263616E766173222C226576656E74427573222C226D6F64656C696E6722';
wwv_flow_imp.g_varchar2_table(40817) := '2C22656C656D656E74466163746F7279222C2262706D6E466163746F7279222C2262706D6E6A73222C22656C656D656E745265676973747279225D2C63702E24696E6A6563743D5B22696E6A6563746F72222C226D6F64656C696E67225D2C522863702C';
wwv_flow_imp.g_varchar2_table(40818) := '6572292C522864702C6572292C64702E24696E6A6563743D5B226576656E74427573225D2C522868702C6572292C68702E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C522875702C6572292C75702E24696E6A656374';
wwv_flow_imp.g_varchar2_table(40819) := '3D5B226576656E74427573222C22656C656D656E74466163746F7279222C226D6F64656C696E67225D2C522870702C6572292C70702E24696E6A6563743D5B2263616E766173222C22696E6A6563746F72222C226D6F64646C65222C226D6F64656C696E';
wwv_flow_imp.g_varchar2_table(40820) := '67225D2C522867702C6572292C67702E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C6D702E24696E6A6563743D5B226576656E74427573222C226D6F64656C696E67225D2C52286D702C6572293B636F6E7374207670';
wwv_flow_imp.g_varchar2_table(40821) := '3D7B5F5F696E69745F5F3A5B2261646170746976654C6162656C506F736974696F6E696E674265686176696F72222C22617070656E644265686176696F72222C226173736F63696174696F6E4265686176696F72222C226174746163684576656E744265';
wwv_flow_imp.g_varchar2_table(40822) := '686176696F72222C22626F756E646172794576656E744265686176696F72222C22636F6D70656E73617465426F756E646172794576656E744265686176696F7572222C226372656174654265686176696F72222C22637265617465446174614F626A6563';
wwv_flow_imp.g_varchar2_table(40823) := '744265686176696F72222C226372656174655061727469636970616E744265686176696F72222C2264617461496E7075744173736F63696174696F6E4265686176696F72222C226461746153746F72654265686176696F72222C2264656C6574654C616E';
wwv_flow_imp.g_varchar2_table(40824) := '654265686176696F72222C226465746163684576656E744265686176696F72222C2264726F704F6E466C6F774265686176696F72222C226576656E744261736564476174657761794265686176696F72222C22666978486F7665724265686176696F7222';
wwv_flow_imp.g_varchar2_table(40825) := '2C2267726F75704265686176696F72222C22696D706F7274446F636B696E67466978222C226973486F72697A6F6E74616C466978222C226C6162656C4265686176696F72222C226C61796F7574436F6E6E656374696F6E4265686176696F72222C226D65';
wwv_flow_imp.g_varchar2_table(40826) := '7373616765466C6F774265686176696F72222C226E6F6E496E74657272757074696E674265686176696F72222C2272656D6F7665456C656D656E744265686176696F72222C2272656D6F7665456D6265646465644C6162656C426F756E64734265686176';
wwv_flow_imp.g_varchar2_table(40827) := '696F72222C2272656D6F76655061727469636970616E744265686176696F72222C227265706C616365436F6E6E656374696F6E4265686176696F72222C227265706C616365456C656D656E744265686176696F7572222C22726573697A65426568617669';
wwv_flow_imp.g_varchar2_table(40828) := '6F72222C22726573697A654C616E654265686176696F72222C22726F6F74456C656D656E745265666572656E63654265686176696F72222C227370616365546F6F6C4265686176696F72222C2273756250726F63657373506C616E654265686176696F72';
wwv_flow_imp.g_varchar2_table(40829) := '222C2273756250726F6365737353746172744576656E744265686176696F72222C2274657874416E6E6F746174696F6E4265686176696F72222C22746F67676C65436F6C6C61707365436F6E6E656374696F6E4265686176696F7572222C22746F67676C';
wwv_flow_imp.g_varchar2_table(40830) := '65456C656D656E74436F6C6C617073654265686176696F7572222C22756E636C61696D49644265686176696F72222C22757064617465466C6F774E6F6465526566734265686176696F72222C22756E73657444656661756C74466C6F774265686176696F';
wwv_flow_imp.g_varchar2_table(40831) := '72225D2C61646170746976654C6162656C506F736974696F6E696E674265686176696F723A5B2274797065222C73685D2C617070656E644265686176696F723A5B2274797065222C61685D2C6173736F63696174696F6E4265686176696F723A5B227479';
wwv_flow_imp.g_varchar2_table(40832) := '7065222C6C685D2C6174746163684576656E744265686176696F723A5B2274797065222C63685D2C626F756E646172794576656E744265686176696F723A5B2274797065222C68685D2C636F6D70656E73617465426F756E646172794576656E74426568';
wwv_flow_imp.g_varchar2_table(40833) := '6176696F75723A5B2274797065222C75685D2C6372656174654265686176696F723A5B2274797065222C66685D2C637265617465446174614F626A6563744265686176696F723A5B2274797065222C76685D2C6372656174655061727469636970616E74';
wwv_flow_imp.g_varchar2_table(40834) := '4265686176696F723A5B2274797065222C5F685D2C64617461496E7075744173736F63696174696F6E4265686176696F723A5B2274797065222C77685D2C6461746153746F72654265686176696F723A5B2274797065222C78685D2C64656C6574654C61';
wwv_flow_imp.g_varchar2_table(40835) := '6E654265686176696F723A5B2274797065222C7A685D2C6465746163684576656E744265686176696F723A5B2274797065222C48685D2C64726F704F6E466C6F774265686176696F723A5B2274797065222C6A685D2C6576656E74426173656447617465';
wwv_flow_imp.g_varchar2_table(40836) := '7761794265686176696F723A5B2274797065222C55685D2C666978486F7665724265686176696F723A5B2274797065222C51685D2C67726F75704265686176696F723A5B2274797065222C59685D2C696D706F7274446F636B696E674669783A5B227479';
wwv_flow_imp.g_varchar2_table(40837) := '7065222C58685D2C6973486F72697A6F6E74616C4669783A5B2274797065222C65755D2C6C6162656C4265686176696F723A5B2274797065222C62755D2C6C61796F7574436F6E6E656374696F6E4265686176696F723A5B2274797065222C5F755D2C6D';
wwv_flow_imp.g_varchar2_table(40838) := '657373616765466C6F774265686176696F723A5B2274797065222C44755D2C6E6F6E496E74657272757074696E674265686176696F723A5B2274797065222C41755D2C72656D6F7665456C656D656E744265686176696F723A5B2274797065222C50755D';
wwv_flow_imp.g_varchar2_table(40839) := '2C72656D6F7665456D6265646465644C6162656C426F756E64734265686176696F723A5B2274797065222C4E755D2C72656D6F76655061727469636970616E744265686176696F723A5B2274797065222C52755D2C7265706C616365436F6E6E65637469';
wwv_flow_imp.g_varchar2_table(40840) := '6F6E4265686176696F723A5B2274797065222C46755D2C7265706C616365456C656D656E744265686176696F75723A5B2274797065222C42755D2C726573697A654265686176696F723A5B2274797065222C55755D2C726573697A654C616E6542656861';
wwv_flow_imp.g_varchar2_table(40841) := '76696F723A5B2274797065222C74705D2C726F6F74456C656D656E745265666572656E63654265686176696F723A5B2274797065222C6E705D2C7370616365546F6F6C4265686176696F723A5B2274797065222C6F705D2C73756250726F63657373506C';
wwv_flow_imp.g_varchar2_table(40842) := '616E654265686176696F723A5B2274797065222C6C705D2C73756250726F6365737353746172744576656E744265686176696F723A5B2274797065222C63705D2C74657874416E6E6F746174696F6E4265686176696F723A5B2274797065222C64705D2C';
wwv_flow_imp.g_varchar2_table(40843) := '746F67676C65436F6C6C61707365436F6E6E656374696F6E4265686176696F75723A5B2274797065222C68705D2C746F67676C65456C656D656E74436F6C6C617073654265686176696F75723A5B2274797065222C75705D2C756E636C61696D49644265';
wwv_flow_imp.g_varchar2_table(40844) := '686176696F723A5B2274797065222C70705D2C756E73657444656661756C74466C6F774265686176696F723A5B2274797065222C67705D2C757064617465466C6F774E6F6465526566734265686176696F723A5B2274797065222C6D705D7D3B66756E63';
wwv_flow_imp.g_varchar2_table(40845) := '74696F6E20627028652C74297B766172206E3D576E28652C742C2D3135293B72657475726E22696E7465727365637422213D3D6E3F6E3A6E756C6C7D66756E6374696F6E205F702865297B70632E63616C6C28746869732C65297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(40846) := '79702865297B72657475726E21657C7C526E2865297D66756E6374696F6E2077702865297B646F7B69662828302C792E69732928652C2262706D6E3A50726F6365737322292972657475726E28302C792E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(40847) := '65293B69662828302C792E69732928652C2262706D6E3A5061727469636970616E7422292972657475726E28302C792E676574427573696E6573734F626A656374292865292E70726F636573735265667C7C28302C792E676574427573696E6573734F62';
wwv_flow_imp.g_varchar2_table(40848) := '6A656374292865297D7768696C6528653D652E706172656E74297D66756E6374696F6E2043702865297B72657475726E28302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E22297D66756E6374696F6E2053702865297B726574';
wwv_flow_imp.g_varchar2_table(40849) := '75726E28302C792E69732928652C2262706D6E3A47726F75702229262621652E6C6162656C5461726765747D66756E6374696F6E2078702865297B72657475726E28302C792E69732928652C2262706D6E3A426F756E646172794576656E742229262644';
wwv_flow_imp.g_varchar2_table(40850) := '7028652C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22297D66756E6374696F6E206B702865297B72657475726E28302C792E676574427573696E6573734F626A656374292865292E6973466F72436F6D70656E736174';
wwv_flow_imp.g_varchar2_table(40851) := '696F6E7D66756E6374696F6E2045702865297B666F722876617220743D653B743D742E706172656E743B297B69662828302C792E69732928742C2262706D6E3A466C6F77456C656D656E7473436F6E7461696E657222292972657475726E28302C792E67';
wwv_flow_imp.g_varchar2_table(40852) := '6574427573696E6573734F626A656374292874293B69662828302C792E69732928742C2262706D6E3A5061727469636970616E7422292972657475726E28302C792E676574427573696E6573734F626A656374292874292E70726F636573735265667D72';
wwv_flow_imp.g_varchar2_table(40853) := '657475726E206E756C6C7D66756E6374696F6E204C7028652C74297B72657475726E2045702865293D3D3D45702874297D66756E6374696F6E20447028652C74297B766172206E3D28302C792E676574427573696E6573734F626A656374292865293B72';
wwv_flow_imp.g_varchar2_table(40854) := '657475726E212128302C692E493629286E2E6576656E74446566696E6974696F6E737C7C5B5D2C2866756E6374696F6E2865297B72657475726E28302C792E69732928652C74297D29297D66756E6374696F6E20547028652C74297B72657475726E2828';
wwv_flow_imp.g_varchar2_table(40855) := '302C792E676574427573696E6573734F626A656374292865292E6576656E74446566696E6974696F6E737C7C5B5D292E6576657279282866756E6374696F6E2865297B72657475726E28302C792E69732928652C74297D29297D66756E6374696F6E2049';
wwv_flow_imp.g_varchar2_table(40856) := '7028652C74297B766172206E3D66756E6374696F6E2865297B666F722876617220743D5B5D3B653B2928653D652E706172656E74292626742E707573682865293B72657475726E20747D2874293B72657475726E2D31213D3D6E2E696E6465784F662865';
wwv_flow_imp.g_varchar2_table(40857) := '297D66756E6374696F6E204D7028652C742C6E297B69662879702865297C7C79702874292972657475726E206E756C6C3B6966282128302C792E697329286E2C2262706D6E3A446174614173736F63696174696F6E2229297B696628717028652C742929';
wwv_flow_imp.g_varchar2_table(40858) := '72657475726E7B747970653A2262706D6E3A4D657373616765466C6F77227D3B696628247028652C74292972657475726E7B747970653A2262706D6E3A53657175656E6365466C6F77227D7D72657475726E20557028652C74297C7C286A7028652C7429';
wwv_flow_imp.g_varchar2_table(40859) := '3F7B747970653A2262706D6E3A4173736F63696174696F6E222C6173736F63696174696F6E446972656374696F6E3A224F6E65227D3A2121577028652C742926267B747970653A2262706D6E3A4173736F63696174696F6E222C6173736F63696174696F';
wwv_flow_imp.g_varchar2_table(40860) := '6E446972656374696F6E3A224E6F6E65227D297D66756E6374696F6E20417028652C74297B72657475726E212821526E2865292626215370286529297C7C212828302C792E69732928742C2262706D6E3A5061727469636970616E74222926262128302C';
wwv_flow_imp.g_varchar2_table(40861) := '72732E4176292874292926262828302C792E69732928652C2262706D6E3A5061727469636970616E7422293F28302C792E69732928742C2262706D6E3A50726F6365737322297C7C28302C792E69732928742C2262706D6E3A436F6C6C61626F72617469';
wwv_flow_imp.g_varchar2_table(40862) := '6F6E22293A28302C792E6973416E792928652C5B2262706D6E3A44617461496E707574222C2262706D6E3A446174614F7574707574225D292626652E706172656E743F743D3D3D652E706172656E743A28302C792E69732928652C2262706D6E3A4C616E';
wwv_flow_imp.g_varchar2_table(40863) := '6522293F28302C792E69732928742C2262706D6E3A5061727469636970616E7422297C7C28302C792E69732928742C2262706D6E3A4C616E6522293A212828302C792E69732928652C2262706D6E3A426F756E646172794576656E7422292626286E3D65';
wwv_flow_imp.g_varchar2_table(40864) := '2C2128302C792E676574427573696E6573734F626A65637429286E292E63616E63656C41637469766974797C7C215070286E292626214F70286E29292926262828302C792E69732928652C2262706D6E3A466C6F77456C656D656E74222926262128302C';
wwv_flow_imp.g_varchar2_table(40865) := '792E69732928652C2262706D6E3A4461746153746F72655265666572656E636522293F28302C792E69732928742C2262706D6E3A466C6F77456C656D656E7473436F6E7461696E657222293F28302C72732E4176292874293A28302C792E6973416E7929';
wwv_flow_imp.g_varchar2_table(40866) := '28742C5B2262706D6E3A5061727469636970616E74222C2262706D6E3A4C616E65225D293A28302C792E69732928652C2262706D6E3A4461746153746F72655265666572656E63652229262628302C792E69732928742C2262706D6E3A436F6C6C61626F';
wwv_flow_imp.g_varchar2_table(40867) := '726174696F6E22293F28302C692E7A4E292828302C792E676574427573696E6573734F626A656374292874292E67657428227061727469636970616E747322292C2866756E6374696F6E2865297B72657475726E2121652E676574282270726F63657373';
wwv_flow_imp.g_varchar2_table(40868) := '52656622297D29293A28302C792E6973416E792928652C5B2262706D6E3A4172746966616374222C2262706D6E3A446174614173736F63696174696F6E222C2262706D6E3A4461746153746F72655265666572656E6365225D293F28302C792E6973416E';
wwv_flow_imp.g_varchar2_table(40869) := '792928742C5B2262706D6E3A436F6C6C61626F726174696F6E222C2262706D6E3A4C616E65222C2262706D6E3A5061727469636970616E74222C2262706D6E3A50726F63657373222C2262706D6E3A53756250726F63657373225D293A212128302C792E';
wwv_flow_imp.g_varchar2_table(40870) := '69732928652C2262706D6E3A4D657373616765466C6F77222926262828302C792E69732928742C2262706D6E3A436F6C6C61626F726174696F6E22297C7C652E736F757263652E706172656E743D3D747C7C652E7461726765742E706172656E743D3D74';
wwv_flow_imp.g_varchar2_table(40871) := '2929293B766172206E7D66756E6374696F6E204E702865297B72657475726E28302C792E69732928652C2262706D6E3A4C616E6522297D66756E6374696F6E2050702865297B76617220743D28302C792E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(40872) := '65293B72657475726E207426262128742E6576656E74446566696E6974696F6E732626742E6576656E74446566696E6974696F6E732E6C656E677468297D66756E6374696F6E204F702865297B72657475726E20527028652C5B2262706D6E3A4D657373';
wwv_flow_imp.g_varchar2_table(40873) := '6167654576656E74446566696E6974696F6E222C2262706D6E3A54696D65724576656E74446566696E6974696F6E222C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E222C2262706D6E3A436F6E646974696F6E616C4576656E7444';
wwv_flow_imp.g_varchar2_table(40874) := '6566696E6974696F6E225D297D66756E6374696F6E20527028652C74297B72657475726E20742E736F6D65282866756E6374696F6E2874297B72657475726E20447028652C74297D29297D66756E6374696F6E20467028652C742C6E2C6F297B69662841';
wwv_flow_imp.g_varchar2_table(40875) := '727261792E697341727261792865297C7C28653D5B655D292C31213D3D652E6C656E6774682972657475726E21313B76617220733D655B305D3B72657475726E21526E2873292626212166756E6374696F6E2865297B72657475726E212166756E637469';
wwv_flow_imp.g_varchar2_table(40876) := '6F6E2865297B72657475726E21526E286529262628302C792E69732928652C2262706D6E3A426F756E646172794576656E7422297D2865297C7C21282128302C792E69732928652C2262706D6E3A496E7465726D6564696174655468726F774576656E74';
wwv_flow_imp.g_varchar2_table(40877) := '22297C7C215070286529297C7C28302C792E69732928652C2262706D6E3A496E7465726D65646961746543617463684576656E74222926264F702865297D28732926262128302C72732E513129287429262621282128302C792E69732928742C2262706D';
wwv_flow_imp.g_varchar2_table(40878) := '6E3A416374697669747922297C7C6B7028742929262621286F2626216270286F2C74292926262166756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A526563656976655461736B2229262628302C692E49362928652E';
wwv_flow_imp.g_varchar2_table(40879) := '696E636F6D696E672C2866756E6374696F6E2865297B72657475726E28302C792E69732928652E736F757263652C2262706D6E3A4576656E7442617365644761746577617922297D29297D287429262622617474616368227D66756E6374696F6E204270';
wwv_flow_imp.g_varchar2_table(40880) := '28652C742C6E297B69662821742972657475726E21313B766172206F3D7B7265706C6163656D656E74733A5B5D7D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B28302C72732E5131292874297C7C28302C792E69732928';
wwv_flow_imp.g_varchar2_table(40881) := '652C2262706D6E3A53746172744576656E7422292626226C6162656C22213D3D652E747970652626417028652C742926262828302C72732E6F68292865297C7C6F2E7265706C6163656D656E74732E70757368287B6F6C64456C656D656E7449643A652E';
wwv_flow_imp.g_varchar2_table(40882) := '69642C6E6577456C656D656E74547970653A2262706D6E3A53746172744576656E74227D292C2828302C72732E474D292865297C7C28302C72732E7068292865297C7C28302C72732E6650292865292926266F2E7265706C6163656D656E74732E707573';
wwv_flow_imp.g_varchar2_table(40883) := '68287B6F6C64456C656D656E7449643A652E69642C6E6577456C656D656E74547970653A2262706D6E3A53746172744576656E74227D292C527028652C5B2262706D6E3A4D6573736167654576656E74446566696E6974696F6E222C2262706D6E3A5469';
wwv_flow_imp.g_varchar2_table(40884) := '6D65724576656E74446566696E6974696F6E222C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E222C2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E225D29262628302C792E69732928742C226270';
wwv_flow_imp.g_varchar2_table(40885) := '6D6E3A53756250726F63657373222926266F2E7265706C6163656D656E74732E70757368287B6F6C64456C656D656E7449643A652E69642C6E6577456C656D656E74547970653A2262706D6E3A53746172744576656E74227D29292C28302C792E697329';
wwv_flow_imp.g_varchar2_table(40886) := '28742C2262706D6E3A5472616E73616374696F6E22297C7C447028652C2262706D6E3A43616E63656C4576656E74446566696E6974696F6E22292626226C6162656C22213D3D652E7479706526262828302C792E69732928652C2262706D6E3A456E6445';
wwv_flow_imp.g_varchar2_table(40887) := '76656E7422292626417028652C742926266F2E7265706C6163656D656E74732E70757368287B6F6C64456C656D656E7449643A652E69642C6E6577456C656D656E74547970653A2262706D6E3A456E644576656E74227D292C28302C792E69732928652C';
wwv_flow_imp.g_varchar2_table(40888) := '2262706D6E3A426F756E646172794576656E7422292626467028652C742C302C6E2926266F2E7265706C6163656D656E74732E70757368287B6F6C64456C656D656E7449643A652E69642C6E6577456C656D656E74547970653A2262706D6E3A426F756E';
wwv_flow_imp.g_varchar2_table(40889) := '646172794576656E74227D29297D29292C21216F2E7265706C6163656D656E74732E6C656E67746826266F7D66756E6374696F6E20567028652C74297B72657475726E2128302C692E7A4E2928652C4E702926262821747C7C652E657665727928286675';
wwv_flow_imp.g_varchar2_table(40890) := '6E6374696F6E2865297B72657475726E20417028652C74297D2929297D66756E6374696F6E207A7028652C742C6E2C69297B72657475726E212174262628212821526E2865292626215370286529297C7C2166756E6374696F6E28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(40891) := '726E20653D3D3D747D286E2C7429262628216E7C7C214970286E2C742929262628417028652C74297C7C4B7028652C742929297D66756E6374696F6E20487028652C74297B72657475726E28302C792E69732928652C2262706D6E3A53756250726F6365';
wwv_flow_imp.g_varchar2_table(40892) := '737322293F28302C72732E41762928652926262821747C7C742E77696474683E3D3130302626742E6865696768743E3D3830293A21212828302C792E69732928652C2262706D6E3A4C616E6522297C7C28302C792E69732928652C2262706D6E3A506172';
wwv_flow_imp.g_varchar2_table(40893) := '7469636970616E7422297C7C43702865297C7C5370286529297D66756E6374696F6E20577028652C74297B72657475726E2128497028742C65297C7C497028652C74297C7C2166756E6374696F6E28652C74297B766172206E3D43702865292C693D4370';
wwv_flow_imp.g_varchar2_table(40894) := '2874293B72657475726E286E7C7C692926266E213D3D697D28652C7429262621557028652C7429297D66756E6374696F6E206A7028652C74297B72657475726E204C7028652C742926267870286529262628302C792E69732928742C2262706D6E3A4163';
wwv_flow_imp.g_varchar2_table(40895) := '74697669747922292626286E3D652C21742E6174746163686572732E696E636C75646573286E292926262128302C72732E5131292874293B766172206E7D66756E6374696F6E20717028652C74297B72657475726E212851702865292626215170287429';
wwv_flow_imp.g_varchar2_table(40896) := '292626286E3D652C28302C792E697329286E2C2262706D6E3A496E746572616374696F6E4E6F6465222926262128302C792E697329286E2C2262706D6E3A426F756E646172794576656E7422292626282128302C792E697329286E2C2262706D6E3A4576';
wwv_flow_imp.g_varchar2_table(40897) := '656E7422297C7C28302C792E697329286E2C2262706D6E3A5468726F774576656E74222926265470286E2C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E222929262666756E6374696F6E2865297B72657475726E28302C792E69';
wwv_flow_imp.g_varchar2_table(40898) := '732928652C2262706D6E3A496E746572616374696F6E4E6F646522292626216B702865292626282128302C792E69732928652C2262706D6E3A4576656E7422297C7C28302C792E69732928652C2262706D6E3A43617463684576656E7422292626547028';
wwv_flow_imp.g_varchar2_table(40899) := '652C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E2229292626212828302C792E69732928652C2262706D6E3A426F756E646172794576656E742229262621447028652C2262706D6E3A4D6573736167654576656E74446566696E';
wwv_flow_imp.g_varchar2_table(40900) := '6974696F6E2229297D28742926262166756E6374696F6E28652C74297B72657475726E2077702865293D3D3D77702874297D28652C7429293B766172206E7D66756E6374696F6E20247028652C74297B72657475726E206E3D652C28302C792E69732928';
wwv_flow_imp.g_varchar2_table(40901) := '6E2C2262706D6E3A466C6F774E6F6465222926262128302C792E697329286E2C2262706D6E3A456E644576656E74222926262128302C72732E513129286E292626212828302C792E697329286E2C2262706D6E3A496E7465726D6564696174655468726F';
wwv_flow_imp.g_varchar2_table(40902) := '774576656E74222926264470286E2C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E2229292626217870286E292626216B70286E29262666756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A466C6F77';
wwv_flow_imp.g_varchar2_table(40903) := '4E6F6465222926262128302C792E69732928652C2262706D6E3A53746172744576656E74222926262128302C792E69732928652C2262706D6E3A426F756E646172794576656E74222926262128302C72732E5131292865292626212828302C792E697329';
wwv_flow_imp.g_varchar2_table(40904) := '28652C2262706D6E3A496E7465726D65646961746543617463684576656E7422292626447028652C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E2229292626216B702865297D28742926264C7028652C74292626212828302C792E6973';
wwv_flow_imp.g_varchar2_table(40905) := '2928652C2262706D6E3A4576656E74426173656447617465776179222926262166756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A526563656976655461736B22297C7C28302C792E69732928652C2262706D6E3A49';
wwv_flow_imp.g_varchar2_table(40906) := '6E7465726D65646961746543617463684576656E742229262628447028652C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22297C7C447028652C2262706D6E3A54696D65724576656E74446566696E6974696F6E22297C7C4470';
wwv_flow_imp.g_varchar2_table(40907) := '28652C2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E22297C7C447028652C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E2229297D287429293B766172206E7D66756E6374696F6E20557028652C';
wwv_flow_imp.g_varchar2_table(40908) := '74297B72657475726E28302C792E6973416E792928652C5B2262706D6E3A446174614F626A6563745265666572656E6365222C2262706D6E3A4461746153746F72655265666572656E6365225D29262628302C792E6973416E792928742C5B2262706D6E';
wwv_flow_imp.g_varchar2_table(40909) := '3A4163746976697479222C2262706D6E3A5468726F774576656E74225D293F7B747970653A2262706D6E3A44617461496E7075744173736F63696174696F6E227D3A21282128302C792E6973416E792928742C5B2262706D6E3A446174614F626A656374';
wwv_flow_imp.g_varchar2_table(40910) := '5265666572656E6365222C2262706D6E3A4461746153746F72655265666572656E6365225D297C7C2128302C792E6973416E792928652C5B2262706D6E3A4163746976697479222C2262706D6E3A43617463684576656E74225D292926267B747970653A';
wwv_flow_imp.g_varchar2_table(40911) := '2262706D6E3A446174614F75747075744173736F63696174696F6E227D7D66756E6374696F6E204B7028652C742C6E297B69662821742972657475726E21313B69662841727261792E69734172726179286529297B69662831213D3D652E6C656E677468';
wwv_flow_imp.g_varchar2_table(40912) := '2972657475726E21313B653D655B305D7D72657475726E20742E736F75726365213D3D652626742E746172676574213D3D65262628302C792E6973416E792928742C5B2262706D6E3A53657175656E6365466C6F77222C2262706D6E3A4D657373616765';
wwv_flow_imp.g_varchar2_table(40913) := '466C6F77225D29262621526E287429262628302C792E69732928652C2262706D6E3A466C6F774E6F6465222926262128302C792E69732928652C2262706D6E3A426F756E646172794576656E7422292626417028652C742E706172656E74297D66756E63';
wwv_flow_imp.g_varchar2_table(40914) := '74696F6E20477028652C74297B72657475726E2121526E2874297C7C212828302C792E69732928742C2262706D6E3A4C616E65222926262166756E6374696F6E28652C74297B72657475726E206526267426262D31213D3D652E696E6465784F66287429';
wwv_flow_imp.g_varchar2_table(40915) := '7D28652C742E706172656E7429297D66756E6374696F6E2051702865297B72657475726E28302C4C632E676574506172656E742928652C2262706D6E3A50726F6365737322297C7C28302C4C632E676574506172656E742928652C2262706D6E3A436F6C';
wwv_flow_imp.g_varchar2_table(40916) := '6C61626F726174696F6E22297D52285F702C7063292C5F702E24696E6A6563743D5B226576656E74427573225D2C5F702E70726F746F747970652E696E69743D66756E6374696F6E28297B746869732E61646452756C652822636F6E6E656374696F6E2E';
wwv_flow_imp.g_varchar2_table(40917) := '7374617274222C2866756E6374696F6E2865297B72657475726E20797028743D652E736F75726365293F6E756C6C3A28302C792E6973416E792928742C5B2262706D6E3A466C6F774E6F6465222C2262706D6E3A496E746572616374696F6E4E6F646522';
wwv_flow_imp.g_varchar2_table(40918) := '2C2262706D6E3A446174614F626A6563745265666572656E6365222C2262706D6E3A4461746153746F72655265666572656E6365222C2262706D6E3A47726F7570222C2262706D6E3A54657874416E6E6F746174696F6E225D293B76617220747D29292C';
wwv_flow_imp.g_varchar2_table(40919) := '746869732E61646452756C652822636F6E6E656374696F6E2E637265617465222C2866756E6374696F6E2865297B76617220743D652E736F757263652C6E3D652E7461726765742C693D652E68696E74737C7C7B7D2C6F3D692E74617267657450617265';
wwv_flow_imp.g_varchar2_table(40920) := '6E743B696628692E7461726765744174746163682972657475726E21313B6F2626286E2E706172656E743D6F293B7472797B72657475726E204D7028742C6E297D66696E616C6C797B6F2626286E2E706172656E743D6E756C6C297D7D29292C74686973';
wwv_flow_imp.g_varchar2_table(40921) := '2E61646452756C652822636F6E6E656374696F6E2E7265636F6E6E656374222C2866756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E3B72657475726E204D7028652E736F757263652C652E7461726765742C74297D29292C7468';
wwv_flow_imp.g_varchar2_table(40922) := '69732E61646452756C652822636F6E6E656374696F6E2E757064617465576179706F696E7473222C2866756E6374696F6E2865297B72657475726E7B747970653A652E636F6E6E656374696F6E2E747970657D7D29292C746869732E61646452756C6528';
wwv_flow_imp.g_varchar2_table(40923) := '2273686170652E726573697A65222C2866756E6374696F6E2865297B72657475726E20487028652E73686170652C652E6E6577426F756E6473297D29292C746869732E61646452756C652822656C656D656E74732E637265617465222C2866756E637469';
wwv_flow_imp.g_varchar2_table(40924) := '6F6E2865297B76617220743D652E656C656D656E74732C6E3D652E706F736974696F6E2C6F3D652E7461726765743B72657475726E21284F6E286F292626214B7028742C6F2929262628302C692E53692928742C2866756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(40925) := '75726E204F6E2865293F4D7028652E736F757263652C652E7461726765742C65293A652E686F73743F467028652C652E686F73742C302C6E293A7A7028652C6F2C6E756C6C297D29297D29292C746869732E61646452756C652822656C656D656E74732E';
wwv_flow_imp.g_varchar2_table(40926) := '6D6F7665222C2866756E6374696F6E2865297B76617220743D652E7461726765742C6E3D652E7368617065732C693D652E706F736974696F6E3B72657475726E204670286E2C742C302C69297C7C4270286E2C742C69297C7C5670286E2C74297C7C4B70';
wwv_flow_imp.g_varchar2_table(40927) := '286E2C74297D29292C746869732E61646452756C65282273686170652E637265617465222C2866756E6374696F6E2865297B72657475726E207A7028652E73686170652C652E7461726765742C652E736F757263652C652E706F736974696F6E297D2929';
wwv_flow_imp.g_varchar2_table(40928) := '2C746869732E61646452756C65282273686170652E617474616368222C2866756E6374696F6E2865297B72657475726E20467028652E73686170652C652E7461726765742C302C652E706F736974696F6E297D29292C746869732E61646452756C652822';
wwv_flow_imp.g_varchar2_table(40929) := '656C656D656E742E636F7079222C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B72657475726E20477028652E656C656D656E74732C74297D29297D2C5F702E70726F746F747970652E63616E436F6E6E6563744D6573736167';
wwv_flow_imp.g_varchar2_table(40930) := '65466C6F773D71702C5F702E70726F746F747970652E63616E436F6E6E65637453657175656E6365466C6F773D24702C5F702E70726F746F747970652E63616E436F6E6E656374446174614173736F63696174696F6E3D55702C5F702E70726F746F7479';
wwv_flow_imp.g_varchar2_table(40931) := '70652E63616E436F6E6E6563744173736F63696174696F6E3D57702C5F702E70726F746F747970652E63616E436F6E6E656374436F6D70656E736174696F6E4173736F63696174696F6E3D6A702C5F702E70726F746F747970652E63616E4D6F76653D56';
wwv_flow_imp.g_varchar2_table(40932) := '702C5F702E70726F746F747970652E63616E4174746163683D46702C5F702E70726F746F747970652E63616E5265706C6163653D42702C5F702E70726F746F747970652E63616E44726F703D41702C5F702E70726F746F747970652E63616E496E736572';
wwv_flow_imp.g_varchar2_table(40933) := '743D4B702C5F702E70726F746F747970652E63616E4372656174653D7A702C5F702E70726F746F747970652E63616E436F6E6E6563743D4D702C5F702E70726F746F747970652E63616E526573697A653D48702C5F702E70726F746F747970652E63616E';
wwv_flow_imp.g_varchar2_table(40934) := '436F70793D47703B636F6E73742059703D7B5F5F646570656E64735F5F3A5B4B635D2C5F5F696E69745F5F3A5B2262706D6E52756C6573225D2C62706D6E52756C65733A5B2274797065222C5F705D7D3B66756E6374696F6E205A7028652C74297B652E';
wwv_flow_imp.g_varchar2_table(40935) := '6F6E282273617665584D4C2E7374617274222C3265332C2866756E6374696F6E28297B76617220653D742E676574526F6F74456C656D656E747328293B28302C692E6A4A2928652C2866756E6374696F6E2865297B76617220742C6E2C6F3D28302C792E';
wwv_flow_imp.g_varchar2_table(40936) := '6765744469292865293B743D6C74285B655D2C2131292C743D28302C692E70622928742C2866756E6374696F6E2874297B72657475726E2074213D3D65262621742E6C6162656C5461726765747D29292C6E3D28302C692E546A2928742C792E67657444';
wwv_flow_imp.g_varchar2_table(40937) := '69292C6F2E7365742822706C616E65456C656D656E74222C6E297D29297D29297D5A702E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E73742058703D7B5F5F696E69745F5F3A5B2262706D6E44694F72646572696E';
wwv_flow_imp.g_varchar2_table(40938) := '67225D2C62706D6E44694F72646572696E673A5B2274797065222C5A705D7D3B66756E6374696F6E204A702865297B65722E63616C6C28746869732C65293B76617220743D746869733B746869732E70726545786563757465285B2273686170652E6372';
wwv_flow_imp.g_varchar2_table(40939) := '65617465222C22636F6E6E656374696F6E2E637265617465225D2C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E73686170657C7C6E2E636F6E6E656374696F6E2C6F3D6E2E706172656E742C733D742E6765744F72';
wwv_flow_imp.g_varchar2_table(40940) := '646572696E6728692C6F293B73262628766F69642030213D3D732E706172656E742626286E2E706172656E743D732E706172656E74292C6E2E706172656E74496E6465783D732E696E646578297D29292C746869732E70726545786563757465285B2273';
wwv_flow_imp.g_varchar2_table(40941) := '686170652E6D6F7665222C22636F6E6E656374696F6E2E6D6F7665225D2C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E73686170657C7C6E2E636F6E6E656374696F6E2C6F3D6E2E6E6577506172656E747C7C692E';
wwv_flow_imp.g_varchar2_table(40942) := '706172656E742C733D742E6765744F72646572696E6728692C6F293B73262628766F69642030213D3D732E706172656E742626286E2E6E6577506172656E743D732E706172656E74292C6E2E6E6577506172656E74496E6465783D732E696E646578297D';
wwv_flow_imp.g_varchar2_table(40943) := '29297D66756E6374696F6E20656728652C74297B4A702E63616C6C28746869732C65293B766172206E3D5B7B747970653A2262706D6E3A53756250726F63657373222C6F726465723A7B6C6576656C3A367D7D2C7B747970653A2262706D6E3A53657175';
wwv_flow_imp.g_varchar2_table(40944) := '656E6365466C6F77222C6F726465723A7B6C6576656C3A392C636F6E7461696E6572733A5B2262706D6E3A5061727469636970616E74222C2262706D6E3A466C6F77456C656D656E7473436F6E7461696E6572225D7D7D2C7B747970653A2262706D6E3A';
wwv_flow_imp.g_varchar2_table(40945) := '446174614173736F63696174696F6E222C6F726465723A7B6C6576656C3A392C636F6E7461696E6572733A5B2262706D6E3A436F6C6C61626F726174696F6E222C2262706D6E3A466C6F77456C656D656E7473436F6E7461696E6572225D7D7D2C7B7479';
wwv_flow_imp.g_varchar2_table(40946) := '70653A2262706D6E3A54657874416E6E6F746174696F6E222C6F726465723A7B6C6576656C3A397D7D2C7B747970653A2262706D6E3A4D657373616765466C6F77222C6F726465723A7B6C6576656C3A392C636F6E7461696E6572733A5B2262706D6E3A';
wwv_flow_imp.g_varchar2_table(40947) := '436F6C6C61626F726174696F6E225D7D7D2C7B747970653A2262706D6E3A4173736F63696174696F6E222C6F726465723A7B6C6576656C3A362C636F6E7461696E6572733A5B2262706D6E3A5061727469636970616E74222C2262706D6E3A466C6F7745';
wwv_flow_imp.g_varchar2_table(40948) := '6C656D656E7473436F6E7461696E6572222C2262706D6E3A436F6C6C61626F726174696F6E225D7D7D2C7B747970653A2262706D6E3A426F756E646172794576656E74222C6F726465723A7B6C6576656C3A387D7D2C7B747970653A2262706D6E3A4772';
wwv_flow_imp.g_varchar2_table(40949) := '6F7570222C6F726465723A7B6C6576656C3A31302C636F6E7461696E6572733A5B2262706D6E3A436F6C6C61626F726174696F6E222C2262706D6E3A466C6F77456C656D656E7473436F6E7461696E6572225D7D7D2C7B747970653A2262706D6E3A466C';
wwv_flow_imp.g_varchar2_table(40950) := '6F77456C656D656E74222C6F726465723A7B6C6576656C3A357D7D2C7B747970653A2262706D6E3A5061727469636970616E74222C6F726465723A7B6C6576656C3A2D327D7D2C7B747970653A2262706D6E3A4C616E65222C6F726465723A7B6C657665';
wwv_flow_imp.g_varchar2_table(40951) := '6C3A2D317D7D5D3B66756E6374696F6E206F2865297B76617220743D652E6F726465723B696628747C7C28652E6F726465723D743D66756E6374696F6E2865297B696628652E6C6162656C5461726765742972657475726E7B6C6576656C3A31307D3B76';
wwv_flow_imp.g_varchar2_table(40952) := '617220743D28302C692E493629286E2C2866756E6374696F6E2874297B72657475726E28302C792E6973416E792928652C5B742E747970655D297D29293B72657475726E20742626742E6F726465727C7C7B6C6576656C3A317D7D286529292C21742974';
wwv_flow_imp.g_varchar2_table(40953) := '68726F77206E6577204572726F7228606E6F206F7264657220666F72203C247B652E69647D3E60293B72657475726E20747D746869732E6765744F72646572696E673D66756E6374696F6E28652C6E297B696628652E6C6162656C5461726765747C7C28';
wwv_flow_imp.g_varchar2_table(40954) := '302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E22292972657475726E7B706172656E743A742E66696E64526F6F74286E297C7C742E676574526F6F74456C656D656E7428292C696E6465783A2D317D3B76617220733D6F2865';
wwv_flow_imp.g_varchar2_table(40955) := '293B732E636F6E7461696E6572732626286E3D66756E6374696F6E28652C742C6E297B666F722876617220693D743B6926262128302C792E6973416E792928692C6E293B29693D692E706172656E743B6966282169297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(40956) := '7228606E6F20706172656E7420666F72203C247B652E69647D3E20696E203C247B742626742E69647D3E60293B72657475726E20697D28652C6E2C732E636F6E7461696E65727329293B76617220723D6E2E6368696C6472656E2E696E6465784F662865';
wwv_flow_imp.g_varchar2_table(40957) := '292C613D28302C692E534C29286E2E6368696C6472656E2C2866756E6374696F6E2874297B72657475726E212821652E6C6162656C5461726765742626742E6C6162656C546172676574292626732E6C6576656C3C6F2874292E6C6576656C7D29293B72';
wwv_flow_imp.g_varchar2_table(40958) := '657475726E2D31213D3D6126262D31213D3D722626723C61262628612D3D31292C7B696E6465783A612C706172656E743A6E7D7D7D4A702E70726F746F747970652E6765744F72646572696E673D66756E6374696F6E28652C74297B72657475726E206E';
wwv_flow_imp.g_varchar2_table(40959) := '756C6C7D2C52284A702C6572292C65672E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C522865672C4A70293B636F6E73742074673D7B5F5F696E69745F5F3A5B2262706D6E4F72646572696E6750726F7669646572225D2C';
wwv_flow_imp.g_varchar2_table(40960) := '62706D6E4F72646572696E6750726F76696465723A5B2274797065222C65675D7D3B66756E6374696F6E206E6728297B7D6E672E70726F746F747970652E6765743D66756E6374696F6E28297B72657475726E20746869732E5F646174617D2C6E672E70';
wwv_flow_imp.g_varchar2_table(40961) := '726F746F747970652E7365743D66756E6374696F6E2865297B746869732E5F646174613D657D2C6E672E70726F746F747970652E636C6561723D66756E6374696F6E28297B76617220653D746869732E5F646174613B72657475726E2064656C65746520';
wwv_flow_imp.g_varchar2_table(40962) := '746869732E5F646174612C657D2C6E672E70726F746F747970652E6973456D7074793D66756E6374696F6E28297B72657475726E21746869732E5F646174617D3B636F6E73742069673D7B636C6970626F6172643A5B2274797065222C6E675D7D3B7661';
wwv_flow_imp.g_varchar2_table(40963) := '72206F673D2264726F702D6F6B222C73673D2264726F702D6E6F742D6F6B222C72673D226174746163682D6F6B222C61673D226E65772D706172656E74222C6C673D22637265617465223B66756E6374696F6E20636728652C742C6E2C6F2C73297B6675';
wwv_flow_imp.g_varchar2_table(40964) := '6E6374696F6E207228742C6E297B5B72672C6F672C73672C61675D2E666F7245616368282866756E6374696F6E2869297B693D3D3D6E3F652E6164644D61726B657228742C69293A652E72656D6F76654D61726B657228742C69297D29297D66756E6374';
wwv_flow_imp.g_varchar2_table(40965) := '696F6E206128297B76617220653D742E636F6E7465787428293B652626652E7072656669783D3D3D6C672626742E63616E63656C28297D6E2E6F6E285B226372656174652E6D6F7665222C226372656174652E686F766572225D2C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(40966) := '2865297B76617220743D652E636F6E746578742C6E3D742E656C656D656E74732C6F3D652E686F7665722C613D742E736F757263652C6C3D742E68696E74737C7C7B7D3B696628216F2972657475726E20742E63616E457865637574653D21312C766F69';
wwv_flow_imp.g_varchar2_table(40967) := '6428742E7461726765743D6E756C6C293B64672865293B76617220633D7B783A652E782C793A652E797D2C643D742E63616E457865637574653D6F262666756E6374696F6E28652C742C6E2C6F2C72297B69662821742972657475726E21313B653D2830';
wwv_flow_imp.g_varchar2_table(40968) := '2C692E70622928652C2866756E6374696F6E2874297B766172206E3D742E6C6162656C5461726765743B72657475726E2128742E706172656E747C7C526E28742926262D31213D3D652E696E6465784F66286E29297D29293B76617220613D28302C692E';
wwv_flow_imp.g_varchar2_table(40969) := '49362928652C2866756E6374696F6E2865297B72657475726E214F6E2865297D29292C6C3D21312C633D21312C643D21313B68672865292626286C3D732E616C6C6F776564282273686170652E617474616368222C7B706F736974696F6E3A6E2C736861';
wwv_flow_imp.g_varchar2_table(40970) := '70653A612C7461726765743A747D29292C6C7C7C28643D68672865293F732E616C6C6F776564282273686170652E637265617465222C7B706F736974696F6E3A6E2C73686170653A612C736F757263653A6F2C7461726765743A747D293A732E616C6C6F';
wwv_flow_imp.g_varchar2_table(40971) := '7765642822656C656D656E74732E637265617465222C7B656C656D656E74733A652C706F736974696F6E3A6E2C7461726765743A747D29293B76617220683D722E636F6E6E656374696F6E5461726765743B72657475726E20647C7C6C3F286126266F26';
wwv_flow_imp.g_varchar2_table(40972) := '2628633D732E616C6C6F7765642822636F6E6E656374696F6E2E637265617465222C7B736F757263653A683D3D3D6F3F613A6F2C7461726765743A683D3D3D6F3F6F3A612C68696E74733A7B746172676574506172656E743A742C746172676574417474';
wwv_flow_imp.g_varchar2_table(40973) := '6163683A6C7D7D29292C7B6174746163683A6C2C636F6E6E6563743A637D293A286E756C6C3D3D3D647C7C6E756C6C3D3D3D6C2926266E756C6C7D286E2C6F2C632C612C6C293B6F26266E756C6C213D3D64262628742E7461726765743D6F2C64262664';
wwv_flow_imp.g_varchar2_table(40974) := '2E6174746163683F72286F2C7267293A72286F2C643F61673A736729297D29292C6E2E6F6E285B226372656174652E656E64222C226372656174652E6F7574222C226372656174652E636C65616E7570225D2C2866756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(40975) := '743D652E686F7665723B7426267228742C6E756C6C297D29292C6E2E6F6E28226372656174652E656E64222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E736F757263652C733D742E73686170652C723D742E656C';
wwv_flow_imp.g_varchar2_table(40976) := '656D656E74732C613D742E7461726765742C6C3D742E63616E457865637574652C633D6C26266C2E6174746163682C643D6C26266C2E636F6E6E6563742C683D742E68696E74737C7C7B7D3B69662821313D3D3D6C7C7C21612972657475726E21313B64';
wwv_flow_imp.g_varchar2_table(40977) := '672865293B76617220753D7B783A652E782C793A652E797D3B643F733D6F2E617070656E645368617065286E2C732C752C612C7B6174746163683A632C636F6E6E656374696F6E3A21303D3D3D643F7B7D3A642C636F6E6E656374696F6E546172676574';
wwv_flow_imp.g_varchar2_table(40978) := '3A682E636F6E6E656374696F6E5461726765747D293A28723D6F2E637265617465456C656D656E747328722C752C612C28302C692E6B7029287B7D2C682C7B6174746163683A637D29292C733D28302C692E49362928722C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(40979) := '7B72657475726E214F6E2865297D2929292C28302C692E6B702928742C7B656C656D656E74733A722C73686170653A737D292C28302C692E6B702928652C7B656C656D656E74733A722C73686170653A737D297D29292C6E2E6F6E28226372656174652E';
wwv_flow_imp.g_varchar2_table(40980) := '696E6974222C2866756E6374696F6E28297B6E2E6F6E2822656C656D656E74732E6368616E676564222C61292C6E2E6F6E6365285B226372656174652E63616E63656C222C226372656174652E656E64225D2C3265332C2866756E6374696F6E28297B6E';
wwv_flow_imp.g_varchar2_table(40981) := '2E6F66662822656C656D656E74732E6368616E676564222C61297D29297D29292C746869732E73746172743D66756E6374696F6E28652C6E2C6F297B28302C692E637929286E297C7C286E3D5B6E5D293B76617220733D28302C692E493629286E2C2866';
wwv_flow_imp.g_varchar2_table(40982) := '756E6374696F6E2865297B72657475726E214F6E2865297D29293B69662873297B6F3D28302C692E6B7029287B656C656D656E74733A6E2C68696E74733A7B7D2C73686170653A737D2C6F7C7C7B7D292C28302C692E6A4A29286E2C2866756E6374696F';
wwv_flow_imp.g_varchar2_table(40983) := '6E2865297B28302C692E45742928652E78297C7C28652E783D30292C28302C692E45742928652E79297C7C28652E793D30297D29293B76617220723D63742828302C692E706229286E2C2866756E6374696F6E2865297B72657475726E21652E68696464';
wwv_flow_imp.g_varchar2_table(40984) := '656E7D2929293B28302C692E6A4A29286E2C2866756E6374696F6E2865297B4F6E286529262628652E776179706F696E74733D28302C692E546A2928652E776179706F696E74732C2866756E6374696F6E2865297B72657475726E7B783A652E782D722E';
wwv_flow_imp.g_varchar2_table(40985) := '782D722E77696474682F322C793A652E792D722E792D722E6865696768742F327D7D2929292C28302C692E6B702928652C7B783A652E782D722E782D722E77696474682F322C793A652E792D722E792D722E6865696768742F327D297D29292C742E696E';
wwv_flow_imp.g_varchar2_table(40986) := '697428652C6C672C7B637572736F723A226772616262696E67222C6175746F41637469766174653A21302C646174613A7B73686170653A732C656C656D656E74733A6E2C636F6E746578743A6F7D7D297D7D7D66756E6374696F6E2064672865297B7661';
wwv_flow_imp.g_varchar2_table(40987) := '7220743D652E636F6E746578742E637265617465436F6E73747261696E74733B74262628742E6C656674262628652E783D4D6174682E6D617828652E782C742E6C65667429292C742E7269676874262628652E783D4D6174682E6D696E28652E782C742E';
wwv_flow_imp.g_varchar2_table(40988) := '726967687429292C742E746F70262628652E793D4D6174682E6D617828652E792C742E746F7029292C742E626F74746F6D262628652E793D4D6174682E6D696E28652E792C742E626F74746F6D2929297D66756E6374696F6E2068672865297B72657475';
wwv_flow_imp.g_varchar2_table(40989) := '726E20652626313D3D3D652E6C656E6774682626214F6E28655B305D297D66756E6374696F6E20756728652C742C6E2C692C6F297B742E6F6E28226372656174652E6D6F7665222C3735302C2866756E6374696F6E2874297B76617220733D742E686F76';
wwv_flow_imp.g_varchar2_table(40990) := '65722C723D742E636F6E746578742C613D722E656C656D656E74732C6C3D722E6472616747726F75703B6C7C7C286C3D722E6472616747726F75703D66756E6374696F6E2865297B76617220743D6B6528226722293B666528742C6F2E636C732822646A';
wwv_flow_imp.g_varchar2_table(40991) := '732D647261672D67726F7570222C5B226E6F2D6576656E7473225D29293B76617220733D6B6528226722293B72657475726E20652E666F7245616368282866756E6374696F6E2865297B766172206F3B652E68696464656E7C7C28652E776179706F696E';
wwv_flow_imp.g_varchar2_table(40992) := '74733F286F3D6E2E5F637265617465436F6E7461696E65722822636F6E6E656374696F6E222C73292C6E2E64726177436F6E6E656374696F6E286669286F292C6529293A286F3D6E2E5F637265617465436F6E7461696E657228227368617065222C7329';
wwv_flow_imp.g_varchar2_table(40993) := '2C6E2E647261775368617065286669286F292C65292C6269286F2C652E782C652E7929292C692E6164644472616767657228652C742C6F29297D29292C747D286129292C733F286C2E706172656E744E6F64657C7C756528652E6765744163746976654C';
wwv_flow_imp.g_varchar2_table(40994) := '6179657228292C6C292C6269286C2C742E782C742E7929293A5265286C297D29292C742E6F6E28226372656174652E636C65616E7570222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E6472616747726F75703B7426265265';
wwv_flow_imp.g_varchar2_table(40995) := '2874297D29297D63672E24696E6A6563743D5B2263616E766173222C226472616767696E67222C226576656E74427573222C226D6F64656C696E67222C2272756C6573225D2C75672E24696E6A6563743D5B2263616E766173222C226576656E74427573';
wwv_flow_imp.g_varchar2_table(40996) := '222C226772617068696373466163746F7279222C2270726576696577537570706F7274222C227374796C6573225D3B636F6E73742070673D7B5F5F646570656E64735F5F3A5B6A632C65682C4B632C24725D2C5F5F696E69745F5F3A5B22637265617465';
wwv_flow_imp.g_varchar2_table(40997) := '222C2263726561746550726576696577225D2C6372656174653A5B2274797065222C63675D2C637265617465507265766965773A5B2274797065222C75675D7D3B66756E6374696F6E2067672865297B76617220743D746869733B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(40998) := '6E2865297B742E5F6C6173744D6F76654576656E743D657D746869732E5F6C6173744D6F76654576656E743D6E756C6C2C652E6F6E282263616E7661732E696E6974222C2866756E6374696F6E2865297B28742E5F7376673D652E737667292E61646445';
wwv_flow_imp.g_varchar2_table(40999) := '76656E744C697374656E657228226D6F7573656D6F7665222C6E297D29292C652E6F6E282263616E7661732E64657374726F79222C2866756E6374696F6E28297B742E5F6C6173744D6F7573654576656E743D6E756C6C2C742E5F7376672E72656D6F76';
wwv_flow_imp.g_varchar2_table(41000) := '654576656E744C697374656E657228226D6F7573656D6F7665222C6E297D29297D67672E24696E6A6563743D5B226576656E74427573225D2C67672E70726F746F747970652E6765744C6173744D6F76654576656E743D66756E6374696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(41001) := '7475726E20746869732E5F6C6173744D6F76654576656E747C7C2828653D646F63756D656E742E6372656174654576656E7428224D6F7573654576656E742229292E696E69744D6F7573654576656E742626652E696E69744D6F7573654576656E742822';
wwv_flow_imp.g_varchar2_table(41002) := '6D6F7573656D6F7665222C21302C21302C77696E646F772C302C302C302C302C302C21312C21312C21312C21312C302C6E756C6C292C65293B76617220657D3B636F6E7374206D673D7B5F5F696E69745F5F3A5B226D6F757365225D2C6D6F7573653A5B';
wwv_flow_imp.g_varchar2_table(41003) := '2274797065222C67675D7D3B66756E6374696F6E20666728652C742C6E2C6F2C732C722C612C6C297B746869732E5F63616E7661733D652C746869732E5F6372656174653D742C746869732E5F636C6970626F6172643D6E2C746869732E5F656C656D65';
wwv_flow_imp.g_varchar2_table(41004) := '6E74466163746F72793D6F2C746869732E5F6576656E744275733D732C746869732E5F6D6F64656C696E673D722C746869732E5F6D6F7573653D612C746869732E5F72756C65733D6C2C732E6F6E2822636F707950617374652E636F7079456C656D656E';
wwv_flow_imp.g_varchar2_table(41005) := '74222C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D652E656C656D656E742C6F3D652E656C656D656E74733B742E7072696F726974793D312C742E69643D6E2E69643B76617220733D28302C692E493629286F2C';
wwv_flow_imp.g_varchar2_table(41006) := '2866756E6374696F6E2865297B72657475726E20653D3D3D6E2E706172656E747D29293B73262628742E706172656E743D6E2E706172656E742E6964292C66756E6374696F6E2865297B72657475726E2121652E686F73747D286E29262628742E707269';
wwv_flow_imp.g_varchar2_table(41007) := '6F726974793D322C742E686F73743D6E2E686F73742E6964292C4F6E286E29262628742E7072696F726974793D332C742E736F757263653D6E2E736F757263652E69642C742E7461726765743D6E2E7461726765742E69642C742E776179706F696E7473';
wwv_flow_imp.g_varchar2_table(41008) := '3D66756E6374696F6E2865297B72657475726E28302C692E546A2928652E776179706F696E74732C2866756E6374696F6E2865297B72657475726E28653D7667286529292E6F726967696E616C262628652E6F726967696E616C3D766728652E6F726967';
wwv_flow_imp.g_varchar2_table(41009) := '696E616C29292C657D29297D286E29292C526E286E29262628742E7072696F726974793D342C742E6C6162656C5461726765743D6E2E6C6162656C5461726765742E6964292C28302C692E6A4A29285B2278222C2279222C227769647468222C22686569';
wwv_flow_imp.g_varchar2_table(41010) := '676874225D2C2866756E6374696F6E2865297B28302C692E457429286E5B655D29262628745B655D3D6E5B655D297D29292C742E68696464656E3D6E2E68696464656E2C742E636F6C6C61707365643D6E2E636F6C6C61707365647D29292C732E6F6E28';
wwv_flow_imp.g_varchar2_table(41011) := '22636F707950617374652E7061737465456C656D656E7473222C2866756E6374696F6E2865297B76617220743D652E68696E74733B28302C692E6B702928742C7B637265617465456C656D656E74734265686176696F723A21317D297D29297D66756E63';
wwv_flow_imp.g_varchar2_table(41012) := '74696F6E2076672865297B72657475726E28302C692E6B7029287B7D2C65297D66756E6374696F6E20626728652C74297B766172206E3D742E696E6465784F662865293B72657475726E2D313D3D3D6E3F743A742E73706C696365286E2C31297D66672E';
wwv_flow_imp.g_varchar2_table(41013) := '24696E6A6563743D5B2263616E766173222C22637265617465222C22636C6970626F617264222C22656C656D656E74466163746F7279222C226576656E74427573222C226D6F64656C696E67222C226D6F757365222C2272756C6573225D2C66672E7072';
wwv_flow_imp.g_varchar2_table(41014) := '6F746F747970652E636F70793D66756E6374696F6E2865297B76617220742C6E3B72657475726E28302C692E6379292865297C7C28653D653F5B655D3A5B5D292C6E3D21313D3D3D28743D746869732E5F6576656E744275732E666972652822636F7079';
wwv_flow_imp.g_varchar2_table(41015) := '50617374652E63616E436F7079456C656D656E7473222C7B656C656D656E74733A657D29293F7B7D3A746869732E637265617465547265652828302C692E6379292874293F743A65292C746869732E5F636C6970626F6172642E736574286E292C746869';
wwv_flow_imp.g_varchar2_table(41016) := '732E5F6576656E744275732E666972652822636F707950617374652E656C656D656E7473436F70696564222C7B656C656D656E74733A652C747265653A6E7D292C6E7D2C66672E70726F746F747970652E70617374653D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(41017) := '617220743D746869732E5F636C6970626F6172642E67657428293B69662821746869732E5F636C6970626F6172642E6973456D7074792829297B766172206E3D652626652E68696E74737C7C7B7D3B746869732E5F6576656E744275732E666972652822';
wwv_flow_imp.g_varchar2_table(41018) := '636F707950617374652E7061737465456C656D656E7473222C7B68696E74733A6E7D293B76617220693D746869732E5F637265617465456C656D656E74732874293B696628652626652E656C656D656E742626652E706F696E742972657475726E207468';
wwv_flow_imp.g_varchar2_table(41019) := '69732E5F706173746528692C652E656C656D656E742C652E706F696E742C6E293B746869732E5F6372656174652E737461727428746869732E5F6D6F7573652E6765744C6173744D6F76654576656E7428292C692C7B68696E74733A6E7C7C7B7D7D297D';
wwv_flow_imp.g_varchar2_table(41020) := '7D2C66672E70726F746F747970652E5F70617374653D66756E6374696F6E28652C742C6E2C6F297B28302C692E6A4A2928652C2866756E6374696F6E2865297B28302C692E45742928652E78297C7C28652E783D30292C28302C692E45742928652E7929';
wwv_flow_imp.g_varchar2_table(41021) := '7C7C28652E793D30297D29293B76617220733D63742865293B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B4F6E286529262628652E776179706F696E74733D28302C692E546A2928652E776179706F696E74732C2866756E';
wwv_flow_imp.g_varchar2_table(41022) := '6374696F6E2865297B72657475726E7B783A652E782D732E782D732E77696474682F322C793A652E792D732E792D732E6865696768742F327D7D2929292C28302C692E6B702928652C7B783A652E782D732E782D732E77696474682F322C793A652E792D';
wwv_flow_imp.g_varchar2_table(41023) := '732E792D732E6865696768742F327D297D29292C746869732E5F6D6F64656C696E672E637265617465456C656D656E747328652C6E2C742C28302C692E6B7029287B7D2C6F29297D2C66672E70726F746F747970652E5F637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(41024) := '733D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E5F6576656E744275732C6F3D7B7D2C733D5B5D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E28652C72297B723D7061727365496E7428722C313029';
wwv_flow_imp.g_varchar2_table(41025) := '2C653D28302C692E556C2928652C227072696F7269747922292C28302C692E6A4A2928652C2866756E6374696F6E2865297B76617220722C613D28302C692E6B7029287B7D2C28302C692E634A2928652C5B227072696F72697479225D29293B72657475';
wwv_flow_imp.g_varchar2_table(41026) := '726E206F5B652E706172656E745D3F612E706172656E743D6F5B652E706172656E745D3A64656C65746520612E706172656E742C6E2E666972652822636F707950617374652E7061737465456C656D656E74222C7B63616368653A6F2C64657363726970';
wwv_flow_imp.g_varchar2_table(41027) := '746F723A617D292C4F6E2861293F28612E736F757263653D6F5B652E736F757263655D2C612E7461726765743D6F5B652E7461726765745D2C723D6F5B652E69645D3D742E637265617465436F6E6E656374696F6E2861292C766F696420732E70757368';
wwv_flow_imp.g_varchar2_table(41028) := '287229293A526E2861293F28612E6C6162656C5461726765743D6F5B612E6C6162656C5461726765745D2C723D6F5B652E69645D3D742E6372656174654C6162656C2861292C766F696420732E70757368287229293A28612E686F7374262628612E686F';
wwv_flow_imp.g_varchar2_table(41029) := '73743D6F5B612E686F73745D292C723D6F5B652E69645D3D742E63726561746553686170652861292C766F696420732E70757368287229297D29297D29292C737D2C66672E70726F746F747970652E637265617465436F6E6E656374696F6E3D66756E63';
wwv_flow_imp.g_varchar2_table(41030) := '74696F6E2865297B72657475726E20746869732E5F656C656D656E74466163746F72792E637265617465436F6E6E656374696F6E2828302C692E634A2928652C5B226964225D29297D2C66672E70726F746F747970652E6372656174654C6162656C3D66';
wwv_flow_imp.g_varchar2_table(41031) := '756E6374696F6E2865297B72657475726E20746869732E5F656C656D656E74466163746F72792E6372656174654C6162656C2828302C692E634A2928652C5B226964225D29297D2C66672E70726F746F747970652E63726561746553686170653D66756E';
wwv_flow_imp.g_varchar2_table(41032) := '6374696F6E2865297B72657475726E20746869732E5F656C656D656E74466163746F72792E63726561746553686170652828302C692E634A2928652C5B226964225D29297D2C66672E70726F746F747970652E68617352656C6174696F6E733D66756E63';
wwv_flow_imp.g_varchar2_table(41033) := '74696F6E28652C74297B766172206E2C6F3B72657475726E21284F6E2865292626286E3D28302C692E49362928742C28302C692E674829287B69643A652E736F757263652E69647D29292C6F3D28302C692E49362928742C28302C692E674829287B6964';
wwv_flow_imp.g_varchar2_table(41034) := '3A652E7461726765742E69647D29292C216E7C7C216F297C7C526E28652926262128302C692E49362928742C28302C692E674829287B69643A652E6C6162656C5461726765742E69647D2929297D2C66672E70726F746F747970652E6372656174655472';
wwv_flow_imp.g_varchar2_table(41035) := '65653D66756E6374696F6E2865297B76617220743D746869732E5F72756C65732C6E3D746869732C6F3D7B7D2C733D5B5D3B66756E6374696F6E207228652C74297B766172206E3D28302C692E49362928732C2866756E6374696F6E2874297B72657475';
wwv_flow_imp.g_varchar2_table(41036) := '726E20653D3D3D742E656C656D656E747D29293B6E3F6E2E64657074683C74262628733D66756E6374696F6E28652C74297B766172206E3D742E696E6465784F662865293B72657475726E2D31213D3D6E2626742E73706C696365286E2C31292C747D28';
wwv_flow_imp.g_varchar2_table(41037) := '6E2C73292C732E70757368287B656C656D656E743A6E2E656C656D656E742C64657074683A747D29293A732E70757368287B656C656D656E743A652C64657074683A747D297D72657475726E206174286F742865292C2866756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(41038) := '6F297B69662821526E286529297B28302C692E6A4A2928652E6C6162656C732C2866756E6374696F6E2865297B7228652C6F297D29292C28302C692E6A4A29285B652E6174746163686572732C652E696E636F6D696E672C652E6F7574676F696E675D2C';
wwv_flow_imp.g_varchar2_table(41039) := '2866756E6374696F6E2865297B652626652E6C656E677468262628302C692E6A4A2928652C2866756E6374696F6E2865297B28302C692E6A4A2928652E6C6162656C732C2866756E6374696F6E2865297B7228652C6F297D29292C7228652C6F297D2929';
wwv_flow_imp.g_varchar2_table(41040) := '7D29292C7228652C6F293B76617220733D5B5D3B72657475726E20652E6368696C6472656E262628733D652E6368696C6472656E2E736C6963652829292C6E2E5F6576656E744275732E666972652822636F707950617374652E63726561746554726565';
wwv_flow_imp.g_varchar2_table(41041) := '222C7B656C656D656E743A652C6368696C6472656E3A737D292C737D7D29292C653D28302C692E546A2928732C2866756E6374696F6E2865297B72657475726E20652E656C656D656E747D29292C733D28302C692E546A2928732C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(41042) := '2874297B72657475726E20742E64657363726970746F723D7B7D2C6E2E5F6576656E744275732E666972652822636F707950617374652E636F7079456C656D656E74222C7B64657363726970746F723A742E64657363726970746F722C656C656D656E74';
wwv_flow_imp.g_varchar2_table(41043) := '3A742E656C656D656E742C656C656D656E74733A657D292C747D29292C733D28302C692E556C2928732C2866756E6374696F6E2865297B72657475726E20652E64657363726970746F722E7072696F726974797D29292C653D28302C692E546A2928732C';
wwv_flow_imp.g_varchar2_table(41044) := '2866756E6374696F6E2865297B72657475726E20652E656C656D656E747D29292C28302C692E6A4A2928732C2866756E6374696F6E2869297B76617220733D692E64657074683B6E2E68617352656C6174696F6E7328692E656C656D656E742C65292626';
wwv_flow_imp.g_varchar2_table(41045) := '66756E6374696F6E28652C6E297B72657475726E20742E616C6C6F7765642822656C656D656E742E636F7079222C7B656C656D656E743A652C656C656D656E74733A6E7D297D28692E656C656D656E742C65293F286F5B735D7C7C286F5B735D3D5B5D29';
wwv_flow_imp.g_varchar2_table(41046) := '2C6F5B735D2E7075736828692E64657363726970746F7229293A626728692E656C656D656E742C65297D29292C6F7D3B636F6E7374205F673D7B5F5F646570656E64735F5F3A5B69672C70672C6D672C4B635D2C5F5F696E69745F5F3A5B22636F707950';
wwv_flow_imp.g_varchar2_table(41047) := '61737465225D2C636F707950617374653A5B2274797065222C66675D7D3B66756E6374696F6E20796728652C742C6E297B28302C692E637929286E297C7C286E3D5B6E5D292C28302C692E6A4A29286E2C2866756E6374696F6E286E297B28302C692E62';
wwv_flow_imp.g_varchar2_table(41048) := '302928655B6E5D297C7C28745B6E5D3D655B6E5D297D29297D66756E6374696F6E20776728652C742C6E297B66756E6374696F6E206F28742C69297B766172206F3D652E63726561746528742E2474797065293B72657475726E206E2E636F7079456C65';
wwv_flow_imp.g_varchar2_table(41049) := '6D656E7428742C6F2C6E756C6C2C69297D742E6F6E2822636F707950617374652E636F7079456C656D656E74222C3735302C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D652E656C656D656E742C693D28302C79';
wwv_flow_imp.g_varchar2_table(41050) := '2E676574427573696E6573734F626A65637429286E293B696628526E286E292972657475726E20743B76617220733D742E627573696E6573734F626A6563743D6F28692C2130292C723D742E64693D6F2828302C792E676574446929286E292C2130293B';
wwv_flow_imp.g_varchar2_table(41051) := '722E62706D6E456C656D656E743D732C796728732C742C226E616D6522292C796728722C742C226973457870616E64656422292C692E64656661756C74262628742E64656661756C743D692E64656661756C742E6964297D29293B76617220733D222D62';
wwv_flow_imp.g_varchar2_table(41052) := '706D6E2D6A732D72656673223B742E6F6E2822636F707950617374652E7061737465456C656D656E74222C2866756E6374696F6E2865297B76617220743D652E63616368652C6E3D652E64657363726970746F722C693D6E2E627573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(41053) := '6563742C733D6E2E64693B696628526E286E292972657475726E206E2E627573696E6573734F626A6563743D28302C792E676574427573696E6573734F626A6563742928745B6E2E6C6162656C5461726765745D292C766F6964286E2E64693D28302C79';
wwv_flow_imp.g_varchar2_table(41054) := '2E67657444692928745B6E2E6C6162656C5461726765745D29293B693D6E2E627573696E6573734F626A6563743D6F2869292C28733D6E2E64693D6F287329292E62706D6E456C656D656E743D692C7967286E2C692C5B226973457870616E646564222C';
wwv_flow_imp.g_varchar2_table(41055) := '226E616D65225D292C6E2E747970653D692E24747970657D29292C742E6F6E2822636F707950617374652E636F7079456C656D656E74222C3735302C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D652E656C656D';
wwv_flow_imp.g_varchar2_table(41056) := '656E743B69662828302C792E697329286E2C2262706D6E3A5061727469636970616E742229297B76617220693D28302C792E676574427573696E6573734F626A65637429286E293B692E70726F63657373526566262628742E70726F636573735265663D';
wwv_flow_imp.g_varchar2_table(41057) := '6F28692E70726F636573735265662C213029297D7D29292C742E6F6E2822636F707950617374652E7061737465456C656D656E74222C2866756E6374696F6E2865297B76617220743D652E64657363726970746F722C6E3D742E70726F63657373526566';
wwv_flow_imp.g_varchar2_table(41058) := '3B6E262628742E70726F636573735265663D6F286E29297D29292C742E6F6E2822636F707950617374652E7061737465456C656D656E74222C3735302C2866756E6374696F6E2865297B76617220743D652E63616368653B2166756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(41059) := '74297B655B735D3D747D28742C66756E6374696F6E28652C742C6E297B766172206F3D28302C792E676574427573696E6573734F626A656374292865293B72657475726E20652E64656661756C742626286E5B652E64656661756C745D3D7B656C656D65';
wwv_flow_imp.g_varchar2_table(41060) := '6E743A6F2C70726F70657274793A2264656661756C74227D292C652E686F737426262828302C792E676574427573696E6573734F626A656374292865292E6174746163686564546F5265663D28302C792E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(41061) := '745B652E686F73745D29292C28302C692E634A29286E2C28302C692E545329286E2C2866756E6374696F6E28742C6E2C69297B76617220733D6E2E656C656D656E742C723D6E2E70726F70657274793B72657475726E20693D3D3D652E6964262628732E';
wwv_flow_imp.g_varchar2_table(41062) := '73657428722C6F292C742E7075736828652E696429292C747D292C5B5D29297D28652E64657363726970746F722C742C66756E6374696F6E2865297B72657475726E20655B735D3D655B735D7C7C7B7D7D28742929297D29297D77672E24696E6A656374';
wwv_flow_imp.g_varchar2_table(41063) := '3D5B2262706D6E466163746F7279222C226576656E74427573222C226D6F64646C65436F7079225D3B7661722043673D5B22617274696661637473222C2264617461496E7075744173736F63696174696F6E73222C22646174614F75747075744173736F';
wwv_flow_imp.g_varchar2_table(41064) := '63696174696F6E73222C2264656661756C74222C22666C6F77456C656D656E7473222C226C616E6573222C22696E636F6D696E67222C226F7574676F696E67222C2263617465676F727956616C7565225D3B66756E6374696F6E20536728652C742C6E29';
wwv_flow_imp.g_varchar2_table(41065) := '7B746869732E5F62706D6E466163746F72793D742C746869732E5F6576656E744275733D652C746869732E5F6D6F64646C653D6E2C652E6F6E28226D6F64646C65436F70792E63616E436F707950726F70657274696573222C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(41066) := '297B76617220743D652E70726F70657274794E616D65733B696628742626742E6C656E6774682972657475726E28302C692E556C2928742C2866756E6374696F6E2865297B72657475726E22657874656E73696F6E456C656D656E7473223D3D3D657D29';
wwv_flow_imp.g_varchar2_table(41067) := '297D29292C652E6F6E28226D6F64646C65436F70792E63616E436F707950726F7065727479222C2866756E6374696F6E2865297B76617220743D652E706172656E742C6E3D28302C692E4776292874292626742E2464657363726970746F722C6F3D652E';
wwv_flow_imp.g_varchar2_table(41068) := '70726F70657274794E616D653B72657475726E28216F7C7C2D313D3D3D43672E696E6465784F66286F2929262621286F26266E26262128302C692E493629286E2E70726F706572746965732C28302C692E674829287B6E616D653A6F7D2929292626766F';
wwv_flow_imp.g_varchar2_table(41069) := '696420307D29292C652E6F6E28226D6F64646C65436F70792E63616E536574436F7069656450726F7065727479222C2866756E6374696F6E2865297B76617220742C6E3D652E70726F70657274793B69662828743D6E29262628302C692E546E2928742E';
wwv_flow_imp.g_varchar2_table(41070) := '24696E7374616E63654F66292626742E24696E7374616E63654F66282262706D6E3A457874656E73696F6E456C656D656E74732229262628216E2E76616C7565737C7C216E2E76616C7565732E6C656E677468292972657475726E21317D29297D66756E';
wwv_flow_imp.g_varchar2_table(41071) := '6374696F6E20786728652C74297B72657475726E28302C692E54532928652E70726F706572746965732C2866756E6374696F6E28652C6E297B72657475726E207426266E2E64656661756C743F653A652E636F6E636174286E2E6E616D65297D292C5B5D';
wwv_flow_imp.g_varchar2_table(41072) := '297D53672E24696E6A6563743D5B226576656E74427573222C2262706D6E466163746F7279222C226D6F64646C65225D2C53672E70726F746F747970652E636F7079456C656D656E743D66756E6374696F6E28652C742C6E2C6F3D2131297B7661722073';
wwv_flow_imp.g_varchar2_table(41073) := '3D746869733B6E26262128302C692E637929286E292626286E3D5B6E5D292C6E3D6E7C7C786728652E2464657363726970746F72293B76617220723D746869732E5F6576656E744275732E6669726528226D6F64646C65436F70792E63616E436F707950';
wwv_flow_imp.g_varchar2_table(41074) := '726F70657274696573222C7B70726F70657274794E616D65733A6E2C736F75726365456C656D656E743A652C746172676574456C656D656E743A742C636C6F6E653A6F7D293B72657475726E21313D3D3D727C7C2828302C692E6379292872292626286E';
wwv_flow_imp.g_varchar2_table(41075) := '3D72292C28302C692E6A4A29286E2C2866756E6374696F6E286E297B76617220723B28302C692E7A792928652C6E29262628723D652E676574286E29293B76617220613D732E636F707950726F706572747928722C742C6E2C6F293B28302C692E4F3929';
wwv_flow_imp.g_varchar2_table(41076) := '28612926262131213D3D732E5F6576656E744275732E6669726528226D6F64646C65436F70792E63616E536574436F7069656450726F7065727479222C7B706172656E743A742C70726F70657274793A612C70726F70657274794E616D653A6E7D292626';
wwv_flow_imp.g_varchar2_table(41077) := '742E736574286E2C61297D2929292C747D2C53672E70726F746F747970652E636F707950726F70657274793D66756E6374696F6E28652C742C6E2C6F3D2131297B76617220733D746869732C723D746869732E5F6576656E744275732E6669726528226D';
wwv_flow_imp.g_varchar2_table(41078) := '6F64646C65436F70792E63616E436F707950726F7065727479222C7B706172656E743A742C70726F70657274793A652C70726F70657274794E616D653A6E2C636C6F6E653A6F7D293B6966282131213D3D72297B696628722972657475726E28302C692E';
wwv_flow_imp.g_varchar2_table(41079) := '4776292872292626722E2474797065262621722E24706172656E74262628722E24706172656E743D74292C723B76617220613D746869732E5F6D6F64646C652E67657450726F706572747944657363726970746F7228742C6E293B69662821612E697352';
wwv_flow_imp.g_varchar2_table(41080) := '65666572656E6365297B696628612E697349642972657475726E20652626746869732E5F636F7079496428652C742C6F293B69662828302C692E6379292865292972657475726E28302C692E54532928652C2866756E6374696F6E28652C69297B726574';
wwv_flow_imp.g_varchar2_table(41081) := '75726E28723D732E636F707950726F706572747928692C742C6E2C6F29293F652E636F6E6361742872293A657D292C5B5D293B69662828302C692E4776292865292626652E2474797065297B696628746869732E5F6D6F64646C652E676574456C656D65';
wwv_flow_imp.g_varchar2_table(41082) := '6E7444657363726970746F722865292E697347656E657269632972657475726E3B72657475726E28723D732E5F62706D6E466163746F72792E63726561746528652E247479706529292E24706172656E743D742C723D732E636F7079456C656D656E7428';
wwv_flow_imp.g_varchar2_table(41083) := '652C722C6E756C6C2C6F297D72657475726E20657D7D7D2C53672E70726F746F747970652E5F636F707949643D66756E6374696F6E28652C742C6E3D2131297B72657475726E206E3F653A746869732E5F6D6F64646C652E6964732E61737369676E6564';
wwv_flow_imp.g_varchar2_table(41084) := '2865293F766F696420303A28746869732E5F6D6F64646C652E6964732E636C61696D28652C74292C65297D3B636F6E7374206B673D7B5F5F646570656E64735F5F3A5B5F675D2C5F5F696E69745F5F3A5B2262706D6E436F70795061737465222C226D6F';
wwv_flow_imp.g_varchar2_table(41085) := '64646C65436F7079225D2C62706D6E436F707950617374653A5B2274797065222C77675D2C6D6F64646C65436F70793A5B2274797065222C53675D7D3B7661722045673D4D6174682E726F756E643B66756E6374696F6E204C6728652C74297B74686973';
wwv_flow_imp.g_varchar2_table(41086) := '2E5F6D6F64656C696E673D652C746869732E5F6576656E744275733D747D66756E6374696F6E20446728652C74297B742E6F6E28227265706C6163652E656E64222C3530302C2866756E6374696F6E2874297B636F6E73747B6E6577456C656D656E743A';
wwv_flow_imp.g_varchar2_table(41087) := '6E2C68696E74733A693D7B7D7D3D743B2131213D3D692E73656C6563742626652E73656C656374286E297D29297D4C672E24696E6A6563743D5B226D6F64656C696E67222C226576656E74427573225D2C4C672E70726F746F747970652E7265706C6163';
wwv_flow_imp.g_varchar2_table(41088) := '65456C656D656E743D66756E6374696F6E28652C742C6E297B696628652E776179706F696E74732972657475726E206E756C6C3B766172206F3D746869732E5F6D6F64656C696E672C733D746869732E5F6576656E744275733B732E6669726528227265';
wwv_flow_imp.g_varchar2_table(41089) := '706C6163652E7374617274222C7B656C656D656E743A652C61747472733A742C68696E74733A6E7D293B76617220723D742E77696474687C7C652E77696474682C613D742E6865696768747C7C652E6865696768742C6C3D742E787C7C652E782C633D74';
wwv_flow_imp.g_varchar2_table(41090) := '2E797C7C652E792C643D4567286C2B722F32292C683D456728632B612F32292C753D6F2E7265706C616365536861706528652C28302C692E6B7029287B7D2C742C7B783A642C793A682C77696474683A722C6865696768743A617D292C6E293B72657475';
wwv_flow_imp.g_varchar2_table(41091) := '726E20732E6669726528227265706C6163652E656E64222C7B656C656D656E743A652C6E6577456C656D656E743A752C68696E74733A6E7D292C757D2C44672E24696E6A6563743D5B2273656C656374696F6E222C226576656E74427573225D3B636F6E';
wwv_flow_imp.g_varchar2_table(41092) := '73742054673D7B5F5F696E69745F5F3A5B227265706C616365222C227265706C61636553656C656374696F6E4265686176696F72225D2C7265706C61636553656C656374696F6E4265686176696F723A5B2274797065222C44675D2C7265706C6163653A';
wwv_flow_imp.g_varchar2_table(41093) := '5B2274797065222C4C675D7D3B7661722049673D5B2263616E63656C4163746976697479222C22696E7374616E7469617465222C226576656E744761746577617954797065222C2274726967676572656442794576656E74222C226973496E7465727275';
wwv_flow_imp.g_varchar2_table(41094) := '7074696E67225D3B66756E6374696F6E204D6728652C742C6E2C6F2C732C72297B746869732E7265706C616365456C656D656E743D66756E6374696F6E28612C6C2C63297B633D637C7C7B7D3B76617220643D6C2E747970652C683D612E627573696E65';
wwv_flow_imp.g_varchar2_table(41095) := '73734F626A6563743B696628416728682926262262706D6E3A53756250726F63657373223D3D3D64262666756E6374696F6E28652C74297B766172206E3D65262628302C692E7A792928652C22636F6C6C617073656422293F652E636F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(41096) := '3A2128302C72732E4176292865293B72657475726E206E213D3D287426262828302C692E7A792928742C22636F6C6C617073656422297C7C28302C692E7A792928742C226973457870616E6465642229293F28302C692E7A792928742C22636F6C6C6170';
wwv_flow_imp.g_varchar2_table(41097) := '73656422293F742E636F6C6C61707365643A21742E6973457870616E6465643A6E297D28612C6C292972657475726E206F2E746F67676C65436F6C6C617073652861292C613B76617220753D652E6372656174652864292C703D7B747970653A642C6275';
wwv_flow_imp.g_varchar2_table(41098) := '73696E6573734F626A6563743A752C64693A7B7D7D3B2262706D6E3A4578636C757369766547617465776179223D3D3D64262628702E64692E69734D61726B657256697369626C653D2130292C66756E6374696F6E28652C742C6E297B28302C692E6379';
wwv_flow_imp.g_varchar2_table(41099) := '29286E297C7C286E3D5B6E5D292C28302C692E6A4A29286E2C2866756E6374696F6E286E297B28302C692E62302928655B6E5D297C7C28745B6E5D3D655B6E5D297D29297D28612E64692C702E64692C5B2266696C6C222C227374726F6B65222C226261';
wwv_flow_imp.g_varchar2_table(41100) := '636B67726F756E642D636F6C6F72222C22626F726465722D636F6C6F72222C22636F6C6F72225D293B76617220673D66756E6374696F6E28652C74297B72657475726E20652E66696C746572282866756E6374696F6E2865297B72657475726E20742E69';
wwv_flow_imp.g_varchar2_table(41101) := '6E636C756465732865297D29297D28786728682E2464657363726970746F72292C786728752E2464657363726970746F722C213029293B28302C692E6B702928752C28302C692E557029286C2C496729293B766172206D3D28302C692E70622928672C28';
wwv_flow_imp.g_varchar2_table(41102) := '66756E6374696F6E2865297B72657475726E226576656E74446566696E6974696F6E73223D3D3D653F4E6728612C6C2E6576656E74446566696E6974696F6E54797065293A226C6F6F70436861726163746572697374696373223D3D3D653F2128302C72';
wwv_flow_imp.g_varchar2_table(41103) := '732E5131292875293A212828302C692E7A792928752C65297C7C2270726F63657373526566223D3D3D65262621313D3D3D6C2E6973457870616E6465647C7C2274726967676572656442794576656E74223D3D3D657C7C226973466F72436F6D70656E73';
wwv_flow_imp.g_varchar2_table(41104) := '6174696F6E223D3D3D65262628302C72732E513129287529297D29293B696628753D6E2E636F7079456C656D656E7428682C752C6D292C6C2E6576656E74446566696E6974696F6E547970652626284E6728752C6C2E6576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(41105) := '6E54797065297C7C28702E6576656E74446566696E6974696F6E547970653D6C2E6576656E74446566696E6974696F6E547970652C702E6576656E74446566696E6974696F6E41747472733D6C2E6576656E74446566696E6974696F6E41747472732929';
wwv_flow_imp.g_varchar2_table(41106) := '2C28302C792E69732928682C2262706D6E3A41637469766974792229297B696628416728682929702E6973457870616E6465643D28302C72732E4176292861293B656C7365206966286C262628302C692E7A7929286C2C226973457870616E6465642229';
wwv_flow_imp.g_varchar2_table(41107) := '297B702E6973457870616E6465643D6C2E6973457870616E6465643B76617220663D742E67657444656661756C7453697A6528752C7B6973457870616E6465643A702E6973457870616E6465647D293B702E77696474683D662E77696474682C702E6865';
wwv_flow_imp.g_varchar2_table(41108) := '696768743D662E6865696768742C702E783D612E782D28702E77696474682D612E7769647468292F322C702E793D612E792D28702E6865696768742D612E686569676874292F327D28302C72732E41762928612926262128302C792E69732928682C2262';
wwv_flow_imp.g_varchar2_table(41109) := '706D6E3A5461736B22292626702E6973457870616E646564262628702E77696474683D612E77696474682C702E6865696768743D612E686569676874297D69662841672868292626214167287529262628632E6D6F76654368696C6472656E3D2131292C';
wwv_flow_imp.g_varchar2_table(41110) := '28302C792E69732928682C2262706D6E3A5061727469636970616E742229297B21303D3D3D6C2E6973457870616E6465643F752E70726F636573735265663D652E637265617465282262706D6E3A50726F6365737322293A632E6D6F76654368696C6472';
wwv_flow_imp.g_varchar2_table(41111) := '656E3D21313B76617220763D28302C72732E2462292861293B28302C792E6765744469292861292E6973486F72697A6F6E74616C7C7C2828302C792E6765744469292870292E6973486F72697A6F6E74616C3D76292C702E77696474683D763F612E7769';
wwv_flow_imp.g_varchar2_table(41112) := '6474683A742E67657444656661756C7453697A652870292E77696474682C702E6865696768743D763F742E67657444656661756C7453697A652870292E6865696768743A612E6865696768747D72657475726E20722E616C6C6F77656428227368617065';
wwv_flow_imp.g_varchar2_table(41113) := '2E726573697A65222C7B73686170653A757D297C7C28702E6865696768743D742E67657444656661756C7453697A652870292E6865696768742C702E77696474683D742E67657444656661756C7453697A652870292E7769647468292C752E6E616D653D';
wwv_flow_imp.g_varchar2_table(41114) := '682E6E616D652C28302C792E6973416E792928682C5B2262706D6E3A4578636C757369766547617465776179222C2262706D6E3A496E636C757369766547617465776179222C2262706D6E3A4163746976697479225D29262628302C792E6973416E7929';
wwv_flow_imp.g_varchar2_table(41115) := '28752C5B2262706D6E3A4578636C757369766547617465776179222C2262706D6E3A496E636C757369766547617465776179222C2262706D6E3A4163746976697479225D29262628752E64656661756C743D682E64656661756C74292C6C2E686F737426';
wwv_flow_imp.g_varchar2_table(41116) := '262128302C792E69732928682C2262706D6E3A426F756E646172794576656E742229262628302C792E69732928752C2262706D6E3A426F756E646172794576656E742229262628702E686F73743D6C2E686F7374292C2262706D6E3A4461746153746F72';
wwv_flow_imp.g_varchar2_table(41117) := '655265666572656E636522213D3D702E7479706526262262706D6E3A446174614F626A6563745265666572656E636522213D3D702E747970657C7C28702E783D612E782B28612E77696474682D702E7769647468292F32292C732E7265706C616365456C';
wwv_flow_imp.g_varchar2_table(41118) := '656D656E7428612C702C7B2E2E2E632C746172676574456C656D656E743A6C7D297D7D66756E6374696F6E2041672865297B72657475726E28302C792E69732928652C2262706D6E3A53756250726F6365737322297D66756E6374696F6E204E6728652C';
wwv_flow_imp.g_varchar2_table(41119) := '74297B766172206E3D28302C792E676574427573696E6573734F626A656374292865293B72657475726E207426266E2E67657428226576656E74446566696E6974696F6E7322292E736F6D65282866756E6374696F6E2865297B72657475726E28302C79';
wwv_flow_imp.g_varchar2_table(41120) := '2E69732928652C74297D29297D4D672E24696E6A6563743D5B2262706D6E466163746F7279222C22656C656D656E74466163746F7279222C226D6F64646C65436F7079222C226D6F64656C696E67222C227265706C616365222C2272756C6573225D3B63';
wwv_flow_imp.g_varchar2_table(41121) := '6F6E73742050673D7B5F5F646570656E64735F5F3A5B6B672C54672C24725D2C62706D6E5265706C6163653A5B2274797065222C4D675D7D3B66756E6374696F6E204F672865297B746869732E5F6576656E744275733D652C746869732E5F746F6F6C73';
wwv_flow_imp.g_varchar2_table(41122) := '3D5B5D2C746869732E5F6163746976653D6E756C6C7D4F672E24696E6A6563743D5B226576656E74427573225D2C4F672E70726F746F747970652E7265676973746572546F6F6C3D66756E6374696F6E28652C74297B766172206E3D746869732E5F746F';
wwv_flow_imp.g_varchar2_table(41123) := '6F6C733B6966282174297468726F77206E6577204572726F7228274120746F6F6C2068617320746F206265207265676973746572656420776974682069745C277320226576656E74732227293B6E2E707573682865292C746869732E62696E644576656E';
wwv_flow_imp.g_varchar2_table(41124) := '747328652C74297D2C4F672E70726F746F747970652E69734163746976653D66756E6374696F6E2865297B72657475726E20652626746869732E5F6163746976653D3D3D657D2C4F672E70726F746F747970652E6C656E6774683D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41125) := '65297B72657475726E20746869732E5F746F6F6C732E6C656E6774687D2C4F672E70726F746F747970652E7365744163746976653D66756E6374696F6E2865297B76617220743D746869732E5F6576656E744275733B746869732E5F616374697665213D';
wwv_flow_imp.g_varchar2_table(41126) := '3D65262628746869732E5F6163746976653D652C742E666972652822746F6F6C2D6D616E616765722E757064617465222C7B746F6F6C3A657D29297D2C4F672E70726F746F747970652E62696E644576656E74733D66756E6374696F6E28652C74297B76';
wwv_flow_imp.g_varchar2_table(41127) := '6172206E3D746869732E5F6576656E744275732C6F3D5B5D3B6E2E6F6E28742E746F6F6C2B222E696E6974222C2866756E6374696F6E2874297B742E636F6E746578742E726561637469766174657C7C21746869732E69734163746976652865293F7468';
wwv_flow_imp.g_varchar2_table(41128) := '69732E7365744163746976652865293A746869732E736574416374697665286E756C6C297D292C74686973292C28302C692E6A4A2928742C2866756E6374696F6E2865297B6F2E7075736828652B222E656E64656422292C6F2E7075736828652B222E63';
wwv_flow_imp.g_varchar2_table(41129) := '616E63656C656422297D29292C6E2E6F6E286F2C3235302C2866756E6374696F6E2865297B746869732E5F61637469766526262866756E6374696F6E2865297B76617220743D652E6F726967696E616C4576656E742626652E6F726967696E616C457665';
wwv_flow_imp.g_varchar2_table(41130) := '6E742E7461726765743B72657475726E20742626447428742C272E67726F75705B646174612D67726F75703D22746F6F6C73225D27297D2865297C7C746869732E736574416374697665286E756C6C29297D292C74686973297D3B636F6E73742052673D';
wwv_flow_imp.g_varchar2_table(41131) := '7B5F5F646570656E64735F5F3A5B6A635D2C5F5F696E69745F5F3A5B22746F6F6C4D616E61676572225D2C746F6F6C4D616E616765723A5B2274797065222C4F675D7D3B66756E6374696F6E20466728652C74297B72657475726E2D31213D3D652E696E';
wwv_flow_imp.g_varchar2_table(41132) := '6465784F662874297D7661722042673D4D6174682E6162732C56673D4D6174682E726F756E642C7A673D7B783A227769647468222C793A22686569676874227D2C48673D2263726F737368616972222C57673D7B6E3A22746F70222C773A226C65667422';
wwv_flow_imp.g_varchar2_table(41133) := '2C733A22626F74746F6D222C653A227269676874227D2C6A673D313530302C71673D7B6E3A2273222C773A2265222C733A226E222C653A2277227D3B66756E6374696F6E20246728652C742C6E2C692C6F2C732C72297B746869732E5F63616E7661733D';
wwv_flow_imp.g_varchar2_table(41134) := '652C746869732E5F6472616767696E673D742C746869732E5F6576656E744275733D6E2C746869732E5F6D6F64656C696E673D692C746869732E5F72756C65733D6F2C746869732E5F746F6F6C4D616E616765723D732C746869732E5F6D6F7573653D72';
wwv_flow_imp.g_varchar2_table(41135) := '3B76617220613D746869733B732E7265676973746572546F6F6C28227370616365222C7B746F6F6C3A227370616365546F6F6C2E73656C656374696F6E222C6472616767696E673A227370616365546F6F6C227D292C6E2E6F6E28227370616365546F6F';
wwv_flow_imp.g_varchar2_table(41136) := '6C2E73656C656374696F6E2E656E64222C2866756E6374696F6E2865297B6E2E6F6E636528227370616365546F6F6C2E73656C656374696F6E2E656E646564222C2866756E6374696F6E28297B612E61637469766174654D616B65537061636528652E6F';
wwv_flow_imp.g_varchar2_table(41137) := '726967696E616C4576656E74297D29297D29292C6E2E6F6E28227370616365546F6F6C2E6D6F7665222C6A672C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E696E697469616C697A65643B6E7C7C286E3D742E696E';
wwv_flow_imp.g_varchar2_table(41138) := '697469616C697A65643D612E696E697428652C7429292C6E26264B672865297D29292C6E2E6F6E28227370616365546F6F6C2E656E64222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D742E617869732C6F3D742E6469';
wwv_flow_imp.g_varchar2_table(41139) := '72656374696F6E2C733D742E6D6F76696E675368617065732C723D742E726573697A696E675368617065732C6C3D742E73746172743B696628742E696E697469616C697A6564297B4B672865293B76617220633D7B783A302C793A307D3B635B695D3D56';
wwv_flow_imp.g_varchar2_table(41140) := '6728655B2264222B695D292C612E6D616B65537061636528732C722C632C6F2C6C292C6E2E6F6E636528227370616365546F6F6C2E656E646564222C2866756E6374696F6E2865297B612E616374697661746553656C656374696F6E28652E6F72696769';
wwv_flow_imp.g_varchar2_table(41141) := '6E616C4576656E742C21302C2130297D29297D7D29297D66756E6374696F6E2055672865297B72657475726E7B746F703A652E746F702D32302C72696768743A652E72696768742B32302C626F74746F6D3A652E626F74746F6D2B32302C6C6566743A65';
wwv_flow_imp.g_varchar2_table(41142) := '2E6C6566742D32307D7D66756E6374696F6E204B672865297B76617220742C6E2C6F3D652E636F6E746578742E7370616365546F6F6C436F6E73747261696E74733B6F26262828302C692E457429286F2E6C65667429262628743D4D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(41143) := '652E782C6F2E6C656674292C652E64783D652E64782B742D652E782C652E783D74292C28302C692E457429286F2E726967687429262628743D4D6174682E6D696E28652E782C6F2E7269676874292C652E64783D652E64782B742D652E782C652E783D74';
wwv_flow_imp.g_varchar2_table(41144) := '292C28302C692E457429286F2E746F70292626286E3D4D6174682E6D617828652E792C6F2E746F70292C652E64793D652E64792B6E2D652E792C652E793D6E292C28302C692E457429286F2E626F74746F6D292626286E3D4D6174682E6D696E28652E79';
wwv_flow_imp.g_varchar2_table(41145) := '2C6F2E626F74746F6D292C652E64793D652E64792B6E2D652E792C652E793D6E29297D66756E6374696F6E20476728652C74297B72657475726E2D31213D3D652E696E6465784F662874297D24672E24696E6A6563743D5B2263616E766173222C226472';
wwv_flow_imp.g_varchar2_table(41146) := '616767696E67222C226576656E74427573222C226D6F64656C696E67222C2272756C6573222C22746F6F6C4D616E61676572222C226D6F757365225D2C24672E70726F746F747970652E616374697661746553656C656374696F6E3D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(41147) := '28652C742C6E297B746869732E5F6472616767696E672E696E697428652C227370616365546F6F6C2E73656C656374696F6E222C7B6175746F41637469766174653A742C637572736F723A48672C646174613A7B636F6E746578743A7B72656163746976';
wwv_flow_imp.g_varchar2_table(41148) := '6174653A6E7D7D2C74726170436C69636B3A21317D297D2C24672E70726F746F747970652E61637469766174654D616B6553706163653D66756E6374696F6E2865297B746869732E5F6472616767696E672E696E697428652C227370616365546F6F6C22';
wwv_flow_imp.g_varchar2_table(41149) := '2C7B6175746F41637469766174653A21302C637572736F723A48672C646174613A7B636F6E746578743A7B7D7D7D297D2C24672E70726F746F747970652E6D616B6553706163653D66756E6374696F6E28652C742C6E2C692C6F297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(41150) := '6869732E5F6D6F64656C696E672E637265617465537061636528652C742C6E2C692C6F297D2C24672E70726F746F747970652E696E69743D66756E6374696F6E28652C74297B766172206E3D426728652E6478293E426728652E6479293F2278223A2279';
wwv_flow_imp.g_varchar2_table(41151) := '222C6F3D655B2264222B6E5D2C733D655B6E5D2D6F3B6966284267286F293C352972657475726E21313B6F3C302626286F2A3D2D31292C4E722865292626286F2A3D2D31293B76617220723D66756E6374696F6E28652C74297B6966282278223D3D3D65';
wwv_flow_imp.g_varchar2_table(41152) := '297B696628743E302972657475726E2265223B696628743C302972657475726E2277227D6966282279223D3D3D65297B696628743E302972657475726E2273223B696628743C302972657475726E226E227D72657475726E206E756C6C7D286E2C6F292C';
wwv_flow_imp.g_varchar2_table(41153) := '613D746869732E5F63616E7661732E676574526F6F74456C656D656E7428293B2150722865292626652E686F766572262628613D652E686F766572293B766172206C3D5B2E2E2E6C7428612C2130292C2E2E2E612E6174746163686572737C7C5B5D5D2C';
wwv_flow_imp.g_varchar2_table(41154) := '633D746869732E63616C63756C61746541646A7573746D656E7473286C2C6E2C6F2C73292C643D66756E6374696F6E28652C742C6E2C6F2C73297B76617220723D652E6D6F76696E675368617065732C613D652E726573697A696E675368617065733B69';
wwv_flow_imp.g_varchar2_table(41155) := '6628612E6C656E677468297B766172206C2C632C643D7B7D3B72657475726E28302C692E6A4A2928612C2866756E6374696F6E2865297B76617220682C752C702C672C6D2C662C763D652E6174746163686572732C623D652E6368696C6472656E2C5F3D';
wwv_flow_imp.g_varchar2_table(41156) := '566E2865292C793D28302C692E70622928622C2866756E6374696F6E2865297B72657475726E21284F6E2865297C7C526E2865297C7C476728722C65297C7C476728612C6529297D29292C773D28302C692E70622928622C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(41157) := '7B72657475726E214F6E286529262621526E2865292626476728722C65297D29292C433D5B5D2C533D5B5D3B792E6C656E677468262628753D556728566E28637428792929292C683D6F2D5F5B57675B6E5D5D2B755B57675B6E5D5D2C226E223D3D3D6E';
wwv_flow_imp.g_varchar2_table(41158) := '3F642E626F74746F6D3D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A683A2277223D3D3D6E3F642E72696768743D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A683A2273223D3D3D6E3F642E746F703D';
wwv_flow_imp.g_varchar2_table(41159) := '6C3D28302C692E457429286C293F4D6174682E6D6178286C2C68293A683A2265223D3D3D6E262628642E6C6566743D6C3D28302C692E457429286C293F4D6174682E6D6178286C2C68293A6829292C772E6C656E677468262628703D556728566E286374';
wwv_flow_imp.g_varchar2_table(41160) := '28772929292C683D6F2D705B57675B71675B6E5D5D5D2B5F5B57675B71675B6E5D5D5D2C226E223D3D3D6E3F642E626F74746F6D3D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A683A2277223D3D3D6E3F642E72696768743D63';
wwv_flow_imp.g_varchar2_table(41161) := '3D28302C692E4574292863293F4D6174682E6D696E28632C68293A683A2273223D3D3D6E3F642E746F703D6C3D28302C692E457429286C293F4D6174682E6D6178286C2C68293A683A2265223D3D3D6E262628642E6C6566743D6C3D28302C692E457429';
wwv_flow_imp.g_varchar2_table(41162) := '286C293F4D6174682E6D6178286C2C68293A6829292C762626762E6C656E677468262628762E666F7245616368282866756E6374696F6E2865297B476728722C65293F432E707573682865293A532E707573682865297D29292C432E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(41163) := '28673D566E28637428432E6D617028486E2929292C6D3D5F5B57675B71675B6E5D5D5D2D28675B57675B71675B6E5D5D5D2D6F29292C532E6C656E677468262628663D566E28637428532E6D617028486E2929295B57675B6E5D5D2D285F5B57675B6E5D';
wwv_flow_imp.g_varchar2_table(41164) := '5D2D6F29292C226E223D3D3D6E3F28683D4D6174682E6D696E286D7C7C312F302C667C7C312F30292C642E626F74746F6D3D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A68293A2277223D3D3D6E3F28683D4D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(41165) := '286D7C7C312F302C667C7C312F30292C642E72696768743D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A68293A2273223D3D3D6E3F28683D4D6174682E6D6178286D7C7C2D312F302C667C7C2D312F30292C642E746F703D6C3D';
wwv_flow_imp.g_varchar2_table(41166) := '28302C692E457429286C293F4D6174682E6D6178286C2C68293A68293A2265223D3D3D6E262628683D4D6174682E6D6178286D7C7C2D312F302C667C7C2D312F30292C642E6C6566743D6C3D28302C692E457429286C293F4D6174682E6D6178286C2C68';
wwv_flow_imp.g_varchar2_table(41167) := '293A6829293B76617220783D732626735B652E69645D3B78262628226E223D3D3D6E3F28683D6F2B655B7A675B745D5D2D785B7A675B745D5D2C642E626F74746F6D3D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A68293A2277';
wwv_flow_imp.g_varchar2_table(41168) := '223D3D3D6E3F28683D6F2B655B7A675B745D5D2D785B7A675B745D5D2C642E72696768743D633D28302C692E4574292863293F4D6174682E6D696E28632C68293A68293A2273223D3D3D6E3F28683D6F2D655B7A675B745D5D2B785B7A675B745D5D2C64';
wwv_flow_imp.g_varchar2_table(41169) := '2E746F703D6C3D28302C692E457429286C293F4D6174682E6D6178286C2C68293A68293A2265223D3D3D6E262628683D6F2D655B7A675B745D5D2B785B7A675B745D5D2C642E6C6566743D6C3D28302C692E457429286C293F4D6174682E6D6178286C2C';
wwv_flow_imp.g_varchar2_table(41170) := '68293A6829297D29292C647D7D28632C6E2C722C732C746869732E5F6576656E744275732E6669726528227370616365546F6F6C2E6765744D696E44696D656E73696F6E73222C7B617869733A6E2C646972656374696F6E3A722C7368617065733A632E';
wwv_flow_imp.g_varchar2_table(41171) := '726573697A696E675368617065732C73746172743A737D29293B72657475726E28302C692E6B702928742C632C7B617869733A6E2C646972656374696F6E3A722C7370616365546F6F6C436F6E73747261696E74733A642C73746172743A737D292C7561';
wwv_flow_imp.g_varchar2_table(41172) := '2822726573697A652D222B282278223D3D3D6E3F226577223A226E732229292C21307D2C24672E70726F746F747970652E63616C63756C61746541646A7573746D656E74733D66756E6374696F6E28652C742C6E2C6F297B76617220733D746869732E5F';
wwv_flow_imp.g_varchar2_table(41173) := '72756C65732C723D5B5D2C613D5B5D2C6C3D5B5D2C633D5B5D3B66756E6374696F6E20642865297B722E696E636C756465732865297C7C722E707573682865293B76617220743D652E6C6162656C3B74262621722E696E636C756465732874292626722E';
wwv_flow_imp.g_varchar2_table(41174) := '707573682874297D28302C692E6A4A2928652C2866756E6374696F6E2865297B696628652E706172656E74262621526E286529296966284F6E28652929632E707573682865293B656C73657B76617220693D655B745D2C723D692B655B7A675B745D5D3B';
wwv_flow_imp.g_varchar2_table(41175) := '69662866756E6374696F6E2865297B72657475726E2121652E686F73747D2865292626286E3E302626486E2865295B745D3E6F7C7C6E3C302626486E2865295B745D3C6F29296C2E707573682865293B656C73657B76617220683B69662821286E3E3026';
wwv_flow_imp.g_varchar2_table(41176) := '26693E6F7C7C6E3C302626723C6F292972657475726E20693C6F2626723E6F2626732E616C6C6F776564282273686170652E726573697A65222C7B73686170653A657D293F28683D652C766F696428612E696E636C756465732868297C7C612E70757368';
wwv_flow_imp.g_varchar2_table(41177) := '28682929293A766F696420303B642865297D7D7D29292C28302C692E6A4A2928722C2866756E6374696F6E2865297B76617220743D652E6174746163686572733B74262628302C692E6A4A2928742C2866756E6374696F6E2865297B642865297D29297D';
wwv_flow_imp.g_varchar2_table(41178) := '29293B76617220683D722E636F6E6361742861293B72657475726E28302C692E6A4A29286C2C2866756E6374696F6E2865297B76617220743D652E686F73743B476728682C74292626642865297D29292C683D722E636F6E6361742861292C28302C692E';
wwv_flow_imp.g_varchar2_table(41179) := '6A4A2928632C2866756E6374696F6E2865297B76617220743D652E736F757263652C6E3D652E7461726765742C693D652E6C6162656C3B476728682C74292626476728682C6E292626692626642869297D29292C7B6D6F76696E675368617065733A722C';
wwv_flow_imp.g_varchar2_table(41180) := '726573697A696E675368617065733A617D7D2C24672E70726F746F747970652E746F67676C653D66756E6374696F6E28297B696628746869732E697341637469766528292972657475726E20746869732E5F6472616767696E672E63616E63656C28293B';
wwv_flow_imp.g_varchar2_table(41181) := '76617220653D746869732E5F6D6F7573652E6765744C6173744D6F76654576656E7428293B746869732E616374697661746553656C656374696F6E28652C212165297D2C24672E70726F746F747970652E69734163746976653D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(41182) := '7B76617220653D746869732E5F6472616767696E672E636F6E7465787428293B72657475726E21216526262F5E7370616365546F6F6C2F2E7465737428652E707265666978297D3B7661722051673D22646A732D6472616767696E67222C59673D22646A';
wwv_flow_imp.g_varchar2_table(41183) := '732D726573697A696E67222C5A673D4D6174682E6D61783B66756E6374696F6E20586728652C742C6E2C6F2C73297B66756E6374696F6E207228652C74297B28302C692E6A4A2928652C2866756E6374696F6E2865297B732E6164644472616767657228';
wwv_flow_imp.g_varchar2_table(41184) := '652C74292C6E2E6164644D61726B657228652C5167297D29297D652E6F6E28227370616365546F6F6C2E73656C656374696F6E2E7374617274222C2866756E6374696F6E2865297B76617220743D6E2E6765744C617965722822737061636522292C693D';
wwv_flow_imp.g_varchar2_table(41185) := '652E636F6E746578742C733D6B6528226722293B666528732C6F2E636C732822646A732D63726F7373686169722D67726F7570222C5B226E6F2D6576656E7473225D29292C756528742C73293B76617220723D6B6528227061746822293B666528722C22';
wwv_flow_imp.g_varchar2_table(41186) := '64222C224D20302C2D3130303030204C20302C313030303022292C62652872292E6164642822646A732D63726F73736861697222292C756528732C72293B76617220613D6B6528227061746822293B666528612C2264222C224D202D31303030302C3020';
wwv_flow_imp.g_varchar2_table(41187) := '4C2031303030302C3022292C62652861292E6164642822646A732D63726F73736861697222292C756528732C61292C692E63726F73736861697247726F75703D737D29292C652E6F6E28227370616365546F6F6C2E73656C656374696F6E2E6D6F766522';
wwv_flow_imp.g_varchar2_table(41188) := '2C2866756E6374696F6E2865297B626928652E636F6E746578742E63726F73736861697247726F75702C652E782C652E79297D29292C652E6F6E28227370616365546F6F6C2E73656C656374696F6E2E636C65616E7570222C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(41189) := '297B76617220743D652E636F6E746578742E63726F73736861697247726F75703B74262652652874297D29292C652E6F6E28227370616365546F6F6C2E6D6F7665222C3235302C2866756E6374696F6E2865297B76617220613D652E636F6E746578742C';
wwv_flow_imp.g_varchar2_table(41190) := '6C3D612E6C696E652C633D612E617869732C643D612E6D6F76696E675368617065732C683D612E726573697A696E675368617065733B696628612E696E697469616C697A6564297B69662821612E6472616747726F7570297B76617220753D6E2E676574';
wwv_flow_imp.g_varchar2_table(41191) := '4C617965722822737061636522293B6665286C3D6B6528227061746822292C2264222C224D302C30204C302C3022292C6265286C292E6164642822646A732D63726F73736861697222292C756528752C6C292C612E6C696E653D6C3B76617220703D6B65';
wwv_flow_imp.g_varchar2_table(41192) := '28226722293B666528702C6F2E636C732822646A732D647261672D67726F7570222C5B226E6F2D6576656E7473225D29292C7565286E2E6765744163746976654C6179657228292C70292C7228642C70292C7228612E6D6F76696E67436F6E6E65637469';
wwv_flow_imp.g_varchar2_table(41193) := '6F6E733D742E66696C746572282866756E6374696F6E2865297B76617220743D21313B28302C692E6A4A2928642C2866756E6374696F6E286E297B28302C692E6A4A29286E2E6F7574676F696E672C2866756E6374696F6E286E297B653D3D3D6E262628';
wwv_flow_imp.g_varchar2_table(41194) := '743D2130297D29297D29293B766172206E3D21313B28302C692E6A4A2928642C2866756E6374696F6E2874297B28302C692E6A4A2928742E696E636F6D696E672C2866756E6374696F6E2874297B653D3D3D742626286E3D2130297D29297D29293B7661';
wwv_flow_imp.g_varchar2_table(41195) := '72206F3D21313B28302C692E6A4A2928682C2866756E6374696F6E2874297B28302C692E6A4A2928742E6F7574676F696E672C2866756E6374696F6E2874297B653D3D3D742626286F3D2130297D29297D29293B76617220733D21313B72657475726E28';
wwv_flow_imp.g_varchar2_table(41196) := '302C692E6A4A2928682C2866756E6374696F6E2874297B28302C692E6A4A2928742E696E636F6D696E672C2866756E6374696F6E2874297B653D3D3D74262628733D2130297D29297D29292C4F6E286529262628747C7C6F292626286E7C7C73297D2929';
wwv_flow_imp.g_varchar2_table(41197) := '2C70292C612E6472616747726F75703D707D69662821612E6672616D6547726F7570297B76617220673D6B6528226722293B666528672C6F2E636C732822646A732D6672616D652D67726F7570222C5B226E6F2D6576656E7473225D29292C7565286E2E';
wwv_flow_imp.g_varchar2_table(41198) := '6765744163746976654C6179657228292C67293B766172206D3D5B5D3B28302C692E6A4A2928682C2866756E6374696F6E2865297B76617220743D732E6164644672616D6528652C67292C693D742E67657442426F7828293B6D2E70757368287B656C65';
wwv_flow_imp.g_varchar2_table(41199) := '6D656E743A742C696E697469616C426F756E64733A697D292C6E2E6164644D61726B657228652C5967297D29292C612E6672616D6547726F75703D672C612E6672616D65733D6D7D6665286C2C7B643A7B783A224D222B652E782B222C202D3130303030';
wwv_flow_imp.g_varchar2_table(41200) := '204C222B652E782B222C203130303030222C793A224D202D31303030302C20222B652E792B22204C2031303030302C20222B652E797D5B635D7D293B76617220663D7B783A652E64782C793A652E64797D3B665B7B783A2279222C793A2278227D5B612E';
wwv_flow_imp.g_varchar2_table(41201) := '617869735D5D3D302C626928612E6472616747726F75702C662E782C662E79292C28302C692E6A4A2928612E6672616D65732C2866756E6374696F6E2865297B76617220742C6E2C693D652E656C656D656E742C6F3D652E696E697469616C426F756E64';
wwv_flow_imp.g_varchar2_table(41202) := '733B2265223D3D3D612E646972656374696F6E3F666528692C7B77696474683A5A67286F2E77696474682B662E782C35297D293A666528692C7B77696474683A743D5A67286F2E77696474682D662E782C35292C783A6F2E782B6F2E77696474682D747D';
wwv_flow_imp.g_varchar2_table(41203) := '292C2273223D3D3D612E646972656374696F6E3F666528692C7B6865696768743A5A67286F2E6865696768742B662E792C35297D293A666528692C7B6865696768743A6E3D5A67286F2E6865696768742D662E792C35292C793A6F2E792B6F2E68656967';
wwv_flow_imp.g_varchar2_table(41204) := '68742D6E7D297D29297D7D29292C652E6F6E28227370616365546F6F6C2E636C65616E7570222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6F3D742E6D6F76696E675368617065732C733D742E6D6F76696E67436F6E6E65';
wwv_flow_imp.g_varchar2_table(41205) := '6374696F6E732C723D742E726573697A696E675368617065732C613D742E6C696E652C6C3D742E6472616747726F75702C633D742E6672616D6547726F75703B28302C692E6A4A29286F2C2866756E6374696F6E2865297B6E2E72656D6F76654D61726B';
wwv_flow_imp.g_varchar2_table(41206) := '657228652C5167297D29292C28302C692E6A4A2928732C2866756E6374696F6E2865297B6E2E72656D6F76654D61726B657228652C5167297D29292C6C26262852652861292C5265286C29292C28302C692E6A4A2928722C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(41207) := '7B6E2E72656D6F76654D61726B657228652C5967297D29292C63262652652863297D29297D58672E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279222C2263616E766173222C227374796C6573222C22707265';
wwv_flow_imp.g_varchar2_table(41208) := '76696577537570706F7274225D3B636F6E7374204A673D7B5F5F696E69745F5F3A5B227370616365546F6F6C50726576696577225D2C5F5F646570656E64735F5F3A5B6A632C4B632C52672C65682C6D675D2C7370616365546F6F6C3A5B227479706522';
wwv_flow_imp.g_varchar2_table(41209) := '2C24675D2C7370616365546F6F6C507265766965773A5B2274797065222C58675D7D3B66756E6374696F6E20656D2865297B652E696E766F6B652824672C74686973297D656D2E24696E6A6563743D5B22696E6A6563746F72225D2C5228656D2C246729';
wwv_flow_imp.g_varchar2_table(41210) := '2C656D2E70726F746F747970652E63616C63756C61746541646A7573746D656E74733D66756E6374696F6E28652C742C6E2C69297B766172206F3D24672E70726F746F747970652E63616C63756C61746541646A7573746D656E74732E63616C6C287468';
wwv_flow_imp.g_varchar2_table(41211) := '69732C652C742C6E2C69293B72657475726E206F2E726573697A696E675368617065733D6F2E726573697A696E675368617065732E66696C746572282866756E6374696F6E2865297B72657475726E212828302C792E69732928652C2262706D6E3A5465';
wwv_flow_imp.g_varchar2_table(41212) := '7874416E6E6F746174696F6E22297C7C66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E74222926262128302C792E676574427573696E6573734F626A656374292865292E70726F636573';
wwv_flow_imp.g_varchar2_table(41213) := '735265667D2865292626282279223D3D3D74262628302C72732E2462292865297C7C2278223D3D3D7426262128302C72732E24622928652929297D29292C6F7D3B636F6E737420746D3D7B5F5F646570656E64735F5F3A5B4A675D2C7370616365546F6F';
wwv_flow_imp.g_varchar2_table(41214) := '6C3A5B2274797065222C656D5D7D3B66756E6374696F6E206E6D28652C74297B746869732E5F68616E646C65724D61703D7B7D2C746869732E5F737461636B3D5B5D2C746869732E5F737461636B4964783D2D312C746869732E5F63757272656E744578';
wwv_flow_imp.g_varchar2_table(41215) := '65637574696F6E3D7B616374696F6E733A5B5D2C64697274793A5B5D2C747269676765723A6E756C6C7D2C746869732E5F696E6A6563746F723D742C746869732E5F6576656E744275733D652C746869732E5F7569643D312C652E6F6E285B2264696167';
wwv_flow_imp.g_varchar2_table(41216) := '72616D2E64657374726F79222C226469616772616D2E636C656172225D2C2866756E6374696F6E28297B746869732E636C656172282131297D292C74686973297D6E6D2E24696E6A6563743D5B226576656E74427573222C22696E6A6563746F72225D2C';
wwv_flow_imp.g_varchar2_table(41217) := '6E6D2E70726F746F747970652E657865637574653D66756E6374696F6E28652C74297B6966282165297468726F77206E6577204572726F722822636F6D6D616E6420726571756972656422293B746869732E5F63757272656E74457865637574696F6E2E';
wwv_flow_imp.g_varchar2_table(41218) := '747269676765723D2265786563757465223B636F6E7374206E3D7B636F6D6D616E643A652C636F6E746578743A747D3B746869732E5F70757368416374696F6E286E292C746869732E5F696E7465726E616C45786563757465286E292C746869732E5F70';
wwv_flow_imp.g_varchar2_table(41219) := '6F70416374696F6E28297D2C6E6D2E70726F746F747970652E63616E457865637574653D66756E6374696F6E28652C74297B636F6E7374206E3D7B636F6D6D616E643A652C636F6E746578743A747D2C693D746869732E5F67657448616E646C65722865';
wwv_flow_imp.g_varchar2_table(41220) := '293B6C6574206F3D746869732E5F6669726528652C2263616E45786563757465222C6E293B696628766F696420303D3D3D6F297B69662821692972657475726E21313B692E63616E457865637574652626286F3D692E63616E4578656375746528742929';
wwv_flow_imp.g_varchar2_table(41221) := '7D72657475726E206F7D2C6E6D2E70726F746F747970652E636C6561723D66756E6374696F6E2865297B746869732E5F737461636B2E6C656E6774683D302C746869732E5F737461636B4964783D2D312C2131213D3D652626746869732E5F6669726528';
wwv_flow_imp.g_varchar2_table(41222) := '226368616E676564222C7B747269676765723A22636C656172227D297D2C6E6D2E70726F746F747970652E756E646F3D66756E6374696F6E28297B6C657420652C743D746869732E5F676574556E646F416374696F6E28293B69662874297B666F722874';
wwv_flow_imp.g_varchar2_table(41223) := '6869732E5F63757272656E74457865637574696F6E2E747269676765723D22756E646F222C746869732E5F70757368416374696F6E2874293B74262628746869732E5F696E7465726E616C556E646F2874292C653D746869732E5F676574556E646F4163';
wwv_flow_imp.g_varchar2_table(41224) := '74696F6E28292C652626652E69643D3D3D742E6964293B29743D653B746869732E5F706F70416374696F6E28297D7D2C6E6D2E70726F746F747970652E7265646F3D66756E6374696F6E28297B6C657420652C743D746869732E5F6765745265646F4163';
wwv_flow_imp.g_varchar2_table(41225) := '74696F6E28293B69662874297B666F7228746869732E5F63757272656E74457865637574696F6E2E747269676765723D227265646F222C746869732E5F70757368416374696F6E2874293B74262628746869732E5F696E7465726E616C45786563757465';
wwv_flow_imp.g_varchar2_table(41226) := '28742C2130292C653D746869732E5F6765745265646F416374696F6E28292C652626652E69643D3D3D742E6964293B29743D653B746869732E5F706F70416374696F6E28297D7D2C6E6D2E70726F746F747970652E72656769737465723D66756E637469';
wwv_flow_imp.g_varchar2_table(41227) := '6F6E28652C74297B746869732E5F73657448616E646C657228652C74297D2C6E6D2E70726F746F747970652E726567697374657248616E646C65723D66756E6374696F6E28652C74297B69662821657C7C2174297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(41228) := '22636F6D6D616E6420616E642068616E646C6572436C73206D75737420626520646566696E656422293B636F6E7374206E3D746869732E5F696E6A6563746F722E696E7374616E74696174652874293B746869732E726567697374657228652C6E297D2C';
wwv_flow_imp.g_varchar2_table(41229) := '6E6D2E70726F746F747970652E63616E556E646F3D66756E6374696F6E28297B72657475726E2121746869732E5F676574556E646F416374696F6E28297D2C6E6D2E70726F746F747970652E63616E5265646F3D66756E6374696F6E28297B7265747572';
wwv_flow_imp.g_varchar2_table(41230) := '6E2121746869732E5F6765745265646F416374696F6E28297D2C6E6D2E70726F746F747970652E5F6765745265646F416374696F6E3D66756E6374696F6E28297B72657475726E20746869732E5F737461636B5B746869732E5F737461636B4964782B31';
wwv_flow_imp.g_varchar2_table(41231) := '5D7D2C6E6D2E70726F746F747970652E5F676574556E646F416374696F6E3D66756E6374696F6E28297B72657475726E20746869732E5F737461636B5B746869732E5F737461636B4964785D7D2C6E6D2E70726F746F747970652E5F696E7465726E616C';
wwv_flow_imp.g_varchar2_table(41232) := '556E646F3D66756E6374696F6E2865297B636F6E737420743D652E636F6D6D616E642C6E3D652E636F6E746578742C693D746869732E5F67657448616E646C65722874293B746869732E5F61746F6D6963446F282828293D3E7B746869732E5F66697265';
wwv_flow_imp.g_varchar2_table(41233) := '28742C22726576657274222C65292C692E7265766572742626746869732E5F6D61726B446972747928692E726576657274286E29292C746869732E5F7265766572746564416374696F6E2865292C746869732E5F6669726528742C227265766572746564';
wwv_flow_imp.g_varchar2_table(41234) := '222C65297D29297D2C6E6D2E70726F746F747970652E5F666972653D66756E6374696F6E28652C742C6E297B617267756D656E74732E6C656E6774683C332626286E3D742C743D6E756C6C293B636F6E737420693D743F5B652B222E222B742C745D3A5B';
wwv_flow_imp.g_varchar2_table(41235) := '655D3B6C6574206F3B6E3D746869732E5F6576656E744275732E6372656174654576656E74286E293B666F7228636F6E73742065206F662069296966286F3D746869732E5F6576656E744275732E666972652822636F6D6D616E64537461636B2E222B65';
wwv_flow_imp.g_varchar2_table(41236) := '2C6E292C6E2E63616E63656C427562626C6529627265616B3B72657475726E206F7D2C6E6D2E70726F746F747970652E5F63726561746549643D66756E6374696F6E28297B72657475726E20746869732E5F7569642B2B7D2C6E6D2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(41237) := '652E5F61746F6D6963446F3D66756E6374696F6E2865297B636F6E737420743D746869732E5F63757272656E74457865637574696F6E3B742E61746F6D69633D21303B7472797B6528297D66696E616C6C797B742E61746F6D69633D21317D7D2C6E6D2E';
wwv_flow_imp.g_varchar2_table(41238) := '70726F746F747970652E5F696E7465726E616C457865637574653D66756E6374696F6E28652C74297B636F6E7374206E3D652E636F6D6D616E642C693D652E636F6E746578742C6F3D746869732E5F67657448616E646C6572286E293B696628216F2974';
wwv_flow_imp.g_varchar2_table(41239) := '68726F77206E6577204572726F7228226E6F20636F6D6D616E642068616E646C6572207265676973746572656420666F72203C222B6E2B223E22293B746869732E5F70757368416374696F6E2865292C747C7C28746869732E5F66697265286E2C227072';
wwv_flow_imp.g_varchar2_table(41240) := '6545786563757465222C65292C6F2E7072654578656375746526266F2E707265457865637574652869292C746869732E5F66697265286E2C227072654578656375746564222C6529292C746869732E5F61746F6D6963446F282828293D3E7B746869732E';
wwv_flow_imp.g_varchar2_table(41241) := '5F66697265286E2C2265786563757465222C65292C6F2E657865637574652626746869732E5F6D61726B4469727479286F2E65786563757465286929292C746869732E5F6578656375746564416374696F6E28652C74292C746869732E5F66697265286E';
wwv_flow_imp.g_varchar2_table(41242) := '2C226578656375746564222C65297D29292C747C7C28746869732E5F66697265286E2C22706F737445786563757465222C65292C6F2E706F73744578656375746526266F2E706F7374457865637574652869292C746869732E5F66697265286E2C22706F';
wwv_flow_imp.g_varchar2_table(41243) := '73744578656375746564222C6529292C746869732E5F706F70416374696F6E28297D2C6E6D2E70726F746F747970652E5F70757368416374696F6E3D66756E6374696F6E2865297B636F6E737420743D746869732E5F63757272656E7445786563757469';
wwv_flow_imp.g_varchar2_table(41244) := '6F6E2C6E3D742E616374696F6E732C693D6E5B305D3B696628742E61746F6D6963297468726F77206E6577204572726F722822696C6C6567616C20696E766F636174696F6E20696E203C657865637574653E206F72203C7265766572743E207068617365';
wwv_flow_imp.g_varchar2_table(41245) := '2028616374696F6E3A20222B652E636F6D6D616E642B222922293B652E69647C7C28652E69643D692626692E69647C7C746869732E5F63726561746549642829292C6E2E707573682865297D2C6E6D2E70726F746F747970652E5F706F70416374696F6E';
wwv_flow_imp.g_varchar2_table(41246) := '3D66756E6374696F6E28297B636F6E737420653D746869732E5F63757272656E74457865637574696F6E2C743D652E747269676765722C6E3D652E616374696F6E732C6F3D652E64697274793B6E2E706F7028292C6E2E6C656E6774687C7C2874686973';
wwv_flow_imp.g_varchar2_table(41247) := '2E5F6576656E744275732E666972652822656C656D656E74732E6368616E676564222C7B656C656D656E74733A28302C692E70442928226964222C6F2E726576657273652829297D292C6F2E6C656E6774683D302C746869732E5F666972652822636861';
wwv_flow_imp.g_varchar2_table(41248) := '6E676564222C7B747269676765723A747D292C652E747269676765723D6E756C6C297D2C6E6D2E70726F746F747970652E5F6D61726B44697274793D66756E6374696F6E2865297B636F6E737420743D746869732E5F63757272656E7445786563757469';
wwv_flow_imp.g_varchar2_table(41249) := '6F6E3B65262628653D28302C692E6379292865293F653A5B655D2C742E64697274793D742E64697274792E636F6E636174286529297D2C6E6D2E70726F746F747970652E5F6578656375746564416374696F6E3D66756E6374696F6E28652C74297B636F';
wwv_flow_imp.g_varchar2_table(41250) := '6E7374206E3D2B2B746869732E5F737461636B4964783B747C7C746869732E5F737461636B2E73706C696365286E2C746869732E5F737461636B2E6C656E6774682C65297D2C6E6D2E70726F746F747970652E5F7265766572746564416374696F6E3D66';
wwv_flow_imp.g_varchar2_table(41251) := '756E6374696F6E2865297B746869732E5F737461636B4964782D2D7D2C6E6D2E70726F746F747970652E5F67657448616E646C65723D66756E6374696F6E2865297B72657475726E20746869732E5F68616E646C65724D61705B655D7D2C6E6D2E70726F';
wwv_flow_imp.g_varchar2_table(41252) := '746F747970652E5F73657448616E646C65723D66756E6374696F6E28652C74297B69662821657C7C2174297468726F77206E6577204572726F722822636F6D6D616E6420616E642068616E646C657220726571756972656422293B696628746869732E5F';
wwv_flow_imp.g_varchar2_table(41253) := '68616E646C65724D61705B655D297468726F77206E6577204572726F7228226F766572726964696E672068616E646C657220666F7220636F6D6D616E64203C222B652B223E22293B746869732E5F68616E646C65724D61705B655D3D747D3B636F6E7374';
wwv_flow_imp.g_varchar2_table(41254) := '20696D3D7B636F6D6D616E64537461636B3A5B2274797065222C6E6D5D7D3B66756E6374696F6E206F6D28652C74297B6966282266756E6374696F6E22213D747970656F662074297468726F77206E6577204572726F72282272656D6F7665466E206974';
wwv_flow_imp.g_varchar2_table(41255) := '657261746F72206D75737420626520612066756E6374696F6E22293B69662865297B666F7228766172206E3B6E3D655B305D3B2974286E293B72657475726E20657D7D66756E6374696F6E20736D28652C742C6E297B65722E63616C6C28746869732C74';
wwv_flow_imp.g_varchar2_table(41256) := '293B766172206F3D652E67657428226D6F766550726576696577222C2131293B742E6F6E282273686170652E6D6F76652E7374617274222C313430302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E736861706573';
wwv_flow_imp.g_varchar2_table(41257) := '2C693D742E76616C6964617465645368617065733B742E7368617065733D726D286E292C742E76616C6964617465645368617065733D726D2869297D29292C6F2626742E6F6E282273686170652E6D6F76652E7374617274222C3235302C2866756E6374';
wwv_flow_imp.g_varchar2_table(41258) := '696F6E2865297B76617220743D652E636F6E746578742C6E3D742E7368617065732C733D5B5D3B28302C692E6A4A29286E2C2866756E6374696F6E2865297B28302C692E6A4A2928652E6C6162656C732C2866756E6374696F6E286E297B6E2E68696464';
wwv_flow_imp.g_varchar2_table(41259) := '656E7C7C2D31213D3D742E7368617065732E696E6465784F66286E297C7C732E70757368286E292C652E6C6162656C5461726765742626732E707573682865297D29297D29292C28302C692E6A4A2928732C2866756E6374696F6E2865297B6F2E6D616B';
wwv_flow_imp.g_varchar2_table(41260) := '65447261676761626C6528742C652C2130297D29297D29292C746869732E70726545786563757465642822656C656D656E74732E6D6F7665222C313430302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E636C6F737572652C';
wwv_flow_imp.g_varchar2_table(41261) := '6E3D742E656E636C6F736564456C656D656E74732C6F3D5B5D3B28302C692E6A4A29286E2C2866756E6374696F6E2865297B28302C692E6A4A2928652E6C6162656C732C2866756E6374696F6E2865297B6E5B652E69645D7C7C6F2E707573682865297D';
wwv_flow_imp.g_varchar2_table(41262) := '29297D29292C742E616464416C6C286F297D29292C746869732E70726545786563757465285B22636F6E6E656374696F6E2E64656C657465222C2273686170652E64656C657465225D2C2866756E6374696F6E2865297B76617220743D652E636F6E7465';
wwv_flow_imp.g_varchar2_table(41263) := '78743B6F6D2828742E636F6E6E656374696F6E7C7C742E7368617065292E6C6162656C732C2866756E6374696F6E2865297B6E2E72656D6F7665536861706528652C7B6E65737465643A21307D297D29297D29292C746869732E65786563757465282273';
wwv_flow_imp.g_varchar2_table(41264) := '686170652E64656C657465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170652C693D6E2E6C6162656C5461726765743B69262628742E6C6162656C546172676574496E6465783D477428692E6C616265';
wwv_flow_imp.g_varchar2_table(41265) := '6C732C6E292C742E6C6162656C5461726765743D692C6E2E6C6162656C5461726765743D6E756C6C297D29292C746869732E726576657274282273686170652E64656C657465222C2866756E6374696F6E2865297B76617220743D652E636F6E74657874';
wwv_flow_imp.g_varchar2_table(41266) := '2C6E3D742E73686170652C693D742E6C6162656C5461726765742C6F3D742E6C6162656C546172676574496E6465783B692626284B7428692E6C6162656C732C6E2C6F292C6E2E6C6162656C5461726765743D69297D29297D66756E6374696F6E20726D';
wwv_flow_imp.g_varchar2_table(41267) := '2865297B72657475726E28302C692E70622928652C2866756E6374696F6E2874297B72657475726E2D313D3D3D652E696E6465784F6628742E6C6162656C546172676574297D29297D5228736D2C6572292C736D2E24696E6A6563743D5B22696E6A6563';
wwv_flow_imp.g_varchar2_table(41268) := '746F72222C226576656E74427573222C226D6F64656C696E67225D3B636F6E737420616D3D7B5F5F696E69745F5F3A5B226C6162656C537570706F7274225D2C6C6162656C537570706F72743A5B2274797065222C736D5D7D3B766172206C6D3D226174';
wwv_flow_imp.g_varchar2_table(41269) := '746163682D6F6B223B66756E6374696F6E20636D28652C742C6E2C6F2C73297B65722E63616C6C28746869732C74293B76617220723D652E67657428226D6F766550726576696577222C2131293B742E6F6E282273686170652E6D6F76652E7374617274';
wwv_flow_imp.g_varchar2_table(41270) := '222C313430312C2866756E6374696F6E2865297B76617220742C6E2C6F3D652E636F6E746578742C733D6F2E7368617065732C723D6F2E76616C6964617465645368617065733B6F2E7368617065733D286E3D646D28743D73292C28302C692E524B2928';
wwv_flow_imp.g_varchar2_table(41271) := '226964222C742C6E29292C6F2E76616C6964617465645368617065733D66756E6374696F6E2865297B76617220743D28302C692E247A2928652C22696422293B72657475726E28302C692E70622928652C2866756E6374696F6E2865297B666F72283B65';
wwv_flow_imp.g_varchar2_table(41272) := '3B297B696628652E686F73742626745B652E686F73742E69645D2972657475726E21313B653D652E706172656E747D72657475726E21307D29297D2872297D29292C722626742E6F6E282273686170652E6D6F76652E7374617274222C3235312C286675';
wwv_flow_imp.g_varchar2_table(41273) := '6E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D646D28742E736861706573293B28302C692E6A4A29286E2C2866756E6374696F6E2865297B722E6D616B65447261676761626C6528742C652C2130292C28302C692E6A4A2928652E';
wwv_flow_imp.g_varchar2_table(41274) := '6C6162656C732C2866756E6374696F6E2865297B722E6D616B65447261676761626C6528742C652C2130297D29297D29297D29292C722626742E6F6E282273686170652E6D6F76652E7374617274222C2866756E6374696F6E2865297B76617220693D65';
wwv_flow_imp.g_varchar2_table(41275) := '2E636F6E746578742E7368617065733B696628313D3D3D692E6C656E677468297B766172206F3D695B305D2E686F73743B6F2626286E2E6164644D61726B6572286F2C6C6D292C742E6F6E6365285B2273686170652E6D6F76652E6F7574222C22736861';
wwv_flow_imp.g_varchar2_table(41276) := '70652E6D6F76652E636C65616E7570225D2C2866756E6374696F6E28297B6E2E72656D6F76654D61726B6572286F2C6C6D297D2929297D7D29292C746869732E70726545786563757465642822656C656D656E74732E6D6F7665222C313430312C286675';
wwv_flow_imp.g_varchar2_table(41277) := '6E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E636C6F737572652C6F3D646D28742E736861706573293B28302C692E6A4A29286F2C2866756E6374696F6E2865297B6E2E61646428652C6E2E746F704C6576656C5B652E686F';
wwv_flow_imp.g_varchar2_table(41278) := '73742E69645D297D29297D29292C746869732E706F737445786563757465642822656C656D656E74732E6D6F7665222C2866756E6374696F6E2865297B76617220742C6E3D652E636F6E746578742C6F3D6E2E7368617065732C723D6E2E6E6577486F73';
wwv_flow_imp.g_varchar2_table(41279) := '743B72262631213D3D6F2E6C656E6774687C7C28743D723F6F3A28302C692E706229286F2C2866756E6374696F6E2865297B76617220742C6E3D652E686F73743B72657475726E2066756E6374696F6E2865297B72657475726E2121652E686F73747D28';
wwv_flow_imp.g_varchar2_table(41280) := '6529262628743D6E2C21282D31213D3D6F2E696E6465784F6628742929297D29292C28302C692E6A4A2928742C2866756E6374696F6E2865297B732E7570646174654174746163686D656E7428652C72297D2929297D29292C746869732E706F73744578';
wwv_flow_imp.g_varchar2_table(41281) := '6563757465642822656C656D656E74732E6D6F7665222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E7368617065733B28302C692E6A4A2928742C2866756E6374696F6E2865297B28302C692E6A4A2928652E617474616368';
wwv_flow_imp.g_varchar2_table(41282) := '6572732C2866756E6374696F6E2865297B28302C692E6A4A2928652E6F7574676F696E672E736C69636528292C2866756E6374696F6E2865297B6F2E616C6C6F7765642822636F6E6E656374696F6E2E7265636F6E6E656374222C7B636F6E6E65637469';
wwv_flow_imp.g_varchar2_table(41283) := '6F6E3A652C736F757263653A652E736F757263652C7461726765743A652E7461726765747D297C7C732E72656D6F7665436F6E6E656374696F6E2865297D29292C28302C692E6A4A2928652E696E636F6D696E672E736C69636528292C2866756E637469';
wwv_flow_imp.g_varchar2_table(41284) := '6F6E2865297B6F2E616C6C6F7765642822636F6E6E656374696F6E2E7265636F6E6E656374222C7B636F6E6E656374696F6E3A652C736F757263653A652E736F757263652C7461726765743A652E7461726765747D297C7C732E72656D6F7665436F6E6E';
wwv_flow_imp.g_varchar2_table(41285) := '656374696F6E2865297D29297D29297D29297D29292C746869732E706F737445786563757465282273686170652E637265617465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170652C693D742E686F73';
wwv_flow_imp.g_varchar2_table(41286) := '743B692626732E7570646174654174746163686D656E74286E2C69297D29292C746869732E706F737445786563757465282273686170652E7265706C616365222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E6F6C';
wwv_flow_imp.g_varchar2_table(41287) := '6453686170652C723D742E6E657753686170653B6F6D286E2E6174746163686572732C2866756E6374696F6E2865297B22617474616368223D3D3D6F2E616C6C6F7765642822656C656D656E74732E6D6F7665222C7B7461726765743A722C7368617065';
wwv_flow_imp.g_varchar2_table(41288) := '733A5B655D7D293F732E7570646174654174746163686D656E7428652C72293A732E72656D6F766553686170652865297D29292C722E6174746163686572732E6C656E677468262628302C692E6A4A2928722E6174746163686572732C2866756E637469';
wwv_flow_imp.g_varchar2_table(41289) := '6F6E2865297B76617220743D6D7528652C6E2C72293B732E6D6F7665536861706528652C742C652E706172656E74297D29297D29292C746869732E706F737445786563757465282273686170652E726573697A65222C2866756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(41290) := '617220743D652E636F6E746578742C6E3D742E73686170652C6F3D742E6F6C64426F756E64732C723D742E6E6577426F756E64732C613D6E2E6174746163686572733B2131213D3D28742E68696E74737C7C7B7D292E617474616368537570706F727426';
wwv_flow_imp.g_varchar2_table(41291) := '2628302C692E6A4A2928612C2866756E6374696F6E2865297B76617220743D6D7528652C6F2C72293B732E6D6F7665536861706528652C742C652E706172656E74292C28302C692E6A4A2928652E6C6162656C732C2866756E6374696F6E2865297B732E';
wwv_flow_imp.g_varchar2_table(41292) := '6D6F7665536861706528652C742C652E706172656E74297D29297D29297D29292C746869732E70726545786563757465282273686170652E64656C657465222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E73686170653B6F';
wwv_flow_imp.g_varchar2_table(41293) := '6D28742E6174746163686572732C2866756E6374696F6E2865297B732E72656D6F766553686170652865297D29292C742E686F73742626732E7570646174654174746163686D656E7428742C6E756C6C297D29297D66756E6374696F6E20646D2865297B';
wwv_flow_imp.g_varchar2_table(41294) := '72657475726E28302C692E4271292828302C692E546A2928652C2866756E6374696F6E2865297B72657475726E20652E6174746163686572737C7C5B5D7D2929297D5228636D2C6572292C636D2E24696E6A6563743D5B22696E6A6563746F72222C2265';
wwv_flow_imp.g_varchar2_table(41295) := '76656E74427573222C2263616E766173222C2272756C6573222C226D6F64656C696E67225D3B636F6E737420686D3D7B5F5F646570656E64735F5F3A5B4B635D2C5F5F696E69745F5F3A5B22617474616368537570706F7274225D2C6174746163685375';
wwv_flow_imp.g_varchar2_table(41296) := '70706F72743A5B2274797065222C636D5D7D3B66756E6374696F6E20756D2865297B746869732E5F6D6F64656C3D657D66756E6374696F6E20706D28652C742C6E297B65722E63616C6C28746869732C65292C746869732E5F62706D6E466163746F7279';
wwv_flow_imp.g_varchar2_table(41297) := '3D743B766172206F3D746869733B66756E6374696F6E20732865297B76617220743D652E636F6E746578742E6F6C64526F6F742E6368696C6472656E3B28302C692E6A4A2928742C2866756E6374696F6E2865297B28302C792E69732928652C2262706D';
wwv_flow_imp.g_varchar2_table(41298) := '6E3A42617365456C656D656E74222926266F2E757064617465506172656E742865297D29297D66756E6374696F6E20722865297B76617220743D652E636F6E746578742E73686170653B28302C792E69732928742C2262706D6E3A42617365456C656D65';
wwv_flow_imp.g_varchar2_table(41299) := '6E74222926266F2E757064617465426F756E64732874297D66756E6374696F6E20612865297B6F2E757064617465436F6E6E656374696F6E28652E636F6E74657874297D66756E6374696F6E206C2865297B6F2E757064617465436F6E6E656374696F6E';
wwv_flow_imp.g_varchar2_table(41300) := '576179706F696E747328652E636F6E746578742E636F6E6E656374696F6E297D66756E6374696F6E20632865297B6F2E7570646174654174746163686D656E7428652E636F6E74657874297D66756E6374696F6E20642865297B636F6E73747B656C656D';
wwv_flow_imp.g_varchar2_table(41301) := '656E743A6E7D3D652E636F6E746578742C693D7073286E292C6F3D28302C792E676574446929286E292C733D6F26266F2E67657428226C6162656C22293B6373286E297C7C6C72286E297C7C2869262621733F6F2E73657428226C6162656C222C742E63';
wwv_flow_imp.g_varchar2_table(41302) := '7265617465282262706D6E64693A42504D4E4C6162656C2229293A216926267326266F2E73657428226C6162656C222C766F6964203029297D746869732E6578656375746564285B22636F6E6E656374696F6E2E6C61796F7574222C22636F6E6E656374';
wwv_flow_imp.g_varchar2_table(41303) := '696F6E2E637265617465225D2C2866756E6374696F6E2865297B76617220742C693D652E636F6E746578742C6F3D692E68696E74737C7C7B7D3B692E63726F707065647C7C21313D3D3D6F2E637265617465456C656D656E74734265686176696F727C7C';
wwv_flow_imp.g_varchar2_table(41304) := '2828743D692E636F6E6E656374696F6E292E776179706F696E74733D6E2E67657443726F70706564576179706F696E74732874292C692E63726F707065643D2130297D29292C746869732E7265766572746564285B22636F6E6E656374696F6E2E6C6179';
wwv_flow_imp.g_varchar2_table(41305) := '6F7574225D2C2866756E6374696F6E2865297B64656C65746520652E636F6E746578742E63726F707065647D29292C746869732E6578656375746564285B2273686170652E6D6F7665222C2273686170652E637265617465222C2273686170652E64656C';
wwv_flow_imp.g_varchar2_table(41306) := '657465222C22636F6E6E656374696F6E2E637265617465222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E64656C657465225D2C676D282866756E6374696F6E2865297B76617220743D652E636F6E746578743B6F2E7570';
wwv_flow_imp.g_varchar2_table(41307) := '64617465506172656E7428742E73686170657C7C742E636F6E6E656374696F6E2C742E6F6C64506172656E74297D2929292C746869732E7265766572746564285B2273686170652E6D6F7665222C2273686170652E637265617465222C2273686170652E';
wwv_flow_imp.g_varchar2_table(41308) := '64656C657465222C22636F6E6E656374696F6E2E637265617465222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E64656C657465225D2C676D282866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E';
wwv_flow_imp.g_varchar2_table(41309) := '3D742E73686170657C7C742E636F6E6E656374696F6E2C693D742E706172656E747C7C742E6E6577506172656E743B6F2E757064617465506172656E74286E2C69297D2929292C746869732E6578656375746564285B2263616E7661732E757064617465';
wwv_flow_imp.g_varchar2_table(41310) := '526F6F74225D2C73292C746869732E7265766572746564285B2263616E7661732E757064617465526F6F74225D2C73292C746869732E6578656375746564285B2273686170652E6D6F7665222C2273686170652E637265617465222C2273686170652E72';
wwv_flow_imp.g_varchar2_table(41311) := '6573697A65225D2C676D282866756E6374696F6E2865297B226C6162656C22213D3D652E636F6E746578742E73686170652E747970652626722865297D2929292C746869732E7265766572746564285B2273686170652E6D6F7665222C2273686170652E';
wwv_flow_imp.g_varchar2_table(41312) := '637265617465222C2273686170652E726573697A65225D2C676D282866756E6374696F6E2865297B226C6162656C22213D3D652E636F6E746578742E73686170652E747970652626722865297D2929292C652E6F6E282273686170652E6368616E676564';
wwv_flow_imp.g_varchar2_table(41313) := '222C2866756E6374696F6E2865297B226C6162656C223D3D3D652E656C656D656E742E74797065262672287B636F6E746578743A7B73686170653A652E656C656D656E747D7D297D29292C746869732E6578656375746564285B22636F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(41314) := '6E2E637265617465222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E64656C657465222C22636F6E6E656374696F6E2E7265636F6E6E656374225D2C676D286129292C746869732E7265766572746564285B22636F6E6E65';
wwv_flow_imp.g_varchar2_table(41315) := '6374696F6E2E637265617465222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E64656C657465222C22636F6E6E656374696F6E2E7265636F6E6E656374225D2C676D286129292C746869732E6578656375746564285B2263';
wwv_flow_imp.g_varchar2_table(41316) := '6F6E6E656374696F6E2E6C61796F7574222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E757064617465576179706F696E7473225D2C676D286C29292C746869732E7265766572746564285B22636F6E6E656374696F6E2E';
wwv_flow_imp.g_varchar2_table(41317) := '6C61796F7574222C22636F6E6E656374696F6E2E6D6F7665222C22636F6E6E656374696F6E2E757064617465576179706F696E7473225D2C676D286C29292C746869732E65786563757465642822636F6E6E656374696F6E2E7265636F6E6E656374222C';
wwv_flow_imp.g_varchar2_table(41318) := '676D282866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E636F6E6E656374696F6E2C693D742E6F6C64536F757263652C6F3D742E6E6577536F757263652C733D28302C792E676574427573696E6573734F626A65637429';
wwv_flow_imp.g_varchar2_table(41319) := '286E292C723D28302C792E676574427573696E6573734F626A656374292869292C613D28302C792E676574427573696E6573734F626A65637429286F293B732E636F6E646974696F6E45787072657373696F6E26262128302C792E6973416E792928612C';
wwv_flow_imp.g_varchar2_table(41320) := '5B2262706D6E3A4163746976697479222C2262706D6E3A4578636C757369766547617465776179222C2262706D6E3A496E636C757369766547617465776179225D29262628742E6F6C64436F6E646974696F6E45787072657373696F6E3D732E636F6E64';
wwv_flow_imp.g_varchar2_table(41321) := '6974696F6E45787072657373696F6E2C64656C65746520732E636F6E646974696F6E45787072657373696F6E292C69213D3D6F2626722E64656661756C743D3D3D73262628742E6F6C6444656661756C743D722E64656661756C742C64656C6574652072';
wwv_flow_imp.g_varchar2_table(41322) := '2E64656661756C74297D2929292C746869732E72657665727465642822636F6E6E656374696F6E2E7265636F6E6E656374222C676D282866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E636F6E6E656374696F6E2C693D';
wwv_flow_imp.g_varchar2_table(41323) := '742E6F6C64536F757263652C6F3D742E6E6577536F757263652C733D28302C792E676574427573696E6573734F626A65637429286E292C723D28302C792E676574427573696E6573734F626A656374292869292C613D28302C792E676574427573696E65';
wwv_flow_imp.g_varchar2_table(41324) := '73734F626A65637429286F293B742E6F6C64436F6E646974696F6E45787072657373696F6E262628732E636F6E646974696F6E45787072657373696F6E3D742E6F6C64436F6E646974696F6E45787072657373696F6E292C742E6F6C6444656661756C74';
wwv_flow_imp.g_varchar2_table(41325) := '262628722E64656661756C743D742E6F6C6444656661756C742C64656C65746520612E64656661756C74297D2929292C746869732E6578656375746564285B22656C656D656E742E7570646174654174746163686D656E74225D2C676D286329292C7468';
wwv_flow_imp.g_varchar2_table(41326) := '69732E7265766572746564285B22656C656D656E742E7570646174654174746163686D656E74225D2C676D286329292C746869732E65786563757465642822656C656D656E742E7570646174654C6162656C222C676D286429292C746869732E72657665';
wwv_flow_imp.g_varchar2_table(41327) := '727465642822656C656D656E742E7570646174654C6162656C222C676D286429297D66756E6374696F6E20676D2865297B72657475726E2066756E6374696F6E2874297B766172206E3D742E636F6E746578742C693D6E2E73686170657C7C6E2E636F6E';
wwv_flow_imp.g_varchar2_table(41328) := '6E656374696F6E7C7C6E2E656C656D656E743B28302C792E69732928692C2262706D6E3A42617365456C656D656E7422292626652874297D7D66756E6374696F6E206D6D28652C74297B68692E63616C6C2874686973292C746869732E5F62706D6E4661';
wwv_flow_imp.g_varchar2_table(41329) := '63746F72793D652C746869732E5F6D6F64646C653D747D66756E6374696F6E20666D28652C742C6E297B72657475726E20766F696420303D3D3D745B6E5D3F743A28655B6E5D3D745B6E5D2C28302C692E634A2928742C5B6E5D29297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(41330) := '6E20766D28652C74297B746869732E5F6D6F64656C696E673D652C746869732E5F63616E7661733D747D66756E6374696F6E20626D2865297B746869732E5F6D6F64656C696E673D657D66756E6374696F6E205F6D28652C74297B746869732E5F63616E';
wwv_flow_imp.g_varchar2_table(41331) := '7661733D652C746869732E5F6C61796F757465723D747D756D2E24696E6A6563743D5B226D6F64646C65225D2C756D2E70726F746F747970652E5F6E6565647349643D66756E6374696F6E2865297B72657475726E28302C792E6973416E792928652C5B';
wwv_flow_imp.g_varchar2_table(41332) := '2262706D6E3A526F6F74456C656D656E74222C2262706D6E3A466C6F77456C656D656E74222C2262706D6E3A4D657373616765466C6F77222C2262706D6E3A446174614173736F63696174696F6E222C2262706D6E3A4172746966616374222C2262706D';
wwv_flow_imp.g_varchar2_table(41333) := '6E3A5061727469636970616E74222C2262706D6E3A4C616E65222C2262706D6E3A4C616E65536574222C2262706D6E3A50726F63657373222C2262706D6E3A436F6C6C61626F726174696F6E222C2262706D6E64693A42504D4E5368617065222C226270';
wwv_flow_imp.g_varchar2_table(41334) := '6D6E64693A42504D4E45646765222C2262706D6E64693A42504D4E4469616772616D222C2262706D6E64693A42504D4E506C616E65222C2262706D6E3A50726F7065727479222C2262706D6E3A43617465676F727956616C7565225D297D2C756D2E7072';
wwv_flow_imp.g_varchar2_table(41335) := '6F746F747970652E5F656E7375726549643D66756E6374696F6E2865297B76617220743B652E69643F746869732E5F6D6F64656C2E6964732E636C61696D28652E69642C65293A28743D28302C792E69732928652C2262706D6E3A416374697669747922';
wwv_flow_imp.g_varchar2_table(41336) := '293F224163746976697479223A28302C792E69732928652C2262706D6E3A4576656E7422293F224576656E74223A28302C792E69732928652C2262706D6E3A4761746577617922293F2247617465776179223A28302C792E6973416E792928652C5B2262';
wwv_flow_imp.g_varchar2_table(41337) := '706D6E3A53657175656E6365466C6F77222C2262706D6E3A4D657373616765466C6F77225D293F22466C6F77223A28652E24747970657C7C2222292E7265706C616365282F5E5B5E3A5D2A3A2F672C2222292C742B3D225F222C21652E69642626746869';
wwv_flow_imp.g_varchar2_table(41338) := '732E5F6E656564734964286529262628652E69643D746869732E5F6D6F64656C2E6964732E6E657874507265666978656428742C652929297D2C756D2E70726F746F747970652E6372656174653D66756E6374696F6E28652C74297B766172206E3D7468';
wwv_flow_imp.g_varchar2_table(41339) := '69732E5F6D6F64656C2E63726561746528652C747C7C7B7D293B72657475726E20746869732E5F656E737572654964286E292C6E7D2C756D2E70726F746F747970652E63726561746544694C6162656C3D66756E6374696F6E28297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(41340) := '6869732E637265617465282262706D6E64693A42504D4E4C6162656C222C7B626F756E64733A746869732E6372656174654469426F756E647328297D297D2C756D2E70726F746F747970652E637265617465446953686170653D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(41341) := '2C74297B72657475726E20746869732E637265617465282262706D6E64693A42504D4E5368617065222C28302C692E6B7029287B62706D6E456C656D656E743A652C626F756E64733A746869732E6372656174654469426F756E647328297D2C7429297D';
wwv_flow_imp.g_varchar2_table(41342) := '2C756D2E70726F746F747970652E6372656174654469426F756E64733D66756E6374696F6E2865297B72657475726E20746869732E637265617465282264633A426F756E6473222C65297D2C756D2E70726F746F747970652E6372656174654469576179';
wwv_flow_imp.g_varchar2_table(41343) := '706F696E74733D66756E6374696F6E2865297B76617220743D746869733B72657475726E28302C692E546A2928652C2866756E6374696F6E2865297B72657475726E20742E6372656174654469576179706F696E742865297D29297D2C756D2E70726F74';
wwv_flow_imp.g_varchar2_table(41344) := '6F747970652E6372656174654469576179706F696E743D66756E6374696F6E2865297B72657475726E20746869732E637265617465282264633A506F696E74222C28302C692E55702928652C5B2278222C2279225D29297D2C756D2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(41345) := '652E6372656174654469456467653D66756E6374696F6E28652C74297B72657475726E20746869732E637265617465282262706D6E64693A42504D4E45646765222C28302C692E6B7029287B62706D6E456C656D656E743A652C776179706F696E743A74';
wwv_flow_imp.g_varchar2_table(41346) := '6869732E6372656174654469576179706F696E7473285B5D297D2C7429297D2C756D2E70726F746F747970652E6372656174654469506C616E653D66756E6374696F6E28652C74297B72657475726E20746869732E637265617465282262706D6E64693A';
wwv_flow_imp.g_varchar2_table(41347) := '42504D4E506C616E65222C28302C692E6B7029287B62706D6E456C656D656E743A657D2C7429297D2C5228706D2C6572292C706D2E24696E6A6563743D5B226576656E74427573222C2262706D6E466163746F7279222C22636F6E6E656374696F6E446F';
wwv_flow_imp.g_varchar2_table(41348) := '636B696E67225D2C706D2E70726F746F747970652E7570646174654174746163686D656E743D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D742E627573696E6573734F626A6563742C693D742E686F73743B6E2E617474616368';
wwv_flow_imp.g_varchar2_table(41349) := '6564546F5265663D692626692E627573696E6573734F626A6563747D2C706D2E70726F746F747970652E757064617465506172656E743D66756E6374696F6E28652C74297B6966282128526E2865297C7C28302C792E69732928652C2262706D6E3A4461';
wwv_flow_imp.g_varchar2_table(41350) := '746153746F72655265666572656E636522292626652E706172656E74262628302C792E69732928652E706172656E742C2262706D6E3A436F6C6C61626F726174696F6E222929297B766172206E3D652E706172656E742C693D652E627573696E6573734F';
wwv_flow_imp.g_varchar2_table(41351) := '626A6563742C6F3D28302C792E6765744469292865292C733D6E26266E2E627573696E6573734F626A6563742C723D28302C792E676574446929286E293B28302C792E69732928652C2262706D6E3A466C6F774E6F646522292626746869732E75706461';
wwv_flow_imp.g_varchar2_table(41352) := '7465466C6F774E6F64655265667328692C732C742626742E627573696E6573734F626A656374292C28302C792E69732928652C2262706D6E3A446174614F75747075744173736F63696174696F6E2229262628733D652E736F757263653F652E736F7572';
wwv_flow_imp.g_varchar2_table(41353) := '63652E627573696E6573734F626A6563743A6E756C6C292C28302C792E69732928652C2262706D6E3A44617461496E7075744173736F63696174696F6E2229262628733D652E7461726765743F652E7461726765742E627573696E6573734F626A656374';
wwv_flow_imp.g_varchar2_table(41354) := '3A6E756C6C292C746869732E75706461746553656D616E746963506172656E7428692C73292C28302C792E69732928652C2262706D6E3A446174614F626A6563745265666572656E636522292626692E646174614F626A6563745265662626746869732E';
wwv_flow_imp.g_varchar2_table(41355) := '75706461746553656D616E746963506172656E7428692E646174614F626A6563745265662C73292C746869732E7570646174654469506172656E74286F2C72297D7D2C706D2E70726F746F747970652E757064617465426F756E64733D66756E6374696F';
wwv_flow_imp.g_varchar2_table(41356) := '6E2865297B76617220743D28302C792E6765744469292865292C6E3D66756E6374696F6E2865297B69662828302C792E69732928652C2262706D6E3A41637469766974792229297B76617220743D28302C792E6765744469292865293B69662874297B76';
wwv_flow_imp.g_varchar2_table(41357) := '6172206E3D742E67657428226C6162656C22293B6966286E2972657475726E206E2E6765742822626F756E647322297D7D7D2865293B6966286E297B766172206F3D7661286E2C742E6765742822626F756E64732229293B28302C692E6B7029286E2C7B';
wwv_flow_imp.g_varchar2_table(41358) := '783A652E782B6F2E782C793A652E792B6F2E797D297D76617220733D526E2865293F746869732E5F6765744C6162656C2874293A742C723D732E626F756E64733B727C7C28723D746869732E5F62706D6E466163746F72792E6372656174654469426F75';
wwv_flow_imp.g_varchar2_table(41359) := '6E647328292C732E7365742822626F756E6473222C7229292C28302C692E6B702928722C7B783A652E782C793A652E792C77696474683A652E77696474682C6865696768743A652E6865696768747D297D2C706D2E70726F746F747970652E7570646174';
wwv_flow_imp.g_varchar2_table(41360) := '65466C6F774E6F6465526566733D66756E6374696F6E28652C742C6E297B6E213D3D7426262828302C792E697329286E2C2262706D6E3A4C616E65222926265574286E2E6765742822666C6F774E6F646552656622292C65292C28302C792E6973292874';
wwv_flow_imp.g_varchar2_table(41361) := '2C2262706D6E3A4C616E65222926264B7428742E6765742822666C6F774E6F646552656622292C6529297D2C706D2E70726F746F747970652E7570646174654469436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E297B76617220693D2830';
wwv_flow_imp.g_varchar2_table(41362) := '2C792E6765744469292865292C6F3D28302C792E6765744469292874292C733D28302C792E676574446929286E293B692E736F75726365456C656D656E742626692E736F75726365456C656D656E742E62706D6E456C656D656E74213D3D28302C792E67';
wwv_flow_imp.g_varchar2_table(41363) := '6574427573696E6573734F626A65637429287429262628692E736F75726365456C656D656E743D7426266F292C692E746172676574456C656D656E742626692E746172676574456C656D656E742E62706D6E456C656D656E74213D3D28302C792E676574';
wwv_flow_imp.g_varchar2_table(41364) := '427573696E6573734F626A65637429286E29262628692E746172676574456C656D656E743D6E262673297D2C706D2E70726F746F747970652E7570646174654469506172656E743D66756E6374696F6E28652C74297B6966287426262128302C792E6973';
wwv_flow_imp.g_varchar2_table(41365) := '2928742C2262706D6E64693A42504D4E506C616E652229262628743D742E24706172656E74292C652E24706172656E74213D3D74297B766172206E3D28747C7C652E24706172656E74292E6765742822706C616E65456C656D656E7422293B743F286E2E';
wwv_flow_imp.g_varchar2_table(41366) := '707573682865292C652E24706172656E743D74293A285574286E2C65292C652E24706172656E743D6E756C6C297D7D2C706D2E70726F746F747970652E6765744C616E655365743D66756E6374696F6E2865297B76617220742C6E3B72657475726E2830';
wwv_flow_imp.g_varchar2_table(41367) := '2C792E69732928652C2262706D6E3A4C616E6522293F2828743D652E6368696C644C616E65536574297C7C28743D746869732E5F62706D6E466163746F72792E637265617465282262706D6E3A4C616E6553657422292C652E6368696C644C616E655365';
wwv_flow_imp.g_varchar2_table(41368) := '743D742C742E24706172656E743D65292C74293A2828302C792E69732928652C2262706D6E3A5061727469636970616E742229262628653D652E70726F63657373526566292C28743D286E3D652E67657428226C616E65536574732229295B305D297C7C';
wwv_flow_imp.g_varchar2_table(41369) := '2828743D746869732E5F62706D6E466163746F72792E637265617465282262706D6E3A4C616E655365742229292E24706172656E743D652C6E2E70757368287429292C74297D2C706D2E70726F746F747970652E75706461746553656D616E7469635061';
wwv_flow_imp.g_varchar2_table(41370) := '72656E743D66756E6374696F6E28652C742C6E297B76617220693B696628652E24706172656E74213D3D742626282128302C792E69732928652C2262706D6E3A44617461496E707574222926262128302C792E69732928652C2262706D6E3A446174614F';
wwv_flow_imp.g_varchar2_table(41371) := '757470757422297C7C2828302C792E69732928742C2262706D6E3A5061727469636970616E74222926262270726F6365737352656622696E2074262628743D742E70726F63657373526566292C212822696F53706563696669636174696F6E22696E2074';
wwv_flow_imp.g_varchar2_table(41372) := '297C7C742E696F53706563696669636174696F6E213D3D652E24706172656E742929297B69662828302C792E69732928652C2262706D6E3A4C616E6522292974262628743D746869732E6765744C616E65536574287429292C693D226C616E6573223B65';
wwv_flow_imp.g_varchar2_table(41373) := '6C73652069662828302C792E69732928652C2262706D6E3A466C6F77456C656D656E742229297B696628742969662828302C792E69732928742C2262706D6E3A5061727469636970616E74222929743D742E70726F636573735265663B656C7365206966';
wwv_flow_imp.g_varchar2_table(41374) := '2828302C792E69732928742C2262706D6E3A4C616E65222929646F7B743D742E24706172656E742E24706172656E747D7768696C652828302C792E69732928742C2262706D6E3A4C616E652229293B693D22666C6F77456C656D656E7473227D656C7365';
wwv_flow_imp.g_varchar2_table(41375) := '2069662828302C792E69732928652C2262706D6E3A41727469666163742229297B666F72283B7426262128302C792E69732928742C2262706D6E3A50726F63657373222926262128302C792E69732928742C2262706D6E3A53756250726F636573732229';
wwv_flow_imp.g_varchar2_table(41376) := '26262128302C792E69732928742C2262706D6E3A436F6C6C61626F726174696F6E22293B297B69662828302C792E69732928742C2262706D6E3A5061727469636970616E742229297B743D742E70726F636573735265663B627265616B7D743D742E2470';
wwv_flow_imp.g_varchar2_table(41377) := '6172656E747D693D22617274696661637473227D656C73652069662828302C792E69732928652C2262706D6E3A4D657373616765466C6F77222929693D226D657373616765466C6F7773223B656C73652069662828302C792E69732928652C2262706D6E';
wwv_flow_imp.g_varchar2_table(41378) := '3A5061727469636970616E742229297B693D227061727469636970616E7473223B766172206F2C733D652E70726F636573735265663B732626286F3D66756E6374696F6E2865297B666F72283B6526262128302C792E69732928652C2262706D6E3A4465';
wwv_flow_imp.g_varchar2_table(41379) := '66696E6974696F6E7322293B29653D652E24706172656E743B72657475726E20657D28652E24706172656E747C7C74292C652E24706172656E742626285574286F2E6765742822726F6F74456C656D656E747322292C73292C732E24706172656E743D6E';
wwv_flow_imp.g_varchar2_table(41380) := '756C6C292C742626284B74286F2E6765742822726F6F74456C656D656E747322292C73292C732E24706172656E743D6F29297D656C736528302C792E69732928652C2262706D6E3A446174614F75747075744173736F63696174696F6E22293F693D2264';
wwv_flow_imp.g_varchar2_table(41381) := '6174614F75747075744173736F63696174696F6E73223A28302C792E69732928652C2262706D6E3A44617461496E7075744173736F63696174696F6E2229262628693D2264617461496E7075744173736F63696174696F6E7322293B6966282169297468';
wwv_flow_imp.g_varchar2_table(41382) := '726F77206E6577204572726F7228606E6F20706172656E7420666F72203C247B652E69647D3E20696E203C247B742E69647D3E60293B76617220723B696628652E24706172656E742626557428723D652E24706172656E742E6765742869292C65292C74';
wwv_flow_imp.g_varchar2_table(41383) := '3F2828723D742E676574286929292E707573682865292C652E24706172656E743D74293A652E24706172656E743D6E756C6C2C6E297B76617220613D6E2E6765742869293B557428722C65292C74262628617C7C28613D5B5D2C742E73657428692C6129';
wwv_flow_imp.g_varchar2_table(41384) := '292C612E70757368286529297D7D7D2C706D2E70726F746F747970652E757064617465436F6E6E656374696F6E576179706F696E74733D66756E6374696F6E2865297B28302C792E6765744469292865292E7365742822776179706F696E74222C746869';
wwv_flow_imp.g_varchar2_table(41385) := '732E5F62706D6E466163746F72792E6372656174654469576179706F696E747328652E776179706F696E747329297D2C706D2E70726F746F747970652E757064617465436F6E6E656374696F6E3D66756E6374696F6E2865297B76617220742C6E3D652E';
wwv_flow_imp.g_varchar2_table(41386) := '636F6E6E656374696F6E2C693D28302C792E676574427573696E6573734F626A65637429286E292C6F3D6E2E736F757263652C733D28302C792E676574427573696E6573734F626A65637429286F292C723D6E2E7461726765742C613D28302C792E6765';
wwv_flow_imp.g_varchar2_table(41387) := '74427573696E6573734F626A65637429286E2E746172676574293B69662828302C792E69732928692C2262706D6E3A446174614173736F63696174696F6E22292928302C792E69732928692C2262706D6E3A44617461496E7075744173736F6369617469';
wwv_flow_imp.g_varchar2_table(41388) := '6F6E22293F28692E6765742822736F7572636552656622295B305D3D732C743D652E706172656E747C7C652E6E6577506172656E747C7C612C746869732E75706461746553656D616E746963506172656E7428692C612C7429293A28302C792E69732928';
wwv_flow_imp.g_varchar2_table(41389) := '692C2262706D6E3A446174614F75747075744173736F63696174696F6E2229262628743D652E706172656E747C7C652E6E6577506172656E747C7C732C746869732E75706461746553656D616E746963506172656E7428692C732C74292C692E74617267';
wwv_flow_imp.g_varchar2_table(41390) := '65745265663D61293B656C73657B766172206C3D28302C792E69732928692C2262706D6E3A53657175656E6365466C6F7722293B692E736F75726365526566213D3D732626286C262628557428692E736F757263655265662626692E736F757263655265';
wwv_flow_imp.g_varchar2_table(41391) := '662E67657428226F7574676F696E6722292C69292C732626732E67657428226F7574676F696E6722292626732E67657428226F7574676F696E6722292E70757368286929292C692E736F757263655265663D73292C692E746172676574526566213D3D61';
wwv_flow_imp.g_varchar2_table(41392) := '2626286C262628557428692E7461726765745265662626692E7461726765745265662E6765742822696E636F6D696E6722292C69292C612626612E6765742822696E636F6D696E6722292626612E6765742822696E636F6D696E6722292E707573682869';
wwv_flow_imp.g_varchar2_table(41393) := '29292C692E7461726765745265663D61297D746869732E757064617465436F6E6E656374696F6E576179706F696E7473286E292C746869732E7570646174654469436F6E6E656374696F6E286E2C6F2C72297D2C706D2E70726F746F747970652E5F6765';
wwv_flow_imp.g_varchar2_table(41394) := '744C6162656C3D66756E6374696F6E2865297B72657475726E20652E6C6162656C7C7C28652E6C6162656C3D746869732E5F62706D6E466163746F72792E63726561746544694C6162656C2829292C652E6C6162656C7D2C52286D6D2C6869292C6D6D2E';
wwv_flow_imp.g_varchar2_table(41395) := '24696E6A6563743D5B2262706D6E466163746F7279222C226D6F64646C65225D2C6D6D2E70726F746F747970652E5F626173654372656174653D68692E70726F746F747970652E6372656174652C6D6D2E70726F746F747970652E6372656174653D6675';
wwv_flow_imp.g_varchar2_table(41396) := '6E6374696F6E28652C74297B696628226C6162656C223D3D3D65297B766172206E3D742E64697C7C746869732E5F62706D6E466163746F72792E63726561746544694C6162656C28293B72657475726E20746869732E5F6261736543726561746528652C';
wwv_flow_imp.g_varchar2_table(41397) := '28302C692E6B7029287B747970653A226C6162656C222C64693A6E7D2C61732C7429297D72657475726E20746869732E637265617465456C656D656E7428652C74297D2C6D6D2E70726F746F747970652E637265617465456C656D656E743D66756E6374';
wwv_flow_imp.g_varchar2_table(41398) := '696F6E28652C74297B766172206E2C6F2C732C722C613D28743D28302C692E6B7029287B7D2C747C7C7B7D29292E627573696E6573734F626A6563742C6C3D742E64693B6966282161297B69662821742E74797065297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(41399) := '7228226E6F20736861706520747970652073706563696669656422293B576F28613D746869732E5F62706D6E466163746F72792E63726561746528742E7479706529297D6966286F3D6C2C2128302C792E6973416E7929286F2C5B2262706D6E64693A42';
wwv_flow_imp.g_varchar2_table(41400) := '504D4E5368617065222C2262706D6E64693A42504D4E45646765222C2262706D6E64693A42504D4E4469616772616D222C2262706D6E64693A42504D4E506C616E65225D29297B76617220633D28302C692E6B7029287B7D2C6C7C7C7B7D2C7B69643A61';
wwv_flow_imp.g_varchar2_table(41401) := '2E69642B225F6469227D293B6C3D22726F6F74223D3D3D653F746869732E5F62706D6E466163746F72792E6372656174654469506C616E6528612C63293A22636F6E6E656374696F6E223D3D3D653F746869732E5F62706D6E466163746F72792E637265';
wwv_flow_imp.g_varchar2_table(41402) := '61746544694564676528612C63293A746869732E5F62706D6E466163746F72792E6372656174654469536861706528612C63297D72657475726E28302C792E69732928612C2262706D6E3A47726F75702229262628743D28302C692E6B7029287B697346';
wwv_flow_imp.g_varchar2_table(41403) := '72616D653A21307D2C7429292C743D66756E6374696F6E28652C74297B72657475726E28302C692E6A4A29285B2270726F63657373526566222C226973496E74657272757074696E67222C226173736F63696174696F6E446972656374696F6E222C2269';
wwv_flow_imp.g_varchar2_table(41404) := '73466F72436F6D70656E736174696F6E225D2C2866756E6374696F6E286E297B743D666D28652C742C6E297D29292C747D28612C74292C742E6973457870616E646564262628743D666D286C2C742C226973457870616E6465642229292C28302C792E69';
wwv_flow_imp.g_varchar2_table(41405) := '73416E792928612C5B2262706D6E3A4C616E65222C2262706D6E3A5061727469636970616E74225D29262628743D666D286C2C742C226973486F72697A6F6E74616C2229292C28302C792E69732928612C2262706D6E3A53756250726F63657373222926';
wwv_flow_imp.g_varchar2_table(41406) := '2628742E636F6C6C61707365643D2128302C72732E41762928612C6C29292C28302C792E69732928612C2262706D6E3A4578636C757369766547617465776179222926262828302C692E7A7929286C2C2269734D61726B657256697369626C6522293F76';
wwv_flow_imp.g_varchar2_table(41407) := '6F696420303D3D3D6C2E69734D61726B657256697369626C652626286C2E69734D61726B657256697369626C653D2131293A6C2E69734D61726B657256697369626C653D2130292C28302C692E4F392928742E74726967676572656442794576656E7429';
wwv_flow_imp.g_varchar2_table(41408) := '262628612E74726967676572656442794576656E743D742E74726967676572656442794576656E742C64656C65746520742E74726967676572656442794576656E74292C28302C692E4F392928742E63616E63656C416374697669747929262628612E63';
wwv_flow_imp.g_varchar2_table(41409) := '616E63656C41637469766974793D742E63616E63656C41637469766974792C64656C65746520742E63616E63656C4163746976697479292C742E6576656E74446566696E6974696F6E54797065262628733D612E67657428226576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(41410) := '74696F6E7322297C7C5B5D2C723D746869732E5F62706D6E466163746F72792E63726561746528742E6576656E74446566696E6974696F6E547970652C742E6576656E74446566696E6974696F6E4174747273292C2262706D6E3A436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(41411) := '616C4576656E74446566696E6974696F6E223D3D3D742E6576656E74446566696E6974696F6E54797065262628722E636F6E646974696F6E3D746869732E5F62706D6E466163746F72792E637265617465282262706D6E3A466F726D616C457870726573';
wwv_flow_imp.g_varchar2_table(41412) := '73696F6E2229292C732E707573682872292C722E24706172656E743D612C612E6576656E74446566696E6974696F6E733D732C64656C65746520742E6576656E74446566696E6974696F6E54797065292C6E3D746869732E67657444656661756C745369';
wwv_flow_imp.g_varchar2_table(41413) := '7A6528612C6C292C743D28302C692E6B7029287B69643A612E69647D2C6E2C742C7B627573696E6573734F626A6563743A612C64693A6C7D292C746869732E5F6261736543726561746528652C74297D2C6D6D2E70726F746F747970652E676574446566';
wwv_flow_imp.g_varchar2_table(41414) := '61756C7453697A653D66756E6374696F6E28652C74297B766172206E3D28302C792E676574427573696E6573734F626A656374292865293B696628743D747C7C28302C792E6765744469292865292C28302C792E697329286E2C2262706D6E3A53756250';
wwv_flow_imp.g_varchar2_table(41415) := '726F6365737322292972657475726E28302C72732E417629286E2C74293F7B77696474683A3335302C6865696768743A3230307D3A7B77696474683A3130302C6865696768743A38307D3B69662828302C792E697329286E2C2262706D6E3A5461736B22';
wwv_flow_imp.g_varchar2_table(41416) := '292972657475726E7B77696474683A3130302C6865696768743A38307D3B69662828302C792E697329286E2C2262706D6E3A4761746577617922292972657475726E7B77696474683A35302C6865696768743A35307D3B69662828302C792E697329286E';
wwv_flow_imp.g_varchar2_table(41417) := '2C2262706D6E3A4576656E7422292972657475726E7B77696474683A33362C6865696768743A33367D3B69662828302C792E697329286E2C2262706D6E3A5061727469636970616E742229297B76617220693D766F696420303D3D3D742E6973486F7269';
wwv_flow_imp.g_varchar2_table(41418) := '7A6F6E74616C7C7C21303D3D3D742E6973486F72697A6F6E74616C3B72657475726E28302C72732E417629286E2C74293F693F7B77696474683A3630302C6865696768743A3235307D3A7B77696474683A3235302C6865696768743A3630307D3A693F7B';
wwv_flow_imp.g_varchar2_table(41419) := '77696474683A3430302C6865696768743A36307D3A7B77696474683A36302C6865696768743A3430307D7D72657475726E28302C792E697329286E2C2262706D6E3A4C616E6522293F7B77696474683A3430302C6865696768743A3130307D3A28302C79';
wwv_flow_imp.g_varchar2_table(41420) := '2E697329286E2C2262706D6E3A446174614F626A6563745265666572656E636522293F7B77696474683A33362C6865696768743A35307D3A28302C792E697329286E2C2262706D6E3A4461746153746F72655265666572656E636522293F7B7769647468';
wwv_flow_imp.g_varchar2_table(41421) := '3A35302C6865696768743A35307D3A28302C792E697329286E2C2262706D6E3A54657874416E6E6F746174696F6E22293F7B77696474683A3130302C6865696768743A33307D3A28302C792E697329286E2C2262706D6E3A47726F757022293F7B776964';
wwv_flow_imp.g_varchar2_table(41422) := '74683A3330302C6865696768743A3330307D3A7B77696474683A3130302C6865696768743A38307D7D2C6D6D2E70726F746F747970652E6372656174655061727469636970616E7453686170653D66756E6374696F6E2865297B72657475726E28302C69';
wwv_flow_imp.g_varchar2_table(41423) := '2E4776292865297C7C28653D7B6973457870616E6465643A657D292C2131213D3D28653D28302C692E6B7029287B747970653A2262706D6E3A5061727469636970616E74227D2C657C7C7B7D29292E6973457870616E646564262628652E70726F636573';
wwv_flow_imp.g_varchar2_table(41424) := '735265663D746869732E5F62706D6E466163746F72792E637265617465282262706D6E3A50726F636573732229292C746869732E63726561746553686170652865297D2C766D2E24696E6A6563743D5B226D6F64656C696E67222C2263616E766173225D';
wwv_flow_imp.g_varchar2_table(41425) := '2C766D2E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D652E656C656D656E74732C6F3D652E616C69676E6D656E743B28302C692E6A4A29286E2C2866756E';
wwv_flow_imp.g_varchar2_table(41426) := '6374696F6E2865297B766172206E3D7B783A302C793A307D3B28302C692E4F3929286F2E6C656674293F6E2E783D6F2E6C6566742D652E783A28302C692E4F3929286F2E7269676874293F6E2E783D6F2E72696768742D652E77696474682D652E783A28';
wwv_flow_imp.g_varchar2_table(41427) := '302C692E4F3929286F2E63656E746572293F6E2E783D6F2E63656E7465722D4D6174682E726F756E6428652E77696474682F32292D652E783A28302C692E4F3929286F2E746F70293F6E2E793D6F2E746F702D652E793A28302C692E4F3929286F2E626F';
wwv_flow_imp.g_varchar2_table(41428) := '74746F6D293F6E2E793D6F2E626F74746F6D2D652E6865696768742D652E793A28302C692E4F3929286F2E6D6964646C65292626286E2E793D6F2E6D6964646C652D4D6174682E726F756E6428652E6865696768742F32292D652E79292C742E6D6F7665';
wwv_flow_imp.g_varchar2_table(41429) := '456C656D656E7473285B655D2C6E2C652E706172656E74297D29297D2C766D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B7D2C626D2E24696E6A6563743D5B226D6F64656C696E67225D2C626D2E70726F746F';
wwv_flow_imp.g_varchar2_table(41430) := '747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D652E736F757263653B6966282174297468726F77206E6577204572726F722822736F7572636520726571756972656422293B766172206E3D652E7461726765747C7C';
wwv_flow_imp.g_varchar2_table(41431) := '742E706172656E742C693D652E73686170652C6F3D652E68696E74737C7C7B7D3B693D652E73686170653D746869732E5F6D6F64656C696E672E637265617465536861706528692C652E706F736974696F6E2C6E2C7B6174746163683A6F2E6174746163';
wwv_flow_imp.g_varchar2_table(41432) := '687D292C652E73686170653D697D2C626D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220742C6E2C6F3D652E68696E74737C7C7B7D3B743D652E736F757263652C6E3D652E73686170652C28302C692E';
wwv_flow_imp.g_varchar2_table(41433) := '7A4E2928742E6F7574676F696E672C2866756E6374696F6E2865297B72657475726E20652E7461726765743D3D3D6E7D29297C7C286F2E636F6E6E656374696F6E5461726765743D3D3D652E736F757263653F746869732E5F6D6F64656C696E672E636F';
wwv_flow_imp.g_varchar2_table(41434) := '6E6E65637428652E73686170652C652E736F757263652C652E636F6E6E656374696F6E293A746869732E5F6D6F64656C696E672E636F6E6E65637428652E736F757263652C652E73686170652C652E636F6E6E656374696F6E29297D2C5F6D2E24696E6A';
wwv_flow_imp.g_varchar2_table(41435) := '6563743D5B2263616E766173222C226C61796F75746572225D2C5F6D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D652E736F757263652C693D652E7461726765742C';
wwv_flow_imp.g_varchar2_table(41436) := '6F3D652E706172656E742C733D652E706172656E74496E6465782C723D652E68696E74733B696628216E7C7C2169297468726F77206E6577204572726F722822736F7572636520616E642074617267657420726571756972656422293B696628216F2974';
wwv_flow_imp.g_varchar2_table(41437) := '68726F77206E6577204572726F722822706172656E7420726571756972656422293B72657475726E20742E736F757263653D6E2C742E7461726765743D692C742E776179706F696E74737C7C28742E776179706F696E74733D746869732E5F6C61796F75';
wwv_flow_imp.g_varchar2_table(41438) := '7465722E6C61796F7574436F6E6E656374696F6E28742C7229292C746869732E5F63616E7661732E616464436F6E6E656374696F6E28742C6F2C73292C747D2C5F6D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(41439) := '743D652E636F6E6E656374696F6E3B72657475726E20746869732E5F63616E7661732E72656D6F7665436F6E6E656374696F6E2874292C742E736F757263653D6E756C6C2C742E7461726765743D6E756C6C2C747D3B76617220796D3D4D6174682E726F';
wwv_flow_imp.g_varchar2_table(41440) := '756E643B66756E6374696F6E20776D2865297B746869732E5F6D6F64656C696E673D657D776D2E24696E6A6563743D5B226D6F64656C696E67225D2C776D2E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(41441) := '743D652E656C656D656E74732C6E3D652E706172656E742C6F3D652E706172656E74496E6465782C733D652E706F736974696F6E2C723D652E68696E74732C613D746869732E5F6D6F64656C696E673B28302C692E6A4A2928742C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(41442) := '2865297B28302C692E45742928652E78297C7C28652E783D30292C28302C692E45742928652E79297C7C28652E793D30297D29293B766172206C3D63742828302C692E70622928742C2866756E6374696F6E2865297B72657475726E21652E6869646465';
wwv_flow_imp.g_varchar2_table(41443) := '6E7D2929293B28302C692E6A4A2928742C2866756E6374696F6E2865297B4F6E286529262628652E776179706F696E74733D28302C692E546A2928652E776179706F696E74732C2866756E6374696F6E2865297B72657475726E7B783A796D28652E782D';
wwv_flow_imp.g_varchar2_table(41444) := '6C2E782D6C2E77696474682F322B732E78292C793A796D28652E792D6C2E792D6C2E6865696768742F322B732E79297D7D2929292C28302C692E6B702928652C7B783A796D28652E782D6C2E782D6C2E77696474682F322B732E78292C793A796D28652E';
wwv_flow_imp.g_varchar2_table(41445) := '792D6C2E792D6C2E6865696768742F322B732E79297D297D29293B76617220633D6F742874292C643D7B7D3B28302C692E6A4A2928742C2866756E6374696F6E2865297B6966284F6E28652929645B652E69645D3D28302C692E457429286F293F612E63';
wwv_flow_imp.g_varchar2_table(41446) := '7265617465436F6E6E656374696F6E28645B652E736F757263652E69645D2C645B652E7461726765742E69645D2C6F2C652C652E706172656E747C7C6E2C72293A612E637265617465436F6E6E656374696F6E28645B652E736F757263652E69645D2C64';
wwv_flow_imp.g_varchar2_table(41447) := '5B652E7461726765742E69645D2C652C652E706172656E747C7C6E2C72293B656C73657B76617220743D28302C692E6B7029287B7D2C72293B2D313D3D3D632E696E6465784F66286529262628742E6175746F526573697A653D2131292C526E28652926';
wwv_flow_imp.g_varchar2_table(41448) := '2628743D28302C692E634A2928742C5B22617474616368225D29292C645B652E69645D3D28302C692E457429286F293F612E637265617465536861706528652C28302C692E55702928652C5B2278222C2279222C227769647468222C2268656967687422';
wwv_flow_imp.g_varchar2_table(41449) := '5D292C652E706172656E747C7C6E2C6F2C74293A612E637265617465536861706528652C28302C692E55702928652C5B2278222C2279222C227769647468222C22686569676874225D292C652E706172656E747C7C6E2C74297D7D29292C652E656C656D';
wwv_flow_imp.g_varchar2_table(41450) := '656E74733D28302C692E7A75292864297D3B76617220436D3D4D6174682E726F756E643B66756E6374696F6E20536D2865297B746869732E5F63616E7661733D657D66756E6374696F6E20786D2865297B536D2E63616C6C28746869732C65297D536D2E';
wwv_flow_imp.g_varchar2_table(41451) := '24696E6A6563743D5B2263616E766173225D2C536D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D652E706F736974696F6E2C6F3D652E706172656E742C733D652E706172656E74';
wwv_flow_imp.g_varchar2_table(41452) := '496E6465783B696628216F297468726F77206E6577204572726F722822706172656E7420726571756972656422293B696628216E297468726F77206E6577204572726F722822706F736974696F6E20726571756972656422293B72657475726E20766F69';
wwv_flow_imp.g_varchar2_table(41453) := '642030213D3D6E2E77696474683F28302C692E6B702928742C6E293A28302C692E6B702928742C7B783A6E2E782D436D28742E77696474682F32292C793A6E2E792D436D28742E6865696768742F32297D292C746869732E5F63616E7661732E61646453';
wwv_flow_imp.g_varchar2_table(41454) := '6861706528742C6F2C73292C747D2C536D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E73686170653B72657475726E20746869732E5F63616E7661732E72656D6F766553686170652874292C747D2C52';
wwv_flow_imp.g_varchar2_table(41455) := '28786D2C536D292C786D2E24696E6A6563743D5B2263616E766173225D3B766172206B6D3D536D2E70726F746F747970652E657865637574653B786D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E73';
wwv_flow_imp.g_varchar2_table(41456) := '686170653B72657475726E2066756E6374696F6E2865297B5B227769647468222C22686569676874225D2E666F7245616368282866756E6374696F6E2874297B766F696420303D3D3D655B745D262628655B745D3D30297D29297D2874292C742E6C6162';
wwv_flow_imp.g_varchar2_table(41457) := '656C5461726765743D652E6C6162656C5461726765742C6B6D2E63616C6C28746869732C65297D3B76617220456D3D536D2E70726F746F747970652E7265766572743B66756E6374696F6E204C6D28652C74297B746869732E5F63616E7661733D652C74';
wwv_flow_imp.g_varchar2_table(41458) := '6869732E5F6D6F64656C696E673D747D66756E6374696F6E20446D28652C74297B746869732E5F6D6F64656C696E673D652C746869732E5F656C656D656E7452656769737472793D747D66756E6374696F6E20546D28652C74297B746869732E5F63616E';
wwv_flow_imp.g_varchar2_table(41459) := '7661733D652C746869732E5F6D6F64656C696E673D747D66756E6374696F6E20496D2865297B746869732E5F6D6F64656C696E673D657D786D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B72657475726E20652E73686170';
wwv_flow_imp.g_varchar2_table(41460) := '652E6C6162656C5461726765743D6E756C6C2C456D2E63616C6C28746869732C65297D2C4C6D2E24696E6A6563743D5B2263616E766173222C226D6F64656C696E67225D2C4C6D2E70726F746F747970652E707265457865637574653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(41461) := '6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D652E636F6E6E656374696F6E3B6F6D286E2E696E636F6D696E672C2866756E6374696F6E2865297B742E72656D6F7665436F6E6E656374696F6E28652C7B6E65737465643A21307D';
wwv_flow_imp.g_varchar2_table(41462) := '297D29292C6F6D286E2E6F7574676F696E672C2866756E6374696F6E2865297B742E72656D6F7665436F6E6E656374696F6E28652C7B6E65737465643A21307D297D29297D2C4C6D2E70726F746F747970652E657865637574653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41463) := '65297B76617220743D652E636F6E6E656374696F6E2C6E3D742E706172656E743B72657475726E20652E706172656E743D6E2C652E706172656E74496E6465783D4774286E2E6368696C6472656E2C74292C652E736F757263653D742E736F757263652C';
wwv_flow_imp.g_varchar2_table(41464) := '652E7461726765743D742E7461726765742C746869732E5F63616E7661732E72656D6F7665436F6E6E656374696F6E2874292C742E736F757263653D6E756C6C2C742E7461726765743D6E756C6C2C747D2C4C6D2E70726F746F747970652E7265766572';
wwv_flow_imp.g_varchar2_table(41465) := '743D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D652E706172656E742C693D652E706172656E74496E6465783B72657475726E20742E736F757263653D652E736F757263652C742E7461726765743D652E74617267';
wwv_flow_imp.g_varchar2_table(41466) := '65742C4B74286E2E6368696C6472656E2C742C69292C746869732E5F63616E7661732E616464436F6E6E656374696F6E28742C6E292C747D2C446D2E24696E6A6563743D5B226D6F64656C696E67222C22656C656D656E745265676973747279225D2C44';
wwv_flow_imp.g_varchar2_table(41467) := '6D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D746869732E5F656C656D656E7452656769737472792C6F3D652E656C656D656E74733B28302C692E6A';
wwv_flow_imp.g_varchar2_table(41468) := '4A29286F2C2866756E6374696F6E2865297B6E2E67657428652E696429262628652E776179706F696E74733F742E72656D6F7665436F6E6E656374696F6E2865293A742E72656D6F76655368617065286529297D29297D2C546D2E24696E6A6563743D5B';
wwv_flow_imp.g_varchar2_table(41469) := '2263616E766173222C226D6F64656C696E67225D2C546D2E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D652E73686170653B6F6D286E2E696E636F6D696E';
wwv_flow_imp.g_varchar2_table(41470) := '672C2866756E6374696F6E2865297B742E72656D6F7665436F6E6E656374696F6E28652C7B6E65737465643A21307D297D29292C6F6D286E2E6F7574676F696E672C2866756E6374696F6E2865297B742E72656D6F7665436F6E6E656374696F6E28652C';
wwv_flow_imp.g_varchar2_table(41471) := '7B6E65737465643A21307D297D29292C6F6D286E2E6368696C6472656E2C2866756E6374696F6E2865297B4F6E2865293F742E72656D6F7665436F6E6E656374696F6E28652C7B6E65737465643A21307D293A742E72656D6F7665536861706528652C7B';
wwv_flow_imp.g_varchar2_table(41472) := '6E65737465643A21307D297D29297D2C546D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732C6E3D652E73686170652C693D6E2E706172656E743B72657475726E20652E6F6C';
wwv_flow_imp.g_varchar2_table(41473) := '64506172656E743D692C652E6F6C64506172656E74496E6465783D477428692E6368696C6472656E2C6E292C742E72656D6F76655368617065286E292C6E7D2C546D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(41474) := '743D746869732E5F63616E7661732C6E3D652E73686170652C693D652E6F6C64506172656E742C6F3D652E6F6C64506172656E74496E6465783B72657475726E204B7428692E6368696C6472656E2C6E2C6F292C742E6164645368617065286E2C69292C';
wwv_flow_imp.g_varchar2_table(41475) := '6E7D2C496D2E24696E6A6563743D5B226D6F64656C696E67225D3B766172204D6D3D7B783A2279222C793A2278227D3B66756E6374696F6E20416D28652C74297B746869732E5F6C61796F757465723D652C746869732E5F63616E7661733D747D66756E';
wwv_flow_imp.g_varchar2_table(41476) := '6374696F6E204E6D28297B7D66756E6374696F6E20506D28297B746869732E616C6C5368617065733D7B7D2C746869732E616C6C436F6E6E656374696F6E733D7B7D2C746869732E656E636C6F736564456C656D656E74733D7B7D2C746869732E656E63';
wwv_flow_imp.g_varchar2_table(41477) := '6C6F736564436F6E6E656374696F6E733D7B7D2C746869732E746F704C6576656C3D7B7D7D66756E6374696F6E204F6D2865297B746869732E5F6D6F64656C696E673D657D66756E6374696F6E20526D2865297B746869732E5F68656C7065723D6E6577';
wwv_flow_imp.g_varchar2_table(41478) := '204F6D2865297D66756E6374696F6E20466D2865297B746869732E5F6D6F64656C696E673D652C746869732E5F68656C7065723D6E6577204F6D2865297D66756E6374696F6E20426D2865297B746869732E5F6D6F64656C696E673D657D66756E637469';
wwv_flow_imp.g_varchar2_table(41479) := '6F6E20566D2865297B72657475726E20652E6F726967696E616C7C7C657D66756E6374696F6E207A6D28652C74297B746869732E5F6D6F64656C696E673D652C746869732E5F72756C65733D747D66756E6374696F6E20486D2865297B746869732E5F6D';
wwv_flow_imp.g_varchar2_table(41480) := '6F64656C696E673D657D66756E6374696F6E20576D2865297B746869732E5F6D6F64656C696E673D657D66756E6374696F6E206A6D2865297B72657475726E28302C692E6B7029287B7D2C65297D66756E6374696F6E20716D2865297B73776974636828';
wwv_flow_imp.g_varchar2_table(41481) := '65297B63617365226E223A636173652273223A72657475726E2279223B636173652277223A636173652265223A72657475726E2278227D7D66756E6374696F6E20246D28652C742C6E297B76617220693D716D286E293B72657475726E2F657C732F2E74';
wwv_flow_imp.g_varchar2_table(41482) := '657374286E293F655B695D3E743A2F6E7C772F2E74657374286E293F655B695D3C743A766F696420307D66756E6374696F6E20556D28652C74297B72657475726E2D31213D3D652E696E6465784F662874297D66756E6374696F6E204B6D2865297B7468';
wwv_flow_imp.g_varchar2_table(41483) := '69732E5F6D6F64656C696E673D657D66756E6374696F6E20476D2865297B76617220743D7B7D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B745B652E69645D3D652E68696464656E2C652E6368696C6472656E26262874';
wwv_flow_imp.g_varchar2_table(41484) := '3D28302C692E6B7029287B7D2C742C476D28652E6368696C6472656E2929297D29292C747D66756E6374696F6E20516D28652C74297B766172206E3D5B5D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B652E6869646465';
wwv_flow_imp.g_varchar2_table(41485) := '6E3D742C6E3D6E2E636F6E6361742865292C652E6368696C6472656E2626286E3D6E2E636F6E63617428516D28652E6368696C6472656E2C652E636F6C6C61707365647C7C742929297D29292C6E7D66756E6374696F6E20596D28652C74297B76617220';
wwv_flow_imp.g_varchar2_table(41486) := '6E3D5B5D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B652E68696464656E3D745B652E69645D2C6E3D6E2E636F6E6361742865292C652E6368696C6472656E2626286E3D6E2E636F6E63617428596D28652E6368696C64';
wwv_flow_imp.g_varchar2_table(41487) := '72656E2C742929297D29292C6E7D66756E6374696F6E205A6D2865297B746869732E5F6D6F64656C696E673D657D66756E6374696F6E20586D28652C74297B72657475726E20557428652626652E6174746163686572732C74297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(41488) := '4A6D28652C742C6E297B69662865297B76617220693D652E6174746163686572733B697C7C28652E6174746163686572733D693D5B5D292C4B7428692C742C6E297D7D66756E6374696F6E20656628297B7D66756E6374696F6E20746628652C742C6E29';
wwv_flow_imp.g_varchar2_table(41489) := '7B746869732E5F6576656E744275733D652C746869732E5F656C656D656E74466163746F72793D742C746869732E5F636F6D6D616E64537461636B3D6E3B76617220693D746869733B652E6F6E28226469616772616D2E696E6974222C2866756E637469';
wwv_flow_imp.g_varchar2_table(41490) := '6F6E28297B692E726567697374657248616E646C657273286E297D29297D66756E6374696F6E206E662865297B746869732E5F656C656D656E7452656769737472793D657D66756E6374696F6E206F6628652C74297B28302C692E6A4A2928742C286675';
wwv_flow_imp.g_varchar2_table(41491) := '6E6374696F6E28742C6E297B652E736574286E2C74297D29297D496D2E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D652E67726F7570732C6F3D652E6178';
wwv_flow_imp.g_varchar2_table(41492) := '69732C733D652E64696D656E73696F6E3B66756E6374696F6E207228652C74297B652E72616E67652E6D696E3D4D6174682E6D696E28745B6F5D2C652E72616E67652E6D696E292C652E72616E67652E6D61783D4D6174682E6D617828745B6F5D2B745B';
wwv_flow_imp.g_varchar2_table(41493) := '735D2C652E72616E67652E6D6178297D66756E6374696F6E20612865297B72657475726E20655B6F5D2B655B735D2F327D66756E6374696F6E206C2865297B72657475726E20652E6C656E6774682D317D66756E6374696F6E20632865297B7265747572';
wwv_flow_imp.g_varchar2_table(41494) := '6E20652E6D61782D652E6D696E7D76617220642C682C753D6E5B305D2C703D6C286E292C673D6E5B705D2C6D3D303B28302C692E6A4A29286E2C2866756E6374696F6E28652C64297B76617220682C752C673B652E656C656D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(41495) := '3C323F64262664213D3D6E2E6C656E6774682D312626287228652C652E656C656D656E74735B305D292C6D2B3D6328652E72616E676529293A28753D28683D28302C692E556C2928652E656C656D656E74732C6F29295B305D2C643D3D3D70262628753D';
wwv_flow_imp.g_varchar2_table(41496) := '685B6C2868295D292C673D612875292C652E72616E67653D6E756C6C2C28302C692E6A4A2928682C2866756E6374696F6E286E297B2166756E6374696F6E28652C6E297B76617220693D7B793A307D3B695B6F5D3D652D61286E292C695B6F5D26262869';
wwv_flow_imp.g_varchar2_table(41497) := '5B4D6D5B6F5D5D3D302C742E6D6F7665456C656D656E7473285B6E5D2C692C6E2E706172656E7429297D28672C6E292C6E756C6C213D3D652E72616E67653F7228652C6E293A652E72616E67653D7B6D696E3A6E5B6F5D2C6D61783A6E5B6F5D2B6E5B73';
wwv_flow_imp.g_varchar2_table(41498) := '5D7D7D29292C64262664213D3D6E2E6C656E6774682D312626286D2B3D6328652E72616E67652929297D29292C683D4D6174682E61627328672E72616E67652E6D696E2D752E72616E67652E6D6178292C28643D4D6174682E726F756E642828682D6D29';
wwv_flow_imp.g_varchar2_table(41499) := '2F286E2E6C656E6774682D312929293C6E2E6C656E6774682D317C7C28302C692E6A4A29286E2C2866756E6374696F6E28652C72297B76617220612C6C3D7B7D3B65213D3D75262665213D3D67262628613D6E5B722D315D2C652E72616E67652E6D6178';
wwv_flow_imp.g_varchar2_table(41500) := '3D302C28302C692E6A4A2928652E656C656D656E74732C2866756E6374696F6E286E2C69297B6C5B4D6D5B6F5D5D3D302C6C5B6F5D3D612E72616E67652E6D61782D6E5B6F5D2B642C652E72616E67652E6D696E213D3D6E5B6F5D2626286C5B6F5D2B3D';
wwv_flow_imp.g_varchar2_table(41501) := '6E5B6F5D2D652E72616E67652E6D696E292C6C5B6F5D2626742E6D6F7665456C656D656E7473285B6E5D2C6C2C6E2E706172656E74292C652E72616E67652E6D61783D4D6174682E6D6178286E5B6F5D2B6E5B735D2C693F652E72616E67652E6D61783A';
wwv_flow_imp.g_varchar2_table(41502) := '30297D2929297D29297D2C496D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B7D2C416D2E24696E6A6563743D5B226C61796F75746572222C2263616E766173225D2C416D2E70726F746F747970652E65786563';
wwv_flow_imp.g_varchar2_table(41503) := '7574653D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D742E776179706F696E74733B72657475726E28302C692E6B702928652C7B6F6C64576179706F696E74733A6E7D292C742E776179706F696E74733D74686973';
wwv_flow_imp.g_varchar2_table(41504) := '2E5F6C61796F757465722E6C61796F7574436F6E6E656374696F6E28742C652E68696E7473292C747D2C416D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E3B72657475726E20';
wwv_flow_imp.g_varchar2_table(41505) := '742E776179706F696E74733D652E6F6C64576179706F696E74732C747D2C4E6D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D652E64656C74612C6F3D652E6E657750';
wwv_flow_imp.g_varchar2_table(41506) := '6172656E747C7C742E706172656E742C733D652E6E6577506172656E74496E6465782C723D742E706172656E743B72657475726E20652E6F6C64506172656E743D722C652E6F6C64506172656E74496E6465783D557428722E6368696C6472656E2C7429';
wwv_flow_imp.g_varchar2_table(41507) := '2C4B74286F2E6368696C6472656E2C742C73292C742E706172656E743D6F2C28302C692E6A4A2928742E776179706F696E74732C2866756E6374696F6E2865297B652E782B3D6E2E782C652E792B3D6E2E792C652E6F726967696E616C262628652E6F72';
wwv_flow_imp.g_varchar2_table(41508) := '6967696E616C2E782B3D6E2E782C652E6F726967696E616C2E792B3D6E2E79297D29292C747D2C4E6D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D742E706172656E74';
wwv_flow_imp.g_varchar2_table(41509) := '2C6F3D652E6F6C64506172656E742C733D652E6F6C64506172656E74496E6465782C723D652E64656C74613B72657475726E205574286E2E6368696C6472656E2C74292C4B74286F2E6368696C6472656E2C742C73292C742E706172656E743D6F2C2830';
wwv_flow_imp.g_varchar2_table(41510) := '2C692E6A4A2928742E776179706F696E74732C2866756E6374696F6E2865297B652E782D3D722E782C652E792D3D722E792C652E6F726967696E616C262628652E6F726967696E616C2E782D3D722E782C652E6F726967696E616C2E792D3D722E79297D';
wwv_flow_imp.g_varchar2_table(41511) := '29292C747D2C506D2E70726F746F747970652E6164643D66756E6374696F6E28652C74297B72657475726E20746869732E616464416C6C285B655D2C74297D2C506D2E70726F746F747970652E616464416C6C3D66756E6374696F6E28652C74297B7661';
wwv_flow_imp.g_varchar2_table(41512) := '72206E3D66756E6374696F6E28652C742C6E297B28302C692E623029287429262628743D2130292C28302C692E4776292874292626286E3D742C743D2130293B766172206F3D757428286E3D6E7C7C7B7D292E616C6C536861706573292C733D7574286E';
wwv_flow_imp.g_varchar2_table(41513) := '2E616C6C436F6E6E656374696F6E73292C723D7574286E2E656E636C6F736564456C656D656E7473292C613D7574286E2E656E636C6F736564436F6E6E656374696F6E73292C6C3D7574286E2E746F704C6576656C2C74262628302C692E247A2928652C';
wwv_flow_imp.g_varchar2_table(41514) := '2866756E6374696F6E2865297B72657475726E20652E69647D2929293B66756E6374696F6E20632865297B6C5B652E736F757263652E69645D26266C5B652E7461726765742E69645D2626286C5B652E69645D3D5B655D292C6F5B652E736F757263652E';
wwv_flow_imp.g_varchar2_table(41515) := '69645D26266F5B652E7461726765742E69645D262628615B652E69645D3D725B652E69645D3D65292C735B652E69645D3D657D72657475726E20617428652C2866756E6374696F6E2865297B696628725B652E69645D3D652C21652E776179706F696E74';
wwv_flow_imp.g_varchar2_table(41516) := '732972657475726E206F5B652E69645D3D652C28302C692E6A4A2928652E696E636F6D696E672C63292C28302C692E6A4A2928652E6F7574676F696E672C63292C652E6368696C6472656E3B615B652E69645D3D735B652E69645D3D657D29292C7B616C';
wwv_flow_imp.g_varchar2_table(41517) := '6C5368617065733A6F2C616C6C436F6E6E656374696F6E733A732C746F704C6576656C3A6C2C656E636C6F736564436F6E6E656374696F6E733A612C656E636C6F736564456C656D656E74733A727D7D28652C2121742C74686973293B72657475726E28';
wwv_flow_imp.g_varchar2_table(41518) := '302C692E6B702928746869732C6E292C746869737D2C4F6D2E70726F746F747970652E6D6F76655265637572736976653D66756E6374696F6E28652C742C6E297B72657475726E20653F746869732E6D6F7665436C6F7375726528746869732E67657443';
wwv_flow_imp.g_varchar2_table(41519) := '6C6F737572652865292C742C6E293A5B5D7D2C4F6D2E70726F746F747970652E6D6F7665436C6F737572653D66756E6374696F6E28652C742C6E2C6F2C73297B76617220723D746869732E5F6D6F64656C696E672C613D652E616C6C5368617065732C6C';
wwv_flow_imp.g_varchar2_table(41520) := '3D652E616C6C436F6E6E656374696F6E732C633D652E656E636C6F736564436F6E6E656374696F6E732C643D652E746F704C6576656C2C683D21313B732626732E706172656E743D3D3D6E262628683D2130292C28302C692E6A4A2928612C2866756E63';
wwv_flow_imp.g_varchar2_table(41521) := '74696F6E2865297B722E6D6F7665536861706528652C742C645B652E69645D2626216826266E2C7B726563757273653A21312C6C61796F75743A21317D297D29292C28302C692E6A4A29286C2C2866756E6374696F6E2865297B76617220693D2121615B';
wwv_flow_imp.g_varchar2_table(41522) := '652E736F757263652E69645D2C6F3D2121615B652E7461726765742E69645D3B635B652E69645D26266926266F3F722E6D6F7665436F6E6E656374696F6E28652C742C645B652E69645D2626216826266E293A722E6C61796F7574436F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(41523) := '6E28652C7B636F6E6E656374696F6E53746172743A692626437528652C652E736F757263652C74292C636F6E6E656374696F6E456E643A6F2626537528652C652E7461726765742C74297D297D29297D2C4F6D2E70726F746F747970652E676574436C6F';
wwv_flow_imp.g_varchar2_table(41524) := '737572653D66756E6374696F6E2865297B72657475726E286E657720506D292E616464416C6C28652C2130297D2C526D2E24696E6A6563743D5B226D6F64656C696E67225D2C526D2E70726F746F747970652E707265457865637574653D66756E637469';
wwv_flow_imp.g_varchar2_table(41525) := '6F6E2865297B652E636C6F737572653D746869732E5F68656C7065722E676574436C6F7375726528652E736861706573297D2C526D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220742C6E3D652E6869';
wwv_flow_imp.g_varchar2_table(41526) := '6E74733B6E26266E2E7072696D6172795368617065262628743D6E2E7072696D61727953686170652C6E2E6F6C64506172656E743D742E706172656E74292C746869732E5F68656C7065722E6D6F7665436C6F7375726528652E636C6F737572652C652E';
wwv_flow_imp.g_varchar2_table(41527) := '64656C74612C652E6E6577506172656E742C652E6E6577486F73742C74297D2C466D2E24696E6A6563743D5B226D6F64656C696E67225D2C466D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E736861';
wwv_flow_imp.g_varchar2_table(41528) := '70652C6E3D652E64656C74612C6F3D652E6E6577506172656E747C7C742E706172656E742C733D652E6E6577506172656E74496E6465782C723D742E706172656E743B72657475726E20652E6F6C64426F756E64733D28302C692E55702928742C5B2278';
wwv_flow_imp.g_varchar2_table(41529) := '222C2279222C227769647468222C22686569676874225D292C652E6F6C64506172656E743D722C652E6F6C64506172656E74496E6465783D557428722E6368696C6472656E2C74292C4B74286F2E6368696C6472656E2C742C73292C28302C692E6B7029';
wwv_flow_imp.g_varchar2_table(41530) := '28742C7B706172656E743A6F2C783A742E782B6E2E782C793A742E792B6E2E797D292C747D2C466D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D652E64656C74612C6F';
wwv_flow_imp.g_varchar2_table(41531) := '3D652E68696E74732C733D746869732E5F6D6F64656C696E673B2131213D3D6F2E6C61796F757426262828302C692E6A4A2928742E696E636F6D696E672C2866756E6374696F6E2865297B732E6C61796F7574436F6E6E656374696F6E28652C7B636F6E';
wwv_flow_imp.g_varchar2_table(41532) := '6E656374696F6E456E643A537528652C742C6E297D297D29292C28302C692E6A4A2928742E6F7574676F696E672C2866756E6374696F6E2865297B732E6C61796F7574436F6E6E656374696F6E28652C7B636F6E6E656374696F6E53746172743A437528';
wwv_flow_imp.g_varchar2_table(41533) := '652C742C6E297D297D2929292C2131213D3D6F2E726563757273652626746869732E6D6F76654368696C6472656E2865297D2C466D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D65';
wwv_flow_imp.g_varchar2_table(41534) := '2E6F6C64506172656E742C6F3D652E6F6C64506172656E74496E6465782C733D652E64656C74613B72657475726E204B74286E2E6368696C6472656E2C742C6F292C28302C692E6B702928742C7B706172656E743A6E2C783A742E782D732E782C793A74';
wwv_flow_imp.g_varchar2_table(41535) := '2E792D732E797D292C747D2C466D2E70726F746F747970652E6D6F76654368696C6472656E3D66756E6374696F6E2865297B76617220743D652E64656C74612C6E3D652E73686170653B746869732E5F68656C7065722E6D6F7665526563757273697665';
wwv_flow_imp.g_varchar2_table(41536) := '286E2E6368696C6472656E2C742C6E756C6C297D2C466D2E70726F746F747970652E6765744E6577506172656E743D66756E6374696F6E2865297B72657475726E20652E6E6577506172656E747C7C652E73686170652E706172656E747D2C426D2E2469';
wwv_flow_imp.g_varchar2_table(41537) := '6E6A6563743D5B226D6F64656C696E67225D2C426D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E6E6577536F757263652C6E3D652E6E65775461726765742C6F3D652E636F6E6E656374696F6E2C73';
wwv_flow_imp.g_varchar2_table(41538) := '3D652E646F636B696E674F72506F696E74733B69662821742626216E297468726F77206E6577204572726F7228226E6577536F75726365206F72206E657754617267657420726571756972656422293B72657475726E28302C692E637929287329262628';
wwv_flow_imp.g_varchar2_table(41539) := '652E6F6C64576179706F696E74733D6F2E776179706F696E74732C6F2E776179706F696E74733D73292C74262628652E6F6C64536F757263653D6F2E736F757263652C6F2E736F757263653D74292C6E262628652E6F6C645461726765743D6F2E746172';
wwv_flow_imp.g_varchar2_table(41540) := '6765742C6F2E7461726765743D6E292C6F7D2C426D2E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D652E6E6577536F757263652C6F3D652E6E657754617267';
wwv_flow_imp.g_varchar2_table(41541) := '65742C733D652E646F636B696E674F72506F696E74732C723D652E68696E74737C7C7B7D2C613D7B7D3B722E636F6E6E656374696F6E5374617274262628612E636F6E6E656374696F6E53746172743D722E636F6E6E656374696F6E5374617274292C72';
wwv_flow_imp.g_varchar2_table(41542) := '2E636F6E6E656374696F6E456E64262628612E636F6E6E656374696F6E456E643D722E636F6E6E656374696F6E456E64292C2131213D3D722E6C61796F7574436F6E6E656374696F6E262628216E7C7C6F262622736F7572636522213D3D722E646F636B';
wwv_flow_imp.g_varchar2_table(41543) := '696E677C7C28612E636F6E6E656374696F6E53746172743D612E636F6E6E656374696F6E53746172747C7C566D2828302C692E6379292873293F735B305D3A7329292C216F7C7C6E26262274617267657422213D3D722E646F636B696E677C7C28612E63';
wwv_flow_imp.g_varchar2_table(41544) := '6F6E6E656374696F6E456E643D612E636F6E6E656374696F6E456E647C7C566D2828302C692E6379292873293F735B732E6C656E6774682D315D3A7329292C722E6E6577576179706F696E7473262628612E776179706F696E74733D722E6E6577576179';
wwv_flow_imp.g_varchar2_table(41545) := '706F696E7473292C746869732E5F6D6F64656C696E672E6C61796F7574436F6E6E656374696F6E28742C6129297D2C426D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E6F6C64536F757263652C6E3D65';
wwv_flow_imp.g_varchar2_table(41546) := '2E6F6C645461726765742C693D652E6F6C64576179706F696E74732C6F3D652E636F6E6E656374696F6E3B72657475726E20742626286F2E736F757263653D74292C6E2626286F2E7461726765743D6E292C692626286F2E776179706F696E74733D6929';
wwv_flow_imp.g_varchar2_table(41547) := '2C6F7D2C7A6D2E24696E6A6563743D5B226D6F64656C696E67222C2272756C6573225D2C7A6D2E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220742C6E3D746869732C6F3D746869732E5F6D6F64656C696E';
wwv_flow_imp.g_varchar2_table(41548) := '672C733D746869732E5F72756C65732C723D652E6F6C6453686170652C613D652E6E6577446174612C6C3D652E68696E74737C7C7B7D3B66756E6374696F6E206328652C742C6E297B72657475726E20732E616C6C6F7765642822636F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(41549) := '6E2E7265636F6E6E656374222C7B636F6E6E656374696F6E3A6E2C736F757263653A652C7461726765743A747D297D76617220642C683D7B783A612E782C793A612E797D2C753D7B783A722E782C793A722E792C77696474683A722E77696474682C6865';
wwv_flow_imp.g_varchar2_table(41550) := '696768743A722E6865696768747D3B743D652E6E657753686170653D652E6E657753686170657C7C6E2E637265617465536861706528612C682C722E706172656E742C6C292C722E686F737426266F2E7570646174654174746163686D656E7428742C72';
wwv_flow_imp.g_varchar2_table(41551) := '2E686F7374292C2131213D3D6C2E6D6F76654368696C6472656E262628643D722E6368696C6472656E2E736C69636528292C6F2E6D6F7665456C656D656E747328642C7B783A302C793A307D2C742C6C29293B76617220703D722E696E636F6D696E672E';
wwv_flow_imp.g_varchar2_table(41552) := '736C69636528292C673D722E6F7574676F696E672E736C69636528293B28302C692E6A4A2928702C2866756E6374696F6E2865297B6328652E736F757263652C742C652926266E2E7265636F6E6E656374456E6428652C742C777528652C742C75292C6C';
wwv_flow_imp.g_varchar2_table(41553) := '297D29292C28302C692E6A4A2928672C2866756E6374696F6E2865297B76617220693D652E7461726765743B6328742C692C652926266E2E7265636F6E6E656374537461727428652C742C797528652C742C75292C6C297D29297D2C7A6D2E70726F746F';
wwv_flow_imp.g_varchar2_table(41554) := '747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220743D652E6F6C6453686170653B746869732E5F6D6F64656C696E672E72656D6F766553686170652874297D2C7A6D2E70726F746F747970652E657865637574653D6675';
wwv_flow_imp.g_varchar2_table(41555) := '6E6374696F6E2865297B7D2C7A6D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B7D2C7A6D2E70726F746F747970652E63726561746553686170653D66756E6374696F6E28652C742C6E2C69297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(41556) := '2E5F6D6F64656C696E672E637265617465536861706528652C742C6E2C69297D2C7A6D2E70726F746F747970652E7265636F6E6E65637453746172743D66756E6374696F6E28652C742C6E2C69297B746869732E5F6D6F64656C696E672E7265636F6E6E';
wwv_flow_imp.g_varchar2_table(41557) := '656374537461727428652C742C6E2C69297D2C7A6D2E70726F746F747970652E7265636F6E6E656374456E643D66756E6374696F6E28652C742C6E2C69297B746869732E5F6D6F64656C696E672E7265636F6E6E656374456E6428652C742C6E2C69297D';
wwv_flow_imp.g_varchar2_table(41558) := '2C486D2E24696E6A6563743D5B226D6F64656C696E67225D2C486D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D652E6E6577426F756E64732C6F3D652E6D696E426F756E64733B';
wwv_flow_imp.g_varchar2_table(41559) := '696628766F696420303D3D3D6E2E787C7C766F696420303D3D3D6E2E797C7C766F696420303D3D3D6E2E77696474687C7C766F696420303D3D3D6E2E686569676874297468726F77206E6577204572726F7228226E6577426F756E6473206D7573742068';
wwv_flow_imp.g_varchar2_table(41560) := '617665207B782C20792C2077696474682C206865696768747D2070726F7065727469657322293B6966286F2626286E2E77696474683C6F2E77696474687C7C6E2E6865696768743C6F2E68656967687429297468726F77206E6577204572726F72282277';
wwv_flow_imp.g_varchar2_table(41561) := '6964746820616E64206865696768742063616E6E6F74206265206C657373207468616E206D696E696D756D2068656967687420616E6420776964746822293B696628216F26266E2E77696474683C31307C7C6E2E6865696768743C3130297468726F7720';
wwv_flow_imp.g_varchar2_table(41562) := '6E6577204572726F722822776964746820616E64206865696768742063616E6E6F74206265206C657373207468616E203130707822293B72657475726E20652E6F6C64426F756E64733D7B77696474683A742E77696474682C6865696768743A742E6865';
wwv_flow_imp.g_varchar2_table(41563) := '696768742C783A742E782C793A742E797D2C28302C692E6B702928742C7B77696474683A6E2E77696474682C6865696768743A6E2E6865696768742C783A6E2E782C793A6E2E797D292C747D2C486D2E70726F746F747970652E706F7374457865637574';
wwv_flow_imp.g_varchar2_table(41564) := '653D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D652E73686170652C6F3D652E6F6C64426F756E64733B2131213D3D28652E68696E74737C7C7B7D292E6C61796F757426262828302C692E6A4A29286E2E696E';
wwv_flow_imp.g_varchar2_table(41565) := '636F6D696E672C2866756E6374696F6E2865297B742E6C61796F7574436F6E6E656374696F6E28652C7B636F6E6E656374696F6E456E643A777528652C6E2C6F297D297D29292C28302C692E6A4A29286E2E6F7574676F696E672C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(41566) := '2865297B742E6C61796F7574436F6E6E656374696F6E28652C7B636F6E6E656374696F6E53746172743A797528652C6E2C6F297D297D2929297D2C486D2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E73';
wwv_flow_imp.g_varchar2_table(41567) := '686170652C6E3D652E6F6C64426F756E64733B72657475726E28302C692E6B702928742C7B77696474683A6E2E77696474682C6865696768743A6E2E6865696768742C783A6E2E782C793A6E2E797D292C747D2C576D2E24696E6A6563743D5B226D6F64';
wwv_flow_imp.g_varchar2_table(41568) := '656C696E67225D2C576D2E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D652E64656C74612C6E3D652E646972656374696F6E2C6F3D652E6D6F76696E675368617065732C733D652E726573697A696E';
wwv_flow_imp.g_varchar2_table(41569) := '675368617065732C723D652E73746172742C613D7B7D3B746869732E6D6F7665536861706573286F2C74292C28302C692E6A4A2928732C2866756E6374696F6E2865297B615B652E69645D3D66756E6374696F6E2865297B72657475726E7B783A652E78';
wwv_flow_imp.g_varchar2_table(41570) := '2C793A652E792C6865696768743A652E6865696768742C77696474683A652E77696474687D7D2865297D29292C746869732E726573697A6553686170657328732C742C6E292C746869732E757064617465436F6E6E656374696F6E576179706F696E7473';
wwv_flow_imp.g_varchar2_table(41571) := '2866756E6374696F6E28652C74297B766172206E3D5B5D3B72657475726E28302C692E6A4A2928652E636F6E6361742874292C2866756E6374696F6E286F297B76617220733D6F2E696E636F6D696E672C723D6F2E6F7574676F696E673B28302C692E6A';
wwv_flow_imp.g_varchar2_table(41572) := '4A2928732E636F6E6361742872292C2866756E6374696F6E2869297B766172206F3D692E736F757263652C733D692E7461726765743B28466728652C6F297C7C466728652C73297C7C466728742C6F297C7C466728742C7329292626284667286E2C6929';
wwv_flow_imp.g_varchar2_table(41573) := '7C7C6E2E70757368286929297D29297D29292C6E7D286F2C73292C742C6E2C722C6F2C732C61297D2C576D2E70726F746F747970652E657865637574653D66756E6374696F6E28297B7D2C576D2E70726F746F747970652E7265766572743D66756E6374';
wwv_flow_imp.g_varchar2_table(41574) := '696F6E28297B7D2C576D2E70726F746F747970652E6D6F76655368617065733D66756E6374696F6E28652C74297B766172206E3D746869733B28302C692E6A4A2928652C2866756E6374696F6E2865297B6E2E5F6D6F64656C696E672E6D6F7665536861';
wwv_flow_imp.g_varchar2_table(41575) := '706528652C742C6E756C6C2C7B6175746F526573697A653A21312C6C61796F75743A21312C726563757273653A21317D297D29297D2C576D2E70726F746F747970652E726573697A655368617065733D66756E6374696F6E28652C742C6E297B76617220';
wwv_flow_imp.g_varchar2_table(41576) := '6F3D746869733B28302C692E6A4A2928652C2866756E6374696F6E2865297B76617220693D66756E6374696F6E28652C742C6E297B76617220693D652E782C6F3D652E792C733D652E77696474682C723D652E6865696768742C613D6E2E782C6C3D6E2E';
wwv_flow_imp.g_varchar2_table(41577) := '793B7377697463682874297B63617365226E223A72657475726E7B783A692C793A6F2B6C2C77696474683A732C6865696768743A722D6C7D3B636173652273223A72657475726E7B783A692C793A6F2C77696474683A732C6865696768743A722B6C7D3B';
wwv_flow_imp.g_varchar2_table(41578) := '636173652277223A72657475726E7B783A692B612C793A6F2C77696474683A732D612C6865696768743A727D3B636173652265223A72657475726E7B783A692C793A6F2C77696474683A732B612C6865696768743A727D3B64656661756C743A7468726F';
wwv_flow_imp.g_varchar2_table(41579) := '77206E6577204572726F722822756E6B6E6F776E20646972656374696F6E3A20222B74297D7D28652C6E2C74293B6F2E5F6D6F64656C696E672E726573697A65536861706528652C692C6E756C6C2C7B617474616368537570706F72743A21312C617574';
wwv_flow_imp.g_varchar2_table(41580) := '6F526573697A653A21312C6C61796F75743A21317D297D29297D2C576D2E70726F746F747970652E757064617465436F6E6E656374696F6E576179706F696E74733D66756E6374696F6E28652C742C6E2C6F2C732C722C61297B766172206C3D74686973';
wwv_flow_imp.g_varchar2_table(41581) := '2C633D732E636F6E6361742872293B28302C692E6A4A2928652C2866756E6374696F6E2865297B76617220643D652E736F757263652C683D652E7461726765742C753D66756E6374696F6E2865297B72657475726E28302C692E546A2928652E77617970';
wwv_flow_imp.g_varchar2_table(41582) := '6F696E74732C2866756E6374696F6E2865297B72657475726E28653D6A6D286529292E6F726967696E616C262628652E6F726967696E616C3D6A6D28652E6F726967696E616C29292C657D29297D2865292C703D716D286E292C673D7B7D3B556D28632C';
wwv_flow_imp.g_varchar2_table(41583) := '64292626556D28632C68293F28753D28302C692E546A2928752C2866756E6374696F6E2865297B72657475726E20246D28652C6F2C6E29262628655B705D3D655B705D2B745B705D292C652E6F726967696E616C2626246D28652E6F726967696E616C2C';
wwv_flow_imp.g_varchar2_table(41584) := '6F2C6E29262628652E6F726967696E616C5B705D3D652E6F726967696E616C5B705D2B745B705D292C657D29292C6C2E5F6D6F64656C696E672E757064617465576179706F696E747328652C752C7B6C6162656C4265686176696F723A21317D29293A28';
wwv_flow_imp.g_varchar2_table(41585) := '556D28632C64297C7C556D28632C682929262628556D28732C64293F672E636F6E6E656374696F6E53746172743D437528652C642C74293A556D28732C68293F672E636F6E6E656374696F6E456E643D537528652C682C74293A556D28722C64293F672E';
wwv_flow_imp.g_varchar2_table(41586) := '636F6E6E656374696F6E53746172743D797528652C642C615B642E69645D293A556D28722C6829262628672E636F6E6E656374696F6E456E643D777528652C682C615B682E69645D29292C6C2E5F6D6F64656C696E672E6C61796F7574436F6E6E656374';
wwv_flow_imp.g_varchar2_table(41587) := '696F6E28652C6729297D29297D2C4B6D2E24696E6A6563743D5B226D6F64656C696E67225D2C4B6D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D742E6368696C6472656E3B652E';
wwv_flow_imp.g_varchar2_table(41588) := '6F6C644368696C6472656E5669736962696C6974793D476D286E292C742E636F6C6C61707365643D21742E636F6C6C61707365643B76617220693D516D286E2C742E636F6C6C6170736564293B72657475726E5B745D2E636F6E6361742869297D2C4B6D';
wwv_flow_imp.g_varchar2_table(41589) := '2E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D652E6F6C644368696C6472656E5669736962696C6974792C693D596D28742E6368696C6472656E2C6E293B72657475726E20742E636F';
wwv_flow_imp.g_varchar2_table(41590) := '6C6C61707365643D21742E636F6C6C61707365642C5B745D2E636F6E6361742869297D2C5A6D2E24696E6A6563743D5B226D6F64656C696E67225D2C5A6D2E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D65';
wwv_flow_imp.g_varchar2_table(41591) := '2E73686170652C6E3D652E6E6577486F73742C693D742E686F73743B72657475726E20652E6F6C64486F73743D692C652E61747461636865724964783D586D28692C74292C4A6D286E2C74292C742E686F73743D6E2C747D2C5A6D2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(41592) := '652E7265766572743D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D652E6E6577486F73742C693D652E6F6C64486F73742C6F3D652E61747461636865724964783B72657475726E20742E686F73743D692C586D286E2C74292C4A';
wwv_flow_imp.g_varchar2_table(41593) := '6D28692C742C6F292C747D2C65662E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D652E6E6577576179706F696E74733B72657475726E20652E6F6C64576179706F696E';
wwv_flow_imp.g_varchar2_table(41594) := '74733D742E776179706F696E74732C742E776179706F696E74733D6E2C747D2C65662E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220743D652E636F6E6E656374696F6E2C6E3D652E6F6C64576179706F696E74733B';
wwv_flow_imp.g_varchar2_table(41595) := '72657475726E20742E776179706F696E74733D6E2C747D2C74662E24696E6A6563743D5B226576656E74427573222C22656C656D656E74466163746F7279222C22636F6D6D616E64537461636B225D2C74662E70726F746F747970652E67657448616E64';
wwv_flow_imp.g_varchar2_table(41596) := '6C6572733D66756E6374696F6E28297B72657475726E7B2273686170652E617070656E64223A626D2C2273686170652E637265617465223A536D2C2273686170652E64656C657465223A546D2C2273686170652E6D6F7665223A466D2C2273686170652E';
wwv_flow_imp.g_varchar2_table(41597) := '726573697A65223A486D2C2273686170652E7265706C616365223A7A6D2C2273686170652E746F67676C65436F6C6C61707365223A4B6D2C7370616365546F6F6C3A576D2C226C6162656C2E637265617465223A786D2C22636F6E6E656374696F6E2E63';
wwv_flow_imp.g_varchar2_table(41598) := '7265617465223A5F6D2C22636F6E6E656374696F6E2E64656C657465223A4C6D2C22636F6E6E656374696F6E2E6D6F7665223A4E6D2C22636F6E6E656374696F6E2E6C61796F7574223A416D2C22636F6E6E656374696F6E2E757064617465576179706F';
wwv_flow_imp.g_varchar2_table(41599) := '696E7473223A65662C22636F6E6E656374696F6E2E7265636F6E6E656374223A426D2C22656C656D656E74732E637265617465223A776D2C22656C656D656E74732E6D6F7665223A526D2C22656C656D656E74732E64656C657465223A446D2C22656C65';
wwv_flow_imp.g_varchar2_table(41600) := '6D656E74732E64697374726962757465223A496D2C22656C656D656E74732E616C69676E223A766D2C22656C656D656E742E7570646174654174746163686D656E74223A5A6D7D7D2C74662E70726F746F747970652E726567697374657248616E646C65';
wwv_flow_imp.g_varchar2_table(41601) := '72733D66756E6374696F6E2865297B28302C692E6A4A2928746869732E67657448616E646C65727328292C2866756E6374696F6E28742C6E297B652E726567697374657248616E646C6572286E2C74297D29297D2C74662E70726F746F747970652E6D6F';
wwv_flow_imp.g_varchar2_table(41602) := '766553686170653D66756E6374696F6E28652C742C6E2C692C6F297B226F626A656374223D3D747970656F6620692626286F3D692C693D6E756C6C293B76617220733D7B73686170653A652C64656C74613A742C6E6577506172656E743A6E2C6E657750';
wwv_flow_imp.g_varchar2_table(41603) := '6172656E74496E6465783A692C68696E74733A6F7C7C7B7D7D3B746869732E5F636F6D6D616E64537461636B2E65786563757465282273686170652E6D6F7665222C73297D2C74662E70726F746F747970652E7570646174654174746163686D656E743D';
wwv_flow_imp.g_varchar2_table(41604) := '66756E6374696F6E28652C74297B766172206E3D7B73686170653A652C6E6577486F73743A747D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E742E7570646174654174746163686D656E74222C6E297D2C7466';
wwv_flow_imp.g_varchar2_table(41605) := '2E70726F746F747970652E6D6F7665456C656D656E74733D66756E6374696F6E28652C742C6E2C69297B766172206F2C733D28693D697C7C7B7D292E6174746163682C723D6E3B21303D3D3D733F286F3D6E2C723D6E2E706172656E74293A21313D3D3D';
wwv_flow_imp.g_varchar2_table(41606) := '732626286F3D6E756C6C293B76617220613D7B7368617065733A652C64656C74613A742C6E6577506172656E743A722C6E6577486F73743A6F2C68696E74733A697D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D65';
wwv_flow_imp.g_varchar2_table(41607) := '6E74732E6D6F7665222C61297D2C74662E70726F746F747970652E6D6F7665436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E2C692C6F297B226F626A656374223D3D747970656F6620692626286F3D692C693D766F69642030293B766172';
wwv_flow_imp.g_varchar2_table(41608) := '20733D7B636F6E6E656374696F6E3A652C64656C74613A742C6E6577506172656E743A6E2C6E6577506172656E74496E6465783A692C68696E74733A6F7C7C7B7D7D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822636F6E6E65';
wwv_flow_imp.g_varchar2_table(41609) := '6374696F6E2E6D6F7665222C73297D2C74662E70726F746F747970652E6C61796F7574436F6E6E656374696F6E3D66756E6374696F6E28652C74297B766172206E3D7B636F6E6E656374696F6E3A652C68696E74733A747C7C7B7D7D3B746869732E5F63';
wwv_flow_imp.g_varchar2_table(41610) := '6F6D6D616E64537461636B2E657865637574652822636F6E6E656374696F6E2E6C61796F7574222C6E297D2C74662E70726F746F747970652E637265617465436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E2C692C6F2C73297B226F626A';
wwv_flow_imp.g_varchar2_table(41611) := '656374223D3D747970656F66206E262628733D6F2C6F3D692C693D6E2C6E3D766F69642030293B76617220723D7B736F757263653A652C7461726765743A742C706172656E743A6F2C706172656E74496E6465783A6E2C636F6E6E656374696F6E3A693D';
wwv_flow_imp.g_varchar2_table(41612) := '746869732E5F6372656174652822636F6E6E656374696F6E222C69292C68696E74733A737D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E657865637574652822636F6E6E656374696F6E2E637265617465222C72292C722E636F6E';
wwv_flow_imp.g_varchar2_table(41613) := '6E656374696F6E7D2C74662E70726F746F747970652E63726561746553686170653D66756E6374696F6E28652C742C6E2C692C6F297B226E756D62657222213D747970656F6620692626286F3D692C693D766F69642030293B76617220732C722C613D28';
wwv_flow_imp.g_varchar2_table(41614) := '6F3D6F7C7C7B7D292E6174746163683B653D746869732E5F63726561746528227368617065222C65292C613F28733D6E2E706172656E742C723D6E293A733D6E3B766172206C3D7B706F736974696F6E3A742C73686170653A652C706172656E743A732C';
wwv_flow_imp.g_varchar2_table(41615) := '706172656E74496E6465783A692C686F73743A722C68696E74733A6F7D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E65786563757465282273686170652E637265617465222C6C292C6C2E73686170657D2C74662E70726F746F74';
wwv_flow_imp.g_varchar2_table(41616) := '7970652E637265617465456C656D656E74733D66756E6374696F6E28652C742C6E2C6F2C73297B28302C692E6379292865297C7C28653D5B655D292C226E756D62657222213D747970656F66206F262628733D6F2C6F3D766F69642030293B7661722072';
wwv_flow_imp.g_varchar2_table(41617) := '3D7B706F736974696F6E3A742C656C656D656E74733A652C706172656E743A6E2C706172656E74496E6465783A6F2C68696E74733A733D737C7C7B7D7D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E657865637574652822656C65';
wwv_flow_imp.g_varchar2_table(41618) := '6D656E74732E637265617465222C72292C722E656C656D656E74737D2C74662E70726F746F747970652E6372656174654C6162656C3D66756E6374696F6E28652C742C6E2C69297B6E3D746869732E5F63726561746528226C6162656C222C6E293B7661';
wwv_flow_imp.g_varchar2_table(41619) := '72206F3D7B6C6162656C5461726765743A652C706F736974696F6E3A742C706172656E743A697C7C652E706172656E742C73686170653A6E7D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E6578656375746528226C6162656C2E63';
wwv_flow_imp.g_varchar2_table(41620) := '7265617465222C6F292C6F2E73686170657D2C74662E70726F746F747970652E617070656E6453686170653D66756E6374696F6E28652C742C6E2C692C6F297B6F3D6F7C7C7B7D3B76617220733D7B736F757263653A652C706F736974696F6E3A6E2C74';
wwv_flow_imp.g_varchar2_table(41621) := '61726765743A692C73686170653A743D746869732E5F63726561746528227368617065222C74292C636F6E6E656374696F6E3A6F2E636F6E6E656374696F6E2C636F6E6E656374696F6E506172656E743A6F2E636F6E6E656374696F6E506172656E742C';
wwv_flow_imp.g_varchar2_table(41622) := '68696E74733A6F7D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E65786563757465282273686170652E617070656E64222C73292C732E73686170657D2C74662E70726F746F747970652E72656D6F7665456C656D656E74733D6675';
wwv_flow_imp.g_varchar2_table(41623) := '6E6374696F6E2865297B76617220743D7B656C656D656E74733A657D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E74732E64656C657465222C74297D2C74662E70726F746F747970652E646973747269627574';
wwv_flow_imp.g_varchar2_table(41624) := '65456C656D656E74733D66756E6374696F6E28652C742C6E297B76617220693D7B67726F7570733A652C617869733A742C64696D656E73696F6E3A6E7D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E74732E64';
wwv_flow_imp.g_varchar2_table(41625) := '697374726962757465222C69297D2C74662E70726F746F747970652E72656D6F766553686170653D66756E6374696F6E28652C74297B766172206E3D7B73686170653A652C68696E74733A747C7C7B7D7D3B746869732E5F636F6D6D616E64537461636B';
wwv_flow_imp.g_varchar2_table(41626) := '2E65786563757465282273686170652E64656C657465222C6E297D2C74662E70726F746F747970652E72656D6F7665436F6E6E656374696F6E3D66756E6374696F6E28652C74297B766172206E3D7B636F6E6E656374696F6E3A652C68696E74733A747C';
wwv_flow_imp.g_varchar2_table(41627) := '7C7B7D7D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822636F6E6E656374696F6E2E64656C657465222C6E297D2C74662E70726F746F747970652E7265706C61636553686170653D66756E6374696F6E28652C742C6E297B7661';
wwv_flow_imp.g_varchar2_table(41628) := '7220693D7B6F6C6453686170653A652C6E6577446174613A742C68696E74733A6E7C7C7B7D7D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E65786563757465282273686170652E7265706C616365222C69292C692E6E6577536861';
wwv_flow_imp.g_varchar2_table(41629) := '70657D2C74662E70726F746F747970652E616C69676E456C656D656E74733D66756E6374696F6E28652C74297B766172206E3D7B656C656D656E74733A652C616C69676E6D656E743A747D3B746869732E5F636F6D6D616E64537461636B2E6578656375';
wwv_flow_imp.g_varchar2_table(41630) := '74652822656C656D656E74732E616C69676E222C6E297D2C74662E70726F746F747970652E726573697A6553686170653D66756E6374696F6E28652C742C6E2C69297B766172206F3D7B73686170653A652C6E6577426F756E64733A742C6D696E426F75';
wwv_flow_imp.g_varchar2_table(41631) := '6E64733A6E2C68696E74733A697D3B746869732E5F636F6D6D616E64537461636B2E65786563757465282273686170652E726573697A65222C6F297D2C74662E70726F746F747970652E63726561746553706163653D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(41632) := '2C692C6F297B76617220733D7B64656C74613A6E2C646972656374696F6E3A692C6D6F76696E675368617065733A652C726573697A696E675368617065733A742C73746172743A6F7D3B746869732E5F636F6D6D616E64537461636B2E65786563757465';
wwv_flow_imp.g_varchar2_table(41633) := '28227370616365546F6F6C222C73297D2C74662E70726F746F747970652E757064617465576179706F696E74733D66756E6374696F6E28652C742C6E297B76617220693D7B636F6E6E656374696F6E3A652C6E6577576179706F696E74733A742C68696E';
wwv_flow_imp.g_varchar2_table(41634) := '74733A6E7C7C7B7D7D3B746869732E5F636F6D6D616E64537461636B2E657865637574652822636F6E6E656374696F6E2E757064617465576179706F696E7473222C69297D2C74662E70726F746F747970652E7265636F6E6E6563743D66756E6374696F';
wwv_flow_imp.g_varchar2_table(41635) := '6E28652C742C6E2C692C6F297B76617220733D7B636F6E6E656374696F6E3A652C6E6577536F757263653A742C6E65775461726765743A6E2C646F636B696E674F72506F696E74733A692C68696E74733A6F7C7C7B7D7D3B746869732E5F636F6D6D616E';
wwv_flow_imp.g_varchar2_table(41636) := '64537461636B2E657865637574652822636F6E6E656374696F6E2E7265636F6E6E656374222C73297D2C74662E70726F746F747970652E7265636F6E6E65637453746172743D66756E6374696F6E28652C742C6E2C6F297B6F7C7C286F3D7B7D292C7468';
wwv_flow_imp.g_varchar2_table(41637) := '69732E7265636F6E6E65637428652C742C652E7461726765742C6E2C28302C692E6B7029286F2C7B646F636B696E673A22736F75726365227D29297D2C74662E70726F746F747970652E7265636F6E6E656374456E643D66756E6374696F6E28652C742C';
wwv_flow_imp.g_varchar2_table(41638) := '6E2C6F297B6F7C7C286F3D7B7D292C746869732E7265636F6E6E65637428652C652E736F757263652C742C6E2C28302C692E6B7029286F2C7B646F636B696E673A22746172676574227D29297D2C74662E70726F746F747970652E636F6E6E6563743D66';
wwv_flow_imp.g_varchar2_table(41639) := '756E6374696F6E28652C742C6E2C69297B72657475726E20746869732E637265617465436F6E6E656374696F6E28652C742C6E7C7C7B7D2C652E706172656E742C69297D2C74662E70726F746F747970652E5F6372656174653D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(41640) := '2C74297B72657475726E207420696E7374616E63656F662073693F743A746869732E5F656C656D656E74466163746F72792E63726561746528652C74297D2C74662E70726F746F747970652E746F67676C65436F6C6C617073653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41641) := '652C74297B766172206E3D7B73686170653A652C68696E74733A747C7C7B7D7D3B746869732E5F636F6D6D616E64537461636B2E65786563757465282273686170652E746F67676C65436F6C6C61707365222C6E297D2C6E662E24696E6A6563743D5B22';
wwv_flow_imp.g_varchar2_table(41642) := '656C656D656E745265676973747279225D2C6E662E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6D6F64646C65456C656D656E742C6F3D652E70726F706572746965733B';
wwv_flow_imp.g_varchar2_table(41643) := '696628216E297468726F77206E6577204572726F7228223C6D6F64646C65456C656D656E743E20726571756972656422293B76617220733D652E6368616E6765647C7C746869732E5F67657456697375616C5265666572656E636573286E292E636F6E63';
wwv_flow_imp.g_varchar2_table(41644) := '61742874292C723D652E6F6C6450726F706572746965737C7C66756E6374696F6E28652C74297B72657475726E28302C692E54532928742C2866756E6374696F6E28742C6E297B72657475726E20745B6E5D3D652E676574286E292C747D292C7B7D297D';
wwv_flow_imp.g_varchar2_table(41645) := '286E2C28302C692E485029286F29293B72657475726E206F66286E2C6F292C652E6F6C6450726F706572746965733D722C652E6368616E6765643D732C737D2C6E662E70726F746F747970652E7265766572743D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(41646) := '743D652E6F6C6450726F706572746965732C6E3D652E6D6F64646C65456C656D656E742C693D652E6368616E6765643B72657475726E206F66286E2C74292C697D2C6E662E70726F746F747970652E5F67657456697375616C5265666572656E6365733D';
wwv_flow_imp.g_varchar2_table(41647) := '66756E6374696F6E2865297B76617220743D746869732E5F656C656D656E7452656769737472793B72657475726E28302C792E69732928652C2262706D6E3A446174614F626A65637422293F66756E6374696F6E28652C74297B72657475726E20742E66';
wwv_flow_imp.g_varchar2_table(41648) := '696C746572282866756E6374696F6E2874297B72657475726E28302C792E69732928742C2262706D6E3A446174614F626A6563745265666572656E63652229262628302C792E676574427573696E6573734F626A656374292874292E646174614F626A65';
wwv_flow_imp.g_varchar2_table(41649) := '63745265663D3D3D657D29297D28652C74293A5B5D7D3B7661722073663D2264656661756C74222C72663D226964222C61663D7B77696474683A302C6865696768743A307D3B66756E6374696F6E206C6628652C742C6E2C69297B746869732E5F656C65';
wwv_flow_imp.g_varchar2_table(41650) := '6D656E7452656769737472793D652C746869732E5F6D6F64646C653D742C746869732E5F6D6F64656C696E673D6E2C746869732E5F7465787452656E64657265723D697D66756E6374696F6E20636628652C74297B72657475726E20726620696E206526';
wwv_flow_imp.g_varchar2_table(41651) := '26655B72665D213D3D745B72665D7D66756E6374696F6E20646628652C74297B766172206E3D652E627573696E6573734F626A6563742C6F3D28302C792E6765744469292865293B28302C692E6A4A2928742C2866756E6374696F6E28652C74297B2264';
wwv_flow_imp.g_varchar2_table(41652) := '6922213D3D743F6E2E73657428742C65293A6F262666756E6374696F6E28652C74297B28302C692E6A4A2928742C2866756E6374696F6E28742C6E297B652E736574286E2C74297D29297D286F2C65297D29297D6C662E24696E6A6563743D5B22656C65';
wwv_flow_imp.g_varchar2_table(41653) := '6D656E745265676973747279222C226D6F64646C65222C226D6F64656C696E67222C227465787452656E6465726572225D2C6C662E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E656C656D656E742C6E';
wwv_flow_imp.g_varchar2_table(41654) := '3D5B745D3B6966282174297468726F77206E6577204572726F722822656C656D656E7420726571756972656422293B766172206F3D746869732E5F656C656D656E7452656769737472792C733D746869732E5F6D6F64646C652E6964732C723D742E6275';
wwv_flow_imp.g_varchar2_table(41655) := '73696E6573734F626A6563742C613D66756E6374696F6E2865297B76617220743D28302C692E6B7029287B7D2C65293B72657475726E2068662E666F7245616368282866756E6374696F6E286E297B6E20696E2065262628745B6E5D3D28302C792E6765';
wwv_flow_imp.g_varchar2_table(41656) := '74427573696E6573734F626A6563742928745B6E5D29297D29292C747D28652E70726F70657274696573292C6C3D652E6F6C6450726F706572746965737C7C66756E6374696F6E28652C74297B766172206E3D28302C692E4850292874292C6F3D652E62';
wwv_flow_imp.g_varchar2_table(41657) := '7573696E6573734F626A6563742C733D28302C792E6765744469292865293B72657475726E28302C692E545329286E2C2866756E6374696F6E28652C6E297B72657475726E20655B6E5D3D22646922213D3D6E3F6F2E676574286E293A66756E6374696F';
wwv_flow_imp.g_varchar2_table(41658) := '6E28652C74297B72657475726E28302C692E54532928742C2866756E6374696F6E28742C6E297B72657475726E20745B6E5D3D652626652E676574286E292C747D292C7B7D297D28732C28302C692E48502928742E646929292C657D292C7B7D297D2874';
wwv_flow_imp.g_varchar2_table(41659) := '2C61293B72657475726E20636628612C7229262628732E756E636C61696D28725B72665D292C6F2E757064617465496428742C615B72665D292C732E636C61696D28615B72665D2C7229292C736620696E2061262628615B73665D26266E2E7075736828';
wwv_flow_imp.g_varchar2_table(41660) := '6F2E67657428615B73665D2E696429292C725B73665D26266E2E70757368286F2E67657428725B73665D2E69642929292C646628742C61292C652E6F6C6450726F706572746965733D6C2C652E6368616E6765643D6E2C6E7D2C6C662E70726F746F7479';
wwv_flow_imp.g_varchar2_table(41661) := '70652E706F7374457865637574653D66756E6374696F6E2865297B76617220743D652E656C656D656E742E6C6162656C2C6E3D74262628302C792E676574427573696E6573734F626A656374292874292E6E616D653B6966286E297B76617220693D7468';
wwv_flow_imp.g_varchar2_table(41662) := '69732E5F7465787452656E64657265722E67657445787465726E616C4C6162656C426F756E647328742C6E293B746869732E5F6D6F64656C696E672E726573697A65536861706528742C692C6166297D7D2C6C662E70726F746F747970652E7265766572';
wwv_flow_imp.g_varchar2_table(41663) := '743D66756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E70726F706572746965732C693D652E6F6C6450726F706572746965732C6F3D742E627573696E6573734F626A6563742C733D746869732E5F656C656D656E74526567';
wwv_flow_imp.g_varchar2_table(41664) := '69737472792C723D746869732E5F6D6F64646C652E6964733B72657475726E20646628742C69292C6366286E2C6F29262628722E756E636C61696D286E5B72665D292C732E757064617465496428742C695B72665D292C722E636C61696D28695B72665D';
wwv_flow_imp.g_varchar2_table(41665) := '2C6F29292C652E6368616E6765647D3B7661722068663D5B2264656661756C74225D3B66756E6374696F6E20756628652C74297B746869732E5F63616E7661733D652C746869732E5F6D6F64656C696E673D747D66756E6374696F6E20706628652C7429';
wwv_flow_imp.g_varchar2_table(41666) := '7B746869732E5F6D6F64656C696E673D652C746869732E5F7370616365546F6F6C3D747D66756E6374696F6E2067662865297B746869732E5F6D6F64656C696E673D657D66756E6374696F6E206D6628652C74297B746869732E5F6D6F64656C696E673D';
wwv_flow_imp.g_varchar2_table(41667) := '652C746869732E5F7370616365546F6F6C3D747D75662E24696E6A6563743D5B2263616E766173222C226D6F64656C696E67225D2C75662E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D746869732E5F6361';
wwv_flow_imp.g_varchar2_table(41668) := '6E7661732C6E3D652E6E6577526F6F742C693D6E2E627573696E6573734F626A6563742C6F3D742E676574526F6F74456C656D656E7428292C733D6F2E627573696E6573734F626A6563742C723D732E24706172656E742C613D28302C792E6765744469';
wwv_flow_imp.g_varchar2_table(41669) := '29286F293B72657475726E20742E736574526F6F74456C656D656E74286E292C742E72656D6F7665526F6F74456C656D656E74286F292C4B7428722E726F6F74456C656D656E74732C69292C692E24706172656E743D722C557428722E726F6F74456C65';
wwv_flow_imp.g_varchar2_table(41670) := '6D656E74732C73292C732E24706172656E743D6E756C6C2C6F2E64693D6E756C6C2C612E62706D6E456C656D656E743D692C6E2E64693D612C652E6F6C64526F6F743D6F2C5B5D7D2C75662E70726F746F747970652E7265766572743D66756E6374696F';
wwv_flow_imp.g_varchar2_table(41671) := '6E2865297B76617220743D746869732E5F63616E7661732C6E3D652E6E6577526F6F742C693D6E2E627573696E6573734F626A6563742C6F3D652E6F6C64526F6F742C733D6F2E627573696E6573734F626A6563742C723D692E24706172656E742C613D';
wwv_flow_imp.g_varchar2_table(41672) := '28302C792E676574446929286E293B72657475726E20742E736574526F6F74456C656D656E74286F292C742E72656D6F7665526F6F74456C656D656E74286E292C557428722E726F6F74456C656D656E74732C69292C692E24706172656E743D6E756C6C';
wwv_flow_imp.g_varchar2_table(41673) := '2C4B7428722E726F6F74456C656D656E74732C73292C732E24706172656E743D722C6E2E64693D6E756C6C2C612E62706D6E456C656D656E743D732C6F2E64693D612C5B5D7D2C70662E24696E6A6563743D5B226D6F64656C696E67222C227370616365';
wwv_flow_imp.g_varchar2_table(41674) := '546F6F6C225D2C70662E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D746869732E5F7370616365546F6F6C2C6E3D746869732E5F6D6F64656C696E672C6F3D652E73686170652C733D652E6C6F6361';
wwv_flow_imp.g_varchar2_table(41675) := '74696F6E2C723D5668286F292C613D723D3D3D6F2C6C3D613F6F3A6F2E706172656E742C633D4268286C292C643D28302C72732E246229286F293B696628643F226C656674223D3D3D733F733D22746F70223A227269676874223D3D3D73262628733D22';
wwv_flow_imp.g_varchar2_table(41676) := '626F74746F6D22293A22746F70223D3D3D733F733D226C656674223A22626F74746F6D223D3D3D73262628733D22726967687422292C21632E6C656E677468297B76617220683D643F7B783A6F2E782B52682C793A6F2E792C77696474683A6F2E776964';
wwv_flow_imp.g_varchar2_table(41677) := '74682D52682C6865696768743A6F2E6865696768747D3A7B783A6F2E782C793A6F2E792B52682C77696474683A6F2E77696474682C6865696768743A6F2E6865696768742D52687D3B6E2E6372656174655368617065287B747970653A2262706D6E3A4C';
wwv_flow_imp.g_varchar2_table(41678) := '616E65222C6973486F72697A6F6E74616C3A647D2C682C6C297D76617220752C702C672C6D2C662C763D5B5D3B617428722C2866756E6374696F6E2865297B72657475726E20762E707573682865292C652E6C6162656C2626762E7075736828652E6C61';
wwv_flow_imp.g_varchar2_table(41679) := '62656C292C653D3D3D6F3F5B5D3A28302C692E70622928652E6368696C6472656E2C2866756E6374696F6E2865297B72657475726E2065213D3D6F7D29297D29292C22746F70223D3D3D733F28753D2D3132302C673D28703D6F2E79292B31302C6D3D22';
wwv_flow_imp.g_varchar2_table(41680) := '6E222C663D227922293A226C656674223D3D3D733F28753D2D3132302C673D28703D6F2E78292B31302C6D3D2277222C663D227822293A22626F74746F6D223D3D3D733F28753D3132302C673D28703D6F2E792B6F2E686569676874292D31302C6D3D22';
wwv_flow_imp.g_varchar2_table(41681) := '73222C663D227922293A227269676874223D3D3D73262628753D3132302C673D28703D6F2E782B6F2E7769647468292D31302C6D3D2265222C663D227822293B76617220623D742E63616C63756C61746541646A7573746D656E747328762C662C752C67';
wwv_flow_imp.g_varchar2_table(41682) := '292C5F3D643F7B783A302C793A757D3A7B783A752C793A307D3B742E6D616B65537061636528622E6D6F76696E675368617065732C622E726573697A696E675368617065732C5F2C6D2C67293B76617220793D643F7B783A6F2E782B28613F52683A3029';
wwv_flow_imp.g_varchar2_table(41683) := '2C793A702D2822746F70223D3D3D733F3132303A30292C77696474683A6F2E77696474682D28613F52683A30292C6865696768743A3132307D3A7B783A702D28226C656674223D3D3D733F3132303A30292C793A6F2E792B28613F52683A30292C776964';
wwv_flow_imp.g_varchar2_table(41684) := '74683A3132302C6865696768743A6F2E6865696768742D28613F52683A30297D3B652E6E65774C616E653D6E2E6372656174655368617065287B747970653A2262706D6E3A4C616E65222C6973486F72697A6F6E74616C3A647D2C792C6C297D2C67662E';
wwv_flow_imp.g_varchar2_table(41685) := '24696E6A6563743D5B226D6F64656C696E67225D2C67662E70726F746F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D652E73686170652C693D652E636F756E742C6F3D';
wwv_flow_imp.g_varchar2_table(41686) := '4268286E292C733D6F2E6C656E6774683B696628733E69297468726F77206E6577204572726F7228606D6F7265207468616E203C247B697D3E206368696C64206C616E657360293B76617220722C612C6C2C632C643D28302C72732E246229286E292C68';
wwv_flow_imp.g_varchar2_table(41687) := '3D643F6E2E6865696768743A6E2E77696474682C753D4D6174682E726F756E6428682F69293B666F7228633D303B633C693B632B2B29723D633D3D3D692D313F682D752A633A752C613D643F7B783A6E2E782B52682C793A6E2E792B632A752C77696474';
wwv_flow_imp.g_varchar2_table(41688) := '683A6E2E77696474682D52682C6865696768743A727D3A7B783A6E2E782B632A752C793A6E2E792B52682C77696474683A722C6865696768743A6E2E6865696768742D52687D2C633C733F742E726573697A655368617065286F5B635D2C61293A286C3D';
wwv_flow_imp.g_varchar2_table(41689) := '7B747970653A2262706D6E3A4C616E65222C6973486F72697A6F6E74616C3A647D2C742E6372656174655368617065286C2C612C6E29297D2C6D662E24696E6A6563743D5B226D6F64656C696E67222C227370616365546F6F6C225D2C6D662E70726F74';
wwv_flow_imp.g_varchar2_table(41690) := '6F747970652E707265457865637574653D66756E6374696F6E2865297B76617220743D652E73686170652C6E3D652E6E6577426F756E64733B2131213D3D652E62616C616E6365643F746869732E726573697A6542616C616E63656428742C6E293A7468';
wwv_flow_imp.g_varchar2_table(41691) := '69732E726573697A65537061636528742C6E297D2C6D662E70726F746F747970652E726573697A6542616C616E6365643D66756E6374696F6E28652C74297B766172206E3D746869732E5F6D6F64656C696E672C693D66756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(41692) := '766172206E3D56682865292C693D4668286E2C28302C792E697329286E2C2262706D6E3A50726F6365737322293F5B5D3A5B6E5D292C6F3D566E2865292C733D566E2874292C723D66756E6374696F6E28652C74297B72657475726E20446828566E2874';
wwv_flow_imp.g_varchar2_table(41693) := '292C566E286529297D28652C74292C613D5B5D2C6C3D28302C72732E2462292865293B72657475726E20692E666F7245616368282866756E6374696F6E2874297B69662874213D3D65297B766172206E3D6C3F303A722E746F702C693D6C3F722E726967';
wwv_flow_imp.g_varchar2_table(41694) := '68743A302C633D6C3F303A722E626F74746F6D2C643D6C3F722E6C6566743A302C683D566E2874293B722E746F70262628506828682E626F74746F6D2D6F2E746F70293C3130262628633D732E746F702D682E626F74746F6D292C506828682E746F702D';
wwv_flow_imp.g_varchar2_table(41695) := '6F2E746F70293C352626286E3D732E746F702D682E746F7029292C722E6C656674262628506828682E72696768742D6F2E6C656674293C3130262628693D732E6C6566742D682E7269676874292C506828682E6C6566742D6F2E6C656674293C35262628';
wwv_flow_imp.g_varchar2_table(41696) := '643D732E6C6566742D682E6C65667429292C722E626F74746F6D262628506828682E746F702D6F2E626F74746F6D293C31302626286E3D732E626F74746F6D2D682E746F70292C506828682E626F74746F6D2D6F2E626F74746F6D293C35262628633D73';
wwv_flow_imp.g_varchar2_table(41697) := '2E626F74746F6D2D682E626F74746F6D29292C722E7269676874262628506828682E6C6566742D6F2E7269676874293C3130262628643D732E72696768742D682E6C656674292C506828682E72696768742D6F2E7269676874293C35262628693D732E72';
wwv_flow_imp.g_varchar2_table(41698) := '696768742D682E726967687429292C286E7C7C697C7C637C7C64292626612E70757368287B73686170653A742C6E6577426F756E64733A546828742C7B746F703A6E2C72696768743A692C626F74746F6D3A632C6C6566743A647D297D297D7D29292C61';
wwv_flow_imp.g_varchar2_table(41699) := '7D28652C74293B6E2E726573697A65536861706528652C74292C692E666F7245616368282866756E6374696F6E2865297B6E2E726573697A65536861706528652E73686170652C652E6E6577426F756E6473297D29297D2C6D662E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(41700) := '2E726573697A6553706163653D66756E6374696F6E28652C74297B766172206E2C692C6F2C732C722C613D746869732E5F7370616365546F6F6C2C6C3D566E2865292C633D446828566E2874292C6C292C643D56682865292C683D5B5D2C753D5B5D3B61';
wwv_flow_imp.g_varchar2_table(41701) := '7428642C2866756E6374696F6E2865297B72657475726E20682E707573682865292C2828302C792E69732928652C2262706D6E3A4C616E6522297C7C28302C792E69732928652C2262706D6E3A5061727469636970616E742229292626752E7075736828';
wwv_flow_imp.g_varchar2_table(41702) := '65292C652E6368696C6472656E7D29292C28632E626F74746F6D7C7C632E746F70292626286E3D632E626F74746F6D7C7C632E746F702C693D652E792B28632E626F74746F6D3F652E6865696768743A30292B28632E626F74746F6D3F2D31303A313029';
wwv_flow_imp.g_varchar2_table(41703) := '2C6F3D632E626F74746F6D3F2273223A226E222C733D632E746F703E307C7C632E626F74746F6D3C303F2D6E3A6E2C723D612E63616C63756C61746541646A7573746D656E747328682C2279222C732C69292C612E6D616B65537061636528722E6D6F76';
wwv_flow_imp.g_varchar2_table(41704) := '696E675368617065732C722E726573697A696E675368617065732C7B783A302C793A6E7D2C6F29292C28632E6C6566747C7C632E7269676874292626286E3D632E72696768747C7C632E6C6566742C693D652E782B28632E72696768743F652E77696474';
wwv_flow_imp.g_varchar2_table(41705) := '683A30292B28632E72696768743F2D31303A313030292C6F3D632E72696768743F2265223A2277222C733D632E6C6566743E307C7C632E72696768743C303F2D6E3A6E2C723D612E63616C63756C61746541646A7573746D656E747328752C2278222C73';
wwv_flow_imp.g_varchar2_table(41706) := '2C69292C612E6D616B65537061636528722E6D6F76696E675368617065732C722E726573697A696E675368617065732C7B783A6E2C793A307D2C6F29297D3B7661722066663D22666C6F774E6F6465526566222C76663D226C616E6573223B66756E6374';
wwv_flow_imp.g_varchar2_table(41707) := '696F6E2062662865297B746869732E5F656C656D656E7452656769737472793D657D66756E6374696F6E205F662865297B746869732E5F6D6F64646C653D657D62662E24696E6A6563743D5B22656C656D656E745265676973747279225D2C62662E7072';
wwv_flow_imp.g_varchar2_table(41708) := '6F746F747970652E5F636F6D70757465557064617465733D66756E6374696F6E28652C74297B766172206E3D5B5D2C693D5B5D2C6F3D7B7D2C733D5B5D3B66756E6374696F6E20722865297B2D313D3D3D6E2E696E6465784F66286529262628732E7075';
wwv_flow_imp.g_varchar2_table(41709) := '73682865292C6E2E70757368286529297D72657475726E20742E666F7245616368282866756E6374696F6E2865297B76617220743D56682865293B6966287426262D313D3D3D6E2E696E6465784F66287429297B76617220693D742E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(41710) := '2E66696C746572282866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A466C6F774E6F646522297D29293B692E666F72456163682872292C6E2E707573682874297D7D29292C652E666F72456163682872292C732E';
wwv_flow_imp.g_varchar2_table(41711) := '666F7245616368282866756E6374696F6E2865297B76617220743D652E627573696E6573734F626A6563742C6E3D742E676574287666292E736C69636528292C733D66756E6374696F6E2865297B69662821652E706172656E742972657475726E5B5D3B';
wwv_flow_imp.g_varchar2_table(41712) := '76617220743D66756E6374696F6E2865297B76617220743D56682865293B72657475726E206F5B742E69645D7C7C286F5B742E69645D3D4668287429292C6F5B742E69645D7D2865293B72657475726E20742E66696C746572282866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41713) := '74297B72657475726E206E3D652C693D566E2874292C6F3D6E2E782B6E2E77696474682F322C733D6E2E792B6E2E6865696768742F322C6F3E692E6C65667426266F3C692E72696768742626733E692E746F702626733C692E626F74746F6D3B76617220';
wwv_flow_imp.g_varchar2_table(41714) := '6E2C692C6F2C737D29292E6D6170282866756E6374696F6E2865297B72657475726E20652E627573696E6573734F626A6563747D29297D2865293B692E70757368287B666C6F774E6F64653A742C72656D6F76653A6E2C6164643A737D297D29292C742E';
wwv_flow_imp.g_varchar2_table(41715) := '666F7245616368282866756E6374696F6E2865297B76617220743D652E627573696E6573734F626A6563743B652E706172656E747C7C742E676574286666292E666F7245616368282866756E6374696F6E2865297B692E70757368287B666C6F774E6F64';
wwv_flow_imp.g_varchar2_table(41716) := '653A652C72656D6F76653A5B745D2C6164643A5B5D7D297D29297D29292C697D2C62662E70726F746F747970652E657865637574653D66756E6374696F6E2865297B76617220743D652E757064617465733B72657475726E20747C7C28743D652E757064';
wwv_flow_imp.g_varchar2_table(41717) := '617465733D746869732E5F636F6D707574655570646174657328652E666C6F774E6F64655368617065732C652E6C616E6553686170657329292C742E666F7245616368282866756E6374696F6E2865297B76617220743D652E666C6F774E6F64652C6E3D';
wwv_flow_imp.g_varchar2_table(41718) := '742E676574287666293B652E72656D6F76652E666F7245616368282866756E6374696F6E2865297B5574286E2C65292C557428652E676574286666292C74297D29292C652E6164642E666F7245616368282866756E6374696F6E2865297B4B74286E2C65';
wwv_flow_imp.g_varchar2_table(41719) := '292C4B7428652E676574286666292C74297D29297D29292C5B5D7D2C62662E70726F746F747970652E7265766572743D66756E6374696F6E2865297B72657475726E20652E757064617465732E666F7245616368282866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(41720) := '7220743D652E666C6F774E6F64652C6E3D742E676574287666293B652E6164642E666F7245616368282866756E6374696F6E2865297B5574286E2C65292C557428652E676574286666292C74297D29292C652E72656D6F76652E666F7245616368282866';
wwv_flow_imp.g_varchar2_table(41721) := '756E6374696F6E2865297B4B74286E2C65292C4B7428652E676574286666292C74297D29297D29292C5B5D7D2C5F662E24696E6A6563743D5B226D6F64646C65225D2C5F662E70726F746F747970652E657865637574653D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(41722) := '76617220743D746869732E5F6D6F64646C652E6964732C6E3D652E69642C693D652E656C656D656E743B72657475726E20652E636C61696D696E673F742E636C61696D286E2C69293A742E756E636C61696D286E292C5B5D7D2C5F662E70726F746F7479';
wwv_flow_imp.g_varchar2_table(41723) := '70652E7265766572743D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64646C652E6964732C6E3D652E69642C693D652E656C656D656E743B72657475726E20652E636C61696D696E673F742E756E636C61696D286E293A742E636C61';
wwv_flow_imp.g_varchar2_table(41724) := '696D286E2C69292C5B5D7D3B7661722079663D7B66696C6C3A766F696420302C7374726F6B653A766F696420307D3B66756E6374696F6E2077662865297B746869732E5F636F6D6D616E64537461636B3D652C746869732E5F6E6F726D616C697A65436F';
wwv_flow_imp.g_varchar2_table(41725) := '6C6F723D66756E6374696F6E2865297B69662865297B69662828302C692E4B6729286529297B76617220743D66756E6374696F6E2865297B76617220743D646F63756D656E742E637265617465456C656D656E74282263616E76617322292E676574436F';
wwv_flow_imp.g_varchar2_table(41726) := '6E746578742822326422293B72657475726E20742E66696C6C5374796C653D227472616E73706172656E74222C742E66696C6C5374796C653D652C2F5E235B302D39612D66412D465D7B367D242F2E7465737428742E66696C6C5374796C65293F742E66';
wwv_flow_imp.g_varchar2_table(41727) := '696C6C5374796C653A6E756C6C7D2865293B696628742972657475726E20747D7468726F77206E6577204572726F722860696E76616C696420636F6C6F722076616C75653A20247B657D60297D7D7D77662E24696E6A6563743D5B22636F6D6D616E6453';
wwv_flow_imp.g_varchar2_table(41728) := '7461636B225D2C77662E70726F746F747970652E706F7374457865637574653D66756E6374696F6E2865297B76617220743D652E656C656D656E74732C6E3D652E636F6C6F72737C7C79662C6F3D746869732C733D7B7D3B2266696C6C22696E206E2626';
wwv_flow_imp.g_varchar2_table(41729) := '28302C692E6B702928732C7B226261636B67726F756E642D636F6C6F72223A746869732E5F6E6F726D616C697A65436F6C6F72286E2E66696C6C297D292C227374726F6B6522696E206E262628302C692E6B702928732C7B22626F726465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(41730) := '72223A746869732E5F6E6F726D616C697A65436F6C6F72286E2E7374726F6B65297D292C28302C692E6A4A2928742C2866756E6374696F6E2865297B76617220743D4F6E2865293F28302C692E55702928732C5B22626F726465722D636F6C6F72225D29';
wwv_flow_imp.g_varchar2_table(41731) := '3A732C6E3D28302C792E6765744469292865293B69662866756E6374696F6E2865297B22626F726465722D636F6C6F7222696E2065262628652E7374726F6B653D655B22626F726465722D636F6C6F72225D292C226261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(41732) := '7222696E2065262628652E66696C6C3D655B226261636B67726F756E642D636F6C6F72225D297D2874292C526E286529296F2E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F706572';
wwv_flow_imp.g_varchar2_table(41733) := '74696573222C7B656C656D656E743A652C6D6F64646C65456C656D656E743A6E2E6C6162656C2C70726F706572746965733A7B636F6C6F723A735B22626F726465722D636F6C6F72225D7D7D293B656C73657B6966282128302C792E6973416E7929286E';
wwv_flow_imp.g_varchar2_table(41734) := '2C5B2262706D6E64693A42504D4E45646765222C2262706D6E64693A42504D4E5368617065225D292972657475726E3B6F2E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E742E75706461746550726F70657274696573222C7B';
wwv_flow_imp.g_varchar2_table(41735) := '656C656D656E743A652C70726F706572746965733A7B64693A747D7D297D7D29297D3B7661722043663D7B77696474683A302C6865696768743A307D3B66756E6374696F6E20536628652C742C6E297B66756E6374696F6E206928652C74297B76617220';
wwv_flow_imp.g_varchar2_table(41736) := '6E3D652E6C6162656C7C7C652C693D652E6C6162656C5461726765747C7C653B72657475726E2066756E6374696F6E28652C74297B766172206E3D652E627573696E6573734F626A6563742C693D7573286E293B692626282263617465676F727956616C';
wwv_flow_imp.g_varchar2_table(41737) := '7565526566223D3D3D693F6E2E63617465676F727956616C75655265662E76616C75653D743A6E5B695D3D74297D286E2C74292C5B6E2C695D7D746869732E707265457865637574653D66756E6374696F6E2874297B766172206E3D742E656C656D656E';
wwv_flow_imp.g_varchar2_table(41738) := '742C693D6E2E627573696E6573734F626A6563742C6F3D742E6E65774C6162656C3B69662821526E286E2926266373286E292626216473286E292626217866286F29297B76617220733D6873286E293B733D7B783A732E782C793A732E792B377D2C652E';
wwv_flow_imp.g_varchar2_table(41739) := '6372656174654C6162656C286E2C732C7B69643A692E69642B225F6C6162656C222C627573696E6573734F626A6563743A692C64693A6E2E64697D297D7D2C746869732E657865637574653D66756E6374696F6E2865297B72657475726E20652E6F6C64';
wwv_flow_imp.g_varchar2_table(41740) := '4C6162656C3D707328652E656C656D656E74292C6928652E656C656D656E742C652E6E65774C6162656C297D2C746869732E7265766572743D66756E6374696F6E2865297B72657475726E206928652E656C656D656E742C652E6F6C644C6162656C297D';
wwv_flow_imp.g_varchar2_table(41741) := '2C746869732E706F7374457865637574653D66756E6374696F6E286E297B76617220693D6E2E656C656D656E742C6F3D692E6C6162656C7C7C692C733D6E2E6E65774C6162656C2C723D6E2E6E6577426F756E64732C613D6E2E68696E74737C7C7B7D3B';
wwv_flow_imp.g_varchar2_table(41742) := '696628526E286F297C7C28302C792E697329286F2C2262706D6E3A54657874416E6E6F746174696F6E222929696628526E286F2926267866287329292131213D3D612E72656D6F766553686170652626652E72656D6F76655368617065286F2C7B756E73';
wwv_flow_imp.g_varchar2_table(41743) := '65744C6162656C3A21317D293B656C73657B766172206C3D70732869293B766F696420303D3D3D72262628723D742E67657445787465726E616C4C6162656C426F756E6473286F2C6C29292C722626652E726573697A655368617065286F2C722C436629';
wwv_flow_imp.g_varchar2_table(41744) := '7D7D7D66756E6374696F6E2078662865297B72657475726E21657C7C21652E7472696D28297D66756E6374696F6E206B6628652C742C6E2C69297B74662E63616C6C28746869732C652C742C6E292C746869732E5F62706D6E52756C65733D697D66756E';
wwv_flow_imp.g_varchar2_table(41745) := '6374696F6E20456628297B7D53662E24696E6A6563743D5B226D6F64656C696E67222C227465787452656E6465726572222C2262706D6E466163746F7279225D2C52286B662C7466292C6B662E24696E6A6563743D5B226576656E74427573222C22656C';
wwv_flow_imp.g_varchar2_table(41746) := '656D656E74466163746F7279222C22636F6D6D616E64537461636B222C2262706D6E52756C6573225D2C6B662E70726F746F747970652E67657448616E646C6572733D66756E6374696F6E28297B76617220653D74662E70726F746F747970652E676574';
wwv_flow_imp.g_varchar2_table(41747) := '48616E646C6572732E63616C6C2874686973293B72657475726E20655B22656C656D656E742E7570646174654D6F64646C6550726F70657274696573225D3D6E662C655B22656C656D656E742E75706461746550726F70657274696573225D3D6C662C65';
wwv_flow_imp.g_varchar2_table(41748) := '5B2263616E7661732E757064617465526F6F74225D3D75662C655B226C616E652E616464225D3D70662C655B226C616E652E726573697A65225D3D6D662C655B226C616E652E73706C6974225D3D67662C655B226C616E652E7570646174655265667322';
wwv_flow_imp.g_varchar2_table(41749) := '5D3D62662C655B2269642E757064617465436C61696D225D3D5F662C655B22656C656D656E742E736574436F6C6F72225D3D77662C655B22656C656D656E742E7570646174654C6162656C225D3D53662C657D2C6B662E70726F746F747970652E757064';
wwv_flow_imp.g_varchar2_table(41750) := '6174654C6162656C3D66756E6374696F6E28652C742C6E2C69297B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E742E7570646174654C6162656C222C7B656C656D656E743A652C6E65774C6162656C3A742C6E65';
wwv_flow_imp.g_varchar2_table(41751) := '77426F756E64733A6E2C68696E74733A697C7C7B7D7D297D2C6B662E70726F746F747970652E636F6E6E6563743D66756E6374696F6E28652C742C6E2C69297B766172206F3D746869732E5F62706D6E52756C65733B6966286E7C7C286E3D6F2E63616E';
wwv_flow_imp.g_varchar2_table(41752) := '436F6E6E65637428652C7429292C6E2972657475726E20746869732E637265617465436F6E6E656374696F6E28652C742C6E2C652E706172656E742C69297D2C6B662E70726F746F747970652E7570646174654D6F64646C6550726F706572746965733D';
wwv_flow_imp.g_varchar2_table(41753) := '66756E6374696F6E28652C742C6E297B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A652C6D6F64646C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(41754) := '3A742C70726F706572746965733A6E7D297D2C6B662E70726F746F747970652E75706461746550726F706572746965733D66756E6374696F6E28652C74297B746869732E5F636F6D6D616E64537461636B2E657865637574652822656C656D656E742E75';
wwv_flow_imp.g_varchar2_table(41755) := '706461746550726F70657274696573222C7B656C656D656E743A652C70726F706572746965733A747D297D2C6B662E70726F746F747970652E726573697A654C616E653D66756E6374696F6E28652C742C6E297B746869732E5F636F6D6D616E64537461';
wwv_flow_imp.g_varchar2_table(41756) := '636B2E6578656375746528226C616E652E726573697A65222C7B73686170653A652C6E6577426F756E64733A742C62616C616E6365643A6E7D297D2C6B662E70726F746F747970652E6164644C616E653D66756E6374696F6E28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(41757) := '3D7B73686170653A652C6C6F636174696F6E3A747D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E6578656375746528226C616E652E616464222C6E292C6E2E6E65774C616E657D2C6B662E70726F746F747970652E73706C69744C';
wwv_flow_imp.g_varchar2_table(41758) := '616E653D66756E6374696F6E28652C74297B746869732E5F636F6D6D616E64537461636B2E6578656375746528226C616E652E73706C6974222C7B73686170653A652C636F756E743A747D297D2C6B662E70726F746F747970652E6D616B65436F6C6C61';
wwv_flow_imp.g_varchar2_table(41759) := '626F726174696F6E3D66756E6374696F6E28297B76617220653D746869732E5F6372656174652822726F6F74222C7B747970653A2262706D6E3A436F6C6C61626F726174696F6E227D292C743D7B6E6577526F6F743A657D3B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(41760) := '2E5F636F6D6D616E64537461636B2E65786563757465282263616E7661732E757064617465526F6F74222C74292C657D2C6B662E70726F746F747970652E6D616B6550726F636573733D66756E6374696F6E28297B76617220653D746869732E5F637265';
wwv_flow_imp.g_varchar2_table(41761) := '6174652822726F6F74222C7B747970653A2262706D6E3A50726F63657373227D292C743D7B6E6577526F6F743A657D3B72657475726E20746869732E5F636F6D6D616E64537461636B2E65786563757465282263616E7661732E757064617465526F6F74';
wwv_flow_imp.g_varchar2_table(41762) := '222C74292C657D2C6B662E70726F746F747970652E7570646174654C616E65526566733D66756E6374696F6E28652C74297B746869732E5F636F6D6D616E64537461636B2E6578656375746528226C616E652E75706461746552656673222C7B666C6F77';
wwv_flow_imp.g_varchar2_table(41763) := '4E6F64655368617065733A652C6C616E655368617065733A747D297D2C6B662E70726F746F747970652E636C61696D49643D66756E6374696F6E28652C74297B746869732E5F636F6D6D616E64537461636B2E65786563757465282269642E7570646174';
wwv_flow_imp.g_varchar2_table(41764) := '65436C61696D222C7B69643A652C656C656D656E743A742C636C61696D696E673A21307D297D2C6B662E70726F746F747970652E756E636C61696D49643D66756E6374696F6E28652C74297B746869732E5F636F6D6D616E64537461636B2E6578656375';
wwv_flow_imp.g_varchar2_table(41765) := '7465282269642E757064617465436C61696D222C7B69643A652C656C656D656E743A747D297D2C6B662E70726F746F747970652E736574436F6C6F723D66756E6374696F6E28652C74297B652E6C656E6774687C7C28653D5B655D292C746869732E5F63';
wwv_flow_imp.g_varchar2_table(41766) := '6F6D6D616E64537461636B2E657865637574652822656C656D656E742E736574436F6C6F72222C7B656C656D656E74733A652C636F6C6F72733A747D297D2C45662E70726F746F747970652E6C61796F7574436F6E6E656374696F6E3D66756E6374696F';
wwv_flow_imp.g_varchar2_table(41767) := '6E28652C74297B72657475726E5B28743D747C7C7B7D292E636F6E6E656374696F6E53746172747C7C486E28742E736F757263657C7C652E736F75726365292C742E636F6E6E656374696F6E456E647C7C486E28742E7461726765747C7C652E74617267';
wwv_flow_imp.g_varchar2_table(41768) := '6574295D7D3B766172204C663D32302C44663D352C54663D4D6174682E726F756E642C49663D32302C4D663D7B22683A68223A32302C22763A76223A32302C22683A76223A2D31302C22763A68223A2D31307D3B66756E6374696F6E20416628652C742C';
wwv_flow_imp.g_varchar2_table(41769) := '6E297B76617220692C6F2C732C723D576E28742C652C4466292C613D6E2E73706C697428223A22295B305D2C6C3D54662828742E782D652E78292F322B652E78292C633D54662828742E792D652E79292F322B652E79292C643D28733D722C7B743A2F74';
wwv_flow_imp.g_varchar2_table(41770) := '6F702F2C723A2F72696768742F2C623A2F626F74746F6D2F2C6C3A2F6C6566742F2C683A2F6C6566747C72696768742F2C763A2F746F707C626F74746F6D2F7D5B615D2E74657374287329292C683D2F687C727C6C2F2E746573742861292C753D21312C';
wwv_flow_imp.g_varchar2_table(41771) := '703D21313B72657475726E20643F28693D683F7B783A6C2C793A652E797D3A7B783A652E782C793A637D2C6F3D683F22683A68223A22763A7622293A28753D66756E6374696F6E28652C74297B72657475726E217B743A2F746F702F2C723A2F72696768';
wwv_flow_imp.g_varchar2_table(41772) := '742F2C623A2F626F74746F6D2F2C6C3A2F6C6566742F2C683A2F2E2F2C763A2F2E2F7D5B745D2E746573742865297D28722C61292C6F3D683F22683A76223A22763A68222C753F683F28703D633D3D3D652E792C693D7B783A652E782B4C662A282F6C2F';
wwv_flow_imp.g_varchar2_table(41773) := '2E746573742861293F2D313A31292C793A703F632B4C663A637D293A693D7B783A28703D6C3D3D3D652E78293F6C2B4C663A6C2C793A652E792B4C662A282F742F2E746573742861293F2D313A31297D3A693D7B783A6C2C793A637D292C7B776179706F';
wwv_flow_imp.g_varchar2_table(41774) := '696E74733A506628652C692C6F292E636F6E6361742869292C646972656374696F6E733A6F2C7475726E4E657874446972656374696F6E733A707D7D66756E6374696F6E204E662865297B72657475726E20652E73706C697428223A22292E7265766572';
wwv_flow_imp.g_varchar2_table(41775) := '736528292E6A6F696E28223A22297D66756E6374696F6E20506628652C742C6E297B6966282166756E6374696F6E2865297B72657475726E206526262F5E687C767C747C727C627C6C3A687C767C747C727C627C6C242F2E746573742865297D286E3D6E';
wwv_flow_imp.g_varchar2_table(41776) := '7C7C22683A682229297468726F77206E6577204572726F722822756E6B6E6F776E20646972656374696F6E733A203C222B6E2B223E3A206D75737420626520737065636966696564206173203C73746172743E3A3C656E643E2077697468207374617274';
wwv_flow_imp.g_varchar2_table(41777) := '2F656E6420696E207B20682C762C742C722C622C6C207D22293B6966284266286E29297B76617220693D66756E6374696F6E28652C742C6E297B72657475726E20416628652C742C6E297D28652C742C6E292C6F3D66756E6374696F6E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(41778) := '7B76617220693D416628742C652C4E66286E29293B72657475726E7B776179706F696E74733A692E776179706F696E74732E736C69636528292E7265766572736528292C646972656374696F6E733A4E6628692E646972656374696F6E73292C7475726E';
wwv_flow_imp.g_varchar2_table(41779) := '4E657874446972656374696F6E733A692E7475726E4E657874446972656374696F6E737D7D28652C742C6E292C733D66756E6374696F6E28652C74297B766172206E3D652E646972656374696F6E732E73706C697428223A22295B315D2C693D742E6469';
wwv_flow_imp.g_varchar2_table(41780) := '72656374696F6E732E73706C697428223A22295B305D3B652E7475726E4E657874446972656374696F6E732626286E3D2268223D3D6E3F2276223A226822292C742E7475726E4E657874446972656374696F6E73262628693D2268223D3D693F2276223A';
wwv_flow_imp.g_varchar2_table(41781) := '226822293B766172206F3D6E2B223A222B693B72657475726E7B776179706F696E74733A506628652E776179706F696E74735B652E776179706F696E74732E6C656E6774682D315D2C742E776179706F696E74735B305D2C6F292C646972656374696F6E';
wwv_flow_imp.g_varchar2_table(41782) := '733A6F7D7D28692C6F293B72657475726E5B5D2E636F6E63617428692E776179706F696E74732C732E776179706F696E74732C6F2E776179706F696E7473297D72657475726E2066756E6374696F6E28652C742C6E297B76617220693D54662828742E78';
wwv_flow_imp.g_varchar2_table(41783) := '2D652E78292F322B652E78292C6F3D54662828742E792D652E79292F322B652E79293B69662822683A76223D3D3D6E2972657475726E5B7B783A742E782C793A652E797D5D3B69662822763A68223D3D3D6E2972657475726E5B7B783A652E782C793A74';
wwv_flow_imp.g_varchar2_table(41784) := '2E797D5D3B69662822683A68223D3D3D6E2972657475726E5B7B783A692C793A652E797D2C7B783A692C793A742E797D5D3B69662822763A76223D3D3D6E2972657475726E5B7B783A652E782C793A6F7D2C7B783A742E782C793A6F7D5D3B7468726F77';
wwv_flow_imp.g_varchar2_table(41785) := '206E6577204572726F722822696E76616C696420646972656374696F6E733A2063616E206F6E6C792068616E646C652076617269616E73206F66205B68765D3A5B68765D22297D28652C742C6E297D66756E6374696F6E204F6628652C742C6E2C6F2C73';
wwv_flow_imp.g_varchar2_table(41786) := '2C72297B76617220613B72657475726E28302C692E637929286E29262628733D6E2C723D6F2C6E3D486E2865292C6F3D486E287429292C733D737C7C5B5D2C613D2D31213D3D28723D28302C692E6B7029287B7072656665727265644C61796F7574733A';
wwv_flow_imp.g_varchar2_table(41787) := '5B5D7D2C7229292E7072656665727265644C61796F7574732E696E6465784F66282273747261696768742229262666756E6374696F6E28652C742C6E2C692C6F297B76617220732C722C613D7B7D3B72657475726E20723D576E28652C74292C2F5E2874';
wwv_flow_imp.g_varchar2_table(41788) := '6F707C626F74746F6D7C6C6566747C726967687429242F2E746573742872293F282F746F707C626F74746F6D2F2E74657374287229262628733D227822292C2F6C6566747C72696768742F2E74657374287229262628733D227922292C22746172676574';
wwv_flow_imp.g_varchar2_table(41789) := '223D3D3D6F2E7072657365727665446F636B696E673F526628732C692C65293F28615B735D3D695B735D2C5B7B783A766F69642030213D3D612E783F612E783A6E2E782C793A766F69642030213D3D612E793F612E793A6E2E792C6F726967696E616C3A';
wwv_flow_imp.g_varchar2_table(41790) := '7B783A766F69642030213D3D612E783F612E783A6E2E782C793A766F69642030213D3D612E793F612E793A6E2E797D7D2C7B783A692E782C793A692E797D5D293A6E756C6C3A526628732C6E2C74293F28615B735D3D6E5B735D2C5B7B783A6E2E782C79';
wwv_flow_imp.g_varchar2_table(41791) := '3A6E2E797D2C7B783A766F69642030213D3D612E783F612E783A692E782C793A766F69642030213D3D612E793F612E793A692E792C6F726967696E616C3A7B783A766F69642030213D3D612E783F612E783A692E782C793A766F69642030213D3D612E79';
wwv_flow_imp.g_varchar2_table(41792) := '3F612E793A692E797D7D5D293A6E756C6C293A6E756C6C7D28652C742C6E2C6F2C72292C617C7C28613D722E636F6E6E656374696F6E456E64262666756E6374696F6E28652C742C6E2C69297B766172206F3D692E736C69636528292E72657665727365';
wwv_flow_imp.g_varchar2_table(41793) := '28293B72657475726E286F3D466628652C742C6E2C6F29293F6F2E7265766572736528293A6E756C6C7D28742C652C6F2C73292C617C7C28613D722E636F6E6E656374696F6E53746172742626466628652C742C6E2C7329297C7C2821722E636F6E6E65';
wwv_flow_imp.g_varchar2_table(41794) := '6374696F6E5374617274262621722E636F6E6E656374696F6E456E642626732626732E6C656E6774683F733A66756E6374696F6E28652C742C6E2C6F2C73297B76617220723D732626732E7072656665727265644C61796F7574737C7C5B5D2C613D2830';
wwv_flow_imp.g_varchar2_table(41795) := '2C692E46462928722C22737472616967687422295B305D7C7C22683A68222C6C3D576E28652C742C4D665B615D7C7C30292C633D66756E6374696F6E28652C74297B69662842662874292972657475726E20743B7377697463682865297B636173652269';
wwv_flow_imp.g_varchar2_table(41796) := '6E74657273656374223A72657475726E22743A74223B6361736522746F70223A6361736522626F74746F6D223A72657475726E22763A76223B63617365226C656674223A63617365227269676874223A72657475726E22683A68223B64656661756C743A';
wwv_flow_imp.g_varchar2_table(41797) := '72657475726E20747D7D286C2C61293B6E3D6E7C7C486E2865292C6F3D6F7C7C486E2874293B76617220643D632E73706C697428223A22292C683D5666286E2C652C645B305D2C66756E6374696F6E2865297B72657475726E7B746F703A22626F74746F';
wwv_flow_imp.g_varchar2_table(41798) := '6D222C626F74746F6D3A22746F70222C6C6566743A227269676874222C72696768743A226C656674222C22746F702D6C656674223A22626F74746F6D2D7269676874222C22626F74746F6D2D7269676874223A22746F702D6C656674222C22746F702D72';
wwv_flow_imp.g_varchar2_table(41799) := '69676874223A22626F74746F6D2D6C656674222C22626F74746F6D2D6C656674223A22746F702D7269676874227D5B655D7D286C29293B72657475726E2066756E6374696F6E28652C742C6E297B76617220693D506628652C742C6E293B72657475726E';
wwv_flow_imp.g_varchar2_table(41800) := '20692E756E73686966742865292C692E707573682874292C7A662869297D28682C5666286F2C742C645B315D2C6C292C63297D28652C742C6E2C6F2C722929297D66756E6374696F6E20526628652C742C6E297B72657475726E2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41801) := '652C742C6E297B72657475726E20653E3D742626653C3D6E7D28745B655D2C6E5B655D2C6E5B655D2B6E5B7B783A227769647468222C793A22686569676874227D5B655D5D297D66756E6374696F6E20466628652C742C6E2C6F297B69662866756E6374';
wwv_flow_imp.g_varchar2_table(41802) := '696F6E2865297B72657475726E20652E6C656E6774683C337C7C2128652E6C656E6774683E34292626212128302C692E49362928652C2866756E6374696F6E28742C6E297B76617220693D655B6E2D315D3B72657475726E20692626517428742C69293C';
wwv_flow_imp.g_varchar2_table(41803) := '337D29297D286F292972657475726E206E756C6C3B76617220732C723D6F5B305D2C613D6F2E736C69636528293B72657475726E20615B305D3D6E2C615B315D3D66756E6374696F6E28652C742C6E297B73776974636828587428742C6529297B636173';
wwv_flow_imp.g_varchar2_table(41804) := '652276223A72657475726E7B783A6E2E782C793A652E797D3B636173652268223A72657475726E7B783A652E782C793A6E2E797D7D72657475726E7B783A652E782C793A652E797D7D28615B315D2C722C6E292C733D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(41805) := '297B76617220693B666F7228693D652E6C656E6774682D323B30213D3D693B692D2D29696628656E28655B695D2C742C4966297C7C656E28655B695D2C6E2C4966292972657475726E20652E736C6963652869293B72657475726E20657D28612C652C74';
wwv_flow_imp.g_varchar2_table(41806) := '292C73213D3D61262628613D466628652C742C6E2C7329292C61262658742861293F6E756C6C3A617D66756E6374696F6E2042662865297B72657475726E206526262F747C727C627C6C2F2E746573742865297D66756E6374696F6E20566628652C742C';
wwv_flow_imp.g_varchar2_table(41807) := '6E2C69297B6966282268223D3D3D6E2626286E3D2F6C6566742F2E746573742869293F226C223A227222292C2276223D3D3D6E2626286E3D2F746F702F2E746573742869293F2274223A226222292C2274223D3D3D6E2972657475726E7B6F726967696E';
wwv_flow_imp.g_varchar2_table(41808) := '616C3A652C783A652E782C793A742E797D3B6966282272223D3D3D6E2972657475726E7B6F726967696E616C3A652C783A742E782B742E77696474682C793A652E797D3B6966282262223D3D3D6E2972657475726E7B6F726967696E616C3A652C783A65';
wwv_flow_imp.g_varchar2_table(41809) := '2E782C793A742E792B742E6865696768747D3B696628226C223D3D3D6E2972657475726E7B6F726967696E616C3A652C783A742E782C793A652E797D3B7468726F77206E6577204572726F722822756E657870656374656420646F636B696E6744697265';
wwv_flow_imp.g_varchar2_table(41810) := '6374696F6E3A203C222B6E2B223E22297D66756E6374696F6E207A662865297B72657475726E20652E726564756365282866756E6374696F6E28742C6E2C69297B72657475726E20597428745B742E6C656E6774682D315D2C655B692B315D2C6E2C3029';
wwv_flow_imp.g_varchar2_table(41811) := '7C7C742E70757368286E292C747D292C5B5D297D7661722048663D34302C57663D7B64656661756C743A5B22683A68225D2C66726F6D476174657761793A5B22763A68225D2C746F476174657761793A5B22683A76225D2C6C6F6F703A7B66726F6D546F';
wwv_flow_imp.g_varchar2_table(41812) := '703A5B22743A72225D2C66726F6D52696768743A5B22723A62225D2C66726F6D4C6566743A5B226C3A74225D2C66726F6D426F74746F6D3A5B22623A6C225D7D2C626F756E646172794C6F6F703A7B616C7465726E617465486F72697A6F6E74616C5369';
wwv_flow_imp.g_varchar2_table(41813) := '64653A2262222C616C7465726E617465566572746963616C536964653A226C222C64656661756C743A2276227D2C6D657373616765466C6F773A5B227374726169676874222C22763A76225D2C73756250726F636573733A5B227374726169676874222C';
wwv_flow_imp.g_varchar2_table(41814) := '22683A68225D2C6973486F72697A6F6E74616C3A21307D2C6A663D7B64656661756C743A5B22763A76225D2C66726F6D476174657761793A5B22683A76225D2C746F476174657761793A5B22763A68225D2C6C6F6F703A7B66726F6D546F703A5B22743A';
wwv_flow_imp.g_varchar2_table(41815) := '6C225D2C66726F6D52696768743A5B22723A74225D2C66726F6D4C6566743A5B226C3A62225D2C66726F6D426F74746F6D3A5B22623A72225D7D2C626F756E646172794C6F6F703A7B616C7465726E617465486F72697A6F6E74616C536964653A227422';
wwv_flow_imp.g_varchar2_table(41816) := '2C616C7465726E617465566572746963616C536964653A2272222C64656661756C743A2268227D2C6D657373616765466C6F773A5B227374726169676874222C22683A68225D2C73756250726F636573733A5B227374726169676874222C22763A76225D';
wwv_flow_imp.g_varchar2_table(41817) := '2C6973486F72697A6F6E74616C3A21317D2C71663D7B746F703A22626F74746F6D222C22746F702D7269676874223A22626F74746F6D2D6C656674222C22746F702D6C656674223A22626F74746F6D2D7269676874222C72696768743A226C656674222C';
wwv_flow_imp.g_varchar2_table(41818) := '626F74746F6D3A22746F70222C22626F74746F6D2D7269676874223A22746F702D6C656674222C22626F74746F6D2D6C656674223A22746F702D7269676874222C6C6566743A227269676874227D2C24663D7B746F703A2274222C72696768743A227222';
wwv_flow_imp.g_varchar2_table(41819) := '2C626F74746F6D3A2262222C6C6566743A226C227D3B66756E6374696F6E20556628297B7D66756E6374696F6E204B6628652C74297B72657475726E28302C792E69732928742C2262706D6E3A5061727469636970616E7422293F22736F75726365223A';
wwv_flow_imp.g_varchar2_table(41820) := '28302C792E69732928652C2262706D6E3A5061727469636970616E7422293F22746172676574223A5A662874293F22736F75726365223A5A662865297C7C28302C792E69732928742C2262706D6E3A4576656E7422293F22746172676574223A28302C79';
wwv_flow_imp.g_varchar2_table(41821) := '2E69732928652C2262706D6E3A4576656E7422293F22736F75726365223A6E756C6C7D66756E6374696F6E2047662865297B72657475726E205A662865293F22746172676574223A22736F75726365227D66756E6374696F6E20516628652C74297B7265';
wwv_flow_imp.g_varchar2_table(41822) := '7475726E20653F652E6F726967696E616C7C7C653A486E2874297D66756E6374696F6E20596628652C74297B72657475726E28302C792E69732928742C2262706D6E3A41637469766974792229262628302C792E69732928652C2262706D6E3A426F756E';
wwv_flow_imp.g_varchar2_table(41823) := '646172794576656E7422292626742E627573696E6573734F626A6563742E6973466F72436F6D70656E736174696F6E7D66756E6374696F6E205A662865297B72657475726E28302C792E69732928652C2262706D6E3A53756250726F6365737322292626';
wwv_flow_imp.g_varchar2_table(41824) := '28302C72732E4176292865297D66756E6374696F6E20586628652C74297B72657475726E20653D3D3D747D66756E6374696F6E204A662865297B76617220743D2F72696768747C6C6566742F2E657865632865293B72657475726E20742626745B305D7D';
wwv_flow_imp.g_varchar2_table(41825) := '66756E6374696F6E2065762865297B76617220743D2F746F707C626F74746F6D2F2E657865632865293B72657475726E20742626745B305D7D66756E6374696F6E20747628652C74297B72657475726E2071665B655D3D3D3D747D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(41826) := '6E762865297B72657475726E227269676874223D3D3D657C7C226C656674223D3D3D657D66756E6374696F6E20697628652C742C6E297B76617220693D742E776179706F696E74732C6F3D692626692E6C656E6774682626576E28695B305D2C65293B72';
wwv_flow_imp.g_varchar2_table(41827) := '657475726E22746F70223D3D3D6F3F6E2E6C6F6F702E66726F6D546F703A227269676874223D3D3D6F3F6E2E6C6F6F702E66726F6D52696768743A226C656674223D3D3D6F3F6E2E6C6F6F702E66726F6D4C6566743A6E2E6C6F6F702E66726F6D426F74';
wwv_flow_imp.g_varchar2_table(41828) := '746F6D7D66756E6374696F6E206F7628652C742C6E2C69297B766172206F2C732C722C612C6C3D486E2865292C633D486E2874292C643D28613D28723D65292E686F73742C576E28486E2872292C612C2D313029292C683D586628652E686F73742C7429';
wwv_flow_imp.g_varchar2_table(41829) := '2C753D2D31213D3D5B22746F70222C227269676874222C22626F74746F6D222C226C656674225D2E696E6465784F662864292C703D576E28632C6C2C7B783A652E77696474682F322B742E77696474682F322C793A652E6865696768742F322B742E6865';
wwv_flow_imp.g_varchar2_table(41830) := '696768742F327D293B72657475726E20683F66756E6374696F6E28652C742C6E2C692C6F2C73297B76617220723D743F653A732E6973486F72697A6F6E74616C3F65762865293A4A662865293B72657475726E5B24665B725D2B223A222B28743F6E7628';
wwv_flow_imp.g_varchar2_table(41831) := '65293F7376282279222C6E2C692C6F293F2268223A732E626F756E646172794C6F6F702E616C7465726E617465486F72697A6F6E74616C536964653A7376282278222C6E2C692C6F293F2276223A732E626F756E646172794C6F6F702E616C7465726E61';
wwv_flow_imp.g_varchar2_table(41832) := '7465566572746963616C536964653A732E626F756E646172794C6F6F702E64656661756C74295D7D28642C752C652C742C6E2C69293A286F3D66756E6374696F6E28652C742C6E2C69297B6966286E2972657475726E2024665B655D3B766172206F3D65';
wwv_flow_imp.g_varchar2_table(41833) := '762865292C733D4A662865292C723D65762874292C613D4A662874293B69662869297B6966285866286F2C72297C7C747628732C61292972657475726E2024665B6F5D7D656C736520696628586628732C61297C7C7476286F2C72292972657475726E20';
wwv_flow_imp.g_varchar2_table(41834) := '24665B735D3B72657475726E2024665B693F733A6F5D7D28642C702C752C692E6973486F72697A6F6E74616C292C733D66756E6374696F6E28652C742C6E2C69297B72657475726E206E3F6E762865293F66756E6374696F6E28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(41835) := '3D4A662865292C693D71665B6E5D3B72657475726E2D31213D3D742E696E6465784F662869297D28652C74297C7C586628652C74293F2268223A2276223A66756E6374696F6E28652C74297B766172206E3D65762865292C693D71665B6E5D3B72657475';
wwv_flow_imp.g_varchar2_table(41836) := '726E2D31213D3D742E696E6465784F662869297D28652C74297C7C586628652C74293F2276223A2268223A693F58662865762865292C6576287429293F2268223A2276223A5866284A662865292C4A66287429293F2276223A2268227D28642C702C752C';
wwv_flow_imp.g_varchar2_table(41837) := '692E6973486F72697A6F6E74616C292C5B6F2B223A222B735D297D66756E6374696F6E20737628652C742C6E2C69297B766172206F3D48663B72657475726E2128727628652C692C6E2C6F297C7C727628652C692C7B783A6E2E782B6E2E77696474682C';
wwv_flow_imp.g_varchar2_table(41838) := '793A6E2E792B6E2E6865696768747D2C6F297C7C727628652C692C486E2874292C6F29297D66756E6374696F6E20727628652C742C6E2C69297B72657475726E204D6174682E61627328745B655D2D6E5B655D293C697D66756E6374696F6E2061762865';
wwv_flow_imp.g_varchar2_table(41839) := '297B72657475726E28302C692E6B7029287B6F726967696E616C3A652E706F696E742E6F726967696E616C7C7C652E706F696E747D2C652E61637475616C297D66756E6374696F6E206C7628652C74297B746869732E5F656C656D656E74526567697374';
wwv_flow_imp.g_varchar2_table(41840) := '72793D652C746869732E5F6772617068696373466163746F72793D747D522855662C4566292C55662E70726F746F747970652E6C61796F7574436F6E6E656374696F6E3D66756E6374696F6E28652C74297B747C7C28743D7B7D293B766172206E2C6F2C';
wwv_flow_imp.g_varchar2_table(41841) := '733D742E736F757263657C7C652E736F757263652C723D742E7461726765747C7C652E7461726765742C613D742E776179706F696E74737C7C652E776179706F696E74732C6C3D742E636F6E6E656374696F6E53746172742C633D742E636F6E6E656374';
wwv_flow_imp.g_varchar2_table(41842) := '696F6E456E643B6966286C7C7C286C3D516628612626615B305D2C7329292C637C7C28633D516628612626615B612E6C656E6774682D315D2C7229292C2828302C792E69732928652C2262706D6E3A4173736F63696174696F6E22297C7C28302C792E69';
wwv_flow_imp.g_varchar2_table(41843) := '732928652C2262706D6E3A446174614173736F63696174696F6E222929262661262621596628732C72292972657475726E5B5D2E636F6E636174285B6C5D2C612E736C69636528312C2D31292C5B635D293B76617220643D28302C4C632E697344697265';
wwv_flow_imp.g_varchar2_table(41844) := '6374696F6E486F72697A6F6E74616C292873293F57663A6A663B72657475726E28302C792E69732928652C2262706D6E3A4D657373616765466C6F7722293F6E3D66756E6374696F6E28652C742C6E297B72657475726E7B7072656665727265644C6179';
wwv_flow_imp.g_varchar2_table(41845) := '6F7574733A6E2E6D657373616765466C6F772C7072657365727665446F636B696E673A4B6628652C74297D7D28732C722C64293A2828302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722297C7C596628732C7229292626286E3D73';
wwv_flow_imp.g_varchar2_table(41846) := '3D3D3D723F7B7072656665727265644C61796F7574733A697628732C652C64297D3A28302C792E69732928732C2262706D6E3A426F756E646172794576656E7422293F7B7072656665727265644C61796F7574733A6F7628732C722C632C64297D3A5A66';
wwv_flow_imp.g_varchar2_table(41847) := '2873297C7C5A662872293F7B7072656665727265644C61796F7574733A642E73756250726F636573732C7072657365727665446F636B696E673A47662873297D3A28302C792E69732928732C2262706D6E3A4761746577617922293F7B70726566657272';
wwv_flow_imp.g_varchar2_table(41848) := '65644C61796F7574733A642E66726F6D476174657761797D3A28302C792E69732928722C2262706D6E3A4761746577617922293F7B7072656665727265644C61796F7574733A642E746F476174657761797D3A7B7072656665727265644C61796F757473';
wwv_flow_imp.g_varchar2_table(41849) := '3A642E64656661756C747D292C6E2626286F3D7A66284F6628732C722C6C2C632C612C6E3D28302C692E6B7029286E2C74292929292C6F7C7C5B6C2C635D7D2C6C762E24696E6A6563743D5B22656C656D656E745265676973747279222C226772617068';
wwv_flow_imp.g_varchar2_table(41850) := '696373466163746F7279225D2C6C762E70726F746F747970652E67657443726F70706564576179706F696E74733D66756E6374696F6E28652C742C6E297B743D747C7C652E736F757263652C6E3D6E7C7C652E7461726765743B76617220693D74686973';
wwv_flow_imp.g_varchar2_table(41851) := '2E676574446F636B696E67506F696E7428652C742C2130292C6F3D746869732E676574446F636B696E67506F696E7428652C6E292C733D652E776179706F696E74732E736C69636528692E6964782B312C6F2E696478293B72657475726E20732E756E73';
wwv_flow_imp.g_varchar2_table(41852) := '68696674286176286929292C732E70757368286176286F29292C737D2C6C762E70726F746F747970652E676574446F636B696E67506F696E743D66756E6374696F6E28652C742C6E297B76617220692C6F2C733D652E776179706F696E74733B72657475';
wwv_flow_imp.g_varchar2_table(41853) := '726E7B706F696E743A6F3D735B693D6E3F303A732E6C656E6774682D315D2C61637475616C3A746869732E5F676574496E74657273656374696F6E28742C652C6E297C7C6F2C6964783A697D7D2C6C762E70726F746F747970652E5F676574496E746572';
wwv_flow_imp.g_varchar2_table(41854) := '73656374696F6E3D66756E6374696F6E28652C742C6E297B72657475726E206A6E28746869732E5F6765745368617065506174682865292C746869732E5F676574436F6E6E656374696F6E506174682874292C6E297D2C6C762E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(41855) := '5F676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B72657475726E20746869732E5F6772617068696373466163746F72792E676574436F6E6E656374696F6E506174682865297D2C6C762E70726F746F747970652E5F67657453';
wwv_flow_imp.g_varchar2_table(41856) := '68617065506174683D66756E6374696F6E2865297B72657475726E20746869732E5F6772617068696373466163746F72792E6765745368617065506174682865297D2C6C762E70726F746F747970652E5F6765744766783D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(41857) := '72657475726E20746869732E5F656C656D656E7452656769737472792E67657447726170686963732865297D3B636F6E73742063763D7B5F5F696E69745F5F3A5B226D6F64656C696E67222C2262706D6E55706461746572225D2C5F5F646570656E6473';
wwv_flow_imp.g_varchar2_table(41858) := '5F5F3A5B76702C59702C58702C74672C50672C696D2C616D2C686D2C24722C4A732C746D5D2C62706D6E466163746F72793A5B2274797065222C756D5D2C62706D6E557064617465723A5B2274797065222C706D5D2C656C656D656E74466163746F7279';
wwv_flow_imp.g_varchar2_table(41859) := '3A5B2274797065222C6D6D5D2C6D6F64656C696E673A5B2274797065222C6B665D2C6C61796F757465723A5B2274797065222C55665D2C636F6E6E656374696F6E446F636B696E673A5B2274797065222C6C765D7D2C64763D4D6174682E726F756E643B';
wwv_flow_imp.g_varchar2_table(41860) := '66756E6374696F6E20687628652C742C6E2C692C6F2C73297B746869732E5F636F6D706C6578507265766965773D652C746869732E5F636F6E6E656374696F6E446F636B696E673D742C746869732E5F656C656D656E74466163746F72793D6E2C746869';
wwv_flow_imp.g_varchar2_table(41861) := '732E5F6576656E744275733D692C746869732E5F6C61796F757465723D6F2C746869732E5F72756C65733D737D68762E70726F746F747970652E6372656174653D66756E6374696F6E28652C742C6E297B636F6E7374206F3D746869732E5F636F6D706C';
wwv_flow_imp.g_varchar2_table(41862) := '6578507265766965772C733D746869732E5F636F6E6E656374696F6E446F636B696E672C723D746869732E5F656C656D656E74466163746F72792C613D746869732E5F6576656E744275732C6C3D746869732E5F6C61796F757465722C633D746869732E';
wwv_flow_imp.g_varchar2_table(41863) := '5F72756C65732C643D722E63726561746553686170652828302C692E6B7029287B747970653A747D2C6E29292C683D612E6669726528226175746F506C616365222C7B736F757263653A652C73686170653A647D293B69662821682972657475726E3B28';
wwv_flow_imp.g_varchar2_table(41864) := '302C692E6B702928642C7B783A682E782D647628642E77696474682F32292C793A682E792D647628642E6865696768742F32297D293B636F6E737420753D632E616C6C6F7765642822636F6E6E656374696F6E2E637265617465222C7B736F757263653A';
wwv_flow_imp.g_varchar2_table(41865) := '652C7461726765743A642C68696E74733A7B746172676574506172656E743A652E706172656E747D7D293B6C657420703D6E756C6C3B75262628703D722E637265617465436F6E6E656374696F6E2875292C702E776179706F696E74733D6C2E6C61796F';
wwv_flow_imp.g_varchar2_table(41866) := '7574436F6E6E656374696F6E28702C7B736F757263653A652C7461726765743A647D292C702E776179706F696E74733D732E67657443726F70706564576179706F696E747328702C652C6429292C6F2E637265617465287B637265617465643A5B642C70';
wwv_flow_imp.g_varchar2_table(41867) := '5D2E66696C7465722828653D3E2128302C692E67442928652929297D297D2C68762E70726F746F747970652E636C65616E55703D66756E6374696F6E28297B746869732E5F636F6D706C6578507265766965772E636C65616E557028297D2C68762E2469';
wwv_flow_imp.g_varchar2_table(41868) := '6E6A6563743D5B22636F6D706C657850726576696577222C22636F6E6E656374696F6E446F636B696E67222C22656C656D656E74466163746F7279222C226576656E74427573222C226C61796F75746572222C2272756C6573225D3B636F6E7374207576';
wwv_flow_imp.g_varchar2_table(41869) := '3D7B5F5F646570656E64735F5F3A5B4D632C69682C63765D2C5F5F696E69745F5F3A5B22617070656E6450726576696577225D2C617070656E64507265766965773A5B2274797065222C68765D7D3B66756E6374696F6E20707628652C74297B72657475';
wwv_flow_imp.g_varchar2_table(41870) := '726E20742E666F7245616368282866756E6374696F6E2874297B74262622737472696E6722213D747970656F66207426262141727261792E6973417272617928742926264F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(41871) := '286E297B6966282264656661756C7422213D3D6E262621286E20696E206529297B76617220693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293B4F626A6563742E646566696E6550726F706572747928652C';
wwv_flow_imp.g_varchar2_table(41872) := '6E2C692E6765743F693A7B656E756D657261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20745B6E5D7D7D297D7D29297D29292C4F626A6563742E667265657A652865297D4F626A6563742E70726F746F747970652E746F5374';
wwv_flow_imp.g_varchar2_table(41873) := '72696E672C4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B636F6E73742067763D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E206D762865297B69662821657C7C21652E6E6F64';
wwv_flow_imp.g_varchar2_table(41874) := '6554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D6D762E70726F74';
wwv_flow_imp.g_varchar2_table(41875) := '6F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C6D762E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A6563742052';
wwv_flow_imp.g_varchar2_table(41876) := '65674578705D223D3D67762E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C6D762E70726F746F747970652E72656D6F76654D61746368696E673D66';
wwv_flow_imp.g_varchar2_table(41877) := '756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E207468';
wwv_flow_imp.g_varchar2_table(41878) := '69737D2C6D762E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C6528';
wwv_flow_imp.g_varchar2_table(41879) := '65293A746869732E6C6973742E746F67676C652865292C746869737D2C6D762E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C6D762E70726F746F747970';
wwv_flow_imp.g_varchar2_table(41880) := '652E6861733D6D762E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B7661722066762C76762C62762C5F763D7B7D3B66756E6374696F6E207976';
wwv_flow_imp.g_varchar2_table(41881) := '28297B66763D77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C76763D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F7665';
wwv_flow_imp.g_varchar2_table(41882) := '4576656E744C697374656E6572223A226465746163684576656E74222C62763D226164644576656E744C697374656E657222213D3D66763F226F6E223A22227D7661722077762C43763D7076287B5F5F70726F746F5F5F3A6E756C6C2C62696E643A5F76';
wwv_flow_imp.g_varchar2_table(41883) := '2E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2066767C7C797628292C655B66765D2862762B742C6E2C697C7C2131292C6E7D2C756E62696E643A5F762E756E62696E643D66756E6374696F6E28652C742C6E2C69297B7265';
wwv_flow_imp.g_varchar2_table(41884) := '7475726E2076767C7C797628292C655B76765D2862762B742C6E2C697C7C2131292C6E7D2C64656661756C743A5F767D2C5B5F765D292C53763D21313B22756E646566696E656422213D747970656F6620646F63756D656E742626282877763D646F6375';
wwv_flow_imp.g_varchar2_table(41885) := '6D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D22636865636B626F';
wwv_flow_imp.g_varchar2_table(41886) := '78222F3E272C53763D2177762E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C77763D766F69642030293B7661722078763D7B6C6567656E643A5B312C223C6669656C647365743E222C223C2F6669656C6473';
wwv_flow_imp.g_varchar2_table(41887) := '65743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E222C223C2F636F6C67726F';
wwv_flow_imp.g_varchar2_table(41888) := '75703E3C2F7461626C653E225D2C5F64656661756C743A53763F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B78762E74643D78762E74683D5B332C223C7461626C653E3C74626F64793E3C74723E222C223C2F7472';
wwv_flow_imp.g_varchar2_table(41889) := '3E3C2F74626F64793E3C2F7461626C653E225D2C78762E6F7074696F6E3D78762E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C78762E74686561643D7876';
wwv_flow_imp.g_varchar2_table(41890) := '2E74626F64793D78762E636F6C67726F75703D78762E63617074696F6E3D78762E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C78762E706F6C796C696E653D78762E656C6C697073653D78762E706F6C79676F6E3D7876';
wwv_flow_imp.g_varchar2_table(41891) := '2E636972636C653D78762E746578743D78762E6C696E653D78762E706174683D78762E726563743D78762E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F6E3D22312E';
wwv_flow_imp.g_varchar2_table(41892) := '31223E272C223C2F7376673E225D3B766172206B763D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870656374656422293B747C7C';
wwv_flow_imp.g_varchar2_table(41893) := '28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F672C222229';
wwv_flow_imp.g_varchar2_table(41894) := '3B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C64293B7661';
wwv_flow_imp.g_varchar2_table(41895) := '72206F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C2878762C69293F78765B695D3A78762E5F64656661756C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E637265617465456C656D';
wwv_flow_imp.g_varchar2_table(41896) := '656E74282264697622293B666F72286C2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E66697273744368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76654368696C';
wwv_flow_imp.g_varchar2_table(41897) := '64286C2E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273744368696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C64286C2E666972';
wwv_flow_imp.g_varchar2_table(41898) := '73744368696C6429293B72657475726E20637D3B66756E6374696F6E2045762865297B652E706172656E744E6F64652626652E706172656E744E6F64652E72656D6F76654368696C642865297D766172204C763D4D6174682E6D696E2C44763D4D617468';
wwv_flow_imp.g_varchar2_table(41899) := '2E6D61783B66756E6374696F6E2054762865297B652E70726576656E7444656661756C7428297D66756E6374696F6E2049762865297B652E73746F7050726F7061676174696F6E28297D66756E6374696F6E204D762865297B746869732E636F6E746169';
wwv_flow_imp.g_varchar2_table(41900) := '6E65723D652E636F6E7461696E65722C746869732E706172656E743D6B7628273C64697620636C6173733D22646A732D6469726563742D65646974696E672D706172656E74223E3C64697620636C6173733D22646A732D6469726563742D65646974696E';
wwv_flow_imp.g_varchar2_table(41901) := '672D636F6E74656E742220636F6E74656E746564697461626C653D2274727565223E3C2F6469763E3C2F6469763E27292C746869732E636F6E74656E743D28746869732E706172656E747C7C646F63756D656E74292E717565727953656C6563746F7228';
wwv_flow_imp.g_varchar2_table(41902) := '225B636F6E74656E746564697461626C655D22292C746869732E6B657948616E646C65723D652E6B657948616E646C65727C7C66756E6374696F6E28297B7D2C746869732E726573697A6548616E646C65723D652E726573697A6548616E646C65727C7C';
wwv_flow_imp.g_varchar2_table(41903) := '66756E6374696F6E28297B7D2C746869732E6175746F526573697A653D28302C692E6F492928746869732E6175746F526573697A652C74686973292C746869732E68616E646C6550617374653D28302C692E6F492928746869732E68616E646C65506173';
wwv_flow_imp.g_varchar2_table(41904) := '74652C74686973297D66756E6374696F6E20417628652C74297B746869732E5F6576656E744275733D652C746869732E5F70726F7669646572733D5B5D2C746869732E5F74657874626F783D6E6577204D76287B636F6E7461696E65723A742E67657443';
wwv_flow_imp.g_varchar2_table(41905) := '6F6E7461696E657228292C6B657948616E646C65723A28302C692E6F492928746869732E5F68616E646C654B65792C74686973292C726573697A6548616E646C65723A28302C692E6F492928746869732E5F68616E646C65526573697A652C7468697329';
wwv_flow_imp.g_varchar2_table(41906) := '7D297D4D762E70726F746F747970652E6372656174653D66756E6374696F6E28652C742C6E2C6F297B76617220733D746869732E706172656E742C723D746869732E636F6E74656E742C613D746869732E636F6E7461696E65723B6F3D746869732E6F70';
wwv_flow_imp.g_varchar2_table(41907) := '74696F6E733D6F7C7C7B7D2C743D746869732E7374796C653D747C7C7B7D3B766172206C3D28302C692E55702928742C5B227769647468222C22686569676874222C226D61785769647468222C226D6178486569676874222C226D696E5769647468222C';
wwv_flow_imp.g_varchar2_table(41908) := '226D696E486569676874222C226C656674222C22746F70222C226261636B67726F756E64436F6C6F72222C22706F736974696F6E222C226F766572666C6F77222C22626F72646572222C22776F726457726170222C2274657874416C69676E222C226F75';
wwv_flow_imp.g_varchar2_table(41909) := '746C696E65222C227472616E73666F726D225D293B28302C692E6B702928732E7374796C652C7B77696474683A652E77696474682B227078222C6865696768743A652E6865696768742B227078222C6D617857696474683A652E6D617857696474682B22';
wwv_flow_imp.g_varchar2_table(41910) := '7078222C6D61784865696768743A652E6D61784865696768742B227078222C6D696E57696474683A652E6D696E57696474682B227078222C6D696E4865696768743A652E6D696E4865696768742B227078222C6C6566743A652E782B227078222C746F70';
wwv_flow_imp.g_varchar2_table(41911) := '3A652E792B227078222C6261636B67726F756E64436F6C6F723A2223666666666666222C706F736974696F6E3A226162736F6C757465222C6F766572666C6F773A2276697369626C65222C626F726465723A2231707820736F6C69642023636363222C62';
wwv_flow_imp.g_varchar2_table(41912) := '6F7853697A696E673A22626F726465722D626F78222C776F7264577261703A226E6F726D616C222C74657874416C69676E3A2263656E746572222C6F75746C696E653A226E6F6E65227D2C6C293B76617220633D28302C692E55702928742C5B22666F6E';
wwv_flow_imp.g_varchar2_table(41913) := '7446616D696C79222C22666F6E7453697A65222C22666F6E74576569676874222C226C696E65486569676874222C2270616464696E67222C2270616464696E67546F70222C2270616464696E675269676874222C2270616464696E67426F74746F6D222C';
wwv_flow_imp.g_varchar2_table(41914) := '2270616464696E674C656674225D293B72657475726E28302C692E6B702928722E7374796C652C7B626F7853697A696E673A22626F726465722D626F78222C77696474683A2231303025222C6F75746C696E653A226E6F6E65222C776F7264577261703A';
wwv_flow_imp.g_varchar2_table(41915) := '22627265616B2D776F7264227D2C63292C6F2E63656E746572566572746963616C6C79262628302C692E6B702928722E7374796C652C7B706F736974696F6E3A226162736F6C757465222C746F703A22353025222C7472616E73666F726D3A227472616E';
wwv_flow_imp.g_varchar2_table(41916) := '736C61746528302C202D35302529227D2C63292C722E696E6E6572546578743D6E2C43762E62696E6428722C226B6579646F776E222C746869732E6B657948616E646C6572292C43762E62696E6428722C226D6F757365646F776E222C4976292C43762E';
wwv_flow_imp.g_varchar2_table(41917) := '62696E6428722C227061737465222C746869732E68616E646C655061737465292C6F2E6175746F526573697A65262643762E62696E6428722C22696E707574222C746869732E6175746F526573697A65292C6F2E726573697A61626C652626746869732E';
wwv_flow_imp.g_varchar2_table(41918) := '726573697A61626C652874292C612E617070656E644368696C642873292C746869732E73657453656C656374696F6E28722E6C6173744368696C642C722E6C6173744368696C642626722E6C6173744368696C642E6C656E677468292C737D2C4D762E70';
wwv_flow_imp.g_varchar2_table(41919) := '726F746F747970652E68616E646C6550617374653D66756E6374696F6E2865297B76617220742C6E3D746869732E6F7074696F6E732C693D746869732E7374796C653B696628652E70726576656E7444656661756C7428292C743D652E636C6970626F61';
wwv_flow_imp.g_varchar2_table(41920) := '7264446174613F652E636C6970626F617264446174612E676574446174612822746578742F706C61696E22293A77696E646F772E636C6970626F617264446174612E6765744461746128225465787422292C746869732E696E7365727454657874287429';
wwv_flow_imp.g_varchar2_table(41921) := '2C6E2E6175746F526573697A65297B766172206F3D746869732E6175746F526573697A652869293B6F2626746869732E726573697A6548616E646C6572286F297D7D2C4D762E70726F746F747970652E696E73657274546578743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41922) := '65297B653D66756E6374696F6E2865297B72657475726E20652E7265706C616365282F5C725C6E7C5C727C5C6E2F672C225C6E22297D2865292C646F63756D656E742E65786563436F6D6D616E642822696E7365727454657874222C21312C65297C7C74';
wwv_flow_imp.g_varchar2_table(41923) := '6869732E5F696E736572745465787449452865297D2C4D762E70726F746F747970652E5F696E736572745465787449453D66756E6374696F6E2865297B76617220742C6E2C692C6F3D746869732E67657453656C656374696F6E28292C733D6F2E737461';
wwv_flow_imp.g_varchar2_table(41924) := '7274436F6E7461696E65722C723D6F2E656E64436F6E7461696E65722C613D6F2E73746172744F66667365742C6C3D6F2E656E644F66667365742C633D6F2E636F6D6D6F6E416E636573746F72436F6E7461696E65722C643D28743D632E6368696C644E';
wwv_flow_imp.g_varchar2_table(41925) := '6F6465732C5B5D2E736C6963652E63616C6C287429293B69662866756E6374696F6E2865297B72657475726E20652E6E6F6465547970653D3D3D4E6F64652E544558545F4E4F44457D286329297B76617220683D732E74657874436F6E74656E743B732E';
wwv_flow_imp.g_varchar2_table(41926) := '74657874436F6E74656E743D682E737562737472696E6728302C61292B652B682E737562737472696E67286C292C6E3D732C693D612B652E6C656E6774687D656C736520696628733D3D3D746869732E636F6E74656E742626723D3D3D746869732E636F';
wwv_flow_imp.g_varchar2_table(41927) := '6E74656E74297B76617220753D646F63756D656E742E637265617465546578744E6F64652865293B746869732E636F6E74656E742E696E736572744265666F726528752C645B615D292C6E3D752C693D752E74657874436F6E74656E742E6C656E677468';
wwv_flow_imp.g_varchar2_table(41928) := '7D656C73657B76617220703D642E696E6465784F662873292C673D642E696E6465784F662872293B642E666F7245616368282866756E6374696F6E28742C6E297B6E3D3D3D703F742E74657874436F6E74656E743D732E74657874436F6E74656E742E73';
wwv_flow_imp.g_varchar2_table(41929) := '7562737472696E6728302C61292B652B722E74657874436F6E74656E742E737562737472696E67286C293A6E3E7026266E3C3D67262645762874297D29292C6E3D732C693D612B652E6C656E6774687D6E2626766F69642030213D3D6926267365745469';
wwv_flow_imp.g_varchar2_table(41930) := '6D656F7574282866756E6374696F6E28297B73656C662E73657453656C656374696F6E286E2C69297D29297D2C4D762E70726F746F747970652E6175746F526573697A653D66756E6374696F6E28297B76617220653D746869732E706172656E742C743D';
wwv_flow_imp.g_varchar2_table(41931) := '746869732E636F6E74656E742C6E3D7061727365496E7428746869732E7374796C652E666F6E7453697A65297C7C31323B696628742E7363726F6C6C4865696768743E652E6F66667365744865696768747C7C742E7363726F6C6C4865696768743C652E';
wwv_flow_imp.g_varchar2_table(41932) := '6F66667365744865696768742D6E297B76617220693D652E676574426F756E64696E67436C69656E745265637428292C6F3D742E7363726F6C6C4865696768743B652E7374796C652E6865696768743D6F2B227078222C746869732E726573697A654861';
wwv_flow_imp.g_varchar2_table(41933) := '6E646C6572287B77696474683A692E77696474682C6865696768743A692E6865696768742C64783A302C64793A6F2D692E6865696768747D297D7D2C4D762E70726F746F747970652E726573697A61626C653D66756E6374696F6E28297B76617220653D';
wwv_flow_imp.g_varchar2_table(41934) := '746869732C743D746869732E706172656E742C6E3D746869732E726573697A6548616E646C652C6F3D7061727365496E7428746869732E7374796C652E6D696E5769647468297C7C302C733D7061727365496E7428746869732E7374796C652E6D696E48';
wwv_flow_imp.g_varchar2_table(41935) := '6569676874297C7C302C723D7061727365496E7428746869732E7374796C652E6D61785769647468297C7C312F302C613D7061727365496E7428746869732E7374796C652E6D6178486569676874297C7C312F303B696628216E297B766172206C2C632C';
wwv_flow_imp.g_varchar2_table(41936) := '642C683B6E3D746869732E726573697A6548616E646C653D6B7628273C64697620636C6173733D22646A732D6469726563742D65646974696E672D726573697A652D68616E646C65223E3C2F6469763E27293B76617220753D66756E6374696F6E286E29';
wwv_flow_imp.g_varchar2_table(41937) := '7B5476286E292C4976286E293B76617220693D4C7628447628642B6E2E636C69656E74582D6C2C6F292C72292C753D4C7628447628682B6E2E636C69656E74592D632C73292C61293B742E7374796C652E77696474683D692B227078222C742E7374796C';
wwv_flow_imp.g_varchar2_table(41938) := '652E6865696768743D752B227078222C652E726573697A6548616E646C6572287B77696474683A642C6865696768743A682C64783A6E2E636C69656E74582D6C2C64793A6E2E636C69656E74592D637D297D2C703D66756E6374696F6E2865297B547628';
wwv_flow_imp.g_varchar2_table(41939) := '65292C49762865292C43762E756E62696E6428646F63756D656E742C226D6F7573656D6F7665222C752C2131292C43762E756E62696E6428646F63756D656E742C226D6F7573657570222C702C2131297D3B43762E62696E64286E2C226D6F757365646F';
wwv_flow_imp.g_varchar2_table(41940) := '776E222C2866756E6374696F6E2865297B54762865292C49762865292C6C3D652E636C69656E74582C633D652E636C69656E74593B766172206E3D742E676574426F756E64696E67436C69656E745265637428293B643D6E2E77696474682C683D6E2E68';
wwv_flow_imp.g_varchar2_table(41941) := '65696768742C43762E62696E6428646F63756D656E742C226D6F7573656D6F7665222C75292C43762E62696E6428646F63756D656E742C226D6F7573657570222C70297D29297D28302C692E6B7029286E2E7374796C652C7B706F736974696F6E3A2261';
wwv_flow_imp.g_varchar2_table(41942) := '62736F6C757465222C626F74746F6D3A22307078222C72696768743A22307078222C637572736F723A226E7773652D726573697A65222C77696474683A2230222C6865696768743A2230222C626F72646572546F703A287061727365496E742874686973';
wwv_flow_imp.g_varchar2_table(41943) := '2E7374796C652E666F6E7453697A65292F347C7C33292B22707820736F6C6964207472616E73706172656E74222C626F7264657252696768743A287061727365496E7428746869732E7374796C652E666F6E7453697A65292F347C7C33292B2270782073';
wwv_flow_imp.g_varchar2_table(41944) := '6F6C69642023636363222C626F72646572426F74746F6D3A287061727365496E7428746869732E7374796C652E666F6E7453697A65292F347C7C33292B22707820736F6C69642023636363222C626F726465724C6566743A287061727365496E74287468';
wwv_flow_imp.g_varchar2_table(41945) := '69732E7374796C652E666F6E7453697A65292F347C7C33292B22707820736F6C6964207472616E73706172656E74227D292C742E617070656E644368696C64286E297D2C4D762E70726F746F747970652E64657374726F793D66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(41946) := '76617220653D746869732E706172656E742C743D746869732E636F6E74656E742C6E3D746869732E726573697A6548616E646C653B742E696E6E6572546578743D22222C652E72656D6F766541747472696275746528227374796C6522292C742E72656D';
wwv_flow_imp.g_varchar2_table(41947) := '6F766541747472696275746528227374796C6522292C43762E756E62696E6428742C226B6579646F776E222C746869732E6B657948616E646C6572292C43762E756E62696E6428742C226D6F757365646F776E222C4976292C43762E756E62696E642874';
wwv_flow_imp.g_varchar2_table(41948) := '2C22696E707574222C746869732E6175746F526573697A65292C43762E756E62696E6428742C227061737465222C746869732E68616E646C655061737465292C6E2626286E2E72656D6F766541747472696275746528227374796C6522292C4576286E29';
wwv_flow_imp.g_varchar2_table(41949) := '292C45762865297D2C4D762E70726F746F747970652E67657456616C75653D66756E6374696F6E28297B72657475726E20746869732E636F6E74656E742E696E6E6572546578742E7472696D28297D2C4D762E70726F746F747970652E67657453656C65';
wwv_flow_imp.g_varchar2_table(41950) := '6374696F6E3D66756E6374696F6E28297B72657475726E2077696E646F772E67657453656C656374696F6E28292E67657452616E676541742830297D2C4D762E70726F746F747970652E73657453656C656374696F6E3D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(41951) := '7B766172206E3D646F63756D656E742E63726561746552616E676528293B6E756C6C3D3D3D653F6E2E73656C6563744E6F6465436F6E74656E747328746869732E636F6E74656E74293A286E2E736574537461727428652C74292C6E2E736574456E6428';
wwv_flow_imp.g_varchar2_table(41952) := '652C7429293B76617220693D77696E646F772E67657453656C656374696F6E28293B692E72656D6F7665416C6C52616E67657328292C692E61646452616E6765286E297D2C41762E24696E6A6563743D5B226576656E74427573222C2263616E76617322';
wwv_flow_imp.g_varchar2_table(41953) := '5D2C41762E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E2865297B746869732E5F70726F7669646572732E707573682865297D2C41762E70726F746F747970652E69734163746976653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(41954) := '65297B72657475726E212821746869732E5F6163746976657C7C652626746869732E5F6163746976652E656C656D656E74213D3D65297D2C41762E70726F746F747970652E63616E63656C3D66756E6374696F6E28297B746869732E5F61637469766526';
wwv_flow_imp.g_varchar2_table(41955) := '2628746869732E5F66697265282263616E63656C22292C746869732E636C6F73652829297D2C41762E70726F746F747970652E5F666972653D66756E6374696F6E28652C74297B746869732E5F6576656E744275732E6669726528226469726563744564';
wwv_flow_imp.g_varchar2_table(41956) := '6974696E672E222B652C747C7C7B6163746976653A746869732E5F6163746976657D297D2C41762E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E5F74657874626F782E64657374726F7928292C746869732E5F666972';
wwv_flow_imp.g_varchar2_table(41957) := '6528226465616374697661746522292C746869732E5F6163746976653D6E756C6C2C746869732E726573697A61626C653D766F696420307D2C41762E70726F746F747970652E636F6D706C6574653D66756E6374696F6E28297B76617220653D74686973';
wwv_flow_imp.g_varchar2_table(41958) := '2E5F6163746976653B69662865297B76617220742C6E3D652E636F6E746578742E626F756E64732C693D746869732E2474657874626F782E676574426F756E64696E67436C69656E745265637428292C6F3D746869732E67657456616C756528293B6F3D';
wwv_flow_imp.g_varchar2_table(41959) := '3D3D652E636F6E746578742E746578742626692E6865696768743D3D3D6E2E6865696768742626692E77696474683D3D3D6E2E77696474687C7C28743D746869732E5F74657874626F782E636F6E7461696E65722E676574426F756E64696E67436C6965';
wwv_flow_imp.g_varchar2_table(41960) := '6E745265637428292C652E70726F76696465722E75706461746528652E656C656D656E742C6F2C652E636F6E746578742E746578742C7B783A692E6C6566742D742E6C6566742C793A692E746F702D742E746F702C77696474683A692E77696474682C68';
wwv_flow_imp.g_varchar2_table(41961) := '65696768743A692E6865696768747D29292C746869732E5F666972652822636F6D706C65746522292C746869732E636C6F736528297D7D2C41762E70726F746F747970652E67657456616C75653D66756E6374696F6E28297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(41962) := '2E5F74657874626F782E67657456616C756528297D2C41762E70726F746F747970652E5F68616E646C654B65793D66756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28293B76617220743D652E6B6579436F64657C7C652E636861';
wwv_flow_imp.g_varchar2_table(41963) := '72436F64653B72657475726E2032373D3D3D743F28652E70726576656E7444656661756C7428292C746869732E63616E63656C2829293A3133213D3D747C7C652E73686966744B65793F766F696420303A28652E70726576656E7444656661756C742829';
wwv_flow_imp.g_varchar2_table(41964) := '2C746869732E636F6D706C6574652829297D2C41762E70726F746F747970652E5F68616E646C65526573697A653D66756E6374696F6E2865297B746869732E5F666972652822726573697A65222C65297D2C41762E70726F746F747970652E6163746976';
wwv_flow_imp.g_varchar2_table(41965) := '6174653D66756E6374696F6E2865297B76617220743B746869732E697341637469766528292626746869732E63616E63656C28293B766172206E3D28302C692E49362928746869732E5F70726F7669646572732C2866756E6374696F6E286E297B726574';
wwv_flow_imp.g_varchar2_table(41966) := '75726E28743D6E2E6163746976617465286529293F6E3A6E756C6C7D29293B72657475726E2074262628746869732E2474657874626F783D746869732E5F74657874626F782E63726561746528742E626F756E64732C742E7374796C652C742E74657874';
wwv_flow_imp.g_varchar2_table(41967) := '2C742E6F7074696F6E73292C746869732E5F6163746976653D7B656C656D656E743A652C636F6E746578743A742C70726F76696465723A6E7D2C742E6F7074696F6E732626742E6F7074696F6E732E726573697A61626C65262628746869732E72657369';
wwv_flow_imp.g_varchar2_table(41968) := '7A61626C653D2130292C746869732E5F66697265282261637469766174652229292C2121747D3B636F6E7374204E763D7B5F5F646570656E64735F5F3A5B42725D2C5F5F696E69745F5F3A5B2264697265637445646974696E67225D2C64697265637445';
wwv_flow_imp.g_varchar2_table(41969) := '646974696E673A5B2274797065222C41765D7D3B66756E6374696F6E2050762865297B72657475726E2066756E6374696F6E2874297B766172206E3D742E7461726765742C693D28302C792E676574427573696E6573734F626A656374292865292C6F3D';
wwv_flow_imp.g_varchar2_table(41970) := '692E6576656E74446566696E6974696F6E732626692E6576656E74446566696E6974696F6E735B305D2C733D692E24747970653D3D3D6E2E747970652C723D286F26266F2E2474797065293D3D3D6E2E6576656E74446566696E6974696F6E547970652C';
wwv_flow_imp.g_varchar2_table(41971) := '613D21216E2E74726967676572656442794576656E743D3D2121692E74726967676572656442794576656E742C6C3D766F696420303D3D3D6E2E6973457870616E6465647C7C6E2E6973457870616E6465643D3D3D28302C72732E4176292865293B7265';
wwv_flow_imp.g_varchar2_table(41972) := '7475726E21287326267226266126266C297D7D766172204F763D5B7B6C6162656C3A225374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D7374617274222C636C6173734E616D653A2262706D6E';
wwv_flow_imp.g_varchar2_table(41973) := '2D69636F6E2D73746172742D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74227D7D2C7B6C6162656C3A22496E7465726D656469617465207468726F77206576656E74222C616374696F6E4E616D';
wwv_flow_imp.g_varchar2_table(41974) := '653A227265706C6163652D776974682D6E6F6E652D696E7465726D6564696174652D7468726F77696E67222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E65222C7461726765743A7B7479';
wwv_flow_imp.g_varchar2_table(41975) := '70653A2262706D6E3A496E7465726D6564696174655468726F774576656E74227D7D2C7B6C6162656C3A22456E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D656E64222C636C6173734E616D653A22';
wwv_flow_imp.g_varchar2_table(41976) := '62706D6E2D69636F6E2D656E642D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A456E644576656E74227D7D2C7B6C6162656C3A224D657373616765207374617274206576656E74222C616374696F6E4E616D653A227265';
wwv_flow_imp.g_varchar2_table(41977) := '706C6163652D776974682D6D6573736167652D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6D657373616765222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C65';
wwv_flow_imp.g_varchar2_table(41978) := '76656E74446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A2254696D6572207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D7769';
wwv_flow_imp.g_varchar2_table(41979) := '74682D74696D65722D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D74696D6572222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E697469';
wwv_flow_imp.g_varchar2_table(41980) := '6F6E547970653A2262706D6E3A54696D65724576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A22436F6E646974696F6E616C207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6E6469';
wwv_flow_imp.g_varchar2_table(41981) := '74696F6E616C2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D636F6E646974696F6E222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(41982) := '74696F6E547970653A2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A225369676E616C207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D7369';
wwv_flow_imp.g_varchar2_table(41983) := '676E616C2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D7369676E616C222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E54';
wwv_flow_imp.g_varchar2_table(41984) := '7970653A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E227D7D5D2C52763D5B7B6C6162656C3A225374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D7374617274222C636C';
wwv_flow_imp.g_varchar2_table(41985) := '6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74227D7D2C7B6C6162656C3A22496E7465726D656469617465207468726F7720657665';
wwv_flow_imp.g_varchar2_table(41986) := '6E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D696E7465726D6564696174652D7468726F77696E67222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E';
wwv_flow_imp.g_varchar2_table(41987) := '65222C7461726765743A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74227D7D2C7B6C6162656C3A22456E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D656E64';
wwv_flow_imp.g_varchar2_table(41988) := '222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A456E644576656E74227D7D5D2C46763D5B7B6C6162656C3A225374617274206576656E74222C61637469';
wwv_flow_imp.g_varchar2_table(41989) := '6F6E4E616D653A227265706C6163652D776974682D6E6F6E652D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A53746172744576656E';
wwv_flow_imp.g_varchar2_table(41990) := '74227D7D2C7B6C6162656C3A22496E7465726D656469617465207468726F77206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D696E7465726D6564696174652D7468726F77222C636C6173734E616D653A22';
wwv_flow_imp.g_varchar2_table(41991) := '62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74227D7D2C7B6C6162656C3A22456E64206576656E74222C61';
wwv_flow_imp.g_varchar2_table(41992) := '6374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A456E644576656E74227D';
wwv_flow_imp.g_varchar2_table(41993) := '7D2C7B6C6162656C3A224D65737361676520696E7465726D656469617465206361746368206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6D6573736167652D696E7465726D6564696174652D6361746368222C636C61';
wwv_flow_imp.g_varchar2_table(41994) := '73734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D657373616765222C7461726765743A7B747970653A2262706D6E3A496E7465726D65646961746543617463684576656E74222C6576656E74';
wwv_flow_imp.g_varchar2_table(41995) := '446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A224D65737361676520696E7465726D656469617465207468726F77206576656E74222C616374696F6E4E616D653A';
wwv_flow_imp.g_varchar2_table(41996) := '227265706C6163652D776974682D6D6573736167652D696E7465726D6564696174652D7468726F77222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D657373616765222C746172';
wwv_flow_imp.g_varchar2_table(41997) := '6765743A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A22';
wwv_flow_imp.g_varchar2_table(41998) := '54696D657220696E7465726D656469617465206361746368206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D74696D65722D696E7465726D6564696174652D6361746368222C636C6173734E616D653A2262706D6E2D69';
wwv_flow_imp.g_varchar2_table(41999) := '636F6E2D696E7465726D6564696174652D6576656E742D63617463682D74696D6572222C7461726765743A7B747970653A2262706D6E3A496E7465726D65646961746543617463684576656E74222C6576656E74446566696E6974696F6E547970653A22';
wwv_flow_imp.g_varchar2_table(42000) := '62706D6E3A54696D65724576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A22457363616C6174696F6E20696E7465726D656469617465207468726F77206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D65';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(42001) := '7363616C6174696F6E2D696E7465726D6564696174652D7468726F77222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D657363616C6174696F6E222C7461726765743A7B74797065';
wwv_flow_imp.g_varchar2_table(42002) := '3A2262706D6E3A496E7465726D6564696174655468726F774576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A22436F6E646974';
wwv_flow_imp.g_varchar2_table(42003) := '696F6E616C20696E7465726D656469617465206361746368206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6E646974696F6E616C2D696E7465726D6564696174652D6361746368222C636C6173734E616D653A22';
wwv_flow_imp.g_varchar2_table(42004) := '62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6E646974696F6E222C7461726765743A7B747970653A2262706D6E3A496E7465726D65646961746543617463684576656E74222C6576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(42005) := '74696F6E547970653A2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A224C696E6B20696E7465726D656469617465206361746368206576656E74222C616374696F6E4E616D653A227265706C';
wwv_flow_imp.g_varchar2_table(42006) := '6163652D776974682D6C696E6B2D696E7465726D6564696174652D6361746368222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6C696E6B222C7461726765743A7B747970653A22';
wwv_flow_imp.g_varchar2_table(42007) := '62706D6E3A496E7465726D65646961746543617463684576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4C696E6B4576656E74446566696E6974696F6E222C6576656E74446566696E6974696F6E41747472733A7B6E61';
wwv_flow_imp.g_varchar2_table(42008) := '6D653A22227D7D7D2C7B6C6162656C3A224C696E6B20696E7465726D656469617465207468726F77206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6C696E6B2D696E7465726D6564696174652D7468726F77222C636C';
wwv_flow_imp.g_varchar2_table(42009) := '6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6C696E6B222C7461726765743A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74222C6576656E744465';
wwv_flow_imp.g_varchar2_table(42010) := '66696E6974696F6E547970653A2262706D6E3A4C696E6B4576656E74446566696E6974696F6E222C6576656E74446566696E6974696F6E41747472733A7B6E616D653A22227D7D7D2C7B6C6162656C3A22436F6D70656E736174696F6E20696E7465726D';
wwv_flow_imp.g_varchar2_table(42011) := '656469617465207468726F77206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6D70656E736174696F6E2D696E7465726D6564696174652D7468726F77222C636C6173734E616D653A2262706D6E2D69636F6E2D69';
wwv_flow_imp.g_varchar2_table(42012) := '6E7465726D6564696174652D6576656E742D7468726F772D636F6D70656E736174696F6E222C7461726765743A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74222C6576656E74446566696E6974696F6E54797065';
wwv_flow_imp.g_varchar2_table(42013) := '3A2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A225369676E616C20696E7465726D656469617465206361746368206576656E74222C616374696F6E4E616D653A227265706C6163652D776974';
wwv_flow_imp.g_varchar2_table(42014) := '682D7369676E616C2D696E7465726D6564696174652D6361746368222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D7369676E616C222C7461726765743A7B747970653A2262706D';
wwv_flow_imp.g_varchar2_table(42015) := '6E3A496E7465726D65646961746543617463684576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A225369676E616C20696E7465726D6564';
wwv_flow_imp.g_varchar2_table(42016) := '69617465207468726F77206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D7369676E616C2D696E7465726D6564696174652D7468726F77222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D656469';
wwv_flow_imp.g_varchar2_table(42017) := '6174652D6576656E742D7468726F772D7369676E616C222C7461726765743A7B747970653A2262706D6E3A496E7465726D6564696174655468726F774576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C45';
wwv_flow_imp.g_varchar2_table(42018) := '76656E74446566696E6974696F6E227D7D5D2C42763D5B7B6C6162656C3A225374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D7374617274222C636C6173734E616D653A2262706D6E2D69636F';
wwv_flow_imp.g_varchar2_table(42019) := '6E2D73746172742D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74227D7D2C7B6C6162656C3A22496E7465726D656469617465207468726F77206576656E74222C616374696F6E4E616D653A2272';
wwv_flow_imp.g_varchar2_table(42020) := '65706C6163652D776974682D6E6F6E652D696E7465726D6564696174652D7468726F77222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D';
wwv_flow_imp.g_varchar2_table(42021) := '6E3A496E7465726D6564696174655468726F774576656E74227D7D2C7B6C6162656C3A22456E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E652D656E64222C636C6173734E616D653A2262706D6E2D6963';
wwv_flow_imp.g_varchar2_table(42022) := '6F6E2D656E642D6576656E742D6E6F6E65222C7461726765743A7B747970653A2262706D6E3A456E644576656E74227D7D2C7B6C6162656C3A224D65737361676520656E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974';
wwv_flow_imp.g_varchar2_table(42023) := '682D6D6573736167652D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D6D657373616765222C7461726765743A7B747970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E54';
wwv_flow_imp.g_varchar2_table(42024) := '7970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A22457363616C6174696F6E20656E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D657363616C6174696F';
wwv_flow_imp.g_varchar2_table(42025) := '6E2D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D657363616C6174696F6E222C7461726765743A7B747970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E547970653A22';
wwv_flow_imp.g_varchar2_table(42026) := '62706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A224572726F7220656E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6572726F722D656E64222C636C617373';
wwv_flow_imp.g_varchar2_table(42027) := '4E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D6572726F72222C7461726765743A7B747970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4572726F724576656E744465';
wwv_flow_imp.g_varchar2_table(42028) := '66696E6974696F6E227D7D2C7B6C6162656C3A2243616E63656C20656E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D63616E63656C2D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D';
wwv_flow_imp.g_varchar2_table(42029) := '6576656E742D63616E63656C222C7461726765743A7B747970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A43616E63656C4576656E74446566696E6974696F6E227D7D2C7B6C6162656C';
wwv_flow_imp.g_varchar2_table(42030) := '3A22436F6D70656E736174696F6E20656E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6D70656E736174696F6E2D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D';
wwv_flow_imp.g_varchar2_table(42031) := '636F6D70656E736174696F6E222C7461726765743A7B747970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E227D7D2C7B6C';
wwv_flow_imp.g_varchar2_table(42032) := '6162656C3A225369676E616C20656E64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D7369676E616C2D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D7369676E616C222C';
wwv_flow_imp.g_varchar2_table(42033) := '7461726765743A7B747970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E227D7D2C7B6C6162656C3A225465726D696E61746520656E';
wwv_flow_imp.g_varchar2_table(42034) := '64206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D7465726D696E6174652D656E64222C636C6173734E616D653A2262706D6E2D69636F6E2D656E642D6576656E742D7465726D696E617465222C7461726765743A7B74';
wwv_flow_imp.g_varchar2_table(42035) := '7970653A2262706D6E3A456E644576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5465726D696E6174654576656E74446566696E6974696F6E227D7D5D2C56763D5B7B6C6162656C3A224578636C757369766520676174';
wwv_flow_imp.g_varchar2_table(42036) := '65776179222C616374696F6E4E616D653A227265706C6163652D776974682D6578636C75736976652D67617465776179222C636C6173734E616D653A2262706D6E2D69636F6E2D676174657761792D786F72222C7461726765743A7B747970653A226270';
wwv_flow_imp.g_varchar2_table(42037) := '6D6E3A4578636C757369766547617465776179227D7D2C7B6C6162656C3A22506172616C6C656C2067617465776179222C616374696F6E4E616D653A227265706C6163652D776974682D706172616C6C656C2D67617465776179222C636C6173734E616D';
wwv_flow_imp.g_varchar2_table(42038) := '653A2262706D6E2D69636F6E2D676174657761792D706172616C6C656C222C7461726765743A7B747970653A2262706D6E3A506172616C6C656C47617465776179227D7D2C7B6C6162656C3A22496E636C75736976652067617465776179222C61637469';
wwv_flow_imp.g_varchar2_table(42039) := '6F6E4E616D653A227265706C6163652D776974682D696E636C75736976652D67617465776179222C636C6173734E616D653A2262706D6E2D69636F6E2D676174657761792D6F72222C7461726765743A7B747970653A2262706D6E3A496E636C75736976';
wwv_flow_imp.g_varchar2_table(42040) := '6547617465776179227D7D2C7B6C6162656C3A22436F6D706C65782067617465776179222C616374696F6E4E616D653A227265706C6163652D776974682D636F6D706C65782D67617465776179222C636C6173734E616D653A2262706D6E2D69636F6E2D';
wwv_flow_imp.g_varchar2_table(42041) := '676174657761792D636F6D706C6578222C7461726765743A7B747970653A2262706D6E3A436F6D706C657847617465776179227D7D2C7B6C6162656C3A224576656E742D62617365642067617465776179222C616374696F6E4E616D653A227265706C61';
wwv_flow_imp.g_varchar2_table(42042) := '63652D776974682D6576656E742D62617365642D67617465776179222C636C6173734E616D653A2262706D6E2D69636F6E2D676174657761792D6576656E746261736564222C7461726765743A7B747970653A2262706D6E3A4576656E74426173656447';
wwv_flow_imp.g_varchar2_table(42043) := '617465776179222C696E7374616E74696174653A21312C6576656E7447617465776179547970653A224578636C7573697665227D7D5D2C7A763D5B7B6C6162656C3A225472616E73616374696F6E222C616374696F6E4E616D653A227265706C6163652D';
wwv_flow_imp.g_varchar2_table(42044) := '776974682D7472616E73616374696F6E222C636C6173734E616D653A2262706D6E2D69636F6E2D7472616E73616374696F6E222C7461726765743A7B747970653A2262706D6E3A5472616E73616374696F6E222C6973457870616E6465643A21307D7D2C';
wwv_flow_imp.g_varchar2_table(42045) := '7B6C6162656C3A224576656E74207375622D70726F63657373222C616374696F6E4E616D653A227265706C6163652D776974682D6576656E742D73756270726F63657373222C636C6173734E616D653A2262706D6E2D69636F6E2D6576656E742D737562';
wwv_flow_imp.g_varchar2_table(42046) := '70726F636573732D657870616E646564222C7461726765743A7B747970653A2262706D6E3A53756250726F63657373222C74726967676572656442794576656E743A21302C6973457870616E6465643A21307D7D2C7B6C6162656C3A225375622D70726F';
wwv_flow_imp.g_varchar2_table(42047) := '636573732028636F6C6C617073656429222C616374696F6E4E616D653A227265706C6163652D776974682D636F6C6C61707365642D73756270726F63657373222C636C6173734E616D653A2262706D6E2D69636F6E2D73756270726F636573732D636F6C';
wwv_flow_imp.g_varchar2_table(42048) := '6C6170736564222C7461726765743A7B747970653A2262706D6E3A53756250726F63657373222C6973457870616E6465643A21317D7D5D2C48763D5B7B6C6162656C3A225472616E73616374696F6E222C616374696F6E4E616D653A227265706C616365';
wwv_flow_imp.g_varchar2_table(42049) := '2D776974682D7472616E73616374696F6E222C636C6173734E616D653A2262706D6E2D69636F6E2D7472616E73616374696F6E222C7461726765743A7B747970653A2262706D6E3A5472616E73616374696F6E222C6973457870616E6465643A21307D7D';
wwv_flow_imp.g_varchar2_table(42050) := '2C7B6C6162656C3A225375622D70726F63657373222C616374696F6E4E616D653A227265706C6163652D776974682D73756270726F63657373222C636C6173734E616D653A2262706D6E2D69636F6E2D73756270726F636573732D657870616E64656422';
wwv_flow_imp.g_varchar2_table(42051) := '2C7461726765743A7B747970653A2262706D6E3A53756250726F63657373222C6973457870616E6465643A21307D7D2C7B6C6162656C3A224576656E74207375622D70726F63657373222C616374696F6E4E616D653A227265706C6163652D776974682D';
wwv_flow_imp.g_varchar2_table(42052) := '6576656E742D73756270726F63657373222C636C6173734E616D653A2262706D6E2D69636F6E2D6576656E742D73756270726F636573732D657870616E646564222C7461726765743A7B747970653A2262706D6E3A53756250726F63657373222C747269';
wwv_flow_imp.g_varchar2_table(42053) := '67676572656442794576656E743A21302C6973457870616E6465643A21307D7D5D2C57763D48762C6A763D5B7B6C6162656C3A225461736B222C616374696F6E4E616D653A227265706C6163652D776974682D7461736B222C636C6173734E616D653A22';
wwv_flow_imp.g_varchar2_table(42054) := '62706D6E2D69636F6E2D7461736B222C7461726765743A7B747970653A2262706D6E3A5461736B227D7D2C7B6C6162656C3A2255736572207461736B222C616374696F6E4E616D653A227265706C6163652D776974682D757365722D7461736B222C636C';
wwv_flow_imp.g_varchar2_table(42055) := '6173734E616D653A2262706D6E2D69636F6E2D75736572222C7461726765743A7B747970653A2262706D6E3A557365725461736B227D7D2C7B6C6162656C3A2253657276696365207461736B222C616374696F6E4E616D653A227265706C6163652D7769';
wwv_flow_imp.g_varchar2_table(42056) := '74682D736572766963652D7461736B222C636C6173734E616D653A2262706D6E2D69636F6E2D73657276696365222C7461726765743A7B747970653A2262706D6E3A536572766963655461736B227D7D2C7B6C6162656C3A2253656E64207461736B222C';
wwv_flow_imp.g_varchar2_table(42057) := '616374696F6E4E616D653A227265706C6163652D776974682D73656E642D7461736B222C636C6173734E616D653A2262706D6E2D69636F6E2D73656E64222C7461726765743A7B747970653A2262706D6E3A53656E645461736B227D7D2C7B6C6162656C';
wwv_flow_imp.g_varchar2_table(42058) := '3A2252656365697665207461736B222C616374696F6E4E616D653A227265706C6163652D776974682D726563656976652D7461736B222C636C6173734E616D653A2262706D6E2D69636F6E2D72656365697665222C7461726765743A7B747970653A2262';
wwv_flow_imp.g_varchar2_table(42059) := '706D6E3A526563656976655461736B227D7D2C7B6C6162656C3A224D616E75616C207461736B222C616374696F6E4E616D653A227265706C6163652D776974682D6D616E75616C2D7461736B222C636C6173734E616D653A2262706D6E2D69636F6E2D6D';
wwv_flow_imp.g_varchar2_table(42060) := '616E75616C222C7461726765743A7B747970653A2262706D6E3A4D616E75616C5461736B227D7D2C7B6C6162656C3A22427573696E6573732072756C65207461736B222C616374696F6E4E616D653A227265706C6163652D776974682D72756C652D7461';
wwv_flow_imp.g_varchar2_table(42061) := '736B222C636C6173734E616D653A2262706D6E2D69636F6E2D627573696E6573732D72756C65222C7461726765743A7B747970653A2262706D6E3A427573696E65737352756C655461736B227D7D2C7B6C6162656C3A22536372697074207461736B222C';
wwv_flow_imp.g_varchar2_table(42062) := '616374696F6E4E616D653A227265706C6163652D776974682D7363726970742D7461736B222C636C6173734E616D653A2262706D6E2D69636F6E2D736372697074222C7461726765743A7B747970653A2262706D6E3A5363726970745461736B227D7D2C';
wwv_flow_imp.g_varchar2_table(42063) := '7B6C6162656C3A2243616C6C206163746976697479222C616374696F6E4E616D653A227265706C6163652D776974682D63616C6C2D6163746976697479222C636C6173734E616D653A2262706D6E2D69636F6E2D63616C6C2D6163746976697479222C74';
wwv_flow_imp.g_varchar2_table(42064) := '61726765743A7B747970653A2262706D6E3A43616C6C4163746976697479227D7D2C7B6C6162656C3A225375622D70726F636573732028636F6C6C617073656429222C616374696F6E4E616D653A227265706C6163652D776974682D636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(42065) := '642D73756270726F63657373222C636C6173734E616D653A2262706D6E2D69636F6E2D73756270726F636573732D636F6C6C6170736564222C7461726765743A7B747970653A2262706D6E3A53756250726F63657373222C6973457870616E6465643A21';
wwv_flow_imp.g_varchar2_table(42066) := '317D7D2C7B6C6162656C3A225375622D70726F636573732028657870616E64656429222C616374696F6E4E616D653A227265706C6163652D776974682D657870616E6465642D73756270726F63657373222C636C6173734E616D653A2262706D6E2D6963';
wwv_flow_imp.g_varchar2_table(42067) := '6F6E2D73756270726F636573732D657870616E646564222C7461726765743A7B747970653A2262706D6E3A53756250726F63657373222C6973457870616E6465643A21307D7D5D2C71763D5B7B6C6162656C3A22446174612073746F7265207265666572';
wwv_flow_imp.g_varchar2_table(42068) := '656E6365222C616374696F6E4E616D653A227265706C6163652D776974682D646174612D73746F72652D7265666572656E6365222C636C6173734E616D653A2262706D6E2D69636F6E2D646174612D73746F7265222C7461726765743A7B747970653A22';
wwv_flow_imp.g_varchar2_table(42069) := '62706D6E3A4461746153746F72655265666572656E6365227D7D5D2C24763D5B7B6C6162656C3A2244617461206F626A656374207265666572656E6365222C616374696F6E4E616D653A227265706C6163652D776974682D646174612D6F626A6563742D';
wwv_flow_imp.g_varchar2_table(42070) := '7265666572656E6365222C636C6173734E616D653A2262706D6E2D69636F6E2D646174612D6F626A656374222C7461726765743A7B747970653A2262706D6E3A446174614F626A6563745265666572656E6365227D7D5D2C55763D5B7B6C6162656C3A22';
wwv_flow_imp.g_varchar2_table(42071) := '4D65737361676520626F756E64617279206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6D6573736167652D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(42072) := '2D6576656E742D63617463682D6D657373616765222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(42073) := '74696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C6162656C3A2254696D657220626F756E64617279206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D74696D65722D626F756E64617279222C636C61';
wwv_flow_imp.g_varchar2_table(42074) := '73734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D74696D6572222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E54';
wwv_flow_imp.g_varchar2_table(42075) := '7970653A2262706D6E3A54696D65724576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C6162656C3A22457363616C6174696F6E20626F756E64617279206576656E74222C616374696F6E4E616D653A2272';
wwv_flow_imp.g_varchar2_table(42076) := '65706C6163652D776974682D657363616C6174696F6E2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D657363616C6174696F6E222C7461726765743A7B74';
wwv_flow_imp.g_varchar2_table(42077) := '7970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C';
wwv_flow_imp.g_varchar2_table(42078) := '6162656C3A22436F6E646974696F6E616C20626F756E64617279206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6E646974696F6E616C2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F';
wwv_flow_imp.g_varchar2_table(42079) := '6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6E646974696F6E222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A436F';
wwv_flow_imp.g_varchar2_table(42080) := '6E646974696F6E616C4576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C6162656C3A224572726F7220626F756E64617279206576656E74222C616374696F6E4E616D653A227265706C6163652D77697468';
wwv_flow_imp.g_varchar2_table(42081) := '2D6572726F722D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6572726F72222C7461726765743A7B747970653A2262706D6E3A426F756E64617279457665';
wwv_flow_imp.g_varchar2_table(42082) := '6E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4572726F724576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C6162656C3A2243616E63656C20626F756E64617279206576656E';
wwv_flow_imp.g_varchar2_table(42083) := '74222C616374696F6E4E616D653A227265706C6163652D776974682D63616E63656C2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D63616E63656C222C74';
wwv_flow_imp.g_varchar2_table(42084) := '61726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A43616E63656C4576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21307D';
wwv_flow_imp.g_varchar2_table(42085) := '7D2C7B6C6162656C3A225369676E616C20626F756E64617279206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D7369676E616C2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465';
wwv_flow_imp.g_varchar2_table(42086) := '726D6564696174652D6576656E742D63617463682D7369676E616C222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E74';
wwv_flow_imp.g_varchar2_table(42087) := '446566696E6974696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C6162656C3A22436F6D70656E736174696F6E20626F756E64617279206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6D70656E';
wwv_flow_imp.g_varchar2_table(42088) := '736174696F6E2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6D70656E736174696F6E222C7461726765743A7B747970653A2262706D6E3A426F756E';
wwv_flow_imp.g_varchar2_table(42089) := '646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21307D7D2C7B6C6162656C3A224D65737361676520';
wwv_flow_imp.g_varchar2_table(42090) := '626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D6D6573736167652D626F756E64617279222C636C617373';
wwv_flow_imp.g_varchar2_table(42091) := '4E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D657373616765222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E7422';
wwv_flow_imp.g_varchar2_table(42092) := '2C6576656E74446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21317D7D2C7B6C6162656C3A2254696D657220626F756E64617279206576656E7420';
wwv_flow_imp.g_varchar2_table(42093) := '286E6F6E2D696E74657272757074696E6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D74696D65722D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D69';
wwv_flow_imp.g_varchar2_table(42094) := '6E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D74696D6572222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970';
wwv_flow_imp.g_varchar2_table(42095) := '653A2262706D6E3A54696D65724576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21317D7D2C7B6C6162656C3A22457363616C6174696F6E20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E';
wwv_flow_imp.g_varchar2_table(42096) := '6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(42097) := '2D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D';
wwv_flow_imp.g_varchar2_table(42098) := '6E3A457363616C6174696F6E4576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21317D7D2C7B6C6162656C3A22436F6E646974696F6E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E';
wwv_flow_imp.g_varchar2_table(42099) := '6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E616C2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(42100) := '652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D';
wwv_flow_imp.g_varchar2_table(42101) := '6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E222C63616E63656C41637469766974793A21317D7D2C7B6C6162656C3A225369676E616C20626F756E64617279206576656E7420286E6F6E2D696E74657272757074696E6729222C';
wwv_flow_imp.g_varchar2_table(42102) := '616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D7369676E616C2D626F756E64617279222C636C6173734E616D653A2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63';
wwv_flow_imp.g_varchar2_table(42103) := '617463682D6E6F6E2D696E74657272757074696E672D7369676E616C222C7461726765743A7B747970653A2262706D6E3A426F756E646172794576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E';
wwv_flow_imp.g_varchar2_table(42104) := '74446566696E6974696F6E222C63616E63656C41637469766974793A21317D7D5D2C4B763D5B7B6C6162656C3A224D657373616765207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6D6573736167652D';
wwv_flow_imp.g_varchar2_table(42105) := '7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6D657373616765222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A';
wwv_flow_imp.g_varchar2_table(42106) := '2262706D6E3A4D6573736167654576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21307D7D2C7B6C6162656C3A2254696D6572207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974';
wwv_flow_imp.g_varchar2_table(42107) := '682D74696D65722D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D74696D6572222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(42108) := '6E547970653A2262706D6E3A54696D65724576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21307D7D2C7B6C6162656C3A22436F6E646974696F6E616C207374617274206576656E74222C616374696F6E4E616D653A2272';
wwv_flow_imp.g_varchar2_table(42109) := '65706C6163652D776974682D636F6E646974696F6E616C2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D636F6E646974696F6E222C7461726765743A7B747970653A2262706D6E3A537461727445';
wwv_flow_imp.g_varchar2_table(42110) := '76656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21307D7D2C7B6C6162656C3A225369676E616C207374617274';
wwv_flow_imp.g_varchar2_table(42111) := '206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D7369676E616C2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D7369676E616C222C7461726765743A7B74797065';
wwv_flow_imp.g_varchar2_table(42112) := '3A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21307D7D2C7B6C6162656C3A224572726F';
wwv_flow_imp.g_varchar2_table(42113) := '72207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D6572726F722D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6572726F72222C7461726765743A';
wwv_flow_imp.g_varchar2_table(42114) := '7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4572726F724576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21307D7D2C7B6C6162656C3A22';
wwv_flow_imp.g_varchar2_table(42115) := '457363616C6174696F6E207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D657363616C6174696F6E2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D';
wwv_flow_imp.g_varchar2_table(42116) := '657363616C6174696F6E222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E222C6973496E';
wwv_flow_imp.g_varchar2_table(42117) := '74657272757074696E673A21307D7D2C7B6C6162656C3A22436F6D70656E736174696F6E207374617274206576656E74222C616374696F6E4E616D653A227265706C6163652D776974682D636F6D70656E736174696F6E2D7374617274222C636C617373';
wwv_flow_imp.g_varchar2_table(42118) := '4E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D636F6D70656E736174696F6E222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A43';
wwv_flow_imp.g_varchar2_table(42119) := '6F6D70656E736174654576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21307D7D2C7B6C6162656C3A224D657373616765207374617274206576656E7420286E6F6E2D696E74657272757074696E6729222C616374696F6E';
wwv_flow_imp.g_varchar2_table(42120) := '4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D6D6573736167652D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E67';
wwv_flow_imp.g_varchar2_table(42121) := '2D6D657373616765222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E222C6973496E7465727275';
wwv_flow_imp.g_varchar2_table(42122) := '7074696E673A21317D7D2C7B6C6162656C3A2254696D6572207374617274206576656E7420286E6F6E2D696E74657272757074696E6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D74';
wwv_flow_imp.g_varchar2_table(42123) := '696D65722D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D74696D6572222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C';
wwv_flow_imp.g_varchar2_table(42124) := '6576656E74446566696E6974696F6E547970653A2262706D6E3A54696D65724576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21317D7D2C7B6C6162656C3A22436F6E646974696F6E616C207374617274206576656E7420';
wwv_flow_imp.g_varchar2_table(42125) := '286E6F6E2D696E74657272757074696E6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E616C2D7374617274222C636C6173734E616D653A2262706D6E2D69636F';
wwv_flow_imp.g_varchar2_table(42126) := '6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A43';
wwv_flow_imp.g_varchar2_table(42127) := '6F6E646974696F6E616C4576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21317D7D2C7B6C6162656C3A225369676E616C207374617274206576656E7420286E6F6E2D696E74657272757074696E6729222C616374696F6E';
wwv_flow_imp.g_varchar2_table(42128) := '4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E672D7369676E616C2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D';
wwv_flow_imp.g_varchar2_table(42129) := '7369676E616C222C7461726765743A7B747970653A2262706D6E3A53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E222C6973496E7465727275707469';
wwv_flow_imp.g_varchar2_table(42130) := '6E673A21317D7D2C7B6C6162656C3A22457363616C6174696F6E207374617274206576656E7420286E6F6E2D696E74657272757074696E6729222C616374696F6E4E616D653A227265706C6163652D776974682D6E6F6E2D696E74657272757074696E67';
wwv_flow_imp.g_varchar2_table(42131) := '2D657363616C6174696F6E2D7374617274222C636C6173734E616D653A2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E222C7461726765743A7B747970653A2262706D6E3A';
wwv_flow_imp.g_varchar2_table(42132) := '53746172744576656E74222C6576656E74446566696E6974696F6E547970653A2262706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E222C6973496E74657272757074696E673A21317D7D5D2C47763D5B7B6C6162656C3A225365';
wwv_flow_imp.g_varchar2_table(42133) := '7175656E636520666C6F77222C616374696F6E4E616D653A227265706C6163652D776974682D73657175656E63652D666C6F77222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E6E656374696F6E227D2C7B6C6162656C3A224465666175';
wwv_flow_imp.g_varchar2_table(42134) := '6C7420666C6F77222C616374696F6E4E616D653A227265706C6163652D776974682D64656661756C742D666C6F77222C636C6173734E616D653A2262706D6E2D69636F6E2D64656661756C742D666C6F77227D2C7B6C6162656C3A22436F6E646974696F';
wwv_flow_imp.g_varchar2_table(42135) := '6E616C20666C6F77222C616374696F6E4E616D653A227265706C6163652D776974682D636F6E646974696F6E616C2D666C6F77222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E646974696F6E616C2D666C6F77227D5D2C51763D5B7B6C';
wwv_flow_imp.g_varchar2_table(42136) := '6162656C3A22457870616E64656420706F6F6C2F7061727469636970616E74222C616374696F6E4E616D653A227265706C6163652D776974682D657870616E6465642D706F6F6C222C636C6173734E616D653A2262706D6E2D69636F6E2D706172746963';
wwv_flow_imp.g_varchar2_table(42137) := '6970616E74222C7461726765743A7B747970653A2262706D6E3A5061727469636970616E74222C6973457870616E6465643A21307D7D2C7B6C6162656C3A66756E6374696F6E2865297B76617220743D22456D70747920706F6F6C2F7061727469636970';
wwv_flow_imp.g_varchar2_table(42138) := '616E74223B72657475726E20652E6368696C6472656E2626652E6368696C6472656E2E6C656E677468262628742B3D22202872656D6F76657320636F6E74656E742922292C747D2C616374696F6E4E616D653A227265706C6163652D776974682D636F6C';
wwv_flow_imp.g_varchar2_table(42139) := '6C61707365642D706F6F6C222C636C6173734E616D653A2262706D6E2D69636F6E2D6C616E65222C7461726765743A7B747970653A2262706D6E3A5061727469636970616E74222C6973457870616E6465643A21317D7D5D3B636F6E73742059763D275C';
wwv_flow_imp.g_varchar2_table(42140) := '6E20203C7376672076696577426F783D22302030203230343820323034382220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667223E5C6E202020203C67207472616E73666F726D3D227472616E736C61746528302039';
wwv_flow_imp.g_varchar2_table(42141) := '39352E363429223E5C6E2020202020203C7061746820643D226D313839392032382E3335376332312E353435203536372E34332D3539382E333820313032332E352D313133332E36203833352E39322D3534382E30392D3134372E32312D3830312E3537';
wwv_flow_imp.g_varchar2_table(42142) := '2D3837332E39352D3436332E35392D31333330203330322E36322D3438302E3320313037312E372D3530372E353420313430372E362D34392E383437203132322E3134203135332E3132203139302E3037203334382E3037203138392E3539203534332E';
wwv_flow_imp.g_varchar2_table(42143) := '39317A222066696C6C3D226E6F6E6522207374726F6B653D2263757272656E74436F6C6F7222207374726F6B652D6461736861727261793D223431382E3331303432322C203336312E3233323831363522207374726F6B652D6C696E656361703D22726F';
wwv_flow_imp.g_varchar2_table(42144) := '756E6422207374726F6B652D77696474683D22313030222F3E5C6E202020203C2F673E5C6E20203C2F7376673E272C5A763D275C6E20203C7376672076696577426F783D22302030203230343820323034382220786D6C6E733D22687474703A2F2F7777';
wwv_flow_imp.g_varchar2_table(42145) := '772E77332E6F72672F323030302F737667223E5C6E20202020203C67207472616E73666F726D3D227472616E736C6174652830203939352E363429222066696C6C3D226E6F6E6522207374726F6B653D2263757272656E74436F6C6F7222207374726F6B';
wwv_flow_imp.g_varchar2_table(42146) := '652D6C696E656361703D22726F756E64223E5C6E20202020202020203C636972636C652063783D2231303234222063793D2232382E3335372220723D2238373522207374726F6B652D6461736861727261793D223431382E3331303432322C203336312E';
wwv_flow_imp.g_varchar2_table(42147) := '3233323831363522207374726F6B652D77696474683D22313030222F3E5C6E20202020202020203C636972636C652063783D2231303234222063793D2232382E3335372220723D2236383522207374726F6B652D6461736861727261793D223334382E33';
wwv_flow_imp.g_varchar2_table(42148) := '313034343835372C3236312E323332383336343322207374726F6B652D646173686F66667365743D2235303022207374726F6B652D77696474683D22313030222F3E5C6E20202020203C2F673E5C6E20203C2F7376673E273B66756E6374696F6E205876';
wwv_flow_imp.g_varchar2_table(42149) := '28652C742C6E2C692C6F2C732C722C61297B746869732E5F62706D6E466163746F72793D652C746869732E5F706F7075704D656E753D742C746869732E5F6D6F64656C696E673D6E2C746869732E5F6D6F64646C653D692C746869732E5F62706D6E5265';
wwv_flow_imp.g_varchar2_table(42150) := '706C6163653D6F2C746869732E5F72756C65733D732C746869732E5F7472616E736C6174653D722C746869732E5F6D6F64646C65436F70793D612C746869732E5F726567697374657228297D58762E24696E6A6563743D5B2262706D6E466163746F7279';
wwv_flow_imp.g_varchar2_table(42151) := '222C22706F7075704D656E75222C226D6F64656C696E67222C226D6F64646C65222C2262706D6E5265706C616365222C2272756C6573222C227472616E736C617465222C226D6F64646C65436F7079225D2C58762E70726F746F747970652E5F72656769';
wwv_flow_imp.g_varchar2_table(42152) := '737465723D66756E6374696F6E28297B746869732E5F706F7075704D656E752E726567697374657250726F7669646572282262706D6E2D7265706C616365222C74686973297D2C58762E70726F746F747970652E676574506F7075704D656E75456E7472';
wwv_flow_imp.g_varchar2_table(42153) := '6965733D66756E6374696F6E2865297B76617220743D652E627573696E6573734F626A6563742C6E3D746869732E5F72756C65732C6F3D5B5D3B69662828302C692E6379292865297C7C216E2E616C6C6F776564282273686170652E7265706C61636522';
wwv_flow_imp.g_varchar2_table(42154) := '2C7B656C656D656E743A657D292972657475726E7B7D3B76617220733D50762865293B72657475726E28302C792E69732928742C2262706D6E3A446174614F626A6563745265666572656E636522293F746869732E5F637265617465456E747269657328';
wwv_flow_imp.g_varchar2_table(42155) := '652C7176293A28302C792E69732928742C2262706D6E3A4461746153746F72655265666572656E6365222926262128302C792E69732928652E706172656E742C2262706D6E3A436F6C6C61626F726174696F6E22293F746869732E5F637265617465456E';
wwv_flow_imp.g_varchar2_table(42156) := '747269657328652C2476293A28302C792E69732928742C2262706D6E3A53746172744576656E74222926262128302C792E69732928742E24706172656E742C2262706D6E3A53756250726F6365737322293F286F3D28302C692E706229284F762C73292C';
wwv_flow_imp.g_varchar2_table(42157) := '746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A5061727469636970616E7422293F286F3D28302C692E7062292851762C2866756E6374696F6E2874297B72657475726E28302C72732E417629';
wwv_flow_imp.g_varchar2_table(42158) := '286529213D3D742E7461726765742E6973457870616E6465647D29292C746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A53746172744576656E742229262628302C72732E51312928742E2470';
wwv_flow_imp.g_varchar2_table(42159) := '6172656E74293F286F3D28302C692E706229284B762C2866756E6374696F6E2865297B766172206E3D2131213D3D652E7461726765742E6973496E74657272757074696E672C693D742E6973496E74657272757074696E673D3D3D6E3B72657475726E20';
wwv_flow_imp.g_varchar2_table(42160) := '732865297C7C2173286529262621697D29292C746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A53746172744576656E74222926262128302C72732E51312928742E24706172656E7429262628';
wwv_flow_imp.g_varchar2_table(42161) := '302C792E69732928742E24706172656E742C2262706D6E3A53756250726F6365737322293F286F3D28302C692E7062292852762C73292C746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A456E';
wwv_flow_imp.g_varchar2_table(42162) := '644576656E7422293F286F3D28302C692E7062292842762C2866756E6374696F6E2865297B72657475726E21282262706D6E3A43616E63656C4576656E74446566696E6974696F6E223D3D652E7461726765742E6576656E74446566696E6974696F6E54';
wwv_flow_imp.g_varchar2_table(42163) := '79706526262128302C792E69732928742E24706172656E742C2262706D6E3A5472616E73616374696F6E2229292626732865297D29292C746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A426F';
wwv_flow_imp.g_varchar2_table(42164) := '756E646172794576656E7422293F286F3D28302C692E7062292855762C2866756E6374696F6E2865297B766172206E3D652E7461726765743B6966282262706D6E3A43616E63656C4576656E74446566696E6974696F6E223D3D6E2E6576656E74446566';
wwv_flow_imp.g_varchar2_table(42165) := '696E6974696F6E5479706526262128302C792E69732928742E6174746163686564546F5265662C2262706D6E3A5472616E73616374696F6E22292972657475726E21313B76617220693D2131213D3D6E2E63616E63656C41637469766974792C6F3D742E';
wwv_flow_imp.g_varchar2_table(42166) := '63616E63656C41637469766974793D3D693B72657475726E20732865297C7C21732865292626216F7D29292C746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A496E7465726D65646961746543';
wwv_flow_imp.g_varchar2_table(42167) := '617463684576656E7422297C7C28302C792E69732928742C2262706D6E3A496E7465726D6564696174655468726F774576656E7422293F286F3D28302C692E7062292846762C73292C746869732E5F637265617465456E747269657328652C6F29293A28';
wwv_flow_imp.g_varchar2_table(42168) := '302C792E69732928742C2262706D6E3A4761746577617922293F286F3D28302C692E7062292856762C73292C746869732E5F637265617465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A5472616E73616374696F6E2229';
wwv_flow_imp.g_varchar2_table(42169) := '3F286F3D28302C692E7062292848762C73292C746869732E5F637265617465456E747269657328652C6F29293A28302C72732E513129287429262628302C72732E4176292865293F286F3D28302C692E7062292857762C73292C746869732E5F63726561';
wwv_flow_imp.g_varchar2_table(42170) := '7465456E747269657328652C6F29293A28302C792E69732928742C2262706D6E3A53756250726F636573732229262628302C72732E4176292865293F286F3D28302C692E706229287A762C73292C746869732E5F637265617465456E747269657328652C';
wwv_flow_imp.g_varchar2_table(42171) := '6F29293A28302C792E69732928742C2262706D6E3A4164486F6353756250726F63657373222926262128302C72732E4176292865293F286F3D28302C692E706229286A762C2866756E6374696F6E2865297B76617220743D652E7461726765742C6E3D22';
wwv_flow_imp.g_varchar2_table(42172) := '62706D6E3A53756250726F63657373223D3D3D742E747970652C693D21303D3D3D742E6973457870616E6465643B72657475726E205076287429262628216E7C7C69297D29292C746869732E5F637265617465456E747269657328652C6F29293A28302C';
wwv_flow_imp.g_varchar2_table(42173) := '792E69732928742C2262706D6E3A53657175656E6365466C6F7722293F746869732E5F63726561746553657175656E6365466C6F77456E747269657328652C4776293A28302C792E69732928742C2262706D6E3A466C6F774E6F646522293F286F3D2830';
wwv_flow_imp.g_varchar2_table(42174) := '2C692E706229286A762C73292C28302C792E69732928742C2262706D6E3A53756250726F63657373222926262128302C72732E4176292865292626286F3D28302C692E706229286F2C2866756E6374696F6E2865297B72657475726E225375622D70726F';
wwv_flow_imp.g_varchar2_table(42175) := '636573732028636F6C6C61707365642922213D3D652E6C6162656C7D2929292C746869732E5F637265617465456E747269657328652C6F29293A7B7D7D2C58762E70726F746F747970652E676574506F7075704D656E75486561646572456E7472696573';
wwv_flow_imp.g_varchar2_table(42176) := '3D66756E6374696F6E2865297B76617220743D7B7D3B72657475726E28302C792E69732928652C2262706D6E3A4163746976697479222926262128302C72732E513129286529262628743D7B2E2E2E742C2E2E2E746869732E5F6765744C6F6F70436861';
wwv_flow_imp.g_varchar2_table(42177) := '726163746572697374696373486561646572456E74726965732865297D292C28302C792E69732928652C2262706D6E3A446174614F626A6563745265666572656E63652229262628743D7B2E2E2E742C2E2E2E746869732E5F676574436F6C6C65637469';
wwv_flow_imp.g_varchar2_table(42178) := '6F6E486561646572456E74726965732865297D292C28302C792E69732928652C2262706D6E3A5061727469636970616E742229262628743D7B2E2E2E742C2E2E2E746869732E5F6765745061727469636970616E744D756C7469706C6963697479486561';
wwv_flow_imp.g_varchar2_table(42179) := '646572456E74726965732865297D292C2128302C792E69732928652C2262706D6E3A53756250726F6365737322297C7C28302C792E69732928652C2262706D6E3A5472616E73616374696F6E22297C7C28302C72732E5131292865297C7C28743D7B2E2E';
wwv_flow_imp.g_varchar2_table(42180) := '2E742C2E2E2E746869732E5F6765744164486F63486561646572456E74726965732865297D292C4975286529262628743D7B2E2E2E742C2E2E2E746869732E5F6765744E6F6E496E74657272757074696E67486561646572456E74726965732865297D29';
wwv_flow_imp.g_varchar2_table(42181) := '2C747D2C58762E70726F746F747970652E5F637265617465456E74726965733D66756E6374696F6E28652C74297B766172206E3D7B7D2C6F3D746869733B72657475726E28302C692E6A4A2928742C2866756E6374696F6E2874297B6E5B742E61637469';
wwv_flow_imp.g_varchar2_table(42182) := '6F6E4E616D655D3D6F2E5F637265617465456E74727928742C65297D29292C6E7D2C58762E70726F746F747970652E5F63726561746553657175656E6365466C6F77456E74726965733D66756E6374696F6E28652C74297B766172206E3D28302C792E67';
wwv_flow_imp.g_varchar2_table(42183) := '6574427573696E6573734F626A656374292865292C6F3D7B7D2C733D746869732E5F6D6F64656C696E672C723D746869732E5F6D6F64646C652C613D746869733B72657475726E28302C692E6A4A2928742C2866756E6374696F6E2874297B7377697463';
wwv_flow_imp.g_varchar2_table(42184) := '6828742E616374696F6E4E616D65297B63617365227265706C6163652D776974682D64656661756C742D666C6F77223A6E2E736F757263655265662E64656661756C74213D3D6E26262828302C792E697329286E2E736F757263655265662C2262706D6E';
wwv_flow_imp.g_varchar2_table(42185) := '3A4578636C75736976654761746577617922297C7C28302C792E697329286E2E736F757263655265662C2262706D6E3A496E636C75736976654761746577617922297C7C28302C792E697329286E2E736F757263655265662C2262706D6E3A436F6D706C';
wwv_flow_imp.g_varchar2_table(42186) := '65784761746577617922297C7C28302C792E697329286E2E736F757263655265662C2262706D6E3A41637469766974792229292626286F3D7B2E2E2E6F2C5B742E616374696F6E4E616D655D3A612E5F637265617465456E74727928742C652C2866756E';
wwv_flow_imp.g_varchar2_table(42187) := '6374696F6E28297B732E75706461746550726F7065727469657328652E736F757263652C7B64656661756C743A6E7D297D29297D293B627265616B3B63617365227265706C6163652D776974682D636F6E646974696F6E616C2D666C6F77223A216E2E63';
wwv_flow_imp.g_varchar2_table(42188) := '6F6E646974696F6E45787072657373696F6E262628302C792E697329286E2E736F757263655265662C2262706D6E3A416374697669747922292626286F3D7B2E2E2E6F2C5B742E616374696F6E4E616D655D3A612E5F637265617465456E74727928742C';
wwv_flow_imp.g_varchar2_table(42189) := '652C2866756E6374696F6E28297B76617220743D722E637265617465282262706D6E3A466F726D616C45787072657373696F6E222C7B626F64793A22227D293B732E75706461746550726F7065727469657328652C7B636F6E646974696F6E4578707265';
wwv_flow_imp.g_varchar2_table(42190) := '7373696F6E3A747D297D29297D293B627265616B3B64656661756C743A28302C792E697329286E2E736F757263655265662C2262706D6E3A4163746976697479222926266E2E636F6E646974696F6E45787072657373696F6E2626286F3D7B2E2E2E6F2C';
wwv_flow_imp.g_varchar2_table(42191) := '5B742E616374696F6E4E616D655D3A612E5F637265617465456E74727928742C652C2866756E6374696F6E28297B732E75706461746550726F7065727469657328652C7B636F6E646974696F6E45787072657373696F6E3A766F696420307D297D29297D';
wwv_flow_imp.g_varchar2_table(42192) := '292C2828302C792E697329286E2E736F757263655265662C2262706D6E3A4578636C75736976654761746577617922297C7C28302C792E697329286E2E736F757263655265662C2262706D6E3A496E636C75736976654761746577617922297C7C28302C';
wwv_flow_imp.g_varchar2_table(42193) := '792E697329286E2E736F757263655265662C2262706D6E3A436F6D706C65784761746577617922297C7C28302C792E697329286E2E736F757263655265662C2262706D6E3A416374697669747922292926266E2E736F757263655265662E64656661756C';
wwv_flow_imp.g_varchar2_table(42194) := '743D3D3D6E2626286F3D7B2E2E2E6F2C5B742E616374696F6E4E616D655D3A612E5F637265617465456E74727928742C652C2866756E6374696F6E28297B732E75706461746550726F7065727469657328652E736F757263652C7B64656661756C743A76';
wwv_flow_imp.g_varchar2_table(42195) := '6F696420307D297D29297D297D7D29292C6F7D2C58762E70726F746F747970652E5F637265617465456E7472793D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F7472616E736C6174652C6F3D746869732E5F62706D6E5265706C';
wwv_flow_imp.g_varchar2_table(42196) := '6163652E7265706C616365456C656D656E742C733D652E6C6162656C3B72657475726E207326262266756E6374696F6E223D3D747970656F662073262628733D73287429292C6E3D6E7C7C66756E6374696F6E28297B72657475726E206F28742C652E74';
wwv_flow_imp.g_varchar2_table(42197) := '6172676574297D2C7B6C6162656C3A692873292C636C6173734E616D653A652E636C6173734E616D652C616374696F6E3A6E7D7D2C58762E70726F746F747970652E5F6765744C6F6F70436861726163746572697374696373486561646572456E747269';
wwv_flow_imp.g_varchar2_table(42198) := '65733D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E5F7472616E736C6174653B66756E6374696F6E2069286E2C69297B696628692E6163746976652972657475726E20766F696420742E5F6D6F64656C696E672E75706461';
wwv_flow_imp.g_varchar2_table(42199) := '746550726F7065727469657328652C7B6C6F6F704368617261637465726973746963733A766F696420307D293B636F6E7374206F3D652E627573696E6573734F626A6563742E67657428226C6F6F7043686172616374657269737469637322292C733D74';
wwv_flow_imp.g_varchar2_table(42200) := '2E5F6D6F64646C652E63726561746528692E6F7074696F6E732E6C6F6F70436861726163746572697374696373293B6F2626742E5F6D6F64646C65436F70792E636F7079456C656D656E74286F2C73292C732E7365742822697353657175656E7469616C';
wwv_flow_imp.g_varchar2_table(42201) := '222C692E6F7074696F6E732E697353657175656E7469616C292C742E5F6D6F64656C696E672E75706461746550726F7065727469657328652C7B6C6F6F704368617261637465726973746963733A737D297D766172206F2C732C722C613D28302C792E67';
wwv_flow_imp.g_varchar2_table(42202) := '6574427573696E6573734F626A656374292865292E6C6F6F704368617261637465726973746963733B72657475726E20612626286F3D612E697353657175656E7469616C2C733D766F696420303D3D3D612E697353657175656E7469616C2C723D766F69';
wwv_flow_imp.g_varchar2_table(42203) := '642030213D3D612E697353657175656E7469616C262621612E697353657175656E7469616C292C7B22746F67676C652D706172616C6C656C2D6D69223A7B636C6173734E616D653A2262706D6E2D69636F6E2D706172616C6C656C2D6D692D6D61726B65';
wwv_flow_imp.g_varchar2_table(42204) := '72222C7469746C653A6E2822506172616C6C656C206D756C74692D696E7374616E636522292C6163746976653A722C616374696F6E3A692C6F7074696F6E733A7B6C6F6F704368617261637465726973746963733A2262706D6E3A4D756C7469496E7374';
wwv_flow_imp.g_varchar2_table(42205) := '616E63654C6F6F70436861726163746572697374696373222C697353657175656E7469616C3A21317D7D2C22746F67676C652D73657175656E7469616C2D6D69223A7B636C6173734E616D653A2262706D6E2D69636F6E2D73657175656E7469616C2D6D';
wwv_flow_imp.g_varchar2_table(42206) := '692D6D61726B6572222C7469746C653A6E282253657175656E7469616C206D756C74692D696E7374616E636522292C6163746976653A6F2C616374696F6E3A692C6F7074696F6E733A7B6C6F6F704368617261637465726973746963733A2262706D6E3A';
wwv_flow_imp.g_varchar2_table(42207) := '4D756C7469496E7374616E63654C6F6F70436861726163746572697374696373222C697353657175656E7469616C3A21307D7D2C22746F67676C652D6C6F6F70223A7B636C6173734E616D653A2262706D6E2D69636F6E2D6C6F6F702D6D61726B657222';
wwv_flow_imp.g_varchar2_table(42208) := '2C7469746C653A6E28224C6F6F7022292C6163746976653A732C616374696F6E3A692C6F7074696F6E733A7B6C6F6F704368617261637465726973746963733A2262706D6E3A5374616E646172644C6F6F70436861726163746572697374696373227D7D';
wwv_flow_imp.g_varchar2_table(42209) := '7D7D2C58762E70726F746F747970652E5F676574436F6C6C656374696F6E486561646572456E74726965733D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E5F7472616E736C6174652C693D652E627573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(42210) := '6563742E646174614F626A6563745265663B69662821692972657475726E7B7D3B766172206F3D692E6973436F6C6C656374696F6E3B72657475726E7B22746F67676C652D69732D636F6C6C656374696F6E223A7B636C6173734E616D653A2262706D6E';
wwv_flow_imp.g_varchar2_table(42211) := '2D69636F6E2D706172616C6C656C2D6D692D6D61726B6572222C7469746C653A6E2822436F6C6C656374696F6E22292C6163746976653A6F2C616374696F6E3A66756E6374696F6E286E2C6F297B742E5F6D6F64656C696E672E7570646174654D6F6464';
wwv_flow_imp.g_varchar2_table(42212) := '6C6550726F7065727469657328652C692C7B6973436F6C6C656374696F6E3A216F2E6163746976657D297D7D7D7D2C58762E70726F746F747970652E5F6765745061727469636970616E744D756C7469706C6963697479486561646572456E7472696573';
wwv_flow_imp.g_varchar2_table(42213) := '3D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E5F62706D6E466163746F72792C693D746869732E5F7472616E736C6174652C6F3D652E627573696E6573734F626A6563742E7061727469636970616E744D756C7469706C69';
wwv_flow_imp.g_varchar2_table(42214) := '636974793B72657475726E7B22746F67676C652D7061727469636970616E742D6D756C7469706C6963697479223A7B636C6173734E616D653A2262706D6E2D69636F6E2D706172616C6C656C2D6D692D6D61726B6572222C7469746C653A692822506172';
wwv_flow_imp.g_varchar2_table(42215) := '7469636970616E74206D756C7469706C696369747922292C6163746976653A21216F2C616374696F6E3A66756E6374696F6E28692C6F297B76617220733B6F2E6163746976657C7C28733D6E2E637265617465282262706D6E3A5061727469636970616E';
wwv_flow_imp.g_varchar2_table(42216) := '744D756C7469706C69636974792229292C742E5F6D6F64656C696E672E75706461746550726F7065727469657328652C7B7061727469636970616E744D756C7469706C69636974793A737D297D7D7D7D2C58762E70726F746F747970652E5F6765744164';
wwv_flow_imp.g_varchar2_table(42217) := '486F63486561646572456E74726965733D66756E6374696F6E2865297B76617220743D746869732E5F7472616E736C6174652C6E3D28302C792E676574427573696E6573734F626A656374292865292C693D28302C792E697329286E2C2262706D6E3A41';
wwv_flow_imp.g_varchar2_table(42218) := '64486F6353756250726F6365737322292C6F3D746869732E5F62706D6E5265706C6163652E7265706C616365456C656D656E743B72657475726E7B22746F67676C652D6164686F63223A7B636C6173734E616D653A2262706D6E2D69636F6E2D61642D68';
wwv_flow_imp.g_varchar2_table(42219) := '6F632D6D61726B6572222C7469746C653A74282241642D686F6322292C6163746976653A692C616374696F6E3A66756E6374696F6E28742C6E297B72657475726E206F28652C693F7B747970653A2262706D6E3A53756250726F63657373227D3A7B7479';
wwv_flow_imp.g_varchar2_table(42220) := '70653A2262706D6E3A4164486F6353756250726F63657373227D2C7B6175746F526573697A653A21312C6C61796F7574436F6E6E656374696F6E3A21317D297D7D7D7D2C58762E70726F746F747970652E5F6765744E6F6E496E74657272757074696E67';
wwv_flow_imp.g_varchar2_table(42221) := '486561646572456E74726965733D66756E6374696F6E2865297B636F6E737420743D746869732E5F7472616E736C6174652C6E3D28302C792E676574427573696E6573734F626A656374292865292C693D746869732C6F3D4D752865292C733D28302C79';
wwv_flow_imp.g_varchar2_table(42222) := '2E69732928652C2262706D6E3A426F756E646172794576656E7422293F5A763A59762C723D216E5B6F5D3B72657475726E7B22746F67676C652D6E6F6E2D696E74657272757074696E67223A7B696D61676548746D6C3A732C7469746C653A742822546F';
wwv_flow_imp.g_varchar2_table(42223) := '67676C65206E6F6E2D696E74657272757074696E6722292C6163746976653A722C616374696F6E3A66756E6374696F6E28297B692E5F6D6F64656C696E672E75706461746550726F7065727469657328652C7B5B6F5D3A2121727D297D7D7D7D3B636F6E';
wwv_flow_imp.g_varchar2_table(42224) := '7374204A763D7B5F5F646570656E64735F5F3A5B6C632C50672C4D635D2C5F5F696E69745F5F3A5B227265706C6163654D656E7550726F7669646572225D2C7265706C6163654D656E7550726F76696465723A5B2274797065222C58765D7D3B66756E63';
wwv_flow_imp.g_varchar2_table(42225) := '74696F6E20656228652C742C6E2C692C6F2C732C722C612C6C2C632C642C682C75297B653D657C7C7B7D2C692E726567697374657250726F76696465722874686973292C746869732E5F636F6E746578745061643D692C746869732E5F6D6F64656C696E';
wwv_flow_imp.g_varchar2_table(42226) := '673D6F2C746869732E5F656C656D656E74466163746F72793D732C746869732E5F636F6E6E6563743D722C746869732E5F6372656174653D612C746869732E5F706F7075704D656E753D6C2C746869732E5F63616E7661733D632C746869732E5F72756C';
wwv_flow_imp.g_varchar2_table(42227) := '65733D642C746869732E5F7472616E736C6174653D682C746869732E5F6576656E744275733D6E2C746869732E5F617070656E64507265766965773D752C2131213D3D652E6175746F506C616365262628746869732E5F6175746F506C6163653D742E67';
wwv_flow_imp.g_varchar2_table(42228) := '657428226175746F506C616365222C213129292C6E2E6F6E28226372656174652E656E64222C3235302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E73686170653B6966284E722865292626692E69734F70656E287429297B';
wwv_flow_imp.g_varchar2_table(42229) := '766172206E3D692E676574456E74726965732874293B6E2E7265706C61636526266E2E7265706C6163652E616374696F6E2E636C69636B28652C74297D7D29292C6E2E6F6E2822636F6E746578745061642E636C6F7365222C2866756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(42230) := '7B752E636C65616E557028297D29297D66756E6374696F6E20746228652C742C6E297B766172206F3D652E24696E7374616E63654F662874292C733D21312C723D652E6576656E74446566696E6974696F6E737C7C5B5D3B72657475726E28302C692E6A';
wwv_flow_imp.g_varchar2_table(42231) := '4A2928722C2866756E6374696F6E2865297B652E24747970653D3D3D6E262628733D2130297D29292C6F2626737D65622E24696E6A6563743D5B22636F6E6669672E636F6E74657874506164222C22696E6A6563746F72222C226576656E74427573222C';
wwv_flow_imp.g_varchar2_table(42232) := '22636F6E74657874506164222C226D6F64656C696E67222C22656C656D656E74466163746F7279222C22636F6E6E656374222C22637265617465222C22706F7075704D656E75222C2263616E766173222C2272756C6573222C227472616E736C61746522';
wwv_flow_imp.g_varchar2_table(42233) := '2C22617070656E6450726576696577225D2C65622E70726F746F747970652E6765744D756C7469456C656D656E74436F6E74657874506164456E74726965733D66756E6374696F6E2865297B76617220743D746869732E5F6D6F64656C696E672C6E3D7B';
wwv_flow_imp.g_varchar2_table(42234) := '7D3B72657475726E20746869732E5F697344656C657465416C6C6F776564286529262628302C692E6B7029286E2C7B64656C6574653A7B67726F75703A2265646974222C636C6173734E616D653A2262706D6E2D69636F6E2D7472617368222C7469746C';
wwv_flow_imp.g_varchar2_table(42235) := '653A746869732E5F7472616E736C617465282244656C65746522292C616374696F6E3A7B636C69636B3A66756E6374696F6E28652C6E297B742E72656D6F7665456C656D656E7473286E2E736C6963652829297D7D7D7D292C6E7D2C65622E70726F746F';
wwv_flow_imp.g_varchar2_table(42236) := '747970652E5F697344656C657465416C6C6F7765643D66756E6374696F6E2865297B76617220743D746869732E5F72756C65732E616C6C6F7765642822656C656D656E74732E64656C657465222C7B656C656D656E74733A657D293B72657475726E2830';
wwv_flow_imp.g_varchar2_table(42237) := '2C692E6379292874293F28302C692E53692928652C28653D3E742E696E636C7564657328652929293A747D2C65622E70726F746F747970652E676574436F6E74657874506164456E74726965733D66756E6374696F6E2865297B76617220743D74686973';
wwv_flow_imp.g_varchar2_table(42238) := '2E5F636F6E746578745061642C6E3D746869732E5F6D6F64656C696E672C6F3D746869732E5F656C656D656E74466163746F72792C733D746869732E5F636F6E6E6563742C723D746869732E5F6372656174652C613D746869732E5F706F7075704D656E';
wwv_flow_imp.g_varchar2_table(42239) := '752C6C3D746869732E5F6175746F506C6163652C633D746869732E5F7472616E736C6174652C643D746869732E5F617070656E64507265766965772C683D7B7D3B696628226C6162656C223D3D3D652E747970652972657475726E20746869732E5F6973';
wwv_flow_imp.g_varchar2_table(42240) := '44656C657465416C6C6F776564285B655D29262628302C692E6B702928682C6D2829292C683B76617220753D652E627573696E6573734F626A6563743B66756E6374696F6E207028652C74297B732E737461727428652C74297D66756E6374696F6E2067';
wwv_flow_imp.g_varchar2_table(42241) := '28652C74297B6E2E72656D6F7665456C656D656E7473285B745D297D66756E6374696F6E206D28297B72657475726E7B64656C6574653A7B67726F75703A2265646974222C636C6173734E616D653A2262706D6E2D69636F6E2D7472617368222C746974';
wwv_flow_imp.g_varchar2_table(42242) := '6C653A63282244656C65746522292C616374696F6E3A7B636C69636B3A677D7D7D7D66756E6374696F6E206628652C742C6E2C73297B66756E6374696F6E206128742C6E297B76617220613D6F2E63726561746553686170652828302C692E6B7029287B';
wwv_flow_imp.g_varchar2_table(42243) := '747970653A657D2C7329293B722E737461727428742C612C7B736F757263653A6E7D297D76617220633D6C3F66756E6374696F6E28742C6E297B76617220723D6F2E63726561746553686170652828302C692E6B7029287B747970653A657D2C7329293B';
wwv_flow_imp.g_varchar2_table(42244) := '6C2E617070656E64286E2C72297D3A612C683D6C3F66756E6374696F6E28742C6E297B72657475726E20642E637265617465286E2C652C73292C28293D3E7B642E636C65616E557028297D7D3A6E756C6C3B72657475726E7B67726F75703A226D6F6465';
wwv_flow_imp.g_varchar2_table(42245) := '6C222C636C6173734E616D653A742C7469746C653A6E2C616374696F6E3A7B6472616773746172743A612C636C69636B3A632C686F7665723A687D7D7D66756E6374696F6E20762865297B72657475726E2066756E6374696F6E28692C6F297B6E2E7370';
wwv_flow_imp.g_varchar2_table(42246) := '6C69744C616E65286F2C65292C742E6F70656E286F2C2130297D7D69662828302C792E6973416E792928752C5B2262706D6E3A4C616E65222C2262706D6E3A5061727469636970616E74225D29262628302C72732E417629286529297B76617220623D42';
wwv_flow_imp.g_varchar2_table(42247) := '682865293B28302C692E6B702928682C7B226C616E652D696E736572742D61626F7665223A7B67726F75703A226C616E652D696E736572742D61626F7665222C636C6173734E616D653A2262706D6E2D69636F6E2D6C616E652D696E736572742D61626F';
wwv_flow_imp.g_varchar2_table(42248) := '7665222C7469746C653A632822416464206C616E652061626F766522292C616374696F6E3A7B636C69636B3A66756E6374696F6E28652C74297B6E2E6164644C616E6528742C22746F7022297D7D7D7D292C622E6C656E6774683C322626282828302C72';
wwv_flow_imp.g_varchar2_table(42249) := '732E2462292865293F652E6865696768743E3D3132303A652E77696474683E3D31323029262628302C692E6B702928682C7B226C616E652D6469766964652D74776F223A7B67726F75703A226C616E652D646976696465222C636C6173734E616D653A22';
wwv_flow_imp.g_varchar2_table(42250) := '62706D6E2D69636F6E2D6C616E652D6469766964652D74776F222C7469746C653A63282244697669646520696E746F2074776F206C616E657322292C616374696F6E3A7B636C69636B3A762832297D7D7D292C2828302C72732E2462292865293F652E68';
wwv_flow_imp.g_varchar2_table(42251) := '65696768743E3D3138303A652E77696474683E3D31383029262628302C692E6B702928682C7B226C616E652D6469766964652D7468726565223A7B67726F75703A226C616E652D646976696465222C636C6173734E616D653A2262706D6E2D69636F6E2D';
wwv_flow_imp.g_varchar2_table(42252) := '6C616E652D6469766964652D7468726565222C7469746C653A63282244697669646520696E746F207468726565206C616E657322292C616374696F6E3A7B636C69636B3A762833297D7D7D29292C28302C692E6B702928682C7B226C616E652D696E7365';
wwv_flow_imp.g_varchar2_table(42253) := '72742D62656C6F77223A7B67726F75703A226C616E652D696E736572742D62656C6F77222C636C6173734E616D653A2262706D6E2D69636F6E2D6C616E652D696E736572742D62656C6F77222C7469746C653A632822416464206C616E652062656C6F77';
wwv_flow_imp.g_varchar2_table(42254) := '22292C616374696F6E3A7B636C69636B3A66756E6374696F6E28652C74297B6E2E6164644C616E6528742C22626F74746F6D22297D7D7D7D297D72657475726E28302C792E69732928752C2262706D6E3A466C6F774E6F6465222926262828302C792E69';
wwv_flow_imp.g_varchar2_table(42255) := '732928752C2262706D6E3A4576656E7442617365644761746577617922293F28302C692E6B702928682C7B22617070656E642E726563656976652D7461736B223A66282262706D6E3A526563656976655461736B222C2262706D6E2D69636F6E2D726563';
wwv_flow_imp.g_varchar2_table(42256) := '656976652D7461736B222C632822417070656E642072656365697665207461736B2229292C22617070656E642E6D6573736167652D696E7465726D6564696174652D6576656E74223A66282262706D6E3A496E7465726D65646961746543617463684576';
wwv_flow_imp.g_varchar2_table(42257) := '656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D657373616765222C632822417070656E64206D65737361676520696E7465726D656469617465206361746368206576656E7422292C7B6576656E';
wwv_flow_imp.g_varchar2_table(42258) := '74446566696E6974696F6E547970653A2262706D6E3A4D6573736167654576656E74446566696E6974696F6E227D292C22617070656E642E74696D65722D696E7465726D6564696174652D6576656E74223A66282262706D6E3A496E7465726D65646961';
wwv_flow_imp.g_varchar2_table(42259) := '746543617463684576656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D74696D6572222C632822417070656E642074696D657220696E7465726D656469617465206361746368206576656E7422292C';
wwv_flow_imp.g_varchar2_table(42260) := '7B6576656E74446566696E6974696F6E547970653A2262706D6E3A54696D65724576656E74446566696E6974696F6E227D292C22617070656E642E636F6E646974696F6E2D696E7465726D6564696174652D6576656E74223A66282262706D6E3A496E74';
wwv_flow_imp.g_varchar2_table(42261) := '65726D65646961746543617463684576656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6E646974696F6E222C632822417070656E6420636F6E646974696F6E616C20696E7465726D65646961';
wwv_flow_imp.g_varchar2_table(42262) := '7465206361746368206576656E7422292C7B6576656E74446566696E6974696F6E547970653A2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E227D292C22617070656E642E7369676E616C2D696E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(42263) := '652D6576656E74223A66282262706D6E3A496E7465726D65646961746543617463684576656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D7369676E616C222C632822417070656E64207369676E61';
wwv_flow_imp.g_varchar2_table(42264) := '6C20696E7465726D656469617465206361746368206576656E7422292C7B6576656E74446566696E6974696F6E547970653A2262706D6E3A5369676E616C4576656E74446566696E6974696F6E227D297D293A746228752C2262706D6E3A426F756E6461';
wwv_flow_imp.g_varchar2_table(42265) := '72794576656E74222C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22293F28302C692E6B702928682C7B22617070656E642E636F6D70656E736174696F6E2D6163746976697479223A66282262706D6E3A5461736B222C';
wwv_flow_imp.g_varchar2_table(42266) := '2262706D6E2D69636F6E2D7461736B222C632822417070656E6420636F6D70656E736174696F6E20616374697669747922292C7B6973466F72436F6D70656E736174696F6E3A21307D297D293A28302C792E69732928752C2262706D6E3A456E64457665';
wwv_flow_imp.g_varchar2_table(42267) := '6E7422297C7C752E6973466F72436F6D70656E736174696F6E7C7C746228752C2262706D6E3A496E7465726D6564696174655468726F774576656E74222C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E22297C7C28302C72732E513129';
wwv_flow_imp.g_varchar2_table(42268) := '2875297C7C28302C692E6B702928682C7B22617070656E642E656E642D6576656E74223A66282262706D6E3A456E644576656E74222C2262706D6E2D69636F6E2D656E642D6576656E742D6E6F6E65222C632822417070656E6420656E64206576656E74';
wwv_flow_imp.g_varchar2_table(42269) := '2229292C22617070656E642E67617465776179223A66282262706D6E3A4578636C757369766547617465776179222C2262706D6E2D69636F6E2D676174657761792D6E6F6E65222C632822417070656E6420676174657761792229292C22617070656E64';
wwv_flow_imp.g_varchar2_table(42270) := '2E617070656E642D7461736B223A66282262706D6E3A5461736B222C2262706D6E2D69636F6E2D7461736B222C632822417070656E64207461736B2229292C22617070656E642E696E7465726D6564696174652D6576656E74223A66282262706D6E3A49';
wwv_flow_imp.g_varchar2_table(42271) := '6E7465726D6564696174655468726F774576656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E65222C632822417070656E6420696E7465726D6564696174652F626F756E64617279206576656E742229297D';
wwv_flow_imp.g_varchar2_table(42272) := '29292C612E6973456D70747928652C2262706D6E2D7265706C61636522297C7C28302C692E6B702928682C7B7265706C6163653A7B67726F75703A2265646974222C636C6173734E616D653A2262706D6E2D69636F6E2D73637265772D7772656E636822';
wwv_flow_imp.g_varchar2_table(42273) := '2C7469746C653A6328224368616E676520656C656D656E7422292C616374696F6E3A7B636C69636B3A66756E6374696F6E28652C6E297B766172206F3D28302C692E6B70292866756E6374696F6E2865297B766172206E3D742E6765745061642865292E';
wwv_flow_imp.g_varchar2_table(42274) := '68746D6C2E676574426F756E64696E67436C69656E745265637428293B72657475726E7B783A6E2E6C6566742C793A6E2E626F74746F6D2B357D7D286E292C7B637572736F723A7B783A652E782C793A652E797D7D293B612E6F70656E286E2C2262706D';
wwv_flow_imp.g_varchar2_table(42275) := '6E2D7265706C616365222C6F2C7B7469746C653A6328224368616E676520656C656D656E7422292C77696474683A3330302C7365617263683A21307D297D7D7D7D292C28302C792E69732928752C2262706D6E3A53657175656E6365466C6F7722292626';
wwv_flow_imp.g_varchar2_table(42276) := '28302C692E6B702928682C7B22617070656E642E746578742D616E6E6F746174696F6E223A66282262706D6E3A54657874416E6E6F746174696F6E222C2262706D6E2D69636F6E2D746578742D616E6E6F746174696F6E222C6328224164642074657874';
wwv_flow_imp.g_varchar2_table(42277) := '20616E6E6F746174696F6E2229297D292C28302C792E6973416E792928752C5B2262706D6E3A466C6F774E6F6465222C2262706D6E3A496E746572616374696F6E4E6F6465222C2262706D6E3A446174614F626A6563745265666572656E6365222C2262';
wwv_flow_imp.g_varchar2_table(42278) := '706D6E3A4461746153746F72655265666572656E6365225D29262628302C692E6B702928682C7B22617070656E642E746578742D616E6E6F746174696F6E223A66282262706D6E3A54657874416E6E6F746174696F6E222C2262706D6E2D69636F6E2D74';
wwv_flow_imp.g_varchar2_table(42279) := '6578742D616E6E6F746174696F6E222C632822416464207465787420616E6E6F746174696F6E2229292C636F6E6E6563743A7B67726F75703A22636F6E6E656374222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E6E656374696F6E2D6D';
wwv_flow_imp.g_varchar2_table(42280) := '756C7469222C7469746C653A632822436F6E6E65637420746F206F7468657220656C656D656E7422292C616374696F6E3A7B636C69636B3A702C6472616773746172743A707D7D7D292C28302C792E69732928752C2262706D6E3A54657874416E6E6F74';
wwv_flow_imp.g_varchar2_table(42281) := '6174696F6E2229262628302C692E6B702928682C7B636F6E6E6563743A7B67726F75703A22636F6E6E656374222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C7469222C7469746C653A632822436F6E6E6563';
wwv_flow_imp.g_varchar2_table(42282) := '74207573696E67206173736F63696174696F6E22292C616374696F6E3A7B636C69636B3A702C6472616773746172743A707D7D7D292C28302C792E6973416E792928752C5B2262706D6E3A446174614F626A6563745265666572656E6365222C2262706D';
wwv_flow_imp.g_varchar2_table(42283) := '6E3A4461746153746F72655265666572656E6365225D29262628302C692E6B702928682C7B636F6E6E6563743A7B67726F75703A22636F6E6E656374222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C746922';
wwv_flow_imp.g_varchar2_table(42284) := '2C7469746C653A632822436F6E6E656374207573696E67206461746120696E707574206173736F63696174696F6E22292C616374696F6E3A7B636C69636B3A702C6472616773746172743A707D7D7D292C28302C792E69732928752C2262706D6E3A4772';
wwv_flow_imp.g_varchar2_table(42285) := '6F75702229262628302C692E6B702928682C7B22617070656E642E746578742D616E6E6F746174696F6E223A66282262706D6E3A54657874416E6E6F746174696F6E222C2262706D6E2D69636F6E2D746578742D616E6E6F746174696F6E222C63282241';
wwv_flow_imp.g_varchar2_table(42286) := '6464207465787420616E6E6F746174696F6E2229297D292C746869732E5F697344656C657465416C6C6F776564285B655D29262628302C692E6B702928682C6D2829292C687D3B636F6E7374206E623D7B5F5F646570656E64735F5F3A5B75762C4E762C';
wwv_flow_imp.g_varchar2_table(42287) := '42612C24722C4B642C70672C4A765D2C5F5F696E69745F5F3A5B22636F6E7465787450616450726F7669646572225D2C636F6E7465787450616450726F76696465723A5B2274797065222C65625D7D3B7661722069623D7B686F72697A6F6E74616C3A5B';
wwv_flow_imp.g_varchar2_table(42288) := '2278222C227769647468225D2C766572746963616C3A5B2279222C22686569676874225D7D3B66756E6374696F6E206F6228652C74297B746869732E5F6D6F64656C696E673D652C746869732E5F66696C746572733D5B5D2C746869732E726567697374';
wwv_flow_imp.g_varchar2_table(42289) := '657246696C746572282866756E6374696F6E2865297B766172206E3D742E616C6C6F7765642822656C656D656E74732E64697374726962757465222C7B656C656D656E74733A657D293B72657475726E28302C692E637929286E293F6E3A6E3F653A5B5D';
wwv_flow_imp.g_varchar2_table(42290) := '7D29297D6F622E24696E6A6563743D5B226D6F64656C696E67222C2272756C6573225D2C6F622E70726F746F747970652E726567697374657246696C7465723D66756E6374696F6E2865297B6966282266756E6374696F6E22213D747970656F66206529';
wwv_flow_imp.g_varchar2_table(42291) := '7468726F77206E6577204572726F7228227468652066696C7465722068617320746F20626520612066756E6374696F6E22293B746869732E5F66696C746572732E707573682865297D2C6F622E70726F746F747970652E747269676765723D66756E6374';
wwv_flow_imp.g_varchar2_table(42292) := '696F6E28652C74297B766172206E2C692C6F3D746869732E5F6D6F64656C696E673B6966282128652E6C656E6774683C337C7C28746869732E5F7365744F7269656E746174696F6E2874292C693D746869732E5F66696C746572456C656D656E74732865';
wwv_flow_imp.g_varchar2_table(42293) := '292C286E3D746869732E5F63726561746547726F757073286929292E6C656E6774683C3D3229292972657475726E206F2E64697374726962757465456C656D656E7473286E2C746869732E5F617869732C746869732E5F64696D656E73696F6E292C6E7D';
wwv_flow_imp.g_varchar2_table(42294) := '2C6F622E70726F746F747970652E5F66696C746572456C656D656E74733D66756E6374696F6E2865297B76617220743D746869732E5F66696C746572732C6E3D746869732E5F617869732C6F3D746869732E5F64696D656E73696F6E2C733D5B5D2E636F';
wwv_flow_imp.g_varchar2_table(42295) := '6E6361742865293B72657475726E20742E6C656E6774683F2828302C692E6A4A2928742C2866756E6374696F6E2865297B733D6528732C6E2C6F297D29292C73293A657D2C6F622E70726F746F747970652E5F63726561746547726F7570733D66756E63';
wwv_flow_imp.g_varchar2_table(42296) := '74696F6E2865297B76617220743D5B5D2C6E3D746869732C6F3D746869732E5F617869732C733D746869732E5F64696D656E73696F6E3B696628216F297468726F77206E6577204572726F7228276D7573742068617665206120646566696E6564202261';
wwv_flow_imp.g_varchar2_table(42297) := '7869732220616E64202264696D656E73696F6E2227293B76617220723D28302C692E556C2928652C6F293B72657475726E28302C692E6A4A2928722C2866756E6374696F6E28652C69297B76617220722C613D6E2E5F66696E6452616E676528652C6F2C';
wwv_flow_imp.g_varchar2_table(42298) := '73292C6C3D745B742E6C656E6774682D315D3B6C26266E2E5F686173496E74657273656374696F6E286C2E72616E67652C61293F745B742E6C656E6774682D315D2E656C656D656E74732E707573682865293A28723D7B72616E67653A612C656C656D65';
wwv_flow_imp.g_varchar2_table(42299) := '6E74733A5B655D7D2C742E70757368287229297D29292C747D2C6F622E70726F746F747970652E5F7365744F7269656E746174696F6E3D66756E6374696F6E2865297B76617220743D69625B655D3B746869732E5F617869733D745B305D2C746869732E';
wwv_flow_imp.g_varchar2_table(42300) := '5F64696D656E73696F6E3D745B315D7D2C6F622E70726F746F747970652E5F686173496E74657273656374696F6E3D66756E6374696F6E28652C74297B72657475726E204D6174682E6D617828652E6D696E2C652E6D6178293E3D4D6174682E6D696E28';
wwv_flow_imp.g_varchar2_table(42301) := '742E6D696E2C742E6D61782926264D6174682E6D696E28652E6D696E2C652E6D6178293C3D4D6174682E6D617828742E6D696E2C742E6D6178297D2C6F622E70726F746F747970652E5F66696E6452616E67653D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(42302) := '743D655B746869732E5F617869735D3B72657475726E7B6D696E3A742B352C6D61783A742B655B746869732E5F64696D656E73696F6E5D2D357D7D3B636F6E73742073623D7B5F5F696E69745F5F3A5B2264697374726962757465456C656D656E747322';
wwv_flow_imp.g_varchar2_table(42303) := '5D2C64697374726962757465456C656D656E74733A5B2274797065222C6F625D7D3B66756E6374696F6E2072622865297B70632E63616C6C28746869732C65297D72622E24696E6A6563743D5B226576656E74427573225D2C522872622C7063292C7262';
wwv_flow_imp.g_varchar2_table(42304) := '2E70726F746F747970652E696E69743D66756E6374696F6E28297B746869732E61646452756C652822656C656D656E74732E64697374726962757465222C2866756E6374696F6E2865297B76617220743D652E656C656D656E74733B72657475726E2128';
wwv_flow_imp.g_varchar2_table(42305) := '28743D6F7428743D28302C692E70622928742C2866756E6374696F6E2865297B76617220743D28302C792E6973416E792928652C5B2262706D6E3A4173736F63696174696F6E222C2262706D6E3A426F756E646172794576656E74222C2262706D6E3A44';
wwv_flow_imp.g_varchar2_table(42306) := '617461496E7075744173736F63696174696F6E222C2262706D6E3A446174614F75747075744173736F63696174696F6E222C2262706D6E3A4C616E65222C2262706D6E3A4D657373616765466C6F77222C2262706D6E3A53657175656E6365466C6F7722';
wwv_flow_imp.g_varchar2_table(42307) := '2C2262706D6E3A54657874416E6E6F746174696F6E225D293B72657475726E2128652E6C6162656C5461726765747C7C74297D292929292E6C656E6774683C33292626747D29297D3B636F6E73742061623D273C73766720786D6C6E733D22687474703A';
wwv_flow_imp.g_varchar2_table(42308) := '2F2F7777772E77332E6F72672F323030302F737667222076696577426F783D2230203020313830302031383030223E5C6E202020202020202020202020202020203C706F6C796C696E6520706F696E74733D223435302034303020343530203135302031';
wwv_flow_imp.g_varchar2_table(42309) := '3335302031353020313335302034303022207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B7374726F6B652D6C696E656A6F696E3A726F756E643B222F3E5C6E20';
wwv_flow_imp.g_varchar2_table(42310) := '2020202020202020202020202020203C7265637420783D223135302220793D22343530222077696474683D2236303022206865696768743D2231323030222072783D223122207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E';
wwv_flow_imp.g_varchar2_table(42311) := '74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E202020202020202020202020202020203C7265637420783D22313035302220793D22343530222077696474683D2236303022206865696768743D22383030222072';
wwv_flow_imp.g_varchar2_table(42312) := '783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B6F7061636974793A2E353B223E3C2F726563743E5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(42313) := '202020203C2F7376673E272C6C623D273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076696577426F783D2230203020313830302031383030223E5C6E20202020202020202020202020203C706F6C';
wwv_flow_imp.g_varchar2_table(42314) := '796C696E6520706F696E74733D2234303020313335302031353020313335302031353020343530203430302034353022207374796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A31';
wwv_flow_imp.g_varchar2_table(42315) := '30303B7374726F6B652D6C696E656A6F696E3A726F756E643B222F3E5C6E20202020202020202020202020203C7265637420783D223435302220793D22313530222077696474683D223132303022206865696768743D22363030222072783D2231222073';
wwv_flow_imp.g_varchar2_table(42316) := '74796C653D2266696C6C3A6E6F6E653B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B223E3C2F726563743E5C6E20202020202020202020202020203C7265637420783D223435302220793D223130353022';
wwv_flow_imp.g_varchar2_table(42317) := '2077696474683D2238303022206865696768743D22363030222072783D223122207374796C653D2266696C6C3A63757272656E74436F6C6F723B7374726F6B653A63757272656E74436F6C6F723B7374726F6B652D77696474683A3130303B6F70616369';
wwv_flow_imp.g_varchar2_table(42318) := '74793A2E353B223E3C2F726563743E5C6E2020202020202020202020203C2F7376673E273B66756E6374696F6E20636228652C742C6E2C69297B746869732E5F64697374726962757465456C656D656E74733D742C746869732E5F7472616E736C617465';
wwv_flow_imp.g_varchar2_table(42319) := '3D6E2C746869732E5F706F7075704D656E753D652C746869732E5F72756C65733D692C652E726567697374657250726F76696465722822616C69676E2D656C656D656E7473222C3930302C74686973297D63622E24696E6A6563743D5B22706F7075704D';
wwv_flow_imp.g_varchar2_table(42320) := '656E75222C2264697374726962757465456C656D656E7473222C227472616E736C617465222C2272756C6573225D2C63622E70726F746F747970652E676574506F7075704D656E75456E74726965733D66756E6374696F6E2865297B76617220743D7B7D';
wwv_flow_imp.g_varchar2_table(42321) := '3B72657475726E20746869732E5F6973416C6C6F776564286529262628302C692E6B702928742C746869732E5F676574456E7472696573286529292C747D2C63622E70726F746F747970652E5F6973416C6C6F7765643D66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(42322) := '657475726E20746869732E5F72756C65732E616C6C6F7765642822656C656D656E74732E64697374726962757465222C7B656C656D656E74733A657D297D2C63622E70726F746F747970652E5F676574456E74726965733D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(42323) := '76617220743D746869732E5F64697374726962757465456C656D656E74732C6E3D746869732E5F7472616E736C6174652C693D746869732E5F706F7075704D656E753B72657475726E7B22646973747269627574652D656C656D656E74732D686F72697A';
wwv_flow_imp.g_varchar2_table(42324) := '6F6E74616C223A7B67726F75703A2264697374726962757465222C7469746C653A6E28224469737472696275746520656C656D656E747320686F72697A6F6E74616C6C7922292C636C6173734E616D653A22626A732D616C69676E2D656C656D656E7473';
wwv_flow_imp.g_varchar2_table(42325) := '2D6D656E752D656E747279222C696D61676548746D6C3A61622C616374696F6E3A66756E6374696F6E286E2C6F297B742E7472696767657228652C22686F72697A6F6E74616C22292C692E636C6F736528297D7D2C22646973747269627574652D656C65';
wwv_flow_imp.g_varchar2_table(42326) := '6D656E74732D766572746963616C223A7B67726F75703A2264697374726962757465222C7469746C653A6E28224469737472696275746520656C656D656E747320766572746963616C6C7922292C696D61676548746D6C3A6C622C616374696F6E3A6675';
wwv_flow_imp.g_varchar2_table(42327) := '6E6374696F6E286E2C6F297B742E7472696767657228652C22766572746963616C22292C692E636C6F736528297D7D7D7D3B636F6E73742064623D7B5F5F646570656E64735F5F3A5B6C632C73625D2C5F5F696E69745F5F3A5B2262706D6E4469737472';
wwv_flow_imp.g_varchar2_table(42328) := '6962757465456C656D656E7473222C2264697374726962757465456C656D656E74734D656E7550726F7669646572225D2C62706D6E44697374726962757465456C656D656E74733A5B2274797065222C72625D2C64697374726962757465456C656D656E';
wwv_flow_imp.g_varchar2_table(42329) := '74734D656E7550726F76696465723A5B2274797065222C63625D7D3B7661722068623D226973206E6F742061207265676973746572656420616374696F6E223B66756E6374696F6E20756228652C74297B746869732E5F616374696F6E733D7B7D3B7661';
wwv_flow_imp.g_varchar2_table(42330) := '72206E3D746869733B652E6F6E28226469616772616D2E696E6974222C2866756E6374696F6E28297B6E2E5F726567697374657244656661756C74416374696F6E732874292C652E666972652822656469746F72416374696F6E732E696E6974222C7B65';
wwv_flow_imp.g_varchar2_table(42331) := '6469746F72416374696F6E733A6E7D297D29297D66756E6374696F6E20706228652C74297B72657475726E206E6577204572726F7228652B2220222B74297D75622E24696E6A6563743D5B226576656E74427573222C22696E6A6563746F72225D2C7562';
wwv_flow_imp.g_varchar2_table(42332) := '2E70726F746F747970652E5F726567697374657244656661756C74416374696F6E733D66756E6374696F6E2865297B76617220743D652E6765742822636F6D6D616E64537461636B222C2131292C6E3D652E67657428226D6F64656C696E67222C213129';
wwv_flow_imp.g_varchar2_table(42333) := '2C6F3D652E676574282273656C656374696F6E222C2131292C733D652E67657428227A6F6F6D5363726F6C6C222C2131292C723D652E6765742822636F70795061737465222C2131292C613D652E676574282263616E766173222C2131292C6C3D652E67';
wwv_flow_imp.g_varchar2_table(42334) := '6574282272756C6573222C2131292C633D652E67657428226B6579626F6172644D6F7665222C2131292C643D652E67657428226B6579626F6172644D6F766553656C656374696F6E222C2131293B74262628746869732E72656769737465722822756E64';
wwv_flow_imp.g_varchar2_table(42335) := '6F222C2866756E6374696F6E28297B742E756E646F28297D29292C746869732E726567697374657228227265646F222C2866756E6374696F6E28297B742E7265646F28297D2929292C7226266F2626746869732E72656769737465722822636F7079222C';
wwv_flow_imp.g_varchar2_table(42336) := '2866756E6374696F6E28297B76617220653D6F2E67657428293B696628652E6C656E6774682972657475726E20722E636F70792865297D29292C722626746869732E726567697374657228227061737465222C2866756E6374696F6E28297B722E706173';
wwv_flow_imp.g_varchar2_table(42337) := '746528297D29292C732626746869732E72656769737465722822737465705A6F6F6D222C2866756E6374696F6E2865297B732E737465705A6F6F6D28652E76616C7565297D29292C612626746869732E726567697374657228227A6F6F6D222C2866756E';
wwv_flow_imp.g_varchar2_table(42338) := '6374696F6E2865297B612E7A6F6F6D28652E76616C7565297D29292C6E26266F26266C2626746869732E7265676973746572282272656D6F766553656C656374696F6E222C2866756E6374696F6E28297B76617220653D6F2E67657428293B696628652E';
wwv_flow_imp.g_varchar2_table(42339) := '6C656E677468297B76617220742C733D6C2E616C6C6F7765642822656C656D656E74732E64656C657465222C7B656C656D656E74733A657D293B2131213D3D73262628743D28302C692E6379292873293F733A65292E6C656E67746826266E2E72656D6F';
wwv_flow_imp.g_varchar2_table(42340) := '7665456C656D656E747328742E736C6963652829297D7D29292C632626746869732E726567697374657228226D6F766543616E766173222C2866756E6374696F6E2865297B632E6D6F766543616E7661732865297D29292C642626746869732E72656769';
wwv_flow_imp.g_varchar2_table(42341) := '7374657228226D6F766553656C656374696F6E222C2866756E6374696F6E2865297B642E6D6F766553656C656374696F6E28652E646972656374696F6E2C652E616363656C657261746564297D29297D2C75622E70726F746F747970652E747269676765';
wwv_flow_imp.g_varchar2_table(42342) := '723D66756E6374696F6E28652C74297B69662821746869732E5F616374696F6E735B655D297468726F7720706228652C6862293B72657475726E20746869732E5F616374696F6E735B655D2874297D2C75622E70726F746F747970652E72656769737465';
wwv_flow_imp.g_varchar2_table(42343) := '723D66756E6374696F6E28652C74297B766172206E3D746869733B69662822737472696E67223D3D747970656F6620652972657475726E20746869732E5F7265676973746572416374696F6E28652C74293B28302C692E6A4A2928652C2866756E637469';
wwv_flow_imp.g_varchar2_table(42344) := '6F6E28652C74297B6E2E5F7265676973746572416374696F6E28742C65297D29297D2C75622E70726F746F747970652E5F7265676973746572416374696F6E3D66756E6374696F6E28652C74297B696628746869732E6973526567697374657265642865';
wwv_flow_imp.g_varchar2_table(42345) := '29297468726F7720706228652C22697320616C7265616479207265676973746572656422293B746869732E5F616374696F6E735B655D3D747D2C75622E70726F746F747970652E756E72656769737465723D66756E6374696F6E2865297B696628217468';
wwv_flow_imp.g_varchar2_table(42346) := '69732E697352656769737465726564286529297468726F7720706228652C6862293B746869732E5F616374696F6E735B655D3D766F696420307D2C75622E70726F746F747970652E676574416374696F6E733D66756E6374696F6E28297B72657475726E';
wwv_flow_imp.g_varchar2_table(42347) := '204F626A6563742E6B65797328746869732E5F616374696F6E73297D2C75622E70726F746F747970652E6973526567697374657265643D66756E6374696F6E2865297B72657475726E2121746869732E5F616374696F6E735B655D7D3B636F6E73742067';
wwv_flow_imp.g_varchar2_table(42348) := '623D7B5F5F696E69745F5F3A5B22656469746F72416374696F6E73225D2C656469746F72416374696F6E733A5B2274797065222C75625D7D3B66756E6374696F6E206D622865297B652E696E766F6B652875622C74686973297D52286D622C7562292C6D';
wwv_flow_imp.g_varchar2_table(42349) := '622E24696E6A6563743D5B22696E6A6563746F72225D2C6D622E70726F746F747970652E5F726567697374657244656661756C74416374696F6E733D66756E6374696F6E2865297B75622E70726F746F747970652E5F726567697374657244656661756C';
wwv_flow_imp.g_varchar2_table(42350) := '74416374696F6E732E63616C6C28746869732C65293B76617220743D652E676574282263616E766173222C2131292C6E3D652E6765742822656C656D656E745265676973747279222C2131292C6F3D652E676574282273656C656374696F6E222C213129';
wwv_flow_imp.g_varchar2_table(42351) := '2C733D652E67657428227370616365546F6F6C222C2131292C723D652E67657428226C6173736F546F6F6C222C2131292C613D652E676574282268616E64546F6F6C222C2131292C6C3D652E6765742822676C6F62616C436F6E6E656374222C2131292C';
wwv_flow_imp.g_varchar2_table(42352) := '633D652E676574282264697374726962757465456C656D656E7473222C2131292C643D652E6765742822616C69676E456C656D656E7473222C2131292C683D652E676574282264697265637445646974696E67222C2131292C753D652E67657428227365';
wwv_flow_imp.g_varchar2_table(42353) := '61726368506164222C2131292C703D652E67657428226D6F64656C696E67222C2131292C673D652E6765742822636F6E74657874506164222C2131293B7426266E26266F2626746869732E5F7265676973746572416374696F6E282273656C656374456C';
wwv_flow_imp.g_varchar2_table(42354) := '656D656E7473222C2866756E6374696F6E28297B76617220653D742E676574526F6F74456C656D656E7428292C693D6E2E66696C746572282866756E6374696F6E2874297B72657475726E2074213D3D657D29293B72657475726E206F2E73656C656374';
wwv_flow_imp.g_varchar2_table(42355) := '2869292C697D29292C732626746869732E5F7265676973746572416374696F6E28227370616365546F6F6C222C2866756E6374696F6E28297B732E746F67676C6528297D29292C722626746869732E5F7265676973746572416374696F6E28226C617373';
wwv_flow_imp.g_varchar2_table(42356) := '6F546F6F6C222C2866756E6374696F6E28297B722E746F67676C6528297D29292C612626746869732E5F7265676973746572416374696F6E282268616E64546F6F6C222C2866756E6374696F6E28297B612E746F67676C6528297D29292C6C2626746869';
wwv_flow_imp.g_varchar2_table(42357) := '732E5F7265676973746572416374696F6E2822676C6F62616C436F6E6E656374546F6F6C222C2866756E6374696F6E28297B6C2E746F67676C6528297D29292C6F2626632626746869732E5F7265676973746572416374696F6E28226469737472696275';
wwv_flow_imp.g_varchar2_table(42358) := '7465456C656D656E7473222C2866756E6374696F6E2865297B76617220743D6F2E67657428292C6E3D652E747970653B742E6C656E6774682626632E7472696767657228742C6E297D29292C6F2626642626746869732E5F726567697374657241637469';
wwv_flow_imp.g_varchar2_table(42359) := '6F6E2822616C69676E456C656D656E7473222C2866756E6374696F6E2865297B76617220743D6F2E67657428292C6E3D5B5D2C733D652E747970653B742E6C656E6774682626286E3D28302C692E70622928742C2866756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(42360) := '75726E2128302C792E69732928652C2262706D6E3A4C616E6522297D29292C642E74726967676572286E2C7329297D29292C6F2626702626746869732E5F7265676973746572416374696F6E2822736574436F6C6F72222C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(42361) := '7B76617220743D6F2E67657428293B742E6C656E6774682626702E736574436F6C6F7228742C65297D29292C6F2626682626746869732E5F7265676973746572416374696F6E282264697265637445646974696E67222C2866756E6374696F6E28297B76';
wwv_flow_imp.g_varchar2_table(42362) := '617220653D6F2E67657428293B652E6C656E6774682626682E616374697661746528655B305D297D29292C752626746869732E5F7265676973746572416374696F6E282266696E64222C2866756E6374696F6E28297B752E746F67676C6528297D29292C';
wwv_flow_imp.g_varchar2_table(42363) := '742626702626746869732E5F7265676973746572416374696F6E28226D6F7665546F4F726967696E222C2866756E6374696F6E28297B76617220652C692C6F3D742E676574526F6F74456C656D656E7428293B653D637428693D28302C792E697329286F';
wwv_flow_imp.g_varchar2_table(42364) := '2C2262706D6E3A436F6C6C61626F726174696F6E22293F6E2E66696C746572282866756E6374696F6E2865297B72657475726E28302C792E69732928652E706172656E742C2262706D6E3A436F6C6C61626F726174696F6E22297D29293A6E2E66696C74';
wwv_flow_imp.g_varchar2_table(42365) := '6572282866756E6374696F6E2865297B72657475726E2065213D3D6F26262128302C792E69732928652E706172656E742C2262706D6E3A53756250726F6365737322297D2929292C702E6D6F7665456C656D656E747328692C7B783A2D652E782C793A2D';
wwv_flow_imp.g_varchar2_table(42366) := '652E797D2C6F297D29292C6F2626672626746869732E5F7265676973746572416374696F6E28227265706C616365456C656D656E74222C2866756E6374696F6E2865297B672E74726967676572456E74727928227265706C616365222C22636C69636B22';
wwv_flow_imp.g_varchar2_table(42367) := '2C65297D29297D3B636F6E73742066623D7B5F5F646570656E64735F5F3A5B67625D2C656469746F72416374696F6E733A5B2274797065222C6D625D7D3B66756E6374696F6E2076622865297B652E6F6E285B226372656174652E696E6974222C227368';
wwv_flow_imp.g_varchar2_table(42368) := '6170652E6D6F76652E696E6974225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D652E73686170653B28302C792E6973416E7929286E2C5B2262706D6E3A5061727469636970616E74222C2262706D6E3A5375625072';
wwv_flow_imp.g_varchar2_table(42369) := '6F63657373222C2262706D6E3A54657874416E6E6F746174696F6E225D29262628742E67726964536E617070696E67436F6E746578747C7C28742E67726964536E617070696E67436F6E746578743D7B7D292C742E67726964536E617070696E67436F6E';
wwv_flow_imp.g_varchar2_table(42370) := '746578742E736E61704C6F636174696F6E3D22746F702D6C65667422297D29297D66756E6374696F6E20626228652C742C6E297B72657475726E206E7C7C286E3D22726F756E6422292C4D6174685B6E5D28652F74292A747D66756E6374696F6E205F62';
wwv_flow_imp.g_varchar2_table(42371) := '28652C742C6E297B766172206F3D216E7C7C2131213D3D6E2E6163746976653B746869732E5F6576656E744275733D743B76617220733D746869733B742E6F6E28226469616772616D2E696E6974222C3830302C2866756E6374696F6E28297B732E7365';
wwv_flow_imp.g_varchar2_table(42372) := '74416374697665286F297D29292C742E6F6E285B226372656174652E6D6F7665222C226372656174652E656E64222C2262656E64706F696E742E6D6F76652E6D6F7665222C2262656E64706F696E742E6D6F76652E656E64222C22636F6E6E6563742E6D';
wwv_flow_imp.g_varchar2_table(42373) := '6F7665222C22636F6E6E6563742E656E64222C22636F6E6E656374696F6E5365676D656E742E6D6F76652E6D6F7665222C22636F6E6E656374696F6E5365676D656E742E6D6F76652E656E64222C22726573697A652E6D6F7665222C22726573697A652E';
wwv_flow_imp.g_varchar2_table(42374) := '656E64222C2273686170652E6D6F76652E6D6F7665222C2273686170652E6D6F76652E656E64225D2C313230302C2866756E6374696F6E2874297B766172206E3D742E6F726967696E616C4576656E743B696628212821732E6163746976657C7C6E2626';
wwv_flow_imp.g_varchar2_table(42375) := '5A72286E2929297B766172206F3D742E636F6E746578742C723D6F2E67726964536E617070696E67436F6E746578743B727C7C28723D6F2E67726964536E617070696E67436F6E746578743D7B7D292C5B2278222C2279225D2E666F7245616368282866';
wwv_flow_imp.g_varchar2_table(42376) := '756E6374696F6E286E297B766172206F3D7B7D2C723D66756E6374696F6E28652C742C6E297B766172206F3D652E636F6E746578742C733D652E73686170652C723D6F2E67726964536E617070696E67436F6E746578742C613D722E736E61704C6F6361';
wwv_flow_imp.g_varchar2_table(42377) := '74696F6E2C6C3D722E736E61704F66667365743B72657475726E206C262628302C692E457429286C5B745D293F6C5B745D3A286C7C7C286C3D722E736E61704F66667365743D7B7D292C28302C692E457429286C5B745D297C7C286C5B745D3D30292C73';
wwv_flow_imp.g_varchar2_table(42378) := '3F286E2E67657428732E6964297C7C2879622874293F6C5B745D2B3D735B745D2B732E77696474682F323A6C5B745D2B3D735B745D2B732E6865696768742F32292C613F282278223D3D3D743F2F6C6566742F2E746573742861293F6C5B745D2D3D732E';
wwv_flow_imp.g_varchar2_table(42379) := '77696474682F323A2F72696768742F2E746573742861292626286C5B745D2B3D732E77696474682F32293A2F746F702F2E746573742861293F6C5B745D2D3D732E6865696768742F323A2F626F74746F6D2F2E746573742861292626286C5B745D2B3D73';
wwv_flow_imp.g_varchar2_table(42380) := '2E6865696768742F32292C6C5B745D293A6C5B745D293A6C5B745D297D28742C6E2C65293B722626286F2E6F66667365743D72293B76617220613D66756E6374696F6E28652C74297B766172206E3D652E636F6E746578742C693D6E2E63726561746543';
wwv_flow_imp.g_varchar2_table(42381) := '6F6E73747261696E74732C6F3D6E2E726573697A65436F6E73747261696E74737C7C7B7D2C733D6E2E67726964536E617070696E67436F6E746578742C723D732E736E6170436F6E73747261696E74733B696628722626725B745D2972657475726E2072';
wwv_flow_imp.g_varchar2_table(42382) := '5B745D3B727C7C28723D732E736E6170436F6E73747261696E74733D7B7D292C725B745D7C7C28725B745D3D7B7D293B76617220613D6E2E646972656374696F6E3B6926262879622874293F28722E782E6D696E3D692E6C6566742C722E782E6D61783D';
wwv_flow_imp.g_varchar2_table(42383) := '692E7269676874293A28722E792E6D696E3D692E746F702C722E792E6D61783D692E626F74746F6D29293B766172206C3D6F2E6D696E2C633D6F2E6D61783B72657475726E206C26262879622874293F43622861293F722E782E6D61783D6C2E6C656674';
wwv_flow_imp.g_varchar2_table(42384) := '3A722E782E6D696E3D6C2E72696768743A77622861293F722E792E6D61783D6C2E746F703A722E792E6D696E3D6C2E626F74746F6D292C6326262879622874293F43622861293F722E782E6D696E3D632E6C6566743A722E782E6D61783D632E72696768';
wwv_flow_imp.g_varchar2_table(42385) := '743A77622861293F722E792E6D696E3D632E746F703A722E792E6D61783D632E626F74746F6D292C725B745D7D28742C6E293B61262628302C692E6B7029286F2C61292C4F6428742C6E297C7C732E736E61704576656E7428742C6E2C6F297D29297D7D';
wwv_flow_imp.g_varchar2_table(42386) := '29297D66756E6374696F6E2079622865297B72657475726E2278223D3D3D657D66756E6374696F6E2077622865297B72657475726E2D31213D3D652E696E6465784F6628226E22297D66756E6374696F6E2043622865297B72657475726E2D31213D3D65';
wwv_flow_imp.g_varchar2_table(42387) := '2E696E6465784F6628227722297D66756E6374696F6E20536228652C74297B65722E63616C6C28746869732C65292C746869732E5F67726964536E617070696E673D743B766172206E3D746869733B746869732E70726545786563757465282273686170';
wwv_flow_imp.g_varchar2_table(42388) := '652E726573697A65222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6F3D28742E68696E74737C7C7B7D292E6175746F526573697A653B6966286F297B76617220733D742E73686170652C723D742E6E6577426F756E64733B';
wwv_flow_imp.g_varchar2_table(42389) := '28302C692E4B6729286F293F742E6E6577426F756E64733D6E2E736E6170436F6D706C657828722C6F293A742E6E6577426F756E64733D6E2E736E617053696D706C6528732C72297D7D29297D66756E6374696F6E20786228652C74297B652E6F6E285B';
wwv_flow_imp.g_varchar2_table(42390) := '227370616365546F6F6C2E6D6F7665222C227370616365546F6F6C2E656E64225D2C3265332C2866756E6374696F6E2865297B766172206E2C693D652E636F6E746578743B692E696E697469616C697A65642626282278223D3D3D692E617869733F286E';
wwv_flow_imp.g_varchar2_table(42391) := '3D742E736E617056616C756528652E6478292C652E783D652E782B6E2D652E64782C652E64783D6E293A286E3D742E736E617056616C756528652E6479292C652E793D652E792B6E2D652E64792C652E64793D6E29297D29297D76622E24696E6A656374';
wwv_flow_imp.g_varchar2_table(42392) := '3D5B226576656E74427573225D2C5F622E70726F746F747970652E736E61704576656E743D66756E6374696F6E28652C742C6E297B526428652C742C746869732E736E617056616C756528655B745D2C6E29297D2C5F622E70726F746F747970652E6765';
wwv_flow_imp.g_varchar2_table(42393) := '744772696453706163696E673D66756E6374696F6E28297B72657475726E2031307D2C5F622E70726F746F747970652E736E617056616C75653D66756E6374696F6E28652C74297B766172206E2C6F2C733D303B72657475726E20742626742E6F666673';
wwv_flow_imp.g_varchar2_table(42394) := '6574262628733D742E6F6666736574292C653D626228652B3D732C3130292C742626742E6D696E2626286E3D742E6D696E2C28302C692E457429286E292626286E3D6262286E2B732C31302C226365696C22292C653D4D6174682E6D617828652C6E2929';
wwv_flow_imp.g_varchar2_table(42395) := '292C742626742E6D61782626286F3D742E6D61782C28302C692E457429286F292626286F3D6262286F2B732C31302C22666C6F6F7222292C653D4D6174682E6D696E28652C6F2929292C652D737D2C5F622E70726F746F747970652E6973416374697665';
wwv_flow_imp.g_varchar2_table(42396) := '3D66756E6374696F6E28297B72657475726E20746869732E6163746976657D2C5F622E70726F746F747970652E7365744163746976653D66756E6374696F6E2865297B746869732E6163746976653D652C746869732E5F6576656E744275732E66697265';
wwv_flow_imp.g_varchar2_table(42397) := '282267726964536E617070696E672E746F67676C65222C7B6163746976653A657D297D2C5F622E70726F746F747970652E746F67676C654163746976653D66756E6374696F6E28297B746869732E7365744163746976652821746869732E616374697665';
wwv_flow_imp.g_varchar2_table(42398) := '297D2C5F622E24696E6A6563743D5B22656C656D656E745265676973747279222C226576656E74427573222C22636F6E6669672E67726964536E617070696E67225D2C53622E24696E6A6563743D5B226576656E74427573222C2267726964536E617070';
wwv_flow_imp.g_varchar2_table(42399) := '696E67222C226D6F64656C696E67225D2C522853622C6572292C53622E70726F746F747970652E736E617053696D706C653D66756E6374696F6E28652C74297B766172206E3D746869732E5F67726964536E617070696E673B72657475726E20742E7769';
wwv_flow_imp.g_varchar2_table(42400) := '6474683D6E2E736E617056616C756528742E77696474682C7B6D696E3A742E77696474687D292C742E6865696768743D6E2E736E617056616C756528742E6865696768742C7B6D696E3A742E6865696768747D292C742E783D652E782B652E7769647468';
wwv_flow_imp.g_varchar2_table(42401) := '2F322D742E77696474682F322C742E793D652E792B652E6865696768742F322D742E6865696768742F322C747D2C53622E70726F746F747970652E736E6170436F6D706C65783D66756E6374696F6E28652C74297B72657475726E2F777C652F2E746573';
wwv_flow_imp.g_varchar2_table(42402) := '74287429262628653D746869732E736E6170486F72697A6F6E74616C6C7928652C7429292C2F6E7C732F2E74657374287429262628653D746869732E736E6170566572746963616C6C7928652C7429292C657D2C53622E70726F746F747970652E736E61';
wwv_flow_imp.g_varchar2_table(42403) := '70486F72697A6F6E74616C6C793D66756E6374696F6E28652C74297B766172206E3D746869732E5F67726964536E617070696E672C6F3D2F772F2E746573742874292C733D2F652F2E746573742874292C723D7B7D3B72657475726E20722E7769647468';
wwv_flow_imp.g_varchar2_table(42404) := '3D6E2E736E617056616C756528652E77696474682C7B6D696E3A652E77696474687D292C732626286F3F28722E783D6E2E736E617056616C756528652E782C7B6D61783A652E787D292C722E77696474682B3D6E2E736E617056616C756528652E782D72';
wwv_flow_imp.g_varchar2_table(42405) := '2E782C7B6D696E3A652E782D722E787D29293A652E783D652E782B652E77696474682D722E7769647468292C28302C692E6B702928652C72292C657D2C53622E70726F746F747970652E736E6170566572746963616C6C793D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(42406) := '74297B766172206E3D746869732E5F67726964536E617070696E672C6F3D2F6E2F2E746573742874292C733D2F732F2E746573742874292C723D7B7D3B72657475726E20722E6865696768743D6E2E736E617056616C756528652E6865696768742C7B6D';
wwv_flow_imp.g_varchar2_table(42407) := '696E3A652E6865696768747D292C6F262628733F28722E793D6E2E736E617056616C756528652E792C7B6D61783A652E797D292C722E6865696768742B3D6E2E736E617056616C756528652E792D722E792C7B6D696E3A652E792D722E797D29293A652E';
wwv_flow_imp.g_varchar2_table(42408) := '793D652E792B652E6865696768742D722E686569676874292C28302C692E6B702928652C72292C657D2C78622E24696E6A6563743D5B226576656E74427573222C2267726964536E617070696E67225D3B636F6E7374206B623D7B5F5F646570656E6473';
wwv_flow_imp.g_varchar2_table(42409) := '5F5F3A5B7B5F5F696E69745F5F3A5B2267726964536E617070696E67526573697A654265686176696F72222C2267726964536E617070696E675370616365546F6F6C4265686176696F72225D2C67726964536E617070696E67526573697A654265686176';
wwv_flow_imp.g_varchar2_table(42410) := '696F723A5B2274797065222C53625D2C67726964536E617070696E675370616365546F6F6C4265686176696F723A5B2274797065222C78625D7D5D2C5F5F696E69745F5F3A5B2267726964536E617070696E67225D2C67726964536E617070696E673A5B';
wwv_flow_imp.g_varchar2_table(42411) := '2274797065222C5F625D7D3B66756E6374696F6E20456228652C74297B652E6F6E28226175746F506C616365222C3265332C2866756E6374696F6E2865297B766172206E3D652E736F757263652C693D486E286E292C6F3D652E73686170652C733D4463';
wwv_flow_imp.g_varchar2_table(42412) := '286E2C6F293B72657475726E5B2278222C2279225D2E666F7245616368282866756E6374696F6E2865297B766172206E3D7B7D3B735B655D213D3D695B655D262628735B655D3E695B655D3F6E2E6D696E3D735B655D3A6E2E6D61783D735B655D2C2830';
wwv_flow_imp.g_varchar2_table(42413) := '2C792E697329286F2C2262706D6E3A54657874416E6E6F746174696F6E222926262866756E6374696F6E2865297B72657475726E2278223D3D3D657D2865293F6E2E6F66667365743D2D6F2E77696474682F323A6E2E6F66667365743D2D6F2E68656967';
wwv_flow_imp.g_varchar2_table(42414) := '68742F32292C735B655D3D742E736E617056616C756528735B655D2C6E29297D29292C737D29297D66756E6374696F6E204C6228652C742C6E297B742E6F6E285B226372656174652E7374617274222C2273686170652E6D6F76652E7374617274225D2C';
wwv_flow_imp.g_varchar2_table(42415) := '313735302C2866756E6374696F6E2874297B76617220693D742E636F6E746578742C6F3D692E73686170652C733D652E676574526F6F74456C656D656E7428293B28302C792E697329286F2C2262706D6E3A5061727469636970616E742229262628302C';
wwv_flow_imp.g_varchar2_table(42416) := '792E69732928732C2262706D6E3A50726F6365737322292626732E6368696C6472656E2E6C656E6774682626692E637265617465436F6E73747261696E74732626286F2E77696474683D6E2E736E617056616C7565286F2E77696474682C7B6D696E3A6F';
wwv_flow_imp.g_varchar2_table(42417) := '2E77696474687D292C6F2E6865696768743D6E2E736E617056616C7565286F2E6865696768742C7B6D696E3A6F2E6865696768747D29297D29297D66756E6374696F6E20446228652C742C6E297B65722E63616C6C28746869732C65292C746869732E5F';
wwv_flow_imp.g_varchar2_table(42418) := '67726964536E617070696E673D743B76617220693D746869733B746869732E706F73744578656375746564285B22636F6E6E656374696F6E2E637265617465222C22636F6E6E656374696F6E2E6C61796F7574225D2C3365332C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(42419) := '65297B76617220743D652E636F6E746578742C6F3D742E636F6E6E656374696F6E2C733D742E68696E74737C7C7B7D2C723D6F2E776179706F696E74733B732E636F6E6E656374696F6E53746172747C7C732E636F6E6E656374696F6E456E647C7C2131';
wwv_flow_imp.g_varchar2_table(42420) := '3D3D3D732E637265617465456C656D656E74734265686176696F727C7C66756E6374696F6E2865297B72657475726E20652E6C656E6774683E337D28722926266E2E757064617465576179706F696E7473286F2C692E736E61704D6964646C655365676D';
wwv_flow_imp.g_varchar2_table(42421) := '656E7473287229297D29297D66756E6374696F6E20546228652C742C6E297B766172206F3D587428742C6E292C733D7B7D3B72657475726E2066756E6374696F6E2865297B72657475726E2268223D3D3D657D286F29262628732E793D652E736E617056';
wwv_flow_imp.g_varchar2_table(42422) := '616C756528742E7929292C66756E6374696F6E2865297B72657475726E2276223D3D3D657D286F29262628732E783D652E736E617056616C756528742E7829292C28227822696E20737C7C227922696E207329262628743D28302C692E6B7029287B7D2C';
wwv_flow_imp.g_varchar2_table(42423) := '742C73292C6E3D28302C692E6B7029287B7D2C6E2C7329292C5B742C6E5D7D45622E24696E6A6563743D5B226576656E74427573222C2267726964536E617070696E67225D2C4C622E24696E6A6563743D5B2263616E766173222C226576656E74427573';
wwv_flow_imp.g_varchar2_table(42424) := '222C2267726964536E617070696E67225D2C44622E24696E6A6563743D5B226576656E74427573222C2267726964536E617070696E67222C226D6F64656C696E67225D2C522844622C6572292C44622E70726F746F747970652E736E61704D6964646C65';
wwv_flow_imp.g_varchar2_table(42425) := '5365676D656E74733D66756E6374696F6E2865297B76617220742C6E3D746869732E5F67726964536E617070696E673B653D652E736C69636528293B666F722876617220693D313B693C652E6C656E6774682D323B692B2B29743D5462286E2C655B695D';
wwv_flow_imp.g_varchar2_table(42426) := '2C655B692B315D292C655B695D3D745B305D2C655B692B315D3D745B315D3B72657475726E20657D3B636F6E73742049623D7B5F5F646570656E64735F5F3A5B6B622C7B5F5F696E69745F5F3A5B2267726964536E617070696E674175746F506C616365';
wwv_flow_imp.g_varchar2_table(42427) := '4265686176696F72222C2267726964536E617070696E675061727469636970616E744265686176696F72222C2267726964536E617070696E674C61796F7574436F6E6E656374696F6E4265686176696F72225D2C67726964536E617070696E674175746F';
wwv_flow_imp.g_varchar2_table(42428) := '506C6163654265686176696F723A5B2274797065222C45625D2C67726964536E617070696E675061727469636970616E744265686176696F723A5B2274797065222C4C625D2C67726964536E617070696E674C61796F7574436F6E6E656374696F6E4265';
wwv_flow_imp.g_varchar2_table(42429) := '686176696F723A5B2274797065222C44625D7D5D2C5F5F696E69745F5F3A5B2262706D6E47726964536E617070696E67225D2C62706D6E47726964536E617070696E673A5B2274797065222C76625D7D3B66756E6374696F6E204D6228652C74297B7468';
wwv_flow_imp.g_varchar2_table(42430) := '69732E5F696E746572616374696F6E4576656E74733D743B766172206E3D746869733B652E6F6E285B22696E746572616374696F6E4576656E74732E637265617465486974222C22696E746572616374696F6E4576656E74732E75706461746548697422';
wwv_flow_imp.g_varchar2_table(42431) := '5D2C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C693D652E6766783B72657475726E28302C792E69732928742C2262706D6E3A4C616E6522293F6E2E5F6372656174655061727469636970616E7448697428742C69293A2830';
wwv_flow_imp.g_varchar2_table(42432) := '2C792E69732928742C2262706D6E3A5061727469636970616E7422293F28302C72732E4176292874293F6E2E5F6372656174655061727469636970616E7448697428742C69293A6E2E5F63726561746544656661756C7448697428742C69293A28302C79';
wwv_flow_imp.g_varchar2_table(42433) := '2E69732928742C2262706D6E3A53756250726F6365737322293F28302C72732E4176292874293F6E2E5F63726561746553756250726F6365737348697428742C69293A6E2E5F63726561746544656661756C7448697428742C69293A766F696420307D29';
wwv_flow_imp.g_varchar2_table(42434) := '297D4D622E24696E6A6563743D5B226576656E74427573222C22696E746572616374696F6E4576656E7473225D2C4D622E70726F746F747970652E5F63726561746544656661756C744869743D66756E6374696F6E28652C74297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(42435) := '69732E5F696E746572616374696F6E4576656E74732E72656D6F7665486974732874292C746869732E5F696E746572616374696F6E4576656E74732E63726561746544656661756C7448697428652C74292C21307D2C4D622E70726F746F747970652E5F';
wwv_flow_imp.g_varchar2_table(42436) := '6372656174655061727469636970616E744869743D66756E6374696F6E28652C74297B746869732E5F696E746572616374696F6E4576656E74732E72656D6F7665486974732874292C746869732E5F696E746572616374696F6E4576656E74732E637265';
wwv_flow_imp.g_varchar2_table(42437) := '617465426F7848697428742C226E6F2D6D6F7665222C7B77696474683A652E77696474682C6865696768743A652E6865696768747D292C746869732E5F696E746572616374696F6E4576656E74732E637265617465426F7848697428742C22636C69636B';
wwv_flow_imp.g_varchar2_table(42438) := '2D7374726F6B65222C7B77696474683A652E77696474682C6865696768743A652E6865696768747D293B766172206E3D28302C72732E2462292865293F7B77696474683A33302C6865696768743A652E6865696768747D3A7B77696474683A652E776964';
wwv_flow_imp.g_varchar2_table(42439) := '74682C6865696768743A33307D3B72657475726E20746869732E5F696E746572616374696F6E4576656E74732E637265617465426F7848697428742C22616C6C222C6E292C21307D2C4D622E70726F746F747970652E5F63726561746553756250726F63';
wwv_flow_imp.g_varchar2_table(42440) := '6573734869743D66756E6374696F6E28652C74297B72657475726E20746869732E5F696E746572616374696F6E4576656E74732E72656D6F7665486974732874292C746869732E5F696E746572616374696F6E4576656E74732E637265617465426F7848';
wwv_flow_imp.g_varchar2_table(42441) := '697428742C226E6F2D6D6F7665222C7B77696474683A652E77696474682C6865696768743A652E6865696768747D292C746869732E5F696E746572616374696F6E4576656E74732E637265617465426F7848697428742C22636C69636B2D7374726F6B65';
wwv_flow_imp.g_varchar2_table(42442) := '222C7B77696474683A652E77696474682C6865696768743A652E6865696768747D292C746869732E5F696E746572616374696F6E4576656E74732E637265617465426F7848697428742C22616C6C222C7B77696474683A652E77696474682C6865696768';
wwv_flow_imp.g_varchar2_table(42443) := '743A33307D292C21307D3B636F6E73742041623D7B5F5F696E69745F5F3A5B2262706D6E496E746572616374696F6E4576656E7473225D2C62706D6E496E746572616374696F6E4576656E74733A5B2274797065222C4D625D7D3B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(42444) := '4E622865297B652E696E766F6B652872612C74686973297D52284E622C7261292C4E622E24696E6A6563743D5B22696E6A6563746F72225D2C4E622E70726F746F747970652E726567697374657242696E64696E67733D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(42445) := '7B66756E6374696F6E206E286E2C69297B742E697352656769737465726564286E292626652E6164644C697374656E65722869297D72612E70726F746F747970652E726567697374657242696E64696E67732E63616C6C28746869732C652C74292C6E28';
wwv_flow_imp.g_varchar2_table(42446) := '2273656C656374456C656D656E7473222C2866756E6374696F6E286E297B76617220693D6E2E6B65794576656E743B696628652E69734B6579285B2261222C2241225D2C69292626652E6973436D642869292972657475726E20742E7472696767657228';
wwv_flow_imp.g_varchar2_table(42447) := '2273656C656374456C656D656E747322292C21307D29292C6E282266696E64222C2866756E6374696F6E286E297B76617220693D6E2E6B65794576656E743B696628652E69734B6579285B2266222C2246225D2C69292626652E6973436D642869292972';
wwv_flow_imp.g_varchar2_table(42448) := '657475726E20742E74726967676572282266696E6422292C21307D29292C6E28227370616365546F6F6C222C2866756E6374696F6E286E297B76617220693D6E2E6B65794576656E743B69662821652E6861734D6F646966696572286929297265747572';
wwv_flow_imp.g_varchar2_table(42449) := '6E20652E69734B6579285B2273222C2253225D2C69293F28742E7472696767657228227370616365546F6F6C22292C2130293A766F696420307D29292C6E28226C6173736F546F6F6C222C2866756E6374696F6E286E297B76617220693D6E2E6B657945';
wwv_flow_imp.g_varchar2_table(42450) := '76656E743B69662821652E6861734D6F6469666965722869292972657475726E20652E69734B6579285B226C222C224C225D2C69293F28742E7472696767657228226C6173736F546F6F6C22292C2130293A766F696420307D29292C6E282268616E6454';
wwv_flow_imp.g_varchar2_table(42451) := '6F6F6C222C2866756E6374696F6E286E297B76617220693D6E2E6B65794576656E743B69662821652E6861734D6F6469666965722869292972657475726E20652E69734B6579285B2268222C2248225D2C69293F28742E74726967676572282268616E64';
wwv_flow_imp.g_varchar2_table(42452) := '546F6F6C22292C2130293A766F696420307D29292C6E2822676C6F62616C436F6E6E656374546F6F6C222C2866756E6374696F6E286E297B76617220693D6E2E6B65794576656E743B69662821652E6861734D6F6469666965722869292972657475726E';
wwv_flow_imp.g_varchar2_table(42453) := '20652E69734B6579285B2263222C2243225D2C69293F28742E747269676765722822676C6F62616C436F6E6E656374546F6F6C22292C2130293A766F696420307D29292C6E282264697265637445646974696E67222C2866756E6374696F6E286E297B76';
wwv_flow_imp.g_varchar2_table(42454) := '617220693D6E2E6B65794576656E743B69662821652E6861734D6F6469666965722869292972657475726E20652E69734B6579285B2265222C2245225D2C69293F28742E74726967676572282264697265637445646974696E6722292C2130293A766F69';
wwv_flow_imp.g_varchar2_table(42455) := '6420307D29292C6E28227265706C616365456C656D656E74222C2866756E6374696F6E286E297B76617220693D6E2E6B65794576656E743B69662821652E6861734D6F6469666965722869292972657475726E20652E69734B6579285B2272222C225222';
wwv_flow_imp.g_varchar2_table(42456) := '5D2C69293F28742E7472696767657228227265706C616365456C656D656E74222C69292C2130293A766F696420307D29297D3B636F6E73742050623D7B5F5F646570656E64735F5F3A5B61615D2C5F5F696E69745F5F3A5B226B6579626F61726442696E';
wwv_flow_imp.g_varchar2_table(42457) := '64696E6773225D2C6B6579626F61726442696E64696E67733A5B2274797065222C4E625D7D3B766172204F623D7B6D6F766553706565643A312C6D6F76655370656564416363656C6572617465643A31307D2C52623D226C656674222C46623D22726967';
wwv_flow_imp.g_varchar2_table(42458) := '6874222C42623D22646F776E222C56623D7B4172726F774C6566743A52622C4C6566743A52622C4172726F7755703A227570222C55703A227570222C4172726F7752696768743A46622C52696768743A46622C4172726F77446F776E3A42622C446F776E';
wwv_flow_imp.g_varchar2_table(42459) := '3A42627D2C7A623D7B6C6566743A66756E6374696F6E2865297B72657475726E7B783A2D652C793A307D7D2C75703A66756E6374696F6E2865297B72657475726E7B783A302C793A2D657D7D2C72696768743A66756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(42460) := '6E7B783A652C793A307D7D2C646F776E3A66756E6374696F6E2865297B72657475726E7B783A302C793A657D7D7D3B66756E6374696F6E20486228652C742C6E2C6F2C73297B76617220723D746869733B746869732E5F636F6E6669673D28302C692E6B';
wwv_flow_imp.g_varchar2_table(42461) := '7029287B7D2C4F622C657C7C7B7D292C742E6164644C697374656E657228313530302C2866756E6374696F6E2865297B766172206E3D652E6B65794576656E742C693D56625B6E2E6B65795D3B69662869262621742E6973436D64286E29297B76617220';
wwv_flow_imp.g_varchar2_table(42462) := '6F3D742E69735368696674286E293B72657475726E20722E6D6F766553656C656374696F6E28692C6F292C21307D7D29292C746869732E6D6F766553656C656374696F6E3D66756E6374696F6E28652C74297B76617220693D732E67657428293B696628';
wwv_flow_imp.g_varchar2_table(42463) := '692E6C656E677468297B76617220723D746869732E5F636F6E6669675B743F226D6F76655370656564416363656C657261746564223A226D6F76655370656564225D2C613D7A625B655D2872293B6F2E616C6C6F7765642822656C656D656E74732E6D6F';
wwv_flow_imp.g_varchar2_table(42464) := '7665222C7B7368617065733A697D2926266E2E6D6F7665456C656D656E747328692C61297D7D7D48622E24696E6A6563743D5B22636F6E6669672E6B6579626F6172644D6F766553656C656374696F6E222C226B6579626F617264222C226D6F64656C69';
wwv_flow_imp.g_varchar2_table(42465) := '6E67222C2272756C6573222C2273656C656374696F6E225D3B636F6E73742057623D7B5F5F646570656E64735F5F3A5B61612C24725D2C5F5F696E69745F5F3A5B226B6579626F6172644D6F766553656C656374696F6E225D2C6B6579626F6172644D6F';
wwv_flow_imp.g_varchar2_table(42466) := '766553656C656374696F6E3A5B2274797065222C48625D7D3B66756E6374696F6E206A6228652C742C6E2C69297B746869732E5F6472616767696E673D692C746869732E5F72756C65733D743B766172206F3D746869733B652E6F6E2822726573697A65';
wwv_flow_imp.g_varchar2_table(42467) := '2E7374617274222C2866756E6374696F6E2865297B76617220742C6E2C693B6E3D28743D652E636F6E74657874292E726573697A65436F6E73747261696E74732C693D742E6D696E426F756E64732C766F696420303D3D3D6E262628766F696420303D3D';
wwv_flow_imp.g_varchar2_table(42468) := '3D69262628693D6F2E636F6D707574654D696E526573697A65426F78287429292C742E726573697A65436F6E73747261696E74733D7B6D696E3A566E2869297D297D29292C652E6F6E2822726573697A652E6D6F7665222C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(42469) := '7B76617220743D7B783A652E64782C793A652E64797D3B2166756E6374696F6E28652C74297B766172206E2C693D652E73686170652C733D652E646972656374696F6E2C723D652E726573697A65436F6E73747261696E74733B652E64656C74613D742C';
wwv_flow_imp.g_varchar2_table(42470) := '6E3D66756E6374696F6E28652C742C6E297B76617220693D6E2E782C6F3D6E2E792C733D7B783A652E782C793A652E792C77696474683A652E77696474682C6865696768743A652E6865696768747D3B72657475726E2D31213D3D742E696E6465784F66';
wwv_flow_imp.g_varchar2_table(42471) := '28226E22293F28732E793D652E792B6F2C732E6865696768743D652E6865696768742D6F293A2D31213D3D742E696E6465784F662822732229262628732E6865696768743D652E6865696768742B6F292C2D31213D3D742E696E6465784F662822652229';
wwv_flow_imp.g_varchar2_table(42472) := '3F732E77696474683D652E77696474682B693A2D31213D3D742E696E6465784F662822772229262628732E783D652E782B692C732E77696474683D652E77696474682D69292C737D28692C732C74292C652E6E6577426F756E64733D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(42473) := '28652C74297B69662821742972657475726E20653B766172206E3D566E2865293B72657475726E207A6E287B746F703A49682822746F70222C6E2C74292C72696768743A496828227269676874222C6E2C74292C626F74746F6D3A49682822626F74746F';
wwv_flow_imp.g_varchar2_table(42474) := '6D222C6E2C74292C6C6566743A496828226C656674222C6E2C74297D297D286E2C72292C652E63616E457865637574653D6F2E63616E526573697A652865297D28652E636F6E746578742C74297D29292C652E6F6E2822726573697A652E656E64222C28';
wwv_flow_imp.g_varchar2_table(42475) := '66756E6374696F6E2865297B2166756E6374696F6E2865297B76617220743D652E73686170652C693D652E63616E457865637574652C6F3D652E6E6577426F756E64733B69662869297B6966282166756E6374696F6E28652C74297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(42476) := '2E78213D3D742E787C7C652E79213D3D742E797C7C652E7769647468213D3D742E77696474687C7C652E686569676874213D3D742E6865696768747D28742C6F3D466E286F29292972657475726E3B6E2E726573697A65536861706528742C6F297D7D28';
wwv_flow_imp.g_varchar2_table(42477) := '652E636F6E74657874297D29297D66756E6374696F6E20716228652C74297B766172206E3D486E2865292C693D566E2865292C6F3D7B783A6E2E782C793A6E2E797D3B72657475726E2D31213D3D742E696E6465784F6628226E22293F6F2E793D692E74';
wwv_flow_imp.g_varchar2_table(42478) := '6F703A2D31213D3D742E696E6465784F6628227322292626286F2E793D692E626F74746F6D292C2D31213D3D742E696E6465784F6628226522293F6F2E783D692E72696768743A2D31213D3D742E696E6465784F6628227722292626286F2E783D692E6C';
wwv_flow_imp.g_varchar2_table(42479) := '656674292C6F7D66756E6374696F6E2024622865297B76617220743D22726573697A652D223B72657475726E226E223D3D3D657C7C2273223D3D3D653F742B226E73223A2265223D3D3D657C7C2277223D3D3D653F742B226577223A226E77223D3D3D65';
wwv_flow_imp.g_varchar2_table(42480) := '7C7C227365223D3D3D653F742B226E777365223A742B226E657377227D6A622E70726F746F747970652E63616E526573697A653D66756E6374696F6E2865297B76617220743D746869732E5F72756C65732C6E3D28302C692E55702928652C5B226E6577';
wwv_flow_imp.g_varchar2_table(42481) := '426F756E6473222C227368617065222C2264656C7461222C22646972656374696F6E225D293B72657475726E20742E616C6C6F776564282273686170652E726573697A65222C6E297D2C6A622E70726F746F747970652E61637469766174653D66756E63';
wwv_flow_imp.g_varchar2_table(42482) := '74696F6E28652C742C6E297B766172206F2C732C723D746869732E5F6472616767696E673B69662822737472696E67223D3D747970656F66206E2626286E3D7B646972656374696F6E3A6E7D292C2128733D286F3D28302C692E6B7029287B7368617065';
wwv_flow_imp.g_varchar2_table(42483) := '3A747D2C6E29292E646972656374696F6E29297468726F77206E6577204572726F7228226D7573742070726F76696465206120646972656374696F6E20286E7C777C737C657C6E777C73657C6E657C73772922293B722E696E697428652C716228742C73';
wwv_flow_imp.g_varchar2_table(42484) := '292C22726573697A65222C7B6175746F41637469766174653A21302C637572736F723A24622873292C646174613A7B73686170653A742C636F6E746578743A6F7D7D297D2C6A622E70726F746F747970652E636F6D707574654D696E526573697A65426F';
wwv_flow_imp.g_varchar2_table(42485) := '783D66756E6374696F6E2865297B76617220742C6E2C692C6F2C732C722C612C6C3D652E73686170653B72657475726E20743D652E646972656374696F6E2C6E3D6C2C693D652E6D696E44696D656E73696F6E737C7C7B77696474683A31302C68656967';
wwv_flow_imp.g_varchar2_table(42486) := '68743A31307D2C6F3D4E68286C2C652E6368696C6472656E426F7850616464696E67292C733D566E286E292C723D7B746F703A2F6E2F2E746573742874293F732E626F74746F6D2D692E6865696768743A732E746F702C6C6566743A2F772F2E74657374';
wwv_flow_imp.g_varchar2_table(42487) := '2874293F732E72696768742D692E77696474683A732E6C6566742C626F74746F6D3A2F732F2E746573742874293F732E746F702B692E6865696768743A732E626F74746F6D2C72696768743A2F652F2E746573742874293F732E6C6566742B692E776964';
wwv_flow_imp.g_varchar2_table(42488) := '74683A732E72696768747D2C613D6F3F566E286F293A722C7A6E287B746F703A456828722E746F702C612E746F70292C6C6566743A456828722E6C6566742C612E6C656674292C626F74746F6D3A6B6828722E626F74746F6D2C612E626F74746F6D292C';
wwv_flow_imp.g_varchar2_table(42489) := '72696768743A6B6828722E72696768742C612E7269676874297D297D2C6A622E24696E6A6563743D5B226576656E74427573222C2272756C6573222C226D6F64656C696E67222C226472616767696E67225D3B7661722055623D22646A732D726573697A';
wwv_flow_imp.g_varchar2_table(42490) := '696E67222C4B623D22726573697A652D6E6F742D6F6B223B66756E6374696F6E20476228652C742C6E297B652E6F6E2822726573697A652E6D6F7665222C3530302C2866756E6374696F6E2865297B76617220692C6F2C732C723B6F3D28693D652E636F';
wwv_flow_imp.g_varchar2_table(42491) := '6E74657874292E73686170652C733D692E6E6577426F756E64732C28723D692E6672616D65297C7C28723D692E6672616D653D6E2E6164644672616D65286F2C742E6765744163746976654C617965722829292C742E6164644D61726B6572286F2C5562';
wwv_flow_imp.g_varchar2_table(42492) := '29292C732E77696474683E352626666528722C7B783A732E782C77696474683A732E77696474687D292C732E6865696768743E352626666528722C7B793A732E792C6865696768743A732E6865696768747D292C692E63616E457865637574653F626528';
wwv_flow_imp.g_varchar2_table(42493) := '72292E72656D6F7665284B62293A62652872292E616464284B62297D29292C652E6F6E2822726573697A652E636C65616E7570222C2866756E6374696F6E2865297B766172206E2C693B693D286E3D652E636F6E74657874292E73686170652C6E2E6672';
wwv_flow_imp.g_varchar2_table(42494) := '616D6526265265286E2E6672616D65292C742E72656D6F76654D61726B657228692C5562297D29297D47622E24696E6A6563743D5B226576656E74427573222C2263616E766173222C2270726576696577537570706F7274225D3B7661722051623D2264';
wwv_flow_imp.g_varchar2_table(42495) := '6A732D726573697A6572222C59623D5B226E222C2277222C2273222C2265222C226E77222C226E65222C227365222C227377225D3B66756E6374696F6E205A6228652C742C6E2C6F297B746869732E5F726573697A653D6F2C746869732E5F63616E7661';
wwv_flow_imp.g_varchar2_table(42496) := '733D743B76617220733D746869733B652E6F6E282273656C656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B76617220743D652E6E657753656C656374696F6E3B732E72656D6F7665526573697A65727328292C313D3D3D742E6C';
wwv_flow_imp.g_varchar2_table(42497) := '656E677468262628302C692E6A4A2928742C28302C692E6F492928732E616464526573697A65722C7329297D29292C652E6F6E282273686170652E6368616E676564222C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B6E2E69';
wwv_flow_imp.g_varchar2_table(42498) := '7353656C6563746564287429262628732E72656D6F7665526573697A65727328292C732E616464526573697A6572287429297D29297D5A622E70726F746F747970652E6D616B65447261676761626C653D66756E6374696F6E28652C742C6E297B766172';
wwv_flow_imp.g_varchar2_table(42499) := '20693D746869732E5F726573697A653B66756E6374696F6E206F2874297B41722874292626692E616374697661746528742C652C6E297D4F742E62696E6428742C226D6F757365646F776E222C6F292C4F742E62696E6428742C22746F75636873746172';
wwv_flow_imp.g_varchar2_table(42500) := '74222C6F297D2C5A622E70726F746F747970652E5F637265617465526573697A65723D66756E6374696F6E28652C742C6E2C69297B766172206F3D746869732E5F676574526573697A657273506172656E7428292C733D66756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(42501) := '617220743D7B783A302C793A307D3B72657475726E2D31213D3D652E696E6465784F6628226522293F742E783D363A2D31213D3D652E696E6465784F662822772229262628742E783D2D36292C2D31213D3D652E696E6465784F6628227322293F742E79';
wwv_flow_imp.g_varchar2_table(42502) := '3D363A2D31213D3D652E696E6465784F6628226E2229262628742E793D2D36292C747D2869292C723D6B6528226722293B62652872292E616464285162292C62652872292E6164642851622B222D222B652E6964292C62652872292E6164642851622B22';
wwv_flow_imp.g_varchar2_table(42503) := '2D222B69292C7565286F2C72293B76617220613D6B6528227265637422293B666528612C7B783A2D342B732E782C793A2D342B732E792C77696474683A382C6865696768743A387D292C62652861292E6164642851622B222D76697375616C22292C7565';
wwv_flow_imp.g_varchar2_table(42504) := '28722C61293B766172206C3D6B6528227265637422293B72657475726E206665286C2C7B783A2D31302B732E782C793A2D31302B732E792C77696474683A32302C6865696768743A32307D292C6265286C292E6164642851622B222D68697422292C7565';
wwv_flow_imp.g_varchar2_table(42505) := '28722C6C292C766928722C742C6E292C727D2C5A622E70726F746F747970652E637265617465526573697A65723D66756E6374696F6E28652C74297B766172206E3D716228652C74292C693D746869732E5F637265617465526573697A657228652C6E2E';
wwv_flow_imp.g_varchar2_table(42506) := '782C6E2E792C74293B746869732E6D616B65447261676761626C6528652C692C74297D2C5A622E70726F746F747970652E616464526573697A65723D66756E6374696F6E2865297B76617220743D746869733B214F6E2865292626746869732E5F726573';
wwv_flow_imp.g_varchar2_table(42507) := '697A652E63616E526573697A65287B73686170653A657D29262628302C692E6A4A292859622C2866756E6374696F6E286E297B742E637265617465526573697A657228652C6E297D29297D2C5A622E70726F746F747970652E72656D6F7665526573697A';
wwv_flow_imp.g_varchar2_table(42508) := '6572733D66756E6374696F6E28297B796528746869732E5F676574526573697A657273506172656E742829297D2C5A622E70726F746F747970652E5F676574526573697A657273506172656E743D66756E6374696F6E28297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(42509) := '2E5F63616E7661732E6765744C617965722822726573697A65727322297D2C5A622E24696E6A6563743D5B226576656E74427573222C2263616E766173222C2273656C656374696F6E222C22726573697A65225D3B636F6E73742058623D7B5F5F646570';
wwv_flow_imp.g_varchar2_table(42510) := '656E64735F5F3A5B4B632C6A632C65685D2C5F5F696E69745F5F3A5B22726573697A65222C22726573697A6550726576696577222C22726573697A6548616E646C6573225D2C726573697A653A5B2274797065222C6A625D2C726573697A655072657669';
wwv_flow_imp.g_varchar2_table(42511) := '65773A5B2274797065222C47625D2C726573697A6548616E646C65733A5B2274797065222C5A625D7D3B66756E6374696F6E204A6228652C742C6E2C692C6F2C732C72297B66756E6374696F6E206128652C74297B28747C7C28302C792E6973416E7929';
wwv_flow_imp.g_varchar2_table(42512) := '28652C5B2262706D6E3A5461736B222C2262706D6E3A54657874416E6E6F746174696F6E222C2262706D6E3A5061727469636970616E74225D297C7C655F286529292626692E61637469766174652865297D746869732E5F62706D6E466163746F72793D';
wwv_flow_imp.g_varchar2_table(42513) := '742C746869732E5F63616E7661733D6E2C746869732E5F6D6F64656C696E673D6F2C746869732E5F7465787452656E64657265723D722C692E726567697374657250726F76696465722874686973292C652E6F6E2822656C656D656E742E64626C636C69';
wwv_flow_imp.g_varchar2_table(42514) := '636B222C2866756E6374696F6E2865297B6128652E656C656D656E742C2130297D29292C652E6F6E285B226175746F506C6163652E7374617274222C2263616E7661732E76696577626F782E6368616E67696E67222C22647261672E696E6974222C2265';
wwv_flow_imp.g_varchar2_table(42515) := '6C656D656E742E6D6F757365646F776E222C22706F7075704D656E752E6F70656E222C22726F6F742E736574222C2273656C656374696F6E2E6368616E676564225D2C2866756E6374696F6E28297B692E697341637469766528292626692E636F6D706C';
wwv_flow_imp.g_varchar2_table(42516) := '65746528297D29292C652E6F6E285B2273686170652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C3265332C2866756E6374696F6E2865297B692E697341637469766528652E656C656D656E74292626692E63616E63656C28';
wwv_flow_imp.g_varchar2_table(42517) := '297D29292C652E6F6E285B22636F6D6D616E64537461636B2E6368616E676564225D2C2866756E6374696F6E2865297B692E697341637469766528292626692E63616E63656C28297D29292C652E6F6E282264697265637445646974696E672E61637469';
wwv_flow_imp.g_varchar2_table(42518) := '76617465222C2866756E6374696F6E2865297B732E72656D6F7665526573697A65727328297D29292C652E6F6E28226372656174652E656E64222C3530302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170';
wwv_flow_imp.g_varchar2_table(42519) := '652C693D652E636F6E746578742E63616E457865637574653B652E6973546F7563687C7C69262628742E68696E7473262621313D3D3D742E68696E74732E637265617465456C656D656E74734265686176696F727C7C61286E29297D29292C652E6F6E28';
wwv_flow_imp.g_varchar2_table(42520) := '226175746F506C6163652E656E64222C3530302C2866756E6374696F6E2865297B6128652E7368617065297D29297D66756E6374696F6E20655F2865297B72657475726E28302C792E69732928652C2262706D6E3A53756250726F636573732229262621';
wwv_flow_imp.g_varchar2_table(42521) := '28302C72732E4176292865297D4A622E24696E6A6563743D5B226576656E74427573222C2262706D6E466163746F7279222C2263616E766173222C2264697265637445646974696E67222C226D6F64656C696E67222C22726573697A6548616E646C6573';
wwv_flow_imp.g_varchar2_table(42522) := '222C227465787452656E6465726572225D2C4A622E70726F746F747970652E61637469766174653D66756E6374696F6E2865297B76617220743D70732865293B696628766F69642030213D3D74297B766172206E3D7B746578743A747D2C6F3D74686973';
wwv_flow_imp.g_varchar2_table(42523) := '2E67657445646974696E6742426F782865293B28302C692E6B7029286E2C6F293B76617220733D7B7D2C723D6E2E7374796C657C7C7B7D3B72657475726E28302C692E6B702928722C7B6261636B67726F756E64436F6C6F723A6E756C6C2C626F726465';
wwv_flow_imp.g_varchar2_table(42524) := '723A6E756C6C7D292C2828302C792E6973416E792928652C5B2262706D6E3A5461736B222C2262706D6E3A5061727469636970616E74222C2262706D6E3A4C616E65222C2262706D6E3A43616C6C4163746976697479225D297C7C655F28652929262628';
wwv_flow_imp.g_varchar2_table(42525) := '302C692E6B702928732C7B63656E746572566572746963616C6C793A21307D292C637328652926262828302C692E6B702928732C7B6175746F526573697A653A21307D292C28302C692E6B702928722C7B6261636B67726F756E64436F6C6F723A222366';
wwv_flow_imp.g_varchar2_table(42526) := '6666666666222C626F726465723A2231707820736F6C69642023636363227D29292C28302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E222926262828302C692E6B702928732C7B726573697A61626C653A21302C6175746F52';
wwv_flow_imp.g_varchar2_table(42527) := '6573697A653A21307D292C28302C692E6B702928722C7B6261636B67726F756E64436F6C6F723A2223666666666666222C626F726465723A2231707820736F6C69642023636363227D29292C28302C692E6B7029286E2C7B6F7074696F6E733A732C7374';
wwv_flow_imp.g_varchar2_table(42528) := '796C653A727D292C6E7D7D2C4A622E70726F746F747970652E67657445646974696E6742426F783D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732C6E3D652E6C6162656C7C7C652C6F3D742E6765744162736F6C75746542';
wwv_flow_imp.g_varchar2_table(42529) := '426F78286E292C733D6F2E782B6F2E77696474682F322C723D6F2E792B6F2E6865696768742F322C613D7B783A6F2E782C793A6F2E797D2C6C3D742E7A6F6F6D28292C633D746869732E5F7465787452656E64657265722E67657444656661756C745374';
wwv_flow_imp.g_varchar2_table(42530) := '796C6528292C643D746869732E5F7465787452656E64657265722E67657445787465726E616C5374796C6528292C683D642E666F6E7453697A652A6C2C753D642E6C696E654865696768742C703D632E666F6E7453697A652A6C2C673D632E6C696E6548';
wwv_flow_imp.g_varchar2_table(42531) := '65696768742C6D3D7B666F6E7446616D696C793A746869732E5F7465787452656E64657265722E67657444656661756C745374796C6528292E666F6E7446616D696C792C666F6E745765696768743A746869732E5F7465787452656E64657265722E6765';
wwv_flow_imp.g_varchar2_table(42532) := '7444656661756C745374796C6528292E666F6E745765696768747D3B69662828302C792E69732928652C2262706D6E3A4C616E6522297C7C66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A506172746963697061';
wwv_flow_imp.g_varchar2_table(42533) := '6E742229262628302C72732E4176292865297D286529297B76617220663D28302C72732E2462292865292C763D663F7B77696474683A6F2E6865696768742C6865696768743A33302A6C2C783A6F2E782D6F2E6865696768742F322B31352A6C2C793A72';
wwv_flow_imp.g_varchar2_table(42534) := '2D33302A6C2F327D3A7B77696474683A6F2E77696474682C6865696768743A33302A6C7D3B28302C692E6B702928612C76292C28302C692E6B7029286D2C7B666F6E7453697A653A702B227078222C6C696E654865696768743A672C70616464696E6754';
wwv_flow_imp.g_varchar2_table(42535) := '6F703A372A6C2B227078222C70616464696E67426F74746F6D3A372A6C2B227078222C70616464696E674C6566743A352A6C2B227078222C70616464696E6752696768743A352A6C2B227078222C7472616E73666F726D3A663F22726F74617465282D39';
wwv_flow_imp.g_varchar2_table(42536) := '3064656729223A6E756C6C7D297D69662866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E74222926262128302C72732E4176292865297D286529297B76617220623D28302C72732E2462';
wwv_flow_imp.g_varchar2_table(42537) := '292865292C5F3D623F7B77696474683A6F2E77696474682C6865696768743A6F2E6865696768747D3A7B77696474683A6F2E6865696768742C6865696768743A6F2E77696474682C783A732D6F2E6865696768742F322C793A722D6F2E77696474682F32';
wwv_flow_imp.g_varchar2_table(42538) := '7D3B28302C692E6B702928612C5F292C28302C692E6B7029286D2C7B666F6E7453697A653A702B227078222C6C696E654865696768743A672C70616464696E67546F703A372A6C2B227078222C70616464696E67426F74746F6D3A372A6C2B227078222C';
wwv_flow_imp.g_varchar2_table(42539) := '70616464696E674C6566743A352A6C2B227078222C70616464696E6752696768743A352A6C2B227078222C7472616E73666F726D3A623F6E756C6C3A22726F74617465282D393064656729227D297D2828302C792E6973416E792928652C5B2262706D6E';
wwv_flow_imp.g_varchar2_table(42540) := '3A5461736B222C2262706D6E3A43616C6C4163746976697479225D297C7C655F2865292926262828302C692E6B702928612C7B77696474683A6F2E77696474682C6865696768743A6F2E6865696768747D292C28302C692E6B7029286D2C7B666F6E7453';
wwv_flow_imp.g_varchar2_table(42541) := '697A653A702B227078222C6C696E654865696768743A672C70616464696E67546F703A372A6C2B227078222C70616464696E67426F74746F6D3A372A6C2B227078222C70616464696E674C6566743A352A6C2B227078222C70616464696E675269676874';
wwv_flow_imp.g_varchar2_table(42542) := '3A352A6C2B227078227D29292C66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A53756250726F636573732229262628302C72732E4176292865297D28652926262828302C692E6B702928612C7B77696474683A6F';
wwv_flow_imp.g_varchar2_table(42543) := '2E77696474682C783A6F2E787D292C28302C692E6B7029286D2C7B666F6E7453697A653A702B227078222C6C696E654865696768743A672C70616464696E67546F703A372A6C2B227078222C70616464696E67426F74746F6D3A372A6C2B227078222C70';
wwv_flow_imp.g_varchar2_table(42544) := '616464696E674C6566743A352A6C2B227078222C70616464696E6752696768743A352A6C2B227078227D29293B76617220773D39302A6C2C433D372A6C2C533D342A6C3B6966286E2E6C6162656C54617267657426262828302C692E6B702928612C7B77';
wwv_flow_imp.g_varchar2_table(42545) := '696474683A772C6865696768743A6F2E6865696768742B432B532C783A732D772F322C793A6F2E792D437D292C28302C692E6B7029286D2C7B666F6E7453697A653A682B227078222C6C696E654865696768743A752C70616464696E67546F703A432B22';
wwv_flow_imp.g_varchar2_table(42546) := '7078222C70616464696E67426F74746F6D3A532B227078227D29292C6373286E292626216473286E29262621526E286E29297B76617220783D68732865292C6B3D742E6765744162736F6C75746542426F78287B783A782E782C793A782E792C77696474';
wwv_flow_imp.g_varchar2_table(42547) := '683A302C6865696768743A307D292C453D682B432B533B28302C692E6B702928612C7B77696474683A772C6865696768743A452C783A6B2E782D772F322C793A6B2E792D452F327D292C28302C692E6B7029286D2C7B666F6E7453697A653A682B227078';
wwv_flow_imp.g_varchar2_table(42548) := '222C6C696E654865696768743A752C70616464696E67546F703A432B227078222C70616464696E67426F74746F6D3A532B227078227D297D72657475726E28302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E22292626282830';
wwv_flow_imp.g_varchar2_table(42549) := '2C692E6B702928612C7B77696474683A6F2E77696474682C6865696768743A6F2E6865696768742C6D696E57696474683A33302A6C2C6D696E4865696768743A31302A6C7D292C28302C692E6B7029286D2C7B74657874416C69676E3A226C656674222C';
wwv_flow_imp.g_varchar2_table(42550) := '70616464696E67546F703A352A6C2B227078222C70616464696E67426F74746F6D3A372A6C2B227078222C70616464696E674C6566743A372A6C2B227078222C70616464696E6752696768743A352A6C2B227078222C666F6E7453697A653A702B227078';
wwv_flow_imp.g_varchar2_table(42551) := '222C6C696E654865696768743A677D29292C7B626F756E64733A612C7374796C653A6D7D7D2C4A622E70726F746F747970652E7570646174653D66756E6374696F6E28652C742C6E2C69297B766172206F2C732C723B28302C792E69732928652C226270';
wwv_flow_imp.g_varchar2_table(42552) := '6D6E3A54657874416E6E6F746174696F6E2229262628733D746869732E5F63616E7661732E6765744162736F6C75746542426F782865292C6F3D7B783A652E782C793A652E792C77696474683A652E77696474682F732E77696474682A692E7769647468';
wwv_flow_imp.g_varchar2_table(42553) := '2C6865696768743A652E6865696768742F732E6865696768742A692E6865696768747D292C28723D74292626722E7472696D28297C7C28743D6E756C6C292C746869732E5F6D6F64656C696E672E7570646174654C6162656C28652C742C6F297D3B7661';
wwv_flow_imp.g_varchar2_table(42554) := '7220745F3D22646A732D656C656D656E742D68696464656E222C6E5F3D22646A732D6C6162656C2D68696464656E223B66756E6374696F6E20695F28652C742C6E297B76617220692C6F2C732C723D746869732C613D742E67657444656661756C744C61';
wwv_flow_imp.g_varchar2_table(42555) := '79657228293B652E6F6E282264697265637445646974696E672E6163746976617465222C2866756E6374696F6E2865297B766172206C3D652E6163746976653B696628693D6C2E656C656D656E742E6C6162656C7C7C6C2E656C656D656E742C28302C79';
wwv_flow_imp.g_varchar2_table(42556) := '2E69732928692C2262706D6E3A54657874416E6E6F746174696F6E2229297B6F3D742E6765744162736F6C75746542426F782869292C733D6B6528226722293B76617220633D6E2E6765745363616C6564506174682822544558545F414E4E4F54415449';
wwv_flow_imp.g_varchar2_table(42557) := '4F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A692E77696474682C636F6E7461696E65724865696768743A692E6865696768742C706F736974696F6E3A7B6D783A302C6D79';
wwv_flow_imp.g_varchar2_table(42558) := '3A307D7D292C643D722E706174683D6B6528227061746822293B666528642C7B643A632C7374726F6B6557696474683A322C7374726F6B653A6F5F2869297D292C756528732C64292C756528612C73292C626928732C692E782C692E79297D28302C792E';
wwv_flow_imp.g_varchar2_table(42559) := '69732928692C2262706D6E3A54657874416E6E6F746174696F6E22297C7C692E6C6162656C5461726765743F742E6164644D61726B657228692C745F293A2828302C792E69732928692C2262706D6E3A5461736B22297C7C28302C792E69732928692C22';
wwv_flow_imp.g_varchar2_table(42560) := '62706D6E3A43616C6C416374697669747922297C7C28302C792E69732928692C2262706D6E3A53756250726F6365737322297C7C28302C792E69732928692C2262706D6E3A5061727469636970616E742229292626742E6164644D61726B657228692C6E';
wwv_flow_imp.g_varchar2_table(42561) := '5F297D29292C652E6F6E282264697265637445646974696E672E726573697A65222C2866756E6374696F6E2865297B69662828302C792E69732928692C2262706D6E3A54657874416E6E6F746174696F6E2229297B76617220743D652E6865696768742C';
wwv_flow_imp.g_varchar2_table(42562) := '733D652E64792C613D4D6174682E6D617828692E6865696768742F6F2E6865696768742A28742B73292C30292C6C3D6E2E6765745363616C6564506174682822544558545F414E4E4F544154494F4E222C7B785363616C65466163746F723A312C795363';
wwv_flow_imp.g_varchar2_table(42563) := '616C65466163746F723A312C636F6E7461696E657257696474683A692E77696474682C636F6E7461696E65724865696768743A612C706F736974696F6E3A7B6D783A302C6D793A307D7D293B666528722E706174682C7B643A6C7D297D7D29292C652E6F';
wwv_flow_imp.g_varchar2_table(42564) := '6E285B2264697265637445646974696E672E636F6D706C657465222C2264697265637445646974696E672E63616E63656C225D2C2866756E6374696F6E2865297B766172206E3D652E6163746976653B6E262628742E72656D6F76654D61726B6572286E';
wwv_flow_imp.g_varchar2_table(42565) := '2E656C656D656E742E6C6162656C7C7C6E2E656C656D656E742C745F292C742E72656D6F76654D61726B657228692C6E5F29292C693D766F696420302C6F3D766F696420302C7326262852652873292C733D766F69642030297D29297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(42566) := '6E206F5F28652C74297B72657475726E28302C792E6765744469292865292E67657428227374726F6B6522297C7C747C7C22626C61636B227D695F2E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22706174684D6170225D3B';
wwv_flow_imp.g_varchar2_table(42567) := '636F6E737420735F3D7B5F5F646570656E64735F5F3A5B4A732C58622C4E765D2C5F5F696E69745F5F3A5B226C6162656C45646974696E6750726F7669646572222C226C6162656C45646974696E6750726576696577225D2C6C6162656C45646974696E';
wwv_flow_imp.g_varchar2_table(42568) := '6750726F76696465723A5B2274797065222C4A625D2C6C6162656C45646974696E67507265766965773A5B2274797065222C695F5D7D3B76617220725F3D6E65772024732822747422293B66756E6374696F6E20615F28652C74297B652E7374796C652E';
wwv_flow_imp.g_varchar2_table(42569) := '646973706C61793D21313D3D3D743F226E6F6E65223A22227D766172206C5F3D22646A732D746F6F6C746970222C635F3D222E222B6C5F3B66756E6374696F6E20645F28652C74297B766172206E2C693B746869732E5F6576656E744275733D652C7468';
wwv_flow_imp.g_varchar2_table(42570) := '69732E5F63616E7661733D742C746869732E5F6964733D725F2C746869732E5F746F6F6C74697044656661756C74733D7B73686F773A7B6D696E5A6F6F6D3A2E372C6D61785A6F6F6D3A357D7D2C746869732E5F746F6F6C746970733D7B7D2C74686973';
wwv_flow_imp.g_varchar2_table(42571) := '2E5F746F6F6C746970526F6F743D286E3D742E676574436F6E7461696E657228292C437428693D487428273C64697620636C6173733D22646A732D746F6F6C7469702D636F6E7461696E657222202F3E27292C7B706F736974696F6E3A226162736F6C75';
wwv_flow_imp.g_varchar2_table(42572) := '7465222C77696474683A2230222C6865696768743A2230227D292C6E2E696E736572744265666F726528692C6E2E66697273744368696C64292C69293B766172206F3D746869733B467428746869732E5F746F6F6C746970526F6F742C635F2C226D6F75';
wwv_flow_imp.g_varchar2_table(42573) := '7365646F776E222C2866756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28297D29292C467428746869732E5F746F6F6C746970526F6F742C635F2C226D6F7573656F766572222C2866756E6374696F6E2865297B6F2E7472696767';
wwv_flow_imp.g_varchar2_table(42574) := '657228226D6F7573656F766572222C65297D29292C467428746869732E5F746F6F6C746970526F6F742C635F2C226D6F7573656F7574222C2866756E6374696F6E2865297B6F2E7472696767657228226D6F7573656F7574222C65297D29292C74686973';
wwv_flow_imp.g_varchar2_table(42575) := '2E5F696E697428297D645F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C645F2E70726F746F747970652E6164643D66756E6374696F6E2865297B69662821652E706F736974696F6E297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(42576) := '7228226D75737420737065636966697920746F6F6C74697020706F736974696F6E22293B69662821652E68746D6C297468726F77206E6577204572726F7228226D75737420737065636966697920746F6F6C7469702068746D6C22293B76617220743D74';
wwv_flow_imp.g_varchar2_table(42577) := '6869732E5F6964732E6E65787428293B72657475726E20653D28302C692E6B7029287B7D2C746869732E5F746F6F6C74697044656661756C74732C652C7B69643A747D292C746869732E5F616464546F6F6C7469702865292C652E74696D656F75742626';
wwv_flow_imp.g_varchar2_table(42578) := '746869732E73657454696D656F75742865292C747D2C645F2E70726F746F747970652E747269676765723D66756E6374696F6E28652C74297B766172206E3D742E64656C65676174655461726765747C7C742E7461726765742C693D746869732E676574';
wwv_flow_imp.g_varchar2_table(42579) := '285374286E2C22646174612D746F6F6C7469702D69642229293B69262628226D6F7573656F766572223D3D3D652626692E74696D656F75742626746869732E636C65617254696D656F75742869292C226D6F7573656F7574223D3D3D652626692E74696D';
wwv_flow_imp.g_varchar2_table(42580) := '656F7574262628692E74696D656F75743D3165332C746869732E73657454696D656F757428692929297D2C645F2E70726F746F747970652E6765743D66756E6374696F6E2865297B72657475726E22737472696E6722213D747970656F66206526262865';
wwv_flow_imp.g_varchar2_table(42581) := '3D652E6964292C746869732E5F746F6F6C746970735B655D7D2C645F2E70726F746F747970652E636C65617254696D656F75743D66756E6374696F6E2865297B696628653D746869732E676574286529297B76617220743D652E72656D6F766554696D65';
wwv_flow_imp.g_varchar2_table(42582) := '723B74262628636C65617254696D656F75742874292C652E72656D6F766554696D65723D6E756C6C297D7D2C645F2E70726F746F747970652E73657454696D656F75743D66756E6374696F6E2865297B696628653D746869732E676574286529297B7468';
wwv_flow_imp.g_varchar2_table(42583) := '69732E636C65617254696D656F75742865293B76617220743D746869733B652E72656D6F766554696D65723D73657454696D656F7574282866756E6374696F6E28297B742E72656D6F76652865297D292C652E74696D656F7574297D7D2C645F2E70726F';
wwv_flow_imp.g_varchar2_table(42584) := '746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869732E6765742865293B74262628247428742E68746D6C292C247428742E68746D6C436F6E7461696E6572292C64656C65746520742E68746D6C436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(42585) := '722C64656C65746520746869732E5F746F6F6C746970735B742E69645D297D2C645F2E70726F746F747970652E73686F773D66756E6374696F6E28297B615F28746869732E5F746F6F6C746970526F6F74297D2C645F2E70726F746F747970652E686964';
wwv_flow_imp.g_varchar2_table(42586) := '653D66756E6374696F6E28297B615F28746869732E5F746F6F6C746970526F6F742C2131297D2C645F2E70726F746F747970652E5F757064617465526F6F743D66756E6374696F6E2865297B76617220743D652E7363616C657C7C312C6E3D652E736361';
wwv_flow_imp.g_varchar2_table(42587) := '6C657C7C312C693D226D617472697828222B742B222C302C302C222B6E2B222C222B2D312A652E782A742B222C222B2D312A652E792A6E2B2229223B746869732E5F746F6F6C746970526F6F742E7374796C652E7472616E73666F726D3D692C74686973';
wwv_flow_imp.g_varchar2_table(42588) := '2E5F746F6F6C746970526F6F742E7374796C655B222D6D732D7472616E73666F726D225D3D697D2C645F2E70726F746F747970652E5F616464546F6F6C7469703D66756E6374696F6E2865297B76617220742C6E3D652E69642C6F3D652E68746D6C2C73';
wwv_flow_imp.g_varchar2_table(42589) := '3D746869732E5F746F6F6C746970526F6F743B6F2E67657426266F2E636F6E7374727563746F722E70726F746F747970652E6A71756572792626286F3D6F2E676574283029292C28302C692E4B6729286F292626286F3D4874286F29292C437428743D48';
wwv_flow_imp.g_varchar2_table(42590) := '7428273C64697620646174612D746F6F6C7469702D69643D22272B6E2B272220636C6173733D22272B6C5F2B27223E27292C7B706F736974696F6E3A226162736F6C757465227D292C742E617070656E644368696C64286F292C652E7479706526266B74';
wwv_flow_imp.g_varchar2_table(42591) := '2874292E6164642822646A732D746F6F6C7469702D222B652E74797065292C652E636C6173734E616D6526266B742874292E61646428652E636C6173734E616D65292C652E68746D6C436F6E7461696E65723D742C732E617070656E644368696C642874';
wwv_flow_imp.g_varchar2_table(42592) := '292C746869732E5F746F6F6C746970735B6E5D3D652C746869732E5F757064617465546F6F6C7469702865297D2C645F2E70726F746F747970652E5F757064617465546F6F6C7469703D66756E6374696F6E2865297B76617220743D652E706F73697469';
wwv_flow_imp.g_varchar2_table(42593) := '6F6E3B2166756E6374696F6E28652C742C6E297B437428652C7B6C6566743A742B227078222C746F703A6E2B227078227D297D28652E68746D6C436F6E7461696E65722C742E782C742E79297D2C645F2E70726F746F747970652E5F757064617465546F';
wwv_flow_imp.g_varchar2_table(42594) := '6F6C7469705669736962696C74793D66756E6374696F6E2865297B28302C692E6A4A2928746869732E5F746F6F6C746970732C2866756E6374696F6E2874297B766172206E3D742E73686F772C693D742E68746D6C436F6E7461696E65722C6F3D21303B';
wwv_flow_imp.g_varchar2_table(42595) := '6E262628286E2E6D696E5A6F6F6D3E652E7363616C657C7C6E2E6D61785A6F6F6D3C652E7363616C65292626286F3D2131292C615F28692C6F29297D29297D2C645F2E70726F746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D';
wwv_flow_imp.g_varchar2_table(42596) := '746869733B746869732E5F6576656E744275732E6F6E282263616E7661732E76696577626F782E6368616E67696E67222C2866756E6374696F6E2874297B652E6869646528297D29292C746869732E5F6576656E744275732E6F6E282263616E7661732E';
wwv_flow_imp.g_varchar2_table(42597) := '76696577626F782E6368616E676564222C2866756E6374696F6E2874297B766172206E3B6E3D742E76696577626F782C652E5F757064617465526F6F74286E292C652E5F757064617465546F6F6C7469705669736962696C7479286E292C652E73686F77';
wwv_flow_imp.g_varchar2_table(42598) := '28297D29297D3B636F6E737420685F3D7B5F5F696E69745F5F3A5B22746F6F6C74697073225D2C746F6F6C746970733A5B2274797065222C645F5D7D3B66756E6374696F6E20755F28652C742C6E297B652E6F6E285B2273686170652E6D6F76652E7265';
wwv_flow_imp.g_varchar2_table(42599) := '6A6563746564222C226372656174652E72656A6563746564225D2C2866756E6374696F6E2865297B76617220692C6F2C733D652E636F6E746578742C723D732E73686170652C613D732E7461726765743B28302C792E69732928612C2262706D6E3A436F';
wwv_flow_imp.g_varchar2_table(42600) := '6C6C61626F726174696F6E2229262628302C792E69732928722C2262706D6E3A466C6F774E6F64652229262628693D652C6F3D6E2822666C6F7720656C656D656E7473206D757374206265206368696C6472656E206F6620706F6F6C732F706172746963';
wwv_flow_imp.g_varchar2_table(42601) := '6970616E747322292C742E616464287B706F736974696F6E3A7B783A692E782B352C793A692E792B357D2C747970653A226572726F72222C74696D656F75743A3265332C68746D6C3A223C6469763E222B6F2B223C2F6469763E227D29297D29297D755F';
wwv_flow_imp.g_varchar2_table(42602) := '2E24696E6A6563743D5B226576656E74427573222C22746F6F6C74697073222C227472616E736C617465225D3B636F6E737420705F3D7B5F5F646570656E64735F5F3A5B685F5D2C5F5F696E69745F5F3A5B226D6F64656C696E67466565646261636B22';
wwv_flow_imp.g_varchar2_table(42603) := '5D2C6D6F64656C696E67466565646261636B3A5B2274797065222C755F5D7D3B76617220675F3D4D6174682E726F756E643B66756E6374696F6E206D5F28652C742C6E2C6F2C73297B66756E6374696F6E207228652C742C6E2C69297B72657475726E20';
wwv_flow_imp.g_varchar2_table(42604) := '732E616C6C6F7765642822656C656D656E74732E6D6F7665222C7B7368617065733A652C64656C74613A742C706F736974696F6E3A6E2C7461726765743A697D297D66756E6374696F6E206128652C6E2C6F2C73297B69662828302C692E477629286F29';
wwv_flow_imp.g_varchar2_table(42605) := '262628733D6F2C6F3D2131292C216E2E776179706F696E747326266E2E706172656E74262621626528652E746172676574292E6861732822646A732D6869742D6E6F2D6D6F76652229297B76617220723D66756E6374696F6E2865297B72657475726E7B';
wwv_flow_imp.g_varchar2_table(42606) := '783A652E782B675F28652E77696474682F32292C793A652E792B675F28652E6865696768742F32297D7D286E293B72657475726E20742E696E697428652C722C2273686170652E6D6F7665222C7B637572736F723A226772616262696E67222C6175746F';
wwv_flow_imp.g_varchar2_table(42607) := '41637469766174653A6F2C646174613A7B73686170653A6E2C636F6E746578743A737C7C7B7D7D7D292C21307D7D652E6F6E282273686170652E6D6F76652E7374617274222C313530302C2866756E6374696F6E2865297B76617220743D652E636F6E74';
wwv_flow_imp.g_varchar2_table(42608) := '6578742C6E3D652E73686170652C733D6F2E67657428292E736C69636528293B2D313D3D3D732E696E6465784F66286E29262628733D5B6E5D292C733D66756E6374696F6E2865297B76617220743D28302C692E247A2928652C22696422293B72657475';
wwv_flow_imp.g_varchar2_table(42609) := '726E28302C692E70622928652C2866756E6374696F6E2865297B666F72283B653D652E706172656E743B29696628745B652E69645D2972657475726E21313B72657475726E21307D29297D2873292C28302C692E6B702928742C7B7368617065733A732C';
wwv_flow_imp.g_varchar2_table(42610) := '76616C6964617465645368617065733A732C73686170653A6E7D297D29292C652E6F6E282273686170652E6D6F76652E7374617274222C313235302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E76616C69646174';
wwv_flow_imp.g_varchar2_table(42611) := '65645368617065733B6966282128742E63616E457865637574653D72286E29292972657475726E21317D29292C652E6F6E282273686170652E6D6F76652E6D6F7665222C3530302C2866756E6374696F6E2865297B76617220742C6E3D652E636F6E7465';
wwv_flow_imp.g_varchar2_table(42612) := '78742C693D6E2E76616C6964617465645368617065732C6F3D652E686F7665722C733D7B783A652E64782C793A652E64797D3B743D7228692C732C7B783A652E782C793A652E797D2C6F292C6E2E64656C74613D732C6E2E63616E457865637574653D74';
wwv_flow_imp.g_varchar2_table(42613) := '2C6E2E7461726765743D6E756C6C213D3D743F6F3A6E756C6C7D29292C652E6F6E282273686170652E6D6F76652E656E64222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C693D742E64656C74612C6F3D742E63616E457865';
wwv_flow_imp.g_varchar2_table(42614) := '637574652C733D22617474616368223D3D3D6F2C723D742E7368617065733B69662821313D3D3D6F2972657475726E21313B692E783D675F28692E78292C692E793D675F28692E79292C303D3D3D692E782626303D3D3D692E797C7C6E2E6D6F7665456C';
wwv_flow_imp.g_varchar2_table(42615) := '656D656E747328722C692C742E7461726765742C7B7072696D61727953686170653A742E73686170652C6174746163683A737D297D29292C652E6F6E2822656C656D656E742E6D6F757365646F776E222C2866756E6374696F6E2865297B696628417228';
wwv_flow_imp.g_varchar2_table(42616) := '6529297B76617220743D4C722865293B6966282174297468726F77206E6577204572726F7228226D75737420737570706C7920444F4D206D6F757365646F776E206576656E7422293B72657475726E206128742C652E656C656D656E74297D7D29292C74';
wwv_flow_imp.g_varchar2_table(42617) := '6869732E73746172743D617D6D5F2E24696E6A6563743D5B226576656E74427573222C226472616767696E67222C226D6F64656C696E67222C2273656C656374696F6E222C2272756C6573225D3B76617220665F3D22646A732D6472616767696E67222C';
wwv_flow_imp.g_varchar2_table(42618) := '765F3D2264726F702D6F6B222C625F3D2264726F702D6E6F742D6F6B222C5F5F3D226E65772D706172656E74222C795F3D226174746163682D6F6B223B66756E6374696F6E20775F28652C742C6E2C6F297B66756E6374696F6E20732865297B76617220';
wwv_flow_imp.g_varchar2_table(42619) := '743D6C7428652C2130292C6E3D742E666C61744D61702828653D3E28652E696E636F6D696E677C7C5B5D292E636F6E63617428652E6F7574676F696E677C7C5B5D2929292C693D742E636F6E636174286E293B72657475726E5B2E2E2E6E657720536574';
wwv_flow_imp.g_varchar2_table(42620) := '2869295D7D66756E6374696F6E207228652C6E297B5B795F2C765F2C625F2C5F5F5D2E666F7245616368282866756E6374696F6E2869297B693D3D3D6E3F742E6164644D61726B657228652C69293A742E72656D6F76654D61726B657228652C69297D29';
wwv_flow_imp.g_varchar2_table(42621) := '297D652E6F6E282273686170652E6D6F76652E7374617274222C3439392C2866756E6374696F6E2865297B76617220722C613D652E636F6E746578742C6C3D612E7368617065732C633D612E616C6C44726167676564456C656D656E74732C643D66756E';
wwv_flow_imp.g_varchar2_table(42622) := '6374696F6E2865297B76617220743B72657475726E20743D732865292C28302C692E70622928742C2866756E6374696F6E2865297B72657475726E214F6E2865297C7C28302C692E49362928742C28302C692E674829287B69643A652E736F757263652E';
wwv_flow_imp.g_varchar2_table(42623) := '69647D2929262628302C692E49362928742C28302C692E674829287B69643A652E7461726765742E69647D29297D29297D286C293B69662821612E6472616747726F7570297B76617220683D6B6528226722293B666528682C6E2E636C732822646A732D';
wwv_flow_imp.g_varchar2_table(42624) := '647261672D67726F7570222C5B226E6F2D6576656E7473225D29292C756528742E6765744163746976654C6179657228292C68292C612E6472616747726F75703D687D642E666F7245616368282866756E6374696F6E2865297B6F2E6164644472616767';
wwv_flow_imp.g_varchar2_table(42625) := '657228652C612E6472616747726F7570297D29292C633D633F28302C692E427129285B632C73286C295D293A73286C292C28302C692E6A4A2928632C2866756E6374696F6E2865297B742E6164644D61726B657228652C665F297D29292C612E616C6C44';
wwv_flow_imp.g_varchar2_table(42626) := '726167676564456C656D656E74733D632C612E646966666572656E74506172656E74733D28723D6C2C31213D3D28302C692E456A292828302C692E247A2928722C2866756E6374696F6E2865297B72657475726E20652E706172656E742626652E706172';
wwv_flow_imp.g_varchar2_table(42627) := '656E742E69647D292929297D29292C652E6F6E282273686170652E6D6F76652E6D6F7665222C3439392C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E6472616747726F75702C693D742E7461726765742C6F3D742E';
wwv_flow_imp.g_varchar2_table(42628) := '73686170652E706172656E742C733D742E63616E457865637574653B6926262822617474616368223D3D3D733F7228692C795F293A742E63616E4578656375746526266F2626692E6964213D3D6F2E69643F7228692C5F5F293A7228692C742E63616E45';
wwv_flow_imp.g_varchar2_table(42629) := '7865637574653F765F3A625F29292C6269286E2C652E64782C652E6479297D29292C652E6F6E285B2273686170652E6D6F76652E6F7574222C2273686170652E6D6F76652E636C65616E7570225D2C2866756E6374696F6E2865297B76617220743D652E';
wwv_flow_imp.g_varchar2_table(42630) := '636F6E746578742E7461726765743B7426267228742C6E756C6C297D29292C652E6F6E282273686170652E6D6F76652E636C65616E7570222C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742C6F3D6E2E616C6C44726167676564';
wwv_flow_imp.g_varchar2_table(42631) := '456C656D656E74732C733D6E2E6472616747726F75703B28302C692E6A4A29286F2C2866756E6374696F6E2865297B742E72656D6F76654D61726B657228652C665F297D29292C73262652652873297D29292C746869732E6D616B65447261676761626C';
wwv_flow_imp.g_varchar2_table(42632) := '653D66756E6374696F6E28652C6E2C69297B6F2E61646444726167676572286E2C652E6472616747726F7570292C692626742E6164644D61726B6572286E2C665F292C652E616C6C44726167676564456C656D656E74733F652E616C6C44726167676564';
wwv_flow_imp.g_varchar2_table(42633) := '456C656D656E74732E70757368286E293A652E616C6C44726167676564456C656D656E74733D5B6E5D7D7D775F2E24696E6A6563743D5B226576656E74427573222C2263616E766173222C227374796C6573222C2270726576696577537570706F727422';
wwv_flow_imp.g_varchar2_table(42634) := '5D3B636F6E737420435F3D7B5F5F646570656E64735F5F3A5B42722C24722C5F722C4B632C6A632C65685D2C5F5F696E69745F5F3A5B226D6F7665222C226D6F766550726576696577225D2C6D6F76653A5B2274797065222C6D5F5D2C6D6F7665507265';
wwv_flow_imp.g_varchar2_table(42635) := '766965773A5B2274797065222C775F5D7D3B76617220535F3D222E646A732D70616C657474652D746F67676C65222C785F3D222E656E747279222C6B5F3D535F2B222C20222B785F2C455F3D22646A732D70616C657474652D222C4C5F3D226F70656E22';
wwv_flow_imp.g_varchar2_table(42636) := '2C445F3D2274776F2D636F6C756D6E223B66756E6374696F6E20545F28652C74297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D743B766172206E3D746869733B652E6F6E2822746F6F6C2D6D616E616765722E75706461';
wwv_flow_imp.g_varchar2_table(42637) := '7465222C2866756E6374696F6E2865297B76617220743D652E746F6F6C3B6E2E757064617465546F6F6C486967686C696768742874297D29292C652E6F6E28226931386E2E6368616E676564222C2866756E6374696F6E28297B6E2E5F75706461746528';
wwv_flow_imp.g_varchar2_table(42638) := '297D29292C652E6F6E28226469616772616D2E696E6974222C2866756E6374696F6E28297B6E2E5F6469616772616D496E697469616C697A65643D21302C6E2E5F72656275696C6428297D29297D66756E6374696F6E20495F28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(42639) := '3D742E67657450616C65747465456E747269657328293B72657475726E28302C692E546E29286E293F6E2865293A2828302C692E6A4A29286E2C2866756E6374696F6E28742C6E297B655B6E5D3D747D29292C65297D545F2E24696E6A6563743D5B2265';
wwv_flow_imp.g_varchar2_table(42640) := '76656E74427573222C2263616E766173225D2C545F2E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E28652C74297B747C7C28743D652C653D316533292C746869732E5F6576656E744275732E6F6E282270616C';
wwv_flow_imp.g_varchar2_table(42641) := '657474652E67657450726F766964657273222C652C2866756E6374696F6E2865297B652E70726F7669646572732E707573682874297D29292C746869732E5F72656275696C6428297D2C545F2E70726F746F747970652E676574456E74726965733D6675';
wwv_flow_imp.g_varchar2_table(42642) := '6E6374696F6E28297B72657475726E20746869732E5F67657450726F76696465727328292E72656475636528495F2C7B7D297D2C545F2E70726F746F747970652E5F72656275696C643D66756E6374696F6E28297B746869732E5F6469616772616D496E';
wwv_flow_imp.g_varchar2_table(42643) := '697469616C697A65642626746869732E5F67657450726F76696465727328292E6C656E677468262628746869732E5F636F6E7461696E65727C7C746869732E5F696E697428292C746869732E5F7570646174652829297D2C545F2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(42644) := '2E5F696E69743D66756E6374696F6E28297B76617220653D746869732C743D746869732E5F6576656E744275732C6E3D746869732E5F676574506172656E74436F6E7461696E657228292C693D746869732E5F636F6E7461696E65723D487428545F2E48';
wwv_flow_imp.g_varchar2_table(42645) := '544D4C5F4D41524B5550293B6E2E617070656E644368696C642869292C6B74286E292E61646428455F2B2273686F776E22292C467428692C6B5F2C22636C69636B222C2866756E6374696F6E2874297B696628577428742E64656C656761746554617267';
wwv_flow_imp.g_varchar2_table(42646) := '65742C535F292972657475726E20652E746F67676C6528293B652E747269676765722822636C69636B222C74297D29292C4F742E62696E6428692C226D6F757365646F776E222C2866756E6374696F6E2865297B652E73746F7050726F7061676174696F';
wwv_flow_imp.g_varchar2_table(42647) := '6E28297D29292C467428692C785F2C22647261677374617274222C2866756E6374696F6E2874297B652E747269676765722822647261677374617274222C74297D29292C742E6F6E282263616E7661732E726573697A6564222C746869732E5F6C61796F';
wwv_flow_imp.g_varchar2_table(42648) := '75744368616E6765642C74686973292C742E66697265282270616C657474652E637265617465222C7B636F6E7461696E65723A697D297D2C545F2E70726F746F747970652E5F67657450726F7669646572733D66756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(42649) := '3D746869732E5F6576656E744275732E6372656174654576656E74287B747970653A2270616C657474652E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E666972652874';
wwv_flow_imp.g_varchar2_table(42650) := '292C742E70726F7669646572737D2C545F2E70726F746F747970652E5F746F67676C6553746174653D66756E6374696F6E2865297B653D657C7C7B7D3B76617220742C6E3D746869732E5F676574506172656E74436F6E7461696E657228292C693D7468';
wwv_flow_imp.g_varchar2_table(42651) := '69732E5F636F6E7461696E65722C6F3D746869732E5F6576656E744275732C733D6B742869292C723D6B74286E293B743D2274776F436F6C756D6E22696E20653F652E74776F436F6C756D6E3A746869732E5F6E65656473436F6C6C61707365286E2E63';
wwv_flow_imp.g_varchar2_table(42652) := '6C69656E744865696768742C746869732E5F656E74726965737C7C7B7D292C732E746F67676C6528445F2C74292C722E746F67676C6528455F2B445F2C74292C226F70656E22696E2065262628732E746F67676C65284C5F2C652E6F70656E292C722E74';
wwv_flow_imp.g_varchar2_table(42653) := '6F67676C6528455F2B4C5F2C652E6F70656E29292C6F2E66697265282270616C657474652E6368616E676564222C7B74776F436F6C756D6E3A742C6F70656E3A746869732E69734F70656E28297D297D2C545F2E70726F746F747970652E5F7570646174';
wwv_flow_imp.g_varchar2_table(42654) := '653D66756E6374696F6E28297B76617220653D6A7428222E646A732D70616C657474652D656E7472696573222C746869732E5F636F6E7461696E6572292C743D746869732E5F656E74726965733D746869732E676574456E747269657328293B4C742865';
wwv_flow_imp.g_varchar2_table(42655) := '292C28302C692E6A4A2928742C2866756E6374696F6E28742C6E297B766172206F3D742E67726F75707C7C2264656661756C74222C733D6A7428225B646174612D67726F75703D222B76286F292B225D222C65293B737C7C28537428733D487428273C64';
wwv_flow_imp.g_varchar2_table(42656) := '697620636C6173733D2267726F7570223E3C2F6469763E27292C22646174612D67726F7570222C6F292C652E617070656E644368696C64287329293B76617220722C612C6C2C633D742E68746D6C7C7C28742E736570617261746F723F273C687220636C';
wwv_flow_imp.g_varchar2_table(42657) := '6173733D22736570617261746F7222202F3E273A273C64697620636C6173733D22656E7472792220647261676761626C653D2274727565223E3C2F6469763E27292C643D48742863293B696628732E617070656E644368696C642864292C21742E736570';
wwv_flow_imp.g_varchar2_table(42658) := '617261746F72262628537428642C22646174612D616374696F6E222C6E292C742E7469746C652626537428642C227469746C65222C742E7469746C65292C742E636C6173734E616D65262628723D642C613D742E636C6173734E616D652C6C3D6B742872';
wwv_flow_imp.g_varchar2_table(42659) := '292C2828302C692E6379292861293F613A612E73706C6974282F5C732B2F6729292E666F7245616368282866756E6374696F6E2865297B6C2E6164642865297D2929292C742E696D61676555726C29297B76617220683D487428223C696D673E22293B53';
wwv_flow_imp.g_varchar2_table(42660) := '7428682C22737263222C742E696D61676555726C292C642E617070656E644368696C642868297D7D29292C746869732E6F70656E28297D2C545F2E70726F746F747970652E747269676765723D66756E6374696F6E28652C742C6E297B76617220692C6F';
wwv_flow_imp.g_varchar2_table(42661) := '2C733D742E64656C65676174655461726765747C7C742E7461726765743B72657475726E20733F28693D537428732C22646174612D616374696F6E22292C6F3D742E6F726967696E616C4576656E747C7C742C746869732E74726967676572456E747279';
wwv_flow_imp.g_varchar2_table(42662) := '28692C652C6F2C6E29293A742E70726576656E7444656661756C7428297D2C545F2E70726F746F747970652E74726967676572456E7472793D66756E6374696F6E28652C742C6E2C6F297B76617220732C723B69662828733D746869732E5F656E747269';
wwv_flow_imp.g_varchar2_table(42663) := '65735B655D29262628723D732E616374696F6E2C2131213D3D746869732E5F6576656E744275732E66697265282270616C657474652E74726967676572222C7B656E7472793A732C6576656E743A6E7D2929297B69662828302C692E546E29287229297B';
wwv_flow_imp.g_varchar2_table(42664) := '69662822636C69636B223D3D3D742972657475726E2072286E2C6F297D656C736520696628725B745D2972657475726E20725B745D286E2C6F293B6E2E70726576656E7444656661756C7428297D7D2C545F2E70726F746F747970652E5F6C61796F7574';
wwv_flow_imp.g_varchar2_table(42665) := '4368616E6765643D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B7D297D2C545F2E70726F746F747970652E5F6E65656473436F6C6C617073653D66756E6374696F6E28652C74297B72657475726E20653C34362A4F626A65';
wwv_flow_imp.g_varchar2_table(42666) := '63742E6B6579732874292E6C656E6774682B35307D2C545F2E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B6F70656E3A21312C74776F436F6C756D6E3A21317D297D2C545F2E7072';
wwv_flow_imp.g_varchar2_table(42667) := '6F746F747970652E6F70656E3D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B6F70656E3A21307D297D2C545F2E70726F746F747970652E746F67676C653D66756E6374696F6E28297B746869732E69734F70656E28293F74';
wwv_flow_imp.g_varchar2_table(42668) := '6869732E636C6F736528293A746869732E6F70656E28297D2C545F2E70726F746F747970652E6973416374697665546F6F6C3D66756E6374696F6E2865297B72657475726E20652626746869732E5F616374697665546F6F6C3D3D3D657D2C545F2E7072';
wwv_flow_imp.g_varchar2_table(42669) := '6F746F747970652E757064617465546F6F6C486967686C696768743D66756E6374696F6E2865297B76617220742C6E3B746869732E5F746F6F6C73436F6E7461696E65727C7C28743D6A7428222E646A732D70616C657474652D656E7472696573222C74';
wwv_flow_imp.g_varchar2_table(42670) := '6869732E5F636F6E7461696E6572292C746869732E5F746F6F6C73436F6E7461696E65723D6A7428225B646174612D67726F75703D746F6F6C735D222C7429292C6E3D746869732E5F746F6F6C73436F6E7461696E65722C28302C692E6A4A29286E2E63';
wwv_flow_imp.g_varchar2_table(42671) := '68696C6472656E2C2866756E6374696F6E2874297B766172206E3D742E6765744174747269627574652822646174612D616374696F6E22293B6966286E297B76617220693D6B742874293B6E3D6E2E7265706C61636528222D746F6F6C222C2222292C69';
wwv_flow_imp.g_varchar2_table(42672) := '2E636F6E7461696E732822656E747279222926266E3D3D3D653F692E6164642822686967686C6967687465642D656E74727922293A692E72656D6F76652822686967686C6967687465642D656E74727922297D7D29297D2C545F2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(42673) := '2E69734F70656E3D66756E6374696F6E28297B72657475726E206B7428746869732E5F636F6E7461696E6572292E686173284C5F297D2C545F2E70726F746F747970652E5F676574506172656E74436F6E7461696E65723D66756E6374696F6E28297B72';
wwv_flow_imp.g_varchar2_table(42674) := '657475726E20746869732E5F63616E7661732E676574436F6E7461696E657228297D2C545F2E48544D4C5F4D41524B55503D273C64697620636C6173733D22646A732D70616C65747465223E3C64697620636C6173733D22646A732D70616C657474652D';
wwv_flow_imp.g_varchar2_table(42675) := '656E7472696573223E3C2F6469763E3C64697620636C6173733D22646A732D70616C657474652D746F67676C65223E3C2F6469763E3C2F6469763E273B636F6E7374204D5F3D7B5F5F696E69745F5F3A5B2270616C65747465225D2C70616C657474653A';
wwv_flow_imp.g_varchar2_table(42676) := '5B2274797065222C545F5D7D3B76617220415F3D2263726F737368616972223B66756E6374696F6E204E5F28652C742C6E2C692C6F2C732C72297B746869732E5F73656C656374696F6E3D6F2C746869732E5F6472616767696E673D6E2C746869732E5F';
wwv_flow_imp.g_varchar2_table(42677) := '6D6F7573653D723B76617220613D746869733B732E7265676973746572546F6F6C28226C6173736F222C7B746F6F6C3A226C6173736F2E73656C656374696F6E222C6472616767696E673A226C6173736F227D292C652E6F6E28226C6173736F2E73656C';
wwv_flow_imp.g_varchar2_table(42678) := '656374696F6E2E656E64222C2866756E6374696F6E2874297B766172206E3D742E6F726967696E616C4576656E742E7461726765743B28742E686F7665727C7C6E20696E7374616E63656F6620535647456C656D656E74292626652E6F6E636528226C61';
wwv_flow_imp.g_varchar2_table(42679) := '73736F2E73656C656374696F6E2E656E646564222C2866756E6374696F6E28297B612E61637469766174654C6173736F28742E6F726967696E616C4576656E742C2130297D29297D29292C652E6F6E28226C6173736F2E656E64222C302C2866756E6374';
wwv_flow_imp.g_varchar2_table(42680) := '696F6E2865297B76617220743D652E636F6E746578742C6E3D505F2865292C6F3D692E66696C746572282866756E6374696F6E2865297B72657475726E20657D29292C733D50722865293B612E73656C656374286F2C6E2C733F742E73656C656374696F';
wwv_flow_imp.g_varchar2_table(42681) := '6E3A5B5D297D29292C652E6F6E28226C6173736F2E7374617274222C2866756E6374696F6E2865297B766172206E3D652E636F6E746578743B6E2E62626F783D505F2865292C66756E6374696F6E2865297B766172206E2C693D742E6765744163746976';
wwv_flow_imp.g_varchar2_table(42682) := '654C6179657228293B6665286E3D652E6672616D653D6B6528227265637422292C7B636C6173733A22646A732D6C6173736F2D6F7665726C6179222C77696474683A312C6865696768743A312C783A302C793A307D292C756528692C6E297D286E292C6E';
wwv_flow_imp.g_varchar2_table(42683) := '2E73656C656374696F6E3D6F2E67657428297D29292C652E6F6E28226C6173736F2E6D6F7665222C2866756E6374696F6E2865297B76617220743D652E636F6E746578743B742E62626F783D505F2865292C66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(42684) := '652E6672616D652C6E3D652E62626F783B666528742C7B783A6E2E782C793A6E2E792C77696474683A6E2E77696474682C6865696768743A6E2E6865696768747D297D2874297D29292C652E6F6E28226C6173736F2E636C65616E7570222C2866756E63';
wwv_flow_imp.g_varchar2_table(42685) := '74696F6E2865297B2166756E6374696F6E2865297B652E6672616D652626526528652E6672616D65297D28652E636F6E74657874297D29292C652E6F6E2822656C656D656E742E6D6F757365646F776E222C313530302C2866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(42686) := '69662850722865292972657475726E20612E61637469766174654C6173736F28652E6F726967696E616C4576656E74292C21307D29297D66756E6374696F6E20505F2865297B76617220743D7B783A652E782D652E64782C793A652E792D652E64797D2C';
wwv_flow_imp.g_varchar2_table(42687) := '6E3D7B783A652E782C793A652E797D3B72657475726E20742E783C3D6E2E782626742E793C6E2E797C7C742E783C6E2E782626742E793C3D6E2E793F7B783A742E782C793A742E792C77696474683A6E2E782D742E782C6865696768743A6E2E792D742E';
wwv_flow_imp.g_varchar2_table(42688) := '797D3A742E783E3D6E2E782626742E793C6E2E797C7C742E783E6E2E782626742E793C3D6E2E793F7B783A6E2E782C793A742E792C77696474683A742E782D6E2E782C6865696768743A6E2E792D742E797D3A742E783C3D6E2E782626742E793E6E2E79';
wwv_flow_imp.g_varchar2_table(42689) := '7C7C742E783C6E2E782626742E793E3D6E2E793F7B783A742E782C793A6E2E792C77696474683A6E2E782D742E782C6865696768743A742E792D6E2E797D3A742E783E3D6E2E782626742E793E6E2E797C7C742E783E6E2E782626742E793E3D6E2E793F';
wwv_flow_imp.g_varchar2_table(42690) := '7B783A6E2E782C793A6E2E792C77696474683A742E782D6E2E782C6865696768743A742E792D6E2E797D3A7B783A6E2E782C793A6E2E792C77696474683A302C6865696768743A307D7D4E5F2E24696E6A6563743D5B226576656E74427573222C226361';
wwv_flow_imp.g_varchar2_table(42691) := '6E766173222C226472616767696E67222C22656C656D656E745265676973747279222C2273656C656374696F6E222C22746F6F6C4D616E61676572222C226D6F757365225D2C4E5F2E70726F746F747970652E61637469766174654C6173736F3D66756E';
wwv_flow_imp.g_varchar2_table(42692) := '6374696F6E28652C74297B746869732E5F6472616767696E672E696E697428652C226C6173736F222C7B6175746F41637469766174653A742C637572736F723A415F2C646174613A7B636F6E746578743A7B7D7D7D297D2C4E5F2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(42693) := '2E616374697661746553656C656374696F6E3D66756E6374696F6E28652C74297B746869732E5F6472616767696E672E696E697428652C226C6173736F2E73656C656374696F6E222C7B74726170436C69636B3A21312C6175746F41637469766174653A';
wwv_flow_imp.g_varchar2_table(42694) := '742C637572736F723A415F2C646174613A7B636F6E746578743A7B7D7D2C6B65657053656C656374696F6E3A21307D297D2C4E5F2E70726F746F747970652E73656C6563743D66756E6374696F6E28652C742C6E3D5B5D297B766172206F3D66756E6374';
wwv_flow_imp.g_varchar2_table(42695) := '696F6E28652C74297B766172206E3D7B7D3B72657475726E28302C692E6A4A2928652C2866756E6374696F6E2865297B766172206F3D653B6F2E776179706F696E74732626286F3D6374286F29292C2128302C692E45742928742E792926266F2E783E74';
wwv_flow_imp.g_varchar2_table(42696) := '2E782626286E5B652E69645D3D65292C2128302C692E45742928742E782926266F2E793E742E792626286E5B652E69645D3D65292C6F2E783E742E7826266F2E793E742E7926262828302C692E45742928742E776964746829262628302C692E45742928';
wwv_flow_imp.g_varchar2_table(42697) := '742E6865696768742926266F2E77696474682B6F2E783C742E77696474682B742E7826266F2E6865696768742B6F2E793C742E6865696768742B742E793F6E5B652E69645D3D653A28302C692E45742928742E776964746829262628302C692E45742928';
wwv_flow_imp.g_varchar2_table(42698) := '742E686569676874297C7C286E5B652E69645D3D6529297D29292C6E7D28652C74293B746869732E5F73656C656374696F6E2E73656C656374285B2E2E2E6E2C2E2E2E28302C692E7A7529286F295D297D2C4E5F2E70726F746F747970652E746F67676C';
wwv_flow_imp.g_varchar2_table(42699) := '653D66756E6374696F6E28297B696628746869732E697341637469766528292972657475726E20746869732E5F6472616767696E672E63616E63656C28293B76617220653D746869732E5F6D6F7573652E6765744C6173744D6F76654576656E7428293B';
wwv_flow_imp.g_varchar2_table(42700) := '746869732E616374697661746553656C656374696F6E28652C212165297D2C4E5F2E70726F746F747970652E69734163746976653D66756E6374696F6E28297B76617220653D746869732E5F6472616767696E672E636F6E7465787428293B7265747572';
wwv_flow_imp.g_varchar2_table(42701) := '6E206526262F5E6C6173736F2F2E7465737428652E707265666978297D3B636F6E7374204F5F3D7B5F5F646570656E64735F5F3A5B52672C6D675D2C5F5F696E69745F5F3A5B226C6173736F546F6F6C225D2C6C6173736F546F6F6C3A5B227479706522';
wwv_flow_imp.g_varchar2_table(42702) := '2C4E5F5D7D3B76617220525F3D313530302C465F3D2267726162223B66756E6374696F6E20425F28652C742C6E2C692C6F2C73297B746869732E5F6472616767696E673D6E2C746869732E5F6D6F7573653D733B76617220723D746869732C613D692E67';
wwv_flow_imp.g_varchar2_table(42703) := '657428226B6579626F617264222C2131293B6F2E7265676973746572546F6F6C282268616E64222C7B746F6F6C3A2268616E64222C6472616767696E673A2268616E642E6D6F7665227D292C652E6F6E2822656C656D656E742E6D6F757365646F776E22';
wwv_flow_imp.g_varchar2_table(42704) := '2C525F2C2866756E6374696F6E2865297B6966284E722865292972657475726E20722E61637469766174654D6F766528652E6F726967696E616C4576656E742C2130292C21317D29292C612626612E6164644C697374656E657228525F2C2866756E6374';
wwv_flow_imp.g_varchar2_table(42705) := '696F6E2865297B696628565F28652E6B65794576656E7429262621722E69734163746976652829297B76617220743D722E5F6D6F7573652E6765744C6173744D6F76654576656E7428293B722E61637469766174654D6F766528742C212174297D7D292C';
wwv_flow_imp.g_varchar2_table(42706) := '226B6579626F6172642E6B6579646F776E22292C612626612E6164644C697374656E657228525F2C2866756E6374696F6E2865297B565F28652E6B65794576656E74292626722E697341637469766528292626722E746F67676C6528297D292C226B6579';
wwv_flow_imp.g_varchar2_table(42707) := '626F6172642E6B6579757022292C652E6F6E282268616E642E656E64222C2866756E6374696F6E2874297B766172206E3D742E6F726967696E616C4576656E742E7461726765743B6966282128742E686F7665727C7C6E20696E7374616E63656F662053';
wwv_flow_imp.g_varchar2_table(42708) := '5647456C656D656E74292972657475726E21313B652E6F6E6365282268616E642E656E646564222C2866756E6374696F6E28297B722E61637469766174654D6F766528742E6F726967696E616C4576656E742C7B726561637469766174653A21307D297D';
wwv_flow_imp.g_varchar2_table(42709) := '29297D29292C652E6F6E282268616E642E6D6F76652E6D6F7665222C2866756E6374696F6E2865297B766172206E3D742E76696577626F7828292E7363616C653B742E7363726F6C6C287B64783A652E64782A6E2C64793A652E64792A6E7D297D29292C';
wwv_flow_imp.g_varchar2_table(42710) := '652E6F6E282268616E642E6D6F76652E656E64222C2866756E6374696F6E2874297B766172206E3D742E636F6E746578742E726561637469766174653B72657475726E214E7228742926266E2626652E6F6E6365282268616E642E6D6F76652E656E6465';
wwv_flow_imp.g_varchar2_table(42711) := '64222C2866756E6374696F6E2865297B722E616374697661746548616E6428652E6F726967696E616C4576656E742C21302C2130297D29292C21317D29297D66756E6374696F6E20565F2865297B72657475726E20587228225370616365222C65297D42';
wwv_flow_imp.g_varchar2_table(42712) := '5F2E24696E6A6563743D5B226576656E74427573222C2263616E766173222C226472616767696E67222C22696E6A6563746F72222C22746F6F6C4D616E61676572222C226D6F757365225D2C425F2E70726F746F747970652E61637469766174654D6F76';
wwv_flow_imp.g_varchar2_table(42713) := '653D66756E6374696F6E28652C742C6E297B226F626A656374223D3D747970656F6620742626286E3D742C743D2131292C746869732E5F6472616767696E672E696E697428652C2268616E642E6D6F7665222C7B6175746F41637469766174653A742C63';
wwv_flow_imp.g_varchar2_table(42714) := '7572736F723A465F2C646174613A7B636F6E746578743A6E7C7C7B7D7D7D297D2C425F2E70726F746F747970652E616374697661746548616E643D66756E6374696F6E28652C742C6E297B746869732E5F6472616767696E672E696E697428652C226861';
wwv_flow_imp.g_varchar2_table(42715) := '6E64222C7B74726170436C69636B3A21312C6175746F41637469766174653A742C637572736F723A465F2C646174613A7B636F6E746578743A7B726561637469766174653A6E7D7D7D297D2C425F2E70726F746F747970652E746F67676C653D66756E63';
wwv_flow_imp.g_varchar2_table(42716) := '74696F6E28297B696628746869732E697341637469766528292972657475726E20746869732E5F6472616767696E672E63616E63656C28293B76617220653D746869732E5F6D6F7573652E6765744C6173744D6F76654576656E7428293B746869732E61';
wwv_flow_imp.g_varchar2_table(42717) := '6374697661746548616E6428652C212165297D2C425F2E70726F746F747970652E69734163746976653D66756E6374696F6E28297B76617220653D746869732E5F6472616767696E672E636F6E7465787428293B72657475726E21216526262F5E286861';
wwv_flow_imp.g_varchar2_table(42718) := '6E647C68616E645C2E6D6F766529242F2E7465737428652E707265666978297D3B636F6E7374207A5F3D7B5F5F646570656E64735F5F3A5B52672C6D675D2C5F5F696E69745F5F3A5B2268616E64546F6F6C225D2C68616E64546F6F6C3A5B2274797065';
wwv_flow_imp.g_varchar2_table(42719) := '222C425F5D7D3B76617220485F3D22636F6E6E6563742D6F6B222C575F3D22636F6E6E6563742D6E6F742D6F6B223B66756E6374696F6E206A5F28652C742C6E2C692C6F2C732C72297B76617220613D746869733B746869732E5F6472616767696E673D';
wwv_flow_imp.g_varchar2_table(42720) := '742C746869732E5F72756C65733D732C746869732E5F6D6F7573653D722C6F2E7265676973746572546F6F6C2822676C6F62616C2D636F6E6E656374222C7B746F6F6C3A22676C6F62616C2D636F6E6E656374222C6472616767696E673A22676C6F6261';
wwv_flow_imp.g_varchar2_table(42721) := '6C2D636F6E6E6563742E64726167227D292C652E6F6E2822676C6F62616C2D636F6E6E6563742E686F766572222C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D652E686F7665722C6F3D742E63616E5374617274436F6E';
wwv_flow_imp.g_varchar2_table(42722) := '6E6563743D612E63616E5374617274436F6E6E656374286E293B6E756C6C213D3D6F262628742E73746172745461726765743D6E2C692E6164644D61726B6572286E2C6F3F485F3A575F29297D29292C652E6F6E285B22676C6F62616C2D636F6E6E6563';
wwv_flow_imp.g_varchar2_table(42723) := '742E6F7574222C22676C6F62616C2D636F6E6E6563742E636C65616E7570225D2C2866756E6374696F6E2865297B76617220743D652E636F6E746578742E73746172745461726765742C6E3D652E636F6E746578742E63616E5374617274436F6E6E6563';
wwv_flow_imp.g_varchar2_table(42724) := '743B742626692E72656D6F76654D61726B657228742C6E3F485F3A575F297D29292C652E6F6E285B22676C6F62616C2D636F6E6E6563742E656E646564225D2C2866756E6374696F6E2874297B76617220693D742E636F6E746578742E73746172745461';
wwv_flow_imp.g_varchar2_table(42725) := '726765742C6F3D7B783A742E782C793A742E797D3B696628612E63616E5374617274436F6E6E6563742869292972657475726E20652E6F6E63652822656C656D656E742E6F7574222C2866756E6374696F6E28297B652E6F6E6365285B22636F6E6E6563';
wwv_flow_imp.g_varchar2_table(42726) := '742E656E646564222C22636F6E6E6563742E63616E63656C6564225D2C2866756E6374696F6E28297B652E666972652822676C6F62616C2D636F6E6E6563742E647261672E656E64656422297D29292C6E2E7374617274286E756C6C2C692C6F297D2929';
wwv_flow_imp.g_varchar2_table(42727) := '2C21317D29297D6A5F2E24696E6A6563743D5B226576656E74427573222C226472616767696E67222C22636F6E6E656374222C2263616E766173222C22746F6F6C4D616E61676572222C2272756C6573222C226D6F757365225D2C6A5F2E70726F746F74';
wwv_flow_imp.g_varchar2_table(42728) := '7970652E73746172743D66756E6374696F6E28652C74297B746869732E5F6472616767696E672E696E697428652C22676C6F62616C2D636F6E6E656374222C7B6175746F41637469766174653A742C74726170436C69636B3A21312C646174613A7B636F';
wwv_flow_imp.g_varchar2_table(42729) := '6E746578743A7B7D7D7D297D2C6A5F2E70726F746F747970652E746F67676C653D66756E6374696F6E28297B696628746869732E697341637469766528292972657475726E20746869732E5F6472616767696E672E63616E63656C28293B76617220653D';
wwv_flow_imp.g_varchar2_table(42730) := '746869732E5F6D6F7573652E6765744C6173744D6F76654576656E7428293B72657475726E20746869732E737461727428652C212165297D2C6A5F2E70726F746F747970652E69734163746976653D66756E6374696F6E28297B76617220653D74686973';
wwv_flow_imp.g_varchar2_table(42731) := '2E5F6472616767696E672E636F6E7465787428293B72657475726E206526262F5E676C6F62616C2D636F6E6E6563742F2E7465737428652E707265666978297D2C6A5F2E70726F746F747970652E63616E5374617274436F6E6E6563743D66756E637469';
wwv_flow_imp.g_varchar2_table(42732) := '6F6E2865297B72657475726E20746869732E5F72756C65732E616C6C6F7765642822636F6E6E656374696F6E2E7374617274222C7B736F757263653A657D297D3B636F6E737420715F3D7B5F5F646570656E64735F5F3A5B4B642C4B632C6A632C52672C';
wwv_flow_imp.g_varchar2_table(42733) := '6D675D2C676C6F62616C436F6E6E6563743A5B2274797065222C6A5F5D7D3B66756E6374696F6E20245F28652C742C6E2C692C6F2C732C722C61297B746869732E5F70616C657474653D652C746869732E5F6372656174653D742C746869732E5F656C65';
wwv_flow_imp.g_varchar2_table(42734) := '6D656E74466163746F72793D6E2C746869732E5F7370616365546F6F6C3D692C746869732E5F6C6173736F546F6F6C3D6F2C746869732E5F68616E64546F6F6C3D732C746869732E5F676C6F62616C436F6E6E6563743D722C746869732E5F7472616E73';
wwv_flow_imp.g_varchar2_table(42735) := '6C6174653D612C652E726567697374657250726F76696465722874686973297D245F2E24696E6A6563743D5B2270616C65747465222C22637265617465222C22656C656D656E74466163746F7279222C227370616365546F6F6C222C226C6173736F546F';
wwv_flow_imp.g_varchar2_table(42736) := '6F6C222C2268616E64546F6F6C222C22676C6F62616C436F6E6E656374222C227472616E736C617465225D2C245F2E70726F746F747970652E67657450616C65747465456E74726965733D66756E6374696F6E28297B76617220653D7B7D2C743D746869';
wwv_flow_imp.g_varchar2_table(42737) := '732E5F6372656174652C6E3D746869732E5F656C656D656E74466163746F72792C6F3D746869732E5F7370616365546F6F6C2C733D746869732E5F6C6173736F546F6F6C2C723D746869732E5F68616E64546F6F6C2C613D746869732E5F676C6F62616C';
wwv_flow_imp.g_varchar2_table(42738) := '436F6E6E6563742C6C3D746869732E5F7472616E736C6174653B66756E6374696F6E206328652C6F2C732C722C61297B66756E6374696F6E206C286F297B76617220733D6E2E63726561746553686170652828302C692E6B7029287B747970653A657D2C';
wwv_flow_imp.g_varchar2_table(42739) := '6129293B742E7374617274286F2C73297D72657475726E7B67726F75703A6F2C636C6173734E616D653A732C7469746C653A722C616374696F6E3A7B6472616773746172743A6C2C636C69636B3A6C7D7D7D66756E6374696F6E20642865297B76617220';
wwv_flow_imp.g_varchar2_table(42740) := '693D6E2E6372656174655368617065287B747970653A2262706D6E3A53756250726F63657373222C783A302C793A302C6973457870616E6465643A21307D292C6F3D6E2E6372656174655368617065287B747970653A2262706D6E3A5374617274457665';
wwv_flow_imp.g_varchar2_table(42741) := '6E74222C783A34302C793A38322C706172656E743A697D293B742E737461727428652C5B692C6F5D2C7B68696E74733A7B6175746F53656C6563743A5B695D7D7D297D66756E6374696F6E20682865297B742E737461727428652C6E2E63726561746550';
wwv_flow_imp.g_varchar2_table(42742) := '61727469636970616E7453686170652829297D72657475726E28302C692E6B702928652C7B2268616E642D746F6F6C223A7B67726F75703A22746F6F6C73222C636C6173734E616D653A2262706D6E2D69636F6E2D68616E642D746F6F6C222C7469746C';
wwv_flow_imp.g_varchar2_table(42743) := '653A6C282241637469766174652068616E6420746F6F6C22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B722E616374697661746548616E642865297D7D7D2C226C6173736F2D746F6F6C223A7B67726F75703A22746F6F6C7322';
wwv_flow_imp.g_varchar2_table(42744) := '2C636C6173734E616D653A2262706D6E2D69636F6E2D6C6173736F2D746F6F6C222C7469746C653A6C28224163746976617465206C6173736F20746F6F6C22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B732E61637469766174';
wwv_flow_imp.g_varchar2_table(42745) := '6553656C656374696F6E2865297D7D7D2C2273706163652D746F6F6C223A7B67726F75703A22746F6F6C73222C636C6173734E616D653A2262706D6E2D69636F6E2D73706163652D746F6F6C222C7469746C653A6C282241637469766174652063726561';
wwv_flow_imp.g_varchar2_table(42746) := '74652F72656D6F766520737061636520746F6F6C22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B6F2E616374697661746553656C656374696F6E2865297D7D7D2C22676C6F62616C2D636F6E6E6563742D746F6F6C223A7B6772';
wwv_flow_imp.g_varchar2_table(42747) := '6F75703A22746F6F6C73222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C7469222C7469746C653A6C2822416374697661746520676C6F62616C20636F6E6E65637420746F6F6C22292C616374696F6E3A7B63';
wwv_flow_imp.g_varchar2_table(42748) := '6C69636B3A66756E6374696F6E2865297B612E73746172742865297D7D7D2C22746F6F6C2D736570617261746F72223A7B67726F75703A22746F6F6C73222C736570617261746F723A21307D2C226372656174652E73746172742D6576656E74223A6328';
wwv_flow_imp.g_varchar2_table(42749) := '2262706D6E3A53746172744576656E74222C226576656E74222C2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E65222C6C2822437265617465207374617274206576656E742229292C226372656174652E696E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(42750) := '2D6576656E74223A63282262706D6E3A496E7465726D6564696174655468726F774576656E74222C226576656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E65222C6C282243726561746520696E7465726D';
wwv_flow_imp.g_varchar2_table(42751) := '6564696174652F626F756E64617279206576656E742229292C226372656174652E656E642D6576656E74223A63282262706D6E3A456E644576656E74222C226576656E74222C2262706D6E2D69636F6E2D656E642D6576656E742D6E6F6E65222C6C2822';
wwv_flow_imp.g_varchar2_table(42752) := '43726561746520656E64206576656E742229292C226372656174652E6578636C75736976652D67617465776179223A63282262706D6E3A4578636C757369766547617465776179222C2267617465776179222C2262706D6E2D69636F6E2D676174657761';
wwv_flow_imp.g_varchar2_table(42753) := '792D6E6F6E65222C6C282243726561746520676174657761792229292C226372656174652E7461736B223A63282262706D6E3A5461736B222C226163746976697479222C2262706D6E2D69636F6E2D7461736B222C6C2822437265617465207461736B22';
wwv_flow_imp.g_varchar2_table(42754) := '29292C226372656174652E646174612D6F626A656374223A63282262706D6E3A446174614F626A6563745265666572656E6365222C22646174612D6F626A656374222C2262706D6E2D69636F6E2D646174612D6F626A656374222C6C2822437265617465';
wwv_flow_imp.g_varchar2_table(42755) := '2064617461206F626A656374207265666572656E63652229292C226372656174652E646174612D73746F7265223A63282262706D6E3A4461746153746F72655265666572656E6365222C22646174612D73746F7265222C2262706D6E2D69636F6E2D6461';
wwv_flow_imp.g_varchar2_table(42756) := '74612D73746F7265222C6C282243726561746520646174612073746F7265207265666572656E63652229292C226372656174652E73756270726F636573732D657870616E646564223A7B67726F75703A226163746976697479222C636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(42757) := '3A2262706D6E2D69636F6E2D73756270726F636573732D657870616E646564222C7469746C653A6C282243726561746520657870616E646564207375622D70726F6365737322292C616374696F6E3A7B6472616773746172743A642C636C69636B3A647D';
wwv_flow_imp.g_varchar2_table(42758) := '7D2C226372656174652E7061727469636970616E742D657870616E646564223A7B67726F75703A22636F6C6C61626F726174696F6E222C636C6173734E616D653A2262706D6E2D69636F6E2D7061727469636970616E74222C7469746C653A6C28224372';
wwv_flow_imp.g_varchar2_table(42759) := '6561746520706F6F6C2F7061727469636970616E7422292C616374696F6E3A7B6472616773746172743A682C636C69636B3A687D7D2C226372656174652E67726F7570223A63282262706D6E3A47726F7570222C226172746966616374222C2262706D6E';
wwv_flow_imp.g_varchar2_table(42760) := '2D69636F6E2D67726F7570222C6C28224372656174652067726F75702229297D292C657D3B636F6E737420555F3D7B5F5F646570656E64735F5F3A5B4D5F2C70672C746D2C4F5F2C7A5F2C715F2C56735D2C5F5F696E69745F5F3A5B2270616C65747465';
wwv_flow_imp.g_varchar2_table(42761) := '50726F7669646572225D2C70616C6574746550726F76696465723A5B2274797065222C245F5D7D3B66756E6374696F6E204B5F28652C742C6E2C6F2C73297B65722E63616C6C28746869732C65292C652E6F6E282273686170652E6D6F76652E6D6F7665';
wwv_flow_imp.g_varchar2_table(42762) := '222C3235302C2866756E6374696F6E2865297B76617220723D652E636F6E746578742C613D722E63616E457865637574653B722E76697375616C5265706C6163656D656E74737C7C28722E76697375616C5265706C6163656D656E74733D7B7D292C6126';
wwv_flow_imp.g_varchar2_table(42763) := '26612E7265706C6163656D656E74733F66756E6374696F6E2865297B76617220723D652E63616E457865637574652E7265706C6163656D656E74733B28302C692E6A4A2928722C2866756E6374696F6E2872297B76617220613D722E6F6C64456C656D65';
wwv_flow_imp.g_varchar2_table(42764) := '6E7449642C6C3D7B747970653A722E6E6577456C656D656E74547970657D3B69662821652E76697375616C5265706C6163656D656E74735B615D297B76617220633D742E6765742861293B28302C692E6B7029286C2C7B783A632E782C793A632E797D29';
wwv_flow_imp.g_varchar2_table(42765) := '3B76617220643D6E2E6372656174655368617065286C293B6F2E616464536861706528642C632E706172656E74293B76617220683D646528275B646174612D656C656D656E742D69643D22272B7628632E6964292B27225D272C652E6472616747726F75';
wwv_flow_imp.g_varchar2_table(42766) := '70293B682626666528682C7B646973706C61793A226E6F6E65227D293B76617220753D732E6164644472616767657228642C652E6472616747726F7570293B652E76697375616C5265706C6163656D656E74735B615D3D752C6F2E72656D6F7665536861';
wwv_flow_imp.g_varchar2_table(42767) := '70652864297D7D29297D2872293A66756E6374696F6E2865297B76617220743D652E76697375616C5265706C6163656D656E74733B28302C692E6A4A2928742C2866756E6374696F6E286E2C69297B766172206F3D646528275B646174612D656C656D65';
wwv_flow_imp.g_varchar2_table(42768) := '6E742D69643D22272B762869292B27225D272C652E6472616747726F7570293B6F26266665286F2C7B646973706C61793A22696E6C696E65227D292C6E2E72656D6F766528292C745B695D262664656C65746520745B695D7D29297D2872297D29297D4B';
wwv_flow_imp.g_varchar2_table(42769) := '5F2E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279222C22656C656D656E74466163746F7279222C2263616E766173222C2270726576696577537570706F7274225D2C52284B5F2C6572293B636F6E73742047';
wwv_flow_imp.g_varchar2_table(42770) := '5F3D7B5F5F646570656E64735F5F3A5B65685D2C5F5F696E69745F5F3A5B2262706D6E5265706C61636550726576696577225D2C62706D6E5265706C616365507265766965773A5B2274797065222C4B5F5D7D3B76617220515F3D5B2278222C2279225D';
wwv_flow_imp.g_varchar2_table(42771) := '2C595F3D4D6174682E6162733B66756E6374696F6E205A5F2865297B652E6F6E285B22636F6E6E6563742E686F766572222C22636F6E6E6563742E6D6F7665222C22636F6E6E6563742E656E64225D2C313235302C2866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(42772) := '7220742C6E3D652E636F6E746578742C6F3D6E2E63616E457865637574652C733D6E2E73746172742C723D6E2E686F7665722C613D6E2E736F757263652C6C3D6E2E7461726765743B652E6F726967696E616C4576656E7426265A7228652E6F72696769';
wwv_flow_imp.g_varchar2_table(42773) := '6E616C4576656E74297C7C286E2E696E697469616C436F6E6E656374696F6E53746172747C7C286E2E696E697469616C436F6E6E656374696F6E53746172743D6E2E636F6E6E656374696F6E5374617274292C6F262672262666756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(42774) := '742C6E297B515F2E666F7245616368282866756E6374696F6E2869297B766172206F3D657928692C74293B655B695D3C745B695D2B6E3F526428652C692C745B695D2B6E293A655B695D3E745B695D2B6F2D6E2626526428652C692C745B695D2B6F2D6E';
wwv_flow_imp.g_varchar2_table(42775) := '297D29297D28652C722C66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5461736B22293F31303A32307D287229292C72262628743D6F2C28302C692E7A4E29285B2262706D6E3A4173736F63696174696F6E222C';
wwv_flow_imp.g_varchar2_table(42776) := '2262706D6E3A44617461496E7075744173736F63696174696F6E222C2262706D6E3A446174614F75747075744173736F63696174696F6E222C2262706D6E3A53657175656E6365466C6F77225D2C2866756E6374696F6E2865297B72657475726E204A5F';
wwv_flow_imp.g_varchar2_table(42777) := '28742C65297D2929293F286E2E636F6E6E656374696F6E53746172743D50642873292C28302C792E6973416E792928722C5B2262706D6E3A4576656E74222C2262706D6E3A47617465776179225D292626585F28652C5064287229292C28302C792E6973';
wwv_flow_imp.g_varchar2_table(42778) := '416E792928722C5B2262706D6E3A5461736B222C2262706D6E3A53756250726F63657373225D29262666756E6374696F6E28652C74297B766172206E3D50642874293B515F2E666F7245616368282866756E6374696F6E2869297B2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(42779) := '28652C742C6E297B72657475726E20655B6E5D3E745B6E5D2B32302626655B6E5D3C745B6E5D2B6579286E2C74292D32307D2928652C742C69292626526428652C692C6E5B695D297D29297D28652C72292C28302C792E69732928612C2262706D6E3A42';
wwv_flow_imp.g_varchar2_table(42780) := '6F756E646172794576656E74222926266C3D3D3D612E686F7374262666756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E736F757263652C693D742E7461726765743B6966282166756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(42781) := '652E686F7665722C6E3D652E736F757263653B72657475726E207426266E2626743D3D3D6E7D287429297B766172206F3D5064286E292C733D576E286F2C692C2D3130292C723D5B5D3B2F746F707C626F74746F6D2F2E746573742873292626722E7075';
wwv_flow_imp.g_varchar2_table(42782) := '736828227822292C2F6C6566747C72696768742F2E746573742873292626722E7075736828227922292C722E666F7245616368282866756E6374696F6E2874297B766172206E2C693D655B745D3B595F28692D6F5B745D293C34302626286E3D693E6F5B';
wwv_flow_imp.g_varchar2_table(42783) := '745D3F6F5B745D2B34303A6F5B745D2D34302C526428652C742C6E29297D29297D7D286529293A4A5F286F2C2262706D6E3A4D657373616765466C6F7722293F2828302C792E69732928732C2262706D6E3A4576656E7422292626286E2E636F6E6E6563';
wwv_flow_imp.g_varchar2_table(42784) := '74696F6E53746172743D5064287329292C28302C792E69732928722C2262706D6E3A4576656E7422292626585F28652C506428722929293A6E2E636F6E6E656374696F6E53746172743D6E2E696E697469616C436F6E6E656374696F6E5374617274297D';
wwv_flow_imp.g_varchar2_table(42785) := '29297D66756E6374696F6E20585F28652C74297B526428652C2278222C742E78292C526428652C2279222C742E79297D66756E6374696F6E204A5F28652C74297B72657475726E20652626652E747970653D3D3D747D66756E6374696F6E20657928652C';
wwv_flow_imp.g_varchar2_table(42786) := '74297B72657475726E2278223D3D3D653F742E77696474683A742E6865696768747D66756E6374696F6E20747928297B746869732E5F746172676574733D7B7D2C746869732E5F736E61704F726967696E733D7B7D2C746869732E5F736E61704C6F6361';
wwv_flow_imp.g_varchar2_table(42787) := '74696F6E733D5B5D2C746869732E5F64656661756C74536E6170733D7B7D7D66756E6374696F6E206E7928297B746869732E5F736E617056616C7565733D7B7D7D5A5F2E24696E6A6563743D5B226576656E74427573225D2C74792E70726F746F747970';
wwv_flow_imp.g_varchar2_table(42788) := '652E676574536E61704F726967696E3D66756E6374696F6E2865297B72657475726E20746869732E5F736E61704F726967696E735B655D7D2C74792E70726F746F747970652E736574536E61704F726967696E3D66756E6374696F6E28652C74297B7468';
wwv_flow_imp.g_varchar2_table(42789) := '69732E5F736E61704F726967696E735B655D3D742C2D313D3D3D746869732E5F736E61704C6F636174696F6E732E696E6465784F662865292626746869732E5F736E61704C6F636174696F6E732E707573682865297D2C74792E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(42790) := '61646444656661756C74536E61703D66756E6374696F6E28652C74297B766172206E3D746869732E5F64656661756C74536E6170735B655D3B6E7C7C286E3D746869732E5F64656661756C74536E6170735B655D3D5B5D292C6E2E707573682874297D2C';
wwv_flow_imp.g_varchar2_table(42791) := '74792E70726F746F747970652E676574536E61704C6F636174696F6E733D66756E6374696F6E28297B72657475726E20746869732E5F736E61704C6F636174696F6E737D2C74792E70726F746F747970652E736574536E61704C6F636174696F6E733D66';
wwv_flow_imp.g_varchar2_table(42792) := '756E6374696F6E2865297B746869732E5F736E61704C6F636174696F6E733D657D2C74792E70726F746F747970652E706F696E7473466F725461726765743D66756E6374696F6E2865297B76617220743D652E69647C7C652C6E3D746869732E5F746172';
wwv_flow_imp.g_varchar2_table(42793) := '676574735B745D3B72657475726E206E7C7C286E3D746869732E5F746172676574735B745D3D6E6577206E79292E696E697444656661756C747328746869732E5F64656661756C74536E617073292C6E7D2C6E792E70726F746F747970652E6164643D66';
wwv_flow_imp.g_varchar2_table(42794) := '756E6374696F6E28652C74297B766172206E3D746869732E5F736E617056616C7565735B655D3B6E7C7C286E3D746869732E5F736E617056616C7565735B655D3D7B783A5B5D2C793A5B5D7D292C2D313D3D3D6E2E782E696E6465784F6628742E782926';
wwv_flow_imp.g_varchar2_table(42795) := '266E2E782E7075736828742E78292C2D313D3D3D6E2E792E696E6465784F6628742E792926266E2E792E7075736828742E79297D2C6E792E70726F746F747970652E736E61703D66756E6374696F6E28652C742C6E2C69297B766172206F3D746869732E';
wwv_flow_imp.g_varchar2_table(42796) := '5F736E617056616C7565735B745D3B72657475726E206F262666756E6374696F6E28652C742C6E297B76617220692C6F3B666F72286E3D766F696420303D3D3D6E3F31303A6E2C693D303B693C742E6C656E6774683B692B2B296966286F3D745B695D2C';
wwv_flow_imp.g_varchar2_table(42797) := '4964286F2D65293C3D6E2972657475726E206F7D28655B6E5D2C6F5B6E5D2C69297D2C6E792E70726F746F747970652E696E697444656661756C74733D66756E6374696F6E2865297B76617220743D746869733B28302C692E6A4A2928657C7C7B7D2C28';
wwv_flow_imp.g_varchar2_table(42798) := '66756E6374696F6E28652C6E297B28302C692E6A4A2928652C2866756E6374696F6E2865297B742E616464286E2C65297D29297D29297D3B7661722069793D313235303B66756E6374696F6E206F7928652C742C6E297B76617220693D746869733B7468';
wwv_flow_imp.g_varchar2_table(42799) := '69732E5F656C656D656E7452656769737472793D652C742E6F6E285B226372656174652E7374617274222C2273686170652E6D6F76652E7374617274225D2C2866756E6374696F6E2865297B692E696E6974536E61702865297D29292C742E6F6E285B22';
wwv_flow_imp.g_varchar2_table(42800) := '6372656174652E6D6F7665222C226372656174652E656E64222C2273686170652E6D6F76652E6D6F7665222C2273686170652E6D6F76652E656E64225D2C69792C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6F3D742E7368';
wwv_flow_imp.g_varchar2_table(42801) := '6170652C733D742E736E6170436F6E746578742C723D742E7461726765743B6966282821652E6F726967696E616C4576656E747C7C215A7228652E6F726967696E616C4576656E7429292626214F64286529262672297B76617220613D732E706F696E74';
wwv_flow_imp.g_varchar2_table(42802) := '73466F725461726765742872293B612E696E697469616C697A65647C7C2828613D692E616464536E6170546172676574506F696E747328612C6F2C7229292E696E697469616C697A65643D2130292C6E2E736E617028652C61297D7D29292C742E6F6E28';
wwv_flow_imp.g_varchar2_table(42803) := '5B226372656174652E636C65616E7570222C2273686170652E6D6F76652E636C65616E7570225D2C2866756E6374696F6E28297B6E2E6869646528297D29297D66756E6374696F6E20737928652C74297B742E696E766F6B65286F792C74686973292C65';
wwv_flow_imp.g_varchar2_table(42804) := '2E6F6E285B226372656174652E6D6F7665222C226372656174652E656E64225D2C313530302C7279292C652E6F6E285B226372656174652E6D6F7665222C226372656174652E656E64222C2273686170652E6D6F76652E6D6F7665222C2273686170652E';
wwv_flow_imp.g_varchar2_table(42805) := '6D6F76652E656E64225D2C313530302C2866756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E63616E457865637574652C693D742E7461726765743B6E26262822617474616368223D3D3D6E7C7C6E2E617474616368292626';
wwv_flow_imp.g_varchar2_table(42806) := '214F64286529262666756E6374696F6E28652C74297B766172206E2C693D566E2874292C6F3D627028652C74292C733D652E636F6E746578742E73686170653B6E3D732E706172656E743F7B783A302C793A307D3A486E2873292C2F746F702F2E746573';
wwv_flow_imp.g_varchar2_table(42807) := '74286F293F526428652C2279222C692E746F702D6E2E79293A2F626F74746F6D2F2E74657374286F292626526428652C2279222C692E626F74746F6D2D6E2E79292C2F6C6566742F2E74657374286F293F526428652C2278222C692E6C6566742D6E2E78';
wwv_flow_imp.g_varchar2_table(42808) := '293A2F72696768742F2E74657374286F292626526428652C2278222C692E72696768742D6E2E78297D28652C69297D29297D66756E6374696F6E2072792865297B76617220743D652E636F6E746578742E637265617465436F6E73747261696E74733B69';
wwv_flow_imp.g_varchar2_table(42809) := '662874297B766172206E3D742E746F702C693D742E72696768742C6F3D742E626F74746F6D2C733D742E6C6566743B28732626733E3D652E787C7C692626693C3D652E78292626526428652C2278222C652E78292C286E26266E3E3D652E797C7C6F2626';
wwv_flow_imp.g_varchar2_table(42810) := '6F3C3D652E79292626526428652C2279222C652E79297D7D66756E6374696F6E20617928652C74297B72657475726E2D31213D3D652E696E6465784F662874297D66756E6374696F6E206C7928652C742C6E297B72657475726E20743F7B783A652E782D';
wwv_flow_imp.g_varchar2_table(42811) := '6E2E782C793A652E792D6E2E797D3A7B783A652E782C793A652E797D7D66756E6374696F6E20637928652C74297B766172206E3D746869733B652E6F6E285B22726573697A652E7374617274225D2C2866756E6374696F6E2865297B6E2E696E6974536E';
wwv_flow_imp.g_varchar2_table(42812) := '61702865297D29292C652E6F6E285B22726573697A652E6D6F7665222C22726573697A652E656E64225D2C313235302C2866756E6374696F6E2865297B76617220693D652E636F6E746578742C6F3D692E73686170652C733D6F2E706172656E742C723D';
wwv_flow_imp.g_varchar2_table(42813) := '692E646972656374696F6E2C613D692E736E6170436F6E746578743B6966282128652E6F726967696E616C4576656E7426265A7228652E6F726967696E616C4576656E74297C7C4F6428652929297B766172206C3D612E706F696E7473466F7254617267';
wwv_flow_imp.g_varchar2_table(42814) := '65742873293B6C2E696E697469616C697A65647C7C28286C3D6E2E616464536E6170546172676574506F696E7473286C2C6F2C732C7229292E696E697469616C697A65643D2130292C66756E6374696F6E2865297B72657475726E226E223D3D3D657C7C';
wwv_flow_imp.g_varchar2_table(42815) := '2273223D3D3D657D2872292626526428652C2278222C652E78292C66756E6374696F6E2865297B72657475726E2265223D3D3D657C7C2277223D3D3D657D2872292626526428652C2279222C652E79292C742E736E617028652C6C297D7D29292C652E6F';
wwv_flow_imp.g_varchar2_table(42816) := '6E285B22726573697A652E636C65616E7570225D2C2866756E6374696F6E28297B742E6869646528297D29297D66756E6374696F6E20647928652C74297B766172206E3D486E2865292C693D566E2865292C6F3D7B783A6E2E782C793A6E2E797D3B7265';
wwv_flow_imp.g_varchar2_table(42817) := '7475726E2D31213D3D742E696E6465784F6628226E22293F6F2E793D692E746F703A2D31213D3D742E696E6465784F6628227322292626286F2E793D692E626F74746F6D292C2D31213D3D742E696E6465784F6628226522293F6F2E783D692E72696768';
wwv_flow_imp.g_varchar2_table(42818) := '743A2D31213D3D742E696E6465784F6628227722292626286F2E783D692E6C656674292C6F7D66756E6374696F6E2068792865297B746869732E5F63616E7661733D652C746869732E5F6173796E63486964653D28302C692E7367292828302C692E6F49';
wwv_flow_imp.g_varchar2_table(42819) := '2928746869732E686964652C74686973292C316533297D6F792E24696E6A6563743D5B22656C656D656E745265676973747279222C226576656E74427573222C22736E617070696E67225D2C6F792E70726F746F747970652E696E6974536E61703D6675';
wwv_flow_imp.g_varchar2_table(42820) := '6E6374696F6E2865297B76617220742C6E3D746869732E5F656C656D656E7452656769737472792C693D652E636F6E746578742C6F3D692E73686170652C733D692E736E6170436F6E746578743B737C7C28733D692E736E6170436F6E746578743D6E65';
wwv_flow_imp.g_varchar2_table(42821) := '77207479293B76617220723D28743D6E2E676574286F2E6964293F5064286F2C65293A7B783A652E782B5064286F292E782C793A652E792B5064286F292E797D292E782D6F2E77696474682F322C613D742E792D6F2E6865696768742F322C6C3D742E78';
wwv_flow_imp.g_varchar2_table(42822) := '2B6F2E77696474682F322C633D742E792B6F2E6865696768742F323B72657475726E20732E736574536E61704F726967696E28226D6964222C7B783A742E782D652E782C793A742E792D652E797D292C526E286F297C7C28732E736574536E61704F7269';
wwv_flow_imp.g_varchar2_table(42823) := '67696E2822746F702D6C656674222C7B783A722D652E782C793A612D652E797D292C732E736574536E61704F726967696E2822626F74746F6D2D7269676874222C7B783A6C2D652E782C793A632D652E797D29292C737D2C6F792E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(42824) := '2E616464536E6170546172676574506F696E74733D66756E6374696F6E28652C742C6E297B766172206F3D746869732E676574536E61705461726765747328742C6E293B72657475726E28302C692E6A4A29286F2C2866756E6374696F6E286E297B6966';
wwv_flow_imp.g_varchar2_table(42825) := '28526E286E2929526E2874292626652E61646428226D6964222C5064286E29293B656C7365206966284F6E286E29297B6966286E2E776179706F696E74732E6C656E6774683C332972657475726E3B766172206F3D6E2E776179706F696E74732E736C69';
wwv_flow_imp.g_varchar2_table(42826) := '636528312C2D31293B28302C692E6A4A29286F2C2866756E6374696F6E2874297B652E61646428226D6964222C74297D29297D656C736520652E61646428226D6964222C5064286E29297D29292C28302C692E45742928742E7829262628302C692E4574';
wwv_flow_imp.g_varchar2_table(42827) := '2928742E79293F28746869732E5F656C656D656E7452656769737472792E67657428742E6964292626652E61646428226D6964222C5064287429292C65293A657D2C6F792E70726F746F747970652E676574536E6170546172676574733D66756E637469';
wwv_flow_imp.g_varchar2_table(42828) := '6F6E28652C74297B72657475726E2046642874292E66696C746572282866756E6374696F6E2865297B72657475726E21652E68696464656E7D29297D2C522873792C6F79292C73792E24696E6A6563743D5B226576656E74427573222C22696E6A656374';
wwv_flow_imp.g_varchar2_table(42829) := '6F72225D2C73792E70726F746F747970652E696E6974536E61703D66756E6374696F6E2865297B76617220743D6F792E70726F746F747970652E696E6974536E61702E63616C6C28746869732C65292C6E3D652E73686170652C6F3D2121746869732E5F';
wwv_flow_imp.g_varchar2_table(42830) := '656C656D656E7452656769737472792E676574286E2E6964293B72657475726E28302C692E6A4A29286E2E6F7574676F696E672C2866756E6374696F6E286E297B76617220693D6E2E776179706F696E74735B305D3B693D692E6F726967696E616C7C7C';
wwv_flow_imp.g_varchar2_table(42831) := '692C742E736574536E61704F726967696E286E2E69642B222D646F636B696E67222C6C7928692C6F2C6529297D29292C28302C692E6A4A29286E2E696E636F6D696E672C2866756E6374696F6E286E297B76617220693D6E2E776179706F696E74735B6E';
wwv_flow_imp.g_varchar2_table(42832) := '2E776179706F696E74732E6C656E6774682D315D3B693D692E6F726967696E616C7C7C692C742E736574536E61704F726967696E286E2E69642B222D646F636B696E67222C6C7928692C6F2C6529297D29292C28302C792E697329286E2C2262706D6E3A';
wwv_flow_imp.g_varchar2_table(42833) := '5061727469636970616E7422292626742E736574536E61704C6F636174696F6E73285B22746F702D6C656674222C22626F74746F6D2D7269676874222C226D6964225D292C747D2C73792E70726F746F747970652E616464536E6170546172676574506F';
wwv_flow_imp.g_varchar2_table(42834) := '696E74733D66756E6374696F6E28652C742C6E297B6F792E70726F746F747970652E616464536E6170546172676574506F696E74732E63616C6C28746869732C652C742C6E293B766172206F3D746869732E676574536E61705461726765747328742C6E';
wwv_flow_imp.g_varchar2_table(42835) := '293B28302C692E6A4A29286F2C2866756E6374696F6E286E297B76617220693B693D6E2C2828302C792E69732928692C2262706D6E3A53756250726F636573732229262628302C72732E4176292869297C7C28302C792E69732928692C2262706D6E3A50';
wwv_flow_imp.g_varchar2_table(42836) := '61727469636970616E7422297C7C5B742C6E5D2E6576657279282866756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A54657874416E6E6F746174696F6E22297D292929262628652E6164642822746F702D6C656674';
wwv_flow_imp.g_varchar2_table(42837) := '222C4164286E29292C652E6164642822626F74746F6D2D7269676874222C4E64286E2929297D29293B76617220733D746869732E5F656C656D656E7452656769737472793B72657475726E28302C692E6A4A2928742E696E636F6D696E672C2866756E63';
wwv_flow_imp.g_varchar2_table(42838) := '74696F6E286E297B696628732E67657428742E696429297B6179286F2C6E2E736F75726365297C7C652E61646428226D6964222C486E286E2E736F7572636529293B76617220693D6E2E776179706F696E74735B305D3B652E616464286E2E69642B222D';
wwv_flow_imp.g_varchar2_table(42839) := '646F636B696E67222C692E6F726967696E616C7C7C69297D7D29292C28302C692E6A4A2928742E6F7574676F696E672C2866756E6374696F6E286E297B696628732E67657428742E696429297B6179286F2C6E2E746172676574297C7C652E6164642822';
wwv_flow_imp.g_varchar2_table(42840) := '6D6964222C486E286E2E74617267657429293B76617220693D6E2E776179706F696E74735B6E2E776179706F696E74732E6C656E6774682D315D3B652E616464286E2E69642B222D646F636B696E67222C692E6F726967696E616C7C7C69297D7D29292C';
wwv_flow_imp.g_varchar2_table(42841) := '28302C792E697329286E2C2262706D6E3A53657175656E6365466C6F772229262628653D746869732E616464536E6170546172676574506F696E747328652C742C6E2E706172656E7429292C657D2C73792E70726F746F747970652E676574536E617054';
wwv_flow_imp.g_varchar2_table(42842) := '6172676574733D66756E6374696F6E28652C74297B72657475726E206F792E70726F746F747970652E676574536E6170546172676574732E63616C6C28746869732C652C74292E66696C746572282866756E6374696F6E2865297B72657475726E212830';
wwv_flow_imp.g_varchar2_table(42843) := '2C792E69732928652C2262706D6E3A4C616E6522297D29297D2C63792E70726F746F747970652E696E6974536E61703D66756E6374696F6E2865297B76617220743D652E636F6E746578742C6E3D742E73686170652C693D742E646972656374696F6E2C';
wwv_flow_imp.g_varchar2_table(42844) := '6F3D742E736E6170436F6E746578743B6F7C7C286F3D742E736E6170436F6E746578743D6E6577207479293B76617220733D6479286E2C69293B72657475726E206F2E736574536E61704F726967696E2822636F726E6572222C7B783A732E782D652E78';
wwv_flow_imp.g_varchar2_table(42845) := '2C793A732E792D652E797D292C6F7D2C63792E70726F746F747970652E616464536E6170546172676574506F696E74733D66756E6374696F6E28652C742C6E2C6F297B76617220733D746869732E676574536E61705461726765747328742C6E293B7265';
wwv_flow_imp.g_varchar2_table(42846) := '7475726E28302C692E6A4A2928732C2866756E6374696F6E2874297B652E6164642822636F726E6572222C4E64287429292C652E6164642822636F726E6572222C4164287429297D29292C652E6164642822636F726E6572222C647928742C6F29292C65';
wwv_flow_imp.g_varchar2_table(42847) := '7D2C63792E24696E6A6563743D5B226576656E74427573222C22736E617070696E67225D2C63792E70726F746F747970652E676574536E6170546172676574733D66756E6374696F6E28652C74297B72657475726E2046642874292E66696C7465722828';
wwv_flow_imp.g_varchar2_table(42848) := '66756E6374696F6E2874297B72657475726E206E3D652C2128742E686F73743D3D3D6E7C7C4F6E2874297C7C66756E6374696F6E2865297B72657475726E2121652E68696464656E7D2874297C7C526E287429293B766172206E7D29297D2C68792E2469';
wwv_flow_imp.g_varchar2_table(42849) := '6E6A6563743D5B2263616E766173225D2C68792E70726F746F747970652E736E61703D66756E6374696F6E28652C74297B766172206E3D652E636F6E746578742E736E6170436F6E746578742C6F3D6E2E676574536E61704C6F636174696F6E7328292C';
wwv_flow_imp.g_varchar2_table(42850) := '733D7B783A4F6428652C227822292C793A4F6428652C227922297D3B28302C692E6A4A29286F2C2866756E6374696F6E286F297B76617220723D6E2E676574536E61704F726967696E286F292C613D7B783A652E782B722E782C793A652E792B722E797D';
wwv_flow_imp.g_varchar2_table(42851) := '3B69662828302C692E6A4A29285B2278222C2279225D2C2866756E6374696F6E2865297B766172206E3B735B655D7C7C766F69642030213D3D286E3D742E736E617028612C6F2C652C372929262628735B655D3D7B76616C75653A6E2C6F726967696E56';
wwv_flow_imp.g_varchar2_table(42852) := '616C75653A6E2D725B655D7D297D29292C732E782626732E792972657475726E21317D29292C746869732E73686F77536E61704C696E652822766572746963616C222C732E782626732E782E76616C7565292C746869732E73686F77536E61704C696E65';
wwv_flow_imp.g_varchar2_table(42853) := '2822686F72697A6F6E74616C222C732E792626732E792E76616C7565292C28302C692E6A4A29285B2278222C2279225D2C2866756E6374696F6E2874297B766172206E3D735B745D3B28302C692E477629286E292626526428652C742C6E2E6F72696769';
wwv_flow_imp.g_varchar2_table(42854) := '6E56616C7565297D29297D2C68792E70726F746F747970652E5F6372656174654C696E653D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732E6765744C617965722822736E617022292C6E3D6B6528227061746822293B7265';
wwv_flow_imp.g_varchar2_table(42855) := '7475726E206665286E2C7B643A224D302C30204C302C30227D292C6265286E292E6164642822646A732D736E61702D6C696E6522292C756528742C6E292C7B7570646174653A66756E6374696F6E2874297B28302C692E4574292874293F6665286E2C22';
wwv_flow_imp.g_varchar2_table(42856) := '686F72697A6F6E74616C223D3D3D653F7B643A224D2D3130303030302C222B742B22204C2B3130303030302C222B742C646973706C61793A22227D3A7B643A224D20222B742B222C2D313030303030204C20222B742B222C202B313030303030222C6469';
wwv_flow_imp.g_varchar2_table(42857) := '73706C61793A22227D293A6665286E2C7B646973706C61793A226E6F6E65227D297D7D7D2C68792E70726F746F747970652E5F637265617465536E61704C696E65733D66756E6374696F6E28297B746869732E5F736E61704C696E65733D7B686F72697A';
wwv_flow_imp.g_varchar2_table(42858) := '6F6E74616C3A746869732E5F6372656174654C696E652822686F72697A6F6E74616C22292C766572746963616C3A746869732E5F6372656174654C696E652822766572746963616C22297D7D2C68792E70726F746F747970652E73686F77536E61704C69';
wwv_flow_imp.g_varchar2_table(42859) := '6E653D66756E6374696F6E28652C74297B766172206E3D746869732E676574536E61704C696E652865293B6E26266E2E7570646174652874292C746869732E5F6173796E634869646528297D2C68792E70726F746F747970652E676574536E61704C696E';
wwv_flow_imp.g_varchar2_table(42860) := '653D66756E6374696F6E2865297B72657475726E20746869732E5F736E61704C696E65737C7C746869732E5F637265617465536E61704C696E657328292C746869732E5F736E61704C696E65735B655D7D2C68792E70726F746F747970652E686964653D';
wwv_flow_imp.g_varchar2_table(42861) := '66756E6374696F6E28297B28302C692E6A4A2928746869732E5F736E61704C696E65732C2866756E6374696F6E2865297B652E75706461746528297D29297D3B636F6E73742075793D7B5F5F646570656E64735F5F3A5B7B5F5F696E69745F5F3A5B2263';
wwv_flow_imp.g_varchar2_table(42862) := '72656174654D6F7665536E617070696E67222C22726573697A65536E617070696E67222C22736E617070696E67225D2C6372656174654D6F7665536E617070696E673A5B2274797065222C6F795D2C726573697A65536E617070696E673A5B2274797065';
wwv_flow_imp.g_varchar2_table(42863) := '222C63795D2C736E617070696E673A5B2274797065222C68795D7D5D2C5F5F696E69745F5F3A5B22636F6E6E656374536E617070696E67222C226372656174654D6F7665536E617070696E67225D2C636F6E6E656374536E617070696E673A5B22747970';
wwv_flow_imp.g_varchar2_table(42864) := '65222C5A5F5D2C6372656174654D6F7665536E617070696E673A5B2274797065222C73795D7D3B66756E6374696F6E20707928652C742C6E2C692C6F297B746869732E5F6F70656E3D21312C746869732E5F726573756C74733D5B5D2C746869732E5F65';
wwv_flow_imp.g_varchar2_table(42865) := '76656E744D6170733D5B5D2C746869732E5F63616E7661733D652C746869732E5F6576656E744275733D742C746869732E5F6F7665726C6179733D6E2C746869732E5F73656C656374696F6E3D692C746869732E5F7472616E736C6174653D6F2C746869';
wwv_flow_imp.g_varchar2_table(42866) := '732E5F636F6E7461696E65723D746869732E5F676574426F7848746D6C28292C746869732E5F736561726368496E7075743D6A742870792E494E5055545F53454C4543544F522C746869732E5F636F6E7461696E6572292C746869732E5F726573756C74';
wwv_flow_imp.g_varchar2_table(42867) := '73436F6E7461696E65723D6A742870792E524553554C54535F434F4E5441494E45525F53454C4543544F522C746869732E5F636F6E7461696E6572292C746869732E5F63616E7661732E676574436F6E7461696E657228292E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(42868) := '28746869732E5F636F6E7461696E6572292C742E6F6E285B2263616E7661732E64657374726F79222C226469616772616D2E64657374726F79225D2C746869732E636C6F73652C74686973297D66756E6374696F6E20677928652C742C6E297B76617220';
wwv_flow_imp.g_varchar2_table(42869) := '693D66756E6374696F6E2865297B76617220743D22223B72657475726E20652E666F7245616368282866756E6374696F6E2865297B652E6D6174636865643F742B3D273C7374726F6E6720636C6173733D22272B70792E524553554C545F484947484C49';
wwv_flow_imp.g_varchar2_table(42870) := '4748545F434C4153532B27223E272B5F28652E6D617463686564292B223C2F7374726F6E673E223A742B3D5F28652E6E6F726D616C297D29292C2222213D3D743F743A6E756C6C7D2874292C6F3D4874286E293B6F2E696E6E657248544D4C3D692C652E';
wwv_flow_imp.g_varchar2_table(42871) := '617070656E644368696C64286F297D70792E24696E6A6563743D5B2263616E766173222C226576656E74427573222C226F7665726C617973222C2273656C656374696F6E222C227472616E736C617465225D2C70792E70726F746F747970652E5F62696E';
wwv_flow_imp.g_varchar2_table(42872) := '644576656E74733D66756E6374696F6E28297B76617220653D746869733B66756E6374696F6E207428742C6E2C692C6F297B652E5F6576656E744D6170732E70757368287B656C3A742C747970653A692C6C697374656E65723A467428742C6E2C692C6F';
wwv_flow_imp.g_varchar2_table(42873) := '297D297D7428646F63756D656E742C2268746D6C222C22636C69636B222C2866756E6374696F6E2874297B652E636C6F736528297D29292C7428746869732E5F636F6E7461696E65722C70792E494E5055545F53454C4543544F522C22636C69636B222C';
wwv_flow_imp.g_varchar2_table(42874) := '2866756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28292C652E64656C65676174655461726765742E666F63757328297D29292C7428746869732E5F636F6E7461696E65722C70792E524553554C545F53454C4543544F522C226D';
wwv_flow_imp.g_varchar2_table(42875) := '6F7573656F766572222C2866756E6374696F6E2874297B742E73746F7050726F7061676174696F6E28292C652E5F7363726F6C6C546F4E6F646528742E64656C6567617465546172676574292C652E5F70726573656C65637428742E64656C6567617465';
wwv_flow_imp.g_varchar2_table(42876) := '546172676574297D29292C7428746869732E5F636F6E7461696E65722C70792E524553554C545F53454C4543544F522C22636C69636B222C2866756E6374696F6E2874297B742E73746F7050726F7061676174696F6E28292C652E5F73656C6563742874';
wwv_flow_imp.g_varchar2_table(42877) := '2E64656C6567617465546172676574297D29292C7428746869732E5F636F6E7461696E65722C70792E494E5055545F53454C4543544F522C226B6579646F776E222C2866756E6374696F6E2865297B587228224172726F775570222C65292626652E7072';
wwv_flow_imp.g_varchar2_table(42878) := '6576656E7444656661756C7428292C587228224172726F77446F776E222C65292626652E70726576656E7444656661756C7428297D29292C7428746869732E5F636F6E7461696E65722C70792E494E5055545F53454C4543544F522C226B65797570222C';
wwv_flow_imp.g_varchar2_table(42879) := '2866756E6374696F6E2874297B69662858722822457363617065222C74292972657475726E20652E636C6F736528293B69662858722822456E746572222C7429297B766172206E3D652E5F67657443757272656E74526573756C7428293B72657475726E';
wwv_flow_imp.g_varchar2_table(42880) := '206E3F652E5F73656C656374286E293A652E636C6F736528297D72657475726E20587228224172726F775570222C74293F652E5F7363726F6C6C546F446972656374696F6E282130293A587228224172726F77446F776E222C74293F652E5F7363726F6C';
wwv_flow_imp.g_varchar2_table(42881) := '6C546F446972656374696F6E28293A766F6964285872285B224172726F774C656674222C224172726F775269676874225D2C74297C7C652E5F73656172636828742E64656C65676174655461726765742E76616C756529297D29297D2C70792E70726F74';
wwv_flow_imp.g_varchar2_table(42882) := '6F747970652E5F756E62696E644576656E74733D66756E6374696F6E28297B746869732E5F6576656E744D6170732E666F7245616368282866756E6374696F6E2865297B427428652E656C2C652E747970652C652E6C697374656E6572297D29297D2C70';
wwv_flow_imp.g_varchar2_table(42883) := '792E70726F746F747970652E5F7365617263683D66756E6374696F6E2865297B76617220743D746869733B696628746869732E5F636C656172526573756C747328292C6526262222213D3D65297B766172206E3D746869732E5F73656172636850726F76';
wwv_flow_imp.g_varchar2_table(42884) := '696465722E66696E642865293B6966286E2E6C656E677468297B6E2E666F7245616368282866756E6374696F6E2865297B766172206E3D652E656C656D656E742E69642C693D742E5F637265617465526573756C744E6F646528652C6E293B742E5F7265';
wwv_flow_imp.g_varchar2_table(42885) := '73756C74735B6E5D3D7B656C656D656E743A652E656C656D656E742C6E6F64653A697D7D29293B76617220693D6A742870792E524553554C545F53454C4543544F522C746869732E5F726573756C7473436F6E7461696E6572293B746869732E5F736372';
wwv_flow_imp.g_varchar2_table(42886) := '6F6C6C546F4E6F64652869292C746869732E5F70726573656C6563742869297D7D7D2C70792E70726F746F747970652E5F7363726F6C6C546F446972656374696F6E3D66756E6374696F6E2865297B76617220743D746869732E5F67657443757272656E';
wwv_flow_imp.g_varchar2_table(42887) := '74526573756C7428293B69662874297B766172206E3D653F742E70726576696F7573456C656D656E745369626C696E673A742E6E657874456C656D656E745369626C696E673B6E262628746869732E5F7363726F6C6C546F4E6F6465286E292C74686973';
wwv_flow_imp.g_varchar2_table(42888) := '2E5F70726573656C656374286E29297D7D2C70792E70726F746F747970652E5F7363726F6C6C546F4E6F64653D66756E6374696F6E2865297B69662865262665213D3D746869732E5F67657443757272656E74526573756C742829297B76617220743D65';
wwv_flow_imp.g_varchar2_table(42889) := '2E6F6666736574546F702C6E3D746869732E5F726573756C7473436F6E7461696E65722E7363726F6C6C546F702C693D742D746869732E5F726573756C7473436F6E7461696E65722E636C69656E744865696768742B652E636C69656E74486569676874';
wwv_flow_imp.g_varchar2_table(42890) := '3B743C6E3F746869732E5F726573756C7473436F6E7461696E65722E7363726F6C6C546F703D743A6E3C69262628746869732E5F726573756C7473436F6E7461696E65722E7363726F6C6C546F703D69297D7D2C70792E70726F746F747970652E5F636C';
wwv_flow_imp.g_varchar2_table(42891) := '656172526573756C74733D66756E6374696F6E28297B4C7428746869732E5F726573756C7473436F6E7461696E6572292C746869732E5F726573756C74733D5B5D2C746869732E5F72657365744F7665726C617928292C746869732E5F6576656E744275';
wwv_flow_imp.g_varchar2_table(42892) := '732E6669726528227365617263685061642E636C656172656422297D2C70792E70726F746F747970652E5F67657443757272656E74526573756C743D66756E6374696F6E28297B72657475726E206A742870792E524553554C545F53454C45435445445F';
wwv_flow_imp.g_varchar2_table(42893) := '53454C4543544F522C746869732E5F726573756C7473436F6E7461696E6572297D2C70792E70726F746F747970652E5F637265617465526573756C744E6F64653D66756E6374696F6E28652C74297B766172206E3D48742870792E524553554C545F4854';
wwv_flow_imp.g_varchar2_table(42894) := '4D4C293B72657475726E20652E7072696D617279546F6B656E732E6C656E6774683E3026266779286E2C652E7072696D617279546F6B656E732C70792E524553554C545F5052494D4152595F48544D4C292C6779286E2C652E7365636F6E64617279546F';
wwv_flow_imp.g_varchar2_table(42895) := '6B656E732C70792E524553554C545F5345434F4E444152595F48544D4C292C5374286E2C70792E524553554C545F49445F4154545249425554452C74292C746869732E5F726573756C7473436F6E7461696E65722E617070656E644368696C64286E292C';
wwv_flow_imp.g_varchar2_table(42896) := '6E7D2C70792E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E2865297B746869732E5F73656172636850726F76696465723D657D2C70792E70726F746F747970652E6F70656E3D66756E6374696F6E28297B6966';
wwv_flow_imp.g_varchar2_table(42897) := '2821746869732E5F73656172636850726F7669646572297468726F77206E6577204572726F7228226E6F207365617263682070726F7669646572207265676973746572656422293B746869732E69734F70656E28297C7C28746869732E5F62696E644576';
wwv_flow_imp.g_varchar2_table(42898) := '656E747328292C746869732E5F6F70656E3D21302C6B7428746869732E5F636F6E7461696E6572292E61646428226F70656E22292C746869732E5F736561726368496E7075742E666F63757328292C746869732E5F6576656E744275732E666972652822';
wwv_flow_imp.g_varchar2_table(42899) := '7365617263685061642E6F70656E65642229297D2C70792E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E69734F70656E2829262628746869732E5F756E62696E644576656E747328292C746869732E5F6F70656E3D21';
wwv_flow_imp.g_varchar2_table(42900) := '312C6B7428746869732E5F636F6E7461696E6572292E72656D6F766528226F70656E22292C746869732E5F636C656172526573756C747328292C746869732E5F736561726368496E7075742E76616C75653D22222C746869732E5F736561726368496E70';
wwv_flow_imp.g_varchar2_table(42901) := '75742E626C757228292C746869732E5F72657365744F7665726C617928292C746869732E5F6576656E744275732E6669726528227365617263685061642E636C6F7365642229297D2C70792E70726F746F747970652E746F67676C653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(42902) := '6E28297B746869732E69734F70656E28293F746869732E636C6F736528293A746869732E6F70656E28297D2C70792E70726F746F747970652E69734F70656E3D66756E6374696F6E28297B72657475726E20746869732E5F6F70656E7D2C70792E70726F';
wwv_flow_imp.g_varchar2_table(42903) := '746F747970652E5F70726573656C6563743D66756E6374696F6E2865297B76617220743D746869732E5F67657443757272656E74526573756C7428293B69662865213D3D74297B7426266B742874292E72656D6F76652870792E524553554C545F53454C';
wwv_flow_imp.g_varchar2_table(42904) := '45435445445F434C415353293B766172206E3D537428652C70792E524553554C545F49445F415454524942555445292C693D746869732E5F726573756C74735B6E5D2E656C656D656E743B6B742865292E6164642870792E524553554C545F53454C4543';
wwv_flow_imp.g_varchar2_table(42905) := '5445445F434C415353292C746869732E5F72657365744F7665726C61792869292C746869732E5F63616E7661732E7363726F6C6C546F456C656D656E7428692C7B746F703A3430307D292C746869732E5F73656C656374696F6E2E73656C656374286929';
wwv_flow_imp.g_varchar2_table(42906) := '2C746869732E5F6576656E744275732E6669726528227365617263685061642E70726573656C6563746564222C69297D7D2C70792E70726F746F747970652E5F73656C6563743D66756E6374696F6E2865297B76617220743D537428652C70792E524553';
wwv_flow_imp.g_varchar2_table(42907) := '554C545F49445F415454524942555445292C6E3D746869732E5F726573756C74735B745D2E656C656D656E743B746869732E636C6F736528292C746869732E5F72657365744F7665726C617928292C746869732E5F63616E7661732E7363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(42908) := '456C656D656E74286E2C7B746F703A3430307D292C746869732E5F73656C656374696F6E2E73656C656374286E292C746869732E5F6576656E744275732E6669726528227365617263685061642E73656C6563746564222C6E297D2C70792E70726F746F';
wwv_flow_imp.g_varchar2_table(42909) := '747970652E5F72657365744F7665726C61793D66756E6374696F6E2865297B696628746869732E5F6F7665726C617949642626746869732E5F6F7665726C6179732E72656D6F766528746869732E5F6F7665726C61794964292C65297B76617220743D66';
wwv_flow_imp.g_varchar2_table(42910) := '756E6374696F6E2865297B76617220743D652E77696474682B31322C6E3D652E6865696768742B31322C693D7B77696474683A742B227078222C6865696768743A6E2B227078227D2C6F3D487428273C64697620636C6173733D22272B70792E4F564552';
wwv_flow_imp.g_varchar2_table(42911) := '4C41595F434C4153532B27223E3C2F6469763E27293B72657475726E204374286F2C69292C7B706F736974696F6E3A7B626F74746F6D3A6E2D362C72696768743A742D367D2C73686F773A21302C68746D6C3A6F7D7D286374286529293B746869732E5F';
wwv_flow_imp.g_varchar2_table(42912) := '6F7665726C617949643D746869732E5F6F7665726C6179732E61646428652C74297D7D2C70792E70726F746F747970652E5F676574426F7848746D6C3D66756E6374696F6E28297B636F6E737420653D48742870792E424F585F48544D4C292C743D6A74';
wwv_flow_imp.g_varchar2_table(42913) := '2870792E494E5055545F53454C4543544F522C65293B72657475726E20742626742E7365744174747269627574652822617269612D6C6162656C222C746869732E5F7472616E736C617465282253656172636820696E206469616772616D2229292C657D';
wwv_flow_imp.g_varchar2_table(42914) := '2C70792E434F4E5441494E45525F53454C4543544F523D222E646A732D7365617263682D636F6E7461696E6572222C70792E494E5055545F53454C4543544F523D222E646A732D7365617263682D696E70757420696E707574222C70792E524553554C54';
wwv_flow_imp.g_varchar2_table(42915) := '535F434F4E5441494E45525F53454C4543544F523D222E646A732D7365617263682D726573756C7473222C70792E524553554C545F53454C4543544F523D222E646A732D7365617263682D726573756C74222C70792E524553554C545F53454C45435445';
wwv_flow_imp.g_varchar2_table(42916) := '445F434C4153533D22646A732D7365617263682D726573756C742D73656C6563746564222C70792E524553554C545F53454C45435445445F53454C4543544F523D222E222B70792E524553554C545F53454C45435445445F434C4153532C70792E524553';
wwv_flow_imp.g_varchar2_table(42917) := '554C545F49445F4154545249425554453D22646174612D726573756C742D6964222C70792E524553554C545F484947484C494748545F434C4153533D22646A732D7365617263682D686967686C69676874222C70792E4F5645524C41595F434C4153533D';
wwv_flow_imp.g_varchar2_table(42918) := '22646A732D7365617263682D6F7665726C6179222C70792E424F585F48544D4C3D273C64697620636C6173733D22646A732D7365617263682D636F6E7461696E657220646A732D647261676761626C6520646A732D7363726F6C6C61626C65223E3C6469';
wwv_flow_imp.g_varchar2_table(42919) := '7620636C6173733D22646A732D7365617263682D696E707574223E3C696E70757420747970653D2274657874222F3E3C2F6469763E3C64697620636C6173733D22646A732D7365617263682D726573756C7473223E3C2F6469763E3C2F6469763E272C70';
wwv_flow_imp.g_varchar2_table(42920) := '792E524553554C545F48544D4C3D273C64697620636C6173733D22646A732D7365617263682D726573756C74223E3C2F6469763E272C70792E524553554C545F5052494D4152595F48544D4C3D273C64697620636C6173733D22646A732D736561726368';
wwv_flow_imp.g_varchar2_table(42921) := '2D726573756C742D7072696D617279223E3C2F6469763E272C70792E524553554C545F5345434F4E444152595F48544D4C3D273C7020636C6173733D22646A732D7365617263682D726573756C742D7365636F6E64617279223E3C2F703E273B636F6E73';
wwv_flow_imp.g_varchar2_table(42922) := '74206D793D7B5F5F646570656E64735F5F3A5B56732C5A732C24725D2C7365617263685061643A5B2274797065222C70795D7D3B66756E6374696F6E20667928652C742C6E297B746869732E5F656C656D656E7452656769737472793D652C746869732E';
wwv_flow_imp.g_varchar2_table(42923) := '5F63616E7661733D6E2C742E726567697374657250726F76696465722874686973297D66756E6374696F6E2076792865297B72657475726E28302C692E70622928652C2866756E6374696F6E2865297B72657475726E2121652E6D6174636865647D2929';
wwv_flow_imp.g_varchar2_table(42924) := '2E6C656E6774683E307D66756E6374696F6E20627928652C74297B766172206E3D5B5D2C693D653B69662821652972657475726E206E3B653D652E746F4C6F7765724361736528292C743D742E746F4C6F7765724361736528293B766172206F3D652E69';
wwv_flow_imp.g_varchar2_table(42925) := '6E6465784F662874293B72657475726E206F3E2D313F2830213D3D6F26266E2E70757368287B6E6F726D616C3A692E73756273747228302C6F297D292C6E2E70757368287B6D6174636865643A692E737562737472286F2C742E6C656E677468297D292C';
wwv_flow_imp.g_varchar2_table(42926) := '742E6C656E6774682B6F3C652E6C656E67746826266E2E70757368287B6E6F726D616C3A692E73756273747228742E6C656E6774682B6F2C652E6C656E677468297D29293A6E2E70757368287B6E6F726D616C3A697D292C6E7D66792E24696E6A656374';
wwv_flow_imp.g_varchar2_table(42927) := '3D5B22656C656D656E745265676973747279222C22736561726368506164222C2263616E766173225D2C66792E70726F746F747970652E66696E643D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732E676574526F6F74456C';
wwv_flow_imp.g_varchar2_table(42928) := '656D656E747328292C6E3D746869732E5F656C656D656E7452656769737472792E66696C746572282866756E6374696F6E2865297B72657475726E21652E6C6162656C5461726765747D29293B72657475726E206E3D28302C692E706229286E2C286675';
wwv_flow_imp.g_varchar2_table(42929) := '6E6374696F6E2865297B72657475726E21742E696E636C756465732865297D29292C6E3D28302C692E546A29286E2C2866756E6374696F6E2874297B72657475726E7B7072696D617279546F6B656E733A62792870732874292C65292C7365636F6E6461';
wwv_flow_imp.g_varchar2_table(42930) := '7279546F6B656E733A627928742E69642C65292C656C656D656E743A747D7D29292C6E3D28302C692E706229286E2C2866756E6374696F6E2865297B72657475726E20767928652E7072696D617279546F6B656E73297C7C767928652E7365636F6E6461';
wwv_flow_imp.g_varchar2_table(42931) := '7279546F6B656E73297D29292C28302C692E556C29286E2C2866756E6374696F6E2865297B72657475726E20707328652E656C656D656E74292B652E656C656D656E742E69647D29297D3B636F6E7374205F793D7B5F5F646570656E64735F5F3A5B6D79';
wwv_flow_imp.g_varchar2_table(42932) := '5D2C5F5F696E69745F5F3A5B2262706D6E536561726368225D2C62706D6E5365617263683A5B2274797065222C66795D7D3B66756E6374696F6E2079792865297B73732E63616C6C28746869732C65297D522879792C7373292C79792E5669657765723D';
wwv_flow_imp.g_varchar2_table(42933) := '55722C79792E4E61766967617465645669657765723D45612C79792E70726F746F747970652E6372656174654469616772616D3D66756E6374696F6E28297B72657475726E20746869732E696D706F7274584D4C28273C3F786D6C2076657273696F6E3D';
wwv_flow_imp.g_varchar2_table(42934) := '22312E302220656E636F64696E673D225554462D38223F3E3C62706D6E3A646566696E6974696F6E7320786D6C6E733A7873693D22687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E63652220786D6C6E';
wwv_flow_imp.g_varchar2_table(42935) := '733A62706D6E3D22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4D4F44454C2220786D6C6E733A62706D6E64693D22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130';
wwv_flow_imp.g_varchar2_table(42936) := '303532342F44492220786D6C6E733A64633D22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F444322207461726765744E616D6573706163653D22687474703A2F2F62706D6E2E696F2F736368656D612F6270';
wwv_flow_imp.g_varchar2_table(42937) := '6D6E222069643D22446566696E6974696F6E735F31223E3C62706D6E3A70726F636573732069643D2250726F636573735F312220697345786563757461626C653D2266616C7365223E3C62706D6E3A73746172744576656E742069643D22537461727445';
wwv_flow_imp.g_varchar2_table(42938) := '76656E745F31222F3E3C2F62706D6E3A70726F636573733E3C62706D6E64693A42504D4E4469616772616D2069643D2242504D4E4469616772616D5F31223E3C62706D6E64693A42504D4E506C616E652069643D2242504D4E506C616E655F3122206270';
wwv_flow_imp.g_varchar2_table(42939) := '6D6E456C656D656E743D2250726F636573735F31223E3C62706D6E64693A42504D4E53686170652069643D225F42504D4E53686170655F53746172744576656E745F32222062706D6E456C656D656E743D2253746172744576656E745F31223E3C64633A';
wwv_flow_imp.g_varchar2_table(42940) := '426F756E6473206865696768743D2233362E30222077696474683D2233362E302220783D223137332E302220793D223130322E30222F3E3C2F62706D6E64693A42504D4E53686170653E3C2F62706D6E64693A42504D4E506C616E653E3C2F62706D6E64';
wwv_flow_imp.g_varchar2_table(42941) := '693A42504D4E4469616772616D3E3C2F62706D6E3A646566696E6974696F6E733E27297D2C79792E70726F746F747970652E5F696E746572616374696F6E4D6F64756C65733D5B64612C5F612C6B615D2C79792E70726F746F747970652E5F6D6F64656C';
wwv_flow_imp.g_varchar2_table(42942) := '696E674D6F64756C65733D5B6D632C4D632C24632C52632C48642C4B642C51642C6E622C6B672C70672C64622C66622C49622C41622C50622C57622C735F2C63762C705F2C435F2C555F2C475F2C58622C75792C5F795D2C79792E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(42943) := '2E5F6D6F64756C65733D5B5D2E636F6E6361742855722E70726F746F747970652E5F6D6F64756C65732C79792E70726F746F747970652E5F696E746572616374696F6E4D6F64756C65732C79792E70726F746F747970652E5F6D6F64656C696E674D6F64';
wwv_flow_imp.g_varchar2_table(42944) := '756C6573293B7661722077793D6F28323037292C43793D6F2E6E287779292C53793D6F2836353939292C78793D6F2E6E285379292C6B793D6F2835323839292C45793D6F2E6E286B79292C4C793D6F2832333432292C44793D6F2E6E284C79292C54793D';
wwv_flow_imp.g_varchar2_table(42945) := '6F2833313537292C49793D6F2E6E285479292C4D793D6F2838323434292C41793D6F2E6E284D79292C4E793D6F2839373737292C50793D6F2E6E284E79292C4F793D6F28313838292C52793D6F2E6E284F79292C46793D6F2835393234292C42793D6F2E';
wwv_flow_imp.g_varchar2_table(42946) := '6E284679292C56793D6F28373134292C7A793D6F2E6E285679292C48793D6F2832373031292C57793D6F2E6E284879292C6A793D6F2839343336292C71793D6F2E6E286A79292C24793D6F2833363533292C55793D6F2E6E282479292C4B793D6F283937';
wwv_flow_imp.g_varchar2_table(42947) := '3034292C47793D6F2E6E284B79292C51793D6F2832343338292C59793D6F2E6E285179292C5A793D6F2834333136292C58793D6F2E6E285A79292C4A793D6F2831363630292C65773D6F2E6E284A79292C74773D6F2831353736292C6E773D6F2E6E2874';
wwv_flow_imp.g_varchar2_table(42948) := '77292C69773D6F2839383731292C6F773D6F2E6E286977292C73773D6F2832393931292C72773D6F2E6E287377292C61773D6F2831333832292C6C773D6F2E6E286177292C63773D6F2831353934292C64773D6F2E6E286377292C68773D6F2836353237';
wwv_flow_imp.g_varchar2_table(42949) := '292C75773D6F2E6E286877292C70773D6F2831393935292C67773D6F2E6E287077292C6D773D6F2839333434292C66773D6F2E6E286D77293B636F6E73742076773D7B7D3B66756E6374696F6E20627728297B7D62772E70726F746F747970652E726573';
wwv_flow_imp.g_varchar2_table(42950) := '6F6C766552756C653D66756E6374696F6E28652C74297B636F6E7374206E3D76775B652B222F222B745D3B696628216E297468726F77206E6577204572726F72282263616E6E6F74207265736F6C76652072756C65203C222B652B222F222B742B223E3A';
wwv_flow_imp.g_varchar2_table(42951) := '206E6F742062756E646C656422293B72657475726E206E7D2C62772E70726F746F747970652E7265736F6C7665436F6E6669673D66756E6374696F6E28652C74297B7468726F77206E6577204572726F72282263616E6E6F74207265736F6C766520636F';
wwv_flow_imp.g_varchar2_table(42952) := '6E666967203C222B742B223E20696E203C222B652B223E3A206E6F742062756E646C656422297D3B636F6E7374205F773D7B7265736F6C7665723A6E65772062772C636F6E6669673A7B72756C65733A7B22636F6E646974696F6E616C2D666C6F777322';
wwv_flow_imp.g_varchar2_table(42953) := '3A302C22656E642D6576656E742D7265717569726564223A226572726F72222C226576656E742D7375622D70726F636573732D74797065642D73746172742D6576656E74223A226572726F72222C2266616B652D6A6F696E223A227761726E222C676C6F';
wwv_flow_imp.g_varchar2_table(42954) := '62616C3A227761726E222C226C6162656C2D7265717569726564223A227761726E222C226C696E6B2D6576656E74223A226572726F72222C226E6F2D62706D6E6469223A226572726F72222C226E6F2D636F6D706C65782D67617465776179223A226572';
wwv_flow_imp.g_varchar2_table(42955) := '726F72222C226E6F2D646973636F6E6E6563746564223A226572726F72222C226E6F2D6475706C69636174652D73657175656E63652D666C6F7773223A226572726F72222C226E6F2D676174657761792D6A6F696E2D666F726B223A302C226E6F2D696D';
wwv_flow_imp.g_varchar2_table(42956) := '706C696369742D73706C6974223A226572726F72222C226E6F2D696D706C696369742D656E64223A226572726F72222C226E6F2D696D706C696369742D7374617274223A226572726F72222C226E6F2D696E636C75736976652D67617465776179223A30';
wwv_flow_imp.g_varchar2_table(42957) := '2C226E6F2D6F7665726C617070696E672D656C656D656E7473223A227761726E222C2273696E676C652D626C616E6B2D73746172742D6576656E74223A226572726F72222C2273696E676C652D6576656E742D646566696E6974696F6E223A226572726F';
wwv_flow_imp.g_varchar2_table(42958) := '72222C2273746172742D6576656E742D7265717569726564223A226572726F72222C227375622D70726F636573732D626C616E6B2D73746172742D6576656E74223A226572726F72222C227375706572666C756F75732D67617465776179223A22776172';
wwv_flow_imp.g_varchar2_table(42959) := '6E222C227375706572666C756F75732D7465726D696E6174696F6E223A227761726E222C22617065782F6D61782D69642D6C656E677468223A226572726F72222C22617065782F6D657267652D73706C69742D6761746577617973223A227761726E222C';
wwv_flow_imp.g_varchar2_table(42960) := '22617065782F73746172742D6576656E7473223A227761726E222C22617065782F636F6E646974696F6E616C2D73657175656E63652D666C6F7773223A227761726E222C22617065782F697465726174696F6E732D6C6F6F70223A227761726E227D7D7D';
wwv_flow_imp.g_varchar2_table(42961) := '3B76775B2262706D6E6C696E742F656E642D6576656E742D7265717569726564225D3D437928292C76775B2262706D6E6C696E742F6576656E742D7375622D70726F636573732D74797065642D73746172742D6576656E74225D3D787928292C76775B22';
wwv_flow_imp.g_varchar2_table(42962) := '62706D6E6C696E742F66616B652D6A6F696E225D3D457928292C76775B2262706D6E6C696E742F676C6F62616C225D3D447928292C76775B2262706D6E6C696E742F6C6162656C2D7265717569726564225D3D497928292C76775B2262706D6E6C696E74';
wwv_flow_imp.g_varchar2_table(42963) := '2F6C696E6B2D6576656E74225D3D417928292C76775B2262706D6E6C696E742F6E6F2D62706D6E6469225D3D507928292C76775B2262706D6E6C696E742F6E6F2D636F6D706C65782D67617465776179225D3D527928292C76775B2262706D6E6C696E74';
wwv_flow_imp.g_varchar2_table(42964) := '2F6E6F2D646973636F6E6E6563746564225D3D427928292C76775B2262706D6E6C696E742F6E6F2D6475706C69636174652D73657175656E63652D666C6F7773225D3D7A7928292C76775B2262706D6E6C696E742F6E6F2D696D706C696369742D73706C';
wwv_flow_imp.g_varchar2_table(42965) := '6974225D3D577928292C76775B2262706D6E6C696E742F6E6F2D696D706C696369742D656E64225D3D717928292C76775B2262706D6E6C696E742F6E6F2D696D706C696369742D7374617274225D3D557928292C76775B2262706D6E6C696E742F6E6F2D';
wwv_flow_imp.g_varchar2_table(42966) := '6F7665726C617070696E672D656C656D656E7473225D3D477928292C76775B2262706D6E6C696E742F73696E676C652D626C616E6B2D73746172742D6576656E74225D3D597928292C76775B2262706D6E6C696E742F73696E676C652D6576656E742D64';
wwv_flow_imp.g_varchar2_table(42967) := '6566696E6974696F6E225D3D587928292C76775B2262706D6E6C696E742F73746172742D6576656E742D7265717569726564225D3D657728292C76775B2262706D6E6C696E742F7375622D70726F636573732D626C616E6B2D73746172742D6576656E74';
wwv_flow_imp.g_varchar2_table(42968) := '225D3D6E7728292C76775B2262706D6E6C696E742F7375706572666C756F75732D67617465776179225D3D6F7728292C76775B2262706D6E6C696E742F7375706572666C756F75732D7465726D696E6174696F6E225D3D727728292C76775B2262706D6E';
wwv_flow_imp.g_varchar2_table(42969) := '6C696E742D706C7567696E2D617065782F6D61782D69642D6C656E677468225D3D6C7728292C76775B2262706D6E6C696E742D706C7567696E2D617065782F6D657267652D73706C69742D6761746577617973225D3D647728292C76775B2262706D6E6C';
wwv_flow_imp.g_varchar2_table(42970) := '696E742D706C7567696E2D617065782F73746172742D6576656E7473225D3D757728292C76775B2262706D6E6C696E742D706C7567696E2D617065782F636F6E646974696F6E616C2D73657175656E63652D666C6F7773225D3D677728292C76775B2262';
wwv_flow_imp.g_varchar2_table(42971) := '706D6E6C696E742D706C7567696E2D617065782F697465726174696F6E732D6C6F6F70225D3D667728293B636F6E73742079773D4A534F4E2E706172736528277B226E616D65223A2241504558222C22707265666978223A2261706578222C2275726922';
wwv_flow_imp.g_varchar2_table(42972) := '3A2268747470733A2F2F666C6F7773666F72617065782E6F7267222C22786D6C223A7B22746167416C696173223A226C6F77657243617365227D2C226173736F63696174696F6E73223A5B5D2C227479706573223A5B7B226E616D65223A2250726F6365';
wwv_flow_imp.g_varchar2_table(42973) := '737341747472696275746573222C22657874656E6473223A5B2262706D6E3A50726F63657373225D2C2270726F70657274696573223A5B7B226E616D65223A22697343616C6C61626C65222C22697341747472223A747275652C2274797065223A225374';
wwv_flow_imp.g_varchar2_table(42974) := '72696E67227D2C7B226E616D65223A226973537461727461626C65222C22697341747472223A747275652C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224261636B67726F756E645461736B53657373696F6E222C22657874656E';
wwv_flow_imp.g_varchar2_table(42975) := '6473223A5B2262706D6E3A50726F63657373225D2C2270726F70657274696573223A5B7B226E616D65223A226D616E75616C496E707574222C22697341747472223A747275652C2274797065223A22537472696E67227D2C7B226E616D65223A22617070';
wwv_flow_imp.g_varchar2_table(42976) := '6C69636174696F6E4964222C22697341747472223A747275652C2274797065223A22537472696E67227D2C7B226E616D65223A22706167654964222C22697341747472223A747275652C2274797065223A22537472696E67227D2C7B226E616D65223A22';
wwv_flow_imp.g_varchar2_table(42977) := '757365726E616D65222C22697341747472223A747275652C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A225461736B41747472696275746573222C22657874656E6473223A5B2262706D6E3A5461736B225D2C2270726F70657274';
wwv_flow_imp.g_varchar2_table(42978) := '696573223A5B7B226E616D65223A2274797065222C22697341747472223A747275652C2274797065223A22537472696E67227D2C7B226E616D65223A226D616E75616C496E707574222C22697341747472223A747275652C2274797065223A2253747269';
wwv_flow_imp.g_varchar2_table(42979) := '6E67227D5D7D2C7B226E616D65223A224576656E7441747472696275746573222C22657874656E6473223A5B2262706D6E3A4576656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2274797065222C22697341747472223A74727565';
wwv_flow_imp.g_varchar2_table(42980) := '2C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A2243616C6C416374697669747941747472696275746573222C22657874656E6473223A5B2262706D6E3A43616C6C4163746976697479225D2C2270726F70657274696573223A5B7B';
wwv_flow_imp.g_varchar2_table(42981) := '226E616D65223A226D616E75616C496E707574222C22697341747472223A747275652C2274797065223A22537472696E67227D2C7B226E616D65223A2263616C6C65644469616772616D222C22697341747472223A747275652C2274797065223A225374';
wwv_flow_imp.g_varchar2_table(42982) := '72696E67227D2C7B226E616D65223A2263616C6C65644469616772616D56657273696F6E53656C656374696F6E222C22697341747472223A747275652C2274797065223A22537472696E67227D2C7B226E616D65223A2263616C6C65644469616772616D';
wwv_flow_imp.g_varchar2_table(42983) := '56657273696F6E222C22697341747472223A747275652C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224170657850616765222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B';
wwv_flow_imp.g_varchar2_table(42984) := '7B226E616D65223A226170706C69636174696F6E4964222C2274797065223A22537472696E67227D2C7B226E616D65223A22706167654964222C2274797065223A22537472696E67227D2C7B226E616D65223A2272657175657374222C2274797065223A';
wwv_flow_imp.g_varchar2_table(42985) := '22537472696E67227D2C7B226E616D65223A226361636865222C2274797065223A22537472696E67227D2C7B226E616D65223A22706167654974656D73222C2274797065223A22506167654974656D73227D5D7D2C7B226E616D65223A22417065784170';
wwv_flow_imp.g_varchar2_table(42986) := '70726F76616C222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A226170706C69636174696F6E4964222C2274797065223A22537472696E67227D2C7B226E616D65223A22746173';
wwv_flow_imp.g_varchar2_table(42987) := '6B5374617469634964222C2274797065223A22537472696E67227D2C7B226E616D65223A227375626A656374222C2274797065223A22537472696E67227D2C7B226E616D65223A22627573696E657373526566222C2274797065223A22537472696E6722';
wwv_flow_imp.g_varchar2_table(42988) := '7D2C7B226E616D65223A22706172616D6574657273222C2274797065223A22506172616D6574657273227D2C7B226E616D65223A22726573756C745661726961626C65222C2274797065223A22537472696E67227D2C7B226E616D65223A22696E697469';
wwv_flow_imp.g_varchar2_table(42989) := '61746F72222C2274797065223A22537472696E67227D2C7B226E616D65223A227072696F72697479222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224170657853696D706C65466F726D222C227375706572436C617373223A5B';
wwv_flow_imp.g_varchar2_table(42990) := '22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A226170706C69636174696F6E4964222C2274797065223A22537472696E67227D2C7B226E616D65223A22706167654964222C2274797065223A22537472696E67227D2C';
wwv_flow_imp.g_varchar2_table(42991) := '7B226E616D65223A226974656D4E616D65222C2274797065223A22537472696E67227D2C7B226E616D65223A22706167654974656D73222C2274797065223A22506167654974656D73227D2C7B226E616D65223A22666F726D54656D706C617465497465';
wwv_flow_imp.g_varchar2_table(42992) := '6D222C2274797065223A22537472696E67227D2C7B226E616D65223A22666F726D54656D706C6174654964222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22506172616D6574657273222C227375706572436C617373223A5B22';
wwv_flow_imp.g_varchar2_table(42993) := '456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A22706172616D65746572222C2274797065223A22506172616D65746572222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A22506172616D65746572222C';
wwv_flow_imp.g_varchar2_table(42994) := '227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A227061725374617469634964222C2274797065223A22537472696E67227D2C7B226E616D65223A227061724461746154797065222C';
wwv_flow_imp.g_varchar2_table(42995) := '2274797065223A22537472696E67227D2C7B226E616D65223A2270617256616C7565222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22506167654974656D73222C227375706572436C617373223A5B22456C656D656E74225D2C';
wwv_flow_imp.g_varchar2_table(42996) := '2270726F70657274696573223A5B7B226E616D65223A22706167654974656D222C2274797065223A22506167654974656D222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A22506167654974656D222C227375706572436C617373223A';
wwv_flow_imp.g_varchar2_table(42997) := '5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A226974656D4E616D65222C2274797065223A22537472696E67227D2C7B226E616D65223A226974656D56616C7565222C2274797065223A22537472696E67227D5D7D';
wwv_flow_imp.g_varchar2_table(42998) := '2C7B226E616D65223A2245786563757465506C73716C222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A22656E67696E65222C2274797065223A22537472696E67227D2C7B226E';
wwv_flow_imp.g_varchar2_table(42999) := '616D65223A22706C73716C436F6465222C2274797065223A22537472696E67227D2C7B226E616D65223A226175746F42696E6473222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A2253656E644D61696C222C227375706572436C';
wwv_flow_imp.g_varchar2_table(43000) := '617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A22656D61696C46726F6D222C2274797065223A22537472696E67227D2C7B226E616D65223A22656D61696C546F222C2274797065223A22537472696E67';
wwv_flow_imp.g_varchar2_table(43001) := '227D2C7B226E616D65223A22656D61696C4343222C2274797065223A22537472696E67227D2C7B226E616D65223A22656D61696C424343222C2274797065223A22537472696E67227D2C7B226E616D65223A22656D61696C5265706C79546F222C227479';
wwv_flow_imp.g_varchar2_table(43002) := '7065223A22537472696E67227D2C7B226E616D65223A2275736554656D706C617465222C2274797065223A22537472696E67227D2C7B226E616D65223A226170706C69636174696F6E4964222C2274797065223A22537472696E67227D2C7B226E616D65';
wwv_flow_imp.g_varchar2_table(43003) := '223A2274656D706C6174654964222C2274797065223A22537472696E67227D2C7B226E616D65223A22706C616365686F6C646572222C2274797065223A22537472696E67227D2C7B226E616D65223A227375626A656374222C2274797065223A22537472';
wwv_flow_imp.g_varchar2_table(43004) := '696E67227D2C7B226E616D65223A22626F647954657874222C2274797065223A22537472696E67227D2C7B226E616D65223A22626F647948544D4C222C2274797065223A22537472696E67227D2C7B226E616D65223A226174746163686D656E74222C22';
wwv_flow_imp.g_varchar2_table(43005) := '74797065223A22537472696E67227D2C7B226E616D65223A22696D6D6564696174656C79222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22617065785465726D696E6174696F6E4576656E74222C22657874656E6473223A5B22';
wwv_flow_imp.g_varchar2_table(43006) := '62706D6E3A5465726D696E6174654576656E74446566696E6974696F6E225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F63657373537461747573222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A225072';
wwv_flow_imp.g_varchar2_table(43007) := '6F636573735661726961626C65222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2276617253657175656E6365222C2274797065223A22537472696E67227D2C7B226E616D6522';
wwv_flow_imp.g_varchar2_table(43008) := '3A227661724E616D65222C2274797065223A22537472696E67227D2C7B226E616D65223A227661724461746154797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2276617245787072657373696F6E54797065222C2274797065';
wwv_flow_imp.g_varchar2_table(43009) := '223A22537472696E67227D2C7B226E616D65223A2276617245787072657373696F6E222C2274797065223A22537472696E67227D2C7B226E616D65223A227661724465736372697074696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E';
wwv_flow_imp.g_varchar2_table(43010) := '616D65223A224265666F72655461736B222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F6356617273222C2274797065223A2250726F636573735661726961626C6522';
wwv_flow_imp.g_varchar2_table(43011) := '2C2269734D616E79223A747275657D5D7D2C7B226E616D65223A2241667465725461736B222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F6356617273222C22747970';
wwv_flow_imp.g_varchar2_table(43012) := '65223A2250726F636573735661726961626C65222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A2241667465724D65726765222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B22';
wwv_flow_imp.g_varchar2_table(43013) := '6E616D65223A2270726F6356617273222C2274797065223A2250726F636573735661726961626C65222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A224265666F726553706C6974222C227375706572436C617373223A5B22456C656D';
wwv_flow_imp.g_varchar2_table(43014) := '656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F6356617273222C2274797065223A2250726F636573735661726961626C65222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A224265666F72654576656E';
wwv_flow_imp.g_varchar2_table(43015) := '74222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F6356617273222C2274797065223A2250726F636573735661726961626C65222C2269734D616E79223A747275657D';
wwv_flow_imp.g_varchar2_table(43016) := '5D7D2C7B226E616D65223A22496E5661726961626C6573222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F6356617273222C2274797065223A2250726F636573735661';
wwv_flow_imp.g_varchar2_table(43017) := '726961626C65222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A224F75745661726961626C6573222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2270726F63';
wwv_flow_imp.g_varchar2_table(43018) := '56617273222C2274797065223A2250726F636573735661726961626C65222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A224F6E4576656E74222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F7065727469';
wwv_flow_imp.g_varchar2_table(43019) := '6573223A5B7B226E616D65223A2270726F6356617273222C2274797065223A2250726F636573735661726961626C65222C2269734D616E79223A747275657D5D7D2C7B226E616D65223A224F7261636C654576656E74446566696E6974696F6E222C2265';
wwv_flow_imp.g_varchar2_table(43020) := '7874656E6473223A5B2262706D6E3A54696D65724576656E74446566696E6974696F6E225D2C2270726F70657274696573223A5B7B226E616D65223A2274696D657254797065222C22697341747472223A747275652C2274797065223A22537472696E67';
wwv_flow_imp.g_varchar2_table(43021) := '227D5D7D2C7B226E616D65223A224F7261636C6544617465222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2264617465222C2274797065223A22537472696E67227D2C7B226E';
wwv_flow_imp.g_varchar2_table(43022) := '616D65223A22666F726D61744D61736B222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224F7261636C654475726174696F6E222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A';
wwv_flow_imp.g_varchar2_table(43023) := '5B7B226E616D65223A22696E74657276616C594D222C2274797065223A22537472696E67227D2C7B226E616D65223A22696E74657276616C4453222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224F7261636C654379636C6522';
wwv_flow_imp.g_varchar2_table(43024) := '2C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A227374617274496E74657276616C4453222C2274797065223A22537472696E67227D2C7B226E616D65223A22726570656174496E';
wwv_flow_imp.g_varchar2_table(43025) := '74657276616C4453222C2274797065223A22537472696E67227D2C7B226E616D65223A226D617852756E73222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A2253657175656E6365466C6F77222C22657874656E6473223A5B2262';
wwv_flow_imp.g_varchar2_table(43026) := '706D6E3A53657175656E6365466C6F77225D2C2270726F70657274696573223A5B7B226E616D65223A2273657175656E6365222C22697341747472223A747275652C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22506F74656E74';
wwv_flow_imp.g_varchar2_table(43027) := '69616C5573657273222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A22';
wwv_flow_imp.g_varchar2_table(43028) := '65787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22506F74656E7469616C47726F757073222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E61';
wwv_flow_imp.g_varchar2_table(43029) := '6D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224578636C756465645573657273';
wwv_flow_imp.g_varchar2_table(43030) := '222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A226578707265737369';
wwv_flow_imp.g_varchar2_table(43031) := '6F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22506F74656E7469616C5374617274696E675573657273222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D';
wwv_flow_imp.g_varchar2_table(43032) := '65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22506F74656E7469616C5374617274';
wwv_flow_imp.g_varchar2_table(43033) := '696E6747726F757073222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A';
wwv_flow_imp.g_varchar2_table(43034) := '2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224578636C756465645374617274696E675573657273222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573';
wwv_flow_imp.g_varchar2_table(43035) := '223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A225072696F7269';
wwv_flow_imp.g_varchar2_table(43036) := '7479222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A22657870726573';
wwv_flow_imp.g_varchar2_table(43037) := '73696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224475654F6E222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54';
wwv_flow_imp.g_varchar2_table(43038) := '797065222C2274797065223A22537472696E67227D2C7B226E616D65223A22666F726D61744D61736B222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C';
wwv_flow_imp.g_varchar2_table(43039) := '7B226E616D65223A224C616E6541747472696275746573222C22657874656E6473223A5B2262706D6E3A4C616E65225D2C2270726F70657274696573223A5B7B226E616D65223A226973526F6C65222C22697341747472223A747275652C227479706522';
wwv_flow_imp.g_varchar2_table(43040) := '3A22537472696E67227D2C7B226E616D65223A22726F6C65222C22697341747472223A747275652C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22437573746F6D457874656E73696F6E222C227375706572436C617373223A5B22';
wwv_flow_imp.g_varchar2_table(43041) := '456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A22637573746F6D457874656E73696F6E222C2274797065223A22537472696E67222C226973426F6479223A747275657D5D7D2C7B226E616D65223A22456E64706F696E74';
wwv_flow_imp.g_varchar2_table(43042) := '222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A226578707265737369';
wwv_flow_imp.g_varchar2_table(43043) := '6F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A224D6573736167654E616D65222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373';
wwv_flow_imp.g_varchar2_table(43044) := '696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22436F7272656C6174696F6E4B6579222C227375706572436C61';
wwv_flow_imp.g_varchar2_table(43045) := '7373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A';
wwv_flow_imp.g_varchar2_table(43046) := '22537472696E67227D5D7D2C7B226E616D65223A22436F7272656C6174696F6E56616C7565222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E547970';
wwv_flow_imp.g_varchar2_table(43047) := '65222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A225061796C6F6164222C227375706572436C617373223A5B22456C656D656E74';
wwv_flow_imp.g_varchar2_table(43048) := '225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(43049) := '226E616D65223A225061796C6F61645661726961626C65222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2276616C7565222C226973426F6479223A747275652C227479706522';
wwv_flow_imp.g_varchar2_table(43050) := '3A22537472696E67227D5D7D2C7B226E616D65223A224465736372697074696F6E222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2276616C7565222C226973426F6479223A74';
wwv_flow_imp.g_varchar2_table(43051) := '7275652C2274797065223A22537472696E67227D5D7D2C7B226E616D65223A22496E707574436F6C6C656374696F6E222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A22657870';
wwv_flow_imp.g_varchar2_table(43052) := '72657373696F6E54797065222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D2C7B226E616D65223A22696E736964655661726961626C65222C2274797065223A';
wwv_flow_imp.g_varchar2_table(43053) := '22537472696E67227D5D7D2C7B226E616D65223A224F7574707574436F6C6C656374696F6E222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E547970';
wwv_flow_imp.g_varchar2_table(43054) := '65222C2274797065223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D2C7B226E616D65223A22696E736964655661726961626C65222C2274797065223A22537472696E67227D5D';
wwv_flow_imp.g_varchar2_table(43055) := '7D2C7B226E616D65223A22436F6D706C6574696F6E436F6E646974696F6E222C227375706572436C617373223A5B22456C656D656E74225D2C2270726F70657274696573223A5B7B226E616D65223A2265787072657373696F6E54797065222C22747970';
wwv_flow_imp.g_varchar2_table(43056) := '65223A22537472696E67227D2C7B226E616D65223A2265787072657373696F6E222C2274797065223A22537472696E67227D5D7D5D7D27293B66756E6374696F6E2077772865297B72657475726E204C772865292E6765742822657874656E73696F6E45';
wwv_flow_imp.g_varchar2_table(43057) := '6C656D656E747322297D66756E6374696F6E20437728652C74297B636F6E7374206E3D77772865293B72657475726E206E26266E2E76616C7565733F6E2E76616C7565732E66696C746572282866756E6374696F6E2865297B72657475726E20652E2469';
wwv_flow_imp.g_varchar2_table(43058) := '6E7374616E63654F662874297D29295B305D3A6E756C6C7D66756E6374696F6E20537728652C742C6E2C69297B636F6E7374206F3D692E63726561746528652C74293B72657475726E206E2626286F2E24706172656E743D6E292C6F7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(43059) := '6E20787728652C74297B72657475726E205377282262706D6E3A457874656E73696F6E456C656D656E7473222C7B76616C7565733A5B5D7D2C4C772865292C74297D66756E6374696F6E206B7728652C742C6E2C69297B72657475726E20537728652C74';
wwv_flow_imp.g_varchar2_table(43060) := '2C6E2C69297D66756E6374696F6E20457728652C742C6E2C69297B636F6E73747B657874656E73696F6E456C656D656E74733A6F7D3D743B6C657420732C723B6F2E676574282276616C75657322292E736F6D652828653D3E65213D3D6E29293F28733D';
wwv_flow_imp.g_varchar2_table(43061) := '6F2C723D7B76616C7565733A6F2E676574282276616C75657322292E66696C7465722828653D3E65213D3D6E29297D293A28733D742C723D7B657874656E73696F6E456C656D656E74733A766F696420307D292C692E7570646174654D6F64646C655072';
wwv_flow_imp.g_varchar2_table(43062) := '6F7065727469657328652C732C72297D66756E6374696F6E204C772865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E742229262628302C792E676574427573696E6573734F626A656374292865292E70726F63';
wwv_flow_imp.g_varchar2_table(43063) := '6573735265663F28302C792E676574427573696E6573734F626A656374292865292E70726F636573735265663A28302C792E676574427573696E6573734F626A656374292865297D7661722044772C54772C49772C4D772C41773D6F2833313034292C4E';
wwv_flow_imp.g_varchar2_table(43064) := '773D302C50773D5B5D2C4F773D5B5D2C52773D41772E66462E5F5F622C46773D41772E66462E5F5F722C42773D41772E66462E6469666665642C56773D41772E66462E5F5F632C7A773D41772E66462E756E6D6F756E743B66756E6374696F6E20487728';
wwv_flow_imp.g_varchar2_table(43065) := '652C74297B41772E66462E5F5F68262641772E66462E5F5F682854772C652C4E777C7C74292C4E773D303B766172206E3D54772E5F5F487C7C2854772E5F5F483D7B5F5F3A5B5D2C5F5F683A5B5D7D293B72657475726E20653E3D6E2E5F5F2E6C656E67';
wwv_flow_imp.g_varchar2_table(43066) := '746826266E2E5F5F2E70757368287B5F5F563A4F777D292C6E2E5F5F5B655D7D66756E6374696F6E2057772865297B72657475726E204E773D312C66756E6374696F6E28652C742C6E297B76617220693D48772844772B2B2C32293B696628692E743D65';
wwv_flow_imp.g_varchar2_table(43067) := '2C21692E5F5F63262628692E5F5F3D5B6E3F6E2874293A744328766F696420302C74292C66756E6374696F6E2865297B76617220743D692E5F5F4E3F692E5F5F4E5B305D3A692E5F5F5B305D2C6E3D692E7428742C65293B74213D3D6E262628692E5F5F';
wwv_flow_imp.g_varchar2_table(43068) := '4E3D5B6E2C692E5F5F5B315D5D2C692E5F5F632E7365745374617465287B7D29297D5D2C692E5F5F633D54772C2154772E7529297B766172206F3D66756E6374696F6E28652C742C6E297B69662821692E5F5F632E5F5F482972657475726E21303B7661';
wwv_flow_imp.g_varchar2_table(43069) := '72206F3D692E5F5F632E5F5F482E5F5F2E66696C746572282866756E6374696F6E2865297B72657475726E20652E5F5F637D29293B6966286F2E6576657279282866756E6374696F6E2865297B72657475726E21652E5F5F4E7D29292972657475726E21';
wwv_flow_imp.g_varchar2_table(43070) := '737C7C732E63616C6C28746869732C652C742C6E293B76617220723D21313B72657475726E206F2E666F7245616368282866756E6374696F6E2865297B696628652E5F5F4E297B76617220743D652E5F5F5B305D3B652E5F5F3D652E5F5F4E2C652E5F5F';
wwv_flow_imp.g_varchar2_table(43071) := '4E3D766F696420302C74213D3D652E5F5F5B305D262628723D2130297D7D29292C212821722626692E5F5F632E70726F70733D3D3D652926262821737C7C732E63616C6C28746869732C652C742C6E29297D3B54772E753D21303B76617220733D54772E';
wwv_flow_imp.g_varchar2_table(43072) := '73686F756C64436F6D706F6E656E745570646174652C723D54772E636F6D706F6E656E7457696C6C5570646174653B54772E636F6D706F6E656E7457696C6C5570646174653D66756E6374696F6E28652C742C6E297B696628746869732E5F5F65297B76';
wwv_flow_imp.g_varchar2_table(43073) := '617220693D733B733D766F696420302C6F28652C742C6E292C733D697D722626722E63616C6C28746869732C652C742C6E297D2C54772E73686F756C64436F6D706F6E656E745570646174653D6F7D72657475726E20692E5F5F4E7C7C692E5F5F7D2874';
wwv_flow_imp.g_varchar2_table(43074) := '432C65297D66756E6374696F6E206A7728652C74297B766172206E3D48772844772B2B2C33293B2141772E66462E5F5F7326266543286E2E5F5F482C74292626286E2E5F5F3D652C6E2E693D742C54772E5F5F482E5F5F682E70757368286E29297D6675';
wwv_flow_imp.g_varchar2_table(43075) := '6E6374696F6E20717728652C74297B766172206E3D48772844772B2B2C34293B2141772E66462E5F5F7326266543286E2E5F5F482C74292626286E2E5F5F3D652C6E2E693D742C54772E5F5F682E70757368286E29297D66756E6374696F6E2024772865';
wwv_flow_imp.g_varchar2_table(43076) := '297B72657475726E204E773D352C5577282866756E6374696F6E28297B72657475726E7B63757272656E743A657D7D292C5B5D297D66756E6374696F6E20557728652C74297B766172206E3D48772844772B2B2C37293B72657475726E206543286E2E5F';
wwv_flow_imp.g_varchar2_table(43077) := '5F482C74293F286E2E5F5F563D6528292C6E2E693D742C6E2E5F5F683D652C6E2E5F5F56293A6E2E5F5F7D66756E6374696F6E204B7728652C74297B72657475726E204E773D382C5577282866756E6374696F6E28297B72657475726E20657D292C7429';
wwv_flow_imp.g_varchar2_table(43078) := '7D66756E6374696F6E2047772865297B76617220743D54772E636F6E746578745B652E5F5F635D2C6E3D48772844772B2B2C39293B72657475726E206E2E633D652C743F286E756C6C3D3D6E2E5F5F2626286E2E5F5F3D21302C742E7375622854772929';
wwv_flow_imp.g_varchar2_table(43079) := '2C742E70726F70732E76616C7565293A652E5F5F7D66756E6374696F6E20517728297B666F722876617220653B653D50772E736869667428293B29696628652E5F5F502626652E5F5F48297472797B652E5F5F482E5F5F682E666F724561636828587729';
wwv_flow_imp.g_varchar2_table(43080) := '2C652E5F5F482E5F5F682E666F7245616368284A77292C652E5F5F482E5F5F683D5B5D7D63617463682874297B652E5F5F482E5F5F683D5B5D2C41772E66462E5F5F6528742C652E5F5F76297D7D41772E66462E5F5F623D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(43081) := '54773D6E756C6C2C5277262652772865297D2C41772E66462E5F5F723D66756E6374696F6E2865297B4677262646772865292C44773D303B76617220743D2854773D652E5F5F63292E5F5F483B7426262849773D3D3D54773F28742E5F5F683D5B5D2C54';
wwv_flow_imp.g_varchar2_table(43082) := '772E5F5F683D5B5D2C742E5F5F2E666F7245616368282866756E6374696F6E2865297B652E5F5F4E262628652E5F5F3D652E5F5F4E292C652E5F5F563D4F772C652E5F5F4E3D652E693D766F696420307D2929293A28742E5F5F682E666F724561636828';
wwv_flow_imp.g_varchar2_table(43083) := '5877292C742E5F5F682E666F7245616368284A77292C742E5F5F683D5B5D2C44773D3029292C49773D54777D2C41772E66462E6469666665643D66756E6374696F6E2865297B4277262642772865293B76617220743D652E5F5F633B742626742E5F5F48';
wwv_flow_imp.g_varchar2_table(43084) := '262628742E5F5F482E5F5F682E6C656E67746826262831213D3D50772E7075736828742926264D773D3D3D41772E66462E72657175657374416E696D6174696F6E4672616D657C7C28284D773D41772E66462E72657175657374416E696D6174696F6E46';
wwv_flow_imp.g_varchar2_table(43085) := '72616D65297C7C5A772928517729292C742E5F5F482E5F5F2E666F7245616368282866756E6374696F6E2865297B652E69262628652E5F5F483D652E69292C652E5F5F56213D3D4F77262628652E5F5F3D652E5F5F56292C652E693D766F696420302C65';
wwv_flow_imp.g_varchar2_table(43086) := '2E5F5F563D4F777D2929292C49773D54773D6E756C6C7D2C41772E66462E5F5F633D66756E6374696F6E28652C74297B742E736F6D65282866756E6374696F6E2865297B7472797B652E5F5F682E666F7245616368285877292C652E5F5F683D652E5F5F';
wwv_flow_imp.g_varchar2_table(43087) := '682E66696C746572282866756E6374696F6E2865297B72657475726E21652E5F5F7C7C4A772865297D29297D6361746368286E297B742E736F6D65282866756E6374696F6E2865297B652E5F5F68262628652E5F5F683D5B5D297D29292C743D5B5D2C41';
wwv_flow_imp.g_varchar2_table(43088) := '772E66462E5F5F65286E2C652E5F5F76297D7D29292C56772626567728652C74297D2C41772E66462E756E6D6F756E743D66756E6374696F6E2865297B7A7726267A772865293B76617220742C6E3D652E5F5F633B6E26266E2E5F5F482626286E2E5F5F';
wwv_flow_imp.g_varchar2_table(43089) := '482E5F5F2E666F7245616368282866756E6374696F6E2865297B7472797B58772865297D63617463682865297B743D657D7D29292C6E2E5F5F483D766F696420302C74262641772E66462E5F5F6528742C6E2E5F5F7629297D3B7661722059773D226675';
wwv_flow_imp.g_varchar2_table(43090) := '6E6374696F6E223D3D747970656F662072657175657374416E696D6174696F6E4672616D653B66756E6374696F6E205A772865297B76617220742C6E3D66756E6374696F6E28297B636C65617254696D656F75742869292C5977262663616E63656C416E';
wwv_flow_imp.g_varchar2_table(43091) := '696D6174696F6E4672616D652874292C73657454696D656F75742865297D2C693D73657454696D656F7574286E2C313030293B5977262628743D72657175657374416E696D6174696F6E4672616D65286E29297D66756E6374696F6E2058772865297B76';
wwv_flow_imp.g_varchar2_table(43092) := '617220743D54772C6E3D652E5F5F633B2266756E6374696F6E223D3D747970656F66206E262628652E5F5F633D766F696420302C6E2829292C54773D747D66756E6374696F6E204A772865297B76617220743D54773B652E5F5F633D652E5F5F28292C54';
wwv_flow_imp.g_varchar2_table(43093) := '773D747D66756E6374696F6E20654328652C74297B72657475726E21657C7C652E6C656E677468213D3D742E6C656E6774687C7C742E736F6D65282866756E6374696F6E28742C6E297B72657475726E2074213D3D655B6E5D7D29297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(43094) := '6E20744328652C74297B72657475726E2266756E6374696F6E223D3D747970656F6620743F742865293A747D66756E6374696F6E206E4328652C74297B666F7228766172206E20696E207429655B6E5D3D745B6E5D3B72657475726E20657D66756E6374';
wwv_flow_imp.g_varchar2_table(43095) := '696F6E20694328652C74297B666F7228766172206E20696E206529696628225F5F736F7572636522213D3D6E262621286E20696E2074292972657475726E21303B666F7228766172206920696E207429696628225F5F736F7572636522213D3D69262665';
wwv_flow_imp.g_varchar2_table(43096) := '5B695D213D3D745B695D2972657475726E21303B72657475726E21317D66756E6374696F6E206F432865297B746869732E70726F70733D657D286F432E70726F746F747970653D6E65772041772E7541292E6973507572655265616374436F6D706F6E65';
wwv_flow_imp.g_varchar2_table(43097) := '6E743D21302C6F432E70726F746F747970652E73686F756C64436F6D706F6E656E745570646174653D66756E6374696F6E28652C74297B72657475726E20694328746869732E70726F70732C65297C7C694328746869732E73746174652C74297D3B7661';
wwv_flow_imp.g_varchar2_table(43098) := '722073433D41772E66462E5F5F623B41772E66462E5F5F623D66756E6374696F6E2865297B652E747970652626652E747970652E5F5F662626652E726566262628652E70726F70732E7265663D652E7265662C652E7265663D6E756C6C292C7343262673';
wwv_flow_imp.g_varchar2_table(43099) := '432865297D3B7661722072433D22756E646566696E656422213D747970656F662053796D626F6C262653796D626F6C2E666F72262653796D626F6C2E666F72282272656163742E666F72776172645F72656622297C7C333931313B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(43100) := '61432865297B66756E6374696F6E20742874297B766172206E3D6E43287B7D2C74293B72657475726E2064656C657465206E2E7265662C65286E2C742E7265667C7C6E756C6C297D72657475726E20742E2424747970656F663D72432C742E72656E6465';
wwv_flow_imp.g_varchar2_table(43101) := '723D742C742E70726F746F747970652E69735265616374436F6D706F6E656E743D742E5F5F663D21302C742E646973706C61794E616D653D22466F727761726452656628222B28652E646973706C61794E616D657C7C652E6E616D65292B2229222C747D';
wwv_flow_imp.g_varchar2_table(43102) := '766172206C433D2841772E76322C41772E66462E5F5F65293B41772E66462E5F5F653D66756E6374696F6E28652C742C6E2C69297B696628652E7468656E29666F7228766172206F2C733D743B733D732E5F5F3B29696628286F3D732E5F5F632926266F';
wwv_flow_imp.g_varchar2_table(43103) := '2E5F5F632972657475726E206E756C6C3D3D742E5F5F65262628742E5F5F653D6E2E5F5F652C742E5F5F6B3D6E2E5F5F6B292C6F2E5F5F6328652C74293B6C4328652C742C6E2C69297D3B7661722063433D41772E66462E756E6D6F756E743B66756E63';
wwv_flow_imp.g_varchar2_table(43104) := '74696F6E20644328652C742C6E297B72657475726E2065262628652E5F5F632626652E5F5F632E5F5F48262628652E5F5F632E5F5F482E5F5F2E666F7245616368282866756E6374696F6E2865297B2266756E6374696F6E223D3D747970656F6620652E';
wwv_flow_imp.g_varchar2_table(43105) := '5F5F632626652E5F5F6328297D29292C652E5F5F632E5F5F483D6E756C6C292C6E756C6C213D28653D6E43287B7D2C6529292E5F5F63262628652E5F5F632E5F5F503D3D3D6E262628652E5F5F632E5F5F503D74292C652E5F5F633D6E756C6C292C652E';
wwv_flow_imp.g_varchar2_table(43106) := '5F5F6B3D652E5F5F6B2626652E5F5F6B2E6D6170282866756E6374696F6E2865297B72657475726E20644328652C742C6E297D2929292C657D66756E6374696F6E20684328652C742C6E297B72657475726E206526266E262628652E5F5F763D6E756C6C';
wwv_flow_imp.g_varchar2_table(43107) := '2C652E5F5F6B3D652E5F5F6B2626652E5F5F6B2E6D6170282866756E6374696F6E2865297B72657475726E20684328652C742C6E297D29292C652E5F5F632626652E5F5F632E5F5F503D3D3D74262628652E5F5F6526266E2E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(43108) := '28652E5F5F65292C652E5F5F632E5F5F653D21302C652E5F5F632E5F5F503D6E29292C657D66756E6374696F6E20754328297B746869732E5F5F753D302C746869732E743D6E756C6C2C746869732E5F5F623D6E756C6C7D66756E6374696F6E20704328';
wwv_flow_imp.g_varchar2_table(43109) := '65297B76617220743D652E5F5F2E5F5F633B72657475726E20742626742E5F5F612626742E5F5F612865297D66756E6374696F6E20674328297B746869732E753D6E756C6C2C746869732E6F3D6E756C6C7D41772E66462E756E6D6F756E743D66756E63';
wwv_flow_imp.g_varchar2_table(43110) := '74696F6E2865297B76617220743D652E5F5F633B742626742E5F5F522626742E5F5F5228292C742626333226652E5F5F75262628652E747970653D6E756C6C292C6343262663432865297D2C2875432E70726F746F747970653D6E65772041772E754129';
wwv_flow_imp.g_varchar2_table(43111) := '2E5F5F633D66756E6374696F6E28652C74297B766172206E3D742E5F5F632C693D746869733B6E756C6C3D3D692E74262628692E743D5B5D292C692E742E70757368286E293B766172206F3D704328692E5F5F76292C733D21312C723D66756E6374696F';
wwv_flow_imp.g_varchar2_table(43112) := '6E28297B737C7C28733D21302C6E2E5F5F523D6E756C6C2C6F3F6F2861293A612829297D3B6E2E5F5F523D723B76617220613D66756E6374696F6E28297B69662821202D2D692E5F5F75297B696628692E73746174652E5F5F61297B76617220653D692E';
wwv_flow_imp.g_varchar2_table(43113) := '73746174652E5F5F613B692E5F5F762E5F5F6B5B305D3D684328652C652E5F5F632E5F5F502C652E5F5F632E5F5F4F297D76617220743B666F7228692E7365745374617465287B5F5F613A692E5F5F623D6E756C6C7D293B743D692E742E706F7028293B';
wwv_flow_imp.g_varchar2_table(43114) := '29742E666F72636555706461746528297D7D3B692E5F5F752B2B7C7C333226742E5F5F757C7C692E7365745374617465287B5F5F613A692E5F5F623D692E5F5F762E5F5F6B5B305D7D292C652E7468656E28722C72297D2C75432E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(43115) := '2E636F6D706F6E656E7457696C6C556E6D6F756E743D66756E6374696F6E28297B746869732E743D5B5D7D2C75432E70726F746F747970652E72656E6465723D66756E6374696F6E28652C74297B696628746869732E5F5F62297B696628746869732E5F';
wwv_flow_imp.g_varchar2_table(43116) := '5F762E5F5F6B297B766172206E3D646F63756D656E742E637265617465456C656D656E74282264697622292C693D746869732E5F5F762E5F5F6B5B305D2E5F5F633B746869732E5F5F762E5F5F6B5B305D3D644328746869732E5F5F622C6E2C692E5F5F';
wwv_flow_imp.g_varchar2_table(43117) := '4F3D692E5F5F50297D746869732E5F5F623D6E756C6C7D766172206F3D742E5F5F61262628302C41772E6E292841772E464B2C6E756C6C2C652E66616C6C6261636B293B72657475726E206F2626286F2E5F5F75263D2D3333292C5B28302C41772E6E29';
wwv_flow_imp.g_varchar2_table(43118) := '2841772E464B2C6E756C6C2C742E5F5F613F6E756C6C3A652E6368696C6472656E292C6F5D7D3B766172206D433D66756E6374696F6E28652C742C6E297B6966282B2B6E5B315D3D3D3D6E5B305D2626652E6F2E64656C6574652874292C652E70726F70';
wwv_flow_imp.g_varchar2_table(43119) := '732E72657665616C4F72646572262628227422213D3D652E70726F70732E72657665616C4F726465725B305D7C7C21652E6F2E73697A652929666F72286E3D652E753B6E3B297B666F72283B6E2E6C656E6774683E333B296E2E706F70282928293B6966';
wwv_flow_imp.g_varchar2_table(43120) := '286E5B315D3C6E5B305D29627265616B3B652E753D6E3D6E5B325D7D7D3B66756E6374696F6E2066432865297B72657475726E20746869732E6765744368696C64436F6E746578743D66756E6374696F6E28297B72657475726E20652E636F6E74657874';
wwv_flow_imp.g_varchar2_table(43121) := '7D2C652E6368696C6472656E7D66756E6374696F6E2076432865297B76617220743D746869732C6E3D652E693B742E636F6D706F6E656E7457696C6C556E6D6F756E743D66756E6374696F6E28297B28302C41772E585829286E756C6C2C742E6C292C74';
wwv_flow_imp.g_varchar2_table(43122) := '2E6C3D6E756C6C2C742E693D6E756C6C7D2C742E692626742E69213D3D6E2626742E636F6D706F6E656E7457696C6C556E6D6F756E7428292C742E6C7C7C28742E693D6E2C742E6C3D7B6E6F6465547970653A312C706172656E744E6F64653A6E2C6368';
wwv_flow_imp.g_varchar2_table(43123) := '696C644E6F6465733A5B5D2C617070656E644368696C643A66756E6374696F6E2865297B746869732E6368696C644E6F6465732E707573682865292C742E692E617070656E644368696C642865297D2C696E736572744265666F72653A66756E6374696F';
wwv_flow_imp.g_varchar2_table(43124) := '6E28652C6E297B746869732E6368696C644E6F6465732E707573682865292C742E692E617070656E644368696C642865297D2C72656D6F76654368696C643A66756E6374696F6E2865297B746869732E6368696C644E6F6465732E73706C696365287468';
wwv_flow_imp.g_varchar2_table(43125) := '69732E6368696C644E6F6465732E696E6465784F662865293E3E3E312C31292C742E692E72656D6F76654368696C642865297D7D292C28302C41772E5858292828302C41772E6E292866432C7B636F6E746578743A742E636F6E746578747D2C652E5F5F';
wwv_flow_imp.g_varchar2_table(43126) := '76292C742E6C297D66756E6374696F6E20624328652C74297B766172206E3D28302C41772E6E292876432C7B5F5F763A652C693A747D293B72657475726E206E2E636F6E7461696E6572496E666F3D742C6E7D2867432E70726F746F747970653D6E6577';
wwv_flow_imp.g_varchar2_table(43127) := '2041772E7541292E5F5F613D66756E6374696F6E2865297B76617220743D746869732C6E3D704328742E5F5F76292C693D742E6F2E6765742865293B72657475726E20695B305D2B2B2C66756E6374696F6E286F297B76617220733D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(43128) := '28297B742E70726F70732E72657665616C4F726465723F28692E70757368286F292C6D4328742C652C6929293A6F28297D3B6E3F6E2873293A7328297D7D2C67432E70726F746F747970652E72656E6465723D66756E6374696F6E2865297B746869732E';
wwv_flow_imp.g_varchar2_table(43129) := '753D6E756C6C2C746869732E6F3D6E6577204D61703B76617220743D28302C41772E76322928652E6368696C6472656E293B652E72657665616C4F7264657226262262223D3D3D652E72657665616C4F726465725B305D2626742E726576657273652829';
wwv_flow_imp.g_varchar2_table(43130) := '3B666F7228766172206E3D742E6C656E6774683B6E2D2D3B29746869732E6F2E73657428745B6E5D2C746869732E753D5B312C302C746869732E755D293B72657475726E20652E6368696C6472656E7D2C67432E70726F746F747970652E636F6D706F6E';
wwv_flow_imp.g_varchar2_table(43131) := '656E744469645570646174653D67432E70726F746F747970652E636F6D706F6E656E744469644D6F756E743D66756E6374696F6E28297B76617220653D746869733B746869732E6F2E666F7245616368282866756E6374696F6E28742C6E297B6D432865';
wwv_flow_imp.g_varchar2_table(43132) := '2C6E2C74297D29297D3B766172205F433D22756E646566696E656422213D747970656F662053796D626F6C262653796D626F6C2E666F72262653796D626F6C2E666F72282272656163742E656C656D656E7422297C7C36303130332C79433D2F5E283F3A';
wwv_flow_imp.g_varchar2_table(43133) := '616363656E747C616C69676E6D656E747C6172616269637C626173656C696E657C6361707C636C6970283F215061746855297C636F6C6F727C646F6D696E616E747C66696C6C7C666C6F6F647C666F6E747C676C797068283F2152297C686F72697A7C69';
wwv_flow_imp.g_varchar2_table(43134) := '6D616765282153297C6C65747465727C6C69676874696E677C6D61726B6572283F21487C577C55297C6F7665726C696E657C7061696E747C706F696E7465727C73686170657C73746F707C737472696B657468726F7567687C7374726F6B657C74657874';
wwv_flow_imp.g_varchar2_table(43135) := '283F214C297C7472616E73666F726D7C756E6465726C696E657C756E69636F64657C756E6974737C767C766563746F727C766572747C776F72647C77726974696E677C78283F214329295B412D5A5D2F2C77433D2F5E6F6E28416E697C5472617C546F75';
wwv_flow_imp.g_varchar2_table(43136) := '7C4265666F7265496E707C436F6D706F292F2C43433D2F5B412D5A302D395D2F672C53433D22756E646566696E656422213D747970656F6620646F63756D656E742C78433D66756E6374696F6E2865297B72657475726E2822756E646566696E65642221';
wwv_flow_imp.g_varchar2_table(43137) := '3D747970656F662053796D626F6C26262273796D626F6C223D3D747970656F662053796D626F6C28293F2F66696C7C6368657C7261642F3A2F66696C7C6368657C72612F292E746573742865297D3B41772E75412E70726F746F747970652E6973526561';
wwv_flow_imp.g_varchar2_table(43138) := '6374436F6D706F6E656E743D7B7D2C5B22636F6D706F6E656E7457696C6C4D6F756E74222C22636F6D706F6E656E7457696C6C5265636569766550726F7073222C22636F6D706F6E656E7457696C6C557064617465225D2E666F7245616368282866756E';
wwv_flow_imp.g_varchar2_table(43139) := '6374696F6E2865297B4F626A6563742E646566696E6550726F70657274792841772E75412E70726F746F747970652C652C7B636F6E666967757261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20746869735B22554E53414645';
wwv_flow_imp.g_varchar2_table(43140) := '5F222B655D7D2C7365743A66756E6374696F6E2874297B4F626A6563742E646566696E6550726F706572747928746869732C652C7B636F6E666967757261626C653A21302C7772697461626C653A21302C76616C75653A747D297D7D297D29293B766172';
wwv_flow_imp.g_varchar2_table(43141) := '206B433D41772E66462E6576656E743B66756E6374696F6E20454328297B7D66756E6374696F6E204C4328297B72657475726E20746869732E63616E63656C427562626C657D66756E6374696F6E20444328297B72657475726E20746869732E64656661';
wwv_flow_imp.g_varchar2_table(43142) := '756C7450726576656E7465647D41772E66462E6576656E743D66756E6374696F6E2865297B72657475726E206B43262628653D6B43286529292C652E706572736973743D45432C652E697350726F7061676174696F6E53746F707065643D4C432C652E69';
wwv_flow_imp.g_varchar2_table(43143) := '7344656661756C7450726576656E7465643D44432C652E6E61746976654576656E743D657D3B7661722054433D7B656E756D657261626C653A21312C636F6E666967757261626C653A21302C6765743A66756E6374696F6E28297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(43144) := '69732E636C6173737D7D2C49433D41772E66462E766E6F64653B41772E66462E766E6F64653D66756E6374696F6E2865297B22737472696E67223D3D747970656F6620652E74797065262666756E6374696F6E2865297B76617220743D652E70726F7073';
wwv_flow_imp.g_varchar2_table(43145) := '2C6E3D652E747970652C693D7B7D3B666F7228766172206F20696E2074297B76617220733D745B6F5D3B69662821282276616C7565223D3D3D6F26262264656661756C7456616C756522696E207426266E756C6C3D3D737C7C53432626226368696C6472';
wwv_flow_imp.g_varchar2_table(43146) := '656E223D3D3D6F2626226E6F736372697074223D3D3D6E7C7C22636C617373223D3D3D6F7C7C22636C6173734E616D65223D3D3D6F29297B76617220723D6F2E746F4C6F7765724361736528293B2264656661756C7456616C7565223D3D3D6F26262276';
wwv_flow_imp.g_varchar2_table(43147) := '616C756522696E207426266E756C6C3D3D742E76616C75653F6F3D2276616C7565223A22646F776E6C6F6164223D3D3D6F262621303D3D3D733F733D22223A226F6E646F75626C65636C69636B223D3D3D723F6F3D226F6E64626C636C69636B223A226F';
wwv_flow_imp.g_varchar2_table(43148) := '6E6368616E676522213D3D727C7C22696E70757422213D3D6E262622746578746172656122213D3D6E7C7C784328742E74797065293F226F6E666F637573223D3D3D723F6F3D226F6E666F637573696E223A226F6E626C7572223D3D3D723F6F3D226F6E';
wwv_flow_imp.g_varchar2_table(43149) := '666F6375736F7574223A77432E74657374286F293F6F3D723A2D313D3D3D6E2E696E6465784F6628222D2229262679432E74657374286F293F6F3D6F2E7265706C6163652843432C222D242622292E746F4C6F7765724361736528293A6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(43150) := '73262628733D766F69642030293A723D6F3D226F6E696E707574222C226F6E696E707574223D3D3D722626695B6F3D725D2626286F3D226F6E696E7075744361707475726522292C695B6F5D3D737D7D2273656C656374223D3D6E2626692E6D756C7469';
wwv_flow_imp.g_varchar2_table(43151) := '706C65262641727261792E6973417272617928692E76616C756529262628692E76616C75653D28302C41772E76322928742E6368696C6472656E292E666F7245616368282866756E6374696F6E2865297B652E70726F70732E73656C65637465643D2D31';
wwv_flow_imp.g_varchar2_table(43152) := '213D692E76616C75652E696E6465784F6628652E70726F70732E76616C7565297D2929292C2273656C656374223D3D6E26266E756C6C213D692E64656661756C7456616C7565262628692E76616C75653D28302C41772E76322928742E6368696C647265';
wwv_flow_imp.g_varchar2_table(43153) := '6E292E666F7245616368282866756E6374696F6E2865297B652E70726F70732E73656C65637465643D692E6D756C7469706C653F2D31213D692E64656661756C7456616C75652E696E6465784F6628652E70726F70732E76616C7565293A692E64656661';
wwv_flow_imp.g_varchar2_table(43154) := '756C7456616C75653D3D652E70726F70732E76616C75657D2929292C742E636C617373262621742E636C6173734E616D653F28692E636C6173733D742E636C6173732C4F626A6563742E646566696E6550726F706572747928692C22636C6173734E616D';
wwv_flow_imp.g_varchar2_table(43155) := '65222C544329293A28742E636C6173734E616D65262621742E636C6173737C7C742E636C6173732626742E636C6173734E616D6529262628692E636C6173733D692E636C6173734E616D653D742E636C6173734E616D65292C652E70726F70733D697D28';
wwv_flow_imp.g_varchar2_table(43156) := '65292C652E2424747970656F663D5F432C4943262649432865297D3B766172204D433D41772E66462E5F5F723B41772E66462E5F5F723D66756E6374696F6E2865297B4D4326264D432865292C652E5F5F637D3B7661722041433D41772E66462E646966';
wwv_flow_imp.g_varchar2_table(43157) := '6665643B41772E66462E6469666665643D66756E6374696F6E2865297B4143262641432865293B76617220743D652E70726F70732C6E3D652E5F5F653B6E756C6C213D6E2626227465787461726561223D3D3D652E7479706526262276616C756522696E';
wwv_flow_imp.g_varchar2_table(43158) := '20742626742E76616C7565213D3D6E2E76616C75652626286E2E76616C75653D6E756C6C3D3D742E76616C75653F22223A742E76616C7565297D2C41772E464B3B766172204E433D41772E6E2C50433D2841772E71362C41772E5F332C41772E464B2C41';
wwv_flow_imp.g_varchar2_table(43159) := '772E75412C6F283334323129292C4F433D6F2836393432292C52433D6F2E6E284F43293B4F626A6563742E70726F746F747970652E746F537472696E672C4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B636F6E737420';
wwv_flow_imp.g_varchar2_table(43160) := '46433D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E2042432865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E7420726566657265';
wwv_flow_imp.g_varchar2_table(43161) := '6E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D42432E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E61646428';
wwv_flow_imp.g_varchar2_table(43162) := '65292C746869737D2C42432E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D223D3D46432E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A';
wwv_flow_imp.g_varchar2_table(43163) := '28746869732E6C6973742E72656D6F76652865292C74686973297D2C42432E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D30';
wwv_flow_imp.g_varchar2_table(43164) := '3B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C42432E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(43165) := '6E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C42432E70726F746F747970652E61';
wwv_flow_imp.g_varchar2_table(43166) := '727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C42432E70726F746F747970652E6861733D42432E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(43167) := '75726E20746869732E6C6973742E636F6E7461696E732865297D3B7661722056432C7A432C48432C57433D7B7D3B66756E6374696F6E206A4328297B56433D77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374';
wwv_flow_imp.g_varchar2_table(43168) := '656E6572223A226174746163684576656E74222C7A433D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A226465746163684576656E74222C48433D226164644576656E744C69';
wwv_flow_imp.g_varchar2_table(43169) := '7374656E657222213D3D56433F226F6E223A22227D57432E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2056437C7C6A4328292C655B56435D2848432B742C6E2C697C7C2131292C6E7D2C57432E756E62696E643D66756E63';
wwv_flow_imp.g_varchar2_table(43170) := '74696F6E28652C742C6E2C69297B72657475726E207A437C7C6A4328292C655B7A435D2848432B742C6E2C697C7C2131292C6E7D3B7661722071432C24433D21313B22756E646566696E656422213D747970656F6620646F63756D656E74262628287143';
wwv_flow_imp.g_varchar2_table(43171) := '3D646F63756D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D226368';
wwv_flow_imp.g_varchar2_table(43172) := '65636B626F78222F3E272C24433D2171432E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C71433D766F69642030293B7661722055433D7B6C6567656E643A5B312C223C6669656C647365743E222C223C2F66';
wwv_flow_imp.g_varchar2_table(43173) := '69656C647365743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E222C223C2F63';
wwv_flow_imp.g_varchar2_table(43174) := '6F6C67726F75703E3C2F7461626C653E225D2C5F64656661756C743A24433F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B55432E74643D55432E74683D5B332C223C7461626C653E3C74626F64793E3C74723E222C';
wwv_flow_imp.g_varchar2_table(43175) := '223C2F74723E3C2F74626F64793E3C2F7461626C653E225D2C55432E6F7074696F6E3D55432E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C55432E746865';
wwv_flow_imp.g_varchar2_table(43176) := '61643D55432E74626F64793D55432E636F6C67726F75703D55432E63617074696F6E3D55432E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C55432E706F6C796C696E653D55432E656C6C697073653D55432E706F6C7967';
wwv_flow_imp.g_varchar2_table(43177) := '6F6E3D55432E636972636C653D55432E746578743D55432E6C696E653D55432E706174683D55432E726563743D55432E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F';
wwv_flow_imp.g_varchar2_table(43178) := '6E3D22312E31223E272C223C2F7376673E225D3B766172204B433D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870656374656422';
wwv_flow_imp.g_varchar2_table(43179) := '293B747C7C28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F';
wwv_flow_imp.g_varchar2_table(43180) := '672C2222293B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C';
wwv_flow_imp.g_varchar2_table(43181) := '64293B766172206F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C2855432C69293F55435B695D3A55432E5F64656661756C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E6372656174';
wwv_flow_imp.g_varchar2_table(43182) := '65456C656D656E74282264697622293B666F72286C2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E66697273744368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76';
wwv_flow_imp.g_varchar2_table(43183) := '654368696C64286C2E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273744368696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C6428';
wwv_flow_imp.g_varchar2_table(43184) := '6C2E66697273744368696C6429293B72657475726E20637D3B66756E6374696F6E20474328652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F722865297D636F6E73742051433D313032343B6C65742059';
wwv_flow_imp.g_varchar2_table(43185) := '433D303B636C617373205A437B636F6E7374727563746F7228652C74297B746869732E66726F6D3D652C746869732E746F3D747D7D636C6173732058437B636F6E7374727563746F7228653D7B7D297B746869732E69643D59432B2B2C746869732E7065';
wwv_flow_imp.g_varchar2_table(43186) := '724E6F64653D2121652E7065724E6F64652C746869732E646573657269616C697A653D652E646573657269616C697A657C7C2828293D3E7B7468726F77206E6577204572726F72282254686973206E6F6465207479706520646F65736E27742064656669';
wwv_flow_imp.g_varchar2_table(43187) := '6E65206120646573657269616C697A652066756E6374696F6E22297D297D6164642865297B696628746869732E7065724E6F6465297468726F77206E65772052616E67654572726F72282243616E277420616464207065722D6E6F64652070726F707320';
wwv_flow_imp.g_varchar2_table(43188) := '746F206E6F646520747970657322293B72657475726E2266756E6374696F6E22213D747970656F662065262628653D74532E6D61746368286529292C743D3E7B6C6574206E3D652874293B72657475726E20766F696420303D3D3D6E3F6E756C6C3A5B74';
wwv_flow_imp.g_varchar2_table(43189) := '6869732C6E5D7D7D7D58432E636C6F73656442793D6E6577205843287B646573657269616C697A653A653D3E652E73706C697428222022297D292C58432E6F70656E656442793D6E6577205843287B646573657269616C697A653A653D3E652E73706C69';
wwv_flow_imp.g_varchar2_table(43190) := '7428222022297D292C58432E67726F75703D6E6577205843287B646573657269616C697A653A653D3E652E73706C697428222022297D292C58432E69736F6C6174653D6E6577205843287B646573657269616C697A653A653D3E7B696628652626227274';
wwv_flow_imp.g_varchar2_table(43191) := '6C22213D652626226C747222213D652626226175746F22213D65297468726F77206E65772052616E67654572726F722822496E76616C69642076616C756520666F722069736F6C6174653A20222B65293B72657475726E20657C7C226175746F227D7D29';
wwv_flow_imp.g_varchar2_table(43192) := '2C58432E636F6E74657874486173683D6E6577205843287B7065724E6F64653A21307D292C58432E6C6F6F6B41686561643D6E6577205843287B7065724E6F64653A21307D292C58432E6D6F756E7465643D6E6577205843287B7065724E6F64653A2130';
wwv_flow_imp.g_varchar2_table(43193) := '7D293B636C617373204A437B636F6E7374727563746F7228652C742C6E297B746869732E747265653D652C746869732E6F7665726C61793D742C746869732E7061727365723D6E7D737461746963206765742865297B72657475726E20652626652E7072';
wwv_flow_imp.g_varchar2_table(43194) := '6F70732626652E70726F70735B58432E6D6F756E7465642E69645D7D7D636F6E73742065533D4F626A6563742E637265617465286E756C6C293B636C6173732074537B636F6E7374727563746F7228652C742C6E2C693D30297B746869732E6E616D653D';
wwv_flow_imp.g_varchar2_table(43195) := '652C746869732E70726F70733D742C746869732E69643D6E2C746869732E666C6167733D697D73746174696320646566696E652865297B6C657420743D652E70726F70732626652E70726F70732E6C656E6774683F4F626A6563742E637265617465286E';
wwv_flow_imp.g_varchar2_table(43196) := '756C6C293A65532C6E3D28652E746F703F313A30297C28652E736B69707065643F323A30297C28652E6572726F723F343A30297C286E756C6C3D3D652E6E616D653F383A30292C693D6E657720745328652E6E616D657C7C22222C742C652E69642C6E29';
wwv_flow_imp.g_varchar2_table(43197) := '3B696628652E70726F707329666F72286C6574206E206F6620652E70726F70732969662841727261792E69734172726179286E297C7C286E3D6E286929292C6E297B6966286E5B305D2E7065724E6F6465297468726F77206E65772052616E6765457272';
wwv_flow_imp.g_varchar2_table(43198) := '6F72282243616E27742073746F72652061207065722D6E6F64652070726F70206F6E2061206E6F6465207479706522293B745B6E5B305D2E69645D3D6E5B315D7D72657475726E20697D70726F702865297B72657475726E20746869732E70726F70735B';
wwv_flow_imp.g_varchar2_table(43199) := '652E69645D7D676574206973546F7028297B72657475726E283126746869732E666C616773293E307D676574206973536B697070656428297B72657475726E283226746869732E666C616773293E307D6765742069734572726F7228297B72657475726E';
wwv_flow_imp.g_varchar2_table(43200) := '283426746869732E666C616773293E307D676574206973416E6F6E796D6F757328297B72657475726E283826746869732E666C616773293E307D69732865297B69662822737472696E67223D3D747970656F662065297B696628746869732E6E616D653D';
wwv_flow_imp.g_varchar2_table(43201) := '3D652972657475726E21303B6C657420743D746869732E70726F702858432E67726F7570293B72657475726E2121742626742E696E6465784F662865293E2D317D72657475726E20746869732E69643D3D657D737461746963206D617463682865297B6C';
wwv_flow_imp.g_varchar2_table(43202) := '657420743D4F626A6563742E637265617465286E756C6C293B666F72286C6574206E20696E206529666F72286C65742069206F66206E2E73706C6974282220222929745B695D3D655B6E5D3B72657475726E20653D3E7B666F72286C6574206E3D652E70';
wwv_flow_imp.g_varchar2_table(43203) := '726F702858432E67726F7570292C693D2D313B693C286E3F6E2E6C656E6774683A30293B692B2B297B6C6574206F3D745B693C303F652E6E616D653A6E5B695D5D3B6966286F2972657475726E206F7D7D7D7D74532E6E6F6E653D6E6577207453282222';
wwv_flow_imp.g_varchar2_table(43204) := '2C4F626A6563742E637265617465286E756C6C292C302C38293B636C617373206E537B636F6E7374727563746F722865297B746869732E74797065733D653B666F72286C657420743D303B743C652E6C656E6774683B742B2B29696628655B745D2E6964';
wwv_flow_imp.g_varchar2_table(43205) := '213D74297468726F77206E65772052616E67654572726F7228224E6F64652074797065206964732073686F756C6420636F72726573706F6E6420746F20617272617920706F736974696F6E73207768656E206372656174696E672061206E6F6465207365';
wwv_flow_imp.g_varchar2_table(43206) := '7422297D657874656E64282E2E2E65297B6C657420743D5B5D3B666F72286C6574206E206F6620746869732E7479706573297B6C657420693D6E756C6C3B666F72286C65742074206F662065297B6C657420653D74286E293B65262628697C7C28693D4F';
wwv_flow_imp.g_varchar2_table(43207) := '626A6563742E61737369676E287B7D2C6E2E70726F707329292C695B655B305D2E69645D3D655B315D297D742E7075736828693F6E6577207453286E2E6E616D652C692C6E2E69642C6E2E666C616773293A6E297D72657475726E206E6577206E532874';
wwv_flow_imp.g_varchar2_table(43208) := '297D7D636F6E73742069533D6E6577205765616B4D61702C6F533D6E6577205765616B4D61703B7661722073533B2166756E6374696F6E2865297B655B652E4578636C756465427566666572733D315D3D224578636C75646542756666657273222C655B';
wwv_flow_imp.g_varchar2_table(43209) := '652E496E636C756465416E6F6E796D6F75733D325D3D22496E636C756465416E6F6E796D6F7573222C655B652E49676E6F72654D6F756E74733D345D3D2249676E6F72654D6F756E7473222C655B652E49676E6F72654F7665726C6179733D385D3D2249';
wwv_flow_imp.g_varchar2_table(43210) := '676E6F72654F7665726C617973227D2873537C7C2873533D7B7D29293B636C6173732072537B636F6E7374727563746F7228652C742C6E2C692C6F297B696628746869732E747970653D652C746869732E6368696C6472656E3D742C746869732E706F73';
wwv_flow_imp.g_varchar2_table(43211) := '6974696F6E733D6E2C746869732E6C656E6774683D692C746869732E70726F70733D6E756C6C2C6F26266F2E6C656E677468297B746869732E70726F70733D4F626A6563742E637265617465286E756C6C293B666F72286C65745B652C745D6F66206F29';
wwv_flow_imp.g_varchar2_table(43212) := '746869732E70726F70735B226E756D626572223D3D747970656F6620653F653A652E69645D3D747D7D746F537472696E6728297B6C657420653D4A432E6765742874686973293B69662865262621652E6F7665726C61792972657475726E20652E747265';
wwv_flow_imp.g_varchar2_table(43213) := '652E746F537472696E6728293B6C657420743D22223B666F72286C65742065206F6620746869732E6368696C6472656E297B6C6574206E3D652E746F537472696E6728293B6E26262874262628742B3D222C22292C742B3D6E297D72657475726E207468';
wwv_flow_imp.g_varchar2_table(43214) := '69732E747970652E6E616D653F282F5C572F2E7465737428746869732E747970652E6E616D6529262621746869732E747970652E69734572726F723F4A534F4E2E737472696E6769667928746869732E747970652E6E616D65293A746869732E74797065';
wwv_flow_imp.g_varchar2_table(43215) := '2E6E616D65292B28742E6C656E6774683F2228222B742B2229223A2222293A747D637572736F7228653D30297B72657475726E206E6577205F5328746869732E746F704E6F64652C65297D637572736F72417428652C743D302C6E3D30297B6C65742069';
wwv_flow_imp.g_varchar2_table(43216) := '3D69532E6765742874686973297C7C746869732E746F704E6F64652C6F3D6E6577205F532869293B72657475726E206F2E6D6F7665546F28652C74292C69532E73657428746869732C6F2E5F74726565292C6F7D67657420746F704E6F646528297B7265';
wwv_flow_imp.g_varchar2_table(43217) := '7475726E206E657720755328746869732C302C302C6E756C6C297D7265736F6C766528652C743D30297B6C6574206E3D64532869532E6765742874686973297C7C746869732E746F704E6F64652C652C742C2131293B72657475726E2069532E73657428';
wwv_flow_imp.g_varchar2_table(43218) := '746869732C6E292C6E7D7265736F6C7665496E6E657228652C743D30297B6C6574206E3D6453286F532E6765742874686973297C7C746869732E746F704E6F64652C652C742C2130293B72657475726E206F532E73657428746869732C6E292C6E7D7265';
wwv_flow_imp.g_varchar2_table(43219) := '736F6C7665537461636B28652C743D30297B72657475726E2066756E6374696F6E28652C742C6E297B6C657420693D652E7265736F6C7665496E6E657228742C6E292C6F3D6E756C6C3B666F72286C657420653D6920696E7374616E63656F662075533F';
wwv_flow_imp.g_varchar2_table(43220) := '693A692E636F6E746578742E706172656E743B653B653D652E706172656E7429696628652E696E6465783C30297B6C657420733D652E706172656E743B286F7C7C286F3D5B695D29292E7075736828732E7265736F6C766528742C6E29292C653D737D65';
wwv_flow_imp.g_varchar2_table(43221) := '6C73657B6C657420733D4A432E67657428652E74726565293B696628732626732E6F7665726C61792626732E6F7665726C61795B305D2E66726F6D3C3D742626732E6F7665726C61795B732E6F7665726C61792E6C656E6774682D315D2E746F3E3D7429';
wwv_flow_imp.g_varchar2_table(43222) := '7B6C657420723D6E657720755328732E747265652C732E6F7665726C61795B305D2E66726F6D2B652E66726F6D2C2D312C65293B286F7C7C286F3D5B695D29292E7075736828645328722C742C6E2C213129297D7D72657475726E206F3F7653286F293A';
wwv_flow_imp.g_varchar2_table(43223) := '697D28746869732C652C74297D697465726174652865297B6C65747B656E7465723A742C6C656176653A6E2C66726F6D3A693D302C746F3A6F3D746869732E6C656E6774687D3D652C733D652E6D6F64657C7C302C723D28732673532E496E636C756465';
wwv_flow_imp.g_varchar2_table(43224) := '416E6F6E796D6F7573293E303B666F72286C657420653D746869732E637572736F7228737C73532E496E636C756465416E6F6E796D6F7573293B3B297B6C657420733D21313B696628652E66726F6D3C3D6F2626652E746F3E3D6926262821722626652E';
wwv_flow_imp.g_varchar2_table(43225) := '747970652E6973416E6F6E796D6F75737C7C2131213D3D7428652929297B696628652E66697273744368696C64282929636F6E74696E75653B733D21307D666F72283B7326266E262628727C7C21652E747970652E6973416E6F6E796D6F75732926266E';
wwv_flow_imp.g_varchar2_table(43226) := '2865292C21652E6E6578745369626C696E6728293B297B69662821652E706172656E7428292972657475726E3B733D21307D7D7D70726F702865297B72657475726E20652E7065724E6F64653F746869732E70726F70733F746869732E70726F70735B65';
wwv_flow_imp.g_varchar2_table(43227) := '2E69645D3A766F696420303A746869732E747970652E70726F702865297D6765742070726F7056616C75657328297B6C657420653D5B5D3B696628746869732E70726F707329666F72286C6574207420696E20746869732E70726F707329652E70757368';
wwv_flow_imp.g_varchar2_table(43228) := '285B2B742C746869732E70726F70735B745D5D293B72657475726E20657D62616C616E636528653D7B7D297B72657475726E20746869732E6368696C6472656E2E6C656E6774683C3D383F746869733A53532874532E6E6F6E652C746869732E6368696C';
wwv_flow_imp.g_varchar2_table(43229) := '6472656E2C746869732E706F736974696F6E732C302C746869732E6368696C6472656E2E6C656E6774682C302C746869732E6C656E6774682C2828652C742C6E293D3E6E657720725328746869732E747970652C652C742C6E2C746869732E70726F7056';
wwv_flow_imp.g_varchar2_table(43230) := '616C75657329292C652E6D616B65547265657C7C2828652C742C6E293D3E6E65772072532874532E6E6F6E652C652C742C6E2929297D737461746963206275696C642865297B72657475726E2066756E6374696F6E2865297B76617220743B6C65747B62';
wwv_flow_imp.g_varchar2_table(43231) := '75666665723A6E2C6E6F64655365743A692C6D61784275666665724C656E6774683A6F3D51432C7265757365643A733D5B5D2C6D696E526570656174547970653A723D692E74797065732E6C656E6774687D3D652C613D41727261792E69734172726179';
wwv_flow_imp.g_varchar2_table(43232) := '286E293F6E6577206153286E2C6E2E6C656E677468293A6E2C6C3D692E74797065732C633D302C643D303B66756E6374696F6E206828652C742C6E2C662C762C62297B6C65747B69643A5F2C73746172743A792C656E643A772C73697A653A437D3D612C';
wwv_flow_imp.g_varchar2_table(43233) := '533D643B666F72283B433C303B297B696628612E6E65787428292C2D313D3D43297B6C657420743D735B5F5D3B72657475726E206E2E707573682874292C766F696420662E7075736828792D65297D6966282D333D3D432972657475726E20766F696428';
wwv_flow_imp.g_varchar2_table(43234) := '633D5F293B6966282D343D3D432972657475726E20766F696428643D5F293B7468726F77206E65772052616E67654572726F722860556E7265636F676E697A6564207265636F72642073697A653A20247B437D60297D6C657420782C6B2C453D6C5B5F5D';
wwv_flow_imp.g_varchar2_table(43235) := '2C4C3D792D653B696628772D793C3D6F2626286B3D66756E6374696F6E28652C74297B6C6574206E3D612E666F726B28292C693D302C733D302C6C3D302C633D6E2E656E642D6F2C643D7B73697A653A302C73746172743A302C736B69703A307D3B653A';
wwv_flow_imp.g_varchar2_table(43236) := '666F72286C6574206F3D6E2E706F732D653B6E2E706F733E6F3B297B6C657420653D6E2E73697A653B6966286E2E69643D3D742626653E3D30297B642E73697A653D692C642E73746172743D732C642E736B69703D6C2C6C2B3D342C692B3D342C6E2E6E';
wwv_flow_imp.g_varchar2_table(43237) := '65787428293B636F6E74696E75657D6C657420613D6E2E706F732D653B696628653C307C7C613C6F7C7C6E2E73746172743C6329627265616B3B6C657420683D6E2E69643E3D723F343A302C753D6E2E73746172743B666F72286E2E6E65787428293B6E';
wwv_flow_imp.g_varchar2_table(43238) := '2E706F733E613B297B6966286E2E73697A653C30297B6966282D33213D6E2E73697A6529627265616B20653B682B3D347D656C7365206E2E69643E3D72262628682B3D34293B6E2E6E65787428297D733D752C692B3D652C6C2B3D687D72657475726E28';
wwv_flow_imp.g_varchar2_table(43239) := '743C307C7C693D3D6529262628642E73697A653D692C642E73746172743D732C642E736B69703D6C292C642E73697A653E343F643A766F696420307D28612E706F732D742C762929297B6C657420743D6E65772055696E7431364172726179286B2E7369';
wwv_flow_imp.g_varchar2_table(43240) := '7A652D6B2E736B6970292C6E3D612E706F732D6B2E73697A652C6F3D742E6C656E6774683B666F72283B612E706F733E6E3B296F3D6D286B2E73746172742C742C6F293B783D6E6577206C5328742C772D6B2E73746172742C69292C4C3D6B2E73746172';
wwv_flow_imp.g_varchar2_table(43241) := '742D657D656C73657B6C657420653D612E706F732D433B612E6E65787428293B6C657420743D5B5D2C6E3D5B5D2C693D5F3E3D723F5F3A2D312C733D302C6C3D773B666F72283B612E706F733E653B29693E3D302626612E69643D3D692626612E73697A';
wwv_flow_imp.g_varchar2_table(43242) := '653E3D303F28612E656E643C3D6C2D6F2626287028742C6E2C792C732C612E656E642C6C2C692C53292C733D742E6C656E6774682C6C3D612E656E64292C612E6E6578742829293A623E323530303F7528792C652C742C6E293A6828792C652C742C6E2C';
wwv_flow_imp.g_varchar2_table(43243) := '692C622B31293B696628693E3D302626733E302626733C742E6C656E67746826267028742C6E2C792C732C792C6C2C692C53292C742E7265766572736528292C6E2E7265766572736528292C693E2D312626733E30297B6C657420653D66756E6374696F';
wwv_flow_imp.g_varchar2_table(43244) := '6E2865297B72657475726E28742C6E2C69293D3E7B6C6574206F2C732C723D302C613D742E6C656E6774682D313B696628613E3D302626286F3D745B615D29696E7374616E63656F66207253297B696628216126266F2E747970653D3D6526266F2E6C65';
wwv_flow_imp.g_varchar2_table(43245) := '6E6774683D3D692972657475726E206F3B28733D6F2E70726F702858432E6C6F6F6B41686561642929262628723D6E5B615D2B6F2E6C656E6774682B73297D72657475726E206728652C742C6E2C692C72297D7D2845293B783D535328452C742C6E2C30';
wwv_flow_imp.g_varchar2_table(43246) := '2C742E6C656E6774682C302C772D792C652C65297D656C736520783D6728452C742C6E2C772D792C532D77297D6E2E707573682878292C662E70757368284C297D66756E6374696F6E207528652C742C6E2C73297B6C657420723D5B5D2C6C3D302C633D';
wwv_flow_imp.g_varchar2_table(43247) := '2D313B666F72283B612E706F733E743B297B6C65747B69643A652C73746172743A742C656E643A6E2C73697A653A697D3D613B696628693E3429612E6E65787428293B656C73657B696628633E2D312626743C6329627265616B3B633C30262628633D6E';
wwv_flow_imp.g_varchar2_table(43248) := '2D6F292C722E7075736828652C742C6E292C6C2B2B2C612E6E65787428297D7D6966286C297B6C657420743D6E65772055696E743136417272617928342A6C292C6F3D725B722E6C656E6774682D325D3B666F72286C657420653D722E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(43249) := '332C6E3D303B653E3D303B652D3D3329745B6E2B2B5D3D725B655D2C745B6E2B2B5D3D725B652B315D2D6F2C745B6E2B2B5D3D725B652B325D2D6F2C745B6E2B2B5D3D6E3B6E2E70757368286E6577206C5328742C725B325D2D6F2C6929292C732E7075';
wwv_flow_imp.g_varchar2_table(43250) := '7368286F2D65297D7D66756E6374696F6E207028652C742C6E2C6F2C732C722C612C6C297B6C657420633D5B5D2C643D5B5D3B666F72283B652E6C656E6774683E6F3B29632E7075736828652E706F702829292C642E7075736828742E706F7028292B6E';
wwv_flow_imp.g_varchar2_table(43251) := '2D73293B652E70757368286728692E74797065735B615D2C632C642C722D732C6C2D7229292C742E7075736828732D6E297D66756E6374696F6E206728652C742C6E2C692C6F3D302C73297B69662863297B6C657420653D5B58432E636F6E7465787448';
wwv_flow_imp.g_varchar2_table(43252) := '6173682C635D3B733D733F5B655D2E636F6E6361742873293A5B655D7D6966286F3E3235297B6C657420653D5B58432E6C6F6F6B41686561642C6F5D3B733D733F5B655D2E636F6E6361742873293A5B655D7D72657475726E206E657720725328652C74';
wwv_flow_imp.g_varchar2_table(43253) := '2C6E2C692C73297D66756E6374696F6E206D28652C742C6E297B6C65747B69643A692C73746172743A6F2C656E643A732C73697A653A6C7D3D613B696628612E6E65787428292C6C3E3D302626693C72297B6C657420723D6E3B6966286C3E34297B6C65';
wwv_flow_imp.g_varchar2_table(43254) := '7420693D612E706F732D286C2D34293B666F72283B612E706F733E693B296E3D6D28652C742C6E297D745B2D2D6E5D3D722C745B2D2D6E5D3D732D652C745B2D2D6E5D3D6F2D652C745B2D2D6E5D3D697D656C73652D333D3D6C3F633D693A2D343D3D6C';
wwv_flow_imp.g_varchar2_table(43255) := '262628643D69293B72657475726E206E7D6C657420663D5B5D2C763D5B5D3B666F72283B612E706F733E303B296828652E73746172747C7C302C652E62756666657253746172747C7C302C662C762C2D312C30293B6C657420623D6E756C6C213D3D2874';
wwv_flow_imp.g_varchar2_table(43256) := '3D652E6C656E677468292626766F69642030213D3D743F743A662E6C656E6774683F765B305D2B665B305D2E6C656E6774683A303B72657475726E206E6577207253286C5B652E746F7049445D2C662E7265766572736528292C762E7265766572736528';
wwv_flow_imp.g_varchar2_table(43257) := '292C62297D2865297D7D72532E656D7074793D6E65772072532874532E6E6F6E652C5B5D2C5B5D2C30293B636C6173732061537B636F6E7374727563746F7228652C74297B746869732E6275666665723D652C746869732E696E6465783D747D67657420';
wwv_flow_imp.g_varchar2_table(43258) := '696428297B72657475726E20746869732E6275666665725B746869732E696E6465782D345D7D67657420737461727428297B72657475726E20746869732E6275666665725B746869732E696E6465782D335D7D67657420656E6428297B72657475726E20';
wwv_flow_imp.g_varchar2_table(43259) := '746869732E6275666665725B746869732E696E6465782D325D7D6765742073697A6528297B72657475726E20746869732E6275666665725B746869732E696E6465782D315D7D67657420706F7328297B72657475726E20746869732E696E6465787D6E65';
wwv_flow_imp.g_varchar2_table(43260) := '787428297B746869732E696E6465782D3D347D666F726B28297B72657475726E206E657720615328746869732E6275666665722C746869732E696E646578297D7D636C617373206C537B636F6E7374727563746F7228652C742C6E297B746869732E6275';
wwv_flow_imp.g_varchar2_table(43261) := '666665723D652C746869732E6C656E6774683D742C746869732E7365743D6E7D676574207479706528297B72657475726E2074532E6E6F6E657D746F537472696E6728297B6C657420653D5B5D3B666F72286C657420743D303B743C746869732E627566';
wwv_flow_imp.g_varchar2_table(43262) := '6665722E6C656E6774683B29652E7075736828746869732E6368696C64537472696E67287429292C743D746869732E6275666665725B742B335D3B72657475726E20652E6A6F696E28222C22297D6368696C64537472696E672865297B6C657420743D74';
wwv_flow_imp.g_varchar2_table(43263) := '6869732E6275666665725B655D2C6E3D746869732E6275666665725B652B335D2C693D746869732E7365742E74797065735B745D2C6F3D692E6E616D653B6966282F5C572F2E74657374286F29262621692E69734572726F722626286F3D4A534F4E2E73';
wwv_flow_imp.g_varchar2_table(43264) := '7472696E67696679286F29292C6E3D3D28652B3D34292972657475726E206F3B6C657420733D5B5D3B666F72283B653C6E3B29732E7075736828746869732E6368696C64537472696E67286529292C653D746869732E6275666665725B652B335D3B7265';
wwv_flow_imp.g_varchar2_table(43265) := '7475726E206F2B2228222B732E6A6F696E28222C22292B2229227D66696E644368696C6428652C742C6E2C692C6F297B6C65747B6275666665723A737D3D746869732C723D2D313B666F72286C657420613D653B61213D74262621286353286F2C692C73';
wwv_flow_imp.g_varchar2_table(43266) := '5B612B315D2C735B612B325D29262628723D612C6E3E3029293B613D735B612B335D293B72657475726E20727D736C69636528652C742C6E297B6C657420693D746869732E6275666665722C6F3D6E65772055696E743136417272617928742D65292C73';
wwv_flow_imp.g_varchar2_table(43267) := '3D303B666F72286C657420723D652C613D303B723C743B297B6F5B612B2B5D3D695B722B2B5D2C6F5B612B2B5D3D695B722B2B5D2D6E3B6C657420743D6F5B612B2B5D3D695B722B2B5D2D6E3B6F5B612B2B5D3D695B722B2B5D2D652C733D4D6174682E';
wwv_flow_imp.g_varchar2_table(43268) := '6D617828732C74297D72657475726E206E6577206C53286F2C732C746869732E736574297D7D66756E6374696F6E20635328652C742C6E2C69297B7377697463682865297B636173652D323A72657475726E206E3C743B636173652D313A72657475726E';
wwv_flow_imp.g_varchar2_table(43269) := '20693E3D7426266E3C743B6361736520303A72657475726E206E3C742626693E743B6361736520313A72657475726E206E3C3D742626693E743B6361736520323A72657475726E20693E743B6361736520343A72657475726E21307D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(43270) := '6E20645328652C742C6E2C69297B666F7228766172206F3B652E66726F6D3D3D652E746F7C7C286E3C313F652E66726F6D3E3D743A652E66726F6D3E74297C7C286E3E2D313F652E746F3C3D743A652E746F3C74293B297B6C657420743D216926266520';
wwv_flow_imp.g_varchar2_table(43271) := '696E7374616E63656F662075532626652E696E6465783C303F6E756C6C3A652E706172656E743B69662821742972657475726E20653B653D747D6C657420733D693F303A73532E49676E6F72654F7665726C6179733B6966286929666F72286C65742069';
wwv_flow_imp.g_varchar2_table(43272) := '3D652C723D692E706172656E743B723B693D722C723D692E706172656E74296920696E7374616E63656F662075532626692E696E6465783C302626286E756C6C3D3D3D286F3D722E656E74657228742C6E2C7329297C7C766F696420303D3D3D6F3F766F';
wwv_flow_imp.g_varchar2_table(43273) := '696420303A6F2E66726F6D29213D692E66726F6D262628653D72293B666F72283B3B297B6C657420693D652E656E74657228742C6E2C73293B69662821692972657475726E20653B653D697D7D636C6173732068537B637572736F7228653D30297B7265';
wwv_flow_imp.g_varchar2_table(43274) := '7475726E206E6577205F5328746869732C65297D6765744368696C6428652C743D6E756C6C2C6E3D6E756C6C297B6C657420693D705328746869732C652C742C6E293B72657475726E20692E6C656E6774683F695B305D3A6E756C6C7D6765744368696C';
wwv_flow_imp.g_varchar2_table(43275) := '6472656E28652C743D6E756C6C2C6E3D6E756C6C297B72657475726E20705328746869732C652C742C6E297D7265736F6C766528652C743D30297B72657475726E20645328746869732C652C742C2131297D7265736F6C7665496E6E657228652C743D30';
wwv_flow_imp.g_varchar2_table(43276) := '297B72657475726E20645328746869732C652C742C2130297D6D61746368436F6E746578742865297B72657475726E20675328746869732C65297D656E746572556E66696E69736865644E6F6465734265666F72652865297B6C657420743D746869732E';
wwv_flow_imp.g_varchar2_table(43277) := '6368696C644265666F72652865292C6E3D746869733B666F72283B743B297B6C657420653D742E6C6173744368696C643B69662821657C7C652E746F213D742E746F29627265616B3B652E747970652E69734572726F722626652E66726F6D3D3D652E74';
wwv_flow_imp.g_varchar2_table(43278) := '6F3F286E3D742C743D652E707265765369626C696E67293A743D657D72657475726E206E7D676574206E6F646528297B72657475726E20746869737D676574206E65787428297B72657475726E20746869732E706172656E747D7D636C61737320755320';
wwv_flow_imp.g_varchar2_table(43279) := '657874656E64732068537B636F6E7374727563746F7228652C742C6E2C69297B737570657228292C746869732E5F747265653D652C746869732E66726F6D3D742C746869732E696E6465783D6E2C746869732E5F706172656E743D697D67657420747970';
wwv_flow_imp.g_varchar2_table(43280) := '6528297B72657475726E20746869732E5F747265652E747970657D676574206E616D6528297B72657475726E20746869732E5F747265652E747970652E6E616D657D67657420746F28297B72657475726E20746869732E66726F6D2B746869732E5F7472';
wwv_flow_imp.g_varchar2_table(43281) := '65652E6C656E6774687D6E6578744368696C6428652C742C6E2C692C6F3D30297B666F72286C657420733D746869733B3B297B666F72286C65747B6368696C6472656E3A722C706F736974696F6E733A617D3D732E5F747265652C6C3D743E303F722E6C';
wwv_flow_imp.g_varchar2_table(43282) := '656E6774683A2D313B65213D6C3B652B3D74297B6C6574206C3D725B655D2C633D615B655D2B732E66726F6D3B696628635328692C6E2C632C632B6C2E6C656E67746829296966286C20696E7374616E63656F66206C53297B6966286F2673532E457863';
wwv_flow_imp.g_varchar2_table(43283) := '6C7564654275666665727329636F6E74696E75653B6C657420723D6C2E66696E644368696C6428302C6C2E6275666665722E6C656E6774682C742C6E2D632C69293B696628723E2D312972657475726E206E6577206653286E6577206D5328732C6C2C65';
wwv_flow_imp.g_varchar2_table(43284) := '2C63292C6E756C6C2C72297D656C7365206966286F2673532E496E636C756465416E6F6E796D6F75737C7C216C2E747970652E6973416E6F6E796D6F75737C7C7953286C29297B6C657420723B69662821286F2673532E49676E6F72654D6F756E747329';
wwv_flow_imp.g_varchar2_table(43285) := '262628723D4A432E676574286C2929262621722E6F7665726C61792972657475726E206E657720755328722E747265652C632C652C73293B6C657420613D6E6577207553286C2C632C652C73293B72657475726E206F2673532E496E636C756465416E6F';
wwv_flow_imp.g_varchar2_table(43286) := '6E796D6F75737C7C21612E747970652E6973416E6F6E796D6F75733F613A612E6E6578744368696C6428743C303F6C2E6368696C6472656E2E6C656E6774682D313A302C742C6E2C69297D7D6966286F2673532E496E636C756465416E6F6E796D6F7573';
wwv_flow_imp.g_varchar2_table(43287) := '7C7C21732E747970652E6973416E6F6E796D6F75732972657475726E206E756C6C3B696628653D732E696E6465783E3D303F732E696E6465782B743A743C303F2D313A732E5F706172656E742E5F747265652E6368696C6472656E2E6C656E6774682C73';
wwv_flow_imp.g_varchar2_table(43288) := '3D732E5F706172656E742C21732972657475726E206E756C6C7D7D6765742066697273744368696C6428297B72657475726E20746869732E6E6578744368696C6428302C312C302C34297D676574206C6173744368696C6428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(43289) := '69732E6E6578744368696C6428746869732E5F747265652E6368696C6472656E2E6C656E6774682D312C2D312C302C34297D6368696C6441667465722865297B72657475726E20746869732E6E6578744368696C6428302C312C652C32297D6368696C64';
wwv_flow_imp.g_varchar2_table(43290) := '4265666F72652865297B72657475726E20746869732E6E6578744368696C6428746869732E5F747265652E6368696C6472656E2E6C656E6774682D312C2D312C652C2D32297D656E74657228652C742C6E3D30297B6C657420693B69662821286E267353';
wwv_flow_imp.g_varchar2_table(43291) := '2E49676E6F72654F7665726C61797329262628693D4A432E67657428746869732E5F7472656529292626692E6F7665726C6179297B6C6574206E3D652D746869732E66726F6D3B666F72286C65747B66726F6D3A652C746F3A6F7D6F6620692E6F766572';
wwv_flow_imp.g_varchar2_table(43292) := '6C61792969662828743E303F653C3D6E3A653C6E29262628743C303F6F3E3D6E3A6F3E6E292972657475726E206E657720755328692E747265652C692E6F7665726C61795B305D2E66726F6D2B746869732E66726F6D2C2D312C74686973297D72657475';
wwv_flow_imp.g_varchar2_table(43293) := '726E20746869732E6E6578744368696C6428302C312C652C742C6E297D6E6578745369676E69666963616E74506172656E7428297B6C657420653D746869733B666F72283B652E747970652E6973416E6F6E796D6F75732626652E5F706172656E743B29';
wwv_flow_imp.g_varchar2_table(43294) := '653D652E5F706172656E743B72657475726E20657D67657420706172656E7428297B72657475726E20746869732E5F706172656E743F746869732E5F706172656E742E6E6578745369676E69666963616E74506172656E7428293A6E756C6C7D67657420';
wwv_flow_imp.g_varchar2_table(43295) := '6E6578745369626C696E6728297B72657475726E20746869732E5F706172656E742626746869732E696E6465783E3D303F746869732E5F706172656E742E6E6578744368696C6428746869732E696E6465782B312C312C302C34293A6E756C6C7D676574';
wwv_flow_imp.g_varchar2_table(43296) := '20707265765369626C696E6728297B72657475726E20746869732E5F706172656E742626746869732E696E6465783E3D303F746869732E5F706172656E742E6E6578744368696C6428746869732E696E6465782D312C2D312C302C34293A6E756C6C7D67';
wwv_flow_imp.g_varchar2_table(43297) := '6574207472656528297B72657475726E20746869732E5F747265657D746F5472656528297B72657475726E20746869732E5F747265657D746F537472696E6728297B72657475726E20746869732E5F747265652E746F537472696E6728297D7D66756E63';
wwv_flow_imp.g_varchar2_table(43298) := '74696F6E20705328652C742C6E2C69297B6C6574206F3D652E637572736F7228292C733D5B5D3B696628216F2E66697273744368696C6428292972657475726E20733B6966286E756C6C213D6E29666F72286C657420653D21313B21653B29696628653D';
wwv_flow_imp.g_varchar2_table(43299) := '6F2E747970652E6973286E292C216F2E6E6578745369626C696E6728292972657475726E20733B666F72283B3B297B6966286E756C6C213D6926266F2E747970652E69732869292972657475726E20733B6966286F2E747970652E69732874292626732E';
wwv_flow_imp.g_varchar2_table(43300) := '70757368286F2E6E6F6465292C216F2E6E6578745369626C696E6728292972657475726E206E756C6C3D3D693F733A5B5D7D7D66756E6374696F6E20675328652C742C6E3D742E6C656E6774682D31297B666F72286C657420693D652E706172656E743B';
wwv_flow_imp.g_varchar2_table(43301) := '6E3E3D303B693D692E706172656E74297B69662821692972657475726E21313B69662821692E747970652E6973416E6F6E796D6F7573297B696628745B6E5D2626745B6E5D213D692E6E616D652972657475726E21313B6E2D2D7D7D72657475726E2130';
wwv_flow_imp.g_varchar2_table(43302) := '7D636C617373206D537B636F6E7374727563746F7228652C742C6E2C69297B746869732E706172656E743D652C746869732E6275666665723D742C746869732E696E6465783D6E2C746869732E73746172743D697D7D636C61737320665320657874656E';
wwv_flow_imp.g_varchar2_table(43303) := '64732068537B676574206E616D6528297B72657475726E20746869732E747970652E6E616D657D6765742066726F6D28297B72657475726E20746869732E636F6E746578742E73746172742B746869732E636F6E746578742E6275666665722E62756666';
wwv_flow_imp.g_varchar2_table(43304) := '65725B746869732E696E6465782B315D7D67657420746F28297B72657475726E20746869732E636F6E746578742E73746172742B746869732E636F6E746578742E6275666665722E6275666665725B746869732E696E6465782B325D7D636F6E73747275';
wwv_flow_imp.g_varchar2_table(43305) := '63746F7228652C742C6E297B737570657228292C746869732E636F6E746578743D652C746869732E5F706172656E743D742C746869732E696E6465783D6E2C746869732E747970653D652E6275666665722E7365742E74797065735B652E627566666572';
wwv_flow_imp.g_varchar2_table(43306) := '2E6275666665725B6E5D5D7D6368696C6428652C742C6E297B6C65747B6275666665723A697D3D746869732E636F6E746578742C6F3D692E66696E644368696C6428746869732E696E6465782B342C692E6275666665725B746869732E696E6465782B33';
wwv_flow_imp.g_varchar2_table(43307) := '5D2C652C742D746869732E636F6E746578742E73746172742C6E293B72657475726E206F3C303F6E756C6C3A6E657720665328746869732E636F6E746578742C746869732C6F297D6765742066697273744368696C6428297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(43308) := '2E6368696C6428312C302C34297D676574206C6173744368696C6428297B72657475726E20746869732E6368696C64282D312C302C34297D6368696C6441667465722865297B72657475726E20746869732E6368696C6428312C652C32297D6368696C64';
wwv_flow_imp.g_varchar2_table(43309) := '4265666F72652865297B72657475726E20746869732E6368696C64282D312C652C2D32297D656E74657228652C742C6E3D30297B6966286E2673532E4578636C756465427566666572732972657475726E206E756C6C3B6C65747B6275666665723A697D';
wwv_flow_imp.g_varchar2_table(43310) := '3D746869732E636F6E746578742C6F3D692E66696E644368696C6428746869732E696E6465782B342C692E6275666665725B746869732E696E6465782B335D2C743E303F313A2D312C652D746869732E636F6E746578742E73746172742C74293B726574';
wwv_flow_imp.g_varchar2_table(43311) := '75726E206F3C303F6E756C6C3A6E657720665328746869732E636F6E746578742C746869732C6F297D67657420706172656E7428297B72657475726E20746869732E5F706172656E747C7C746869732E636F6E746578742E706172656E742E6E65787453';
wwv_flow_imp.g_varchar2_table(43312) := '69676E69666963616E74506172656E7428297D65787465726E616C5369626C696E672865297B72657475726E20746869732E5F706172656E743F6E756C6C3A746869732E636F6E746578742E706172656E742E6E6578744368696C6428746869732E636F';
wwv_flow_imp.g_varchar2_table(43313) := '6E746578742E696E6465782B652C652C302C34297D676574206E6578745369626C696E6728297B6C65747B6275666665723A657D3D746869732E636F6E746578742C743D652E6275666665725B746869732E696E6465782B335D3B72657475726E20743C';
wwv_flow_imp.g_varchar2_table(43314) := '28746869732E5F706172656E743F652E6275666665725B746869732E5F706172656E742E696E6465782B335D3A652E6275666665722E6C656E677468293F6E657720665328746869732E636F6E746578742C746869732E5F706172656E742C74293A7468';
wwv_flow_imp.g_varchar2_table(43315) := '69732E65787465726E616C5369626C696E672831297D67657420707265765369626C696E6728297B6C65747B6275666665723A657D3D746869732E636F6E746578742C743D746869732E5F706172656E743F746869732E5F706172656E742E696E646578';
wwv_flow_imp.g_varchar2_table(43316) := '2B343A303B72657475726E20746869732E696E6465783D3D743F746869732E65787465726E616C5369626C696E67282D31293A6E657720665328746869732E636F6E746578742C746869732E5F706172656E742C652E66696E644368696C6428742C7468';
wwv_flow_imp.g_varchar2_table(43317) := '69732E696E6465782C2D312C302C3429297D676574207472656528297B72657475726E206E756C6C7D746F5472656528297B6C657420653D5B5D2C743D5B5D2C7B6275666665723A6E7D3D746869732E636F6E746578742C693D746869732E696E646578';
wwv_flow_imp.g_varchar2_table(43318) := '2B342C6F3D6E2E6275666665725B746869732E696E6465782B335D3B6966286F3E69297B6C657420733D6E2E6275666665725B746869732E696E6465782B315D3B652E70757368286E2E736C69636528692C6F2C7329292C742E707573682830297D7265';
wwv_flow_imp.g_varchar2_table(43319) := '7475726E206E657720725328746869732E747970652C652C742C746869732E746F2D746869732E66726F6D297D746F537472696E6728297B72657475726E20746869732E636F6E746578742E6275666665722E6368696C64537472696E6728746869732E';
wwv_flow_imp.g_varchar2_table(43320) := '696E646578297D7D66756E6374696F6E2076532865297B69662821652E6C656E6774682972657475726E206E756C6C3B6C657420743D302C6E3D655B305D3B666F72286C657420693D313B693C652E6C656E6774683B692B2B297B6C6574206F3D655B69';
wwv_flow_imp.g_varchar2_table(43321) := '5D3B286F2E66726F6D3E6E2E66726F6D7C7C6F2E746F3C6E2E746F292626286E3D6F2C743D69297D6C657420693D6E20696E7374616E63656F6620755326266E2E696E6465783C303F6E756C6C3A6E2E706172656E742C6F3D652E736C69636528293B72';
wwv_flow_imp.g_varchar2_table(43322) := '657475726E20693F6F5B745D3D693A6F2E73706C69636528742C31292C6E6577206253286F2C6E297D636C6173732062537B636F6E7374727563746F7228652C74297B746869732E68656164733D652C746869732E6E6F64653D747D676574206E657874';
wwv_flow_imp.g_varchar2_table(43323) := '28297B72657475726E20765328746869732E6865616473297D7D636C617373205F537B676574206E616D6528297B72657475726E20746869732E747970652E6E616D657D636F6E7374727563746F7228652C743D30297B696628746869732E6D6F64653D';
wwv_flow_imp.g_varchar2_table(43324) := '742C746869732E6275666665723D6E756C6C2C746869732E737461636B3D5B5D2C746869732E696E6465783D302C746869732E6275666665724E6F64653D6E756C6C2C6520696E7374616E63656F6620755329746869732E7969656C644E6F6465286529';
wwv_flow_imp.g_varchar2_table(43325) := '3B656C73657B746869732E5F747265653D652E636F6E746578742E706172656E742C746869732E6275666665723D652E636F6E746578743B666F72286C657420743D652E5F706172656E743B743B743D742E5F706172656E7429746869732E737461636B';
wwv_flow_imp.g_varchar2_table(43326) := '2E756E736869667428742E696E646578293B746869732E6275666665724E6F64653D652C746869732E7969656C6442756628652E696E646578297D7D7969656C644E6F64652865297B72657475726E212165262628746869732E5F747265653D652C7468';
wwv_flow_imp.g_varchar2_table(43327) := '69732E747970653D652E747970652C746869732E66726F6D3D652E66726F6D2C746869732E746F3D652E746F2C2130297D7969656C6442756628652C74297B746869732E696E6465783D653B6C65747B73746172743A6E2C6275666665723A697D3D7468';
wwv_flow_imp.g_varchar2_table(43328) := '69732E6275666665723B72657475726E20746869732E747970653D747C7C692E7365742E74797065735B692E6275666665725B655D5D2C746869732E66726F6D3D6E2B692E6275666665725B652B315D2C746869732E746F3D6E2B692E6275666665725B';
wwv_flow_imp.g_varchar2_table(43329) := '652B325D2C21307D7969656C642865297B72657475726E2121652626286520696E7374616E63656F662075533F28746869732E6275666665723D6E756C6C2C746869732E7969656C644E6F6465286529293A28746869732E6275666665723D652E636F6E';
wwv_flow_imp.g_varchar2_table(43330) := '746578742C746869732E7969656C6442756628652E696E6465782C652E747970652929297D746F537472696E6728297B72657475726E20746869732E6275666665723F746869732E6275666665722E6275666665722E6368696C64537472696E67287468';
wwv_flow_imp.g_varchar2_table(43331) := '69732E696E646578293A746869732E5F747265652E746F537472696E6728297D656E7465724368696C6428652C742C6E297B69662821746869732E6275666665722972657475726E20746869732E7969656C6428746869732E5F747265652E6E65787443';
wwv_flow_imp.g_varchar2_table(43332) := '68696C6428653C303F746869732E5F747265652E5F747265652E6368696C6472656E2E6C656E6774682D313A302C652C742C6E2C746869732E6D6F646529293B6C65747B6275666665723A697D3D746869732E6275666665722C6F3D692E66696E644368';
wwv_flow_imp.g_varchar2_table(43333) := '696C6428746869732E696E6465782B342C692E6275666665725B746869732E696E6465782B335D2C652C742D746869732E6275666665722E73746172742C6E293B72657475726E21286F3C3029262628746869732E737461636B2E707573682874686973';
wwv_flow_imp.g_varchar2_table(43334) := '2E696E646578292C746869732E7969656C64427566286F29297D66697273744368696C6428297B72657475726E20746869732E656E7465724368696C6428312C302C34297D6C6173744368696C6428297B72657475726E20746869732E656E7465724368';
wwv_flow_imp.g_varchar2_table(43335) := '696C64282D312C302C34297D6368696C6441667465722865297B72657475726E20746869732E656E7465724368696C6428312C652C32297D6368696C644265666F72652865297B72657475726E20746869732E656E7465724368696C64282D312C652C2D';
wwv_flow_imp.g_varchar2_table(43336) := '32297D656E74657228652C742C6E3D746869732E6D6F6465297B72657475726E20746869732E6275666665723F21286E2673532E4578636C75646542756666657273292626746869732E656E7465724368696C6428312C652C74293A746869732E796965';
wwv_flow_imp.g_varchar2_table(43337) := '6C6428746869732E5F747265652E656E74657228652C742C6E29297D706172656E7428297B69662821746869732E6275666665722972657475726E20746869732E7969656C644E6F646528746869732E6D6F64652673532E496E636C756465416E6F6E79';
wwv_flow_imp.g_varchar2_table(43338) := '6D6F75733F746869732E5F747265652E5F706172656E743A746869732E5F747265652E706172656E74293B696628746869732E737461636B2E6C656E6774682972657475726E20746869732E7969656C6442756628746869732E737461636B2E706F7028';
wwv_flow_imp.g_varchar2_table(43339) := '29293B6C657420653D746869732E6D6F64652673532E496E636C756465416E6F6E796D6F75733F746869732E6275666665722E706172656E743A746869732E6275666665722E706172656E742E6E6578745369676E69666963616E74506172656E742829';
wwv_flow_imp.g_varchar2_table(43340) := '3B72657475726E20746869732E6275666665723D6E756C6C2C746869732E7969656C644E6F64652865297D7369626C696E672865297B69662821746869732E6275666665722972657475726E2121746869732E5F747265652E5F706172656E7426267468';
wwv_flow_imp.g_varchar2_table(43341) := '69732E7969656C6428746869732E5F747265652E696E6465783C303F6E756C6C3A746869732E5F747265652E5F706172656E742E6E6578744368696C6428746869732E5F747265652E696E6465782B652C652C302C342C746869732E6D6F646529293B6C';
wwv_flow_imp.g_varchar2_table(43342) := '65747B6275666665723A747D3D746869732E6275666665722C6E3D746869732E737461636B2E6C656E6774682D313B696628653C30297B6C657420653D6E3C303F303A746869732E737461636B5B6E5D2B343B696628746869732E696E646578213D6529';
wwv_flow_imp.g_varchar2_table(43343) := '72657475726E20746869732E7969656C6442756628742E66696E644368696C6428652C746869732E696E6465782C2D312C302C3429297D656C73657B6C657420653D742E6275666665725B746869732E696E6465782B335D3B696628653C286E3C303F74';
wwv_flow_imp.g_varchar2_table(43344) := '2E6275666665722E6C656E6774683A742E6275666665725B746869732E737461636B5B6E5D2B335D292972657475726E20746869732E7969656C644275662865297D72657475726E206E3C302626746869732E7969656C6428746869732E627566666572';
wwv_flow_imp.g_varchar2_table(43345) := '2E706172656E742E6E6578744368696C6428746869732E6275666665722E696E6465782B652C652C302C342C746869732E6D6F646529297D6E6578745369626C696E6728297B72657475726E20746869732E7369626C696E672831297D70726576536962';
wwv_flow_imp.g_varchar2_table(43346) := '6C696E6728297B72657475726E20746869732E7369626C696E67282D31297D61744C6173744E6F64652865297B6C657420742C6E2C7B6275666665723A697D3D746869733B69662869297B696628653E30297B696628746869732E696E6465783C692E62';
wwv_flow_imp.g_varchar2_table(43347) := '75666665722E6275666665722E6C656E6774682972657475726E21317D656C736520666F72286C657420653D303B653C746869732E696E6465783B652B2B29696628692E6275666665722E6275666665725B652B335D3C746869732E696E646578297265';
wwv_flow_imp.g_varchar2_table(43348) := '7475726E21313B287B696E6465783A742C706172656E743A6E7D3D69297D656C7365287B696E6465783A742C5F706172656E743A6E7D3D746869732E5F74726565293B666F72283B6E3B287B696E6465783A742C5F706172656E743A6E7D3D6E29296966';
wwv_flow_imp.g_varchar2_table(43349) := '28743E2D3129666F72286C657420693D742B652C6F3D653C303F2D313A6E2E5F747265652E6368696C6472656E2E6C656E6774683B69213D6F3B692B3D65297B6C657420653D6E2E5F747265652E6368696C6472656E5B695D3B696628746869732E6D6F';
wwv_flow_imp.g_varchar2_table(43350) := '64652673532E496E636C756465416E6F6E796D6F75737C7C6520696E7374616E63656F66206C537C7C21652E747970652E6973416E6F6E796D6F75737C7C79532865292972657475726E21317D72657475726E21307D6D6F766528652C74297B69662874';
wwv_flow_imp.g_varchar2_table(43351) := '2626746869732E656E7465724368696C6428652C302C34292972657475726E21303B666F72283B3B297B696628746869732E7369626C696E672865292972657475726E21303B696628746869732E61744C6173744E6F64652865297C7C21746869732E70';
wwv_flow_imp.g_varchar2_table(43352) := '6172656E7428292972657475726E21317D7D6E65787428653D2130297B72657475726E20746869732E6D6F766528312C65297D7072657628653D2130297B72657475726E20746869732E6D6F7665282D312C65297D6D6F7665546F28652C743D30297B66';
wwv_flow_imp.g_varchar2_table(43353) := '6F72283B28746869732E66726F6D3D3D746869732E746F7C7C28743C313F746869732E66726F6D3E3D653A746869732E66726F6D3E65297C7C28743E2D313F746869732E746F3C3D653A746869732E746F3C6529292626746869732E706172656E742829';
wwv_flow_imp.g_varchar2_table(43354) := '3B293B666F72283B746869732E656E7465724368696C6428312C652C74293B293B72657475726E20746869737D676574206E6F646528297B69662821746869732E6275666665722972657475726E20746869732E5F747265653B6C657420653D74686973';
wwv_flow_imp.g_varchar2_table(43355) := '2E6275666665724E6F64652C743D6E756C6C2C6E3D303B696628652626652E636F6E746578743D3D746869732E62756666657229653A666F72286C657420693D746869732E696E6465782C6F3D746869732E737461636B2E6C656E6774683B6F3E3D303B';
wwv_flow_imp.g_varchar2_table(43356) := '297B666F72286C657420733D653B733B733D732E5F706172656E7429696628732E696E6465783D3D69297B696628693D3D746869732E696E6465782972657475726E20733B743D732C6E3D6F2B313B627265616B20657D693D746869732E737461636B5B';
wwv_flow_imp.g_varchar2_table(43357) := '2D2D6F5D7D666F72286C657420653D6E3B653C746869732E737461636B2E6C656E6774683B652B2B29743D6E657720665328746869732E6275666665722C742C746869732E737461636B5B655D293B72657475726E20746869732E6275666665724E6F64';
wwv_flow_imp.g_varchar2_table(43358) := '653D6E657720665328746869732E6275666665722C742C746869732E696E646578297D676574207472656528297B72657475726E20746869732E6275666665723F6E756C6C3A746869732E5F747265652E5F747265657D6974657261746528652C74297B';
wwv_flow_imp.g_varchar2_table(43359) := '666F72286C6574206E3D303B3B297B6C657420693D21313B696628746869732E747970652E6973416E6F6E796D6F75737C7C2131213D3D65287468697329297B696628746869732E66697273744368696C642829297B6E2B2B3B636F6E74696E75657D74';
wwv_flow_imp.g_varchar2_table(43360) := '6869732E747970652E6973416E6F6E796D6F75737C7C28693D2130297D666F72283B692626742626742874686973292C693D746869732E747970652E6973416E6F6E796D6F75732C21746869732E6E6578745369626C696E6728293B297B696628216E29';
wwv_flow_imp.g_varchar2_table(43361) := '72657475726E3B746869732E706172656E7428292C6E2D2D2C693D21307D7D7D6D61746368436F6E746578742865297B69662821746869732E6275666665722972657475726E20675328746869732E6E6F64652C65293B6C65747B6275666665723A747D';
wwv_flow_imp.g_varchar2_table(43362) := '3D746869732E6275666665722C7B74797065733A6E7D3D742E7365743B666F72286C657420693D652E6C656E6774682D312C6F3D746869732E737461636B2E6C656E6774682D313B693E3D303B6F2D2D297B6966286F3C302972657475726E2067532874';
wwv_flow_imp.g_varchar2_table(43363) := '6869732E6E6F64652C652C69293B6C657420733D6E5B742E6275666665725B746869732E737461636B5B6F5D5D5D3B69662821732E6973416E6F6E796D6F7573297B696628655B695D2626655B695D213D732E6E616D652972657475726E21313B692D2D';
wwv_flow_imp.g_varchar2_table(43364) := '7D7D72657475726E21307D7D66756E6374696F6E2079532865297B72657475726E20652E6368696C6472656E2E736F6D652828653D3E6520696E7374616E63656F66206C537C7C21652E747970652E6973416E6F6E796D6F75737C7C795328652929297D';
wwv_flow_imp.g_varchar2_table(43365) := '636F6E73742077533D6E6577205765616B4D61703B66756E6374696F6E20435328652C74297B69662821652E6973416E6F6E796D6F75737C7C7420696E7374616E63656F66206C537C7C742E74797065213D652972657475726E20313B6C6574206E3D77';
wwv_flow_imp.g_varchar2_table(43366) := '532E6765742874293B6966286E756C6C3D3D6E297B6E3D313B666F72286C65742069206F6620742E6368696C6472656E297B696628692E74797065213D657C7C21286920696E7374616E63656F6620725329297B6E3D313B627265616B7D6E2B3D435328';
wwv_flow_imp.g_varchar2_table(43367) := '652C69297D77532E73657428742C6E297D72657475726E206E7D66756E6374696F6E20535328652C742C6E2C692C6F2C732C722C612C6C297B6C657420633D303B666F72286C6574206E3D693B6E3C6F3B6E2B2B29632B3D435328652C745B6E5D293B6C';
wwv_flow_imp.g_varchar2_table(43368) := '657420643D4D6174682E6365696C28312E352A632F38292C683D5B5D2C753D5B5D3B72657475726E2066756E6374696F6E2074286E2C692C6F2C722C61297B666F72286C657420633D6F3B633C723B297B6C6574206F3D632C703D695B635D2C673D4353';
wwv_flow_imp.g_varchar2_table(43369) := '28652C6E5B635D293B666F7228632B2B3B633C723B632B2B297B6C657420743D435328652C6E5B635D293B696628672B743E3D6429627265616B3B672B3D747D696628633D3D6F2B31297B696628673E64297B6C657420653D6E5B6F5D3B7428652E6368';
wwv_flow_imp.g_varchar2_table(43370) := '696C6472656E2C652E706F736974696F6E732C302C652E6368696C6472656E2E6C656E6774682C695B6F5D2B61293B636F6E74696E75657D682E70757368286E5B6F5D297D656C73657B6C657420743D695B632D315D2B6E5B632D315D2E6C656E677468';
wwv_flow_imp.g_varchar2_table(43371) := '2D703B682E7075736828535328652C6E2C692C6F2C632C702C742C6E756C6C2C6C29297D752E7075736828702B612D73297D7D28742C6E2C692C6F2C30292C28617C7C6C2928682C752C72297D636C6173732078537B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(43372) := '742C6E2C692C6F3D21312C733D2131297B746869732E66726F6D3D652C746869732E746F3D742C746869732E747265653D6E2C746869732E6F66667365743D692C746869732E6F70656E3D286F3F313A30297C28733F323A30297D676574206F70656E53';
wwv_flow_imp.g_varchar2_table(43373) := '7461727428297B72657475726E283126746869732E6F70656E293E307D676574206F70656E456E6428297B72657475726E283226746869732E6F70656E293E307D737461746963206164645472656528652C743D5B5D2C6E3D2131297B6C657420693D5B';
wwv_flow_imp.g_varchar2_table(43374) := '6E657720785328302C652E6C656E6774682C652C302C21312C6E295D3B666F72286C6574206E206F662074296E2E746F3E652E6C656E6774682626692E70757368286E293B72657475726E20697D737461746963206170706C794368616E67657328652C';
wwv_flow_imp.g_varchar2_table(43375) := '742C6E3D313238297B69662821742E6C656E6774682972657475726E20653B6C657420693D5B5D2C6F3D312C733D652E6C656E6774683F655B305D3A6E756C6C3B666F72286C657420723D302C613D302C6C3D303B3B722B2B297B6C657420633D723C74';
wwv_flow_imp.g_varchar2_table(43376) := '2E6C656E6774683F745B725D3A6E756C6C2C643D633F632E66726F6D413A3165393B696628642D613E3D6E29666F72283B732626732E66726F6D3C643B297B6C657420743D733B696628613E3D742E66726F6D7C7C643C3D742E746F7C7C6C297B6C6574';
wwv_flow_imp.g_varchar2_table(43377) := '20653D4D6174682E6D617828742E66726F6D2C61292D6C2C6E3D4D6174682E6D696E28742E746F2C64292D6C3B743D653E3D6E3F6E756C6C3A6E657720785328652C6E2C742E747265652C742E6F66667365742B6C2C723E302C212163297D6966287426';
wwv_flow_imp.g_varchar2_table(43378) := '26692E707573682874292C732E746F3E6429627265616B3B733D6F3C652E6C656E6774683F655B6F2B2B5D3A6E756C6C7D696628216329627265616B3B613D632E746F412C6C3D632E746F412D632E746F427D72657475726E20697D7D636C617373206B';
wwv_flow_imp.g_varchar2_table(43379) := '537B7374617274506172736528652C742C6E297B72657475726E22737472696E67223D3D747970656F662065262628653D6E6577204553286529292C6E3D6E3F6E2E6C656E6774683F6E2E6D61702828653D3E6E6577205A4328652E66726F6D2C652E74';
wwv_flow_imp.g_varchar2_table(43380) := '6F2929293A5B6E6577205A4328302C30295D3A5B6E6577205A4328302C652E6C656E677468295D2C746869732E637265617465506172736528652C747C7C5B5D2C6E297D706172736528652C742C6E297B6C657420693D746869732E7374617274506172';
wwv_flow_imp.g_varchar2_table(43381) := '736528652C742C6E293B666F72283B3B297B6C657420653D692E616476616E636528293B696628652972657475726E20657D7D7D636C6173732045537B636F6E7374727563746F722865297B746869732E737472696E673D657D676574206C656E677468';
wwv_flow_imp.g_varchar2_table(43382) := '28297B72657475726E20746869732E737472696E672E6C656E6774687D6368756E6B2865297B72657475726E20746869732E737472696E672E736C6963652865297D676574206C696E654368756E6B7328297B72657475726E21317D7265616428652C74';
wwv_flow_imp.g_varchar2_table(43383) := '297B72657475726E20746869732E737472696E672E736C69636528652C74297D7D636C617373204C537B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E7061727365723D652C746869732E70617273653D742C746869732E6F7665';
wwv_flow_imp.g_varchar2_table(43384) := '726C61793D6E2C746869732E7461726765743D692C746869732E66726F6D3D6F7D7D66756E6374696F6E2044532865297B69662821652E6C656E6774687C7C652E736F6D652828653D3E652E66726F6D3E3D652E746F2929297468726F77206E65772052';
wwv_flow_imp.g_varchar2_table(43385) := '616E67654572726F722822496E76616C696420696E6E65722070617273652072616E67657320676976656E3A20222B4A534F4E2E737472696E67696679286529297D636C6173732054537B636F6E7374727563746F7228652C742C6E2C692C6F2C732C72';
wwv_flow_imp.g_varchar2_table(43386) := '297B746869732E7061727365723D652C746869732E7072656469636174653D742C746869732E6D6F756E74733D6E2C746869732E696E6465783D692C746869732E73746172743D6F2C746869732E7461726765743D732C746869732E707265763D722C74';
wwv_flow_imp.g_varchar2_table(43387) := '6869732E64657074683D302C746869732E72616E6765733D5B5D7D7D636F6E73742049533D6E6577205843287B7065724E6F64653A21307D293B636C617373204D537B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E6E6573743D';
wwv_flow_imp.g_varchar2_table(43388) := '742C746869732E696E7075743D6E2C746869732E667261676D656E74733D692C746869732E72616E6765733D6F2C746869732E696E6E65723D5B5D2C746869732E696E6E6572446F6E653D302C746869732E62617365547265653D6E756C6C2C74686973';
wwv_flow_imp.g_varchar2_table(43389) := '2E73746F7070656441743D6E756C6C2C746869732E6261736550617273653D657D616476616E636528297B696628746869732E626173655061727365297B6C657420653D746869732E6261736550617273652E616476616E636528293B69662821652972';
wwv_flow_imp.g_varchar2_table(43390) := '657475726E206E756C6C3B696628746869732E6261736550617273653D6E756C6C2C746869732E62617365547265653D652C746869732E7374617274496E6E657228292C6E756C6C213D746869732E73746F70706564417429666F72286C65742065206F';
wwv_flow_imp.g_varchar2_table(43391) := '6620746869732E696E6E657229652E70617273652E73746F70417428746869732E73746F707065644174297D696628746869732E696E6E6572446F6E653D3D746869732E696E6E65722E6C656E677468297B6C657420653D746869732E62617365547265';
wwv_flow_imp.g_varchar2_table(43392) := '653B72657475726E206E756C6C213D746869732E73746F707065644174262628653D6E657720725328652E747970652C652E6368696C6472656E2C652E706F736974696F6E732C652E6C656E6774682C652E70726F7056616C7565732E636F6E63617428';
wwv_flow_imp.g_varchar2_table(43393) := '5B5B49532C746869732E73746F7070656441745D5D2929292C657D6C657420653D746869732E696E6E65725B746869732E696E6E6572446F6E655D2C743D652E70617273652E616476616E636528293B69662874297B746869732E696E6E6572446F6E65';
wwv_flow_imp.g_varchar2_table(43394) := '2B2B3B6C6574206E3D4F626A6563742E61737369676E284F626A6563742E637265617465286E756C6C292C652E7461726765742E70726F7073293B6E5B58432E6D6F756E7465642E69645D3D6E6577204A4328742C652E6F7665726C61792C652E706172';
wwv_flow_imp.g_varchar2_table(43395) := '736572292C652E7461726765742E70726F70733D6E7D72657475726E206E756C6C7D67657420706172736564506F7328297B696628746869732E6261736550617273652972657475726E20303B6C657420653D746869732E696E7075742E6C656E677468';
wwv_flow_imp.g_varchar2_table(43396) := '3B666F72286C657420743D746869732E696E6E6572446F6E653B743C746869732E696E6E65722E6C656E6774683B742B2B29746869732E696E6E65725B745D2E66726F6D3C65262628653D4D6174682E6D696E28652C746869732E696E6E65725B745D2E';
wwv_flow_imp.g_varchar2_table(43397) := '70617273652E706172736564506F7329293B72657475726E20657D73746F7041742865297B696628746869732E73746F7070656441743D652C746869732E62617365506172736529746869732E6261736550617273652E73746F7041742865293B656C73';
wwv_flow_imp.g_varchar2_table(43398) := '6520666F72286C657420743D746869732E696E6E6572446F6E653B743C746869732E696E6E65722E6C656E6774683B742B2B29746869732E696E6E65725B745D2E70617273652E73746F7041742865297D7374617274496E6E657228297B6C657420653D';
wwv_flow_imp.g_varchar2_table(43399) := '6E657720525328746869732E667261676D656E7473292C743D6E756C6C2C6E3D6E756C6C2C693D6E6577205F53286E657720755328746869732E62617365547265652C746869732E72616E6765735B305D2E66726F6D2C302C6E756C6C292C73532E496E';
wwv_flow_imp.g_varchar2_table(43400) := '636C756465416E6F6E796D6F75737C73532E49676E6F72654D6F756E7473293B653A666F72286C6574206F2C733B3B297B6C657420722C613D21303B6966286E756C6C213D746869732E73746F7070656441742626692E66726F6D3E3D746869732E7374';
wwv_flow_imp.g_varchar2_table(43401) := '6F70706564417429613D21313B656C736520696628652E6861734E6F6465286929297B69662874297B6C657420653D742E6D6F756E74732E66696E642828653D3E652E667261672E66726F6D3C3D692E66726F6D2626652E667261672E746F3E3D692E74';
wwv_flow_imp.g_varchar2_table(43402) := '6F2626652E6D6F756E742E6F7665726C617929293B6966286529666F72286C6574206E206F6620652E6D6F756E742E6F7665726C6179297B6C6574206F3D6E2E66726F6D2B652E706F732C733D6E2E746F2B652E706F733B6F3E3D692E66726F6D262673';
wwv_flow_imp.g_varchar2_table(43403) := '3C3D692E746F262621742E72616E6765732E736F6D652828653D3E652E66726F6D3C732626652E746F3E6F29292626742E72616E6765732E70757368287B66726F6D3A6F2C746F3A737D297D7D613D21317D656C7365206966286E262628733D4153286E';
wwv_flow_imp.g_varchar2_table(43404) := '2E72616E6765732C692E66726F6D2C692E746F292929613D32213D733B656C73652069662821692E747970652E6973416E6F6E796D6F75732626286F3D746869732E6E65737428692C746869732E696E7075742929262628692E66726F6D3C692E746F7C';
wwv_flow_imp.g_varchar2_table(43405) := '7C216F2E6F7665726C617929297B692E747265657C7C50532869293B6C657420733D652E66696E644D6F756E747328692E66726F6D2C6F2E706172736572293B6966282266756E6374696F6E223D3D747970656F66206F2E6F7665726C617929743D6E65';
wwv_flow_imp.g_varchar2_table(43406) := '77205453286F2E7061727365722C6F2E6F7665726C61792C732C746869732E696E6E65722E6C656E6774682C692E66726F6D2C692E747265652C74293B656C73657B6C657420653D465328746869732E72616E6765732C6F2E6F7665726C61797C7C2869';
wwv_flow_imp.g_varchar2_table(43407) := '2E66726F6D3C692E746F3F5B6E6577205A4328692E66726F6D2C692E746F295D3A5B5D29293B652E6C656E677468262644532865292C21652E6C656E67746826266F2E6F7665726C61797C7C746869732E696E6E65722E70757368286E6577204C53286F';
wwv_flow_imp.g_varchar2_table(43408) := '2E7061727365722C652E6C656E6774683F6F2E7061727365722E7374617274506172736528746869732E696E7075742C565328732C65292C65293A6F2E7061727365722E73746172745061727365282222292C6F2E6F7665726C61793F6F2E6F7665726C';
wwv_flow_imp.g_varchar2_table(43409) := '61792E6D61702828653D3E6E6577205A4328652E66726F6D2D692E66726F6D2C652E746F2D692E66726F6D2929293A6E756C6C2C692E747265652C652E6C656E6774683F655B305D2E66726F6D3A692E66726F6D29292C6F2E6F7665726C61793F652E6C';
wwv_flow_imp.g_varchar2_table(43410) := '656E6774682626286E3D7B72616E6765733A652C64657074683A302C707265763A6E7D293A613D21317D7D656C73652074262628723D742E7072656469636174652869292926262821303D3D3D72262628723D6E6577205A4328692E66726F6D2C692E74';
wwv_flow_imp.g_varchar2_table(43411) := '6F29292C722E66726F6D3C722E746F2626742E72616E6765732E70757368287229293B696628612626692E66697273744368696C64282929742626742E64657074682B2B2C6E26266E2E64657074682B2B3B656C736520666F72283B21692E6E65787453';
wwv_flow_imp.g_varchar2_table(43412) := '69626C696E6728293B297B69662821692E706172656E74282929627265616B20653B69662874262621202D2D742E6465707468297B6C657420653D465328746869732E72616E6765732C742E72616E676573293B652E6C656E6774682626284453286529';
wwv_flow_imp.g_varchar2_table(43413) := '2C746869732E696E6E65722E73706C69636528742E696E6465782C302C6E6577204C5328742E7061727365722C742E7061727365722E7374617274506172736528746869732E696E7075742C565328742E6D6F756E74732C65292C65292C742E72616E67';
wwv_flow_imp.g_varchar2_table(43414) := '65732E6D61702828653D3E6E6577205A4328652E66726F6D2D742E73746172742C652E746F2D742E73746172742929292C742E7461726765742C655B305D2E66726F6D2929292C743D742E707265767D6E262621202D2D6E2E64657074682626286E3D6E';
wwv_flow_imp.g_varchar2_table(43415) := '2E70726576297D7D7D7D66756E6374696F6E20415328652C742C6E297B666F72286C65742069206F662065297B696628692E66726F6D3E3D6E29627265616B3B696628692E746F3E742972657475726E20692E66726F6D3C3D742626692E746F3E3D6E3F';
wwv_flow_imp.g_varchar2_table(43416) := '323A317D72657475726E20307D66756E6374696F6E204E5328652C742C6E2C692C6F2C73297B696628743C6E297B6C657420723D652E6275666665725B742B315D3B692E7075736828652E736C69636528742C6E2C7229292C6F2E7075736828722D7329';
wwv_flow_imp.g_varchar2_table(43417) := '7D7D66756E6374696F6E2050532865297B6C65747B6E6F64653A747D3D652C6E3D5B5D2C693D742E636F6E746578742E6275666665723B646F7B6E2E7075736828652E696E646578292C652E706172656E7428297D7768696C652821652E74726565293B';
wwv_flow_imp.g_varchar2_table(43418) := '6C6574206F3D652E747265652C733D6F2E6368696C6472656E2E696E6465784F662869292C723D6F2E6368696C6472656E5B735D2C613D722E6275666665722C6C3D5B735D3B6F2E6368696C6472656E5B735D3D66756E6374696F6E206528692C6F2C73';
wwv_flow_imp.g_varchar2_table(43419) := '2C632C642C68297B6C657420753D6E5B685D2C703D5B5D2C673D5B5D3B4E5328722C692C752C702C672C63293B6C6574206D3D615B752B315D2C663D615B752B325D3B6C2E7075736828702E6C656E677468293B6C657420763D683F6528752B342C615B';
wwv_flow_imp.g_varchar2_table(43420) := '752B335D2C722E7365742E74797065735B615B755D5D2C6D2C662D6D2C682D31293A742E746F5472656528293B72657475726E20702E707573682876292C672E70757368286D2D63292C4E5328722C615B752B335D2C6F2C702C672C63292C6E65772072';
wwv_flow_imp.g_varchar2_table(43421) := '5328732C702C672C64297D28302C612E6C656E6774682C74532E6E6F6E652C302C722E6C656E6774682C6E2E6C656E6774682D31293B666F72286C65742074206F66206C297B6C6574206E3D652E747265652E6368696C6472656E5B745D2C693D652E74';
wwv_flow_imp.g_varchar2_table(43422) := '7265652E706F736974696F6E735B745D3B652E7969656C64286E6577207553286E2C692B652E66726F6D2C742C652E5F7472656529297D7D636C617373204F537B636F6E7374727563746F7228652C74297B746869732E6F66667365743D742C74686973';
wwv_flow_imp.g_varchar2_table(43423) := '2E646F6E653D21312C746869732E637572736F723D652E637572736F722873532E496E636C756465416E6F6E796D6F75737C73532E49676E6F72654D6F756E7473297D6D6F7665546F2865297B6C65747B637572736F723A747D3D746869732C6E3D652D';
wwv_flow_imp.g_varchar2_table(43424) := '746869732E6F66667365743B666F72283B21746869732E646F6E652626742E66726F6D3C6E3B29742E746F3E3D652626742E656E746572286E2C312C73532E49676E6F72654F7665726C6179737C73532E4578636C75646542756666657273297C7C742E';
wwv_flow_imp.g_varchar2_table(43425) := '6E657874282131297C7C28746869732E646F6E653D2130297D6861734E6F64652865297B696628746869732E6D6F7665546F28652E66726F6D292C21746869732E646F6E652626746869732E637572736F722E66726F6D2B746869732E6F66667365743D';
wwv_flow_imp.g_varchar2_table(43426) := '3D652E66726F6D2626746869732E637572736F722E7472656529666F72286C657420743D746869732E637572736F722E747265653B3B297B696628743D3D652E747265652972657475726E21303B6966282128742E6368696C6472656E2E6C656E677468';
wwv_flow_imp.g_varchar2_table(43427) := '2626303D3D742E706F736974696F6E735B305D2626742E6368696C6472656E5B305D696E7374616E63656F662072532929627265616B3B743D742E6368696C6472656E5B305D7D72657475726E21317D7D636C6173732052537B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(43428) := '722865297B76617220743B696628746869732E667261676D656E74733D652C746869732E637572546F3D302C746869732E66726167493D302C652E6C656E677468297B6C6574206E3D746869732E637572467261673D655B305D3B746869732E63757254';
wwv_flow_imp.g_varchar2_table(43429) := '6F3D6E756C6C213D3D28743D6E2E747265652E70726F7028495329292626766F69642030213D3D743F743A6E2E746F2C746869732E696E6E65723D6E6577204F53286E2E747265652C2D6E2E6F6666736574297D656C736520746869732E637572467261';
wwv_flow_imp.g_varchar2_table(43430) := '673D746869732E696E6E65723D6E756C6C7D6861734E6F64652865297B666F72283B746869732E637572467261672626652E66726F6D3E3D746869732E637572546F3B29746869732E6E6578744672616728293B72657475726E20746869732E63757246';
wwv_flow_imp.g_varchar2_table(43431) := '7261672626746869732E637572467261672E66726F6D3C3D652E66726F6D2626746869732E637572546F3E3D652E746F2626746869732E696E6E65722E6861734E6F64652865297D6E6578744672616728297B76617220653B696628746869732E667261';
wwv_flow_imp.g_varchar2_table(43432) := '67492B2B2C746869732E66726167493D3D746869732E667261676D656E74732E6C656E67746829746869732E637572467261673D746869732E696E6E65723D6E756C6C3B656C73657B6C657420743D746869732E637572467261673D746869732E667261';
wwv_flow_imp.g_varchar2_table(43433) := '676D656E74735B746869732E66726167495D3B746869732E637572546F3D6E756C6C213D3D28653D742E747265652E70726F7028495329292626766F69642030213D3D653F653A742E746F2C746869732E696E6E65723D6E6577204F5328742E74726565';
wwv_flow_imp.g_varchar2_table(43434) := '2C2D742E6F6666736574297D7D66696E644D6F756E747328652C74297B766172206E3B6C657420693D5B5D3B696628746869732E696E6E6572297B746869732E696E6E65722E637572736F722E6D6F7665546F28652C31293B666F72286C657420653D74';
wwv_flow_imp.g_varchar2_table(43435) := '6869732E696E6E65722E637572736F722E6E6F64653B653B653D652E706172656E74297B6C6574206F3D6E756C6C3D3D3D286E3D652E74726565297C7C766F696420303D3D3D6E3F766F696420303A6E2E70726F702858432E6D6F756E746564293B6966';
wwv_flow_imp.g_varchar2_table(43436) := '286F26266F2E7061727365723D3D7429666F72286C657420743D746869732E66726167493B743C746869732E667261676D656E74732E6C656E6774683B742B2B297B6C6574206E3D746869732E667261676D656E74735B745D3B6966286E2E66726F6D3E';
wwv_flow_imp.g_varchar2_table(43437) := '3D652E746F29627265616B3B6E2E747265653D3D746869732E637572467261672E747265652626692E70757368287B667261673A6E2C706F733A652E66726F6D2D6E2E6F66667365742C6D6F756E743A6F7D297D7D7D72657475726E20697D7D66756E63';
wwv_flow_imp.g_varchar2_table(43438) := '74696F6E20465328652C74297B6C6574206E3D6E756C6C2C693D743B666F72286C6574206F3D312C733D303B6F3C652E6C656E6774683B6F2B2B297B6C657420723D655B6F2D315D2E746F2C613D655B6F5D2E66726F6D3B666F72283B733C692E6C656E';
wwv_flow_imp.g_varchar2_table(43439) := '6774683B732B2B297B6C657420653D695B735D3B696628652E66726F6D3E3D6129627265616B3B652E746F3C3D727C7C286E7C7C28693D6E3D742E736C6963652829292C652E66726F6D3C723F286E5B735D3D6E6577205A4328652E66726F6D2C72292C';
wwv_flow_imp.g_varchar2_table(43440) := '652E746F3E6126266E2E73706C69636528732B312C302C6E6577205A4328612C652E746F2929293A652E746F3E613F6E5B732D2D5D3D6E6577205A4328612C652E746F293A6E2E73706C69636528732D2D2C3129297D7D72657475726E20697D66756E63';
wwv_flow_imp.g_varchar2_table(43441) := '74696F6E20425328652C742C6E2C69297B6C6574206F3D302C733D302C723D21312C613D21312C6C3D2D3165392C633D5B5D3B666F72283B3B297B6C657420643D6F3D3D652E6C656E6774683F3165393A723F655B6F5D2E746F3A655B6F5D2E66726F6D';
wwv_flow_imp.g_varchar2_table(43442) := '2C683D733D3D742E6C656E6774683F3165393A613F745B735D2E746F3A745B735D2E66726F6D3B69662872213D61297B6C657420653D4D6174682E6D6178286C2C6E292C743D4D6174682E6D696E28642C682C69293B653C742626632E70757368286E65';
wwv_flow_imp.g_varchar2_table(43443) := '77205A4328652C7429297D6966286C3D4D6174682E6D696E28642C68292C3165393D3D6C29627265616B3B643D3D6C262628723F28723D21312C6F2B2B293A723D2130292C683D3D6C262628613F28613D21312C732B2B293A613D2130297D7265747572';
wwv_flow_imp.g_varchar2_table(43444) := '6E20637D66756E6374696F6E20565328652C74297B6C6574206E3D5B5D3B666F72286C65747B706F733A692C6D6F756E743A6F2C667261673A737D6F662065297B6C657420653D692B286F2E6F7665726C61793F6F2E6F7665726C61795B305D2E66726F';
wwv_flow_imp.g_varchar2_table(43445) := '6D3A30292C723D652B6F2E747265652E6C656E6774682C613D4D6174682E6D617828732E66726F6D2C65292C6C3D4D6174682E6D696E28732E746F2C72293B6966286F2E6F7665726C6179297B6C657420723D6F2E6F7665726C61792E6D61702828653D';
wwv_flow_imp.g_varchar2_table(43446) := '3E6E6577205A4328652E66726F6D2B692C652E746F2B692929292C633D425328742C722C612C6C293B666F72286C657420743D302C693D613B3B742B2B297B6C657420723D743D3D632E6C656E6774682C613D723F6C3A635B745D2E66726F6D3B696628';
wwv_flow_imp.g_varchar2_table(43447) := '613E6926266E2E70757368286E657720785328692C612C6F2E747265652C2D652C732E66726F6D3E3D697C7C732E6F70656E53746172742C732E746F3C3D617C7C732E6F70656E456E6429292C7229627265616B3B693D635B745D2E746F7D7D656C7365';
wwv_flow_imp.g_varchar2_table(43448) := '206E2E70757368286E657720785328612C6C2C6F2E747265652C2D652C732E66726F6D3E3D657C7C732E6F70656E53746172742C732E746F3C3D727C7C732E6F70656E456E6429297D72657475726E206E7D636C617373207A537B636F6E737472756374';
wwv_flow_imp.g_varchar2_table(43449) := '6F7228652C742C6E2C692C6F2C732C722C612C6C2C633D302C64297B746869732E703D652C746869732E737461636B3D742C746869732E73746174653D6E2C746869732E726564756365506F733D692C746869732E706F733D6F2C746869732E73636F72';
wwv_flow_imp.g_varchar2_table(43450) := '653D732C746869732E6275666665723D722C746869732E627566666572426173653D612C746869732E637572436F6E746578743D6C2C746869732E6C6F6F6B41686561643D632C746869732E706172656E743D647D746F537472696E6728297B72657475';
wwv_flow_imp.g_varchar2_table(43451) := '726E605B247B746869732E737461636B2E66696C746572282828652C74293D3E7425333D3D3029292E636F6E63617428746869732E7374617465297D5D40247B746869732E706F737D247B746869732E73636F72653F2221222B746869732E73636F7265';
wwv_flow_imp.g_varchar2_table(43452) := '3A22227D607D73746174696320737461727428652C742C6E3D30297B6C657420693D652E7061727365722E636F6E746578743B72657475726E206E6577207A5328652C5B5D2C742C6E2C6E2C302C5B5D2C302C693F6E657720485328692C692E73746172';
wwv_flow_imp.g_varchar2_table(43453) := '74293A6E756C6C2C302C6E756C6C297D67657420636F6E7465787428297B72657475726E20746869732E637572436F6E746578743F746869732E637572436F6E746578742E636F6E746578743A6E756C6C7D70757368537461746528652C74297B746869';
wwv_flow_imp.g_varchar2_table(43454) := '732E737461636B2E7075736828746869732E73746174652C742C746869732E627566666572426173652B746869732E6275666665722E6C656E677468292C746869732E73746174653D657D7265647563652865297B76617220743B6C6574206E3D653E3E';
wwv_flow_imp.g_varchar2_table(43455) := '31392C693D363535333526652C7B7061727365723A6F7D3D746869732E702C733D746869732E726564756365506F733C746869732E706F732D32353B732626746869732E7365744C6F6F6B416865616428746869732E706F73293B6C657420723D6F2E64';
wwv_flow_imp.g_varchar2_table(43456) := '796E616D6963507265636564656E63652869293B69662872262628746869732E73636F72652B3D72292C303D3D6E2972657475726E20746869732E707573685374617465286F2E676574476F746F28746869732E73746174652C692C2130292C74686973';
wwv_flow_imp.g_varchar2_table(43457) := '2E726564756365506F73292C693C6F2E6D696E5265706561745465726D2626746869732E73746F72654E6F646528692C746869732E726564756365506F732C746869732E726564756365506F732C733F383A342C2130292C766F696420746869732E7265';
wwv_flow_imp.g_varchar2_table(43458) := '64756365436F6E7465787428692C746869732E726564756365506F73293B6C657420613D746869732E737461636B2E6C656E6774682D332A286E2D31292D2832363231343426653F363A30292C6C3D613F746869732E737461636B5B612D325D3A746869';
wwv_flow_imp.g_varchar2_table(43459) := '732E702E72616E6765735B305D2E66726F6D2C633D746869732E726564756365506F732D6C3B633E3D326533262621286E756C6C3D3D3D28743D746869732E702E7061727365722E6E6F64655365742E74797065735B695D297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(43460) := '743F766F696420303A742E6973416E6F6E796D6F7573292626286C3D3D746869732E702E6C617374426967526564756374696F6E53746172743F28746869732E702E626967526564756374696F6E436F756E742B2B2C746869732E702E6C617374426967';
wwv_flow_imp.g_varchar2_table(43461) := '526564756374696F6E53697A653D63293A746869732E702E6C617374426967526564756374696F6E53697A653C63262628746869732E702E626967526564756374696F6E436F756E743D312C746869732E702E6C617374426967526564756374696F6E53';
wwv_flow_imp.g_varchar2_table(43462) := '746172743D6C2C746869732E702E6C617374426967526564756374696F6E53697A653D6329293B6C657420643D613F746869732E737461636B5B612D315D3A302C683D746869732E627566666572426173652B746869732E6275666665722E6C656E6774';
wwv_flow_imp.g_varchar2_table(43463) := '682D643B696628693C6F2E6D696E5265706561745465726D7C7C3133313037322665297B6C657420653D6F2E7374617465466C616728746869732E73746174652C31293F746869732E706F733A746869732E726564756365506F733B746869732E73746F';
wwv_flow_imp.g_varchar2_table(43464) := '72654E6F646528692C6C2C652C682B342C2130297D696628323632313434266529746869732E73746174653D746869732E737461636B5B615D3B656C73657B6C657420653D746869732E737461636B5B612D335D3B746869732E73746174653D6F2E6765';
wwv_flow_imp.g_varchar2_table(43465) := '74476F746F28652C692C2130297D666F72283B746869732E737461636B2E6C656E6774683E613B29746869732E737461636B2E706F7028293B746869732E726564756365436F6E7465787428692C6C297D73746F72654E6F646528652C742C6E2C693D34';
wwv_flow_imp.g_varchar2_table(43466) := '2C6F3D2131297B696628303D3D6526262821746869732E737461636B2E6C656E6774687C7C746869732E737461636B5B746869732E737461636B2E6C656E6774682D315D3C746869732E6275666665722E6C656E6774682B746869732E62756666657242';
wwv_flow_imp.g_varchar2_table(43467) := '61736529297B6C657420653D746869732C693D746869732E6275666665722E6C656E6774683B696628303D3D692626652E706172656E74262628693D652E627566666572426173652D652E706172656E742E627566666572426173652C653D652E706172';
wwv_flow_imp.g_varchar2_table(43468) := '656E74292C693E302626303D3D652E6275666665725B692D345D2626652E6275666665725B692D315D3E2D31297B696628743D3D6E2972657475726E3B696628652E6275666665725B692D325D3E3D742972657475726E20766F696428652E6275666665';
wwv_flow_imp.g_varchar2_table(43469) := '725B692D325D3D6E297D7D6966286F2626746869732E706F73213D6E297B6C6574206F3D746869732E6275666665722E6C656E6774683B6966286F3E30262630213D746869732E6275666665725B6F2D345D297B6C657420653D21313B666F72286C6574';
wwv_flow_imp.g_varchar2_table(43470) := '20743D6F3B743E302626746869732E6275666665725B742D325D3E6E3B742D3D3429696628746869732E6275666665725B742D315D3E3D30297B653D21303B627265616B7D6966286529666F72283B6F3E302626746869732E6275666665725B6F2D325D';
wwv_flow_imp.g_varchar2_table(43471) := '3E6E3B29746869732E6275666665725B6F5D3D746869732E6275666665725B6F2D345D2C746869732E6275666665725B6F2B315D3D746869732E6275666665725B6F2D335D2C746869732E6275666665725B6F2B325D3D746869732E6275666665725B6F';
wwv_flow_imp.g_varchar2_table(43472) := '2D325D2C746869732E6275666665725B6F2B335D3D746869732E6275666665725B6F2D315D2C6F2D3D342C693E34262628692D3D34297D746869732E6275666665725B6F5D3D652C746869732E6275666665725B6F2B315D3D742C746869732E62756666';
wwv_flow_imp.g_varchar2_table(43473) := '65725B6F2B325D3D6E2C746869732E6275666665725B6F2B335D3D697D656C736520746869732E6275666665722E7075736828652C742C6E2C69297D736869667428652C742C6E2C69297B696628313331303732266529746869732E7075736853746174';
wwv_flow_imp.g_varchar2_table(43474) := '6528363535333526652C746869732E706F73293B656C736520696628323632313434266529746869732E706F733D692C746869732E7368696674436F6E7465787428742C6E292C743C3D746869732E702E7061727365722E6D61784E6F64652626746869';
wwv_flow_imp.g_varchar2_table(43475) := '732E6275666665722E7075736828742C6E2C692C34293B656C73657B6C6574206F3D652C7B7061727365723A737D3D746869732E703B28693E746869732E706F737C7C743C3D732E6D61784E6F646529262628746869732E706F733D692C732E73746174';
wwv_flow_imp.g_varchar2_table(43476) := '65466C6167286F2C31297C7C28746869732E726564756365506F733D6929292C746869732E707573685374617465286F2C6E292C746869732E7368696674436F6E7465787428742C6E292C743C3D732E6D61784E6F64652626746869732E627566666572';
wwv_flow_imp.g_varchar2_table(43477) := '2E7075736828742C6E2C692C34297D7D6170706C7928652C742C6E2C69297B363535333626653F746869732E7265647563652865293A746869732E736869667428652C742C6E2C69297D7573654E6F646528652C74297B6C6574206E3D746869732E702E';
wwv_flow_imp.g_varchar2_table(43478) := '7265757365642E6C656E6774682D313B286E3C307C7C746869732E702E7265757365645B6E5D213D6529262628746869732E702E7265757365642E707573682865292C6E2B2B293B6C657420693D746869732E706F733B746869732E726564756365506F';
wwv_flow_imp.g_varchar2_table(43479) := '733D746869732E706F733D692B652E6C656E6774682C746869732E70757368537461746528742C69292C746869732E6275666665722E70757368286E2C692C746869732E726564756365506F732C2D31292C746869732E637572436F6E74657874262674';
wwv_flow_imp.g_varchar2_table(43480) := '6869732E757064617465436F6E7465787428746869732E637572436F6E746578742E747261636B65722E726575736528746869732E637572436F6E746578742E636F6E746578742C652C746869732C746869732E702E73747265616D2E72657365742874';
wwv_flow_imp.g_varchar2_table(43481) := '6869732E706F732D652E6C656E6774682929297D73706C697428297B6C657420653D746869732C743D652E6275666665722E6C656E6774683B666F72283B743E302626652E6275666665725B742D325D3E652E726564756365506F733B29742D3D343B6C';
wwv_flow_imp.g_varchar2_table(43482) := '6574206E3D652E6275666665722E736C6963652874292C693D652E627566666572426173652B743B666F72283B652626693D3D652E627566666572426173653B29653D652E706172656E743B72657475726E206E6577207A5328746869732E702C746869';
wwv_flow_imp.g_varchar2_table(43483) := '732E737461636B2E736C69636528292C746869732E73746174652C746869732E726564756365506F732C746869732E706F732C746869732E73636F72652C6E2C692C746869732E637572436F6E746578742C746869732E6C6F6F6B41686561642C65297D';
wwv_flow_imp.g_varchar2_table(43484) := '7265636F766572427944656C65746528652C74297B6C6574206E3D653C3D746869732E702E7061727365722E6D61784E6F64653B6E2626746869732E73746F72654E6F646528652C746869732E706F732C742C34292C746869732E73746F72654E6F6465';
wwv_flow_imp.g_varchar2_table(43485) := '28302C746869732E706F732C742C6E3F383A34292C746869732E706F733D746869732E726564756365506F733D742C746869732E73636F72652D3D3139307D63616E53686966742865297B666F72286C657420743D6E65772057532874686973293B3B29';
wwv_flow_imp.g_varchar2_table(43486) := '7B6C6574206E3D746869732E702E7061727365722E7374617465536C6F7428742E73746174652C34297C7C746869732E702E7061727365722E686173416374696F6E28742E73746174652C65293B696628303D3D6E2972657475726E21313B6966282128';
wwv_flow_imp.g_varchar2_table(43487) := '3635353336266E292972657475726E21303B742E726564756365286E297D7D7265636F7665724279496E736572742865297B696628746869732E737461636B2E6C656E6774683E3D3330302972657475726E5B5D3B6C657420743D746869732E702E7061';
wwv_flow_imp.g_varchar2_table(43488) := '727365722E6E65787453746174657328746869732E7374617465293B696628742E6C656E6774683E387C7C746869732E737461636B2E6C656E6774683E3D313230297B6C6574206E3D5B5D3B666F72286C657420692C6F3D303B6F3C742E6C656E677468';
wwv_flow_imp.g_varchar2_table(43489) := '3B6F2B3D322928693D745B6F2B315D29213D746869732E73746174652626746869732E702E7061727365722E686173416374696F6E28692C652926266E2E7075736828745B6F5D2C69293B696628746869732E737461636B2E6C656E6774683C31323029';
wwv_flow_imp.g_varchar2_table(43490) := '666F72286C657420653D303B6E2E6C656E6774683C382626653C742E6C656E6774683B652B3D32297B6C657420693D745B652B315D3B6E2E736F6D65282828652C74293D3E3126742626653D3D6929297C7C6E2E7075736828745B655D2C69297D743D6E';
wwv_flow_imp.g_varchar2_table(43491) := '7D6C6574206E3D5B5D3B666F72286C657420653D303B653C742E6C656E67746826266E2E6C656E6774683C343B652B3D32297B6C657420693D745B652B315D3B696628693D3D746869732E737461746529636F6E74696E75653B6C6574206F3D74686973';
wwv_flow_imp.g_varchar2_table(43492) := '2E73706C697428293B6F2E70757368537461746528692C746869732E706F73292C6F2E73746F72654E6F646528302C6F2E706F732C6F2E706F732C342C2130292C6F2E7368696674436F6E7465787428745B655D2C746869732E706F73292C6F2E726564';
wwv_flow_imp.g_varchar2_table(43493) := '756365506F733D746869732E706F732C6F2E73636F72652D3D3230302C6E2E70757368286F297D72657475726E206E7D666F72636552656475636528297B6C65747B7061727365723A657D3D746869732E702C743D652E7374617465536C6F7428746869';
wwv_flow_imp.g_varchar2_table(43494) := '732E73746174652C35293B696628212836353533362674292972657475726E21313B69662821652E76616C6964416374696F6E28746869732E73746174652C7429297B6C6574206E3D743E3E31392C693D363535333526742C6F3D746869732E73746163';
wwv_flow_imp.g_varchar2_table(43495) := '6B2E6C656E6774682D332A6E3B6966286F3C307C7C652E676574476F746F28746869732E737461636B5B6F5D2C692C2131293C30297B6C657420653D746869732E66696E64466F72636564526564756374696F6E28293B6966286E756C6C3D3D65297265';
wwv_flow_imp.g_varchar2_table(43496) := '7475726E21313B743D657D746869732E73746F72654E6F646528302C746869732E706F732C746869732E706F732C342C2130292C746869732E73636F72652D3D3130307D72657475726E20746869732E726564756365506F733D746869732E706F732C74';
wwv_flow_imp.g_varchar2_table(43497) := '6869732E7265647563652874292C21307D66696E64466F72636564526564756374696F6E28297B6C65747B7061727365723A657D3D746869732E702C743D5B5D2C6E3D28692C6F293D3E7B69662821742E696E636C756465732869292972657475726E20';
wwv_flow_imp.g_varchar2_table(43498) := '742E707573682869292C652E616C6C416374696F6E7328692C28743D3E7B6966283339333231362674293B656C73652069662836353533362674297B6C6574206E3D28743E3E3139292D6F3B6966286E3E31297B6C657420693D363535333526742C6F3D';
wwv_flow_imp.g_varchar2_table(43499) := '746869732E737461636B2E6C656E6774682D332A6E3B6966286F3E3D302626652E676574476F746F28746869732E737461636B5B6F5D2C692C2131293E3D302972657475726E206E3C3C31397C36353533367C697D7D656C73657B6C657420653D6E2874';
wwv_flow_imp.g_varchar2_table(43500) := '2C6F2B31293B6966286E756C6C213D652972657475726E20657D7D29297D3B72657475726E206E28746869732E73746174652C30297D666F726365416C6C28297B666F72283B21746869732E702E7061727365722E7374617465466C616728746869732E';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(43501) := '73746174652C32293B2969662821746869732E666F7263655265647563652829297B746869732E73746F72654E6F646528302C746869732E706F732C746869732E706F732C342C2130293B627265616B7D72657475726E20746869737D67657420646561';
wwv_flow_imp.g_varchar2_table(43502) := '64456E6428297B69662833213D746869732E737461636B2E6C656E6774682972657475726E21313B6C65747B7061727365723A657D3D746869732E703B72657475726E2036353533353D3D652E646174615B652E7374617465536C6F7428746869732E73';
wwv_flow_imp.g_varchar2_table(43503) := '746174652C31295D262621652E7374617465536C6F7428746869732E73746174652C34297D7265737461727428297B746869732E73746F72654E6F646528302C746869732E706F732C746869732E706F732C342C2130292C746869732E73746174653D74';
wwv_flow_imp.g_varchar2_table(43504) := '6869732E737461636B5B305D2C746869732E737461636B2E6C656E6774683D307D73616D6553746174652865297B696628746869732E7374617465213D652E73746174657C7C746869732E737461636B2E6C656E677468213D652E737461636B2E6C656E';
wwv_flow_imp.g_varchar2_table(43505) := '6774682972657475726E21313B666F72286C657420743D303B743C746869732E737461636B2E6C656E6774683B742B3D3329696628746869732E737461636B5B745D213D652E737461636B5B745D2972657475726E21313B72657475726E21307D676574';
wwv_flow_imp.g_varchar2_table(43506) := '2070617273657228297B72657475726E20746869732E702E7061727365727D6469616C656374456E61626C65642865297B72657475726E20746869732E702E7061727365722E6469616C6563742E666C6167735B655D7D7368696674436F6E7465787428';
wwv_flow_imp.g_varchar2_table(43507) := '652C74297B746869732E637572436F6E746578742626746869732E757064617465436F6E7465787428746869732E637572436F6E746578742E747261636B65722E736869667428746869732E637572436F6E746578742E636F6E746578742C652C746869';
wwv_flow_imp.g_varchar2_table(43508) := '732C746869732E702E73747265616D2E726573657428742929297D726564756365436F6E7465787428652C74297B746869732E637572436F6E746578742626746869732E757064617465436F6E7465787428746869732E637572436F6E746578742E7472';
wwv_flow_imp.g_varchar2_table(43509) := '61636B65722E72656475636528746869732E637572436F6E746578742E636F6E746578742C652C746869732C746869732E702E73747265616D2E726573657428742929297D656D6974436F6E7465787428297B6C657420653D746869732E627566666572';
wwv_flow_imp.g_varchar2_table(43510) := '2E6C656E6774682D313B28653C307C7C2D33213D746869732E6275666665725B655D292626746869732E6275666665722E7075736828746869732E637572436F6E746578742E686173682C746869732E706F732C746869732E706F732C2D33297D656D69';
wwv_flow_imp.g_varchar2_table(43511) := '744C6F6F6B416865616428297B6C657420653D746869732E6275666665722E6C656E6774682D313B28653C307C7C2D34213D746869732E6275666665725B655D292626746869732E6275666665722E7075736828746869732E6C6F6F6B41686561642C74';
wwv_flow_imp.g_varchar2_table(43512) := '6869732E706F732C746869732E706F732C2D34297D757064617465436F6E746578742865297B69662865213D746869732E637572436F6E746578742E636F6E74657874297B6C657420743D6E657720485328746869732E637572436F6E746578742E7472';
wwv_flow_imp.g_varchar2_table(43513) := '61636B65722C65293B742E68617368213D746869732E637572436F6E746578742E686173682626746869732E656D6974436F6E7465787428292C746869732E637572436F6E746578743D747D7D7365744C6F6F6B41686561642865297B653E746869732E';
wwv_flow_imp.g_varchar2_table(43514) := '6C6F6F6B4168656164262628746869732E656D69744C6F6F6B416865616428292C746869732E6C6F6F6B41686561643D65297D636C6F736528297B746869732E637572436F6E746578742626746869732E637572436F6E746578742E747261636B65722E';
wwv_flow_imp.g_varchar2_table(43515) := '7374726963742626746869732E656D6974436F6E7465787428292C746869732E6C6F6F6B41686561643E302626746869732E656D69744C6F6F6B416865616428297D7D636C6173732048537B636F6E7374727563746F7228652C74297B746869732E7472';
wwv_flow_imp.g_varchar2_table(43516) := '61636B65723D652C746869732E636F6E746578743D742C746869732E686173683D652E7374726963743F652E686173682874293A307D7D636C6173732057537B636F6E7374727563746F722865297B746869732E73746172743D652C746869732E737461';
wwv_flow_imp.g_varchar2_table(43517) := '74653D652E73746174652C746869732E737461636B3D652E737461636B2C746869732E626173653D746869732E737461636B2E6C656E6774687D7265647563652865297B6C657420743D363535333526652C6E3D653E3E31393B303D3D6E3F2874686973';
wwv_flow_imp.g_varchar2_table(43518) := '2E737461636B3D3D746869732E73746172742E737461636B262628746869732E737461636B3D746869732E737461636B2E736C6963652829292C746869732E737461636B2E7075736828746869732E73746174652C302C30292C746869732E626173652B';
wwv_flow_imp.g_varchar2_table(43519) := '3D33293A746869732E626173652D3D332A286E2D31293B6C657420693D746869732E73746172742E702E7061727365722E676574476F746F28746869732E737461636B5B746869732E626173652D335D2C742C2130293B746869732E73746174653D697D';
wwv_flow_imp.g_varchar2_table(43520) := '7D636C617373206A537B636F6E7374727563746F7228652C742C6E297B746869732E737461636B3D652C746869732E706F733D742C746869732E696E6465783D6E2C746869732E6275666665723D652E6275666665722C303D3D746869732E696E646578';
wwv_flow_imp.g_varchar2_table(43521) := '2626746869732E6D617962654E65787428297D7374617469632063726561746528652C743D652E627566666572426173652B652E6275666665722E6C656E677468297B72657475726E206E6577206A5328652C742C742D652E6275666665724261736529';
wwv_flow_imp.g_varchar2_table(43522) := '7D6D617962654E65787428297B6C657420653D746869732E737461636B2E706172656E743B6E756C6C213D65262628746869732E696E6465783D746869732E737461636B2E627566666572426173652D652E627566666572426173652C746869732E7374';
wwv_flow_imp.g_varchar2_table(43523) := '61636B3D652C746869732E6275666665723D652E627566666572297D67657420696428297B72657475726E20746869732E6275666665725B746869732E696E6465782D345D7D67657420737461727428297B72657475726E20746869732E627566666572';
wwv_flow_imp.g_varchar2_table(43524) := '5B746869732E696E6465782D335D7D67657420656E6428297B72657475726E20746869732E6275666665725B746869732E696E6465782D325D7D6765742073697A6528297B72657475726E20746869732E6275666665725B746869732E696E6465782D31';
wwv_flow_imp.g_varchar2_table(43525) := '5D7D6E65787428297B746869732E696E6465782D3D342C746869732E706F732D3D342C303D3D746869732E696E6465782626746869732E6D617962654E65787428297D666F726B28297B72657475726E206E6577206A5328746869732E737461636B2C74';
wwv_flow_imp.g_varchar2_table(43526) := '6869732E706F732C746869732E696E646578297D7D66756E6374696F6E20715328652C743D55696E7431364172726179297B69662822737472696E6722213D747970656F6620652972657475726E20653B6C6574206E3D6E756C6C3B666F72286C657420';
wwv_flow_imp.g_varchar2_table(43527) := '693D302C6F3D303B693C652E6C656E6774683B297B6C657420733D303B666F72283B3B297B6C657420743D652E63686172436F6465417428692B2B292C6E3D21313B6966283132363D3D74297B733D36353533353B627265616B7D743E3D39322626742D';
wwv_flow_imp.g_varchar2_table(43528) := '2D2C743E3D33342626742D2D3B6C6574206F3D742D33323B6966286F3E3D34362626286F2D3D34362C6E3D2130292C732B3D6F2C6E29627265616B3B732A3D34367D6E3F6E5B6F2B2B5D3D733A6E3D6E657720742873297D72657475726E206E7D636C61';
wwv_flow_imp.g_varchar2_table(43529) := '73732024537B636F6E7374727563746F7228297B746869732E73746172743D2D312C746869732E76616C75653D2D312C746869732E656E643D2D312C746869732E657874656E6465643D2D312C746869732E6C6F6F6B41686561643D302C746869732E6D';
wwv_flow_imp.g_varchar2_table(43530) := '61736B3D302C746869732E636F6E746578743D307D7D636F6E73742055533D6E65772024533B636C617373204B537B636F6E7374727563746F7228652C74297B746869732E696E7075743D652C746869732E72616E6765733D742C746869732E6368756E';
wwv_flow_imp.g_varchar2_table(43531) := '6B3D22222C746869732E6368756E6B4F66663D302C746869732E6368756E6B323D22222C746869732E6368756E6B32506F733D302C746869732E6E6578743D2D312C746869732E746F6B656E3D55532C746869732E72616E6765496E6465783D302C7468';
wwv_flow_imp.g_varchar2_table(43532) := '69732E706F733D746869732E6368756E6B506F733D745B305D2E66726F6D2C746869732E72616E67653D745B305D2C746869732E656E643D745B742E6C656E6774682D315D2E746F2C746869732E726561644E65787428297D7265736F6C76654F666673';
wwv_flow_imp.g_varchar2_table(43533) := '657428652C74297B6C6574206E3D746869732E72616E67652C693D746869732E72616E6765496E6465782C6F3D746869732E706F732B653B666F72283B6F3C6E2E66726F6D3B297B69662821692972657475726E206E756C6C3B6C657420653D74686973';
wwv_flow_imp.g_varchar2_table(43534) := '2E72616E6765735B2D2D695D3B6F2D3D6E2E66726F6D2D652E746F2C6E3D657D666F72283B743C303F6F3E6E2E746F3A6F3E3D6E2E746F3B297B696628693D3D746869732E72616E6765732E6C656E6774682D312972657475726E206E756C6C3B6C6574';
wwv_flow_imp.g_varchar2_table(43535) := '20653D746869732E72616E6765735B2B2B695D3B6F2B3D652E66726F6D2D6E2E746F2C6E3D657D72657475726E206F7D636C6970506F732865297B696628653E3D746869732E72616E67652E66726F6D2626653C746869732E72616E67652E746F297265';
wwv_flow_imp.g_varchar2_table(43536) := '7475726E20653B666F72286C65742074206F6620746869732E72616E67657329696628742E746F3E652972657475726E204D6174682E6D617828652C742E66726F6D293B72657475726E20746869732E656E647D7065656B2865297B6C657420742C6E2C';
wwv_flow_imp.g_varchar2_table(43537) := '693D746869732E6368756E6B4F66662B653B696628693E3D302626693C746869732E6368756E6B2E6C656E67746829743D746869732E706F732B652C6E3D746869732E6368756E6B2E63686172436F646541742869293B656C73657B6C657420693D7468';
wwv_flow_imp.g_varchar2_table(43538) := '69732E7265736F6C76654F666673657428652C31293B6966286E756C6C3D3D692972657475726E2D313B696628743D692C743E3D746869732E6368756E6B32506F732626743C746869732E6368756E6B32506F732B746869732E6368756E6B322E6C656E';
wwv_flow_imp.g_varchar2_table(43539) := '677468296E3D746869732E6368756E6B322E63686172436F6465417428742D746869732E6368756E6B32506F73293B656C73657B6C657420653D746869732E72616E6765496E6465782C693D746869732E72616E67653B666F72283B692E746F3C3D743B';
wwv_flow_imp.g_varchar2_table(43540) := '29693D746869732E72616E6765735B2B2B655D3B746869732E6368756E6B323D746869732E696E7075742E6368756E6B28746869732E6368756E6B32506F733D74292C742B746869732E6368756E6B322E6C656E6774683E692E746F262628746869732E';
wwv_flow_imp.g_varchar2_table(43541) := '6368756E6B323D746869732E6368756E6B322E736C69636528302C692E746F2D7429292C6E3D746869732E6368756E6B322E63686172436F646541742830297D7D72657475726E20743E3D746869732E746F6B656E2E6C6F6F6B41686561642626287468';
wwv_flow_imp.g_varchar2_table(43542) := '69732E746F6B656E2E6C6F6F6B41686561643D742B31292C6E7D616363657074546F6B656E28652C743D30297B6C6574206E3D743F746869732E7265736F6C76654F666673657428742C2D31293A746869732E706F733B6966286E756C6C3D3D6E7C7C6E';
wwv_flow_imp.g_varchar2_table(43543) := '3C746869732E746F6B656E2E7374617274297468726F77206E65772052616E67654572726F722822546F6B656E20656E64206F7574206F6620626F756E647322293B746869732E746F6B656E2E76616C75653D652C746869732E746F6B656E2E656E643D';
wwv_flow_imp.g_varchar2_table(43544) := '6E7D616363657074546F6B656E546F28652C74297B746869732E746F6B656E2E76616C75653D652C746869732E746F6B656E2E656E643D747D6765744368756E6B28297B696628746869732E706F733E3D746869732E6368756E6B32506F732626746869';
wwv_flow_imp.g_varchar2_table(43545) := '732E706F733C746869732E6368756E6B32506F732B746869732E6368756E6B322E6C656E677468297B6C65747B6368756E6B3A652C6368756E6B506F733A747D3D746869733B746869732E6368756E6B3D746869732E6368756E6B322C746869732E6368';
wwv_flow_imp.g_varchar2_table(43546) := '756E6B506F733D746869732E6368756E6B32506F732C746869732E6368756E6B323D652C746869732E6368756E6B32506F733D742C746869732E6368756E6B4F66663D746869732E706F732D746869732E6368756E6B506F737D656C73657B746869732E';
wwv_flow_imp.g_varchar2_table(43547) := '6368756E6B323D746869732E6368756E6B2C746869732E6368756E6B32506F733D746869732E6368756E6B506F733B6C657420653D746869732E696E7075742E6368756E6B28746869732E706F73292C743D746869732E706F732B652E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(43548) := '746869732E6368756E6B3D743E746869732E72616E67652E746F3F652E736C69636528302C746869732E72616E67652E746F2D746869732E706F73293A652C746869732E6368756E6B506F733D746869732E706F732C746869732E6368756E6B4F66663D';
wwv_flow_imp.g_varchar2_table(43549) := '307D7D726561644E65787428297B72657475726E20746869732E6368756E6B4F66663E3D746869732E6368756E6B2E6C656E677468262628746869732E6765744368756E6B28292C746869732E6368756E6B4F66663D3D746869732E6368756E6B2E6C65';
wwv_flow_imp.g_varchar2_table(43550) := '6E677468293F746869732E6E6578743D2D313A746869732E6E6578743D746869732E6368756E6B2E63686172436F6465417428746869732E6368756E6B4F6666297D616476616E636528653D31297B666F7228746869732E6368756E6B4F66662B3D653B';
wwv_flow_imp.g_varchar2_table(43551) := '746869732E706F732B653E3D746869732E72616E67652E746F3B297B696628746869732E72616E6765496E6465783D3D746869732E72616E6765732E6C656E6774682D312972657475726E20746869732E736574446F6E6528293B652D3D746869732E72';
wwv_flow_imp.g_varchar2_table(43552) := '616E67652E746F2D746869732E706F732C746869732E72616E67653D746869732E72616E6765735B2B2B746869732E72616E6765496E6465785D2C746869732E706F733D746869732E72616E67652E66726F6D7D72657475726E20746869732E706F732B';
wwv_flow_imp.g_varchar2_table(43553) := '3D652C746869732E706F733E3D746869732E746F6B656E2E6C6F6F6B4168656164262628746869732E746F6B656E2E6C6F6F6B41686561643D746869732E706F732B31292C746869732E726561644E65787428297D736574446F6E6528297B7265747572';
wwv_flow_imp.g_varchar2_table(43554) := '6E20746869732E706F733D746869732E6368756E6B506F733D746869732E656E642C746869732E72616E67653D746869732E72616E6765735B746869732E72616E6765496E6465783D746869732E72616E6765732E6C656E6774682D315D2C746869732E';
wwv_flow_imp.g_varchar2_table(43555) := '6368756E6B3D22222C746869732E6E6578743D2D317D726573657428652C74297B696628743F28746869732E746F6B656E3D742C742E73746172743D652C742E6C6F6F6B41686561643D652B312C742E76616C75653D742E657874656E6465643D2D3129';
wwv_flow_imp.g_varchar2_table(43556) := '3A746869732E746F6B656E3D55532C746869732E706F73213D65297B696628746869732E706F733D652C653D3D746869732E656E642972657475726E20746869732E736574446F6E6528292C746869733B666F72283B653C746869732E72616E67652E66';
wwv_flow_imp.g_varchar2_table(43557) := '726F6D3B29746869732E72616E67653D746869732E72616E6765735B2D2D746869732E72616E6765496E6465785D3B666F72283B653E3D746869732E72616E67652E746F3B29746869732E72616E67653D746869732E72616E6765735B2B2B746869732E';
wwv_flow_imp.g_varchar2_table(43558) := '72616E6765496E6465785D3B653E3D746869732E6368756E6B506F732626653C746869732E6368756E6B506F732B746869732E6368756E6B2E6C656E6774683F746869732E6368756E6B4F66663D652D746869732E6368756E6B506F733A28746869732E';
wwv_flow_imp.g_varchar2_table(43559) := '6368756E6B3D22222C746869732E6368756E6B4F66663D30292C746869732E726561644E65787428297D72657475726E20746869737D7265616428652C74297B696628653E3D746869732E6368756E6B506F732626743C3D746869732E6368756E6B506F';
wwv_flow_imp.g_varchar2_table(43560) := '732B746869732E6368756E6B2E6C656E6774682972657475726E20746869732E6368756E6B2E736C69636528652D746869732E6368756E6B506F732C742D746869732E6368756E6B506F73293B696628653E3D746869732E6368756E6B32506F73262674';
wwv_flow_imp.g_varchar2_table(43561) := '3C3D746869732E6368756E6B32506F732B746869732E6368756E6B322E6C656E6774682972657475726E20746869732E6368756E6B322E736C69636528652D746869732E6368756E6B32506F732C742D746869732E6368756E6B32506F73293B69662865';
wwv_flow_imp.g_varchar2_table(43562) := '3E3D746869732E72616E67652E66726F6D2626743C3D746869732E72616E67652E746F2972657475726E20746869732E696E7075742E7265616428652C74293B6C6574206E3D22223B666F72286C65742069206F6620746869732E72616E676573297B69';
wwv_flow_imp.g_varchar2_table(43563) := '6628692E66726F6D3E3D7429627265616B3B692E746F3E652626286E2B3D746869732E696E7075742E72656164284D6174682E6D617828692E66726F6D2C65292C4D6174682E6D696E28692E746F2C742929297D72657475726E206E7D7D636C61737320';
wwv_flow_imp.g_varchar2_table(43564) := '47537B636F6E7374727563746F7228652C74297B746869732E646174613D652C746869732E69643D747D746F6B656E28652C74297B6C65747B7061727365723A6E7D3D742E703B2166756E6374696F6E28652C742C6E2C692C6F2C73297B6C657420723D';
wwv_flow_imp.g_varchar2_table(43565) := '302C613D313C3C692C7B6469616C6563743A6C7D3D6E2E702E7061727365723B653A666F72283B6126655B725D3B297B6C6574206E3D655B722B315D3B666F72286C657420693D722B333B693C6E3B692B3D322969662828655B692B315D2661293E3029';
wwv_flow_imp.g_varchar2_table(43566) := '7B6C6574206E3D655B695D3B6966286C2E616C6C6F7773286E292626282D313D3D742E746F6B656E2E76616C75657C7C742E746F6B656E2E76616C75653D3D6E7C7C5A53286E2C742E746F6B656E2E76616C75652C6F2C732929297B742E616363657074';
wwv_flow_imp.g_varchar2_table(43567) := '546F6B656E286E293B627265616B7D7D6C657420693D742E6E6578742C633D302C643D655B722B325D3B6966282128742E6E6578743C302626643E63262636353533353D3D655B6E2B332A642D335D29297B666F72283B633C643B297B6C6574206F3D63';
wwv_flow_imp.g_varchar2_table(43568) := '2B643E3E312C733D6E2B6F2B286F3C3C31292C613D655B735D2C6C3D655B732B315D7C7C36353533363B696628693C6129643D6F3B656C73657B6966282128693E3D6C29297B723D655B732B325D2C742E616476616E636528293B636F6E74696E756520';
wwv_flow_imp.g_varchar2_table(43569) := '657D633D6F2B317D7D627265616B7D723D655B6E2B332A642D315D7D7D28746869732E646174612C652C742C746869732E69642C6E2E646174612C6E2E746F6B656E507265635461626C65297D7D47532E70726F746F747970652E636F6E746578747561';
wwv_flow_imp.g_varchar2_table(43570) := '6C3D47532E70726F746F747970652E66616C6C6261636B3D47532E70726F746F747970652E657874656E643D21312C47532E70726F746F747970652E66616C6C6261636B3D47532E70726F746F747970652E657874656E643D21313B636C617373205153';
wwv_flow_imp.g_varchar2_table(43571) := '7B636F6E7374727563746F7228652C743D7B7D297B746869732E746F6B656E3D652C746869732E636F6E7465787475616C3D2121742E636F6E7465787475616C2C746869732E66616C6C6261636B3D2121742E66616C6C6261636B2C746869732E657874';
wwv_flow_imp.g_varchar2_table(43572) := '656E643D2121742E657874656E647D7D66756E6374696F6E20595328652C742C6E297B666F72286C657420692C6F3D743B3635353335213D28693D655B6F5D293B6F2B2B29696628693D3D6E2972657475726E206F2D743B72657475726E2D317D66756E';
wwv_flow_imp.g_varchar2_table(43573) := '6374696F6E205A5328652C742C6E2C69297B6C6574206F3D5953286E2C692C74293B72657475726E206F3C307C7C5953286E2C692C65293C6F7D636F6E73742058533D22756E646566696E656422213D747970656F662070726F63657373262670726F63';
wwv_flow_imp.g_varchar2_table(43574) := '6573732E656E7626262F5C6270617273655C622F2E746573742870726F636573732E656E762E4C4F47293B6C6574204A533D6E756C6C3B66756E6374696F6E20657828652C742C6E297B6C657420693D652E637572736F722873532E496E636C75646541';
wwv_flow_imp.g_varchar2_table(43575) := '6E6F6E796D6F7573293B666F7228692E6D6F7665546F2874293B3B2969662821286E3C303F692E6368696C644265666F72652874293A692E6368696C6441667465722874292929666F72283B3B297B696628286E3C303F692E746F3C743A692E66726F6D';
wwv_flow_imp.g_varchar2_table(43576) := '3E7429262621692E747970652E69734572726F722972657475726E206E3C303F4D6174682E6D617828302C4D6174682E6D696E28692E746F2D312C742D323529293A4D6174682E6D696E28652E6C656E6774682C4D6174682E6D617828692E66726F6D2B';
wwv_flow_imp.g_varchar2_table(43577) := '312C742B323529293B6966286E3C303F692E707265765369626C696E6728293A692E6E6578745369626C696E67282929627265616B3B69662821692E706172656E7428292972657475726E206E3C303F303A652E6C656E6774687D7D636C617373207478';
wwv_flow_imp.g_varchar2_table(43578) := '7B636F6E7374727563746F7228652C74297B746869732E667261676D656E74733D652C746869732E6E6F64655365743D742C746869732E693D302C746869732E667261676D656E743D6E756C6C2C746869732E7361666546726F6D3D2D312C746869732E';
wwv_flow_imp.g_varchar2_table(43579) := '73616665546F3D2D312C746869732E74726565733D5B5D2C746869732E73746172743D5B5D2C746869732E696E6465783D5B5D2C746869732E6E657874467261676D656E7428297D6E657874467261676D656E7428297B6C657420653D746869732E6672';
wwv_flow_imp.g_varchar2_table(43580) := '61676D656E743D746869732E693D3D746869732E667261676D656E74732E6C656E6774683F6E756C6C3A746869732E667261676D656E74735B746869732E692B2B5D3B69662865297B666F7228746869732E7361666546726F6D3D652E6F70656E537461';
wwv_flow_imp.g_varchar2_table(43581) := '72743F657828652E747265652C652E66726F6D2B652E6F66667365742C31292D652E6F66667365743A652E66726F6D2C746869732E73616665546F3D652E6F70656E456E643F657828652E747265652C652E746F2B652E6F66667365742C2D31292D652E';
wwv_flow_imp.g_varchar2_table(43582) := '6F66667365743A652E746F3B746869732E74726565732E6C656E6774683B29746869732E74726565732E706F7028292C746869732E73746172742E706F7028292C746869732E696E6465782E706F7028293B746869732E74726565732E7075736828652E';
wwv_flow_imp.g_varchar2_table(43583) := '74726565292C746869732E73746172742E70757368282D652E6F6666736574292C746869732E696E6465782E707573682830292C746869732E6E65787453746172743D746869732E7361666546726F6D7D656C736520746869732E6E6578745374617274';
wwv_flow_imp.g_varchar2_table(43584) := '3D3165397D6E6F646541742865297B696628653C746869732E6E65787453746172742972657475726E206E756C6C3B666F72283B746869732E667261676D656E742626746869732E73616665546F3C3D653B29746869732E6E657874467261676D656E74';
wwv_flow_imp.g_varchar2_table(43585) := '28293B69662821746869732E667261676D656E742972657475726E206E756C6C3B666F72283B3B297B6C657420743D746869732E74726565732E6C656E6774682D313B696628743C302972657475726E20746869732E6E657874467261676D656E742829';
wwv_flow_imp.g_varchar2_table(43586) := '2C6E756C6C3B6C6574206E3D746869732E74726565735B745D2C693D746869732E696E6465785B745D3B696628693D3D6E2E6368696C6472656E2E6C656E677468297B746869732E74726565732E706F7028292C746869732E73746172742E706F702829';
wwv_flow_imp.g_varchar2_table(43587) := '2C746869732E696E6465782E706F7028293B636F6E74696E75657D6C6574206F3D6E2E6368696C6472656E5B695D2C733D746869732E73746172745B745D2B6E2E706F736974696F6E735B695D3B696628733E652972657475726E20746869732E6E6578';
wwv_flow_imp.g_varchar2_table(43588) := '7453746172743D732C6E756C6C3B6966286F20696E7374616E63656F66207253297B696628733D3D65297B696628733C746869732E7361666546726F6D2972657475726E206E756C6C3B6C657420653D732B6F2E6C656E6774683B696628653C3D746869';
wwv_flow_imp.g_varchar2_table(43589) := '732E73616665546F297B6C657420743D6F2E70726F702858432E6C6F6F6B4168656164293B69662821747C7C652B743C746869732E667261676D656E742E746F2972657475726E206F7D7D746869732E696E6465785B745D2B2B2C732B6F2E6C656E6774';
wwv_flow_imp.g_varchar2_table(43590) := '683E3D4D6174682E6D617828746869732E7361666546726F6D2C6529262628746869732E74726565732E70757368286F292C746869732E73746172742E707573682873292C746869732E696E6465782E70757368283029297D656C736520746869732E69';
wwv_flow_imp.g_varchar2_table(43591) := '6E6465785B745D2B2B2C746869732E6E65787453746172743D732B6F2E6C656E6774687D7D7D636C617373206E787B636F6E7374727563746F7228652C74297B746869732E73747265616D3D742C746869732E746F6B656E733D5B5D2C746869732E6D61';
wwv_flow_imp.g_varchar2_table(43592) := '696E546F6B656E3D6E756C6C2C746869732E616374696F6E733D5B5D2C746869732E746F6B656E733D652E746F6B656E697A6572732E6D61702828653D3E6E657720245329297D676574416374696F6E732865297B6C657420743D302C6E3D6E756C6C2C';
wwv_flow_imp.g_varchar2_table(43593) := '7B7061727365723A697D3D652E702C7B746F6B656E697A6572733A6F7D3D692C733D692E7374617465536C6F7428652E73746174652C33292C723D652E637572436F6E746578743F652E637572436F6E746578742E686173683A302C613D303B666F7228';
wwv_flow_imp.g_varchar2_table(43594) := '6C657420693D303B693C6F2E6C656E6774683B692B2B297B6966282128313C3C6926732929636F6E74696E75653B6C6574206C3D6F5B695D2C633D746869732E746F6B656E735B695D3B69662828216E7C7C6C2E66616C6C6261636B29262628286C2E63';
wwv_flow_imp.g_varchar2_table(43595) := '6F6E7465787475616C7C7C632E7374617274213D652E706F737C7C632E6D61736B213D737C7C632E636F6E74657874213D7229262628746869732E757064617465436163686564546F6B656E28632C6C2C65292C632E6D61736B3D732C632E636F6E7465';
wwv_flow_imp.g_varchar2_table(43596) := '78743D72292C632E6C6F6F6B41686561643E632E656E642B3235262628613D4D6174682E6D617828632E6C6F6F6B41686561642C6129292C30213D632E76616C756529297B6C657420693D743B696628632E657874656E6465643E2D31262628743D7468';
wwv_flow_imp.g_varchar2_table(43597) := '69732E616464416374696F6E7328652C632E657874656E6465642C632E656E642C7429292C743D746869732E616464416374696F6E7328652C632E76616C75652C632E656E642C74292C216C2E657874656E642626286E3D632C743E692929627265616B';
wwv_flow_imp.g_varchar2_table(43598) := '7D7D666F72283B746869732E616374696F6E732E6C656E6774683E743B29746869732E616374696F6E732E706F7028293B72657475726E20612626652E7365744C6F6F6B41686561642861292C6E7C7C652E706F73213D746869732E73747265616D2E65';
wwv_flow_imp.g_varchar2_table(43599) := '6E647C7C286E3D6E65772024532C6E2E76616C75653D652E702E7061727365722E656F665465726D2C6E2E73746172743D6E2E656E643D652E706F732C743D746869732E616464416374696F6E7328652C6E2E76616C75652C6E2E656E642C7429292C74';
wwv_flow_imp.g_varchar2_table(43600) := '6869732E6D61696E546F6B656E3D6E2C746869732E616374696F6E737D6765744D61696E546F6B656E2865297B696628746869732E6D61696E546F6B656E2972657475726E20746869732E6D61696E546F6B656E3B6C657420743D6E65772024532C7B70';
wwv_flow_imp.g_varchar2_table(43601) := '6F733A6E2C703A697D3D653B72657475726E20742E73746172743D6E2C742E656E643D4D6174682E6D696E286E2B312C692E73747265616D2E656E64292C742E76616C75653D6E3D3D692E73747265616D2E656E643F692E7061727365722E656F665465';
wwv_flow_imp.g_varchar2_table(43602) := '726D3A302C747D757064617465436163686564546F6B656E28652C742C6E297B6C657420693D746869732E73747265616D2E636C6970506F73286E2E706F73293B696628742E746F6B656E28746869732E73747265616D2E726573657428692C65292C6E';
wwv_flow_imp.g_varchar2_table(43603) := '292C652E76616C75653E2D31297B6C65747B7061727365723A747D3D6E2E703B666F72286C657420693D303B693C742E7370656369616C697A65642E6C656E6774683B692B2B29696628742E7370656369616C697A65645B695D3D3D652E76616C756529';
wwv_flow_imp.g_varchar2_table(43604) := '7B6C6574206F3D742E7370656369616C697A6572735B695D28746869732E73747265616D2E7265616428652E73746172742C652E656E64292C6E293B6966286F3E3D3026266E2E702E7061727365722E6469616C6563742E616C6C6F7773286F3E3E3129';
wwv_flow_imp.g_varchar2_table(43605) := '297B31266F3F652E657874656E6465643D6F3E3E313A652E76616C75653D6F3E3E313B627265616B7D7D7D656C736520652E76616C75653D302C652E656E643D746869732E73747265616D2E636C6970506F7328692B31297D707574416374696F6E2865';
wwv_flow_imp.g_varchar2_table(43606) := '2C742C6E2C69297B666F72286C657420743D303B743C693B742B3D3329696628746869732E616374696F6E735B745D3D3D652972657475726E20693B72657475726E20746869732E616374696F6E735B692B2B5D3D652C746869732E616374696F6E735B';
wwv_flow_imp.g_varchar2_table(43607) := '692B2B5D3D742C746869732E616374696F6E735B692B2B5D3D6E2C697D616464416374696F6E7328652C742C6E2C69297B6C65747B73746174653A6F7D3D652C7B7061727365723A737D3D652E702C7B646174613A727D3D733B666F72286C657420653D';
wwv_flow_imp.g_varchar2_table(43608) := '303B653C323B652B2B29666F72286C657420613D732E7374617465536C6F74286F2C653F323A31293B3B612B3D33297B69662836353533353D3D725B615D297B69662831213D725B612B315D297B303D3D692626323D3D725B612B315D262628693D7468';
wwv_flow_imp.g_varchar2_table(43609) := '69732E707574416374696F6E28637828722C612B32292C742C6E2C6929293B627265616B7D613D637828722C612B32297D725B615D3D3D74262628693D746869732E707574416374696F6E28637828722C612B31292C742C6E2C6929297D72657475726E';
wwv_flow_imp.g_varchar2_table(43610) := '20697D7D636C6173732069787B636F6E7374727563746F7228652C742C6E2C69297B746869732E7061727365723D652C746869732E696E7075743D742C746869732E72616E6765733D692C746869732E7265636F766572696E673D302C746869732E6E65';
wwv_flow_imp.g_varchar2_table(43611) := '7874537461636B49443D393831322C746869732E6D696E537461636B506F733D302C746869732E7265757365643D5B5D2C746869732E73746F7070656441743D6E756C6C2C746869732E6C617374426967526564756374696F6E53746172743D2D312C74';
wwv_flow_imp.g_varchar2_table(43612) := '6869732E6C617374426967526564756374696F6E53697A653D302C746869732E626967526564756374696F6E436F756E743D302C746869732E73747265616D3D6E6577204B5328742C69292C746869732E746F6B656E733D6E6577206E7828652C746869';
wwv_flow_imp.g_varchar2_table(43613) := '732E73747265616D292C746869732E746F705465726D3D652E746F705B315D3B6C65747B66726F6D3A6F7D3D695B305D3B746869732E737461636B733D5B7A532E737461727428746869732C652E746F705B305D2C6F295D2C746869732E667261676D65';
wwv_flow_imp.g_varchar2_table(43614) := '6E74733D6E2E6C656E6774682626746869732E73747265616D2E656E642D6F3E342A652E6275666665724C656E6774683F6E6577207478286E2C652E6E6F6465536574293A6E756C6C7D67657420706172736564506F7328297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(43615) := '732E6D696E537461636B506F737D616476616E636528297B6C657420652C742C6E3D746869732E737461636B732C693D746869732E6D696E537461636B506F732C6F3D746869732E737461636B733D5B5D3B696628746869732E62696752656475637469';
wwv_flow_imp.g_varchar2_table(43616) := '6F6E436F756E743E3330302626313D3D6E2E6C656E677468297B6C65745B655D3D6E3B666F72283B652E666F72636552656475636528292626652E737461636B2E6C656E6774682626652E737461636B5B652E737461636B2E6C656E6774682D325D3E3D';
wwv_flow_imp.g_varchar2_table(43617) := '746869732E6C617374426967526564756374696F6E53746172743B293B746869732E626967526564756374696F6E436F756E743D746869732E6C617374426967526564756374696F6E53697A653D307D666F72286C657420733D303B733C6E2E6C656E67';
wwv_flow_imp.g_varchar2_table(43618) := '74683B732B2B297B6C657420723D6E5B735D3B666F72283B3B297B696628746869732E746F6B656E732E6D61696E546F6B656E3D6E756C6C2C722E706F733E69296F2E707573682872293B656C73657B696628746869732E616476616E6365537461636B';
wwv_flow_imp.g_varchar2_table(43619) := '28722C6F2C6E2929636F6E74696E75653B7B657C7C28653D5B5D2C743D5B5D292C652E707573682872293B6C6574206E3D746869732E746F6B656E732E6765744D61696E546F6B656E2872293B742E70757368286E2E76616C75652C6E2E656E64297D7D';
wwv_flow_imp.g_varchar2_table(43620) := '627265616B7D7D696628216F2E6C656E677468297B6C657420743D65262666756E6374696F6E2865297B6C657420743D6E756C6C3B666F72286C6574206E206F662065297B6C657420653D6E2E702E73746F7070656441743B286E2E706F733D3D6E2E70';
wwv_flow_imp.g_varchar2_table(43621) := '2E73747265616D2E656E647C7C6E756C6C213D6526266E2E706F733E652926266E2E702E7061727365722E7374617465466C6167286E2E73746174652C322926262821747C7C742E73636F72653C6E2E73636F726529262628743D6E297D72657475726E';
wwv_flow_imp.g_varchar2_table(43622) := '20747D2865293B696628742972657475726E2058532626636F6E736F6C652E6C6F67282246696E697368207769746820222B746869732E737461636B4944287429292C746869732E737461636B546F547265652874293B696628746869732E7061727365';
wwv_flow_imp.g_varchar2_table(43623) := '722E737472696374297468726F772058532626652626636F6E736F6C652E6C6F672822537475636B207769746820746F6B656E20222B28746869732E746F6B656E732E6D61696E546F6B656E3F746869732E7061727365722E6765744E616D6528746869';
wwv_flow_imp.g_varchar2_table(43624) := '732E746F6B656E732E6D61696E546F6B656E2E76616C7565293A226E6F6E652229292C6E65772053796E7461784572726F7228224E6F20706172736520617420222B69293B746869732E7265636F766572696E677C7C28746869732E7265636F76657269';
wwv_flow_imp.g_varchar2_table(43625) := '6E673D35297D696628746869732E7265636F766572696E67262665297B6C6574206E3D6E756C6C213D746869732E73746F7070656441742626655B305D2E706F733E746869732E73746F7070656441743F655B305D3A746869732E72756E5265636F7665';
wwv_flow_imp.g_varchar2_table(43626) := '727928652C742C6F293B6966286E2972657475726E2058532626636F6E736F6C652E6C6F672822466F7263652D66696E69736820222B746869732E737461636B4944286E29292C746869732E737461636B546F54726565286E2E666F726365416C6C2829';
wwv_flow_imp.g_varchar2_table(43627) := '297D696628746869732E7265636F766572696E67297B6C657420653D313D3D746869732E7265636F766572696E673F313A332A746869732E7265636F766572696E673B6966286F2E6C656E6774683E6529666F72286F2E736F7274282828652C74293D3E';
wwv_flow_imp.g_varchar2_table(43628) := '742E73636F72652D652E73636F726529293B6F2E6C656E6774683E653B296F2E706F7028293B6F2E736F6D652828653D3E652E726564756365506F733E6929292626746869732E7265636F766572696E672D2D7D656C7365206966286F2E6C656E677468';
wwv_flow_imp.g_varchar2_table(43629) := '3E31297B653A666F72286C657420653D303B653C6F2E6C656E6774682D313B652B2B297B6C657420743D6F5B655D3B666F72286C6574206E3D652B313B6E3C6F2E6C656E6774683B6E2B2B297B6C657420693D6F5B6E5D3B696628742E73616D65537461';
wwv_flow_imp.g_varchar2_table(43630) := '74652869297C7C742E6275666665722E6C656E6774683E3530302626692E6275666665722E6C656E6774683E353030297B696628212828742E73636F72652D692E73636F72657C7C742E6275666665722E6C656E6774682D692E6275666665722E6C656E';
wwv_flow_imp.g_varchar2_table(43631) := '677468293E3029297B6F2E73706C69636528652D2D2C31293B636F6E74696E756520657D6F2E73706C696365286E2D2D2C31297D7D7D6F2E6C656E6774683E313226266F2E73706C6963652831322C6F2E6C656E6774682D3132297D746869732E6D696E';
wwv_flow_imp.g_varchar2_table(43632) := '537461636B506F733D6F5B305D2E706F733B666F72286C657420653D313B653C6F2E6C656E6774683B652B2B296F5B655D2E706F733C746869732E6D696E537461636B506F73262628746869732E6D696E537461636B506F733D6F5B655D2E706F73293B';
wwv_flow_imp.g_varchar2_table(43633) := '72657475726E206E756C6C7D73746F7041742865297B6966286E756C6C213D746869732E73746F7070656441742626746869732E73746F7070656441743C65297468726F77206E65772052616E67654572726F72282243616E2774206D6F76652073746F';
wwv_flow_imp.g_varchar2_table(43634) := '70706564417420666F727761726422293B746869732E73746F7070656441743D657D616476616E6365537461636B28652C742C6E297B6C657420693D652E706F732C7B7061727365723A6F7D3D746869732C733D58533F746869732E737461636B494428';
wwv_flow_imp.g_varchar2_table(43635) := '65292B22202D3E20223A22223B6966286E756C6C213D746869732E73746F7070656441742626693E746869732E73746F7070656441742972657475726E20652E666F72636552656475636528293F653A6E756C6C3B696628746869732E667261676D656E';
wwv_flow_imp.g_varchar2_table(43636) := '7473297B6C657420743D652E637572436F6E746578742626652E637572436F6E746578742E747261636B65722E7374726963742C6E3D743F652E637572436F6E746578742E686173683A303B666F72286C657420723D746869732E667261676D656E7473';
wwv_flow_imp.g_varchar2_table(43637) := '2E6E6F646541742869293B723B297B6C657420693D746869732E7061727365722E6E6F64655365742E74797065735B722E747970652E69645D3D3D722E747970653F6F2E676574476F746F28652E73746174652C722E747970652E6964293A2D313B6966';
wwv_flow_imp.g_varchar2_table(43638) := '28693E2D312626722E6C656E67746826262821747C7C28722E70726F702858432E636F6E7465787448617368297C7C30293D3D6E292972657475726E20652E7573654E6F646528722C69292C58532626636F6E736F6C652E6C6F6728732B746869732E73';
wwv_flow_imp.g_varchar2_table(43639) := '7461636B49442865292B602028766961207265757365206F6620247B6F2E6765744E616D6528722E747970652E6964297D2960292C21303B69662821287220696E7374616E63656F66207253297C7C303D3D722E6368696C6472656E2E6C656E6774687C';
wwv_flow_imp.g_varchar2_table(43640) := '7C722E706F736974696F6E735B305D3E3029627265616B3B6C657420613D722E6368696C6472656E5B305D3B69662821286120696E7374616E63656F662072532626303D3D722E706F736974696F6E735B305D2929627265616B3B723D617D7D6C657420';
wwv_flow_imp.g_varchar2_table(43641) := '723D6F2E7374617465536C6F7428652E73746174652C34293B696628723E302972657475726E20652E7265647563652872292C58532626636F6E736F6C652E6C6F6728732B746869732E737461636B49442865292B60202876696120616C776179732D72';
wwv_flow_imp.g_varchar2_table(43642) := '656475636520247B6F2E6765744E616D652836353533352672297D2960292C21303B696628652E737461636B2E6C656E6774683E3D3834303029666F72283B652E737461636B2E6C656E6774683E3665332626652E666F72636552656475636528293B29';
wwv_flow_imp.g_varchar2_table(43643) := '3B6C657420613D746869732E746F6B656E732E676574416374696F6E732865293B666F72286C657420723D303B723C612E6C656E6774683B297B6C6574206C3D615B722B2B5D2C633D615B722B2B5D2C643D615B722B2B5D2C683D723D3D612E6C656E67';
wwv_flow_imp.g_varchar2_table(43644) := '74687C7C216E2C753D683F653A652E73706C697428292C703D746869732E746F6B656E732E6D61696E546F6B656E3B696628752E6170706C79286C2C632C703F702E73746172743A752E706F732C64292C58532626636F6E736F6C652E6C6F6728732B74';
wwv_flow_imp.g_varchar2_table(43645) := '6869732E737461636B49442875292B60202876696120247B3635353336266C3F60726564756365206F6620247B6F2E6765744E616D65283635353335266C297D603A227368696674227D20666F7220247B6F2E6765744E616D652863297D204020247B69';
wwv_flow_imp.g_varchar2_table(43646) := '7D247B753D3D653F22223A222C2073706C6974227D2960292C682972657475726E21303B752E706F733E693F742E707573682875293A6E2E707573682875297D72657475726E21317D616476616E636546756C6C7928652C74297B6C6574206E3D652E70';
wwv_flow_imp.g_varchar2_table(43647) := '6F733B666F72283B3B297B69662821746869732E616476616E6365537461636B28652C6E756C6C2C6E756C6C292972657475726E21313B696628652E706F733E6E2972657475726E206F7828652C74292C21307D7D72756E5265636F7665727928652C74';
wwv_flow_imp.g_varchar2_table(43648) := '2C6E297B6C657420693D6E756C6C2C6F3D21313B666F72286C657420733D303B733C652E6C656E6774683B732B2B297B6C657420723D655B735D2C613D745B733C3C315D2C6C3D745B312B28733C3C31295D2C633D58533F746869732E737461636B4944';
wwv_flow_imp.g_varchar2_table(43649) := '2872292B22202D3E20223A22223B696628722E64656164456E64297B6966286F29636F6E74696E75653B6966286F3D21302C722E7265737461727428292C58532626636F6E736F6C652E6C6F6728632B746869732E737461636B49442872292B22202872';
wwv_flow_imp.g_varchar2_table(43650) := '65737461727465642922292C746869732E616476616E636546756C6C7928722C6E2929636F6E74696E75657D6C657420643D722E73706C697428292C683D633B666F72286C657420653D303B642E666F72636552656475636528292626653C3130262628';
wwv_flow_imp.g_varchar2_table(43651) := '58532626636F6E736F6C652E6C6F6728682B746869732E737461636B49442864292B22202876696120666F7263652D7265647563652922292C21746869732E616476616E636546756C6C7928642C6E29293B652B2B295853262628683D746869732E7374';
wwv_flow_imp.g_varchar2_table(43652) := '61636B49442864292B22202D3E2022293B666F72286C65742065206F6620722E7265636F7665724279496E736572742861292958532626636F6E736F6C652E6C6F6728632B746869732E737461636B49442865292B222028766961207265636F7665722D';
wwv_flow_imp.g_varchar2_table(43653) := '696E736572742922292C746869732E616476616E636546756C6C7928652C6E293B746869732E73747265616D2E656E643E722E706F733F286C3D3D722E706F732626286C2B2B2C613D30292C722E7265636F766572427944656C65746528612C6C292C58';
wwv_flow_imp.g_varchar2_table(43654) := '532626636F6E736F6C652E6C6F6728632B746869732E737461636B49442872292B602028766961207265636F7665722D64656C65746520247B746869732E7061727365722E6765744E616D652861297D2960292C6F7828722C6E29293A2821697C7C692E';
wwv_flow_imp.g_varchar2_table(43655) := '73636F72653C722E73636F726529262628693D72297D72657475726E20697D737461636B546F547265652865297B72657475726E20652E636C6F736528292C72532E6275696C64287B6275666665723A6A532E6372656174652865292C6E6F6465536574';
wwv_flow_imp.g_varchar2_table(43656) := '3A746869732E7061727365722E6E6F64655365742C746F7049443A746869732E746F705465726D2C6D61784275666665724C656E6774683A746869732E7061727365722E6275666665724C656E6774682C7265757365643A746869732E7265757365642C';
wwv_flow_imp.g_varchar2_table(43657) := '73746172743A746869732E72616E6765735B305D2E66726F6D2C6C656E6774683A652E706F732D746869732E72616E6765735B305D2E66726F6D2C6D696E526570656174547970653A746869732E7061727365722E6D696E5265706561745465726D7D29';
wwv_flow_imp.g_varchar2_table(43658) := '7D737461636B49442865297B6C657420743D284A537C7C284A533D6E6577205765616B4D617029292E6765742865293B72657475726E20747C7C4A532E73657428652C743D537472696E672E66726F6D436F6465506F696E7428746869732E6E65787453';
wwv_flow_imp.g_varchar2_table(43659) := '7461636B49442B2B29292C742B657D7D66756E6374696F6E206F7828652C74297B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B297B6C657420693D745B6E5D3B696628692E706F733D3D652E706F732626692E73616D655374617465';
wwv_flow_imp.g_varchar2_table(43660) := '2865292972657475726E20766F696428745B6E5D2E73636F72653C652E73636F7265262628745B6E5D3D6529297D742E707573682865297D636C6173732073787B636F6E7374727563746F7228652C742C6E297B746869732E736F757263653D652C7468';
wwv_flow_imp.g_varchar2_table(43661) := '69732E666C6167733D742C746869732E64697361626C65643D6E7D616C6C6F77732865297B72657475726E21746869732E64697361626C65647C7C303D3D746869732E64697361626C65645B655D7D7D636F6E73742072783D653D3E653B636C61737320';
wwv_flow_imp.g_varchar2_table(43662) := '61787B636F6E7374727563746F722865297B746869732E73746172743D652E73746172742C746869732E73686966743D652E73686966747C7C72782C746869732E7265647563653D652E7265647563657C7C72782C746869732E72657573653D652E7265';
wwv_flow_imp.g_varchar2_table(43663) := '7573657C7C72782C746869732E686173683D652E686173687C7C2828293D3E30292C746869732E7374726963743D2131213D3D652E7374726963747D7D636C617373206C7820657874656E6473206B537B636F6E7374727563746F722865297B69662873';
wwv_flow_imp.g_varchar2_table(43664) := '7570657228292C746869732E77726170706572733D5B5D2C3134213D652E76657273696F6E297468726F77206E65772052616E67654572726F7228605061727365722076657273696F6E2028247B652E76657273696F6E7D2920646F65736E2774206D61';
wwv_flow_imp.g_varchar2_table(43665) := '7463682072756E74696D652076657273696F6E202831342960293B6C657420743D652E6E6F64654E616D65732E73706C697428222022293B746869732E6D696E5265706561745465726D3D742E6C656E6774683B666F72286C6574206E3D303B6E3C652E';
wwv_flow_imp.g_varchar2_table(43666) := '7265706561744E6F6465436F756E743B6E2B2B29742E70757368282222293B6C6574206E3D4F626A6563742E6B65797328652E746F7052756C6573292E6D61702828743D3E652E746F7052756C65735B745D5B315D29292C693D5B5D3B666F72286C6574';
wwv_flow_imp.g_varchar2_table(43667) := '20653D303B653C742E6C656E6774683B652B2B29692E70757368285B5D293B66756E6374696F6E206F28652C742C6E297B695B655D2E70757368285B742C742E646573657269616C697A6528537472696E67286E29295D297D696628652E6E6F64655072';
wwv_flow_imp.g_varchar2_table(43668) := '6F707329666F72286C65742074206F6620652E6E6F646550726F7073297B6C657420653D745B305D3B22737472696E67223D3D747970656F662065262628653D58435B655D293B666F72286C6574206E3D313B6E3C742E6C656E6774683B297B6C657420';
wwv_flow_imp.g_varchar2_table(43669) := '693D745B6E2B2B5D3B696628693E3D30296F28692C652C745B6E2B2B5D293B656C73657B6C657420733D745B6E2B2D695D3B666F72286C657420723D2D693B723E303B722D2D296F28745B6E2B2B5D2C652C73293B6E2B2B7D7D7D746869732E6E6F6465';
wwv_flow_imp.g_varchar2_table(43670) := '5365743D6E6577206E5328742E6D6170282828742C6F293D3E74532E646566696E65287B6E616D653A6F3E3D746869732E6D696E5265706561745465726D3F766F696420303A742C69643A6F2C70726F70733A695B6F5D2C746F703A6E2E696E6465784F';
wwv_flow_imp.g_varchar2_table(43671) := '66286F293E2D312C6572726F723A303D3D6F2C736B69707065643A652E736B69707065644E6F6465732626652E736B69707065644E6F6465732E696E6465784F66286F293E2D317D292929292C652E70726F70536F7572636573262628746869732E6E6F';
wwv_flow_imp.g_varchar2_table(43672) := '64655365743D746869732E6E6F64655365742E657874656E64282E2E2E652E70726F70536F757263657329292C746869732E7374726963743D21312C746869732E6275666665724C656E6774683D51433B6C657420733D715328652E746F6B656E446174';
wwv_flow_imp.g_varchar2_table(43673) := '61293B746869732E636F6E746578743D652E636F6E746578742C746869732E7370656369616C697A657253706563733D652E7370656369616C697A65647C7C5B5D2C746869732E7370656369616C697A65643D6E65772055696E74313641727261792874';
wwv_flow_imp.g_varchar2_table(43674) := '6869732E7370656369616C697A657253706563732E6C656E677468293B666F72286C657420653D303B653C746869732E7370656369616C697A657253706563732E6C656E6774683B652B2B29746869732E7370656369616C697A65645B655D3D74686973';
wwv_flow_imp.g_varchar2_table(43675) := '2E7370656369616C697A657253706563735B655D2E7465726D3B746869732E7370656369616C697A6572733D746869732E7370656369616C697A657253706563732E6D6170286478292C746869732E7374617465733D715328652E7374617465732C5569';
wwv_flow_imp.g_varchar2_table(43676) := '6E7433324172726179292C746869732E646174613D715328652E737461746544617461292C746869732E676F746F3D715328652E676F746F292C746869732E6D61785465726D3D652E6D61785465726D2C746869732E746F6B656E697A6572733D652E74';
wwv_flow_imp.g_varchar2_table(43677) := '6F6B656E697A6572732E6D61702828653D3E226E756D626572223D3D747970656F6620653F6E657720475328732C65293A6529292C746869732E746F7052756C65733D652E746F7052756C65732C746869732E6469616C656374733D652E6469616C6563';
wwv_flow_imp.g_varchar2_table(43678) := '74737C7C7B7D2C746869732E64796E616D6963507265636564656E6365733D652E64796E616D6963507265636564656E6365737C7C6E756C6C2C746869732E746F6B656E507265635461626C653D652E746F6B656E507265632C746869732E7465726D4E';
wwv_flow_imp.g_varchar2_table(43679) := '616D65733D652E7465726D4E616D65737C7C6E756C6C2C746869732E6D61784E6F64653D746869732E6E6F64655365742E74797065732E6C656E6774682D312C746869732E6469616C6563743D746869732E70617273654469616C65637428292C746869';
wwv_flow_imp.g_varchar2_table(43680) := '732E746F703D746869732E746F7052756C65735B4F626A6563742E6B65797328746869732E746F7052756C6573295B305D5D7D637265617465506172736528652C742C6E297B6C657420693D6E657720697828746869732C652C742C6E293B666F72286C';
wwv_flow_imp.g_varchar2_table(43681) := '6574206F206F6620746869732E777261707065727329693D6F28692C652C742C6E293B72657475726E20697D676574476F746F28652C742C6E3D2131297B6C657420693D746869732E676F746F3B696628743E3D695B305D2972657475726E2D313B666F';
wwv_flow_imp.g_varchar2_table(43682) := '72286C6574206F3D695B742B315D3B3B297B6C657420743D695B6F2B2B5D2C733D3126742C723D695B6F2B2B5D3B6966287326266E2972657475726E20723B666F72286C6574206E3D6F2B28743E3E31293B6F3C6E3B6F2B2B29696628695B6F5D3D3D65';
wwv_flow_imp.g_varchar2_table(43683) := '2972657475726E20723B696628732972657475726E2D317D7D686173416374696F6E28652C74297B6C6574206E3D746869732E646174613B666F72286C657420693D303B693C323B692B2B29666F72286C6574206F2C733D746869732E7374617465536C';
wwv_flow_imp.g_varchar2_table(43684) := '6F7428652C693F323A31293B3B732B3D33297B69662836353533353D3D286F3D6E5B735D29297B69662831213D6E5B732B315D297B696628323D3D6E5B732B315D2972657475726E206378286E2C732B32293B627265616B7D6F3D6E5B733D6378286E2C';
wwv_flow_imp.g_varchar2_table(43685) := '732B32295D7D6966286F3D3D747C7C303D3D6F2972657475726E206378286E2C732B31297D72657475726E20307D7374617465536C6F7428652C74297B72657475726E20746869732E7374617465735B362A652B745D7D7374617465466C616728652C74';
wwv_flow_imp.g_varchar2_table(43686) := '297B72657475726E28746869732E7374617465536C6F7428652C30292674293E307D76616C6964416374696F6E28652C74297B72657475726E2121746869732E616C6C416374696F6E7328652C28653D3E653D3D747C7C6E756C6C29297D616C6C416374';
wwv_flow_imp.g_varchar2_table(43687) := '696F6E7328652C74297B6C6574206E3D746869732E7374617465536C6F7428652C34292C693D6E3F74286E293A766F696420303B666F72286C6574206E3D746869732E7374617465536C6F7428652C31293B6E756C6C3D3D693B6E2B3D33297B69662836';
wwv_flow_imp.g_varchar2_table(43688) := '353533353D3D746869732E646174615B6E5D297B69662831213D746869732E646174615B6E2B315D29627265616B3B6E3D637828746869732E646174612C6E2B32297D693D7428637828746869732E646174612C6E2B3129297D72657475726E20697D6E';
wwv_flow_imp.g_varchar2_table(43689) := '6578745374617465732865297B6C657420743D5B5D3B666F72286C6574206E3D746869732E7374617465536C6F7428652C31293B3B6E2B3D33297B69662836353533353D3D746869732E646174615B6E5D297B69662831213D746869732E646174615B6E';
wwv_flow_imp.g_varchar2_table(43690) := '2B315D29627265616B3B6E3D637828746869732E646174612C6E2B32297D69662821283126746869732E646174615B6E2B325D29297B6C657420653D746869732E646174615B6E2B315D3B742E736F6D65282828742C6E293D3E31266E2626743D3D6529';
wwv_flow_imp.g_varchar2_table(43691) := '297C7C742E7075736828746869732E646174615B6E5D2C65297D7D72657475726E20747D636F6E6669677572652865297B6C657420743D4F626A6563742E61737369676E284F626A6563742E637265617465286C782E70726F746F74797065292C746869';
wwv_flow_imp.g_varchar2_table(43692) := '73293B696628652E70726F7073262628742E6E6F64655365743D746869732E6E6F64655365742E657874656E64282E2E2E652E70726F707329292C652E746F70297B6C6574206E3D746869732E746F7052756C65735B652E746F705D3B696628216E2974';
wwv_flow_imp.g_varchar2_table(43693) := '68726F77206E65772052616E67654572726F722860496E76616C696420746F702072756C65206E616D6520247B652E746F707D60293B742E746F703D6E7D72657475726E20652E746F6B656E697A657273262628742E746F6B656E697A6572733D746869';
wwv_flow_imp.g_varchar2_table(43694) := '732E746F6B656E697A6572732E6D61702828743D3E7B6C6574206E3D652E746F6B656E697A6572732E66696E642828653D3E652E66726F6D3D3D7429293B72657475726E206E3F6E2E746F3A747D2929292C652E7370656369616C697A65727326262874';
wwv_flow_imp.g_varchar2_table(43695) := '2E7370656369616C697A6572733D746869732E7370656369616C697A6572732E736C69636528292C742E7370656369616C697A657253706563733D746869732E7370656369616C697A657253706563732E6D61702828286E2C69293D3E7B6C6574206F3D';
wwv_flow_imp.g_varchar2_table(43696) := '652E7370656369616C697A6572732E66696E642828653D3E652E66726F6D3D3D6E2E65787465726E616C29293B696628216F2972657475726E206E3B6C657420733D4F626A6563742E61737369676E284F626A6563742E61737369676E287B7D2C6E292C';
wwv_flow_imp.g_varchar2_table(43697) := '7B65787465726E616C3A6F2E746F7D293B72657475726E20742E7370656369616C697A6572735B695D3D64782873292C737D2929292C652E636F6E74657874547261636B6572262628742E636F6E746578743D652E636F6E74657874547261636B657229';
wwv_flow_imp.g_varchar2_table(43698) := '2C652E6469616C656374262628742E6469616C6563743D746869732E70617273654469616C65637428652E6469616C65637429292C6E756C6C213D652E737472696374262628742E7374726963743D652E737472696374292C652E77726170262628742E';
wwv_flow_imp.g_varchar2_table(43699) := '77726170706572733D742E77726170706572732E636F6E63617428652E7772617029292C6E756C6C213D652E6275666665724C656E677468262628742E6275666665724C656E6774683D652E6275666665724C656E677468292C747D6861735772617070';
wwv_flow_imp.g_varchar2_table(43700) := '65727328297B72657475726E20746869732E77726170706572732E6C656E6774683E307D6765744E616D652865297B72657475726E20746869732E7465726D4E616D65733F746869732E7465726D4E616D65735B655D3A537472696E6728653C3D746869';
wwv_flow_imp.g_varchar2_table(43701) := '732E6D61784E6F64652626746869732E6E6F64655365742E74797065735B655D2E6E616D657C7C65297D67657420656F665465726D28297B72657475726E20746869732E6D61784E6F64652B317D67657420746F704E6F646528297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(43702) := '6869732E6E6F64655365742E74797065735B746869732E746F705B315D5D7D64796E616D6963507265636564656E63652865297B6C657420743D746869732E64796E616D6963507265636564656E6365733B72657475726E206E756C6C3D3D743F303A74';
wwv_flow_imp.g_varchar2_table(43703) := '5B655D7C7C307D70617273654469616C6563742865297B6C657420743D4F626A6563742E6B65797328746869732E6469616C65637473292C6E3D742E6D6170282828293D3E213129293B6966286529666F72286C65742069206F6620652E73706C697428';
wwv_flow_imp.g_varchar2_table(43704) := '22202229297B6C657420653D742E696E6465784F662869293B653E3D302626286E5B655D3D2130297D6C657420693D6E756C6C3B666F72286C657420653D303B653C742E6C656E6774683B652B2B29696628216E5B655D29666F72286C6574206E2C6F3D';
wwv_flow_imp.g_varchar2_table(43705) := '746869732E6469616C656374735B745B655D5D3B3635353335213D286E3D746869732E646174615B6F2B2B5D293B2928697C7C28693D6E65772055696E7438417272617928746869732E6D61785465726D2B312929295B6E5D3D313B72657475726E206E';
wwv_flow_imp.g_varchar2_table(43706) := '657720737828652C6E2C69297D73746174696320646573657269616C697A652865297B72657475726E206E6577206C782865297D7D66756E6374696F6E20637828652C74297B72657475726E20655B745D7C655B742B315D3C3C31367D66756E6374696F';
wwv_flow_imp.g_varchar2_table(43707) := '6E2064782865297B696628652E65787465726E616C297B6C657420743D652E657874656E643F313A303B72657475726E286E2C69293D3E652E65787465726E616C286E2C69293C3C317C747D72657475726E20652E6765747D6C65742068783D303B636C';
wwv_flow_imp.g_varchar2_table(43708) := '6173732075787B636F6E7374727563746F7228652C742C6E2C69297B746869732E6E616D653D652C746869732E7365743D742C746869732E626173653D6E2C746869732E6D6F6469666965643D692C746869732E69643D68782B2B7D746F537472696E67';
wwv_flow_imp.g_varchar2_table(43709) := '28297B6C65747B6E616D653A657D3D746869733B666F72286C65742074206F6620746869732E6D6F64696669656429742E6E616D65262628653D60247B742E6E616D657D28247B657D2960293B72657475726E20657D73746174696320646566696E6528';
wwv_flow_imp.g_varchar2_table(43710) := '652C74297B6C6574206E3D22737472696E67223D3D747970656F6620653F653A223F223B6966286520696E7374616E63656F66207578262628743D65292C6E756C6C3D3D743F766F696420303A742E62617365297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(43711) := '2243616E206E6F74206465726976652066726F6D2061206D6F6469666965642074616722293B6C657420693D6E6577207578286E2C5B5D2C6E756C6C2C5B5D293B696628692E7365742E707573682869292C7429666F72286C65742065206F6620742E73';
wwv_flow_imp.g_varchar2_table(43712) := '657429692E7365742E707573682865293B72657475726E20697D73746174696320646566696E654D6F6469666965722865297B6C657420743D6E65772067782865293B72657475726E20653D3E652E6D6F6469666965642E696E6465784F662874293E2D';
wwv_flow_imp.g_varchar2_table(43713) := '313F653A67782E67657428652E626173657C7C652C652E6D6F6469666965642E636F6E6361742874292E736F7274282828652C74293D3E652E69642D742E69642929297D7D6C65742070783D303B636C6173732067787B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(43714) := '297B746869732E6E616D653D652C746869732E696E7374616E6365733D5B5D2C746869732E69643D70782B2B7D7374617469632067657428652C74297B69662821742E6C656E6774682972657475726E20653B6C6574206E3D745B305D2E696E7374616E';
wwv_flow_imp.g_varchar2_table(43715) := '6365732E66696E6428286E3D3E6E2E626173653D3D65262666756E6374696F6E28652C74297B72657475726E20652E6C656E6774683D3D742E6C656E6774682626652E6576657279282828652C6E293D3E653D3D745B6E5D29297D28742C6E2E6D6F6469';
wwv_flow_imp.g_varchar2_table(43716) := '666965642929293B6966286E2972657475726E206E3B6C657420693D5B5D2C6F3D6E657720757828652E6E616D652C692C652C74293B666F72286C65742065206F66207429652E696E7374616E6365732E70757368286F293B6C657420733D66756E6374';
wwv_flow_imp.g_varchar2_table(43717) := '696F6E2865297B6C657420743D5B5B5D5D3B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B29666F72286C657420693D302C6F3D742E6C656E6774683B693C6F3B692B2B29742E7075736828745B695D2E636F6E63617428655B6E5D29';
wwv_flow_imp.g_varchar2_table(43718) := '293B72657475726E20742E736F7274282828652C74293D3E742E6C656E6774682D652E6C656E67746829297D2874293B666F72286C65742074206F6620652E7365742969662821742E6D6F6469666965642E6C656E67746829666F72286C65742065206F';
wwv_flow_imp.g_varchar2_table(43719) := '66207329692E707573682867782E67657428742C6529293B72657475726E206F7D7D66756E6374696F6E206D782865297B6C657420743D4F626A6563742E637265617465286E756C6C293B666F72286C6574206E20696E2065297B6C657420693D655B6E';
wwv_flow_imp.g_varchar2_table(43720) := '5D3B41727261792E697341727261792869297C7C28693D5B695D293B666F72286C65742065206F66206E2E73706C697428222022292969662865297B6C6574206E3D5B5D2C6F3D322C733D653B666F72286C657420743D303B3B297B696628222E2E2E22';
wwv_flow_imp.g_varchar2_table(43721) := '3D3D732626743E302626742B333D3D652E6C656E677468297B6F3D313B627265616B7D6C657420693D2F5E22283F3A5B5E225C5C5D7C5C5C2E292A3F227C5B5E5C2F215D2B2F2E657865632873293B6966282169297468726F77206E65772052616E6765';
wwv_flow_imp.g_varchar2_table(43722) := '4572726F722822496E76616C696420706174683A20222B65293B6966286E2E7075736828222A223D3D695B305D3F22223A2722273D3D695B305D5B305D3F4A534F4E2E706172736528695B305D293A695B305D292C742B3D695B305D2E6C656E6774682C';
wwv_flow_imp.g_varchar2_table(43723) := '743D3D652E6C656E67746829627265616B3B6C657420723D655B742B2B5D3B696628743D3D652E6C656E67746826262221223D3D72297B6F3D303B627265616B7D696628222F22213D72297468726F77206E65772052616E67654572726F722822496E76';
wwv_flow_imp.g_varchar2_table(43724) := '616C696420706174683A20222B65293B733D652E736C6963652874297D6C657420723D6E2E6C656E6774682D312C613D6E5B725D3B6966282161297468726F77206E65772052616E67654572726F722822496E76616C696420706174683A20222B65293B';
wwv_flow_imp.g_varchar2_table(43725) := '6C6574206C3D6E657720767828692C6F2C723E303F6E2E736C69636528302C72293A6E756C6C293B745B615D3D6C2E736F727428745B615D297D7D72657475726E2066782E6164642874297D636F6E73742066783D6E65772058433B636C617373207678';
wwv_flow_imp.g_varchar2_table(43726) := '7B636F6E7374727563746F7228652C742C6E2C69297B746869732E746167733D652C746869732E6D6F64653D742C746869732E636F6E746578743D6E2C746869732E6E6578743D697D676574206F706171756528297B72657475726E20303D3D74686973';
wwv_flow_imp.g_varchar2_table(43727) := '2E6D6F64657D67657420696E686572697428297B72657475726E20313D3D746869732E6D6F64657D736F72742865297B72657475726E21657C7C652E64657074683C746869732E64657074683F28746869732E6E6578743D652C74686973293A28652E6E';
wwv_flow_imp.g_varchar2_table(43728) := '6578743D746869732E736F727428652E6E657874292C65297D67657420646570746828297B72657475726E20746869732E636F6E746578743F746869732E636F6E746578742E6C656E6774683A307D7D66756E6374696F6E20627828652C74297B6C6574';
wwv_flow_imp.g_varchar2_table(43729) := '206E3D4F626A6563742E637265617465286E756C6C293B666F72286C65742074206F6620652969662841727261792E6973417272617928742E7461672929666F72286C65742065206F6620742E746167296E5B652E69645D3D742E636C6173733B656C73';
wwv_flow_imp.g_varchar2_table(43730) := '65206E5B742E7461672E69645D3D742E636C6173733B6C65747B73636F70653A692C616C6C3A6F3D6E756C6C7D3D747C7C7B7D3B72657475726E7B7374796C653A653D3E7B6C657420743D6F3B666F72286C65742069206F66206529666F72286C657420';
wwv_flow_imp.g_varchar2_table(43731) := '65206F6620692E736574297B6C657420693D6E5B652E69645D3B69662869297B743D743F742B2220222B693A693B627265616B7D7D72657475726E20747D2C73636F70653A697D7D66756E6374696F6E205F7828652C742C6E2C693D302C6F3D652E6C65';
wwv_flow_imp.g_varchar2_table(43732) := '6E677468297B6C657420733D6E657720797828692C41727261792E697341727261792874293F743A5B745D2C6E293B732E686967686C6967687452616E676528652E637572736F7228292C692C6F2C22222C732E686967686C69676874657273292C732E';
wwv_flow_imp.g_varchar2_table(43733) := '666C757368286F297D76782E656D7074793D6E6577207678285B5D2C322C6E756C6C293B636C6173732079787B636F6E7374727563746F7228652C742C6E297B746869732E61743D652C746869732E686967686C696768746572733D742C746869732E73';
wwv_flow_imp.g_varchar2_table(43734) := '70616E3D6E2C746869732E636C6173733D22227D73746172745370616E28652C74297B74213D746869732E636C617373262628746869732E666C7573682865292C653E746869732E6174262628746869732E61743D65292C746869732E636C6173733D74';
wwv_flow_imp.g_varchar2_table(43735) := '297D666C7573682865297B653E746869732E61742626746869732E636C6173732626746869732E7370616E28746869732E61742C652C746869732E636C617373297D686967686C6967687452616E676528652C742C6E2C692C6F297B6C65747B74797065';
wwv_flow_imp.g_varchar2_table(43736) := '3A732C66726F6D3A722C746F3A617D3D653B696628723E3D6E7C7C613C3D742972657475726E3B732E6973546F702626286F3D746869732E686967686C696768746572732E66696C7465722828653D3E21652E73636F70657C7C652E73636F7065287329';
wwv_flow_imp.g_varchar2_table(43737) := '2929293B6C6574206C3D692C633D66756E6374696F6E2865297B6C657420743D652E747970652E70726F70286678293B666F72283B742626742E636F6E74657874262621652E6D61746368436F6E7465787428742E636F6E74657874293B29743D742E6E';
wwv_flow_imp.g_varchar2_table(43738) := '6578743B72657475726E20747C7C6E756C6C7D2865297C7C76782E656D7074792C643D66756E6374696F6E28652C74297B6C6574206E3D6E756C6C3B666F72286C65742069206F662065297B6C657420653D692E7374796C652874293B652626286E3D6E';
wwv_flow_imp.g_varchar2_table(43739) := '3F6E2B2220222B653A65297D72657475726E206E7D286F2C632E74616773293B696628642626286C2626286C2B3D222022292C6C2B3D642C313D3D632E6D6F6465262628692B3D28693F2220223A2222292B6429292C746869732E73746172745370616E';
wwv_flow_imp.g_varchar2_table(43740) := '284D6174682E6D617828742C72292C6C292C632E6F70617175652972657475726E3B6C657420683D652E747265652626652E747265652E70726F702858432E6D6F756E746564293B696628682626682E6F7665726C6179297B6C657420733D652E6E6F64';
wwv_flow_imp.g_varchar2_table(43741) := '652E656E74657228682E6F7665726C61795B305D2E66726F6D2B722C31292C633D746869732E686967686C696768746572732E66696C7465722828653D3E21652E73636F70657C7C652E73636F706528682E747265652E747970652929292C643D652E66';
wwv_flow_imp.g_varchar2_table(43742) := '697273744368696C6428293B666F72286C657420753D302C703D723B3B752B2B297B6C657420673D753C682E6F7665726C61792E6C656E6774683F682E6F7665726C61795B755D3A6E756C6C2C6D3D673F672E66726F6D2B723A612C663D4D6174682E6D';
wwv_flow_imp.g_varchar2_table(43743) := '617828742C70292C763D4D6174682E6D696E286E2C6D293B696628663C7626266429666F72283B652E66726F6D3C76262628746869732E686967686C6967687452616E676528652C662C762C692C6F292C746869732E73746172745370616E284D617468';
wwv_flow_imp.g_varchar2_table(43744) := '2E6D696E28762C652E746F292C6C292C2128652E746F3E3D6D292626652E6E6578745369626C696E672829293B293B69662821677C7C6D3E6E29627265616B3B703D672E746F2B722C703E74262628746869732E686967686C6967687452616E67652873';
wwv_flow_imp.g_varchar2_table(43745) := '2E637572736F7228292C4D6174682E6D617828742C672E66726F6D2B72292C4D6174682E6D696E286E2C70292C22222C63292C746869732E73746172745370616E284D6174682E6D696E286E2C70292C6C29297D642626652E706172656E7428297D656C';
wwv_flow_imp.g_varchar2_table(43746) := '736520696628652E66697273744368696C642829297B68262628693D2222293B646F7B6966282128652E746F3C3D7429297B696628652E66726F6D3E3D6E29627265616B3B746869732E686967686C6967687452616E676528652C742C6E2C692C6F292C';
wwv_flow_imp.g_varchar2_table(43747) := '746869732E73746172745370616E284D6174682E6D696E286E2C652E746F292C6C297D7D7768696C6528652E6E6578745369626C696E672829293B652E706172656E7428297D7D7D636F6E73742077783D75782E646566696E652C43783D777828292C53';
wwv_flow_imp.g_varchar2_table(43748) := '783D777828292C78783D7778285378292C6B783D7778285378292C45783D777828292C4C783D7778284578292C44783D7778284578292C54783D777828292C49783D7778285478292C4D783D777828292C41783D777828292C4E783D777828292C50783D';
wwv_flow_imp.g_varchar2_table(43749) := '7778284E78292C4F783D777828292C52783D7B636F6D6D656E743A43782C6C696E65436F6D6D656E743A7778284378292C626C6F636B436F6D6D656E743A7778284378292C646F63436F6D6D656E743A7778284378292C6E616D653A53782C7661726961';
wwv_flow_imp.g_varchar2_table(43750) := '626C654E616D653A7778285378292C747970654E616D653A78782C7461674E616D653A7778287878292C70726F70657274794E616D653A6B782C6174747269627574654E616D653A7778286B78292C636C6173734E616D653A7778285378292C6C616265';
wwv_flow_imp.g_varchar2_table(43751) := '6C4E616D653A7778285378292C6E616D6573706163653A7778285378292C6D6163726F4E616D653A7778285378292C6C69746572616C3A45782C737472696E673A4C782C646F63537472696E673A7778284C78292C6368617261637465723A7778284C78';
wwv_flow_imp.g_varchar2_table(43752) := '292C61747472696275746556616C75653A7778284C78292C6E756D6265723A44782C696E74656765723A7778284478292C666C6F61743A7778284478292C626F6F6C3A7778284578292C7265676578703A7778284578292C6573636170653A7778284578';
wwv_flow_imp.g_varchar2_table(43753) := '292C636F6C6F723A7778284578292C75726C3A7778284578292C6B6579776F72643A4D782C73656C663A7778284D78292C6E756C6C3A7778284D78292C61746F6D3A7778284D78292C756E69743A7778284D78292C6D6F6469666965723A7778284D7829';
wwv_flow_imp.g_varchar2_table(43754) := '2C6F70657261746F724B6579776F72643A7778284D78292C636F6E74726F6C4B6579776F72643A7778284D78292C646566696E6974696F6E4B6579776F72643A7778284D78292C6D6F64756C654B6579776F72643A7778284D78292C6F70657261746F72';
wwv_flow_imp.g_varchar2_table(43755) := '3A41782C64657265664F70657261746F723A7778284178292C61726974686D657469634F70657261746F723A7778284178292C6C6F6769634F70657261746F723A7778284178292C626974776973654F70657261746F723A7778284178292C636F6D7061';
wwv_flow_imp.g_varchar2_table(43756) := '72654F70657261746F723A7778284178292C7570646174654F70657261746F723A7778284178292C646566696E6974696F6E4F70657261746F723A7778284178292C747970654F70657261746F723A7778284178292C636F6E74726F6C4F70657261746F';
wwv_flow_imp.g_varchar2_table(43757) := '723A7778284178292C70756E6374756174696F6E3A4E782C736570617261746F723A7778284E78292C627261636B65743A50782C616E676C65427261636B65743A7778285078292C737175617265427261636B65743A7778285078292C706172656E3A77';
wwv_flow_imp.g_varchar2_table(43758) := '78285078292C62726163653A7778285078292C636F6E74656E743A54782C68656164696E673A49782C68656164696E67313A7778284978292C68656164696E67323A7778284978292C68656164696E67333A7778284978292C68656164696E67343A7778';
wwv_flow_imp.g_varchar2_table(43759) := '284978292C68656164696E67353A7778284978292C68656164696E67363A7778284978292C636F6E74656E74536570617261746F723A7778285478292C6C6973743A7778285478292C71756F74653A7778285478292C656D7068617369733A7778285478';
wwv_flow_imp.g_varchar2_table(43760) := '292C7374726F6E673A7778285478292C6C696E6B3A7778285478292C6D6F6E6F73706163653A7778285478292C737472696B657468726F7567683A7778285478292C696E7365727465643A777828292C64656C657465643A777828292C6368616E676564';
wwv_flow_imp.g_varchar2_table(43761) := '3A777828292C696E76616C69643A777828292C6D6574613A4F782C646F63756D656E744D6574613A7778284F78292C616E6E6F746174696F6E3A7778284F78292C70726F63657373696E67496E737472756374696F6E3A7778284F78292C646566696E69';
wwv_flow_imp.g_varchar2_table(43762) := '74696F6E3A75782E646566696E654D6F6469666965722822646566696E6974696F6E22292C636F6E7374616E743A75782E646566696E654D6F6469666965722822636F6E7374616E7422292C66756E6374696F6E3A75782E646566696E654D6F64696669';
wwv_flow_imp.g_varchar2_table(43763) := '6572282266756E6374696F6E22292C7374616E646172643A75782E646566696E654D6F64696669657228227374616E6461726422292C6C6F63616C3A75782E646566696E654D6F64696669657228226C6F63616C22292C7370656369616C3A75782E6465';
wwv_flow_imp.g_varchar2_table(43764) := '66696E654D6F64696669657228227370656369616C22297D3B666F72286C6574206520696E205278297B6C657420743D52785B655D3B7420696E7374616E63656F66207578262628742E6E616D653D65297D6278285B7B7461673A52782E6C696E6B2C63';
wwv_flow_imp.g_varchar2_table(43765) := '6C6173733A22746F6B2D6C696E6B227D2C7B7461673A52782E68656164696E672C636C6173733A22746F6B2D68656164696E67227D2C7B7461673A52782E656D7068617369732C636C6173733A22746F6B2D656D706861736973227D2C7B7461673A5278';
wwv_flow_imp.g_varchar2_table(43766) := '2E7374726F6E672C636C6173733A22746F6B2D7374726F6E67227D2C7B7461673A52782E6B6579776F72642C636C6173733A22746F6B2D6B6579776F7264227D2C7B7461673A52782E61746F6D2C636C6173733A22746F6B2D61746F6D227D2C7B746167';
wwv_flow_imp.g_varchar2_table(43767) := '3A52782E626F6F6C2C636C6173733A22746F6B2D626F6F6C227D2C7B7461673A52782E75726C2C636C6173733A22746F6B2D75726C227D2C7B7461673A52782E6C6162656C4E616D652C636C6173733A22746F6B2D6C6162656C4E616D65227D2C7B7461';
wwv_flow_imp.g_varchar2_table(43768) := '673A52782E696E7365727465642C636C6173733A22746F6B2D696E736572746564227D2C7B7461673A52782E64656C657465642C636C6173733A22746F6B2D64656C65746564227D2C7B7461673A52782E6C69746572616C2C636C6173733A22746F6B2D';
wwv_flow_imp.g_varchar2_table(43769) := '6C69746572616C227D2C7B7461673A52782E737472696E672C636C6173733A22746F6B2D737472696E67227D2C7B7461673A52782E6E756D6265722C636C6173733A22746F6B2D6E756D626572227D2C7B7461673A5B52782E7265676578702C52782E65';
wwv_flow_imp.g_varchar2_table(43770) := '73636170652C52782E7370656369616C2852782E737472696E67295D2C636C6173733A22746F6B2D737472696E6732227D2C7B7461673A52782E7661726961626C654E616D652C636C6173733A22746F6B2D7661726961626C654E616D65227D2C7B7461';
wwv_flow_imp.g_varchar2_table(43771) := '673A52782E6C6F63616C2852782E7661726961626C654E616D65292C636C6173733A22746F6B2D7661726961626C654E616D6520746F6B2D6C6F63616C227D2C7B7461673A52782E646566696E6974696F6E2852782E7661726961626C654E616D65292C';
wwv_flow_imp.g_varchar2_table(43772) := '636C6173733A22746F6B2D7661726961626C654E616D6520746F6B2D646566696E6974696F6E227D2C7B7461673A52782E7370656369616C2852782E7661726961626C654E616D65292C636C6173733A22746F6B2D7661726961626C654E616D6532227D';
wwv_flow_imp.g_varchar2_table(43773) := '2C7B7461673A52782E646566696E6974696F6E2852782E70726F70657274794E616D65292C636C6173733A22746F6B2D70726F70657274794E616D6520746F6B2D646566696E6974696F6E227D2C7B7461673A52782E747970654E616D652C636C617373';
wwv_flow_imp.g_varchar2_table(43774) := '3A22746F6B2D747970654E616D65227D2C7B7461673A52782E6E616D6573706163652C636C6173733A22746F6B2D6E616D657370616365227D2C7B7461673A52782E636C6173734E616D652C636C6173733A22746F6B2D636C6173734E616D65227D2C7B';
wwv_flow_imp.g_varchar2_table(43775) := '7461673A52782E6D6163726F4E616D652C636C6173733A22746F6B2D6D6163726F4E616D65227D2C7B7461673A52782E70726F70657274794E616D652C636C6173733A22746F6B2D70726F70657274794E616D65227D2C7B7461673A52782E6F70657261';
wwv_flow_imp.g_varchar2_table(43776) := '746F722C636C6173733A22746F6B2D6F70657261746F72227D2C7B7461673A52782E636F6D6D656E742C636C6173733A22746F6B2D636F6D6D656E74227D2C7B7461673A52782E6D6574612C636C6173733A22746F6B2D6D657461227D2C7B7461673A52';
wwv_flow_imp.g_varchar2_table(43777) := '782E696E76616C69642C636C6173733A22746F6B2D696E76616C6964227D2C7B7461673A52782E70756E6374756174696F6E2C636C6173733A22746F6B2D70756E6374756174696F6E227D5D293B636C6173732046787B6C696E6541742865297B696628';
wwv_flow_imp.g_varchar2_table(43778) := '653C307C7C653E746869732E6C656E677468297468726F77206E65772052616E67654572726F722860496E76616C696420706F736974696F6E20247B657D20696E20646F63756D656E74206F66206C656E67746820247B746869732E6C656E6774687D60';
wwv_flow_imp.g_varchar2_table(43779) := '293B72657475726E20746869732E6C696E65496E6E657228652C21312C312C30297D6C696E652865297B696628653C317C7C653E746869732E6C696E6573297468726F77206E65772052616E67654572726F722860496E76616C6964206C696E65206E75';
wwv_flow_imp.g_varchar2_table(43780) := '6D62657220247B657D20696E20247B746869732E6C696E65737D2D6C696E6520646F63756D656E7460293B72657475726E20746869732E6C696E65496E6E657228652C21302C312C30297D7265706C61636528652C742C6E297B5B652C745D3D55782874';
wwv_flow_imp.g_varchar2_table(43781) := '6869732C652C74293B6C657420693D5B5D3B72657475726E20746869732E6465636F6D706F736528302C652C692C32292C6E2E6C656E67746826266E2E6465636F6D706F736528302C6E2E6C656E6774682C692C33292C746869732E6465636F6D706F73';
wwv_flow_imp.g_varchar2_table(43782) := '6528742C746869732E6C656E6774682C692C31292C56782E66726F6D28692C746869732E6C656E6774682D28742D65292B6E2E6C656E677468297D617070656E642865297B72657475726E20746869732E7265706C61636528746869732E6C656E677468';
wwv_flow_imp.g_varchar2_table(43783) := '2C746869732E6C656E6774682C65297D736C69636528652C743D746869732E6C656E677468297B5B652C745D3D557828746869732C652C74293B6C6574206E3D5B5D3B72657475726E20746869732E6465636F6D706F736528652C742C6E2C30292C5678';
wwv_flow_imp.g_varchar2_table(43784) := '2E66726F6D286E2C742D65297D65712865297B696628653D3D746869732972657475726E21303B696628652E6C656E677468213D746869732E6C656E6774687C7C652E6C696E6573213D746869732E6C696E65732972657475726E21313B6C657420743D';
wwv_flow_imp.g_varchar2_table(43785) := '746869732E7363616E4964656E746963616C28652C31292C6E3D746869732E6C656E6774682D746869732E7363616E4964656E746963616C28652C2D31292C693D6E65772057782874686973292C6F3D6E65772057782865293B666F72286C657420653D';
wwv_flow_imp.g_varchar2_table(43786) := '742C733D743B3B297B696628692E6E6578742865292C6F2E6E6578742865292C653D302C692E6C696E65427265616B213D6F2E6C696E65427265616B7C7C692E646F6E65213D6F2E646F6E657C7C692E76616C7565213D6F2E76616C7565297265747572';
wwv_flow_imp.g_varchar2_table(43787) := '6E21313B696628732B3D692E76616C75652E6C656E6774682C692E646F6E657C7C733E3D6E2972657475726E21307D7D6974657228653D31297B72657475726E206E657720577828746869732C65297D6974657252616E676528652C743D746869732E6C';
wwv_flow_imp.g_varchar2_table(43788) := '656E677468297B72657475726E206E6577206A7828746869732C652C74297D697465724C696E657328652C74297B6C6574206E3B6966286E756C6C3D3D65296E3D746869732E6974657228293B656C73657B6E756C6C3D3D74262628743D746869732E6C';
wwv_flow_imp.g_varchar2_table(43789) := '696E65732B31293B6C657420693D746869732E6C696E652865292E66726F6D3B6E3D746869732E6974657252616E676528692C4D6174682E6D617828692C743D3D746869732E6C696E65732B313F746869732E6C656E6774683A743C3D313F303A746869';
wwv_flow_imp.g_varchar2_table(43790) := '732E6C696E6528742D31292E746F29297D72657475726E206E6577207178286E297D746F537472696E6728297B72657475726E20746869732E736C696365537472696E672830297D746F4A534F4E28297B6C657420653D5B5D3B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(43791) := '732E666C617474656E2865292C657D636F6E7374727563746F7228297B7D737461746963206F662865297B696628303D3D652E6C656E677468297468726F77206E65772052616E67654572726F7228224120646F63756D656E74206D7573742068617665';
wwv_flow_imp.g_varchar2_table(43792) := '206174206C65617374206F6E65206C696E6522293B72657475726E2031213D652E6C656E6774687C7C655B305D3F652E6C656E6774683C3D33323F6E65772042782865293A56782E66726F6D2842782E73706C697428652C5B5D29293A46782E656D7074';
wwv_flow_imp.g_varchar2_table(43793) := '797D7D636C61737320427820657874656E64732046787B636F6E7374727563746F7228652C743D66756E6374696F6E2865297B6C657420743D2D313B666F72286C6574206E206F66206529742B3D6E2E6C656E6774682B313B72657475726E20747D2865';
wwv_flow_imp.g_varchar2_table(43794) := '29297B737570657228292C746869732E746578743D652C746869732E6C656E6774683D747D676574206C696E657328297B72657475726E20746869732E746578742E6C656E6774687D676574206368696C6472656E28297B72657475726E206E756C6C7D';
wwv_flow_imp.g_varchar2_table(43795) := '6C696E65496E6E657228652C742C6E2C69297B666F72286C6574206F3D303B3B6F2B2B297B6C657420733D746869732E746578745B6F5D2C723D692B732E6C656E6774683B69662828743F6E3A72293E3D652972657475726E206E657720247828692C72';
wwv_flow_imp.g_varchar2_table(43796) := '2C6E2C73293B693D722B312C6E2B2B7D7D6465636F6D706F736528652C742C6E2C69297B6C6574206F3D653C3D302626743E3D746869732E6C656E6774683F746869733A6E657720427828487828746869732E746578742C652C74292C4D6174682E6D69';
wwv_flow_imp.g_varchar2_table(43797) := '6E28742C746869732E6C656E677468292D4D6174682E6D617828302C6529293B696628312669297B6C657420653D6E2E706F7028292C743D7A78286F2E746578742C652E746578742E736C69636528292C302C6F2E6C656E677468293B696628742E6C65';
wwv_flow_imp.g_varchar2_table(43798) := '6E6774683C3D3332296E2E70757368286E657720427828742C652E6C656E6774682B6F2E6C656E67746829293B656C73657B6C657420653D742E6C656E6774683E3E313B6E2E70757368286E657720427828742E736C69636528302C6529292C6E657720';
wwv_flow_imp.g_varchar2_table(43799) := '427828742E736C69636528652929297D7D656C7365206E2E70757368286F297D7265706C61636528652C742C6E297B69662821286E20696E7374616E63656F66204278292972657475726E2073757065722E7265706C61636528652C742C6E293B5B652C';
wwv_flow_imp.g_varchar2_table(43800) := '745D3D557828746869732C652C74293B6C657420693D7A7828746869732E746578742C7A78286E2E746578742C487828746869732E746578742C302C6529292C74292C6F3D746869732E6C656E6774682B6E2E6C656E6774682D28742D65293B72657475';
wwv_flow_imp.g_varchar2_table(43801) := '726E20692E6C656E6774683C3D33323F6E657720427828692C6F293A56782E66726F6D2842782E73706C697428692C5B5D292C6F297D736C696365537472696E6728652C743D746869732E6C656E6774682C6E3D225C6E22297B5B652C745D3D55782874';
wwv_flow_imp.g_varchar2_table(43802) := '6869732C652C74293B6C657420693D22223B666F72286C6574206F3D302C733D303B6F3C3D742626733C746869732E746578742E6C656E6774683B732B2B297B6C657420723D746869732E746578745B735D2C613D6F2B722E6C656E6774683B6F3E6526';
wwv_flow_imp.g_varchar2_table(43803) := '2673262628692B3D6E292C653C612626743E6F262628692B3D722E736C696365284D6174682E6D617828302C652D6F292C742D6F29292C6F3D612B317D72657475726E20697D666C617474656E2865297B666F72286C65742074206F6620746869732E74';
wwv_flow_imp.g_varchar2_table(43804) := '65787429652E707573682874297D7363616E4964656E746963616C28297B72657475726E20307D7374617469632073706C697428652C74297B6C6574206E3D5B5D2C693D2D313B666F72286C6574206F206F662065296E2E70757368286F292C692B3D6F';
wwv_flow_imp.g_varchar2_table(43805) := '2E6C656E6774682B312C33323D3D6E2E6C656E677468262628742E70757368286E6577204278286E2C6929292C6E3D5B5D2C693D2D31293B72657475726E20693E2D312626742E70757368286E6577204278286E2C6929292C747D7D636C617373205678';
wwv_flow_imp.g_varchar2_table(43806) := '20657874656E64732046787B636F6E7374727563746F7228652C74297B737570657228292C746869732E6368696C6472656E3D652C746869732E6C656E6774683D742C746869732E6C696E65733D303B666F72286C65742074206F66206529746869732E';
wwv_flow_imp.g_varchar2_table(43807) := '6C696E65732B3D742E6C696E65737D6C696E65496E6E657228652C742C6E2C69297B666F72286C6574206F3D303B3B6F2B2B297B6C657420733D746869732E6368696C6472656E5B6F5D2C723D692B732E6C656E6774682C613D6E2B732E6C696E65732D';
wwv_flow_imp.g_varchar2_table(43808) := '313B69662828743F613A72293E3D652972657475726E20732E6C696E65496E6E657228652C742C6E2C69293B693D722B312C6E3D612B317D7D6465636F6D706F736528652C742C6E2C69297B666F72286C6574206F3D302C733D303B733C3D7426266F3C';
wwv_flow_imp.g_varchar2_table(43809) := '746869732E6368696C6472656E2E6C656E6774683B6F2B2B297B6C657420723D746869732E6368696C6472656E5B6F5D2C613D732B722E6C656E6774683B696628653C3D612626743E3D73297B6C6574206F3D69262828733C3D653F313A30297C28613E';
wwv_flow_imp.g_varchar2_table(43810) := '3D743F323A3029293B733E3D652626613C3D742626216F3F6E2E707573682872293A722E6465636F6D706F736528652D732C742D732C6E2C6F297D733D612B317D7D7265706C61636528652C742C6E297B6966285B652C745D3D557828746869732C652C';
wwv_flow_imp.g_varchar2_table(43811) := '74292C6E2E6C696E65733C746869732E6C696E657329666F72286C657420693D302C6F3D303B693C746869732E6368696C6472656E2E6C656E6774683B692B2B297B6C657420733D746869732E6368696C6472656E5B695D2C723D6F2B732E6C656E6774';
wwv_flow_imp.g_varchar2_table(43812) := '683B696628653E3D6F2626743C3D72297B6C657420613D732E7265706C61636528652D6F2C742D6F2C6E292C6C3D746869732E6C696E65732D732E6C696E65732B612E6C696E65733B696628612E6C696E65733C6C3E3E342626612E6C696E65733E6C3E';
wwv_flow_imp.g_varchar2_table(43813) := '3E36297B6C6574206F3D746869732E6368696C6472656E2E736C69636528293B72657475726E206F5B695D3D612C6E6577205678286F2C746869732E6C656E6774682D28742D65292B6E2E6C656E677468297D72657475726E2073757065722E7265706C';
wwv_flow_imp.g_varchar2_table(43814) := '616365286F2C722C61297D6F3D722B317D72657475726E2073757065722E7265706C61636528652C742C6E297D736C696365537472696E6728652C743D746869732E6C656E6774682C6E3D225C6E22297B5B652C745D3D557828746869732C652C74293B';
wwv_flow_imp.g_varchar2_table(43815) := '6C657420693D22223B666F72286C6574206F3D302C733D303B6F3C746869732E6368696C6472656E2E6C656E6774682626733C3D743B6F2B2B297B6C657420723D746869732E6368696C6472656E5B6F5D2C613D732B722E6C656E6774683B733E652626';
wwv_flow_imp.g_varchar2_table(43816) := '6F262628692B3D6E292C653C612626743E73262628692B3D722E736C696365537472696E6728652D732C742D732C6E29292C733D612B317D72657475726E20697D666C617474656E2865297B666F72286C65742074206F6620746869732E6368696C6472';
wwv_flow_imp.g_varchar2_table(43817) := '656E29742E666C617474656E2865297D7363616E4964656E746963616C28652C74297B69662821286520696E7374616E63656F66205678292972657475726E20303B6C6574206E3D302C5B692C6F2C732C725D3D743E303F5B302C302C746869732E6368';
wwv_flow_imp.g_varchar2_table(43818) := '696C6472656E2E6C656E6774682C652E6368696C6472656E2E6C656E6774685D3A5B746869732E6368696C6472656E2E6C656E6774682D312C652E6368696C6472656E2E6C656E6774682D312C2D312C2D315D3B666F72283B3B692B3D742C6F2B3D7429';
wwv_flow_imp.g_varchar2_table(43819) := '7B696628693D3D737C7C6F3D3D722972657475726E206E3B6C657420613D746869732E6368696C6472656E5B695D2C6C3D652E6368696C6472656E5B6F5D3B69662861213D6C2972657475726E206E2B612E7363616E4964656E746963616C286C2C7429';
wwv_flow_imp.g_varchar2_table(43820) := '3B6E2B3D612E6C656E6774682B317D7D7374617469632066726F6D28652C743D652E726564756365282828652C74293D3E652B742E6C656E6774682B31292C2D3129297B6C6574206E3D303B666F72286C65742074206F662065296E2B3D742E6C696E65';
wwv_flow_imp.g_varchar2_table(43821) := '733B6966286E3C3332297B6C6574206E3D5B5D3B666F72286C65742074206F66206529742E666C617474656E286E293B72657475726E206E6577204278286E2C74297D6C657420693D4D6174682E6D61782833322C6E3E3E35292C6F3D693C3C312C733D';
wwv_flow_imp.g_varchar2_table(43822) := '693E3E312C723D5B5D2C613D302C6C3D2D312C633D5B5D3B66756E6374696F6E20642865297B6C657420743B696628652E6C696E65733E6F26266520696E7374616E63656F6620567829666F72286C65742074206F6620652E6368696C6472656E296428';
wwv_flow_imp.g_varchar2_table(43823) := '74293B656C736520652E6C696E65733E73262628613E737C7C2161293F286828292C722E70757368286529293A6520696E7374616E63656F66204278262661262628743D635B632E6C656E6774682D315D29696E7374616E63656F662042782626652E6C';
wwv_flow_imp.g_varchar2_table(43824) := '696E65732B742E6C696E65733C3D33323F28612B3D652E6C696E65732C6C2B3D652E6C656E6774682B312C635B632E6C656E6774682D315D3D6E657720427828742E746578742E636F6E63617428652E74657874292C742E6C656E6774682B312B652E6C';
wwv_flow_imp.g_varchar2_table(43825) := '656E67746829293A28612B652E6C696E65733E6926266828292C612B3D652E6C696E65732C6C2B3D652E6C656E6774682B312C632E70757368286529297D66756E6374696F6E206828297B30213D61262628722E7075736828313D3D632E6C656E677468';
wwv_flow_imp.g_varchar2_table(43826) := '3F635B305D3A56782E66726F6D28632C6C29292C6C3D2D312C613D632E6C656E6774683D30297D666F72286C65742074206F66206529642874293B72657475726E206828292C313D3D722E6C656E6774683F725B305D3A6E657720567828722C74297D7D';
wwv_flow_imp.g_varchar2_table(43827) := '66756E6374696F6E207A7828652C742C6E3D302C693D316539297B666F72286C6574206F3D302C733D302C723D21303B733C652E6C656E67746826266F3C3D693B732B2B297B6C657420613D655B735D2C6C3D6F2B612E6C656E6774683B6C3E3D6E2626';
wwv_flow_imp.g_varchar2_table(43828) := '286C3E69262628613D612E736C69636528302C692D6F29292C6F3C6E262628613D612E736C696365286E2D6F29292C723F28745B742E6C656E6774682D315D2B3D612C723D2131293A742E70757368286129292C6F3D6C2B317D72657475726E20747D66';
wwv_flow_imp.g_varchar2_table(43829) := '756E6374696F6E20487828652C742C6E297B72657475726E207A7828652C5B22225D2C742C6E297D46782E656D7074793D6E6577204278285B22225D2C30293B636C6173732057787B636F6E7374727563746F7228652C743D31297B746869732E646972';
wwv_flow_imp.g_varchar2_table(43830) := '3D742C746869732E646F6E653D21312C746869732E6C696E65427265616B3D21312C746869732E76616C75653D22222C746869732E6E6F6465733D5B655D2C746869732E6F6666736574733D5B743E303F313A286520696E7374616E63656F662042783F';
wwv_flow_imp.g_varchar2_table(43831) := '652E746578742E6C656E6774683A652E6368696C6472656E2E6C656E677468293C3C315D7D6E657874496E6E657228652C74297B666F7228746869732E646F6E653D746869732E6C696E65427265616B3D21313B3B297B6C6574206E3D746869732E6E6F';
wwv_flow_imp.g_varchar2_table(43832) := '6465732E6C656E6774682D312C693D746869732E6E6F6465735B6E5D2C6F3D746869732E6F6666736574735B6E5D2C733D6F3E3E312C723D6920696E7374616E63656F662042783F692E746578742E6C656E6774683A692E6368696C6472656E2E6C656E';
wwv_flow_imp.g_varchar2_table(43833) := '6774683B696628733D3D28743E303F723A3029297B696628303D3D6E2972657475726E20746869732E646F6E653D21302C746869732E76616C75653D22222C746869733B743E302626746869732E6F6666736574735B6E2D315D2B2B2C746869732E6E6F';
wwv_flow_imp.g_varchar2_table(43834) := '6465732E706F7028292C746869732E6F6666736574732E706F7028297D656C7365206966282831266F293D3D28743E303F303A3129297B696628746869732E6F6666736574735B6E5D2B3D742C303D3D652972657475726E20746869732E6C696E654272';
wwv_flow_imp.g_varchar2_table(43835) := '65616B3D21302C746869732E76616C75653D225C6E222C746869733B652D2D7D656C7365206966286920696E7374616E63656F66204278297B6C6574206F3D692E746578745B732B28743C303F2D313A30295D3B696628746869732E6F6666736574735B';
wwv_flow_imp.g_varchar2_table(43836) := '6E5D2B3D742C6F2E6C656E6774683E4D6174682E6D617828302C65292972657475726E20746869732E76616C75653D303D3D653F6F3A743E303F6F2E736C6963652865293A6F2E736C69636528302C6F2E6C656E6774682D65292C746869733B652D3D6F';
wwv_flow_imp.g_varchar2_table(43837) := '2E6C656E6774687D656C73657B6C6574206F3D692E6368696C6472656E5B732B28743C303F2D313A30295D3B653E6F2E6C656E6774683F28652D3D6F2E6C656E6774682C746869732E6F6666736574735B6E5D2B3D74293A28743C302626746869732E6F';
wwv_flow_imp.g_varchar2_table(43838) := '6666736574735B6E5D2D2D2C746869732E6E6F6465732E70757368286F292C746869732E6F6666736574732E7075736828743E303F313A286F20696E7374616E63656F662042783F6F2E746578742E6C656E6774683A6F2E6368696C6472656E2E6C656E';
wwv_flow_imp.g_varchar2_table(43839) := '677468293C3C3129297D7D7D6E65787428653D30297B72657475726E20653C30262628746869732E6E657874496E6E6572282D652C2D746869732E646972292C653D746869732E76616C75652E6C656E677468292C746869732E6E657874496E6E657228';
wwv_flow_imp.g_varchar2_table(43840) := '652C746869732E646972297D7D636C617373206A787B636F6E7374727563746F7228652C742C6E297B746869732E76616C75653D22222C746869732E646F6E653D21312C746869732E637572736F723D6E657720577828652C743E6E3F2D313A31292C74';
wwv_flow_imp.g_varchar2_table(43841) := '6869732E706F733D743E6E3F652E6C656E6774683A302C746869732E66726F6D3D4D6174682E6D696E28742C6E292C746869732E746F3D4D6174682E6D617828742C6E297D6E657874496E6E657228652C74297B696628743C303F746869732E706F733C';
wwv_flow_imp.g_varchar2_table(43842) := '3D746869732E66726F6D3A746869732E706F733E3D746869732E746F2972657475726E20746869732E76616C75653D22222C746869732E646F6E653D21302C746869733B652B3D4D6174682E6D617828302C743C303F746869732E706F732D746869732E';
wwv_flow_imp.g_varchar2_table(43843) := '746F3A746869732E66726F6D2D746869732E706F73293B6C6574206E3D743C303F746869732E706F732D746869732E66726F6D3A746869732E746F2D746869732E706F733B653E6E262628653D6E292C6E2D3D653B6C65747B76616C75653A697D3D7468';
wwv_flow_imp.g_varchar2_table(43844) := '69732E637572736F722E6E6578742865293B72657475726E20746869732E706F732B3D28692E6C656E6774682B65292A742C746869732E76616C75653D692E6C656E6774683C3D6E3F693A743C303F692E736C69636528692E6C656E6774682D6E293A69';
wwv_flow_imp.g_varchar2_table(43845) := '2E736C69636528302C6E292C746869732E646F6E653D21746869732E76616C75652C746869737D6E65787428653D30297B72657475726E20653C303F653D4D6174682E6D617828652C746869732E66726F6D2D746869732E706F73293A653E3026262865';
wwv_flow_imp.g_varchar2_table(43846) := '3D4D6174682E6D696E28652C746869732E746F2D746869732E706F7329292C746869732E6E657874496E6E657228652C746869732E637572736F722E646972297D676574206C696E65427265616B28297B72657475726E20746869732E637572736F722E';
wwv_flow_imp.g_varchar2_table(43847) := '6C696E65427265616B26262222213D746869732E76616C75657D7D636C6173732071787B636F6E7374727563746F722865297B746869732E696E6E65723D652C746869732E6166746572427265616B3D21302C746869732E76616C75653D22222C746869';
wwv_flow_imp.g_varchar2_table(43848) := '732E646F6E653D21317D6E65787428653D30297B6C65747B646F6E653A742C6C696E65427265616B3A6E2C76616C75653A697D3D746869732E696E6E65722E6E6578742865293B72657475726E20742626746869732E6166746572427265616B3F287468';
wwv_flow_imp.g_varchar2_table(43849) := '69732E76616C75653D22222C746869732E6166746572427265616B3D2131293A743F28746869732E646F6E653D21302C746869732E76616C75653D2222293A6E3F746869732E6166746572427265616B3F746869732E76616C75653D22223A2874686973';
wwv_flow_imp.g_varchar2_table(43850) := '2E6166746572427265616B3D21302C746869732E6E6578742829293A28746869732E76616C75653D692C746869732E6166746572427265616B3D2131292C746869737D676574206C696E65427265616B28297B72657475726E21317D7D22756E64656669';
wwv_flow_imp.g_varchar2_table(43851) := '6E656422213D747970656F662053796D626F6C26262846782E70726F746F747970655B53796D626F6C2E6974657261746F725D3D66756E6374696F6E28297B72657475726E20746869732E6974657228297D2C57782E70726F746F747970655B53796D62';
wwv_flow_imp.g_varchar2_table(43852) := '6F6C2E6974657261746F725D3D6A782E70726F746F747970655B53796D626F6C2E6974657261746F725D3D71782E70726F746F747970655B53796D626F6C2E6974657261746F725D3D66756E6374696F6E28297B72657475726E20746869737D293B636C';
wwv_flow_imp.g_varchar2_table(43853) := '6173732024787B636F6E7374727563746F7228652C742C6E2C69297B746869732E66726F6D3D652C746869732E746F3D742C746869732E6E756D6265723D6E2C746869732E746578743D697D676574206C656E67746828297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(43854) := '2E746F2D746869732E66726F6D7D7D66756E6374696F6E20557828652C742C6E297B72657475726E5B743D4D6174682E6D617828302C4D6174682E6D696E28652E6C656E6774682C7429292C4D6174682E6D617828742C4D6174682E6D696E28652E6C65';
wwv_flow_imp.g_varchar2_table(43855) := '6E6774682C6E29295D7D6C6574204B783D226C632C33342C376E2C372C37622C31392C2C2C2C322C2C322C2C2C32302C622C31632C6C2C672C2C32742C372C322C362C322C322C2C342C7A2C2C752C722C326A2C622C316D2C392C392C2C6F2C342C2C39';
wwv_flow_imp.g_varchar2_table(43856) := '2C2C332C2C352C31372C332C33622C662C2C772C316A2C2C2C2C342C382C342C2C332C372C612C322C742C2C316D2C2C2C2C322C342C382C2C392C2C612C322C712C2C322C322C316C2C2C342C322C342C322C322C332C332C2C752C322C332C2C622C32';
wwv_flow_imp.g_varchar2_table(43857) := '2C316C2C2C342C352C2C322C342C2C6B2C322C6D2C362C2C2C316D2C2C2C322C2C342C382C2C372C332C612C322C752C2C316E2C2C2C2C632C2C392C2C31342C2C332C2C316C2C332C352C332C2C342C372C322C622C322C742C2C316D2C2C322C2C322C';
wwv_flow_imp.g_varchar2_table(43858) := '2C332C2C352C322C372C322C622C322C732C322C316C2C322C2C2C322C342C382C2C392C2C612C322C742C2C32302C2C342C2C322C332C2C2C382C2C32392C2C322C372C632C382C32712C2C322C392C622C362C32322C322C722C2C2C2C2C2C316A2C65';
wwv_flow_imp.g_varchar2_table(43859) := '2C2C352C2C322C352C622C2C31302C392C2C32752C342C2C362C2C322C322C322C702C322C342C332C672C342C642C2C322C322C362C2C662C2C6A6A2C332C71612C332C742C332C742C322C752C322C31732C322C2C372C382C2C322C622C392C2C3139';
wwv_flow_imp.g_varchar2_table(43860) := '2C332C33622C322C792C2C33612C332C342C322C392C2C362C332C36332C322C322C2C316D2C2C2C372C2C2C2C2C322C382C362C612C322C2C31632C682C31722C342C31632C372C2C2C352C2C31342C392C632C322C772C342C322C322C2C332C316B2C';
wwv_flow_imp.g_varchar2_table(43861) := '2C2C322C332C2C2C332C316D2C382C322C322C34382C332C2C642C2C372C342C2C362C2C332C322C35692C316D2C2C352C656B2C2C35662C782C3264612C332C33782C2C326F2C772C66652C362C32782C322C6E39772C342C2C612C772C322C32382C32';
wwv_flow_imp.g_varchar2_table(43862) := '2C376B2C2C332C2C342C2C702C322C352C2C34372C322C712C692C642C2C31322C382C702C622C31612C332C31632C2C322C342C322C322C31332C2C31762C362C322C322C322C322C632C2C382C2C31622C2C31662C2C2C332C322C322C352C322C2C2C';
wwv_flow_imp.g_varchar2_table(43863) := '31362C322C382C2C366D2C2C322C2C342C2C666E342C2C6B682C672C672C672C61362C322C67742C2C36612C2C34352C352C3161652C332C2C322C352C342C31342C332C342C2C346C2C322C66782C342C61722C322C34392C622C34772C2C31692C662C';
wwv_flow_imp.g_varchar2_table(43864) := '316B2C332C31642C342C322C322C31782C332C31302C352C2C382C31712C2C632C322C31672C392C612C342C322C2C326E2C332C322C2C2C322C362C2C34672C2C332C382C6C2C322C316C2C322C2C2C2C2C6D2C2C652C372C332C352C35662C382C322C';
wwv_flow_imp.g_varchar2_table(43865) := '332C2C2C6E2C2C32392C2C322C362C2C2C322C2C2C322C2C322C366A2C2C322C342C362C322C2C322C722C322C32642C382C322C2C2C322C32792C2C2C2C322C362C2C2C32742C332C322C342C2C352C37372C392C2C322C36742C2C612C322C2C2C342C';
wwv_flow_imp.g_varchar2_table(43866) := '2C34302C342C322C322C342C2C772C612C31342C362C322C342C382C2C392C362C322C332C31612C642C2C322C62612C372C2C362C2C2C32612C6D2C322C372C2C322C2C322C33652C362C332C2C2C322C2C372C2C2C32302C322C332C2C2C2C396E2C32';
wwv_flow_imp.g_varchar2_table(43867) := '2C6630622C352C316E2C372C74342C2C31722C342C32392C2C66356B2C322C3433712C2C2C332C342C352C382C382C322C372C752C342C34342C332C31697A2C316A2C342C31652C382C2C652C2C6D2C352C2C662C3131732C372C2C682C322C372C2C32';
wwv_flow_imp.g_varchar2_table(43868) := '2C2C352C37392C372C63352C342C3135732C372C33312C372C3234302C352C6778376B2C326F2C336B2C366F222E73706C697428222C22292E6D61702828653D3E653F7061727365496E7428652C3336293A3129293B666F72286C657420653D313B653C';
wwv_flow_imp.g_varchar2_table(43869) := '4B782E6C656E6774683B652B2B294B785B655D2B3D4B785B652D315D3B66756E6374696F6E2047782865297B666F72286C657420743D313B743C4B782E6C656E6774683B742B3D32296966284B785B745D3E652972657475726E204B785B742D315D3C3D';
wwv_flow_imp.g_varchar2_table(43870) := '653B72657475726E21317D66756E6374696F6E2051782865297B72657475726E20653E3D3132373436322626653C3D3132373438377D636F6E73742059783D383230353B66756E6374696F6E205A7828652C742C6E3D21302C693D2130297B7265747572';
wwv_flow_imp.g_varchar2_table(43871) := '6E286E3F58783A4A782928652C742C69297D66756E6374696F6E20587828652C742C6E297B696628743D3D652E6C656E6774682972657475726E20743B742626656B28652E63686172436F64654174287429292626746B28652E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(43872) := '28742D3129292626742D2D3B6C657420693D6E6B28652C74293B666F7228742B3D6F6B2869293B743C652E6C656E6774683B297B6C6574206F3D6E6B28652C74293B696628693D3D59787C7C6F3D3D59787C7C6E26264778286F2929742B3D6F6B286F29';
wwv_flow_imp.g_varchar2_table(43873) := '2C693D6F3B656C73657B696628215178286F2929627265616B3B7B6C6574206E3D302C693D742D323B666F72283B693E3D3026265178286E6B28652C6929293B296E2B2B2C692D3D323B6966286E25323D3D3029627265616B3B742B3D327D7D7D726574';
wwv_flow_imp.g_varchar2_table(43874) := '75726E20747D66756E6374696F6E204A7828652C742C6E297B666F72283B743E303B297B6C657420693D587828652C742D322C6E293B696628693C742972657475726E20693B742D2D7D72657475726E20307D66756E6374696F6E20656B2865297B7265';
wwv_flow_imp.g_varchar2_table(43875) := '7475726E20653E3D35363332302626653C35373334347D66756E6374696F6E20746B2865297B72657475726E20653E3D35353239362626653C35363332307D66756E6374696F6E206E6B28652C74297B6C6574206E3D652E63686172436F646541742874';
wwv_flow_imp.g_varchar2_table(43876) := '293B69662821746B286E297C7C742B313D3D652E6C656E6774682972657475726E206E3B6C657420693D652E63686172436F6465417428742B31293B72657475726E20656B2869293F692D35363332302B286E2D35353239363C3C3130292B3635353336';
wwv_flow_imp.g_varchar2_table(43877) := '3A6E7D66756E6374696F6E20696B2865297B72657475726E20653C3D36353533353F537472696E672E66726F6D43686172436F64652865293A28652D3D36353533362C537472696E672E66726F6D43686172436F64652835353239362B28653E3E313029';
wwv_flow_imp.g_varchar2_table(43878) := '2C35363332302B283130323326652929297D66756E6374696F6E206F6B2865297B72657475726E20653C36353533363F313A327D636F6E737420736B3D2F5C725C6E3F7C5C6E2F3B76617220726B3D66756E6374696F6E2865297B72657475726E20655B';
wwv_flow_imp.g_varchar2_table(43879) := '652E53696D706C653D305D3D2253696D706C65222C655B652E547261636B44656C3D315D3D22547261636B44656C222C655B652E547261636B4265666F72653D325D3D22547261636B4265666F7265222C655B652E547261636B41667465723D335D3D22';
wwv_flow_imp.g_varchar2_table(43880) := '547261636B4166746572222C657D28726B7C7C28726B3D7B7D29293B636C61737320616B7B636F6E7374727563746F722865297B746869732E73656374696F6E733D657D676574206C656E67746828297B6C657420653D303B666F72286C657420743D30';
wwv_flow_imp.g_varchar2_table(43881) := '3B743C746869732E73656374696F6E732E6C656E6774683B742B3D3229652B3D746869732E73656374696F6E735B745D3B72657475726E20657D676574206E65774C656E67746828297B6C657420653D303B666F72286C657420743D303B743C74686973';
wwv_flow_imp.g_varchar2_table(43882) := '2E73656374696F6E732E6C656E6774683B742B3D32297B6C6574206E3D746869732E73656374696F6E735B742B315D3B652B3D6E3C303F746869732E73656374696F6E735B745D3A6E7D72657475726E20657D67657420656D70747928297B7265747572';
wwv_flow_imp.g_varchar2_table(43883) := '6E20303D3D746869732E73656374696F6E732E6C656E6774687C7C323D3D746869732E73656374696F6E732E6C656E6774682626746869732E73656374696F6E735B315D3C307D69746572476170732865297B666F72286C657420743D302C6E3D302C69';
wwv_flow_imp.g_varchar2_table(43884) := '3D303B743C746869732E73656374696F6E732E6C656E6774683B297B6C6574206F3D746869732E73656374696F6E735B742B2B5D2C733D746869732E73656374696F6E735B742B2B5D3B733C303F2865286E2C692C6F292C692B3D6F293A692B3D732C6E';
wwv_flow_imp.g_varchar2_table(43885) := '2B3D6F7D7D697465724368616E67656452616E67657328652C743D2131297B686B28746869732C652C74297D67657420696E7665727465644465736328297B6C657420653D5B5D3B666F72286C657420743D303B743C746869732E73656374696F6E732E';
wwv_flow_imp.g_varchar2_table(43886) := '6C656E6774683B297B6C6574206E3D746869732E73656374696F6E735B742B2B5D2C693D746869732E73656374696F6E735B742B2B5D3B693C303F652E70757368286E2C69293A652E7075736828692C6E297D72657475726E206E657720616B2865297D';
wwv_flow_imp.g_varchar2_table(43887) := '636F6D706F7365446573632865297B72657475726E20746869732E656D7074793F653A652E656D7074793F746869733A706B28746869732C65297D6D61704465736328652C743D2131297B72657475726E20652E656D7074793F746869733A756B287468';
wwv_flow_imp.g_varchar2_table(43888) := '69732C652C74297D6D6170506F7328652C743D2D312C6E3D726B2E53696D706C65297B6C657420693D302C6F3D303B666F72286C657420733D303B733C746869732E73656374696F6E732E6C656E6774683B297B6C657420723D746869732E7365637469';
wwv_flow_imp.g_varchar2_table(43889) := '6F6E735B732B2B5D2C613D746869732E73656374696F6E735B732B2B5D2C6C3D692B723B696628613C30297B6966286C3E652972657475726E206F2B28652D69293B6F2B3D727D656C73657B6966286E213D726B2E53696D706C6526266C3E3D65262628';
wwv_flow_imp.g_varchar2_table(43890) := '6E3D3D726B2E547261636B44656C2626693C6526266C3E657C7C6E3D3D726B2E547261636B4265666F72652626693C657C7C6E3D3D726B2E547261636B416674657226266C3E65292972657475726E206E756C6C3B6966286C3E657C7C6C3D3D65262674';
wwv_flow_imp.g_varchar2_table(43891) := '3C30262621722972657475726E20653D3D697C7C743C303F6F3A6F2B613B6F2B3D617D693D6C7D696628653E69297468726F77206E65772052616E67654572726F722860506F736974696F6E20247B657D206973206F7574206F662072616E676520666F';
wwv_flow_imp.g_varchar2_table(43892) := '72206368616E6765736574206F66206C656E67746820247B697D60293B72657475726E206F7D746F756368657352616E676528652C743D65297B666F72286C6574206E3D302C693D303B6E3C746869732E73656374696F6E732E6C656E6774682626693C';
wwv_flow_imp.g_varchar2_table(43893) := '3D743B297B6C6574206F3D692B746869732E73656374696F6E735B6E2B2B5D3B696628746869732E73656374696F6E735B6E2B2B5D3E3D302626693C3D7426266F3E3D652972657475726E2128693C6526266F3E74297C7C22636F766572223B693D6F7D';
wwv_flow_imp.g_varchar2_table(43894) := '72657475726E21317D746F537472696E6728297B6C657420653D22223B666F72286C657420743D303B743C746869732E73656374696F6E732E6C656E6774683B297B6C6574206E3D746869732E73656374696F6E735B742B2B5D2C693D746869732E7365';
wwv_flow_imp.g_varchar2_table(43895) := '6374696F6E735B742B2B5D3B652B3D28653F2220223A2222292B6E2B28693E3D303F223A222B693A2222297D72657475726E20657D746F4A534F4E28297B72657475726E20746869732E73656374696F6E737D7374617469632066726F6D4A534F4E2865';
wwv_flow_imp.g_varchar2_table(43896) := '297B6966282141727261792E697341727261792865297C7C652E6C656E67746825327C7C652E736F6D652828653D3E226E756D62657222213D747970656F6620652929297468726F77206E65772052616E67654572726F722822496E76616C6964204A53';
wwv_flow_imp.g_varchar2_table(43897) := '4F4E20726570726573656E746174696F6E206F66204368616E67654465736322293B72657475726E206E657720616B2865297D737461746963206372656174652865297B72657475726E206E657720616B2865297D7D636C617373206C6B20657874656E';
wwv_flow_imp.g_varchar2_table(43898) := '647320616B7B636F6E7374727563746F7228652C74297B73757065722865292C746869732E696E7365727465643D747D6170706C792865297B696628746869732E6C656E677468213D652E6C656E677468297468726F77206E65772052616E6765457272';
wwv_flow_imp.g_varchar2_table(43899) := '6F7228224170706C79696E67206368616E67652073657420746F206120646F63756D656E742077697468207468652077726F6E67206C656E67746822293B72657475726E20686B28746869732C2828742C6E2C692C6F2C73293D3E653D652E7265706C61';
wwv_flow_imp.g_varchar2_table(43900) := '636528692C692B286E2D74292C7329292C2131292C657D6D61704465736328652C743D2131297B72657475726E20756B28746869732C652C742C2130297D696E766572742865297B6C657420743D746869732E73656374696F6E732E736C69636528292C';
wwv_flow_imp.g_varchar2_table(43901) := '6E3D5B5D3B666F72286C657420693D302C6F3D303B693C742E6C656E6774683B692B3D32297B6C657420733D745B695D2C723D745B692B315D3B696628723E3D30297B745B695D3D722C745B692B315D3D733B6C657420613D693E3E313B666F72283B6E';
wwv_flow_imp.g_varchar2_table(43902) := '2E6C656E6774683C613B296E2E707573682846782E656D707479293B6E2E7075736828733F652E736C696365286F2C6F2B73293A46782E656D707479297D6F2B3D737D72657475726E206E6577206C6B28742C6E297D636F6D706F73652865297B726574';
wwv_flow_imp.g_varchar2_table(43903) := '75726E20746869732E656D7074793F653A652E656D7074793F746869733A706B28746869732C652C2130297D6D617028652C743D2131297B72657475726E20652E656D7074793F746869733A756B28746869732C652C742C2130297D697465724368616E';
wwv_flow_imp.g_varchar2_table(43904) := '67657328652C743D2131297B686B28746869732C652C74297D676574206465736328297B72657475726E20616B2E63726561746528746869732E73656374696F6E73297D66696C7465722865297B6C657420743D5B5D2C6E3D5B5D2C693D5B5D2C6F3D6E';
wwv_flow_imp.g_varchar2_table(43905) := '657720676B2874686973293B653A666F72286C657420733D302C723D303B3B297B6C657420613D733D3D652E6C656E6774683F3165393A655B732B2B5D3B666F72283B723C617C7C723D3D612626303D3D6F2E6C656E3B297B6966286F2E646F6E652962';
wwv_flow_imp.g_varchar2_table(43906) := '7265616B20653B6C657420653D4D6174682E6D696E286F2E6C656E2C612D72293B636B28692C652C2D31293B6C657420733D2D313D3D6F2E696E733F2D313A303D3D6F2E6F66663F6F2E696E733A303B636B28742C652C73292C733E302626646B286E2C';
wwv_flow_imp.g_varchar2_table(43907) := '742C6F2E74657874292C6F2E666F72776172642865292C722B3D657D6C6574206C3D655B732B2B5D3B666F72283B723C6C3B297B6966286F2E646F6E6529627265616B20653B6C657420653D4D6174682E6D696E286F2E6C656E2C6C2D72293B636B2874';
wwv_flow_imp.g_varchar2_table(43908) := '2C652C2D31292C636B28692C652C2D313D3D6F2E696E733F2D313A303D3D6F2E6F66663F6F2E696E733A30292C6F2E666F72776172642865292C722B3D657D7D72657475726E7B6368616E6765733A6E6577206C6B28742C6E292C66696C74657265643A';
wwv_flow_imp.g_varchar2_table(43909) := '616B2E6372656174652869297D7D746F4A534F4E28297B6C657420653D5B5D3B666F72286C657420743D303B743C746869732E73656374696F6E732E6C656E6774683B742B3D32297B6C6574206E3D746869732E73656374696F6E735B745D2C693D7468';
wwv_flow_imp.g_varchar2_table(43910) := '69732E73656374696F6E735B742B315D3B693C303F652E70757368286E293A303D3D693F652E70757368285B6E5D293A652E70757368285B6E5D2E636F6E63617428746869732E696E7365727465645B743E3E315D2E746F4A534F4E282929297D726574';
wwv_flow_imp.g_varchar2_table(43911) := '75726E20657D737461746963206F6628652C742C6E297B6C657420693D5B5D2C6F3D5B5D2C733D302C723D6E756C6C3B66756E6374696F6E206128653D2131297B6966282165262621692E6C656E6774682972657475726E3B733C742626636B28692C74';
wwv_flow_imp.g_varchar2_table(43912) := '2D732C2D31293B6C6574206E3D6E6577206C6B28692C6F293B723D723F722E636F6D706F7365286E2E6D6170287229293A6E2C693D5B5D2C6F3D5B5D2C733D307D72657475726E2066756E6374696F6E2065286C297B69662841727261792E6973417272';
wwv_flow_imp.g_varchar2_table(43913) := '6179286C2929666F72286C65742074206F66206C29652874293B656C7365206966286C20696E7374616E63656F66206C6B297B6966286C2E6C656E677468213D74297468726F77206E65772052616E67654572726F7228604D69736D6174636865642063';
wwv_flow_imp.g_varchar2_table(43914) := '68616E676520736574206C656E6774682028676F7420247B6C2E6C656E6774687D2C20657870656374656420247B747D2960293B6128292C723D723F722E636F6D706F7365286C2E6D6170287229293A6C7D656C73657B6C65747B66726F6D3A652C746F';
wwv_flow_imp.g_varchar2_table(43915) := '3A723D652C696E736572743A637D3D6C3B696628653E727C7C653C307C7C723E74297468726F77206E65772052616E67654572726F722860496E76616C6964206368616E67652072616E676520247B657D20746F20247B727D2028696E20646F63206F66';
wwv_flow_imp.g_varchar2_table(43916) := '206C656E67746820247B747D2960293B6C657420643D633F22737472696E67223D3D747970656F6620633F46782E6F6628632E73706C6974286E7C7C736B29293A633A46782E656D7074792C683D642E6C656E6774683B696628653D3D722626303D3D68';
wwv_flow_imp.g_varchar2_table(43917) := '2972657475726E3B653C7326266128292C653E732626636B28692C652D732C2D31292C636B28692C722D652C68292C646B286F2C692C64292C733D727D7D2865292C61282172292C727D73746174696320656D7074792865297B72657475726E206E6577';
wwv_flow_imp.g_varchar2_table(43918) := '206C6B28653F5B652C2D315D3A5B5D2C5B5D297D7374617469632066726F6D4A534F4E2865297B6966282141727261792E69734172726179286529297468726F77206E65772052616E67654572726F722822496E76616C6964204A534F4E207265707265';
wwv_flow_imp.g_varchar2_table(43919) := '73656E746174696F6E206F66204368616E676553657422293B6C657420743D5B5D2C6E3D5B5D3B666F72286C657420693D303B693C652E6C656E6774683B692B2B297B6C6574206F3D655B695D3B696628226E756D626572223D3D747970656F66206F29';
wwv_flow_imp.g_varchar2_table(43920) := '742E70757368286F2C2D31293B656C73657B6966282141727261792E69734172726179286F297C7C226E756D62657222213D747970656F66206F5B305D7C7C6F2E736F6D65282828652C74293D3E74262622737472696E6722213D747970656F66206529';
wwv_flow_imp.g_varchar2_table(43921) := '29297468726F77206E65772052616E67654572726F722822496E76616C6964204A534F4E20726570726573656E746174696F6E206F66204368616E676553657422293B696628313D3D6F2E6C656E67746829742E70757368286F5B305D2C30293B656C73';
wwv_flow_imp.g_varchar2_table(43922) := '657B666F72283B6E2E6C656E6774683C693B296E2E707573682846782E656D707479293B6E5B695D3D46782E6F66286F2E736C696365283129292C742E70757368286F5B305D2C6E5B695D2E6C656E677468297D7D7D72657475726E206E6577206C6B28';
wwv_flow_imp.g_varchar2_table(43923) := '742C6E297D7374617469632063726561746553657428652C74297B72657475726E206E6577206C6B28652C74297D7D66756E6374696F6E20636B28652C742C6E2C693D2131297B696628303D3D7426266E3C3D302972657475726E3B6C6574206F3D652E';
wwv_flow_imp.g_varchar2_table(43924) := '6C656E6774682D323B6F3E3D3026266E3C3D3026266E3D3D655B6F2B315D3F655B6F5D2B3D743A303D3D742626303D3D655B6F5D3F655B6F2B315D2B3D6E3A693F28655B6F5D2B3D742C655B6F2B315D2B3D6E293A652E7075736828742C6E297D66756E';
wwv_flow_imp.g_varchar2_table(43925) := '6374696F6E20646B28652C742C6E297B696628303D3D6E2E6C656E6774682972657475726E3B6C657420693D742E6C656E6774682D323E3E313B696628693C652E6C656E67746829655B652E6C656E6774682D315D3D655B652E6C656E6774682D315D2E';
wwv_flow_imp.g_varchar2_table(43926) := '617070656E64286E293B656C73657B666F72283B652E6C656E6774683C693B29652E707573682846782E656D707479293B652E70757368286E297D7D66756E6374696F6E20686B28652C742C6E297B6C657420693D652E696E7365727465643B666F7228';
wwv_flow_imp.g_varchar2_table(43927) := '6C6574206F3D302C733D302C723D303B723C652E73656374696F6E732E6C656E6774683B297B6C657420613D652E73656374696F6E735B722B2B5D2C6C3D652E73656374696F6E735B722B2B5D3B6966286C3C30296F2B3D612C732B3D613B656C73657B';
wwv_flow_imp.g_varchar2_table(43928) := '6C657420633D6F2C643D732C683D46782E656D7074793B666F72283B632B3D612C642B3D6C2C6C262669262628683D682E617070656E6428695B722D323E3E315D29292C21286E7C7C723D3D652E73656374696F6E732E6C656E6774687C7C652E736563';
wwv_flow_imp.g_varchar2_table(43929) := '74696F6E735B722B315D3C30293B29613D652E73656374696F6E735B722B2B5D2C6C3D652E73656374696F6E735B722B2B5D3B74286F2C632C732C642C68292C6F3D632C733D647D7D7D66756E6374696F6E20756B28652C742C6E2C693D2131297B6C65';
wwv_flow_imp.g_varchar2_table(43930) := '74206F3D5B5D2C733D693F5B5D3A6E756C6C2C723D6E657720676B2865292C613D6E657720676B2874293B666F72286C657420653D2D313B3B296966282D313D3D722E696E7326262D313D3D612E696E73297B6C657420653D4D6174682E6D696E28722E';
wwv_flow_imp.g_varchar2_table(43931) := '6C656E2C612E6C656E293B636B286F2C652C2D31292C722E666F72776172642865292C612E666F72776172642865297D656C736520696628612E696E733E3D30262628722E696E733C307C7C653D3D722E697C7C303D3D722E6F6666262628612E6C656E';
wwv_flow_imp.g_varchar2_table(43932) := '3C722E6C656E7C7C612E6C656E3D3D722E6C656E2626216E2929297B6C657420743D612E6C656E3B666F7228636B286F2C612E696E732C2D31293B743B297B6C6574206E3D4D6174682E6D696E28722E6C656E2C74293B722E696E733E3D302626653C72';
wwv_flow_imp.g_varchar2_table(43933) := '2E692626722E6C656E3C3D6E262628636B286F2C302C722E696E73292C732626646B28732C6F2C722E74657874292C653D722E69292C722E666F7277617264286E292C742D3D6E7D612E6E65787428297D656C73657B6966282128722E696E733E3D3029';
wwv_flow_imp.g_varchar2_table(43934) := '297B696628722E646F6E652626612E646F6E652972657475726E20733F6C6B2E637265617465536574286F2C73293A616B2E637265617465286F293B7468726F77206E6577204572726F7228224D69736D617463686564206368616E676520736574206C';
wwv_flow_imp.g_varchar2_table(43935) := '656E6774687322297D7B6C657420743D302C6E3D722E6C656E3B666F72283B6E3B296966282D313D3D612E696E73297B6C657420653D4D6174682E6D696E286E2C612E6C656E293B742B3D652C6E2D3D652C612E666F72776172642865297D656C73657B';
wwv_flow_imp.g_varchar2_table(43936) := '6966282128303D3D612E696E732626612E6C656E3C6E2929627265616B3B6E2D3D612E6C656E2C612E6E65787428297D636B286F2C742C653C722E693F722E696E733A30292C732626653C722E692626646B28732C6F2C722E74657874292C653D722E69';
wwv_flow_imp.g_varchar2_table(43937) := '2C722E666F727761726428722E6C656E2D6E297D7D7D66756E6374696F6E20706B28652C742C6E3D2131297B6C657420693D5B5D2C6F3D6E3F5B5D3A6E756C6C2C733D6E657720676B2865292C723D6E657720676B2874293B666F72286C657420653D21';
wwv_flow_imp.g_varchar2_table(43938) := '313B3B297B696628732E646F6E652626722E646F6E652972657475726E206F3F6C6B2E63726561746553657428692C6F293A616B2E6372656174652869293B696628303D3D732E696E7329636B28692C732E6C656E2C302C65292C732E6E65787428293B';
wwv_flow_imp.g_varchar2_table(43939) := '656C73652069662830213D722E6C656E7C7C722E646F6E65297B696628732E646F6E657C7C722E646F6E65297468726F77206E6577204572726F7228224D69736D617463686564206368616E676520736574206C656E6774687322293B7B6C657420743D';
wwv_flow_imp.g_varchar2_table(43940) := '4D6174682E6D696E28732E6C656E322C722E6C656E292C6E3D692E6C656E6774683B6966282D313D3D732E696E73297B6C6574206E3D2D313D3D722E696E733F2D313A722E6F66663F303A722E696E733B636B28692C742C6E2C65292C6F26266E262664';
wwv_flow_imp.g_varchar2_table(43941) := '6B286F2C692C722E74657874297D656C73652D313D3D722E696E733F28636B28692C732E6F66663F303A732E6C656E2C742C65292C6F2626646B286F2C692C732E7465787442697428742929293A28636B28692C732E6F66663F303A732E6C656E2C722E';
wwv_flow_imp.g_varchar2_table(43942) := '6F66663F303A722E696E732C65292C6F262621722E6F66662626646B286F2C692C722E7465787429293B653D28732E696E733E747C7C722E696E733E3D302626722E6C656E3E7429262628657C7C692E6C656E6774683E6E292C732E666F727761726432';
wwv_flow_imp.g_varchar2_table(43943) := '2874292C722E666F72776172642874297D7D656C736520636B28692C302C722E696E732C65292C6F2626646B286F2C692C722E74657874292C722E6E65787428297D7D636C61737320676B7B636F6E7374727563746F722865297B746869732E7365743D';
wwv_flow_imp.g_varchar2_table(43944) := '652C746869732E693D302C746869732E6E65787428297D6E65787428297B6C65747B73656374696F6E733A657D3D746869732E7365743B746869732E693C652E6C656E6774683F28746869732E6C656E3D655B746869732E692B2B5D2C746869732E696E';
wwv_flow_imp.g_varchar2_table(43945) := '733D655B746869732E692B2B5D293A28746869732E6C656E3D302C746869732E696E733D2D32292C746869732E6F66663D307D67657420646F6E6528297B72657475726E2D323D3D746869732E696E737D676574206C656E3228297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(43946) := '6869732E696E733C303F746869732E6C656E3A746869732E696E737D676574207465787428297B6C65747B696E7365727465643A657D3D746869732E7365742C743D746869732E692D323E3E313B72657475726E20743E3D652E6C656E6774683F46782E';
wwv_flow_imp.g_varchar2_table(43947) := '656D7074793A655B745D7D746578744269742865297B6C65747B696E7365727465643A747D3D746869732E7365742C6E3D746869732E692D323E3E313B72657475726E206E3E3D742E6C656E677468262621653F46782E656D7074793A745B6E5D2E736C';
wwv_flow_imp.g_varchar2_table(43948) := '69636528746869732E6F66662C6E756C6C3D3D653F766F696420303A746869732E6F66662B65297D666F72776172642865297B653D3D746869732E6C656E3F746869732E6E65787428293A28746869732E6C656E2D3D652C746869732E6F66662B3D6529';
wwv_flow_imp.g_varchar2_table(43949) := '7D666F7277617264322865297B2D313D3D746869732E696E733F746869732E666F72776172642865293A653D3D746869732E696E733F746869732E6E65787428293A28746869732E696E732D3D652C746869732E6F66662B3D65297D7D636C617373206D';
wwv_flow_imp.g_varchar2_table(43950) := '6B7B636F6E7374727563746F7228652C742C6E297B746869732E66726F6D3D652C746869732E746F3D742C746869732E666C6167733D6E7D67657420616E63686F7228297B72657475726E20333226746869732E666C6167733F746869732E746F3A7468';
wwv_flow_imp.g_varchar2_table(43951) := '69732E66726F6D7D676574206865616428297B72657475726E20333226746869732E666C6167733F746869732E66726F6D3A746869732E746F7D67657420656D70747928297B72657475726E20746869732E66726F6D3D3D746869732E746F7D67657420';
wwv_flow_imp.g_varchar2_table(43952) := '6173736F6328297B72657475726E203826746869732E666C6167733F2D313A313626746869732E666C6167733F313A307D67657420626964694C6576656C28297B6C657420653D3726746869732E666C6167733B72657475726E20373D3D653F6E756C6C';
wwv_flow_imp.g_varchar2_table(43953) := '3A657D67657420676F616C436F6C756D6E28297B6C657420653D746869732E666C6167733E3E363B72657475726E2031363737373231353D3D653F766F696420303A657D6D617028652C743D2D31297B6C6574206E2C693B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(43954) := '656D7074793F6E3D693D652E6D6170506F7328746869732E66726F6D2C74293A286E3D652E6D6170506F7328746869732E66726F6D2C31292C693D652E6D6170506F7328746869732E746F2C2D3129292C6E3D3D746869732E66726F6D2626693D3D7468';
wwv_flow_imp.g_varchar2_table(43955) := '69732E746F3F746869733A6E6577206D6B286E2C692C746869732E666C616773297D657874656E6428652C743D65297B696628653C3D746869732E616E63686F722626743E3D746869732E616E63686F722972657475726E20666B2E72616E676528652C';
wwv_flow_imp.g_varchar2_table(43956) := '74293B6C6574206E3D4D6174682E61627328652D746869732E616E63686F72293E4D6174682E61627328742D746869732E616E63686F72293F653A743B72657475726E20666B2E72616E676528746869732E616E63686F722C6E297D657128652C743D21';
wwv_flow_imp.g_varchar2_table(43957) := '31297B72657475726E2128746869732E616E63686F72213D652E616E63686F727C7C746869732E68656164213D652E686561647C7C742626746869732E656D7074792626746869732E6173736F63213D652E6173736F63297D746F4A534F4E28297B7265';
wwv_flow_imp.g_varchar2_table(43958) := '7475726E7B616E63686F723A746869732E616E63686F722C686561643A746869732E686561647D7D7374617469632066726F6D4A534F4E2865297B69662821657C7C226E756D62657222213D747970656F6620652E616E63686F727C7C226E756D626572';
wwv_flow_imp.g_varchar2_table(43959) := '22213D747970656F6620652E68656164297468726F77206E65772052616E67654572726F722822496E76616C6964204A534F4E20726570726573656E746174696F6E20666F722053656C656374696F6E52616E676522293B72657475726E20666B2E7261';
wwv_flow_imp.g_varchar2_table(43960) := '6E676528652E616E63686F722C652E68656164297D7374617469632063726561746528652C742C6E297B72657475726E206E6577206D6B28652C742C6E297D7D636C61737320666B7B636F6E7374727563746F7228652C74297B746869732E72616E6765';
wwv_flow_imp.g_varchar2_table(43961) := '733D652C746869732E6D61696E496E6465783D747D6D617028652C743D2D31297B72657475726E20652E656D7074793F746869733A666B2E63726561746528746869732E72616E6765732E6D617028286E3D3E6E2E6D617028652C742929292C74686973';
wwv_flow_imp.g_varchar2_table(43962) := '2E6D61696E496E646578297D657128652C743D2131297B696628746869732E72616E6765732E6C656E677468213D652E72616E6765732E6C656E6774687C7C746869732E6D61696E496E646578213D652E6D61696E496E6465782972657475726E21313B';
wwv_flow_imp.g_varchar2_table(43963) := '666F72286C6574206E3D303B6E3C746869732E72616E6765732E6C656E6774683B6E2B2B2969662821746869732E72616E6765735B6E5D2E657128652E72616E6765735B6E5D2C74292972657475726E21313B72657475726E21307D676574206D61696E';
wwv_flow_imp.g_varchar2_table(43964) := '28297B72657475726E20746869732E72616E6765735B746869732E6D61696E496E6465785D7D617353696E676C6528297B72657475726E20313D3D746869732E72616E6765732E6C656E6774683F746869733A6E657720666B285B746869732E6D61696E';
wwv_flow_imp.g_varchar2_table(43965) := '5D2C30297D61646452616E676528652C743D2130297B72657475726E20666B2E637265617465285B655D2E636F6E63617428746869732E72616E676573292C743F303A746869732E6D61696E496E6465782B31297D7265706C61636552616E676528652C';
wwv_flow_imp.g_varchar2_table(43966) := '743D746869732E6D61696E496E646578297B6C6574206E3D746869732E72616E6765732E736C69636528293B72657475726E206E5B745D3D652C666B2E637265617465286E2C746869732E6D61696E496E646578297D746F4A534F4E28297B7265747572';
wwv_flow_imp.g_varchar2_table(43967) := '6E7B72616E6765733A746869732E72616E6765732E6D61702828653D3E652E746F4A534F4E282929292C6D61696E3A746869732E6D61696E496E6465787D7D7374617469632066726F6D4A534F4E2865297B69662821657C7C2141727261792E69734172';
wwv_flow_imp.g_varchar2_table(43968) := '72617928652E72616E676573297C7C226E756D62657222213D747970656F6620652E6D61696E7C7C652E6D61696E3E3D652E72616E6765732E6C656E677468297468726F77206E65772052616E67654572726F722822496E76616C6964204A534F4E2072';
wwv_flow_imp.g_varchar2_table(43969) := '6570726573656E746174696F6E20666F7220456469746F7253656C656374696F6E22293B72657475726E206E657720666B28652E72616E6765732E6D61702828653D3E6D6B2E66726F6D4A534F4E28652929292C652E6D61696E297D7374617469632073';
wwv_flow_imp.g_varchar2_table(43970) := '696E676C6528652C743D65297B72657475726E206E657720666B285B666B2E72616E676528652C74295D2C30297D7374617469632063726561746528652C743D30297B696628303D3D652E6C656E677468297468726F77206E65772052616E6765457272';
wwv_flow_imp.g_varchar2_table(43971) := '6F722822412073656C656374696F6E206E65656473206174206C65617374206F6E652072616E676522293B666F72286C6574206E3D302C693D303B693C652E6C656E6774683B692B2B297B6C6574206F3D655B695D3B6966286F2E656D7074793F6F2E66';
wwv_flow_imp.g_varchar2_table(43972) := '726F6D3C3D6E3A6F2E66726F6D3C6E2972657475726E20666B2E6E6F726D616C697A656428652E736C69636528292C74293B6E3D6F2E746F7D72657475726E206E657720666B28652C74297D73746174696320637572736F7228652C743D302C6E2C6929';
wwv_flow_imp.g_varchar2_table(43973) := '7B72657475726E206D6B2E63726561746528652C652C28303D3D743F303A743C303F383A3136297C286E756C6C3D3D6E3F373A4D6174682E6D696E28362C6E29297C286E756C6C213D693F693A3136373737323135293C3C36297D737461746963207261';
wwv_flow_imp.g_varchar2_table(43974) := '6E676528652C742C6E2C69297B6C6574206F3D286E756C6C213D6E3F6E3A3136373737323135293C3C367C286E756C6C3D3D693F373A4D6174682E6D696E28362C6929293B72657475726E20743C653F6D6B2E63726561746528742C652C34387C6F293A';
wwv_flow_imp.g_varchar2_table(43975) := '6D6B2E63726561746528652C742C28743E653F383A30297C6F297D737461746963206E6F726D616C697A656428652C743D30297B6C6574206E3D655B745D3B652E736F7274282828652C74293D3E652E66726F6D2D742E66726F6D29292C743D652E696E';
wwv_flow_imp.g_varchar2_table(43976) := '6465784F66286E293B666F72286C6574206E3D313B6E3C652E6C656E6774683B6E2B2B297B6C657420693D655B6E5D2C6F3D655B6E2D315D3B696628692E656D7074793F692E66726F6D3C3D6F2E746F3A692E66726F6D3C6F2E746F297B6C657420733D';
wwv_flow_imp.g_varchar2_table(43977) := '6F2E66726F6D2C723D4D6174682E6D617828692E746F2C6F2E746F293B6E3C3D742626742D2D2C652E73706C696365282D2D6E2C322C692E616E63686F723E692E686561643F666B2E72616E676528722C73293A666B2E72616E676528732C7229297D7D';
wwv_flow_imp.g_varchar2_table(43978) := '72657475726E206E657720666B28652C74297D7D66756E6374696F6E20766B28652C74297B666F72286C6574206E206F6620652E72616E676573296966286E2E746F3E74297468726F77206E65772052616E67654572726F72282253656C656374696F6E';
wwv_flow_imp.g_varchar2_table(43979) := '20706F696E7473206F757473696465206F6620646F63756D656E7422297D6C657420626B3D303B636C617373205F6B7B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E636F6D62696E653D652C746869732E636F6D70617265496E';
wwv_flow_imp.g_varchar2_table(43980) := '7075743D742C746869732E636F6D706172653D6E2C746869732E69735374617469633D692C746869732E69643D626B2B2B2C746869732E64656661756C743D65285B5D292C746869732E657874656E73696F6E733D2266756E6374696F6E223D3D747970';
wwv_flow_imp.g_varchar2_table(43981) := '656F66206F3F6F2874686973293A6F7D6765742072656164657228297B72657475726E20746869737D73746174696320646566696E6528653D7B7D297B72657475726E206E6577205F6B28652E636F6D62696E657C7C28653D3E65292C652E636F6D7061';
wwv_flow_imp.g_varchar2_table(43982) := '7265496E7075747C7C2828652C74293D3E653D3D3D74292C652E636F6D706172657C7C28652E636F6D62696E653F28652C74293D3E653D3D3D743A796B292C2121652E7374617469632C652E656E61626C6573297D6F662865297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(43983) := '7720776B285B5D2C746869732C302C65297D636F6D7075746528652C74297B696628746869732E6973537461746963297468726F77206E6577204572726F72282243616E277420636F6D7075746520612073746174696320666163657422293B72657475';
wwv_flow_imp.g_varchar2_table(43984) := '726E206E657720776B28652C746869732C312C74297D636F6D707574654E28652C74297B696628746869732E6973537461746963297468726F77206E6577204572726F72282243616E277420636F6D707574652061207374617469632066616365742229';
wwv_flow_imp.g_varchar2_table(43985) := '3B72657475726E206E657720776B28652C746869732C322C74297D66726F6D28652C74297B72657475726E20747C7C28743D653D3E65292C746869732E636F6D70757465285B655D2C286E3D3E74286E2E6669656C642865292929297D7D66756E637469';
wwv_flow_imp.g_varchar2_table(43986) := '6F6E20796B28652C74297B72657475726E20653D3D747C7C652E6C656E6774683D3D742E6C656E6774682626652E6576657279282828652C6E293D3E653D3D3D745B6E5D29297D636C61737320776B7B636F6E7374727563746F7228652C742C6E2C6929';
wwv_flow_imp.g_varchar2_table(43987) := '7B746869732E646570656E64656E636965733D652C746869732E66616365743D742C746869732E747970653D6E2C746869732E76616C75653D692C746869732E69643D626B2B2B7D64796E616D6963536C6F742865297B76617220743B6C6574206E3D74';
wwv_flow_imp.g_varchar2_table(43988) := '6869732E76616C75652C693D746869732E66616365742E636F6D70617265496E7075742C6F3D746869732E69642C733D655B6F5D3E3E312C723D323D3D746869732E747970652C613D21312C6C3D21312C633D5B5D3B666F72286C6574206E206F662074';
wwv_flow_imp.g_varchar2_table(43989) := '6869732E646570656E64656E636965732922646F63223D3D6E3F613D21303A2273656C656374696F6E223D3D6E3F6C3D21303A3126286E756C6C213D3D28743D655B6E2E69645D292626766F69642030213D3D743F743A31297C7C632E7075736828655B';
wwv_flow_imp.g_varchar2_table(43990) := '6E2E69645D293B72657475726E7B6372656174653A653D3E28652E76616C7565735B735D3D6E2865292C31292C75706461746528652C74297B696628612626742E646F634368616E6765647C7C6C262628742E646F634368616E6765647C7C742E73656C';
wwv_flow_imp.g_varchar2_table(43991) := '656374696F6E297C7C536B28652C6329297B6C657420743D6E2865293B696628723F21436B28742C652E76616C7565735B735D2C69293A216928742C652E76616C7565735B735D292972657475726E20652E76616C7565735B735D3D742C317D72657475';
wwv_flow_imp.g_varchar2_table(43992) := '726E20307D2C7265636F6E6669677572653A28652C74293D3E7B6C657420612C6C3D742E636F6E6669672E616464726573735B6F5D3B6966286E756C6C213D6C297B6C6574206F3D506B28742C6C293B696628746869732E646570656E64656E63696573';
wwv_flow_imp.g_varchar2_table(43993) := '2E657665727928286E3D3E6E20696E7374616E63656F66205F6B3F742E6661636574286E293D3D3D652E6661636574286E293A21286E20696E7374616E63656F6620456B297C7C742E6669656C64286E2C2131293D3D652E6669656C64286E2C21312929';
wwv_flow_imp.g_varchar2_table(43994) := '297C7C28723F436B28613D6E2865292C6F2C69293A6928613D6E2865292C6F29292972657475726E20652E76616C7565735B735D3D6F2C307D656C736520613D6E2865293B72657475726E20652E76616C7565735B735D3D612C317D7D7D7D66756E6374';
wwv_flow_imp.g_varchar2_table(43995) := '696F6E20436B28652C742C6E297B696628652E6C656E677468213D742E6C656E6774682972657475726E21313B666F72286C657420693D303B693C652E6C656E6774683B692B2B29696628216E28655B695D2C745B695D292972657475726E21313B7265';
wwv_flow_imp.g_varchar2_table(43996) := '7475726E21307D66756E6374696F6E20536B28652C74297B6C6574206E3D21313B666F72286C65742069206F6620742931264E6B28652C69292626286E3D2130293B72657475726E206E7D66756E6374696F6E20786B28652C742C6E297B6C657420693D';
wwv_flow_imp.g_varchar2_table(43997) := '6E2E6D61702828743D3E655B742E69645D29292C6F3D6E2E6D61702828653D3E652E7479706529292C733D692E66696C7465722828653D3E21283126652929292C723D655B742E69645D3E3E313B66756E6374696F6E20612865297B6C6574206E3D5B5D';
wwv_flow_imp.g_varchar2_table(43998) := '3B666F72286C657420743D303B743C692E6C656E6774683B742B2B297B6C657420733D506B28652C695B745D293B696628323D3D6F5B745D29666F72286C65742065206F662073296E2E707573682865293B656C7365206E2E707573682873297D726574';
wwv_flow_imp.g_varchar2_table(43999) := '75726E20742E636F6D62696E65286E297D72657475726E7B6372656174652865297B666F72286C65742074206F662069294E6B28652C74293B72657475726E20652E76616C7565735B725D3D612865292C317D2C75706461746528652C6E297B69662821';
wwv_flow_imp.g_varchar2_table(44000) := '536B28652C73292972657475726E20303B6C657420693D612865293B72657475726E20742E636F6D7061726528692C652E76616C7565735B725D293F303A28652E76616C7565735B725D3D692C31297D2C7265636F6E66696775726528652C6F297B6C65';
wwv_flow_imp.g_varchar2_table(44001) := '7420733D536B28652C69292C6C3D6F2E636F6E6669672E6661636574735B742E69645D2C633D6F2E66616365742874293B6966286C262621732626796B286E2C6C292972657475726E20652E76616C7565735B725D3D632C303B6C657420643D61286529';
wwv_flow_imp.g_varchar2_table(44002) := '3B72657475726E20742E636F6D7061726528642C63293F28652E76616C7565735B725D3D632C30293A28652E76616C7565735B725D3D642C31297D7D7D636F6E7374206B6B3D5F6B2E646566696E65287B7374617469633A21307D293B636C6173732045';
wwv_flow_imp.g_varchar2_table(44003) := '6B7B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E69643D652C746869732E637265617465463D742C746869732E757064617465463D6E2C746869732E636F6D70617265463D692C746869732E737065633D6F2C746869732E7072';
wwv_flow_imp.g_varchar2_table(44004) := '6F76696465733D766F696420307D73746174696320646566696E652865297B6C657420743D6E657720456B28626B2B2B2C652E6372656174652C652E7570646174652C652E636F6D706172657C7C2828652C74293D3E653D3D3D74292C65293B72657475';
wwv_flow_imp.g_varchar2_table(44005) := '726E20652E70726F76696465262628742E70726F76696465733D652E70726F76696465287429292C747D6372656174652865297B6C657420743D652E6661636574286B6B292E66696E642828653D3E652E6669656C643D3D7468697329293B7265747572';
wwv_flow_imp.g_varchar2_table(44006) := '6E28286E756C6C3D3D743F766F696420303A742E637265617465297C7C746869732E63726561746546292865297D736C6F742865297B6C657420743D655B746869732E69645D3E3E313B72657475726E7B6372656174653A653D3E28652E76616C756573';
wwv_flow_imp.g_varchar2_table(44007) := '5B745D3D746869732E6372656174652865292C31292C7570646174653A28652C6E293D3E7B6C657420693D652E76616C7565735B745D2C6F3D746869732E7570646174654628692C6E293B72657475726E20746869732E636F6D706172654628692C6F29';
wwv_flow_imp.g_varchar2_table(44008) := '3F303A28652E76616C7565735B745D3D6F2C31297D2C7265636F6E6669677572653A28652C6E293D3E6E756C6C213D6E2E636F6E6669672E616464726573735B746869732E69645D3F28652E76616C7565735B745D3D6E2E6669656C642874686973292C';
wwv_flow_imp.g_varchar2_table(44009) := '30293A28652E76616C7565735B745D3D746869732E6372656174652865292C31297D7D696E69742865297B72657475726E5B746869732C6B6B2E6F66287B6669656C643A746869732C6372656174653A657D295D7D67657420657874656E73696F6E2829';
wwv_flow_imp.g_varchar2_table(44010) := '7B72657475726E20746869737D7D66756E6374696F6E204C6B2865297B72657475726E20743D3E6E657720546B28742C65297D636F6E737420446B3D7B686967686573743A4C6B2830292C686967683A4C6B2831292C64656661756C743A4C6B2832292C';
wwv_flow_imp.g_varchar2_table(44011) := '6C6F773A4C6B2833292C6C6F776573743A4C6B2834297D3B636C61737320546B7B636F6E7374727563746F7228652C74297B746869732E696E6E65723D652C746869732E707265633D747D7D636C61737320496B7B6F662865297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(44012) := '77204D6B28746869732C65297D7265636F6E6669677572652865297B72657475726E20496B2E7265636F6E6669677572652E6F66287B636F6D706172746D656E743A746869732C657874656E73696F6E3A657D297D6765742865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(44013) := '2E636F6E6669672E636F6D706172746D656E74732E6765742874686973297D7D636C617373204D6B7B636F6E7374727563746F7228652C74297B746869732E636F6D706172746D656E743D652C746869732E696E6E65723D747D7D636C61737320416B7B';
wwv_flow_imp.g_varchar2_table(44014) := '636F6E7374727563746F7228652C742C6E2C692C6F2C73297B666F7228746869732E626173653D652C746869732E636F6D706172746D656E74733D742C746869732E64796E616D6963536C6F74733D6E2C746869732E616464726573733D692C74686973';
wwv_flow_imp.g_varchar2_table(44015) := '2E73746174696356616C7565733D6F2C746869732E6661636574733D732C746869732E73746174757354656D706C6174653D5B5D3B746869732E73746174757354656D706C6174652E6C656E6774683C6E2E6C656E6774683B29746869732E7374617475';
wwv_flow_imp.g_varchar2_table(44016) := '7354656D706C6174652E707573682830297D73746174696346616365742865297B6C657420743D746869732E616464726573735B652E69645D3B72657475726E206E756C6C3D3D743F652E64656661756C743A746869732E73746174696356616C756573';
wwv_flow_imp.g_varchar2_table(44017) := '5B743E3E315D7D737461746963207265736F6C766528652C742C6E297B6C657420693D5B5D2C6F3D4F626A6563742E637265617465286E756C6C292C733D6E6577204D61703B666F72286C6574206E206F662066756E6374696F6E28652C742C6E297B6C';
wwv_flow_imp.g_varchar2_table(44018) := '657420693D5B5B5D2C5B5D2C5B5D2C5B5D2C5B5D5D2C6F3D6E6577204D61703B72657475726E2066756E6374696F6E206528732C72297B6C657420613D6F2E6765742873293B6966286E756C6C213D61297B696628613C3D722972657475726E3B6C6574';
wwv_flow_imp.g_varchar2_table(44019) := '20653D695B615D2E696E6465784F662873293B653E2D312626695B615D2E73706C69636528652C31292C7320696E7374616E63656F66204D6B26266E2E64656C65746528732E636F6D706172746D656E74297D6966286F2E73657428732C72292C417272';
wwv_flow_imp.g_varchar2_table(44020) := '61792E6973417272617928732929666F72286C65742074206F662073296528742C72293B656C7365206966287320696E7374616E63656F66204D6B297B6966286E2E68617328732E636F6D706172746D656E7429297468726F77206E65772052616E6765';
wwv_flow_imp.g_varchar2_table(44021) := '4572726F7228224475706C696361746520757365206F6620636F6D706172746D656E7420696E20657874656E73696F6E7322293B6C657420693D742E67657428732E636F6D706172746D656E74297C7C732E696E6E65723B6E2E73657428732E636F6D70';
wwv_flow_imp.g_varchar2_table(44022) := '6172746D656E742C69292C6528692C72297D656C7365206966287320696E7374616E63656F6620546B296528732E696E6E65722C732E70726563293B656C7365206966287320696E7374616E63656F6620456B29695B725D2E707573682873292C732E70';
wwv_flow_imp.g_varchar2_table(44023) := '726F766964657326266528732E70726F76696465732C72293B656C7365206966287320696E7374616E63656F6620776B29695B725D2E707573682873292C732E66616365742E657874656E73696F6E7326266528732E66616365742E657874656E73696F';
wwv_flow_imp.g_varchar2_table(44024) := '6E732C32293B656C73657B6C657420743D732E657874656E73696F6E3B6966282174297468726F77206E6577204572726F722860556E7265636F676E697A656420657874656E73696F6E2076616C756520696E20657874656E73696F6E20736574202824';
wwv_flow_imp.g_varchar2_table(44025) := '7B737D292E205468697320736F6D6574696D65732068617070656E732062656361757365206D756C7469706C6520696E7374616E636573206F662040636F64656D6972726F722F737461746520617265206C6F616465642C20627265616B696E6720696E';
wwv_flow_imp.g_varchar2_table(44026) := '7374616E63656F6620636865636B732E60293B6528742C72297D7D28652C32292C692E726564756365282828652C74293D3E652E636F6E63617428742929297D28652C742C7329296E20696E7374616E63656F6620456B3F692E70757368286E293A286F';
wwv_flow_imp.g_varchar2_table(44027) := '5B6E2E66616365742E69645D7C7C286F5B6E2E66616365742E69645D3D5B5D29292E70757368286E293B6C657420723D4F626A6563742E637265617465286E756C6C292C613D5B5D2C6C3D5B5D3B666F72286C65742065206F66206929725B652E69645D';
wwv_flow_imp.g_varchar2_table(44028) := '3D6C2E6C656E6774683C3C312C6C2E707573682828743D3E652E736C6F7428742929293B6C657420633D6E756C6C3D3D6E3F766F696420303A6E2E636F6E6669672E6661636574733B666F72286C6574206520696E206F297B6C657420743D6F5B655D2C';
wwv_flow_imp.g_varchar2_table(44029) := '693D745B305D2E66616365742C733D632626635B655D7C7C5B5D3B696628742E65766572792828653D3E303D3D652E74797065292929696628725B692E69645D3D612E6C656E6774683C3C317C312C796B28732C742929612E70757368286E2E66616365';
wwv_flow_imp.g_varchar2_table(44030) := '74286929293B656C73657B6C657420653D692E636F6D62696E6528742E6D61702828653D3E652E76616C75652929293B612E70757368286E2626692E636F6D7061726528652C6E2E6661636574286929293F6E2E66616365742869293A65297D656C7365';
wwv_flow_imp.g_varchar2_table(44031) := '7B666F72286C65742065206F66207429303D3D652E747970653F28725B652E69645D3D612E6C656E6774683C3C317C312C612E7075736828652E76616C756529293A28725B652E69645D3D6C2E6C656E6774683C3C312C6C2E707573682828743D3E652E';
wwv_flow_imp.g_varchar2_table(44032) := '64796E616D6963536C6F742874292929293B725B692E69645D3D6C2E6C656E6774683C3C312C6C2E707573682828653D3E786B28652C692C742929297D7D6C657420643D6C2E6D61702828653D3E6528722929293B72657475726E206E657720416B2865';
wwv_flow_imp.g_varchar2_table(44033) := '2C732C642C722C612C6F297D7D66756E6374696F6E204E6B28652C74297B6966283126742972657475726E20323B6C6574206E3D743E3E312C693D652E7374617475735B6E5D3B696628343D3D69297468726F77206E6577204572726F7228224379636C';
wwv_flow_imp.g_varchar2_table(44034) := '696320646570656E64656E6379206265747765656E206669656C647320616E642F6F722066616365747322293B6966283226692972657475726E20693B652E7374617475735B6E5D3D343B6C6574206F3D652E636F6D70757465536C6F7428652C652E63';
wwv_flow_imp.g_varchar2_table(44035) := '6F6E6669672E64796E616D6963536C6F74735B6E5D293B72657475726E20652E7374617475735B6E5D3D327C6F7D66756E6374696F6E20506B28652C74297B72657475726E203126743F652E636F6E6669672E73746174696356616C7565735B743E3E31';
wwv_flow_imp.g_varchar2_table(44036) := '5D3A652E76616C7565735B743E3E315D7D636F6E7374204F6B3D5F6B2E646566696E6528292C526B3D5F6B2E646566696E65287B636F6D62696E653A653D3E652E736F6D652828653D3E6529292C7374617469633A21307D292C466B3D5F6B2E64656669';
wwv_flow_imp.g_varchar2_table(44037) := '6E65287B636F6D62696E653A653D3E652E6C656E6774683F655B305D3A766F696420302C7374617469633A21307D292C426B3D5F6B2E646566696E6528292C566B3D5F6B2E646566696E6528292C7A6B3D5F6B2E646566696E6528292C486B3D5F6B2E64';
wwv_flow_imp.g_varchar2_table(44038) := '6566696E65287B636F6D62696E653A653D3E2121652E6C656E6774682626655B305D7D293B636C61737320576B7B636F6E7374727563746F7228652C74297B746869732E747970653D652C746869732E76616C75653D747D73746174696320646566696E';
wwv_flow_imp.g_varchar2_table(44039) := '6528297B72657475726E206E6577206A6B7D7D636C617373206A6B7B6F662865297B72657475726E206E657720576B28746869732C65297D7D636C61737320716B7B636F6E7374727563746F722865297B746869732E6D61703D657D6F662865297B7265';
wwv_flow_imp.g_varchar2_table(44040) := '7475726E206E657720246B28746869732C65297D7D636C61737320246B7B636F6E7374727563746F7228652C74297B746869732E747970653D652C746869732E76616C75653D747D6D61702865297B6C657420743D746869732E747970652E6D61702874';
wwv_flow_imp.g_varchar2_table(44041) := '6869732E76616C75652C65293B72657475726E20766F696420303D3D3D743F766F696420303A743D3D746869732E76616C75653F746869733A6E657720246B28746869732E747970652C74297D69732865297B72657475726E20746869732E747970653D';
wwv_flow_imp.g_varchar2_table(44042) := '3D657D73746174696320646566696E6528653D7B7D297B72657475726E206E657720716B28652E6D61707C7C28653D3E6529297D737461746963206D61704566666563747328652C74297B69662821652E6C656E6774682972657475726E20653B6C6574';
wwv_flow_imp.g_varchar2_table(44043) := '206E3D5B5D3B666F72286C65742069206F662065297B6C657420653D692E6D61702874293B6526266E2E707573682865297D72657475726E206E7D7D246B2E7265636F6E6669677572653D246B2E646566696E6528292C246B2E617070656E64436F6E66';
wwv_flow_imp.g_varchar2_table(44044) := '69673D246B2E646566696E6528293B636C61737320556B7B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E737461727453746174653D652C746869732E6368616E6765733D742C746869732E73656C656374696F6E3D6E2C74';
wwv_flow_imp.g_varchar2_table(44045) := '6869732E656666656374733D692C746869732E616E6E6F746174696F6E733D6F2C746869732E7363726F6C6C496E746F566965773D732C746869732E5F646F633D6E756C6C2C746869732E5F73746174653D6E756C6C2C6E2626766B286E2C742E6E6577';
wwv_flow_imp.g_varchar2_table(44046) := '4C656E677468292C6F2E736F6D652828653D3E652E747970653D3D556B2E74696D6529297C7C28746869732E616E6E6F746174696F6E733D6F2E636F6E63617428556B2E74696D652E6F6628446174652E6E6F7728292929297D73746174696320637265';
wwv_flow_imp.g_varchar2_table(44047) := '61746528652C742C6E2C692C6F2C73297B72657475726E206E657720556B28652C742C6E2C692C6F2C73297D676574206E6577446F6328297B72657475726E20746869732E5F646F637C7C28746869732E5F646F633D746869732E6368616E6765732E61';
wwv_flow_imp.g_varchar2_table(44048) := '70706C7928746869732E737461727453746174652E646F6329297D676574206E657753656C656374696F6E28297B72657475726E20746869732E73656C656374696F6E7C7C746869732E737461727453746174652E73656C656374696F6E2E6D61702874';
wwv_flow_imp.g_varchar2_table(44049) := '6869732E6368616E676573297D67657420737461746528297B72657475726E20746869732E5F73746174657C7C746869732E737461727453746174652E6170706C795472616E73616374696F6E2874686973292C746869732E5F73746174657D616E6E6F';
wwv_flow_imp.g_varchar2_table(44050) := '746174696F6E2865297B666F72286C65742074206F6620746869732E616E6E6F746174696F6E7329696628742E747970653D3D652972657475726E20742E76616C75657D67657420646F634368616E67656428297B72657475726E21746869732E636861';
wwv_flow_imp.g_varchar2_table(44051) := '6E6765732E656D7074797D676574207265636F6E6669677572656428297B72657475726E20746869732E737461727453746174652E636F6E666967213D746869732E73746174652E636F6E6669677D6973557365724576656E742865297B6C657420743D';
wwv_flow_imp.g_varchar2_table(44052) := '746869732E616E6E6F746174696F6E28556B2E757365724576656E74293B72657475726E212821747C7C2128743D3D657C7C742E6C656E6774683E652E6C656E6774682626742E736C69636528302C652E6C656E677468293D3D652626222E223D3D745B';
wwv_flow_imp.g_varchar2_table(44053) := '652E6C656E6774685D29297D7D66756E6374696F6E204B6B28652C74297B6C6574206E3D5B5D3B666F72286C657420693D302C6F3D303B3B297B6C657420732C723B696628693C652E6C656E6774682626286F3D3D742E6C656E6774687C7C745B6F5D3E';
wwv_flow_imp.g_varchar2_table(44054) := '3D655B695D2929733D655B692B2B5D2C723D655B692B2B5D3B656C73657B69662821286F3C742E6C656E677468292972657475726E206E3B733D745B6F2B2B5D2C723D745B6F2B2B5D7D216E2E6C656E6774687C7C6E5B6E2E6C656E6774682D315D3C73';
wwv_flow_imp.g_varchar2_table(44055) := '3F6E2E7075736828732C72293A6E5B6E2E6C656E6774682D315D3C722626286E5B6E2E6C656E6774682D315D3D72297D7D66756E6374696F6E20476B28652C742C6E297B76617220693B6C6574206F2C732C723B72657475726E206E3F286F3D742E6368';
wwv_flow_imp.g_varchar2_table(44056) := '616E6765732C733D6C6B2E656D70747928742E6368616E6765732E6C656E677468292C723D652E6368616E6765732E636F6D706F736528742E6368616E67657329293A286F3D742E6368616E6765732E6D617028652E6368616E676573292C733D652E63';
wwv_flow_imp.g_varchar2_table(44057) := '68616E6765732E6D61704465736328742E6368616E6765732C2130292C723D652E6368616E6765732E636F6D706F7365286F29292C7B6368616E6765733A722C73656C656374696F6E3A742E73656C656374696F6E3F742E73656C656374696F6E2E6D61';
wwv_flow_imp.g_varchar2_table(44058) := '702873293A6E756C6C3D3D3D28693D652E73656C656374696F6E297C7C766F696420303D3D3D693F766F696420303A692E6D6170286F292C656666656374733A246B2E6D61704566666563747328652E656666656374732C6F292E636F6E63617428246B';
wwv_flow_imp.g_varchar2_table(44059) := '2E6D61704566666563747328742E656666656374732C7329292C616E6E6F746174696F6E733A652E616E6E6F746174696F6E732E6C656E6774683F652E616E6E6F746174696F6E732E636F6E63617428742E616E6E6F746174696F6E73293A742E616E6E';
wwv_flow_imp.g_varchar2_table(44060) := '6F746174696F6E732C7363726F6C6C496E746F566965773A652E7363726F6C6C496E746F566965777C7C742E7363726F6C6C496E746F566965777D7D66756E6374696F6E20516B28652C742C6E297B6C657420693D742E73656C656374696F6E2C6F3D58';
wwv_flow_imp.g_varchar2_table(44061) := '6B28742E616E6E6F746174696F6E73293B72657475726E20742E757365724576656E742626286F3D6F2E636F6E63617428556B2E757365724576656E742E6F6628742E757365724576656E742929292C7B6368616E6765733A742E6368616E6765732069';
wwv_flow_imp.g_varchar2_table(44062) := '6E7374616E63656F66206C6B3F742E6368616E6765733A6C6B2E6F6628742E6368616E6765737C7C5B5D2C6E2C652E666163657428466B29292C73656C656374696F6E3A692626286920696E7374616E63656F6620666B3F693A666B2E73696E676C6528';
wwv_flow_imp.g_varchar2_table(44063) := '692E616E63686F722C692E6865616429292C656666656374733A586B28742E65666665637473292C616E6E6F746174696F6E733A6F2C7363726F6C6C496E746F566965773A2121742E7363726F6C6C496E746F566965777D7D66756E6374696F6E20596B';
wwv_flow_imp.g_varchar2_table(44064) := '28652C742C6E297B6C657420693D516B28652C742E6C656E6774683F745B305D3A7B7D2C652E646F632E6C656E677468293B742E6C656E677468262621313D3D3D745B305D2E66696C7465722626286E3D2131293B666F72286C6574206F3D313B6F3C74';
wwv_flow_imp.g_varchar2_table(44065) := '2E6C656E6774683B6F2B2B297B21313D3D3D745B6F5D2E66696C7465722626286E3D2131293B6C657420733D2121745B6F5D2E73657175656E7469616C3B693D476B28692C516B28652C745B6F5D2C733F692E6368616E6765732E6E65774C656E677468';
wwv_flow_imp.g_varchar2_table(44066) := '3A652E646F632E6C656E677468292C73297D6C6574206F3D556B2E63726561746528652C692E6368616E6765732C692E73656C656374696F6E2C692E656666656374732C692E616E6E6F746174696F6E732C692E7363726F6C6C496E746F56696577293B';
wwv_flow_imp.g_varchar2_table(44067) := '72657475726E2066756E6374696F6E2865297B6C657420743D652E737461727453746174652C6E3D742E6661636574287A6B292C693D653B666F72286C6574206F3D6E2E6C656E6774682D313B6F3E3D303B6F2D2D297B6C657420733D6E5B6F5D286529';
wwv_flow_imp.g_varchar2_table(44068) := '3B7326264F626A6563742E6B6579732873292E6C656E677468262628693D476B28692C516B28742C732C652E6368616E6765732E6E65774C656E677468292C213029297D72657475726E20693D3D653F653A556B2E63726561746528742C652E6368616E';
wwv_flow_imp.g_varchar2_table(44069) := '6765732C652E73656C656374696F6E2C692E656666656374732C692E616E6E6F746174696F6E732C692E7363726F6C6C496E746F56696577297D286E3F66756E6374696F6E2865297B6C657420743D652E737461727453746174652C6E3D21303B666F72';
wwv_flow_imp.g_varchar2_table(44070) := '286C65742069206F6620742E666163657428426B29297B6C657420743D692865293B69662821313D3D3D74297B6E3D21313B627265616B7D41727261792E697341727261792874292626286E3D21303D3D3D6E3F743A4B6B286E2C7429297D6966282130';
wwv_flow_imp.g_varchar2_table(44071) := '213D3D6E297B6C657420692C6F3B69662821313D3D3D6E296F3D652E6368616E6765732E696E766572746564446573632C693D6C6B2E656D70747928742E646F632E6C656E677468293B656C73657B6C657420743D652E6368616E6765732E66696C7465';
wwv_flow_imp.g_varchar2_table(44072) := '72286E293B693D742E6368616E6765732C6F3D742E66696C74657265642E6D61704465736328742E6368616E676573292E696E766572746564446573637D653D556B2E63726561746528742C692C652E73656C656374696F6E2626652E73656C65637469';
wwv_flow_imp.g_varchar2_table(44073) := '6F6E2E6D6170286F292C246B2E6D61704566666563747328652E656666656374732C6F292C652E616E6E6F746174696F6E732C652E7363726F6C6C496E746F56696577297D6C657420693D742E666163657428566B293B666F72286C6574206E3D692E6C';
wwv_flow_imp.g_varchar2_table(44074) := '656E6774682D313B6E3E3D303B6E2D2D297B6C6574206F3D695B6E5D2865293B653D6F20696E7374616E63656F6620556B3F6F3A41727261792E69734172726179286F292626313D3D6F2E6C656E67746826266F5B305D696E7374616E63656F6620556B';
wwv_flow_imp.g_varchar2_table(44075) := '3F6F5B305D3A596B28742C586B286F292C2131297D72657475726E20657D286F293A6F297D556B2E74696D653D576B2E646566696E6528292C556B2E757365724576656E743D576B2E646566696E6528292C556B2E616464546F486973746F72793D576B';
wwv_flow_imp.g_varchar2_table(44076) := '2E646566696E6528292C556B2E72656D6F74653D576B2E646566696E6528293B636F6E7374205A6B3D5B5D3B66756E6374696F6E20586B2865297B72657475726E206E756C6C3D3D653F5A6B3A41727261792E697341727261792865293F653A5B655D7D';
wwv_flow_imp.g_varchar2_table(44077) := '766172204A6B3D66756E6374696F6E2865297B72657475726E20655B652E576F72643D305D3D22576F7264222C655B652E53706163653D315D3D225370616365222C655B652E4F746865723D325D3D224F74686572222C657D284A6B7C7C284A6B3D7B7D';
wwv_flow_imp.g_varchar2_table(44078) := '29293B636F6E73742065453D2F5B5C75303064665C75303538375C75303539302D5C75303566345C75303630302D5C75303666665C75333034302D5C75333039665C75333061302D5C75333066665C75333430302D5C75346462355C75346530302D5C75';
wwv_flow_imp.g_varchar2_table(44079) := '396663635C75616330302D5C75643761665D2F3B6C65742074453B7472797B74453D6E65772052656745787028225B5C5C707B416C70686162657469637D5C5C707B4E756D6265727D5F5D222C227522297D636174636828746C297B7D636C617373206E';
wwv_flow_imp.g_varchar2_table(44080) := '457B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E636F6E6669673D652C746869732E646F633D742C746869732E73656C656374696F6E3D6E2C746869732E76616C7565733D692C746869732E7374617475733D652E737461';
wwv_flow_imp.g_varchar2_table(44081) := '74757354656D706C6174652E736C69636528292C746869732E636F6D70757465536C6F743D6F2C73262628732E5F73746174653D74686973293B666F72286C657420653D303B653C746869732E636F6E6669672E64796E616D6963536C6F74732E6C656E';
wwv_flow_imp.g_varchar2_table(44082) := '6774683B652B2B294E6B28746869732C653C3C31293B746869732E636F6D70757465536C6F743D6E756C6C7D6669656C6428652C743D2130297B6C6574206E3D746869732E636F6E6669672E616464726573735B652E69645D3B6966286E756C6C213D6E';
wwv_flow_imp.g_varchar2_table(44083) := '2972657475726E204E6B28746869732C6E292C506B28746869732C6E293B69662874297468726F77206E65772052616E67654572726F7228224669656C64206973206E6F742070726573656E7420696E207468697320737461746522297D757064617465';
wwv_flow_imp.g_varchar2_table(44084) := '282E2E2E65297B72657475726E20596B28746869732C652C2130297D6170706C795472616E73616374696F6E2865297B6C657420742C6E3D746869732E636F6E6669672C7B626173653A692C636F6D706172746D656E74733A6F7D3D6E3B666F72286C65';
wwv_flow_imp.g_varchar2_table(44085) := '742074206F6620652E6566666563747329742E697328496B2E7265636F6E666967757265293F286E2626286F3D6E6577204D61702C6E2E636F6D706172746D656E74732E666F7245616368282828652C74293D3E6F2E73657428742C652929292C6E3D6E';
wwv_flow_imp.g_varchar2_table(44086) := '756C6C292C6F2E73657428742E76616C75652E636F6D706172746D656E742C742E76616C75652E657874656E73696F6E29293A742E697328246B2E7265636F6E666967757265293F286E3D6E756C6C2C693D742E76616C7565293A742E697328246B2E61';
wwv_flow_imp.g_varchar2_table(44087) := '7070656E64436F6E666967292626286E3D6E756C6C2C693D586B2869292E636F6E63617428742E76616C756529293B6E3F743D652E737461727453746174652E76616C7565732E736C69636528293A286E3D416B2E7265736F6C766528692C6F2C746869';
wwv_flow_imp.g_varchar2_table(44088) := '73292C743D6E6577206E45286E2C746869732E646F632C746869732E73656C656374696F6E2C6E2E64796E616D6963536C6F74732E6D6170282828293D3E6E756C6C29292C2828652C74293D3E742E7265636F6E66696775726528652C7468697329292C';
wwv_flow_imp.g_varchar2_table(44089) := '6E756C6C292E76616C756573293B6C657420733D652E737461727453746174652E666163657428526B293F652E6E657753656C656374696F6E3A652E6E657753656C656374696F6E2E617353696E676C6528293B6E6577206E45286E2C652E6E6577446F';
wwv_flow_imp.g_varchar2_table(44090) := '632C732C742C2828742C6E293D3E6E2E75706461746528742C6529292C65297D7265706C61636553656C656374696F6E2865297B72657475726E22737472696E67223D3D747970656F662065262628653D746869732E746F54657874286529292C746869';
wwv_flow_imp.g_varchar2_table(44091) := '732E6368616E6765427952616E67652828743D3E287B6368616E6765733A7B66726F6D3A742E66726F6D2C746F3A742E746F2C696E736572743A657D2C72616E67653A666B2E637572736F7228742E66726F6D2B652E6C656E677468297D2929297D6368';
wwv_flow_imp.g_varchar2_table(44092) := '616E6765427952616E67652865297B6C657420743D746869732E73656C656374696F6E2C6E3D6528742E72616E6765735B305D292C693D746869732E6368616E676573286E2E6368616E676573292C6F3D5B6E2E72616E67655D2C733D586B286E2E6566';
wwv_flow_imp.g_varchar2_table(44093) := '6665637473293B666F72286C6574206E3D313B6E3C742E72616E6765732E6C656E6774683B6E2B2B297B6C657420723D6528742E72616E6765735B6E5D292C613D746869732E6368616E67657328722E6368616E676573292C6C3D612E6D61702869293B';
wwv_flow_imp.g_varchar2_table(44094) := '666F72286C657420653D303B653C6E3B652B2B296F5B655D3D6F5B655D2E6D6170286C293B6C657420633D692E6D61704465736328612C2130293B6F2E7075736828722E72616E67652E6D6170286329292C693D692E636F6D706F7365286C292C733D24';
wwv_flow_imp.g_varchar2_table(44095) := '6B2E6D61704566666563747328732C6C292E636F6E63617428246B2E6D61704566666563747328586B28722E65666665637473292C6329297D72657475726E7B6368616E6765733A692C73656C656374696F6E3A666B2E637265617465286F2C742E6D61';
wwv_flow_imp.g_varchar2_table(44096) := '696E496E646578292C656666656374733A737D7D6368616E67657328653D5B5D297B72657475726E206520696E7374616E63656F66206C6B3F653A6C6B2E6F6628652C746869732E646F632E6C656E6774682C746869732E6661636574286E452E6C696E';
wwv_flow_imp.g_varchar2_table(44097) := '65536570617261746F7229297D746F546578742865297B72657475726E2046782E6F6628652E73706C697428746869732E6661636574286E452E6C696E65536570617261746F72297C7C736B29297D736C696365446F6328653D302C743D746869732E64';
wwv_flow_imp.g_varchar2_table(44098) := '6F632E6C656E677468297B72657475726E20746869732E646F632E736C696365537472696E6728652C742C746869732E6C696E65427265616B297D66616365742865297B6C657420743D746869732E636F6E6669672E616464726573735B652E69645D3B';
wwv_flow_imp.g_varchar2_table(44099) := '72657475726E206E756C6C3D3D743F652E64656661756C743A284E6B28746869732C74292C506B28746869732C7429297D746F4A534F4E2865297B6C657420743D7B646F633A746869732E736C696365446F6328292C73656C656374696F6E3A74686973';
wwv_flow_imp.g_varchar2_table(44100) := '2E73656C656374696F6E2E746F4A534F4E28297D3B6966286529666F72286C6574206E20696E2065297B6C657420693D655B6E5D3B6920696E7374616E63656F6620456B26266E756C6C213D746869732E636F6E6669672E616464726573735B692E6964';
wwv_flow_imp.g_varchar2_table(44101) := '5D262628745B6E5D3D692E737065632E746F4A534F4E28746869732E6669656C6428655B6E5D292C7468697329297D72657475726E20747D7374617469632066726F6D4A534F4E28652C743D7B7D2C6E297B69662821657C7C22737472696E6722213D74';
wwv_flow_imp.g_varchar2_table(44102) := '7970656F6620652E646F63297468726F77206E65772052616E67654572726F722822496E76616C6964204A534F4E20726570726573656E746174696F6E20666F7220456469746F72537461746522293B6C657420693D5B5D3B6966286E29666F72286C65';
wwv_flow_imp.g_varchar2_table(44103) := '74207420696E206E296966284F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C7429297B6C6574206F3D6E5B745D2C733D655B745D3B692E70757368286F2E696E69742828653D3E6F2E737065632E6672';
wwv_flow_imp.g_varchar2_table(44104) := '6F6D4A534F4E28732C65292929297D72657475726E206E452E637265617465287B646F633A652E646F632C73656C656374696F6E3A666B2E66726F6D4A534F4E28652E73656C656374696F6E292C657874656E73696F6E733A742E657874656E73696F6E';
wwv_flow_imp.g_varchar2_table(44105) := '733F692E636F6E636174285B742E657874656E73696F6E735D293A697D297D7374617469632063726561746528653D7B7D297B6C657420743D416B2E7265736F6C766528652E657874656E73696F6E737C7C5B5D2C6E6577204D6170292C6E3D652E646F';
wwv_flow_imp.g_varchar2_table(44106) := '6320696E7374616E63656F662046783F652E646F633A46782E6F662828652E646F637C7C2222292E73706C697428742E7374617469634661636574286E452E6C696E65536570617261746F72297C7C736B29292C693D652E73656C656374696F6E3F652E';
wwv_flow_imp.g_varchar2_table(44107) := '73656C656374696F6E20696E7374616E63656F6620666B3F652E73656C656374696F6E3A666B2E73696E676C6528652E73656C656374696F6E2E616E63686F722C652E73656C656374696F6E2E68656164293A666B2E73696E676C652830293B72657475';
wwv_flow_imp.g_varchar2_table(44108) := '726E20766B28692C6E2E6C656E677468292C742E737461746963466163657428526B297C7C28693D692E617353696E676C652829292C6E6577206E4528742C6E2C692C742E64796E616D6963536C6F74732E6D6170282828293D3E6E756C6C29292C2828';
wwv_flow_imp.g_varchar2_table(44109) := '652C74293D3E742E637265617465286529292C6E756C6C297D6765742074616253697A6528297B72657475726E20746869732E6661636574286E452E74616253697A65297D676574206C696E65427265616B28297B72657475726E20746869732E666163';
wwv_flow_imp.g_varchar2_table(44110) := '6574286E452E6C696E65536570617261746F72297C7C225C6E227D67657420726561644F6E6C7928297B72657475726E20746869732E666163657428486B297D70687261736528652C2E2E2E74297B666F72286C65742074206F6620746869732E666163';
wwv_flow_imp.g_varchar2_table(44111) := '6574286E452E7068726173657329296966284F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C6529297B653D745B655D3B627265616B7D72657475726E20742E6C656E677468262628653D652E7265706C';
wwv_flow_imp.g_varchar2_table(44112) := '616365282F5C24285C247C5C642A292F672C2828652C6E293D3E7B6966282224223D3D6E2972657475726E2224223B6C657420693D2B286E7C7C31293B72657475726E21697C7C693E742E6C656E6774683F653A745B692D315D7D2929292C657D6C616E';
wwv_flow_imp.g_varchar2_table(44113) := '677561676544617461417428652C742C6E3D2D31297B6C657420693D5B5D3B666F72286C6574206F206F6620746869732E6661636574284F6B2929666F72286C65742073206F66206F28746869732C742C6E29294F626A6563742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(44114) := '2E6861734F776E50726F70657274792E63616C6C28732C65292626692E7075736828735B655D293B72657475726E20697D6368617243617465676F72697A65722865297B72657475726E20743D746869732E6C616E67756167654461746141742822776F';
wwv_flow_imp.g_varchar2_table(44115) := '72644368617273222C65292E6A6F696E282222292C653D3E7B696628212F5C532F2E746573742865292972657475726E204A6B2E53706163653B69662866756E6374696F6E2865297B69662874452972657475726E2074452E746573742865293B666F72';
wwv_flow_imp.g_varchar2_table(44116) := '286C657420743D303B743C652E6C656E6774683B742B2B297B6C6574206E3D655B745D3B6966282F5C772F2E74657374286E297C7C6E3E22C280222626286E2E746F5570706572436173652829213D6E2E746F4C6F7765724361736528297C7C65452E74';
wwv_flow_imp.g_varchar2_table(44117) := '657374286E29292972657475726E21307D72657475726E21317D2865292972657475726E204A6B2E576F72643B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29696628652E696E6465784F6628745B6E5D293E2D312972657475726E';
wwv_flow_imp.g_varchar2_table(44118) := '204A6B2E576F72643B72657475726E204A6B2E4F746865727D3B76617220747D776F726441742865297B6C65747B746578743A742C66726F6D3A6E2C6C656E6774683A697D3D746869732E646F632E6C696E6541742865292C6F3D746869732E63686172';
wwv_flow_imp.g_varchar2_table(44119) := '43617465676F72697A65722865292C733D652D6E2C723D652D6E3B666F72283B733E303B297B6C657420653D5A7828742C732C2131293B6966286F28742E736C69636528652C732929213D4A6B2E576F726429627265616B3B733D657D666F72283B723C';
wwv_flow_imp.g_varchar2_table(44120) := '693B297B6C657420653D5A7828742C72293B6966286F28742E736C69636528722C652929213D4A6B2E576F726429627265616B3B723D657D72657475726E20733D3D723F6E756C6C3A666B2E72616E676528732B6E2C722B6E297D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(44121) := '20694528652C742C6E3D7B7D297B6C657420693D7B7D3B666F72286C65742074206F66206529666F72286C65742065206F66204F626A6563742E6B657973287429297B6C6574206F3D745B655D2C733D695B655D3B696628766F696420303D3D3D732969';
wwv_flow_imp.g_varchar2_table(44122) := '5B655D3D6F3B656C736520696628733D3D3D6F7C7C766F696420303D3D3D6F293B656C73657B696628214F626A6563742E6861734F776E50726F70657274792E63616C6C286E2C6529297468726F77206E6577204572726F722822436F6E666967206D65';
wwv_flow_imp.g_varchar2_table(44123) := '72676520636F6E666C69637420666F72206669656C6420222B65293B695B655D3D6E5B655D28732C6F297D7D666F72286C6574206520696E207429766F696420303D3D3D695B655D262628695B655D3D745B655D293B72657475726E20697D6E452E616C';
wwv_flow_imp.g_varchar2_table(44124) := '6C6F774D756C7469706C6553656C656374696F6E733D526B2C6E452E74616253697A653D5F6B2E646566696E65287B636F6D62696E653A653D3E652E6C656E6774683F655B305D3A347D292C6E452E6C696E65536570617261746F723D466B2C6E452E72';
wwv_flow_imp.g_varchar2_table(44125) := '6561644F6E6C793D486B2C6E452E706872617365733D5F6B2E646566696E65287B636F6D7061726528652C74297B6C6574206E3D4F626A6563742E6B6579732865292C693D4F626A6563742E6B6579732874293B72657475726E206E2E6C656E6774683D';
wwv_flow_imp.g_varchar2_table(44126) := '3D692E6C656E67746826266E2E657665727928286E3D3E655B6E5D3D3D745B6E5D29297D7D292C6E452E6C616E6775616765446174613D4F6B2C6E452E6368616E676546696C7465723D426B2C6E452E7472616E73616374696F6E46696C7465723D566B';
wwv_flow_imp.g_varchar2_table(44127) := '2C6E452E7472616E73616374696F6E457874656E6465723D7A6B2C496B2E7265636F6E6669677572653D246B2E646566696E6528293B636C617373206F457B65712865297B72657475726E20746869733D3D657D72616E676528652C743D65297B726574';
wwv_flow_imp.g_varchar2_table(44128) := '75726E2073452E63726561746528652C742C74686973297D7D6F452E70726F746F747970652E7374617274536964653D6F452E70726F746F747970652E656E64536964653D302C6F452E70726F746F747970652E706F696E743D21312C6F452E70726F74';
wwv_flow_imp.g_varchar2_table(44129) := '6F747970652E6D61704D6F64653D726B2E547261636B44656C3B636C6173732073457B636F6E7374727563746F7228652C742C6E297B746869732E66726F6D3D652C746869732E746F3D742C746869732E76616C75653D6E7D7374617469632063726561';
wwv_flow_imp.g_varchar2_table(44130) := '746528652C742C6E297B72657475726E206E657720734528652C742C6E297D7D66756E6374696F6E20724528652C74297B72657475726E20652E66726F6D2D742E66726F6D7C7C652E76616C75652E7374617274536964652D742E76616C75652E737461';
wwv_flow_imp.g_varchar2_table(44131) := '7274536964657D636C6173732061457B636F6E7374727563746F7228652C742C6E2C69297B746869732E66726F6D3D652C746869732E746F3D742C746869732E76616C75653D6E2C746869732E6D6178506F696E743D697D676574206C656E6774682829';
wwv_flow_imp.g_varchar2_table(44132) := '7B72657475726E20746869732E746F5B746869732E746F2E6C656E6774682D315D7D66696E64496E64657828652C742C6E2C693D30297B6C6574206F3D6E3F746869732E746F3A746869732E66726F6D3B666F72286C657420733D692C723D6F2E6C656E';
wwv_flow_imp.g_varchar2_table(44133) := '6774683B3B297B696628733D3D722972657475726E20733B6C657420693D732B723E3E312C613D6F5B695D2D657C7C286E3F746869732E76616C75655B695D2E656E64536964653A746869732E76616C75655B695D2E737461727453696465292D743B69';
wwv_flow_imp.g_varchar2_table(44134) := '6628693D3D732972657475726E20613E3D303F733A723B613E3D303F723D693A733D692B317D7D6265747765656E28652C742C6E2C69297B666F72286C6574206F3D746869732E66696E64496E64657828742C2D3165392C2130292C733D746869732E66';
wwv_flow_imp.g_varchar2_table(44135) := '696E64496E646578286E2C3165392C21312C6F293B6F3C733B6F2B2B2969662821313D3D3D6928746869732E66726F6D5B6F5D2B652C746869732E746F5B6F5D2B652C746869732E76616C75655B6F5D292972657475726E21317D6D617028652C74297B';
wwv_flow_imp.g_varchar2_table(44136) := '6C6574206E3D5B5D2C693D5B5D2C6F3D5B5D2C733D2D312C723D2D313B666F72286C657420613D303B613C746869732E76616C75652E6C656E6774683B612B2B297B6C6574206C2C632C643D746869732E76616C75655B615D2C683D746869732E66726F';
wwv_flow_imp.g_varchar2_table(44137) := '6D5B615D2B652C753D746869732E746F5B615D2B653B696628683D3D75297B6C657420653D742E6D6170506F7328682C642E7374617274536964652C642E6D61704D6F6465293B6966286E756C6C3D3D6529636F6E74696E75653B6966286C3D633D652C';
wwv_flow_imp.g_varchar2_table(44138) := '642E737461727453696465213D642E656E6453696465262628633D742E6D6170506F7328682C642E656E6453696465292C633C6C2929636F6E74696E75657D656C7365206966286C3D742E6D6170506F7328682C642E737461727453696465292C633D74';
wwv_flow_imp.g_varchar2_table(44139) := '2E6D6170506F7328752C642E656E6453696465292C6C3E637C7C6C3D3D632626642E7374617274536964653E302626642E656E64536964653C3D3029636F6E74696E75653B28632D6C7C7C642E656E64536964652D642E737461727453696465293C307C';
wwv_flow_imp.g_varchar2_table(44140) := '7C28733C30262628733D6C292C642E706F696E74262628723D4D6174682E6D617828722C632D6C29292C6E2E707573682864292C692E70757368286C2D73292C6F2E7075736828632D7329297D72657475726E7B6D61707065643A6E2E6C656E6774683F';
wwv_flow_imp.g_varchar2_table(44141) := '6E657720614528692C6F2C6E2C72293A6E756C6C2C706F733A737D7D7D636C617373206C457B636F6E7374727563746F7228652C742C6E2C69297B746869732E6368756E6B506F733D652C746869732E6368756E6B3D742C746869732E6E6578744C6179';
wwv_flow_imp.g_varchar2_table(44142) := '65723D6E2C746869732E6D6178506F696E743D697D7374617469632063726561746528652C742C6E2C69297B72657475726E206E6577206C4528652C742C6E2C69297D676574206C656E67746828297B6C657420653D746869732E6368756E6B2E6C656E';
wwv_flow_imp.g_varchar2_table(44143) := '6774682D313B72657475726E20653C303F303A4D6174682E6D617828746869732E6368756E6B456E642865292C746869732E6E6578744C617965722E6C656E677468297D6765742073697A6528297B696628746869732E6973456D707479297265747572';
wwv_flow_imp.g_varchar2_table(44144) := '6E20303B6C657420653D746869732E6E6578744C617965722E73697A653B666F72286C65742074206F6620746869732E6368756E6B29652B3D742E76616C75652E6C656E6774683B72657475726E20657D6368756E6B456E642865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(44145) := '746869732E6368756E6B506F735B655D2B746869732E6368756E6B5B655D2E6C656E6774687D7570646174652865297B6C65747B6164643A743D5B5D2C736F72743A6E3D21312C66696C74657246726F6D3A693D302C66696C746572546F3A6F3D746869';
wwv_flow_imp.g_varchar2_table(44146) := '732E6C656E6774687D3D652C733D652E66696C7465723B696628303D3D742E6C656E677468262621732972657475726E20746869733B6966286E262628743D742E736C69636528292E736F727428724529292C746869732E6973456D7074792972657475';
wwv_flow_imp.g_varchar2_table(44147) := '726E20742E6C656E6774683F6C452E6F662874293A746869733B6C657420723D6E657720684528746869732C6E756C6C2C2D31292E676F746F2830292C613D302C6C3D5B5D2C633D6E65772063453B666F72283B722E76616C75657C7C613C742E6C656E';
wwv_flow_imp.g_varchar2_table(44148) := '6774683B29696628613C742E6C656E677468262628722E66726F6D2D745B615D2E66726F6D7C7C722E7374617274536964652D745B615D2E76616C75652E737461727453696465293E3D30297B6C657420653D745B612B2B5D3B632E616464496E6E6572';
wwv_flow_imp.g_varchar2_table(44149) := '28652E66726F6D2C652E746F2C652E76616C7565297C7C6C2E707573682865297D656C736520313D3D722E72616E6765496E6465782626722E6368756E6B496E6465783C746869732E6368756E6B2E6C656E677468262628613D3D742E6C656E6774687C';
wwv_flow_imp.g_varchar2_table(44150) := '7C746869732E6368756E6B456E6428722E6368756E6B496E646578293C745B615D2E66726F6D2926262821737C7C693E746869732E6368756E6B456E6428722E6368756E6B496E646578297C7C6F3C746869732E6368756E6B506F735B722E6368756E6B';
wwv_flow_imp.g_varchar2_table(44151) := '496E6465785D292626632E6164644368756E6B28746869732E6368756E6B506F735B722E6368756E6B496E6465785D2C746869732E6368756E6B5B722E6368756E6B496E6465785D293F722E6E6578744368756E6B28293A282821737C7C693E722E746F';
wwv_flow_imp.g_varchar2_table(44152) := '7C7C6F3C722E66726F6D7C7C7328722E66726F6D2C722E746F2C722E76616C75652929262628632E616464496E6E657228722E66726F6D2C722E746F2C722E76616C7565297C7C6C2E707573682873452E63726561746528722E66726F6D2C722E746F2C';
wwv_flow_imp.g_varchar2_table(44153) := '722E76616C75652929292C722E6E6578742829293B72657475726E20632E66696E697368496E6E657228746869732E6E6578744C617965722E6973456D7074792626216C2E6C656E6774683F6C452E656D7074793A746869732E6E6578744C617965722E';
wwv_flow_imp.g_varchar2_table(44154) := '757064617465287B6164643A6C2C66696C7465723A732C66696C74657246726F6D3A692C66696C746572546F3A6F7D29297D6D61702865297B696628652E656D7074797C7C746869732E6973456D7074792972657475726E20746869733B6C657420743D';
wwv_flow_imp.g_varchar2_table(44155) := '5B5D2C6E3D5B5D2C693D2D313B666F72286C6574206F3D303B6F3C746869732E6368756E6B2E6C656E6774683B6F2B2B297B6C657420733D746869732E6368756E6B506F735B6F5D2C723D746869732E6368756E6B5B6F5D2C613D652E746F7563686573';
wwv_flow_imp.g_varchar2_table(44156) := '52616E676528732C732B722E6C656E677468293B69662821313D3D3D6129693D4D6174682E6D617828692C722E6D6178506F696E74292C742E707573682872292C6E2E7075736828652E6D6170506F73287329293B656C73652069662821303D3D3D6129';
wwv_flow_imp.g_varchar2_table(44157) := '7B6C65747B6D61707065643A6F2C706F733A617D3D722E6D617028732C65293B6F262628693D4D6174682E6D617828692C6F2E6D6178506F696E74292C742E70757368286F292C6E2E70757368286129297D7D6C6574206F3D746869732E6E6578744C61';
wwv_flow_imp.g_varchar2_table(44158) := '7965722E6D61702865293B72657475726E20303D3D742E6C656E6774683F6F3A6E6577206C45286E2C742C6F7C7C6C452E656D7074792C69297D6265747765656E28652C742C6E297B69662821746869732E6973456D707479297B666F72286C65742069';
wwv_flow_imp.g_varchar2_table(44159) := '3D303B693C746869732E6368756E6B2E6C656E6774683B692B2B297B6C6574206F3D746869732E6368756E6B506F735B695D2C733D746869732E6368756E6B5B695D3B696628743E3D6F2626653C3D6F2B732E6C656E677468262621313D3D3D732E6265';
wwv_flow_imp.g_varchar2_table(44160) := '747765656E286F2C652D6F2C742D6F2C6E292972657475726E7D746869732E6E6578744C617965722E6265747765656E28652C742C6E297D7D6974657228653D30297B72657475726E2075452E66726F6D285B746869735D292E676F746F2865297D6765';
wwv_flow_imp.g_varchar2_table(44161) := '74206973456D70747928297B72657475726E20746869732E6E6578744C617965723D3D746869737D737461746963206974657228652C743D30297B72657475726E2075452E66726F6D2865292E676F746F2874297D73746174696320636F6D7061726528';
wwv_flow_imp.g_varchar2_table(44162) := '652C742C6E2C692C6F3D2D31297B6C657420733D652E66696C7465722828653D3E652E6D6178506F696E743E307C7C21652E6973456D7074792626652E6D6178506F696E743E3D6F29292C723D742E66696C7465722828653D3E652E6D6178506F696E74';
wwv_flow_imp.g_varchar2_table(44163) := '3E307C7C21652E6973456D7074792626652E6D6178506F696E743E3D6F29292C613D644528732C722C6E292C6C3D6E657720674528732C612C6F292C633D6E657720674528722C612C6F293B6E2E6974657247617073282828652C742C6E293D3E6D4528';
wwv_flow_imp.g_varchar2_table(44164) := '6C2C652C632C742C6E2C692929292C6E2E656D7074792626303D3D6E2E6C656E67746826266D45286C2C302C632C302C302C69297D73746174696320657128652C742C6E3D302C69297B6E756C6C3D3D69262628693D393939393939393939293B6C6574';
wwv_flow_imp.g_varchar2_table(44165) := '206F3D652E66696C7465722828653D3E21652E6973456D7074792626742E696E6465784F662865293C3029292C733D742E66696C7465722828743D3E21742E6973456D7074792626652E696E6465784F662874293C3029293B6966286F2E6C656E677468';
wwv_flow_imp.g_varchar2_table(44166) := '213D732E6C656E6774682972657475726E21313B696628216F2E6C656E6774682972657475726E21303B6C657420723D6445286F2C73292C613D6E6577206745286F2C722C30292E676F746F286E292C6C3D6E657720674528732C722C30292E676F746F';
wwv_flow_imp.g_varchar2_table(44167) := '286E293B666F72283B3B297B696628612E746F213D6C2E746F7C7C21664528612E6163746976652C6C2E616374697665297C7C612E706F696E74262628216C2E706F696E747C7C21612E706F696E742E6571286C2E706F696E7429292972657475726E21';
wwv_flow_imp.g_varchar2_table(44168) := '313B696628612E746F3E692972657475726E21303B612E6E65787428292C6C2E6E65787428297D7D737461746963207370616E7328652C742C6E2C692C6F3D2D31297B6C657420733D6E657720674528652C6E756C6C2C6F292E676F746F2874292C723D';
wwv_flow_imp.g_varchar2_table(44169) := '742C613D732E6F70656E53746172743B666F72283B3B297B6C657420653D4D6174682E6D696E28732E746F2C6E293B696628732E706F696E74297B6C6574206E3D732E616374697665466F72506F696E7428732E746F292C6F3D732E706F696E7446726F';
wwv_flow_imp.g_varchar2_table(44170) := '6D3C743F6E2E6C656E6774682B313A732E706F696E742E7374617274536964653C303F6E2E6C656E6774683A4D6174682E6D696E286E2E6C656E6774682C61293B692E706F696E7428722C652C732E706F696E742C6E2C6F2C732E706F696E7452616E6B';
wwv_flow_imp.g_varchar2_table(44171) := '292C613D4D6174682E6D696E28732E6F70656E456E642865292C6E2E6C656E677468297D656C736520653E72262628692E7370616E28722C652C732E6163746976652C61292C613D732E6F70656E456E64286529293B696628732E746F3E6E2972657475';
wwv_flow_imp.g_varchar2_table(44172) := '726E20612B28732E706F696E742626732E746F3E6E3F313A30293B723D732E746F2C732E6E65787428297D7D737461746963206F6628652C743D2131297B6C6574206E3D6E65772063453B666F72286C65742069206F66206520696E7374616E63656F66';
wwv_flow_imp.g_varchar2_table(44173) := '2073453F5B655D3A743F66756E6374696F6E2865297B696628652E6C656E6774683E3129666F72286C657420743D655B305D2C6E3D313B6E3C652E6C656E6774683B6E2B2B297B6C657420693D655B6E5D3B696628724528742C69293E30297265747572';
wwv_flow_imp.g_varchar2_table(44174) := '6E20652E736C69636528292E736F7274287245293B743D697D72657475726E20657D2865293A65296E2E61646428692E66726F6D2C692E746F2C692E76616C7565293B72657475726E206E2E66696E69736828297D737461746963206A6F696E2865297B';
wwv_flow_imp.g_varchar2_table(44175) := '69662821652E6C656E6774682972657475726E206C452E656D7074793B6C657420743D655B652E6C656E6774682D315D3B666F72286C6574206E3D652E6C656E6774682D323B6E3E3D303B6E2D2D29666F72286C657420693D655B6E5D3B69213D6C452E';
wwv_flow_imp.g_varchar2_table(44176) := '656D7074793B693D692E6E6578744C6179657229743D6E6577206C4528692E6368756E6B506F732C692E6368756E6B2C742C4D6174682E6D617828692E6D6178506F696E742C742E6D6178506F696E7429293B72657475726E20747D7D6C452E656D7074';
wwv_flow_imp.g_varchar2_table(44177) := '793D6E6577206C45285B5D2C5B5D2C6E756C6C2C2D31292C6C452E656D7074792E6E6578744C617965723D6C452E656D7074793B636C6173732063457B66696E6973684368756E6B2865297B746869732E6368756E6B732E70757368286E657720614528';
wwv_flow_imp.g_varchar2_table(44178) := '746869732E66726F6D2C746869732E746F2C746869732E76616C75652C746869732E6D6178506F696E7429292C746869732E6368756E6B506F732E7075736828746869732E6368756E6B5374617274292C746869732E6368756E6B53746172743D2D312C';
wwv_flow_imp.g_varchar2_table(44179) := '746869732E7365744D6178506F696E743D4D6174682E6D617828746869732E7365744D6178506F696E742C746869732E6D6178506F696E74292C746869732E6D6178506F696E743D2D312C65262628746869732E66726F6D3D5B5D2C746869732E746F3D';
wwv_flow_imp.g_varchar2_table(44180) := '5B5D2C746869732E76616C75653D5B5D297D636F6E7374727563746F7228297B746869732E6368756E6B733D5B5D2C746869732E6368756E6B506F733D5B5D2C746869732E6368756E6B53746172743D2D312C746869732E6C6173743D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(44181) := '69732E6C61737446726F6D3D2D3165392C746869732E6C617374546F3D2D3165392C746869732E66726F6D3D5B5D2C746869732E746F3D5B5D2C746869732E76616C75653D5B5D2C746869732E6D6178506F696E743D2D312C746869732E7365744D6178';
wwv_flow_imp.g_varchar2_table(44182) := '506F696E743D2D312C746869732E6E6578744C617965723D6E756C6C7D61646428652C742C6E297B746869732E616464496E6E657228652C742C6E297C7C28746869732E6E6578744C617965727C7C28746869732E6E6578744C617965723D6E65772063';
wwv_flow_imp.g_varchar2_table(44183) := '4529292E61646428652C742C6E297D616464496E6E657228652C742C6E297B6C657420693D652D746869732E6C617374546F7C7C6E2E7374617274536964652D746869732E6C6173742E656E64536964653B696628693C3D30262628652D746869732E6C';
wwv_flow_imp.g_varchar2_table(44184) := '61737446726F6D7C7C6E2E7374617274536964652D746869732E6C6173742E737461727453696465293C30297468726F77206E6577204572726F72282252616E676573206D75737420626520616464656420736F72746564206279206066726F6D602070';
wwv_flow_imp.g_varchar2_table(44185) := '6F736974696F6E20616E6420607374617274536964656022293B72657475726E2128693C307C7C283235303D3D746869732E66726F6D2E6C656E6774682626746869732E66696E6973684368756E6B282130292C746869732E6368756E6B53746172743C';
wwv_flow_imp.g_varchar2_table(44186) := '30262628746869732E6368756E6B53746172743D65292C746869732E66726F6D2E7075736828652D746869732E6368756E6B5374617274292C746869732E746F2E7075736828742D746869732E6368756E6B5374617274292C746869732E6C6173743D6E';
wwv_flow_imp.g_varchar2_table(44187) := '2C746869732E6C61737446726F6D3D652C746869732E6C617374546F3D742C746869732E76616C75652E70757368286E292C6E2E706F696E74262628746869732E6D6178506F696E743D4D6174682E6D617828746869732E6D6178506F696E742C742D65';
wwv_flow_imp.g_varchar2_table(44188) := '29292C3029297D6164644368756E6B28652C74297B69662828652D746869732E6C617374546F7C7C742E76616C75655B305D2E7374617274536964652D746869732E6C6173742E656E6453696465293C302972657475726E21313B746869732E66726F6D';
wwv_flow_imp.g_varchar2_table(44189) := '2E6C656E6774682626746869732E66696E6973684368756E6B282130292C746869732E7365744D6178506F696E743D4D6174682E6D617828746869732E7365744D6178506F696E742C742E6D6178506F696E74292C746869732E6368756E6B732E707573';
wwv_flow_imp.g_varchar2_table(44190) := '682874292C746869732E6368756E6B506F732E707573682865293B6C6574206E3D742E76616C75652E6C656E6774682D313B72657475726E20746869732E6C6173743D742E76616C75655B6E5D2C746869732E6C61737446726F6D3D742E66726F6D5B6E';
wwv_flow_imp.g_varchar2_table(44191) := '5D2B652C746869732E6C617374546F3D742E746F5B6E5D2B652C21307D66696E69736828297B72657475726E20746869732E66696E697368496E6E6572286C452E656D707479297D66696E697368496E6E65722865297B696628746869732E66726F6D2E';
wwv_flow_imp.g_varchar2_table(44192) := '6C656E6774682626746869732E66696E6973684368756E6B282131292C303D3D746869732E6368756E6B732E6C656E6774682972657475726E20653B6C657420743D6C452E63726561746528746869732E6368756E6B506F732C746869732E6368756E6B';
wwv_flow_imp.g_varchar2_table(44193) := '732C746869732E6E6578744C617965723F746869732E6E6578744C617965722E66696E697368496E6E65722865293A652C746869732E7365744D6178506F696E74293B72657475726E20746869732E66726F6D3D6E756C6C2C747D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(44194) := '20644528652C742C6E297B6C657420693D6E6577204D61703B666F72286C65742074206F66206529666F72286C657420653D303B653C742E6368756E6B2E6C656E6774683B652B2B29742E6368756E6B5B655D2E6D6178506F696E743C3D302626692E73';
wwv_flow_imp.g_varchar2_table(44195) := '657428742E6368756E6B5B655D2C742E6368756E6B506F735B655D293B6C6574206F3D6E6577205365743B666F72286C65742065206F66207429666F72286C657420743D303B743C652E6368756E6B2E6C656E6774683B742B2B297B6C657420733D692E';
wwv_flow_imp.g_varchar2_table(44196) := '67657428652E6368756E6B5B745D293B6E756C6C3D3D737C7C286E3F6E2E6D6170506F732873293A7329213D652E6368756E6B506F735B745D7C7C286E756C6C3D3D6E3F766F696420303A6E2E746F756368657352616E676528732C732B652E6368756E';
wwv_flow_imp.g_varchar2_table(44197) := '6B5B745D2E6C656E67746829297C7C6F2E61646428652E6368756E6B5B745D297D72657475726E206F7D636C6173732068457B636F6E7374727563746F7228652C742C6E2C693D30297B746869732E6C617965723D652C746869732E736B69703D742C74';
wwv_flow_imp.g_varchar2_table(44198) := '6869732E6D696E506F696E743D6E2C746869732E72616E6B3D697D6765742073746172745369646528297B72657475726E20746869732E76616C75653F746869732E76616C75652E7374617274536964653A307D67657420656E645369646528297B7265';
wwv_flow_imp.g_varchar2_table(44199) := '7475726E20746869732E76616C75653F746869732E76616C75652E656E64536964653A307D676F746F28652C743D2D316539297B72657475726E20746869732E6368756E6B496E6465783D746869732E72616E6765496E6465783D302C746869732E676F';
wwv_flow_imp.g_varchar2_table(44200) := '746F496E6E657228652C742C2131292C746869737D676F746F496E6E657228652C742C6E297B666F72283B746869732E6368756E6B496E6465783C746869732E6C617965722E6368756E6B2E6C656E6774683B297B6C657420743D746869732E6C617965';
wwv_flow_imp.g_varchar2_table(44201) := '722E6368756E6B5B746869732E6368756E6B496E6465785D3B6966282128746869732E736B69702626746869732E736B69702E6861732874297C7C746869732E6C617965722E6368756E6B456E6428746869732E6368756E6B496E646578293C657C7C74';
wwv_flow_imp.g_varchar2_table(44202) := '2E6D6178506F696E743C746869732E6D696E506F696E742929627265616B3B746869732E6368756E6B496E6465782B2B2C6E3D21317D696628746869732E6368756E6B496E6465783C746869732E6C617965722E6368756E6B2E6C656E677468297B6C65';
wwv_flow_imp.g_varchar2_table(44203) := '7420693D746869732E6C617965722E6368756E6B5B746869732E6368756E6B496E6465785D2E66696E64496E64657828652D746869732E6C617965722E6368756E6B506F735B746869732E6368756E6B496E6465785D2C742C2130293B28216E7C7C7468';
wwv_flow_imp.g_varchar2_table(44204) := '69732E72616E6765496E6465783C69292626746869732E73657452616E6765496E6465782869297D746869732E6E65787428297D666F727761726428652C74297B28746869732E746F2D657C7C746869732E656E64536964652D74293C30262674686973';
wwv_flow_imp.g_varchar2_table(44205) := '2E676F746F496E6E657228652C742C2130297D6E65787428297B666F72283B3B297B696628746869732E6368756E6B496E6465783D3D746869732E6C617965722E6368756E6B2E6C656E677468297B746869732E66726F6D3D746869732E746F3D316539';
wwv_flow_imp.g_varchar2_table(44206) := '2C746869732E76616C75653D6E756C6C3B627265616B7D7B6C657420653D746869732E6C617965722E6368756E6B506F735B746869732E6368756E6B496E6465785D2C743D746869732E6C617965722E6368756E6B5B746869732E6368756E6B496E6465';
wwv_flow_imp.g_varchar2_table(44207) := '785D2C6E3D652B742E66726F6D5B746869732E72616E6765496E6465785D3B696628746869732E66726F6D3D6E2C746869732E746F3D652B742E746F5B746869732E72616E6765496E6465785D2C746869732E76616C75653D742E76616C75655B746869';
wwv_flow_imp.g_varchar2_table(44208) := '732E72616E6765496E6465785D2C746869732E73657452616E6765496E64657828746869732E72616E6765496E6465782B31292C746869732E6D696E506F696E743C307C7C746869732E76616C75652E706F696E742626746869732E746F2D746869732E';
wwv_flow_imp.g_varchar2_table(44209) := '66726F6D3E3D746869732E6D696E506F696E7429627265616B7D7D7D73657452616E6765496E6465782865297B696628653D3D746869732E6C617965722E6368756E6B5B746869732E6368756E6B496E6465785D2E76616C75652E6C656E677468297B69';
wwv_flow_imp.g_varchar2_table(44210) := '6628746869732E6368756E6B496E6465782B2B2C746869732E736B697029666F72283B746869732E6368756E6B496E6465783C746869732E6C617965722E6368756E6B2E6C656E6774682626746869732E736B69702E68617328746869732E6C61796572';
wwv_flow_imp.g_varchar2_table(44211) := '2E6368756E6B5B746869732E6368756E6B496E6465785D293B29746869732E6368756E6B496E6465782B2B3B746869732E72616E6765496E6465783D307D656C736520746869732E72616E6765496E6465783D657D6E6578744368756E6B28297B746869';
wwv_flow_imp.g_varchar2_table(44212) := '732E6368756E6B496E6465782B2B2C746869732E72616E6765496E6465783D302C746869732E6E65787428297D636F6D706172652865297B72657475726E20746869732E66726F6D2D652E66726F6D7C7C746869732E7374617274536964652D652E7374';
wwv_flow_imp.g_varchar2_table(44213) := '617274536964657C7C746869732E72616E6B2D652E72616E6B7C7C746869732E746F2D652E746F7C7C746869732E656E64536964652D652E656E64536964657D7D636C6173732075457B636F6E7374727563746F722865297B746869732E686561703D65';
wwv_flow_imp.g_varchar2_table(44214) := '7D7374617469632066726F6D28652C743D6E756C6C2C6E3D2D31297B6C657420693D5B5D3B666F72286C6574206F3D303B6F3C652E6C656E6774683B6F2B2B29666F72286C657420733D655B6F5D3B21732E6973456D7074793B733D732E6E6578744C61';
wwv_flow_imp.g_varchar2_table(44215) := '79657229732E6D6178506F696E743E3D6E2626692E70757368286E657720684528732C742C6E2C6F29293B72657475726E20313D3D692E6C656E6774683F695B305D3A6E65772075452869297D6765742073746172745369646528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(44216) := '746869732E76616C75653F746869732E76616C75652E7374617274536964653A307D676F746F28652C743D2D316539297B666F72286C6574206E206F6620746869732E68656170296E2E676F746F28652C74293B666F72286C657420653D746869732E68';
wwv_flow_imp.g_varchar2_table(44217) := '6561702E6C656E6774683E3E313B653E3D303B652D2D29704528746869732E686561702C65293B72657475726E20746869732E6E65787428292C746869737D666F727761726428652C74297B666F72286C6574206E206F6620746869732E68656170296E';
wwv_flow_imp.g_varchar2_table(44218) := '2E666F727761726428652C74293B666F72286C657420653D746869732E686561702E6C656E6774683E3E313B653E3D303B652D2D29704528746869732E686561702C65293B28746869732E746F2D657C7C746869732E76616C75652E656E64536964652D';
wwv_flow_imp.g_varchar2_table(44219) := '74293C302626746869732E6E65787428297D6E65787428297B696628303D3D746869732E686561702E6C656E67746829746869732E66726F6D3D746869732E746F3D3165392C746869732E76616C75653D6E756C6C2C746869732E72616E6B3D2D313B65';
wwv_flow_imp.g_varchar2_table(44220) := '6C73657B6C657420653D746869732E686561705B305D3B746869732E66726F6D3D652E66726F6D2C746869732E746F3D652E746F2C746869732E76616C75653D652E76616C75652C746869732E72616E6B3D652E72616E6B2C652E76616C75652626652E';
wwv_flow_imp.g_varchar2_table(44221) := '6E65787428292C704528746869732E686561702C30297D7D7D66756E6374696F6E20704528652C74297B666F72286C6574206E3D655B745D3B3B297B6C657420693D312B28743C3C31293B696628693E3D652E6C656E67746829627265616B3B6C657420';
wwv_flow_imp.g_varchar2_table(44222) := '6F3D655B695D3B696628692B313C652E6C656E67746826266F2E636F6D7061726528655B692B315D293E3D302626286F3D655B692B315D2C692B2B292C6E2E636F6D70617265286F293C3029627265616B3B655B695D3D6E2C655B745D3D6F2C743D697D';
wwv_flow_imp.g_varchar2_table(44223) := '7D636C6173732067457B636F6E7374727563746F7228652C742C6E297B746869732E6D696E506F696E743D6E2C746869732E6163746976653D5B5D2C746869732E616374697665546F3D5B5D2C746869732E61637469766552616E6B3D5B5D2C74686973';
wwv_flow_imp.g_varchar2_table(44224) := '2E6D696E4163746976653D2D312C746869732E706F696E743D6E756C6C2C746869732E706F696E7446726F6D3D302C746869732E706F696E7452616E6B3D302C746869732E746F3D2D3165392C746869732E656E64536964653D302C746869732E6F7065';
wwv_flow_imp.g_varchar2_table(44225) := '6E53746172743D2D312C746869732E637572736F723D75452E66726F6D28652C742C6E297D676F746F28652C743D2D316539297B72657475726E20746869732E637572736F722E676F746F28652C74292C746869732E6163746976652E6C656E6774683D';
wwv_flow_imp.g_varchar2_table(44226) := '746869732E616374697665546F2E6C656E6774683D746869732E61637469766552616E6B2E6C656E6774683D302C746869732E6D696E4163746976653D2D312C746869732E746F3D652C746869732E656E64536964653D742C746869732E6F70656E5374';
wwv_flow_imp.g_varchar2_table(44227) := '6172743D2D312C746869732E6E65787428292C746869737D666F727761726428652C74297B666F72283B746869732E6D696E4163746976653E2D31262628746869732E616374697665546F5B746869732E6D696E4163746976655D2D657C7C746869732E';
wwv_flow_imp.g_varchar2_table(44228) := '6163746976655B746869732E6D696E4163746976655D2E656E64536964652D74293C303B29746869732E72656D6F766541637469766528746869732E6D696E416374697665293B746869732E637572736F722E666F727761726428652C74297D72656D6F';
wwv_flow_imp.g_varchar2_table(44229) := '76654163746976652865297B764528746869732E6163746976652C65292C764528746869732E616374697665546F2C65292C764528746869732E61637469766552616E6B2C65292C746869732E6D696E4163746976653D5F4528746869732E6163746976';
wwv_flow_imp.g_varchar2_table(44230) := '652C746869732E616374697665546F297D6164644163746976652865297B6C657420743D302C7B76616C75653A6E2C746F3A692C72616E6B3A6F7D3D746869732E637572736F723B666F72283B743C746869732E61637469766552616E6B2E6C656E6774';
wwv_flow_imp.g_varchar2_table(44231) := '682626286F2D746869732E61637469766552616E6B5B745D7C7C692D746869732E616374697665546F5B745D293E303B29742B2B3B624528746869732E6163746976652C742C6E292C624528746869732E616374697665546F2C742C69292C6245287468';
wwv_flow_imp.g_varchar2_table(44232) := '69732E61637469766552616E6B2C742C6F292C652626624528652C742C746869732E637572736F722E66726F6D292C746869732E6D696E4163746976653D5F4528746869732E6163746976652C746869732E616374697665546F297D6E65787428297B6C';
wwv_flow_imp.g_varchar2_table(44233) := '657420653D746869732E746F2C743D746869732E706F696E743B746869732E706F696E743D6E756C6C3B6C6574206E3D746869732E6F70656E53746172743C303F5B5D3A6E756C6C3B666F72283B3B297B6C657420693D746869732E6D696E4163746976';
wwv_flow_imp.g_varchar2_table(44234) := '653B696628693E2D31262628746869732E616374697665546F5B695D2D746869732E637572736F722E66726F6D7C7C746869732E6163746976655B695D2E656E64536964652D746869732E637572736F722E737461727453696465293C30297B69662874';
wwv_flow_imp.g_varchar2_table(44235) := '6869732E616374697665546F5B695D3E65297B746869732E746F3D746869732E616374697665546F5B695D2C746869732E656E64536964653D746869732E6163746976655B695D2E656E64536964653B627265616B7D746869732E72656D6F7665416374';
wwv_flow_imp.g_varchar2_table(44236) := '6976652869292C6E26267645286E2C69297D656C73657B69662821746869732E637572736F722E76616C7565297B746869732E746F3D746869732E656E64536964653D3165393B627265616B7D696628746869732E637572736F722E66726F6D3E65297B';
wwv_flow_imp.g_varchar2_table(44237) := '746869732E746F3D746869732E637572736F722E66726F6D2C746869732E656E64536964653D746869732E637572736F722E7374617274536964653B627265616B7D7B6C657420653D746869732E637572736F722E76616C75653B696628652E706F696E';
wwv_flow_imp.g_varchar2_table(44238) := '74297B6966282128742626746869732E637572736F722E746F3D3D746869732E746F2626746869732E637572736F722E66726F6D3C746869732E637572736F722E746F29297B746869732E706F696E743D652C746869732E706F696E7446726F6D3D7468';
wwv_flow_imp.g_varchar2_table(44239) := '69732E637572736F722E66726F6D2C746869732E706F696E7452616E6B3D746869732E637572736F722E72616E6B2C746869732E746F3D746869732E637572736F722E746F2C746869732E656E64536964653D652E656E64536964652C746869732E6375';
wwv_flow_imp.g_varchar2_table(44240) := '72736F722E6E65787428292C746869732E666F727761726428746869732E746F2C746869732E656E6453696465293B627265616B7D746869732E637572736F722E6E65787428297D656C736520746869732E616464416374697665286E292C746869732E';
wwv_flow_imp.g_varchar2_table(44241) := '637572736F722E6E65787428297D7D7D6966286E297B746869732E6F70656E53746172743D303B666F72286C657420743D6E2E6C656E6774682D313B743E3D3026266E5B745D3C653B742D2D29746869732E6F70656E53746172742B2B7D7D6163746976';
wwv_flow_imp.g_varchar2_table(44242) := '65466F72506F696E742865297B69662821746869732E6163746976652E6C656E6774682972657475726E20746869732E6163746976653B6C657420743D5B5D3B666F72286C6574206E3D746869732E6163746976652E6C656E6774682D313B6E3E3D3026';
wwv_flow_imp.g_varchar2_table(44243) := '262128746869732E61637469766552616E6B5B6E5D3C746869732E706F696E7452616E6B293B6E2D2D2928746869732E616374697665546F5B6E5D3E657C7C746869732E616374697665546F5B6E5D3D3D652626746869732E6163746976655B6E5D2E65';
wwv_flow_imp.g_varchar2_table(44244) := '6E64536964653E3D746869732E706F696E742E656E6453696465292626742E7075736828746869732E6163746976655B6E5D293B72657475726E20742E7265766572736528297D6F70656E456E642865297B6C657420743D303B666F72286C6574206E3D';
wwv_flow_imp.g_varchar2_table(44245) := '746869732E616374697665546F2E6C656E6774682D313B6E3E3D302626746869732E616374697665546F5B6E5D3E653B6E2D2D29742B2B3B72657475726E20747D7D66756E6374696F6E206D4528652C742C6E2C692C6F2C73297B652E676F746F287429';
wwv_flow_imp.g_varchar2_table(44246) := '2C6E2E676F746F2869293B6C657420723D692B6F2C613D692C6C3D692D743B666F72283B3B297B6C657420743D652E746F2B6C2D6E2E746F7C7C652E656E64536964652D6E2E656E64536964652C693D743C303F652E746F2B6C3A6E2E746F2C6F3D4D61';
wwv_flow_imp.g_varchar2_table(44247) := '74682E6D696E28692C72293B696628652E706F696E747C7C6E2E706F696E743F652E706F696E7426266E2E706F696E74262628652E706F696E743D3D6E2E706F696E747C7C652E706F696E742E6571286E2E706F696E7429292626664528652E61637469';
wwv_flow_imp.g_varchar2_table(44248) := '7665466F72506F696E7428652E746F292C6E2E616374697665466F72506F696E74286E2E746F29297C7C732E636F6D70617265506F696E7428612C6F2C652E706F696E742C6E2E706F696E74293A6F3E61262621664528652E6163746976652C6E2E6163';
wwv_flow_imp.g_varchar2_table(44249) := '74697665292626732E636F6D7061726552616E676528612C6F2C652E6163746976652C6E2E616374697665292C693E7229627265616B3B613D692C743C3D302626652E6E65787428292C743E3D3026266E2E6E65787428297D7D66756E6374696F6E2066';
wwv_flow_imp.g_varchar2_table(44250) := '4528652C74297B696628652E6C656E677468213D742E6C656E6774682972657475726E21313B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B29696628655B6E5D213D745B6E5D262621655B6E5D2E657128745B6E5D29297265747572';
wwv_flow_imp.g_varchar2_table(44251) := '6E21313B72657475726E21307D66756E6374696F6E20764528652C74297B666F72286C6574206E3D742C693D652E6C656E6774682D313B6E3C693B6E2B2B29655B6E5D3D655B6E2B315D3B652E706F7028297D66756E6374696F6E20624528652C742C6E';
wwv_flow_imp.g_varchar2_table(44252) := '297B666F72286C6574206E3D652E6C656E6774682D313B6E3E3D743B6E2D2D29655B6E2B315D3D655B6E5D3B655B745D3D6E7D66756E6374696F6E205F4528652C74297B6C6574206E3D2D312C693D3165393B666F72286C6574206F3D303B6F3C742E6C';
wwv_flow_imp.g_varchar2_table(44253) := '656E6774683B6F2B2B2928745B6F5D2D697C7C655B6F5D2E656E64536964652D655B6E5D2E656E6453696465293C302626286E3D6F2C693D745B6F5D293B72657475726E206E7D66756E6374696F6E20794528652C742C6E3D652E6C656E677468297B6C';
wwv_flow_imp.g_varchar2_table(44254) := '657420693D303B666F72286C6574206F3D303B6F3C6E3B29393D3D652E63686172436F64654174286F293F28692B3D742D6925742C6F2B2B293A28692B2B2C6F3D5A7828652C6F29293B72657475726E20697D636F6E73742077453D22756E646566696E';
wwv_flow_imp.g_varchar2_table(44255) := '6564223D3D747970656F662053796D626F6C3F225F5FCDBC223A53796D626F6C2E666F722822CDBC22292C43453D22756E646566696E6564223D3D747970656F662053796D626F6C3F225F5F7374796C65536574222B4D6174682E666C6F6F7228316538';
wwv_flow_imp.g_varchar2_table(44256) := '2A4D6174682E72616E646F6D2829293A53796D626F6C28227374796C6553657422292C53453D22756E646566696E656422213D747970656F6620676C6F62616C546869733F676C6F62616C546869733A22756E646566696E656422213D747970656F6620';
wwv_flow_imp.g_varchar2_table(44257) := '77696E646F773F77696E646F773A7B7D3B636C6173732078457B636F6E7374727563746F7228652C74297B746869732E72756C65733D5B5D3B6C65747B66696E6973683A6E7D3D747C7C7B7D3B66756E6374696F6E20692865297B72657475726E2F5E40';
wwv_flow_imp.g_varchar2_table(44258) := '2F2E746573742865293F5B655D3A652E73706C6974282F2C5C732A2F297D66756E6374696F6E206F28652C742C732C72297B6C657420613D5B5D2C6C3D2F5E40285C772B295C622F2E6578656328655B305D292C633D6C2626226B65796672616D657322';
wwv_flow_imp.g_varchar2_table(44259) := '3D3D6C5B315D3B6966286C26266E756C6C3D3D742972657475726E20732E7075736828655B305D2B223B22293B666F72286C6574206E20696E2074297B6C657420723D745B6E5D3B6966282F262F2E74657374286E29296F286E2E73706C6974282F2C5C';
wwv_flow_imp.g_varchar2_table(44260) := '732A2F292E6D61702828743D3E652E6D61702828653D3E742E7265706C616365282F262F2C6529292929292E726564756365282828652C74293D3E652E636F6E63617428742929292C722C73293B656C736520696628722626226F626A656374223D3D74';
wwv_flow_imp.g_varchar2_table(44261) := '7970656F662072297B696628216C297468726F77206E65772052616E67654572726F7228225468652076616C7565206F6620612070726F70657274792028222B6E2B22292073686F756C642062652061207072696D69746976652076616C75652E22293B';
wwv_flow_imp.g_varchar2_table(44262) := '6F2869286E292C722C612C63297D656C7365206E756C6C213D722626612E70757368286E2E7265706C616365282F5F2E2A2F2C2222292E7265706C616365282F5B412D5A5D2F672C28653D3E222D222B652E746F4C6F77657243617365282929292B223A';
wwv_flow_imp.g_varchar2_table(44263) := '20222B722B223B22297D28612E6C656E6774687C7C63292626732E707573682828216E7C7C6C7C7C723F653A652E6D6170286E29292E6A6F696E28222C2022292B22207B222B612E6A6F696E28222022292B227D22297D666F72286C6574207420696E20';
wwv_flow_imp.g_varchar2_table(44264) := '65296F28692874292C655B745D2C746869732E72756C6573297D67657452756C657328297B72657475726E20746869732E72756C65732E6A6F696E28225C6E22297D737461746963206E65774E616D6528297B6C657420653D53455B77455D7C7C313B72';
wwv_flow_imp.g_varchar2_table(44265) := '657475726E2053455B77455D3D652B312C22CDBC222B652E746F537472696E67283336297D737461746963206D6F756E7428652C742C6E297B6C657420693D655B43455D2C6F3D6E26266E2E6E6F6E63653B693F6F2626692E7365744E6F6E6365286F29';
wwv_flow_imp.g_varchar2_table(44266) := '3A693D6E657720454528652C6F292C692E6D6F756E742841727261792E697341727261792874293F743A5B745D2C65297D7D6C6574206B453D6E6577204D61703B636C6173732045457B636F6E7374727563746F7228652C74297B6C6574206E3D652E6F';
wwv_flow_imp.g_varchar2_table(44267) := '776E6572446F63756D656E747C7C652C693D6E2E64656661756C74566965773B69662821652E686561642626652E61646F707465645374796C655368656574732626692E4353535374796C655368656574297B6C657420743D6B452E676574286E293B69';
wwv_flow_imp.g_varchar2_table(44268) := '6628742972657475726E20655B43455D3D743B746869732E73686565743D6E657720692E4353535374796C6553686565742C6B452E736574286E2C74686973297D656C736520746869732E7374796C655461673D6E2E637265617465456C656D656E7428';
wwv_flow_imp.g_varchar2_table(44269) := '227374796C6522292C742626746869732E7374796C655461672E73657441747472696275746528226E6F6E6365222C74293B746869732E6D6F64756C65733D5B5D2C655B43455D3D746869737D6D6F756E7428652C74297B6C6574206E3D746869732E73';
wwv_flow_imp.g_varchar2_table(44270) := '686565742C693D302C6F3D303B666F72286C657420743D303B743C652E6C656E6774683B742B2B297B6C657420733D655B745D2C723D746869732E6D6F64756C65732E696E6465784F662873293B696628723C6F2626723E2D31262628746869732E6D6F';
wwv_flow_imp.g_varchar2_table(44271) := '64756C65732E73706C69636528722C31292C6F2D2D2C723D2D31292C2D313D3D72297B696628746869732E6D6F64756C65732E73706C696365286F2B2B2C302C73292C6E29666F72286C657420653D303B653C732E72756C65732E6C656E6774683B652B';
wwv_flow_imp.g_varchar2_table(44272) := '2B296E2E696E7365727452756C6528732E72756C65735B655D2C692B2B297D656C73657B666F72283B6F3C723B29692B3D746869732E6D6F64756C65735B6F2B2B5D2E72756C65732E6C656E6774683B692B3D732E72756C65732E6C656E6774682C6F2B';
wwv_flow_imp.g_varchar2_table(44273) := '2B7D7D6966286E29742E61646F707465645374796C655368656574732E696E6465784F6628746869732E7368656574293C30262628742E61646F707465645374796C655368656574733D5B746869732E73686565742C2E2E2E742E61646F707465645374';
wwv_flow_imp.g_varchar2_table(44274) := '796C655368656574735D293B656C73657B6C657420653D22223B666F72286C657420743D303B743C746869732E6D6F64756C65732E6C656E6774683B742B2B29652B3D746869732E6D6F64756C65735B745D2E67657452756C657328292B225C6E223B74';
wwv_flow_imp.g_varchar2_table(44275) := '6869732E7374796C655461672E74657874436F6E74656E743D653B6C6574206E3D742E686561647C7C743B746869732E7374796C655461672E706172656E744E6F6465213D6E26266E2E696E736572744265666F726528746869732E7374796C65546167';
wwv_flow_imp.g_varchar2_table(44276) := '2C6E2E66697273744368696C64297D7D7365744E6F6E63652865297B746869732E7374796C655461672626746869732E7374796C655461672E67657441747472696275746528226E6F6E63652229213D652626746869732E7374796C655461672E736574';
wwv_flow_imp.g_varchar2_table(44277) := '41747472696275746528226E6F6E6365222C65297D7D666F7228766172204C453D7B383A224261636B7370616365222C393A22546162222C31303A22456E746572222C31323A224E756D4C6F636B222C31333A22456E746572222C31363A225368696674';
wwv_flow_imp.g_varchar2_table(44278) := '222C31373A22436F6E74726F6C222C31383A22416C74222C32303A22436170734C6F636B222C32373A22457363617065222C33323A2220222C33333A22506167655570222C33343A2250616765446F776E222C33353A22456E64222C33363A22486F6D65';
wwv_flow_imp.g_varchar2_table(44279) := '222C33373A224172726F774C656674222C33383A224172726F775570222C33393A224172726F775269676874222C34303A224172726F77446F776E222C34343A225072696E7453637265656E222C34353A22496E73657274222C34363A2244656C657465';
wwv_flow_imp.g_varchar2_table(44280) := '222C35393A223B222C36313A223D222C39313A224D657461222C39323A224D657461222C3130363A222A222C3130373A222B222C3130383A222C222C3130393A222D222C3131303A222E222C3131313A222F222C3134343A224E756D4C6F636B222C3134';
wwv_flow_imp.g_varchar2_table(44281) := '353A225363726F6C6C4C6F636B222C3136303A225368696674222C3136313A225368696674222C3136323A22436F6E74726F6C222C3136333A22436F6E74726F6C222C3136343A22416C74222C3136353A22416C74222C3137333A222D222C3138363A22';
wwv_flow_imp.g_varchar2_table(44282) := '3B222C3138373A223D222C3138383A222C222C3138393A222D222C3139303A222E222C3139313A222F222C3139323A2260222C3231393A225B222C3232303A225C5C222C3232313A225D222C3232323A2227227D2C44453D7B34383A2229222C34393A22';
wwv_flow_imp.g_varchar2_table(44283) := '21222C35303A2240222C35313A2223222C35323A2224222C35333A2225222C35343A225E222C35353A2226222C35363A222A222C35373A2228222C35393A223A222C36313A222B222C3137333A225F222C3138363A223A222C3138373A222B222C313838';
wwv_flow_imp.g_varchar2_table(44284) := '3A223C222C3138393A225F222C3139303A223E222C3139313A223F222C3139323A227E222C3231393A227B222C3232303A227C222C3232313A227D222C3232323A2722277D2C54453D22756E646566696E656422213D747970656F66206E617669676174';
wwv_flow_imp.g_varchar2_table(44285) := '6F7226262F4D61632F2E74657374286E6176696761746F722E706C6174666F726D292C49453D22756E646566696E656422213D747970656F66206E6176696761746F7226262F4D534945205C647C54726964656E745C2F283F3A5B372D395D7C5C647B32';
wwv_flow_imp.g_varchar2_table(44286) := '2C7D295C2E2E2A72763A285C642B292F2E65786563286E6176696761746F722E757365724167656E74292C4D453D303B4D453C31303B4D452B2B294C455B34382B4D455D3D4C455B39362B4D455D3D537472696E67284D45293B666F72284D453D313B4D';
wwv_flow_imp.g_varchar2_table(44287) := '453C3D32343B4D452B2B294C455B4D452B3131315D3D2246222B4D453B666F72284D453D36353B4D453C3D39303B4D452B2B294C455B4D455D3D537472696E672E66726F6D43686172436F6465284D452B3332292C44455B4D455D3D537472696E672E66';
wwv_flow_imp.g_varchar2_table(44288) := '726F6D43686172436F6465284D45293B666F722876617220414520696E204C452944452E6861734F776E50726F7065727479284145297C7C2844455B41455D3D4C455B41455D293B66756E6374696F6E204E452865297B6C657420743B72657475726E20';
wwv_flow_imp.g_varchar2_table(44289) := '743D31313D3D652E6E6F6465547970653F652E67657453656C656374696F6E3F653A652E6F776E6572446F63756D656E743A652C742E67657453656C656374696F6E28297D66756E6374696F6E20504528652C74297B72657475726E212174262628653D';
wwv_flow_imp.g_varchar2_table(44290) := '3D747C7C652E636F6E7461696E732831213D742E6E6F6465547970653F742E706172656E744E6F64653A7429297D66756E6374696F6E204F4528652C74297B69662821742E616E63686F724E6F64652972657475726E21313B7472797B72657475726E20';
wwv_flow_imp.g_varchar2_table(44291) := '504528652C742E616E63686F724E6F6465297D63617463682865297B72657475726E21317D7D66756E6374696F6E2052452865297B72657475726E20333D3D652E6E6F6465547970653F514528652C302C652E6E6F646556616C75652E6C656E67746829';
wwv_flow_imp.g_varchar2_table(44292) := '2E676574436C69656E74526563747328293A313D3D652E6E6F6465547970653F652E676574436C69656E74526563747328293A5B5D7D66756E6374696F6E20464528652C742C6E2C69297B72657475726E21216E2626287A4528652C742C6E2C692C2D31';
wwv_flow_imp.g_varchar2_table(44293) := '297C7C7A4528652C742C6E2C692C3129297D66756E6374696F6E2042452865297B666F722876617220743D303B3B742B2B296966282128653D652E70726576696F75735369626C696E67292972657475726E20747D66756E6374696F6E2056452865297B';
wwv_flow_imp.g_varchar2_table(44294) := '72657475726E20313D3D652E6E6F64655479706526262F5E284449567C507C4C497C554C7C4F4C7C424C4F434B51554F54457C44447C44547C485C647C53454354494F4E7C50524529242F2E7465737428652E6E6F64654E616D65297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(44295) := '6E207A4528652C742C6E2C692C6F297B666F72283B3B297B696628653D3D6E2626743D3D692972657475726E21303B696628743D3D286F3C303F303A484528652929297B69662822444956223D3D652E6E6F64654E616D652972657475726E21313B6C65';
wwv_flow_imp.g_varchar2_table(44296) := '74206E3D652E706172656E744E6F64653B696628216E7C7C31213D6E2E6E6F6465547970652972657475726E21313B743D42452865292B286F3C303F303A31292C653D6E7D656C73657B69662831213D652E6E6F6465547970652972657475726E21313B';
wwv_flow_imp.g_varchar2_table(44297) := '696628313D3D28653D652E6368696C644E6F6465735B742B286F3C303F2D313A30295D292E6E6F64655479706526262266616C7365223D3D652E636F6E74656E744564697461626C652972657475726E21313B743D6F3C303F48452865293A307D7D7D66';
wwv_flow_imp.g_varchar2_table(44298) := '756E6374696F6E2048452865297B72657475726E20333D3D652E6E6F6465547970653F652E6E6F646556616C75652E6C656E6774683A652E6368696C644E6F6465732E6C656E6774687D66756E6374696F6E20574528652C74297B6C6574206E3D743F65';
wwv_flow_imp.g_varchar2_table(44299) := '2E6C6566743A652E72696768743B72657475726E7B6C6566743A6E2C72696768743A6E2C746F703A652E746F702C626F74746F6D3A652E626F74746F6D7D7D66756E6374696F6E206A452865297B6C657420743D652E76697375616C56696577706F7274';
wwv_flow_imp.g_varchar2_table(44300) := '3B72657475726E20743F7B6C6566743A302C72696768743A742E77696474682C746F703A302C626F74746F6D3A742E6865696768747D3A7B6C6566743A302C72696768743A652E696E6E657257696474682C746F703A302C626F74746F6D3A652E696E6E';
wwv_flow_imp.g_varchar2_table(44301) := '65724865696768747D7D66756E6374696F6E20714528652C74297B6C6574206E3D742E77696474682F652E6F666673657457696474682C693D742E6865696768742F652E6F66667365744865696768743B72657475726E286E3E2E39393526266E3C312E';
wwv_flow_imp.g_varchar2_table(44302) := '3030357C7C21697346696E697465286E297C7C4D6174682E61627328742E77696474682D652E6F66667365745769647468293C31292626286E3D31292C28693E2E3939352626693C312E3030357C7C21697346696E6974652869297C7C4D6174682E6162';
wwv_flow_imp.g_varchar2_table(44303) := '7328742E6865696768742D652E6F6666736574486569676874293C3129262628693D31292C7B7363616C65583A6E2C7363616C65593A697D7D636C6173732024457B636F6E7374727563746F7228297B746869732E616E63686F724E6F64653D6E756C6C';
wwv_flow_imp.g_varchar2_table(44304) := '2C746869732E616E63686F724F66667365743D302C746869732E666F6375734E6F64653D6E756C6C2C746869732E666F6375734F66667365743D307D65712865297B72657475726E20746869732E616E63686F724E6F64653D3D652E616E63686F724E6F';
wwv_flow_imp.g_varchar2_table(44305) := '64652626746869732E616E63686F724F66667365743D3D652E616E63686F724F66667365742626746869732E666F6375734E6F64653D3D652E666F6375734E6F64652626746869732E666F6375734F66667365743D3D652E666F6375734F66667365747D';
wwv_flow_imp.g_varchar2_table(44306) := '73657452616E67652865297B6C65747B616E63686F724E6F64653A742C666F6375734E6F64653A6E7D3D653B746869732E73657428742C4D6174682E6D696E28652E616E63686F724F66667365742C743F48452874293A30292C6E2C4D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(44307) := '28652E666F6375734F66667365742C6E3F4845286E293A3029297D73657428652C742C6E2C69297B746869732E616E63686F724E6F64653D652C746869732E616E63686F724F66667365743D742C746869732E666F6375734E6F64653D6E2C746869732E';
wwv_flow_imp.g_varchar2_table(44308) := '666F6375734F66667365743D697D7D6C65742055452C4B453D6E756C6C3B66756E6374696F6E2047452865297B696628652E7365744163746976652972657475726E20652E73657441637469766528293B6966284B452972657475726E20652E666F6375';
wwv_flow_imp.g_varchar2_table(44309) := '73284B45293B6C657420743D5B5D3B666F72286C6574206E3D653B6E262628742E70757368286E2C6E2E7363726F6C6C546F702C6E2E7363726F6C6C4C656674292C6E213D6E2E6F776E6572446F63756D656E74293B6E3D6E2E706172656E744E6F6465';
wwv_flow_imp.g_varchar2_table(44310) := '293B696628652E666F637573286E756C6C3D3D4B453F7B6765742070726576656E745363726F6C6C28297B72657475726E204B453D7B70726576656E745363726F6C6C3A21307D2C21307D7D3A766F69642030292C214B45297B4B453D21313B666F7228';
wwv_flow_imp.g_varchar2_table(44311) := '6C657420653D303B653C742E6C656E6774683B297B6C6574206E3D745B652B2B5D2C693D745B652B2B5D2C6F3D745B652B2B5D3B6E2E7363726F6C6C546F70213D692626286E2E7363726F6C6C546F703D69292C6E2E7363726F6C6C4C656674213D6F26';
wwv_flow_imp.g_varchar2_table(44312) := '26286E2E7363726F6C6C4C6566743D6F297D7D7D66756E6374696F6E20514528652C742C6E3D74297B6C657420693D55457C7C2855453D646F63756D656E742E63726561746552616E67652829293B72657475726E20692E736574456E6428652C6E292C';
wwv_flow_imp.g_varchar2_table(44313) := '692E736574537461727428652C74292C697D66756E6374696F6E20594528652C742C6E2C69297B6C6574206F3D7B6B65793A742C636F64653A742C6B6579436F64653A6E2C77686963683A6E2C63616E63656C61626C653A21307D3B692626287B616C74';
wwv_flow_imp.g_varchar2_table(44314) := '4B65793A6F2E616C744B65792C6374726C4B65793A6F2E6374726C4B65792C73686966744B65793A6F2E73686966744B65792C6D6574614B65793A6F2E6D6574614B65797D3D69293B6C657420733D6E6577204B6579626F6172644576656E7428226B65';
wwv_flow_imp.g_varchar2_table(44315) := '79646F776E222C6F293B732E73796E7468657469633D21302C652E64697370617463684576656E742873293B6C657420723D6E6577204B6579626F6172644576656E7428226B65797570222C6F293B72657475726E20722E73796E7468657469633D2130';
wwv_flow_imp.g_varchar2_table(44316) := '2C652E64697370617463684576656E742872292C732E64656661756C7450726576656E7465647C7C722E64656661756C7450726576656E7465647D66756E6374696F6E205A452865297B666F72283B652E617474726962757465732E6C656E6774683B29';
wwv_flow_imp.g_varchar2_table(44317) := '652E72656D6F76654174747269627574654E6F646528652E617474726962757465735B305D297D66756E6374696F6E2058452865297B72657475726E20652E7363726F6C6C546F703E4D6174682E6D617828312C652E7363726F6C6C4865696768742D65';
wwv_flow_imp.g_varchar2_table(44318) := '2E636C69656E744865696768742D34297D66756E6374696F6E204A4528652C74297B666F72286C6574206E3D652C693D743B3B297B696628333D3D6E2E6E6F6465547970652626693E302972657475726E7B6E6F64653A6E2C6F66667365743A697D3B69';
wwv_flow_imp.g_varchar2_table(44319) := '6628313D3D6E2E6E6F6465547970652626693E30297B6966282266616C7365223D3D6E2E636F6E74656E744564697461626C652972657475726E206E756C6C3B6E3D6E2E6368696C644E6F6465735B692D315D2C693D4845286E297D656C73657B696628';
wwv_flow_imp.g_varchar2_table(44320) := '216E2E706172656E744E6F64657C7C5645286E292972657475726E206E756C6C3B693D4245286E292C6E3D6E2E706172656E744E6F64657D7D7D66756E6374696F6E20654C28652C74297B666F72286C6574206E3D652C693D743B3B297B696628333D3D';
wwv_flow_imp.g_varchar2_table(44321) := '6E2E6E6F6465547970652626693C6E2E6E6F646556616C75652E6C656E6774682972657475726E7B6E6F64653A6E2C6F66667365743A697D3B696628313D3D6E2E6E6F6465547970652626693C6E2E6368696C644E6F6465732E6C656E677468297B6966';
wwv_flow_imp.g_varchar2_table(44322) := '282266616C7365223D3D6E2E636F6E74656E744564697461626C652972657475726E206E756C6C3B6E3D6E2E6368696C644E6F6465735B695D2C693D307D656C73657B696628216E2E706172656E744E6F64657C7C5645286E292972657475726E206E75';
wwv_flow_imp.g_varchar2_table(44323) := '6C6C3B693D4245286E292B312C6E3D6E2E706172656E744E6F64657D7D7D636C61737320744C7B636F6E7374727563746F7228652C742C6E3D2130297B746869732E6E6F64653D652C746869732E6F66667365743D742C746869732E707265636973653D';
wwv_flow_imp.g_varchar2_table(44324) := '6E7D737461746963206265666F726528652C74297B72657475726E206E657720744C28652E706172656E744E6F64652C42452865292C74297D73746174696320616674657228652C74297B72657475726E206E657720744C28652E706172656E744E6F64';
wwv_flow_imp.g_varchar2_table(44325) := '652C42452865292B312C74297D7D636F6E7374206E4C3D5B5D3B636C61737320694C7B636F6E7374727563746F7228297B746869732E706172656E743D6E756C6C2C746869732E646F6D3D6E756C6C2C746869732E666C6167733D327D676574206F7665';
wwv_flow_imp.g_varchar2_table(44326) := '7272696465444F4D5465787428297B72657475726E206E756C6C7D67657420706F734174537461727428297B72657475726E20746869732E706172656E743F746869732E706172656E742E706F734265666F72652874686973293A307D67657420706F73';
wwv_flow_imp.g_varchar2_table(44327) := '4174456E6428297B72657475726E20746869732E706F73417453746172742B746869732E6C656E6774687D706F734265666F72652865297B6C657420743D746869732E706F73417453746172743B666F72286C6574206E206F6620746869732E6368696C';
wwv_flow_imp.g_varchar2_table(44328) := '6472656E297B6966286E3D3D652972657475726E20743B742B3D6E2E6C656E6774682B6E2E627265616B41667465727D7468726F77206E65772052616E67654572726F722822496E76616C6964206368696C6420696E20706F734265666F726522297D70';
wwv_flow_imp.g_varchar2_table(44329) := '6F7341667465722865297B72657475726E20746869732E706F734265666F72652865292B652E6C656E6774687D73796E6328652C74297B6966283226746869732E666C616773297B6C6574206E2C693D746869732E646F6D2C6F3D6E756C6C3B666F7228';
wwv_flow_imp.g_varchar2_table(44330) := '6C65742073206F6620746869732E6368696C6472656E297B6966283726732E666C616773297B69662821732E646F6D2626286E3D6F3F6F2E6E6578745369626C696E673A692E66697273744368696C6429297B6C657420653D694C2E676574286E293B28';
wwv_flow_imp.g_varchar2_table(44331) := '21657C7C21652E706172656E742626652E63616E5265757365444F4D287329292626732E7265757365444F4D286E297D732E73796E6328652C74292C732E666C616773263D2D387D6966286E3D6F3F6F2E6E6578745369626C696E673A692E6669727374';
wwv_flow_imp.g_varchar2_table(44332) := '4368696C642C74262621742E7772697474656E2626742E6E6F64653D3D6926266E213D732E646F6D262628742E7772697474656E3D2130292C732E646F6D2E706172656E744E6F64653D3D6929666F72283B6E26266E213D732E646F6D3B296E3D6F4C28';
wwv_flow_imp.g_varchar2_table(44333) := '6E293B656C736520692E696E736572744265666F726528732E646F6D2C6E293B6F3D732E646F6D7D666F72286E3D6F3F6F2E6E6578745369626C696E673A692E66697273744368696C642C6E2626742626742E6E6F64653D3D69262628742E7772697474';
wwv_flow_imp.g_varchar2_table(44334) := '656E3D2130293B6E3B296E3D6F4C286E297D656C7365206966283126746869732E666C61677329666F72286C6574206E206F6620746869732E6368696C6472656E2937266E2E666C6167732626286E2E73796E6328652C74292C6E2E666C616773263D2D';
wwv_flow_imp.g_varchar2_table(44335) := '38297D7265757365444F4D2865297B7D6C6F63616C506F7346726F6D444F4D28652C74297B6C6574206E3B696628653D3D746869732E646F6D296E3D746869732E646F6D2E6368696C644E6F6465735B745D3B656C73657B6C657420693D303D3D484528';
wwv_flow_imp.g_varchar2_table(44336) := '65293F303A303D3D743F2D313A313B666F72283B3B297B6C657420743D652E706172656E744E6F64653B696628743D3D746869732E646F6D29627265616B3B303D3D692626742E66697273744368696C64213D742E6C6173744368696C64262628693D65';
wwv_flow_imp.g_varchar2_table(44337) := '3D3D742E66697273744368696C643F2D313A31292C653D747D6E3D693C303F653A652E6E6578745369626C696E677D6966286E3D3D746869732E646F6D2E66697273744368696C642972657475726E20303B666F72283B6E262621694C2E676574286E29';
wwv_flow_imp.g_varchar2_table(44338) := '3B296E3D6E2E6E6578745369626C696E673B696628216E2972657475726E20746869732E6C656E6774683B666F72286C657420653D302C743D303B3B652B2B297B6C657420693D746869732E6368696C6472656E5B655D3B696628692E646F6D3D3D6E29';
wwv_flow_imp.g_varchar2_table(44339) := '72657475726E20743B742B3D692E6C656E6774682B692E627265616B41667465727D7D646F6D426F756E647341726F756E6428652C742C6E3D30297B6C657420693D2D312C6F3D2D312C733D2D312C723D2D313B666F72286C657420613D302C6C3D6E2C';
wwv_flow_imp.g_varchar2_table(44340) := '633D6E3B613C746869732E6368696C6472656E2E6C656E6774683B612B2B297B6C6574206E3D746869732E6368696C6472656E5B615D2C643D6C2B6E2E6C656E6774683B6966286C3C652626643E742972657475726E206E2E646F6D426F756E64734172';
wwv_flow_imp.g_varchar2_table(44341) := '6F756E6428652C742C6C293B696628643E3D6526262D313D3D69262628693D612C6F3D6C292C6C3E7426266E2E646F6D2E706172656E744E6F64653D3D746869732E646F6D297B733D612C723D633B627265616B7D633D642C6C3D642B6E2E627265616B';
wwv_flow_imp.g_varchar2_table(44342) := '41667465727D72657475726E7B66726F6D3A6F2C746F3A723C303F6E2B746869732E6C656E6774683A722C7374617274444F4D3A28693F746869732E6368696C6472656E5B692D315D2E646F6D2E6E6578745369626C696E673A6E756C6C297C7C746869';
wwv_flow_imp.g_varchar2_table(44343) := '732E646F6D2E66697273744368696C642C656E64444F4D3A733C746869732E6368696C6472656E2E6C656E6774682626733E3D303F746869732E6368696C6472656E5B735D2E646F6D3A6E756C6C7D7D6D61726B446972747928653D2131297B74686973';
wwv_flow_imp.g_varchar2_table(44344) := '2E666C6167737C3D322C746869732E6D61726B506172656E747344697274792865297D6D61726B506172656E747344697274792865297B666F72286C657420743D746869732E706172656E743B743B743D742E706172656E74297B69662865262628742E';
wwv_flow_imp.g_varchar2_table(44345) := '666C6167737C3D32292C3126742E666C6167732972657475726E3B742E666C6167737C3D312C653D21317D7D736574506172656E742865297B746869732E706172656E74213D65262628746869732E706172656E743D652C3726746869732E666C616773';
wwv_flow_imp.g_varchar2_table(44346) := '2626746869732E6D61726B506172656E7473446972747928213029297D736574444F4D2865297B746869732E646F6D213D65262628746869732E646F6D262628746869732E646F6D2E636D566965773D6E756C6C292C746869732E646F6D3D652C652E63';
wwv_flow_imp.g_varchar2_table(44347) := '6D566965773D74686973297D67657420726F6F745669657728297B666F72286C657420653D746869733B3B297B6C657420743D652E706172656E743B69662821742972657475726E20653B653D747D7D7265706C6163654368696C6472656E28652C742C';
wwv_flow_imp.g_varchar2_table(44348) := '6E3D6E4C297B746869732E6D61726B446972747928293B666F72286C657420693D653B693C743B692B2B297B6C657420653D746869732E6368696C6472656E5B695D3B652E706172656E743D3D7468697326266E2E696E6465784F662865293C30262665';
wwv_flow_imp.g_varchar2_table(44349) := '2E64657374726F7928297D746869732E6368696C6472656E2E73706C69636528652C742D652C2E2E2E6E293B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B296E5B655D2E736574506172656E742874686973297D69676E6F72654D75';
wwv_flow_imp.g_varchar2_table(44350) := '746174696F6E2865297B72657475726E21317D69676E6F72654576656E742865297B72657475726E21317D6368696C64437572736F7228653D746869732E6C656E677468297B72657475726E206E657720734C28746869732E6368696C6472656E2C652C';
wwv_flow_imp.g_varchar2_table(44351) := '746869732E6368696C6472656E2E6C656E677468297D6368696C64506F7328652C743D31297B72657475726E20746869732E6368696C64437572736F7228292E66696E64506F7328652C74297D746F537472696E6728297B6C657420653D746869732E63';
wwv_flow_imp.g_varchar2_table(44352) := '6F6E7374727563746F722E6E616D652E7265706C616365282256696577222C2222293B72657475726E20652B28746869732E6368696C6472656E2E6C656E6774683F2228222B746869732E6368696C6472656E2E6A6F696E28292B2229223A746869732E';
wwv_flow_imp.g_varchar2_table(44353) := '6C656E6774683F225B222B282254657874223D3D653F746869732E746578743A746869732E6C656E677468292B225D223A2222292B28746869732E627265616B41667465723F2223223A2222297D737461746963206765742865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(44354) := '2E636D566965777D6765742069734564697461626C6528297B72657475726E21307D67657420697357696467657428297B72657475726E21317D67657420697348696464656E28297B72657475726E21317D6D6572676528652C742C6E2C692C6F2C7329';
wwv_flow_imp.g_varchar2_table(44355) := '7B72657475726E21317D6265636F6D652865297B72657475726E21317D63616E5265757365444F4D2865297B72657475726E20652E636F6E7374727563746F723D3D746869732E636F6E7374727563746F7226262128382628746869732E666C6167737C';
wwv_flow_imp.g_varchar2_table(44356) := '652E666C61677329297D6765745369646528297B72657475726E20307D64657374726F7928297B666F72286C65742065206F6620746869732E6368696C6472656E29652E706172656E743D3D746869732626652E64657374726F7928293B746869732E70';
wwv_flow_imp.g_varchar2_table(44357) := '6172656E743D6E756C6C7D7D66756E6374696F6E206F4C2865297B6C657420743D652E6E6578745369626C696E673B72657475726E20652E706172656E744E6F64652E72656D6F76654368696C642865292C747D694C2E70726F746F747970652E627265';
wwv_flow_imp.g_varchar2_table(44358) := '616B41667465723D303B636C61737320734C7B636F6E7374727563746F7228652C742C6E297B746869732E6368696C6472656E3D652C746869732E706F733D742C746869732E693D6E2C746869732E6F66663D307D66696E64506F7328652C743D31297B';
wwv_flow_imp.g_varchar2_table(44359) := '666F72283B3B297B696628653E746869732E706F737C7C653D3D746869732E706F73262628743E307C7C303D3D746869732E697C7C746869732E6368696C6472656E5B746869732E692D315D2E627265616B4166746572292972657475726E2074686973';
wwv_flow_imp.g_varchar2_table(44360) := '2E6F66663D652D746869732E706F732C746869733B6C6574206E3D746869732E6368696C6472656E5B2D2D746869732E695D3B746869732E706F732D3D6E2E6C656E6774682B6E2E627265616B41667465727D7D7D66756E6374696F6E20724C28652C74';
wwv_flow_imp.g_varchar2_table(44361) := '2C6E2C692C6F2C732C722C612C6C297B6C65747B6368696C6472656E3A637D3D652C643D632E6C656E6774683F635B745D3A6E756C6C2C683D732E6C656E6774683F735B732E6C656E6774682D315D3A6E756C6C2C753D683F682E627265616B41667465';
wwv_flow_imp.g_varchar2_table(44362) := '723A723B6966282128743D3D6926266426262172262621752626732E6C656E6774683C322626642E6D65726765286E2C6F2C732E6C656E6774683F683A6E756C6C2C303D3D6E2C612C6C2929297B696628693C632E6C656E677468297B6C657420653D63';
wwv_flow_imp.g_varchar2_table(44363) := '5B695D3B652626286F3C652E6C656E6774687C7C652E627265616B41667465722626286E756C6C3D3D683F766F696420303A682E627265616B416674657229293F28743D3D69262628653D652E73706C6974286F292C6F3D30292C21752626682626652E';
wwv_flow_imp.g_varchar2_table(44364) := '6D6572676528302C6F2C682C21302C302C6C293F735B732E6C656E6774682D315D3D653A28286F7C7C652E6368696C6472656E2E6C656E677468262621652E6368696C6472656E5B305D2E6C656E677468292626652E6D6572676528302C6F2C6E756C6C';
wwv_flow_imp.g_varchar2_table(44365) := '2C21312C302C6C292C732E7075736828652929293A286E756C6C3D3D653F766F696420303A652E627265616B416674657229262628683F682E627265616B41667465723D313A723D31292C692B2B7D666F722864262628642E627265616B41667465723D';
wwv_flow_imp.g_varchar2_table(44366) := '722C6E3E3026262821722626732E6C656E6774682626642E6D65726765286E2C642E6C656E6774682C735B305D2C21312C612C30293F642E627265616B41667465723D732E736869667428292E627265616B41667465723A286E3C642E6C656E6774687C';
wwv_flow_imp.g_varchar2_table(44367) := '7C642E6368696C6472656E2E6C656E6774682626303D3D642E6368696C6472656E5B642E6368696C6472656E2E6C656E6774682D315D2E6C656E677468292626642E6D65726765286E2C642E6C656E6774682C6E756C6C2C21312C612C30292C742B2B29';
wwv_flow_imp.g_varchar2_table(44368) := '293B743C692626732E6C656E6774683B29696628635B692D315D2E6265636F6D6528735B732E6C656E6774682D315D2929692D2D2C732E706F7028292C6C3D732E6C656E6774683F303A613B656C73657B69662821635B745D2E6265636F6D6528735B30';
wwv_flow_imp.g_varchar2_table(44369) := '5D2929627265616B3B742B2B2C732E736869667428292C613D732E6C656E6774683F303A6C7D21732E6C656E6774682626742626693C632E6C656E677468262621635B742D315D2E627265616B41667465722626635B695D2E6D6572676528302C302C63';
wwv_flow_imp.g_varchar2_table(44370) := '5B742D315D2C21312C612C6C292626742D2D2C28743C697C7C732E6C656E677468292626652E7265706C6163654368696C6472656E28742C692C73297D7D66756E6374696F6E20614C28652C742C6E2C692C6F2C73297B6C657420723D652E6368696C64';
wwv_flow_imp.g_varchar2_table(44371) := '437572736F7228292C7B693A612C6F66663A6C7D3D722E66696E64506F73286E2C31292C7B693A632C6F66663A647D3D722E66696E64506F7328742C2D31292C683D742D6E3B666F72286C65742065206F66206929682B3D652E6C656E6774683B652E6C';
wwv_flow_imp.g_varchar2_table(44372) := '656E6774682B3D682C724C28652C632C642C612C6C2C692C302C6F2C73297D6C6574206C4C3D22756E646566696E656422213D747970656F66206E6176696761746F723F6E6176696761746F723A7B757365724167656E743A22222C76656E646F723A22';
wwv_flow_imp.g_varchar2_table(44373) := '222C706C6174666F726D3A22227D2C634C3D22756E646566696E656422213D747970656F6620646F63756D656E743F646F63756D656E743A7B646F63756D656E74456C656D656E743A7B7374796C653A7B7D7D7D3B636F6E737420644C3D2F456467655C';
wwv_flow_imp.g_varchar2_table(44374) := '2F285C642B292F2E65786563286C4C2E757365724167656E74292C684C3D2F4D534945205C642F2E74657374286C4C2E757365724167656E74292C754C3D2F54726964656E745C2F283F3A5B372D395D7C5C647B322C7D295C2E2E2A72763A285C642B29';
wwv_flow_imp.g_varchar2_table(44375) := '2F2E65786563286C4C2E757365724167656E74292C704C3D212128684C7C7C754C7C7C644C292C674C3D21704C26262F6765636B6F5C2F285C642B292F692E74657374286C4C2E757365724167656E74292C6D4C3D21704C26262F4368726F6D655C2F28';
wwv_flow_imp.g_varchar2_table(44376) := '5C642B292F2E65786563286C4C2E757365724167656E74292C664C3D227765626B6974466F6E74536D6F6F7468696E6722696E20634C2E646F63756D656E74456C656D656E742E7374796C652C764C3D21704C26262F4170706C6520436F6D7075746572';
wwv_flow_imp.g_varchar2_table(44377) := '2F2E74657374286C4C2E76656E646F72292C624C3D764C2626282F4D6F62696C655C2F5C772B2F2E74657374286C4C2E757365724167656E74297C7C6C4C2E6D6178546F756368506F696E74733E32293B766172205F4C3D7B6D61633A624C7C7C2F4D61';
wwv_flow_imp.g_varchar2_table(44378) := '632F2E74657374286C4C2E706C6174666F726D292C77696E646F77733A2F57696E2F2E74657374286C4C2E706C6174666F726D292C6C696E75783A2F4C696E75787C5831312F2E74657374286C4C2E706C6174666F726D292C69653A704C2C69655F7665';
wwv_flow_imp.g_varchar2_table(44379) := '7273696F6E3A684C3F634C2E646F63756D656E744D6F64657C7C363A754C3F2B754C5B315D3A644C3F2B644C5B315D3A302C6765636B6F3A674C2C6765636B6F5F76657273696F6E3A674C3F2B282F46697265666F785C2F285C642B292F2E6578656328';
wwv_flow_imp.g_varchar2_table(44380) := '6C4C2E757365724167656E74297C7C5B302C305D295B315D3A302C6368726F6D653A21216D4C2C6368726F6D655F76657273696F6E3A6D4C3F2B6D4C5B315D3A302C696F733A624C2C616E64726F69643A2F416E64726F69645C622F2E74657374286C4C';
wwv_flow_imp.g_varchar2_table(44381) := '2E757365724167656E74292C7765626B69743A664C2C7361666172693A764C2C7765626B69745F76657273696F6E3A664C3F2B282F5C624170706C655765624B69745C2F285C642B292F2E65786563286C4C2E757365724167656E74297C7C5B302C305D';
wwv_flow_imp.g_varchar2_table(44382) := '295B315D3A302C74616253697A653A6E756C6C213D634C2E646F63756D656E74456C656D656E742E7374796C652E74616253697A653F227461622D73697A65223A222D6D6F7A2D7461622D73697A65227D3B636C61737320794C20657874656E64732069';
wwv_flow_imp.g_varchar2_table(44383) := '4C7B636F6E7374727563746F722865297B737570657228292C746869732E746578743D657D676574206C656E67746828297B72657475726E20746869732E746578742E6C656E6774687D637265617465444F4D2865297B746869732E736574444F4D2865';
wwv_flow_imp.g_varchar2_table(44384) := '7C7C646F63756D656E742E637265617465546578744E6F646528746869732E7465787429297D73796E6328652C74297B746869732E646F6D7C7C746869732E637265617465444F4D28292C746869732E646F6D2E6E6F646556616C7565213D746869732E';
wwv_flow_imp.g_varchar2_table(44385) := '74657874262628742626742E6E6F64653D3D746869732E646F6D262628742E7772697474656E3D2130292C746869732E646F6D2E6E6F646556616C75653D746869732E74657874297D7265757365444F4D2865297B333D3D652E6E6F6465547970652626';
wwv_flow_imp.g_varchar2_table(44386) := '746869732E637265617465444F4D2865297D6D6572676528652C742C6E297B72657475726E21283826746869732E666C6167737C7C6E26262821286E20696E7374616E63656F6620794C297C7C746869732E6C656E6774682D28742D65292B6E2E6C656E';
wwv_flow_imp.g_varchar2_table(44387) := '6774683E3235367C7C38266E2E666C616773297C7C28746869732E746578743D746869732E746578742E736C69636528302C65292B286E3F6E2E746578743A2222292B746869732E746578742E736C6963652874292C746869732E6D61726B4469727479';
wwv_flow_imp.g_varchar2_table(44388) := '28292C3029297D73706C69742865297B6C657420743D6E657720794C28746869732E746578742E736C696365286529293B72657475726E20746869732E746578743D746869732E746578742E736C69636528302C65292C746869732E6D61726B44697274';
wwv_flow_imp.g_varchar2_table(44389) := '7928292C742E666C6167737C3D3826746869732E666C6167732C747D6C6F63616C506F7346726F6D444F4D28652C74297B72657475726E20653D3D746869732E646F6D3F743A743F746869732E746578742E6C656E6774683A307D646F6D4174506F7328';
wwv_flow_imp.g_varchar2_table(44390) := '65297B72657475726E206E657720744C28746869732E646F6D2C65297D646F6D426F756E647341726F756E6428652C742C6E297B72657475726E7B66726F6D3A6E2C746F3A6E2B746869732E6C656E6774682C7374617274444F4D3A746869732E646F6D';
wwv_flow_imp.g_varchar2_table(44391) := '2C656E64444F4D3A746869732E646F6D2E6E6578745369626C696E677D7D636F6F726473417428652C74297B72657475726E2066756E6374696F6E28652C742C6E297B6C657420693D652E6E6F646556616C75652E6C656E6774683B743E69262628743D';
wwv_flow_imp.g_varchar2_table(44392) := '69293B6C6574206F3D742C733D742C723D303B303D3D7426266E3C307C7C743D3D6926266E3E3D303F5F4C2E6368726F6D657C7C5F4C2E6765636B6F7C7C28743F286F2D2D2C723D31293A733C69262628732B2B2C723D2D3129293A6E3C303F6F2D2D3A';
wwv_flow_imp.g_varchar2_table(44393) := '733C692626732B2B3B6C657420613D514528652C6F2C73292E676574436C69656E74526563747328293B69662821612E6C656E6774682972657475726E206E756C6C3B6C6574206C3D615B28723F723C303A6E3E3D30293F303A612E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(44394) := '5D3B72657475726E205F4C2E736166617269262621722626303D3D6C2E77696474682626286C3D41727261792E70726F746F747970652E66696E642E63616C6C28612C28653D3E652E776964746829297C7C6C292C723F5745286C2C723C30293A6C7C7C';
wwv_flow_imp.g_varchar2_table(44395) := '6E756C6C7D28746869732E646F6D2C652C74297D7D636C61737320774C20657874656E647320694C7B636F6E7374727563746F7228652C743D5B5D2C6E3D30297B737570657228292C746869732E6D61726B3D652C746869732E6368696C6472656E3D74';
wwv_flow_imp.g_varchar2_table(44396) := '2C746869732E6C656E6774683D6E3B666F72286C65742065206F66207429652E736574506172656E742874686973297D73657441747472732865297B6966285A452865292C746869732E6D61726B2E636C617373262628652E636C6173734E616D653D74';
wwv_flow_imp.g_varchar2_table(44397) := '6869732E6D61726B2E636C617373292C746869732E6D61726B2E617474727329666F72286C6574207420696E20746869732E6D61726B2E617474727329652E73657441747472696275746528742C746869732E6D61726B2E61747472735B745D293B7265';
wwv_flow_imp.g_varchar2_table(44398) := '7475726E20657D63616E5265757365444F4D2865297B72657475726E2073757065722E63616E5265757365444F4D28652926262128382628746869732E666C6167737C652E666C61677329297D7265757365444F4D2865297B652E6E6F64654E616D653D';
wwv_flow_imp.g_varchar2_table(44399) := '3D746869732E6D61726B2E7461674E616D652E746F5570706572436173652829262628746869732E736574444F4D2865292C746869732E666C6167737C3D36297D73796E6328652C74297B746869732E646F6D3F3426746869732E666C61677326267468';
wwv_flow_imp.g_varchar2_table(44400) := '69732E736574417474727328746869732E646F6D293A746869732E736574444F4D28746869732E736574417474727328646F63756D656E742E637265617465456C656D656E7428746869732E6D61726B2E7461674E616D652929292C73757065722E7379';
wwv_flow_imp.g_varchar2_table(44401) := '6E6328652C74297D6D6572676528652C742C6E2C692C6F2C73297B72657475726E21286E26262821286E20696E7374616E63656F6620774C26266E2E6D61726B2E657128746869732E6D61726B29297C7C6526266F3C3D307C7C743C746869732E6C656E';
wwv_flow_imp.g_varchar2_table(44402) := '6774682626733C3D30297C7C28614C28746869732C652C742C6E3F6E2E6368696C6472656E2E736C69636528293A5B5D2C6F2D312C732D31292C746869732E6D61726B446972747928292C3029297D73706C69742865297B6C657420743D5B5D2C6E3D30';
wwv_flow_imp.g_varchar2_table(44403) := '2C693D2D312C6F3D303B666F72286C65742073206F6620746869732E6368696C6472656E297B6C657420723D6E2B732E6C656E6774683B723E652626742E70757368286E3C653F732E73706C697428652D6E293A73292C693C3026266E3E3D6526262869';
wwv_flow_imp.g_varchar2_table(44404) := '3D6F292C6E3D722C6F2B2B7D6C657420733D746869732E6C656E6774682D653B72657475726E20746869732E6C656E6774683D652C693E2D31262628746869732E6368696C6472656E2E6C656E6774683D692C746869732E6D61726B4469727479282929';
wwv_flow_imp.g_varchar2_table(44405) := '2C6E657720774C28746869732E6D61726B2C742C73297D646F6D4174506F732865297B72657475726E20784C28746869732C65297D636F6F726473417428652C74297B72657475726E20454C28746869732C652C74297D7D636C61737320434C20657874';
wwv_flow_imp.g_varchar2_table(44406) := '656E647320694C7B7374617469632063726561746528652C742C6E297B72657475726E206E657720434C28652C742C6E297D636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E7769646765743D652C746869732E6C656E67';
wwv_flow_imp.g_varchar2_table(44407) := '74683D742C746869732E736964653D6E2C746869732E707265765769646765743D6E756C6C7D73706C69742865297B6C657420743D434C2E63726561746528746869732E7769646765742C746869732E6C656E6774682D652C746869732E73696465293B';
wwv_flow_imp.g_varchar2_table(44408) := '72657475726E20746869732E6C656E6774682D3D652C747D73796E632865297B746869732E646F6D2626746869732E7769646765742E757064617465444F4D28746869732E646F6D2C65297C7C28746869732E646F6D2626746869732E70726576576964';
wwv_flow_imp.g_varchar2_table(44409) := '6765742626746869732E707265765769646765742E64657374726F7928746869732E646F6D292C746869732E707265765769646765743D6E756C6C2C746869732E736574444F4D28746869732E7769646765742E746F444F4D286529292C746869732E77';
wwv_flow_imp.g_varchar2_table(44410) := '69646765742E6564697461626C657C7C28746869732E646F6D2E636F6E74656E744564697461626C653D2266616C73652229297D6765745369646528297B72657475726E20746869732E736964657D6D6572676528652C742C6E2C692C6F2C73297B7265';
wwv_flow_imp.g_varchar2_table(44411) := '7475726E21286E26262821286E20696E7374616E63656F6620434C2626746869732E7769646765742E636F6D70617265286E2E77696467657429297C7C653E3026266F3C3D307C7C743C746869732E6C656E6774682626733C3D30297C7C28746869732E';
wwv_flow_imp.g_varchar2_table(44412) := '6C656E6774683D652B286E3F6E2E6C656E6774683A30292B28746869732E6C656E6774682D74292C3029297D6265636F6D652865297B72657475726E206520696E7374616E63656F6620434C2626652E736964653D3D746869732E736964652626746869';
wwv_flow_imp.g_varchar2_table(44413) := '732E7769646765742E636F6E7374727563746F723D3D652E7769646765742E636F6E7374727563746F72262628746869732E7769646765742E636F6D7061726528652E776964676574297C7C746869732E6D61726B4469727479282130292C746869732E';
wwv_flow_imp.g_varchar2_table(44414) := '646F6D262621746869732E70726576576964676574262628746869732E707265765769646765743D746869732E776964676574292C746869732E7769646765743D652E7769646765742C746869732E6C656E6774683D652E6C656E6774682C2130297D69';
wwv_flow_imp.g_varchar2_table(44415) := '676E6F72654D75746174696F6E28297B72657475726E21307D69676E6F72654576656E742865297B72657475726E20746869732E7769646765742E69676E6F72654576656E742865297D676574206F76657272696465444F4D5465787428297B69662830';
wwv_flow_imp.g_varchar2_table(44416) := '3D3D746869732E6C656E6774682972657475726E2046782E656D7074793B6C657420653D746869733B666F72283B652E706172656E743B29653D652E706172656E743B6C65747B766965773A747D3D652C6E3D742626742E73746174652E646F632C693D';
wwv_flow_imp.g_varchar2_table(44417) := '746869732E706F73417453746172743B72657475726E206E3F6E2E736C69636528692C692B746869732E6C656E677468293A46782E656D7074797D646F6D4174506F732865297B72657475726E28746869732E6C656E6774683F303D3D653A746869732E';
wwv_flow_imp.g_varchar2_table(44418) := '736964653E30293F744C2E6265666F726528746869732E646F6D293A744C2E616674657228746869732E646F6D2C653D3D746869732E6C656E677468297D646F6D426F756E647341726F756E6428297B72657475726E206E756C6C7D636F6F7264734174';
wwv_flow_imp.g_varchar2_table(44419) := '28652C74297B6C6574206E3D746869732E7769646765742E636F6F726473417428746869732E646F6D2C652C74293B6966286E2972657475726E206E3B6C657420693D746869732E646F6D2E676574436C69656E74526563747328292C6F3D6E756C6C3B';
wwv_flow_imp.g_varchar2_table(44420) := '69662821692E6C656E6774682972657475726E206E756C6C3B6C657420733D746869732E736964653F746869732E736964653C303A653E303B666F72286C657420743D733F692E6C656E6774682D313A303B6F3D695B745D2C2128653E303F303D3D743A';
wwv_flow_imp.g_varchar2_table(44421) := '743D3D692E6C656E6774682D317C7C6F2E746F703C6F2E626F74746F6D293B742B3D733F2D313A31293B72657475726E205745286F2C2173297D6765742069734564697461626C6528297B72657475726E21317D67657420697357696467657428297B72';
wwv_flow_imp.g_varchar2_table(44422) := '657475726E21307D67657420697348696464656E28297B72657475726E20746869732E7769646765742E697348696464656E7D64657374726F7928297B73757065722E64657374726F7928292C746869732E646F6D2626746869732E7769646765742E64';
wwv_flow_imp.g_varchar2_table(44423) := '657374726F7928746869732E646F6D297D7D636C61737320534C20657874656E647320694C7B636F6E7374727563746F722865297B737570657228292C746869732E736964653D657D676574206C656E67746828297B72657475726E20307D6D65726765';
wwv_flow_imp.g_varchar2_table(44424) := '28297B72657475726E21317D6265636F6D652865297B72657475726E206520696E7374616E63656F6620534C2626652E736964653D3D746869732E736964657D73706C697428297B72657475726E206E657720534C28746869732E73696465297D73796E';
wwv_flow_imp.g_varchar2_table(44425) := '6328297B69662821746869732E646F6D297B6C657420653D646F63756D656E742E637265617465456C656D656E742822696D6722293B652E636C6173734E616D653D22636D2D776964676574427566666572222C652E7365744174747269627574652822';
wwv_flow_imp.g_varchar2_table(44426) := '617269612D68696464656E222C227472756522292C746869732E736574444F4D2865297D7D6765745369646528297B72657475726E20746869732E736964657D646F6D4174506F732865297B72657475726E20746869732E736964653E303F744C2E6265';
wwv_flow_imp.g_varchar2_table(44427) := '666F726528746869732E646F6D293A744C2E616674657228746869732E646F6D297D6C6F63616C506F7346726F6D444F4D28297B72657475726E20307D646F6D426F756E647341726F756E6428297B72657475726E206E756C6C7D636F6F726473417428';
wwv_flow_imp.g_varchar2_table(44428) := '65297B72657475726E20746869732E646F6D2E676574426F756E64696E67436C69656E745265637428297D676574206F76657272696465444F4D5465787428297B72657475726E2046782E656D7074797D67657420697348696464656E28297B72657475';
wwv_flow_imp.g_varchar2_table(44429) := '726E21307D7D66756E6374696F6E20784C28652C74297B6C6574206E3D652E646F6D2C7B6368696C6472656E3A697D3D652C6F3D303B666F72286C657420653D303B6F3C692E6C656E6774683B6F2B2B297B6C657420733D695B6F5D2C723D652B732E6C';
wwv_flow_imp.g_varchar2_table(44430) := '656E6774683B6966282128723D3D652626732E6765745369646528293C3D3029297B696628743E652626743C722626732E646F6D2E706172656E744E6F64653D3D6E2972657475726E20732E646F6D4174506F7328742D65293B696628743C3D65296272';
wwv_flow_imp.g_varchar2_table(44431) := '65616B3B653D727D7D666F72286C657420653D6F3B653E303B652D2D297B6C657420743D695B652D315D3B696628742E646F6D2E706172656E744E6F64653D3D6E2972657475726E20742E646F6D4174506F7328742E6C656E677468297D666F72286C65';
wwv_flow_imp.g_varchar2_table(44432) := '7420653D6F3B653C692E6C656E6774683B652B2B297B6C657420743D695B655D3B696628742E646F6D2E706172656E744E6F64653D3D6E2972657475726E20742E646F6D4174506F732830297D72657475726E206E657720744C286E2C30297D66756E63';
wwv_flow_imp.g_varchar2_table(44433) := '74696F6E206B4C28652C742C6E297B6C657420692C7B6368696C6472656E3A6F7D3D653B6E3E3026267420696E7374616E63656F6620774C26266F2E6C656E677468262628693D6F5B6F2E6C656E6774682D315D29696E7374616E63656F6620774C2626';
wwv_flow_imp.g_varchar2_table(44434) := '692E6D61726B2E657128742E6D61726B293F6B4C28692C742E6368696C6472656E5B305D2C6E2D31293A286F2E707573682874292C742E736574506172656E74286529292C652E6C656E6774682B3D742E6C656E6774687D66756E6374696F6E20454C28';
wwv_flow_imp.g_varchar2_table(44435) := '652C742C6E297B6C657420693D6E756C6C2C6F3D2D312C733D6E756C6C2C723D2D313B2166756E6374696F6E206528742C61297B666F72286C6574206C3D302C633D303B6C3C742E6368696C6472656E2E6C656E6774682626633C3D613B6C2B2B297B6C';
wwv_flow_imp.g_varchar2_table(44436) := '657420643D742E6368696C6472656E5B6C5D2C683D632B642E6C656E6774683B683E3D61262628642E6368696C6472656E2E6C656E6774683F6528642C612D63293A2821737C7C732E697348696464656E26266E3E3029262628683E617C7C633D3D6826';
wwv_flow_imp.g_varchar2_table(44437) := '26642E6765745369646528293E30293F28733D642C723D612D63293A28633C617C7C633D3D682626642E6765745369646528293C30262621642E697348696464656E29262628693D642C6F3D612D6329292C633D687D7D28652C74293B6C657420613D28';
wwv_flow_imp.g_varchar2_table(44438) := '6E3C303F693A73297C7C697C7C733B72657475726E20613F612E636F6F7264734174284D6174682E6D617828302C613D3D693F6F3A72292C6E293A66756E6374696F6E2865297B6C657420743D652E646F6D2E6C6173744368696C643B69662821742972';
wwv_flow_imp.g_varchar2_table(44439) := '657475726E20652E646F6D2E676574426F756E64696E67436C69656E745265637428293B6C6574206E3D52452874293B72657475726E206E5B6E2E6C656E6774682D315D7C7C6E756C6C7D2865297D66756E6374696F6E204C4C28652C74297B666F7228';
wwv_flow_imp.g_varchar2_table(44440) := '6C6574206E20696E20652922636C617373223D3D6E2626742E636C6173733F742E636C6173732B3D2220222B652E636C6173733A227374796C65223D3D6E2626742E7374796C653F742E7374796C652B3D223B222B652E7374796C653A745B6E5D3D655B';
wwv_flow_imp.g_varchar2_table(44441) := '6E5D3B72657475726E20747D794C2E70726F746F747970652E6368696C6472656E3D434C2E70726F746F747970652E6368696C6472656E3D534C2E70726F746F747970652E6368696C6472656E3D6E4C3B636F6E737420444C3D4F626A6563742E637265';
wwv_flow_imp.g_varchar2_table(44442) := '617465286E756C6C293B66756E6374696F6E20544C28652C742C6E297B696628653D3D742972657475726E21303B657C7C28653D444C292C747C7C28743D444C293B6C657420693D4F626A6563742E6B6579732865292C6F3D4F626A6563742E6B657973';
wwv_flow_imp.g_varchar2_table(44443) := '2874293B696628692E6C656E6774682D286E2626692E696E6465784F66286E293E2D313F313A3029213D6F2E6C656E6774682D286E26266F2E696E6465784F66286E293E2D313F313A30292972657475726E21313B666F72286C65742073206F66206929';
wwv_flow_imp.g_varchar2_table(44444) := '69662873213D6E2626282D313D3D6F2E696E6465784F662873297C7C655B735D213D3D745B735D292972657475726E21313B72657475726E21307D66756E6374696F6E20494C28652C742C6E297B6C657420693D21313B6966287429666F72286C657420';
wwv_flow_imp.g_varchar2_table(44445) := '6F20696E2074296E26266F20696E206E7C7C28693D21302C227374796C65223D3D6F3F652E7374796C652E637373546578743D22223A652E72656D6F7665417474726962757465286F29293B6966286E29666F72286C6574206F20696E206E2974262674';
wwv_flow_imp.g_varchar2_table(44446) := '5B6F5D3D3D6E5B6F5D7C7C28693D21302C227374796C65223D3D6F3F652E7374796C652E637373546578743D6E5B6F5D3A652E736574417474726962757465286F2C6E5B6F5D29293B72657475726E20697D66756E6374696F6E204D4C2865297B6C6574';
wwv_flow_imp.g_varchar2_table(44447) := '20743D4F626A6563742E637265617465286E756C6C293B666F72286C6574206E3D303B6E3C652E617474726962757465732E6C656E6774683B6E2B2B297B6C657420693D652E617474726962757465735B6E5D3B745B692E6E616D655D3D692E76616C75';
wwv_flow_imp.g_varchar2_table(44448) := '657D72657475726E20747D636C61737320414C7B65712865297B72657475726E21317D757064617465444F4D28652C74297B72657475726E21317D636F6D706172652865297B72657475726E20746869733D3D657C7C746869732E636F6E737472756374';
wwv_flow_imp.g_varchar2_table(44449) := '6F723D3D652E636F6E7374727563746F722626746869732E65712865297D67657420657374696D6174656448656967687428297B72657475726E2D317D676574206C696E65427265616B7328297B72657475726E20307D69676E6F72654576656E742865';
wwv_flow_imp.g_varchar2_table(44450) := '297B72657475726E21307D636F6F726473417428652C742C6E297B72657475726E206E756C6C7D67657420697348696464656E28297B72657475726E21317D676574206564697461626C6528297B72657475726E21317D64657374726F792865297B7D7D';
wwv_flow_imp.g_varchar2_table(44451) := '766172204E4C3D66756E6374696F6E2865297B72657475726E20655B652E546578743D305D3D2254657874222C655B652E5769646765744265666F72653D315D3D225769646765744265666F7265222C655B652E57696467657441667465723D325D3D22';
wwv_flow_imp.g_varchar2_table(44452) := '5769646765744166746572222C655B652E57696467657452616E67653D335D3D2257696467657452616E6765222C657D284E4C7C7C284E4C3D7B7D29293B636C61737320504C20657874656E6473206F457B636F6E7374727563746F7228652C742C6E2C';
wwv_flow_imp.g_varchar2_table(44453) := '69297B737570657228292C746869732E7374617274536964653D652C746869732E656E64536964653D742C746869732E7769646765743D6E2C746869732E737065633D697D6765742068656967687452656C6576616E7428297B72657475726E21317D73';
wwv_flow_imp.g_varchar2_table(44454) := '7461746963206D61726B2865297B72657475726E206E6577204F4C2865297D737461746963207769646765742865297B6C657420743D4D6174682E6D6178282D3165342C4D6174682E6D696E283165342C652E736964657C7C3029292C6E3D2121652E62';
wwv_flow_imp.g_varchar2_table(44455) := '6C6F636B3B72657475726E20742B3D6E262621652E696E6C696E654F726465723F743E303F3365383A2D3465383A743E303F3165383A2D3165382C6E657720464C28652C742C742C6E2C652E7769646765747C7C6E756C6C2C2131297D73746174696320';
wwv_flow_imp.g_varchar2_table(44456) := '7265706C6163652865297B6C657420742C6E2C693D2121652E626C6F636B3B696628652E6973426C6F636B47617029743D2D3565382C6E3D3465383B656C73657B6C65747B73746172743A6F2C656E643A737D3D424C28652C69293B743D286F3F693F2D';
wwv_flow_imp.g_varchar2_table(44457) := '3365383A2D313A356538292D312C6E3D312B28733F693F3265383A313A2D366538297D72657475726E206E657720464C28652C742C6E2C692C652E7769646765747C7C6E756C6C2C2130297D737461746963206C696E652865297B72657475726E206E65';
wwv_flow_imp.g_varchar2_table(44458) := '7720524C2865297D7374617469632073657428652C743D2131297B72657475726E206C452E6F6628652C74297D68617348656967687428297B72657475726E2121746869732E7769646765742626746869732E7769646765742E657374696D6174656448';
wwv_flow_imp.g_varchar2_table(44459) := '65696768743E2D317D7D504C2E6E6F6E653D6C452E656D7074793B636C617373204F4C20657874656E647320504C7B636F6E7374727563746F722865297B6C65747B73746172743A742C656E643A6E7D3D424C2865293B737570657228743F2D313A3565';
wwv_flow_imp.g_varchar2_table(44460) := '382C6E3F313A2D3665382C6E756C6C2C65292C746869732E7461674E616D653D652E7461674E616D657C7C227370616E222C746869732E636C6173733D652E636C6173737C7C22222C746869732E61747472733D652E617474726962757465737C7C6E75';
wwv_flow_imp.g_varchar2_table(44461) := '6C6C7D65712865297B76617220742C6E3B72657475726E20746869733D3D657C7C6520696E7374616E63656F66204F4C2626746869732E7461674E616D653D3D652E7461674E616D65262628746869732E636C6173737C7C286E756C6C3D3D3D28743D74';
wwv_flow_imp.g_varchar2_table(44462) := '6869732E6174747273297C7C766F696420303D3D3D743F766F696420303A742E636C61737329293D3D28652E636C6173737C7C286E756C6C3D3D3D286E3D652E6174747273297C7C766F696420303D3D3D6E3F766F696420303A6E2E636C617373292926';
wwv_flow_imp.g_varchar2_table(44463) := '26544C28746869732E61747472732C652E61747472732C22636C61737322297D72616E676528652C743D65297B696628653E3D74297468726F77206E65772052616E67654572726F7228224D61726B206465636F726174696F6E73206D6179206E6F7420';
wwv_flow_imp.g_varchar2_table(44464) := '626520656D70747922293B72657475726E2073757065722E72616E676528652C74297D7D4F4C2E70726F746F747970652E706F696E743D21313B636C61737320524C20657874656E647320504C7B636F6E7374727563746F722865297B7375706572282D';
wwv_flow_imp.g_varchar2_table(44465) := '3265382C2D3265382C6E756C6C2C65297D65712865297B72657475726E206520696E7374616E63656F6620524C2626746869732E737065632E636C6173733D3D652E737065632E636C6173732626544C28746869732E737065632E617474726962757465';
wwv_flow_imp.g_varchar2_table(44466) := '732C652E737065632E61747472696275746573297D72616E676528652C743D65297B69662874213D65297468726F77206E65772052616E67654572726F7228224C696E65206465636F726174696F6E2072616E676573206D757374206265207A65726F2D';
wwv_flow_imp.g_varchar2_table(44467) := '6C656E67746822293B72657475726E2073757065722E72616E676528652C74297D7D524C2E70726F746F747970652E6D61704D6F64653D726B2E547261636B4265666F72652C524C2E70726F746F747970652E706F696E743D21303B636C61737320464C';
wwv_flow_imp.g_varchar2_table(44468) := '20657874656E647320504C7B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B737570657228742C6E2C6F2C65292C746869732E626C6F636B3D692C746869732E69735265706C6163653D732C746869732E6D61704D6F64653D693F743C3D';
wwv_flow_imp.g_varchar2_table(44469) := '303F726B2E547261636B4265666F72653A726B2E547261636B41667465723A726B2E547261636B44656C7D676574207479706528297B72657475726E20746869732E737461727453696465213D746869732E656E64536964653F4E4C2E57696467657452';
wwv_flow_imp.g_varchar2_table(44470) := '616E67653A746869732E7374617274536964653C3D303F4E4C2E5769646765744265666F72653A4E4C2E57696467657441667465727D6765742068656967687452656C6576616E7428297B72657475726E20746869732E626C6F636B7C7C212174686973';
wwv_flow_imp.g_varchar2_table(44471) := '2E776964676574262628746869732E7769646765742E657374696D617465644865696768743E3D357C7C746869732E7769646765742E6C696E65427265616B733E30297D65712865297B72657475726E206520696E7374616E63656F6620464C26266675';
wwv_flow_imp.g_varchar2_table(44472) := '6E6374696F6E28652C74297B72657475726E20653D3D747C7C212128652626742626652E636F6D70617265287429297D28746869732E7769646765742C652E776964676574292626746869732E626C6F636B3D3D652E626C6F636B2626746869732E7374';
wwv_flow_imp.g_varchar2_table(44473) := '617274536964653D3D652E7374617274536964652626746869732E656E64536964653D3D652E656E64536964657D72616E676528652C743D65297B696628746869732E69735265706C616365262628653E747C7C653D3D742626746869732E7374617274';
wwv_flow_imp.g_varchar2_table(44474) := '536964653E302626746869732E656E64536964653C3D3029297468726F77206E65772052616E67654572726F722822496E76616C69642072616E676520666F72207265706C6163656D656E74206465636F726174696F6E22293B69662821746869732E69';
wwv_flow_imp.g_varchar2_table(44475) := '735265706C616365262674213D65297468726F77206E65772052616E67654572726F722822576964676574206465636F726174696F6E732063616E206F6E6C792068617665207A65726F2D6C656E6774682072616E67657322293B72657475726E207375';
wwv_flow_imp.g_varchar2_table(44476) := '7065722E72616E676528652C74297D7D66756E6374696F6E20424C28652C743D2131297B6C65747B696E636C757369766553746172743A6E2C696E636C7573697665456E643A697D3D653B72657475726E206E756C6C3D3D6E2626286E3D652E696E636C';
wwv_flow_imp.g_varchar2_table(44477) := '7573697665292C6E756C6C3D3D69262628693D652E696E636C7573697665292C7B73746172743A6E756C6C213D6E3F6E3A742C656E643A6E756C6C213D693F693A747D7D66756E6374696F6E20564C28652C742C6E2C693D30297B6C6574206F3D6E2E6C';
wwv_flow_imp.g_varchar2_table(44478) := '656E6774682D313B6F3E3D3026266E5B6F5D2B693E3D653F6E5B6F5D3D4D6174682E6D6178286E5B6F5D2C74293A6E2E7075736828652C74297D464C2E70726F746F747970652E706F696E743D21303B636C617373207A4C20657874656E647320694C7B';
wwv_flow_imp.g_varchar2_table(44479) := '636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E6368696C6472656E3D5B5D2C746869732E6C656E6774683D302C746869732E7072657641747472733D766F696420302C746869732E61747472733D6E75';
wwv_flow_imp.g_varchar2_table(44480) := '6C6C2C746869732E627265616B41667465723D307D6D6572676528652C742C6E2C692C6F2C73297B6966286E297B69662821286E20696E7374616E63656F66207A4C292972657475726E21313B746869732E646F6D7C7C6E2E7472616E73666572444F4D';
wwv_flow_imp.g_varchar2_table(44481) := '2874686973297D72657475726E20692626746869732E7365744465636F286E3F6E2E61747472733A6E756C6C292C614C28746869732C652C742C6E3F6E2E6368696C6472656E2E736C69636528293A5B5D2C6F2C73292C21307D73706C69742865297B6C';
wwv_flow_imp.g_varchar2_table(44482) := '657420743D6E6577207A4C3B696628742E627265616B41667465723D746869732E627265616B41667465722C303D3D746869732E6C656E6774682972657475726E20743B6C65747B693A6E2C6F66663A697D3D746869732E6368696C64506F732865293B';
wwv_flow_imp.g_varchar2_table(44483) := '69262628742E617070656E6428746869732E6368696C6472656E5B6E5D2E73706C69742869292C30292C746869732E6368696C6472656E5B6E5D2E6D6572676528692C746869732E6368696C6472656E5B6E5D2E6C656E6774682C6E756C6C2C21312C30';
wwv_flow_imp.g_varchar2_table(44484) := '2C30292C6E2B2B293B666F72286C657420653D6E3B653C746869732E6368696C6472656E2E6C656E6774683B652B2B29742E617070656E6428746869732E6368696C6472656E5B655D2C30293B666F72283B6E3E302626303D3D746869732E6368696C64';
wwv_flow_imp.g_varchar2_table(44485) := '72656E5B6E2D315D2E6C656E6774683B29746869732E6368696C6472656E5B2D2D6E5D2E64657374726F7928293B72657475726E20746869732E6368696C6472656E2E6C656E6774683D6E2C746869732E6D61726B446972747928292C746869732E6C65';
wwv_flow_imp.g_varchar2_table(44486) := '6E6774683D652C747D7472616E73666572444F4D2865297B746869732E646F6D262628746869732E6D61726B446972747928292C652E736574444F4D28746869732E646F6D292C652E7072657641747472733D766F696420303D3D3D746869732E707265';
wwv_flow_imp.g_varchar2_table(44487) := '7641747472733F746869732E61747472733A746869732E7072657641747472732C746869732E7072657641747472733D766F696420302C746869732E646F6D3D6E756C6C297D7365744465636F2865297B544C28746869732E61747472732C65297C7C28';
wwv_flow_imp.g_varchar2_table(44488) := '746869732E646F6D262628746869732E7072657641747472733D746869732E61747472732C746869732E6D61726B44697274792829292C746869732E61747472733D65297D617070656E6428652C74297B6B4C28746869732C652C74297D6164644C696E';
wwv_flow_imp.g_varchar2_table(44489) := '654465636F2865297B6C657420743D652E737065632E617474726962757465732C6E3D652E737065632E636C6173733B74262628746869732E61747472733D4C4C28742C746869732E61747472737C7C7B7D29292C6E262628746869732E61747472733D';
wwv_flow_imp.g_varchar2_table(44490) := '4C4C287B636C6173733A6E7D2C746869732E61747472737C7C7B7D29297D646F6D4174506F732865297B72657475726E20784C28746869732C65297D7265757365444F4D2865297B22444956223D3D652E6E6F64654E616D65262628746869732E736574';
wwv_flow_imp.g_varchar2_table(44491) := '444F4D2865292C746869732E666C6167737C3D36297D73796E6328652C74297B766172206E3B746869732E646F6D3F3426746869732E666C6167732626285A4528746869732E646F6D292C746869732E646F6D2E636C6173734E616D653D22636D2D6C69';
wwv_flow_imp.g_varchar2_table(44492) := '6E65222C746869732E7072657641747472733D746869732E61747472733F6E756C6C3A766F69642030293A28746869732E736574444F4D28646F63756D656E742E637265617465456C656D656E7428226469762229292C746869732E646F6D2E636C6173';
wwv_flow_imp.g_varchar2_table(44493) := '734E616D653D22636D2D6C696E65222C746869732E7072657641747472733D746869732E61747472733F6E756C6C3A766F69642030292C766F69642030213D3D746869732E707265764174747273262628494C28746869732E646F6D2C746869732E7072';
wwv_flow_imp.g_varchar2_table(44494) := '657641747472732C746869732E6174747273292C746869732E646F6D2E636C6173734C6973742E6164642822636D2D6C696E6522292C746869732E7072657641747472733D766F69642030292C73757065722E73796E6328652C74293B6C657420693D74';
wwv_flow_imp.g_varchar2_table(44495) := '6869732E646F6D2E6C6173744368696C643B666F72283B692626694C2E676574286929696E7374616E63656F6620774C3B29693D692E6C6173744368696C643B6966282128692626746869732E6C656E677468262628224252223D3D692E6E6F64654E61';
wwv_flow_imp.g_varchar2_table(44496) := '6D657C7C30213D286E756C6C3D3D3D286E3D694C2E676574286929297C7C766F696420303D3D3D6E3F766F696420303A6E2E69734564697461626C65297C7C5F4C2E696F732626746869732E6368696C6472656E2E736F6D652828653D3E6520696E7374';
wwv_flow_imp.g_varchar2_table(44497) := '616E63656F6620794C29292929297B6C657420653D646F63756D656E742E637265617465456C656D656E742822425222293B652E636D49676E6F72653D21302C746869732E646F6D2E617070656E644368696C642865297D7D6D65617375726554657874';
wwv_flow_imp.g_varchar2_table(44498) := '53697A6528297B696628303D3D746869732E6368696C6472656E2E6C656E6774687C7C746869732E6C656E6774683E32302972657475726E206E756C6C3B6C657420652C743D303B666F72286C6574206E206F6620746869732E6368696C6472656E297B';
wwv_flow_imp.g_varchar2_table(44499) := '69662821286E20696E7374616E63656F6620794C297C7C2F5B5E202D7E5D2F2E74657374286E2E74657874292972657475726E206E756C6C3B6C657420693D5245286E2E646F6D293B69662831213D692E6C656E6774682972657475726E206E756C6C3B';
wwv_flow_imp.g_varchar2_table(44500) := '742B3D695B305D2E77696474682C653D695B305D2E6865696768747D72657475726E20743F7B6C696E654865696768743A746869732E646F6D2E676574426F756E64696E67436C69656E745265637428292E6865696768742C6368617257696474683A74';
wwv_flow_imp.g_varchar2_table(44501) := '2F746869732E6C656E6774682C746578744865696768743A657D3A6E756C6C7D636F6F726473417428652C74297B6C6574206E3D454C28746869732C652C74293B69662821746869732E6368696C6472656E2E6C656E67746826266E2626746869732E70';
wwv_flow_imp.g_varchar2_table(44502) := '6172656E74297B6C65747B6865696768744F7261636C653A657D3D746869732E706172656E742E766965772E7669657753746174652C743D6E2E626F74746F6D2D6E2E746F703B6966284D6174682E61627328742D652E6C696E65486569676874293C32';
wwv_flow_imp.g_varchar2_table(44503) := '2626652E746578744865696768743C74297B6C657420693D28742D652E74657874486569676874292F323B72657475726E7B746F703A6E2E746F702B692C626F74746F6D3A6E2E626F74746F6D2D692C6C6566743A6E2E6C6566742C72696768743A6E2E';
wwv_flow_imp.g_varchar2_table(44504) := '6C6566747D7D7D72657475726E206E7D6265636F6D652865297B72657475726E206520696E7374616E63656F66207A4C2626303D3D746869732E6368696C6472656E2E6C656E6774682626303D3D652E6368696C6472656E2E6C656E6774682626544C28';
wwv_flow_imp.g_varchar2_table(44505) := '746869732E61747472732C652E6174747273292626746869732E627265616B41667465723D3D652E627265616B41667465727D636F7665727328297B72657475726E21307D7374617469632066696E6428652C74297B666F72286C6574206E3D302C693D';
wwv_flow_imp.g_varchar2_table(44506) := '303B6E3C652E6368696C6472656E2E6C656E6774683B6E2B2B297B6C6574206F3D652E6368696C6472656E5B6E5D2C733D692B6F2E6C656E6774683B696628733E3D74297B6966286F20696E7374616E63656F66207A4C2972657475726E206F3B696628';
wwv_flow_imp.g_varchar2_table(44507) := '733E7429627265616B7D693D732B6F2E627265616B41667465727D72657475726E206E756C6C7D7D636C61737320484C20657874656E647320694C7B636F6E7374727563746F7228652C742C6E297B737570657228292C746869732E7769646765743D65';
wwv_flow_imp.g_varchar2_table(44508) := '2C746869732E6C656E6774683D742C746869732E6465636F3D6E2C746869732E627265616B41667465723D302C746869732E707265765769646765743D6E756C6C7D6D6572676528652C742C6E2C692C6F2C73297B72657475726E21286E26262821286E';
wwv_flow_imp.g_varchar2_table(44509) := '20696E7374616E63656F6620484C2626746869732E7769646765742E636F6D70617265286E2E77696467657429297C7C653E3026266F3C3D307C7C743C746869732E6C656E6774682626733C3D30297C7C28746869732E6C656E6774683D652B286E3F6E';
wwv_flow_imp.g_varchar2_table(44510) := '2E6C656E6774683A30292B28746869732E6C656E6774682D74292C3029297D646F6D4174506F732865297B72657475726E20303D3D653F744C2E6265666F726528746869732E646F6D293A744C2E616674657228746869732E646F6D2C653D3D74686973';
wwv_flow_imp.g_varchar2_table(44511) := '2E6C656E677468297D73706C69742865297B6C657420743D746869732E6C656E6774682D653B746869732E6C656E6774683D653B6C6574206E3D6E657720484C28746869732E7769646765742C742C746869732E6465636F293B72657475726E206E2E62';
wwv_flow_imp.g_varchar2_table(44512) := '7265616B41667465723D746869732E627265616B41667465722C6E7D676574206368696C6472656E28297B72657475726E206E4C7D73796E632865297B746869732E646F6D2626746869732E7769646765742E757064617465444F4D28746869732E646F';
wwv_flow_imp.g_varchar2_table(44513) := '6D2C65297C7C28746869732E646F6D2626746869732E707265765769646765742626746869732E707265765769646765742E64657374726F7928746869732E646F6D292C746869732E707265765769646765743D6E756C6C2C746869732E736574444F4D';
wwv_flow_imp.g_varchar2_table(44514) := '28746869732E7769646765742E746F444F4D286529292C746869732E7769646765742E6564697461626C657C7C28746869732E646F6D2E636F6E74656E744564697461626C653D2266616C73652229297D676574206F76657272696465444F4D54657874';
wwv_flow_imp.g_varchar2_table(44515) := '28297B72657475726E20746869732E706172656E743F746869732E706172656E742E766965772E73746174652E646F632E736C69636528746869732E706F73417453746172742C746869732E706F734174456E64293A46782E656D7074797D646F6D426F';
wwv_flow_imp.g_varchar2_table(44516) := '756E647341726F756E6428297B72657475726E206E756C6C7D6265636F6D652865297B72657475726E206520696E7374616E63656F6620484C2626652E7769646765742E636F6E7374727563746F723D3D746869732E7769646765742E636F6E73747275';
wwv_flow_imp.g_varchar2_table(44517) := '63746F72262628652E7769646765742E636F6D7061726528746869732E776964676574297C7C746869732E6D61726B4469727479282130292C746869732E646F6D262621746869732E70726576576964676574262628746869732E707265765769646765';
wwv_flow_imp.g_varchar2_table(44518) := '743D746869732E776964676574292C746869732E7769646765743D652E7769646765742C746869732E6C656E6774683D652E6C656E6774682C746869732E6465636F3D652E6465636F2C746869732E627265616B41667465723D652E627265616B416674';
wwv_flow_imp.g_varchar2_table(44519) := '65722C2130297D69676E6F72654D75746174696F6E28297B72657475726E21307D69676E6F72654576656E742865297B72657475726E20746869732E7769646765742E69676E6F72654576656E742865297D6765742069734564697461626C6528297B72';
wwv_flow_imp.g_varchar2_table(44520) := '657475726E21317D67657420697357696467657428297B72657475726E21307D636F6F726473417428652C74297B72657475726E20746869732E7769646765742E636F6F726473417428746869732E646F6D2C652C74297C7C28746869732E7769646765';
wwv_flow_imp.g_varchar2_table(44521) := '7420696E7374616E63656F6620574C3F6E756C6C3A574528746869732E646F6D2E676574426F756E64696E67436C69656E745265637428292C746869732E6C656E6774683F303D3D653A743C3D3029297D64657374726F7928297B73757065722E646573';
wwv_flow_imp.g_varchar2_table(44522) := '74726F7928292C746869732E646F6D2626746869732E7769646765742E64657374726F7928746869732E646F6D297D636F766572732865297B6C65747B7374617274536964653A742C656E64536964653A6E7D3D746869732E6465636F3B72657475726E';
wwv_flow_imp.g_varchar2_table(44523) := '2074213D6E262628653C303F743C303A6E3E30297D7D636C61737320574C20657874656E647320414C7B636F6E7374727563746F722865297B737570657228292C746869732E6865696768743D657D746F444F4D28297B6C657420653D646F63756D656E';
wwv_flow_imp.g_varchar2_table(44524) := '742E637265617465456C656D656E74282264697622293B72657475726E20652E636C6173734E616D653D22636D2D676170222C746869732E757064617465444F4D2865292C657D65712865297B72657475726E20652E6865696768743D3D746869732E68';
wwv_flow_imp.g_varchar2_table(44525) := '65696768747D757064617465444F4D2865297B72657475726E20652E7374796C652E6865696768743D746869732E6865696768742B227078222C21307D676574206564697461626C6528297B72657475726E21307D67657420657374696D617465644865';
wwv_flow_imp.g_varchar2_table(44526) := '6967687428297B72657475726E20746869732E6865696768747D69676E6F72654576656E7428297B72657475726E21317D7D636C617373206A4C7B636F6E7374727563746F7228652C742C6E2C69297B746869732E646F633D652C746869732E706F733D';
wwv_flow_imp.g_varchar2_table(44527) := '742C746869732E656E643D6E2C746869732E646973616C6C6F77426C6F636B45666665637473466F723D692C746869732E636F6E74656E743D5B5D2C746869732E6375724C696E653D6E756C6C2C746869732E627265616B417453746172743D302C7468';
wwv_flow_imp.g_varchar2_table(44528) := '69732E70656E64696E674275666665723D302C746869732E6275666665724D61726B733D5B5D2C746869732E6174437572736F72506F733D21302C746869732E6F70656E53746172743D2D312C746869732E6F70656E456E643D2D312C746869732E7465';
wwv_flow_imp.g_varchar2_table(44529) := '78743D22222C746869732E746578744F66663D302C746869732E637572736F723D652E6974657228292C746869732E736B69703D747D706F73436F766572656428297B696628303D3D746869732E636F6E74656E742E6C656E6774682972657475726E21';
wwv_flow_imp.g_varchar2_table(44530) := '746869732E627265616B417453746172742626746869732E646F632E6C696E65417428746869732E706F73292E66726F6D213D746869732E706F733B6C657420653D746869732E636F6E74656E745B746869732E636F6E74656E742E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(44531) := '5D3B72657475726E2128652E627265616B41667465727C7C6520696E7374616E63656F6620484C2626652E6465636F2E656E64536964653C30297D6765744C696E6528297B72657475726E20746869732E6375724C696E657C7C28746869732E636F6E74';
wwv_flow_imp.g_varchar2_table(44532) := '656E742E7075736828746869732E6375724C696E653D6E6577207A4C292C746869732E6174437572736F72506F733D2130292C746869732E6375724C696E657D666C75736842756666657228653D746869732E6275666665724D61726B73297B74686973';
wwv_flow_imp.g_varchar2_table(44533) := '2E70656E64696E67427566666572262628746869732E6375724C696E652E617070656E6428714C286E657720534C282D31292C65292C652E6C656E677468292C746869732E70656E64696E674275666665723D30297D616464426C6F636B576964676574';
wwv_flow_imp.g_varchar2_table(44534) := '2865297B746869732E666C75736842756666657228292C746869732E6375724C696E653D6E756C6C2C746869732E636F6E74656E742E707573682865297D66696E6973682865297B746869732E70656E64696E674275666665722626653C3D746869732E';
wwv_flow_imp.g_varchar2_table(44535) := '6275666665724D61726B732E6C656E6774683F746869732E666C75736842756666657228293A746869732E70656E64696E674275666665723D302C746869732E706F73436F766572656428297C7C652626746869732E636F6E74656E742E6C656E677468';
wwv_flow_imp.g_varchar2_table(44536) := '2626746869732E636F6E74656E745B746869732E636F6E74656E742E6C656E6774682D315D696E7374616E63656F6620484C7C7C746869732E6765744C696E6528297D6275696C645465787428652C742C6E297B666F72283B653E303B297B6966287468';
wwv_flow_imp.g_varchar2_table(44537) := '69732E746578744F66663D3D746869732E746578742E6C656E677468297B6C65747B76616C75653A742C6C696E65427265616B3A6E2C646F6E653A697D3D746869732E637572736F722E6E65787428746869732E736B6970293B696628746869732E736B';
wwv_flow_imp.g_varchar2_table(44538) := '69703D302C69297468726F77206E6577204572726F72282252616E206F7574206F66207465787420636F6E74656E74207768656E2064726177696E6720696E6C696E6520766965777322293B6966286E297B746869732E706F73436F766572656428297C';
wwv_flow_imp.g_varchar2_table(44539) := '7C746869732E6765744C696E6528292C746869732E636F6E74656E742E6C656E6774683F746869732E636F6E74656E745B746869732E636F6E74656E742E6C656E6774682D315D2E627265616B41667465723D313A746869732E627265616B4174537461';
wwv_flow_imp.g_varchar2_table(44540) := '72743D312C746869732E666C75736842756666657228292C746869732E6375724C696E653D6E756C6C2C746869732E6174437572736F72506F733D21302C652D2D3B636F6E74696E75657D746869732E746578743D742C746869732E746578744F66663D';
wwv_flow_imp.g_varchar2_table(44541) := '307D6C657420693D4D6174682E6D696E28746869732E746578742E6C656E6774682D746869732E746578744F66662C652C353132293B746869732E666C75736842756666657228742E736C69636528742E6C656E6774682D6E29292C746869732E676574';
wwv_flow_imp.g_varchar2_table(44542) := '4C696E6528292E617070656E6428714C286E657720794C28746869732E746578742E736C69636528746869732E746578744F66662C746869732E746578744F66662B6929292C74292C6E292C746869732E6174437572736F72506F733D21302C74686973';
wwv_flow_imp.g_varchar2_table(44543) := '2E746578744F66662B3D692C652D3D692C6E3D307D7D7370616E28652C742C6E2C69297B746869732E6275696C645465787428742D652C6E2C69292C746869732E706F733D742C746869732E6F70656E53746172743C30262628746869732E6F70656E53';
wwv_flow_imp.g_varchar2_table(44544) := '746172743D69297D706F696E7428652C742C6E2C692C6F2C73297B696628746869732E646973616C6C6F77426C6F636B45666665637473466F725B735D26266E20696E7374616E63656F6620464C297B6966286E2E626C6F636B297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(44545) := '2052616E67654572726F722822426C6F636B206465636F726174696F6E73206D6179206E6F74206265207370656369666965642076696120706C7567696E7322293B696628743E746869732E646F632E6C696E65417428746869732E706F73292E746F29';
wwv_flow_imp.g_varchar2_table(44546) := '7468726F77206E65772052616E67654572726F7228224465636F726174696F6E732074686174207265706C616365206C696E6520627265616B73206D6179206E6F74206265207370656369666965642076696120706C7567696E7322297D6C657420723D';
wwv_flow_imp.g_varchar2_table(44547) := '742D653B6966286E20696E7374616E63656F6620464C296966286E2E626C6F636B296E2E7374617274536964653E30262621746869732E706F73436F766572656428292626746869732E6765744C696E6528292C746869732E616464426C6F636B576964';
wwv_flow_imp.g_varchar2_table(44548) := '676574286E657720484C286E2E7769646765747C7C244C2E626C6F636B2C722C6E29293B656C73657B6C657420733D434C2E637265617465286E2E7769646765747C7C244C2E696E6C696E652C722C723F303A6E2E737461727453696465292C613D7468';
wwv_flow_imp.g_varchar2_table(44549) := '69732E6174437572736F72506F73262621732E69734564697461626C6526266F3C3D692E6C656E677468262628653C747C7C6E2E7374617274536964653E30292C6C3D21732E69734564697461626C65262628653C747C7C6F3E692E6C656E6774687C7C';
wwv_flow_imp.g_varchar2_table(44550) := '6E2E7374617274536964653C3D30292C633D746869732E6765744C696E6528293B32213D746869732E70656E64696E674275666665727C7C617C7C732E69734564697461626C657C7C28746869732E70656E64696E674275666665723D30292C74686973';
wwv_flow_imp.g_varchar2_table(44551) := '2E666C7573684275666665722869292C61262628632E617070656E6428714C286E657720534C2831292C69292C6F292C6F3D692E6C656E6774682B4D6174682E6D617828302C6F2D692E6C656E67746829292C632E617070656E6428714C28732C69292C';
wwv_flow_imp.g_varchar2_table(44552) := '6F292C746869732E6174437572736F72506F733D6C2C746869732E70656E64696E674275666665723D6C3F653C747C7C6F3E692E6C656E6774683F313A323A302C746869732E70656E64696E67427566666572262628746869732E6275666665724D6172';
wwv_flow_imp.g_varchar2_table(44553) := '6B733D692E736C6963652829297D656C736520746869732E646F632E6C696E65417428746869732E706F73292E66726F6D3D3D746869732E706F732626746869732E6765744C696E6528292E6164644C696E654465636F286E293B72262628746869732E';
wwv_flow_imp.g_varchar2_table(44554) := '746578744F66662B723C3D746869732E746578742E6C656E6774683F746869732E746578744F66662B3D723A28746869732E736B69702B3D722D28746869732E746578742E6C656E6774682D746869732E746578744F6666292C746869732E746578743D';
wwv_flow_imp.g_varchar2_table(44555) := '22222C746869732E746578744F66663D30292C746869732E706F733D74292C746869732E6F70656E53746172743C30262628746869732E6F70656E53746172743D6F297D737461746963206275696C6428652C742C6E2C692C6F297B6C657420733D6E65';
wwv_flow_imp.g_varchar2_table(44556) := '77206A4C28652C742C6E2C6F293B72657475726E20732E6F70656E456E643D6C452E7370616E7328692C742C6E2C73292C732E6F70656E53746172743C30262628732E6F70656E53746172743D732E6F70656E456E64292C732E66696E69736828732E6F';
wwv_flow_imp.g_varchar2_table(44557) := '70656E456E64292C737D7D66756E6374696F6E20714C28652C74297B666F72286C6574206E206F66207429653D6E657720774C286E2C5B655D2C652E6C656E677468293B72657475726E20657D636C61737320244C20657874656E647320414C7B636F6E';
wwv_flow_imp.g_varchar2_table(44558) := '7374727563746F722865297B737570657228292C746869732E7461673D657D65712865297B72657475726E20652E7461673D3D746869732E7461677D746F444F4D28297B72657475726E20646F63756D656E742E637265617465456C656D656E74287468';
wwv_flow_imp.g_varchar2_table(44559) := '69732E746167297D757064617465444F4D2865297B72657475726E20652E6E6F64654E616D652E746F4C6F7765724361736528293D3D746869732E7461677D67657420697348696464656E28297B72657475726E21307D7D244C2E696E6C696E653D6E65';
wwv_flow_imp.g_varchar2_table(44560) := '7720244C28227370616E22292C244C2E626C6F636B3D6E657720244C282264697622293B76617220554C3D66756E6374696F6E2865297B72657475726E20655B652E4C54523D305D3D224C5452222C655B652E52544C3D315D3D2252544C222C657D2855';
wwv_flow_imp.g_varchar2_table(44561) := '4C7C7C28554C3D7B7D29293B636F6E7374204B4C3D554C2E4C54522C474C3D554C2E52544C3B66756E6374696F6E20514C2865297B6C657420743D5B5D3B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B29742E7075736828313C3C2B';
wwv_flow_imp.g_varchar2_table(44562) := '655B6E5D293B72657475726E20747D636F6E737420594C3D514C2822383838383838383838383838383838383838383838383838383838383838383838383836363638383838383837383738333333333333333333333738383838383830303030303030';
wwv_flow_imp.g_varchar2_table(44563) := '30303030303030303030303030303030303030383838383838303030303030303030303030303030303030303030303030303038383838383838383838383838383838383838383838383838383838383838383838383838373836363636383838383038';
wwv_flow_imp.g_varchar2_table(44564) := '3838383836363333383038383833303838383838303030303030303030303030303030303030303030303038303030303030303030303030303030303030303030303030303030303030303822292C5A4C3D514C28223434343434343838323636323732';
wwv_flow_imp.g_varchar2_table(44565) := '38383939393939393939393939323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232393939393939393939393939393939393939393939343434343434343434343634343232323832';
wwv_flow_imp.g_varchar2_table(44566) := '32323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232';
wwv_flow_imp.g_varchar2_table(44567) := '39393939393939343939393939393932323939383939393932323333333333333333333322292C584C3D4F626A6563742E637265617465286E756C6C292C4A4C3D5B5D3B666F72286C65742065206F665B222829222C225B5D222C227B7D225D297B6C65';
wwv_flow_imp.g_varchar2_table(44568) := '7420743D652E63686172436F646541742830292C6E3D652E63686172436F646541742831293B584C5B745D3D6E2C584C5B6E5D3D2D747D66756E6374696F6E2065442865297B72657475726E20653C3D3234373F594C5B655D3A313432343C3D65262665';
wwv_flow_imp.g_varchar2_table(44569) := '3C3D313532343F323A313533363C3D652626653C3D313738353F5A4C5B652D313533365D3A313737343C3D652626653C3D323232303F343A383139323C3D652626653C3D383230343F3235363A36343333363C3D652626653C3D36353032333F343A317D';
wwv_flow_imp.g_varchar2_table(44570) := '636F6E73742074443D2F5B5C75303539302D5C75303566345C75303630302D5C75303666665C75303730302D5C75303861635C75666235302D5C75666466665D2F3B636C617373206E447B6765742064697228297B72657475726E20746869732E6C6576';
wwv_flow_imp.g_varchar2_table(44571) := '656C25323F474C3A4B4C7D636F6E7374727563746F7228652C742C6E297B746869732E66726F6D3D652C746869732E746F3D742C746869732E6C6576656C3D6E7D7369646528652C74297B72657475726E20746869732E6469723D3D743D3D653F746869';
wwv_flow_imp.g_varchar2_table(44572) := '732E746F3A746869732E66726F6D7D666F727761726428652C74297B72657475726E20653D3D28746869732E6469723D3D74297D7374617469632066696E6428652C742C6E2C69297B6C6574206F3D2D313B666F72286C657420733D303B733C652E6C65';
wwv_flow_imp.g_varchar2_table(44573) := '6E6774683B732B2B297B6C657420723D655B735D3B696628722E66726F6D3C3D742626722E746F3E3D74297B696628722E6C6576656C3D3D6E2972657475726E20733B286F3C307C7C2830213D693F693C303F722E66726F6D3C743A722E746F3E743A65';
wwv_flow_imp.g_varchar2_table(44574) := '5B6F5D2E6C6576656C3E722E6C6576656C29292626286F3D73297D7D6966286F3C30297468726F77206E65772052616E67654572726F722822496E646578206F7574206F662072616E676522293B72657475726E206F7D7D66756E6374696F6E20694428';
wwv_flow_imp.g_varchar2_table(44575) := '652C74297B696628652E6C656E677468213D742E6C656E6774682972657475726E21313B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B6C657420693D655B6E5D2C6F3D745B6E5D3B696628692E66726F6D213D6F2E66726F6D7C';
wwv_flow_imp.g_varchar2_table(44576) := '7C692E746F213D6F2E746F7C7C692E646972656374696F6E213D6F2E646972656374696F6E7C7C21694428692E696E6E65722C6F2E696E6E6572292972657475726E21317D72657475726E21307D636F6E7374206F443D5B5D3B66756E6374696F6E2073';
wwv_flow_imp.g_varchar2_table(44577) := '4428652C742C6E2C692C6F2C732C72297B6C657420613D6925323F323A313B6966286925323D3D6F253229666F72286C6574206C3D742C633D303B6C3C6E3B297B6C657420743D21302C643D21313B696628633D3D732E6C656E6774687C7C6C3C735B63';
wwv_flow_imp.g_varchar2_table(44578) := '5D2E66726F6D297B6C657420653D6F445B6C5D3B65213D61262628743D21312C643D31363D3D65297D6C657420683D747C7C31213D613F6E756C6C3A5B5D2C753D743F693A692B312C703D6C3B653A666F72283B3B29696628633C732E6C656E67746826';
wwv_flow_imp.g_varchar2_table(44579) := '26703D3D735B635D2E66726F6D297B6966286429627265616B20653B6C657420673D735B635D3B696628217429666F72286C657420653D672E746F2C743D632B313B3B297B696628653D3D6E29627265616B20653B6966282128743C732E6C656E677468';
wwv_flow_imp.g_varchar2_table(44580) := '2626735B745D2E66726F6D3D3D6529297B6966286F445B655D3D3D6129627265616B20653B627265616B7D653D735B742B2B5D2E746F7D632B2B2C683F682E707573682867293A28672E66726F6D3E6C2626722E70757368286E6577206E44286C2C672E';
wwv_flow_imp.g_varchar2_table(44581) := '66726F6D2C7529292C724428652C672E646972656374696F6E3D3D4B4C213D2128752532293F692B313A692C6F2C672E696E6E65722C672E66726F6D2C672E746F2C72292C6C3D672E746F292C703D672E746F7D656C73657B696628703D3D6E7C7C2874';
wwv_flow_imp.g_varchar2_table(44582) := '3F6F445B705D213D613A6F445B705D3D3D612929627265616B3B702B2B7D683F734428652C6C2C702C692B312C6F2C682C72293A6C3C702626722E70757368286E6577206E44286C2C702C7529292C6C3D707D656C736520666F72286C6574206C3D6E2C';
wwv_flow_imp.g_varchar2_table(44583) := '633D732E6C656E6774683B6C3E743B297B6C6574206E3D21302C643D21313B69662821637C7C6C3E735B632D315D2E746F297B6C657420653D6F445B6C2D315D3B65213D612626286E3D21312C643D31363D3D65297D6C657420683D6E7C7C31213D613F';
wwv_flow_imp.g_varchar2_table(44584) := '6E756C6C3A5B5D2C753D6E3F693A692B312C703D6C3B653A666F72283B3B29696628632626703D3D735B632D315D2E746F297B6966286429627265616B20653B6C657420673D735B2D2D635D3B696628216E29666F72286C657420653D672E66726F6D2C';
wwv_flow_imp.g_varchar2_table(44585) := '6E3D633B3B297B696628653D3D7429627265616B20653B696628216E7C7C735B6E2D315D2E746F213D65297B6966286F445B652D315D3D3D6129627265616B20653B627265616B7D653D735B2D2D6E5D2E66726F6D7D683F682E707573682867293A2867';
wwv_flow_imp.g_varchar2_table(44586) := '2E746F3C6C2626722E70757368286E6577206E4428672E746F2C6C2C7529292C724428652C672E646972656374696F6E3D3D4B4C213D2128752532293F692B313A692C6F2C672E696E6E65722C672E66726F6D2C672E746F2C72292C6C3D672E66726F6D';
wwv_flow_imp.g_varchar2_table(44587) := '292C703D672E66726F6D7D656C73657B696628703D3D747C7C286E3F6F445B702D315D213D613A6F445B702D315D3D3D612929627265616B3B702D2D7D683F734428652C702C6C2C692B312C6F2C682C72293A703C6C2626722E70757368286E6577206E';
wwv_flow_imp.g_varchar2_table(44588) := '4428702C6C2C7529292C6C3D707D7D66756E6374696F6E20724428652C742C6E2C692C6F2C732C72297B6C657420613D7425323F323A313B2166756E6374696F6E28652C742C6E2C692C6F297B666F72286C657420733D303B733C3D692E6C656E677468';
wwv_flow_imp.g_varchar2_table(44589) := '3B732B2B297B6C657420723D733F695B732D315D2E746F3A742C613D733C692E6C656E6774683F695B735D2E66726F6D3A6E2C6C3D733F3235363A6F3B666F72286C657420743D722C6E3D6C2C693D6C3B743C613B742B2B297B6C6574206F3D65442865';
wwv_flow_imp.g_varchar2_table(44590) := '2E63686172436F64654174287429293B3531323D3D6F3F6F3D6E3A383D3D6F2626343D3D692626286F3D3136292C6F445B745D3D343D3D6F3F323A6F2C37266F262628693D6F292C6E3D6F7D666F72286C657420653D722C743D6C2C693D6C3B653C613B';
wwv_flow_imp.g_varchar2_table(44591) := '652B2B297B6C6574206F3D6F445B655D3B6966283132383D3D6F29653C612D312626743D3D6F445B652B315D2626323426743F6F3D6F445B655D3D743A6F445B655D3D3235363B656C73652069662836343D3D6F297B6C6574206F3D652B313B666F7228';
wwv_flow_imp.g_varchar2_table(44592) := '3B6F3C61262636343D3D6F445B6F5D3B296F2B2B3B6C657420733D652626383D3D747C7C6F3C6E2626383D3D6F445B6F5D3F313D3D693F313A383A3235363B666F72286C657420743D653B743C6F3B742B2B296F445B745D3D733B653D6F2D317D656C73';
wwv_flow_imp.g_varchar2_table(44593) := '6520383D3D6F2626313D3D692626286F445B655D3D31293B743D6F2C37266F262628693D6F297D7D7D28652C6F2C732C692C61292C66756E6374696F6E28652C742C6E2C692C6F297B6C657420733D313D3D6F3F323A313B666F72286C657420723D302C';
wwv_flow_imp.g_varchar2_table(44594) := '613D302C6C3D303B723C3D692E6C656E6774683B722B2B297B6C657420633D723F695B722D315D2E746F3A742C643D723C692E6C656E6774683F695B725D2E66726F6D3A6E3B666F72286C657420742C6E2C692C723D633B723C643B722B2B296966286E';
wwv_flow_imp.g_varchar2_table(44595) := '3D584C5B743D652E63686172436F646541742872295D296966286E3C30297B666F72286C657420653D612D333B653E3D303B652D3D33296966284A4C5B652B315D3D3D2D6E297B6C657420743D4A4C5B652B325D2C6E3D3226743F6F3A3426743F312674';
wwv_flow_imp.g_varchar2_table(44596) := '3F733A6F3A303B6E2626286F445B725D3D6F445B4A4C5B655D5D3D6E292C613D653B627265616B7D7D656C73657B6966283138393D3D4A4C2E6C656E67746829627265616B3B4A4C5B612B2B5D3D722C4A4C5B612B2B5D3D742C4A4C5B612B2B5D3D6C7D';
wwv_flow_imp.g_varchar2_table(44597) := '656C736520696628323D3D28693D6F445B725D297C7C313D3D69297B6C657420653D693D3D6F3B6C3D653F303A313B666F72286C657420743D612D333B743E3D303B742D3D33297B6C6574206E3D4A4C5B742B325D3B69662832266E29627265616B3B69';
wwv_flow_imp.g_varchar2_table(44598) := '662865294A4C5B742B325D7C3D323B656C73657B69662834266E29627265616B3B4A4C5B742B325D7C3D347D7D7D7D7D28652C6F2C732C692C61292C66756E6374696F6E28652C742C6E2C69297B666F72286C6574206F3D302C733D693B6F3C3D6E2E6C';
wwv_flow_imp.g_varchar2_table(44599) := '656E6774683B6F2B2B297B6C657420723D6F3F6E5B6F2D315D2E746F3A652C613D6F3C6E2E6C656E6774683F6E5B6F5D2E66726F6D3A743B666F72286C6574206C3D723B6C3C613B297B6C657420723D6F445B6C5D3B6966283235363D3D72297B6C6574';
wwv_flow_imp.g_varchar2_table(44600) := '20723D6C2B313B666F72283B3B29696628723D3D61297B6966286F3D3D6E2E6C656E67746829627265616B3B723D6E5B6F2B2B5D2E746F2C613D6F3C6E2E6C656E6774683F6E5B6F5D2E66726F6D3A747D656C73657B696628323536213D6F445B725D29';
wwv_flow_imp.g_varchar2_table(44601) := '627265616B3B722B2B7D6C657420633D313D3D732C643D633D3D28313D3D28723C743F6F445B725D3A6929293F633F313A323A693B666F72286C657420743D722C693D6F2C733D693F6E5B692D315D2E746F3A653B743E6C3B29743D3D73262628743D6E';
wwv_flow_imp.g_varchar2_table(44602) := '5B2D2D695D2E66726F6D2C733D693F6E5B692D315D2E746F3A65292C6F445B2D2D745D3D643B6C3D727D656C736520733D722C6C2B2B7D7D7D286F2C732C692C61292C734428652C6F2C732C742C6E2C692C72297D66756E6374696F6E2061442865297B';
wwv_flow_imp.g_varchar2_table(44603) := '72657475726E5B6E6577206E4428302C652C30295D7D6C6574206C443D22223B66756E6374696F6E20634428652C742C6E2C692C6F297B76617220733B6C657420723D692E686561642D652E66726F6D2C613D6E442E66696E6428742C722C6E756C6C21';
wwv_flow_imp.g_varchar2_table(44604) := '3D3D28733D692E626964694C6576656C292626766F69642030213D3D733F733A2D312C692E6173736F63292C6C3D745B615D2C633D6C2E73696465286F2C6E293B696628723D3D63297B6C657420653D612B3D6F3F313A2D313B696628653C307C7C653E';
wwv_flow_imp.g_varchar2_table(44605) := '3D742E6C656E6774682972657475726E206E756C6C3B6C3D745B613D655D2C723D6C2E7369646528216F2C6E292C633D6C2E73696465286F2C6E297D6C657420643D5A7828652E746578742C722C6C2E666F7277617264286F2C6E29293B28643C6C2E66';
wwv_flow_imp.g_varchar2_table(44606) := '726F6D7C7C643E6C2E746F29262628643D63292C6C443D652E746578742E736C696365284D6174682E6D696E28722C64292C4D6174682E6D617828722C6429293B6C657420683D613D3D286F3F742E6C656E6774682D313A30293F6E756C6C3A745B612B';
wwv_flow_imp.g_varchar2_table(44607) := '286F3F313A2D31295D3B72657475726E20682626643D3D632626682E6C6576656C2B286F3F303A31293C6C2E6C6576656C3F666B2E637572736F7228682E7369646528216F2C6E292B652E66726F6D2C682E666F7277617264286F2C6E293F313A2D312C';
wwv_flow_imp.g_varchar2_table(44608) := '682E6C6576656C293A666B2E637572736F7228642B652E66726F6D2C6C2E666F7277617264286F2C6E293F2D313A312C6C2E6C6576656C297D66756E6374696F6E20644428652C742C6E297B666F72286C657420693D743B693C6E3B692B2B297B6C6574';
wwv_flow_imp.g_varchar2_table(44609) := '20743D654428652E63686172436F64654174286929293B696628313D3D742972657475726E204B4C3B696628323D3D747C7C343D3D742972657475726E20474C7D72657475726E204B4C7D636F6E73742068443D5F6B2E646566696E6528292C75443D5F';
wwv_flow_imp.g_varchar2_table(44610) := '6B2E646566696E6528292C70443D5F6B2E646566696E6528292C67443D5F6B2E646566696E6528292C6D443D5F6B2E646566696E6528292C66443D5F6B2E646566696E6528292C76443D5F6B2E646566696E6528292C62443D5F6B2E646566696E652829';
wwv_flow_imp.g_varchar2_table(44611) := '2C5F443D5F6B2E646566696E6528292C79443D5F6B2E646566696E65287B636F6D62696E653A653D3E652E736F6D652828653D3E6529297D292C77443D5F6B2E646566696E65287B636F6D62696E653A653D3E652E736F6D652828653D3E6529297D292C';
wwv_flow_imp.g_varchar2_table(44612) := '43443D5F6B2E646566696E6528293B636C6173732053447B636F6E7374727563746F7228652C743D226E656172657374222C6E3D226E656172657374222C693D352C6F3D352C733D2131297B746869732E72616E67653D652C746869732E793D742C7468';
wwv_flow_imp.g_varchar2_table(44613) := '69732E783D6E2C746869732E794D617267696E3D692C746869732E784D617267696E3D6F2C746869732E6973536E617073686F743D737D6D61702865297B72657475726E20652E656D7074793F746869733A6E657720534428746869732E72616E67652E';
wwv_flow_imp.g_varchar2_table(44614) := '6D61702865292C746869732E792C746869732E782C746869732E794D617267696E2C746869732E784D617267696E2C746869732E6973536E617073686F74297D636C69702865297B72657475726E20746869732E72616E67652E746F3C3D652E646F632E';
wwv_flow_imp.g_varchar2_table(44615) := '6C656E6774683F746869733A6E657720534428666B2E637572736F7228652E646F632E6C656E677468292C746869732E792C746869732E782C746869732E794D617267696E2C746869732E784D617267696E2C746869732E6973536E617073686F74297D';
wwv_flow_imp.g_varchar2_table(44616) := '7D636F6E73742078443D246B2E646566696E65287B6D61703A28652C74293D3E652E6D61702874297D292C6B443D246B2E646566696E6528293B66756E6374696F6E20454428652C742C6E297B6C657420693D652E6661636574286744293B692E6C656E';
wwv_flow_imp.g_varchar2_table(44617) := '6774683F695B305D2874293A77696E646F772E6F6E6572726F723F77696E646F772E6F6E6572726F7228537472696E672874292C6E2C766F696420302C766F696420302C74293A6E3F636F6E736F6C652E6572726F72286E2B223A222C74293A636F6E73';
wwv_flow_imp.g_varchar2_table(44618) := '6F6C652E6572726F722874297D636F6E7374204C443D5F6B2E646566696E65287B636F6D62696E653A653D3E21652E6C656E6774687C7C655B305D7D293B6C65742044443D303B636F6E73742054443D5F6B2E646566696E6528293B636C617373204944';
wwv_flow_imp.g_varchar2_table(44619) := '7B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E69643D652C746869732E6372656174653D742C746869732E646F6D4576656E7448616E646C6572733D6E2C746869732E646F6D4576656E744F62736572766572733D692C746869';
wwv_flow_imp.g_varchar2_table(44620) := '732E657874656E73696F6E3D6F2874686973297D73746174696320646566696E6528652C74297B636F6E73747B6576656E7448616E646C6572733A6E2C6576656E744F62736572766572733A692C70726F766964653A6F2C6465636F726174696F6E733A';
wwv_flow_imp.g_varchar2_table(44621) := '737D3D747C7C7B7D3B72657475726E206E65772049442844442B2B2C652C6E2C692C28653D3E7B6C657420743D5B54442E6F662865295D3B72657475726E20732626742E707573682850442E6F662828743D3E7B6C6574206E3D742E706C7567696E2865';
wwv_flow_imp.g_varchar2_table(44622) := '293B72657475726E206E3F73286E293A504C2E6E6F6E657D2929292C6F2626742E70757368286F286529292C747D29297D7374617469632066726F6D436C61737328652C74297B72657475726E2049442E646566696E652828743D3E6E65772065287429';
wwv_flow_imp.g_varchar2_table(44623) := '292C74297D7D636C617373204D447B636F6E7374727563746F722865297B746869732E737065633D652C746869732E6D7573745570646174653D6E756C6C2C746869732E76616C75653D6E756C6C7D7570646174652865297B696628746869732E76616C';
wwv_flow_imp.g_varchar2_table(44624) := '7565297B696628746869732E6D757374557064617465297B6C657420653D746869732E6D7573745570646174653B696628746869732E6D7573745570646174653D6E756C6C2C746869732E76616C75652E757064617465297472797B746869732E76616C';
wwv_flow_imp.g_varchar2_table(44625) := '75652E7570646174652865297D63617463682874297B696628454428652E73746174652C742C22436F64654D6972726F7220706C7567696E206372617368656422292C746869732E76616C75652E64657374726F79297472797B746869732E76616C7565';
wwv_flow_imp.g_varchar2_table(44626) := '2E64657374726F7928297D63617463682865297B7D746869732E6465616374697661746528297D7D7D656C736520696628746869732E73706563297472797B746869732E76616C75653D746869732E737065632E6372656174652865297D636174636828';
wwv_flow_imp.g_varchar2_table(44627) := '74297B454428652E73746174652C742C22436F64654D6972726F7220706C7567696E206372617368656422292C746869732E6465616374697661746528297D72657475726E20746869737D64657374726F792865297B76617220743B6966286E756C6C3D';
wwv_flow_imp.g_varchar2_table(44628) := '3D3D28743D746869732E76616C7565297C7C766F696420303D3D3D743F766F696420303A742E64657374726F79297472797B746869732E76616C75652E64657374726F7928297D63617463682874297B454428652E73746174652C742C22436F64654D69';
wwv_flow_imp.g_varchar2_table(44629) := '72726F7220706C7567696E206372617368656422297D7D6465616374697661746528297B746869732E737065633D746869732E76616C75653D6E756C6C7D7D636F6E73742041443D5F6B2E646566696E6528292C4E443D5F6B2E646566696E6528292C50';
wwv_flow_imp.g_varchar2_table(44630) := '443D5F6B2E646566696E6528292C4F443D5F6B2E646566696E6528292C52443D5F6B2E646566696E6528292C46443D5F6B2E646566696E6528293B66756E6374696F6E20424428652C74297B6C6574206E3D652E73746174652E6661636574284644293B';
wwv_flow_imp.g_varchar2_table(44631) := '696628216E2E6C656E6774682972657475726E206E3B6C657420693D6E2E6D61702828743D3E7420696E7374616E63656F662046756E6374696F6E3F742865293A7429292C6F3D5B5D3B72657475726E206C452E7370616E7328692C742E66726F6D2C74';
wwv_flow_imp.g_varchar2_table(44632) := '2E746F2C7B706F696E7428297B7D2C7370616E28652C6E2C692C73297B6C657420723D652D742E66726F6D2C613D6E2D742E66726F6D2C6C3D6F3B666F72286C657420653D692E6C656E6774682D313B653E3D303B652D2D2C732D2D297B6C6574206E2C';
wwv_flow_imp.g_varchar2_table(44633) := '6F3D695B655D2E737065632E6269646949736F6C6174653B6966286E756C6C3D3D6F2626286F3D644428742E746578742C722C6129292C733E3026266C2E6C656E6774682626286E3D6C5B6C2E6C656E6774682D315D292E746F3D3D7226266E2E646972';
wwv_flow_imp.g_varchar2_table(44634) := '656374696F6E3D3D6F296E2E746F3D612C6C3D6E2E696E6E65723B656C73657B6C657420653D7B66726F6D3A722C746F3A612C646972656374696F6E3A6F2C696E6E65723A5B5D7D3B6C2E707573682865292C6C3D652E696E6E65727D7D7D7D292C6F7D';
wwv_flow_imp.g_varchar2_table(44635) := '636F6E73742056443D5F6B2E646566696E6528293B66756E6374696F6E207A442865297B6C657420743D302C6E3D302C693D302C6F3D303B666F72286C65742073206F6620652E73746174652E666163657428564429297B6C657420723D732865293B72';
wwv_flow_imp.g_varchar2_table(44636) := '2626286E756C6C213D722E6C656674262628743D4D6174682E6D617828742C722E6C65667429292C6E756C6C213D722E72696768742626286E3D4D6174682E6D6178286E2C722E726967687429292C6E756C6C213D722E746F70262628693D4D6174682E';
wwv_flow_imp.g_varchar2_table(44637) := '6D617828692C722E746F7029292C6E756C6C213D722E626F74746F6D2626286F3D4D6174682E6D6178286F2C722E626F74746F6D2929297D72657475726E7B6C6566743A742C72696768743A6E2C746F703A692C626F74746F6D3A6F7D7D636F6E737420';
wwv_flow_imp.g_varchar2_table(44638) := '48443D5F6B2E646566696E6528293B636C6173732057447B636F6E7374727563746F7228652C742C6E2C69297B746869732E66726F6D413D652C746869732E746F413D742C746869732E66726F6D423D6E2C746869732E746F423D697D6A6F696E286529';
wwv_flow_imp.g_varchar2_table(44639) := '7B72657475726E206E6577205744284D6174682E6D696E28746869732E66726F6D412C652E66726F6D41292C4D6174682E6D617828746869732E746F412C652E746F41292C4D6174682E6D696E28746869732E66726F6D422C652E66726F6D42292C4D61';
wwv_flow_imp.g_varchar2_table(44640) := '74682E6D617828746869732E746F422C652E746F4229297D616464546F5365742865297B6C657420743D652E6C656E6774682C6E3D746869733B666F72283B743E303B742D2D297B6C657420693D655B742D315D3B6966282128692E66726F6D413E6E2E';
wwv_flow_imp.g_varchar2_table(44641) := '746F4129297B696628692E746F413C6E2E66726F6D4129627265616B3B6E3D6E2E6A6F696E2869292C652E73706C69636528742D312C31297D7D72657475726E20652E73706C69636528742C302C6E292C657D73746174696320657874656E6457697468';
wwv_flow_imp.g_varchar2_table(44642) := '52616E67657328652C74297B696628303D3D742E6C656E6774682972657475726E20653B6C6574206E3D5B5D3B666F72286C657420693D302C6F3D302C733D302C723D303B3B692B2B297B6C657420613D693D3D652E6C656E6774683F6E756C6C3A655B';
wwv_flow_imp.g_varchar2_table(44643) := '695D2C6C3D732D722C633D613F612E66726F6D423A3165393B666F72283B6F3C742E6C656E6774682626745B6F5D3C633B297B6C657420653D745B6F5D2C693D745B6F2B315D2C733D4D6174682E6D617828722C65292C613D4D6174682E6D696E28632C';
wwv_flow_imp.g_varchar2_table(44644) := '69293B696628733C3D6126266E657720574428732B6C2C612B6C2C732C61292E616464546F536574286E292C693E6329627265616B3B6F2B3D327D69662821612972657475726E206E3B6E657720574428612E66726F6D412C612E746F412C612E66726F';
wwv_flow_imp.g_varchar2_table(44645) := '6D422C612E746F42292E616464546F536574286E292C733D612E746F412C723D612E746F427D7D7D636C617373206A447B636F6E7374727563746F7228652C742C6E297B746869732E766965773D652C746869732E73746174653D742C746869732E7472';
wwv_flow_imp.g_varchar2_table(44646) := '616E73616374696F6E733D6E2C746869732E666C6167733D302C746869732E737461727453746174653D652E73746174652C746869732E6368616E6765733D6C6B2E656D70747928746869732E737461727453746174652E646F632E6C656E677468293B';
wwv_flow_imp.g_varchar2_table(44647) := '666F72286C65742065206F66206E29746869732E6368616E6765733D746869732E6368616E6765732E636F6D706F736528652E6368616E676573293B6C657420693D5B5D3B746869732E6368616E6765732E697465724368616E67656452616E67657328';
wwv_flow_imp.g_varchar2_table(44648) := '2828652C742C6E2C6F293D3E692E70757368286E657720574428652C742C6E2C6F292929292C746869732E6368616E67656452616E6765733D697D7374617469632063726561746528652C742C6E297B72657475726E206E6577206A4428652C742C6E29';
wwv_flow_imp.g_varchar2_table(44649) := '7D6765742076696577706F72744368616E67656428297B72657475726E283426746869732E666C616773293E307D676574206865696768744368616E67656428297B72657475726E283226746869732E666C616773293E307D6765742067656F6D657472';
wwv_flow_imp.g_varchar2_table(44650) := '794368616E67656428297B72657475726E20746869732E646F634368616E6765647C7C28313026746869732E666C616773293E307D67657420666F6375734368616E67656428297B72657475726E283126746869732E666C616773293E307D6765742064';
wwv_flow_imp.g_varchar2_table(44651) := '6F634368616E67656428297B72657475726E21746869732E6368616E6765732E656D7074797D6765742073656C656374696F6E53657428297B72657475726E20746869732E7472616E73616374696F6E732E736F6D652828653D3E652E73656C65637469';
wwv_flow_imp.g_varchar2_table(44652) := '6F6E29297D67657420656D70747928297B72657475726E20303D3D746869732E666C6167732626303D3D746869732E7472616E73616374696F6E732E6C656E6774687D7D636C61737320714420657874656E647320694C7B676574206C656E6774682829';
wwv_flow_imp.g_varchar2_table(44653) := '7B72657475726E20746869732E766965772E73746174652E646F632E6C656E6774687D636F6E7374727563746F722865297B737570657228292C746869732E766965773D652C746869732E6465636F726174696F6E733D5B5D2C746869732E64796E616D';
wwv_flow_imp.g_varchar2_table(44654) := '69634465636F726174696F6E4D61703D5B21315D2C746869732E646F6D4368616E6765643D6E756C6C2C746869732E686173436F6D706F736974696F6E3D6E756C6C2C746869732E6D61726B6564466F72436F6D706F736974696F6E3D6E657720536574';
wwv_flow_imp.g_varchar2_table(44655) := '2C746869732E65646974436F6E74657874466F726D617474696E673D504C2E6E6F6E652C746869732E6C617374436F6D706F736974696F6E4166746572437572736F723D21312C746869732E6D696E57696474683D302C746869732E6D696E5769647468';
wwv_flow_imp.g_varchar2_table(44656) := '46726F6D3D302C746869732E6D696E5769647468546F3D302C746869732E696D70726563697365416E63686F723D6E756C6C2C746869732E696D70726563697365486561643D6E756C6C2C746869732E666F72636553656C656374696F6E3D21312C7468';
wwv_flow_imp.g_varchar2_table(44657) := '69732E6C6173745570646174653D446174652E6E6F7728292C746869732E736574444F4D28652E636F6E74656E74444F4D292C746869732E6368696C6472656E3D5B6E6577207A4C5D2C746869732E6368696C6472656E5B305D2E736574506172656E74';
wwv_flow_imp.g_varchar2_table(44658) := '2874686973292C746869732E7570646174654465636F28292C746869732E757064617465496E6E6572285B6E657720574428302C302C302C652E73746174652E646F632E6C656E677468295D2C302C6E756C6C297D7570646174652865297B7661722074';
wwv_flow_imp.g_varchar2_table(44659) := '3B6C6574206E3D652E6368616E67656452616E6765733B746869732E6D696E57696474683E3026266E2E6C656E6774682626286E2E65766572792828287B66726F6D413A652C746F413A747D293D3E743C746869732E6D696E576964746846726F6D7C7C';
wwv_flow_imp.g_varchar2_table(44660) := '653E746869732E6D696E5769647468546F29293F28746869732E6D696E576964746846726F6D3D652E6368616E6765732E6D6170506F7328746869732E6D696E576964746846726F6D2C31292C746869732E6D696E5769647468546F3D652E6368616E67';
wwv_flow_imp.g_varchar2_table(44661) := '65732E6D6170506F7328746869732E6D696E5769647468546F2C3129293A746869732E6D696E57696474683D746869732E6D696E576964746846726F6D3D746869732E6D696E5769647468546F3D30292C746869732E75706461746545646974436F6E74';
wwv_flow_imp.g_varchar2_table(44662) := '657874466F726D617474696E672865293B6C657420693D2D313B746869732E766965772E696E70757453746174652E636F6D706F73696E673E3D30262621746869732E766965772E6F627365727665722E65646974436F6E74657874262628286E756C6C';
wwv_flow_imp.g_varchar2_table(44663) := '3D3D3D28743D746869732E646F6D4368616E676564297C7C766F696420303D3D3D743F766F696420303A742E6E657753656C293F693D746869732E646F6D4368616E6765642E6E657753656C2E686561643A66756E6374696F6E28652C74297B6C657420';
wwv_flow_imp.g_varchar2_table(44664) := '6E3D21313B72657475726E20742626652E697465724368616E67656452616E676573282828652C69293D3E7B653C742E746F2626693E742E66726F6D2626286E3D2130297D29292C6E7D28652E6368616E6765732C746869732E686173436F6D706F7369';
wwv_flow_imp.g_varchar2_table(44665) := '74696F6E297C7C652E73656C656374696F6E5365747C7C28693D652E73746174652E73656C656374696F6E2E6D61696E2E6865616429293B6C6574206F3D693E2D313F66756E6374696F6E28652C742C6E297B6C657420693D244428652C6E293B696628';
wwv_flow_imp.g_varchar2_table(44666) := '21692972657475726E206E756C6C3B6C65747B6E6F64653A6F2C66726F6D3A732C746F3A727D3D692C613D6F2E6E6F646556616C75653B6966282F5B5C6E5C725D2F2E746573742861292972657475726E206E756C6C3B696628652E73746174652E646F';
wwv_flow_imp.g_varchar2_table(44667) := '632E736C696365537472696E6728692E66726F6D2C692E746F29213D612972657475726E206E756C6C3B6C6574206C3D742E696E766572746564446573632C633D6E6577205744286C2E6D6170506F732873292C6C2E6D6170506F732872292C732C7229';
wwv_flow_imp.g_varchar2_table(44668) := '2C643D5B5D3B666F72286C657420743D6F2E706172656E744E6F64653B3B743D742E706172656E744E6F6465297B6C6574206E3D694C2E6765742874293B6966286E20696E7374616E63656F6620774C29642E70757368287B6E6F64653A742C6465636F';
wwv_flow_imp.g_varchar2_table(44669) := '3A6E2E6D61726B7D293B656C73657B6966286E20696E7374616E63656F66207A4C7C7C22444956223D3D742E6E6F64654E616D652626742E706172656E744E6F64653D3D652E636F6E74656E74444F4D2972657475726E7B72616E67653A632C74657874';
wwv_flow_imp.g_varchar2_table(44670) := '3A6F2C6D61726B733A642C6C696E653A747D3B696628743D3D652E636F6E74656E74444F4D2972657475726E206E756C6C3B642E70757368287B6E6F64653A742C6465636F3A6E6577204F4C287B696E636C75736976653A21302C617474726962757465';
wwv_flow_imp.g_varchar2_table(44671) := '733A4D4C2874292C7461674E616D653A742E7461674E616D652E746F4C6F7765724361736528297D297D297D7D7D28746869732E766965772C652E6368616E6765732C69293A6E756C6C3B696628746869732E646F6D4368616E6765643D6E756C6C2C74';
wwv_flow_imp.g_varchar2_table(44672) := '6869732E686173436F6D706F736974696F6E297B746869732E6D61726B6564466F72436F6D706F736974696F6E2E636C65617228293B6C65747B66726F6D3A742C746F3A697D3D746869732E686173436F6D706F736974696F6E3B6E3D6E657720574428';
wwv_flow_imp.g_varchar2_table(44673) := '742C692C652E6368616E6765732E6D6170506F7328742C2D31292C652E6368616E6765732E6D6170506F7328692C3129292E616464546F536574286E2E736C6963652829297D746869732E686173436F6D706F736974696F6E3D6F3F7B66726F6D3A6F2E';
wwv_flow_imp.g_varchar2_table(44674) := '72616E67652E66726F6D422C746F3A6F2E72616E67652E746F427D3A6E756C6C2C285F4C2E69657C7C5F4C2E6368726F6D65292626216F2626652626652E73746174652E646F632E6C696E6573213D652E737461727453746174652E646F632E6C696E65';
wwv_flow_imp.g_varchar2_table(44675) := '73262628746869732E666F72636553656C656374696F6E3D2130293B6C657420733D66756E6374696F6E28652C742C6E297B6C657420693D6E65772055443B72657475726E206C452E636F6D7061726528652C742C6E2C69292C692E6368616E6765737D';
wwv_flow_imp.g_varchar2_table(44676) := '28746869732E6465636F726174696F6E732C746869732E7570646174654465636F28292C652E6368616E676573293B72657475726E206E3D57442E657874656E645769746852616E676573286E2C73292C2121283726746869732E666C6167737C7C3021';
wwv_flow_imp.g_varchar2_table(44677) := '3D6E2E6C656E67746829262628746869732E757064617465496E6E6572286E2C652E737461727453746174652E646F632E6C656E6774682C6F292C652E7472616E73616374696F6E732E6C656E677468262628746869732E6C6173745570646174653D44';
wwv_flow_imp.g_varchar2_table(44678) := '6174652E6E6F772829292C2130297D757064617465496E6E657228652C742C6E297B746869732E766965772E7669657753746174652E6D7573744D656173757265436F6E74656E743D21302C746869732E7570646174654368696C6472656E28652C742C';
wwv_flow_imp.g_varchar2_table(44679) := '6E293B6C65747B6F627365727665723A697D3D746869732E766965773B692E69676E6F7265282828293D3E7B746869732E646F6D2E7374796C652E6865696768743D746869732E766965772E7669657753746174652E636F6E74656E744865696768742F';
wwv_flow_imp.g_varchar2_table(44680) := '746869732E766965772E7363616C65592B227078222C746869732E646F6D2E7374796C652E666C657842617369733D746869732E6D696E57696474683F746869732E6D696E57696474682B227078223A22223B6C657420653D5F4C2E6368726F6D657C7C';
wwv_flow_imp.g_varchar2_table(44681) := '5F4C2E696F733F7B6E6F64653A692E73656C656374696F6E52616E67652E666F6375734E6F64652C7772697474656E3A21317D3A766F696420303B746869732E73796E6328746869732E766965772C65292C746869732E666C616773263D2D382C652626';
wwv_flow_imp.g_varchar2_table(44682) := '28652E7772697474656E7C7C692E73656C656374696F6E52616E67652E666F6375734E6F6465213D652E6E6F646529262628746869732E666F72636553656C656374696F6E3D2130292C746869732E646F6D2E7374796C652E6865696768743D22227D29';
wwv_flow_imp.g_varchar2_table(44683) := '292C746869732E6D61726B6564466F72436F6D706F736974696F6E2E666F72456163682828653D3E652E666C616773263D2D3929293B6C6574206F3D5B5D3B696628746869732E766965772E76696577706F72742E66726F6D7C7C746869732E76696577';
wwv_flow_imp.g_varchar2_table(44684) := '2E76696577706F72742E746F3C746869732E766965772E73746174652E646F632E6C656E67746829666F72286C65742065206F6620746869732E6368696C6472656E296520696E7374616E63656F6620484C2626652E77696467657420696E7374616E63';
wwv_flow_imp.g_varchar2_table(44685) := '656F6620574C26266F2E7075736828652E646F6D293B692E75706461746547617073286F297D7570646174654368696C6472656E28652C742C6E297B6C657420693D6E3F6E2E72616E67652E616464546F53657428652E736C6963652829293A652C6F3D';
wwv_flow_imp.g_varchar2_table(44686) := '746869732E6368696C64437572736F722874293B666F72286C657420653D692E6C656E6774682D313B3B652D2D297B6C657420743D653E3D303F695B655D3A6E756C6C3B696628217429627265616B3B6C657420732C722C612C6C2C7B66726F6D413A63';
wwv_flow_imp.g_varchar2_table(44687) := '2C746F413A642C66726F6D423A682C746F423A757D3D743B6966286E26266E2E72616E67652E66726F6D423C7526266E2E72616E67652E746F423E68297B6C657420653D6A4C2E6275696C6428746869732E766965772E73746174652E646F632C682C6E';
wwv_flow_imp.g_varchar2_table(44688) := '2E72616E67652E66726F6D422C746869732E6465636F726174696F6E732C746869732E64796E616D69634465636F726174696F6E4D6170292C743D6A4C2E6275696C6428746869732E766965772E73746174652E646F632C6E2E72616E67652E746F422C';
wwv_flow_imp.g_varchar2_table(44689) := '752C746869732E6465636F726174696F6E732C746869732E64796E616D69634465636F726174696F6E4D6170293B723D652E627265616B417453746172742C613D652E6F70656E53746172742C6C3D742E6F70656E456E643B6C657420693D746869732E';
wwv_flow_imp.g_varchar2_table(44690) := '636F6D706F736974696F6E56696577286E293B742E627265616B417453746172743F692E627265616B41667465723D313A742E636F6E74656E742E6C656E6774682626692E6D6572676528692E6C656E6774682C692E6C656E6774682C742E636F6E7465';
wwv_flow_imp.g_varchar2_table(44691) := '6E745B305D2C21312C742E6F70656E53746172742C3029262628692E627265616B41667465723D742E636F6E74656E745B305D2E627265616B41667465722C742E636F6E74656E742E73686966742829292C652E636F6E74656E742E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(44692) := '692E6D6572676528302C302C652E636F6E74656E745B652E636F6E74656E742E6C656E6774682D315D2C21302C302C652E6F70656E456E64292626652E636F6E74656E742E706F7028292C733D652E636F6E74656E742E636F6E6361742869292E636F6E';
wwv_flow_imp.g_varchar2_table(44693) := '63617428742E636F6E74656E74297D656C7365287B636F6E74656E743A732C627265616B417453746172743A722C6F70656E53746172743A612C6F70656E456E643A6C7D3D6A4C2E6275696C6428746869732E766965772E73746174652E646F632C682C';
wwv_flow_imp.g_varchar2_table(44694) := '752C746869732E6465636F726174696F6E732C746869732E64796E616D69634465636F726174696F6E4D617029293B6C65747B693A702C6F66663A677D3D6F2E66696E64506F7328642C31292C7B693A6D2C6F66663A667D3D6F2E66696E64506F732863';
wwv_flow_imp.g_varchar2_table(44695) := '2C2D31293B724C28746869732C6D2C662C702C672C732C722C612C6C297D6E2626746869732E666978436F6D706F736974696F6E444F4D286E297D75706461746545646974436F6E74657874466F726D617474696E672865297B746869732E6564697443';
wwv_flow_imp.g_varchar2_table(44696) := '6F6E74657874466F726D617474696E673D746869732E65646974436F6E74657874466F726D617474696E672E6D617028652E6368616E676573293B666F72286C65742074206F6620652E7472616E73616374696F6E7329666F72286C65742065206F6620';
wwv_flow_imp.g_varchar2_table(44697) := '742E6566666563747329652E6973286B4429262628746869732E65646974436F6E74657874466F726D617474696E673D652E76616C7565297D636F6D706F736974696F6E566965772865297B6C657420743D6E657720794C28652E746578742E6E6F6465';
wwv_flow_imp.g_varchar2_table(44698) := '56616C7565293B742E666C6167737C3D383B666F72286C65747B6465636F3A6E7D6F6620652E6D61726B7329743D6E657720774C286E2C5B745D2C742E6C656E677468293B6C6574206E3D6E6577207A4C3B72657475726E206E2E617070656E6428742C';
wwv_flow_imp.g_varchar2_table(44699) := '30292C6E7D666978436F6D706F736974696F6E444F4D2865297B6C657420743D28652C74293D3E7B742E666C6167737C3D387C28742E6368696C6472656E2E736F6D652828653D3E3726652E666C61677329293F313A30292C746869732E6D61726B6564';
wwv_flow_imp.g_varchar2_table(44700) := '466F72436F6D706F736974696F6E2E6164642874293B6C6574206E3D694C2E6765742865293B6E26266E213D742626286E2E646F6D3D6E756C6C292C742E736574444F4D2865297D2C6E3D746869732E6368696C64506F7328652E72616E67652E66726F';
wwv_flow_imp.g_varchar2_table(44701) := '6D422C31292C693D746869732E6368696C6472656E5B6E2E695D3B7428652E6C696E652C69293B666F72286C6574206F3D652E6D61726B732E6C656E6774682D313B6F3E3D2D313B6F2D2D296E3D692E6368696C64506F73286E2E6F66662C31292C693D';
wwv_flow_imp.g_varchar2_table(44702) := '692E6368696C6472656E5B6E2E695D2C74286F3E3D303F652E6D61726B735B6F5D2E6E6F64653A652E746578742C69297D75706461746553656C656374696F6E28653D21312C743D2131297B21652626746869732E766965772E6F627365727665722E73';
wwv_flow_imp.g_varchar2_table(44703) := '656C656374696F6E52616E67652E666F6375734E6F64657C7C746869732E766965772E6F627365727665722E7265616453656C656374696F6E52616E676528293B6C6574206E3D746869732E766965772E726F6F742E616374697665456C656D656E742C';
wwv_flow_imp.g_varchar2_table(44704) := '693D6E3D3D746869732E646F6D2C6F3D216926264F4528746869732E646F6D2C746869732E766965772E6F627365727665722E73656C656374696F6E52616E676529262621286E2626746869732E646F6D2E636F6E7461696E73286E29293B6966282128';
wwv_flow_imp.g_varchar2_table(44705) := '697C7C747C7C6F292972657475726E3B6C657420733D746869732E666F72636553656C656374696F6E3B746869732E666F72636553656C656374696F6E3D21313B6C657420723D746869732E766965772E73746174652E73656C656374696F6E2E6D6169';
wwv_flow_imp.g_varchar2_table(44706) := '6E2C613D746869732E6D6F7665546F4C696E6528746869732E646F6D4174506F7328722E616E63686F7229292C6C3D722E656D7074793F613A746869732E6D6F7665546F4C696E6528746869732E646F6D4174506F7328722E6865616429293B6966285F';
wwv_flow_imp.g_varchar2_table(44707) := '4C2E6765636B6F2626722E656D707479262621746869732E686173436F6D706F736974696F6E2626313D3D28633D61292E6E6F64652E6E6F6465547970652626632E6E6F64652E66697273744368696C64262628303D3D632E6F66667365747C7C226661';
wwv_flow_imp.g_varchar2_table(44708) := '6C7365223D3D632E6E6F64652E6368696C644E6F6465735B632E6F66667365742D315D2E636F6E74656E744564697461626C6529262628632E6F66667365743D3D632E6E6F64652E6368696C644E6F6465732E6C656E6774687C7C2266616C7365223D3D';
wwv_flow_imp.g_varchar2_table(44709) := '632E6E6F64652E6368696C644E6F6465735B632E6F66667365745D2E636F6E74656E744564697461626C6529297B6C657420653D646F63756D656E742E637265617465546578744E6F6465282222293B746869732E766965772E6F627365727665722E69';
wwv_flow_imp.g_varchar2_table(44710) := '676E6F7265282828293D3E612E6E6F64652E696E736572744265666F726528652C612E6E6F64652E6368696C644E6F6465735B612E6F66667365745D7C7C6E756C6C2929292C613D6C3D6E657720744C28652C30292C733D21307D76617220633B6C6574';
wwv_flow_imp.g_varchar2_table(44711) := '20643D746869732E766965772E6F627365727665722E73656C656374696F6E52616E67653B21732626642E666F6375734E6F6465262628464528612E6E6F64652C612E6F66667365742C642E616E63686F724E6F64652C642E616E63686F724F66667365';
wwv_flow_imp.g_varchar2_table(44712) := '742926264645286C2E6E6F64652C6C2E6F66667365742C642E666F6375734E6F64652C642E666F6375734F6666736574297C7C746869732E7375707072657373576964676574437572736F724368616E676528642C7229297C7C28746869732E76696577';
wwv_flow_imp.g_varchar2_table(44713) := '2E6F627365727665722E69676E6F7265282828293D3E7B5F4C2E616E64726F696426265F4C2E6368726F6D652626746869732E646F6D2E636F6E7461696E7328642E666F6375734E6F646529262666756E6374696F6E28652C74297B666F72286C657420';
wwv_flow_imp.g_varchar2_table(44714) := '6E3D653B6E26266E213D743B6E3D6E2E61737369676E6564536C6F747C7C6E2E706172656E744E6F646529696628313D3D6E2E6E6F64655479706526262266616C7365223D3D6E2E636F6E74656E744564697461626C652972657475726E21303B726574';
wwv_flow_imp.g_varchar2_table(44715) := '75726E21317D28642E666F6375734E6F64652C746869732E646F6D29262628746869732E646F6D2E626C757228292C746869732E646F6D2E666F637573287B70726576656E745363726F6C6C3A21307D29293B6C657420653D4E4528746869732E766965';
wwv_flow_imp.g_varchar2_table(44716) := '772E726F6F74293B6966286529696628722E656D707479297B6966285F4C2E6765636B6F297B6C657420653D66756E6374696F6E28652C74297B72657475726E2031213D652E6E6F6465547970653F303A287426262266616C7365223D3D652E6368696C';
wwv_flow_imp.g_varchar2_table(44717) := '644E6F6465735B742D315D2E636F6E74656E744564697461626C653F313A30297C28743C652E6368696C644E6F6465732E6C656E67746826262266616C7365223D3D652E6368696C644E6F6465735B745D2E636F6E74656E744564697461626C653F323A';
wwv_flow_imp.g_varchar2_table(44718) := '30297D28612E6E6F64652C612E6F6666736574293B69662865262633213D65297B6C657420743D28313D3D653F4A453A654C2928612E6E6F64652C612E6F6666736574293B74262628613D6E657720744C28742E6E6F64652C742E6F666673657429297D';
wwv_flow_imp.g_varchar2_table(44719) := '7D652E636F6C6C6170736528612E6E6F64652C612E6F6666736574292C6E756C6C213D722E626964694C6576656C2626766F69642030213D3D652E6361726574426964694C6576656C262628652E6361726574426964694C6576656C3D722E626964694C';
wwv_flow_imp.g_varchar2_table(44720) := '6576656C297D656C736520696628652E657874656E64297B652E636F6C6C6170736528612E6E6F64652C612E6F6666736574293B7472797B652E657874656E64286C2E6E6F64652C6C2E6F6666736574297D63617463682865297B7D7D656C73657B6C65';
wwv_flow_imp.g_varchar2_table(44721) := '7420743D646F63756D656E742E63726561746552616E676528293B722E616E63686F723E722E686561642626285B612C6C5D3D5B6C2C615D292C742E736574456E64286C2E6E6F64652C6C2E6F6666736574292C742E736574537461727428612E6E6F64';
wwv_flow_imp.g_varchar2_table(44722) := '652C612E6F6666736574292C652E72656D6F7665416C6C52616E67657328292C652E61646452616E67652874297D6F2626746869732E766965772E726F6F742E616374697665456C656D656E743D3D746869732E646F6D262628746869732E646F6D2E62';
wwv_flow_imp.g_varchar2_table(44723) := '6C757228292C6E26266E2E666F6375732829297D29292C746869732E766965772E6F627365727665722E73657453656C656374696F6E52616E676528612C6C29292C746869732E696D70726563697365416E63686F723D612E707265636973653F6E756C';
wwv_flow_imp.g_varchar2_table(44724) := '6C3A6E657720744C28642E616E63686F724E6F64652C642E616E63686F724F6666736574292C746869732E696D70726563697365486561643D6C2E707265636973653F6E756C6C3A6E657720744C28642E666F6375734E6F64652C642E666F6375734F66';
wwv_flow_imp.g_varchar2_table(44725) := '66736574297D7375707072657373576964676574437572736F724368616E676528652C74297B72657475726E20746869732E686173436F6D706F736974696F6E2626742E656D7074792626464528652E666F6375734E6F64652C652E666F6375734F6666';
wwv_flow_imp.g_varchar2_table(44726) := '7365742C652E616E63686F724E6F64652C652E616E63686F724F6666736574292626746869732E706F7346726F6D444F4D28652E666F6375734E6F64652C652E666F6375734F6666736574293D3D742E686561647D656E666F726365437572736F724173';
wwv_flow_imp.g_varchar2_table(44727) := '736F6328297B696628746869732E686173436F6D706F736974696F6E2972657475726E3B6C65747B766965773A657D3D746869732C743D652E73746174652E73656C656374696F6E2E6D61696E2C6E3D4E4528652E726F6F74292C7B616E63686F724E6F';
wwv_flow_imp.g_varchar2_table(44728) := '64653A692C616E63686F724F66667365743A6F7D3D652E6F627365727665722E73656C656374696F6E52616E67653B69662821286E2626742E656D7074792626742E6173736F6326266E2E6D6F64696679292972657475726E3B6C657420733D7A4C2E66';
wwv_flow_imp.g_varchar2_table(44729) := '696E6428746869732C742E68656164293B69662821732972657475726E3B6C657420723D732E706F73417453746172743B696628742E686561643D3D727C7C742E686561643D3D722B732E6C656E6774682972657475726E3B6C657420613D746869732E';
wwv_flow_imp.g_varchar2_table(44730) := '636F6F726473417428742E686561642C2D31292C6C3D746869732E636F6F726473417428742E686561642C31293B69662821617C7C216C7C7C612E626F74746F6D3E6C2E746F702972657475726E3B6C657420633D746869732E646F6D4174506F732874';
wwv_flow_imp.g_varchar2_table(44731) := '2E686561642B742E6173736F63293B6E2E636F6C6C6170736528632E6E6F64652C632E6F6666736574292C6E2E6D6F6469667928226D6F7665222C742E6173736F633C303F22666F7277617264223A226261636B77617264222C226C696E65626F756E64';
wwv_flow_imp.g_varchar2_table(44732) := '61727922292C652E6F627365727665722E7265616453656C656374696F6E52616E676528293B6C657420643D652E6F627365727665722E73656C656374696F6E52616E67653B652E646F63566965772E706F7346726F6D444F4D28642E616E63686F724E';
wwv_flow_imp.g_varchar2_table(44733) := '6F64652C642E616E63686F724F666673657429213D742E66726F6D26266E2E636F6C6C6170736528692C6F297D6D6F7665546F4C696E652865297B6C657420742C6E3D746869732E646F6D3B696628652E6E6F6465213D6E2972657475726E20653B666F';
wwv_flow_imp.g_varchar2_table(44734) := '72286C657420693D652E6F66667365743B21742626693C6E2E6368696C644E6F6465732E6C656E6774683B692B2B297B6C657420653D694C2E676574286E2E6368696C644E6F6465735B695D293B6520696E7374616E63656F66207A4C262628743D652E';
wwv_flow_imp.g_varchar2_table(44735) := '646F6D4174506F73283029297D666F72286C657420693D652E6F66667365742D313B21742626693E3D303B692D2D297B6C657420653D694C2E676574286E2E6368696C644E6F6465735B695D293B6520696E7374616E63656F66207A4C262628743D652E';
wwv_flow_imp.g_varchar2_table(44736) := '646F6D4174506F7328652E6C656E67746829297D72657475726E20743F6E657720744C28742E6E6F64652C742E6F66667365742C2130293A657D6E6561726573742865297B666F72286C657420743D653B743B297B6C657420653D694C2E676574287429';
wwv_flow_imp.g_varchar2_table(44737) := '3B696628652626652E726F6F74566965773D3D746869732972657475726E20653B743D742E706172656E744E6F64657D72657475726E206E756C6C7D706F7346726F6D444F4D28652C74297B6C6574206E3D746869732E6E6561726573742865293B6966';
wwv_flow_imp.g_varchar2_table(44738) := '28216E297468726F77206E65772052616E67654572726F722822547279696E6720746F2066696E6420706F736974696F6E20666F72206120444F4D20706F736974696F6E206F757473696465206F662074686520646F63756D656E7422293B7265747572';
wwv_flow_imp.g_varchar2_table(44739) := '6E206E2E6C6F63616C506F7346726F6D444F4D28652C74292B6E2E706F73417453746172747D646F6D4174506F732865297B6C65747B693A742C6F66663A6E7D3D746869732E6368696C64437572736F7228292E66696E64506F7328652C2D31293B666F';
wwv_flow_imp.g_varchar2_table(44740) := '72283B743C746869732E6368696C6472656E2E6C656E6774682D313B297B6C657420653D746869732E6368696C6472656E5B745D3B6966286E3C652E6C656E6774687C7C6520696E7374616E63656F66207A4C29627265616B3B742B2B2C6E3D307D7265';
wwv_flow_imp.g_varchar2_table(44741) := '7475726E20746869732E6368696C6472656E5B745D2E646F6D4174506F73286E297D636F6F726473417428652C74297B6C6574206E3D6E756C6C2C693D303B666F72286C6574206F3D746869732E6C656E6774682C733D746869732E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(44742) := '2E6C656E6774682D313B733E3D303B732D2D297B6C657420723D746869732E6368696C6472656E5B735D2C613D6F2D722E627265616B41667465722C6C3D612D722E6C656E6774683B696628613C6529627265616B3B6966286C3C3D652626286C3C657C';
wwv_flow_imp.g_varchar2_table(44743) := '7C722E636F76657273282D312929262628613E657C7C722E636F7665727328312929262628216E7C7C7220696E7374616E63656F66207A4C262621286E20696E7374616E63656F66207A4C2626743E3D302929296E3D722C693D6C3B656C736520696628';
wwv_flow_imp.g_varchar2_table(44744) := '6E26266C3D3D652626613D3D6526267220696E7374616E63656F6620484C26264D6174682E6162732874293C32297B696628722E6465636F2E7374617274536964653C3029627265616B3B732626286E3D6E756C6C297D6F3D6C7D72657475726E206E3F';
wwv_flow_imp.g_varchar2_table(44745) := '6E2E636F6F726473417428652D692C74293A6E756C6C7D636F6F726473466F72436861722865297B6C65747B693A742C6F66663A6E7D3D746869732E6368696C64506F7328652C31292C693D746869732E6368696C6472656E5B745D3B69662821286920';
wwv_flow_imp.g_varchar2_table(44746) := '696E7374616E63656F66207A4C292972657475726E206E756C6C3B666F72283B692E6368696C6472656E2E6C656E6774683B297B6C65747B693A652C6F66663A747D3D692E6368696C64506F73286E2C31293B666F72283B3B652B2B297B696628653D3D';
wwv_flow_imp.g_varchar2_table(44747) := '692E6368696C6472656E2E6C656E6774682972657475726E206E756C6C3B69662828693D692E6368696C6472656E5B655D292E6C656E67746829627265616B7D6E3D747D69662821286920696E7374616E63656F6620794C292972657475726E206E756C';
wwv_flow_imp.g_varchar2_table(44748) := '6C3B6C6574206F3D5A7828692E746578742C6E293B6966286F3D3D6E2972657475726E206E756C6C3B6C657420733D514528692E646F6D2C6E2C6F292E676574436C69656E74526563747328293B666F72286C657420653D303B653C732E6C656E677468';
wwv_flow_imp.g_varchar2_table(44749) := '3B652B2B297B6C657420743D735B655D3B696628653D3D732E6C656E6774682D317C7C742E746F703C742E626F74746F6D2626742E6C6566743C742E72696768742972657475726E20747D72657475726E206E756C6C7D6D65617375726556697369626C';
wwv_flow_imp.g_varchar2_table(44750) := '654C696E65486569676874732865297B6C657420743D5B5D2C7B66726F6D3A6E2C746F3A697D3D652C6F3D746869732E766965772E636F6E74656E74444F4D2E636C69656E7457696474682C733D6F3E4D6174682E6D617828746869732E766965772E73';
wwv_flow_imp.g_varchar2_table(44751) := '63726F6C6C444F4D2E636C69656E7457696474682C746869732E6D696E5769647468292B312C723D2D312C613D746869732E766965772E74657874446972656374696F6E3D3D554C2E4C54523B666F72286C657420653D302C6C3D303B6C3C746869732E';
wwv_flow_imp.g_varchar2_table(44752) := '6368696C6472656E2E6C656E6774683B6C2B2B297B6C657420633D746869732E6368696C6472656E5B6C5D2C643D652B632E6C656E6774683B696628643E6929627265616B3B696628653E3D6E297B6C6574206E3D632E646F6D2E676574426F756E6469';
wwv_flow_imp.g_varchar2_table(44753) := '6E67436C69656E745265637428293B696628742E70757368286E2E686569676874292C73297B6C657420743D632E646F6D2E6C6173744368696C642C693D743F52452874293A5B5D3B696628692E6C656E677468297B6C657420743D695B692E6C656E67';
wwv_flow_imp.g_varchar2_table(44754) := '74682D315D2C733D613F742E72696768742D6E2E6C6566743A6E2E72696768742D742E6C6566743B733E72262628723D732C746869732E6D696E57696474683D6F2C746869732E6D696E576964746846726F6D3D652C746869732E6D696E576964746854';
wwv_flow_imp.g_varchar2_table(44755) := '6F3D64297D7D7D653D642B632E627265616B41667465727D72657475726E20747D74657874446972656374696F6E41742865297B6C65747B693A747D3D746869732E6368696C64506F7328652C31293B72657475726E2272746C223D3D676574436F6D70';
wwv_flow_imp.g_varchar2_table(44756) := '757465645374796C6528746869732E6368696C6472656E5B745D2E646F6D292E646972656374696F6E3F554C2E52544C3A554C2E4C54527D6D6561737572655465787453697A6528297B666F72286C65742065206F6620746869732E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(44757) := '296966286520696E7374616E63656F66207A4C297B6C657420743D652E6D6561737572655465787453697A6528293B696628742972657475726E20747D6C657420652C742C6E2C693D646F63756D656E742E637265617465456C656D656E742822646976';
wwv_flow_imp.g_varchar2_table(44758) := '22293B72657475726E20692E636C6173734E616D653D22636D2D6C696E65222C692E7374796C652E77696474683D2239393939397078222C692E7374796C652E706F736974696F6E3D226162736F6C757465222C692E74657874436F6E74656E743D2261';
wwv_flow_imp.g_varchar2_table(44759) := '62632064656620676869206A6B6C206D6E6F2070717220737475222C746869732E766965772E6F627365727665722E69676E6F7265282828293D3E7B746869732E646F6D2E617070656E644368696C642869293B6C6574206F3D524528692E6669727374';
wwv_flow_imp.g_varchar2_table(44760) := '4368696C64295B305D3B653D692E676574426F756E64696E67436C69656E745265637428292E6865696768742C743D6F3F6F2E77696474682F32373A372C6E3D6F3F6F2E6865696768743A652C692E72656D6F766528297D29292C7B6C696E6548656967';
wwv_flow_imp.g_varchar2_table(44761) := '68743A652C6368617257696474683A742C746578744865696768743A6E7D7D6368696C64437572736F7228653D746869732E6C656E677468297B6C657420743D746869732E6368696C6472656E2E6C656E6774683B72657475726E2074262628652D3D74';
wwv_flow_imp.g_varchar2_table(44762) := '6869732E6368696C6472656E5B2D2D745D2E6C656E677468292C6E657720734C28746869732E6368696C6472656E2C652C74297D636F6D70757465426C6F636B4761704465636F28297B6C657420653D5B5D2C743D746869732E766965772E7669657753';
wwv_flow_imp.g_varchar2_table(44763) := '746174653B666F72286C6574206E3D302C693D303B3B692B2B297B6C6574206F3D693D3D742E76696577706F7274732E6C656E6774683F6E756C6C3A742E76696577706F7274735B695D2C733D6F3F6F2E66726F6D2D313A746869732E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(44764) := '696628733E6E297B6C657420693D28742E6C696E65426C6F636B41742873292E626F74746F6D2D742E6C696E65426C6F636B4174286E292E746F70292F746869732E766965772E7363616C65593B652E7075736828504C2E7265706C616365287B776964';
wwv_flow_imp.g_varchar2_table(44765) := '6765743A6E657720574C2869292C626C6F636B3A21302C696E636C75736976653A21302C6973426C6F636B4761703A21307D292E72616E6765286E2C7329297D696628216F29627265616B3B6E3D6F2E746F2B317D72657475726E20504C2E7365742865';
wwv_flow_imp.g_varchar2_table(44766) := '297D7570646174654465636F28297B6C657420653D312C743D746869732E766965772E73746174652E6661636574285044292E6D61702828743D3E28746869732E64796E616D69634465636F726174696F6E4D61705B652B2B5D3D2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(44767) := '223D3D747970656F662074293F7428746869732E76696577293A7429292C6E3D21312C693D746869732E766965772E73746174652E6661636574284F44292E6D6170282828652C74293D3E7B6C657420693D2266756E6374696F6E223D3D747970656F66';
wwv_flow_imp.g_varchar2_table(44768) := '20653B72657475726E20692626286E3D2130292C693F6528746869732E76696577293A657D29293B666F7228692E6C656E677468262628746869732E64796E616D69634465636F726174696F6E4D61705B652B2B5D3D6E2C742E70757368286C452E6A6F';
wwv_flow_imp.g_varchar2_table(44769) := '696E28692929292C746869732E6465636F726174696F6E733D5B746869732E65646974436F6E74657874466F726D617474696E672C2E2E2E742C746869732E636F6D70757465426C6F636B4761704465636F28292C746869732E766965772E7669657753';
wwv_flow_imp.g_varchar2_table(44770) := '746174652E6C696E654761704465636F5D3B653C746869732E6465636F726174696F6E732E6C656E6774683B29746869732E64796E616D69634465636F726174696F6E4D61705B652B2B5D3D21313B72657475726E20746869732E6465636F726174696F';
wwv_flow_imp.g_varchar2_table(44771) := '6E737D7363726F6C6C496E746F566965772865297B696628652E6973536E617073686F74297B6C657420743D746869732E766965772E7669657753746174652E6C696E65426C6F636B417428652E72616E67652E68656164293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(44772) := '732E766965772E7363726F6C6C444F4D2E7363726F6C6C546F703D742E746F702D652E794D617267696E2C766F696428746869732E766965772E7363726F6C6C444F4D2E7363726F6C6C4C6566743D652E784D617267696E297D666F72286C6574207420';
wwv_flow_imp.g_varchar2_table(44773) := '6F6620746869732E766965772E73746174652E666163657428434429297472797B6966287428746869732E766965772C652E72616E67652C65292972657475726E21307D63617463682865297B454428746869732E766965772E73746174652C652C2273';
wwv_flow_imp.g_varchar2_table(44774) := '63726F6C6C2068616E646C657222297D6C657420742C7B72616E67653A6E7D3D652C693D746869732E636F6F7264734174286E2E686561642C6E2E656D7074793F6E2E6173736F633A6E2E686561643E6E2E616E63686F723F2D313A31293B6966282169';
wwv_flow_imp.g_varchar2_table(44775) := '2972657475726E3B216E2E656D707479262628743D746869732E636F6F7264734174286E2E616E63686F722C6E2E616E63686F723E6E2E686561643F2D313A312929262628693D7B6C6566743A4D6174682E6D696E28692E6C6566742C742E6C65667429';
wwv_flow_imp.g_varchar2_table(44776) := '2C746F703A4D6174682E6D696E28692E746F702C742E746F70292C72696768743A4D6174682E6D617828692E72696768742C742E7269676874292C626F74746F6D3A4D6174682E6D617828692E626F74746F6D2C742E626F74746F6D297D293B6C657420';
wwv_flow_imp.g_varchar2_table(44777) := '6F3D7A4428746869732E76696577292C733D7B6C6566743A692E6C6566742D6F2E6C6566742C746F703A692E746F702D6F2E746F702C72696768743A692E72696768742B6F2E72696768742C626F74746F6D3A692E626F74746F6D2B6F2E626F74746F6D';
wwv_flow_imp.g_varchar2_table(44778) := '7D2C7B6F666673657457696474683A722C6F66667365744865696768743A617D3D746869732E766965772E7363726F6C6C444F4D3B2166756E6374696F6E28652C742C6E2C692C6F2C732C722C61297B6C6574206C3D652E6F776E6572446F63756D656E';
wwv_flow_imp.g_varchar2_table(44779) := '742C633D6C2E64656661756C74566965777C7C77696E646F773B666F72286C657420643D652C683D21313B64262621683B29696628313D3D642E6E6F646554797065297B6C657420652C753D643D3D6C2E626F64792C703D312C673D313B696628752965';
wwv_flow_imp.g_varchar2_table(44780) := '3D6A452863293B656C73657B6966282F5E2866697865647C737469636B7929242F2E7465737428676574436F6D70757465645374796C652864292E706F736974696F6E29262628683D2130292C642E7363726F6C6C4865696768743C3D642E636C69656E';
wwv_flow_imp.g_varchar2_table(44781) := '744865696768742626642E7363726F6C6C57696474683C3D642E636C69656E745769647468297B643D642E61737369676E6564536C6F747C7C642E706172656E744E6F64653B636F6E74696E75657D6C657420743D642E676574426F756E64696E67436C';
wwv_flow_imp.g_varchar2_table(44782) := '69656E745265637428293B287B7363616C65583A702C7363616C65593A677D3D714528642C7429292C653D7B6C6566743A742E6C6566742C72696768743A742E6C6566742B642E636C69656E7457696474682A702C746F703A742E746F702C626F74746F';
wwv_flow_imp.g_varchar2_table(44783) := '6D3A742E746F702B642E636C69656E744865696768742A677D7D6C6574206D3D302C663D303B696628226E656172657374223D3D6F29742E746F703C652E746F703F28663D2D28652E746F702D742E746F702B72292C6E3E302626742E626F74746F6D3E';
wwv_flow_imp.g_varchar2_table(44784) := '652E626F74746F6D2B66262628663D742E626F74746F6D2D652E626F74746F6D2B662B7229293A742E626F74746F6D3E652E626F74746F6D262628663D742E626F74746F6D2D652E626F74746F6D2B722C6E3C302626742E746F702D663C652E746F7026';
wwv_flow_imp.g_varchar2_table(44785) := '2628663D2D28652E746F702B662D742E746F702B722929293B656C73657B6C657420693D742E626F74746F6D2D742E746F702C733D652E626F74746F6D2D652E746F703B663D282263656E746572223D3D6F2626693C3D733F742E746F702B692F322D73';
wwv_flow_imp.g_varchar2_table(44786) := '2F323A227374617274223D3D6F7C7C2263656E746572223D3D6F26266E3C303F742E746F702D723A742E626F74746F6D2D732B72292D652E746F707D696628226E656172657374223D3D693F742E6C6566743C652E6C6566743F286D3D2D28652E6C6566';
wwv_flow_imp.g_varchar2_table(44787) := '742D742E6C6566742B73292C6E3E302626742E72696768743E652E72696768742B6D2626286D3D742E72696768742D652E72696768742B6D2B7329293A742E72696768743E652E72696768742626286D3D742E72696768742D652E72696768742B732C6E';
wwv_flow_imp.g_varchar2_table(44788) := '3C302626742E6C6566743C652E6C6566742B6D2626286D3D2D28652E6C6566742B6D2D742E6C6566742B732929293A6D3D282263656E746572223D3D693F742E6C6566742B28742E72696768742D742E6C656674292F322D28652E72696768742D652E6C';
wwv_flow_imp.g_varchar2_table(44789) := '656674292F323A227374617274223D3D693D3D613F742E6C6566742D733A742E72696768742D28652E72696768742D652E6C656674292B73292D652E6C6566742C6D7C7C66296966287529632E7363726F6C6C4279286D2C66293B656C73657B6C657420';
wwv_flow_imp.g_varchar2_table(44790) := '653D302C6E3D303B69662866297B6C657420653D642E7363726F6C6C546F703B642E7363726F6C6C546F702B3D662F672C6E3D28642E7363726F6C6C546F702D65292A677D6966286D297B6C657420743D642E7363726F6C6C4C6566743B642E7363726F';
wwv_flow_imp.g_varchar2_table(44791) := '6C6C4C6566742B3D6D2F702C653D28642E7363726F6C6C4C6566742D74292A707D743D7B6C6566743A742E6C6566742D652C746F703A742E746F702D6E2C72696768743A742E72696768742D652C626F74746F6D3A742E626F74746F6D2D6E7D2C652626';
wwv_flow_imp.g_varchar2_table(44792) := '4D6174682E61627328652D6D293C31262628693D226E65617265737422292C6E26264D6174682E616273286E2D66293C312626286F3D226E65617265737422297D6966287529627265616B3B643D642E61737369676E6564536C6F747C7C642E70617265';
wwv_flow_imp.g_varchar2_table(44793) := '6E744E6F64657D656C73657B6966283131213D642E6E6F64655479706529627265616B3B643D642E686F73747D7D28746869732E766965772E7363726F6C6C444F4D2C732C6E2E686561643C6E2E616E63686F723F2D313A312C652E782C652E792C4D61';
wwv_flow_imp.g_varchar2_table(44794) := '74682E6D6178284D6174682E6D696E28652E784D617267696E2C72292C2D72292C4D6174682E6D6178284D6174682E6D696E28652E794D617267696E2C61292C2D61292C746869732E766965772E74657874446972656374696F6E3D3D554C2E4C545229';
wwv_flow_imp.g_varchar2_table(44795) := '7D7D66756E6374696F6E20244428652C74297B6C6574206E3D652E6F627365727665722E73656C656374696F6E52616E67653B696628216E2E666F6375734E6F64652972657475726E206E756C6C3B6C657420693D4A45286E2E666F6375734E6F64652C';
wwv_flow_imp.g_varchar2_table(44796) := '6E2E666F6375734F6666736574292C6F3D654C286E2E666F6375734E6F64652C6E2E666F6375734F6666736574292C733D697C7C6F3B6966286F26266926266F2E6E6F6465213D692E6E6F6465297B6C657420743D694C2E676574286F2E6E6F6465293B';
wwv_flow_imp.g_varchar2_table(44797) := '69662821747C7C7420696E7374616E63656F6620794C2626742E74657874213D6F2E6E6F64652E6E6F646556616C756529733D6F3B656C736520696628652E646F63566965772E6C617374436F6D706F736974696F6E4166746572437572736F72297B6C';
wwv_flow_imp.g_varchar2_table(44798) := '657420653D694C2E67657428692E6E6F6465293B21657C7C6520696E7374616E63656F6620794C2626652E74657874213D692E6E6F64652E6E6F646556616C75657C7C28733D6F297D7D696628652E646F63566965772E6C617374436F6D706F73697469';
wwv_flow_imp.g_varchar2_table(44799) := '6F6E4166746572437572736F723D73213D692C21732972657475726E206E756C6C3B6C657420723D742D732E6F66667365743B72657475726E7B66726F6D3A722C746F3A722B732E6E6F64652E6E6F646556616C75652E6C656E6774682C6E6F64653A73';
wwv_flow_imp.g_varchar2_table(44800) := '2E6E6F64657D7D6C65742055443D636C6173737B636F6E7374727563746F7228297B746869732E6368616E6765733D5B5D7D636F6D7061726552616E676528652C74297B564C28652C742C746869732E6368616E676573297D636F6D70617265506F696E';
wwv_flow_imp.g_varchar2_table(44801) := '7428652C74297B564C28652C742C746869732E6368616E676573297D7D3B66756E6374696F6E204B4428652C74297B72657475726E20742E6C6566743E653F742E6C6566742D653A4D6174682E6D617828302C652D742E7269676874297D66756E637469';
wwv_flow_imp.g_varchar2_table(44802) := '6F6E20474428652C74297B72657475726E20742E746F703E653F742E746F702D653A4D6174682E6D617828302C652D742E626F74746F6D297D66756E6374696F6E20514428652C74297B72657475726E20652E746F703C742E626F74746F6D2D31262665';
wwv_flow_imp.g_varchar2_table(44803) := '2E626F74746F6D3E742E746F702B317D66756E6374696F6E20594428652C74297B72657475726E20743C652E746F703F7B746F703A742C6C6566743A652E6C6566742C72696768743A652E72696768742C626F74746F6D3A652E626F74746F6D7D3A657D';
wwv_flow_imp.g_varchar2_table(44804) := '66756E6374696F6E205A4428652C74297B72657475726E20743E652E626F74746F6D3F7B746F703A652E746F702C6C6566743A652E6C6566742C72696768743A652E72696768742C626F74746F6D3A747D3A657D66756E6374696F6E20584428652C742C';
wwv_flow_imp.g_varchar2_table(44805) := '6E297B6C657420692C6F2C732C722C612C6C2C632C642C683D21313B666F72286C657420753D652E66697273744368696C643B753B753D752E6E6578745369626C696E67297B6C657420653D52452875293B666F72286C657420703D303B703C652E6C65';
wwv_flow_imp.g_varchar2_table(44806) := '6E6774683B702B2B297B6C657420673D655B705D3B6F26265144286F2C6729262628673D5944285A4428672C6F2E626F74746F6D292C6F2E746F7029293B6C6574206D3D4B4428742C67292C663D4744286E2C67293B696628303D3D6D2626303D3D6629';
wwv_flow_imp.g_varchar2_table(44807) := '72657475726E20333D3D752E6E6F6465547970653F4A4428752C742C6E293A584428752C742C6E293B69662821697C7C723E667C7C723D3D662626733E6D297B693D752C6F3D672C733D6D2C723D663B6C657420613D663F6E3C672E746F703F2D313A31';
wwv_flow_imp.g_varchar2_table(44808) := '3A6D3F743C672E6C6566743F2D313A313A303B683D21617C7C28613E303F703C652E6C656E6774682D313A703E30297D303D3D6D3F6E3E672E626F74746F6D26262821637C7C632E626F74746F6D3C672E626F74746F6D293F28613D752C633D67293A6E';
wwv_flow_imp.g_varchar2_table(44809) := '3C672E746F7026262821647C7C642E746F703E672E746F70292626286C3D752C643D67293A632626514428632C67293F633D5A4428632C672E626F74746F6D293A642626514428642C6729262628643D594428642C672E746F7029297D7D696628632626';
wwv_flow_imp.g_varchar2_table(44810) := '632E626F74746F6D3E3D6E3F28693D612C6F3D63293A642626642E746F703C3D6E262628693D6C2C6F3D64292C21692972657475726E7B6E6F64653A652C6F66667365743A307D3B6C657420753D4D6174682E6D6178286F2E6C6566742C4D6174682E6D';
wwv_flow_imp.g_varchar2_table(44811) := '696E286F2E72696768742C7429293B72657475726E20333D3D692E6E6F6465547970653F4A4428692C752C6E293A6826262266616C736522213D692E636F6E74656E744564697461626C653F584428692C752C6E293A7B6E6F64653A652C6F6666736574';
wwv_flow_imp.g_varchar2_table(44812) := '3A41727261792E70726F746F747970652E696E6465784F662E63616C6C28652E6368696C644E6F6465732C69292B28743E3D286F2E6C6566742B6F2E7269676874292F323F313A30297D7D66756E6374696F6E204A4428652C742C6E297B6C657420693D';
wwv_flow_imp.g_varchar2_table(44813) := '652E6E6F646556616C75652E6C656E6774682C6F3D2D312C733D3165392C723D303B666F72286C657420613D303B613C693B612B2B297B6C657420693D514528652C612C612B31292E676574436C69656E74526563747328293B666F72286C6574206C3D';
wwv_flow_imp.g_varchar2_table(44814) := '303B6C3C692E6C656E6774683B6C2B2B297B6C657420633D695B6C5D3B696628632E746F703D3D632E626F74746F6D29636F6E74696E75653B727C7C28723D742D632E6C656674293B6C657420643D28632E746F703E6E3F632E746F702D6E3A6E2D632E';
wwv_flow_imp.g_varchar2_table(44815) := '626F74746F6D292D313B696628632E6C6566742D313C3D742626632E72696768742B313E3D742626643C73297B6C6574206E3D743E3D28632E6C6566742B632E7269676874292F322C693D6E3B696628285F4C2E6368726F6D657C7C5F4C2E6765636B6F';
wwv_flow_imp.g_varchar2_table(44816) := '292626514528652C61292E676574426F756E64696E67436C69656E745265637428292E6C6566743D3D632E7269676874262628693D216E292C643C3D302972657475726E7B6E6F64653A652C6F66667365743A612B28693F313A30297D3B6F3D612B2869';
wwv_flow_imp.g_varchar2_table(44817) := '3F313A30292C733D647D7D7D72657475726E7B6E6F64653A652C6F66667365743A6F3E2D313F6F3A723E303F652E6E6F646556616C75652E6C656E6774683A307D7D66756E6374696F6E20655428652C742C6E2C693D2D31297B766172206F2C733B6C65';
wwv_flow_imp.g_varchar2_table(44818) := '7420722C613D652E636F6E74656E74444F4D2E676574426F756E64696E67436C69656E745265637428292C6C3D612E746F702B652E7669657753746174652E70616464696E67546F702C7B646F634865696768743A637D3D652E7669657753746174652C';
wwv_flow_imp.g_varchar2_table(44819) := '7B783A642C793A687D3D742C753D682D6C3B696628753C302972657475726E20303B696628753E632972657475726E20652E73746174652E646F632E6C656E6774683B666F72286C657420743D652E7669657753746174652E6865696768744F7261636C';
wwv_flow_imp.g_varchar2_table(44820) := '652E746578744865696768742F322C6F3D21313B723D652E656C656D656E7441744865696768742875292C722E74797065213D4E4C2E546578743B29666F72283B753D693E303F722E626F74746F6D2B743A722E746F702D742C2128753E3D302626753C';
wwv_flow_imp.g_varchar2_table(44821) := '3D63293B297B6966286F2972657475726E206E3F6E756C6C3A303B6F3D21302C693D2D697D683D6C2B753B6C657420703D722E66726F6D3B696628703C652E76696577706F72742E66726F6D2972657475726E20303D3D652E76696577706F72742E6672';
wwv_flow_imp.g_varchar2_table(44822) := '6F6D3F303A6E3F6E756C6C3A745428652C612C722C642C68293B696628703E652E76696577706F72742E746F2972657475726E20652E76696577706F72742E746F3D3D652E73746174652E646F632E6C656E6774683F652E73746174652E646F632E6C65';
wwv_flow_imp.g_varchar2_table(44823) := '6E6774683A6E3F6E756C6C3A745428652C612C722C642C68293B6C657420673D652E646F6D2E6F776E6572446F63756D656E742C6D3D652E726F6F742E656C656D656E7446726F6D506F696E743F652E726F6F743A672C663D6D2E656C656D656E744672';
wwv_flow_imp.g_varchar2_table(44824) := '6F6D506F696E7428642C68293B66262621652E636F6E74656E74444F4D2E636F6E7461696E73286629262628663D6E756C6C292C667C7C28643D4D6174682E6D617828612E6C6566742B312C4D6174682E6D696E28612E72696768742D312C6429292C66';
wwv_flow_imp.g_varchar2_table(44825) := '3D6D2E656C656D656E7446726F6D506F696E7428642C68292C66262621652E636F6E74656E74444F4D2E636F6E7461696E73286629262628663D6E756C6C29293B6C657420762C623D2D313B69662866262630213D286E756C6C3D3D3D286F3D652E646F';
wwv_flow_imp.g_varchar2_table(44826) := '63566965772E6E656172657374286629297C7C766F696420303D3D3D6F3F766F696420303A6F2E69734564697461626C652929696628672E6361726574506F736974696F6E46726F6D506F696E74297B6C657420653D672E6361726574506F736974696F';
wwv_flow_imp.g_varchar2_table(44827) := '6E46726F6D506F696E7428642C68293B652626287B6F66667365744E6F64653A762C6F66667365743A627D3D65297D656C736520696628672E636172657452616E676546726F6D506F696E74297B6C657420743D672E636172657452616E676546726F6D';
wwv_flow_imp.g_varchar2_table(44828) := '506F696E7428642C68293B74262628287B7374617274436F6E7461696E65723A762C73746172744F66667365743A627D3D74292C2821652E636F6E74656E74444F4D2E636F6E7461696E732876297C7C5F4C2E736166617269262666756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(44829) := '652C742C6E297B6C657420693B69662833213D652E6E6F6465547970657C7C74213D28693D652E6E6F646556616C75652E6C656E677468292972657475726E21313B666F72286C657420743D652E6E6578745369626C696E673B743B743D742E6E657874';
wwv_flow_imp.g_varchar2_table(44830) := '5369626C696E672969662831213D742E6E6F6465547970657C7C22425222213D742E6E6F64654E616D652972657475726E21313B72657475726E20514528652C692D312C69292E676574426F756E64696E67436C69656E745265637428292E6C6566743E';
wwv_flow_imp.g_varchar2_table(44831) := '6E7D28762C622C64297C7C5F4C2E6368726F6D65262666756E6374696F6E28652C742C6E297B69662830213D742972657475726E21313B666F72286C657420743D653B3B297B6C657420653D742E706172656E744E6F64653B69662821657C7C31213D65';
wwv_flow_imp.g_varchar2_table(44832) := '2E6E6F6465547970657C7C652E66697273744368696C64213D742972657475726E21313B696628652E636C6173734C6973742E636F6E7461696E732822636D2D6C696E65222929627265616B3B743D657D72657475726E206E2D28313D3D652E6E6F6465';
wwv_flow_imp.g_varchar2_table(44833) := '547970653F652E676574426F756E64696E67436C69656E745265637428293A514528652C302C4D6174682E6D617828652E6E6F646556616C75652E6C656E6774682C3129292E676574426F756E64696E67436C69656E74526563742829292E6C6566743E';
wwv_flow_imp.g_varchar2_table(44834) := '357D28762C622C642929262628763D766F6964203029297D69662821767C7C21652E646F63566965772E646F6D2E636F6E7461696E73287629297B6C657420743D7A4C2E66696E6428652E646F63566965772C70293B69662821742972657475726E2075';
wwv_flow_imp.g_varchar2_table(44835) := '3E722E746F702B722E6865696768742F323F722E746F3A722E66726F6D3B287B6E6F64653A762C6F66667365743A627D3D584428742E646F6D2C642C6829297D6C6574205F3D652E646F63566965772E6E6561726573742876293B696628215F29726574';
wwv_flow_imp.g_varchar2_table(44836) := '75726E206E756C6C3B6966285F2E69735769646765742626313D3D286E756C6C3D3D3D28733D5F2E646F6D297C7C766F696420303D3D3D733F766F696420303A732E6E6F64655479706529297B6C657420653D5F2E646F6D2E676574426F756E64696E67';
wwv_flow_imp.g_varchar2_table(44837) := '436C69656E745265637428293B72657475726E20742E793C652E746F707C7C742E793C3D652E626F74746F6D2626742E783C3D28652E6C6566742B652E7269676874292F323F5F2E706F73417453746172743A5F2E706F734174456E647D72657475726E';
wwv_flow_imp.g_varchar2_table(44838) := '205F2E6C6F63616C506F7346726F6D444F4D28762C62292B5F2E706F73417453746172747D66756E6374696F6E20745428652C742C6E2C692C6F297B6C657420733D4D6174682E726F756E642828692D742E6C656674292A652E64656661756C74436861';
wwv_flow_imp.g_varchar2_table(44839) := '7261637465725769647468293B696628652E6C696E655772617070696E6726266E2E6865696768743E312E352A652E64656661756C744C696E65486569676874297B6C657420743D652E7669657753746174652E6865696768744F7261636C652E746578';
wwv_flow_imp.g_varchar2_table(44840) := '744865696768743B732B3D4D6174682E666C6F6F7228286F2D6E2E746F702D2E352A28652E64656661756C744C696E654865696768742D7429292F74292A652E7669657753746174652E6865696768744F7261636C652E6C696E654C656E6774687D6C65';
wwv_flow_imp.g_varchar2_table(44841) := '7420723D652E73746174652E736C696365446F63286E2E66726F6D2C6E2E746F293B72657475726E206E2E66726F6D2B66756E6374696F6E28652C742C6E297B666F72286C657420693D302C6F3D303B3B297B6966286F3E3D742972657475726E20693B';
wwv_flow_imp.g_varchar2_table(44842) := '696628693D3D652E6C656E67746829627265616B3B6F2B3D393D3D652E63686172436F646541742869293F6E2D6F256E3A312C693D5A7828652C69297D72657475726E20652E6C656E6774687D28722C732C652E73746174652E74616253697A65297D66';
wwv_flow_imp.g_varchar2_table(44843) := '756E6374696F6E206E5428652C742C6E2C69297B6C6574206F3D652E73746174652E646F632E6C696E65417428742E68656164292C733D652E626964695370616E73286F292C723D652E74657874446972656374696F6E4174286F2E66726F6D293B666F';
wwv_flow_imp.g_varchar2_table(44844) := '72286C657420613D742C6C3D6E756C6C3B3B297B6C657420743D6344286F2C732C722C612C6E292C633D6C443B6966282174297B6966286F2E6E756D6265723D3D286E3F652E73746174652E646F632E6C696E65733A31292972657475726E20613B633D';
wwv_flow_imp.g_varchar2_table(44845) := '225C6E222C6F3D652E73746174652E646F632E6C696E65286F2E6E756D6265722B286E3F313A2D3129292C733D652E626964695370616E73286F292C743D652E76697375616C4C696E6553696465286F2C216E297D6966286C297B696628216C28632929';
wwv_flow_imp.g_varchar2_table(44846) := '72657475726E20617D656C73657B69662821692972657475726E20743B6C3D692863297D613D747D7D66756E6374696F6E20695428652C742C6E297B666F72283B3B297B6C657420693D303B666F72286C6574206F206F662065296F2E6265747765656E';
wwv_flow_imp.g_varchar2_table(44847) := '28742D312C742B312C2828652C6F2C73293D3E7B696628743E652626743C6F297B6C657420733D697C7C6E7C7C28742D653C6F2D743F2D313A31293B743D733C303F653A6F2C693D737D7D29293B69662821692972657475726E20747D7D66756E637469';
wwv_flow_imp.g_varchar2_table(44848) := '6F6E206F5428652C742C6E297B6C657420693D695428652E73746174652E6661636574285244292E6D61702828743D3E7428652929292C6E2E66726F6D2C742E686561643E6E2E66726F6D3F2D313A31293B72657475726E20693D3D6E2E66726F6D3F6E';
wwv_flow_imp.g_varchar2_table(44849) := '3A666B2E637572736F7228692C693C6E2E66726F6D3F313A2D31297D636F6E73742073543D22EFBFBF223B636C6173732072547B636F6E7374727563746F7228652C74297B746869732E706F696E74733D652C746869732E746578743D22222C74686973';
wwv_flow_imp.g_varchar2_table(44850) := '2E6C696E65536570617261746F723D742E6661636574286E452E6C696E65536570617261746F72297D617070656E642865297B746869732E746578742B3D657D6C696E65427265616B28297B746869732E746578742B3D73547D7265616452616E676528';
wwv_flow_imp.g_varchar2_table(44851) := '652C74297B69662821652972657475726E20746869733B6C6574206E3D652E706172656E744E6F64653B666F72286C657420693D653B3B297B746869732E66696E64506F696E744265666F7265286E2C69293B6C657420653D746869732E746578742E6C';
wwv_flow_imp.g_varchar2_table(44852) := '656E6774683B746869732E726561644E6F64652869293B6C6574206F3D692E6E6578745369626C696E673B6966286F3D3D7429627265616B3B6C657420733D694C2E6765742869292C723D694C2E676574286F293B28732626723F732E627265616B4166';
wwv_flow_imp.g_varchar2_table(44853) := '7465723A28733F732E627265616B41667465723A5645286929297C7C5645286F2926262822425222213D692E6E6F64654E616D657C7C692E636D49676E6F7265292626746869732E746578742E6C656E6774683E65292626746869732E6C696E65427265';
wwv_flow_imp.g_varchar2_table(44854) := '616B28292C693D6F7D72657475726E20746869732E66696E64506F696E744265666F7265286E2C74292C746869737D72656164546578744E6F64652865297B6C657420743D652E6E6F646556616C75653B666F72286C6574206E206F6620746869732E70';
wwv_flow_imp.g_varchar2_table(44855) := '6F696E7473296E2E6E6F64653D3D652626286E2E706F733D746869732E746578742E6C656E6774682B4D6174682E6D696E286E2E6F66667365742C742E6C656E67746829293B666F72286C6574206E3D302C693D746869732E6C696E6553657061726174';
wwv_flow_imp.g_varchar2_table(44856) := '6F723F6E756C6C3A2F5C725C6E3F7C5C6E2F673B3B297B6C6574206F2C733D2D312C723D313B696628746869732E6C696E65536570617261746F723F28733D742E696E6465784F6628746869732E6C696E65536570617261746F722C6E292C723D746869';
wwv_flow_imp.g_varchar2_table(44857) := '732E6C696E65536570617261746F722E6C656E677468293A286F3D692E6578656328742929262628733D6F2E696E6465782C723D6F5B305D2E6C656E677468292C746869732E617070656E6428742E736C696365286E2C733C303F742E6C656E6774683A';
wwv_flow_imp.g_varchar2_table(44858) := '7329292C733C3029627265616B3B696628746869732E6C696E65427265616B28292C723E3129666F72286C65742074206F6620746869732E706F696E747329742E6E6F64653D3D652626742E706F733E746869732E746578742E6C656E67746826262874';
wwv_flow_imp.g_varchar2_table(44859) := '2E706F732D3D722D31293B6E3D732B727D7D726561644E6F64652865297B696628652E636D49676E6F72652972657475726E3B6C657420743D694C2E6765742865292C6E3D742626742E6F76657272696465444F4D546578743B6966286E756C6C213D6E';
wwv_flow_imp.g_varchar2_table(44860) := '297B746869732E66696E64506F696E74496E7369646528652C6E2E6C656E677468293B666F72286C657420653D6E2E6974657228293B21652E6E65787428292E646F6E653B29652E6C696E65427265616B3F746869732E6C696E65427265616B28293A74';
wwv_flow_imp.g_varchar2_table(44861) := '6869732E617070656E6428652E76616C7565297D656C736520333D3D652E6E6F6465547970653F746869732E72656164546578744E6F64652865293A224252223D3D652E6E6F64654E616D653F652E6E6578745369626C696E672626746869732E6C696E';
wwv_flow_imp.g_varchar2_table(44862) := '65427265616B28293A313D3D652E6E6F6465547970652626746869732E7265616452616E676528652E66697273744368696C642C6E756C6C297D66696E64506F696E744265666F726528652C74297B666F72286C6574206E206F6620746869732E706F69';
wwv_flow_imp.g_varchar2_table(44863) := '6E7473296E2E6E6F64653D3D652626652E6368696C644E6F6465735B6E2E6F66667365745D3D3D742626286E2E706F733D746869732E746578742E6C656E677468297D66696E64506F696E74496E7369646528652C74297B666F72286C6574206E206F66';
wwv_flow_imp.g_varchar2_table(44864) := '20746869732E706F696E74732928333D3D652E6E6F6465547970653F6E2E6E6F64653D3D653A652E636F6E7461696E73286E2E6E6F646529292626286E2E706F733D746869732E746578742E6C656E6774682B28615428652C6E2E6E6F64652C6E2E6F66';
wwv_flow_imp.g_varchar2_table(44865) := '66736574293F743A3029297D7D66756E6374696F6E20615428652C742C6E297B666F72283B3B297B69662821747C7C6E3C48452874292972657475726E21313B696628743D3D652972657475726E21303B6E3D42452874292B312C743D742E706172656E';
wwv_flow_imp.g_varchar2_table(44866) := '744E6F64657D7D636C617373206C547B636F6E7374727563746F7228652C74297B746869732E6E6F64653D652C746869732E6F66667365743D742C746869732E706F733D2D317D7D636C6173732063547B636F6E7374727563746F7228652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(44867) := '297B746869732E747970654F7665723D692C746869732E626F756E64733D6E756C6C2C746869732E746578743D22222C746869732E646F6D4368616E6765643D743E2D313B6C65747B696D70726563697365486561643A6F2C696D70726563697365416E';
wwv_flow_imp.g_varchar2_table(44868) := '63686F723A737D3D652E646F63566965773B696628652E73746174652E726561644F6E6C792626743E2D3129746869732E6E657753656C3D6E756C6C3B656C736520696628743E2D31262628746869732E626F756E64733D652E646F63566965772E646F';
wwv_flow_imp.g_varchar2_table(44869) := '6D426F756E647341726F756E6428742C6E2C302929297B6C657420743D6F7C7C733F5B5D3A66756E6374696F6E2865297B6C657420743D5B5D3B696628652E726F6F742E616374697665456C656D656E74213D652E636F6E74656E74444F4D2972657475';
wwv_flow_imp.g_varchar2_table(44870) := '726E20743B6C65747B616E63686F724E6F64653A6E2C616E63686F724F66667365743A692C666F6375734E6F64653A6F2C666F6375734F66667365743A737D3D652E6F627365727665722E73656C656374696F6E52616E67653B72657475726E206E2626';
wwv_flow_imp.g_varchar2_table(44871) := '28742E70757368286E6577206C54286E2C6929292C6F3D3D6E2626733D3D697C7C742E70757368286E6577206C54286F2C732929292C747D2865292C6E3D6E657720725428742C652E7374617465293B6E2E7265616452616E676528746869732E626F75';
wwv_flow_imp.g_varchar2_table(44872) := '6E64732E7374617274444F4D2C746869732E626F756E64732E656E64444F4D292C746869732E746578743D6E2E746578742C746869732E6E657753656C3D66756E6374696F6E28652C74297B696628303D3D652E6C656E6774682972657475726E206E75';
wwv_flow_imp.g_varchar2_table(44873) := '6C6C3B6C6574206E3D655B305D2E706F732C693D323D3D652E6C656E6774683F655B315D2E706F733A6E3B72657475726E206E3E2D312626693E2D313F666B2E73696E676C65286E2B742C692B74293A6E756C6C7D28742C746869732E626F756E64732E';
wwv_flow_imp.g_varchar2_table(44874) := '66726F6D297D656C73657B6C657420743D652E6F627365727665722E73656C656374696F6E52616E67652C6E3D6F26266F2E6E6F64653D3D742E666F6375734E6F646526266F2E6F66667365743D3D742E666F6375734F66667365747C7C21504528652E';
wwv_flow_imp.g_varchar2_table(44875) := '636F6E74656E74444F4D2C742E666F6375734E6F6465293F652E73746174652E73656C656374696F6E2E6D61696E2E686561643A652E646F63566965772E706F7346726F6D444F4D28742E666F6375734E6F64652C742E666F6375734F6666736574292C';
wwv_flow_imp.g_varchar2_table(44876) := '693D732626732E6E6F64653D3D742E616E63686F724E6F64652626732E6F66667365743D3D742E616E63686F724F66667365747C7C21504528652E636F6E74656E74444F4D2C742E616E63686F724E6F6465293F652E73746174652E73656C656374696F';
wwv_flow_imp.g_varchar2_table(44877) := '6E2E6D61696E2E616E63686F723A652E646F63566965772E706F7346726F6D444F4D28742E616E63686F724E6F64652C742E616E63686F724F6666736574292C723D652E76696577706F72743B696628285F4C2E696F737C7C5F4C2E6368726F6D652926';
wwv_flow_imp.g_varchar2_table(44878) := '26652E73746174652E73656C656374696F6E2E6D61696E2E656D70747926266E213D69262628722E66726F6D3E307C7C722E746F3C652E73746174652E646F632E6C656E67746829297B6C657420743D4D6174682E6D696E286E2C69292C6F3D4D617468';
wwv_flow_imp.g_varchar2_table(44879) := '2E6D6178286E2C69292C733D722E66726F6D2D742C613D722E746F2D6F3B30213D73262631213D73262630213D747C7C30213D6126262D31213D6126266F213D652E73746174652E646F632E6C656E6774687C7C286E3D302C693D652E73746174652E64';
wwv_flow_imp.g_varchar2_table(44880) := '6F632E6C656E677468297D746869732E6E657753656C3D666B2E73696E676C6528692C6E297D7D7D66756E6374696F6E20645428652C74297B6C6574206E2C7B6E657753656C3A697D3D742C6F3D652E73746174652E73656C656374696F6E2E6D61696E';
wwv_flow_imp.g_varchar2_table(44881) := '2C733D652E696E70757453746174652E6C6173744B657954696D653E446174652E6E6F7728292D3130303F652E696E70757453746174652E6C6173744B6579436F64653A2D313B696628742E626F756E6473297B6C65747B66726F6D3A692C746F3A727D';
wwv_flow_imp.g_varchar2_table(44882) := '3D742E626F756E64732C613D6F2E66726F6D2C6C3D6E756C6C3B28383D3D3D737C7C5F4C2E616E64726F69642626742E746578742E6C656E6774683C722D6929262628613D6F2E746F2C6C3D22656E6422293B6C657420633D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(44883) := '742C6E2C69297B6C6574206F3D4D6174682E6D696E28652E6C656E6774682C742E6C656E677468292C733D303B666F72283B733C6F2626652E63686172436F646541742873293D3D742E63686172436F646541742873293B29732B2B3B696628733D3D6F';
wwv_flow_imp.g_varchar2_table(44884) := '2626652E6C656E6774683D3D742E6C656E6774682972657475726E206E756C6C3B6C657420723D652E6C656E6774682C613D742E6C656E6774683B666F72283B723E302626613E302626652E63686172436F6465417428722D31293D3D742E6368617243';
wwv_flow_imp.g_varchar2_table(44885) := '6F6465417428612D31293B29722D2D2C612D2D3B72657475726E22656E64223D3D692626286E2D3D722B4D6174682E6D617828302C732D4D6174682E6D696E28722C6129292D73292C723C732626652E6C656E6774683C742E6C656E6774683F28732D3D';
wwv_flow_imp.g_varchar2_table(44886) := '6E3C3D7326266E3E3D723F732D6E3A302C613D732B28612D72292C723D73293A613C73262628732D3D6E3C3D7326266E3E3D613F732D6E3A302C723D732B28722D61292C613D73292C7B66726F6D3A732C746F413A722C746F423A617D7D28652E737461';
wwv_flow_imp.g_varchar2_table(44887) := '74652E646F632E736C696365537472696E6728692C722C7354292C742E746578742C612D692C6C293B632626285F4C2E6368726F6D65262631333D3D732626632E746F423D3D632E66726F6D2B322626742E746578742E736C69636528632E66726F6D2C';
wwv_flow_imp.g_varchar2_table(44888) := '632E746F42293D3D73542B73542626632E746F422D2D2C6E3D7B66726F6D3A692B632E66726F6D2C746F3A692B632E746F412C696E736572743A46782E6F6628742E746578742E736C69636528632E66726F6D2C632E746F42292E73706C697428735429';
wwv_flow_imp.g_varchar2_table(44889) := '297D297D656C7365206926262821652E686173466F6375732626652E73746174652E6661636574284C44297C7C692E6D61696E2E6571286F2929262628693D6E756C6C293B696628216E262621692972657475726E21313B696628216E2626742E747970';
wwv_flow_imp.g_varchar2_table(44890) := '654F7665722626216F2E656D7074792626692626692E6D61696E2E656D7074793F6E3D7B66726F6D3A6F2E66726F6D2C746F3A6F2E746F2C696E736572743A652E73746174652E646F632E736C696365286F2E66726F6D2C6F2E746F297D3A6E26266E2E';
wwv_flow_imp.g_varchar2_table(44891) := '66726F6D3E3D6F2E66726F6D26266E2E746F3C3D6F2E746F2626286E2E66726F6D213D6F2E66726F6D7C7C6E2E746F213D6F2E746F2926266F2E746F2D6F2E66726F6D2D286E2E746F2D6E2E66726F6D293C3D343F6E3D7B66726F6D3A6F2E66726F6D2C';
wwv_flow_imp.g_varchar2_table(44892) := '746F3A6F2E746F2C696E736572743A652E73746174652E646F632E736C696365286F2E66726F6D2C6E2E66726F6D292E617070656E64286E2E696E73657274292E617070656E6428652E73746174652E646F632E736C696365286E2E746F2C6F2E746F29';
wwv_flow_imp.g_varchar2_table(44893) := '297D3A285F4C2E6D61637C7C5F4C2E616E64726F69642926266E26266E2E66726F6D3D3D6E2E746F26266E2E66726F6D3D3D6F2E686561642D3126262F5E5C2E203F242F2E74657374286E2E696E736572742E746F537472696E672829292626226F6666';
wwv_flow_imp.g_varchar2_table(44894) := '223D3D652E636F6E74656E74444F4D2E67657441747472696275746528226175746F636F727265637422293F28692626323D3D6E2E696E736572742E6C656E677468262628693D666B2E73696E676C6528692E6D61696E2E616E63686F722D312C692E6D';
wwv_flow_imp.g_varchar2_table(44895) := '61696E2E686561642D3129292C6E3D7B66726F6D3A6F2E66726F6D2C746F3A6F2E746F2C696E736572743A46782E6F66285B2220225D297D293A5F4C2E6368726F6D6526266E26266E2E66726F6D3D3D6E2E746F26266E2E66726F6D3D3D6F2E68656164';
wwv_flow_imp.g_varchar2_table(44896) := '2626225C6E20223D3D6E2E696E736572742E746F537472696E6728292626652E6C696E655772617070696E6726262869262628693D666B2E73696E676C6528692E6D61696E2E616E63686F722D312C692E6D61696E2E686561642D3129292C6E3D7B6672';
wwv_flow_imp.g_varchar2_table(44897) := '6F6D3A6F2E66726F6D2C746F3A6F2E746F2C696E736572743A46782E6F66285B2220225D297D292C6E2972657475726E20685428652C6E2C692C73293B69662869262621692E6D61696E2E6571286F29297B6C657420743D21312C6E3D2273656C656374';
wwv_flow_imp.g_varchar2_table(44898) := '223B72657475726E20652E696E70757453746174652E6C61737453656C656374696F6E54696D653E446174652E6E6F7728292D35302626282273656C656374223D3D652E696E70757453746174652E6C61737453656C656374696F6E4F726967696E2626';
wwv_flow_imp.g_varchar2_table(44899) := '28743D2130292C6E3D652E696E70757453746174652E6C61737453656C656374696F6E4F726967696E292C652E6469737061746368287B73656C656374696F6E3A692C7363726F6C6C496E746F566965773A742C757365724576656E743A6E7D292C2130';
wwv_flow_imp.g_varchar2_table(44900) := '7D72657475726E21317D66756E6374696F6E20685428652C742C6E2C693D2D31297B6966285F4C2E696F732626652E696E70757453746174652E666C757368494F534B65792874292972657475726E21303B6C6574206F3D652E73746174652E73656C65';
wwv_flow_imp.g_varchar2_table(44901) := '6374696F6E2E6D61696E3B6966285F4C2E616E64726F6964262628742E746F3D3D6F2E746F262628742E66726F6D3D3D6F2E66726F6D7C7C742E66726F6D3D3D6F2E66726F6D2D3126262220223D3D652E73746174652E736C696365446F6328742E6672';
wwv_flow_imp.g_varchar2_table(44902) := '6F6D2C6F2E66726F6D29292626313D3D742E696E736572742E6C656E6774682626323D3D742E696E736572742E6C696E65732626594528652E636F6E74656E74444F4D2C22456E746572222C3133297C7C28742E66726F6D3D3D6F2E66726F6D2D312626';
wwv_flow_imp.g_varchar2_table(44903) := '742E746F3D3D6F2E746F2626303D3D742E696E736572742E6C656E6774687C7C383D3D692626742E696E736572742E6C656E6774683C742E746F2D742E66726F6D2626742E746F3E6F2E68656164292626594528652E636F6E74656E74444F4D2C224261';
wwv_flow_imp.g_varchar2_table(44904) := '636B7370616365222C38297C7C742E66726F6D3D3D6F2E66726F6D2626742E746F3D3D6F2E746F2B312626303D3D742E696E736572742E6C656E6774682626594528652E636F6E74656E74444F4D2C2244656C657465222C343629292972657475726E21';
wwv_flow_imp.g_varchar2_table(44905) := '303B6C657420732C723D742E696E736572742E746F537472696E6728293B652E696E70757453746174652E636F6D706F73696E673E3D302626652E696E70757453746174652E636F6D706F73696E672B2B3B6C657420613D28293D3E737C7C28733D6675';
wwv_flow_imp.g_varchar2_table(44906) := '6E6374696F6E28652C742C6E297B6C657420692C6F3D652E73746174652C733D6F2E73656C656374696F6E2E6D61696E3B696628742E66726F6D3E3D732E66726F6D2626742E746F3C3D732E746F2626742E746F2D742E66726F6D3E3D28732E746F2D73';
wwv_flow_imp.g_varchar2_table(44907) := '2E66726F6D292F33262628216E7C7C6E2E6D61696E2E656D70747926266E2E6D61696E2E66726F6D3D3D742E66726F6D2B742E696E736572742E6C656E677468292626652E696E70757453746174652E636F6D706F73696E673C30297B6C6574206E3D73';
wwv_flow_imp.g_varchar2_table(44908) := '2E66726F6D3C742E66726F6D3F6F2E736C696365446F6328732E66726F6D2C742E66726F6D293A22222C723D732E746F3E742E746F3F6F2E736C696365446F6328742E746F2C732E746F293A22223B693D6F2E7265706C61636553656C656374696F6E28';
wwv_flow_imp.g_varchar2_table(44909) := '652E73746174652E746F54657874286E2B742E696E736572742E736C696365537472696E6728302C766F696420302C652E73746174652E6C696E65427265616B292B7229297D656C73657B6C657420723D6F2E6368616E6765732874292C613D6E26266E';
wwv_flow_imp.g_varchar2_table(44910) := '2E6D61696E2E746F3C3D722E6E65774C656E6774683F6E2E6D61696E3A766F696420303B6966286F2E73656C656374696F6E2E72616E6765732E6C656E6774683E312626652E696E70757453746174652E636F6D706F73696E673E3D302626742E746F3C';
wwv_flow_imp.g_varchar2_table(44911) := '3D732E746F2626742E746F3E3D732E746F2D3130297B6C6574206C2C633D652E73746174652E736C696365446F6328742E66726F6D2C742E746F292C643D6E2626244428652C6E2E6D61696E2E68656164293B69662864297B6C657420653D742E696E73';
wwv_flow_imp.g_varchar2_table(44912) := '6572742E6C656E6774682D28742E746F2D742E66726F6D293B6C3D7B66726F6D3A642E66726F6D2C746F3A642E746F2D657D7D656C7365206C3D652E73746174652E646F632E6C696E65417428732E68656164293B6C657420683D732E746F2D742E746F';
wwv_flow_imp.g_varchar2_table(44913) := '2C753D732E746F2D732E66726F6D3B693D6F2E6368616E6765427952616E676528286E3D3E7B6966286E2E66726F6D3D3D732E66726F6D26266E2E746F3D3D732E746F2972657475726E7B6368616E6765733A722C72616E67653A617C7C6E2E6D617028';
wwv_flow_imp.g_varchar2_table(44914) := '72297D3B6C657420693D6E2E746F2D682C643D692D632E6C656E6774683B6966286E2E746F2D6E2E66726F6D213D757C7C652E73746174652E736C696365446F6328642C6929213D637C7C6E2E746F3E3D6C2E66726F6D26266E2E66726F6D3C3D6C2E74';
wwv_flow_imp.g_varchar2_table(44915) := '6F2972657475726E7B72616E67653A6E7D3B6C657420703D6F2E6368616E676573287B66726F6D3A642C746F3A692C696E736572743A742E696E736572747D292C673D6E2E746F2D732E746F3B72657475726E7B6368616E6765733A702C72616E67653A';
wwv_flow_imp.g_varchar2_table(44916) := '613F666B2E72616E6765284D6174682E6D617828302C612E616E63686F722B67292C4D6174682E6D617828302C612E686561642B6729293A6E2E6D61702870297D7D29297D656C736520693D7B6368616E6765733A722C73656C656374696F6E3A612626';
wwv_flow_imp.g_varchar2_table(44917) := '6F2E73656C656374696F6E2E7265706C61636552616E67652861297D7D6C657420723D22696E7075742E74797065223B72657475726E28652E636F6D706F73696E677C7C652E696E70757453746174652E636F6D706F736974696F6E50656E64696E6743';
wwv_flow_imp.g_varchar2_table(44918) := '68616E67652626652E696E70757453746174652E636F6D706F736974696F6E456E64656441743E446174652E6E6F7728292D353029262628652E696E70757453746174652E636F6D706F736974696F6E50656E64696E674368616E67653D21312C722B3D';
wwv_flow_imp.g_varchar2_table(44919) := '222E636F6D706F7365222C652E696E70757453746174652E636F6D706F736974696F6E46697273744368616E6765262628722B3D222E7374617274222C652E696E70757453746174652E636F6D706F736974696F6E46697273744368616E67653D213129';
wwv_flow_imp.g_varchar2_table(44920) := '292C6F2E75706461746528692C7B757365724576656E743A722C7363726F6C6C496E746F566965773A21307D297D28652C742C6E29293B72657475726E20652E73746174652E6661636574286644292E736F6D6528286E3D3E6E28652C742E66726F6D2C';
wwv_flow_imp.g_varchar2_table(44921) := '742E746F2C722C612929297C7C652E646973706174636828612829292C21307D636C6173732075547B73657453656C656374696F6E4F726967696E2865297B746869732E6C61737453656C656374696F6E4F726967696E3D652C746869732E6C61737453';
wwv_flow_imp.g_varchar2_table(44922) := '656C656374696F6E54696D653D446174652E6E6F7728297D636F6E7374727563746F722865297B746869732E766965773D652C746869732E6C6173744B6579436F64653D302C746869732E6C6173744B657954696D653D302C746869732E6C617374546F';
wwv_flow_imp.g_varchar2_table(44923) := '75636854696D653D302C746869732E6C617374466F63757354696D653D302C746869732E6C6173745363726F6C6C546F703D302C746869732E6C6173745363726F6C6C4C6566743D302C746869732E70656E64696E67494F534B65793D766F696420302C';
wwv_flow_imp.g_varchar2_table(44924) := '746869732E746162466F6375734D6F64653D2D312C746869732E6C61737453656C656374696F6E4F726967696E3D6E756C6C2C746869732E6C61737453656C656374696F6E54696D653D302C746869732E6C617374436F6E746578744D656E753D302C74';
wwv_flow_imp.g_varchar2_table(44925) := '6869732E7363726F6C6C48616E646C6572733D5B5D2C746869732E68616E646C6572733D4F626A6563742E637265617465286E756C6C292C746869732E636F6D706F73696E673D2D312C746869732E636F6D706F736974696F6E46697273744368616E67';
wwv_flow_imp.g_varchar2_table(44926) := '653D6E756C6C2C746869732E636F6D706F736974696F6E456E64656441743D302C746869732E636F6D706F736974696F6E50656E64696E674B65793D21312C746869732E636F6D706F736974696F6E50656E64696E674368616E67653D21312C74686973';
wwv_flow_imp.g_varchar2_table(44927) := '2E6D6F75736553656C656374696F6E3D6E756C6C2C746869732E64726167676564436F6E74656E743D6E756C6C2C746869732E68616E646C654576656E743D746869732E68616E646C654576656E742E62696E642874686973292C746869732E6E6F7469';
wwv_flow_imp.g_varchar2_table(44928) := '66696564466F63757365643D652E686173466F6375732C5F4C2E7361666172692626652E636F6E74656E74444F4D2E6164644576656E744C697374656E65722822696E707574222C2828293D3E6E756C6C29292C5F4C2E6765636B6F262666756E637469';
wwv_flow_imp.g_varchar2_table(44929) := '6F6E2865297B56542E6861732865297C7C2856542E6164642865292C652E6164644576656E744C697374656E65722822636F7079222C2828293D3E7B7D29292C652E6164644576656E744C697374656E65722822637574222C2828293D3E7B7D2929297D';
wwv_flow_imp.g_varchar2_table(44930) := '28652E636F6E74656E74444F4D2E6F776E6572446F63756D656E74297D68616E646C654576656E742865297B2866756E6374696F6E28652C74297B69662821742E627562626C65732972657475726E21303B696628742E64656661756C7450726576656E';
wwv_flow_imp.g_varchar2_table(44931) := '7465642972657475726E21313B666F72286C6574206E2C693D742E7461726765743B69213D652E636F6E74656E74444F4D3B693D692E706172656E744E6F64652969662821697C7C31313D3D692E6E6F6465547970657C7C286E3D694C2E676574286929';
wwv_flow_imp.g_varchar2_table(44932) := '2926266E2E69676E6F72654576656E742874292972657475726E21313B72657475726E21307D2928746869732E766965772C6529262621746869732E69676E6F7265447572696E67436F6D706F736974696F6E286529262628226B6579646F776E223D3D';
wwv_flow_imp.g_varchar2_table(44933) := '652E747970652626746869732E6B6579646F776E2865297C7C746869732E72756E48616E646C65727328652E747970652C6529297D72756E48616E646C65727328652C74297B6C6574206E3D746869732E68616E646C6572735B655D3B6966286E297B66';
wwv_flow_imp.g_varchar2_table(44934) := '6F72286C65742065206F66206E2E6F6273657276657273296528746869732E766965772C74293B666F72286C65742065206F66206E2E68616E646C657273297B696628742E64656661756C7450726576656E74656429627265616B3B6966286528746869';
wwv_flow_imp.g_varchar2_table(44935) := '732E766965772C7429297B742E70726576656E7444656661756C7428293B627265616B7D7D7D7D656E7375726548616E646C6572732865297B6C657420743D67542865292C6E3D746869732E68616E646C6572732C693D746869732E766965772E636F6E';
wwv_flow_imp.g_varchar2_table(44936) := '74656E74444F4D3B666F72286C6574206520696E207429696628227363726F6C6C22213D65297B6C6574206F3D21745B655D2E68616E646C6572732E6C656E6774682C733D6E5B655D3B7326266F213D21732E68616E646C6572732E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(44937) := '28692E72656D6F76654576656E744C697374656E657228652C746869732E68616E646C654576656E74292C733D6E756C6C292C737C7C692E6164644576656E744C697374656E657228652C746869732E68616E646C654576656E742C7B70617373697665';
wwv_flow_imp.g_varchar2_table(44938) := '3A6F7D297D666F72286C6574206520696E206E29227363726F6C6C223D3D657C7C745B655D7C7C692E72656D6F76654576656E744C697374656E657228652C746869732E68616E646C654576656E74293B746869732E68616E646C6572733D747D6B6579';
wwv_flow_imp.g_varchar2_table(44939) := '646F776E2865297B696628746869732E6C6173744B6579436F64653D652E6B6579436F64652C746869732E6C6173744B657954696D653D446174652E6E6F7728292C393D3D652E6B6579436F64652626746869732E746162466F6375734D6F64653E2D31';
wwv_flow_imp.g_varchar2_table(44940) := '26262821746869732E746162466F6375734D6F64657C7C446174652E6E6F7728293C3D746869732E746162466F6375734D6F6465292972657475726E21303B696628746869732E746162466F6375734D6F64653E3026263237213D652E6B6579436F6465';
wwv_flow_imp.g_varchar2_table(44941) := '262676542E696E6465784F6628652E6B6579436F6465293C30262628746869732E746162466F6375734D6F64653D2D31292C5F4C2E616E64726F696426265F4C2E6368726F6D65262621652E73796E74686574696326262831333D3D652E6B6579436F64';
wwv_flow_imp.g_varchar2_table(44942) := '657C7C383D3D652E6B6579436F6465292972657475726E20746869732E766965772E6F627365727665722E64656C6179416E64726F69644B657928652E6B65792C652E6B6579436F6465292C21303B6C657420743B72657475726E215F4C2E696F737C7C';
wwv_flow_imp.g_varchar2_table(44943) := '652E73796E7468657469637C7C652E616C744B65797C7C652E6D6574614B65797C7C212828743D6D542E66696E642828743D3E742E6B6579436F64653D3D652E6B6579436F6465292929262621652E6374726C4B65797C7C66542E696E6465784F662865';
wwv_flow_imp.g_varchar2_table(44944) := '2E6B6579293E2D312626652E6374726C4B6579262621652E73686966744B6579293F28323239213D652E6B6579436F64652626746869732E766965772E6F627365727665722E666F726365466C75736828292C2131293A28746869732E70656E64696E67';
wwv_flow_imp.g_varchar2_table(44945) := '494F534B65793D747C7C652C73657454696D656F7574282828293D3E746869732E666C757368494F534B65792829292C323530292C2130297D666C757368494F534B65792865297B6C657420743D746869732E70656E64696E67494F534B65793B726574';
wwv_flow_imp.g_varchar2_table(44946) := '75726E2121742626212822456E746572223D3D742E6B65792626652626652E66726F6D3C652E746F26262F5E5C532B242F2E7465737428652E696E736572742E746F537472696E6728292929262628746869732E70656E64696E67494F534B65793D766F';
wwv_flow_imp.g_varchar2_table(44947) := '696420302C594528746869732E766965772E636F6E74656E74444F4D2C742E6B65792C742E6B6579436F64652C7420696E7374616E63656F66204B6579626F6172644576656E743F743A766F6964203029297D69676E6F7265447572696E67436F6D706F';
wwv_flow_imp.g_varchar2_table(44948) := '736974696F6E2865297B72657475726E21212F5E6B65792F2E7465737428652E7479706529262628746869732E636F6D706F73696E673E307C7C2121285F4C2E7361666172692626215F4C2E696F732626746869732E636F6D706F736974696F6E50656E';
wwv_flow_imp.g_varchar2_table(44949) := '64696E674B65792626446174652E6E6F7728292D746869732E636F6D706F736974696F6E456E64656441743C31303029262628746869732E636F6D706F736974696F6E50656E64696E674B65793D21312C213029297D73746172744D6F75736553656C65';
wwv_flow_imp.g_varchar2_table(44950) := '6374696F6E2865297B746869732E6D6F75736553656C656374696F6E2626746869732E6D6F75736553656C656374696F6E2E64657374726F7928292C746869732E6D6F75736553656C656374696F6E3D657D7570646174652865297B746869732E766965';
wwv_flow_imp.g_varchar2_table(44951) := '772E6F627365727665722E7570646174652865292C746869732E6D6F75736553656C656374696F6E2626746869732E6D6F75736553656C656374696F6E2E7570646174652865292C746869732E64726167676564436F6E74656E742626652E646F634368';
wwv_flow_imp.g_varchar2_table(44952) := '616E676564262628746869732E64726167676564436F6E74656E743D746869732E64726167676564436F6E74656E742E6D617028652E6368616E67657329292C652E7472616E73616374696F6E732E6C656E677468262628746869732E6C6173744B6579';
wwv_flow_imp.g_varchar2_table(44953) := '436F64653D746869732E6C61737453656C656374696F6E54696D653D30297D64657374726F7928297B746869732E6D6F75736553656C656374696F6E2626746869732E6D6F75736553656C656374696F6E2E64657374726F7928297D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(44954) := '6E20705428652C74297B72657475726E286E2C69293D3E7B7472797B72657475726E20742E63616C6C28652C692C6E297D63617463682865297B4544286E2E73746174652C65297D7D7D66756E6374696F6E2067542865297B6C657420743D4F626A6563';
wwv_flow_imp.g_varchar2_table(44955) := '742E637265617465286E756C6C293B66756E6374696F6E206E2865297B72657475726E20745B655D7C7C28745B655D3D7B6F62736572766572733A5B5D2C68616E646C6572733A5B5D7D297D666F72286C65742074206F662065297B6C657420653D742E';
wwv_flow_imp.g_varchar2_table(44956) := '737065633B696628652626652E646F6D4576656E7448616E646C65727329666F72286C6574206920696E20652E646F6D4576656E7448616E646C657273297B6C6574206F3D652E646F6D4576656E7448616E646C6572735B695D3B6F26266E2869292E68';
wwv_flow_imp.g_varchar2_table(44957) := '616E646C6572732E7075736828705428742E76616C75652C6F29297D696628652626652E646F6D4576656E744F627365727665727329666F72286C6574206920696E20652E646F6D4576656E744F6273657276657273297B6C6574206F3D652E646F6D45';
wwv_flow_imp.g_varchar2_table(44958) := '76656E744F62736572766572735B695D3B6F26266E2869292E6F62736572766572732E7075736828705428742E76616C75652C6F29297D7D666F72286C6574206520696E207954296E2865292E68616E646C6572732E707573682879545B655D293B666F';
wwv_flow_imp.g_varchar2_table(44959) := '72286C6574206520696E207754296E2865292E6F62736572766572732E707573682877545B655D293B72657475726E20747D636F6E7374206D543D5B7B6B65793A224261636B7370616365222C6B6579436F64653A382C696E707574547970653A226465';
wwv_flow_imp.g_varchar2_table(44960) := '6C657465436F6E74656E744261636B77617264227D2C7B6B65793A22456E746572222C6B6579436F64653A31332C696E707574547970653A22696E73657274506172616772617068227D2C7B6B65793A22456E746572222C6B6579436F64653A31332C69';
wwv_flow_imp.g_varchar2_table(44961) := '6E707574547970653A22696E736572744C696E65427265616B227D2C7B6B65793A2244656C657465222C6B6579436F64653A34362C696E707574547970653A2264656C657465436F6E74656E74466F7277617264227D5D2C66543D226474686B6F222C76';
wwv_flow_imp.g_varchar2_table(44962) := '543D5B31362C31372C31382C32302C39312C39322C3232342C3232355D3B66756E6374696F6E2062542865297B72657475726E2E372A4D6174682E6D617828302C65292B387D636C617373205F547B636F6E7374727563746F7228652C742C6E2C69297B';
wwv_flow_imp.g_varchar2_table(44963) := '746869732E766965773D652C746869732E73746172744576656E743D742C746869732E7374796C653D6E2C746869732E6D75737453656C6563743D692C746869732E7363726F6C6C53706565643D7B783A302C793A307D2C746869732E7363726F6C6C69';
wwv_flow_imp.g_varchar2_table(44964) := '6E673D2D312C746869732E6C6173744576656E743D742C746869732E7363726F6C6C506172656E74733D66756E6374696F6E2865297B6C657420742C6E2C693D652E6F776E6572446F63756D656E743B666F72286C6574206F3D652E706172656E744E6F';
wwv_flow_imp.g_varchar2_table(44965) := '64653B6F262621286F3D3D692E626F64797C7C7426266E293B29696628313D3D6F2E6E6F64655479706529216E26266F2E7363726F6C6C4865696768743E6F2E636C69656E744865696768742626286E3D6F292C217426266F2E7363726F6C6C57696474';
wwv_flow_imp.g_varchar2_table(44966) := '683E6F2E636C69656E745769647468262628743D6F292C6F3D6F2E61737369676E6564536C6F747C7C6F2E706172656E744E6F64653B656C73657B6966283131213D6F2E6E6F64655479706529627265616B3B6F3D6F2E686F73747D72657475726E7B78';
wwv_flow_imp.g_varchar2_table(44967) := '3A742C793A6E7D7D28652E636F6E74656E74444F4D292C746869732E61746F6D733D652E73746174652E6661636574285244292E6D61702828743D3E7428652929293B6C6574206F3D652E636F6E74656E74444F4D2E6F776E6572446F63756D656E743B';
wwv_flow_imp.g_varchar2_table(44968) := '6F2E6164644576656E744C697374656E657228226D6F7573656D6F7665222C746869732E6D6F76653D746869732E6D6F76652E62696E64287468697329292C6F2E6164644576656E744C697374656E657228226D6F7573657570222C746869732E75703D';
wwv_flow_imp.g_varchar2_table(44969) := '746869732E75702E62696E64287468697329292C746869732E657874656E643D742E73686966744B65792C746869732E6D756C7469706C653D652E73746174652E6661636574286E452E616C6C6F774D756C7469706C6553656C656374696F6E73292626';
wwv_flow_imp.g_varchar2_table(44970) := '66756E6374696F6E28652C74297B6C6574206E3D652E73746174652E6661636574286844293B72657475726E206E2E6C656E6774683F6E5B305D2874293A5F4C2E6D61633F742E6D6574614B65793A742E6374726C4B65797D28652C74292C746869732E';
wwv_flow_imp.g_varchar2_table(44971) := '6472616767696E673D21282166756E6374696F6E28652C74297B6C65747B6D61696E3A6E7D3D652E73746174652E73656C656374696F6E3B6966286E2E656D7074792972657475726E21313B6C657420693D4E4528652E726F6F74293B69662821697C7C';
wwv_flow_imp.g_varchar2_table(44972) := '303D3D692E72616E6765436F756E742972657475726E21303B6C6574206F3D692E67657452616E676541742830292E676574436C69656E74526563747328293B666F72286C657420653D303B653C6F2E6C656E6774683B652B2B297B6C6574206E3D6F5B';
wwv_flow_imp.g_varchar2_table(44973) := '655D3B6966286E2E6C6566743C3D742E636C69656E745826266E2E72696768743E3D742E636C69656E745826266E2E746F703C3D742E636C69656E745926266E2E626F74746F6D3E3D742E636C69656E74592972657475726E21307D72657475726E2131';
wwv_flow_imp.g_varchar2_table(44974) := '7D28652C74297C7C31213D4E542874292926266E756C6C7D73746172742865297B21313D3D3D746869732E6472616767696E672626746869732E73656C6563742865297D6D6F76652865297B696628303D3D652E627574746F6E732972657475726E2074';
wwv_flow_imp.g_varchar2_table(44975) := '6869732E64657374726F7928293B696628746869732E6472616767696E677C7C6E756C6C3D3D746869732E6472616767696E67262666756E6374696F6E28652C74297B72657475726E204D6174682E6D6178284D6174682E61627328652E636C69656E74';
wwv_flow_imp.g_varchar2_table(44976) := '582D742E636C69656E7458292C4D6174682E61627328652E636C69656E74592D742E636C69656E745929297D28746869732E73746172744576656E742C65293C31302972657475726E3B746869732E73656C65637428746869732E6C6173744576656E74';
wwv_flow_imp.g_varchar2_table(44977) := '3D65293B6C657420743D302C6E3D302C693D302C6F3D302C733D746869732E766965772E77696E2E696E6E657257696474682C723D746869732E766965772E77696E2E696E6E65724865696768743B746869732E7363726F6C6C506172656E74732E7826';
wwv_flow_imp.g_varchar2_table(44978) := '26287B6C6566743A692C72696768743A737D3D746869732E7363726F6C6C506172656E74732E782E676574426F756E64696E67436C69656E74526563742829292C746869732E7363726F6C6C506172656E74732E792626287B746F703A6F2C626F74746F';
wwv_flow_imp.g_varchar2_table(44979) := '6D3A727D3D746869732E7363726F6C6C506172656E74732E792E676574426F756E64696E67436C69656E74526563742829293B6C657420613D7A4428746869732E76696577293B652E636C69656E74582D612E6C6566743C3D692B363F743D2D62542869';
wwv_flow_imp.g_varchar2_table(44980) := '2D652E636C69656E7458293A652E636C69656E74582B612E72696768743E3D732D36262628743D625428652E636C69656E74582D7329292C652E636C69656E74592D612E746F703C3D6F2B363F6E3D2D6254286F2D652E636C69656E7459293A652E636C';
wwv_flow_imp.g_varchar2_table(44981) := '69656E74592B612E626F74746F6D3E3D722D362626286E3D625428652E636C69656E74592D7229292C746869732E7365745363726F6C6C537065656428742C6E297D75702865297B6E756C6C3D3D746869732E6472616767696E672626746869732E7365';
wwv_flow_imp.g_varchar2_table(44982) := '6C65637428746869732E6C6173744576656E74292C746869732E6472616767696E677C7C652E70726576656E7444656661756C7428292C746869732E64657374726F7928297D64657374726F7928297B746869732E7365745363726F6C6C537065656428';
wwv_flow_imp.g_varchar2_table(44983) := '302C30293B6C657420653D746869732E766965772E636F6E74656E74444F4D2E6F776E6572446F63756D656E743B652E72656D6F76654576656E744C697374656E657228226D6F7573656D6F7665222C746869732E6D6F7665292C652E72656D6F766545';
wwv_flow_imp.g_varchar2_table(44984) := '76656E744C697374656E657228226D6F7573657570222C746869732E7570292C746869732E766965772E696E70757453746174652E6D6F75736553656C656374696F6E3D746869732E766965772E696E70757453746174652E64726167676564436F6E74';
wwv_flow_imp.g_varchar2_table(44985) := '656E743D6E756C6C7D7365745363726F6C6C537065656428652C74297B746869732E7363726F6C6C53706565643D7B783A652C793A747D2C657C7C743F746869732E7363726F6C6C696E673C30262628746869732E7363726F6C6C696E673D736574496E';
wwv_flow_imp.g_varchar2_table(44986) := '74657276616C282828293D3E746869732E7363726F6C6C2829292C353029293A746869732E7363726F6C6C696E673E2D31262628636C656172496E74657276616C28746869732E7363726F6C6C696E67292C746869732E7363726F6C6C696E673D2D3129';
wwv_flow_imp.g_varchar2_table(44987) := '7D7363726F6C6C28297B6C65747B783A652C793A747D3D746869732E7363726F6C6C53706565643B652626746869732E7363726F6C6C506172656E74732E78262628746869732E7363726F6C6C506172656E74732E782E7363726F6C6C4C6566742B3D65';
wwv_flow_imp.g_varchar2_table(44988) := '2C653D30292C742626746869732E7363726F6C6C506172656E74732E79262628746869732E7363726F6C6C506172656E74732E792E7363726F6C6C546F702B3D742C743D30292C28657C7C74292626746869732E766965772E77696E2E7363726F6C6C42';
wwv_flow_imp.g_varchar2_table(44989) := '7928652C74292C21313D3D3D746869732E6472616767696E672626746869732E73656C65637428746869732E6C6173744576656E74297D736B697041746F6D732865297B6C657420743D6E756C6C3B666F72286C6574206E3D303B6E3C652E72616E6765';
wwv_flow_imp.g_varchar2_table(44990) := '732E6C656E6774683B6E2B2B297B6C657420693D652E72616E6765735B6E5D2C6F3D6E756C6C3B696628692E656D707479297B6C657420653D695428746869732E61746F6D732C692E66726F6D2C30293B65213D692E66726F6D2626286F3D666B2E6375';
wwv_flow_imp.g_varchar2_table(44991) := '72736F7228652C2D3129297D656C73657B6C657420653D695428746869732E61746F6D732C692E66726F6D2C2D31292C743D695428746869732E61746F6D732C692E746F2C31293B653D3D692E66726F6D2626743D3D692E746F7C7C286F3D666B2E7261';
wwv_flow_imp.g_varchar2_table(44992) := '6E676528692E66726F6D3D3D692E616E63686F723F653A742C692E66726F6D3D3D692E686561643F653A7429297D6F262628747C7C28743D652E72616E6765732E736C6963652829292C745B6E5D3D6F297D72657475726E20743F666B2E637265617465';
wwv_flow_imp.g_varchar2_table(44993) := '28742C652E6D61696E496E646578293A657D73656C6563742865297B6C65747B766965773A747D3D746869732C6E3D746869732E736B697041746F6D7328746869732E7374796C652E67657428652C746869732E657874656E642C746869732E6D756C74';
wwv_flow_imp.g_varchar2_table(44994) := '69706C6529293B21746869732E6D75737453656C65637426266E2E657128742E73746174652E73656C656374696F6E2C21313D3D3D746869732E6472616767696E67297C7C746869732E766965772E6469737061746368287B73656C656374696F6E3A6E';
wwv_flow_imp.g_varchar2_table(44995) := '2C757365724576656E743A2273656C6563742E706F696E746572227D292C746869732E6D75737453656C6563743D21317D7570646174652865297B652E7472616E73616374696F6E732E736F6D652828653D3E652E6973557365724576656E742822696E';
wwv_flow_imp.g_varchar2_table(44996) := '7075742E74797065222929293F746869732E64657374726F7928293A746869732E7374796C652E757064617465286529262673657454696D656F7574282828293D3E746869732E73656C65637428746869732E6C6173744576656E7429292C3230297D7D';
wwv_flow_imp.g_varchar2_table(44997) := '636F6E73742079543D4F626A6563742E637265617465286E756C6C292C77543D4F626A6563742E637265617465286E756C6C292C43543D5F4C2E696526265F4C2E69655F76657273696F6E3C31357C7C5F4C2E696F7326265F4C2E7765626B69745F7665';
wwv_flow_imp.g_varchar2_table(44998) := '7273696F6E3C3630343B66756E6374696F6E20535428652C742C6E297B666F72286C65742069206F6620652E6661636574287429296E3D69286E2C65293B72657475726E206E7D66756E6374696F6E20785428652C74297B743D535428652E7374617465';
wwv_flow_imp.g_varchar2_table(44999) := '2C62442C74293B6C6574206E2C7B73746174653A697D3D652C6F3D312C733D692E746F546578742874292C723D732E6C696E65733D3D692E73656C656374696F6E2E72616E6765732E6C656E6774682C613D6E756C6C213D4F542626692E73656C656374';
wwv_flow_imp.g_varchar2_table(45000) := '696F6E2E72616E6765732E65766572792828653D3E652E656D707479292926264F543D3D732E746F537472696E6728293B69662861297B6C657420653D2D313B6E3D692E6368616E6765427952616E676528286E3D3E7B6C657420613D692E646F632E6C';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(45001) := '696E654174286E2E66726F6D293B696628612E66726F6D3D3D652972657475726E7B72616E67653A6E7D3B653D612E66726F6D3B6C6574206C3D692E746F546578742828723F732E6C696E65286F2B2B292E746578743A74292B692E6C696E6542726561';
wwv_flow_imp.g_varchar2_table(45002) := '6B293B72657475726E7B6368616E6765733A7B66726F6D3A612E66726F6D2C696E736572743A6C7D2C72616E67653A666B2E637572736F72286E2E66726F6D2B6C2E6C656E677468297D7D29297D656C7365206E3D723F692E6368616E6765427952616E';
wwv_flow_imp.g_varchar2_table(45003) := '67652828653D3E7B6C657420743D732E6C696E65286F2B2B293B72657475726E7B6368616E6765733A7B66726F6D3A652E66726F6D2C746F3A652E746F2C696E736572743A742E746578747D2C72616E67653A666B2E637572736F7228652E66726F6D2B';
wwv_flow_imp.g_varchar2_table(45004) := '742E6C656E677468297D7D29293A692E7265706C61636553656C656374696F6E2873293B652E6469737061746368286E2C7B757365724576656E743A22696E7075742E7061737465222C7363726F6C6C496E746F566965773A21307D297D66756E637469';
wwv_flow_imp.g_varchar2_table(45005) := '6F6E206B5428652C742C6E2C69297B696628313D3D692972657475726E20666B2E637572736F7228742C6E293B696628323D3D692972657475726E2066756E6374696F6E28652C742C6E3D31297B6C657420693D652E6368617243617465676F72697A65';
wwv_flow_imp.g_varchar2_table(45006) := '722874292C6F3D652E646F632E6C696E6541742874292C733D742D6F2E66726F6D3B696628303D3D6F2E6C656E6774682972657475726E20666B2E637572736F722874293B303D3D733F6E3D313A733D3D6F2E6C656E6774682626286E3D2D31293B6C65';
wwv_flow_imp.g_varchar2_table(45007) := '7420723D732C613D733B6E3C303F723D5A78286F2E746578742C732C2131293A613D5A78286F2E746578742C73293B6C6574206C3D69286F2E746578742E736C69636528722C6129293B666F72283B723E303B297B6C657420653D5A78286F2E74657874';
wwv_flow_imp.g_varchar2_table(45008) := '2C722C2131293B69662869286F2E746578742E736C69636528652C722929213D6C29627265616B3B723D657D666F72283B613C6F2E6C656E6774683B297B6C657420653D5A78286F2E746578742C61293B69662869286F2E746578742E736C6963652861';
wwv_flow_imp.g_varchar2_table(45009) := '2C652929213D6C29627265616B3B613D657D72657475726E20666B2E72616E676528722B6F2E66726F6D2C612B6F2E66726F6D297D28652E73746174652C742C6E293B7B6C6574206E3D7A4C2E66696E6428652E646F63566965772C74292C693D652E73';
wwv_flow_imp.g_varchar2_table(45010) := '746174652E646F632E6C696E654174286E3F6E2E706F734174456E643A74292C6F3D6E3F6E2E706F73417453746172743A692E66726F6D2C733D6E3F6E2E706F734174456E643A692E746F3B72657475726E20733C652E73746174652E646F632E6C656E';
wwv_flow_imp.g_varchar2_table(45011) := '6774682626733D3D692E746F2626732B2B2C666B2E72616E6765286F2C73297D7D77542E7363726F6C6C3D653D3E7B652E696E70757453746174652E6C6173745363726F6C6C546F703D652E7363726F6C6C444F4D2E7363726F6C6C546F702C652E696E';
wwv_flow_imp.g_varchar2_table(45012) := '70757453746174652E6C6173745363726F6C6C4C6566743D652E7363726F6C6C444F4D2E7363726F6C6C4C6566747D2C79542E6B6579646F776E3D28652C74293D3E28652E696E70757453746174652E73657453656C656374696F6E4F726967696E2822';
wwv_flow_imp.g_varchar2_table(45013) := '73656C65637422292C32373D3D742E6B6579436F6465262630213D652E696E70757453746174652E746162466F6375734D6F6465262628652E696E70757453746174652E746162466F6375734D6F64653D446174652E6E6F7728292B326533292C213129';
wwv_flow_imp.g_varchar2_table(45014) := '2C77542E746F75636873746172743D28652C74293D3E7B652E696E70757453746174652E6C617374546F75636854696D653D446174652E6E6F7728292C652E696E70757453746174652E73657453656C656374696F6E4F726967696E282273656C656374';
wwv_flow_imp.g_varchar2_table(45015) := '2E706F696E74657222297D2C77542E746F7563686D6F76653D653D3E7B652E696E70757453746174652E73657453656C656374696F6E4F726967696E282273656C6563742E706F696E74657222297D2C79542E6D6F757365646F776E3D28652C74293D3E';
wwv_flow_imp.g_varchar2_table(45016) := '7B696628652E6F627365727665722E666C75736828292C652E696E70757453746174652E6C617374546F75636854696D653E446174652E6E6F7728292D3265332972657475726E21313B6C6574206E3D6E756C6C3B666F72286C65742069206F6620652E';
wwv_flow_imp.g_varchar2_table(45017) := '73746174652E666163657428704429296966286E3D6928652C74292C6E29627265616B3B6966286E7C7C30213D742E627574746F6E7C7C286E3D66756E6374696F6E28652C74297B6C6574206E3D445428652C74292C693D4E542874292C6F3D652E7374';
wwv_flow_imp.g_varchar2_table(45018) := '6174652E73656C656374696F6E3B72657475726E7B7570646174652865297B652E646F634368616E6765642626286E2E706F733D652E6368616E6765732E6D6170506F73286E2E706F73292C6F3D6F2E6D617028652E6368616E67657329297D2C676574';
wwv_flow_imp.g_varchar2_table(45019) := '28742C732C72297B6C657420612C6C3D445428652C74292C633D6B5428652C6C2E706F732C6C2E626961732C69293B6966286E2E706F73213D6C2E706F7326262173297B6C657420743D6B5428652C6E2E706F732C6E2E626961732C69292C6F3D4D6174';
wwv_flow_imp.g_varchar2_table(45020) := '682E6D696E28742E66726F6D2C632E66726F6D292C733D4D6174682E6D617828742E746F2C632E746F293B633D6F3C632E66726F6D3F666B2E72616E6765286F2C73293A666B2E72616E676528732C6F297D72657475726E20733F6F2E7265706C616365';
wwv_flow_imp.g_varchar2_table(45021) := '52616E6765286F2E6D61696E2E657874656E6428632E66726F6D2C632E746F29293A722626313D3D6926266F2E72616E6765732E6C656E6774683E31262628613D66756E6374696F6E28652C74297B666F72286C6574206E3D303B6E3C652E72616E6765';
wwv_flow_imp.g_varchar2_table(45022) := '732E6C656E6774683B6E2B2B297B6C65747B66726F6D3A692C746F3A6F7D3D652E72616E6765735B6E5D3B696628693C3D7426266F3E3D742972657475726E20666B2E63726561746528652E72616E6765732E736C69636528302C6E292E636F6E636174';
wwv_flow_imp.g_varchar2_table(45023) := '28652E72616E6765732E736C696365286E2B3129292C652E6D61696E496E6465783D3D6E3F303A652E6D61696E496E6465782D28652E6D61696E496E6465783E6E3F313A3029297D72657475726E206E756C6C7D286F2C6C2E706F7329293F613A723F6F';
wwv_flow_imp.g_varchar2_table(45024) := '2E61646452616E67652863293A666B2E637265617465285B635D297D7D7D28652C7429292C6E297B6C657420693D21652E686173466F6375733B652E696E70757453746174652E73746172744D6F75736553656C656374696F6E286E6577205F5428652C';
wwv_flow_imp.g_varchar2_table(45025) := '742C6E2C6929292C692626652E6F627365727665722E69676E6F7265282828293D3E7B474528652E636F6E74656E74444F4D293B6C657420743D652E726F6F742E616374697665456C656D656E743B74262621742E636F6E7461696E7328652E636F6E74';
wwv_flow_imp.g_varchar2_table(45026) := '656E74444F4D292626742E626C757228297D29293B6C6574206F3D652E696E70757453746174652E6D6F75736553656C656374696F6E3B6966286F2972657475726E206F2E73746172742874292C21313D3D3D6F2E6472616767696E677D72657475726E';
wwv_flow_imp.g_varchar2_table(45027) := '21317D3B6C65742045543D28652C742C6E293D3E743E3D6E2E746F702626743C3D6E2E626F74746F6D2626653E3D6E2E6C6566742626653C3D6E2E72696768743B66756E6374696F6E204C5428652C742C6E2C69297B6C6574206F3D7A4C2E66696E6428';
wwv_flow_imp.g_varchar2_table(45028) := '652E646F63566965772C74293B696628216F2972657475726E20313B6C657420733D742D6F2E706F73417453746172743B696628303D3D732972657475726E20313B696628733D3D6F2E6C656E6774682972657475726E2D313B6C657420723D6F2E636F';
wwv_flow_imp.g_varchar2_table(45029) := '6F726473417428732C2D31293B6966287226264554286E2C692C72292972657475726E2D313B6C657420613D6F2E636F6F726473417428732C31293B72657475726E206126264554286E2C692C61293F313A722626722E626F74746F6D3E3D693F2D313A';
wwv_flow_imp.g_varchar2_table(45030) := '317D66756E6374696F6E20445428652C74297B6C6574206E3D652E706F734174436F6F726473287B783A742E636C69656E74582C793A742E636C69656E74597D2C2131293B72657475726E7B706F733A6E2C626961733A4C5428652C6E2C742E636C6965';
wwv_flow_imp.g_varchar2_table(45031) := '6E74582C742E636C69656E7459297D7D636F6E73742054543D5F4C2E696526265F4C2E69655F76657273696F6E3C3D31313B6C65742049543D6E756C6C2C4D543D302C41543D303B66756E6374696F6E204E542865297B6966282154542972657475726E';
wwv_flow_imp.g_varchar2_table(45032) := '20652E64657461696C3B6C657420743D49542C6E3D41543B72657475726E2049543D652C41543D446174652E6E6F7728292C4D543D21747C7C6E3E446174652E6E6F7728292D34303026264D6174682E61627328742E636C69656E74582D652E636C6965';
wwv_flow_imp.g_varchar2_table(45033) := '6E7458293C3226264D6174682E61627328742E636C69656E74592D652E636C69656E7459293C323F284D542B312925333A317D66756E6374696F6E20505428652C742C6E2C69297B69662821286E3D535428652E73746174652C62442C6E292929726574';
wwv_flow_imp.g_varchar2_table(45034) := '75726E3B6C6574206F3D652E706F734174436F6F726473287B783A742E636C69656E74582C793A742E636C69656E74597D2C2131292C7B64726167676564436F6E74656E743A737D3D652E696E70757453746174652C723D69262673262666756E637469';
wwv_flow_imp.g_varchar2_table(45035) := '6F6E28652C74297B6C6574206E3D652E73746174652E6661636574287544293B72657475726E206E2E6C656E6774683F6E5B305D2874293A5F4C2E6D61633F21742E616C744B65793A21742E6374726C4B65797D28652C74293F7B66726F6D3A732E6672';
wwv_flow_imp.g_varchar2_table(45036) := '6F6D2C746F3A732E746F7D3A6E756C6C2C613D7B66726F6D3A6F2C696E736572743A6E7D2C6C3D652E73746174652E6368616E67657328723F5B722C615D3A61293B652E666F63757328292C652E6469737061746368287B6368616E6765733A6C2C7365';
wwv_flow_imp.g_varchar2_table(45037) := '6C656374696F6E3A7B616E63686F723A6C2E6D6170506F73286F2C2D31292C686561643A6C2E6D6170506F73286F2C31297D2C757365724576656E743A723F226D6F76652E64726F70223A22696E7075742E64726F70227D292C652E696E707574537461';
wwv_flow_imp.g_varchar2_table(45038) := '74652E64726167676564436F6E74656E743D6E756C6C7D79542E6472616773746172743D28652C74293D3E7B6C65747B73656C656374696F6E3A7B6D61696E3A6E7D7D3D652E73746174653B696628742E7461726765742E647261676761626C65297B6C';
wwv_flow_imp.g_varchar2_table(45039) := '657420693D652E646F63566965772E6E65617265737428742E746172676574293B696628692626692E6973576964676574297B6C657420653D692E706F73417453746172742C743D652B692E6C656E6774683B28653E3D6E2E746F7C7C743C3D6E2E6672';
wwv_flow_imp.g_varchar2_table(45040) := '6F6D292626286E3D666B2E72616E676528652C7429297D7D6C65747B696E70757453746174653A697D3D653B72657475726E20692E6D6F75736553656C656374696F6E262628692E6D6F75736553656C656374696F6E2E6472616767696E673D2130292C';
wwv_flow_imp.g_varchar2_table(45041) := '692E64726167676564436F6E74656E743D6E2C742E646174615472616E73666572262628742E646174615472616E736665722E73657444617461282254657874222C535428652E73746174652C5F442C652E73746174652E736C696365446F63286E2E66';
wwv_flow_imp.g_varchar2_table(45042) := '726F6D2C6E2E746F2929292C742E646174615472616E736665722E656666656374416C6C6F7765643D22636F70794D6F766522292C21317D2C79542E64726167656E643D653D3E28652E696E70757453746174652E64726167676564436F6E74656E743D';
wwv_flow_imp.g_varchar2_table(45043) := '6E756C6C2C2131292C79542E64726F703D28652C74293D3E7B69662821742E646174615472616E736665722972657475726E21313B696628652E73746174652E726561644F6E6C792972657475726E21303B6C6574206E3D742E646174615472616E7366';
wwv_flow_imp.g_varchar2_table(45044) := '65722E66696C65733B6966286E26266E2E6C656E677468297B6C657420693D4172726179286E2E6C656E677468292C6F3D302C733D28293D3E7B2B2B6F3D3D6E2E6C656E6774682626505428652C742C692E66696C7465722828653D3E6E756C6C213D65';
wwv_flow_imp.g_varchar2_table(45045) := '29292E6A6F696E28652E73746174652E6C696E65427265616B292C2131297D3B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B297B6C657420743D6E65772046696C655265616465723B742E6F6E6572726F723D732C742E6F6E6C6F61';
wwv_flow_imp.g_varchar2_table(45046) := '643D28293D3E7B2F5B5C7830302D5C7830385C7830652D5C7831665D7B327D2F2E7465737428742E726573756C74297C7C28695B655D3D742E726573756C74292C7328297D2C742E72656164417354657874286E5B655D297D72657475726E21307D7B6C';
wwv_flow_imp.g_varchar2_table(45047) := '6574206E3D742E646174615472616E736665722E6765744461746128225465787422293B6966286E2972657475726E20505428652C742C6E2C2130292C21307D72657475726E21317D2C79542E70617374653D28652C74293D3E7B696628652E73746174';
wwv_flow_imp.g_varchar2_table(45048) := '652E726561644F6E6C792972657475726E21303B652E6F627365727665722E666C75736828293B6C6574206E3D43543F6E756C6C3A742E636C6970626F617264446174613B72657475726E206E3F28785428652C6E2E676574446174612822746578742F';
wwv_flow_imp.g_varchar2_table(45049) := '706C61696E22297C7C6E2E676574446174612822746578742F7572692D6C6973742229292C2130293A2866756E6374696F6E2865297B6C657420743D652E646F6D2E706172656E744E6F64653B69662821742972657475726E3B6C6574206E3D742E6170';
wwv_flow_imp.g_varchar2_table(45050) := '70656E644368696C6428646F63756D656E742E637265617465456C656D656E74282274657874617265612229293B6E2E7374796C652E637373546578743D22706F736974696F6E3A2066697865643B206C6566743A202D313030303070783B20746F703A';
wwv_flow_imp.g_varchar2_table(45051) := '2031307078222C6E2E666F63757328292C73657454696D656F7574282828293D3E7B652E666F63757328292C6E2E72656D6F766528292C785428652C6E2E76616C7565297D292C3530297D2865292C2131297D3B6C6574204F543D6E756C6C3B79542E63';
wwv_flow_imp.g_varchar2_table(45052) := '6F70793D79542E6375743D28652C74293D3E7B6C65747B746578743A6E2C72616E6765733A692C6C696E65776973653A6F7D3D66756E6374696F6E2865297B6C657420743D5B5D2C6E3D5B5D2C693D21313B666F72286C65742069206F6620652E73656C';
wwv_flow_imp.g_varchar2_table(45053) := '656374696F6E2E72616E67657329692E656D7074797C7C28742E7075736828652E736C696365446F6328692E66726F6D2C692E746F29292C6E2E70757368286929293B69662821742E6C656E677468297B6C6574206F3D2D313B666F72286C65747B6672';
wwv_flow_imp.g_varchar2_table(45054) := '6F6D3A697D6F6620652E73656C656374696F6E2E72616E676573297B6C657420733D652E646F632E6C696E6541742869293B732E6E756D6265723E6F262628742E7075736828732E74657874292C6E2E70757368287B66726F6D3A732E66726F6D2C746F';
wwv_flow_imp.g_varchar2_table(45055) := '3A4D6174682E6D696E28652E646F632E6C656E6774682C732E746F2B31297D29292C6F3D732E6E756D6265727D693D21307D72657475726E7B746578743A535428652C5F442C742E6A6F696E28652E6C696E65427265616B29292C72616E6765733A6E2C';
wwv_flow_imp.g_varchar2_table(45056) := '6C696E65776973653A697D7D28652E7374617465293B696628216E2626216F2972657475726E21313B4F543D6F3F6E3A6E756C6C2C2263757422213D742E747970657C7C652E73746174652E726561644F6E6C797C7C652E6469737061746368287B6368';
wwv_flow_imp.g_varchar2_table(45057) := '616E6765733A692C7363726F6C6C496E746F566965773A21302C757365724576656E743A2264656C6574652E637574227D293B6C657420733D43543F6E756C6C3A742E636C6970626F617264446174613B72657475726E20733F28732E636C6561724461';
wwv_flow_imp.g_varchar2_table(45058) := '746128292C732E736574446174612822746578742F706C61696E222C6E292C2130293A2866756E6374696F6E28652C74297B6C6574206E3D652E646F6D2E706172656E744E6F64653B696628216E2972657475726E3B6C657420693D6E2E617070656E64';
wwv_flow_imp.g_varchar2_table(45059) := '4368696C6428646F63756D656E742E637265617465456C656D656E74282274657874617265612229293B692E7374796C652E637373546578743D22706F736974696F6E3A2066697865643B206C6566743A202D313030303070783B20746F703A20313070';
wwv_flow_imp.g_varchar2_table(45060) := '78222C692E76616C75653D742C692E666F63757328292C692E73656C656374696F6E456E643D742E6C656E6774682C692E73656C656374696F6E53746172743D302C73657454696D656F7574282828293D3E7B692E72656D6F766528292C652E666F6375';
wwv_flow_imp.g_varchar2_table(45061) := '7328297D292C3530297D28652C6E292C2131297D3B636F6E73742052543D576B2E646566696E6528293B66756E6374696F6E20465428652C74297B6C6574206E3D5B5D3B666F72286C65742069206F6620652E666163657428764429297B6C6574206F3D';
wwv_flow_imp.g_varchar2_table(45062) := '6928652C74293B6F26266E2E70757368286F297D72657475726E206E3F652E757064617465287B656666656374733A6E2C616E6E6F746174696F6E733A52542E6F66282130297D293A6E756C6C7D66756E6374696F6E2042542865297B73657454696D65';
wwv_flow_imp.g_varchar2_table(45063) := '6F7574282828293D3E7B6C657420743D652E686173466F6375733B69662874213D652E696E70757453746174652E6E6F746966696564466F6375736564297B6C6574206E3D465428652E73746174652C74293B6E3F652E6469737061746368286E293A65';
wwv_flow_imp.g_varchar2_table(45064) := '2E757064617465285B5D297D7D292C3130297D77542E666F6375733D653D3E7B652E696E70757453746174652E6C617374466F63757354696D653D446174652E6E6F7728292C652E7363726F6C6C444F4D2E7363726F6C6C546F707C7C21652E696E7075';
wwv_flow_imp.g_varchar2_table(45065) := '7453746174652E6C6173745363726F6C6C546F70262621652E696E70757453746174652E6C6173745363726F6C6C4C6566747C7C28652E7363726F6C6C444F4D2E7363726F6C6C546F703D652E696E70757453746174652E6C6173745363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(45066) := '702C652E7363726F6C6C444F4D2E7363726F6C6C4C6566743D652E696E70757453746174652E6C6173745363726F6C6C4C656674292C42542865297D2C77542E626C75723D653D3E7B652E6F627365727665722E636C65617253656C656374696F6E5261';
wwv_flow_imp.g_varchar2_table(45067) := '6E676528292C42542865297D2C77542E636F6D706F736974696F6E73746172743D77542E636F6D706F736974696F6E7570646174653D653D3E7B652E6F627365727665722E65646974436F6E746578747C7C286E756C6C3D3D652E696E70757453746174';
wwv_flow_imp.g_varchar2_table(45068) := '652E636F6D706F736974696F6E46697273744368616E6765262628652E696E70757453746174652E636F6D706F736974696F6E46697273744368616E67653D2130292C652E696E70757453746174652E636F6D706F73696E673C30262628652E696E7075';
wwv_flow_imp.g_varchar2_table(45069) := '7453746174652E636F6D706F73696E673D3029297D2C77542E636F6D706F736974696F6E656E643D653D3E7B652E6F627365727665722E65646974436F6E746578747C7C28652E696E70757453746174652E636F6D706F73696E673D2D312C652E696E70';
wwv_flow_imp.g_varchar2_table(45070) := '757453746174652E636F6D706F736974696F6E456E64656441743D446174652E6E6F7728292C652E696E70757453746174652E636F6D706F736974696F6E50656E64696E674B65793D21302C652E696E70757453746174652E636F6D706F736974696F6E';
wwv_flow_imp.g_varchar2_table(45071) := '50656E64696E674368616E67653D652E6F627365727665722E70656E64696E675265636F72647328292E6C656E6774683E302C652E696E70757453746174652E636F6D706F736974696F6E46697273744368616E67653D6E756C6C2C5F4C2E6368726F6D';
wwv_flow_imp.g_varchar2_table(45072) := '6526265F4C2E616E64726F69643F652E6F627365727665722E666C757368536F6F6E28293A652E696E70757453746174652E636F6D706F736974696F6E50656E64696E674368616E67653F50726F6D6973652E7265736F6C766528292E7468656E282828';
wwv_flow_imp.g_varchar2_table(45073) := '293D3E652E6F627365727665722E666C757368282929293A73657454696D656F7574282828293D3E7B652E696E70757453746174652E636F6D706F73696E673C302626652E646F63566965772E686173436F6D706F736974696F6E2626652E7570646174';
wwv_flow_imp.g_varchar2_table(45074) := '65285B5D297D292C353029297D2C77542E636F6E746578746D656E753D653D3E7B652E696E70757453746174652E6C617374436F6E746578744D656E753D446174652E6E6F7728297D2C79542E6265666F7265696E7075743D28652C74293D3E7B766172';
wwv_flow_imp.g_varchar2_table(45075) := '206E2C693B69662822696E736572745265706C6163656D656E7454657874223D3D742E696E707574547970652626652E6F627365727665722E65646974436F6E74657874297B6C657420693D6E756C6C3D3D3D286E3D742E646174615472616E73666572';
wwv_flow_imp.g_varchar2_table(45076) := '297C7C766F696420303D3D3D6E3F766F696420303A6E2E676574446174612822746578742F706C61696E22292C6F3D742E67657454617267657452616E67657328293B6966286926266F2E6C656E677468297B6C657420743D6F5B305D2C6E3D652E706F';
wwv_flow_imp.g_varchar2_table(45077) := '734174444F4D28742E7374617274436F6E7461696E65722C742E73746172744F6666736574292C733D652E706F734174444F4D28742E656E64436F6E7461696E65722C742E656E644F6666736574293B72657475726E20685428652C7B66726F6D3A6E2C';
wwv_flow_imp.g_varchar2_table(45078) := '746F3A732C696E736572743A652E73746174652E746F546578742869297D2C6E756C6C292C21307D7D6C6574206F3B6966285F4C2E6368726F6D6526265F4C2E616E64726F69642626286F3D6D542E66696E642828653D3E652E696E707574547970653D';
wwv_flow_imp.g_varchar2_table(45079) := '3D742E696E70757454797065292929262628652E6F627365727665722E64656C6179416E64726F69644B6579286F2E6B65792C6F2E6B6579436F6465292C224261636B7370616365223D3D6F2E6B65797C7C2244656C657465223D3D6F2E6B657929297B';
wwv_flow_imp.g_varchar2_table(45080) := '6C657420743D286E756C6C3D3D3D28693D77696E646F772E76697375616C56696577706F7274297C7C766F696420303D3D3D693F766F696420303A692E686569676874297C7C303B73657454696D656F7574282828293D3E7B766172206E3B28286E756C';
wwv_flow_imp.g_varchar2_table(45081) := '6C3D3D3D286E3D77696E646F772E76697375616C56696577706F7274297C7C766F696420303D3D3D6E3F766F696420303A6E2E686569676874297C7C30293E742B31302626652E686173466F637573262628652E636F6E74656E74444F4D2E626C757228';
wwv_flow_imp.g_varchar2_table(45082) := '292C652E666F6375732829297D292C313030297D72657475726E205F4C2E696F7326262264656C657465436F6E74656E74466F7277617264223D3D742E696E707574547970652626652E6F627365727665722E666C757368536F6F6E28292C5F4C2E7361';
wwv_flow_imp.g_varchar2_table(45083) := '66617269262622696E7365727454657874223D3D742E696E707574547970652626652E696E70757453746174652E636F6D706F73696E673E3D30262673657454696D656F7574282828293D3E77542E636F6D706F736974696F6E656E6428652C7429292C';
wwv_flow_imp.g_varchar2_table(45084) := '3230292C21317D3B636F6E73742056543D6E6577205365742C7A543D5B227072652D77726170222C226E6F726D616C222C227072652D6C696E65222C22627265616B2D737061636573225D3B6C65742048543D21313B66756E6374696F6E20575428297B';
wwv_flow_imp.g_varchar2_table(45085) := '48543D21317D636C617373206A547B636F6E7374727563746F722865297B746869732E6C696E655772617070696E673D652C746869732E646F633D46782E656D7074792C746869732E68656967687453616D706C65733D7B7D2C746869732E6C696E6548';
wwv_flow_imp.g_varchar2_table(45086) := '65696768743D31342C746869732E6368617257696474683D372C746869732E746578744865696768743D31342C746869732E6C696E654C656E6774683D33307D686569676874466F7247617028652C74297B6C6574206E3D746869732E646F632E6C696E';
wwv_flow_imp.g_varchar2_table(45087) := '6541742874292E6E756D6265722D746869732E646F632E6C696E6541742865292E6E756D6265722B313B72657475726E20746869732E6C696E655772617070696E672626286E2B3D4D6174682E6D617828302C4D6174682E6365696C2828742D652D6E2A';
wwv_flow_imp.g_varchar2_table(45088) := '746869732E6C696E654C656E6774682A2E35292F746869732E6C696E654C656E6774682929292C746869732E6C696E654865696768742A6E7D686569676874466F724C696E652865297B72657475726E20746869732E6C696E655772617070696E673F28';
wwv_flow_imp.g_varchar2_table(45089) := '312B4D6174682E6D617828302C4D6174682E6365696C2828652D746869732E6C696E654C656E677468292F28746869732E6C696E654C656E6774682D35292929292A746869732E6C696E654865696768743A746869732E6C696E654865696768747D7365';
wwv_flow_imp.g_varchar2_table(45090) := '74446F632865297B72657475726E20746869732E646F633D652C746869737D6D75737452656672657368466F725772617070696E672865297B72657475726E207A542E696E6465784F662865293E2D31213D746869732E6C696E655772617070696E677D';
wwv_flow_imp.g_varchar2_table(45091) := '6D75737452656672657368466F72486569676874732865297B6C657420743D21313B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B297B6C657420693D655B6E5D3B693C303F6E2B2B3A746869732E68656967687453616D706C65735B';
wwv_flow_imp.g_varchar2_table(45092) := '4D6174682E666C6F6F722831302A69295D7C7C28743D21302C746869732E68656967687453616D706C65735B4D6174682E666C6F6F722831302A69295D3D2130297D72657475726E20747D7265667265736828652C742C6E2C692C6F2C73297B6C657420';
wwv_flow_imp.g_varchar2_table(45093) := '723D7A542E696E6465784F662865293E2D312C613D4D6174682E726F756E64287429213D4D6174682E726F756E6428746869732E6C696E65486569676874297C7C746869732E6C696E655772617070696E67213D723B696628746869732E6C696E655772';
wwv_flow_imp.g_varchar2_table(45094) := '617070696E673D722C746869732E6C696E654865696768743D742C746869732E6368617257696474683D6E2C746869732E746578744865696768743D692C746869732E6C696E654C656E6774683D6F2C61297B746869732E68656967687453616D706C65';
wwv_flow_imp.g_varchar2_table(45095) := '733D7B7D3B666F72286C657420653D303B653C732E6C656E6774683B652B2B297B6C657420743D735B655D3B743C303F652B2B3A746869732E68656967687453616D706C65735B4D6174682E666C6F6F722831302A74295D3D21307D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(45096) := '617D7D636C6173732071547B636F6E7374727563746F7228652C74297B746869732E66726F6D3D652C746869732E686569676874733D742C746869732E696E6465783D307D676574206D6F726528297B72657475726E20746869732E696E6465783C7468';
wwv_flow_imp.g_varchar2_table(45097) := '69732E686569676874732E6C656E6774687D7D636C6173732024547B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E66726F6D3D652C746869732E6C656E6774683D742C746869732E746F703D6E2C746869732E6865696768743D';
wwv_flow_imp.g_varchar2_table(45098) := '692C746869732E5F636F6E74656E743D6F7D676574207479706528297B72657475726E226E756D626572223D3D747970656F6620746869732E5F636F6E74656E743F4E4C2E546578743A41727261792E6973417272617928746869732E5F636F6E74656E';
wwv_flow_imp.g_varchar2_table(45099) := '74293F746869732E5F636F6E74656E743A746869732E5F636F6E74656E742E747970657D67657420746F28297B72657475726E20746869732E66726F6D2B746869732E6C656E6774687D67657420626F74746F6D28297B72657475726E20746869732E74';
wwv_flow_imp.g_varchar2_table(45100) := '6F702B746869732E6865696768747D6765742077696467657428297B72657475726E20746869732E5F636F6E74656E7420696E7374616E63656F6620464C3F746869732E5F636F6E74656E742E7769646765743A6E756C6C7D676574207769646765744C';
wwv_flow_imp.g_varchar2_table(45101) := '696E65427265616B7328297B72657475726E226E756D626572223D3D747970656F6620746869732E5F636F6E74656E743F746869732E5F636F6E74656E743A307D6A6F696E2865297B6C657420743D2841727261792E6973417272617928746869732E5F';
wwv_flow_imp.g_varchar2_table(45102) := '636F6E74656E74293F746869732E5F636F6E74656E743A5B746869735D292E636F6E6361742841727261792E6973417272617928652E5F636F6E74656E74293F652E5F636F6E74656E743A5B655D293B72657475726E206E657720245428746869732E66';
wwv_flow_imp.g_varchar2_table(45103) := '726F6D2C746869732E6C656E6774682B652E6C656E6774682C746869732E746F702C746869732E6865696768742B652E6865696768742C74297D7D7661722055543D66756E6374696F6E2865297B72657475726E20655B652E4279506F733D305D3D2242';
wwv_flow_imp.g_varchar2_table(45104) := '79506F73222C655B652E42794865696768743D315D3D224279486569676874222C655B652E4279506F734E6F4865696768743D325D3D224279506F734E6F486569676874222C657D2855547C7C2855543D7B7D29293B636F6E7374204B543D2E3030313B';
wwv_flow_imp.g_varchar2_table(45105) := '636C6173732047547B636F6E7374727563746F7228652C742C6E3D32297B746869732E6C656E6774683D652C746869732E6865696768743D742C746869732E666C6167733D6E7D676574206F7574646174656428297B72657475726E283226746869732E';
wwv_flow_imp.g_varchar2_table(45106) := '666C616773293E307D736574206F757464617465642865297B746869732E666C6167733D28653F323A30297C2D3326746869732E666C6167737D7365744865696768742865297B746869732E686569676874213D652626284D6174682E61627328746869';
wwv_flow_imp.g_varchar2_table(45107) := '732E6865696768742D65293E4B5426262848543D2130292C746869732E6865696768743D65297D7265706C61636528652C742C6E297B72657475726E2047542E6F66286E297D6465636F6D706F73654C65667428652C74297B742E707573682874686973';
wwv_flow_imp.g_varchar2_table(45108) := '297D6465636F6D706F7365526967687428652C74297B742E707573682874686973297D6170706C794368616E67657328652C742C6E2C69297B6C6574206F3D746869732C733D6E2E646F633B666F72286C657420723D692E6C656E6774682D313B723E3D';
wwv_flow_imp.g_varchar2_table(45109) := '303B722D2D297B6C65747B66726F6D413A612C746F413A6C2C66726F6D423A632C746F423A647D3D695B725D2C683D6F2E6C696E65417428612C55542E4279506F734E6F4865696768742C6E2E736574446F632874292C302C30292C753D682E746F3E3D';
wwv_flow_imp.g_varchar2_table(45110) := '6C3F683A6F2E6C696E654174286C2C55542E4279506F734E6F4865696768742C6E2C302C30293B666F7228642B3D752E746F2D6C2C6C3D752E746F3B723E302626682E66726F6D3C3D695B722D315D2E746F413B29613D695B722D315D2E66726F6D412C';
wwv_flow_imp.g_varchar2_table(45111) := '633D695B722D315D2E66726F6D422C722D2D2C613C682E66726F6D262628683D6F2E6C696E65417428612C55542E4279506F734E6F4865696768742C6E2C302C3029293B632B3D682E66726F6D2D612C613D682E66726F6D3B6C657420703D74492E6275';
wwv_flow_imp.g_varchar2_table(45112) := '696C64286E2E736574446F632873292C652C632C64293B6F3D5154286F2C6F2E7265706C61636528612C6C2C7029297D72657475726E206F2E757064617465486569676874286E2C30297D73746174696320656D70747928297B72657475726E206E6577';
wwv_flow_imp.g_varchar2_table(45113) := '205A5428302C30297D737461746963206F662865297B696628313D3D652E6C656E6774682972657475726E20655B305D3B6C657420743D302C6E3D652E6C656E6774682C693D302C6F3D303B666F72283B3B29696628743D3D6E29696628693E322A6F29';
wwv_flow_imp.g_varchar2_table(45114) := '7B6C6574206F3D655B742D315D3B6F2E627265616B3F652E73706C696365282D2D742C312C6F2E6C6566742C6E756C6C2C6F2E7269676874293A652E73706C696365282D2D742C312C6F2E6C6566742C6F2E7269676874292C6E2B3D312B6F2E62726561';
wwv_flow_imp.g_varchar2_table(45115) := '6B2C692D3D6F2E73697A657D656C73657B69662821286F3E322A692929627265616B3B7B6C657420743D655B6E5D3B742E627265616B3F652E73706C696365286E2C312C742E6C6566742C6E756C6C2C742E7269676874293A652E73706C696365286E2C';
wwv_flow_imp.g_varchar2_table(45116) := '312C742E6C6566742C742E7269676874292C6E2B3D322B742E627265616B2C6F2D3D742E73697A657D7D656C736520696628693C6F297B6C6574206E3D655B742B2B5D3B6E262628692B3D6E2E73697A65297D656C73657B6C657420743D655B2D2D6E5D';
wwv_flow_imp.g_varchar2_table(45117) := '3B742626286F2B3D742E73697A65297D6C657420733D303B72657475726E206E756C6C3D3D655B742D315D3F28733D312C742D2D293A6E756C6C3D3D655B745D262628733D312C6E2B2B292C6E6577204A542847542E6F6628652E736C69636528302C74';
wwv_flow_imp.g_varchar2_table(45118) := '29292C732C47542E6F6628652E736C696365286E2929297D7D66756E6374696F6E20515428652C74297B72657475726E20653D3D743F653A28652E636F6E7374727563746F72213D742E636F6E7374727563746F7226262848543D2130292C74297D4754';
wwv_flow_imp.g_varchar2_table(45119) := '2E70726F746F747970652E73697A653D313B636C61737320595420657874656E64732047547B636F6E7374727563746F7228652C742C6E297B737570657228652C74292C746869732E6465636F3D6E7D626C6F636B417428652C742C6E2C69297B726574';
wwv_flow_imp.g_varchar2_table(45120) := '75726E206E657720245428692C746869732E6C656E6774682C6E2C746869732E6865696768742C746869732E6465636F7C7C30297D6C696E65417428652C742C6E2C692C6F297B72657475726E20746869732E626C6F636B417428302C6E2C692C6F297D';
wwv_flow_imp.g_varchar2_table(45121) := '666F72456163684C696E6528652C742C6E2C692C6F2C73297B653C3D6F2B746869732E6C656E6774682626743E3D6F26267328746869732E626C6F636B417428302C6E2C692C6F29297D75706461746548656967687428652C743D302C6E3D21312C6929';
wwv_flow_imp.g_varchar2_table(45122) := '7B72657475726E20692626692E66726F6D3C3D742626692E6D6F72652626746869732E73657448656967687428692E686569676874735B692E696E6465782B2B5D292C746869732E6F757464617465643D21312C746869737D746F537472696E6728297B';
wwv_flow_imp.g_varchar2_table(45123) := '72657475726E60626C6F636B28247B746869732E6C656E6774687D29607D7D636C617373205A5420657874656E64732059547B636F6E7374727563746F7228652C74297B737570657228652C742C6E756C6C292C746869732E636F6C6C61707365643D30';
wwv_flow_imp.g_varchar2_table(45124) := '2C746869732E7769646765744865696768743D302C746869732E627265616B733D307D626C6F636B417428652C742C6E2C69297B72657475726E206E657720245428692C746869732E6C656E6774682C6E2C746869732E6865696768742C746869732E62';
wwv_flow_imp.g_varchar2_table(45125) := '7265616B73297D7265706C61636528652C742C6E297B6C657420693D6E5B305D3B72657475726E20313D3D6E2E6C656E6774682626286920696E7374616E63656F66205A547C7C6920696E7374616E63656F6620585426263426692E666C616773292626';
wwv_flow_imp.g_varchar2_table(45126) := '4D6174682E61627328746869732E6C656E6774682D692E6C656E677468293C31303F286920696E7374616E63656F662058543F693D6E6577205A5428692E6C656E6774682C746869732E686569676874293A692E6865696768743D746869732E68656967';
wwv_flow_imp.g_varchar2_table(45127) := '68742C746869732E6F757464617465647C7C28692E6F757464617465643D2131292C69293A47542E6F66286E297D75706461746548656967687428652C743D302C6E3D21312C69297B72657475726E20692626692E66726F6D3C3D742626692E6D6F7265';
wwv_flow_imp.g_varchar2_table(45128) := '3F746869732E73657448656967687428692E686569676874735B692E696E6465782B2B5D293A286E7C7C746869732E6F75746461746564292626746869732E736574486569676874284D6174682E6D617828746869732E7769646765744865696768742C';
wwv_flow_imp.g_varchar2_table(45129) := '652E686569676874466F724C696E6528746869732E6C656E6774682D746869732E636F6C6C617073656429292B746869732E627265616B732A652E6C696E65486569676874292C746869732E6F757464617465643D21312C746869737D746F537472696E';
wwv_flow_imp.g_varchar2_table(45130) := '6728297B72657475726E606C696E6528247B746869732E6C656E6774687D247B746869732E636F6C6C61707365643F2D746869732E636F6C6C61707365643A22227D247B746869732E7769646765744865696768743F223A222B746869732E7769646765';
wwv_flow_imp.g_varchar2_table(45131) := '744865696768743A22227D29607D7D636C61737320585420657874656E64732047547B636F6E7374727563746F722865297B737570657228652C30297D6865696768744D65747269637328652C74297B6C6574206E2C693D652E646F632E6C696E654174';
wwv_flow_imp.g_varchar2_table(45132) := '2874292E6E756D6265722C6F3D652E646F632E6C696E65417428742B746869732E6C656E677468292E6E756D6265722C733D6F2D692B312C723D303B696628652E6C696E655772617070696E67297B6C657420743D4D6174682E6D696E28746869732E68';
wwv_flow_imp.g_varchar2_table(45133) := '65696768742C652E6C696E654865696768742A73293B6E3D742F732C746869732E6C656E6774683E732B31262628723D28746869732E6865696768742D74292F28746869732E6C656E6774682D732D3129297D656C7365206E3D746869732E6865696768';
wwv_flow_imp.g_varchar2_table(45134) := '742F733B72657475726E7B66697273744C696E653A692C6C6173744C696E653A6F2C7065724C696E653A6E2C706572436861723A727D7D626C6F636B417428652C742C6E2C69297B6C65747B66697273744C696E653A6F2C6C6173744C696E653A732C70';
wwv_flow_imp.g_varchar2_table(45135) := '65724C696E653A722C706572436861723A617D3D746869732E6865696768744D65747269637328742C69293B696628742E6C696E655772617070696E67297B6C6574206F3D692B28653C742E6C696E654865696768743F303A4D6174682E726F756E6428';
wwv_flow_imp.g_varchar2_table(45136) := '4D6174682E6D617828302C4D6174682E6D696E28312C28652D6E292F746869732E68656967687429292A746869732E6C656E67746829292C733D742E646F632E6C696E654174286F292C6C3D722B732E6C656E6774682A612C633D4D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(45137) := '6E2C652D6C2F32293B72657475726E206E657720245428732E66726F6D2C732E6C656E6774682C632C6C2C30297D7B6C657420693D4D6174682E6D617828302C4D6174682E6D696E28732D6F2C4D6174682E666C6F6F722828652D6E292F722929292C7B';
wwv_flow_imp.g_varchar2_table(45138) := '66726F6D3A612C6C656E6774683A6C7D3D742E646F632E6C696E65286F2B69293B72657475726E206E657720245428612C6C2C6E2B722A692C722C30297D7D6C696E65417428652C742C6E2C692C6F297B696628743D3D55542E42794865696768742972';
wwv_flow_imp.g_varchar2_table(45139) := '657475726E20746869732E626C6F636B417428652C6E2C692C6F293B696628743D3D55542E4279506F734E6F486569676874297B6C65747B66726F6D3A742C746F3A697D3D6E2E646F632E6C696E6541742865293B72657475726E206E65772024542874';
wwv_flow_imp.g_varchar2_table(45140) := '2C692D742C302C302C30297D6C65747B66697273744C696E653A732C7065724C696E653A722C706572436861723A617D3D746869732E6865696768744D657472696373286E2C6F292C6C3D6E2E646F632E6C696E6541742865292C633D722B6C2E6C656E';
wwv_flow_imp.g_varchar2_table(45141) := '6774682A612C643D6C2E6E756D6265722D732C683D692B722A642B612A286C2E66726F6D2D6F2D64293B72657475726E206E6577202454286C2E66726F6D2C6C2E6C656E6774682C4D6174682E6D617828692C4D6174682E6D696E28682C692B74686973';
wwv_flow_imp.g_varchar2_table(45142) := '2E6865696768742D6329292C632C30297D666F72456163684C696E6528652C742C6E2C692C6F2C73297B653D4D6174682E6D617828652C6F292C743D4D6174682E6D696E28742C6F2B746869732E6C656E677468293B6C65747B66697273744C696E653A';
wwv_flow_imp.g_varchar2_table(45143) := '722C7065724C696E653A612C706572436861723A6C7D3D746869732E6865696768744D657472696373286E2C6F293B666F72286C657420633D652C643D693B633C3D743B297B6C657420743D6E2E646F632E6C696E6541742863293B696628633D3D6529';
wwv_flow_imp.g_varchar2_table(45144) := '7B6C6574206E3D742E6E756D6265722D723B642B3D612A6E2B6C2A28652D6F2D6E297D6C657420693D612B6C2A742E6C656E6774683B73286E657720245428742E66726F6D2C742E6C656E6774682C642C692C3029292C642B3D692C633D742E746F2B31';
wwv_flow_imp.g_varchar2_table(45145) := '7D7D7265706C61636528652C742C6E297B6C657420693D746869732E6C656E6774682D743B696628693E30297B6C657420653D6E5B6E2E6C656E6774682D315D3B6520696E7374616E63656F662058543F6E5B6E2E6C656E6774682D315D3D6E65772058';
wwv_flow_imp.g_varchar2_table(45146) := '5428652E6C656E6774682B69293A6E2E70757368286E756C6C2C6E657720585428692D3129297D696628653E30297B6C657420743D6E5B305D3B7420696E7374616E63656F662058543F6E5B305D3D6E657720585428652B742E6C656E677468293A6E2E';
wwv_flow_imp.g_varchar2_table(45147) := '756E7368696674286E657720585428652D31292C6E756C6C297D72657475726E2047542E6F66286E297D6465636F6D706F73654C65667428652C74297B742E70757368286E657720585428652D31292C6E756C6C297D6465636F6D706F73655269676874';
wwv_flow_imp.g_varchar2_table(45148) := '28652C74297B742E70757368286E756C6C2C6E657720585428746869732E6C656E6774682D652D3129297D75706461746548656967687428652C743D302C6E3D21312C69297B6C6574206F3D742B746869732E6C656E6774683B696628692626692E6672';
wwv_flow_imp.g_varchar2_table(45149) := '6F6D3C3D742B746869732E6C656E6774682626692E6D6F7265297B6C6574206E3D5B5D2C733D4D6174682E6D617828742C692E66726F6D292C723D2D313B666F7228692E66726F6D3E7426266E2E70757368286E657720585428692E66726F6D2D742D31';
wwv_flow_imp.g_varchar2_table(45150) := '292E75706461746548656967687428652C7429293B733C3D6F2626692E6D6F72653B297B6C657420743D652E646F632E6C696E6541742873292E6C656E6774683B6E2E6C656E67746826266E2E70757368286E756C6C293B6C6574206F3D692E68656967';
wwv_flow_imp.g_varchar2_table(45151) := '6874735B692E696E6465782B2B5D3B2D313D3D723F723D6F3A4D6174682E616273286F2D72293E3D4B54262628723D2D32293B6C657420613D6E6577205A5428742C6F293B612E6F757464617465643D21312C6E2E707573682861292C732B3D742B317D';
wwv_flow_imp.g_varchar2_table(45152) := '733C3D6F26266E2E70757368286E756C6C2C6E6577205854286F2D73292E75706461746548656967687428652C7329293B6C657420613D47542E6F66286E293B72657475726E28723C307C7C4D6174682E61627328612E6865696768742D746869732E68';
wwv_flow_imp.g_varchar2_table(45153) := '6569676874293E3D4B547C7C4D6174682E61627328722D746869732E6865696768744D65747269637328652C74292E7065724C696E65293E3D4B542926262848543D2130292C515428746869732C61297D72657475726E286E7C7C746869732E6F757464';
wwv_flow_imp.g_varchar2_table(45154) := '6174656429262628746869732E73657448656967687428652E686569676874466F7247617028742C742B746869732E6C656E67746829292C746869732E6F757464617465643D2131292C746869737D746F537472696E6728297B72657475726E60676170';
wwv_flow_imp.g_varchar2_table(45155) := '28247B746869732E6C656E6774687D29607D7D636C617373204A5420657874656E64732047547B636F6E7374727563746F7228652C742C6E297B737570657228652E6C656E6774682B742B6E2E6C656E6774682C652E6865696768742B6E2E6865696768';
wwv_flow_imp.g_varchar2_table(45156) := '742C747C28652E6F757464617465647C7C6E2E6F757464617465643F323A3029292C746869732E6C6566743D652C746869732E72696768743D6E2C746869732E73697A653D652E73697A652B6E2E73697A657D67657420627265616B28297B7265747572';
wwv_flow_imp.g_varchar2_table(45157) := '6E203126746869732E666C6167737D626C6F636B417428652C742C6E2C69297B6C6574206F3D6E2B746869732E6C6566742E6865696768743B72657475726E20653C6F3F746869732E6C6566742E626C6F636B417428652C742C6E2C69293A746869732E';
wwv_flow_imp.g_varchar2_table(45158) := '72696768742E626C6F636B417428652C742C6F2C692B746869732E6C6566742E6C656E6774682B746869732E627265616B297D6C696E65417428652C742C6E2C692C6F297B6C657420733D692B746869732E6C6566742E6865696768742C723D6F2B7468';
wwv_flow_imp.g_varchar2_table(45159) := '69732E6C6566742E6C656E6774682B746869732E627265616B2C613D743D3D55542E42794865696768743F653C733A653C722C6C3D613F746869732E6C6566742E6C696E65417428652C742C6E2C692C6F293A746869732E72696768742E6C696E654174';
wwv_flow_imp.g_varchar2_table(45160) := '28652C742C6E2C732C72293B696628746869732E627265616B7C7C28613F6C2E746F3C723A6C2E66726F6D3E72292972657475726E206C3B6C657420633D743D3D55542E4279506F734E6F4865696768743F55542E4279506F734E6F4865696768743A55';
wwv_flow_imp.g_varchar2_table(45161) := '542E4279506F733B72657475726E20613F6C2E6A6F696E28746869732E72696768742E6C696E65417428722C632C6E2C732C7229293A746869732E6C6566742E6C696E65417428722C632C6E2C692C6F292E6A6F696E286C297D666F72456163684C696E';
wwv_flow_imp.g_varchar2_table(45162) := '6528652C742C6E2C692C6F2C73297B6C657420723D692B746869732E6C6566742E6865696768742C613D6F2B746869732E6C6566742E6C656E6774682B746869732E627265616B3B696628746869732E627265616B29653C612626746869732E6C656674';
wwv_flow_imp.g_varchar2_table(45163) := '2E666F72456163684C696E6528652C742C6E2C692C6F2C73292C743E3D612626746869732E72696768742E666F72456163684C696E6528652C742C6E2C722C612C73293B656C73657B6C6574206C3D746869732E6C696E65417428612C55542E4279506F';
wwv_flow_imp.g_varchar2_table(45164) := '732C6E2C692C6F293B653C6C2E66726F6D2626746869732E6C6566742E666F72456163684C696E6528652C6C2E66726F6D2D312C6E2C692C6F2C73292C6C2E746F3E3D6526266C2E66726F6D3C3D74262673286C292C743E6C2E746F2626746869732E72';
wwv_flow_imp.g_varchar2_table(45165) := '696768742E666F72456163684C696E65286C2E746F2B312C742C6E2C722C612C73297D7D7265706C61636528652C742C6E297B6C657420693D746869732E6C6566742E6C656E6774682B746869732E627265616B3B696628743C692972657475726E2074';
wwv_flow_imp.g_varchar2_table(45166) := '6869732E62616C616E63656428746869732E6C6566742E7265706C61636528652C742C6E292C746869732E7269676874293B696628653E746869732E6C6566742E6C656E6774682972657475726E20746869732E62616C616E63656428746869732E6C65';
wwv_flow_imp.g_varchar2_table(45167) := '66742C746869732E72696768742E7265706C61636528652D692C742D692C6E29293B6C6574206F3D5B5D3B653E302626746869732E6465636F6D706F73654C65667428652C6F293B6C657420733D6F2E6C656E6774683B666F72286C65742065206F6620';
wwv_flow_imp.g_varchar2_table(45168) := '6E296F2E707573682865293B696628653E3026266549286F2C732D31292C743C746869732E6C656E677468297B6C657420653D6F2E6C656E6774683B746869732E6465636F6D706F7365526967687428742C6F292C6549286F2C65297D72657475726E20';
wwv_flow_imp.g_varchar2_table(45169) := '47542E6F66286F297D6465636F6D706F73654C65667428652C74297B6C6574206E3D746869732E6C6566742E6C656E6774683B696628653C3D6E2972657475726E20746869732E6C6566742E6465636F6D706F73654C65667428652C74293B742E707573';
wwv_flow_imp.g_varchar2_table(45170) := '6828746869732E6C656674292C746869732E627265616B2626286E2B2B2C653E3D6E2626742E70757368286E756C6C29292C653E6E2626746869732E72696768742E6465636F6D706F73654C65667428652D6E2C74297D6465636F6D706F736552696768';
wwv_flow_imp.g_varchar2_table(45171) := '7428652C74297B6C6574206E3D746869732E6C6566742E6C656E6774682C693D6E2B746869732E627265616B3B696628653E3D692972657475726E20746869732E72696768742E6465636F6D706F7365526967687428652D692C74293B653C6E26267468';
wwv_flow_imp.g_varchar2_table(45172) := '69732E6C6566742E6465636F6D706F7365526967687428652C74292C746869732E627265616B2626653C692626742E70757368286E756C6C292C742E7075736828746869732E7269676874297D62616C616E63656428652C74297B72657475726E20652E';
wwv_flow_imp.g_varchar2_table(45173) := '73697A653E322A742E73697A657C7C742E73697A653E322A652E73697A653F47542E6F6628746869732E627265616B3F5B652C6E756C6C2C745D3A5B652C745D293A28746869732E6C6566743D515428746869732E6C6566742C65292C746869732E7269';
wwv_flow_imp.g_varchar2_table(45174) := '6768743D515428746869732E72696768742C74292C746869732E73657448656967687428652E6865696768742B742E686569676874292C746869732E6F757464617465643D652E6F757464617465647C7C742E6F757464617465642C746869732E73697A';
wwv_flow_imp.g_varchar2_table(45175) := '653D652E73697A652B742E73697A652C746869732E6C656E6774683D652E6C656E6774682B746869732E627265616B2B742E6C656E6774682C74686973297D75706461746548656967687428652C743D302C6E3D21312C69297B6C65747B6C6566743A6F';
wwv_flow_imp.g_varchar2_table(45176) := '2C72696768743A737D3D746869732C723D742B6F2E6C656E6774682B746869732E627265616B2C613D6E756C6C3B72657475726E20692626692E66726F6D3C3D742B6F2E6C656E6774682626692E6D6F72653F613D6F3D6F2E7570646174654865696768';
wwv_flow_imp.g_varchar2_table(45177) := '7428652C742C6E2C69293A6F2E75706461746548656967687428652C742C6E292C692626692E66726F6D3C3D722B732E6C656E6774682626692E6D6F72653F613D733D732E75706461746548656967687428652C722C6E2C69293A732E75706461746548';
wwv_flow_imp.g_varchar2_table(45178) := '656967687428652C722C6E292C613F746869732E62616C616E636564286F2C73293A28746869732E6865696768743D746869732E6C6566742E6865696768742B746869732E72696768742E6865696768742C746869732E6F757464617465643D21312C74';
wwv_flow_imp.g_varchar2_table(45179) := '686973297D746F537472696E6728297B72657475726E20746869732E6C6566742B28746869732E627265616B3F2220223A222D22292B746869732E72696768747D7D66756E6374696F6E20654928652C74297B6C6574206E2C693B6E756C6C3D3D655B74';
wwv_flow_imp.g_varchar2_table(45180) := '5D2626286E3D655B742D315D29696E7374616E63656F66205854262628693D655B742B315D29696E7374616E63656F662058542626652E73706C69636528742D312C332C6E6577205854286E2E6C656E6774682B312B692E6C656E67746829297D636C61';
wwv_flow_imp.g_varchar2_table(45181) := '73732074497B636F6E7374727563746F7228652C74297B746869732E706F733D652C746869732E6F7261636C653D742C746869732E6E6F6465733D5B5D2C746869732E6C696E6553746172743D2D312C746869732E6C696E65456E643D2D312C74686973';
wwv_flow_imp.g_varchar2_table(45182) := '2E636F766572696E673D6E756C6C2C746869732E7772697474656E546F3D657D676574206973436F766572656428297B72657475726E20746869732E636F766572696E672626746869732E6E6F6465735B746869732E6E6F6465732E6C656E6774682D31';
wwv_flow_imp.g_varchar2_table(45183) := '5D3D3D746869732E636F766572696E677D7370616E28652C74297B696628746869732E6C696E6553746172743E2D31297B6C657420653D4D6174682E6D696E28742C746869732E6C696E65456E64292C6E3D746869732E6E6F6465735B746869732E6E6F';
wwv_flow_imp.g_varchar2_table(45184) := '6465732E6C656E6774682D315D3B6E20696E7374616E63656F66205A543F6E2E6C656E6774682B3D652D746869732E706F733A28653E746869732E706F737C7C21746869732E6973436F7665726564292626746869732E6E6F6465732E70757368286E65';
wwv_flow_imp.g_varchar2_table(45185) := '77205A5428652D746869732E706F732C2D3129292C746869732E7772697474656E546F3D652C743E65262628746869732E6E6F6465732E70757368286E756C6C292C746869732E7772697474656E546F2B2B2C746869732E6C696E6553746172743D2D31';
wwv_flow_imp.g_varchar2_table(45186) := '297D746869732E706F733D747D706F696E7428652C742C6E297B696628653C747C7C6E2E68656967687452656C6576616E74297B6C657420693D6E2E7769646765743F6E2E7769646765742E657374696D617465644865696768743A302C6F3D6E2E7769';
wwv_flow_imp.g_varchar2_table(45187) := '646765743F6E2E7769646765742E6C696E65427265616B733A303B693C30262628693D746869732E6F7261636C652E6C696E65486569676874293B6C657420733D742D653B6E2E626C6F636B3F746869732E616464426C6F636B286E657720595428732C';
wwv_flow_imp.g_varchar2_table(45188) := '692C6E29293A28737C7C6F7C7C693E3D35292626746869732E6164644C696E654465636F28692C6F2C73297D656C736520743E652626746869732E7370616E28652C74293B746869732E6C696E65456E643E2D312626746869732E6C696E65456E643C74';
wwv_flow_imp.g_varchar2_table(45189) := '6869732E706F73262628746869732E6C696E65456E643D746869732E6F7261636C652E646F632E6C696E65417428746869732E706F73292E746F297D656E7465724C696E6528297B696628746869732E6C696E6553746172743E2D312972657475726E3B';
wwv_flow_imp.g_varchar2_table(45190) := '6C65747B66726F6D3A652C746F3A747D3D746869732E6F7261636C652E646F632E6C696E65417428746869732E706F73293B746869732E6C696E6553746172743D652C746869732E6C696E65456E643D742C746869732E7772697474656E546F3C652626';
wwv_flow_imp.g_varchar2_table(45191) := '2828746869732E7772697474656E546F3C652D317C7C6E756C6C3D3D746869732E6E6F6465735B746869732E6E6F6465732E6C656E6774682D315D292626746869732E6E6F6465732E7075736828746869732E626C616E6B436F6E74656E742874686973';
wwv_flow_imp.g_varchar2_table(45192) := '2E7772697474656E546F2C652D3129292C746869732E6E6F6465732E70757368286E756C6C29292C746869732E706F733E652626746869732E6E6F6465732E70757368286E6577205A5428746869732E706F732D652C2D3129292C746869732E77726974';
wwv_flow_imp.g_varchar2_table(45193) := '74656E546F3D746869732E706F737D626C616E6B436F6E74656E7428652C74297B6C6574206E3D6E657720585428742D65293B72657475726E20746869732E6F7261636C652E646F632E6C696E6541742865292E746F3D3D742626286E2E666C6167737C';
wwv_flow_imp.g_varchar2_table(45194) := '3D34292C6E7D656E737572654C696E6528297B746869732E656E7465724C696E6528293B6C657420653D746869732E6E6F6465732E6C656E6774683F746869732E6E6F6465735B746869732E6E6F6465732E6C656E6774682D315D3A6E756C6C3B696628';
wwv_flow_imp.g_varchar2_table(45195) := '6520696E7374616E63656F66205A542972657475726E20653B6C657420743D6E6577205A5428302C2D31293B72657475726E20746869732E6E6F6465732E707573682874292C747D616464426C6F636B2865297B746869732E656E7465724C696E652829';
wwv_flow_imp.g_varchar2_table(45196) := '3B6C657420743D652E6465636F3B742626742E7374617274536964653E30262621746869732E6973436F76657265642626746869732E656E737572654C696E6528292C746869732E6E6F6465732E707573682865292C746869732E7772697474656E546F';
wwv_flow_imp.g_varchar2_table(45197) := '3D746869732E706F733D746869732E706F732B652E6C656E6774682C742626742E656E64536964653E30262628746869732E636F766572696E673D65297D6164644C696E654465636F28652C742C6E297B6C657420693D746869732E656E737572654C69';
wwv_flow_imp.g_varchar2_table(45198) := '6E6528293B692E6C656E6774682B3D6E2C692E636F6C6C61707365642B3D6E2C692E7769646765744865696768743D4D6174682E6D617828692E7769646765744865696768742C65292C692E627265616B732B3D742C746869732E7772697474656E546F';
wwv_flow_imp.g_varchar2_table(45199) := '3D746869732E706F733D746869732E706F732B6E7D66696E6973682865297B6C657420743D303D3D746869732E6E6F6465732E6C656E6774683F6E756C6C3A746869732E6E6F6465735B746869732E6E6F6465732E6C656E6774682D315D3B2128746869';
wwv_flow_imp.g_varchar2_table(45200) := '732E6C696E6553746172743E2D31297C7C7420696E7374616E63656F66205A547C7C746869732E6973436F76657265643F28746869732E7772697474656E546F3C746869732E706F737C7C6E756C6C3D3D74292626746869732E6E6F6465732E70757368';
wwv_flow_imp.g_varchar2_table(45201) := '28746869732E626C616E6B436F6E74656E7428746869732E7772697474656E546F2C746869732E706F7329293A746869732E6E6F6465732E70757368286E6577205A5428302C2D3129293B6C6574206E3D653B666F72286C65742065206F662074686973';
wwv_flow_imp.g_varchar2_table(45202) := '2E6E6F646573296520696E7374616E63656F66205A542626652E75706461746548656967687428746869732E6F7261636C652C6E292C6E2B3D653F652E6C656E6774683A313B72657475726E20746869732E6E6F6465737D737461746963206275696C64';
wwv_flow_imp.g_varchar2_table(45203) := '28652C742C6E2C69297B6C6574206F3D6E6577207449286E2C65293B72657475726E206C452E7370616E7328742C6E2C692C6F2C30292C6F2E66696E697368286E297D7D636C617373206E497B636F6E7374727563746F7228297B746869732E6368616E';
wwv_flow_imp.g_varchar2_table(45204) := '6765733D5B5D7D636F6D7061726552616E676528297B7D636F6D70617265506F696E7428652C742C6E2C69297B28653C747C7C6E26266E2E68656967687452656C6576616E747C7C692626692E68656967687452656C6576616E74292626564C28652C74';
wwv_flow_imp.g_varchar2_table(45205) := '2C746869732E6368616E6765732C35297D7D66756E6374696F6E20694928652C74297B6C6574206E3D652E676574426F756E64696E67436C69656E745265637428292C693D652E6F776E6572446F63756D656E742C6F3D692E64656661756C7456696577';
wwv_flow_imp.g_varchar2_table(45206) := '7C7C77696E646F772C733D4D6174682E6D617828302C6E2E6C656674292C723D4D6174682E6D696E286F2E696E6E657257696474682C6E2E7269676874292C613D4D6174682E6D617828302C6E2E746F70292C6C3D4D6174682E6D696E286F2E696E6E65';
wwv_flow_imp.g_varchar2_table(45207) := '724865696768742C6E2E626F74746F6D293B666F72286C657420743D652E706172656E744E6F64653B74262674213D692E626F64793B29696628313D3D742E6E6F646554797065297B6C6574206E3D742C693D77696E646F772E676574436F6D70757465';
wwv_flow_imp.g_varchar2_table(45208) := '645374796C65286E293B696628286E2E7363726F6C6C4865696768743E6E2E636C69656E744865696768747C7C6E2E7363726F6C6C57696474683E6E2E636C69656E7457696474682926262276697369626C6522213D692E6F766572666C6F77297B6C65';
wwv_flow_imp.g_varchar2_table(45209) := '7420693D6E2E676574426F756E64696E67436C69656E745265637428293B733D4D6174682E6D617828732C692E6C656674292C723D4D6174682E6D696E28722C692E7269676874292C613D4D6174682E6D617828612C692E746F70292C6C3D4D6174682E';
wwv_flow_imp.g_varchar2_table(45210) := '6D696E28743D3D652E706172656E744E6F64653F6F2E696E6E65724865696768743A6C2C692E626F74746F6D297D743D226162736F6C757465223D3D692E706F736974696F6E7C7C226669786564223D3D692E706F736974696F6E3F6E2E6F6666736574';
wwv_flow_imp.g_varchar2_table(45211) := '506172656E743A6E2E706172656E744E6F64657D656C73657B6966283131213D742E6E6F64655479706529627265616B3B743D742E686F73747D72657475726E7B6C6566743A732D6E2E6C6566742C72696768743A4D6174682E6D617828732C72292D6E';
wwv_flow_imp.g_varchar2_table(45212) := '2E6C6566742C746F703A612D286E2E746F702B74292C626F74746F6D3A4D6174682E6D617828612C6C292D286E2E746F702B74297D7D66756E6374696F6E206F4928652C74297B6C6574206E3D652E676574426F756E64696E67436C69656E7452656374';
wwv_flow_imp.g_varchar2_table(45213) := '28293B72657475726E7B6C6566743A302C72696768743A6E2E72696768742D6E2E6C6566742C746F703A742C626F74746F6D3A6E2E626F74746F6D2D286E2E746F702B74297D7D636C6173732073497B636F6E7374727563746F7228652C742C6E297B74';
wwv_flow_imp.g_varchar2_table(45214) := '6869732E66726F6D3D652C746869732E746F3D742C746869732E73697A653D6E7D7374617469632073616D6528652C74297B696628652E6C656E677468213D742E6C656E6774682972657475726E21313B666F72286C6574206E3D303B6E3C652E6C656E';
wwv_flow_imp.g_varchar2_table(45215) := '6774683B6E2B2B297B6C657420693D655B6E5D2C6F3D745B6E5D3B696628692E66726F6D213D6F2E66726F6D7C7C692E746F213D6F2E746F7C7C692E73697A65213D6F2E73697A652972657475726E21317D72657475726E21307D6472617728652C7429';
wwv_flow_imp.g_varchar2_table(45216) := '7B72657475726E20504C2E7265706C616365287B7769646765743A6E657720724928746869732E73697A652A28743F652E7363616C65593A652E7363616C6558292C74297D292E72616E676528746869732E66726F6D2C746869732E746F297D7D636C61';
wwv_flow_imp.g_varchar2_table(45217) := '737320724920657874656E647320414C7B636F6E7374727563746F7228652C74297B737570657228292C746869732E73697A653D652C746869732E766572746963616C3D747D65712865297B72657475726E20652E73697A653D3D746869732E73697A65';
wwv_flow_imp.g_varchar2_table(45218) := '2626652E766572746963616C3D3D746869732E766572746963616C7D746F444F4D28297B6C657420653D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E20746869732E766572746963616C3F652E7374796C65';
wwv_flow_imp.g_varchar2_table(45219) := '2E6865696768743D746869732E73697A652B227078223A28652E7374796C652E77696474683D746869732E73697A652B227078222C652E7374796C652E6865696768743D22327078222C652E7374796C652E646973706C61793D22696E6C696E652D626C';
wwv_flow_imp.g_varchar2_table(45220) := '6F636B22292C657D67657420657374696D6174656448656967687428297B72657475726E20746869732E766572746963616C3F746869732E73697A653A2D317D7D636C6173732061497B636F6E7374727563746F722865297B746869732E73746174653D';
wwv_flow_imp.g_varchar2_table(45221) := '652C746869732E706978656C56696577706F72743D7B6C6566743A302C72696768743A77696E646F772E696E6E657257696474682C746F703A302C626F74746F6D3A307D2C746869732E696E566965773D21302C746869732E70616464696E67546F703D';
wwv_flow_imp.g_varchar2_table(45222) := '302C746869732E70616464696E67426F74746F6D3D302C746869732E636F6E74656E74444F4D57696474683D302C746869732E636F6E74656E74444F4D4865696768743D302C746869732E656469746F724865696768743D302C746869732E656469746F';
wwv_flow_imp.g_varchar2_table(45223) := '7257696474683D302C746869732E7363726F6C6C546F703D302C746869732E7363726F6C6C6564546F426F74746F6D3D21312C746869732E7363616C65583D312C746869732E7363616C65593D312C746869732E7363726F6C6C416E63686F72506F733D';
wwv_flow_imp.g_varchar2_table(45224) := '302C746869732E7363726F6C6C416E63686F724865696768743D2D312C746869732E7363616C65723D68492C746869732E7363726F6C6C5461726765743D6E756C6C2C746869732E7072696E74696E673D21312C746869732E6D7573744D656173757265';
wwv_flow_imp.g_varchar2_table(45225) := '436F6E74656E743D21302C746869732E64656661756C7454657874446972656374696F6E3D554C2E4C54522C746869732E76697369626C6552616E6765733D5B5D2C746869732E6D757374456E666F726365437572736F724173736F633D21313B6C6574';
wwv_flow_imp.g_varchar2_table(45226) := '20743D652E6661636574284E44292E736F6D652828653D3E2266756E6374696F6E22213D747970656F662065262622636D2D6C696E655772617070696E67223D3D652E636C61737329293B746869732E6865696768744F7261636C653D6E6577206A5428';
wwv_flow_imp.g_varchar2_table(45227) := '74292C746869732E73746174654465636F3D652E6661636574285044292E66696C7465722828653D3E2266756E6374696F6E22213D747970656F66206529292C746869732E6865696768744D61703D47542E656D70747928292E6170706C794368616E67';
wwv_flow_imp.g_varchar2_table(45228) := '657328746869732E73746174654465636F2C46782E656D7074792C746869732E6865696768744F7261636C652E736574446F6328652E646F63292C5B6E657720574428302C302C302C652E646F632E6C656E677468295D293B666F72286C657420653D30';
wwv_flow_imp.g_varchar2_table(45229) := '3B653C32262628746869732E76696577706F72743D746869732E67657456696577706F727428302C6E756C6C292C746869732E757064617465466F7256696577706F72742829293B652B2B293B746869732E75706461746556696577706F72744C696E65';
wwv_flow_imp.g_varchar2_table(45230) := '7328292C746869732E6C696E65476170733D746869732E656E737572654C696E6547617073285B5D292C746869732E6C696E654761704465636F3D504C2E73657428746869732E6C696E65476170732E6D61702828653D3E652E6472617728746869732C';
wwv_flow_imp.g_varchar2_table(45231) := '2131292929292C746869732E636F6D7075746556697369626C6552616E67657328297D757064617465466F7256696577706F727428297B6C657420653D5B746869732E76696577706F72745D2C7B6D61696E3A747D3D746869732E73746174652E73656C';
wwv_flow_imp.g_varchar2_table(45232) := '656374696F6E3B666F72286C6574206E3D303B6E3C3D313B6E2B2B297B6C657420693D6E3F742E686561643A742E616E63686F723B69662821652E736F6D652828287B66726F6D3A652C746F3A747D293D3E693E3D652626693C3D742929297B6C65747B';
wwv_flow_imp.g_varchar2_table(45233) := '66726F6D3A742C746F3A6E7D3D746869732E6C696E65426C6F636B41742869293B652E70757368286E6577206C4928742C6E29297D7D72657475726E20746869732E76696577706F7274733D652E736F7274282828652C74293D3E652E66726F6D2D742E';
wwv_flow_imp.g_varchar2_table(45234) := '66726F6D29292C746869732E7570646174655363616C657228297D7570646174655363616C657228297B6C657420653D746869732E7363616C65723B72657475726E20746869732E7363616C65723D746869732E6865696768744D61702E686569676874';
wwv_flow_imp.g_varchar2_table(45235) := '3C3D3765363F68493A6E657720754928746869732E6865696768744F7261636C652C746869732E6865696768744D61702C746869732E76696577706F727473292C652E657128746869732E7363616C6572293F303A327D75706461746556696577706F72';
wwv_flow_imp.g_varchar2_table(45236) := '744C696E657328297B746869732E76696577706F72744C696E65733D5B5D2C746869732E6865696768744D61702E666F72456163684C696E6528746869732E76696577706F72742E66726F6D2C746869732E76696577706F72742E746F2C746869732E68';
wwv_flow_imp.g_varchar2_table(45237) := '65696768744F7261636C652E736574446F6328746869732E73746174652E646F63292C302C302C28653D3E7B746869732E76696577706F72744C696E65732E7075736828704928652C746869732E7363616C657229297D29297D75706461746528652C74';
wwv_flow_imp.g_varchar2_table(45238) := '3D6E756C6C297B746869732E73746174653D652E73746174653B6C6574206E3D746869732E73746174654465636F3B746869732E73746174654465636F3D746869732E73746174652E6661636574285044292E66696C7465722828653D3E2266756E6374';
wwv_flow_imp.g_varchar2_table(45239) := '696F6E22213D747970656F66206529293B6C657420693D652E6368616E67656452616E6765732C6F3D57442E657874656E645769746852616E67657328692C66756E6374696F6E28652C742C6E297B6C657420693D6E6577206E493B72657475726E206C';
wwv_flow_imp.g_varchar2_table(45240) := '452E636F6D7061726528652C742C6E2C692C30292C692E6368616E6765737D286E2C746869732E73746174654465636F2C653F652E6368616E6765733A6C6B2E656D70747928746869732E73746174652E646F632E6C656E6774682929292C733D746869';
wwv_flow_imp.g_varchar2_table(45241) := '732E6865696768744D61702E6865696768742C723D746869732E7363726F6C6C6564546F426F74746F6D3F6E756C6C3A746869732E7363726F6C6C416E63686F72417428746869732E7363726F6C6C546F70293B575428292C746869732E686569676874';
wwv_flow_imp.g_varchar2_table(45242) := '4D61703D746869732E6865696768744D61702E6170706C794368616E67657328746869732E73746174654465636F2C652E737461727453746174652E646F632C746869732E6865696768744F7261636C652E736574446F6328746869732E73746174652E';
wwv_flow_imp.g_varchar2_table(45243) := '646F63292C6F292C28746869732E6865696768744D61702E686569676874213D737C7C485429262628652E666C6167737C3D32292C723F28746869732E7363726F6C6C416E63686F72506F733D652E6368616E6765732E6D6170506F7328722E66726F6D';
wwv_flow_imp.g_varchar2_table(45244) := '2C2D31292C746869732E7363726F6C6C416E63686F724865696768743D722E746F70293A28746869732E7363726F6C6C416E63686F72506F733D2D312C746869732E7363726F6C6C416E63686F724865696768743D746869732E6865696768744D61702E';
wwv_flow_imp.g_varchar2_table(45245) := '686569676874293B6C657420613D6F2E6C656E6774683F746869732E6D617056696577706F727428746869732E76696577706F72742C652E6368616E676573293A746869732E76696577706F72743B2874262628742E72616E67652E686561643C612E66';
wwv_flow_imp.g_varchar2_table(45246) := '726F6D7C7C742E72616E67652E686561643E612E746F297C7C21746869732E76696577706F72744973417070726F70726961746528612929262628613D746869732E67657456696577706F727428302C7429293B6C6574206C3D612E66726F6D213D7468';
wwv_flow_imp.g_varchar2_table(45247) := '69732E76696577706F72742E66726F6D7C7C612E746F213D746869732E76696577706F72742E746F3B746869732E76696577706F72743D612C652E666C6167737C3D746869732E757064617465466F7256696577706F727428292C286C7C7C21652E6368';
wwv_flow_imp.g_varchar2_table(45248) := '616E6765732E656D7074797C7C3226652E666C616773292626746869732E75706461746556696577706F72744C696E657328292C28746869732E6C696E65476170732E6C656E6774687C7C746869732E76696577706F72742E746F2D746869732E766965';
wwv_flow_imp.g_varchar2_table(45249) := '77706F72742E66726F6D3E346533292626746869732E7570646174654C696E654761707328746869732E656E737572654C696E654761707328746869732E6D61704C696E654761707328746869732E6C696E65476170732C652E6368616E676573292929';
wwv_flow_imp.g_varchar2_table(45250) := '2C652E666C6167737C3D746869732E636F6D7075746556697369626C6552616E67657328292C74262628746869732E7363726F6C6C5461726765743D74292C21746869732E6D757374456E666F726365437572736F724173736F632626652E73656C6563';
wwv_flow_imp.g_varchar2_table(45251) := '74696F6E5365742626652E766965772E6C696E655772617070696E672626652E73746174652E73656C656374696F6E2E6D61696E2E656D7074792626652E73746174652E73656C656374696F6E2E6D61696E2E6173736F63262621652E73746174652E66';
wwv_flow_imp.g_varchar2_table(45252) := '6163657428774429262628746869732E6D757374456E666F726365437572736F724173736F633D2130297D6D6561737572652865297B6C657420743D652E636F6E74656E74444F4D2C6E3D77696E646F772E676574436F6D70757465645374796C652874';
wwv_flow_imp.g_varchar2_table(45253) := '292C693D746869732E6865696768744F7261636C652C6F3D6E2E776869746553706163653B746869732E64656661756C7454657874446972656374696F6E3D2272746C223D3D6E2E646972656374696F6E3F554C2E52544C3A554C2E4C54523B6C657420';
wwv_flow_imp.g_varchar2_table(45254) := '733D746869732E6865696768744F7261636C652E6D75737452656672657368466F725772617070696E67286F292C723D742E676574426F756E64696E67436C69656E745265637428292C613D737C7C746869732E6D7573744D656173757265436F6E7465';
wwv_flow_imp.g_varchar2_table(45255) := '6E747C7C746869732E636F6E74656E74444F4D486569676874213D722E6865696768743B746869732E636F6E74656E74444F4D4865696768743D722E6865696768742C746869732E6D7573744D656173757265436F6E74656E743D21313B6C6574206C3D';
wwv_flow_imp.g_varchar2_table(45256) := '302C633D303B696628722E77696474682626722E686569676874297B6C65747B7363616C65583A652C7363616C65593A6E7D3D714528742C72293B28653E2E30303526264D6174682E61627328746869732E7363616C65582D65293E2E3030357C7C6E3E';
wwv_flow_imp.g_varchar2_table(45257) := '2E30303526264D6174682E61627328746869732E7363616C65592D6E293E2E30303529262628746869732E7363616C65583D652C746869732E7363616C65593D6E2C6C7C3D382C733D613D2130297D6C657420643D287061727365496E74286E2E706164';
wwv_flow_imp.g_varchar2_table(45258) := '64696E67546F70297C7C30292A746869732E7363616C65592C683D287061727365496E74286E2E70616464696E67426F74746F6D297C7C30292A746869732E7363616C65593B746869732E70616464696E67546F703D3D642626746869732E7061646469';
wwv_flow_imp.g_varchar2_table(45259) := '6E67426F74746F6D3D3D687C7C28746869732E70616464696E67546F703D642C746869732E70616464696E67426F74746F6D3D682C6C7C3D3130292C746869732E656469746F725769647468213D652E7363726F6C6C444F4D2E636C69656E7457696474';
wwv_flow_imp.g_varchar2_table(45260) := '68262628692E6C696E655772617070696E67262628613D2130292C746869732E656469746F7257696474683D652E7363726F6C6C444F4D2E636C69656E7457696474682C6C7C3D38293B6C657420753D652E7363726F6C6C444F4D2E7363726F6C6C546F';
wwv_flow_imp.g_varchar2_table(45261) := '702A746869732E7363616C65593B746869732E7363726F6C6C546F70213D75262628746869732E7363726F6C6C416E63686F724865696768743D2D312C746869732E7363726F6C6C546F703D75292C746869732E7363726F6C6C6564546F426F74746F6D';
wwv_flow_imp.g_varchar2_table(45262) := '3D584528652E7363726F6C6C444F4D293B6C657420703D28746869732E7072696E74696E673F6F493A69492928742C746869732E70616464696E67546F70292C673D702E746F702D746869732E706978656C56696577706F72742E746F702C6D3D702E62';
wwv_flow_imp.g_varchar2_table(45263) := '6F74746F6D2D746869732E706978656C56696577706F72742E626F74746F6D3B746869732E706978656C56696577706F72743D703B6C657420663D746869732E706978656C56696577706F72742E626F74746F6D3E746869732E706978656C5669657770';
wwv_flow_imp.g_varchar2_table(45264) := '6F72742E746F702626746869732E706978656C56696577706F72742E72696768743E746869732E706978656C56696577706F72742E6C6566743B69662866213D746869732E696E56696577262628746869732E696E566965773D662C66262628613D2130';
wwv_flow_imp.g_varchar2_table(45265) := '29292C21746869732E696E56696577262621746869732E7363726F6C6C5461726765742972657475726E20303B6C657420763D722E77696474683B696628746869732E636F6E74656E74444F4D57696474683D3D762626746869732E656469746F724865';
wwv_flow_imp.g_varchar2_table(45266) := '696768743D3D652E7363726F6C6C444F4D2E636C69656E744865696768747C7C28746869732E636F6E74656E74444F4D57696474683D722E77696474682C746869732E656469746F724865696768743D652E7363726F6C6C444F4D2E636C69656E744865';
wwv_flow_imp.g_varchar2_table(45267) := '696768742C6C7C3D38292C61297B6C657420743D652E646F63566965772E6D65617375726556697369626C654C696E654865696768747328746869732E76696577706F7274293B696628692E6D75737452656672657368466F7248656967687473287429';
wwv_flow_imp.g_varchar2_table(45268) := '262628733D2130292C737C7C692E6C696E655772617070696E6726264D6174682E61627328762D746869732E636F6E74656E74444F4D5769647468293E692E636861725769647468297B6C65747B6C696E654865696768743A6E2C636861725769647468';
wwv_flow_imp.g_varchar2_table(45269) := '3A722C746578744865696768743A617D3D652E646F63566965772E6D6561737572655465787453697A6528293B733D6E3E302626692E72656672657368286F2C6E2C722C612C762F722C74292C73262628652E646F63566965772E6D696E57696474683D';
wwv_flow_imp.g_varchar2_table(45270) := '302C6C7C3D38297D673E3026266D3E303F633D4D6174682E6D617828672C6D293A673C3026266D3C30262628633D4D6174682E6D696E28672C6D29292C575428293B666F72286C6574206E206F6620746869732E76696577706F727473297B6C6574206F';
wwv_flow_imp.g_varchar2_table(45271) := '3D6E2E66726F6D3D3D746869732E76696577706F72742E66726F6D3F743A652E646F63566965772E6D65617375726556697369626C654C696E6548656967687473286E293B746869732E6865696768744D61703D28733F47542E656D70747928292E6170';
wwv_flow_imp.g_varchar2_table(45272) := '706C794368616E67657328746869732E73746174654465636F2C46782E656D7074792C746869732E6865696768744F7261636C652C5B6E657720574428302C302C302C652E73746174652E646F632E6C656E677468295D293A746869732E686569676874';
wwv_flow_imp.g_varchar2_table(45273) := '4D6170292E75706461746548656967687428692C302C732C6E6577207154286E2E66726F6D2C6F29297D48542626286C7C3D32297D6C657420623D21746869732E76696577706F72744973417070726F70726961746528746869732E76696577706F7274';
wwv_flow_imp.g_varchar2_table(45274) := '2C63297C7C746869732E7363726F6C6C546172676574262628746869732E7363726F6C6C5461726765742E72616E67652E686561643C746869732E76696577706F72742E66726F6D7C7C746869732E7363726F6C6C5461726765742E72616E67652E6865';
wwv_flow_imp.g_varchar2_table(45275) := '61643E746869732E76696577706F72742E746F293B72657475726E206226262832266C2626286C7C3D746869732E7570646174655363616C65722829292C746869732E76696577706F72743D746869732E67657456696577706F727428632C746869732E';
wwv_flow_imp.g_varchar2_table(45276) := '7363726F6C6C546172676574292C6C7C3D746869732E757064617465466F7256696577706F72742829292C2832266C7C7C62292626746869732E75706461746556696577706F72744C696E657328292C28746869732E6C696E65476170732E6C656E6774';
wwv_flow_imp.g_varchar2_table(45277) := '687C7C746869732E76696577706F72742E746F2D746869732E76696577706F72742E66726F6D3E346533292626746869732E7570646174654C696E654761707328746869732E656E737572654C696E654761707328733F5B5D3A746869732E6C696E6547';
wwv_flow_imp.g_varchar2_table(45278) := '6170732C6529292C6C7C3D746869732E636F6D7075746556697369626C6552616E67657328292C746869732E6D757374456E666F726365437572736F724173736F63262628746869732E6D757374456E666F726365437572736F724173736F633D21312C';
wwv_flow_imp.g_varchar2_table(45279) := '652E646F63566965772E656E666F726365437572736F724173736F632829292C6C7D6765742076697369626C65546F7028297B72657475726E20746869732E7363616C65722E66726F6D444F4D28746869732E706978656C56696577706F72742E746F70';
wwv_flow_imp.g_varchar2_table(45280) := '297D6765742076697369626C65426F74746F6D28297B72657475726E20746869732E7363616C65722E66726F6D444F4D28746869732E706978656C56696577706F72742E626F74746F6D297D67657456696577706F727428652C74297B6C6574206E3D2E';
wwv_flow_imp.g_varchar2_table(45281) := '352D4D6174682E6D6178282D2E352C4D6174682E6D696E282E352C652F3165332F3229292C693D746869732E6865696768744D61702C6F3D746869732E6865696768744F7261636C652C7B76697369626C65546F703A732C76697369626C65426F74746F';
wwv_flow_imp.g_varchar2_table(45282) := '6D3A727D3D746869732C613D6E6577206C4928692E6C696E65417428732D3165332A6E2C55542E42794865696768742C6F2C302C30292E66726F6D2C692E6C696E65417428722B3165332A28312D6E292C55542E42794865696768742C6F2C302C30292E';
wwv_flow_imp.g_varchar2_table(45283) := '746F293B69662874297B6C65747B686561643A657D3D742E72616E67653B696628653C612E66726F6D7C7C653E612E746F297B6C6574206E2C733D4D6174682E6D696E28746869732E656469746F724865696768742C746869732E706978656C56696577';
wwv_flow_imp.g_varchar2_table(45284) := '706F72742E626F74746F6D2D746869732E706978656C56696577706F72742E746F70292C723D692E6C696E65417428652C55542E4279506F732C6F2C302C30293B6E3D2263656E746572223D3D742E793F28722E746F702B722E626F74746F6D292F322D';
wwv_flow_imp.g_varchar2_table(45285) := '732F323A227374617274223D3D742E797C7C226E656172657374223D3D742E792626653C612E66726F6D3F722E746F703A722E626F74746F6D2D732C613D6E6577206C4928692E6C696E654174286E2D3530302C55542E42794865696768742C6F2C302C';
wwv_flow_imp.g_varchar2_table(45286) := '30292E66726F6D2C692E6C696E654174286E2B732B3530302C55542E42794865696768742C6F2C302C30292E746F297D7D72657475726E20617D6D617056696577706F727428652C74297B6C6574206E3D742E6D6170506F7328652E66726F6D2C2D3129';
wwv_flow_imp.g_varchar2_table(45287) := '2C693D742E6D6170506F7328652E746F2C31293B72657475726E206E6577206C4928746869732E6865696768744D61702E6C696E654174286E2C55542E4279506F732C746869732E6865696768744F7261636C652C302C30292E66726F6D2C746869732E';
wwv_flow_imp.g_varchar2_table(45288) := '6865696768744D61702E6C696E65417428692C55542E4279506F732C746869732E6865696768744F7261636C652C302C30292E746F297D76696577706F72744973417070726F707269617465287B66726F6D3A652C746F3A747D2C6E3D30297B69662821';
wwv_flow_imp.g_varchar2_table(45289) := '746869732E696E566965772972657475726E21303B6C65747B746F703A697D3D746869732E6865696768744D61702E6C696E65417428652C55542E4279506F732C746869732E6865696768744F7261636C652C302C30292C7B626F74746F6D3A6F7D3D74';
wwv_flow_imp.g_varchar2_table(45290) := '6869732E6865696768744D61702E6C696E65417428742C55542E4279506F732C746869732E6865696768744F7261636C652C302C30292C7B76697369626C65546F703A732C76697369626C65426F74746F6D3A727D3D746869733B72657475726E28303D';
wwv_flow_imp.g_varchar2_table(45291) := '3D657C7C693C3D732D4D6174682E6D61782831302C4D6174682E6D696E282D6E2C323530292929262628743D3D746869732E73746174652E646F632E6C656E6774687C7C6F3E3D722B4D6174682E6D61782831302C4D6174682E6D696E286E2C32353029';
wwv_flow_imp.g_varchar2_table(45292) := '29292626693E732D32653326266F3C722B3265337D6D61704C696E654761707328652C74297B69662821652E6C656E6774687C7C742E656D7074792972657475726E20653B6C6574206E3D5B5D3B666F72286C65742069206F66206529742E746F756368';
wwv_flow_imp.g_varchar2_table(45293) := '657352616E676528692E66726F6D2C692E746F297C7C6E2E70757368286E657720734928742E6D6170506F7328692E66726F6D292C742E6D6170506F7328692E746F292C692E73697A6529293B72657475726E206E7D656E737572654C696E6547617073';
wwv_flow_imp.g_varchar2_table(45294) := '28652C74297B6C6574206E3D746869732E6865696768744F7261636C652E6C696E655772617070696E672C693D6E3F3165343A3265332C6F3D693E3E312C733D693C3C313B696628746869732E64656661756C7454657874446972656374696F6E213D55';
wwv_flow_imp.g_varchar2_table(45295) := '4C2E4C54522626216E2972657475726E5B5D3B6C657420723D5B5D2C613D28692C732C6C2C63293D3E7B696628732D693C6F2972657475726E3B6C657420643D746869732E73746174652E73656C656374696F6E2E6D61696E2C683D5B642E66726F6D5D';
wwv_flow_imp.g_varchar2_table(45296) := '3B642E656D7074797C7C682E7075736828642E746F293B666F72286C65742065206F66206829696628653E692626653C732972657475726E206128692C652D31302C6C2C63292C766F6964206128652B31302C732C6C2C63293B6C657420753D66756E63';
wwv_flow_imp.g_varchar2_table(45297) := '74696F6E28652C74297B666F72286C6574206E206F6620652969662874286E292972657475726E206E7D28652C28653D3E652E66726F6D3E3D6C2E66726F6D2626652E746F3C3D6C2E746F26264D6174682E61627328652E66726F6D2D69293C6F26264D';
wwv_flow_imp.g_varchar2_table(45298) := '6174682E61627328652E746F2D73293C6F262621682E736F6D652828743D3E652E66726F6D3C742626652E746F3E74292929293B6966282175297B696628733C6C2E746F26267426266E2626742E76697369626C6552616E6765732E736F6D652828653D';
wwv_flow_imp.g_varchar2_table(45299) := '3E652E66726F6D3C3D732626652E746F3E3D732929297B6C657420653D742E6D6F7665546F4C696E65426F756E6461727928666B2E637572736F722873292C21312C2130292E686561643B653E69262628733D65297D753D6E657720734928692C732C74';
wwv_flow_imp.g_varchar2_table(45300) := '6869732E67617053697A65286C2C692C732C6329297D722E707573682875297D2C6C3D653D3E7B696628652E6C656E6774683C737C7C652E74797065213D4E4C2E546578742972657475726E3B6C657420743D66756E6374696F6E28652C742C6E297B6C';
wwv_flow_imp.g_varchar2_table(45301) := '657420693D5B5D2C6F3D652C733D303B72657475726E206C452E7370616E73286E2C652C742C7B7370616E28297B7D2C706F696E7428652C74297B653E6F262628692E70757368287B66726F6D3A6F2C746F3A657D292C732B3D652D6F292C6F3D747D7D';
wwv_flow_imp.g_varchar2_table(45302) := '2C3230292C6F3C74262628692E70757368287B66726F6D3A6F2C746F3A747D292C732B3D742D6F292C7B746F74616C3A732C72616E6765733A697D7D28652E66726F6D2C652E746F2C746869732E73746174654465636F293B696628742E746F74616C3C';
wwv_flow_imp.g_varchar2_table(45303) := '732972657475726E3B6C6574206F2C722C6C3D746869732E7363726F6C6C5461726765743F746869732E7363726F6C6C5461726765742E72616E67652E686561643A6E756C6C3B6966286E297B6C6574206E2C732C613D692F746869732E686569676874';
wwv_flow_imp.g_varchar2_table(45304) := '4F7261636C652E6C696E654C656E6774682A746869732E6865696768744F7261636C652E6C696E654865696768743B6966286E756C6C213D6C297B6C657420693D644928742C6C292C6F3D2828746869732E76697369626C65426F74746F6D2D74686973';
wwv_flow_imp.g_varchar2_table(45305) := '2E76697369626C65546F70292F322B61292F652E6865696768743B6E3D692D6F2C733D692B6F7D656C7365206E3D28746869732E76697369626C65546F702D652E746F702D61292F652E6865696768742C733D28746869732E76697369626C65426F7474';
wwv_flow_imp.g_varchar2_table(45306) := '6F6D2D652E746F702B61292F652E6865696768743B6F3D634928742C6E292C723D634928742C73297D656C73657B6C657420652C6E2C733D742E746F74616C2A746869732E6865696768744F7261636C652E6368617257696474682C613D692A74686973';
wwv_flow_imp.g_varchar2_table(45307) := '2E6865696768744F7261636C652E6368617257696474683B6966286E756C6C213D6C297B6C657420693D644928742C6C292C6F3D2828746869732E706978656C56696577706F72742E72696768742D746869732E706978656C56696577706F72742E6C65';
wwv_flow_imp.g_varchar2_table(45308) := '6674292F322B61292F733B653D692D6F2C6E3D692B6F7D656C736520653D28746869732E706978656C56696577706F72742E6C6566742D61292F732C6E3D28746869732E706978656C56696577706F72742E72696768742B61292F733B6F3D634928742C';
wwv_flow_imp.g_varchar2_table(45309) := '65292C723D634928742C6E297D6F3E652E66726F6D26266128652E66726F6D2C6F2C652C74292C723C652E746F26266128722C652E746F2C652C74297D3B666F72286C65742065206F6620746869732E76696577706F72744C696E65732941727261792E';
wwv_flow_imp.g_varchar2_table(45310) := '6973417272617928652E74797065293F652E747970652E666F7245616368286C293A6C2865293B72657475726E20727D67617053697A6528652C742C6E2C69297B6C6574206F3D644928692C6E292D644928692C74293B72657475726E20746869732E68';
wwv_flow_imp.g_varchar2_table(45311) := '65696768744F7261636C652E6C696E655772617070696E673F652E6865696768742A6F3A692E746F74616C2A746869732E6865696768744F7261636C652E6368617257696474682A6F7D7570646174654C696E65476170732865297B73492E73616D6528';
wwv_flow_imp.g_varchar2_table(45312) := '652C746869732E6C696E6547617073297C7C28746869732E6C696E65476170733D652C746869732E6C696E654761704465636F3D504C2E73657428652E6D61702828653D3E652E6472617728746869732C746869732E6865696768744F7261636C652E6C';
wwv_flow_imp.g_varchar2_table(45313) := '696E655772617070696E6729292929297D636F6D7075746556697369626C6552616E67657328297B6C657420653D746869732E73746174654465636F3B746869732E6C696E65476170732E6C656E677468262628653D652E636F6E63617428746869732E';
wwv_flow_imp.g_varchar2_table(45314) := '6C696E654761704465636F29293B6C657420743D5B5D3B6C452E7370616E7328652C746869732E76696577706F72742E66726F6D2C746869732E76696577706F72742E746F2C7B7370616E28652C6E297B742E70757368287B66726F6D3A652C746F3A6E';
wwv_flow_imp.g_varchar2_table(45315) := '7D297D2C706F696E7428297B7D7D2C3230293B6C6574206E3D742E6C656E677468213D746869732E76697369626C6552616E6765732E6C656E6774687C7C746869732E76697369626C6552616E6765732E736F6D65282828652C6E293D3E652E66726F6D';
wwv_flow_imp.g_varchar2_table(45316) := '213D745B6E5D2E66726F6D7C7C652E746F213D745B6E5D2E746F29293B72657475726E20746869732E76697369626C6552616E6765733D742C6E3F343A307D6C696E65426C6F636B41742865297B72657475726E20653E3D746869732E76696577706F72';
wwv_flow_imp.g_varchar2_table(45317) := '742E66726F6D2626653C3D746869732E76696577706F72742E746F2626746869732E76696577706F72744C696E65732E66696E642828743D3E742E66726F6D3C3D652626742E746F3E3D6529297C7C704928746869732E6865696768744D61702E6C696E';
wwv_flow_imp.g_varchar2_table(45318) := '65417428652C55542E4279506F732C746869732E6865696768744F7261636C652C302C30292C746869732E7363616C6572297D6C696E65426C6F636B41744865696768742865297B72657475726E20653E3D746869732E76696577706F72744C696E6573';
wwv_flow_imp.g_varchar2_table(45319) := '5B305D2E746F702626653C3D746869732E76696577706F72744C696E65735B746869732E76696577706F72744C696E65732E6C656E6774682D315D2E626F74746F6D2626746869732E76696577706F72744C696E65732E66696E642828743D3E742E746F';
wwv_flow_imp.g_varchar2_table(45320) := '703C3D652626742E626F74746F6D3E3D6529297C7C704928746869732E6865696768744D61702E6C696E65417428746869732E7363616C65722E66726F6D444F4D2865292C55542E42794865696768742C746869732E6865696768744F7261636C652C30';
wwv_flow_imp.g_varchar2_table(45321) := '2C30292C746869732E7363616C6572297D7363726F6C6C416E63686F7241742865297B6C657420743D746869732E6C696E65426C6F636B417448656967687428652B38293B72657475726E20742E66726F6D3E3D746869732E76696577706F72742E6672';
wwv_flow_imp.g_varchar2_table(45322) := '6F6D7C7C746869732E76696577706F72744C696E65735B305D2E746F702D653E3230303F743A746869732E76696577706F72744C696E65735B305D7D656C656D656E7441744865696768742865297B72657475726E20704928746869732E686569676874';
wwv_flow_imp.g_varchar2_table(45323) := '4D61702E626C6F636B417428746869732E7363616C65722E66726F6D444F4D2865292C746869732E6865696768744F7261636C652C302C30292C746869732E7363616C6572297D67657420646F6348656967687428297B72657475726E20746869732E73';
wwv_flow_imp.g_varchar2_table(45324) := '63616C65722E746F444F4D28746869732E6865696768744D61702E686569676874297D67657420636F6E74656E7448656967687428297B72657475726E20746869732E646F634865696768742B746869732E70616464696E67546F702B746869732E7061';
wwv_flow_imp.g_varchar2_table(45325) := '6464696E67426F74746F6D7D7D636C617373206C497B636F6E7374727563746F7228652C74297B746869732E66726F6D3D652C746869732E746F3D747D7D66756E6374696F6E206349287B746F74616C3A652C72616E6765733A747D2C6E297B6966286E';
wwv_flow_imp.g_varchar2_table(45326) := '3C3D302972657475726E20745B305D2E66726F6D3B6966286E3E3D312972657475726E20745B742E6C656E6774682D315D2E746F3B6C657420693D4D6174682E666C6F6F7228652A6E293B666F72286C657420653D303B3B652B2B297B6C65747B66726F';
wwv_flow_imp.g_varchar2_table(45327) := '6D3A6E2C746F3A6F7D3D745B655D2C733D6F2D6E3B696628693C3D732972657475726E206E2B693B692D3D737D7D66756E6374696F6E20644928652C74297B6C6574206E3D303B666F72286C65747B66726F6D3A692C746F3A6F7D6F6620652E72616E67';
wwv_flow_imp.g_varchar2_table(45328) := '6573297B696628743C3D6F297B6E2B3D742D693B627265616B7D6E2B3D6F2D697D72657475726E206E2F652E746F74616C7D636F6E73742068493D7B746F444F4D3A653D3E652C66726F6D444F4D3A653D3E652C7363616C653A312C65712865297B7265';
wwv_flow_imp.g_varchar2_table(45329) := '7475726E20653D3D746869737D7D3B636C6173732075497B636F6E7374727563746F7228652C742C6E297B6C657420693D302C6F3D302C733D303B746869732E76696577706F7274733D6E2E6D61702828287B66726F6D3A6E2C746F3A6F7D293D3E7B6C';
wwv_flow_imp.g_varchar2_table(45330) := '657420733D742E6C696E654174286E2C55542E4279506F732C652C302C30292E746F702C723D742E6C696E654174286F2C55542E4279506F732C652C302C30292E626F74746F6D3B72657475726E20692B3D722D732C7B66726F6D3A6E2C746F3A6F2C74';
wwv_flow_imp.g_varchar2_table(45331) := '6F703A732C626F74746F6D3A722C646F6D546F703A302C646F6D426F74746F6D3A307D7D29292C746869732E7363616C653D283765362D69292F28742E6865696768742D69293B666F72286C65742065206F6620746869732E76696577706F7274732965';
wwv_flow_imp.g_varchar2_table(45332) := '2E646F6D546F703D732B28652E746F702D6F292A746869732E7363616C652C733D652E646F6D426F74746F6D3D652E646F6D546F702B28652E626F74746F6D2D652E746F70292C6F3D652E626F74746F6D7D746F444F4D2865297B666F72286C65742074';
wwv_flow_imp.g_varchar2_table(45333) := '3D302C6E3D302C693D303B3B742B2B297B6C6574206F3D743C746869732E76696577706F7274732E6C656E6774683F746869732E76696577706F7274735B745D3A6E756C6C3B696628216F7C7C653C6F2E746F702972657475726E20692B28652D6E292A';
wwv_flow_imp.g_varchar2_table(45334) := '746869732E7363616C653B696628653C3D6F2E626F74746F6D2972657475726E206F2E646F6D546F702B28652D6F2E746F70293B6E3D6F2E626F74746F6D2C693D6F2E646F6D426F74746F6D7D7D66726F6D444F4D2865297B666F72286C657420743D30';
wwv_flow_imp.g_varchar2_table(45335) := '2C6E3D302C693D303B3B742B2B297B6C6574206F3D743C746869732E76696577706F7274732E6C656E6774683F746869732E76696577706F7274735B745D3A6E756C6C3B696628216F7C7C653C6F2E646F6D546F702972657475726E206E2B28652D6929';
wwv_flow_imp.g_varchar2_table(45336) := '2F746869732E7363616C653B696628653C3D6F2E646F6D426F74746F6D2972657475726E206F2E746F702B28652D6F2E646F6D546F70293B6E3D6F2E626F74746F6D2C693D6F2E646F6D426F74746F6D7D7D65712865297B72657475726E206520696E73';
wwv_flow_imp.g_varchar2_table(45337) := '74616E63656F662075492626746869732E7363616C653D3D652E7363616C652626746869732E76696577706F7274732E6C656E6774683D3D652E76696577706F7274732E6C656E6774682626746869732E76696577706F7274732E657665727928282874';
wwv_flow_imp.g_varchar2_table(45338) := '2C6E293D3E742E66726F6D3D3D652E76696577706F7274735B6E5D2E66726F6D2626742E746F3D3D652E76696577706F7274735B6E5D2E746F29297D7D66756E6374696F6E20704928652C74297B696628313D3D742E7363616C652972657475726E2065';
wwv_flow_imp.g_varchar2_table(45339) := '3B6C6574206E3D742E746F444F4D28652E746F70292C693D742E746F444F4D28652E626F74746F6D293B72657475726E206E657720245428652E66726F6D2C652E6C656E6774682C6E2C692D6E2C41727261792E6973417272617928652E5F636F6E7465';
wwv_flow_imp.g_varchar2_table(45340) := '6E74293F652E5F636F6E74656E742E6D61702828653D3E704928652C742929293A652E5F636F6E74656E74297D636F6E73742067493D5F6B2E646566696E65287B636F6D62696E653A653D3E652E6A6F696E28222022297D292C6D493D5F6B2E64656669';
wwv_flow_imp.g_varchar2_table(45341) := '6E65287B636F6D62696E653A653D3E652E696E6465784F66282130293E2D317D292C66493D78452E6E65774E616D6528292C76493D78452E6E65774E616D6528292C62493D78452E6E65774E616D6528292C5F493D7B22266C69676874223A222E222B76';
wwv_flow_imp.g_varchar2_table(45342) := '492C22266461726B223A222E222B62497D3B66756E6374696F6E20794928652C742C6E297B72657475726E206E657720784528742C7B66696E6973683A743D3E2F262F2E746573742874293F742E7265706C616365282F265C772A2F2C28743D3E7B6966';
wwv_flow_imp.g_varchar2_table(45343) := '282226223D3D742972657475726E20653B696628216E7C7C216E5B745D297468726F77206E65772052616E67654572726F722860556E737570706F727465642073656C6563746F723A20247B747D60293B72657475726E206E5B745D7D29293A652B2220';
wwv_flow_imp.g_varchar2_table(45344) := '222B747D297D636F6E73742077493D794928222E222B66492C7B2226223A7B706F736974696F6E3A2272656C61746976652021696D706F7274616E74222C626F7853697A696E673A22626F726465722D626F78222C22262E636D2D666F6375736564223A';
wwv_flow_imp.g_varchar2_table(45345) := '7B6F75746C696E653A2231707820646F747465642023323132313231227D2C646973706C61793A22666C65782021696D706F7274616E74222C666C6578446972656374696F6E3A22636F6C756D6E227D2C222E636D2D7363726F6C6C6572223A7B646973';
wwv_flow_imp.g_varchar2_table(45346) := '706C61793A22666C65782021696D706F7274616E74222C616C69676E4974656D733A22666C65782D73746172742021696D706F7274616E74222C666F6E7446616D696C793A226D6F6E6F7370616365222C6C696E654865696768743A312E342C68656967';
wwv_flow_imp.g_varchar2_table(45347) := '68743A2231303025222C6F766572666C6F77583A226175746F222C706F736974696F6E3A2272656C6174697665222C7A496E6465783A302C6F766572666C6F77416E63686F723A226E6F6E65227D2C222E636D2D636F6E74656E74223A7B6D617267696E';
wwv_flow_imp.g_varchar2_table(45348) := '3A302C666C657847726F773A322C666C6578536872696E6B3A302C646973706C61793A22626C6F636B222C776869746553706163653A22707265222C776F7264577261703A226E6F726D616C222C626F7853697A696E673A22626F726465722D626F7822';
wwv_flow_imp.g_varchar2_table(45349) := '2C6D696E4865696768743A2231303025222C70616464696E673A223470782030222C6F75746C696E653A226E6F6E65222C22265B636F6E74656E746564697461626C653D747275655D223A7B5765626B6974557365724D6F646966793A22726561642D77';
wwv_flow_imp.g_varchar2_table(45350) := '726974652D706C61696E746578742D6F6E6C79227D7D2C222E636D2D6C696E655772617070696E67223A7B776869746553706163655F66616C6C6261636B3A227072652D77726170222C776869746553706163653A22627265616B2D737061636573222C';
wwv_flow_imp.g_varchar2_table(45351) := '776F7264427265616B3A22627265616B2D776F7264222C6F766572666C6F77577261703A22616E797768657265222C666C6578536872696E6B3A317D2C22266C69676874202E636D2D636F6E74656E74223A7B6361726574436F6C6F723A22626C61636B';
wwv_flow_imp.g_varchar2_table(45352) := '227D2C22266461726B202E636D2D636F6E74656E74223A7B6361726574436F6C6F723A227768697465227D2C222E636D2D6C696E65223A7B646973706C61793A22626C6F636B222C70616464696E673A223020327078203020367078227D2C222E636D2D';
wwv_flow_imp.g_varchar2_table(45353) := '6C61796572223A7B706F736974696F6E3A226162736F6C757465222C6C6566743A302C746F703A302C636F6E7461696E3A2273697A65207374796C65222C2226203E202A223A7B706F736974696F6E3A226162736F6C757465227D7D2C22266C69676874';
wwv_flow_imp.g_varchar2_table(45354) := '202E636D2D73656C656374696F6E4261636B67726F756E64223A7B6261636B67726F756E643A2223643964396439227D2C22266461726B202E636D2D73656C656374696F6E4261636B67726F756E64223A7B6261636B67726F756E643A2223323232227D';
wwv_flow_imp.g_varchar2_table(45355) := '2C22266C696768742E636D2D666F6375736564203E202E636D2D7363726F6C6C6572203E202E636D2D73656C656374696F6E4C61796572202E636D2D73656C656374696F6E4261636B67726F756E64223A7B6261636B67726F756E643A22236437643466';
wwv_flow_imp.g_varchar2_table(45356) := '30227D2C22266461726B2E636D2D666F6375736564203E202E636D2D7363726F6C6C6572203E202E636D2D73656C656374696F6E4C61796572202E636D2D73656C656374696F6E4261636B67726F756E64223A7B6261636B67726F756E643A2223323333';
wwv_flow_imp.g_varchar2_table(45357) := '227D2C222E636D2D637572736F724C61796572223A7B706F696E7465724576656E74733A226E6F6E65227D2C22262E636D2D666F6375736564203E202E636D2D7363726F6C6C6572203E202E636D2D637572736F724C61796572223A7B616E696D617469';
wwv_flow_imp.g_varchar2_table(45358) := '6F6E3A22737465707328312920636D2D626C696E6B20312E327320696E66696E697465227D2C22406B65796672616D657320636D2D626C696E6B223A7B223025223A7B7D2C22353025223A7B6F7061636974793A307D2C2231303025223A7B7D7D2C2240';
wwv_flow_imp.g_varchar2_table(45359) := '6B65796672616D657320636D2D626C696E6B32223A7B223025223A7B7D2C22353025223A7B6F7061636974793A307D2C2231303025223A7B7D7D2C222E636D2D637572736F722C202E636D2D64726F70437572736F72223A7B626F726465724C6566743A';
wwv_flow_imp.g_varchar2_table(45360) := '22312E32707820736F6C696420626C61636B222C6D617267696E4C6566743A222D302E367078222C706F696E7465724576656E74733A226E6F6E65227D2C222E636D2D637572736F72223A7B646973706C61793A226E6F6E65227D2C22266461726B202E';
wwv_flow_imp.g_varchar2_table(45361) := '636D2D637572736F72223A7B626F726465724C656674436F6C6F723A2223343434227D2C222E636D2D64726F70437572736F72223A7B706F736974696F6E3A226162736F6C757465227D2C22262E636D2D666F6375736564203E202E636D2D7363726F6C';
wwv_flow_imp.g_varchar2_table(45362) := '6C6572203E202E636D2D637572736F724C61796572202E636D2D637572736F72223A7B646973706C61793A22626C6F636B227D2C222E636D2D69736F223A7B756E69636F6465426964693A2269736F6C617465227D2C222E636D2D616E6E6F756E636564';
wwv_flow_imp.g_varchar2_table(45363) := '223A7B706F736974696F6E3A226669786564222C746F703A222D31303030307078227D2C22406D65646961207072696E74223A7B222E636D2D616E6E6F756E636564223A7B646973706C61793A226E6F6E65227D7D2C22266C69676874202E636D2D6163';
wwv_flow_imp.g_varchar2_table(45364) := '746976654C696E65223A7B6261636B67726F756E64436F6C6F723A22236363656566663434227D2C22266461726B202E636D2D6163746976654C696E65223A7B6261636B67726F756E64436F6C6F723A22233939656566663333227D2C22266C69676874';
wwv_flow_imp.g_varchar2_table(45365) := '202E636D2D7370656369616C43686172223A7B636F6C6F723A22726564227D2C22266461726B202E636D2D7370656369616C43686172223A7B636F6C6F723A2223663738227D2C222E636D2D67757474657273223A7B666C6578536872696E6B3A302C64';
wwv_flow_imp.g_varchar2_table(45366) := '6973706C61793A22666C6578222C6865696768743A2231303025222C626F7853697A696E673A22626F726465722D626F78222C696E736574496E6C696E6553746172743A302C7A496E6465783A3230307D2C22266C69676874202E636D2D677574746572';
wwv_flow_imp.g_varchar2_table(45367) := '73223A7B6261636B67726F756E64436F6C6F723A2223663566356635222C636F6C6F723A2223366336633663222C626F7264657252696768743A2231707820736F6C69642023646464227D2C22266461726B202E636D2D67757474657273223A7B626163';
wwv_flow_imp.g_varchar2_table(45368) := '6B67726F756E64436F6C6F723A2223333333333338222C636F6C6F723A2223636363227D2C222E636D2D677574746572223A7B646973706C61793A22666C65782021696D706F7274616E74222C666C6578446972656374696F6E3A22636F6C756D6E222C';
wwv_flow_imp.g_varchar2_table(45369) := '666C6578536872696E6B3A302C626F7853697A696E673A22626F726465722D626F78222C6D696E4865696768743A2231303025222C6F766572666C6F773A2268696464656E227D2C222E636D2D677574746572456C656D656E74223A7B626F7853697A69';
wwv_flow_imp.g_varchar2_table(45370) := '6E673A22626F726465722D626F78227D2C222E636D2D6C696E654E756D62657273202E636D2D677574746572456C656D656E74223A7B70616464696E673A223020337078203020357078222C6D696E57696474683A2232307078222C74657874416C6967';
wwv_flow_imp.g_varchar2_table(45371) := '6E3A227269676874222C776869746553706163653A226E6F77726170227D2C22266C69676874202E636D2D6163746976654C696E65477574746572223A7B6261636B67726F756E64436F6C6F723A2223653266326666227D2C22266461726B202E636D2D';
wwv_flow_imp.g_varchar2_table(45372) := '6163746976654C696E65477574746572223A7B6261636B67726F756E64436F6C6F723A2223323232323237227D2C222E636D2D70616E656C73223A7B626F7853697A696E673A22626F726465722D626F78222C706F736974696F6E3A22737469636B7922';
wwv_flow_imp.g_varchar2_table(45373) := '2C6C6566743A302C72696768743A302C7A496E6465783A3330307D2C22266C69676874202E636D2D70616E656C73223A7B6261636B67726F756E64436F6C6F723A2223663566356635222C636F6C6F723A22626C61636B227D2C22266C69676874202E63';
wwv_flow_imp.g_varchar2_table(45374) := '6D2D70616E656C732D746F70223A7B626F72646572426F74746F6D3A2231707820736F6C69642023646464227D2C22266C69676874202E636D2D70616E656C732D626F74746F6D223A7B626F72646572546F703A2231707820736F6C6964202364646422';
wwv_flow_imp.g_varchar2_table(45375) := '7D2C22266461726B202E636D2D70616E656C73223A7B6261636B67726F756E64436F6C6F723A2223333333333338222C636F6C6F723A227768697465227D2C222E636D2D746162223A7B646973706C61793A22696E6C696E652D626C6F636B222C6F7665';
wwv_flow_imp.g_varchar2_table(45376) := '72666C6F773A2268696464656E222C766572746963616C416C69676E3A22626F74746F6D227D2C222E636D2D776964676574427566666572223A7B766572746963616C416C69676E3A22746578742D746F70222C6865696768743A2231656D222C776964';
wwv_flow_imp.g_varchar2_table(45377) := '74683A302C646973706C61793A22696E6C696E65227D2C222E636D2D706C616365686F6C646572223A7B636F6C6F723A2223383838222C646973706C61793A22696E6C696E652D626C6F636B222C766572746963616C416C69676E3A22746F70227D2C22';
wwv_flow_imp.g_varchar2_table(45378) := '2E636D2D686967686C6967687453706163653A6265666F7265223A7B636F6E74656E743A226174747228646174612D646973706C617929222C706F736974696F6E3A226162736F6C757465222C706F696E7465724576656E74733A226E6F6E65222C636F';
wwv_flow_imp.g_varchar2_table(45379) := '6C6F723A2223383838227D2C222E636D2D686967686C69676874546162223A7B6261636B67726F756E64496D6167653A2775726C285C27646174613A696D6167652F7376672B786D6C2C3C73766720786D6C6E733D22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(45380) := '6F72672F323030302F737667222077696474683D2232303022206865696768743D223230223E3C70617468207374726F6B653D2225323338383822207374726F6B652D77696474683D2231222066696C6C3D226E6F6E652220643D224D31203130483139';
wwv_flow_imp.g_varchar2_table(45381) := '364C31393020354D3139302031354C3139362031304D31393720344C313937203136222F3E3C2F7376673E5C2729272C6261636B67726F756E6453697A653A226175746F2031303025222C6261636B67726F756E64506F736974696F6E3A227269676874';
wwv_flow_imp.g_varchar2_table(45382) := '20393025222C6261636B67726F756E645265706561743A226E6F2D726570656174227D2C222E636D2D747261696C696E675370616365223A7B6261636B67726F756E64436F6C6F723A22236666333332323535227D2C222E636D2D627574746F6E223A7B';
wwv_flow_imp.g_varchar2_table(45383) := '766572746963616C416C69676E3A226D6964646C65222C636F6C6F723A22696E6865726974222C666F6E7453697A653A22373025222C70616464696E673A222E32656D2031656D222C626F726465725261646975733A22317078227D2C22266C69676874';
wwv_flow_imp.g_varchar2_table(45384) := '202E636D2D627574746F6E223A7B6261636B67726F756E64496D6167653A226C696E6561722D6772616469656E7428236566663166352C202364396439646629222C626F726465723A2231707820736F6C69642023383838222C22263A61637469766522';
wwv_flow_imp.g_varchar2_table(45385) := '3A7B6261636B67726F756E64496D6167653A226C696E6561722D6772616469656E7428236234623462342C202364306433643629227D7D2C22266461726B202E636D2D627574746F6E223A7B6261636B67726F756E64496D6167653A226C696E6561722D';
wwv_flow_imp.g_varchar2_table(45386) := '6772616469656E7428233339333933392C202331313129222C626F726465723A2231707820736F6C69642023383838222C22263A616374697665223A7B6261636B67726F756E64496D6167653A226C696E6561722D6772616469656E7428233131312C20';
wwv_flow_imp.g_varchar2_table(45387) := '2333333329227D7D2C222E636D2D746578746669656C64223A7B766572746963616C416C69676E3A226D6964646C65222C636F6C6F723A22696E6865726974222C666F6E7453697A653A22373025222C626F726465723A2231707820736F6C6964207369';
wwv_flow_imp.g_varchar2_table(45388) := '6C766572222C70616464696E673A222E32656D202E35656D227D2C22266C69676874202E636D2D746578746669656C64223A7B6261636B67726F756E64436F6C6F723A227768697465227D2C22266461726B202E636D2D746578746669656C64223A7B62';
wwv_flow_imp.g_varchar2_table(45389) := '6F726465723A2231707820736F6C69642023353535222C6261636B67726F756E64436F6C6F723A22696E6865726974227D7D2C5F49292C43493D7B6368696C644C6973743A21302C636861726163746572446174613A21302C737562747265653A21302C';
wwv_flow_imp.g_varchar2_table(45390) := '617474726962757465733A21302C636861726163746572446174614F6C6456616C75653A21307D2C53493D5F4C2E696526265F4C2E69655F76657273696F6E3C3D31313B636C6173732078497B636F6E7374727563746F722865297B746869732E766965';
wwv_flow_imp.g_varchar2_table(45391) := '773D652C746869732E6163746976653D21312C746869732E65646974436F6E746578743D6E756C6C2C746869732E73656C656374696F6E52616E67653D6E65772024452C746869732E73656C656374696F6E4368616E6765643D21312C746869732E6465';
wwv_flow_imp.g_varchar2_table(45392) := '6C61796564466C7573683D2D312C746869732E726573697A6554696D656F75743D2D312C746869732E71756575653D5B5D2C746869732E64656C61796564416E64726F69644B65793D6E756C6C2C746869732E666C757368696E67416E64726F69644B65';
wwv_flow_imp.g_varchar2_table(45393) := '793D2D312C746869732E6C6173744368616E67653D302C746869732E7363726F6C6C546172676574733D5B5D2C746869732E696E74657273656374696F6E3D6E756C6C2C746869732E726573697A655363726F6C6C3D6E756C6C2C746869732E696E7465';
wwv_flow_imp.g_varchar2_table(45394) := '7273656374696E673D21312C746869732E676170496E74657273656374696F6E3D6E756C6C2C746869732E676170733D5B5D2C746869732E7072696E7451756572793D6E756C6C2C746869732E706172656E74436865636B3D2D312C746869732E646F6D';
wwv_flow_imp.g_varchar2_table(45395) := '3D652E636F6E74656E74444F4D2C746869732E6F627365727665723D6E6577204D75746174696F6E4F627365727665722828743D3E7B666F72286C65742065206F66207429746869732E71756575652E707573682865293B285F4C2E696526265F4C2E69';
wwv_flow_imp.g_varchar2_table(45396) := '655F76657273696F6E3C3D31317C7C5F4C2E696F732626652E636F6D706F73696E67292626742E736F6D652828653D3E226368696C644C697374223D3D652E747970652626652E72656D6F7665644E6F6465732E6C656E6774687C7C2263686172616374';
wwv_flow_imp.g_varchar2_table(45397) := '657244617461223D3D652E747970652626652E6F6C6456616C75652E6C656E6774683E652E7461726765742E6E6F646556616C75652E6C656E67746829293F746869732E666C757368536F6F6E28293A746869732E666C75736828297D29292C2177696E';
wwv_flow_imp.g_varchar2_table(45398) := '646F772E45646974436F6E746578747C7C21313D3D3D652E636F6E7374727563746F722E454449545F434F4E544558547C7C5F4C2E6368726F6D6526265F4C2E6368726F6D655F76657273696F6E3C3132367C7C28746869732E65646974436F6E746578';
wwv_flow_imp.g_varchar2_table(45399) := '743D6E6577204C492865292C652E73746174652E6661636574284C4429262628652E636F6E74656E74444F4D2E65646974436F6E746578743D746869732E65646974436F6E746578742E65646974436F6E7465787429292C5349262628746869732E6F6E';
wwv_flow_imp.g_varchar2_table(45400) := '43686172446174613D653D3E7B746869732E71756575652E70757368287B7461726765743A652E7461726765742C747970653A2263686172616374657244617461222C6F6C6456616C75653A652E7072657656616C75657D292C746869732E666C757368';
wwv_flow_imp.g_varchar2_table(45401) := '536F6F6E28297D292C746869732E6F6E53656C656374696F6E4368616E67653D746869732E6F6E53656C656374696F6E4368616E67652E62696E642874686973292C746869732E6F6E526573697A653D746869732E6F6E526573697A652E62696E642874';
wwv_flow_imp.g_varchar2_table(45402) := '686973292C746869732E6F6E5072696E743D746869732E6F6E5072696E742E62696E642874686973292C746869732E6F6E5363726F6C6C3D746869732E6F6E5363726F6C6C2E62696E642874686973292C77696E646F772E6D617463684D656469612626';
wwv_flow_imp.g_varchar2_table(45403) := '28746869732E7072696E7451756572793D77696E646F772E6D617463684D6564696128227072696E742229292C2266756E6374696F6E223D3D747970656F6620526573697A654F62736572766572262628746869732E726573697A655363726F6C6C3D6E';
wwv_flow_imp.g_varchar2_table(45404) := '657720526573697A654F62736572766572282828293D3E7B76617220653B286E756C6C3D3D3D28653D746869732E766965772E646F6356696577297C7C766F696420303D3D3D653F766F696420303A652E6C617374557064617465293C446174652E6E6F';
wwv_flow_imp.g_varchar2_table(45405) := '7728292D37352626746869732E6F6E526573697A6528297D29292C746869732E726573697A655363726F6C6C2E6F62736572766528652E7363726F6C6C444F4D29292C746869732E61646457696E646F774C697374656E65727328746869732E77696E3D';
wwv_flow_imp.g_varchar2_table(45406) := '652E77696E292C746869732E737461727428292C2266756E6374696F6E223D3D747970656F6620496E74657273656374696F6E4F62736572766572262628746869732E696E74657273656374696F6E3D6E657720496E74657273656374696F6E4F627365';
wwv_flow_imp.g_varchar2_table(45407) := '727665722828653D3E7B746869732E706172656E74436865636B3C30262628746869732E706172656E74436865636B3D73657454696D656F757428746869732E6C697374656E466F725363726F6C6C2E62696E642874686973292C31653329292C652E6C';
wwv_flow_imp.g_varchar2_table(45408) := '656E6774683E302626655B652E6C656E6774682D315D2E696E74657273656374696F6E526174696F3E30213D746869732E696E74657273656374696E67262628746869732E696E74657273656374696E673D21746869732E696E74657273656374696E67';
wwv_flow_imp.g_varchar2_table(45409) := '2C746869732E696E74657273656374696E67213D746869732E766965772E696E566965772626746869732E6F6E5363726F6C6C4368616E67656428646F63756D656E742E6372656174654576656E7428224576656E74222929297D292C7B746872657368';
wwv_flow_imp.g_varchar2_table(45410) := '6F6C643A5B302C2E3030315D7D292C746869732E696E74657273656374696F6E2E6F62736572766528746869732E646F6D292C746869732E676170496E74657273656374696F6E3D6E657720496E74657273656374696F6E4F627365727665722828653D';
wwv_flow_imp.g_varchar2_table(45411) := '3E7B652E6C656E6774683E302626655B652E6C656E6774682D315D2E696E74657273656374696F6E526174696F3E302626746869732E6F6E5363726F6C6C4368616E67656428646F63756D656E742E6372656174654576656E7428224576656E74222929';
wwv_flow_imp.g_varchar2_table(45412) := '7D292C7B7D29292C746869732E6C697374656E466F725363726F6C6C28292C746869732E7265616453656C656374696F6E52616E676528297D6F6E5363726F6C6C4368616E6765642865297B746869732E766965772E696E70757453746174652E72756E';
wwv_flow_imp.g_varchar2_table(45413) := '48616E646C65727328227363726F6C6C222C65292C746869732E696E74657273656374696E672626746869732E766965772E6D65617375726528297D6F6E5363726F6C6C2865297B746869732E696E74657273656374696E672626746869732E666C7573';
wwv_flow_imp.g_varchar2_table(45414) := '68282131292C746869732E65646974436F6E746578742626746869732E766965772E726571756573744D65617375726528746869732E65646974436F6E746578742E6D656173757265526571292C746869732E6F6E5363726F6C6C4368616E6765642865';
wwv_flow_imp.g_varchar2_table(45415) := '297D6F6E526573697A6528297B746869732E726573697A6554696D656F75743C30262628746869732E726573697A6554696D656F75743D73657454696D656F7574282828293D3E7B746869732E726573697A6554696D656F75743D2D312C746869732E76';
wwv_flow_imp.g_varchar2_table(45416) := '6965772E726571756573744D65617375726528297D292C353029297D6F6E5072696E742865297B28226368616E676522213D652E747970652626652E747970657C7C652E6D61746368657329262628746869732E766965772E7669657753746174652E70';
wwv_flow_imp.g_varchar2_table(45417) := '72696E74696E673D21302C746869732E766965772E6D65617375726528292C73657454696D656F7574282828293D3E7B746869732E766965772E7669657753746174652E7072696E74696E673D21312C746869732E766965772E726571756573744D6561';
wwv_flow_imp.g_varchar2_table(45418) := '7375726528297D292C35303029297D757064617465476170732865297B696628746869732E676170496E74657273656374696F6E262628652E6C656E677468213D746869732E676170732E6C656E6774687C7C746869732E676170732E736F6D65282828';
wwv_flow_imp.g_varchar2_table(45419) := '742C6E293D3E74213D655B6E5D292929297B746869732E676170496E74657273656374696F6E2E646973636F6E6E65637428293B666F72286C65742074206F66206529746869732E676170496E74657273656374696F6E2E6F6273657276652874293B74';
wwv_flow_imp.g_varchar2_table(45420) := '6869732E676170733D657D7D6F6E53656C656374696F6E4368616E67652865297B6C657420743D746869732E73656C656374696F6E4368616E6765643B69662821746869732E7265616453656C656374696F6E52616E676528297C7C746869732E64656C';
wwv_flow_imp.g_varchar2_table(45421) := '61796564416E64726F69644B65792972657475726E3B6C65747B766965773A6E7D3D746869732C693D746869732E73656C656374696F6E52616E67653B6966286E2E73746174652E6661636574284C44293F6E2E726F6F742E616374697665456C656D65';
wwv_flow_imp.g_varchar2_table(45422) := '6E74213D746869732E646F6D3A214F45286E2E646F6D2C69292972657475726E3B6C6574206F3D692E616E63686F724E6F646526266E2E646F63566965772E6E65617265737428692E616E63686F724E6F6465293B6F26266F2E69676E6F72654576656E';
wwv_flow_imp.g_varchar2_table(45423) := '742865293F747C7C28746869732E73656C656374696F6E4368616E6765643D2131293A285F4C2E696526265F4C2E69655F76657273696F6E3C3D31317C7C5F4C2E616E64726F696426265F4C2E6368726F6D65292626216E2E73746174652E73656C6563';
wwv_flow_imp.g_varchar2_table(45424) := '74696F6E2E6D61696E2E656D7074792626692E666F6375734E6F64652626464528692E666F6375734E6F64652C692E666F6375734F66667365742C692E616E63686F724E6F64652C692E616E63686F724F6666736574293F746869732E666C757368536F';
wwv_flow_imp.g_varchar2_table(45425) := '6F6E28293A746869732E666C757368282131297D7265616453656C656374696F6E52616E676528297B6C65747B766965773A657D3D746869732C743D4E4528652E726F6F74293B69662821742972657475726E21313B6C6574206E3D5F4C2E7361666172';
wwv_flow_imp.g_varchar2_table(45426) := '69262631313D3D652E726F6F742E6E6F646554797065262666756E6374696F6E2865297B6C657420743D652E616374697665456C656D656E743B666F72283B742626742E736861646F77526F6F743B29743D742E736861646F77526F6F742E6163746976';
wwv_flow_imp.g_varchar2_table(45427) := '65456C656D656E743B72657475726E20747D28746869732E646F6D2E6F776E6572446F63756D656E74293D3D746869732E646F6D262666756E6374696F6E28652C74297B696628742E676574436F6D706F73656452616E676573297B6C6574206E3D742E';
wwv_flow_imp.g_varchar2_table(45428) := '676574436F6D706F73656452616E67657328652E726F6F74295B305D3B6966286E2972657475726E20454928652C6E297D6C6574206E3D6E756C6C3B66756E6374696F6E20692865297B652E70726576656E7444656661756C7428292C652E73746F7049';
wwv_flow_imp.g_varchar2_table(45429) := '6D6D65646961746550726F7061676174696F6E28292C6E3D652E67657454617267657452616E67657328295B305D7D72657475726E20652E636F6E74656E74444F4D2E6164644576656E744C697374656E657228226265666F7265696E707574222C692C';
wwv_flow_imp.g_varchar2_table(45430) := '2130292C652E646F6D2E6F776E6572446F63756D656E742E65786563436F6D6D616E642822696E64656E7422292C652E636F6E74656E74444F4D2E72656D6F76654576656E744C697374656E657228226265666F7265696E707574222C692C2130292C6E';
wwv_flow_imp.g_varchar2_table(45431) := '3F454928652C6E293A6E756C6C7D28746869732E766965772C74297C7C743B696628216E7C7C746869732E73656C656374696F6E52616E67652E6571286E292972657475726E21313B6C657420693D4F4528746869732E646F6D2C6E293B72657475726E';
wwv_flow_imp.g_varchar2_table(45432) := '2069262621746869732E73656C656374696F6E4368616E6765642626652E696E70757453746174652E6C617374466F63757354696D653E446174652E6E6F7728292D3230302626652E696E70757453746174652E6C617374546F75636854696D653C4461';
wwv_flow_imp.g_varchar2_table(45433) := '74652E6E6F7728292D333030262666756E6374696F6E28652C74297B6C6574206E3D742E666F6375734E6F64652C693D742E666F6375734F66667365743B696628216E7C7C742E616E63686F724E6F6465213D6E7C7C742E616E63686F724F6666736574';
wwv_flow_imp.g_varchar2_table(45434) := '213D692972657475726E21313B666F7228693D4D6174682E6D696E28692C4845286E29293B3B2969662869297B69662831213D6E2E6E6F6465547970652972657475726E21313B6C657420653D6E2E6368696C644E6F6465735B692D315D3B2266616C73';
wwv_flow_imp.g_varchar2_table(45435) := '65223D3D652E636F6E74656E744564697461626C653F692D2D3A286E3D652C693D4845286E29297D656C73657B6966286E3D3D652972657475726E21303B693D4245286E292C6E3D6E2E706172656E744E6F64657D7D28746869732E646F6D2C6E293F28';
wwv_flow_imp.g_varchar2_table(45436) := '746869732E766965772E696E70757453746174652E6C617374466F63757354696D653D302C652E646F63566965772E75706461746553656C656374696F6E28292C2131293A28746869732E73656C656374696F6E52616E67652E73657452616E6765286E';
wwv_flow_imp.g_varchar2_table(45437) := '292C69262628746869732E73656C656374696F6E4368616E6765643D2130292C2130297D73657453656C656374696F6E52616E676528652C74297B746869732E73656C656374696F6E52616E67652E73657428652E6E6F64652C652E6F66667365742C74';
wwv_flow_imp.g_varchar2_table(45438) := '2E6E6F64652C742E6F6666736574292C746869732E73656C656374696F6E4368616E6765643D21317D636C65617253656C656374696F6E52616E676528297B746869732E73656C656374696F6E52616E67652E736574286E756C6C2C302C6E756C6C2C30';
wwv_flow_imp.g_varchar2_table(45439) := '297D6C697374656E466F725363726F6C6C28297B746869732E706172656E74436865636B3D2D313B6C657420653D302C743D6E756C6C3B666F72286C6574206E3D746869732E646F6D3B6E3B29696628313D3D6E2E6E6F6465547970652921742626653C';
wwv_flow_imp.g_varchar2_table(45440) := '746869732E7363726F6C6C546172676574732E6C656E6774682626746869732E7363726F6C6C546172676574735B655D3D3D6E3F652B2B3A747C7C28743D746869732E7363726F6C6C546172676574732E736C69636528302C6529292C742626742E7075';
wwv_flow_imp.g_varchar2_table(45441) := '7368286E292C6E3D6E2E61737369676E6564536C6F747C7C6E2E706172656E744E6F64653B656C73657B6966283131213D6E2E6E6F64655479706529627265616B3B6E3D6E2E686F73747D696628653C746869732E7363726F6C6C546172676574732E6C';
wwv_flow_imp.g_varchar2_table(45442) := '656E67746826262174262628743D746869732E7363726F6C6C546172676574732E736C69636528302C6529292C74297B666F72286C65742065206F6620746869732E7363726F6C6C5461726765747329652E72656D6F76654576656E744C697374656E65';
wwv_flow_imp.g_varchar2_table(45443) := '7228227363726F6C6C222C746869732E6F6E5363726F6C6C293B666F72286C65742065206F6620746869732E7363726F6C6C546172676574733D7429652E6164644576656E744C697374656E657228227363726F6C6C222C746869732E6F6E5363726F6C';
wwv_flow_imp.g_varchar2_table(45444) := '6C297D7D69676E6F72652865297B69662821746869732E6163746976652972657475726E206528293B7472797B72657475726E20746869732E73746F7028292C6528297D66696E616C6C797B746869732E737461727428292C746869732E636C65617228';
wwv_flow_imp.g_varchar2_table(45445) := '297D7D737461727428297B746869732E6163746976657C7C28746869732E6F627365727665722E6F62736572766528746869732E646F6D2C4349292C53492626746869732E646F6D2E6164644576656E744C697374656E65722822444F4D436861726163';
wwv_flow_imp.g_varchar2_table(45446) := '746572446174614D6F646966696564222C746869732E6F6E4368617244617461292C746869732E6163746976653D2130297D73746F7028297B746869732E616374697665262628746869732E6163746976653D21312C746869732E6F627365727665722E';
wwv_flow_imp.g_varchar2_table(45447) := '646973636F6E6E65637428292C53492626746869732E646F6D2E72656D6F76654576656E744C697374656E65722822444F4D436861726163746572446174614D6F646966696564222C746869732E6F6E436861724461746129297D636C65617228297B74';
wwv_flow_imp.g_varchar2_table(45448) := '6869732E70726F636573735265636F72647328292C746869732E71756575652E6C656E6774683D302C746869732E73656C656374696F6E4368616E6765643D21317D64656C6179416E64726F69644B657928652C74297B766172206E3B69662821746869';
wwv_flow_imp.g_varchar2_table(45449) := '732E64656C61796564416E64726F69644B6579297B6C657420653D28293D3E7B6C657420653D746869732E64656C61796564416E64726F69644B65793B65262628746869732E636C65617244656C61796564416E64726F69644B657928292C746869732E';
wwv_flow_imp.g_varchar2_table(45450) := '766965772E696E70757453746174652E6C6173744B6579436F64653D652E6B6579436F64652C746869732E766965772E696E70757453746174652E6C6173744B657954696D653D446174652E6E6F7728292C21746869732E666C75736828292626652E66';
wwv_flow_imp.g_varchar2_table(45451) := '6F7263652626594528746869732E646F6D2C652E6B65792C652E6B6579436F646529297D3B746869732E666C757368696E67416E64726F69644B65793D746869732E766965772E77696E2E72657175657374416E696D6174696F6E4672616D652865297D';
wwv_flow_imp.g_varchar2_table(45452) := '746869732E64656C61796564416E64726F69644B6579262622456E74657222213D657C7C28746869732E64656C61796564416E64726F69644B65793D7B6B65793A652C6B6579436F64653A742C666F7263653A746869732E6C6173744368616E67653C44';
wwv_flow_imp.g_varchar2_table(45453) := '6174652E6E6F7728292D35307C7C2121286E756C6C3D3D3D286E3D746869732E64656C61796564416E64726F69644B6579297C7C766F696420303D3D3D6E3F766F696420303A6E2E666F726365297D297D636C65617244656C61796564416E64726F6964';
wwv_flow_imp.g_varchar2_table(45454) := '4B657928297B746869732E77696E2E63616E63656C416E696D6174696F6E4672616D6528746869732E666C757368696E67416E64726F69644B6579292C746869732E64656C61796564416E64726F69644B65793D6E756C6C2C746869732E666C75736869';
wwv_flow_imp.g_varchar2_table(45455) := '6E67416E64726F69644B65793D2D317D666C757368536F6F6E28297B746869732E64656C61796564466C7573683C30262628746869732E64656C61796564466C7573683D746869732E766965772E77696E2E72657175657374416E696D6174696F6E4672';
wwv_flow_imp.g_varchar2_table(45456) := '616D65282828293D3E7B746869732E64656C61796564466C7573683D2D312C746869732E666C75736828297D2929297D666F726365466C75736828297B746869732E64656C61796564466C7573683E3D30262628746869732E766965772E77696E2E6361';
wwv_flow_imp.g_varchar2_table(45457) := '6E63656C416E696D6174696F6E4672616D6528746869732E64656C61796564466C757368292C746869732E64656C61796564466C7573683D2D31292C746869732E666C75736828297D70656E64696E675265636F72647328297B666F72286C6574206520';
wwv_flow_imp.g_varchar2_table(45458) := '6F6620746869732E6F627365727665722E74616B655265636F726473282929746869732E71756575652E707573682865293B72657475726E20746869732E71756575657D70726F636573735265636F72647328297B6C657420653D746869732E70656E64';
wwv_flow_imp.g_varchar2_table(45459) := '696E675265636F72647328293B652E6C656E677468262628746869732E71756575653D5B5D293B6C657420743D2D312C6E3D2D312C693D21313B666F72286C6574206F206F662065297B6C657420653D746869732E726561644D75746174696F6E286F29';
wwv_flow_imp.g_varchar2_table(45460) := '3B65262628652E747970654F766572262628693D2130292C2D313D3D743F287B66726F6D3A742C746F3A6E7D3D65293A28743D4D6174682E6D696E28652E66726F6D2C74292C6E3D4D6174682E6D617828652E746F2C6E2929297D72657475726E7B6672';
wwv_flow_imp.g_varchar2_table(45461) := '6F6D3A742C746F3A6E2C747970654F7665723A697D7D726561644368616E676528297B6C65747B66726F6D3A652C746F3A742C747970654F7665723A6E7D3D746869732E70726F636573735265636F72647328292C693D746869732E73656C656374696F';
wwv_flow_imp.g_varchar2_table(45462) := '6E4368616E67656426264F4528746869732E646F6D2C746869732E73656C656374696F6E52616E6765293B696628653C30262621692972657475726E206E756C6C3B653E2D31262628746869732E6C6173744368616E67653D446174652E6E6F77282929';
wwv_flow_imp.g_varchar2_table(45463) := '2C746869732E766965772E696E70757453746174652E6C617374466F63757354696D653D302C746869732E73656C656374696F6E4368616E6765643D21313B6C6574206F3D6E657720635428746869732E766965772C652C742C6E293B72657475726E20';
wwv_flow_imp.g_varchar2_table(45464) := '746869732E766965772E646F63566965772E646F6D4368616E6765643D7B6E657753656C3A6F2E6E657753656C3F6F2E6E657753656C2E6D61696E3A6E756C6C7D2C6F7D666C75736828653D2130297B696628746869732E64656C61796564466C757368';
wwv_flow_imp.g_varchar2_table(45465) := '3E3D307C7C746869732E64656C61796564416E64726F69644B65792972657475726E21313B652626746869732E7265616453656C656374696F6E52616E676528293B6C657420743D746869732E726561644368616E676528293B69662821742972657475';
wwv_flow_imp.g_varchar2_table(45466) := '726E20746869732E766965772E726571756573744D65617375726528292C21313B6C6574206E3D746869732E766965772E73746174652C693D645428746869732E766965772C74293B72657475726E20746869732E766965772E73746174653D3D6E2626';
wwv_flow_imp.g_varchar2_table(45467) := '28742E646F6D4368616E6765647C7C742E6E657753656C262621742E6E657753656C2E6D61696E2E657128746869732E766965772E73746174652E73656C656374696F6E2E6D61696E29292626746869732E766965772E757064617465285B5D292C697D';
wwv_flow_imp.g_varchar2_table(45468) := '726561644D75746174696F6E2865297B6C657420743D746869732E766965772E646F63566965772E6E65617265737428652E746172676574293B69662821747C7C742E69676E6F72654D75746174696F6E2865292972657475726E206E756C6C3B696628';
wwv_flow_imp.g_varchar2_table(45469) := '742E6D61726B4469727479282261747472696275746573223D3D652E74797065292C2261747472696275746573223D3D652E74797065262628742E666C6167737C3D34292C226368696C644C697374223D3D652E74797065297B6C6574206E3D6B492874';
wwv_flow_imp.g_varchar2_table(45470) := '2C652E70726576696F75735369626C696E677C7C652E7461726765742E70726576696F75735369626C696E672C2D31292C693D6B4928742C652E6E6578745369626C696E677C7C652E7461726765742E6E6578745369626C696E672C31293B7265747572';
wwv_flow_imp.g_varchar2_table(45471) := '6E7B66726F6D3A6E3F742E706F734166746572286E293A742E706F73417453746172742C746F3A693F742E706F734265666F72652869293A742E706F734174456E642C747970654F7665723A21317D7D72657475726E2263686172616374657244617461';
wwv_flow_imp.g_varchar2_table(45472) := '223D3D652E747970653F7B66726F6D3A742E706F73417453746172742C746F3A742E706F734174456E642C747970654F7665723A652E7461726765742E6E6F646556616C75653D3D652E6F6C6456616C75657D3A6E756C6C7D73657457696E646F772865';
wwv_flow_imp.g_varchar2_table(45473) := '297B65213D746869732E77696E262628746869732E72656D6F766557696E646F774C697374656E65727328746869732E77696E292C746869732E77696E3D652C746869732E61646457696E646F774C697374656E65727328746869732E77696E29297D61';
wwv_flow_imp.g_varchar2_table(45474) := '646457696E646F774C697374656E6572732865297B652E6164644576656E744C697374656E65722822726573697A65222C746869732E6F6E526573697A65292C746869732E7072696E7451756572793F746869732E7072696E7451756572792E61646445';
wwv_flow_imp.g_varchar2_table(45475) := '76656E744C697374656E65723F746869732E7072696E7451756572792E6164644576656E744C697374656E657228226368616E6765222C746869732E6F6E5072696E74293A746869732E7072696E7451756572792E6164644C697374656E657228746869';
wwv_flow_imp.g_varchar2_table(45476) := '732E6F6E5072696E74293A652E6164644576656E744C697374656E657228226265666F72657072696E74222C746869732E6F6E5072696E74292C652E6164644576656E744C697374656E657228227363726F6C6C222C746869732E6F6E5363726F6C6C29';
wwv_flow_imp.g_varchar2_table(45477) := '2C652E646F63756D656E742E6164644576656E744C697374656E6572282273656C656374696F6E6368616E6765222C746869732E6F6E53656C656374696F6E4368616E6765297D72656D6F766557696E646F774C697374656E6572732865297B652E7265';
wwv_flow_imp.g_varchar2_table(45478) := '6D6F76654576656E744C697374656E657228227363726F6C6C222C746869732E6F6E5363726F6C6C292C652E72656D6F76654576656E744C697374656E65722822726573697A65222C746869732E6F6E526573697A65292C746869732E7072696E745175';
wwv_flow_imp.g_varchar2_table(45479) := '6572793F746869732E7072696E7451756572792E72656D6F76654576656E744C697374656E65723F746869732E7072696E7451756572792E72656D6F76654576656E744C697374656E657228226368616E6765222C746869732E6F6E5072696E74293A74';
wwv_flow_imp.g_varchar2_table(45480) := '6869732E7072696E7451756572792E72656D6F76654C697374656E657228746869732E6F6E5072696E74293A652E72656D6F76654576656E744C697374656E657228226265666F72657072696E74222C746869732E6F6E5072696E74292C652E646F6375';
wwv_flow_imp.g_varchar2_table(45481) := '6D656E742E72656D6F76654576656E744C697374656E6572282273656C656374696F6E6368616E6765222C746869732E6F6E53656C656374696F6E4368616E6765297D7570646174652865297B746869732E65646974436F6E7465787426262874686973';
wwv_flow_imp.g_varchar2_table(45482) := '2E65646974436F6E746578742E7570646174652865292C652E737461727453746174652E6661636574284C4429213D652E73746174652E6661636574284C4429262628652E766965772E636F6E74656E74444F4D2E65646974436F6E746578743D652E73';
wwv_flow_imp.g_varchar2_table(45483) := '746174652E6661636574284C44293F746869732E65646974436F6E746578742E65646974436F6E746578743A6E756C6C29297D64657374726F7928297B76617220652C742C6E3B746869732E73746F7028292C6E756C6C3D3D3D28653D746869732E696E';
wwv_flow_imp.g_varchar2_table(45484) := '74657273656374696F6E297C7C766F696420303D3D3D657C7C652E646973636F6E6E65637428292C6E756C6C3D3D3D28743D746869732E676170496E74657273656374696F6E297C7C766F696420303D3D3D747C7C742E646973636F6E6E65637428292C';
wwv_flow_imp.g_varchar2_table(45485) := '6E756C6C3D3D3D286E3D746869732E726573697A655363726F6C6C297C7C766F696420303D3D3D6E7C7C6E2E646973636F6E6E65637428293B666F72286C65742065206F6620746869732E7363726F6C6C5461726765747329652E72656D6F7665457665';
wwv_flow_imp.g_varchar2_table(45486) := '6E744C697374656E657228227363726F6C6C222C746869732E6F6E5363726F6C6C293B746869732E72656D6F766557696E646F774C697374656E65727328746869732E77696E292C636C65617254696D656F757428746869732E706172656E7443686563';
wwv_flow_imp.g_varchar2_table(45487) := '6B292C636C65617254696D656F757428746869732E726573697A6554696D656F7574292C746869732E77696E2E63616E63656C416E696D6174696F6E4672616D6528746869732E64656C61796564466C757368292C746869732E77696E2E63616E63656C';
wwv_flow_imp.g_varchar2_table(45488) := '416E696D6174696F6E4672616D6528746869732E666C757368696E67416E64726F69644B6579292C746869732E65646974436F6E74657874262628746869732E766965772E636F6E74656E74444F4D2E65646974436F6E746578743D6E756C6C2C746869';
wwv_flow_imp.g_varchar2_table(45489) := '732E65646974436F6E746578742E64657374726F792829297D7D66756E6374696F6E206B4928652C742C6E297B666F72283B743B297B6C657420693D694C2E6765742874293B696628692626692E706172656E743D3D652972657475726E20693B6C6574';
wwv_flow_imp.g_varchar2_table(45490) := '206F3D742E706172656E744E6F64653B743D6F213D652E646F6D3F6F3A6E3E303F742E6E6578745369626C696E673A742E70726576696F75735369626C696E677D72657475726E206E756C6C7D66756E6374696F6E20454928652C74297B6C6574206E3D';
wwv_flow_imp.g_varchar2_table(45491) := '742E7374617274436F6E7461696E65722C693D742E73746172744F66667365742C6F3D742E656E64436F6E7461696E65722C733D742E656E644F66667365742C723D652E646F63566965772E646F6D4174506F7328652E73746174652E73656C65637469';
wwv_flow_imp.g_varchar2_table(45492) := '6F6E2E6D61696E2E616E63686F72293B72657475726E20464528722E6E6F64652C722E6F66667365742C6F2C73292626285B6E2C692C6F2C735D3D5B6F2C732C6E2C695D292C7B616E63686F724E6F64653A6E2C616E63686F724F66667365743A692C66';
wwv_flow_imp.g_varchar2_table(45493) := '6F6375734E6F64653A6F2C666F6375734F66667365743A737D7D636C617373204C497B636F6E7374727563746F722865297B746869732E66726F6D3D302C746869732E746F3D302C746869732E70656E64696E67436F6E746578744368616E67653D6E75';
wwv_flow_imp.g_varchar2_table(45494) := '6C6C2C746869732E68616E646C6572733D4F626A6563742E637265617465286E756C6C292C746869732E726573657452616E676528652E7374617465293B6C657420743D746869732E65646974436F6E746578743D6E65772077696E646F772E45646974';
wwv_flow_imp.g_varchar2_table(45495) := '436F6E74657874287B746578743A652E73746174652E646F632E736C696365537472696E6728746869732E66726F6D2C746869732E746F292C73656C656374696F6E53746172743A746869732E746F436F6E74657874506F73284D6174682E6D61782874';
wwv_flow_imp.g_varchar2_table(45496) := '6869732E66726F6D2C4D6174682E6D696E28746869732E746F2C652E73746174652E73656C656374696F6E2E6D61696E2E616E63686F722929292C73656C656374696F6E456E643A746869732E746F436F6E74657874506F7328652E73746174652E7365';
wwv_flow_imp.g_varchar2_table(45497) := '6C656374696F6E2E6D61696E2E68656164297D293B746869732E68616E646C6572732E746578747570646174653D743D3E7B6C65747B616E63686F723A6E7D3D652E73746174652E73656C656374696F6E2E6D61696E2C693D7B66726F6D3A746869732E';
wwv_flow_imp.g_varchar2_table(45498) := '746F456469746F72506F7328742E75706461746552616E67655374617274292C746F3A746869732E746F456469746F72506F7328742E75706461746552616E6765456E64292C696E736572743A46782E6F6628742E746578742E73706C697428225C6E22';
wwv_flow_imp.g_varchar2_table(45499) := '29297D3B692E66726F6D3D3D746869732E66726F6D26266E3C746869732E66726F6D3F692E66726F6D3D6E3A692E746F3D3D746869732E746F26266E3E746869732E746F262628692E746F3D6E292C28692E66726F6D213D692E746F7C7C692E696E7365';
wwv_flow_imp.g_varchar2_table(45500) := '72742E6C656E67746829262628746869732E70656E64696E67436F6E746578744368616E67653D692C652E73746174652E726561644F6E6C797C7C685428652C692C666B2E73696E676C6528746869732E746F456469746F72506F7328742E73656C6563';
wwv_flow_imp.g_varchar2_table(45501) := '74696F6E5374617274292C746869732E746F456469746F72506F7328742E73656C656374696F6E456E642929292C746869732E70656E64696E67436F6E746578744368616E6765262628746869732E72657665727450656E64696E6728652E7374617465';
wwv_flow_imp.g_varchar2_table(45502) := '292C746869732E73657453656C656374696F6E28652E73746174652929297D2C746869732E68616E646C6572732E636861726163746572626F756E64737570646174653D6E3D3E7B6C657420693D5B5D2C6F3D6E756C6C3B666F72286C657420743D7468';
wwv_flow_imp.g_varchar2_table(45503) := '69732E746F456469746F72506F73286E2E72616E67655374617274292C733D746869732E746F456469746F72506F73286E2E72616E6765456E64293B743C733B742B2B297B6C6574206E3D652E636F6F726473466F72436861722874293B6F3D6E26266E';
wwv_flow_imp.g_varchar2_table(45504) := '657720444F4D52656374286E2E6C6566742C6E2E746F702C6E2E72696768742D6E2E6C6566742C6E2E626F74746F6D2D6E2E746F70297C7C6F7C7C6E657720444F4D526563742C692E70757368286F297D742E757064617465436861726163746572426F';
wwv_flow_imp.g_varchar2_table(45505) := '756E6473286E2E72616E676553746172742C69297D2C746869732E68616E646C6572732E74657874666F726D61747570646174653D743D3E7B6C6574206E3D5B5D3B666F72286C65742065206F6620742E67657454657874466F726D6174732829297B6C';
wwv_flow_imp.g_varchar2_table(45506) := '657420743D652E756E6465726C696E655374796C652C693D652E756E6465726C696E65546869636B6E6573733B696628224E6F6E6522213D742626224E6F6E6522213D69297B6C6574206F3D60746578742D6465636F726174696F6E3A20756E6465726C';
wwv_flow_imp.g_varchar2_table(45507) := '696E6520247B22446173686564223D3D743F2264617368656420223A225371756967676C65223D3D743F227761767920223A22227D247B225468696E223D3D693F313A327D7078603B6E2E7075736828504C2E6D61726B287B617474726962757465733A';
wwv_flow_imp.g_varchar2_table(45508) := '7B7374796C653A6F7D7D292E72616E676528746869732E746F456469746F72506F7328652E72616E67655374617274292C746869732E746F456469746F72506F7328652E72616E6765456E642929297D7D652E6469737061746368287B65666665637473';
wwv_flow_imp.g_varchar2_table(45509) := '3A6B442E6F6628504C2E736574286E29297D297D2C746869732E68616E646C6572732E636F6D706F736974696F6E73746172743D28293D3E7B652E696E70757453746174652E636F6D706F73696E673C30262628652E696E70757453746174652E636F6D';
wwv_flow_imp.g_varchar2_table(45510) := '706F73696E673D302C652E696E70757453746174652E636F6D706F736974696F6E46697273744368616E67653D2130297D2C746869732E68616E646C6572732E636F6D706F736974696F6E656E643D28293D3E7B652E696E70757453746174652E636F6D';
wwv_flow_imp.g_varchar2_table(45511) := '706F73696E673D2D312C652E696E70757453746174652E636F6D706F736974696F6E46697273744368616E67653D6E756C6C7D3B666F72286C6574206520696E20746869732E68616E646C65727329742E6164644576656E744C697374656E657228652C';
wwv_flow_imp.g_varchar2_table(45512) := '746869732E68616E646C6572735B655D293B746869732E6D6561737572655265713D7B726561643A653D3E7B746869732E65646974436F6E746578742E757064617465436F6E74726F6C426F756E647328652E636F6E74656E74444F4D2E676574426F75';
wwv_flow_imp.g_varchar2_table(45513) := '6E64696E67436C69656E74526563742829293B6C657420743D4E4528652E726F6F74293B742626742E72616E6765436F756E742626746869732E65646974436F6E746578742E75706461746553656C656374696F6E426F756E647328742E67657452616E';
wwv_flow_imp.g_varchar2_table(45514) := '676541742830292E676574426F756E64696E67436C69656E74526563742829297D7D7D6170706C7945646974732865297B6C657420743D302C6E3D21312C693D746869732E70656E64696E67436F6E746578744368616E67653B72657475726E20652E63';
wwv_flow_imp.g_varchar2_table(45515) := '68616E6765732E697465724368616E6765732828286F2C732C722C612C6C293D3E7B6966286E2972657475726E3B6C657420633D6C2E6C656E6774682D28732D6F293B696628692626733E3D692E746F297B696628692E66726F6D3D3D6F2626692E746F';
wwv_flow_imp.g_varchar2_table(45516) := '3D3D732626692E696E736572742E6571286C292972657475726E20693D746869732E70656E64696E67436F6E746578744368616E67653D6E756C6C2C742B3D632C766F696428746869732E746F2B3D63293B693D6E756C6C2C746869732E726576657274';
wwv_flow_imp.g_varchar2_table(45517) := '50656E64696E6728652E7374617465297D6966286F2B3D742C28732B3D74293C3D746869732E66726F6D29746869732E66726F6D2B3D632C746869732E746F2B3D633B656C7365206966286F3C746869732E746F297B6966286F3C746869732E66726F6D';
wwv_flow_imp.g_varchar2_table(45518) := '7C7C733E746869732E746F7C7C746869732E746F2D746869732E66726F6D2B6C2E6C656E6774683E3365342972657475726E20766F6964286E3D2130293B746869732E65646974436F6E746578742E7570646174655465787428746869732E746F436F6E';
wwv_flow_imp.g_varchar2_table(45519) := '74657874506F73286F292C746869732E746F436F6E74657874506F732873292C6C2E746F537472696E672829292C746869732E746F2B3D637D742B3D637D29292C692626216E2626746869732E72657665727450656E64696E6728652E7374617465292C';
wwv_flow_imp.g_varchar2_table(45520) := '216E7D7570646174652865297B6C657420743D746869732E70656E64696E67436F6E746578744368616E67653B746869732E6170706C7945646974732865292626746869732E72616E6765497356616C696428652E7374617465293F28652E646F634368';
wwv_flow_imp.g_varchar2_table(45521) := '616E6765647C7C652E73656C656374696F6E5365747C7C74292626746869732E73657453656C656374696F6E28652E7374617465293A28746869732E70656E64696E67436F6E746578744368616E67653D6E756C6C2C746869732E726573657452616E67';
wwv_flow_imp.g_varchar2_table(45522) := '6528652E7374617465292C746869732E65646974436F6E746578742E7570646174655465787428302C746869732E65646974436F6E746578742E746578742E6C656E6774682C652E73746174652E646F632E736C696365537472696E6728746869732E66';
wwv_flow_imp.g_varchar2_table(45523) := '726F6D2C746869732E746F29292C746869732E73657453656C656374696F6E28652E737461746529292C28652E67656F6D657472794368616E6765647C7C652E646F634368616E6765647C7C652E73656C656374696F6E536574292626652E766965772E';
wwv_flow_imp.g_varchar2_table(45524) := '726571756573744D65617375726528746869732E6D656173757265526571297D726573657452616E67652865297B6C65747B686561643A747D3D652E73656C656374696F6E2E6D61696E3B746869732E66726F6D3D4D6174682E6D617828302C742D3165';
wwv_flow_imp.g_varchar2_table(45525) := '34292C746869732E746F3D4D6174682E6D696E28652E646F632E6C656E6774682C742B316534297D72657665727450656E64696E672865297B6C657420743D746869732E70656E64696E67436F6E746578744368616E67653B746869732E70656E64696E';
wwv_flow_imp.g_varchar2_table(45526) := '67436F6E746578744368616E67653D6E756C6C2C746869732E65646974436F6E746578742E7570646174655465787428746869732E746F436F6E74657874506F7328742E66726F6D292C746869732E746F436F6E74657874506F7328742E66726F6D2B74';
wwv_flow_imp.g_varchar2_table(45527) := '2E696E736572742E6C656E677468292C652E646F632E736C696365537472696E6728742E66726F6D2C742E746F29297D73657453656C656374696F6E2865297B6C65747B6D61696E3A747D3D652E73656C656374696F6E2C6E3D746869732E746F436F6E';
wwv_flow_imp.g_varchar2_table(45528) := '74657874506F73284D6174682E6D617828746869732E66726F6D2C4D6174682E6D696E28746869732E746F2C742E616E63686F722929292C693D746869732E746F436F6E74657874506F7328742E68656164293B746869732E65646974436F6E74657874';
wwv_flow_imp.g_varchar2_table(45529) := '2E73656C656374696F6E53746172743D3D6E2626746869732E65646974436F6E746578742E73656C656374696F6E456E643D3D697C7C746869732E65646974436F6E746578742E75706461746553656C656374696F6E286E2C69297D72616E6765497356';
wwv_flow_imp.g_varchar2_table(45530) := '616C69642865297B6C65747B686561643A747D3D652E73656C656374696F6E2E6D61696E3B72657475726E2128746869732E66726F6D3E302626742D746869732E66726F6D3C3530307C7C746869732E746F3C652E646F632E6C656E6774682626746869';
wwv_flow_imp.g_varchar2_table(45531) := '732E746F2D743C3530307C7C746869732E746F2D746869732E66726F6D3E336534297D746F456469746F72506F732865297B72657475726E20652B746869732E66726F6D7D746F436F6E74657874506F732865297B72657475726E20652D746869732E66';
wwv_flow_imp.g_varchar2_table(45532) := '726F6D7D64657374726F7928297B666F72286C6574206520696E20746869732E68616E646C65727329746869732E65646974436F6E746578742E72656D6F76654576656E744C697374656E657228652C746869732E68616E646C6572735B655D297D7D63';
wwv_flow_imp.g_varchar2_table(45533) := '6C6173732044497B67657420737461746528297B72657475726E20746869732E7669657753746174652E73746174657D6765742076696577706F727428297B72657475726E20746869732E7669657753746174652E76696577706F72747D676574207669';
wwv_flow_imp.g_varchar2_table(45534) := '7369626C6552616E67657328297B72657475726E20746869732E7669657753746174652E76697369626C6552616E6765737D67657420696E5669657728297B72657475726E20746869732E7669657753746174652E696E566965777D67657420636F6D70';
wwv_flow_imp.g_varchar2_table(45535) := '6F73696E6728297B72657475726E20746869732E696E70757453746174652E636F6D706F73696E673E307D67657420636F6D706F736974696F6E5374617274656428297B72657475726E20746869732E696E70757453746174652E636F6D706F73696E67';
wwv_flow_imp.g_varchar2_table(45536) := '3E3D307D67657420726F6F7428297B72657475726E20746869732E5F726F6F747D6765742077696E28297B72657475726E20746869732E646F6D2E6F776E6572446F63756D656E742E64656661756C74566965777C7C77696E646F777D636F6E73747275';
wwv_flow_imp.g_varchar2_table(45537) := '63746F7228653D7B7D297B76617220743B746869732E706C7567696E733D5B5D2C746869732E706C7567696E4D61703D6E6577204D61702C746869732E656469746F7241747472733D7B7D2C746869732E636F6E74656E7441747472733D7B7D2C746869';
wwv_flow_imp.g_varchar2_table(45538) := '732E6269646943616368653D5B5D2C746869732E64657374726F7965643D21312C746869732E75706461746553746174653D322C746869732E6D6561737572655363686564756C65643D2D312C746869732E6D65617375726552657175657374733D5B5D';
wwv_flow_imp.g_varchar2_table(45539) := '2C746869732E636F6E74656E74444F4D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E7363726F6C6C444F4D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E736372';
wwv_flow_imp.g_varchar2_table(45540) := '6F6C6C444F4D2E746162496E6465783D2D312C746869732E7363726F6C6C444F4D2E636C6173734E616D653D22636D2D7363726F6C6C6572222C746869732E7363726F6C6C444F4D2E617070656E644368696C6428746869732E636F6E74656E74444F4D';
wwv_flow_imp.g_varchar2_table(45541) := '292C746869732E616E6E6F756E6365444F4D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E616E6E6F756E6365444F4D2E636C6173734E616D653D22636D2D616E6E6F756E636564222C746869732E616E6E6F';
wwv_flow_imp.g_varchar2_table(45542) := '756E6365444F4D2E7365744174747269627574652822617269612D6C697665222C22706F6C69746522292C746869732E646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E617070656E64436869';
wwv_flow_imp.g_varchar2_table(45543) := '6C6428746869732E616E6E6F756E6365444F4D292C746869732E646F6D2E617070656E644368696C6428746869732E7363726F6C6C444F4D292C652E706172656E742626652E706172656E742E617070656E644368696C6428746869732E646F6D293B6C';
wwv_flow_imp.g_varchar2_table(45544) := '65747B64697370617463683A6E7D3D653B746869732E64697370617463685472616E73616374696F6E733D652E64697370617463685472616E73616374696F6E737C7C6E262628653D3E652E666F72456163682828653D3E6E28652C7468697329292929';
wwv_flow_imp.g_varchar2_table(45545) := '7C7C28653D3E746869732E757064617465286529292C746869732E64697370617463683D746869732E64697370617463682E62696E642874686973292C746869732E5F726F6F743D652E726F6F747C7C66756E6374696F6E2865297B666F72283B653B29';
wwv_flow_imp.g_varchar2_table(45546) := '7B69662865262628393D3D652E6E6F6465547970657C7C31313D3D652E6E6F6465547970652626652E686F7374292972657475726E20653B653D652E61737369676E6564536C6F747C7C652E706172656E744E6F64657D72657475726E206E756C6C7D28';
wwv_flow_imp.g_varchar2_table(45547) := '652E706172656E74297C7C646F63756D656E742C746869732E7669657753746174653D6E657720614928652E73746174657C7C6E452E637265617465286529292C652E7363726F6C6C546F2626652E7363726F6C6C546F2E697328784429262628746869';
wwv_flow_imp.g_varchar2_table(45548) := '732E7669657753746174652E7363726F6C6C5461726765743D652E7363726F6C6C546F2E76616C75652E636C697028746869732E7669657753746174652E737461746529292C746869732E706C7567696E733D746869732E73746174652E666163657428';
wwv_flow_imp.g_varchar2_table(45549) := '5444292E6D61702828653D3E6E6577204D4428652929293B666F72286C65742065206F6620746869732E706C7567696E7329652E7570646174652874686973293B746869732E6F627365727665723D6E65772078492874686973292C746869732E696E70';
wwv_flow_imp.g_varchar2_table(45550) := '757453746174653D6E65772075542874686973292C746869732E696E70757453746174652E656E7375726548616E646C65727328746869732E706C7567696E73292C746869732E646F63566965773D6E65772071442874686973292C746869732E6D6F75';
wwv_flow_imp.g_varchar2_table(45551) := '6E745374796C657328292C746869732E757064617465417474727328292C746869732E75706461746553746174653D302C746869732E726571756573744D65617375726528292C286E756C6C3D3D3D28743D646F63756D656E742E666F6E7473297C7C76';
wwv_flow_imp.g_varchar2_table(45552) := '6F696420303D3D3D743F766F696420303A742E7265616479292626646F63756D656E742E666F6E74732E72656164792E7468656E282828293D3E746869732E726571756573744D656173757265282929297D6469737061746368282E2E2E65297B6C6574';
wwv_flow_imp.g_varchar2_table(45553) := '20743D313D3D652E6C656E6774682626655B305D696E7374616E63656F6620556B3F653A313D3D652E6C656E677468262641727261792E6973417272617928655B305D293F655B305D3A5B746869732E73746174652E757064617465282E2E2E65295D3B';
wwv_flow_imp.g_varchar2_table(45554) := '746869732E64697370617463685472616E73616374696F6E7328742C74686973297D7570646174652865297B69662830213D746869732E7570646174655374617465297468726F77206E6577204572726F72282243616C6C7320746F20456469746F7256';
wwv_flow_imp.g_varchar2_table(45555) := '6965772E75706461746520617265206E6F7420616C6C6F776564207768696C6520616E2075706461746520697320696E2070726F677265737322293B6C657420742C6E3D21312C693D21312C6F3D746869732E73746174653B666F72286C65742074206F';
wwv_flow_imp.g_varchar2_table(45556) := '662065297B696628742E73746172745374617465213D6F297468726F77206E65772052616E67654572726F722822547279696E6720746F2075706461746520737461746520776974682061207472616E73616374696F6E207468617420646F65736E2774';
wwv_flow_imp.g_varchar2_table(45557) := '2073746172742066726F6D207468652070726576696F75732073746174652E22293B6F3D742E73746174657D696628746869732E64657374726F7965642972657475726E20766F696428746869732E7669657753746174652E73746174653D6F293B6C65';
wwv_flow_imp.g_varchar2_table(45558) := '7420733D746869732E686173466F6375732C723D302C613D6E756C6C3B652E736F6D652828653D3E652E616E6E6F746174696F6E2852542929293F28746869732E696E70757453746174652E6E6F746966696564466F63757365643D732C723D31293A73';
wwv_flow_imp.g_varchar2_table(45559) := '213D746869732E696E70757453746174652E6E6F746966696564466F6375736564262628746869732E696E70757453746174652E6E6F746966696564466F63757365643D732C613D4654286F2C73292C617C7C28723D3129293B6C6574206C3D74686973';
wwv_flow_imp.g_varchar2_table(45560) := '2E6F627365727665722E64656C61796564416E64726F69644B65792C633D6E756C6C3B6966286C3F28746869732E6F627365727665722E636C65617244656C61796564416E64726F69644B657928292C633D746869732E6F627365727665722E72656164';
wwv_flow_imp.g_varchar2_table(45561) := '4368616E676528292C2863262621746869732E73746174652E646F632E6571286F2E646F63297C7C21746869732E73746174652E73656C656374696F6E2E6571286F2E73656C656374696F6E2929262628633D6E756C6C29293A746869732E6F62736572';
wwv_flow_imp.g_varchar2_table(45562) := '7665722E636C65617228292C6F2E6661636574286E452E7068726173657329213D746869732E73746174652E6661636574286E452E70687261736573292972657475726E20746869732E7365745374617465286F293B743D6A442E637265617465287468';
wwv_flow_imp.g_varchar2_table(45563) := '69732C6F2C65292C742E666C6167737C3D723B6C657420643D746869732E7669657753746174652E7363726F6C6C5461726765743B7472797B746869732E75706461746553746174653D323B666F72286C65742074206F662065297B6966286426262864';
wwv_flow_imp.g_varchar2_table(45564) := '3D642E6D617028742E6368616E67657329292C742E7363726F6C6C496E746F56696577297B6C65747B6D61696E3A657D3D742E73746174652E73656C656374696F6E3B643D6E657720534428652E656D7074793F653A666B2E637572736F7228652E6865';
wwv_flow_imp.g_varchar2_table(45565) := '61642C652E686561643E652E616E63686F723F2D313A3129297D666F72286C65742065206F6620742E6566666563747329652E697328784429262628643D652E76616C75652E636C697028746869732E737461746529297D746869732E76696577537461';
wwv_flow_imp.g_varchar2_table(45566) := '74652E75706461746528742C64292C746869732E6269646943616368653D4D492E75706461746528746869732E6269646943616368652C742E6368616E676573292C742E656D7074797C7C28746869732E757064617465506C7567696E732874292C7468';
wwv_flow_imp.g_varchar2_table(45567) := '69732E696E70757453746174652E757064617465287429292C6E3D746869732E646F63566965772E7570646174652874292C746869732E73746174652E666163657428484429213D746869732E7374796C654D6F64756C65732626746869732E6D6F756E';
wwv_flow_imp.g_varchar2_table(45568) := '745374796C657328292C693D746869732E757064617465417474727328292C746869732E73686F77416E6E6F756E63656D656E74732865292C746869732E646F63566965772E75706461746553656C656374696F6E286E2C652E736F6D652828653D3E65';
wwv_flow_imp.g_varchar2_table(45569) := '2E6973557365724576656E74282273656C6563742E706F696E74657222292929297D66696E616C6C797B746869732E75706461746553746174653D307D696628742E737461727453746174652E666163657428674929213D742E73746174652E66616365';
wwv_flow_imp.g_varchar2_table(45570) := '7428674929262628746869732E7669657753746174652E6D7573744D656173757265436F6E74656E743D2130292C286E7C7C697C7C647C7C746869732E7669657753746174652E6D757374456E666F726365437572736F724173736F637C7C746869732E';
wwv_flow_imp.g_varchar2_table(45571) := '7669657753746174652E6D7573744D656173757265436F6E74656E74292626746869732E726571756573744D65617375726528292C6E2626746869732E646F635669657755706461746528292C21742E656D70747929666F72286C65742065206F662074';
wwv_flow_imp.g_varchar2_table(45572) := '6869732E73746174652E6661636574286D4429297472797B652874297D63617463682865297B454428746869732E73746174652C652C22757064617465206C697374656E657222297D28617C7C6329262650726F6D6973652E7265736F6C766528292E74';
wwv_flow_imp.g_varchar2_table(45573) := '68656E282828293D3E7B612626746869732E73746174653D3D612E737461727453746174652626746869732E64697370617463682861292C63262621645428746869732C632926266C2E666F7263652626594528746869732E636F6E74656E74444F4D2C';
wwv_flow_imp.g_varchar2_table(45574) := '6C2E6B65792C6C2E6B6579436F6465297D29297D73657453746174652865297B69662830213D746869732E7570646174655374617465297468726F77206E6577204572726F72282243616C6C7320746F20456469746F72566965772E7365745374617465';
wwv_flow_imp.g_varchar2_table(45575) := '20617265206E6F7420616C6C6F776564207768696C6520616E2075706461746520697320696E2070726F677265737322293B696628746869732E64657374726F7965642972657475726E20766F696428746869732E7669657753746174652E7374617465';
wwv_flow_imp.g_varchar2_table(45576) := '3D65293B746869732E75706461746553746174653D323B6C657420743D746869732E686173466F6375733B7472797B666F72286C65742065206F6620746869732E706C7567696E7329652E64657374726F792874686973293B746869732E766965775374';
wwv_flow_imp.g_varchar2_table(45577) := '6174653D6E65772061492865292C746869732E706C7567696E733D652E6661636574285444292E6D61702828653D3E6E6577204D4428652929292C746869732E706C7567696E4D61702E636C65617228293B666F72286C65742065206F6620746869732E';
wwv_flow_imp.g_varchar2_table(45578) := '706C7567696E7329652E7570646174652874686973293B746869732E646F63566965772E64657374726F7928292C746869732E646F63566965773D6E65772071442874686973292C746869732E696E70757453746174652E656E7375726548616E646C65';
wwv_flow_imp.g_varchar2_table(45579) := '727328746869732E706C7567696E73292C746869732E6D6F756E745374796C657328292C746869732E757064617465417474727328292C746869732E6269646943616368653D5B5D7D66696E616C6C797B746869732E75706461746553746174653D307D';
wwv_flow_imp.g_varchar2_table(45580) := '742626746869732E666F63757328292C746869732E726571756573744D65617375726528297D757064617465506C7567696E732865297B6C657420743D652E737461727453746174652E6661636574285444292C6E3D652E73746174652E666163657428';
wwv_flow_imp.g_varchar2_table(45581) := '5444293B69662874213D6E297B6C657420693D5B5D3B666F72286C6574206F206F66206E297B6C6574206E3D742E696E6465784F66286F293B6966286E3C3029692E70757368286E6577204D44286F29293B656C73657B6C657420743D746869732E706C';
wwv_flow_imp.g_varchar2_table(45582) := '7567696E735B6E5D3B742E6D7573745570646174653D652C692E707573682874297D7D666F72286C65742074206F6620746869732E706C7567696E7329742E6D757374557064617465213D652626742E64657374726F792874686973293B746869732E70';
wwv_flow_imp.g_varchar2_table(45583) := '6C7567696E733D692C746869732E706C7567696E4D61702E636C65617228297D656C736520666F72286C65742074206F6620746869732E706C7567696E7329742E6D7573745570646174653D653B666F72286C657420653D303B653C746869732E706C75';
wwv_flow_imp.g_varchar2_table(45584) := '67696E732E6C656E6774683B652B2B29746869732E706C7567696E735B655D2E7570646174652874686973293B74213D6E2626746869732E696E70757453746174652E656E7375726548616E646C65727328746869732E706C7567696E73297D646F6356';
wwv_flow_imp.g_varchar2_table(45585) := '69657755706461746528297B666F72286C65742065206F6620746869732E706C7567696E73297B6C657420743D652E76616C75653B696628742626742E646F6356696577557064617465297472797B742E646F6356696577557064617465287468697329';
wwv_flow_imp.g_varchar2_table(45586) := '7D63617463682865297B454428746869732E73746174652C652C22646F63207669657720757064617465206C697374656E657222297D7D7D6D65617375726528653D2130297B696628746869732E64657374726F7965642972657475726E3B6966287468';
wwv_flow_imp.g_varchar2_table(45587) := '69732E6D6561737572655363686564756C65643E2D312626746869732E77696E2E63616E63656C416E696D6174696F6E4672616D6528746869732E6D6561737572655363686564756C6564292C746869732E6F627365727665722E64656C61796564416E';
wwv_flow_imp.g_varchar2_table(45588) := '64726F69644B65792972657475726E20746869732E6D6561737572655363686564756C65643D2D312C766F696420746869732E726571756573744D65617375726528293B746869732E6D6561737572655363686564756C65643D302C652626746869732E';
wwv_flow_imp.g_varchar2_table(45589) := '6F627365727665722E666F726365466C75736828293B6C657420743D6E756C6C2C6E3D746869732E7363726F6C6C444F4D2C693D6E2E7363726F6C6C546F702A746869732E7363616C65592C7B7363726F6C6C416E63686F72506F733A6F2C7363726F6C';
wwv_flow_imp.g_varchar2_table(45590) := '6C416E63686F724865696768743A737D3D746869732E7669657753746174653B4D6174682E61627328692D746869732E7669657753746174652E7363726F6C6C546F70293E31262628733D2D31292C746869732E7669657753746174652E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(45591) := '416E63686F724865696768743D2D313B7472797B666F72286C657420653D303B3B652B2B297B696628733C30296966285845286E29296F3D2D312C733D746869732E7669657753746174652E6865696768744D61702E6865696768743B656C73657B6C65';
wwv_flow_imp.g_varchar2_table(45592) := '7420653D746869732E7669657753746174652E7363726F6C6C416E63686F7241742869293B6F3D652E66726F6D2C733D652E746F707D746869732E75706461746553746174653D313B6C657420723D746869732E7669657753746174652E6D6561737572';
wwv_flow_imp.g_varchar2_table(45593) := '652874686973293B6966282172262621746869732E6D65617375726552657175657374732E6C656E67746826266E756C6C3D3D746869732E7669657753746174652E7363726F6C6C54617267657429627265616B3B696628653E35297B636F6E736F6C65';
wwv_flow_imp.g_varchar2_table(45594) := '2E7761726E28746869732E6D65617375726552657175657374732E6C656E6774683F224D656173757265206C6F6F7020726573746172746564206D6F7265207468616E20352074696D6573223A2256696577706F7274206661696C656420746F20737461';
wwv_flow_imp.g_varchar2_table(45595) := '62696C697A6522293B627265616B7D6C657420613D5B5D3B3426727C7C285B746869732E6D65617375726552657175657374732C615D3D5B612C746869732E6D65617375726552657175657374735D293B6C6574206C3D612E6D61702828653D3E7B7472';
wwv_flow_imp.g_varchar2_table(45596) := '797B72657475726E20652E726561642874686973297D63617463682865297B72657475726E20454428746869732E73746174652C65292C49497D7D29292C633D6A442E63726561746528746869732C746869732E73746174652C5B5D292C643D21313B63';
wwv_flow_imp.g_varchar2_table(45597) := '2E666C6167737C3D722C743F742E666C6167737C3D723A743D632C746869732E75706461746553746174653D322C632E656D7074797C7C28746869732E757064617465506C7567696E732863292C746869732E696E70757453746174652E757064617465';
wwv_flow_imp.g_varchar2_table(45598) := '2863292C746869732E757064617465417474727328292C643D746869732E646F63566965772E7570646174652863292C642626746869732E646F63566965775570646174652829293B666F72286C657420653D303B653C612E6C656E6774683B652B2B29';
wwv_flow_imp.g_varchar2_table(45599) := '6966286C5B655D213D4949297472797B6C657420743D615B655D3B742E77726974652626742E7772697465286C5B655D2C74686973297D63617463682865297B454428746869732E73746174652C65297D696628642626746869732E646F63566965772E';
wwv_flow_imp.g_varchar2_table(45600) := '75706461746553656C656374696F6E282130292C21632E76696577706F72744368616E6765642626303D3D746869732E6D65617375726552657175657374732E6C656E677468297B696628746869732E7669657753746174652E656469746F7248656967';
wwv_flow_imp.g_varchar2_table(45601) := '6874297B696628746869732E7669657753746174652E7363726F6C6C546172676574297B746869732E646F63566965772E7363726F6C6C496E746F5669657728746869732E7669657753746174652E7363726F6C6C546172676574292C746869732E7669';
wwv_flow_imp.g_varchar2_table(45602) := '657753746174652E7363726F6C6C5461726765743D6E756C6C2C733D2D313B636F6E74696E75657D7B6C657420653D286F3C303F746869732E7669657753746174652E6865696768744D61702E6865696768743A746869732E7669657753746174652E6C';
wwv_flow_imp.g_varchar2_table(45603) := '696E65426C6F636B4174286F292E746F70292D733B696628653E317C7C653C2D31297B692B3D652C6E2E7363726F6C6C546F703D692F746869732E7363616C65592C733D2D313B636F6E74696E75657D7D7D627265616B7D7D7D66696E616C6C797B7468';
wwv_flow_imp.g_varchar2_table(45604) := '69732E75706461746553746174653D302C746869732E6D6561737572655363686564756C65643D2D317D69662874262621742E656D70747929666F72286C65742065206F6620746869732E73746174652E6661636574286D442929652874297D67657420';
wwv_flow_imp.g_varchar2_table(45605) := '7468656D65436C617373657328297B72657475726E2066492B2220222B28746869732E73746174652E6661636574286D49293F62493A7649292B2220222B746869732E73746174652E6661636574286749297D757064617465417474727328297B6C6574';
wwv_flow_imp.g_varchar2_table(45606) := '20653D414928746869732C41442C7B636C6173733A22636D2D656469746F72222B28746869732E686173466F6375733F2220636D2D666F637573656420223A222022292B746869732E7468656D65436C61737365737D292C743D7B7370656C6C63686563';
wwv_flow_imp.g_varchar2_table(45607) := '6B3A2266616C7365222C6175746F636F72726563743A226F6666222C6175746F6361706974616C697A653A226F6666222C7472616E736C6174653A226E6F222C636F6E74656E746564697461626C653A746869732E73746174652E6661636574284C4429';
wwv_flow_imp.g_varchar2_table(45608) := '3F2274727565223A2266616C7365222C636C6173733A22636D2D636F6E74656E74222C7374796C653A60247B5F4C2E74616253697A657D3A20247B746869732E73746174652E74616253697A657D602C726F6C653A2274657874626F78222C2261726961';
wwv_flow_imp.g_varchar2_table(45609) := '2D6D756C74696C696E65223A2274727565227D3B746869732E73746174652E726561644F6E6C79262628745B22617269612D726561646F6E6C79225D3D227472756522292C414928746869732C4E442C74293B6C6574206E3D746869732E6F6273657276';
wwv_flow_imp.g_varchar2_table(45610) := '65722E69676E6F7265282828293D3E7B6C6574206E3D494C28746869732E636F6E74656E74444F4D2C746869732E636F6E74656E7441747472732C74292C693D494C28746869732E646F6D2C746869732E656469746F7241747472732C65293B72657475';
wwv_flow_imp.g_varchar2_table(45611) := '726E206E7C7C697D29293B72657475726E20746869732E656469746F7241747472733D652C746869732E636F6E74656E7441747472733D742C6E7D73686F77416E6E6F756E63656D656E74732865297B6C657420743D21303B666F72286C6574206E206F';
wwv_flow_imp.g_varchar2_table(45612) := '66206529666F72286C65742065206F66206E2E6566666563747329652E69732844492E616E6E6F756E63652926262874262628746869732E616E6E6F756E6365444F4D2E74657874436F6E74656E743D2222292C743D21312C746869732E616E6E6F756E';
wwv_flow_imp.g_varchar2_table(45613) := '6365444F4D2E617070656E644368696C6428646F63756D656E742E637265617465456C656D656E7428226469762229292E74657874436F6E74656E743D652E76616C7565297D6D6F756E745374796C657328297B746869732E7374796C654D6F64756C65';
wwv_flow_imp.g_varchar2_table(45614) := '733D746869732E73746174652E6661636574284844293B6C657420653D746869732E73746174652E66616365742844492E6373704E6F6E6365293B78452E6D6F756E7428746869732E726F6F742C746869732E7374796C654D6F64756C65732E636F6E63';
wwv_flow_imp.g_varchar2_table(45615) := '6174287749292E7265766572736528292C653F7B6E6F6E63653A657D3A766F69642030297D726561644D6561737572656428297B696628323D3D746869732E7570646174655374617465297468726F77206E6577204572726F72282252656164696E6720';
wwv_flow_imp.g_varchar2_table(45616) := '74686520656469746F72206C61796F75742069736E277420616C6C6F77656420647572696E6720616E2075706461746522293B303D3D746869732E75706461746553746174652626746869732E6D6561737572655363686564756C65643E2D3126267468';
wwv_flow_imp.g_varchar2_table(45617) := '69732E6D656173757265282131297D726571756573744D6561737572652865297B696628746869732E6D6561737572655363686564756C65643C30262628746869732E6D6561737572655363686564756C65643D746869732E77696E2E72657175657374';
wwv_flow_imp.g_varchar2_table(45618) := '416E696D6174696F6E4672616D65282828293D3E746869732E6D65617375726528292929292C65297B696628746869732E6D65617375726552657175657374732E696E6465784F662865293E2D312972657475726E3B6966286E756C6C213D652E6B6579';
wwv_flow_imp.g_varchar2_table(45619) := '29666F72286C657420743D303B743C746869732E6D65617375726552657175657374732E6C656E6774683B742B2B29696628746869732E6D65617375726552657175657374735B745D2E6B65793D3D3D652E6B65792972657475726E20766F6964287468';
wwv_flow_imp.g_varchar2_table(45620) := '69732E6D65617375726552657175657374735B745D3D65293B746869732E6D65617375726552657175657374732E707573682865297D7D706C7567696E2865297B6C657420743D746869732E706C7567696E4D61702E6765742865293B72657475726E28';
wwv_flow_imp.g_varchar2_table(45621) := '766F696420303D3D3D747C7C742626742E73706563213D65292626746869732E706C7567696E4D61702E73657428652C743D746869732E706C7567696E732E66696E642828743D3E742E737065633D3D6529297C7C6E756C6C292C742626742E75706461';
wwv_flow_imp.g_varchar2_table(45622) := '74652874686973292E76616C75657D67657420646F63756D656E74546F7028297B72657475726E20746869732E636F6E74656E74444F4D2E676574426F756E64696E67436C69656E745265637428292E746F702B746869732E7669657753746174652E70';
wwv_flow_imp.g_varchar2_table(45623) := '616464696E67546F707D67657420646F63756D656E7450616464696E6728297B72657475726E7B746F703A746869732E7669657753746174652E70616464696E67546F702C626F74746F6D3A746869732E7669657753746174652E70616464696E67426F';
wwv_flow_imp.g_varchar2_table(45624) := '74746F6D7D7D676574207363616C655828297B72657475726E20746869732E7669657753746174652E7363616C65587D676574207363616C655928297B72657475726E20746869732E7669657753746174652E7363616C65597D656C656D656E74417448';
wwv_flow_imp.g_varchar2_table(45625) := '65696768742865297B72657475726E20746869732E726561644D6561737572656428292C746869732E7669657753746174652E656C656D656E7441744865696768742865297D6C696E65426C6F636B41744865696768742865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(45626) := '69732E726561644D6561737572656428292C746869732E7669657753746174652E6C696E65426C6F636B41744865696768742865297D6765742076696577706F72744C696E65426C6F636B7328297B72657475726E20746869732E766965775374617465';
wwv_flow_imp.g_varchar2_table(45627) := '2E76696577706F72744C696E65737D6C696E65426C6F636B41742865297B72657475726E20746869732E7669657753746174652E6C696E65426C6F636B41742865297D67657420636F6E74656E7448656967687428297B72657475726E20746869732E76';
wwv_flow_imp.g_varchar2_table(45628) := '69657753746174652E636F6E74656E744865696768747D6D6F766542794368617228652C742C6E297B72657475726E206F5428746869732C652C6E5428746869732C652C742C6E29297D6D6F7665427947726F757028652C74297B72657475726E206F54';
wwv_flow_imp.g_varchar2_table(45629) := '28746869732C652C6E5428746869732C652C742C28743D3E66756E6374696F6E28652C742C6E297B6C657420693D652E73746174652E6368617243617465676F72697A65722874292C6F3D69286E293B72657475726E20653D3E7B6C657420743D692865';
wwv_flow_imp.g_varchar2_table(45630) := '293B72657475726E206F3D3D4A6B2E53706163652626286F3D74292C6F3D3D747D7D28746869732C652E686561642C74292929297D76697375616C4C696E655369646528652C74297B6C6574206E3D746869732E626964695370616E732865292C693D74';
wwv_flow_imp.g_varchar2_table(45631) := '6869732E74657874446972656374696F6E417428652E66726F6D292C6F3D6E5B743F6E2E6C656E6774682D313A305D3B72657475726E20666B2E637572736F72286F2E7369646528742C69292B652E66726F6D2C6F2E666F72776172642821742C69293F';
wwv_flow_imp.g_varchar2_table(45632) := '313A2D31297D6D6F7665546F4C696E65426F756E6461727928652C742C6E3D2130297B72657475726E2066756E6374696F6E28652C742C6E2C69297B6C6574206F3D66756E6374696F6E28652C74297B6C6574206E3D652E6C696E65426C6F636B417428';
wwv_flow_imp.g_varchar2_table(45633) := '74293B69662841727261792E69734172726179286E2E747970652929666F72286C65742065206F66206E2E7479706529696628652E746F3E747C7C652E746F3D3D74262628652E746F3D3D6E2E746F7C7C652E747970653D3D4E4C2E5465787429297265';
wwv_flow_imp.g_varchar2_table(45634) := '7475726E20653B72657475726E206E7D28652C742E68656164292C733D6926266F2E747970653D3D4E4C2E54657874262628652E6C696E655772617070696E677C7C6F2E7769646765744C696E65427265616B73293F652E636F6F7264734174506F7328';
wwv_flow_imp.g_varchar2_table(45635) := '742E6173736F633C302626742E686561643E6F2E66726F6D3F742E686561642D313A742E68656164293A6E756C6C3B69662873297B6C657420743D652E646F6D2E676574426F756E64696E67436C69656E745265637428292C693D652E74657874446972';
wwv_flow_imp.g_varchar2_table(45636) := '656374696F6E4174286F2E66726F6D292C723D652E706F734174436F6F726473287B783A6E3D3D28693D3D554C2E4C5452293F742E72696768742D313A742E6C6566742B312C793A28732E746F702B732E626F74746F6D292F327D293B6966286E756C6C';
wwv_flow_imp.g_varchar2_table(45637) := '213D722972657475726E20666B2E637572736F7228722C6E3F2D313A31297D72657475726E20666B2E637572736F72286E3F6F2E746F3A6F2E66726F6D2C6E3F2D313A31297D28746869732C652C742C6E297D6D6F7665566572746963616C6C7928652C';
wwv_flow_imp.g_varchar2_table(45638) := '742C6E297B72657475726E206F5428746869732C652C66756E6374696F6E28652C742C6E2C69297B6C6574206F3D742E686561642C733D6E3F313A2D313B6966286F3D3D286E3F652E73746174652E646F632E6C656E6774683A30292972657475726E20';
wwv_flow_imp.g_varchar2_table(45639) := '666B2E637572736F72286F2C742E6173736F63293B6C657420722C613D742E676F616C436F6C756D6E2C6C3D652E636F6E74656E74444F4D2E676574426F756E64696E67436C69656E745265637428292C633D652E636F6F7264734174506F73286F2C74';
wwv_flow_imp.g_varchar2_table(45640) := '2E6173736F637C7C2D31292C643D652E646F63756D656E74546F703B69662863296E756C6C3D3D61262628613D632E6C6566742D6C2E6C656674292C723D733C303F632E746F703A632E626F74746F6D3B656C73657B6C657420743D652E766965775374';
wwv_flow_imp.g_varchar2_table(45641) := '6174652E6C696E65426C6F636B4174286F293B6E756C6C3D3D61262628613D4D6174682E6D696E286C2E72696768742D6C2E6C6566742C652E64656661756C7443686172616374657257696474682A286F2D742E66726F6D2929292C723D28733C303F74';
wwv_flow_imp.g_varchar2_table(45642) := '2E746F703A742E626F74746F6D292B647D6C657420683D6C2E6C6566742B612C753D6E756C6C213D693F693A652E7669657753746174652E6865696768744F7261636C652E746578744865696768743E3E313B666F72286C657420743D303B3B742B3D31';
wwv_flow_imp.g_varchar2_table(45643) := '30297B6C6574206E3D722B28752B74292A732C693D655428652C7B783A682C793A6E7D2C21312C73293B6966286E3C6C2E746F707C7C6E3E6C2E626F74746F6D7C7C28733C303F693C6F3A693E6F29297B6C657420743D652E646F63566965772E636F6F';
wwv_flow_imp.g_varchar2_table(45644) := '726473466F72436861722869292C6F3D21747C7C6E3C742E746F703F2D313A313B72657475726E20666B2E637572736F7228692C6F2C766F696420302C61297D7D7D28746869732C652C742C6E29297D646F6D4174506F732865297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(45645) := '6869732E646F63566965772E646F6D4174506F732865297D706F734174444F4D28652C743D30297B72657475726E20746869732E646F63566965772E706F7346726F6D444F4D28652C74297D706F734174436F6F72647328652C743D2130297B72657475';
wwv_flow_imp.g_varchar2_table(45646) := '726E20746869732E726561644D6561737572656428292C655428746869732C652C74297D636F6F7264734174506F7328652C743D31297B746869732E726561644D6561737572656428293B6C6574206E3D746869732E646F63566965772E636F6F726473';
wwv_flow_imp.g_varchar2_table(45647) := '417428652C74293B696628216E7C7C6E2E6C6566743D3D6E2E72696768742972657475726E206E3B6C657420693D746869732E73746174652E646F632E6C696E6541742865292C6F3D746869732E626964695370616E732869293B72657475726E205745';
wwv_flow_imp.g_varchar2_table(45648) := '286E2C6F5B6E442E66696E64286F2C652D692E66726F6D2C2D312C74295D2E6469723D3D554C2E4C54523D3D743E30297D636F6F726473466F72436861722865297B72657475726E20746869732E726561644D6561737572656428292C746869732E646F';
wwv_flow_imp.g_varchar2_table(45649) := '63566965772E636F6F726473466F72436861722865297D6765742064656661756C74436861726163746572576964746828297B72657475726E20746869732E7669657753746174652E6865696768744F7261636C652E6368617257696474687D67657420';
wwv_flow_imp.g_varchar2_table(45650) := '64656661756C744C696E6548656967687428297B72657475726E20746869732E7669657753746174652E6865696768744F7261636C652E6C696E654865696768747D6765742074657874446972656374696F6E28297B72657475726E20746869732E7669';
wwv_flow_imp.g_varchar2_table(45651) := '657753746174652E64656661756C7454657874446972656374696F6E7D74657874446972656374696F6E41742865297B72657475726E21746869732E73746174652E6661636574287944297C7C653C746869732E76696577706F72742E66726F6D7C7C65';
wwv_flow_imp.g_varchar2_table(45652) := '3E746869732E76696577706F72742E746F3F746869732E74657874446972656374696F6E3A28746869732E726561644D6561737572656428292C746869732E646F63566965772E74657874446972656374696F6E4174286529297D676574206C696E6557';
wwv_flow_imp.g_varchar2_table(45653) := '72617070696E6728297B72657475726E20746869732E7669657753746174652E6865696768744F7261636C652E6C696E655772617070696E677D626964695370616E732865297B696628652E6C656E6774683E54492972657475726E20614428652E6C65';
wwv_flow_imp.g_varchar2_table(45654) := '6E677468293B6C657420742C6E3D746869732E74657874446972656374696F6E417428652E66726F6D293B666F72286C65742069206F6620746869732E62696469436163686529696628692E66726F6D3D3D652E66726F6D2626692E6469723D3D6E2626';
wwv_flow_imp.g_varchar2_table(45655) := '28692E66726573687C7C694428692E69736F6C617465732C743D424428746869732C652929292972657475726E20692E6F726465723B747C7C28743D424428746869732C6529293B6C657420693D66756E6374696F6E28652C742C6E297B696628216529';
wwv_flow_imp.g_varchar2_table(45656) := '72657475726E5B6E6577206E4428302C302C743D3D474C3F313A30295D3B696628743D3D4B4C2626216E2E6C656E67746826262174442E746573742865292972657475726E20614428652E6C656E677468293B6966286E2E6C656E67746829666F72283B';
wwv_flow_imp.g_varchar2_table(45657) := '652E6C656E6774683E6F442E6C656E6774683B296F445B6F442E6C656E6774685D3D3235363B6C657420693D5B5D2C6F3D743D3D4B4C3F303A313B72657475726E20724428652C6F2C6F2C6E2C302C652E6C656E6774682C69292C697D28652E74657874';
wwv_flow_imp.g_varchar2_table(45658) := '2C6E2C74293B72657475726E20746869732E6269646943616368652E70757368286E6577204D4928652E66726F6D2C652E746F2C6E2C742C21302C6929292C697D67657420686173466F63757328297B76617220653B72657475726E28746869732E646F';
wwv_flow_imp.g_varchar2_table(45659) := '6D2E6F776E6572446F63756D656E742E686173466F63757328297C7C5F4C2E7361666172692626286E756C6C3D3D3D28653D746869732E696E7075745374617465297C7C766F696420303D3D3D653F766F696420303A652E6C617374436F6E746578744D';
wwv_flow_imp.g_varchar2_table(45660) := '656E75293E446174652E6E6F7728292D336534292626746869732E726F6F742E616374697665456C656D656E743D3D746869732E636F6E74656E74444F4D7D666F63757328297B746869732E6F627365727665722E69676E6F7265282828293D3E7B4745';
wwv_flow_imp.g_varchar2_table(45661) := '28746869732E636F6E74656E74444F4D292C746869732E646F63566965772E75706461746553656C656374696F6E28297D29297D736574526F6F742865297B746869732E5F726F6F74213D65262628746869732E5F726F6F743D652C746869732E6F6273';
wwv_flow_imp.g_varchar2_table(45662) := '65727665722E73657457696E646F772828393D3D652E6E6F6465547970653F653A652E6F776E6572446F63756D656E74292E64656661756C74566965777C7C77696E646F77292C746869732E6D6F756E745374796C65732829297D64657374726F792829';
wwv_flow_imp.g_varchar2_table(45663) := '7B746869732E726F6F742E616374697665456C656D656E743D3D746869732E636F6E74656E74444F4D2626746869732E636F6E74656E74444F4D2E626C757228293B666F72286C65742065206F6620746869732E706C7567696E7329652E64657374726F';
wwv_flow_imp.g_varchar2_table(45664) := '792874686973293B746869732E706C7567696E733D5B5D2C746869732E696E70757453746174652E64657374726F7928292C746869732E646F63566965772E64657374726F7928292C746869732E646F6D2E72656D6F766528292C746869732E6F627365';
wwv_flow_imp.g_varchar2_table(45665) := '727665722E64657374726F7928292C746869732E6D6561737572655363686564756C65643E2D312626746869732E77696E2E63616E63656C416E696D6174696F6E4672616D6528746869732E6D6561737572655363686564756C6564292C746869732E64';
wwv_flow_imp.g_varchar2_table(45666) := '657374726F7965643D21307D737461746963207363726F6C6C496E746F5669657728652C743D7B7D297B72657475726E2078442E6F66286E657720534428226E756D626572223D3D747970656F6620653F666B2E637572736F722865293A652C742E792C';
wwv_flow_imp.g_varchar2_table(45667) := '742E782C742E794D617267696E2C742E784D617267696E29297D7363726F6C6C536E617073686F7428297B6C65747B7363726F6C6C546F703A652C7363726F6C6C4C6566743A747D3D746869732E7363726F6C6C444F4D2C6E3D746869732E7669657753';
wwv_flow_imp.g_varchar2_table(45668) := '746174652E7363726F6C6C416E63686F7241742865293B72657475726E2078442E6F66286E657720534428666B2E637572736F72286E2E66726F6D292C227374617274222C227374617274222C6E2E746F702D652C742C213029297D736574546162466F';
wwv_flow_imp.g_varchar2_table(45669) := '6375734D6F64652865297B6E756C6C3D3D653F746869732E696E70757453746174652E746162466F6375734D6F64653D746869732E696E70757453746174652E746162466F6375734D6F64653C303F303A2D313A22626F6F6C65616E223D3D747970656F';
wwv_flow_imp.g_varchar2_table(45670) := '6620653F746869732E696E70757453746174652E746162466F6375734D6F64653D653F303A2D313A30213D746869732E696E70757453746174652E746162466F6375734D6F6465262628746869732E696E70757453746174652E746162466F6375734D6F';
wwv_flow_imp.g_varchar2_table(45671) := '64653D446174652E6E6F7728292B65297D73746174696320646F6D4576656E7448616E646C6572732865297B72657475726E2049442E646566696E65282828293D3E287B7D29292C7B6576656E7448616E646C6572733A657D297D73746174696320646F';
wwv_flow_imp.g_varchar2_table(45672) := '6D4576656E744F62736572766572732865297B72657475726E2049442E646566696E65282828293D3E287B7D29292C7B6576656E744F62736572766572733A657D297D737461746963207468656D6528652C74297B6C6574206E3D78452E6E65774E616D';
wwv_flow_imp.g_varchar2_table(45673) := '6528292C693D5B67492E6F66286E292C48442E6F6628794928602E247B6E7D602C6529295D3B72657475726E20742626742E6461726B2626692E70757368286D492E6F6628213029292C697D73746174696320626173655468656D652865297B72657475';
wwv_flow_imp.g_varchar2_table(45674) := '726E20446B2E6C6F776573742848442E6F6628794928222E222B66492C652C5F492929297D7374617469632066696E6446726F6D444F4D2865297B76617220743B6C6574206E3D652E717565727953656C6563746F7228222E636D2D636F6E74656E7422';
wwv_flow_imp.g_varchar2_table(45675) := '292C693D6E2626694C2E676574286E297C7C694C2E6765742865293B72657475726E286E756C6C3D3D3D28743D6E756C6C3D3D693F766F696420303A692E726F6F7456696577297C7C766F696420303D3D3D743F766F696420303A742E76696577297C7C';
wwv_flow_imp.g_varchar2_table(45676) := '6E756C6C7D7D44492E7374796C654D6F64756C653D48442C44492E696E70757448616E646C65723D66442C44492E636C6970626F617264496E70757446696C7465723D62442C44492E636C6970626F6172644F757470757446696C7465723D5F442C4449';
wwv_flow_imp.g_varchar2_table(45677) := '2E7363726F6C6C48616E646C65723D43442C44492E666F6375734368616E67654566666563743D76442C44492E7065724C696E6554657874446972656374696F6E3D79442C44492E657863657074696F6E53696E6B3D67442C44492E7570646174654C69';
wwv_flow_imp.g_varchar2_table(45678) := '7374656E65723D6D442C44492E6564697461626C653D4C442C44492E6D6F75736553656C656374696F6E5374796C653D70442C44492E647261674D6F76657353656C656374696F6E3D75442C44492E636C69636B4164647353656C656374696F6E52616E';
wwv_flow_imp.g_varchar2_table(45679) := '67653D68442C44492E6465636F726174696F6E733D50442C44492E6F757465724465636F726174696F6E733D4F442C44492E61746F6D696352616E6765733D52442C44492E6269646949736F6C6174656452616E6765733D46442C44492E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(45680) := '4D617267696E733D56442C44492E6461726B5468656D653D6D492C44492E6373704E6F6E63653D5F6B2E646566696E65287B636F6D62696E653A653D3E652E6C656E6774683F655B305D3A22227D292C44492E636F6E74656E7441747472696275746573';
wwv_flow_imp.g_varchar2_table(45681) := '3D4E442C44492E656469746F72417474726962757465733D41442C44492E6C696E655772617070696E673D44492E636F6E74656E74417474726962757465732E6F66287B636C6173733A22636D2D6C696E655772617070696E67227D292C44492E616E6E';
wwv_flow_imp.g_varchar2_table(45682) := '6F756E63653D246B2E646566696E6528293B636F6E73742054493D343039362C49493D7B7D3B636C617373204D497B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E66726F6D3D652C746869732E746F3D742C746869732E64';
wwv_flow_imp.g_varchar2_table(45683) := '69723D6E2C746869732E69736F6C617465733D692C746869732E66726573683D6F2C746869732E6F726465723D737D7374617469632075706461746528652C74297B696628742E656D707479262621652E736F6D652828653D3E652E6672657368292929';
wwv_flow_imp.g_varchar2_table(45684) := '72657475726E20653B6C6574206E3D5B5D2C693D652E6C656E6774683F655B652E6C656E6774682D315D2E6469723A554C2E4C54523B666F72286C6574206F3D4D6174682E6D617828302C652E6C656E6774682D3130293B6F3C652E6C656E6774683B6F';
wwv_flow_imp.g_varchar2_table(45685) := '2B2B297B6C657420733D655B6F5D3B732E646972213D697C7C742E746F756368657352616E676528732E66726F6D2C732E746F297C7C6E2E70757368286E6577204D4928742E6D6170506F7328732E66726F6D2C31292C742E6D6170506F7328732E746F';
wwv_flow_imp.g_varchar2_table(45686) := '2C2D31292C732E6469722C732E69736F6C617465732C21312C732E6F7264657229297D72657475726E206E7D7D66756E6374696F6E20414928652C742C6E297B666F72286C657420693D652E73746174652E66616365742874292C6F3D692E6C656E6774';
wwv_flow_imp.g_varchar2_table(45687) := '682D313B6F3E3D303B6F2D2D297B6C657420743D695B6F5D2C733D2266756E6374696F6E223D3D747970656F6620743F742865293A743B7326264C4C28732C6E297D72657475726E206E7D636F6E7374204E493D5F4C2E6D61633F226D6163223A5F4C2E';
wwv_flow_imp.g_varchar2_table(45688) := '77696E646F77733F2277696E223A5F4C2E6C696E75783F226C696E7578223A226B6579223B66756E6374696F6E20504928652C742C6E297B72657475726E20742E616C744B6579262628653D22416C742D222B65292C742E6374726C4B6579262628653D';
wwv_flow_imp.g_varchar2_table(45689) := '224374726C2D222B65292C742E6D6574614B6579262628653D224D6574612D222B65292C2131213D3D6E2626742E73686966744B6579262628653D2253686966742D222B65292C657D636F6E7374204F493D446B2E64656661756C742844492E646F6D45';
wwv_flow_imp.g_varchar2_table(45690) := '76656E7448616E646C657273287B6B6579646F776E3A28652C74293D3E66756E6374696F6E28652C742C6E2C69297B7A493D743B6C6574206F3D66756E6374696F6E2865297B76617220743D212854452626652E6D6574614B65792626652E7368696674';
wwv_flow_imp.g_varchar2_table(45691) := '4B6579262621652E6374726C4B6579262621652E616C744B65797C7C49452626652E73686966744B65792626652E6B65792626313D3D652E6B65792E6C656E6774687C7C22556E6964656E746966696564223D3D652E6B6579292626652E6B65797C7C28';
wwv_flow_imp.g_varchar2_table(45692) := '652E73686966744B65793F44453A4C45295B652E6B6579436F64655D7C7C652E6B65797C7C22556E6964656E746966696564223B72657475726E22457363223D3D74262628743D2245736361706522292C2244656C223D3D74262628743D2244656C6574';
wwv_flow_imp.g_varchar2_table(45693) := '6522292C224C656674223D3D74262628743D224172726F774C65667422292C225570223D3D74262628743D224172726F77557022292C225269676874223D3D74262628743D224172726F77526967687422292C22446F776E223D3D74262628743D224172';
wwv_flow_imp.g_varchar2_table(45694) := '726F77446F776E22292C747D2874292C733D6F6B286E6B286F2C3029293D3D6F2E6C656E6774682626222022213D6F2C723D22222C613D21312C6C3D21312C633D21313B4249262642492E766965773D3D6E262642492E73636F70653D3D69262628723D';
wwv_flow_imp.g_varchar2_table(45695) := '42492E7072656669782B2220222C76542E696E6465784F6628742E6B6579436F6465293C302626286C3D21302C42493D6E756C6C29293B6C657420642C682C753D6E6577205365742C703D653D3E7B69662865297B666F72286C65742074206F6620652E';
wwv_flow_imp.g_varchar2_table(45696) := '72756E2969662821752E686173287429262628752E6164642874292C74286E29292972657475726E20652E73746F7050726F7061676174696F6E262628633D2130292C21303B652E70726576656E7444656661756C74262628652E73746F7050726F7061';
wwv_flow_imp.g_varchar2_table(45697) := '676174696F6E262628633D2130292C6C3D2130297D72657475726E21317D2C673D655B695D3B72657475726E20672626287028675B722B5049286F2C742C2173295D293F613D21303A73262628742E616C744B65797C7C742E6D6574614B65797C7C742E';
wwv_flow_imp.g_varchar2_table(45698) := '6374726C4B657929262621285F4C2E77696E646F77732626742E6374726C4B65792626742E616C744B657929262628643D4C455B742E6B6579436F64655D29262664213D6F3F287028675B722B504928642C742C2130295D297C7C742E73686966744B65';
wwv_flow_imp.g_varchar2_table(45699) := '79262628683D44455B742E6B6579436F64655D29213D6F262668213D6426267028675B722B504928682C742C2131295D2929262628613D2130293A732626742E73686966744B657926267028675B722B5049286F2C742C2130295D29262628613D213029';
wwv_flow_imp.g_varchar2_table(45700) := '2C216126267028672E5F616E7929262628613D213029292C6C262628613D2130292C612626632626742E73746F7050726F7061676174696F6E28292C7A493D6E756C6C2C617D2866756E6374696F6E2865297B6C657420743D652E666163657428524929';
wwv_flow_imp.g_varchar2_table(45701) := '2C6E3D46492E6765742874293B72657475726E206E7C7C46492E73657428742C6E3D66756E6374696F6E28652C743D4E49297B6C6574206E3D4F626A6563742E637265617465286E756C6C292C693D4F626A6563742E637265617465286E756C6C292C6F';
wwv_flow_imp.g_varchar2_table(45702) := '3D28652C74293D3E7B6C6574206E3D695B655D3B6966286E756C6C3D3D6E29695B655D3D743B656C7365206966286E213D74297468726F77206E6577204572726F7228224B65792062696E64696E6720222B652B22206973207573656420626F74682061';
wwv_flow_imp.g_varchar2_table(45703) := '73206120726567756C61722062696E64696E6720616E642061732061206D756C74692D7374726F6B652070726566697822297D2C733D28652C692C732C722C61293D3E7B766172206C2C633B6C657420643D6E5B655D7C7C286E5B655D3D4F626A656374';
wwv_flow_imp.g_varchar2_table(45704) := '2E637265617465286E756C6C29292C683D692E73706C6974282F20283F2124292F292E6D61702828653D3E66756E6374696F6E28652C74297B636F6E7374206E3D652E73706C6974282F2D283F2124292F293B6C657420692C6F2C732C722C613D6E5B6E';
wwv_flow_imp.g_varchar2_table(45705) := '2E6C656E6774682D315D3B225370616365223D3D61262628613D222022293B666F72286C657420653D303B653C6E2E6C656E6774682D313B2B2B65297B636F6E737420613D6E5B655D3B6966282F5E28636D647C6D6574617C6D29242F692E7465737428';
wwv_flow_imp.g_varchar2_table(45706) := '612929723D21303B656C7365206966282F5E61286C74293F242F692E7465737428612929693D21303B656C7365206966282F5E28637C6374726C7C636F6E74726F6C29242F692E74657374286129296F3D21303B656C7365206966282F5E732868696674';
wwv_flow_imp.g_varchar2_table(45707) := '293F242F692E7465737428612929733D21303B656C73657B696628212F5E6D6F64242F692E74657374286129297468726F77206E6577204572726F722822556E7265636F676E697A6564206D6F646966696572206E616D653A20222B61293B226D616322';
wwv_flow_imp.g_varchar2_table(45708) := '3D3D743F723D21303A6F3D21307D7D72657475726E2069262628613D22416C742D222B61292C6F262628613D224374726C2D222B61292C72262628613D224D6574612D222B61292C73262628613D2253686966742D222B61292C617D28652C742929293B';
wwv_flow_imp.g_varchar2_table(45709) := '666F72286C657420743D313B743C682E6C656E6774683B742B2B297B6C6574206E3D682E736C69636528302C74292E6A6F696E28222022293B6F286E2C2130292C645B6E5D7C7C28645B6E5D3D7B70726576656E7444656661756C743A21302C73746F70';
wwv_flow_imp.g_varchar2_table(45710) := '50726F7061676174696F6E3A21312C72756E3A5B743D3E7B6C657420693D42493D7B766965773A742C7072656669783A6E2C73636F70653A657D3B72657475726E2073657454696D656F7574282828293D3E7B42493D3D6926262842493D6E756C6C297D';
wwv_flow_imp.g_varchar2_table(45711) := '292C5649292C21307D5D7D297D6C657420753D682E6A6F696E28222022293B6F28752C2131293B6C657420703D645B755D7C7C28645B755D3D7B70726576656E7444656661756C743A21312C73746F7050726F7061676174696F6E3A21312C72756E3A28';
wwv_flow_imp.g_varchar2_table(45712) := '6E756C6C3D3D3D28633D6E756C6C3D3D3D286C3D642E5F616E79297C7C766F696420303D3D3D6C3F766F696420303A6C2E72756E297C7C766F696420303D3D3D633F766F696420303A632E736C6963652829297C7C5B5D7D293B732626702E72756E2E70';
wwv_flow_imp.g_varchar2_table(45713) := '7573682873292C72262628702E70726576656E7444656661756C743D2130292C61262628702E73746F7050726F7061676174696F6E3D2130297D3B666F72286C65742069206F662065297B6C657420653D692E73636F70653F692E73636F70652E73706C';
wwv_flow_imp.g_varchar2_table(45714) := '697428222022293A5B22656469746F72225D3B696628692E616E7929666F72286C65742074206F662065297B6C657420653D6E5B745D7C7C286E5B745D3D4F626A6563742E637265617465286E756C6C29293B652E5F616E797C7C28652E5F616E793D7B';
wwv_flow_imp.g_varchar2_table(45715) := '70726576656E7444656661756C743A21312C73746F7050726F7061676174696F6E3A21312C72756E3A5B5D7D293B6C65747B616E793A6F7D3D693B666F72286C6574207420696E206529655B745D2E72756E2E707573682828653D3E6F28652C7A492929';
wwv_flow_imp.g_varchar2_table(45716) := '297D6C6574206F3D695B745D7C7C692E6B65793B6966286F29666F72286C65742074206F662065297328742C6F2C692E72756E2C692E70726576656E7444656661756C742C692E73746F7050726F7061676174696F6E292C692E73686966742626732874';
wwv_flow_imp.g_varchar2_table(45717) := '2C2253686966742D222B6F2C692E73686966742C692E70726576656E7444656661756C742C692E73746F7050726F7061676174696F6E297D72657475726E206E7D28742E726564756365282828652C74293D3E652E636F6E636174287429292C5B5D2929';
wwv_flow_imp.g_varchar2_table(45718) := '292C6E7D28742E7374617465292C652C742C22656469746F7222297D29292C52493D5F6B2E646566696E65287B656E61626C65733A4F497D292C46493D6E6577205765616B4D61703B6C65742042493D6E756C6C3B636F6E73742056493D3465333B6C65';
wwv_flow_imp.g_varchar2_table(45719) := '74207A493D6E756C6C3B636F6E73742048493D7B222E636D2D6C696E65223A7B2226203A3A73656C656374696F6E2C20263A3A73656C656374696F6E223A7B6261636B67726F756E64436F6C6F723A227472616E73706172656E742021696D706F727461';
wwv_flow_imp.g_varchar2_table(45720) := '6E74227D7D2C222E636D2D636F6E74656E74223A7B2226203A666F637573223A7B6361726574436F6C6F723A22696E697469616C2021696D706F7274616E74222C22263A3A73656C656374696F6E2C2026203A3A73656C656374696F6E223A7B6261636B';
wwv_flow_imp.g_varchar2_table(45721) := '67726F756E64436F6C6F723A22486967686C696768742021696D706F7274616E74227D7D7D7D3B215F4C2E696F7326262848495B222E636D2D6C696E65225D2E6361726574436F6C6F723D48495B222E636D2D636F6E74656E74225D2E6361726574436F';
wwv_flow_imp.g_varchar2_table(45722) := '6C6F723D227472616E73706172656E742021696D706F7274616E7422293B636C61737320574920657874656E647320414C7B636F6E7374727563746F722865297B737570657228292C746869732E636F6E74656E743D657D746F444F4D28297B6C657420';
wwv_flow_imp.g_varchar2_table(45723) := '653D646F63756D656E742E637265617465456C656D656E7428227370616E22293B72657475726E20652E636C6173734E616D653D22636D2D706C616365686F6C646572222C652E7374796C652E706F696E7465724576656E74733D226E6F6E65222C652E';
wwv_flow_imp.g_varchar2_table(45724) := '617070656E644368696C642822737472696E67223D3D747970656F6620746869732E636F6E74656E743F646F63756D656E742E637265617465546578744E6F646528746869732E636F6E74656E74293A746869732E636F6E74656E74292C22737472696E';
wwv_flow_imp.g_varchar2_table(45725) := '67223D3D747970656F6620746869732E636F6E74656E743F652E7365744174747269627574652822617269612D6C6162656C222C22706C616365686F6C64657220222B746869732E636F6E74656E74293A652E7365744174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(45726) := '612D68696464656E222C227472756522292C657D636F6F72647341742865297B6C657420743D652E66697273744368696C643F524528652E66697273744368696C64293A5B5D3B69662821742E6C656E6774682972657475726E206E756C6C3B6C657420';
wwv_flow_imp.g_varchar2_table(45727) := '6E3D77696E646F772E676574436F6D70757465645374796C6528652E706172656E744E6F6465292C693D574528745B305D2C2272746C22213D6E2E646972656374696F6E292C6F3D7061727365496E74286E2E6C696E65486569676874293B7265747572';
wwv_flow_imp.g_varchar2_table(45728) := '6E20692E626F74746F6D2D692E746F703E312E352A6F3F7B6C6566743A692E6C6566742C72696768743A692E72696768742C746F703A692E746F702C626F74746F6D3A692E746F702B6F7D3A697D69676E6F72654576656E7428297B72657475726E2131';
wwv_flow_imp.g_varchar2_table(45729) := '7D7D66756E6374696F6E206A492865297B72657475726E2049442E66726F6D436C61737328636C6173737B636F6E7374727563746F722874297B746869732E766965773D742C746869732E706C616365686F6C6465723D653F504C2E736574285B504C2E';
wwv_flow_imp.g_varchar2_table(45730) := '776964676574287B7769646765743A6E65772057492865292C736964653A317D292E72616E67652830295D293A504C2E6E6F6E657D676574206465636F726174696F6E7328297B72657475726E20746869732E766965772E73746174652E646F632E6C65';
wwv_flow_imp.g_varchar2_table(45731) := '6E6774683F504C2E6E6F6E653A746869732E706C616365686F6C6465727D7D2C7B6465636F726174696F6E733A653D3E652E6465636F726174696F6E737D297D636F6E73742071493D222D31303030307078223B636C6173732024497B636F6E73747275';
wwv_flow_imp.g_varchar2_table(45732) := '63746F7228652C742C6E2C69297B746869732E66616365743D742C746869732E637265617465546F6F6C746970566965773D6E2C746869732E72656D6F7665546F6F6C746970566965773D692C746869732E696E7075743D652E73746174652E66616365';
wwv_flow_imp.g_varchar2_table(45733) := '742874292C746869732E746F6F6C746970733D746869732E696E7075742E66696C7465722828653D3E6529293B6C6574206F3D6E756C6C3B746869732E746F6F6C74697056696577733D746869732E746F6F6C746970732E6D61702828653D3E6F3D6E28';
wwv_flow_imp.g_varchar2_table(45734) := '652C6F2929297D75706461746528652C74297B766172206E3B6C657420693D652E73746174652E666163657428746869732E6661636574292C6F3D692E66696C7465722828653D3E6529293B696628693D3D3D746869732E696E707574297B666F72286C';
wwv_flow_imp.g_varchar2_table(45735) := '65742074206F6620746869732E746F6F6C746970566965777329742E7570646174652626742E7570646174652865293B72657475726E21317D6C657420733D5B5D2C723D743F5B5D3A6E756C6C3B666F72286C6574206E3D303B6E3C6F2E6C656E677468';
wwv_flow_imp.g_varchar2_table(45736) := '3B6E2B2B297B6C657420693D6F5B6E5D2C613D2D313B69662869297B666F72286C657420653D303B653C746869732E746F6F6C746970732E6C656E6774683B652B2B297B6C657420743D746869732E746F6F6C746970735B655D3B742626742E63726561';
wwv_flow_imp.g_varchar2_table(45737) := '74653D3D692E637265617465262628613D65297D696628613C3029735B6E5D3D746869732E637265617465546F6F6C7469705669657728692C6E3F735B6E2D315D3A6E756C6C292C72262628725B6E5D3D2121692E61626F7665293B656C73657B6C6574';
wwv_flow_imp.g_varchar2_table(45738) := '20693D735B6E5D3D746869732E746F6F6C74697056696577735B615D3B72262628725B6E5D3D745B615D292C692E7570646174652626692E7570646174652865297D7D7D666F72286C65742065206F6620746869732E746F6F6C74697056696577732973';
wwv_flow_imp.g_varchar2_table(45739) := '2E696E6465784F662865293C30262628746869732E72656D6F7665546F6F6C746970566965772865292C6E756C6C3D3D3D286E3D652E64657374726F79297C7C766F696420303D3D3D6E7C7C6E2E63616C6C286529293B72657475726E2074262628722E';
wwv_flow_imp.g_varchar2_table(45740) := '666F7245616368282828652C6E293D3E745B6E5D3D6529292C742E6C656E6774683D722E6C656E677468292C746869732E696E7075743D692C746869732E746F6F6C746970733D6F2C746869732E746F6F6C74697056696577733D732C21307D7D66756E';
wwv_flow_imp.g_varchar2_table(45741) := '6374696F6E20554928653D7B7D297B72657475726E2047492E6F662865297D66756E6374696F6E204B492865297B6C65747B77696E3A747D3D653B72657475726E7B746F703A302C6C6566743A302C626F74746F6D3A742E696E6E65724865696768742C';
wwv_flow_imp.g_varchar2_table(45742) := '72696768743A742E696E6E657257696474687D7D636F6E73742047493D5F6B2E646566696E65287B636F6D62696E653A653D3E7B76617220742C6E2C693B72657475726E7B706F736974696F6E3A5F4C2E696F733F226162736F6C757465223A286E756C';
wwv_flow_imp.g_varchar2_table(45743) := '6C3D3D3D28743D652E66696E642828653D3E652E706F736974696F6E2929297C7C766F696420303D3D3D743F766F696420303A742E706F736974696F6E297C7C226669786564222C706172656E743A286E756C6C3D3D3D286E3D652E66696E642828653D';
wwv_flow_imp.g_varchar2_table(45744) := '3E652E706172656E742929297C7C766F696420303D3D3D6E3F766F696420303A6E2E706172656E74297C7C6E756C6C2C746F6F6C74697053706163653A286E756C6C3D3D3D28693D652E66696E642828653D3E652E746F6F6C7469705370616365292929';
wwv_flow_imp.g_varchar2_table(45745) := '7C7C766F696420303D3D3D693F766F696420303A692E746F6F6C7469705370616365297C7C4B497D7D7D292C51493D6E6577205765616B4D61702C59493D49442E66726F6D436C61737328636C6173737B636F6E7374727563746F722865297B74686973';
wwv_flow_imp.g_varchar2_table(45746) := '2E766965773D652C746869732E61626F76653D5B5D2C746869732E696E566965773D21302C746869732E6D6164654162736F6C7574653D21312C746869732E6C6173745472616E73616374696F6E3D302C746869732E6D65617375726554696D656F7574';
wwv_flow_imp.g_varchar2_table(45747) := '3D2D313B6C657420743D652E73746174652E6661636574284749293B746869732E706F736974696F6E3D742E706F736974696F6E2C746869732E706172656E743D742E706172656E742C746869732E636C61737365733D652E7468656D65436C61737365';
wwv_flow_imp.g_varchar2_table(45748) := '732C746869732E637265617465436F6E7461696E657228292C746869732E6D6561737572655265713D7B726561643A746869732E726561644D6561737572652E62696E642874686973292C77726974653A746869732E77726974654D6561737572652E62';
wwv_flow_imp.g_varchar2_table(45749) := '696E642874686973292C6B65793A746869737D2C746869732E726573697A654F627365727665723D2266756E6374696F6E223D3D747970656F6620526573697A654F627365727665723F6E657720526573697A654F62736572766572282828293D3E7468';
wwv_flow_imp.g_varchar2_table(45750) := '69732E6D656173757265536F6F6E282929293A6E756C6C2C746869732E6D616E616765723D6E657720244928652C4A492C2828652C74293D3E746869732E637265617465546F6F6C74697028652C7429292C28653D3E7B746869732E726573697A654F62';
wwv_flow_imp.g_varchar2_table(45751) := '7365727665722626746869732E726573697A654F627365727665722E756E6F62736572766528652E646F6D292C652E646F6D2E72656D6F766528297D29292C746869732E61626F76653D746869732E6D616E616765722E746F6F6C746970732E6D617028';
wwv_flow_imp.g_varchar2_table(45752) := '28653D3E2121652E61626F766529292C746869732E696E74657273656374696F6E4F627365727665723D2266756E6374696F6E223D3D747970656F6620496E74657273656374696F6E4F627365727665723F6E657720496E74657273656374696F6E4F62';
wwv_flow_imp.g_varchar2_table(45753) := '7365727665722828653D3E7B446174652E6E6F7728293E746869732E6C6173745472616E73616374696F6E2D35302626652E6C656E6774683E302626655B652E6C656E6774682D315D2E696E74657273656374696F6E526174696F3C312626746869732E';
wwv_flow_imp.g_varchar2_table(45754) := '6D656173757265536F6F6E28297D292C7B7468726573686F6C643A5B315D7D293A6E756C6C2C746869732E6F627365727665496E74657273656374696F6E28292C652E77696E2E6164644576656E744C697374656E65722822726573697A65222C746869';
wwv_flow_imp.g_varchar2_table(45755) := '732E6D656173757265536F6F6E3D746869732E6D656173757265536F6F6E2E62696E64287468697329292C746869732E6D617962654D65617375726528297D637265617465436F6E7461696E657228297B746869732E706172656E743F28746869732E63';
wwv_flow_imp.g_varchar2_table(45756) := '6F6E7461696E65723D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E636F6E7461696E65722E7374796C652E706F736974696F6E3D2272656C6174697665222C746869732E636F6E7461696E65722E636C617373';
wwv_flow_imp.g_varchar2_table(45757) := '4E616D653D746869732E766965772E7468656D65436C61737365732C746869732E706172656E742E617070656E644368696C6428746869732E636F6E7461696E657229293A746869732E636F6E7461696E65723D746869732E766965772E646F6D7D6F62';
wwv_flow_imp.g_varchar2_table(45758) := '7365727665496E74657273656374696F6E28297B696628746869732E696E74657273656374696F6E4F62736572766572297B746869732E696E74657273656374696F6E4F627365727665722E646973636F6E6E65637428293B666F72286C65742065206F';
wwv_flow_imp.g_varchar2_table(45759) := '6620746869732E6D616E616765722E746F6F6C746970566965777329746869732E696E74657273656374696F6E4F627365727665722E6F62736572766528652E646F6D297D7D6D656173757265536F6F6E28297B746869732E6D65617375726554696D65';
wwv_flow_imp.g_varchar2_table(45760) := '6F75743C30262628746869732E6D65617375726554696D656F75743D73657454696D656F7574282828293D3E7B746869732E6D65617375726554696D656F75743D2D312C746869732E6D617962654D65617375726528297D292C353029297D7570646174';
wwv_flow_imp.g_varchar2_table(45761) := '652865297B652E7472616E73616374696F6E732E6C656E677468262628746869732E6C6173745472616E73616374696F6E3D446174652E6E6F772829293B6C657420743D746869732E6D616E616765722E75706461746528652C746869732E61626F7665';
wwv_flow_imp.g_varchar2_table(45762) := '293B742626746869732E6F627365727665496E74657273656374696F6E28293B6C6574206E3D747C7C652E67656F6D657472794368616E6765642C693D652E73746174652E6661636574284749293B696628692E706F736974696F6E213D746869732E70';
wwv_flow_imp.g_varchar2_table(45763) := '6F736974696F6E262621746869732E6D6164654162736F6C757465297B746869732E706F736974696F6E3D692E706F736974696F6E3B666F72286C65742065206F6620746869732E6D616E616765722E746F6F6C746970566965777329652E646F6D2E73';
wwv_flow_imp.g_varchar2_table(45764) := '74796C652E706F736974696F6E3D746869732E706F736974696F6E3B6E3D21307D696628692E706172656E74213D746869732E706172656E74297B746869732E706172656E742626746869732E636F6E7461696E65722E72656D6F766528292C74686973';
wwv_flow_imp.g_varchar2_table(45765) := '2E706172656E743D692E706172656E742C746869732E637265617465436F6E7461696E657228293B666F72286C65742065206F6620746869732E6D616E616765722E746F6F6C746970566965777329746869732E636F6E7461696E65722E617070656E64';
wwv_flow_imp.g_varchar2_table(45766) := '4368696C6428652E646F6D293B6E3D21307D656C736520746869732E706172656E742626746869732E766965772E7468656D65436C6173736573213D746869732E636C6173736573262628746869732E636C61737365733D746869732E636F6E7461696E';
wwv_flow_imp.g_varchar2_table(45767) := '65722E636C6173734E616D653D746869732E766965772E7468656D65436C6173736573293B6E2626746869732E6D617962654D65617375726528297D637265617465546F6F6C74697028652C74297B6C6574206E3D652E63726561746528746869732E76';
wwv_flow_imp.g_varchar2_table(45768) := '696577292C693D743F742E646F6D3A6E756C6C3B6966286E2E646F6D2E636C6173734C6973742E6164642822636D2D746F6F6C74697022292C652E6172726F772626216E2E646F6D2E717565727953656C6563746F7228222E636D2D746F6F6C74697020';
wwv_flow_imp.g_varchar2_table(45769) := '3E202E636D2D746F6F6C7469702D6172726F772229297B6C657420653D646F63756D656E742E637265617465456C656D656E74282264697622293B652E636C6173734E616D653D22636D2D746F6F6C7469702D6172726F77222C6E2E646F6D2E61707065';
wwv_flow_imp.g_varchar2_table(45770) := '6E644368696C642865297D72657475726E206E2E646F6D2E7374796C652E706F736974696F6E3D746869732E706F736974696F6E2C6E2E646F6D2E7374796C652E746F703D71492C6E2E646F6D2E7374796C652E6C6566743D22307078222C746869732E';
wwv_flow_imp.g_varchar2_table(45771) := '636F6E7461696E65722E696E736572744265666F7265286E2E646F6D2C69292C6E2E6D6F756E7426266E2E6D6F756E7428746869732E76696577292C746869732E726573697A654F627365727665722626746869732E726573697A654F62736572766572';
wwv_flow_imp.g_varchar2_table(45772) := '2E6F627365727665286E2E646F6D292C6E7D64657374726F7928297B76617220652C742C6E3B746869732E766965772E77696E2E72656D6F76654576656E744C697374656E65722822726573697A65222C746869732E6D656173757265536F6F6E293B66';
wwv_flow_imp.g_varchar2_table(45773) := '6F72286C65742074206F6620746869732E6D616E616765722E746F6F6C746970566965777329742E646F6D2E72656D6F766528292C6E756C6C3D3D3D28653D742E64657374726F79297C7C766F696420303D3D3D657C7C652E63616C6C2874293B746869';
wwv_flow_imp.g_varchar2_table(45774) := '732E706172656E742626746869732E636F6E7461696E65722E72656D6F766528292C6E756C6C3D3D3D28743D746869732E726573697A654F62736572766572297C7C766F696420303D3D3D747C7C742E646973636F6E6E65637428292C6E756C6C3D3D3D';
wwv_flow_imp.g_varchar2_table(45775) := '286E3D746869732E696E74657273656374696F6E4F62736572766572297C7C766F696420303D3D3D6E7C7C6E2E646973636F6E6E65637428292C636C65617254696D656F757428746869732E6D65617375726554696D656F7574297D726561644D656173';
wwv_flow_imp.g_varchar2_table(45776) := '75726528297B6C657420653D746869732E766965772E646F6D2E676574426F756E64696E67436C69656E745265637428292C743D312C6E3D312C693D21313B696628226669786564223D3D746869732E706F736974696F6E2626746869732E6D616E6167';
wwv_flow_imp.g_varchar2_table(45777) := '65722E746F6F6C74697056696577732E6C656E677468297B6C65747B646F6D3A657D3D746869732E6D616E616765722E746F6F6C74697056696577735B305D3B6966285F4C2E6765636B6F29693D652E6F6666736574506172656E74213D746869732E63';
wwv_flow_imp.g_varchar2_table(45778) := '6F6E7461696E65722E6F776E6572446F63756D656E742E626F64793B656C736520696628652E7374796C652E746F703D3D7149262622307078223D3D652E7374796C652E6C656674297B6C657420743D652E676574426F756E64696E67436C69656E7452';
wwv_flow_imp.g_varchar2_table(45779) := '65637428293B693D4D6174682E61627328742E746F702B316534293E317C7C4D6174682E61627328742E6C656674293E317D7D696628697C7C226162736F6C757465223D3D746869732E706F736974696F6E29696628746869732E706172656E74297B6C';
wwv_flow_imp.g_varchar2_table(45780) := '657420653D746869732E706172656E742E676574426F756E64696E67436C69656E745265637428293B652E77696474682626652E686569676874262628743D652E77696474682F746869732E706172656E742E6F666673657457696474682C6E3D652E68';
wwv_flow_imp.g_varchar2_table(45781) := '65696768742F746869732E706172656E742E6F6666736574486569676874297D656C7365287B7363616C65583A742C7363616C65593A6E7D3D746869732E766965772E766965775374617465293B72657475726E7B656469746F723A652C706172656E74';
wwv_flow_imp.g_varchar2_table(45782) := '3A746869732E706172656E743F746869732E636F6E7461696E65722E676574426F756E64696E67436C69656E745265637428293A652C706F733A746869732E6D616E616765722E746F6F6C746970732E6D6170282828652C74293D3E7B6C6574206E3D74';
wwv_flow_imp.g_varchar2_table(45783) := '6869732E6D616E616765722E746F6F6C74697056696577735B745D3B72657475726E206E2E676574436F6F7264733F6E2E676574436F6F72647328652E706F73293A746869732E766965772E636F6F7264734174506F7328652E706F73297D29292C7369';
wwv_flow_imp.g_varchar2_table(45784) := '7A653A746869732E6D616E616765722E746F6F6C74697056696577732E6D61702828287B646F6D3A657D293D3E652E676574426F756E64696E67436C69656E7452656374282929292C73706163653A746869732E766965772E73746174652E6661636574';
wwv_flow_imp.g_varchar2_table(45785) := '284749292E746F6F6C746970537061636528746869732E76696577292C7363616C65583A742C7363616C65593A6E2C6D616B654162736F6C7574653A697D7D77726974654D6561737572652865297B76617220743B696628652E6D616B654162736F6C75';
wwv_flow_imp.g_varchar2_table(45786) := '7465297B746869732E6D6164654162736F6C7574653D21302C746869732E706F736974696F6E3D226162736F6C757465223B666F72286C65742065206F6620746869732E6D616E616765722E746F6F6C746970566965777329652E646F6D2E7374796C65';
wwv_flow_imp.g_varchar2_table(45787) := '2E706F736974696F6E3D226162736F6C757465227D6C65747B656469746F723A6E2C73706163653A692C7363616C65583A6F2C7363616C65593A737D3D652C723D5B5D3B666F72286C657420613D303B613C746869732E6D616E616765722E746F6F6C74';
wwv_flow_imp.g_varchar2_table(45788) := '6970732E6C656E6774683B612B2B297B6C6574206C3D746869732E6D616E616765722E746F6F6C746970735B615D2C633D746869732E6D616E616765722E746F6F6C74697056696577735B615D2C7B646F6D3A647D3D632C683D652E706F735B615D2C75';
wwv_flow_imp.g_varchar2_table(45789) := '3D652E73697A655B615D3B69662821687C7C682E626F74746F6D3C3D4D6174682E6D6178286E2E746F702C692E746F70297C7C682E746F703E3D4D6174682E6D696E286E2E626F74746F6D2C692E626F74746F6D297C7C682E72696768743C4D6174682E';
wwv_flow_imp.g_varchar2_table(45790) := '6D6178286E2E6C6566742C692E6C656674292D2E317C7C682E6C6566743E4D6174682E6D696E286E2E72696768742C692E7269676874292B2E31297B642E7374796C652E746F703D71493B636F6E74696E75657D6C657420703D6C2E6172726F773F632E';
wwv_flow_imp.g_varchar2_table(45791) := '646F6D2E717565727953656C6563746F7228222E636D2D746F6F6C7469702D6172726F7722293A6E756C6C2C673D703F373A302C6D3D752E72696768742D752E6C6566742C663D6E756C6C213D3D28743D51492E676574286329292626766F6964203021';
wwv_flow_imp.g_varchar2_table(45792) := '3D3D743F743A752E626F74746F6D2D752E746F702C763D632E6F66667365747C7C58492C623D746869732E766965772E74657874446972656374696F6E3D3D554C2E4C54522C5F3D752E77696474683E692E72696768742D692E6C6566743F623F692E6C';
wwv_flow_imp.g_varchar2_table(45793) := '6566743A692E72696768742D752E77696474683A623F4D6174682E6D617828692E6C6566742C4D6174682E6D696E28682E6C6566742D28703F31343A30292B762E782C692E72696768742D6D29293A4D6174682E6D696E284D6174682E6D617828692E6C';
wwv_flow_imp.g_varchar2_table(45794) := '6566742C682E6C6566742D6D2B28703F31343A30292D762E78292C692E72696768742D6D292C793D746869732E61626F76655B615D3B216C2E73747269637453696465262628793F682E746F702D28752E626F74746F6D2D752E746F70292D762E793C69';
wwv_flow_imp.g_varchar2_table(45795) := '2E746F703A682E626F74746F6D2B28752E626F74746F6D2D752E746F70292B762E793E692E626F74746F6D292626793D3D692E626F74746F6D2D682E626F74746F6D3E682E746F702D692E746F70262628793D746869732E61626F76655B615D3D217929';
wwv_flow_imp.g_varchar2_table(45796) := '3B6C657420773D28793F682E746F702D692E746F703A692E626F74746F6D2D682E626F74746F6D292D673B696628773C6626262131213D3D632E726573697A65297B696628773C746869732E766965772E64656661756C744C696E65486569676874297B';
wwv_flow_imp.g_varchar2_table(45797) := '642E7374796C652E746F703D71493B636F6E74696E75657D51492E73657428632C66292C642E7374796C652E6865696768743D28663D77292F732B227078227D656C736520642E7374796C652E686569676874262628642E7374796C652E686569676874';
wwv_flow_imp.g_varchar2_table(45798) := '3D2222293B6C657420433D793F682E746F702D662D672D762E793A682E626F74746F6D2B672B762E792C533D5F2B6D3B6966282130213D3D632E6F7665726C617029666F72286C65742065206F66207229652E6C6566743C532626652E72696768743E5F';
wwv_flow_imp.g_varchar2_table(45799) := '2626652E746F703C432B662626652E626F74746F6D3E43262628433D793F652E746F702D662D322D673A652E626F74746F6D2B672B32293B696628226162736F6C757465223D3D746869732E706F736974696F6E3F28642E7374796C652E746F703D2843';
wwv_flow_imp.g_varchar2_table(45800) := '2D652E706172656E742E746F70292F732B227078222C642E7374796C652E6C6566743D285F2D652E706172656E742E6C656674292F6F2B22707822293A28642E7374796C652E746F703D432F732B227078222C642E7374796C652E6C6566743D5F2F6F2B';
wwv_flow_imp.g_varchar2_table(45801) := '22707822292C70297B6C657420653D682E6C6566742B28623F762E783A2D762E78292D285F2B31342D37293B702E7374796C652E6C6566743D652F6F2B227078227D2130213D3D632E6F7665726C61702626722E70757368287B6C6566743A5F2C746F70';
wwv_flow_imp.g_varchar2_table(45802) := '3A432C72696768743A532C626F74746F6D3A432B667D292C642E636C6173734C6973742E746F67676C652822636D2D746F6F6C7469702D61626F7665222C79292C642E636C6173734C6973742E746F67676C652822636D2D746F6F6C7469702D62656C6F';
wwv_flow_imp.g_varchar2_table(45803) := '77222C2179292C632E706F736974696F6E65642626632E706F736974696F6E656428652E7370616365297D7D6D617962654D65617375726528297B696628746869732E6D616E616765722E746F6F6C746970732E6C656E677468262628746869732E7669';
wwv_flow_imp.g_varchar2_table(45804) := '65772E696E566965772626746869732E766965772E726571756573744D65617375726528746869732E6D656173757265526571292C746869732E696E56696577213D746869732E766965772E696E56696577262628746869732E696E566965773D746869';
wwv_flow_imp.g_varchar2_table(45805) := '732E766965772E696E566965772C21746869732E696E56696577292929666F72286C65742065206F6620746869732E6D616E616765722E746F6F6C746970566965777329652E646F6D2E7374796C652E746F703D71497D7D2C7B6576656E744F62736572';
wwv_flow_imp.g_varchar2_table(45806) := '766572733A7B7363726F6C6C28297B746869732E6D617962654D65617375726528297D7D7D292C5A493D44492E626173655468656D65287B222E636D2D746F6F6C746970223A7B7A496E6465783A3130302C626F7853697A696E673A22626F726465722D';
wwv_flow_imp.g_varchar2_table(45807) := '626F78227D2C22266C69676874202E636D2D746F6F6C746970223A7B626F726465723A2231707820736F6C69642023626262222C6261636B67726F756E64436F6C6F723A2223663566356635227D2C22266C69676874202E636D2D746F6F6C7469702D73';
wwv_flow_imp.g_varchar2_table(45808) := '656374696F6E3A6E6F74283A66697273742D6368696C6429223A7B626F72646572546F703A2231707820736F6C69642023626262227D2C22266461726B202E636D2D746F6F6C746970223A7B6261636B67726F756E64436F6C6F723A2223333333333338';
wwv_flow_imp.g_varchar2_table(45809) := '222C636F6C6F723A227768697465227D2C222E636D2D746F6F6C7469702D6172726F77223A7B6865696768743A22377078222C77696474683A2231347078222C706F736974696F6E3A226162736F6C757465222C7A496E6465783A2D312C6F766572666C';
wwv_flow_imp.g_varchar2_table(45810) := '6F773A2268696464656E222C22263A6265666F72652C20263A6166746572223A7B636F6E74656E743A222727222C706F736974696F6E3A226162736F6C757465222C77696474683A302C6865696768743A302C626F726465724C6566743A223770782073';
wwv_flow_imp.g_varchar2_table(45811) := '6F6C6964207472616E73706172656E74222C626F7264657252696768743A2237707820736F6C6964207472616E73706172656E74227D2C222E636D2D746F6F6C7469702D61626F76652026223A7B626F74746F6D3A222D377078222C22263A6265666F72';
wwv_flow_imp.g_varchar2_table(45812) := '65223A7B626F72646572546F703A2237707820736F6C69642023626262227D2C22263A6166746572223A7B626F72646572546F703A2237707820736F6C69642023663566356635222C626F74746F6D3A22317078227D7D2C222E636D2D746F6F6C746970';
wwv_flow_imp.g_varchar2_table(45813) := '2D62656C6F772026223A7B746F703A222D377078222C22263A6265666F7265223A7B626F72646572426F74746F6D3A2237707820736F6C69642023626262227D2C22263A6166746572223A7B626F72646572426F74746F6D3A2237707820736F6C696420';
wwv_flow_imp.g_varchar2_table(45814) := '23663566356635222C746F703A22317078227D7D7D2C22266461726B202E636D2D746F6F6C746970202E636D2D746F6F6C7469702D6172726F77223A7B22263A6265666F7265223A7B626F72646572546F70436F6C6F723A2223333333333338222C626F';
wwv_flow_imp.g_varchar2_table(45815) := '72646572426F74746F6D436F6C6F723A2223333333333338227D2C22263A6166746572223A7B626F72646572546F70436F6C6F723A227472616E73706172656E74222C626F72646572426F74746F6D436F6C6F723A227472616E73706172656E74227D7D';
wwv_flow_imp.g_varchar2_table(45816) := '7D292C58493D7B783A302C793A307D2C4A493D5F6B2E646566696E65287B656E61626C65733A5B59492C5A495D7D292C654D3D5F6B2E646566696E65287B636F6D62696E653A653D3E652E726564756365282828652C74293D3E652E636F6E6361742874';
wwv_flow_imp.g_varchar2_table(45817) := '29292C5B5D297D293B636C61737320744D7B737461746963206372656174652865297B72657475726E206E657720744D2865297D636F6E7374727563746F722865297B746869732E766965773D652C746869732E6D6F756E7465643D21312C746869732E';
wwv_flow_imp.g_varchar2_table(45818) := '646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E636C6173734C6973742E6164642822636D2D746F6F6C7469702D686F76657222292C746869732E6D616E616765723D6E657720244928652C65';
wwv_flow_imp.g_varchar2_table(45819) := '4D2C2828652C74293D3E746869732E637265617465486F737465645669657728652C7429292C28653D3E652E646F6D2E72656D6F7665282929297D637265617465486F737465645669657728652C74297B6C6574206E3D652E6372656174652874686973';
wwv_flow_imp.g_varchar2_table(45820) := '2E76696577293B72657475726E206E2E646F6D2E636C6173734C6973742E6164642822636D2D746F6F6C7469702D73656374696F6E22292C746869732E646F6D2E696E736572744265666F7265286E2E646F6D2C743F742E646F6D2E6E6578745369626C';
wwv_flow_imp.g_varchar2_table(45821) := '696E673A746869732E646F6D2E66697273744368696C64292C746869732E6D6F756E74656426266E2E6D6F756E7426266E2E6D6F756E7428746869732E76696577292C6E7D6D6F756E742865297B666F72286C65742074206F6620746869732E6D616E61';
wwv_flow_imp.g_varchar2_table(45822) := '6765722E746F6F6C746970566965777329742E6D6F756E742626742E6D6F756E742865293B746869732E6D6F756E7465643D21307D706F736974696F6E65642865297B666F72286C65742074206F6620746869732E6D616E616765722E746F6F6C746970';
wwv_flow_imp.g_varchar2_table(45823) := '566965777329742E706F736974696F6E65642626742E706F736974696F6E65642865297D7570646174652865297B746869732E6D616E616765722E7570646174652865297D64657374726F7928297B76617220653B666F72286C65742074206F66207468';
wwv_flow_imp.g_varchar2_table(45824) := '69732E6D616E616765722E746F6F6C7469705669657773296E756C6C3D3D3D28653D742E64657374726F79297C7C766F696420303D3D3D657C7C652E63616C6C2874297D7061737350726F702865297B6C657420743B666F72286C6574206E206F662074';
wwv_flow_imp.g_varchar2_table(45825) := '6869732E6D616E616765722E746F6F6C7469705669657773297B6C657420693D6E5B655D3B696628766F69642030213D3D6929696628766F696420303D3D3D7429743D693B656C73652069662874213D3D692972657475726E7D72657475726E20747D67';
wwv_flow_imp.g_varchar2_table(45826) := '6574206F666673657428297B72657475726E20746869732E7061737350726F7028226F666673657422297D67657420676574436F6F72647328297B72657475726E20746869732E7061737350726F702822676574436F6F72647322297D676574206F7665';
wwv_flow_imp.g_varchar2_table(45827) := '726C617028297B72657475726E20746869732E7061737350726F7028226F7665726C617022297D67657420726573697A6528297B72657475726E20746869732E7061737350726F702822726573697A6522297D7D636F6E7374206E4D3D4A492E636F6D70';
wwv_flow_imp.g_varchar2_table(45828) := '757465285B654D5D2C28653D3E7B6C657420743D652E666163657428654D293B72657475726E20303D3D3D742E6C656E6774683F6E756C6C3A7B706F733A4D6174682E6D696E282E2E2E742E6D61702828653D3E652E706F732929292C656E643A4D6174';
wwv_flow_imp.g_varchar2_table(45829) := '682E6D6178282E2E2E742E6D61702828653D3E7B76617220743B72657475726E206E756C6C213D3D28743D652E656E64292626766F69642030213D3D743F743A652E706F737D2929292C6372656174653A744D2E6372656174652C61626F76653A745B30';
wwv_flow_imp.g_varchar2_table(45830) := '5D2E61626F76652C6172726F773A742E736F6D652828653D3E652E6172726F7729297D7D29293B636C61737320694D7B636F6E7374727563746F7228652C742C6E2C692C6F297B746869732E766965773D652C746869732E736F757263653D742C746869';
wwv_flow_imp.g_varchar2_table(45831) := '732E6669656C643D6E2C746869732E736574486F7665723D692C746869732E686F76657254696D653D6F2C746869732E686F76657254696D656F75743D2D312C746869732E7265737461727454696D656F75743D2D312C746869732E70656E64696E673D';
wwv_flow_imp.g_varchar2_table(45832) := '6E756C6C2C746869732E6C6173744D6F76653D7B783A302C793A302C7461726765743A652E646F6D2C74696D653A307D2C746869732E636865636B486F7665723D746869732E636865636B486F7665722E62696E642874686973292C652E646F6D2E6164';
wwv_flow_imp.g_varchar2_table(45833) := '644576656E744C697374656E657228226D6F7573656C65617665222C746869732E6D6F7573656C656176653D746869732E6D6F7573656C656176652E62696E64287468697329292C652E646F6D2E6164644576656E744C697374656E657228226D6F7573';
wwv_flow_imp.g_varchar2_table(45834) := '656D6F7665222C746869732E6D6F7573656D6F76653D746869732E6D6F7573656D6F76652E62696E64287468697329297D75706461746528297B746869732E70656E64696E67262628746869732E70656E64696E673D6E756C6C2C636C65617254696D65';
wwv_flow_imp.g_varchar2_table(45835) := '6F757428746869732E7265737461727454696D656F7574292C746869732E7265737461727454696D656F75743D73657454696D656F7574282828293D3E746869732E7374617274486F7665722829292C323029297D6765742061637469766528297B7265';
wwv_flow_imp.g_varchar2_table(45836) := '7475726E20746869732E766965772E73746174652E6669656C6428746869732E6669656C64297D636865636B486F76657228297B696628746869732E686F76657254696D656F75743D2D312C746869732E6163746976652E6C656E677468297265747572';
wwv_flow_imp.g_varchar2_table(45837) := '6E3B6C657420653D446174652E6E6F7728292D746869732E6C6173744D6F76652E74696D653B653C746869732E686F76657254696D653F746869732E686F76657254696D656F75743D73657454696D656F757428746869732E636865636B486F7665722C';
wwv_flow_imp.g_varchar2_table(45838) := '746869732E686F76657254696D652D65293A746869732E7374617274486F76657228297D7374617274486F76657228297B636C65617254696D656F757428746869732E7265737461727454696D656F7574293B6C65747B766965773A652C6C6173744D6F';
wwv_flow_imp.g_varchar2_table(45839) := '76653A747D3D746869732C6E3D652E646F63566965772E6E65617265737428742E746172676574293B696628216E2972657475726E3B6C657420692C6F3D313B6966286E20696E7374616E63656F6620434C29693D6E2E706F73417453746172743B656C';
wwv_flow_imp.g_varchar2_table(45840) := '73657B696628693D652E706F734174436F6F7264732874292C6E756C6C3D3D692972657475726E3B6C6574206E3D652E636F6F7264734174506F732869293B696628216E7C7C742E793C6E2E746F707C7C742E793E6E2E626F74746F6D7C7C742E783C6E';
wwv_flow_imp.g_varchar2_table(45841) := '2E6C6566742D652E64656661756C7443686172616374657257696474687C7C742E783E6E2E72696768742B652E64656661756C7443686172616374657257696474682972657475726E3B6C657420733D652E626964695370616E7328652E73746174652E';
wwv_flow_imp.g_varchar2_table(45842) := '646F632E6C696E654174286929292E66696E642828653D3E652E66726F6D3C3D692626652E746F3E3D6929292C723D732626732E6469723D3D554C2E52544C3F2D313A313B6F3D742E783C6E2E6C6566743F2D723A727D6C657420733D746869732E736F';
wwv_flow_imp.g_varchar2_table(45843) := '7572636528652C692C6F293B6966286E756C6C3D3D733F766F696420303A732E7468656E297B6C657420743D746869732E70656E64696E673D7B706F733A697D3B732E7468656E28286E3D3E7B746869732E70656E64696E673D3D74262628746869732E';
wwv_flow_imp.g_varchar2_table(45844) := '70656E64696E673D6E756C6C2C216E7C7C41727261792E69734172726179286E292626216E2E6C656E6774687C7C652E6469737061746368287B656666656374733A746869732E736574486F7665722E6F662841727261792E69734172726179286E293F';
wwv_flow_imp.g_varchar2_table(45845) := '6E3A5B6E5D297D29297D292C28743D3E454428652E73746174652C742C22686F76657220746F6F6C746970222929297D656C736521737C7C41727261792E69734172726179287329262621732E6C656E6774687C7C652E6469737061746368287B656666';
wwv_flow_imp.g_varchar2_table(45846) := '656374733A746869732E736574486F7665722E6F662841727261792E697341727261792873293F733A5B735D297D297D67657420746F6F6C74697028297B6C657420653D746869732E766965772E706C7567696E285949292C743D653F652E6D616E6167';
wwv_flow_imp.g_varchar2_table(45847) := '65722E746F6F6C746970732E66696E64496E6465782828653D3E652E6372656174653D3D744D2E63726561746529293A2D313B72657475726E20743E2D313F652E6D616E616765722E746F6F6C74697056696577735B745D3A6E756C6C7D6D6F7573656D';
wwv_flow_imp.g_varchar2_table(45848) := '6F76652865297B76617220742C6E3B746869732E6C6173744D6F76653D7B783A652E636C69656E74582C793A652E636C69656E74592C7461726765743A652E7461726765742C74696D653A446174652E6E6F7728297D2C746869732E686F76657254696D';
wwv_flow_imp.g_varchar2_table(45849) := '656F75743C30262628746869732E686F76657254696D656F75743D73657454696D656F757428746869732E636865636B486F7665722C746869732E686F76657254696D6529293B6C65747B6163746976653A692C746F6F6C7469703A6F7D3D746869733B';
wwv_flow_imp.g_varchar2_table(45850) := '696628692E6C656E67746826266F26262166756E6374696F6E28652C74297B6C6574206E2C7B6C6566743A692C72696768743A6F2C746F703A732C626F74746F6D3A727D3D652E676574426F756E64696E67436C69656E745265637428293B6966286E3D';
wwv_flow_imp.g_varchar2_table(45851) := '652E717565727953656C6563746F7228222E636D2D746F6F6C7469702D6172726F772229297B6C657420653D6E2E676574426F756E64696E67436C69656E745265637428293B733D4D6174682E6D696E28652E746F702C73292C723D4D6174682E6D6178';
wwv_flow_imp.g_varchar2_table(45852) := '28652E626F74746F6D2C72297D72657475726E20742E636C69656E74583E3D692D6F4D2626742E636C69656E74583C3D6F2B6F4D2626742E636C69656E74593E3D732D6F4D2626742E636C69656E74593C3D722B6F4D7D286F2E646F6D2C65297C7C7468';
wwv_flow_imp.g_varchar2_table(45853) := '69732E70656E64696E67297B6C65747B706F733A6F7D3D695B305D7C7C746869732E70656E64696E672C733D6E756C6C213D3D286E3D6E756C6C3D3D3D28743D695B305D297C7C766F696420303D3D3D743F766F696420303A742E656E64292626766F69';
wwv_flow_imp.g_varchar2_table(45854) := '642030213D3D6E3F6E3A6F3B286F3D3D733F746869732E766965772E706F734174436F6F72647328746869732E6C6173744D6F7665293D3D6F3A66756E6374696F6E28652C742C6E2C692C6F297B6C657420733D652E7363726F6C6C444F4D2E67657442';
wwv_flow_imp.g_varchar2_table(45855) := '6F756E64696E67436C69656E745265637428292C723D652E646F63756D656E74546F702B652E646F63756D656E7450616464696E672E746F702B652E636F6E74656E744865696768743B696628732E6C6566743E697C7C732E72696768743C697C7C732E';
wwv_flow_imp.g_varchar2_table(45856) := '746F703E6F7C7C4D6174682E6D696E28732E626F74746F6D2C72293C6F2972657475726E21313B6C657420613D652E706F734174436F6F726473287B783A692C793A6F7D2C2131293B72657475726E20613E3D742626613C3D6E7D28746869732E766965';
wwv_flow_imp.g_varchar2_table(45857) := '772C6F2C732C652E636C69656E74582C652E636C69656E745929297C7C28746869732E766965772E6469737061746368287B656666656374733A746869732E736574486F7665722E6F66285B5D297D292C746869732E70656E64696E673D6E756C6C297D';
wwv_flow_imp.g_varchar2_table(45858) := '7D6D6F7573656C656176652865297B636C65617254696D656F757428746869732E686F76657254696D656F7574292C746869732E686F76657254696D656F75743D2D313B6C65747B6163746976653A747D3D746869733B696628742E6C656E677468297B';
wwv_flow_imp.g_varchar2_table(45859) := '6C65747B746F6F6C7469703A747D3D746869733B742626742E646F6D2E636F6E7461696E7328652E72656C61746564546172676574293F746869732E7761746368546F6F6C7469704C6561766528742E646F6D293A746869732E766965772E6469737061';
wwv_flow_imp.g_varchar2_table(45860) := '746368287B656666656374733A746869732E736574486F7665722E6F66285B5D297D297D7D7761746368546F6F6C7469704C656176652865297B6C657420743D6E3D3E7B652E72656D6F76654576656E744C697374656E657228226D6F7573656C656176';
wwv_flow_imp.g_varchar2_table(45861) := '65222C74292C746869732E6163746976652E6C656E677468262621746869732E766965772E646F6D2E636F6E7461696E73286E2E72656C61746564546172676574292626746869732E766965772E6469737061746368287B656666656374733A74686973';
wwv_flow_imp.g_varchar2_table(45862) := '2E736574486F7665722E6F66285B5D297D297D3B652E6164644576656E744C697374656E657228226D6F7573656C65617665222C74297D64657374726F7928297B636C65617254696D656F757428746869732E686F76657254696D656F7574292C746869';
wwv_flow_imp.g_varchar2_table(45863) := '732E766965772E646F6D2E72656D6F76654576656E744C697374656E657228226D6F7573656C65617665222C746869732E6D6F7573656C65617665292C746869732E766965772E646F6D2E72656D6F76654576656E744C697374656E657228226D6F7573';
wwv_flow_imp.g_varchar2_table(45864) := '656D6F7665222C746869732E6D6F7573656D6F7665297D7D636F6E7374206F4D3D343B66756E6374696F6E20734D28652C743D7B7D297B6C6574206E3D246B2E646566696E6528292C693D456B2E646566696E65287B6372656174653A28293D3E5B5D2C';
wwv_flow_imp.g_varchar2_table(45865) := '75706461746528652C69297B696628652E6C656E677468262628742E686964654F6E4368616E6765262628692E646F634368616E6765647C7C692E73656C656374696F6E293F653D5B5D3A742E686964654F6E262628653D652E66696C7465722828653D';
wwv_flow_imp.g_varchar2_table(45866) := '3E21742E686964654F6E28692C65292929292C692E646F634368616E67656429297B6C657420743D5B5D3B666F72286C6574206E206F662065297B6C657420653D692E6368616E6765732E6D6170506F73286E2E706F732C2D312C726B2E547261636B44';
wwv_flow_imp.g_varchar2_table(45867) := '656C293B6966286E756C6C213D65297B6C6574206F3D4F626A6563742E61737369676E284F626A6563742E637265617465286E756C6C292C6E293B6F2E706F733D652C6E756C6C213D6F2E656E642626286F2E656E643D692E6368616E6765732E6D6170';
wwv_flow_imp.g_varchar2_table(45868) := '506F73286F2E656E6429292C742E70757368286F297D7D653D747D666F72286C65742074206F6620692E6566666563747329742E6973286E29262628653D742E76616C7565292C742E697328614D29262628653D5B5D293B72657475726E20657D2C7072';
wwv_flow_imp.g_varchar2_table(45869) := '6F766964653A653D3E654D2E66726F6D2865297D293B72657475726E7B6163746976653A692C657874656E73696F6E3A5B692C49442E646566696E6528286F3D3E6E657720694D286F2C652C692C6E2C742E686F76657254696D657C7C3330302929292C';
wwv_flow_imp.g_varchar2_table(45870) := '6E4D5D7D7D66756E6374696F6E20724D28652C74297B6C6574206E3D652E706C7567696E285949293B696628216E2972657475726E206E756C6C3B6C657420693D6E2E6D616E616765722E746F6F6C746970732E696E6465784F662874293B7265747572';
wwv_flow_imp.g_varchar2_table(45871) := '6E20693C303F6E756C6C3A6E2E6D616E616765722E746F6F6C74697056696577735B695D7D636F6E737420614D3D246B2E646566696E6528292C6C4D3D5F6B2E646566696E65287B636F6D62696E652865297B6C657420742C6E3B666F72286C65742069';
wwv_flow_imp.g_varchar2_table(45872) := '206F66206529743D747C7C692E746F70436F6E7461696E65722C6E3D6E7C7C692E626F74746F6D436F6E7461696E65723B72657475726E7B746F70436F6E7461696E65723A742C626F74746F6D436F6E7461696E65723A6E7D7D7D292C634D3D49442E66';
wwv_flow_imp.g_varchar2_table(45873) := '726F6D436C61737328636C6173737B636F6E7374727563746F722865297B746869732E696E7075743D652E73746174652E666163657428754D292C746869732E73706563733D746869732E696E7075742E66696C7465722828653D3E6529292C74686973';
wwv_flow_imp.g_varchar2_table(45874) := '2E70616E656C733D746869732E73706563732E6D61702828743D3E7428652929293B6C657420743D652E73746174652E6661636574286C4D293B746869732E746F703D6E657720644D28652C21302C742E746F70436F6E7461696E6572292C746869732E';
wwv_flow_imp.g_varchar2_table(45875) := '626F74746F6D3D6E657720644D28652C21312C742E626F74746F6D436F6E7461696E6572292C746869732E746F702E73796E6328746869732E70616E656C732E66696C7465722828653D3E652E746F702929292C746869732E626F74746F6D2E73796E63';
wwv_flow_imp.g_varchar2_table(45876) := '28746869732E70616E656C732E66696C7465722828653D3E21652E746F702929293B666F72286C65742065206F6620746869732E70616E656C7329652E646F6D2E636C6173734C6973742E6164642822636D2D70616E656C22292C652E6D6F756E742626';
wwv_flow_imp.g_varchar2_table(45877) := '652E6D6F756E7428297D7570646174652865297B6C657420743D652E73746174652E6661636574286C4D293B746869732E746F702E636F6E7461696E6572213D742E746F70436F6E7461696E6572262628746869732E746F702E73796E63285B5D292C74';
wwv_flow_imp.g_varchar2_table(45878) := '6869732E746F703D6E657720644D28652E766965772C21302C742E746F70436F6E7461696E657229292C746869732E626F74746F6D2E636F6E7461696E6572213D742E626F74746F6D436F6E7461696E6572262628746869732E626F74746F6D2E73796E';
wwv_flow_imp.g_varchar2_table(45879) := '63285B5D292C746869732E626F74746F6D3D6E657720644D28652E766965772C21312C742E626F74746F6D436F6E7461696E657229292C746869732E746F702E73796E63436C617373657328292C746869732E626F74746F6D2E73796E63436C61737365';
wwv_flow_imp.g_varchar2_table(45880) := '7328293B6C6574206E3D652E73746174652E666163657428754D293B6966286E213D746869732E696E707574297B6C657420743D6E2E66696C7465722828653D3E6529292C693D5B5D2C6F3D5B5D2C733D5B5D2C723D5B5D3B666F72286C6574206E206F';
wwv_flow_imp.g_varchar2_table(45881) := '662074297B6C657420742C613D746869732E73706563732E696E6465784F66286E293B613C303F28743D6E28652E76696577292C722E70757368287429293A28743D746869732E70616E656C735B615D2C742E7570646174652626742E75706461746528';
wwv_flow_imp.g_varchar2_table(45882) := '6529292C692E707573682874292C28742E746F703F6F3A73292E707573682874297D746869732E73706563733D742C746869732E70616E656C733D692C746869732E746F702E73796E63286F292C746869732E626F74746F6D2E73796E632873293B666F';
wwv_flow_imp.g_varchar2_table(45883) := '72286C65742065206F66207229652E646F6D2E636C6173734C6973742E6164642822636D2D70616E656C22292C652E6D6F756E742626652E6D6F756E7428297D656C736520666F72286C65742074206F6620746869732E70616E656C7329742E75706461';
wwv_flow_imp.g_varchar2_table(45884) := '74652626742E7570646174652865297D64657374726F7928297B746869732E746F702E73796E63285B5D292C746869732E626F74746F6D2E73796E63285B5D297D7D2C7B70726F766964653A653D3E44492E7363726F6C6C4D617267696E732E6F662828';
wwv_flow_imp.g_varchar2_table(45885) := '743D3E7B6C6574206E3D742E706C7567696E2865293B72657475726E206E26267B746F703A6E2E746F702E7363726F6C6C4D617267696E28292C626F74746F6D3A6E2E626F74746F6D2E7363726F6C6C4D617267696E28297D7D29297D293B636C617373';
wwv_flow_imp.g_varchar2_table(45886) := '20644D7B636F6E7374727563746F7228652C742C6E297B746869732E766965773D652C746869732E746F703D742C746869732E636F6E7461696E65723D6E2C746869732E646F6D3D766F696420302C746869732E636C61737365733D22222C746869732E';
wwv_flow_imp.g_varchar2_table(45887) := '70616E656C733D5B5D2C746869732E73796E63436C617373657328297D73796E632865297B666F72286C65742074206F6620746869732E70616E656C7329742E64657374726F792626652E696E6465784F662874293C302626742E64657374726F792829';
wwv_flow_imp.g_varchar2_table(45888) := '3B746869732E70616E656C733D652C746869732E73796E63444F4D28297D73796E63444F4D28297B696628303D3D746869732E70616E656C732E6C656E6774682972657475726E20766F696428746869732E646F6D262628746869732E646F6D2E72656D';
wwv_flow_imp.g_varchar2_table(45889) := '6F766528292C746869732E646F6D3D766F6964203029293B69662821746869732E646F6D297B746869732E646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E636C6173734E616D653D74686973';
wwv_flow_imp.g_varchar2_table(45890) := '2E746F703F22636D2D70616E656C7320636D2D70616E656C732D746F70223A22636D2D70616E656C7320636D2D70616E656C732D626F74746F6D222C746869732E646F6D2E7374796C655B746869732E746F703F22746F70223A22626F74746F6D225D3D';
wwv_flow_imp.g_varchar2_table(45891) := '2230223B6C657420653D746869732E636F6E7461696E65727C7C746869732E766965772E646F6D3B652E696E736572744265666F726528746869732E646F6D2C746869732E746F703F652E66697273744368696C643A6E756C6C297D6C657420653D7468';
wwv_flow_imp.g_varchar2_table(45892) := '69732E646F6D2E66697273744368696C643B666F72286C65742074206F6620746869732E70616E656C7329696628742E646F6D2E706172656E744E6F64653D3D746869732E646F6D297B666F72283B65213D742E646F6D3B29653D684D2865293B653D65';
wwv_flow_imp.g_varchar2_table(45893) := '2E6E6578745369626C696E677D656C736520746869732E646F6D2E696E736572744265666F726528742E646F6D2C65293B666F72283B653B29653D684D2865297D7363726F6C6C4D617267696E28297B72657475726E21746869732E646F6D7C7C746869';
wwv_flow_imp.g_varchar2_table(45894) := '732E636F6E7461696E65723F303A4D6174682E6D617828302C746869732E746F703F746869732E646F6D2E676574426F756E64696E67436C69656E745265637428292E626F74746F6D2D4D6174682E6D617828302C746869732E766965772E7363726F6C';
wwv_flow_imp.g_varchar2_table(45895) := '6C444F4D2E676574426F756E64696E67436C69656E745265637428292E746F70293A4D6174682E6D696E28696E6E65724865696768742C746869732E766965772E7363726F6C6C444F4D2E676574426F756E64696E67436C69656E745265637428292E62';
wwv_flow_imp.g_varchar2_table(45896) := '6F74746F6D292D746869732E646F6D2E676574426F756E64696E67436C69656E745265637428292E746F70297D73796E63436C617373657328297B696628746869732E636F6E7461696E65722626746869732E636C6173736573213D746869732E766965';
wwv_flow_imp.g_varchar2_table(45897) := '772E7468656D65436C6173736573297B666F72286C65742065206F6620746869732E636C61737365732E73706C6974282220222929652626746869732E636F6E7461696E65722E636C6173734C6973742E72656D6F76652865293B666F72286C65742065';
wwv_flow_imp.g_varchar2_table(45898) := '206F6628746869732E636C61737365733D746869732E766965772E7468656D65436C6173736573292E73706C6974282220222929652626746869732E636F6E7461696E65722E636C6173734C6973742E6164642865297D7D7D66756E6374696F6E20684D';
wwv_flow_imp.g_varchar2_table(45899) := '2865297B6C657420743D652E6E6578745369626C696E673B72657475726E20652E72656D6F766528292C747D636F6E737420754D3D5F6B2E646566696E65287B656E61626C65733A634D7D293B636C61737320704D20657874656E6473206F457B636F6D';
wwv_flow_imp.g_varchar2_table(45900) := '706172652865297B72657475726E20746869733D3D657C7C746869732E636F6E7374727563746F723D3D652E636F6E7374727563746F722626746869732E65712865297D65712865297B72657475726E21317D64657374726F792865297B7D7D704D2E70';
wwv_flow_imp.g_varchar2_table(45901) := '726F746F747970652E656C656D656E74436C6173733D22222C704D2E70726F746F747970652E746F444F4D3D766F696420302C704D2E70726F746F747970652E6D61704D6F64653D726B2E547261636B4265666F72652C704D2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(45902) := '7374617274536964653D704D2E70726F746F747970652E656E64536964653D2D312C704D2E70726F746F747970652E706F696E743D21303B636F6E737420674D3D5F6B2E646566696E6528292C6D4D3D5F6B2E646566696E6528292C664D3D5F6B2E6465';
wwv_flow_imp.g_varchar2_table(45903) := '66696E6528292C764D3D5F6B2E646566696E65287B636F6D62696E653A653D3E652E736F6D652828653D3E6529297D293B66756E6374696F6E20624D2865297B6C657420743D5B5F4D5D3B72657475726E2065262621313D3D3D652E6669786564262674';
wwv_flow_imp.g_varchar2_table(45904) := '2E7075736828764D2E6F6628213029292C747D636F6E7374205F4D3D49442E66726F6D436C61737328636C6173737B636F6E7374727563746F722865297B746869732E766965773D652C746869732E7072657656696577706F72743D652E76696577706F';
wwv_flow_imp.g_varchar2_table(45905) := '72742C746869732E646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E636C6173734E616D653D22636D2D67757474657273222C746869732E646F6D2E7365744174747269627574652822617269';
wwv_flow_imp.g_varchar2_table(45906) := '612D68696464656E222C227472756522292C746869732E646F6D2E7374796C652E6D696E4865696768743D746869732E766965772E636F6E74656E744865696768742F746869732E766965772E7363616C65592B227078222C746869732E677574746572';
wwv_flow_imp.g_varchar2_table(45907) := '733D652E73746174652E666163657428664D292E6D61702828743D3E6E657720534D28652C742929293B666F72286C65742065206F6620746869732E6775747465727329746869732E646F6D2E617070656E644368696C6428652E646F6D293B74686973';
wwv_flow_imp.g_varchar2_table(45908) := '2E66697865643D21652E73746174652E666163657428764D292C746869732E6669786564262628746869732E646F6D2E7374796C652E706F736974696F6E3D22737469636B7922292C746869732E73796E6347757474657273282131292C652E7363726F';
wwv_flow_imp.g_varchar2_table(45909) := '6C6C444F4D2E696E736572744265666F726528746869732E646F6D2C652E636F6E74656E74444F4D297D7570646174652865297B696628746869732E75706461746547757474657273286529297B6C657420743D746869732E7072657656696577706F72';
wwv_flow_imp.g_varchar2_table(45910) := '742C6E3D652E766965772E76696577706F72742C693D4D6174682E6D696E28742E746F2C6E2E746F292D4D6174682E6D617828742E66726F6D2C6E2E66726F6D293B746869732E73796E634775747465727328693C2E382A286E2E746F2D6E2E66726F6D';
wwv_flow_imp.g_varchar2_table(45911) := '29297D652E67656F6D657472794368616E676564262628746869732E646F6D2E7374796C652E6D696E4865696768743D746869732E766965772E636F6E74656E744865696768742F746869732E766965772E7363616C65592B22707822292C746869732E';
wwv_flow_imp.g_varchar2_table(45912) := '766965772E73746174652E666163657428764D29213D21746869732E6669786564262628746869732E66697865643D21746869732E66697865642C746869732E646F6D2E7374796C652E706F736974696F6E3D746869732E66697865643F22737469636B';
wwv_flow_imp.g_varchar2_table(45913) := '79223A2222292C746869732E7072657656696577706F72743D652E766965772E76696577706F72747D73796E63477574746572732865297B6C657420743D746869732E646F6D2E6E6578745369626C696E673B652626746869732E646F6D2E72656D6F76';
wwv_flow_imp.g_varchar2_table(45914) := '6528293B6C6574206E3D6C452E6974657228746869732E766965772E73746174652E666163657428674D292C746869732E766965772E76696577706F72742E66726F6D292C693D5B5D2C6F3D746869732E677574746572732E6D61702828653D3E6E6577';
wwv_flow_imp.g_varchar2_table(45915) := '20434D28652C746869732E766965772E76696577706F72742C2D746869732E766965772E646F63756D656E7450616464696E672E746F702929293B666F72286C65742065206F6620746869732E766965772E76696577706F72744C696E65426C6F636B73';
wwv_flow_imp.g_varchar2_table(45916) := '29696628692E6C656E677468262628693D5B5D292C41727261792E6973417272617928652E7479706529297B6C657420743D21303B666F72286C65742073206F6620652E7479706529696628732E747970653D3D4E4C2E54657874262674297B774D286E';
wwv_flow_imp.g_varchar2_table(45917) := '2C692C732E66726F6D293B666F72286C65742065206F66206F29652E6C696E6528746869732E766965772C732C69293B743D21317D656C736520696628732E77696467657429666F72286C65742065206F66206F29652E77696467657428746869732E76';
wwv_flow_imp.g_varchar2_table(45918) := '6965772C73297D656C736520696628652E747970653D3D4E4C2E54657874297B774D286E2C692C652E66726F6D293B666F72286C65742074206F66206F29742E6C696E6528746869732E766965772C652C69297D656C736520696628652E776964676574';
wwv_flow_imp.g_varchar2_table(45919) := '29666F72286C65742074206F66206F29742E77696467657428746869732E766965772C65293B666F72286C65742065206F66206F29652E66696E69736828293B652626746869732E766965772E7363726F6C6C444F4D2E696E736572744265666F726528';
wwv_flow_imp.g_varchar2_table(45920) := '746869732E646F6D2C74297D757064617465477574746572732865297B6C657420743D652E737461727453746174652E666163657428664D292C6E3D652E73746174652E666163657428664D292C693D652E646F634368616E6765647C7C652E68656967';
wwv_flow_imp.g_varchar2_table(45921) := '68744368616E6765647C7C652E76696577706F72744368616E6765647C7C216C452E657128652E737461727453746174652E666163657428674D292C652E73746174652E666163657428674D292C652E766965772E76696577706F72742E66726F6D2C65';
wwv_flow_imp.g_varchar2_table(45922) := '2E766965772E76696577706F72742E746F293B696628743D3D6E29666F72286C65742074206F6620746869732E6775747465727329742E757064617465286529262628693D2130293B656C73657B693D21303B6C6574206F3D5B5D3B666F72286C657420';
wwv_flow_imp.g_varchar2_table(45923) := '69206F66206E297B6C6574206E3D742E696E6465784F662869293B6E3C303F6F2E70757368286E657720534D28746869732E766965772C6929293A28746869732E677574746572735B6E5D2E7570646174652865292C6F2E7075736828746869732E6775';
wwv_flow_imp.g_varchar2_table(45924) := '74746572735B6E5D29297D666F72286C65742065206F6620746869732E6775747465727329652E646F6D2E72656D6F766528292C6F2E696E6465784F662865293C302626652E64657374726F7928293B666F72286C65742065206F66206F29746869732E';
wwv_flow_imp.g_varchar2_table(45925) := '646F6D2E617070656E644368696C6428652E646F6D293B746869732E677574746572733D6F7D72657475726E20697D64657374726F7928297B666F72286C65742065206F6620746869732E6775747465727329652E64657374726F7928293B746869732E';
wwv_flow_imp.g_varchar2_table(45926) := '646F6D2E72656D6F766528297D7D2C7B70726F766964653A653D3E44492E7363726F6C6C4D617267696E732E6F662828743D3E7B6C6574206E3D742E706C7567696E2865293B72657475726E206E262630213D6E2E677574746572732E6C656E67746826';
wwv_flow_imp.g_varchar2_table(45927) := '266E2E66697865643F742E74657874446972656374696F6E3D3D554C2E4C54523F7B6C6566743A6E2E646F6D2E6F666673657457696474682A742E7363616C65587D3A7B72696768743A6E2E646F6D2E6F666673657457696474682A742E7363616C6558';
wwv_flow_imp.g_varchar2_table(45928) := '7D3A6E756C6C7D29297D293B66756E6374696F6E20794D2865297B72657475726E2041727261792E697341727261792865293F653A5B655D7D66756E6374696F6E20774D28652C742C6E297B666F72283B652E76616C75652626652E66726F6D3C3D6E3B';
wwv_flow_imp.g_varchar2_table(45929) := '29652E66726F6D3D3D6E2626742E7075736828652E76616C7565292C652E6E65787428297D636C61737320434D7B636F6E7374727563746F7228652C742C6E297B746869732E6775747465723D652C746869732E6865696768743D6E2C746869732E693D';
wwv_flow_imp.g_varchar2_table(45930) := '302C746869732E637572736F723D6C452E6974657228652E6D61726B6572732C742E66726F6D297D616464456C656D656E7428652C742C6E297B6C65747B6775747465723A697D3D746869732C6F3D28742E746F702D746869732E686569676874292F65';
wwv_flow_imp.g_varchar2_table(45931) := '2E7363616C65592C733D742E6865696768742F652E7363616C65593B696628746869732E693D3D692E656C656D656E74732E6C656E677468297B6C657420743D6E657720784D28652C732C6F2C6E293B692E656C656D656E74732E707573682874292C69';
wwv_flow_imp.g_varchar2_table(45932) := '2E646F6D2E617070656E644368696C6428742E646F6D297D656C736520692E656C656D656E74735B746869732E695D2E75706461746528652C732C6F2C6E293B746869732E6865696768743D742E626F74746F6D2C746869732E692B2B7D6C696E652865';
wwv_flow_imp.g_varchar2_table(45933) := '2C742C6E297B6C657420693D5B5D3B774D28746869732E637572736F722C692C742E66726F6D292C6E2E6C656E677468262628693D692E636F6E636174286E29293B6C6574206F3D746869732E6775747465722E636F6E6669672E6C696E654D61726B65';
wwv_flow_imp.g_varchar2_table(45934) := '7228652C742C69293B6F2626692E756E7368696674286F293B6C657420733D746869732E6775747465723B2830213D692E6C656E6774687C7C732E636F6E6669672E72656E646572456D707479456C656D656E7473292626746869732E616464456C656D';
wwv_flow_imp.g_varchar2_table(45935) := '656E7428652C742C69297D77696467657428652C74297B6C6574206E3D746869732E6775747465722E636F6E6669672E7769646765744D61726B657228652C742E7769646765742C74292C693D6E3F5B6E5D3A6E756C6C3B666F72286C6574206E206F66';
wwv_flow_imp.g_varchar2_table(45936) := '20652E73746174652E6661636574286D4D29297B6C6574206F3D6E28652C742E7769646765742C74293B6F262628697C7C28693D5B5D29292E70757368286F297D692626746869732E616464456C656D656E7428652C742C69297D66696E69736828297B';
wwv_flow_imp.g_varchar2_table(45937) := '6C657420653D746869732E6775747465723B666F72283B652E656C656D656E74732E6C656E6774683E746869732E693B297B6C657420743D652E656C656D656E74732E706F7028293B652E646F6D2E72656D6F76654368696C6428742E646F6D292C742E';
wwv_flow_imp.g_varchar2_table(45938) := '64657374726F7928297D7D7D636C61737320534D7B636F6E7374727563746F7228652C74297B746869732E766965773D652C746869732E636F6E6669673D742C746869732E656C656D656E74733D5B5D2C746869732E7370616365723D6E756C6C2C7468';
wwv_flow_imp.g_varchar2_table(45939) := '69732E646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E636C6173734E616D653D22636D2D677574746572222B28746869732E636F6E6669672E636C6173733F2220222B746869732E636F6E66';
wwv_flow_imp.g_varchar2_table(45940) := '69672E636C6173733A2222293B666F72286C6574206E20696E20742E646F6D4576656E7448616E646C65727329746869732E646F6D2E6164644576656E744C697374656E6572286E2C28693D3E7B6C6574206F2C733D692E7461726765743B6966287321';
wwv_flow_imp.g_varchar2_table(45941) := '3D746869732E646F6D2626746869732E646F6D2E636F6E7461696E73287329297B666F72283B732E706172656E744E6F6465213D746869732E646F6D3B29733D732E706172656E744E6F64653B6C657420653D732E676574426F756E64696E67436C6965';
wwv_flow_imp.g_varchar2_table(45942) := '6E745265637428293B6F3D28652E746F702B652E626F74746F6D292F327D656C7365206F3D692E636C69656E74593B6C657420723D652E6C696E65426C6F636B4174486569676874286F2D652E646F63756D656E74546F70293B742E646F6D4576656E74';
wwv_flow_imp.g_varchar2_table(45943) := '48616E646C6572735B6E5D28652C722C69292626692E70726576656E7444656661756C7428297D29293B746869732E6D61726B6572733D794D28742E6D61726B657273286529292C742E696E697469616C537061636572262628746869732E7370616365';
wwv_flow_imp.g_varchar2_table(45944) := '723D6E657720784D28652C302C302C5B742E696E697469616C5370616365722865295D292C746869732E646F6D2E617070656E644368696C6428746869732E7370616365722E646F6D292C746869732E7370616365722E646F6D2E7374796C652E637373';
wwv_flow_imp.g_varchar2_table(45945) := '546578742B3D227669736962696C6974793A2068696464656E3B20706F696E7465722D6576656E74733A206E6F6E6522297D7570646174652865297B6C657420743D746869732E6D61726B6572733B696628746869732E6D61726B6572733D794D287468';
wwv_flow_imp.g_varchar2_table(45946) := '69732E636F6E6669672E6D61726B65727328652E7669657729292C746869732E7370616365722626746869732E636F6E6669672E757064617465537061636572297B6C657420743D746869732E636F6E6669672E75706461746553706163657228746869';
wwv_flow_imp.g_varchar2_table(45947) := '732E7370616365722E6D61726B6572735B305D2C65293B74213D746869732E7370616365722E6D61726B6572735B305D2626746869732E7370616365722E75706461746528652E766965772C302C302C5B745D297D6C6574206E3D652E766965772E7669';
wwv_flow_imp.g_varchar2_table(45948) := '6577706F72743B72657475726E216C452E657128746869732E6D61726B6572732C742C6E2E66726F6D2C6E2E746F297C7C2121746869732E636F6E6669672E6C696E654D61726B65724368616E67652626746869732E636F6E6669672E6C696E654D6172';
wwv_flow_imp.g_varchar2_table(45949) := '6B65724368616E67652865297D64657374726F7928297B666F72286C65742065206F6620746869732E656C656D656E747329652E64657374726F7928297D7D636C61737320784D7B636F6E7374727563746F7228652C742C6E2C69297B746869732E6865';
wwv_flow_imp.g_varchar2_table(45950) := '696768743D2D312C746869732E61626F76653D302C746869732E6D61726B6572733D5B5D2C746869732E646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E636C6173734E616D653D22636D2D67';
wwv_flow_imp.g_varchar2_table(45951) := '7574746572456C656D656E74222C746869732E75706461746528652C742C6E2C69297D75706461746528652C742C6E2C69297B746869732E686569676874213D74262628746869732E6865696768743D742C746869732E646F6D2E7374796C652E686569';
wwv_flow_imp.g_varchar2_table(45952) := '6768743D742B22707822292C746869732E61626F7665213D6E262628746869732E646F6D2E7374796C652E6D617267696E546F703D28746869732E61626F76653D6E293F6E2B227078223A2222292C66756E6374696F6E28652C74297B696628652E6C65';
wwv_flow_imp.g_varchar2_table(45953) := '6E677468213D742E6C656E6774682972657475726E21313B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B2B2969662821655B6E5D2E636F6D7061726528745B6E5D292972657475726E21313B72657475726E21307D28746869732E6D61';
wwv_flow_imp.g_varchar2_table(45954) := '726B6572732C69297C7C746869732E7365744D61726B65727328652C69297D7365744D61726B65727328652C74297B6C6574206E3D22636D2D677574746572456C656D656E74222C693D746869732E646F6D2E66697273744368696C643B666F72286C65';
wwv_flow_imp.g_varchar2_table(45955) := '74206F3D302C733D303B3B297B6C657420723D732C613D6F3C742E6C656E6774683F745B6F2B2B5D3A6E756C6C2C6C3D21313B69662861297B6C657420653D612E656C656D656E74436C6173733B652626286E2B3D2220222B65293B666F72286C657420';
wwv_flow_imp.g_varchar2_table(45956) := '653D733B653C746869732E6D61726B6572732E6C656E6774683B652B2B29696628746869732E6D61726B6572735B655D2E636F6D70617265286129297B723D652C6C3D21303B627265616B7D7D656C736520723D746869732E6D61726B6572732E6C656E';
wwv_flow_imp.g_varchar2_table(45957) := '6774683B666F72283B733C723B297B6C657420653D746869732E6D61726B6572735B732B2B5D3B696628652E746F444F4D297B652E64657374726F792869293B6C657420743D692E6E6578745369626C696E673B692E72656D6F766528292C693D747D7D';
wwv_flow_imp.g_varchar2_table(45958) := '696628216129627265616B3B612E746F444F4D2626286C3F693D692E6E6578745369626C696E673A746869732E646F6D2E696E736572744265666F726528612E746F444F4D2865292C6929292C6C2626732B2B7D746869732E646F6D2E636C6173734E61';
wwv_flow_imp.g_varchar2_table(45959) := '6D653D6E2C746869732E6D61726B6572733D747D64657374726F7928297B746869732E7365744D61726B657273286E756C6C2C5B5D297D7D636F6E7374206B4D3D5F6B2E646566696E6528292C454D3D5F6B2E646566696E6528292C4C4D3D5F6B2E6465';
wwv_flow_imp.g_varchar2_table(45960) := '66696E65287B636F6D62696E653A653D3E694528652C7B666F726D61744E756D6265723A537472696E672C646F6D4576656E7448616E646C6572733A7B7D7D2C7B646F6D4576656E7448616E646C65727328652C74297B6C6574206E3D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(45961) := '61737369676E287B7D2C65293B666F72286C6574206520696E2074297B6C657420693D6E5B655D2C6F3D745B655D3B6E5B655D3D693F28652C742C6E293D3E6928652C742C6E297C7C6F28652C742C6E293A6F7D72657475726E206E7D7D297D293B636C';
wwv_flow_imp.g_varchar2_table(45962) := '61737320444D20657874656E647320704D7B636F6E7374727563746F722865297B737570657228292C746869732E6E756D6265723D657D65712865297B72657475726E20746869732E6E756D6265723D3D652E6E756D6265727D746F444F4D28297B7265';
wwv_flow_imp.g_varchar2_table(45963) := '7475726E20646F63756D656E742E637265617465546578744E6F646528746869732E6E756D626572297D7D66756E6374696F6E20544D28652C74297B72657475726E20652E73746174652E6661636574284C4D292E666F726D61744E756D62657228742C';
wwv_flow_imp.g_varchar2_table(45964) := '652E7374617465297D636F6E737420494D3D664D2E636F6D70757465285B4C4D5D2C28653D3E287B636C6173733A22636D2D6C696E654E756D62657273222C72656E646572456D707479456C656D656E74733A21312C6D61726B6572733A653D3E652E73';
wwv_flow_imp.g_varchar2_table(45965) := '746174652E6661636574286B4D292C6C696E654D61726B65723A28652C742C6E293D3E6E2E736F6D652828653D3E652E746F444F4D29293F6E756C6C3A6E657720444D28544D28652C652E73746174652E646F632E6C696E65417428742E66726F6D292E';
wwv_flow_imp.g_varchar2_table(45966) := '6E756D62657229292C7769646765744D61726B65723A28652C742C6E293D3E7B666F72286C65742069206F6620652E73746174652E666163657428454D29297B6C6574206F3D6928652C742C6E293B6966286F2972657475726E206F7D72657475726E20';
wwv_flow_imp.g_varchar2_table(45967) := '6E756C6C7D2C6C696E654D61726B65724368616E67653A653D3E652E737461727453746174652E6661636574284C4D29213D652E73746174652E6661636574284C4D292C696E697469616C5370616365723A653D3E6E657720444D28544D28652C414D28';
wwv_flow_imp.g_varchar2_table(45968) := '652E73746174652E646F632E6C696E65732929292C75706461746553706163657228652C74297B6C6574206E3D544D28742E766965772C414D28742E766965772E73746174652E646F632E6C696E657329293B72657475726E206E3D3D652E6E756D6265';
wwv_flow_imp.g_varchar2_table(45969) := '723F653A6E657720444D286E297D2C646F6D4576656E7448616E646C6572733A652E6661636574284C4D292E646F6D4576656E7448616E646C6572737D2929293B66756E6374696F6E204D4D28653D7B7D297B72657475726E5B4C4D2E6F662865292C62';
wwv_flow_imp.g_varchar2_table(45970) := '4D28292C494D5D7D66756E6374696F6E20414D2865297B6C657420743D393B666F72283B743C653B29743D31302A742B393B72657475726E20747D766172204E4D3B636F6E737420504D3D6E65772058433B636F6E7374204F4D3D6E65772058433B636C';
wwv_flow_imp.g_varchar2_table(45971) := '61737320524D7B636F6E7374727563746F7228652C742C6E3D5B5D2C693D2222297B746869732E646174613D652C746869732E6E616D653D692C6E452E70726F746F747970652E6861734F776E50726F706572747928227472656522297C7C4F626A6563';
wwv_flow_imp.g_varchar2_table(45972) := '742E646566696E6550726F7065727479286E452E70726F746F747970652C2274726565222C7B67657428297B72657475726E20564D2874686973297D7D292C746869732E7061727365723D742C746869732E657874656E73696F6E3D5B474D2E6F662874';
wwv_flow_imp.g_varchar2_table(45973) := '686973292C6E452E6C616E6775616765446174612E6F66282828652C742C6E293D3E7B6C657420693D464D28652C742C6E292C6F3D692E747970652E70726F7028504D293B696628216F2972657475726E5B5D3B6C657420733D652E6661636574286F29';
wwv_flow_imp.g_varchar2_table(45974) := '2C723D692E747970652E70726F70284F4D293B69662872297B6C6574206F3D692E7265736F6C766528742D692E66726F6D2C6E293B666F72286C65742074206F66207229696628742E74657374286F2C6529297B6C6574206E3D652E666163657428742E';
wwv_flow_imp.g_varchar2_table(45975) := '6661636574293B72657475726E227265706C616365223D3D742E747970653F6E3A6E2E636F6E6361742873297D7D72657475726E20737D29295D2E636F6E636174286E297D6973416374697665417428652C742C6E3D2D31297B72657475726E20464D28';
wwv_flow_imp.g_varchar2_table(45976) := '652C742C6E292E747970652E70726F7028504D293D3D746869732E646174617D66696E64526567696F6E732865297B6C657420743D652E666163657428474D293B696628286E756C6C3D3D743F766F696420303A742E64617461293D3D746869732E6461';
wwv_flow_imp.g_varchar2_table(45977) := '74612972657475726E5B7B66726F6D3A302C746F3A652E646F632E6C656E6774687D5D3B69662821747C7C21742E616C6C6F77734E657374696E672972657475726E5B5D3B6C6574206E3D5B5D2C693D28652C74293D3E7B696628652E70726F7028504D';
wwv_flow_imp.g_varchar2_table(45978) := '293D3D746869732E646174612972657475726E20766F6964206E2E70757368287B66726F6D3A742C746F3A742B652E6C656E6774687D293B6C6574206F3D652E70726F702858432E6D6F756E746564293B6966286F297B6966286F2E747265652E70726F';
wwv_flow_imp.g_varchar2_table(45979) := '7028504D293D3D746869732E64617461297B6966286F2E6F7665726C617929666F72286C65742065206F66206F2E6F7665726C6179296E2E70757368287B66726F6D3A652E66726F6D2B742C746F3A652E746F2B747D293B656C7365206E2E7075736828';
wwv_flow_imp.g_varchar2_table(45980) := '7B66726F6D3A742C746F3A742B652E6C656E6774687D293B72657475726E7D6966286F2E6F7665726C6179297B6C657420653D6E2E6C656E6774683B69662869286F2E747265652C6F2E6F7665726C61795B305D2E66726F6D2B74292C6E2E6C656E6774';
wwv_flow_imp.g_varchar2_table(45981) := '683E652972657475726E7D7D666F72286C6574206E3D303B6E3C652E6368696C6472656E2E6C656E6774683B6E2B2B297B6C6574206F3D652E6368696C6472656E5B6E5D3B6F20696E7374616E63656F66207253262669286F2C652E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(45982) := '735B6E5D2B74297D7D3B72657475726E206928564D2865292C30292C6E7D67657420616C6C6F77734E657374696E6728297B72657475726E21307D7D66756E6374696F6E20464D28652C742C6E297B6C657420693D652E666163657428474D292C6F3D56';
wwv_flow_imp.g_varchar2_table(45983) := '4D2865292E746F704E6F64653B69662821697C7C692E616C6C6F77734E657374696E6729666F72286C657420653D6F3B653B653D652E656E74657228742C6E2C73532E4578636C756465427566666572732929652E747970652E6973546F702626286F3D';
wwv_flow_imp.g_varchar2_table(45984) := '65293B72657475726E206F7D524D2E73657453746174653D246B2E646566696E6528293B636C61737320424D20657874656E647320524D7B636F6E7374727563746F7228652C742C6E297B737570657228652C742C5B5D2C6E292C746869732E70617273';
wwv_flow_imp.g_varchar2_table(45985) := '65723D747D73746174696320646566696E652865297B6C657420743D286E3D652E6C616E6775616765446174612C5F6B2E646566696E65287B636F6D62696E653A6E3F653D3E652E636F6E636174286E293A766F696420307D29293B766172206E3B7265';
wwv_flow_imp.g_varchar2_table(45986) := '7475726E206E657720424D28742C652E7061727365722E636F6E666967757265287B70726F70733A5B504D2E6164642828653D3E652E6973546F703F743A766F6964203029295D7D292C652E6E616D65297D636F6E66696775726528652C74297B726574';
wwv_flow_imp.g_varchar2_table(45987) := '75726E206E657720424D28746869732E646174612C746869732E7061727365722E636F6E6669677572652865292C747C7C746869732E6E616D65297D67657420616C6C6F77734E657374696E6728297B72657475726E20746869732E7061727365722E68';
wwv_flow_imp.g_varchar2_table(45988) := '6173577261707065727328297D7D66756E6374696F6E20564D2865297B6C657420743D652E6669656C6428524D2E73746174652C2131293B72657475726E20743F742E747265653A72532E656D7074797D636C617373207A4D7B636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(45989) := '722865297B746869732E646F633D652C746869732E637572736F72506F733D302C746869732E737472696E673D22222C746869732E637572736F723D652E6974657228297D676574206C656E67746828297B72657475726E20746869732E646F632E6C65';
wwv_flow_imp.g_varchar2_table(45990) := '6E6774687D73796E63546F2865297B72657475726E20746869732E737472696E673D746869732E637572736F722E6E65787428652D746869732E637572736F72506F73292E76616C75652C746869732E637572736F72506F733D652B746869732E737472';
wwv_flow_imp.g_varchar2_table(45991) := '696E672E6C656E6774682C746869732E637572736F72506F732D746869732E737472696E672E6C656E6774687D6368756E6B2865297B72657475726E20746869732E73796E63546F2865292C746869732E737472696E677D676574206C696E654368756E';
wwv_flow_imp.g_varchar2_table(45992) := '6B7328297B72657475726E21307D7265616428652C74297B6C6574206E3D746869732E637572736F72506F732D746869732E737472696E672E6C656E6774683B72657475726E20653C6E7C7C743E3D746869732E637572736F72506F733F746869732E64';
wwv_flow_imp.g_varchar2_table(45993) := '6F632E736C696365537472696E6728652C74293A746869732E737472696E672E736C69636528652D6E2C742D6E297D7D6C657420484D3D6E756C6C3B636C61737320574D7B636F6E7374727563746F7228652C742C6E3D5B5D2C692C6F2C732C722C6129';
wwv_flow_imp.g_varchar2_table(45994) := '7B746869732E7061727365723D652C746869732E73746174653D742C746869732E667261676D656E74733D6E2C746869732E747265653D692C746869732E747265654C656E3D6F2C746869732E76696577706F72743D732C746869732E736B6970706564';
wwv_flow_imp.g_varchar2_table(45995) := '3D722C746869732E7363686564756C654F6E3D612C746869732E70617273653D6E756C6C2C746869732E74656D70536B69707065643D5B5D7D7374617469632063726561746528652C742C6E297B72657475726E206E657720574D28652C742C5B5D2C72';
wwv_flow_imp.g_varchar2_table(45996) := '532E656D7074792C302C6E2C5B5D2C6E756C6C297D7374617274506172736528297B72657475726E20746869732E7061727365722E73746172745061727365286E6577207A4D28746869732E73746174652E646F63292C746869732E667261676D656E74';
wwv_flow_imp.g_varchar2_table(45997) := '73297D776F726B28652C74297B72657475726E206E756C6C213D742626743E3D746869732E73746174652E646F632E6C656E677468262628743D766F69642030292C746869732E74726565213D72532E656D7074792626746869732E6973446F6E65286E';
wwv_flow_imp.g_varchar2_table(45998) := '756C6C213D743F743A746869732E73746174652E646F632E6C656E677468293F28746869732E74616B655472656528292C2130293A746869732E77697468436F6E74657874282828293D3E7B766172206E3B696628226E756D626572223D3D747970656F';
wwv_flow_imp.g_varchar2_table(45999) := '662065297B6C657420743D446174652E6E6F7728292B653B653D28293D3E446174652E6E6F7728293E747D666F7228746869732E70617273657C7C28746869732E70617273653D746869732E737461727450617273652829292C6E756C6C213D74262628';
wwv_flow_imp.g_varchar2_table(46000) := '6E756C6C3D3D746869732E70617273652E73746F7070656441747C7C746869732E70617273652E73746F7070656441743E74292626743C746869732E73746174652E646F632E6C656E6774682626746869732E70617273652E73746F7041742874293B3B';
wwv_flow_imp.g_varchar2_table(46001) := '297B6C657420693D746869732E70617273652E616476616E636528293B69662869297B696628746869732E667261676D656E74733D746869732E776974686F757454656D70536B69707065642878532E6164645472656528692C746869732E667261676D';
wwv_flow_imp.g_varchar2_table(46002) := '656E74732C6E756C6C213D746869732E70617273652E73746F70706564417429292C746869732E747265654C656E3D6E756C6C213D3D286E3D746869732E70617273652E73746F707065644174292626766F69642030213D3D6E3F6E3A746869732E7374';
wwv_flow_imp.g_varchar2_table(46003) := '6174652E646F632E6C656E6774682C746869732E747265653D692C746869732E70617273653D6E756C6C2C2128746869732E747265654C656E3C286E756C6C213D743F743A746869732E73746174652E646F632E6C656E67746829292972657475726E21';
wwv_flow_imp.g_varchar2_table(46004) := '303B746869732E70617273653D746869732E7374617274506172736528297D6966286528292972657475726E21317D7D29297D74616B655472656528297B6C657420652C743B746869732E7061727365262628653D746869732E70617273652E70617273';
wwv_flow_imp.g_varchar2_table(46005) := '6564506F73293E3D746869732E747265654C656E262628286E756C6C3D3D746869732E70617273652E73746F7070656441747C7C746869732E70617273652E73746F7070656441743E65292626746869732E70617273652E73746F7041742865292C7468';
wwv_flow_imp.g_varchar2_table(46006) := '69732E77697468436F6E74657874282828293D3E7B666F72283B2128743D746869732E70617273652E616476616E63652829293B293B7D29292C746869732E747265654C656E3D652C746869732E747265653D742C746869732E667261676D656E74733D';
wwv_flow_imp.g_varchar2_table(46007) := '746869732E776974686F757454656D70536B69707065642878532E6164645472656528746869732E747265652C746869732E667261676D656E74732C213029292C746869732E70617273653D6E756C6C297D77697468436F6E746578742865297B6C6574';
wwv_flow_imp.g_varchar2_table(46008) := '20743D484D3B484D3D746869733B7472797B72657475726E206528297D66696E616C6C797B484D3D747D7D776974686F757454656D70536B69707065642865297B666F72286C657420743B743D746869732E74656D70536B69707065642E706F7028293B';
wwv_flow_imp.g_varchar2_table(46009) := '29653D6A4D28652C742E66726F6D2C742E746F293B72657475726E20657D6368616E67657328652C74297B6C65747B667261676D656E74733A6E2C747265653A692C747265654C656E3A6F2C76696577706F72743A732C736B69707065643A727D3D7468';
wwv_flow_imp.g_varchar2_table(46010) := '69733B696628746869732E74616B655472656528292C21652E656D707479297B6C657420743D5B5D3B696628652E697465724368616E67656452616E676573282828652C6E2C692C6F293D3E742E70757368287B66726F6D413A652C746F413A6E2C6672';
wwv_flow_imp.g_varchar2_table(46011) := '6F6D423A692C746F423A6F7D2929292C6E3D78532E6170706C794368616E676573286E2C74292C693D72532E656D7074792C6F3D302C733D7B66726F6D3A652E6D6170506F7328732E66726F6D2C2D31292C746F3A652E6D6170506F7328732E746F2C31';
wwv_flow_imp.g_varchar2_table(46012) := '297D2C746869732E736B69707065642E6C656E677468297B723D5B5D3B666F72286C65742074206F6620746869732E736B6970706564297B6C6574206E3D652E6D6170506F7328742E66726F6D2C31292C693D652E6D6170506F7328742E746F2C2D3129';
wwv_flow_imp.g_varchar2_table(46013) := '3B6E3C692626722E70757368287B66726F6D3A6E2C746F3A697D297D7D7D72657475726E206E657720574D28746869732E7061727365722C742C6E2C692C6F2C732C722C746869732E7363686564756C654F6E297D75706461746556696577706F727428';
wwv_flow_imp.g_varchar2_table(46014) := '65297B696628746869732E76696577706F72742E66726F6D3D3D652E66726F6D2626746869732E76696577706F72742E746F3D3D652E746F2972657475726E21313B746869732E76696577706F72743D653B6C657420743D746869732E736B6970706564';
wwv_flow_imp.g_varchar2_table(46015) := '2E6C656E6774683B666F72286C657420743D303B743C746869732E736B69707065642E6C656E6774683B742B2B297B6C65747B66726F6D3A6E2C746F3A697D3D746869732E736B69707065645B745D3B6E3C652E746F2626693E652E66726F6D26262874';
wwv_flow_imp.g_varchar2_table(46016) := '6869732E667261676D656E74733D6A4D28746869732E667261676D656E74732C6E2C69292C746869732E736B69707065642E73706C69636528742D2D2C3129297D72657475726E2128746869732E736B69707065642E6C656E6774683E3D747C7C287468';
wwv_flow_imp.g_varchar2_table(46017) := '69732E726573657428292C3029297D726573657428297B746869732E7061727365262628746869732E74616B655472656528292C746869732E70617273653D6E756C6C297D736B6970556E74696C496E5669657728652C74297B746869732E736B697070';
wwv_flow_imp.g_varchar2_table(46018) := '65642E70757368287B66726F6D3A652C746F3A747D297D73746174696320676574536B697070696E675061727365722865297B72657475726E206E657720636C61737320657874656E6473206B537B637265617465506172736528742C6E2C69297B6C65';
wwv_flow_imp.g_varchar2_table(46019) := '74206F3D695B305D2E66726F6D2C733D695B692E6C656E6774682D315D2E746F2C723D7B706172736564506F733A6F2C616476616E636528297B6C657420743D484D3B69662874297B666F72286C65742065206F66206929742E74656D70536B69707065';
wwv_flow_imp.g_varchar2_table(46020) := '642E707573682865293B65262628742E7363686564756C654F6E3D742E7363686564756C654F6E3F50726F6D6973652E616C6C285B742E7363686564756C654F6E2C655D293A65297D72657475726E20746869732E706172736564506F733D732C6E6577';
wwv_flow_imp.g_varchar2_table(46021) := '2072532874532E6E6F6E652C5B5D2C5B5D2C732D6F297D2C73746F7070656441743A6E756C6C2C73746F70417428297B7D7D3B72657475726E20727D7D7D6973446F6E652865297B653D4D6174682E6D696E28652C746869732E73746174652E646F632E';
wwv_flow_imp.g_varchar2_table(46022) := '6C656E677468293B6C657420743D746869732E667261676D656E74733B72657475726E20746869732E747265654C656E3E3D652626742E6C656E6774682626303D3D745B305D2E66726F6D2626745B305D2E746F3E3D657D737461746963206765742829';
wwv_flow_imp.g_varchar2_table(46023) := '7B72657475726E20484D7D7D66756E6374696F6E206A4D28652C742C6E297B72657475726E2078532E6170706C794368616E67657328652C5B7B66726F6D413A742C746F413A6E2C66726F6D423A742C746F423A6E7D5D297D636C61737320714D7B636F';
wwv_flow_imp.g_varchar2_table(46024) := '6E7374727563746F722865297B746869732E636F6E746578743D652C746869732E747265653D652E747265657D6170706C792865297B69662821652E646F634368616E6765642626746869732E747265653D3D746869732E636F6E746578742E74726565';
wwv_flow_imp.g_varchar2_table(46025) := '2972657475726E20746869733B6C657420743D746869732E636F6E746578742E6368616E67657328652E6368616E6765732C652E7374617465292C6E3D746869732E636F6E746578742E747265654C656E3D3D652E737461727453746174652E646F632E';
wwv_flow_imp.g_varchar2_table(46026) := '6C656E6774683F766F696420303A4D6174682E6D617828652E6368616E6765732E6D6170506F7328746869732E636F6E746578742E747265654C656E292C742E76696577706F72742E746F293B72657475726E20742E776F726B2832302C6E297C7C742E';
wwv_flow_imp.g_varchar2_table(46027) := '74616B655472656528292C6E657720714D2874297D73746174696320696E69742865297B6C657420743D4D6174682E6D696E283365332C652E646F632E6C656E677468292C6E3D574D2E63726561746528652E666163657428474D292E7061727365722C';
wwv_flow_imp.g_varchar2_table(46028) := '652C7B66726F6D3A302C746F3A747D293B72657475726E206E2E776F726B2832302C74297C7C6E2E74616B655472656528292C6E657720714D286E297D7D524D2E73746174653D456B2E646566696E65287B6372656174653A714D2E696E69742C757064';
wwv_flow_imp.g_varchar2_table(46029) := '61746528652C74297B666F72286C65742065206F6620742E6566666563747329696628652E697328524D2E7365745374617465292972657475726E20652E76616C75653B72657475726E20742E737461727453746174652E666163657428474D29213D74';
wwv_flow_imp.g_varchar2_table(46030) := '2E73746174652E666163657428474D293F714D2E696E697428742E7374617465293A652E6170706C792874297D7D293B6C657420244D3D653D3E7B6C657420743D73657454696D656F7574282828293D3E652829292C353030293B72657475726E28293D';
wwv_flow_imp.g_varchar2_table(46031) := '3E636C65617254696D656F75742874297D3B22756E646566696E656422213D747970656F66207265717565737449646C6543616C6C6261636B262628244D3D653D3E7B6C657420743D2D312C6E3D73657454696D656F7574282828293D3E7B743D726571';
wwv_flow_imp.g_varchar2_table(46032) := '7565737449646C6543616C6C6261636B28652C7B74696D656F75743A3430307D297D292C313030293B72657475726E28293D3E743C303F636C65617254696D656F7574286E293A63616E63656C49646C6543616C6C6261636B2874297D293B636F6E7374';
wwv_flow_imp.g_varchar2_table(46033) := '20554D3D22756E646566696E656422213D747970656F66206E6176696761746F722626286E756C6C3D3D3D284E4D3D6E6176696761746F722E7363686564756C696E67297C7C766F696420303D3D3D4E4D3F766F696420303A4E4D2E6973496E70757450';
wwv_flow_imp.g_varchar2_table(46034) := '656E64696E67293F28293D3E6E6176696761746F722E7363686564756C696E672E6973496E70757450656E64696E6728293A6E756C6C2C4B4D3D49442E66726F6D436C61737328636C6173737B636F6E7374727563746F722865297B746869732E766965';
wwv_flow_imp.g_varchar2_table(46035) := '773D652C746869732E776F726B696E673D6E756C6C2C746869732E776F726B5363686564756C65643D302C746869732E6368756E6B456E643D2D312C746869732E6368756E6B4275646765743D2D312C746869732E776F726B3D746869732E776F726B2E';
wwv_flow_imp.g_varchar2_table(46036) := '62696E642874686973292C746869732E7363686564756C65576F726B28297D7570646174652865297B6C657420743D746869732E766965772E73746174652E6669656C6428524D2E7374617465292E636F6E746578743B28742E75706461746556696577';
wwv_flow_imp.g_varchar2_table(46037) := '706F727428652E766965772E76696577706F7274297C7C746869732E766965772E76696577706F72742E746F3E742E747265654C656E292626746869732E7363686564756C65576F726B28292C28652E646F634368616E6765647C7C652E73656C656374';
wwv_flow_imp.g_varchar2_table(46038) := '696F6E53657429262628746869732E766965772E686173466F637573262628746869732E6368756E6B4275646765742B3D3530292C746869732E7363686564756C65576F726B2829292C746869732E636865636B4173796E635363686564756C65287429';
wwv_flow_imp.g_varchar2_table(46039) := '7D7363686564756C65576F726B28297B696628746869732E776F726B696E672972657475726E3B6C65747B73746174653A657D3D746869732E766965772C743D652E6669656C6428524D2E7374617465293B742E747265653D3D742E636F6E746578742E';
wwv_flow_imp.g_varchar2_table(46040) := '747265652626742E636F6E746578742E6973446F6E6528652E646F632E6C656E677468297C7C28746869732E776F726B696E673D244D28746869732E776F726B29297D776F726B2865297B746869732E776F726B696E673D6E756C6C3B6C657420743D44';
wwv_flow_imp.g_varchar2_table(46041) := '6174652E6E6F7728293B696628746869732E6368756E6B456E643C74262628746869732E6368756E6B456E643C307C7C746869732E766965772E686173466F63757329262628746869732E6368756E6B456E643D742B3365342C746869732E6368756E6B';
wwv_flow_imp.g_varchar2_table(46042) := '4275646765743D336533292C746869732E6368756E6B4275646765743C3D302972657475726E3B6C65747B73746174653A6E2C76696577706F72743A7B746F3A697D7D3D746869732E766965772C6F3D6E2E6669656C6428524D2E7374617465293B6966';
wwv_flow_imp.g_varchar2_table(46043) := '286F2E747265653D3D6F2E636F6E746578742E7472656526266F2E636F6E746578742E6973446F6E6528692B316535292972657475726E3B6C657420733D446174652E6E6F7728292B4D6174682E6D696E28746869732E6368756E6B4275646765742C31';
wwv_flow_imp.g_varchar2_table(46044) := '30302C65262621554D3F4D6174682E6D61782832352C652E74696D6552656D61696E696E6728292D35293A316539292C723D6F2E636F6E746578742E747265654C656E3C6926266E2E646F632E6C656E6774683E692B3165332C613D6F2E636F6E746578';
wwv_flow_imp.g_varchar2_table(46045) := '742E776F726B282828293D3E554D2626554D28297C7C446174652E6E6F7728293E73292C692B28723F303A31653529293B746869732E6368756E6B4275646765742D3D446174652E6E6F7728292D742C28617C7C746869732E6368756E6B427564676574';
wwv_flow_imp.g_varchar2_table(46046) := '3C3D30292626286F2E636F6E746578742E74616B655472656528292C746869732E766965772E6469737061746368287B656666656374733A524D2E73657453746174652E6F66286E657720714D286F2E636F6E7465787429297D29292C746869732E6368';
wwv_flow_imp.g_varchar2_table(46047) := '756E6B4275646765743E3026262821617C7C72292626746869732E7363686564756C65576F726B28292C746869732E636865636B4173796E635363686564756C65286F2E636F6E74657874297D636865636B4173796E635363686564756C652865297B65';
wwv_flow_imp.g_varchar2_table(46048) := '2E7363686564756C654F6E262628746869732E776F726B5363686564756C65642B2B2C652E7363686564756C654F6E2E7468656E282828293D3E746869732E7363686564756C65576F726B282929292E63617463682828653D3E454428746869732E7669';
wwv_flow_imp.g_varchar2_table(46049) := '65772E73746174652C652929292E7468656E282828293D3E746869732E776F726B5363686564756C65642D2D29292C652E7363686564756C654F6E3D6E756C6C297D64657374726F7928297B746869732E776F726B696E672626746869732E776F726B69';
wwv_flow_imp.g_varchar2_table(46050) := '6E6728297D6973576F726B696E6728297B72657475726E212128746869732E776F726B696E677C7C746869732E776F726B5363686564756C65643E30297D7D2C7B6576656E7448616E646C6572733A7B666F63757328297B746869732E7363686564756C';
wwv_flow_imp.g_varchar2_table(46051) := '65576F726B28297D7D7D292C474D3D5F6B2E646566696E65287B636F6D62696E653A653D3E652E6C656E6774683F655B305D3A6E756C6C2C656E61626C65733A653D3E5B524D2E73746174652C4B4D2C44492E636F6E74656E7441747472696275746573';
wwv_flow_imp.g_varchar2_table(46052) := '2E636F6D70757465285B655D2C28743D3E7B6C6574206E3D742E66616365742865293B72657475726E206E26266E2E6E616D653F7B22646174612D6C616E6775616765223A6E2E6E616D657D3A7B7D7D29295D7D293B636C61737320514D7B636F6E7374';
wwv_flow_imp.g_varchar2_table(46053) := '727563746F7228652C743D5B5D297B746869732E6C616E67756167653D652C746869732E737570706F72743D742C746869732E657874656E73696F6E3D5B652C745D7D7D636F6E737420594D3D5F6B2E646566696E6528292C5A4D3D5F6B2E646566696E';
wwv_flow_imp.g_varchar2_table(46054) := '65287B636F6D62696E653A653D3E7B69662821652E6C656E6774682972657475726E222020223B6C657420743D655B305D3B69662821747C7C2F5C532F2E746573742874297C7C41727261792E66726F6D2874292E736F6D652828653D3E65213D745B30';
wwv_flow_imp.g_varchar2_table(46055) := '5D2929297468726F77206E6577204572726F722822496E76616C696420696E64656E7420756E69743A20222B4A534F4E2E737472696E6769667928655B305D29293B72657475726E20747D7D293B66756E6374696F6E20584D2865297B6C657420743D65';
wwv_flow_imp.g_varchar2_table(46056) := '2E6661636574285A4D293B72657475726E20393D3D742E63686172436F646541742830293F652E74616253697A652A742E6C656E6774683A742E6C656E6774687D66756E6374696F6E204A4D28652C74297B6C6574206E3D22222C693D652E7461625369';
wwv_flow_imp.g_varchar2_table(46057) := '7A652C6F3D652E6661636574285A4D295B305D3B696628225C74223D3D6F297B666F72283B743E3D693B296E2B3D225C74222C742D3D693B6F3D2220227D666F72286C657420653D303B653C743B652B2B296E2B3D6F3B72657475726E206E7D66756E63';
wwv_flow_imp.g_varchar2_table(46058) := '74696F6E20654128652C74297B6520696E7374616E63656F66206E45262628653D6E6577207441286529293B666F72286C6574206E206F6620652E73746174652E666163657428594D29297B6C657420693D6E28652C74293B696628766F69642030213D';
wwv_flow_imp.g_varchar2_table(46059) := '3D692972657475726E20697D6C6574206E3D564D28652E7374617465293B72657475726E206E2E6C656E6774683E3D743F66756E6374696F6E28652C742C6E297B6C657420693D742E7265736F6C7665537461636B286E292C6F3D692E6E6F64652E656E';
wwv_flow_imp.g_varchar2_table(46060) := '746572556E66696E69736865644E6F6465734265666F7265286E293B6966286F213D692E6E6F6465297B6C657420653D5B5D3B666F72286C657420743D6F3B74213D692E6E6F64653B743D742E706172656E7429652E707573682874293B666F72286C65';
wwv_flow_imp.g_varchar2_table(46061) := '7420743D652E6C656E6774682D313B743E3D303B742D2D29693D7B6E6F64653A655B745D2C6E6578743A697D7D72657475726E20694128692C652C6E297D28652C6E2C74293A6E756C6C7D636C6173732074417B636F6E7374727563746F7228652C743D';
wwv_flow_imp.g_varchar2_table(46062) := '7B7D297B746869732E73746174653D652C746869732E6F7074696F6E733D742C746869732E756E69743D584D2865297D6C696E65417428652C743D31297B6C6574206E3D746869732E73746174652E646F632E6C696E6541742865292C7B73696D756C61';
wwv_flow_imp.g_varchar2_table(46063) := '7465427265616B3A692C73696D756C617465446F75626C65427265616B3A6F7D3D746869732E6F7074696F6E733B72657475726E206E756C6C213D692626693E3D6E2E66726F6D2626693C3D6E2E746F3F6F2626693D3D653F7B746578743A22222C6672';
wwv_flow_imp.g_varchar2_table(46064) := '6F6D3A657D3A28743C303F693C653A693C3D65293F7B746578743A6E2E746578742E736C69636528692D6E2E66726F6D292C66726F6D3A697D3A7B746578743A6E2E746578742E736C69636528302C692D6E2E66726F6D292C66726F6D3A6E2E66726F6D';
wwv_flow_imp.g_varchar2_table(46065) := '7D3A6E7D746578744166746572506F7328652C743D31297B696628746869732E6F7074696F6E732E73696D756C617465446F75626C65427265616B2626653D3D746869732E6F7074696F6E732E73696D756C617465427265616B2972657475726E22223B';
wwv_flow_imp.g_varchar2_table(46066) := '6C65747B746578743A6E2C66726F6D3A697D3D746869732E6C696E65417428652C74293B72657475726E206E2E736C69636528652D692C4D6174682E6D696E286E2E6C656E6774682C652B3130302D6929297D636F6C756D6E28652C743D31297B6C6574';
wwv_flow_imp.g_varchar2_table(46067) := '7B746578743A6E2C66726F6D3A697D3D746869732E6C696E65417428652C74292C6F3D746869732E636F756E74436F6C756D6E286E2C652D69292C733D746869732E6F7074696F6E732E6F76657272696465496E64656E746174696F6E3F746869732E6F';
wwv_flow_imp.g_varchar2_table(46068) := '7074696F6E732E6F76657272696465496E64656E746174696F6E2869293A2D313B72657475726E20733E2D312626286F2B3D732D746869732E636F756E74436F6C756D6E286E2C6E2E736561726368282F5C537C242F2929292C6F7D636F756E74436F6C';
wwv_flow_imp.g_varchar2_table(46069) := '756D6E28652C743D652E6C656E677468297B72657475726E20794528652C746869732E73746174652E74616253697A652C74297D6C696E65496E64656E7428652C743D31297B6C65747B746578743A6E2C66726F6D3A697D3D746869732E6C696E654174';
wwv_flow_imp.g_varchar2_table(46070) := '28652C74292C6F3D746869732E6F7074696F6E732E6F76657272696465496E64656E746174696F6E3B6966286F297B6C657420653D6F2869293B696628653E2D312972657475726E20657D72657475726E20746869732E636F756E74436F6C756D6E286E';
wwv_flow_imp.g_varchar2_table(46071) := '2C6E2E736561726368282F5C537C242F29297D6765742073696D756C61746564427265616B28297B72657475726E20746869732E6F7074696F6E732E73696D756C617465427265616B7C7C6E756C6C7D7D636F6E7374206E413D6E65772058433B66756E';
wwv_flow_imp.g_varchar2_table(46072) := '6374696F6E20694128652C742C6E297B666F72286C657420693D653B693B693D692E6E657874297B6C657420653D6F4128692E6E6F6465293B696628652972657475726E20652872412E63726561746528742C6E2C6929297D72657475726E20307D6675';
wwv_flow_imp.g_varchar2_table(46073) := '6E6374696F6E206F412865297B6C657420743D652E747970652E70726F70286E41293B696628742972657475726E20743B6C6574206E2C693D652E66697273744368696C643B696628692626286E3D692E747970652E70726F702858432E636C6F736564';
wwv_flow_imp.g_varchar2_table(46074) := '42792929297B6C657420743D652E6C6173744368696C642C693D7426266E2E696E6465784F6628742E6E616D65293E2D313B72657475726E20653D3E634128652C21302C312C766F696420302C6926262166756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(46075) := '652E706F733D3D652E6F7074696F6E732E73696D756C617465427265616B2626652E6F7074696F6E732E73696D756C617465446F75626C65427265616B7D2865293F742E66726F6D3A766F69642030297D72657475726E206E756C6C3D3D652E70617265';
wwv_flow_imp.g_varchar2_table(46076) := '6E743F73413A6E756C6C7D66756E6374696F6E20734128297B72657475726E20307D636C61737320724120657874656E64732074417B636F6E7374727563746F7228652C742C6E297B737570657228652E73746174652C652E6F7074696F6E73292C7468';
wwv_flow_imp.g_varchar2_table(46077) := '69732E626173653D652C746869732E706F733D742C746869732E636F6E746578743D6E7D676574206E6F646528297B72657475726E20746869732E636F6E746578742E6E6F64657D7374617469632063726561746528652C742C6E297B72657475726E20';
wwv_flow_imp.g_varchar2_table(46078) := '6E657720724128652C742C6E297D6765742074657874416674657228297B72657475726E20746869732E746578744166746572506F7328746869732E706F73297D6765742062617365496E64656E7428297B72657475726E20746869732E62617365496E';
wwv_flow_imp.g_varchar2_table(46079) := '64656E74466F7228746869732E6E6F6465297D62617365496E64656E74466F722865297B6C657420743D746869732E73746174652E646F632E6C696E65417428652E66726F6D293B666F72283B3B297B6C6574206E3D652E7265736F6C766528742E6672';
wwv_flow_imp.g_varchar2_table(46080) := '6F6D293B666F72283B6E2E706172656E7426266E2E706172656E742E66726F6D3D3D6E2E66726F6D3B296E3D6E2E706172656E743B6966286141286E2C652929627265616B3B743D746869732E73746174652E646F632E6C696E654174286E2E66726F6D';
wwv_flow_imp.g_varchar2_table(46081) := '297D72657475726E20746869732E6C696E65496E64656E7428742E66726F6D297D636F6E74696E756528297B72657475726E20694128746869732E636F6E746578742E6E6578742C746869732E626173652C746869732E706F73297D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(46082) := '6E20614128652C74297B666F72286C6574206E3D743B6E3B6E3D6E2E706172656E7429696628653D3D6E2972657475726E21303B72657475726E21317D66756E6374696F6E206C41287B636C6F73696E673A652C616C69676E3A743D21302C756E697473';
wwv_flow_imp.g_varchar2_table(46083) := '3A6E3D317D297B72657475726E20693D3E634128692C742C6E2C65297D66756E6374696F6E20634128652C742C6E2C692C6F297B6C657420733D652E7465787441667465722C723D732E6D61746368282F5E5C732A2F295B305D2E6C656E6774682C613D';
wwv_flow_imp.g_varchar2_table(46084) := '692626732E736C69636528722C722B692E6C656E677468293D3D697C7C6F3D3D652E706F732B722C6C3D743F66756E6374696F6E2865297B6C657420743D652E6E6F64652C6E3D742E6368696C64416674657228742E66726F6D292C693D742E6C617374';
wwv_flow_imp.g_varchar2_table(46085) := '4368696C643B696628216E2972657475726E206E756C6C3B6C6574206F3D652E6F7074696F6E732E73696D756C617465427265616B2C733D652E73746174652E646F632E6C696E654174286E2E66726F6D292C723D6E756C6C3D3D6F7C7C6F3C3D732E66';
wwv_flow_imp.g_varchar2_table(46086) := '726F6D3F732E746F3A4D6174682E6D696E28732E746F2C6F293B666F72286C657420653D6E2E746F3B3B297B6C6574206F3D742E6368696C6441667465722865293B696628216F7C7C6F3D3D692972657475726E206E756C6C3B696628216F2E74797065';
wwv_flow_imp.g_varchar2_table(46087) := '2E6973536B69707065642972657475726E206F2E66726F6D3C723F6E3A6E756C6C3B653D6F2E746F7D7D2865293A6E756C6C3B72657475726E206C3F613F652E636F6C756D6E286C2E66726F6D293A652E636F6C756D6E286C2E746F293A652E62617365';
wwv_flow_imp.g_varchar2_table(46088) := '496E64656E742B28613F303A652E756E69742A6E297D66756E6374696F6E206441287B6578636570743A652C756E6974733A743D317D3D7B7D297B72657475726E206E3D3E7B6C657420693D652626652E74657374286E2E746578744166746572293B72';
wwv_flow_imp.g_varchar2_table(46089) := '657475726E206E2E62617365496E64656E742B28693F303A742A6E2E756E6974297D7D636F6E73742068413D3230303B66756E6374696F6E20754128297B72657475726E206E452E7472616E73616374696F6E46696C7465722E6F662828653D3E7B6966';
wwv_flow_imp.g_varchar2_table(46090) := '2821652E646F634368616E6765647C7C21652E6973557365724576656E742822696E7075742E747970652229262621652E6973557365724576656E742822696E7075742E636F6D706C65746522292972657475726E20653B6C657420743D652E73746172';
wwv_flow_imp.g_varchar2_table(46091) := '7453746174652E6C616E67756167654461746141742822696E64656E744F6E496E707574222C652E737461727453746174652E73656C656374696F6E2E6D61696E2E68656164293B69662821742E6C656E6774682972657475726E20653B6C6574206E3D';
wwv_flow_imp.g_varchar2_table(46092) := '652E6E6577446F632C7B686561643A697D3D652E6E657753656C656374696F6E2E6D61696E2C6F3D6E2E6C696E6541742869293B696628693E6F2E66726F6D2B68412972657475726E20653B6C657420733D6E2E736C696365537472696E67286F2E6672';
wwv_flow_imp.g_varchar2_table(46093) := '6F6D2C69293B69662821742E736F6D652828653D3E652E7465737428732929292972657475726E20653B6C65747B73746174653A727D3D652C613D2D312C6C3D5B5D3B666F72286C65747B686561643A657D6F6620722E73656C656374696F6E2E72616E';
wwv_flow_imp.g_varchar2_table(46094) := '676573297B6C657420743D722E646F632E6C696E6541742865293B696628742E66726F6D3D3D6129636F6E74696E75653B613D742E66726F6D3B6C6574206E3D654128722C742E66726F6D293B6966286E756C6C3D3D6E29636F6E74696E75653B6C6574';
wwv_flow_imp.g_varchar2_table(46095) := '20693D2F5E5C732A2F2E6578656328742E74657874295B305D2C6F3D4A4D28722C6E293B69213D6F26266C2E70757368287B66726F6D3A742E66726F6D2C746F3A742E66726F6D2B692E6C656E6774682C696E736572743A6F7D297D72657475726E206C';
wwv_flow_imp.g_varchar2_table(46096) := '2E6C656E6774683F5B652C7B6368616E6765733A6C2C73657175656E7469616C3A21307D5D3A657D29297D636F6E73742070413D6E65772058433B66756E6374696F6E2067412865297B6C657420743D652E66697273744368696C642C6E3D652E6C6173';
wwv_flow_imp.g_varchar2_table(46097) := '744368696C643B72657475726E20742626742E746F3C6E2E66726F6D3F7B66726F6D3A742E746F2C746F3A6E2E747970652E69734572726F723F652E746F3A6E2E66726F6D7D3A6E756C6C7D636C617373206D417B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(46098) := '297B6C6574206E3B66756E6374696F6E20692865297B6C657420743D78452E6E65774E616D6528293B72657475726E286E7C7C286E3D4F626A6563742E637265617465286E756C6C2929295B222E222B745D3D652C747D746869732E73706563733D653B';
wwv_flow_imp.g_varchar2_table(46099) := '636F6E7374206F3D22737472696E67223D3D747970656F6620742E616C6C3F742E616C6C3A742E616C6C3F6928742E616C6C293A766F696420302C733D742E73636F70653B746869732E73636F70653D7320696E7374616E63656F6620524D3F653D3E65';
wwv_flow_imp.g_varchar2_table(46100) := '2E70726F7028504D293D3D732E646174613A733F653D3E653D3D733A766F696420302C746869732E7374796C653D627828652E6D61702828653D3E287B7461673A652E7461672C636C6173733A652E636C6173737C7C69284F626A6563742E6173736967';
wwv_flow_imp.g_varchar2_table(46101) := '6E287B7D2C652C7B7461673A6E756C6C7D29297D2929292C7B616C6C3A6F7D292E7374796C652C746869732E6D6F64756C653D6E3F6E6577207845286E293A6E756C6C2C746869732E7468656D65547970653D742E7468656D65547970657D7374617469';
wwv_flow_imp.g_varchar2_table(46102) := '6320646566696E6528652C74297B72657475726E206E6577206D4128652C747C7C7B7D297D7D636F6E73742066413D5F6B2E646566696E6528292C76413D5F6B2E646566696E65287B636F6D62696E653A653D3E652E6C656E6774683F5B655B305D5D3A';
wwv_flow_imp.g_varchar2_table(46103) := '6E756C6C7D293B66756E6374696F6E2062412865297B6C657420743D652E6661636574286641293B72657475726E20742E6C656E6774683F743A652E6661636574287641297D66756E6374696F6E205F4128652C74297B6C6574206E2C693D5B77415D3B';
wwv_flow_imp.g_varchar2_table(46104) := '72657475726E206520696E7374616E63656F66206D41262628652E6D6F64756C652626692E707573682844492E7374796C654D6F64756C652E6F6628652E6D6F64756C6529292C6E3D652E7468656D6554797065292C286E756C6C3D3D743F766F696420';
wwv_flow_imp.g_varchar2_table(46105) := '303A742E66616C6C6261636B293F692E707573682876412E6F66286529293A6E3F692E707573682866412E636F6D707574654E285B44492E6461726B5468656D655D2C28743D3E742E66616365742844492E6461726B5468656D65293D3D28226461726B';
wwv_flow_imp.g_varchar2_table(46106) := '223D3D6E293F5B655D3A5B5D2929293A692E707573682866412E6F66286529292C697D636C6173732079417B636F6E7374727563746F722865297B746869732E6D61726B43616368653D4F626A6563742E637265617465286E756C6C292C746869732E74';
wwv_flow_imp.g_varchar2_table(46107) := '7265653D564D28652E7374617465292C746869732E6465636F726174696F6E733D746869732E6275696C644465636F28652C624128652E737461746529292C746869732E6465636F7261746564546F3D652E76696577706F72742E746F7D757064617465';
wwv_flow_imp.g_varchar2_table(46108) := '2865297B6C657420743D564D28652E7374617465292C6E3D624128652E7374617465292C693D6E213D624128652E73746172745374617465292C7B76696577706F72743A6F7D3D652E766965772C733D652E6368616E6765732E6D6170506F7328746869';
wwv_flow_imp.g_varchar2_table(46109) := '732E6465636F7261746564546F2C31293B742E6C656E6774683C6F2E746F262621692626742E747970653D3D746869732E747265652E747970652626733E3D6F2E746F3F28746869732E6465636F726174696F6E733D746869732E6465636F726174696F';
wwv_flow_imp.g_varchar2_table(46110) := '6E732E6D617028652E6368616E676573292C746869732E6465636F7261746564546F3D73293A2874213D746869732E747265657C7C652E76696577706F72744368616E6765647C7C6929262628746869732E747265653D742C746869732E6465636F7261';
wwv_flow_imp.g_varchar2_table(46111) := '74696F6E733D746869732E6275696C644465636F28652E766965772C6E292C746869732E6465636F7261746564546F3D6F2E746F297D6275696C644465636F28652C74297B69662821747C7C21746869732E747265652E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(46112) := '20504C2E6E6F6E653B6C6574206E3D6E65772063453B666F72286C65747B66726F6D3A692C746F3A6F7D6F6620652E76697369626C6552616E676573295F7828746869732E747265652C742C2828652C742C69293D3E7B6E2E61646428652C742C746869';
wwv_flow_imp.g_varchar2_table(46113) := '732E6D61726B43616368655B695D7C7C28746869732E6D61726B43616368655B695D3D504C2E6D61726B287B636C6173733A697D2929297D292C692C6F293B72657475726E206E2E66696E69736828297D7D636F6E73742077413D446B2E686967682849';
wwv_flow_imp.g_varchar2_table(46114) := '442E66726F6D436C6173732879412C7B6465636F726174696F6E733A653D3E652E6465636F726174696F6E737D29292C43413D2852782E6D6574612C52782E6C696E6B2C52782E68656164696E672C52782E656D7068617369732C52782E7374726F6E67';
wwv_flow_imp.g_varchar2_table(46115) := '2C52782E737472696B657468726F7567682C52782E6B6579776F72642C52782E61746F6D2C52782E626F6F6C2C52782E75726C2C52782E636F6E74656E74536570617261746F722C52782E6C6162656C4E616D652C52782E6C69746572616C2C52782E69';
wwv_flow_imp.g_varchar2_table(46116) := '6E7365727465642C52782E737472696E672C52782E64656C657465642C52782E7265676578702C52782E6573636170652C52782E737472696E672C52782E7661726961626C654E616D652C52782E7661726961626C654E616D652C52782E747970654E61';
wwv_flow_imp.g_varchar2_table(46117) := '6D652C52782E6E616D6573706163652C52782E636C6173734E616D652C52782E7661726961626C654E616D652C52782E6D6163726F4E616D652C52782E70726F70657274794E616D652C52782E636F6D6D656E742C52782E696E76616C69642C44492E62';
wwv_flow_imp.g_varchar2_table(46118) := '6173655468656D65287B22262E636D2D666F6375736564202E636D2D6D61746368696E67427261636B6574223A7B6261636B67726F756E64436F6C6F723A22233332386338323532227D2C22262E636D2D666F6375736564202E636D2D6E6F6E6D617463';
wwv_flow_imp.g_varchar2_table(46119) := '68696E67427261636B6574223A7B6261636B67726F756E64436F6C6F723A22236262353535353434227D7D29292C53413D3165342C78413D2228295B5D7B7D222C6B413D5F6B2E646566696E65287B636F6D62696E653A653D3E694528652C7B61667465';
wwv_flow_imp.g_varchar2_table(46120) := '72437572736F723A21302C627261636B6574733A78412C6D61785363616E44697374616E63653A53412C72656E6465724D617463683A44417D297D292C45413D504C2E6D61726B287B636C6173733A22636D2D6D61746368696E67427261636B6574227D';
wwv_flow_imp.g_varchar2_table(46121) := '292C4C413D504C2E6D61726B287B636C6173733A22636D2D6E6F6E6D61746368696E67427261636B6574227D293B66756E6374696F6E2044412865297B6C657420743D5B5D2C6E3D652E6D6174636865643F45413A4C413B72657475726E20742E707573';
wwv_flow_imp.g_varchar2_table(46122) := '68286E2E72616E676528652E73746172742E66726F6D2C652E73746172742E746F29292C652E656E642626742E70757368286E2E72616E676528652E656E642E66726F6D2C652E656E642E746F29292C747D636F6E73742054413D456B2E646566696E65';
wwv_flow_imp.g_varchar2_table(46123) := '287B6372656174653A28293D3E504C2E6E6F6E652C75706461746528652C74297B69662821742E646F634368616E676564262621742E73656C656374696F6E2972657475726E20653B6C6574206E3D5B5D2C693D742E73746174652E6661636574286B41';
wwv_flow_imp.g_varchar2_table(46124) := '293B666F72286C65742065206F6620742E73746174652E73656C656374696F6E2E72616E676573297B69662821652E656D70747929636F6E74696E75653B6C6574206F3D4F4128742E73746174652C652E686561642C2D312C69297C7C652E686561643E';
wwv_flow_imp.g_varchar2_table(46125) := '3026264F4128742E73746174652C652E686561642D312C312C69297C7C692E6166746572437572736F722626284F4128742E73746174652C652E686561642C312C69297C7C652E686561643C742E73746174652E646F632E6C656E67746826264F412874';
wwv_flow_imp.g_varchar2_table(46126) := '2E73746174652C652E686561642B312C2D312C6929293B6F2626286E3D6E2E636F6E63617428692E72656E6465724D61746368286F2C742E73746174652929297D72657475726E20504C2E736574286E2C2130297D2C70726F766964653A653D3E44492E';
wwv_flow_imp.g_varchar2_table(46127) := '6465636F726174696F6E732E66726F6D2865297D292C49413D5B54412C43415D3B66756E6374696F6E204D4128653D7B7D297B72657475726E5B6B412E6F662865292C49415D7D636F6E73742041413D6E65772058433B66756E6374696F6E204E412865';
wwv_flow_imp.g_varchar2_table(46128) := '2C742C6E297B6C657420693D652E70726F7028743C303F58432E6F70656E656442793A58432E636C6F7365644279293B696628692972657475726E20693B696628313D3D652E6E616D652E6C656E677468297B6C657420693D6E2E696E6465784F662865';
wwv_flow_imp.g_varchar2_table(46129) := '2E6E616D65293B696628693E2D3126266925323D3D28743C303F313A30292972657475726E5B6E5B692B745D5D7D72657475726E206E756C6C7D66756E6374696F6E2050412865297B6C657420743D652E747970652E70726F70284141293B7265747572';
wwv_flow_imp.g_varchar2_table(46130) := '6E20743F7428652E6E6F6465293A657D66756E6374696F6E204F4128652C742C6E2C693D7B7D297B6C6574206F3D692E6D61785363616E44697374616E63657C7C53412C733D692E627261636B6574737C7C78412C723D564D2865292C613D722E726573';
wwv_flow_imp.g_varchar2_table(46131) := '6F6C7665496E6E657228742C6E293B666F72286C657420653D613B653B653D652E706172656E74297B6C657420693D4E4128652E747970652C6E2C73293B696628692626652E66726F6D3C652E746F297B6C6574206F3D50412865293B6966286F262628';
wwv_flow_imp.g_varchar2_table(46132) := '6E3E303F743E3D6F2E66726F6D2626743C6F2E746F3A743E6F2E66726F6D2626743C3D6F2E746F292972657475726E20524128302C302C6E2C652C6F2C692C73297D7D72657475726E2066756E6374696F6E28652C742C6E2C692C6F2C732C72297B6C65';
wwv_flow_imp.g_varchar2_table(46133) := '7420613D6E3C303F652E736C696365446F6328742D312C74293A652E736C696365446F6328742C742B31292C6C3D722E696E6465784F662861293B6966286C3C307C7C6C25323D3D30213D6E3E302972657475726E206E756C6C3B6C657420633D7B6672';
wwv_flow_imp.g_varchar2_table(46134) := '6F6D3A6E3C303F742D313A742C746F3A6E3E303F742B313A747D2C643D652E646F632E6974657252616E676528742C6E3E303F652E646F632E6C656E6774683A30292C683D303B666F72286C657420653D303B21642E6E65787428292E646F6E65262665';
wwv_flow_imp.g_varchar2_table(46135) := '3C3D733B297B6C657420733D642E76616C75653B6E3C30262628652B3D732E6C656E677468293B6C657420613D742B652A6E3B666F72286C657420653D6E3E303F303A732E6C656E6774682D312C743D6E3E303F732E6C656E6774683A2D313B65213D74';
wwv_flow_imp.g_varchar2_table(46136) := '3B652B3D6E297B6C657420743D722E696E6465784F6628735B655D293B6966282128743C307C7C692E7265736F6C7665496E6E657228612B652C31292E74797065213D6F29296966287425323D3D303D3D6E3E3029682B2B3B656C73657B696628313D3D';
wwv_flow_imp.g_varchar2_table(46137) := '682972657475726E7B73746172743A632C656E643A7B66726F6D3A612B652C746F3A612B652B317D2C6D6174636865643A743E3E313D3D6C3E3E317D3B682D2D7D7D6E3E30262628652B3D732E6C656E677468297D72657475726E20642E646F6E653F7B';
wwv_flow_imp.g_varchar2_table(46138) := '73746172743A632C6D6174636865643A21317D3A6E756C6C7D28652C742C6E2C722C612E747970652C6F2C73297D66756E6374696F6E20524128652C742C6E2C692C6F2C732C72297B6C657420613D692E706172656E742C6C3D7B66726F6D3A6F2E6672';
wwv_flow_imp.g_varchar2_table(46139) := '6F6D2C746F3A6F2E746F7D2C633D302C643D6E756C6C3D3D613F766F696420303A612E637572736F7228293B696628642626286E3C303F642E6368696C644265666F726528692E66726F6D293A642E6368696C64416674657228692E746F292929646F7B';
wwv_flow_imp.g_varchar2_table(46140) := '6966286E3C303F642E746F3C3D692E66726F6D3A642E66726F6D3E3D692E746F297B696628303D3D632626732E696E6465784F6628642E747970652E6E616D65293E2D312626642E66726F6D3C642E746F297B6C657420653D50412864293B7265747572';
wwv_flow_imp.g_varchar2_table(46141) := '6E7B73746172743A6C2C656E643A653F7B66726F6D3A652E66726F6D2C746F3A652E746F7D3A766F696420302C6D6174636865643A21307D7D6966284E4128642E747970652C6E2C722929632B2B3B656C7365206966284E4128642E747970652C2D6E2C';
wwv_flow_imp.g_varchar2_table(46142) := '7229297B696628303D3D63297B6C657420653D50412864293B72657475726E7B73746172743A6C2C656E643A652626652E66726F6D3C652E746F3F7B66726F6D3A652E66726F6D2C746F3A652E746F7D3A766F696420302C6D6174636865643A21317D7D';
wwv_flow_imp.g_varchar2_table(46143) := '632D2D7D7D7D7768696C65286E3C303F642E707265765369626C696E6728293A642E6E6578745369626C696E672829293B72657475726E7B73746172743A6C2C6D6174636865643A21317D7D636F6E73742046413D4F626A6563742E637265617465286E';
wwv_flow_imp.g_varchar2_table(46144) := '756C6C292C42413D5B74532E6E6F6E655D2C56413D5B5D2C7A413D4F626A6563742E637265617465286E756C6C292C48413D4F626A6563742E637265617465286E756C6C293B666F72286C65745B652C745D6F665B5B227661726961626C65222C227661';
wwv_flow_imp.g_varchar2_table(46145) := '726961626C654E616D65225D2C5B227661726961626C652D32222C227661726961626C654E616D652E7370656369616C225D2C5B22737472696E672D32222C22737472696E672E7370656369616C225D2C5B22646566222C227661726961626C654E616D';
wwv_flow_imp.g_varchar2_table(46146) := '652E646566696E6974696F6E225D2C5B22746167222C227461674E616D65225D2C5B22617474726962757465222C226174747269627574654E616D65225D2C5B2274797065222C22747970654E616D65225D2C5B226275696C74696E222C227661726961';
wwv_flow_imp.g_varchar2_table(46147) := '626C654E616D652E7374616E64617264225D2C5B227175616C6966696572222C226D6F646966696572225D2C5B226572726F72222C22696E76616C6964225D2C5B22686561646572222C2268656164696E67225D2C5B2270726F7065727479222C227072';
wwv_flow_imp.g_varchar2_table(46148) := '6F70657274794E616D65225D5D2948415B655D3D6A412846412C74293B66756E6374696F6E20574128652C74297B56412E696E6465784F662865293E2D317C7C2856412E707573682865292C636F6E736F6C652E7761726E287429297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(46149) := '6E206A4128652C74297B6C6574206E3D5B5D3B666F72286C65742069206F6620742E73706C69742822202229297B6C657420743D5B5D3B666F72286C6574206E206F6620692E73706C697428222E2229297B6C657420693D655B6E5D7C7C52785B6E5D3B';
wwv_flow_imp.g_varchar2_table(46150) := '693F2266756E6374696F6E223D3D747970656F6620693F742E6C656E6774683F743D742E6D61702869293A5741286E2C604D6F64696669657220247B6E7D2075736564206174207374617274206F662074616760293A742E6C656E6774683F5741286E2C';
wwv_flow_imp.g_varchar2_table(46151) := '6054616720247B6E7D2075736564206173206D6F64696669657260293A743D41727261792E697341727261792869293F693A5B695D3A5741286E2C60556E6B6E6F776E20686967686C69676874696E672074616720247B6E7D60297D666F72286C657420';
wwv_flow_imp.g_varchar2_table(46152) := '65206F662074296E2E707573682865297D696628216E2E6C656E6774682972657475726E20303B6C657420693D742E7265706C616365282F202F672C225F22292C6F3D692B2220222B6E2E6D61702828653D3E652E696429292C733D7A415B6F5D3B6966';
wwv_flow_imp.g_varchar2_table(46153) := '28732972657475726E20732E69643B6C657420723D7A415B6F5D3D74532E646566696E65287B69643A42412E6C656E6774682C6E616D653A692C70726F70733A5B6D78287B5B695D3A6E7D295D7D293B72657475726E2042412E707573682872292C722E';
wwv_flow_imp.g_varchar2_table(46154) := '69647D554C2E52544C2C554C2E4C54523B636C6173732071417B636F6E7374727563746F7228652C742C6E2C69297B746869732E73746174653D652C746869732E706F733D742C746869732E6578706C696369743D6E2C746869732E766965773D692C74';
wwv_flow_imp.g_varchar2_table(46155) := '6869732E61626F72744C697374656E6572733D5B5D2C746869732E61626F72744F6E446F634368616E67653D21317D746F6B656E4265666F72652865297B6C657420743D564D28746869732E7374617465292E7265736F6C7665496E6E65722874686973';
wwv_flow_imp.g_varchar2_table(46156) := '2E706F732C2D31293B666F72283B742626652E696E6465784F6628742E6E616D65293C303B29743D742E706172656E743B72657475726E20743F7B66726F6D3A742E66726F6D2C746F3A746869732E706F732C746578743A746869732E73746174652E73';
wwv_flow_imp.g_varchar2_table(46157) := '6C696365446F6328742E66726F6D2C746869732E706F73292C747970653A742E747970657D3A6E756C6C7D6D617463684265666F72652865297B6C657420743D746869732E73746174652E646F632E6C696E65417428746869732E706F73292C6E3D4D61';
wwv_flow_imp.g_varchar2_table(46158) := '74682E6D617828742E66726F6D2C746869732E706F732D323530292C693D742E746578742E736C696365286E2D742E66726F6D2C746869732E706F732D742E66726F6D292C6F3D692E73656172636828514128652C213129293B72657475726E206F3C30';
wwv_flow_imp.g_varchar2_table(46159) := '3F6E756C6C3A7B66726F6D3A6E2B6F2C746F3A746869732E706F732C746578743A692E736C696365286F297D7D6765742061626F7274656428297B72657475726E206E756C6C3D3D746869732E61626F72744C697374656E6572737D6164644576656E74';
wwv_flow_imp.g_varchar2_table(46160) := '4C697374656E657228652C742C6E297B2261626F7274223D3D652626746869732E61626F72744C697374656E657273262628746869732E61626F72744C697374656E6572732E707573682874292C6E26266E2E6F6E446F634368616E6765262628746869';
wwv_flow_imp.g_varchar2_table(46161) := '732E61626F72744F6E446F634368616E67653D213029297D7D66756E6374696F6E2024412865297B6C657420743D4F626A6563742E6B6579732865292E6A6F696E282222292C6E3D2F5C772F2E746573742874293B72657475726E206E262628743D742E';
wwv_flow_imp.g_varchar2_table(46162) := '7265706C616365282F5C772F672C222229292C605B247B6E3F225C5C77223A22227D247B742E7265706C616365282F5B5E5C775C735D2F672C225C5C242622297D5D607D66756E6374696F6E2055412865297B6C657420743D652E6D61702828653D3E22';
wwv_flow_imp.g_varchar2_table(46163) := '737472696E67223D3D747970656F6620653F7B6C6162656C3A657D3A6529292C5B6E2C695D3D742E65766572792828653D3E2F5E5C772B242F2E7465737428652E6C6162656C2929293F5B2F5C772A242F2C2F5C772B242F5D3A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(46164) := '297B6C657420743D4F626A6563742E637265617465286E756C6C292C6E3D4F626A6563742E637265617465286E756C6C293B666F72286C65747B6C6162656C3A697D6F662065297B745B695B305D5D3D21303B666F72286C657420653D313B653C692E6C';
wwv_flow_imp.g_varchar2_table(46165) := '656E6774683B652B2B296E5B695B655D5D3D21307D6C657420693D24412874292B2441286E292B222A24223B72657475726E5B6E65772052656745787028225E222B69292C6E6577205265674578702869295D7D2874293B72657475726E20653D3E7B6C';
wwv_flow_imp.g_varchar2_table(46166) := '6574206F3D652E6D617463684265666F72652869293B72657475726E206F7C7C652E6578706C696369743F7B66726F6D3A6F3F6F2E66726F6D3A652E706F732C6F7074696F6E733A742C76616C6964466F723A6E7D3A6E756C6C7D7D636C617373204B41';
wwv_flow_imp.g_varchar2_table(46167) := '7B636F6E7374727563746F7228652C742C6E2C69297B746869732E636F6D706C6574696F6E3D652C746869732E736F757263653D742C746869732E6D617463683D6E2C746869732E73636F72653D697D7D66756E6374696F6E2047412865297B72657475';
wwv_flow_imp.g_varchar2_table(46168) := '726E20652E73656C656374696F6E2E6D61696E2E66726F6D7D66756E6374696F6E20514128652C74297B766172206E3B6C65747B736F757263653A697D3D652C6F3D742626225E22213D695B305D2C733D222422213D695B692E6C656E6774682D315D3B';
wwv_flow_imp.g_varchar2_table(46169) := '72657475726E206F7C7C733F6E6577205265674578702860247B6F3F225E223A22227D283F3A247B697D29247B733F2224223A22227D602C6E756C6C213D3D286E3D652E666C616773292626766F69642030213D3D6E3F6E3A652E69676E6F7265436173';
wwv_flow_imp.g_varchar2_table(46170) := '653F2269223A2222293A657D636F6E73742059413D576B2E646566696E6528292C5A413D6E6577205765616B4D61703B66756E6374696F6E2058412865297B6966282141727261792E697341727261792865292972657475726E20653B6C657420743D5A';
wwv_flow_imp.g_varchar2_table(46171) := '412E6765742865293B72657475726E20747C7C5A412E73657428652C743D5541286529292C747D636F6E7374204A413D246B2E646566696E6528292C654E3D246B2E646566696E6528293B636C61737320744E7B636F6E7374727563746F722865297B74';
wwv_flow_imp.g_varchar2_table(46172) := '6869732E7061747465726E3D652C746869732E63686172733D5B5D2C746869732E666F6C6465643D5B5D2C746869732E616E793D5B5D2C746869732E707265636973653D5B5D2C746869732E6279576F72643D5B5D2C746869732E73636F72653D302C74';
wwv_flow_imp.g_varchar2_table(46173) := '6869732E6D6174636865643D5B5D3B666F72286C657420743D303B743C652E6C656E6774683B297B6C6574206E3D6E6B28652C74292C693D6F6B286E293B746869732E63686172732E70757368286E293B6C6574206F3D652E736C69636528742C742B69';
wwv_flow_imp.g_varchar2_table(46174) := '292C733D6F2E746F55707065724361736528293B746869732E666F6C6465642E70757368286E6B28733D3D6F3F6F2E746F4C6F7765724361736528293A732C3029292C742B3D697D746869732E61737472616C3D652E6C656E677468213D746869732E63';
wwv_flow_imp.g_varchar2_table(46175) := '686172732E6C656E6774687D72657428652C74297B72657475726E20746869732E73636F72653D652C746869732E6D6174636865643D742C746869737D6D617463682865297B696628303D3D746869732E7061747465726E2E6C656E6774682972657475';
wwv_flow_imp.g_varchar2_table(46176) := '726E20746869732E726574282D3130302C5B5D293B696628652E6C656E6774683C746869732E7061747465726E2E6C656E6774682972657475726E206E756C6C3B6C65747B63686172733A742C666F6C6465643A6E2C616E793A692C707265636973653A';
wwv_flow_imp.g_varchar2_table(46177) := '6F2C6279576F72643A737D3D746869733B696628313D3D742E6C656E677468297B6C657420693D6E6B28652C30292C6F3D6F6B2869292C733D6F3D3D652E6C656E6774683F303A2D3130303B696628693D3D745B305D293B656C73657B69662869213D6E';
wwv_flow_imp.g_varchar2_table(46178) := '5B305D2972657475726E206E756C6C3B732B3D2D3230307D72657475726E20746869732E72657428732C5B302C6F5D297D6C657420723D652E696E6465784F6628746869732E7061747465726E293B696628303D3D722972657475726E20746869732E72';
wwv_flow_imp.g_varchar2_table(46179) := '657428652E6C656E6774683D3D746869732E7061747465726E2E6C656E6774683F303A2D3130302C5B302C746869732E7061747465726E2E6C656E6774685D293B6C657420613D742E6C656E6774682C6C3D303B696628723C30297B666F72286C657420';
wwv_flow_imp.g_varchar2_table(46180) := '6F3D302C733D4D6174682E6D696E28652E6C656E6774682C323030293B6F3C7326266C3C613B297B6C657420733D6E6B28652C6F293B73213D745B6C5D262673213D6E5B6C5D7C7C28695B6C2B2B5D3D6F292C6F2B3D6F6B2873297D6966286C3C612972';
wwv_flow_imp.g_varchar2_table(46181) := '657475726E206E756C6C7D6C657420633D302C643D302C683D21312C753D302C703D2D312C673D2D312C6D3D2F5B612D7A5D2F2E746573742865292C663D21303B666F72286C657420693D302C6C3D4D6174682E6D696E28652E6C656E6774682C323030';
wwv_flow_imp.g_varchar2_table(46182) := '292C763D303B693C6C2626643C613B297B6C6574206C3D6E6B28652C69293B723C30262628633C6126266C3D3D745B635D2626286F5B632B2B5D3D69292C753C612626286C3D3D745B755D7C7C6C3D3D6E5B755D3F28303D3D75262628703D69292C673D';
wwv_flow_imp.g_varchar2_table(46183) := '692B312C752B2B293A753D3029293B6C657420622C5F3D6C3C3235353F6C3E3D343826266C3C3D35377C7C6C3E3D393726266C3C3D3132323F323A6C3E3D363526266C3C3D39303F313A303A28623D696B286C2929213D622E746F4C6F77657243617365';
wwv_flow_imp.g_varchar2_table(46184) := '28293F313A62213D622E746F55707065724361736528293F323A303B2821697C7C313D3D5F26266D7C7C303D3D76262630213D5F29262628745B645D3D3D6C7C7C6E5B645D3D3D6C262628683D2130293F735B642B2B5D3D693A732E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(46185) := '28663D213129292C763D5F2C692B3D6F6B286C297D72657475726E20643D3D612626303D3D735B305D2626663F746869732E726573756C742828683F2D3230303A30292D3130302C732C65293A753D3D612626303D3D703F746869732E726574282D3230';
wwv_flow_imp.g_varchar2_table(46186) := '302D652E6C656E6774682B28673D3D652E6C656E6774683F303A2D313030292C5B302C675D293A723E2D313F746869732E726574282D3730302D652E6C656E6774682C5B722C722B746869732E7061747465726E2E6C656E6774685D293A753D3D613F74';
wwv_flow_imp.g_varchar2_table(46187) := '6869732E726574282D3930302D652E6C656E6774682C5B702C675D293A643D3D613F746869732E726573756C742828683F2D3230303A30292D3130302D3730302B28663F303A2D31313030292C732C65293A323D3D742E6C656E6774683F6E756C6C3A74';
wwv_flow_imp.g_varchar2_table(46188) := '6869732E726573756C742828695B305D3F2D3730303A30292D3230302D313130302C692C65297D726573756C7428652C742C6E297B6C657420693D5B5D2C6F3D303B666F72286C65742065206F662074297B6C657420743D652B28746869732E61737472';
wwv_flow_imp.g_varchar2_table(46189) := '616C3F6F6B286E6B286E2C6529293A31293B6F2626695B6F2D315D3D3D653F695B6F2D315D3D743A28695B6F2B2B5D3D652C695B6F2B2B5D3D74297D72657475726E20746869732E72657428652D6E2E6C656E6774682C69297D7D636C617373206E4E7B';
wwv_flow_imp.g_varchar2_table(46190) := '636F6E7374727563746F722865297B746869732E7061747465726E3D652C746869732E6D6174636865643D5B5D2C746869732E73636F72653D302C746869732E666F6C6465643D652E746F4C6F7765724361736528297D6D617463682865297B69662865';
wwv_flow_imp.g_varchar2_table(46191) := '2E6C656E6774683C746869732E7061747465726E2E6C656E6774682972657475726E206E756C6C3B6C657420743D652E736C69636528302C746869732E7061747465726E2E6C656E677468292C6E3D743D3D746869732E7061747465726E3F303A742E74';
wwv_flow_imp.g_varchar2_table(46192) := '6F4C6F7765724361736528293D3D746869732E666F6C6465643F2D3230303A6E756C6C3B72657475726E206E756C6C3D3D6E3F6E756C6C3A28746869732E6D6174636865643D5B302C742E6C656E6774685D2C746869732E73636F72653D6E2B28652E6C';
wwv_flow_imp.g_varchar2_table(46193) := '656E6774683D3D746869732E7061747465726E2E6C656E6774683F303A2D313030292C74686973297D7D636F6E737420694E3D5F6B2E646566696E65287B636F6D62696E653A653D3E694528652C7B61637469766174654F6E547970696E673A21302C61';
wwv_flow_imp.g_varchar2_table(46194) := '637469766174654F6E436F6D706C6574696F6E3A28293D3E21312C61637469766174654F6E547970696E6744656C61793A3130302C73656C6563744F6E4F70656E3A21302C6F766572726964653A6E756C6C2C636C6F73654F6E426C75723A21302C6D61';
wwv_flow_imp.g_varchar2_table(46195) := '7852656E64657265644F7074696F6E733A3130302C64656661756C744B65796D61703A21302C746F6F6C746970436C6173733A28293D3E22222C6F7074696F6E436C6173733A28293D3E22222C61626F7665437572736F723A21312C69636F6E733A2130';
wwv_flow_imp.g_varchar2_table(46196) := '2C616464546F4F7074696F6E733A5B5D2C706F736974696F6E496E666F3A734E2C66696C7465725374726963743A21312C636F6D70617265436F6D706C6574696F6E733A28652C74293D3E652E6C6162656C2E6C6F63616C65436F6D7061726528742E6C';
wwv_flow_imp.g_varchar2_table(46197) := '6162656C292C696E746572616374696F6E44656C61793A37352C75706461746553796E6354696D653A3130307D2C7B64656661756C744B65796D61703A28652C74293D3E652626742C636C6F73654F6E426C75723A28652C74293D3E652626742C69636F';
wwv_flow_imp.g_varchar2_table(46198) := '6E733A28652C74293D3E652626742C746F6F6C746970436C6173733A28652C74293D3E6E3D3E6F4E2865286E292C74286E29292C6F7074696F6E436C6173733A28652C74293D3E6E3D3E6F4E2865286E292C74286E29292C616464546F4F7074696F6E73';
wwv_flow_imp.g_varchar2_table(46199) := '3A28652C74293D3E652E636F6E6361742874292C66696C7465725374726963743A28652C74293D3E657C7C747D297D293B66756E6374696F6E206F4E28652C74297B72657475726E20653F743F652B2220222B743A653A747D66756E6374696F6E20734E';
wwv_flow_imp.g_varchar2_table(46200) := '28652C742C6E2C692C6F2C73297B6C657420722C612C6C3D652E74657874446972656374696F6E3D3D554C2E52544C2C633D6C2C643D21312C683D22746F70222C753D742E6C6566742D6F2E6C6566742C703D6F2E72696768742D742E72696768742C67';
wwv_flow_imp.g_varchar2_table(46201) := '3D692E72696768742D692E6C6566742C6D3D692E626F74746F6D2D692E746F703B696628632626753C4D6174682E6D696E28672C70293F633D21313A21632626703C4D6174682E6D696E28672C7529262628633D2130292C673C3D28633F753A70292972';
wwv_flow_imp.g_varchar2_table(46202) := '3D4D6174682E6D6178286F2E746F702C4D6174682E6D696E286E2E746F702C6F2E626F74746F6D2D6D29292D742E746F702C613D4D6174682E6D696E283430302C633F753A70293B656C73657B643D21302C613D4D6174682E6D696E283430302C286C3F';
wwv_flow_imp.g_varchar2_table(46203) := '742E72696768743A6F2E72696768742D742E6C656674292D3330293B6C657420653D6F2E626F74746F6D2D742E626F74746F6D3B653E3D6D7C7C653E742E746F703F723D6E2E626F74746F6D2D742E746F703A28683D22626F74746F6D222C723D742E62';
wwv_flow_imp.g_varchar2_table(46204) := '6F74746F6D2D6E2E746F70297D72657475726E7B7374796C653A60247B687D3A20247B722F2828742E626F74746F6D2D742E746F70292F732E6F6666736574486569676874297D70783B206D61782D77696474683A20247B612F2828742E72696768742D';
wwv_flow_imp.g_varchar2_table(46205) := '742E6C656674292F732E6F66667365745769647468297D7078602C636C6173733A22636D2D636F6D706C6574696F6E496E666F2D222B28643F6C3F226C6566742D6E6172726F77223A2272696768742D6E6172726F77223A633F226C656674223A227269';
wwv_flow_imp.g_varchar2_table(46206) := '67687422297D7D66756E6374696F6E20724E28652C742C6E297B696628653C3D6E2972657475726E7B66726F6D3A302C746F3A657D3B696628743C30262628743D30292C743C3D653E3E31297B6C657420653D4D6174682E666C6F6F7228742F6E293B72';
wwv_flow_imp.g_varchar2_table(46207) := '657475726E7B66726F6D3A652A6E2C746F3A28652B31292A6E7D7D6C657420693D4D6174682E666C6F6F722828652D74292F6E293B72657475726E7B66726F6D3A652D28692B31292A6E2C746F3A652D692A6E7D7D636C61737320614E7B636F6E737472';
wwv_flow_imp.g_varchar2_table(46208) := '7563746F7228652C742C6E297B746869732E766965773D652C746869732E73746174654669656C643D742C746869732E6170706C79436F6D706C6574696F6E3D6E2C746869732E696E666F3D6E756C6C2C746869732E696E666F44657374726F793D6E75';
wwv_flow_imp.g_varchar2_table(46209) := '6C6C2C746869732E706C616365496E666F5265713D7B726561643A28293D3E746869732E6D656173757265496E666F28292C77726974653A653D3E746869732E706C616365496E666F2865292C6B65793A746869737D2C746869732E73706163653D6E75';
wwv_flow_imp.g_varchar2_table(46210) := '6C6C2C746869732E63757272656E74436C6173733D22223B6C657420693D652E73746174652E6669656C642874292C7B6F7074696F6E733A6F2C73656C65637465643A737D3D692E6F70656E2C723D652E73746174652E666163657428694E293B746869';
wwv_flow_imp.g_varchar2_table(46211) := '732E6F7074696F6E436F6E74656E743D66756E6374696F6E2865297B6C657420743D652E616464546F4F7074696F6E732E736C69636528293B72657475726E20652E69636F6E732626742E70757368287B72656E6465722865297B6C657420743D646F63';
wwv_flow_imp.g_varchar2_table(46212) := '756D656E742E637265617465456C656D656E74282264697622293B72657475726E20742E636C6173734C6973742E6164642822636D2D636F6D706C6574696F6E49636F6E22292C652E747970652626742E636C6173734C6973742E616464282E2E2E652E';
wwv_flow_imp.g_varchar2_table(46213) := '747970652E73706C6974282F5C732B2F67292E6D61702828653D3E22636D2D636F6D706C6574696F6E49636F6E2D222B652929292C742E7365744174747269627574652822617269612D68696464656E222C227472756522292C747D2C706F736974696F';
wwv_flow_imp.g_varchar2_table(46214) := '6E3A32307D292C742E70757368287B72656E64657228652C742C6E2C69297B6C6574206F3D646F63756D656E742E637265617465456C656D656E7428227370616E22293B6F2E636C6173734E616D653D22636D2D636F6D706C6574696F6E4C6162656C22';
wwv_flow_imp.g_varchar2_table(46215) := '3B6C657420733D652E646973706C61794C6162656C7C7C652E6C6162656C2C723D303B666F72286C657420653D303B653C692E6C656E6774683B297B6C657420743D695B652B2B5D2C6E3D695B652B2B5D3B743E7226266F2E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(46216) := '28646F63756D656E742E637265617465546578744E6F646528732E736C69636528722C742929293B6C657420613D6F2E617070656E644368696C6428646F63756D656E742E637265617465456C656D656E7428227370616E2229293B612E617070656E64';
wwv_flow_imp.g_varchar2_table(46217) := '4368696C6428646F63756D656E742E637265617465546578744E6F646528732E736C69636528742C6E2929292C612E636C6173734E616D653D22636D2D636F6D706C6574696F6E4D61746368656454657874222C723D6E7D72657475726E20723C732E6C';
wwv_flow_imp.g_varchar2_table(46218) := '656E67746826266F2E617070656E644368696C6428646F63756D656E742E637265617465546578744E6F646528732E736C69636528722929292C6F7D2C706F736974696F6E3A35307D2C7B72656E6465722865297B69662821652E64657461696C297265';
wwv_flow_imp.g_varchar2_table(46219) := '7475726E206E756C6C3B6C657420743D646F63756D656E742E637265617465456C656D656E7428227370616E22293B72657475726E20742E636C6173734E616D653D22636D2D636F6D706C6574696F6E44657461696C222C742E74657874436F6E74656E';
wwv_flow_imp.g_varchar2_table(46220) := '743D652E64657461696C2C747D2C706F736974696F6E3A38307D292C742E736F7274282828652C74293D3E652E706F736974696F6E2D742E706F736974696F6E29292E6D61702828653D3E652E72656E64657229297D2872292C746869732E6F7074696F';
wwv_flow_imp.g_varchar2_table(46221) := '6E436C6173733D722E6F7074696F6E436C6173732C746869732E746F6F6C746970436C6173733D722E746F6F6C746970436C6173732C746869732E72616E67653D724E286F2E6C656E6774682C732C722E6D617852656E64657265644F7074696F6E7329';
wwv_flow_imp.g_varchar2_table(46222) := '2C746869732E646F6D3D646F63756D656E742E637265617465456C656D656E74282264697622292C746869732E646F6D2E636C6173734E616D653D22636D2D746F6F6C7469702D6175746F636F6D706C657465222C746869732E757064617465546F6F6C';
wwv_flow_imp.g_varchar2_table(46223) := '746970436C61737328652E7374617465292C746869732E646F6D2E6164644576656E744C697374656E657228226D6F757365646F776E222C286E3D3E7B6C65747B6F7074696F6E733A697D3D652E73746174652E6669656C642874292E6F70656E3B666F';
wwv_flow_imp.g_varchar2_table(46224) := '72286C657420742C6F3D6E2E7461726765743B6F26266F213D746869732E646F6D3B6F3D6F2E706172656E744E6F646529696628224C49223D3D6F2E6E6F64654E616D65262628743D2F2D285C642B29242F2E65786563286F2E6964292926262B745B31';
wwv_flow_imp.g_varchar2_table(46225) := '5D3C692E6C656E6774682972657475726E20746869732E6170706C79436F6D706C6574696F6E28652C695B2B745B315D5D292C766F6964206E2E70726576656E7444656661756C7428297D29292C746869732E646F6D2E6164644576656E744C69737465';
wwv_flow_imp.g_varchar2_table(46226) := '6E65722822666F6375736F7574222C28743D3E7B6C6574206E3D652E73746174652E6669656C6428746869732E73746174654669656C642C2131293B6E26266E2E746F6F6C7469702626652E73746174652E666163657428694E292E636C6F73654F6E42';
wwv_flow_imp.g_varchar2_table(46227) := '6C75722626742E72656C61746564546172676574213D652E636F6E74656E74444F4D2626652E6469737061746368287B656666656374733A654E2E6F66286E756C6C297D297D29292C746869732E73686F774F7074696F6E73286F2C692E6964297D6D6F';
wwv_flow_imp.g_varchar2_table(46228) := '756E7428297B746869732E75706461746553656C28297D73686F774F7074696F6E7328652C74297B746869732E6C6973742626746869732E6C6973742E72656D6F766528292C746869732E6C6973743D746869732E646F6D2E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(46229) := '28746869732E6372656174654C697374426F7828652C742C746869732E72616E676529292C746869732E6C6973742E6164644576656E744C697374656E657228227363726F6C6C222C2828293D3E7B746869732E696E666F2626746869732E766965772E';
wwv_flow_imp.g_varchar2_table(46230) := '726571756573744D65617375726528746869732E706C616365496E666F526571297D29297D7570646174652865297B76617220743B6C6574206E3D652E73746174652E6669656C6428746869732E73746174654669656C64292C693D652E737461727453';
wwv_flow_imp.g_varchar2_table(46231) := '746174652E6669656C6428746869732E73746174654669656C64293B696628746869732E757064617465546F6F6C746970436C61737328652E7374617465292C6E213D69297B6C65747B6F7074696F6E733A6F2C73656C65637465643A732C6469736162';
wwv_flow_imp.g_varchar2_table(46232) := '6C65643A727D3D6E2E6F70656E3B692E6F70656E2626692E6F70656E2E6F7074696F6E733D3D6F7C7C28746869732E72616E67653D724E286F2E6C656E6774682C732C652E73746174652E666163657428694E292E6D617852656E64657265644F707469';
wwv_flow_imp.g_varchar2_table(46233) := '6F6E73292C746869732E73686F774F7074696F6E73286F2C6E2E696429292C746869732E75706461746553656C28292C72213D286E756C6C3D3D3D28743D692E6F70656E297C7C766F696420303D3D3D743F766F696420303A742E64697361626C656429';
wwv_flow_imp.g_varchar2_table(46234) := '2626746869732E646F6D2E636C6173734C6973742E746F67676C652822636D2D746F6F6C7469702D6175746F636F6D706C6574652D64697361626C6564222C212172297D7D757064617465546F6F6C746970436C6173732865297B6C657420743D746869';
wwv_flow_imp.g_varchar2_table(46235) := '732E746F6F6C746970436C6173732865293B69662874213D746869732E63757272656E74436C617373297B666F72286C65742065206F6620746869732E63757272656E74436C6173732E73706C6974282220222929652626746869732E646F6D2E636C61';
wwv_flow_imp.g_varchar2_table(46236) := '73734C6973742E72656D6F76652865293B666F72286C65742065206F6620742E73706C6974282220222929652626746869732E646F6D2E636C6173734C6973742E6164642865293B746869732E63757272656E74436C6173733D747D7D706F736974696F';
wwv_flow_imp.g_varchar2_table(46237) := '6E65642865297B746869732E73706163653D652C746869732E696E666F2626746869732E766965772E726571756573744D65617375726528746869732E706C616365496E666F526571297D75706461746553656C28297B6C657420653D746869732E7669';
wwv_flow_imp.g_varchar2_table(46238) := '65772E73746174652E6669656C6428746869732E73746174654669656C64292C743D652E6F70656E3B69662828742E73656C65637465643E2D312626742E73656C65637465643C746869732E72616E67652E66726F6D7C7C742E73656C65637465643E3D';
wwv_flow_imp.g_varchar2_table(46239) := '746869732E72616E67652E746F29262628746869732E72616E67653D724E28742E6F7074696F6E732E6C656E6774682C742E73656C65637465642C746869732E766965772E73746174652E666163657428694E292E6D617852656E64657265644F707469';
wwv_flow_imp.g_varchar2_table(46240) := '6F6E73292C746869732E73686F774F7074696F6E7328742E6F7074696F6E732C652E696429292C746869732E75706461746553656C65637465644F7074696F6E28742E73656C656374656429297B746869732E64657374726F79496E666F28293B6C6574';
wwv_flow_imp.g_varchar2_table(46241) := '7B636F6D706C6574696F6E3A6E7D3D742E6F7074696F6E735B742E73656C65637465645D2C7B696E666F3A697D3D6E3B69662821692972657475726E3B6C6574206F3D22737472696E67223D3D747970656F6620693F646F63756D656E742E6372656174';
wwv_flow_imp.g_varchar2_table(46242) := '65546578744E6F64652869293A69286E293B696628216F2972657475726E3B227468656E22696E206F3F6F2E7468656E2828743D3E7B742626746869732E766965772E73746174652E6669656C6428746869732E73746174654669656C642C2131293D3D';
wwv_flow_imp.g_varchar2_table(46243) := '652626746869732E616464496E666F50616E6528742C6E297D29292E63617463682828653D3E454428746869732E766965772E73746174652C652C22636F6D706C6574696F6E20696E666F222929293A746869732E616464496E666F50616E65286F2C6E';
wwv_flow_imp.g_varchar2_table(46244) := '297D7D616464496E666F50616E6528652C74297B746869732E64657374726F79496E666F28293B6C6574206E3D746869732E696E666F3D646F63756D656E742E637265617465456C656D656E74282264697622293B6966286E2E636C6173734E616D653D';
wwv_flow_imp.g_varchar2_table(46245) := '22636D2D746F6F6C74697020636D2D636F6D706C6574696F6E496E666F222C6E756C6C213D652E6E6F646554797065296E2E617070656E644368696C642865292C746869732E696E666F44657374726F793D6E756C6C3B656C73657B6C65747B646F6D3A';
wwv_flow_imp.g_varchar2_table(46246) := '742C64657374726F793A697D3D653B6E2E617070656E644368696C642874292C746869732E696E666F44657374726F793D697C7C6E756C6C7D746869732E646F6D2E617070656E644368696C64286E292C746869732E766965772E726571756573744D65';
wwv_flow_imp.g_varchar2_table(46247) := '617375726528746869732E706C616365496E666F526571297D75706461746553656C65637465644F7074696F6E2865297B6C657420743D6E756C6C3B666F72286C6574206E3D746869732E6C6973742E66697273744368696C642C693D746869732E7261';
wwv_flow_imp.g_varchar2_table(46248) := '6E67652E66726F6D3B6E3B6E3D6E2E6E6578745369626C696E672C692B2B29224C49223D3D6E2E6E6F64654E616D6526266E2E69643F693D3D653F6E2E6861734174747269627574652822617269612D73656C656374656422297C7C286E2E7365744174';
wwv_flow_imp.g_varchar2_table(46249) := '747269627574652822617269612D73656C6563746564222C227472756522292C743D6E293A6E2E6861734174747269627574652822617269612D73656C6563746564222926266E2E72656D6F76654174747269627574652822617269612D73656C656374';
wwv_flow_imp.g_varchar2_table(46250) := '656422293A692D2D3B72657475726E2074262666756E6374696F6E28652C74297B6C6574206E3D652E676574426F756E64696E67436C69656E745265637428292C693D742E676574426F756E64696E67436C69656E745265637428292C6F3D6E2E686569';
wwv_flow_imp.g_varchar2_table(46251) := '6768742F652E6F66667365744865696768743B692E746F703C6E2E746F703F652E7363726F6C6C546F702D3D286E2E746F702D692E746F70292F6F3A692E626F74746F6D3E6E2E626F74746F6D262628652E7363726F6C6C546F702B3D28692E626F7474';
wwv_flow_imp.g_varchar2_table(46252) := '6F6D2D6E2E626F74746F6D292F6F297D28746869732E6C6973742C74292C747D6D656173757265496E666F28297B6C657420653D746869732E646F6D2E717565727953656C6563746F7228225B617269612D73656C65637465645D22293B69662821657C';
wwv_flow_imp.g_varchar2_table(46253) := '7C21746869732E696E666F2972657475726E206E756C6C3B6C657420743D746869732E646F6D2E676574426F756E64696E67436C69656E745265637428292C6E3D746869732E696E666F2E676574426F756E64696E67436C69656E745265637428292C69';
wwv_flow_imp.g_varchar2_table(46254) := '3D652E676574426F756E64696E67436C69656E745265637428292C6F3D746869732E73706163653B696628216F297B6C657420653D746869732E646F6D2E6F776E6572446F63756D656E742E64656661756C74566965777C7C77696E646F773B6F3D7B6C';
wwv_flow_imp.g_varchar2_table(46255) := '6566743A302C746F703A302C72696768743A652E696E6E657257696474682C626F74746F6D3A652E696E6E65724865696768747D7D72657475726E20692E746F703E4D6174682E6D696E286F2E626F74746F6D2C742E626F74746F6D292D31307C7C692E';
wwv_flow_imp.g_varchar2_table(46256) := '626F74746F6D3C4D6174682E6D6178286F2E746F702C742E746F70292B31303F6E756C6C3A746869732E766965772E73746174652E666163657428694E292E706F736974696F6E496E666F28746869732E766965772C742C692C6E2C6F2C746869732E64';
wwv_flow_imp.g_varchar2_table(46257) := '6F6D297D706C616365496E666F2865297B746869732E696E666F262628653F28652E7374796C65262628746869732E696E666F2E7374796C652E637373546578743D652E7374796C65292C746869732E696E666F2E636C6173734E616D653D22636D2D74';
wwv_flow_imp.g_varchar2_table(46258) := '6F6F6C74697020636D2D636F6D706C6574696F6E496E666F20222B28652E636C6173737C7C222229293A746869732E696E666F2E7374796C652E637373546578743D22746F703A202D316536707822297D6372656174654C697374426F7828652C742C6E';
wwv_flow_imp.g_varchar2_table(46259) := '297B636F6E737420693D646F63756D656E742E637265617465456C656D656E742822756C22293B692E69643D742C692E7365744174747269627574652822726F6C65222C226C697374626F7822292C692E7365744174747269627574652822617269612D';
wwv_flow_imp.g_varchar2_table(46260) := '657870616E646564222C227472756522292C692E7365744174747269627574652822617269612D6C6162656C222C746869732E766965772E73746174652E7068726173652822436F6D706C6574696F6E732229293B6C6574206F3D6E756C6C3B666F7228';
wwv_flow_imp.g_varchar2_table(46261) := '6C657420733D6E2E66726F6D3B733C6E2E746F3B732B2B297B6C65747B636F6D706C6574696F6E3A722C6D617463683A617D3D655B735D2C7B73656374696F6E3A6C7D3D723B6966286C297B6C657420653D22737472696E67223D3D747970656F66206C';
wwv_flow_imp.g_varchar2_table(46262) := '3F6C3A6C2E6E616D653B65213D6F262628733E6E2E66726F6D7C7C303D3D6E2E66726F6D292626286F3D652C22737472696E6722213D747970656F66206C26266C2E6865616465723F692E617070656E644368696C64286C2E686561646572286C29293A';
wwv_flow_imp.g_varchar2_table(46263) := '692E617070656E644368696C6428646F63756D656E742E637265617465456C656D656E742822636F6D706C6574696F6E2D73656374696F6E2229292E74657874436F6E74656E743D65297D636F6E737420633D692E617070656E644368696C6428646F63';
wwv_flow_imp.g_varchar2_table(46264) := '756D656E742E637265617465456C656D656E7428226C692229293B632E69643D742B222D222B732C632E7365744174747269627574652822726F6C65222C226F7074696F6E22293B6C657420643D746869732E6F7074696F6E436C6173732872293B6426';
wwv_flow_imp.g_varchar2_table(46265) := '2628632E636C6173734E616D653D64293B666F72286C65742065206F6620746869732E6F7074696F6E436F6E74656E74297B6C657420743D6528722C746869732E766965772E73746174652C746869732E766965772C61293B742626632E617070656E64';
wwv_flow_imp.g_varchar2_table(46266) := '4368696C642874297D7D72657475726E206E2E66726F6D2626692E636C6173734C6973742E6164642822636D2D636F6D706C6574696F6E4C697374496E636F6D706C657465546F7022292C6E2E746F3C652E6C656E6774682626692E636C6173734C6973';
wwv_flow_imp.g_varchar2_table(46267) := '742E6164642822636D2D636F6D706C6574696F6E4C697374496E636F6D706C657465426F74746F6D22292C697D64657374726F79496E666F28297B746869732E696E666F262628746869732E696E666F44657374726F792626746869732E696E666F4465';
wwv_flow_imp.g_varchar2_table(46268) := '7374726F7928292C746869732E696E666F2E72656D6F766528292C746869732E696E666F3D6E756C6C297D64657374726F7928297B746869732E64657374726F79496E666F28297D7D66756E6374696F6E206C4E28652C74297B72657475726E206E3D3E';
wwv_flow_imp.g_varchar2_table(46269) := '6E657720614E286E2C652C74297D66756E6374696F6E20634E2865297B72657475726E203130302A28652E626F6F73747C7C30292B28652E6170706C793F31303A30292B28652E696E666F3F353A30292B28652E747970653F313A30297D636C61737320';
wwv_flow_imp.g_varchar2_table(46270) := '644E7B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E6F7074696F6E733D652C746869732E61747472733D742C746869732E746F6F6C7469703D6E2C746869732E74696D657374616D703D692C746869732E73656C65637465';
wwv_flow_imp.g_varchar2_table(46271) := '643D6F2C746869732E64697361626C65643D737D73657453656C656374656428652C74297B72657475726E20653D3D746869732E73656C65637465647C7C653E3D746869732E6F7074696F6E732E6C656E6774683F746869733A6E657720644E28746869';
wwv_flow_imp.g_varchar2_table(46272) := '732E6F7074696F6E732C674E28742C65292C746869732E746F6F6C7469702C746869732E74696D657374616D702C652C746869732E64697361626C6564297D737461746963206275696C6428652C742C6E2C692C6F297B6C657420733D66756E6374696F';
wwv_flow_imp.g_varchar2_table(46273) := '6E28652C74297B6C6574206E3D5B5D2C693D6E756C6C2C6F3D653D3E7B6E2E707573682865293B6C65747B73656374696F6E3A747D3D652E636F6D706C6574696F6E3B69662874297B697C7C28693D5B5D293B6C657420653D22737472696E67223D3D74';
wwv_flow_imp.g_varchar2_table(46274) := '7970656F6620743F743A742E6E616D653B692E736F6D652828743D3E742E6E616D653D3D6529297C7C692E707573682822737472696E67223D3D747970656F6620743F7B6E616D653A657D3A74297D7D2C733D742E666163657428694E293B666F72286C';
wwv_flow_imp.g_varchar2_table(46275) := '65742069206F66206529696628692E686173526573756C742829297B6C657420653D692E726573756C742E6765744D617463683B69662821313D3D3D692E726573756C742E66696C74657229666F72286C65742074206F6620692E726573756C742E6F70';
wwv_flow_imp.g_varchar2_table(46276) := '74696F6E73296F286E6577204B4128742C692E736F757263652C653F652874293A5B5D2C3165392D6E2E6C656E67746829293B656C73657B6C6574206E2C723D742E736C696365446F6328692E66726F6D2C692E746F292C613D732E66696C7465725374';
wwv_flow_imp.g_varchar2_table(46277) := '726963743F6E6577206E4E2872293A6E657720744E2872293B666F72286C65742074206F6620692E726573756C742E6F7074696F6E73296966286E3D612E6D6174636828742E6C6162656C29297B6C657420733D742E646973706C61794C6162656C3F65';
wwv_flow_imp.g_varchar2_table(46278) := '3F6528742C6E2E6D617463686564293A5B5D3A6E2E6D6174636865643B6F286E6577204B4128742C692E736F757263652C732C6E2E73636F72652B28742E626F6F73747C7C302929297D7D7D69662869297B6C657420653D4F626A6563742E6372656174';
wwv_flow_imp.g_varchar2_table(46279) := '65286E756C6C292C743D302C6F3D28652C74293D3E7B766172206E2C693B72657475726E286E756C6C213D3D286E3D652E72616E6B292626766F69642030213D3D6E3F6E3A316539292D286E756C6C213D3D28693D742E72616E6B292626766F69642030';
wwv_flow_imp.g_varchar2_table(46280) := '213D3D693F693A316539297C7C28652E6E616D653C742E6E616D653F2D313A31297D3B666F72286C6574206E206F6620692E736F7274286F2929742D3D3165352C655B6E2E6E616D655D3D743B666F72286C65742074206F66206E297B6C65747B736563';
wwv_flow_imp.g_varchar2_table(46281) := '74696F6E3A6E7D3D742E636F6D706C6574696F6E3B6E262628742E73636F72652B3D655B22737472696E67223D3D747970656F66206E3F6E3A6E2E6E616D655D297D7D6C657420723D5B5D2C613D6E756C6C2C6C3D732E636F6D70617265436F6D706C65';
wwv_flow_imp.g_varchar2_table(46282) := '74696F6E733B666F72286C65742065206F66206E2E736F7274282828652C74293D3E742E73636F72652D652E73636F72657C7C6C28652E636F6D706C6574696F6E2C742E636F6D706C6574696F6E292929297B6C657420743D652E636F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(46283) := '6E3B21617C7C612E6C6162656C213D742E6C6162656C7C7C612E64657461696C213D742E64657461696C7C7C6E756C6C213D612E7479706526266E756C6C213D742E747970652626612E74797065213D742E747970657C7C612E6170706C79213D742E61';
wwv_flow_imp.g_varchar2_table(46284) := '70706C797C7C612E626F6F7374213D742E626F6F73743F722E707573682865293A634E28652E636F6D706C6574696F6E293E634E286129262628725B722E6C656E6774682D315D3D65292C613D652E636F6D706C6574696F6E7D72657475726E20727D28';
wwv_flow_imp.g_varchar2_table(46285) := '652C74293B69662821732E6C656E6774682972657475726E20692626652E736F6D652828653D3E313D3D652E737461746529293F6E657720644E28692E6F7074696F6E732C692E61747472732C692E746F6F6C7469702C692E74696D657374616D702C69';
wwv_flow_imp.g_varchar2_table(46286) := '2E73656C65637465642C2130293A6E756C6C3B6C657420723D742E666163657428694E292E73656C6563744F6E4F70656E3F303A2D313B696628692626692E73656C6563746564213D7226262D31213D692E73656C6563746564297B6C657420653D692E';
wwv_flow_imp.g_varchar2_table(46287) := '6F7074696F6E735B692E73656C65637465645D2E636F6D706C6574696F6E3B666F72286C657420743D303B743C732E6C656E6774683B742B2B29696628735B745D2E636F6D706C6574696F6E3D3D65297B723D743B627265616B7D7D72657475726E206E';
wwv_flow_imp.g_varchar2_table(46288) := '657720644E28732C674E286E2C72292C7B706F733A652E726564756365282828652C74293D3E742E686173526573756C7428293F4D6174682E6D696E28652C742E66726F6D293A65292C316538292C6372656174653A534E2C61626F76653A6F2E61626F';
wwv_flow_imp.g_varchar2_table(46289) := '7665437572736F727D2C693F692E74696D657374616D703A446174652E6E6F7728292C722C2131297D6D61702865297B72657475726E206E657720644E28746869732E6F7074696F6E732C746869732E61747472732C4F626A6563742E61737369676E28';
wwv_flow_imp.g_varchar2_table(46290) := '4F626A6563742E61737369676E287B7D2C746869732E746F6F6C746970292C7B706F733A652E6D6170506F7328746869732E746F6F6C7469702E706F73297D292C746869732E74696D657374616D702C746869732E73656C65637465642C746869732E64';
wwv_flow_imp.g_varchar2_table(46291) := '697361626C6564297D7D636C61737320684E7B636F6E7374727563746F7228652C742C6E297B746869732E6163746976653D652C746869732E69643D742C746869732E6F70656E3D6E7D73746174696320737461727428297B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(46292) := '684E286D4E2C22636D2D61632D222B4D6174682E666C6F6F72283265362A4D6174682E72616E646F6D2829292E746F537472696E67283336292C6E756C6C297D7570646174652865297B6C65747B73746174653A747D3D652C6E3D742E66616365742869';
wwv_flow_imp.g_varchar2_table(46293) := '4E292C693D286E2E6F766572726964657C7C742E6C616E677561676544617461417428226175746F636F6D706C657465222C4741287429292E6D617028584129292E6D61702828743D3E7B6C657420693D746869732E6163746976652E66696E64282865';
wwv_flow_imp.g_varchar2_table(46294) := '3D3E652E736F757263653D3D7429297C7C6E657720764E28742C746869732E6163746976652E736F6D652828653D3E30213D652E737461746529293F313A30293B72657475726E20692E75706461746528652C6E297D29293B692E6C656E6774683D3D74';
wwv_flow_imp.g_varchar2_table(46295) := '6869732E6163746976652E6C656E6774682626692E6576657279282828652C74293D3E653D3D746869732E6163746976655B745D2929262628693D746869732E616374697665293B6C6574206F3D746869732E6F70656E3B6F2626652E646F634368616E';
wwv_flow_imp.g_varchar2_table(46296) := '6765642626286F3D6F2E6D617028652E6368616E67657329292C652E73656C656374696F6E7C7C692E736F6D652828743D3E742E686173526573756C7428292626652E6368616E6765732E746F756368657352616E676528742E66726F6D2C742E746F29';
wwv_flow_imp.g_varchar2_table(46297) := '29297C7C2166756E6374696F6E28652C74297B696628653D3D742972657475726E21303B666F72286C6574206E3D302C693D303B3B297B666F72283B6E3C652E6C656E677468262621655B6E5D2E686173526573756C743B296E2B2B3B666F72283B693C';
wwv_flow_imp.g_varchar2_table(46298) := '742E6C656E677468262621745B695D2E686173526573756C743B29692B2B3B6C6574206F3D6E3D3D652E6C656E6774682C733D693D3D742E6C656E6774683B6966286F7C7C732972657475726E206F3D3D733B696628655B6E2B2B5D2E726573756C7421';
wwv_flow_imp.g_varchar2_table(46299) := '3D745B692B2B5D2E726573756C742972657475726E21317D7D28692C746869732E616374697665293F6F3D644E2E6275696C6428692C742C746869732E69642C6F2C6E293A6F26266F2E64697361626C6564262621692E736F6D652828653D3E313D3D65';
wwv_flow_imp.g_varchar2_table(46300) := '2E737461746529292626286F3D6E756C6C292C216F2626692E65766572792828653D3E31213D652E737461746529292626692E736F6D652828653D3E652E686173526573756C7428292929262628693D692E6D61702828653D3E652E686173526573756C';
wwv_flow_imp.g_varchar2_table(46301) := '7428293F6E657720764E28652E736F757263652C30293A652929293B666F72286C65742074206F6620652E6566666563747329742E697328794E292626286F3D6F26266F2E73657453656C656374656428742E76616C75652C746869732E696429293B72';
wwv_flow_imp.g_varchar2_table(46302) := '657475726E20693D3D746869732E61637469766526266F3D3D746869732E6F70656E3F746869733A6E657720684E28692C746869732E69642C6F297D67657420746F6F6C74697028297B72657475726E20746869732E6F70656E3F746869732E6F70656E';
wwv_flow_imp.g_varchar2_table(46303) := '2E746F6F6C7469703A6E756C6C7D67657420617474727328297B72657475726E20746869732E6F70656E3F746869732E6F70656E2E61747472733A746869732E6163746976652E6C656E6774683F754E3A704E7D7D636F6E737420754E3D7B2261726961';
wwv_flow_imp.g_varchar2_table(46304) := '2D6175746F636F6D706C657465223A226C697374227D2C704E3D7B7D3B66756E6374696F6E20674E28652C74297B6C6574206E3D7B22617269612D6175746F636F6D706C657465223A226C697374222C22617269612D686173706F707570223A226C6973';
wwv_flow_imp.g_varchar2_table(46305) := '74626F78222C22617269612D636F6E74726F6C73223A657D3B72657475726E20743E2D312626286E5B22617269612D61637469766564657363656E64616E74225D3D652B222D222B74292C6E7D636F6E7374206D4E3D5B5D3B66756E6374696F6E20664E';
wwv_flow_imp.g_varchar2_table(46306) := '28652C74297B696628652E6973557365724576656E742822696E7075742E636F6D706C6574652229297B6C6574206E3D652E616E6E6F746174696F6E285941293B6966286E2626742E61637469766174654F6E436F6D706C6574696F6E286E2929726574';
wwv_flow_imp.g_varchar2_table(46307) := '75726E2031327D6C6574206E3D652E6973557365724576656E742822696E7075742E7479706522293B72657475726E206E2626742E61637469766174654F6E547970696E673F353A6E3F313A652E6973557365724576656E74282264656C6574652E6261';
wwv_flow_imp.g_varchar2_table(46308) := '636B7761726422293F323A652E73656C656374696F6E3F383A652E646F634368616E6765643F31363A307D636C61737320764E7B636F6E7374727563746F7228652C742C6E3D2D31297B746869732E736F757263653D652C746869732E73746174653D74';
wwv_flow_imp.g_varchar2_table(46309) := '2C746869732E6578706C69636974506F733D6E7D686173526573756C7428297B72657475726E21317D75706461746528652C74297B6C6574206E3D664E28652C74292C693D746869733B2838266E7C7C3136266E2626746869732E746F75636865732865';
wwv_flow_imp.g_varchar2_table(46310) := '2929262628693D6E657720764E28692E736F757263652C3029292C34266E2626303D3D692E7374617465262628693D6E657720764E28746869732E736F757263652C3129292C693D692E757064617465466F7228652C6E293B666F72286C65742074206F';
wwv_flow_imp.g_varchar2_table(46311) := '6620652E6566666563747329696628742E6973284A412929693D6E657720764E28692E736F757263652C312C742E76616C75653F474128652E7374617465293A2D31293B656C736520696628742E697328654E2929693D6E657720764E28692E736F7572';
wwv_flow_imp.g_varchar2_table(46312) := '63652C30293B656C736520696628742E6973285F4E2929666F72286C65742065206F6620742E76616C756529652E736F757263653D3D692E736F75726365262628693D65293B72657475726E20697D757064617465466F7228652C74297B72657475726E';
wwv_flow_imp.g_varchar2_table(46313) := '20746869732E6D617028652E6368616E676573297D6D61702865297B72657475726E20652E656D7074797C7C746869732E6578706C69636974506F733C303F746869733A6E657720764E28746869732E736F757263652C746869732E73746174652C652E';
wwv_flow_imp.g_varchar2_table(46314) := '6D6170506F7328746869732E6578706C69636974506F7329297D746F75636865732865297B72657475726E20652E6368616E6765732E746F756368657352616E676528474128652E737461746529297D7D636C61737320624E20657874656E647320764E';
wwv_flow_imp.g_varchar2_table(46315) := '7B636F6E7374727563746F7228652C742C6E2C692C6F297B737570657228652C322C74292C746869732E726573756C743D6E2C746869732E66726F6D3D692C746869732E746F3D6F7D686173526573756C7428297B72657475726E21307D757064617465';
wwv_flow_imp.g_varchar2_table(46316) := '466F7228652C74297B766172206E3B6966282128332674292972657475726E20746869732E6D617028652E6368616E676573293B6C657420693D746869732E726573756C743B692E6D6170262621652E6368616E6765732E656D707479262628693D692E';
wwv_flow_imp.g_varchar2_table(46317) := '6D617028692C652E6368616E67657329293B6C6574206F3D652E6368616E6765732E6D6170506F7328746869732E66726F6D292C733D652E6368616E6765732E6D6170506F7328746869732E746F2C31292C723D474128652E7374617465293B69662828';
wwv_flow_imp.g_varchar2_table(46318) := '746869732E6578706C69636974506F733C303F723C3D6F3A723C746869732E66726F6D297C7C723E737C7C21697C7C3226742626474128652E73746172745374617465293D3D746869732E66726F6D2972657475726E206E657720764E28746869732E73';
wwv_flow_imp.g_varchar2_table(46319) := '6F757263652C3426743F313A30293B6C657420613D746869732E6578706C69636974506F733C303F2D313A652E6368616E6765732E6D6170506F7328746869732E6578706C69636974506F73293B72657475726E2066756E6374696F6E28652C742C6E2C';
wwv_flow_imp.g_varchar2_table(46320) := '69297B69662821652972657475726E21313B6C6574206F3D742E736C696365446F63286E2C69293B72657475726E2266756E6374696F6E223D3D747970656F6620653F65286F2C6E2C692C74293A514128652C2130292E74657374286F297D28692E7661';
wwv_flow_imp.g_varchar2_table(46321) := '6C6964466F722C652E73746174652C6F2C73293F6E657720624E28746869732E736F757263652C612C692C6F2C73293A692E757064617465262628693D692E75706461746528692C6F2C732C6E657720714128652E73746174652C722C613E3D30292929';
wwv_flow_imp.g_varchar2_table(46322) := '3F6E657720624E28746869732E736F757263652C612C692C692E66726F6D2C6E756C6C213D3D286E3D692E746F292626766F69642030213D3D6E3F6E3A474128652E737461746529293A6E657720764E28746869732E736F757263652C312C61297D6D61';
wwv_flow_imp.g_varchar2_table(46323) := '702865297B72657475726E20652E656D7074793F746869733A28746869732E726573756C742E6D61703F746869732E726573756C742E6D617028746869732E726573756C742C65293A746869732E726573756C74293F6E657720624E28746869732E736F';
wwv_flow_imp.g_varchar2_table(46324) := '757263652C746869732E6578706C69636974506F733C303F2D313A652E6D6170506F7328746869732E6578706C69636974506F73292C746869732E726573756C742C652E6D6170506F7328746869732E66726F6D292C652E6D6170506F7328746869732E';
wwv_flow_imp.g_varchar2_table(46325) := '746F2C3129293A6E657720764E28746869732E736F757263652C30297D746F75636865732865297B72657475726E20652E6368616E6765732E746F756368657352616E676528746869732E66726F6D2C746869732E746F297D7D636F6E7374205F4E3D24';
wwv_flow_imp.g_varchar2_table(46326) := '6B2E646566696E65287B6D61703A28652C74293D3E652E6D61702828653D3E652E6D617028742929297D292C794E3D246B2E646566696E6528292C774E3D456B2E646566696E65287B6372656174653A28293D3E684E2E737461727428292C7570646174';
wwv_flow_imp.g_varchar2_table(46327) := '653A28652C74293D3E652E7570646174652874292C70726F766964653A653D3E5B4A492E66726F6D28652C28653D3E652E746F6F6C74697029292C44492E636F6E74656E74417474726962757465732E66726F6D28652C28653D3E652E61747472732929';
wwv_flow_imp.g_varchar2_table(46328) := '5D7D293B66756E6374696F6E20434E28652C74297B636F6E7374206E3D742E636F6D706C6574696F6E2E6170706C797C7C742E636F6D706C6574696F6E2E6C6162656C3B6C657420693D652E73746174652E6669656C6428774E292E6163746976652E66';
wwv_flow_imp.g_varchar2_table(46329) := '696E642828653D3E652E736F757263653D3D742E736F7572636529293B72657475726E206920696E7374616E63656F6620624E26262822737472696E67223D3D747970656F66206E3F652E6469737061746368284F626A6563742E61737369676E284F62';
wwv_flow_imp.g_varchar2_table(46330) := '6A6563742E61737369676E287B7D2C66756E6374696F6E28652C742C6E2C69297B6C65747B6D61696E3A6F7D3D652E73656C656374696F6E2C733D6E2D6F2E66726F6D2C723D692D6F2E66726F6D3B72657475726E204F626A6563742E61737369676E28';
wwv_flow_imp.g_varchar2_table(46331) := '4F626A6563742E61737369676E287B7D2C652E6368616E6765427952616E67652828613D3E61213D6F26266E213D692626652E736C696365446F6328612E66726F6D2B732C612E66726F6D2B7229213D652E736C696365446F63286E2C69293F7B72616E';
wwv_flow_imp.g_varchar2_table(46332) := '67653A617D3A7B6368616E6765733A7B66726F6D3A612E66726F6D2B732C746F3A693D3D6F2E66726F6D3F612E746F3A612E66726F6D2B722C696E736572743A747D2C72616E67653A666B2E637572736F7228612E66726F6D2B732B742E6C656E677468';
wwv_flow_imp.g_varchar2_table(46333) := '297D2929292C7B7363726F6C6C496E746F566965773A21302C757365724576656E743A22696E7075742E636F6D706C657465227D297D28652E73746174652C6E2C692E66726F6D2C692E746F29292C7B616E6E6F746174696F6E733A59412E6F6628742E';
wwv_flow_imp.g_varchar2_table(46334) := '636F6D706C6574696F6E297D29293A6E28652C742E636F6D706C6574696F6E2C692E66726F6D2C692E746F292C2130297D636F6E737420534E3D6C4E28774E2C434E293B66756E6374696F6E20784E28652C743D226F7074696F6E22297B72657475726E';
wwv_flow_imp.g_varchar2_table(46335) := '206E3D3E7B6C657420693D6E2E73746174652E6669656C6428774E2C2131293B69662821697C7C21692E6F70656E7C7C692E6F70656E2E64697361626C65647C7C446174652E6E6F7728292D692E6F70656E2E74696D657374616D703C6E2E7374617465';
wwv_flow_imp.g_varchar2_table(46336) := '2E666163657428694E292E696E746572616374696F6E44656C61792972657475726E21313B6C6574206F2C733D313B2270616765223D3D742626286F3D724D286E2C692E6F70656E2E746F6F6C7469702929262628733D4D6174682E6D617828322C4D61';
wwv_flow_imp.g_varchar2_table(46337) := '74682E666C6F6F72286F2E646F6D2E6F66667365744865696768742F6F2E646F6D2E717565727953656C6563746F7228226C6922292E6F6666736574486569676874292D3129293B6C65747B6C656E6774683A727D3D692E6F70656E2E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(46338) := '2C613D692E6F70656E2E73656C65637465643E2D313F692E6F70656E2E73656C65637465642B732A28653F313A2D31293A653F303A722D313B72657475726E20613C303F613D2270616765223D3D743F303A722D313A613E3D72262628613D2270616765';
wwv_flow_imp.g_varchar2_table(46339) := '223D3D743F722D313A30292C6E2E6469737061746368287B656666656374733A794E2E6F662861297D292C21307D7D636C617373206B4E7B636F6E7374727563746F7228652C74297B746869732E6163746976653D652C746869732E636F6E746578743D';
wwv_flow_imp.g_varchar2_table(46340) := '742C746869732E74696D653D446174652E6E6F7728292C746869732E757064617465733D5B5D2C746869732E646F6E653D766F696420307D7D636F6E737420454E3D49442E66726F6D436C61737328636C6173737B636F6E7374727563746F722865297B';
wwv_flow_imp.g_varchar2_table(46341) := '746869732E766965773D652C746869732E6465626F756E63655570646174653D2D312C746869732E72756E6E696E673D5B5D2C746869732E6465626F756E63654163636570743D2D312C746869732E70656E64696E6753746172743D21312C746869732E';
wwv_flow_imp.g_varchar2_table(46342) := '636F6D706F73696E673D303B666F72286C65742074206F6620652E73746174652E6669656C6428774E292E61637469766529313D3D742E73746174652626746869732E737461727451756572792874297D7570646174652865297B6C657420743D652E73';
wwv_flow_imp.g_varchar2_table(46343) := '746174652E6669656C6428774E292C6E3D652E73746174652E666163657428694E293B69662821652E73656C656374696F6E536574262621652E646F634368616E6765642626652E737461727453746174652E6669656C6428774E293D3D742972657475';
wwv_flow_imp.g_varchar2_table(46344) := '726E3B6C657420693D652E7472616E73616374696F6E732E736F6D652828653D3E7B6C657420743D664E28652C6E293B72657475726E203826747C7C28652E73656C656374696F6E7C7C652E646F634368616E6765642926262128332674297D29293B66';
wwv_flow_imp.g_varchar2_table(46345) := '6F72286C657420743D303B743C746869732E72756E6E696E672E6C656E6774683B742B2B297B6C6574206E3D746869732E72756E6E696E675B745D3B696628697C7C6E2E636F6E746578742E61626F72744F6E446F634368616E67652626652E646F6343';
wwv_flow_imp.g_varchar2_table(46346) := '68616E6765647C7C6E2E757064617465732E6C656E6774682B652E7472616E73616374696F6E732E6C656E6774683E35302626446174652E6E6F7728292D6E2E74696D653E316533297B666F72286C65742065206F66206E2E636F6E746578742E61626F';
wwv_flow_imp.g_varchar2_table(46347) := '72744C697374656E657273297472797B6528297D63617463682865297B454428746869732E766965772E73746174652C65297D6E2E636F6E746578742E61626F72744C697374656E6572733D6E756C6C2C746869732E72756E6E696E672E73706C696365';
wwv_flow_imp.g_varchar2_table(46348) := '28742D2D2C31297D656C7365206E2E757064617465732E70757368282E2E2E652E7472616E73616374696F6E73297D746869732E6465626F756E63655570646174653E2D312626636C65617254696D656F757428746869732E6465626F756E6365557064';
wwv_flow_imp.g_varchar2_table(46349) := '617465292C652E7472616E73616374696F6E732E736F6D652828653D3E652E656666656374732E736F6D652828653D3E652E6973284A412929292929262628746869732E70656E64696E6753746172743D2130293B6C6574206F3D746869732E70656E64';
wwv_flow_imp.g_varchar2_table(46350) := '696E6753746172743F35303A6E2E61637469766174654F6E547970696E6744656C61793B696628746869732E6465626F756E63655570646174653D742E6163746976652E736F6D652828653D3E313D3D652E7374617465262621746869732E72756E6E69';
wwv_flow_imp.g_varchar2_table(46351) := '6E672E736F6D652828743D3E742E6163746976652E736F757263653D3D652E736F75726365292929293F73657454696D656F7574282828293D3E746869732E73746172745570646174652829292C6F293A2D312C30213D746869732E636F6D706F73696E';
wwv_flow_imp.g_varchar2_table(46352) := '6729666F72286C65742074206F6620652E7472616E73616374696F6E7329742E6973557365724576656E742822696E7075742E7479706522293F746869732E636F6D706F73696E673D323A323D3D746869732E636F6D706F73696E672626742E73656C65';
wwv_flow_imp.g_varchar2_table(46353) := '6374696F6E262628746869732E636F6D706F73696E673D33297D737461727455706461746528297B746869732E6465626F756E63655570646174653D2D312C746869732E70656E64696E6753746172743D21313B6C65747B73746174653A657D3D746869';
wwv_flow_imp.g_varchar2_table(46354) := '732E766965772C743D652E6669656C6428774E293B666F72286C65742065206F6620742E6163746976652931213D652E73746174657C7C746869732E72756E6E696E672E736F6D652828743D3E742E6163746976652E736F757263653D3D652E736F7572';
wwv_flow_imp.g_varchar2_table(46355) := '636529297C7C746869732E737461727451756572792865297D737461727451756572792865297B6C65747B73746174653A747D3D746869732E766965772C6E3D47412874292C693D6E657720714128742C6E2C652E6578706C69636974506F733D3D6E2C';
wwv_flow_imp.g_varchar2_table(46356) := '746869732E76696577292C6F3D6E6577206B4E28652C69293B746869732E72756E6E696E672E70757368286F292C50726F6D6973652E7265736F6C766528652E736F75726365286929292E7468656E2828653D3E7B6F2E636F6E746578742E61626F7274';
wwv_flow_imp.g_varchar2_table(46357) := '65647C7C286F2E646F6E653D657C7C6E756C6C2C746869732E7363686564756C654163636570742829297D292C28653D3E7B746869732E766965772E6469737061746368287B656666656374733A654E2E6F66286E756C6C297D292C454428746869732E';
wwv_flow_imp.g_varchar2_table(46358) := '766965772E73746174652C65297D29297D7363686564756C6541636365707428297B746869732E72756E6E696E672E65766572792828653D3E766F69642030213D3D652E646F6E6529293F746869732E61636365707428293A746869732E6465626F756E';
wwv_flow_imp.g_varchar2_table(46359) := '63654163636570743C30262628746869732E6465626F756E63654163636570743D73657454696D656F7574282828293D3E746869732E6163636570742829292C746869732E766965772E73746174652E666163657428694E292E75706461746553796E63';
wwv_flow_imp.g_varchar2_table(46360) := '54696D6529297D61636365707428297B76617220653B746869732E6465626F756E63654163636570743E2D312626636C65617254696D656F757428746869732E6465626F756E6365416363657074292C746869732E6465626F756E63654163636570743D';
wwv_flow_imp.g_varchar2_table(46361) := '2D313B6C657420743D5B5D2C6E3D746869732E766965772E73746174652E666163657428694E293B666F72286C657420693D303B693C746869732E72756E6E696E672E6C656E6774683B692B2B297B6C6574206F3D746869732E72756E6E696E675B695D';
wwv_flow_imp.g_varchar2_table(46362) := '3B696628766F696420303D3D3D6F2E646F6E6529636F6E74696E75653B696628746869732E72756E6E696E672E73706C69636528692D2D2C31292C6F2E646F6E65297B6C657420693D6E657720624E286F2E6163746976652E736F757263652C6F2E6163';
wwv_flow_imp.g_varchar2_table(46363) := '746976652E6578706C69636974506F732C6F2E646F6E652C6F2E646F6E652E66726F6D2C6E756C6C213D3D28653D6F2E646F6E652E746F292626766F69642030213D3D653F653A4741286F2E757064617465732E6C656E6774683F6F2E75706461746573';
wwv_flow_imp.g_varchar2_table(46364) := '5B305D2E737461727453746174653A746869732E766965772E737461746529293B666F72286C65742065206F66206F2E7570646174657329693D692E75706461746528652C6E293B696628692E686173526573756C742829297B742E707573682869293B';
wwv_flow_imp.g_varchar2_table(46365) := '636F6E74696E75657D7D6C657420733D746869732E766965772E73746174652E6669656C6428774E292E6163746976652E66696E642828653D3E652E736F757263653D3D6F2E6163746976652E736F7572636529293B696628732626313D3D732E737461';
wwv_flow_imp.g_varchar2_table(46366) := '7465296966286E756C6C3D3D6F2E646F6E65297B6C657420653D6E657720764E286F2E6163746976652E736F757263652C30293B666F72286C65742074206F66206F2E7570646174657329653D652E75706461746528742C6E293B31213D652E73746174';
wwv_flow_imp.g_varchar2_table(46367) := '652626742E707573682865297D656C736520746869732E737461727451756572792873297D742E6C656E6774682626746869732E766965772E6469737061746368287B656666656374733A5F4E2E6F662874297D297D7D2C7B6576656E7448616E646C65';
wwv_flow_imp.g_varchar2_table(46368) := '72733A7B626C75722865297B6C657420743D746869732E766965772E73746174652E6669656C6428774E2C2131293B696628742626742E746F6F6C7469702626746869732E766965772E73746174652E666163657428694E292E636C6F73654F6E426C75';
wwv_flow_imp.g_varchar2_table(46369) := '72297B6C6574206E3D742E6F70656E2626724D28746869732E766965772C742E6F70656E2E746F6F6C746970293B6E26266E2E646F6D2E636F6E7461696E7328652E72656C61746564546172676574297C7C73657454696D656F7574282828293D3E7468';
wwv_flow_imp.g_varchar2_table(46370) := '69732E766965772E6469737061746368287B656666656374733A654E2E6F66286E756C6C297D29292C3130297D7D2C636F6D706F736974696F6E737461727428297B746869732E636F6D706F73696E673D317D2C636F6D706F736974696F6E656E642829';
wwv_flow_imp.g_varchar2_table(46371) := '7B333D3D746869732E636F6D706F73696E67262673657454696D656F7574282828293D3E746869732E766965772E6469737061746368287B656666656374733A4A412E6F66282131297D29292C3230292C746869732E636F6D706F73696E673D307D7D7D';
wwv_flow_imp.g_varchar2_table(46372) := '292C4C4E3D226F626A656374223D3D747970656F66206E6176696761746F7226262F57696E2F2E74657374286E6176696761746F722E706C6174666F726D292C444E3D446B2E686967686573742844492E646F6D4576656E7448616E646C657273287B6B';
wwv_flow_imp.g_varchar2_table(46373) := '6579646F776E28652C74297B6C6574206E3D742E73746174652E6669656C6428774E2C2131293B696628216E7C7C216E2E6F70656E7C7C6E2E6F70656E2E64697361626C65647C7C6E2E6F70656E2E73656C65637465643C307C7C652E6B65792E6C656E';
wwv_flow_imp.g_varchar2_table(46374) := '6774683E317C7C652E6374726C4B6579262628214C4E7C7C21652E616C744B6579297C7C652E6D6574614B65792972657475726E21313B6C657420693D6E2E6F70656E2E6F7074696F6E735B6E2E6F70656E2E73656C65637465645D2C6F3D6E2E616374';
wwv_flow_imp.g_varchar2_table(46375) := '6976652E66696E642828653D3E652E736F757263653D3D692E736F7572636529292C733D692E636F6D706C6574696F6E2E636F6D6D6974436861726163746572737C7C6F2E726573756C742E636F6D6D6974436861726163746572733B72657475726E20';
wwv_flow_imp.g_varchar2_table(46376) := '732626732E696E6465784F6628652E6B6579293E2D312626434E28742C69292C21317D7D29292C544E3D44492E626173655468656D65287B222E636D2D746F6F6C7469702E636D2D746F6F6C7469702D6175746F636F6D706C657465223A7B2226203E20';
wwv_flow_imp.g_varchar2_table(46377) := '756C223A7B666F6E7446616D696C793A226D6F6E6F7370616365222C776869746553706163653A226E6F77726170222C6F766572666C6F773A2268696464656E206175746F222C6D617857696474685F66616C6C6261636B3A223730307078222C6D6178';
wwv_flow_imp.g_varchar2_table(46378) := '57696474683A226D696E2837303070782C203935767729222C6D696E57696474683A223235307078222C6D61784865696768743A223130656D222C6865696768743A2231303025222C6C6973745374796C653A226E6F6E65222C6D617267696E3A302C70';
wwv_flow_imp.g_varchar2_table(46379) := '616464696E673A302C2226203E206C692C2026203E20636F6D706C6574696F6E2D73656374696F6E223A7B70616464696E673A2231707820337078222C6C696E654865696768743A312E327D2C2226203E206C69223A7B6F766572666C6F77583A226869';
wwv_flow_imp.g_varchar2_table(46380) := '6464656E222C746578744F766572666C6F773A22656C6C6970736973222C637572736F723A22706F696E746572227D2C2226203E20636F6D706C6574696F6E2D73656374696F6E223A7B646973706C61793A226C6973742D6974656D222C626F72646572';
wwv_flow_imp.g_varchar2_table(46381) := '426F74746F6D3A2231707820736F6C69642073696C766572222C70616464696E674C6566743A22302E35656D222C6F7061636974793A2E377D7D7D2C22266C69676874202E636D2D746F6F6C7469702D6175746F636F6D706C65746520756C206C695B61';
wwv_flow_imp.g_varchar2_table(46382) := '7269612D73656C65637465645D223A7B6261636B67726F756E643A2223313763222C636F6C6F723A227768697465227D2C22266C69676874202E636D2D746F6F6C7469702D6175746F636F6D706C6574652D64697361626C656420756C206C695B617269';
wwv_flow_imp.g_varchar2_table(46383) := '612D73656C65637465645D223A7B6261636B67726F756E643A2223373737227D2C22266461726B202E636D2D746F6F6C7469702D6175746F636F6D706C65746520756C206C695B617269612D73656C65637465645D223A7B6261636B67726F756E643A22';
wwv_flow_imp.g_varchar2_table(46384) := '23333437222C636F6C6F723A227768697465227D2C22266461726B202E636D2D746F6F6C7469702D6175746F636F6D706C6574652D64697361626C656420756C206C695B617269612D73656C65637465645D223A7B6261636B67726F756E643A22233434';
wwv_flow_imp.g_varchar2_table(46385) := '34227D2C222E636D2D636F6D706C6574696F6E4C697374496E636F6D706C657465546F703A6265666F72652C202E636D2D636F6D706C6574696F6E4C697374496E636F6D706C657465426F74746F6D3A6166746572223A7B636F6E74656E743A2722C2B7';
wwv_flow_imp.g_varchar2_table(46386) := 'C2B7C2B722272C6F7061636974793A2E352C646973706C61793A22626C6F636B222C74657874416C69676E3A2263656E746572227D2C222E636D2D746F6F6C7469702E636D2D636F6D706C6574696F6E496E666F223A7B706F736974696F6E3A22616273';
wwv_flow_imp.g_varchar2_table(46387) := '6F6C757465222C70616464696E673A2233707820397078222C77696474683A226D61782D636F6E74656E74222C6D617857696474683A223430307078222C626F7853697A696E673A22626F726465722D626F78222C776869746553706163653A22707265';
wwv_flow_imp.g_varchar2_table(46388) := '2D6C696E65227D2C222E636D2D636F6D706C6574696F6E496E666F2E636D2D636F6D706C6574696F6E496E666F2D6C656674223A7B72696768743A2231303025227D2C222E636D2D636F6D706C6574696F6E496E666F2E636D2D636F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(46389) := '496E666F2D7269676874223A7B6C6566743A2231303025227D2C222E636D2D636F6D706C6574696F6E496E666F2E636D2D636F6D706C6574696F6E496E666F2D6C6566742D6E6172726F77223A7B72696768743A2233307078227D2C222E636D2D636F6D';
wwv_flow_imp.g_varchar2_table(46390) := '706C6574696F6E496E666F2E636D2D636F6D706C6574696F6E496E666F2D72696768742D6E6172726F77223A7B6C6566743A2233307078227D2C22266C69676874202E636D2D736E69707065744669656C64223A7B6261636B67726F756E64436F6C6F72';
wwv_flow_imp.g_varchar2_table(46391) := '3A22233030303030303232227D2C22266461726B202E636D2D736E69707065744669656C64223A7B6261636B67726F756E64436F6C6F723A22236666666666663232227D2C222E636D2D736E69707065744669656C64506F736974696F6E223A7B766572';
wwv_flow_imp.g_varchar2_table(46392) := '746963616C416C69676E3A22746578742D746F70222C77696474683A302C6865696768743A22312E3135656D222C646973706C61793A22696E6C696E652D626C6F636B222C6D617267696E3A2230202D302E377078202D2E37656D222C626F726465724C';
wwv_flow_imp.g_varchar2_table(46393) := '6566743A22312E34707820646F747465642023383838227D2C222E636D2D636F6D706C6574696F6E4D61746368656454657874223A7B746578744465636F726174696F6E3A22756E6465726C696E65227D2C222E636D2D636F6D706C6574696F6E446574';
wwv_flow_imp.g_varchar2_table(46394) := '61696C223A7B6D617267696E4C6566743A22302E35656D222C666F6E745374796C653A226974616C6963227D2C222E636D2D636F6D706C6574696F6E49636F6E223A7B666F6E7453697A653A22393025222C77696474683A222E38656D222C646973706C';
wwv_flow_imp.g_varchar2_table(46395) := '61793A22696E6C696E652D626C6F636B222C74657874416C69676E3A2263656E746572222C70616464696E6752696768743A222E36656D222C6F7061636974793A22302E36222C626F7853697A696E673A22636F6E74656E742D626F78227D2C222E636D';
wwv_flow_imp.g_varchar2_table(46396) := '2D636F6D706C6574696F6E49636F6E2D66756E6374696F6E2C202E636D2D636F6D706C6574696F6E49636F6E2D6D6574686F64223A7B22263A6166746572223A7B636F6E74656E743A2227C69227227D7D2C222E636D2D636F6D706C6574696F6E49636F';
wwv_flow_imp.g_varchar2_table(46397) := '6E2D636C617373223A7B22263A6166746572223A7B636F6E74656E743A2227E2978B27227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D696E74657266616365223A7B22263A6166746572223A7B636F6E74656E743A2227E2978C27227D7D2C';
wwv_flow_imp.g_varchar2_table(46398) := '222E636D2D636F6D706C6574696F6E49636F6E2D7661726961626C65223A7B22263A6166746572223A7B636F6E74656E743A2227F09D91A527227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D636F6E7374616E74223A7B22263A6166746572';
wwv_flow_imp.g_varchar2_table(46399) := '223A7B636F6E74656E743A2227F09D90B627227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D74797065223A7B22263A6166746572223A7B636F6E74656E743A2227F09D91A127227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D65';
wwv_flow_imp.g_varchar2_table(46400) := '6E756D223A7B22263A6166746572223A7B636F6E74656E743A2227E288AA27227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D70726F7065727479223A7B22263A6166746572223A7B636F6E74656E743A2227E296A127227D7D2C222E636D2D';
wwv_flow_imp.g_varchar2_table(46401) := '636F6D706C6574696F6E49636F6E2D6B6579776F7264223A7B22263A6166746572223A7B636F6E74656E743A2227F09F9491EFB88E27227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D6E616D657370616365223A7B22263A6166746572223A';
wwv_flow_imp.g_varchar2_table(46402) := '7B636F6E74656E743A2227E296A227227D7D2C222E636D2D636F6D706C6574696F6E49636F6E2D74657874223A7B22263A6166746572223A7B636F6E74656E743A222761626327222C666F6E7453697A653A22353025222C766572746963616C416C6967';
wwv_flow_imp.g_varchar2_table(46403) := '6E3A226D6964646C65227D7D7D293B636C61737320494E7B636F6E7374727563746F7228652C742C6E2C69297B746869732E6669656C643D652C746869732E6C696E653D742C746869732E66726F6D3D6E2C746869732E746F3D697D7D636C617373204D';
wwv_flow_imp.g_varchar2_table(46404) := '4E7B636F6E7374727563746F7228652C742C6E297B746869732E6669656C643D652C746869732E66726F6D3D742C746869732E746F3D6E7D6D61702865297B6C657420743D652E6D6170506F7328746869732E66726F6D2C2D312C726B2E547261636B44';
wwv_flow_imp.g_varchar2_table(46405) := '656C292C6E3D652E6D6170506F7328746869732E746F2C312C726B2E547261636B44656C293B72657475726E206E756C6C3D3D747C7C6E756C6C3D3D6E3F6E756C6C3A6E6577204D4E28746869732E6669656C642C742C6E297D7D636C61737320414E7B';
wwv_flow_imp.g_varchar2_table(46406) := '636F6E7374727563746F7228652C74297B746869732E6C696E65733D652C746869732E6669656C64506F736974696F6E733D747D696E7374616E746961746528652C74297B6C6574206E3D5B5D2C693D5B745D2C6F3D652E646F632E6C696E6541742874';
wwv_flow_imp.g_varchar2_table(46407) := '292C733D2F5E5C732A2F2E65786563286F2E74657874295B305D3B666F72286C6574206F206F6620746869732E6C696E6573297B6966286E2E6C656E677468297B6C6574206E3D732C723D2F5E5C742A2F2E65786563286F295B305D2E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(46408) := '666F72286C657420743D303B743C723B742B2B296E2B3D652E6661636574285A4D293B692E7075736828742B6E2E6C656E6774682D72292C6F3D6E2B6F2E736C6963652872297D6E2E70757368286F292C742B3D6F2E6C656E6774682B317D6C65742072';
wwv_flow_imp.g_varchar2_table(46409) := '3D746869732E6669656C64506F736974696F6E732E6D61702828653D3E6E6577204D4E28652E6669656C642C695B652E6C696E655D2B652E66726F6D2C695B652E6C696E655D2B652E746F2929293B72657475726E7B746578743A6E2C72616E6765733A';
wwv_flow_imp.g_varchar2_table(46410) := '727D7D7374617469632070617273652865297B6C657420742C6E3D5B5D2C693D5B5D2C6F3D5B5D3B666F72286C65742073206F6620652E73706C6974282F5C725C6E3F7C5C6E2F29297B666F72283B743D2F5B23245D5C7B283F3A285C642B29283F3A3A';
wwv_flow_imp.g_varchar2_table(46411) := '285B5E7D5D2A29293F7C28283F3A5C5C5B7B7D5D7C5B5E7D5D292A29295C7D2F2E657865632873293B297B6C657420653D745B315D3F2B745B315D3A6E756C6C2C723D745B325D7C7C745B335D7C7C22222C613D2D312C6C3D722E7265706C616365282F';
wwv_flow_imp.g_varchar2_table(46412) := '5C5C5B7B7D5D2F672C28653D3E655B315D29293B666F72286C657420743D303B743C6E2E6C656E6774683B742B2B29286E756C6C213D653F6E5B745D2E7365713D3D653A6C26266E5B745D2E6E616D653D3D6C29262628613D74293B696628613C30297B';
wwv_flow_imp.g_varchar2_table(46413) := '6C657420743D303B666F72283B743C6E2E6C656E6774682626286E756C6C3D3D657C7C6E756C6C213D6E5B745D2E73657126266E5B745D2E7365713C65293B29742B2B3B6E2E73706C69636528742C302C7B7365713A652C6E616D653A6C7D292C613D74';
wwv_flow_imp.g_varchar2_table(46414) := '3B666F72286C65742065206F66206F29652E6669656C643E3D612626652E6669656C642B2B7D6F2E70757368286E657720494E28612C692E6C656E6774682C742E696E6465782C742E696E6465782B6C2E6C656E67746829292C733D732E736C69636528';
wwv_flow_imp.g_varchar2_table(46415) := '302C742E696E646578292B722B732E736C69636528742E696E6465782B745B305D2E6C656E677468297D733D732E7265706C616365282F5C5C285B7B7D5D292F672C2828652C742C6E293D3E7B666F72286C65742065206F66206F29652E6C696E653D3D';
wwv_flow_imp.g_varchar2_table(46416) := '692E6C656E6774682626652E66726F6D3E6E262628652E66726F6D2D2D2C652E746F2D2D293B72657475726E20747D29292C692E707573682873297D72657475726E206E657720414E28692C6F297D7D6C6574204E4E3D504C2E776964676574287B7769';
wwv_flow_imp.g_varchar2_table(46417) := '646765743A6E657720636C61737320657874656E647320414C7B746F444F4D28297B6C657420653D646F63756D656E742E637265617465456C656D656E7428227370616E22293B72657475726E20652E636C6173734E616D653D22636D2D736E69707065';
wwv_flow_imp.g_varchar2_table(46418) := '744669656C64506F736974696F6E222C657D69676E6F72654576656E7428297B72657475726E21317D7D7D292C504E3D504C2E6D61726B287B636C6173733A22636D2D736E69707065744669656C64227D293B636C617373204F4E7B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(46419) := '746F7228652C74297B746869732E72616E6765733D652C746869732E6163746976653D742C746869732E6465636F3D504C2E73657428652E6D61702828653D3E28652E66726F6D3D3D652E746F3F4E4E3A504E292E72616E676528652E66726F6D2C652E';
wwv_flow_imp.g_varchar2_table(46420) := '746F292929297D6D61702865297B6C657420743D5B5D3B666F72286C6574206E206F6620746869732E72616E676573297B6C657420693D6E2E6D61702865293B69662821692972657475726E206E756C6C3B742E707573682869297D72657475726E206E';
wwv_flow_imp.g_varchar2_table(46421) := '6577204F4E28742C746869732E616374697665297D73656C656374696F6E496E736964654669656C642865297B72657475726E20652E72616E6765732E65766572792828653D3E746869732E72616E6765732E736F6D652828743D3E742E6669656C643D';
wwv_flow_imp.g_varchar2_table(46422) := '3D746869732E6163746976652626742E66726F6D3C3D652E66726F6D2626742E746F3E3D652E746F292929297D7D636F6E737420524E3D246B2E646566696E65287B6D61703A28652C74293D3E652626652E6D61702874297D292C464E3D246B2E646566';
wwv_flow_imp.g_varchar2_table(46423) := '696E6528292C424E3D456B2E646566696E65287B6372656174653A28293D3E6E756C6C2C75706461746528652C74297B666F72286C6574206E206F6620742E65666665637473297B6966286E2E697328524E292972657475726E206E2E76616C75653B69';
wwv_flow_imp.g_varchar2_table(46424) := '66286E2E697328464E292626652972657475726E206E6577204F4E28652E72616E6765732C6E2E76616C7565297D72657475726E20652626742E646F634368616E676564262628653D652E6D617028742E6368616E67657329292C652626742E73656C65';
wwv_flow_imp.g_varchar2_table(46425) := '6374696F6E262621652E73656C656374696F6E496E736964654669656C6428742E73656C656374696F6E29262628653D6E756C6C292C657D2C70726F766964653A653D3E44492E6465636F726174696F6E732E66726F6D28652C28653D3E653F652E6465';
wwv_flow_imp.g_varchar2_table(46426) := '636F3A504C2E6E6F6E6529297D293B66756E6374696F6E20564E28652C74297B72657475726E20666B2E63726561746528652E66696C7465722828653D3E652E6669656C643D3D7429292E6D61702828653D3E666B2E72616E676528652E66726F6D2C65';
wwv_flow_imp.g_varchar2_table(46427) := '2E746F292929297D66756E6374696F6E207A4E2865297B6C657420743D414E2E70617273652865293B72657475726E28652C6E2C692C6F293D3E7B6C65747B746578743A732C72616E6765733A727D3D742E696E7374616E746961746528652E73746174';
wwv_flow_imp.g_varchar2_table(46428) := '652C69292C613D7B6368616E6765733A7B66726F6D3A692C746F3A6F2C696E736572743A46782E6F662873297D2C7363726F6C6C496E746F566965773A21302C616E6E6F746174696F6E733A6E3F5B59412E6F66286E292C556B2E757365724576656E74';
wwv_flow_imp.g_varchar2_table(46429) := '2E6F662822696E7075742E636F6D706C65746522295D3A766F696420307D3B696628722E6C656E677468262628612E73656C656374696F6E3D564E28722C3029292C722E736F6D652828653D3E652E6669656C643E302929297B6C657420743D6E657720';
wwv_flow_imp.g_varchar2_table(46430) := '4F4E28722C30292C6E3D612E656666656374733D5B524E2E6F662874295D3B766F696420303D3D3D652E73746174652E6669656C6428424E2C21312926266E2E7075736828246B2E617070656E64436F6E6669672E6F66285B424E2C714E2C554E2C544E';
wwv_flow_imp.g_varchar2_table(46431) := '5D29297D652E646973706174636828652E73746174652E757064617465286129297D7D66756E6374696F6E20484E2865297B72657475726E287B73746174653A742C64697370617463683A6E7D293D3E7B6C657420693D742E6669656C6428424E2C2131';
wwv_flow_imp.g_varchar2_table(46432) := '293B69662821697C7C653C302626303D3D692E6163746976652972657475726E21313B6C6574206F3D692E6163746976652B652C733D653E30262621692E72616E6765732E736F6D652828743D3E742E6669656C643D3D6F2B6529293B72657475726E20';
wwv_flow_imp.g_varchar2_table(46433) := '6E28742E757064617465287B73656C656374696F6E3A564E28692E72616E6765732C6F292C656666656374733A524E2E6F6628733F6E756C6C3A6E6577204F4E28692E72616E6765732C6F29292C7363726F6C6C496E746F566965773A21307D29292C21';
wwv_flow_imp.g_varchar2_table(46434) := '307D7D636F6E737420574E3D5B7B6B65793A22546162222C72756E3A484E2831292C73686966743A484E282D31297D2C7B6B65793A22457363617065222C72756E3A287B73746174653A652C64697370617463683A747D293D3E2121652E6669656C6428';
wwv_flow_imp.g_varchar2_table(46435) := '424E2C2131292626287428652E757064617465287B656666656374733A524E2E6F66286E756C6C297D29292C2130297D5D2C6A4E3D5F6B2E646566696E65287B636F6D62696E653A653D3E652E6C656E6774683F655B305D3A574E7D292C714E3D446B2E';
wwv_flow_imp.g_varchar2_table(46436) := '686967686573742852492E636F6D70757465285B6A4E5D2C28653D3E652E6661636574286A4E292929293B66756E6374696F6E20244E28652C74297B72657475726E204F626A6563742E61737369676E284F626A6563742E61737369676E287B7D2C7429';
wwv_flow_imp.g_varchar2_table(46437) := '2C7B6170706C793A7A4E2865297D297D636F6E737420554E3D44492E646F6D4576656E7448616E646C657273287B6D6F757365646F776E28652C74297B6C6574206E2C693D742E73746174652E6669656C6428424E2C2131293B69662821697C7C6E756C';
wwv_flow_imp.g_varchar2_table(46438) := '6C3D3D286E3D742E706F734174436F6F726473287B783A652E636C69656E74582C793A652E636C69656E74597D29292972657475726E21313B6C6574206F3D692E72616E6765732E66696E642828653D3E652E66726F6D3C3D6E2626652E746F3E3D6E29';
wwv_flow_imp.g_varchar2_table(46439) := '293B72657475726E2128216F7C7C6F2E6669656C643D3D692E6163746976657C7C28742E6469737061746368287B73656C656374696F6E3A564E28692E72616E6765732C6F2E6669656C64292C656666656374733A524E2E6F6628692E72616E6765732E';
wwv_flow_imp.g_varchar2_table(46440) := '736F6D652828653D3E652E6669656C643E6F2E6669656C6429293F6E6577204F4E28692E72616E6765732C6F2E6669656C64293A6E756C6C292C7363726F6C6C496E746F566965773A21307D292C3029297D7D292C4B4E3D7B627261636B6574733A5B22';
wwv_flow_imp.g_varchar2_table(46441) := '28222C225B222C227B222C2227222C2722275D2C6265666F72653A22295D7D3A3B3E222C737472696E6750726566697865733A5B5D7D2C474E3D246B2E646566696E65287B6D617028652C74297B6C6574206E3D742E6D6170506F7328652C2D312C726B';
wwv_flow_imp.g_varchar2_table(46442) := '2E547261636B4166746572293B72657475726E206E756C6C3D3D6E3F766F696420303A6E7D7D292C514E3D6E657720636C61737320657874656E6473206F457B7D3B514E2E7374617274536964653D312C514E2E656E64536964653D2D313B636F6E7374';
wwv_flow_imp.g_varchar2_table(46443) := '20594E3D456B2E646566696E65287B6372656174653A28293D3E6C452E656D7074792C75706461746528652C74297B696628653D652E6D617028742E6368616E676573292C742E73656C656374696F6E297B6C6574206E3D742E73746174652E646F632E';
wwv_flow_imp.g_varchar2_table(46444) := '6C696E65417428742E73656C656374696F6E2E6D61696E2E68656164293B653D652E757064617465287B66696C7465723A653D3E653E3D6E2E66726F6D2626653C3D6E2E746F7D297D666F72286C6574206E206F6620742E65666665637473296E2E6973';
wwv_flow_imp.g_varchar2_table(46445) := '28474E29262628653D652E757064617465287B6164643A5B514E2E72616E6765286E2E76616C75652C6E2E76616C75652B31295D7D29293B72657475726E20657D7D293B66756E6374696F6E205A4E28297B72657475726E5B74502C594E5D7D636F6E73';
wwv_flow_imp.g_varchar2_table(46446) := '7420584E3D2228295B5D7B7D3C3E223B66756E6374696F6E204A4E2865297B666F72286C657420743D303B743C383B742B3D3229696628584E2E63686172436F646541742874293D3D652972657475726E20584E2E63686172417428742B31293B726574';
wwv_flow_imp.g_varchar2_table(46447) := '75726E20696B28653C3132383F653A652B31297D636F6E73742065503D226F626A656374223D3D747970656F66206E6176696761746F7226262F416E64726F69645C622F2E74657374286E6176696761746F722E757365724167656E74292C74503D4449';
wwv_flow_imp.g_varchar2_table(46448) := '2E696E70757448616E646C65722E6F66282828652C742C6E2C69293D3E7B6966282865503F652E636F6D706F73696E673A652E636F6D706F736974696F6E53746172746564297C7C652E73746174652E726561644F6E6C792972657475726E21313B6C65';
wwv_flow_imp.g_varchar2_table(46449) := '74206F3D652E73746174652E73656C656374696F6E2E6D61696E3B696628692E6C656E6774683E327C7C323D3D692E6C656E6774682626313D3D6F6B286E6B28692C3029297C7C74213D6F2E66726F6D7C7C6E213D6F2E746F2972657475726E21313B6C';
wwv_flow_imp.g_varchar2_table(46450) := '657420733D66756E6374696F6E28652C74297B6C6574206E3D66756E6374696F6E28652C74297B72657475726E20652E6C616E67756167654461746141742822636C6F7365427261636B657473222C74295B305D7C7C4B4E7D28652C652E73656C656374';
wwv_flow_imp.g_varchar2_table(46451) := '696F6E2E6D61696E2E68656164292C693D6E2E627261636B6574737C7C4B4E2E627261636B6574733B666F72286C6574206F206F662069297B6C657420733D4A4E286E6B286F2C3029293B696628743D3D6F2972657475726E20733D3D6F3F725028652C';
wwv_flow_imp.g_varchar2_table(46452) := '6F2C692E696E6465784F66286F2B6F2B6F293E2D312C6E293A6F5028652C6F2C732C6E2E6265666F72657C7C4B4E2E6265666F7265293B696628743D3D7326266E5028652C652E73656C656374696F6E2E6D61696E2E66726F6D292972657475726E2073';
wwv_flow_imp.g_varchar2_table(46453) := '5028652C302C73297D72657475726E206E756C6C7D28652E73746174652C69293B72657475726E212173262628652E64697370617463682873292C2130297D29293B66756E6374696F6E206E5028652C74297B6C6574206E3D21313B72657475726E2065';
wwv_flow_imp.g_varchar2_table(46454) := '2E6669656C6428594E292E6265747765656E28302C652E646F632E6C656E6774682C28653D3E7B653D3D742626286E3D2130297D29292C6E7D66756E6374696F6E20695028652C74297B6C6574206E3D652E736C696365537472696E6728742C742B3229';
wwv_flow_imp.g_varchar2_table(46455) := '3B72657475726E206E2E736C69636528302C6F6B286E6B286E2C302929297D66756E6374696F6E206F5028652C742C6E2C69297B6C6574206F3D6E756C6C2C733D652E6368616E6765427952616E67652828733D3E7B69662821732E656D707479297265';
wwv_flow_imp.g_varchar2_table(46456) := '7475726E7B6368616E6765733A5B7B696E736572743A742C66726F6D3A732E66726F6D7D2C7B696E736572743A6E2C66726F6D3A732E746F7D5D2C656666656374733A474E2E6F6628732E746F2B742E6C656E677468292C72616E67653A666B2E72616E';
wwv_flow_imp.g_varchar2_table(46457) := '676528732E616E63686F722B742E6C656E6774682C732E686561642B742E6C656E677468297D3B6C657420723D695028652E646F632C732E68656164293B72657475726E21727C7C2F5C732F2E746573742872297C7C692E696E6465784F662872293E2D';
wwv_flow_imp.g_varchar2_table(46458) := '313F7B6368616E6765733A7B696E736572743A742B6E2C66726F6D3A732E686561647D2C656666656374733A474E2E6F6628732E686561642B742E6C656E677468292C72616E67653A666B2E637572736F7228732E686561642B742E6C656E677468297D';
wwv_flow_imp.g_varchar2_table(46459) := '3A7B72616E67653A6F3D737D7D29293B72657475726E206F3F6E756C6C3A652E75706461746528732C7B7363726F6C6C496E746F566965773A21302C757365724576656E743A22696E7075742E74797065227D297D66756E6374696F6E20735028652C74';
wwv_flow_imp.g_varchar2_table(46460) := '2C6E297B6C657420693D6E756C6C2C6F3D652E6368616E6765427952616E67652828743D3E742E656D7074792626695028652E646F632C742E68656164293D3D6E3F7B6368616E6765733A7B66726F6D3A742E686561642C746F3A742E686561642B6E2E';
wwv_flow_imp.g_varchar2_table(46461) := '6C656E6774682C696E736572743A6E7D2C72616E67653A666B2E637572736F7228742E686561642B6E2E6C656E677468297D3A693D7B72616E67653A747D29293B72657475726E20693F6E756C6C3A652E757064617465286F2C7B7363726F6C6C496E74';
wwv_flow_imp.g_varchar2_table(46462) := '6F566965773A21302C757365724576656E743A22696E7075742E74797065227D297D66756E6374696F6E20725028652C742C6E2C69297B6C6574206F3D692E737472696E6750726566697865737C7C4B4E2E737472696E6750726566697865732C733D6E';
wwv_flow_imp.g_varchar2_table(46463) := '756C6C2C723D652E6368616E6765427952616E67652828693D3E7B69662821692E656D7074792972657475726E7B6368616E6765733A5B7B696E736572743A742C66726F6D3A692E66726F6D7D2C7B696E736572743A742C66726F6D3A692E746F7D5D2C';
wwv_flow_imp.g_varchar2_table(46464) := '656666656374733A474E2E6F6628692E746F2B742E6C656E677468292C72616E67653A666B2E72616E676528692E616E63686F722B742E6C656E6774682C692E686561642B742E6C656E677468297D3B6C657420722C613D692E686561642C6C3D695028';
wwv_flow_imp.g_varchar2_table(46465) := '652E646F632C61293B6966286C3D3D74297B696628615028652C61292972657475726E7B6368616E6765733A7B696E736572743A742B742C66726F6D3A617D2C656666656374733A474E2E6F6628612B742E6C656E677468292C72616E67653A666B2E63';
wwv_flow_imp.g_varchar2_table(46466) := '7572736F7228612B742E6C656E677468297D3B6966286E5028652C6129297B6C657420693D6E2626652E736C696365446F6328612C612B332A742E6C656E677468293D3D742B742B743F742B742B743A743B72657475726E7B6368616E6765733A7B6672';
wwv_flow_imp.g_varchar2_table(46467) := '6F6D3A612C746F3A612B692E6C656E6774682C696E736572743A697D2C72616E67653A666B2E637572736F7228612B692E6C656E677468297D7D7D656C73657B6966286E2626652E736C696365446F6328612D322A742E6C656E6774682C61293D3D742B';
wwv_flow_imp.g_varchar2_table(46468) := '74262628723D6C5028652C612D322A742E6C656E6774682C6F29293E2D312626615028652C72292972657475726E7B6368616E6765733A7B696E736572743A742B742B742B742C66726F6D3A617D2C656666656374733A474E2E6F6628612B742E6C656E';
wwv_flow_imp.g_varchar2_table(46469) := '677468292C72616E67653A666B2E637572736F7228612B742E6C656E677468297D3B696628652E6368617243617465676F72697A6572286129286C29213D4A6B2E576F726426266C5028652C612C6F293E2D3126262166756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(46470) := '2C69297B6C6574206F3D564D2865292E7265736F6C7665496E6E657228742C2D31292C733D692E726564756365282828652C74293D3E4D6174682E6D617828652C742E6C656E67746829292C30293B666F72286C657420723D303B723C353B722B2B297B';
wwv_flow_imp.g_varchar2_table(46471) := '6C657420723D652E736C696365446F63286F2E66726F6D2C4D6174682E6D696E286F2E746F2C6F2E66726F6D2B6E2E6C656E6774682B7329292C613D722E696E6465784F66286E293B69662821617C7C613E2D312626692E696E6465784F6628722E736C';
wwv_flow_imp.g_varchar2_table(46472) := '69636528302C6129293E2D31297B6C657420743D6F2E66697273744368696C643B666F72283B742626742E66726F6D3D3D6F2E66726F6D2626742E746F2D742E66726F6D3E6E2E6C656E6774682B613B297B696628652E736C696365446F6328742E746F';
wwv_flow_imp.g_varchar2_table(46473) := '2D6E2E6C656E6774682C742E746F293D3D6E2972657475726E21313B743D742E66697273744368696C647D72657475726E21307D6C6574206C3D6F2E746F3D3D7426266F2E706172656E743B696628216C29627265616B3B6F3D6C7D72657475726E2131';
wwv_flow_imp.g_varchar2_table(46474) := '7D28652C612C742C6F292972657475726E7B6368616E6765733A7B696E736572743A742B742C66726F6D3A617D2C656666656374733A474E2E6F6628612B742E6C656E677468292C72616E67653A666B2E637572736F7228612B742E6C656E677468297D';
wwv_flow_imp.g_varchar2_table(46475) := '7D72657475726E7B72616E67653A733D697D7D29293B72657475726E20733F6E756C6C3A652E75706461746528722C7B7363726F6C6C496E746F566965773A21302C757365724576656E743A22696E7075742E74797065227D297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(46476) := '615028652C74297B6C6574206E3D564D2865292E7265736F6C7665496E6E657228742B31293B72657475726E206E2E706172656E7426266E2E66726F6D3D3D747D66756E6374696F6E206C5028652C742C6E297B6C657420693D652E6368617243617465';
wwv_flow_imp.g_varchar2_table(46477) := '676F72697A65722874293B6966286928652E736C696365446F6328742D312C742929213D4A6B2E576F72642972657475726E20743B666F72286C6574206F206F66206E297B6C6574206E3D742D6F2E6C656E6774683B696628652E736C696365446F6328';
wwv_flow_imp.g_varchar2_table(46478) := '6E2C74293D3D6F26266928652E736C696365446F63286E2D312C6E2929213D4A6B2E576F72642972657475726E206E7D72657475726E2D317D66756E6374696F6E20635028653D7B7D297B72657475726E5B444E2C774E2C694E2E6F662865292C454E2C';
wwv_flow_imp.g_varchar2_table(46479) := '68502C544E5D7D636F6E73742064503D5B7B6B65793A224374726C2D5370616365222C72756E3A653D3E2121652E73746174652E6669656C6428774E2C213129262628652E6469737061746368287B656666656374733A4A412E6F66282130297D292C21';
wwv_flow_imp.g_varchar2_table(46480) := '30297D2C7B6B65793A22457363617065222C72756E3A653D3E7B6C657420743D652E73746174652E6669656C6428774E2C2131293B72657475726E212821747C7C21742E6163746976652E736F6D652828653D3E30213D652E737461746529297C7C2865';
wwv_flow_imp.g_varchar2_table(46481) := '2E6469737061746368287B656666656374733A654E2E6F66286E756C6C297D292C3029297D7D2C7B6B65793A224172726F77446F776E222C72756E3A784E282130297D2C7B6B65793A224172726F775570222C72756E3A784E282131297D2C7B6B65793A';
wwv_flow_imp.g_varchar2_table(46482) := '2250616765446F776E222C72756E3A784E2821302C227061676522297D2C7B6B65793A22506167655570222C72756E3A784E2821312C227061676522297D2C7B6B65793A22456E746572222C72756E3A653D3E7B6C657420743D652E73746174652E6669';
wwv_flow_imp.g_varchar2_table(46483) := '656C6428774E2C2131293B72657475726E2128652E73746174652E726561644F6E6C797C7C21747C7C21742E6F70656E7C7C742E6F70656E2E73656C65637465643C307C7C742E6F70656E2E64697361626C65647C7C446174652E6E6F7728292D742E6F';
wwv_flow_imp.g_varchar2_table(46484) := '70656E2E74696D657374616D703C652E73746174652E666163657428694E292E696E746572616374696F6E44656C6179292626434E28652C742E6F70656E2E6F7074696F6E735B742E6F70656E2E73656C65637465645D297D7D5D2C68503D446B2E6869';
wwv_flow_imp.g_varchar2_table(46485) := '67686573742852492E636F6D707574654E285B694E5D2C28653D3E652E666163657428694E292E64656661756C744B65796D61703F5B64505D3A5B5D2929293B66756E6374696F6E20755028652C74297B72657475726E287B73746174653A6E2C646973';
wwv_flow_imp.g_varchar2_table(46486) := '70617463683A697D293D3E7B6966286E2E726561644F6E6C792972657475726E21313B6C6574206F3D6528742C6E293B72657475726E21216F26262869286E2E757064617465286F29292C2130297D7D636F6E73742070503D7550285F502C30292C6750';
wwv_flow_imp.g_varchar2_table(46487) := '3D75502862502C30292C6D503D7550282828652C74293D3E625028652C742C66756E6374696F6E2865297B6C657420743D5B5D3B666F72286C6574206E206F6620652E73656C656374696F6E2E72616E676573297B6C657420693D652E646F632E6C696E';
wwv_flow_imp.g_varchar2_table(46488) := '654174286E2E66726F6D292C6F3D6E2E746F3C3D692E746F3F693A652E646F632E6C696E654174286E2E746F292C733D742E6C656E6774682D313B733E3D302626745B735D2E746F3E692E66726F6D3F745B735D2E746F3D6F2E746F3A742E7075736828';
wwv_flow_imp.g_varchar2_table(46489) := '7B66726F6D3A692E66726F6D2B2F5E5C732A2F2E6578656328692E74657874295B305D2E6C656E6774682C746F3A6F2E746F7D297D72657475726E20747D28742929292C30293B66756E6374696F6E20665028652C74297B6C6574206E3D652E6C616E67';
wwv_flow_imp.g_varchar2_table(46490) := '756167654461746141742822636F6D6D656E74546F6B656E73222C74293B72657475726E206E2E6C656E6774683F6E5B305D3A7B7D7D636F6E73742076503D35303B66756E6374696F6E20625028652C742C6E3D742E73656C656374696F6E2E72616E67';
wwv_flow_imp.g_varchar2_table(46491) := '6573297B6C657420693D6E2E6D61702828653D3E665028742C652E66726F6D292E626C6F636B29293B69662821692E65766572792828653D3E6529292972657475726E206E756C6C3B6C6574206F3D6E2E6D6170282828652C6E293D3E66756E6374696F';
wwv_flow_imp.g_varchar2_table(46492) := '6E28652C7B6F70656E3A742C636C6F73653A6E7D2C692C6F297B6C657420732C722C613D652E736C696365446F6328692D76502C69292C6C3D652E736C696365446F63286F2C6F2B7650292C633D2F5C732A242F2E657865632861295B305D2E6C656E67';
wwv_flow_imp.g_varchar2_table(46493) := '74682C643D2F5E5C732A2F2E65786563286C295B305D2E6C656E6774682C683D612E6C656E6774682D633B696628612E736C69636528682D742E6C656E6774682C68293D3D7426266C2E736C69636528642C642B6E2E6C656E677468293D3D6E29726574';
wwv_flow_imp.g_varchar2_table(46494) := '75726E7B6F70656E3A7B706F733A692D632C6D617267696E3A632626317D2C636C6F73653A7B706F733A6F2B642C6D617267696E3A642626317D7D3B6F2D693C3D322A76503F733D723D652E736C696365446F6328692C6F293A28733D652E736C696365';
wwv_flow_imp.g_varchar2_table(46495) := '446F6328692C692B7650292C723D652E736C696365446F63286F2D76502C6F29293B6C657420753D2F5E5C732A2F2E657865632873295B305D2E6C656E6774682C703D2F5C732A242F2E657865632872295B305D2E6C656E6774682C673D722E6C656E67';
wwv_flow_imp.g_varchar2_table(46496) := '74682D702D6E2E6C656E6774683B72657475726E20732E736C69636528752C752B742E6C656E677468293D3D742626722E736C69636528672C672B6E2E6C656E677468293D3D6E3F7B6F70656E3A7B706F733A692B752B742E6C656E6774682C6D617267';
wwv_flow_imp.g_varchar2_table(46497) := '696E3A2F5C732F2E7465737428732E63686172417428752B742E6C656E67746829293F313A307D2C636C6F73653A7B706F733A6F2D702D6E2E6C656E6774682C6D617267696E3A2F5C732F2E7465737428722E63686172417428672D3129293F313A307D';
wwv_flow_imp.g_varchar2_table(46498) := '7D3A6E756C6C7D28742C695B6E5D2C652E66726F6D2C652E746F2929293B69662832213D652626216F2E65766572792828653D3E6529292972657475726E7B6368616E6765733A742E6368616E676573286E2E6D6170282828652C74293D3E6F5B745D3F';
wwv_flow_imp.g_varchar2_table(46499) := '5B5D3A5B7B66726F6D3A652E66726F6D2C696E736572743A695B745D2E6F70656E2B2220227D2C7B66726F6D3A652E746F2C696E736572743A2220222B695B745D2E636C6F73657D5D2929297D3B69662831213D6526266F2E736F6D652828653D3E6529';
wwv_flow_imp.g_varchar2_table(46500) := '29297B6C657420653D5B5D3B666F72286C657420742C6E3D303B6E3C6F2E6C656E6774683B6E2B2B29696628743D6F5B6E5D297B6C6574206F3D695B6E5D2C7B6F70656E3A732C636C6F73653A727D3D743B652E70757368287B66726F6D3A732E706F73';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(46501) := '2D6F2E6F70656E2E6C656E6774682C746F3A732E706F732B732E6D617267696E7D2C7B66726F6D3A722E706F732D722E6D617267696E2C746F3A722E706F732B6F2E636C6F73652E6C656E6774687D297D72657475726E7B6368616E6765733A657D7D72';
wwv_flow_imp.g_varchar2_table(46502) := '657475726E206E756C6C7D66756E6374696F6E205F5028652C742C6E3D742E73656C656374696F6E2E72616E676573297B6C657420693D5B5D2C6F3D2D313B666F72286C65747B66726F6D3A652C746F3A737D6F66206E297B6C6574206E3D692E6C656E';
wwv_flow_imp.g_varchar2_table(46503) := '6774682C723D3165392C613D665028742C65292E6C696E653B69662861297B666F72286C6574206E3D653B6E3C3D733B297B6C6574206C3D742E646F632E6C696E654174286E293B6966286C2E66726F6D3E6F262628653D3D737C7C733E6C2E66726F6D';
wwv_flow_imp.g_varchar2_table(46504) := '29297B6F3D6C2E66726F6D3B6C657420653D2F5E5C732A2F2E65786563286C2E74657874295B305D2E6C656E6774682C743D653D3D6C2E6C656E6774682C6E3D6C2E746578742E736C69636528652C652B612E6C656E677468293D3D613F653A2D313B65';
wwv_flow_imp.g_varchar2_table(46505) := '3C6C2E746578742E6C656E6774682626653C72262628723D65292C692E70757368287B6C696E653A6C2C636F6D6D656E743A6E2C746F6B656E3A612C696E64656E743A652C656D7074793A742C73696E676C653A21317D297D6E3D6C2E746F2B317D6966';
wwv_flow_imp.g_varchar2_table(46506) := '28723C31653929666F72286C657420653D6E3B653C692E6C656E6774683B652B2B29695B655D2E696E64656E743C695B655D2E6C696E652E746578742E6C656E677468262628695B655D2E696E64656E743D72293B692E6C656E6774683D3D6E2B312626';
wwv_flow_imp.g_varchar2_table(46507) := '28695B6E5D2E73696E676C653D2130297D7D69662832213D652626692E736F6D652828653D3E652E636F6D6D656E743C3026262821652E656D7074797C7C652E73696E676C65292929297B6C657420653D5B5D3B666F72286C65747B6C696E653A742C74';
wwv_flow_imp.g_varchar2_table(46508) := '6F6B656E3A6E2C696E64656E743A6F2C656D7074793A732C73696E676C653A727D6F6620692921722626737C7C652E70757368287B66726F6D3A742E66726F6D2B6F2C696E736572743A6E2B2220227D293B6C6574206E3D742E6368616E676573286529';
wwv_flow_imp.g_varchar2_table(46509) := '3B72657475726E7B6368616E6765733A6E2C73656C656374696F6E3A742E73656C656374696F6E2E6D6170286E2C31297D7D69662831213D652626692E736F6D652828653D3E652E636F6D6D656E743E3D302929297B6C657420653D5B5D3B666F72286C';
wwv_flow_imp.g_varchar2_table(46510) := '65747B6C696E653A742C636F6D6D656E743A6E2C746F6B656E3A6F7D6F662069296966286E3E3D30297B6C657420693D742E66726F6D2B6E2C733D692B6F2E6C656E6774683B2220223D3D742E746578745B732D742E66726F6D5D2626732B2B2C652E70';
wwv_flow_imp.g_varchar2_table(46511) := '757368287B66726F6D3A692C746F3A737D297D72657475726E7B6368616E6765733A657D7D72657475726E206E756C6C7D636F6E73742079503D576B2E646566696E6528292C77503D5F6B2E646566696E6528293B636C6173732043507B636F6E737472';
wwv_flow_imp.g_varchar2_table(46512) := '7563746F7228652C742C6E2C692C6F297B746869732E6368616E6765733D652C746869732E656666656374733D742C746869732E6D61707065643D6E2C746869732E737461727453656C656374696F6E3D692C746869732E73656C656374696F6E734166';
wwv_flow_imp.g_varchar2_table(46513) := '7465723D6F7D73657453656C41667465722865297B72657475726E206E657720435028746869732E6368616E6765732C746869732E656666656374732C746869732E6D61707065642C746869732E737461727453656C656374696F6E2C65297D746F4A53';
wwv_flow_imp.g_varchar2_table(46514) := '4F4E28297B76617220652C742C6E3B72657475726E7B6368616E6765733A6E756C6C3D3D3D28653D746869732E6368616E676573297C7C766F696420303D3D3D653F766F696420303A652E746F4A534F4E28292C6D61707065643A6E756C6C3D3D3D2874';
wwv_flow_imp.g_varchar2_table(46515) := '3D746869732E6D6170706564297C7C766F696420303D3D3D743F766F696420303A742E746F4A534F4E28292C737461727453656C656374696F6E3A6E756C6C3D3D3D286E3D746869732E737461727453656C656374696F6E297C7C766F696420303D3D3D';
wwv_flow_imp.g_varchar2_table(46516) := '6E3F766F696420303A6E2E746F4A534F4E28292C73656C656374696F6E7341667465723A746869732E73656C656374696F6E7341667465722E6D61702828653D3E652E746F4A534F4E282929297D7D7374617469632066726F6D4A534F4E2865297B7265';
wwv_flow_imp.g_varchar2_table(46517) := '7475726E206E657720435028652E6368616E67657326266C6B2E66726F6D4A534F4E28652E6368616E676573292C5B5D2C652E6D61707065642626616B2E66726F6D4A534F4E28652E6D6170706564292C652E737461727453656C656374696F6E262666';
wwv_flow_imp.g_varchar2_table(46518) := '6B2E66726F6D4A534F4E28652E737461727453656C656374696F6E292C652E73656C656374696F6E7341667465722E6D617028666B2E66726F6D4A534F4E29297D7374617469632066726F6D5472616E73616374696F6E28652C74297B6C6574206E3D6B';
wwv_flow_imp.g_varchar2_table(46519) := '503B666F72286C65742074206F6620652E737461727453746174652E666163657428775029297B6C657420693D742865293B692E6C656E6774682626286E3D6E2E636F6E636174286929297D72657475726E216E2E6C656E6774682626652E6368616E67';
wwv_flow_imp.g_varchar2_table(46520) := '65732E656D7074793F6E756C6C3A6E657720435028652E6368616E6765732E696E7665727428652E737461727453746174652E646F63292C6E2C766F696420302C747C7C652E737461727453746174652E73656C656374696F6E2C6B50297D7374617469';
wwv_flow_imp.g_varchar2_table(46521) := '632073656C656374696F6E2865297B72657475726E206E657720435028766F696420302C6B502C766F696420302C766F696420302C65297D7D66756E6374696F6E20535028652C742C6E2C69297B6C6574206F3D742B313E6E2B32303F742D6E2D313A30';
wwv_flow_imp.g_varchar2_table(46522) := '2C733D652E736C696365286F2C74293B72657475726E20732E707573682869292C737D66756E6374696F6E20785028652C74297B72657475726E20652E6C656E6774683F742E6C656E6774683F652E636F6E6361742874293A653A747D636F6E7374206B';
wwv_flow_imp.g_varchar2_table(46523) := '503D5B5D3B66756E6374696F6E2045502865297B6C657420743D655B652E6C656E6774682D315D2C6E3D652E736C69636528293B72657475726E206E5B652E6C656E6774682D315D3D742E73657453656C416674657228742E73656C656374696F6E7341';
wwv_flow_imp.g_varchar2_table(46524) := '667465722E736C69636528302C742E73656C656374696F6E7341667465722E6C656E6774682D3129292C6E7D66756E6374696F6E204C5028652C74297B69662821652E6C656E6774682972657475726E20653B6C6574206E3D652E6C656E6774682C693D';
wwv_flow_imp.g_varchar2_table(46525) := '6B503B666F72283B6E3B297B6C6574206F3D445028655B6E2D315D2C742C69293B6966286F2E6368616E6765732626216F2E6368616E6765732E656D7074797C7C6F2E656666656374732E6C656E677468297B6C657420743D652E736C69636528302C6E';
wwv_flow_imp.g_varchar2_table(46526) := '293B72657475726E20745B6E2D315D3D6F2C747D743D6F2E6D61707065642C6E2D2D2C693D6F2E73656C656374696F6E7341667465727D72657475726E20692E6C656E6774683F5B43502E73656C656374696F6E2869295D3A6B507D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(46527) := '20445028652C742C6E297B6C657420693D785028652E73656C656374696F6E7341667465722E6C656E6774683F652E73656C656374696F6E7341667465722E6D61702828653D3E652E6D617028742929293A6B502C6E293B69662821652E6368616E6765';
wwv_flow_imp.g_varchar2_table(46528) := '732972657475726E2043502E73656C656374696F6E2869293B6C6574206F3D652E6368616E6765732E6D61702874292C733D742E6D61704465736328652E6368616E6765732C2130292C723D652E6D61707065643F652E6D61707065642E636F6D706F73';
wwv_flow_imp.g_varchar2_table(46529) := '65446573632873293A733B72657475726E206E6577204350286F2C246B2E6D61704566666563747328652E656666656374732C74292C722C652E737461727453656C656374696F6E2E6D61702873292C69297D636F6E73742054503D2F5E28696E707574';
wwv_flow_imp.g_varchar2_table(46530) := '5C2E747970657C64656C6574652928247C5C2E292F3B636C6173732049507B636F6E7374727563746F7228652C742C6E3D302C693D766F69642030297B746869732E646F6E653D652C746869732E756E646F6E653D742C746869732E7072657654696D65';
wwv_flow_imp.g_varchar2_table(46531) := '3D6E2C746869732E70726576557365724576656E743D697D69736F6C61746528297B72657475726E20746869732E7072657654696D653F6E657720495028746869732E646F6E652C746869732E756E646F6E65293A746869737D6164644368616E676573';
wwv_flow_imp.g_varchar2_table(46532) := '28652C742C6E2C692C6F297B6C657420733D746869732E646F6E652C723D735B732E6C656E6774682D315D3B72657475726E20733D722626722E6368616E676573262621722E6368616E6765732E656D7074792626652E6368616E676573262628216E7C';
wwv_flow_imp.g_varchar2_table(46533) := '7C54502E74657374286E292926262821722E73656C656374696F6E7341667465722E6C656E6774682626742D746869732E7072657654696D653C692E6E657747726F757044656C61792626692E6A6F696E546F4576656E74286F2C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(46534) := '652C74297B6C6574206E3D5B5D2C693D21313B72657475726E20652E697465724368616E67656452616E676573282828652C74293D3E6E2E7075736828652C742929292C742E697465724368616E67656452616E676573282828652C742C6F2C73293D3E';
wwv_flow_imp.g_varchar2_table(46535) := '7B666F72286C657420653D303B653C6E2E6C656E6774683B297B6C657420743D6E5B652B2B5D2C723D6E5B652B2B5D3B733E3D7426266F3C3D72262628693D2130297D7D29292C697D28722E6368616E6765732C652E6368616E67657329297C7C22696E';
wwv_flow_imp.g_varchar2_table(46536) := '7075742E747970652E636F6D706F7365223D3D6E293F535028732C732E6C656E6774682D312C692E6D696E44657074682C6E657720435028652E6368616E6765732E636F6D706F736528722E6368616E676573292C785028246B2E6D6170456666656374';
wwv_flow_imp.g_varchar2_table(46537) := '7328652E656666656374732C722E6368616E676573292C722E65666665637473292C722E6D61707065642C722E737461727453656C656374696F6E2C6B5029293A535028732C732E6C656E6774682C692E6D696E44657074682C65292C6E657720495028';
wwv_flow_imp.g_varchar2_table(46538) := '732C6B502C742C6E297D61646453656C656374696F6E28652C742C6E2C69297B6C6574206F3D746869732E646F6E652E6C656E6774683F746869732E646F6E655B746869732E646F6E652E6C656E6774682D315D2E73656C656374696F6E734166746572';
wwv_flow_imp.g_varchar2_table(46539) := '3A6B503B72657475726E206F2E6C656E6774683E302626742D746869732E7072657654696D653C6926266E3D3D746869732E70726576557365724576656E7426266E26262F5E73656C65637428247C5C2E292F2E74657374286E29262666756E6374696F';
wwv_flow_imp.g_varchar2_table(46540) := '6E28652C74297B72657475726E20652E72616E6765732E6C656E6774683D3D742E72616E6765732E6C656E6774682626303D3D3D652E72616E6765732E66696C746572282828652C6E293D3E652E656D707479213D742E72616E6765735B6E5D2E656D70';
wwv_flow_imp.g_varchar2_table(46541) := '747929292E6C656E6774687D286F5B6F2E6C656E6774682D315D2C65293F746869733A6E65772049502866756E6374696F6E28652C74297B696628652E6C656E677468297B6C6574206E3D655B652E6C656E6774682D315D2C693D6E2E73656C65637469';
wwv_flow_imp.g_varchar2_table(46542) := '6F6E7341667465722E736C696365284D6174682E6D617828302C6E2E73656C656374696F6E7341667465722E6C656E6774682D32303029293B72657475726E20692E6C656E6774682626695B692E6C656E6774682D315D2E65712874293F653A28692E70';
wwv_flow_imp.g_varchar2_table(46543) := '7573682874292C535028652C652E6C656E6774682D312C3165392C6E2E73657453656C416674657228692929297D72657475726E5B43502E73656C656374696F6E285B745D295D7D28746869732E646F6E652C65292C746869732E756E646F6E652C742C';
wwv_flow_imp.g_varchar2_table(46544) := '6E297D6164644D617070696E672865297B72657475726E206E6577204950284C5028746869732E646F6E652C65292C4C5028746869732E756E646F6E652C65292C746869732E7072657654696D652C746869732E70726576557365724576656E74297D70';
wwv_flow_imp.g_varchar2_table(46545) := '6F7028652C742C6E297B6C657420693D303D3D653F746869732E646F6E653A746869732E756E646F6E653B696628303D3D692E6C656E6774682972657475726E206E756C6C3B6C6574206F3D695B692E6C656E6774682D315D2C733D6F2E73656C656374';
wwv_flow_imp.g_varchar2_table(46546) := '696F6E7341667465725B305D7C7C742E73656C656374696F6E3B6966286E26266F2E73656C656374696F6E7341667465722E6C656E6774682972657475726E20742E757064617465287B73656C656374696F6E3A6F2E73656C656374696F6E7341667465';
wwv_flow_imp.g_varchar2_table(46547) := '725B6F2E73656C656374696F6E7341667465722E6C656E6774682D315D2C616E6E6F746174696F6E733A79502E6F66287B736964653A652C726573743A45502869292C73656C656374696F6E3A737D292C757365724576656E743A303D3D653F2273656C';
wwv_flow_imp.g_varchar2_table(46548) := '6563742E756E646F223A2273656C6563742E7265646F222C7363726F6C6C496E746F566965773A21307D293B6966286F2E6368616E676573297B6C6574206E3D313D3D692E6C656E6774683F6B503A692E736C69636528302C692E6C656E6774682D3129';
wwv_flow_imp.g_varchar2_table(46549) := '3B72657475726E206F2E6D61707065642626286E3D4C50286E2C6F2E6D617070656429292C742E757064617465287B6368616E6765733A6F2E6368616E6765732C73656C656374696F6E3A6F2E737461727453656C656374696F6E2C656666656374733A';
wwv_flow_imp.g_varchar2_table(46550) := '6F2E656666656374732C616E6E6F746174696F6E733A79502E6F66287B736964653A652C726573743A6E2C73656C656374696F6E3A737D292C66696C7465723A21312C757365724576656E743A303D3D653F22756E646F223A227265646F222C7363726F';
wwv_flow_imp.g_varchar2_table(46551) := '6C6C496E746F566965773A21307D297D72657475726E206E756C6C7D7D66756E6374696F6E204D5028652C74297B72657475726E20666B2E63726561746528652E72616E6765732E6D61702874292C652E6D61696E496E646578297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(46552) := '20415028652C74297B72657475726E20652E757064617465287B73656C656374696F6E3A742C7363726F6C6C496E746F566965773A21302C757365724576656E743A2273656C656374227D297D66756E6374696F6E204E50287B73746174653A652C6469';
wwv_flow_imp.g_varchar2_table(46553) := '7370617463683A747D2C6E297B6C657420693D4D5028652E73656C656374696F6E2C6E293B72657475726E21692E657128652E73656C656374696F6E2C2130292626287428415028652C6929292C2130297D66756E6374696F6E20505028652C74297B72';
wwv_flow_imp.g_varchar2_table(46554) := '657475726E20666B2E637572736F7228743F652E746F3A652E66726F6D297D66756E6374696F6E204F5028652C74297B72657475726E204E5028652C286E3D3E6E2E656D7074793F652E6D6F7665427943686172286E2C74293A5050286E2C742929297D';
wwv_flow_imp.g_varchar2_table(46555) := '66756E6374696F6E2052502865297B72657475726E20652E74657874446972656374696F6E417428652E73746174652E73656C656374696F6E2E6D61696E2E68656164293D3D554C2E4C54527D49502E656D7074793D6E6577204950286B502C6B50293B';
wwv_flow_imp.g_varchar2_table(46556) := '636F6E73742046503D653D3E4F5028652C215250286529292C42503D653D3E4F5028652C5250286529293B66756E6374696F6E20565028652C74297B72657475726E204E5028652C286E3D3E6E2E656D7074793F652E6D6F7665427947726F7570286E2C';
wwv_flow_imp.g_varchar2_table(46557) := '74293A5050286E2C742929297D66756E6374696F6E207A5028652C742C6E297B696628742E747970652E70726F70286E292972657475726E21303B6C657420693D742E746F2D742E66726F6D3B72657475726E2069262628693E327C7C2F5B5E5C732C2E';
wwv_flow_imp.g_varchar2_table(46558) := '3B3A5D2F2E7465737428652E736C696365446F6328742E66726F6D2C742E746F2929297C7C742E66697273744368696C647D66756E6374696F6E20485028652C742C6E297B6C657420692C6F2C733D564D2865292E7265736F6C7665496E6E657228742E';
wwv_flow_imp.g_varchar2_table(46559) := '68656164292C723D6E3F58432E636C6F73656442793A58432E6F70656E656442793B666F72286C657420693D742E686561643B3B297B6C657420743D6E3F732E6368696C6441667465722869293A732E6368696C644265666F72652869293B6966282174';
wwv_flow_imp.g_varchar2_table(46560) := '29627265616B3B7A5028652C742C72293F733D743A693D6E3F742E746F3A742E66726F6D7D72657475726E206F3D732E747970652E70726F70287229262628693D6E3F4F4128652C732E66726F6D2C31293A4F4128652C732E746F2C2D3129292626692E';
wwv_flow_imp.g_varchar2_table(46561) := '6D6174636865643F6E3F692E656E642E746F3A692E656E642E66726F6D3A6E3F732E746F3A732E66726F6D2C666B2E637572736F72286F2C6E3F2D313A31297D66756E6374696F6E20575028652C74297B72657475726E204E5028652C286E3D3E7B6966';
wwv_flow_imp.g_varchar2_table(46562) := '28216E2E656D7074792972657475726E205050286E2C74293B6C657420693D652E6D6F7665566572746963616C6C79286E2C74293B72657475726E20692E68656164213D6E2E686561643F693A652E6D6F7665546F4C696E65426F756E64617279286E2C';
wwv_flow_imp.g_varchar2_table(46563) := '74297D29297D22756E646566696E656422213D747970656F6620496E746C2626496E746C2E5365676D656E7465723B636F6E7374206A503D653D3E575028652C2131292C71503D653D3E575028652C2130293B66756E6374696F6E2024502865297B6C65';
wwv_flow_imp.g_varchar2_table(46564) := '7420742C6E3D652E7363726F6C6C444F4D2E636C69656E744865696768743C652E7363726F6C6C444F4D2E7363726F6C6C4865696768742D322C693D302C6F3D303B6966286E297B666F72286C65742074206F6620652E73746174652E66616365742844';
wwv_flow_imp.g_varchar2_table(46565) := '492E7363726F6C6C4D617267696E7329297B6C6574206E3D742865293B286E756C6C3D3D6E3F766F696420303A6E2E746F7029262628693D4D6174682E6D6178286E756C6C3D3D6E3F766F696420303A6E2E746F702C6929292C286E756C6C3D3D6E3F76';
wwv_flow_imp.g_varchar2_table(46566) := '6F696420303A6E2E626F74746F6D292626286F3D4D6174682E6D6178286E756C6C3D3D6E3F766F696420303A6E2E626F74746F6D2C6F29297D743D652E7363726F6C6C444F4D2E636C69656E744865696768742D692D6F7D656C736520743D28652E646F';
wwv_flow_imp.g_varchar2_table(46567) := '6D2E6F776E6572446F63756D656E742E64656661756C74566965777C7C77696E646F77292E696E6E65724865696768743B72657475726E7B6D617267696E546F703A692C6D617267696E426F74746F6D3A6F2C73656C665363726F6C6C3A6E2C68656967';
wwv_flow_imp.g_varchar2_table(46568) := '68743A4D6174682E6D617828652E64656661756C744C696E654865696768742C742D35297D7D66756E6374696F6E20555028652C74297B6C6574206E2C693D24502865292C7B73746174653A6F7D3D652C733D4D50286F2E73656C656374696F6E2C286E';
wwv_flow_imp.g_varchar2_table(46569) := '3D3E6E2E656D7074793F652E6D6F7665566572746963616C6C79286E2C742C692E686569676874293A5050286E2C742929293B696628732E6571286F2E73656C656374696F6E292972657475726E21313B696628692E73656C665363726F6C6C297B6C65';
wwv_flow_imp.g_varchar2_table(46570) := '7420743D652E636F6F7264734174506F73286F2E73656C656374696F6E2E6D61696E2E68656164292C723D652E7363726F6C6C444F4D2E676574426F756E64696E67436C69656E745265637428292C613D722E746F702B692E6D617267696E546F702C6C';
wwv_flow_imp.g_varchar2_table(46571) := '3D722E626F74746F6D2D692E6D617267696E426F74746F6D3B742626742E746F703E612626742E626F74746F6D3C6C2626286E3D44492E7363726F6C6C496E746F5669657728732E6D61696E2E686561642C7B793A227374617274222C794D617267696E';
wwv_flow_imp.g_varchar2_table(46572) := '3A742E746F702D617D29297D72657475726E20652E6469737061746368284150286F2C73292C7B656666656374733A6E7D292C21307D636F6E7374204B503D653D3E555028652C2131292C47503D653D3E555028652C2130293B66756E6374696F6E2051';
wwv_flow_imp.g_varchar2_table(46573) := '5028652C742C6E297B6C657420693D652E6C696E65426C6F636B417428742E68656164292C6F3D652E6D6F7665546F4C696E65426F756E6461727928742C6E293B6966286F2E686561643D3D742E6865616426266F2E68656164213D286E3F692E746F3A';
wwv_flow_imp.g_varchar2_table(46574) := '692E66726F6D292626286F3D652E6D6F7665546F4C696E65426F756E6461727928742C6E2C213129292C216E26266F2E686561643D3D692E66726F6D2626692E6C656E677468297B6C6574206E3D2F5E5C732A2F2E6578656328652E73746174652E736C';
wwv_flow_imp.g_varchar2_table(46575) := '696365446F6328692E66726F6D2C4D6174682E6D696E28692E66726F6D2B3130302C692E746F2929295B305D2E6C656E6774683B6E2626742E68656164213D692E66726F6D2B6E2626286F3D666B2E637572736F7228692E66726F6D2B6E29297D726574';
wwv_flow_imp.g_varchar2_table(46576) := '75726E206F7D66756E6374696F6E20595028652C74297B6C6574206E3D4D5028652E73746174652E73656C656374696F6E2C28653D3E7B6C6574206E3D742865293B72657475726E20666B2E72616E676528652E616E63686F722C6E2E686561642C6E2E';
wwv_flow_imp.g_varchar2_table(46577) := '676F616C436F6C756D6E2C6E2E626964694C6576656C7C7C766F69642030297D29293B72657475726E216E2E657128652E73746174652E73656C656374696F6E29262628652E646973706174636828415028652E73746174652C6E29292C2130297D6675';
wwv_flow_imp.g_varchar2_table(46578) := '6E6374696F6E205A5028652C74297B72657475726E20595028652C286E3D3E652E6D6F7665427943686172286E2C742929297D636F6E73742058503D653D3E5A5028652C215250286529292C4A503D653D3E5A5028652C5250286529293B66756E637469';
wwv_flow_imp.g_varchar2_table(46579) := '6F6E20654F28652C74297B72657475726E20595028652C286E3D3E652E6D6F7665427947726F7570286E2C742929297D66756E6374696F6E20744F28652C74297B72657475726E20595028652C286E3D3E652E6D6F7665566572746963616C6C79286E2C';
wwv_flow_imp.g_varchar2_table(46580) := '742929297D636F6E7374206E4F3D653D3E744F28652C2131292C694F3D653D3E744F28652C2130293B66756E6374696F6E206F4F28652C74297B72657475726E20595028652C286E3D3E652E6D6F7665566572746963616C6C79286E2C742C2450286529';
wwv_flow_imp.g_varchar2_table(46581) := '2E6865696768742929297D636F6E737420734F3D653D3E6F4F28652C2131292C724F3D653D3E6F4F28652C2130292C614F3D287B73746174653A652C64697370617463683A747D293D3E287428415028652C7B616E63686F723A307D29292C2130292C6C';
wwv_flow_imp.g_varchar2_table(46582) := '4F3D287B73746174653A652C64697370617463683A747D293D3E287428415028652C7B616E63686F723A652E646F632E6C656E6774687D29292C2130292C634F3D287B73746174653A652C64697370617463683A747D293D3E287428415028652C7B616E';
wwv_flow_imp.g_varchar2_table(46583) := '63686F723A652E73656C656374696F6E2E6D61696E2E616E63686F722C686561643A307D29292C2130292C644F3D287B73746174653A652C64697370617463683A747D293D3E287428415028652C7B616E63686F723A652E73656C656374696F6E2E6D61';
wwv_flow_imp.g_varchar2_table(46584) := '696E2E616E63686F722C686561643A652E646F632E6C656E6774687D29292C2130293B66756E6374696F6E20684F28652C74297B696628652E73746174652E726561644F6E6C792972657475726E21313B6C6574206E3D2264656C6574652E73656C6563';
wwv_flow_imp.g_varchar2_table(46585) := '74696F6E222C7B73746174653A697D3D652C6F3D692E6368616E6765427952616E67652828693D3E7B6C65747B66726F6D3A6F2C746F3A737D3D693B6966286F3D3D73297B6C657420723D742869293B723C6F3F286E3D2264656C6574652E6261636B77';
wwv_flow_imp.g_varchar2_table(46586) := '617264222C723D754F28652C722C213129293A723E6F2626286E3D2264656C6574652E666F7277617264222C723D754F28652C722C213029292C6F3D4D6174682E6D696E286F2C72292C733D4D6174682E6D617828732C72297D656C7365206F3D754F28';
wwv_flow_imp.g_varchar2_table(46587) := '652C6F2C2131292C733D754F28652C732C2130293B72657475726E206F3D3D733F7B72616E67653A697D3A7B6368616E6765733A7B66726F6D3A6F2C746F3A737D2C72616E67653A666B2E637572736F72286F2C6F3C692E686561643F2D313A31297D7D';
wwv_flow_imp.g_varchar2_table(46588) := '29293B72657475726E216F2E6368616E6765732E656D707479262628652E646973706174636828692E757064617465286F2C7B7363726F6C6C496E746F566965773A21302C757365724576656E743A6E2C656666656374733A2264656C6574652E73656C';
wwv_flow_imp.g_varchar2_table(46589) := '656374696F6E223D3D6E3F44492E616E6E6F756E63652E6F6628692E706872617365282253656C656374696F6E2064656C657465642229293A766F696420307D29292C2130297D66756E6374696F6E20754F28652C742C6E297B6966286520696E737461';
wwv_flow_imp.g_varchar2_table(46590) := '6E63656F6620444929666F72286C65742069206F6620652E73746174652E66616365742844492E61746F6D696352616E676573292E6D61702828743D3E74286529292929692E6265747765656E28742C742C2828652C69293D3E7B653C742626693E7426';
wwv_flow_imp.g_varchar2_table(46591) := '2628743D6E3F693A65297D29293B72657475726E20747D636F6E737420704F3D28652C742C6E293D3E684F28652C28693D3E7B6C6574206F2C732C723D692E66726F6D2C7B73746174653A617D3D652C6C3D612E646F632E6C696E6541742872293B6966';
wwv_flow_imp.g_varchar2_table(46592) := '286E262621742626723E6C2E66726F6D2626723C6C2E66726F6D2B3230302626212F5B5E205C745D2F2E74657374286F3D6C2E746578742E736C69636528302C722D6C2E66726F6D2929297B696628225C74223D3D6F5B6F2E6C656E6774682D315D2972';
wwv_flow_imp.g_varchar2_table(46593) := '657475726E20722D313B6C657420653D7945286F2C612E74616253697A652925584D2861297C7C584D2861293B666F72286C657420743D303B743C6526262220223D3D6F5B6F2E6C656E6774682D312D745D3B742B2B29722D2D3B733D727D656C736520';
wwv_flow_imp.g_varchar2_table(46594) := '733D5A78286C2E746578742C722D6C2E66726F6D2C742C74292B6C2E66726F6D2C733D3D7226266C2E6E756D626572213D28743F612E646F632E6C696E65733A31293F732B3D743F313A2D313A217426262F5B5C75666530302D5C75666530665D2F2E74';
wwv_flow_imp.g_varchar2_table(46595) := '657374286C2E746578742E736C69636528732D6C2E66726F6D2C722D6C2E66726F6D2929262628733D5A78286C2E746578742C732D6C2E66726F6D2C21312C2131292B6C2E66726F6D293B72657475726E20737D29292C674F3D653D3E704F28652C2131';
wwv_flow_imp.g_varchar2_table(46596) := '2C2130292C6D4F3D653D3E704F28652C21302C2131292C664F3D28652C74293D3E684F28652C286E3D3E7B6C657420693D6E2E686561642C7B73746174653A6F7D3D652C733D6F2E646F632E6C696E6541742869292C723D6F2E6368617243617465676F';
wwv_flow_imp.g_varchar2_table(46597) := '72697A65722869293B666F72286C657420653D6E756C6C3B3B297B696628693D3D28743F732E746F3A732E66726F6D29297B693D3D6E2E686561642626732E6E756D626572213D28743F6F2E646F632E6C696E65733A3129262628692B3D743F313A2D31';
wwv_flow_imp.g_varchar2_table(46598) := '293B627265616B7D6C657420613D5A7828732E746578742C692D732E66726F6D2C74292B732E66726F6D2C6C3D732E746578742E736C696365284D6174682E6D696E28692C61292D732E66726F6D2C4D6174682E6D617828692C61292D732E66726F6D29';
wwv_flow_imp.g_varchar2_table(46599) := '2C633D72286C293B6966286E756C6C213D65262663213D6529627265616B3B2220223D3D6C2626693D3D6E2E686561647C7C28653D63292C693D617D72657475726E20697D29292C764F3D653D3E664F28652C2131293B66756E6374696F6E20624F2865';
wwv_flow_imp.g_varchar2_table(46600) := '297B6C657420743D5B5D2C6E3D2D313B666F72286C65742069206F6620652E73656C656374696F6E2E72616E676573297B6C6574206F3D652E646F632E6C696E65417428692E66726F6D292C733D652E646F632E6C696E65417428692E746F293B696628';
wwv_flow_imp.g_varchar2_table(46601) := '692E656D7074797C7C692E746F213D732E66726F6D7C7C28733D652E646F632E6C696E65417428692E746F2D3129292C6E3E3D6F2E6E756D626572297B6C657420653D745B742E6C656E6774682D315D3B652E746F3D732E746F2C652E72616E6765732E';
wwv_flow_imp.g_varchar2_table(46602) := '707573682869297D656C736520742E70757368287B66726F6D3A6F2E66726F6D2C746F3A732E746F2C72616E6765733A5B695D7D293B6E3D732E6E756D6265722B317D72657475726E20747D66756E6374696F6E205F4F28652C742C6E297B696628652E';
wwv_flow_imp.g_varchar2_table(46603) := '726561644F6E6C792972657475726E21313B6C657420693D5B5D2C6F3D5B5D3B666F72286C65742074206F6620624F286529297B6966286E3F742E746F3D3D652E646F632E6C656E6774683A303D3D742E66726F6D29636F6E74696E75653B6C65742073';
wwv_flow_imp.g_varchar2_table(46604) := '3D652E646F632E6C696E654174286E3F742E746F2B313A742E66726F6D2D31292C723D732E6C656E6774682B313B6966286E297B692E70757368287B66726F6D3A742E746F2C746F3A732E746F7D2C7B66726F6D3A742E66726F6D2C696E736572743A73';
wwv_flow_imp.g_varchar2_table(46605) := '2E746578742B652E6C696E65427265616B7D293B666F72286C6574206E206F6620742E72616E676573296F2E7075736828666B2E72616E6765284D6174682E6D696E28652E646F632E6C656E6774682C6E2E616E63686F722B72292C4D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(46606) := '28652E646F632E6C656E6774682C6E2E686561642B722929297D656C73657B692E70757368287B66726F6D3A732E66726F6D2C746F3A742E66726F6D7D2C7B66726F6D3A742E746F2C696E736572743A652E6C696E65427265616B2B732E746578747D29';
wwv_flow_imp.g_varchar2_table(46607) := '3B666F72286C65742065206F6620742E72616E676573296F2E7075736828666B2E72616E676528652E616E63686F722D722C652E686561642D7229297D7D72657475726E2121692E6C656E6774682626287428652E757064617465287B6368616E676573';
wwv_flow_imp.g_varchar2_table(46608) := '3A692C7363726F6C6C496E746F566965773A21302C73656C656374696F6E3A666B2E637265617465286F2C652E73656C656374696F6E2E6D61696E496E646578292C757365724576656E743A226D6F76652E6C696E65227D29292C2130297D66756E6374';
wwv_flow_imp.g_varchar2_table(46609) := '696F6E20794F28652C742C6E297B696628652E726561644F6E6C792972657475726E21313B6C657420693D5B5D3B666F72286C65742074206F6620624F286529296E3F692E70757368287B66726F6D3A742E66726F6D2C696E736572743A652E646F632E';
wwv_flow_imp.g_varchar2_table(46610) := '736C69636528742E66726F6D2C742E746F292B652E6C696E65427265616B7D293A692E70757368287B66726F6D3A742E746F2C696E736572743A652E6C696E65427265616B2B652E646F632E736C69636528742E66726F6D2C742E746F297D293B726574';
wwv_flow_imp.g_varchar2_table(46611) := '75726E207428652E757064617465287B6368616E6765733A692C7363726F6C6C496E746F566965773A21302C757365724576656E743A22696E7075742E636F70796C696E65227D29292C21307D636F6E737420774F3D534F282131292C434F3D534F2821';
wwv_flow_imp.g_varchar2_table(46612) := '30293B66756E6374696F6E20534F2865297B72657475726E287B73746174653A742C64697370617463683A6E7D293D3E7B696628742E726561644F6E6C792972657475726E21313B6C657420693D742E6368616E6765427952616E676528286E3D3E7B6C';
wwv_flow_imp.g_varchar2_table(46613) := '65747B66726F6D3A692C746F3A6F7D3D6E2C733D742E646F632E6C696E6541742869292C723D21652626693D3D6F262666756E6374696F6E28652C74297B6966282F5C285C297C5C5B5C5D7C5C7B5C7D2F2E7465737428652E736C696365446F6328742D';
wwv_flow_imp.g_varchar2_table(46614) := '312C742B3129292972657475726E7B66726F6D3A742C746F3A747D3B6C6574206E2C693D564D2865292E7265736F6C7665496E6E65722874292C6F3D692E6368696C644265666F72652874292C733D692E6368696C6441667465722874293B7265747572';
wwv_flow_imp.g_varchar2_table(46615) := '6E206F26267326266F2E746F3C3D742626732E66726F6D3E3D742626286E3D6F2E747970652E70726F702858432E636C6F7365644279292926266E2E696E6465784F6628732E6E616D65293E2D312626652E646F632E6C696E654174286F2E746F292E66';
wwv_flow_imp.g_varchar2_table(46616) := '726F6D3D3D652E646F632E6C696E65417428732E66726F6D292E66726F6D2626212F5C532F2E7465737428652E736C696365446F63286F2E746F2C732E66726F6D29293F7B66726F6D3A6F2E746F2C746F3A732E66726F6D7D3A6E756C6C7D28742C6929';
wwv_flow_imp.g_varchar2_table(46617) := '3B65262628693D6F3D286F3C3D732E746F3F733A742E646F632E6C696E654174286F29292E746F293B6C657420613D6E657720744128742C7B73696D756C617465427265616B3A692C73696D756C617465446F75626C65427265616B3A2121727D292C6C';
wwv_flow_imp.g_varchar2_table(46618) := '3D654128612C69293B666F72286E756C6C3D3D6C2626286C3D7945282F5E5C732A2F2E6578656328742E646F632E6C696E6541742869292E74657874295B305D2C742E74616253697A6529293B6F3C732E746F26262F5C732F2E7465737428732E746578';
wwv_flow_imp.g_varchar2_table(46619) := '745B6F2D732E66726F6D5D293B296F2B2B3B723F287B66726F6D3A692C746F3A6F7D3D72293A693E732E66726F6D2626693C732E66726F6D2B3130302626212F5C532F2E7465737428732E746578742E736C69636528302C692929262628693D732E6672';
wwv_flow_imp.g_varchar2_table(46620) := '6F6D293B6C657420633D5B22222C4A4D28742C6C295D3B72657475726E20722626632E70757368284A4D28742C612E6C696E65496E64656E7428732E66726F6D2C2D312929292C7B6368616E6765733A7B66726F6D3A692C746F3A6F2C696E736572743A';
wwv_flow_imp.g_varchar2_table(46621) := '46782E6F662863297D2C72616E67653A666B2E637572736F7228692B312B635B315D2E6C656E677468297D7D29293B72657475726E206E28742E75706461746528692C7B7363726F6C6C496E746F566965773A21302C757365724576656E743A22696E70';
wwv_flow_imp.g_varchar2_table(46622) := '7574227D29292C21307D7D66756E6374696F6E20784F28652C74297B6C6574206E3D2D313B72657475726E20652E6368616E6765427952616E67652828693D3E7B6C6574206F3D5B5D3B666F72286C657420733D692E66726F6D3B733C3D692E746F3B29';
wwv_flow_imp.g_varchar2_table(46623) := '7B6C657420723D652E646F632E6C696E6541742873293B722E6E756D6265723E6E262628692E656D7074797C7C692E746F3E722E66726F6D292626287428722C6F2C69292C6E3D722E6E756D626572292C733D722E746F2B317D6C657420733D652E6368';
wwv_flow_imp.g_varchar2_table(46624) := '616E676573286F293B72657475726E7B6368616E6765733A6F2C72616E67653A666B2E72616E676528732E6D6170506F7328692E616E63686F722C31292C732E6D6170506F7328692E686561642C3129297D7D29297D636F6E7374206B4F3D5B7B6B6579';
wwv_flow_imp.g_varchar2_table(46625) := '3A224374726C2D62222C72756E3A46502C73686966743A58502C70726576656E7444656661756C743A21307D2C7B6B65793A224374726C2D66222C72756E3A42502C73686966743A4A507D2C7B6B65793A224374726C2D70222C72756E3A6A502C736869';
wwv_flow_imp.g_varchar2_table(46626) := '66743A6E4F7D2C7B6B65793A224374726C2D6E222C72756E3A71502C73686966743A694F7D2C7B6B65793A224374726C2D61222C72756E3A653D3E4E5028652C28743D3E666B2E637572736F7228652E6C696E65426C6F636B417428742E68656164292E';
wwv_flow_imp.g_varchar2_table(46627) := '66726F6D2C312929292C73686966743A653D3E595028652C28743D3E666B2E637572736F7228652E6C696E65426C6F636B417428742E68656164292E66726F6D2929297D2C7B6B65793A224374726C2D65222C72756E3A653D3E4E5028652C28743D3E66';
wwv_flow_imp.g_varchar2_table(46628) := '6B2E637572736F7228652E6C696E65426C6F636B417428742E68656164292E746F2C2D312929292C73686966743A653D3E595028652C28743D3E666B2E637572736F7228652E6C696E65426C6F636B417428742E68656164292E746F2929297D2C7B6B65';
wwv_flow_imp.g_varchar2_table(46629) := '793A224374726C2D64222C72756E3A6D4F7D2C7B6B65793A224374726C2D68222C72756E3A674F7D2C7B6B65793A224374726C2D6B222C72756E3A653D3E684F28652C28743D3E7B6C6574206E3D652E6C696E65426C6F636B417428742E68656164292E';
wwv_flow_imp.g_varchar2_table(46630) := '746F3B72657475726E20742E686561643C6E3F6E3A4D6174682E6D696E28652E73746174652E646F632E6C656E6774682C742E686561642B31297D29297D2C7B6B65793A224374726C2D416C742D68222C72756E3A764F7D2C7B6B65793A224374726C2D';
wwv_flow_imp.g_varchar2_table(46631) := '6F222C72756E3A287B73746174653A652C64697370617463683A747D293D3E7B696628652E726561644F6E6C792972657475726E21313B6C6574206E3D652E6368616E6765427952616E67652828653D3E287B6368616E6765733A7B66726F6D3A652E66';
wwv_flow_imp.g_varchar2_table(46632) := '726F6D2C746F3A652E746F2C696E736572743A46782E6F66285B22222C22225D297D2C72616E67653A666B2E637572736F7228652E66726F6D297D2929293B72657475726E207428652E757064617465286E2C7B7363726F6C6C496E746F566965773A21';
wwv_flow_imp.g_varchar2_table(46633) := '302C757365724576656E743A22696E707574227D29292C21307D7D2C7B6B65793A224374726C2D74222C72756E3A287B73746174653A652C64697370617463683A747D293D3E7B696628652E726561644F6E6C792972657475726E21313B6C6574206E3D';
wwv_flow_imp.g_varchar2_table(46634) := '652E6368616E6765427952616E67652828743D3E7B69662821742E656D7074797C7C303D3D742E66726F6D7C7C742E66726F6D3D3D652E646F632E6C656E6774682972657475726E7B72616E67653A747D3B6C6574206E3D742E66726F6D2C693D652E64';
wwv_flow_imp.g_varchar2_table(46635) := '6F632E6C696E654174286E292C6F3D6E3D3D692E66726F6D3F6E2D313A5A7828692E746578742C6E2D692E66726F6D2C2131292B692E66726F6D2C733D6E3D3D692E746F3F6E2B313A5A7828692E746578742C6E2D692E66726F6D2C2130292B692E6672';
wwv_flow_imp.g_varchar2_table(46636) := '6F6D3B72657475726E7B6368616E6765733A7B66726F6D3A6F2C746F3A732C696E736572743A652E646F632E736C696365286E2C73292E617070656E6428652E646F632E736C696365286F2C6E29297D2C72616E67653A666B2E637572736F722873297D';
wwv_flow_imp.g_varchar2_table(46637) := '7D29293B72657475726E216E2E6368616E6765732E656D7074792626287428652E757064617465286E2C7B7363726F6C6C496E746F566965773A21302C757365724576656E743A226D6F76652E636861726163746572227D29292C2130297D7D2C7B6B65';
wwv_flow_imp.g_varchar2_table(46638) := '793A224374726C2D76222C72756E3A47507D5D2C454F3D5B7B6B65793A224172726F774C656674222C72756E3A46502C73686966743A58502C70726576656E7444656661756C743A21307D2C7B6B65793A224D6F642D4172726F774C656674222C6D6163';
wwv_flow_imp.g_varchar2_table(46639) := '3A22416C742D4172726F774C656674222C72756E3A653D3E565028652C215250286529292C73686966743A653D3E654F28652C215250286529292C70726576656E7444656661756C743A21307D2C7B6D61633A22436D642D4172726F774C656674222C72';
wwv_flow_imp.g_varchar2_table(46640) := '756E3A653D3E4E5028652C28743D3E515028652C742C2152502865292929292C73686966743A653D3E595028652C28743D3E515028652C742C2152502865292929292C70726576656E7444656661756C743A21307D2C7B6B65793A224172726F77526967';
wwv_flow_imp.g_varchar2_table(46641) := '6874222C72756E3A42502C73686966743A4A502C70726576656E7444656661756C743A21307D2C7B6B65793A224D6F642D4172726F775269676874222C6D61633A22416C742D4172726F775269676874222C72756E3A653D3E565028652C525028652929';
wwv_flow_imp.g_varchar2_table(46642) := '2C73686966743A653D3E654F28652C5250286529292C70726576656E7444656661756C743A21307D2C7B6D61633A22436D642D4172726F775269676874222C72756E3A653D3E4E5028652C28743D3E515028652C742C52502865292929292C7368696674';
wwv_flow_imp.g_varchar2_table(46643) := '3A653D3E595028652C28743D3E515028652C742C52502865292929292C70726576656E7444656661756C743A21307D2C7B6B65793A224172726F775570222C72756E3A6A502C73686966743A6E4F2C70726576656E7444656661756C743A21307D2C7B6D';
wwv_flow_imp.g_varchar2_table(46644) := '61633A22436D642D4172726F775570222C72756E3A614F2C73686966743A634F7D2C7B6D61633A224374726C2D4172726F775570222C72756E3A4B502C73686966743A734F7D2C7B6B65793A224172726F77446F776E222C72756E3A71502C7368696674';
wwv_flow_imp.g_varchar2_table(46645) := '3A694F2C70726576656E7444656661756C743A21307D2C7B6D61633A22436D642D4172726F77446F776E222C72756E3A6C4F2C73686966743A644F7D2C7B6D61633A224374726C2D4172726F77446F776E222C72756E3A47502C73686966743A724F7D2C';
wwv_flow_imp.g_varchar2_table(46646) := '7B6B65793A22506167655570222C72756E3A4B502C73686966743A734F7D2C7B6B65793A2250616765446F776E222C72756E3A47502C73686966743A724F7D2C7B6B65793A22486F6D65222C72756E3A653D3E4E5028652C28743D3E515028652C742C21';
wwv_flow_imp.g_varchar2_table(46647) := '312929292C73686966743A653D3E595028652C28743D3E515028652C742C21312929292C70726576656E7444656661756C743A21307D2C7B6B65793A224D6F642D486F6D65222C72756E3A614F2C73686966743A634F7D2C7B6B65793A22456E64222C72';
wwv_flow_imp.g_varchar2_table(46648) := '756E3A653D3E4E5028652C28743D3E515028652C742C21302929292C73686966743A653D3E595028652C28743D3E515028652C742C21302929292C70726576656E7444656661756C743A21307D2C7B6B65793A224D6F642D456E64222C72756E3A6C4F2C';
wwv_flow_imp.g_varchar2_table(46649) := '73686966743A644F7D2C7B6B65793A22456E746572222C72756E3A774F7D2C7B6B65793A224D6F642D61222C72756E3A287B73746174653A652C64697370617463683A747D293D3E287428652E757064617465287B73656C656374696F6E3A7B616E6368';
wwv_flow_imp.g_varchar2_table(46650) := '6F723A302C686561643A652E646F632E6C656E6774687D2C757365724576656E743A2273656C656374227D29292C2130297D2C7B6B65793A224261636B7370616365222C72756E3A674F2C73686966743A674F7D2C7B6B65793A2244656C657465222C72';
wwv_flow_imp.g_varchar2_table(46651) := '756E3A6D4F7D2C7B6B65793A224D6F642D4261636B7370616365222C6D61633A22416C742D4261636B7370616365222C72756E3A764F7D2C7B6B65793A224D6F642D44656C657465222C6D61633A22416C742D44656C657465222C72756E3A653D3E664F';
wwv_flow_imp.g_varchar2_table(46652) := '28652C2130297D2C7B6D61633A224D6F642D4261636B7370616365222C72756E3A653D3E684F28652C28743D3E7B6C6574206E3D652E6D6F7665546F4C696E65426F756E6461727928742C2131292E686561643B72657475726E20742E686561643E6E3F';
wwv_flow_imp.g_varchar2_table(46653) := '6E3A4D6174682E6D617828302C742E686561642D31297D29297D2C7B6D61633A224D6F642D44656C657465222C72756E3A653D3E684F28652C28743D3E7B6C6574206E3D652E6D6F7665546F4C696E65426F756E6461727928742C2130292E686561643B';
wwv_flow_imp.g_varchar2_table(46654) := '72657475726E20742E686561643C6E3F6E3A4D6174682E6D696E28652E73746174652E646F632E6C656E6774682C742E686561642B31297D29297D5D2E636F6E636174286B4F2E6D61702828653D3E287B6D61633A652E6B65792C72756E3A652E72756E';
wwv_flow_imp.g_varchar2_table(46655) := '2C73686966743A652E73686966747D292929292C4C4F3D5B7B6B65793A22416C742D4172726F774C656674222C6D61633A224374726C2D4172726F774C656674222C72756E3A653D3E4E5028652C28743D3E485028652E73746174652C742C2152502865';
wwv_flow_imp.g_varchar2_table(46656) := '292929292C73686966743A653D3E595028652C28743D3E485028652E73746174652C742C2152502865292929297D2C7B6B65793A22416C742D4172726F775269676874222C6D61633A224374726C2D4172726F775269676874222C72756E3A653D3E4E50';
wwv_flow_imp.g_varchar2_table(46657) := '28652C28743D3E485028652E73746174652C742C52502865292929292C73686966743A653D3E595028652C28743D3E485028652E73746174652C742C52502865292929297D2C7B6B65793A22416C742D4172726F775570222C72756E3A287B7374617465';
wwv_flow_imp.g_varchar2_table(46658) := '3A652C64697370617463683A747D293D3E5F4F28652C742C2131297D2C7B6B65793A2253686966742D416C742D4172726F775570222C72756E3A287B73746174653A652C64697370617463683A747D293D3E794F28652C742C2131297D2C7B6B65793A22';
wwv_flow_imp.g_varchar2_table(46659) := '416C742D4172726F77446F776E222C72756E3A287B73746174653A652C64697370617463683A747D293D3E5F4F28652C742C2130297D2C7B6B65793A2253686966742D416C742D4172726F77446F776E222C72756E3A287B73746174653A652C64697370';
wwv_flow_imp.g_varchar2_table(46660) := '617463683A747D293D3E794F28652C742C2130297D2C7B6B65793A22457363617065222C72756E3A287B73746174653A652C64697370617463683A747D293D3E7B6C6574206E3D652E73656C656374696F6E2C693D6E756C6C3B72657475726E206E2E72';
wwv_flow_imp.g_varchar2_table(46661) := '616E6765732E6C656E6774683E313F693D666B2E637265617465285B6E2E6D61696E5D293A6E2E6D61696E2E656D7074797C7C28693D666B2E637265617465285B666B2E637572736F72286E2E6D61696E2E68656164295D29292C212169262628742841';
wwv_flow_imp.g_varchar2_table(46662) := '5028652C6929292C2130297D7D2C7B6B65793A224D6F642D456E746572222C72756E3A434F7D2C7B6B65793A22416C742D6C222C6D61633A224374726C2D6C222C72756E3A287B73746174653A652C64697370617463683A747D293D3E7B6C6574206E3D';
wwv_flow_imp.g_varchar2_table(46663) := '624F2865292E6D61702828287B66726F6D3A742C746F3A6E7D293D3E666B2E72616E676528742C4D6174682E6D696E286E2B312C652E646F632E6C656E677468292929293B72657475726E207428652E757064617465287B73656C656374696F6E3A666B';
wwv_flow_imp.g_varchar2_table(46664) := '2E637265617465286E292C757365724576656E743A2273656C656374227D29292C21307D7D2C7B6B65793A224D6F642D69222C72756E3A287B73746174653A652C64697370617463683A747D293D3E7B6C6574206E3D4D5028652E73656C656374696F6E';
wwv_flow_imp.g_varchar2_table(46665) := '2C28743D3E7B766172206E3B666F72286C657420693D564D2865292E7265736F6C7665537461636B28742E66726F6D2C31293B693B693D692E6E657874297B6C65747B6E6F64653A657D3D693B69662828652E66726F6D3C742E66726F6D2626652E746F';
wwv_flow_imp.g_varchar2_table(46666) := '3E3D742E746F7C7C652E746F3E742E746F2626652E66726F6D3C3D742E66726F6D292626286E756C6C3D3D3D286E3D652E706172656E74297C7C766F696420303D3D3D6E3F766F696420303A6E2E706172656E74292972657475726E20666B2E72616E67';
wwv_flow_imp.g_varchar2_table(46667) := '6528652E746F2C652E66726F6D297D72657475726E20747D29293B72657475726E207428415028652C6E29292C21307D2C70726576656E7444656661756C743A21307D2C7B6B65793A224D6F642D5B222C72756E3A287B73746174653A652C6469737061';
wwv_flow_imp.g_varchar2_table(46668) := '7463683A747D293D3E21652E726561644F6E6C792626287428652E75706461746528784F28652C2828742C6E293D3E7B6C657420693D2F5E5C732A2F2E6578656328742E74657874295B305D3B69662821692972657475726E3B6C6574206F3D79452869';
wwv_flow_imp.g_varchar2_table(46669) := '2C652E74616253697A65292C733D302C723D4A4D28652C4D6174682E6D617828302C6F2D584D28652929293B666F72283B733C692E6C656E6774682626733C722E6C656E6774682626692E63686172436F646541742873293D3D722E63686172436F6465';
wwv_flow_imp.g_varchar2_table(46670) := '41742873293B29732B2B3B6E2E70757368287B66726F6D3A742E66726F6D2B732C746F3A742E66726F6D2B692E6C656E6774682C696E736572743A722E736C6963652873297D297D29292C7B757365724576656E743A2264656C6574652E646564656E74';
wwv_flow_imp.g_varchar2_table(46671) := '227D29292C2130297D2C7B6B65793A224D6F642D5D222C72756E3A287B73746174653A652C64697370617463683A747D293D3E21652E726561644F6E6C792626287428652E75706461746528784F28652C2828742C6E293D3E7B6E2E70757368287B6672';
wwv_flow_imp.g_varchar2_table(46672) := '6F6D3A742E66726F6D2C696E736572743A652E6661636574285A4D297D297D29292C7B757365724576656E743A22696E7075742E696E64656E74227D29292C2130297D2C7B6B65793A224D6F642D416C742D5C5C222C72756E3A287B73746174653A652C';
wwv_flow_imp.g_varchar2_table(46673) := '64697370617463683A747D293D3E7B696628652E726561644F6E6C792972657475726E21313B6C6574206E3D4F626A6563742E637265617465286E756C6C292C693D6E657720744128652C7B6F76657272696465496E64656E746174696F6E3A653D3E7B';
wwv_flow_imp.g_varchar2_table(46674) := '6C657420743D6E5B655D3B72657475726E206E756C6C3D3D743F2D313A747D7D292C6F3D784F28652C2828742C6F2C73293D3E7B6C657420723D654128692C742E66726F6D293B6966286E756C6C3D3D722972657475726E3B2F5C532F2E746573742874';
wwv_flow_imp.g_varchar2_table(46675) := '2E74657874297C7C28723D30293B6C657420613D2F5E5C732A2F2E6578656328742E74657874295B305D2C6C3D4A4D28652C72293B2861213D6C7C7C732E66726F6D3C742E66726F6D2B612E6C656E677468292626286E5B742E66726F6D5D3D722C6F2E';
wwv_flow_imp.g_varchar2_table(46676) := '70757368287B66726F6D3A742E66726F6D2C746F3A742E66726F6D2B612E6C656E6774682C696E736572743A6C7D29297D29293B72657475726E206F2E6368616E6765732E656D7074797C7C7428652E757064617465286F2C7B757365724576656E743A';
wwv_flow_imp.g_varchar2_table(46677) := '22696E64656E74227D29292C21307D7D2C7B6B65793A2253686966742D4D6F642D6B222C72756E3A653D3E7B696628652E73746174652E726561644F6E6C792972657475726E21313B6C65747B73746174653A747D3D652C6E3D742E6368616E67657328';
wwv_flow_imp.g_varchar2_table(46678) := '624F2874292E6D61702828287B66726F6D3A652C746F3A6E7D293D3E28653E303F652D2D3A6E3C742E646F632E6C656E67746826266E2B2B2C7B66726F6D3A652C746F3A6E7D292929292C693D4D5028742E73656C656374696F6E2C28743D3E7B6C6574';
wwv_flow_imp.g_varchar2_table(46679) := '206E3B696628652E6C696E655772617070696E67297B6C657420693D652E6C696E65426C6F636B417428742E68656164292C6F3D652E636F6F7264734174506F7328742E686561642C742E6173736F637C7C31293B6F2626286E3D692E626F74746F6D2B';
wwv_flow_imp.g_varchar2_table(46680) := '652E646F63756D656E74546F702D6F2E626F74746F6D2B652E64656661756C744C696E654865696768742F32297D72657475726E20652E6D6F7665566572746963616C6C7928742C21302C6E297D29292E6D6170286E293B72657475726E20652E646973';
wwv_flow_imp.g_varchar2_table(46681) := '7061746368287B6368616E6765733A6E2C73656C656374696F6E3A692C7363726F6C6C496E746F566965773A21302C757365724576656E743A2264656C6574652E6C696E65227D292C21307D7D2C7B6B65793A2253686966742D4D6F642D5C5C222C7275';
wwv_flow_imp.g_varchar2_table(46682) := '6E3A287B73746174653A652C64697370617463683A747D293D3E66756E6374696F6E28652C742C6E297B6C657420693D21312C6F3D4D5028652E73656C656374696F6E2C28743D3E7B6C6574206F3D4F4128652C742E686561642C2D31297C7C4F412865';
wwv_flow_imp.g_varchar2_table(46683) := '2C742E686561642C31297C7C742E686561643E3026264F4128652C742E686561642D312C31297C7C742E686561643C652E646F632E6C656E67746826264F4128652C742E686561642B312C2D31293B696628216F7C7C216F2E656E642972657475726E20';
wwv_flow_imp.g_varchar2_table(46684) := '743B693D21303B6C657420733D6F2E73746172742E66726F6D3D3D742E686561643F6F2E656E642E746F3A6F2E656E642E66726F6D3B72657475726E206E3F666B2E72616E676528742E616E63686F722C73293A666B2E637572736F722873297D29293B';
wwv_flow_imp.g_varchar2_table(46685) := '72657475726E2121692626287428415028652C6F29292C2130297D28652C742C2131297D2C7B6B65793A224D6F642D2F222C72756E3A653D3E7B6C65747B73746174653A747D3D652C6E3D742E646F632E6C696E65417428742E73656C656374696F6E2E';
wwv_flow_imp.g_varchar2_table(46686) := '6D61696E2E66726F6D292C693D665028652E73746174652C6E2E66726F6D293B72657475726E20692E6C696E653F70502865293A2121692E626C6F636B26266D502865297D7D2C7B6B65793A22416C742D41222C72756E3A67507D2C7B6B65793A224374';
wwv_flow_imp.g_varchar2_table(46687) := '726C2D6D222C6D61633A2253686966742D416C742D6D222C72756E3A653D3E28652E736574546162466F6375734D6F646528292C2130297D5D2E636F6E63617428454F293B66756E6374696F6E20444F28297B76617220653D617267756D656E74735B30';
wwv_flow_imp.g_varchar2_table(46688) := '5D3B22737472696E67223D3D747970656F662065262628653D646F63756D656E742E637265617465456C656D656E74286529293B76617220743D312C6E3D617267756D656E74735B315D3B6966286E2626226F626A656374223D3D747970656F66206E26';
wwv_flow_imp.g_varchar2_table(46689) := '266E756C6C3D3D6E2E6E6F64655479706526262141727261792E69734172726179286E29297B666F7228766172206920696E206E296966284F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286E2C6929297B76';
wwv_flow_imp.g_varchar2_table(46690) := '6172206F3D6E5B695D3B22737472696E67223D3D747970656F66206F3F652E73657441747472696275746528692C6F293A6E756C6C213D6F262628655B695D3D6F297D742B2B7D666F72283B743C617267756D656E74732E6C656E6774683B742B2B2954';
wwv_flow_imp.g_varchar2_table(46691) := '4F28652C617267756D656E74735B745D293B72657475726E20657D66756E6374696F6E20544F28652C74297B69662822737472696E67223D3D747970656F66207429652E617070656E644368696C6428646F63756D656E742E637265617465546578744E';
wwv_flow_imp.g_varchar2_table(46692) := '6F6465287429293B656C7365206966286E756C6C3D3D74293B656C7365206966286E756C6C213D742E6E6F64655479706529652E617070656E644368696C642874293B656C73657B6966282141727261792E69734172726179287429297468726F77206E';
wwv_flow_imp.g_varchar2_table(46693) := '65772052616E67654572726F722822556E737570706F72746564206368696C64206E6F64653A20222B74293B666F7228766172206E3D303B6E3C742E6C656E6774683B6E2B2B29544F28652C745B6E5D297D7D636C61737320494F7B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(46694) := '746F7228652C742C6E297B746869732E66726F6D3D652C746869732E746F3D742C746869732E646961676E6F737469633D6E7D7D636C617373204D4F7B636F6E7374727563746F7228652C742C6E297B746869732E646961676E6F73746963733D652C74';
wwv_flow_imp.g_varchar2_table(46695) := '6869732E70616E656C3D742C746869732E73656C65637465643D6E7D73746174696320696E697428652C742C6E297B6C657420693D652C6F3D6E2E6661636574286A4F292E6D61726B657246696C7465723B6F262628693D6F28692C6E29293B6C657420';
wwv_flow_imp.g_varchar2_table(46696) := '733D504C2E73657428692E6D61702828653D3E652E66726F6D3D3D652E746F7C7C652E66726F6D3D3D652E746F2D3126266E2E646F632E6C696E65417428652E66726F6D292E746F3D3D652E66726F6D3F504C2E776964676574287B7769646765743A6E';
wwv_flow_imp.g_varchar2_table(46697) := '6577204B4F2865292C646961676E6F737469633A657D292E72616E676528652E66726F6D293A504C2E6D61726B287B617474726962757465733A7B636C6173733A22636D2D6C696E7452616E676520636D2D6C696E7452616E67652D222B652E73657665';
wwv_flow_imp.g_varchar2_table(46698) := '726974792B28652E6D61726B436C6173733F2220222B652E6D61726B436C6173733A2222297D2C646961676E6F737469633A657D292E72616E676528652E66726F6D2C652E746F2929292C2130293B72657475726E206E6577204D4F28732C742C414F28';
wwv_flow_imp.g_varchar2_table(46699) := '7329297D7D66756E6374696F6E20414F28652C743D6E756C6C2C6E3D30297B6C657420693D6E756C6C3B72657475726E20652E6265747765656E286E2C3165392C2828652C6E2C7B737065633A6F7D293D3E7B69662821747C7C6F2E646961676E6F7374';
wwv_flow_imp.g_varchar2_table(46700) := '69633D3D742972657475726E20693D6E657720494F28652C6E2C6F2E646961676E6F73746963292C21317D29292C697D66756E6374696F6E204E4F28652C74297B72657475726E20652E6669656C6428464F2C2131293F743A742E636F6E63617428246B';
wwv_flow_imp.g_varchar2_table(46701) := '2E617070656E64436F6E6669672E6F6628584F29297D636F6E737420504F3D246B2E646566696E6528292C4F4F3D246B2E646566696E6528292C524F3D246B2E646566696E6528292C464F3D456B2E646566696E65287B6372656174653A28293D3E6E65';
wwv_flow_imp.g_varchar2_table(46702) := '77204D4F28504C2E6E6F6E652C6E756C6C2C6E756C6C292C75706461746528652C74297B696628742E646F634368616E6765642626652E646961676E6F73746963732E73697A65297B6C6574206E3D652E646961676E6F73746963732E6D617028742E63';
wwv_flow_imp.g_varchar2_table(46703) := '68616E676573292C693D6E756C6C2C6F3D652E70616E656C3B696628652E73656C6563746564297B6C6574206F3D742E6368616E6765732E6D6170506F7328652E73656C65637465642E66726F6D2C31293B693D414F286E2C652E73656C65637465642E';
wwv_flow_imp.g_varchar2_table(46704) := '646961676E6F737469632C6F297C7C414F286E2C6E756C6C2C6F297D216E2E73697A6526266F2626742E73746174652E6661636574286A4F292E6175746F50616E656C2626286F3D6E756C6C292C653D6E6577204D4F286E2C6F2C69297D666F72286C65';
wwv_flow_imp.g_varchar2_table(46705) := '74206E206F6620742E65666665637473296966286E2E697328504F29297B6C657420693D742E73746174652E6661636574286A4F292E6175746F50616E656C3F6E2E76616C75652E6C656E6774683F514F2E6F70656E3A6E756C6C3A652E70616E656C3B';
wwv_flow_imp.g_varchar2_table(46706) := '653D4D4F2E696E6974286E2E76616C75652C692C742E7374617465297D656C7365206E2E6973284F4F293F653D6E6577204D4F28652E646961676E6F73746963732C6E2E76616C75653F514F2E6F70656E3A6E756C6C2C652E73656C6563746564293A6E';
wwv_flow_imp.g_varchar2_table(46707) := '2E697328524F29262628653D6E6577204D4F28652E646961676E6F73746963732C652E70616E656C2C6E2E76616C756529293B72657475726E20657D2C70726F766964653A653D3E5B754D2E66726F6D28652C28653D3E652E70616E656C29292C44492E';
wwv_flow_imp.g_varchar2_table(46708) := '6465636F726174696F6E732E66726F6D28652C28653D3E652E646961676E6F737469637329295D7D292C424F3D504C2E6D61726B287B636C6173733A22636D2D6C696E7452616E676520636D2D6C696E7452616E67652D616374697665227D293B66756E';
wwv_flow_imp.g_varchar2_table(46709) := '6374696F6E20564F28652C742C6E297B6C65747B646961676E6F73746963733A697D3D652E73746174652E6669656C6428464F292C6F3D5B5D2C733D3265382C723D303B692E6265747765656E28742D286E3C303F313A30292C742B286E3E303F313A30';
wwv_flow_imp.g_varchar2_table(46710) := '292C2828652C692C7B737065633A617D293D3E7B743E3D652626743C3D69262628653D3D697C7C28743E657C7C6E3E3029262628743C697C7C6E3C3029292626286F2E7075736828612E646961676E6F73746963292C733D4D6174682E6D696E28652C73';
wwv_flow_imp.g_varchar2_table(46711) := '292C723D4D6174682E6D617828692C7229297D29293B6C657420613D652E73746174652E6661636574286A4F292E746F6F6C74697046696C7465723B72657475726E20612626286F3D61286F2C652E737461746529292C6F2E6C656E6774683F7B706F73';
wwv_flow_imp.g_varchar2_table(46712) := '3A732C656E643A722C61626F76653A652E73746174652E646F632E6C696E6541742873292E746F3C722C6372656174653A28293D3E287B646F6D3A7A4F28652C6F297D297D3A6E756C6C7D66756E6374696F6E207A4F28652C74297B72657475726E2044';
wwv_flow_imp.g_varchar2_table(46713) := '4F2822756C222C7B636C6173733A22636D2D746F6F6C7469702D6C696E74227D2C742E6D61702828743D3E554F28652C742C2131292929297D636F6E737420484F3D653D3E7B6C657420743D652E73746174652E6669656C6428464F2C2131293B726574';
wwv_flow_imp.g_varchar2_table(46714) := '75726E212821747C7C21742E70616E656C7C7C28652E6469737061746368287B656666656374733A4F4F2E6F66282131297D292C3029297D2C574F3D49442E66726F6D436C61737328636C6173737B636F6E7374727563746F722865297B746869732E76';
wwv_flow_imp.g_varchar2_table(46715) := '6965773D652C746869732E74696D656F75743D2D312C746869732E7365743D21303B6C65747B64656C61793A747D3D652E73746174652E6661636574286A4F293B746869732E6C696E7454696D653D446174652E6E6F7728292B742C746869732E72756E';
wwv_flow_imp.g_varchar2_table(46716) := '3D746869732E72756E2E62696E642874686973292C746869732E74696D656F75743D73657454696D656F757428746869732E72756E2C74297D72756E28297B636C65617254696D656F757428746869732E74696D656F7574293B6C657420653D44617465';
wwv_flow_imp.g_varchar2_table(46717) := '2E6E6F7728293B696628653C746869732E6C696E7454696D652D313029746869732E74696D656F75743D73657454696D656F757428746869732E72756E2C746869732E6C696E7454696D652D65293B656C73657B746869732E7365743D21313B6C65747B';
wwv_flow_imp.g_varchar2_table(46718) := '73746174653A657D3D746869732E766965772C7B736F75726365733A747D3D652E6661636574286A4F293B742E6C656E677468262650726F6D6973652E616C6C28742E6D61702828653D3E50726F6D6973652E7265736F6C7665286528746869732E7669';
wwv_flow_imp.g_varchar2_table(46719) := '657729292929292E7468656E2828743D3E7B6C6574206E3D742E726564756365282828652C74293D3E652E636F6E63617428742929293B746869732E766965772E73746174652E646F633D3D652E646F632626746869732E766965772E64697370617463';
wwv_flow_imp.g_varchar2_table(46720) := '682866756E6374696F6E28652C74297B72657475726E7B656666656374733A4E4F28652C5B504F2E6F662874295D297D7D28746869732E766965772E73746174652C6E29297D292C28653D3E7B454428746869732E766965772E73746174652C65297D29';
wwv_flow_imp.g_varchar2_table(46721) := '297D7D7570646174652865297B6C657420743D652E73746174652E6661636574286A4F293B28652E646F634368616E6765647C7C74213D652E737461727453746174652E6661636574286A4F297C7C742E6E65656473526566726573682626742E6E6565';
wwv_flow_imp.g_varchar2_table(46722) := '64735265667265736828652929262628746869732E6C696E7454696D653D446174652E6E6F7728292B742E64656C61792C746869732E7365747C7C28746869732E7365743D21302C746869732E74696D656F75743D73657454696D656F75742874686973';
wwv_flow_imp.g_varchar2_table(46723) := '2E72756E2C742E64656C61792929297D666F72636528297B746869732E736574262628746869732E6C696E7454696D653D446174652E6E6F7728292C746869732E72756E2829297D64657374726F7928297B636C65617254696D656F757428746869732E';
wwv_flow_imp.g_varchar2_table(46724) := '74696D656F7574297D7D292C6A4F3D5F6B2E646566696E65287B636F6D62696E653A653D3E4F626A6563742E61737369676E287B736F75726365733A652E6D61702828653D3E652E736F7572636529292E66696C7465722828653D3E6E756C6C213D6529';
wwv_flow_imp.g_varchar2_table(46725) := '297D2C694528652E6D61702828653D3E652E636F6E66696729292C7B64656C61793A3735302C6D61726B657246696C7465723A6E756C6C2C746F6F6C74697046696C7465723A6E756C6C2C6E65656473526566726573683A6E756C6C2C686964654F6E3A';
wwv_flow_imp.g_varchar2_table(46726) := '28293D3E6E756C6C7D2C7B6E65656473526566726573683A28652C74293D3E653F743F6E3D3E65286E297C7C74286E293A653A747D29297D293B66756E6374696F6E20714F28652C743D7B7D297B72657475726E5B6A4F2E6F66287B736F757263653A65';
wwv_flow_imp.g_varchar2_table(46727) := '2C636F6E6669673A747D292C574F2C584F5D7D66756E6374696F6E20244F2865297B6C657420743D5B5D3B6966286529653A666F72286C65747B6E616D653A6E7D6F662065297B666F72286C657420653D303B653C6E2E6C656E6774683B652B2B297B6C';
wwv_flow_imp.g_varchar2_table(46728) := '657420693D6E5B655D3B6966282F5B612D7A412D5A5D2F2E74657374286929262621742E736F6D652828653D3E652E746F4C6F7765724361736528293D3D692E746F4C6F7765724361736528292929297B742E707573682869293B636F6E74696E756520';
wwv_flow_imp.g_varchar2_table(46729) := '657D7D742E70757368282222297D72657475726E20747D66756E6374696F6E20554F28652C742C6E297B76617220693B6C6574206F3D6E3F244F28742E616374696F6E73293A5B5D3B72657475726E20444F28226C69222C7B636C6173733A22636D2D64';
wwv_flow_imp.g_varchar2_table(46730) := '6961676E6F7374696320636D2D646961676E6F737469632D222B742E73657665726974797D2C444F28227370616E222C7B636C6173733A22636D2D646961676E6F7374696354657874227D2C742E72656E6465724D6573736167653F742E72656E646572';
wwv_flow_imp.g_varchar2_table(46731) := '4D6573736167652865293A742E6D657373616765292C6E756C6C3D3D3D28693D742E616374696F6E73297C7C766F696420303D3D3D693F766F696420303A692E6D61702828286E2C69293D3E7B6C657420733D21312C723D693D3E7B696628692E707265';
wwv_flow_imp.g_varchar2_table(46732) := '76656E7444656661756C7428292C732972657475726E3B733D21303B6C6574206F3D414F28652E73746174652E6669656C6428464F292E646961676E6F73746963732C74293B6F26266E2E6170706C7928652C6F2E66726F6D2C6F2E746F297D2C7B6E61';
wwv_flow_imp.g_varchar2_table(46733) := '6D653A617D3D6E2C6C3D6F5B695D3F612E696E6465784F66286F5B695D293A2D312C633D6C3C303F613A5B612E736C69636528302C6C292C444F282275222C612E736C696365286C2C6C2B3129292C612E736C696365286C2B31295D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(46734) := '444F2822627574746F6E222C7B747970653A22627574746F6E222C636C6173733A22636D2D646961676E6F73746963416374696F6E222C6F6E636C69636B3A722C6F6E6D6F757365646F776E3A722C22617269612D6C6162656C223A6020416374696F6E';
wwv_flow_imp.g_varchar2_table(46735) := '3A20247B617D247B6C3C303F22223A602028616363657373206B65792022247B6F5B695D7D2922607D2E607D2C63297D29292C742E736F757263652626444F2822646976222C7B636C6173733A22636D2D646961676E6F73746963536F75726365227D2C';
wwv_flow_imp.g_varchar2_table(46736) := '742E736F7572636529297D636C617373204B4F20657874656E647320414C7B636F6E7374727563746F722865297B737570657228292C746869732E646961676E6F737469633D657D65712865297B72657475726E20652E646961676E6F737469633D3D74';
wwv_flow_imp.g_varchar2_table(46737) := '6869732E646961676E6F737469637D746F444F4D28297B72657475726E20444F28227370616E222C7B636C6173733A22636D2D6C696E74506F696E7420636D2D6C696E74506F696E742D222B746869732E646961676E6F737469632E7365766572697479';
wwv_flow_imp.g_varchar2_table(46738) := '7D297D7D636C61737320474F7B636F6E7374727563746F7228652C74297B746869732E646961676E6F737469633D742C746869732E69643D226974656D5F222B4D6174682E666C6F6F7228343239343936373239352A4D6174682E72616E646F6D282929';
wwv_flow_imp.g_varchar2_table(46739) := '2E746F537472696E67283136292C746869732E646F6D3D554F28652C742C2130292C746869732E646F6D2E69643D746869732E69642C746869732E646F6D2E7365744174747269627574652822726F6C65222C226F7074696F6E22297D7D636C61737320';
wwv_flow_imp.g_varchar2_table(46740) := '514F7B636F6E7374727563746F722865297B746869732E766965773D652C746869732E6974656D733D5B5D2C746869732E6C6973743D444F2822756C222C7B746162496E6465783A302C726F6C653A226C697374626F78222C22617269612D6C6162656C';
wwv_flow_imp.g_varchar2_table(46741) := '223A746869732E766965772E73746174652E7068726173652822446961676E6F737469637322292C6F6E6B6579646F776E3A743D3E7B69662832373D3D742E6B6579436F646529484F28746869732E76696577292C746869732E766965772E666F637573';
wwv_flow_imp.g_varchar2_table(46742) := '28293B656C73652069662833383D3D742E6B6579436F64657C7C33333D3D742E6B6579436F646529746869732E6D6F766553656C656374696F6E2828746869732E73656C6563746564496E6465782D312B746869732E6974656D732E6C656E6774682925';
wwv_flow_imp.g_varchar2_table(46743) := '746869732E6974656D732E6C656E677468293B656C73652069662834303D3D742E6B6579436F64657C7C33343D3D742E6B6579436F646529746869732E6D6F766553656C656374696F6E2828746869732E73656C6563746564496E6465782B3129257468';
wwv_flow_imp.g_varchar2_table(46744) := '69732E6974656D732E6C656E677468293B656C73652069662833363D3D742E6B6579436F646529746869732E6D6F766553656C656374696F6E2830293B656C73652069662833353D3D742E6B6579436F646529746869732E6D6F766553656C656374696F';
wwv_flow_imp.g_varchar2_table(46745) := '6E28746869732E6974656D732E6C656E6774682D31293B656C73652069662831333D3D742E6B6579436F646529746869732E766965772E666F63757328293B656C73657B6966282128742E6B6579436F64653E3D36352626742E6B6579436F64653C3D39';
wwv_flow_imp.g_varchar2_table(46746) := '302626746869732E73656C6563746564496E6465783E3D30292972657475726E3B7B6C65747B646961676E6F737469633A6E7D3D746869732E6974656D735B746869732E73656C6563746564496E6465785D2C693D244F286E2E616374696F6E73293B66';
wwv_flow_imp.g_varchar2_table(46747) := '6F72286C6574206F3D303B6F3C692E6C656E6774683B6F2B2B29696628695B6F5D2E746F55707065724361736528292E63686172436F646541742830293D3D742E6B6579436F6465297B6C657420743D414F28746869732E766965772E73746174652E66';
wwv_flow_imp.g_varchar2_table(46748) := '69656C6428464F292E646961676E6F73746963732C6E293B7426266E2E616374696F6E735B6F5D2E6170706C7928652C742E66726F6D2C742E746F297D7D7D742E70726576656E7444656661756C7428297D2C6F6E636C69636B3A653D3E7B666F72286C';
wwv_flow_imp.g_varchar2_table(46749) := '657420743D303B743C746869732E6974656D732E6C656E6774683B742B2B29746869732E6974656D735B745D2E646F6D2E636F6E7461696E7328652E746172676574292626746869732E6D6F766553656C656374696F6E2874297D7D292C746869732E64';
wwv_flow_imp.g_varchar2_table(46750) := '6F6D3D444F2822646976222C7B636C6173733A22636D2D70616E656C2D6C696E74227D2C746869732E6C6973742C444F2822627574746F6E222C7B747970653A22627574746F6E222C6E616D653A22636C6F7365222C22617269612D6C6162656C223A74';
wwv_flow_imp.g_varchar2_table(46751) := '6869732E766965772E73746174652E7068726173652822636C6F736522292C6F6E636C69636B3A28293D3E484F28746869732E76696577297D2C22C3972229292C746869732E75706461746528297D6765742073656C6563746564496E64657828297B6C';
wwv_flow_imp.g_varchar2_table(46752) := '657420653D746869732E766965772E73746174652E6669656C6428464F292E73656C65637465643B69662821652972657475726E2D313B666F72286C657420743D303B743C746869732E6974656D732E6C656E6774683B742B2B29696628746869732E69';
wwv_flow_imp.g_varchar2_table(46753) := '74656D735B745D2E646961676E6F737469633D3D652E646961676E6F737469632972657475726E20743B72657475726E2D317D75706461746528297B6C65747B646961676E6F73746963733A652C73656C65637465643A747D3D746869732E766965772E';
wwv_flow_imp.g_varchar2_table(46754) := '73746174652E6669656C6428464F292C6E3D302C693D21312C6F3D6E756C6C3B666F7228652E6265747765656E28302C746869732E766965772E73746174652E646F632E6C656E6774682C2828652C732C7B737065633A727D293D3E7B6C657420612C6C';
wwv_flow_imp.g_varchar2_table(46755) := '3D2D313B666F72286C657420653D6E3B653C746869732E6974656D732E6C656E6774683B652B2B29696628746869732E6974656D735B655D2E646961676E6F737469633D3D722E646961676E6F73746963297B6C3D653B627265616B7D6C3C303F28613D';
wwv_flow_imp.g_varchar2_table(46756) := '6E657720474F28746869732E766965772C722E646961676E6F73746963292C746869732E6974656D732E73706C696365286E2C302C61292C693D2130293A28613D746869732E6974656D735B6C5D2C6C3E6E262628746869732E6974656D732E73706C69';
wwv_flow_imp.g_varchar2_table(46757) := '6365286E2C6C2D6E292C693D213029292C742626612E646961676E6F737469633D3D742E646961676E6F737469633F612E646F6D2E6861734174747269627574652822617269612D73656C656374656422297C7C28612E646F6D2E736574417474726962';
wwv_flow_imp.g_varchar2_table(46758) := '7574652822617269612D73656C6563746564222C227472756522292C6F3D61293A612E646F6D2E6861734174747269627574652822617269612D73656C656374656422292626612E646F6D2E72656D6F76654174747269627574652822617269612D7365';
wwv_flow_imp.g_varchar2_table(46759) := '6C656374656422292C6E2B2B7D29293B6E3C746869732E6974656D732E6C656E67746826262128313D3D746869732E6974656D732E6C656E6774682626746869732E6974656D735B305D2E646961676E6F737469632E66726F6D3C30293B29693D21302C';
wwv_flow_imp.g_varchar2_table(46760) := '746869732E6974656D732E706F7028293B303D3D746869732E6974656D732E6C656E677468262628746869732E6974656D732E70757368286E657720474F28746869732E766965772C7B66726F6D3A2D312C746F3A2D312C73657665726974793A22696E';
wwv_flow_imp.g_varchar2_table(46761) := '666F222C6D6573736167653A746869732E766965772E73746174652E70687261736528224E6F20646961676E6F737469637322297D29292C693D2130292C6F3F28746869732E6C6973742E7365744174747269627574652822617269612D616374697665';
wwv_flow_imp.g_varchar2_table(46762) := '64657363656E64616E74222C6F2E6964292C746869732E766965772E726571756573744D656173757265287B6B65793A746869732C726561643A28293D3E287B73656C3A6F2E646F6D2E676574426F756E64696E67436C69656E745265637428292C7061';
wwv_flow_imp.g_varchar2_table(46763) := '6E656C3A746869732E6C6973742E676574426F756E64696E67436C69656E745265637428297D292C77726974653A287B73656C3A652C70616E656C3A747D293D3E7B6C6574206E3D742E6865696768742F746869732E6C6973742E6F6666736574486569';
wwv_flow_imp.g_varchar2_table(46764) := '6768743B652E746F703C742E746F703F746869732E6C6973742E7363726F6C6C546F702D3D28742E746F702D652E746F70292F6E3A652E626F74746F6D3E742E626F74746F6D262628746869732E6C6973742E7363726F6C6C546F702B3D28652E626F74';
wwv_flow_imp.g_varchar2_table(46765) := '746F6D2D742E626F74746F6D292F6E297D7D29293A746869732E73656C6563746564496E6465783C302626746869732E6C6973742E72656D6F76654174747269627574652822617269612D61637469766564657363656E64616E7422292C692626746869';
wwv_flow_imp.g_varchar2_table(46766) := '732E73796E6328297D73796E6328297B6C657420653D746869732E6C6973742E66697273744368696C643B66756E6374696F6E207428297B6C657420743D653B653D742E6E6578745369626C696E672C742E72656D6F766528297D666F72286C6574206E';
wwv_flow_imp.g_varchar2_table(46767) := '206F6620746869732E6974656D73296966286E2E646F6D2E706172656E744E6F64653D3D746869732E6C697374297B666F72283B65213D6E2E646F6D3B297428293B653D6E2E646F6D2E6E6578745369626C696E677D656C736520746869732E6C697374';
wwv_flow_imp.g_varchar2_table(46768) := '2E696E736572744265666F7265286E2E646F6D2C65293B666F72283B653B297428297D6D6F766553656C656374696F6E2865297B696628746869732E73656C6563746564496E6465783C302972657475726E3B6C657420743D414F28746869732E766965';
wwv_flow_imp.g_varchar2_table(46769) := '772E73746174652E6669656C6428464F292E646961676E6F73746963732C746869732E6974656D735B655D2E646961676E6F73746963293B742626746869732E766965772E6469737061746368287B73656C656374696F6E3A7B616E63686F723A742E66';
wwv_flow_imp.g_varchar2_table(46770) := '726F6D2C686561643A742E746F7D2C7363726F6C6C496E746F566965773A21302C656666656374733A524F2E6F662874297D297D737461746963206F70656E2865297B72657475726E206E657720514F2865297D7D66756E6374696F6E20594F2865297B';
wwv_flow_imp.g_varchar2_table(46771) := '72657475726E2066756E6374696F6E28652C743D2776696577426F783D223020302034302034302227297B72657475726E6075726C2827646174613A696D6167652F7376672B786D6C2C3C73766720786D6C6E733D22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(46772) := '6F72672F323030302F7376672220247B747D3E247B656E636F6465555249436F6D706F6E656E742865297D3C2F7376673E2729607D28603C7061746820643D226D3020322E35206C32202D312E35206C312030206C3220312E35206C3120302220737472';
wwv_flow_imp.g_varchar2_table(46773) := '6F6B653D22247B657D222066696C6C3D226E6F6E6522207374726F6B652D77696474683D222E37222F3E602C2777696474683D223622206865696768743D22332227297D636F6E7374205A4F3D44492E626173655468656D65287B222E636D2D64696167';
wwv_flow_imp.g_varchar2_table(46774) := '6E6F73746963223A7B70616464696E673A22337078203670782033707820387078222C6D617267696E4C6566743A222D317078222C646973706C61793A22626C6F636B222C776869746553706163653A227072652D77726170227D2C222E636D2D646961';
wwv_flow_imp.g_varchar2_table(46775) := '676E6F737469632D6572726F72223A7B626F726465724C6566743A2235707820736F6C69642023643131227D2C222E636D2D646961676E6F737469632D7761726E696E67223A7B626F726465724C6566743A2235707820736F6C6964206F72616E676522';
wwv_flow_imp.g_varchar2_table(46776) := '7D2C222E636D2D646961676E6F737469632D696E666F223A7B626F726465724C6566743A2235707820736F6C69642023393939227D2C222E636D2D646961676E6F737469632D68696E74223A7B626F726465724C6566743A2235707820736F6C69642023';
wwv_flow_imp.g_varchar2_table(46777) := '363664227D2C222E636D2D646961676E6F73746963416374696F6E223A7B666F6E743A22696E6865726974222C626F726465723A226E6F6E65222C70616464696E673A2232707820347078222C6261636B67726F756E64436F6C6F723A2223343434222C';
wwv_flow_imp.g_varchar2_table(46778) := '636F6C6F723A227768697465222C626F726465725261646975733A22337078222C6D617267696E4C6566743A22387078222C637572736F723A22706F696E746572227D2C222E636D2D646961676E6F73746963536F75726365223A7B666F6E7453697A65';
wwv_flow_imp.g_varchar2_table(46779) := '3A22373025222C6F7061636974793A2E377D2C222E636D2D6C696E7452616E6765223A7B6261636B67726F756E64506F736974696F6E3A226C65667420626F74746F6D222C6261636B67726F756E645265706561743A227265706561742D78222C706164';
wwv_flow_imp.g_varchar2_table(46780) := '64696E67426F74746F6D3A22302E377078227D2C222E636D2D6C696E7452616E67652D6572726F72223A7B6261636B67726F756E64496D6167653A594F28222364313122297D2C222E636D2D6C696E7452616E67652D7761726E696E67223A7B6261636B';
wwv_flow_imp.g_varchar2_table(46781) := '67726F756E64496D6167653A594F28226F72616E676522297D2C222E636D2D6C696E7452616E67652D696E666F223A7B6261636B67726F756E64496D6167653A594F28222339393922297D2C222E636D2D6C696E7452616E67652D68696E74223A7B6261';
wwv_flow_imp.g_varchar2_table(46782) := '636B67726F756E64496D6167653A594F28222336366422297D2C222E636D2D6C696E7452616E67652D616374697665223A7B6261636B67726F756E64436F6C6F723A22236666646439393830227D2C222E636D2D746F6F6C7469702D6C696E74223A7B70';
wwv_flow_imp.g_varchar2_table(46783) := '616464696E673A302C6D617267696E3A307D2C222E636D2D6C696E74506F696E74223A7B706F736974696F6E3A2272656C6174697665222C22263A6166746572223A7B636F6E74656E743A272222272C706F736974696F6E3A226162736F6C757465222C';
wwv_flow_imp.g_varchar2_table(46784) := '626F74746F6D3A302C6C6566743A222D327078222C626F726465724C6566743A2233707820736F6C6964207472616E73706172656E74222C626F7264657252696768743A2233707820736F6C6964207472616E73706172656E74222C626F72646572426F';
wwv_flow_imp.g_varchar2_table(46785) := '74746F6D3A2234707820736F6C69642023643131227D7D2C222E636D2D6C696E74506F696E742D7761726E696E67223A7B22263A6166746572223A7B626F72646572426F74746F6D436F6C6F723A226F72616E6765227D7D2C222E636D2D6C696E74506F';
wwv_flow_imp.g_varchar2_table(46786) := '696E742D696E666F223A7B22263A6166746572223A7B626F72646572426F74746F6D436F6C6F723A2223393939227D7D2C222E636D2D6C696E74506F696E742D68696E74223A7B22263A6166746572223A7B626F72646572426F74746F6D436F6C6F723A';
wwv_flow_imp.g_varchar2_table(46787) := '2223363664227D7D2C222E636D2D70616E656C2E636D2D70616E656C2D6C696E74223A7B706F736974696F6E3A2272656C6174697665222C222620756C223A7B6D61784865696768743A223130307078222C6F766572666C6F77593A226175746F222C22';
wwv_flow_imp.g_varchar2_table(46788) := '26205B617269612D73656C65637465645D223A7B6261636B67726F756E64436F6C6F723A2223646464222C22262075223A7B746578744465636F726174696F6E3A22756E6465726C696E65227D7D2C22263A666F637573205B617269612D73656C656374';
wwv_flow_imp.g_varchar2_table(46789) := '65645D223A7B6261636B67726F756E645F66616C6C6261636B3A2223626466222C6261636B67726F756E64436F6C6F723A22486967686C69676874222C636F6C6F725F66616C6C6261636B3A227768697465222C636F6C6F723A22486967686C69676874';
wwv_flow_imp.g_varchar2_table(46790) := '54657874227D2C22262075223A7B746578744465636F726174696F6E3A226E6F6E65227D2C70616464696E673A302C6D617267696E3A307D2C2226205B6E616D653D636C6F73655D223A7B706F736974696F6E3A226162736F6C757465222C746F703A22';
wwv_flow_imp.g_varchar2_table(46791) := '30222C72696768743A22327078222C6261636B67726F756E643A22696E6865726974222C626F726465723A226E6F6E65222C666F6E743A22696E6865726974222C70616464696E673A302C6D617267696E3A307D7D7D292C584F3D5B464F2C44492E6465';
wwv_flow_imp.g_varchar2_table(46792) := '636F726174696F6E732E636F6D70757465285B464F5D2C28653D3E7B6C65747B73656C65637465643A742C70616E656C3A6E7D3D652E6669656C6428464F293B72657475726E207426266E2626742E66726F6D213D742E746F3F504C2E736574285B424F';
wwv_flow_imp.g_varchar2_table(46793) := '2E72616E676528742E66726F6D2C742E746F295D293A504C2E6E6F6E657D29292C734D28564F2C7B686964654F6E3A66756E6374696F6E28652C74297B6C6574206E3D742E706F732C693D742E656E647C7C6E2C6F3D652E73746174652E666163657428';
wwv_flow_imp.g_varchar2_table(46794) := '6A4F292E686964654F6E28652C6E2C69293B6966286E756C6C213D6F2972657475726E206F3B6C657420733D652E737461727453746174652E646F632E6C696E65417428742E706F73293B72657475726E212821652E656666656374732E736F6D652828';
wwv_flow_imp.g_varchar2_table(46795) := '653D3E652E697328504F292929262621652E6368616E6765732E746F756368657352616E676528732E66726F6D2C4D6174682E6D617828732E746F2C692929297D7D292C5A4F5D3B636C617373204A4F7B7374617469632063726561746528652C742C6E';
wwv_flow_imp.g_varchar2_table(46796) := '2C692C6F297B72657475726E206E6577204A4F28652C742C6E2C692B28693C3C38292B652B28743C3C34297C302C6F2C5B5D2C5B5D297D636F6E7374727563746F7228652C742C6E2C692C6F2C732C72297B746869732E747970653D652C746869732E76';
wwv_flow_imp.g_varchar2_table(46797) := '616C75653D742C746869732E66726F6D3D6E2C746869732E686173683D692C746869732E656E643D6F2C746869732E6368696C6472656E3D732C746869732E706F736974696F6E733D722C746869732E6861736850726F703D5B5B58432E636F6E746578';
wwv_flow_imp.g_varchar2_table(46798) := '74486173682C695D5D7D6164644368696C6428652C74297B652E70726F702858432E636F6E746578744861736829213D746869732E68617368262628653D6E657720725328652E747970652C652E6368696C6472656E2C652E706F736974696F6E732C65';
wwv_flow_imp.g_varchar2_table(46799) := '2E6C656E6774682C746869732E6861736850726F7029292C746869732E6368696C6472656E2E707573682865292C746869732E706F736974696F6E732E707573682874297D746F5472656528652C743D746869732E656E64297B6C6574206E3D74686973';
wwv_flow_imp.g_varchar2_table(46800) := '2E6368696C6472656E2E6C656E6774682D313B72657475726E206E3E3D30262628743D4D6174682E6D617828742C746869732E706F736974696F6E735B6E5D2B746869732E6368696C6472656E5B6E5D2E6C656E6774682B746869732E66726F6D29292C';
wwv_flow_imp.g_varchar2_table(46801) := '6E657720725328652E74797065735B746869732E747970655D2C746869732E6368696C6472656E2C746869732E706F736974696F6E732C742D746869732E66726F6D292E62616C616E6365287B6D616B65547265653A28652C742C6E293D3E6E65772072';
wwv_flow_imp.g_varchar2_table(46802) := '532874532E6E6F6E652C652C742C6E2C746869732E6861736850726F70297D297D7D7661722065523B2166756E6374696F6E2865297B655B652E446F63756D656E743D315D3D22446F63756D656E74222C655B652E436F6465426C6F636B3D325D3D2243';
wwv_flow_imp.g_varchar2_table(46803) := '6F6465426C6F636B222C655B652E46656E636564436F64653D335D3D2246656E636564436F6465222C655B652E426C6F636B71756F74653D345D3D22426C6F636B71756F7465222C655B652E486F72697A6F6E74616C52756C653D355D3D22486F72697A';
wwv_flow_imp.g_varchar2_table(46804) := '6F6E74616C52756C65222C655B652E42756C6C65744C6973743D365D3D2242756C6C65744C697374222C655B652E4F7264657265644C6973743D375D3D224F7264657265644C697374222C655B652E4C6973744974656D3D385D3D224C6973744974656D';
wwv_flow_imp.g_varchar2_table(46805) := '222C655B652E41545848656164696E67313D395D3D2241545848656164696E6731222C655B652E41545848656164696E67323D31305D3D2241545848656164696E6732222C655B652E41545848656164696E67333D31315D3D2241545848656164696E67';
wwv_flow_imp.g_varchar2_table(46806) := '33222C655B652E41545848656164696E67343D31325D3D2241545848656164696E6734222C655B652E41545848656164696E67353D31335D3D2241545848656164696E6735222C655B652E41545848656164696E67363D31345D3D224154584865616469';
wwv_flow_imp.g_varchar2_table(46807) := '6E6736222C655B652E53657465787448656164696E67313D31355D3D2253657465787448656164696E6731222C655B652E53657465787448656164696E67323D31365D3D2253657465787448656164696E6732222C655B652E48544D4C426C6F636B3D31';
wwv_flow_imp.g_varchar2_table(46808) := '375D3D2248544D4C426C6F636B222C655B652E4C696E6B5265666572656E63653D31385D3D224C696E6B5265666572656E6365222C655B652E5061726167726170683D31395D3D22506172616772617068222C655B652E436F6D6D656E74426C6F636B3D';
wwv_flow_imp.g_varchar2_table(46809) := '32305D3D22436F6D6D656E74426C6F636B222C655B652E50726F63657373696E67496E737472756374696F6E426C6F636B3D32315D3D2250726F63657373696E67496E737472756374696F6E426C6F636B222C655B652E4573636170653D32325D3D2245';
wwv_flow_imp.g_varchar2_table(46810) := '7363617065222C655B652E456E746974793D32335D3D22456E74697479222C655B652E48617264427265616B3D32345D3D2248617264427265616B222C655B652E456D7068617369733D32355D3D22456D706861736973222C655B652E5374726F6E6745';
wwv_flow_imp.g_varchar2_table(46811) := '6D7068617369733D32365D3D225374726F6E67456D706861736973222C655B652E4C696E6B3D32375D3D224C696E6B222C655B652E496D6167653D32385D3D22496D616765222C655B652E496E6C696E65436F64653D32395D3D22496E6C696E65436F64';
wwv_flow_imp.g_varchar2_table(46812) := '65222C655B652E48544D4C5461673D33305D3D2248544D4C546167222C655B652E436F6D6D656E743D33315D3D22436F6D6D656E74222C655B652E50726F63657373696E67496E737472756374696F6E3D33325D3D2250726F63657373696E67496E7374';
wwv_flow_imp.g_varchar2_table(46813) := '72756374696F6E222C655B652E4175746F6C696E6B3D33335D3D224175746F6C696E6B222C655B652E4865616465724D61726B3D33345D3D224865616465724D61726B222C655B652E51756F74654D61726B3D33355D3D2251756F74654D61726B222C65';
wwv_flow_imp.g_varchar2_table(46814) := '5B652E4C6973744D61726B3D33365D3D224C6973744D61726B222C655B652E4C696E6B4D61726B3D33375D3D224C696E6B4D61726B222C655B652E456D7068617369734D61726B3D33385D3D22456D7068617369734D61726B222C655B652E436F64654D';
wwv_flow_imp.g_varchar2_table(46815) := '61726B3D33395D3D22436F64654D61726B222C655B652E436F6465546578743D34305D3D22436F646554657874222C655B652E436F6465496E666F3D34315D3D22436F6465496E666F222C655B652E4C696E6B5469746C653D34325D3D224C696E6B5469';
wwv_flow_imp.g_varchar2_table(46816) := '746C65222C655B652E4C696E6B4C6162656C3D34335D3D224C696E6B4C6162656C222C655B652E55524C3D34345D3D2255524C227D2865527C7C2865523D7B7D29293B636C6173732074527B636F6E7374727563746F7228652C74297B746869732E7374';
wwv_flow_imp.g_varchar2_table(46817) := '6172743D652C746869732E636F6E74656E743D742C746869732E6D61726B733D5B5D2C746869732E706172736572733D5B5D7D7D636C617373206E527B636F6E7374727563746F7228297B746869732E746578743D22222C746869732E62617365496E64';
wwv_flow_imp.g_varchar2_table(46818) := '656E743D302C746869732E62617365506F733D302C746869732E64657074683D302C746869732E6D61726B6572733D5B5D2C746869732E706F733D302C746869732E696E64656E743D302C746869732E6E6578743D2D317D666F727761726428297B7468';
wwv_flow_imp.g_varchar2_table(46819) := '69732E62617365506F733E746869732E706F732626746869732E666F7277617264496E6E657228297D666F7277617264496E6E657228297B6C657420653D746869732E736B6970537061636528746869732E62617365506F73293B746869732E696E6465';
wwv_flow_imp.g_varchar2_table(46820) := '6E743D746869732E636F756E74496E64656E7428652C746869732E706F732C746869732E696E64656E74292C746869732E706F733D652C746869732E6E6578743D653D3D746869732E746578742E6C656E6774683F2D313A746869732E746578742E6368';
wwv_flow_imp.g_varchar2_table(46821) := '6172436F646541742865297D736B697053706163652865297B72657475726E20725228746869732E746578742C65297D72657365742865297B666F7228746869732E746578743D652C746869732E62617365496E64656E743D746869732E62617365506F';
wwv_flow_imp.g_varchar2_table(46822) := '733D746869732E706F733D746869732E696E64656E743D302C746869732E666F7277617264496E6E657228292C746869732E64657074683D313B746869732E6D61726B6572732E6C656E6774683B29746869732E6D61726B6572732E706F7028297D6D6F';
wwv_flow_imp.g_varchar2_table(46823) := '7665426173652865297B746869732E62617365506F733D652C746869732E62617365496E64656E743D746869732E636F756E74496E64656E7428652C746869732E706F732C746869732E696E64656E74297D6D6F766542617365436F6C756D6E2865297B';
wwv_flow_imp.g_varchar2_table(46824) := '746869732E62617365496E64656E743D652C746869732E62617365506F733D746869732E66696E64436F6C756D6E2865297D6164644D61726B65722865297B746869732E6D61726B6572732E707573682865297D636F756E74496E64656E7428652C743D';
wwv_flow_imp.g_varchar2_table(46825) := '302C6E3D30297B666F72286C657420693D743B693C653B692B2B296E2B3D393D3D746869732E746578742E63686172436F646541742869293F342D6E25343A313B72657475726E206E7D66696E64436F6C756D6E2865297B6C657420743D303B666F7228';
wwv_flow_imp.g_varchar2_table(46826) := '6C6574206E3D303B743C746869732E746578742E6C656E67746826266E3C653B742B2B296E2B3D393D3D746869732E746578742E63686172436F646541742874293F342D6E25343A313B72657475726E20747D736372756228297B69662821746869732E';
wwv_flow_imp.g_varchar2_table(46827) := '62617365496E64656E742972657475726E20746869732E746578743B6C657420653D22223B666F72286C657420743D303B743C746869732E62617365506F733B742B2B29652B3D2220223B72657475726E20652B746869732E746578742E736C69636528';
wwv_flow_imp.g_varchar2_table(46828) := '746869732E62617365506F73297D7D66756E6374696F6E20695228652C742C6E297B6966286E2E706F733D3D6E2E746578742E6C656E6774687C7C65213D742E626C6F636B26266E2E696E64656E743E3D742E737461636B5B6E2E64657074682B315D2E';
wwv_flow_imp.g_varchar2_table(46829) := '76616C75652B6E2E62617365496E64656E742972657475726E21303B6966286E2E696E64656E743E3D6E2E62617365496E64656E742B342972657475726E21313B6C657420693D28652E747970653D3D65522E4F7264657265644C6973743F70523A7552';
wwv_flow_imp.g_varchar2_table(46830) := '29286E2C742C2131293B72657475726E20693E30262628652E74797065213D65522E42756C6C65744C6973747C7C6452286E2C742C2131293C302926266E2E746578742E63686172436F64654174286E2E706F732B692D31293D3D652E76616C75657D63';
wwv_flow_imp.g_varchar2_table(46831) := '6F6E7374206F523D7B5B65522E426C6F636B71756F74655D3A28652C742C6E293D3E36323D3D6E2E6E6578742626286E2E6D61726B6572732E707573682848522865522E51756F74654D61726B2C742E6C696E6553746172742B6E2E706F732C742E6C69';
wwv_flow_imp.g_varchar2_table(46832) := '6E6553746172742B6E2E706F732B3129292C6E2E6D6F766542617365286E2E706F732B287352286E2E746578742E63686172436F64654174286E2E706F732B3129293F323A3129292C652E656E643D742E6C696E6553746172742B6E2E746578742E6C65';
wwv_flow_imp.g_varchar2_table(46833) := '6E6774682C2130292C5B65522E4C6973744974656D5D3A28652C742C6E293D3E21286E2E696E64656E743C6E2E62617365496E64656E742B652E76616C756526266E2E6E6578743E2D317C7C286E2E6D6F766542617365436F6C756D6E286E2E62617365';
wwv_flow_imp.g_varchar2_table(46834) := '496E64656E742B652E76616C7565292C3029292C5B65522E4F7264657265644C6973745D3A69522C5B65522E42756C6C65744C6973745D3A69522C5B65522E446F63756D656E745D3A28293D3E21307D3B66756E6374696F6E2073522865297B72657475';
wwv_flow_imp.g_varchar2_table(46835) := '726E2033323D3D657C7C393D3D657C7C31303D3D657C7C31333D3D657D66756E6374696F6E20725228652C743D30297B666F72283B743C652E6C656E6774682626735228652E63686172436F64654174287429293B29742B2B3B72657475726E20747D66';
wwv_flow_imp.g_varchar2_table(46836) := '756E6374696F6E20615228652C742C6E297B666F72283B743E6E2626735228652E63686172436F6465417428742D3129293B29742D2D3B72657475726E20747D66756E6374696F6E206C522865297B6966283936213D652E6E6578742626313236213D65';
wwv_flow_imp.g_varchar2_table(46837) := '2E6E6578742972657475726E2D313B6C657420743D652E706F732B313B666F72283B743C652E746578742E6C656E6774682626652E746578742E63686172436F646541742874293D3D652E6E6578743B29742B2B3B696628743C652E706F732B33297265';
wwv_flow_imp.g_varchar2_table(46838) := '7475726E2D313B69662839363D3D652E6E65787429666F72286C6574206E3D743B6E3C652E746578742E6C656E6774683B6E2B2B2969662839363D3D652E746578742E63686172436F64654174286E292972657475726E2D313B72657475726E20747D66';
wwv_flow_imp.g_varchar2_table(46839) := '756E6374696F6E2063522865297B72657475726E203632213D652E6E6578743F2D313A33323D3D652E746578742E63686172436F6465417428652E706F732B31293F323A317D66756E6374696F6E20645228652C742C6E297B6966283432213D652E6E65';
wwv_flow_imp.g_varchar2_table(46840) := '787426263435213D652E6E65787426263935213D652E6E6578742972657475726E2D313B6C657420693D313B666F72286C657420743D652E706F732B313B743C652E746578742E6C656E6774683B742B2B297B6C6574206E3D652E746578742E63686172';
wwv_flow_imp.g_varchar2_table(46841) := '436F646541742874293B6966286E3D3D652E6E65787429692B2B3B656C736520696628217352286E292972657475726E2D317D72657475726E206E262634353D3D652E6E65787426266D522865293E2D312626652E64657074683D3D742E737461636B2E';
wwv_flow_imp.g_varchar2_table(46842) := '6C656E6774682626742E7061727365722E6C656166426C6F636B506172736572732E696E6465784F66284C522E53657465787448656164696E67293E2D317C7C693C333F2D313A317D66756E6374696F6E20685228652C74297B666F72286C6574206E3D';
wwv_flow_imp.g_varchar2_table(46843) := '652E737461636B2E6C656E6774682D313B6E3E3D303B6E2D2D29696628652E737461636B5B6E5D2E747970653D3D742972657475726E21303B72657475726E21317D66756E6374696F6E20755228652C742C6E297B72657475726E203435213D652E6E65';
wwv_flow_imp.g_varchar2_table(46844) := '787426263433213D652E6E65787426263432213D652E6E6578747C7C652E706F73213D652E746578742E6C656E6774682D31262621735228652E746578742E63686172436F6465417428652E706F732B3129297C7C2128216E7C7C685228742C65522E42';
wwv_flow_imp.g_varchar2_table(46845) := '756C6C65744C697374297C7C652E736B6970537061636528652E706F732B32293C652E746578742E6C656E677468293F2D313A317D66756E6374696F6E20705228652C742C6E297B6C657420693D652E706F732C6F3D652E6E6578743B666F72283B6F3E';
wwv_flow_imp.g_varchar2_table(46846) := '3D343826266F3C3D35373B297B696628692B2B2C693D3D652E746578742E6C656E6774682972657475726E2D313B6F3D652E746578742E63686172436F646541742869297D72657475726E20693D3D652E706F737C7C693E652E706F732B397C7C343621';
wwv_flow_imp.g_varchar2_table(46847) := '3D6F26263431213D6F7C7C693C652E746578742E6C656E6774682D31262621735228652E746578742E63686172436F6465417428692B3129297C7C6E262621685228742C65522E4F7264657265644C69737429262628652E736B6970537061636528692B';
wwv_flow_imp.g_varchar2_table(46848) := '31293D3D652E746578742E6C656E6774687C7C693E652E706F732B317C7C3439213D652E6E657874293F2D313A692B312D652E706F737D66756E6374696F6E2067522865297B6966283335213D652E6E6578742972657475726E2D313B6C657420743D65';
wwv_flow_imp.g_varchar2_table(46849) := '2E706F732B313B666F72283B743C652E746578742E6C656E677468262633353D3D652E746578742E63686172436F646541742874293B29742B2B3B696628743C652E746578742E6C656E67746826263332213D652E746578742E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(46850) := '2874292972657475726E2D313B6C6574206E3D742D652E706F733B72657475726E206E3E363F2D313A6E7D66756E6374696F6E206D522865297B6966283435213D652E6E65787426263631213D652E6E6578747C7C652E696E64656E743E3D652E626173';
wwv_flow_imp.g_varchar2_table(46851) := '65496E64656E742B342972657475726E2D313B6C657420743D652E706F732B313B666F72283B743C652E746578742E6C656E6774682626652E746578742E63686172436F646541742874293D3D652E6E6578743B29742B2B3B6C6574206E3D743B666F72';
wwv_flow_imp.g_varchar2_table(46852) := '283B743C652E746578742E6C656E6774682626735228652E746578742E63686172436F64654174287429293B29742B2B3B72657475726E20743D3D652E746578742E6C656E6774683F6E3A2D317D636F6E73742066523D2F5E5B205C745D2A242F2C7652';
wwv_flow_imp.g_varchar2_table(46853) := '3D2F2D2D3E2F2C62523D2F5C3F3E2F2C5F523D5B5B2F5E3C283F3A7363726970747C7072657C7374796C6529283F3A5C737C3E7C24292F692C2F3C5C2F283F3A7363726970747C7072657C7374796C65293E2F695D2C5B2F5E5C732A3C212D2D2F2C7652';
wwv_flow_imp.g_varchar2_table(46854) := '5D2C5B2F5E5C732A3C5C3F2F2C62525D2C5B2F5E5C732A3C215B412D5A5D2F2C2F3E2F5D2C5B2F5E5C732A3C215C5B43444154415C5B2F2C2F5C5D5C5D3E2F5D2C5B2F5E5C732A3C5C2F3F283F3A616464726573737C61727469636C657C61736964657C';
wwv_flow_imp.g_varchar2_table(46855) := '626173657C62617365666F6E747C626C6F636B71756F74657C626F64797C63617074696F6E7C63656E7465727C636F6C7C636F6C67726F75707C64647C64657461696C737C6469616C6F677C6469727C6469767C646C7C64747C6669656C647365747C66';
wwv_flow_imp.g_varchar2_table(46856) := '696763617074696F6E7C6669677572657C666F6F7465727C666F726D7C6672616D657C6672616D657365747C68317C68327C68337C68347C68357C68367C686561647C6865616465727C68727C68746D6C7C696672616D657C6C6567656E647C6C697C6C';
wwv_flow_imp.g_varchar2_table(46857) := '696E6B7C6D61696E7C6D656E757C6D656E756974656D7C6E61767C6E6F6672616D65737C6F6C7C6F707467726F75707C6F7074696F6E7C707C706172616D7C73656374696F6E7C736F757263657C73756D6D6172797C7461626C657C74626F64797C7464';
wwv_flow_imp.g_varchar2_table(46858) := '7C74666F6F747C74687C74686561647C7469746C657C74727C747261636B7C756C29283F3A5C737C5C2F3F3E7C24292F692C66525D2C5B2F5E5C732A283F3A3C5C2F5B612D7A5D5B5C772D5D2A5C732A3E7C3C5B612D7A5D5B5C772D5D2A285C732B5B61';
wwv_flow_imp.g_varchar2_table(46859) := '2D7A3A5F5D5B5C772D2E5D2A283F3A5C732A3D5C732A283F3A5B5E5C7322273D3C3E605D2B7C275B5E275D2A277C225B5E225D2A2229293F292A5C732A3E295C732A242F692C66525D5D3B66756E6374696F6E20795228652C742C6E297B696628363021';
wwv_flow_imp.g_varchar2_table(46860) := '3D652E6E6578742972657475726E2D313B6C657420693D652E746578742E736C69636528652E706F73293B666F72286C657420653D302C743D5F522E6C656E6774682D286E3F313A30293B653C743B652B2B296966285F525B655D5B305D2E7465737428';
wwv_flow_imp.g_varchar2_table(46861) := '69292972657475726E20653B72657475726E2D317D66756E6374696F6E20775228652C74297B6C6574206E3D652E636F756E74496E64656E7428742C652E706F732C652E696E64656E74292C693D652E636F756E74496E64656E7428652E736B69705370';
wwv_flow_imp.g_varchar2_table(46862) := '6163652874292C742C6E293B72657475726E20693E3D6E2B353F6E2B313A697D66756E6374696F6E20435228652C742C6E297B6C657420693D652E6C656E6774682D313B693E3D302626655B695D2E746F3D3D742626655B695D2E747970653D3D65522E';
wwv_flow_imp.g_varchar2_table(46863) := '436F6465546578743F655B695D2E746F3D6E3A652E707573682848522865522E436F6465546578742C742C6E29297D636F6E73742053523D7B4C696E6B5265666572656E63653A766F696420302C496E64656E746564436F646528652C74297B6C657420';
wwv_flow_imp.g_varchar2_table(46864) := '6E3D742E62617365496E64656E742B343B696628742E696E64656E743C6E2972657475726E21313B6C657420693D742E66696E64436F6C756D6E286E292C6F3D652E6C696E6553746172742B692C733D652E6C696E6553746172742B742E746578742E6C';
wwv_flow_imp.g_varchar2_table(46865) := '656E6774682C723D5B5D2C613D5B5D3B666F7228435228722C6F2C73293B652E6E6578744C696E6528292626742E64657074683E3D652E737461636B2E6C656E6774683B29696628742E706F733D3D742E746578742E6C656E677468297B435228612C65';
wwv_flow_imp.g_varchar2_table(46866) := '2E6C696E6553746172742D312C652E6C696E655374617274293B666F72286C65742065206F6620742E6D61726B65727329612E707573682865297D656C73657B696628742E696E64656E743C6E29627265616B3B7B696628612E6C656E677468297B666F';
wwv_flow_imp.g_varchar2_table(46867) := '72286C65742065206F66206129652E747970653D3D65522E436F6465546578743F435228722C652E66726F6D2C652E746F293A722E707573682865293B613D5B5D7D435228722C652E6C696E6553746172742D312C652E6C696E655374617274293B666F';
wwv_flow_imp.g_varchar2_table(46868) := '72286C65742065206F6620742E6D61726B65727329722E707573682865293B733D652E6C696E6553746172742B742E746578742E6C656E6774683B6C6574206E3D652E6C696E6553746172742B742E66696E64436F6C756D6E28742E62617365496E6465';
wwv_flow_imp.g_varchar2_table(46869) := '6E742B34293B6E3C732626435228722C6E2C73297D7D72657475726E20612E6C656E677468262628613D612E66696C7465722828653D3E652E74797065213D65522E436F64655465787429292C612E6C656E677468262628742E6D61726B6572733D612E';
wwv_flow_imp.g_varchar2_table(46870) := '636F6E63617428742E6D61726B6572732929292C652E6164644E6F646528652E6275666665722E7772697465456C656D656E747328722C2D6F292E66696E6973682865522E436F6465426C6F636B2C732D6F292C6F292C21307D2C46656E636564436F64';
wwv_flow_imp.g_varchar2_table(46871) := '6528652C74297B6C6574206E3D6C522874293B6966286E3C302972657475726E21313B6C657420693D652E6C696E6553746172742B742E706F732C6F3D742E6E6578742C733D6E2D742E706F732C723D742E736B69705370616365286E292C613D615228';
wwv_flow_imp.g_varchar2_table(46872) := '742E746578742C742E746578742E6C656E6774682C72292C6C3D5B48522865522E436F64654D61726B2C692C692B73295D3B723C6126266C2E707573682848522865522E436F6465496E666F2C652E6C696E6553746172742B722C652E6C696E65537461';
wwv_flow_imp.g_varchar2_table(46873) := '72742B6129293B666F72286C6574206E3D21303B652E6E6578744C696E6528292626742E64657074683E3D652E737461636B2E6C656E6774683B6E3D2131297B6C657420693D742E706F733B696628742E696E64656E742D742E62617365496E64656E74';
wwv_flow_imp.g_varchar2_table(46874) := '3C3429666F72283B693C742E746578742E6C656E6774682626742E746578742E63686172436F646541742869293D3D6F3B29692B2B3B696628692D742E706F733E3D732626742E736B697053706163652869293D3D742E746578742E6C656E677468297B';
wwv_flow_imp.g_varchar2_table(46875) := '666F72286C65742065206F6620742E6D61726B657273296C2E707573682865293B6C2E707573682848522865522E436F64654D61726B2C652E6C696E6553746172742B742E706F732C652E6C696E6553746172742B6929292C652E6E6578744C696E6528';
wwv_flow_imp.g_varchar2_table(46876) := '293B627265616B7D7B6E7C7C4352286C2C652E6C696E6553746172742D312C652E6C696E655374617274293B666F72286C65742065206F6620742E6D61726B657273296C2E707573682865293B6C657420693D652E6C696E6553746172742B742E626173';
wwv_flow_imp.g_varchar2_table(46877) := '65506F732C6F3D652E6C696E6553746172742B742E746578742E6C656E6774683B693C6F26264352286C2C692C6F297D7D72657475726E20652E6164644E6F646528652E6275666665722E7772697465456C656D656E7473286C2C2D69292E66696E6973';
wwv_flow_imp.g_varchar2_table(46878) := '682865522E46656E636564436F64652C652E707265764C696E65456E6428292D69292C69292C21307D2C426C6F636B71756F746528652C74297B6C6574206E3D63522874293B72657475726E21286E3C3029262628652E7374617274436F6E7465787428';
wwv_flow_imp.g_varchar2_table(46879) := '65522E426C6F636B71756F74652C742E706F73292C652E6164644E6F64652865522E51756F74654D61726B2C652E6C696E6553746172742B742E706F732C652E6C696E6553746172742B742E706F732B31292C742E6D6F76654261736528742E706F732B';
wwv_flow_imp.g_varchar2_table(46880) := '6E292C6E756C6C297D2C486F72697A6F6E74616C52756C6528652C74297B696628645228742C652C2131293C302972657475726E21313B6C6574206E3D652E6C696E6553746172742B742E706F733B72657475726E20652E6E6578744C696E6528292C65';
wwv_flow_imp.g_varchar2_table(46881) := '2E6164644E6F64652865522E486F72697A6F6E74616C52756C652C6E292C21307D2C42756C6C65744C69737428652C74297B6C6574206E3D755228742C652C2131293B6966286E3C302972657475726E21313B652E626C6F636B2E74797065213D65522E';
wwv_flow_imp.g_varchar2_table(46882) := '42756C6C65744C6973742626652E7374617274436F6E746578742865522E42756C6C65744C6973742C742E62617365506F732C742E6E657874293B6C657420693D775228742C742E706F732B31293B72657475726E20652E7374617274436F6E74657874';
wwv_flow_imp.g_varchar2_table(46883) := '2865522E4C6973744974656D2C742E62617365506F732C692D742E62617365496E64656E74292C652E6164644E6F64652865522E4C6973744D61726B2C652E6C696E6553746172742B742E706F732C652E6C696E6553746172742B742E706F732B6E292C';
wwv_flow_imp.g_varchar2_table(46884) := '742E6D6F766542617365436F6C756D6E2869292C6E756C6C7D2C4F7264657265644C69737428652C74297B6C6574206E3D705228742C652C2131293B6966286E3C302972657475726E21313B652E626C6F636B2E74797065213D65522E4F726465726564';
wwv_flow_imp.g_varchar2_table(46885) := '4C6973742626652E7374617274436F6E746578742865522E4F7264657265644C6973742C742E62617365506F732C742E746578742E63686172436F6465417428742E706F732B6E2D3129293B6C657420693D775228742C742E706F732B6E293B72657475';
wwv_flow_imp.g_varchar2_table(46886) := '726E20652E7374617274436F6E746578742865522E4C6973744974656D2C742E62617365506F732C692D742E62617365496E64656E74292C652E6164644E6F64652865522E4C6973744D61726B2C652E6C696E6553746172742B742E706F732C652E6C69';
wwv_flow_imp.g_varchar2_table(46887) := '6E6553746172742B742E706F732B6E292C742E6D6F766542617365436F6C756D6E2869292C6E756C6C7D2C41545848656164696E6728652C74297B6C6574206E3D67522874293B6966286E3C302972657475726E21313B6C657420693D742E706F732C6F';
wwv_flow_imp.g_varchar2_table(46888) := '3D652E6C696E6553746172742B692C733D615228742E746578742C742E746578742E6C656E6774682C69292C723D733B666F72283B723E692626742E746578742E63686172436F6465417428722D31293D3D742E6E6578743B29722D2D3B72213D732626';
wwv_flow_imp.g_varchar2_table(46889) := '72213D692626735228742E746578742E63686172436F6465417428722D3129297C7C28723D742E746578742E6C656E677468293B6C657420613D652E6275666665722E77726974652865522E4865616465724D61726B2C302C6E292E7772697465456C65';
wwv_flow_imp.g_varchar2_table(46890) := '6D656E747328652E7061727365722E7061727365496E6C696E6528742E746578742E736C69636528692B6E2B312C72292C6F2B6E2B31292C2D6F293B723C742E746578742E6C656E6774682626612E77726974652865522E4865616465724D61726B2C72';
wwv_flow_imp.g_varchar2_table(46891) := '2D692C732D69293B6C6574206C3D612E66696E6973682865522E41545848656164696E67312D312B6E2C742E746578742E6C656E6774682D69293B72657475726E20652E6E6578744C696E6528292C652E6164644E6F6465286C2C6F292C21307D2C4854';
wwv_flow_imp.g_varchar2_table(46892) := '4D4C426C6F636B28652C74297B6C6574206E3D795228742C302C2131293B6966286E3C302972657475726E21313B6C657420693D652E6C696E6553746172742B742E706F732C6F3D5F525B6E5D5B315D2C733D5B5D2C723D6F213D66523B666F72283B21';
wwv_flow_imp.g_varchar2_table(46893) := '6F2E7465737428742E74657874292626652E6E6578744C696E6528293B297B696628742E64657074683C652E737461636B2E6C656E677468297B723D21313B627265616B7D666F72286C65742065206F6620742E6D61726B65727329732E707573682865';
wwv_flow_imp.g_varchar2_table(46894) := '297D722626652E6E6578744C696E6528293B6C657420613D6F3D3D76523F65522E436F6D6D656E74426C6F636B3A6F3D3D62523F65522E50726F63657373696E67496E737472756374696F6E426C6F636B3A65522E48544D4C426C6F636B2C6C3D652E70';
wwv_flow_imp.g_varchar2_table(46895) := '7265764C696E65456E6428293B72657475726E20652E6164644E6F646528652E6275666665722E7772697465456C656D656E747328732C2D69292E66696E69736828612C6C2D69292C69292C21307D2C53657465787448656164696E673A766F69642030';
wwv_flow_imp.g_varchar2_table(46896) := '7D3B636C6173732078527B636F6E7374727563746F722865297B746869732E73746167653D302C746869732E656C74733D5B5D2C746869732E706F733D302C746869732E73746172743D652E73746172742C746869732E616476616E636528652E636F6E';
wwv_flow_imp.g_varchar2_table(46897) := '74656E74297D6E6578744C696E6528652C742C6E297B6966282D313D3D746869732E73746167652972657475726E21313B6C657420693D6E2E636F6E74656E742B225C6E222B742E736372756228292C6F3D746869732E616476616E63652869293B7265';
wwv_flow_imp.g_varchar2_table(46898) := '7475726E206F3E2D3126266F3C692E6C656E6774682626746869732E636F6D706C65746528652C6E2C6F297D66696E69736828652C74297B72657475726E28323D3D746869732E73746167657C7C333D3D746869732E7374616765292626725228742E63';
wwv_flow_imp.g_varchar2_table(46899) := '6F6E74656E742C746869732E706F73293D3D742E636F6E74656E742E6C656E6774682626746869732E636F6D706C65746528652C742C742E636F6E74656E742E6C656E677468297D636F6D706C65746528652C742C6E297B72657475726E20652E616464';
wwv_flow_imp.g_varchar2_table(46900) := '4C656166456C656D656E7428742C48522865522E4C696E6B5265666572656E63652C746869732E73746172742C746869732E73746172742B6E2C746869732E656C747329292C21307D6E65787453746167652865297B72657475726E20653F2874686973';
wwv_flow_imp.g_varchar2_table(46901) := '2E706F733D652E746F2D746869732E73746172742C746869732E656C74732E707573682865292C746869732E73746167652B2B2C2130293A2821313D3D3D65262628746869732E73746167653D2D31292C2131297D616476616E63652865297B666F7228';
wwv_flow_imp.g_varchar2_table(46902) := '3B3B297B6966282D313D3D746869732E73746167652972657475726E2D313B696628303D3D746869732E7374616765297B69662821746869732E6E657874537461676528585228652C746869732E706F732C746869732E73746172742C21302929297265';
wwv_flow_imp.g_varchar2_table(46903) := '7475726E2D313B6966283538213D652E63686172436F6465417428746869732E706F73292972657475726E20746869732E73746167653D2D313B746869732E656C74732E707573682848522865522E4C696E6B4D61726B2C746869732E706F732B746869';
wwv_flow_imp.g_varchar2_table(46904) := '732E73746172742C746869732E706F732B746869732E73746172742B3129292C746869732E706F732B2B7D656C73657B69662831213D746869732E7374616765297B696628323D3D746869732E7374616765297B6C657420743D725228652C746869732E';
wwv_flow_imp.g_varchar2_table(46905) := '706F73292C6E3D303B696628743E746869732E706F73297B6C657420693D5A5228652C742C746869732E7374617274293B69662869297B6C657420743D6B5228652C692E746F2D746869732E7374617274293B743E30262628746869732E6E6578745374';
wwv_flow_imp.g_varchar2_table(46906) := '6167652869292C6E3D74297D7D72657475726E206E7C7C286E3D6B5228652C746869732E706F7329292C6E3E3026266E3C652E6C656E6774683F6E3A2D317D72657475726E206B5228652C746869732E706F73297D69662821746869732E6E6578745374';
wwv_flow_imp.g_varchar2_table(46907) := '61676528595228652C725228652C746869732E706F73292C746869732E737461727429292972657475726E2D317D7D7D7D66756E6374696F6E206B5228652C74297B666F72283B743C652E6C656E6774683B742B2B297B6C6574206E3D652E6368617243';
wwv_flow_imp.g_varchar2_table(46908) := '6F646541742874293B69662831303D3D6E29627265616B3B696628217352286E292972657475726E2D317D72657475726E20747D636C6173732045527B6E6578744C696E6528652C742C6E297B6C657420693D742E64657074683C652E737461636B2E6C';
wwv_flow_imp.g_varchar2_table(46909) := '656E6774683F2D313A6D522874292C6F3D742E6E6578743B696628693C302972657475726E21313B6C657420733D48522865522E4865616465724D61726B2C652E6C696E6553746172742B742E706F732C652E6C696E6553746172742B69293B72657475';
wwv_flow_imp.g_varchar2_table(46910) := '726E20652E6E6578744C696E6528292C652E6164644C656166456C656D656E74286E2C48522836313D3D6F3F65522E53657465787448656164696E67313A65522E53657465787448656164696E67322C6E2E73746172742C652E707265764C696E65456E';
wwv_flow_imp.g_varchar2_table(46911) := '6428292C5B2E2E2E652E7061727365722E7061727365496E6C696E65286E2E636F6E74656E742C6E2E7374617274292C735D29292C21307D66696E69736828297B72657475726E21317D7D636F6E7374204C523D7B4C696E6B5265666572656E63653A28';
wwv_flow_imp.g_varchar2_table(46912) := '652C74293D3E39313D3D742E636F6E74656E742E63686172436F646541742830293F6E65772078522874293A6E756C6C2C53657465787448656164696E673A28293D3E6E65772045527D2C44523D5B28652C74293D3E67522874293E3D302C28652C7429';
wwv_flow_imp.g_varchar2_table(46913) := '3D3E6C522874293E3D302C28652C74293D3E63522874293E3D302C28652C74293D3E755228742C652C2130293E3D302C28652C74293D3E705228742C652C2130293E3D302C28652C74293D3E645228742C652C2130293E3D302C28652C74293D3E795228';
wwv_flow_imp.g_varchar2_table(46914) := '742C302C2130293E3D305D2C54523D7B746578743A22222C656E643A307D3B636C6173732049527B636F6E7374727563746F7228652C742C6E2C69297B746869732E7061727365723D652C746869732E696E7075743D742C746869732E72616E6765733D';
wwv_flow_imp.g_varchar2_table(46915) := '692C746869732E6C696E653D6E6577206E522C746869732E6174456E643D21312C746869732E7265757365506C616365686F6C646572733D6E6577204D61702C746869732E73746F7070656441743D6E756C6C2C746869732E72616E6765493D302C7468';
wwv_flow_imp.g_varchar2_table(46916) := '69732E746F3D695B692E6C656E6774682D315D2E746F2C746869732E6C696E6553746172743D746869732E6162736F6C7574654C696E6553746172743D746869732E6162736F6C7574654C696E65456E643D695B305D2E66726F6D2C746869732E626C6F';
wwv_flow_imp.g_varchar2_table(46917) := '636B3D4A4F2E6372656174652865522E446F63756D656E742C302C746869732E6C696E6553746172742C302C30292C746869732E737461636B3D5B746869732E626C6F636B5D2C746869732E667261676D656E74733D6E2E6C656E6774683F6E6577206E';
wwv_flow_imp.g_varchar2_table(46918) := '46286E2C74293A6E756C6C2C746869732E726561644C696E6528297D67657420706172736564506F7328297B72657475726E20746869732E6162736F6C7574654C696E6553746172747D616476616E636528297B6966286E756C6C213D746869732E7374';
wwv_flow_imp.g_varchar2_table(46919) := '6F7070656441742626746869732E6162736F6C7574654C696E6553746172743E746869732E73746F7070656441742972657475726E20746869732E66696E69736828293B6C65747B6C696E653A657D3D746869733B666F72283B3B297B666F72286C6574';
wwv_flow_imp.g_varchar2_table(46920) := '20743D303B3B297B6C6574206E3D652E64657074683C746869732E737461636B2E6C656E6774683F746869732E737461636B5B746869732E737461636B2E6C656E6774682D315D3A6E756C6C3B666F72283B743C652E6D61726B6572732E6C656E677468';
wwv_flow_imp.g_varchar2_table(46921) := '262628216E7C7C652E6D61726B6572735B745D2E66726F6D3C6E2E656E64293B297B6C6574206E3D652E6D61726B6572735B742B2B5D3B746869732E6164644E6F6465286E2E747970652C6E2E66726F6D2C6E2E746F297D696628216E29627265616B3B';
wwv_flow_imp.g_varchar2_table(46922) := '746869732E66696E697368436F6E7465787428297D696628652E706F733C652E746578742E6C656E67746829627265616B3B69662821746869732E6E6578744C696E6528292972657475726E20746869732E66696E69736828297D696628746869732E66';
wwv_flow_imp.g_varchar2_table(46923) := '7261676D656E74732626746869732E7265757365467261676D656E7428652E62617365506F73292972657475726E206E756C6C3B653A666F72283B3B297B666F72286C65742074206F6620746869732E7061727365722E626C6F636B5061727365727329';
wwv_flow_imp.g_varchar2_table(46924) := '69662874297B6C6574206E3D7428746869732C65293B69662830213D6E297B696628313D3D6E2972657475726E206E756C6C3B652E666F727761726428293B636F6E74696E756520657D7D627265616B7D6C657420743D6E657720745228746869732E6C';
wwv_flow_imp.g_varchar2_table(46925) := '696E6553746172742B652E706F732C652E746578742E736C69636528652E706F7329293B666F72286C65742065206F6620746869732E7061727365722E6C656166426C6F636B506172736572732969662865297B6C6574206E3D6528746869732C74293B';
wwv_flow_imp.g_varchar2_table(46926) := '6E2626742E706172736572732E70757368286E297D653A666F72283B746869732E6E6578744C696E6528292626652E706F73213D652E746578742E6C656E6774683B297B696628652E696E64656E743C652E62617365496E64656E742B3429666F72286C';
wwv_flow_imp.g_varchar2_table(46927) := '6574206E206F6620746869732E7061727365722E656E644C656166426C6F636B296966286E28746869732C652C742929627265616B20653B666F72286C6574206E206F6620742E70617273657273296966286E2E6E6578744C696E6528746869732C652C';
wwv_flow_imp.g_varchar2_table(46928) := '74292972657475726E206E756C6C3B742E636F6E74656E742B3D225C6E222B652E736372756228293B666F72286C6574206E206F6620652E6D61726B65727329742E6D61726B732E70757368286E297D72657475726E20746869732E66696E6973684C65';
wwv_flow_imp.g_varchar2_table(46929) := '61662874292C6E756C6C7D73746F7041742865297B6966286E756C6C213D746869732E73746F7070656441742626746869732E73746F7070656441743C65297468726F77206E65772052616E67654572726F72282243616E2774206D6F76652073746F70';
wwv_flow_imp.g_varchar2_table(46930) := '706564417420666F727761726422293B746869732E73746F7070656441743D657D7265757365467261676D656E742865297B69662821746869732E667261676D656E74732E6D6F7665546F28746869732E6162736F6C7574654C696E6553746172742B65';
wwv_flow_imp.g_varchar2_table(46931) := '2C746869732E6162736F6C7574654C696E655374617274297C7C21746869732E667261676D656E74732E6D61746368657328746869732E626C6F636B2E68617368292972657475726E21313B6C657420743D746869732E667261676D656E74732E74616B';
wwv_flow_imp.g_varchar2_table(46932) := '654E6F6465732874686973293B72657475726E212174262628746869732E6162736F6C7574654C696E6553746172742B3D742C746869732E6C696E6553746172743D694628746869732E6162736F6C7574654C696E6553746172742C746869732E72616E';
wwv_flow_imp.g_varchar2_table(46933) := '676573292C746869732E6D6F766552616E67654928292C746869732E6162736F6C7574654C696E6553746172743C746869732E746F3F28746869732E6C696E6553746172742B2B2C746869732E6162736F6C7574654C696E6553746172742B2B2C746869';
wwv_flow_imp.g_varchar2_table(46934) := '732E726561644C696E652829293A28746869732E6174456E643D21302C746869732E726561644C696E652829292C2130297D67657420646570746828297B72657475726E20746869732E737461636B2E6C656E6774687D706172656E745479706528653D';
wwv_flow_imp.g_varchar2_table(46935) := '746869732E64657074682D31297B72657475726E20746869732E7061727365722E6E6F64655365742E74797065735B746869732E737461636B5B655D2E747970655D7D6E6578744C696E6528297B72657475726E20746869732E6C696E6553746172742B';
wwv_flow_imp.g_varchar2_table(46936) := '3D746869732E6C696E652E746578742E6C656E6774682C746869732E6162736F6C7574654C696E65456E643E3D746869732E746F3F28746869732E6162736F6C7574654C696E6553746172743D746869732E6162736F6C7574654C696E65456E642C7468';
wwv_flow_imp.g_varchar2_table(46937) := '69732E6174456E643D21302C746869732E726561644C696E6528292C2131293A28746869732E6C696E6553746172742B2B2C746869732E6162736F6C7574654C696E6553746172743D746869732E6162736F6C7574654C696E65456E642B312C74686973';
wwv_flow_imp.g_varchar2_table(46938) := '2E6D6F766552616E67654928292C746869732E726561644C696E6528292C2130297D6D6F766552616E67654928297B666F72283B746869732E72616E6765493C746869732E72616E6765732E6C656E6774682D312626746869732E6162736F6C7574654C';
wwv_flow_imp.g_varchar2_table(46939) := '696E6553746172743E3D746869732E72616E6765735B746869732E72616E6765495D2E746F3B29746869732E72616E6765492B2B2C746869732E6162736F6C7574654C696E6553746172743D4D6174682E6D617828746869732E6162736F6C7574654C69';
wwv_flow_imp.g_varchar2_table(46940) := '6E6553746172742C746869732E72616E6765735B746869732E72616E6765495D2E66726F6D297D7363616E4C696E652865297B6C657420743D54523B696628742E656E643D652C653E3D746869732E746F29742E746578743D22223B656C736520696628';
wwv_flow_imp.g_varchar2_table(46941) := '742E746578743D746869732E6C696E654368756E6B41742865292C742E656E642B3D742E746578742E6C656E6774682C746869732E72616E6765732E6C656E6774683E31297B6C657420653D746869732E6162736F6C7574654C696E6553746172742C6E';
wwv_flow_imp.g_varchar2_table(46942) := '3D746869732E72616E6765493B666F72283B746869732E72616E6765735B6E5D2E746F3C742E656E643B297B6E2B2B3B6C657420693D746869732E72616E6765735B6E5D2E66726F6D2C6F3D746869732E6C696E654368756E6B41742869293B742E656E';
wwv_flow_imp.g_varchar2_table(46943) := '643D692B6F2E6C656E6774682C742E746578743D742E746578742E736C69636528302C746869732E72616E6765735B6E2D315D2E746F2D65292B6F2C653D742E656E642D742E746578742E6C656E6774687D7D72657475726E20747D726561644C696E65';
wwv_flow_imp.g_varchar2_table(46944) := '28297B6C65747B6C696E653A657D3D746869732C7B746578743A742C656E643A6E7D3D746869732E7363616E4C696E6528746869732E6162736F6C7574654C696E655374617274293B666F7228746869732E6162736F6C7574654C696E65456E643D6E2C';
wwv_flow_imp.g_varchar2_table(46945) := '652E72657365742874293B652E64657074683C746869732E737461636B2E6C656E6774683B652E64657074682B2B297B6C657420743D746869732E737461636B5B652E64657074685D2C6E3D746869732E7061727365722E736B6970436F6E746578744D';
wwv_flow_imp.g_varchar2_table(46946) := '61726B75705B742E747970655D3B696628216E297468726F77206E6577204572726F722822556E68616E646C656420626C6F636B20636F6E7465787420222B65525B742E747970655D293B696628216E28742C746869732C652929627265616B3B652E66';
wwv_flow_imp.g_varchar2_table(46947) := '6F727761726428297D7D6C696E654368756E6B41742865297B6C657420742C6E3D746869732E696E7075742E6368756E6B2865293B696628746869732E696E7075742E6C696E654368756E6B7329743D225C6E223D3D6E3F22223A6E3B656C73657B6C65';
wwv_flow_imp.g_varchar2_table(46948) := '7420653D6E2E696E6465784F6628225C6E22293B743D653C303F6E3A6E2E736C69636528302C65297D72657475726E20652B742E6C656E6774683E746869732E746F3F742E736C69636528302C746869732E746F2D65293A747D707265764C696E65456E';
wwv_flow_imp.g_varchar2_table(46949) := '6428297B72657475726E20746869732E6174456E643F746869732E6C696E6553746172743A746869732E6C696E6553746172742D317D7374617274436F6E7465787428652C742C6E3D30297B746869732E626C6F636B3D4A4F2E63726561746528652C6E';
wwv_flow_imp.g_varchar2_table(46950) := '2C746869732E6C696E6553746172742B742C746869732E626C6F636B2E686173682C746869732E6C696E6553746172742B746869732E6C696E652E746578742E6C656E677468292C746869732E737461636B2E7075736828746869732E626C6F636B297D';
wwv_flow_imp.g_varchar2_table(46951) := '7374617274436F6D706F7369746528652C742C6E3D30297B746869732E7374617274436F6E7465787428746869732E7061727365722E6765744E6F6465547970652865292C742C6E297D6164644E6F646528652C742C6E297B226E756D626572223D3D74';
wwv_flow_imp.g_varchar2_table(46952) := '7970656F662065262628653D6E657720725328746869732E7061727365722E6E6F64655365742E74797065735B655D2C46522C46522C286E756C6C213D6E3F6E3A746869732E707265764C696E65456E642829292D7429292C746869732E626C6F636B2E';
wwv_flow_imp.g_varchar2_table(46953) := '6164644368696C6428652C742D746869732E626C6F636B2E66726F6D297D616464456C656D656E742865297B746869732E626C6F636B2E6164644368696C6428652E746F5472656528746869732E7061727365722E6E6F6465536574292C652E66726F6D';
wwv_flow_imp.g_varchar2_table(46954) := '2D746869732E626C6F636B2E66726F6D297D6164644C656166456C656D656E7428652C74297B746869732E6164644E6F646528746869732E6275666665722E7772697465456C656D656E747328654628742E6368696C6472656E2C652E6D61726B73292C';
wwv_flow_imp.g_varchar2_table(46955) := '2D742E66726F6D292E66696E69736828742E747970652C742E746F2D742E66726F6D292C742E66726F6D297D66696E697368436F6E7465787428297B6C657420653D746869732E737461636B2E706F7028292C743D746869732E737461636B5B74686973';
wwv_flow_imp.g_varchar2_table(46956) := '2E737461636B2E6C656E6774682D315D3B742E6164644368696C6428652E746F5472656528746869732E7061727365722E6E6F6465536574292C652E66726F6D2D742E66726F6D292C746869732E626C6F636B3D747D66696E69736828297B666F72283B';
wwv_flow_imp.g_varchar2_table(46957) := '746869732E737461636B2E6C656E6774683E313B29746869732E66696E697368436F6E7465787428293B72657475726E20746869732E6164644761707328746869732E626C6F636B2E746F5472656528746869732E7061727365722E6E6F64655365742C';
wwv_flow_imp.g_varchar2_table(46958) := '746869732E6C696E65537461727429297D616464476170732865297B72657475726E20746869732E72616E6765732E6C656E6774683E313F4D5228746869732E72616E6765732C302C652E746F704E6F64652C746869732E72616E6765735B305D2E6672';
wwv_flow_imp.g_varchar2_table(46959) := '6F6D2C746869732E7265757365506C616365686F6C64657273293A657D66696E6973684C6561662865297B666F72286C65742074206F6620652E7061727365727329696628742E66696E69736828746869732C65292972657475726E3B6C657420743D65';
wwv_flow_imp.g_varchar2_table(46960) := '4628746869732E7061727365722E7061727365496E6C696E6528652E636F6E74656E742C652E7374617274292C652E6D61726B73293B746869732E6164644E6F646528746869732E6275666665722E7772697465456C656D656E747328742C2D652E7374';
wwv_flow_imp.g_varchar2_table(46961) := '617274292E66696E6973682865522E5061726167726170682C652E636F6E74656E742E6C656E677468292C652E7374617274297D656C7428652C742C6E2C69297B72657475726E22737472696E67223D3D747970656F6620653F485228746869732E7061';
wwv_flow_imp.g_varchar2_table(46962) := '727365722E6765744E6F6465547970652865292C742C6E2C69293A6E6577207A5228652C74297D6765742062756666657228297B72657475726E206E657720425228746869732E7061727365722E6E6F6465536574297D7D66756E6374696F6E204D5228';
wwv_flow_imp.g_varchar2_table(46963) := '652C742C6E2C692C6F297B6C657420733D655B745D2E746F2C723D5B5D2C613D5B5D2C6C3D6E2E66726F6D2B693B66756E6374696F6E2063286E2C6F297B666F72283B6F3F6E3E3D733A6E3E733B297B6C6574206F3D655B742B315D2E66726F6D2D733B';
wwv_flow_imp.g_varchar2_table(46964) := '692B3D6F2C6E2B3D6F2C742B2B2C733D655B745D2E746F7D7D666F72286C657420643D6E2E66697273744368696C643B643B643D642E6E6578745369626C696E67297B6328642E66726F6D2B692C2130293B6C6574206E2C683D642E66726F6D2B692C75';
wwv_flow_imp.g_varchar2_table(46965) := '3D6F2E67657428642E74726565293B753F6E3D753A642E746F2B693E733F286E3D4D5228652C742C642C692C6F292C6328642E746F2B692C213129293A6E3D642E746F5472656528292C722E70757368286E292C612E7075736828682D6C297D72657475';
wwv_flow_imp.g_varchar2_table(46966) := '726E2063286E2E746F2B692C2131292C6E6577207253286E2E747970652C722C612C6E2E746F2B692D6C2C6E2E747265653F6E2E747265652E70726F7056616C7565733A766F69642030297D636C61737320415220657874656E6473206B537B636F6E73';
wwv_flow_imp.g_varchar2_table(46967) := '74727563746F7228652C742C6E2C692C6F2C732C722C612C6C297B737570657228292C746869732E6E6F64655365743D652C746869732E626C6F636B506172736572733D742C746869732E6C656166426C6F636B506172736572733D6E2C746869732E62';
wwv_flow_imp.g_varchar2_table(46968) := '6C6F636B4E616D65733D692C746869732E656E644C656166426C6F636B3D6F2C746869732E736B6970436F6E746578744D61726B75703D732C746869732E696E6C696E65506172736572733D722C746869732E696E6C696E654E616D65733D612C746869';
wwv_flow_imp.g_varchar2_table(46969) := '732E77726170706572733D6C2C746869732E6E6F646554797065733D4F626A6563742E637265617465286E756C6C293B666F72286C65742074206F6620652E747970657329746869732E6E6F646554797065735B742E6E616D655D3D742E69647D637265';
wwv_flow_imp.g_varchar2_table(46970) := '617465506172736528652C742C6E297B6C657420693D6E657720495228746869732C652C742C6E293B666F72286C6574206F206F6620746869732E777261707065727329693D6F28692C652C742C6E293B72657475726E20697D636F6E66696775726528';
wwv_flow_imp.g_varchar2_table(46971) := '65297B6C657420743D50522865293B69662821742972657475726E20746869733B6C65747B6E6F64655365743A6E2C736B6970436F6E746578744D61726B75703A697D3D746869732C6F3D746869732E626C6F636B506172736572732E736C6963652829';
wwv_flow_imp.g_varchar2_table(46972) := '2C733D746869732E6C656166426C6F636B506172736572732E736C69636528292C723D746869732E626C6F636B4E616D65732E736C69636528292C613D746869732E696E6C696E65506172736572732E736C69636528292C6C3D746869732E696E6C696E';
wwv_flow_imp.g_varchar2_table(46973) := '654E616D65732E736C69636528292C633D746869732E656E644C656166426C6F636B2E736C69636528292C643D746869732E77726170706572733B6966284E5228742E646566696E654E6F64657329297B693D4F626A6563742E61737369676E287B7D2C';
wwv_flow_imp.g_varchar2_table(46974) := '69293B6C657420652C6F3D6E2E74797065732E736C69636528293B666F72286C6574206E206F6620742E646566696E654E6F646573297B6C65747B6E616D653A742C626C6F636B3A732C636F6D706F736974653A722C7374796C653A617D3D2273747269';
wwv_flow_imp.g_varchar2_table(46975) := '6E67223D3D747970656F66206E3F7B6E616D653A6E7D3A6E3B6966286F2E736F6D652828653D3E652E6E616D653D3D74292929636F6E74696E75653B72262628695B6F2E6C656E6774685D3D28652C742C6E293D3E7228742C6E2C652E76616C75652929';
wwv_flow_imp.g_varchar2_table(46976) := '3B6C6574206C3D6F2E6C656E6774682C633D723F5B22426C6F636B222C22426C6F636B436F6E74657874225D3A733F6C3E3D65522E41545848656164696E673126266C3C3D65522E53657465787448656164696E67323F5B22426C6F636B222C224C6561';
wwv_flow_imp.g_varchar2_table(46977) := '66426C6F636B222C2248656164696E67225D3A5B22426C6F636B222C224C656166426C6F636B225D3A766F696420303B6F2E707573682874532E646566696E65287B69643A6C2C6E616D653A742C70726F70733A6326265B5B58432E67726F75702C635D';
wwv_flow_imp.g_varchar2_table(46978) := '5D7D29292C61262628657C7C28653D7B7D292C41727261792E697341727261792861297C7C6120696E7374616E63656F662075783F655B745D3D613A4F626A6563742E61737369676E28652C6129297D6E3D6E6577206E53286F292C652626286E3D6E2E';
wwv_flow_imp.g_varchar2_table(46979) := '657874656E64286D7828652929297D6966284E5228742E70726F7073292626286E3D6E2E657874656E64282E2E2E742E70726F707329292C4E5228742E72656D6F76652929666F72286C65742065206F6620742E72656D6F7665297B6C657420743D7468';
wwv_flow_imp.g_varchar2_table(46980) := '69732E626C6F636B4E616D65732E696E6465784F662865292C6E3D746869732E696E6C696E654E616D65732E696E6465784F662865293B743E2D312626286F5B745D3D735B745D3D766F69642030292C6E3E2D31262628615B6E5D3D766F69642030297D';
wwv_flow_imp.g_varchar2_table(46981) := '6966284E5228742E7061727365426C6F636B2929666F72286C65742065206F6620742E7061727365426C6F636B297B6C657420743D722E696E6465784F6628652E6E616D65293B696628743E2D31296F5B745D3D652E70617273652C735B745D3D652E6C';
wwv_flow_imp.g_varchar2_table(46982) := '6561663B656C73657B6C657420743D652E6265666F72653F4F5228722C652E6265666F7265293A652E61667465723F4F5228722C652E6166746572292B313A722E6C656E6774682D313B6F2E73706C69636528742C302C652E7061727365292C732E7370';
wwv_flow_imp.g_varchar2_table(46983) := '6C69636528742C302C652E6C656166292C722E73706C69636528742C302C652E6E616D65297D652E656E644C6561662626632E7075736828652E656E644C656166297D6966284E5228742E7061727365496E6C696E652929666F72286C65742065206F66';
wwv_flow_imp.g_varchar2_table(46984) := '20742E7061727365496E6C696E65297B6C657420743D6C2E696E6465784F6628652E6E616D65293B696628743E2D3129615B745D3D652E70617273653B656C73657B6C657420743D652E6265666F72653F4F52286C2C652E6265666F7265293A652E6166';
wwv_flow_imp.g_varchar2_table(46985) := '7465723F4F52286C2C652E6166746572292B313A6C2E6C656E6774682D313B612E73706C69636528742C302C652E7061727365292C6C2E73706C69636528742C302C652E6E616D65297D7D72657475726E20742E77726170262628643D642E636F6E6361';
wwv_flow_imp.g_varchar2_table(46986) := '7428742E7772617029292C6E6577204152286E2C6F2C732C722C632C692C612C6C2C64297D6765744E6F6465547970652865297B6C657420743D746869732E6E6F646554797065735B655D3B6966286E756C6C3D3D74297468726F77206E65772052616E';
wwv_flow_imp.g_varchar2_table(46987) := '67654572726F722860556E6B6E6F776E206E6F646520747970652027247B657D2760293B72657475726E20747D7061727365496E6C696E6528652C74297B6C6574206E3D6E6577204A5228746869732C652C74293B653A666F72286C657420653D743B65';
wwv_flow_imp.g_varchar2_table(46988) := '3C6E2E656E643B297B6C657420743D6E2E636861722865293B666F72286C65742069206F6620746869732E696E6C696E65506172736572732969662869297B6C6574206F3D69286E2C742C65293B6966286F3E3D30297B653D6F3B636F6E74696E756520';
wwv_flow_imp.g_varchar2_table(46989) := '657D7D652B2B7D72657475726E206E2E7265736F6C76654D61726B6572732830297D7D66756E6374696F6E204E522865297B72657475726E206E756C6C213D652626652E6C656E6774683E307D66756E6374696F6E2050522865297B6966282141727261';
wwv_flow_imp.g_varchar2_table(46990) := '792E697341727261792865292972657475726E20653B696628303D3D652E6C656E6774682972657475726E206E756C6C3B6C657420743D505228655B305D293B696628313D3D652E6C656E6774682972657475726E20743B6C6574206E3D505228652E73';
wwv_flow_imp.g_varchar2_table(46991) := '6C696365283129293B696628216E7C7C21742972657475726E20747C7C6E3B6C657420693D28652C74293D3E28657C7C4652292E636F6E63617428747C7C4652292C6F3D742E777261702C733D6E2E777261703B72657475726E7B70726F70733A692874';
wwv_flow_imp.g_varchar2_table(46992) := '2E70726F70732C6E2E70726F7073292C646566696E654E6F6465733A6928742E646566696E654E6F6465732C6E2E646566696E654E6F646573292C7061727365426C6F636B3A6928742E7061727365426C6F636B2C6E2E7061727365426C6F636B292C70';
wwv_flow_imp.g_varchar2_table(46993) := '61727365496E6C696E653A6928742E7061727365496E6C696E652C6E2E7061727365496E6C696E65292C72656D6F76653A6928742E72656D6F76652C6E2E72656D6F7665292C777261703A6F3F733F28652C742C6E2C69293D3E6F287328652C742C6E2C';
wwv_flow_imp.g_varchar2_table(46994) := '69292C742C6E2C69293A6F3A737D7D66756E6374696F6E204F5228652C74297B6C6574206E3D652E696E6465784F662874293B6966286E3C30297468726F77206E65772052616E67654572726F722860506F736974696F6E207370656369666965642072';
wwv_flow_imp.g_varchar2_table(46995) := '656C617469766520746F20756E6B6E6F776E2070617273657220247B747D60293B72657475726E206E7D6C65742052523D5B74532E6E6F6E655D3B666F72286C657420652C743D313B653D65525B745D3B742B2B2952525B745D3D74532E646566696E65';
wwv_flow_imp.g_varchar2_table(46996) := '287B69643A742C6E616D653A652C70726F70733A743E3D65522E4573636170653F5B5D3A5B5B58432E67726F75702C7420696E206F523F5B22426C6F636B222C22426C6F636B436F6E74657874225D3A5B22426C6F636B222C224C656166426C6F636B22';
wwv_flow_imp.g_varchar2_table(46997) := '5D5D5D2C746F703A22446F63756D656E74223D3D657D293B636F6E73742046523D5B5D3B636C6173732042527B636F6E7374727563746F722865297B746869732E6E6F64655365743D652C746869732E636F6E74656E743D5B5D2C746869732E6E6F6465';
wwv_flow_imp.g_varchar2_table(46998) := '733D5B5D7D777269746528652C742C6E2C693D30297B72657475726E20746869732E636F6E74656E742E7075736828652C742C6E2C342B342A69292C746869737D7772697465456C656D656E747328652C743D30297B666F72286C6574206E206F662065';
wwv_flow_imp.g_varchar2_table(46999) := '296E2E7772697465546F28746869732C74293B72657475726E20746869737D66696E69736828652C74297B72657475726E2072532E6275696C64287B6275666665723A746869732E636F6E74656E742C6E6F64655365743A746869732E6E6F6465536574';
wwv_flow_imp.g_varchar2_table(47000) := '2C7265757365643A746869732E6E6F6465732C746F7049443A652C6C656E6774683A747D297D7D636C6173732056527B636F6E7374727563746F7228652C742C6E2C693D4652297B746869732E747970653D652C746869732E66726F6D3D742C74686973';
wwv_flow_imp.g_varchar2_table(47001) := '2E746F3D6E2C746869732E6368696C6472656E3D697D7772697465546F28652C74297B6C6574206E3D652E636F6E74656E742E6C656E6774683B652E7772697465456C656D656E747328746869732E6368696C6472656E2C74292C652E636F6E74656E74';
wwv_flow_imp.g_varchar2_table(47002) := '2E7075736828746869732E747970652C746869732E66726F6D2B742C746869732E746F2B742C652E636F6E74656E742E6C656E6774682B342D6E297D746F547265652865297B72657475726E206E65772042522865292E7772697465456C656D656E7473';
wwv_flow_imp.g_varchar2_table(47003) := '28746869732E6368696C6472656E2C2D746869732E66726F6D292E66696E69736828746869732E747970652C746869732E746F2D746869732E66726F6D297D7D636C617373207A527B636F6E7374727563746F7228652C74297B746869732E747265653D';
wwv_flow_imp.g_varchar2_table(47004) := '652C746869732E66726F6D3D747D67657420746F28297B72657475726E20746869732E66726F6D2B746869732E747265652E6C656E6774687D676574207479706528297B72657475726E20746869732E747265652E747970652E69647D67657420636869';
wwv_flow_imp.g_varchar2_table(47005) := '6C6472656E28297B72657475726E2046527D7772697465546F28652C74297B652E6E6F6465732E7075736828746869732E74726565292C652E636F6E74656E742E7075736828652E6E6F6465732E6C656E6774682D312C746869732E66726F6D2B742C74';
wwv_flow_imp.g_varchar2_table(47006) := '6869732E746F2B742C2D31297D746F5472656528297B72657475726E20746869732E747265657D7D66756E6374696F6E20485228652C742C6E2C69297B72657475726E206E657720565228652C742C6E2C69297D636F6E73742057523D7B7265736F6C76';
wwv_flow_imp.g_varchar2_table(47007) := '653A22456D706861736973222C6D61726B3A22456D7068617369734D61726B227D2C6A523D7B7265736F6C76653A22456D706861736973222C6D61726B3A22456D7068617369734D61726B227D2C71523D7B7D2C24523D7B7D3B636C6173732055527B63';
wwv_flow_imp.g_varchar2_table(47008) := '6F6E7374727563746F7228652C742C6E2C69297B746869732E747970653D652C746869732E66726F6D3D742C746869732E746F3D6E2C746869732E736964653D697D7D6C6574204B523D2F5B2122232425262728292A2B2C5C2D2E5C2F3A3B3C3D3E3F40';
wwv_flow_imp.g_varchar2_table(47009) := '5C5B5C5C5C5D5E5F607B7C7D7E5C7841315C75323031302D5C75323032375D2F3B7472797B4B523D6E65772052656745787028225B5C5C707B537D7C5C5C707B507D5D222C227522297D636174636828746C297B7D636F6E73742047523D7B4573636170';
wwv_flow_imp.g_varchar2_table(47010) := '6528652C742C6E297B6966283932213D747C7C6E3D3D652E656E642D312972657475726E2D313B6C657420693D652E63686172286E2B31293B666F72286C657420743D303B743C33323B742B2B2969662822215C22232425262728292A2B2C2D2E2F3A3B';
wwv_flow_imp.g_varchar2_table(47011) := '3C3D3E3F405B5C5C5D5E5F607B7C7D7E222E63686172436F646541742874293D3D692972657475726E20652E617070656E642848522865522E4573636170652C6E2C6E2B3229293B72657475726E2D317D2C456E7469747928652C742C6E297B69662833';
wwv_flow_imp.g_varchar2_table(47012) := '38213D742972657475726E2D313B6C657420693D2F5E283F3A235C642B7C23785B612D665C645D2B7C5C772B293B2F692E6578656328652E736C696365286E2B312C6E2B333129293B72657475726E20693F652E617070656E642848522865522E456E74';
wwv_flow_imp.g_varchar2_table(47013) := '6974792C6E2C6E2B312B695B305D2E6C656E67746829293A2D317D2C496E6C696E65436F646528652C742C6E297B6966283936213D747C7C6E262639363D3D652E63686172286E2D31292972657475726E2D313B6C657420693D6E2B313B666F72283B69';
wwv_flow_imp.g_varchar2_table(47014) := '3C652E656E64262639363D3D652E636861722869293B29692B2B3B6C6574206F3D692D6E2C733D303B666F72283B693C652E656E643B692B2B2969662839363D3D652E63686172286929297B696628732B2B2C733D3D6F26263936213D652E6368617228';
wwv_flow_imp.g_varchar2_table(47015) := '692B31292972657475726E20652E617070656E642848522865522E496E6C696E65436F64652C6E2C692B312C5B48522865522E436F64654D61726B2C6E2C6E2B6F292C48522865522E436F64654D61726B2C692B312D6F2C692B31295D29297D656C7365';
wwv_flow_imp.g_varchar2_table(47016) := '20733D303B72657475726E2D317D2C48544D4C54616728652C742C6E297B6966283630213D747C7C6E3D3D652E656E642D312972657475726E2D313B6C657420693D652E736C696365286E2B312C652E656E64292C6F3D2F5E283F3A5B612D7A5D5B2D5C';
wwv_flow_imp.g_varchar2_table(47017) := '772B2E5D2B3A5B5E5C733E5D2B7C5B612D7A5C642E2123242526272A2B2F3D3F5E5F607B7C7D7E2D5D2B405B612D7A5C645D283F3A5B612D7A5C642D5D7B302C36317D5B612D7A5C645D293F283F3A5C2E5B612D7A5C645D283F3A5B612D7A5C642D5D7B';
wwv_flow_imp.g_varchar2_table(47018) := '302C36317D5B612D7A5C645D293F292A293E2F692E657865632869293B6966286F2972657475726E20652E617070656E642848522865522E4175746F6C696E6B2C6E2C6E2B312B6F5B305D2E6C656E6774682C5B48522865522E4C696E6B4D61726B2C6E';
wwv_flow_imp.g_varchar2_table(47019) := '2C6E2B31292C48522865522E55524C2C6E2B312C6E2B6F5B305D2E6C656E677468292C48522865522E4C696E6B4D61726B2C6E2B6F5B305D2E6C656E6774682C6E2B312B6F5B305D2E6C656E677468295D29293B6C657420733D2F5E212D2D5B5E3E5D28';
wwv_flow_imp.g_varchar2_table(47020) := '3F3A2D5B5E2D5D7C5B5E2D5D292A3F2D2D3E2F692E657865632869293B696628732972657475726E20652E617070656E642848522865522E436F6D6D656E742C6E2C6E2B312B735B305D2E6C656E67746829293B6C657420723D2F5E5C3F5B5E5D2A3F5C';
wwv_flow_imp.g_varchar2_table(47021) := '3F3E2F2E657865632869293B696628722972657475726E20652E617070656E642848522865522E50726F63657373696E67496E737472756374696F6E2C6E2C6E2B312B725B305D2E6C656E67746829293B6C657420613D2F5E283F3A215B412D5A5D5B5E';
wwv_flow_imp.g_varchar2_table(47022) := '5D2A3F3E7C215C5B43444154415C5B5B5E5D2A3F5C5D5C5D3E7C5C2F5C732A5B612D7A412D5A5D5B5C772D5D2A5C732A3E7C5C732A5B612D7A412D5A5D5B5C772D5D2A285C732B5B612D7A412D5A3A5F5D5B5C772D2E3A5D2A283F3A5C732A3D5C732A28';
wwv_flow_imp.g_varchar2_table(47023) := '3F3A5B5E5C7322273D3C3E605D2B7C275B5E275D2A277C225B5E225D2A2229293F292A5C732A285C2F5C732A293F3E292F2E657865632869293B72657475726E20613F652E617070656E642848522865522E48544D4C5461672C6E2C6E2B312B615B305D';
wwv_flow_imp.g_varchar2_table(47024) := '2E6C656E67746829293A2D317D2C456D70686173697328652C742C6E297B6966283935213D7426263432213D742972657475726E2D313B6C657420693D6E2B313B666F72283B652E636861722869293D3D743B29692B2B3B6C6574206F3D652E736C6963';
wwv_flow_imp.g_varchar2_table(47025) := '65286E2D312C6E292C733D652E736C69636528692C692B31292C723D4B522E74657374286F292C613D4B522E746573742873292C6C3D2F5C737C5E242F2E74657374286F292C633D2F5C737C5E242F2E746573742873292C643D216326262821617C7C6C';
wwv_flow_imp.g_varchar2_table(47026) := '7C7C72292C683D216C26262821727C7C637C7C61292C753D6426262834323D3D747C7C21687C7C72292C703D6826262834323D3D747C7C21647C7C61293B72657475726E20652E617070656E64286E65772055522839353D3D743F57523A6A522C6E2C69';
wwv_flow_imp.g_varchar2_table(47027) := '2C28753F313A30297C28703F323A302929297D2C48617264427265616B28652C742C6E297B69662839323D3D74262631303D3D652E63686172286E2B31292972657475726E20652E617070656E642848522865522E48617264427265616B2C6E2C6E2B32';
wwv_flow_imp.g_varchar2_table(47028) := '29293B69662833323D3D74297B6C657420743D6E2B313B666F72283B33323D3D652E636861722874293B29742B2B3B69662831303D3D652E636861722874292626743E3D6E2B322972657475726E20652E617070656E642848522865522E486172644272';
wwv_flow_imp.g_varchar2_table(47029) := '65616B2C6E2C742B3129297D72657475726E2D317D2C4C696E6B3A28652C742C6E293D3E39313D3D743F652E617070656E64286E65772055522871522C6E2C6E2B312C3129293A2D312C496D6167653A28652C742C6E293D3E33333D3D74262639313D3D';
wwv_flow_imp.g_varchar2_table(47030) := '652E63686172286E2B31293F652E617070656E64286E65772055522824522C6E2C6E2B322C3129293A2D312C4C696E6B456E6428652C742C6E297B6966283933213D742972657475726E2D313B666F72286C657420743D652E70617274732E6C656E6774';
wwv_flow_imp.g_varchar2_table(47031) := '682D313B743E3D303B742D2D297B6C657420693D652E70617274735B745D3B6966286920696E7374616E63656F66205552262628692E747970653D3D71527C7C692E747970653D3D245229297B69662821692E736964657C7C652E736B69705370616365';
wwv_flow_imp.g_varchar2_table(47032) := '28692E746F293D3D6E2626212F5B285C5B5D2F2E7465737428652E736C696365286E2B312C6E2B3229292972657475726E20652E70617274735B745D3D6E756C6C2C2D313B6C6574206F3D652E74616B65436F6E74656E742874292C733D652E70617274';
wwv_flow_imp.g_varchar2_table(47033) := '735B745D3D515228652C6F2C692E747970653D3D71523F65522E4C696E6B3A65522E496D6167652C692E66726F6D2C6E2B31293B696628692E747970653D3D715229666F72286C6574206E3D303B6E3C743B6E2B2B297B6C657420743D652E7061727473';
wwv_flow_imp.g_varchar2_table(47034) := '5B6E5D3B7420696E7374616E63656F662055522626742E747970653D3D7152262628742E736964653D30297D72657475726E20732E746F7D7D72657475726E2D317D7D3B66756E6374696F6E20515228652C742C6E2C692C6F297B6C65747B746578743A';
wwv_flow_imp.g_varchar2_table(47035) := '737D3D652C723D652E63686172286F292C613D6F3B696628742E756E73686966742848522865522E4C696E6B4D61726B2C692C692B286E3D3D65522E496D6167653F323A312929292C742E707573682848522865522E4C696E6B4D61726B2C6F2D312C6F';
wwv_flow_imp.g_varchar2_table(47036) := '29292C34303D3D72297B6C6574206E2C693D652E736B69705370616365286F2B31292C723D595228732C692D652E6F66667365742C652E6F6666736574293B72262628693D652E736B6970537061636528722E746F292C69213D722E746F2626286E3D5A';
wwv_flow_imp.g_varchar2_table(47037) := '5228732C692D652E6F66667365742C652E6F6666736574292C6E262628693D652E736B69705370616365286E2E746F292929292C34313D3D652E63686172286929262628742E707573682848522865522E4C696E6B4D61726B2C6F2C6F2B3129292C613D';
wwv_flow_imp.g_varchar2_table(47038) := '692B312C722626742E707573682872292C6E2626742E70757368286E292C742E707573682848522865522E4C696E6B4D61726B2C692C612929297D656C73652069662839313D3D72297B6C6574206E3D585228732C6F2D652E6F66667365742C652E6F66';
wwv_flow_imp.g_varchar2_table(47039) := '667365742C2131293B6E262628742E70757368286E292C613D6E2E746F297D72657475726E204852286E2C692C612C74297D66756E6374696F6E20595228652C742C6E297B69662836303D3D652E63686172436F64654174287429297B666F72286C6574';
wwv_flow_imp.g_varchar2_table(47040) := '20693D742B313B693C652E6C656E6774683B692B2B297B6C6574206F3D652E63686172436F646541742869293B69662836323D3D6F2972657475726E2048522865522E55524C2C742B6E2C692B312B6E293B69662836303D3D6F7C7C31303D3D6F297265';
wwv_flow_imp.g_varchar2_table(47041) := '7475726E21317D72657475726E206E756C6C7D7B6C657420693D302C6F3D743B666F72286C657420743D21313B6F3C652E6C656E6774683B6F2B2B297B6C6574206E3D652E63686172436F64654174286F293B6966287352286E2929627265616B3B6966';
wwv_flow_imp.g_varchar2_table(47042) := '287429743D21313B656C73652069662834303D3D6E29692B2B3B656C73652069662834313D3D6E297B696628216929627265616B3B692D2D7D656C73652039323D3D6E262628743D2130297D72657475726E206F3E743F48522865522E55524C2C742B6E';
wwv_flow_imp.g_varchar2_table(47043) := '2C6F2B6E293A6F3D3D652E6C656E67746826266E756C6C7D7D66756E6374696F6E205A5228652C742C6E297B6C657420693D652E63686172436F646541742874293B6966283339213D6926263334213D6926263430213D692972657475726E21313B6C65';
wwv_flow_imp.g_varchar2_table(47044) := '74206F3D34303D3D693F34313A693B666F72286C657420693D742B312C733D21313B693C652E6C656E6774683B692B2B297B6C657420723D652E63686172436F646541742869293B6966287329733D21313B656C73657B696628723D3D6F297265747572';
wwv_flow_imp.g_varchar2_table(47045) := '6E2048522865522E4C696E6B5469746C652C742B6E2C692B312B6E293B39323D3D72262628733D2130297D7D72657475726E206E756C6C7D66756E6374696F6E20585228652C742C6E2C69297B666F72286C6574206F3D21312C733D742B312C723D4D61';
wwv_flow_imp.g_varchar2_table(47046) := '74682E6D696E28652E6C656E6774682C732B393939293B733C723B732B2B297B6C657420723D652E63686172436F646541742873293B6966286F296F3D21313B656C73657B69662839333D3D722972657475726E2169262648522865522E4C696E6B4C61';
wwv_flow_imp.g_varchar2_table(47047) := '62656C2C742B6E2C732B312B6E293B696628692626217352287229262628693D2131292C39313D3D722972657475726E21313B39323D3D722626286F3D2130297D7D72657475726E206E756C6C7D636C617373204A527B636F6E7374727563746F722865';
wwv_flow_imp.g_varchar2_table(47048) := '2C742C6E297B746869732E7061727365723D652C746869732E746578743D742C746869732E6F66667365743D6E2C746869732E70617274733D5B5D7D636861722865297B72657475726E20653E3D746869732E656E643F2D313A746869732E746578742E';
wwv_flow_imp.g_varchar2_table(47049) := '63686172436F6465417428652D746869732E6F6666736574297D67657420656E6428297B72657475726E20746869732E6F66667365742B746869732E746578742E6C656E6774687D736C69636528652C74297B72657475726E20746869732E746578742E';
wwv_flow_imp.g_varchar2_table(47050) := '736C69636528652D746869732E6F66667365742C742D746869732E6F6666736574297D617070656E642865297B72657475726E20746869732E70617274732E707573682865292C652E746F7D61646444656C696D6974657228652C742C6E2C692C6F297B';
wwv_flow_imp.g_varchar2_table(47051) := '72657475726E20746869732E617070656E64286E657720555228652C742C6E2C28693F313A30297C286F3F323A302929297D676574206861734F70656E4C696E6B28297B666F72286C657420653D746869732E70617274732E6C656E6774682D313B653E';
wwv_flow_imp.g_varchar2_table(47052) := '3D303B652D2D297B6C657420743D746869732E70617274735B655D3B6966287420696E7374616E63656F66205552262628742E747970653D3D71527C7C742E747970653D3D2452292972657475726E21307D72657475726E21317D616464456C656D656E';
wwv_flow_imp.g_varchar2_table(47053) := '742865297B72657475726E20746869732E617070656E642865297D7265736F6C76654D61726B6572732865297B666F72286C657420743D653B743C746869732E70617274732E6C656E6774683B742B2B297B6C6574206E3D746869732E70617274735B74';
wwv_flow_imp.g_varchar2_table(47054) := '5D3B69662821286E20696E7374616E63656F6620555226266E2E747970652E7265736F6C7665262632266E2E736964652929636F6E74696E75653B6C657420692C6F3D6E2E747970653D3D57527C7C6E2E747970653D3D6A522C733D6E2E746F2D6E2E66';
wwv_flow_imp.g_varchar2_table(47055) := '726F6D2C723D742D313B666F72283B723E3D653B722D2D297B6C657420653D746869732E70617274735B725D3B6966286520696E7374616E63656F6620555226263126652E736964652626652E747970653D3D6E2E74797065262621286F26262831266E';
wwv_flow_imp.g_varchar2_table(47056) := '2E736964657C7C3226652E7369646529262628652E746F2D652E66726F6D2B732925333D3D3026262828652E746F2D652E66726F6D2925337C7C7325332929297B693D653B627265616B7D7D696628216929636F6E74696E75653B6C657420613D6E2E74';
wwv_flow_imp.g_varchar2_table(47057) := '7970652E7265736F6C76652C6C3D5B5D2C633D692E66726F6D2C643D6E2E746F3B6966286F297B6C657420653D4D6174682E6D696E28322C692E746F2D692E66726F6D2C73293B633D692E746F2D652C643D6E2E66726F6D2B652C613D313D3D653F2245';
wwv_flow_imp.g_varchar2_table(47058) := '6D706861736973223A225374726F6E67456D706861736973227D692E747970652E6D61726B26266C2E7075736828746869732E656C7428692E747970652E6D61726B2C632C692E746F29293B666F72286C657420653D722B313B653C743B652B2B297468';
wwv_flow_imp.g_varchar2_table(47059) := '69732E70617274735B655D696E7374616E63656F6620565226266C2E7075736828746869732E70617274735B655D292C746869732E70617274735B655D3D6E756C6C3B6E2E747970652E6D61726B26266C2E7075736828746869732E656C74286E2E7479';
wwv_flow_imp.g_varchar2_table(47060) := '70652E6D61726B2C6E2E66726F6D2C6429293B6C657420683D746869732E656C7428612C632C642C6C293B746869732E70617274735B725D3D6F2626692E66726F6D213D633F6E657720555228692E747970652C692E66726F6D2C632C692E7369646529';
wwv_flow_imp.g_varchar2_table(47061) := '3A6E756C6C2C28746869732E70617274735B745D3D6F26266E2E746F213D643F6E6577205552286E2E747970652C642C6E2E746F2C6E2E73696465293A6E756C6C293F746869732E70617274732E73706C69636528742C302C68293A746869732E706172';
wwv_flow_imp.g_varchar2_table(47062) := '74735B745D3D687D6C657420743D5B5D3B666F72286C6574206E3D653B6E3C746869732E70617274732E6C656E6774683B6E2B2B297B6C657420653D746869732E70617274735B6E5D3B6520696E7374616E63656F662056522626742E70757368286529';
wwv_flow_imp.g_varchar2_table(47063) := '7D72657475726E20747D66696E644F70656E696E6744656C696D697465722865297B666F72286C657420743D746869732E70617274732E6C656E6774682D313B743E3D303B742D2D297B6C6574206E3D746869732E70617274735B745D3B6966286E2069';
wwv_flow_imp.g_varchar2_table(47064) := '6E7374616E63656F6620555226266E2E747970653D3D652972657475726E20747D72657475726E206E756C6C7D74616B65436F6E74656E742865297B6C657420743D746869732E7265736F6C76654D61726B6572732865293B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(47065) := '2E70617274732E6C656E6774683D652C747D736B697053706163652865297B72657475726E20725228746869732E746578742C652D746869732E6F6666736574292B746869732E6F66667365747D656C7428652C742C6E2C69297B72657475726E227374';
wwv_flow_imp.g_varchar2_table(47066) := '72696E67223D3D747970656F6620653F485228746869732E7061727365722E6765744E6F6465547970652865292C742C6E2C69293A6E6577207A5228652C74297D7D66756E6374696F6E20654628652C74297B69662821742E6C656E6774682972657475';
wwv_flow_imp.g_varchar2_table(47067) := '726E20653B69662821652E6C656E6774682972657475726E20743B6C6574206E3D652E736C69636528292C693D303B666F72286C65742065206F662074297B666F72283B693C6E2E6C656E67746826266E5B695D2E746F3C652E746F3B29692B2B3B6966';
wwv_flow_imp.g_varchar2_table(47068) := '28693C6E2E6C656E67746826266E5B695D2E66726F6D3C652E66726F6D297B6C657420743D6E5B695D3B7420696E7374616E63656F662056522626286E5B695D3D6E657720565228742E747970652C742E66726F6D2C742E746F2C654628742E6368696C';
wwv_flow_imp.g_varchar2_table(47069) := '6472656E2C5B655D2929297D656C7365206E2E73706C69636528692B2B2C302C65297D72657475726E206E7D636F6E73742074463D5B65522E436F6465426C6F636B2C65522E4C6973744974656D2C65522E4F7264657265644C6973742C65522E42756C';
wwv_flow_imp.g_varchar2_table(47070) := '6C65744C6973745D3B636C617373206E467B636F6E7374727563746F7228652C74297B746869732E667261676D656E74733D652C746869732E696E7075743D742C746869732E693D302C746869732E667261676D656E743D6E756C6C2C746869732E6672';
wwv_flow_imp.g_varchar2_table(47071) := '61676D656E74456E643D2D312C746869732E637572736F723D6E756C6C2C652E6C656E677468262628746869732E667261676D656E743D655B746869732E692B2B5D297D6E657874467261676D656E7428297B746869732E667261676D656E743D746869';
wwv_flow_imp.g_varchar2_table(47072) := '732E693C746869732E667261676D656E74732E6C656E6774683F746869732E667261676D656E74735B746869732E692B2B5D3A6E756C6C2C746869732E637572736F723D6E756C6C2C746869732E667261676D656E74456E643D2D317D6D6F7665546F28';
wwv_flow_imp.g_varchar2_table(47073) := '652C74297B666F72283B746869732E667261676D656E742626746869732E667261676D656E742E746F3C3D653B29746869732E6E657874467261676D656E7428293B69662821746869732E667261676D656E747C7C746869732E667261676D656E742E66';
wwv_flow_imp.g_varchar2_table(47074) := '726F6D3E28653F652D313A30292972657475726E21313B696628746869732E667261676D656E74456E643C30297B6C657420653D746869732E667261676D656E742E746F3B666F72283B653E302626225C6E22213D746869732E696E7075742E72656164';
wwv_flow_imp.g_varchar2_table(47075) := '28652D312C65293B29652D2D3B746869732E667261676D656E74456E643D653F652D313A307D6C6574206E3D746869732E637572736F723B6E7C7C286E3D746869732E637572736F723D746869732E667261676D656E742E747265652E637572736F7228';
wwv_flow_imp.g_varchar2_table(47076) := '292C6E2E66697273744368696C642829293B6C657420693D652B746869732E667261676D656E742E6F66667365743B666F72283B6E2E746F3C3D693B29696628216E2E706172656E7428292972657475726E21313B666F72283B3B297B6966286E2E6672';
wwv_flow_imp.g_varchar2_table(47077) := '6F6D3E3D692972657475726E20746869732E667261676D656E742E66726F6D3C3D743B696628216E2E6368696C6441667465722869292972657475726E21317D7D6D6174636865732865297B6C657420743D746869732E637572736F722E747265653B72';
wwv_flow_imp.g_varchar2_table(47078) := '657475726E20742626742E70726F702858432E636F6E7465787448617368293D3D657D74616B654E6F6465732865297B6C657420743D746869732E637572736F722C6E3D746869732E667261676D656E742E6F66667365742C693D746869732E66726167';
wwv_flow_imp.g_varchar2_table(47079) := '6D656E74456E642D28746869732E667261676D656E742E6F70656E456E643F313A30292C6F3D652E6162736F6C7574654C696E6553746172742C733D6F2C723D652E626C6F636B2E6368696C6472656E2E6C656E6774682C613D732C6C3D723B666F7228';
wwv_flow_imp.g_varchar2_table(47080) := '3B3B297B696628742E746F2D6E3E69297B696628742E747970652E6973416E6F6E796D6F75732626742E66697273744368696C64282929636F6E74696E75653B627265616B7D6C6574206F3D694628742E66726F6D2D6E2C652E72616E676573293B6966';
wwv_flow_imp.g_varchar2_table(47081) := '28742E746F2D6E3C3D652E72616E6765735B652E72616E6765495D2E746F29652E6164644E6F646528742E747265652C6F293B656C73657B6C6574206E3D6E657720725328652E7061727365722E6E6F64655365742E74797065735B65522E5061726167';
wwv_flow_imp.g_varchar2_table(47082) := '726170685D2C5B5D2C5B5D2C302C652E626C6F636B2E6861736850726F70293B652E7265757365506C616365686F6C646572732E736574286E2C742E74726565292C652E6164644E6F6465286E2C6F297D696628742E747970652E69732822426C6F636B';
wwv_flow_imp.g_varchar2_table(47083) := '222926262874462E696E6465784F6628742E747970652E6964293C303F28733D742E746F2D6E2C723D652E626C6F636B2E6368696C6472656E2E6C656E677468293A28733D612C723D6C2C613D742E746F2D6E2C6C3D652E626C6F636B2E6368696C6472';
wwv_flow_imp.g_varchar2_table(47084) := '656E2E6C656E67746829292C21742E6E6578745369626C696E67282929627265616B7D666F72283B652E626C6F636B2E6368696C6472656E2E6C656E6774683E723B29652E626C6F636B2E6368696C6472656E2E706F7028292C652E626C6F636B2E706F';
wwv_flow_imp.g_varchar2_table(47085) := '736974696F6E732E706F7028293B72657475726E20732D6F7D7D66756E6374696F6E20694628652C74297B6C6574206E3D653B666F72286C657420693D313B693C742E6C656E6774683B692B2B297B6C6574206F3D745B692D315D2E746F2C733D745B69';
wwv_flow_imp.g_varchar2_table(47086) := '5D2E66726F6D3B6F3C652626286E2D3D732D6F297D72657475726E206E7D636F6E7374206F463D6D78287B22426C6F636B71756F74652F2E2E2E223A52782E71756F74652C486F72697A6F6E74616C52756C653A52782E636F6E74656E74536570617261';
wwv_flow_imp.g_varchar2_table(47087) := '746F722C2241545848656164696E67312F2E2E2E2053657465787448656164696E67312F2E2E2E223A52782E68656164696E67312C2241545848656164696E67322F2E2E2E2053657465787448656164696E67322F2E2E2E223A52782E68656164696E67';
wwv_flow_imp.g_varchar2_table(47088) := '322C2241545848656164696E67332F2E2E2E223A52782E68656164696E67332C2241545848656164696E67342F2E2E2E223A52782E68656164696E67342C2241545848656164696E67352F2E2E2E223A52782E68656164696E67352C2241545848656164';
wwv_flow_imp.g_varchar2_table(47089) := '696E67362F2E2E2E223A52782E68656164696E67362C22436F6D6D656E7420436F6D6D656E74426C6F636B223A52782E636F6D6D656E742C4573636170653A52782E6573636170652C456E746974793A52782E6368617261637465722C22456D70686173';
wwv_flow_imp.g_varchar2_table(47090) := '69732F2E2E2E223A52782E656D7068617369732C225374726F6E67456D7068617369732F2E2E2E223A52782E7374726F6E672C224C696E6B2F2E2E2E20496D6167652F2E2E2E223A52782E6C696E6B2C224F7264657265644C6973742F2E2E2E2042756C';
wwv_flow_imp.g_varchar2_table(47091) := '6C65744C6973742F2E2E2E223A52782E6C6973742C22426C6F636B51756F74652F2E2E2E223A52782E71756F74652C22496E6C696E65436F646520436F646554657874223A52782E6D6F6E6F73706163652C2255524C204175746F6C696E6B223A52782E';
wwv_flow_imp.g_varchar2_table(47092) := '75726C2C224865616465724D61726B2048617264427265616B2051756F74654D61726B204C6973744D61726B204C696E6B4D61726B20456D7068617369734D61726B20436F64654D61726B223A52782E70726F63657373696E67496E737472756374696F';
wwv_flow_imp.g_varchar2_table(47093) := '6E2C22436F6465496E666F204C696E6B4C6162656C223A52782E6C6162656C4E616D652C4C696E6B5469746C653A52782E737472696E672C5061726167726170683A52782E636F6E74656E747D292C73463D6E6577204152286E6577206E53285252292E';
wwv_flow_imp.g_varchar2_table(47094) := '657874656E64286F46292C4F626A6563742E6B657973285352292E6D61702828653D3E53525B655D29292C4F626A6563742E6B657973285352292E6D61702828653D3E4C525B655D29292C4F626A6563742E6B657973285352292C44522C6F522C4F626A';
wwv_flow_imp.g_varchar2_table(47095) := '6563742E6B657973284752292E6D61702828653D3E47525B655D29292C4F626A6563742E6B657973284752292C5B5D293B52782E737472696B657468726F7567682C52782E70726F63657373696E67496E737472756374696F6E3B52782E68656164696E';
wwv_flow_imp.g_varchar2_table(47096) := '672C52782E636F6E74656E742C52782E70726F63657373696E67496E737472756374696F6E3B66756E6374696F6E20724628652C742C6E297B72657475726E28692C6F2C73293D3E7B6966286F213D657C7C692E6368617228732B31293D3D6529726574';
wwv_flow_imp.g_varchar2_table(47097) := '75726E2D313B6C657420723D5B692E656C74286E2C732C732B31295D3B666F72286C6574206F3D732B313B6F3C692E656E643B6F2B2B297B6C657420613D692E63686172286F293B696628613D3D652972657475726E20692E616464456C656D656E7428';
wwv_flow_imp.g_varchar2_table(47098) := '692E656C7428742C732C6F2B312C722E636F6E63617428692E656C74286E2C6F2C6F2B31292929293B69662839323D3D612626722E7075736828692E656C742822457363617065222C6F2C322B6F2B2B29292C735228612929627265616B7D7265747572';
wwv_flow_imp.g_varchar2_table(47099) := '6E2D317D7D52782E6C6973742C52782E61746F6D2C52782E7370656369616C2852782E636F6E74656E74292C52782E70726F63657373696E67496E737472756374696F6E2C72462839342C225375706572736372697074222C2253757065727363726970';
wwv_flow_imp.g_varchar2_table(47100) := '744D61726B22292C52782E7370656369616C2852782E636F6E74656E74292C52782E70726F63657373696E67496E737472756374696F6E2C7246283132362C22537562736372697074222C225375627363726970744D61726B22292C52782E6368617261';
wwv_flow_imp.g_varchar2_table(47101) := '637465723B636F6E73742061463D3132322C6C463D3132332C63463D3132382C64463D342C68463D3133312C75463D372C70463D382C67463D392C6D463D31302C66463D3133392C76463D31392C62463D3134302C5F463D32332C79463D3134312C7746';
wwv_flow_imp.g_varchar2_table(47102) := '3D32372C43463D33372C53463D34312C78463D3134352C6B463D3134362C45463D3134372C4C463D3134382C44463D34372C54463D36382C49463D3135342C4D463D37302C41463D3135352C4E463D37322C50463D3135362C4F463D37362C52463D3136';
wwv_flow_imp.g_varchar2_table(47103) := '312C46463D37392C42463D38302C56463D38312C7A463D3136372C48463D38392C57463D39302C6A463D3136392C71463D39372C24463D3137312C55463D39382C4B463D3130302C47463D3130312C51463D22756E646566696E656422213D747970656F';
wwv_flow_imp.g_varchar2_table(47104) := '662070726F63657373262670726F636573732E656E7626262F5C62667061727365283A646267293F5C622F2E746573742870726F636573732E656E762E4C4F47292C59463D22756E646566696E656422213D747970656F662070726F6365737326267072';
wwv_flow_imp.g_varchar2_table(47105) := '6F636573732E656E7626262F5C626670617273653A6462675C622F2E746573742870726F636573732E656E762E4C4F47292C5A463D22756E646566696E656422213D747970656F662070726F63657373262670726F636573732E656E7626262F5C62636F';
wwv_flow_imp.g_varchar2_table(47106) := '6E746578745C622F2E746573742870726F636573732E656E762E4C4F47292C58463D5B392C31312C31322C33322C3133332C3136302C353736302C383139322C383139332C383139342C383139352C383139362C383139372C383139382C383139392C38';
wwv_flow_imp.g_varchar2_table(47107) := '3230302C383230312C383230322C383233322C383233332C383233392C383238372C31323238385D2C4A463D6E4228225C6E5C7222292C65423D222A222E63686172436F646541742830292C74423D6E422822272E2F2D2B2A5E22293B66756E6374696F';
wwv_flow_imp.g_varchar2_table(47108) := '6E206E422865297B72657475726E2041727261792E66726F6D2865292E6D61702828653D3E652E63686172436F6465417428302929297D66756E6374696F6E2069422865297B72657475726E20653E3D34382626653C3D35377C7C3138333D3D3D657C7C';
wwv_flow_imp.g_varchar2_table(47109) := '653E3D3736382626653C3D3837397C7C653E3D383235352626653C3D383235367D66756E6374696F6E206F4228652C74297B72657475726E20742E636F6E63617428652E73706C6974282F5C6E2F67292E6A6F696E28225C6E222B7429297D66756E6374';
wwv_flow_imp.g_varchar2_table(47110) := '696F6E20734228652C743D30297B636F6E7374206E3D652E7065656B2874293B72657475726E206E3D3D3D65422626652E7065656B28742B31293D3D3D65423F7B6F66667365743A322C746F6B656E3A222A2A227D3A28693D6E2C74422E696E636C7564';
wwv_flow_imp.g_varchar2_table(47111) := '65732869293F7B6F66667365743A312C746F6B656E3A537472696E672E66726F6D43686172436F6465286E297D3A6E756C6C293B76617220697D66756E6374696F6E20724228652C743D302C6E3D2131297B666F72286C6574206F3D21312C733D5B5D2C';
wwv_flow_imp.g_varchar2_table(47112) := '723D303B3B722B2B297B636F6E737420613D652E7065656B28742B72293B696628212836333D3D3D28693D61297C7C693E3D36352626693C3D39307C7C39353D3D3D697C7C693E3D39372626693C3D3132327C7C693E3D3139322626693C3D3231347C7C';
wwv_flow_imp.g_varchar2_table(47113) := '693E3D3231362626693C3D3234367C7C693E3D3234382626693C3D3736377C7C693E3D3838302626693C3D3839337C7C693E3D3839352626693C3D383139317C7C693E3D383230342626693C3D383230357C7C693E3D383330342626693C3D383539317C';
wwv_flow_imp.g_varchar2_table(47114) := '7C693E3D31313236342626693C3D31323237317C7C693E3D31323238392626693C3D35353239357C7C693E3D36333734342626693C3D36343937357C7C693E3D36353030382626693C3D36353533337C7C693E3D35353239362626693C3D35363331397C';
wwv_flow_imp.g_varchar2_table(47115) := '7C693E3D35363332302626693C3D35373334337C7C286F7C7C6E2926266942286129292972657475726E20732E6C656E6774683F7B746F6B656E3A537472696E672E66726F6D43686172436F6465282E2E2E73292C6F66667365743A727D3A6E756C6C3B';
wwv_flow_imp.g_varchar2_table(47116) := '6F7C7C286F3D2130292C732E707573682861297D76617220697D66756E6374696F6E20614228652C74297B666F72286C657420693D21312C6F3D303B3B6F2B2B297B6966286E3D652E7065656B28742B6F292C2158462E696E636C75646573286E292972';
wwv_flow_imp.g_varchar2_table(47117) := '657475726E20693F7B746F6B656E3A2220222C6F66667365743A6F7D3A6E756C6C3B697C7C28693D2130297D766172206E7D636F6E7374206C423D7B5B61465D3A226964656E746966696572222C5B6C465D3A226E616D654964656E746966696572227D';
wwv_flow_imp.g_varchar2_table(47118) := '2C63423D6E6577205153282828652C74293D3E7B59462626636F6E736F6C652E6C6F67282225733A2054203C6964656E746966696572207C206E616D654964656E7469666965723E222C652E706F73293B636F6E7374206E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(47119) := '74297B636F6E7374206E3D742E636F6E746578744B65797328292C693D742E746F6B656E733B666F72286C657420743D302C6F3D5B5D2C733D6E756C6C3B3B297B636F6E737420723D692E6C656E6774682B6F2E6C656E6774683E302C613D6F2E6C656E';
wwv_flow_imp.g_varchar2_table(47120) := '6774683E302C6C3D724228652C742C72297C7C722626734228652C74297C7C612626614228652C74293B696628216C2972657475726E20733B636F6E73747B746F6B656E3A632C6F66667365743A647D3D6C3B696628742B3D642C2220223D3D3D632963';
wwv_flow_imp.g_varchar2_table(47121) := '6F6E74696E75653B6F3D5B2E2E2E6F2C635D3B636F6E737420683D5B2E2E2E692C2E2E2E6F5D2E6A6F696E28222022293B6966286E2E736F6D652828653D3E653D3D3D682929297B636F6E737420653D6F5B305D3B733D7B746F6B656E3A652C6F666673';
wwv_flow_imp.g_varchar2_table(47122) := '65743A652E6C656E6774682C7465726D3A3132337D7D696628216E2E736F6D652828653D3E652E737461727473576974682868292929297B69662866422E736F6D652828653D3E653D3D3D682929297B636F6E737420653D6F5B305D3B733D7B746F6B65';
wwv_flow_imp.g_varchar2_table(47123) := '6E3A652C6F66667365743A652E6C656E6774682C7465726D3A3132327D7D6966282166422E736F6D652828653D3E652E7374617274735769746828682929292972657475726E20737D7D7D28652C742E636F6E74657874292C693D742E636F6E74657874';
wwv_flow_imp.g_varchar2_table(47124) := '2E746F6B656E732C6F3D6E7C7C724228652C302C692E6C656E6774683E30293B6F262628652E616476616E6365286F2E6F6666736574292C652E616363657074546F6B656E286E3F6E2E7465726D3A313232292C51462626636F6E736F6C652E6C6F6728';
wwv_flow_imp.g_varchar2_table(47125) := '2225733A204D41544348203C25733E203C25733E222C652E706F732C6E3F6C425B6E2E7465726D5D3A226964656E746966696572222C6F2E746F6B656E29297D292C7B636F6E7465787475616C3A21307D292C64423D6E6577205153282828652C74293D';
wwv_flow_imp.g_varchar2_table(47126) := '3E7B59462626636F6E736F6C652E6C6F67282225733A2054203C70726F70657274794964656E7469666965723E222C652E706F73293B636F6E7374206E3D724228652C302C742E636F6E746578742E746F6B656E732E6C656E6774683E30293B6E262628';
wwv_flow_imp.g_varchar2_table(47127) := '652E616476616E6365286E2E6F6666736574292C652E616363657074546F6B656E28313231292C51462626636F6E736F6C652E6C6F67282225733A204D41544348203C70726F70657274794964656E7469666965723E203C25733E222C652E706F732C6E';
wwv_flow_imp.g_varchar2_table(47128) := '2E746F6B656E29297D29292C68423D6E6577205153282828652C74293D3E7B6C6574206E3B59462626636F6E736F6C652E6C6F67282225733A2054203C696E7365727453656D693E222C652E706F73293B6C657420693D21313B666F72286E3D303B3B6E';
wwv_flow_imp.g_varchar2_table(47129) := '2B2B297B636F6E737420743D652E7065656B286E293B6966282158462E696E636C75646573287429297B4A462E696E636C75646573287429262628693D2130293B627265616B7D7D69662869297B636F6E737420743D724228652C6E2B31293B69662861';
wwv_flow_imp.g_varchar2_table(47130) := '4228652C6E2B31297C7C7426262F5E287468656E7C656C73657C72657475726E7C73617469736669657329242F2E7465737428742E746F6B656E292972657475726E3B51462626636F6E736F6C652E6C6F67282225733A204D41544348203C696E736572';
wwv_flow_imp.g_varchar2_table(47131) := '7453656D693E222C652E706F73292C652E616363657074546F6B656E28313234297D7D29292C75423D7B5B50465D3A2246756E6374696F6E496E766F636174696F6E222C5B41465D3A2246696C74657245787072657373696F6E222C5B49465D3A225061';
wwv_flow_imp.g_varchar2_table(47132) := '746845787072657373696F6E227D2C70423D7B5B24465D3A22436F6E74657874222C5B6A465D3A2246756E6374696F6E446566696E6974696F6E222C5B68465D3A22466F7245787072657373696F6E222C5B7A465D3A224C697374222C5B62465D3A2249';
wwv_flow_imp.g_varchar2_table(47133) := '6645787072657373696F6E222C5B79465D3A225175616E74696669656445787072657373696F6E227D2C67423D7B5B71465D3A22436F6E74657874222C5B57465D3A2246756E6374696F6E446566696E6974696F6E222C5B64465D3A22466F7245787072';
wwv_flow_imp.g_varchar2_table(47134) := '657373696F6E222C5B48465D3A224C697374222C5B76465D3A22496645787072657373696F6E222C5B5F465D3A225175616E74696669656445787072657373696F6E222C5B54465D3A225061746845787072657373696F6E222C5B4E465D3A2246756E63';
wwv_flow_imp.g_varchar2_table(47135) := '74696F6E496E766F636174696F6E222C5B4D465D3A2246696C74657245787072657373696F6E222C5B53465D3A2241726974686D6574696345787072657373696F6E227D3B636C617373206D427B636F6E7374727563746F722865297B746869732E666E';
wwv_flow_imp.g_varchar2_table(47136) := '3D657D6765742865297B72657475726E20746869732E666E2865297D737461746963206F662865297B72657475726E206E6577206D422865297D7D636F6E73742066423D4F626A6563742E6B657973287B226461746520616E642074696D65223A312C64';
wwv_flow_imp.g_varchar2_table(47137) := '6174653A312C74696D653A312C6475726174696F6E3A317D293B636C6173732076427B636F6E7374727563746F7228653D7B7D297B746869732E76616C75653D657D6765744B65797328297B72657475726E204F626A6563742E6B65797328746869732E';
wwv_flow_imp.g_varchar2_table(47138) := '76616C7565297D6765742865297B636F6E737420743D746869732E76616C75655B655D2C6E3D746869732E636F6E7374727563746F723B72657475726E206E2E697341746F6D69632874293F743A6E2E6F662874297D73657428652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(47139) := '6E20746869732E636F6E7374727563746F722E6F66287B2E2E2E746869732E76616C75652C5B655D3A747D297D73746174696320697341746F6D69632865297B72657475726E21657C7C6520696E7374616E63656F6620746869737C7C6520696E737461';
wwv_flow_imp.g_varchar2_table(47140) := '6E63656F66206D427C7C226F626A65637422213D747970656F6620657D737461746963206F66282E2E2E65297B636F6E737420743D653D3E652626226F626A656374223D3D747970656F6620653F6520696E7374616E63656F6620746869733F652E7661';
wwv_flow_imp.g_varchar2_table(47141) := '6C75653A7B2E2E2E657D3A7B7D3B72657475726E206E6577207468697328652E726564756365282828652C6E293D3E287B2E2E2E652C2E2E2E74286E297D29292C7B7D29297D7D636C6173732062427B636F6E7374727563746F72287B6E616D653A653D';
wwv_flow_imp.g_varchar2_table(47142) := '2245787072657373696F6E73222C746F6B656E733A743D5B5D2C6368696C6472656E3A6E3D5B5D2C706172656E743A693D6E756C6C2C636F6E746578743A6F3D6E756C6C2C76616C75653A733D6E756C6C2C7261773A723D6E756C6C7D3D7B7D297B7468';
wwv_flow_imp.g_varchar2_table(47143) := '69732E6E616D653D652C746869732E746F6B656E733D742C746869732E6368696C6472656E3D6E2C746869732E706172656E743D692C746869732E636F6E746578743D6F2C746869732E76616C75653D732C746869732E7261773D727D656E7465725363';
wwv_flow_imp.g_varchar2_table(47144) := '6F70652865297B636F6E737420743D746869732E6F66287B6E616D653A652C706172656E743A746869737D293B72657475726E205A462626636F6E736F6C652E6C6F6728225B25735D20656E746572222C742E706174682C742E636F6E74657874292C74';
wwv_flow_imp.g_varchar2_table(47145) := '7D6578697453636F70652865297B72657475726E20746869732E706172656E743F285A462626636F6E736F6C652E6C6F6728225B25735D206578697420256F5C6E2573222C746869732E706174682C746869732E636F6E746578742C6F4228652C222020';
wwv_flow_imp.g_varchar2_table(47146) := '2229292C746869732E706172656E742E707573684368696C64287468697329293A285A462626636F6E736F6C652E6C6F6728225B25735D204E4F206578697420256F5C6E2573222C746869732E706174682C746869732E636F6E746578742C6F4228652C';
wwv_flow_imp.g_varchar2_table(47147) := '2220202229292C74686973297D746F6B656E2865297B72657475726E205A462626636F6E736F6C652E6C6F6728225B25735D20746F6B656E203C25733E202B203C25733E222C746869732E706174682C746869732E746F6B656E732E6A6F696E28222022';
wwv_flow_imp.g_varchar2_table(47148) := '292C65292C746869732E61737369676E287B746F6B656E733A5B2E2E2E746869732E746F6B656E732C655D7D297D6C69746572616C2865297B72657475726E205A462626636F6E736F6C652E6C6F6728225B25735D206C69746572616C20256F222C7468';
wwv_flow_imp.g_varchar2_table(47149) := '69732E706174682C65292C746869732E707573684368696C6428746869732E6F66287B6E616D653A224C69746572616C222C76616C75653A657D29297D636F6D707574656456616C756528297B666F72286C657420653D746869733B3B653D534228652E';
wwv_flow_imp.g_varchar2_table(47150) := '6368696C6472656E29297B69662821652972657475726E206E756C6C3B696628652E76616C75652972657475726E20652E76616C75657D7D636F6E746578744B65797328297B72657475726E20746869732E636F6E746578742E6765744B65797328292E';
wwv_flow_imp.g_varchar2_table(47151) := '6D6170285F42297D676574207061746828297B72657475726E20746869732E706172656E743F2E706174683F2E636F6E6361742822203E20222C746869732E6E616D65297C7C746869732E6E616D657D6765742865297B636F6E737420743D5B652C6526';
wwv_flow_imp.g_varchar2_table(47152) := '265F422865295D2C6E3D746869732E636F6E746578742E6765744B65797328292E66696E642828653D3E742E696E636C75646573285F422865292929293B696628766F696420303D3D3D6E2972657475726E3B636F6E737420693D746869732E636F6E74';
wwv_flow_imp.g_varchar2_table(47153) := '6578742E676574286E293B72657475726E206920696E7374616E63656F66206D423F692E6765742874686973293A697D7265736F6C76654E616D6528297B636F6E737420653D746869732E746F6B656E732E6A6F696E28222022292C743D746869732E61';
wwv_flow_imp.g_varchar2_table(47154) := '737369676E287B746F6B656E733A5B5D7D292C6E3D746869732E6F66287B6E616D653A225661726961626C654E616D65222C706172656E743A742C76616C75653A746869732E6765742865292C7261773A657D293B72657475726E205A462626636F6E73';
wwv_flow_imp.g_varchar2_table(47155) := '6F6C652E6C6F6728225B25735D207265736F6C7665206E616D65203C25733D25733E222C6E2E706174682C652C746869732E676574286529292C742E707573684368696C64286E297D707573684368696C642865297B69662821652972657475726E2074';
wwv_flow_imp.g_varchar2_table(47156) := '6869733B636F6E737420743D746869732E61737369676E287B6368696C6472656E3A5B2E2E2E746869732E6368696C6472656E2C655D7D293B72657475726E20652E706172656E743D742C747D707573684368696C6472656E2865297B6C657420743D74';
wwv_flow_imp.g_varchar2_table(47157) := '6869733B666F7228636F6E7374206E206F66206529743D742E707573684368696C64286E293B72657475726E20747D6465636C6172654E616D6528297B696628303D3D3D746869732E746F6B656E732E6C656E677468297468726F77204572726F722822';
wwv_flow_imp.g_varchar2_table(47158) := '6E6F20746F6B656E7320746F206465636C617265206E616D6522293B636F6E737420653D746869732E746F6B656E732E6A6F696E28222022293B72657475726E205A462626636F6E736F6C652E6C6F6728225B25735D206465636C6172654E616D65203C';
wwv_flow_imp.g_varchar2_table(47159) := '25733E222C746869732E706174682C65292C746869732E61737369676E287B746F6B656E733A5B5D7D292E707573684368696C6428746869732E6F66287B6E616D653A224E616D65222C76616C75653A657D29297D646566696E6528652C74297B696628';
wwv_flow_imp.g_varchar2_table(47160) := '22737472696E6722213D747970656F6620652972657475726E205A462626636F6E736F6C652E6C6F6728225B25735D206E6F20646566696E65203C25733D25733E222C746869732E706174682C652C74292C746869733B5A462626636F6E736F6C652E6C';
wwv_flow_imp.g_varchar2_table(47161) := '6F6728225B25735D20646566696E65203C25733D25733E222C746869732E706174682C652C74293B636F6E7374206E3D746869732E636F6E746578742E73657428652C74293B72657475726E20746869732E61737369676E287B636F6E746578743A6E7D';
wwv_flow_imp.g_varchar2_table(47162) := '297D61737369676E28653D7B7D297B72657475726E2062422E6F66287B2E2E2E746869732C2E2E2E657D297D6F6628653D7B7D297B636F6E737420743D7B636F6E746578743A746869732E636F6E746578742C706172656E743A746869732E706172656E';
wwv_flow_imp.g_varchar2_table(47163) := '747D3B72657475726E2062422E6F66287B2E2E2E742C2E2E2E657D297D737461746963206F662865297B636F6E73747B6E616D653A742C746F6B656E733A6E3D5B5D2C6368696C6472656E3A693D5B5D2C706172656E743A6F3D6E756C6C2C636F6E7465';
wwv_flow_imp.g_varchar2_table(47164) := '78743A732C76616C75653A722C7261773A617D3D653B6966282173297468726F77206E6577204572726F7228226D7573742070726F76696465203C636F6E746578743E22293B72657475726E206E6577206242287B6E616D653A742C746F6B656E733A5B';
wwv_flow_imp.g_varchar2_table(47165) := '2E2E2E6E5D2C6368696C6472656E3A5B2E2E2E695D2C636F6E746578743A732C706172656E743A6F2C76616C75653A722C7261773A617D297D7D66756E6374696F6E205F422865297B72657475726E20652E7265706C616365282F5C732A285B2E2F5C2D';
wwv_flow_imp.g_varchar2_table(47166) := '272B5D7C5C2A5C2A3F295C732A2F672C222024312022292E7265706C616365282F5C737B322C7D2F672C222022292E7472696D28297D66756E6374696F6E20794228652C742C6E297B636F6E737420693D652E6368696C6472656E2E66696C7465722828';
wwv_flow_imp.g_varchar2_table(47167) := '653D3E652E6E616D65213D3D7429292C6F3D652E6368696C6472656E2E66696C7465722828653D3E652E6E616D653D3D3D7429292C733D695B305D2C723D695B4D6174682E6D617828312C692E6C656E6774682D31295D2C613D733F2E636F6D70757465';
wwv_flow_imp.g_varchar2_table(47168) := '6456616C756528292C6C3D723F2E636F6D707574656456616C756528297C7C6E756C6C3B72657475726E20652E61737369676E287B6368696C6472656E3A6F7D292E656E74657253636F70652874292E707573684368696C6472656E2869292E65786974';
wwv_flow_imp.g_varchar2_table(47169) := '53636F7065286E292E646566696E6528612C6C297D66756E6374696F6E20774228653D7B7D2C743D7642297B636F6E7374206E3D62422E6F66287B636F6E746578743A742E6F662865297D293B72657475726E206E6577206178287B73746172743A6E2C';
wwv_flow_imp.g_varchar2_table(47170) := '72656475636528652C6E2C692C6F297B6966286E3D3D3D7646297B636F6E73745B6E2C695D3D652E6368696C6472656E2E736C696365282D32293B653D652E61737369676E287B76616C75653A742E6F66286E3F2E636F6D707574656456616C75652829';
wwv_flow_imp.g_varchar2_table(47171) := '2C693F2E636F6D707574656456616C75652829297D297D6966286E3D3D3D4846262628653D652E61737369676E287B76616C75653A742E6F66282E2E2E652E6368696C6472656E2E6D61702828653D3E653F2E636F6D707574656456616C756528292929';
wwv_flow_imp.g_varchar2_table(47172) := '297D29292C6E3D3D3D4D46297B636F6E73745B742C6E5D3D652E6368696C6472656E2E736C696365282D32293B653D652E61737369676E287B76616C75653A743F2E636F6D707574656456616C756528297D297D6966286E3D3D3D4E46297B636F6E7374';
wwv_flow_imp.g_varchar2_table(47173) := '5B742C2E2E2E6E5D3D652E6368696C6472656E3B226765742076616C7565223D3D3D743F2E726177262628653D66756E6374696F6E28652C74297B69662821742E6C656E6774682972657475726E20652E61737369676E287B76616C75653A6E756C6C7D';
wwv_flow_imp.g_varchar2_table(47174) := '293B696628224E616D65223D3D3D745B305D2E6E616D65262628743D66756E6374696F6E2865297B636F6E737420743D7B7D3B666F72286C6574206E3D303B6E3C652E6C656E6774683B6E2B3D32297B636F6E73745B692C6F5D3D652E736C696365286E';
wwv_flow_imp.g_varchar2_table(47175) := '2C6E2B32293B745B692E76616C75655D3D6F7D72657475726E5B226D222C226B6579225D2E6D61702828653D3E745B655D29297D287429292C32213D3D742E6C656E6774682972657475726E20652E61737369676E287B76616C75653A6E756C6C7D293B';
wwv_flow_imp.g_varchar2_table(47176) := '636F6E73745B6E2C695D3D742C6F3D693F2E636F6D707574656456616C756528292C733D6E3F2E636F6D707574656456616C756528293B72657475726E20732626226F626A656374223D3D747970656F662073262622737472696E67223D3D747970656F';
wwv_flow_imp.g_varchar2_table(47177) := '66206F3F652E61737369676E287B76616C75653A5B5F42286F292C6F5D2E726564756365282828652C74293D3E732E6765742874297C7C65292C6E756C6C297D293A652E61737369676E287B76616C75653A6E756C6C7D297D28652C6E29297D636F6E73';
wwv_flow_imp.g_varchar2_table(47178) := '7420733D70425B6E5D3B696628732972657475726E20652E656E74657253636F70652873293B636F6E737420723D75425B6E5D3B69662872297B636F6E73747B6368696C6472656E3A692C636F6E746578743A6F7D3D652C733D692E736C69636528302C';
wwv_flow_imp.g_varchar2_table(47179) := '2D31292C613D53422869293B6C6574206C3D6E756C6C3B72657475726E206E3D3D3D49462626286C3D742E6F6628613F2E636F6D707574656456616C7565282929292C6E3D3D3D41462626286C3D742E6F66286F2C613F2E636F6D707574656456616C75';
wwv_flow_imp.g_varchar2_table(47180) := '652829292E73657428226974656D222C613F2E636F6D707574656456616C7565282929292C652E61737369676E287B6368696C6472656E3A737D292E656E74657253636F70652872292E707573684368696C642861292E61737369676E287B636F6E7465';
wwv_flow_imp.g_varchar2_table(47181) := '78743A6C7C7C6F7D297D636F6E737420613D6F2E72656164286F2E706F732C692E706F73293B69662867425B6E5D2972657475726E20652E6578697453636F70652861293B6966286E3D3D3D5546297B636F6E7374206E3D652E6368696C6472656E2E66';
wwv_flow_imp.g_varchar2_table(47182) := '696C7465722828653D3E22436F6E74657874456E74727922213D3D652E6E616D6529292C693D6E5B305D2C6F3D5342286E293B72657475726E20794228652C22436F6E74657874456E747279222C61292E61737369676E287B76616C75653A742E6F6628';
wwv_flow_imp.g_varchar2_table(47183) := '652E76616C7565292E73657428693F2E636F6D707574656456616C756528292C6F3F2E636F6D707574656456616C75652829297D297D6966286E3D3D3D75467C7C6E3D3D3D77462972657475726E20794228652C22496E45787072657373696F6E222C61';
wwv_flow_imp.g_varchar2_table(47184) := '293B6966286E3D3D3D66462972657475726E20652E646566696E6528227061727469616C222C6D422E6F662828653D3E534228652E6368696C6472656E293F2E636F6D707574656456616C756528292929293B6966286E3D3D3D4F46297B636F6E737420';
wwv_flow_imp.g_varchar2_table(47185) := '743D534228652E6368696C6472656E292E636F6D707574656456616C756528293B72657475726E20652E646566696E6528742C31297D6966286E3D3D3D78467C7C6E3D3D3D6B467C7C6E3D3D3D4546297B636F6E737420743D652E6368696C6472656E2E';
wwv_flow_imp.g_varchar2_table(47186) := '736C69636528302C2D31292C6E3D534228652E6368696C6472656E293B72657475726E20652E61737369676E287B6368696C6472656E3A747D292E656E74657253636F7065282241726974686D6574696345787072657373696F6E22292E707573684368';
wwv_flow_imp.g_varchar2_table(47187) := '696C64286E297D6966286E3D3D3D4C462972657475726E20652E656E74657253636F7065282241726974686D6574696345787072657373696F6E22293B6966286E3D3D3D67467C7C6E3D3D3D6D467C7C6E3D3D3D47462972657475726E20652E746F6B65';
wwv_flow_imp.g_varchar2_table(47188) := '6E2861293B6966286E3D3D3D42462972657475726E20652E6C69746572616C28612E7265706C616365282F5E227C22242F672C222229293B6966286E3D3D3D56462972657475726E20652E6C69746572616C282274727565223D3D3D61293B6966286E3D';
wwv_flow_imp.g_varchar2_table(47189) := '3D3D46462972657475726E20652E6C69746572616C287061727365466C6F6174286129293B6966286E3D3D3D52462972657475726E20652E6C69746572616C286E756C6C293B6966286E3D3D3D44462972657475726E20652E7265736F6C76654E616D65';
wwv_flow_imp.g_varchar2_table(47190) := '28293B6966286E3D3D3D70467C7C6E3D3D3D4B462972657475726E20652E6465636C6172654E616D6528293B696628286E3D3D3D63467C7C6E3D3D3D4346292626652E746F6B656E732E6C656E6774683E30297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(47191) := '756E636C6561726564206E616D6522293B6966286E3D3D3D6346297B6C657420743D653B666F72283B742E706172656E743B29743D742E6578697453636F70652861293B72657475726E20747D72657475726E20657D7D297D636F6E73742043423D7742';
wwv_flow_imp.g_varchar2_table(47192) := '287B7D293B66756E6374696F6E2053422865297B72657475726E20655B652E6C656E6774682D315D7D636F6E73742078423D6D78287B537472696E674C69746572616C3A52782E737472696E672C4E756D657269634C69746572616C3A52782E6E756D62';
wwv_flow_imp.g_varchar2_table(47193) := '65722C426F6F6C65616E4C69746572616C3A52782E626F6F6C2C2241744C69746572616C21223A52782E7370656369616C2852782E737472696E67292C436F6D706172654F703A52782E636F6D706172654F70657261746F722C41726974684F703A5278';
wwv_flow_imp.g_varchar2_table(47194) := '2E61726974686D657469634F70657261746F722C22666F72206966207468656E20656C736520736F6D6520657665727920736174697366696573206265747765656E2072657475726E223A52782E636F6E74726F6C4B6579776F72642C22696E20696E73';
wwv_flow_imp.g_varchar2_table(47195) := '74616E6365206F6620616E64206F72223A52782E6F70657261746F724B6579776F72642C66756E6374696F6E3A52782E646566696E6974696F6E4B6579776F72642C61733A52782E6B6579776F72642C22547970652F2E2E2E223A52782E747970654E61';
wwv_flow_imp.g_varchar2_table(47196) := '6D652C57696C64636172643A52782E7370656369616C2852782E7661726961626C654E616D65292C6E756C6C3A52782E6E756C6C2C4C696E65436F6D6D656E743A52782E6C696E65436F6D6D656E742C426C6F636B436F6D6D656E743A52782E626C6F63';
wwv_flow_imp.g_varchar2_table(47197) := '6B436F6D6D656E742C275661726961626C654E616D652120223F22273A52782E7661726961626C654E616D652C224461746554696D65436F6E7374727563746F7221205370656369616C46756E6374696F6E4E616D6521223A52782E66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(47198) := '2852782E7370656369616C2852782E7661726961626C654E616D6529292C224C69737420496E74657276616C223A52782E6C6973742C436F6E746578743A52782E646566696E6974696F6E2852782E6C69746572616C292C224E616D6521223A52782E64';
wwv_flow_imp.g_varchar2_table(47199) := '6566696E6974696F6E2852782E7661726961626C654E616D65292C224B65792F4E616D652120436F6E74657874456E747279547970652F4E616D6521223A52782E646566696E6974696F6E2852782E70726F70657274794E616D65292C22506174684578';
wwv_flow_imp.g_varchar2_table(47200) := '7072657373696F6E2F5661726961626C654E616D6521223A52782E66756E6374696F6E2852782E70726F70657274794E616D65292C22466F726D616C506172616D657465722F506172616D657465724E616D6521223A52782E66756E6374696F6E285278';
wwv_flow_imp.g_varchar2_table(47201) := '2E646566696E6974696F6E2852782E7661726961626C654E616D6529292C22282029223A52782E706172656E2C225B205D223A52782E737175617265427261636B65742C227B207D223A52782E62726163652C222E223A52782E64657265664F70657261';
wwv_flow_imp.g_varchar2_table(47202) := '746F722C222C203B223A52782E736570617261746F722C222E2E223A52782E70756E6374756174696F6E7D292C6B423D7B5F5F70726F746F5F5F3A6E756C6C2C666F723A31302C696E3A33322C72657475726E3A33362C69663A34302C7468656E3A3432';
wwv_flow_imp.g_varchar2_table(47203) := '2C656C73653A34342C736F6D653A34382C65766572793A35302C7361746973666965733A35362C6F723A36302C616E643A36342C6265747765656E3A37322C696E7374616E63653A38362C6F663A38392C646179733A3130312C74696D653A3130332C64';
wwv_flow_imp.g_varchar2_table(47204) := '75726174696F6E3A3130352C79656172733A3130372C6D6F6E7468733A3130392C646174653A3131312C6C6973743A3131372C636F6E746578743A3132332C66756E6374696F6E3A3133302C6E756C6C3A3135362C747275653A3333302C66616C73653A';
wwv_flow_imp.g_varchar2_table(47205) := '3333302C223F223A3137302C65787465726E616C3A3138362C6E6F743A3231317D2C45423D6C782E646573657269616C697A65287B76657273696F6E3A31342C7374617465733A22437C4F6051594F4F4F6051594F4F4F246D51594F4F4F4F5155272343';
wwv_flow_imp.g_varchar2_table(47206) := '65272343654F247751594F272343604F265151594F272346514F4F515127234666272346664F265B51594F272346664F6051594F272344564F4F51552723456E2723456E4F277B515E4F2723445D4F4F51552723445E2723445E4F4F51552723445D2723';
wwv_flow_imp.g_varchar2_table(47207) := '445D4F4F514F2723466E2723466E4F297851574F272344764F4F51512723447D2723447D4F4F51512723454F2723454F4F4F515127234550272345504F297D4F574F272345534F297851574F272345514F4F515127234551272345514F4F515127234674';
wwv_flow_imp.g_varchar2_table(47208) := '272346744F4F515127234672272346724F4F515127234679272346794F4F515127234555272345554F6051594F272345574F4F515127234653272346534F2A53515E4F272346534F2B7951594F272345584F2C5151574F272345594F4F51502723467D27';
wwv_flow_imp.g_varchar2_table(47209) := '23467D4F2C5651584F272345614F4F51512723467A2723467A4F4F51512723465227234652514F51574F4F4F4F515127234654272346544F4F51512723465E2723465E4F6051594F2723436F4F4F51512723465F2723465F4F247751594F272343734F2C';
wwv_flow_imp.g_varchar2_table(47210) := '6251594F272344774F4F515127234673272346734F2C6751594F272345524F4F514F27234552272345524F6051594F272345564F6051594F272345554F4F514F2723467B2723467B512C6F51574F4F4F2C7451594F272344524F2D6B51574F272346624F';
wwv_flow_imp.g_varchar2_table(47211) := '4F514F27234454272344544F2D7651594F272346664F2D7D51574F4F4F2E7451594F272343644F2F5251594F272346564F4F515127234363272343634F2F5751594F272346554F4F515127234362272343624F2F6051594F2C35387A4F6051594F2C3539';
wwv_flow_imp.g_varchar2_table(47212) := '694F4F515127234663272346634F4F515127234664272346644F4F515127234665272346654F6051594F2C3539714F6051594F2C3539714F6051594F2C3539714F4F51512723466C2723466C4F2F6551594F2C353A5E4F4F51512723466D2723466D4F60';
wwv_flow_imp.g_varchar2_table(47213) := '51594F2C353A604F6051594F2C3539654F6051594F2C3539674F6051594F2C3539694F315E51594F2C3539694F316551594F2C3539724F4F51512C353A692C353A694F316A51594F2C3539714F4F51552D45386C2D45386C4F335E51594F2723466F4F4F';
wwv_flow_imp.g_varchar2_table(47214) := '51512C353A622C353A624F4F51512C353A6E2C353A6E4F4F51512C353A6C2C353A6C4F336551594F2C353A724F4F51512C353B6E2C353B6E4F336F51594F2C353A714F337C51574F2C353A734F345251594F2C353A744F4F515027234565272345654F34';
wwv_flow_imp.g_varchar2_table(47215) := '7851584F272345644F4F514F27234563272345634F355051574F272345624F355551574F2723474F4F355E51574F2C353A7B4F356351594F2C35395A4F2F5251594F272346614F4F515127234377272343774F356A51594F272346604F4F515127234376';
wwv_flow_imp.g_varchar2_table(47216) := '272343764F357251594F2C35395F4F357751594F2C353A634F357C51594F2C353A6D4F336851594F2C353A714F365251594F2C353A704F6051594F27234577512C6F51574F4F4F6051594F2723456D4F367851574F2C353B7C4F6051594F4F4F4F515227';
wwv_flow_imp.g_varchar2_table(47217) := '234366272343664F4F51512723456A2723456A4F377251594F2C35394F4F6051594F2C353B714F4F515127234659272346594F247751594F2723456B4F385351594F2C353B704F6051594F31472E664F4F51512723465D2723465D4F387951594F31472F';
wwv_flow_imp.g_varchar2_table(47218) := '544F3B7051594F31472F5D4F3B7A51594F31472F5D4F3C5551594F31472F5D4F4F515131472F7831472F784F3D7851594F31472F7A4F3E5051594F31472F504F3F5951594F31472F524F406351594F31472F544F6051594F31472F544F4F515131472F54';
wwv_flow_imp.g_varchar2_table(47219) := '31472F544F407951594F31472F5E4F4168515E4F272343644F427A51594F272346714F4F514F2723447A2723447A4F435551574F272344794F435A51574F272346704F4F514F27234478272344784F4F514F2723447B2723447B4F436351574F2C353C5A';
wwv_flow_imp.g_varchar2_table(47220) := '4F4F51513147305E3147305E4F6051594F3147305D4F6051594F272345734F436851574F2C353C5D4F4F51513147305F3147305F4F437351574F2723455B4F444F51574F2723467C4F4F514F2723455A2723455A4F445751574F314730604F4F51502723';
wwv_flow_imp.g_varchar2_table(47221) := '4575272345754F445D51584F2C353B4F4F6051594F2C353A7C4F446451584F272345764F446C51574F2C353C6A4F4F515131473067314730674F6051594F31472E754F6051594F2C353B7B4F247751594F2723456C4F447451594F2C353B7A4F6051594F';
wwv_flow_imp.g_varchar2_table(47222) := '31472E794F447C51594F31472F7D4F4F514F31473058314730584F4F514F2C353B632C353B634F4F514F2D4538752D4538754F4F514F2C353B582C353B584F4F514F2D45386B2D45386B4F455251574F4F4F4F51512D4538682D4538684F455751594F27';
wwv_flow_imp.g_varchar2_table(47223) := '23436D4F4F51513147315D3147315D4F4F51512C353B562C353B564F4F51512D4538692D4538694F456551594F372B24514F4F5151372B2566372B25664F6051594F372B246F4F465B51594F2C353A724F466951574F372B246F4F466E51594F2723445B';
wwv_flow_imp.g_varchar2_table(47224) := '4F4F51512723445A2723445A4F486251594F2723445F4F486751594F2723445F4F486C51594F2723445F4F487151604F272344674F487651604F2723446A4F487B51604F2723446E4F4F5151372B2478372B24784F6051594F2C353A654F247751594F27';
wwv_flow_imp.g_varchar2_table(47225) := '2345724F495151574F2C353C5B4F4F515131473175314731754F4A5751594F372B25774F4A6551594F2C353B5F4F4F514F2D4538712D4538714F407951594F2C353A764F247751594F272345744F4A7251574F2C353C684F4A7A51594F372B257A4F4F51';
wwv_flow_imp.g_varchar2_table(47226) := '502D4538732D4538734F4B5251594F314730684F4F514F2C353B622C353B624F4F514F2D4538742D4538744F4B5D51594F372B24614F4B6451594F314731674F4F51512C353B572C353B574F4F51512D45386A2D45386A4F4B6E51594F372B24654F4F51';
wwv_flow_imp.g_varchar2_table(47227) := '4F372B2569372B25694F6051594F2C3539584F4C6551594F3C3C485A4F4F51513C3C485A3C3C485A4F2F6551594F2723456F4F4D6E51594F2C3539764F21206251594F2C3539794F21206751594F2C3539794F21206C51594F2C3539794F21207151594F';
wwv_flow_imp.g_varchar2_table(47228) := '2C353A524F247751594F2C353A554F21216051624F2C353A594F21216751594F314730504F4F514F2C353B5E2C353B5E4F4F514F2D4538702D4538704F21217151594F3C3C49634F4F51513C3C49633C3C49634F4F514F31473062314730624F4F514F2C';
wwv_flow_imp.g_varchar2_table(47229) := '353B602C353B604F4F514F2D4538722D4538724F21257051594F2723455E4F4F51513C3C49663C3C49664F6051594F3C3C49664F6051594F3C3C477B4F21266751594F31472E734F4F51512C353B5A2C353B5A4F4F51512D45386D2D45386D4F21267151';
wwv_flow_imp.g_varchar2_table(47230) := '594F31472F654F4F515131472F6531472F654F21267651624F2723445D4F21275851604F2723445B4F21276451604F31472F6D4F21276951574F2723446D4F21276E51604F272346684F4F514F2723446C2723446C4F21277651604F31472F704F4F514F';
wwv_flow_imp.g_varchar2_table(47231) := '27234471272344714F21277B51604F2723466A4F4F514F27234470272344704F21285451604F31472F744F4F5151414E3F51414E3F514F21285951594F414E3D674F4F5151372B2550372B25504F21295051604F2C3539764F4F5151372B2558372B2558';
wwv_flow_imp.g_varchar2_table(47232) := '4F21207151594F2C353A584F247751594F272345704F21295B51604F2C353C534F4F5151372B255B372B255B4F21207151594F272345714F21296451604F2C353C554F21296C51604F372B25604F4F514F31472F7331472F734F4F514F2C353B5B2C353B';
wwv_flow_imp.g_varchar2_table(47233) := '5B4F4F514F2D45386E2D45386E4F4F514F2C353B5D2C353B5D4F4F514F2D45386F2D45386F4F407951594F3C3C487A4F4F5151414E3E66414E3E664F2F6551594F2723456F4F21207151594F3C3C487A4F21297151604F372B25604F21297651604F3147';
wwv_flow_imp.g_varchar2_table(47234) := '2F744F21216051624F2C353A594F21297B51604F2723446E222C7374617465446174613A22212A5B7E4F23724F5323734F53504F53514F537E4F54734F5A564F5B554F64744F68764F69764F737D4F76694F21547B4F21557B4F2156784F21587A4F2163';
wwv_flow_imp.g_varchar2_table(47235) := '214F4F21677C4F2169674F2170794F21776A4F23536E4F236E524F236F524F245A5A4F24695F4F246A604F246B614F246C624F7E4F54734F5B554F64744F68764F69764F737D4F76694F21547B4F21557B4F2156784F21587A4F2163214F4F21677C4F21';
wwv_flow_imp.g_varchar2_table(47236) := '69674F2170794F21776A4F23536E4F236E524F236F524F245A5A4F24695F4F246A604F246B614F246C624F7E4F5A21544F235D21554F7E5023504F236E524F236F524F7E4F5A215E4F5B215E4F5D215F4F5E215F4F5F21604F60216B4F6E21684F702169';
wwv_flow_imp.g_varchar2_table(47237) := '4F72215D4F73215D4F74216A4F7B216C4F216921664F237A21644F762462587E4F236C23745824732374587E5025504F2469216D4F542459585A2459585B2459586424595868245958692459587324595876245958215424595821552459582156245958';
wwv_flow_imp.g_varchar2_table(47238) := '2158245958216324595821672459582169245958217024595821772459582353245958236E245958236F245958245A245958246A245958246B245958246C2459587E4F236E524F236F524F5A2150585B2150585D2150585E2150585F215058602150586E';
wwv_flow_imp.g_varchar2_table(47239) := '21505870215058722150587321505874215058762150587B2150582169215058236C2150582370215058237A2150582473215058244F21505878215058237D215058216721505865215058622150582352215058662150586C2150587E4F7621704F7E4F';
wwv_flow_imp.g_varchar2_table(47240) := '246A604F7E4F237021754F5A2376585B2376585D2376585E2376585F237658602376586E23765870237658722376587323765874237658762376587B2376582169237658236C237658237A2376582473237658244F23765878237658237D237658216723';
wwv_flow_imp.g_varchar2_table(47241) := '765865237658622376582352237658662376586C2376587E4F21672465507E50604F7621784F7E4F236D21794F246A604F23522472507E4F7023564F7E4F7023574F762175587E4F2473235A4F7E4F236C7558244F755824737558787558237D75582167';
wwv_flow_imp.g_varchar2_table(47242) := '7558657558627558235275586675586C75587E5025504F244F235D4F236C245558782455587E4F236C235B587E50265B4F76235F4F7E4F5A23604F5B23604F5D23604F5E23604F5F23604F236E524F236F524F237A23604F237B23604F245D57587E4F60';
wwv_flow_imp.g_varchar2_table(47243) := '5758785758244F57587E502E534F6023644F7E4F244F23654F622378587E4F6223684F7E4F236E524F236F524F245A5A4F7E4F54734F5A564F5B554F64744F68764F69764F737D4F21547B4F21557B4F2156784F21587A4F2163214F4F21677C4F216967';
wwv_flow_imp.g_varchar2_table(47244) := '4F2170794F21776A4F23536E4F236E524F236F524F245A5A4F24695F4F246A604F246B614F246C624F7E4F7623724F7E502F704F7C23744F7E4F7B216C4F216921664F237A21644F5A79615B79615D79615E79615F79616079616E796170796172796173';
wwv_flow_imp.g_varchar2_table(47245) := '796174796176246258236C796124737961244F7961787961237D796121677961657961627961235279616679616C79617E4F782465507E50604F78237D4F237D244F4F7E5025504F237D244F4F244F24504F21672465587E5025504F216724524F7E4F23';
wwv_flow_imp.g_varchar2_table(47246) := '6E524F236F524F782470507E4F5A23604F5B23604F5D23604F5E23604F5F23604F236D21794F237A23604F237B23604F7E4F245D2357587E50345E4F245D24594F7E4F244F245A4F23522472587E4F2352245D4F7E4F65245E4F7E5025504F244F24604F';
wwv_flow_imp.g_varchar2_table(47247) := '6C2453587E4F6C24624F7E4F215724634F7E4F215424644F7E4F236C2178612473217861244F21786178217861237D217861216721786165217861622178612352217861662178616C2178617E5025504F244F235D4F236C245561782455617E4F5A2360';
wwv_flow_imp.g_varchar2_table(47248) := '4F5B23604F5D23604F5E23604F5F23604F236E524F236F524F237A23604F237B23604F7E4F605761245D5761785761244F57617E5037544F244F23654F622378617E4F5A215E4F5B215E4F5D215F4F5E215F4F5F21604F7B216C4F216921664F237A2164';
wwv_flow_imp.g_varchar2_table(47249) := '4F762462587E4F6071696E7169707169727169737169747169236C716924737169244F7169787169237D716921677169657169627169235271696671696C71697E50385B4F5F21604F7B216C4F216921664F237A21644F5A79695B79696079696E796970';
wwv_flow_imp.g_varchar2_table(47250) := '796972796973796974796976246258236C796924737969244F7969787969237D796921677969657969627969235279696679696C79697E4F5D215F4F5E215F4F7E503A534F5D79695E79697E503A534F7B216C4F216921664F237A21644F5A79695B7969';
wwv_flow_imp.g_varchar2_table(47251) := '5D79695E79695F79696079696E796970796972796973796974796976246258236C796924737969244F7969787969237D796921677969657969627969235279696679696C79697E4F216724704F7E5025504F60216B4F7021694F72215D4F73215D4F7421';
wwv_flow_imp.g_varchar2_table(47252) := '6A4F6E6D69236C6D6924736D69244F6D69786D69237D6D6921676D69656D69626D6923526D69666D696C6D697E50385B4F60216B4F72215D4F73215D4F74216A4F6E6F69706F69236C6F6924736F69244F6F69786F69237D6F6921676F69656F69626F69';
wwv_flow_imp.g_varchar2_table(47253) := '23526F69666F696C6F697E50385B4F60216B4F6E21684F7024714F72215D4F73215D4F74216A4F7E50385B4F215324764F215624774F215824784F215B24794F215F247A4F2163247B4F236E524F236F524F245A5A4F7E4F5A2362585B2362585D236258';
wwv_flow_imp.g_varchar2_table(47254) := '5E2362585F236258602362586E2362587023625872236258732362587423625876236258782362587B2362582169236258236E236258236F2362582370236258237A236258244F2362587E502E534F244F24504F782465587E5025504F245D247D4F7E4F';
wwv_flow_imp.g_varchar2_table(47255) := '244F254F4F782464587E4F7825514F7E4F244F24504F2167246561782465617E4F245D25554F78234F58244F234F587E4F244F25564F782470587E4F7825584F7E4F245D2357617E50345E4F236D21794F246A604F7E4F244F245A4F23522472617E4F24';
wwv_flow_imp.g_varchar2_table(47256) := '4F24604F6C2453617E4F215525634F7E4F78724F7E4F237D25644F626158244F61587E5025504F236C537124735371244F5371785371237D537121675371655371625371235253716653716C53717E5025504F78237D4F237D244F4F244F75587E502550';
wwv_flow_imp.g_varchar2_table(47257) := '4F7825664F7E4F237A25674F5A214F585B214F585D214F585E214F585F214F5860214F586E214F5870214F5872214F5873214F5874214F5876214F587B214F582169214F58236C214F582473214F58244F214F5878214F58237D214F582167214F586521';
wwv_flow_imp.g_varchar2_table(47258) := '4F5862214F582352214F5866214F586C214F587E4F7025694F7E4F70256A4F7E4F70256B4F7E4F215D256C4F7E4F215D256D4F7E4F215D256E4F7E4F244F254F4F782464617E4F5A215E4F5B215E4F5D215F4F5E215F4F5F21604F60216B4F6E21684F70';
wwv_flow_imp.g_varchar2_table(47259) := '21694F72215D4F73215D4F74216A4F7B216C4F237A21644F762462587E4F7825734F216725734F216925724F7E5049594F2167236761244F236761782367617E5025504F244F25564F782470617E4F235025794F7E50604F2352235569244F2355697E50';
wwv_flow_imp.g_varchar2_table(47260) := '25504F66257A4F7E5025504F6C245469244F2454697E5025504F236C677124736771244F6771786771237D677121676771656771626771235267716667716C67717E5025504F6071796E7179707179727179737179747179236C717924737179244F7179';
wwv_flow_imp.g_varchar2_table(47261) := '787179237D717921677179657179627179235271796671796C71797E50385B4F237A25674F5A214F615B214F615D214F615E214F615F214F6160214F616E214F6170214F6172214F6173214F6174214F6176214F617B214F612169214F61236C214F6124';
wwv_flow_imp.g_varchar2_table(47262) := '73214F61244F214F6178214F61237D214F612167214F6165214F6162214F612352214F6166214F616C214F617E4F2154264F4F7E4F2157264F4F7E4F215426504F7E4F215324764F215624774F215824784F215B24794F215F247A4F216326754F236E52';
wwv_flow_imp.g_varchar2_table(47263) := '4F236F524F245A5A4F7E4F2159245E507E502120714F78216D69244F216D697E5025504F542461585A2461585B2461585D2179795E2179795F217979602179796424615868246158692461586E2179797021797972217979732461587421797976246158';
wwv_flow_imp.g_varchar2_table(47264) := '7B2179792154246158215524615821562461582158246158216324615821672461582169246158217024615821772461582353246158236C217979236E246158236F246158237A217979245A2461582469246158246A246158246B246158246C24615824';
wwv_flow_imp.g_varchar2_table(47265) := '73217979244F21797978217979237D21797965217979622179792352217979662179796C2179797E4F236C2351582473235158244F23515878235158237D235158216723515865235158622351582352235158662351586C2351587E5025504F62616924';
wwv_flow_imp.g_varchar2_table(47266) := '4F61697E5025504F2155265F4F7E4F236E524F236F524F2159215058237A215058244F2150587E4F237A26704F2159214F58244F214F587E4F215926614F7E4F245D26624F7E4F244F26634F2159245B587E4F215926654F7E4F244F26664F2159245E58';
wwv_flow_imp.g_varchar2_table(47267) := '7E4F215926684F7E4F236C6321522473632152244F63215278632152237D632152216763215265632152626321522352632152666321526C6321527E5025504F237A26704F2159214F61244F214F617E4F244F26634F2159245B617E4F244F26664F2159';
wwv_flow_imp.g_varchar2_table(47268) := '245E617E4F245F266E4F7E4F245F26714F7E4F215926724F7E4F215D26744F7E4F245A7E51505F5E24695D237A7E222C676F746F3A22457C247350505050247450256D2570257626592773505050505050277C5024745050502474505028502853502474';
wwv_flow_imp.g_varchar2_table(47269) := '502474502474505050285950286550247424745050286E295429602A6D295450505050505050295450502954502B722B752954502B7B2C5224745024745024742C592D522D552D5B2D52502D642E5D2D642D642F5D3055502474307D247431763176326F';
wwv_flow_imp.g_varchar2_table(47270) := '327250327850503176334F33552F58335950503362503365336C33723378344F355A3565356B35713577364F3655365B3662505050505050505036683671387839713A6A3A6D50503A7150503A773A7A3B733C6C3C6F3C733C783D673E563E76503F6F50';
wwv_flow_imp.g_varchar2_table(47271) := '3F72503F764069415B4254425A425E24744264426450505050435D38784455447D45514579216D6A4F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825';
wwv_flow_imp.g_varchar2_table(47272) := '642579257A52215B535121595352246D236553215753236553235177246057237721702178254F2556542654256D26632357584F50515759696C757C7D215D2161216221632165216721682169216A216B235A235D235F2363236723722374244F245024';
wwv_flow_imp.g_varchar2_table(47273) := '59245E245F24622471247D2555255825642567256C256E2579257A265126622666266E2670267126746221565377217823652460254F2556256D26635523612156236223755223752170552361215623622375542457217A245852246C23635223557751';
wwv_flow_imp.g_varchar2_table(47274) := '235377522560246055215251235F2372512373216B522467235D517251512469235F522473237251247C23745125742555512653256C552658256E26662674512669266254266F266E267163247523742555256C256E26622666266E26712674216C6B4F';
wwv_flow_imp.g_varchar2_table(47275) := '505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A51236D216555247423742555266E53257C256726705D2652256C256E2662266626712674';
wwv_flow_imp.g_varchar2_table(47276) := '23565B4F505157696C757C7D215D2161216221632165216721682169216A216B2170235A235D235F2363236723722374244F24502459245E245F24622471247D2555255825642567256C256E2579257A26622666266E267026712674522657256D512655';
wwv_flow_imp.g_varchar2_table(47277) := '256D52266A266351265B256E5226732674532659256E267452266C2666216D5D4F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A52237C';
wwv_flow_imp.g_varchar2_table(47278) := '21705123792170522570254F5323782170254F54245321782556216D654F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216C654F5051';
wwv_flow_imp.g_varchar2_table(47279) := '57696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A5121726254217B6F245A216D634F505157696C757C7D215D216121622163216721682169216A';
wwv_flow_imp.g_varchar2_table(47280) := '216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216D644F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D';
wwv_flow_imp.g_varchar2_table(47281) := '255825642579257A216D684F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216D704F505157696C757C7D215D21612162216321672168';
wwv_flow_imp.g_varchar2_table(47282) := '2169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A522456217851245421785225752556512578255852265D257951217D6F52255B245A54217C6F245A53217A6F245A542457217A2458527251';
wwv_flow_imp.g_varchar2_table(47283) := '5323622156237552246A2362512366215952246E23665124612353522561246151235E2152522468235E2176594F505157696C757C7D215D2161216221632165216721682169216A216B2170235A235D235F2363236723722374244F24502459245E245F';
wwv_flow_imp.g_varchar2_table(47284) := '24622471247D25552558256425672579257A266E53216F5926515F2651256C256E26622666267026712674512568247453257D256826605226602652512664265552266B2664512667265952266D26675125502379522571255053245121762376522554';
wwv_flow_imp.g_varchar2_table(47285) := '245151255724545225762557512458217A522559245851245B217D52255D245B51235B2150522466235B51724F51215050522465235A55544F50235A57215151216B235D235F51216E57512174695121766C512350755123587C5123597D512369215D51';
wwv_flow_imp.g_varchar2_table(47286) := '236A216151236B216251236C216351236E216751236F21685123702169512371216A512376217051246B236351246F23675124722372512552244F512553245051255A245951255E245E51255F245F5125622462512565247151256F247D532577255825';
wwv_flow_imp.g_varchar2_table(47287) := '7951257B256452265E257A216D714F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216D534F505157696C757C7D215D21612162216321';
wwv_flow_imp.g_varchar2_table(47288) := '6721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A52215A53542158532365512363215752245F2351522367215B216D754F505157696C757C7D215D216121622163216721682169216A';
wwv_flow_imp.g_varchar2_table(47289) := '216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216D774F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D';
wwv_flow_imp.g_varchar2_table(47290) := '255825642579257A5223547754235277246056215351235F237221582161542151217421762350235823592369236E236F237023712376246B246F247225522553255A255E255F25622565256F2577257B265E215A216254215121742176235023582359';
wwv_flow_imp.g_varchar2_table(47291) := '2369236A236E236F237023712376246B246F247225522553255A255E255F25622565256F2577257B265E215D2163542151217421762350235823592369236A236B236E236F237023712376246B246F247225522553255A255E255F25622565256F257725';
wwv_flow_imp.g_varchar2_table(47292) := '7B265E216D574F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A522656256D54265A256E267421612165542151216E2174217623502358';
wwv_flow_imp.g_varchar2_table(47293) := '23592369236A236B236C236E236F237023712376246B246F247225522553255A255E255F25622565256F2577257B265E21612167542151216E217421762350235823592369236A236B236C236E236F237023712376246B246F247225522553255A255E25';
wwv_flow_imp.g_varchar2_table(47294) := '5F25622565256F2577257B265E216D5E4F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A5121715E5221736352237A21705121776C5223';
wwv_flow_imp.g_varchar2_table(47295) := '7B2170216D664F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216D6C4F505157696C757C7D215D216121622163216721682169216A21';
wwv_flow_imp.g_varchar2_table(47296) := '6B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A216D6D4F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D25';
wwv_flow_imp.g_varchar2_table(47297) := '5825642579257A5224552178216D6F4F505157696C757C7D215D216121622163216721682169216A216B2170235A235D235F236323672372244F24502459245E245F24622471247D255825642579257A52234F6F222C6E6F64654E616D65733A22E29AA0';
wwv_flow_imp.g_varchar2_table(47298) := '204C696E65436F6D6D656E7420426C6F636B436F6D6D656E742045787072657373696F6E20466F7245787072657373696F6E20666F7220496E45787072657373696F6E7320496E45787072657373696F6E204E616D65204964656E746966696572204964';
wwv_flow_imp.g_varchar2_table(47299) := '656E7469666965722041726974684F702041726974684F702041726974684F702041726974684F702041726974684F7020696E20497465726174696F6E436F6E746578742072657475726E20496645787072657373696F6E206966207468656E20656C73';
wwv_flow_imp.g_varchar2_table(47300) := '65205175616E74696669656445787072657373696F6E20736F6D6520657665727920496E45787072657373696F6E7320496E45787072657373696F6E20736174697366696573204469736A756E6374696F6E206F7220436F6E6A756E6374696F6E20616E';
wwv_flow_imp.g_varchar2_table(47301) := '6420436F6D70617269736F6E20436F6D706172654F7020436F6D706172654F70206265747765656E20506F736974697665556E61727954657374202820506F736974697665556E617279546573747320292041726974686D657469634578707265737369';
wwv_flow_imp.g_varchar2_table(47302) := '6F6E20496E7374616E63654F6645787072657373696F6E20696E7374616E6365206F662054797065205175616C69666965644E616D65205661726961626C654E616D65204261636B7469636B4964656E746966696572205370656369616C547970652064';
wwv_flow_imp.g_varchar2_table(47303) := '6179732074696D65206475726174696F6E207965617273206D6F6E7468732064617465203E204C69737454797065206C697374203C20436F6E746578745479706520636F6E7465787420436F6E74657874456E747279547970657320436F6E7465787445';
wwv_flow_imp.g_varchar2_table(47304) := '6E747279547970652046756E6374696F6E547970652066756E6374696F6E20417267756D656E74547970657320417267756D656E7454797065205061746845787072657373696F6E205D2046696C74657245787072657373696F6E205B2046756E637469';
wwv_flow_imp.g_varchar2_table(47305) := '6F6E496E766F636174696F6E205370656369616C46756E6374696F6E4E616D65204E616D6564506172616D6574657273204E616D6564506172616D6574657220506172616D657465724E616D6520506F736974696F6E616C506172616D6574657273206E';
wwv_flow_imp.g_varchar2_table(47306) := '756C6C204E756D657269634C69746572616C20537472696E674C69746572616C20426F6F6C65616E4C69746572616C204461746554696D654C69746572616C204461746554696D65436F6E7374727563746F722041744C69746572616C203F2053696D70';
wwv_flow_imp.g_varchar2_table(47307) := '6C65506F736974697665556E6172795465737420496E74657276616C20506172656E74686573697A656445787072657373696F6E204C6973742046756E6374696F6E446566696E6974696F6E20466F726D616C506172616D657465727320466F726D616C';
wwv_flow_imp.g_varchar2_table(47308) := '506172616D657465722065787465726E616C2046756E6374696F6E426F6479207D207B20436F6E7465787420436F6E74657874456E747279204B6579204E616D65204964656E7469666965722045787072657373696F6E7320556E617279546573747320';
wwv_flow_imp.g_varchar2_table(47309) := '57696C6463617264206E6F74222C6D61785465726D3A3137332C636F6E746578743A43422C6E6F646550726F70733A5B5B22636C6F7365644279222C33382C2229222C37312C225D222C39362C227D225D2C5B226F70656E65644279222C34302C222822';
wwv_flow_imp.g_varchar2_table(47310) := '2C36392C225B222C39352C227B225D2C5B2267726F7570222C2D352C37382C37392C38302C38312C38322C224C69746572616C225D5D2C70726F70536F75726365733A5B78425D2C736B69707065644E6F6465733A5B302C312C325D2C7265706561744E';
wwv_flow_imp.g_varchar2_table(47311) := '6F6465436F756E743A31342C746F6B656E446174613A222D637E527658592369595A245E5A5B23695D5E245E70712369717224637273246E777826667879266B797A26707A7B26757B7C27537C7D27587D214F275E214F2150276B215021512854215121';
wwv_flow_imp.g_varchar2_table(47312) := '5B2A4F215B215D2A61215D215E2A66215E215F2A6B215F21602469216021612A7A216221632B55217D234F2B5A235023512B6023512352267D235323542B65236F23702D58237123722D5E24662467236923425923425A236924495324495F236924497C';
wwv_flow_imp.g_varchar2_table(47313) := '24497D245E24497D244A4F245E244A54244A552369244B56244B57236926465526465623693F48543F485523697E236E5923727E585923695A5B23697071236924662467236923425923425A236924495324495F2369244A54244A552369244B56244B57';
wwv_flow_imp.g_varchar2_table(47314) := '236926465526465623693F48543F485523697E24634F23737E7E246650215F216024697E246E4F727E7E247357246A7E4F59246E5A72246E7273255D73234F246E234F2350256223503B2753246E3B27533B3D6026603C256C4F246E7E25624F246A7E7E';
wwv_flow_imp.g_varchar2_table(47315) := '2565524F3B2753246E3B27533B3D60256E3B3D604F246E7E257358246A7E4F59246E5A72246E7273255D73234F246E234F2350256223503B2753246E3B27533B3D6026603B3D603C256C246E3C256C4F246E7E2663503B3D603C256C246E7E266B4F237B';
wwv_flow_imp.g_varchar2_table(47316) := '7E7E26704F767E7E26754F787E7E267A505E7E7A7B267D7E27534F5F7E7E27584F5B7E7E275E4F244F7E522763505A5021602161276651276B4F245F517E277051237A7E214F215027762151215B277B7E277B4F237D7E7E28515024697E2151215B277B';
wwv_flow_imp.g_varchar2_table(47317) := '7E2859515D7E7A7B28602150215129677E2863544F7A28607A7B28727B3B275328603B27533B3D6029613C256C4F28607E2875564F7A28607A7B28727B2150286021502151295B21513B275328603B27533B3D6029613C256C4F28607E29614F517E7E29';
wwv_flow_imp.g_varchar2_table(47318) := '64503B3D603C256C28607E296C53507E4F5929675A3B275329673B27533B3D6029783C256C4F29677E297B503B3D603C256C29677E2A545124697E214F21502A5A2151215B2A4F7E2A5E502151215B277B7E2A664F245D7E7E2A6B4F24737E522A725021';
wwv_flow_imp.g_varchar2_table(47319) := '5D517350215F21602A75502A7A4F7350522B52502159517350215F21602A757E2B5A4F246C7E7E2B604F21697E7E2B654F21677E7E2B68574F592B655A234F2B65234F23502C51235023532B65235323542C7C23543B27532B653B27533B3D602D523C25';
wwv_flow_imp.g_varchar2_table(47320) := '6C4F2B657E2C54524F3B27532B653B27533B3D602C5E3B3D604F2B657E2C61584F592B655A234F2B65234F23502C51235023532B65235323542C7C23543B27532B653B27533B3D602D523B3D603C256C2B653C256C4F2B657E2D524F245A7E7E2D55503B';
wwv_flow_imp.g_varchar2_table(47321) := '3D603C256C2B657E2D5E4F23537E7E2D634F23527E222C746F6B656E697A6572733A5B64422C63422C68422C302C315D2C746F7052756C65733A7B45787072657373696F6E3A5B302C335D2C45787072657373696F6E733A5B312C3130325D2C556E6172';
wwv_flow_imp.g_varchar2_table(47322) := '7954657374733A5B322C3130335D7D2C6469616C656374733A7B63616D756E64613A323533327D2C64796E616D6963507265636564656E6365733A7B33313A2D312C36383A312C37323A2D312C37343A2D317D2C7370656369616C697A65643A5B7B7465';
wwv_flow_imp.g_varchar2_table(47323) := '726D3A3132322C6765743A653D3E6B425B655D7C7C2D317D5D2C746F6B656E507265633A323533347D293B66756E6374696F6E204C422865297B636F6E737420743D5B5D3B72657475726E20652E69746572617465287B656E7465723A653D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(47324) := '7374206E3D652E6E6F64653B696628216E2E747970652E69734572726F722972657475726E3B636F6E737420693D6E2E706172656E742C6F3D4442286E292C733D7B66726F6D3A6E2E66726F6D2C746F3A6E2E746F2C73657665726974793A226572726F';
wwv_flow_imp.g_varchar2_table(47325) := '72222C747970653A2253796E746178204572726F72227D3B6966286E2E66726F6D213D3D6E2E746F29732E6D6573736167653D60556E7265636F676E697A656420746F6B656E20696E203C247B692E6E616D657D3E603B656C7365206966286F29732E6D';
wwv_flow_imp.g_varchar2_table(47326) := '6573736167653D60556E7265636F676E697A656420746F6B656E203C247B6F2E6E616D657D3E20696E203C247B692E6E616D657D3E602C732E746F3D6F2E746F3B656C73657B636F6E737420653D692E656E746572556E66696E69736865644E6F646573';
wwv_flow_imp.g_varchar2_table(47327) := '4265666F7265286E2E746F293B732E6D6573736167653D60496E636F6D706C657465203C247B28657C7C69292E6E616D657D3E607D742E707573682873297D7D292C747D66756E6374696F6E2044422865297B72657475726E20653F652E6E6578745369';
wwv_flow_imp.g_varchar2_table(47328) := '626C696E677C7C444228652E706172656E74293A6E756C6C7D636F6E73742054423D5B7B6372656174653A653D3E287B656E7465722874297B6966282246696C74657245787072657373696F6E22213D3D742E6E616D652972657475726E3B636F6E7374';
wwv_flow_imp.g_varchar2_table(47329) := '206E3D652E72656164436F6E74656E7428742E66726F6D2C742E746F293B6966282F5C5B5C732A305C732A5C5D242F2E74657374286E29297B636F6E73747B66726F6D3A692C746F3A6F7D3D743B652E7265706F7274287B66726F6D3A692C746F3A6F2C';
wwv_flow_imp.g_varchar2_table(47330) := '6D6573736167653A224669727374206974656D20697320616363657373656420766961205B315D222C73657665726974793A226572726F72222C747970653A2266697273742D6974656D222C616374696F6E733A5B7B6E616D653A22666978222C617070';
wwv_flow_imp.g_varchar2_table(47331) := '6C7928742C733D692C723D6F297B652E757064617465436F6E74656E7428732C722C6E2E7265706C616365282F5C5B5C732A305C732A5C5D242F2C225B315D2229297D7D5D7D297D7D7D297D5D3B66756E6374696F6E2049422865297B636F6E73747B72';
wwv_flow_imp.g_varchar2_table(47332) := '656164436F6E74656E743A742C73796E746178547265653A6E2C757064617465436F6E74656E743A697D3D652C6F3D5B5D2C733D7B72656164436F6E74656E743A742C7265706F72743A653D3E7B6F2E707573682865297D2C757064617465436F6E7465';
wwv_flow_imp.g_varchar2_table(47333) := '6E743A697D2C723D54422E6D61702828653D3E652E63726561746528732929293B72657475726E206E2E69746572617465287B656E7465723A653D3E7B666F7228636F6E73742074206F66207229742E656E7465722626742E656E7465722865297D2C6C';
wwv_flow_imp.g_varchar2_table(47334) := '656176653A653D3E7B666F7228636F6E73742074206F66207229742E6C656176652626742E6C656176652865297D7D292C6F7D636F6E7374204D423D28293D3E653D3E7B696628303D3D3D652E73746174652E646F632E6C656E6774682972657475726E';
wwv_flow_imp.g_varchar2_table(47335) := '5B5D3B636F6E737420743D286E3D7B73796E746178547265653A564D28652E7374617465292C72656164436F6E74656E743A28742C6E293D3E652E73746174652E736C696365446F6328742C6E292C757064617465436F6E74656E743A28742C6E2C6929';
wwv_flow_imp.g_varchar2_table(47336) := '3D3E652E6469737061746368287B6368616E6765733A7B66726F6D3A742C746F3A6E2C696E736572743A697D7D297D2C5B2E2E2E4C42286E2E73796E74617854726565292C2E2E2E4942286E295D293B766172206E3B72657475726E20742E6D61702828';
wwv_flow_imp.g_varchar2_table(47337) := '653D3E287B2E2E2E652C736F757263653A652E747970657D2929297D2C41423D5F41286D412E646566696E65285B7B7461673A52782E7374726F6E672C666F6E745765696768743A22626F6C64227D2C7B7461673A52782E656D7068617369732C666F6E';
wwv_flow_imp.g_varchar2_table(47338) := '745374796C653A226974616C6963227D5D29293B766172204E423D5B44492E7468656D65287B2226202E636D2D6C696E7452616E6765223A7B706F736974696F6E3A2272656C6174697665227D2C2226202E636D2D6C696E7452616E67653A3A61667465';
wwv_flow_imp.g_varchar2_table(47339) := '72223A7B636F6E74656E743A272222272C77696474683A2231303025222C706F736974696F6E3A226162736F6C757465222C6C6566743A22307078222C626F74746F6D3A222D327078222C6865696768743A22337078222C6261636B67726F756E645265';
wwv_flow_imp.g_varchar2_table(47340) := '706561743A227265706561742D78227D2C2226202E636D2D6C696E7452616E67652E636D2D6C696E7452616E67652D7761726E696E672C2026202E636D2D6C696E7452616E67652E636D2D6C696E7452616E67652D6572726F72223A7B6261636B67726F';
wwv_flow_imp.g_varchar2_table(47341) := '756E64496D6167653A226E6F6E65227D2C2226202E636D2D6C696E74506F696E743A3A6166746572223A7B626F74746F6D3A222D327078227D7D292C41425D3B636F6E73742050423D653D3E60253233247B652E736C6963652831297D602C4F423D7B62';
wwv_flow_imp.g_varchar2_table(47342) := '6C61636B3A2223316632623336222C6461726B477265793A2223326633643538222C677265793A2223343034613563222C6D6964477265793A2223353736303731222C6C69676874477265793A2223633564316535222C6F666657686974653A22236439';
wwv_flow_imp.g_varchar2_table(47343) := '65306635222C736E6F7757686974653A2223656166316666222C77686974653A2223666666666666222C6D6F7373477265656E3A2223376162366161222C696365426C75653A2223366362666438222C7761746572426C75653A2223303635616161222C';
wwv_flow_imp.g_varchar2_table(47344) := '627269676874426C75653A2223306135366239222C64656570426C75653A2223333535343732222C7265643A2223396631633135222C6F72616E676542726F776E3A2223623435303266222C79656C6C6F773A2223646562643731222C6C696C613A2223';
wwv_flow_imp.g_varchar2_table(47345) := '396134383930222C707572706C653A2223356232633833227D2C52423D7B6C696768744261636B67726F756E643A4F422E77686974652C6461726B4261636B67726F756E643A4F422E736E6F7757686974652C73656C656374696F6E3A4F422E736E6F77';
wwv_flow_imp.g_varchar2_table(47346) := '57686974652C746F6F6C7469704261636B67726F756E643A4F422E6F666657686974652C6572726F723A4F422E7265642C7761726E696E673A4F422E79656C6C6F772C696E76616C69643A2223623430303030227D3B7661722046423D5B44492E746865';
wwv_flow_imp.g_varchar2_table(47347) := '6D65287B2226223A7B636F6C6F723A4F422E626C61636B2C6261636B67726F756E64436F6C6F723A52422E6C696768744261636B67726F756E647D2C222E636D2D636F6E74656E74223A7B6361726574436F6C6F723A4F422E6461726B477265797D2C22';
wwv_flow_imp.g_varchar2_table(47348) := '2E636D2D637572736F722C202E636D2D64726F70437572736F72223A7B626F726465724C656674436F6C6F723A4F422E6461726B477265797D2C22262E636D2D666F6375736564202E636D2D73656C656374696F6E4261636B67726F756E642C202E636D';
wwv_flow_imp.g_varchar2_table(47349) := '2D73656C656374696F6E4261636B67726F756E642C202E636D2D636F6E74656E74203A3A73656C656374696F6E223A7B6261636B67726F756E64436F6C6F723A52422E73656C656374696F6E7D2C222E636D2D70616E656C73223A7B6261636B67726F75';
wwv_flow_imp.g_varchar2_table(47350) := '6E64436F6C6F723A52422E6461726B4261636B67726F756E642C636F6C6F723A4F422E677265797D2C222E636D2D70616E656C732E636D2D70616E656C732D746F70223A7B626F72646572426F74746F6D3A6032707820736F6C696420247B4F422E626C';
wwv_flow_imp.g_varchar2_table(47351) := '61636B7D607D2C222E636D2D70616E656C732E636D2D70616E656C732D626F74746F6D223A7B626F72646572546F703A6032707820736F6C696420247B4F422E626C61636B7D607D2C222E636D2D7365617263684D61746368223A7B6261636B67726F75';
wwv_flow_imp.g_varchar2_table(47352) := '6E64436F6C6F723A22233732613166663539222C6F75746C696E653A6031707820736F6C696420247B4F422E6D6964477265797D607D2C222E636D2D7365617263684D617463682E636D2D7365617263684D617463682D73656C6563746564223A7B6261';
wwv_flow_imp.g_varchar2_table(47353) := '636B67726F756E64436F6C6F723A4F422E6F666657686974657D2C222E636D2D6163746976654C696E65223A7B6261636B67726F756E64436F6C6F723A52422E73656C656374696F6E7D2C222E636D2D73656C656374696F6E4D61746368223A7B626163';
wwv_flow_imp.g_varchar2_table(47354) := '6B67726F756E64436F6C6F723A4F422E6F666657686974657D2C22262E636D2D666F6375736564202E636D2D6D61746368696E67427261636B65742C20262E636D2D666F6375736564202E636D2D6E6F6E6D61746368696E67427261636B6574223A7B6F';
wwv_flow_imp.g_varchar2_table(47355) := '75746C696E653A6031707820736F6C696420247B4F422E677265797D607D2C22262E636D2D666F6375736564202E636D2D6D61746368696E67427261636B6574223A7B6261636B67726F756E64436F6C6F723A4F422E736E6F7757686974657D2C222E63';
wwv_flow_imp.g_varchar2_table(47356) := '6D2D67757474657273223A7B6261636B67726F756E64436F6C6F723A2223663366376665222C636F6C6F723A2223353236363864222C626F726465723A226E6F6E65222C70616464696E673A223020357078227D2C222E636D2D6163746976654C696E65';
wwv_flow_imp.g_varchar2_table(47357) := '477574746572223A7B6261636B67726F756E64436F6C6F723A52422E73656C656374696F6E7D2C222E636D2D666F6C64506C616365686F6C646572223A7B6261636B67726F756E64436F6C6F723A227472616E73706172656E74222C626F726465723A22';
wwv_flow_imp.g_varchar2_table(47358) := '6E6F6E65222C636F6C6F723A2223646464227D2C222E636D2D746F6F6C746970223A7B626F726465723A226E6F6E65222C6261636B67726F756E64436F6C6F723A52422E746F6F6C7469704261636B67726F756E647D2C222E636D2D746F6F6C74697020';
wwv_flow_imp.g_varchar2_table(47359) := '2E636D2D746F6F6C7469702D6172726F773A6265666F7265223A7B626F72646572546F70436F6C6F723A227472616E73706172656E74222C626F72646572426F74746F6D436F6C6F723A227472616E73706172656E74227D2C222E636D2D746F6F6C7469';
wwv_flow_imp.g_varchar2_table(47360) := '70202E636D2D746F6F6C7469702D6172726F773A6166746572223A7B626F72646572546F70436F6C6F723A52422E746F6F6C7469704261636B67726F756E642C626F72646572426F74746F6D436F6C6F723A52422E746F6F6C7469704261636B67726F75';
wwv_flow_imp.g_varchar2_table(47361) := '6E647D2C222E636D2D746F6F6C7469702D6175746F636F6D706C657465223A7B2226203E20756C203E206C695B617269612D73656C65637465645D223A7B6261636B67726F756E64436F6C6F723A52422E6461726B4261636B67726F756E642C636F6C6F';
wwv_flow_imp.g_varchar2_table(47362) := '723A4F422E6D6964477265797D7D2C2226202E636D2D6C696E7452616E67652E636D2D6C696E7452616E67652D7761726E696E673A3A6166746572223A7B6261636B67726F756E64496D6167653A6075726C2822646174613A696D6167652F7376672B78';
wwv_flow_imp.g_varchar2_table(47363) := '6D6C2C3C73766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272077696474683D273627206865696768743D2733273E3C7061746820643D276D3020322E35206C32202D312E35206C312030206C3220312E3520';
wwv_flow_imp.g_varchar2_table(47364) := '6C31203027207374726F6B653D27247B50422852422E7761726E696E67297D272066696C6C3D276E6F6E6527207374726F6B652D77696474683D27312E32272F3E3C2F7376673E2229607D2C2226202E636D2D6C696E7452616E67652E636D2D6C696E74';
wwv_flow_imp.g_varchar2_table(47365) := '52616E67652D6572726F723A3A6166746572223A7B6261636B67726F756E64496D6167653A6075726C2822646174613A696D6167652F7376672B786D6C2C3C73766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667';
wwv_flow_imp.g_varchar2_table(47366) := '272077696474683D273627206865696768743D2733273E3C7061746820643D276D3020322E35206C32202D312E35206C312030206C3220312E35206C31203027207374726F6B653D27247B50422852422E6572726F72297D272066696C6C3D276E6F6E65';
wwv_flow_imp.g_varchar2_table(47367) := '27207374726F6B652D77696474683D27312E32272F3E3C2F7376673E2229607D2C2226202E636D2D646961676E6F737469632D7761726E696E67223A7B626F726465723A6031707820736F6C696420247B52422E7761726E696E677D602C626F72646572';
wwv_flow_imp.g_varchar2_table(47368) := '4C6566743A6035707820736F6C696420247B52422E7761726E696E677D602C6261636B67726F756E643A52422E6C696768744261636B67726F756E647D2C2226202E636D2D646961676E6F737469632D6572726F72223A7B626F726465723A6031707820';
wwv_flow_imp.g_varchar2_table(47369) := '736F6C696420247B52422E6572726F727D602C626F726465724C6566743A6035707820736F6C696420247B52422E6572726F727D602C6261636B67726F756E643A52422E6C696768744261636B67726F756E647D2C2226202E636D2D646961676E6F7374';
wwv_flow_imp.g_varchar2_table(47370) := '6963223A7B70616464696E673A2233707820387078227D7D2C7B6461726B3A21317D292C5F41286D412E646566696E65285B7B7461673A5B52782E6D6163726F4E616D652C52782E7661726961626C654E616D655D2C636F6C6F723A4F422E7761746572';
wwv_flow_imp.g_varchar2_table(47371) := '426C75657D2C7B7461673A5B52782E7370656369616C2852782E627261636B6574295D2C636F6C6F723A4F422E7761746572426C75652C666F6E745765696768743A22626F6C64227D2C7B7461673A5B52782E636F6C6F722C52782E6E616D652C52782E';
wwv_flow_imp.g_varchar2_table(47372) := '646566696E6974696F6E2852782E6E616D65292C52782E636F6E7374616E742852782E6E616D65292C52782E7374616E646172642852782E6E616D65292C52782E70726F70657274794E616D655D2C636F6C6F723A4F422E64656570426C75657D2C7B74';
wwv_flow_imp.g_varchar2_table(47373) := '61673A5B52782E646566696E6974696F6E2852782E7661726961626C654E616D65292C52782E66756E6374696F6E2852782E7661726961626C654E616D65292C52782E66756E6374696F6E2852782E70726F70657274794E616D65295D2C636F6C6F723A';
wwv_flow_imp.g_varchar2_table(47374) := '4F422E627269676874426C75657D2C7B7461673A5B52782E6C6162656C4E616D655D2C636F6C6F723A4F422E6F72616E676542726F776E7D2C7B7461673A5B52782E616E6E6F746174696F6E5D2C636F6C6F723A52422E696E76616C69647D2C7B746167';
wwv_flow_imp.g_varchar2_table(47375) := '3A5B52782E6E756D6265722C52782E6368616E6765642C52782E616E6E6F746174696F6E2C52782E6D6F6469666965722C52782E73656C662C52782E6E616D6573706163652C52782E61746F6D2C52782E626F6F6C2C52782E7370656369616C2852782E';
wwv_flow_imp.g_varchar2_table(47376) := '7661726961626C654E616D65295D2C636F6C6F723A4F422E7265647D2C7B7461673A5B52782E747970654E616D652C52782E636C6173734E616D652C52782E6174747269627574654E616D655D2C636F6C6F723A4F422E6C696C617D2C7B7461673A5B52';
wwv_flow_imp.g_varchar2_table(47377) := '782E6F70657261746F722C52782E6F70657261746F724B6579776F72642C52782E7461674E616D652C52782E6B6579776F72645D2C636F6C6F723A4F422E707572706C657D2C7B7461673A5B52782E616E676C65427261636B65742C52782E7371756172';
wwv_flow_imp.g_varchar2_table(47378) := '65427261636B65742C52782E62726163652C52782E736570617261746F722C52782E70756E6374756174696F6E5D2C636F6C6F723A4F422E6D6964477265797D2C7B7461673A5B52782E7265676578705D2C636F6C6F723A4F422E64656570426C75657D';
wwv_flow_imp.g_varchar2_table(47379) := '2C7B7461673A5B52782E71756F74655D2C636F6C6F723A4F422E6461726B477265797D2C7B7461673A5B52782E737472696E672C52782E6368617261637465722C52782E64656C657465645D2C636F6C6F723A4F422E6F72616E676542726F776E7D2C7B';
wwv_flow_imp.g_varchar2_table(47380) := '7461673A52782E6C696E6B2C636F6C6F723A4F422E6D6F7373477265656E2C746578744465636F726174696F6E3A22756E6465726C696E65222C74657874556E6465726C696E65506F736974696F6E3A22756E646572227D2C7B7461673A5B52782E7572';
wwv_flow_imp.g_varchar2_table(47381) := '6C2C52782E6573636170652C52782E7370656369616C2852782E737472696E67295D2C636F6C6F723A4F422E7265647D2C7B7461673A5B52782E6D6574615D2C636F6C6F723A4F422E696365426C75657D2C7B7461673A5B52782E636F6D6D656E745D2C';
wwv_flow_imp.g_varchar2_table(47382) := '636F6C6F723A4F422E6D6964477265792C666F6E745374796C653A226974616C6963227D2C7B7461673A52782E7374726F6E672C666F6E745765696768743A22626F6C64222C636F6C6F723A4F422E64656570426C75657D2C7B7461673A52782E656D70';
wwv_flow_imp.g_varchar2_table(47383) := '68617369732C666F6E745374796C653A226974616C6963222C636F6C6F723A4F422E64656570426C75657D2C7B7461673A52782E737472696B657468726F7567682C746578744465636F726174696F6E3A226C696E652D7468726F756768227D2C7B7461';
wwv_flow_imp.g_varchar2_table(47384) := '673A52782E68656164696E672C666F6E745765696768743A22626F6C64222C636F6C6F723A4F422E6D6964477261797D2C7B7461673A52782E7370656369616C2852782E68656164696E6731292C666F6E745765696768743A22626F6C64222C636F6C6F';
wwv_flow_imp.g_varchar2_table(47385) := '723A4F422E6461726B477265797D2C7B7461673A5B52782E68656164696E67312C52782E68656164696E67322C52782E68656164696E67332C52782E68656164696E67345D2C666F6E745765696768743A22626F6C64222C636F6C6F723A4F422E6D6964';
wwv_flow_imp.g_varchar2_table(47386) := '477265797D2C7B7461673A5B52782E68656164696E67352C52782E68656164696E67362C52782E70726F63657373696E67496E737472756374696F6E2C52782E696E7365727465645D2C636F6C6F723A4F422E677265797D2C7B7461673A5B52782E636F';
wwv_flow_imp.g_varchar2_table(47387) := '6E74656E74536570617261746F725D2C636F6C6F723A4F422E79656C6C6F777D2C7B7461673A52782E696E76616C69642C636F6C6F723A4F422E6D6964477265792C626F72646572426F74746F6D3A6031707820646F7474656420247B52422E696E7661';
wwv_flow_imp.g_varchar2_table(47388) := '6C69647D607D5D29295D3B636F6E73742042423D2223663037313738222C56423D2223666666636531222C7A423D2223656339653666222C48423D227267626128302C20302C20302C20302E3529222C57423D2223333533613432222C6A423D22236666';
wwv_flow_imp.g_varchar2_table(47389) := '63633030222C71423D22666666383930223B7661722024423D5B44492E7468656D65287B2226223A7B636F6C6F723A2223666666666666222C6261636B67726F756E64436F6C6F723A2223323932643365227D2C222E636D2D636F6E74656E74223A7B63';
wwv_flow_imp.g_varchar2_table(47390) := '61726574436F6C6F723A6A427D2C22262E636D2D666F6375736564202E636D2D637572736F72223A7B626F726465724C656674436F6C6F723A6A427D2C22262E636D2D666F6375736564202E636D2D73656C656374696F6E4261636B67726F756E642C20';
wwv_flow_imp.g_varchar2_table(47391) := '2E636D2D73656C656374696F6E4261636B67726F756E642C202E636D2D636F6E74656E74203A3A73656C656374696F6E223A7B6261636B67726F756E64436F6C6F723A2272676261283132382C203230332C203139362C20302E3229227D2C222E636D2D';
wwv_flow_imp.g_varchar2_table(47392) := '70616E656C73223A7B6261636B67726F756E64436F6C6F723A2223323132353262222C636F6C6F723A2223666666666666227D2C222E636D2D70616E656C732E636D2D70616E656C732D746F70223A7B626F72646572426F74746F6D3A2232707820736F';
wwv_flow_imp.g_varchar2_table(47393) := '6C696420626C61636B227D2C222E636D2D70616E656C732E636D2D70616E656C732D626F74746F6D223A7B626F72646572546F703A2232707820736F6C696420626C61636B227D2C222E636D2D7365617263684D61746368223A7B6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(47394) := '64436F6C6F723A22233732613166663539222C6F75746C696E653A2231707820736F6C69642023343537646666227D2C222E636D2D7365617263684D617463682E636D2D7365617263684D617463682D73656C6563746564223A7B6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(47395) := '64436F6C6F723A22233631393966663266227D2C222E636D2D6163746976654C696E65223A7B6261636B67726F756E64436F6C6F723A48427D2C222E636D2D73656C656374696F6E4D61746368223A7B6261636B67726F756E64436F6C6F723A22236161';
wwv_flow_imp.g_varchar2_table(47396) := '666536363161227D2C22262E636D2D666F6375736564202E636D2D6D61746368696E67427261636B65742C20262E636D2D666F6375736564202E636D2D6E6F6E6D61746368696E67427261636B6574223A7B6261636B67726F756E64436F6C6F723A2223';
wwv_flow_imp.g_varchar2_table(47397) := '6261643066383437222C6F75746C696E653A2231707820736F6C69642023353135613662227D2C222E636D2D67757474657273223A7B6261636B67726F756E643A2223323932643365222C636F6C6F723A2223363736653935222C626F726465723A226E';
wwv_flow_imp.g_varchar2_table(47398) := '6F6E65222C70616464696E673A223020357078227D2C222E636D2D6163746976654C696E65477574746572223A7B6261636B67726F756E64436F6C6F723A48427D2C222E636D2D666F6C64506C616365686F6C646572223A7B6261636B67726F756E6443';
wwv_flow_imp.g_varchar2_table(47399) := '6F6C6F723A227472616E73706172656E74222C626F726465723A226E6F6E65222C636F6C6F723A2223646464227D2C222E636D2D746F6F6C746970223A7B626F726465723A226E6F6E65222C6261636B67726F756E64436F6C6F723A57427D2C222E636D';
wwv_flow_imp.g_varchar2_table(47400) := '2D746F6F6C746970202E636D2D746F6F6C7469702D6172726F773A6265666F7265223A7B626F72646572546F70436F6C6F723A227472616E73706172656E74222C626F72646572426F74746F6D436F6C6F723A227472616E73706172656E74227D2C222E';
wwv_flow_imp.g_varchar2_table(47401) := '636D2D746F6F6C746970202E636D2D746F6F6C7469702D6172726F773A6166746572223A7B626F72646572546F70436F6C6F723A57422C626F72646572426F74746F6D436F6C6F723A57427D2C222E636D2D746F6F6C7469702D6175746F636F6D706C65';
wwv_flow_imp.g_varchar2_table(47402) := '7465223A7B2226203E20756C203E206C695B617269612D73656C65637465645D223A7B6261636B67726F756E64436F6C6F723A48422C636F6C6F723A2223616262326266227D7D2C2226202E636D2D6C696E7452616E67652E636D2D6C696E7452616E67';
wwv_flow_imp.g_varchar2_table(47403) := '652D7761726E696E673A3A6166746572223A7B6261636B67726F756E64496D6167653A6075726C2822646174613A696D6167652F7376672B786D6C2C3C73766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F7376672720';
wwv_flow_imp.g_varchar2_table(47404) := '77696474683D273627206865696768743D2733273E3C7061746820643D276D3020322E35206C32202D312E35206C312030206C3220312E35206C31203027207374726F6B653D27247B22253233222B71427D272066696C6C3D276E6F6E6527207374726F';
wwv_flow_imp.g_varchar2_table(47405) := '6B652D77696474683D27312E32272F3E3C2F7376673E2229607D2C2226202E636D2D6C696E7452616E67652E636D2D6C696E7452616E67652D6572726F723A3A6166746572223A7B6261636B67726F756E64496D6167653A2275726C285C22646174613A';
wwv_flow_imp.g_varchar2_table(47406) := '696D6167652F7376672B786D6C2C3C73766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272077696474683D273627206865696768743D2733273E3C7061746820643D276D3020322E35206C32202D312E35206C';
wwv_flow_imp.g_varchar2_table(47407) := '312030206C3220312E35206C31203027207374726F6B653D27726564272066696C6C3D276E6F6E6527207374726F6B652D77696474683D27312E32272F3E3C2F7376673E5C2229227D2C2226202E636D2D646961676E6F737469632D7761726E696E6722';
wwv_flow_imp.g_varchar2_table(47408) := '3A7B626F726465724C6566743A6035707820736F6C69642023247B71427D602C6261636B67726F756E643A2223323831653136227D2C2226202E636D2D646961676E6F737469632D6572726F72223A7B626F726465724C6566743A2235707820736F6C69';
wwv_flow_imp.g_varchar2_table(47409) := '6420726564222C6261636B67726F756E643A2223323831363136227D2C2226202E636D2D646961676E6F73746963223A7B626F726465725261646975733A22327078222C70616464696E673A2233707820387078227D7D2C7B6461726B3A21307D292C5F';
wwv_flow_imp.g_varchar2_table(47410) := '41286D412E646566696E65285B7B7461673A52782E68656164696E67312C636F6C6F723A56427D2C7B7461673A52782E68656164696E67322C636F6C6F723A56427D2C7B7461673A52782E68656164696E67332C636F6C6F723A56427D2C7B7461673A52';
wwv_flow_imp.g_varchar2_table(47411) := '782E68656164696E67342C636F6C6F723A56427D2C7B7461673A52782E68656164696E67352C636F6C6F723A56427D2C7B7461673A52782E68656164696E67362C636F6C6F723A56427D2C7B7461673A52782E7370656369616C2852782E627261636B65';
wwv_flow_imp.g_varchar2_table(47412) := '74292C636F6C6F723A7A422C666F6E745765696768743A22626F6C64227D2C7B7461673A52782E6B6579776F72642C636F6C6F723A2223633739326561227D2C7B7461673A52782E6F70657261746F722C636F6C6F723A2223383964646666227D2C7B74';
wwv_flow_imp.g_varchar2_table(47413) := '61673A52782E7370656369616C2852782E7661726961626C654E616D65292C636F6C6F723A2223656566666666227D2C7B7461673A52782E747970654E616D652C636F6C6F723A2223663037313738227D2C7B7461673A52782E61746F6D2C636F6C6F72';
wwv_flow_imp.g_varchar2_table(47414) := '3A2223663738633663227D2C7B7461673A52782E6E756D6265722C636F6C6F723A2223666635333730227D2C7B7461673A52782E626F6F6C2C636F6C6F723A2223666635333730227D2C7B7461673A52782E646566696E6974696F6E2852782E76617269';
wwv_flow_imp.g_varchar2_table(47415) := '61626C654E616D65292C636F6C6F723A2223383261616666227D2C7B7461673A52782E737472696E672C636F6C6F723A2223633365383864227D2C7B7461673A52782E636F6D6D656E742C636F6C6F723A2223376438373939227D2C7B7461673A52782E';
wwv_flow_imp.g_varchar2_table(47416) := '7461674E616D652C636F6C6F723A2223666635333730227D2C7B7461673A52782E627261636B65742C636F6C6F723A2223613261316134227D2C7B7461673A52782E6D6574612C636F6C6F723A2223666663623662227D2C7B7461673A52782E73706563';
wwv_flow_imp.g_varchar2_table(47417) := '69616C2852782E737472696E67292C636F6C6F723A42427D2C7B7461673A52782E70726F70657274794E616D652C636F6C6F723A7A427D2C7B7461673A52782E7661726961626C654E616D652C636F6C6F723A7A427D2C7B7461673A52782E6174747269';
wwv_flow_imp.g_varchar2_table(47418) := '627574654E616D652C636F6C6F723A42427D2C7B7461673A52782E636C6173734E616D652C636F6C6F723A42427D2C7B7461673A52782E696E76616C69642C636F6C6F723A2223666666666666227D5D29295D3B636F6E73742055423D5B2E2E2E4E422C';
wwv_flow_imp.g_varchar2_table(47419) := '2E2E2E46425D2C4B423D5B2E2E2E4E422C2E2E2E24425D2C47423D28652C743D30293D3E7B636F6E7374206E3D3132353D3D3D652E7065656B2874292C693D3132353D3D3D652E7065656B28742B31293B72657475726E206E2626697C7C2D313D3D3D65';
wwv_flow_imp.g_varchar2_table(47420) := '2E7065656B2874297D2C51423D6E6577205153282828652C74293D3E7B6C6574206E3D303B666F72283B21474228652C6E293B296E2B2B3B6E3E30262628652E616476616E6365286E292C652E616363657074546F6B656E283229297D29292C59423D28';
wwv_flow_imp.g_varchar2_table(47421) := '652C743D30293D3E7B636F6E7374206E3D3132333D3D3D652E7065656B2874292C693D3132333D3D3D652E7065656B28742B31293B72657475726E206E2626697C7C2D313D3D3D652E7065656B2874297D2C5A423D6E6577205153282828652C74293D3E';
wwv_flow_imp.g_varchar2_table(47422) := '7B6C6574206E3D303B666F72283B21594228652C6E293B296E2B2B3B6E3E30262628652E616476616E6365286E292C652E616363657074546F6B656E283329297D29292C58423D6E6577205153282828652C74293D3E7B6C6574206E3D303B666F72283B';
wwv_flow_imp.g_varchar2_table(47423) := '2D31213D3D652E7065656B286E293B296E2B2B3B6E3E30262628652E616476616E6365286E292C652E616363657074546F6B656E283129297D29292C4A423D6D78287B436F6E646974696F6E616C5370616E6E65723A52782E7370656369616C2852782E';
wwv_flow_imp.g_varchar2_table(47424) := '627261636B6574292C436F6E646974696F6E616C5370616E6E6572436C6F73653A52782E7370656369616C2852782E627261636B6574292C436F6E646974696F6E616C5370616E6E6572436C6F73654E6C3A52782E7370656369616C2852782E62726163';
wwv_flow_imp.g_varchar2_table(47425) := '6B6574292C4C6F6F705370616E6E65723A52782E7370656369616C2852782E627261636B6574292C4C6F6F705370616E6E6572436C6F73653A52782E7370656369616C2852782E627261636B6574292C4C6F6F705370616E6E6572436C6F73654E6C3A52';
wwv_flow_imp.g_varchar2_table(47426) := '782E7370656369616C2852782E627261636B6574292C456D707479496E736572743A52782E7370656369616C2852782E627261636B6574292C496E736572743A52782E7370656369616C2852782E627261636B6574297D292C65563D6C782E6465736572';
wwv_flow_imp.g_varchar2_table(47427) := '69616C697A65287B76657273696F6E3A31342C7374617465733A2224624F514F614F4F4F664F584F272343624F4F4F602723436D2723436D4F714F574F272343634F764F574F272343664F4F4F6027234370272343704F4F4F6027234369272343694F7B';
wwv_flow_imp.g_varchar2_table(47428) := '4F614F2723436C4F216A4F534F4F514F4F4F4F4F4F216F4F504F2C35387B4F21744F584F2C35387C4F4F4F602C35387C2C35387C4F217C4F514F2C35387D4F23524F514F2C3539514F4F4F602D4536672D4536674F4F4F6031472E6731472E674F23574F';
wwv_flow_imp.g_varchar2_table(47429) := '504F31472E674F4F4F6031472E6831472E684F235D4F614F31472E694F23714F614F31472E6C4F4F4F60372B2452372B24524F24564F504F372B24544F245F4F504F372B24574F4F4F603C3C476F3C3C476F4F4F4F603C3C47723C3C4772222C73746174';
wwv_flow_imp.g_varchar2_table(47430) := '65446174613A2224677E4F52554F5F574F62504F65524F67534F5E60507E4F51594F5F5A4F635B4F7E4F515D4F7E4F515E4F7E4F52554F62504F65524F67534F5E60585760585860585A60585B60587E4F50584F7E4F63604F7E4F51614F63624F7E4F66';
wwv_flow_imp.g_varchar2_table(47431) := '634F7E4F66644F7E4F63654F7E4F52554F62504F65524F67534F5760505860507E4F52554F62504F65524F67534F5A60505B60507E4F57684F58684F7E4F5A694F5B694F7E4F222C676F746F3A22215A65505050505066666C50506C50507250507A2154';
wwv_flow_imp.g_varchar2_table(47432) := '5050215458514F56636458544F56636455564F6364525F5651584F51666352676458554F566364222C6E6F64654E616D65733A22E29AA0204665656C204665656C426C6F636B2053696D706C6554657874426C6F636B204665656C65727320496E736572';
wwv_flow_imp.g_varchar2_table(47433) := '7420456D707479496E7365727420436F6E646974696F6E616C5370616E6E657220436F6E646974696F6E616C5370616E6E6572436C6F736520436F6E646974696F6E616C5370616E6E6572436C6F73654E6C204C6F6F705370616E6E6572204C6F6F7053';
wwv_flow_imp.g_varchar2_table(47434) := '70616E6E6572436C6F7365204C6F6F705370616E6E6572436C6F73654E6C222C6D61785465726D3A32332C70726F70536F75726365733A5B4A425D2C736B69707065644E6F6465733A5B305D2C7265706561744E6F6465436F756E743A312C746F6B656E';
wwv_flow_imp.g_varchar2_table(47435) := '446174613A2225587E5252215F21605B236F2370612371237224727E614F5F7E7E6450236F2370677E6C51627E73747221502151217B7E7551235D235E7B23602361215E7E214F502359235A21527E215550707121587E215E4F657E7E21615023632364';
wwv_flow_imp.g_varchar2_table(47436) := '21647E21675023632364216A7E216D502364236521707E217350707121767E217B4F677E7E234F51235D235E23552360236123757E2358502359235A235B7E235F502371237223627E2365502371237223687E236D50577E595A23707E23754F587E7E23';
wwv_flow_imp.g_varchar2_table(47437) := '785023632364237B7E244F502363236424527E2455502364236524587E245B5023712372245F7E2462502371237224657E246A505A7E595A246D7E24724F5B7E522475502371237224785225505063506651595A25535125584F6651222C746F6B656E69';
wwv_flow_imp.g_varchar2_table(47438) := '7A6572733A5B302C312C58422C51422C5A425D2C746F7052756C65733A7B4665656C6572733A5B302C345D7D2C746F6B656E507265633A307D292C74563D7B436F6E646974696F6E616C5370616E6E65723A67412C4C6F6F705370616E6E65723A67417D';
wwv_flow_imp.g_varchar2_table(47439) := '3B66756E6374696F6E206E562865297B636F6E737420743D5B5D3B72657475726E20652E69746572617465287B656E7465723A653D3E7B22456D707479496E73657274223D3D3D652E747970652E6E616D652626742E70757368287B66726F6D3A652E66';
wwv_flow_imp.g_varchar2_table(47440) := '726F6D2C746F3A652E746F2C73657665726974793A227761726E696E67222C6D6573736167653A227468697320696E7365727420697320656D70747920616E642077696C6C2062652069676E6F726564222C747970653A22656D707479496E7365727422';
wwv_flow_imp.g_varchar2_table(47441) := '7D297D7D292C747D7661722069563D714F2866756E6374696F6E28297B636F6E737420653D4D4228293B72657475726E20743D3E7B636F6E7374206E3D652874293B72657475726E20303D3D3D742E73746174652E646F632E6C656E6774683F5B5D3A5B';
wwv_flow_imp.g_varchar2_table(47442) := '2E2E2E6E2C2E2E2E28693D564D28742E7374617465292C5B2E2E2E6E562869295D292E6D61702828653D3E287B2E2E2E652C736F757263653A226665656C657273206C696E746572227D2929295D3B76617220697D7D2829293B66756E6374696F6E206F';
wwv_flow_imp.g_varchar2_table(47443) := '56287B636F6E7461696E65723A652C746F6F6C746970436F6E7461696E65723A742C686F73744C616E67756167653A6E2C686F73744C616E67756167655061727365723A692C6F6E4368616E67653A6F3D28293D3E7B7D2C6F6E4B6579446F776E3A733D';
wwv_flow_imp.g_varchar2_table(47444) := '28293D3E7B7D2C6F6E4C696E743A723D28293D3E7B7D2C636F6E74656E74417474726962757465733A613D7B7D2C726561644F6E6C793A6C3D21312C76616C75653A633D22222C656E61626C65477574746572733A643D21312C73696E676C654C696E65';
wwv_flow_imp.g_varchar2_table(47445) := '3A683D21312C6C696E65577261703A753D21312C6461726B4D6F64653A703D21317D297B636F6E737420673D44492E7570646174654C697374656E65722E6F662828653D3E7B652E646F634368616E67656426266F28652E73746174652E646F632E746F';
wwv_flow_imp.g_varchar2_table(47446) := '537472696E672829297D29292C6D3D44492E7570646174654C697374656E65722E6F662828653D3E7B636F6E737420743D652E7472616E73616374696F6E732E666C61744D61702828653D3E652E6566666563747329292E66696C7465722828653D3E65';
wwv_flow_imp.g_varchar2_table(47447) := '2E697328504F2929293B69662821742E6C656E6774682972657475726E3B636F6E7374206E3D742E666C61744D61702828653D3E652E76616C756529293B72286E297D29292C663D44492E636F6E74656E74417474726962757465732E6F662861292C76';
wwv_flow_imp.g_varchar2_table(47448) := '3D44492E646F6D4576656E7448616E646C657273287B6B6579646F776E3A737D293B22737472696E67223D3D747970656F662074262628743D646F63756D656E742E717565727953656C6563746F72287429293B636F6E737420623D743F5549287B746F';
wwv_flow_imp.g_varchar2_table(47449) := '6F6C74697053706163653A66756E6374696F6E28297B72657475726E20742E676574426F756E64696E67436C69656E745265637428297D7D293A5B5D2C5F3D28653D3E6E657720514D2866756E6374696F6E28653D6E756C6C297B636F6E737420743D65';
wwv_flow_imp.g_varchar2_table(47450) := '562E636F6E666967757265287B777261703A286E3D743D3E224665656C223D3D742E6E616D657C7C224665656C426C6F636B223D3D742E6E616D653F7B7061727365723A45427D3A6526262253696D706C6554657874426C6F636B223D3D742E6E616D65';
wwv_flow_imp.g_varchar2_table(47451) := '3F7B7061727365723A657D3A6E756C6C2C28652C742C692C6F293D3E6E6577204D5328652C6E2C742C692C6F29292C70726F70733A5B70412E616464287456295D7D293B766172206E3B72657475726E20424D2E646566696E65287B7061727365723A74';
wwv_flow_imp.g_varchar2_table(47452) := '7D297D2865292C5B5D292928697C7C6E262628653D3E226D61726B646F776E223D3D3D653F73463A6E756C6C29286E29292C793D5B4D4128292C672C662C5A4E28292C754128292C762C52492E6F66285B2E2E2E4C4F5D292C5F2C69562C6D2C622C703F';
wwv_flow_imp.g_varchar2_table(47453) := '4B423A55422C2E2E2E643F5B4D4D28295D3A5B5D2C2E2E2E683F5B6E452E7472616E73616374696F6E46696C7465722E6F662828653D3E652E6E6577446F632E6C696E65733E313F5B5D3A6529295D3A5B5D2C2E2E2E753F5B44492E6C696E6557726170';
wwv_flow_imp.g_varchar2_table(47454) := '70696E675D3A5B5D5D3B72657475726E206C2626792E707573682844492E6564697461626C652E6F6628213129292C68262663262628633D632E746F537472696E6728292E73706C697428225C6E22295B305D292C746869732E5F636D456469746F723D';
wwv_flow_imp.g_varchar2_table(47455) := '6E6577204449287B73746174653A6E452E637265617465287B646F633A632C657874656E73696F6E733A797D292C706172656E743A657D292C746869737D6F562E70726F746F747970652E73657456616C75653D66756E6374696F6E2865297B74686973';
wwv_flow_imp.g_varchar2_table(47456) := '2E5F636D456469746F722E6469737061746368287B6368616E6765733A7B66726F6D3A302C746F3A746869732E5F636D456469746F722E73746174652E646F632E6C656E6774682C696E736572743A657D7D297D2C6F562E70726F746F747970652E666F';
wwv_flow_imp.g_varchar2_table(47457) := '6375733D66756E6374696F6E2865297B636F6E737420743D746869732E5F636D456469746F723B696628742E636F6E74656E74444F4D2E666F63757328292C742E666F63757328292C226E756D626572223D3D747970656F662065297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(47458) := '3D742E73746174652E646F632E6C656E6774683B742E6469737061746368287B73656C656374696F6E3A7B616E63686F723A653C3D6E3F653A6E7D7D297D7D2C6F562E70726F746F747970652E67657453656C656374696F6E3D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(47459) := '7B72657475726E20746869732E5F636D456469746F722E73746174652E73656C656374696F6E7D3B636F6E73742073563D5B244E282266756E6374696F6E28247B706172616D737D2920247B626F64797D222C7B6C6162656C3A2266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(47460) := '2C64657461696C3A22646566696E6974696F6E222C747970653A226B6579776F7264227D292C244E2822666F7220247B7661727D20696E20247B636F6C6C656374696F6E7D2072657475726E20247B76616C75657D222C7B6C6162656C3A22666F72222C';
wwv_flow_imp.g_varchar2_table(47461) := '64657461696C3A2265787072657373696F6E222C747970653A226B6579776F7264227D292C244E2822657665727920247B7661727D20696E20247B636F6C6C656374696F6E7D2073617469736669657320247B636F6E646974696F6E7D222C7B6C616265';
wwv_flow_imp.g_varchar2_table(47462) := '6C3A226576657279222C64657461696C3A227175616E7469666965642065787072657373696F6E222C747970653A226B6579776F7264227D292C244E2822736F6D6520247B7661727D20696E20247B636F6C6C656374696F6E7D20736174697366696573';
wwv_flow_imp.g_varchar2_table(47463) := '20247B636F6E646974696F6E7D222C7B6C6162656C3A22736F6D65222C64657461696C3A227175616E7469666965642065787072657373696F6E222C747970653A226B6579776F7264227D292C244E2822696620247B636F6E646974696F6E7D20746865';
wwv_flow_imp.g_varchar2_table(47464) := '6E20247B76616C75657D20656C736520247B6F746865722076616C75657D222C7B6C6162656C3A226966222C64657461696C3A22626C6F636B222C747970653A226B6579776F7264227D292C244E28227B20247B6B65797D3A20247B76616C75657D207D';
wwv_flow_imp.g_varchar2_table(47465) := '222C7B6C6162656C3A22636F6E74657874222C64657461696C3A22626C6F636B222C747970653A226B6579776F7264227D295D3B66756E6374696F6E20725628297B72657475726E2072563D4F626A6563742E61737369676E3F4F626A6563742E617373';
wwv_flow_imp.g_varchar2_table(47466) := '69676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E294F626A6563742E';
wwv_flow_imp.g_varchar2_table(47467) := '70726F746F747970652E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C72562E6170706C7928746869732C617267756D656E7473297D66756E6374696F6E2061562865297B636F';
wwv_flow_imp.g_varchar2_table(47468) := '6E73747B636F6E746578743A742C61667465723A6E2C6265666F72653A692C6B6579776F72643A6F7D3D653B72657475726E2066756E6374696F6E28652C74297B636F6E73747B6E6F6465733A6E2C6265666F72653A692C61667465723A6F2C6B657977';
wwv_flow_imp.g_varchar2_table(47469) := '6F72643A737D3D653B72657475726E20653D3E7B636F6E73747B73746174653A722C706F733A617D3D652C6C3D66756E6374696F6E28652C74297B666F722841727261792E697341727261792874297C7C28743D5B745D293B653B653D652E706172656E';
wwv_flow_imp.g_varchar2_table(47470) := '74297B696628742E696E636C7564657328652E6E616D65292972657475726E20653B696628652E747970652E6973546F7029627265616B7D72657475726E206E756C6C7D28564D2872292E7265736F6C7665496E6E657228612C2D31292C6E293B726574';
wwv_flow_imp.g_varchar2_table(47471) := '75726E206C3F6856286C2C612C5B732C695D297C7C66756E6374696F6E28652C742C6E297B72657475726E20755628652C742C6E2C31297D286C2C612C5B732C6F5D297C7C6F2626216856286C2C612C5B6F5D293F6E756C6C3A742865293A6E756C6C7D';
wwv_flow_imp.g_varchar2_table(47472) := '7D287B6E6F6465733A742C6265666F72653A692C61667465723A6E2C6B6579776F72643A6F7D2C5541285B7B6C6162656C3A6F2C747970653A226B6579776F7264222C626F6F73743A31307D5D29297D636F6E7374206C563D5B6156287B636F6E746578';
wwv_flow_imp.g_varchar2_table(47473) := '743A22496E45787072657373696F6E222C6B6579776F72643A22696E227D292C6156287B636F6E746578743A22496645787072657373696F6E222C6B6579776F72643A227468656E222C61667465723A226966222C6265666F72653A22656C7365227D29';
wwv_flow_imp.g_varchar2_table(47474) := '2C6156287B636F6E746578743A22496645787072657373696F6E222C6B6579776F72643A22656C7365222C61667465723A227468656E227D292C6156287B636F6E746578743A225175616E74696669656445787072657373696F6E222C6B6579776F7264';
wwv_flow_imp.g_varchar2_table(47475) := '3A22736174697366696573227D292C6156287B636F6E746578743A22466F7245787072657373696F6E222C61667465723A22496E45787072657373696F6E73222C6B6579776F72643A2272657475726E227D295D2C63563D5B22537472696E674C697465';
wwv_flow_imp.g_varchar2_table(47476) := '72616C222C224964656E746966696572222C224C696E65436F6D6D656E74222C22426C6F636B436F6D6D656E74222C225061746845787072657373696F6E225D3B66756E6374696F6E2064562865297B72657475726E20743D63562C6E3D554128652E6D';
wwv_flow_imp.g_varchar2_table(47477) := '61702828653D3E7256287B7D2C652C7B747970653A2274657874227D292929292C653D3E7B666F72286C6574206E3D564D28652E7374617465292E7265736F6C7665496E6E657228652E706F732C2D31293B6E3B6E3D6E2E706172656E74297B69662874';
wwv_flow_imp.g_varchar2_table(47478) := '2E696E6465784F66286E2E6E616D65293E2D312972657475726E206E756C6C3B6966286E2E747970652E6973546F7029627265616B7D72657475726E206E2865297D3B76617220742C6E7D66756E6374696F6E20685628652C742C6E297B72657475726E';
wwv_flow_imp.g_varchar2_table(47479) := '20755628652C742C6E2C2D31297D66756E6374696F6E20755628652C742C6E2C69297B6C6574206F3D655B693E303F226368696C644166746572223A226368696C644265666F7265225D2874293B666F72283B6F3B297B6966286E2E696E636C75646573';
wwv_flow_imp.g_varchar2_table(47480) := '286F2E6E616D65292972657475726E206F3B6966286F2E747970652E69734572726F7226266F2E66697273744368696C6426266E2E696E636C75646573286F2E66697273744368696C642E6E616D65292972657475726E206F2E66697273744368696C64';
wwv_flow_imp.g_varchar2_table(47481) := '3B6F3D6F5B693E303F226E6578745369626C696E67223A22707265765369626C696E67225D7D72657475726E206E756C6C7D636F6E73742070563D424D2E646566696E65287B7061727365723A45422E636F6E666967757265287B70726F70733A5B6E41';
wwv_flow_imp.g_varchar2_table(47482) := '2E616464287B436F6E746578743A6C41287B636C6F73696E673A227D227D292C224C6973742046696C74657245787072657373696F6E223A6C41287B636C6F73696E673A225D227D292C22506172656E74686573697A656445787072657373696F6E2046';
wwv_flow_imp.g_varchar2_table(47483) := '756E6374696F6E496E766F636174696F6E223A6441287B6578636570743A2F5E5C732A5C292F7D292C22466F7245787072657373696F6E205175616E74696669656445787072657373696F6E20496645787072657373696F6E223A6441287B6578636570';
wwv_flow_imp.g_varchar2_table(47484) := '743A2F5E5C732A287468656E7C656C73657C72657475726E7C736174697366696573295C622F7D292C46756E6374696F6E446566696E6974696F6E3A6441287B6578636570743A2F5E5C732A285C287C5C29292F7D297D292C70412E616464287B436F6E';
wwv_flow_imp.g_varchar2_table(47485) := '746578743A67412C4C6973743A67412C506172656E74686573697A656445787072657373696F6E3A67412C46756E6374696F6E446566696E6974696F6E2865297B636F6E737420743D652E6765744368696C6428222922293B72657475726E20743F7B66';
wwv_flow_imp.g_varchar2_table(47486) := '726F6D3A742E746F2C746F3A652E746F7D3A6E756C6C7D7D295D7D292C6C616E6775616765446174613A7B696E64656E744F6E496E7075743A2F5E5C732A285C297C5C7D7C5C5D7C7468656E7C656C73657C72657475726E7C7361746973666965732924';
wwv_flow_imp.g_varchar2_table(47487) := '2F2C636F6D6D656E74546F6B656E733A7B6C696E653A222F2F222C626C6F636B3A7B6F70656E3A222F2A222C636C6F73653A222A2F227D7D7D7D292C67563D70562E636F6E666967757265287B746F703A22556E6172795465737473227D2C224645454C';
wwv_flow_imp.g_varchar2_table(47488) := '20756E61727920746573747322292C6D563D70562E636F6E666967757265287B746F703A2245787072657373696F6E227D2C224645454C2065787072657373696F6E22293B4F626A6563742E70726F746F747970652E746F537472696E672C4F626A6563';
wwv_flow_imp.g_varchar2_table(47489) := '742E70726F746F747970652E6861734F776E50726F70657274793B636F6E73742066563D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E2076562865297B69662821657C7C21652E6E6F646554797065297468726F';
wwv_flow_imp.g_varchar2_table(47490) := '77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D76562E70726F746F747970652E6164643D';
wwv_flow_imp.g_varchar2_table(47491) := '66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C76562E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D223D3D66';
wwv_flow_imp.g_varchar2_table(47492) := '562E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C76562E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(47493) := '7B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C76562E70726F';
wwv_flow_imp.g_varchar2_table(47494) := '746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C69';
wwv_flow_imp.g_varchar2_table(47495) := '73742E746F67676C652865292C746869737D2C76562E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C76562E70726F746F747970652E6861733D76562E70';
wwv_flow_imp.g_varchar2_table(47496) := '726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B7661722062562C5F562C79562C77563D7B7D3B66756E6374696F6E20435628297B62563D77696E64';
wwv_flow_imp.g_varchar2_table(47497) := '6F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C5F563D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C69737465';
wwv_flow_imp.g_varchar2_table(47498) := '6E6572223A226465746163684576656E74222C79563D226164644576656E744C697374656E657222213D3D62563F226F6E223A22227D77562E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2062567C7C435628292C655B6256';
wwv_flow_imp.g_varchar2_table(47499) := '5D2879562B742C6E2C697C7C2131292C6E7D2C77562E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E205F567C7C435628292C655B5F565D2879562B742C6E2C697C7C2131292C6E7D3B7661722053562C78563D21313B22';
wwv_flow_imp.g_varchar2_table(47500) := '756E646566696E656422213D747970656F6620646F63756D656E742626282853563D646F63756D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E';
wwv_flow_imp.g_varchar2_table(47501) := '3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D22636865636B626F78222F3E272C78563D2153562E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C53563D766F69642030293B7661';
wwv_flow_imp.g_varchar2_table(47502) := '72206B563D7B6C6567656E643A5B312C223C6669656C647365743E222C223C2F6669656C647365743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C';
wwv_flow_imp.g_varchar2_table(47503) := '653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E222C223C2F636F6C67726F75703E3C2F7461626C653E225D2C5F64656661756C743A78563F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B6B562E';
wwv_flow_imp.g_varchar2_table(47504) := '74643D6B562E74683D5B332C223C7461626C653E3C74626F64793E3C74723E222C223C2F74723E3C2F74626F64793E3C2F7461626C653E225D2C6B562E6F7074696F6E3D6B562E6F707467726F75703D5B312C273C73656C656374206D756C7469706C65';
wwv_flow_imp.g_varchar2_table(47505) := '3D226D756C7469706C65223E272C223C2F73656C6563743E225D2C6B562E74686561643D6B562E74626F64793D6B562E636F6C67726F75703D6B562E63617074696F6E3D6B562E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E22';
wwv_flow_imp.g_varchar2_table(47506) := '5D2C6B562E706F6C796C696E653D6B562E656C6C697073653D6B562E706F6C79676F6E3D6B562E636972636C653D6B562E746578743D6B562E6C696E653D6B562E706174683D6B562E726563743D6B562E673D5B312C273C73766720786D6C6E733D2268';
wwv_flow_imp.g_varchar2_table(47507) := '7474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F6E3D22312E31223E272C223C2F7376673E225D3B7661722045563D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F';
wwv_flow_imp.g_varchar2_table(47508) := '77206E657720547970654572726F722822537472696E6720657870656374656422293B747C7C28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E6372656174655465';
wwv_flow_imp.g_varchar2_table(47509) := '78744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F672C2222293B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E696E6E';
wwv_flow_imp.g_varchar2_table(47510) := '657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C64293B766172206F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286B562C69293F6B565B695D3A6B562E5F6465666175';
wwv_flow_imp.g_varchar2_table(47511) := '6C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E637265617465456C656D656E74282264697622293B666F72286C2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E6669727374';
wwv_flow_imp.g_varchar2_table(47512) := '4368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76654368696C64286C2E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273744368';
wwv_flow_imp.g_varchar2_table(47513) := '696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C64286C2E66697273744368696C6429293B72657475726E20637D2C4C563D5B714F284D422829295D2C44563D5B44492E7468656D65287B2226202E636D2D636F6E74656E74';
wwv_flow_imp.g_varchar2_table(47514) := '223A7B70616464696E673A22307078227D2C2226202E636D2D6C696E65223A7B70616464696E673A22307078227D2C22262E636D2D656469746F722E636D2D666F6375736564223A7B6F75746C696E653A226E6F6E65227D2C2226202E636D2D636F6D70';
wwv_flow_imp.g_varchar2_table(47515) := '6C6574696F6E496E666F223A7B776869746553706163653A227072652D77726170222C6F766572666C6F773A2268696464656E222C746578744F766572666C6F773A22656C6C6970736973227D2C2226202E636D2D636F6D706C6574696F6E496E666F20';
wwv_flow_imp.g_varchar2_table(47516) := '3E202A223A7B776869746553706163653A226E6F726D616C227D2C2226202E636D2D636F6D706C6574696F6E496E666F20756C223A7B6D617267696E3A302C70616464696E674C6566743A2231357078227D2C2226202E636D2D636F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(47517) := '496E666F20707265223A7B6D617267696E426F74746F6D3A302C776869746553706163653A227072652D77726170227D2C2226202E636D2D636F6D706C6574696F6E496E666F2070223A7B6D617267696E546F703A307D2C2226202E636D2D636F6D706C';
wwv_flow_imp.g_varchar2_table(47518) := '6574696F6E496E666F20703A6E6F74283A6C6173742D6F662D7479706529223A7B6D617267696E426F74746F6D3A307D7D292C44492E626173655468656D65287B2226202E7661726961626C654E616D65223A7B636F6C6F723A2223313066227D2C2226';
wwv_flow_imp.g_varchar2_table(47519) := '202E6E756D626572223A7B636F6C6F723A2223313634227D2C2226202E737472696E67223A7B636F6C6F723A2223613131227D2C2226202E626F6F6C223A7B636F6C6F723A2223323139227D2C2226202E66756E6374696F6E223A7B636F6C6F723A2223';
wwv_flow_imp.g_varchar2_table(47520) := '616133373331222C666F6E745765696768743A22626F6C64227D2C2226202E636F6E74726F6C223A7B636F6C6F723A2223373038227D7D292C5F41286D412E646566696E65285B7B7461673A52782E7661726961626C654E616D652C636C6173733A2276';
wwv_flow_imp.g_varchar2_table(47521) := '61726961626C654E616D65227D2C7B7461673A52782E6E616D652C636C6173733A227661726961626C654E616D65227D2C7B7461673A52782E6E756D6265722C636C6173733A226E756D626572227D2C7B7461673A52782E737472696E672C636C617373';
wwv_flow_imp.g_varchar2_table(47522) := '3A22737472696E67227D2C7B7461673A52782E626F6F6C2C636C6173733A22626F6F6C227D2C7B7461673A52782E66756E6374696F6E2852782E7661726961626C654E616D65292C636C6173733A2266756E6374696F6E227D2C7B7461673A52782E6675';
wwv_flow_imp.g_varchar2_table(47523) := '6E6374696F6E2852782E7370656369616C2852782E7661726961626C654E616D6529292C636C6173733A2266756E6374696F6E227D2C7B7461673A52782E636F6E74726F6C4B6579776F72642C636C6173733A22636F6E74726F6C227D2C7B7461673A52';
wwv_flow_imp.g_varchar2_table(47524) := '782E6F70657261746F724B6579776F72642C636C6173733A22636F6E74726F6C227D5D29295D3B66756E6374696F6E2054562865297B72657475726E20652626652E66726F6D3D3D3D652E746F7D66756E6374696F6E2049562865297B72657475726E21';
wwv_flow_imp.g_varchar2_table(47525) := '2165262628225061746845787072657373696F6E223D3D3D652E6E616D657C7C495628652E706172656E7429297D66756E6374696F6E204D56287B7661726961626C65733A657D297B72657475726E20743D3E7B636F6E7374206E3D564D28742E737461';
wwv_flow_imp.g_varchar2_table(47526) := '7465292E7265736F6C766528742E706F732C2D31293B696628214956286E292972657475726E3B636F6E737420693D66756E6374696F6E2865297B666F72283B653B297B696628225061746845787072657373696F6E223D3D3D652E6E616D6529726574';
wwv_flow_imp.g_varchar2_table(47527) := '75726E20653B653D652E706172656E747D7D286E292C6F3D6E3D3D3D693F742E706F733A6E2E66726F6D2C733D415628692C74293B6C657420723D653B666F722876617220613D303B613C732E6C656E6774682D313B612B2B297B766172206C3D722E66';
wwv_flow_imp.g_varchar2_table(47528) := '696E642828653D3E652E6E616D653D3D3D735B615D2E6E616D6529293B696628216C2972657475726E206E756C6C3B696628226F7074696F6E616C22213D3D6C2E69734C697374262621216C2E69734C697374213D3D735B615D2E69734C697374297265';
wwv_flow_imp.g_varchar2_table(47529) := '7475726E3B723D6C2E656E74726965737D72657475726E20723F28723D722E6D61702828653D3E287B6C6162656C3A652E6E616D652C747970653A227661726961626C65222C696E666F3A652E696E666F2C64657461696C3A652E64657461696C7D2929';
wwv_flow_imp.g_varchar2_table(47530) := '292C7B66726F6D3A6F2C6F7074696F6E733A727D293A766F696420307D7D66756E6374696F6E20415628652C74297B6C6574206E3D5B5D3B666F72286C657420693D652E66697273744368696C643B693B693D692E6E6578745369626C696E6729225061';
wwv_flow_imp.g_varchar2_table(47531) := '746845787072657373696F6E223D3D3D692E6E616D653F6E2E70757368282E2E2E415628692C7429293A2246696C74657245787072657373696F6E223D3D3D692E6E616D653F6E2E70757368282E2E2E4E5628692C7429293A6E2E70757368287B6E616D';
wwv_flow_imp.g_varchar2_table(47532) := '653A505628692C74292C69734C6973743A21317D293B72657475726E206E7D66756E6374696F6E204E5628652C74297B636F6E7374206E3D652E66697273744368696C643B696628225061746845787072657373696F6E223D3D3D6E2E6E616D65297B63';
wwv_flow_imp.g_varchar2_table(47533) := '6F6E737420653D4156286E2C74293B72657475726E20655B652E6C656E6774682D315D2E69734C6973743D21302C657D72657475726E5B7B6E616D653A5056286E2C74292C69734C6973743A21307D5D7D66756E6374696F6E20505628652C74297B7265';
wwv_flow_imp.g_varchar2_table(47534) := '7475726E20742E73746174652E736C696365446F6328652E66726F6D2C652E746F297D66756E6374696F6E204F56287B7661726961626C65733A653D5B5D2C6275696C74696E733A743D5B5D7D297B636F6E7374206E3D66756E6374696F6E28652C7429';
wwv_flow_imp.g_varchar2_table(47535) := '7B72657475726E5B5D2E636F6E63617428652E6D61702828653D3E525628652929292C742E6D61702828653D3E52562865292929297D28652C74293B72657475726E206E2E6C656E6774683F653D3E7B636F6E73747B706F733A742C73746174653A697D';
wwv_flow_imp.g_varchar2_table(47536) := '3D652C6F3D564D2869292E7265736F6C766528742C2D31293B72657475726E2066756E6374696F6E28652C74297B636F6E7374206E3D652E6E6578745369626C696E673B72657475726E2054562865297C7C6E26266E2E66726F6D3D3D3D742626545628';
wwv_flow_imp.g_varchar2_table(47537) := '6E297D286F2C74293F652E6578706C696369743F7B66726F6D3A742C6F7074696F6E733A6E7D3A6E756C6C3A2166756E6374696F6E2865297B72657475726E20652626652E706172656E742626225661726961626C654E616D65223D3D3D652E70617265';
wwv_flow_imp.g_varchar2_table(47538) := '6E742E6E616D657D286F297C7C4956286F293F6E756C6C3A7B66726F6D3A6F2E66726F6D2C6F7074696F6E733A6E7D7D3A653D3E6E756C6C7D66756E6374696F6E20525628652C74297B72657475726E2266756E6374696F6E223D3D3D652E747970653F';
wwv_flow_imp.g_varchar2_table(47539) := '66756E6374696F6E28652C74297B636F6E73747B6E616D653A6E2C696E666F3A692C64657461696C3A6F2C706172616D733A733D5B5D7D3D652C723D732E6D61702828287B6E616D653A652C747970653A747D2C6E293D3E287B6E616D653A657C7C6070';
wwv_flow_imp.g_varchar2_table(47540) := '6172616D20247B6E2B317D602C747970653A747D2929292C613D60247B6E7D28247B722E6D61702828653D3E22247B222B652E6E616D652B227D2229292E6A6F696E28222C2022297D29602C6C3D722E6D61702828287B6E616D653A652C747970653A74';
wwv_flow_imp.g_varchar2_table(47541) := '7D293D3E743F60247B657D3A20247B747D603A6529292E6A6F696E28222C2022293B72657475726E20244E28612C7B6C6162656C3A60247B6E7D28247B6C7D29602C747970653A2266756E6374696F6E222C696E666F3A692C64657461696C3A6F2C626F';
wwv_flow_imp.g_varchar2_table(47542) := '6F73743A747D297D28652C74293A7B6C6162656C3A652E6E616D652C747970653A227661726961626C65222C696E666F3A652E696E666F2C64657461696C3A652E64657461696C2C626F6F73743A747D7D66756E6374696F6E204656287B766172696162';
wwv_flow_imp.g_varchar2_table(47543) := '6C65733A653D5B5D2C6275696C74696E733A743D5B5D7D297B72657475726E5B4D56287B7661726961626C65733A657D292C4F56287B7661726961626C65733A652C6275696C74696E733A747D292C64562873562E6D61702828653D3E287B2E2E2E652C';
wwv_flow_imp.g_varchar2_table(47544) := '626F6F73743A2D317D292929292C2E2E2E6C565D7D636F6E73742042563D5F6B2E646566696E6528292C56563D5F6B2E646566696E6528292C7A563D5F6B2E646566696E6528293B66756E6374696F6E204856287B6469616C6563743A653D2265787072';
wwv_flow_imp.g_varchar2_table(47545) := '657373696F6E222C7661726961626C65733A743D5B5D2C6275696C74696E733A6E3D5B5D2C636F6D706C6574696F6E733A693D4656287B6275696C74696E733A6E2C7661726961626C65733A747D297D297B636F6E7374206F3D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(47546) := '297B72657475726E20652E736C69636528292E7265766572736528292E726564756365282828652C74293D3E28655B742E6E616D655D3D28293D3E7B7D2C6529292C7B7D297D285B2E2E2E742C2E2E2E6E5D293B72657475726E5B7A562E6F662865292C';
wwv_flow_imp.g_varchar2_table(47547) := '42562E6F66286E292C56562E6F662874292C28733D7B6469616C6563743A652C636F6E746578743A6F2C636F6D706C6574696F6E733A697D2C66756E6374696F6E28653D7B7D297B636F6E737420743D22756E6172795465737473223D3D3D652E646961';
wwv_flow_imp.g_varchar2_table(47548) := '6C6563743F67563A6D562C6E3D652E7061727365724469616C6563742C693D774228652E636F6E74657874292C6F3D742E636F6E666967757265287B636F6E74657874547261636B65723A692C6469616C6563743A6E7D292C733D652E636F6D706C6574';
wwv_flow_imp.g_varchar2_table(47549) := '696F6E737C7C5B6456287356292C6C565D2E666C617428293B72657475726E206E657720514D286F2C5B2E2E2E732E6D61702828653D3E6F2E646174612E6F66287B6175746F636F6D706C6574653A657D2929295D297D287329295D3B76617220737D63';
wwv_flow_imp.g_varchar2_table(47550) := '6F6E73742057563D5B7B6E616D653A226E6F74286E6567616E6429222C6465736372697074696F6E3A273C703E52657475726E7320746865206C6F676963616C206E65676174696F6E206F662074686520676976656E2076616C75652E3C2F703E5C6E3C';
wwv_flow_imp.g_varchar2_table(47551) := '703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6E6F74286E6567616E643A20626F6F6C65616E293A20626F';
wwv_flow_imp.g_varchar2_table(47552) := '6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6E6F742874727565295C6E';
wwv_flow_imp.g_varchar2_table(47553) := '2F2F2066616C73655C6E5C6E6E6F74286E756C6C295C6E2F2F206E756C6C5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22697320646566696E65642876616C756529222C6465736372697074696F6E3A273C703E3C656D3E43616D75';
wwv_flow_imp.g_varchar2_table(47554) := '6E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E436865636B73206966206120676976656E2076616C7565206973206E6F74203C636F64653E6E756C6C3C2F636F64653E2E204966207468652076616C7565206973203C636F64653E6E';
wwv_flow_imp.g_varchar2_table(47555) := '756C6C3C2F636F64653E207468656E207468652066756E6374696F6E2072657475726E73203C636F64653E66616C73653C2F636F64653E2E5C6E4F74686572776973652C207468652066756E6374696F6E2072657475726E73203C636F64653E74727565';
wwv_flow_imp.g_varchar2_table(47556) := '3C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E697320646566696E65';
wwv_flow_imp.g_varchar2_table(47557) := '642876616C75653A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D';
wwv_flow_imp.g_varchar2_table(47558) := '6665656C223E697320646566696E65642831295C6E2F2F20747275655C6E5C6E697320646566696E6564286E756C6C295C6E2F2F2066616C73655C6E5C6E697320646566696E65642878295C6E2F2F2066616C7365202D206966206E6F20766172696162';
wwv_flow_imp.g_varchar2_table(47559) := '6C65202671756F743B782671756F743B206578697374735C6E5C6E697320646566696E656428782E79295C6E2F2F2066616C7365202D206966206E6F207661726961626C65202671756F743B782671756F743B20657869737473206F7220697420646F65';
wwv_flow_imp.g_varchar2_table(47560) := '736E262333393B74206861766520612070726F7065727479202671756F743B792671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3A3A3A63617574696F6E20427265616B696E67206368616E67653C2F703E5C6E3C703E54686973206675';
wwv_flow_imp.g_varchar2_table(47561) := '6E6374696F6E20776F726B656420646966666572656E746C7920696E2070726576696F75732076657273696F6E732E2049742072657475726E6564203C636F64653E747275653C2F636F64653E206966207468652076616C756520776173203C636F6465';
wwv_flow_imp.g_varchar2_table(47562) := '3E6E756C6C3C2F636F64653E2E5C6E53696E636520746869732076657273696F6E2C207468652066756E6374696F6E2072657475726E73203C636F64653E66616C73653C2F636F64653E206966207468652076616C7565206973203C636F64653E6E756C';
wwv_flow_imp.g_varchar2_table(47563) := '6C3C2F636F64653E2E3C2F703E5C6E3C703E3A3A3A3C2F703E5C6E277D2C7B6E616D653A22676574206F7220656C73652876616C75652C2064656661756C7429222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73';
wwv_flow_imp.g_varchar2_table(47564) := '696F6E3C2F656D3E3C2F703E5C6E3C703E52657475726E207468652070726F76696465642076616C756520706172616D65746572206966206E6F74203C636F64653E6E756C6C3C2F636F64653E2C206F74686572776973652072657475726E2074686520';
wwv_flow_imp.g_varchar2_table(47565) := '64656661756C7420706172616D657465723C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E';
wwv_flow_imp.g_varchar2_table(47566) := '676574206F7220656C73652876616C75653A20416E792C2064656661756C743A20416E79293A20416E795C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C63';
wwv_flow_imp.g_varchar2_table(47567) := '6F646520636C6173733D226C616E67756167652D6665656C223E676574206F7220656C7365282671756F743B746869732671756F743B2C202671756F743B64656661756C742671756F743B295C6E2F2F202671756F743B746869732671756F743B5C6E5C';
wwv_flow_imp.g_varchar2_table(47568) := '6E676574206F7220656C7365286E756C6C2C202671756F743B64656661756C742671756F743B295C6E2F2F202671756F743B64656661756C742671756F743B5C6E5C6E676574206F7220656C7365286E756C6C2C206E756C6C295C6E2F2F206E756C6C5C';
wwv_flow_imp.g_varchar2_table(47569) := '6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226173736572742876616C75652C20636F6E646974696F6E29222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E';
wwv_flow_imp.g_varchar2_table(47570) := '3C703E56657269667920746861742074686520676976656E20636F6E646974696F6E206973206D65742E2049662074686520636F6E646974696F6E206973203C636F64653E747275653C2F636F64653E2C207468652066756E6374696F6E207265747572';
wwv_flow_imp.g_varchar2_table(47571) := '6E73207468652076616C75652E5C6E4F74686572776973652C20746865206576616C756174696F6E206661696C73207769746820616E206572726F722E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374';
wwv_flow_imp.g_varchar2_table(47572) := '726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6173736572742876616C75653A20416E792C20636F6E646974696F6E3A20416E79295C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C73';
wwv_flow_imp.g_varchar2_table(47573) := '74726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E61737365727428782C207820213D206E756C6C295C6E2F2F202671756F743B76616C75652671';
wwv_flow_imp.g_varchar2_table(47574) := '756F743B202D2069662078206973202671756F743B76616C75652671756F743B5C6E2F2F206572726F72202D2069662078206973206E756C6C206F7220646F65736E262333393B742065786973745C6E5C6E61737365727428782C2078202667743B3D20';
wwv_flow_imp.g_varchar2_table(47575) := '30295C6E2F2F2034202D206966207820697320345C6E2F2F206572726F72202D2069662078206973206C657373207468616E207A65726F5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226173736572742876616C75652C20636F6E64';
wwv_flow_imp.g_varchar2_table(47576) := '6974696F6E2C20636175736529222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E56657269667920746861742074686520676976656E20636F6E646974696F6E206973';
wwv_flow_imp.g_varchar2_table(47577) := '206D65742E2049662074686520636F6E646974696F6E206973203C636F64653E747275653C2F636F64653E2C207468652066756E6374696F6E2072657475726E73207468652076616C75652E5C6E4F74686572776973652C20746865206576616C756174';
wwv_flow_imp.g_varchar2_table(47578) := '696F6E206661696C73207769746820616E206572726F7220636F6E7461696E696E672074686520676976656E206D6573736167652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F70';
wwv_flow_imp.g_varchar2_table(47579) := '3E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6173736572742876616C75653A20416E792C20636F6E646974696F6E3A20416E792C2063617573653A20537472696E67295C6E3C2F636F64653E3C2F7072653E';
wwv_flow_imp.g_varchar2_table(47580) := '5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E61737365727428782C207820213D206E756C6C2C202671756F743B26233339';
wwv_flow_imp.g_varchar2_table(47581) := '3B78262333393B2073686F756C64206E6F74206265206E756C6C2671756F743B295C6E2F2F202671756F743B76616C75652671756F743B202D2069662078206973202671756F743B76616C75652671756F743B5C6E2F2F206572726F7228262333393B78';
wwv_flow_imp.g_varchar2_table(47582) := '262333393B2073686F756C64206E6F74206265206E756C6C29202D2069662078206973206E756C6C206F7220646F65736E262333393B742065786973745C6E5C6E61737365727428782C2078202667743B3D20302C202671756F743B262333393B782623';
wwv_flow_imp.g_varchar2_table(47583) := '33393B2073686F756C6420626520706F7369746976652671756F743B295C6E2F2F2034202D206966207820697320345C6E2F2F206572726F7228262333393B78262333393B2073686F756C6420626520706F73697469766529202D206966207820697320';
wwv_flow_imp.g_varchar2_table(47584) := '6C657373207468616E207A65726F5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226765742076616C756528636F6E746578742C206B657929222C6465736372697074696F6E3A273C703E52657475726E73207468652076616C756520';
wwv_flow_imp.g_varchar2_table(47585) := '6F662074686520636F6E7465787420656E74727920776974682074686520676976656E206B65792E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F6465';
wwv_flow_imp.g_varchar2_table(47586) := '20636C6173733D226C616E67756167652D6665656C223E6765742076616C756528636F6E746578743A20636F6E746578742C206B65793A20737472696E67293A20416E795C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D';
wwv_flow_imp.g_varchar2_table(47587) := '706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6765742076616C7565287B666F6F3A203132337D2C202671756F743B666F6F2671756F743B295C6E2F2F203132335C6E';
wwv_flow_imp.g_varchar2_table(47588) := '5C6E6765742076616C7565287B613A20317D2C202671756F743B622671756F743B295C6E2F2F206E756C6C5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226765742076616C756528636F6E746578742C206B65797329222C64657363';
wwv_flow_imp.g_varchar2_table(47589) := '72697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E52657475726E73207468652076616C7565206F662074686520636F6E7465787420656E74727920666F72206120636F6E7465787420';
wwv_flow_imp.g_varchar2_table(47590) := '7061746820646566696E65642062792074686520676976656E206B6579732E3C2F703E5C6E3C703E4966203C636F64653E6B6579733C2F636F64653E20636F6E7461696E7320746865206B657973203C636F64653E5B6B312C206B325D3C2F636F64653E';
wwv_flow_imp.g_varchar2_table(47591) := '207468656E2069742072657475726E73207468652076616C756520617420746865206E657374656420656E747279203C636F64653E6B312E6B323C2F636F64653E206F662074686520636F6E746578742E3C2F703E5C6E3C703E4966203C636F64653E6B';
wwv_flow_imp.g_varchar2_table(47592) := '6579733C2F636F64653E2061726520656D707479206F7220746865206E657374656420656E74727920646566696E656420627920746865206B65797320646F65736E262333393B7420657869737420696E2074686520636F6E746578742C206974207265';
wwv_flow_imp.g_varchar2_table(47593) := '7475726E73203C636F64653E6E756C6C3C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E6775616765';
wwv_flow_imp.g_varchar2_table(47594) := '2D6665656C223E6765742076616C756528636F6E746578743A20636F6E746578742C206B6579733A206C697374266C743B737472696E672667743B293A20416E795C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65';
wwv_flow_imp.g_varchar2_table(47595) := '733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6765742076616C7565287B783A312C20793A207B7A3A307D7D2C205B2671756F743B792671756F743B2C202671756F743B7A26';
wwv_flow_imp.g_varchar2_table(47596) := '71756F743B5D295C6E2F2F20305C6E5C6E6765742076616C7565287B783A207B793A207B7A3A307D7D7D2C205B2671756F743B782671756F743B2C202671756F743B792671756F743B5D295C6E2F2F207B7A3A307D5C6E5C6E6765742076616C7565287B';
wwv_flow_imp.g_varchar2_table(47597) := '613A207B623A20337D7D2C205B2671756F743B622671756F743B5D295C6E2F2F206E756C6C5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2267657420656E747269657328636F6E7465787429222C6465736372697074696F6E3A273C';
wwv_flow_imp.g_varchar2_table(47598) := '703E52657475726E732074686520656E7472696573206F662074686520636F6E746578742061732061206C697374206F66206B65792D76616C75652D70616972732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572';
wwv_flow_imp.g_varchar2_table(47599) := '653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E67657420656E747269657328636F6E746578743A20636F6E74657874293A206C697374266C743B636F6E746578742667743B5C';
wwv_flow_imp.g_varchar2_table(47600) := '6E3C2F636F64653E3C2F7072653E5C6E3C703E5468652072657475726E2076616C75652069732061206C697374206F6620636F6E74657874732E204561636820636F6E7465787420636F6E7461696E732074776F20656E747269657320666F7220267175';
wwv_flow_imp.g_varchar2_table(47601) := '6F743B6B65792671756F743B20616E64202671756F743B76616C75652671756F743B2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167';
wwv_flow_imp.g_varchar2_table(47602) := '652D6665656C223E67657420656E7472696573287B666F6F3A203132337D295C6E2F2F205B7B6B65793A202671756F743B666F6F2671756F743B2C2076616C75653A203132337D5D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(47603) := '6F6E746578742070757428636F6E746578742C206B65792C2076616C756529222C6465736372697074696F6E3A273C703E416464732061206E657720656E74727920776974682074686520676976656E206B657920616E642076616C756520746F207468';
wwv_flow_imp.g_varchar2_table(47604) := '6520636F6E746578742E2052657475726E732061206E657720636F6E74657874207468617420696E636C756465732074686520656E7472792E3C2F703E5C6E3C703E496620616E20656E74727920666F72207468652073616D65206B657920616C726561';
wwv_flow_imp.g_varchar2_table(47605) := '64792065786973747320696E2074686520636F6E746578742C206974206F7665727269646573207468652076616C75652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C';
wwv_flow_imp.g_varchar2_table(47606) := '7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E746578742070757428636F6E746578743A20636F6E746578742C206B65793A20737472696E672C2076616C75653A20416E79293A20636F6E746578745C6E3C2F63';
wwv_flow_imp.g_varchar2_table(47607) := '6F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E7465787420707574287B783A317D2C202671';
wwv_flow_imp.g_varchar2_table(47608) := '756F743B792671756F743B2C2032295C6E2F2F207B783A312C20793A327D5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3A3A3A696E666F5C6E5468652066756E6374696F6E203C636F64653E636F6E746578742070757428293C2F636F64653E2072';
wwv_flow_imp.g_varchar2_table(47609) := '65706C61636564207468652070726576696F75732066756E6374696F6E203C636F64653E70757428293C2F636F64653E202843616D756E646120457874656E73696F6E292E205468655C6E70726576696F75732066756E6374696F6E2069732064657072';
wwv_flow_imp.g_varchar2_table(47610) := '65636174656420616E642073686F756C64206E6F74206265207573656420616E796D6F72652E5C6E3A3A3A3C2F703E5C6E277D2C7B6E616D653A22636F6E746578742070757428636F6E746578742C206B6579732C2076616C756529222C646573637269';
wwv_flow_imp.g_varchar2_table(47611) := '7074696F6E3A273C703E416464732061206E657720656E74727920776974682074686520676976656E2076616C756520746F2074686520636F6E746578742E205468652070617468206F662074686520656E74727920697320646566696E656420627920';
wwv_flow_imp.g_varchar2_table(47612) := '746865206B6579732E2052657475726E732061206E657720636F6E74657874207468617420696E636C756465732074686520656E7472792E3C2F703E5C6E3C703E4966203C636F64653E6B6579733C2F636F64653E20636F6E7461696E7320746865206B';
wwv_flow_imp.g_varchar2_table(47613) := '657973203C636F64653E5B6B312C206B325D3C2F636F64653E207468656E206974206164647320746865206E657374656420656E747279203C636F64653E6B312E6B32203D2076616C75653C2F636F64653E20746F2074686520636F6E746578742E3C2F';
wwv_flow_imp.g_varchar2_table(47614) := '703E5C6E3C703E496620616E20656E74727920666F72207468652073616D65206B65797320616C72656164792065786973747320696E2074686520636F6E746578742C206974206F7665727269646573207468652076616C75652E3C2F703E5C6E3C703E';
wwv_flow_imp.g_varchar2_table(47615) := '4966203C636F64653E6B6579733C2F636F64653E2061726520656D7074792C2069742072657475726E73203C636F64653E6E756C6C3C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374';
wwv_flow_imp.g_varchar2_table(47616) := '726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E746578742070757428636F6E746578743A20636F6E746578742C206B6579733A206C697374266C743B737472696E672667743B2C20';
wwv_flow_imp.g_varchar2_table(47617) := '76616C75653A20416E79293A20636F6E746578745C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665';
wwv_flow_imp.g_varchar2_table(47618) := '656C223E636F6E7465787420707574287B783A317D2C205B2671756F743B792671756F743B5D2C2032295C6E2F2F207B783A312C20793A327D5C6E5C6E636F6E7465787420707574287B783A312C20793A207B7A3A307D7D2C205B2671756F743B792671';
wwv_flow_imp.g_varchar2_table(47619) := '756F743B2C202671756F743B7A2671756F743B5D2C2032295C6E2F2F207B783A312C20793A207B7A3A327D7D5C6E5C6E636F6E7465787420707574287B783A317D2C205B2671756F743B792671756F743B2C202671756F743B7A2671756F743B5D2C2032';
wwv_flow_imp.g_varchar2_table(47620) := '295C6E2F2F207B783A312C20793A207B7A3A327D7D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22636F6E74657874206D6572676528636F6E746578747329222C6465736372697074696F6E3A273C703E556E696F6E207468652067';
wwv_flow_imp.g_varchar2_table(47621) := '6976656E20636F6E74657874732E2052657475726E732061206E657720636F6E74657874207468617420696E636C7564657320616C6C20656E7472696573206F662074686520676976656E20636F6E74657874732E3C2F703E5C6E3C703E496620616E20';
wwv_flow_imp.g_varchar2_table(47622) := '656E74727920666F72207468652073616D65206B657920616C72656164792065786973747320696E206120636F6E746578742C206974206F7665727269646573207468652076616C75652E2054686520656E747269657320617265206F76657272696464';
wwv_flow_imp.g_varchar2_table(47623) := '656E20696E207468652073616D65206F7264657220617320696E20746865206C697374206F6620636F6E74657874732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C70';
wwv_flow_imp.g_varchar2_table(47624) := '72653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E74657874206D6572676528636F6E74657874733A206C697374266C743B636F6E746578742667743B293A20636F6E746578745C6E3C2F636F64653E3C2F7072653E5C';
wwv_flow_imp.g_varchar2_table(47625) := '6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E74657874206D65726765285B7B783A317D2C207B793A327D5D295C6E2F';
wwv_flow_imp.g_varchar2_table(47626) := '2F207B783A312C20793A327D5C6E5C6E636F6E74657874206D65726765285B7B783A312C20793A20307D2C207B793A327D5D295C6E2F2F207B783A312C20793A327D5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3A3A3A696E666F5C6E5468652066';
wwv_flow_imp.g_varchar2_table(47627) := '756E6374696F6E203C636F64653E636F6E74657874206D6572676528293C2F636F64653E207265706C61636564207468652070726576696F75732066756E6374696F6E203C636F64653E70757420616C6C28293C2F636F64653E202843616D756E646120';
wwv_flow_imp.g_varchar2_table(47628) := '457874656E73696F6E292E205468655C6E70726576696F75732066756E6374696F6E206973206465707265636174656420616E642073686F756C64206E6F74206265207573656420616E796D6F72652E5C6E3A3A3A3C2F703E5C6E277D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(47629) := '22737472696E672866726F6D29222C6465736372697074696F6E3A273C703E52657475726E732074686520676976656E2076616C7565206173206120737472696E6720726570726573656E746174696F6E2E3C2F703E5C6E3C703E3C7374726F6E673E46';
wwv_flow_imp.g_varchar2_table(47630) := '756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E672866726F6D3A20416E79293A20737472696E675C6E3C2F636F64653E3C';
wwv_flow_imp.g_varchar2_table(47631) := '2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E6728312E31295C6E2F2F202671756F743B312E3126';
wwv_flow_imp.g_varchar2_table(47632) := '71756F743B5C6E5C6E737472696E672864617465282671756F743B323031322D31322D32352671756F743B29295C6E2F2F202671756F743B323031322D31322D32352671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226E';
wwv_flow_imp.g_varchar2_table(47633) := '756D6265722866726F6D29222C6465736372697074696F6E3A273C703E5061727365732074686520676976656E20737472696E6720746F2061206E756D6265722E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E6174757265';
wwv_flow_imp.g_varchar2_table(47634) := '3C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6E756D6265722866726F6D3A20737472696E67293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C737472';
wwv_flow_imp.g_varchar2_table(47635) := '6F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6E756D626572282671756F743B313530302E352671756F743B295C6E2F2F20313530302E355C6E3C';
wwv_flow_imp.g_varchar2_table(47636) := '2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22636F6E7465787428656E747269657329222C6465736372697074696F6E3A273C703E436F6E73747275637473206120636F6E74657874206F662074686520676976656E206C697374206F6620';
wwv_flow_imp.g_varchar2_table(47637) := '6B65792D76616C75652070616972732E2049742069732074686520726576657273652066756E6374696F6E20746F203C6120687265663D226665656C2D6275696C742D696E2D66756E6374696F6E732D636F6E746578742E6D64236765742D656E747269';
wwv_flow_imp.g_varchar2_table(47638) := '6573636F6E74657874223E67657420656E747269657328293C2F613E2E3C2F703E5C6E3C703E45616368206B65792D76616C75652070616972206D757374206265206120636F6E7465787420776974682074776F20656E74726965733A203C636F64653E';
wwv_flow_imp.g_varchar2_table(47639) := '6B65793C2F636F64653E20616E64203C636F64653E76616C75653C2F636F64653E2E2054686520656E7472792077697468206E616D65203C636F64653E6B65793C2F636F64653E206D757374206861766520612076616C7565206F662074686520747970';
wwv_flow_imp.g_varchar2_table(47640) := '65203C636F64653E737472696E673C2F636F64653E2E3C2F703E5C6E3C703E4974206D69676874206F7665727269646520636F6E7465787420656E747269657320696620746865206B6579732061726520657175616C2E2054686520656E747269657320';
wwv_flow_imp.g_varchar2_table(47641) := '617265206F76657272696464656E20696E207468652073616D65206F726465722061732074686520636F6E746578747320696E2074686520676976656E206C6973742E3C2F703E5C6E3C703E52657475726E73203C636F64653E6E756C6C3C2F636F6465';
wwv_flow_imp.g_varchar2_table(47642) := '3E206966206F6E65206F662074686520656E7472696573206973206E6F74206120636F6E74657874206F72206966206120636F6E7465787420646F65736E262333393B7420636F6E7461696E2074686520726571756972656420656E74726965732E3C2F';
wwv_flow_imp.g_varchar2_table(47643) := '703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E7465787428656E74726965733A206C69';
wwv_flow_imp.g_varchar2_table(47644) := '7374266C743B636F6E746578742667743B293A20636F6E746578745C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67';
wwv_flow_imp.g_varchar2_table(47645) := '756167652D6665656C223E636F6E74657874285B7B2671756F743B6B65792671756F743B3A2671756F743B612671756F743B2C202671756F743B76616C75652671756F743B3A317D2C207B2671756F743B6B65792671756F743B3A2671756F743B622671';
wwv_flow_imp.g_varchar2_table(47646) := '756F743B2C202671756F743B76616C75652671756F743B3A327D5D295C6E2F2F207B613A312C20623A327D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22646174652866726F6D29222C6465736372697074696F6E3A273C703E5265';
wwv_flow_imp.g_varchar2_table(47647) := '7475726E73206120646174652066726F6D2074686520676976656E2076616C75652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C617373';
wwv_flow_imp.g_varchar2_table(47648) := '3D226C616E67756167652D6665656C223E646174652866726F6D3A20737472696E67293A20646174655C6E3C2F636F64653E3C2F7072653E5C6E3C703E5061727365732074686520676976656E20737472696E6720696E746F206120646174652E3C2F70';
wwv_flow_imp.g_varchar2_table(47649) := '3E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646174652866726F6D3A206461746520616E642074696D65293A20646174655C6E3C2F636F64653E3C2F7072653E5C6E3C703E45787472616374732074686520';
wwv_flow_imp.g_varchar2_table(47650) := '6461746520636F6D706F6E656E742066726F6D2074686520676976656E206461746520616E642074696D652E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C617373';
wwv_flow_imp.g_varchar2_table(47651) := '3D226C616E67756167652D6665656C223E64617465282671756F743B323031382D30342D32392671756F743B295C6E2F2F2064617465282671756F743B323031382D30342D32392671756F743B295C6E5C6E64617465286461746520616E642074696D65';
wwv_flow_imp.g_varchar2_table(47652) := '282671756F743B323031322D31322D32355431313A30303A30302671756F743B29295C6E2F2F2064617465282671756F743B323031322D31322D32352671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22646174652879';
wwv_flow_imp.g_varchar2_table(47653) := '6561722C206D6F6E74682C2064617929222C6465736372697074696F6E3A273C703E52657475726E73206120646174652066726F6D2074686520676976656E20636F6D706F6E656E74732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E';
wwv_flow_imp.g_varchar2_table(47654) := '207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6461746528796561723A206E756D6265722C206D6F6E74683A206E756D6265722C206461793A206E756D';
wwv_flow_imp.g_varchar2_table(47655) := '626572293A20646174655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646174652832';
wwv_flow_imp.g_varchar2_table(47656) := '3031322C2031322C203235295C6E2F2F2064617465282671756F743B323031322D31322D32352671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2274696D652866726F6D29222C6465736372697074696F6E3A273C703E';
wwv_flow_imp.g_varchar2_table(47657) := '52657475726E7320612074696D652066726F6D2074686520676976656E2076616C75652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C61';
wwv_flow_imp.g_varchar2_table(47658) := '73733D226C616E67756167652D6665656C223E74696D652866726F6D3A20737472696E67293A2074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E5061727365732074686520676976656E20737472696E6720696E746F20612074696D652E3C';
wwv_flow_imp.g_varchar2_table(47659) := '2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E74696D652866726F6D3A206461746520616E642074696D65293A2074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E4578747261637473207468';
wwv_flow_imp.g_varchar2_table(47660) := '652074696D6520636F6D706F6E656E742066726F6D2074686520676976656E206461746520616E642074696D652E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C61';
wwv_flow_imp.g_varchar2_table(47661) := '73733D226C616E67756167652D6665656C223E74696D65282671756F743B31323A30303A30302671756F743B295C6E2F2F2074696D65282671756F743B31323A30303A30302671756F743B295C6E5C6E74696D65286461746520616E642074696D652826';
wwv_flow_imp.g_varchar2_table(47662) := '71756F743B323031322D31322D32355431313A30303A30302671756F743B29295C6E2F2F2074696D65282671756F743B31313A30303A30302671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2274696D6528686F75722C';
wwv_flow_imp.g_varchar2_table(47663) := '206D696E7574652C207365636F6E6429222C6465736372697074696F6E3A273C703E52657475726E7320612074696D652066726F6D2074686520676976656E20636F6D706F6E656E74732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E';
wwv_flow_imp.g_varchar2_table(47664) := '207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E74696D6528686F75723A206E756D6265722C206D696E7574653A206E756D6265722C207365636F6E643A';
wwv_flow_imp.g_varchar2_table(47665) := '206E756D626572293A2074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7469';
wwv_flow_imp.g_varchar2_table(47666) := '6D652832332C2035392C2030295C6E2F2F2074696D65282671756F743B32333A35393A30302671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2274696D6528686F75722C206D696E7574652C207365636F6E642C206F66';
wwv_flow_imp.g_varchar2_table(47667) := '6673657429222C6465736372697074696F6E3A273C703E52657475726E7320612074696D652066726F6D2074686520676976656E20636F6D706F6E656E74732C20696E636C7564696E6720612074696D657A6F6E65206F66667365742E3C2F703E5C6E3C';
wwv_flow_imp.g_varchar2_table(47668) := '703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E74696D6528686F75723A206E756D6265722C206D696E7574';
wwv_flow_imp.g_varchar2_table(47669) := '653A206E756D6265722C207365636F6E643A206E756D6265722C206F66667365743A206461797320616E642074696D65206475726174696F6E293A2074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C6573';
wwv_flow_imp.g_varchar2_table(47670) := '3C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E74696D652831342C2033302C20302C206475726174696F6E282671756F743B505431482671756F743B29295C6E2F2F2074696D65';
wwv_flow_imp.g_varchar2_table(47671) := '282671756F743B31343A33303A30302B30313A30302671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226461746520616E642074696D652866726F6D29222C6465736372697074696F6E3A273C703E5061727365732074';
wwv_flow_imp.g_varchar2_table(47672) := '686520676976656E20737472696E6720696E746F2061206461746520616E642074696D652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C';
wwv_flow_imp.g_varchar2_table(47673) := '6173733D226C616E67756167652D6665656C223E6461746520616E642074696D652866726F6D3A20737472696E67293A206461746520616E642074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F';
wwv_flow_imp.g_varchar2_table(47674) := '7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6461746520616E642074696D65282671756F743B323031382D30342D32395430393A33303A30302671756F743B295C6E2F2F20646174';
wwv_flow_imp.g_varchar2_table(47675) := '6520616E642074696D65282671756F743B323031382D30342D32395430393A33303A30302671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226461746520616E642074696D6528646174652C2074696D6529222C646573';
wwv_flow_imp.g_varchar2_table(47676) := '6372697074696F6E3A273C703E52657475726E732061206461746520616E642074696D652066726F6D2074686520676976656E20636F6D706F6E656E74732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F';
wwv_flow_imp.g_varchar2_table(47677) := '7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6461746520616E642074696D6528646174653A20646174652C2074696D653A2074696D65293A206461746520616E642074696D655C6E';
wwv_flow_imp.g_varchar2_table(47678) := '3C2F636F64653E3C2F7072653E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6461746520616E642074696D6528646174653A206461746520616E642074696D652C2074696D653A2074696D65293A2064617465';
wwv_flow_imp.g_varchar2_table(47679) := '20616E642074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E52657475726E732061206461746520616E642074696D652076616C7565207468617420636F6E7369737473206F6620746865206461746520636F6D706F6E656E74206F66203C63';
wwv_flow_imp.g_varchar2_table(47680) := '6F64653E646174653C2F636F64653E20636F6D62696E65642077697468203C636F64653E74696D653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F64652063';
wwv_flow_imp.g_varchar2_table(47681) := '6C6173733D226C616E67756167652D6665656C223E6461746520616E642074696D652864617465282671756F743B323031322D31322D32342671756F743B292C74696D65282671756F743B5432333A35393A30302671756F743B29295C6E2F2F20646174';
wwv_flow_imp.g_varchar2_table(47682) := '6520616E642074696D65282671756F743B323031322D31322D32345432333A35393A30302671756F743B295C6E5C6E6461746520616E642074696D65286461746520616E642074696D65282671756F743B323031322D31322D32355431313A30303A3030';
wwv_flow_imp.g_varchar2_table(47683) := '2671756F743B292C74696D65282671756F743B5432333A35393A30302671756F743B29295C6E2F2F206461746520616E642074696D65282671756F743B323031322D31322D32355432333A35393A30302671756F743B295C6E3C2F636F64653E3C2F7072';
wwv_flow_imp.g_varchar2_table(47684) := '653E5C6E277D2C7B6E616D653A226461746520616E642074696D6528646174652C2074696D657A6F6E6529222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E52657475';
wwv_flow_imp.g_varchar2_table(47685) := '726E732074686520676976656E206461746520616E642074696D652076616C75652061742074686520676976656E2074696D657A6F6E652E3C2F703E5C6E3C703E4966203C636F64653E646174653C2F636F64653E20686173206120646966666572656E';
wwv_flow_imp.g_varchar2_table(47686) := '742074696D657A6F6E65207468616E203C636F64653E74696D657A6F6E653C2F636F64653E207468656E2069742061646A75737473207468652074696D6520746F206D6174636820746865206C6F63616C2074696D65206F66203C636F64653E74696D65';
wwv_flow_imp.g_varchar2_table(47687) := '7A6F6E653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6461746520';
wwv_flow_imp.g_varchar2_table(47688) := '616E642074696D6528646174653A206461746520616E642074696D652C2074696D657A6F6E653A20737472696E67293A206461746520616E642074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F';
wwv_flow_imp.g_varchar2_table(47689) := '7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6461746520616E642074696D6528402671756F743B323032302D30372D33315431343A32373A3330404575726F70652F4265726C696E';
wwv_flow_imp.g_varchar2_table(47690) := '2671756F743B2C202671756F743B416D65726963612F4C6F735F416E67656C65732671756F743B295C6E2F2F206461746520616E642074696D65282671756F743B323032302D30372D33315430353A32373A333040416D65726963612F4C6F735F416E67';
wwv_flow_imp.g_varchar2_table(47691) := '656C65732671756F743B295C6E5C6E6461746520616E642074696D6528402671756F743B323032302D30372D33315431343A32373A33302671756F743B2C202671756F743B5A2671756F743B295C6E2F2F206461746520616E642074696D65282671756F';
wwv_flow_imp.g_varchar2_table(47692) := '743B323032302D30372D33315431323A32373A33305A2671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226475726174696F6E2866726F6D29222C6465736372697074696F6E3A273C703E506172736573207468652067';
wwv_flow_imp.g_varchar2_table(47693) := '6976656E20737472696E6720696E746F2061206475726174696F6E2E20546865206475726174696F6E206973206569746865722061206461797320616E642074696D65206475726174696F6E206F72206120796561727320616E64206D6F6E7468732064';
wwv_flow_imp.g_varchar2_table(47694) := '75726174696F6E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6475726174696F6E28';
wwv_flow_imp.g_varchar2_table(47695) := '66726F6D3A20737472696E67293A206461797320616E642074696D65206475726174696F6E5C6E3C2F636F64653E3C2F7072653E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6475726174696F6E2866726F6D';
wwv_flow_imp.g_varchar2_table(47696) := '3A20737472696E67293A20796561727320616E64206D6F6E746873206475726174696F6E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C';
wwv_flow_imp.g_varchar2_table(47697) := '6173733D226C616E67756167652D6665656C223E6475726174696F6E282671756F743B5035442671756F743B295C6E2F2F206475726174696F6E282671756F743B5035442671756F743B295C6E5C6E6475726174696F6E282671756F743B503332592671';
wwv_flow_imp.g_varchar2_table(47698) := '756F743B295C6E2F2F206475726174696F6E282671756F743B503332592671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22796561727320616E64206D6F6E746873206475726174696F6E2866726F6D2C20746F29222C';
wwv_flow_imp.g_varchar2_table(47699) := '6465736372697074696F6E3A273C703E52657475726E732074686520796561727320616E64206D6F6E746873206475726174696F6E206265747765656E203C636F64653E66726F6D3C2F636F64653E20616E64203C636F64653E746F3C2F636F64653E2E';
wwv_flow_imp.g_varchar2_table(47700) := '3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E796561727320616E64206D6F6E74687320';
wwv_flow_imp.g_varchar2_table(47701) := '6475726174696F6E2866726F6D3A20646174652C20746F3A2064617465293A20796561727320616E64206D6F6E746873206475726174696F6E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E';
wwv_flow_imp.g_varchar2_table(47702) := '673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E796561727320616E64206D6F6E746873206475726174696F6E2864617465282671756F743B323031312D31322D32322671756F743B292C20646174';
wwv_flow_imp.g_varchar2_table(47703) := '65282671756F743B323031332D30382D32342671756F743B29295C6E2F2F206475726174696F6E282671756F743B503159384D2671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226C69737420636F6E7461696E73286C';
wwv_flow_imp.g_varchar2_table(47704) := '6973742C20656C656D656E7429222C6465736372697074696F6E3A273C703E52657475726E73203C636F64653E747275653C2F636F64653E2069662074686520676976656E206C69737420636F6E7461696E732074686520656C656D656E742E204F7468';
wwv_flow_imp.g_varchar2_table(47705) := '6572776973652C2072657475726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173';
wwv_flow_imp.g_varchar2_table(47706) := '733D226C616E67756167652D6665656C223E6C69737420636F6E7461696E73286C6973743A206C6973742C20656C656D656E743A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C';
wwv_flow_imp.g_varchar2_table(47707) := '65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C69737420636F6E7461696E73285B312C322C335D2C2032295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C';
wwv_flow_imp.g_varchar2_table(47708) := '6E277D2C7B6E616D653A22636F756E74286C69737429222C6465736372697074696F6E3A273C703E52657475726E7320746865206E756D626572206F6620656C656D656E7473206F662074686520676976656E206C6973742E3C2F703E5C6E3C703E3C73';
wwv_flow_imp.g_varchar2_table(47709) := '74726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F756E74286C6973743A206C697374293A206E756D6265725C6E3C';
wwv_flow_imp.g_varchar2_table(47710) := '2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F756E74285B312C322C335D295C6E2F2F20';
wwv_flow_imp.g_varchar2_table(47711) := '335C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D696E286C69737429222C6465736372697074696F6E3A273C703E52657475726E7320746865206D696E696D756D206F662074686520676976656E206C6973742E3C2F703E5C6E3C';
wwv_flow_imp.g_varchar2_table(47712) := '703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D696E286C6973743A206C697374293A20416E795C6E3C2F';
wwv_flow_imp.g_varchar2_table(47713) := '636F64653E3C2F7072653E5C6E3C703E416C6C20656C656D656E747320696E203C636F64653E6C6973743C2F636F64653E2073686F756C642068617665207468652073616D65207479706520616E6420626520636F6D70617261626C652E3C2F703E5C6E';
wwv_flow_imp.g_varchar2_table(47714) := '3C703E54686520706172616D65746572203C636F64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374';
wwv_flow_imp.g_varchar2_table(47715) := '726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D696E285B312C322C335D295C6E2F2F20315C6E5C6E6D696E28312C322C33295C6E2F2F20315C';
wwv_flow_imp.g_varchar2_table(47716) := '6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D6178286C69737429222C6465736372697074696F6E3A273C703E52657475726E7320746865206D6178696D756D206F662074686520676976656E206C6973742E3C2F703E5C6E3C703E';
wwv_flow_imp.g_varchar2_table(47717) := '3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6178286C6973743A206C697374293A20416E795C6E3C2F636F';
wwv_flow_imp.g_varchar2_table(47718) := '64653E3C2F7072653E5C6E3C703E416C6C20656C656D656E747320696E203C636F64653E6C6973743C2F636F64653E2073686F756C642068617665207468652073616D65207479706520616E6420626520636F6D70617261626C652E3C2F703E5C6E3C70';
wwv_flow_imp.g_varchar2_table(47719) := '3E54686520706172616D65746572203C636F64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F';
wwv_flow_imp.g_varchar2_table(47720) := '6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6178285B312C322C335D295C6E2F2F20335C6E5C6E6D617828312C322C33295C6E2F2F20335C6E3C';
wwv_flow_imp.g_varchar2_table(47721) := '2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2273756D286C69737429222C6465736372697074696F6E3A273C703E52657475726E73207468652073756D206F662074686520676976656E206C697374206F66206E756D626572732E3C2F703E';
wwv_flow_imp.g_varchar2_table(47722) := '5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73756D286C6973743A206C697374266C743B6E756D';
wwv_flow_imp.g_varchar2_table(47723) := '6265722667743B293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F72206173206120';
wwv_flow_imp.g_varchar2_table(47724) := '73657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73756D285B31';
wwv_flow_imp.g_varchar2_table(47725) := '2C322C335D295C6E2F2F20365C6E5C6E73756D28312C322C33295C6E2F2F20365C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2270726F64756374286C69737429222C6465736372697074696F6E3A273C703E52657475726E73207468';
wwv_flow_imp.g_varchar2_table(47726) := '652070726F64756374206F662074686520676976656E206C697374206F66206E756D626572732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520';
wwv_flow_imp.g_varchar2_table(47727) := '636C6173733D226C616E67756167652D6665656C223E70726F64756374286C6973743A206C697374266C743B6E756D6265722667743B293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F';
wwv_flow_imp.g_varchar2_table(47728) := '64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E';
wwv_flow_imp.g_varchar2_table(47729) := '673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E70726F64756374285B322C20332C20345D295C6E2F2F2032345C6E5C6E70726F6475637428322C20332C2034295C6E2F2F2032345C6E3C2F636F64';
wwv_flow_imp.g_varchar2_table(47730) := '653E3C2F7072653E5C6E277D2C7B6E616D653A226D65616E286C69737429222C6465736372697074696F6E3A273C703E52657475726E73207468652061726974686D65746963206D65616E2028692E652E206176657261676529206F6620746865206769';
wwv_flow_imp.g_varchar2_table(47731) := '76656E206C697374206F66206E756D626572732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D666565';
wwv_flow_imp.g_varchar2_table(47732) := '6C223E6D65616E286C6973743A206C697374266C743B6E756D6265722667743B293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E6C6973743C2F636F64653E2063616E20626520';
wwv_flow_imp.g_varchar2_table(47733) := '7061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C61';
wwv_flow_imp.g_varchar2_table(47734) := '73733D226C616E67756167652D6665656C223E6D65616E285B312C322C335D295C6E2F2F20325C6E5C6E6D65616E28312C322C33295C6E2F2F20325C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D656469616E286C69737429222C';
wwv_flow_imp.g_varchar2_table(47735) := '6465736372697074696F6E3A273C703E52657475726E7320746865206D656469616E20656C656D656E74206F662074686520676976656E206C697374206F66206E756D626572732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369';
wwv_flow_imp.g_varchar2_table(47736) := '676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D656469616E286C6973743A206C697374266C743B6E756D6265722667743B293A206E756D6265725C6E3C2F63';
wwv_flow_imp.g_varchar2_table(47737) := '6F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E';
wwv_flow_imp.g_varchar2_table(47738) := '3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D656469616E28382C20322C20352C20332C2034295C6E2F2F2034';
wwv_flow_imp.g_varchar2_table(47739) := '5C6E5C6E6D656469616E285B362C20312C20322C20335D295C6E2F2F20322E355C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737464646576286C69737429222C6465736372697074696F6E3A273C703E52657475726E7320746865';
wwv_flow_imp.g_varchar2_table(47740) := '207374616E6461726420646576696174696F6E206F662074686520676976656E206C697374206F66206E756D626572732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C';
wwv_flow_imp.g_varchar2_table(47741) := '7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737464646576286C6973743A206C697374266C743B6E756D6265722667743B293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E5468652070617261';
wwv_flow_imp.g_varchar2_table(47742) := '6D65746572203C636F64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C';
wwv_flow_imp.g_varchar2_table(47743) := '65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73746464657628322C20342C20372C2035295C6E2F2F20322E303831363635393939343636313332365C6E5C6E7374646465';
wwv_flow_imp.g_varchar2_table(47744) := '76285B322C20342C20372C20355D295C6E2F2F20322E303831363635393939343636313332365C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D6F6465286C69737429222C6465736372697074696F6E3A273C703E52657475726E73';
wwv_flow_imp.g_varchar2_table(47745) := '20746865206D6F6465206F662074686520676976656E206C697374206F66206E756D626572732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520';
wwv_flow_imp.g_varchar2_table(47746) := '636C6173733D226C616E67756167652D6665656C223E6D6F6465286C6973743A206C697374266C743B6E756D6265722667743B293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E';
wwv_flow_imp.g_varchar2_table(47747) := '6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C';
wwv_flow_imp.g_varchar2_table(47748) := '2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6F646528362C20332C20392C20362C2036295C6E2F2F205B365D5C6E5C6E6D6F6465285B362C20312C20392C20362C20315D295C6E2F2F205B312C2036';
wwv_flow_imp.g_varchar2_table(47749) := '5D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22616C6C286C69737429222C6465736372697074696F6E3A273C703E52657475726E73203C636F64653E66616C73653C2F636F64653E20696620616E7920656C656D656E74206F6620';
wwv_flow_imp.g_varchar2_table(47750) := '74686520676976656E206C697374206973203C636F64653E66616C73653C2F636F64653E2E204F74686572776973652C2072657475726E73203C636F64653E747275653C2F636F64653E2E3C2F703E5C6E3C703E49662074686520676976656E206C6973';
wwv_flow_imp.g_varchar2_table(47751) := '7420697320656D7074792C2069742072657475726E73203C636F64653E747275653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F64';
wwv_flow_imp.g_varchar2_table(47752) := '6520636C6173733D226C616E67756167652D6665656C223E616C6C286C6973743A206C697374266C743B626F6F6C65616E2667743B293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F';
wwv_flow_imp.g_varchar2_table(47753) := '64653E6C6973743C2F636F64653E2063616E206265207061737365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E';
wwv_flow_imp.g_varchar2_table(47754) := '673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616C6C285B747275652C66616C73655D295C6E2F2F2066616C73655C6E5C6E616C6C2866616C73652C6E756C6C2C74727565295C6E2F2F2066616C';
wwv_flow_imp.g_varchar2_table(47755) := '73655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3A3A3A696E666F5C6E5468652066756E6374696F6E203C636F64653E616C6C28293C2F636F64653E207265706C61636564207468652070726576696F75732066756E6374696F6E203C636F64653E';
wwv_flow_imp.g_varchar2_table(47756) := '616E6428293C2F636F64653E2E205468652070726576696F75732066756E6374696F6E206973206465707265636174656420616E645C6E73686F756C64206E6F74206265207573656420616E796D6F72652E5C6E3A3A3A3C2F703E5C6E277D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(47757) := '653A22616E79286C69737429222C6465736372697074696F6E3A273C703E52657475726E73203C636F64653E747275653C2F636F64653E20696620616E7920656C656D656E74206F662074686520676976656E206C697374206973203C636F64653E7472';
wwv_flow_imp.g_varchar2_table(47758) := '75653C2F636F64653E2E204F74686572776973652C2072657475726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E49662074686520676976656E206C69737420697320656D7074792C2069742072657475726E73203C636F';
wwv_flow_imp.g_varchar2_table(47759) := '64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E61';
wwv_flow_imp.g_varchar2_table(47760) := '6E79286C6973743A206C697374266C743B626F6F6C65616E2667743B293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E6C6973743C2F636F64653E2063616E20626520706173';
wwv_flow_imp.g_varchar2_table(47761) := '7365642061732061206C697374206F7220617320612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D';
wwv_flow_imp.g_varchar2_table(47762) := '226C616E67756167652D6665656C223E616E79285B66616C73652C747275655D295C6E2F2F20747275655C6E5C6E616E792866616C73652C6E756C6C2C74727565295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3A3A3A696E';
wwv_flow_imp.g_varchar2_table(47763) := '666F5C6E5468652066756E6374696F6E203C636F64653E616E7928293C2F636F64653E207265706C61636564207468652070726576696F75732066756E6374696F6E203C636F64653E6F7228293C2F636F64653E2E205468652070726576696F75732066';
wwv_flow_imp.g_varchar2_table(47764) := '756E6374696F6E206973206465707265636174656420616E645C6E73686F756C64206E6F74206265207573656420616E796D6F72652E5C6E3A3A3A3C2F703E5C6E277D2C7B6E616D653A227375626C697374286C6973742C20737461727420706F736974';
wwv_flow_imp.g_varchar2_table(47765) := '696F6E29222C6465736372697074696F6E3A273C703E52657475726E732061207061727469616C206C697374206F662074686520676976656E2076616C7565207374617274696E67206174203C636F64653E737461727420706F736974696F6E3C2F636F';
wwv_flow_imp.g_varchar2_table(47766) := '64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7375626C697374286C6973743A';
wwv_flow_imp.g_varchar2_table(47767) := '206C6973742C20737461727420706F736974696F6E3A206E756D626572293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E737461727420706F736974696F6E3C2F636F64653E20737461727473206174207468';
wwv_flow_imp.g_varchar2_table(47768) := '6520696E646578203C636F64653E313C2F636F64653E2E20546865206C61737420706F736974696F6E206973203C636F64653E2D313C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C';
wwv_flow_imp.g_varchar2_table(47769) := '6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7375626C697374285B312C322C335D2C2032295C6E2F2F205B322C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A227375626C697374286C69';
wwv_flow_imp.g_varchar2_table(47770) := '73742C20737461727420706F736974696F6E2C206C656E67746829222C6465736372697074696F6E3A273C703E52657475726E732061207061727469616C206C697374206F662074686520676976656E2076616C7565207374617274696E67206174203C';
wwv_flow_imp.g_varchar2_table(47771) := '636F64653E737461727420706F736974696F6E3C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E6775';
wwv_flow_imp.g_varchar2_table(47772) := '6167652D6665656C223E7375626C697374286C6973743A206C6973742C20737461727420706F736974696F6E3A206E756D6265722C206C656E6774683A206E756D626572293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C';
wwv_flow_imp.g_varchar2_table(47773) := '636F64653E737461727420706F736974696F6E3C2F636F64653E207374617274732061742074686520696E646578203C636F64653E313C2F636F64653E2E20546865206C61737420706F736974696F6E206973203C636F64653E2D313C2F636F64653E2E';
wwv_flow_imp.g_varchar2_table(47774) := '3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7375626C697374285B312C322C335D2C20312C2032295C6E2F2F20';
wwv_flow_imp.g_varchar2_table(47775) := '5B312C325D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22617070656E64286C6973742C206974656D7329222C6465736372697074696F6E3A273C703E52657475726E732074686520676976656E206C697374207769746820616C6C';
wwv_flow_imp.g_varchar2_table(47776) := '203C636F64653E6974656D733C2F636F64653E20617070656E6465642E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E';
wwv_flow_imp.g_varchar2_table(47777) := '67756167652D6665656C223E617070656E64286C6973743A206C6973742C206974656D733A20416E79293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E6974656D733C2F636F64653E';
wwv_flow_imp.g_varchar2_table(47778) := '2063616E20626520612073696E676C6520656C656D656E74206F7220612073657175656E6365206F6620656C656D656E74732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F64';
wwv_flow_imp.g_varchar2_table(47779) := '6520636C6173733D226C616E67756167652D6665656C223E617070656E64285B315D2C20322C2033295C6E2F2F205B312C322C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22636F6E636174656E617465286C6973747329222C';
wwv_flow_imp.g_varchar2_table(47780) := '6465736372697074696F6E3A273C703E52657475726E732061206C697374207468617420696E636C7564657320616C6C20656C656D656E7473206F662074686520676976656E206C697374732E3C2F703E5C6E3C703E3C7374726F6E673E46756E637469';
wwv_flow_imp.g_varchar2_table(47781) := '6F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E636174656E617465286C697374733A206C697374293A206C6973745C6E3C2F636F64653E3C';
wwv_flow_imp.g_varchar2_table(47782) := '2F7072653E5C6E3C703E54686520706172616D65746572203C636F64653E6C697374733C2F636F64653E20697320612073657175656E6365206F66206C697374732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E';
wwv_flow_imp.g_varchar2_table(47783) := '3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E636174656E617465285B312C325D2C5B335D295C6E2F2F205B312C322C335D5C6E5C6E636F6E636174656E617465285B315D2C5B325D2C5B335D';
wwv_flow_imp.g_varchar2_table(47784) := '295C6E2F2F205B312C322C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22696E73657274206265666F7265286C6973742C20706F736974696F6E2C206E65774974656D29222C6465736372697074696F6E3A273C703E52657475';
wwv_flow_imp.g_varchar2_table(47785) := '726E732074686520676976656E206C6973742077697468203C636F64653E6E65774974656D3C2F636F64653E20696E736572746564206174203C636F64653E706F736974696F6E3C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E63';
wwv_flow_imp.g_varchar2_table(47786) := '74696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E696E73657274206265666F7265286C6973743A206C6973742C20706F736974696F6E3A206E75';
wwv_flow_imp.g_varchar2_table(47787) := '6D6265722C206E65774974656D3A20416E79293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E706F736974696F6E3C2F636F64653E207374617274732061742074686520696E646578203C636F64653E313C2F';
wwv_flow_imp.g_varchar2_table(47788) := '636F64653E2E20546865206C61737420706F736974696F6E206973203C636F64653E2D313C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C617373';
wwv_flow_imp.g_varchar2_table(47789) := '3D226C616E67756167652D6665656C223E696E73657274206265666F7265285B312C335D2C312C32295C6E2F2F205B322C312C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2272656D6F7665286C6973742C20706F736974696F';
wwv_flow_imp.g_varchar2_table(47790) := '6E29222C6465736372697074696F6E3A273C703E52657475726E732074686520676976656E206C69737420776974686F75742074686520656C656D656E74206174203C636F64653E706F736974696F6E3C2F636F64653E2E3C2F703E5C6E3C703E3C7374';
wwv_flow_imp.g_varchar2_table(47791) := '726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E72656D6F7665286C6973743A206C6973742C20706F736974696F6E3A20';
wwv_flow_imp.g_varchar2_table(47792) := '6E756D626572293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E706F736974696F6E3C2F636F64653E207374617274732061742074686520696E646578203C636F64653E313C2F636F64653E2E20546865206C';
wwv_flow_imp.g_varchar2_table(47793) := '61737420706F736974696F6E206973203C636F64653E2D313C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D66';
wwv_flow_imp.g_varchar2_table(47794) := '65656C223E72656D6F7665285B312C322C335D2C2032295C6E2F2F205B312C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2272657665727365286C69737429222C6465736372697074696F6E3A273C703E52657475726E732074';
wwv_flow_imp.g_varchar2_table(47795) := '686520676976656E206C69737420696E2072657665726564206F726465722E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C';
wwv_flow_imp.g_varchar2_table(47796) := '616E67756167652D6665656C223E72657665727365286C6973743A206C697374293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F6465';
wwv_flow_imp.g_varchar2_table(47797) := '20636C6173733D226C616E67756167652D6665656C223E72657665727365285B312C322C335D295C6E2F2F205B332C322C315D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22696E646578206F66286C6973742C206D617463682922';
wwv_flow_imp.g_varchar2_table(47798) := '2C6465736372697074696F6E3A273C703E52657475726E7320616E20617363656E64696E67206C697374206F6620706F736974696F6E7320636F6E7461696E696E67203C636F64653E6D617463683C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F';
wwv_flow_imp.g_varchar2_table(47799) := '6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E696E646578206F66286C6973743A206C6973742C206D617463683A20416E79';
wwv_flow_imp.g_varchar2_table(47800) := '293A206C697374266C743B6E756D6265722667743B5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D66';
wwv_flow_imp.g_varchar2_table(47801) := '65656C223E696E646578206F66285B312C322C332C325D2C32295C6E2F2F205B322C345D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22756E696F6E286C69737429222C6465736372697074696F6E3A273C703E52657475726E7320';
wwv_flow_imp.g_varchar2_table(47802) := '61206C697374207468617420696E636C7564657320616C6C20656C656D656E7473206F662074686520676976656E206C6973747320776974686F7574206475706C6963617465732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369';
wwv_flow_imp.g_varchar2_table(47803) := '676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E756E696F6E286C6973743A206C697374293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E5468';
wwv_flow_imp.g_varchar2_table(47804) := '6520706172616D65746572203C636F64653E6C6973743C2F636F64653E20697320612073657175656E6365206F66206C697374732E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C63';
wwv_flow_imp.g_varchar2_table(47805) := '6F646520636C6173733D226C616E67756167652D6665656C223E756E696F6E285B312C325D2C5B322C335D295C6E2F2F205B312C322C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2264697374696E63742076616C756573286C';
wwv_flow_imp.g_varchar2_table(47806) := '69737429222C6465736372697074696F6E3A273C703E52657475726E732074686520676976656E206C69737420776974686F7574206475706C6963617465732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C';
wwv_flow_imp.g_varchar2_table(47807) := '2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E64697374696E63742076616C756573286C6973743A206C697374293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E';
wwv_flow_imp.g_varchar2_table(47808) := '3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E64697374696E63742076616C756573285B312C322C332C322C315D295C6E2F2F205B312C';
wwv_flow_imp.g_varchar2_table(47809) := '322C335D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226475706C69636174652076616C756573286C69737429222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F70';
wwv_flow_imp.g_varchar2_table(47810) := '3E5C6E3C703E52657475726E7320616C6C206475706C69636174652076616C756573206F662074686520676976656E206C6973742E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F70';
wwv_flow_imp.g_varchar2_table(47811) := '3E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6475706C69636174652076616C756573286C6973743A206C697374293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578';
wwv_flow_imp.g_varchar2_table(47812) := '616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6475706C69636174652076616C756573285B312C322C332C322C315D295C6E2F2F205B312C325D5C6E3C2F636F64';
wwv_flow_imp.g_varchar2_table(47813) := '653E3C2F7072653E5C6E277D2C7B6E616D653A22666C617474656E286C69737429222C6465736372697074696F6E3A273C703E52657475726E732061206C697374207468617420696E636C7564657320616C6C20656C656D656E7473206F662074686520';
wwv_flow_imp.g_varchar2_table(47814) := '676976656E206C69737420776974686F7574206E6573746564206C697374732E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D22';
wwv_flow_imp.g_varchar2_table(47815) := '6C616E67756167652D6665656C223E666C617474656E286C6973743A206C697374293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F64';
wwv_flow_imp.g_varchar2_table(47816) := '6520636C6173733D226C616E67756167652D6665656C223E666C617474656E285B5B312C325D2C5B5B335D5D2C20345D295C6E2F2F205B312C322C332C345D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22736F7274286C6973742C';
wwv_flow_imp.g_varchar2_table(47817) := '20707265636564657329222C6465736372697074696F6E3A273C703E52657475726E732074686520676976656E206C69737420736F7274656420627920746865203C636F64653E70726563656465733C2F636F64653E2066756E6374696F6E2E3C2F703E';
wwv_flow_imp.g_varchar2_table(47818) := '5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E736F7274286C6973743A206C6973742C2070726563';
wwv_flow_imp.g_varchar2_table(47819) := '656465733A2066756E6374696F6E266C743B28416E792C20416E7929202D2667743B20626F6F6C65616E2667743B293A206C6973745C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F';
wwv_flow_imp.g_varchar2_table(47820) := '703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E736F7274286C6973743A205B332C312C342C352C325D2C2070726563656465733A2066756E6374696F6E28782C7929207820266C743B2079295C6E2F2F205B';
wwv_flow_imp.g_varchar2_table(47821) := '312C322C332C342C355D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737472696E67206A6F696E286C69737429222C6465736372697074696F6E3A273C703E4A6F696E732061206C697374206F6620737472696E677320696E746F';
wwv_flow_imp.g_varchar2_table(47822) := '20612073696E676C6520737472696E672E20546869732069732073696D696C617220746F5C6E4A617661262333393B73203C6120687265663D2268747470733A2F2F646F63732E6F7261636C652E636F6D2F656E2F6A6176612F6A61766173652F31312F';
wwv_flow_imp.g_varchar2_table(47823) := '646F63732F6170692F6A6176612E626173652F6A6176612F7574696C2F73747265616D2F436F6C6C6563746F72732E68746D6C236A6F696E696E67286A6176612E6C616E672E4368617253657175656E63652C6A6176612E6C616E672E43686172536571';
wwv_flow_imp.g_varchar2_table(47824) := '75656E63652C6A6176612E6C616E672E4368617253657175656E636529223E6A6F696E696E673C2F613E5C6E66756E6374696F6E2E3C2F703E5C6E3C703E496620616E206974656D206F6620746865206C697374206973203C636F64653E6E756C6C3C2F';
wwv_flow_imp.g_varchar2_table(47825) := '636F64653E2C20746865206974656D2069732069676E6F72656420666F722074686520726573756C7420737472696E672E20496620616E206974656D2069735C6E6E656974686572206120737472696E67206E6F72203C636F64653E6E756C6C3C2F636F';
wwv_flow_imp.g_varchar2_table(47826) := '64653E2C207468652066756E6374696F6E2072657475726E73203C636F64653E6E756C6C3C2F636F64653E20696E7374656164206F66206120737472696E672E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C';
wwv_flow_imp.g_varchar2_table(47827) := '2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206A6F696E286C6973743A206C697374266C743B737472696E672667743B293A20737472696E675C6E3C2F636F6465';
wwv_flow_imp.g_varchar2_table(47828) := '3E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206A6F696E285B2671756F743B612671756F';
wwv_flow_imp.g_varchar2_table(47829) := '743B2C2671756F743B622671756F743B2C2671756F743B632671756F743B5D295C6E2F2F202671756F743B6162632671756F743B5C6E5C6E737472696E67206A6F696E285B2671756F743B612671756F743B2C6E756C6C2C2671756F743B632671756F74';
wwv_flow_imp.g_varchar2_table(47830) := '3B5D295C6E2F2F202671756F743B61632671756F743B5C6E5C6E737472696E67206A6F696E285B5D295C6E2F2F202671756F743B2671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737472696E67206A6F696E286C6973';
wwv_flow_imp.g_varchar2_table(47831) := '742C2064656C696D6974657229222C6465736372697074696F6E3A273C703E4A6F696E732061206C697374206F6620737472696E677320696E746F20612073696E676C6520737472696E672E20546869732069732073696D696C617220746F5C6E4A6176';
wwv_flow_imp.g_varchar2_table(47832) := '61262333393B73203C6120687265663D2268747470733A2F2F646F63732E6F7261636C652E636F6D2F656E2F6A6176612F6A61766173652F31312F646F63732F6170692F6A6176612E626173652F6A6176612F7574696C2F73747265616D2F436F6C6C65';
wwv_flow_imp.g_varchar2_table(47833) := '63746F72732E68746D6C236A6F696E696E67286A6176612E6C616E672E4368617253657175656E63652C6A6176612E6C616E672E4368617253657175656E63652C6A6176612E6C616E672E4368617253657175656E636529223E6A6F696E696E673C2F61';
wwv_flow_imp.g_varchar2_table(47834) := '3E5C6E66756E6374696F6E2E3C2F703E5C6E3C703E496620616E206974656D206F6620746865206C697374206973203C636F64653E6E756C6C3C2F636F64653E2C20746865206974656D2069732069676E6F72656420666F722074686520726573756C74';
wwv_flow_imp.g_varchar2_table(47835) := '20737472696E672E20496620616E206974656D2069735C6E6E656974686572206120737472696E67206E6F72203C636F64653E6E756C6C3C2F636F64653E2C207468652066756E6374696F6E2072657475726E73203C636F64653E6E756C6C3C2F636F64';
wwv_flow_imp.g_varchar2_table(47836) := '653E20696E7374656164206F66206120737472696E672E3C2F703E5C6E3C703E54686520726573756C74696E6720737472696E6720636F6E7461696E732061203C636F64653E64656C696D697465723C2F636F64653E206265747765656E206561636820';
wwv_flow_imp.g_varchar2_table(47837) := '656C656D656E742E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206A6F';
wwv_flow_imp.g_varchar2_table(47838) := '696E286C6973743A206C697374266C743B737472696E672667743B2C2064656C696D697465723A20737472696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E';
wwv_flow_imp.g_varchar2_table(47839) := '3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206A6F696E285B2671756F743B612671756F743B5D2C202671756F743B582671756F743B295C6E2F2F202671756F743B612671756F743B';
wwv_flow_imp.g_varchar2_table(47840) := '5C6E5C6E737472696E67206A6F696E285B2671756F743B612671756F743B2C2671756F743B622671756F743B2C2671756F743B632671756F743B5D2C202671756F743B2C202671756F743B295C6E2F2F202671756F743B612C20622C20632671756F743B';
wwv_flow_imp.g_varchar2_table(47841) := '5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737472696E67206A6F696E286C6973742C2064656C696D697465722C207072656669782C2073756666697829222C6465736372697074696F6E3A273C703E3C656D3E43616D756E6461';
wwv_flow_imp.g_varchar2_table(47842) := '20457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E4A6F696E732061206C697374206F6620737472696E677320696E746F20612073696E676C6520737472696E672E20546869732069732073696D696C617220746F5C6E4A617661262333393B73';
wwv_flow_imp.g_varchar2_table(47843) := '203C6120687265663D2268747470733A2F2F646F63732E6F7261636C652E636F6D2F656E2F6A6176612F6A61766173652F31312F646F63732F6170692F6A6176612E626173652F6A6176612F7574696C2F73747265616D2F436F6C6C6563746F72732E68';
wwv_flow_imp.g_varchar2_table(47844) := '746D6C236A6F696E696E67286A6176612E6C616E672E4368617253657175656E63652C6A6176612E6C616E672E4368617253657175656E63652C6A6176612E6C616E672E4368617253657175656E636529223E6A6F696E696E673C2F613E5C6E66756E63';
wwv_flow_imp.g_varchar2_table(47845) := '74696F6E2E3C2F703E5C6E3C703E496620616E206974656D206F6620746865206C697374206973203C636F64653E6E756C6C3C2F636F64653E2C20746865206974656D2069732069676E6F72656420666F722074686520726573756C7420737472696E67';
wwv_flow_imp.g_varchar2_table(47846) := '2E20496620616E206974656D2069735C6E6E656974686572206120737472696E67206E6F72203C636F64653E6E756C6C3C2F636F64653E2C207468652066756E6374696F6E2072657475726E73203C636F64653E6E756C6C3C2F636F64653E20696E7374';
wwv_flow_imp.g_varchar2_table(47847) := '656164206F66206120737472696E672E3C2F703E5C6E3C703E54686520726573756C74696E6720737472696E67207374617274732077697468203C636F64653E7072656669783C2F636F64653E2C20636F6E7461696E732061203C636F64653E64656C69';
wwv_flow_imp.g_varchar2_table(47848) := '6D697465723C2F636F64653E206265747765656E206561636820656C656D656E742C20616E6420656E64735C6E77697468203C636F64653E7375666669783C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E';
wwv_flow_imp.g_varchar2_table(47849) := '61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206A6F696E286C6973743A206C697374266C743B737472696E672667743B2C2064656C696D69746572';
wwv_flow_imp.g_varchar2_table(47850) := '3A20737472696E672C207072656669783A20737472696E672C207375666669783A20737472696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E';
wwv_flow_imp.g_varchar2_table(47851) := '3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206A6F696E285B2671756F743B612671756F743B2C2671756F743B622671756F743B2C2671756F743B632671756F743B5D2C202671756F743B2C202671';
wwv_flow_imp.g_varchar2_table(47852) := '756F743B2C202671756F743B5B2671756F743B2C202671756F743B5D2671756F743B295C6E2F2F202671756F743B5B612C20622C20635D2671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22646563696D616C286E2C2073';
wwv_flow_imp.g_varchar2_table(47853) := '63616C6529222C6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C75652061742074686520676976656E207363616C652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E6174757265';
wwv_flow_imp.g_varchar2_table(47854) := '3C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646563696D616C286E3A206E756D6265722C207363616C653A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F';
wwv_flow_imp.g_varchar2_table(47855) := '7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646563696D616C28312F332C2032295C6E2F2F202E33335C6E5C6E';
wwv_flow_imp.g_varchar2_table(47856) := '646563696D616C28312E352C2030295C6E2F2F20325C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22666C6F6F72286E29222C6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C756520776974';
wwv_flow_imp.g_varchar2_table(47857) := '6820726F756E64696E67206D6F646520666C6F6F72696E672E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167';
wwv_flow_imp.g_varchar2_table(47858) := '652D6665656C223E666C6F6F72286E3A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D';
wwv_flow_imp.g_varchar2_table(47859) := '226C616E67756167652D6665656C223E666C6F6F7228312E35295C6E2F2F20315C6E5C6E666C6F6F72282D312E35295C6E2F2F202D325C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22666C6F6F72286E2C207363616C6529222C6465';
wwv_flow_imp.g_varchar2_table(47860) := '736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C7565207769746820726F756E64696E67206D6F646520666C6F6F72696E672061742074686520676976656E207363616C652E3C2F703E5C6E3C703E3C7374726F6E67';
wwv_flow_imp.g_varchar2_table(47861) := '3E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E666C6F6F72286E3A206E756D6265722C207363616C653A206E756D626572293A20';
wwv_flow_imp.g_varchar2_table(47862) := '6E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E666C6F6F72282D312E35';
wwv_flow_imp.g_varchar2_table(47863) := '362C2031295C6E2F2F202D312E365C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226365696C696E67286E29222C6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C7565207769746820726F75';
wwv_flow_imp.g_varchar2_table(47864) := '6E64696E67206D6F6465206365696C696E672E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C';
wwv_flow_imp.g_varchar2_table(47865) := '223E6365696C696E67286E3A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E';
wwv_flow_imp.g_varchar2_table(47866) := '67756167652D6665656C223E6365696C696E6728312E35295C6E2F2F20325C6E5C6E6365696C696E67282D312E35295C6E2F2F202D315C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226365696C696E67286E2C207363616C6529222C';
wwv_flow_imp.g_varchar2_table(47867) := '6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C7565207769746820726F756E64696E67206D6F6465206365696C696E672061742074686520676976656E207363616C652E3C2F703E5C6E3C703E3C7374726F6E';
wwv_flow_imp.g_varchar2_table(47868) := '673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6365696C696E67286E3A206E756D6265722C207363616C653A206E756D626572';
wwv_flow_imp.g_varchar2_table(47869) := '293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6365696C696E67';
wwv_flow_imp.g_varchar2_table(47870) := '282D312E35362C2031295C6E2F2F202D312E355C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22726F756E64207570286E2C207363616C6529222C6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076';
wwv_flow_imp.g_varchar2_table(47871) := '616C756520776974682074686520726F756E64696E67206D6F646520726F756E642D75702061742074686520676976656E207363616C652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E';
wwv_flow_imp.g_varchar2_table(47872) := '3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E726F756E64207570286E3A206E756D6265722C207363616C653A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C70';
wwv_flow_imp.g_varchar2_table(47873) := '3E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E726F756E6420757028352E35295C6E2F2F20365C6E5C6E726F756E64207570282D352E';
wwv_flow_imp.g_varchar2_table(47874) := '35295C6E2F2F202D365C6E5C6E726F756E6420757028312E3132312C2032295C6E2F2F20312E31335C6E5C6E726F756E64207570282D312E3132362C2032295C6E2F2F202D312E31335C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(47875) := '726F756E6420646F776E286E2C207363616C6529222C6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C756520776974682074686520726F756E64696E67206D6F646520726F756E642D646F776E206174207468';
wwv_flow_imp.g_varchar2_table(47876) := '6520676976656E207363616C652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E726F75';
wwv_flow_imp.g_varchar2_table(47877) := '6E6420646F776E286E3A206E756D6265722C207363616C653A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F';
wwv_flow_imp.g_varchar2_table(47878) := '646520636C6173733D226C616E67756167652D6665656C223E726F756E6420646F776E28352E352C2030295C6E2F2F20355C6E5C6E726F756E6420646F776E20282D352E352C2030295C6E2F2F202D355C6E5C6E726F756E6420646F776E2028312E3132';
wwv_flow_imp.g_varchar2_table(47879) := '312C2032295C6E2F2F20312E31325C6E5C6E726F756E6420646F776E20282D312E3132362C2032295C6E2F2F202D312E31325C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22726F756E642068616C66207570286E2C207363616C6529';
wwv_flow_imp.g_varchar2_table(47880) := '222C6465736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C756520776974682074686520726F756E64696E67206D6F646520726F756E642D68616C662D75702061742074686520676976656E207363616C652E3C2F70';
wwv_flow_imp.g_varchar2_table(47881) := '3E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E726F756E642068616C66207570286E3A206E756D';
wwv_flow_imp.g_varchar2_table(47882) := '6265722C207363616C653A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67';
wwv_flow_imp.g_varchar2_table(47883) := '756167652D6665656C223E726F756E642068616C6620757028352E352C2030295C6E2F2F20365C6E5C6E726F756E642068616C66207570282D352E352C2030295C6E2F2F202D365C6E5C6E726F756E642068616C6620757028312E3132312C2032295C6E';
wwv_flow_imp.g_varchar2_table(47884) := '2F2F20312E31325C6E5C6E726F756E642068616C66207570282D312E3132362C2032295C6E2F2F202D312E31335C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22726F756E642068616C6620646F776E286E2C207363616C6529222C64';
wwv_flow_imp.g_varchar2_table(47885) := '65736372697074696F6E3A273C703E526F756E64732074686520676976656E2076616C756520776974682074686520726F756E64696E67206D6F646520726F756E642D68616C662D646F776E2061742074686520676976656E207363616C652E3C2F703E';
wwv_flow_imp.g_varchar2_table(47886) := '5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E726F756E642068616C6620646F776E286E3A206E75';
wwv_flow_imp.g_varchar2_table(47887) := '6D6265722C207363616C653A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E';
wwv_flow_imp.g_varchar2_table(47888) := '67756167652D6665656C223E726F756E642068616C6620646F776E2028352E352C2030295C6E2F2F20355C6E5C6E726F756E642068616C6620646F776E20282D352E352C2030295C6E2F2F202D355C6E5C6E726F756E642068616C6620646F776E202831';
wwv_flow_imp.g_varchar2_table(47889) := '2E3132312C2032295C6E2F2F20312E31325C6E5C6E726F756E642068616C6620646F776E20282D312E3132362C2032295C6E2F2F202D312E31335C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22616273286E756D62657229222C6465';
wwv_flow_imp.g_varchar2_table(47890) := '736372697074696F6E3A273C703E52657475726E7320746865206162736F6C7574652076616C7565206F662074686520676976656E206E756D657269632076616C75652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E6174';
wwv_flow_imp.g_varchar2_table(47891) := '7572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616273286E756D6265723A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C73';
wwv_flow_imp.g_varchar2_table(47892) := '74726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616273283130295C6E2F2F2031305C6E5C6E616273282D3130295C6E2F2F2031305C6E3C2F63';
wwv_flow_imp.g_varchar2_table(47893) := '6F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D6F64756C6F286469766964656E642C2064697669736F7229222C6465736372697074696F6E3A273C703E52657475726E73207468652072656D61696E646572206F662074686520646976697369';
wwv_flow_imp.g_varchar2_table(47894) := '6F6E206F66206469766964656E642062792064697669736F722E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E677561';
wwv_flow_imp.g_varchar2_table(47895) := '67652D6665656C223E6D6F64756C6F286469766964656E643A206E756D6265722C2064697669736F723A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F';
wwv_flow_imp.g_varchar2_table(47896) := '6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6F64756C6F2831322C2035295C6E2F2F20325C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2273717274286E756D62657229';
wwv_flow_imp.g_varchar2_table(47897) := '222C6465736372697074696F6E3A273C703E52657475726E73207468652073717561726520726F6F74206F662074686520676976656E2076616C75652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374';
wwv_flow_imp.g_varchar2_table(47898) := '726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73717274286E756D6265723A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E';
wwv_flow_imp.g_varchar2_table(47899) := '4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73717274283136295C6E2F2F20345C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226C6F67';
wwv_flow_imp.g_varchar2_table(47900) := '286E756D62657229222C6465736372697074696F6E3A273C703E52657475726E7320746865206E61747572616C206C6F6761726974686D202862617365206529206F662074686520676976656E2076616C75652E3C2F703E5C6E3C703E3C7374726F6E67';
wwv_flow_imp.g_varchar2_table(47901) := '3E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C6F67286E756D6265723A206E756D626572293A206E756D6265725C6E3C2F636F';
wwv_flow_imp.g_varchar2_table(47902) := '64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C6F67283130295C6E2F2F20322E3330323538353039';
wwv_flow_imp.g_varchar2_table(47903) := '323939343034365C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22657870286E756D62657229222C6465736372697074696F6E3A273C703E52657475726E73207468652045756C6572E2809973206E756D626572206520726169736564';
wwv_flow_imp.g_varchar2_table(47904) := '20746F2074686520706F776572206F662074686520676976656E206E756D626572202E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173';
wwv_flow_imp.g_varchar2_table(47905) := '733D226C616E67756167652D6665656C223E657870286E756D6265723A206E756D626572293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C707265';
wwv_flow_imp.g_varchar2_table(47906) := '3E3C636F646520636C6173733D226C616E67756167652D6665656C223E6578702835295C6E2F2F203134382E343133313539313032353736365C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226F6464286E756D62657229222C646573';
wwv_flow_imp.g_varchar2_table(47907) := '6372697074696F6E3A273C703E52657475726E73203C636F64653E747275653C2F636F64653E2069662074686520676976656E2076616C7565206973206F64642E204F74686572776973652C2072657475726E73203C636F64653E66616C73653C2F636F';
wwv_flow_imp.g_varchar2_table(47908) := '64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6F6464286E756D6265723A206E';
wwv_flow_imp.g_varchar2_table(47909) := '756D626572293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6F';
wwv_flow_imp.g_varchar2_table(47910) := '64642835295C6E2F2F20747275655C6E5C6E6F64642832295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226576656E286E756D62657229222C6465736372697074696F6E3A273C703E52657475726E73203C';
wwv_flow_imp.g_varchar2_table(47911) := '636F64653E747275653C2F636F64653E2069662074686520676976656E206973206576656E2E204F74686572776973652C2072657475726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E637469';
wwv_flow_imp.g_varchar2_table(47912) := '6F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6576656E286E756D6265723A206E756D626572293A20626F6F6C65616E5C6E3C2F636F64653E3C2F';
wwv_flow_imp.g_varchar2_table(47913) := '7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6576656E2835295C6E2F2F2066616C73655C6E5C6E6576656E2832';
wwv_flow_imp.g_varchar2_table(47914) := '295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2272616E646F6D206E756D6265722829222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E';
wwv_flow_imp.g_varchar2_table(47915) := '5C6E3C703E52657475726E7320612072616E646F6D206E756D626572206265747765656E203C636F64653E303C2F636F64653E20616E64203C636F64653E313C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E20736967';
wwv_flow_imp.g_varchar2_table(47916) := '6E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E72616E646F6D206E756D62657228293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374';
wwv_flow_imp.g_varchar2_table(47917) := '726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E72616E646F6D206E756D62657228295C6E2F2F20302E393730313631383133323537393739355C';
wwv_flow_imp.g_varchar2_table(47918) := '6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226265666F726528706F696E74312C20706F696E743229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E67';
wwv_flow_imp.g_varchar2_table(47919) := '3E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F726528706F696E74313A20416E792C20706F696E74323A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C70';
wwv_flow_imp.g_varchar2_table(47920) := '3E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F726528312C203130295C6E2F2F20747275655C6E5C6E6265666F7265283130';
wwv_flow_imp.g_varchar2_table(47921) := '2C2031295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226265666F72652872616E67652C20706F696E7429222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E';
wwv_flow_imp.g_varchar2_table(47922) := '61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F72652872616E67653A2072616E67652C20706F696E743A20416E79293A20626F6F6C65616E5C6E3C2F636F';
wwv_flow_imp.g_varchar2_table(47923) := '64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F7265285B312E2E355D2C203130295C6E2F2F';
wwv_flow_imp.g_varchar2_table(47924) := '20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226265666F726528706F696E742C2072616E676529222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374';
wwv_flow_imp.g_varchar2_table(47925) := '726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F726528706F696E743A20416E792C2072616E67653A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E';
wwv_flow_imp.g_varchar2_table(47926) := '5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F726528312C205B322E2E355D295C6E2F2F20747275655C6E3C2F63';
wwv_flow_imp.g_varchar2_table(47927) := '6F64653E3C2F7072653E5C6E277D2C7B6E616D653A226265666F72652872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F70';
wwv_flow_imp.g_varchar2_table(47928) := '3E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F72652872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C70';
wwv_flow_imp.g_varchar2_table(47929) := '3E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6265666F7265285B312E2E355D2C205B362E2E31305D295C6E2F2F20747275655C6E5C';
wwv_flow_imp.g_varchar2_table(47930) := '6E6265666F7265285B312E2E35292C5B352E2E31305D295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22616674657228706F696E74312C20706F696E743229222C6465736372697074696F6E3A273C703E3C73';
wwv_flow_imp.g_varchar2_table(47931) := '74726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616674657228706F696E74313A20416E792C20706F696E74323A2041';
wwv_flow_imp.g_varchar2_table(47932) := '6E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E61667465';
wwv_flow_imp.g_varchar2_table(47933) := '722831302C2031295C6E2F2F20747275655C6E5C6E616674657228312C203130295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2261667465722872616E67652C20706F696E7429222C646573637269707469';
wwv_flow_imp.g_varchar2_table(47934) := '6F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E61667465722872616E67653A2072616E67652C';
wwv_flow_imp.g_varchar2_table(47935) := '20706F696E743A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D66';
wwv_flow_imp.g_varchar2_table(47936) := '65656C223E6166746572285B312E2E355D2C203130295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22616674657228706F696E742C2072616E676529222C6465736372697074696F6E3A273C703E3C737472';
wwv_flow_imp.g_varchar2_table(47937) := '6F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616674657228706F696E743A20416E792C2072616E67653A2072616E6765';
wwv_flow_imp.g_varchar2_table(47938) := '293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616674657228';
wwv_flow_imp.g_varchar2_table(47939) := '31322C205B322E2E355D295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2261667465722872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E637469';
wwv_flow_imp.g_varchar2_table(47940) := '6F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E61667465722872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F';
wwv_flow_imp.g_varchar2_table(47941) := '6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6166746572285B362E2E3130';
wwv_flow_imp.g_varchar2_table(47942) := '5D2C205B312E2E355D295C6E2F2F20747275655C6E5C6E6166746572285B352E2E31305D2C205B312E2E3529295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D656574732872616E6765312C2072616E6765';
wwv_flow_imp.g_varchar2_table(47943) := '3229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6565747328';
wwv_flow_imp.g_varchar2_table(47944) := '72616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520';
wwv_flow_imp.g_varchar2_table(47945) := '636C6173733D226C616E67756167652D6665656C223E6D65657473285B312E2E355D2C205B352E2E31305D295C6E2F2F20747275655C6E5C6E6D65657473285B312E2E335D2C205B342E2E365D295C6E2F2F2066616C73655C6E5C6E6D65657473285B31';
wwv_flow_imp.g_varchar2_table(47946) := '2E2E335D2C205B332E2E355D295C6E2F2F20747275655C6E5C6E6D65657473285B312E2E355D2C2028352E2E385D295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D65742062792872616E6765312C2072';
wwv_flow_imp.g_varchar2_table(47947) := '616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D65';
wwv_flow_imp.g_varchar2_table(47948) := '742062792872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C';
wwv_flow_imp.g_varchar2_table(47949) := '636F646520636C6173733D226C616E67756167652D6665656C223E6D6574206279285B352E2E31305D2C205B312E2E355D295C6E2F2F20747275655C6E5C6E6D6574206279285B332E2E345D2C205B312E2E325D295C6E2F2F2066616C73655C6E5C6E6D';
wwv_flow_imp.g_varchar2_table(47950) := '6574206279285B332E2E355D2C205B312E2E335D295C6E2F2F20747275655C6E5C6E6D65742062792828352E2E385D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E6D6574206279285B352E2E31305D2C205B312E2E3529295C6E2F2F206661';
wwv_flow_imp.g_varchar2_table(47951) := '6C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226F7665726C6170732872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F';
wwv_flow_imp.g_varchar2_table(47952) := '7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6F7665726C6170732872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64';
wwv_flow_imp.g_varchar2_table(47953) := '653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6F7665726C617073285B352E2E31305D2C205B312E2E36';
wwv_flow_imp.g_varchar2_table(47954) := '5D295C6E2F2F20747275655C6E5C6E6F7665726C6170732828332E2E375D2C205B312E2E345D295C6E2F2F20747275655C6E5C6E6F7665726C617073285B312E2E335D2C2028332E2E365D295C6E2F2F2066616C73655C6E5C6E6F7665726C6170732828';
wwv_flow_imp.g_varchar2_table(47955) := '352E2E385D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E6F7665726C617073285B342E2E31305D2C205B312E2E3529295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226F7665726C617073206265';
wwv_flow_imp.g_varchar2_table(47956) := '666F72652872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E';
wwv_flow_imp.g_varchar2_table(47957) := '67756167652D6665656C223E6F7665726C617073206265666F72652872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C';
wwv_flow_imp.g_varchar2_table(47958) := '65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6F7665726C617073206265666F7265285B312E2E355D2C205B342E2E31305D295C6E2F2F20747275655C6E5C6E6F7665726C';
wwv_flow_imp.g_varchar2_table(47959) := '617073206265666F7265285B332E2E345D2C205B312E2E325D295C6E2F2F2066616C73655C6E5C6E6F7665726C617073206265666F7265285B312E2E335D2C2028332E2E355D295C6E2F2F2066616C73655C6E5C6E6F7665726C617073206265666F7265';
wwv_flow_imp.g_varchar2_table(47960) := '285B312E2E35292C2028332E2E385D295C6E2F2F20747275655C6E5C6E6F7665726C617073206265666F7265285B312E2E35292C205B352E2E31305D295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226F76';
wwv_flow_imp.g_varchar2_table(47961) := '65726C6170732061667465722872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C';
wwv_flow_imp.g_varchar2_table(47962) := '6173733D226C616E67756167652D6665656C223E6F7665726C6170732061667465722872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E67';
wwv_flow_imp.g_varchar2_table(47963) := '3E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6F7665726C617073206166746572285B342E2E31305D2C205B312E2E355D295C6E2F2F20747275655C6E5C';
wwv_flow_imp.g_varchar2_table(47964) := '6E6F7665726C617073206166746572285B332E2E345D2C205B312E2E325D295C6E2F2F2066616C73655C6E5C6E6F7665726C617073206166746572285B332E2E355D2C205B312E2E3329295C6E2F2F2066616C73655C6E5C6E6F7665726C617073206166';
wwv_flow_imp.g_varchar2_table(47965) := '7465722828352E2E385D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E6F7665726C617073206166746572285B342E2E31305D2C205B312E2E3529295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(47966) := '66696E697368657328706F696E742C2072616E676529222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C';
wwv_flow_imp.g_varchar2_table(47967) := '616E67756167652D6665656C223E66696E697368657328706F696E743A20416E792C2072616E67653A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E';
wwv_flow_imp.g_varchar2_table(47968) := '673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E66696E697368657328352C205B312E2E355D295C6E2F2F20747275655C6E5C6E66696E69736865732831302C205B312E2E375D295C6E2F2F206661';
wwv_flow_imp.g_varchar2_table(47969) := '6C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2266696E69736865732872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F';
wwv_flow_imp.g_varchar2_table(47970) := '7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E66696E69736865732872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64';
wwv_flow_imp.g_varchar2_table(47971) := '653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E66696E6973686573285B332E2E355D2C205B312E2E355D';
wwv_flow_imp.g_varchar2_table(47972) := '295C6E2F2F20747275655C6E5C6E66696E69736865732828312E2E355D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E66696E6973686573285B352E2E31305D2C205B312E2E313029295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F70';
wwv_flow_imp.g_varchar2_table(47973) := '72653E5C6E277D2C7B6E616D653A2266696E69736865642062792872616E67652C20706F696E7429222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C';
wwv_flow_imp.g_varchar2_table(47974) := '7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E66696E69736865642062792872616E67653A2072616E67652C20706F696E743A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C73';
wwv_flow_imp.g_varchar2_table(47975) := '74726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E66696E6973686564206279285B352E2E31305D2C203130295C6E2F2F20747275655C6E5C6E66';
wwv_flow_imp.g_varchar2_table(47976) := '696E6973686564206279285B332E2E345D2C2032295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2266696E69736865642062792872616E6765312C2072616E67653229222C6465736372697074696F6E3A27';
wwv_flow_imp.g_varchar2_table(47977) := '3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E66696E69736865642062792872616E6765313A2072616E';
wwv_flow_imp.g_varchar2_table(47978) := '67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67';
wwv_flow_imp.g_varchar2_table(47979) := '756167652D6665656C223E66696E6973686564206279285B312E2E355D2C205B332E2E355D295C6E2F2F20747275655C6E5C6E66696E69736865642062792828352E2E385D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E66696E6973686564';
wwv_flow_imp.g_varchar2_table(47980) := '206279285B352E2E31305D2C2028312E2E313029295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22696E636C756465732872616E67652C20706F696E7429222C6465736372697074696F6E3A273C703E3C73';
wwv_flow_imp.g_varchar2_table(47981) := '74726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E696E636C756465732872616E67653A2072616E67652C20706F696E74';
wwv_flow_imp.g_varchar2_table(47982) := '3A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E69';
wwv_flow_imp.g_varchar2_table(47983) := '6E636C75646573285B352E2E31305D2C2036295C6E2F2F20747275655C6E5C6E696E636C75646573285B332E2E345D2C2035295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22696E636C756465732872616E';
wwv_flow_imp.g_varchar2_table(47984) := '6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665';
wwv_flow_imp.g_varchar2_table(47985) := '656C223E696E636C756465732872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E';
wwv_flow_imp.g_varchar2_table(47986) := '5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E696E636C75646573285B312E2E31305D2C205B342E2E365D295C6E2F2F20747275655C6E5C6E696E636C756465732828352E2E385D2C205B312E2E3529295C6E2F';
wwv_flow_imp.g_varchar2_table(47987) := '2F2066616C73655C6E5C6E696E636C75646573285B312E2E31305D2C205B312E2E3529295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22647572696E6728706F696E742C2072616E676529222C646573637269';
wwv_flow_imp.g_varchar2_table(47988) := '7074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E647572696E6728706F696E743A20416E';
wwv_flow_imp.g_varchar2_table(47989) := '792C2072616E67653A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E677561';
wwv_flow_imp.g_varchar2_table(47990) := '67652D6665656C223E647572696E6728352C205B312E2E31305D295C6E2F2F20747275655C6E5C6E647572696E672831322C205B312E2E31305D295C6E2F2F2066616C73655C6E5C6E647572696E6728312C2028312E2E31305D295C6E2F2F2066616C73';
wwv_flow_imp.g_varchar2_table(47991) := '655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22647572696E672872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F';
wwv_flow_imp.g_varchar2_table(47992) := '6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E647572696E672872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072';
wwv_flow_imp.g_varchar2_table(47993) := '653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E647572696E67285B342E2E365D2C205B312E2E313029295C6E2F2F2074';
wwv_flow_imp.g_varchar2_table(47994) := '7275655C6E5C6E647572696E672828312E2E355D2C2028312E2E31305D295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2273746172747328706F696E742C2072616E676529222C6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(47995) := '273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73746172747328706F696E743A20416E792C2072616E';
wwv_flow_imp.g_varchar2_table(47996) := '67653A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D666565';
wwv_flow_imp.g_varchar2_table(47997) := '6C223E73746172747328312C205B312E2E355D295C6E2F2F20747275655C6E5C6E73746172747328312C2028312E2E385D295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A227374617274732872616E676531';
wwv_flow_imp.g_varchar2_table(47998) := '2C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C22';
wwv_flow_imp.g_varchar2_table(47999) := '3E7374617274732872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072';
wwv_flow_imp.g_varchar2_table(48000) := '653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7374617274732828312E2E355D2C205B312E2E355D295C6E2F2F2066616C73655C6E5C6E737461727473285B312E2E31305D2C205B312E2E355D295C6E2F2F2066616C73655C';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(48001) := '6E5C6E7374617274732828312E2E35292C2028312E2E313029295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737461727465642062792872616E67652C20706F696E7429222C6465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(48002) := '273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737461727465642062792872616E67653A2072616E67';
wwv_flow_imp.g_varchar2_table(48003) := '652C20706F696E743A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E6775616765';
wwv_flow_imp.g_varchar2_table(48004) := '2D6665656C223E73746172746564206279285B312E2E31305D2C2031295C6E2F2F20747275655C6E5C6E737461727465642062792828312E2E31305D2C2031295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(48005) := '22737461727465642062792872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C61';
wwv_flow_imp.g_varchar2_table(48006) := '73733D226C616E67756167652D6665656C223E737461727465642062792872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D';
wwv_flow_imp.g_varchar2_table(48007) := '706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73746172746564206279285B312E2E31305D2C205B312E2E355D295C6E2F2F20747275655C6E5C6E7374617274656420';
wwv_flow_imp.g_varchar2_table(48008) := '62792828312E2E31305D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E73746172746564206279285B312E2E31305D2C205B312E2E313029295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22636F69';
wwv_flow_imp.g_varchar2_table(48009) := '6E636964657328706F696E74312C20706F696E743229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C';
wwv_flow_imp.g_varchar2_table(48010) := '616E67756167652D6665656C223E636F696E636964657328706F696E74313A20416E792C20706F696E74323A20416E79293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F';
wwv_flow_imp.g_varchar2_table(48011) := '6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F696E636964657328352C2035295C6E2F2F20747275655C6E5C6E636F696E636964657328332C2034295C6E2F2F2066616C73655C6E3C2F63';
wwv_flow_imp.g_varchar2_table(48012) := '6F64653E3C2F7072653E5C6E277D2C7B6E616D653A22636F696E63696465732872616E6765312C2072616E67653229222C6465736372697074696F6E3A273C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E';
wwv_flow_imp.g_varchar2_table(48013) := '3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F696E63696465732872616E6765313A2072616E67652C2072616E6765323A2072616E6765293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072';
wwv_flow_imp.g_varchar2_table(48014) := '653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F696E6369646573285B312E2E355D2C205B312E2E355D295C6E2F2F';
wwv_flow_imp.g_varchar2_table(48015) := '20747275655C6E5C6E636F696E63696465732828312E2E355D2C205B312E2E3529295C6E2F2F2066616C73655C6E5C6E636F696E6369646573285B312E2E355D2C205B322E2E365D295C6E2F2F2066616C73655C6E3C2F636F64653E3C2F7072653E5C6E';
wwv_flow_imp.g_varchar2_table(48016) := '277D2C7B6E616D653A22737562737472696E6728737472696E672C20737461727420706F736974696F6E29222C6465736372697074696F6E3A273C703E52657475726E73206120737562737472696E67206F662074686520676976656E2076616C756520';
wwv_flow_imp.g_varchar2_table(48017) := '7374617274696E67206174203C636F64653E737461727420706F736974696F6E3C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F6465';
wwv_flow_imp.g_varchar2_table(48018) := '20636C6173733D226C616E67756167652D6665656C223E737562737472696E6728737472696E673A20737472696E672C20737461727420706F736974696F6E3A206E756D626572293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E';
wwv_flow_imp.g_varchar2_table(48019) := '546865203C636F64653E737461727420706F736974696F6E3C2F636F64653E207374617274732061742074686520696E646578203C636F64653E313C2F636F64653E2E20546865206C61737420706F736974696F6E206973203C636F64653E2D313C2F63';
wwv_flow_imp.g_varchar2_table(48020) := '6F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737562737472696E67282671756F743B666F6F626172';
wwv_flow_imp.g_varchar2_table(48021) := '2671756F743B2C2033295C6E2F2F202671756F743B6F6261722671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737562737472696E6728737472696E672C20737461727420706F736974696F6E2C206C656E6774682922';
wwv_flow_imp.g_varchar2_table(48022) := '2C6465736372697074696F6E3A273C703E52657475726E73206120737562737472696E67206F662074686520676976656E2076616C7565207374617274696E67206174203C636F64653E737461727420706F736974696F6E3C2F636F64653E2E3C2F703E';
wwv_flow_imp.g_varchar2_table(48023) := '5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737562737472696E6728737472696E673A20737472';
wwv_flow_imp.g_varchar2_table(48024) := '696E672C20737461727420706F736974696F6E3A206E756D6265722C206C656E6774683A206E756D626572293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E737461727420706F736974696F6E3C2F636F';
wwv_flow_imp.g_varchar2_table(48025) := '64653E207374617274732061742074686520696E646578203C636F64653E313C2F636F64653E2E20546865206C61737420706F736974696F6E206973203C636F64653E2D313C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C';
wwv_flow_imp.g_varchar2_table(48026) := '65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737562737472696E67282671756F743B666F6F6261722671756F743B2C20332C2033295C6E2F2F202671756F743B6F626126';
wwv_flow_imp.g_varchar2_table(48027) := '71756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737472696E67206C656E67746828737472696E6729222C6465736372697074696F6E3A273C703E52657475726E7320746865206E756D626572206F662063686172616374';
wwv_flow_imp.g_varchar2_table(48028) := '65727320696E2074686520676976656E2076616C75652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D';
wwv_flow_imp.g_varchar2_table(48029) := '6665656C223E737472696E67206C656E67746828737472696E673A20737472696E67293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C';
wwv_flow_imp.g_varchar2_table(48030) := '636F646520636C6173733D226C616E67756167652D6665656C223E737472696E67206C656E677468282671756F743B666F6F2671756F743B295C6E2F2F20335C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A2275707065722063617365';
wwv_flow_imp.g_varchar2_table(48031) := '28737472696E6729222C6465736372697074696F6E3A273C703E52657475726E732074686520676976656E2076616C7565207769746820616C6C206368617261637465727320617265207570706572636173652E3C2F703E5C6E3C703E3C7374726F6E67';
wwv_flow_imp.g_varchar2_table(48032) := '3E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7570706572206361736528737472696E673A20737472696E67293A20737472696E';
wwv_flow_imp.g_varchar2_table(48033) := '675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E75707065722063617365282671756F';
wwv_flow_imp.g_varchar2_table(48034) := '743B614263342671756F743B295C6E2F2F202671756F743B414243342671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226C6F776572206361736528737472696E6729222C6465736372697074696F6E3A273C703E526574';
wwv_flow_imp.g_varchar2_table(48035) := '75726E732074686520676976656E2076616C7565207769746820616C6C206368617261637465727320617265206C6F776572636173652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C';
wwv_flow_imp.g_varchar2_table(48036) := '2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C6F776572206361736528737472696E673A20737472696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E';
wwv_flow_imp.g_varchar2_table(48037) := '4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C6F7765722063617365282671756F743B614263342671756F743B295C6E2F2F202671756F743B6162633426';
wwv_flow_imp.g_varchar2_table(48038) := '71756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737562737472696E67206265666F726528737472696E672C206D6174636829222C6465736372697074696F6E3A273C703E52657475726E73206120737562737472696E67';
wwv_flow_imp.g_varchar2_table(48039) := '206F662074686520676976656E2076616C7565207468617420636F6E7461696E7320616C6C2063686172616374657273206265666F7265203C636F64653E6D617463683C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E';
wwv_flow_imp.g_varchar2_table(48040) := '207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737562737472696E67206265666F726528737472696E673A20737472696E672C206D617463683A207374';
wwv_flow_imp.g_varchar2_table(48041) := '72696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737562';
wwv_flow_imp.g_varchar2_table(48042) := '737472696E67206265666F7265282671756F743B666F6F6261722671756F743B2C202671756F743B6261722671756F743B295C6E2F2F202671756F743B666F6F2671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22737562';
wwv_flow_imp.g_varchar2_table(48043) := '737472696E6720616674657228737472696E672C206D6174636829222C6465736372697074696F6E3A273C703E52657475726E73206120737562737472696E67206F662074686520676976656E2076616C7565207468617420636F6E7461696E7320616C';
wwv_flow_imp.g_varchar2_table(48044) := '6C2063686172616374657273206166746572203C636F64653E6D617463683C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F64652063';
wwv_flow_imp.g_varchar2_table(48045) := '6C6173733D226C616E67756167652D6665656C223E737562737472696E6720616674657228737472696E673A20737472696E672C206D617463683A20737472696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F';
wwv_flow_imp.g_varchar2_table(48046) := '6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737562737472696E67206166746572282671756F743B666F6F6261722671756F743B2C202671756F74';
wwv_flow_imp.g_varchar2_table(48047) := '3B6F622671756F743B295C6E2F2F202671756F743B61722671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22636F6E7461696E7328737472696E672C206D6174636829222C6465736372697074696F6E3A273C703E526574';
wwv_flow_imp.g_varchar2_table(48048) := '75726E73203C636F64653E747275653C2F636F64653E2069662074686520676976656E2076616C756520636F6E7461696E732074686520737562737472696E67203C636F64653E6D617463683C2F636F64653E2E204F74686572776973652C2072657475';
wwv_flow_imp.g_varchar2_table(48049) := '726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D';
wwv_flow_imp.g_varchar2_table(48050) := '6665656C223E636F6E7461696E7328737472696E673A20737472696E672C206D617463683A20737472696E67293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C';
wwv_flow_imp.g_varchar2_table(48051) := '2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E636F6E7461696E73282671756F743B666F6F6261722671756F743B2C202671756F743B6F662671756F743B295C6E2F2F2066616C73655C6E3C2F636F6465';
wwv_flow_imp.g_varchar2_table(48052) := '3E3C2F7072653E5C6E277D2C7B6E616D653A22737461727473207769746828737472696E672C206D6174636829222C6465736372697074696F6E3A273C703E52657475726E73203C636F64653E747275653C2F636F64653E206966207468652067697665';
wwv_flow_imp.g_varchar2_table(48053) := '6E2076616C75652073746172747320776974682074686520737562737472696E67203C636F64653E6D617463683C2F636F64653E2E204F74686572776973652C2072657475726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C70';
wwv_flow_imp.g_varchar2_table(48054) := '3E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E737461727473207769746828737472696E673A20737472696E';
wwv_flow_imp.g_varchar2_table(48055) := '672C206D617463683A20737472696E67293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E6775';
wwv_flow_imp.g_varchar2_table(48056) := '6167652D6665656C223E7374617274732077697468282671756F743B666F6F6261722671756F743B2C202671756F743B666F2671756F743B295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22656E6473207769';
wwv_flow_imp.g_varchar2_table(48057) := '746828737472696E672C206D6174636829222C6465736372697074696F6E3A273C703E52657475726E73203C636F64653E747275653C2F636F64653E2069662074686520676976656E2076616C756520656E647320776974682074686520737562737472';
wwv_flow_imp.g_varchar2_table(48058) := '696E67203C636F64653E6D617463683C2F636F64653E2E204F74686572776973652C2072657475726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F73';
wwv_flow_imp.g_varchar2_table(48059) := '74726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E656E6473207769746828737472696E673A20737472696E672C206D617463683A20737472696E67293A20626F6F6C65616E5C6E3C2F636F';
wwv_flow_imp.g_varchar2_table(48060) := '64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E656E64732077697468282671756F743B666F6F626172';
wwv_flow_imp.g_varchar2_table(48061) := '2671756F743B2C202671756F743B722671756F743B295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D61746368657328696E7075742C207061747465726E29222C6465736372697074696F6E3A273C703E52';
wwv_flow_imp.g_varchar2_table(48062) := '657475726E73203C636F64653E747275653C2F636F64653E2069662074686520676976656E2076616C7565206D61746368657320746865203C636F64653E7061747465726E3C2F636F64653E2E204F74686572776973652C2072657475726E73203C636F';
wwv_flow_imp.g_varchar2_table(48063) := '64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D';
wwv_flow_imp.g_varchar2_table(48064) := '61746368657328696E7075743A20737472696E672C207061747465726E3A20737472696E67293A20626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E7061747465726E3C2F636F64653E206973206120737472';
wwv_flow_imp.g_varchar2_table(48065) := '696E67207468617420636F6E7461696E73206120726567756C61722065787072657373696F6E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E';
wwv_flow_imp.g_varchar2_table(48066) := '67756167652D6665656C223E6D617463686573282671756F743B666F6F6261722671756F743B2C202671756F743B5E666F2A6261722671756F743B295C6E2F2F20747275655C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226D617463';
wwv_flow_imp.g_varchar2_table(48067) := '68657328696E7075742C207061747465726E2C20666C61677329222C6465736372697074696F6E3A273C703E52657475726E73203C636F64653E747275653C2F636F64653E2069662074686520676976656E2076616C7565206D61746368657320746865';
wwv_flow_imp.g_varchar2_table(48068) := '203C636F64653E7061747465726E3C2F636F64653E2E204F74686572776973652C2072657475726E73203C636F64653E66616C73653C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374';
wwv_flow_imp.g_varchar2_table(48069) := '726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D61746368657328696E7075743A20737472696E672C207061747465726E3A20737472696E672C20666C6167733A20737472696E67293A20';
wwv_flow_imp.g_varchar2_table(48070) := '626F6F6C65616E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E7061747465726E3C2F636F64653E206973206120737472696E67207468617420636F6E7461696E73206120726567756C61722065787072657373696F6E2E3C';
wwv_flow_imp.g_varchar2_table(48071) := '2F703E5C6E3C703E546865203C636F64653E666C6167733C2F636F64653E2063616E20636F6E7461696E206F6E65206F72206D6F7265206F662074686520666F6C6C6F77696E6720636861726163746572733A3C2F703E5C6E3C756C3E5C6E3C6C693E3C';
wwv_flow_imp.g_varchar2_table(48072) := '636F64653E733C2F636F64653E2028646F742D616C6C293C2F6C693E5C6E3C6C693E3C636F64653E6D3C2F636F64653E20286D756C74692D6C696E65293C2F6C693E5C6E3C6C693E3C636F64653E693C2F636F64653E20286361736520696E73656E7369';
wwv_flow_imp.g_varchar2_table(48073) := '74697665293C2F6C693E5C6E3C6C693E3C636F64653E783C2F636F64653E2028636F6D6D656E7473293C2F6C693E5C6E3C2F756C3E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520';
wwv_flow_imp.g_varchar2_table(48074) := '636C6173733D226C616E67756167652D6665656C223E6D617463686573282671756F743B466F6F4261722671756F743B2C202671756F743B666F6F2671756F743B2C202671756F743B692671756F743B295C6E2F2F20747275655C6E3C2F636F64653E3C';
wwv_flow_imp.g_varchar2_table(48075) := '2F7072653E5C6E277D2C7B6E616D653A227265706C61636528696E7075742C207061747465726E2C207265706C6163656D656E7429222C6465736372697074696F6E3A273C703E52657475726E732074686520726573756C74696E6720737472696E6720';
wwv_flow_imp.g_varchar2_table(48076) := '6166746572207265706C6163696E6720616C6C206F6363757272656E636573206F66203C636F64653E7061747465726E3C2F636F64653E2077697468203C636F64653E7265706C6163656D656E743C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F';
wwv_flow_imp.g_varchar2_table(48077) := '6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7265706C61636528696E7075743A20737472696E672C207061747465726E3A';
wwv_flow_imp.g_varchar2_table(48078) := '20737472696E672C207265706C6163656D656E743A20737472696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E7061747465726E3C2F636F64653E206973206120737472696E6720746861742063';
wwv_flow_imp.g_varchar2_table(48079) := '6F6E7461696E73206120726567756C61722065787072657373696F6E2E3C2F703E5C6E3C703E546865203C636F64653E7265706C6163656D656E743C2F636F64653E2063616E2061636365737320746865206D617463682067726F757073206279207573';
wwv_flow_imp.g_varchar2_table(48080) := '696E67203C636F64653E243C2F636F64653E20616E6420746865206E756D626572206F66207468652067726F75702C20666F72206578616D706C652C5C6E3C636F64653E24313C2F636F64653E20746F2061636365737320746865206669727374206772';
wwv_flow_imp.g_varchar2_table(48081) := '6F75702E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7265706C616365282671756F743B616263642671756F74';
wwv_flow_imp.g_varchar2_table(48082) := '3B2C202671756F743B286162297C2861292671756F743B2C202671756F743B5B313D24315D5B323D24325D2671756F743B295C6E2F2F202671756F743B5B313D61625D5B323D5D63642671756F743B5C6E5C6E7265706C616365282671756F743B303132';
wwv_flow_imp.g_varchar2_table(48083) := '333435363738392671756F743B2C202671756F743B285C5C647B337D29285C5C647B337D29285C5C647B347D292671756F743B2C202671756F743B282431292024322D24332671756F743B295C6E2F2F202671756F743B2830313229203334352D363738';
wwv_flow_imp.g_varchar2_table(48084) := '392671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A227265706C61636528696E7075742C207061747465726E2C207265706C6163656D656E742C20666C61677329222C6465736372697074696F6E3A273C703E5265747572';
wwv_flow_imp.g_varchar2_table(48085) := '6E732074686520726573756C74696E6720737472696E67206166746572207265706C6163696E6720616C6C206F6363757272656E636573206F66203C636F64653E7061747465726E3C2F636F64653E2077697468203C636F64653E7265706C6163656D65';
wwv_flow_imp.g_varchar2_table(48086) := '6E743C2F636F64653E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7265706C616365';
wwv_flow_imp.g_varchar2_table(48087) := '28696E7075743A20737472696E672C207061747465726E3A20737472696E672C207265706C6163656D656E743A20737472696E672C20666C6167733A20737472696E67293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E54686520';
wwv_flow_imp.g_varchar2_table(48088) := '3C636F64653E7061747465726E3C2F636F64653E206973206120737472696E67207468617420636F6E7461696E73206120726567756C61722065787072657373696F6E2E3C2F703E5C6E3C703E546865203C636F64653E7265706C6163656D656E743C2F';
wwv_flow_imp.g_varchar2_table(48089) := '636F64653E2063616E2061636365737320746865206D617463682067726F757073206279207573696E67203C636F64653E243C2F636F64653E20616E6420746865206E756D626572206F66207468652067726F75702C20666F72206578616D706C652C5C';
wwv_flow_imp.g_varchar2_table(48090) := '6E3C636F64653E24313C2F636F64653E20746F20616363657373207468652066697273742067726F75702E3C2F703E5C6E3C703E546865203C636F64653E666C6167733C2F636F64653E2063616E20636F6E7461696E206F6E65206F72206D6F7265206F';
wwv_flow_imp.g_varchar2_table(48091) := '662074686520666F6C6C6F77696E6720636861726163746572733A3C2F703E5C6E3C756C3E5C6E3C6C693E3C636F64653E733C2F636F64653E2028646F742D616C6C293C2F6C693E5C6E3C6C693E3C636F64653E6D3C2F636F64653E20286D756C74692D';
wwv_flow_imp.g_varchar2_table(48092) := '6C696E65293C2F6C693E5C6E3C6C693E3C636F64653E693C2F636F64653E20286361736520696E73656E736974697665293C2F6C693E5C6E3C6C693E3C636F64653E783C2F636F64653E2028636F6D6D656E7473293C2F6C693E5C6E3C2F756C3E5C6E3C';
wwv_flow_imp.g_varchar2_table(48093) := '703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7265706C616365282671756F743B486F7720646F20796F75206665656C3F2671756F';
wwv_flow_imp.g_varchar2_table(48094) := '743B2C202671756F743B4665656C2671756F743B2C202671756F743B4645454C2671756F743B2C202671756F743B692671756F743B295C6E2F2F202671756F743B486F7720646F20796F75204645454C3F2671756F743B5C6E3C2F636F64653E3C2F7072';
wwv_flow_imp.g_varchar2_table(48095) := '653E5C6E277D2C7B6E616D653A2273706C697428737472696E672C2064656C696D6974657229222C6465736372697074696F6E3A273C703E53706C6974732074686520676976656E2076616C756520696E746F2061206C697374206F6620737562737472';
wwv_flow_imp.g_varchar2_table(48096) := '696E67732C20627265616B696E672061742065616368206F6363757272656E6365206F6620746865203C636F64653E64656C696D697465723C2F636F64653E207061747465726E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369';
wwv_flow_imp.g_varchar2_table(48097) := '676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73706C697428737472696E673A20737472696E672C2064656C696D697465723A20737472696E67293A206C6973';
wwv_flow_imp.g_varchar2_table(48098) := '74266C743B737472696E672667743B5C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E64656C696D697465723C2F636F64653E206973206120737472696E67207468617420636F6E7461696E73206120726567756C6172206578';
wwv_flow_imp.g_varchar2_table(48099) := '7072657373696F6E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E73706C6974282671756F743B4A6F686E2044';
wwv_flow_imp.g_varchar2_table(48100) := '6F652671756F743B2C202671756F743B5C5C732671756F743B20295C6E2F2F205B2671756F743B4A6F686E2671756F743B2C202671756F743B446F652671756F743B5D5C6E5C6E73706C6974282671756F743B613B623B633B3B2671756F743B2C202671';
wwv_flow_imp.g_varchar2_table(48101) := '756F743B3B2671756F743B295C6E2F2F205B2671756F743B612671756F743B2C202671756F743B622671756F743B2C202671756F743B632671756F743B2C202671756F743B2671756F743B2C202671756F743B2671756F743B5D5C6E3C2F636F64653E3C';
wwv_flow_imp.g_varchar2_table(48102) := '2F7072653E5C6E277D2C7B6E616D653A226578747261637428737472696E672C207061747465726E29222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E52657475726E';
wwv_flow_imp.g_varchar2_table(48103) := '7320616C6C206D617463686573206F6620746865207061747465726E20696E2074686520676976656E20737472696E672E2052657475726E7320616E20656D707479206C69737420696620746865207061747465726E20646F65736E262333393B745C6E';
wwv_flow_imp.g_varchar2_table(48104) := '6D617463682E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6578747261637428737472';
wwv_flow_imp.g_varchar2_table(48105) := '696E673A20737472696E672C207061747465726E3A20737472696E67293A206C697374266C743B737472696E672667743B5C6E3C2F636F64653E3C2F7072653E5C6E3C703E546865203C636F64653E7061747465726E3C2F636F64653E20697320612073';
wwv_flow_imp.g_varchar2_table(48106) := '7472696E67207468617420636F6E7461696E73206120726567756C61722065787072657373696F6E2E3C2F703E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C';
wwv_flow_imp.g_varchar2_table(48107) := '616E67756167652D6665656C223E65787472616374282671756F743B7265666572656E6365732061726520313233342C20313235362C20313337382671756F743B2C202671756F743B31325B302D395D2A2671756F743B295C6E2F2F205B2671756F743B';
wwv_flow_imp.g_varchar2_table(48108) := '313233342671756F743B2C2671756F743B313235362671756F743B5D5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A226E6F772829222C6465736372697074696F6E3A273C703E52657475726E73207468652063757272656E74206461';
wwv_flow_imp.g_varchar2_table(48109) := '746520616E642074696D6520696E636C7564696E67207468652074696D657A6F6E652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173';
wwv_flow_imp.g_varchar2_table(48110) := '733D226C616E67756167652D6665656C223E6E6F7728293A206461746520616E642074696D655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520';
wwv_flow_imp.g_varchar2_table(48111) := '636C6173733D226C616E67756167652D6665656C223E6E6F7728295C6E2F2F206461746520616E642074696D65282671756F743B323032302D30372D33315431343A32373A3330404575726F70652F4265726C696E2671756F743B295C6E3C2F636F6465';
wwv_flow_imp.g_varchar2_table(48112) := '3E3C2F7072653E5C6E277D2C7B6E616D653A22746F6461792829222C6465736372697074696F6E3A273C703E52657475726E73207468652063757272656E7420646174652E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61';
wwv_flow_imp.g_varchar2_table(48113) := '747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E746F64617928293A20646174655C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65';
wwv_flow_imp.g_varchar2_table(48114) := '733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E746F64617928295C6E2F2F2064617465282671756F743B323032302D30372D33312671756F743B295C6E3C2F636F64653E3C2F';
wwv_flow_imp.g_varchar2_table(48115) := '7072653E5C6E277D2C7B6E616D653A22646179206F66207765656B286461746529222C6465736372697074696F6E3A273C703E52657475726E732074686520646179206F6620746865207765656B206163636F7264696E6720746F207468652047726567';
wwv_flow_imp.g_varchar2_table(48116) := '6F7269616E2063616C656E6461722E204E6F7465207468617420697420616C776179732072657475726E732074686520456E676C697368206E616D65206F6620746865206461792E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369';
wwv_flow_imp.g_varchar2_table(48117) := '676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646179206F66207765656B28646174653A2064617465293A20737472696E675C6E3C2F636F64653E3C2F707265';
wwv_flow_imp.g_varchar2_table(48118) := '3E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646179206F66207765656B28646174653A206461746520616E642074696D65293A20737472696E675C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C737472';
wwv_flow_imp.g_varchar2_table(48119) := '6F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646179206F66207765656B2864617465282671756F743B323031392D30392D31372671756F743B29';
wwv_flow_imp.g_varchar2_table(48120) := '295C6E2F2F202671756F743B547565736461792671756F743B5C6E5C6E646179206F66207765656B286461746520616E642074696D65282671756F743B323031392D30392D31375431323A30303A30302671756F743B29295C6E2F2F202671756F743B54';
wwv_flow_imp.g_varchar2_table(48121) := '7565736461792671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22646179206F662079656172286461746529222C6465736372697074696F6E3A273C703E52657475726E732074686520477265676F7269616E206E756D62';
wwv_flow_imp.g_varchar2_table(48122) := '6572206F6620746865206461792077697468696E2074686520796561722E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C61';
wwv_flow_imp.g_varchar2_table(48123) := '6E67756167652D6665656C223E646179206F66207965617228646174653A2064617465293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E646179206F66';
wwv_flow_imp.g_varchar2_table(48124) := '207965617228646174653A206461746520616E642074696D65293A206E756D6265725C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173';
wwv_flow_imp.g_varchar2_table(48125) := '733D226C616E67756167652D6665656C223E646179206F6620796561722864617465282671756F743B323031392D30392D31372671756F743B29295C6E2F2F203236305C6E5C6E646179206F662079656172286461746520616E642074696D6528267175';
wwv_flow_imp.g_varchar2_table(48126) := '6F743B323031392D30392D31375431323A30303A30302671756F743B29295C6E2F2F203236305C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A227765656B206F662079656172286461746529222C6465736372697074696F6E3A273C70';
wwv_flow_imp.g_varchar2_table(48127) := '3E52657475726E732074686520477265676F7269616E206E756D626572206F6620746865207765656B2077697468696E2074686520796561722C206163636F7264696E6720746F2049534F20383630312E3C2F703E5C6E3C703E3C7374726F6E673E4675';
wwv_flow_imp.g_varchar2_table(48128) := '6E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7765656B206F66207965617228646174653A2064617465293A206E756D6265725C6E3C2F';
wwv_flow_imp.g_varchar2_table(48129) := '636F64653E3C2F7072653E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7765656B206F66207965617228646174653A206461746520616E642074696D65293A206E756D6265725C6E3C2F636F64653E3C2F7072';
wwv_flow_imp.g_varchar2_table(48130) := '653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E7765656B206F6620796561722864617465282671756F743B323031392D';
wwv_flow_imp.g_varchar2_table(48131) := '30392D31372671756F743B29295C6E2F2F2033385C6E5C6E7765656B206F662079656172286461746520616E642074696D65282671756F743B323031392D30392D31375431323A30303A30302671756F743B29295C6E2F2F2033385C6E3C2F636F64653E';
wwv_flow_imp.g_varchar2_table(48132) := '3C2F7072653E5C6E277D2C7B6E616D653A226D6F6E7468206F662079656172286461746529222C6465736372697074696F6E3A273C703E52657475726E7320746865206D6F6E7468206F66207468652079656172206163636F7264696E6720746F207468';
wwv_flow_imp.g_varchar2_table(48133) := '6520477265676F7269616E2063616C656E6461722E204E6F7465207468617420697420616C776179732072657475726E732074686520456E676C697368206E616D65206F6620746865206D6F6E74682E3C2F703E5C6E3C703E3C7374726F6E673E46756E';
wwv_flow_imp.g_varchar2_table(48134) := '6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6F6E7468206F66207965617228646174653A2064617465293A20737472696E675C6E3C2F';
wwv_flow_imp.g_varchar2_table(48135) := '636F64653E3C2F7072653E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6F6E7468206F66207965617228646174653A206461746520616E642074696D65293A20737472696E675C6E3C2F636F64653E3C2F70';
wwv_flow_imp.g_varchar2_table(48136) := '72653E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6D6F6E7468206F6620796561722864617465282671756F743B323031';
wwv_flow_imp.g_varchar2_table(48137) := '392D30392D31372671756F743B29295C6E2F2F202671756F743B53657074656D6265722671756F743B5C6E5C6E6D6F6E7468206F662079656172286461746520616E642074696D65282671756F743B323031392D30392D31375431323A30303A30302671';
wwv_flow_imp.g_varchar2_table(48138) := '756F743B29295C6E2F2F202671756F743B53657074656D6265722671756F743B5C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B6E616D653A22616273286E29222C6465736372697074696F6E3A273C703E52657475726E7320746865206162736F6C';
wwv_flow_imp.g_varchar2_table(48139) := '7574652076616C7565206F66206120676976656E206475726174696F6E2E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E207369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C61';
wwv_flow_imp.g_varchar2_table(48140) := '6E67756167652D6665656C223E616273286E3A206461797320616E642074696D65206475726174696F6E293A206461797320616E642074696D65206475726174696F6E5C6E3C2F636F64653E3C2F7072653E5C6E3C7072653E3C636F646520636C617373';
wwv_flow_imp.g_varchar2_table(48141) := '3D226C616E67756167652D6665656C223E616273286E3A20796561727320616E64206D6F6E746873206475726174696F6E293A20796561727320616E64206D6F6E746873206475726174696F6E5C6E3C2F636F64653E3C2F7072653E5C6E3C703E3C7374';
wwv_flow_imp.g_varchar2_table(48142) := '726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E616273286475726174696F6E282671756F743B2D505435482671756F743B29295C6E2F2F202671';
wwv_flow_imp.g_varchar2_table(48143) := '756F743B6475726174696F6E282671756F743B505435482671756F743B292671756F743B5C6E5C6E616273286475726174696F6E282671756F743B505435482671756F743B29295C6E2F2F202671756F743B6475726174696F6E282671756F743B505435';
wwv_flow_imp.g_varchar2_table(48144) := '482671756F743B292671756F743B5C6E5C6E616273286475726174696F6E282671756F743B2D50324D2671756F743B29295C6E2F2F206475726174696F6E282671756F743B50324D2671756F743B295C6E3C2F636F64653E3C2F7072653E5C6E277D2C7B';
wwv_flow_imp.g_varchar2_table(48145) := '6E616D653A226C61737420646179206F66206D6F6E7468286461746529222C6465736372697074696F6E3A273C703E3C656D3E43616D756E646120457874656E73696F6E3C2F656D3E3C2F703E5C6E3C703E54616B657320746865206D6F6E7468206F66';
wwv_flow_imp.g_varchar2_table(48146) := '2074686520676976656E2064617465206F7220646174652D74696D652076616C756520616E642072657475726E7320746865206C61737420646179206F662074686973206D6F6E74682E3C2F703E5C6E3C703E3C7374726F6E673E46756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(48147) := '7369676E61747572653C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C61737420646179206F66206D6F6E746828646174653A2064617465293A20646174655C6E3C2F636F6465';
wwv_flow_imp.g_varchar2_table(48148) := '3E3C2F7072653E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C61737420646179206F66206D6F6E746828646174653A206461746520616E642074696D65293A20646174655C6E3C2F636F64653E3C2F707265';
wwv_flow_imp.g_varchar2_table(48149) := '3E5C6E3C703E3C7374726F6E673E4578616D706C65733C2F7374726F6E673E3C2F703E5C6E3C7072653E3C636F646520636C6173733D226C616E67756167652D6665656C223E6C61737420646179206F66206D6F6E74682864617465282671756F743B32';
wwv_flow_imp.g_varchar2_table(48150) := '3032322D31302D30312671756F743B29295C6E2F2F2064617465282671756F743B323032322D31302D33312671756F743B29295C6E5C6E6C61737420646179206F66206D6F6E7468286461746520616E642074696D65282671756F743B323032322D3130';
wwv_flow_imp.g_varchar2_table(48151) := '2D31365431323A30303A30302671756F743B29295C6E2F2F2064617465282671756F743B323032322D31302D33312671756F743B29295C6E3C2F636F64653E3C2F7072653E5C6E277D5D2E6D6170282866756E6374696F6E2865297B636F6E73747B6E61';
wwv_flow_imp.g_varchar2_table(48152) := '6D653A742C6465736372697074696F6E3A6E7D3D652C693D742E6D61746368282F5E285B5C775C735D2B295C28282E2A295C29242F292C6F3D695B315D2C733D695B325D2E73706C697428222C2022292E6D61702828653D3E287B6E616D653A657D2929';
wwv_flow_imp.g_varchar2_table(48153) := '293B72657475726E7B6E616D653A6F2C747970653A2266756E6374696F6E222C706172616D733A732C696E666F3A28293D3E455628603C64697620636C6173733D226465736372697074696F6E223E247B6E7D3C6469763E60292C626F6F73743A307D7D';
wwv_flow_imp.g_varchar2_table(48154) := '29292C6A563D6E657720496B2C71563D6E657720496B3B66756E6374696F6E202456287B657874656E73696F6E733A653D5B5D2C6469616C6563743A743D2265787072657373696F6E222C636F6E7461696E65723A6E2C636F6E74656E74417474726962';
wwv_flow_imp.g_varchar2_table(48155) := '757465733A693D7B7D2C746F6F6C746970436F6E7461696E65723A6F2C6F6E4368616E67653A733D28293D3E7B7D2C6F6E4B6579446F776E3A723D28293D3E7B7D2C6F6E4C696E743A613D28293D3E7B7D2C706C616365686F6C6465723A6C3D22222C72';
wwv_flow_imp.g_varchar2_table(48156) := '6561644F6E6C793A633D21312C76616C75653A643D22222C6275696C74696E733A683D57562C7661726961626C65733A753D5B5D7D297B636F6E737420703D44492E7570646174654C697374656E65722E6F662828653D3E7B652E646F634368616E6765';
wwv_flow_imp.g_varchar2_table(48157) := '6426267328652E73746174652E646F632E746F537472696E672829297D29292C673D44492E7570646174654C697374656E65722E6F662828653D3E7B636F6E737420743D652E7472616E73616374696F6E732E666C61744D61702828653D3E652E656666';
wwv_flow_imp.g_varchar2_table(48158) := '6563747329292E66696C7465722828653D3E652E697328504F2929293B69662821742E6C656E6774682972657475726E3B636F6E7374206E3D742E666C61744D61702828653D3E652E76616C756529293B61286E297D29292C6D3D44492E646F6D457665';
wwv_flow_imp.g_varchar2_table(48159) := '6E7448616E646C657273287B6B6579646F776E3A727D293B22737472696E67223D3D747970656F66206F2626286F3D646F63756D656E742E717565727953656C6563746F72286F29293B636F6E737420663D6F3F5549287B746F6F6C7469705370616365';
wwv_flow_imp.g_varchar2_table(48160) := '3A66756E6374696F6E28297B72657475726E206F2E676574426F756E64696E67436C69656E745265637428297D7D293A5B5D2C763D5B635028292C6A562E6F66284856287B6469616C6563743A742C6275696C74696E733A682C7661726961626C65733A';
wwv_flow_imp.g_varchar2_table(48161) := '757D29292C4D4128292C754128292C5A4E28292C44492E636F6E74656E74417474726962757465732E6F662869292C702C6D2C52492E6F66285B2E2E2E4C4F5D292C4C562C672C662C71562E6F66286A49286C29292C44562C2E2E2E655D3B7265747572';
wwv_flow_imp.g_varchar2_table(48162) := '6E20632626762E707573682844492E6564697461626C652E6F6628213129292C746869732E5F636D456469746F723D6E6577204449287B73746174653A6E452E637265617465287B646F633A642C657874656E73696F6E733A767D292C706172656E743A';
wwv_flow_imp.g_varchar2_table(48163) := '6E7D292C746869737D24562E70726F746F747970652E73657456616C75653D66756E6374696F6E2865297B746869732E5F636D456469746F722E6469737061746368287B6368616E6765733A7B66726F6D3A302C746F3A746869732E5F636D456469746F';
wwv_flow_imp.g_varchar2_table(48164) := '722E73746174652E646F632E6C656E6774682C696E736572743A657D7D297D2C24562E70726F746F747970652E666F6375733D66756E6374696F6E2865297B636F6E737420743D746869732E5F636D456469746F723B696628742E636F6E74656E74444F';
wwv_flow_imp.g_varchar2_table(48165) := '4D2E666F63757328292C742E666F63757328292C226E756D626572223D3D747970656F662065297B636F6E7374206E3D742E73746174652E646F632E6C656E6774683B742E6469737061746368287B73656C656374696F6E3A7B616E63686F723A653C3D';
wwv_flow_imp.g_varchar2_table(48166) := '6E3F653A6E7D7D297D7D2C24562E70726F746F747970652E67657453656C656374696F6E3D66756E6374696F6E28297B72657475726E20746869732E5F636D456469746F722E73746174652E73656C656374696F6E7D2C24562E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(48167) := '7365745661726961626C65733D66756E6374696F6E2865297B636F6E73747B6469616C6563743A742C6275696C74696E733A6E7D3D7B6275696C74696E733A28693D746869732E5F636D456469746F722E7374617465292E6661636574284256295B305D';
wwv_flow_imp.g_varchar2_table(48168) := '2C7661726961626C65733A692E6661636574285656295B305D2C6469616C6563743A692E6661636574287A56295B305D7D3B76617220693B746869732E5F636D456469746F722E6469737061746368287B656666656374733A5B6A562E7265636F6E6669';
wwv_flow_imp.g_varchar2_table(48169) := '67757265284856287B6469616C6563743A742C6275696C74696E733A6E2C7661726961626C65733A657D29295D7D297D2C24562E70726F746F747970652E736574506C616365686F6C6465723D66756E6374696F6E2865297B746869732E5F636D456469';
wwv_flow_imp.g_varchar2_table(48170) := '746F722E6469737061746368287B656666656374733A71562E7265636F6E666967757265286A49286529297D297D3B7661722055563D5B22696E7075743A6E6F74285B696E6572745D29222C2273656C6563743A6E6F74285B696E6572745D29222C2274';
wwv_flow_imp.g_varchar2_table(48171) := '657874617265613A6E6F74285B696E6572745D29222C22615B687265665D3A6E6F74285B696E6572745D29222C22627574746F6E3A6E6F74285B696E6572745D29222C225B746162696E6465785D3A6E6F7428736C6F74293A6E6F74285B696E6572745D';
wwv_flow_imp.g_varchar2_table(48172) := '29222C22617564696F5B636F6E74726F6C735D3A6E6F74285B696E6572745D29222C22766964656F5B636F6E74726F6C735D3A6E6F74285B696E6572745D29222C275B636F6E74656E746564697461626C655D3A6E6F74285B636F6E74656E7465646974';
wwv_flow_imp.g_varchar2_table(48173) := '61626C653D2266616C7365225D293A6E6F74285B696E6572745D29272C2264657461696C733E73756D6D6172793A66697273742D6F662D747970653A6E6F74285B696E6572745D29222C2264657461696C733A6E6F74285B696E6572745D29225D2C4B56';
wwv_flow_imp.g_varchar2_table(48174) := '3D55562E6A6F696E28222C22292C47563D22756E646566696E6564223D3D747970656F6620456C656D656E742C51563D47563F66756E6374696F6E28297B7D3A456C656D656E742E70726F746F747970652E6D6174636865737C7C456C656D656E742E70';
wwv_flow_imp.g_varchar2_table(48175) := '726F746F747970652E6D734D61746368657353656C6563746F727C7C456C656D656E742E70726F746F747970652E7765626B69744D61746368657353656C6563746F722C59563D2147562626456C656D656E742E70726F746F747970652E676574526F6F';
wwv_flow_imp.g_varchar2_table(48176) := '744E6F64653F66756E6374696F6E2865297B76617220743B72657475726E206E756C6C3D3D657C7C6E756C6C3D3D3D28743D652E676574526F6F744E6F6465297C7C766F696420303D3D3D743F766F696420303A742E63616C6C2865297D3A66756E6374';
wwv_flow_imp.g_varchar2_table(48177) := '696F6E2865297B72657475726E206E756C6C3D3D653F766F696420303A652E6F776E6572446F63756D656E747D2C5A563D66756E6374696F6E206528742C6E297B76617220693B766F696420303D3D3D6E2626286E3D2130293B766172206F3D6E756C6C';
wwv_flow_imp.g_varchar2_table(48178) := '3D3D747C7C6E756C6C3D3D3D28693D742E676574417474726962757465297C7C766F696420303D3D3D693F766F696420303A692E63616C6C28742C22696E65727422293B72657475726E22223D3D3D6F7C7C2274727565223D3D3D6F7C7C6E2626742626';
wwv_flow_imp.g_varchar2_table(48179) := '6528742E706172656E744E6F6465297D2C58563D66756E6374696F6E28652C742C6E297B6966285A562865292972657475726E5B5D3B76617220693D41727261792E70726F746F747970652E736C6963652E6170706C7928652E717565727953656C6563';
wwv_flow_imp.g_varchar2_table(48180) := '746F72416C6C284B5629293B72657475726E2074262651562E63616C6C28652C4B56292626692E756E73686966742865292C692E66696C746572286E297D2C4A563D66756E6374696F6E206528742C6E2C69297B666F7228766172206F3D5B5D2C733D41';
wwv_flow_imp.g_varchar2_table(48181) := '727261792E66726F6D2874293B732E6C656E6774683B297B76617220723D732E736869667428293B696628215A5628722C2131292969662822534C4F54223D3D3D722E7461674E616D65297B76617220613D722E61737369676E6564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(48182) := '28292C6C3D6528612E6C656E6774683F613A722E6368696C6472656E2C21302C69293B692E666C617474656E3F6F2E707573682E6170706C79286F2C6C293A6F2E70757368287B73636F7065506172656E743A722C63616E646964617465733A6C7D297D';
wwv_flow_imp.g_varchar2_table(48183) := '656C73657B51562E63616C6C28722C4B56292626692E66696C7465722872292626286E7C7C21742E696E636C756465732872292926266F2E707573682872293B76617220633D722E736861646F77526F6F747C7C2266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(48184) := '6F6620692E676574536861646F77526F6F742626692E676574536861646F77526F6F742872292C643D215A5628632C21312926262821692E736861646F77526F6F7446696C7465727C7C692E736861646F77526F6F7446696C746572287229293B696628';
wwv_flow_imp.g_varchar2_table(48185) := '63262664297B76617220683D652821303D3D3D633F722E6368696C6472656E3A632E6368696C6472656E2C21302C69293B692E666C617474656E3F6F2E707573682E6170706C79286F2C68293A6F2E70757368287B73636F7065506172656E743A722C63';
wwv_flow_imp.g_varchar2_table(48186) := '616E646964617465733A687D297D656C736520732E756E73686966742E6170706C7928732C722E6368696C6472656E297D7D72657475726E206F7D2C657A3D66756E6374696F6E2865297B72657475726E2169734E614E287061727365496E7428652E67';
wwv_flow_imp.g_varchar2_table(48187) := '65744174747269627574652822746162696E64657822292C313029297D2C747A3D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F7228224E6F206E6F64652070726F766964656422293B72657475726E20652E74616249';
wwv_flow_imp.g_varchar2_table(48188) := '6E6465783C302626282F5E28415544494F7C564944454F7C44455441494C5329242F2E7465737428652E7461674E616D65297C7C66756E6374696F6E2865297B76617220742C6E3D6E756C6C3D3D657C7C6E756C6C3D3D3D28743D652E67657441747472';
wwv_flow_imp.g_varchar2_table(48189) := '6962757465297C7C766F696420303D3D3D743F766F696420303A742E63616C6C28652C22636F6E74656E746564697461626C6522293B72657475726E22223D3D3D6E7C7C2274727565223D3D3D6E7D28652929262621657A2865293F303A652E74616249';
wwv_flow_imp.g_varchar2_table(48190) := '6E6465787D2C6E7A3D66756E6374696F6E28652C74297B72657475726E20652E746162496E6465783D3D3D742E746162496E6465783F652E646F63756D656E744F726465722D742E646F63756D656E744F726465723A652E746162496E6465782D742E74';
wwv_flow_imp.g_varchar2_table(48191) := '6162496E6465787D2C697A3D66756E6374696F6E2865297B72657475726E22494E505554223D3D3D652E7461674E616D657D2C6F7A3D66756E6374696F6E2865297B76617220743D652E676574426F756E64696E67436C69656E745265637428292C6E3D';
wwv_flow_imp.g_varchar2_table(48192) := '742E77696474682C693D742E6865696768743B72657475726E20303D3D3D6E2626303D3D3D697D2C737A3D66756E6374696F6E28652C74297B72657475726E2128742E64697361626C65647C7C5A562874297C7C66756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(48193) := '726E20697A28652926262268696464656E223D3D3D652E747970657D2874297C7C66756E6374696F6E28652C74297B766172206E3D742E646973706C6179436865636B2C693D742E676574536861646F77526F6F743B6966282268696464656E223D3D3D';
wwv_flow_imp.g_varchar2_table(48194) := '676574436F6D70757465645374796C652865292E7669736962696C6974792972657475726E21303B766172206F3D51562E63616C6C28652C2264657461696C733E73756D6D6172793A66697273742D6F662D7479706522293F652E706172656E74456C65';
wwv_flow_imp.g_varchar2_table(48195) := '6D656E743A653B69662851562E63616C6C286F2C2264657461696C733A6E6F74285B6F70656E5D29202A22292972657475726E21303B6966286E26262266756C6C22213D3D6E2626226C65676163792D66756C6C22213D3D6E297B696628226E6F6E2D7A';
wwv_flow_imp.g_varchar2_table(48196) := '65726F2D61726561223D3D3D6E2972657475726E206F7A2865297D656C73657B6966282266756E6374696F6E223D3D747970656F662069297B666F722876617220733D653B653B297B76617220723D652E706172656E74456C656D656E742C613D595628';
wwv_flow_imp.g_varchar2_table(48197) := '65293B69662872262621722E736861646F77526F6F74262621303D3D3D692872292972657475726E206F7A2865293B653D652E61737369676E6564536C6F743F652E61737369676E6564536C6F743A727C7C613D3D3D652E6F776E6572446F63756D656E';
wwv_flow_imp.g_varchar2_table(48198) := '743F723A612E686F73747D653D737D69662866756E6374696F6E2865297B76617220742C6E2C692C6F2C733D65262659562865292C723D6E756C6C3D3D3D28743D73297C7C766F696420303D3D3D743F766F696420303A742E686F73742C613D21313B69';
wwv_flow_imp.g_varchar2_table(48199) := '662873262673213D3D6529666F7228613D2121286E756C6C213D3D286E3D72292626766F69642030213D3D6E26266E756C6C213D3D28693D6E2E6F776E6572446F63756D656E74292626766F69642030213D3D692626692E636F6E7461696E732872297C';
wwv_flow_imp.g_varchar2_table(48200) := '7C6E756C6C213D6526266E756C6C213D3D286F3D652E6F776E6572446F63756D656E74292626766F69642030213D3D6F26266F2E636F6E7461696E73286529293B21612626723B297B766172206C2C632C643B613D21286E756C6C3D3D3D28633D723D6E';
wwv_flow_imp.g_varchar2_table(48201) := '756C6C3D3D3D286C3D733D5956287229297C7C766F696420303D3D3D6C3F766F696420303A6C2E686F7374297C7C766F696420303D3D3D637C7C6E756C6C3D3D3D28643D632E6F776E6572446F63756D656E74297C7C766F696420303D3D3D647C7C2164';
wwv_flow_imp.g_varchar2_table(48202) := '2E636F6E7461696E73287229297D72657475726E20617D2865292972657475726E21652E676574436C69656E74526563747328292E6C656E6774683B696628226C65676163792D66756C6C22213D3D6E2972657475726E21307D72657475726E21317D28';
wwv_flow_imp.g_varchar2_table(48203) := '742C65297C7C66756E6374696F6E2865297B72657475726E2244455441494C53223D3D3D652E7461674E616D65262641727261792E70726F746F747970652E736C6963652E6170706C7928652E6368696C6472656E292E736F6D65282866756E6374696F';
wwv_flow_imp.g_varchar2_table(48204) := '6E2865297B72657475726E2253554D4D415259223D3D3D652E7461674E616D657D29297D2874297C7C66756E6374696F6E2865297B6966282F5E28494E5055547C425554544F4E7C53454C4543547C544558544152454129242F2E7465737428652E7461';
wwv_flow_imp.g_varchar2_table(48205) := '674E616D652929666F722876617220743D652E706172656E74456C656D656E743B743B297B696628224649454C44534554223D3D3D742E7461674E616D652626742E64697361626C6564297B666F7228766172206E3D303B6E3C742E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(48206) := '2E6C656E6774683B6E2B2B297B76617220693D742E6368696C6472656E2E6974656D286E293B696628224C4547454E44223D3D3D692E7461674E616D652972657475726E212151562E63616C6C28742C226669656C647365745B64697361626C65645D20';
wwv_flow_imp.g_varchar2_table(48207) := '2A22297C7C21692E636F6E7461696E732865297D72657475726E21307D743D742E706172656E74456C656D656E747D72657475726E21317D287429297D2C727A3D66756E6374696F6E28652C74297B72657475726E212866756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(48208) := '657475726E2066756E6374696F6E2865297B72657475726E20697A286529262622726164696F223D3D3D652E747970657D28652926262166756E6374696F6E2865297B69662821652E6E616D652972657475726E21303B76617220742C6E3D652E666F72';
wwv_flow_imp.g_varchar2_table(48209) := '6D7C7C59562865292C693D66756E6374696F6E2865297B72657475726E206E2E717565727953656C6563746F72416C6C2827696E7075745B747970653D22726164696F225D5B6E616D653D22272B652B27225D27297D3B69662822756E646566696E6564';
wwv_flow_imp.g_varchar2_table(48210) := '22213D747970656F662077696E646F772626766F69642030213D3D77696E646F772E43535326262266756E6374696F6E223D3D747970656F662077696E646F772E4353532E65736361706529743D692877696E646F772E4353532E65736361706528652E';
wwv_flow_imp.g_varchar2_table(48211) := '6E616D6529293B656C7365207472797B743D6928652E6E616D65297D63617463682865297B72657475726E20636F6E736F6C652E6572726F7228224C6F6F6B73206C696B6520796F752068617665206120726164696F20627574746F6E20776974682061';
wwv_flow_imp.g_varchar2_table(48212) := '206E616D652061747472696275746520636F6E7461696E696E6720696E76616C6964204353532073656C6563746F72206368617261637465727320616E64206E65656420746865204353532E65736361706520706F6C7966696C6C3A202573222C652E6D';
wwv_flow_imp.g_varchar2_table(48213) := '657373616765292C21317D766172206F3D66756E6374696F6E28652C74297B666F7228766172206E3D303B6E3C652E6C656E6774683B6E2B2B29696628655B6E5D2E636865636B65642626655B6E5D2E666F726D3D3D3D742972657475726E20655B6E5D';
wwv_flow_imp.g_varchar2_table(48214) := '7D28742C652E666F726D293B72657475726E216F7C7C6F3D3D3D657D2865297D2874297C7C747A2874293C307C7C21737A28652C7429297D2C617A3D66756E6374696F6E2865297B76617220743D7061727365496E7428652E6765744174747269627574';
wwv_flow_imp.g_varchar2_table(48215) := '652822746162696E64657822292C3130293B72657475726E21212869734E614E2874297C7C743E3D30297D2C6C7A3D66756E6374696F6E20652874297B766172206E3D5B5D2C693D5B5D3B72657475726E20742E666F7245616368282866756E6374696F';
wwv_flow_imp.g_varchar2_table(48216) := '6E28742C6F297B76617220733D2121742E73636F7065506172656E742C723D733F742E73636F7065506172656E743A742C613D66756E6374696F6E28652C74297B766172206E3D747A2865293B72657475726E206E3C30262674262621657A2865293F30';
wwv_flow_imp.g_varchar2_table(48217) := '3A6E7D28722C73292C6C3D733F6528742E63616E64696461746573293A723B303D3D3D613F733F6E2E707573682E6170706C79286E2C6C293A6E2E707573682872293A692E70757368287B646F63756D656E744F726465723A6F2C746162496E6465783A';
wwv_flow_imp.g_varchar2_table(48218) := '612C6974656D3A742C697353636F70653A732C636F6E74656E743A6C7D297D29292C692E736F7274286E7A292E726564756365282866756E6374696F6E28652C74297B72657475726E20742E697353636F70653F652E707573682E6170706C7928652C74';
wwv_flow_imp.g_varchar2_table(48219) := '2E636F6E74656E74293A652E7075736828742E636F6E74656E74292C657D292C5B5D292E636F6E636174286E297D2C637A3D66756E6374696F6E28652C74297B696628743D747C7C7B7D2C2165297468726F77206E6577204572726F7228224E6F206E6F';
wwv_flow_imp.g_varchar2_table(48220) := '64652070726F766964656422293B72657475726E2131213D3D51562E63616C6C28652C4B56292626727A28742C65297D2C647A3D55562E636F6E6361742822696672616D6522292E6A6F696E28222C22292C687A3D66756E6374696F6E28652C74297B69';
wwv_flow_imp.g_varchar2_table(48221) := '6628743D747C7C7B7D2C2165297468726F77206E6577204572726F7228224E6F206E6F64652070726F766964656422293B72657475726E2131213D3D51562E63616C6C28652C647A292626737A28742C65297D3B66756E6374696F6E20757A28652C7429';
wwv_flow_imp.g_varchar2_table(48222) := '7B766172206E3D4F626A6563742E6B6579732865293B6966284F626A6563742E6765744F776E50726F706572747953796D626F6C73297B76617220693D4F626A6563742E6765744F776E50726F706572747953796D626F6C732865293B74262628693D69';
wwv_flow_imp.g_varchar2_table(48223) := '2E66696C746572282866756E6374696F6E2874297B72657475726E204F626A6563742E6765744F776E50726F706572747944657363726970746F7228652C74292E656E756D657261626C657D2929292C6E2E707573682E6170706C79286E2C69297D7265';
wwv_flow_imp.g_varchar2_table(48224) := '7475726E206E7D66756E6374696F6E20707A2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D6E756C6C213D617267756D656E74735B745D3F617267756D656E74735B745D3A7B7D3B74';
wwv_flow_imp.g_varchar2_table(48225) := '25323F757A284F626A656374286E292C2130292E666F7245616368282866756E6374696F6E2874297B76617220692C6F2C733B693D652C6F3D742C733D6E5B745D2C286F3D66756E6374696F6E2865297B76617220743D66756E6374696F6E2865297B69';
wwv_flow_imp.g_varchar2_table(48226) := '6628226F626A65637422213D747970656F6620657C7C6E756C6C3D3D3D652972657475726E20653B76617220743D655B53796D626F6C2E746F5072696D69746976655D3B696628766F69642030213D3D74297B766172206E3D742E63616C6C28652C2273';
wwv_flow_imp.g_varchar2_table(48227) := '7472696E6722293B696628226F626A65637422213D747970656F66206E2972657475726E206E3B7468726F77206E657720547970654572726F7228224040746F5072696D6974697665206D7573742072657475726E2061207072696D6974697665207661';
wwv_flow_imp.g_varchar2_table(48228) := '6C75652E22297D72657475726E20537472696E672865297D2865293B72657475726E2273796D626F6C223D3D747970656F6620743F743A537472696E672874297D286F2929696E20693F4F626A6563742E646566696E6550726F706572747928692C6F2C';
wwv_flow_imp.g_varchar2_table(48229) := '7B76616C75653A732C656E756D657261626C653A21302C636F6E666967757261626C653A21302C7772697461626C653A21307D293A695B6F5D3D737D29293A4F626A6563742E6765744F776E50726F706572747944657363726970746F72733F4F626A65';
wwv_flow_imp.g_varchar2_table(48230) := '63742E646566696E6550726F7065727469657328652C4F626A6563742E6765744F776E50726F706572747944657363726970746F7273286E29293A757A284F626A656374286E29292E666F7245616368282866756E6374696F6E2874297B4F626A656374';
wwv_flow_imp.g_varchar2_table(48231) := '2E646566696E6550726F706572747928652C742C4F626A6563742E6765744F776E50726F706572747944657363726970746F72286E2C7429297D29297D72657475726E20657D76617220677A3D66756E6374696F6E2865297B72657475726E2254616222';
wwv_flow_imp.g_varchar2_table(48232) := '3D3D3D286E756C6C3D3D653F766F696420303A652E6B6579297C7C393D3D3D286E756C6C3D3D653F766F696420303A652E6B6579436F6465297D2C6D7A3D66756E6374696F6E2865297B72657475726E20677A286529262621652E73686966744B65797D';
wwv_flow_imp.g_varchar2_table(48233) := '2C667A3D66756E6374696F6E2865297B72657475726E20677A2865292626652E73686966744B65797D2C767A3D66756E6374696F6E2865297B72657475726E2073657454696D656F757428652C30297D2C627A3D66756E6374696F6E28652C74297B7661';
wwv_flow_imp.g_varchar2_table(48234) := '72206E3D2D313B72657475726E20652E6576657279282866756E6374696F6E28652C69297B72657475726E21742865297C7C286E3D692C2131297D29292C6E7D2C5F7A3D66756E6374696F6E2865297B666F722876617220743D617267756D656E74732E';
wwv_flow_imp.g_varchar2_table(48235) := '6C656E6774682C6E3D6E657720417272617928743E313F742D313A30292C693D313B693C743B692B2B296E5B692D315D3D617267756D656E74735B695D3B72657475726E2266756E6374696F6E223D3D747970656F6620653F652E6170706C7928766F69';
wwv_flow_imp.g_varchar2_table(48236) := '6420302C6E293A657D2C797A3D66756E6374696F6E2865297B72657475726E20652E7461726765742E736861646F77526F6F7426262266756E6374696F6E223D3D747970656F6620652E636F6D706F736564506174683F652E636F6D706F736564506174';
wwv_flow_imp.g_varchar2_table(48237) := '6828295B305D3A652E7461726765747D2C777A3D5B5D2C437A3D66756E6374696F6E28652C74297B766172206E2C693D286E756C6C3D3D743F766F696420303A742E646F63756D656E74297C7C646F63756D656E742C6F3D286E756C6C3D3D743F766F69';
wwv_flow_imp.g_varchar2_table(48238) := '6420303A742E74726170537461636B297C7C777A2C733D707A287B72657475726E466F6375734F6E446561637469766174653A21302C65736361706544656163746976617465733A21302C64656C6179496E697469616C466F6375733A21302C69734B65';
wwv_flow_imp.g_varchar2_table(48239) := '79466F72776172643A6D7A2C69734B65794261636B776172643A667A7D2C74292C723D7B636F6E7461696E6572733A5B5D2C636F6E7461696E657247726F7570733A5B5D2C7461626261626C6547726F7570733A5B5D2C6E6F6465466F63757365644265';
wwv_flow_imp.g_varchar2_table(48240) := '666F726541637469766174696F6E3A6E756C6C2C6D6F7374526563656E746C79466F63757365644E6F64653A6E756C6C2C6163746976653A21312C7061757365643A21312C64656C6179496E697469616C466F63757354696D65723A766F696420302C72';
wwv_flow_imp.g_varchar2_table(48241) := '6563656E744E61764576656E743A766F696420307D2C613D66756E6374696F6E28652C742C6E297B72657475726E20652626766F69642030213D3D655B745D3F655B745D3A735B6E7C7C745D7D2C6C3D66756E6374696F6E28652C74297B766172206E3D';
wwv_flow_imp.g_varchar2_table(48242) := '2266756E6374696F6E223D3D747970656F66286E756C6C3D3D743F766F696420303A742E636F6D706F73656450617468293F742E636F6D706F7365645061746828293A766F696420303B72657475726E20722E636F6E7461696E657247726F7570732E66';
wwv_flow_imp.g_varchar2_table(48243) := '696E64496E646578282866756E6374696F6E2874297B76617220693D742E636F6E7461696E65722C6F3D742E7461626261626C654E6F6465733B72657475726E20692E636F6E7461696E732865297C7C286E756C6C3D3D6E3F766F696420303A6E2E696E';
wwv_flow_imp.g_varchar2_table(48244) := '636C75646573286929297C7C6F2E66696E64282866756E6374696F6E2874297B72657475726E20743D3D3D657D29297D29297D2C633D66756E6374696F6E2865297B76617220743D735B655D3B6966282266756E6374696F6E223D3D747970656F662074';
wwv_flow_imp.g_varchar2_table(48245) := '297B666F7228766172206E3D617267756D656E74732E6C656E6774682C6F3D6E6577204172726179286E3E313F6E2D313A30292C723D313B723C6E3B722B2B296F5B722D315D3D617267756D656E74735B725D3B743D742E6170706C7928766F69642030';
wwv_flow_imp.g_varchar2_table(48246) := '2C6F297D69662821303D3D3D74262628743D766F69642030292C2174297B696628766F696420303D3D3D747C7C21313D3D3D742972657475726E20743B7468726F77206E6577204572726F72282260222E636F6E63617428652C22602077617320737065';
wwv_flow_imp.g_varchar2_table(48247) := '6369666965642062757420776173206E6F742061206E6F64652C206F7220646964206E6F742072657475726E2061206E6F64652229297D76617220613D743B69662822737472696E67223D3D747970656F66207426262128613D692E717565727953656C';
wwv_flow_imp.g_varchar2_table(48248) := '6563746F7228742929297468726F77206E6577204572726F72282260222E636F6E63617428652C22602061732073656C6563746F722072656665727320746F206E6F206B6E6F776E206E6F64652229293B72657475726E20617D2C643D66756E6374696F';
wwv_flow_imp.g_varchar2_table(48249) := '6E28297B76617220653D632822696E697469616C466F63757322293B69662821313D3D3D652972657475726E21313B696628766F696420303D3D3D657C7C21687A28652C732E7461626261626C654F7074696F6E7329296966286C28692E616374697665';
wwv_flow_imp.g_varchar2_table(48250) := '456C656D656E74293E3D3029653D692E616374697665456C656D656E743B656C73657B76617220743D722E7461626261626C6547726F7570735B305D3B653D742626742E66697273745461626261626C654E6F64657C7C63282266616C6C6261636B466F';
wwv_flow_imp.g_varchar2_table(48251) := '63757322297D6966282165297468726F77206E6577204572726F722822596F757220666F6375732D74726170206E6565647320746F2068617665206174206C65617374206F6E6520666F63757361626C6520656C656D656E7422293B72657475726E2065';
wwv_flow_imp.g_varchar2_table(48252) := '7D2C683D66756E6374696F6E28297B696628722E636F6E7461696E657247726F7570733D722E636F6E7461696E6572732E6D6170282866756E6374696F6E2865297B76617220743D66756E6374696F6E28652C74297B766172206E3B72657475726E206E';
wwv_flow_imp.g_varchar2_table(48253) := '3D28743D747C7C7B7D292E676574536861646F77526F6F743F4A56285B655D2C742E696E636C756465436F6E7461696E65722C7B66696C7465723A727A2E62696E64286E756C6C2C74292C666C617474656E3A21312C676574536861646F77526F6F743A';
wwv_flow_imp.g_varchar2_table(48254) := '742E676574536861646F77526F6F742C736861646F77526F6F7446696C7465723A617A7D293A585628652C742E696E636C756465436F6E7461696E65722C727A2E62696E64286E756C6C2C7429292C6C7A286E297D28652C732E7461626261626C654F70';
wwv_flow_imp.g_varchar2_table(48255) := '74696F6E73292C6E3D66756E6374696F6E28652C74297B72657475726E28743D747C7C7B7D292E676574536861646F77526F6F743F4A56285B655D2C742E696E636C756465436F6E7461696E65722C7B66696C7465723A737A2E62696E64286E756C6C2C';
wwv_flow_imp.g_varchar2_table(48256) := '74292C666C617474656E3A21302C676574536861646F77526F6F743A742E676574536861646F77526F6F747D293A585628652C742E696E636C756465436F6E7461696E65722C737A2E62696E64286E756C6C2C7429297D28652C732E7461626261626C65';
wwv_flow_imp.g_varchar2_table(48257) := '4F7074696F6E73292C693D742E6C656E6774683E303F745B305D3A766F696420302C6F3D742E6C656E6774683E303F745B742E6C656E6774682D315D3A766F696420302C723D6E2E66696E64282866756E6374696F6E2865297B72657475726E20637A28';
wwv_flow_imp.g_varchar2_table(48258) := '65297D29292C613D6E2E736C69636528292E7265766572736528292E66696E64282866756E6374696F6E2865297B72657475726E20637A2865297D29292C6C3D2121742E66696E64282866756E6374696F6E2865297B72657475726E20747A2865293E30';
wwv_flow_imp.g_varchar2_table(48259) := '7D29293B72657475726E7B636F6E7461696E65723A652C7461626261626C654E6F6465733A742C666F63757361626C654E6F6465733A6E2C706F73546162496E6465786573466F756E643A6C2C66697273745461626261626C654E6F64653A692C6C6173';
wwv_flow_imp.g_varchar2_table(48260) := '745461626261626C654E6F64653A6F2C6669727374446F6D5461626261626C654E6F64653A722C6C617374446F6D5461626261626C654E6F64653A612C6E6578745461626261626C654E6F64653A66756E6374696F6E2865297B76617220693D21286172';
wwv_flow_imp.g_varchar2_table(48261) := '67756D656E74732E6C656E6774683E312626766F69642030213D3D617267756D656E74735B315D297C7C617267756D656E74735B315D2C6F3D742E696E6465784F662865293B72657475726E206F3C303F693F6E2E736C696365286E2E696E6465784F66';
wwv_flow_imp.g_varchar2_table(48262) := '2865292B31292E66696E64282866756E6374696F6E2865297B72657475726E20637A2865297D29293A6E2E736C69636528302C6E2E696E6465784F66286529292E7265766572736528292E66696E64282866756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(48263) := '637A2865297D29293A745B6F2B28693F313A2D31295D7D7D7D29292C722E7461626261626C6547726F7570733D722E636F6E7461696E657247726F7570732E66696C746572282866756E6374696F6E2865297B72657475726E20652E7461626261626C65';
wwv_flow_imp.g_varchar2_table(48264) := '4E6F6465732E6C656E6774683E307D29292C722E7461626261626C6547726F7570732E6C656E6774683C3D3026262163282266616C6C6261636B466F6375732229297468726F77206E6577204572726F722822596F757220666F6375732D74726170206D';
wwv_flow_imp.g_varchar2_table(48265) := '7573742068617665206174206C65617374206F6E6520636F6E7461696E65722077697468206174206C65617374206F6E65207461626261626C65206E6F646520696E20697420617420616C6C2074696D657322293B696628722E636F6E7461696E657247';
wwv_flow_imp.g_varchar2_table(48266) := '726F7570732E66696E64282866756E6374696F6E2865297B72657475726E20652E706F73546162496E6465786573466F756E647D29292626722E636F6E7461696E657247726F7570732E6C656E6774683E31297468726F77206E6577204572726F722822';
wwv_flow_imp.g_varchar2_table(48267) := '4174206C65617374206F6E65206E6F64652077697468206120706F73697469766520746162696E6465782077617320666F756E6420696E206F6E65206F6620796F757220666F6375732D747261702773206D756C7469706C6520636F6E7461696E657273';
wwv_flow_imp.g_varchar2_table(48268) := '2E20506F73697469766520746162696E646578657320617265206F6E6C7920737570706F7274656420696E2073696E676C652D636F6E7461696E657220666F6375732D74726170732E22297D2C753D66756E6374696F6E20652874297B766172206E3D74';
wwv_flow_imp.g_varchar2_table(48269) := '2E616374697665456C656D656E743B6966286E2972657475726E206E2E736861646F77526F6F7426266E756C6C213D3D6E2E736861646F77526F6F742E616374697665456C656D656E743F65286E2E736861646F77526F6F74293A6E7D2C703D66756E63';
wwv_flow_imp.g_varchar2_table(48270) := '74696F6E20652874297B2131213D3D74262674213D3D7528646F63756D656E7429262628742626742E666F6375733F28742E666F637573287B70726576656E745363726F6C6C3A2121732E70726576656E745363726F6C6C7D292C722E6D6F7374526563';
wwv_flow_imp.g_varchar2_table(48271) := '656E746C79466F63757365644E6F64653D742C66756E6374696F6E2865297B72657475726E20652E7461674E616D65262622696E707574223D3D3D652E7461674E616D652E746F4C6F77657243617365282926262266756E6374696F6E223D3D74797065';
wwv_flow_imp.g_varchar2_table(48272) := '6F6620652E73656C6563747D2874292626742E73656C6563742829293A652864282929297D2C673D66756E6374696F6E2865297B76617220743D63282273657452657475726E466F637573222C65293B72657475726E20747C7C2131213D3D742626657D';
wwv_flow_imp.g_varchar2_table(48273) := '2C6D3D66756E6374696F6E2865297B76617220743D652E7461726765742C6E3D652E6576656E742C693D652E69734261636B776172642C6F3D766F69642030213D3D692626693B743D747C7C797A286E292C6828293B76617220613D6E756C6C3B696628';
wwv_flow_imp.g_varchar2_table(48274) := '722E7461626261626C6547726F7570732E6C656E6774683E30297B76617220643D6C28742C6E292C753D643E3D303F722E636F6E7461696E657247726F7570735B645D3A766F696420303B696628643C3029613D6F3F722E7461626261626C6547726F75';
wwv_flow_imp.g_varchar2_table(48275) := '70735B722E7461626261626C6547726F7570732E6C656E6774682D315D2E6C6173745461626261626C654E6F64653A722E7461626261626C6547726F7570735B305D2E66697273745461626261626C654E6F64653B656C7365206966286F297B76617220';
wwv_flow_imp.g_varchar2_table(48276) := '703D627A28722E7461626261626C6547726F7570732C2866756E6374696F6E2865297B766172206E3D652E66697273745461626261626C654E6F64653B72657475726E20743D3D3D6E7D29293B696628703C30262628752E636F6E7461696E65723D3D3D';
wwv_flow_imp.g_varchar2_table(48277) := '747C7C687A28742C732E7461626261626C654F7074696F6E7329262621637A28742C732E7461626261626C654F7074696F6E7329262621752E6E6578745461626261626C654E6F646528742C21312929262628703D64292C703E3D30297B76617220673D';
wwv_flow_imp.g_varchar2_table(48278) := '303D3D3D703F722E7461626261626C6547726F7570732E6C656E6774682D313A702D312C6D3D722E7461626261626C6547726F7570735B675D3B613D747A2874293E3D303F6D2E6C6173745461626261626C654E6F64653A6D2E6C617374446F6D546162';
wwv_flow_imp.g_varchar2_table(48279) := '6261626C654E6F64657D656C736520677A286E297C7C28613D752E6E6578745461626261626C654E6F646528742C213129297D656C73657B76617220663D627A28722E7461626261626C6547726F7570732C2866756E6374696F6E2865297B766172206E';
wwv_flow_imp.g_varchar2_table(48280) := '3D652E6C6173745461626261626C654E6F64653B72657475726E20743D3D3D6E7D29293B696628663C30262628752E636F6E7461696E65723D3D3D747C7C687A28742C732E7461626261626C654F7074696F6E7329262621637A28742C732E7461626261';
wwv_flow_imp.g_varchar2_table(48281) := '626C654F7074696F6E7329262621752E6E6578745461626261626C654E6F646528742929262628663D64292C663E3D30297B76617220763D663D3D3D722E7461626261626C6547726F7570732E6C656E6774682D313F303A662B312C623D722E74616262';
wwv_flow_imp.g_varchar2_table(48282) := '61626C6547726F7570735B765D3B613D747A2874293E3D303F622E66697273745461626261626C654E6F64653A622E6669727374446F6D5461626261626C654E6F64657D656C736520677A286E297C7C28613D752E6E6578745461626261626C654E6F64';
wwv_flow_imp.g_varchar2_table(48283) := '65287429297D7D656C736520613D63282266616C6C6261636B466F63757322293B72657475726E20617D2C663D66756E6374696F6E2865297B76617220743D797A2865293B6C28742C65293E3D307C7C285F7A28732E636C69636B4F7574736964654465';
wwv_flow_imp.g_varchar2_table(48284) := '6163746976617465732C65293F6E2E64656163746976617465287B72657475726E466F6375733A732E72657475726E466F6375734F6E446561637469766174657D293A5F7A28732E616C6C6F774F757473696465436C69636B2C65297C7C652E70726576';
wwv_flow_imp.g_varchar2_table(48285) := '656E7444656661756C742829297D2C763D66756E6374696F6E2865297B76617220743D797A2865292C6E3D6C28742C65293E3D303B6966286E7C7C7420696E7374616E63656F6620446F63756D656E74296E262628722E6D6F7374526563656E746C7946';
wwv_flow_imp.g_varchar2_table(48286) := '6F63757365644E6F64653D74293B656C73657B76617220693B652E73746F70496D6D65646961746550726F7061676174696F6E28293B766172206F3D21303B696628722E6D6F7374526563656E746C79466F63757365644E6F646529696628747A28722E';
wwv_flow_imp.g_varchar2_table(48287) := '6D6F7374526563656E746C79466F63757365644E6F6465293E30297B76617220613D6C28722E6D6F7374526563656E746C79466F63757365644E6F6465292C633D722E636F6E7461696E657247726F7570735B615D2E7461626261626C654E6F6465733B';
wwv_flow_imp.g_varchar2_table(48288) := '696628632E6C656E6774683E30297B76617220683D632E66696E64496E646578282866756E6374696F6E2865297B72657475726E20653D3D3D722E6D6F7374526563656E746C79466F63757365644E6F64657D29293B683E3D30262628732E69734B6579';
wwv_flow_imp.g_varchar2_table(48289) := '466F727761726428722E726563656E744E61764576656E74293F682B313C632E6C656E677468262628693D635B682B315D2C6F3D2131293A682D313E3D30262628693D635B682D315D2C6F3D213129297D7D656C736520722E636F6E7461696E65724772';
wwv_flow_imp.g_varchar2_table(48290) := '6F7570732E736F6D65282866756E6374696F6E2865297B72657475726E20652E7461626261626C654E6F6465732E736F6D65282866756E6374696F6E2865297B72657475726E20747A2865293E307D29297D29297C7C286F3D2131293B656C7365206F3D';
wwv_flow_imp.g_varchar2_table(48291) := '21313B6F262628693D6D287B7461726765743A722E6D6F7374526563656E746C79466F63757365644E6F64652C69734261636B776172643A732E69734B65794261636B7761726428722E726563656E744E61764576656E74297D29292C7028697C7C722E';
wwv_flow_imp.g_varchar2_table(48292) := '6D6F7374526563656E746C79466F63757365644E6F64657C7C642829297D722E726563656E744E61764576656E743D766F696420307D2C623D66756E6374696F6E2865297B69662866756E6374696F6E2865297B72657475726E22457363617065223D3D';
wwv_flow_imp.g_varchar2_table(48293) := '3D286E756C6C3D3D653F766F696420303A652E6B6579297C7C22457363223D3D3D286E756C6C3D3D653F766F696420303A652E6B6579297C7C32373D3D3D286E756C6C3D3D653F766F696420303A652E6B6579436F6465297D28652926262131213D3D5F';
wwv_flow_imp.g_varchar2_table(48294) := '7A28732E65736361706544656163746976617465732C65292972657475726E20652E70726576656E7444656661756C7428292C766F6964206E2E6465616374697661746528293B28732E69734B6579466F72776172642865297C7C732E69734B65794261';
wwv_flow_imp.g_varchar2_table(48295) := '636B7761726428652929262666756E6374696F6E2865297B76617220743D617267756D656E74732E6C656E6774683E312626766F69642030213D3D617267756D656E74735B315D2626617267756D656E74735B315D3B722E726563656E744E6176457665';
wwv_flow_imp.g_varchar2_table(48296) := '6E743D653B766172206E3D6D287B6576656E743A652C69734261636B776172643A747D293B6E262628677A2865292626652E70726576656E7444656661756C7428292C70286E29297D28652C732E69734B65794261636B77617264286529297D2C5F3D66';
wwv_flow_imp.g_varchar2_table(48297) := '756E6374696F6E2865297B76617220743D797A2865293B6C28742C65293E3D307C7C5F7A28732E636C69636B4F75747369646544656163746976617465732C65297C7C5F7A28732E616C6C6F774F757473696465436C69636B2C65297C7C28652E707265';
wwv_flow_imp.g_varchar2_table(48298) := '76656E7444656661756C7428292C652E73746F70496D6D65646961746550726F7061676174696F6E2829297D2C793D66756E6374696F6E28297B696628722E6163746976652972657475726E2066756E6374696F6E28652C74297B696628652E6C656E67';
wwv_flow_imp.g_varchar2_table(48299) := '74683E30297B766172206E3D655B652E6C656E6774682D315D3B6E213D3D7426266E2E706175736528297D76617220693D652E696E6465784F662874293B2D313D3D3D697C7C652E73706C69636528692C31292C652E707573682874297D286F2C6E292C';
wwv_flow_imp.g_varchar2_table(48300) := '722E64656C6179496E697469616C466F63757354696D65723D732E64656C6179496E697469616C466F6375733F767A282866756E6374696F6E28297B7028642829297D29293A7028642829292C692E6164644576656E744C697374656E65722822666F63';
wwv_flow_imp.g_varchar2_table(48301) := '7573696E222C762C2130292C692E6164644576656E744C697374656E657228226D6F757365646F776E222C662C7B636170747572653A21302C706173736976653A21317D292C692E6164644576656E744C697374656E65722822746F7563687374617274';
wwv_flow_imp.g_varchar2_table(48302) := '222C662C7B636170747572653A21302C706173736976653A21317D292C692E6164644576656E744C697374656E65722822636C69636B222C5F2C7B636170747572653A21302C706173736976653A21317D292C692E6164644576656E744C697374656E65';
wwv_flow_imp.g_varchar2_table(48303) := '7228226B6579646F776E222C622C7B636170747572653A21302C706173736976653A21317D292C6E7D2C773D66756E6374696F6E28297B696628722E6163746976652972657475726E20692E72656D6F76654576656E744C697374656E65722822666F63';
wwv_flow_imp.g_varchar2_table(48304) := '7573696E222C762C2130292C692E72656D6F76654576656E744C697374656E657228226D6F757365646F776E222C662C2130292C692E72656D6F76654576656E744C697374656E65722822746F7563687374617274222C662C2130292C692E72656D6F76';
wwv_flow_imp.g_varchar2_table(48305) := '654576656E744C697374656E65722822636C69636B222C5F2C2130292C692E72656D6F76654576656E744C697374656E657228226B6579646F776E222C622C2130292C6E7D2C433D22756E646566696E656422213D747970656F662077696E646F772626';
wwv_flow_imp.g_varchar2_table(48306) := '224D75746174696F6E4F6273657276657222696E2077696E646F773F6E6577204D75746174696F6E4F62736572766572282866756E6374696F6E2865297B76617220743D652E736F6D65282866756E6374696F6E2865297B72657475726E204172726179';
wwv_flow_imp.g_varchar2_table(48307) := '2E66726F6D28652E72656D6F7665644E6F646573292E736F6D65282866756E6374696F6E2865297B72657475726E20653D3D3D722E6D6F7374526563656E746C79466F63757365644E6F64657D29297D29293B7426267028642829297D29293A766F6964';
wwv_flow_imp.g_varchar2_table(48308) := '20302C533D66756E6374696F6E28297B43262628432E646973636F6E6E65637428292C722E616374697665262621722E7061757365642626722E636F6E7461696E6572732E6D6170282866756E6374696F6E2865297B432E6F62736572766528652C7B73';
wwv_flow_imp.g_varchar2_table(48309) := '7562747265653A21302C6368696C644C6973743A21307D297D2929297D3B72657475726E286E3D7B6765742061637469766528297B72657475726E20722E6163746976657D2C6765742070617573656428297B72657475726E20722E7061757365647D2C';
wwv_flow_imp.g_varchar2_table(48310) := '61637469766174653A66756E6374696F6E2865297B696628722E6163746976652972657475726E20746869733B76617220743D6128652C226F6E416374697661746522292C6E3D6128652C226F6E506F7374416374697661746522292C6F3D6128652C22';
wwv_flow_imp.g_varchar2_table(48311) := '636865636B43616E466F6375735472617022293B6F7C7C6828292C722E6163746976653D21302C722E7061757365643D21312C722E6E6F6465466F63757365644265666F726541637469766174696F6E3D692E616374697665456C656D656E742C6E756C';
wwv_flow_imp.g_varchar2_table(48312) := '6C3D3D747C7C7428293B76617220733D66756E6374696F6E28297B6F26266828292C7928292C5328292C6E756C6C3D3D6E7C7C6E28297D3B72657475726E206F3F286F28722E636F6E7461696E6572732E636F6E6361742829292E7468656E28732C7329';
wwv_flow_imp.g_varchar2_table(48313) := '2C74686973293A287328292C74686973297D2C646561637469766174653A66756E6374696F6E2865297B69662821722E6163746976652972657475726E20746869733B76617220743D707A287B6F6E446561637469766174653A732E6F6E446561637469';
wwv_flow_imp.g_varchar2_table(48314) := '766174652C6F6E506F7374446561637469766174653A732E6F6E506F7374446561637469766174652C636865636B43616E52657475726E466F6375733A732E636865636B43616E52657475726E466F6375737D2C65293B636C65617254696D656F757428';
wwv_flow_imp.g_varchar2_table(48315) := '722E64656C6179496E697469616C466F63757354696D6572292C722E64656C6179496E697469616C466F63757354696D65723D766F696420302C7728292C722E6163746976653D21312C722E7061757365643D21312C5328292C66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(48316) := '2C74297B766172206E3D652E696E6465784F662874293B2D31213D3D6E2626652E73706C696365286E2C31292C652E6C656E6774683E302626655B652E6C656E6774682D315D2E756E706175736528297D286F2C6E293B76617220693D6128742C226F6E';
wwv_flow_imp.g_varchar2_table(48317) := '4465616374697661746522292C6C3D6128742C226F6E506F73744465616374697661746522292C633D6128742C22636865636B43616E52657475726E466F63757322292C643D6128742C2272657475726E466F637573222C2272657475726E466F637573';
wwv_flow_imp.g_varchar2_table(48318) := '4F6E4465616374697661746522293B6E756C6C3D3D697C7C6928293B76617220683D66756E6374696F6E28297B767A282866756E6374696F6E28297B64262670286728722E6E6F6465466F63757365644265666F726541637469766174696F6E29292C6E';
wwv_flow_imp.g_varchar2_table(48319) := '756C6C3D3D6C7C7C6C28297D29297D3B72657475726E20642626633F2863286728722E6E6F6465466F63757365644265666F726541637469766174696F6E29292E7468656E28682C68292C74686973293A286828292C74686973297D2C70617573653A66';
wwv_flow_imp.g_varchar2_table(48320) := '756E6374696F6E2865297B696628722E7061757365647C7C21722E6163746976652972657475726E20746869733B76617220743D6128652C226F6E506175736522292C6E3D6128652C226F6E506F7374506175736522293B72657475726E20722E706175';
wwv_flow_imp.g_varchar2_table(48321) := '7365643D21302C6E756C6C3D3D747C7C7428292C7728292C5328292C6E756C6C3D3D6E7C7C6E28292C746869737D2C756E70617573653A66756E6374696F6E2865297B69662821722E7061757365647C7C21722E6163746976652972657475726E207468';
wwv_flow_imp.g_varchar2_table(48322) := '69733B76617220743D6128652C226F6E556E706175736522292C6E3D6128652C226F6E506F7374556E706175736522293B72657475726E20722E7061757365643D21312C6E756C6C3D3D747C7C7428292C6828292C7928292C5328292C6E756C6C3D3D6E';
wwv_flow_imp.g_varchar2_table(48323) := '7C7C6E28292C746869737D2C757064617465436F6E7461696E6572456C656D656E74733A66756E6374696F6E2865297B76617220743D5B5D2E636F6E6361742865292E66696C74657228426F6F6C65616E293B72657475726E20722E636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(48324) := '72733D742E6D6170282866756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F6620653F692E717565727953656C6563746F722865293A657D29292C722E61637469766526266828292C5328292C746869737D7D292E757064';
wwv_flow_imp.g_varchar2_table(48325) := '617465436F6E7461696E6572456C656D656E74732865292C6E7D2C537A3D66756E6374696F6E2865297B72657475726E28302C50432E6A7378292822737667222C7B2E2E2E652C6368696C6472656E3A28302C50432E6A737829282270617468222C7B66';
wwv_flow_imp.g_varchar2_table(48326) := '696C6C52756C653A226576656E6F6464222C643A226D31312E36353720382D342E393520342E3935613120312030203020312D312E3431342D312E3431344C382E383238203820352E32393320342E3436344131203120302031203120362E3730372033';
wwv_flow_imp.g_varchar2_table(48327) := '2E30354C31312E36353720385A227D297D297D3B537A2E64656661756C7450726F70733D7B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223136222C6865696768743A223136227D3B76617220';
wwv_flow_imp.g_varchar2_table(48328) := '787A3D66756E6374696F6E2865297B72657475726E28302C50432E6A7378292822737667222C7B2E2E2E652C6368696C6472656E3A28302C50432E6A737829282270617468222C7B66696C6C52756C653A226576656E6F6464222C643A224D3920313356';
wwv_flow_imp.g_varchar2_table(48329) := '3968346131203120302030203020302D3248395633613120312030203120302D3220307634483361312031203020312030203020326834763461312031203020302030203220305A227D297D297D3B787A2E64656661756C7450726F70733D7B786D6C6E';
wwv_flow_imp.g_varchar2_table(48330) := '733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223136222C6865696768743A223136227D3B766172206B7A3D66756E6374696F6E2865297B72657475726E28302C50432E6A7378292822737667222C7B2E2E';
wwv_flow_imp.g_varchar2_table(48331) := '2E652C6368696C6472656E3A28302C50432E6A737829282270617468222C7B66696C6C52756C653A226576656E6F6464222C643A224D313220367637633020312E312D2E3420312E35352D312E3520312E3535682D3543342E342031342E353520342031';
wwv_flow_imp.g_varchar2_table(48332) := '342E312034203133563668385A6D2D312E3520312E35682D3576342E336330202E36362E3520312E3220312E31313120312E3248392E3339632E363131203020312E3131312D2E353420312E3131312D312E3256372E355A4D31332033682D326C2D312D';
wwv_flow_imp.g_varchar2_table(48333) := '3148364C352033483376312E3568313056335A227D297D297D3B6B7A2E64656661756C7450726F70733D7B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223136222C6865696768743A22313622';
wwv_flow_imp.g_varchar2_table(48334) := '7D3B76617220457A3D66756E6374696F6E2865297B72657475726E28302C50432E6A737873292822737667222C7B2E2E2E652C6368696C6472656E3A5B28302C50432E6A737829282270617468222C7B66696C6C3A2223666666222C7374796C653A7B6D';
wwv_flow_imp.g_varchar2_table(48335) := '6978426C656E644D6F64653A226D756C7469706C79227D2C643A224D30203068313676313648307A227D292C28302C50432E6A737829282270617468222C7B66696C6C3A2223666666222C7374796C653A7B6D6978426C656E644D6F64653A226D756C74';
wwv_flow_imp.g_varchar2_table(48336) := '69706C79227D2C643A224D30203068313676313648307A227D292C28302C50432E6A737829282270617468222C7B643A224D37203348357632683256337A6D34203048397632683256337A4D37203748357632683256377A6D3420304839763268325637';
wwv_flow_imp.g_varchar2_table(48337) := '7A6D2D342034483576326832762D327A6D342030483976326832762D327A222C66696C6C3A2223313631363136227D295D7D297D3B457A2E64656661756C7450726F70733D7B77696474683A223136222C6865696768743A223136222C66696C6C3A226E';
wwv_flow_imp.g_varchar2_table(48338) := '6F6E65222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D3B766172204C7A3D66756E6374696F6E2865297B72657475726E28302C50432E6A7378292822737667222C7B2E2E2E652C6368696C6472656E3A2830';
wwv_flow_imp.g_varchar2_table(48339) := '2C50432E6A737829282270617468222C7B66696C6C52756C653A226576656E6F6464222C636C697052756C653A226576656E6F6464222C643A224D31322E3633372031322E363337762D342E373268312E33363276342E3732316330202E33362D2E3133';
wwv_flow_imp.g_varchar2_table(48340) := '372E3637362D2E3431312E39352D2E3237352E3237352D2E3539312E3431322D2E39352E34313248332E333632632D2E333820302D2E3730332D2E3133322D2E3936372D2E33393641312E33313520312E33313520302030203120322031322E36333856';
wwv_flow_imp.g_varchar2_table(48341) := '332E33363263302D2E33382E3133322D2E3730332E3339362D2E39363753322E393832203220332E333633203268342E35353376312E33363348332E33363376392E32373468392E3237345A4D3134203248392E32386C2D2E30303120312E3336326832';
wwv_flow_imp.g_varchar2_table(48342) := '2E3430384C352E30363520392E3938346C2E39352E393520362E3632322D362E36323276322E34303948313456325A222C66696C6C3A2263757272656E74636F6C6F72227D297D297D3B4C7A2E64656661756C7450726F70733D7B77696474683A223136';
wwv_flow_imp.g_varchar2_table(48343) := '222C6865696768743A223136222C66696C6C3A226E6F6E65222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D3B76617220447A3D66756E6374696F6E2865297B72657475726E28302C50432E6A737829282273';
wwv_flow_imp.g_varchar2_table(48344) := '7667222C7B2E2E2E652C6368696C6472656E3A28302C50432E6A737829282270617468222C7B643A224D332E3631372031312E3939632D2E3133372E3638342D2E33393220312E31392D2E37363520312E3531382D2E3336322E3332382D2E3838322E34';
wwv_flow_imp.g_varchar2_table(48345) := '39322D312E3535382E34393248306C2E3330392D312E35373968312E3236346C312E3531352D372E3634682D2E3931326C2E3330392D312E353739682E3931316C2E3233362D312E313931632E3133372D2E3638352E3338372D312E3139322E37352D31';
wwv_flow_imp.g_varchar2_table(48346) := '2E353243342E3735332E31363420352E323737203020352E393533203068312E3239344C362E393420312E35373948352E3637356C2D2E33323320312E36323368312E3236346C2D2E33303920312E35373948352E3034336C2D312E34323620372E3230';
wwv_flow_imp.g_varchar2_table(48347) := '385A4D352E3630352031312E3032316C332E3032392D342E3135354C372E323820332E32303268322E3037336C2E37303620322E353437682E3137366C312E3639312D322E3534374831346C2D332E30313420342E30353120312E33333820332E373638';
wwv_flow_imp.g_varchar2_table(48348) := '4831302E32356C2D2E3730362D322E36303648392E33374C372E3637382031312E303248352E3630355A222C66696C6C3A2263757272656E74636F6C6F72227D297D297D3B447A2E64656661756C7450726F70733D7B77696474683A223134222C686569';
wwv_flow_imp.g_varchar2_table(48349) := '6768743A223134222C66696C6C3A226E6F6E65222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D3B76617220547A3D66756E6374696F6E2865297B72657475726E28302C50432E6A737873292822737667222C';
wwv_flow_imp.g_varchar2_table(48350) := '7B2E2E2E652C6368696C6472656E3A5B28302C50432E6A737829282270617468222C7B643A224D3136203261313420313420302031203020313420313441313420313420302030203020313620325A6D302032366131322031322030203120312031322D';
wwv_flow_imp.g_varchar2_table(48351) := '31322031322031322030203020312D31322031325A227D292C28302C50432E6A7378292822636972636C65222C7B63783A223136222C63793A2232332E35222C723A22312E35227D292C28302C50432E6A737829282270617468222C7B643A224D313720';
wwv_flow_imp.g_varchar2_table(48352) := '38682D312E3561342E343920342E34392030203020302D342E3520342E35762E356832762D2E3561322E3520322E3520302030203120322E352D322E3548313761322E3520322E3520302030203120302035682D3276342E35683256313761342E352034';
wwv_flow_imp.g_varchar2_table(48353) := '2E3520302030203020302D395A227D292C28302C50432E6A737829282270617468222C7B7374796C653A7B66696C6C3A226E6F6E65227D2C643A224D30203068333276333248307A227D295D7D297D3B547A2E64656661756C7450726F70733D7B786D6C';
wwv_flow_imp.g_varchar2_table(48354) := '6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C76696577426F783A22302030203332203332227D3B76617220497A3D66756E6374696F6E2865297B72657475726E28302C50432E6A737873292822737667222C7B2E2E2E';
wwv_flow_imp.g_varchar2_table(48355) := '652C6368696C6472656E3A5B28302C50432E6A737829282270617468222C7B66696C6C3A2263757272656E74436F6C6F72222C643A224D3238203448313061322E30303620322E3030362030203020302D32203276313461322E30303620322E30303620';
wwv_flow_imp.g_varchar2_table(48356) := '30203020302032203268313861322E30303620322E30303620302030203020322D32563661322E30303620322E3030362030203020302D322D325A6D3020313648313056366831385A227D292C28302C50432E6A737829282270617468222C7B66696C6C';
wwv_flow_imp.g_varchar2_table(48357) := '3A2263757272656E74436F6C6F72222C643A224D313820323648345631366832762D32483461322E30303620322E3030362030203020302D32203276313061322E30303620322E3030362030203020302032203268313461322E30303620322E30303620';
wwv_flow_imp.g_varchar2_table(48358) := '302030203020322D32762D32682D325A227D295D7D297D3B497A2E64656661756C7450726F70733D7B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223136222C6865696768743A223136222C76';
wwv_flow_imp.g_varchar2_table(48359) := '696577426F783A22302030203332203332227D3B766172204D7A3D66756E6374696F6E2865297B72657475726E28302C50432E6A7378292822737667222C7B2E2E2E652C6368696C6472656E3A28302C50432E6A737829282270617468222C7B66696C6C';
wwv_flow_imp.g_varchar2_table(48360) := '52756C653A226576656E6F6464222C643A226D313220342E372D2E372D2E374C3820372E3320342E3720346C2D2E372E374C372E33203820342031312E336C2E372E374C3820382E376C332E3320332E332E372D2E374C382E37203820313220342E375A';
wwv_flow_imp.g_varchar2_table(48361) := '222C66696C6C3A2263757272656E74436F6C6F72227D297D297D3B66756E6374696F6E20417A2865297B636F6E73747B656C656D656E743A742C68656164657250726F76696465723A6E7D3D652C7B676574456C656D656E7449636F6E3A692C67657444';
wwv_flow_imp.g_varchar2_table(48362) := '6F63756D656E746174696F6E5265663A6F2C676574456C656D656E744C6162656C3A732C676574547970654C6162656C3A727D3D6E2C613D732874292C6C3D722874292C633D6F26266F2874292C643D692874293B72657475726E28302C50432E6A7378';
wwv_flow_imp.g_varchar2_table(48363) := '73292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D686561646572222C6368696C6472656E3A5B28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(48364) := '6C2D6865616465722D69636F6E222C6368696C6472656E3A64262628302C50432E6A73782928642C7B77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D297D292C28302C50432E6A7378732928';
wwv_flow_imp.g_varchar2_table(48365) := '22646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6865616465722D6C6162656C73222C6368696C6472656E3A5B28302C50432E6A7378292822646976222C7B7469746C653A6C2C636C6173733A2262696F2D70726F';
wwv_flow_imp.g_varchar2_table(48366) := '706572746965732D70616E656C2D6865616465722D74797065222C6368696C6472656E3A6C7D292C613F28302C50432E6A7378292822646976222C7B7469746C653A612C636C6173733A2262696F2D70726F706572746965732D70616E656C2D68656164';
wwv_flow_imp.g_varchar2_table(48367) := '65722D6C6162656C222C6368696C6472656E3A617D293A6E756C6C5D7D292C28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6865616465722D616374696F6E73222C6368696C647265';
wwv_flow_imp.g_varchar2_table(48368) := '6E3A633F28302C50432E6A737829282261222C7B72656C3A226E6F6F70656E6572222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6865616465722D6C696E6B222C687265663A632C7469746C653A224F70656E20646F63756D';
wwv_flow_imp.g_varchar2_table(48369) := '656E746174696F6E222C7461726765743A225F626C616E6B222C6368696C6472656E3A28302C50432E6A737829284C7A2C7B7D297D293A6E756C6C7D295D7D297D4D7A2E64656661756C7450726F70733D7B786D6C6E733A22687474703A2F2F7777772E';
wwv_flow_imp.g_varchar2_table(48370) := '77332E6F72672F323030302F737667222C77696474683A223136222C6865696768743A223136227D3B636F6E7374204E7A3D28302C41772E713629287B6465736372697074696F6E3A7B7D2C6765744465736372697074696F6E466F7249643A28293D3E';
wwv_flow_imp.g_varchar2_table(48371) := '7B7D7D292C507A3D28302C41772E713629287B6572726F72733A7B7D7D292C4F7A3D28302C41772E713629287B6576656E744275733A6E756C6C7D292C527A3D28302C41772E713629287B6C61796F75743A7B7D2C7365744C61796F75743A28293D3E7B';
wwv_flow_imp.g_varchar2_table(48372) := '7D2C6765744C61796F7574466F724B65793A28293D3E7B7D2C7365744C61796F7574466F724B65793A28293D3E7B7D7D292C467A3D28302C41772E713629287B746F6F6C7469703A7B7D2C676574546F6F6C746970466F7249643A28293D3E7B7D7D293B';
wwv_flow_imp.g_varchar2_table(48373) := '66756E6374696F6E20427A2865297B636F6E73747B666F7249643A742C656C656D656E743A6E7D3D652C693D66756E6374696F6E28652C74297B636F6E73747B676574546F6F6C746970466F7249643A6E7D3D477728467A293B72657475726E206E2865';
wwv_flow_imp.g_varchar2_table(48374) := '2C74297D28742C6E292C6F3D652E76616C75657C7C693B72657475726E206F3F28302C50432E6A73782928567A2C7B2E2E2E652C76616C75653A6F2C666F7249643A577A2874297D293A652E6368696C6472656E7D66756E6374696F6E20567A2865297B';
wwv_flow_imp.g_varchar2_table(48375) := '636F6E73747B666F7249643A742C76616C75653A6E2C706172656E743A692C646972656374696F6E3A6F3D227269676874222C706F736974696F6E3A737D3D652C5B722C615D3D5777282131292C5B6C2C635D3D5777282131293B6C657420643D6E756C';
wwv_flow_imp.g_varchar2_table(48376) := '6C3B636F6E737420683D2477286E756C6C292C753D2477286E756C6C292C703D6173796E6320653D3E7B636F6E737420743D28293D3E61282130293B727C7C647C7C286520696E7374616E63656F66204D6F7573654576656E743F643D73657454696D65';
wwv_flow_imp.g_varchar2_table(48377) := '6F757428742C323030293A287428292C632821302929297D2C673D28293D3E7B61282131292C63282131297D3B6A77282828293D3E7B636F6E73747B63757272656E743A657D3D683B69662821652972657475726E3B636F6E737420743D653D3E7B636F';
wwv_flow_imp.g_varchar2_table(48378) := '6E737420743D646F63756D656E742E616374697665456C656D656E743D3D3D682E63757272656E747C7C646F63756D656E742E616374697665456C656D656E742E636C6F7365737428222E62696F2D70726F706572746965732D70616E656C2D746F6F6C';
wwv_flow_imp.g_varchar2_table(48379) := '74697022293B21727C7C28287B783A652C793A747D293D3E7B636F6E7374206E3D752E63757272656E742C693D682E63757272656E743B72657475726E206E2626287A7A28652C742C692E676574426F756E64696E67436C69656E74526563742829297C';
wwv_flow_imp.g_varchar2_table(48380) := '7C7A7A28652C742C6E2E676574426F756E64696E67436C69656E7452656374282929297D29287B783A652E782C793A652E797D297C7C7426266C7C7C6728297D2C6E3D653D3E7B636F6E73747B72656C617465645461726765743A747D3D653B72262621';
wwv_flow_imp.g_varchar2_table(48381) := '682E63757272656E742E6D61746368657328223A686F7665722229262674262621742E636C6F7365737428222E62696F2D70726F706572746965732D70616E656C2D746F6F6C746970222926266728297D3B72657475726E20646F63756D656E742E6164';
wwv_flow_imp.g_varchar2_table(48382) := '644576656E744C697374656E65722822776865656C222C74292C646F63756D656E742E6164644576656E744C697374656E65722822666F6375736F7574222C6E292C646F63756D656E742E6164644576656E744C697374656E657228226D6F7573656D6F';
wwv_flow_imp.g_varchar2_table(48383) := '7665222C74292C28293D3E7B646F63756D656E742E72656D6F76654576656E744C697374656E65722822776865656C222C74292C646F63756D656E742E72656D6F76654576656E744C697374656E657228226D6F7573656D6F7665222C74292C646F6375';
wwv_flow_imp.g_varchar2_table(48384) := '6D656E742E72656D6F76654576656E744C697374656E65722822666F6375736F7574222C6E297D7D292C5B682E63757272656E742C722C6C5D293B636F6E7374206D3D28293D3E28302C50432E6A737873292822646976222C7B636C6173733A6062696F';
wwv_flow_imp.g_varchar2_table(48385) := '2D70726F706572746965732D70616E656C2D746F6F6C74697020247B6F7D602C726F6C653A22746F6F6C746970222C69643A2262696F2D70726F706572746965732D70616E656C2D746F6F6C746970222C22617269612D6C6162656C6C65646279223A74';
wwv_flow_imp.g_varchar2_table(48386) := '2C7374796C653A737C7C487A28682E63757272656E74292C7265663A752C6F6E436C69636B3A653D3E652E73746F7050726F7061676174696F6E28292C6368696C6472656E3A5B28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D';
wwv_flow_imp.g_varchar2_table(48387) := '70726F706572746965732D70616E656C2D746F6F6C7469702D636F6E74656E74222C6368696C6472656E3A6E7D292C28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D746F6F6C746970';
wwv_flow_imp.g_varchar2_table(48388) := '2D6172726F77227D295D7D293B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D746F6F6C7469702D77726170706572222C746162496E6465783A2230222C7265663A';
wwv_flow_imp.g_varchar2_table(48389) := '682C6F6E4D6F757365456E7465723A702C6F6E4D6F7573654C656176653A28293D3E7B636C65617254696D656F75742864292C643D6E756C6C7D2C6F6E466F6375733A702C6F6E4B6579446F776E3A653D3E7B22457363617065223D3D3D652E636F6465';
wwv_flow_imp.g_varchar2_table(48390) := '26266728297D2C6368696C6472656E3A5B652E6368696C6472656E2C723F693F6243286D28292C692E63757272656E74293A6D28293A6E756C6C5D7D297D66756E6374696F6E207A7A28652C742C6E297B636F6E73747B746F703A692C72696768743A6F';
wwv_flow_imp.g_varchar2_table(48391) := '2C626F74746F6D3A732C6C6566743A727D3D6E3B72657475726E20653E3D722626653C3D6F2626743E3D692626743C3D737D66756E6374696F6E20487A2865297B636F6E737420743D652E676574426F756E64696E67436C69656E745265637428293B72';
wwv_flow_imp.g_varchar2_table(48392) := '657475726E6072696768743A2063616C632831303025202D20247B742E787D7078293B20746F703A20247B742E746F702D31302B227078227D3B607D66756E6374696F6E20577A2865297B72657475726E6062696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(48393) := '656C2D247B657D607D66756E6374696F6E206A7A2865297B636F6E73747B6572726F72733A747D3D477728507A293B72657475726E20745B655D7D66756E6374696F6E20717A28297B636F6E73747B6572726F72733A657D3D477728507A293B72657475';
wwv_flow_imp.g_varchar2_table(48394) := '726E20657D66756E6374696F6E20247A28652C742C6E297B636F6E737420693D4777284F7A293B6E7C7C287B6576656E744275733A6E7D3D69293B636F6E7374206F3D2477282131293B6E2626216F2E63757272656E7426266E2E6F6E28652C74292C6A';
wwv_flow_imp.g_varchar2_table(48395) := '77282828293D3E286E26266F2E63757272656E7426266E2E6F6E28652C74292C6F2E63757272656E743D21302C28293D3E7B6E26266E2E6F666628652C74297D29292C5B742C652C6E5D297D66756E6374696F6E20557A28652C74297B636F6E73747B67';
wwv_flow_imp.g_varchar2_table(48396) := '65744C61796F7574466F724B65793A6E2C7365744C61796F7574466F724B65793A697D3D477728527A293B72657475726E5B6E28652C74292C4B772828743D3E7B6928652C74297D292C5B695D295D7D66756E6374696F6E204B7A2865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(48397) := '20743D247728293B72657475726E206A77282828293D3E7B742E63757272656E743D657D29292C742E63757272656E747D66756E6374696F6E20477A2865297B636F6E73747B6F6E53686F773A747D3D477728527A292C6E3D247728292C6F3D24772821';
wwv_flow_imp.g_varchar2_table(48398) := '31292C733D4B7728286E3D3E7B6E2E69643D3D3D652626287428292C6F2E63757272656E747C7C286F2E63757272656E743D213029297D292C5B655D293B72657475726E206A77282828293D3E7B6F2E63757272656E7426266E2E63757272656E742626';
wwv_flow_imp.g_varchar2_table(48399) := '2828302C692E546E29286E2E63757272656E742E666F6375732926266E2E63757272656E742E666F63757328292C28302C692E546E29286E2E63757272656E742E73656C6563742926266E2E63757272656E742E73656C65637428292C6F2E6375727265';
wwv_flow_imp.g_varchar2_table(48400) := '6E743D2131297D29292C247A282270726F7065727469657350616E656C2E73686F77456E747279222C73292C6E7D66756E6374696F6E20517A28652C742C6E297B636F6E73745B692C6F5D3D5777284743287429292C733D4B77282828293D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(48401) := '737420653D47432874293B65213D3D6926266F2865297D292C5B742C695D293B6A77282828293D3E7B7328297D292C5B735D292C247A282270726F7065727469657350616E656C2E617474616368222C73292C247A282270726F7065727469657350616E';
wwv_flow_imp.g_varchar2_table(48402) := '656C2E646574616368222C73292C6A77282828293D3E7B636F6E737420743D496E74657273656374696F6E4F627365727665723B69662821742972657475726E3B69662821652E63757272656E747C7C21692972657475726E3B636F6E7374206F3D6E65';
wwv_flow_imp.g_varchar2_table(48403) := '7720742828653D3E7B30213D3D692E7363726F6C6C4865696768742626652E666F72456163682828653D3E7B652E696E74657273656374696F6E526174696F3C313F6E282130293A313D3D3D652E696E74657273656374696F6E526174696F26266E2821';
wwv_flow_imp.g_varchar2_table(48404) := '31297D29297D292C7B726F6F743A692C726F6F744D617267696E3A2230707820307078203939393939392520307078222C7468726573686F6C643A5B315D7D293B72657475726E206F2E6F62736572766528652E63757272656E74292C28293D3E7B6F2E';
wwv_flow_imp.g_varchar2_table(48405) := '756E6F62736572766528652E63757272656E74297D7D292C5B652E63757272656E742C692C6E5D297D66756E6374696F6E20597A2865297B636F6E737420743D24772865293B72657475726E20742E63757272656E743D652C4B772828282E2E2E65293D';
wwv_flow_imp.g_varchar2_table(48406) := '3E742E63757272656E74282E2E2E6529292C5B5D297D66756E6374696F6E205A7A2865297B636F6E73747B656C656D656E743A742C656E74726965733A6E3D5B5D2C69643A6F2C6C6162656C3A732C73686F756C644F70656E3A723D21317D3D652C613D';
wwv_flow_imp.g_varchar2_table(48407) := '2477286E756C6C292C5B6C2C635D3D557A285B2267726F757073222C6F2C226F70656E225D2C72292C643D4B77282828293D3E6328213029292C5B635D292C5B682C755D3D5777282131292C5B702C675D3D5777282131293B6A77282828293D3E7B636F';
wwv_flow_imp.g_varchar2_table(48408) := '6E737420653D72657175657374416E696D6174696F6E4672616D65282828293D3E7B636F6E737420653D6E2E66696E642828653D3E7B636F6E73747B69643A742C69734564697465643A6E7D3D652C6F3D474328605B646174612D656E7472792D69643D';
wwv_flow_imp.g_varchar2_table(48409) := '22247B747D225D60293B72657475726E21282128302C692E546E29286E297C7C216F2926266E28474328222E62696F2D70726F706572746965732D70616E656C2D696E707574222C6F29297D29293B752865297D29293B72657475726E28293D3E63616E';
wwv_flow_imp.g_varchar2_table(48410) := '63656C416E696D6174696F6E4672616D652865297D292C5B6E2C755D293B636F6E7374206D3D717A28292C663D6E2E736F6D652828653D3E6D5B652E69645D29293B517A28612C226469762E62696F2D70726F706572746965732D70616E656C2D736372';
wwv_flow_imp.g_varchar2_table(48411) := '6F6C6C2D636F6E7461696E6572222C67293B636F6E737420763D7B2E2E2E477728527A292C6F6E53686F773A647D3B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D';
wwv_flow_imp.g_varchar2_table(48412) := '67726F7570222C22646174612D67726F75702D6964223A2267726F75702D222B6F2C7265663A612C6368696C6472656E3A5B28302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(48413) := '6C2D67726F75702D686561646572222C683F22223A22656D707479222C6C3F226F70656E223A22222C7026266C3F22737469636B79223A2222292C6F6E436C69636B3A28293D3E6328216C292C6368696C6472656E3A5B28302C50432E6A737829282264';
wwv_flow_imp.g_varchar2_table(48414) := '6976222C7B7469746C653A652E746F6F6C7469703F6E756C6C3A732C22646174612D7469746C65223A732C636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D7469746C65222C6368696C6472656E3A';
wwv_flow_imp.g_varchar2_table(48415) := '28302C50432E6A73782928427A2C7B76616C75653A652E746F6F6C7469702C666F7249643A2267726F75702D222B6F2C656C656D656E743A742C706172656E743A612C6368696C6472656E3A737D297D292C28302C50432E6A737873292822646976222C';
wwv_flow_imp.g_varchar2_table(48416) := '7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D627574746F6E73222C6368696C6472656E3A5B28302C50432E6A73782928587A2C7B6564697465643A682C6861734572726F72733A667D292C28';
wwv_flow_imp.g_varchar2_table(48417) := '302C50432E6A7378292822627574746F6E222C7B747970653A22627574746F6E222C7469746C653A22546F67676C652073656374696F6E222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D6275';
wwv_flow_imp.g_varchar2_table(48418) := '74746F6E2062696F2D70726F706572746965732D70616E656C2D6172726F77222C6368696C6472656E3A28302C50432E6A73782928537A2C7B636C6173733A6C3F2262696F2D70726F706572746965732D70616E656C2D6172726F772D646F776E223A22';
wwv_flow_imp.g_varchar2_table(48419) := '62696F2D70726F706572746965732D70616E656C2D6172726F772D7269676874227D297D295D7D295D7D292C28302C50432E6A7378292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D67726F7570';
wwv_flow_imp.g_varchar2_table(48420) := '2D656E7472696573222C6C3F226F70656E223A2222292C6368696C6472656E3A28302C50432E6A73782928527A2E50726F76696465722C7B76616C75653A762C6368696C6472656E3A6E2E6D61702828653D3E7B636F6E73747B636F6D706F6E656E743A';
wwv_flow_imp.g_varchar2_table(48421) := '6E2C69643A697D3D653B72657475726E28302C41772E6E29286E2C7B2E2E2E652C656C656D656E743A742C6B65793A697D297D29297D297D295D7D297D66756E6374696F6E20587A2865297B636F6E73747B6564697465643A742C6861734572726F7273';
wwv_flow_imp.g_varchar2_table(48422) := '3A6E7D3D653B72657475726E206E3F28302C50432E6A7378292822646976222C7B7469746C653A2253656374696F6E20636F6E7461696E7320616E206572726F72222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D646F742062';
wwv_flow_imp.g_varchar2_table(48423) := '696F2D70726F706572746965732D70616E656C2D646F742D2D6572726F72227D293A743F28302C50432E6A7378292822646976222C7B7469746C653A2253656374696F6E20636F6E7461696E732064617461222C636C6173733A2262696F2D70726F7065';
wwv_flow_imp.g_varchar2_table(48424) := '72746965732D70616E656C2D646F74227D293A6E756C6C7D66756E6374696F6E204A7A2865297B636F6E73747B746578743A742C69636F6E3A6E7D3D653B72657475726E28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F';
wwv_flow_imp.g_varchar2_table(48425) := '706572746965732D70616E656C206F70656E222C6368696C6472656E3A28302C50432E6A73787329282273656374696F6E222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D706C616365686F6C646572222C6368696C647265';
wwv_flow_imp.g_varchar2_table(48426) := '6E3A5B6E262628302C50432E6A737829286E2C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D706C616365686F6C6465722D69636F6E227D292C28302C50432E6A737829282270222C7B636C6173733A2262696F2D70726F7065';
wwv_flow_imp.g_varchar2_table(48427) := '72746965732D70616E656C2D706C616365686F6C6465722D74657874222C6368696C6472656E3A747D295D7D297D297D66756E6374696F6E2065482865297B636F6E73747B656C656D656E743A742C666F7249643A6E2C76616C75653A697D3D652C6F3D';
wwv_flow_imp.g_varchar2_table(48428) := '66756E6374696F6E28652C74297B636F6E73747B6765744465736372697074696F6E466F7249643A6E7D3D4777284E7A293B72657475726E206E28652C74297D286E2C74292C733D697C7C6F3B696628732972657475726E28302C50432E6A7378292822';
wwv_flow_imp.g_varchar2_table(48429) := '646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E222C6368696C6472656E3A737D297D636F6E73742074483D28293D3E7B7D2C6E483D6143282828652C74293D3E7B636F6E73747B6F6E49';
wwv_flow_imp.g_varchar2_table(48430) := '6E7075743A6E2C64697361626C65643A692C746F6F6C746970436F6E7461696E65723A6F2C656E61626C65477574746572733A732C76616C75653A722C6F6E4C696E743A613D74482C6F6E506F7075704F70656E3A6C3D74482C706F7075704F70656E3A';
wwv_flow_imp.g_varchar2_table(48431) := '632C636F6E74656E74417474726962757465733A643D7B7D2C686F73744C616E67756167653A683D6E756C6C2C73696E676C654C696E653A753D21317D3D652C703D247728292C5B672C6D5D3D577728292C5B662C765D3D577728727C7C2222293B2166';
wwv_flow_imp.g_varchar2_table(48432) := '756E6374696F6E28652C74297B636F6E73745B6E2C695D3D577728766F69642030293B742E63757272656E743D5577282828293D3E287B666F6375733A743D3E7B653F652E666F6375732874293A28766F696420303D3D3D74262628743D312F30292C69';
wwv_flow_imp.g_varchar2_table(48433) := '287429297D7D29292C5B655D292C6A77282828293D3E7B766F69642030213D3D6E262665262628652E666F637573286E292C6928213129297D292C5B652C6E5D297D28672C74293B636F6E737420623D597A2828653D3E7B6E2865292C762865297D2929';
wwv_flow_imp.g_varchar2_table(48434) := '3B72657475726E206A77282828293D3E7B6C657420653B72657475726E20653D6E6577206F56287B636F6E7461696E65723A702E63757272656E742C6F6E4368616E67653A622C76616C75653A662C6F6E4C696E743A612C636F6E74656E744174747269';
wwv_flow_imp.g_varchar2_table(48435) := '62757465733A642C746F6F6C746970436F6E7461696E65723A6F2C656E61626C65477574746572733A732C686F73744C616E67756167653A682C73696E676C654C696E653A752C6C696E65577261703A21307D292C6D2865292C28293D3E7B61285B5D29';
wwv_flow_imp.g_varchar2_table(48436) := '2C702E63757272656E742E696E6E657248544D4C3D22222C6D286E756C6C297D7D292C5B5D292C6A77282828293D3E7B67262672213D3D66262628672E73657456616C75652872292C76287229297D292C5B725D292C28302C50432E6A73787329282264';
wwv_flow_imp.g_varchar2_table(48437) := '6976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E6572222C633F22706F7075704F70656E223A6E756C6C292C6368696C6472656E3A5B28302C50432E';
wwv_flow_imp.g_varchar2_table(48438) := '6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F725F5F6F70656E2D706F7075702D706C616365686F6C646572222C6368696C6472656E3A224F70656E656420696E20';
wwv_flow_imp.g_varchar2_table(48439) := '656469746F72227D292C28302C50432E6A7378292822646976222C7B6E616D653A652E6E616D652C636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722062696F2D70726F7065727469';
wwv_flow_imp.g_varchar2_table(48440) := '65732D70616E656C2D696E707574222C663F22656469746564223A6E756C6C2C693F2264697361626C6564223A6E756C6C292C7265663A702C6F6E436C69636B3A28293D3E7B742E63757272656E742E666F63757328297D7D292C28302C50432E6A7378';
wwv_flow_imp.g_varchar2_table(48441) := '292822627574746F6E222C7B747970653A22627574746F6E222C7469746C653A224F70656E20706F702D757020656469746F72222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F707570222C6F6E';
wwv_flow_imp.g_varchar2_table(48442) := '436C69636B3A28293D3E6C28226665656C65727322292C6368696C6472656E3A28302C50432E6A73782928497A2C7B7D297D295D7D297D29292C69483D28293D3E7B7D2C6F483D6143282828652C74293D3E7B636F6E73747B636F6E74656E7441747472';
wwv_flow_imp.g_varchar2_table(48443) := '6962757465733A6E2C656E61626C65477574746572733A692C76616C75653A6F2C6F6E496E7075743A732C6F6E4665656C546F67676C653A723D69482C6F6E4C696E743A613D69482C6F6E506F7075704F70656E3A6C3D69482C706C616365686F6C6465';
wwv_flow_imp.g_varchar2_table(48444) := '723A632C706F7075704F70656E3A642C64697361626C65643A682C746F6F6C746970436F6E7461696E65723A752C7661726961626C65733A707D3D652C673D247728292C5B6D2C665D3D577728292C5B762C625D3D5777286F7C7C2222293B2166756E63';
wwv_flow_imp.g_varchar2_table(48445) := '74696F6E28652C74297B636F6E73745B6E2C695D3D577728766F69642030293B742E63757272656E743D5577282828293D3E287B666F6375733A743D3E7B653F652E666F6375732874293A28766F696420303D3D3D74262628743D312F30292C69287429';
wwv_flow_imp.g_varchar2_table(48446) := '297D7D29292C5B655D292C6A77282828293D3E7B766F69642030213D3D6E262665262628652E666F637573286E292C6928213129297D292C5B652C6E5D297D286D2C74293B636F6E7374205F3D597A2828653D3E7B732865292C622865297D29293B7265';
wwv_flow_imp.g_varchar2_table(48447) := '7475726E206A77282828293D3E7B6C657420653B72657475726E20653D6E6577202456287B636F6E7461696E65723A672E63757272656E742C6F6E4368616E67653A5F2C6F6E4B6579446F776E3A743D3E7B696628224261636B737061636522213D3D74';
wwv_flow_imp.g_varchar2_table(48448) := '2E6B65797C7C21652972657475726E3B636F6E7374206E3D652E67657453656C656374696F6E28292C693D6E2E72616E6765735B6E2E6D61696E496E6465785D3B303D3D3D692E66726F6D2626303D3D3D692E746F26267228297D2C6F6E4C696E743A61';
wwv_flow_imp.g_varchar2_table(48449) := '2C706C616365686F6C6465723A632C746F6F6C746970436F6E7461696E65723A752C76616C75653A762C7661726961626C65733A702C657874656E73696F6E733A5B2E2E2E693F5B4D4D28295D3A5B5D2C44492E6C696E655772617070696E675D2C636F';
wwv_flow_imp.g_varchar2_table(48450) := '6E74656E74417474726962757465733A6E7D292C662865292C28293D3E7B61285B5D292C672E63757272656E742E696E6E657248544D4C3D22222C66286E756C6C297D7D292C5B5D292C6A77282828293D3E7B6D26266F213D3D762626286D2E73657456';
wwv_flow_imp.g_varchar2_table(48451) := '616C7565286F292C62286F29297D292C5B6F5D292C6A77282828293D3E7B6D26266D2E7365745661726961626C65732870297D292C5B705D292C6A77282828293D3E7B6D26266D2E736574506C616365686F6C6465722863297D292C5B635D292C28302C';
wwv_flow_imp.g_varchar2_table(48452) := '50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572222C683F2264697361626C6564223A6E756C6C2C643F22706F7075704F70';
wwv_flow_imp.g_varchar2_table(48453) := '656E223A6E756C6C292C6368696C6472656E3A5B28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F725F5F6F70656E2D706F7075702D706C616365686F6C6465';
wwv_flow_imp.g_varchar2_table(48454) := '72222C6368696C6472656E3A224F70656E656420696E20656469746F72227D292C28302C50432E6A7378292822646976222C7B6E616D653A652E6E616D652C636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D696E7075';
wwv_flow_imp.g_varchar2_table(48455) := '74222C763F22656469746564223A6E756C6C292C7265663A672C6F6E436C69636B3A28293D3E7B742E63757272656E742E666F63757328297D7D292C28302C50432E6A7378292822627574746F6E222C7B747970653A22627574746F6E222C7469746C65';
wwv_flow_imp.g_varchar2_table(48456) := '3A224F70656E20706F702D757020656469746F72222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F707570222C6F6E436C69636B3A28293D3E6C28292C6368696C6472656E3A28302C50432E6A73';
wwv_flow_imp.g_varchar2_table(48457) := '782928497A2C7B7D297D295D7D297D29293B66756E6374696F6E2073482865297B636F6E73747B6163746976653A747D3D653B72657475726E20743F28302C50432E6A73782928227370616E222C7B636C6173733A2262696F2D70726F70657274696573';
wwv_flow_imp.g_varchar2_table(48458) := '2D70616E656C2D6665656C2D696E64696361746F72222C6368696C6472656E3A223D227D293A6E756C6C7D636F6E73742072483D28293D3E7B7D3B66756E6374696F6E2061482865297B636F6E73747B6665656C3A743D21312C6163746976653A6E2C64';
wwv_flow_imp.g_varchar2_table(48459) := '697361626C65643A693D21312C6F6E436C69636B3A6F3D72487D3D652C733D60436C69636B20746F20247B6E3F2272656D6F7665223A227365742061227D2064796E616D69632076616C75652077697468204645454C2065787072657373696F6E603B72';
wwv_flow_imp.g_varchar2_table(48460) := '657475726E28302C50432E6A7378292822627574746F6E222C7B747970653A22627574746F6E222C636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D6665656C2D69636F6E222C6E3F22616374697665223A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(48461) := '227265717569726564223D3D3D743F227265717569726564223A226F7074696F6E616C22292C6F6E436C69636B3A653D3E7B6F2865292C652E706F696E746572547970657C7C652E73746F7050726F7061676174696F6E28297D2C64697361626C65643A';
wwv_flow_imp.g_varchar2_table(48462) := '227265717569726564223D3D3D747C7C692C7469746C653A227265717569726564223D3D3D743F224645454C2065787072657373696F6E206973206D616E6461746F7279223A732C6368696C6472656E3A28302C50432E6A73782928447A2C7B7D297D29';
wwv_flow_imp.g_varchar2_table(48463) := '7D636F6E7374206C483D28302C41772E713629287B6F70656E3A28293D3E7B7D2C636C6F73653A28293D3E7B7D2C736F757263653A6E756C6C7D293B66756E6374696F6E2063482865297B652E70726576656E7444656661756C7428292C652E73746F70';
wwv_flow_imp.g_varchar2_table(48464) := '50726F7061676174696F6E28297D636F6E73742064483D28293D3E7B7D2C68483D6143282866756E6374696F6E28652C74297B636F6E73747B636F6E7461696E65723A6E2C636C6173734E616D653A692C64656C6179496E697469616C466F6375733A6F';
wwv_flow_imp.g_varchar2_table(48465) := '2C706F736974696F6E3A732C77696474683A722C6865696768743A612C6F6E436C6F73653A6C2C6F6E506F737441637469766174653A633D64482C6F6E506F7374446561637469766174653A643D64482C72657475726E466F6375733A683D21302C636C';
wwv_flow_imp.g_varchar2_table(48466) := '6F73654F6E4573636170653A753D21302C7469746C653A707D3D652C673D2477286E756C6C292C6D3D2477286E756C6C292C663D747C7C6D2C763D5577282828293D3E66756E6374696F6E2865297B72657475726E22737472696E67223D3D747970656F';
wwv_flow_imp.g_varchar2_table(48467) := '6620653F47432865293A657D286E29292C5B6E5D292C623D28293D3E7B672E63757272656E742626672E63757272656E742E616374697661746528297D3B6C6574205F3D7B7D3B72657475726E20732626285F3D7B2E2E2E5F2C746F703A732E746F702B';
wwv_flow_imp.g_varchar2_table(48468) := '227078222C6C6566743A732E6C6566742B227078227D292C722626285F2E77696474683D722B22707822292C612626285F2E6865696768743D612B22707822292C6A77282828293D3E28662E63757272656E742626662E63757272656E742E6164644576';
wwv_flow_imp.g_varchar2_table(48469) := '656E744C697374656E65722822666F637573696E222C62292C28293D3E7B662E63757272656E742E72656D6F76654576656E744C697374656E65722822666F637573696E222C62297D29292C5B665D292C6A77282828293D3E28662E63757272656E7426';
wwv_flow_imp.g_varchar2_table(48470) := '2628672E63757272656E743D437A28662E63757272656E742C7B636C69636B4F75747369646544656163746976617465733A21302C64656C6179496E697469616C466F6375733A6F2C66616C6C6261636B466F6375733A662E63757272656E742C6F6E50';
wwv_flow_imp.g_varchar2_table(48471) := '6F737441637469766174653A632C6F6E506F7374446561637469766174653A642C72657475726E466F6375734F6E446561637469766174653A687D292C672E63757272656E742E61637469766174652829292C28293D3E672E63757272656E742626672E';
wwv_flow_imp.g_varchar2_table(48472) := '63757272656E742E64656163746976617465282929292C5B665D292C247A282270726F7065727469657350616E656C2E646574616368222C6C292C62432828302C50432E6A7378292822646976222C7B22617269612D6C6162656C223A702C746162496E';
wwv_flow_imp.g_varchar2_table(48473) := '6465783A2D312C7265663A662C6F6E4B6579446F776E3A653D3E7B652E73746F7050726F7061676174696F6E28292C75262622457363617065223D3D3D652E6B657926266C28297D2C726F6C653A226469616C6F67222C636C6173733A52432829282262';
wwv_flow_imp.g_varchar2_table(48474) := '696F2D70726F706572746965732D70616E656C2D706F707570222C69292C7374796C653A5F2C6368696C6472656E3A652E6368696C6472656E7D292C767C7C646F63756D656E742E626F6479297D29293B66756E6374696F6E2075482865297B72657475';
wwv_flow_imp.g_varchar2_table(48475) := '726E20652E636C6F7365737428222E62696F2D70726F706572746965732D70616E656C2D706F70757022297D68482E5469746C653D66756E6374696F6E2865297B636F6E73747B6368696C6472656E3A742C636C6173734E616D653A6E2C647261676761';
wwv_flow_imp.g_varchar2_table(48476) := '626C653A692C656D69743A6F3D28293D3E7B7D2C7469746C653A732C73686F77436C6F7365427574746F6E3A723D21312C636C6F7365427574746F6E546F6F6C7469703A613D22436C6F736520706F707570222C6F6E436C6F73653A6C2C2E2E2E637D3D';
wwv_flow_imp.g_varchar2_table(48477) := '652C643D2477287B7374617274506F736974696F6E3A6E756C6C2C6E6577506F736974696F6E3A6E756C6C7D292C683D247728292C753D247728292C703D28652C74293D3E7B2166756E6374696F6E2865297B652E70726576656E7444656661756C7428';
wwv_flow_imp.g_varchar2_table(48478) := '292C652E73746F7050726F7061676174696F6E28297D2865293B636F6E73747B783A6E2C793A697D3D742C733D7B783A642E63757272656E742E7374617274506F736974696F6E2E782B6E2C793A642E63757272656E742E7374617274506F736974696F';
wwv_flow_imp.g_varchar2_table(48479) := '6E2E792B697D2C723D754828752E63757272656E74293B722E7374796C652E746F703D732E792B227078222C722E7374796C652E6C6566743D732E782B227078222C6F2822647261676F766572222C7B6E6577506F736974696F6E3A732C64656C74613A';
wwv_flow_imp.g_varchar2_table(48480) := '747D297D3B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D706F7075705F5F686561646572222C69262622647261676761626C65222C6E292C7265663A';
wwv_flow_imp.g_varchar2_table(48481) := '752C647261676761626C653A692C6F6E4472616753746172743A653D3E7B2866756E6374696F6E28652C74297B6C6574206E2C692C6F3B66756E6374696F6E20732874297B636F6E737420733D7B783A742E636C69656E74582D692C793A742E636C6965';
wwv_flow_imp.g_varchar2_table(48482) := '6E74592D6F7D3B72657475726E20652E63616C6C286E2C742C73297D66756E6374696F6E207228297B646F63756D656E742E72656D6F76654576656E744C697374656E65722822647261676F766572222C732C2130292C646F63756D656E742E72656D6F';
wwv_flow_imp.g_varchar2_table(48483) := '76654576656E744C697374656E6572282264726167656E746572222C63482C2130292C646F63756D656E742E72656D6F76654576656E744C697374656E6572282264726167656E64222C72292C646F63756D656E742E72656D6F76654576656E744C6973';
wwv_flow_imp.g_varchar2_table(48484) := '74656E6572282264726F70222C6348297D72657475726E2066756E6374696F6E2865297B6E3D746869732C693D652E636C69656E74582C6F3D652E636C69656E74592C652E646174615472616E736665722626652E646174615472616E736665722E7365';
wwv_flow_imp.g_varchar2_table(48485) := '7444726167496D61676528747C7C4B4328273C63616E7661732077696474683D223022206865696768743D223022202F3E27292C302C30292C646F63756D656E742E6164644576656E744C697374656E65722822647261676F766572222C732C2130292C';
wwv_flow_imp.g_varchar2_table(48486) := '646F63756D656E742E6164644576656E744C697374656E6572282264726167656E746572222C63482C2130292C646F63756D656E742E6164644576656E744C697374656E6572282264726167656E64222C72292C646F63756D656E742E6164644576656E';
wwv_flow_imp.g_varchar2_table(48487) := '744C697374656E6572282264726F70222C6348297D7D2928702C682E63757272656E74292865292C652E73746F7050726F7061676174696F6E28293B636F6E737420743D754828752E63757272656E74292E676574426F756E64696E67436C69656E7452';
wwv_flow_imp.g_varchar2_table(48488) := '65637428293B642E63757272656E742E7374617274506F736974696F6E3D7B783A742E6C6566742C793A742E746F707D2C6F282264726167737461727422297D2C6F6E44726167456E643A28293D3E7B642E63757272656E742E6E6577506F736974696F';
wwv_flow_imp.g_varchar2_table(48489) := '6E3D6E756C6C2C6F282264726167656E6422297D2C2E2E2E632C6368696C6472656E3A5B69262628302C50432E6A737873292850432E467261676D656E742C7B6368696C6472656E3A5B28302C50432E6A7378292822646976222C7B7265663A682C636C';
wwv_flow_imp.g_varchar2_table(48490) := '6173733A2262696F2D70726F706572746965732D70616E656C2D706F7075705F5F647261672D70726576696577227D292C28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D706F707570';
wwv_flow_imp.g_varchar2_table(48491) := '5F5F647261672D68616E646C65222C6368696C6472656E3A28302C50432E6A73782928457A2C7B7D297D295D7D292C28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D706F7075705F5F';
wwv_flow_imp.g_varchar2_table(48492) := '7469746C65222C6368696C6472656E3A737D292C742C72262628302C50432E6A7378292822627574746F6E222C7B7469746C653A612C636C6173733A2262696F2D70726F706572746965732D70616E656C2D706F7075705F5F636C6F7365222C6F6E436C';
wwv_flow_imp.g_varchar2_table(48493) := '69636B3A6C2C6368696C6472656E3A28302C50432E6A737829284D7A2C7B7D297D295D7D297D2C68482E426F64793D66756E6374696F6E2865297B636F6E73747B6368696C6472656E3A742C636C6173734E616D653A6E2C2E2E2E697D3D653B72657475';
wwv_flow_imp.g_varchar2_table(48494) := '726E28302C50432E6A7378292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D706F7075705F5F626F6479222C6E292C2E2E2E692C6368696C6472656E3A747D297D2C68482E466F6F7465723D6675';
wwv_flow_imp.g_varchar2_table(48495) := '6E6374696F6E2865297B636F6E73747B6368696C6472656E3A742C636C6173734E616D653A6E2C2E2E2E697D3D653B72657475726E28302C50432E6A7378292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D7061';
wwv_flow_imp.g_varchar2_table(48496) := '6E656C2D706F7075705F5F666F6F746572222C6E292C2E2E2E692C6368696C6472656E3A652E6368696C6472656E7D297D3B636F6E73742070483D3730302C67483D3235303B66756E6374696F6E206D482865297B636F6E73747B656C656D656E743A74';
wwv_flow_imp.g_varchar2_table(48497) := '2C6576656E744275733A6E3D7B6669726528297B7D2C6F6E28297B7D2C6F666628297B7D7D2C706F707570436F6E7461696E65723A697D3D652C6F3D4B7A2874292C5B732C725D3D5777287B7D292C5B612C6C5D3D5777282131292C5B632C645D3D5777';
wwv_flow_imp.g_varchar2_table(48498) := '286E756C6C292C5B682C755D3D5777286E756C6C292C703D28652C74293D3E7B6E2E6669726528226665656C506F7075702E222B652C74297D2C673D4B77282828293D3E212161292C5B615D293B2166756E6374696F6E28652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(48499) := '3D2477282131293B6A77282828293D3E7B6E2E63757272656E743F617C7C702822636C6F73656422293A6E2E63757272656E743D21307D292C74297D28302C5B615D293B636F6E7374206D3D28652C742C6E293D3E7B642865292C722874292C6C282130';
wwv_flow_imp.g_varchar2_table(48500) := '292C75286E292C7028226F70656E22297D2C663D28653D7B7D293D3E7B636F6E73747B69643A747D3D653B74262674213D3D637C7C286C282131292C64286E756C6C29297D2C763D7B6F70656E3A6D2C636C6F73653A662C736F757263653A637D3B7265';
wwv_flow_imp.g_varchar2_table(48501) := '7475726E206A77282828293D3E7B7426266F262674213D3D6F26266628297D292C5B745D292C6A77282828293D3E7B636F6E737420653D28293D3E6728293B72657475726E206E2E6F6E28226665656C506F7075702E5F636C6F7365222C66292C6E2E6F';
wwv_flow_imp.g_varchar2_table(48502) := '6E28226665656C506F7075702E5F6F70656E222C28653D3E7B636F6E73747B656E74727949643A742C706F707570436F6E6669673A6E2C736F75726365456C656D656E743A697D3D653B6D28742C6E2C69297D29292C6E2E6F6E28226665656C506F7075';
wwv_flow_imp.g_varchar2_table(48503) := '702E5F69734F70656E222C65292C28293D3E7B6E2E6F666628226665656C506F7075702E5F636C6F7365222C66292C6E2E6F666628226665656C506F7075702E5F6F70656E222C6D292C6E2E6F666628226665656C506F7075702E5F69734F70656E222C';
wwv_flow_imp.g_varchar2_table(48504) := '65297D7D292C5B6E2C675D292C28302C50432E6A73787329286C482E50726F76696465722C7B76616C75653A762C6368696C6472656E3A5B61262628302C50432E6A7378292866482C7B6F6E436C6F73653A662C636F6E7461696E65723A692C736F7572';
wwv_flow_imp.g_varchar2_table(48505) := '6365456C656D656E743A682C656D69743A702C2E2E2E737D292C652E6368696C6472656E5D7D297D66756E6374696F6E2066482865297B636F6E73747B636F6E7461696E65723A742C69643A6E2C686F73744C616E67756167653A692C6F6E496E707574';
wwv_flow_imp.g_varchar2_table(48506) := '3A6F2C6F6E436C6F73653A732C706F736974696F6E3A722C73696E676C654C696E653A612C736F75726365456C656D656E743A6C2C7469746C653A632C746F6F6C746970436F6E7461696E65723A642C747970653A682C76616C75653A752C7661726961';
wwv_flow_imp.g_varchar2_table(48507) := '626C65733A702C656D69743A677D3D652C6D3D247728292C663D247728292C763D2477282131293B72657475726E206A77282828293D3E286728226F70656E6564222C7B646F6D4E6F64653A662E63757272656E747D292C28293D3E672822636C6F7365';
wwv_flow_imp.g_varchar2_table(48508) := '222C7B646F6D4E6F64653A662E63757272656E747D2929292C5B5D292C6A77282828293D3E7B6D2E63757272656E7426266D2E63757272656E742E666F63757328297D292C5B6D5D292C28302C50432E6A737873292868482C7B636F6E7461696E65723A';
wwv_flow_imp.g_varchar2_table(48509) := '742C636C6173734E616D653A2262696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570222C656D69743A672C706F736974696F6E3A722C7469746C653A632C6F6E436C6F73653A732C72657475726E466F6375733A21312C636C6F';
wwv_flow_imp.g_varchar2_table(48510) := '73654F6E4573636170653A21312C64656C6179496E697469616C466F6375733A21312C6F6E506F7374446561637469766174653A28293D3E7B6C26266C2E666F63757328297D2C6865696768743A67482C77696474683A70482C7265663A662C6368696C';
wwv_flow_imp.g_varchar2_table(48511) := '6472656E3A5B28302C50432E6A737873292868482E5469746C652C7B7469746C653A632C656D69743A672C73686F77436C6F7365427574746F6E3A21302C636C6F7365427574746F6E546F6F6C7469703A225361766520616E6420636C6F7365222C6F6E';
wwv_flow_imp.g_varchar2_table(48512) := '436C6F73653A732C647261676761626C653A21302C6368696C6472656E3A5B226665656C223D3D3D68262628302C50432E6A73787329282261222C7B687265663A2268747470733A2F2F646F63732E63616D756E64612E696F2F646F63732F636F6D706F';
wwv_flow_imp.g_varchar2_table(48513) := '6E656E74732F6D6F64656C65722F6665656C2F776861742D69732D6665656C2F222C7461726765743A225F626C616E6B222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6665656C2D706F7075705F5F7469746C652D6C696E6B';
wwv_flow_imp.g_varchar2_table(48514) := '222C6368696C6472656E3A5B224C6561726E204645454C2065787072657373696F6E73222C28302C50432E6A73782928547A2C7B7D295D7D292C226665656C657273223D3D3D68262628302C50432E6A73787329282261222C7B687265663A2268747470';
wwv_flow_imp.g_varchar2_table(48515) := '733A2F2F646F63732E63616D756E64612E696F2F646F63732F636F6D706F6E656E74732F6D6F64656C65722F666F726D732F636F6E66696775726174696F6E2F666F726D732D636F6E6669672D74656D706C6174696E672D73796E7461782F222C746172';
wwv_flow_imp.g_varchar2_table(48516) := '6765743A225F626C616E6B222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6665656C2D706F7075705F5F7469746C652D6C696E6B222C6368696C6472656E3A5B224C6561726E2074656D706C6174696E67222C28302C50432E';
wwv_flow_imp.g_varchar2_table(48517) := '6A73782928547A2C7B7D295D7D295D7D292C28302C50432E6A7378292868482E426F64792C7B6368696C6472656E3A28302C50432E6A737873292822646976222C7B6F6E4B6579446F776E436170747572653A653D3E7B22457363617065223D3D3D652E';
wwv_flow_imp.g_varchar2_table(48518) := '6B6579262628762E63757272656E743D652E7461726765742E636C6F7365737428222E636D2D656469746F7222292E717565727953656C6563746F7228222E636D2D746F6F6C7469702D6175746F636F6D706C6574652229297D2C6F6E4B6579446F776E';
wwv_flow_imp.g_varchar2_table(48519) := '3A653D3E7B22457363617065223D3D3D652E6B6579262628762E63757272656E747C7C287328292C762E63757272656E743D213129297D2C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6665656C2D706F7075705F5F626F6479';
wwv_flow_imp.g_varchar2_table(48520) := '222C6368696C6472656E3A5B226665656C223D3D3D68262628302C50432E6A737829286F482C7B656E61626C65477574746572733A21302C69643A7648286E292C6E616D653A6E2C6F6E496E7075743A6F2C76616C75653A752C7661726961626C65733A';
wwv_flow_imp.g_varchar2_table(48521) := '702C7265663A6D2C746F6F6C746970436F6E7461696E65723A647D292C226665656C657273223D3D3D68262628302C50432E6A737829286E482C7B69643A7648286E292C636F6E74656E74417474726962757465733A7B22617269612D6C6162656C223A';
wwv_flow_imp.g_varchar2_table(48522) := '637D2C656E61626C65477574746572733A21302C686F73744C616E67756167653A692C6E616D653A6E2C6F6E496E7075743A6F2C76616C75653A752C7265663A6D2C73696E676C654C696E653A612C746F6F6C746970436F6E7461696E65723A647D295D';
wwv_flow_imp.g_varchar2_table(48523) := '7D297D295D7D297D66756E6374696F6E2076482865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D66756E6374696F6E2062482865297B636F6E73747B69643A742C6C6162656C3A6E2C6F6E496E7075743A69';
wwv_flow_imp.g_varchar2_table(48524) := '2C76616C75653A6F2C73776974636865724C6162656C3A732C696E6C696E653A722C6F6E466F6375733A612C6F6E426C75723A6C2C696E7075745265663A632C746F6F6C7469703A647D3D652C5B682C755D3D5777286F293B72657475726E206A772828';
wwv_flow_imp.g_varchar2_table(48525) := '28293D3E7B6F213D3D68262675286F297D292C5B6F5D292C28302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368222C7B696E6C696E653A72';
wwv_flow_imp.g_varchar2_table(48526) := '7D292C6368696C6472656E3A5B28302C50432E6A73782928226C6162656C222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6C6162656C222C666F723A77482874292C6368696C6472656E3A28302C50432E6A73782928427A';
wwv_flow_imp.g_varchar2_table(48527) := '2C7B76616C75653A642C666F7249643A742C656C656D656E743A652E656C656D656E742C6368696C6472656E3A6E7D297D292C28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6669';
wwv_flow_imp.g_varchar2_table(48528) := '656C642D77726170706572222C6368696C6472656E3A5B28302C50432E6A7378732928226C6162656C222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F7377697463686572222C636869';
wwv_flow_imp.g_varchar2_table(48529) := '6C6472656E3A5B28302C50432E6A7378292822696E707574222C7B7265663A632C69643A77482874292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C747970653A22636865636B626F78222C6F6E466F637573';
wwv_flow_imp.g_varchar2_table(48530) := '3A612C6F6E426C75723A6C2C6E616D653A742C6F6E496E7075743A653D3E7B286173796E6328293D3E7B6928216F297D2928292C7528652E7461726765742E76616C7565297D2C636865636B65643A2121687D292C28302C50432E6A7378292822737061';
wwv_flow_imp.g_varchar2_table(48531) := '6E222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F736C69646572227D295D7D292C73262628302C50432E6A737829282270222C7B636C6173733A2262696F2D70726F70657274696573';
wwv_flow_imp.g_varchar2_table(48532) := '2D70616E656C2D746F67676C652D7377697463685F5F6C6162656C222C6368696C6472656E3A737D295D7D295D7D297D66756E6374696F6E205F482865297B636F6E73747B656C656D656E743A742C69643A6E2C6465736372697074696F6E3A692C6C61';
wwv_flow_imp.g_varchar2_table(48533) := '62656C3A6F2C73776974636865724C6162656C3A732C696E6C696E653A722C67657456616C75653A612C73657456616C75653A6C2C6F6E466F6375733A632C6F6E426C75723A642C746F6F6C7469703A687D3D652C753D612874293B72657475726E2830';
wwv_flow_imp.g_varchar2_table(48534) := '2C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D656E7472792062696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682D656E747279222C22646174612D65';
wwv_flow_imp.g_varchar2_table(48535) := '6E7472792D6964223A6E2C6368696C6472656E3A5B28302C50432E6A7378292862482C7B69643A6E2C6C6162656C3A6F2C76616C75653A752C6F6E496E7075743A6C2C6F6E466F6375733A632C6F6E426C75723A642C73776974636865724C6162656C3A';
wwv_flow_imp.g_varchar2_table(48536) := '732C696E6C696E653A722C746F6F6C7469703A682C656C656D656E743A747D292C28302C50432E6A7378292865482C7B666F7249643A6E2C656C656D656E743A742C76616C75653A697D295D7D297D66756E6374696F6E2079482865297B72657475726E';
wwv_flow_imp.g_varchar2_table(48537) := '206526262121652E636865636B65647D66756E6374696F6E2077482865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D66756E6374696F6E2043482865297B636F6E73747B6465626F756E63653A742C646973';
wwv_flow_imp.g_varchar2_table(48538) := '61626C65643A6E2C646973706C61794C6162656C3A693D21302C69643A6F2C696E7075745265663A732C6C6162656C3A722C6D61783A612C6D696E3A6C2C6F6E496E7075743A632C737465703A642C76616C75653A683D22222C6F6E466F6375733A752C';
wwv_flow_imp.g_varchar2_table(48539) := '6F6E426C75723A707D3D652C5B672C6D5D3D57772868292C663D5577282828293D3E742828653D3E7B652E76616C69646974792E76616C696426266328652E76616C75653F7061727365466C6F617428652E76616C7565293A766F69642030297D292929';
wwv_flow_imp.g_varchar2_table(48540) := '2C5B632C745D293B72657475726E206A77282828293D3E7B68213D3D6726266D2868297D292C5B685D292C28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6E756D6265726669656C';
wwv_flow_imp.g_varchar2_table(48541) := '64222C6368696C6472656E3A5B69262628302C50432E6A73782928226C6162656C222C7B666F723A6B48286F292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6C6162656C222C6368696C6472656E3A727D292C28302C50432E';
wwv_flow_imp.g_varchar2_table(48542) := '6A7378292822696E707574222C7B69643A6B48286F292C7265663A732C747970653A226E756D626572222C6E616D653A6F2C7370656C6C436865636B3A2266616C7365222C6175746F436F6D706C6574653A226F6666222C64697361626C65643A6E2C63';
wwv_flow_imp.g_varchar2_table(48543) := '6C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C6D61783A612C6D696E3A6C2C6F6E496E7075743A653D3E7B6628652E746172676574292C6D28652E7461726765742E76616C7565297D2C6F6E466F6375733A752C6F';
wwv_flow_imp.g_varchar2_table(48544) := '6E426C75723A702C737465703A642C76616C75653A677D295D7D297D66756E6374696F6E2053482865297B636F6E73747B6465626F756E63653A742C6465736372697074696F6E3A6E2C64697361626C65643A6F2C656C656D656E743A732C6765745661';
wwv_flow_imp.g_varchar2_table(48545) := '6C75653A722C69643A612C6C6162656C3A6C2C6D61783A632C6D696E3A642C73657456616C75653A682C737465703A752C6F6E466F6375733A702C6F6E426C75723A672C76616C69646174653A6D7D3D652C663D6A7A2861292C5B762C625D3D5777286E';
wwv_flow_imp.g_varchar2_table(48546) := '756C6C293B6C6574205F3D722873293B6A77282828293D3E7B69662828302C692E546E29286D29297B636F6E737420653D6D285F297C7C6E756C6C3B622865297D7D292C5B5F2C6D5D293B636F6E737420793D667C7C763B72657475726E28302C50432E';
wwv_flow_imp.g_varchar2_table(48547) := '6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D656E747279222C793F226861732D6572726F72223A2222292C22646174612D656E7472792D6964223A612C6368696C6472656E3A5B28';
wwv_flow_imp.g_varchar2_table(48548) := '302C50432E6A7378292843482C7B6465626F756E63653A742C64697361626C65643A6F2C69643A612C6C6162656C3A6C2C6F6E466F6375733A702C6F6E426C75723A672C6F6E496E7075743A653D3E7B6C657420743D6E756C6C3B28302C692E546E2928';
wwv_flow_imp.g_varchar2_table(48549) := '6D29262628743D6D2865297C7C6E756C6C292C6828652C74292C622874297D2C6D61783A632C6D696E3A642C737465703A752C76616C75653A5F7D2C73292C79262628302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F7065';
wwv_flow_imp.g_varchar2_table(48550) := '72746965732D70616E656C2D6572726F72222C6368696C6472656E3A797D292C28302C50432E6A7378292865482C7B666F7249643A612C656C656D656E743A732C76616C75653A6E7D295D7D297D66756E6374696F6E2078482865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(48551) := '6526262121652E76616C75657D66756E6374696F6E206B482865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D636F6E73742045483D28293D3E7B7D2C4C483D2844483D66756E6374696F6E2865297B636F6E';
wwv_flow_imp.g_varchar2_table(48552) := '73747B6465626F756E63653A742C69643A6E2C656C656D656E743A6F2C6C6162656C3A732C686F73744C616E67756167653A722C6F6E496E7075743A612C6F6E4572726F723A6C2C706C616365686F6C6465723A632C6665656C3A642C76616C75653A68';
wwv_flow_imp.g_varchar2_table(48553) := '3D22222C64697361626C65643A753D21312C7661726961626C65733A702C73696E676C654C696E653A672C746F6F6C746970436F6E7461696E65723A6D2C4F7074696F6E616C436F6D706F6E656E743A663D54482C746F6F6C7469703A767D3D652C5B62';
wwv_flow_imp.g_varchar2_table(48554) := '2C5F5D3D57772868292C793D477A286E292C773D247728292C433D28302C692E4B67292862292626622E7374617274735769746828223D22297C7C227265717569726564223D3D3D642C533D28302C692E4B67292862292626622E737461727473576974';
wwv_flow_imp.g_varchar2_table(48555) := '6828223D22293F622E737562737472696E672831293A622C5B782C6B5D3D577728766F69642030292C7B6F70656E3A452C736F757263653A4C7D3D4777286C48292C443D4C3D3D3D6E2C543D28653D30293D3E7B636F6E737420743D772E63757272656E';
wwv_flow_imp.g_varchar2_table(48556) := '742E636F6E7461696E7328646F63756D656E742E616374697665456C656D656E74293F646F63756D656E742E616374697665456C656D656E742E73656C656374696F6E53746172743A312F303B6B28742B65297D2C493D5577282828293D3E742828653D';
wwv_flow_imp.g_varchar2_table(48557) := '3E7B612865297D2929292C5B612C745D292C4D3D653D3E7B5F2865292C4928766F696420303D3D3D657C7C22223D3D3D657C7C223D223D3D3D653F766F696420303A65297D2C413D597A282828293D3E7B22726571756972656422213D3D6426264D2843';
wwv_flow_imp.g_varchar2_table(48558) := '3F533A223D222B62297D29292C4E3D653D3E7B43262628653D223D222B65292C65213D3D622626284D2865292C2143262628302C692E4B67292865292626652E7374617274735769746828223D2229262654282D3129297D2C503D597A2828653D3E7B65';
wwv_flow_imp.g_varchar2_table(48559) := '2626652E6C656E6774683F6C2822556E7061727361626C65204645454C2065787072657373696F6E2E22293A6C28766F69642030297D29292C4F3D28653D226665656C22293D3E7B636F6E737420743D7B69643A6E2C686F73744C616E67756167653A72';
wwv_flow_imp.g_varchar2_table(48560) := '2C6F6E496E7075743A4E2C706F736974696F6E3A4D4828772E63757272656E74292C73696E676C654C696E653A672C7469746C653A4148286F2C73292C746F6F6C746970436F6E7461696E65723A6D2C747970653A652C76616C75653A532C7661726961';
wwv_flow_imp.g_varchar2_table(48561) := '626C65733A707D3B45286E2C742C792E63757272656E74297D3B72657475726E206A77282828293D3E7B766F69642030213D3D78262628792E63757272656E742E666F6375732878292C6B28766F6964203029297D292C5B785D292C6A77282828293D3E';
wwv_flow_imp.g_varchar2_table(48562) := '7B68213D3D6226264D28687C7C28433F223D223A222229297D292C5B685D292C6A77282828293D3E7B636F6E737420653D653D3E7B432626652E636C6970626F617264446174612E7365744461746128226170706C69636174696F6E2F4645454C222C65';
wwv_flow_imp.g_varchar2_table(48563) := '2E636C6970626F617264446174612E676574446174612822746578742229297D2C743D653D3E7B437C7C447C7C652E636C6970626F617264446174612E6765744461746128226170706C69636174696F6E2F4645454C2229262673657454696D656F7574';
wwv_flow_imp.g_varchar2_table(48564) := '282828293D3E7B4128292C5428297D29297D3B72657475726E20772E63757272656E742E6164644576656E744C697374656E65722822636F7079222C65292C772E63757272656E742E6164644576656E744C697374656E65722822637574222C65292C77';
wwv_flow_imp.g_varchar2_table(48565) := '2E63757272656E742E6164644576656E744C697374656E657228227061737465222C74292C28293D3E7B772E63757272656E742E72656D6F76654576656E744C697374656E65722822636F7079222C65292C772E63757272656E742E72656D6F76654576';
wwv_flow_imp.g_varchar2_table(48566) := '656E744C697374656E65722822637574222C65292C772E63757272656E742E72656D6F76654576656E744C697374656E657228227061737465222C74297D7D292C5B772C432C412C545D292C28302C50432E6A737873292822646976222C7B636C617373';
wwv_flow_imp.g_varchar2_table(48567) := '3A52432829282262696F2D70726F706572746965732D70616E656C2D6665656C2D656E747279222C7B226665656C2D616374697665223A437D292C6368696C6472656E3A5B28302C50432E6A7378732928226C6162656C222C7B666F723A4948286E292C';
wwv_flow_imp.g_varchar2_table(48568) := '636C6173733A2262696F2D70726F706572746965732D70616E656C2D6C6162656C222C6F6E436C69636B3A28293D3E5428292C6368696C6472656E3A5B28302C50432E6A73782928427A2C7B76616C75653A762C666F7249643A6E2C656C656D656E743A';
wwv_flow_imp.g_varchar2_table(48569) := '652E656C656D656E742C6368696C6472656E3A737D292C28302C50432E6A7378292861482C7B6C6162656C3A732C6665656C3A642C6F6E436C69636B3A412C6163746976653A437D295D7D292C28302C50432E6A737873292822646976222C7B636C6173';
wwv_flow_imp.g_varchar2_table(48570) := '733A2262696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E6572222C7265663A772C6368696C6472656E3A5B28302C50432E6A7378292873482C7B6163746976653A432C64697361626C65643A226F7074696F6E616C2221';
wwv_flow_imp.g_varchar2_table(48571) := '3D3D647C7C752C6F6E436C69636B3A417D292C433F28302C50432E6A737829286F482C7B6E616D653A6E2C6F6E496E7075743A4E2C636F6E74656E74417474726962757465733A7B69643A4948286E292C22617269612D6C6162656C223A737D2C646973';
wwv_flow_imp.g_varchar2_table(48572) := '61626C65643A752C706F7075704F70656E3A442C6F6E4665656C546F67676C653A28293D3E7B4128292C54282130297D2C6F6E4C696E743A502C6F6E506F7075704F70656E3A4F2C706C616365686F6C6465723A632C76616C75653A532C766172696162';
wwv_flow_imp.g_varchar2_table(48573) := '6C65733A702C7265663A792C746F6F6C746970436F6E7461696E65723A6D7D293A28302C50432E6A73782928662C7B2E2E2E652C706F7075704F70656E3A442C6F6E496E7075743A4E2C636F6E74656E74417474726962757465733A7B69643A4948286E';
wwv_flow_imp.g_varchar2_table(48574) := '292C22617269612D6C6162656C223A737D2C76616C75653A622C7265663A792C6F6E506F7075704F70656E3A4F2C636F6E7461696E65725265663A777D295D7D295D7D297D2C66756E6374696F6E2865297B636F6E73747B69643A747D3D652C7B636C6F';
wwv_flow_imp.g_varchar2_table(48575) := '73653A6E7D3D4777286C48292C693D597A286E293B72657475726E206A77282828293D3E28293D3E7B69287B69643A747D297D292C5B5D292C28302C50432E6A7378292844482C7B2E2E2E657D297D293B7661722044483B636F6E73742054483D614328';
wwv_flow_imp.g_varchar2_table(48576) := '2828652C74293D3E7B636F6E73747B69643A6E2C64697361626C65643A692C6F6E496E7075743A6F2C76616C75653A732C6F6E466F6375733A722C6F6E426C75723A612C706C616365686F6C6465723A6C7D3D652C633D247728293B72657475726E2074';
wwv_flow_imp.g_varchar2_table(48577) := '2E63757272656E743D7B666F6375733A653D3E7B636F6E737420743D632E63757272656E743B74262628742E666F63757328292C226E756D626572223D3D747970656F662065262628653E732E6C656E677468262628653D732E6C656E677468292C742E';
wwv_flow_imp.g_varchar2_table(48578) := '73657453656C656374696F6E52616E676528652C652929297D7D2C28302C50432E6A7378292822696E707574222C7B69643A4948286E292C747970653A2274657874222C7265663A632C6E616D653A6E2C7370656C6C436865636B3A2266616C7365222C';
wwv_flow_imp.g_varchar2_table(48579) := '6175746F436F6D706C6574653A226F6666222C64697361626C65643A692C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C6F6E496E7075743A653D3E6F28652E7461726765742E76616C7565292C6F6E466F6375';
wwv_flow_imp.g_varchar2_table(48580) := '733A722C6F6E426C75723A612C706C616365686F6C6465723A6C2C76616C75653A737C7C22227D297D29293B66756E6374696F6E2049482865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D66756E6374696F';
wwv_flow_imp.g_varchar2_table(48581) := '6E204D482865297B636F6E73747B746F703A742C6C6566743A6E7D3D652E676574426F756E64696E67436C69656E745265637428293B72657475726E7B6C6566743A6E2D70482D32302C746F703A747D7D66756E6374696F6E20414828652C74297B6C65';
wwv_flow_imp.g_varchar2_table(48582) := '74206E3D22223B72657475726E20652626652E747970652626286E3D60247B652E747970657D202F2060292C60247B6E7D247B747D607D6143282828652C74293D3E7B636F6E73747B69643A6E2C6465626F756E63653A692C64697361626C65643A6F2C';
wwv_flow_imp.g_varchar2_table(48583) := '6F6E496E7075743A732C76616C75653A722C6D696E3A612C6D61783A6C2C737465703A632C6F6E466F6375733A642C6F6E426C75723A687D3D652C753D247728293B72657475726E20742E63757272656E743D7B666F6375733A653D3E7B636F6E737420';
wwv_flow_imp.g_varchar2_table(48584) := '743D752E63757272656E743B74262628742E666F63757328292C226E756D626572223D3D747970656F662065262665213D3D312F30262628653E722E6C656E677468262628653D722E6C656E677468292C742E73657453656C656374696F6E52616E6765';
wwv_flow_imp.g_varchar2_table(48585) := '28652C652929297D7D2C28302C50432E6A7378292843482C7B69643A6E2C6465626F756E63653A692C64697361626C65643A6F2C646973706C61794C6162656C3A21312C696E7075745265663A752C6D61783A6C2C6D696E3A612C6F6E496E7075743A73';
wwv_flow_imp.g_varchar2_table(48586) := '2C737465703A632C76616C75653A722C6F6E466F6375733A642C6F6E426C75723A687D297D29292C6143282828652C74293D3E7B636F6E73747B69643A6E2C64697361626C65643A692C6F6E496E7075743A6F2C76616C75653A732C6F6E466F6375733A';
wwv_flow_imp.g_varchar2_table(48587) := '722C6F6E426C75723A612C706C616365686F6C6465723A6C7D3D652C633D247728293B72657475726E20742E63757272656E743D7B666F6375733A28293D3E7B636F6E737420653D632E63757272656E743B65262628652E666F63757328292C652E7365';
wwv_flow_imp.g_varchar2_table(48588) := '7453656C656374696F6E52616E676528302C3029297D7D2C28302C50432E6A73782928227465787461726561222C7B69643A4948286E292C747970653A2274657874222C7265663A632C6E616D653A6E2C7370656C6C436865636B3A2266616C7365222C';
wwv_flow_imp.g_varchar2_table(48589) := '6175746F436F6D706C6574653A226F6666222C64697361626C65643A692C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C6F6E496E7075743A653D3E6F28652E7461726765742E76616C7565292C6F6E466F6375';
wwv_flow_imp.g_varchar2_table(48590) := '733A722C6F6E426C75723A612C706C616365686F6C6465723A6C2C76616C75653A737C7C22222C22646174612D6772616D6D223A2266616C7365227D297D29292C6143282828652C74293D3E7B636F6E73747B69643A6E2C6F6E496E7075743A692C7661';
wwv_flow_imp.g_varchar2_table(48591) := '6C75653A6F2C6F6E466F6375733A732C6F6E426C75723A722C73776974636865724C6162656C3A617D3D652C6C3D247728293B72657475726E20742E63757272656E743D7B666F6375733A28293D3E7B636F6E737420653D6C2E63757272656E743B6526';
wwv_flow_imp.g_varchar2_table(48592) := '26652E666F63757328297D7D2C28302C50432E6A7378292862482C7B69643A6E2C76616C75653A6F2C696E7075745265663A6C2C6F6E496E7075743A692C6F6E466F6375733A732C6F6E426C75723A722C73776974636865724C6162656C3A617D297D29';
wwv_flow_imp.g_varchar2_table(48593) := '292C6143282828652C74293D3E7B636F6E73747B69643A6E2C64697361626C65643A692C6F6E496E7075743A6F2C76616C75653A732C6F6E466F6375733A722C6F6E426C75723A617D3D652C6C3D247728293B72657475726E20742E63757272656E743D';
wwv_flow_imp.g_varchar2_table(48594) := '7B666F6375733A28293D3E7B636F6E737420653D6C2E63757272656E743B652626652E666F63757328297D7D2C28302C50432E6A7378292822696E707574222C7B7265663A6C2C69643A4948286E292C6E616D653A6E2C6F6E466F6375733A722C6F6E42';
wwv_flow_imp.g_varchar2_table(48595) := '6C75723A612C747970653A22636865636B626F78222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C6F6E4368616E67653A287B7461726765743A657D293D3E7B6F28652E636865636B6564297D2C636865636B';
wwv_flow_imp.g_varchar2_table(48596) := '65643A732C64697361626C65643A697D297D29293B636F6E7374204E483D7B7D2C50483D7B7D2C4F483D7B7D3B66756E6374696F6E2052482865297B636F6E73747B656C656D656E743A742C68656164657250726F76696465723A6E2C706C616365686F';
wwv_flow_imp.g_varchar2_table(48597) := '6C64657250726F76696465723A6F2C67726F7570733A732C6C61796F7574436F6E6669673A722C6C61796F75744368616E6765643A612C6465736372697074696F6E436F6E6669673A6C2C6465736372697074696F6E4C6F616465643A632C746F6F6C74';
wwv_flow_imp.g_varchar2_table(48598) := '6970436F6E6669673A642C746F6F6C7469704C6F616465643A682C6665656C506F707570436F6E7461696E65723A752C6576656E744275733A707D3D652C5B672C6D5D3D5777284648287229293B2166756E6374696F6E28652C74297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(48599) := '3D2477282131293B7177282828293D3E7B6966286E2E63757272656E742972657475726E2828293D3E7B636F6E737420653D46482872293B6D2865297D2928293B6E2E63757272656E743D21307D292C74297D28302C5B725D292C6A77282828293D3E7B';
wwv_flow_imp.g_varchar2_table(48600) := '2266756E6374696F6E223D3D747970656F6620612626612867297D292C5B672C615D293B636F6E737420663D7B6C61796F75743A672C7365744C61796F75743A6D2C6765744C61796F7574466F724B65793A28652C74293D3E28302C692E4A742928672C';
wwv_flow_imp.g_varchar2_table(48601) := '652C74292C7365744C61796F7574466F724B65793A28652C74293D3E7B636F6E7374206E3D28302C692E6B7029287B7D2C67293B28302C692E685A29286E2C652C74292C6D286E297D7D2C763D5577282828293D3E66756E6374696F6E28653D7B7D297B';
wwv_flow_imp.g_varchar2_table(48602) := '72657475726E7B2E2E2E50482C2E2E2E657D7D286C29292C5B6C5D293B6A77282828293D3E7B2266756E6374696F6E223D3D747970656F6620632626632876297D292C5B762C635D293B636F6E737420623D7B6465736372697074696F6E3A762C676574';
wwv_flow_imp.g_varchar2_table(48603) := '4465736372697074696F6E466F7249643A28652C74293D3E765B655D2626765B655D2874297D2C5F3D5577282828293D3E66756E6374696F6E28653D7B7D297B72657475726E7B2E2E2E4F482C2E2E2E657D7D286429292C5B645D293B6A77282828293D';
wwv_flow_imp.g_varchar2_table(48604) := '3E7B2266756E6374696F6E223D3D747970656F662068262668285F297D292C5B5F2C685D293B636F6E737420793D7B746F6F6C7469703A5F2C676574546F6F6C746970466F7249643A28652C74293D3E5F5B655D26265F5B655D2874297D2C5B772C435D';
wwv_flow_imp.g_varchar2_table(48605) := '3D5777287B7D293B247A282270726F7065727469657350616E656C2E7365744572726F7273222C28287B6572726F72733A657D293D3E43286529292C70293B636F6E737420533D7B6572726F72733A777D2C783D7B6576656E744275733A707D2C6B3D7B';
wwv_flow_imp.g_varchar2_table(48606) := '656C656D656E743A747D3B72657475726E206F262621743F28302C50432E6A737829284A7A2C7B2E2E2E6F2E676574456D70747928297D293A6F262628302C692E6379292874293F28302C50432E6A737829284A7A2C7B2E2E2E6F2E6765744D756C7469';
wwv_flow_imp.g_varchar2_table(48607) := '706C6528297D293A28302C50432E6A73782928527A2E50726F76696465722C7B76616C75653A6B2C6368696C6472656E3A28302C50432E6A73782928507A2E50726F76696465722C7B76616C75653A532C6368696C6472656E3A28302C50432E6A737829';
wwv_flow_imp.g_varchar2_table(48608) := '284E7A2E50726F76696465722C7B76616C75653A622C6368696C6472656E3A28302C50432E6A73782928467A2E50726F76696465722C7B76616C75653A792C6368696C6472656E3A28302C50432E6A73782928527A2E50726F76696465722C7B76616C75';
wwv_flow_imp.g_varchar2_table(48609) := '653A662C6368696C6472656E3A28302C50432E6A737829284F7A2E50726F76696465722C7B76616C75653A782C6368696C6472656E3A28302C50432E6A737829286D482C7B656C656D656E743A742C6576656E744275733A702C706F707570436F6E7461';
wwv_flow_imp.g_varchar2_table(48610) := '696E65723A752C6368696C6472656E3A28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C222C6368696C6472656E3A5B28302C50432E6A73782928417A2C7B656C656D656E743A742C68';
wwv_flow_imp.g_varchar2_table(48611) := '656164657250726F76696465723A6E7D292C28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D7363726F6C6C2D636F6E7461696E6572222C6368696C6472656E3A732E6D61702828653D';
wwv_flow_imp.g_varchar2_table(48612) := '3E7B636F6E73747B636F6D706F6E656E743A6E3D5A7A2C69643A697D3D653B72657475726E28302C41772E6E29286E2C7B2E2E2E652C6B65793A692C656C656D656E743A747D297D29297D295D7D297D297D297D297D297D297D297D297D66756E637469';
wwv_flow_imp.g_varchar2_table(48613) := '6F6E20464828653D7B7D2C743D4E48297B72657475726E7B2E2E2E742C2E2E2E657D7D66756E6374696F6E20424828652C74297B72657475726E20743D747C7C7B7D2C652E7265706C616365282F7B285B5E7D5D2B297D2F672C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(48614) := '652C6E297B72657475726E20745B6E5D7C7C227B222B6E2B227D227D29297D66756E6374696F6E2056482865297B636F6E73747B656C656D656E743A742C656E74726965733A6E3D5B5D2C69643A6F2C6C6162656C3A732C6F70656E3A722C72656D6F76';
wwv_flow_imp.g_varchar2_table(48615) := '653A612C7472616E736C6174653A6C3D42487D3D652C5B632C645D3D57772872292C7B6F6E53686F773A687D3D477728527A292C753D7B2E2E2E477728527A292C6F6E53686F773A4B77282828293D3E7B64282130292C28302C692E546E292868292626';
wwv_flow_imp.g_varchar2_table(48616) := '6828297D292C5B682C645D297D2C703D6C28223C656D7074793E22293B72657475726E28302C50432E6A737873292822646976222C7B22646174612D656E7472792D6964223A6F2C636C6173733A52432829282262696F2D70726F706572746965732D70';
wwv_flow_imp.g_varchar2_table(48617) := '616E656C2D636F6C6C61707369626C652D656E747279222C633F226F70656E223A2222292C6368696C6472656E3A5B28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D636F6C6C6170';
wwv_flow_imp.g_varchar2_table(48618) := '7369626C652D656E7472792D686561646572222C6F6E436C69636B3A28293D3E64282163292C6368696C6472656E3A5B28302C50432E6A7378292822646976222C7B7469746C653A737C7C702C636C6173733A52432829282262696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(48619) := '6965732D70616E656C2D636F6C6C61707369626C652D656E7472792D6865616465722D7469746C65222C2173262622656D70747922292C6368696C6472656E3A737C7C707D292C28302C50432E6A7378292822627574746F6E222C7B747970653A226275';
wwv_flow_imp.g_varchar2_table(48620) := '74746F6E222C7469746C653A6C2822546F67676C65206C697374206974656D22292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6172726F77202062696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C';
wwv_flow_imp.g_varchar2_table(48621) := '652D656E7472792D6172726F77222C6368696C6472656E3A28302C50432E6A73782928537A2C7B636C6173733A633F2262696F2D70726F706572746965732D70616E656C2D6172726F772D646F776E223A2262696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(48622) := '656C2D6172726F772D7269676874227D297D292C613F28302C50432E6A7378292822627574746F6E222C7B747970653A22627574746F6E222C7469746C653A6C282244656C657465206974656D22292C636C6173733A2262696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(48623) := '732D70616E656C2D72656D6F76652D656E747279222C6F6E436C69636B3A612C6368696C6472656E3A28302C50432E6A737829286B7A2C7B7D297D293A6E756C6C5D7D292C28302C50432E6A7378292822646976222C7B636C6173733A52432829282262';
wwv_flow_imp.g_varchar2_table(48624) := '696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573222C633F226F70656E223A2222292C6368696C6472656E3A28302C50432E6A73782928527A2E50726F76696465722C7B76616C75653A75';
wwv_flow_imp.g_varchar2_table(48625) := '2C6368696C6472656E3A6E2E6D61702828653D3E7B636F6E73747B636F6D706F6E656E743A6E2C69643A697D3D653B72657475726E28302C41772E6E29286E2C7B2E2E2E652C656C656D656E743A742C6B65793A697D297D29297D297D295D7D297D6675';
wwv_flow_imp.g_varchar2_table(48626) := '6E6374696F6E207A482865297B636F6E73747B6175746F466F637573456E7472793A742C6175746F4F70656E3A6E2C7472616E736C6174653A6F3D42487D3D653B72657475726E206A77282828293D3E7B6966286E262674297B636F6E737420653D4743';
wwv_flow_imp.g_varchar2_table(48627) := '28605B646174612D656E7472792D69643D22247B747D225D60292C6E3D474328222E62696F2D70726F706572746965732D70616E656C2D696E707574222C65293B6E26262828302C692E546E29286E2E73656C656374293F6E2E73656C65637428293A28';
wwv_flow_imp.g_varchar2_table(48628) := '302C692E546E29286E2E666F6375732926266E2E666F63757328292C6E2E7363726F6C6C496E746F566965772829297D7D292C5B6E2C745D292C28302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D7061';
wwv_flow_imp.g_varchar2_table(48629) := '6E656C2D6C6973742D6974656D222C6368696C6472656E3A28302C50432E6A7378292856482C7B2E2E2E652C6F70656E3A6E2C7472616E736C6174653A6F7D297D297D636F6E73742048483D28293D3E7B7D3B66756E6374696F6E2057482865297B636F';
wwv_flow_imp.g_varchar2_table(48630) := '6E73747B6164643A742C656C656D656E743A6E2C69643A692C6974656D733A6F2C6C6162656C3A732C73686F756C644F70656E3A723D21312C7472616E736C6174653A613D42487D3D653B6A77282828293D3E7B6E756C6C213D652E73686F756C64536F';
wwv_flow_imp.g_varchar2_table(48631) := '72742626636F6E736F6C652E7761726E28227468652070726F7065727479202773686F756C64536F727427206973206E6F206C6F6E67657220737570706F7274656422297D292C5B652E73686F756C64536F72745D293B636F6E7374206C3D2477286E75';
wwv_flow_imp.g_varchar2_table(48632) := '6C6C292C5B632C645D3D557A285B2267726F757073222C692C226F70656E225D2C72292C5B682C755D3D5777282131292C703D4B77282828293D3E6428213029292C5B645D292C5B672C6D5D3D5777285B5D292C5B662C765D3D5777282131292C623D4B';
wwv_flow_imp.g_varchar2_table(48633) := '7A286E292C5F3D4B77282828293D3E6428216329292C5B635D292C793D6E3D3D3D622626632626663F66756E6374696F6E28652C74297B636F6E7374206E3D652E6D61702828653D3E652E696429292C693D742E6D61702828653D3E652E696429293B72';
wwv_flow_imp.g_varchar2_table(48634) := '657475726E206E2E66696C7465722828653D3E21692E696E636C7564657328652929297D286F2C67293A5B5D3B6A77282828293D3E7B6D286F292C76282131297D292C5B6F5D292C517A286C2C226469762E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(48635) := '656C2D7363726F6C6C2D636F6E7461696E6572222C75293B636F6E737420773D21216F2E6C656E6774682C433D7B2E2E2E477728527A292C6F6E53686F773A707D2C533D717A28292C783D6F2E736F6D652828653D3E2121535B652E69645D7C7C28652E';
wwv_flow_imp.g_varchar2_table(48636) := '656E74726965733F652E656E74726965732E736F6D652828653D3E535B652E69645D29293A766F696420302929293B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D';
wwv_flow_imp.g_varchar2_table(48637) := '67726F7570222C22646174612D67726F75702D6964223A2267726F75702D222B692C7265663A6C2C6368696C6472656E3A5B28302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(48638) := '6C2D67726F75702D686561646572222C773F22223A22656D707479222C772626633F226F70656E223A22222C682626633F22737469636B79223A2222292C6F6E436C69636B3A773F5F3A48482C6368696C6472656E3A5B28302C50432E6A737829282264';
wwv_flow_imp.g_varchar2_table(48639) := '6976222C7B7469746C653A652E746F6F6C7469703F6E756C6C3A732C22646174612D7469746C65223A732C636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D7469746C65222C6368696C6472656E3A';
wwv_flow_imp.g_varchar2_table(48640) := '28302C50432E6A73782928427A2C7B76616C75653A652E746F6F6C7469702C666F7249643A2267726F75702D222B692C656C656D656E743A6E2C706172656E743A6C2C6368696C6472656E3A737D297D292C28302C50432E6A737873292822646976222C';
wwv_flow_imp.g_varchar2_table(48641) := '7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D627574746F6E73222C6368696C6472656E3A5B743F28302C50432E6A737873292822627574746F6E222C7B747970653A22627574746F6E222C74';
wwv_flow_imp.g_varchar2_table(48642) := '69746C653A612822437265617465206E6577206C697374206974656D22292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D627574746F6E2062696F2D70726F706572746965732D70616E656C2D';
wwv_flow_imp.g_varchar2_table(48643) := '6164642D656E747279222C6F6E436C69636B3A653D3E7B76282130292C64282130292C742865297D2C6368696C6472656E3A5B28302C50432E6A73782928787A2C7B7D292C773F6E756C6C3A28302C50432E6A73782928227370616E222C7B636C617373';
wwv_flow_imp.g_varchar2_table(48644) := '3A2262696F2D70726F706572746965732D70616E656C2D6164642D656E7472792D6C6162656C222C6368696C6472656E3A61282243726561746522297D295D7D293A6E756C6C2C773F28302C50432E6A7378292822646976222C7B7469746C653A612822';
wwv_flow_imp.g_varchar2_table(48645) := '4C69737420636F6E7461696E73207B6E756D4F664974656D737D206974656D222B2831213D6F2E6C656E6774683F2273223A2222292C7B6E756D4F664974656D733A6F2E6C656E6774687D292C636C6173733A52432829282262696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(48646) := '6965732D70616E656C2D6C6973742D6261646765222C783F2262696F2D70726F706572746965732D70616E656C2D6C6973742D62616467652D2D6572726F72223A2222292C6368696C6472656E3A6F2E6C656E6774687D293A6E756C6C2C773F28302C50';
wwv_flow_imp.g_varchar2_table(48647) := '432E6A7378292822627574746F6E222C7B747970653A22627574746F6E222C7469746C653A612822546F67676C652073656374696F6E22292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D6275';
wwv_flow_imp.g_varchar2_table(48648) := '74746F6E2062696F2D70726F706572746965732D70616E656C2D6172726F77222C6368696C6472656E3A28302C50432E6A73782928537A2C7B636C6173733A633F2262696F2D70726F706572746965732D70616E656C2D6172726F772D646F776E223A22';
wwv_flow_imp.g_varchar2_table(48649) := '62696F2D70726F706572746965732D70616E656C2D6172726F772D7269676874227D297D293A6E756C6C5D7D295D7D292C28302C50432E6A7378292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D';
wwv_flow_imp.g_varchar2_table(48650) := '6C697374222C632626773F226F70656E223A2222292C6368696C6472656E3A28302C50432E6A73782928527A2E50726F76696465722C7B76616C75653A432C6368696C6472656E3A6F2E6D6170282828652C74293D3E7B69662821652972657475726E3B';
wwv_flow_imp.g_varchar2_table(48651) := '636F6E73747B69643A697D3D652C6F3D792E696E636C7564657328652E6964293B72657475726E28302C41772E6E29287A482C7B2E2E2E652C6175746F4F70656E3A6F2C656C656D656E743A6E2C696E6465783A742C6B65793A692C7472616E736C6174';
wwv_flow_imp.g_varchar2_table(48652) := '653A617D297D29297D297D295D7D297D66756E6374696F6E206A482865297B636F6E73747B69643A742C6C6162656C3A6E2C6F6E4368616E67653A692C64697361626C65643A6F2C76616C75653A733D21312C6F6E466F6375733A722C6F6E426C75723A';
wwv_flow_imp.g_varchar2_table(48653) := '612C746F6F6C7469703A6C7D3D652C5B632C645D3D57772873293B6A77282828293D3E7B73213D3D632626642873297D292C5B735D293B636F6E737420683D477A2874293B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A';
wwv_flow_imp.g_varchar2_table(48654) := '2262696F2D70726F706572746965732D70616E656C2D636865636B626F78222C6368696C6472656E3A5B28302C50432E6A7378292822696E707574222C7B7265663A682C69643A55482874292C6E616D653A742C6F6E466F6375733A722C6F6E426C7572';
wwv_flow_imp.g_varchar2_table(48655) := '3A612C747970653A22636865636B626F78222C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C6F6E4368616E67653A653D3E7B28287B7461726765743A657D293D3E7B6928652E636865636B6564297D29286529';
wwv_flow_imp.g_varchar2_table(48656) := '2C6428652E7461726765742E76616C7565297D2C636865636B65643A632C64697361626C65643A6F7D292C28302C50432E6A73782928226C6162656C222C7B666F723A55482874292C636C6173733A2262696F2D70726F706572746965732D70616E656C';
wwv_flow_imp.g_varchar2_table(48657) := '2D6C6162656C222C6368696C6472656E3A28302C50432E6A73782928427A2C7B76616C75653A6C2C666F7249643A742C656C656D656E743A652E656C656D656E742C6368696C6472656E3A6E7D297D295D7D297D66756E6374696F6E2071482865297B63';
wwv_flow_imp.g_varchar2_table(48658) := '6F6E73747B656C656D656E743A742C69643A6E2C6465736372697074696F6E3A692C6C6162656C3A6F2C67657456616C75653A732C73657456616C75653A722C64697361626C65643A612C6F6E466F6375733A6C2C6F6E426C75723A632C746F6F6C7469';
wwv_flow_imp.g_varchar2_table(48659) := '703A647D3D652C683D732874292C753D6A7A286E293B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D656E7472792062696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(48660) := '6C2D636865636B626F782D656E747279222C22646174612D656E7472792D6964223A6E2C6368696C6472656E3A5B28302C50432E6A737829286A482C7B64697361626C65643A612C69643A6E2C6C6162656C3A6F2C6F6E4368616E67653A722C6F6E466F';
wwv_flow_imp.g_varchar2_table(48661) := '6375733A6C2C6F6E426C75723A632C76616C75653A682C746F6F6C7469703A642C656C656D656E743A747D2C74292C75262628302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6572726F';
wwv_flow_imp.g_varchar2_table(48662) := '72222C6368696C6472656E3A757D292C28302C50432E6A7378292865482C7B666F7249643A6E2C656C656D656E743A742C76616C75653A697D295D7D297D66756E6374696F6E2024482865297B72657475726E206526262121652E636865636B65647D66';
wwv_flow_imp.g_varchar2_table(48663) := '756E6374696F6E2055482865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D66756E6374696F6E204B482865297B636F6E73747B69643A742C6C6162656C3A6E2C6F6E4368616E67653A692C6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(48664) := '3A6F3D5B5D2C76616C75653A733D22222C64697361626C65643A722C6F6E466F6375733A612C6F6E426C75723A6C2C746F6F6C7469703A637D3D652C643D477A2874292C5B682C755D3D57772873293B72657475726E206A77282828293D3E7B73213D3D';
wwv_flow_imp.g_varchar2_table(48665) := '682626752873297D292C5B735D292C28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D73656C656374222C6368696C6472656E3A5B28302C50432E6A73782928226C6162656C222C7B';
wwv_flow_imp.g_varchar2_table(48666) := '666F723A59482874292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6C6162656C222C6368696C6472656E3A28302C50432E6A73782928427A2C7B76616C75653A632C666F7249643A742C656C656D656E743A652E656C656D65';
wwv_flow_imp.g_varchar2_table(48667) := '6E742C6368696C6472656E3A6E7D297D292C28302C50432E6A737829282273656C656374222C7B7265663A642C69643A59482874292C6E616D653A742C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574222C6F6E496E';
wwv_flow_imp.g_varchar2_table(48668) := '7075743A653D3E7B28287B7461726765743A657D293D3E7B6928652E76616C7565297D292865292C7528652E7461726765742E76616C7565297D2C6F6E466F6375733A612C6F6E426C75723A6C2C76616C75653A682C64697361626C65643A722C636869';
wwv_flow_imp.g_varchar2_table(48669) := '6C6472656E3A6F2E6D6170282828652C74293D3E652E6368696C6472656E3F28302C50432E6A73782928226F707467726F7570222C7B6C6162656C3A652E6C6162656C2C6368696C6472656E3A652E6368696C6472656E2E6D6170282828652C74293D3E';
wwv_flow_imp.g_varchar2_table(48670) := '28302C50432E6A73782928226F7074696F6E222C7B76616C75653A652E76616C75652C64697361626C65643A652E64697361626C65642C6368696C6472656E3A652E6C6162656C7D2C742929297D2C74293A28302C50432E6A73782928226F7074696F6E';
wwv_flow_imp.g_varchar2_table(48671) := '222C7B76616C75653A652E76616C75652C64697361626C65643A652E64697361626C65642C6368696C6472656E3A652E6C6162656C7D2C742929297D295D7D297D66756E6374696F6E2047482865297B636F6E73747B656C656D656E743A742C69643A6E';
wwv_flow_imp.g_varchar2_table(48672) := '2C6465736372697074696F6E3A6F2C6C6162656C3A732C67657456616C75653A722C73657456616C75653A612C6765744F7074696F6E733A6C2C64697361626C65643A632C6F6E466F6375733A642C6F6E426C75723A682C76616C69646174653A752C74';
wwv_flow_imp.g_varchar2_table(48673) := '6F6F6C7469703A707D3D652C673D6C2874292C6D3D6A7A286E292C5B662C765D3D5777286E756C6C293B6C657420623D722874293B6A77282828293D3E7B69662828302C692E546E29287529297B636F6E737420653D752862297C7C6E756C6C3B762865';
wwv_flow_imp.g_varchar2_table(48674) := '297D7D292C5B622C755D293B636F6E7374205F3D6D7C7C663B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D656E747279222C5F3F226861732D657272';
wwv_flow_imp.g_varchar2_table(48675) := '6F72223A2222292C22646174612D656E7472792D6964223A6E2C6368696C6472656E3A5B28302C50432E6A737829284B482C7B69643A6E2C6C6162656C3A732C76616C75653A622C6F6E4368616E67653A653D3E7B6C657420743D6E756C6C3B28302C69';
wwv_flow_imp.g_varchar2_table(48676) := '2E546E29287529262628743D752865297C7C6E756C6C292C6128652C74292C762874297D2C6F6E466F6375733A642C6F6E426C75723A682C6F7074696F6E733A672C64697361626C65643A632C746F6F6C7469703A702C656C656D656E743A747D2C7429';
wwv_flow_imp.g_varchar2_table(48677) := '2C5F262628302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6572726F72222C6368696C6472656E3A5F7D292C28302C50432E6A7378292865482C7B666F7249643A6E2C656C656D656E74';
wwv_flow_imp.g_varchar2_table(48678) := '3A742C76616C75653A6F7D295D7D297D66756E6374696F6E2051482865297B72657475726E206526262121652E76616C75657D66756E6374696F6E2059482865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D';
wwv_flow_imp.g_varchar2_table(48679) := '66756E6374696F6E205A482865297B652E7374796C652E6865696768743D226175746F222C652E7374796C652E6865696768743D60247B652E7363726F6C6C4865696768742B327D7078607D66756E6374696F6E2058482865297B636F6E73747B69643A';
wwv_flow_imp.g_varchar2_table(48680) := '742C6C6162656C3A6E2C6465626F756E63653A692C6F6E496E7075743A6F2C76616C75653A733D22222C64697361626C65643A722C6D6F6E6F73706163653A612C6F6E466F6375733A6C2C6F6E426C75723A632C6175746F526573697A653A643D21302C';
wwv_flow_imp.g_varchar2_table(48681) := '706C616365686F6C6465723A682C726F77733A753D28643F313A32292C746F6F6C7469703A707D3D652C5B672C6D5D3D57772873292C663D477A2874292C763D66756E6374696F6E2865297B636F6E73745B742C6E5D3D57772821216526262121652E63';
wwv_flow_imp.g_varchar2_table(48682) := '6C69656E74486569676874293B72657475726E207177282828293D3E7B69662821652972657475726E3B636F6E737420693D6E657720526573697A654F627365727665722828285B655D293D3E7B72657175657374416E696D6174696F6E4672616D6528';
wwv_flow_imp.g_varchar2_table(48683) := '2828293D3E7B636F6E737420693D2121652E636F6E74656E74526563742E6865696768743B69213D3D7426266E2869297D29297D29293B72657475726E20692E6F6273657276652865292C28293D3E692E646973636F6E6E65637428297D292C5B652C74';
wwv_flow_imp.g_varchar2_table(48684) := '5D292C747D28662E63757272656E74292C623D5577282828293D3E692828653D3E6F28652E76616C75652E6C656E6774683F652E76616C75653A766F69642030292929292C5B6F2C695D293B72657475726E207177282828293D3E7B6426265A4828662E';
wwv_flow_imp.g_varchar2_table(48685) := '63757272656E74297D292C5B5D292C7177282828293D3E7B7626266426265A4828662E63757272656E74297D292C5B765D292C6A77282828293D3E7B73213D3D6726266D2873297D292C5B735D292C28302C50432E6A737873292822646976222C7B636C';
wwv_flow_imp.g_varchar2_table(48686) := '6173733A2262696F2D70726F706572746965732D70616E656C2D7465787461726561222C6368696C6472656E3A5B28302C50432E6A73782928226C6162656C222C7B666F723A74572874292C636C6173733A2262696F2D70726F706572746965732D7061';
wwv_flow_imp.g_varchar2_table(48687) := '6E656C2D6C6162656C222C6368696C6472656E3A28302C50432E6A73782928427A2C7B76616C75653A702C666F7249643A742C656C656D656E743A652E656C656D656E742C6368696C6472656E3A6E7D297D292C28302C50432E6A737829282274657874';
wwv_flow_imp.g_varchar2_table(48688) := '61726561222C7B7265663A662C69643A74572874292C6E616D653A742C7370656C6C436865636B3A2266616C7365222C636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D696E707574222C613F2262696F2D70726F7065';
wwv_flow_imp.g_varchar2_table(48689) := '72746965732D70616E656C2D696E7075742D6D6F6E6F7370616365223A22222C643F226175746F2D726573697A65223A2222292C6F6E496E7075743A653D3E7B6228652E746172676574292C6426265A4828652E746172676574292C6D28652E74617267';
wwv_flow_imp.g_varchar2_table(48690) := '65742E76616C7565297D2C6F6E466F6375733A6C2C6F6E426C75723A632C706C616365686F6C6465723A682C726F77733A752C76616C75653A672C64697361626C65643A722C22646174612D6772616D6D223A2266616C7365227D295D7D297D66756E63';
wwv_flow_imp.g_varchar2_table(48691) := '74696F6E204A482865297B636F6E73747B656C656D656E743A742C69643A6E2C6465736372697074696F6E3A6F2C6465626F756E63653A732C6C6162656C3A722C67657456616C75653A612C73657456616C75653A6C2C726F77733A632C6D6F6E6F7370';
wwv_flow_imp.g_varchar2_table(48692) := '6163653A642C64697361626C65643A682C76616C69646174653A752C6F6E466F6375733A702C6F6E426C75723A672C706C616365686F6C6465723A6D2C6175746F526573697A653A662C746F6F6C7469703A767D3D652C623D6A7A286E292C5B5F2C795D';
wwv_flow_imp.g_varchar2_table(48693) := '3D5777286E756C6C293B6C657420773D612874293B6A77282828293D3E7B69662828302C692E546E29287529297B636F6E737420653D752877297C7C6E756C6C3B792865297D7D292C5B772C755D293B636F6E737420433D627C7C5F3B72657475726E28';
wwv_flow_imp.g_varchar2_table(48694) := '302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F706572746965732D70616E656C2D656E747279222C433F226861732D6572726F72223A2222292C22646174612D656E7472792D6964223A6E2C6368696C6472';
wwv_flow_imp.g_varchar2_table(48695) := '656E3A5B28302C50432E6A7378292858482C7B69643A6E2C6C6162656C3A722C76616C75653A772C6F6E496E7075743A653D3E7B6C657420743D6E756C6C3B28302C692E546E29287529262628743D752865297C7C6E756C6C292C6C28652C74292C7928';
wwv_flow_imp.g_varchar2_table(48696) := '74297D2C6F6E466F6375733A702C6F6E426C75723A672C726F77733A632C6465626F756E63653A732C6D6F6E6F73706163653A642C64697361626C65643A682C706C616365686F6C6465723A6D2C6175746F526573697A653A662C746F6F6C7469703A76';
wwv_flow_imp.g_varchar2_table(48697) := '2C656C656D656E743A747D2C74292C43262628302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6572726F72222C6368696C6472656E3A437D292C28302C50432E6A7378292865482C7B66';
wwv_flow_imp.g_varchar2_table(48698) := '6F7249643A6E2C656C656D656E743A742C76616C75653A6F7D295D7D297D66756E6374696F6E2065572865297B72657475726E206526262121652E76616C75657D66756E6374696F6E2074572865297B72657475726E6062696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(48699) := '732D70616E656C2D247B657D607D66756E6374696F6E206E572865297B636F6E73747B6465626F756E63653A742C64697361626C65643A6E3D21312C69643A692C6C6162656C3A6F2C6F6E496E7075743A732C6F6E466F6375733A722C6F6E426C75723A';
wwv_flow_imp.g_varchar2_table(48700) := '612C706C616365686F6C6465723A6C2C76616C75653A633D22222C746F6F6C7469703A647D3D652C5B682C755D3D577728637C7C2222292C703D477A2869292C673D5577282828293D3E742828653D3E7328652E76616C75652E6C656E6774683F652E76';
wwv_flow_imp.g_varchar2_table(48701) := '616C75653A766F69642030292929292C5B732C745D293B72657475726E206A77282828293D3E7B63213D3D682626752863297D292C5B635D292C28302C50432E6A737873292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70';
wwv_flow_imp.g_varchar2_table(48702) := '616E656C2D746578746669656C64222C6368696C6472656E3A5B28302C50432E6A73782928226C6162656C222C7B666F723A73572869292C636C6173733A2262696F2D70726F706572746965732D70616E656C2D6C6162656C222C6368696C6472656E3A';
wwv_flow_imp.g_varchar2_table(48703) := '28302C50432E6A73782928427A2C7B76616C75653A642C666F7249643A692C656C656D656E743A652E656C656D656E742C6368696C6472656E3A6F7D297D292C28302C50432E6A7378292822696E707574222C7B7265663A702C69643A73572869292C74';
wwv_flow_imp.g_varchar2_table(48704) := '7970653A2274657874222C6E616D653A692C7370656C6C436865636B3A2266616C7365222C6175746F436F6D706C6574653A226F6666222C64697361626C65643A6E2C636C6173733A2262696F2D70726F706572746965732D70616E656C2D696E707574';
wwv_flow_imp.g_varchar2_table(48705) := '222C6F6E496E7075743A653D3E7B6728652E746172676574292C7528652E7461726765742E76616C7565297D2C6F6E466F6375733A722C6F6E426C75723A612C706C616365686F6C6465723A6C2C76616C75653A687D295D7D297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(48706) := '69572865297B636F6E73747B656C656D656E743A742C69643A6E2C6465736372697074696F6E3A6F2C6465626F756E63653A732C64697361626C65643A722C6C6162656C3A612C67657456616C75653A6C2C73657456616C75653A632C76616C69646174';
wwv_flow_imp.g_varchar2_table(48707) := '653A642C6F6E466F6375733A682C6F6E426C75723A752C706C616365686F6C6465723A702C746F6F6C7469703A677D3D652C6D3D6A7A286E292C5B662C765D3D5777286E756C6C293B6C657420623D6C2874293B6A77282828293D3E7B69662828302C69';
wwv_flow_imp.g_varchar2_table(48708) := '2E546E29286429297B636F6E737420653D642862297C7C6E756C6C3B762865297D7D292C5B622C645D293B636F6E7374205F3D6D7C7C663B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A52432829282262696F2D70726F';
wwv_flow_imp.g_varchar2_table(48709) := '706572746965732D70616E656C2D656E747279222C5F3F226861732D6572726F72223A2222292C22646174612D656E7472792D6964223A6E2C6368696C6472656E3A5B28302C50432E6A737829286E572C7B6465626F756E63653A732C64697361626C65';
wwv_flow_imp.g_varchar2_table(48710) := '643A722C69643A6E2C6C6162656C3A612C6F6E496E7075743A653D3E7B6C657420743D6E756C6C3B28302C692E546E29286429262628743D642865297C7C6E756C6C292C6328652C74292C762874297D2C6F6E466F6375733A682C6F6E426C75723A752C';
wwv_flow_imp.g_varchar2_table(48711) := '706C616365686F6C6465723A702C76616C75653A622C746F6F6C7469703A672C656C656D656E743A747D2C74292C5F262628302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6572726F72';
wwv_flow_imp.g_varchar2_table(48712) := '222C6368696C6472656E3A5F7D292C28302C50432E6A7378292865482C7B666F7249643A6E2C656C656D656E743A742C76616C75653A6F7D295D7D297D66756E6374696F6E206F572865297B72657475726E206526262121652E76616C75657D66756E63';
wwv_flow_imp.g_varchar2_table(48713) := '74696F6E2073572865297B72657475726E6062696F2D70726F706572746965732D70616E656C2D247B657D607D66756E6374696F6E2072572865297B72657475726E2066756E6374696F6E2874297B6966282131213D3D65297B766172206E3D28302C69';
wwv_flow_imp.g_varchar2_table(48714) := '2E4574292865293F653A3330303B72657475726E28302C692E73672928742C6E297D72657475726E20747D7D72572E24696E6A6563743D5B22636F6E6669672E6465626F756E6365496E707574225D3B7661722061573D7B6465626F756E6365496E7075';
wwv_flow_imp.g_varchar2_table(48715) := '743A5B22666163746F7279222C72575D7D3B636C617373206C577B636F6E7374727563746F722865297B746869732E5F6576656E744275733D657D69734F70656E28297B72657475726E20746869732E5F6576656E744275732E6669726528226665656C';
wwv_flow_imp.g_varchar2_table(48716) := '506F7075702E5F69734F70656E22297D6F70656E28652C742C6E297B72657475726E20746869732E5F6576656E744275732E6669726528226665656C506F7075702E5F6F70656E222C7B656E74727949643A652C706F707570436F6E6669673A742C736F';
wwv_flow_imp.g_varchar2_table(48717) := '75726365456C656D656E743A6E7D297D636C6F736528297B72657475726E20746869732E5F6576656E744275732E6669726528226665656C506F7075702E5F636C6F736522297D7D6C572E24696E6A6563743D5B226576656E74427573225D3B76617220';
wwv_flow_imp.g_varchar2_table(48718) := '63573D7B6665656C506F7075703A5B2274797065222C6C575D7D3B636C6173732064577B636F6E7374727563746F722865297B746869732E747970653D657D676574457874656E73696F6E50726F706572747928652C742C6E297B636F6E737420693D43';
wwv_flow_imp.g_varchar2_table(48719) := '77286E7C7C4C772865292C746869732E74797065293B72657475726E20692626695B745D7D736574457874656E73696F6E50726F706572747928652C742C6E2C692C6F297B636F6E737420733D6F7C7C4C772865293B6C657420722C612C6C3D77772873';
wwv_flow_imp.g_varchar2_table(48720) := '292C633D437728732C746869732E74797065293B6966286C2969662863297B636F6E737420653D5B5D3B666F7228636F6E7374207420696E206929695B745D7C7C28695B745D3D766F696420302C652E70757368287429293B4F626A6563742E6B657973';
wwv_flow_imp.g_varchar2_table(48721) := '2863292E736F6D652828743D3E22247479706522213D3D74262621652E696E636C7564657328742929293F28613D632C723D69293A6C2E676574282276616C75657322292E736F6D652828653D3E65213D3D6329293F28613D6C2C723D7B76616C756573';
wwv_flow_imp.g_varchar2_table(48722) := '3A6C2E676574282276616C75657322292E66696C7465722828653D3E65213D3D6329297D293A28613D732C723D7B657874656E73696F6E456C656D656E74733A766F696420307D297D656C736520613D6C2C633D6B7728746869732E747970652C692C6C';
wwv_flow_imp.g_varchar2_table(48723) := '2C6E292C723D7B76616C7565733A6C2E676574282276616C75657322292E636F6E6361742863297D3B656C736520613D732C6C3D787728652C6E292C633D6B7728746869732E747970652C692C6C2C6E292C6C2E76616C7565732E707573682863292C72';
wwv_flow_imp.g_varchar2_table(48724) := '3D7B657874656E73696F6E456C656D656E74733A6C7D3B72657475726E20742E7570646174654D6F64646C6550726F7065727469657328652C612C72297D7D66756E6374696F6E20685728652C74297B72657475726E20742E666F724561636828286675';
wwv_flow_imp.g_varchar2_table(48725) := '6E6374696F6E2874297B74262622737472696E6722213D747970656F66207426262141727261792E6973417272617928742926264F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B6966282264656661756C7422';
wwv_flow_imp.g_varchar2_table(48726) := '213D3D6E262621286E20696E206529297B76617220693D4F626A6563742E6765744F776E50726F706572747944657363726970746F7228742C6E293B4F626A6563742E646566696E6550726F706572747928652C6E2C692E6765743F693A7B656E756D65';
wwv_flow_imp.g_varchar2_table(48727) := '7261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20745B6E5D7D7D297D7D29297D29292C4F626A6563742E667265657A652865297D4F626A6563742E70726F746F747970652E746F537472696E672C4F626A6563742E70726F74';
wwv_flow_imp.g_varchar2_table(48728) := '6F747970652E6861734F776E50726F70657274793B636F6E73742075573D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E2070572865297B69662821657C7C21652E6E6F646554797065297468726F77206E657720';
wwv_flow_imp.g_varchar2_table(48729) := '4572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D70572E70726F746F747970652E6164643D66756E637469';
wwv_flow_imp.g_varchar2_table(48730) := '6F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C70572E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D223D3D75572E63616C6C';
wwv_flow_imp.g_varchar2_table(48731) := '2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C70572E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(48732) := '20743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C70572E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(48733) := '2E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67';
wwv_flow_imp.g_varchar2_table(48734) := '676C652865292C746869737D2C70572E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C70572E70726F746F747970652E6861733D70572E70726F746F7479';
wwv_flow_imp.g_varchar2_table(48735) := '70652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B7661722067572C6D572C66572C76573D7B7D3B66756E6374696F6E20625728297B67573D77696E646F772E616464';
wwv_flow_imp.g_varchar2_table(48736) := '4576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C6D573D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A22';
wwv_flow_imp.g_varchar2_table(48737) := '6465746163684576656E74222C66573D226164644576656E744C697374656E657222213D3D67573F226F6E223A22227D766172205F572C79573D6857287B5F5F70726F746F5F5F3A6E756C6C2C62696E643A76572E62696E643D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(48738) := '2C742C6E2C69297B72657475726E2067577C7C625728292C655B67575D2866572B742C6E2C697C7C2131292C6E7D2C756E62696E643A76572E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E206D577C7C625728292C655B';
wwv_flow_imp.g_varchar2_table(48739) := '6D575D2866572B742C6E2C697C7C2131292C6E7D2C64656661756C743A76577D2C5B76575D292C77573D21313B22756E646566696E656422213D747970656F6620646F63756D656E74262628285F573D646F63756D656E742E637265617465456C656D65';
wwv_flow_imp.g_varchar2_table(48740) := '6E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D22636865636B626F78222F3E272C77573D215F572E676574';
wwv_flow_imp.g_varchar2_table(48741) := '456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C5F573D766F69642030293B7661722043573D7B6C6567656E643A5B312C223C6669656C647365743E222C223C2F6669656C647365743E225D2C74723A5B322C223C7461';
wwv_flow_imp.g_varchar2_table(48742) := '626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E222C223C2F636F6C67726F75703E3C2F7461626C653E225D2C5F64';
wwv_flow_imp.g_varchar2_table(48743) := '656661756C743A77573F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B43572E74643D43572E74683D5B332C223C7461626C653E3C74626F64793E3C74723E222C223C2F74723E3C2F74626F64793E3C2F7461626C65';
wwv_flow_imp.g_varchar2_table(48744) := '3E225D2C43572E6F7074696F6E3D43572E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C43572E74686561643D43572E74626F64793D43572E636F6C67726F';
wwv_flow_imp.g_varchar2_table(48745) := '75703D43572E63617074696F6E3D43572E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C43572E706F6C796C696E653D43572E656C6C697073653D43572E706F6C79676F6E3D43572E636972636C653D43572E746578743D';
wwv_flow_imp.g_varchar2_table(48746) := '43572E6C696E653D43572E706174683D43572E726563743D43572E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076657273696F6E3D22312E31223E272C223C2F7376673E225D3B76';
wwv_flow_imp.g_varchar2_table(48747) := '61722053573D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870656374656422293B747C7C28743D646F63756D656E74293B766172';
wwv_flow_imp.g_varchar2_table(48748) := '206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B7C5C732B242F672C2222293B76617220693D6E5B315D3B69662822';
wwv_flow_imp.g_varchar2_table(48749) := '626F6479223D3D692972657475726E286C3D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C6C2E72656D6F76654368696C64286C2E6C6173744368696C64293B766172206F3D4F626A6563742E70726F746F';
wwv_flow_imp.g_varchar2_table(48750) := '747970652E6861734F776E50726F70657274792E63616C6C2843572C69293F43575B695D3A43572E5F64656661756C742C733D6F5B305D2C723D6F5B315D2C613D6F5B325D2C6C3D742E637265617465456C656D656E74282264697622293B666F72286C';
wwv_flow_imp.g_varchar2_table(48751) := '2E696E6E657248544D4C3D722B652B613B732D2D3B296C3D6C2E6C6173744368696C643B6966286C2E66697273744368696C643D3D6C2E6C6173744368696C642972657475726E206C2E72656D6F76654368696C64286C2E66697273744368696C64293B';
wwv_flow_imp.g_varchar2_table(48752) := '666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B6C2E66697273744368696C643B29632E617070656E644368696C64286C2E72656D6F76654368696C64286C2E66697273744368696C6429293B72657475726E';
wwv_flow_imp.g_varchar2_table(48753) := '20637D3B66756E6374696F6E20785728652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F722865297D766172206B573D6F2835323835293B6F2836343830293B636F6E73742045573D28302C41772E7136';
wwv_flow_imp.g_varchar2_table(48754) := '29287B73656C6563746564456C656D656E743A6E756C6C2C696E6A6563746F723A6E756C6C2C676574536572766963653A28293D3E6E756C6C7D293B66756E6374696F6E204C5728652C74297B636F6E73747B676574536572766963653A6E7D3D477728';
wwv_flow_imp.g_varchar2_table(48755) := '4557293B72657475726E206E28652C74297D66756E6374696F6E20445728297B72657475726E2044573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D31';
wwv_flow_imp.g_varchar2_table(48756) := '3B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D';
wwv_flow_imp.g_varchar2_table(48757) := '297D72657475726E20657D2C44572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20545728297B72657475726E2054573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E63';
wwv_flow_imp.g_varchar2_table(48758) := '74696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E6361';
wwv_flow_imp.g_varchar2_table(48759) := '6C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C54572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20495728297B72657475726E2049573D4F626A6563742E61737369676E3F4F626A656374';
wwv_flow_imp.g_varchar2_table(48760) := '2E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D';
wwv_flow_imp.g_varchar2_table(48761) := '292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C49572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E204D5728297B72657475726E204D573D4F';
wwv_flow_imp.g_varchar2_table(48762) := '626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D';
wwv_flow_imp.g_varchar2_table(48763) := '3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4D572E6170706C79286E756C6C2C617267756D656E7473297D66756E637469';
wwv_flow_imp.g_varchar2_table(48764) := '6F6E20415728297B72657475726E2041573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B29';
wwv_flow_imp.g_varchar2_table(48765) := '7B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C41572E6170706C79286E756C';
wwv_flow_imp.g_varchar2_table(48766) := '6C2C617267756D656E7473297D66756E6374696F6E204E5728297B72657475726E204E573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C6172';
wwv_flow_imp.g_varchar2_table(48767) := '67756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D726574';
wwv_flow_imp.g_varchar2_table(48768) := '75726E20657D2C4E572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20505728297B72657475726E2050573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(48769) := '65297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C';
wwv_flow_imp.g_varchar2_table(48770) := '6929262628655B695D3D6E5B695D297D72657475726E20657D2C50572E6170706C79286E756C6C2C617267756D656E7473297D766172204F573D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5057287B77696474683A22';
wwv_flow_imp.g_varchar2_table(48771) := '3332222C6865696768743A223332222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D2C74292C4E43282270617468222C7B7374726F6B653A2223303030222C7374726F6B6557696474683A2232222C7374726F';
wwv_flow_imp.g_varchar2_table(48772) := '6B654C696E656361703A22726F756E64222C7374726F6B654461736861727261793A22312E312C342E33222C643A224D312E352033302E354C32372035227D292C4E43282270617468222C7B643A224D33312E3830332E3139374C32362E352031362E31';
wwv_flow_imp.g_varchar2_table(48773) := '30376C2D312E35322D312E353220332E3738332D31312E33352D31312E333520332E3738332D312E35322D312E35327A227D29293B66756E6374696F6E20525728297B72657475726E2052573D4F626A6563742E61737369676E3F4F626A6563742E6173';
wwv_flow_imp.g_varchar2_table(48774) := '7369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E68';
wwv_flow_imp.g_varchar2_table(48775) := '61734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C52572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20465728297B72657475726E2046573D4F626A65';
wwv_flow_imp.g_varchar2_table(48776) := '63742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F';
wwv_flow_imp.g_varchar2_table(48777) := '7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C46572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(48778) := '425728297B72657475726E2042573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B7661';
wwv_flow_imp.g_varchar2_table(48779) := '72206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C42572E6170706C79286E756C6C2C61';
wwv_flow_imp.g_varchar2_table(48780) := '7267756D656E7473297D66756E6374696F6E20565728297B72657475726E2056573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D';
wwv_flow_imp.g_varchar2_table(48781) := '656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E';
wwv_flow_imp.g_varchar2_table(48782) := '20657D2C56572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E207A5728297B72657475726E207A573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(48783) := '666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C692926';
wwv_flow_imp.g_varchar2_table(48784) := '2628655B695D3D6E5B695D297D72657475726E20657D2C7A572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20485728297B72657475726E2048573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E';
wwv_flow_imp.g_varchar2_table(48785) := '62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E';
wwv_flow_imp.g_varchar2_table(48786) := '50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C48572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20575728297B72657475726E2057573D4F626A6563742E6173';
wwv_flow_imp.g_varchar2_table(48787) := '7369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172';
wwv_flow_imp.g_varchar2_table(48788) := '206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C57572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206A5728297B';
wwv_flow_imp.g_varchar2_table(48789) := '72657475726E206A573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D61';
wwv_flow_imp.g_varchar2_table(48790) := '7267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6A572E6170706C79286E756C6C2C617267756D65';
wwv_flow_imp.g_varchar2_table(48791) := '6E7473297D66756E6374696F6E20715728297B72657475726E2071573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E';
wwv_flow_imp.g_varchar2_table(48792) := '6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C71';
wwv_flow_imp.g_varchar2_table(48793) := '572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20245728297B72657475726E2024573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876';
wwv_flow_imp.g_varchar2_table(48794) := '617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B69';
wwv_flow_imp.g_varchar2_table(48795) := '5D3D6E5B695D297D72657475726E20657D2C24572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20555728297B72657475726E2055573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428';
wwv_flow_imp.g_varchar2_table(48796) := '293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F7065';
wwv_flow_imp.g_varchar2_table(48797) := '7274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C55572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E204B5728297B72657475726E204B573D4F626A6563742E61737369676E3F';
wwv_flow_imp.g_varchar2_table(48798) := '4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E';
wwv_flow_imp.g_varchar2_table(48799) := '206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4B572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20475728297B7265747572';
wwv_flow_imp.g_varchar2_table(48800) := '6E2047573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D65';
wwv_flow_imp.g_varchar2_table(48801) := '6E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C47572E6170706C79286E756C6C2C617267756D656E7473297D';
wwv_flow_imp.g_varchar2_table(48802) := '66756E6374696F6E20515728297B72657475726E2051573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774';
wwv_flow_imp.g_varchar2_table(48803) := '683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C51572E617070';
wwv_flow_imp.g_varchar2_table(48804) := '6C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20595728297B72657475726E2059573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D';
wwv_flow_imp.g_varchar2_table(48805) := '313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B69';
wwv_flow_imp.g_varchar2_table(48806) := '5D297D72657475726E20657D2C59572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E205A5728297B72657475726E205A573D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E';
wwv_flow_imp.g_varchar2_table(48807) := '6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63';
wwv_flow_imp.g_varchar2_table(48808) := '616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C5A572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20585728297B72657475726E2058573D4F626A6563742E61737369676E3F4F626A6563';
wwv_flow_imp.g_varchar2_table(48809) := '742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B';
wwv_flow_imp.g_varchar2_table(48810) := '7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C58572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E204A5728297B72657475726E204A573D';
wwv_flow_imp.g_varchar2_table(48811) := '4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B74';
wwv_flow_imp.g_varchar2_table(48812) := '5D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4A572E6170706C79286E756C6C2C617267756D656E7473297D66756E6374';
wwv_flow_imp.g_varchar2_table(48813) := '696F6E20656A28297B72657475726E20656A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B';
wwv_flow_imp.g_varchar2_table(48814) := '297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C656A2E6170706C79286E75';
wwv_flow_imp.g_varchar2_table(48815) := '6C6C2C617267756D656E7473297D66756E6374696F6E20746A28297B72657475726E20746A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C61';
wwv_flow_imp.g_varchar2_table(48816) := '7267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D7265';
wwv_flow_imp.g_varchar2_table(48817) := '7475726E20657D2C746A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206E6A28297B72657475726E206E6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(48818) := '2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E';
wwv_flow_imp.g_varchar2_table(48819) := '2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6E6A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20696A28297B72657475726E20696A3D4F626A6563742E61737369676E3F4F626A6563742E617373';
wwv_flow_imp.g_varchar2_table(48820) := '69676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861';
wwv_flow_imp.g_varchar2_table(48821) := '734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C696A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206F6A28297B72657475726E206F6A3D4F626A6563';
wwv_flow_imp.g_varchar2_table(48822) := '742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F72';
wwv_flow_imp.g_varchar2_table(48823) := '28766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6F6A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E2073';
wwv_flow_imp.g_varchar2_table(48824) := '6A28297B72657475726E20736A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172';
wwv_flow_imp.g_varchar2_table(48825) := '206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C736A2E6170706C79286E756C6C2C6172';
wwv_flow_imp.g_varchar2_table(48826) := '67756D656E7473297D76617220726A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C736A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C686569';
wwv_flow_imp.g_varchar2_table(48827) := '6768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E3131312E39333520362E3238362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E3734203136';
wwv_flow_imp.g_varchar2_table(48828) := '2E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E34353420';
wwv_flow_imp.g_varchar2_table(48829) := '31372E3230312E303935632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E323833';
wwv_flow_imp.g_varchar2_table(48830) := '2D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633';
wwv_flow_imp.g_varchar2_table(48831) := '322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E38';
wwv_flow_imp.g_varchar2_table(48832) := '31372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231352D322E3238322D322E30';
wwv_flow_imp.g_varchar2_table(48833) := '32322D352E332D332E3231372D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E363336203131';
wwv_flow_imp.g_varchar2_table(48834) := '2E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038322031312E3038322030203031313620352E303231';
wwv_flow_imp.g_varchar2_table(48835) := '7A6D2D332E39353620332E3934366C2D332E30393620332E30393720332E39383520332E3938352D332E39313320332E39313320332E30343720332E30343820332E3931332D332E39313320332E39383820332E39383720332E3039372D332E3039364C';
wwv_flow_imp.g_varchar2_table(48836) := '31392E3037362031366C332E3931342D332E3931332D332E3034382D332E3034382D332E39313320332E3931332D332E3938362D332E3938357A6D2D2E30303220312E3232326C332E39383820332E39383720332E3931332D332E39313320312E383236';
wwv_flow_imp.g_varchar2_table(48837) := '20312E3832362D332E39313320332E39313320332E39383520332E3938362D312E38373320312E3837332D332E3938352D332E3938352D332E39313320332E3931332D312E3832372D312E38323720332E3931342D332E3931332D332E3938382D332E39';
wwv_flow_imp.g_varchar2_table(48838) := '383720312E3837332D312E3837337A227D29293B66756E6374696F6E20616A28297B72657475726E20616A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F72287661722074';
wwv_flow_imp.g_varchar2_table(48839) := '3D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B';
wwv_flow_imp.g_varchar2_table(48840) := '695D297D72657475726E20657D2C616A2E6170706C79286E756C6C2C617267756D656E7473297D766172206C6A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C616A287B786D6C6E733A22687474703A2F2F7777772E77';
wwv_flow_imp.g_varchar2_table(48841) := '332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E39333520362E3238362E3132352031342E3033632D';
wwv_flow_imp.g_varchar2_table(48842) := '2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D';
wwv_flow_imp.g_varchar2_table(48843) := '31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E3834';
wwv_flow_imp.g_varchar2_table(48844) := '20352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E32';
wwv_flow_imp.g_varchar2_table(48845) := '322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E3739';
wwv_flow_imp.g_varchar2_table(48846) := '2031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D';
wwv_flow_imp.g_varchar2_table(48847) := '31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E393035';
wwv_flow_imp.g_varchar2_table(48848) := '2E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E38';
wwv_flow_imp.g_varchar2_table(48849) := '36344131312E3038332031312E3038332030203031313620352E3032317A6D2D2E353620352E3737326C2D372E34303820352E32333120372E34303920352E323334762D352E30353763322E33383520312E36383720342E37373120332E33373120372E';
wwv_flow_imp.g_varchar2_table(48850) := '31353720352E3035375631302E3739336C2D372E31353720352E303535762D352E3035357A6D2D2E38363520312E36363576372E3132356C2D352E3034382D332E35363220352E3034382D332E3536337A6D372E313631203076372E3133326C2D352E30';
wwv_flow_imp.g_varchar2_table(48851) := '34382D332E35363620352E3034382D332E3536367A227D29293B66756E6374696F6E20636A28297B72657475726E20636A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F72';
wwv_flow_imp.g_varchar2_table(48852) := '2876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C692926262865';
wwv_flow_imp.g_varchar2_table(48853) := '5B695D3D6E5B695D297D72657475726E20657D2C636A2E6170706C79286E756C6C2C617267756D656E7473297D76617220646A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C636A287B786D6C6E733A22687474703A2F';
wwv_flow_imp.g_varchar2_table(48854) := '2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E39372E3034682D2E31323743382E3731332D2E30313820322E30303320352E3333';
wwv_flow_imp.g_varchar2_table(48855) := '342E3433372031322E323836632D312E353120362E3132332E39382031332E30303520362E3133362031362E36363520352E31323520332E3738382031322E35343620342E3130352031372E3931322E36323320352E3237322D332E32373620382E3333';
wwv_flow_imp.g_varchar2_table(48856) := '2D392E37363620372E3332352D31352E3931362D2E3930342D362E3234312D352E37392D31312E372D31312E39352D31332E3134334131362E3038322031362E303832203020303031352E39372E30347A6D2D2E31383120312E373234632E3131352030';
wwv_flow_imp.g_varchar2_table(48857) := '202E32332030202E3334372E30303320362E3632352D2E3036362031322E38323320352E3134392031332E38392031312E363920312E313320352E39312D312E3930382031322E3334392D372E3236322031352E3133382D352E34373320332E3031332D';
wwv_flow_imp.g_varchar2_table(48858) := '31322E38363620312E3838342D31372E3131362D322E37323643312E3239312032312E3337322E3434342031332E39313420332E38303220382E36303263322E3439332D342E31313220372E3136392D362E3831392031312E3938372D362E3833387A6D';
wwv_flow_imp.g_varchar2_table(48859) := '2E32383320312E353534632D2E31313720302D2E3233342E3030322D2E3335312E3030352D362E3120302D31312E36393120352E3034392D31322E3334362031312E3131342D2E373820352E36383420322E3739352031312E36313220382E3231382031';
wwv_flow_imp.g_varchar2_table(48860) := '332E353220352E31333920312E3934332031312E3431362E3130312031342E3632342D342E333820332E3436312D342E35383320332E3236322D31312E3533382D2E3539362D31352E3833312D322E33362D322E3734372D352E3932342D342E3432332D';
wwv_flow_imp.g_varchar2_table(48861) := '392E3534392D342E3432387A6D2D2E30373820312E363935632E3037382030202E3135362030202E3233342E30303320352E3420302031302E33323120342E3535362031302E37333420392E3934322E35363320352E31332D322E3935382031302E3336';
wwv_flow_imp.g_varchar2_table(48862) := '342D372E3937312031312E3637382D342E38333220312E34312D31302E3435372D2E3933352D31322E3734362D352E3434362D322E3436332D342E3535392D312E322D31302E37393520332E3031342D31332E3838336131312E3037322031312E303732';
wwv_flow_imp.g_varchar2_table(48863) := '2030203031362E3733352D322E3239347A6D2D352E33353220342E3236365632322E3736316831302E37313656392E3237394831302E3634327A6D2E3836332E38363668382E3938377631312E3735682D382E393837762D31312E37357A6D2E39323720';
wwv_flow_imp.g_varchar2_table(48864) := '312E333233762E38363268372E313333762D2E383632682D372E3133337A6D3020322E363032762E38363668372E313333762D2E383636682D372E3133337A6D3020332E303038762E38363268372E313333762D2E383632682D372E3133337A6D302032';
wwv_flow_imp.g_varchar2_table(48865) := '2E373137762E38363368372E313333762D2E383633682D372E3133337A227D29293B66756E6374696F6E20686A28297B72657475726E20686A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F';
wwv_flow_imp.g_varchar2_table(48866) := '6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C28';
wwv_flow_imp.g_varchar2_table(48867) := '6E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C686A2E6170706C79286E756C6C2C617267756D656E7473297D76617220756A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C686A287B786D6C6E73';
wwv_flow_imp.g_varchar2_table(48868) := '3A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E39333520362E32';
wwv_flow_imp.g_varchar2_table(48869) := '38362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E373237';
wwv_flow_imp.g_varchar2_table(48870) := '2D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E';
wwv_flow_imp.g_varchar2_table(48871) := '3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D35';
wwv_flow_imp.g_varchar2_table(48872) := '2E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36';
wwv_flow_imp.g_varchar2_table(48873) := '373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E35';
wwv_flow_imp.g_varchar2_table(48874) := '32352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E303832';
wwv_flow_imp.g_varchar2_table(48875) := '2031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E';
wwv_flow_imp.g_varchar2_table(48876) := '34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D362E31333220342E313934632D312E323120322E3435352D322E34323220342E39312D332E36333320372E3336346C2D342E3531362D35';
wwv_flow_imp.g_varchar2_table(48877) := '2E3837352D342E3130332031322E31333320342E362D352E39313263312E353820312E383120332E31363220332E36313920342E37343420352E3432394C32322E313320392E3231357A4D31342E3338332031332E316C342E32393520352E3434352031';
wwv_flow_imp.g_varchar2_table(48878) := '2E3037332D322E3338372D312E30323720342E3133312D342E3338342D352E3135372D312E37373820322E373520312E3832312D342E3738327A227D29293B66756E6374696F6E20706A28297B72657475726E20706A3D4F626A6563742E61737369676E';
wwv_flow_imp.g_varchar2_table(48879) := '3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F722876617220692069';
wwv_flow_imp.g_varchar2_table(48880) := '6E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C706A2E6170706C79286E756C6C2C617267756D656E7473297D76617220676A3D287B7374796C65733A653D';
wwv_flow_imp.g_varchar2_table(48881) := '7B7D2C2E2E2E747D293D3E4E432822737667222C706A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A22';
wwv_flow_imp.g_varchar2_table(48882) := '4D31352E3937352E30343943382E3139352D2E31312E39333520362E3238362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E3939';
wwv_flow_imp.g_varchar2_table(48883) := '2031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430382D2E30332D2E3831372D2E30';
wwv_flow_imp.g_varchar2_table(48884) := '34362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D35';
wwv_flow_imp.g_varchar2_table(48885) := '2E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D352E3137342031302E3830392D35';
wwv_flow_imp.g_varchar2_table(48886) := '2E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E31393820';
wwv_flow_imp.g_varchar2_table(48887) := '31312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620';
wwv_flow_imp.g_varchar2_table(48888) := '352E30323163352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D';
wwv_flow_imp.g_varchar2_table(48889) := '31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D2E30303620332E393237632D312E36373220342E3635342D322E';
wwv_flow_imp.g_varchar2_table(48890) := '37333420392E3530322D342E3430362031342E31353520312E3533342D312E35323520322E3837322D332E32333420342E3430362D342E3735396C342E34303620342E3736632D312E3439362D342E37312D322E39312D392E3434362D342E3430362D31';
wwv_flow_imp.g_varchar2_table(48891) := '342E3135367A6D2E30333220322E393239632E38323220322E35383620312E35393820352E31383620322E343220372E3737316C2D322E34322D322E363132632D2E3638322E3539372D322E34353220322E3838342D322E33333820322E3338382E3837';
wwv_flow_imp.g_varchar2_table(48892) := '2D322E34383720312E3434372D352E30363720322E3333382D372E3534377A227D29293B66756E6374696F6E206D6A28297B72657475726E206D6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374';
wwv_flow_imp.g_varchar2_table(48893) := '696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C';
wwv_flow_imp.g_varchar2_table(48894) := '6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6D6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220666A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6D6A287B786D6C';
wwv_flow_imp.g_varchar2_table(48895) := '6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E3933352036';
wwv_flow_imp.g_varchar2_table(48896) := '2E3238362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E37';
wwv_flow_imp.g_varchar2_table(48897) := '32372D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463';
wwv_flow_imp.g_varchar2_table(48898) := '372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E353537';
wwv_flow_imp.g_varchar2_table(48899) := '2D352E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D3132';
wwv_flow_imp.g_varchar2_table(48900) := '2E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E3730322032';
wwv_flow_imp.g_varchar2_table(48901) := '2E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E30';
wwv_flow_imp.g_varchar2_table(48902) := '38322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31';
wwv_flow_imp.g_varchar2_table(48903) := '302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D312E373820342E30393376332E35353548392E37383576362E37313468372E39393476332E3535346C352E3832392D362E3931312D';
wwv_flow_imp.g_varchar2_table(48904) := '352E38332D362E3931327A6D2E39373420322E3538346C332E363120342E3239352D332E363120342E323934762D312E393333682D372E3838762D342E36383868372E3838762D312E3936387A227D29293B66756E6374696F6E20766A28297B72657475';
wwv_flow_imp.g_varchar2_table(48905) := '726E20766A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D';
wwv_flow_imp.g_varchar2_table(48906) := '656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C766A2E6170706C79286E756C6C2C617267756D656E747329';
wwv_flow_imp.g_varchar2_table(48907) := '7D76617220626A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C766A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A22333222';
wwv_flow_imp.g_varchar2_table(48908) := '7D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E39333520362E3238362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E3636';
wwv_flow_imp.g_varchar2_table(48909) := '3620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E3039';
wwv_flow_imp.g_varchar2_table(48910) := '35632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E323637203132';
wwv_flow_imp.g_varchar2_table(48911) := '2E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E3137312036';
wwv_flow_imp.g_varchar2_table(48912) := '2E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E303334';
wwv_flow_imp.g_varchar2_table(48913) := '2031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E';
wwv_flow_imp.g_varchar2_table(48914) := '3231362D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037';
wwv_flow_imp.g_varchar2_table(48915) := '352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D2D372E32343520';
wwv_flow_imp.g_varchar2_table(48916) := '352E3437357631312E30366831342E353032762D31312E303648382E3735347A6D332E32323220312E37323868382E303537632D312E3432372E3837382D322E38353420322E3830362D342E32383120332E3031366C2D332E3737362D332E3031367A6D';
wwv_flow_imp.g_varchar2_table(48917) := '392E35353420312E30313776362E3538374831302E34385631332E32346C352E35323420342E34313420352E3532362D342E3431347A227D29293B66756E6374696F6E205F6A28297B72657475726E205F6A3D4F626A6563742E61737369676E3F4F626A';
wwv_flow_imp.g_varchar2_table(48918) := '6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29';
wwv_flow_imp.g_varchar2_table(48919) := '287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C5F6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220796A3D287B7374796C65733A653D7B7D2C2E';
wwv_flow_imp.g_varchar2_table(48920) := '2E2E747D293D3E4E432822737667222C5F6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E';
wwv_flow_imp.g_varchar2_table(48921) := '3937352E30303343382E3139352D2E3135362E39333520362E32342E3132352031332E393835632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E3939203137';
wwv_flow_imp.g_varchar2_table(48922) := '2E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E3838342032332E3434352E3430372031372E3230312E303439632D2E3430382D2E30332D2E3831372D2E303436';
wwv_flow_imp.g_varchar2_table(48923) := '2D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38';
wwv_flow_imp.g_varchar2_table(48924) := '343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E3137342E3837322031312E36373920342E39383520362E39313663322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E';
wwv_flow_imp.g_varchar2_table(48925) := '31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031';
wwv_flow_imp.g_varchar2_table(48926) := '312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D31362034';
wwv_flow_imp.g_varchar2_table(48927) := '2E39373563352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31';
wwv_flow_imp.g_varchar2_table(48928) := '312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620342E3937357A6D2E30303620332E3037336C2D372E363220352E35333120322E3931';
wwv_flow_imp.g_varchar2_table(48929) := '20382E393568392E34326C322E39312D382E39352D372E36322D352E35337A6D3020312E3036376C362E36303420342E3739342D322E35323320372E373537682D382E3136326C2D322E3532322D372E37353720362E3630332D342E3739347A227D2929';
wwv_flow_imp.g_varchar2_table(48930) := '3B66756E6374696F6E20776A28297B72657475726E20776A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E67';
wwv_flow_imp.g_varchar2_table(48931) := '74683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C776A2E6170';
wwv_flow_imp.g_varchar2_table(48932) := '706C79286E756C6C2C617267756D656E7473297D76617220436A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C776A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C776964';
wwv_flow_imp.g_varchar2_table(48933) := '74683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31302E36333820392E3536335632332E3035366831302E37323456392E3536334831302E3633387A6D2E3836332E38363668382E3939357631312E3736';
wwv_flow_imp.g_varchar2_table(48934) := '4831312E355631302E34337A6D2E39323820312E333234762E38363268372E313339762D2E383632682D372E31347A6D3020322E363035762E38363668372E313339762D2E383636682D372E31347A6D3020332E3031762E38363368372E313339762D2E';
wwv_flow_imp.g_varchar2_table(48935) := '383633682D372E31347A6D3020322E3732762E38363368372E313339762D2E383634682D372E31347A4D31352E3939392E333038682D2E3030346C2D2E3138382E303031682D2E3031316C2D2E3138382E303034682D2E3031314C31352E34312E333268';
wwv_flow_imp.g_varchar2_table(48936) := '2D2E3031316C2D2E3138372E303038682D2E3030354C31352E322E33336C2D2E3138372E3031682D2E3030356C2D2E3030352E3030312D2E3138372E303133682D2E3031314C31342E36322E3337682D2E30316C2D2E3138362E303138682D2E3031316C';
wwv_flow_imp.g_varchar2_table(48937) := '2D2E3138352E30322D2E3030352E303031682D2E3030366C2D2E3138352E3032322D2E3030352E303031682D2E3030356C2D2E3138352E303235682D2E3030356C2D2E3030352E3030312D2E3138352E303237682D2E3030356C2D2E3030352E3030312D';
wwv_flow_imp.g_varchar2_table(48938) := '2E3138342E303239682D2E3030356C2D2E3030352E3030312D2E3138332E3033312D2E3030362E3030312D2E3030352E3030312D2E3138322E3033332D2E3030362E3030312D2E3030352E3030312D2E3138322E3033352D2E3030352E3030312D2E3030';
wwv_flow_imp.g_varchar2_table(48939) := '352E3030312D2E3138322E303338682D2E3030356C2D2E3030352E3030322D2E3138312E3034682D2E3030356C2D2E3030352E3030322D2E31382E3034322D2E3030362E3030312D2E3030352E3030312D2E31382E3034342D2E3030352E303032682D2E';
wwv_flow_imp.g_varchar2_table(48940) := '3030356C2D2E31372E3034352D2E3135322E3035342D2E3133392E3038322D2E3132312E3130362D2E312E3132372D2E3037342E3134332D2E3034362E3135352D2E3031372E31362E3031332E31362E3034332E3135362E30372E3134352E3039372E31';
wwv_flow_imp.g_varchar2_table(48941) := '332E3131392E3130382E3133372E3038352E31352E3035382E3135392E30332E31362D2E3030312E3133332D2E3032332E3136352D2E3034332E3136382D2E3034312E3137312D2E30342E3137312D2E3033372E3137322D2E3033362E31372D2E303333';
wwv_flow_imp.g_varchar2_table(48942) := '2E3137332D2E30332E31372D2E30332E3137372D2E3032372E3137312D2E3032352E3137352D2E3032322E3137352D2E30322E3137352D2E30322E3137362D2E3031362E3137352D2E3031342E3137372D2E3031322E3137362D2E30312E3137372D2E30';
wwv_flow_imp.g_varchar2_table(48943) := '30372E3137342D2E3030362E3137372D2E3030332E3137382D2E303031682E3137376C2E3137382E3030342E3137342E3030362E3137372E3030372E3137362E30312E3137372E3031322E3137352E3031342E3137362E3031372E3137352E3031382E31';
wwv_flow_imp.g_varchar2_table(48944) := '37352E30322E3137352E3032332E3137312E3032352E3137362E3032372E31372E30332E3137342E30332E31372E3033332E3137312E3033362E3135342E3033332E31362E30322E3136312D2E30312E3135362D2E30342E3134362D2E3036392E313331';
wwv_flow_imp.g_varchar2_table(48945) := '2D2E3039342E3131312D2E3131372E3038372D2E3133352E3036312D2E31352E3033322D2E3135382E3030322D2E31362D2E3032372D2E31362D2E3035372D2E31354C323020312E3032336C2D2E3130382D2E31322D2E3132382D2E3039372D2E313435';
wwv_flow_imp.g_varchar2_table(48946) := '2D2E3037332D2E3132382D2E3033382D2E3135382D2E3033352D2E3030352D2E3030312D2E3030352D2E3030314C31392E31342E3632682D2E3030356C2D2E3030352D2E3030322D2E3138322D2E303335682D2E3030364C31382E3933382E35386C2D2E';
wwv_flow_imp.g_varchar2_table(48947) := '3138322D2E303333682D2E3030366C2D2E3030352D2E3030322D2E3138332D2E30332D2E3030352D2E3030312D2E3030362D2E3030312D2E3138332D2E303239682D2E3030356C2D2E3030362D2E3030312D2E3138342D2E303237682D2E3030356C2D2E';
wwv_flow_imp.g_varchar2_table(48948) := '3030352D2E3030312D2E3138352D2E303234682D2E3030354C31372E3936382E34332031372E3738332E34316C2D2E3030362D2E303031682D2E3030356C2D2E3138352D2E3032682D2E3030366C2D2E3030352D2E3030314C31372E33392E3337682D2E';
wwv_flow_imp.g_varchar2_table(48949) := '3030354C31372E33382E3336386C2D2E3138372D2E303135682D2E3030356C2D2E3030352D2E3030312D2E3138372D2E303133682D2E3031314C31362E382E333238682D2E3031314C31362E362E3332682D2E3031316C2D2E3138372D2E303036682D2E';
wwv_flow_imp.g_varchar2_table(48950) := '3031314C31362E3230342E3331682D2E3031314C31362E3030352E33314831367A6D392E30313620322E3933356C2D2E31362E3030342D2E3135382E3033332D2E31352E3036322D2E3133342E30392D2E3131362E3131312D2E3039332E3133322D2E30';
wwv_flow_imp.g_varchar2_table(48951) := '36372E3134372D2E3033382E3135362D2E30312E3136312E3032322E31362E30352E3135332E3037382E3134312E3130332E3132342E3130322E3038372E3034352E3033342E3134322E3130362E3133372E3130352E31342E31312E3133362E31312E31';
wwv_flow_imp.g_varchar2_table(48952) := '33352E3131322E3133342E3131352E3133342E3131372E31332E3131352E3133322E3132322E3132382E31322E3132372E3132322E3132362E3132352E3132342E3132362E3132342E3132382E3132312E31332E3131382E3132382E3131382E3133322E';
wwv_flow_imp.g_varchar2_table(48953) := '3131372E3133332E3131332E3133342E3131332E3133362E31312E3133362E3130392E3133372E3130392E3134322E3130342E31342E3130332E31342E3130312E3134322E312E3134342E3039392E3134362E3039352E3134352E3039342E3134372E30';
wwv_flow_imp.g_varchar2_table(48954) := '39332E31352E3039322E31352E3038372E3134392E3038372E31352E3038342E3135322E3038342E3135352E30382E3135322E30382E3135352E30342E3038312E3038342E3133382E31312E3131392E3132382E3039362E3134352E3037322E3135352E';
wwv_flow_imp.g_varchar2_table(48955) := '3034332E31362E3031332E31362D2E3031362E3135352D2E3034362E3134342D2E3037342E3132372D2E3039392E3130362D2E31322E3038332D2E31342E3035352D2E3135312E3032362D2E31362D2E3030342D2E31362D2E3033342D2E3135382D2E30';
wwv_flow_imp.g_varchar2_table(48956) := '352D2E3132342D2E3034322D2E3038352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038342D2E3136352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038362D2E3136342D2E3030322D2E3030342D2E3030332D2E3030352D2E3038';
wwv_flow_imp.g_varchar2_table(48957) := '382D2E3136322D2E3030322D2E3030352D2E3030332D2E3030352D2E30392D2E3136312D2E3030322D2E3030352D2E3030332D2E3030342D2E3039322D2E31362D2E3030332D2E3030352D2E3030322D2E3030352D2E3039342D2E31362D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(48958) := '3030342D2E3030332D2E3030342D2E3039362D2E3135392D2E3030322D2E3030342D2E3030332D2E3030352D2E3039382D2E3135372D2E3030332D2E3030342D2E3030332D2E3030352D2E312D2E3135362D2E3030332D2E3030342D2E3030332D2E3030';
wwv_flow_imp.g_varchar2_table(48959) := '352D2E3130312D2E3135342D2E3030332D2E3030352D2E3030332D2E3030342D2E3130342D2E3135342D2E3030332D2E3030342D2E3030332D2E3030352D2E3130362D2E3135322D2E3030332D2E3030352D2E3030332D2E3030342D2E3130382D2E3135';
wwv_flow_imp.g_varchar2_table(48960) := '312D2E3030332D2E3030342D2E3030332D2E3030352D2E31312D2E31352D2E3030332D2E3030342D2E3030332D2E3030342D2E3131312D2E31352D2E3030342D2E3030332D2E3030332D2E3030352D2E3131332D2E3134372D2E3030342D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(48961) := '3030332D2E3030352D2E3131352D2E3134362D2E3030342D2E3030342D2E3030332D2E3030342D2E3131372D2E3134352D2E3030342D2E3030342D2E3030332D2E3030342D2E31322D2E3134342D2E3030332D2E3030342D2E3030332D2E3030342D2E31';
wwv_flow_imp.g_varchar2_table(48962) := '32312D2E3134322D2E3030342D2E3030342D2E3030332D2E3030342D2E3132332D2E3134312D2E3030332D2E3030342D2E3030342D2E3030342D2E3132352D2E31342D2E3030332D2E3030342D2E3030342D2E3030342D2E3132372D2E3133382D2E3030';
wwv_flow_imp.g_varchar2_table(48963) := '332D2E3030342D2E3030342D2E3030342D2E3132382D2E3133362D2E3030342D2E3030342D2E3030342D2E3030342D2E31332D2E3133352D2E3030342D2E3030342D2E3030342D2E3030342D2E3133322D2E3133342D2E3030332D2E3030342D2E303034';
wwv_flow_imp.g_varchar2_table(48964) := '2D2E3030332D2E3133342D2E3133332D2E3030342D2E3030332D2E3030342D2E3030342D2E3133352D2E31332D2E3030342D2E3030342D2E3030342D2E3030342D2E3133362D2E3132382D2E3030342D2E3030342D2E3030342D2E3030342D2E3133382D';
wwv_flow_imp.g_varchar2_table(48965) := '2E3132362D2E3030342D2E3030342D2E3030342D2E3030332D2E31342D2E3132352D2E3030342D2E3030342D2E3030342D2E3030332D2E31342D2E3132332D2E3030352D2E3030342D2E3030342D2E3030332D2E3134322D2E3132312D2E3030342D2E30';
wwv_flow_imp.g_varchar2_table(48966) := '30342D2E3030342D2E3030332D2E3134342D2E31322D2E3030342D2E3030332D2E3030342D2E3030332D2E3134352D2E3131372D2E3030342D2E3030342D2E3030342D2E3030332D2E3134372D2E3131352D2E3030342D2E3030342D2E3030342D2E3030';
wwv_flow_imp.g_varchar2_table(48967) := '332D2E3134382D2E3131332D2E3030342D2E3030332D2E3030342D2E3030342D2E3134392D2E3131312D2E3030342D2E3030332D2E3030342D2E3030342D2E30352D2E3033362D2E31342D2E3038332D2E31352D2E3035352D2E31362D2E3032377A6D2D';
wwv_flow_imp.g_varchar2_table(48968) := '31382E3338312E3334346C2D2E3136312E3030382D2E3135372E3033372D2E3134372E3036362D2E3131312E3037342D2E30342E3033322D2E3030352E3030332D2E3030342E3030342D2E3134352E3131372D2E3030342E3030332D2E3030342E303034';
wwv_flow_imp.g_varchar2_table(48969) := '2D2E3134342E3131392D2E3030342E3030332D2E3030342E3030342D2E3134322E31322D2E3030342E3030342D2E3030342E3030342D2E3134312E3132332D2E3030342E3030332D2E3030342E3030342D2E31342E3132352D2E3030342E3030332D2E30';
wwv_flow_imp.g_varchar2_table(48970) := '30342E3030342D2E3133382E3132362D2E3030342E3030342D2E3030342E3030342D2E3133362E3132382D2E3030342E3030342D2E3030342E3030342D2E3133352E31332D2E3030342E3030342D2E3030342E3030332D2E3133342E3133332D2E303034';
wwv_flow_imp.g_varchar2_table(48971) := '2E3030334C342E36383220356C2D2E3133322E3133342D2E3030332E3030342D2E3030342E3030342D2E31332E3133352D2E3030342E3030342D2E3030342E3030342D2E3132382E3133362D2E3030342E3030342D2E3030342E3030342D2E3132362E31';
wwv_flow_imp.g_varchar2_table(48972) := '33382D2E3030342E3030342D2E3030332E3030342D2E3132352E31342D2E3030342E3030342D2E3030332E3030342D2E3132332E31342D2E3030342E3030352D2E3030332E3030342D2E3132312E3134322D2E3030342E3030342D2E3030332E3030342D';
wwv_flow_imp.g_varchar2_table(48973) := '2E31322E3134342D2E3030332E3030342D2E3030332E3030342D2E3131372E3134352D2E3030342E3030342D2E3030332E3030342D2E3131352E3134362D2E3030342E3030352D2E3030332E3030342D2E3131332E3134372D2E3030332E3030352D2E30';
wwv_flow_imp.g_varchar2_table(48974) := '30342E3030342D2E3131312E3134392D2E3030332E3030342D2E3030342E3030342D2E31312E31352D2E3030322E3030352D2E3030332E3030342D2E3130382E3135312D2E3030332E3030342D2E3030332E3030352D2E3130362E3135322D2E3030332E';
wwv_flow_imp.g_varchar2_table(48975) := '3030352D2E3030332E3030342D2E3130342E3135342D2E3030332E3030342D2E3030332E3030352D2E3130322E3135342D2E3030332E3030352D2E3030322E3030342D2E312E3135362D2E3030332E3030352D2E3030332E3030342D2E3039382E313537';
wwv_flow_imp.g_varchar2_table(48976) := '2D2E3030332E3030352D2E3030332E3030342D2E3039362E3135392D2E3030322E3030342D2E3030332E3030352D2E3039342E31362D2E3030332E3030342D2E3030322E3030342D2E3039322E31362D2E3030332E3030352D2E3030332E3030352D2E30';
wwv_flow_imp.g_varchar2_table(48977) := '392E3136312D2E3030322E3030352D2E3030332E3030352D2E3038382E3136322D2E3030322E3030352D2E3030332E3030342D2E3038362E3136342D2E3030322E3030352D2E3030322E3030342D2E3038342E3136352D2E3030332E3030352D2E303032';
wwv_flow_imp.g_varchar2_table(48978) := '2E3030342D2E3038322E3136362D2E3030322E3030342D2E3030332E3030352D2E30382E3136372D2E3030322E3030342D2E3030322E3030352D2E3037382E3136382D2E3030322E3030342D2E3030322E3030352D2E3034352E312D2E3035332E313533';
wwv_flow_imp.g_varchar2_table(48979) := '2D2E3032332E31362E3030372E31362E3033372E3135372E3036352E3134382E3039322E3133322E3131342E3131342E3133342E30392E3134382E3036342E3135372E3033352E3136312E3030362E31362D2E3032352E3135322D2E3035342E31342D2E';
wwv_flow_imp.g_varchar2_table(48980) := '30382E3132312D2E3130362E312D2E3132362E3036352D2E3131382E3034332D2E3039352E3037342D2E31362E3037352D2E3135352E3037372D2E3135372E30382D2E3135352E30382D2E3135322E3038332D2E3135352E3038352D2E3135322E303836';
wwv_flow_imp.g_varchar2_table(48981) := '2D2E31352E3038382D2E3134392E3039312D2E31352E3039342D2E31352E3039342D2E3134372E3039352D2E3134352E3039392D2E3134362E312D2E3134342E312D2E3134322E3130342D2E31342E3130342D2E31342E31312D2E3134322E3130372D2E';
wwv_flow_imp.g_varchar2_table(48982) := '3133372E31312D2E3133362E3131342D2E3133362E3131332D2E3133342E3131372D2E3133332E3131382D2E3133322E3131372D2E3132392E3132322D2E31332E3132342D2E3132372E3132332D2E3132362E3132372D2E3132352E3132372D2E313232';
wwv_flow_imp.g_varchar2_table(48983) := '2E3132382D2E31322E3133322D2E3132322E31332D2E3131352E3133332D2E3131372E3133352D2E3131352E3133352D2E3131312E3133362D2E31312E3033372D2E30332E3131372D2E31312E3039342D2E3133322E3036382D2E3134362E30342D2E31';
wwv_flow_imp.g_varchar2_table(48984) := '35362E30312D2E3136312D2E30322D2E31362D2E30352D2E3135342D2E3037362D2E3134312D2E3130322D2E3132352D2E3132332D2E3130342D2E31342D2E30382D2E3135332D2E3035312D2E31362D2E3032337A4D313620332E353935682D2E303035';
wwv_flow_imp.g_varchar2_table(48985) := '6C2D2E3134382E303031682D2E30316C2D2E3134372E303033682D2E3031316C2D2E3134372E303035682D2E3031316C2D2E3134362E303037682D2E3031316C2D2E3134362E303039682D2E3031316C2D2E3134362E3031682D2E3030356C2D2E303035';
wwv_flow_imp.g_varchar2_table(48986) := '2E3030312D2E3134362E303132682D2E3031316C2D2E3134352E303134682D2E3030366C2D2E3030352E3030312D2E30352E3030362D2E3135382E3033312D2E31352E30362D2E3133352E3038382D2E3131372E3131312D2E3039342E31332D2E303639';
wwv_flow_imp.g_varchar2_table(48987) := '2E3134372D2E30342E3135362D2E30312E31362E3031392E31362E3034392E3135342E3037362E3134322E3130322E3132352E3132332E3130352E31342E30382E3135322E3035312E31362E3032332E3133342D2E3030332E3034352D2E3030352E3133';
wwv_flow_imp.g_varchar2_table(48988) := '352D2E3031332E3133332D2E30312E3133362D2E30312E3133352D2E3030372E3133372D2E3030362E3133362D2E3030342E3133362D2E303033682E3237346C2E3133362E3030332E3133362E3030342E3133362E3030362E3133362E3030372E313336';
wwv_flow_imp.g_varchar2_table(48989) := '2E30312E3133332E30312E3133352E3031332E3133352E3031342E3133352E3031362E3133342E3031382E3133322E3031382E3133342E3032312E3133332E3032332E3133332E3032342E3133332E3032352E31332E3032372E3133322E30332E313332';
wwv_flow_imp.g_varchar2_table(48990) := '2E30332E3132392E3033312E31332E3033342E3132392E3033352E3132392E3033362E31332E30342E3132362E3033382E3132382E3034322E3132362E3034322E3132382E3034352E3132372E3034372E3132362E3034372E31322E3034382E3132372E';
wwv_flow_imp.g_varchar2_table(48991) := '3035312E3132332E3035322E3030362E3030322E3134372E3034382E31362E3032312E31362D2E3030392E3135372D2E3033382E3134372D2E3036372E3133312D2E3039332E3131322D2E3131362E3038392D2E3133352E3036322D2E3134392E303333';
wwv_flow_imp.g_varchar2_table(48992) := '2D2E3135382E3030342D2E31362D2E3032372D2E31362D2E3035352D2E3135312D2E3038332D2E3133392D2E3130372D2E31322D2E3132372D2E3039392D2E3131382D2E3036332D2E3030342D2E3030312D2E3030352D2E3030332D2E3030352D2E3030';
wwv_flow_imp.g_varchar2_table(48993) := '322D2E3133332D2E3035362D2E3030352D2E3030322D2E3030352D2E3030322D2E3133342D2E3035342D2E3030342D2E3030322D2E3030352D2E3030322D2E3133352D2E3035332D2E3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E3035';
wwv_flow_imp.g_varchar2_table(48994) := '312D2E3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E30352D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034382D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034362D2E3030352D2E303032';
wwv_flow_imp.g_varchar2_table(48995) := '2D2E3030352D2E3030322D2E3133372D2E3034342D2E3030352D2E3030322D2E3030352D2E3030312D2E3133382D2E3034332D2E3030362D2E3030322D2E3030352D2E3030312D2E3133382D2E3034322D2E3030352D2E3030312D2E3030352D2E303032';
wwv_flow_imp.g_varchar2_table(48996) := '2D2E31342D2E30344831392E346C2D2E3030352D2E3030322D2E31342D2E3033382D2E3030352D2E3030312D2E3030352D2E3030322D2E31342D2E3033362D2E3030352D2E3030312D2E3030352D2E3030312D2E3134312D2E3033352D2E3030352D2E30';
wwv_flow_imp.g_varchar2_table(48997) := '30312D2E3030352D2E3030312D2E3134322D2E3033332D2E3030352D2E3030312D2E3030352D2E3030312D2E3134322D2E3033312D2E3030352D2E303032682D2E3030356C2D2E3134322D2E30332D2E3030352D2E3030312D2E3030352D2E3030312D2E';
wwv_flow_imp.g_varchar2_table(48998) := '3134332D2E303238682D2E3030356C2D2E3030352D2E3030322D2E3134332D2E3032352D2E3030362D2E3030312D2E3030352D2E3030312D2E3134332D2E3032342D2E3030352D2E3030312D2E3030362D2E3030312D2E3134332D2E3032322D2E303036';
wwv_flow_imp.g_varchar2_table(48999) := '2D2E303031682D2E3030356C2D2E3134342D2E303232682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303139682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303137682D2E3030366C2D2E3030352D2E3030312D2E3134352D2E';
wwv_flow_imp.g_varchar2_table(49000) := '303136682D2E3031316C2D2E3134352D2E3031344831372E316C2D2E3030352D2E3030312D2E3134362D2E303132682D2E30316C2D2E3134362D2E30312D2E3030362D2E303031682D2E3030356C2D2E3134362D2E303039682D2E3031316C2D2E313437';
wwv_flow_imp.g_varchar2_table(49001) := '2D2E303036682D2E30314C31362E333220332E36682D2E3031316C2D2E3134372D2E303033682D2E3031316C2D2E3134372D2E3030314831367A6D2D352E34383220312E3336366C2D2E31362E3030382D2E3135372E3033372D2E3132332E3035332D2E';
wwv_flow_imp.g_varchar2_table(49002) := '30362E3033322D2E3030352E3030322D2E3030342E3030332D2E3132382E3036392D2E3030342E3030322D2E3030352E3030332D2E3132362E30372D2E3030352E3030332D2E3030342E3030322D2E3132362E3037322D2E3030352E3030332D2E303034';
wwv_flow_imp.g_varchar2_table(49003) := '2E3030332D2E3132352E3037332D2E3030342E3030332D2E3030352E3030332D2E3132342E3037352D2E3030342E3030332D2E3030352E3030322D2E3132332E3037372D2E3030342E3030332D2E3030352E3030332D2E3132322E3037382D2E3030342E';
wwv_flow_imp.g_varchar2_table(49004) := '3030332D2E3030352E3030332D2E3132312E30382D2E3030342E3030322D2E3030352E3030332D2E31322E3038322D2E3030352E3030332D2E3030342E3030332D2E31322E3038332D2E3030342E3030332D2E3030342E3030332D2E3131382E3038342D';
wwv_flow_imp.g_varchar2_table(49005) := '2E3030352E3030332D2E3030342E3030332D2E3131382E3038362D2E3030342E3030332D2E3030342E3030332D2E3131372E3038382D2E3030342E3030332D2E3030342E3030332D2E3131362E3038392D2E3030342E3030332D2E3030342E3030342D2E';
wwv_flow_imp.g_varchar2_table(49006) := '3131342E30392D2E3030352E3030332D2E3030342E3030332D2E3131332E3039322D2E3030342E3030342D2E3030342E3030332D2E3131332E3039332D2E3030342E3030342D2E3030342E3030332D2E3131312E3039352D2E3030352E3030332D2E3030';
wwv_flow_imp.g_varchar2_table(49007) := '342E3030342D2E31312E3039362D2E3030342E3030342D2E3030342E3030332D2E31312E3039382D2E3030332E3030332D2E3030342E3030342D2E3130382E312D2E3030342E3030332D2E3030342E3030332D2E3130372E3130312D2E3030342E303034';
wwv_flow_imp.g_varchar2_table(49008) := '2D2E3030342E3030332D2E3130362E3130322D2E3030342E3030342D2E3030332E3030342D2E3130352E3130332D2E3030342E3030342D2E3030342E3030342D2E3130332E3130352D2E3030342E3030342D2E3030342E3030332D2E3130322E3130362D';
wwv_flow_imp.g_varchar2_table(49009) := '2E3030332E3030342D2E3030342E3030342D2E312E3130372D2E3030342E3030342D2E3030342E3030342D2E3039392E3130382D2E3030342E3030342D2E3030332E3030342D2E3039382E31312D2E3030332E3030332D2E3030342E3030342D2E303936';
wwv_flow_imp.g_varchar2_table(49010) := '2E31312D2E3030342E3030352D2E3030332E3030342D2E3039352E3131312D2E3030332E3030342D2E3030342E3030342D2E3039332E3131332D2E3030332E3030342D2E3030342E3030342D2E3039322E3131332D2E3030332E3030342D2E3030332E30';
wwv_flow_imp.g_varchar2_table(49011) := '30352D2E30392E3131342D2E3030342E3030342D2E3030332E3030342D2E3038392E3131362D2E3030332E3030342D2E3030332E3030342D2E3038382E3131372D2E3030332E3030342D2E3030332E3030342D2E3038362E3131382D2E3030332E303034';
wwv_flow_imp.g_varchar2_table(49012) := '2D2E3030332E3030352D2E3038342E3131382D2E3030332E3030342D2E3030332E3030352D2E3038332E31322D2E3030332E3030332D2E3030332E3030352D2E3038322E31322D2E3030332E3030352D2E3030322E3030342D2E3036382E3130332D2E30';
wwv_flow_imp.g_varchar2_table(49013) := '37362E3134322D2E3034382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E3039352E31332E3131372E31312E3133362E3038362E31352E30362E3135382E30332E3136322E3030322E3135382D2E30332E3135';
wwv_flow_imp.g_varchar2_table(49014) := '2D2E3035372E3133382D2E3038352E3131392D2E3130392E3038322D2E3130352E3036352D2E3039392E3037352D2E31312E3037372D2E3131332E3037372D2E3130372E30382D2E31312E30382D2E3130382E3038342D2E3130382E3038332D2E313035';
wwv_flow_imp.g_varchar2_table(49015) := '2E3038362D2E3130362E3038362D2E3130342E3038382D2E3130342E3038392D2E3130312E30392D2E3130322E3039332D2E3130312E3039332D2E3039392E3039342D2E3039372E3039352D2E3039362E3039382D2E3039372E3039382D2E3039352E30';
wwv_flow_imp.g_varchar2_table(49016) := '39392D2E3039332E312D2E3039322E3130332D2E3039312E3130312D2E3038392E3130342D2E3038382E3130342D2E3038362E3130362D2E3038362E3130362D2E3038332E3130362D2E3038322E3130392D2E3038322E3130382D2E3037392E31312D2E';
wwv_flow_imp.g_varchar2_table(49017) := '3037382E31312D2E3037362E3131322D2E3037362E3131322D2E3037342E3131332D2E3037322E3131332D2E3037312E3131352D2E30372E3131352D2E3036382E3131382D2E3036372E3131372D2E3036352E31322D2E3036352E3035342D2E3032392E';
wwv_flow_imp.g_varchar2_table(49018) := '3133352D2E3038382E3131362D2E3131312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E3030392D2E3136312D2E30322D2E31362D2E30352D2E3135332D2E3037382D2E3134322D2E3130322D2E3132352D2E3132332D2E3130332D';
wwv_flow_imp.g_varchar2_table(49019) := '2E3134312D2E3037392D2E3135332D2E3035312D2E31362D2E3032327A6D31332E393120322E3131366C2D2E3136322E3030382D2E3135372E3033372D2E3134372E3036362D2E3133322E3039322D2E3131332E3131362D2E30392E3133342D2E303633';
wwv_flow_imp.g_varchar2_table(49020) := '2E3134382D2E3033342E3135372D2E3030352E3136322E3032352E3135392E3035352E3135322E3038322E3133382E3038362E3130332E30392E30392E3039342E3039382E3039322E3039392E3039332E312E3039312E3130332E3038392E3130312E30';
wwv_flow_imp.g_varchar2_table(49021) := '38382E3130342E3038362E3130342E3038362E3130362E3038332E3130352E3038332E3130382E30382E3130382E3038312E31312E3037372E3130372E3037372E3131322E3037352E3131312E3037352E3131342E3037322E3131332E3037312E313133';
wwv_flow_imp.g_varchar2_table(49022) := '2E30372E3131342E3036382E3131382E3036372E3131352E3036352E3131382E3036342E3131372E3036322E3131372E3036312E3132312E3035392E3131392E3035392E3132322E3035362E3132312E3035342E31322E3035352E3132352E3035312E31';
wwv_flow_imp.g_varchar2_table(49023) := '32332E3035312E3132352E3034382E3132332E3034382E3132372E3034372E3132362E3034342E3132352E3034332E3132382E3034322E3132392E3033392E3132362E3033382E31332E3032322E3037362E3035382E31352E3038352E3133372E31312E';
wwv_flow_imp.g_varchar2_table(49024) := '3131392E3132392E3039362E3134352E30372E3135352E3034332E31362E3031332E3136312D2E3031372E3135342D2E3034362E3134342D2E3037352E3132362D2E312E3130362D2E31322E3038322D2E31342E3035352D2E3135312E3032352D2E3136';
wwv_flow_imp.g_varchar2_table(49025) := '2D2E3030352D2E31362D2E3032362D2E3133322D2E3032332D2E3038322D2E3030322D2E3030352D2E3030312D2E3030352D2E3034322D2E3133392D2E3030312D2E3030352D2E3030322D2E3030352D2E3034332D2E3133382D2E3030312D2E3030352D';
wwv_flow_imp.g_varchar2_table(49026) := '2E3030322D2E3030352D2E3034342D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E3034362D2E3133372D2E3030322D2E3030352D2E3030312D2E3030352D2E3034382D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D';
wwv_flow_imp.g_varchar2_table(49027) := '2E30352D2E3133352D2E3030312D2E3030352D2E3030322D2E3030352D2E3035312D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035332D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035342D2E3133332D2E';
wwv_flow_imp.g_varchar2_table(49028) := '3030322D2E3030352D2E3030322D2E3030352D2E3035372D2E3133332D2E3030322D2E3030352D2E3030322D2E3030352D2E3035372D2E3133322D2E3030332D2E3030352D2E3030322D2E3030352D2E30362D2E3133322D2E3030312D2E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49029) := '30322D2E3030342D2E3036312D2E3133322D2E3030332D2E3030342D2E3030322D2E3030352D2E3036332D2E31332D2E3030322D2E3030352D2E3030322D2E3030352D2E3036342D2E31332D2E3030332D2E3030342D2E3030322D2E3030352D2E303636';
wwv_flow_imp.g_varchar2_table(49030) := '2D2E3132392D2E3030322D2E3030342D2E3030332D2E3030352D2E3036372D2E3132382D2E3030322D2E3030352D2E3030332D2E3030342D2E3036392D2E3132382D2E3030322D2E3030342D2E3030332D2E3030352D2E30372D2E3132362D2E3030332D';
wwv_flow_imp.g_varchar2_table(49031) := '2E3030352D2E3030332D2E3030342D2E3037322D2E3132362D2E3030322D2E3030352D2E3030332D2E3030342D2E3037342D2E3132352D2E3030322D2E3030342D2E3030332D2E3030352D2E3037352D2E3132342D2E3030332D2E3030342D2E3030332D';
wwv_flow_imp.g_varchar2_table(49032) := '2E3030352D2E3037362D2E3132332D2E3030332D2E3030342D2E3030332D2E3030352D2E3037382D2E3132322D2E3030332D2E3030342D2E3030332D2E3030352D2E30382D2E3132312D2E3030332D2E3030342D2E3030332D2E3030352D2E3038312D2E';
wwv_flow_imp.g_varchar2_table(49033) := '31322D2E3030332D2E3030352D2E3030332D2E3030342D2E3038332D2E31322D2E3030332D2E3030342D2E3030332D2E3030342D2E3038342D2E3131382D2E3030332D2E3030352D2E3030332D2E3030342D2E3038362D2E3131382D2E3030332D2E3030';
wwv_flow_imp.g_varchar2_table(49034) := '342D2E3030342D2E3030342D2E3038372D2E3131372D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E3131362D2E3030322D2E3030342D2E3030342D2E3030342D2E30392D2E3131342D2E3030332D2E3030352D2E3030342D2E3030342D';
wwv_flow_imp.g_varchar2_table(49035) := '2E3039312D2E3131332D2E3030342D2E3030342D2E3030332D2E3030342D2E3039342D2E3131332D2E3030332D2E3030342D2E3030332D2E3030342D2E3039352D2E3131312D2E3030342D2E3030342D2E3030332D2E3030342D2E3039362D2E31312D2E';
wwv_flow_imp.g_varchar2_table(49036) := '3030342D2E3030352D2E3030332D2E3030342D2E3039382D2E31312D2E3030342D2E3030332D2E3030332D2E3030342D2E312D2E3130382D2E3030332D2E3030342D2E3030342D2E3030342D2E312D2E3130372D2E3030342D2E3030342D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49037) := '3030342D2E3130322D2E3130362D2E3030332D2E3030332D2E3030342D2E3030342D2E3039332D2E3039352D2E3132342D2E3130332D2E31342D2E30382D2E3135332D2E30352D2E31362D2E3032337A4D342E34352031332E3133356C2D2E3136312E30';
wwv_flow_imp.g_varchar2_table(49038) := '30322D2E3135382E3033322D2E31352E30362D2E3133352E3038382D2E3131382E31312D2E3039342E3133312D2E3036392E3134362D2E3033352E3132392D2E3032362E313332762E3030356C2D2E3030322E3030352D2E3032352E3134332D2E303031';
wwv_flow_imp.g_varchar2_table(49039) := '2E3030352D2E3030312E3030362D2E3032342E3134332D2E3030312E3030352D2E3030312E3030362D2E3032322E3134332D2E3030312E3030362D2E3030312E3030352D2E30322E3134342D2E3030312E3030352D2E3030312E3030352D2E3031392E31';
wwv_flow_imp.g_varchar2_table(49040) := '3435762E3030356C2D2E3030312E3030362D2E3031372E313434762E3030366C2D2E3030312E3030352D2E3031362E313435762E3031316C2D2E3031342E313435762E3030356C2D2E3030312E3030362D2E3031322E313436762E30316C2D2E30312E31';
wwv_flow_imp.g_varchar2_table(49041) := '34362D2E3030312E303036762E3030356C2D2E3030392E313436762E3031316C2D2E3030372E313436762E3031316C2D2E3030342E313437762E3031316C2D2E3030332E313437762E30316C2D2E3030322E313438762E30316C2E3030312E313438762E';
wwv_flow_imp.g_varchar2_table(49042) := '30316C2E3030332E313437762E3031316C2E3030352E313437762E30316C2E3030372E313437762E3031316C2E3030392E313436762E3031316C2E30312E313436762E30316C2E3031332E313436762E3031316C2E3031342E313435762E3030356C2E30';
wwv_flow_imp.g_varchar2_table(49043) := '30312E3030362E3031362E313435762E3031316C2E3031382E313434762E3030366C2E3030312E3030352E3031392E313434762E3030366C2E3030312E3030352E3032312E313434762E3030356C2E3030322E3030362E3032322E313433762E3030366C';
wwv_flow_imp.g_varchar2_table(49044) := '2E3030322E3030352E3032342E313433762E3030356C2E3030322E3030362E3032352E3134332E3030312E3030352E3030312E3030352E3032382E3134332E3030312E3030352E3030312E3030352E30332E313432762E3030356C2E3030322E3030362E';
wwv_flow_imp.g_varchar2_table(49045) := '30332E3134312E3030322E3030352E3030312E3030352E3033332E313432762E3030356C2E3030322E3030352E3033352E3134762E3030366C2E3030322E3030352E3033362E31342E3030322E3030352E3030312E3030352E3033382E31342E3030312E';
wwv_flow_imp.g_varchar2_table(49046) := '3030352E3030322E3030352E30342E3134762E3030356C2E3030322E3030352E3034322E3133382E3030312E3030362E3030322E3030352E3034322E3133382E3030322E3030352E3030322E3030352E3031372E3035342E3036342E3134382E30392E31';
wwv_flow_imp.g_varchar2_table(49047) := '33342E3131342E3131342E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030372E31362D2E3032332E3135332D2E3035322E31342D2E30382E3132332D2E3130342E3130322D2E3132352E3037362D2E3134322E3034392D2E3135';
wwv_flow_imp.g_varchar2_table(49048) := '332E30322D2E31362D2E3031312D2E3136312D2E3033312D2E31332D2E3031372D2E3035312D2E3033392D2E3132362D2E3033382D2E31332D2E3033372D2E3132382D2E3033352D2E31332D2E3033332D2E3132382D2E3033332D2E3133342D2E30332D';
wwv_flow_imp.g_varchar2_table(49049) := '2E31332D2E3032392D2E3133312D2E3032362D2E31332D2E3032362D2E3133332D2E3032342D2E3133332D2E3032332D2E3133332D2E30322D2E3133322D2E30322D2E3133362D2E3031372D2E3133322D2E3031362D2E3133352D2E3031342D2E313335';
wwv_flow_imp.g_varchar2_table(49050) := '2D2E3031322D2E3133332D2E3031322D2E3133382D2E3030392D2E3133332D2E3030372D2E3133362D2E3030362D2E3133382D2E3030342D2E3133342D2E3030332D2E313336762D2E3237346C2E3030332D2E3133362E3030342D2E3133342E3030362D';
wwv_flow_imp.g_varchar2_table(49051) := '2E3133392E3030372D2E3133362E30312D2E3133332E30312D2E3133382E3031332D2E3133322E3031342D2E3133352E3031362D2E3133352E3031372D2E3133322E30322D2E3133372E30322D2E31332E3032332D2E3133342E3032342D2E3133332E30';
wwv_flow_imp.g_varchar2_table(49052) := '32342D2E3132362E3031362D2E31362D2E3031342D2E3136312D2E3034342D2E3135352D2E3037322D2E3134352D2E3039382D2E3132382D2E31322D2E3130382D2E3133372D2E3038342D2E31352D2E3035372D2E31362D2E3032397A6D32362E363938';
wwv_flow_imp.g_varchar2_table(49053) := '20312E3630316C2D2E3136312E30312D2E3135372E30342D2E3134362E3036372D2E3133312E3039332D2E3131322E3131372D2E3038382E3133352D2E3036312E3134392D2E3033332E3135372D2E3030352E3133342E3030362E31342E3030362E3137';
wwv_flow_imp.g_varchar2_table(49054) := '362E3030332E3137372E3030312E3137382D2E3030312E3137372D2E3030332E3137382D2E3030362E3137372D2E3030372E3137362D2E30312E3137372D2E3031322E3137362D2E3031352E3137362D2E3031362E3137332D2E3031382E3137352D2E30';
wwv_flow_imp.g_varchar2_table(49055) := '322E3137352D2E3032342E3137342D2E3032352E3137352D2E3032362E31372D2E30332E3137342D2E30332E3137332D2E3033332E31372D2E3033362E3137322D2E3033372E31372D2E30342E31372D2E3034322E3137322D2E3034332E3136382D2E30';
wwv_flow_imp.g_varchar2_table(49056) := '34352E3136362D2E3034382E3136392D2E30352E3136372D2E3035322E3136382D2E3035332E3136342D2E3035362E3136362D2E3035382E3136362D2E30362E31362D2E3036322E3136352D2E3036322E3135382D2E3036362E3136352D2E3036382E31';
wwv_flow_imp.g_varchar2_table(49057) := '362D2E30372E31362D2E30372E3135382D2E3037352E3135392D2E3037342E3135352D2E3037392E3135382D2E30382E3135382D2E30362E31352D2E30332E3135382D2E3030312E3136312E3032392E3135392E3035382E31352E3038352E3133372E31';
wwv_flow_imp.g_varchar2_table(49058) := '30382E3131392E31332E3039372E3134342E30372E3135362E3034342E31362E3031332E31362D2E3031372E3135352D2E3034362E3134332D2E3037342E3132372D2E312E3130372D2E31322E30372D2E3131352E3038332D2E3136342E3030332D2E30';
wwv_flow_imp.g_varchar2_table(49059) := '30352E3030322D2E3030342E3038322D2E3136362E3030322D2E3030352E3030332D2E3030342E30382D2E3136372E3030322D2E3030352E3030322D2E3030342E3037382D2E3136382E3030322D2E3030352E3030322D2E3030342E3037362D2E313639';
wwv_flow_imp.g_varchar2_table(49060) := '2E3030322D2E3030342E3030322D2E3030352E3037342D2E31372E3030322D2E3030342E3030322D2E3030352E3037322D2E31372E3030322D2E3030352E3030322D2E3030352E30372D2E3137312E3030312D2E3030352E3030322D2E3030352E303638';
wwv_flow_imp.g_varchar2_table(49061) := '2D2E3137322E3030322D2E3030342E3030322D2E3030352E3036352D2E3137332E3030322D2E3030352E3030322D2E3030352E3036332D2E3137332E3030322D2E3030352E3030322D2E3030352E30362D2E3137342E3030332D2E3030352E3030312D2E';
wwv_flow_imp.g_varchar2_table(49062) := '3030352E30362D2E3137352E3030312D2E3030352E3030322D2E3030352E3035372D2E3137362E3030312D2E3030352E3030322D2E3030352E3035352D2E3137372E3030312D2E3030352E3030322D2E3030352E3035322D2E3137372E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49063) := '352E3030312D2E3030352E3035312D2E3137382E3030312D2E3030352E3030322D2E3030352E3034382D2E3137392E3030322D2E303035762D2E3030356C2E3034372D2E3137392E3030312D2E3030352E3030322D2E3030352E3034342D2E3138762D2E';
wwv_flow_imp.g_varchar2_table(49064) := '3030356C2E3030322D2E3030352E3034322D2E31382E3030312D2E3030362E3030312D2E3030352E30342D2E3138312E3030312D2E3030352E3030312D2E3030352E3033372D2E3138322E3030322D2E303035762D2E3030356C2E3033362D2E31383276';
wwv_flow_imp.g_varchar2_table(49065) := '2D2E3030366C2E3030322D2E3030352E3033332D2E313832762D2E3030366C2E3030322D2E3030352E30332D2E3138332E3030312D2E3030352E3030312D2E3030352E3032392D2E313834762D2E3030356C2E3030312D2E3030362E3032372D2E313834';
wwv_flow_imp.g_varchar2_table(49066) := '762D2E3030356C2E3030312D2E3030352E3032342D2E313835762D2E3030356C2E3030312D2E3030352E3032322D2E313835762D2E3030366C2E3030312D2E3030352E30322D2E313835762D2E3030366C2E3030312D2E3030352E3031372D2E31383676';
wwv_flow_imp.g_varchar2_table(49067) := '2D2E3030356C2E3030312D2E3030352E3031352D2E313837762D2E3030356C2E3030312D2E3030352E3031332D2E313837762D2E30316C2E30312D2E3138372E3030312D2E303036762D2E3030356C2E3030392D2E313837762D2E3031316C2E3030362D';
wwv_flow_imp.g_varchar2_table(49068) := '2E3138375631362E376C2E3030342D2E313838762D2E3031316C2E3030312D2E313838762D2E30316C2D2E3030312D2E313838762D2E3031316C2D2E3030342D2E313838762D2E3031316C2D2E3030362D2E313837762D2E3031316C2D2E3030372D2E31';
wwv_flow_imp.g_varchar2_table(49069) := '34352D2E3032322D2E31362D2E30352D2E3135322D2E30382D2E3134312D2E3130332D2E3132342D2E3132352D2E3130322D2E3134312D2E3037372D2E3135332D2E30352D2E31362D2E30327A6D2D33302E32312E3537326C2D2E3136312E3030312D2E';
wwv_flow_imp.g_varchar2_table(49070) := '3135382E3033322D2E31352E30362D2E3133362E3038372D2E3131372E31312D2E3039352E3133312D2E3036382E3134362D2E30342E3135362D2E3031322E3133332D2E3030312E3134762E30316C2E3030312E313838762E3031316C2E3030342E3138';
wwv_flow_imp.g_varchar2_table(49071) := '38762E3031316C2E3030362E313837762E3031316C2E3030382E313837762E3031316C2E3031312E313837762E3030356C2E3030312E3030352E3031332E313837762E30316C2E3031362E313837762E30316C2E3031382E313836762E3031316C2E3032';
wwv_flow_imp.g_varchar2_table(49072) := '2E3138352E3030312E303035762E3030366C2E3032322E3138352E3030312E303035762E3030356C2E3032352E313835762E3030356C2E3030312E3030352E3032372E313834762E3030366C2E3030312E3030352E3032392E313834762E3030356C2E30';
wwv_flow_imp.g_varchar2_table(49073) := '30312E3030352E3033312E3138332E3030312E3030352E3030312E3030362E3033332E3138322E3030312E3030352E3030312E3030362E3033352E3138322E3030312E3030352E3030312E3030352E3033382E313832762E3030356C2E3030322E303035';
wwv_flow_imp.g_varchar2_table(49074) := '2E30342E313831762E3030356C2E3030322E3030352E3034322E31382E3030312E3030362E3030312E3030352E3034342E31382E3030322E303035762E3030356C2E3034372E31382E3030312E3030342E3030322E3030352E3034382E3137392E303032';
wwv_flow_imp.g_varchar2_table(49075) := '2E3030352E3030312E3030352E30352E3137382E3030322E3030352E3030312E3030352E3035332E3137372E3030322E3030352E3030312E3030352E3035352E3137372E3030322E3030352E3030312E3030352E3035372E3137362E3030322E3030352E';
wwv_flow_imp.g_varchar2_table(49076) := '3030312E3030352E30362E3137352E3030312E3030352E3030322E3030352E3036312E3137342E3030322E3030352E3030322E3030352E3036332E3137332E3030322E3030352E3030322E3030352E3036352E3137332E3030322E3030352E3030322E30';
wwv_flow_imp.g_varchar2_table(49077) := '30342E3036372E3137322E3030322E3030352E3030322E3030352E30372E3137312E3030322E3030352E3030322E3030352E3037322E31372E3030322E3030352E3030322E3030342E3037342E31372E3030322E3030352E3030322E3030342E3037362E';
wwv_flow_imp.g_varchar2_table(49078) := '3136392E3030322E3030342E3030322E3030352E3037382E3136382E3030322E3030342E3030322E3030352E30382E3136372E3030332E3030342E3030322E3030352E3038322E3136362E3030322E3030342E3030332E3030352E30322E30342E303836';
wwv_flow_imp.g_varchar2_table(49079) := '2E3133362E31312E3131382E31332E3039352E3134362E30372E3135362E3034312E31362E3031322E31362D2E3031392E3135352D2E3034382E3134322D2E3037352E3132362D2E312E3130352D2E3132332E30382D2E31342E3035342D2E3135322E30';
wwv_flow_imp.g_varchar2_table(49080) := '32342D2E31362D2E3030362D2E31362D2E3033362D2E3135382D2E3035312D2E3132332D2E3031382D2E3033342D2E3037382D2E3135382D2E3037342D2E3135352D2E3037342D2E31362D2E3037312D2E3135372D2E30372D2E31362D2E3036382D2E31';
wwv_flow_imp.g_varchar2_table(49081) := '362D2E3036372D2E3136352D2E3036322D2E3135382D2E3036322D2E3136342D2E3035392D2E3136312D2E3035382D2E3136362D2E3035362D2E3136362D2E3035332D2E3136342D2E3035322D2E3136382D2E30352D2E3136372D2E3034382D2E31372D';
wwv_flow_imp.g_varchar2_table(49082) := '2E3034352D2E3136352D2E3034332D2E3136382D2E3034332D2E3137322D2E3033392D2E31372D2E3033372D2E31372D2E3033362D2E3137322D2E3033332D2E31372D2E30332D2E3137332D2E30332D2E3137342D2E3032372D2E31372D2E3032352D2E';
wwv_flow_imp.g_varchar2_table(49083) := '3137352D2E3032322D2E3137342D2E3032312D2E3137352D2E3031382D2E3137352D2E3031372D2E3137332D2E3031342D2E3137362D2E3031322D2E3137362D2E30312D2E3137372D2E3030372D2E3137362D2E3030362D2E3137372D2E3030332D2E31';
wwv_flow_imp.g_varchar2_table(49084) := '37382D2E3030312D2E313737762D2E3133346C2D2E3031332D2E31362D2E3034342D2E3135362D2E3037322D2E3134342D2E3039372D2E3132392D2E31322D2E3130382D2E3133372D2E3038352D2E31352D2E3035372D2E3135392D2E3032387A6D3236';
wwv_flow_imp.g_varchar2_table(49085) := '2E37393820322E3032346C2D2E31362E3030372D2E3135372E3033382D2E3134382E3036362D2E3133322E3039322D2E3131332E3131352D2E30392E3133342D2E3036322E3134382D2E30332E3132372D2E3030312E3030342D2E3032332E3133342D2E';
wwv_flow_imp.g_varchar2_table(49086) := '3032342E3133332D2E3032362E3133332D2E3032362E31332D2E30332E3133322D2E30332E3132392D2E3033322E3133342D2E3033332E3132382D2E3033352E31332D2E3033372E3132382D2E3033382E31332D2E30342E3132362D2E30342E3132382D';
wwv_flow_imp.g_varchar2_table(49087) := '2E3034342E3132382D2E3034342E3132362D2E3034362E3132362D2E3034382E3132362D2E30352E3132352D2E30352E3132352D2E3035312E3132322D2E3035342E3132332D2E3035352E3132322D2E3035362E31322D2E3035382E3132322D2E30362E';
wwv_flow_imp.g_varchar2_table(49088) := '31322D2E3036312E31322D2E3036332E3131392D2E3036322E3131362D2E3036372E3131392D2E3036362E3131362D2E3036392E3131352D2E3036392E3131352D2E30372E3131332D2E3037332E3131332D2E3037342E3131322D2E3037362E3131332D';
wwv_flow_imp.g_varchar2_table(49089) := '2E3037372E3131322D2E3037372E3130372D2E30382E31312D2E30382E3130372D2E3038352E31312D2E3034342E3035362D2E3038382E3133352D2E30362E31352D2E3033332E3135382D2E3030322E31362E3032372E31362E3035372E31352E303833';
wwv_flow_imp.g_varchar2_table(49090) := '2E3133382E3130382E31322E3132382E3039382E3134342E3037322E3135352E3034352E31362E3031352E3136312D2E3031362E3135352D2E3034342E3134342D2E3037332E3132382D2E3039382E30392D2E3039392E30352D2E3036312E3030332D2E';
wwv_flow_imp.g_varchar2_table(49091) := '3030342E3030332D2E3030352E3038392D2E3131352E3030332D2E3030342E3030332D2E3030352E3038382D2E3131362E3030332D2E3030342E3030332D2E3030352E3038362D2E3131372E3030332D2E3030342E3030332D2E3030352E3038342D2E31';
wwv_flow_imp.g_varchar2_table(49092) := '31382E3030332D2E3030342E3030332D2E3030352E3038332D2E31322E3030332D2E3030342E3030332D2E3030342E3038312D2E31322E3030332D2E3030352E3030332D2E3030342E30382D2E3132312E3030332D2E3030352E3030332D2E3030342E30';
wwv_flow_imp.g_varchar2_table(49093) := '37382D2E3132322E3030332D2E3030352E3030332D2E3030342E3037372D2E3132332E3030322D2E3030352E3030332D2E3030342E3037352D2E3132342E3030332D2E3030352E3030332D2E3030342E3037332D2E3132352E3030332D2E3030352E3030';
wwv_flow_imp.g_varchar2_table(49094) := '332D2E3030342E3037322D2E3132362E3030322D2E3030342E3030332D2E3030352E30372D2E3132362E3030332D2E3030352E3030322D2E3030352E30372D2E3132372E3030322D2E3030342E3030322D2E3030352E3036382D2E3132382E3030322D2E';
wwv_flow_imp.g_varchar2_table(49095) := '3030352E3030322D2E3030342E3036362D2E31332E3030332D2E3030342E3030322D2E3030352E3036342D2E31332E3030322D2E3030342E3030332D2E3030352E3036322D2E31332E3030322D2E3030352E3030332D2E3030352E30362D2E31332E3030';
wwv_flow_imp.g_varchar2_table(49096) := '332D2E3030352E3030322D2E3030352E30362D2E3133322E3030322D2E3030352E3030322D2E3030352E3035372D2E3133322E3030332D2E3030352E3030322D2E3030352E3035362D2E3133332E3030322D2E3030352E3030322D2E3030352E3035342D';
wwv_flow_imp.g_varchar2_table(49097) := '2E3133342E3030322D2E3030342E3030322D2E3030352E3035332D2E3133352E3030322D2E3030352E3030322D2E3030352E3035312D2E3133352E3030322D2E3030352E3030322D2E3030352E30352D2E3133352E3030312D2E3030352E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49098) := '30352E3034382D2E3133372E3030312D2E3030352E3030322D2E3030352E3034362D2E3133372E3030322D2E3030352E3030322D2E3030352E3034342D2E3133372E3030322D2E3030352E3030322D2E3030352E3034322D2E3133382E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49099) := '352E3030312D2E3030362E3034322D2E3133382E3030312D2E3030352E3030322D2E3030352E30342D2E3134762D2E3030356C2E3030322D2E3030352E3033382D2E31342E3030312D2E3030352E3030322D2E3030352E3033362D2E31342E3030312D2E';
wwv_flow_imp.g_varchar2_table(49100) := '3030352E3030312D2E3030352E3033352D2E3134312E3030312D2E3030352E3030312D2E3030352E3033332D2E3134322E3030312D2E3030352E3030312D2E3030352E3033312D2E3134312E3030312D2E3030362E3030322D2E3030352E3032392D2E31';
wwv_flow_imp.g_varchar2_table(49101) := '3432762D2E3030356C2E3030322D2E3030352E3032382D2E313433762D2E3030356C2E3030322D2E3030352E3032352D2E3134332E3030312D2E3030362E3030312D2E3030352E3032342D2E3134332E3030312D2E3030352E3030312D2E3030362E3030';
wwv_flow_imp.g_varchar2_table(49102) := '312D2E3030362E30312D2E3136312D2E30322D2E31362D2E30352D2E3135342D2E3037372D2E3134312D2E3130322D2E3132352D2E3132332D2E3130342D2E3134312D2E3037392D2E3135332D2E3035312D2E31362D2E3032327A4D362E383431203233';
wwv_flow_imp.g_varchar2_table(49103) := '2E3031396C2D2E31362E3032342D2E3135322E3035332D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E3134322D2E3034382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E303737';
wwv_flow_imp.g_varchar2_table(49104) := '2E3130392E30342E3034382E3030332E3030342E3030332E3030342E3039352E3131312E3030332E3030342E3030342E3030342E3039362E31312E3030342E3030352E3030332E3030342E3039382E3130392E3030332E3030342E3030342E3030342E31';
wwv_flow_imp.g_varchar2_table(49105) := '2E3130382E3030332E3030342E3030332E3030342E3130312E3130372E3030342E3030342E3030332E3030342E3130322E3130352E3030342E3030342E3030342E3030342E3130332E3130352E3030342E3030342E3030342E3030332E3130352E313034';
wwv_flow_imp.g_varchar2_table(49106) := '2E3030332E3030342E3030342E3030332E3130362E3130322E3030342E3030342E3030342E3030342E3130372E312E3030342E3030342E3030342E3030342E3130382E3039392E3030342E3030332E3030342E3030342E31312E3039382E3030332E3030';
wwv_flow_imp.g_varchar2_table(49107) := '332E3030342E3030342E31312E3039362E3030342E3030332E3030352E3030342E31312E3039352E3030352E3030332E3030342E3030342E3131332E3039332E3030342E3030332E3030342E3030342E3131332E3039312E3030342E3030342E3030352E';
wwv_flow_imp.g_varchar2_table(49108) := '3030332E3131342E30392E3030342E3030342E3030342E3030332E3131362E3038392E3030342E3030332E3030342E3030332E3131372E3038382E3030342E3030332E3030342E3030332E3131382E3038362E3030342E3030332E3030352E3030332E31';
wwv_flow_imp.g_varchar2_table(49109) := '31382E3038342E3030342E3030332E3030352E3030332E3131392E3038332E3030342E3030332E3030352E3030332E31322E3038312E3030352E3030332E3030342E3030332E3132312E30382E3030352E3030332E3030342E3030332E3132322E303738';
wwv_flow_imp.g_varchar2_table(49110) := '2E3030352E3030332E3030342E3030332E3132332E3037362E3030352E3030332E3030342E3030332E3132342E3037352E3030352E3030332E3030342E3030332E3132352E3037332E3030342E3030332E3030352E3030322E3132362E3037332E303034';
wwv_flow_imp.g_varchar2_table(49111) := '2E3030322E3030352E3030332E3132362E30372E3030352E3030332E3030342E3030322E3132382E30372E3030342E3030322E3030352E3030322E3132382E3036372E3030352E3030332E3030342E3030322E31332E3036362E3030342E3030322E3030';
wwv_flow_imp.g_varchar2_table(49112) := '352E3030332E31332E3036342E3030342E3030322E3030352E3030332E31332E3036322E3030352E3030322E3030342E3030332E3133322E30362E3030342E3030332E3030352E3030322E3133322E30362E3030352E3030322E3030352E3030322E3133';
wwv_flow_imp.g_varchar2_table(49113) := '322E3035372E3030352E3030322E3030352E3030322E3133332E3035372E3030352E3030322E3030352E3030322E3133332E3035342E3030352E3030322E3030352E3030322E31332E30352E3135342E3034352E31362E3031362E31362D2E3031352E31';
wwv_flow_imp.g_varchar2_table(49114) := '35362D2E3034352E3134342D2E3037322E3132382D2E3039382E3130382D2E31322E3038332D2E3133382E3035372D2E31352E3032382D2E31362D2E3030332D2E31362D2E3033322D2E3135392D2E3036312D2E3134392D2E3038382D2E3133352D2E31';
wwv_flow_imp.g_varchar2_table(49115) := '312D2E3131372D2E3133322D2E3039342D2E31322D2E3035382D2E3132342D2E3034392D2E3132362D2E3035312D2E3132322D2E3035312D2E3132322D2E3035342D2E31322D2E3035342D2E3132362D2E3035382D2E3131392D2E3035372D2E31322D2E';
wwv_flow_imp.g_varchar2_table(49116) := '30362D2E31322D2E30362D2E3131382D2E3036332D2E3131372D2E3036342D2E3131392D2E3036362D2E3131362D2E3036362D2E3131352D2E3036382D2E3131352D2E30372D2E3131332D2E30372D2E3131352D2E3037342D2E3131322D2E3037342D2E';
wwv_flow_imp.g_varchar2_table(49117) := '31312D2E3037352D2E31312D2E3037362D2E3131322D2E30382D2E31312D2E30382D2E3130392D2E3038312D2E3130362D2E3038322D2E3130342D2E3038322D2E3130362D2E3038362D2E3130352D2E3038372D2E3130312D2E3038362D2E3130352D2E';
wwv_flow_imp.g_varchar2_table(49118) := '3039312D2E312D2E30392D2E312D2E3039312D2E312D2E3039342D2E3039372D2E3039342D2E312D2E3039382D2E3039332D2E3039352D2E3039362D2E312D2E3039332D2E3039382D2E3039322D2E3130312D2E3038392D2E312D2E30392D2E3130322D';
wwv_flow_imp.g_varchar2_table(49119) := '2E3038382D2E3130342D2E3033362D2E3034332D2E3131342D2E3131342D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E3033362D2E3136312D2E3030367A6D31352E30363320322E3730316C2D2E31362E3031342D2E3135362E3034';
wwv_flow_imp.g_varchar2_table(49120) := '342D2E31322E3035372D2E30362E3033342D2E31322E3036362D2E3131372E3036342D2E3131382E3036322D2E31322E3036312D2E31322E30362D2E3131382E3035372D2E3132362E3035382D2E31322E3035342D2E3132322E3035342D2E3132322E30';
wwv_flow_imp.g_varchar2_table(49121) := '352D2E3132362E3035322D2E3132352E30352D2E3132342E3034362D2E3132372E3034372D2E3132352E3034342D2E3132392E3034332D2E3132362E30342D2E31332E3034322D2E3132382E3033382D2E3132372E3033352D2E31332E3033362D2E3133';
wwv_flow_imp.g_varchar2_table(49122) := '312E3033342D2E3132392E3033312D2E3133322E30332D2E31332E30332D2E3133352E3032372D2E3133332E3032362D2E31332E3032332D2E31332E3032322D2E3133372E3032312D2E3133322E30322D2E3133342E3031372D2E3133322E3031352D2E';
wwv_flow_imp.g_varchar2_table(49123) := '3133382E3031352D2E3133352E3031332D2E3133332E30312D2E3133382E30312D2E3133362E3030372D2E3133342E3030362D2E3133362E3030342D2E31342E3030332D2E31362E3031382D2E3135352E3034372D2E3134322E3037362D2E3132372E31';
wwv_flow_imp.g_varchar2_table(49124) := '2D2E3130352E3132322D2E30382E31342D2E3035342E3135312D2E3032352E31362E3030362E31362E3033352E3135382E3036342E3134382E30392E3133342E3131342E3131342E3133332E3039322E3134372E3036352E3135372E3033362E3133342E';
wwv_flow_imp.g_varchar2_table(49125) := '3030382E3134352D2E303032682E3031316C2E3134372D2E303035682E30316C2E3134372D2E303037682E3031316C2E3134362D2E303039682E3031316C2E3134362D2E3031682E3030356C2E3030352D2E3030312E3134362D2E303132682E3031316C';
wwv_flow_imp.g_varchar2_table(49126) := '2E3134352D2E303134682E3030356C2E3030362D2E3030312E3134352D2E303136682E3031316C2E3134342D2E303138682E3030366C2E3030352D2E3030312E3134342D2E3032682E3031316C2E3134342D2E3032312E3030352D2E303031682E303036';
wwv_flow_imp.g_varchar2_table(49127) := '6C2E3134332D2E3032332E3030362D2E303031682E3030356C2E3134332D2E303235682E3030356C2E3030362D2E3030322E3134332D2E303236682E3030356C2E3030352D2E3030322E3134332D2E3032372E3030352D2E3030312E3030352D2E303031';
wwv_flow_imp.g_varchar2_table(49128) := '2E3134322D2E3033682E3030356C2E3030352D2E3030322E3134322D2E30332E3030352D2E3030322E3030352D2E3030312E3134322D2E3033332E3030352D2E3030312E3030352D2E3030312E31342D2E3033352E3030362D2E3030312E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49129) := '30312E31342D2E303337682E3030356C2E3030352D2E3030322E31342D2E3033382E3030352D2E303032682E3030356C2E31342D2E30342E3030352D2E3030322E3030352D2E3030312E3133382D2E3034322E3030352D2E3030312E3030362D2E303032';
wwv_flow_imp.g_varchar2_table(49130) := '2E3133382D2E3034332E3030352D2E3030312E3030352D2E3030322E3133372D2E3034342E3030352D2E3030322E3030352D2E3030322E3133372D2E3034362E3030352D2E3030322E3030352D2E3030312E3133372D2E3034382E3030352D2E3030322E';
wwv_flow_imp.g_varchar2_table(49131) := '3030352D2E3030322E3133352D2E30352E3030352D2E3030312E3030352D2E3030322E3133352D2E3035312E3030352D2E3030322E3030352D2E3030322E3133352D2E3035332E3030352D2E3030322E3030342D2E3030322E3133342D2E3035342E3030';
wwv_flow_imp.g_varchar2_table(49132) := '352D2E3030322E3030352D2E3030322E3133332D2E3035372E3030352D2E3030322E3030352D2E3030322E3133322D2E3035372E3030352D2E3030332E3030352D2E3030322E3133322D2E30362E3030352D2E3030312E3030342D2E3030322E3133312D';
wwv_flow_imp.g_varchar2_table(49133) := '2E3036312E3030352D2E3030332E3030352D2E3030322E31332D2E3036322E3030352D2E3030332E3030352D2E3030322E31332D2E3036342E3030342D2E3030332E3030352D2E3030322E3132382D2E3036362E3030352D2E3030322E3030352D2E3030';
wwv_flow_imp.g_varchar2_table(49134) := '332E3132382D2E3036372E3030352D2E3030322E3030342D2E3030332E3132372D2E3036392E3030352D2E3030322E3030352D2E3030332E3132362D2E30372E3030352D2E3030332E3030342D2E3030332E3036352D2E3033372E3133322D2E3039332E';
wwv_flow_imp.g_varchar2_table(49135) := '3131322D2E3131352E3038392D2E3133352E3036322D2E3134392E3033342D2E3135372E3030332D2E3136312D2E3032362D2E31362D2E3035352D2E31352D2E3038322D2E31342D2E3130372D2E31322D2E3132372D2E312D2E3134342D2E3037332D2E';
wwv_flow_imp.g_varchar2_table(49136) := '3135342D2E3034362D2E31362D2E3031367A4D362E33332032372E3132376C2D2E31362E3032332D2E3135322E3035332D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E3134322D2E3034382E3135342D2E30322E31362E30';
wwv_flow_imp.g_varchar2_table(49137) := '31322E3136312E3034312E3135362E30372E3134362E3039342E31332E3039362E3039332E3033322E3032362E3030342E3030332E3030342E3030342E3134352E3131372E3030342E3030332E3030342E3030342E3134362E3131352E3030352E303033';
wwv_flow_imp.g_varchar2_table(49138) := '2E3030342E3030342E3134372E3131332E3030352E3030332E3030342E3030342E3134392E3131312E3030342E3030332E3030342E3030332E31352E31312E3030352E3030332E3030342E3030332E3135312E3130382E3030342E3030332E3030352E30';
wwv_flow_imp.g_varchar2_table(49139) := '30332E3135322E3130362E3030352E3030332E3030342E3030332E3135342E3130342E3030342E3030332E3030352E3030332E3135342E3130322E3030352E3030322E3030342E3030332E3135362E312E3030352E3030332E3030342E3030332E313537';
wwv_flow_imp.g_varchar2_table(49140) := '2E3039382E3030352E3030332E3030342E3030322E3135392E3039362E3030342E3030332E3030352E3030332E31362E3039342E3030342E3030332E3030342E3030322E31362E3039322E3030352E3030332E3030352E3030322E3136312E30392E3030';
wwv_flow_imp.g_varchar2_table(49141) := '352E3030332E3030352E3030322E3136322E3038382E3030352E3030332E3030342E3030322E3136342E3038362E3030352E3030332E3030342E3030322E3136352E3038342E3030352E3030332E3030342E3030322E3136362E3038322E3030342E3030';
wwv_flow_imp.g_varchar2_table(49142) := '322E3030352E3030332E3136372E30382E3030342E3030322E3030352E3030322E3136382E3037382E3030342E3030322E3030352E3030322E3136382E3037362E3030352E3030322E3030352E3030322E31372E3037342E3030342E3030322E3030352E';
wwv_flow_imp.g_varchar2_table(49143) := '3030322E31372E3037322E3030352E3030322E3030352E3030322E31372E30372E3030362E3030322E3030352E3030312E3137312E3036382E3030352E3030322E3030352E3030322E3137332E3036352E3030352E3030322E3030352E3030322E313733';
wwv_flow_imp.g_varchar2_table(49144) := '2E3036332E3030352E3030322E3030352E3030322E3137342E30362E3030352E3030332E3030352E3030312E3137352E30362E3030352E3030312E3030352E3030322E3137362E3035372E3030352E3030312E3030352E3030322E3137362E3035352E30';
wwv_flow_imp.g_varchar2_table(49145) := '30362E3030312E3030352E3030322E3137372E3035322E3030352E3030322E3030352E3030312E3137382E30352E3030352E3030322E3030352E3030322E3137382E3034382E3030362E3030312E3030352E3030322E3137392E3034362E3030352E3030';
wwv_flow_imp.g_varchar2_table(49146) := '312E3030352E3030322E31382E303434682E3030356C2E3030352E3030322E31382E3034322E3030362E3030312E3030352E3030312E3135392E3033352E31362E30322E31362D2E30312E3135372D2E30342E3134362D2E3036392E31332D2E3039342E';
wwv_flow_imp.g_varchar2_table(49147) := '3131322D2E3131372E3038372D2E3133362E30362D2E3134392E3033332D2E3135382E3030322D2E3136312D2E3032382D2E3135392D2E3035372D2E31352D2E3038342D2E3133382D2E3130382D2E31322D2E3132382D2E3039382D2E3134342D2E3037';
wwv_flow_imp.g_varchar2_table(49148) := '322D2E3132382D2E3033392D2E3135342D2E3033332D2E3136382D2E30342D2E3137312D2E3034312D2E31372D2E3034342D2E3136382D2E3034362D2E3136372D2E3034372D2E3136382D2E30352D2E3136352D2E3035312D2E3136362D2E3035342D2E';
wwv_flow_imp.g_varchar2_table(49149) := '3136362D2E3035362D2E3136332D2E3035372D2E3136352D2E30362D2E3136312D2E3036322D2E3136342D2E3036342D2E31362D2E3036352D2E31362D2E3036382D2E3136322D2E30372D2E3135372D2E30372D2E3135372D2E3037342D2E3135372D2E';
wwv_flow_imp.g_varchar2_table(49150) := '3037352D2E3135362D2E3037372D2E3135332D2E3037392D2E3135362D2E3038322D2E3135332D2E3038322D2E3135342D2E3038362D2E31352D2E3038362D2E3135322D2E30392D2E3134382D2E30392D2E3134372D2E3039322D2E3134392D2E303935';
wwv_flow_imp.g_varchar2_table(49151) := '2D2E3134352D2E3039352D2E3134342D2E3039382D2E3134352D2E312D2E3134332D2E3130322D2E31342D2E3130332D2E31342D2E3130342D2E31342D2E3130382D2E3133392D2E31312D2E3133362D2E31312D2E3032372D2E3032322D2E3133332D2E';
wwv_flow_imp.g_varchar2_table(49152) := '3039312D2E3134382D2E3036352D2E3135372D2E3033362D2E3136312D2E3030367A6D31392E3231352E3038376C2D2E31362E30312D2E3135372E3033392D2E3134362E3036372D2E31312E3037362D2E3036342E3035312D2E3133392E31312D2E3134';
wwv_flow_imp.g_varchar2_table(49153) := '2E3130382D2E31342E3130342D2E31342E3130332D2E3134332E3130312D2E3134352E3130312D2E3134342E3039382D2E3134352E3039352D2E3134392E3039352D2E3134382E3039332D2E3134372E3038392D2E3135322E30392D2E31352E3038362D';
wwv_flow_imp.g_varchar2_table(49154) := '2E3135342E3038362D2E3135332E3038322D2E3135362E3038322D2E3135332E3037392D2E3135362E3037372D2E3135372E3037352D2E3135382E3037332D2E3135372E3037312D2E31362E30372D2E31362E3036382D2E3136312E3036352D2E313634';
wwv_flow_imp.g_varchar2_table(49155) := '2E3036342D2E3136312E3036312D2E3136352E30362D2E3136332E3035382D2E3136362E3035362D2E3136362E3035342D2E3136362E3035312D2E3136372E30352D2E3136372E3034372D2E31372E3034362D2E3136382E3034342D2E3137312E303432';
wwv_flow_imp.g_varchar2_table(49156) := '2D2E3136382E3033392D2E31372E3033372D2E31312E3032332D2E3135342E3034372D2E3134332E3037352D2E3132362E312D2E3130362E3132322D2E3038312E3133392D2E3035342E3135322D2E3032352E31362E3030362E31362E3033352E313538';
wwv_flow_imp.g_varchar2_table(49157) := '2E3036332E3134382E30392E3133332E3131342E3131352E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030372E3133332D2E3031362E3131352D2E3032342E3030352D2E3030312E3030352D2E3030312E3138312D2E3034682E';
wwv_flow_imp.g_varchar2_table(49158) := '3030356C2E3030352D2E3030322E31382D2E3034322E3030362D2E3030312E3030352D2E3030312E31382D2E3034342E3030352D2E3030322E3030352D2E3030312E31382D2E3034362E3030342D2E303032682E3030356C2E3137392D2E3035682E3030';
wwv_flow_imp.g_varchar2_table(49159) := '356C2E3030352D2E3030322E3137382D2E30352E3030352D2E3030322E3030352D2E3030322E3137372D2E3035322E3030352D2E3030322E3030352D2E3030312E3137372D2E3035352E3030352D2E3030322E3030352D2E3030312E3137362D2E303537';
wwv_flow_imp.g_varchar2_table(49160) := '2E3030352D2E3030322E3030352D2E3030322E3137352D2E3035392E3030352D2E3030312E3030352D2E3030322E3137342D2E3036312E3030352D2E3030322E3030352D2E3030322E3137332D2E3036332E3030352D2E3030322E3030352D2E3030322E';
wwv_flow_imp.g_varchar2_table(49161) := '3137332D2E3036352E3030342D2E3030322E3030352D2E3030322E3137322D2E3036382E3030352D2E3030322E3030352D2E3030322E3137312D2E30372E3030352D2E3030312E3030352D2E3030322E31372D2E3037322E3030352D2E3030322E303034';
wwv_flow_imp.g_varchar2_table(49162) := '2D2E3030322E31372D2E3037342E3030352D2E3030322E3030342D2E3030322E3136392D2E3037362E3030342D2E3030322E3030352D2E3030322E3136382D2E3037382E3030342D2E3030322E3030352D2E3030332E3136372D2E30382E3030342D2E30';
wwv_flow_imp.g_varchar2_table(49163) := '30322E3030352D2E3030322E3136362D2E3038322E3030342D2E3030322E3030352D2E3030332E3136352D2E3038342E3030342D2E3030322E3030352D2E3030332E3136332D2E3038362E3030352D2E3030322E3030352D2E3030332E3136322D2E3038';
wwv_flow_imp.g_varchar2_table(49164) := '382E3030352D2E3030322E3030352D2E3030332E3136312D2E30392E3030352D2E3030322E3030342D2E3030332E31362D2E3039322E3030352D2E3030332E3030352D2E3030322E31362D2E3039342E3030342D2E3030332E3030342D2E3030332E3135';
wwv_flow_imp.g_varchar2_table(49165) := '382D2E3039362E3030352D2E3030322E3030342D2E3030332E3135382D2E3039382E3030342D2E3030332E3030352D2E3030332E3135362D2E312E3030342D2E3030332E3030342D2E3030332E3135352D2E3130312E3030352D2E3030332E3030342D2E';
wwv_flow_imp.g_varchar2_table(49166) := '3030332E3135342D2E3130342E3030342D2E3030332E3030342D2E3030332E3135332D2E3130362E3030342D2E3030332E3030352D2E3030332E3135312D2E3130382E3030342D2E3030332E3030352D2E3030332E31352D2E31312E3030342D2E303033';
wwv_flow_imp.g_varchar2_table(49167) := '2E3030342D2E3030332E3134392D2E3131322E3030342D2E3030332E3030342D2E3030332E3134382D2E3131332E3030342D2E3030342E3030342D2E3030332E3134372D2E3131352E3030342D2E3030342E3030342D2E3030332E3036382D2E3035352E';
wwv_flow_imp.g_varchar2_table(49168) := '3131362D2E3131332E3039322D2E3133322E3036362D2E3134372E3033382D2E3135372E3030382D2E31362D2E3032322D2E31362D2E30352D2E3135332D2E30382D2E31342D2E3130332D2E3132352D2E3132342D2E3130322D2E3134322D2E3037372D';
wwv_flow_imp.g_varchar2_table(49169) := '2E3135332D2E30352D2E31362D2E30327A227D29293B66756E6374696F6E20536A28297B72657475726E20536A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F7228766172';
wwv_flow_imp.g_varchar2_table(49170) := '20743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D';
wwv_flow_imp.g_varchar2_table(49171) := '6E5B695D297D72657475726E20657D2C536A2E6170706C79286E756C6C2C617267756D656E7473297D76617220786A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C536A287B786D6C6E733A22687474703A2F2F777777';
wwv_flow_imp.g_varchar2_table(49172) := '2E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31362E30313220392E323232632D312E36373320342E3635372D322E37333520392E3530382D342E';
wwv_flow_imp.g_varchar2_table(49173) := '3430392031342E31363420312E3533362D312E35323620322E3837342D332E32333620342E34312D342E3736326C342E34303820342E373632632D312E3439372D342E3731322D322E3931312D392E3435312D342E3430392D31342E3136347A6D2E3033';
wwv_flow_imp.g_varchar2_table(49174) := '3220322E3933632E38323320322E35383820312E35393920352E313920322E34323120372E3737376C2D322E34322D322E363134632D2E3638332E3539382D322E34353420322E3838362D322E333420322E33392E3837312D322E34383920312E343438';
wwv_flow_imp.g_varchar2_table(49175) := '2D352E303720322E33342D372E3535327A4D31362E3031322E333132632D312E3434382E30322D322E39332E3135372D342E3330322E3632382D2E3835322E3434372D2E32353520312E3836332E363620312E35373420322E3235352D2E36303820342E';
wwv_flow_imp.g_varchar2_table(49176) := '3634382D2E36303720362E3932322D2E3130382E3933342E30373520312E3232382D312E3337362E3333382D312E36374331382E3435312E34342031372E3232372E3331372031362E3031322E3331317A6D392E30313220322E393334632D2E3931332D';
wwv_flow_imp.g_varchar2_table(49177) := '2E3130342D312E32373220312E3235382D2E34353420312E36343820312E38333420312E333620332E32393320332E31383520342E333120352E32322E3532362E37373620312E3834322E30393820312E3531352D2E37386131352E3532322031352E35';
wwv_flow_imp.g_varchar2_table(49178) := '323220302030302D352E30362D362E303036632D2E312D2E3034342D2E3230332D2E30372D2E33312D2E3038327A4D362E363520332E3539632D2E3736322E3038392D312E32342E3830392D312E38303520312E32363743332E333820362E3239352032';
wwv_flow_imp.g_varchar2_table(49179) := '2E31363320382E30303720312E333720392E393035632D2E3236362E38393820312E30393420312E34383420312E3536342E3637356131342E3832352031342E3832352030203031342E3332372D352E3536632E3437362D2E3531352E30392D312E3431';
wwv_flow_imp.g_varchar2_table(49180) := '392D2E3631322D312E3433317A6D392E3336322E303037632D2E3639382E3036362D312E3638392D2E31362D322E3033332E3633352D2E3238322E3733332E35333520312E33353820312E32313720312E31323520312E3830362D2E31343720332E3633';
wwv_flow_imp.g_varchar2_table(49181) := '2E32303320352E3239332E3930372E3930322E32353520312E3437322D312E3131322E3635362D312E3537332D312E362D2E3733352D332E3337342D312E3038392D352E3133332D312E3039347A6D2D352E34373920312E333635632D2E3833352E3135';
wwv_flow_imp.g_varchar2_table(49182) := '2D312E3531372E37362D322E323120312E3232362D312E3230332E39342D322E33313820322E3036312D332E30353720332E3430322D2E33332E39303420312E30363320312E35353220312E3534372E37323320312E3034352D312E36353620322E3539';
wwv_flow_imp.g_varchar2_table(49183) := '362D322E39323520342E3238352D332E3837332E3534352D2E3439392E3137312D312E3436332D2E3536352D312E3437387A6D31332E39303320322E313135632D2E3837352D2E30372D312E323220312E3137332D2E35303120312E36323720312E3332';
wwv_flow_imp.g_varchar2_table(49184) := '3520312E333420322E31383820332E30363220322E37343820342E38342E3436382E383420312E3836392E323120312E3535372D2E3639392D2E3630342D322E3131382D312E3735312D342E3039372D332E3335312D352E363135612E39332E39332030';
wwv_flow_imp.g_varchar2_table(49185) := '2030302D2E3435332D2E3135337A4D342E3436372031332E313332632D2E3832322D2E30372D2E3939362E3832362D312E30343620312E3435352D2E32353620312E39332D2E30393420332E3933332E35363220352E3736392E3430362E38343420312E';
wwv_flow_imp.g_varchar2_table(49186) := '3830372E33363520312E3631322D2E3535316131312E3439382031312E34393820302030312D2E3333342D352E3830382E3837342E38373420302030302D2E3739342D2E3836357A6D32362E36383720312E36632D2E3734362D2E3033372D312E303134';
wwv_flow_imp.g_varchar2_table(49187) := '2E3738352D2E38373920312E3339352E30343320322E3339332D2E353720342E3737312D312E363620362E3839342D2E33312E38383420312E303220312E35333620312E35332E37356131352E3633322031352E3633322030203030312E3832312D382E';
wwv_flow_imp.g_varchar2_table(49188) := '3337322E3837362E38373620302030302D2E3831322D2E3636377A6D2D33302E3139372E353731632D2E3738322D2E3037332D312E3034342E3737352D2E39333320312E3430342E30363820322E3431342E36363120342E38333320312E38303920362E';
wwv_flow_imp.g_varchar2_table(49189) := '3936322E3533342E373720312E3834322E30373620312E3530352D2E3739386131342E3833332031342E38333320302030312D312E3630332D362E3836312E3837362E38373620302030302D2E3737382D2E3730377A6D32362E37383720322E30323463';
wwv_flow_imp.g_varchar2_table(49190) := '2D2E3737372D2E3034382D2E3935322E3739372D312E30323120312E3339322D2E33353420312E3639322D312E32303220332E3233312D322E32313620342E3630382D2E3430372E3837322E39323520312E36333820312E34382E38353220312E333631';
wwv_flow_imp.g_varchar2_table(49191) := '2D312E37333320322E3239362D332E38323720322E3538322D362E303137612E3837342E38373420302030302D2E3832352D2E3833357A4D362E3835372032332E303132632D2E3830382E3031382D312E30383220312E3132322D2E343720312E353920';
wwv_flow_imp.g_varchar2_table(49192) := '312E33393320312E36303720332E31383720322E38383620352E31393420332E3539392E39312E32323220312E34332D312E3136352E3539382D312E3539366131312E3439352031312E34393520302030312D342E3732332D332E3339362E3839392E38';
wwv_flow_imp.g_varchar2_table(49193) := '393920302030302D2E3539392D2E3139377A6D31352E30353720322E37632D2E38312E3139342D312E3530342E37362D322E3332352E3937322D312E3230332E3435382D322E352E3533362D332E3735382E3636342D2E3836392E3330372D2E35373320';
wwv_flow_imp.g_varchar2_table(49194) := '312E3732382E33343620312E36363320322E3230312D2E30333420342E3431322D2E36323620362E3239332D312E3737382E3630342D2E3439352E3232372D312E3533322D2E3535362D312E3532317A4D362E3334362032372E313138632D2E3833332E';
wwv_flow_imp.g_varchar2_table(49195) := '3030382D312E313120312E3231382D2E33393520312E36313720312E39383620312E36303220342E33353820322E37343920362E38363820332E3232362E3933332E30373620312E3232372D312E3337362E3333382D312E36376131342E383338203134';
wwv_flow_imp.g_varchar2_table(49196) := '2E38333820302030312D362E3334352D332E3036362E3932392E39323920302030302D2E3436362D2E3130377A6D31392E3230382E303837632D2E3736362E30392D312E3234312E3834312D312E39323220312E3135382D312E3531362E3939312D332E';
wwv_flow_imp.g_varchar2_table(49197) := '32353120312E35382D342E39393620322E3030352D2E3837322E3430352D2E33343620312E3834392E35383420312E36303420322E3534332D2E35323620342E39382D312E363620362E3936332D332E3334342E34372D2E35322E3037322D312E34322D';
wwv_flow_imp.g_varchar2_table(49198) := '2E36332D312E3432337A227D29293B66756E6374696F6E206B6A28297B72657475726E206B6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C';
wwv_flow_imp.g_varchar2_table(49199) := '617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72';
wwv_flow_imp.g_varchar2_table(49200) := '657475726E20657D2C6B6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220456A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6B6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F7267';
wwv_flow_imp.g_varchar2_table(49201) := '2F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D382E3734322031302E3436347631312E3037326831342E3531365631302E34363448382E3734327A6D332E32323420';
wwv_flow_imp.g_varchar2_table(49202) := '312E373368382E30363661363935363920363935363920302030302D342E30333420332E32326C2D342E3033322D332E32327A6D392E35363520312E30313876362E3539344831302E343639762D362E3539334C31362031372E36336C352E3533322D34';
wwv_flow_imp.g_varchar2_table(49203) := '2E3431397A4D31362030682D2E3030356C2D2E3138382E303031682D2E3031316C2D2E3138382E303034682D2E3031316C2D2E3138372E303036682D2E3031316C2D2E3138372E303038682D2E3030354C31352E322E30326C2D2E3138372E3031682D2E';
wwv_flow_imp.g_varchar2_table(49204) := '3030356C2D2E3030352E3030312D2E3138372E303133682D2E3031314C31342E36322E3036682D2E30316C2D2E3138362E303138682D2E3031316C2D2E3138352E30322D2E3030352E303031682D2E3030366C2D2E3138352E3032322D2E3030352E3030';
wwv_flow_imp.g_varchar2_table(49205) := '31682D2E3030356C2D2E3138352E303235682D2E3030356C2D2E3030352E3030312D2E3138352E303237682D2E3030356C2D2E3030352E3030312D2E3138342E303239682D2E3030356C2D2E3030352E3030312D2E3138332E3033312D2E3030362E3030';
wwv_flow_imp.g_varchar2_table(49206) := '312D2E3030352E3030312D2E3138322E3033332D2E3030362E3030312D2E3030352E3030312D2E3138322E3033352D2E3030352E3030312D2E3030352E3030312D2E3138322E303338682D2E3030356C2D2E3030352E3030322D2E3138312E3034682D2E';
wwv_flow_imp.g_varchar2_table(49207) := '3030356C2D2E3030352E3030322D2E31382E3034322D2E3030362E3030312D2E3030352E3030312D2E31382E3034342D2E3030352E303032682D2E3030356C2D2E31372E3034352D2E3135322E3035342D2E3133392E3038322D2E3132312E3130362D2E';
wwv_flow_imp.g_varchar2_table(49208) := '312E3132372D2E3037342E3134332D2E3034362E3135352D2E3031372E31362E3031332E31362E3034332E3135362E30372E3134352E3039372E31332E3131392E3130382E3133372E3038352E31352E3035382E3135392E30332E31362D2E3030312E31';
wwv_flow_imp.g_varchar2_table(49209) := '33332D2E3032332E3136352D2E3034332E3136382D2E3034312E3137312D2E30342E3137312D2E3033372E3137322D2E3033362E31372D2E3033332E3137332D2E30332E31372D2E30332E3137372D2E3032372E3137312D2E3032352E3137352D2E3032';
wwv_flow_imp.g_varchar2_table(49210) := '322E3137352D2E30322E3137352D2E30322E3137362D2E3031362E3137352D2E3031342E3137372D2E3031322E3137362D2E30312E3137372D2E3030372E3137342D2E3030362E3137372D2E3030334C313620312E3733682E3137376C2E3137382E3030';
wwv_flow_imp.g_varchar2_table(49211) := '342E3137342E3030362E3137372E3030372E3137362E30312E3137372E3031322E3137352E3031342E3137362E3031372E3137352E3031382E3137352E30322E3137352E3032332E3137312E3032352E3137362E3032372E31372E30332E3137342E3033';
wwv_flow_imp.g_varchar2_table(49212) := '2E31372E3033332E3137312E3033362E3135342E3033332E31362E30322E3136312D2E30312E3135362D2E30342E3134362D2E3036392E3133312D2E3039342E3131312D2E3131372E3038372D2E3133352E3036312D2E31352E3033322D2E3135382E30';
wwv_flow_imp.g_varchar2_table(49213) := '30322D2E31362D2E3032372D2E31362D2E3035372D2E31354C3230202E3731346C2D2E3130382D2E31322D2E3132382D2E3039372D2E3134352D2E3037332D2E3132382D2E3033382D2E3135382D2E3033352D2E3030352D2E3030312D2E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49214) := '30314C31392E31342E3331682D2E3030356C2D2E3030352D2E3030322D2E3138322D2E303335682D2E3030366C2D2E3030352D2E3030322D2E3138322D2E303333682D2E3030366C2D2E3030352D2E3030322D2E3138332D2E30332D2E3030352D2E3030';
wwv_flow_imp.g_varchar2_table(49215) := '312D2E3030362D2E3030312D2E3138332D2E303239682D2E3030356C2D2E3030362D2E3030312D2E3138342D2E303237682D2E3030356C2D2E3030352D2E3030312D2E3138352D2E303234682D2E3030354C31372E3936382E31322031372E3738332E31';
wwv_flow_imp.g_varchar2_table(49216) := '6C2D2E3030362D2E303031682D2E3030356C2D2E3138352D2E3032682D2E3030366C2D2E3030352D2E3030314C31372E33392E3036682D2E3030354C31372E33382E30366C2D2E3138372D2E303135682D2E3030356C2D2E3030352D2E3030312D2E3138';
wwv_flow_imp.g_varchar2_table(49217) := '372D2E303133682D2E3031314C31362E382E3032682D2E3031314C31362E362E3031682D2E3031316C2D2E3138372D2E303036682D2E3031314C31362E3230342030682D2E3031314C31362E30303520304831367A6D392E30313520322E3933356C2D2E';
wwv_flow_imp.g_varchar2_table(49218) := '31362E3030342D2E3135382E3033332D2E31352E3036322D2E3133342E30392D2E3131362E3131312D2E3039332E3133322D2E3036372E3134372D2E3033382E3135362D2E30312E3136312E3032322E31362E30352E3135332E3037382E3134312E3130';
wwv_flow_imp.g_varchar2_table(49219) := '332E3132342E3130322E3038372E3034352E3033342E3134322E3130362E3133372E3130352E31342E31312E3133362E31312E3133352E3131322E3133342E3131352E3133342E3131372E31332E3131352E3133322E3132322E3132382E31322E313237';
wwv_flow_imp.g_varchar2_table(49220) := '2E3132322E3132362E3132352E3132342E3132362E3132342E3132382E3132312E31332E3131382E3132382E3131382E3133322E3131372E3133332E3131332E3133342E3131332E3133362E31312E3133362E3130392E3133372E3130392E3134322E31';
wwv_flow_imp.g_varchar2_table(49221) := '30342E31342E3130332E31342E3130312E3134322E312E3134342E3039392E3134362E3039352E3134352E3039342E3134372E3039332E31352E3039322E31352E3038372E3134392E3038372E31352E3038342E3135322E3038342E3135352E30382E31';
wwv_flow_imp.g_varchar2_table(49222) := '35322E30382E3135352E30342E3038312E3038342E3133382E31312E3131392E3132382E3039362E3134352E3037322E3135352E3034332E31362E3031332E31362D2E3031362E3135352D2E3034362E3134342D2E3037342E3132372D2E3039392E3130';
wwv_flow_imp.g_varchar2_table(49223) := '362D2E31322E3038332D2E31342E3035352D2E3135312E3032362D2E31362D2E3030342D2E31362D2E3033342D2E3135382D2E30352D2E3132342D2E3034322D2E3038352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038342D2E3136352D2E';
wwv_flow_imp.g_varchar2_table(49224) := '3030322D2E3030342D2E3030332D2E3030352D2E3038362D2E3136342D2E3030322D2E3030342D2E3030332D2E3030352D2E3038382D2E3136322D2E3030322D2E3030352D2E3030332D2E3030352D2E30392D2E3136312D2E3030322D2E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49225) := '30332D2E3030342D2E3039322D2E31362D2E3030332D2E3030352D2E3030322D2E3030352D2E3039342D2E31362D2E3030332D2E3030342D2E3030332D2E3030342D2E3039362D2E3135392D2E3030322D2E3030342D2E3030332D2E3030352D2E303938';
wwv_flow_imp.g_varchar2_table(49226) := '2D2E3135372D2E3030332D2E3030342D2E3030332D2E3030352D2E312D2E3135362D2E3030332D2E3030342D2E3030332D2E3030352D2E3130312D2E3135342D2E3030332D2E3030352D2E3030332D2E3030342D2E3130342D2E3135342D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(49227) := '3030342D2E3030332D2E3030352D2E3130362D2E3135322D2E3030332D2E3030352D2E3030332D2E3030342D2E3130382D2E3135312D2E3030332D2E3030342D2E3030332D2E3030352D2E31312D2E31352D2E3030332D2E3030342D2E3030332D2E3030';
wwv_flow_imp.g_varchar2_table(49228) := '342D2E3131312D2E31352D2E3030342D2E3030332D2E3030332D2E3030352D2E3131332D2E3134372D2E3030342D2E3030342D2E3030332D2E3030352D2E3131352D2E3134362D2E3030342D2E3030342D2E3030332D2E3030342D2E3131372D2E313435';
wwv_flow_imp.g_varchar2_table(49229) := '2D2E3030342D2E3030342D2E3030332D2E3030342D2E31322D2E3134342D2E3030332D2E3030342D2E3030332D2E3030342D2E3132312D2E3134322D2E3030342D2E3030342D2E3030332D2E3030342D2E3132332D2E3134312D2E3030332D2E3030342D';
wwv_flow_imp.g_varchar2_table(49230) := '2E3030342D2E3030342D2E3132352D2E31342D2E3030332D2E3030342D2E3030342D2E3030342D2E3132372D2E3133382D2E3030332D2E3030342D2E3030342D2E3030342D2E3132382D2E3133362D2E3030342D2E3030342D2E3030342D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49231) := '31332D2E3133352D2E3030342D2E3030342D2E3030342D2E3030342D2E3133322D2E3133342D2E3030332D2E3030342D2E3030342D2E3030332D2E3133342D2E3133332D2E3030342D2E3030332D2E3030342D2E3030342D2E3133352D2E31332D2E3030';
wwv_flow_imp.g_varchar2_table(49232) := '342D2E3030342D2E3030342D2E3030342D2E3133362D2E3132382D2E3030342D2E3030342D2E3030342D2E3030342D2E3133382D2E3132362D2E3030342D2E3030342D2E3030342D2E3030332D2E31342D2E3132352D2E3030342D2E3030342D2E303034';
wwv_flow_imp.g_varchar2_table(49233) := '2D2E3030332D2E31342D2E3132332D2E3030352D2E3030342D2E3030342D2E3030332D2E3134322D2E3132312D2E3030342D2E3030342D2E3030342D2E3030332D2E3134342D2E31322D2E3030342D2E3030332D2E3030342D2E3030332D2E3134352D2E';
wwv_flow_imp.g_varchar2_table(49234) := '3131372D2E3030342D2E3030342D2E3030342D2E3030332D2E3134372D2E3131352D2E3030342D2E3030342D2E3030342D2E3030332D2E3134382D2E3131332D2E3030342D2E3030332D2E3030342D2E3030342D2E3134392D2E3131312D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49235) := '3030332D2E3030342D2E3030342D2E30352D2E3033362D2E31342D2E3038332D2E31352D2E3035352D2E31362D2E3032377A4D362E36333420332E32386C2D2E3136312E3030382D2E3135372E3033372D2E3134372E3036362D2E3131312E3037342D2E';
wwv_flow_imp.g_varchar2_table(49236) := '30342E3033322D2E3030352E3030332D2E3030342E3030342D2E3134352E3131372D2E3030342E3030332D2E3030342E3030342D2E3134342E3131392D2E3030342E3030332D2E3030342E3030342D2E3134322E31322D2E3030342E3030342D2E303034';
wwv_flow_imp.g_varchar2_table(49237) := '2E3030342D2E3134312E3132332D2E3030342E3030332D2E3030342E3030342D2E31342E3132352D2E3030342E3030332D2E3030342E3030342D2E3133382E3132362D2E3030342E3030342D2E3030342E3030342D2E3133362E3132382D2E3030342E30';
wwv_flow_imp.g_varchar2_table(49238) := '30342D2E3030342E3030342D2E3133352E31332D2E3030342E3030342D2E3030342E3030332D2E3133342E3133332D2E3030342E3030332D2E3030342E3030342D2E3133322E3133342D2E3030332E3030342D2E3030342E3030342D2E31332E3133352D';
wwv_flow_imp.g_varchar2_table(49239) := '2E3030342E3030342D2E3030342E3030342D2E3132382E3133362D2E3030342E3030342D2E3030342E3030342D2E3132362E3133382D2E3030342E3030342D2E3030332E3030342D2E3132352E31342D2E3030342E3030342D2E3030332E3030342D2E31';
wwv_flow_imp.g_varchar2_table(49240) := '32332E31342D2E3030342E3030352D2E3030332E3030342D2E3132312E3134322D2E3030342E3030342D2E3030332E3030342D2E31322E3134342D2E3030332E3030342D2E3030332E3030342D2E3131372E3134352D2E3030342E3030342D2E3030332E';
wwv_flow_imp.g_varchar2_table(49241) := '3030342D2E3131352E3134362D2E3030342E3030352D2E3030332E3030342D2E3131332E3134372D2E3030332E3030352D2E3030342E3030342D2E3131312E3134392D2E3030332E3030342D2E3030342E3030342D2E31312E31352D2E3030322E303035';
wwv_flow_imp.g_varchar2_table(49242) := '2D2E3030332E3030342D2E3130382E3135312D2E3030332E3030342D2E3030332E3030352D2E3130362E3135322D2E3030332E3030352D2E3030332E3030342D2E3130342E3135342D2E3030332E3030342D2E3030332E3030352D2E3130322E3135342D';
wwv_flow_imp.g_varchar2_table(49243) := '2E3030332E3030352D2E3030322E3030342D2E312E3135362D2E3030332E3030352D2E3030332E3030342D2E3039382E3135372D2E3030332E3030352D2E3030332E3030342D2E3039362E3135392D2E3030322E3030342D2E3030332E3030352D2E3039';
wwv_flow_imp.g_varchar2_table(49244) := '342E31362D2E3030332E3030342D2E3030322E3030342D2E3039322E31362D2E3030332E3030352D2E3030332E3030352D2E30392E3136312D2E3030322E3030352D2E3030332E3030352D2E3038382E3136322D2E3030322E3030352D2E3030332E3030';
wwv_flow_imp.g_varchar2_table(49245) := '342D2E3038362E3136342D2E3030322E3030352D2E3030322E3030342D2E3038342E3136352D2E3030332E3030352D2E3030322E3030342D2E3038322E3136362D2E3030322E3030342D2E3030332E3030352D2E30382E3136372D2E3030322E3030342D';
wwv_flow_imp.g_varchar2_table(49246) := '2E3030322E3030352D2E3037382E3136382D2E3030322E3030342D2E3030322E3030352D2E3034352E312D2E3035332E3135332D2E3032332E31362E3030372E31362E3033372E3135372E3036352E3134382E3039322E3133322E3131342E3131342E31';
wwv_flow_imp.g_varchar2_table(49247) := '33342E30392E3134382E3036342E3135372E3033352E3136312E3030362E31362D2E3032352E3135322D2E3035342E31342D2E30382E3132312D2E3130362E312D2E3132362E3036352D2E3131382E3034332D2E3039352E3037342D2E31362E3037352D';
wwv_flow_imp.g_varchar2_table(49248) := '2E3135352E3037372D2E3135372E30382D2E3135352E30382D2E3135322E3038332D2E3135352E3038352D2E3135322E3038362D2E31352E3038382D2E3134392E3039312D2E31352E3039342D2E31352E3039342D2E3134372E3039352D2E3134352E30';
wwv_flow_imp.g_varchar2_table(49249) := '39392D2E3134362E312D2E3134342E312D2E3134322E3130342D2E31342E3130342D2E31342E31312D2E3134322E3130372D2E3133372E31312D2E3133362E3131342D2E3133362E3131332D2E3133342E3131372D2E3133332E3131382D2E3133322E31';
wwv_flow_imp.g_varchar2_table(49250) := '31372D2E3132392E3132322D2E31332E3132342D2E3132372E3132332D2E3132362E3132372D2E3132352E3132372D2E3132322E3132382D2E31322E3133322D2E3132322E31332D2E3131352E3133332D2E3131372E3133352D2E3131352E3133352D2E';
wwv_flow_imp.g_varchar2_table(49251) := '3131312E3133362D2E31312E3033372D2E30332E3131372D2E31312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E30312D2E3136312D2E30322D2E31362D2E30352D2E3135342D2E3037362D2E3134312D2E3130322D2E3132352D2E';
wwv_flow_imp.g_varchar2_table(49252) := '3132332D2E3130342D2E31342D2E30382D2E3135332D2E3035312D2E31362D2E3032337A4D313620332E323836682D2E3030356C2D2E3134382E303031682D2E30316C2D2E3134372E303033682D2E3031316C2D2E3134372E303035682D2E3031316C2D';
wwv_flow_imp.g_varchar2_table(49253) := '2E3134362E303037682D2E3031316C2D2E3134362E303039682D2E3031316C2D2E3134362E3031682D2E3030356C2D2E3030352E3030312D2E3134362E303132682D2E3031316C2D2E3134352E303134682D2E3030366C2D2E3030352E3030312D2E3035';
wwv_flow_imp.g_varchar2_table(49254) := '2E3030362D2E3135382E3033312D2E31352E30362D2E3133352E3038382D2E3131372E3131312D2E3039342E31332D2E3036392E3134372D2E30342E3135362D2E30312E31362E3031392E31362E3034392E3135342E3037362E3134322E3130322E3132';
wwv_flow_imp.g_varchar2_table(49255) := '352E3132332E3130352E31342E30382E3135322E3035312E31362E3032332E3133342D2E3030332E3034352D2E3030352E3133352D2E3031332E3133332D2E30312E3133362D2E30312E3133352D2E3030372E3133372D2E3030362E3133362D2E303034';
wwv_flow_imp.g_varchar2_table(49256) := '2E3133362D2E303033682E3237346C2E3133362E3030332E3133362E3030342E3133362E3030362E3133362E3030372E3133362E30312E3133332E30312E3133352E3031332E3133352E3031342E3133352E3031362E3133342E3031382E3133322E3031';
wwv_flow_imp.g_varchar2_table(49257) := '382E3133342E3032312E3133332E3032332E3133332E3032342E3133332E3032352E31332E3032372E3133322E30332E3133322E30332E3132392E3033312E31332E3033342E3132392E3033352E3132392E3033362E31332E30342E3132362E3033382E';
wwv_flow_imp.g_varchar2_table(49258) := '3132382E3034322E3132362E3034322E3132382E3034352E3132372E3034372E3132362E3034372E31322E3034382E3132372E3035312E3132332E3035322E3030362E3030322E3134372E3034382E31362E3032312E31362D2E3030392E3135372D2E30';
wwv_flow_imp.g_varchar2_table(49259) := '33382E3134372D2E3036372E3133312D2E3039332E3131322D2E3131362E3038392D2E3133352E3036322D2E3134392E3033332D2E3135382E3030342D2E31362D2E3032372D2E31362D2E3035352D2E3135312D2E3038332D2E3133392D2E3130372D2E';
wwv_flow_imp.g_varchar2_table(49260) := '31322D2E3132372D2E3039392D2E3131382D2E3036332D2E3030342D2E3030312D2E3030352D2E3030332D2E3030352D2E3030322D2E3133332D2E3035362D2E3030352D2E3030322D2E3030352D2E3030322D2E3133342D2E3035342D2E3030342D2E30';
wwv_flow_imp.g_varchar2_table(49261) := '30322D2E3030352D2E3030322D2E3133352D2E3035332D2E3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E3035312D2E3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E30352D2E3030352D2E3030312D2E3030352D2E3030';
wwv_flow_imp.g_varchar2_table(49262) := '322D2E3133372D2E3034382D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034362D2E3030352D2E3030322D2E3030352D2E3030322D2E3133372D2E3034342D2E3030352D2E3030322D2E3030352D2E3030312D2E3133382D2E3034';
wwv_flow_imp.g_varchar2_table(49263) := '332D2E3030362D2E3030322D2E3030352D2E3030312D2E3133382D2E3034322D2E3030352D2E3030312D2E3030352D2E3030322D2E31342D2E30344831392E346C2D2E3030352D2E3030322D2E31342D2E3033382D2E3030352D2E3030312D2E3030352D';
wwv_flow_imp.g_varchar2_table(49264) := '2E3030322D2E31342D2E3033362D2E3030352D2E3030312D2E3030352D2E3030312D2E3134312D2E3033352D2E3030352D2E3030312D2E3030352D2E3030312D2E3134322D2E3033332D2E3030352D2E3030312D2E3030352D2E3030312D2E3134322D2E';
wwv_flow_imp.g_varchar2_table(49265) := '3033312D2E3030352D2E303032682D2E3030356C2D2E3134322D2E30332D2E3030352D2E3030312D2E3030352D2E3030312D2E3134332D2E303238682D2E3030356C2D2E3030352D2E3030322D2E3134332D2E3032352D2E3030362D2E3030312D2E3030';
wwv_flow_imp.g_varchar2_table(49266) := '352D2E3030312D2E3134332D2E3032342D2E3030352D2E3030312D2E3030362D2E3030312D2E3134332D2E3032322D2E3030362D2E303031682D2E3030356C2D2E3134342D2E303232682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303139';
wwv_flow_imp.g_varchar2_table(49267) := '682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303137682D2E3030366C2D2E3030352D2E3030312D2E3134352D2E303136682D2E3031316C2D2E3134352D2E3031344831372E316C2D2E3030352D2E3030312D2E3134362D2E303132682D2E';
wwv_flow_imp.g_varchar2_table(49268) := '30316C2D2E3134362D2E30312D2E3030362D2E303031682D2E3030356C2D2E3134362D2E303039682D2E3031316C2D2E3134372D2E303036682D2E30316C2D2E3134372D2E303035682D2E3031316C2D2E3134372D2E303033682D2E3031316C2D2E3134';
wwv_flow_imp.g_varchar2_table(49269) := '372D2E3030314831367A6D2D352E34383220312E3336366C2D2E31362E3030382D2E3135372E3033372D2E3132332E3035332D2E30362E3033322D2E3030352E3030322D2E3030342E3030332D2E3132382E3036392D2E3030342E3030322D2E3030352E';
wwv_flow_imp.g_varchar2_table(49270) := '3030332D2E3132362E30372D2E3030352E3030332D2E3030342E3030322D2E3132362E3037322D2E3030352E3030332D2E3030342E3030332D2E3132352E3037332D2E3030342E3030332D2E3030352E3030332D2E3132342E3037352D2E3030342E3030';
wwv_flow_imp.g_varchar2_table(49271) := '332D2E3030352E3030322D2E3132332E3037372D2E3030342E3030332D2E3030352E3030332D2E3132322E3037382D2E3030342E3030332D2E3030352E3030332D2E3132312E30382D2E3030342E3030322D2E3030352E3030332D2E31322E3038322D2E';
wwv_flow_imp.g_varchar2_table(49272) := '3030352E3030332D2E3030342E3030332D2E31322E3038332D2E3030342E3030332D2E3030342E3030332D2E3131382E3038342D2E3030352E3030332D2E3030342E3030332D2E3131382E3038362D2E3030342E3030332D2E3030342E3030332D2E3131';
wwv_flow_imp.g_varchar2_table(49273) := '372E3038382D2E3030342E3030332D2E3030342E3030332D2E3131362E3038392D2E3030342E3030332D2E3030342E3030342D2E3131342E30392D2E3030352E3030332D2E3030342E3030332D2E3131332E3039322D2E3030342E3030342D2E3030342E';
wwv_flow_imp.g_varchar2_table(49274) := '3030332D2E3131332E3039332D2E3030342E3030342D2E3030342E3030332D2E3131312E3039352D2E3030352E3030332D2E3030342E3030342D2E31312E3039362D2E3030342E3030342D2E3030342E3030332D2E31312E3039382D2E3030332E303033';
wwv_flow_imp.g_varchar2_table(49275) := '2D2E3030342E3030342D2E3130382E312D2E3030342E3030332D2E3030342E3030332D2E3130372E3130312D2E3030342E3030342D2E3030342E3030332D2E3130362E3130322D2E3030342E3030342D2E3030332E3030342D2E3130352E3130332D2E30';
wwv_flow_imp.g_varchar2_table(49276) := '30342E3030342D2E3030342E3030342D2E3130332E3130352D2E3030342E3030342D2E3030342E3030332D2E3130322E3130362D2E3030332E3030342D2E3030342E3030342D2E312E3130372D2E3030342E3030342D2E3030342E3030342D2E3039392E';
wwv_flow_imp.g_varchar2_table(49277) := '3130382D2E3030342E3030342D2E3030332E3030342D2E3039382E31312D2E3030332E3030332D2E3030342E3030342D2E3039362E31312D2E3030342E3030352D2E3030332E3030342D2E3039352E3131312D2E3030332E3030342D2E3030342E303034';
wwv_flow_imp.g_varchar2_table(49278) := '2D2E3039332E3131332D2E3030332E3030342D2E3030342E3030342D2E3039322E3131332D2E3030332E3030342D2E3030332E3030352D2E30392E3131342D2E3030342E3030342D2E3030332E3030342D2E3038392E3131362D2E3030332E3030342D2E';
wwv_flow_imp.g_varchar2_table(49279) := '3030332E3030342D2E3038382E3131372D2E3030332E3030342D2E3030332E3030342D2E3038362E3131382D2E3030332E3030342D2E3030332E3030352D2E3038342E3131382D2E3030332E3030342D2E3030332E3030352D2E3038332E31322D2E3030';
wwv_flow_imp.g_varchar2_table(49280) := '332E3030332D2E3030332E3030352D2E3038322E31322D2E3030332E3030352D2E3030322E3030342D2E3036382E3130332D2E3037362E3134322D2E3034382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E30';
wwv_flow_imp.g_varchar2_table(49281) := '39352E31332E3131372E31312E3133362E3038362E31352E30362E3135382E30332E3136322E3030322E3135382D2E30332E31352D2E3035372E3133382D2E3038352E3131392D2E3130392E3038322D2E3130352E3036352D2E3039392E3037352D2E31';
wwv_flow_imp.g_varchar2_table(49282) := '312E3037372D2E3131332E3037372D2E3130372E30382D2E31312E30382D2E3130382E3038342D2E3130382E3038332D2E3130352E3038362D2E3130362E3038362D2E3130342E3038382D2E3130342E3038392D2E3130312E30392D2E3130322E303933';
wwv_flow_imp.g_varchar2_table(49283) := '2D2E3130312E3039332D2E3039392E3039342D2E3039372E3039352D2E3039362E3039382D2E3039372E3039382D2E3039352E3039392D2E3039332E312D2E3039322E3130332D2E3039312E3130312D2E3038392E3130342D2E3038382E3130342D2E30';
wwv_flow_imp.g_varchar2_table(49284) := '38362E3130362D2E3038362E3130362D2E3038332E3130362D2E3038322E3130392D2E3038322E3130382D2E3037392E31312D2E3037382E31312D2E3037362E3131322D2E3037362E3131322D2E3037342E3131332D2E3037322E3131332D2E3037312E';
wwv_flow_imp.g_varchar2_table(49285) := '3131352D2E30372E3131352D2E3036382E3131382D2E3036372E3131372D2E3036352E31322D2E3036352E3035342D2E3032392E3133352D2E3038382E3131362D2E3131312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E3030392D';
wwv_flow_imp.g_varchar2_table(49286) := '2E3136312D2E30322D2E31362D2E30352D2E3135332D2E3037382D2E3134322D2E3130322D2E3132352D2E3132332D2E3130332D2E3134312D2E3037392D2E3135332D2E3035312D2E31362D2E3032327A6D31332E393120322E3131366C2D2E3136322E';
wwv_flow_imp.g_varchar2_table(49287) := '3030382D2E3135372E3033372D2E3134372E3036362D2E3133322E3039322D2E3131332E3131362D2E30392E3133342D2E3036332E3134382D2E3033342E3135372D2E3030352E3136322E3032352E3135392E3035352E3135322E3038322E3133382E30';
wwv_flow_imp.g_varchar2_table(49288) := '38362E3130332E30392E30392E3039342E3039382E3039322E3039392E3039332E312E3039312E3130332E3038392E3130312E3038382E3130342E3038362E3130342E3038362E3130362E3038332E3130352E3038332E3130382E30382E3130382E3038';
wwv_flow_imp.g_varchar2_table(49289) := '312E31312E3037372E3130372E3037372E3131322E3037352E3131312E3037352E3131342E3037322E3131332E3037312E3131332E30372E3131342E3036382E3131382E3036372E3131352E3036352E3131382E3036342E3131372E3036322E3131372E';
wwv_flow_imp.g_varchar2_table(49290) := '3036312E3132312E3035392E3131392E3035392E3132322E3035362E3132312E3035342E31322E3035352E3132352E3035312E3132332E3035312E3132352E3034382E3132332E3034382E3132372E3034372E3132362E3034342E3132352E3034332E31';
wwv_flow_imp.g_varchar2_table(49291) := '32382E3034322E3132392E3033392E3132362E3033382E31332E3032322E3037362E3035382E31352E3038352E3133372E31312E3131392E3132392E3039362E3134352E30372E3135352E3034332E31362E3031332E3136312D2E3031372E3135342D2E';
wwv_flow_imp.g_varchar2_table(49292) := '3034362E3134342D2E3037352E3132362D2E312E3130362D2E31322E3038322D2E31342E3035352D2E3135312E3032352D2E31362D2E3030352D2E31362D2E3032362D2E3133322D2E3032332D2E3038322D2E3030322D2E3030352D2E3030312D2E3030';
wwv_flow_imp.g_varchar2_table(49293) := '352D2E3034322D2E3133392D2E3030312D2E3030352D2E3030322D2E3030352D2E3034332D2E3133382D2E3030312D2E3030352D2E3030322D2E3030352D2E3034342D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E3034362D2E3133';
wwv_flow_imp.g_varchar2_table(49294) := '372D2E3030322D2E3030352D2E3030312D2E3030352D2E3034382D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E30352D2E3133352D2E3030312D2E3030352D2E3030322D2E3030352D2E3035312D2E3133352D2E3030322D2E303035';
wwv_flow_imp.g_varchar2_table(49295) := '2D2E3030322D2E3030352D2E3035332D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035342D2E3133332D2E3030322D2E3030352D2E3030322D2E3030352D2E3035372D2E3133332D2E3030322D2E3030352D2E3030322D2E303035';
wwv_flow_imp.g_varchar2_table(49296) := '2D2E3035372D2E3133322D2E3030332D2E3030352D2E3030322D2E3030352D2E30362D2E3133322D2E3030312D2E3030352D2E3030322D2E3030342D2E3036312D2E3133322D2E3030332D2E3030342D2E3030322D2E3030352D2E3036332D2E31332D2E';
wwv_flow_imp.g_varchar2_table(49297) := '3030322D2E3030352D2E3030322D2E3030352D2E3036342D2E31332D2E3030332D2E3030342D2E3030322D2E3030352D2E3036362D2E3132392D2E3030322D2E3030342D2E3030332D2E3030352D2E3036372D2E3132382D2E3030322D2E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49298) := '30332D2E3030342D2E3036392D2E3132382D2E3030322D2E3030342D2E3030332D2E3030352D2E30372D2E3132362D2E3030332D2E3030352D2E3030332D2E3030342D2E3037322D2E3132362D2E3030322D2E3030352D2E3030332D2E3030342D2E3037';
wwv_flow_imp.g_varchar2_table(49299) := '342D2E3132352D2E3030322D2E3030342D2E3030332D2E3030352D2E3037352D2E3132342D2E3030332D2E3030342D2E3030332D2E3030352D2E3037362D2E3132332D2E3030332D2E3030342D2E3030332D2E3030352D2E3037382D2E3132322D2E3030';
wwv_flow_imp.g_varchar2_table(49300) := '332D2E3030342D2E3030332D2E3030352D2E30382D2E3132312D2E3030332D2E3030342D2E3030332D2E3030352D2E3038312D2E31322D2E3030332D2E3030352D2E3030332D2E3030342D2E3038332D2E31322D2E3030332D2E3030342D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(49301) := '3030342D2E3038342D2E3131382D2E3030332D2E3030352D2E3030332D2E3030342D2E3038362D2E3131382D2E3030332D2E3030342D2E3030342D2E3030342D2E3038372D2E3131372D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E31';
wwv_flow_imp.g_varchar2_table(49302) := '31362D2E3030322D2E3030342D2E3030342D2E3030342D2E30392D2E3131342D2E3030332D2E3030352D2E3030342D2E3030342D2E3039312D2E3131332D2E3030342D2E3030342D2E3030332D2E3030342D2E3039342D2E3131332D2E3030332D2E3030';
wwv_flow_imp.g_varchar2_table(49303) := '342D2E3030332D2E3030342D2E3039352D2E3131312D2E3030342D2E3030342D2E3030332D2E3030342D2E3039362D2E31312D2E3030342D2E3030352D2E3030332D2E3030342D2E3039382D2E31312D2E3030342D2E3030332D2E3030332D2E3030342D';
wwv_flow_imp.g_varchar2_table(49304) := '2E312D2E3130382D2E3030332D2E3030342D2E3030342D2E3030342D2E312D2E3130372D2E3030342D2E3030342D2E3030342D2E3030342D2E3130322D2E3130362D2E3030332D2E3030332D2E3030342D2E3030342D2E3039332D2E3039352D2E313234';
wwv_flow_imp.g_varchar2_table(49305) := '2D2E3130332D2E31342D2E30382D2E3135332D2E30352D2E31362D2E3032337A4D342E34352031322E3832366C2D2E3136312E3030322D2E3135382E3033322D2E31352E30362D2E3133352E3038382D2E3131382E31312D2E3039342E3133312D2E3036';
wwv_flow_imp.g_varchar2_table(49306) := '392E3134362D2E3033352E3132392D2E3032362E313332762E3030356C2D2E3030322E3030352D2E3032352E3134332D2E3030312E3030352D2E3030312E3030362D2E3032342E3134332D2E3030312E3030352D2E3030312E3030362D2E3032322E3134';
wwv_flow_imp.g_varchar2_table(49307) := '332D2E3030312E3030362D2E3030312E3030352D2E30322E3134342D2E3030312E3030352D2E3030312E3030352D2E3031392E313435762E3030356C2D2E3030312E3030362D2E3031372E313434762E3030366C2D2E3030312E3030352D2E3031362E31';
wwv_flow_imp.g_varchar2_table(49308) := '3435762E3031316C2D2E3031342E313435762E3030356C2D2E3030312E3030362D2E3031322E313436762E30316C2D2E30312E3134362D2E3030312E303036762E3030356C2D2E3030392E313436762E3031316C2D2E3030372E313436762E3031316C2D';
wwv_flow_imp.g_varchar2_table(49309) := '2E3030342E313437762E3031316C2D2E3030332E313437762E30316C2D2E3030322E313438762E30316C2E3030312E313438762E30316C2E3030332E313437762E3031316C2E3030352E313437762E30316C2E3030372E313437762E3031316C2E303039';
wwv_flow_imp.g_varchar2_table(49310) := '2E313436762E3031316C2E30312E313436762E30316C2E3031332E313436762E3031316C2E3031342E313435762E3030356C2E3030312E3030362E3031362E313435762E3031316C2E3031382E313434762E3030366C2E3030312E3030352E3031392E31';
wwv_flow_imp.g_varchar2_table(49311) := '3434762E3030366C2E3030312E3030352E3032312E313434762E3030356C2E3030322E3030362E3032322E313433762E3030366C2E3030322E3030352E3032342E313433762E3030356C2E3030322E3030362E3032352E3134332E3030312E3030352E30';
wwv_flow_imp.g_varchar2_table(49312) := '30312E3030352E3032382E3134332E3030312E3030352E3030312E3030352E30332E313432762E3030356C2E3030322E3030362E30332E3134312E3030322E3030352E3030312E3030352E3033332E313432762E3030356C2E3030322E3030352E303335';
wwv_flow_imp.g_varchar2_table(49313) := '2E3134762E3030366C2E3030322E3030352E3033362E31342E3030322E3030352E3030312E3030352E3033382E31342E3030312E3030352E3030322E3030352E30342E3134762E3030356C2E3030322E3030352E3034322E3133382E3030312E3030362E';
wwv_flow_imp.g_varchar2_table(49314) := '3030322E3030352E3034322E3133382E3030322E3030352E3030322E3030352E3031372E3035342E3036342E3134382E30392E3133342E3131342E3131342E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030372E31362D2E3032';
wwv_flow_imp.g_varchar2_table(49315) := '332E3135332D2E3035322E31342D2E30382E3132332D2E3130342E3130322D2E3132352E3037362D2E3134322E3034392D2E3135332E30322D2E31362D2E3031312D2E3136312D2E3033312D2E31332D2E3031372D2E3035312D2E3033392D2E3132362D';
wwv_flow_imp.g_varchar2_table(49316) := '2E3033382D2E31332D2E3033372D2E3132382D2E3033352D2E31332D2E3033332D2E3132382D2E3033332D2E3133342D2E30332D2E31332D2E3032392D2E3133312D2E3032362D2E31332D2E3032362D2E3133332D2E3032342D2E3133332D2E3032332D';
wwv_flow_imp.g_varchar2_table(49317) := '2E3133332D2E30322D2E3133322D2E30322D2E3133362D2E3031372D2E3133322D2E3031362D2E3133352D2E3031342D2E3133352D2E3031322D2E3133332D2E3031322D2E3133382D2E3030392D2E3133332D2E3030372D2E3133362D2E3030362D2E31';
wwv_flow_imp.g_varchar2_table(49318) := '33382D2E3030342D2E3133342D2E3030332D2E313336762D2E3237346C2E3030332D2E3133362E3030342D2E3133342E3030362D2E3133392E3030372D2E3133362E30312D2E3133332E30312D2E3133382E3031332D2E3133322E3031342D2E3133352E';
wwv_flow_imp.g_varchar2_table(49319) := '3031362D2E3133352E3031372D2E3133322E30322D2E3133372E30322D2E31332E3032332D2E3133342E3032342D2E3133332E3032342D2E3132362E3031362D2E31362D2E3031342D2E3136312D2E3034342D2E3135352D2E3037322D2E3134352D2E30';
wwv_flow_imp.g_varchar2_table(49320) := '39382D2E3132382D2E31322D2E3130382D2E3133372D2E3038342D2E31352D2E3035372D2E31362D2E3032397A6D32362E36393820312E3630316C2D2E3136312E30312D2E3135372E30342D2E3134362E3036372D2E3133312E3039332D2E3131322E31';
wwv_flow_imp.g_varchar2_table(49321) := '31372D2E3038382E3133352D2E3036312E3134392D2E3033332E3135372D2E3030352E3133342E3030362E31342E3030362E3137362E3030332E3137372E3030312E3137382D2E3030312E3137372D2E3030332E3137382D2E3030362E3137372D2E3030';
wwv_flow_imp.g_varchar2_table(49322) := '372E3137362D2E30312E3137372D2E3031322E3137362D2E3031352E3137362D2E3031362E3137332D2E3031382E3137352D2E30322E3137352D2E3032342E3137342D2E3032352E3137352D2E3032362E31372D2E30332E3137342D2E30332E3137332D';
wwv_flow_imp.g_varchar2_table(49323) := '2E3033332E31372D2E3033362E3137322D2E3033372E31372D2E30342E31372D2E3034322E3137322D2E3034332E3136382D2E3034352E3136362D2E3034382E3136392D2E30352E3136372D2E3035322E3136382D2E3035332E3136342D2E3035362E31';
wwv_flow_imp.g_varchar2_table(49324) := '36362D2E3035382E3136362D2E30362E31362D2E3036322E3136352D2E3036322E3135382D2E3036362E3136352D2E3036382E31362D2E30372E31362D2E30372E3135382D2E3037352E3135392D2E3037342E3135352D2E3037392E3135382D2E30382E';
wwv_flow_imp.g_varchar2_table(49325) := '3135382D2E30362E31352D2E30332E3135382D2E3030312E3136312E3032392E3135392E3035382E31352E3038352E3133372E3130382E3131392E31332E3039372E3134342E30372E3135362E3034342E31362E3031332E31362D2E3031372E3135352D';
wwv_flow_imp.g_varchar2_table(49326) := '2E3034362E3134332D2E3037342E3132372D2E312E3130372D2E31322E30372D2E3131352E3038332D2E3136342E3030332D2E3030352E3030322D2E3030342E3038322D2E3136362E3030322D2E3030352E3030332D2E3030342E30382D2E3136372E30';
wwv_flow_imp.g_varchar2_table(49327) := '30322D2E3030352E3030322D2E3030342E3037382D2E3136382E3030322D2E3030352E3030322D2E3030342E3037362D2E3136392E3030322D2E3030342E3030322D2E3030352E3037342D2E31372E3030322D2E3030342E3030322D2E3030352E303732';
wwv_flow_imp.g_varchar2_table(49328) := '2D2E31372E3030322D2E3030352E3030322D2E3030352E30372D2E3137312E3030312D2E3030352E3030322D2E3030352E3036382D2E3137322E3030322D2E3030342E3030322D2E3030352E3036352D2E3137332E3030322D2E3030352E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49329) := '30352E3036332D2E3137332E3030322D2E3030352E3030322D2E3030352E30362D2E3137342E3030332D2E3030352E3030312D2E3030352E30362D2E3137352E3030312D2E3030352E3030322D2E3030352E3035372D2E3137362E3030312D2E3030352E';
wwv_flow_imp.g_varchar2_table(49330) := '3030322D2E3030352E3035352D2E3137372E3030312D2E3030352E3030322D2E3030352E3035322D2E3137372E3030322D2E3030352E3030312D2E3030352E3035312D2E3137382E3030312D2E3030352E3030322D2E3030352E3034382D2E3137392E30';
wwv_flow_imp.g_varchar2_table(49331) := '30322D2E303035762D2E3030356C2E3034372D2E3137392E3030312D2E3030352E3030322D2E3030352E3034342D2E3138762D2E3030356C2E3030322D2E3030352E3034322D2E31382E3030312D2E3030362E3030312D2E3030352E30342D2E3138312E';
wwv_flow_imp.g_varchar2_table(49332) := '3030312D2E3030352E3030312D2E3030352E3033372D2E3138322E3030322D2E303035762D2E3030356C2E3033362D2E313832762D2E3030366C2E3030322D2E3030352E3033332D2E313832762D2E3030366C2E3030322D2E3030352E30332D2E313833';
wwv_flow_imp.g_varchar2_table(49333) := '2E3030312D2E3030352E3030312D2E3030352E3032392D2E313834762D2E3030356C2E3030312D2E3030362E3032372D2E313834762D2E3030356C2E3030312D2E3030352E3032342D2E313835762D2E3030356C2E3030312D2E3030352E3032322D2E31';
wwv_flow_imp.g_varchar2_table(49334) := '3835762D2E3030366C2E3030312D2E3030352E30322D2E313835762D2E3030366C2E3030312D2E3030352E3031372D2E313836762D2E3030356C2E3030312D2E3030352E3031352D2E313837762D2E3030356C2E3030312D2E3030352E3031332D2E3138';
wwv_flow_imp.g_varchar2_table(49335) := '37762D2E30316C2E30312D2E3138372E3030312D2E303036762D2E3030356C2E3030392D2E313837762D2E3031316C2E3030362D2E313837762D2E3031316C2E3030342D2E313838762D2E3031316C2E3030312D2E313838762D2E30316C2D2E3030312D';
wwv_flow_imp.g_varchar2_table(49336) := '2E313838762D2E3031316C2D2E3030342D2E313838762D2E3031316C2D2E3030362D2E313837762D2E3031316C2D2E3030372D2E3134352D2E3032322D2E31362D2E30352D2E3135322D2E30382D2E3134312D2E3130332D2E3132342D2E3132352D2E31';
wwv_flow_imp.g_varchar2_table(49337) := '30322D2E3134312D2E3037372D2E3135332D2E30352D2E31362D2E30327A4D2E3933382031354C2E3737372031356C2D2E3135382E3033322D2E31352E30362D2E3133362E3038372D2E3131372E31312D2E3039352E3133312D2E3036382E3134362D2E';
wwv_flow_imp.g_varchar2_table(49338) := '30342E3135362D2E3031322E3133332D2E3030312E3134762E30316C2E3030312E313838762E3031316C2E3030342E313838762E3031316C2E3030362E313837762E3031316C2E3030382E313837762E3031316C2E3031312E313837762E3030356C2E30';
wwv_flow_imp.g_varchar2_table(49339) := '30312E3030352E3031332E313837762E30316C2E3031362E313837762E30316C2E3031382E313836762E3031316C2E30322E3138352E3030312E303035762E3030366C2E3032322E3138352E3030312E303035762E3030356C2E3032352E313835762E30';
wwv_flow_imp.g_varchar2_table(49340) := '30356C2E3030312E3030352E3032372E313834762E3030366C2E3030312E3030352E3032392E313834762E3030356C2E3030312E3030352E3033312E3138332E3030312E3030352E3030312E3030362E3033332E3138322E3030312E3030352E3030312E';
wwv_flow_imp.g_varchar2_table(49341) := '3030362E3033352E3138322E3030312E3030352E3030312E3030352E3033382E313832762E3030356C2E3030322E3030352E30342E313831762E3030356C2E3030322E3030352E3034322E31382E3030312E3030362E3030312E3030352E3034342E3138';
wwv_flow_imp.g_varchar2_table(49342) := '2E3030322E303035762E3030356C2E3034372E31382E3030312E3030342E3030322E3030352E3034382E3137392E3030322E3030352E3030312E3030352E30352E3137382E3030322E3030352E3030312E3030352E3035332E3137372E3030322E303035';
wwv_flow_imp.g_varchar2_table(49343) := '2E3030312E3030352E3035352E3137372E3030322E3030352E3030312E3030352E3035372E3137362E3030322E3030352E3030312E3030352E30362E3137352E3030312E3030352E3030322E3030352E3036312E3137342E3030322E3030352E3030322E';
wwv_flow_imp.g_varchar2_table(49344) := '3030352E3036332E3137332E3030322E3030352E3030322E3030352E3036352E3137332E3030322E3030352E3030322E3030342E3036372E3137322E3030322E3030352E3030322E3030352E30372E3137312E3030322E3030352E3030322E3030352E30';
wwv_flow_imp.g_varchar2_table(49345) := '37322E31372E3030322E3030352E3030322E3030342E3037342E31372E3030322E3030352E3030322E3030342E3037362E3136392E3030322E3030342E3030322E3030352E3037382E3136382E3030322E3030342E3030322E3030352E30382E3136372E';
wwv_flow_imp.g_varchar2_table(49346) := '3030332E3030342E3030322E3030352E3038322E3136362E3030322E3030342E3030332E3030352E30322E30342E3038362E3133362E31312E3131382E31332E3039352E3134362E30372E3135362E3034312E31362E3031322E31362D2E3031392E3135';
wwv_flow_imp.g_varchar2_table(49347) := '352D2E3034382E3134322D2E3037352E3132362D2E312E3130352D2E3132332E30382D2E31342E3035342D2E3135322E3032342D2E31362D2E3030362D2E31362D2E3033362D2E3135382D2E3035312D2E3132332D2E3031382D2E3033342D2E3037382D';
wwv_flow_imp.g_varchar2_table(49348) := '2E3135384C332E312032322E316C2D2E3037342D2E31362D2E3037312D2E3135372D2E30372D2E31362D2E3036382D2E31362D2E3036372D2E3136352D2E3036322D2E3135382D2E3036322D2E3136342D2E3035392D2E3136312D2E3035382D2E313636';
wwv_flow_imp.g_varchar2_table(49349) := '2D2E3035362D2E3136362D2E3035332D2E3136342D2E3035322D2E3136382D2E30352D2E3136372D2E3034382D2E31372D2E3034352D2E3136352D2E3034332D2E3136382D2E3034332D2E3137322D2E3033392D2E31372D2E3033372D2E31372D2E3033';
wwv_flow_imp.g_varchar2_table(49350) := '362D2E3137322D2E3033332D2E31372D2E30332D2E3137332D2E30332D2E3137342D2E3032372D2E31372D2E3032352D2E3137352D2E3032322D2E3137342D2E3032312D2E3137352D2E3031382D2E3137352D2E3031372D2E3137332D2E3031342D2E31';
wwv_flow_imp.g_varchar2_table(49351) := '37362D2E3031322D2E3137362D2E30312D2E3137372D2E3030372D2E3137362D2E3030362D2E3137372D2E3030332D2E3137384C312E3733203136762D2E3133346C2D2E3031332D2E31362D2E3034342D2E3135362D2E3037322D2E3134342D2E303937';
wwv_flow_imp.g_varchar2_table(49352) := '2D2E3132392D2E31322D2E3130382D2E3133372D2E3038352D2E31352D2E3035374C2E3933382031357A6D32362E37393820322E3032346C2D2E31362E3030372D2E3135372E3033382D2E3134382E3036362D2E3133322E3039322D2E3131332E313135';
wwv_flow_imp.g_varchar2_table(49353) := '2D2E30392E3133342D2E3036322E3134382D2E30332E3132372D2E3030312E3030342D2E3032332E3133342D2E3032342E3133332D2E3032362E3133332D2E3032362E31332D2E30332E3133322D2E30332E3132392D2E3033322E3133342D2E3033332E';
wwv_flow_imp.g_varchar2_table(49354) := '3132382D2E3033352E31332D2E3033372E3132382D2E3033382E31332D2E30342E3132362D2E30342E3132382D2E3034342E3132382D2E3034342E3132362D2E3034362E3132362D2E3034382E3132362D2E30352E3132352D2E30352E3132352D2E3035';
wwv_flow_imp.g_varchar2_table(49355) := '312E3132322D2E3035342E3132332D2E3035352E3132322D2E3035362E31322D2E3035382E3132322D2E30362E31322D2E3036312E31322D2E3036332E3131392D2E3036322E3131362D2E3036372E3131392D2E3036362E3131362D2E3036392E313135';
wwv_flow_imp.g_varchar2_table(49356) := '2D2E3036392E3131352D2E30372E3131332D2E3037332E3131332D2E3037342E3131322D2E3037362E3131332D2E3037372E3131322D2E3037372E3130372D2E30382E31312D2E30382E3130372D2E3038352E31312D2E3034342E3035362D2E3038382E';
wwv_flow_imp.g_varchar2_table(49357) := '3133352D2E30362E31352D2E3033332E3135382D2E3030322E31362E3032372E31362E3035372E31352E3038332E3133382E3130382E31322E3132382E3039382E3134342E3037322E3135352E3034352E31362E3031352E3136312D2E3031362E313535';
wwv_flow_imp.g_varchar2_table(49358) := '2D2E3034342E3134342D2E3037332E3132382D2E3039382E30392D2E3039392E30352D2E3036312E3030332D2E3030342E3030332D2E3030352E3038392D2E3131352E3030332D2E3030342E3030332D2E3030352E3038382D2E3131362E3030332D2E30';
wwv_flow_imp.g_varchar2_table(49359) := '30342E3030332D2E3030352E3038362D2E3131372E3030332D2E3030342E3030332D2E3030352E3038342D2E3131382E3030332D2E3030342E3030332D2E3030352E3038332D2E31322E3030332D2E3030342E3030332D2E3030342E3038312D2E31322E';
wwv_flow_imp.g_varchar2_table(49360) := '3030332D2E3030352E3030332D2E3030342E30382D2E3132312E3030332D2E3030352E3030332D2E3030342E3037382D2E3132322E3030332D2E3030352E3030332D2E3030342E3037372D2E3132332E3030322D2E3030352E3030332D2E3030342E3037';
wwv_flow_imp.g_varchar2_table(49361) := '352D2E3132342E3030332D2E3030352E3030332D2E3030342E3037332D2E3132352E3030332D2E3030352E3030332D2E3030342E3037322D2E3132362E3030322D2E3030342E3030332D2E3030352E30372D2E3132362E3030332D2E3030352E3030322D';
wwv_flow_imp.g_varchar2_table(49362) := '2E3030352E30372D2E3132372E3030322D2E3030342E3030322D2E3030352E3036382D2E3132382E3030322D2E3030352E3030322D2E3030342E3036362D2E31332E3030332D2E3030342E3030322D2E3030352E3036342D2E31332E3030322D2E303034';
wwv_flow_imp.g_varchar2_table(49363) := '2E3030332D2E3030352E3036322D2E31332E3030322D2E3030352E3030332D2E3030352E30362D2E31332E3030332D2E3030352E3030322D2E3030352E30362D2E3133322E3030322D2E3030352E3030322D2E3030352E3035372D2E3133322E3030332D';
wwv_flow_imp.g_varchar2_table(49364) := '2E3030352E3030322D2E3030352E3035362D2E3133332E3030322D2E3030352E3030322D2E3030352E3035342D2E3133342E3030322D2E3030342E3030322D2E3030352E3035332D2E3133352E3030322D2E3030352E3030322D2E3030352E3035312D2E';
wwv_flow_imp.g_varchar2_table(49365) := '3133352E3030322D2E3030352E3030322D2E3030352E30352D2E3133352E3030312D2E3030352E3030322D2E3030352E3034382D2E3133372E3030312D2E3030352E3030322D2E3030352E3034362D2E3133372E3030322D2E3030352E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49366) := '352E3034342D2E3133372E3030322D2E3030352E3030322D2E3030352E3034322D2E3133382E3030322D2E3030352E3030312D2E3030362E3034322D2E3133382E3030312D2E3030352E3030322D2E3030352E30342D2E31345631392E346C2E3030322D';
wwv_flow_imp.g_varchar2_table(49367) := '2E3030352E3033382D2E31342E3030312D2E3030352E3030322D2E3030352E3033362D2E31342E3030312D2E3030352E3030312D2E3030352E3033352D2E3134312E3030312D2E3030352E3030312D2E3030352E3033332D2E3134322E3030312D2E3030';
wwv_flow_imp.g_varchar2_table(49368) := '352E3030312D2E3030352E3033312D2E3134312E3030312D2E3030362E3030322D2E3030352E3032392D2E313432762D2E3030356C2E3030322D2E3030352E3032382D2E313433762D2E3030356C2E3030322D2E3030352E3032352D2E3134332E303031';
wwv_flow_imp.g_varchar2_table(49369) := '2D2E3030362E3030312D2E3030352E3032342D2E3134332E3030312D2E3030352E3030312D2E3030362E3030312D2E3030362E30312D2E3136312D2E30322D2E31362D2E30352D2E3135342D2E3037372D2E3134312D2E3130322D2E3132352D2E313233';
wwv_flow_imp.g_varchar2_table(49370) := '2D2E3130342D2E3134312D2E3037392D2E3135332D2E3035312D2E31362D2E3032327A4D362E3834312032322E37316C2D2E31362E3032342D2E3135322E3035332D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E3134322D';
wwv_flow_imp.g_varchar2_table(49371) := '2E3034382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E3037372E3130392E30342E3034382E3030332E3030342E3030332E3030342E3039352E3131312E3030332E3030342E3030342E3030342E3039362E31';
wwv_flow_imp.g_varchar2_table(49372) := '312E3030342E3030352E3030332E3030342E3039382E3130392E3030332E3030342E3030342E3030342E312E3130382E3030332E3030342E3030332E3030342E3130312E3130372E3030342E3030342E3030332E3030342E3130322E3130352E3030342E';
wwv_flow_imp.g_varchar2_table(49373) := '3030342E3030342E3030342E3130332E3130352E3030342E3030342E3030342E3030332E3130352E3130342E3030332E3030342E3030342E3030332E3130362E3130322E3030342E3030342E3030342E3030342E3130372E312E3030342E3030342E3030';
wwv_flow_imp.g_varchar2_table(49374) := '342E3030342E3130382E3039392E3030342E3030332E3030342E3030342E31312E3039382E3030332E3030332E3030342E3030342E31312E3039362E3030342E3030332E3030352E3030342E31312E3039352E3030352E3030332E3030342E3030342E31';
wwv_flow_imp.g_varchar2_table(49375) := '31332E3039332E3030342E3030332E3030342E3030342E3131332E3039312E3030342E3030342E3030352E3030332E3131342E30392E3030342E3030342E3030342E3030332E3131362E3038392E3030342E3030332E3030342E3030332E3131372E3038';
wwv_flow_imp.g_varchar2_table(49376) := '382E3030342E3030332E3030342E3030332E3131382E3038362E3030342E3030332E3030352E3030332E3131382E3038342E3030342E3030332E3030352E3030332E3131392E3038332E3030342E3030332E3030352E3030332E31322E3038312E303035';
wwv_flow_imp.g_varchar2_table(49377) := '2E3030332E3030342E3030332E3132312E30382E3030352E3030332E3030342E3030332E3132322E3037382E3030352E3030332E3030342E3030332E3132332E3037362E3030352E3030332E3030342E3030332E3132342E3037352E3030352E3030332E';
wwv_flow_imp.g_varchar2_table(49378) := '3030342E3030332E3132352E3037332E3030342E3030332E3030352E3030322E3132362E3037332E3030342E3030322E3030352E3030332E3132362E30372E3030352E3030332E3030342E3030322E3132382E30372E3030342E3030322E3030352E3030';
wwv_flow_imp.g_varchar2_table(49379) := '322E3132382E3036372E3030352E3030332E3030342E3030322E31332E3036362E3030342E3030322E3030352E3030332E31332E3036342E3030342E3030322E3030352E3030332E31332E3036322E3030352E3030322E3030342E3030332E3133322E30';
wwv_flow_imp.g_varchar2_table(49380) := '362E3030342E3030332E3030352E3030322E3133322E30362E3030352E3030322E3030352E3030322E3133322E3035372E3030352E3030322E3030352E3030322E3133332E3035372E3030352E3030322E3030352E3030322E3133332E3035342E303035';
wwv_flow_imp.g_varchar2_table(49381) := '2E3030322E3030352E3030322E31332E30352E3135342E3034352E31362E3031362E31362D2E3031352E3135362D2E3034352E3134342D2E3037322E3132382D2E3039382E3130382D2E31322E3038332D2E3133382E3035372D2E31352E3032382D2E31';
wwv_flow_imp.g_varchar2_table(49382) := '362D2E3030332D2E31362D2E3033322D2E3135392D2E3036312D2E3134392D2E3038382D2E3133352D2E31312D2E3131372D2E3133322D2E3039342D2E31322D2E3035382D2E3132342D2E3034392D2E3132362D2E3035312D2E3132322D2E3035312D2E';
wwv_flow_imp.g_varchar2_table(49383) := '3132322D2E3035342D2E31322D2E3035342D2E3132362D2E3035382D2E3131392D2E3035372D2E31322D2E30362D2E31322D2E30362D2E3131382D2E3036332D2E3131372D2E3036342D2E3131392D2E3036362D2E3131362D2E3036362D2E3131352D2E';
wwv_flow_imp.g_varchar2_table(49384) := '3036382D2E3131352D2E30372D2E3131332D2E30372D2E3131352D2E3037342D2E3131322D2E3037342D2E31312D2E3037352D2E31312D2E3037362D2E3131322D2E30382D2E31312D2E30382D2E3130392D2E3038312D2E3130362D2E3038322D2E3130';
wwv_flow_imp.g_varchar2_table(49385) := '342D2E3038322D2E3130362D2E3038362D2E3130352D2E3038372D2E3130312D2E3038362D2E3130352D2E3039312D2E312D2E30392D2E312D2E3039312D2E312D2E3039342D2E3039372D2E3039342D2E312D2E3039382D2E3039332D2E3039352D2E30';
wwv_flow_imp.g_varchar2_table(49386) := '39362D2E312D2E3039332D2E3039382D2E3039322D2E3130312D2E3038392D2E312D2E30392D2E3130322D2E3038382D2E3130342D2E3033362D2E3034332D2E3131342D2E3131342D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E30';
wwv_flow_imp.g_varchar2_table(49387) := '33362D2E3136312D2E3030367A6D31352E30363320322E3730316C2D2E31362E3031342D2E3135362E3034342D2E31322E3035372D2E30362E3033342D2E31322E3036362D2E3131372E3036342D2E3131382E3036322D2E31322E3036312D2E31322E30';
wwv_flow_imp.g_varchar2_table(49388) := '362D2E3131382E3035372D2E3132362E3035382D2E31322E3035342D2E3132322E3035342D2E3132322E30352D2E3132362E3035322D2E3132352E30352D2E3132342E3034362D2E3132372E3034372D2E3132352E3034342D2E3132392E3034332D2E31';
wwv_flow_imp.g_varchar2_table(49389) := '32362E30342D2E31332E3034322D2E3132382E3033382D2E3132372E3033352D2E31332E3033362D2E3133312E3033342D2E3132392E3033312D2E3133322E30332D2E31332E30332D2E3133352E3032372D2E3133332E3032362D2E31332E3032332D2E';
wwv_flow_imp.g_varchar2_table(49390) := '31332E3032322D2E3133372E3032312D2E3133322E30322D2E3133342E3031372D2E3133322E3031352D2E3133382E3031352D2E3133352E3031332D2E3133332E30312D2E3133382E30312D2E3133362E3030372D2E3133342E3030362D2E3133362E30';
wwv_flow_imp.g_varchar2_table(49391) := '30342D2E31342E3030332D2E31362E3031382D2E3135352E3034372D2E3134322E3037362D2E3132372E312D2E3130352E3132322D2E30382E31342D2E3035342E3135312D2E3032352E31362E3030362E31362E3033352E3135382E3036342E3134382E';
wwv_flow_imp.g_varchar2_table(49392) := '30392E3133342E3131342E3131342E3133332E3039322E3134372E3036352E3135372E3033362E3133342E3030382E3134352D2E303032682E3031316C2E3134372D2E303035682E30316C2E3134372D2E303037682E3031316C2E3134362D2E30303968';
wwv_flow_imp.g_varchar2_table(49393) := '2E3031316C2E3134362D2E3031682E3030356C2E3030352D2E3030312E3134362D2E303132682E3031316C2E3134352D2E303134682E3030356C2E3030362D2E3030312E3134352D2E303136682E3031316C2E3134342D2E303138682E3030366C2E3030';
wwv_flow_imp.g_varchar2_table(49394) := '352D2E3030312E3134342D2E3032682E3031316C2E3134342D2E3032312E3030352D2E303031682E3030366C2E3134332D2E3032332E3030362D2E303031682E3030356C2E3134332D2E303235682E3030356C2E3030362D2E3030322E3134332D2E3032';
wwv_flow_imp.g_varchar2_table(49395) := '36682E3030356C2E3030352D2E3030322E3134332D2E3032372E3030352D2E3030312E3030352D2E3030312E3134322D2E3033682E3030356C2E3030352D2E3030322E3134322D2E30332E3030352D2E3030322E3030352D2E3030312E3134322D2E3033';
wwv_flow_imp.g_varchar2_table(49396) := '332E3030352D2E3030312E3030352D2E3030312E31342D2E3033352E3030362D2E3030312E3030352D2E3030312E31342D2E303337682E3030356C2E3030352D2E3030322E31342D2E3033382E3030352D2E303032682E3030356C2E31342D2E30342E30';
wwv_flow_imp.g_varchar2_table(49397) := '30352D2E3030322E3030352D2E3030312E3133382D2E3034322E3030352D2E3030312E3030362D2E3030322E3133382D2E3034332E3030352D2E3030312E3030352D2E3030322E3133372D2E3034342E3030352D2E3030322E3030352D2E3030322E3133';
wwv_flow_imp.g_varchar2_table(49398) := '372D2E3034362E3030352D2E3030322E3030352D2E3030312E3133372D2E3034382E3030352D2E3030322E3030352D2E3030322E3133352D2E30352E3030352D2E3030312E3030352D2E3030322E3133352D2E3035312E3030352D2E3030322E3030352D';
wwv_flow_imp.g_varchar2_table(49399) := '2E3030322E3133352D2E3035332E3030352D2E3030322E3030342D2E3030322E3133342D2E3035342E3030352D2E3030322E3030352D2E3030322E3133332D2E3035372E3030352D2E3030322E3030352D2E3030322E3133322D2E3035372E3030352D2E';
wwv_flow_imp.g_varchar2_table(49400) := '3030332E3030352D2E3030322E3133322D2E30362E3030352D2E3030312E3030342D2E3030322E3133312D2E3036312E3030352D2E3030332E3030352D2E3030322E31332D2E3036322E3030352D2E3030332E3030352D2E3030322E31332D2E3036342E';
wwv_flow_imp.g_varchar2_table(49401) := '3030342D2E3030332E3030352D2E3030322E3132382D2E3036362E3030352D2E3030322E3030352D2E3030332E3132382D2E3036372E3030352D2E3030322E3030342D2E3030332E3132372D2E3036392E3030352D2E3030322E3030352D2E3030332E31';
wwv_flow_imp.g_varchar2_table(49402) := '32362D2E30372E3030352D2E3030332E3030342D2E3030332E3036352D2E3033372E3133322D2E3039332E3131322D2E3131352E3038392D2E3133352E3036322D2E3134392E3033342D2E3135372E3030332D2E3136312D2E3032362D2E31362D2E3035';
wwv_flow_imp.g_varchar2_table(49403) := '352D2E31352D2E3038322D2E31342D2E3130372D2E31322D2E3132372D2E312D2E3134342D2E3037332D2E3135342D2E3034362D2E31362D2E3031367A4D362E33332032362E3831386C2D2E31362E3032332D2E3135322E3035332D2E31342E30382D2E';
wwv_flow_imp.g_varchar2_table(49404) := '3132322E3130352D2E3130312E3132362D2E3037362E3134322D2E3034382E3135342D2E30322E31362E3031322E3136312E3034312E3135362E30372E3134362E3039342E31332E3039362E3039332E3033322E3032362E3030342E3030332E3030342E';
wwv_flow_imp.g_varchar2_table(49405) := '3030342E3134352E3131372E3030342E3030332E3030342E3030342E3134362E3131352E3030352E3030332E3030342E3030342E3134372E3131332E3030352E3030332E3030342E3030342E3134392E3131312E3030342E3030332E3030342E3030332E';
wwv_flow_imp.g_varchar2_table(49406) := '31352E31312E3030352E3030332E3030342E3030332E3135312E3130382E3030342E3030332E3030352E3030332E3135322E3130362E3030352E3030332E3030342E3030332E3135342E3130342E3030342E3030332E3030352E3030332E3135342E3130';
wwv_flow_imp.g_varchar2_table(49407) := '322E3030352E3030322E3030342E3030332E3135362E312E3030352E3030332E3030342E3030332E3135372E3039382E3030352E3030332E3030342E3030322E3135392E3039362E3030342E3030332E3030352E3030332E31362E3039342E3030342E30';
wwv_flow_imp.g_varchar2_table(49408) := '30332E3030342E3030322E31362E3039322E3030352E3030332E3030352E3030322E3136312E30392E3030352E3030332E3030352E3030322E3136322E3038382E3030352E3030332E3030342E3030322E3136342E3038362E3030352E3030332E303034';
wwv_flow_imp.g_varchar2_table(49409) := '2E3030322E3136352E3038342E3030352E3030332E3030342E3030322E3136362E3038322E3030342E3030322E3030352E3030332E3136372E30382E3030342E3030322E3030352E3030322E3136382E3037382E3030342E3030322E3030352E3030322E';
wwv_flow_imp.g_varchar2_table(49410) := '3136382E3037362E3030352E3030322E3030352E3030322E31372E3037342E3030342E3030322E3030352E3030322E31372E3037322E3030352E3030322E3030352E3030322E31372E30372E3030362E3030322E3030352E3030312E3137312E3036382E';
wwv_flow_imp.g_varchar2_table(49411) := '3030352E3030322E3030352E3030322E3137332E3036352E3030352E3030322E3030352E3030322E3137332E3036332E3030352E3030322E3030352E3030322E3137342E30362E3030352E3030332E3030352E3030312E3137352E30362E3030352E3030';
wwv_flow_imp.g_varchar2_table(49412) := '312E3030352E3030322E3137362E3035372E3030352E3030312E3030352E3030322E3137362E3035352E3030362E3030312E3030352E3030322E3137372E3035322E3030352E3030322E3030352E3030312E3137382E30352E3030352E3030322E303035';
wwv_flow_imp.g_varchar2_table(49413) := '2E3030322E3137382E3034382E3030362E3030312E3030352E3030322E3137392E3034362E3030352E3030312E3030352E3030322E31382E303434682E3030356C2E3030352E3030322E31382E3034322E3030362E3030312E3030352E3030312E313539';
wwv_flow_imp.g_varchar2_table(49414) := '2E3033352E31362E30322E31362D2E30312E3135372D2E30342E3134362D2E3036392E31332D2E3039342E3131322D2E3131372E3038372D2E3133362E30362D2E3134392E3033332D2E3135382E3030322D2E3136312D2E3032382D2E3135392D2E3035';
wwv_flow_imp.g_varchar2_table(49415) := '372D2E31352D2E3038342D2E3133382D2E3130382D2E31322D2E3132382D2E3039382D2E3134342D2E3037322D2E3132382D2E3033392D2E3135342D2E3033332D2E3136382D2E30342D2E3137312D2E3034312D2E31372D2E3034342D2E3136382D2E30';
wwv_flow_imp.g_varchar2_table(49416) := '34362D2E3136372D2E3034372D2E3136382D2E30352D2E3136352D2E3035312D2E3136362D2E3035342D2E3136362D2E3035362D2E3136332D2E3035372D2E3136352D2E30362D2E3136312D2E3036322D2E3136342D2E3036342D2E31362D2E3036352D';
wwv_flow_imp.g_varchar2_table(49417) := '2E31362D2E3036382D2E3136322D2E30372D2E3135372D2E30372D2E3135372D2E3037342D2E3135372D2E3037352D2E3135362D2E3037372D2E3135332D2E3037392D2E3135362D2E3038322D2E3135332D2E3038322D2E3135342D2E3038362D2E3135';
wwv_flow_imp.g_varchar2_table(49418) := '2D2E3038362D2E3135322D2E30392D2E3134382D2E30392D2E3134372D2E3039322D2E3134392D2E3039352D2E3134352D2E3039352D2E3134342D2E3039382D2E3134352D2E312D2E3134332D2E3130322D2E31342D2E3130332D2E31342D2E3130342D';
wwv_flow_imp.g_varchar2_table(49419) := '2E31342D2E3130382D2E3133392D2E31312D2E3133362D2E31312D2E3032372D2E3032322D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E3033362D2E3136312D2E3030367A6D31392E3231352E3038376C2D2E31362E30312D2E3135';
wwv_flow_imp.g_varchar2_table(49420) := '372E3033392D2E3134362E3036372D2E31312E3037362D2E3036342E3035312D2E3133392E31312D2E31342E3130382D2E31342E3130342D2E31342E3130332D2E3134332E3130312D2E3134352E3130312D2E3134342E3039382D2E3134352E3039352D';
wwv_flow_imp.g_varchar2_table(49421) := '2E3134392E3039352D2E3134382E3039332D2E3134372E3038392D2E3135322E30392D2E31352E3038362D2E3135342E3038362D2E3135332E3038322D2E3135362E3038322D2E3135332E3037392D2E3135362E3037372D2E3135372E3037352D2E3135';
wwv_flow_imp.g_varchar2_table(49422) := '382E3037332D2E3135372E3037312D2E31362E30372D2E31362E3036382D2E3136312E3036352D2E3136342E3036342D2E3136312E3036312D2E3136352E30362D2E3136332E3035382D2E3136362E3035362D2E3136362E3035342D2E3136362E303531';
wwv_flow_imp.g_varchar2_table(49423) := '2D2E3136372E30352D2E3136372E3034372D2E31372E3034362D2E3136382E3034342D2E3137312E3034322D2E3136382E3033392D2E31372E3033372D2E31312E3032332D2E3135342E3034372D2E3134332E3037352D2E3132362E312D2E3130362E31';
wwv_flow_imp.g_varchar2_table(49424) := '32322D2E3038312E3133392D2E3035342E3135322D2E3032352E31362E3030362E31362E3033352E3135382E3036332E3134382E30392E3133332E3131342E3131352E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030372E3133';
wwv_flow_imp.g_varchar2_table(49425) := '332D2E3031362E3131352D2E3032342E3030352D2E3030312E3030352D2E3030312E3138312D2E3034682E3030356C2E3030352D2E3030322E31382D2E3034322E3030362D2E3030312E3030352D2E3030312E31382D2E3034342E3030352D2E3030322E';
wwv_flow_imp.g_varchar2_table(49426) := '3030352D2E3030312E31382D2E3034362E3030342D2E303032682E3030356C2E3137392D2E3035682E3030356C2E3030352D2E3030322E3137382D2E30352E3030352D2E3030322E3030352D2E3030322E3137372D2E3035322E3030352D2E3030322E30';
wwv_flow_imp.g_varchar2_table(49427) := '30352D2E3030312E3137372D2E3035352E3030352D2E3030322E3030352D2E3030312E3137362D2E3035372E3030352D2E3030322E3030352D2E3030322E3137352D2E3035392E3030352D2E3030312E3030352D2E3030322E3137342D2E3036312E3030';
wwv_flow_imp.g_varchar2_table(49428) := '352D2E3030322E3030352D2E3030322E3137332D2E3036332E3030352D2E3030322E3030352D2E3030322E3137332D2E3036352E3030342D2E3030322E3030352D2E3030322E3137322D2E3036382E3030352D2E3030322E3030352D2E3030322E313731';
wwv_flow_imp.g_varchar2_table(49429) := '2D2E30372E3030352D2E3030312E3030352D2E3030322E31372D2E3037322E3030352D2E3030322E3030342D2E3030322E31372D2E3037342E3030352D2E3030322E3030342D2E3030322E3136392D2E3037362E3030342D2E3030322E3030352D2E3030';
wwv_flow_imp.g_varchar2_table(49430) := '322E3136382D2E3037382E3030342D2E3030322E3030352D2E3030332E3136372D2E30382E3030342D2E3030322E3030352D2E3030322E3136362D2E3038322E3030342D2E3030322E3030352D2E3030332E3136352D2E3038342E3030342D2E3030322E';
wwv_flow_imp.g_varchar2_table(49431) := '3030352D2E3030332E3136332D2E3038362E3030352D2E3030322E3030352D2E3030332E3136322D2E3038382E3030352D2E3030322E3030352D2E3030332E3136312D2E30392E3030352D2E3030322E3030342D2E3030332E31362D2E3039322E303035';
wwv_flow_imp.g_varchar2_table(49432) := '2D2E3030332E3030352D2E3030322E31362D2E3039342E3030342D2E3030332E3030342D2E3030332E3135382D2E3039362E3030352D2E3030322E3030342D2E3030332E3135382D2E3039382E3030342D2E3030332E3030352D2E3030332E3135362D2E';
wwv_flow_imp.g_varchar2_table(49433) := '312E3030342D2E3030332E3030342D2E3030332E3135352D2E3130312E3030352D2E3030332E3030342D2E3030332E3135342D2E3130342E3030342D2E3030332E3030342D2E3030332E3135332D2E3130362E3030342D2E3030332E3030352D2E303033';
wwv_flow_imp.g_varchar2_table(49434) := '2E3135312D2E3130382E3030342D2E3030332E3030352D2E3030332E31352D2E31312E3030342D2E3030332E3030342D2E3030332E3134392D2E3131322E3030342D2E3030332E3030342D2E3030332E3134382D2E3131332E3030342D2E3030342E3030';
wwv_flow_imp.g_varchar2_table(49435) := '342D2E3030332E3134372D2E3131352E3030342D2E3030342E3030342D2E3030332E3036382D2E3035352E3131362D2E3131332E3039322D2E3133322E3036362D2E3134372E3033382D2E3135372E3030382D2E31362D2E3032322D2E31362D2E30352D';
wwv_flow_imp.g_varchar2_table(49436) := '2E3135332D2E30382D2E31342D2E3130332D2E3132352D2E3132342D2E3130322D2E3134322D2E3037372D2E3135332D2E30352D2E31362D2E30327A227D29293B66756E6374696F6E204C6A28297B72657475726E204C6A3D4F626A6563742E61737369';
wwv_flow_imp.g_varchar2_table(49437) := '676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F72287661722069';
wwv_flow_imp.g_varchar2_table(49438) := '20696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4C6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220446A3D287B7374796C65733A';
wwv_flow_imp.g_varchar2_table(49439) := '653D7B7D2C2E2E2E747D293D3E4E432822737667222C4C6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B64';
wwv_flow_imp.g_varchar2_table(49440) := '3A224D32332E3633372031332E3930326C2D372E3632352D352E3533352D372E36323420352E35333520322E39313220382E39353668392E3432356C322E3931322D382E3935367A6D2D312E3031372E33336C2D322E35323420372E3736324831312E39';
wwv_flow_imp.g_varchar2_table(49441) := '336C2D322E3532342D372E37363220362E3630372D342E37393620362E36303820342E3739367A4D31362E3031322E333131632D312E3434382E30322D322E39332E3135372D342E3330322E3632382D2E3835322E3434372D2E32353520312E3836332E';
wwv_flow_imp.g_varchar2_table(49442) := '363620312E35373420322E3235352D2E36303820342E3634382D2E36303720362E3932322D2E3130382E3933342E30373520312E3232382D312E3337362E3333382D312E36374331382E3435312E34342031372E3232372E3331372031362E3031322E33';
wwv_flow_imp.g_varchar2_table(49443) := '31317A6D392E30313220322E393334632D2E3931332D2E3130342D312E32373220312E3235382D2E34353420312E36343820312E38333420312E333620332E32393320332E31383520342E333120352E32322E3532362E37373620312E3834322E303938';
wwv_flow_imp.g_varchar2_table(49444) := '20312E3531352D2E37386131352E3532322031352E35323220302030302D352E30362D362E303036632D2E312D2E3034342D2E3230332D2E30372D2E33312D2E3038327A4D362E363520332E3539632D2E3736322E3038392D312E32342E3830392D312E';
wwv_flow_imp.g_varchar2_table(49445) := '38303520312E32363743332E333820362E32393520322E31363320382E30303720312E333720392E393035632D2E3236362E38393820312E30393420312E34383420312E3536342E3637356131342E3832352031342E3832352030203031342E3332372D';
wwv_flow_imp.g_varchar2_table(49446) := '352E3536632E3437362D2E3531352E30392D312E3431392D2E3631322D312E3433317A6D392E3336322E303037632D2E3639382E3036362D312E3638392D2E31362D322E3033332E3633352D2E3238322E3733332E35333520312E33353820312E323137';
wwv_flow_imp.g_varchar2_table(49447) := '20312E31323520312E3830362D2E31343720332E36332E32303320352E3239332E3930372E3930322E32353520312E3437322D312E3131322E3635362D312E3537332D312E362D2E3733352D332E3337342D312E3038392D352E3133332D312E3039347A';
wwv_flow_imp.g_varchar2_table(49448) := '6D2D352E34373920312E333635632D2E3833352E31352D312E3531372E37362D322E323120312E3232362D312E3230332E39342D322E33313820322E3036312D332E30353720332E3430322D2E33332E39303420312E30363320312E35353220312E3534';
wwv_flow_imp.g_varchar2_table(49449) := '372E37323320312E3034352D312E36353620322E3539362D322E39323520342E3238352D332E3837332E3534352D2E3439392E3137312D312E3436332D2E3536352D312E3437387A6D31332E39303320322E313135632D2E3837352D2E30372D312E3232';
wwv_flow_imp.g_varchar2_table(49450) := '20312E3137332D2E35303120312E36323720312E33323520312E333420322E31383820332E30363220322E37343820342E38342E3436382E383420312E3836392E323120312E3535372D2E3639392D2E3630342D322E3131382D312E3735312D342E3039';
wwv_flow_imp.g_varchar2_table(49451) := '372D332E3335312D352E363135612E39332E393320302030302D2E3435332D2E3135337A4D342E3436372031332E313332632D2E3832322D2E30372D2E3939362E3832362D312E30343620312E3435352D2E32353620312E39332D2E30393420332E3933';
wwv_flow_imp.g_varchar2_table(49452) := '332E35363220352E3736392E3430362E38343420312E3830372E33363520312E3631322D2E3535316131312E3439382031312E34393820302030312D2E3333342D352E3830382E3837342E38373420302030302D2E3739342D2E3836357A6D32362E3638';
wwv_flow_imp.g_varchar2_table(49453) := '3720312E36632D2E3734362D2E3033372D312E3031342E3738352D2E38373920312E3339352E30343320322E3339332D2E353720342E3737312D312E363620362E3839342D2E33312E38383420312E303220312E35333620312E35332E37356131352E36';
wwv_flow_imp.g_varchar2_table(49454) := '33322031352E3633322030203030312E3832312D382E3337322E3837362E38373620302030302D2E3831322D2E3636377A6D2D33302E3139372E353731632D2E3738322D2E3037332D312E3034342E3737352D2E39333320312E3430342E30363820322E';
wwv_flow_imp.g_varchar2_table(49455) := '3431342E36363120342E38333320312E38303920362E3936322E3533342E373720312E3834322E30373620312E3530352D2E3739386131342E3833332031342E38333320302030312D312E3630332D362E3836312E3837362E38373620302030302D2E37';
wwv_flow_imp.g_varchar2_table(49456) := '37382D2E3730377A6D32362E37383720322E303234632D2E3737372D2E3034382D2E3935322E3739372D312E30323120312E3339322D2E33353420312E3639322D312E32303220332E3233312D322E32313620342E3630382D2E3430372E3837322E3932';
wwv_flow_imp.g_varchar2_table(49457) := '3520312E36333820312E34382E38353220312E3336312D312E37333320322E3239362D332E38323720322E3538322D362E303137612E3837342E38373420302030302D2E3832352D2E3833357A4D362E3835372032332E303132632D2E3830382E303138';
wwv_flow_imp.g_varchar2_table(49458) := '2D312E30383220312E3132322D2E343720312E353920312E33393320312E36303720332E31383720322E38383620352E31393420332E3539392E39312E32323220312E34332D312E3136352E3539382D312E3539366131312E3439352031312E34393520';
wwv_flow_imp.g_varchar2_table(49459) := '302030312D342E3732332D332E3339362E3839392E38393920302030302D2E3539392D2E3139377A6D31352E30353720322E37632D2E38312E3139342D312E3530342E37362D322E3332352E3937322D312E3230332E3435382D322E352E3533362D332E';
wwv_flow_imp.g_varchar2_table(49460) := '3735382E3636342D2E3836392E3330372D2E35373320312E3732382E33343620312E36363320322E3230312D2E30333420342E3431322D2E36323620362E3239332D312E3737382E3630342D2E3439352E3232372D312E3533322D2E3535362D312E3532';
wwv_flow_imp.g_varchar2_table(49461) := '317A4D362E3334362032372E313138632D2E3833332E3030382D312E313120312E3231382D2E33393520312E36313720312E39383620312E36303220342E33353820322E37343920362E38363820332E3232362E3933332E30373620312E3232372D312E';
wwv_flow_imp.g_varchar2_table(49462) := '3337362E3333382D312E36376131342E3833382031342E38333820302030312D362E3334352D332E3036362E3932392E39323920302030302D2E3436362D2E3130377A6D31392E3230382E303837632D2E3736362E30392D312E3234312E3834312D312E';
wwv_flow_imp.g_varchar2_table(49463) := '39323220312E3135382D312E3531362E3939312D332E32353120312E35382D342E39393620322E3030352D2E3837322E3430352D2E33343620312E3834392E35383420312E36303420322E3534332D2E35323620342E39382D312E363620362E3936332D';
wwv_flow_imp.g_varchar2_table(49464) := '332E3334342E34372D2E35322E3037322D312E34322D2E36332D312E3432337A227D29293B66756E6374696F6E20546A28297B72657475726E20546A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E63';
wwv_flow_imp.g_varchar2_table(49465) := '74696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E6361';
wwv_flow_imp.g_varchar2_table(49466) := '6C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C546A2E6170706C79286E756C6C2C617267756D656E7473297D76617220496A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C546A287B786D';
wwv_flow_imp.g_varchar2_table(49467) := '6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31332E353120392E30383176342E34323848392E303876342E';
wwv_flow_imp.g_varchar2_table(49468) := '39383268342E34323876342E34323868342E3938325631382E343968342E343238762D342E3938324831382E343956392E303831682D342E3938327A6D2E38332E383368332E333276342E34323868342E34323976332E3332324831372E363676342E34';
wwv_flow_imp.g_varchar2_table(49469) := '3238682D332E3332762D342E34353448392E3931762D332E32393668342E34323856392E3931317A4D31362030682D2E3030356C2D2E3138382E303031682D2E3031316C2D2E3138382E303034682D2E3031316C2D2E3138372E303036682D2E3031316C';
wwv_flow_imp.g_varchar2_table(49470) := '2D2E3138372E303038682D2E3030354C31352E322E30326C2D2E3138372E3031682D2E3030356C2D2E3030352E3030312D2E3138372E303133682D2E3031314C31342E36322E3036682D2E30316C2D2E3138362E303138682D2E3031316C2D2E3138352E';
wwv_flow_imp.g_varchar2_table(49471) := '30322D2E3030352E303031682D2E3030366C2D2E3138352E3032322D2E3030352E303031682D2E3030356C2D2E3138352E303235682D2E3030356C2D2E3030352E3030312D2E3138352E303237682D2E3030356C2D2E3030352E3030312D2E3138342E30';
wwv_flow_imp.g_varchar2_table(49472) := '3239682D2E3030356C2D2E3030352E3030312D2E3138332E3033312D2E3030362E3030312D2E3030352E3030312D2E3138322E3033332D2E3030362E3030312D2E3030352E3030312D2E3138322E3033352D2E3030352E3030312D2E3030352E3030312D';
wwv_flow_imp.g_varchar2_table(49473) := '2E3138322E303338682D2E3030356C2D2E3030352E3030322D2E3138312E3034682D2E3030356C2D2E3030352E3030322D2E31382E3034322D2E3030362E3030312D2E3030352E3030312D2E31382E3034342D2E3030352E303032682D2E3030356C2D2E';
wwv_flow_imp.g_varchar2_table(49474) := '31372E3034352D2E3135322E3035342D2E3133392E3038322D2E3132312E3130362D2E312E3132372D2E3037342E3134332D2E3034362E3135352D2E3031372E31362E3031332E31362E3034332E3135362E30372E3134352E3039372E31332E3131392E';
wwv_flow_imp.g_varchar2_table(49475) := '3130382E3133372E3038352E31352E3035382E3135392E30332E31362D2E3030312E3133332D2E3032332E3136352D2E3034332E3136382D2E3034312E3137312D2E30342E3137312D2E3033372E3137322D2E3033362E31372D2E3033332E3137332D2E';
wwv_flow_imp.g_varchar2_table(49476) := '30332E31372D2E30332E3137372D2E3032372E3137312D2E3032352E3137352D2E3032322E3137352D2E30322E3137352D2E30322E3137362D2E3031362E3137352D2E3031342E3137372D2E3031322E3137362D2E30312E3137372D2E3030372E313734';
wwv_flow_imp.g_varchar2_table(49477) := '2D2E3030362E3137372D2E3030334C313620312E3733682E3137376C2E3137382E3030342E3137342E3030362E3137372E3030372E3137362E30312E3137372E3031322E3137352E3031342E3137362E3031372E3137352E3031382E3137352E30322E31';
wwv_flow_imp.g_varchar2_table(49478) := '37352E3032332E3137312E3032352E3137362E3032372E31372E30332E3137342E30332E31372E3033332E3137312E3033362E3135342E3033332E31362E30322E3136312D2E30312E3135362D2E30342E3134362D2E3036392E3133312D2E3039342E31';
wwv_flow_imp.g_varchar2_table(49479) := '31312D2E3131372E3038372D2E3133352E3036312D2E31352E3033322D2E3135382E3030322D2E31362D2E3032372D2E31362D2E3035372D2E31354C3230202E3731346C2D2E3130382D2E31322D2E3132382D2E3039372D2E3134352D2E3037332D2E31';
wwv_flow_imp.g_varchar2_table(49480) := '32382D2E3033382D2E3135382D2E3033352D2E3030352D2E3030312D2E3030352D2E3030314C31392E31342E3331682D2E3030356C2D2E3030352D2E3030322D2E3138322D2E303335682D2E3030366C2D2E3030352D2E3030322D2E3138322D2E303333';
wwv_flow_imp.g_varchar2_table(49481) := '682D2E3030366C2D2E3030352D2E3030322D2E3138332D2E30332D2E3030352D2E3030312D2E3030362D2E3030312D2E3138332D2E303239682D2E3030356C2D2E3030362D2E3030312D2E3138342D2E303237682D2E3030356C2D2E3030352D2E303031';
wwv_flow_imp.g_varchar2_table(49482) := '2D2E3138352D2E303234682D2E3030354C31372E3936382E31322031372E3738332E316C2D2E3030362D2E303031682D2E3030356C2D2E3138352D2E3032682D2E3030366C2D2E3030352D2E3030314C31372E33392E3036682D2E3030354C31372E3338';
wwv_flow_imp.g_varchar2_table(49483) := '2E30366C2D2E3138372D2E303135682D2E3030356C2D2E3030352D2E3030312D2E3138372D2E303133682D2E3031314C31362E382E3032682D2E3031314C31362E362E3031682D2E3031316C2D2E3138372D2E303036682D2E3031314C31362E32303420';
wwv_flow_imp.g_varchar2_table(49484) := '30682D2E3031314C31362E30303520304831367A6D392E30313520322E3933356C2D2E31362E3030342D2E3135382E3033332D2E31352E3036322D2E3133342E30392D2E3131362E3131312D2E3039332E3133322D2E3036372E3134372D2E3033382E31';
wwv_flow_imp.g_varchar2_table(49485) := '35362D2E30312E3136312E3032322E31362E30352E3135332E3037382E3134312E3130332E3132342E3130322E3038372E3034352E3033342E3134322E3130362E3133372E3130352E31342E31312E3133362E31312E3133352E3131322E3133342E3131';
wwv_flow_imp.g_varchar2_table(49486) := '352E3133342E3131372E31332E3131352E3133322E3132322E3132382E31322E3132372E3132322E3132362E3132352E3132342E3132362E3132342E3132382E3132312E31332E3131382E3132382E3131382E3133322E3131372E3133332E3131332E31';
wwv_flow_imp.g_varchar2_table(49487) := '33342E3131332E3133362E31312E3133362E3130392E3133372E3130392E3134322E3130342E31342E3130332E31342E3130312E3134322E312E3134342E3039392E3134362E3039352E3134352E3039342E3134372E3039332E31352E3039322E31352E';
wwv_flow_imp.g_varchar2_table(49488) := '3038372E3134392E3038372E31352E3038342E3135322E3038342E3135352E30382E3135322E30382E3135352E30342E3038312E3038342E3133382E31312E3131392E3132382E3039362E3134352E3037322E3135352E3034332E31362E3031332E3136';
wwv_flow_imp.g_varchar2_table(49489) := '2D2E3031362E3135352D2E3034362E3134342D2E3037342E3132372D2E3039392E3130362D2E31322E3038332D2E31342E3035352D2E3135312E3032362D2E31362D2E3030342D2E31362D2E3033342D2E3135382D2E30352D2E3132342D2E3034322D2E';
wwv_flow_imp.g_varchar2_table(49490) := '3038352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038342D2E3136352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038362D2E3136342D2E3030322D2E3030342D2E3030332D2E3030352D2E3038382D2E3136322D2E3030322D2E';
wwv_flow_imp.g_varchar2_table(49491) := '3030352D2E3030332D2E3030352D2E30392D2E3136312D2E3030322D2E3030352D2E3030332D2E3030342D2E3039322D2E31362D2E3030332D2E3030352D2E3030322D2E3030352D2E3039342D2E31362D2E3030332D2E3030342D2E3030332D2E303034';
wwv_flow_imp.g_varchar2_table(49492) := '2D2E3039362D2E3135392D2E3030322D2E3030342D2E3030332D2E3030352D2E3039382D2E3135372D2E3030332D2E3030342D2E3030332D2E3030352D2E312D2E3135362D2E3030332D2E3030342D2E3030332D2E3030352D2E3130312D2E3135342D2E';
wwv_flow_imp.g_varchar2_table(49493) := '3030332D2E3030352D2E3030332D2E3030342D2E3130342D2E3135342D2E3030332D2E3030342D2E3030332D2E3030352D2E3130362D2E3135322D2E3030332D2E3030352D2E3030332D2E3030342D2E3130382D2E3135312D2E3030332D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49494) := '3030332D2E3030352D2E31312D2E31352D2E3030332D2E3030342D2E3030332D2E3030342D2E3131312D2E31352D2E3030342D2E3030332D2E3030332D2E3030352D2E3131332D2E3134372D2E3030342D2E3030342D2E3030332D2E3030352D2E313135';
wwv_flow_imp.g_varchar2_table(49495) := '2D2E3134362D2E3030342D2E3030342D2E3030332D2E3030342D2E3131372D2E3134352D2E3030342D2E3030342D2E3030332D2E3030342D2E31322D2E3134342D2E3030332D2E3030342D2E3030332D2E3030342D2E3132312D2E3134322D2E3030342D';
wwv_flow_imp.g_varchar2_table(49496) := '2E3030342D2E3030332D2E3030342D2E3132332D2E3134312D2E3030332D2E3030342D2E3030342D2E3030342D2E3132352D2E31342D2E3030332D2E3030342D2E3030342D2E3030342D2E3132372D2E3133382D2E3030332D2E3030342D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49497) := '3030342D2E3132382D2E3133362D2E3030342D2E3030342D2E3030342D2E3030342D2E31332D2E3133352D2E3030342D2E3030342D2E3030342D2E3030342D2E3133322D2E3133342D2E3030332D2E3030342D2E3030342D2E3030332D2E3133342D2E31';
wwv_flow_imp.g_varchar2_table(49498) := '33332D2E3030342D2E3030332D2E3030342D2E3030342D2E3133352D2E31332D2E3030342D2E3030342D2E3030342D2E3030342D2E3133362D2E3132382D2E3030342D2E3030342D2E3030342D2E3030342D2E3133382D2E3132362D2E3030342D2E3030';
wwv_flow_imp.g_varchar2_table(49499) := '342D2E3030342D2E3030332D2E31342D2E3132352D2E3030342D2E3030342D2E3030342D2E3030332D2E31342D2E3132332D2E3030352D2E3030342D2E3030342D2E3030332D2E3134322D2E3132312D2E3030342D2E3030342D2E3030342D2E3030332D';
wwv_flow_imp.g_varchar2_table(49500) := '2E3134342D2E31322D2E3030342D2E3030332D2E3030342D2E3030332D2E3134352D2E3131372D2E3030342D2E3030342D2E3030342D2E3030332D2E3134372D2E3131352D2E3030342D2E3030342D2E3030342D2E3030332D2E3134382D2E3131332D2E';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(49501) := '3030342D2E3030332D2E3030342D2E3030342D2E3134392D2E3131312D2E3030342D2E3030332D2E3030342D2E3030342D2E30352D2E3033362D2E31342D2E3038332D2E31352D2E3035352D2E31362D2E3032377A4D362E36333420332E32386C2D2E31';
wwv_flow_imp.g_varchar2_table(49502) := '36312E3030382D2E3135372E3033372D2E3134372E3036362D2E3131312E3037342D2E30342E3033322D2E3030352E3030332D2E3030342E3030342D2E3134352E3131372D2E3030342E3030332D2E3030342E3030342D2E3134342E3131392D2E303034';
wwv_flow_imp.g_varchar2_table(49503) := '2E3030332D2E3030342E3030342D2E3134322E31322D2E3030342E3030342D2E3030342E3030342D2E3134312E3132332D2E3030342E3030332D2E3030342E3030342D2E31342E3132352D2E3030342E3030332D2E3030342E3030342D2E3133382E3132';
wwv_flow_imp.g_varchar2_table(49504) := '362D2E3030342E3030342D2E3030342E3030342D2E3133362E3132382D2E3030342E3030342D2E3030342E3030342D2E3133352E31332D2E3030342E3030342D2E3030342E3030332D2E3133342E3133332D2E3030342E3030332D2E3030342E3030342D';
wwv_flow_imp.g_varchar2_table(49505) := '2E3133322E3133342D2E3030332E3030342D2E3030342E3030342D2E31332E3133352D2E3030342E3030342D2E3030342E3030342D2E3132382E3133362D2E3030342E3030342D2E3030342E3030342D2E3132362E3133382D2E3030342E3030342D2E30';
wwv_flow_imp.g_varchar2_table(49506) := '30332E3030342D2E3132352E31342D2E3030342E3030342D2E3030332E3030342D2E3132332E31342D2E3030342E3030352D2E3030332E3030342D2E3132312E3134322D2E3030342E3030342D2E3030332E3030342D2E31322E3134342D2E3030332E30';
wwv_flow_imp.g_varchar2_table(49507) := '30342D2E3030332E3030342D2E3131372E3134352D2E3030342E3030342D2E3030332E3030342D2E3131352E3134362D2E3030342E3030352D2E3030332E3030342D2E3131332E3134372D2E3030332E3030352D2E3030342E3030342D2E3131312E3134';
wwv_flow_imp.g_varchar2_table(49508) := '392D2E3030332E3030342D2E3030342E3030342D2E31312E31352D2E3030322E3030352D2E3030332E3030342D2E3130382E3135312D2E3030332E3030342D2E3030332E3030352D2E3130362E3135322D2E3030332E3030352D2E3030332E3030342D2E';
wwv_flow_imp.g_varchar2_table(49509) := '3130342E3135342D2E3030332E3030342D2E3030332E3030352D2E3130322E3135342D2E3030332E3030352D2E3030322E3030342D2E312E3135362D2E3030332E3030352D2E3030332E3030342D2E3039382E3135372D2E3030332E3030352D2E303033';
wwv_flow_imp.g_varchar2_table(49510) := '2E3030342D2E3039362E3135392D2E3030322E3030342D2E3030332E3030352D2E3039342E31362D2E3030332E3030342D2E3030322E3030342D2E3039322E31362D2E3030332E3030352D2E3030332E3030352D2E30392E3136312D2E3030322E303035';
wwv_flow_imp.g_varchar2_table(49511) := '2D2E3030332E3030352D2E3038382E3136322D2E3030322E3030352D2E3030332E3030342D2E3038362E3136342D2E3030322E3030352D2E3030322E3030342D2E3038342E3136352D2E3030332E3030352D2E3030322E3030342D2E3038322E3136362D';
wwv_flow_imp.g_varchar2_table(49512) := '2E3030322E3030342D2E3030332E3030352D2E30382E3136372D2E3030322E3030342D2E3030322E3030352D2E3037382E3136382D2E3030322E3030342D2E3030322E3030352D2E3034352E312D2E3035332E3135332D2E3032332E31362E3030372E31';
wwv_flow_imp.g_varchar2_table(49513) := '362E3033372E3135372E3036352E3134382E3039322E3133322E3131342E3131342E3133342E30392E3134382E3036342E3135372E3033352E3136312E3030362E31362D2E3032352E3135322D2E3035342E31342D2E30382E3132312D2E3130362E312D';
wwv_flow_imp.g_varchar2_table(49514) := '2E3132362E3036352D2E3131382E3034332D2E3039352E3037342D2E31362E3037352D2E3135352E3037372D2E3135372E30382D2E3135352E30382D2E3135322E3038332D2E3135352E3038352D2E3135322E3038362D2E31352E3038382D2E3134392E';
wwv_flow_imp.g_varchar2_table(49515) := '3039312D2E31352E3039342D2E31352E3039342D2E3134372E3039352D2E3134352E3039392D2E3134362E312D2E3134342E312D2E3134322E3130342D2E31342E3130342D2E31342E31312D2E3134322E3130372D2E3133372E31312D2E3133362E3131';
wwv_flow_imp.g_varchar2_table(49516) := '342D2E3133362E3131332D2E3133342E3131372D2E3133332E3131382D2E3133322E3131372D2E3132392E3132322D2E31332E3132342D2E3132372E3132332D2E3132362E3132372D2E3132352E3132372D2E3132322E3132382D2E31322E3133322D2E';
wwv_flow_imp.g_varchar2_table(49517) := '3132322E31332D2E3131352E3133332D2E3131372E3133352D2E3131352E3133352D2E3131312E3133362D2E31312E3033372D2E30332E3131372D2E31312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E30312D2E3136312D2E3032';
wwv_flow_imp.g_varchar2_table(49518) := '2D2E31362D2E30352D2E3135342D2E3037362D2E3134312D2E3130322D2E3132352D2E3132332D2E3130342D2E31342D2E30382D2E3135332D2E3035312D2E31362D2E3032337A4D313620332E323836682D2E3030356C2D2E3134382E303031682D2E30';
wwv_flow_imp.g_varchar2_table(49519) := '316C2D2E3134372E303033682D2E3031316C2D2E3134372E303035682D2E3031316C2D2E3134362E303037682D2E3031316C2D2E3134362E303039682D2E3031316C2D2E3134362E3031682D2E3030356C2D2E3030352E3030312D2E3134362E30313268';
wwv_flow_imp.g_varchar2_table(49520) := '2D2E3031316C2D2E3134352E303134682D2E3030366C2D2E3030352E3030312D2E30352E3030362D2E3135382E3033312D2E31352E30362D2E3133352E3038382D2E3131372E3131312D2E3039342E31332D2E3036392E3134372D2E30342E3135362D2E';
wwv_flow_imp.g_varchar2_table(49521) := '30312E31362E3031392E31362E3034392E3135342E3037362E3134322E3130322E3132352E3132332E3130352E31342E30382E3135322E3035312E31362E3032332E3133342D2E3030332E3034352D2E3030352E3133352D2E3031332E3133332D2E3031';
wwv_flow_imp.g_varchar2_table(49522) := '2E3133362D2E30312E3133352D2E3030372E3133372D2E3030362E3133362D2E3030342E3133362D2E303033682E3237346C2E3133362E3030332E3133362E3030342E3133362E3030362E3133362E3030372E3133362E30312E3133332E30312E313335';
wwv_flow_imp.g_varchar2_table(49523) := '2E3031332E3133352E3031342E3133352E3031362E3133342E3031382E3133322E3031382E3133342E3032312E3133332E3032332E3133332E3032342E3133332E3032352E31332E3032372E3133322E30332E3133322E30332E3132392E3033312E3133';
wwv_flow_imp.g_varchar2_table(49524) := '2E3033342E3132392E3033352E3132392E3033362E31332E30342E3132362E3033382E3132382E3034322E3132362E3034322E3132382E3034352E3132372E3034372E3132362E3034372E31322E3034382E3132372E3035312E3132332E3035322E3030';
wwv_flow_imp.g_varchar2_table(49525) := '362E3030322E3134372E3034382E31362E3032312E31362D2E3030392E3135372D2E3033382E3134372D2E3036372E3133312D2E3039332E3131322D2E3131362E3038392D2E3133352E3036322D2E3134392E3033332D2E3135382E3030342D2E31362D';
wwv_flow_imp.g_varchar2_table(49526) := '2E3032372D2E31362D2E3035352D2E3135312D2E3038332D2E3133392D2E3130372D2E31322D2E3132372D2E3039392D2E3131382D2E3036332D2E3030342D2E3030312D2E3030352D2E3030332D2E3030352D2E3030322D2E3133332D2E3035362D2E30';
wwv_flow_imp.g_varchar2_table(49527) := '30352D2E3030322D2E3030352D2E3030322D2E3133342D2E3035342D2E3030342D2E3030322D2E3030352D2E3030322D2E3133352D2E3035332D2E3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E3035312D2E3030352D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49528) := '30352D2E3030322D2E3133352D2E30352D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034382D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034362D2E3030352D2E3030322D2E3030352D2E3030322D2E3133';
wwv_flow_imp.g_varchar2_table(49529) := '372D2E3034342D2E3030352D2E3030322D2E3030352D2E3030312D2E3133382D2E3034332D2E3030362D2E3030322D2E3030352D2E3030312D2E3133382D2E3034322D2E3030352D2E3030312D2E3030352D2E3030322D2E31342D2E30344831392E346C';
wwv_flow_imp.g_varchar2_table(49530) := '2D2E3030352D2E3030322D2E31342D2E3033382D2E3030352D2E3030312D2E3030352D2E3030322D2E31342D2E3033362D2E3030352D2E3030312D2E3030352D2E3030312D2E3134312D2E3033352D2E3030352D2E3030312D2E3030352D2E3030312D2E';
wwv_flow_imp.g_varchar2_table(49531) := '3134322D2E3033332D2E3030352D2E3030312D2E3030352D2E3030312D2E3134322D2E3033312D2E3030352D2E303032682D2E3030356C2D2E3134322D2E30332D2E3030352D2E3030312D2E3030352D2E3030312D2E3134332D2E303238682D2E303035';
wwv_flow_imp.g_varchar2_table(49532) := '6C2D2E3030352D2E3030322D2E3134332D2E3032352D2E3030362D2E3030312D2E3030352D2E3030312D2E3134332D2E3032342D2E3030352D2E3030312D2E3030362D2E3030312D2E3134332D2E3032322D2E3030362D2E303031682D2E3030356C2D2E';
wwv_flow_imp.g_varchar2_table(49533) := '3134342D2E303232682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303139682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303137682D2E3030366C2D2E3030352D2E3030312D2E3134352D2E303136682D2E3031316C2D2E3134';
wwv_flow_imp.g_varchar2_table(49534) := '352D2E3031344831372E316C2D2E3030352D2E3030312D2E3134362D2E303132682D2E30316C2D2E3134362D2E30312D2E3030362D2E303031682D2E3030356C2D2E3134362D2E303039682D2E3031316C2D2E3134372D2E303036682D2E30316C2D2E31';
wwv_flow_imp.g_varchar2_table(49535) := '34372D2E303035682D2E3031316C2D2E3134372D2E303033682D2E3031316C2D2E3134372D2E3030314831367A6D2D352E34383220312E3336366C2D2E31362E3030382D2E3135372E3033372D2E3132332E3035332D2E30362E3033322D2E3030352E30';
wwv_flow_imp.g_varchar2_table(49536) := '30322D2E3030342E3030332D2E3132382E3036392D2E3030342E3030322D2E3030352E3030332D2E3132362E30372D2E3030352E3030332D2E3030342E3030322D2E3132362E3037322D2E3030352E3030332D2E3030342E3030332D2E3132352E303733';
wwv_flow_imp.g_varchar2_table(49537) := '2D2E3030342E3030332D2E3030352E3030332D2E3132342E3037352D2E3030342E3030332D2E3030352E3030322D2E3132332E3037372D2E3030342E3030332D2E3030352E3030332D2E3132322E3037382D2E3030342E3030332D2E3030352E3030332D';
wwv_flow_imp.g_varchar2_table(49538) := '2E3132312E30382D2E3030342E3030322D2E3030352E3030332D2E31322E3038322D2E3030352E3030332D2E3030342E3030332D2E31322E3038332D2E3030342E3030332D2E3030342E3030332D2E3131382E3038342D2E3030352E3030332D2E303034';
wwv_flow_imp.g_varchar2_table(49539) := '2E3030332D2E3131382E3038362D2E3030342E3030332D2E3030342E3030332D2E3131372E3038382D2E3030342E3030332D2E3030342E3030332D2E3131362E3038392D2E3030342E3030332D2E3030342E3030342D2E3131342E30392D2E3030352E30';
wwv_flow_imp.g_varchar2_table(49540) := '30332D2E3030342E3030332D2E3131332E3039322D2E3030342E3030342D2E3030342E3030332D2E3131332E3039332D2E3030342E3030342D2E3030342E3030332D2E3131312E3039352D2E3030352E3030332D2E3030342E3030342D2E31312E303936';
wwv_flow_imp.g_varchar2_table(49541) := '2D2E3030342E3030342D2E3030342E3030332D2E31312E3039382D2E3030332E3030332D2E3030342E3030342D2E3130382E312D2E3030342E3030332D2E3030342E3030332D2E3130372E3130312D2E3030342E3030342D2E3030342E3030332D2E3130';
wwv_flow_imp.g_varchar2_table(49542) := '362E3130322D2E3030342E3030342D2E3030332E3030342D2E3130352E3130332D2E3030342E3030342D2E3030342E3030342D2E3130332E3130352D2E3030342E3030342D2E3030342E3030332D2E3130322E3130362D2E3030332E3030342D2E303034';
wwv_flow_imp.g_varchar2_table(49543) := '2E3030342D2E312E3130372D2E3030342E3030342D2E3030342E3030342D2E3039392E3130382D2E3030342E3030342D2E3030332E3030342D2E3039382E31312D2E3030332E3030332D2E3030342E3030342D2E3039362E31312D2E3030342E3030352D';
wwv_flow_imp.g_varchar2_table(49544) := '2E3030332E3030342D2E3039352E3131312D2E3030332E3030342D2E3030342E3030342D2E3039332E3131332D2E3030332E3030342D2E3030342E3030342D2E3039322E3131332D2E3030332E3030342D2E3030332E3030352D2E30392E3131342D2E30';
wwv_flow_imp.g_varchar2_table(49545) := '30342E3030342D2E3030332E3030342D2E3038392E3131362D2E3030332E3030342D2E3030332E3030342D2E3038382E3131372D2E3030332E3030342D2E3030332E3030342D2E3038362E3131382D2E3030332E3030342D2E3030332E3030352D2E3038';
wwv_flow_imp.g_varchar2_table(49546) := '342E3131382D2E3030332E3030342D2E3030332E3030352D2E3038332E31322D2E3030332E3030332D2E3030332E3030352D2E3038322E31322D2E3030332E3030352D2E3030322E3030342D2E3036382E3130332D2E3037362E3134322D2E3034382E31';
wwv_flow_imp.g_varchar2_table(49547) := '35342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E3039352E31332E3131372E31312E3133362E3038362E31352E30362E3135382E30332E3136322E3030322E3135382D2E30332E31352D2E3035372E3133382D2E3038';
wwv_flow_imp.g_varchar2_table(49548) := '352E3131392D2E3130392E3038322D2E3130352E3036352D2E3039392E3037352D2E31312E3037372D2E3131332E3037372D2E3130372E30382D2E31312E30382D2E3130382E3038342D2E3130382E3038332D2E3130352E3038362D2E3130362E303836';
wwv_flow_imp.g_varchar2_table(49549) := '2D2E3130342E3038382D2E3130342E3038392D2E3130312E30392D2E3130322E3039332D2E3130312E3039332D2E3039392E3039342D2E3039372E3039352D2E3039362E3039382D2E3039372E3039382D2E3039352E3039392D2E3039332E312D2E3039';
wwv_flow_imp.g_varchar2_table(49550) := '322E3130332D2E3039312E3130312D2E3038392E3130342D2E3038382E3130342D2E3038362E3130362D2E3038362E3130362D2E3038332E3130362D2E3038322E3130392D2E3038322E3130382D2E3037392E31312D2E3037382E31312D2E3037362E31';
wwv_flow_imp.g_varchar2_table(49551) := '31322D2E3037362E3131322D2E3037342E3131332D2E3037322E3131332D2E3037312E3131352D2E30372E3131352D2E3036382E3131382D2E3036372E3131372D2E3036352E31322D2E3036352E3035342D2E3032392E3133352D2E3038382E3131362D';
wwv_flow_imp.g_varchar2_table(49552) := '2E3131312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E3030392D2E3136312D2E30322D2E31362D2E30352D2E3135332D2E3037382D2E3134322D2E3130322D2E3132352D2E3132332D2E3130332D2E3134312D2E3037392D2E3135';
wwv_flow_imp.g_varchar2_table(49553) := '332D2E3035312D2E31362D2E3032327A6D31332E393120322E3131366C2D2E3136322E3030382D2E3135372E3033372D2E3134372E3036362D2E3133322E3039322D2E3131332E3131362D2E30392E3133342D2E3036332E3134382D2E3033342E313537';
wwv_flow_imp.g_varchar2_table(49554) := '2D2E3030352E3136322E3032352E3135392E3035352E3135322E3038322E3133382E3038362E3130332E30392E30392E3039342E3039382E3039322E3039392E3039332E312E3039312E3130332E3038392E3130312E3038382E3130342E3038362E3130';
wwv_flow_imp.g_varchar2_table(49555) := '342E3038362E3130362E3038332E3130352E3038332E3130382E30382E3130382E3038312E31312E3037372E3130372E3037372E3131322E3037352E3131312E3037352E3131342E3037322E3131332E3037312E3131332E30372E3131342E3036382E31';
wwv_flow_imp.g_varchar2_table(49556) := '31382E3036372E3131352E3036352E3131382E3036342E3131372E3036322E3131372E3036312E3132312E3035392E3131392E3035392E3132322E3035362E3132312E3035342E31322E3035352E3132352E3035312E3132332E3035312E3132352E3034';
wwv_flow_imp.g_varchar2_table(49557) := '382E3132332E3034382E3132372E3034372E3132362E3034342E3132352E3034332E3132382E3034322E3132392E3033392E3132362E3033382E31332E3032322E3037362E3035382E31352E3038352E3133372E31312E3131392E3132392E3039362E31';
wwv_flow_imp.g_varchar2_table(49558) := '34352E30372E3135352E3034332E31362E3031332E3136312D2E3031372E3135342D2E3034362E3134342D2E3037352E3132362D2E312E3130362D2E31322E3038322D2E31342E3035352D2E3135312E3032352D2E31362D2E3030352D2E31362D2E3032';
wwv_flow_imp.g_varchar2_table(49559) := '362D2E3133322D2E3032332D2E3038322D2E3030322D2E3030352D2E3030312D2E3030352D2E3034322D2E3133392D2E3030312D2E3030352D2E3030322D2E3030352D2E3034332D2E3133382D2E3030312D2E3030352D2E3030322D2E3030352D2E3034';
wwv_flow_imp.g_varchar2_table(49560) := '342D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E3034362D2E3133372D2E3030322D2E3030352D2E3030312D2E3030352D2E3034382D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E30352D2E3133352D2E303031';
wwv_flow_imp.g_varchar2_table(49561) := '2D2E3030352D2E3030322D2E3030352D2E3035312D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035332D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035342D2E3133332D2E3030322D2E3030352D2E303032';
wwv_flow_imp.g_varchar2_table(49562) := '2D2E3030352D2E3035372D2E3133332D2E3030322D2E3030352D2E3030322D2E3030352D2E3035372D2E3133322D2E3030332D2E3030352D2E3030322D2E3030352D2E30362D2E3133322D2E3030312D2E3030352D2E3030322D2E3030342D2E3036312D';
wwv_flow_imp.g_varchar2_table(49563) := '2E3133322D2E3030332D2E3030342D2E3030322D2E3030352D2E3036332D2E31332D2E3030322D2E3030352D2E3030322D2E3030352D2E3036342D2E31332D2E3030332D2E3030342D2E3030322D2E3030352D2E3036362D2E3132392D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49564) := '30342D2E3030332D2E3030352D2E3036372D2E3132382D2E3030322D2E3030352D2E3030332D2E3030342D2E3036392D2E3132382D2E3030322D2E3030342D2E3030332D2E3030352D2E30372D2E3132362D2E3030332D2E3030352D2E3030332D2E3030';
wwv_flow_imp.g_varchar2_table(49565) := '342D2E3037322D2E3132362D2E3030322D2E3030352D2E3030332D2E3030342D2E3037342D2E3132352D2E3030322D2E3030342D2E3030332D2E3030352D2E3037352D2E3132342D2E3030332D2E3030342D2E3030332D2E3030352D2E3037362D2E3132';
wwv_flow_imp.g_varchar2_table(49566) := '332D2E3030332D2E3030342D2E3030332D2E3030352D2E3037382D2E3132322D2E3030332D2E3030342D2E3030332D2E3030352D2E30382D2E3132312D2E3030332D2E3030342D2E3030332D2E3030352D2E3038312D2E31322D2E3030332D2E3030352D';
wwv_flow_imp.g_varchar2_table(49567) := '2E3030332D2E3030342D2E3038332D2E31322D2E3030332D2E3030342D2E3030332D2E3030342D2E3038342D2E3131382D2E3030332D2E3030352D2E3030332D2E3030342D2E3038362D2E3131382D2E3030332D2E3030342D2E3030342D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49568) := '3038372D2E3131372D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E3131362D2E3030322D2E3030342D2E3030342D2E3030342D2E30392D2E3131342D2E3030332D2E3030352D2E3030342D2E3030342D2E3039312D2E3131332D2E3030';
wwv_flow_imp.g_varchar2_table(49569) := '342D2E3030342D2E3030332D2E3030342D2E3039342D2E3131332D2E3030332D2E3030342D2E3030332D2E3030342D2E3039352D2E3131312D2E3030342D2E3030342D2E3030332D2E3030342D2E3039362D2E31312D2E3030342D2E3030352D2E303033';
wwv_flow_imp.g_varchar2_table(49570) := '2D2E3030342D2E3039382D2E31312D2E3030342D2E3030332D2E3030332D2E3030342D2E312D2E3130382D2E3030332D2E3030342D2E3030342D2E3030342D2E312D2E3130372D2E3030342D2E3030342D2E3030342D2E3030342D2E3130322D2E313036';
wwv_flow_imp.g_varchar2_table(49571) := '2D2E3030332D2E3030332D2E3030342D2E3030342D2E3039332D2E3039352D2E3132342D2E3130332D2E31342D2E30382D2E3135332D2E30352D2E31362D2E3032337A4D342E34352031322E3832366C2D2E3136312E3030322D2E3135382E3033322D2E';
wwv_flow_imp.g_varchar2_table(49572) := '31352E30362D2E3133352E3038382D2E3131382E31312D2E3039342E3133312D2E3036392E3134362D2E3033352E3132392D2E3032362E313332762E3030356C2D2E3030322E3030352D2E3032352E3134332D2E3030312E3030352D2E3030312E303036';
wwv_flow_imp.g_varchar2_table(49573) := '2D2E3032342E3134332D2E3030312E3030352D2E3030312E3030362D2E3032322E3134332D2E3030312E3030362D2E3030312E3030352D2E30322E3134342D2E3030312E3030352D2E3030312E3030352D2E3031392E313435762E3030356C2D2E303031';
wwv_flow_imp.g_varchar2_table(49574) := '2E3030362D2E3031372E313434762E3030366C2D2E3030312E3030352D2E3031362E313435762E3031316C2D2E3031342E313435762E3030356C2D2E3030312E3030362D2E3031322E313436762E30316C2D2E30312E3134362D2E3030312E303036762E';
wwv_flow_imp.g_varchar2_table(49575) := '3030356C2D2E3030392E313436762E3031316C2D2E3030372E313436762E3031316C2D2E3030342E313437762E3031316C2D2E3030332E313437762E30316C2D2E3030322E313438762E30316C2E3030312E313438762E30316C2E3030332E313437762E';
wwv_flow_imp.g_varchar2_table(49576) := '3031316C2E3030352E313437762E30316C2E3030372E313437762E3031316C2E3030392E313436762E3031316C2E30312E313436762E30316C2E3031332E313436762E3031316C2E3031342E313435762E3030356C2E3030312E3030362E3031362E3134';
wwv_flow_imp.g_varchar2_table(49577) := '35762E3031316C2E3031382E313434762E3030366C2E3030312E3030352E3031392E313434762E3030366C2E3030312E3030352E3032312E313434762E3030356C2E3030322E3030362E3032322E313433762E3030366C2E3030322E3030352E3032342E';
wwv_flow_imp.g_varchar2_table(49578) := '313433762E3030356C2E3030322E3030362E3032352E3134332E3030312E3030352E3030312E3030352E3032382E3134332E3030312E3030352E3030312E3030352E30332E313432762E3030356C2E3030322E3030362E30332E3134312E3030322E3030';
wwv_flow_imp.g_varchar2_table(49579) := '352E3030312E3030352E3033332E313432762E3030356C2E3030322E3030352E3033352E3134762E3030366C2E3030322E3030352E3033362E31342E3030322E3030352E3030312E3030352E3033382E31342E3030312E3030352E3030322E3030352E30';
wwv_flow_imp.g_varchar2_table(49580) := '342E3134762E3030356C2E3030322E3030352E3034322E3133382E3030312E3030362E3030322E3030352E3034322E3133382E3030322E3030352E3030322E3030352E3031372E3035342E3036342E3134382E30392E3133342E3131342E3131342E3133';
wwv_flow_imp.g_varchar2_table(49581) := '322E3039322E3134382E3036352E3135372E3033372E31362E3030372E31362D2E3032332E3135332D2E3035322E31342D2E30382E3132332D2E3130342E3130322D2E3132352E3037362D2E3134322E3034392D2E3135332E30322D2E31362D2E303131';
wwv_flow_imp.g_varchar2_table(49582) := '2D2E3136312D2E3033312D2E31332D2E3031372D2E3035312D2E3033392D2E3132362D2E3033382D2E31332D2E3033372D2E3132382D2E3033352D2E31332D2E3033332D2E3132382D2E3033332D2E3133342D2E30332D2E31332D2E3032392D2E313331';
wwv_flow_imp.g_varchar2_table(49583) := '2D2E3032362D2E31332D2E3032362D2E3133332D2E3032342D2E3133332D2E3032332D2E3133332D2E30322D2E3133322D2E30322D2E3133362D2E3031372D2E3133322D2E3031362D2E3133352D2E3031342D2E3133352D2E3031322D2E3133332D2E30';
wwv_flow_imp.g_varchar2_table(49584) := '31322D2E3133382D2E3030392D2E3133332D2E3030372D2E3133362D2E3030362D2E3133382D2E3030342D2E3133342D2E3030332D2E313336762D2E3237346C2E3030332D2E3133362E3030342D2E3133342E3030362D2E3133392E3030372D2E313336';
wwv_flow_imp.g_varchar2_table(49585) := '2E30312D2E3133332E30312D2E3133382E3031332D2E3133322E3031342D2E3133352E3031362D2E3133352E3031372D2E3133322E30322D2E3133372E30322D2E31332E3032332D2E3133342E3032342D2E3133332E3032342D2E3132362E3031362D2E';
wwv_flow_imp.g_varchar2_table(49586) := '31362D2E3031342D2E3136312D2E3034342D2E3135352D2E3037322D2E3134352D2E3039382D2E3132382D2E31322D2E3130382D2E3133372D2E3038342D2E31352D2E3035372D2E31362D2E3032397A6D32362E36393820312E3630316C2D2E3136312E';
wwv_flow_imp.g_varchar2_table(49587) := '30312D2E3135372E30342D2E3134362E3036372D2E3133312E3039332D2E3131322E3131372D2E3038382E3133352D2E3036312E3134392D2E3033332E3135372D2E3030352E3133342E3030362E31342E3030362E3137362E3030332E3137372E303031';
wwv_flow_imp.g_varchar2_table(49588) := '2E3137382D2E3030312E3137372D2E3030332E3137382D2E3030362E3137372D2E3030372E3137362D2E30312E3137372D2E3031322E3137362D2E3031352E3137362D2E3031362E3137332D2E3031382E3137352D2E30322E3137352D2E3032342E3137';
wwv_flow_imp.g_varchar2_table(49589) := '342D2E3032352E3137352D2E3032362E31372D2E30332E3137342D2E30332E3137332D2E3033332E31372D2E3033362E3137322D2E3033372E31372D2E30342E31372D2E3034322E3137322D2E3034332E3136382D2E3034352E3136362D2E3034382E31';
wwv_flow_imp.g_varchar2_table(49590) := '36392D2E30352E3136372D2E3035322E3136382D2E3035332E3136342D2E3035362E3136362D2E3035382E3136362D2E30362E31362D2E3036322E3136352D2E3036322E3135382D2E3036362E3136352D2E3036382E31362D2E30372E31362D2E30372E';
wwv_flow_imp.g_varchar2_table(49591) := '3135382D2E3037352E3135392D2E3037342E3135352D2E3037392E3135382D2E30382E3135382D2E30362E31352D2E30332E3135382D2E3030312E3136312E3032392E3135392E3035382E31352E3038352E3133372E3130382E3131392E31332E303937';
wwv_flow_imp.g_varchar2_table(49592) := '2E3134342E30372E3135362E3034342E31362E3031332E31362D2E3031372E3135352D2E3034362E3134332D2E3037342E3132372D2E312E3130372D2E31322E30372D2E3131352E3038332D2E3136342E3030332D2E3030352E3030322D2E3030342E30';
wwv_flow_imp.g_varchar2_table(49593) := '38322D2E3136362E3030322D2E3030352E3030332D2E3030342E30382D2E3136372E3030322D2E3030352E3030322D2E3030342E3037382D2E3136382E3030322D2E3030352E3030322D2E3030342E3037362D2E3136392E3030322D2E3030342E303032';
wwv_flow_imp.g_varchar2_table(49594) := '2D2E3030352E3037342D2E31372E3030322D2E3030342E3030322D2E3030352E3037322D2E31372E3030322D2E3030352E3030322D2E3030352E30372D2E3137312E3030312D2E3030352E3030322D2E3030352E3036382D2E3137322E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49595) := '342E3030322D2E3030352E3036352D2E3137332E3030322D2E3030352E3030322D2E3030352E3036332D2E3137332E3030322D2E3030352E3030322D2E3030352E30362D2E3137342E3030332D2E3030352E3030312D2E3030352E30362D2E3137352E30';
wwv_flow_imp.g_varchar2_table(49596) := '30312D2E3030352E3030322D2E3030352E3035372D2E3137362E3030312D2E3030352E3030322D2E3030352E3035352D2E3137372E3030312D2E3030352E3030322D2E3030352E3035322D2E3137372E3030322D2E3030352E3030312D2E3030352E3035';
wwv_flow_imp.g_varchar2_table(49597) := '312D2E3137382E3030312D2E3030352E3030322D2E3030352E3034382D2E3137392E3030322D2E303035762D2E3030356C2E3034372D2E3137392E3030312D2E3030352E3030322D2E3030352E3034342D2E3138762D2E3030356C2E3030322D2E303035';
wwv_flow_imp.g_varchar2_table(49598) := '2E3034322D2E31382E3030312D2E3030362E3030312D2E3030352E30342D2E3138312E3030312D2E3030352E3030312D2E3030352E3033372D2E3138322E3030322D2E303035762D2E3030356C2E3033362D2E313832762D2E3030366C2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49599) := '30352E3033332D2E313832762D2E3030366C2E3030322D2E3030352E30332D2E3138332E3030312D2E3030352E3030312D2E3030352E3032392D2E313834762D2E3030356C2E3030312D2E3030362E3032372D2E313834762D2E3030356C2E3030312D2E';
wwv_flow_imp.g_varchar2_table(49600) := '3030352E3032342D2E313835762D2E3030356C2E3030312D2E3030352E3032322D2E313835762D2E3030366C2E3030312D2E3030352E30322D2E313835762D2E3030366C2E3030312D2E3030352E3031372D2E313836762D2E3030356C2E3030312D2E30';
wwv_flow_imp.g_varchar2_table(49601) := '30352E3031352D2E313837762D2E3030356C2E3030312D2E3030352E3031332D2E313837762D2E30316C2E30312D2E3138372E3030312D2E303036762D2E3030356C2E3030392D2E313837762D2E3031316C2E3030362D2E313837762D2E3031316C2E30';
wwv_flow_imp.g_varchar2_table(49602) := '30342D2E313838762D2E3031316C2E3030312D2E313838762D2E30316C2D2E3030312D2E313838762D2E3031316C2D2E3030342D2E313838762D2E3031316C2D2E3030362D2E313837762D2E3031316C2D2E3030372D2E3134352D2E3032322D2E31362D';
wwv_flow_imp.g_varchar2_table(49603) := '2E30352D2E3135322D2E30382D2E3134312D2E3130332D2E3132342D2E3132352D2E3130322D2E3134312D2E3037372D2E3135332D2E30352D2E31362D2E30327A4D2E3933382031354C2E3737372031356C2D2E3135382E3033322D2E31352E30362D2E';
wwv_flow_imp.g_varchar2_table(49604) := '3133362E3038372D2E3131372E31312D2E3039352E3133312D2E3036382E3134362D2E30342E3135362D2E3031322E3133332D2E3030312E3134762E30316C2E3030312E313838762E3031316C2E3030342E313838762E3031316C2E3030362E31383776';
wwv_flow_imp.g_varchar2_table(49605) := '2E3031316C2E3030382E313837762E3031316C2E3031312E313837762E3030356C2E3030312E3030352E3031332E313837762E30316C2E3031362E313837762E30316C2E3031382E313836762E3031316C2E30322E3138352E3030312E303035762E3030';
wwv_flow_imp.g_varchar2_table(49606) := '366C2E3032322E3138352E3030312E303035762E3030356C2E3032352E313835762E3030356C2E3030312E3030352E3032372E313834762E3030366C2E3030312E3030352E3032392E313834762E3030356C2E3030312E3030352E3033312E3138332E30';
wwv_flow_imp.g_varchar2_table(49607) := '30312E3030352E3030312E3030362E3033332E3138322E3030312E3030352E3030312E3030362E3033352E3138322E3030312E3030352E3030312E3030352E3033382E313832762E3030356C2E3030322E3030352E30342E313831762E3030356C2E3030';
wwv_flow_imp.g_varchar2_table(49608) := '322E3030352E3034322E31382E3030312E3030362E3030312E3030352E3034342E31382E3030322E303035762E3030356C2E3034372E31382E3030312E3030342E3030322E3030352E3034382E3137392E3030322E3030352E3030312E3030352E30352E';
wwv_flow_imp.g_varchar2_table(49609) := '3137382E3030322E3030352E3030312E3030352E3035332E3137372E3030322E3030352E3030312E3030352E3035352E3137372E3030322E3030352E3030312E3030352E3035372E3137362E3030322E3030352E3030312E3030352E30362E3137352E30';
wwv_flow_imp.g_varchar2_table(49610) := '30312E3030352E3030322E3030352E3036312E3137342E3030322E3030352E3030322E3030352E3036332E3137332E3030322E3030352E3030322E3030352E3036352E3137332E3030322E3030352E3030322E3030342E3036372E3137322E3030322E30';
wwv_flow_imp.g_varchar2_table(49611) := '30352E3030322E3030352E30372E3137312E3030322E3030352E3030322E3030352E3037322E31372E3030322E3030352E3030322E3030342E3037342E31372E3030322E3030352E3030322E3030342E3037362E3136392E3030322E3030342E3030322E';
wwv_flow_imp.g_varchar2_table(49612) := '3030352E3037382E3136382E3030322E3030342E3030322E3030352E30382E3136372E3030332E3030342E3030322E3030352E3038322E3136362E3030322E3030342E3030332E3030352E30322E30342E3038362E3133362E31312E3131382E31332E30';
wwv_flow_imp.g_varchar2_table(49613) := '39352E3134362E30372E3135362E3034312E31362E3031322E31362D2E3031392E3135352D2E3034382E3134322D2E3037352E3132362D2E312E3130352D2E3132332E30382D2E31342E3035342D2E3135322E3032342D2E31362D2E3030362D2E31362D';
wwv_flow_imp.g_varchar2_table(49614) := '2E3033362D2E3135382D2E3035312D2E3132332D2E3031382D2E3033342D2E3037382D2E3135384C332E312032322E316C2D2E3037342D2E31362D2E3037312D2E3135372D2E30372D2E31362D2E3036382D2E31362D2E3036372D2E3136352D2E303632';
wwv_flow_imp.g_varchar2_table(49615) := '2D2E3135382D2E3036322D2E3136342D2E3035392D2E3136312D2E3035382D2E3136362D2E3035362D2E3136362D2E3035332D2E3136342D2E3035322D2E3136382D2E30352D2E3136372D2E3034382D2E31372D2E3034352D2E3136352D2E3034332D2E';
wwv_flow_imp.g_varchar2_table(49616) := '3136382D2E3034332D2E3137322D2E3033392D2E31372D2E3033372D2E31372D2E3033362D2E3137322D2E3033332D2E31372D2E30332D2E3137332D2E30332D2E3137342D2E3032372D2E31372D2E3032352D2E3137352D2E3032322D2E3137342D2E30';
wwv_flow_imp.g_varchar2_table(49617) := '32312D2E3137352D2E3031382D2E3137352D2E3031372D2E3137332D2E3031342D2E3137362D2E3031322D2E3137362D2E30312D2E3137372D2E3030372D2E3137362D2E3030362D2E3137372D2E3030332D2E3137384C312E3733203136762D2E313334';
wwv_flow_imp.g_varchar2_table(49618) := '6C2D2E3031332D2E31362D2E3034342D2E3135362D2E3037322D2E3134342D2E3039372D2E3132392D2E31322D2E3130382D2E3133372D2E3038352D2E31352D2E3035374C2E3933382031357A6D32362E37393820322E3032346C2D2E31362E3030372D';
wwv_flow_imp.g_varchar2_table(49619) := '2E3135372E3033382D2E3134382E3036362D2E3133322E3039322D2E3131332E3131352D2E30392E3133342D2E3036322E3134382D2E30332E3132372D2E3030312E3030342D2E3032332E3133342D2E3032342E3133332D2E3032362E3133332D2E3032';
wwv_flow_imp.g_varchar2_table(49620) := '362E31332D2E30332E3133322D2E30332E3132392D2E3033322E3133342D2E3033332E3132382D2E3033352E31332D2E3033372E3132382D2E3033382E31332D2E30342E3132362D2E30342E3132382D2E3034342E3132382D2E3034342E3132362D2E30';
wwv_flow_imp.g_varchar2_table(49621) := '34362E3132362D2E3034382E3132362D2E30352E3132352D2E30352E3132352D2E3035312E3132322D2E3035342E3132332D2E3035352E3132322D2E3035362E31322D2E3035382E3132322D2E30362E31322D2E3036312E31322D2E3036332E3131392D';
wwv_flow_imp.g_varchar2_table(49622) := '2E3036322E3131362D2E3036372E3131392D2E3036362E3131362D2E3036392E3131352D2E3036392E3131352D2E30372E3131332D2E3037332E3131332D2E3037342E3131322D2E3037362E3131332D2E3037372E3131322D2E3037372E3130372D2E30';
wwv_flow_imp.g_varchar2_table(49623) := '382E31312D2E30382E3130372D2E3038352E31312D2E3034342E3035362D2E3038382E3133352D2E30362E31352D2E3033332E3135382D2E3030322E31362E3032372E31362E3035372E31352E3038332E3133382E3130382E31322E3132382E3039382E';
wwv_flow_imp.g_varchar2_table(49624) := '3134342E3037322E3135352E3034352E31362E3031352E3136312D2E3031362E3135352D2E3034342E3134342D2E3037332E3132382D2E3039382E30392D2E3039392E30352D2E3036312E3030332D2E3030342E3030332D2E3030352E3038392D2E3131';
wwv_flow_imp.g_varchar2_table(49625) := '352E3030332D2E3030342E3030332D2E3030352E3038382D2E3131362E3030332D2E3030342E3030332D2E3030352E3038362D2E3131372E3030332D2E3030342E3030332D2E3030352E3038342D2E3131382E3030332D2E3030342E3030332D2E303035';
wwv_flow_imp.g_varchar2_table(49626) := '2E3038332D2E31322E3030332D2E3030342E3030332D2E3030342E3038312D2E31322E3030332D2E3030352E3030332D2E3030342E30382D2E3132312E3030332D2E3030352E3030332D2E3030342E3037382D2E3132322E3030332D2E3030352E303033';
wwv_flow_imp.g_varchar2_table(49627) := '2D2E3030342E3037372D2E3132332E3030322D2E3030352E3030332D2E3030342E3037352D2E3132342E3030332D2E3030352E3030332D2E3030342E3037332D2E3132352E3030332D2E3030352E3030332D2E3030342E3037322D2E3132362E3030322D';
wwv_flow_imp.g_varchar2_table(49628) := '2E3030342E3030332D2E3030352E30372D2E3132362E3030332D2E3030352E3030322D2E3030352E30372D2E3132372E3030322D2E3030342E3030322D2E3030352E3036382D2E3132382E3030322D2E3030352E3030322D2E3030342E3036362D2E3133';
wwv_flow_imp.g_varchar2_table(49629) := '2E3030332D2E3030342E3030322D2E3030352E3036342D2E31332E3030322D2E3030342E3030332D2E3030352E3036322D2E31332E3030322D2E3030352E3030332D2E3030352E30362D2E31332E3030332D2E3030352E3030322D2E3030352E30362D2E';
wwv_flow_imp.g_varchar2_table(49630) := '3133322E3030322D2E3030352E3030322D2E3030352E3035372D2E3133322E3030332D2E3030352E3030322D2E3030352E3035362D2E3133332E3030322D2E3030352E3030322D2E3030352E3035342D2E3133342E3030322D2E3030342E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49631) := '30352E3035332D2E3133352E3030322D2E3030352E3030322D2E3030352E3035312D2E3133352E3030322D2E3030352E3030322D2E3030352E30352D2E3133352E3030312D2E3030352E3030322D2E3030352E3034382D2E3133372E3030312D2E303035';
wwv_flow_imp.g_varchar2_table(49632) := '2E3030322D2E3030352E3034362D2E3133372E3030322D2E3030352E3030322D2E3030352E3034342D2E3133372E3030322D2E3030352E3030322D2E3030352E3034322D2E3133382E3030322D2E3030352E3030312D2E3030362E3034322D2E3133382E';
wwv_flow_imp.g_varchar2_table(49633) := '3030312D2E3030352E3030322D2E3030352E30342D2E31345631392E346C2E3030322D2E3030352E3033382D2E31342E3030312D2E3030352E3030322D2E3030352E3033362D2E31342E3030312D2E3030352E3030312D2E3030352E3033352D2E313431';
wwv_flow_imp.g_varchar2_table(49634) := '2E3030312D2E3030352E3030312D2E3030352E3033332D2E3134322E3030312D2E3030352E3030312D2E3030352E3033312D2E3134312E3030312D2E3030362E3030322D2E3030352E3032392D2E313432762D2E3030356C2E3030322D2E3030352E3032';
wwv_flow_imp.g_varchar2_table(49635) := '382D2E313433762D2E3030356C2E3030322D2E3030352E3032352D2E3134332E3030312D2E3030362E3030312D2E3030352E3032342D2E3134332E3030312D2E3030352E3030312D2E3030362E3030312D2E3030362E30312D2E3136312D2E30322D2E31';
wwv_flow_imp.g_varchar2_table(49636) := '362D2E30352D2E3135342D2E3037372D2E3134312D2E3130322D2E3132352D2E3132332D2E3130342D2E3134312D2E3037392D2E3135332D2E3035312D2E31362D2E3032327A4D362E3834312032322E37316C2D2E31362E3032342D2E3135322E303533';
wwv_flow_imp.g_varchar2_table(49637) := '2D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E3134322D2E3034382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E3037372E3130392E30342E3034382E3030332E3030342E3030';
wwv_flow_imp.g_varchar2_table(49638) := '332E3030342E3039352E3131312E3030332E3030342E3030342E3030342E3039362E31312E3030342E3030352E3030332E3030342E3039382E3130392E3030332E3030342E3030342E3030342E312E3130382E3030332E3030342E3030332E3030342E31';
wwv_flow_imp.g_varchar2_table(49639) := '30312E3130372E3030342E3030342E3030332E3030342E3130322E3130352E3030342E3030342E3030342E3030342E3130332E3130352E3030342E3030342E3030342E3030332E3130352E3130342E3030332E3030342E3030342E3030332E3130362E31';
wwv_flow_imp.g_varchar2_table(49640) := '30322E3030342E3030342E3030342E3030342E3130372E312E3030342E3030342E3030342E3030342E3130382E3039392E3030342E3030332E3030342E3030342E31312E3039382E3030332E3030332E3030342E3030342E31312E3039362E3030342E30';
wwv_flow_imp.g_varchar2_table(49641) := '30332E3030352E3030342E31312E3039352E3030352E3030332E3030342E3030342E3131332E3039332E3030342E3030332E3030342E3030342E3131332E3039312E3030342E3030342E3030352E3030332E3131342E30392E3030342E3030342E303034';
wwv_flow_imp.g_varchar2_table(49642) := '2E3030332E3131362E3038392E3030342E3030332E3030342E3030332E3131372E3038382E3030342E3030332E3030342E3030332E3131382E3038362E3030342E3030332E3030352E3030332E3131382E3038342E3030342E3030332E3030352E303033';
wwv_flow_imp.g_varchar2_table(49643) := '2E3131392E3038332E3030342E3030332E3030352E3030332E31322E3038312E3030352E3030332E3030342E3030332E3132312E30382E3030352E3030332E3030342E3030332E3132322E3037382E3030352E3030332E3030342E3030332E3132332E30';
wwv_flow_imp.g_varchar2_table(49644) := '37362E3030352E3030332E3030342E3030332E3132342E3037352E3030352E3030332E3030342E3030332E3132352E3037332E3030342E3030332E3030352E3030322E3132362E3037332E3030342E3030322E3030352E3030332E3132362E30372E3030';
wwv_flow_imp.g_varchar2_table(49645) := '352E3030332E3030342E3030322E3132382E30372E3030342E3030322E3030352E3030322E3132382E3036372E3030352E3030332E3030342E3030322E31332E3036362E3030342E3030322E3030352E3030332E31332E3036342E3030342E3030322E30';
wwv_flow_imp.g_varchar2_table(49646) := '30352E3030332E31332E3036322E3030352E3030322E3030342E3030332E3133322E30362E3030342E3030332E3030352E3030322E3133322E30362E3030352E3030322E3030352E3030322E3133322E3035372E3030352E3030322E3030352E3030322E';
wwv_flow_imp.g_varchar2_table(49647) := '3133332E3035372E3030352E3030322E3030352E3030322E3133332E3035342E3030352E3030322E3030352E3030322E31332E30352E3135342E3034352E31362E3031362E31362D2E3031352E3135362D2E3034352E3134342D2E3037322E3132382D2E';
wwv_flow_imp.g_varchar2_table(49648) := '3039382E3130382D2E31322E3038332D2E3133382E3035372D2E31352E3032382D2E31362D2E3030332D2E31362D2E3033322D2E3135392D2E3036312D2E3134392D2E3038382D2E3133352D2E31312D2E3131372D2E3133322D2E3039342D2E31322D2E';
wwv_flow_imp.g_varchar2_table(49649) := '3035382D2E3132342D2E3034392D2E3132362D2E3035312D2E3132322D2E3035312D2E3132322D2E3035342D2E31322D2E3035342D2E3132362D2E3035382D2E3131392D2E3035372D2E31322D2E30362D2E31322D2E30362D2E3131382D2E3036332D2E';
wwv_flow_imp.g_varchar2_table(49650) := '3131372D2E3036342D2E3131392D2E3036362D2E3131362D2E3036362D2E3131352D2E3036382D2E3131352D2E30372D2E3131332D2E30372D2E3131352D2E3037342D2E3131322D2E3037342D2E31312D2E3037352D2E31312D2E3037362D2E3131322D';
wwv_flow_imp.g_varchar2_table(49651) := '2E30382D2E31312D2E30382D2E3130392D2E3038312D2E3130362D2E3038322D2E3130342D2E3038322D2E3130362D2E3038362D2E3130352D2E3038372D2E3130312D2E3038362D2E3130352D2E3039312D2E312D2E30392D2E312D2E3039312D2E312D';
wwv_flow_imp.g_varchar2_table(49652) := '2E3039342D2E3039372D2E3039342D2E312D2E3039382D2E3039332D2E3039352D2E3039362D2E312D2E3039332D2E3039382D2E3039322D2E3130312D2E3038392D2E312D2E30392D2E3130322D2E3038382D2E3130342D2E3033362D2E3034332D2E31';
wwv_flow_imp.g_varchar2_table(49653) := '31342D2E3131342D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E3033362D2E3136312D2E3030367A6D31352E30363320322E3730316C2D2E31362E3031342D2E3135362E3034342D2E31322E3035372D2E30362E3033342D2E31322E';
wwv_flow_imp.g_varchar2_table(49654) := '3036362D2E3131372E3036342D2E3131382E3036322D2E31322E3036312D2E31322E30362D2E3131382E3035372D2E3132362E3035382D2E31322E3035342D2E3132322E3035342D2E3132322E30352D2E3132362E3035322D2E3132352E30352D2E3132';
wwv_flow_imp.g_varchar2_table(49655) := '342E3034362D2E3132372E3034372D2E3132352E3034342D2E3132392E3034332D2E3132362E30342D2E31332E3034322D2E3132382E3033382D2E3132372E3033352D2E31332E3033362D2E3133312E3033342D2E3132392E3033312D2E3133322E3033';
wwv_flow_imp.g_varchar2_table(49656) := '2D2E31332E30332D2E3133352E3032372D2E3133332E3032362D2E31332E3032332D2E31332E3032322D2E3133372E3032312D2E3133322E30322D2E3133342E3031372D2E3133322E3031352D2E3133382E3031352D2E3133352E3031332D2E3133332E';
wwv_flow_imp.g_varchar2_table(49657) := '30312D2E3133382E30312D2E3133362E3030372D2E3133342E3030362D2E3133362E3030342D2E31342E3030332D2E31362E3031382D2E3135352E3034372D2E3134322E3037362D2E3132372E312D2E3130352E3132322D2E30382E31342D2E3035342E';
wwv_flow_imp.g_varchar2_table(49658) := '3135312D2E3032352E31362E3030362E31362E3033352E3135382E3036342E3134382E30392E3133342E3131342E3131342E3133332E3039322E3134372E3036352E3135372E3033362E3133342E3030382E3134352D2E303032682E3031316C2E313437';
wwv_flow_imp.g_varchar2_table(49659) := '2D2E303035682E30316C2E3134372D2E303037682E3031316C2E3134362D2E303039682E3031316C2E3134362D2E3031682E3030356C2E3030352D2E3030312E3134362D2E303132682E3031316C2E3134352D2E303134682E3030356C2E3030362D2E30';
wwv_flow_imp.g_varchar2_table(49660) := '30312E3134352D2E303136682E3031316C2E3134342D2E303138682E3030366C2E3030352D2E3030312E3134342D2E3032682E3031316C2E3134342D2E3032312E3030352D2E303031682E3030366C2E3134332D2E3032332E3030362D2E303031682E30';
wwv_flow_imp.g_varchar2_table(49661) := '30356C2E3134332D2E303235682E3030356C2E3030362D2E3030322E3134332D2E303236682E3030356C2E3030352D2E3030322E3134332D2E3032372E3030352D2E3030312E3030352D2E3030312E3134322D2E3033682E3030356C2E3030352D2E3030';
wwv_flow_imp.g_varchar2_table(49662) := '322E3134322D2E30332E3030352D2E3030322E3030352D2E3030312E3134322D2E3033332E3030352D2E3030312E3030352D2E3030312E31342D2E3033352E3030362D2E3030312E3030352D2E3030312E31342D2E303337682E3030356C2E3030352D2E';
wwv_flow_imp.g_varchar2_table(49663) := '3030322E31342D2E3033382E3030352D2E303032682E3030356C2E31342D2E30342E3030352D2E3030322E3030352D2E3030312E3133382D2E3034322E3030352D2E3030312E3030362D2E3030322E3133382D2E3034332E3030352D2E3030312E303035';
wwv_flow_imp.g_varchar2_table(49664) := '2D2E3030322E3133372D2E3034342E3030352D2E3030322E3030352D2E3030322E3133372D2E3034362E3030352D2E3030322E3030352D2E3030312E3133372D2E3034382E3030352D2E3030322E3030352D2E3030322E3133352D2E30352E3030352D2E';
wwv_flow_imp.g_varchar2_table(49665) := '3030312E3030352D2E3030322E3133352D2E3035312E3030352D2E3030322E3030352D2E3030322E3133352D2E3035332E3030352D2E3030322E3030342D2E3030322E3133342D2E3035342E3030352D2E3030322E3030352D2E3030322E3133332D2E30';
wwv_flow_imp.g_varchar2_table(49666) := '35372E3030352D2E3030322E3030352D2E3030322E3133322D2E3035372E3030352D2E3030332E3030352D2E3030322E3133322D2E30362E3030352D2E3030312E3030342D2E3030322E3133312D2E3036312E3030352D2E3030332E3030352D2E303032';
wwv_flow_imp.g_varchar2_table(49667) := '2E31332D2E3036322E3030352D2E3030332E3030352D2E3030322E31332D2E3036342E3030342D2E3030332E3030352D2E3030322E3132382D2E3036362E3030352D2E3030322E3030352D2E3030332E3132382D2E3036372E3030352D2E3030322E3030';
wwv_flow_imp.g_varchar2_table(49668) := '342D2E3030332E3132372D2E3036392E3030352D2E3030322E3030352D2E3030332E3132362D2E30372E3030352D2E3030332E3030342D2E3030332E3036352D2E3033372E3133322D2E3039332E3131322D2E3131352E3038392D2E3133352E3036322D';
wwv_flow_imp.g_varchar2_table(49669) := '2E3134392E3033342D2E3135372E3030332D2E3136312D2E3032362D2E31362D2E3035352D2E31352D2E3038322D2E31342D2E3130372D2E31322D2E3132372D2E312D2E3134342D2E3037332D2E3135342D2E3034362D2E31362D2E3031367A4D362E33';
wwv_flow_imp.g_varchar2_table(49670) := '332032362E3831386C2D2E31362E3032332D2E3135322E3035332D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E3134322D2E3034382E3135342D2E30322E31362E3031322E3136312E3034312E3135362E30372E3134362E';
wwv_flow_imp.g_varchar2_table(49671) := '3039342E31332E3039362E3039332E3033322E3032362E3030342E3030332E3030342E3030342E3134352E3131372E3030342E3030332E3030342E3030342E3134362E3131352E3030352E3030332E3030342E3030342E3134372E3131332E3030352E30';
wwv_flow_imp.g_varchar2_table(49672) := '30332E3030342E3030342E3134392E3131312E3030342E3030332E3030342E3030332E31352E31312E3030352E3030332E3030342E3030332E3135312E3130382E3030342E3030332E3030352E3030332E3135322E3130362E3030352E3030332E303034';
wwv_flow_imp.g_varchar2_table(49673) := '2E3030332E3135342E3130342E3030342E3030332E3030352E3030332E3135342E3130322E3030352E3030322E3030342E3030332E3135362E312E3030352E3030332E3030342E3030332E3135372E3039382E3030352E3030332E3030342E3030322E31';
wwv_flow_imp.g_varchar2_table(49674) := '35392E3039362E3030342E3030332E3030352E3030332E31362E3039342E3030342E3030332E3030342E3030322E31362E3039322E3030352E3030332E3030352E3030322E3136312E30392E3030352E3030332E3030352E3030322E3136322E3038382E';
wwv_flow_imp.g_varchar2_table(49675) := '3030352E3030332E3030342E3030322E3136342E3038362E3030352E3030332E3030342E3030322E3136352E3038342E3030352E3030332E3030342E3030322E3136362E3038322E3030342E3030322E3030352E3030332E3136372E30382E3030342E30';
wwv_flow_imp.g_varchar2_table(49676) := '30322E3030352E3030322E3136382E3037382E3030342E3030322E3030352E3030322E3136382E3037362E3030352E3030322E3030352E3030322E31372E3037342E3030342E3030322E3030352E3030322E31372E3037322E3030352E3030322E303035';
wwv_flow_imp.g_varchar2_table(49677) := '2E3030322E31372E30372E3030362E3030322E3030352E3030312E3137312E3036382E3030352E3030322E3030352E3030322E3137332E3036352E3030352E3030322E3030352E3030322E3137332E3036332E3030352E3030322E3030352E3030322E31';
wwv_flow_imp.g_varchar2_table(49678) := '37342E30362E3030352E3030332E3030352E3030312E3137352E30362E3030352E3030312E3030352E3030322E3137362E3035372E3030352E3030312E3030352E3030322E3137362E3035352E3030362E3030312E3030352E3030322E3137372E303532';
wwv_flow_imp.g_varchar2_table(49679) := '2E3030352E3030322E3030352E3030312E3137382E30352E3030352E3030322E3030352E3030322E3137382E3034382E3030362E3030312E3030352E3030322E3137392E3034362E3030352E3030312E3030352E3030322E31382E303434682E3030356C';
wwv_flow_imp.g_varchar2_table(49680) := '2E3030352E3030322E31382E3034322E3030362E3030312E3030352E3030312E3135392E3033352E31362E30322E31362D2E30312E3135372D2E30342E3134362D2E3036392E31332D2E3039342E3131322D2E3131372E3038372D2E3133362E30362D2E';
wwv_flow_imp.g_varchar2_table(49681) := '3134392E3033332D2E3135382E3030322D2E3136312D2E3032382D2E3135392D2E3035372D2E31352D2E3038342D2E3133382D2E3130382D2E31322D2E3132382D2E3039382D2E3134342D2E3037322D2E3132382D2E3033392D2E3135342D2E3033332D';
wwv_flow_imp.g_varchar2_table(49682) := '2E3136382D2E30342D2E3137312D2E3034312D2E31372D2E3034342D2E3136382D2E3034362D2E3136372D2E3034372D2E3136382D2E30352D2E3136352D2E3035312D2E3136362D2E3035342D2E3136362D2E3035362D2E3136332D2E3035372D2E3136';
wwv_flow_imp.g_varchar2_table(49683) := '352D2E30362D2E3136312D2E3036322D2E3136342D2E3036342D2E31362D2E3036352D2E31362D2E3036382D2E3136322D2E30372D2E3135372D2E30372D2E3135372D2E3037342D2E3135372D2E3037352D2E3135362D2E3037372D2E3135332D2E3037';
wwv_flow_imp.g_varchar2_table(49684) := '392D2E3135362D2E3038322D2E3135332D2E3038322D2E3135342D2E3038362D2E31352D2E3038362D2E3135322D2E30392D2E3134382D2E30392D2E3134372D2E3039322D2E3134392D2E3039352D2E3134352D2E3039352D2E3134342D2E3039382D2E';
wwv_flow_imp.g_varchar2_table(49685) := '3134352D2E312D2E3134332D2E3130322D2E31342D2E3130332D2E31342D2E3130342D2E31342D2E3130382D2E3133392D2E31312D2E3133362D2E31312D2E3032372D2E3032322D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E3033';
wwv_flow_imp.g_varchar2_table(49686) := '362D2E3136312D2E3030367A6D31392E3231352E3038376C2D2E31362E30312D2E3135372E3033392D2E3134362E3036372D2E31312E3037362D2E3036342E3035312D2E3133392E31312D2E31342E3130382D2E31342E3130342D2E31342E3130332D2E';
wwv_flow_imp.g_varchar2_table(49687) := '3134332E3130312D2E3134352E3130312D2E3134342E3039382D2E3134352E3039352D2E3134392E3039352D2E3134382E3039332D2E3134372E3038392D2E3135322E30392D2E31352E3038362D2E3135342E3038362D2E3135332E3038322D2E313536';
wwv_flow_imp.g_varchar2_table(49688) := '2E3038322D2E3135332E3037392D2E3135362E3037372D2E3135372E3037352D2E3135382E3037332D2E3135372E3037312D2E31362E30372D2E31362E3036382D2E3136312E3036352D2E3136342E3036342D2E3136312E3036312D2E3136352E30362D';
wwv_flow_imp.g_varchar2_table(49689) := '2E3136332E3035382D2E3136362E3035362D2E3136362E3035342D2E3136362E3035312D2E3136372E30352D2E3136372E3034372D2E31372E3034362D2E3136382E3034342D2E3137312E3034322D2E3136382E3033392D2E31372E3033372D2E31312E';
wwv_flow_imp.g_varchar2_table(49690) := '3032332D2E3135342E3034372D2E3134332E3037352D2E3132362E312D2E3130362E3132322D2E3038312E3133392D2E3035342E3135322D2E3032352E31362E3030362E31362E3033352E3135382E3036332E3134382E30392E3133332E3131342E3131';
wwv_flow_imp.g_varchar2_table(49691) := '352E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030372E3133332D2E3031362E3131352D2E3032342E3030352D2E3030312E3030352D2E3030312E3138312D2E3034682E3030356C2E3030352D2E3030322E31382D2E3034322E';
wwv_flow_imp.g_varchar2_table(49692) := '3030362D2E3030312E3030352D2E3030312E31382D2E3034342E3030352D2E3030322E3030352D2E3030312E31382D2E3034362E3030342D2E303032682E3030356C2E3137392D2E3035682E3030356C2E3030352D2E3030322E3137382D2E30352E3030';
wwv_flow_imp.g_varchar2_table(49693) := '352D2E3030322E3030352D2E3030322E3137372D2E3035322E3030352D2E3030322E3030352D2E3030312E3137372D2E3035352E3030352D2E3030322E3030352D2E3030312E3137362D2E3035372E3030352D2E3030322E3030352D2E3030322E313735';
wwv_flow_imp.g_varchar2_table(49694) := '2D2E3035392E3030352D2E3030312E3030352D2E3030322E3137342D2E3036312E3030352D2E3030322E3030352D2E3030322E3137332D2E3036332E3030352D2E3030322E3030352D2E3030322E3137332D2E3036352E3030342D2E3030322E3030352D';
wwv_flow_imp.g_varchar2_table(49695) := '2E3030322E3137322D2E3036382E3030352D2E3030322E3030352D2E3030322E3137312D2E30372E3030352D2E3030312E3030352D2E3030322E31372D2E3037322E3030352D2E3030322E3030342D2E3030322E31372D2E3037342E3030352D2E303032';
wwv_flow_imp.g_varchar2_table(49696) := '2E3030342D2E3030322E3136392D2E3037362E3030342D2E3030322E3030352D2E3030322E3136382D2E3037382E3030342D2E3030322E3030352D2E3030332E3136372D2E30382E3030342D2E3030322E3030352D2E3030322E3136362D2E3038322E30';
wwv_flow_imp.g_varchar2_table(49697) := '30342D2E3030322E3030352D2E3030332E3136352D2E3038342E3030342D2E3030322E3030352D2E3030332E3136332D2E3038362E3030352D2E3030322E3030352D2E3030332E3136322D2E3038382E3030352D2E3030322E3030352D2E3030332E3136';
wwv_flow_imp.g_varchar2_table(49698) := '312D2E30392E3030352D2E3030322E3030342D2E3030332E31362D2E3039322E3030352D2E3030332E3030352D2E3030322E31362D2E3039342E3030342D2E3030332E3030342D2E3030332E3135382D2E3039362E3030352D2E3030322E3030342D2E30';
wwv_flow_imp.g_varchar2_table(49699) := '30332E3135382D2E3039382E3030342D2E3030332E3030352D2E3030332E3135362D2E312E3030342D2E3030332E3030342D2E3030332E3135352D2E3130312E3030352D2E3030332E3030342D2E3030332E3135342D2E3130342E3030342D2E3030332E';
wwv_flow_imp.g_varchar2_table(49700) := '3030342D2E3030332E3135332D2E3130362E3030342D2E3030332E3030352D2E3030332E3135312D2E3130382E3030342D2E3030332E3030352D2E3030332E31352D2E31312E3030342D2E3030332E3030342D2E3030332E3134392D2E3131322E303034';
wwv_flow_imp.g_varchar2_table(49701) := '2D2E3030332E3030342D2E3030332E3134382D2E3131332E3030342D2E3030342E3030342D2E3030332E3134372D2E3131352E3030342D2E3030342E3030342D2E3030332E3036382D2E3035352E3131362D2E3131332E3039322D2E3133322E3036362D';
wwv_flow_imp.g_varchar2_table(49702) := '2E3134372E3033382D2E3135372E3030382D2E31362D2E3032322D2E31362D2E30352D2E3135332D2E30382D2E31342D2E3130332D2E3132352D2E3132342D2E3130322D2E3134322D2E3037372D2E3135332D2E30352D2E31362D2E30327A222C6F7061';
wwv_flow_imp.g_varchar2_table(49703) := '636974793A222E3938227D29293B66756E6374696F6E204D6A28297B72657475726E204D6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C61';
wwv_flow_imp.g_varchar2_table(49704) := '7267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D7265';
wwv_flow_imp.g_varchar2_table(49705) := '7475726E20657D2C4D6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220416A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4D6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_imp.g_varchar2_table(49706) := '323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31362E30313220382E3831364C392E32312032312E3032366831332E3630366C2D362E3830332D31322E32317A6D3020';
wwv_flow_imp.g_varchar2_table(49707) := '312E3737366C352E33333220392E35374831302E3638316C352E3333312D392E35377A6D302D31302E323831632D312E3434382E30322D322E39332E3135372D342E3330322E3632382D2E3835322E3434372D2E32353520312E3836332E363620312E35';
wwv_flow_imp.g_varchar2_table(49708) := '373420322E3235352D2E36303820342E3634382D2E36303720362E3932322D2E3130382E3933342E30373520312E3232382D312E3337362E3333382D312E36374331382E3435312E34342031372E3232372E3331372031362E3031322E3331317A6D392E';
wwv_flow_imp.g_varchar2_table(49709) := '30313220322E393334632D2E3931332D2E3130342D312E32373220312E3235382D2E34353420312E36343820312E38333420312E333620332E32393320332E31383520342E333120352E32322E3532362E37373620312E3834322E30393820312E353135';
wwv_flow_imp.g_varchar2_table(49710) := '2D2E37386131352E3532322031352E35323220302030302D352E30362D362E303036632D2E312D2E3034342D2E3230332D2E30372D2E33312D2E3038327A4D362E363520332E3539632D2E3736322E3038392D312E32342E3830392D312E38303520312E';
wwv_flow_imp.g_varchar2_table(49711) := '32363743332E333820362E32393520322E31363320382E30303720312E333720392E393035632D2E3236362E38393820312E30393420312E34383420312E3536342E3637356131342E3832352031342E3832352030203031342E3332372D352E3536632E';
wwv_flow_imp.g_varchar2_table(49712) := '3437362D2E3531352E30392D312E3431392D2E3631322D312E3433317A6D392E3336322E303037632D2E3639382E3036362D312E3638392D2E31362D322E3033332E3633352D2E3238322E3733332E35333520312E33353820312E32313720312E313235';
wwv_flow_imp.g_varchar2_table(49713) := '20312E3830362D2E31343720332E36332E32303320352E3239332E3930372E3930322E32353520312E3437322D312E3131322E3635362D312E3537332D312E362D2E3733352D332E3337342D312E3038392D352E3133332D312E3039347A6D2D352E3437';
wwv_flow_imp.g_varchar2_table(49714) := '3920312E333635632D2E3833352E31352D312E3531372E37362D322E323120312E3232362D312E3230332E39342D322E33313820322E3036312D332E30353720332E3430322D2E33332E39303420312E30363320312E35353220312E3534372E37323320';
wwv_flow_imp.g_varchar2_table(49715) := '312E3034352D312E36353620322E3539362D322E39323520342E3238352D332E3837332E3534352D2E3439392E3137312D312E3436332D2E3536352D312E3437387A6D31332E39303320322E313135632D2E3837352D2E30372D312E323220312E313733';
wwv_flow_imp.g_varchar2_table(49716) := '2D2E35303120312E36323720312E33323520312E333420322E31383820332E30363220322E37343820342E38342E3436382E383420312E3836392E323120312E3535372D2E3639392D2E3630342D322E3131382D312E3735312D342E3039372D332E3335';
wwv_flow_imp.g_varchar2_table(49717) := '312D352E363135612E39332E393320302030302D2E3435332D2E3135337A4D342E3436372031332E313332632D2E3832322D2E30372D2E3939362E3832362D312E30343620312E3435352D2E32353620312E39332D2E30393420332E3933332E35363220';
wwv_flow_imp.g_varchar2_table(49718) := '352E3736392E3430362E38343420312E3830372E33363520312E3631322D2E3535316131312E3439382031312E34393820302030312D2E3333342D352E3830382E3837342E38373420302030302D2E3739342D2E3836357A6D32362E36383720312E3663';
wwv_flow_imp.g_varchar2_table(49719) := '2D2E3734362D2E3033372D312E3031342E3738352D2E38373920312E3339352E30343320322E3339332D2E353720342E3737312D312E363620362E3839342D2E33312E38383420312E303220312E35333620312E35332E37356131352E3633322031352E';
wwv_flow_imp.g_varchar2_table(49720) := '3633322030203030312E3832312D382E3337322E3837362E38373620302030302D2E3831322D2E3636377A6D2D33302E3139372E353731632D2E3738322D2E3037332D312E3034342E3737352D2E39333320312E3430342E30363820322E3431342E3636';
wwv_flow_imp.g_varchar2_table(49721) := '3120342E38333320312E38303920362E3936322E3533342E373720312E3834322E30373620312E3530352D2E3739386131342E3833332031342E38333320302030312D312E3630332D362E3836312E3837362E38373620302030302D2E3737382D2E3730';
wwv_flow_imp.g_varchar2_table(49722) := '377A6D32362E37383720322E303234632D2E3737372D2E3034382D2E3935322E3739372D312E30323120312E3339322D2E33353420312E3639322D312E32303220332E3233312D322E32313620342E3630382D2E3430372E3837322E39323520312E3633';
wwv_flow_imp.g_varchar2_table(49723) := '3820312E34382E38353220312E3336312D312E37333320322E3239362D332E38323720322E3538322D362E303137612E3837342E38373420302030302D2E3832352D2E3833357A4D362E3835372032332E303132632D2E3830382E3031382D312E303832';
wwv_flow_imp.g_varchar2_table(49724) := '20312E3132322D2E343720312E353920312E33393320312E36303720332E31383720322E38383620352E31393420332E3539392E39312E32323220312E34332D312E3136352E3539382D312E3539366131312E3439352031312E34393520302030312D34';
wwv_flow_imp.g_varchar2_table(49725) := '2E3732332D332E3339362E3839392E38393920302030302D2E3539392D2E3139377A6D31352E30353720322E37632D2E38312E3139342D312E3530342E37362D322E3332352E3937322D312E3230332E3435382D322E352E3533362D332E3735382E3636';
wwv_flow_imp.g_varchar2_table(49726) := '342D2E3836392E3330372D2E35373320312E3732382E33343620312E36363320322E3230312D2E30333420342E3431322D2E36323620362E3239332D312E3737382E3630342D2E3439352E3232372D312E3533322D2E3535362D312E3532317A4D362E33';
wwv_flow_imp.g_varchar2_table(49727) := '34362032372E313138632D2E3833332E3030382D312E313120312E3231382D2E33393520312E36313720312E39383620312E36303220342E33353820322E37343920362E38363820332E3232362E3933332E30373620312E3232372D312E3337362E3333';
wwv_flow_imp.g_varchar2_table(49728) := '382D312E36376131342E3833382031342E38333820302030312D362E3334352D332E3036362E3932392E39323920302030302D2E3436362D2E3130377A6D31392E3230382E303837632D2E3736362E30392D312E3234312E3834312D312E39323220312E';
wwv_flow_imp.g_varchar2_table(49729) := '3135382D312E3531362E3939312D332E32353120312E35382D342E39393620322E3030352D2E3837322E3430352D2E33343620312E3834392E35383420312E36303420322E3534332D2E35323620342E39382D312E363620362E3936332D332E3334342E';
wwv_flow_imp.g_varchar2_table(49730) := '34372D2E35322E3037322D312E34322D2E36332D312E3432337A227D29293B66756E6374696F6E204E6A28297B72657475726E204E6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(49731) := '297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C69';
wwv_flow_imp.g_varchar2_table(49732) := '29262628655B695D3D6E5B695D297D72657475726E20657D2C4E6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220506A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4E6A287B786D6C6E733A2268';
wwv_flow_imp.g_varchar2_table(49733) := '7474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E39393820382E343036632D332E3031382D2E3034312D352E39322031';
wwv_flow_imp.g_varchar2_table(49734) := '2E3932362D372E30333120342E3732372D312E31333820322E3639352D2E353120362E30313220312E35333720382E31303320312E393920322E31343120352E32363820322E393320382E30313420312E39323720322E3837382D2E393820342E393932';
wwv_flow_imp.g_varchar2_table(49735) := '2D332E38323720352E3036382D362E38372E3135332D322E3935372D312E3632342D352E38382D342E332D372E31333761372E35353220372E35353220302030302D332E3238382D2E37357A6D3020312E33383463322E3735392D2E30353220352E3337';
wwv_flow_imp.g_varchar2_table(49736) := '3320312E39373320362E30313520342E3635352E37303420322E3537382D2E34383220352E3531372D322E37393120362E3836372D322E33353820312E34382D352E36383220312E3038362D372E3631382D2E3931382D322E3034332D312E3937312D32';
wwv_flow_imp.g_varchar2_table(49737) := '2E3430372D352E3338312D2E38342D372E37343520312E31312D312E37363320332E31352D322E383820352E3233342D322E38367A6D312E39363220312E3736356C2D322E30373420332E373632632D2E36342E3036382D2E37393320312E30342D2E32';
wwv_flow_imp.g_varchar2_table(49738) := '303220312E332E33392E32372E3639362D2E313820312E3035322D2E31363568332E3137762D2E383635682D332E3138326C312E3939332D332E363135632D2E3235322D2E31342D2E3530352D2E3237382D2E3735372D2E3431377A6D2D312E3936352D';
wwv_flow_imp.g_varchar2_table(49739) := '382E323638682D2E3135386C2D2E3134372E303033682D2E3031316C2D2E3134372E303035682D2E3031316C2D2E3134362E303037682D2E3031316C2D2E3134362E303039682D2E3031316C2D2E3134362E3031682D2E3030356C2D2E3030352E303031';
wwv_flow_imp.g_varchar2_table(49740) := '2D2E3134362E303132682D2E3031316C2D2E3134352E303134682D2E3030366C2D2E3030352E3030312D2E30352E3030362D2E3135382E3033312D2E31352E30362D2E3133352E3038382D2E3131372E3131312D2E3039342E31332D2E3036392E313437';
wwv_flow_imp.g_varchar2_table(49741) := '2D2E30342E3135362D2E30312E31362E3031392E31362E3034392E3135342E3037362E3134322E3130322E3132352E3132332E3130352E31342E30382E3135322E3035312E31362E3032332E3133342D2E3030332E3034352D2E3030352E3133352D2E30';
wwv_flow_imp.g_varchar2_table(49742) := '31332E3133332D2E30312E3133362D2E30312E3133352D2E3030372E3133372D2E3030362E3133362D2E3030342E3133362D2E303033682E3237346C2E3133362E3030332E3133362E3030342E3133362E3030362E3133362E3030372E3133362E30312E';
wwv_flow_imp.g_varchar2_table(49743) := '3133332E30312E3133352E3031332E3133352E3031342E3133352E3031362E3133342E3031382E3133322E3031382E3133342E3032312E3133332E3032332E3133332E3032342E3133332E3032352E31332E3032372E3133322E30332E3133322E30332E';
wwv_flow_imp.g_varchar2_table(49744) := '3132392E3033312E31332E3033342E3132392E3033352E3132392E3033362E31332E30342E3132362E3033382E3132382E3034322E3132362E3034322E3132382E3034352E3132372E3034372E3132362E3034382E31322E3034372E3132372E3035312E';
wwv_flow_imp.g_varchar2_table(49745) := '3132332E3035322E3030362E3030322E3134372E3034382E31362E3032312E31362D2E3030392E3135372D2E3033382E3134372D2E3036372E3133312D2E3039332E3131322D2E3131362E3038392D2E3133352E3036322D2E3134392E3033332D2E3135';
wwv_flow_imp.g_varchar2_table(49746) := '382E3030342D2E31362D2E3032372D2E31362D2E3035352D2E3135312D2E3038332D2E3133382D2E3130372D2E3132312D2E3132372D2E3039392D2E3131382D2E3036332D2E3030342D2E3030312D2E3030352D2E3030332D2E3030352D2E3030322D2E';
wwv_flow_imp.g_varchar2_table(49747) := '3133332D2E3035362D2E3030352D2E3030322D2E3030352D2E3030322D2E3133342D2E3035342D2E3030342D2E3030322D2E3030352D2E3030322D2E3133352D2E3035332D2E3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E3035312D2E';
wwv_flow_imp.g_varchar2_table(49748) := '3030352D2E3030322D2E3030352D2E3030322D2E3133352D2E30352D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034382D2E3030352D2E3030312D2E3030352D2E3030322D2E3133372D2E3034362D2E3030352D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49749) := '30352D2E3030322D2E3133372D2E3034342D2E3030352D2E3030322D2E3030352D2E3030312D2E3133382D2E3034332D2E3030352D2E3030322D2E3030362D2E3030312D2E3133382D2E3034322D2E3030352D2E3030312D2E3030352D2E3030322D2E31';
wwv_flow_imp.g_varchar2_table(49750) := '342D2E30344831392E346C2D2E3030352D2E3030322D2E31342D2E3033382D2E3030352D2E3030312D2E3030352D2E3030322D2E31342D2E3033362D2E3030352D2E3030312D2E3030352D2E3030312D2E3134312D2E3033352D2E3030352D2E3030312D';
wwv_flow_imp.g_varchar2_table(49751) := '2E3030352D2E3030312D2E3134322D2E3033332D2E3030352D2E3030312D2E3030352D2E3030312D2E3134312D2E3033312D2E3030362D2E303032682D2E3030356C2D2E3134322D2E30332D2E3030352D2E3030312D2E3030352D2E3030312D2E313433';
wwv_flow_imp.g_varchar2_table(49752) := '2D2E303238682D2E3030356C2D2E3030352D2E3030312D2E3134332D2E3032362D2E3030362D2E3030312D2E3030352D2E3030312D2E3134332D2E3032342D2E3030352D2E3030312D2E3030362D2E3030312D2E3134332D2E3032322D2E3030362D2E30';
wwv_flow_imp.g_varchar2_table(49753) := '3031682D2E3030356C2D2E3134342D2E303232682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303139682D2E3030356C2D2E3030362D2E3030312D2E3134342D2E303137682D2E3030366C2D2E3030352D2E3030312D2E3134352D2E303136';
wwv_flow_imp.g_varchar2_table(49754) := '682D2E3031316C2D2E3134352D2E3031344831372E316C2D2E3030352D2E3030312D2E3134362D2E303132682D2E30316C2D2E3134362D2E30312D2E3030362D2E303031682D2E3030356C2D2E3134362D2E303039682D2E3031316C2D2E3134372D2E30';
wwv_flow_imp.g_varchar2_table(49755) := '3036682D2E30316C2D2E3134372D2E303035682D2E3031316C2D2E3134372D2E303033682D2E30316C2D2E3134382D2E303031682D2E30317A4D31302E33353720342E36366C2D2E3135362E3033372D2E3132332E3035332D2E30362E3033322D2E3030';
wwv_flow_imp.g_varchar2_table(49756) := '352E3030322D2E3030342E3030332D2E3132382E3036392D2E3030342E3030322D2E3030352E3030332D2E3132362E30372D2E3030352E3030332D2E3030342E3030322D2E3132362E3037322D2E3030352E3030332D2E3030342E3030332D2E3132352E';
wwv_flow_imp.g_varchar2_table(49757) := '3037332D2E3030342E3030332D2E3030352E3030332D2E3132342E3037352D2E3030342E3030332D2E3030352E3030322D2E3132332E3037372D2E3030342E3030332D2E3030352E3030332D2E3132322E3037382D2E3030342E3030332D2E3030352E30';
wwv_flow_imp.g_varchar2_table(49758) := '30332D2E3132312E30382D2E3030342E3030322D2E3030352E3030332D2E31322E3038322D2E3030352E3030332D2E3030342E3030332D2E31322E3038332D2E3030342E3030332D2E3030342E3030332D2E3131382E3038342D2E3030352E3030332D2E';
wwv_flow_imp.g_varchar2_table(49759) := '3030342E3030332D2E3131382E3038362D2E3030342E3030332D2E3030342E3030332D2E3131372E3038382D2E3030342E3030332D2E3030342E3030332D2E3131362E3038392D2E3030342E3030332D2E3030342E3030342D2E3131342E30392D2E3030';
wwv_flow_imp.g_varchar2_table(49760) := '352E3030332D2E3030342E3030332D2E3131332E3039322D2E3030342E3030342D2E3030342E3030332D2E3131332E3039332D2E3030342E3030342D2E3030342E3030332D2E3131312E3039352D2E3030342E3030332D2E3030352E3030342D2E31312E';
wwv_flow_imp.g_varchar2_table(49761) := '3039362D2E3030342E3030342D2E3030342E3030332D2E3130392E3039382D2E3030342E3030332D2E3030342E3030342D2E3130382E312D2E3030342E3030332D2E3030342E3030332D2E3130372E3130312D2E3030342E3030342D2E3030342E303033';
wwv_flow_imp.g_varchar2_table(49762) := '2D2E3130362E3130322D2E3030332E3030342D2E3030342E3030342D2E3130352E3130332D2E3030342E3030342D2E3030342E3030342D2E3130332E3130352D2E3030342E3030342D2E3030342E3030332D2E3130322E3130362D2E3030332E3030342D';
wwv_flow_imp.g_varchar2_table(49763) := '2E3030342E3030342D2E312E3130372D2E3030342E3030342D2E3030342E3030342D2E3039392E3130382D2E3030342E3030342D2E3030332E3030342D2E3039382E31312D2E3030332E3030332D2E3030342E3030342D2E3039362E31312D2E3030342E';
wwv_flow_imp.g_varchar2_table(49764) := '3030352D2E3030332E3030342D2E3039352E3131312D2E3030332E3030342D2E3030342E3030342D2E3039332E3131332D2E3030332E3030342D2E3030342E3030342D2E3039322E3131332D2E3030332E3030342D2E3030332E3030352D2E30392E3131';
wwv_flow_imp.g_varchar2_table(49765) := '342D2E3030342E3030342D2E3030332E3030342D2E3038392E3131362D2E3030332E3030342D2E3030332E3030342D2E3038382E3131372D2E3030332E3030342D2E3030332E3030352D2E3038362E3131372D2E3030332E3030342D2E3030332E303035';
wwv_flow_imp.g_varchar2_table(49766) := '2D2E3038342E3131382D2E3030332E3030342D2E3030332E3030352D2E3038332E31322D2E3030332E3030332D2E3030332E3030352D2E3038322E31322D2E3030332E3030352D2E3030322E3030342D2E3036382E3130332D2E3037362E3134322D2E30';
wwv_flow_imp.g_varchar2_table(49767) := '34382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E3039352E31332E3131372E31312E3133362E3038362E31352E30362E3135382E30332E3136322E3030322E3135382D2E3032392E31352D2E3035382E3133';
wwv_flow_imp.g_varchar2_table(49768) := '382D2E3038352E3131392D2E3130382E3038322D2E3130362E3036352D2E3039392E3037352D2E31312E3037372D2E3131332E3037372D2E3130372E30382D2E31312E30382D2E3130382E3038342D2E3130382E3038332D2E3130352E3038362D2E3130';
wwv_flow_imp.g_varchar2_table(49769) := '362E3038362D2E3130342E3038382D2E3130342E3038392D2E3130312E30392D2E3130322E3039332D2E3130312E3039332D2E3039392E3039342D2E3039372E3039352D2E3039362E3039382D2E3039372E3039382D2E3039352E3039392D2E3039332E';
wwv_flow_imp.g_varchar2_table(49770) := '312D2E3039322E3130332D2E3039312E3130312D2E3038392E3130342D2E3038382E3130342D2E3038362E3130362D2E3038362E3130362D2E3038332E3130362D2E3038322E3130392D2E3038322E3130382D2E3037392E31312D2E3037382E31312D2E';
wwv_flow_imp.g_varchar2_table(49771) := '3037362E3131322D2E3037362E3131322D2E3037342E3131332D2E3037322E3131332D2E3037312E3131352D2E30372E3131352D2E3036382E3131382D2E3036372E3131372D2E3036352E31322D2E3036352E3035342D2E3032392E3133352D2E303838';
wwv_flow_imp.g_varchar2_table(49772) := '2E3131362D2E3131312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E3030392D2E3136312D2E30322D2E31362D2E30352D2E3135332D2E3037382D2E3134322D2E3130322D2E3132352D2E3132332D2E3130332D2E3134312D2E3037';
wwv_flow_imp.g_varchar2_table(49773) := '392D2E3135332D2E3035312D2E31362D2E3032322D2E31362E3030387A6D31332E393120322E3131366C2D2E3135382E3033372D2E3134372E3036362D2E3133322E3039322D2E3131332E3131362D2E30392E3133342D2E3036332E3134382D2E303334';
wwv_flow_imp.g_varchar2_table(49774) := '2E3135372D2E3030352E3136322E3032362E3135392E3035342E3135322E3038322E3133392E3038362E3130322E30392E30392E3039342E3039382E3039332E3039392E3039322E312E3039312E3130332E3038392E3130312E3038382E3130342E3038';
wwv_flow_imp.g_varchar2_table(49775) := '362E3130342E3038362E3130362E3038332E3130352E3038332E3130382E30382E3130382E3038312E31312E3037372E3130372E3037372E3131322E3037352E3131312E3037352E3131342E3037322E3131332E3037312E3131332E30372E3131352E30';
wwv_flow_imp.g_varchar2_table(49776) := '36382E3131372E3036372E3131352E3036352E3131382E3036342E3131372E3036322E3131382E3036312E31322E3035392E3131392E3035392E3132322E3035362E3132312E3035342E31322E3035352E3132352E3035312E3132332E3035312E313235';
wwv_flow_imp.g_varchar2_table(49777) := '2E3034382E3132332E3034392E3132372E3034362E3132362E3034342E3132352E3034332E3132382E3034322E3132392E3033392E3132362E3033382E31332E3032322E3037362E3035382E31352E3038362E3133372E3130392E3131392E3132392E30';
wwv_flow_imp.g_varchar2_table(49778) := '39362E3134352E30372E3135352E3034332E31362E3031332E3136312D2E3031372E3135352D2E3034362E3134332D2E3037342E3132362D2E312E3130362D2E3132322E3038322D2E3133382E3035352D2E3135322E3032352D2E31362D2E3030352D2E';
wwv_flow_imp.g_varchar2_table(49779) := '31362D2E3032362D2E3133322D2E3032332D2E3038322D2E3030322D2E3030352D2E3030312D2E3030352D2E3034322D2E3133392D2E3030312D2E3030352D2E3030322D2E3030352D2E3034332D2E3133382D2E3030312D2E3030352D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49780) := '30352D2E3034342D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E3034362D2E3133372D2E3030322D2E3030352D2E3030312D2E3030352D2E3034382D2E3133372D2E3030322D2E3030352D2E3030322D2E3030352D2E30352D2E3133';
wwv_flow_imp.g_varchar2_table(49781) := '352D2E3030312D2E3030352D2E3030322D2E3030352D2E3035312D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035332D2E3133352D2E3030322D2E3030352D2E3030322D2E3030352D2E3035342D2E3133332D2E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49782) := '352D2E3030322D2E3030352D2E3035372D2E3133332D2E3030322D2E3030352D2E3030322D2E3030352D2E3035372D2E3133322D2E3030332D2E3030352D2E3030322D2E3030352D2E3035392D2E3133322D2E3030322D2E3030352D2E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49783) := '342D2E3036312D2E3133322D2E3030332D2E3030342D2E3030322D2E3030352D2E3036322D2E31332D2E3030332D2E3030352D2E3030322D2E3030352D2E3036342D2E31332D2E3030332D2E3030342D2E3030322D2E3030352D2E3036362D2E3132392D';
wwv_flow_imp.g_varchar2_table(49784) := '2E3030322D2E3030342D2E3030332D2E3030352D2E3036372D2E3132382D2E3030322D2E3030352D2E3030332D2E3030342D2E3036392D2E3132382D2E3030322D2E3030342D2E3030332D2E3030352D2E30372D2E3132362D2E3030332D2E3030352D2E';
wwv_flow_imp.g_varchar2_table(49785) := '3030332D2E3030342D2E3037322D2E3132362D2E3030322D2E3030352D2E3030332D2E3030342D2E3037332D2E3132352D2E3030332D2E3030342D2E3030332D2E3030352D2E3037352D2E3132342D2E3030332D2E3030342D2E3030332D2E3030352D2E';
wwv_flow_imp.g_varchar2_table(49786) := '3037362D2E3132332D2E3030332D2E3030342D2E3030332D2E3030352D2E3037382D2E3132322D2E3030332D2E3030342D2E3030332D2E3030352D2E30382D2E3132312D2E3030332D2E3030342D2E3030332D2E3030352D2E30382D2E31322D2E303034';
wwv_flow_imp.g_varchar2_table(49787) := '2D2E3030352D2E3030332D2E3030342D2E3038332D2E31322D2E3030332D2E3030342D2E3030332D2E3030342D2E3038342D2E3131382D2E3030332D2E3030352D2E3030332D2E3030342D2E3038362D2E3131372D2E3030332D2E3030352D2E3030332D';
wwv_flow_imp.g_varchar2_table(49788) := '2E3030342D2E3038382D2E3131372D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E3131362D2E3030322D2E3030342D2E3030342D2E3030342D2E30392D2E3131342D2E3030332D2E3030352D2E3030342D2E3030342D2E3039312D2E31';
wwv_flow_imp.g_varchar2_table(49789) := '31332D2E3030342D2E3030342D2E3030332D2E3030342D2E3039332D2E3131332D2E3030342D2E3030342D2E3030332D2E3030342D2E3039352D2E3131312D2E3030342D2E3030342D2E3030332D2E3030342D2E3039362D2E31312D2E3030342D2E3030';
wwv_flow_imp.g_varchar2_table(49790) := '352D2E3030332D2E3030342D2E3039382D2E3130392D2E3030342D2E3030342D2E3030332D2E3030342D2E312D2E3130382D2E3030332D2E3030342D2E3030342D2E3030342D2E312D2E3130372D2E3030342D2E3030342D2E3030342D2E3030342D2E31';
wwv_flow_imp.g_varchar2_table(49791) := '30322D2E3130362D2E3030332D2E3030332D2E3030342D2E3030342D2E3039332D2E3039352D2E3132342D2E3130332D2E31342D2E30382D2E3135332D2E30352D2E31362D2E3032332D2E31362E3030387A4D342E3238382031322E3832386C2D2E3135';
wwv_flow_imp.g_varchar2_table(49792) := '382E3033322D2E31352E30362D2E3133352E3038382D2E3131372E31312D2E3039352E3133312D2E3036392E3134362D2E3033352E3132392D2E3032362E313332762E3030356C2D2E3030322E3030352D2E3032352E3134332D2E3030312E3030352D2E';
wwv_flow_imp.g_varchar2_table(49793) := '3030312E3030362D2E3032342E3134332D2E3030312E3030352D2E3030312E3030362D2E3032322E3134332D2E3030312E3030362D2E3030312E3030352D2E30322E3134342D2E3030312E3030352D2E3030312E3030362D2E3031392E313434762E3030';
wwv_flow_imp.g_varchar2_table(49794) := '356C2D2E3030312E3030362D2E3031372E313434762E3030366C2D2E3030312E3030352D2E3031362E313435762E3031316C2D2E3031342E313435762E3030366C2D2E3030312E3030352D2E3031322E313436762E30316C2D2E30312E3134362D2E3030';
wwv_flow_imp.g_varchar2_table(49795) := '312E303036762E3030356C2D2E3030392E313436762E3031316C2D2E3030372E313436762E3031316C2D2E3030342E313437762E3031316C2D2E3030332E313437762E30316C2D2E3030322E313438762E30316C2E3030312E313438762E30316C2E3030';
wwv_flow_imp.g_varchar2_table(49796) := '332E313437762E3031316C2E3030352E313437762E30316C2E3030372E313437762E3031316C2E3030392E313436762E3031316C2E30312E313436762E30316C2E3031332E313436762E3031316C2E3031342E313435762E3030356C2E3030312E303036';
wwv_flow_imp.g_varchar2_table(49797) := '2E3031362E313435762E3031316C2E3031382E313434762E3030366C2E3030312E3030352E3031392E313434762E3030366C2E3030312E3030352E3032312E313434762E3030356C2E3030322E3030362E3032322E313433762E3030366C2E3030322E30';
wwv_flow_imp.g_varchar2_table(49798) := '30352E3032342E313433762E3030356C2E3030322E3030362E3032352E3134332E3030312E3030352E3030312E3030352E3032382E3134332E3030312E3030352E3030312E3030352E30332E313432762E3030356C2E3030322E3030362E30332E313431';
wwv_flow_imp.g_varchar2_table(49799) := '2E3030322E3030352E3030312E3030362E3033332E3134762E3030366C2E3030322E3030352E3033352E3134762E3030366C2E3030322E3030352E3033362E31342E3030322E3030352E3030312E3030352E3033382E31342E3030312E3030352E303032';
wwv_flow_imp.g_varchar2_table(49800) := '2E3030352E30342E3134762E3030356C2E3030322E3030352E3034322E3133382E3030312E3030362E3030322E3030352E3034322E3133382E3030322E3030352E3030322E3030352E3031372E3035342E3036342E3134382E30392E3133342E3131342E';
wwv_flow_imp.g_varchar2_table(49801) := '3131342E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030372E31362D2E3032332E3135332D2E3035322E31342D2E30382E3132332D2E3130332E3130322D2E3132362E3037362D2E3134322E3034392D2E3135332E30322D2E31';
wwv_flow_imp.g_varchar2_table(49802) := '362D2E30312D2E3136312D2E3033322D2E31332D2E3031372D2E3035312D2E3033392D2E3132362D2E3033382D2E31332D2E3033372D2E3132382D2E3033352D2E31332D2E3033332D2E3132382D2E3033332D2E3133342D2E30332D2E31332D2E303239';
wwv_flow_imp.g_varchar2_table(49803) := '2D2E3133312D2E3032362D2E31332D2E3032362D2E3133322D2E3032342D2E3133342D2E3032332D2E3133332D2E30322D2E3133322D2E30322D2E3133362D2E3031372D2E3133322D2E3031362D2E3133352D2E3031342D2E3133352D2E3031322D2E31';
wwv_flow_imp.g_varchar2_table(49804) := '33332D2E3031322D2E3133382D2E3030392D2E3133332D2E3030372D2E3133362D2E3030362D2E3133382D2E3030342D2E3133342D2E3030332D2E313336762D2E3237346C2E3030332D2E3133362E3030342D2E3133342E3030362D2E3133392E303037';
wwv_flow_imp.g_varchar2_table(49805) := '2D2E3133362E30312D2E3133322E30312D2E3133392E3031332D2E3133322E3031342D2E3133352E3031362D2E3133352E3031372D2E3133322E30322D2E3133372E30322D2E31332E3032332D2E3133342E3032342D2E3133332E3032342D2E3132362E';
wwv_flow_imp.g_varchar2_table(49806) := '3031362D2E31362D2E3031342D2E3136312D2E3034342D2E3135352D2E3037322D2E3134352D2E3039382D2E3132382D2E31322D2E3130382D2E3133372D2E3038342D2E31352D2E3035372D2E31362D2E3032392D2E31362E3030327A6D32332E323836';
wwv_flow_imp.g_varchar2_table(49807) := '20342E3230326C2D2E3135362E3033382D2E3134382E3036362D2E3133322E3039322D2E3131332E3131352D2E30392E3133342D2E3036322E3134382D2E30332E3132372D2E3030312E3030342D2E3032332E3133342D2E3032342E3133342D2E303236';
wwv_flow_imp.g_varchar2_table(49808) := '2E3133322D2E3032362E31332D2E30332E3133322D2E30332E3132392D2E3033322E3133342D2E3033332E3132382D2E3033352E31332D2E3033372E3132382D2E3033382E31332D2E30342E3132362D2E30342E3132382D2E3034342E3132382D2E3034';
wwv_flow_imp.g_varchar2_table(49809) := '342E3132362D2E3034362E3132362D2E3034382E3132362D2E30352E3132352D2E30352E3132352D2E3035312E3132322D2E3035342E3132332D2E3035352E3132322D2E3035362E31322D2E3035382E3132322D2E30362E31322D2E3036312E31322D2E';
wwv_flow_imp.g_varchar2_table(49810) := '3036322E3131392D2E3036332E3131362D2E3036372E3131392D2E3036362E3131362D2E3036382E3131352D2E30372E3131352D2E30372E3131332D2E3037332E3131332D2E3037342E3131322D2E3037362E3131332D2E3037372E3131322D2E303737';
wwv_flow_imp.g_varchar2_table(49811) := '2E3130372D2E30382E31312D2E30382E3130382D2E3038352E3130392D2E3034342E3035362D2E3038382E3133352D2E30362E31352D2E3033332E3135382D2E3030322E31362E3032372E31362E3035372E31352E3038332E3133382E3130382E31322E';
wwv_flow_imp.g_varchar2_table(49812) := '3132382E3039382E3134342E3037322E3135352E3034352E31362E3031352E3136312D2E3031362E3135352D2E3034342E3134342D2E3037332E3132382D2E3039382E30392D2E3039392E30352D2E3036312E3030332D2E3030342E3030332D2E303035';
wwv_flow_imp.g_varchar2_table(49813) := '2E3038392D2E3131352E3030332D2E3030342E3030332D2E3030352E3038382D2E3131362E3030332D2E3030342E3030332D2E3030352E3038362D2E3131372E3030332D2E3030342E3030332D2E3030352E3038342D2E3131382E3030332D2E3030342E';
wwv_flow_imp.g_varchar2_table(49814) := '3030332D2E3030352E3038332D2E31322E3030332D2E3030342E3030332D2E3030342E3038322D2E31322E3030332D2E3030352E3030322D2E3030342E30382D2E3132312E3030332D2E3030352E3030332D2E3030342E3037382D2E3132322E3030332D';
wwv_flow_imp.g_varchar2_table(49815) := '2E3030352E3030332D2E3030342E3037372D2E3132332E3030322D2E3030352E3030332D2E3030342E3037352D2E3132342E3030332D2E3030352E3030332D2E3030342E3037332D2E3132352E3030332D2E3030342E3030332D2E3030352E3037322D2E';
wwv_flow_imp.g_varchar2_table(49816) := '3132362E3030322D2E3030342E3030332D2E3030352E30372D2E3132362E3030332D2E3030352E3030322D2E3030352E30372D2E3132372E3030322D2E3030342E3030322D2E3030352E3036382D2E3132382E3030322D2E3030352E3030322D2E303034';
wwv_flow_imp.g_varchar2_table(49817) := '2E3036362D2E31332E3030332D2E3030342E3030322D2E3030352E3036342D2E31332E3030322D2E3030342E3030332D2E3030352E3036322D2E31332E3030332D2E3030352E3030322D2E3030352E30362D2E31332E3030332D2E3030352E3030322D2E';
wwv_flow_imp.g_varchar2_table(49818) := '3030352E30362D2E3133322E3030322D2E3030352E3030322D2E3030352E3035372D2E3133322E3030332D2E3030352E3030322D2E3030352E3035362D2E3133332E3030322D2E3030352E3030322D2E3030352E3035342D2E3133342E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(49819) := '342E3030322D2E3030352E3035332D2E3133352E3030322D2E3030352E3030322D2E3030352E3035312D2E3133352E3030322D2E3030352E3030322D2E3030352E30352D2E3133352E3030312D2E3030352E3030322D2E3030352E3034382D2E3133372E';
wwv_flow_imp.g_varchar2_table(49820) := '3030312D2E3030352E3030322D2E3030352E3034362D2E3133372E3030322D2E3030352E3030322D2E3030352E3034342D2E3133372E3030322D2E3030352E3030322D2E3030352E3034322D2E3133382E3030322D2E3030352E3030322D2E3030362E30';
wwv_flow_imp.g_varchar2_table(49821) := '342D2E3133382E3030322D2E3030352E3030322D2E3030352E30342D2E31345631392E346C2E3030322D2E3030352E3033382D2E31342E3030312D2E3030352E3030322D2E3030352E3033362D2E31342E3030312D2E3030352E3030312D2E3030352E30';
wwv_flow_imp.g_varchar2_table(49822) := '33352D2E3134312E3030312D2E3030352E3030312D2E3030352E3033332D2E3134312E3030312D2E3030362E3030312D2E3030352E3033312D2E3134312E3030322D2E303036762D2E3030356C2E30332D2E3134322E3030312D2E3030352E3030312D2E';
wwv_flow_imp.g_varchar2_table(49823) := '3030352E3032382D2E313433762D2E3030356C2E3030322D2E3030352E3032352D2E3134332E3030312D2E3030362E3030312D2E3030352E3032342D2E3134332E3030312D2E3030352E3030312D2E3030362E3030312D2E3030362E30312D2E3136312D';
wwv_flow_imp.g_varchar2_table(49824) := '2E30322D2E31362D2E30352D2E3135342D2E3037372D2E3134312D2E3130322D2E3132352D2E3132332D2E3130342D2E3134312D2E3037392D2E3135332D2E3035312D2E31362D2E3032322D2E31362E3030377A4D362E3638312032322E3733346C2D2E';
wwv_flow_imp.g_varchar2_table(49825) := '3135322E3035332D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E3134322D2E3034382E3135342D2E3031382E31362E3031312E3136312E3034312E3135362E30372E3134362E3037372E31312E30342E3034372E3030332E';
wwv_flow_imp.g_varchar2_table(49826) := '3030342E3030332E3030342E3039352E3131312E3030332E3030342E3030342E3030342E3039362E31312E3030342E3030352E3030332E3030342E3039382E3130392E3030332E3030342E3030342E3030342E312E3130382E3030332E3030342E303033';
wwv_flow_imp.g_varchar2_table(49827) := '2E3030342E3130312E3130372E3030342E3030342E3030332E3030342E3130322E3130362E3030342E3030332E3030342E3030342E3130332E3130352E3030342E3030342E3030342E3030342E3130352E3130332E3030342E3030342E3030332E303033';
wwv_flow_imp.g_varchar2_table(49828) := '2E3130362E3130322E3030342E3030342E3030342E3030342E3130372E312E3030342E3030342E3030342E3030342E3130382E3039392E3030342E3030332E3030342E3030342E31312E3039382E3030332E3030332E3030342E3030342E31312E303936';
wwv_flow_imp.g_varchar2_table(49829) := '2E3030352E3030342E3030342E3030332E31312E3039352E3030352E3030332E3030342E3030342E3131332E3039332E3030342E3030332E3030342E3030342E3131332E3039312E3030342E3030342E3030352E3030332E3131342E30392E3030342E30';
wwv_flow_imp.g_varchar2_table(49830) := '30342E3030342E3030332E3131362E3038392E3030342E3030332E3030342E3030332E3131372E3038382E3030342E3030332E3030342E3030332E3131382E3038362E3030342E3030332E3030352E3030332E3131382E3038342E3030342E3030332E30';
wwv_flow_imp.g_varchar2_table(49831) := '30352E3030332E3131392E3038332E3030342E3030332E3030352E3030332E31322E3038312E3030352E3030332E3030342E3030332E3132312E30382E3030352E3030332E3030342E3030332E3132322E3037382E3030352E3030332E3030342E303033';
wwv_flow_imp.g_varchar2_table(49832) := '2E3132332E3037362E3030352E3030332E3030342E3030332E3132342E3037352E3030352E3030332E3030342E3030332E3132352E3037332E3030342E3030332E3030352E3030332E3132362E3037322E3030342E3030322E3030352E3030332E313236';
wwv_flow_imp.g_varchar2_table(49833) := '2E30372E3030352E3030332E3030342E3030322E3132382E30372E3030342E3030322E3030352E3030322E3132382E3036382E3030352E3030322E3030342E3030322E31332E3036362E3030342E3030332E3030352E3030322E31332E3036342E303034';
wwv_flow_imp.g_varchar2_table(49834) := '2E3030322E3030352E3030332E31332E3036322E3030352E3030322E3030342E3030332E3133322E30362E3030342E3030332E3030352E3030322E3133322E30362E3030352E3030322E3030352E3030322E3133322E3035372E3030352E3030322E3030';
wwv_flow_imp.g_varchar2_table(49835) := '352E3030332E3133332E3035362E3030352E3030322E3030352E3030322E3133332E3035342E3030352E3030322E3030352E3030322E31332E30352E3135342E3034352E31362E3031362E3136312D2E3031352E3135352D2E3034352E3134342D2E3037';
wwv_flow_imp.g_varchar2_table(49836) := '322E3132382D2E3039382E3130382D2E31322E3038332D2E3133382E3035372D2E31352E3032382D2E31362D2E3030332D2E31362D2E3033322D2E3135382D2E3036312D2E31352D2E3038382D2E3133352D2E31312D2E3131372D2E3133322D2E303934';
wwv_flow_imp.g_varchar2_table(49837) := '2D2E31322D2E3035382D2E3132342D2E3034392D2E3132362D2E3035312D2E3132322D2E3035312D2E3132322D2E3035342D2E31322D2E3035342D2E3132362D2E3035382D2E3131392D2E3035372D2E31322D2E30362D2E31322D2E30362D2E3131382D';
wwv_flow_imp.g_varchar2_table(49838) := '2E3036332D2E3131372D2E3036342D2E3131392D2E3036362D2E3131362D2E3036362D2E3131352D2E3036382D2E3131352D2E30372D2E3131332D2E30372D2E3131352D2E3037342D2E3131322D2E3037342D2E31312D2E3037352D2E31312D2E303736';
wwv_flow_imp.g_varchar2_table(49839) := '2D2E3131322D2E3037392D2E31312D2E30382D2E3130392D2E3038322D2E3130362D2E3038322D2E3130342D2E3038322D2E3130362D2E3038362D2E3130352D2E3038372D2E3130312D2E3038362D2E3130352D2E3039312D2E312D2E30392D2E312D2E';
wwv_flow_imp.g_varchar2_table(49840) := '3039312D2E312D2E3039342D2E3039372D2E3039342D2E312D2E3039382D2E3039332D2E3039352D2E3039362D2E312D2E3039332D2E3039382D2E3039322D2E3130312D2E3038392D2E312D2E30392D2E3130322D2E3038382D2E3130342D2E3033362D';
wwv_flow_imp.g_varchar2_table(49841) := '2E3034332D2E3131342D2E3131342D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E3033362D2E3136312D2E3030362D2E31362E3032347A6D31352E30363320322E3639316C2D2E3135362E3034342D2E31322E3035372D2E30362E30';
wwv_flow_imp.g_varchar2_table(49842) := '33342D2E31322E3036362D2E3131362E3036342D2E3131392E3036322D2E31322E3036312D2E31322E30362D2E3131382E3035372D2E3132362E3035382D2E31322E3035342D2E3132322E3035342D2E3132322E30352D2E3132362E3035322D2E313235';
wwv_flow_imp.g_varchar2_table(49843) := '2E30352D2E3132342E3034362D2E3132372E3034372D2E3132352E3034342D2E3132392E3034332D2E3132362E30342D2E31332E3034322D2E3132382E3033382D2E3132372E3033362D2E31332E3033352D2E3133312E3033342D2E3132392E3033312D';
wwv_flow_imp.g_varchar2_table(49844) := '2E3133322E30332D2E31332E30332D2E3133352E3032372D2E3133332E3032362D2E31332E3032332D2E31332E3032322D2E3133372E3032312D2E3133322E30322D2E3133342E3031372D2E3133322E3031352D2E3133382E3031352D2E3133352E3031';
wwv_flow_imp.g_varchar2_table(49845) := '332D2E3133332E30312D2E3133382E30312D2E3133362E3030372D2E3133342E3030362D2E3133362E3030342D2E31342E3030332D2E31362E3031382D2E3135352E3034372D2E3134322E3037362D2E3132372E312D2E3130352E3132322D2E30382E31';
wwv_flow_imp.g_varchar2_table(49846) := '342D2E3035342E3135312D2E3032352E31362E3030362E31362E3033352E3135382E3036342E3134382E30392E3133342E3131342E3131342E3133332E3039322E3134372E3036352E3135372E3033362E3133342E3030382E3134352D2E303032682E30';
wwv_flow_imp.g_varchar2_table(49847) := '31316C2E3134372D2E303035682E30316C2E3134372D2E303037682E3031316C2E3134362D2E303039682E3031316C2E3134362D2E3031682E3030356C2E3030352D2E3030312E3134362D2E303132682E3031316C2E3134352D2E303134682E3030356C';
wwv_flow_imp.g_varchar2_table(49848) := '2E3030362D2E3030312E3134352D2E303136682E3031316C2E3134342D2E303138682E3030366C2E3030352D2E3030312E3134342D2E3032682E3031316C2E3134342D2E303231682E3030356C2E3030362D2E3030322E3134332D2E303232682E303036';
wwv_flow_imp.g_varchar2_table(49849) := '6C2E3030352D2E3030322E3134332D2E303234682E3030356C2E3030362D2E3030322E3134332D2E303236682E3030356C2E3030352D2E3030322E3134332D2E3032372E3030352D2E3030312E3030352D2E3030312E3134322D2E3033682E3030356C2E';
wwv_flow_imp.g_varchar2_table(49850) := '3030352D2E3030322E3134322D2E30332E3030352D2E3030322E3030352D2E3030312E3134322D2E3033332E3030352D2E3030312E3030352D2E3030312E31342D2E3033352E3030362D2E3030312E3030352D2E3030312E31342D2E3033362E3030352D';
wwv_flow_imp.g_varchar2_table(49851) := '2E3030322E3030352D2E3030312E31342D2E3033382E3030352D2E3030312E3030352D2E3030322E31342D2E3034682E3030356C2E3030352D2E3030322E3133382D2E3034322E3030352D2E3030312E3030362D2E3030322E3133382D2E3034332E3030';
wwv_flow_imp.g_varchar2_table(49852) := '352D2E3030312E3030352D2E3030322E3133372D2E3034342E3030352D2E3030322E3030352D2E3030322E3133372D2E3034362E3030352D2E3030322E3030352D2E3030312E3133372D2E3034382E3030352D2E3030322E3030352D2E3030322E313335';
wwv_flow_imp.g_varchar2_table(49853) := '2D2E30352E3030352D2E3030312E3030352D2E3030322E3133352D2E3035312E3030352D2E3030322E3030352D2E3030322E3133352D2E3035332E3030352D2E3030322E3030342D2E3030322E3133342D2E3035342E3030352D2E3030322E3030352D2E';
wwv_flow_imp.g_varchar2_table(49854) := '3030322E3133332D2E3035362E3030352D2E3030332E3030352D2E3030322E3133322D2E3035372E3030352D2E3030322E3030352D2E3030332E3133322D2E3035392E3030352D2E3030322E3030342D2E3030322E3133312D2E3036312E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49855) := '30332E3030352D2E3030322E31332D2E3036322E3030352D2E3030332E3030352D2E3030322E31332D2E3036342E3030342D2E3030322E3030352D2E3030332E3132392D2E3036362E3030342D2E3030322E3030352D2E3030332E3132382D2E3036372E';
wwv_flow_imp.g_varchar2_table(49856) := '3030352D2E3030322E3030342D2E3030332E3132372D2E3036392E3030352D2E3030322E3030352D2E3030332E3132362D2E30372E3030352D2E3030332E3030342D2E3030322E3036352D2E3033382E3133322D2E3039332E3131322D2E3131352E3038';
wwv_flow_imp.g_varchar2_table(49857) := '392D2E3133352E3036322D2E3134392E3033342D2E3135372E3030342D2E3136312D2E3032372D2E31362D2E3035352D2E31352D2E3038322D2E31342D2E3130372D2E31322D2E3132372D2E312D2E3134342D2E3037332D2E3135342D2E3034352D2E31';
wwv_flow_imp.g_varchar2_table(49858) := '362D2E3031372D2E3136312E3031347A4D31352E39393420306C2D2E3138372E303031682D2E3031316C2D2E3138382E303034682D2E3031316C2D2E3138372E303036682D2E3031316C2D2E3138372E303038682D2E3030354C31352E322E30326C2D2E';
wwv_flow_imp.g_varchar2_table(49859) := '3138372E3031682D2E3030356C2D2E3030352E3030312D2E3138372E303133682D2E30314C31342E36322E3036682D2E30316C2D2E3138362E303138682D2E3031316C2D2E3138352E30322D2E3030352E303031682D2E3030366C2D2E3138352E303232';
wwv_flow_imp.g_varchar2_table(49860) := '2D2E3030352E303031682D2E3030356C2D2E3138352E303235682D2E3030356C2D2E3030352E3030312D2E3138342E303237682D2E3030366C2D2E3030352E3030312D2E3138342E303239682D2E3030356C2D2E3030352E3030312D2E3138332E303331';
wwv_flow_imp.g_varchar2_table(49861) := '2D2E3030352E3030312D2E3030362E3030312D2E3138322E3033332D2E3030362E3030312D2E3030352E3030312D2E3138322E3033352D2E3030352E3030312D2E3030352E3030312D2E3138322E303338682D2E3030356C2D2E3030352E3030322D2E31';
wwv_flow_imp.g_varchar2_table(49862) := '38312E3034682D2E3030356C2D2E3030352E3030322D2E31382E3034322D2E3030362E3030312D2E3030352E3030312D2E31382E3034342D2E3030352E303032682D2E3030356C2D2E31372E3034352D2E3135322E3035342D2E3133392E3038322D2E31';
wwv_flow_imp.g_varchar2_table(49863) := '32312E3130362D2E312E3132372D2E3037342E3134332D2E3034362E3135352D2E3031372E31362E3031332E31362E3034332E3135362E30372E3134352E3039372E31332E3131392E3130382E3133372E3038352E31352E3035382E3135392E30332E31';
wwv_flow_imp.g_varchar2_table(49864) := '362D2E3030312E3133332D2E3032332E3136352D2E3034332E3136382D2E3034312E3137312D2E30342E3137312D2E3033372E3137322D2E3033362E31372D2E3033332E3137332D2E30332E31372D2E30332E3137372D2E3032372E3137312D2E303235';
wwv_flow_imp.g_varchar2_table(49865) := '2E3137352D2E3032322E3137352D2E30322E3137352D2E30322E3137362D2E3031362E3137352D2E3031342E3137372D2E3031322E3137362D2E30312E3137372D2E3030372E3137342D2E3030362E3137372D2E3030334C313620312E3733682E313737';
wwv_flow_imp.g_varchar2_table(49866) := '6C2E3137382E3030342E3137342E3030362E3137372E3030372E3137362E30312E3137372E3031322E3137352E3031342E3137362E3031372E3137352E3031382E3137352E30322E3137352E3032332E3137312E3032352E3137372E3032372E31372E30';
wwv_flow_imp.g_varchar2_table(49867) := '332E3137332E30332E31372E3033332E3137312E3033362E3135342E3033332E31362E30322E3136312D2E30312E3135362D2E30342E3134362D2E3036392E3133312D2E3039342E3131312D2E3131372E3038382D2E3133352E30362D2E31352E303332';
wwv_flow_imp.g_varchar2_table(49868) := '2D2E3135382E3030322D2E31362D2E3032372D2E31362D2E3035372D2E31354C3230202E3731346C2D2E3130382D2E31322D2E3132382D2E3039372D2E3134342D2E3037332D2E3132392D2E3033382D2E3135382D2E3033352D2E3030352D2E3030312D';
wwv_flow_imp.g_varchar2_table(49869) := '2E3030352D2E3030314C31392E31342E3331682D2E3030356C2D2E3030352D2E3030322D2E3138322D2E303335682D2E3030366C2D2E3030352D2E3030322D2E3138322D2E303333682D2E3030366C2D2E3030352D2E3030322D2E3138332D2E30332D2E';
wwv_flow_imp.g_varchar2_table(49870) := '3030352D2E3030312D2E3030352D2E3030312D2E3138342D2E303239682D2E3030356C2D2E3030362D2E3030312D2E3138342D2E303237682D2E3030356C2D2E3030352D2E3030312D2E3138352D2E303234682D2E3030354C31372E3936382E31322031';
wwv_flow_imp.g_varchar2_table(49871) := '372E3738332E316C2D2E3030362D2E303031682D2E3030356C2D2E3138352D2E3032682D2E3030366C2D2E3030352D2E3030314C31372E33392E30362031372E3338352E3036682D2E3030356C2D2E3138372D2E303135682D2E3030356C2D2E3030352D';
wwv_flow_imp.g_varchar2_table(49872) := '2E3030312D2E3138372D2E303133682D2E30314C31362E3739392E3032682D2E3031314C31362E362E3031682D2E3031316C2D2E3138372D2E303036682D2E3031314C31362E3230342030682D2E3031314C31362E3030352030682D2E30317A6D382E38';
wwv_flow_imp.g_varchar2_table(49873) := '3620322E3933396C2D2E3135372E3033332D2E31352E3036322D2E3133342E30392D2E3131362E3131312D2E3039332E3133322D2E3036372E3134372D2E3033382E3135362D2E30312E3136312E3032322E31362E30352E3135332E3037382E3134312E';
wwv_flow_imp.g_varchar2_table(49874) := '3130332E3132342E3130322E3038372E3034352E3033342E3134322E3130362E3133372E3130352E31342E31312E3133362E31312E3133352E3131322E3133342E3131352E3133342E3131372E31332E3131352E3133322E3132322E3132382E31322E31';
wwv_flow_imp.g_varchar2_table(49875) := '32372E3132322E3132372E3132352E3132332E3132362E3132342E3132382E3132312E31332E3131382E3132382E3131382E3133322E3131372E3133332E3131332E3133342E3131332E3133362E31312E3133362E3130392E3133372E3130392E313432';
wwv_flow_imp.g_varchar2_table(49876) := '2E3130342E31342E3130332E31342E3130312E3134322E312E3134342E3039392E3134362E3039352E3134352E3039342E3134372E3039332E31352E3039322E31352E3038372E3134392E3038372E31352E3038352E3135322E3038332E3135352E3038';
wwv_flow_imp.g_varchar2_table(49877) := '2E3135322E30382E3135352E30342E3038312E3038342E3133382E31312E3131392E3132382E3039362E3134352E3037322E3135352E3034332E31362E3031332E3136312D2E3031362E3135352D2E3034362E3134332D2E3037342E3132372D2E303939';
wwv_flow_imp.g_varchar2_table(49878) := '2E3130362D2E31322E3038332D2E31342E3035352D2E3135312E3032362D2E31362D2E3030342D2E31362D2E3033342D2E3135382D2E30352D2E3132342D2E3034322D2E3038352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038342D2E3136';
wwv_flow_imp.g_varchar2_table(49879) := '352D2E3030322D2E3030342D2E3030332D2E3030352D2E3038362D2E3136342D2E3030322D2E3030342D2E3030332D2E3030352D2E3038382D2E3136322D2E3030322D2E3030352D2E3030332D2E3030352D2E30392D2E3136312D2E3030322D2E303035';
wwv_flow_imp.g_varchar2_table(49880) := '2D2E3030332D2E3030342D2E3039322D2E31362D2E3030322D2E3030352D2E3030332D2E3030352D2E3039342D2E31362D2E3030332D2E3030342D2E3030332D2E3030342D2E3039362D2E3135392D2E3030322D2E3030342D2E3030332D2E3030352D2E';
wwv_flow_imp.g_varchar2_table(49881) := '3039382D2E3135372D2E3030332D2E3030342D2E3030332D2E3030352D2E312D2E3135362D2E3030332D2E3030342D2E3030322D2E3030352D2E3130322D2E3135342D2E3030332D2E3030352D2E3030332D2E3030342D2E3130342D2E3135342D2E3030';
wwv_flow_imp.g_varchar2_table(49882) := '332D2E3030342D2E3030332D2E3030352D2E3130362D2E3135322D2E3030332D2E3030342D2E3030332D2E3030352D2E3130382D2E3135312D2E3030332D2E3030342D2E3030332D2E3030352D2E31312D2E31352D2E3030332D2E3030342D2E3030332D';
wwv_flow_imp.g_varchar2_table(49883) := '2E3030342D2E3131312D2E31352D2E3030342D2E3030332D2E3030332D2E3030352D2E3131332D2E3134372D2E3030342D2E3030342D2E3030332D2E3030352D2E3131352D2E3134362D2E3030342D2E3030342D2E3030332D2E3030342D2E3131372D2E';
wwv_flow_imp.g_varchar2_table(49884) := '3134352D2E3030342D2E3030342D2E3030332D2E3030342D2E31322D2E3134342D2E3030332D2E3030342D2E3030332D2E3030342D2E3132312D2E3134322D2E3030332D2E3030342D2E3030342D2E3030342D2E3132332D2E3134312D2E3030332D2E30';
wwv_flow_imp.g_varchar2_table(49885) := '30342D2E3030342D2E3030342D2E3132352D2E31342D2E3030332D2E3030342D2E3030342D2E3030342D2E3132372D2E3133382D2E3030332D2E3030342D2E3030342D2E3030342D2E3132382D2E3133362D2E3030342D2E3030342D2E3030342D2E3030';
wwv_flow_imp.g_varchar2_table(49886) := '342D2E31332D2E3133352D2E3030342D2E3030342D2E3030332D2E3030342D2E3133332D2E3133342D2E3030332D2E3030342D2E3030342D2E3030332D2E3133342D2E3133332D2E3030342D2E3030332D2E3030342D2E3030342D2E3133352D2E31332D';
wwv_flow_imp.g_varchar2_table(49887) := '2E3030342D2E3030342D2E3030342D2E3030342D2E3133362D2E3132382D2E3030342D2E3030342D2E3030342D2E3030342D2E3133382D2E3132362D2E3030342D2E3030342D2E3030342D2E3030332D2E31342D2E3132352D2E3030342D2E3030342D2E';
wwv_flow_imp.g_varchar2_table(49888) := '3030342D2E3030332D2E31342D2E3132332D2E3030352D2E3030342D2E3030342D2E3030332D2E3134322D2E3132312D2E3030342D2E3030342D2E3030342D2E3030332D2E3134342D2E31322D2E3030342D2E3030332D2E3030342D2E3030332D2E3134';
wwv_flow_imp.g_varchar2_table(49889) := '352D2E3131372D2E3030342D2E3030342D2E3030342D2E3030332D2E3134372D2E3131352D2E3030342D2E3030342D2E3030342D2E3030332D2E3134382D2E3131332D2E3030342D2E3030332D2E3030342D2E3030342D2E3134392D2E3131312D2E3030';
wwv_flow_imp.g_varchar2_table(49890) := '342D2E3030332D2E3030342D2E3030342D2E30352D2E3033362D2E31342D2E3038332D2E31352D2E3035352D2E31362D2E3032372D2E31362E3030347A6D2D31382E3338312E3334386C2D2E3135372E3033372D2E3134372E3036362D2E3131312E3037';
wwv_flow_imp.g_varchar2_table(49891) := '342D2E30342E3033322D2E3030352E3030332D2E3030342E3030342D2E3134352E3131372D2E3030342E3030332D2E3030342E3030342D2E3134342E3131392D2E3030342E3030332D2E3030342E3030342D2E3134322E31322D2E3030342E3030342D2E';
wwv_flow_imp.g_varchar2_table(49892) := '3030342E3030342D2E3134312E3132332D2E3030342E3030332D2E3030342E3030342D2E31342E3132352D2E3030342E3030332D2E3030342E3030342D2E3133382E3132362D2E3030342E3030342D2E3030342E3030342D2E3133362E3132382D2E3030';
wwv_flow_imp.g_varchar2_table(49893) := '342E3030342D2E3030342E3030342D2E3133352E31332D2E3030342E3030342D2E3030342E3030332D2E3133342E3133332D2E3030342E3030332D2E3030342E3030342D2E3133322E3133342D2E3030332E3030342D2E3030342E3030342D2E31332E31';
wwv_flow_imp.g_varchar2_table(49894) := '33352D2E3030342E3030342D2E3030342E3030342D2E3132382E3133362D2E3030342E3030342D2E3030342E3030342D2E3132362E3133382D2E3030342E3030342D2E3030332E3030342D2E3132352E31342D2E3030342E3030342D2E3030332E303034';
wwv_flow_imp.g_varchar2_table(49895) := '2D2E3132332E31342D2E3030342E3030352D2E3030332E3030342D2E3132312E3134322D2E3030342E3030342D2E3030332E3030342D2E31322E3134342D2E3030332E3030342D2E3030332E3030342D2E3131372E3134352D2E3030342E3030342D2E30';
wwv_flow_imp.g_varchar2_table(49896) := '30332E3030342D2E3131352E3134362D2E3030342E3030352D2E3030332E3030342D2E3131332E3134372D2E3030332E3030352D2E3030342E3030342D2E3131312E3134392D2E3030332E3030342D2E3030342E3030342D2E31312E31352D2E3030322E';
wwv_flow_imp.g_varchar2_table(49897) := '3030352D2E3030332E3030342D2E3130382E3135312D2E3030332E3030352D2E3030332E3030342D2E3130362E3135322D2E3030332E3030352D2E3030332E3030342D2E3130342E3135342D2E3030332E3030342D2E3030332E3030352D2E3130322E31';
wwv_flow_imp.g_varchar2_table(49898) := '35342D2E3030332E3030352D2E3030322E3030342D2E312E3135362D2E3030332E3030352D2E3030332E3030342D2E3039382E3135372D2E3030332E3030352D2E3030332E3030342D2E3039362E3135392D2E3030322E3030342D2E3030332E3030352D';
wwv_flow_imp.g_varchar2_table(49899) := '2E3039342E31362D2E3030332E3030342D2E3030322E3030342D2E3039322E31362D2E3030332E3030352D2E3030332E3030352D2E30392E3136312D2E3030322E3030352D2E3030332E3030352D2E3038382E3136322D2E3030322E3030352D2E303033';
wwv_flow_imp.g_varchar2_table(49900) := '2E3030342D2E3038362E3136342D2E3030322E3030352D2E3030322E3030342D2E3038342E3136352D2E3030332E3030352D2E3030322E3030342D2E3038322E3136362D2E3030322E3030352D2E3030332E3030342D2E30382E3136372D2E3030322E30';
wwv_flow_imp.g_varchar2_table(49901) := '30342D2E3030322E3030352D2E3037382E3136382D2E3030322E3030342D2E3030322E3030352D2E3034352E312D2E3035332E3135332D2E3032332E31362E3030372E31362E3033372E3135372E3036352E3134382E3039322E3133322E3131342E3131';
wwv_flow_imp.g_varchar2_table(49902) := '342E3133342E30392E3134382E3036342E3135372E3033352E3136312E3030362E31362D2E3032352E3135322D2E3035342E31342D2E30382E3132312D2E3130362E312D2E3132362E3036352D2E3131382E3034332D2E3039352E3037342D2E31362E30';
wwv_flow_imp.g_varchar2_table(49903) := '37352D2E3135352E3037372D2E3135372E30382D2E3135352E30382D2E3135322E3038332D2E3135352E3038352D2E3135322E3038362D2E31352E3038382D2E3134392E3039312D2E31352E3039342D2E31352E3039342D2E3134372E3039352D2E3134';
wwv_flow_imp.g_varchar2_table(49904) := '352E3039392D2E3134362E312D2E3134342E312D2E3134322E3130342D2E31342E3130342D2E31342E31312D2E3134322E3130372D2E3133372E31312D2E3133362E3131342D2E3133362E3131332D2E3133342E3131372D2E3133332E3131382D2E3133';
wwv_flow_imp.g_varchar2_table(49905) := '322E3131372D2E3132392E3132322D2E31332E3132342D2E3132372E3132332D2E3132362E3132372D2E3132352E3132372D2E3132322E3132382D2E31322E3133322D2E3132322E31332D2E3131352E3133332D2E3131372E3133352D2E3131352E3133';
wwv_flow_imp.g_varchar2_table(49906) := '352D2E3131312E3133362D2E31312E3033372D2E30332E3131372D2E31312E3039342D2E3133322E3036382D2E3134362E30342D2E3135362E30312D2E3136312D2E30322D2E31362D2E30352D2E3135342D2E3037362D2E3134312D2E3130322D2E3132';
wwv_flow_imp.g_varchar2_table(49907) := '352D2E3132332D2E3130342D2E31342D2E30382D2E3135332D2E3035312D2E31362D2E3032332D2E3136312E3030387A6D32342E3531342031312E31356C2D2E3135372E30342D2E3134362E3036372D2E3133312E3039332D2E3131322E3131372D2E30';
wwv_flow_imp.g_varchar2_table(49908) := '38382E3133352D2E3036312E3134392D2E3033332E3135372D2E3030352E3133342E3030362E31342E3030362E3137362E3030332E3137372E3030312E3137382D2E3030312E3137372D2E3030332E3137382D2E3030362E3137372D2E3030372E313736';
wwv_flow_imp.g_varchar2_table(49909) := '2D2E30312E3137372D2E3031322E3137362D2E3031352E3137362D2E3031362E3137332D2E3031382E3137352D2E30322E3137352D2E3032342E3137342D2E3032342E3137352D2E3032372E31372D2E30332E3137342D2E30332E3137332D2E3033332E';
wwv_flow_imp.g_varchar2_table(49910) := '31372D2E3033362E3137322D2E3033372E31372D2E30342E31372D2E3034322E3137322D2E3034332E3136382D2E3034352E3136362D2E3034382E3136392D2E30352E3136372D2E3035322E3136382D2E3035332E3136342D2E3035362E3136362D2E30';
wwv_flow_imp.g_varchar2_table(49911) := '35382E3136362D2E30362E3136312D2E3036312E3136342D2E3036332E3135382D2E3036362E3136352D2E3036382E31362D2E30372E31362D2E30372E3135382D2E3037352E3135392D2E3037342E3135352D2E3037382E3135382D2E3038312E313538';
wwv_flow_imp.g_varchar2_table(49912) := '2D2E30362E31352D2E30332E3135382D2E3030312E3136312E3032392E3135392E3035382E31352E3038352E3133372E3130382E31322E31332E3039362E3134342E30372E3135362E3034342E31362E3031332E31362D2E3031372E3135352D2E303436';
wwv_flow_imp.g_varchar2_table(49913) := '2E3134332D2E3037342E3132372D2E312E3130372D2E31322E30372D2E3131352E3038332D2E3136342E3030332D2E3030352E3030322D2E3030342E3038322D2E3136362E3030322D2E3030352E3030332D2E3030342E30382D2E3136372E3030322D2E';
wwv_flow_imp.g_varchar2_table(49914) := '3030352E3030322D2E3030342E3037382D2E3136382E3030322D2E3030342E3030322D2E3030352E3037362D2E3136392E3030322D2E3030342E3030322D2E3030352E3037342D2E31372E3030322D2E3030342E3030322D2E3030352E3037322D2E3137';
wwv_flow_imp.g_varchar2_table(49915) := '2E3030322D2E3030352E3030322D2E3030352E30372D2E31372E3030322D2E3030362E3030312D2E3030352E3036382D2E3137322E3030322D2E3030342E3030322D2E3030352E3036352D2E3137332E3030322D2E3030352E3030322D2E3030352E3036';
wwv_flow_imp.g_varchar2_table(49916) := '332D2E3137332E3030322D2E3030352E3030322D2E3030352E30362D2E3137342E3030332D2E3030352E3030312D2E3030352E30362D2E3137352E3030312D2E3030352E3030322D2E3030352E3035372D2E3137362E3030312D2E3030352E3030322D2E';
wwv_flow_imp.g_varchar2_table(49917) := '3030352E3035352D2E3137372E3030312D2E3030352E3030322D2E3030352E3035322D2E3137372E3030322D2E3030352E3030312D2E3030352E3035312D2E3137382E3030312D2E3030352E3030322D2E3030352E3034382D2E3137392E3030322D2E30';
wwv_flow_imp.g_varchar2_table(49918) := '3035762D2E3030356C2E3034372D2E3137392E3030312D2E3030352E3030322D2E3030352E3034342D2E3138762D2E3030356C2E3030322D2E3030352E3034322D2E31382E3030312D2E3030362E3030312D2E3030352E30342D2E31382E3030312D2E30';
wwv_flow_imp.g_varchar2_table(49919) := '30362E3030312D2E3030352E3033382D2E313832762D2E3030356C2E3030322D2E3030352E3033352D2E313832762D2E3030366C2E3030322D2E3030352E3033332D2E313832762D2E3030366C2E3030322D2E3030352E30332D2E3138332E3030312D2E';
wwv_flow_imp.g_varchar2_table(49920) := '3030352E3030312D2E3030352E3032392D2E313834762D2E3030356C2E3030312D2E3030362E3032372D2E313834762D2E3030356C2E3030312D2E3030352E3032342D2E313835762D2E3030356C2E3030312D2E3030352E3032322D2E313835762D2E30';
wwv_flow_imp.g_varchar2_table(49921) := '30366C2E3030312D2E3030352E30322D2E313835762D2E3030366C2E3030312D2E3030352E3031372D2E313836762D2E3030356C2E3030312D2E3030352E3031352D2E313837762D2E3030356C2E3030312D2E3030352E3031332D2E313837762D2E3031';
wwv_flow_imp.g_varchar2_table(49922) := '6C2E30312D2E3138372E3030312D2E303036762D2E3030356C2E3030392D2E313837762D2E3031316C2E3030362D2E313837762D2E3031316C2E3030342D2E313838762D2E3031316C2E3030312D2E313838762D2E30316C2D2E3030312D2E313838762D';
wwv_flow_imp.g_varchar2_table(49923) := '2E3031316C2D2E3030342D2E313838762D2E3031316C2D2E3030362D2E313837762D2E3031316C2D2E3030372D2E3134352D2E3032322D2E31362D2E30352D2E3135322D2E30382D2E3134312D2E3130332D2E3132342D2E3132352D2E3130322D2E3134';
wwv_flow_imp.g_varchar2_table(49924) := '312D2E3037372D2E3135332D2E30352D2E31362D2E30322D2E3136312E3030397A4D2E3737372031356C2D2E3135382E3033322D2E31352E30362D2E3133362E3038372D2E3131372E31312D2E3039352E3133312D2E3036382E3134362D2E30342E3135';
wwv_flow_imp.g_varchar2_table(49925) := '362D2E3031322E3133332D2E3030312E3134762E30316C2E3030312E313838762E3031316C2E3030342E313838762E3031316C2E3030362E313837762E3031316C2E3030382E313837762E3031316C2E3031312E313837762E3030356C2E3030312E3030';
wwv_flow_imp.g_varchar2_table(49926) := '352E3031332E313837762E30316C2E3031362E313837762E30316C2E3031382E313836762E3031316C2E30322E3138352E3030312E303035762E3030366C2E3032322E3138352E3030312E303035762E3030356C2E3032352E313835762E3030356C2E30';
wwv_flow_imp.g_varchar2_table(49927) := '30312E3030352E3032372E313834762E3030366C2E3030312E3030352E3032392E313834762E3030356C2E3030312E3030352E3033312E3138332E3030312E3030352E3030312E3030362E3033332E3138322E3030312E3030352E3030312E3030362E30';
wwv_flow_imp.g_varchar2_table(49928) := '33352E3138322E3030312E3030352E3030312E3030352E3033382E313832762E3030356C2E3030322E3030352E30342E313831762E3030356C2E3030322E3030352E3034322E31382E3030312E3030362E3030312E3030352E3034342E31382E3030322E';
wwv_flow_imp.g_varchar2_table(49929) := '303035762E3030356C2E3034372E31382E3030312E3030342E3030322E3030352E3034382E3137392E3030322E3030352E3030312E3030352E30352E3137382E3030322E3030352E3030312E3030352E3035332E3137372E3030322E3030352E3030312E';
wwv_flow_imp.g_varchar2_table(49930) := '3030352E3035352E3137372E3030322E3030352E3030312E3030352E3035372E3137362E3030322E3030352E3030312E3030352E30362E3137352E3030312E3030352E3030322E3030352E3036312E3137342E3030322E3030352E3030322E3030352E30';
wwv_flow_imp.g_varchar2_table(49931) := '36332E3137332E3030322E3030352E3030322E3030352E3036352E3137332E3030322E3030352E3030322E3030342E3036372E3137322E3030322E3030352E3030322E3030352E30372E3137312E3030322E3030352E3030322E3030352E3037322E3137';
wwv_flow_imp.g_varchar2_table(49932) := '2E3030322E3030352E3030322E3030352E3037342E3136392E3030322E3030352E3030322E3030342E3037362E3136392E3030322E3030352E3030322E3030342E3037382E3136382E3030322E3030342E3030322E3030352E30382E3136372E3030332E';
wwv_flow_imp.g_varchar2_table(49933) := '3030342E3030322E3030352E3038322E3136362E3030322E3030342E3030332E3030352E30322E30342E3038362E3133362E31312E3131382E31332E3039352E3134362E30372E3135362E3034312E31362E3031322E31362D2E3031392E3135352D2E30';
wwv_flow_imp.g_varchar2_table(49934) := '34382E3134322D2E3037352E3132362D2E312E3130352D2E3132332E30382D2E31342E3035342D2E3135322E3032342D2E31362D2E3030362D2E31362D2E3033362D2E3135382D2E3035312D2E3132332D2E3031382D2E3033342D2E3037382D2E313538';
wwv_flow_imp.g_varchar2_table(49935) := '4C332E312032322E316C2D2E3037342D2E31362D2E3037312D2E3135362D2E30372D2E3136322D2E3036382D2E31362D2E3036372D2E3136342D2E3036322D2E3135382D2E3036322D2E3136342D2E3035392D2E3136312D2E3035382D2E3136362D2E30';
wwv_flow_imp.g_varchar2_table(49936) := '35362D2E3136362D2E3035332D2E3136342D2E3035322D2E3136382D2E30352D2E3136372D2E3034382D2E31372D2E3034352D2E3136352D2E3034332D2E3136382D2E3034332D2E3137322D2E3033392D2E31372D2E3033372D2E31372D2E3033362D2E';
wwv_flow_imp.g_varchar2_table(49937) := '3137322D2E3033332D2E31372D2E30332D2E3137332D2E30332D2E3137342D2E3032372D2E31372D2E3032352D2E3137352D2E3032322D2E3137342D2E3032312D2E3137352D2E3031382D2E3137352D2E3031372D2E3137332D2E3031342D2E3137362D';
wwv_flow_imp.g_varchar2_table(49938) := '2E3031322D2E3137362D2E30312D2E3137372D2E3030372D2E3137362D2E3030362D2E3137372D2E3030332D2E3137384C312E3733203136762D2E3133346C2D2E3031332D2E31362D2E3034342D2E3135362D2E3037322D2E3134342D2E3039372D2E31';
wwv_flow_imp.g_varchar2_table(49939) := '32392D2E31322D2E3130382D2E3133372D2E3038352D2E31352D2E3035374C2E393338203135202E3737372031357A4D362E31372032362E3834326C2D2E3135322E3035322D2E31342E30382D2E3132322E3130352D2E3130312E3132362D2E3037362E';
wwv_flow_imp.g_varchar2_table(49940) := '3134322D2E3034382E3135342D2E30322E31362E3031322E3136312E3034312E3135362E30372E3134362E3039342E31332E3039362E3039332E3033322E3032362E3030342E3030332E3030342E3030342E3134352E3131372E3030342E3030332E3030';
wwv_flow_imp.g_varchar2_table(49941) := '342E3030342E3134362E3131352E3030352E3030332E3030342E3030342E3134372E3131332E3030352E3030332E3030342E3030342E3134392E3131312E3030342E3030332E3030342E3030332E31352E31312E3030352E3030332E3030342E3030332E';
wwv_flow_imp.g_varchar2_table(49942) := '3135312E3130382E3030352E3030332E3030342E3030332E3135322E3130362E3030352E3030332E3030342E3030332E3135342E3130342E3030342E3030332E3030352E3030332E3135342E3130322E3030352E3030322E3030342E3030332E3135362E';
wwv_flow_imp.g_varchar2_table(49943) := '312E3030352E3030332E3030342E3030332E3135372E3039382E3030352E3030332E3030342E3030322E3135392E3039362E3030342E3030332E3030352E3030332E31362E3039342E3030342E3030332E3030342E3030322E31362E3039322E3030352E';
wwv_flow_imp.g_varchar2_table(49944) := '3030332E3030352E3030322E3136312E30392E3030352E3030332E3030352E3030332E3136322E3038382E3030352E3030322E3030342E3030322E3136342E3038372E3030352E3030322E3030342E3030322E3136352E3038342E3030352E3030332E30';
wwv_flow_imp.g_varchar2_table(49945) := '30342E3030322E3136362E3038322E3030342E3030322E3030352E3030332E3136372E30382E3030342E3030322E3030352E3030322E3136382E3037382E3030342E3030322E3030352E3030322E3136392E3037362E3030342E3030322E3030352E3030';
wwv_flow_imp.g_varchar2_table(49946) := '322E31372E3037342E3030342E3030322E3030352E3030322E31372E3037322E3030352E3030322E3030352E3030322E31372E30372E3030362E3030322E3030352E3030312E3137312E3036382E3030352E3030322E3030352E3030322E3137332E3036';
wwv_flow_imp.g_varchar2_table(49947) := '352E3030352E3030322E3030352E3030322E3137332E3036332E3030352E3030322E3030352E3030322E3137342E3036312E3030352E3030322E3030352E3030312E3137352E30362E3030352E3030312E3030352E3030322E3137362E3035372E303035';
wwv_flow_imp.g_varchar2_table(49948) := '2E3030312E3030352E3030322E3137372E3035352E3030352E3030312E3030352E3030322E3137372E3035322E3030352E3030322E3030352E3030312E3137382E3035312E3030352E3030312E3030352E3030322E3137382E3034382E3030362E303032';
wwv_flow_imp.g_varchar2_table(49949) := '682E3030356C2E3137392E3034372E3030352E3030312E3030352E3030322E31382E303434682E3030356C2E3030352E3030322E31382E3034322E3030362E3030312E3030352E3030312E3135392E3033352E31362E30322E31362D2E30312E3135372D';
wwv_flow_imp.g_varchar2_table(49950) := '2E30342E3134362D2E3036392E31332D2E3039342E3131322D2E3131372E3038372D2E3133362E30362D2E3134392E3033332D2E3135382E3030322D2E3136312D2E3032382D2E3135392D2E3035372D2E31352D2E3038342D2E3133382D2E3130382D2E';
wwv_flow_imp.g_varchar2_table(49951) := '31322D2E3132382D2E3039382D2E3134342D2E3037322D2E3132382D2E3033392D2E3135342D2E3033332D2E3136382D2E30342D2E3137312D2E3034312D2E3136392D2E3034342D2E31372D2E3034352D2E3136362D2E3034382D2E3136382D2E30352D';
wwv_flow_imp.g_varchar2_table(49952) := '2E3136352D2E3035312D2E3136362D2E3035342D2E3136362D2E3035362D2E3136332D2E3035372D2E3136352D2E30362D2E3136312D2E3036322D2E3136342D2E3036342D2E31362D2E3036352D2E31362D2E3036382D2E3136322D2E30372D2E313537';
wwv_flow_imp.g_varchar2_table(49953) := '2D2E30372D2E3135372D2E3037342D2E3135372D2E3037352D2E3135362D2E3037372D2E3135332D2E3037392D2E3135362D2E3038322D2E3135332D2E3038322D2E3135342D2E3038362D2E31352D2E3038362D2E3135322D2E30392D2E3134382D2E30';
wwv_flow_imp.g_varchar2_table(49954) := '392D2E3134372D2E3039322D2E3134392D2E3039352D2E3134352D2E3039352D2E3134342D2E3039382D2E3134352D2E312D2E3134332D2E3130322D2E31342D2E3130332D2E31342D2E3130342D2E31342D2E3130382D2E3133392D2E31312D2E313336';
wwv_flow_imp.g_varchar2_table(49955) := '2D2E31312D2E3032372D2E3032322D2E3133332D2E3039312D2E3134382D2E3036352D2E3135372D2E3033362D2E3136312D2E3030362D2E31362E3032347A6D31392E3231342E3037336C2D2E3135362E3033392D2E3134362E3036372D2E31312E3037';
wwv_flow_imp.g_varchar2_table(49956) := '362D2E3036342E3035312D2E3133392E31312D2E31342E3130382D2E31342E3130342D2E31342E3130332D2E3134332E3130312D2E3134352E3130312D2E3134342E3039382D2E3134352E3039352D2E3134392E3039352D2E3134382E3039332D2E3134';
wwv_flow_imp.g_varchar2_table(49957) := '372E3038392D2E3135322E30392D2E31352E3038362D2E3135342E3038362D2E3135332E3038322D2E3135362E3038322D2E3135332E3037392D2E3135362E3037372D2E3135372E3037352D2E3135372E3037332D2E3135382E3037312D2E31362E3037';
wwv_flow_imp.g_varchar2_table(49958) := '2D2E31362E3036382D2E3136312E3036352D2E3136342E3036342D2E3136312E3036312D2E3136352E30362D2E3136332E3035382D2E3136362E3035362D2E3136362E3035342D2E3136362E3035312D2E3136372E30352D2E3136372E3034382D2E3137';
wwv_flow_imp.g_varchar2_table(49959) := '2E3034352D2E3136382E3034342D2E3137312E3034322D2E3136382E3033392D2E31372E3033372D2E31312E3032332D2E3135342E3034372D2E3134332E3037352D2E3132362E312D2E3130362E3132322D2E3038312E3133392D2E3035342E3135322D';
wwv_flow_imp.g_varchar2_table(49960) := '2E3032352E31362E3030362E31362E3033352E3135382E3036332E3134382E30392E3133332E3131342E3131352E3133322E3039322E3134382E3036352E3135372E3033372E31362E3030382E3133332D2E3031372E3131352D2E303234682E3030356C';
wwv_flow_imp.g_varchar2_table(49961) := '2E3030352D2E3030322E3138312D2E3034682E3030356C2E3030352D2E3030322E31382D2E3034322E3030362D2E3030312E3030352D2E3030312E31382D2E3034342E3030352D2E303032682E3030356C2E31382D2E3034372E3030342D2E3030312E30';
wwv_flow_imp.g_varchar2_table(49962) := '30352D2E3030322E3137392D2E3034382E3030352D2E3030322E3030352D2E3030312E3137382D2E30352E3030352D2E3030322E3030352D2E3030322E3137372D2E3035322E3030352D2E3030322E3030352D2E3030312E3137372D2E3035352E303035';
wwv_flow_imp.g_varchar2_table(49963) := '2D2E3030322E3030352D2E3030312E3137362D2E3035372E3030352D2E3030322E3030352D2E3030322E3137352D2E3035392E3030352D2E3030312E3030352D2E3030322E3137342D2E3036312E3030352D2E3030322E3030352D2E3030322E3137332D';
wwv_flow_imp.g_varchar2_table(49964) := '2E3036332E3030352D2E3030322E3030352D2E3030322E3137332D2E3036352E3030352D2E3030322E3030342D2E3030322E3137322D2E3036382E3030352D2E3030312E3030352D2E3030322E3137312D2E30372E3030352D2E3030322E3030352D2E30';
wwv_flow_imp.g_varchar2_table(49965) := '30322E31372D2E3037322E3030352D2E3030322E3030352D2E3030322E3136392D2E3037342E3030352D2E3030322E3030342D2E3030322E3136392D2E3037362E3030342D2E3030322E3030352D2E3030322E3136382D2E3037382E3030342D2E303032';
wwv_flow_imp.g_varchar2_table(49966) := '2E3030352D2E3030322E3136372D2E30382E3030342D2E3030332E3030352D2E3030322E3136362D2E3038322E3030342D2E3030322E3030352D2E3030332E3136352D2E3038342E3030342D2E3030322E3030352D2E3030322E3136332D2E3038372E30';
wwv_flow_imp.g_varchar2_table(49967) := '30352D2E3030322E3030352D2E3030322E3136322D2E3038382E3030352D2E3030332E3030352D2E3030332E3136312D2E30392E3030352D2E3030322E3030342D2E3030332E31362D2E3039322E3030352D2E3030322E3030352D2E3030332E31362D2E';
wwv_flow_imp.g_varchar2_table(49968) := '3039342E3030342D2E3030332E3030342D2E3030332E3135382D2E3039362E3030352D2E3030322E3030342D2E3030332E3135382D2E3039382E3030342D2E3030332E3030352D2E3030332E3135362D2E312E3030342D2E3030332E3030342D2E303032';
wwv_flow_imp.g_varchar2_table(49969) := '2E3135352D2E3130322E3030352D2E3030332E3030342D2E3030332E3135342D2E3130342E3030342D2E3030332E3030352D2E3030332E3135322D2E3130362E3030342D2E3030332E3030352D2E3030332E3135312D2E3130382E3030342D2E3030332E';
wwv_flow_imp.g_varchar2_table(49970) := '3030352D2E3030332E31352D2E31312E3030342D2E3030332E3030342D2E3030332E3134392D2E3131312E3030342D2E3030342E3030342D2E3030332E3134382D2E3131332E3030342D2E3030342E3030342D2E3030332E3134372D2E3131352E303034';
wwv_flow_imp.g_varchar2_table(49971) := '2D2E3030342E3030342D2E3030332E3036382D2E3035352E3131362D2E3131332E3039322D2E3133322E3036362D2E3134372E3033382D2E3135372E3030382D2E31362D2E3032322D2E31362D2E30352D2E3135332D2E30382D2E31342D2E3130332D2E';
wwv_flow_imp.g_varchar2_table(49972) := '3132352D2E3132342D2E3130322D2E3134322D2E3037372D2E3135332D2E30352D2E31362D2E30322D2E31362E3030397A227D29293B66756E6374696F6E204F6A28297B72657475726E204F6A3D4F626A6563742E61737369676E3F4F626A6563742E61';
wwv_flow_imp.g_varchar2_table(49973) := '737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E';
wwv_flow_imp.g_varchar2_table(49974) := '6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4F6A2E6170706C79286E756C6C2C617267756D656E7473297D76617220526A3D287B7374796C65733A653D7B7D2C2E2E2E747D29';
wwv_flow_imp.g_varchar2_table(49975) := '3D3E4E432822737667222C4F6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30';
wwv_flow_imp.g_varchar2_table(49976) := '303343382E3139352D2E3135372E39333520362E32342E3132352031332E393835632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D32';
wwv_flow_imp.g_varchar2_table(49977) := '2E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E3838342032332E3434352E3430382031372E3230312E303439632D2E3430382D2E30332D2E3831372D2E3034362D312E3232';
wwv_flow_imp.g_varchar2_table(49978) := '362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E';
wwv_flow_imp.g_varchar2_table(49979) := '3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E3137342E3837322031312E36373920342E39383520362E39313663322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E';
wwv_flow_imp.g_varchar2_table(49980) := '32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E353834';
wwv_flow_imp.g_varchar2_table(49981) := '2D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231352D322E3238322D322E3032322D352E332D332E3231372D382E3335372D332E32327A4D313620342E39373563';
wwv_flow_imp.g_varchar2_table(49982) := '352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E383835';
wwv_flow_imp.g_varchar2_table(49983) := '2D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038322031312E3038322030203031313620342E3937357A6D2D322E313520332E32383176352E35333448382E32313376342E333868352E36';
wwv_flow_imp.g_varchar2_table(49984) := '333676352E35333468342E33315631382E313768352E363339762D342E3338682D352E363456382E323536682D342E33317A6D2E3836352E38363568322E35383376352E35333468352E36333576322E3635682D352E36333576352E353333682D322E35';
wwv_flow_imp.g_varchar2_table(49985) := '3833762D352E353334682D352E3634762D322E36343968352E363456392E3132317A227D29293B66756E6374696F6E20466A28297B72657475726E20466A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A6675';
wwv_flow_imp.g_varchar2_table(49986) := '6E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E';
wwv_flow_imp.g_varchar2_table(49987) := '63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C466A2E6170706C79286E756C6C2C617267756D656E7473297D76617220426A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C466A287B';
wwv_flow_imp.g_varchar2_table(49988) := '786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E3933';
wwv_flow_imp.g_varchar2_table(49989) := '3520362E3238362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220';
wwv_flow_imp.g_varchar2_table(49990) := '362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37';
wwv_flow_imp.g_varchar2_table(49991) := '323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E';
wwv_flow_imp.g_varchar2_table(49992) := '3535372D352E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E3231';
wwv_flow_imp.g_varchar2_table(49993) := '2D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E3730';
wwv_flow_imp.g_varchar2_table(49994) := '3220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720';
wwv_flow_imp.g_varchar2_table(49995) := '352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34';
wwv_flow_imp.g_varchar2_table(49996) := '382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D2E30303620332E3532314C392E3230362032302E3734356831332E3539384C31362E30303520382E3534327A6D3020312E37';
wwv_flow_imp.g_varchar2_table(49997) := '37356C352E33323920392E3536344831302E3637376C352E3332382D392E3536347A227D29293B66756E6374696F6E20566A28297B72657475726E20566A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A6675';
wwv_flow_imp.g_varchar2_table(49998) := '6E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E';
wwv_flow_imp.g_varchar2_table(49999) := '63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C566A2E6170706C79286E756C6C2C617267756D656E7473297D766172207A6A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C566A287B';
wwv_flow_imp.g_varchar2_table(50000) := '786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E39372E3034682D2E31323743382E3731332D2E30';
wwv_flow_imp.g_varchar2_table(50001) := '313820322E30303320352E3333342E3433372031322E323836632D312E353120362E3132332E39382031332E30303520362E3133362031362E36363520352E31323520332E3738382031322E35343620342E3130352031372E3931322E36323320352E32';
wwv_flow_imp.g_varchar2_table(50002) := '37322D332E32373620382E33332D392E37363620372E3332352D31352E3931362D2E3930342D362E3234312D352E37392D31312E372D31312E39352D31332E3134334131362E3038322031362E303832203020303031352E39372E30347A6D2D2E313831';
wwv_flow_imp.g_varchar2_table(50003) := '20312E373234632E3131352030202E32332030202E3334372E30303320362E3632352D2E3036362031322E38323320352E3134392031332E38392031312E363920312E313320352E39312D312E3930382031322E3334392D372E3236322031352E313338';
wwv_flow_imp.g_varchar2_table(50004) := '2D352E34373320332E3031332D31322E38363620312E3838342D31372E3131362D322E37323643312E3239312032312E3337322E3434342031332E39313420332E38303220382E36303263322E3439332D342E31313220372E3136392D362E3831392031';
wwv_flow_imp.g_varchar2_table(50005) := '312E3938372D362E3833387A6D2E32383320312E353534632D2E31313720302D2E3233342E3030322D2E3335312E3030352D362E3120302D31312E36393120352E3034392D31322E3334362031312E3131342D2E373820352E36383420322E3739352031';
wwv_flow_imp.g_varchar2_table(50006) := '312E36313220382E3231382031332E353220352E31333920312E3934332031312E3431362E3130312031342E3632342D342E333820332E3436312D342E35383320332E3236322D31312E3533382D2E3539362D31352E3833312D322E33362D322E373437';
wwv_flow_imp.g_varchar2_table(50007) := '2D352E3932342D342E3432332D392E3534392D342E3432387A6D2D2E30373820312E363935632E3037382030202E3135362030202E3233342E30303320352E3420302031302E33323120342E3535362031302E37333420392E3934322E35363320352E31';
wwv_flow_imp.g_varchar2_table(50008) := '332D322E3935382031302E3336342D372E3937312031312E3637382D342E38333220312E34312D31302E3435372D2E3933352D31322E3734362D352E3434362D322E3436332D342E3535392D312E322D31302E37393520332E3031342D31332E38383361';
wwv_flow_imp.g_varchar2_table(50009) := '31312E3037322031312E3037322030203031362E3733352D322E3239347A6D2D2E31333720332E3432632D322E3936352E30322D352E37393220312E3936382D362E38383420342E3732322D312E31333720322E3639332D2E35303920362E3030372031';
wwv_flow_imp.g_varchar2_table(50010) := '2E35333620382E30393620312E39383820322E313420352E32363320322E39323920382E30303720312E39323620322E3837352D2E393820342E3938372D332E38323420352E3036332D362E3836352E3135342D322E3935342D312E3632322D352E3837';
wwv_flow_imp.g_varchar2_table(50011) := '352D342E3239352D372E313361372E35343520372E35343520302030302D332E3432372D2E37357A6D2E323720312E33383163322E3730382E30313320352E32343920322E30313420352E383820342E3635322E37303420322E3537362D2E3438312035';
wwv_flow_imp.g_varchar2_table(50012) := '2E3531322D322E37383820362E3836322D322E33353620312E3437382D352E36373720312E3038342D372E3631312D2E3931382D322E3034322D312E39372D322E3430352D352E3337362D2E3833392D372E37333820312E31312D312E37363220332E31';
wwv_flow_imp.g_varchar2_table(50013) := '34362D322E38373720352E3232392D322E383537682E31337A6D312E38333120312E3736346C2D322E30373220332E3736632D2E36342E3036382D2E37393220312E3033392D2E32303220312E3239382E33392E32372E3639362D2E313820312E303531';
wwv_flow_imp.g_varchar2_table(50014) := '2D2E31363468332E313638762D2E383634682D332E31386C312E3939322D332E3631322D2E3735372D2E3431387A227D29293B66756E6374696F6E20486A28297B72657475726E20486A3D4F626A6563742E61737369676E3F4F626A6563742E61737369';
wwv_flow_imp.g_varchar2_table(50015) := '676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E686173';
wwv_flow_imp.g_varchar2_table(50016) := '4F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C486A2E6170706C79286E756C6C2C617267756D656E7473297D76617220576A3D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E';
wwv_flow_imp.g_varchar2_table(50017) := '432822737667222C486A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3834382E30303143';
wwv_flow_imp.g_varchar2_table(50018) := '382E3131332D2E3039332E39333120362E3238312E3132352031332E393833632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E33';
wwv_flow_imp.g_varchar2_table(50019) := '3320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230374332392E31303520342E3933382032332E35352E34382031372E3336372E30364131362E3434382031362E343438203020303031352E3834382030762E';
wwv_flow_imp.g_varchar2_table(50020) := '3030317A6D2E32393320312E37323763372E3131332D2E3039392031332E36363220352E39372031342E3037372031332E30382E353620362E3239392D332E3531362031322E3733352D392E3538322031342E3637392D352E37393820322E3030342D31';
wwv_flow_imp.g_varchar2_table(50021) := '322E3830362D2E31322D31362E3238332D352E323337432E3731372031392E3135392E3837342031312E36333820352E30313620362E38373620372E37323220332E3633382031312E39303220312E36332031362E313420312E3732387A6D2D2E343135';
wwv_flow_imp.g_varchar2_table(50022) := '20312E35353543392E31353720332E32353820332E32353620392E31353620332E3237382031352E373239632D2E313620352E39363520342E3336352031312E3732352031302E3239332031322E37333720352E34303920312E3036352031312E33372D';
wwv_flow_imp.g_varchar2_table(50023) := '312E3734342031332E3737352D362E37353320322E3533342D342E39383620312E3338362D31312E3632372D322E3935332D31352E3235312D322E3336342D322E3037372D352E3531322D332E32372D382E3636372D332E31387A6D2E35303720312E36';
wwv_flow_imp.g_varchar2_table(50024) := '393263352E38322D2E3032362031312E30313320352E3331382031302E37392031312E3134332D2E30323420352E332D342E3331332031302E3236372D392E3633362031302E3830332D352E3037352E3636372D31302E3432362D322E3538382D31312E';
wwv_flow_imp.g_varchar2_table(50025) := '3838352D372E3535332D312E3533352D342E3734342E3439342D31302E343620342E3932352D31322E3838356131312E3037322031312E3037322030203031352E3830362D312E3530387A227D29293B66756E6374696F6E206A6A28297B72657475726E';
wwv_flow_imp.g_varchar2_table(50026) := '206A6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E';
wwv_flow_imp.g_varchar2_table(50027) := '74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6A6A2E6170706C79286E756C6C2C617267756D656E7473297D66';
wwv_flow_imp.g_varchar2_table(50028) := '756E6374696F6E20716A28297B72657475726E20716A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(50029) := '3B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C716A2E6170706C';
wwv_flow_imp.g_varchar2_table(50030) := '79286E756C6C2C617267756D656E7473297D66756E6374696F6E20246A28297B72657475726E20246A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D31';
wwv_flow_imp.g_varchar2_table(50031) := '3B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D';
wwv_flow_imp.g_varchar2_table(50032) := '297D72657475726E20657D2C246A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20556A28297B72657475726E20556A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E63';
wwv_flow_imp.g_varchar2_table(50033) := '74696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E6361';
wwv_flow_imp.g_varchar2_table(50034) := '6C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C556A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E204B6A28297B72657475726E204B6A3D4F626A6563742E61737369676E3F4F626A656374';
wwv_flow_imp.g_varchar2_table(50035) := '2E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D';
wwv_flow_imp.g_varchar2_table(50036) := '292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4B6A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20476A28297B72657475726E20476A3D4F';
wwv_flow_imp.g_varchar2_table(50037) := '626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D';
wwv_flow_imp.g_varchar2_table(50038) := '3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C476A2E6170706C79286E756C6C2C617267756D656E7473297D66756E637469';
wwv_flow_imp.g_varchar2_table(50039) := '6F6E20516A28297B72657475726E20516A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B29';
wwv_flow_imp.g_varchar2_table(50040) := '7B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C516A2E6170706C79286E756C';
wwv_flow_imp.g_varchar2_table(50041) := '6C2C617267756D656E7473297D66756E6374696F6E20596A28297B72657475726E20596A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C6172';
wwv_flow_imp.g_varchar2_table(50042) := '67756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D726574';
wwv_flow_imp.g_varchar2_table(50043) := '75726E20657D2C596A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E205A6A28297B72657475726E205A6A3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(50044) := '65297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C';
wwv_flow_imp.g_varchar2_table(50045) := '6929262628655B695D3D6E5B695D297D72657475726E20657D2C5A6A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20586A28297B72657475726E20586A3D4F626A6563742E61737369676E3F4F626A6563742E61737369';
wwv_flow_imp.g_varchar2_table(50046) := '676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E686173';
wwv_flow_imp.g_varchar2_table(50047) := '4F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C586A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E204A6A28297B72657475726E204A6A3D4F626A656374';
wwv_flow_imp.g_varchar2_table(50048) := '2E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228';
wwv_flow_imp.g_varchar2_table(50049) := '766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C4A6A2E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206571';
wwv_flow_imp.g_varchar2_table(50050) := '28297B72657475726E2065713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B76617220';
wwv_flow_imp.g_varchar2_table(50051) := '6E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C65712E6170706C79286E756C6C2C617267';
wwv_flow_imp.g_varchar2_table(50052) := '756D656E7473297D66756E6374696F6E20747128297B72657475726E2074713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E';
wwv_flow_imp.g_varchar2_table(50053) := '74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E2065';
wwv_flow_imp.g_varchar2_table(50054) := '7D2C74712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206E7128297B72657475726E206E713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F';
wwv_flow_imp.g_varchar2_table(50055) := '722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628';
wwv_flow_imp.g_varchar2_table(50056) := '655B695D3D6E5B695D297D72657475726E20657D2C6E712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20697128297B72657475726E2069713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E6269';
wwv_flow_imp.g_varchar2_table(50057) := '6E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E5072';
wwv_flow_imp.g_varchar2_table(50058) := '6F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C69712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206F7128297B72657475726E206F713D4F626A6563742E61737369';
wwv_flow_imp.g_varchar2_table(50059) := '676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F72287661722069';
wwv_flow_imp.g_varchar2_table(50060) := '20696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6F712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20737128297B7265';
wwv_flow_imp.g_varchar2_table(50061) := '7475726E2073713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267';
wwv_flow_imp.g_varchar2_table(50062) := '756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C73712E6170706C79286E756C6C2C617267756D656E74';
wwv_flow_imp.g_varchar2_table(50063) := '73297D66756E6374696F6E20727128297B72657475726E2072713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C65';
wwv_flow_imp.g_varchar2_table(50064) := '6E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C72712E';
wwv_flow_imp.g_varchar2_table(50065) := '6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20617128297B72657475726E2061713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F7228766172';
wwv_flow_imp.g_varchar2_table(50066) := '20743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D';
wwv_flow_imp.g_varchar2_table(50067) := '6E5B695D297D72657475726E20657D2C61712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206C7128297B72657475726E206C713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A';
wwv_flow_imp.g_varchar2_table(50068) := '66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274';
wwv_flow_imp.g_varchar2_table(50069) := '792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6C712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20637128297B72657475726E2063713D4F626A6563742E61737369676E3F4F62';
wwv_flow_imp.g_varchar2_table(50070) := '6A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E';
wwv_flow_imp.g_varchar2_table(50071) := '29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C63712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20647128297B72657475726E20';
wwv_flow_imp.g_varchar2_table(50072) := '64713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74';
wwv_flow_imp.g_varchar2_table(50073) := '735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C64712E6170706C79286E756C6C2C617267756D656E7473297D6675';
wwv_flow_imp.g_varchar2_table(50074) := '6E6374696F6E20687128297B72657475726E2068713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(50075) := '742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C68712E6170706C79';
wwv_flow_imp.g_varchar2_table(50076) := '286E756C6C2C617267756D656E7473297D66756E6374696F6E20757128297B72657475726E2075713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B';
wwv_flow_imp.g_varchar2_table(50077) := '743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D29';
wwv_flow_imp.g_varchar2_table(50078) := '7D72657475726E20657D2C75712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20707128297B72657475726E2070713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374';
wwv_flow_imp.g_varchar2_table(50079) := '696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C';
wwv_flow_imp.g_varchar2_table(50080) := '6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C70712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20677128297B72657475726E2067713D4F626A6563742E61737369676E3F4F626A6563742E';
wwv_flow_imp.g_varchar2_table(50081) := '61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D29';
wwv_flow_imp.g_varchar2_table(50082) := '2E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C67712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E206D7128297B72657475726E206D713D4F62';
wwv_flow_imp.g_varchar2_table(50083) := '6A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B';
wwv_flow_imp.g_varchar2_table(50084) := '666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6D712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(50085) := '6E20667128297B72657475726E2066713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B';
wwv_flow_imp.g_varchar2_table(50086) := '766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C66712E6170706C79286E756C6C';
wwv_flow_imp.g_varchar2_table(50087) := '2C617267756D656E7473297D66756E6374696F6E20767128297B72657475726E2076713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267';
wwv_flow_imp.g_varchar2_table(50088) := '756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475';
wwv_flow_imp.g_varchar2_table(50089) := '726E20657D2C76712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20627128297B72657475726E2062713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(50090) := '297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C69';
wwv_flow_imp.g_varchar2_table(50091) := '29262628655B695D3D6E5B695D297D72657475726E20657D2C62712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E205F7128297B72657475726E205F713D4F626A6563742E61737369676E3F4F626A6563742E6173736967';
wwv_flow_imp.g_varchar2_table(50092) := '6E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F';
wwv_flow_imp.g_varchar2_table(50093) := '776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C5F712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20797128297B72657475726E2079713D4F626A6563742E';
wwv_flow_imp.g_varchar2_table(50094) := '61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F722876';
wwv_flow_imp.g_varchar2_table(50095) := '6172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C79712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20777128';
wwv_flow_imp.g_varchar2_table(50096) := '297B72657475726E2077713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E';
wwv_flow_imp.g_varchar2_table(50097) := '3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C77712E6170706C79286E756C6C2C61726775';
wwv_flow_imp.g_varchar2_table(50098) := '6D656E7473297D7661722043713D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7771287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768';
wwv_flow_imp.g_varchar2_table(50099) := '743A223332227D2C74292C4E43282270617468222C7B643A224D352E363337203341352E36343420352E36343420302030303020382E3633377631352E34313761352E36343420352E3634342030203030352E36333720352E3633376832302E37323641';
wwv_flow_imp.g_varchar2_table(50100) := '352E36343420352E363434203020303033322032342E30353456382E36333741352E36343420352E363434203020303032362E333633203348352E3633377A6D3020312E3737386832302E37323661332E383320332E38332030203031332E3835392033';
wwv_flow_imp.g_varchar2_table(50101) := '2E3835397631352E34313761332E383320332E383320302030312D332E38353920332E383538682D342E3230315631362E36393548392E3833387631312E32313748352E36333761332E383320332E383320302030312D332E3835392D332E3835385638';
wwv_flow_imp.g_varchar2_table(50102) := '2E36333761332E383320332E38332030203031332E3835392D332E3835397A6D352E33332031332E3034366831302E3036367631302E3036354831302E3936375631372E3832347A6D342E31383920312E3433315632322E30364831322E333576312E36';
wwv_flow_imp.g_varchar2_table(50103) := '383968322E3830345632362E35353468312E36395632332E37343968322E3830345632322E3036682D322E3830345631392E323535682D312E36397A227D29293B66756E6374696F6E20537128297B72657475726E2053713D4F626A6563742E61737369';
wwv_flow_imp.g_varchar2_table(50104) := '676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F72287661722069';
wwv_flow_imp.g_varchar2_table(50105) := '20696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C53712E6170706C79286E756C6C2C617267756D656E7473297D7661722078713D287B7374796C65733A';
wwv_flow_imp.g_varchar2_table(50106) := '653D7B7D2C2E2E2E747D293D3E4E432822737667222C5371287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B64';
wwv_flow_imp.g_varchar2_table(50107) := '3A224D352E363336203341352E36343220352E36343220302030303020382E3633367631352E34313861352E36343320352E3634332030203030352E36333620352E3633366832302E37323841352E36343320352E363433203020303033322032342E30';
wwv_flow_imp.g_varchar2_table(50108) := '353456382E36333641352E36343220352E363432203020303032362E333634203348352E3633367A6D3020312E3737386832302E37323861332E383320332E38332030203031332E38353820332E3835387631352E34313861332E383320332E38332030';
wwv_flow_imp.g_varchar2_table(50109) := '2030312D332E38353820332E383538682D342E3230335631362E37323348392E38347631312E31383948352E36333661332E383320332E383320302030312D332E3835382D332E38353856382E36333661332E383320332E38332030203031332E383538';
wwv_flow_imp.g_varchar2_table(50110) := '2D332E3835387A6D352E3333312031332E3037346831302E3036367631302E30364831302E393637762D31302E30367A6D312E33333620332E39393676312E37313168372E333934762D312E3731682D372E3339347A227D29293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(50111) := '6B7128297B72657475726E206B713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B7661';
wwv_flow_imp.g_varchar2_table(50112) := '72206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C6B712E6170706C79286E756C6C2C61';
wwv_flow_imp.g_varchar2_table(50113) := '7267756D656E7473297D66756E6374696F6E20457128297B72657475726E2045713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D';
wwv_flow_imp.g_varchar2_table(50114) := '656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E';
wwv_flow_imp.g_varchar2_table(50115) := '20657D2C45712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E204C7128297B72657475726E204C713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(50116) := '666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C692926';
wwv_flow_imp.g_varchar2_table(50117) := '2628655B695D3D6E5B695D297D72657475726E20657D2C4C712E6170706C79286E756C6C2C617267756D656E7473297D66756E6374696F6E20447128297B72657475726E2044713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E';
wwv_flow_imp.g_varchar2_table(50118) := '62696E6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E';
wwv_flow_imp.g_varchar2_table(50119) := '50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C44712E6170706C79286E756C6C2C617267756D656E7473297D7661722054713D7B4173736F63696174696F6E3A287B7374796C65733A653D7B7D';
wwv_flow_imp.g_varchar2_table(50120) := '2C2E2E2E747D293D3E4E432822737667222C4457287B77696474683A223332222C6865696768743A223332222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D2C74292C4E43282270617468222C7B7374726F6B';
wwv_flow_imp.g_varchar2_table(50121) := '653A2223303030222C7374726F6B6557696474683A2232222C66696C6C3A226E6F6E65222C7374726F6B654461736861727261793A22332E332C36222C7374726F6B654C696E656361703A22737175617265222C643A224D312E352033302E356C32392D';
wwv_flow_imp.g_varchar2_table(50122) := '3239227D29292C427573696E65737352756C655461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5457287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A';
wwv_flow_imp.g_varchar2_table(50123) := '223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D362E343934203343322E3931362033203020352E393033203020392E3437357631332E333833633020332E35373220322E39313620362E34373520362E343934';
wwv_flow_imp.g_varchar2_table(50124) := '20362E3437356831392E30313263332E353738203020362E3439342D322E39303320362E3439342D362E34373556392E34373543333220352E3930332032392E30383420332032352E353036203348362E3439347A6D3020326831392E3031324332382E';
wwv_flow_imp.g_varchar2_table(50125) := '303135203520333020362E393820333020392E3437357631332E333833633020322E3439352D312E39383520342E3437352D342E34393420342E34373548362E34393443332E3938352032372E33333320322032352E33353320322032322E3835385639';
wwv_flow_imp.g_varchar2_table(50126) := '2E343735433220362E393820332E393835203520362E34393420357A4D352E32393620372E3339387631322E3636356831362E383756372E33393848352E3239367A6D2E37313820342E3338366831352E34333376332E343448392E393835762D332E34';
wwv_flow_imp.g_varchar2_table(50127) := '3332682D2E37313976332E34333148362E303134762D332E34347A6D3020342E31353868332E32353276332E34303348362E303134762D332E3430337A6D332E393720306831312E34363376332E34303348392E393835762D332E3430337A227D292C4E';
wwv_flow_imp.g_varchar2_table(50128) := '43282270617468222C7B643A224D362E30373920382E32303976332E3538374832312E343456382E3230397A227D29292C43616C6C41637469766974793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4957287B786D6C';
wwv_flow_imp.g_varchar2_table(50129) := '6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D32342E393738203363332E373631203020362E383920322E3937';
wwv_flow_imp.g_varchar2_table(50130) := '3920372E30313820362E3639356C2E3030342E3233385632322E34633020332E3734372D332E303520362E3830342D362E37383320362E39336C2D2E32342E30303348372E303233632D332E37363120302D362E38392D322E3937382D372E3031382D36';
wwv_flow_imp.g_varchar2_table(50131) := '2E3639354C302032322E3456392E393333433020362E31383720332E303520332E313320362E37383320332E3030344C372E30323320336831372E3935357A6D3020332E36363748372E303232632D312E38343220302D332E32353520312E3334342D33';
wwv_flow_imp.g_varchar2_table(50132) := '2E333520332E3037396C2D2E3030352E3138375632322E34633020312E37363120312E333520332E31363720332E313620332E3236326C2E3139352E3030354C31302032352E3636365631356831327631302E36363668322E39373863312E3834322030';
wwv_flow_imp.g_varchar2_table(50133) := '20332E3235352D312E33343420332E33352D332E3037396C2E3030352D2E31383756392E39333363302D312E3736312D312E33352D332E3136362D332E31362D332E3236316C2D2E3139352D2E3030357A6D2D332E37333220392E3038374831302E3735';
wwv_flow_imp.g_varchar2_table(50134) := '3476392E3931326831302E343931762D392E3931327A6D2D342E34373520312E38313776322E36353868322E36353876312E3534324831362E373776322E3635384831352E32335632312E37374831322E35375632302E323368322E3635385631372E35';
wwv_flow_imp.g_varchar2_table(50135) := '3768312E3534327A227D29292C436F6C6C61626F726174696F6E3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4D57287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C776964';
wwv_flow_imp.g_varchar2_table(50136) := '74683A223332222C6865696768743A223332227D2C74292C4E43282267222C7B66696C6C52756C653A226576656E6F6464227D2C4E43282270617468222C7B66696C6C52756C653A226E6F6E7A65726F222C643A224D30203076382E3632683332563048';
wwv_flow_imp.g_varchar2_table(50137) := '307A6D312E36353520372E303534762D352E33376832382E363276352E333748312E3635367A4D302032332E3338563332683332762D382E363248307A6D312E36353520372E303534762D352E33376832382E363276352E333748312E3635367A227D29';
wwv_flow_imp.g_varchar2_table(50138) := '2C4E43282270617468222C7B643A224D323420386C342037682D386C342D377A6D3020326C2D322E3238203468342E35364C32342031307A4D32332E3520323168317633682D317A4D32332E3520313568317633682D317A4D382032346C2D342D376838';
wwv_flow_imp.g_varchar2_table(50139) := '6C2D3420377A6D302D326C322E32382D3448352E37324C382032327A4D372E35203868317633682D317A4D372E3520313468317633682D317A227D2929292C436F6E646974696F6E616C466C6F773A287B7374796C65733A653D7B7D2C2E2E2E747D293D';
wwv_flow_imp.g_varchar2_table(50140) := '3E4E432822737667222C4157287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3332202E3034315332';
wwv_flow_imp.g_varchar2_table(50141) := '302E343220352E39352031342E35333720382E37313363312E323620312E313520322E34333220322E33393220332E36343820332E3538382D352E37303320352E37382D332E313520332E3330332D382E30383720382E3331366C2D382E34373220312E';
wwv_flow_imp.g_varchar2_table(50142) := '3337374C302033326C31302E3030362D312E3632362E3039382D2E35393820312E3237392D372E38373363342E3937352D352E30353220322E3430332D322E35353520382E3131382D382E33343620312E32313820312E32313420322E343320322E3433';
wwv_flow_imp.g_varchar2_table(50143) := '3520332E36343820332E3634384332362E32392031312E303138203332202E303431203332202E3034317A4D392E3630332032322E3339374C382E35342032382E393120322E30332032392E39376C312E3036312D362E35313520362E3531322D312E30';
wwv_flow_imp.g_varchar2_table(50144) := '35387A227D29292C53657175656E6365466C6F773A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4E57287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332';
wwv_flow_imp.g_varchar2_table(50145) := '222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3332202E30365332302E333320362E3031342031342E34303320382E37393863312E323720312E313620322E34353120322E343120332E36373620332E3631364C3020';
wwv_flow_imp.g_varchar2_table(50146) := '33302E37333420312E3332352033326C31382E30382D31382E333263312E32323720312E32323320322E34343820322E34353320332E36373620332E3637364332362E3234372031312E3132203332202E3036203332202E30367A227D29292C44617461';
wwv_flow_imp.g_varchar2_table(50147) := '496E7075743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5257287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C';
wwv_flow_imp.g_varchar2_table(50148) := '74292C4E43282270617468222C7B643A224D32302E383333203048332E34383876333248323856372E33364C32302E38333320307A6D2D322E31303520312E38313876372E35303768372E3435347632302E38353748352E33303656312E383138683133';
wwv_flow_imp.g_varchar2_table(50149) := '2E3432327A6D312E3831382E3439336C352E303620352E313936682D352E303656322E3331317A6D2D392E3138322E383676332E37343448372E30383176332E32323268342E32383376332E3734336C352E372D352E3335342D352E372D352E3335347A';
wwv_flow_imp.g_varchar2_table(50150) := '6D2E38303820312E3836386C332E37313120332E3438372D332E373120332E34383756392E33323948372E38383856372E37323368342E32383356352E3033397A227D29292C44617461496E7075744173736F63696174696F6E3A4F572C446174614F75';
wwv_flow_imp.g_varchar2_table(50151) := '747075743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4257287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74';
wwv_flow_imp.g_varchar2_table(50152) := '292C4E43282270617468222C7B643A224D32302E383333203048332E34383876333248323856372E33364C32302E38333320307A6D2D322E31303520312E38313876372E35303768372E3435347632302E38353748352E33303656312E3831386831332E';
wwv_flow_imp.g_varchar2_table(50153) := '3432327A6D312E3831382E3439336C352E303620352E313936682D352E303656322E3331317A6D2D392E3138322E383676332E37343448372E30383176332E32323268342E32383376332E3734336C352E372D352E3335342D352E372D352E3335347A22';
wwv_flow_imp.g_varchar2_table(50154) := '7D29292C446174614F75747075744173736F63696174696F6E3A4F572C446174614F626A6563745265666572656E63653A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4657287B786D6C6E733A22687474703A2F2F7777';
wwv_flow_imp.g_varchar2_table(50155) := '772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D32312E333435203048347633326832342E35313256372E33364C32312E33343520307A4D31392E';
wwv_flow_imp.g_varchar2_table(50156) := '323420312E38313876372E35303768372E3435347632302E38353748352E38313856312E3831384831392E32347A6D312E3831382E3439336C352E303620352E313936682D352E303656322E3331317A227D29292C4461746153746F7265526566657265';
wwv_flow_imp.g_varchar2_table(50157) := '6E63653A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5657287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C7429';
wwv_flow_imp.g_varchar2_table(50158) := '2C4E43282270617468222C7B643A224D31362E3030382031632D332E37313220302D372E3431372E3330362D31302E3331392E3933392D312E34352E3331362D322E372E37312D332E363820312E32323643312E30363520332E3636322E32393720342E';
wwv_flow_imp.g_varchar2_table(50159) := '3330342E30363120352E3233612E3832332E38323320302030302D2E3033352E31354C3020352E3530326C2E3031372E303834632D2E30313220372E343120302031342E343620302032322E30386C2E3031372E303832632E3230332E3938352E393935';
wwv_flow_imp.g_varchar2_table(50160) := '20312E36353620312E39373520322E3137322E39382E35313720322E32332E393120332E363820312E32323620322E3930322E36333320362E3630372E39342031302E3331392E393420332E373131203020372E3431362D2E3330372031302E3331382D';
wwv_flow_imp.g_varchar2_table(50161) := '2E393420312E3435312D2E33313620322E3730312D2E373120332E36382D312E3232362E39382D2E35313620312E3737322D312E31383720312E3937352D322E3137326C2E3031372D2E30383256352E353431612E3832352E3832352030203030302D2E';
wwv_flow_imp.g_varchar2_table(50162) := '313036762D2E3031366C2D2E3030322D2E303133612E3832332E38323320302030302D2E3034362D2E313937632D2E3234342D2E3931362D312E3030372D312E35352D312E3934332D322E3034342D2E39382D2E3531362D322E32332D2E39312D332E36';
wwv_flow_imp.g_varchar2_table(50163) := '382D312E3232364332332E34323320312E3330362031392E37313820312031362E30303620317A6D3020312E36343663332E3632203020372E3234352E33303820392E3936382E39303120312E33362E32393720322E3439372E363720332E3236332031';
wwv_flow_imp.g_varchar2_table(50164) := '2E3037342E3631322E3332332E3933322E36343320312E3036332E3838322D2E3133312E32342D2E3435312E35362D312E3036332E3838322D2E3736362E3430342D312E3930322E3737372D332E32363320312E3037342D322E3732332E3539342D362E';
wwv_flow_imp.g_varchar2_table(50165) := '3334392E3930312D392E3936382E3930312D332E363220302D372E3234352D2E3330372D392E3936382D2E3930312D312E3336312D2E3239372D322E3439372D2E36372D332E3236342D312E3037342D2E3631312D2E3332322D2E3933312D2E3634322D';
wwv_flow_imp.g_varchar2_table(50166) := '312E3036322D2E3838322E31332D2E32342E3435312D2E353620312E3036322D2E3838322E3736372D2E34303320312E3930332D2E37373720332E3236342D312E30373420322E3732332D2E35393320362E3334382D2E3920392E3936382D2E397A4D31';
wwv_flow_imp.g_varchar2_table(50167) := '2E36363420372E363437632E3131322E3036372E3232372E3133322E3334352E3139342E39382E35313720322E32332E393120332E363820312E32323620322E3930322E36333320362E3630372E39342031302E3331392E393420332E37313120302037';
wwv_flow_imp.g_varchar2_table(50168) := '2E3431362D2E3330372031302E3331382D2E393420312E3435312D2E33313620322E3730312D2E373120332E36382D312E3232362E3131392D2E3036322E3233342D2E3132372E3334362D2E31393476312E3933632D2E30382E3234352D2E3339382E36';
wwv_flow_imp.g_varchar2_table(50169) := '31392D312E3131332E3939352D2E3736362E3430342D312E3930322E3737372D332E32363320312E3037342D322E3732332E3539342D362E3334392E3930312D392E3936382E3930312D332E363220302D372E3234352D2E3330372D392E3936382D2E39';
wwv_flow_imp.g_varchar2_table(50170) := '2D312E3336312D2E3239382D322E3439372D2E3637312D332E3236342D312E3037352D2E3731342D2E3337362D312E3033322D2E37352D312E3131322D2E393935762D312E39337A6D3020342E313837632E3131322E3036372E3232372E3133322E3334';
wwv_flow_imp.g_varchar2_table(50171) := '352E3139352E39382E35313620322E32332E393120332E363820312E32323620322E3930322E36333220362E3630372E3933382031302E3331392E39333820332E373131203020372E3431362D2E3330362031302E3331382D2E39333820312E3435312D';
wwv_flow_imp.g_varchar2_table(50172) := '2E33313720322E3730312D2E373120332E36382D312E3232362E3131392D2E3036332E3233342D2E3132382E3334362D2E31393576312E3933632D2E30382E3234352D2E3339382E3631392D312E3131332E3939352D2E3736362E3430342D312E393032';
wwv_flow_imp.g_varchar2_table(50173) := '2E3737372D332E32363320312E3037342D322E3732332E3539342D362E3334392E3930312D392E3936382E3930312D332E363220302D372E3234352D2E3330372D392E3936382D2E392D312E3336312D2E3239382D322E3439372D2E36372D332E323634';
wwv_flow_imp.g_varchar2_table(50174) := '2D312E3037352D2E3731342D2E3337362D312E3033322D2E37352D312E3131322D2E393935762D312E39337A6D3020342E313838632E3131322E3036372E3232372E3133312E3334352E3139342E39382E35313620322E32332E393120332E363820312E';
wwv_flow_imp.g_varchar2_table(50175) := '32323620322E3930322E36333320362E3630372E3933392031302E3331392E39333920332E373131203020372E3431362D2E3330362031302E3331382D2E393420312E3435312D2E33313620322E3730312D2E37303920332E36382D312E3232352E3131';
wwv_flow_imp.g_varchar2_table(50176) := '392D2E3036332E3233342D2E3132372E3334362D2E3139345632372E3437632D2E30382E3234352D2E3339382E3631382D312E3131332E3939352D2E3736362E3430342D312E3930322E3737372D332E32363320312E3037342D322E3732332E3539342D';
wwv_flow_imp.g_varchar2_table(50177) := '362E3334392E392D392E3936382E392D332E363220302D372E3234352D2E3330362D392E3936382D2E392D312E3336312D2E3239372D322E3439372D2E36372D332E3236342D312E3037342D2E3731342D2E3337372D312E3033322D2E37352D312E3131';
wwv_flow_imp.g_varchar2_table(50178) := '322D2E3939355631362E3032327A227D29292C44656661756C74466C6F773A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7A57287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F73766722';
wwv_flow_imp.g_varchar2_table(50179) := '2C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3332202E30365332302E333320362E3031342031342E34303320382E37393863312E323720312E313620322E34353120322E343120332E3637';
wwv_flow_imp.g_varchar2_table(50180) := '3620332E3631364C362E38342032332E383034482E30343676312E37353568352E3036334C302033302E37333520312E3332352033326C362E3335372D362E34343168372E313435762D312E37353648392E3431346C392E39392D31302E31323363312E';
wwv_flow_imp.g_varchar2_table(50181) := '32323820312E32323320322E343520322E34353320332E36373720332E3637364332362E3234372031312E3132203332202E3036203332202E30367A227D29292C43616E63656C456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D29';
wwv_flow_imp.g_varchar2_table(50182) := '3D3E4E432822737667222C4857287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3637362E30';
wwv_flow_imp.g_varchar2_table(50183) := '353143372E3934332E3035382E38333420362E3530312E3130342031342E3231632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E38372031372E3433342D';
wwv_flow_imp.g_varchar2_table(50184) := '322E33343420342E3732352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220352E3030392032332E3339342E3336342031362E3937382E3038334131382E3533322031382E353332203020303031352E3637362E';
wwv_flow_imp.g_varchar2_table(50185) := '30357A6D2E33313720352E30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E30323620312E3030372D31';
wwv_flow_imp.g_varchar2_table(50186) := '302E362D312E3839382D31322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D2D332E39353520332E393138';
wwv_flow_imp.g_varchar2_table(50187) := '4C382E39342031322E3037326C332E39383520332E3938352D332E39313320332E39313320332E30343820332E30343720332E3931332D332E39313320332E39383720332E39383720332E3039362D332E3039362D332E3938372D332E39383720332E39';
wwv_flow_imp.g_varchar2_table(50188) := '31332D332E3931332D332E3034372D332E3034382D332E39313320332E3931332D332E3938352D332E3938357A227D29292C436F6D70656E73617465456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C';
wwv_flow_imp.g_varchar2_table(50189) := '5757287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3637362E30353143372E3934332E3035';
wwv_flow_imp.g_varchar2_table(50190) := '382E38333420362E3530312E3130342031342E3231632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E38372031372E3433342D322E33343420342E373235';
wwv_flow_imp.g_varchar2_table(50191) := '2D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220352E3030392032332E3339342E3336342031362E3937382E3038334131382E3533322031382E353332203020303031352E3637362E30357A6D2E33313720352E';
wwv_flow_imp.g_varchar2_table(50192) := '30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E30323620312E3030372D31302E362D312E3839382D31';
wwv_flow_imp.g_varchar2_table(50193) := '322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D2D2E353620352E3734346C2D372E34303720352E323320';
wwv_flow_imp.g_varchar2_table(50194) := '372E34303820352E323334762D352E30353763322E33383420312E36383720342E37373120332E33373120372E31353720352E3035375631302E3830316C2D372E31353720352E303534762D352E3035347A227D29292C4572726F72456E644576656E74';
wwv_flow_imp.g_varchar2_table(50195) := '3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6A57287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43';
wwv_flow_imp.g_varchar2_table(50196) := '282270617468222C7B643A224D31352E3637362E30353143372E3934332E3035382E38333420362E3530312E3130342031342E3231632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733';
wwv_flow_imp.g_varchar2_table(50197) := '372031322E37383920312E38372031372E3433342D322E33343420342E3732352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220352E3030392032332E3339342E3336342031362E3937382E3038334131382E35';
wwv_flow_imp.g_varchar2_table(50198) := '33322031382E353332203020303031352E3637362E30357A6D2E33313720352E30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E383634';
wwv_flow_imp.g_varchar2_table(50199) := '2031312E3230342D352E30323620312E3030372D31302E362D312E3839382D31322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539';
wwv_flow_imp.g_varchar2_table(50200) := '322D312E3532327A6D362E31333220342E3136366C2D332E36333320372E3336332D342E3531362D352E3837342D342E3130322031322E31333120342E3539392D352E393120342E37343320352E34323720322E3930392D31332E3133377A227D29292C';
wwv_flow_imp.g_varchar2_table(50201) := '457363616C6174696F6E456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7157287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C';
wwv_flow_imp.g_varchar2_table(50202) := '6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3637362E30353143372E3934332E3035382E38333420362E3530312E3130342031342E3231632D2E37383320362E35363520322E3931322031332E34323720382E39';
wwv_flow_imp.g_varchar2_table(50203) := '34322031362E32313620352E3620322E3733372031322E37383920312E38372031372E3433342D322E33343420342E3732352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220352E3030392032332E3339342E33';
wwv_flow_imp.g_varchar2_table(50204) := '36342031362E3937382E3038334131382E3533322031382E353332203020303031352E3637362E30357A6D2E33313720352E30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231';
wwv_flow_imp.g_varchar2_table(50205) := '322D332E36372031302E33332D382E3836342031312E3230342D352E30323620312E3030372D31302E362D312E3839382D31322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E30';
wwv_flow_imp.g_varchar2_table(50206) := '38322031312E3038322030203031352E3539322D312E3532327A6D2E30303620332E39632D312E36373220342E3635332D322E37333320392E352D342E3430362031342E31353320312E3533352D312E35323520322E3837322D332E32333420342E3430';
wwv_flow_imp.g_varchar2_table(50207) := '362D342E3735396C342E34303620342E3736632D312E3439372D342E37312D322E39312D392E3434352D342E3430362D31342E3135357A227D29292C4C696E6B456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E43282273';
wwv_flow_imp.g_varchar2_table(50208) := '7667222C2457287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E363736203043372E3934332E';
wwv_flow_imp.g_varchar2_table(50209) := '3030372E38333420362E34352E3130342031342E3136632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E38372031372E3433342D322E33343420342E3732';
wwv_flow_imp.g_varchar2_table(50210) := '352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220342E3935382032332E3339342E3331332031362E3937382E3033324131382E3533322031382E353332203020303031352E36373620307A6D2E33313720352E';
wwv_flow_imp.g_varchar2_table(50211) := '30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E30323620312E3030372D31302E362D312E3839382D31';
wwv_flow_imp.g_varchar2_table(50212) := '322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D312E373820342E30363576332E35353548392E37373976';
wwv_flow_imp.g_varchar2_table(50213) := '362E37313368372E39393476332E3535346C352E3832382D362E39312D352E3832382D362E3931327A227D29292C4D657373616765456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5557287B786D6C';
wwv_flow_imp.g_varchar2_table(50214) := '6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E363736203043372E3934332E3030372E38333420362E34';
wwv_flow_imp.g_varchar2_table(50215) := '352E3130342031342E3136632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E38372031372E3433342D322E33343420342E3732352D342E303920362E3739';
wwv_flow_imp.g_varchar2_table(50216) := '2D31312E303620342E3731342D31372E3030364332392E323220342E3935382032332E3339342E3331332031362E3937382E3033324131382E3533322031382E353332203020303031352E36373620307A6D2E33313720352E30303663352E3639352D2E';
wwv_flow_imp.g_varchar2_table(50217) := '3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E30323620312E3030372D31302E362D312E3839382D31322E33362D362E3737372D';
wwv_flow_imp.g_varchar2_table(50218) := '312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D2D352E393120352E3434386C362E30343120342E3920362E30342D342E394831302E';
wwv_flow_imp.g_varchar2_table(50219) := '3038347A6D2D312E333420312E31333776392E39326831342E353133762D392E3731386C2D372E31333220352E3738362D372E3338312D352E3938387A227D29292C4D756C7469706C65456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E';
wwv_flow_imp.g_varchar2_table(50220) := '747D293D3E4E432822737667222C4B57287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3637';
wwv_flow_imp.g_varchar2_table(50221) := '36203043372E3934332E3030372E38333420362E34352E3130342031342E3136632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E38372031372E3433342D';
wwv_flow_imp.g_varchar2_table(50222) := '322E33343420342E3732352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220342E3935382032332E3339342E3331332031362E3937382E3033324131382E3532392031382E353239203020303031352E36373620';
wwv_flow_imp.g_varchar2_table(50223) := '307A6D2E33313720352E30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E30323620312E3030372D3130';
wwv_flow_imp.g_varchar2_table(50224) := '2E362D312E3839382D31322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D2E30313120332E3033396C2D37';
wwv_flow_imp.g_varchar2_table(50225) := '2E36313920352E353320322E393120382E393568392E3431386C322E39312D382E39352D372E3631392D352E35337A227D29292C456E644576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4757287B786D6C6E';
wwv_flow_imp.g_varchar2_table(50226) := '733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E38342E30343243382E3635342D2E303120312E3931332035';
wwv_flow_imp.g_varchar2_table(50227) := '2E3433372E342031322E3435342D312E3035372031382E363220312E3535342032352E34393520362E3738342032392E303963352E30373620332E3633362031322E333120332E39322031372E35392E35343420352E3330392D332E32353120382E3433';
wwv_flow_imp.g_varchar2_table(50228) := '352D392E37343420372E3434352D31352E3932314333302E393120372E3330372032352E37393520312E3733382031392E3434322E3432326131362E3036342031362E30363420302030302D332E3630322D2E33387A6D2E33383220352E303163352E32';
wwv_flow_imp.g_varchar2_table(50229) := '382D2E3031372031302E313320342E3335332031302E36363920392E36312E36383720352E3032352D322E3535322031302E3238312D372E3432332031312E3739322D342E37353420312E3631372D31302E3438362D2E3434372D31322E3936322D342E';
wwv_flow_imp.g_varchar2_table(50230) := '3835362D322E37342D342E3537352D312E3537342D31312E30393420322E3736382D31342E32376131312E30352031312E30352030203031362E3934382D322E3237367A227D29292C5369676E616C456E644576656E743A287B7374796C65733A653D7B';
wwv_flow_imp.g_varchar2_table(50231) := '7D2C2E2E2E747D293D3E4E432822737667222C5157287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D';
wwv_flow_imp.g_varchar2_table(50232) := '31352E3637362E30353143372E3934332E3035382E38333420362E3530312E3130342031342E3231632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E3837';
wwv_flow_imp.g_varchar2_table(50233) := '2031372E3433342D322E33343420342E3732352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220352E3030392032332E3339342E3336342031362E3937382E3038334131382E3533322031382E35333220302030';
wwv_flow_imp.g_varchar2_table(50234) := '3031352E3637362E30357A6D2E33313720352E30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E303236';
wwv_flow_imp.g_varchar2_table(50235) := '20312E3030372D31302E362D312E3839382D31322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D2E303036';
wwv_flow_imp.g_varchar2_table(50236) := '20332E343932632D322E32363120342E30372D342E35333220382E3133362D362E3739372031322E3230346831332E3539354C31352E39393920382E35357A227D29292C5465726D696E617465456E644576656E743A287B7374796C65733A653D7B7D2C';
wwv_flow_imp.g_varchar2_table(50237) := '2E2E2E747D293D3E4E432822737667222C5957287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3135';
wwv_flow_imp.g_varchar2_table(50238) := '2E3637362E30353143372E3934332E3035382E38333420362E3530312E3130342031342E3231632D2E37383320362E35363520322E3931322031332E34323720382E3934322031362E32313620352E3620322E3733372031322E37383920312E38372031';
wwv_flow_imp.g_varchar2_table(50239) := '372E3433342D322E33343420342E3732352D342E303920362E37392D31312E303620342E3731342D31372E3030364332392E323220352E3030392032332E3339342E3336342031362E3937382E3038334131382E3533322031382E353332203020303031';
wwv_flow_imp.g_varchar2_table(50240) := '352E3637362E30357A6D2E33313720352E30303663352E3639352D2E3136352031302E39313620342E3835382031302E3938332031302E3535352E32343620352E3231322D332E36372031302E33332D382E3836342031312E3230342D352E3032362031';
wwv_flow_imp.g_varchar2_table(50241) := '2E3030372D31302E362D312E3839382D31322E33362D362E3737372D312E3839342D342E3832362E3033392D31302E39323820342E3634392D31332E34366131312E3038322031312E3038322030203031352E3539322D312E3532327A6D2E3030362032';
wwv_flow_imp.g_varchar2_table(50242) := '2E383539632D352E3236342D2E322D392E34393520352E3535312D372E3735352031302E35313620312E33363620352E30383520382E31303820372E3433362031322E33333920342E33303120342E3435352D322E38303720342E3730382D392E393433';
wwv_flow_imp.g_varchar2_table(50243) := '2E3436322D31332E30353841382E31323820382E3132382030203030313620372E3931357A227D29292C4576656E7453756250726F636573733A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5A57287B786D6C6E733A22';
wwv_flow_imp.g_varchar2_table(50244) := '687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D372E32393520342E373868312E37373956332E303033682D312E37385634';
wwv_flow_imp.g_varchar2_table(50245) := '2E37387A6D332E353538203068312E37373956332E303033682D312E373856342E37387A6D332E353537203068312E373856332E303033682D312E373856342E37387A6D332E353538203068312E373856332E303033682D312E373856342E37387A6D33';
wwv_flow_imp.g_varchar2_table(50246) := '2E353538203068312E37373956332E303033682D312E37373956342E37387A6D332E3535382030632E35352E30313420312E3130362D2E30333420312E3635342E3034356C2E3234352D312E373632632D2E3632392D2E3039362D312E3236362D2E3035';
wwv_flow_imp.g_varchar2_table(50247) := '2D312E392D2E30363156342E37387A4D352E37333220332E30303461352E39333320352E39333320302030302D2E3931352E303933632E3131312E3538322E32323620312E3136342E33313520312E37352E3335382D2E3130312E3934372E3039382E37';
wwv_flow_imp.g_varchar2_table(50248) := '34362D2E3438332D2E3039362D2E3338322E3136342D312E3230382D2E3134362D312E33367A6D32322E33373220322E323831632E3432372E3233342E3831322E35343720312E31332E3931352E34322D2E3420312E3030322D2E37373720312E33332D';
wwv_flow_imp.g_varchar2_table(50249) := '312E313861352E38363320352E38363320302030302D312E3539332D312E3238396C2D2E38363720312E3535347A6D2D32352E32372D312E3434632D2E3538372E3335342D312E31312E3831312D312E35333920312E3334352E34372E3333332E39362E';
wwv_flow_imp.g_varchar2_table(50250) := '383620312E34313720312E3037372E3239392D2E3336322E36362D2E36373320312E3036352D2E3931332D2E3332382D2E3439332D2E35352D312E3035352D2E3934342D312E3530397A4D33302E35313520372E3236632D2E3536332E3034362D2E3535';
wwv_flow_imp.g_varchar2_table(50251) := '372E3334322D2E3337382E3738342E3135342E32352D2E3039372E3836322E32352E38352E3532352D2E30323320312E31342E30343320312E3631322D2E30333261352E38393120352E38393120302030302D2E3336322D322E3032376C2D312E313232';
wwv_flow_imp.g_varchar2_table(50252) := '2E3432357A4D2E32363820372E31313441362E30343220362E30343220302030303020392E30353268312E3738632D2E3031332D2E352E3034372D312E3030332E3230382D312E3437384C2E32393620372E3032376C2D2E3032362E3037392D2E303032';
wwv_flow_imp.g_varchar2_table(50253) := '2E3030387A4D33302E32322031322E3435483332762D312E373739682D312E37373976312E3737397A6D2D33302E32322E313668312E3738762D312E373739483076312E37387A6D33302E323220332E333938483332762D312E3738682D312E37373976';
wwv_flow_imp.g_varchar2_table(50254) := '312E37387A6D2D33302E32322E313668312E3738762D312E373739483076312E3737397A6D33302E323220332E333938483332762D312E3738682D312E37373976312E37387A6D2D33302E32322E313668312E3738762D312E3738483076312E37387A6D';
wwv_flow_imp.g_varchar2_table(50255) := '33302E323220332E333937483332762D312E373739682D312E37373976312E37387A6D2D33302E32322E313668312E3738762D312E373738483076312E3737387A6D33302E31333720312E343761342E30353920342E30353920302030312D2E35323220';
wwv_flow_imp.g_varchar2_table(50256) := '312E3332632E3530362E32383320312E3034362E37313520312E35332E39303861352E38333620352E38333620302030302E3734342D312E393138632D2E3537362D2E3039342D312E3230392D2E3236342D312E3735322D2E33317A6D2D32392E393834';
wwv_flow_imp.g_varchar2_table(50257) := '2E3531632E3135372E3637362E34333520312E3332352E383220312E3930346C312E3438362D2E39373761342E30363520342E30363520302030312D2E3537372D312E3334376C2D312E37332E34327A6D32382E34323720312E393433632D2E3337312E';
wwv_flow_imp.g_varchar2_table(50258) := '3237372D2E37392E34392D312E3233342E3632376C2E35343820312E36393361352E383420352E38342030203030312E3833352D2E39366C2D312E3038322D312E3431322D2E3036362E30352D2E3030312E3030327A6D2D32362E31363420312E343763';
wwv_flow_imp.g_varchar2_table(50259) := '2E3536372E34313320312E32312E37323220312E3838362E3930372E31342D2E3536392E3334332D312E3137352E3434342D312E37323261342E30363220342E30363220302030312D312E3238332D2E3632346C2D312E30343720312E3433387A6D332E';
wwv_flow_imp.g_varchar2_table(50260) := '383820312E31313968312E373739762D312E3738682D312E373876312E37387A6D332E3535203068312E373837762D312E373848392E38343676312E37387A6D332E353635203068312E3738762D312E3738682D312E373876312E37387A6D332E353538';
wwv_flow_imp.g_varchar2_table(50261) := '203068312E3738762D312E3738682D312E373876312E37387A6D332E343531203068312E373433762D312E3738682D312E37343376312E37387A6D332E363635203068312E373739762D312E3738682D312E373876312E37387A6D2D312E3932322D2E35';
wwv_flow_imp.g_varchar2_table(50262) := '34355631362E37373648392E3834365632392E32356831322E3331387A4D31302E3936372031372E3930356831302E3036385632372E39374831302E3936375631372E3930357A6D312E33333620332E39393876312E37313168372E333936762D312E37';
wwv_flow_imp.g_varchar2_table(50263) := '3131682D372E3339367A222C6F7061636974793A222E3937227D29292C436F6D706C6578476174657761793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5857287B786D6C6E733A22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(50264) := '6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31362E303031203061312E323920312E323920302030302D2E3931372E3337334C2E3337332031352E303834';
wwv_flow_imp.g_varchar2_table(50265) := '61312E33313620312E33313620302030302E30303220312E3833346C31342E37312031342E37303961312E33313320312E3331332030203030312E38333320306C31342E3731312D31342E37313161312E33313620312E33313620302030302D2E303032';
wwv_flow_imp.g_varchar2_table(50266) := '2D312E3833344C31362E3931372E33373241312E32393420312E323934203020303031362E30303220307A4D313620322E3138316C31332E3832312031332E3832314C31362032392E38323320322E3137392031362E30303320313620322E31387A6D2D';
wwv_flow_imp.g_varchar2_table(50267) := '2E33323720362E3739762E3030376C2D2E3134352E3032372D2E3131382E30382D2E3038332E3132332D2E3032382E31343576342E3935344C31312E3739332031302E386C2D2E3132352D2E30382D2E31342D2E3032392D2E3134342E3032372D2E3132';
wwv_flow_imp.g_varchar2_table(50268) := '322E3038322D2E34362E34362D2E3038352E3132352D2E3032362E3134322E3032382E31342E30382E31323520332E35303520332E35303548392E3334376C2D2E3030312D2E3030322D2E3134352E3033322D2E3131382E30382D2E3038332E3132322D';
wwv_flow_imp.g_varchar2_table(50269) := '2E3032382E313436762E3635326C2E3032392E3134372E3038322E3131392E31322E30382E3134342E30333268342E3935364C31302E382032302E323037762D2E3030316C2D2E3038342E3132342D2E3032362E3134322E3032382E31342E30382E3132';
wwv_flow_imp.g_varchar2_table(50270) := '342E34362E3436312E3132362E3038322E31342E3032392E3134332D2E3032372E3132342D2E3038344C31352E332031372E363976342E3936342D2E3030316C2E3032382E3134372E3038322E31322E31322E30382E3134342E303331682E3635326C2E';
wwv_flow_imp.g_varchar2_table(50271) := '3134382D2E30332E3131382D2E30382E3038332D2E31322E3032382D2E313436762D342E3936326C332E35303520332E3530352E3132362E3038322E31342E3032372E3134322D2E3032372E3132342D2E3038342E3436312D2E34362E3038332D2E3132';
wwv_flow_imp.g_varchar2_table(50272) := '33732E3032382D2E3134342E3032372D2E3134366C2D2E3032382D2E31342D2E3038322D2E3132362D332E3439362D332E34393668342E3934386C2E3134382D2E30332E3131392D2E30382E3038322D2E31322E3032382D2E313437762D2E3635326C2D';
wwv_flow_imp.g_varchar2_table(50273) := '2E3032382D2E3134352D2E3038332D2E3132322D2E3131392D2E3038732D2E3134372D2E3033332D2E3134372D2E303331682D342E3936346C332E3531322D332E3531322E3038322D2E3132322E3032392D2E3134342D2E3032382D2E31342D2E303834';
wwv_flow_imp.g_varchar2_table(50274) := '2D2E3132342D2E34362D2E3436312D2E3132332D2E3038322D2E31342D2E3032372D2E3134352E3032372D2E3132322E3038322D332E35303720332E35303756392E3334386C2D2E3032382D2E3134362D2E3038322D2E3132322D2E31322D2E30382D2E';
wwv_flow_imp.g_varchar2_table(50275) := '3134372D2E303239682D2E3635327A227D29292C4576656E744261736564476174657761793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4A57287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F3230';
wwv_flow_imp.g_varchar2_table(50276) := '30302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3136203061312E323920312E323920302030302D2E3931382E3337334C2E3337312031352E30383461312E33313620312E33';
wwv_flow_imp.g_varchar2_table(50277) := '313620302030302E30303220312E3833346C31342E37312031342E37303961312E33313320312E3331332030203030312E38333320306C31342E3731312D31342E37313161312E33313620312E33313620302030302D2E3030322D312E3833344C31362E';
wwv_flow_imp.g_varchar2_table(50278) := '3931352E33373241312E32393420312E3239342030203030313620307A6D2D2E30303220322E3138316C31332E3832312031332E3832312D31332E3832312031332E3832312D31332E3832312D31332E38324C31352E39393820322E31387A6D3020352E';
wwv_flow_imp.g_varchar2_table(50279) := '3837366C2D2E3235342E3138352D372E33373720352E33353520322E39313520382E39363468392E3433336C322E3931352D382E3936342D372E3633312D352E35347A6D3020312E30376C362E36313420342E382D322E35323620372E373639682D382E';
wwv_flow_imp.g_varchar2_table(50280) := '3137356C2D322E3532362D372E37363820362E3631342D342E3830327A227D29292C4578636C7573697665476174657761793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C696A287B786D6C6E733A22687474703A2F2F';
wwv_flow_imp.g_varchar2_table(50281) := '7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3136203061312E323920312E323920302030302D2E3931382E3337334C2E3337312031352E';
wwv_flow_imp.g_varchar2_table(50282) := '30383461312E33313620312E33313620302030302E30303220312E3833346C31342E37312031342E37303961312E33313320312E3331332030203030312E38333320306C31342E3731312D31342E37313161312E33313620312E33313620302030302D2E';
wwv_flow_imp.g_varchar2_table(50283) := '3030322D312E3833344C31362E3931352E33373241312E32393420312E3239342030203030313620307A6D2D2E30303220322E3138316C31332E3832312031332E3832312D31332E3832312031332E3832312D31332E3832312D31332E38324C31352E39';
wwv_flow_imp.g_varchar2_table(50284) := '393820322E31387A6D2D352E31363220372E36396C2D2E3136362E3033322D2E3134312E3039362D2E3533322E353332732D2E3039372E3134322D2E3039372E3134346C2D2E30332E3136342E3033322E3136322E3039332E31343420342E3835372034';
wwv_flow_imp.g_varchar2_table(50285) := '2E3835382D342E38353520342E383535762D2E3030314C392E392032316C2D2E30332E3136342E3033322E313632732E3039332E3134322E3039332E3134346C2E3533312E3533322E3134362E3039352E3136322E3033322E3136342D2E30332E313434';
wwv_flow_imp.g_varchar2_table(50286) := '2D2E30393720342E3835352D342E38353620342E38353720342E3835372E3134352E3039352E3136322E3033322E3136342D2E30332E3134342D2E3039372E3533312D2E3533322E3039352D2E31342E3033332D2E3136382D2E3033332D2E3136322D2E';
wwv_flow_imp.g_varchar2_table(50287) := '3039352D2E3134364C31372E3134342031362032322031312E3134346C2E3039352D2E31342E3033332D2E3136362D2E3033332D2E3136332D2E3039372D2E3134342D2E3533322D2E3533322D2E31342D2E3039352D2E3136332D2E3033322D2E313636';
wwv_flow_imp.g_varchar2_table(50288) := '2E3033322D2E3134312E3039354C31362031342E3835356C2D342E3835382D342E383538762D2E3030326C2D2E3134342D2E3039322D2E3136322D2E3033327A227D29292C476174657761793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E';
wwv_flow_imp.g_varchar2_table(50289) := '432822737667222C656A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D2E3337332031352E303834';
wwv_flow_imp.g_varchar2_table(50290) := '61312E33313620312E33313620302030302E30303220312E3833346C31342E37312031342E37303961312E33313320312E3331332030203030312E38333320306C31342E3731312D31342E37313161312E33313620312E33313620302030302D2E303032';
wwv_flow_imp.g_varchar2_table(50291) := '2D312E3833344C31362E3931372E33373361312E33313320312E33313320302030302D312E38333320304C2E3337332031352E3038347A6D312E3830362E3931384C313620322E3138326C31332E3832312031332E38324C31362032392E38323320322E';
wwv_flow_imp.g_varchar2_table(50292) := '3137392031362E3030337A227D29292C496E636C7573697665476174657761793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C746A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F7376';
wwv_flow_imp.g_varchar2_table(50293) := '67222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31362E303031203061312E323920312E323920302030302D2E3931372E3337334C2E3337332031352E30383461312E33313620312E3331';
wwv_flow_imp.g_varchar2_table(50294) := '3620302030302E30303220312E3833346C31342E37312031342E37303961312E33313320312E3331332030203030312E38333320306C31342E3731312D31342E37313161312E33313620312E33313620302030302D2E3030322D312E3833344C31362E39';
wwv_flow_imp.g_varchar2_table(50295) := '31372E33373241312E32393420312E323934203020303031362E30303220307A4D313620322E3138316C31332E3832312031332E3832314C31362032392E38323320322E3137392031362E30303320313620322E31387A6D3020362E33373961372E3434';
wwv_flow_imp.g_varchar2_table(50296) := '3720372E34343720302030302D372E343420372E34343141372E34343720372E343437203020303031362032332E34343320372E34343720372E343437203020303032332E34343320313661372E34343720372E34343720302030302D372E3434312D37';
wwv_flow_imp.g_varchar2_table(50297) := '2E3434317A6D30202E38323561362E363120362E36312030203031362E36313720362E36313641362E363120362E3631203020303131362032322E36313820362E363120362E36312030203031392E33383520313620362E363120362E36312030203031';
wwv_flow_imp.g_varchar2_table(50298) := '313620392E3338357A227D29292C506172616C6C656C476174657761793A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6E6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C';
wwv_flow_imp.g_varchar2_table(50299) := '77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31362E303031203061312E323920312E323920302030302D2E3931372E3337334C2E3337332031352E30383461312E33313620312E3331362030';
wwv_flow_imp.g_varchar2_table(50300) := '2030302E30303220312E3833346C31342E37312031342E37303961312E33313320312E3331332030203030312E38333320306C31342E3731312D31342E37313161312E33313620312E33313620302030302D2E3030322D312E3833344C31362E3931372E';
wwv_flow_imp.g_varchar2_table(50301) := '33373241312E32393420312E323934203020303031362E30303220307A4D313620322E3138316C31332E3832312031332E3832314C31362032392E38323320322E3137392031362E30303320313620322E31387A6D2D2E33373720352E3730386C2D2E31';
wwv_flow_imp.g_varchar2_table(50302) := '36382E3033322D2E3133362E3039322D2E3039362E31342D2E3033322E31363876362E383638682D362E38376C2D2E3030322D2E3030322D2E3136362E3033372D2E3133372E303932762D2E3030326C2D2E3039352E3134312D2E3033332E313637762E';
wwv_flow_imp.g_varchar2_table(50303) := '373533732E3033322E3136392E3033342E31376C2E3039342E3133382E3133382E3039322E3136372E30333668362E383776362E3836376C2D2E3030312D2E3030312E3033332E31372E3039352E3133382E3133382E303932732E3136362E3033352E31';
wwv_flow_imp.g_varchar2_table(50304) := '36372E303337682E3735326C2E31372D2E3033362E3133372D2E3039322E3039352D2E3133372E3033332D2E3137762D362E38363768362E3836386C2E31372D2E3033352E3133372D2E3039322E3039352D2E3133372E3033332D2E3137762D2E373533';
wwv_flow_imp.g_varchar2_table(50305) := '732D2E3033332D2E3136352D2E3033322D2E3136376C2D2E3039362D2E31342D2E3133382D2E303933732D2E31372D2E3033372D2E31372D2E3033354831362E383156382E3332336C2D2E3033332D2E3136382D2E3039342D2E31342D2E3133382D2E30';
wwv_flow_imp.g_varchar2_table(50306) := '39322D2E31372D2E303334682D2E3735327A227D29292C47726F75703A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6F6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77';
wwv_flow_imp.g_varchar2_table(50307) := '696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D362E33342E303136632D322E3333332E3032352D342E36383420312E37372D352E323920342E3137432E36303820352E3834382E383820372E3630';
wwv_flow_imp.g_varchar2_table(50308) := '382E38303420392E33313476322E39323268322E303431632E3033382D322E3333322D2E3037362D342E3637332E3036322D3743332E313420332E33353520342E38363920312E39333820362E36343320322E303468382E393536562E303039632D332E';
wwv_flow_imp.g_varchar2_table(50309) := '30383620302D362E3137332D2E30322D392E3235382030762E3030377A6D31332E30393420322E30323368312E3932562E303039682D312E393276322E30337A6D352E373536203063312E3236352D2E30363920322E36362E30343520332E3630322031';
wwv_flow_imp.g_varchar2_table(50310) := '2E30353520312E3033362E39383320312E32303120322E35323320312E31323220332E393176362E33313368322E303738632D2E30332D322E3637372E3036322D352E33362D2E3034372D382E3033322D2E31372D322E3734332D322E36322D352E3131';
wwv_flow_imp.g_varchar2_table(50311) := '312D352E3231352D352E3233362D2E3531312D2E3036342D312E3032372D2E30322D312E35342D2E30333376322E3032337A4D2E3830332031382E33313968322E303431762D322E303236482E38303476322E3032367A6D32392E313120312E30383468';
wwv_flow_imp.g_varchar2_table(50312) := '322E3038762D322E3033682D322E303876322E30337A4D2E3830342032362E313438632E30303420322E32313820312E33393320342E33363620332E33313320352E323820312E3732382E38353320332E3638312E34343820352E3532312E3534342E34';
wwv_flow_imp.g_varchar2_table(50313) := '332D2E31313220312E32392E32333120312E3433352D2E313833762D312E383437632D312E3738382D2E3034332D332E3538342E3039342D352E3336352D2E3038322D312E36372D2E3335342D322E3931392D322E3034382D322E3836332D332E383434';
wwv_flow_imp.g_varchar2_table(50314) := '762D332E363434482E38303476332E3737377A6D32392E31312D2E303638632E303420312E3936312D312E35303820332E3738372D332E33383120332E3834322D312E3935342E30362D332E3931342E30322D352E38372E30323676322E303363322E31';
wwv_flow_imp.g_varchar2_table(50315) := '31382D2E30343220342E3234322E303820362E3335352D2E30363320322E3532342D2E32363420342E3831382D322E36343420342E39342D352E3332332E30382D312E3033392E3031342D322E3038352E3033352D332E313236682D322E30373876322E';
wwv_flow_imp.g_varchar2_table(50316) := '3631337A6D2D31352E30303620352E38393868312E3932762D322E3033682D312E393276322E30337A227D29292C43616E63656C496E7465726D65646961746543617463684576656E743A726A2C436F6D70656E73617465496E7465726D656469617465';
wwv_flow_imp.g_varchar2_table(50317) := '43617463684576656E743A6C6A2C436F6E646974696F6E616C496E7465726D65646961746543617463684576656E743A646A2C4572726F72496E7465726D65646961746543617463684576656E743A756A2C457363616C6174696F6E496E7465726D6564';
wwv_flow_imp.g_varchar2_table(50318) := '6961746543617463684576656E743A676A2C4C696E6B496E7465726D65646961746543617463684576656E743A666A2C4D657373616765496E7465726D65646961746543617463684576656E743A626A2C4D756C7469706C65496E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(50319) := '6543617463684576656E743A796A2C436F6E646974696F6E616C496E7465726D65646961746543617463684576656E744E6F6E496E74657272757074696E673A436A2C457363616C6174696F6E496E7465726D65646961746543617463684576656E744E';
wwv_flow_imp.g_varchar2_table(50320) := '6F6E496E74657272757074696E673A786A2C4D657373616765496E7465726D65646961746543617463684576656E744E6F6E496E74657272757074696E673A456A2C4D756C7469706C65496E7465726D65646961746543617463684576656E744E6F6E49';
wwv_flow_imp.g_varchar2_table(50321) := '6E74657272757074696E673A446A2C506172616C6C656C496E7465726D65646961746543617463684576656E744E6F6E496E74657272757074696E673A496A2C5369676E616C496E7465726D65646961746543617463684576656E744E6F6E496E746572';
wwv_flow_imp.g_varchar2_table(50322) := '72757074696E673A416A2C54696D6572496E7465726D65646961746543617463684576656E744E6F6E496E74657272757074696E673A506A2C506172616C6C656C4D756C7469706C65496E7465726D65646961746543617463684576656E743A526A2C53';
wwv_flow_imp.g_varchar2_table(50323) := '69676E616C496E7465726D65646961746543617463684576656E743A426A2C54696D6572496E7465726D65646961746543617463684576656E743A7A6A2C496E7465726D6564696174655468726F774576656E743A576A2C436F6D70656E73617465496E';
wwv_flow_imp.g_varchar2_table(50324) := '7465726D6564696174655468726F774576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6A6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332';
wwv_flow_imp.g_varchar2_table(50325) := '222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30303343382E3139352D2E3135362E39333520362E32342E3132352031332E393835632D2E38353520362E353520322E3734312031332E343620382E';
wwv_flow_imp.g_varchar2_table(50326) := '37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E3838342032332E3434';
wwv_flow_imp.g_varchar2_table(50327) := '352E3430372031372E3230312E303439632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E363836';
wwv_flow_imp.g_varchar2_table(50328) := '20362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E3137342E3837322031312E36373920342E39383520362E39';
wwv_flow_imp.g_varchar2_table(50329) := '313663322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E31';
wwv_flow_imp.g_varchar2_table(50330) := '32392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E';
wwv_flow_imp.g_varchar2_table(50331) := '3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620342E39373563352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D39';
wwv_flow_imp.g_varchar2_table(50332) := '2E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E303833203020303131';
wwv_flow_imp.g_varchar2_table(50333) := '3620342E3937357A6D2D2E353620352E3737326C2D372E34303820352E32333120372E34303920352E323334762D352E30353763322E33383520312E36383720342E37373120332E33373120372E31353720352E3035375631302E3734376C2D372E3135';
wwv_flow_imp.g_varchar2_table(50334) := '3720352E303535762D352E3035357A227D29292C457363616C6174696F6E496E7465726D6564696174655468726F774576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C716A287B786D6C6E733A22687474703A';
wwv_flow_imp.g_varchar2_table(50335) := '2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E39333520362E3238362E31323520';
wwv_flow_imp.g_varchar2_table(50336) := '31342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E323433';
wwv_flow_imp.g_varchar2_table(50337) := '20342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236';
wwv_flow_imp.g_varchar2_table(50338) := '392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E37';
wwv_flow_imp.g_varchar2_table(50339) := '32382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538';
wwv_flow_imp.g_varchar2_table(50340) := '352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E3937';
wwv_flow_imp.g_varchar2_table(50341) := '20312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E3038322031312E303234';
wwv_flow_imp.g_varchar2_table(50342) := '2031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E38';
wwv_flow_imp.g_varchar2_table(50343) := '38382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D2E30303620332E393237632D312E36373220342E3635342D322E37333420392E3530322D342E3430362031342E31353520312E3533342D312E3532352032';
wwv_flow_imp.g_varchar2_table(50344) := '2E3837322D332E32333420342E3430362D342E3735396C342E34303620342E3736632D312E3439362D342E37312D322E39312D392E3434362D342E3430362D31342E3135367A227D29292C4C696E6B496E7465726D6564696174655468726F774576656E';
wwv_flow_imp.g_varchar2_table(50345) := '743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C246A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E';
wwv_flow_imp.g_varchar2_table(50346) := '43282270617468222C7B643A224D31352E3937352E30343943382E3139352D2E31312E39333520362E3238362E3132352031342E3033632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834';
wwv_flow_imp.g_varchar2_table(50347) := '372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E39332032332E3434352E3435332031372E3230312E303935632D2E3430';
wwv_flow_imp.g_varchar2_table(50348) := '382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D39';
wwv_flow_imp.g_varchar2_table(50349) := '2E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E32322E3837322031312E37323520342E39383520362E39363263322E3633322D332E31373120362E3637312D35';
wwv_flow_imp.g_varchar2_table(50350) := '2E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E3935';
wwv_flow_imp.g_varchar2_table(50351) := '3320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E';
wwv_flow_imp.g_varchar2_table(50352) := '3335372D332E32327A4D313620352E30323163352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D';
wwv_flow_imp.g_varchar2_table(50353) := '31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620352E3032317A6D312E373820342E30393376332E';
wwv_flow_imp.g_varchar2_table(50354) := '35353548392E37383576362E37313468372E39393476332E3535346C352E3832392D362E3931312D352E38332D362E3931327A227D29292C4D657373616765496E7465726D6564696174655468726F774576656E743A287B7374796C65733A653D7B7D2C';
wwv_flow_imp.g_varchar2_table(50355) := '2E2E2E747D293D3E4E432822737667222C556A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3135';
wwv_flow_imp.g_varchar2_table(50356) := '2E3937352E30303343382E3139352D2E3135362E39333520362E32342E3132352031332E393835632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E39392031';
wwv_flow_imp.g_varchar2_table(50357) := '372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E3838342032332E3434352E3430372031372E3230312E303439632D2E3430382D2E30332D2E3831372D2E3034';
wwv_flow_imp.g_varchar2_table(50358) := '362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D352E';
wwv_flow_imp.g_varchar2_table(50359) := '38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E3137342E3837322031312E36373920342E39383520362E39313663322E3633322D332E31373120362E3637312D352E3137342031302E3830392D35';
wwv_flow_imp.g_varchar2_table(50360) := '2E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E31393820';
wwv_flow_imp.g_varchar2_table(50361) := '31312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D313620';
wwv_flow_imp.g_varchar2_table(50362) := '342E39373563352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538372D';
wwv_flow_imp.g_varchar2_table(50363) := '31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620342E3937357A6D2D352E393120352E3437356C362E303420342E39303120362E30';
wwv_flow_imp.g_varchar2_table(50364) := '34322D342E394831302E3038387A6D2D312E33343120312E31333876392E3932316831342E3531345631312E37396C2D372E31333220352E3738372D372E3338322D352E39397A227D29292C4D756C7469706C65496E7465726D6564696174655468726F';
wwv_flow_imp.g_varchar2_table(50365) := '774576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4B6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D';
wwv_flow_imp.g_varchar2_table(50366) := '2C74292C4E43282270617468222C7B643A224D31352E3937352E30303343382E3139352D2E3135362E39333520362E32342E3132352031332E393835632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E3636';
wwv_flow_imp.g_varchar2_table(50367) := '3620322E3834372031332E30313220312E39392031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E3838342032332E3434352E3430372031372E3230312E30';
wwv_flow_imp.g_varchar2_table(50368) := '3439632D2E3430382D2E30332D2E3831372D2E3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031';
wwv_flow_imp.g_varchar2_table(50369) := '322E3739322D392E3238332031342E3836322D352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E3137342E3837322031312E36373920342E39383520362E39313663322E3633322D332E313731';
wwv_flow_imp.g_varchar2_table(50370) := '20362E3637312D352E3137342031302E3830392D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E30';
wwv_flow_imp.g_varchar2_table(50371) := '33342031322E39353320352E343720312E3139382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D';
wwv_flow_imp.g_varchar2_table(50372) := '332E3231362D382E3335372D332E32327A4D313620342E39373563352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E';
wwv_flow_imp.g_varchar2_table(50373) := '3037352E3636372D31302E3432362D322E3538372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620342E3937357A6D2E30303620';
wwv_flow_imp.g_varchar2_table(50374) := '332E3037336C2D372E363220352E35333220322E393120382E393568392E34326C322E39312D382E39352D372E36322D352E3533327A227D29292C5369676E616C496E7465726D6564696174655468726F774576656E743A287B7374796C65733A653D7B';
wwv_flow_imp.g_varchar2_table(50375) := '7D2C2E2E2E747D293D3E4E432822737667222C476A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D';
wwv_flow_imp.g_varchar2_table(50376) := '31352E3937352E30303343382E3139352D2E3135362E39333520362E32342E3132352031332E393835632D2E38353520362E353520322E3734312031332E343620382E37342031362E33313420352E36363620322E3834372031332E30313220312E3939';
wwv_flow_imp.g_varchar2_table(50377) := '2031372E37312D322E333320342E3734352D342E31363220362E3732372D31312E32343320342E3533322D31372E3230364332392E303920342E3838342032332E3434352E3430372031372E3230312E303439632D2E3430382D2E30332D2E3831372D2E';
wwv_flow_imp.g_varchar2_table(50378) := '3034362D312E3232362D2E3034367A6D2D2E31383120312E37323463372E3133342D2E3236392031332E383420352E36382031342E3339392031322E3830342E36383620362E3238332D332E3236372031322E3739322D392E3238332031342E3836322D';
wwv_flow_imp.g_varchar2_table(50379) := '352E38343720322E3136322D31332E3032352E30362D31362E3535372D352E313431432E3732382031392E3137342E3837322031312E36373920342E39383520362E39313663322E3633322D332E31373120362E3637312D352E3137342031302E383039';
wwv_flow_imp.g_varchar2_table(50380) := '2D352E31397A6D2E32383320312E353533632D362E362D2E32312D31322E36373120352E3538352D31322E37392031322E3138352D2E32393220352E39363420342E3132392031312E3831372031302E3033342031322E39353320352E343720312E3139';
wwv_flow_imp.g_varchar2_table(50381) := '382031312E3538342D312E3631332031342E3032352D362E37303220322E3532352D342E393720312E3339362D31312E3538352D322E3931322D31352E3231362D322E3238322D322E3032312D352E332D332E3231362D382E3335372D332E32327A4D31';
wwv_flow_imp.g_varchar2_table(50382) := '3620342E39373563352E3831382D2E3135342031312E31313720352E3038322031312E3032342031302E3930352E31303320352E3338342D342E32332031302E352D392E3633362031312E3034332D352E3037352E3636372D31302E3432362D322E3538';
wwv_flow_imp.g_varchar2_table(50383) := '372D31312E3838352D372E3535322D312E35332D342E37332E34382D31302E34323820342E3838382D31322E3836344131312E3038332031312E3038332030203031313620342E3937357A6D2E30303620332E3532632D322E32363120342E30372D342E';
wwv_flow_imp.g_varchar2_table(50384) := '35333320382E3133362D362E3739382031322E3230356831332E3539364C31362E30303520382E3439357A227D29292C4C616E653A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C516A287B786D6C6E733A22687474703A';
wwv_flow_imp.g_varchar2_table(50385) := '2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3020377631382E3632683332563748307A6D312E3635352031372E30353656382E3638';
wwv_flow_imp.g_varchar2_table(50386) := '346832382E36327631352E33373248312E3635367A227D29292C4D616E75616C5461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C596A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030';
wwv_flow_imp.g_varchar2_table(50387) := '302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D362E343934203343322E3931362033203020352E393033203020392E3437357631332E333833633020332E35373220322E3931';
wwv_flow_imp.g_varchar2_table(50388) := '3620362E34373520362E34393420362E3437356831392E30313263332E353738203020362E3439342D322E39303320362E3439342D362E34373556392E34373543333220352E3930332032392E30383420332032352E353036203348362E3439347A6D30';
wwv_flow_imp.g_varchar2_table(50389) := '20326831392E3031324332382E303135203520333020362E393820333020392E3437357631332E333833633020322E3439352D312E39383520342E3437352D342E34393420342E34373548362E34393443332E3938352032372E33333320322032352E33';
wwv_flow_imp.g_varchar2_table(50390) := '353320322032322E38353856392E343735433220362E393820332E393835203520362E34393420357A6D342E343320312E333238632D2E3232322E3030352D2E34332E30392D2E3630362E3230332D2E3938352E3633382D342E33353620322E3937372D';
wwv_flow_imp.g_varchar2_table(50391) := '352E30393620332E3438362D2E36372E34362D312E313220312E3135332D312E333820312E3937342D2E32372E3835382D2E32333520312E3739332D2E32333220322E3537362E3030322E35392E30313620312E3130342E313720312E3732372E32322E';
wwv_flow_imp.g_varchar2_table(50392) := '3930382E36333420312E363320312E323320322E3131382E3539372E343920312E3336332E37333220322E32332E37333420332E3033382E30313220362E3037382E30313620392E3131392030202E3332372D2E3030322E3634352D2E3132372E383438';
wwv_flow_imp.g_varchar2_table(50393) := '2D2E33372E3230342D2E3234312E3238372D2E35362E3239312D2E39313461312E37333220312E37333220302030302D2E3039372D2E363235682E333237632E3333352030202E3634312D2E31312E3835322D2E3331362E32312D2E3230362E3331372D';
wwv_flow_imp.g_varchar2_table(50394) := '2E3437352E3337342D2E37353461312E37383320312E37383320302030302D2E3132362D312E31343320312E313820312E313820302030302E3837372D2E353231632E3139362D2E3330362E3235372D2E3636362E3235382D312E3032352E3030312D2E';
wwv_flow_imp.g_varchar2_table(50395) := '3337352D2E3038382D2E3733382D2E3239332D312E30333361312E31373920312E31373920302030302D2E3935382D2E353132682D2E343738632E3130382D2E3233372E3135362D2E3530352E3135352D2E3738322D2E3030332D2E3337332D2E303938';
wwv_flow_imp.g_varchar2_table(50396) := '2D2E3732312D2E3331362D2E393961312E323120312E323120302030302D2E3934332D2E3433632D322E3237332D2E3030342D342E3233362E3031382D362E3431322E3031326C2D2E31392D2E303031632E3130322D2E3130342E3230322D2E3230352E';
wwv_flow_imp.g_varchar2_table(50397) := '3331322D2E3331342E3333372D2E3333362E3636322D2E3635322E38332D2E3836392E342D2E3531362E34362D312E3231352E3132332D312E3732392D2E3137382D2E3237322D2E3433392D2E3435362D2E37322D2E343934612E39332E393320302030';
wwv_flow_imp.g_varchar2_table(50398) := '302D2E3134382D2E3030387A6D2E3032392E3732386C2E3032322E303031632E3035352E3030382E3131352E3032372E3230392E3137322E3133322E3230312E3132362E3630362D2E30392E3838342D2E3037392E3130322D2E3433312E3436352D2E37';
wwv_flow_imp.g_varchar2_table(50399) := '36372E382D2E3333372E3333342D2E3635372E3634332D2E3831352E3833362D2E3135332E3138362D2E3039362E3333382D2E3035362E3433352E30342E3039362E3038352E3231322E3239382E3236332E3036332E3031342E3036362E30312E303836';
wwv_flow_imp.g_varchar2_table(50400) := '2E3031326C2E3036362E30303363322E3432392E30323720342E3938362D2E30303420372E3232332D2E3030332E3139342030202E3239332E3035362E3337392E3136322E3038362E3130352E3135312E3238362E3135332E3533332030202E3235372D';
wwv_flow_imp.g_varchar2_table(50401) := '2E3036352E3436372D2E3135352E35392D2E30392E3132342D2E3138332E3138322D2E33372E3138332D312E3730362D2E3030312D332E3431312D2E3030352D352E3131372D2E303039762E37333163322E32332E30303420342E3436312E303120362E';
wwv_flow_imp.g_varchar2_table(50402) := '3639322E3031322E31372030202E3236352E30362E3336312E322E3039362E3133382E3136342E3336342E3136332E3631352030202E3236382D2E3035382E3530312D2E3134332E3633342D2E3038352E3133322D2E3136322E3139332D2E3338352E31';
wwv_flow_imp.g_varchar2_table(50403) := '39352D322E33322D2E3030312D342E3535342D2E3030362D362E3638382D2E303033762E373363312E393035203020332E3830392E30303320352E3731332E3030312E3139342E3030352E3331362E30392E3431362E32362E3130322E3137332E313531';
wwv_flow_imp.g_varchar2_table(50404) := '2E3434322E3039332E3732382D2E30342E3139332D2E3130322E3331332D2E31372E33382D2E3036372E3036352D2E3134382E3130382D2E3334332E313038682D352E37316C2E3030322E37333463312E343435203020322E38392D2E303120342E3333';
wwv_flow_imp.g_varchar2_table(50405) := '342D2E3030312E3136322030202E3233322E3034312E3239372E3132332E3036342E3038312E3132332E3233382E31322E3438382D2E3030332E3234342D2E3036312E3338352D2E31322E3435352D2E30362E30372D2E3132372E31312D2E3239362E31';
wwv_flow_imp.g_varchar2_table(50406) := '312D332E3033372E3031362D362E3037362E3031322D392E31313320302D2E3733352D2E3030322D312E3331362D2E3139362D312E37372D2E3536382D2E3435342D2E3337322D2E3739332D2E3933352D2E3938362D312E3732382D2E3133342D2E3534';
wwv_flow_imp.g_varchar2_table(50407) := '362D2E3134362D2E3937382D2E3134382D312E3535382D2E3030332D2E3739362D2E3031382D312E3636342E3139392D322E3335342E3232322D2E3730352E3538322D312E323420312E3039362D312E3539332E37352D2E35313520342E31342D322E38';
wwv_flow_imp.g_varchar2_table(50408) := '363620352E3037392D332E343734612E3530342E35303420302030312E3234312D2E3038377A227D29292C4D657373616765466C6F773A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5A6A287B786D6C6E733A22687474';
wwv_flow_imp.g_varchar2_table(50409) := '703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D342E3037332032362E3630376C312E32393520312E3239364C312E333235203332';
wwv_flow_imp.g_varchar2_table(50410) := '6C2D2E3636322D2E3633334C302033302E3733356C342E3037332D342E3132387A6D362E3935332D372E3034366C312E32393620312E3239364C312E3332352033326C372E3535352D372E3635362D312E3239352D312E32393620312E3435352D312E34';
wwv_flow_imp.g_varchar2_table(50411) := '373420312E3938362D322E3031337A4D3332202E3036732D322E36393920352E3138392D352E3431372031302E3436326C2D2E3332362E363333632D312E313420322E3231342D322E32363520342E3430372D332E31373620362E322D312E3232382D31';
wwv_flow_imp.g_varchar2_table(50412) := '2E3232322D322E3434392D322E3435322D332E3637362D332E3637356C2D332E353720332E3631382D312E3239372D312E32393620332E3534312D332E353838632D2E39382D2E3936342D312E3933322D312E3935382D322E3932332D322E39316C2D2E';
wwv_flow_imp.g_varchar2_table(50413) := '3735332D2E37303663322E36382D312E32353820362E3533332D332E31363520392E39352D342E3837366C2E3631372D2E3330394332382E38333820312E363733203332202E3036203332202E30367A6D2D342E31323620342E30366C2D2E3031352E30';
wwv_flow_imp.g_varchar2_table(50414) := '30372D2E3131352E3035372D2E3034382E3032342D2E3131352E3035374C31372E3720392E3137326C352E30313720342E39343820352E3135372D31307A227D29292C5061727469636970616E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D';
wwv_flow_imp.g_varchar2_table(50415) := '3E4E432822737667222C586A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3020357632322E3036';
wwv_flow_imp.g_varchar2_table(50416) := '39683332563548307A6D33302E32373620312E3638347631382E383248362E363256362E3638346832332E3635357A6D2D32382E3632203068332E33317631382E3832682D332E333156362E3638347A227D29292C50726F636573733A287B7374796C65';
wwv_flow_imp.g_varchar2_table(50417) := '733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4A6A287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C';
wwv_flow_imp.g_varchar2_table(50418) := '7B66696C6C52756C653A226576656E6F6464222C643A224D31362E31373720306C2E3133372E303032632E3435322E3030392E392E30333720312E3334322E3038322E3334362E3033362E36322E3330332E36382E3634366C2E34333720322E35333663';
wwv_flow_imp.g_varchar2_table(50419) := '2E3035352E3331392E3239362E35372E3630382E3635352E3938362E32363920312E3932332E36353320322E37393620312E31342E32382E3135352E3632342E3134352E3838352D2E3033396C322E3038332D312E3437612E3737352E37373520302030';
wwv_flow_imp.g_varchar2_table(50420) := '312E3933372E303232632E38362E36393920312E36343520312E34383420322E33343320322E3334332E32322E32372E3232332E3635332E3032332E3933376C2D312E34333920322E303338612E3833332E38333320302030302D2E3033312E38393663';
wwv_flow_imp.g_varchar2_table(50421) := '2E3531322E3838392E393220312E38343620312E32303420322E383535612E3833332E38333320302030302E3635332E3630316C322E3433352E3432632E3334322E3035392E36312E3333332E3634352E3637396131352E3932382031352E3932382030';
wwv_flow_imp.g_varchar2_table(50422) := '2030312E303820322E3036346C2D2E3030332E313134632D2E3031322E3338322D2E3033382E37362D2E30373720312E313334612E3737352E37373520302030312D2E3634352E36386C2D322E3339362E343132612E3833352E38333520302030302D2E';
wwv_flow_imp.g_varchar2_table(50423) := '3635362E36312031322E3531312031322E35313120302030312D312E3220322E3931372E3833322E38333220302030302E3033342E3839326C312E33393620312E393738632E322E3238342E3139362E3636372D2E3032332E3933366131362E31303420';
wwv_flow_imp.g_varchar2_table(50424) := '31362E31303420302030312D322E33343320322E3334332E3737352E37373520302030312D2E3933372E3032336C2D312E39392D312E343034612E3833332E38333320302030302D2E38382D2E303236632D2E3930372E3531362D312E3838362E393232';
wwv_flow_imp.g_varchar2_table(50425) := '2D322E39313620312E32612E3833332E38333320302030302D2E36312E3635366C2D2E34313420322E333936612E3737352E37373520302030312D2E3637392E3634362031362E3039362031362E30393620302030312D332E3331322030202E3737352E';
wwv_flow_imp.g_varchar2_table(50426) := '37373520302030312D2E3637392D2E3634366C2D2E3432332D322E343532612E3833342E38333420302030302D2E3539382D2E3633362031322E3437342031322E34373420302030312D312E3436382D2E3531342031322E34392031322E343920302030';
wwv_flow_imp.g_varchar2_table(50427) := '312D312E3431372D2E36382E3833332E38333320302030302D2E3837382E30336C2D322E30323620312E3433612E3737352E37373520302030312D2E3933372D2E3032332031362E3036392031362E30363920302030312D322E3334322D322E3334322E';
wwv_flow_imp.g_varchar2_table(50428) := '3737342E37373420302030312D2E3032342D2E3933366C312E3430322D312E393836612E3833332E38333320302030302E3033322D2E3839362031322E3530372031322E35303720302030312D312E3231342D322E3931312E3833332E38333320302030';
wwv_flow_imp.g_varchar2_table(50429) := '302D2E3635352D2E3630366C2D322E3338362D2E343132612E3737352E37373520302030312D2E3634362D2E3637382031362E3039372031362E3039372030203031302D332E3331342E3737352E37373520302030312E3634362D2E3637386C322E3338';
wwv_flow_imp.g_varchar2_table(50430) := '362D2E343132612E3833332E38333320302030302E3635352D2E3630362031322E3530372031322E3530372030203031312E3231342D322E3931312E3833332E38333320302030302D2E3033322D2E3839364C332E35353220362E383533612E3737342E';
wwv_flow_imp.g_varchar2_table(50431) := '37373420302030312E3032332D2E3933362031362E3039312031362E3039312030203031322E3334332D322E3334332E3737352E37373520302030312E3933372D2E3032336C322E303320312E343333632E32362E3137372E362E3138322E3837342E30';
wwv_flow_imp.g_varchar2_table(50432) := '32382E3931352D2E35313220312E38382D2E3920322E38372D312E313637612E3833332E38333320302030302E3631322D2E3635366C2E3432342D322E3436612E3737352E37373520302030312E3637392D2E3634354331342E3834352E303332203135';
wwv_flow_imp.g_varchar2_table(50433) := '2E3334382E3030342031352E38352030682E3332367A4D313620362E34632D352E33303220302D392E3620342E3239372D392E3620392E353939203020352E33303220342E32393820392E3620392E3620392E3673392E362D342E32393820392E362D39';
wwv_flow_imp.g_varchar2_table(50434) := '2E362D342E3239382D392E362D392E362D392E367A6D2D3320342E32383363302D312E34323520312E3633372D322E32303320322E3731352D312E32396C352E363920342E383135632E3739342E3637322E37393420312E3931203020322E3538336C2D';
wwv_flow_imp.g_varchar2_table(50435) := '352E363920342E383135632D312E3037382E3931332D322E3731352E3133342D322E3731352D312E32397A227D29292C526563656976655461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6571287B786D6C6E73';
wwv_flow_imp.g_varchar2_table(50436) := '3A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D362E343934203343322E3931362033203020352E393033203020392E';
wwv_flow_imp.g_varchar2_table(50437) := '3437357631332E333833633020332E35373220322E39313620362E34373520362E34393420362E3437356831392E30313263332E353738203020362E3439342D322E39303320362E3439342D362E34373556392E34373543333220352E3930332032392E';
wwv_flow_imp.g_varchar2_table(50438) := '30383420332032352E353036203348362E3439347A6D3020326831392E3031324332382E303135203520333020362E393820333020392E3437357631332E333833633020322E3439352D312E39383520342E3437352D342E34393420342E34373548362E';
wwv_flow_imp.g_varchar2_table(50439) := '34393443332E3938352032372E33333320322032352E33353320322032322E38353856392E343735433220362E393820332E393835203520362E34393420357A4D352E323320372E3736347631312E3537376831372E353556372E37363448352E32337A';
wwv_flow_imp.g_varchar2_table(50440) := '6D312E3831362E3735386831332E3931376C2D362E39353920342E3537372D362E3935382D342E3537377A6D2D312E30362E32316C382E30313820352E32373420382E3031382D352E32373576392E38353348352E39383756382E37337A227D29292C53';
wwv_flow_imp.g_varchar2_table(50441) := '63726970745461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7471287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A2233';
wwv_flow_imp.g_varchar2_table(50442) := '32227D2C74292C4E43282270617468222C7B643A224D362E343934203343322E3931362033203020352E393033203020392E3437357631332E333833633020332E35373220322E39313620362E34373520362E34393420362E3437356831392E30313263';
wwv_flow_imp.g_varchar2_table(50443) := '332E353738203020362E3439342D322E39303320362E3439342D362E34373556392E34373543333220352E3930332032392E30383420332032352E353036203348362E3439347A6D3020326831392E3031324332382E303135203520333020362E393820';
wwv_flow_imp.g_varchar2_table(50444) := '333020392E3437357631332E333833633020322E3439352D312E39383520342E3437352D342E34393420342E34373548362E34393443332E3938352032372E33333320322032352E33353320322032322E38353856392E343735433220362E393820332E';
wwv_flow_imp.g_varchar2_table(50445) := '393835203520362E34393420357A6D322E393920332E3037376C2D2E3037372E3034352D2E3032362E303135632D312E30392E3634362D312E383420312E3233392D322E33333620312E3831382D2E3439362E3537392D2E37333520312E3136322D2E37';
wwv_flow_imp.g_varchar2_table(50446) := '343220312E3732352D2E30313420312E3131392E38313220312E39353820312E35343420322E3730382E3733322E373520312E33383520312E34353620312E34343620322E3034312E3033322E3239382D2E3033392E3539382D2E33363420312E303038';
wwv_flow_imp.g_varchar2_table(50447) := '2D2E3332342E3430382D2E3931312E3839372D312E383520312E3434356C2D312E3338382E38303868382E35366C2E3130312D2E303539632E3939362D2E353820312E3636372D312E31313620322E3039342D312E3635352E3432392D2E35342E363033';
wwv_flow_imp.g_varchar2_table(50448) := '2D312E3130372E3534372D312E3633382D2E31312D312E3035322D2E3936372D312E3831382D312E3638382D322E3535362D2E3732312D2E3733392D312E3330362D312E3433362D312E3239382D322E3039322E3030342D2E3333312E3133322D2E372E';
wwv_flow_imp.g_varchar2_table(50449) := '3533352D312E3137312E3430322D2E343720312E30382D312E303220322E3131392D312E3633366C312E3336322D2E383036682D382E35347A6D2E3234312E38363768352E32373161362E383320362E383320302030302D312E31313320312E3031632D';
wwv_flow_imp.g_varchar2_table(50450) := '2E3439362E35382D2E37333620312E3136332D2E37343320312E3732362D2E30313420312E3131392E38313220312E39353820312E35343420322E3730382E3733322E373520312E33383520312E34353620312E34343620322E3034312E3033322E3239';
wwv_flow_imp.g_varchar2_table(50451) := '382D2E3033392E3539382D2E33363420312E3030382D2E3331322E3339332D2E3837322E3836322D312E37353320312E33383648382E373238632E3336372D2E3238362E3635382D2E3536362E38382D2E3834372E34332D2E35342E3630342D312E3130';
wwv_flow_imp.g_varchar2_table(50452) := '372E3534382D312E3633382D2E31312D312E3035322D2E3936382D312E3831382D312E3638382D322E3535362D2E3732312D2E3733392D312E3330362D312E3433352D312E3239382D322E3039322E3030342D2E3333312E3133322D2E372E3533342D31';
wwv_flow_imp.g_varchar2_table(50453) := '2E3137312E3338392D2E34353420312E30342D2E39383420322E3032312D312E3537357A6D2D312E32333320312E3438762E3468342E3132762D2E34682D342E31327A6D2D2E31353420322E313538762E344831322E36762D2E3448382E33347A6D312E';
wwv_flow_imp.g_varchar2_table(50454) := '39333120322E313538762E3468342E313236762D2E344831302E32377A6D2E353920322E313538762E3468342E323736762D2E34682D342E3237367A227D29292C53656E645461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822';
wwv_flow_imp.g_varchar2_table(50455) := '737667222C6E71287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D362E343934203343322E39313620';
wwv_flow_imp.g_varchar2_table(50456) := '33203020352E393033203020392E3437357631332E333833633020332E35373220322E39313620362E34373520362E34393420362E3437356831392E30313263332E353738203020362E3439342D322E39303320362E3439342D362E34373556392E3437';
wwv_flow_imp.g_varchar2_table(50457) := '3543333220352E3930332032392E30383420332032352E353036203348362E3439347A6D3020326831392E3031324332382E303135203520333020362E393820333020392E3437357631332E333833633020322E3439352D312E39383520342E3437352D';
wwv_flow_imp.g_varchar2_table(50458) := '342E34393420342E34373548362E34393443332E3938352032372E33333320322032352E33353320322032322E38353856392E343735433220362E393820332E393835203520362E34393420357A6D2D312E333820332E31366C382E33333220342E3731';
wwv_flow_imp.g_varchar2_table(50459) := '374C32312E373820382E313648352E3131347A6D2E30323120312E37343576392E3330394832312E3856392E3930356C2D382E33353320342E3635352D382E33312D342E3635357A227D29292C536572766963655461736B3A287B7374796C65733A653D';
wwv_flow_imp.g_varchar2_table(50460) := '7B7D2C2E2E2E747D293D3E4E432822737667222C6971287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A22';
wwv_flow_imp.g_varchar2_table(50461) := '4D362E343934203343322E3931362033203020352E393033203020392E3437357631332E333833633020332E35373220322E39313620362E34373520362E34393420362E3437356831392E30313263332E353738203020362E3439342D322E3930332036';
wwv_flow_imp.g_varchar2_table(50462) := '2E3439342D362E34373556392E34373543333220352E3930332032392E30383420332032352E353036203348362E3439347A6D3020326831392E3031324332382E303135203520333020362E393820333020392E3437357631332E333833633020322E34';
wwv_flow_imp.g_varchar2_table(50463) := '39352D312E39383520342E3437352D342E34393420342E34373548362E34393443332E3938352032372E33333320322032352E33353320322032322E38353856392E343735433220362E393820332E393835203520362E34393420357A6D312E32322031';
wwv_flow_imp.g_varchar2_table(50464) := '2E36383156372E3834632D2E3332392E3039332D2E36332E3232332D2E3931342E3338326C2D2E38332D2E38322D312E35353420312E3536312E38332E3832632D2E31362E3238382D2E3238352E3539342D2E3337322E3931316C2D312E3137372E3030';
wwv_flow_imp.g_varchar2_table(50465) := '3276322E326C312E3138392D2E303034632E3130392E3433312E3334352E3831392E353820312E313635762D312E3839386C2D312E3033382E303034762D2E3733376C312E3033342D2E3030322E3035382D2E323934632E3038342D2E3432392E323532';
wwv_flow_imp.g_varchar2_table(50466) := '2D2E3833382E3439332D312E3230336C2E3136352D2E32352D2E3732372D2E3731382E3532332D2E3532362E3732382E3731392E3234372D2E313635632E3337392D2E32352E3739332D2E34313720312E3230362D2E3530356C2E3239312D2E30362D2E';
wwv_flow_imp.g_varchar2_table(50467) := '3030322D312E3031682E37354C392E313920382E3431374831312E3136632D2E3138352D2E3232312D2E3935312D2E3530382D312E3233372D2E3538384C392E393320362E363848372E3731337A6D322E30373820322E3130356C2E30303320312E3135';
wwv_flow_imp.g_varchar2_table(50468) := '3861342E313920342E313920302030302D2E3931352E3338336C2D2E38332D2E3832312D312E35353320312E3536322E38332E3832632D2E31362E3238382D2E3238362E3539332D2E3337332E39316C2D312E3137362E30303376322E326C312E313838';
wwv_flow_imp.g_varchar2_table(50469) := '2D2E303034632E3039342E3332362E3232342E3632342E3338332E3930356C2D2E38352E38343720312E353720312E3534332E3834372D2E383433632E32392E3136312E3539392E3238362E3931392E33373376312E313938632E3735362E3030362031';
wwv_flow_imp.g_varchar2_table(50470) := '2E35362E30303320322E3230362E3030335631372E383161342E313920342E313920302030302E3931352D2E3338336C2E3834372E38333520312E3535342D312E35362D2E3834382D2E383336632E31362D2E3238382E3238362D2E3539342E3337332D';
wwv_flow_imp.g_varchar2_table(50471) := '2E3931326C312E3135322D2E3030375631322E37356C2D312E3136352E30303761342E303920342E303920302030302D2E3338322D2E3930356C2E3830352D2E3830372D312E35372D312E3534362D2E3830342E38303661342E313620342E3136203020';
wwv_flow_imp.g_varchar2_table(50472) := '30302D2E3931352D2E3337326C2E3030372D312E31343748392E3739327A6D2E3733322E3733682E3735316C2D2E30303620312E3030352E3239372E303538632E34332E3038352E3834342E32353220312E32312E3439326C2E32352E3136322E373031';
wwv_flow_imp.g_varchar2_table(50473) := '2D2E3730342E3532382E35322D2E3730322E3730342E3136392E3235632E3234382E3337342E3431322E3737392E35303520312E3139366C2E3036312E32393220312E3031362D2E303036762E3733376C2D312E30312E3030362D2E3035382E32393263';
wwv_flow_imp.g_varchar2_table(50474) := '2D2E3038352E34332D2E3235322E3833382D2E34393420312E3230356C2D2E3136352E32352E3734342E3733332D2E3532332E3532352D2E3734332D2E3733342D2E3234382E313635632D2E3337382E3234372D2E3738392E3431382D312E3230332E35';
wwv_flow_imp.g_varchar2_table(50475) := '30336C2D2E3239342E30353876312E303637682D2E373435762D312E3035396C2D2E3239352D2E30353761332E33393520332E33393520302030312D312E32312D2E3439326C2D2E3234382D2E3136322D2E3734372E3734332D2E3532382D2E35322E37';
wwv_flow_imp.g_varchar2_table(50476) := '34372D2E3734342D2E31372D2E323561332E35343620332E35343620302030312D2E3530362D312E3139366C2D2E30362D2E3239312D312E30342E303034762D2E3733386C312E3033342D2E3030322E3035382D2E323934632E3038352D2E3432382E32';
wwv_flow_imp.g_varchar2_table(50477) := '35322D2E3833372E3439332D312E3230336C2E3136352D2E32352D2E3732362D2E3731382E3532322D2E3532362E3732382E37322E3234382D2E31363661332E35343620332E3534362030203031312E3230352D2E3530346C2E3239322D2E30362D2E30';
wwv_flow_imp.g_varchar2_table(50478) := '30332D312E30317A6D2E33383820322E36383561312E363520312E363520302030302D312E36343520312E3634356330202E3930342E373420312E36343520312E36343520312E36343561312E363520312E36352030203030312E3634352D312E363435';
wwv_flow_imp.g_varchar2_table(50479) := '20312E363520312E363520302030302D312E3634352D312E3634357A6D30202E3733612E39312E393120302030312E3931352E3931352E39312E393120302030312D2E3931352E3931342E39312E393120302030312D2E3931352D2E3931342E39312E39';
wwv_flow_imp.g_varchar2_table(50480) := '3120302030312E3931352D2E3931357A227D29292C436F6D70656E7361746553746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6F71287B786D6C6E733A22687474703A2F2F7777772E77332E6F72';
wwv_flow_imp.g_varchar2_table(50481) := '672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3939352E30303143392E3730352D2E30383420332E36343320332E39363420312E32353720392E3737352D';
wwv_flow_imp.g_varchar2_table(50482) := '312E3233352031352E3438352E30362032322E35373720342E34322032372E303363342E31393320342E3531332031312E31303220362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636';
wwv_flow_imp.g_varchar2_table(50483) := '342D31342E3236392E3430332D362E3232372D332E32362D31322E34342D382E38372D31352E3135334131352E3932342031352E393234203020303031352E39393420307A6D3020312E373363362E3231332D2E3130382031322E31323220342E333535';
wwv_flow_imp.g_varchar2_table(50484) := '2031332E3732362031302E33353720312E36373820352E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E36323643322E3130312032332E3137312E';
wwv_flow_imp.g_varchar2_table(50485) := '3337372031362E303720322E3834382031302E343463322E31342D352E32303520372E3531352D382E3737342031332E3134372D382E3730387A6D2D2E35363620392E30336C2D372E34313520352E32333520372E34313520352E323338762D352E3036';
wwv_flow_imp.g_varchar2_table(50486) := '3263322E33383620312E36383920342E37373520332E33373520372E31363320352E3036325631302E3736316C2D372E31363320352E303538762D352E3035387A6D2D2E38363620312E36363676372E31334C392E35312031352E3939336C352E303532';
wwv_flow_imp.g_varchar2_table(50487) := '2D332E3536357A6D372E313636203076372E3133376C2D352E3035322D332E35363820352E3035322D332E3536397A227D29292C436F6E646974696F6E616C53746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822';
wwv_flow_imp.g_varchar2_table(50488) := '737667222C7371287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3136203043372E31373420302030';
wwv_flow_imp.g_varchar2_table(50489) := '20372E313734203020313673372E3137342031362031362031362031362D372E3137342031362D31365332342E383236203020313620307A6D3020312E373363372E38393220302031342E323720362E3337382031342E32372031342E3237203020372E';
wwv_flow_imp.g_varchar2_table(50490) := '3839312D362E3337392031342E32372D31342E32372031342E323753312E37332032332E38393120312E373320313643312E373320382E31303820382E31303820312E373320313620312E37337A6D2D352E33363220372E3532337631332E3439336831';
wwv_flow_imp.g_varchar2_table(50491) := '302E37323456392E3235334831302E3633387A6D2E3836332E38363668382E3939355632312E38384831312E3530315631302E31327A6D2E39323820312E333234762E38363368372E313339762D2E383633682D372E3133397A6D3020322E363035762E';
wwv_flow_imp.g_varchar2_table(50492) := '38363768372E313339762D2E383637682D372E3133397A6D3020332E3031762E38363468372E313339762D2E383633682D372E3133397A6D3020322E3732762E38363368372E313339762D2E383633682D372E3133397A227D29292C4572726F72537461';
wwv_flow_imp.g_varchar2_table(50493) := '72744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7271287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A22333222';
wwv_flow_imp.g_varchar2_table(50494) := '7D2C74292C4E43282270617468222C7B643A224D31352E3939352E30303543392E3730352D2E303820332E36343320332E39363820312E32353720392E37382D312E3233352031352E34392E30362032322E35383120342E34322032372E30333463342E';
wwv_flow_imp.g_varchar2_table(50495) := '31393320342E3531332031312E31303220362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636342D31342E3236392E3430332D362E3232372D332E32362D31322E34342D382E38372D31';
wwv_flow_imp.g_varchar2_table(50496) := '352E3135334131352E3932342031352E393234203020303031352E3939342E3030357A6D3020312E373363362E3231332D2E3130382031322E31323220342E3335352031332E3732362031302E33353720312E36373820352E3635332D2E353932203132';
wwv_flow_imp.g_varchar2_table(50497) := '2E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E3632362D342E3831342D332E3833382D362E3533382D31302E3933392D342E3036372D31362E353720322E31342D352E323035';
wwv_flow_imp.g_varchar2_table(50498) := '20372E3531352D382E3737342031332E3134372D382E3730387A6D362E313320372E34356C2D332E36333520372E33372D342E35322D352E3838632D312E333720342E3034382D322E37333820382E3039352D342E3130362031322E3134336C342E3630';
wwv_flow_imp.g_varchar2_table(50499) := '332D352E39313720342E37343820352E34333320322E39312D31332E3134397A6D2D372E37353420332E3838396C342E32393920352E34343920312E3037332D322E33392D312E30323820342E3133352D342E3338372D352E31362D312E373820322E37';
wwv_flow_imp.g_varchar2_table(50500) := '3520312E3832332D342E3738347A227D29292C457363616C6174696F6E53746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6171287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_imp.g_varchar2_table(50501) := '323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3939352E30303143392E3730352D2E30383420332E36343320332E39363420312E32353720392E3737352D312E';
wwv_flow_imp.g_varchar2_table(50502) := '3233352031352E3438352E30362032322E35373720342E34322032372E303363342E31393320342E3531332031312E31303220362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636342D';
wwv_flow_imp.g_varchar2_table(50503) := '31342E3236392E3430332D362E3232372D332E32362D31322E34342D382E38372D31352E3135334131352E3932342031352E393234203020303031352E39393420307A6D3020312E373363362E3231332D2E3130382031322E31323220342E3335352031';
wwv_flow_imp.g_varchar2_table(50504) := '332E3732362031302E33353720312E36373820352E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E36323643322E3130312032332E3137312E3337';
wwv_flow_imp.g_varchar2_table(50505) := '372031362E303720322E3834382031302E343463322E31342D352E32303520372E3531352D382E3737342031332E3134372D382E3730387A6D3020372E313833632D312E36373420342E3635382D322E37333620392E3530392D342E34312031342E3136';
wwv_flow_imp.g_varchar2_table(50506) := '3620312E3533352D312E35323620322E3837342D332E32333620342E34312D342E3736336C342E343120342E373633632D312E3439392D342E3731332D322E3931332D392E3435332D342E34312D31342E3136367A6D2E30333220322E393331632E3832';
wwv_flow_imp.g_varchar2_table(50507) := '3220322E35383820312E35393820352E313920322E343220372E3737386C2D322E34322D322E363135632D2E3638332E3539382D322E34353520322E3838372D322E333420322E33392E3837312D322E34383920312E3434382D352E303720322E33342D';
wwv_flow_imp.g_varchar2_table(50508) := '372E3535337A227D29292C4D65737361676553746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6C71287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77';
wwv_flow_imp.g_varchar2_table(50509) := '696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3939352E30303143392E3730352D2E30383420332E36343320332E39363420312E32353720392E3737352D312E3233352031352E3438352E';
wwv_flow_imp.g_varchar2_table(50510) := '30362032322E35373720342E34322032372E303363342E31393320342E3531332031312E31303220362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636342D31342E3236392E3430332D';
wwv_flow_imp.g_varchar2_table(50511) := '362E3232372D332E32362D31322E34342D382E38372D31352E3135334131352E3932342031352E393234203020303031352E39393420307A6D3020312E373363362E3231332D2E3130382031322E31323220342E3335352031332E3732362031302E3335';
wwv_flow_imp.g_varchar2_table(50512) := '3720312E36373820352E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E36323643322E3130312032332E3137312E3337372031362E303720322E38';
wwv_flow_imp.g_varchar2_table(50513) := '34382031302E343463322E31342D352E32303520372E3531352D382E3737342031332E3134372D382E3730387A6D2D372E32353720382E3733327631312E3036396831342E353133762D31312E303748382E3733387A6D332E32323420312E373368382E';
wwv_flow_imp.g_varchar2_table(50514) := '303634632D312E3432382E3837382D322E38353720322E3830372D342E32383520332E3031386C2D332E3737392D332E3031397A6D392E35363220312E30313776362E3539334831302E3436355631332E32316C352E35323820342E34313720352E3533';
wwv_flow_imp.g_varchar2_table(50515) := '2D342E3431387A227D29292C4D756C7469706C6553746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6371287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F73766722';
wwv_flow_imp.g_varchar2_table(50516) := '2C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3939352E30303143392E3730352D2E30383420332E36343320332E39363420312E32353720392E3737352D312E3233352031352E3438';
wwv_flow_imp.g_varchar2_table(50517) := '352E30362032322E35373720342E34322032372E303363342E31393320342E3531332031312E31303220362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636342D31342E3236392E3430';
wwv_flow_imp.g_varchar2_table(50518) := '332D362E3232372D332E32362D31322E34342D382E38372D31352E3135334131352E3932342031352E393234203020303031352E39393420307A6D3020312E373363362E3231332D2E3130382031322E31323220342E3335352031332E3732362031302E';
wwv_flow_imp.g_varchar2_table(50519) := '33353720312E36373820352E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E36323643322E3130312032332E3137312E3337372031362E30372032';
wwv_flow_imp.g_varchar2_table(50520) := '2E3834382031302E343463322E31342D352E32303520372E3531352D382E3737342031332E3134372D382E3730387A6D3020362E3332386C2D372E36323620352E353336632E393720322E39383620312E39343220352E39373120322E39313320382E39';
wwv_flow_imp.g_varchar2_table(50521) := '353768392E3432366C322E3931322D382E3935372D372E3632352D352E3533367A6D3020312E3036386C362E36303920342E3739382D322E35323520372E3736334831312E39316C2D322E3532342D372E37363320362E3630392D342E3739387A227D29';
wwv_flow_imp.g_varchar2_table(50522) := '292C436F6E646974696F6E616C53746172744576656E744E6F6E496E74657272757074696E673A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6471287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F32';
wwv_flow_imp.g_varchar2_table(50523) := '3030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31302E36333220392E3138395632322E36386831302E37323356392E3138394831302E3633327A6D2E3836322E38363568';
wwv_flow_imp.g_varchar2_table(50524) := '382E3939347631312E37364831312E343934762D31312E37367A6D2E39323820312E333234762E38363368372E313338762D2E383633682D372E3133387A6D3020322E363035762E38363668372E313338762D2E383636682D372E3133387A6D3020332E';
wwv_flow_imp.g_varchar2_table(50525) := '3031762E38363368372E313338762D2E383633682D372E3133387A6D3020322E3732762E38363268372E313338762D2E383633682D372E3133387A4D31362E31322030682D2E3233326C2D2E32322E303034682D2E3031326C2D2E3232312E303036682D';
wwv_flow_imp.g_varchar2_table(50526) := '2E3031326C2D2E32322E3031682D2E3031326C2D2E32322E303133682D2E3031326C2D2E32322E303136682D2E3031326C2D2E32322E303139682D2E3030356C2D2E3030362E3030312D2E32322E303231682D2E3030366C2D2E3030352E3030312D2E32';
wwv_flow_imp.g_varchar2_table(50527) := '322E303235682D2E3031316C2D2E32322E303238682D2E3030356C2D2E3030362E3030322D2E3231392E3033682D2E3030356C2D2E3030362E3030312D2E3231382E3033332D2E3030362E3030312D2E3030362E3030312D2E3231372E3033362D2E3030';
wwv_flow_imp.g_varchar2_table(50528) := '362E3030312D2E3030362E3030312D2E3231372E3033392D2E3030362E3030312D2E3030362E3030312D2E3231362E3034322D2E3030362E3030312D2E3030362E3030312D2E3231352E3034352D2E3030362E3030312D2E3030362E3030322D2E323135';
wwv_flow_imp.g_varchar2_table(50529) := '2E3034372D2E3030362E3030322D2E3030362E3030312D2E3231342E30352D2E3030362E3030322D2E3030362E3030322D2E3131352E3032392D2E3135322E3035332D2E31342E3038312D2E3132322E3130362D2E312E3132362D2E3037352E3134332D';
wwv_flow_imp.g_varchar2_table(50530) := '2E3034372E3135342D2E3031382E31362E3031322E31362E3034322E3135362E30372E3134352E3039352E31332E3131382E31312E3133372E3038362E31352E3035392E3135382E3033682E3136316C2E3133322D2E3032322E31312D2E3032382E3230';
wwv_flow_imp.g_varchar2_table(50531) := '322D2E3034372E3230332D2E3034362E3230382D2E3034332E3230322D2E3033392E3230362D2E3033372E3230362D2E3033342E3230352D2E30332E3230382D2E30332E3230352D2E3032352E3230392D2E3032332E3230382D2E30322E32312D2E3031';
wwv_flow_imp.g_varchar2_table(50532) := '372E3230392D2E3031352E3230372D2E3031312E32312D2E3030392E32312D2E3030362E3230372D2E303033682E32316C2E32312E3030322E3230372E3030352E3230372E3030382E3231322E3031312E3230372E3031342E3230382E3031372E323039';
wwv_flow_imp.g_varchar2_table(50533) := '2E3031392E3230382E3032322E3230352E3032352E3230362E3032382E3230372E30332E3230382E3033352E3230352E3033362E3230322E3033392E3035322E30312E31362E3031382E31362D2E3031322E3135362D2E3034322E3134362D2E30372E31';
wwv_flow_imp.g_varchar2_table(50534) := '332D2E3039362E3130392D2E3131392E3038352D2E3133362E30362D2E31352E30332D2E313539762D2E31366C2D2E30332D2E31362D2E3035392D2E31352D2E3038362D2E3133362D2E3130392D2E3131382D2E31332D2E3039362D2E3134352D2E3037';
wwv_flow_imp.g_varchar2_table(50535) := '2D2E3132382D2E3033382D2E3035372D2E3031312D2E3030362D2E303032682D2E3030366C2D2E3231362D2E3034322D2E3030362D2E3030312D2E3030362D2E3030312D2E3231372D2E3033394831382E396C2D2E3030362D2E3030322D2E3231372D2E';
wwv_flow_imp.g_varchar2_table(50536) := '3033352D2E3030362D2E3030312D2E3030362D2E3030312D2E3231382D2E3033322D2E3030362D2E3030312D2E3030362D2E3030312D2E3231382D2E3033682D2E3030366C2D2E3030362D2E3030312D2E3231392D2E303237682D2E3031316C2D2E3232';
wwv_flow_imp.g_varchar2_table(50537) := '2D2E3032342D2E3030352D2E303031682D2E3030366C2D2E32322D2E303231682D2E3030366C2D2E3030362D2E3030312D2E32322D2E3031372D2E3030352D2E303031682D2E3030364C31372E30362E3033682D2E3031326C2D2E32322D2E303132682D';
wwv_flow_imp.g_varchar2_table(50538) := '2E3031326C2D2E32322D2E3031682D2E3031326C2D2E32322D2E303035682D2E3031324C31362E3133322030682D2E3031327A6D382E37313520322E3738336C2D2E3135372E3033342D2E3134392E3036332D2E3133342E3038392D2E3131362E313132';
wwv_flow_imp.g_varchar2_table(50539) := '2D2E3039322E3133322D2E3036372E3134372D2E3033382E3135372D2E3030382E31362E3032312E31362E3035312E3135332E3037392E3134312E3130332E3132342E3130322E3038372E3035322E303338682E3030316C2E3038372E303634762E3030';
wwv_flow_imp.g_varchar2_table(50540) := '316C2E3038322E3036312E3030322E3030312E3037362E303539682E3030316C2E3038342E3036352E3038322E3036362E3030322E3030312E3037392E3036332E3030322E3030322E3037372E3036332E3038312E3036372E3030322E3030322E303737';
wwv_flow_imp.g_varchar2_table(50541) := '2E3036352E3037362E3036352E3030312E3030322E30382E30372E3037382E3037682E3030326C2E3037352E3036382E3037372E3037322E3030322E3030312E3037332E3036392E3037372E3037332E3037322E30372E3030322E3030312E3037372E30';
wwv_flow_imp.g_varchar2_table(50542) := '37362E30372E3037762E3030316C2E3037352E3037362E30372E3037332E3030322E3030312E3037342E3037392E3030322E3030322E3036392E3037342E3036392E3037352E3037342E3038322E30372E30382E3030322E3030312E3036382E30373968';
wwv_flow_imp.g_varchar2_table(50543) := '2E3030316C2E3036372E3037392E3036382E3038322E3036352E3037382E3030312E3030322E3036382E3038332E3036372E3038342E3036332E3038312E3030312E3030322E3036372E3038372E3030322E3030322E3036332E3038342E3030312E3030';
wwv_flow_imp.g_varchar2_table(50544) := '312E3036342E3038372E3030382E30312E3030382E30312E3039352E31322E3039332E3132312E30392E3131392E3038372E3131392E3038382E3132322E3038362E3132332E3038342E31322E3038312E3132322E3030312E3030322E3038342E313236';
wwv_flow_imp.g_varchar2_table(50545) := '2E30382E3132362E30382E3132372E3037372E3132362E3037392E3133312E3037342E3132372E3037352E3133312E3037332E3133312E30372E31332E30372E3133332E3036392E3133332E3034352E30392E3038362E3133372E3130392E3131392E31';
wwv_flow_imp.g_varchar2_table(50546) := '332E3039362E3134342E30372E3135362E3034322E31362E3031332E31362D2E3031372E3135352D2E3034372E3134332D2E3037352E3132362D2E312E3130362D2E3132312E3038322D2E31342E3035342D2E3135312E3032352D2E31362D2E3030352D';
wwv_flow_imp.g_varchar2_table(50547) := '2E31362D2E3033352D2E3135382D2E30352D2E3132342D2E3034382D2E3039352D2E3030322D2E3030342D2E3030322D2E3030342D2E3037332D2E31342D2E3030322D2E3030352D2E3030322D2E3030342D2E3037342D2E31342D2E3030322D2E303034';
wwv_flow_imp.g_varchar2_table(50548) := '2D2E3030322D2E3030342D2E3037362D2E31342D2E3030322D2E3030332D2E3030322D2E3030342D2E3037372D2E3133392D2E3030332D2E3030342D2E3030322D2E3030342D2E3037382D2E3133382D2E3030332D2E3030342D2E3030322D2E3030332D';
wwv_flow_imp.g_varchar2_table(50549) := '2E30382D2E3133372D2E3030322D2E3030342D2E3030332D2E3030342D2E3038312D2E3133362D2E3030322D2E3030342D2E3030332D2E3030342D2E3038332D2E3133362D2E3030322D2E3030332D2E3030322D2E3030342D2E3038352D2E3133352D2E';
wwv_flow_imp.g_varchar2_table(50550) := '3030322D2E3030342D2E3030332D2E3030332D2E3038352D2E3133342D2E3030332D2E3030342D2E3030322D2E3030342D2E3038372D2E3133322D2E3030332D2E3030342D2E3030332D2E3030342D2E3038382D2E3133322D2E3030332D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50551) := '3030322D2E3030342D2E30392D2E31332D2E3030332D2E3030352D2E3030332D2E3030332D2E3039312D2E31332D2E3030332D2E3030342D2E3030322D2E3030342D2E3039332D2E3132392D2E3030332D2E3030332D2E3030332D2E3030342D2E303934';
wwv_flow_imp.g_varchar2_table(50552) := '2D2E3132382D2E3030332D2E3030342D2E3030332D2E3030332D2E3039352D2E3132372D2E3030332D2E3030342D2E3030332D2E3030342D2E3039372D2E3132352D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E3131342D2E30362D2E';
wwv_flow_imp.g_varchar2_table(50553) := '3038322D2E3030332D2E3030332D2E3030322D2E3030332D2E3036392D2E3039312D2E3030322D2E3030342D2E3030322D2E3030332D2E30372D2E30392D2E3030332D2E3030332D2E3030322D2E3030332D2E30372D2E30392D2E3030332D2E3030332D';
wwv_flow_imp.g_varchar2_table(50554) := '2E3030322D2E3030332D2E3037312D2E30392D2E3030322D2E3030332D2E3030332D2E3030322D2E3037322D2E3038392D2E3030322D2E3030332D2E3030322D2E3030332D2E3037332D2E3038382D2E3030322D2E3030332D2E3030322D2E3030322D2E';
wwv_flow_imp.g_varchar2_table(50555) := '3037342D2E3038372D2E3030322D2E3030332D2E3030322D2E3030332D2E3037342D2E3038362D2E3030332D2E3030332D2E3030322D2E3030332D2E3037342D2E3038362D2E3030332D2E3030322D2E3030322D2E3030332D2E3037352D2E3038352D2E';
wwv_flow_imp.g_varchar2_table(50556) := '3030332D2E3030332D2E3030322D2E3030322D2E3037362D2E3038342D2E3030322D2E3030332D2E3030332D2E3030332D2E3037362D2E3038332D2E3030322D2E3030332D2E3030332D2E3030332D2E3037372D2E3038322D2E3030322D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50557) := '3030332D2E3030322D2E3037372D2E3038322D2E3030332D2E3030332D2E3030332D2E3030322D2E3037382D2E3038312D2E3030322D2E3030332D2E3030332D2E3030332D2E3037382D2E30382D2E3030332D2E3030322D2E3030332D2E3030332D2E30';
wwv_flow_imp.g_varchar2_table(50558) := '37392D2E30382D2E3030322D2E3030322D2E3030332D2E3030322D2E30382D2E30382D2E3030322D2E3030322D2E3030332D2E3030322D2E30382D2E3037382D2E3030332D2E3030332D2E3030332D2E3030322D2E30382D2E3037372D2E3030332D2E30';
wwv_flow_imp.g_varchar2_table(50559) := '30332D2E3030332D2E3030322D2E3038322D2E3037372D2E3030322D2E3030322D2E3030332D2E3030322D2E3038322D2E3037362D2E3030332D2E3030322D2E3030322D2E3030332D2E3038332D2E3037352D2E3030332D2E3030322D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(50560) := '30332D2E3038342D2E3037342D2E3030322D2E3030322D2E3030332D2E3030322D2E3038342D2E3037342D2E3030332D2E3030322D2E3030322D2E3030322D2E3038352D2E3037332D2E3030322D2E3030322D2E3030332D2E3030332D2E3038352D2E30';
wwv_flow_imp.g_varchar2_table(50561) := '37312D2E3030332D2E3030332D2E3030322D2E3030322D2E3038362D2E30372D2E3030332D2E3030332D2E3030322D2E3030322D2E3038362D2E30372D2E3030332D2E3030332D2E3030332D2E3030322D2E3038362D2E30372D2E3030332D2E3030322D';
wwv_flow_imp.g_varchar2_table(50562) := '2E3030332D2E3030322D2E3038372D2E3036392D2E3030322D2E3030322D2E3030332D2E3030322D2E3038382D2E3036382D2E3030322D2E3030322D2E3030332D2E3030322D2E3038382D2E3036372D2E3030332D2E3030332D2E3030332D2E3030322D';
wwv_flow_imp.g_varchar2_table(50563) := '2E3038382D2E3036362D2E3030332D2E3030322D2E3030332D2E3030322D2E3038392D2E3036362D2E3030332D2E3030322D2E3030332D2E3030322D2E3035372D2E3034322D2E31342D2E3038322D2E31352D2E3035352D2E31362D2E3032362D2E3136';
wwv_flow_imp.g_varchar2_table(50564) := '2E3030347A4D362E33373720332E32316C2D2E3135372E3033372D2E3134382E3036362D2E3131312E3037342D2E3030372E3030362D2E3030332E3030322D2E3030332E3030322D2E3038362E3036392D2E3030332E3030322D2E3030322E3030322D2E';
wwv_flow_imp.g_varchar2_table(50565) := '3038362E30372D2E3030332E3030322D2E3030322E3030322D2E3038362E30372D2E3030322E3030332D2E3030332E3030322D2E3038352E3037312D2E3030322E3030322D2E3030332E3030332D2E3038342E3037312D2E3030332E3030332D2E303032';
wwv_flow_imp.g_varchar2_table(50566) := '2E3030322D2E3038342E3037322D2E3030332E3030332D2E3030322E3030322D2E3038332E3037332D2E3030332E3030332D2E3030322E3030322D2E3038332E3037342D2E3030322E3030322D2E3030332E3030332D2E3038322E3037342D2E3030332E';
wwv_flow_imp.g_varchar2_table(50567) := '3030332D2E3030322E3030322D2E3038312E3037362D2E3030332E3030322D2E3030332E3030322D2E30382E3037372D2E3030332E3030322D2E3030332E3030332D2E30382E3037362D2E3030322E3030332D2E3030332E3030322D2E30382E3037382D';
wwv_flow_imp.g_varchar2_table(50568) := '2E3030322E3030322D2E3030332E3030332D2E3037392E3037382D2E3030322E3030332D2E3030332E3030322D2E3037382E30382D2E3030332E3030322D2E3030322E3030322D2E3037382E30382D2E3030322E3030332D2E3030332E3030322D2E3037';
wwv_flow_imp.g_varchar2_table(50569) := '372E30382D2E3030332E3030342D2E3030322E3030322D2E3037372E3038312D2E3030322E3030332D2E3030332E3030332D2E3037362E3038322D2E3030322E3030322D2E3030332E3030332D2E3037352E3038322D2E3030322E3030332D2E3030332E';
wwv_flow_imp.g_varchar2_table(50570) := '3030332D2E3037342E3038332D2E3030332E3030332D2E3030322E3030332D2E3037342E3038342D2E3030332E3030332D2E3030322E3030322D2E3037342E3038352D2E3030322E3030332D2E3030322E3030332D2E3037332E3038352D2E3030332E30';
wwv_flow_imp.g_varchar2_table(50571) := '30332D2E3030322E3030332D2E3037322E3038362D2E3030322E3030332D2E3030332E3030332D2E3037312E3038372D2E3030332E3030332D2E3030322E3030322D2E30372E3038382D2E3030332E3030332D2E3030322E3030332D2E30372E3038382D';
wwv_flow_imp.g_varchar2_table(50572) := '2E3030332E3030332D2E3030322E3030332D2E30372E30392D2E3030322E3030322D2E3030322E3030332D2E3036392E30392D2E3030322E3030332D2E3030332E3030332D2E3036382E30392D2E3030322E3030332D2E3030322E3030332D2E3036372E';
wwv_flow_imp.g_varchar2_table(50573) := '3039322D2E3030332E3030332D2E3030322E3030332D2E3036372E3039322D2E3030322E3030332D2E3030322E3030332D2E3036362E3039322D2E3030322E3030332D2E3030322E3030342D2E3036362E3039332D2E3030322E3030332D2E3030322E30';
wwv_flow_imp.g_varchar2_table(50574) := '30332D2E3036352E3039342D2E3030322E3030332D2E3030322E3030342D2E3036342E3039342D2E3030322E3030332D2E3030322E3030342D2E3036332E3039352D2E3030322E3030332D2E3030322E3030332D2E3036332E3039372D2E3030322E3030';
wwv_flow_imp.g_varchar2_table(50575) := '332D2E3030322E3030332D2E3034362E3037332D2E30352E30372D2E3030332E3030322D2E3030322E3030332D2E3036372E3039332D2E3030332E3030332D2E3030322E3030332D2E3036362E3039342D2E3030322E3030332D2E3030322E3030332D2E';
wwv_flow_imp.g_varchar2_table(50576) := '3036362E3039342D2E3030322E3030332D2E3030322E3030332D2E3036342E3039342D2E3030322E3030342D2E3030322E3030332D2E3036342E3039342D2E3030322E3030342D2E3030322E3030332D2E3036322E3039352D2E3030322E3030332D2E30';
wwv_flow_imp.g_varchar2_table(50577) := '30322E3030332D2E3036322E3039362D2E3030322E3030332D2E3030322E3030332D2E30362E3039362D2E3030332E3030332D2E3030322E3030332D2E30362E3039362D2E3030312E3030342D2E3030322E3030332D2E3035392E3039362D2E3030322E';
wwv_flow_imp.g_varchar2_table(50578) := '3030342D2E3030322E3030332D2E3035382E3039372D2E3030322E3030332D2E3030312E3030332D2E3035372E3039382D2E3030322E3030332D2E3030322E3030332D2E3035362E3039382D2E3030322E3030332D2E3030322E3030332D2E3035352E30';
wwv_flow_imp.g_varchar2_table(50579) := '39382D2E3030322E3030342D2E3030312E3030332D2E3035352E3039382D2E3030312E3030342D2E3030322E3030332D2E3035342E3039392D2E3030312E3030332D2E3030322E3030332D2E3035322E312D2E3030322E3030322D2E3030322E3030342D';
wwv_flow_imp.g_varchar2_table(50580) := '2E3035312E312D2E3030322E3030322D2E3030322E3030342D2E30352E312D2E3030322E3030332D2E3030322E3030332D2E30352E31762E3030336C2D2E3030322E3030342D2E30352E31762E3030336C2D2E3030322E3030342D2E3034382E312D2E30';
wwv_flow_imp.g_varchar2_table(50581) := '30322E3030342D2E3030312E3030332D2E3034372E3130312D2E3030322E3030332D2E3030312E3030342D2E3031332E3032372D2E3035322E3135322D2E3032342E31362E3030362E31362E3033372E3135372E3036342E3134382E3039312E3133332E';
wwv_flow_imp.g_varchar2_table(50582) := '3131342E3131342E3133342E30392E3134372E3036352E3135372E3033362E3136322E3030362E3135392D2E3032342E3135322D2E3035332E31342D2E30382E3132322D2E3130352E312D2E3132362E3036362D2E3131372E30312D2E3032332E303434';
wwv_flow_imp.g_varchar2_table(50583) := '2D2E3039352E3034352D2E3039352E3030322D2E3030332E3034322D2E3038372E3034382D2E3039372E3034382D2E303935762D2E3030316C2E3034382D2E3039322E3030312D2E3030312E3034372D2E30392E30352D2E3039332E3030322D2E303032';
wwv_flow_imp.g_varchar2_table(50584) := '2E3034392D2E30392E3035322D2E3039322E3030312D2E3030322E3035312D2E3038392E3030312D2E3030322E3035312D2E3038372E3035332D2E3038382E3030312D2E3030322E3035352D2E3039312E3035372D2E3039312E3035372D2E30392E3030';
wwv_flow_imp.g_varchar2_table(50585) := '312D2E3030322E3035372D2E3038392E3035352D2E3038332E3030312D2E3030322E30362D2E30392E30362D2E3038382E3036322D2E3038392E3030312D2E3030312E30362D2E3038342E3036332D2E3038382E3036352D2E3038392E3031372D2E3032';
wwv_flow_imp.g_varchar2_table(50586) := '332E3031362D2E3032352E30362D2E3039342E3035392D2E3039762D2E3030326C2E3035382D2E3038362E3035372D2E3038362E3030312D2E3030312E3036322D2E30392E3036322D2E3038382E3030312D2E3030322E30362D2E3038352E3030322D2E';
wwv_flow_imp.g_varchar2_table(50587) := '3030322E30362D2E3038322E3036332D2E3038372E3036342D2E3038342E3030322D2E3030322E3036312D2E30382E3036352D2E3038342E3036342D2E3038762D2E3030316C2E3036372D2E3038332E3036372D2E3038322E30372D2E3038332E303639';
wwv_flow_imp.g_varchar2_table(50588) := '2D2E30382E3036332D2E3037342E3037342D2E3038332E3036382D2E3037372E3030322D2E3030322E30372D2E3037362E30372D2E3037352E3037322D2E3037372E3030312D2E3030312E3036372D2E30372E3037362D2E3037382E3030322D2E303032';
wwv_flow_imp.g_varchar2_table(50589) := '2E30372D2E30372E3037352D2E3037352E3030322D2E3030322E3037322D2E30372E3037352D2E3037322E3030322D2E3030322E3037332D2E3036392E3037342D2E3036382E3030312D2E3030312E30382D2E3037332E3037362D2E3036382E3030322D';
wwv_flow_imp.g_varchar2_table(50590) := '2E3030322E3037322D2E303633762D2E3030316C2E3037382D2E3036372E3037392D2E3036382E3030322D2E3030312E30382D2E3036382E3030322D2E3030322E3037372D2E3036332E3038322D2E3036362E3030312D2E3030312E3037352D2E30362E';
wwv_flow_imp.g_varchar2_table(50591) := '3030322D2E3030322E3030362D2E3030342E3131372D2E3131312E3039342D2E3133312E3036382D2E3134362E30342D2E3135362E30312D2E3136312D2E3031392D2E31362D2E3034392D2E3135342D2E3037362D2E3134312D2E3130322D2E3132352D';
wwv_flow_imp.g_varchar2_table(50592) := '2E3132332D2E3130352D2E31342D2E3037392D2E3135332D2E3035322D2E31362D2E3032332D2E31362E3030377A6D32342E3539362031312E3038386C2D2E3135362E30342D2E3134362E3036372D2E3133312E3039342D2E3131322E3131372D2E3038';
wwv_flow_imp.g_varchar2_table(50593) := '372E3133352D2E3036312E31352D2E3033332E3135372D2E3030342E3133342E3030372E3134322E3030352E3135322E3030342E31352E3030322E313439762E3135336C2E3030312E303131762E3031356C2E3030342E31312E3030322E3131762E3030';
wwv_flow_imp.g_varchar2_table(50594) := '326C2E3030322E313036762E3332316C2D2E3030332E3130322D2E3030322E3130362D2E3030342E3130372D2E3030352E3130352D2E3030362E3130362D2E3030362E3130362D2E3030382E313036762E3030326C2D2E3030382E313033762E3030326C';
wwv_flow_imp.g_varchar2_table(50595) := '2D2E30312E312D2E30312E3130352D2E30312E3130352D2E3031332E3130352D2E3031322E303939762E3030326C2D2E3031342E3130382D2E3031342E312D2E3031362E3130352D2E3031362E313033762E3030326C2D2E3031372E3039392D2E303138';
wwv_flow_imp.g_varchar2_table(50596) := '2E3130342D2E3031392E313033762E3030326C2D2E3031392E3039372D2E30322E3130342D2E3032322E313033762E3030316C2D2E3032322E3039382D2E3032332E313033762E3030326C2D2E3032342E3039362D2E3032352E313033762E3030326C2D';
wwv_flow_imp.g_varchar2_table(50597) := '2E3032342E3039362D2E3032372E313032762E3030336C2D2E3032362E303933762E3030316C2D2E3032392E313033762E3030326C2D2E30332E3039392D2E3032382E303937762E3030326C2D2E30332E3039352D2E30332E303936762E3030316C2D2E';
wwv_flow_imp.g_varchar2_table(50598) := '3033332E312D2E3033312E303935762E3030326C2D2E3033352E31762E3030336C2D2E3033342E303934762E3030336C2D2E3033352E303936762E3030316C2D2E3033342E3039762E3030326C2D2E3033382E3039382D2E3033362E303933762E303032';
wwv_flow_imp.g_varchar2_table(50599) := '6C2D2E3033382E3039352D2E3037392E3139342D2E30382E3138382D2E3038352E3138392D2E3038372E31392D2E30392E3138342D2E3039322E3138332D2E3039352E3138342D2E30352E3039332D2E3036342E3134382D2E3033342E3135382D2E3030';
wwv_flow_imp.g_varchar2_table(50600) := '352E31362E3032362E31362E3035342E3135312E3038322E31342E3130362E31322E3132372E312E3134332E3037352E3135342E3034362E31362E3031372E3136312D2E3031332E3135362D2E3034322E3134342D2E3037312E31332D2E3039362E3130';
wwv_flow_imp.g_varchar2_table(50601) := '392D2E3131392E3037322D2E3131322E3035332D2E3039392E3030332D2E3030352E3030332D2E3030362E3130322D2E3139352E3030332D2E3030362E3030332D2E3030362E3039382D2E3139362E3030332D2E3030362E3030332D2E3030362E303936';
wwv_flow_imp.g_varchar2_table(50602) := '2D2E3139372E3030322D2E3030362E3030332D2E3030362E3039332D2E322E3030322D2E3030362E3030332D2E3030362E30392D2E322E3030322D2E3030362E3030332D2E3030372E3038362D2E3230322E3030332D2E3030362E3030322D2E3030362E';
wwv_flow_imp.g_varchar2_table(50603) := '3038342D2E3230332E3030322D2E3030352E3030312D2E3030352E30342D2E3130322E3030322D2E3030332E3030312D2E3030332E30342D2E3130332E3030312D2E3030332E3030312D2E3030332E30342D2E313033762D2E3030346C2E3030312D2E30';
wwv_flow_imp.g_varchar2_table(50604) := '30332E3033392D2E313033762D2E3030336C2E3030322D2E3030332E3033372D2E3130342E3030312D2E3030332E3030312D2E3030332E3033372D2E313034762D2E3030346C2E3030322D2E3030332E3033352D2E3130342E3030322D2E303033762D2E';
wwv_flow_imp.g_varchar2_table(50605) := '3030346C2E3033352D2E3130342E3030322D2E303034762D2E3030336C2E3033342D2E3130352E3030322D2E303033762D2E3030336C2E3033342D2E313035762D2E3030346C2E3030322D2E3030332E3033322D2E3130362E3030312D2E3030332E3030';
wwv_flow_imp.g_varchar2_table(50606) := '312D2E3030332E3033312D2E3130362E3030312D2E3030332E3030312D2E3030342E3033312D2E3130362E3030312D2E3030332E3030312D2E3030342E30332D2E313036762D2E3030336C2E3030322D2E3030342E3032382D2E3130372E3030312D2E30';
wwv_flow_imp.g_varchar2_table(50607) := '30332E3030312D2E3030332E3032382D2E3130372E3030312D2E3030342E3030312D2E3030332E3032372D2E3130372E3030312D2E303034762D2E3030336C2E3032372D2E3130382E3030312D2E303033762D2E3030346C2E3032362D2E3130382E3030';
wwv_flow_imp.g_varchar2_table(50608) := '312D2E303033762D2E3030346C2E3032352D2E3130382E3030312D2E303033762D2E3030346C2E3032352D2E313038762D2E3030346C2E3030312D2E3030332E3032332D2E313039762D2E3030336C2E3030312D2E3030342E3032322D2E313039762D2E';
wwv_flow_imp.g_varchar2_table(50609) := '3030336C2E3030322D2E3030342E30322D2E3130392E3030312D2E303034762D2E3030336C2E30322D2E31312E3030322D2E303033762D2E3030346C2E30322D2E3131762D2E3030376C2E3031392D2E3131762D2E3030336C2E3030312D2E3030342E30';
wwv_flow_imp.g_varchar2_table(50610) := '31372D2E3131762D2E3030346C2E3030312D2E3030332E3031372D2E3131762D2E3030386C2E3031362D2E3131762D2E3030346C2E3030312D2E3030342E3031352D2E3131762D2E3030386C2E3031352D2E313131762D2E3030386C2E3031332D2E3131';
wwv_flow_imp.g_varchar2_table(50611) := '31762D2E3030376C2E3031332D2E313132762D2E3030376C2E3031312D2E313132762D2E3030346C2E3030312D2E3030342E30312D2E313132762D2E3030376C2E30312D2E313132762D2E3030386C2E3030382D2E313132762D2E3030386C2E3030372D';
wwv_flow_imp.g_varchar2_table(50612) := '2E313133762D2E3030376C2E3030372D2E313133762D2E3030386C2E3030352D2E313133762D2E3030376C2E3030352D2E313134762D2E3030376C2E3030332D2E313134762D2E3030376C2E3030332D2E313134762D2E3132396C2E3030312D2E313134';
wwv_flow_imp.g_varchar2_table(50613) := '762D2E31336C2D2E3030332D2E313134762D2E3030386C2D2E3030332D2E313135762D2E3030376C2D2E3030332D2E313032762D2E3135356C2D2E3030332D2E313538762D2E30316C2D2E3030342D2E313538762D2E30316C2D2E3030362D2E31353876';
wwv_flow_imp.g_varchar2_table(50614) := '2D2E30316C2D2E3030372D2E3134382D2E3032332D2E31362D2E3035312D2E3135322D2E30382D2E31342D2E3130332D2E3132342D2E3132352D2E3130322D2E3134322D2E3037372D2E3135332D2E30352D2E31362D2E30322D2E3136312E30317A6D2D';
wwv_flow_imp.g_varchar2_table(50615) := '33302E3231332E36366C2D2E3135372E3033342D2E3134392E3036332D2E3133342E30392D2E3131352E3131332D2E3039322E3133322D2E3036372E3134372D2E3033372E3135362D2E3030392E3133342E3030312E31315631352E39356C2E3030362E';
wwv_flow_imp.g_varchar2_table(50616) := '3232762E3031326C2E30312E3232762E3031326C2E3031322E3232762E3030366C2E3030312E3030362E3031352E3232762E3030356C2E3030312E3030362E3031382E32322E3030312E303036762E3030366C2E3032322E323139762E3030366C2E3030';
wwv_flow_imp.g_varchar2_table(50617) := '312E3030362E3032342E3231392E3030312E303036762E3030366C2E3032382E3231382E3030312E303036762E3030366C2E3033312E3231382E3030312E3030362E3030312E3030362E3033332E3231382E3030312E3030362E3030312E3030352E3033';
wwv_flow_imp.g_varchar2_table(50618) := '372E323138762E3030366C2E3030322E3030352E30342E323137762E3030366C2E3030312E3030362E3034332E3231362E3030312E3030362E3030312E3030362E3034362E323136762E3030356C2E3030322E3030362E3034382E3231352E3030322E30';
wwv_flow_imp.g_varchar2_table(50619) := '30362E3030312E3030362E3035312E3231342E3030322E303036762E3030366C2E3035352E3231342E3030322E3030352E3030312E3030362E3035372E3231332E3030322E3030362E3030312E3030352E30362E3231332E3030322E3030352E3030312E';
wwv_flow_imp.g_varchar2_table(50620) := '3030362E3036332E3231322E3030322E3030352E3030312E3030362E3036362E32312E3030322E3030362E3030322E3030362E3036382E32312E3030322E3030352E3030322E3030352E30372E32312E3030332E3030352E3030322E3030352E3037342E';
wwv_flow_imp.g_varchar2_table(50621) := '3230382E3030322E3030362E3030322E3030352E3037372E3230372E3030322E3030362E3030322E3030352E30382E3230362E3030322E3030352E3030322E3030362E3038322E3230342E3030322E3030362E3030322E3030352E3038362E3230342E30';
wwv_flow_imp.g_varchar2_table(50622) := '30322E3030352E3030322E3030362E3038382E3230322E3030322E3030352E3030332E3030362E30392E322E3030332E3030362E3030322E3030352E3039342E322E3030322E3030362E3030332E3030352E3039362E3139392E3030322E3030352E3030';
wwv_flow_imp.g_varchar2_table(50623) := '332E3030352E30332E3036322E3038362E3133372E31312E3131382E3132382E3039372E3134352E30372E3135362E3034332E31362E3031332E31362D2E3031372E3135352D2E3034372E3134332D2E3037342E3132372D2E312E3130362D2E3132312E';
wwv_flow_imp.g_varchar2_table(50624) := '3038312D2E31342E3035352D2E31352E3032352D2E31362D2E3030352D2E3136312D2E3033342D2E3135382D2E30352D2E3132342D2E3032382D2E3035352D2E3039322D2E31392D2E3038372D2E3138382D2E3038372D2E3139322D2E3038332D2E3139';
wwv_flow_imp.g_varchar2_table(50625) := '2D2E30382D2E3139332D2E3037382D2E3139342D2E3037362D2E3139362D2E3037332D2E3139352D2E30372D2E3139372D2E3036372D2E3139382D2E3036352D2E3139392D2E3036332D2E322D2E3035392D2E322D2E3035362D2E322D2E3035352D2E32';
wwv_flow_imp.g_varchar2_table(50626) := '30342D2E30352D2E3230312D2E3034392D2E3230322D2E3034362D2E3230352D2E3034332D2E3230362D2E30342D2E3230332D2E3033382D2E3230372D2E3033342D2E3230342D2E3033322D2E3230372D2E3032382D2E3230352D2E3032362D2E323037';
wwv_flow_imp.g_varchar2_table(50627) := '2D2E3032332D2E3230382D2E30322D2E3230372D2E3031382D2E3230372D2E3031342D2E3230382D2E3031312D2E3230372D2E3030392D2E3230382D2E3030352D2E3230372D2E3030322D2E3130342D2E3031372D2E31362D2E3034362D2E3135352D2E';
wwv_flow_imp.g_varchar2_table(50628) := '3037342D2E3134332D2E312D2E3132362D2E3132312D2E3130372D2E3133392D2E3038312D2E3135322D2E3035352D2E3135392D2E3032352D2E3136312E3030347A6D32342E3538352031312E38336C2D2E3135362E3033392D2E3134362E3036382D2E';
wwv_flow_imp.g_varchar2_table(50629) := '31312E3037362D2E3031352E3031322D2E3136332E3132392D2E3136362E3132372D2E3136382E3132352D2E31372E3132342D2E31372E31322D2E3137322E3131382D2E3137332E3131352D2E3137362E3131342D2E3137372E3131312D2E31382E3131';
wwv_flow_imp.g_varchar2_table(50630) := '2D2E3137382E3130352D2E3138322E3130342D2E3138322E3130312D2E3138342E312D2E3138342E3039352D2E3138392E3039352D2E3138362E30392D2E3138382E3038392D2E31392E3038362D2E31392E3038322D2E3139332E3038312D2E3139352E';
wwv_flow_imp.g_varchar2_table(50631) := '3037382D2E3139312E3037342D2E3139372E3037332D2E3139352E30372D2E3139362E3036352D2E3139382E3036342D2E3139382E3036312D2E322E3035382D2E322E3035352D2E322E3035322D2E322E3034392D2E3135312E3033352D2E3135332E30';
wwv_flow_imp.g_varchar2_table(50632) := '352D2E3134312E3037382D2E3132352E3130332D2E3130332E3132342D2E3037382E31342D2E30352E3135342D2E3032322E31362E3030392E31362E3033382E3135372E3036372E3134372E3039332E3133322E3131362E3131322E3133342E3038392E';
wwv_flow_imp.g_varchar2_table(50633) := '3134392E3036322E3135382E3033342E31362E3030332E3133332D2E30322E3135382D2E3033352E3030362D2E3030322E3030362D2E3030312E3231332D2E3035322E3030362D2E3030322E3030372D2E3030312E3231322D2E3035362E3030362D2E30';
wwv_flow_imp.g_varchar2_table(50634) := '30312E3030362D2E3030322E3231322D2E3035382E3030362D2E3030322E3030362D2E3030322E3231312D2E3036312E3030362D2E3030322E3030362D2E3030322E32312D2E3036342E3030362D2E3030322E3030362D2E3030322E32312D2E3036372E';
wwv_flow_imp.g_varchar2_table(50635) := '3030352D2E3030322E3030362D2E3030322E3230382D2E30372E3030362D2E3030322E3030362D2E3030332E3230372D2E3037332E3030362D2E3030322E3030362D2E3030322E3230362D2E3037372E3030362D2E3030322E3030352D2E3030322E3230';
wwv_flow_imp.g_varchar2_table(50636) := '362D2E30382E3030352D2E3030312E3030362D2E3030332E3230342D2E3038322E3030362D2E3030322E3030352D2E3030322E3230332D2E3038352E3030362D2E3030332E3030352D2E3030322E3230322D2E3038382E3030362D2E3030322E3030352D';
wwv_flow_imp.g_varchar2_table(50637) := '2E3030332E322D2E30392E3030362D2E3030332E3030362D2E3030332E322D2E3039332E3030352D2E3030332E3030352D2E3030322E3139382D2E3039362E3030362D2E3030332E3030352D2E3030332E3139372D2E3039392E3030352D2E3030322E30';
wwv_flow_imp.g_varchar2_table(50638) := '30352D2E3030332E3139362D2E3130322E3030352D2E3030322E3030352D2E3030332E3139352D2E3130352E3030352D2E3030322E3030352D2E3030332E3139332D2E3130372E3030352D2E3030332E3030352D2E3030332E3139312D2E31312E303035';
wwv_flow_imp.g_varchar2_table(50639) := '2D2E3030332E3030352D2E3030332E31392D2E3131322E3030352D2E3030332E3030352D2E3030332E3138392D2E3131352E3030352D2E3030332E3030352D2E3030332E3138372D2E3131372E3030352D2E3030332E3030342D2E3030342E3138362D2E';
wwv_flow_imp.g_varchar2_table(50640) := '31322E3030352D2E3030332E3030342D2E3030332E3138342D2E3132322E3030352D2E3030332E3030352D2E3030342E3138322D2E3132352E3030342D2E3030332E3030352D2E3030332E31382D2E3132382E3030352D2E3030332E3030352D2E303033';
wwv_flow_imp.g_varchar2_table(50641) := '2E3137392D2E31332E3030342D2E3030332E3030352D2E3030342E3137372D2E3133322E3030342D2E3030342E3030352D2E3030332E3137352D2E3133352E3030352D2E3030332E3030342D2E3030342E3137332D2E3133372E3030352D2E3030332E30';
wwv_flow_imp.g_varchar2_table(50642) := '30342D2E3030342E3031392D2E3031352E3131352D2E3131332E3039322D2E3133322E3036362D2E3134372E3033382D2E3135372E3030382D2E31362D2E3032322D2E31362D2E3035322D2E3135332D2E3037392D2E31342D2E3130332D2E3132342D2E';
wwv_flow_imp.g_varchar2_table(50643) := '3132352D2E3130322D2E3134322D2E3037382D2E3135332D2E30352D2E31362D2E30322D2E31362E30317A6D2D31392E31372E3035346C2D2E3135332E3035312D2E31342E3037392D2E3132342E3130332D2E3130332E3132352D2E3037372E3134312D';
wwv_flow_imp.g_varchar2_table(50644) := '2E30352E3135332D2E30322E31362E3030392E3136312E30342E3135362E3036372E3134372E3039332E3133312E3039352E3039342E3034372E30342E3030352E3030342E3030352E3030342E31372E31342E3030352E3030342E3030352E3030342E31';
wwv_flow_imp.g_varchar2_table(50645) := '37322E3133372E3030342E3030342E3030352E3030332E3038362E3036372E3030332E3030322E3030332E3030322E3038372E3036372E3030332E3030322E3030332E3030322E3038382E3036362E3030322E3030332E3030332E3030322E3038392E30';
wwv_flow_imp.g_varchar2_table(50646) := '36352E3030322E3030322E3030332E3030322E30392E3036352E3030322E3030322E3030332E3030322E30392E3036342E3030322E3030322E3030332E3030322E30392E3036332E3030332E3030322E3030332E3030322E30392E3036332E3030332E30';
wwv_flow_imp.g_varchar2_table(50647) := '30322E3030332E3030322E3039322E3036322E3030322E3030322E3030332E3030322E3039322E3036312E3030332E3030322E3030332E3030322E3039322E30362E3030332E3030332E3030332E3030312E3039332E30362E3030332E3030322E303033';
wwv_flow_imp.g_varchar2_table(50648) := '2E3030322E3039332E30362E3030332E3030312E3030332E3030322E3039342E3035382E3030332E3030322E3030332E3030322E3039352E3035382E3030332E3030312E3030332E3030322E3039352E3035372E3030332E3030322E3030332E3030322E';
wwv_flow_imp.g_varchar2_table(50649) := '3039352E3035362E3030332E3030322E3030332E3030322E3039362E3035352E3030342E3030322E3030332E3030312E3039362E3035352E3030332E3030322E3030332E3030322E3039382E3035332E3030332E3030322E3030332E3030322E3039372E';
wwv_flow_imp.g_varchar2_table(50650) := '3035332E3030342E3030322E3030332E3030312E3039382E3035332E3030332E3030312E3030332E3030322E3039392E3035322E3030332E3030312E3030332E3030322E312E30352E3030332E3030322E3030332E3030322E312E30352E3030332E3030';
wwv_flow_imp.g_varchar2_table(50651) := '322E3030332E3030312E312E3035682E3030336C2E3030342E3030332E312E3034382E3030342E3030312E3030332E3030322E3130312E3034382E3030332E3030312E3030342E3030322E3130312E3034362E3030342E3030322E3030332E3030312E31';
wwv_flow_imp.g_varchar2_table(50652) := '30322E3034362E3030342E3030322E3030332E3030312E3130332E3034352E3030332E3030322E3030332E3030312E3130332E3034352E3030342E3030312E3030332E3030322E3130342E3034332E3030332E3030312E3030342E3030322E3130342E30';
wwv_flow_imp.g_varchar2_table(50653) := '34322E3030332E3030322E3030342E3030312E3130342E3034322E3030342E3030312E3030332E3030322E3130352E30342E3030342E3030322E3030332E3030312E3130362E30342E3030332E303032682E3030346C2E3130362E30342E3030342E3030';
wwv_flow_imp.g_varchar2_table(50654) := '312E3030332E3030322E3130372E3033382E3030332E3030312E3030342E3030312E3130372E3033382E3030332E3030312E3030342E3030312E3130372E3033372E3030342E3030312E3030342E3030312E3130382E3033362E3030332E3030312E3030';
wwv_flow_imp.g_varchar2_table(50655) := '342E3030312E3130382E3033352E3030342E3030312E3030332E3030312E31312E3033342E3030332E3030312E3030342E3030312E3130392E3033332E3030342E303032682E3030336C2E31312E303333682E3030346C2E3030332E3030322E31312E30';
wwv_flow_imp.g_varchar2_table(50656) := '33312E3030342E3030312E3030342E3030312E3038342E3032332E3038312E3032382E3030342E3030312E3030332E3030312E3130392E3033372E3030332E3030312E3030342E3030312E3130392E3033362E3030332E3030312E3030342E3030312E31';
wwv_flow_imp.g_varchar2_table(50657) := '30392E303335682E3030336C2E3030342E3030322E31312E3033332E3030332E3030312E3030332E3030312E31312E3033332E3030332E3030312E3030342E3030312E3130392E3033312E3030342E303032682E3030336C2E31312E3033312E3030332E';
wwv_flow_imp.g_varchar2_table(50658) := '3030312E3030342E3030312E31312E3033682E3030336C2E3030332E3030312E31312E303239682E3030346C2E3030332E3030322E31312E3032372E3030332E3030312E3030342E3030312E31312E303237682E3030336C2E3030342E3030312E303034';
wwv_flow_imp.g_varchar2_table(50659) := '2E3030312E31362E3032322E31362D2E3030382E3135372D2E3033382E3134372D2E3036372E3133322D2E3039322E3131322D2E3131362E30392D2E3133342E3036322D2E3134392E3033342D2E3135372E3030342D2E3136312D2E3032352D2E31362D';
wwv_flow_imp.g_varchar2_table(50660) := '2E3035352D2E3135312D2E3038322D2E3133392D2E3130372D2E31322D2E3132372D2E312D2E3134332D2E3037342D2E3132342D2E3034682D2E3030336C2D2E3130342D2E3032352D2E3130332D2E303236682D2E3030326C2D2E3039352D2E30323668';
wwv_flow_imp.g_varchar2_table(50661) := '2D2E3030316C2D2E3130312D2E303237682D2E3030326C2D2E312D2E303238682D2E3030326C2D2E3130332D2E30332D2E3130342D2E3033322D2E3039372D2E3033682D2E3030326C2D2E3130332D2E3033332D2E3130322D2E3033332D2E3130312D2E';
wwv_flow_imp.g_varchar2_table(50662) := '3033342D2E3130362D2E3033362D2E3032372D2E30312D2E3032372D2E3030372D2E3130372D2E30332D2E3130342D2E3032392D2E3130342D2E3033682D2E3030326C2D2E3039372D2E30332D2E3130322D2E3033322D2E3130322D2E3033322D2E3130';
wwv_flow_imp.g_varchar2_table(50663) := '322D2E3033342D2E3130332D2E3033352D2E3039362D2E3033342D2E312D2E3033362D2E3130312D2E303337682D2E3030326C2D2E3039342D2E3033362D2E3039362D2E3033372D2E3039372D2E3034682D2E3030326C2D2E3039392D2E30342D2E3039';
wwv_flow_imp.g_varchar2_table(50664) := '382D2E303432682D2E3030326C2D2E3039322D2E30342D2E3039372D2E3034332D2E3039352D2E3034332D2E3039372D2E303434682D2E3030326C2D2E30392D2E3034332D2E3039342D2E3034352D2E3039342D2E3034362D2E3039332D2E3034372D2E';
wwv_flow_imp.g_varchar2_table(50665) := '30392D2E3034362D2E3039362D2E30352D2E3038382D2E3034372D2E3030322D2E3030312D2E30392D2E3034392D2E3039342D2E3035322D2E3030322D2E3030322D2E3038372D2E3034392D2E3038372D2E3035682D2E3030326C2D2E3038382D2E3035';
wwv_flow_imp.g_varchar2_table(50666) := '33682D2E3030316C2D2E30392D2E3035352D2E3038362D2E3035322D2E3030322D2E3030312D2E3038392D2E3035352D2E3038342D2E303534682D2E3030326C2D2E30392D2E303539682D2E3030316C2D2E3038352D2E3035362D2E3030312D2E303031';
wwv_flow_imp.g_varchar2_table(50667) := '2D2E3038342D2E3035362D2E3038322D2E303536682D2E3030316C2D2E3038362D2E30362D2E3038322D2E30353848372E37396C2D2E3038362D2E3036322D2E3030322D2E3030322D2E30382D2E3035382D2E3038312D2E3036682D2E3030316C2D2E30';
wwv_flow_imp.g_varchar2_table(50668) := '38352D2E3036342D2E3030322D2E3030322D2E3037362D2E3035382D2E3030322D2E3030322D2E3038322D2E3036342D2E3136312D2E3132382D2E3136322D2E3133332D2E30342D2E3033342D2E3133322D2E3039322D2E3134372D2E3036362D2E3135';
wwv_flow_imp.g_varchar2_table(50669) := '372D2E3033382D2E31362D2E3030382D2E31362E3032327A227D29292C457363616C6174696F6E53746172744576656E744E6F6E496E74657272757074696E673A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6871287B';
wwv_flow_imp.g_varchar2_table(50670) := '786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D313620392E323039632D312E36373420342E3635352D32';
wwv_flow_imp.g_varchar2_table(50671) := '2E37333520392E3530342D342E3430382031342E313620312E3533342D312E35323620322E3837332D332E32333520342E3430372D342E3736316C342E34303820342E3736632D312E3439372D342E37312D322E39312D392E3434382D342E3430382D31';
wwv_flow_imp.g_varchar2_table(50672) := '342E31367A6D2E30333120322E3933632E38323220322E35383620312E35393820352E31383720322E343220372E3737346C2D322E34322D322E363134632D2E3638322E3539382D322E34353320322E3838362D322E333420322E3338392E3837332D32';
wwv_flow_imp.g_varchar2_table(50673) := '2E34383820312E34352D352E30363820322E33342D372E35357A4D31362E3133322E333634632D312E35312E3031362D332E3035352E3133392D342E3439322E3631342D2E3835342E3434322D2E32363620312E3836312E36353120312E35373820322E';
wwv_flow_imp.g_varchar2_table(50674) := '3236362D2E353820342E3635362D2E35393620362E3934342D2E3134342E3933352E30363320312E32312D312E3339312E3331382D312E3637342D312E3131382D2E32362D322E3237342D2E3336312D332E34322D2E3337347A6D382E38363520322E37';
wwv_flow_imp.g_varchar2_table(50675) := '3737632D2E3933312D2E312D312E32363220312E32392D2E34323520312E36363620312E38363320312E33363420332E32323220332E32393820342E33323220352E3239362E3631372E37333720312E3837352D2E31343520312E3339382D2E3937392D';
wwv_flow_imp.g_varchar2_table(50676) := '312E3138342D322E3237352D322E3830382D342E3338342D342E3932332D352E383636612E3836332E38363320302030302D2E3337322D2E3131377A4D362E353520332E353634632D2E3733342E3037382D312E3139362E3736322D312E37333520312E';
wwv_flow_imp.g_varchar2_table(50677) := '32303643332E35353220362E303220322E353520372E35313120312E36383120392E303533632D2E33312E3533332D2E373120312E33332D2E303320312E3736372E3631352E34333220312E3238322D2E31333220312E3434362D2E3734322E3739362D';
wwv_flow_imp.g_varchar2_table(50678) := '312E34373520312E3734362D322E383920322E3933342D342E30382E34332D2E35343820312E3239322D2E38323220312E33342D312E353935612E3837342E38373420302030302D2E3832322D2E3833397A6D32342E3538322031312E303738632D2E37';
wwv_flow_imp.g_varchar2_table(50679) := '37312D2E3033332D312E3030342E38322D2E38373320312E3433372E313320322E3339352D2E34373120342E3739372D312E36313520362E3839372D2E33332E3837362E39383420312E35353920312E3531322E3738356131342E3237362031342E3237';
wwv_flow_imp.g_varchar2_table(50680) := '362030203030312E3736312D382E35342E3836352E38363520302030302D2E3738352D2E3537397A6D2D33302E3139352E363636632D2E3737342D2E30362D312E3033322E3738352D2E39303520312E3430372E31313720322E34312E37333220342E38';
wwv_flow_imp.g_varchar2_table(50681) := '3120312E38353820362E3934352E3532382E37373420312E38342E303920312E35312D2E3738364131352E3933322031352E3933322030203031312E373238203136612E3837362E38373620302030302D2E37392D2E3639327A6D32342E35372031312E';
wwv_flow_imp.g_varchar2_table(50682) := '383137632D2E3736322E3039392D312E3234332E3833352D312E39313920312E31362D312E35313420312E3030322D332E32333720312E3633322D342E39373820322E3039322D2E3836342E3432332D2E33303720312E3835352E36313620312E353931';
wwv_flow_imp.g_varchar2_table(50683) := '20322E3532382D2E35373820342E39332D312E373520362E3931332D332E3432312E3436392D2E3532322E30372D312E34322D2E3633312D312E3432327A6D2D31392E31362E303432632D2E3834352E3030312D312E313220312E3232382D2E33393520';
wwv_flow_imp.g_varchar2_table(50684) := '312E36323820312E36363520312E34303120332E36363720322E33343820352E373620322E3931322E3631382E31373820312E3438322E35363520312E3839332D2E3137372E3335352D2E3632382D2E3232362D312E3239372D2E38372D312E3332362D';
wwv_flow_imp.g_varchar2_table(50685) := '312E3937322D2E3531352D332E3931322D312E3238352D352E352D322E3539342D2E32362D2E3231332D2E3532322D2E3437322D2E3838382D2E3434337A227D29292C4D65737361676553746172744576656E744E6F6E496E74657272757074696E673A';
wwv_flow_imp.g_varchar2_table(50686) := '287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7571287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E4328';
wwv_flow_imp.g_varchar2_table(50687) := '2270617468222C7B643A224D382E3734362031302E3339337631312E3036346831342E3530365631302E33393348382E3734367A6D332E32323320312E37323868382E3036632D312E3432382E3837392D322E38353620322E3830372D342E3238332033';
wwv_flow_imp.g_varchar2_table(50688) := '2E3031386C2D332E3737372D332E3031387A6D392E35353720312E30313876362E35394831302E343733762D362E35396C352E35323520342E34313620352E3532382D342E3431367A4D31362E3133322030632D312E35312E3031362D332E3035352E31';
wwv_flow_imp.g_varchar2_table(50689) := '33392D342E3439322E3631342D2E3835342E3434322D2E32363620312E3836312E36353120312E35373820322E3236362D2E353820342E3635362D2E35393620362E3934342D2E3134342E3933352E30363320312E32312D312E3339312E3331382D312E';
wwv_flow_imp.g_varchar2_table(50690) := '3637342D312E3131382D2E32362D322E3237342D2E3336312D332E34322D2E3337347A6D382E38363520322E373737632D2E3933312D2E312D312E32363220312E32392D2E34323520312E36363620312E38363320312E33363420332E32323220332E32';
wwv_flow_imp.g_varchar2_table(50691) := '393820342E33323220352E3239362E3631372E37333720312E3837352D2E31343520312E3339382D2E3937392D312E3138342D322E3237352D322E3830382D342E3338342D342E3932332D352E383636612E3836332E38363320302030302D2E3337322D';
wwv_flow_imp.g_varchar2_table(50692) := '2E3131377A4D362E353520332E32632D2E3733342E3037382D312E3139362E3736322D312E37333520312E32303643332E35353220352E36353620322E353520372E31343720312E36383120382E3639632D2E33312E3533332D2E373120312E33332D2E';
wwv_flow_imp.g_varchar2_table(50693) := '303320312E3736372E3631352E34333220312E3238322D2E31333220312E3434362D2E3734322E3739362D312E34373520312E3734362D322E383920322E3933342D342E30382E34332D2E35343820312E3239322D2E38323220312E33342D312E353935';
wwv_flow_imp.g_varchar2_table(50694) := '612E3837342E38373420302030302D2E3832322D2E3833397A6D32342E3538322031312E303738632D2E3737312D2E3033332D312E3030342E38322D2E38373320312E3433372E313320322E3339352D2E34373120342E3739372D312E36313520362E38';
wwv_flow_imp.g_varchar2_table(50695) := '39372D2E33332E3837362E39383420312E35353920312E3531322E3738356131342E3237362031342E3237362030203030312E3736312D382E35342E3836352E38363520302030302D2E3738352D2E3537397A6D2D33302E3139352E363636632D2E3737';
wwv_flow_imp.g_varchar2_table(50696) := '342D2E30362D312E3033322E3738352D2E39303520312E3430372E31313720322E34312E37333220342E383120312E38353820362E3934352E3532382E37373420312E38342E303920312E35312D2E3738366131352E3933322031352E39333220302030';
wwv_flow_imp.g_varchar2_table(50697) := '312D312E3637322D362E3837342E3837362E38373620302030302D2E37392D2E3639327A6D32342E35372031312E383137632D2E3736322E3039392D312E3234332E3833352D312E39313920312E31362D312E35313420312E3030322D332E3233372031';
wwv_flow_imp.g_varchar2_table(50698) := '2E3633322D342E39373820322E3039322D2E3836342E3432332D2E33303720312E3835352E36313620312E35393120322E3532382D2E35373820342E39332D312E373520362E3931332D332E3432312E3436392D2E3532322E30372D312E34322D2E3633';
wwv_flow_imp.g_varchar2_table(50699) := '312D312E3432327A6D2D31392E31362E303432632D2E3834352E3030312D312E313220312E3232382D2E33393520312E36323820312E36363520312E34303120332E36363720322E33343820352E373620322E3931322E3631382E31373820312E343832';
wwv_flow_imp.g_varchar2_table(50700) := '2E35363520312E3839332D2E3137372E3335352D2E3632382D2E3232362D312E3239372D2E38372D312E3332362D312E3937322D2E3531352D332E3931322D312E3238352D352E352D322E3539342D2E32362D2E3231332D2E3532322D2E3437322D2E38';
wwv_flow_imp.g_varchar2_table(50701) := '38382D2E3434337A227D29292C4D756C7469706C6553746172744576656E744E6F6E496E74657272757074696E673A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7071287B786D6C6E733A22687474703A2F2F7777772E';
wwv_flow_imp.g_varchar2_table(50702) := '77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D32332E3632312031332E3532344C313620372E39396C2D372E36323220352E35333420322E39313120';
wwv_flow_imp.g_varchar2_table(50703) := '382E39353268392E3432326C322E3931312D382E3935327A6D2D312E3031362E33336C2D322E35323320372E373539682D382E3136356C2D322E3532342D372E37364C313620392E3035396C362E36303620342E3739367A4D31362E3133322030632D31';
wwv_flow_imp.g_varchar2_table(50704) := '2E35312E3031362D332E3035352E3133392D342E3439322E3631342D2E3835342E3434322D2E32363620312E3836312E36353120312E35373820322E3236362D2E353820342E3635362D2E35393620362E3934342D2E3134342E3933352E30363320312E';
wwv_flow_imp.g_varchar2_table(50705) := '32312D312E3339312E3331382D312E3637342D312E3131382D2E32362D322E3237342D2E3336312D332E34322D2E3337347A6D382E38363520322E373737632D2E3933312D2E312D312E32363220312E32392D2E34323520312E36363620312E38363320';
wwv_flow_imp.g_varchar2_table(50706) := '312E33363420332E32323220332E32393820342E33323220352E3239362E3631372E37333720312E3837352D2E31343520312E3339382D2E3937392D312E3138342D322E3237352D322E3830382D342E3338342D342E3932332D352E383636612E383633';
wwv_flow_imp.g_varchar2_table(50707) := '2E38363320302030302D2E3337322D2E3131377A4D362E353520332E32632D2E3733342E3037382D312E3139362E3736322D312E37333520312E32303643332E35353220352E36353620322E353520372E31343720312E36383120382E3639632D2E3331';
wwv_flow_imp.g_varchar2_table(50708) := '2E3533332D2E373120312E33332D2E303320312E3736372E3631352E34333220312E3238322D2E31333220312E3434362D2E3734322E3739362D312E34373520312E3734362D322E383920322E3933342D342E30382E34332D2E35343820312E3239322D';
wwv_flow_imp.g_varchar2_table(50709) := '2E38323220312E33342D312E353935612E3837342E38373420302030302D2E3832322D2E3833397A6D32342E3538322031312E303738632D2E3737312D2E3033332D312E3030342E38322D2E38373320312E3433372E313320322E3339352D2E34373120';
wwv_flow_imp.g_varchar2_table(50710) := '342E3739372D312E36313520362E3839372D2E33332E3837362E39383420312E35353920312E3531322E3738356131342E3237362031342E3237362030203030312E3736312D382E35342E3836352E38363520302030302D2E3738352D2E3537397A6D2D';
wwv_flow_imp.g_varchar2_table(50711) := '33302E3139352E363636632D2E3737342D2E30362D312E3033322E3738352D2E39303520312E3430372E31313720322E34312E37333220342E383120312E38353820362E3934352E3532382E37373420312E38342E303920312E35312D2E373836613135';
wwv_flow_imp.g_varchar2_table(50712) := '2E3933322031352E39333220302030312D312E3637322D362E3837342E3837362E38373620302030302D2E37392D2E3639327A6D32342E35372031312E383137632D2E3736322E3039392D312E3234332E3833352D312E39313920312E31362D312E3531';
wwv_flow_imp.g_varchar2_table(50713) := '3420312E3030322D332E32333720312E3633322D342E39373820322E3039322D2E3836342E3432332D2E33303720312E3835352E36313620312E35393120322E3532382D2E35373820342E39332D312E373520362E3931332D332E3432312E3436392D2E';
wwv_flow_imp.g_varchar2_table(50714) := '3532322E30372D312E34322D2E3633312D312E3432327A6D2D31392E31362E303432632D2E3834352E3030312D312E313220312E3232382D2E33393520312E36323820312E36363520312E34303120332E36363720322E33343820352E373620322E3931';
wwv_flow_imp.g_varchar2_table(50715) := '322E3631382E31373820312E3438322E35363520312E3839332D2E3137372E3335352D2E3632382D2E3232362D312E3239372D2E38372D312E3332362D312E3937322D2E3531352D332E3931322D312E3238352D352E352D322E3539342D2E32362D2E32';
wwv_flow_imp.g_varchar2_table(50716) := '31332D2E3532322D2E3437322D2E3838382D2E3434337A227D29292C506172616C6C656C4D756C7469706C6553746172744576656E744E6F6E496E74657272757074696E673A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E43282273766722';
wwv_flow_imp.g_varchar2_table(50717) := '2C6771287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31332E35303320392E30313676342E343238';
wwv_flow_imp.g_varchar2_table(50718) := '48392E30373576342E393868342E34323876342E34323868342E3938762D342E34323768342E343238762D342E393831682D342E34323756392E303136682D342E3938317A6D2E38332E383368332E333276342E34323868342E34323876332E3332682D';
wwv_flow_imp.g_varchar2_table(50719) := '342E34323876342E343238682D332E3332762D342E34353448392E393035762D332E32393468342E34323856392E3834367A4D31362E31322030682D2E3233326C2D2E32322E303034682D2E3031326C2D2E3232312E303036682D2E3031326C2D2E3232';
wwv_flow_imp.g_varchar2_table(50720) := '2E3031682D2E3031326C2D2E32322E303133682D2E3031326C2D2E32322E303136682D2E3031326C2D2E32322E303139682D2E3030356C2D2E3030362E3030312D2E32322E303231682D2E3030366C2D2E3030352E3030312D2E32322E303235682D2E30';
wwv_flow_imp.g_varchar2_table(50721) := '31316C2D2E32322E303238682D2E3030356C2D2E3030362E3030322D2E3231392E3033682D2E3030356C2D2E3030362E3030312D2E3231382E3033332D2E3030362E3030312D2E3030362E3030312D2E3231372E3033362D2E3030362E3030312D2E3030';
wwv_flow_imp.g_varchar2_table(50722) := '362E3030312D2E3231372E3033392D2E3030362E3030312D2E3030362E3030312D2E3231362E3034322D2E3030362E3030312D2E3030362E3030312D2E3231352E3034352D2E3030362E3030312D2E3030362E3030322D2E3231352E3034372D2E303036';
wwv_flow_imp.g_varchar2_table(50723) := '2E3030322D2E3030362E3030312D2E3231342E30352D2E3030362E3030322D2E3030362E3030322D2E3131352E3032392D2E3135322E3035332D2E31342E3038312D2E3132322E3130362D2E312E3132362D2E3037352E3134332D2E3034372E3135342D';
wwv_flow_imp.g_varchar2_table(50724) := '2E3031382E31362E3031322E31362E3034322E3135362E30372E3134352E3039352E31332E3131382E31312E3133372E3038362E31352E3035392E3135382E3033682E3136316C2E3133322D2E3032322E31312D2E3032382E3230322D2E3034372E3230';
wwv_flow_imp.g_varchar2_table(50725) := '332D2E3034362E3230382D2E3034332E3230322D2E3033392E3230362D2E3033372E3230362D2E3033342E3230352D2E30332E3230382D2E30332E3230352D2E3032352E3230392D2E3032332E3230382D2E30322E32312D2E3031372E3230392D2E3031';
wwv_flow_imp.g_varchar2_table(50726) := '352E3230372D2E3031312E32312D2E3030392E32312D2E3030362E3230372D2E303033682E32316C2E32312E3030322E3230372E3030352E3230372E3030382E3231322E3031312E3230372E3031342E3230382E3031372E3230392E3031392E3230382E';
wwv_flow_imp.g_varchar2_table(50727) := '3032322E3230352E3032352E3230362E3032382E3230372E30332E3230382E3033352E3230352E3033362E3230322E3033392E3035322E30312E31362E3031382E31362D2E3031322E3135362D2E3034322E3134362D2E30372E31332D2E3039362E3130';
wwv_flow_imp.g_varchar2_table(50728) := '392D2E3131392E3038352D2E3133362E30362D2E31352E30332D2E313539762D2E31366C2D2E30332D2E31362D2E3035392D2E31352D2E3038362D2E3133362D2E3130392D2E3131382D2E31332D2E3039362D2E3134352D2E30372D2E3132382D2E3033';
wwv_flow_imp.g_varchar2_table(50729) := '382D2E3035372D2E3031312D2E3030362D2E303032682D2E3030366C2D2E3231362D2E3034322D2E3030362D2E3030312D2E3030362D2E3030312D2E3231372D2E3033394831382E396C2D2E3030362D2E3030322D2E3231372D2E3033352D2E3030362D';
wwv_flow_imp.g_varchar2_table(50730) := '2E3030312D2E3030362D2E3030312D2E3231382D2E3033322D2E3030362D2E3030312D2E3030362D2E3030312D2E3231382D2E3033682D2E3030366C2D2E3030362D2E3030312D2E3231392D2E303237682D2E3031316C2D2E32322D2E3032342D2E3030';
wwv_flow_imp.g_varchar2_table(50731) := '352D2E303031682D2E3030366C2D2E32322D2E303231682D2E3030366C2D2E3030362D2E3030312D2E32322D2E3031372D2E3030352D2E303031682D2E3030364C31372E30362E3033682D2E3031326C2D2E32322D2E303132682D2E3031326C2D2E3232';
wwv_flow_imp.g_varchar2_table(50732) := '2D2E3031682D2E3031326C2D2E32322D2E303035682D2E3031324C31362E3133322030682D2E3031327A6D382E37313520322E3738336C2D2E3135372E3033342D2E3134392E3036332D2E3133342E3038392D2E3131362E3131322D2E3039322E313332';
wwv_flow_imp.g_varchar2_table(50733) := '2D2E3036372E3134372D2E3033382E3135372D2E3030382E31362E3032312E31362E3035312E3135332E3037392E3134312E3130332E3132342E3130322E3038372E3035322E303338682E3030316C2E3038372E303634762E3030316C2E3038322E3036';
wwv_flow_imp.g_varchar2_table(50734) := '312E3030322E3030312E3037362E303539682E3030316C2E3038342E3036352E3038322E3036362E3030322E3030312E3037392E3036332E3030322E3030322E3037372E3036332E3038312E3036372E3030322E3030322E3037372E3036352E3037362E';
wwv_flow_imp.g_varchar2_table(50735) := '3036352E3030312E3030322E30382E30372E3037382E3037682E3030326C2E3037352E3036382E3037372E3037322E3030322E3030312E3037332E3036392E3037372E3037332E3037322E30372E3030322E3030312E3037372E3037362E30372E303776';
wwv_flow_imp.g_varchar2_table(50736) := '2E3030316C2E3037352E3037362E30372E3037332E3030322E3030312E3037342E3037392E3030322E3030322E3036392E3037342E3036392E3037352E3037342E3038322E30372E30382E3030322E3030312E3036382E303739682E3030316C2E303637';
wwv_flow_imp.g_varchar2_table(50737) := '2E3037392E3036382E3038322E3036352E3037382E3030312E3030322E3036382E3038332E3036372E3038342E3036332E3038312E3030312E3030322E3036372E3038372E3030322E3030322E3036332E3038342E3030312E3030312E3036342E303837';
wwv_flow_imp.g_varchar2_table(50738) := '2E3030382E30312E3030382E30312E3039352E31322E3039332E3132312E30392E3131392E3038372E3131392E3038382E3132322E3038362E3132332E3038342E31322E3038312E3132322E3030312E3030322E3038342E3132362E30382E3132362E30';
wwv_flow_imp.g_varchar2_table(50739) := '382E3132372E3037372E3132362E3037392E3133312E3037342E3132372E3037352E3133312E3037332E3133312E30372E31332E30372E3133332E3036392E3133332E3034352E30392E3038362E3133372E3130392E3131392E31332E3039362E313434';
wwv_flow_imp.g_varchar2_table(50740) := '2E30372E3135362E3034322E31362E3031332E31362D2E3031372E3135352D2E3034372E3134332D2E3037352E3132362D2E312E3130362D2E3132312E3038322D2E31342E3035342D2E3135312E3032352D2E31362D2E3030352D2E31362D2E3033352D';
wwv_flow_imp.g_varchar2_table(50741) := '2E3135382D2E30352D2E3132342D2E3034382D2E3039352D2E3030322D2E3030342D2E3030322D2E3030342D2E3037332D2E31342D2E3030322D2E3030352D2E3030322D2E3030342D2E3037342D2E31342D2E3030322D2E3030342D2E3030322D2E3030';
wwv_flow_imp.g_varchar2_table(50742) := '342D2E3037362D2E31342D2E3030322D2E3030332D2E3030322D2E3030342D2E3037372D2E3133392D2E3030332D2E3030342D2E3030322D2E3030342D2E3037382D2E3133382D2E3030332D2E3030342D2E3030322D2E3030332D2E30382D2E3133372D';
wwv_flow_imp.g_varchar2_table(50743) := '2E3030322D2E3030342D2E3030332D2E3030342D2E3038312D2E3133362D2E3030322D2E3030342D2E3030332D2E3030342D2E3038332D2E3133362D2E3030322D2E3030332D2E3030322D2E3030342D2E3038352D2E3133352D2E3030322D2E3030342D';
wwv_flow_imp.g_varchar2_table(50744) := '2E3030332D2E3030332D2E3038352D2E3133342D2E3030332D2E3030342D2E3030322D2E3030342D2E3038372D2E3133322D2E3030332D2E3030342D2E3030332D2E3030342D2E3038382D2E3133322D2E3030332D2E3030332D2E3030322D2E3030342D';
wwv_flow_imp.g_varchar2_table(50745) := '2E30392D2E31332D2E3030332D2E3030352D2E3030332D2E3030332D2E3039312D2E31332D2E3030332D2E3030342D2E3030322D2E3030342D2E3039332D2E3132392D2E3030332D2E3030332D2E3030332D2E3030342D2E3039342D2E3132382D2E3030';
wwv_flow_imp.g_varchar2_table(50746) := '332D2E3030342D2E3030332D2E3030332D2E3039352D2E3132372D2E3030332D2E3030342D2E3030332D2E3030342D2E3039372D2E3132352D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E3131342D2E30362D2E3038322D2E3030332D';
wwv_flow_imp.g_varchar2_table(50747) := '2E3030332D2E3030322D2E3030332D2E3036392D2E3039312D2E3030322D2E3030342D2E3030322D2E3030332D2E30372D2E30392D2E3030332D2E3030332D2E3030322D2E3030332D2E30372D2E30392D2E3030332D2E3030332D2E3030322D2E303033';
wwv_flow_imp.g_varchar2_table(50748) := '2D2E3037312D2E30392D2E3030322D2E3030332D2E3030332D2E3030322D2E3037322D2E3038392D2E3030322D2E3030332D2E3030322D2E3030332D2E3037332D2E3038382D2E3030322D2E3030332D2E3030322D2E3030322D2E3037342D2E3038372D';
wwv_flow_imp.g_varchar2_table(50749) := '2E3030322D2E3030332D2E3030322D2E3030332D2E3037342D2E3038362D2E3030332D2E3030332D2E3030322D2E3030332D2E3037342D2E3038362D2E3030332D2E3030322D2E3030322D2E3030332D2E3037352D2E3038352D2E3030332D2E3030332D';
wwv_flow_imp.g_varchar2_table(50750) := '2E3030322D2E3030322D2E3037362D2E3038342D2E3030322D2E3030332D2E3030332D2E3030332D2E3037362D2E3038332D2E3030322D2E3030332D2E3030332D2E3030332D2E3037372D2E3038322D2E3030322D2E3030332D2E3030332D2E3030322D';
wwv_flow_imp.g_varchar2_table(50751) := '2E3037372D2E3038322D2E3030332D2E3030332D2E3030332D2E3030322D2E3037382D2E3038312D2E3030322D2E3030332D2E3030332D2E3030332D2E3037382D2E30382D2E3030332D2E3030322D2E3030332D2E3030332D2E3037392D2E30382D2E30';
wwv_flow_imp.g_varchar2_table(50752) := '30322D2E3030322D2E3030332D2E3030322D2E30382D2E30382D2E3030322D2E3030322D2E3030332D2E3030322D2E30382D2E3037382D2E3030332D2E3030332D2E3030332D2E3030322D2E30382D2E3037372D2E3030332D2E3030332D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50753) := '3030322D2E3038322D2E3037372D2E3030322D2E3030322D2E3030332D2E3030322D2E3038322D2E3037362D2E3030332D2E3030322D2E3030322D2E3030332D2E3038332D2E3037352D2E3030332D2E3030322D2E3030322D2E3030332D2E3038342D2E';
wwv_flow_imp.g_varchar2_table(50754) := '3037342D2E3030322D2E3030322D2E3030332D2E3030322D2E3038342D2E3037342D2E3030332D2E3030322D2E3030322D2E3030322D2E3038352D2E3037332D2E3030322D2E3030322D2E3030332D2E3030332D2E3038352D2E3037312D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50755) := '3030332D2E3030322D2E3030322D2E3038362D2E30372D2E3030332D2E3030332D2E3030322D2E3030322D2E3038362D2E30372D2E3030332D2E3030332D2E3030332D2E3030322D2E3038362D2E30372D2E3030332D2E3030322D2E3030332D2E303032';
wwv_flow_imp.g_varchar2_table(50756) := '2D2E3038372D2E3036392D2E3030322D2E3030322D2E3030332D2E3030322D2E3038382D2E3036382D2E3030322D2E3030322D2E3030332D2E3030322D2E3038382D2E3036372D2E3030332D2E3030332D2E3030332D2E3030322D2E3038382D2E303636';
wwv_flow_imp.g_varchar2_table(50757) := '2D2E3030332D2E3030322D2E3030332D2E3030322D2E3038392D2E3036362D2E3030332D2E3030322D2E3030332D2E3030322D2E3035372D2E3034322D2E31342D2E3038322D2E31352D2E3035352D2E31362D2E3032362D2E31362E3030347A4D362E33';
wwv_flow_imp.g_varchar2_table(50758) := '373720332E32316C2D2E3135372E3033372D2E3134382E3036362D2E3131312E3037342D2E3030372E3030362D2E3030332E3030322D2E3030332E3030322D2E3038362E3036392D2E3030332E3030322D2E3030322E3030322D2E3038362E30372D2E30';
wwv_flow_imp.g_varchar2_table(50759) := '30332E3030322D2E3030322E3030322D2E3038362E30372D2E3030322E3030332D2E3030332E3030322D2E3038352E3037312D2E3030322E3030322D2E3030332E3030332D2E3038342E3037312D2E3030332E3030332D2E3030322E3030322D2E303834';
wwv_flow_imp.g_varchar2_table(50760) := '2E3037322D2E3030332E3030332D2E3030322E3030322D2E3038332E3037332D2E3030332E3030332D2E3030322E3030322D2E3038332E3037342D2E3030322E3030322D2E3030332E3030332D2E3038322E3037342D2E3030332E3030332D2E3030322E';
wwv_flow_imp.g_varchar2_table(50761) := '3030322D2E3038312E3037362D2E3030332E3030322D2E3030332E3030322D2E30382E3037372D2E3030332E3030322D2E3030332E3030332D2E30382E3037362D2E3030322E3030332D2E3030332E3030322D2E30382E3037382D2E3030322E3030322D';
wwv_flow_imp.g_varchar2_table(50762) := '2E3030332E3030332D2E3037392E3037382D2E3030322E3030332D2E3030332E3030322D2E3037382E30382D2E3030332E3030322D2E3030322E3030322D2E3037382E30382D2E3030322E3030332D2E3030332E3030322D2E3037372E30382D2E303033';
wwv_flow_imp.g_varchar2_table(50763) := '2E3030342D2E3030322E3030322D2E3037372E3038312D2E3030322E3030332D2E3030332E3030332D2E3037362E3038322D2E3030322E3030322D2E3030332E3030332D2E3037352E3038322D2E3030322E3030332D2E3030332E3030332D2E3037342E';
wwv_flow_imp.g_varchar2_table(50764) := '3038332D2E3030332E3030332D2E3030322E3030332D2E3037342E3038342D2E3030332E3030332D2E3030322E3030322D2E3037342E3038352D2E3030322E3030332D2E3030322E3030332D2E3037332E3038352D2E3030332E3030332D2E3030322E30';
wwv_flow_imp.g_varchar2_table(50765) := '30332D2E3037322E3038362D2E3030322E3030332D2E3030332E3030332D2E3037312E3038372D2E3030332E3030332D2E3030322E3030322D2E30372E3038382D2E3030332E3030332D2E3030322E3030332D2E30372E3038382D2E3030332E3030332D';
wwv_flow_imp.g_varchar2_table(50766) := '2E3030322E3030332D2E30372E30392D2E3030322E3030322D2E3030322E3030332D2E3036392E30392D2E3030322E3030332D2E3030332E3030332D2E3036382E30392D2E3030322E3030332D2E3030322E3030332D2E3036372E3039322D2E3030332E';
wwv_flow_imp.g_varchar2_table(50767) := '3030332D2E3030322E3030332D2E3036372E3039322D2E3030322E3030332D2E3030322E3030332D2E3036362E3039322D2E3030322E3030332D2E3030322E3030342D2E3036362E3039332D2E3030322E3030332D2E3030322E3030332D2E3036352E30';
wwv_flow_imp.g_varchar2_table(50768) := '39342D2E3030322E3030332D2E3030322E3030342D2E3036342E3039342D2E3030322E3030332D2E3030322E3030342D2E3036332E3039352D2E3030322E3030332D2E3030322E3030332D2E3036332E3039372D2E3030322E3030332D2E3030322E3030';
wwv_flow_imp.g_varchar2_table(50769) := '332D2E3034362E3037332D2E30352E30372D2E3030332E3030322D2E3030322E3030332D2E3036372E3039332D2E3030332E3030332D2E3030322E3030332D2E3036362E3039342D2E3030322E3030332D2E3030322E3030332D2E3036362E3039342D2E';
wwv_flow_imp.g_varchar2_table(50770) := '3030322E3030332D2E3030322E3030332D2E3036342E3039342D2E3030322E3030342D2E3030322E3030332D2E3036342E3039342D2E3030322E3030342D2E3030322E3030332D2E3036322E3039352D2E3030322E3030332D2E3030322E3030332D2E30';
wwv_flow_imp.g_varchar2_table(50771) := '36322E3039362D2E3030322E3030332D2E3030322E3030332D2E30362E3039362D2E3030332E3030332D2E3030322E3030332D2E30362E3039362D2E3030312E3030342D2E3030322E3030332D2E3035392E3039362D2E3030322E3030342D2E3030322E';
wwv_flow_imp.g_varchar2_table(50772) := '3030332D2E3035382E3039372D2E3030322E3030332D2E3030312E3030332D2E3035372E3039382D2E3030322E3030332D2E3030322E3030332D2E3035362E3039382D2E3030322E3030332D2E3030322E3030332D2E3035352E3039382D2E3030322E30';
wwv_flow_imp.g_varchar2_table(50773) := '30342D2E3030312E3030332D2E3035352E3039382D2E3030312E3030342D2E3030322E3030332D2E3035342E3039392D2E3030312E3030332D2E3030322E3030332D2E3035322E312D2E3030322E3030322D2E3030322E3030342D2E3035312E312D2E30';
wwv_flow_imp.g_varchar2_table(50774) := '30322E3030322D2E3030322E3030342D2E30352E312D2E3030322E3030332D2E3030322E3030332D2E30352E31762E3030336C2D2E3030322E3030342D2E30352E31762E3030336C2D2E3030322E3030342D2E3034382E312D2E3030322E3030342D2E30';
wwv_flow_imp.g_varchar2_table(50775) := '30312E3030332D2E3034372E3130312D2E3030322E3030332D2E3030312E3030342D2E3031332E3032372D2E3035322E3135322D2E3032342E31362E3030362E31362E3033372E3135372E3036342E3134382E3039312E3133332E3131342E3131342E31';
wwv_flow_imp.g_varchar2_table(50776) := '33342E30392E3134372E3036352E3135372E3033362E3136322E3030362E3135392D2E3032342E3135322D2E3035332E31342D2E30382E3132322D2E3130352E312D2E3132362E3036362D2E3131372E30312D2E3032332E3034342D2E3039352E303435';
wwv_flow_imp.g_varchar2_table(50777) := '2D2E3039352E3030322D2E3030332E3034322D2E3038372E3034382D2E3039372E3034382D2E303935762D2E3030316C2E3034382D2E3039322E3030312D2E3030312E3034372D2E30392E30352D2E3039332E3030322D2E3030322E3034392D2E30392E';
wwv_flow_imp.g_varchar2_table(50778) := '3035322D2E3039322E3030312D2E3030322E3035312D2E3038392E3030312D2E3030322E3035312D2E3038372E3035332D2E3038382E3030312D2E3030322E3035352D2E3039312E3035372D2E3039312E3035372D2E30392E3030312D2E3030322E3035';
wwv_flow_imp.g_varchar2_table(50779) := '372D2E3038392E3035352D2E3038332E3030312D2E3030322E30362D2E30392E30362D2E3038382E3036322D2E3038392E3030312D2E3030312E30362D2E3038342E3036332D2E3038382E3036352D2E3038392E3031372D2E3032332E3031362D2E3032';
wwv_flow_imp.g_varchar2_table(50780) := '352E30362D2E3039342E3035392D2E3039762D2E3030326C2E3035382D2E3038362E3035372D2E3038362E3030312D2E3030312E3036322D2E30392E3036322D2E3038382E3030312D2E3030322E30362D2E3038352E3030322D2E3030322E30362D2E30';
wwv_flow_imp.g_varchar2_table(50781) := '38322E3036332D2E3038372E3036342D2E3038342E3030322D2E3030322E3036312D2E30382E3036352D2E3038342E3036342D2E3038762D2E3030316C2E3036372D2E3038332E3036372D2E3038322E30372D2E3038332E3036392D2E30382E3036332D';
wwv_flow_imp.g_varchar2_table(50782) := '2E3037342E3037342D2E3038332E3036382D2E3037372E3030322D2E3030322E30372D2E3037362E30372D2E3037352E3037322D2E3037372E3030312D2E3030312E3036372D2E30372E3037362D2E3037382E3030322D2E3030322E30372D2E30372E30';
wwv_flow_imp.g_varchar2_table(50783) := '37352D2E3037352E3030322D2E3030322E3037322D2E30372E3037352D2E3037322E3030322D2E3030322E3037332D2E3036392E3037342D2E3036382E3030312D2E3030312E30382D2E3037332E3037362D2E3036382E3030322D2E3030322E3037322D';
wwv_flow_imp.g_varchar2_table(50784) := '2E303633762D2E3030316C2E3037382D2E3036372E3037392D2E3036382E3030322D2E3030312E30382D2E3036382E3030322D2E3030322E3037372D2E3036332E3038322D2E3036362E3030312D2E3030312E3037352D2E30362E3030322D2E3030322E';
wwv_flow_imp.g_varchar2_table(50785) := '3030362D2E3030342E3131372D2E3131312E3039342D2E3133312E3036382D2E3134362E30342D2E3135362E30312D2E3136312D2E3031392D2E31362D2E3034392D2E3135342D2E3037362D2E3134312D2E3130322D2E3132352D2E3132332D2E313035';
wwv_flow_imp.g_varchar2_table(50786) := '2D2E31342D2E3037392D2E3135332D2E3035322D2E31362D2E3032332D2E31362E3030377A6D32342E3539362031312E3038386C2D2E3135362E30342D2E3134362E3036372D2E3133312E3039342D2E3131322E3131372D2E3038372E3133352D2E3036';
wwv_flow_imp.g_varchar2_table(50787) := '312E31352D2E3033332E3135372D2E3030342E3133342E3030372E3134322E3030352E3135322E3030342E31352E3030322E313439762E3135336C2E3030312E303131762E3031356C2E3030342E31312E3030322E3131762E3030326C2E3030322E3130';
wwv_flow_imp.g_varchar2_table(50788) := '36762E3332316C2D2E3030332E3130322D2E3030322E3130362D2E3030342E3130372D2E3030352E3130352D2E3030362E3130362D2E3030362E3130362D2E3030382E313036762E3030326C2D2E3030382E313033762E3030326C2D2E30312E312D2E30';
wwv_flow_imp.g_varchar2_table(50789) := '312E3130352D2E30312E3130352D2E3031332E3130352D2E3031322E303939762E3030326C2D2E3031342E3130382D2E3031342E312D2E3031362E3130352D2E3031362E313033762E3030326C2D2E3031372E3039392D2E3031382E3130342D2E303139';
wwv_flow_imp.g_varchar2_table(50790) := '2E313033762E3030326C2D2E3031392E3039372D2E30322E3130342D2E3032322E313033762E3030316C2D2E3032322E3039382D2E3032332E313033762E3030326C2D2E3032342E3039362D2E3032352E313033762E3030326C2D2E3032342E3039362D';
wwv_flow_imp.g_varchar2_table(50791) := '2E3032372E313032762E3030336C2D2E3032362E303933762E3030316C2D2E3032392E313033762E3030326C2D2E30332E3039392D2E3032382E303937762E3030326C2D2E30332E3039352D2E30332E303936762E3030316C2D2E3033332E312D2E3033';
wwv_flow_imp.g_varchar2_table(50792) := '312E303935762E3030326C2D2E3033352E31762E3030336C2D2E3033342E303934762E3030336C2D2E3033352E303936762E3030316C2D2E3033342E3039762E3030326C2D2E3033382E3039382D2E3033362E303933762E3030326C2D2E3033382E3039';
wwv_flow_imp.g_varchar2_table(50793) := '352D2E3037392E3139342D2E30382E3138382D2E3038352E3138392D2E3038372E31392D2E30392E3138342D2E3039322E3138332D2E3039352E3138342D2E30352E3039332D2E3036342E3134382D2E3033342E3135382D2E3030352E31362E3032362E';
wwv_flow_imp.g_varchar2_table(50794) := '31362E3035342E3135312E3038322E31342E3130362E31322E3132372E312E3134332E3037352E3135342E3034362E31362E3031372E3136312D2E3031332E3135362D2E3034322E3134342D2E3037312E31332D2E3039362E3130392D2E3131392E3037';
wwv_flow_imp.g_varchar2_table(50795) := '322D2E3131322E3035332D2E3039392E3030332D2E3030352E3030332D2E3030362E3130322D2E3139352E3030332D2E3030362E3030332D2E3030362E3039382D2E3139362E3030332D2E3030362E3030332D2E3030362E3039362D2E3139372E303032';
wwv_flow_imp.g_varchar2_table(50796) := '2D2E3030362E3030332D2E3030362E3039332D2E322E3030322D2E3030362E3030332D2E3030362E30392D2E322E3030322D2E3030362E3030332D2E3030372E3038362D2E3230322E3030332D2E3030362E3030322D2E3030362E3038342D2E3230332E';
wwv_flow_imp.g_varchar2_table(50797) := '3030322D2E3030352E3030312D2E3030352E30342D2E3130322E3030322D2E3030332E3030312D2E3030332E30342D2E3130332E3030312D2E3030332E3030312D2E3030332E30342D2E313033762D2E3030346C2E3030312D2E3030332E3033392D2E31';
wwv_flow_imp.g_varchar2_table(50798) := '3033762D2E3030336C2E3030322D2E3030332E3033372D2E3130342E3030312D2E3030332E3030312D2E3030332E3033372D2E313034762D2E3030346C2E3030322D2E3030332E3033352D2E3130342E3030322D2E303033762D2E3030346C2E3033352D';
wwv_flow_imp.g_varchar2_table(50799) := '2E3130342E3030322D2E303034762D2E3030336C2E3033342D2E3130352E3030322D2E303033762D2E3030336C2E3033342D2E313035762D2E3030346C2E3030322D2E3030332E3033322D2E3130362E3030312D2E3030332E3030312D2E3030332E3033';
wwv_flow_imp.g_varchar2_table(50800) := '312D2E3130362E3030312D2E3030332E3030312D2E3030342E3033312D2E3130362E3030312D2E3030332E3030312D2E3030342E30332D2E313036762D2E3030336C2E3030322D2E3030342E3032382D2E3130372E3030312D2E3030332E3030312D2E30';
wwv_flow_imp.g_varchar2_table(50801) := '30332E3032382D2E3130372E3030312D2E3030342E3030312D2E3030332E3032372D2E3130372E3030312D2E303034762D2E3030336C2E3032372D2E3130382E3030312D2E303033762D2E3030346C2E3032362D2E3130382E3030312D2E303033762D2E';
wwv_flow_imp.g_varchar2_table(50802) := '3030346C2E3032352D2E3130382E3030312D2E303033762D2E3030346C2E3032352D2E313038762D2E3030346C2E3030312D2E3030332E3032332D2E313039762D2E3030336C2E3030312D2E3030342E3032322D2E313039762D2E3030336C2E3030322D';
wwv_flow_imp.g_varchar2_table(50803) := '2E3030342E30322D2E3130392E3030312D2E303034762D2E3030336C2E30322D2E31312E3030322D2E303033762D2E3030346C2E30322D2E3131762D2E3030376C2E3031392D2E3131762D2E3030336C2E3030312D2E3030342E3031372D2E3131762D2E';
wwv_flow_imp.g_varchar2_table(50804) := '3030346C2E3030312D2E3030332E3031372D2E3131762D2E3030386C2E3031362D2E3131762D2E3030346C2E3030312D2E3030342E3031352D2E3131762D2E3030386C2E3031352D2E313131762D2E3030386C2E3031332D2E313131762D2E3030376C2E';
wwv_flow_imp.g_varchar2_table(50805) := '3031332D2E313132762D2E3030376C2E3031312D2E313132762D2E3030346C2E3030312D2E3030342E30312D2E313132762D2E3030376C2E30312D2E313132762D2E3030386C2E3030382D2E313132762D2E3030386C2E3030372D2E313133762D2E3030';
wwv_flow_imp.g_varchar2_table(50806) := '376C2E3030372D2E313133762D2E3030386C2E3030352D2E313133762D2E3030376C2E3030352D2E313134762D2E3030376C2E3030332D2E313134762D2E3030376C2E3030332D2E313134762D2E3132396C2E3030312D2E313134762D2E31336C2D2E30';
wwv_flow_imp.g_varchar2_table(50807) := '30332D2E313134762D2E3030386C2D2E3030332D2E313135762D2E3030376C2D2E3030332D2E313032762D2E3135356C2D2E3030332D2E313538762D2E30316C2D2E3030342D2E313538762D2E30316C2D2E3030362D2E313538762D2E30316C2D2E3030';
wwv_flow_imp.g_varchar2_table(50808) := '372D2E3134382D2E3032332D2E31362D2E3035312D2E3135322D2E30382D2E31342D2E3130332D2E3132342D2E3132352D2E3130322D2E3134322D2E3037372D2E3135332D2E30352D2E31362D2E30322D2E3136312E30317A6D2D33302E3231332E3636';
wwv_flow_imp.g_varchar2_table(50809) := '6C2D2E3135372E3033342D2E3134392E3036332D2E3133342E30392D2E3131352E3131332D2E3039322E3133322D2E3036372E3134372D2E3033372E3135362D2E3030392E3133342E3030312E31315631352E39356C2E3030362E3232762E3031326C2E';
wwv_flow_imp.g_varchar2_table(50810) := '30312E3232762E3031326C2E3031322E3232762E3030366C2E3030312E3030362E3031352E3232762E3030356C2E3030312E3030362E3031382E32322E3030312E303036762E3030366C2E3032322E323139762E3030366C2E3030312E3030362E303234';
wwv_flow_imp.g_varchar2_table(50811) := '2E3231392E3030312E303036762E3030366C2E3032382E3231382E3030312E303036762E3030366C2E3033312E3231382E3030312E3030362E3030312E3030362E3033332E3231382E3030312E3030362E3030312E3030352E3033372E323138762E3030';
wwv_flow_imp.g_varchar2_table(50812) := '366C2E3030322E3030352E30342E323137762E3030366C2E3030312E3030362E3034332E3231362E3030312E3030362E3030312E3030362E3034362E323136762E3030356C2E3030322E3030362E3034382E3231352E3030322E3030362E3030312E3030';
wwv_flow_imp.g_varchar2_table(50813) := '362E3035312E3231342E3030322E303036762E3030366C2E3035352E3231342E3030322E3030352E3030312E3030362E3035372E3231332E3030322E3030362E3030312E3030352E30362E3231332E3030322E3030352E3030312E3030362E3036332E32';
wwv_flow_imp.g_varchar2_table(50814) := '31322E3030322E3030352E3030312E3030362E3036362E32312E3030322E3030362E3030322E3030362E3036382E32312E3030322E3030352E3030322E3030352E30372E32312E3030332E3030352E3030322E3030352E3037342E3230382E3030322E30';
wwv_flow_imp.g_varchar2_table(50815) := '30362E3030322E3030352E3037372E3230372E3030322E3030362E3030322E3030352E30382E3230362E3030322E3030352E3030322E3030362E3038322E3230342E3030322E3030362E3030322E3030352E3038362E3230342E3030322E3030352E3030';
wwv_flow_imp.g_varchar2_table(50816) := '322E3030362E3038382E3230322E3030322E3030352E3030332E3030362E30392E322E3030332E3030362E3030322E3030352E3039342E322E3030322E3030362E3030332E3030352E3039362E3139392E3030322E3030352E3030332E3030352E30332E';
wwv_flow_imp.g_varchar2_table(50817) := '3036322E3038362E3133372E31312E3131382E3132382E3039372E3134352E30372E3135362E3034332E31362E3031332E31362D2E3031372E3135352D2E3034372E3134332D2E3037342E3132372D2E312E3130362D2E3132312E3038312D2E31342E30';
wwv_flow_imp.g_varchar2_table(50818) := '35352D2E31352E3032352D2E31362D2E3030352D2E3136312D2E3033342D2E3135382D2E30352D2E3132342D2E3032382D2E3035352D2E3039322D2E31392D2E3038372D2E3138382D2E3038372D2E3139322D2E3038332D2E31392D2E30382D2E313933';
wwv_flow_imp.g_varchar2_table(50819) := '2D2E3037382D2E3139342D2E3037362D2E3139362D2E3037332D2E3139352D2E30372D2E3139372D2E3036372D2E3139382D2E3036352D2E3139392D2E3036332D2E322D2E3035392D2E322D2E3035362D2E322D2E3035352D2E3230342D2E30352D2E32';
wwv_flow_imp.g_varchar2_table(50820) := '30312D2E3034392D2E3230322D2E3034362D2E3230352D2E3034332D2E3230362D2E30342D2E3230332D2E3033382D2E3230372D2E3033342D2E3230342D2E3033322D2E3230372D2E3032382D2E3230352D2E3032362D2E3230372D2E3032332D2E3230';
wwv_flow_imp.g_varchar2_table(50821) := '382D2E30322D2E3230372D2E3031382D2E3230372D2E3031342D2E3230382D2E3031312D2E3230372D2E3030392D2E3230382D2E3030352D2E3230372D2E3030322D2E3130342D2E3031372D2E31362D2E3034362D2E3135352D2E3037342D2E3134332D';
wwv_flow_imp.g_varchar2_table(50822) := '2E312D2E3132362D2E3132312D2E3130372D2E3133392D2E3038312D2E3135322D2E3035352D2E3135392D2E3032352D2E3136312E3030347A6D32342E3538352031312E38336C2D2E3135362E3033392D2E3134362E3036382D2E31312E3037362D2E30';
wwv_flow_imp.g_varchar2_table(50823) := '31352E3031322D2E3136332E3132392D2E3136362E3132372D2E3136382E3132352D2E31372E3132342D2E31372E31322D2E3137322E3131382D2E3137332E3131352D2E3137362E3131342D2E3137372E3131312D2E31382E31312D2E3137382E313035';
wwv_flow_imp.g_varchar2_table(50824) := '2D2E3138322E3130342D2E3138322E3130312D2E3138342E312D2E3138342E3039352D2E3138392E3039352D2E3138362E30392D2E3138382E3038392D2E31392E3038362D2E31392E3038322D2E3139332E3038312D2E3139352E3037382D2E3139312E';
wwv_flow_imp.g_varchar2_table(50825) := '3037342D2E3139372E3037332D2E3139352E30372D2E3139362E3036352D2E3139382E3036342D2E3139382E3036312D2E322E3035382D2E322E3035352D2E322E3035322D2E322E3034392D2E3135312E3033352D2E3135332E30352D2E3134312E3037';
wwv_flow_imp.g_varchar2_table(50826) := '382D2E3132352E3130332D2E3130332E3132342D2E3037382E31342D2E30352E3135342D2E3032322E31362E3030392E31362E3033382E3135372E3036372E3134372E3039332E3133322E3131362E3131322E3133342E3038392E3134392E3036322E31';
wwv_flow_imp.g_varchar2_table(50827) := '35382E3033342E31362E3030332E3133332D2E30322E3135382D2E3033352E3030362D2E3030322E3030362D2E3030312E3231332D2E3035322E3030362D2E3030322E3030372D2E3030312E3231322D2E3035362E3030362D2E3030312E3030362D2E30';
wwv_flow_imp.g_varchar2_table(50828) := '30322E3231322D2E3035382E3030362D2E3030322E3030362D2E3030322E3231312D2E3036312E3030362D2E3030322E3030362D2E3030322E32312D2E3036342E3030362D2E3030322E3030362D2E3030322E32312D2E3036372E3030352D2E3030322E';
wwv_flow_imp.g_varchar2_table(50829) := '3030362D2E3030322E3230382D2E30372E3030362D2E3030322E3030362D2E3030332E3230372D2E3037332E3030362D2E3030322E3030362D2E3030322E3230362D2E3037372E3030362D2E3030322E3030352D2E3030322E3230362D2E30382E303035';
wwv_flow_imp.g_varchar2_table(50830) := '2D2E3030312E3030362D2E3030332E3230342D2E3038322E3030362D2E3030322E3030352D2E3030322E3230332D2E3038352E3030362D2E3030332E3030352D2E3030322E3230322D2E3038382E3030362D2E3030322E3030352D2E3030332E322D2E30';
wwv_flow_imp.g_varchar2_table(50831) := '392E3030362D2E3030332E3030362D2E3030332E322D2E3039332E3030352D2E3030332E3030352D2E3030322E3139382D2E3039362E3030362D2E3030332E3030352D2E3030332E3139372D2E3039392E3030352D2E3030322E3030352D2E3030332E31';
wwv_flow_imp.g_varchar2_table(50832) := '39362D2E3130322E3030352D2E3030322E3030352D2E3030332E3139352D2E3130352E3030352D2E3030322E3030352D2E3030332E3139332D2E3130372E3030352D2E3030332E3030352D2E3030332E3139312D2E31312E3030352D2E3030332E303035';
wwv_flow_imp.g_varchar2_table(50833) := '2D2E3030332E31392D2E3131322E3030352D2E3030332E3030352D2E3030332E3138392D2E3131352E3030352D2E3030332E3030352D2E3030332E3138372D2E3131372E3030352D2E3030332E3030342D2E3030342E3138362D2E31322E3030352D2E30';
wwv_flow_imp.g_varchar2_table(50834) := '30332E3030342D2E3030332E3138342D2E3132322E3030352D2E3030332E3030352D2E3030342E3138322D2E3132352E3030342D2E3030332E3030352D2E3030332E31382D2E3132382E3030352D2E3030332E3030352D2E3030332E3137392D2E31332E';
wwv_flow_imp.g_varchar2_table(50835) := '3030342D2E3030332E3030352D2E3030342E3137372D2E3133322E3030342D2E3030342E3030352D2E3030332E3137352D2E3133352E3030352D2E3030332E3030342D2E3030342E3137332D2E3133372E3030352D2E3030332E3030342D2E3030342E30';
wwv_flow_imp.g_varchar2_table(50836) := '31392D2E3031352E3131352D2E3131332E3039322D2E3133322E3036362D2E3134372E3033382D2E3135372E3030382D2E31362D2E3032322D2E31362D2E3035322D2E3135332D2E3037392D2E31342D2E3130332D2E3132342D2E3132352D2E3130322D';
wwv_flow_imp.g_varchar2_table(50837) := '2E3134322D2E3037382D2E3135332D2E30352D2E31362D2E30322D2E31362E30317A6D2D31392E31372E3035346C2D2E3135332E3035312D2E31342E3037392D2E3132342E3130332D2E3130332E3132352D2E3037372E3134312D2E30352E3135332D2E';
wwv_flow_imp.g_varchar2_table(50838) := '30322E31362E3030392E3136312E30342E3135362E3036372E3134372E3039332E3133312E3039352E3039342E3034372E30342E3030352E3030342E3030352E3030342E31372E31342E3030352E3030342E3030352E3030342E3137322E3133372E3030';
wwv_flow_imp.g_varchar2_table(50839) := '342E3030342E3030352E3030332E3038362E3036372E3030332E3030322E3030332E3030322E3038372E3036372E3030332E3030322E3030332E3030322E3038382E3036362E3030322E3030332E3030332E3030322E3038392E3036352E3030322E3030';
wwv_flow_imp.g_varchar2_table(50840) := '322E3030332E3030322E30392E3036352E3030322E3030322E3030332E3030322E30392E3036342E3030322E3030322E3030332E3030322E30392E3036332E3030332E3030322E3030332E3030322E30392E3036332E3030332E3030322E3030332E3030';
wwv_flow_imp.g_varchar2_table(50841) := '322E3039322E3036322E3030322E3030322E3030332E3030322E3039322E3036312E3030332E3030322E3030332E3030322E3039322E30362E3030332E3030332E3030332E3030312E3039332E30362E3030332E3030322E3030332E3030322E3039332E';
wwv_flow_imp.g_varchar2_table(50842) := '30362E3030332E3030312E3030332E3030322E3039342E3035382E3030332E3030322E3030332E3030322E3039352E3035382E3030332E3030312E3030332E3030322E3039352E3035372E3030332E3030322E3030332E3030322E3039352E3035362E30';
wwv_flow_imp.g_varchar2_table(50843) := '30332E3030322E3030332E3030322E3039362E3035352E3030342E3030322E3030332E3030312E3039362E3035352E3030332E3030322E3030332E3030322E3039382E3035332E3030332E3030322E3030332E3030322E3039372E3035332E3030342E30';
wwv_flow_imp.g_varchar2_table(50844) := '30322E3030332E3030312E3039382E3035332E3030332E3030312E3030332E3030322E3039392E3035322E3030332E3030312E3030332E3030322E312E30352E3030332E3030322E3030332E3030322E312E30352E3030332E3030322E3030332E303031';
wwv_flow_imp.g_varchar2_table(50845) := '2E312E3035682E3030336C2E3030342E3030332E312E3034382E3030342E3030312E3030332E3030322E3130312E3034382E3030332E3030312E3030342E3030322E3130312E3034362E3030342E3030322E3030332E3030312E3130322E3034362E3030';
wwv_flow_imp.g_varchar2_table(50846) := '342E3030322E3030332E3030312E3130332E3034352E3030332E3030322E3030332E3030312E3130332E3034352E3030342E3030312E3030332E3030322E3130342E3034332E3030332E3030312E3030342E3030322E3130342E3034322E3030332E3030';
wwv_flow_imp.g_varchar2_table(50847) := '322E3030342E3030312E3130342E3034322E3030342E3030312E3030332E3030322E3130352E30342E3030342E3030322E3030332E3030312E3130362E30342E3030332E303032682E3030346C2E3130362E30342E3030342E3030312E3030332E303032';
wwv_flow_imp.g_varchar2_table(50848) := '2E3130372E3033382E3030332E3030312E3030342E3030312E3130372E3033382E3030332E3030312E3030342E3030312E3130372E3033372E3030342E3030312E3030342E3030312E3130382E3033362E3030332E3030312E3030342E3030312E313038';
wwv_flow_imp.g_varchar2_table(50849) := '2E3033352E3030342E3030312E3030332E3030312E31312E3033342E3030332E3030312E3030342E3030312E3130392E3033332E3030342E303032682E3030336C2E31312E303333682E3030346C2E3030332E3030322E31312E3033312E3030342E3030';
wwv_flow_imp.g_varchar2_table(50850) := '312E3030342E3030312E3038342E3032332E3038312E3032382E3030342E3030312E3030332E3030312E3130392E3033372E3030332E3030312E3030342E3030312E3130392E3033362E3030332E3030312E3030342E3030312E3130392E303335682E30';
wwv_flow_imp.g_varchar2_table(50851) := '30336C2E3030342E3030322E31312E3033332E3030332E3030312E3030332E3030312E31312E3033332E3030332E3030312E3030342E3030312E3130392E3033312E3030342E303032682E3030336C2E31312E3033312E3030332E3030312E3030342E30';
wwv_flow_imp.g_varchar2_table(50852) := '30312E31312E3033682E3030336C2E3030332E3030312E31312E303239682E3030346C2E3030332E3030322E31312E3032372E3030332E3030312E3030342E3030312E31312E303237682E3030336C2E3030342E3030312E3030342E3030312E31362E30';
wwv_flow_imp.g_varchar2_table(50853) := '32322E31362D2E3030382E3135372D2E3033382E3134372D2E3036372E3133322D2E3039322E3131322D2E3131362E30392D2E3133342E3036322D2E3134392E3033342D2E3135372E3030342D2E3136312D2E3032352D2E31362D2E3035352D2E313531';
wwv_flow_imp.g_varchar2_table(50854) := '2D2E3038322D2E3133392D2E3130372D2E31322D2E3132372D2E312D2E3134332D2E3037342D2E3132342D2E3034682D2E3030336C2D2E3130342D2E3032352D2E3130332D2E303236682D2E3030326C2D2E3039352D2E303236682D2E3030316C2D2E31';
wwv_flow_imp.g_varchar2_table(50855) := '30312D2E303237682D2E3030326C2D2E312D2E303238682D2E3030326C2D2E3130332D2E30332D2E3130342D2E3033322D2E3039372D2E3033682D2E3030326C2D2E3130332D2E3033332D2E3130322D2E3033332D2E3130312D2E3033342D2E3130362D';
wwv_flow_imp.g_varchar2_table(50856) := '2E3033362D2E3032372D2E30312D2E3032372D2E3030372D2E3130372D2E30332D2E3130342D2E3032392D2E3130342D2E3033682D2E3030326C2D2E3039372D2E30332D2E3130322D2E3033322D2E3130322D2E3033322D2E3130322D2E3033342D2E31';
wwv_flow_imp.g_varchar2_table(50857) := '30332D2E3033352D2E3039362D2E3033342D2E312D2E3033362D2E3130312D2E303337682D2E3030326C2D2E3039342D2E3033362D2E3039362D2E3033372D2E3039372D2E3034682D2E3030326C2D2E3039392D2E30342D2E3039382D2E303432682D2E';
wwv_flow_imp.g_varchar2_table(50858) := '3030326C2D2E3039322D2E30342D2E3039372D2E3034332D2E3039352D2E3034332D2E3039372D2E303434682D2E3030326C2D2E30392D2E3034332D2E3039342D2E3034352D2E3039342D2E3034362D2E3039332D2E3034372D2E30392D2E3034362D2E';
wwv_flow_imp.g_varchar2_table(50859) := '3039362D2E30352D2E3038382D2E3034372D2E3030322D2E3030312D2E30392D2E3034392D2E3039342D2E3035322D2E3030322D2E3030322D2E3038372D2E3034392D2E3038372D2E3035682D2E3030326C2D2E3038382D2E303533682D2E3030316C2D';
wwv_flow_imp.g_varchar2_table(50860) := '2E30392D2E3035352D2E3038362D2E3035322D2E3030322D2E3030312D2E3038392D2E3035352D2E3038342D2E303534682D2E3030326C2D2E30392D2E303539682D2E3030316C2D2E3038352D2E3035362D2E3030312D2E3030312D2E3038342D2E3035';
wwv_flow_imp.g_varchar2_table(50861) := '362D2E3038322D2E303536682D2E3030316C2D2E3038362D2E30362D2E3038322D2E30353848372E37396C2D2E3038362D2E3036322D2E3030322D2E3030322D2E30382D2E3035382D2E3038312D2E3036682D2E3030316C2D2E3038352D2E3036342D2E';
wwv_flow_imp.g_varchar2_table(50862) := '3030322D2E3030322D2E3037362D2E3035382D2E3030322D2E3030322D2E3038322D2E3036342D2E3136312D2E3132382D2E3136322D2E3133332D2E30342D2E3033342D2E3133322D2E3039322D2E3134372D2E3036362D2E3135372D2E3033382D2E31';
wwv_flow_imp.g_varchar2_table(50863) := '362D2E3030382D2E31362E3032327A222C6F7061636974793A222E3938227D29292C5369676E616C53746172744576656E744E6F6E496E74657272757074696E673A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6D7128';
wwv_flow_imp.g_varchar2_table(50864) := '7B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31362E30303720382E38324C392E32312032312E3032';
wwv_flow_imp.g_varchar2_table(50865) := '326831332E3539364C31362E30303720382E38327A6D3020312E3737356C352E33323820392E3536334831302E36386C352E3332372D392E3536337A4D31362E31342E333836632D312E3537312E3233362D342E3139352D2E3238342D342E3920312E33';
wwv_flow_imp.g_varchar2_table(50866) := '38312E36313920312E37303320322E3734352E30363920342E3038352E33363520312E3432312D2E313320322E38342E3220342E3233352E3235394332312E32372E3738342031382E31392E333434203137202E3431336132302E3435362032302E3435';
wwv_flow_imp.g_varchar2_table(50867) := '3620302030302D2E38362D2E3032377A4D323520332E313632632D322E31392E3639342E34303120322E323620312E31383120332E30393420312E30383320312E31353220312E39353420322E34383420322E37313520332E38363420312E343820312E';
wwv_flow_imp.g_varchar2_table(50868) := '30303520312E3834352D312E32362E38312D322E30332D312E3135382D312E3839372D322E3631332D332E3730342D342E3531332D342E38396C2D2E3139322D2E3033387A6D2D31382E3433382E343233632D312E3739332E3731322D322E3930392032';
wwv_flow_imp.g_varchar2_table(50869) := '2E3534382D342E303120342E3036312D2E3737332E3831342D322E32313120332E3635332E30303520332E32313120312E3132332D312E34363920312E38372D332E33303620332E3236372D342E3631342E3636342D2E3720322E37332D322E3031332E';
wwv_flow_imp.g_varchar2_table(50870) := '3733382D322E3635387A6D32342E35372031312E303732632D312E3635392E3433352D2E34363820322E3636372D2E393920332E3839356131332E3432372031332E34323720302030312D312E34393720342E343335632D2E323320312E36353920312E';
wwv_flow_imp.g_varchar2_table(50871) := '39393120312E31363520322E3031382D2E3139396131342E3237372031342E3237372030203030312E3235342D372E3535322E3836352E38363520302030302D2E3738352D2E3537397A6D2D33302E31382E363636632D312E3637372E3338362D2E3633';
wwv_flow_imp.g_varchar2_table(50872) := '3320322E3636372D2E36303820332E3837362E33373120312E3632332E37393220332E333520312E373920342E36393620322E3338322E3332312E3537312D322E3333382E3239322D332E3439326131352E39322031352E393220302030312D2E363834';
wwv_flow_imp.g_varchar2_table(50873) := '2D342E33392E3837372E38373720302030302D2E37392D2E36397A6D32342E3535382031312E3831632D312E3735352E3836352D332E33303320322E3236362D352E32373420322E3736352D312E3136322D2E3031362D332E30373420312E3237312D31';
wwv_flow_imp.g_varchar2_table(50874) := '2E33333120322E31303220322E36362D2E34343720352E3136332D312E37333320372E3233362D332E3434352E3437322D2E3530362E30362D312E3433322D2E3633312D312E3432317A6D2D31392E3135312E303433632D322E3030342E3738362E3431';
wwv_flow_imp.g_varchar2_table(50875) := '3620322E34303520312E343320322E39313320312E3630382E39303420332E33373920312E36333620352E32303820312E38373720312E37372D2E3830342D2E3232382D322E3039342D312E3335372D322E3037332D312E37352D2E3533372D332E3430';
wwv_flow_imp.g_varchar2_table(50876) := '332D312E3339362D342E3739382D322E3538366C2D2E3232372D2E3130342D2E3235362D2E3032377A227D29292C54696D657253746172744576656E744E6F6E496E74657272757074696E673A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E';
wwv_flow_imp.g_varchar2_table(50877) := '432822737667222C6671287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E39393120382E3763';
wwv_flow_imp.g_varchar2_table(50878) := '2D332E3031382D2E3034322D352E393220312E3932352D372E303320342E3732352D312E31333820322E3639352D2E35303920362E30313120312E35333720382E31303220312E393920322E31343220352E32363720322E393320382E30313320312E39';
wwv_flow_imp.g_varchar2_table(50879) := '323720322E3837372D2E393820342E39392D332E38323620352E3036372D362E38372E3135332D322E3935362D312E3632342D352E38382D342E3239392D372E31333561372E35353120372E35353120302030302D332E3238382D2E37357A6D3020312E';
wwv_flow_imp.g_varchar2_table(50880) := '33383363322E3735382D2E30353220352E33373220312E39373220362E30313420342E3635342E37303420322E3537382D2E34383220352E3531362D322E373920362E3836372D322E33353820312E34382D352E36383220312E3038352D372E3631372D';
wwv_flow_imp.g_varchar2_table(50881) := '2E3931392D322E3034332D312E39372D322E3430372D352E33382D2E38342D372E37343320312E31312D312E37363420332E3134392D322E383820352E3233332D322E38367A6D312E39363220312E3736346C2D322E30373420332E373632632D2E3634';
wwv_flow_imp.g_varchar2_table(50882) := '2E3036382D2E37393320312E30342D2E32303220312E332E33392E32372E3639362D2E313820312E3035322D2E31363568332E3137762D2E383635682D332E3138326C312E3939332D332E3631342D2E3735372D2E3431387A4D31362E31322E33353868';
wwv_flow_imp.g_varchar2_table(50883) := '2D2E3233326C2D2E32322E303034682D2E3031326C2D2E3232312E303036682D2E3031326C2D2E32322E3031682D2E3031326C2D2E32322E303133682D2E3031326C2D2E32322E303136682D2E3031326C2D2E32322E303139682D2E3030356C2D2E3030';
wwv_flow_imp.g_varchar2_table(50884) := '362E3030312D2E32322E303231682D2E3030366C2D2E3030352E3030312D2E32322E303235682D2E3031316C2D2E32322E303238682D2E3030356C2D2E3030362E3030322D2E3231392E3033682D2E3030356C2D2E3030362E3030312D2E3231382E3033';
wwv_flow_imp.g_varchar2_table(50885) := '332D2E3030362E3030312D2E3030362E3030312D2E3231372E3033362D2E3030362E3030312D2E3030362E3030312D2E3231372E3033392D2E3030362E3030312D2E3030362E3030312D2E3231362E3034322D2E3030362E3030312D2E3030362E303031';
wwv_flow_imp.g_varchar2_table(50886) := '2D2E3231352E3034352D2E3030362E3030312D2E3030362E3030322D2E3231352E3034372D2E3030362E3030322D2E3030362E3030312D2E3231342E30352D2E3030362E3030322D2E3030362E3030322D2E3131352E3032392D2E3135322E3035332D2E';
wwv_flow_imp.g_varchar2_table(50887) := '31342E3038312D2E3132322E3130362D2E312E3132362D2E3037352E3134332D2E3034372E3135342D2E3031382E31362E3031322E31362E3034322E3135362E30372E3134352E3039352E31332E3131382E31312E3133372E3038362E31352E3035392E';
wwv_flow_imp.g_varchar2_table(50888) := '3135382E3033682E3136316C2E3133322D2E3032322E31312D2E3032382E3230322D2E3034372E3230332D2E3034362E3230382D2E3034332E3230322D2E3033392E3230362D2E3033372E3230362D2E3033342E3230352D2E30332E3230382D2E30332E';
wwv_flow_imp.g_varchar2_table(50889) := '3230352D2E3032352E3230392D2E3032332E3230382D2E30322E32312D2E3031372E3230392D2E3031352E3230372D2E3031312E32312D2E3030392E32312D2E3030362E3230372D2E303033682E32316C2E32312E3030322E3230372E3030352E323037';
wwv_flow_imp.g_varchar2_table(50890) := '2E3030382E3231322E3031312E3230372E3031342E3230382E3031372E3230392E3031392E3230382E3032322E3230352E3032352E3230362E3032382E3230372E30332E3230382E3033352E3230352E3033362E3230322E3033392E3035322E30312E31';
wwv_flow_imp.g_varchar2_table(50891) := '362E3031382E31362D2E3031322E3135362D2E3034322E3134362D2E30372E31332D2E3039362E3130392D2E3131392E3038352D2E3133362E30362D2E31352E30332D2E313539762D2E31366C2D2E30332D2E31362D2E3035392D2E31352D2E3038362D';
wwv_flow_imp.g_varchar2_table(50892) := '2E3133364C31392E3832332E396C2D2E31332D2E3039362D2E3134352D2E30372D2E3132382D2E3033382D2E3035372D2E3031312D2E3030362D2E303032682D2E3030364C31392E3133352E36346C2D2E3030362D2E3030312D2E3030362D2E3030312D';
wwv_flow_imp.g_varchar2_table(50893) := '2E3231372D2E3033394831382E396C2D2E3030362D2E3030322D2E3231372D2E3033352D2E3030362D2E3030312D2E3030362D2E3030312D2E3231382D2E3033322D2E3030362D2E3030312D2E3030362D2E3030312D2E3231382D2E3033682D2E303036';
wwv_flow_imp.g_varchar2_table(50894) := '6C2D2E3030362D2E3030312D2E3231392D2E303237682D2E3031316C2D2E32322D2E3032342D2E3030352D2E303031682D2E3030366C2D2E32322D2E303231682D2E3030364C31372E3531322E34326C2D2E32322D2E3031372D2E3030352D2E30303168';
wwv_flow_imp.g_varchar2_table(50895) := '2D2E3030366C2D2E32322D2E303135682D2E3031326C2D2E32322D2E303132682D2E3031326C2D2E32322D2E3031682D2E3031326C2D2E32322D2E303035682D2E3031326C2D2E3232312D2E303033682D2E3031327A6D382E37313520322E3738336C2D';
wwv_flow_imp.g_varchar2_table(50896) := '2E3135372E3033342D2E3134392E3036332D2E3133342E3038392D2E3131362E3131322D2E3039322E3133322D2E3036372E3134372D2E3033382E3135372D2E3030382E31362E3032312E31362E3035312E3135332E3037392E3134312E3130332E3132';
wwv_flow_imp.g_varchar2_table(50897) := '342E3130322E3038372E3035322E303338682E3030316C2E3038372E303634762E3030316C2E3038322E3036312E3030322E3030312E3037362E303539682E3030316C2E3038342E3036352E3038322E3036362E3030322E3030312E3037392E3036332E';
wwv_flow_imp.g_varchar2_table(50898) := '3030322E3030322E3037372E3036332E3038312E3036372E3030322E3030322E3037372E3036352E3037362E3036352E3030312E3030322E30382E30372E3037382E3037682E3030326C2E3037352E3036382E3037372E3037322E3030322E3030312E30';
wwv_flow_imp.g_varchar2_table(50899) := '37332E3036392E3037372E3037332E3037322E30372E3030322E3030312E3037372E3037362E30372E3037762E3030316C2E3037352E3037362E30372E3037332E3030322E3030312E3037342E3037392E3030322E3030322E3036392E3037342E303639';
wwv_flow_imp.g_varchar2_table(50900) := '2E3037352E3037342E3038322E30372E30382E3030322E3030312E3036382E303739682E3030316C2E3036372E3037392E3036382E3038322E3036352E3037382E3030312E3030322E3036382E3038332E3036372E3038342E3036332E3038312E303031';
wwv_flow_imp.g_varchar2_table(50901) := '2E3030322E3036372E3038372E3030322E3030322E3036332E3038342E3030312E3030312E3036342E3038372E3030382E30312E3030382E30312E3039352E31322E3039332E3132312E30392E3131392E3038372E3131392E3038382E3132322E303836';
wwv_flow_imp.g_varchar2_table(50902) := '2E3132332E3038342E31322E3038312E3132322E3030312E3030322E3038342E3132362E30382E3132362E30382E3132372E3037372E3132362E3037392E3133312E3037342E3132372E3037352E3133312E3037332E3133312E30372E31332E30372E31';
wwv_flow_imp.g_varchar2_table(50903) := '33332E3036392E3133332E3034352E30392E3038362E3133372E3130392E3131392E31332E3039362E3134342E30372E3135362E3034322E31362E3031332E31362D2E3031372E3135352D2E3034372E3134332D2E3037352E3132362D2E312E3130362D';
wwv_flow_imp.g_varchar2_table(50904) := '2E3132312E3038322D2E31342E3035342D2E3135312E3032352D2E31362D2E3030352D2E31362D2E3033352D2E3135382D2E30352D2E3132342D2E3034382D2E3039352D2E3030322D2E3030342D2E3030322D2E3030342D2E3037332D2E31342D2E3030';
wwv_flow_imp.g_varchar2_table(50905) := '322D2E3030352D2E3030322D2E3030342D2E3037342D2E31342D2E3030322D2E3030342D2E3030322D2E3030342D2E3037362D2E31342D2E3030322D2E3030332D2E3030322D2E3030342D2E3037372D2E3133392D2E3030332D2E3030342D2E3030322D';
wwv_flow_imp.g_varchar2_table(50906) := '2E3030342D2E3037382D2E3133382D2E3030332D2E3030342D2E3030322D2E3030332D2E30382D2E3133372D2E3030322D2E3030342D2E3030332D2E3030342D2E3038312D2E3133362D2E3030322D2E3030342D2E3030332D2E3030342D2E3038332D2E';
wwv_flow_imp.g_varchar2_table(50907) := '3133362D2E3030322D2E3030332D2E3030322D2E3030342D2E3038352D2E3133352D2E3030322D2E3030342D2E3030332D2E3030332D2E3038352D2E3133342D2E3030332D2E3030342D2E3030322D2E3030342D2E3038372D2E3133322D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50908) := '3030342D2E3030332D2E3030342D2E3038382D2E3133322D2E3030332D2E3030332D2E3030322D2E3030342D2E30392D2E31332D2E3030332D2E3030352D2E3030332D2E3030332D2E3039312D2E31332D2E3030332D2E3030342D2E3030322D2E303034';
wwv_flow_imp.g_varchar2_table(50909) := '2D2E3039332D2E3132392D2E3030332D2E3030332D2E3030332D2E3030342D2E3039342D2E3132382D2E3030332D2E3030342D2E3030332D2E3030332D2E3039352D2E3132372D2E3030332D2E3030342D2E3030332D2E3030342D2E3039372D2E313235';
wwv_flow_imp.g_varchar2_table(50910) := '2D2E3030332D2E3030342D2E3030332D2E3030342D2E30392D2E3131342D2E30362D2E3038322D2E3030332D2E3030332D2E3030322D2E3030332D2E3036392D2E3039312D2E3030322D2E3030342D2E3030322D2E3030332D2E30372D2E30392D2E3030';
wwv_flow_imp.g_varchar2_table(50911) := '332D2E3030332D2E3030322D2E3030332D2E30372D2E30392D2E3030332D2E3030332D2E3030322D2E3030332D2E3037312D2E30392D2E3030322D2E3030332D2E3030332D2E3030322D2E3037322D2E3038392D2E3030322D2E3030332D2E3030322D2E';
wwv_flow_imp.g_varchar2_table(50912) := '3030332D2E3037332D2E3038382D2E3030322D2E3030332D2E3030322D2E3030322D2E3037342D2E3038372D2E3030322D2E3030332D2E3030322D2E3030332D2E3037342D2E3038362D2E3030332D2E3030332D2E3030322D2E3030332D2E3037342D2E';
wwv_flow_imp.g_varchar2_table(50913) := '3038362D2E3030332D2E3030322D2E3030322D2E3030332D2E3037352D2E3038352D2E3030332D2E3030332D2E3030322D2E3030322D2E3037362D2E3038342D2E3030322D2E3030332D2E3030332D2E3030332D2E3037362D2E3038332D2E3030322D2E';
wwv_flow_imp.g_varchar2_table(50914) := '3030332D2E3030332D2E3030332D2E3037372D2E3038322D2E3030322D2E3030332D2E3030332D2E3030322D2E3037372D2E3038322D2E3030332D2E3030332D2E3030332D2E3030322D2E3037382D2E3038312D2E3030322D2E3030332D2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50915) := '3030332D2E3037382D2E30382D2E3030332D2E3030322D2E3030332D2E3030332D2E3037392D2E30382D2E3030322D2E3030322D2E3030332D2E3030322D2E30382D2E30382D2E3030322D2E3030322D2E3030332D2E3030322D2E30382D2E3037382D2E';
wwv_flow_imp.g_varchar2_table(50916) := '3030332D2E3030332D2E3030332D2E3030322D2E30382D2E3037372D2E3030332D2E3030332D2E3030332D2E3030322D2E3038322D2E3037372D2E3030322D2E3030322D2E3030332D2E3030322D2E3038322D2E3037362D2E3030332D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(50917) := '30322D2E3030332D2E3038332D2E3037352D2E3030332D2E3030322D2E3030322D2E3030332D2E3038342D2E3037342D2E3030322D2E3030322D2E3030332D2E3030322D2E3038342D2E3037342D2E3030332D2E3030322D2E3030322D2E3030322D2E30';
wwv_flow_imp.g_varchar2_table(50918) := '38352D2E3037332D2E3030322D2E3030322D2E3030332D2E3030332D2E3038352D2E3037312D2E3030332D2E3030332D2E3030322D2E3030322D2E3038362D2E30372D2E3030332D2E3030332D2E3030322D2E3030322D2E3038362D2E30372D2E303033';
wwv_flow_imp.g_varchar2_table(50919) := '2D2E3030332D2E3030332D2E3030322D2E3038362D2E30372D2E3030332D2E3030322D2E3030332D2E3030322D2E3038372D2E3036392D2E3030322D2E3030322D2E3030332D2E3030322D2E3038382D2E3036382D2E3030322D2E3030322D2E3030332D';
wwv_flow_imp.g_varchar2_table(50920) := '2E3030322D2E3038382D2E3036372D2E3030332D2E3030332D2E3030332D2E3030322D2E3038382D2E3036362D2E3030332D2E3030322D2E3030332D2E3030322D2E3038392D2E3036362D2E3030332D2E3030322D2E3030332D2E3030322D2E3035372D';
wwv_flow_imp.g_varchar2_table(50921) := '2E3034322D2E31342D2E3038322D2E31352D2E3035352D2E31362D2E3032362D2E31362E3030347A6D2D31382E3435382E3432366C2D2E3135372E3033372D2E3134382E3036362D2E3131312E3037342D2E3030372E3030362D2E3030332E3030322D2E';
wwv_flow_imp.g_varchar2_table(50922) := '3030332E3030322D2E3038362E3036392D2E3030332E3030322D2E3030322E3030322D2E3038362E30372D2E3030332E3030322D2E3030322E3030322D2E3038362E30372D2E3030322E3030332D2E3030332E3030322D2E3038352E3037312D2E303032';
wwv_flow_imp.g_varchar2_table(50923) := '2E3030322D2E3030332E3030332D2E3038342E3037312D2E3030332E3030332D2E3030322E3030322D2E3038342E3037322D2E3030332E3030332D2E3030322E3030322D2E3038332E3037332D2E3030332E3030332D2E3030322E3030322D2E3038332E';
wwv_flow_imp.g_varchar2_table(50924) := '3037342D2E3030322E3030322D2E3030332E3030332D2E3038322E3037342D2E3030332E3030332D2E3030322E3030322D2E3038312E3037362D2E3030332E3030322D2E3030332E3030322D2E30382E3037372D2E3030332E3030322D2E3030332E3030';
wwv_flow_imp.g_varchar2_table(50925) := '332D2E30382E3037362D2E3030322E3030332D2E3030332E3030322D2E30382E3037382D2E3030322E3030322D2E3030332E3030332D2E3037392E3037382D2E3030322E3030332D2E3030332E3030322D2E3037382E30382D2E3030332E3030322D2E30';
wwv_flow_imp.g_varchar2_table(50926) := '30322E3030322D2E3037382E30382D2E3030322E3030332D2E3030332E3030322D2E3037372E30382D2E3030332E3030342D2E3030322E3030322D2E3037372E3038312D2E3030322E3030332D2E3030332E3030332D2E3037362E3038322D2E3030322E';
wwv_flow_imp.g_varchar2_table(50927) := '3030322D2E3030332E3030332D2E3037352E3038322D2E3030322E3030332D2E3030332E3030332D2E3037342E3038332D2E3030332E3030332D2E3030322E3030332D2E3037342E3038342D2E3030332E3030332D2E3030322E3030322D2E3037342E30';
wwv_flow_imp.g_varchar2_table(50928) := '38352D2E3030322E3030332D2E3030322E3030332D2E3037332E3038352D2E3030332E3030332D2E3030322E3030332D2E3037322E3038362D2E3030322E3030332D2E3030332E3030332D2E3037312E3038372D2E3030332E3030332D2E3030322E3030';
wwv_flow_imp.g_varchar2_table(50929) := '322D2E30372E3038382D2E3030332E3030332D2E3030322E3030332D2E30372E3038382D2E3030332E3030332D2E3030322E3030332D2E30372E30392D2E3030322E3030322D2E3030322E3030332D2E3036392E30392D2E3030322E3030332D2E303033';
wwv_flow_imp.g_varchar2_table(50930) := '2E3030332D2E3036382E30392D2E3030322E3030332D2E3030322E3030332D2E3036372E3039322D2E3030332E3030332D2E3030322E3030332D2E3036372E3039322D2E3030322E3030332D2E3030322E3030332D2E3036362E3039322D2E3030322E30';
wwv_flow_imp.g_varchar2_table(50931) := '30332D2E3030322E3030342D2E3036362E3039332D2E3030322E3030332D2E3030322E3030332D2E3036352E3039342D2E3030322E3030332D2E3030322E3030342D2E3036342E3039342D2E3030322E3030332D2E3030322E3030342D2E3036332E3039';
wwv_flow_imp.g_varchar2_table(50932) := '352D2E3030322E3030332D2E3030322E3030332D2E3036332E3039372D2E3030322E3030332D2E3030322E3030332D2E3034362E3037332D2E30352E30372D2E3030332E3030322D2E3030322E3030332D2E3036372E3039332D2E3030332E3030332D2E';
wwv_flow_imp.g_varchar2_table(50933) := '3030322E3030332D2E3036362E3039342D2E3030322E3030332D2E3030322E3030332D2E3036362E3039342D2E3030322E3030332D2E3030322E3030332D2E3036342E3039342D2E3030322E3030342D2E3030322E3030332D2E3036342E3039342D2E30';
wwv_flow_imp.g_varchar2_table(50934) := '30322E3030342D2E3030322E3030332D2E3036322E3039352D2E3030322E3030332D2E3030322E3030332D2E3036322E3039362D2E3030322E3030332D2E3030322E3030332D2E30362E3039362D2E3030332E3030332D2E3030322E3030332D2E30362E';
wwv_flow_imp.g_varchar2_table(50935) := '3039362D2E3030312E3030342D2E3030322E3030332D2E3035392E3039362D2E3030322E3030342D2E3030322E3030332D2E3035382E3039372D2E3030322E3030332D2E3030312E3030332D2E3035372E3039382D2E3030322E3030332D2E3030322E30';
wwv_flow_imp.g_varchar2_table(50936) := '30332D2E3035362E3039382D2E3030322E3030332D2E3030322E3030332D2E3035352E3039382D2E3030322E3030342D2E3030312E3030332D2E3035352E3039382D2E3030312E3030342D2E3030322E3030332D2E3035342E3039392D2E3030312E3030';
wwv_flow_imp.g_varchar2_table(50937) := '332D2E3030322E3030332D2E3035322E312D2E3030322E3030322D2E3030322E3030342D2E3035312E312D2E3030322E3030322D2E3030322E3030342D2E30352E312D2E3030322E3030332D2E3030322E3030332D2E30352E31762E3030336C2D2E3030';
wwv_flow_imp.g_varchar2_table(50938) := '322E3030342D2E30352E3156392E356C2D2E3030322E3030342D2E3034382E312D2E3030322E3030342D2E3030312E3030332D2E3034372E3130312D2E3030322E3030332D2E3030312E3030342D2E3031332E3032372D2E3035322E3135322D2E303234';
wwv_flow_imp.g_varchar2_table(50939) := '2E31362E3030362E31362E3033372E3135372E3036342E3134382E3039312E3133332E3131342E3131342E3133342E30392E3134372E3036352E3135372E3033362E3136322E3030362E3135392D2E3032342E3135322D2E3035332E31342D2E30382E31';
wwv_flow_imp.g_varchar2_table(50940) := '32322D2E3130352E312D2E3132362E3036362D2E3131372E30312D2E3032332E3034342D2E3039352E3034352D2E3039352E3030322D2E3030332E3034322D2E3038372E3034382D2E3039372E3034382D2E303935762D2E3030316C2E3034382D2E3039';
wwv_flow_imp.g_varchar2_table(50941) := '322E3030312D2E3030312E3034372D2E30392E30352D2E3039332E3030322D2E3030322E3034392D2E30392E3035322D2E3039322E3030312D2E3030322E3035312D2E3038392E3030312D2E3030322E3035312D2E3038372E3035332D2E3038382E3030';
wwv_flow_imp.g_varchar2_table(50942) := '312D2E3030322E3035352D2E3039312E3035372D2E3039312E3035372D2E30392E3030312D2E3030322E3035372D2E3038392E3035352D2E3038332E3030312D2E3030322E30362D2E30392E30362D2E3038382E3036322D2E3038392E3030312D2E3030';
wwv_flow_imp.g_varchar2_table(50943) := '312E30362D2E3038342E3036332D2E3038382E3036352D2E3038392E3031372D2E3032332E3031362D2E3032352E30362D2E3039342E3035392D2E3039762D2E3030326C2E3035382D2E3038362E3035372D2E3038362E3030312D2E3030312E3036322D';
wwv_flow_imp.g_varchar2_table(50944) := '2E30392E3036322D2E3038382E3030312D2E3030322E30362D2E3038352E3030322D2E3030322E30362D2E3038322E3036332D2E3038372E3036342D2E3038342E3030322D2E3030322E3036312D2E30382E3036352D2E3038342E3036342D2E3038762D';
wwv_flow_imp.g_varchar2_table(50945) := '2E3030316C2E3036372D2E3038332E3036372D2E3038322E30372D2E3038332E3036392D2E30382E3036332D2E3037342E3037342D2E3038332E3036382D2E3037372E3030322D2E3030322E30372D2E3037362E30372D2E3037352E3037322D2E303737';
wwv_flow_imp.g_varchar2_table(50946) := '2E3030312D2E3030312E3036372D2E30372E3037362D2E3037382E3030322D2E3030322E30372D2E30372E3037352D2E3037352E3030322D2E3030322E3037322D2E30372E3037352D2E3037322E3030322D2E3030322E3037332D2E3036392E3037342D';
wwv_flow_imp.g_varchar2_table(50947) := '2E3036382E3030312D2E3030312E30382D2E3037332E3037362D2E3036382E3030322D2E3030322E3037322D2E303633762D2E3030316C2E3037382D2E3036372E3037392D2E3036382E3030322D2E3030312E30382D2E3036382E3030322D2E3030322E';
wwv_flow_imp.g_varchar2_table(50948) := '3037372D2E3036332E3038322D2E3036362E3030312D2E3030312E3037352D2E30362E3030322D2E3030322E3030362D2E3030342E3131372D2E3131312E3039342D2E3133312E3036382D2E3134362E30342D2E3135362E30312D2E3136312D2E303139';
wwv_flow_imp.g_varchar2_table(50949) := '2D2E31362D2E3034392D2E3135342D2E3037362D2E3134312D2E3130322D2E3132352D2E3132332D2E3130352D2E31342D2E3037392D2E3135332D2E3035322D2E31362D2E3032332D2E31362E3030377A6D32342E3539362031312E3038386C2D2E3135';
wwv_flow_imp.g_varchar2_table(50950) := '362E30342D2E3134362E3036372D2E3133312E3039342D2E3131322E3131372D2E3038372E3133352D2E3036312E31352D2E3033332E3135372D2E3030342E3133342E3030372E3134322E3030352E3135322E3030342E31352E3030322E313439762E31';
wwv_flow_imp.g_varchar2_table(50951) := '35336C2E3030312E303131762E3031356C2E3030342E31312E3030322E3131762E3030326C2E3030322E313036762E3332316C2D2E3030332E3130322D2E3030322E3130362D2E3030342E3130372D2E3030352E3130352D2E3030362E3130362D2E3030';
wwv_flow_imp.g_varchar2_table(50952) := '362E3130362D2E3030382E313036762E3030326C2D2E3030382E313033762E3030326C2D2E30312E312D2E30312E3130352D2E30312E3130352D2E3031332E3130352D2E3031322E303939762E3030326C2D2E3031342E3130382D2E3031342E312D2E30';
wwv_flow_imp.g_varchar2_table(50953) := '31362E3130352D2E3031362E313033762E3030326C2D2E3031372E3039392D2E3031382E3130342D2E3031392E313033762E3030326C2D2E3031392E3039372D2E30322E3130342D2E3032322E313033762E3030316C2D2E3032322E3039382D2E303233';
wwv_flow_imp.g_varchar2_table(50954) := '2E313033762E3030326C2D2E3032342E3039362D2E3032352E313033762E3030326C2D2E3032342E3039362D2E3032372E313032762E3030336C2D2E3032362E303933762E3030316C2D2E3032392E313033762E3030326C2D2E30332E3039392D2E3032';
wwv_flow_imp.g_varchar2_table(50955) := '382E303937762E3030326C2D2E30332E3039352D2E30332E303936762E3030316C2D2E3033332E312D2E3033312E303935762E3030326C2D2E3033352E31762E3030336C2D2E3033342E303934762E3030336C2D2E3033352E303936762E3030316C2D2E';
wwv_flow_imp.g_varchar2_table(50956) := '3033342E3039762E3030326C2D2E3033382E3039382D2E3033362E303933762E3030326C2D2E3033382E3039352D2E3037392E3139342D2E30382E3138382D2E3038352E3138392D2E3038372E31392D2E30392E3138342D2E3039322E3138332D2E3039';
wwv_flow_imp.g_varchar2_table(50957) := '352E3138342D2E30352E3039332D2E3036342E3134382D2E3033342E3135382D2E3030352E31362E3032362E31362E3035342E3135312E3038322E31342E3130362E31322E3132372E312E3134332E3037352E3135342E3034362E31362E3031372E3136';
wwv_flow_imp.g_varchar2_table(50958) := '312D2E3031332E3135362D2E3034322E3134342D2E3037312E31332D2E3039362E3130392D2E3131392E3037322D2E3131322E3035332D2E3039392E3030332D2E3030352E3030332D2E3030362E3130322D2E3139352E3030332D2E3030362E3030332D';
wwv_flow_imp.g_varchar2_table(50959) := '2E3030362E3039382D2E3139362E3030332D2E3030362E3030332D2E3030362E3039362D2E3139372E3030322D2E3030362E3030332D2E3030362E3039332D2E322E3030322D2E3030362E3030332D2E3030362E30392D2E322E3030322D2E3030362E30';
wwv_flow_imp.g_varchar2_table(50960) := '30332D2E3030372E3038362D2E3230322E3030332D2E3030362E3030322D2E3030362E3038342D2E3230332E3030322D2E3030352E3030312D2E3030352E30342D2E3130322E3030322D2E3030332E3030312D2E3030332E30342D2E3130332E3030312D';
wwv_flow_imp.g_varchar2_table(50961) := '2E3030332E3030312D2E3030332E30342D2E313033762D2E3030346C2E3030312D2E3030332E3033392D2E313033762D2E3030336C2E3030322D2E3030332E3033372D2E3130342E3030312D2E3030332E3030312D2E3030332E3033372D2E313034762D';
wwv_flow_imp.g_varchar2_table(50962) := '2E3030346C2E3030322D2E3030332E3033352D2E3130342E3030322D2E303033762D2E3030346C2E3033352D2E3130342E3030322D2E303034762D2E3030336C2E3033342D2E3130352E3030322D2E303033762D2E3030336C2E3033342D2E313035762D';
wwv_flow_imp.g_varchar2_table(50963) := '2E3030346C2E3030322D2E3030332E3033322D2E3130362E3030312D2E3030332E3030312D2E3030332E3033312D2E3130362E3030312D2E3030332E3030312D2E3030342E3033312D2E3130362E3030312D2E3030332E3030312D2E3030342E30332D2E';
wwv_flow_imp.g_varchar2_table(50964) := '313036762D2E3030336C2E3030322D2E3030342E3032382D2E3130372E3030312D2E3030332E3030312D2E3030332E3032382D2E3130372E3030312D2E3030342E3030312D2E3030332E3032372D2E3130372E3030312D2E303034762D2E3030336C2E30';
wwv_flow_imp.g_varchar2_table(50965) := '32372D2E3130382E3030312D2E303033762D2E3030346C2E3032362D2E3130382E3030312D2E303033762D2E3030346C2E3032352D2E3130382E3030312D2E303033762D2E3030346C2E3032352D2E313038762D2E3030346C2E3030312D2E3030332E30';
wwv_flow_imp.g_varchar2_table(50966) := '32332D2E313039762D2E3030336C2E3030312D2E3030342E3032322D2E313039762D2E3030336C2E3030322D2E3030342E30322D2E3130392E3030312D2E303034762D2E3030336C2E30322D2E31312E3030322D2E303033762D2E3030346C2E30322D2E';
wwv_flow_imp.g_varchar2_table(50967) := '3131762D2E3030376C2E3031392D2E3131762D2E3030336C2E3030312D2E3030342E3031372D2E3131762D2E3030346C2E3030312D2E3030332E3031372D2E3131762D2E3030386C2E3031362D2E3131762D2E3030346C2E3030312D2E3030342E303135';
wwv_flow_imp.g_varchar2_table(50968) := '2D2E3131762D2E3030386C2E3031352D2E313131762D2E3030386C2E3031332D2E313131762D2E3030376C2E3031332D2E313132762D2E3030376C2E3031312D2E313132762D2E3030346C2E3030312D2E3030342E30312D2E313132762D2E3030376C2E';
wwv_flow_imp.g_varchar2_table(50969) := '30312D2E313132762D2E3030386C2E3030382D2E313132762D2E3030386C2E3030372D2E313133762D2E3030376C2E3030372D2E313133762D2E3030386C2E3030352D2E313133762D2E3030376C2E3030352D2E313134762D2E3030376C2E3030332D2E';
wwv_flow_imp.g_varchar2_table(50970) := '313134762D2E3030376C2E3030332D2E313134762D2E3132396C2E3030312D2E313134762D2E31336C2D2E3030332D2E3131345631362E356C2D2E3030332D2E313135762D2E3030376C2D2E3030332D2E313032762D2E3135356C2D2E3030332D2E3135';
wwv_flow_imp.g_varchar2_table(50971) := '38762D2E30316C2D2E3030342D2E313538762D2E30316C2D2E3030362D2E313538762D2E30316C2D2E3030372D2E3134382D2E3032332D2E31362D2E3035312D2E3135322D2E30382D2E31342D2E3130332D2E3132342D2E3132352D2E3130322D2E3134';
wwv_flow_imp.g_varchar2_table(50972) := '322D2E3037372D2E3135332D2E30352D2E31362D2E30322D2E3136312E30317A6D2D33302E3231332E36366C2D2E3135372E3033342D2E3134392E3036332D2E3133342E30392D2E3131352E3131332D2E3039322E3133322D2E3036372E3134372D2E30';
wwv_flow_imp.g_varchar2_table(50973) := '33372E3135362D2E3030392E3133342E3030312E31315631362E3330386C2E3030362E3232762E3031326C2E30312E3232762E3031326C2E3031322E3232762E3030366C2E3030312E3030362E3031352E3232762E3030356C2E3030312E3030362E3031';
wwv_flow_imp.g_varchar2_table(50974) := '382E32322E3030312E303036762E3030366C2E3032322E323139762E3030366C2E3030312E3030362E3032342E3231392E3030312E303036762E3030366C2E3032382E3231382E3030312E303036762E3030366C2E3033312E3231382E3030312E303036';
wwv_flow_imp.g_varchar2_table(50975) := '2E3030312E3030362E3033332E3231382E3030312E3030362E3030312E3030352E3033372E323138762E3030366C2E3030322E3030352E30342E323137762E3030366C2E3030312E3030362E3034332E3231362E3030312E3030362E3030312E3030362E';
wwv_flow_imp.g_varchar2_table(50976) := '3034362E323136762E3030356C2E3030322E3030362E3034382E3231352E3030322E3030362E3030312E3030362E3035312E3231342E3030322E303036762E3030366C2E3035352E3231342E3030322E3030352E3030312E3030362E3035372E3231332E';
wwv_flow_imp.g_varchar2_table(50977) := '3030322E3030362E3030312E3030352E30362E3231332E3030322E3030352E3030312E3030362E3036332E3231322E3030322E3030352E3030312E3030362E3036362E32312E3030322E3030362E3030322E3030362E3036382E32312E3030322E303035';
wwv_flow_imp.g_varchar2_table(50978) := '2E3030322E3030352E30372E32312E3030332E3030352E3030322E3030352E3037342E3230382E3030322E3030362E3030322E3030352E3037372E3230372E3030322E3030362E3030322E3030352E30382E3230362E3030322E3030352E3030322E3030';
wwv_flow_imp.g_varchar2_table(50979) := '362E3038322E3230342E3030322E3030362E3030322E3030352E3038362E3230342E3030322E3030352E3030322E3030362E3038382E3230322E3030322E3030352E3030332E3030362E30392E322E3030332E3030362E3030322E3030352E3039342E32';
wwv_flow_imp.g_varchar2_table(50980) := '2E3030322E3030362E3030332E3030352E3039362E3139392E3030322E3030352E3030332E3030352E30332E3036322E3038362E3133372E31312E3131382E3132382E3039372E3134352E30372E3135362E3034332E31362E3031332E31362D2E303137';
wwv_flow_imp.g_varchar2_table(50981) := '2E3135352D2E3034372E3134332D2E3037342E3132372D2E312E3130362D2E3132312E3038312D2E31342E3035352D2E31352E3032352D2E31362D2E3030352D2E3136312D2E3033342D2E3135382D2E30352D2E3132342D2E3032382D2E3035352D2E30';
wwv_flow_imp.g_varchar2_table(50982) := '39322D2E31392D2E3038372D2E3138382D2E3038372D2E3139322D2E3038332D2E31392D2E30382D2E3139332D2E3037382D2E3139342D2E3037362D2E3139362D2E3037332D2E3139352D2E30372D2E3139372D2E3036372D2E3139382D2E3036352D2E';
wwv_flow_imp.g_varchar2_table(50983) := '3139392D2E3036332D2E322D2E3035392D2E322D2E3035362D2E322D2E3035352D2E3230342D2E30352D2E3230312D2E3034392D2E3230322D2E3034362D2E3230352D2E3034332D2E3230362D2E30342D2E3230332D2E3033382D2E3230372D2E303334';
wwv_flow_imp.g_varchar2_table(50984) := '2D2E3230342D2E3033322D2E3230372D2E3032382D2E3230352D2E3032362D2E3230372D2E3032332D2E3230382D2E30322D2E3230372D2E3031382D2E3230372D2E3031342D2E3230382D2E3031312D2E3230372D2E3030392D2E3230382D2E3030352D';
wwv_flow_imp.g_varchar2_table(50985) := '2E3230372D2E3030322D2E3130342D2E3031372D2E31362D2E3034362D2E3135352D2E3037342D2E3134332D2E312D2E3132362D2E3132312D2E3130372D2E3133392D2E3038312D2E3135322D2E3035352D2E3135392D2E3032352D2E3136312E303034';
wwv_flow_imp.g_varchar2_table(50986) := '7A6D32342E3538352031312E38336C2D2E3135362E3033392D2E3134362E3036382D2E31312E3037362D2E3031352E3031322D2E3136332E3132392D2E3136362E3132372D2E3136382E3132352D2E31372E3132342D2E31372E31322D2E3137322E3131';
wwv_flow_imp.g_varchar2_table(50987) := '382D2E3137332E3131352D2E3137362E3131342D2E3137372E3131312D2E31382E31312D2E3137382E3130352D2E3138322E3130342D2E3138322E3130312D2E3138342E312D2E3138342E3039352D2E3138392E3039352D2E3138362E30392D2E313838';
wwv_flow_imp.g_varchar2_table(50988) := '2E3038392D2E31392E3038362D2E31392E3038322D2E3139332E3038312D2E3139352E3037382D2E3139312E3037342D2E3139372E3037332D2E3139352E30372D2E3139362E3036352D2E3139382E3036342D2E3139382E3036312D2E322E3035382D2E';
wwv_flow_imp.g_varchar2_table(50989) := '322E3035352D2E322E3035322D2E322E3034392D2E3135312E3033352D2E3135332E30352D2E3134312E3037382D2E3132352E3130332D2E3130332E3132342D2E3037382E31342D2E30352E3135342D2E3032322E31362E3030392E31362E3033382E31';
wwv_flow_imp.g_varchar2_table(50990) := '35372E3036372E3134372E3039332E3133322E3131362E3131322E3133342E3038392E3134392E3036322E3135382E3033342E31362E3030332E3133332D2E30322E3135382D2E3033352E3030362D2E3030322E3030362D2E3030312E3231332D2E3035';
wwv_flow_imp.g_varchar2_table(50991) := '322E3030362D2E3030322E3030372D2E3030312E3231322D2E3035362E3030362D2E3030312E3030362D2E3030322E3231322D2E3035382E3030362D2E3030322E3030362D2E3030322E3231312D2E3036312E3030362D2E3030322E3030362D2E303032';
wwv_flow_imp.g_varchar2_table(50992) := '2E32312D2E3036342E3030362D2E3030322E3030362D2E3030322E32312D2E3036372E3030352D2E3030322E3030362D2E3030322E3230382D2E30372E3030362D2E3030322E3030362D2E3030332E3230372D2E3037332E3030362D2E3030322E303036';
wwv_flow_imp.g_varchar2_table(50993) := '2D2E3030322E3230362D2E3037372E3030362D2E3030322E3030352D2E3030322E3230362D2E30382E3030352D2E3030312E3030362D2E3030332E3230342D2E3038322E3030362D2E3030322E3030352D2E3030322E3230332D2E3038352E3030362D2E';
wwv_flow_imp.g_varchar2_table(50994) := '3030332E3030352D2E3030322E3230322D2E3038382E3030362D2E3030322E3030352D2E3030332E322D2E30392E3030362D2E3030332E3030362D2E3030332E322D2E3039332E3030352D2E3030332E3030352D2E3030322E3139382D2E3039362E3030';
wwv_flow_imp.g_varchar2_table(50995) := '362D2E3030332E3030352D2E3030332E3139372D2E3039392E3030352D2E3030322E3030352D2E3030332E3139362D2E3130322E3030352D2E3030322E3030352D2E3030332E3139352D2E3130352E3030352D2E3030322E3030352D2E3030332E313933';
wwv_flow_imp.g_varchar2_table(50996) := '2D2E3130372E3030352D2E3030332E3030352D2E3030332E3139312D2E31312E3030352D2E3030332E3030352D2E3030332E31392D2E3131322E3030352D2E3030332E3030352D2E3030332E3138392D2E3131352E3030352D2E3030332E3030352D2E30';
wwv_flow_imp.g_varchar2_table(50997) := '30332E3138372D2E3131372E3030352D2E3030332E3030342D2E3030342E3138362D2E31322E3030352D2E3030332E3030342D2E3030332E3138342D2E3132322E3030352D2E3030332E3030352D2E3030342E3138322D2E3132352E3030342D2E303033';
wwv_flow_imp.g_varchar2_table(50998) := '2E3030352D2E3030332E31382D2E3132382E3030352D2E3030332E3030352D2E3030332E3137392D2E31332E3030342D2E3030332E3030352D2E3030342E3137372D2E3133322E3030342D2E3030342E3030352D2E3030332E3137352D2E3133352E3030';
wwv_flow_imp.g_varchar2_table(50999) := '352D2E3030332E3030342D2E3030342E3137332D2E3133372E3030352D2E3030332E3030342D2E3030342E3031392D2E3031352E3131352D2E3131332E3039322D2E3133322E3036362D2E3134372E3033382D2E3135372E3030382D2E31362D2E303232';
wwv_flow_imp.g_varchar2_table(51000) := '2D2E31362D2E3035322D2E3135332D2E3037392D2E31342D2E3130332D2E3132342D2E3132352D2E3130322D2E3134322D2E3037382D2E3135332D2E30352D2E31362D2E30322D2E31362E30317A6D2D31392E31372E3035346C2D2E3135332E3035312D';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(51001) := '2E31342E3037392D2E3132342E3130332D2E3130332E3132352D2E3037372E3134312D2E30352E3135332D2E30322E31362E3030392E3136312E30342E3135362E3036372E3134372E3039332E3133312E3039352E3039342E3034372E30342E3030352E';
wwv_flow_imp.g_varchar2_table(51002) := '3030342E3030352E3030342E31372E31342E3030352E3030342E3030352E3030342E3137322E3133372E3030342E3030342E3030352E3030332E3038362E3036372E3030332E3030322E3030332E3030322E3038372E3036372E3030332E3030322E3030';
wwv_flow_imp.g_varchar2_table(51003) := '332E3030322E3038382E3036362E3030322E3030332E3030332E3030322E3038392E3036352E3030322E3030322E3030332E3030322E30392E3036352E3030322E3030322E3030332E3030322E30392E3036342E3030322E3030322E3030332E3030322E';
wwv_flow_imp.g_varchar2_table(51004) := '30392E3036332E3030332E3030322E3030332E3030322E30392E3036332E3030332E3030322E3030332E3030322E3039322E3036322E3030322E3030322E3030332E3030322E3039322E3036312E3030332E3030322E3030332E3030322E3039322E3036';
wwv_flow_imp.g_varchar2_table(51005) := '2E3030332E3030332E3030332E3030312E3039332E30362E3030332E3030322E3030332E3030322E3039332E30362E3030332E3030312E3030332E3030322E3039342E3035382E3030332E3030322E3030332E3030322E3039352E3035382E3030332E30';
wwv_flow_imp.g_varchar2_table(51006) := '30312E3030332E3030322E3039352E3035372E3030332E3030322E3030332E3030322E3039352E3035362E3030332E3030322E3030332E3030322E3039362E3035352E3030342E3030322E3030332E3030312E3039362E3035352E3030332E3030322E30';
wwv_flow_imp.g_varchar2_table(51007) := '30332E3030322E3039382E3035332E3030332E3030322E3030332E3030322E3039372E3035332E3030342E3030322E3030332E3030312E3039382E3035332E3030332E3030312E3030332E3030322E3039392E3035322E3030332E3030312E3030332E30';
wwv_flow_imp.g_varchar2_table(51008) := '30322E312E30352E3030332E3030322E3030332E3030322E312E30352E3030332E3030322E3030332E3030312E312E3035682E3030336C2E3030342E3030332E312E3034382E3030342E3030312E3030332E3030322E3130312E3034382E3030332E3030';
wwv_flow_imp.g_varchar2_table(51009) := '312E3030342E3030322E3130312E3034362E3030342E3030322E3030332E3030312E3130322E3034362E3030342E3030322E3030332E3030312E3130332E3034352E3030332E3030322E3030332E3030312E3130332E3034352E3030342E3030312E3030';
wwv_flow_imp.g_varchar2_table(51010) := '332E3030322E3130342E3034332E3030332E3030312E3030342E3030322E3130342E3034322E3030332E3030322E3030342E3030312E3130342E3034322E3030342E3030312E3030332E3030322E3130352E30342E3030342E3030322E3030332E303031';
wwv_flow_imp.g_varchar2_table(51011) := '2E3130362E30342E3030332E303032682E3030346C2E3130362E30342E3030342E3030312E3030332E3030322E3130372E3033382E3030332E3030312E3030342E3030312E3130372E3033382E3030332E3030312E3030342E3030312E3130372E303337';
wwv_flow_imp.g_varchar2_table(51012) := '2E3030342E3030312E3030342E3030312E3130382E3033362E3030332E3030312E3030342E3030312E3130382E3033352E3030342E3030312E3030332E3030312E31312E3033342E3030332E3030312E3030342E3030312E3130392E3033332E3030342E';
wwv_flow_imp.g_varchar2_table(51013) := '303032682E3030336C2E31312E303333682E3030346C2E3030332E3030322E31312E3033312E3030342E3030312E3030342E3030312E3038342E3032332E3038312E3032382E3030342E3030312E3030332E3030312E3130392E3033372E3030332E3030';
wwv_flow_imp.g_varchar2_table(51014) := '312E3030342E3030312E3130392E3033362E3030332E3030312E3030342E3030312E3130392E303335682E3030336C2E3030342E3030322E31312E3033332E3030332E3030312E3030332E3030312E31312E3033332E3030332E3030312E3030342E3030';
wwv_flow_imp.g_varchar2_table(51015) := '312E3130392E3033312E3030342E303032682E3030336C2E31312E3033312E3030332E3030312E3030342E3030312E31312E3033682E3030336C2E3030332E3030312E31312E303239682E3030346C2E3030332E3030322E31312E3032372E3030332E30';
wwv_flow_imp.g_varchar2_table(51016) := '30312E3030342E3030312E31312E303237682E3030336C2E3030342E3030312E3030342E3030312E31362E3032322E31362D2E3030382E3135372D2E3033382E3134372D2E3036372E3133322D2E3039322E3131322D2E3131362E30392D2E3133342E30';
wwv_flow_imp.g_varchar2_table(51017) := '36322D2E3134392E3033342D2E3135372E3030342D2E3136312D2E3032352D2E31362D2E3035352D2E3135312D2E3038322D2E3133392D2E3130372D2E31322D2E3132372D2E312D2E3134332D2E3037342D2E3132342D2E3034682D2E3030336C2D2E31';
wwv_flow_imp.g_varchar2_table(51018) := '30342D2E3032352D2E3130332D2E303236682D2E3030326C2D2E3039352D2E303236682D2E3030316C2D2E3130312D2E303237682D2E3030326C2D2E312D2E303238682D2E3030326C2D2E3130332D2E30332D2E3130342D2E3033322D2E3039372D2E30';
wwv_flow_imp.g_varchar2_table(51019) := '33682D2E3030326C2D2E3130332D2E3033332D2E3130322D2E3033332D2E3130312D2E3033342D2E3130362D2E3033362D2E3032372D2E30312D2E3032372D2E3030372D2E3130372D2E30332D2E3130342D2E3032392D2E3130342D2E3033682D2E3030';
wwv_flow_imp.g_varchar2_table(51020) := '326C2D2E3039372D2E30332D2E3130322D2E3033322D2E3130322D2E3033322D2E3130322D2E3033342D2E3130332D2E3033352D2E3039362D2E3033342D2E312D2E3033362D2E3130312D2E303337682D2E3030326C2D2E3039342D2E3033362D2E3039';
wwv_flow_imp.g_varchar2_table(51021) := '362D2E3033372D2E3039372D2E3034682D2E3030326C2D2E3039392D2E30342D2E3039382D2E303432682D2E3030326C2D2E3039322D2E30342D2E3039372D2E3034332D2E3039352D2E3034332D2E3039372D2E303434682D2E3030326C2D2E30392D2E';
wwv_flow_imp.g_varchar2_table(51022) := '3034332D2E3039342D2E3034352D2E3039342D2E3034362D2E3039332D2E3034372D2E30392D2E3034362D2E3039362D2E30352D2E3038382D2E3034372D2E3030322D2E3030312D2E30392D2E3034392D2E3039342D2E3035322D2E3030322D2E303032';
wwv_flow_imp.g_varchar2_table(51023) := '2D2E3038372D2E3034392D2E3038372D2E3035682D2E3030326C2D2E3038382D2E303533682D2E3030316C2D2E30392D2E3035352D2E3038362D2E3035322D2E3030322D2E3030312D2E3038392D2E3035352D2E3038342D2E303534682D2E3030326C2D';
wwv_flow_imp.g_varchar2_table(51024) := '2E30392D2E303539682D2E3030316C2D2E3038352D2E3035362D2E3030312D2E3030312D2E3038342D2E3035362D2E3038322D2E303536682D2E3030316C2D2E3038362D2E30362D2E3038322D2E30353848372E37396C2D2E3038362D2E3036322D2E30';
wwv_flow_imp.g_varchar2_table(51025) := '30322D2E3030322D2E30382D2E3035382D2E3038312D2E3036682D2E3030316C2D2E3038352D2E3036342D2E3030322D2E3030322D2E3037362D2E3035382D2E3030322D2E3030322D2E3038322D2E3036342D2E3136312D2E3132382D2E3136322D2E31';
wwv_flow_imp.g_varchar2_table(51026) := '33332D2E30342D2E3033342D2E3133322D2E3039322D2E3134372D2E3036362D2E3135372D2E3033382D2E31362D2E3030382D2E31362E3032327A227D29292C43616E63656C426F756E646172794576656E743A726A2C436F6D70656E73617465426F75';
wwv_flow_imp.g_varchar2_table(51027) := '6E646172794576656E743A6C6A2C436F6E646974696F6E616C426F756E646172794576656E743A646A2C4572726F72426F756E646172794576656E743A756A2C457363616C6174696F6E426F756E646172794576656E743A676A2C4C696E6B426F756E64';
wwv_flow_imp.g_varchar2_table(51028) := '6172794576656E743A666A2C4D657373616765426F756E646172794576656E743A626A2C4D756C7469706C65426F756E646172794576656E743A796A2C426F756E646172794576656E743A576A2C436F6E646974696F6E616C426F756E64617279457665';
wwv_flow_imp.g_varchar2_table(51029) := '6E744E6F6E496E74657272757074696E673A436A2C457363616C6174696F6E426F756E646172794576656E744E6F6E496E74657272757074696E673A786A2C4D657373616765426F756E646172794576656E744E6F6E496E74657272757074696E673A45';
wwv_flow_imp.g_varchar2_table(51030) := '6A2C4D756C7469706C65426F756E646172794576656E744E6F6E496E74657272757074696E673A446A2C506172616C6C656C426F756E646172794576656E744E6F6E496E74657272757074696E673A496A2C5369676E616C426F756E646172794576656E';
wwv_flow_imp.g_varchar2_table(51031) := '744E6F6E496E74657272757074696E673A416A2C54696D6572426F756E646172794576656E744E6F6E496E74657272757074696E673A506A2C506172616C6C656C4D756C7469706C65426F756E646172794576656E743A526A2C5369676E616C426F756E';
wwv_flow_imp.g_varchar2_table(51032) := '646172794576656E743A426A2C54696D6572426F756E646172794576656E743A7A6A2C53746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7671287B786D6C6E733A22687474703A2F2F7777772E77';
wwv_flow_imp.g_varchar2_table(51033) := '332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3834372E30303443392E36312D2E30313620332E36323420342E30313420312E32353720392E37';
wwv_flow_imp.g_varchar2_table(51034) := '382D312E3233352031352E34392E30362032322E35383120342E34322032372E30333463342E31393320342E3531332031312E31303120362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E';
wwv_flow_imp.g_varchar2_table(51035) := '3636342D31342E3236382E3430332D362E3232382D332E32362D31322E3434312D382E38372D31352E3135344131352E3932342031352E393234203020303031352E3834362E3030347A6D2E34333920312E37323963362E3130352E3033332031312E38';
wwv_flow_imp.g_varchar2_table(51036) := '353620342E34352031332E3433352031302E33353920312E36373820352E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E3632352D342E3831342D';
wwv_flow_imp.g_varchar2_table(51037) := '332E38342D362E3533382D31302E39342D342E3036372D31362E353720322E31342D352E32303620372E3531352D382E3737352031332E3134372D382E37312E3039372D2E3030312E3139342D2E3030322E32392D2E3030317A227D29292C506172616C';
wwv_flow_imp.g_varchar2_table(51038) := '6C656C4D756C7469706C6553746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C6271287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A2233';
wwv_flow_imp.g_varchar2_table(51039) := '32222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E383437203043392E36312D2E303220332E36323420342E303120312E32353720392E3737352D312E3233352031352E3438352E30362032322E35373720342E';
wwv_flow_imp.g_varchar2_table(51040) := '34322032372E303363342E31393320342E3531332031312E31303120362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636342D31342E3236382E3430332D362E3232382D332E32362D31';
wwv_flow_imp.g_varchar2_table(51041) := '322E3434312D382E38372D31352E3135344131352E3932342031352E393234203020303031352E38343620307A6D2E34333920312E37323963362E3130352E3033332031312E38353620342E34352031332E3433352031302E33353920312E3637382035';
wwv_flow_imp.g_varchar2_table(51042) := '2E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E36323543322E3130312032332E31372E3337372031362E303720322E3834382031302E34346332';
wwv_flow_imp.g_varchar2_table(51043) := '2E3133342D352E3220372E3532322D382E37382031332E3134372D382E37312E3039372D2E3030312E3139342D2E3030322E32392D2E3030317A4D31332E35303420392E303876342E34323748392E30373776342E393868342E34323776342E34323768';
wwv_flow_imp.g_varchar2_table(51044) := '342E3938762D342E34323768342E343238762D342E3938682D342E34323756392E3038682D342E39387A6D2E38332E383368332E333276342E34323768342E34323876332E3332682D342E34323776342E343237682D332E3332762D342E34353348392E';
wwv_flow_imp.g_varchar2_table(51045) := '393036762D332E32393468342E34323756392E39317A227D29292C5369676E616C53746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C5F71287B786D6C6E733A22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(51046) := '6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D31352E3939352E30303543392E3730352D2E303820332E36343320332E39363820312E32353720392E37382D';
wwv_flow_imp.g_varchar2_table(51047) := '312E3233352031352E34392E30362032322E35383120342E34322032372E30333463342E31393320342E3531332031312E31303220362E31372031362E38383720342E30353820352E3939362D322E3034322031302E3432332D372E39332031302E3636';
wwv_flow_imp.g_varchar2_table(51048) := '342D31342E3236392E3430332D362E3232372D332E32362D31322E34342D382E38372D31352E3135334131352E3932342031352E393234203020303031352E3939342E3030357A6D3020312E373363362E3231332D2E3130382031322E31323220342E33';
wwv_flow_imp.g_varchar2_table(51049) := '35352031332E3732362031302E33353720312E36373820352E3635332D2E3539322031322E3139382D352E3436332031352E3534372D352E303620332E3731392D31322E35363420332E34352D31372E3334332D2E3632362D342E3831342D332E383338';
wwv_flow_imp.g_varchar2_table(51050) := '2D362E3533382D31302E3933392D342E3036372D31362E353720322E31342D352E32303520372E3531352D382E3737342031332E3134372D382E3730387A6D3020362E3737364C392E31392032302E3732344832322E384C31352E39393520382E353131';
wwv_flow_imp.g_varchar2_table(51051) := '7A6D3020312E3737376C352E33333220392E3537324831302E3636326C352E3333332D392E3537327A227D29292C54696D657253746172744576656E743A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C7971287B786D6C';
wwv_flow_imp.g_varchar2_table(51052) := '6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D3136203043372E3137342030203020372E313734203020313673';
wwv_flow_imp.g_varchar2_table(51053) := '372E3137342031362031362031362031362D372E3137342031362D31365332342E383236203020313620307A6D3020312E373363372E38393220302031342E323720362E3337382031342E32372031342E3237203020372E3839312D362E333739203134';
wwv_flow_imp.g_varchar2_table(51054) := '2E32372D31342E32372031342E323753312E37332032332E38393120312E373320313643312E373320382E31303820382E31303820312E373320313620312E37337A6D2D2E31343320362E363736632D322E3936372E30322D352E37393720312E39372D';
wwv_flow_imp.g_varchar2_table(51055) := '362E383920342E3732372D312E31333820322E3639352D2E353120362E30313220312E35333720382E31303220312E393920322E31343220352E32363820322E39333220382E30313420312E39323820322E3837382D2E393820342E3939322D332E3832';
wwv_flow_imp.g_varchar2_table(51056) := '3720352E3036382D362E38372E3135332D322E3935372D312E3632342D352E3838312D342E332D372E31333761372E35353220372E35353220302030302D332E34332D2E37357A6D2E323720312E33383363322E37312E30313220352E32353420322E30';
wwv_flow_imp.g_varchar2_table(51057) := '313520352E38383620342E3635362E37303420322E3537372D2E34383220352E3531372D322E37393120362E3836372D322E33353820312E34382D352E36383220312E3038352D372E3631382D2E3931382D322E3034332D312E3937312D322E3430372D';
wwv_flow_imp.g_varchar2_table(51058) := '352E3338312D2E38342D372E37343520312E31312D312E37363320332E31352D322E383820352E3233342D322E3836682E31337A6D312E38333320312E3736356C2D322E30373420332E373633632D2E36342E3036382D2E37393320312E30342D2E3230';
wwv_flow_imp.g_varchar2_table(51059) := '3220312E332E33392E32372E3639362D2E313820312E3035322D2E31363568332E3137762D2E383635682D332E3138316C312E3939322D332E3631352D2E3735372D2E3431387A227D29292C436F6C6C617073656453756250726F636573733A43712C43';
wwv_flow_imp.g_varchar2_table(51060) := '6F6C6C61707365644164486F6353756250726F636573733A43712C457870616E64656453756250726F636573733A78712C457870616E6465644164486F6353756250726F636573733A78712C5461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D';
wwv_flow_imp.g_varchar2_table(51061) := '293D3E4E432822737667222C6B71287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D362E3439342032';
wwv_flow_imp.g_varchar2_table(51062) := '2E36363743322E39313620322E363637203020352E3537203020392E3134327631332E33383343302032362E30393720322E39313620323920362E3439342032396831392E3031324332392E3038342032392033322032362E3039372033322032322E35';
wwv_flow_imp.g_varchar2_table(51063) := '323556392E31343263302D332E3537322D322E3931362D362E3437352D362E3439342D362E34373548362E3439347A6D3020326831392E30313263322E353039203020342E34393420312E393820342E34393420342E3437357631332E33383343333020';
wwv_flow_imp.g_varchar2_table(51064) := '32352E30322032382E3031352032372032352E35303620323748362E34393443332E39383520323720322032352E303220322032322E35323556392E31343263302D322E34393520312E3938352D342E34373520342E3439342D342E3437357A227D2929';
wwv_flow_imp.g_varchar2_table(51065) := '2C54657874416E6E6F746174696F6E3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4571287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C686569';
wwv_flow_imp.g_varchar2_table(51066) := '6768743A223332227D2C74292C4E43282270617468222C7B643A224D32322E30383720307633312E363437483332762D312E373838682D382E31323556312E3738384833325630682D392E3931337A6D2D322E3932342031332E3939396C2D322E373337';
wwv_flow_imp.g_varchar2_table(51067) := '20322E31363720322E31363720322E37333820322E3733382D322E3136372D322E3136382D322E3733387A6D2D352E34373520342E3333354C31302E39352032302E356C322E31363820322E37333820322E3733372D322E3136382D322E3136372D322E';
wwv_flow_imp.g_varchar2_table(51068) := '3733377A6D2D352E34373520342E3333356C2D322E37333820322E31363720322E31363820322E37333820322E3733372D322E3136382D322E3136372D322E3733377A6D2D352E34373620342E3333354C302032392E31376C322E31363720322E373338';
wwv_flow_imp.g_varchar2_table(51069) := '20322E3733382D322E3136382D322E3136382D322E3733377A227D29292C5472616E73616374696F6E3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4C71287B786D6C6E733A22687474703A2F2F7777772E77332E6F72';
wwv_flow_imp.g_varchar2_table(51070) := '672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B643A224D352E343232203341352E34323420352E34323420302030303020382E3432327631352E38323261352E3432342035';
wwv_flow_imp.g_varchar2_table(51071) := '2E3432342030203030352E34323220352E3432336832312E31353641352E34323420352E343234203020303033322032342E32343456382E34323241352E34323420352E343234203020303032362E353738203348352E3432327A6D3020312E32343468';
wwv_flow_imp.g_varchar2_table(51072) := '32312E31353661342E31353520342E3135352030203031342E31373820342E3137387631352E38323261342E31353520342E31353520302030312D342E31373820342E31373848352E34323261342E31353520342E31353520302030312D342E3137382D';
wwv_flow_imp.g_varchar2_table(51073) := '342E31373856382E34323261342E31353520342E3135352030203031342E3137382D342E3137387A6D312E30353620312E37373861332E33373320332E33373320302030302D332E33363720332E3336367631332E383961332E33373320332E33373320';
wwv_flow_imp.g_varchar2_table(51074) := '30203030332E33363720332E3336366831392E30343461332E33373320332E3337332030203030332E3336372D332E33363656392E33383861332E33373320332E33373320302030302D332E3336372D332E33363648362E3437387A6D3020312E323435';
wwv_flow_imp.g_varchar2_table(51075) := '6831392E30343463312E313837203020322E3132322E39333520322E31323220322E3132317631332E383961322E31303420322E31303420302030312D322E31323220322E31323248362E34373861322E31303420322E31303420302030312D322E3132';
wwv_flow_imp.g_varchar2_table(51076) := '322D322E31323256392E33383863302D312E3138362E3933352D322E31323120322E3132322D322E3132317A227D29292C557365725461736B3A287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4471287B786D6C6E733A22';
wwv_flow_imp.g_varchar2_table(51077) := '687474703A2F2F7777772E77332E6F72672F323030302F737667222C77696474683A223332222C6865696768743A223332227D2C74292C4E43282270617468222C7B66696C6C52756C653A226576656E6F6464222C643A224D31302E32363320372E3436';
wwv_flow_imp.g_varchar2_table(51078) := '38632D312E36393820302D322E39313220312E3330352D322E39313520322E373931762E3030316330202E34352E3132312E3932342E33313120312E3335322E3133382E3330392E3330382E3539332E3531362E38322D312E3233352E3432332D322E36';
wwv_flow_imp.g_varchar2_table(51079) := '383320312E3131392D332E34313420322E34396C2D2E30342E30373576342E34346831312E303833762D342E34346C2D2E30342D2E303734632D2E37322D312E3335322D322E3133362D322E3034372D332E33362D322E3437312E3539372D2E3630382E';
wwv_flow_imp.g_varchar2_table(51080) := '3737342D312E3339322E3737342D322E3139322D2E3030342D312E3438372D312E3231382D322E3739322D322E3931352D322E3739327A6D2D312E313620312E353833632E30382030202E3136352E3030332E32362E3030382E3735372E30343520312E';
wwv_flow_imp.g_varchar2_table(51081) := '3031322E31383120312E3230372E33312E3139362E31332E3333342E3235322E3835312E3236382E3430342D2E3031362E3539382D2E3038372E3733372D2E3136392E3035362D2E3033332E3130332D2E3036372E3135322D2E312E3132382E3237352E';
wwv_flow_imp.g_varchar2_table(51082) := '3139372E3537382E3139382E3839332030202E3839342D2E31353420312E35322D2E39373520322E3033346C2E30382E363034632E3137312E3035322E3334382E31312E3532372E3137312E3032352E3130352E3035342E3234322E3037332E3338372E';
wwv_flow_imp.g_varchar2_table(51083) := '30322E3135332E3032392E3331312E3031362E3433612E3432322E34323220302030312D2E3035362E3139632D2E3431372E3431372D312E3135372E36362D312E3930382E36362D2E373520302D312E34392D2E3234332D312E3930382D2E3636612E34';
wwv_flow_imp.g_varchar2_table(51084) := '32322E34323220302030312D2E3035362D2E313920312E39343920312E39343920302030312E3031362D2E3433632E30322D2E3134362E3034392D2E3238342E3037342D2E3338382E3137372D2E3036322E3335322D2E3131382E3532312D2E31376C2E';
wwv_flow_imp.g_varchar2_table(51085) := '3034382D2E363438612E3631362E36313620302030302D2E3132362D2E313138632D2E3138332D2E3133382D2E3430352D2E34342D2E3536322D2E3739332D2E3135372D2E3335332D2E3235342D2E3735372D2E3235342D312E303820302D2E3338372E';
wwv_flow_imp.g_varchar2_table(51086) := '3130352D2E3735382E3239372D312E3037396C2E31312D2E3034632E3134332D2E3034362E3333392D2E30392E3637392D2E30397A6D2D312E34343820342E3330346C2D2E3030322E303134632D2E3032352E3138352D2E30342E3338372D2E3031382E';
wwv_flow_imp.g_varchar2_table(51087) := '3538392E3032312E3230322E3037342E34322E3234382E3539332E3539352E35393420312E3439342E38353720322E3338322E3835372E383839203020312E3738382D2E32363320322E3338322D2E3835372E3137342D2E3137342E3232372D2E333931';
wwv_flow_imp.g_varchar2_table(51088) := '2E3234392D2E35393361322E34393620322E34393620302030302D2E3031382D2E35396C2D2E3030322D2E3031632E3930332E33393620312E3737362E39363320322E32353820312E383176332E3539394831332E3533762D322E353338682D2E363776';
wwv_flow_imp.g_varchar2_table(51089) := '322E35333848372E363531762D322E353338682D2E363776322E35333848352E3339762D332E353939632E3438332D2E38343920312E3335392D312E34313620322E3236342D312E3831337A4D362E343935203343322E3931342033203020352E393033';
wwv_flow_imp.g_varchar2_table(51090) := '203020392E3437357631332E333833633020332E35373220322E39313620362E34373520362E34393420362E3437356831392E30313263332E353738203020362E3439342D322E39303320362E3439342D362E34373556392E34373543333220352E3930';
wwv_flow_imp.g_varchar2_table(51091) := '332032392E30383420332032352E353036203348362E3439347A6D3020326831392E30314332382E303136203520333020362E393820333020392E3437357631332E333833633020322E3439352D312E39383520342E3437352D342E34393420342E3437';
wwv_flow_imp.g_varchar2_table(51092) := '3548362E34393443332E3938352032372E33333320322032352E33353320322032322E38353856392E343735433220362E393820332E393835203520362E34393420357A227D29297D3B66756E6374696F6E2049712865297B636F6E73747B747970653A';
wwv_flow_imp.g_varchar2_table(51093) := '747D3D653B6C6574206E3D41712874293B636F6E737420693D66756E6374696F6E2865297B636F6E737420743D28302C792E676574427573696E6573734F626A656374292865292E6576656E74446566696E6974696F6E733B72657475726E2074262674';
wwv_flow_imp.g_varchar2_table(51094) := '5B305D7D2865293B696628692972657475726E206E3D60247B66756E6374696F6E2865297B72657475726E20417128652E2474797065292E7265706C61636528224576656E74446566696E6974696F6E222C2222297D2869297D247B6E7D602C2828302C';
wwv_flow_imp.g_varchar2_table(51095) := '792E69732928652C2262706D6E3A53746172744576656E74222926262128302C72732E6F68292865297C7C28302C792E69732928652C2262706D6E3A426F756E646172794576656E74222926262166756E6374696F6E2865297B636F6E737420743D2830';
wwv_flow_imp.g_varchar2_table(51096) := '2C792E676574427573696E6573734F626A656374292865293B72657475726E207426262131213D3D742E63616E63656C41637469766974797D286529292626286E3D60247B6E7D4E6F6E496E74657272757074696E6760292C6E3B69662828302C792E69';
wwv_flow_imp.g_varchar2_table(51097) := '732928652C2262706D6E3A53756250726F63657373222926262128302C792E69732928652C2262706D6E3A5472616E73616374696F6E22292969662828302C72732E513129286529296E3D604576656E74247B6E7D603B656C73657B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(51098) := '28302C72732E41762928652926262166756E6374696F6E2865297B636F6E737420743D65262628652E64697C7C28302C792E676574427573696E6573734F626A656374292865292E6469293B72657475726E28302C792E69732928742C2262706D6E6469';
wwv_flow_imp.g_varchar2_table(51099) := '3A42504D4E506C616E6522297D2865293B6E3D60247B743F22457870616E646564223A22436F6C6C6170736564227D247B6E7D607D72657475726E2066756E6374696F6E2865297B636F6E737420743D28302C792E676574427573696E6573734F626A65';
wwv_flow_imp.g_varchar2_table(51100) := '6374292865292C6E3D28302C792E676574427573696E6573734F626A6563742928652E736F75726365293B72657475726E21282128302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722297C7C216E292626286E2E64656661756C74';
wwv_flow_imp.g_varchar2_table(51101) := '26266E2E64656661756C743D3D3D7426262828302C792E697329286E2C2262706D6E3A4761746577617922297C7C28302C792E697329286E2C2262706D6E3A4163746976697479222929297D2865292626286E3D2244656661756C74466C6F7722292C66';
wwv_flow_imp.g_varchar2_table(51102) := '756E6374696F6E2865297B636F6E737420743D28302C792E676574427573696E6573734F626A656374292865292C6E3D28302C792E676574427573696E6573734F626A6563742928652E736F75726365293B72657475726E21282128302C792E69732928';
wwv_flow_imp.g_varchar2_table(51103) := '652C2262706D6E3A53657175656E6365466C6F7722297C7C216E29262628742E636F6E646974696F6E45787072657373696F6E262628302C792E697329286E2C2262706D6E3A41637469766974792229297D2865292626286E3D22436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(51104) := '616C466C6F7722292C6E7D636F6E7374204D713D653D3E28657C7C28653D653D3E65292C7B676574446F63756D656E746174696F6E5265663A653D3E7B636F6E737420743D4E7128293B696628742972657475726E2066756E6374696F6E28652C74297B';
wwv_flow_imp.g_varchar2_table(51105) := '636F6E7374206E3D507128652C74293B72657475726E206E26266E2E646F63756D656E746174696F6E5265667D28652C74297D2C676574456C656D656E744C6162656C3A653D3E28302C792E69732928652C2262706D6E3A50726F6365737322293F2830';
wwv_flow_imp.g_varchar2_table(51106) := '2C792E676574427573696E6573734F626A656374292865292E6E616D653A70732865292C676574456C656D656E7449636F6E3A653D3E7B636F6E737420743D49712865292C6E3D4C572822636F6E6669672E656C656D656E7454656D706C61746549636F';
wwv_flow_imp.g_varchar2_table(51107) := '6E52656E6465726572222C2131292C7B69636F6E50726F70657274793A693D227A656562653A6D6F64656C657254656D706C61746549636F6E227D3D6E7C7C7B7D2C6F3D28302C792E676574427573696E6573734F626A656374292865292E6765742869';
wwv_flow_imp.g_varchar2_table(51108) := '293B72657475726E206F3F28293D3E28302C50432E6A7378292822696D67222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6865616465722D74656D706C6174652D69636F6E222C77696474683A223332222C686569676874';
wwv_flow_imp.g_varchar2_table(51109) := '3A223332222C7372633A6F7D293A54715B745D7D2C676574547970654C6162656C3A743D3E7B636F6E7374206E3D4E7128293B6966286E297B636F6E737420693D507128742C6E293B696628692626692E6E616D652972657475726E206528692E6E616D';
wwv_flow_imp.g_varchar2_table(51110) := '65297D636F6E737420693D49712874293B72657475726E206528692E7265706C616365282F285C425B412D5A5D292F672C2220243122292E7265706C616365282F285C624E6F6E20496E74657272757074696E67292F672C22282431292229297D7D293B';
wwv_flow_imp.g_varchar2_table(51111) := '66756E6374696F6E2041712865297B72657475726E20652E73706C697428223A22295B315D7D66756E6374696F6E204E7128297B72657475726E204C572822656C656D656E7454656D706C61746573222C2131297D66756E6374696F6E20507128652C74';
wwv_flow_imp.g_varchar2_table(51112) := '297B72657475726E20742E6765742865297D66756E6374696F6E204F7128297B72657475726E204F713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2865297B666F722876617220743D31';
wwv_flow_imp.g_varchar2_table(51113) := '3B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D';
wwv_flow_imp.g_varchar2_table(51114) := '297D72657475726E20657D2C4F712E6170706C79286E756C6C2C617267756D656E7473297D7661722052713D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667222C4F71287B786D6C6E733A22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(51115) := '6F72672F323030302F737667222C786D6C6E73586C696E6B3A22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B222C77696474683A223634222C6865696768743A223634227D2C74292C4E43282264656673222C6E756C6C2C4E43';
wwv_flow_imp.g_varchar2_table(51116) := '282272656374222C7B69643A2261222C77696474683A223537222C6865696768743A223437222C783A2233222C793A2238222C72783A2237227D292C4E4328226D61736B222C7B69643A2262222C77696474683A223537222C6865696768743A22343722';
wwv_flow_imp.g_varchar2_table(51117) := '2C783A2230222C793A2230222C66696C6C3A2223666666222C6D61736B436F6E74656E74556E6974733A227573657253706163654F6E557365222C6D61736B556E6974733A226F626A656374426F756E64696E67426F78227D2C4E432822757365222C7B';
wwv_flow_imp.g_varchar2_table(51118) := '786C696E6B487265663A222361227D2929292C4E43282267222C7B66696C6C3A226E6F6E65222C66696C6C52756C653A226576656E6F6464227D2C4E43282270617468222C7B66696C6C3A2223383138373938222C643A224D3532203131613520352030';
wwv_flow_imp.g_varchar2_table(51119) := '2030313520357633316135203520302030312D3520354831316135203520302030312D352D35563136613520352030203031352D356834317A6D3020324831316133203320302030302D322E39393520322E3832344C3820313676333161332033203020';
wwv_flow_imp.g_varchar2_table(51120) := '3030322E38323420322E3939354C3131203530683431613320332030203030322E3939352D322E3832344C35352034375631366133203320302030302D322E3832342D322E3939354C35322031337A227D292C4E43282270617468222C7B66696C6C3A22';
wwv_flow_imp.g_varchar2_table(51121) := '23443544374444222C643A224D313620323468333176364831367A4D323120333368323176364832317A227D292C4E432822757365222C7B7374726F6B653A2223423942434336222C7374726F6B654461736861727261793A22352032222C7374726F6B';
wwv_flow_imp.g_varchar2_table(51122) := '6557696474683A2232222C6D61736B3A2275726C28236229222C786C696E6B487265663A222361227D2929293B66756E6374696F6E20467128297B72657475726E2046713D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E';
wwv_flow_imp.g_varchar2_table(51123) := '6428293A66756E6374696F6E2865297B666F722876617220743D313B743C617267756D656E74732E6C656E6774683B742B2B297B766172206E3D617267756D656E74735B745D3B666F7228766172206920696E206E29287B7D292E6861734F776E50726F';
wwv_flow_imp.g_varchar2_table(51124) := '70657274792E63616C6C286E2C6929262628655B695D3D6E5B695D297D72657475726E20657D2C46712E6170706C79286E756C6C2C617267756D656E7473297D7661722042713D287B7374796C65733A653D7B7D2C2E2E2E747D293D3E4E432822737667';
wwv_flow_imp.g_varchar2_table(51125) := '222C4671287B786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C786D6C6E73586C696E6B3A22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B222C77696474683A22313238222C6865696768';
wwv_flow_imp.g_varchar2_table(51126) := '743A223634227D2C74292C4E43282264656673222C6E756C6C2C4E43282270617468222C7B69643A2261222C643A224D3920396831313076343748397A227D292C4E4328226D61736B222C7B69643A2262222C77696474683A22313130222C6865696768';
wwv_flow_imp.g_varchar2_table(51127) := '743A223437222C783A2230222C793A2230222C66696C6C3A2223666666222C6D61736B436F6E74656E74556E6974733A227573657253706163654F6E557365222C6D61736B556E6974733A226F626A656374426F756E64696E67426F78227D2C4E432822';
wwv_flow_imp.g_varchar2_table(51128) := '757365222C7B786C696E6B487265663A222361227D2929292C4E43282267222C7B66696C6C3A226E6F6E65222C66696C6C52756C653A226576656E6F6464227D2C4E43282270617468222C7B66696C6C3A2223383138373938222C643A224D3235203230';
wwv_flow_imp.g_varchar2_table(51129) := '2E3237324C33372E3732382033332032352034352E3732382031322E3237322033332032352032302E3237327A6D3020322E3832394C31352E312033336C392E3920392E3920392E392D392E392D392E392D392E397A227D292C4E43282270617468222C';
wwv_flow_imp.g_varchar2_table(51130) := '7B66696C6C3A2223443544374444222C643A224D313720343768313676364831377A227D292C4E43282270617468222C7B66696C6C3A2223383138373938222C643A224D333520333268323776324833357A227D292C4E43282270617468222C7B66696C';
wwv_flow_imp.g_varchar2_table(51131) := '6C3A2223383138373938222C643A224D363020333076366C362D337A227D292C4E43282270617468222C7B66696C6C3A2223443544374444222C643A224D383020333468323176364838307A227D292C4E43282267222C6E756C6C2C4E43282270617468';
wwv_flow_imp.g_varchar2_table(51132) := '222C7B66696C6C3A2223383138373938222C643A224D3131312031326135203520302030313520357633316135203520302030312D3520354837306135203520302030312D352D35563137613520352030203031352D356834317A6D3020324837306133';
wwv_flow_imp.g_varchar2_table(51133) := '203320302030302D332033763331613320332030203030332033683431613320332030203030332D335631376133203320302030302D332D337A227D292C4E43282270617468222C7B66696C6C3A2223443544374444222C643A224D3735203235683331';
wwv_flow_imp.g_varchar2_table(51134) := '76364837357A227D29292C4E432822757365222C7B7374726F6B653A2223423942434336222C7374726F6B654461736861727261793A22352032222C7374726F6B6557696474683A2232222C6D61736B3A2275726C28236229222C786C696E6B48726566';
wwv_flow_imp.g_varchar2_table(51135) := '3A222361227D2929293B636F6E73742056713D653D3E28657C7C28653D653D3E65292C7B676574456D7074793A28293D3E287B746578743A65282253656C65637420616E20656C656D656E7420746F2065646974206974732070726F706572746965732E';
wwv_flow_imp.g_varchar2_table(51136) := '22292C69636F6E3A52717D292C6765744D756C7469706C653A28293D3E287B746578743A6528224D756C7469706C6520656C656D656E7473206172652073656C65637465642E2053656C65637420612073696E676C6520656C656D656E7420746F206564';
wwv_flow_imp.g_varchar2_table(51137) := '6974206974732070726F706572746965732E22292C69636F6E3A42717D297D293B66756E6374696F6E207A712865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E2C67657450726F7669646572733A6F2C6C61796F7574436F6E66';
wwv_flow_imp.g_varchar2_table(51138) := '69673A732C6465736372697074696F6E436F6E6669673A722C746F6F6C746970436F6E6669673A612C6665656C506F707570436F6E7461696E65723A6C7D3D652C633D6E2E676574282263616E76617322292C643D6E2E6765742822656C656D656E7452';
wwv_flow_imp.g_varchar2_table(51139) := '6567697374727922292C683D6E2E67657428226576656E7442757322292C753D6E2E67657428227472616E736C61746522292C5B702C675D3D5777287B73656C6563746564456C656D656E743A747D292C6D3D702E73656C6563746564456C656D656E74';
wwv_flow_imp.g_varchar2_table(51140) := '2C663D653D3E7B69662821652972657475726E3B6C657420743D653B742626226C6162656C223D3D3D742E74797065262628743D742E6C6162656C546172676574292C67287B2E2E2E702C73656C6563746564456C656D656E743A747D292C682E666972';
wwv_flow_imp.g_varchar2_table(51141) := '65282270726F7065727469657350616E656C2E75706461746564222C7B656C656D656E743A747D297D3B6A77282828293D3E7B636F6E737420653D653D3E7B636F6E73747B6E657753656C656374696F6E3A743D5B5D7D3D653B696628742E6C656E6774';
wwv_flow_imp.g_varchar2_table(51142) := '683E312972657475726E20662874293B636F6E7374206E3D745B305D2C693D632E676574526F6F74456C656D656E7428293B2866756E6374696F6E2865297B72657475726E2065262628652E6973496D706C696369747C7C225F5F696D706C6963697472';
wwv_flow_imp.g_varchar2_table(51143) := '6F6F74223D3D3D652E6964297D292869297C7C66286E7C7C69297D3B72657475726E20682E6F6E282273656C656374696F6E2E6368616E676564222C65292C28293D3E7B682E6F6666282273656C656374696F6E2E6368616E676564222C65297D7D292C';
wwv_flow_imp.g_varchar2_table(51144) := '5B5D292C6A77282828293D3E7B636F6E737420653D653D3E7B636F6E737420743D66756E6374696F6E28652C74297B72657475726E28302C692E49362928652C28653D3E653D3D3D7429297D28652E656C656D656E74732C6D293B74262666756E637469';
wwv_flow_imp.g_varchar2_table(51145) := '6F6E28652C74297B72657475726E20652626742E67657428652E6964297D28742C64292626662874297D3B72657475726E20682E6F6E2822656C656D656E74732E6368616E676564222C65292C28293D3E7B682E6F66662822656C656D656E74732E6368';
wwv_flow_imp.g_varchar2_table(51146) := '616E676564222C65297D7D292C5B6D5D292C6A77282828293D3E7B636F6E737420653D653D3E7B636F6E737420743D652E656C656D656E743B662874297D3B72657475726E20682E6F6E2822726F6F742E6164646564222C65292C28293D3E7B682E6F66';
wwv_flow_imp.g_varchar2_table(51147) := '662822726F6F742E6164646564222C65297D7D292C5B6D5D292C6A77282828293D3E7B636F6E737420653D28293D3E7B66286D297D3B72657475726E20682E6F6E282270726F7065727469657350616E656C2E70726F7669646572734368616E67656422';
wwv_flow_imp.g_varchar2_table(51148) := '2C65292C28293D3E7B682E6F6666282270726F7065727469657350616E656C2E70726F7669646572734368616E676564222C65297D7D292C5B6D5D292C6A77282828293D3E7B636F6E737420653D28293D3E7B66286D297D3B72657475726E20682E6F6E';
wwv_flow_imp.g_varchar2_table(51149) := '2822656C656D656E7454656D706C617465732E6368616E676564222C65292C28293D3E7B682E6F66662822656C656D656E7454656D706C617465732E6368616E676564222C65297D7D292C5B6D5D293B636F6E737420763D7B73656C6563746564456C65';
wwv_flow_imp.g_varchar2_table(51150) := '6D656E743A6D2C696E6A6563746F723A6E2C676574536572766963653A28652C74293D3E6E2E67657428652C74297D2C623D6F286D292C5F3D5577282828293D3E28302C692E54532928622C2866756E6374696F6E28652C74297B72657475726E28302C';
wwv_flow_imp.g_varchar2_table(51151) := '692E637929286D293F5B5D3A742E67657447726F757073286D292865297D292C5B5D29292C5B622C6D5D292C5B792C775D3D577728737C7C7B7D292C433D4B772828653D3E7B682E66697265282270726F7065727469657350616E656C2E6C61796F7574';
wwv_flow_imp.g_varchar2_table(51152) := '4368616E676564222C7B6C61796F75743A657D297D292C5B685D293B72657475726E206A77282828293D3E7B636F6E737420653D653D3E7B636F6E73747B6C61796F75743A747D3D653B772874297D3B72657475726E20682E6F6E282270726F70657274';
wwv_flow_imp.g_varchar2_table(51153) := '69657350616E656C2E7365744C61796F7574222C65292C28293D3E682E6F6666282270726F7065727469657350616E656C2E7365744C61796F7574222C65297D292C5B682C775D292C28302C50432E6A7378292845572E50726F76696465722C7B76616C';
wwv_flow_imp.g_varchar2_table(51154) := '75653A762C6368696C6472656E3A28302C50432E6A7378292852482C7B656C656D656E743A6D2C68656164657250726F76696465723A4D712875292C706C616365686F6C64657250726F76696465723A56712875292C67726F7570733A5F2C6C61796F75';
wwv_flow_imp.g_varchar2_table(51155) := '74436F6E6669673A792C6C61796F75744368616E6765643A432C6465736372697074696F6E436F6E6669673A722C6465736372697074696F6E4C6F616465643A653D3E7B682E66697265282270726F7065727469657350616E656C2E6465736372697074';
wwv_flow_imp.g_varchar2_table(51156) := '696F6E4C6F61646564222C7B6465736372697074696F6E3A657D297D2C746F6F6C746970436F6E6669673A612C746F6F6C7469704C6F616465643A653D3E7B682E66697265282270726F7065727469657350616E656C2E746F6F6C7469704C6F61646564';
wwv_flow_imp.g_varchar2_table(51157) := '222C7B746F6F6C7469703A657D297D2C6665656C506F707570436F6E7461696E65723A6C2C6576656E744275733A687D297D297D636C6173732048717B636F6E7374727563746F7228652C742C6E297B636F6E73747B706172656E743A692C6C61796F75';
wwv_flow_imp.g_varchar2_table(51158) := '743A6F2C6465736372697074696F6E3A732C746F6F6C7469703A722C6665656C506F707570436F6E7461696E65723A617D3D657C7C7B7D3B746869732E5F6576656E744275733D6E2C746869732E5F696E6A6563746F723D742C746869732E5F6C61796F';
wwv_flow_imp.g_varchar2_table(51159) := '7574436F6E6669673D6F2C746869732E5F6465736372697074696F6E436F6E6669673D732C746869732E5F746F6F6C746970436F6E6669673D722C746869732E5F6665656C506F707570436F6E7461696E65723D612C746869732E5F636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(51160) := '723D535728273C646976207374796C653D226865696768743A20313030252220636C6173733D2262696F2D70726F706572746965732D70616E656C2D636F6E7461696E6572223E3C2F6469763E27293B766172206C3D742E6765742822636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(51161) := '537461636B222C2131293B6C262666756E6374696F6E28652C742C6E297B66756E6374696F6E20692865297B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28297D66756E6374696F6E206F2865297B726574';
wwv_flow_imp.g_varchar2_table(51162) := '75726E2065612865293F286E2E756E646F28292C69286529293A74612865293F286E2E7265646F28292C69286529293A766F696420307D742E6F6E28226B6579626F6172642E62696E64222C2866756E6374696F6E28297B79572E62696E6428652C226B';
wwv_flow_imp.g_varchar2_table(51163) := '6579646F776E222C6F297D29292C742E6F6E28226B6579626F6172642E756E62696E64222C2866756E6374696F6E28297B79572E756E62696E6428652C226B6579646F776E222C6F297D29297D28746869732E5F636F6E7461696E65722C6E2C6C292C6E';
wwv_flow_imp.g_varchar2_table(51164) := '2E6F6E28226469616772616D2E696E6974222C2828293D3E7B692626746869732E617474616368546F2869297D29292C6E2E6F6E28226469616772616D2E64657374726F79222C2828293D3E7B746869732E64657461636828297D29292C6E2E6F6E2822';
wwv_flow_imp.g_varchar2_table(51165) := '726F6F742E6164646564222C28653D3E7B636F6E73747B656C656D656E743A747D3D653B746869732E5F72656E6465722874297D29297D617474616368546F2865297B6966282165297468726F77206E6577204572726F722822636F6E7461696E657220';
wwv_flow_imp.g_varchar2_table(51166) := '726571756972656422293B652E6765742626652E636F6E7374727563746F722E70726F746F747970652E6A7175657279262628653D652E676574283029292C22737472696E67223D3D747970656F662065262628653D7857286529292C746869732E6465';
wwv_flow_imp.g_varchar2_table(51167) := '7461636828292C652E617070656E644368696C6428746869732E5F636F6E7461696E6572292C746869732E5F6576656E744275732E66697265282270726F7065727469657350616E656C2E61747461636822297D64657461636828297B636F6E73742065';
wwv_flow_imp.g_varchar2_table(51168) := '3D746869732E5F636F6E7461696E65722E706172656E744E6F64653B65262628652E72656D6F76654368696C6428746869732E5F636F6E7461696E6572292C746869732E5F6576656E744275732E66697265282270726F7065727469657350616E656C2E';
wwv_flow_imp.g_varchar2_table(51169) := '6465746163682229297D726567697374657250726F766964657228652C74297B747C7C28743D652C653D316533292C2266756E6374696F6E223D3D747970656F6620742E67657447726F7570733F28746869732E5F6576656E744275732E6F6E28227072';
wwv_flow_imp.g_varchar2_table(51170) := '6F7065727469657350616E656C2E67657450726F766964657273222C652C2866756E6374696F6E2865297B652E70726F7669646572732E707573682874297D29292C746869732E5F6576656E744275732E66697265282270726F7065727469657350616E';
wwv_flow_imp.g_varchar2_table(51171) := '656C2E70726F7669646572734368616E6765642229293A636F6E736F6C652E6572726F72282250726F706572746965732070726F766964657220646F6573206E6F7420696D706C656D656E74202367657447726F75707328656C656D656E742920415049';
wwv_flow_imp.g_varchar2_table(51172) := '22297D7365744C61796F75742865297B746869732E5F6576656E744275732E66697265282270726F7065727469657350616E656C2E7365744C61796F7574222C7B6C61796F75743A657D297D5F67657450726F76696465727328297B636F6E737420653D';
wwv_flow_imp.g_varchar2_table(51173) := '746869732E5F6576656E744275732E6372656174654576656E74287B747970653A2270726F7065727469657350616E656C2E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E74427573';
wwv_flow_imp.g_varchar2_table(51174) := '2E666972652865292C652E70726F7669646572737D5F72656E6465722865297B636F6E737420743D746869732E5F696E6A6563746F722E676574282263616E76617322293B657C7C28653D742E676574526F6F74456C656D656E742829292C66756E6374';
wwv_flow_imp.g_varchar2_table(51175) := '696F6E2865297B72657475726E2065262628652E6973496D706C696369747C7C225F5F696D706C69636974726F6F74223D3D3D652E6964297D2865297C7C2828302C41772E5858292828302C50432E6A737829287A712C7B656C656D656E743A652C696E';
wwv_flow_imp.g_varchar2_table(51176) := '6A6563746F723A746869732E5F696E6A6563746F722C67657450726F7669646572733A746869732E5F67657450726F7669646572732E62696E642874686973292C6C61796F7574436F6E6669673A746869732E5F6C61796F7574436F6E6669672C646573';
wwv_flow_imp.g_varchar2_table(51177) := '6372697074696F6E436F6E6669673A746869732E5F6465736372697074696F6E436F6E6669672C746F6F6C746970436F6E6669673A746869732E5F746F6F6C746970436F6E6669672C6665656C506F707570436F6E7461696E65723A746869732E5F6665';
wwv_flow_imp.g_varchar2_table(51178) := '656C506F707570436F6E7461696E65727D292C746869732E5F636F6E7461696E6572292C746869732E5F6576656E744275732E66697265282270726F7065727469657350616E656C2E72656E64657265642229297D5F64657374726F7928297B74686973';
wwv_flow_imp.g_varchar2_table(51179) := '2E5F636F6E7461696E657226262828302C41772E585829286E756C6C2C746869732E5F636F6E7461696E6572292C746869732E5F6576656E744275732E66697265282270726F7065727469657350616E656C2E64657374726F7965642229297D7D48712E';
wwv_flow_imp.g_varchar2_table(51180) := '24696E6A6563743D5B22636F6E6669672E70726F7065727469657350616E656C222C22696E6A6563746F72222C226576656E74427573225D3B636C6173732057717B636F6E7374727563746F722865297B746869732E5F636F6D6D616E64537461636B3D';
wwv_flow_imp.g_varchar2_table(51181) := '657D707265457865637574652865297B636F6E737420743D746869732E5F636F6D6D616E64537461636B3B28302C692E6A4A2928652C2866756E6374696F6E2865297B742E6578656375746528652E636D642C652E636F6E74657874297D29297D7D5771';
wwv_flow_imp.g_varchar2_table(51182) := '2E24696E6A6563743D5B22636F6D6D616E64537461636B225D3B636F6E7374206A713D7B2270726F706572746965732D70616E656C2E6D756C74692D636F6D6D616E642D6578656375746F72223A57717D3B66756E6374696F6E20717128652C74297B65';
wwv_flow_imp.g_varchar2_table(51183) := '2E6F6E28226469616772616D2E696E6974222C2866756E6374696F6E28297B28302C692E6A4A29286A712C2866756E6374696F6E28652C6E297B742E726567697374657248616E646C6572286E2C65297D29297D29297D71712E24696E6A6563743D5B22';
wwv_flow_imp.g_varchar2_table(51184) := '6576656E74427573222C22636F6D6D616E64537461636B225D3B7661722024713D7B5F5F646570656E64735F5F3A5B7B5F5F696E69745F5F3A5B71715D7D2C61572C63575D2C5F5F696E69745F5F3A5B2270726F7065727469657350616E656C225D2C70';
wwv_flow_imp.g_varchar2_table(51185) := '726F7065727469657350616E656C3A5B2274797065222C48715D7D3B66756E6374696F6E2055712865297B636F6E73747B6175746F466F637573456E7472793A742C656C656D656E743A6E2C6765744F7074696F6E733A697D3D652C6F3D69286E292C73';
wwv_flow_imp.g_varchar2_table(51186) := '3D4B7A286F293B72657475726E206A77282828293D3E7B6966287426267326266F2E6C656E6774683E732E6C656E677468297B636F6E737420653D785728605B646174612D656E7472792D69643D22247B747D225D60292C6E3D785728222E62696F2D70';
wwv_flow_imp.g_varchar2_table(51187) := '726F706572746965732D70616E656C2D696E707574222C65293B6E26266E2E73656C65637428297D7D292C5B6F5D292C28302C50432E6A7378292847482C7B2E2E2E657D297D66756E6374696F6E204B712865297B72657475726E28302C792E6973416E';
wwv_flow_imp.g_varchar2_table(51188) := '792928652C5B2262706D6E3A53746172744576656E74222C2262706D6E3A426F756E646172794576656E74222C2262706D6E3A456E644576656E74225D292626212147712865297D66756E6374696F6E2047712865297B72657475726E20597128652C22';
wwv_flow_imp.g_varchar2_table(51189) := '62706D6E3A4572726F724576656E74446566696E6974696F6E22297D66756E6374696F6E2051712865297B636F6E737420743D47712865293B72657475726E20742626742E67657428226572726F7252656622297D66756E6374696F6E20597128652C74';
wwv_flow_imp.g_varchar2_table(51190) := '297B636F6E7374206E3D28302C792E676574427573696E6573734F626A656374292865292E67657428226576656E74446566696E6974696F6E7322297C7C5B5D3B72657475726E28302C692E493629286E2C2866756E6374696F6E2865297B7265747572';
wwv_flow_imp.g_varchar2_table(51191) := '6E28302C792E69732928652C74297D29297D66756E6374696F6E205A712865297B72657475726E28302C792E69732928652C2262706D6E3A526563656976655461736B22293F28302C792E676574427573696E6573734F626A656374292865293A597128';
wwv_flow_imp.g_varchar2_table(51192) := '652C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22297D66756E6374696F6E2058712865297B636F6E737420743D5A712865293B72657475726E20742626742E67657428226D65737361676552656622297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(51193) := '204A712865297B72657475726E20597128652C2262706D6E3A4C696E6B4576656E74446566696E6974696F6E22297D66756E6374696F6E2065242865297B72657475726E20597128652C2262706D6E3A5369676E616C4576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(51194) := '6E22297D66756E6374696F6E2074242865297B636F6E737420743D65242865293B72657475726E20742626742E67657428227369676E616C52656622297D66756E6374696F6E206E242865297B72657475726E20597128652C2262706D6E3A457363616C';
wwv_flow_imp.g_varchar2_table(51195) := '6174696F6E4576656E74446566696E6974696F6E22297D66756E6374696F6E2069242865297B72657475726E28302C792E69732928652C2262706D6E3A4576656E742229262621216E242865297D66756E6374696F6E206F242865297B636F6E73742074';
wwv_flow_imp.g_varchar2_table(51196) := '3D6E242865293B72657475726E20742626742E6765742822657363616C6174696F6E52656622297D66756E6374696F6E2073242865297B72657475726E20597128652C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E2229';
wwv_flow_imp.g_varchar2_table(51197) := '7D66756E6374696F6E2072242865297B636F6E73747B656C656D656E743A747D3D653B72657475726E2066756E6374696F6E2865297B72657475726E28302C792E6973416E792928652C5B2262706D6E3A456E644576656E74222C2262706D6E3A496E74';
wwv_flow_imp.g_varchar2_table(51198) := '65726D6564696174655468726F774576656E74225D292626212173242865297D2874293F5B7B69643A2277616974466F72436F6D706C6574696F6E222C636F6D706F6E656E743A61242C69734564697465643A24487D2C7B69643A226163746976697479';
wwv_flow_imp.g_varchar2_table(51199) := '526566222C636F6D706F6E656E743A6C242C69734564697465643A51487D5D3A5B5D7D66756E6374696F6E2061242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728227472616E';
wwv_flow_imp.g_varchar2_table(51200) := '736C61746522292C6F3D73242874293B72657475726E207148287B656C656D656E743A742C69643A2277616974466F72436F6D706C6574696F6E222C6C6162656C3A6928225761697420666F7220636F6D706C6574696F6E22292C67657456616C75653A';
wwv_flow_imp.g_varchar2_table(51201) := '28293D3E6F2E676574282277616974466F72436F6D706C6574696F6E22292C73657456616C75653A653D3E7B6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F';
wwv_flow_imp.g_varchar2_table(51202) := '64646C65456C656D656E743A6F2C70726F706572746965733A7B77616974466F72436F6D706C6574696F6E3A657D7D297D7D297D66756E6374696F6E206C242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E6453';
wwv_flow_imp.g_varchar2_table(51203) := '7461636B22292C6F3D4C572822656C656D656E74526567697374727922292C733D4C5728227472616E736C61746522292C723D73242874293B72657475726E205571287B656C656D656E743A742C69643A226163746976697479526566222C6C6162656C';
wwv_flow_imp.g_varchar2_table(51204) := '3A7328224163746976697479207265666572656E636522292C67657456616C75653A28293D3E7B636F6E737420653D66756E6374696F6E2865297B636F6E737420743D73242865293B72657475726E20742626742E676574282261637469766974795265';
wwv_flow_imp.g_varchar2_table(51205) := '6622297D2874293B72657475726E20652626652E6765742822696422297D2C73657456616C75653A653D3E7B636F6E737420693D653F28302C792E676574427573696E6573734F626A65637429286F2E676574286529293A766F696420303B6E2E657865';
wwv_flow_imp.g_varchar2_table(51206) := '637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A722C70726F706572746965733A7B61637469766974795265663A697D7D297D2C6765744F70';
wwv_flow_imp.g_varchar2_table(51207) := '74696F6E733A28293D3E7B6C657420653D5B7B76616C75653A22222C6C6162656C3A7328223C6E6F6E653E22297D5D3B636F6E7374206E3D66756E6374696F6E2865297B6C657420743D28302C792E676574427573696E6573734F626A65637429286529';
wwv_flow_imp.g_varchar2_table(51208) := '2E24706172656E742C6E3D64242874293B72657475726E28302C792E69732928742C2262706D6E3A53756250726F6365737322292626742E74726967676572656442794576656E74262628743D742E24706172656E742C742626286E3D5B2E2E2E6E2C2E';
wwv_flow_imp.g_varchar2_table(51209) := '2E2E64242874295D29292C6E7D2874293B766172206F3B72657475726E286F3D6E2C28302C692E556C29286F2C28653D3E28652E6E616D657C7C2222292E746F4C6F7765724361736528292929292E666F7245616368282866756E6374696F6E2874297B';
wwv_flow_imp.g_varchar2_table(51210) := '652E70757368287B76616C75653A742E69642C6C6162656C3A68242874297D297D29292C657D7D297D66756E6374696F6E20632428652C74297B636F6E73747B666C6F77456C656D656E74733A6E7D3D653B72657475726E206E2E66696C746572282866';
wwv_flow_imp.g_varchar2_table(51211) := '756E6374696F6E2865297B72657475726E28302C792E69732928652C74297D29297D66756E6374696F6E2064242865297B636F6E737420743D66756E6374696F6E2865297B72657475726E20632428652C2262706D6E3A416374697669747922297D2865';
wwv_flow_imp.g_varchar2_table(51212) := '292C6E3D66756E6374696F6E2865297B72657475726E20632428652C2262706D6E3A426F756E646172794576656E7422297D2865293B72657475726E20742E66696C746572282866756E6374696F6E2865297B72657475726E2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(51213) := '2C74297B72657475726E28302C792E69732928652C2262706D6E3A43616C6C416374697669747922297C7C28302C792E69732928652C2262706D6E3A53756250726F636573732229262621652E74726967676572656442794576656E74262621652E6973';
wwv_flow_imp.g_varchar2_table(51214) := '466F72436F6D70656E736174696F6E7C7C66756E6374696F6E28652C74297B636F6E73747B69643A6E7D3D653B72657475726E212128302C692E49362928742C2866756E6374696F6E2865297B636F6E73747B6174746163686564546F5265663A747D3D';
wwv_flow_imp.g_varchar2_table(51215) := '652C693D73242865293B72657475726E20742626692626742E69643D3D3D6E7D29297D28652C74297D28652C6E297D29297D66756E6374696F6E2068242865297B636F6E73747B69643A742C6E616D653A6E7D3D653B72657475726E60247B6E3F6E2B22';
wwv_flow_imp.g_varchar2_table(51216) := '20223A22227D2869643D247B747D29607D636F6E73742075243D22746578742F706C61696E223B66756E6374696F6E2070242865297B636F6E73747B656C656D656E743A747D3D652C6E3D5B7B69643A22646F63756D656E746174696F6E222C636F6D70';
wwv_flow_imp.g_varchar2_table(51217) := '6F6E656E743A67242C69734564697465643A65577D5D3B72657475726E2066756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E7422292626652E627573696E6573734F626A6563742E676574';
wwv_flow_imp.g_varchar2_table(51218) := '282270726F6365737352656622297D28742926266E2E70757368287B69643A2270726F63657373446F63756D656E746174696F6E222C636F6D706F6E656E743A6D242C69734564697465643A65577D292C6E7D66756E6374696F6E2067242865297B636F';
wwv_flow_imp.g_varchar2_table(51219) := '6E73747B656C656D656E743A747D3D652C6E3D4C57282262706D6E466163746F727922292C693D4C572822636F6D6D616E64537461636B22292C6F3D4C5728227472616E736C61746522292C733D4C5728226465626F756E6365496E70757422292C723D';
wwv_flow_imp.g_varchar2_table(51220) := '76242828302C792E676574427573696E6573734F626A65637429287429292C613D622428742C28302C792E676574427573696E6573734F626A656374292874292C6E2C69293B72657475726E204A48287B656C656D656E743A742C69643A22646F63756D';
wwv_flow_imp.g_varchar2_table(51221) := '656E746174696F6E222C6C6162656C3A6F2822456C656D656E7420646F63756D656E746174696F6E22292C67657456616C75653A722C73657456616C75653A612C6465626F756E63653A737D297D66756E6374696F6E206D242865297B636F6E73747B65';
wwv_flow_imp.g_varchar2_table(51222) := '6C656D656E743A747D3D652C6E3D4C57282262706D6E466163746F727922292C693D4C572822636F6D6D616E64537461636B22292C6F3D4C5728227472616E736C61746522292C733D4C5728226465626F756E6365496E70757422292C723D28302C792E';
wwv_flow_imp.g_varchar2_table(51223) := '676574427573696E6573734F626A656374292874292E70726F636573735265662C613D76242872292C6C3D622428742C722C6E2C69293B72657475726E204A48287B656C656D656E743A742C69643A2270726F63657373446F63756D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(51224) := '222C6C6162656C3A6F282250726F6365737320646F63756D656E746174696F6E22292C67657456616C75653A612C73657456616C75653A6C2C6465626F756E63653A737D297D66756E6374696F6E2066242865297B72657475726E20652E66696E642828';
wwv_flow_imp.g_varchar2_table(51225) := '66756E6374696F6E2865297B72657475726E28652E74657874466F726D61747C7C7524293D3D3D75247D29297D66756E6374696F6E2076242865297B72657475726E2066756E6374696F6E28297B636F6E737420743D662428652626652E676574282264';
wwv_flow_imp.g_varchar2_table(51226) := '6F63756D656E746174696F6E2229293B72657475726E20742626742E746578747D7D66756E6374696F6E20622428652C742C6E2C6F297B72657475726E2066756E6374696F6E2873297B6C657420723D662428742626742E6765742822646F63756D656E';
wwv_flow_imp.g_varchar2_table(51227) := '746174696F6E2229293B72657475726E20723F733F6F2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A652C6D6F64646C65456C656D656E743A722C70726F706572746965';
wwv_flow_imp.g_varchar2_table(51228) := '733A7B746578743A737D7D293A6F2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A652C6D6F64646C65456C656D656E743A742C70726F706572746965733A7B646F63756D';
wwv_flow_imp.g_varchar2_table(51229) := '656E746174696F6E3A28302C692E46462928742E6765742822646F63756D656E746174696F6E22292C72297D7D293A733F28723D6E2E637265617465282262706D6E3A446F63756D656E746174696F6E222C7B746578743A737D292C6F2E657865637574';
wwv_flow_imp.g_varchar2_table(51230) := '652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A652C6D6F64646C65456C656D656E743A742C70726F706572746965733A7B646F63756D656E746174696F6E3A5B2E2E2E742E676574282264';
wwv_flow_imp.g_varchar2_table(51231) := '6F63756D656E746174696F6E22292C725D7D7D29293A766F696420307D7D66756E6374696F6E205F2428652C742C6E2C69297B636F6E7374206F3D692E63726561746528652C74293B72657475726E206E2626286F2E24706172656E743D6E292C6F7D66';
wwv_flow_imp.g_varchar2_table(51232) := '756E6374696F6E2079242865297B72657475726E206E6577207A285B33322C33322C315D292E6E65787450726566697865642865297D66756E6374696F6E2077242865297B6C657420743D653B666F72283B742E24706172656E743B29743D742E247061';
wwv_flow_imp.g_varchar2_table(51233) := '72656E743B72657475726E20747D66756E6374696F6E20432428652C74297B72657475726E206E3D77242865292E6765742822726F6F74456C656D656E747322292C693D742C286E7C7C5B5D292E66696C7465722828653D3E28302C792E69732928652C';
wwv_flow_imp.g_varchar2_table(51234) := '692929293B766172206E2C697D66756E6374696F6E20532428652C742C6E297B72657475726E20432428652C74292E66696E642828653D3E652E69643D3D3D6E29297D636F6E73742078243D22222C6B243D226372656174652D6E6577223B66756E6374';
wwv_flow_imp.g_varchar2_table(51235) := '696F6E2045242865297B636F6E73747B656C656D656E743A747D3D653B696628214B712874292972657475726E5B5D3B6C6574206E3D5B7B69643A226572726F72526566222C636F6D706F6E656E743A4C242C69734564697465643A51487D5D3B726574';
wwv_flow_imp.g_varchar2_table(51236) := '75726E2051712874292626286E3D5B2E2E2E6E2C7B69643A226572726F724E616D65222C636F6D706F6E656E743A44242C69734564697465643A6F577D2C7B69643A226572726F72436F6465222C636F6D706F6E656E743A54242C69734564697465643A';
wwv_flow_imp.g_varchar2_table(51237) := '6F577D5D292C6E7D66756E6374696F6E204C242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C57282262706D6E466163746F727922292C6F3D4C572822636F6D6D616E64537461636B22292C733D4C5728227472616E736C6174652229';
wwv_flow_imp.g_varchar2_table(51238) := '2C723D47712874293B72657475726E205571287B656C656D656E743A742C69643A226572726F72526566222C6C6162656C3A732822476C6F62616C206572726F72207265666572656E636522292C6175746F466F637573456E7472793A226572726F724E';
wwv_flow_imp.g_varchar2_table(51239) := '616D65222C67657456616C75653A28293D3E7B636F6E737420653D51712874293B72657475726E20653F652E6765742822696422293A78247D2C73657456616C75653A653D3E7B636F6E737420693D77242872292C733D5B5D3B6C657420613B72657475';
wwv_flow_imp.g_varchar2_table(51240) := '726E20653D3D3D6B24262628613D5F24282262706D6E3A4572726F72222C7B6E616D653A792428224572726F725F22297D2C692C6E292C653D612E6765742822696422292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F6464';
wwv_flow_imp.g_varchar2_table(51241) := '6C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A742C6D6F64646C65456C656D656E743A692C70726F706572746965733A7B726F6F74456C656D656E74733A5B2E2E2E692E6765742822726F6F74456C656D656E747322292C';
wwv_flow_imp.g_varchar2_table(51242) := '615D7D7D7D29292C613D617C7C532428722C2262706D6E3A4572726F72222C65292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A742C6D6F';
wwv_flow_imp.g_varchar2_table(51243) := '64646C65456C656D656E743A722C70726F706572746965733A7B6572726F725265663A617D7D7D292C6F2E65786563757465282270726F706572746965732D70616E656C2E6D756C74692D636F6D6D616E642D6578656375746F72222C73297D2C676574';
wwv_flow_imp.g_varchar2_table(51244) := '4F7074696F6E733A28293D3E7B6C657420653D5B7B76616C75653A78242C6C6162656C3A7328223C6E6F6E653E22297D2C7B76616C75653A6B242C6C6162656C3A732822437265617465206E6577202E2E2E22297D5D3B766172206E3B72657475726E28';
wwv_flow_imp.g_varchar2_table(51245) := '6E3D43242828302C792E676574427573696E6573734F626A656374292874292C2262706D6E3A4572726F7222292C28302C692E556C29286E2C28653D3E28652E6E616D657C7C2222292E746F4C6F7765724361736528292929292E666F72456163682828';
wwv_flow_imp.g_varchar2_table(51246) := '743D3E7B652E70757368287B76616C75653A742E6765742822696422292C6C6162656C3A742E67657428226E616D6522297D297D29292C657D7D297D66756E6374696F6E2044242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822';
wwv_flow_imp.g_varchar2_table(51247) := '636F6D6D616E64537461636B22292C693D4C5728227472616E736C61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D51712874293B72657475726E206957287B656C656D656E743A742C69643A226572726F724E616D65222C6C';
wwv_flow_imp.g_varchar2_table(51248) := '6162656C3A6928224E616D6522292C67657456616C75653A28293D3E732E67657428226E616D6522292C73657456616C75653A653D3E6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C';
wwv_flow_imp.g_varchar2_table(51249) := '656D656E743A742C6D6F64646C65456C656D656E743A732C70726F706572746965733A7B6E616D653A657D7D292C6465626F756E63653A6F7D297D66756E6374696F6E2054242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C57282263';
wwv_flow_imp.g_varchar2_table(51250) := '6F6D6D616E64537461636B22292C693D4C5728227472616E736C61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D51712874293B72657475726E206957287B656C656D656E743A742C69643A226572726F72436F6465222C6C61';
wwv_flow_imp.g_varchar2_table(51251) := '62656C3A692822436F646522292C67657456616C75653A28293D3E732E67657428226572726F72436F646522292C73657456616C75653A653D3E6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F7065727469657322';
wwv_flow_imp.g_varchar2_table(51252) := '2C7B656C656D656E743A742C6D6F64646C65456C656D656E743A732C70726F706572746965733A7B6572726F72436F64653A657D7D292C6465626F756E63653A6F7D297D636F6E73742049243D226372656174652D6E6577223B66756E6374696F6E204D';
wwv_flow_imp.g_varchar2_table(51253) := '242865297B636F6E73747B656C656D656E743A747D3D653B6966282169242874292972657475726E5B5D3B6C6574206E3D5B7B69643A22657363616C6174696F6E526566222C636F6D706F6E656E743A41242C69734564697465643A51487D5D3B726574';
wwv_flow_imp.g_varchar2_table(51254) := '75726E206F242874292626286E3D5B2E2E2E6E2C7B69643A22657363616C6174696F6E4E616D65222C636F6D706F6E656E743A4E242C69734564697465643A6F577D2C7B69643A22657363616C6174696F6E436F6465222C636F6D706F6E656E743A5024';
wwv_flow_imp.g_varchar2_table(51255) := '2C69734564697465643A6F577D5D292C6E7D66756E6374696F6E2041242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C57282262706D6E466163746F727922292C6F3D4C572822636F6D6D616E64537461636B22292C733D4C57282274';
wwv_flow_imp.g_varchar2_table(51256) := '72616E736C61746522292C723D6E242874293B72657475726E205571287B656C656D656E743A742C69643A22657363616C6174696F6E526566222C6C6162656C3A732822476C6F62616C20657363616C6174696F6E207265666572656E636522292C6175';
wwv_flow_imp.g_varchar2_table(51257) := '746F466F637573456E7472793A22657363616C6174696F6E4E616D65222C67657456616C75653A28293D3E7B636F6E737420653D6F242874293B72657475726E20652626652E6765742822696422297D2C73657456616C75653A653D3E7B636F6E737420';
wwv_flow_imp.g_varchar2_table(51258) := '693D77242872292C733D5B5D3B6C657420613B696628653D3D3D4924297B636F6E7374206F3D79242822457363616C6174696F6E5F22293B613D5F24282262706D6E3A457363616C6174696F6E222C7B69643A6F2C6E616D653A6F7D2C692C6E292C653D';
wwv_flow_imp.g_varchar2_table(51259) := '612E6765742822696422292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A742C6D6F64646C65456C656D656E743A692C70726F7065727469';
wwv_flow_imp.g_varchar2_table(51260) := '65733A7B726F6F74456C656D656E74733A5B2E2E2E692E6765742822726F6F74456C656D656E747322292C615D7D7D7D297D72657475726E20613D617C7C532428722C2262706D6E3A457363616C6174696F6E222C65292C732E70757368287B636D643A';
wwv_flow_imp.g_varchar2_table(51261) := '22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A742C6D6F64646C65456C656D656E743A722C70726F706572746965733A7B657363616C6174696F6E5265663A617D7D7D292C';
wwv_flow_imp.g_varchar2_table(51262) := '6F2E65786563757465282270726F706572746965732D70616E656C2E6D756C74692D636F6D6D616E642D6578656375746F72222C73297D2C6765744F7074696F6E733A28293D3E7B6C657420653D5B7B76616C75653A22222C6C6162656C3A7328223C6E';
wwv_flow_imp.g_varchar2_table(51263) := '6F6E653E22297D2C7B76616C75653A49242C6C6162656C3A732822437265617465206E6577202E2E2E22297D5D3B766172206E3B72657475726E286E3D43242828302C792E676574427573696E6573734F626A656374292874292C2262706D6E3A457363';
wwv_flow_imp.g_varchar2_table(51264) := '616C6174696F6E22292C28302C692E556C29286E2C28653D3E28652E6E616D657C7C2222292E746F4C6F7765724361736528292929292E666F72456163682828743D3E7B652E70757368287B76616C75653A742E6765742822696422292C6C6162656C3A';
wwv_flow_imp.g_varchar2_table(51265) := '742E67657428226E616D6522297D297D29292C657D7D297D66756E6374696F6E204E242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728227472616E736C61746522292C6F3D4C';
wwv_flow_imp.g_varchar2_table(51266) := '5728226465626F756E6365496E70757422292C733D6F242874293B72657475726E206957287B656C656D656E743A742C69643A22657363616C6174696F6E4E616D65222C6C6162656C3A6928224E616D6522292C67657456616C75653A28293D3E732E67';
wwv_flow_imp.g_varchar2_table(51267) := '657428226E616D6522292C73657456616C75653A653D3E6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A732C70726F70657274';
wwv_flow_imp.g_varchar2_table(51268) := '6965733A7B6E616D653A657D7D292C6465626F756E63653A6F7D297D66756E6374696F6E2050242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728227472616E736C6174652229';
wwv_flow_imp.g_varchar2_table(51269) := '2C6F3D4C5728226465626F756E6365496E70757422292C733D6F242874293B72657475726E206957287B656C656D656E743A742C69643A22657363616C6174696F6E436F6465222C6C6162656C3A692822436F646522292C67657456616C75653A28293D';
wwv_flow_imp.g_varchar2_table(51270) := '3E732E6765742822657363616C6174696F6E436F646522292C73657456616C75653A653D3E6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C65';
wwv_flow_imp.g_varchar2_table(51271) := '6D656E743A732C70726F706572746965733A7B657363616C6174696F6E436F64653A657D7D292C6465626F756E63653A6F7D297D66756E6374696F6E204F242865297B636F6E73747B656C656D656E743A747D3D653B72657475726E28302C792E697329';
wwv_flow_imp.g_varchar2_table(51272) := '28742C2262706D6E3A50726F6365737322297C7C66756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E7422292626652E627573696E6573734F626A6563742E676574282270726F6365737352';
wwv_flow_imp.g_varchar2_table(51273) := '656622297D2874293F5B7B69643A22697345786563757461626C65222C636F6D706F6E656E743A52242C69734564697465643A24487D5D3A5B5D7D66756E6374696F6E2052242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C5728226D';
wwv_flow_imp.g_varchar2_table(51274) := '6F64656C696E6722292C693D4C572822636F6D6D616E64537461636B22292C6F3D4C5728227472616E736C61746522293B6C657420732C723B696628723D653D3E7B6E2E75706461746550726F7065727469657328742C7B697345786563757461626C65';
wwv_flow_imp.g_varchar2_table(51275) := '3A657D297D2C733D653D3E652E627573696E6573734F626A6563742E697345786563757461626C652C28302C792E69732928742C2262706D6E3A5061727469636970616E742229297B636F6E737420653D742E627573696E6573734F626A6563742E6765';
wwv_flow_imp.g_varchar2_table(51276) := '74282270726F6365737352656622293B723D6E3D3E7B692E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A652C70726F7065727469';
wwv_flow_imp.g_varchar2_table(51277) := '65733A7B697345786563757461626C653A6E7D7D297D2C733D28293D3E652E6765742822697345786563757461626C6522297D72657475726E207148287B656C656D656E743A742C69643A22697345786563757461626C65222C6C6162656C3A6F282245';
wwv_flow_imp.g_varchar2_table(51278) := '786563757461626C6522292C67657456616C75653A732C73657456616C75653A727D297D636F6E73742046243D2F5C732F2C42243D2F5E285B612D7A5D5B5C772D2E5D2A3A293F5B612D7A5F5D5B5C772D2E5D2A242F692C56243D2F5E5B612D7A5F5D5B';
wwv_flow_imp.g_varchar2_table(51279) := '5C772D2E5D2A242F693B66756E6374696F6E207A2428652C742C6E297B636F6E737420693D652E246D6F64656C2E6964732E61737369676E65642874293B72657475726E20743F69262669213D3D653F6E28224944206D75737420626520756E69717565';
wwv_flow_imp.g_varchar2_table(51280) := '2E22293A66756E6374696F6E28652C74297B72657475726E206E3D652C46242E74657374286E293F7428224944206D757374206E6F7420636F6E7461696E207370616365732E22293A56242E746573742865293F766F696420303A42242E746573742865';
wwv_flow_imp.g_varchar2_table(51281) := '293F7428224944206D757374206E6F7420636F6E7461696E207072656669782E22293A7428224944206D75737420626520612076616C696420514E616D652E22293B766172206E7D28742C6E293A6E28224944206D757374206E6F7420626520656D7074';
wwv_flow_imp.g_varchar2_table(51282) := '792E22297D66756E6374696F6E2048242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C5728226D6F64656C696E6722292C693D4C5728226465626F756E6365496E70757422292C6F3D4C5728227472616E736C61746522292C733D4B77';
wwv_flow_imp.g_varchar2_table(51283) := '2828653D3E28302C792E676574427573696E6573734F626A656374292865292E6964292C5B745D292C723D4B772828653D3E7A242828302C792E676574427573696E6573734F626A656374292874292C652C6F29292C5B742C6F5D293B72657475726E20';
wwv_flow_imp.g_varchar2_table(51284) := '6957287B656C656D656E743A742C69643A226964222C6C6162656C3A6F2828302C792E69732928742C2262706D6E3A5061727469636970616E7422293F225061727469636970616E74204944223A22494422292C67657456616C75653A732C7365745661';
wwv_flow_imp.g_varchar2_table(51285) := '6C75653A28652C69293D3E7B697C7C6E2E75706461746550726F7065727469657328742C7B69643A657D297D2C6465626F756E63653A692C76616C69646174653A727D297D66756E6374696F6E2057242865297B636F6E73747B656C656D656E743A747D';
wwv_flow_imp.g_varchar2_table(51286) := '3D653B72657475726E2066756E6374696F6E2865297B72657475726E28302C792E6973416E792928652C5B2262706D6E3A496E7465726D6564696174655468726F774576656E74222C2262706D6E3A496E7465726D65646961746543617463684576656E';
wwv_flow_imp.g_varchar2_table(51287) := '74225D29262621214A712865297D2874293F5B7B69643A226C696E6B4E616D65222C636F6D706F6E656E743A6A242C69734564697465643A6F577D5D3A5B5D7D66756E6374696F6E206A242865297B636F6E73747B656C656D656E743A747D3D652C6E3D';
wwv_flow_imp.g_varchar2_table(51288) := '4C572822636F6D6D616E64537461636B22292C693D4C5728227472616E736C61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D4A712874293B72657475726E206957287B656C656D656E743A742C69643A226C696E6B4E616D65';
wwv_flow_imp.g_varchar2_table(51289) := '222C6C6162656C3A6928224E616D6522292C67657456616C75653A28293D3E732E67657428226E616D6522292C73657456616C75653A653D3E7B6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F7065727469657322';
wwv_flow_imp.g_varchar2_table(51290) := '2C7B656C656D656E743A742C6D6F64646C65456C656D656E743A732C70726F706572746965733A7B6E616D653A657D7D297D2C6465626F756E63653A6F7D297D636F6E73742071243D22222C24243D226372656174652D6E6577223B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(51291) := '2055242865297B636F6E73747B656C656D656E743A747D3D653B6966282166756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A526563656976655461736B22297C7C28302C792E6973416E792928652C5B2262706D6E';
wwv_flow_imp.g_varchar2_table(51292) := '3A53746172744576656E74222C2262706D6E3A456E644576656E74222C2262706D6E3A496E7465726D6564696174655468726F774576656E74222C2262706D6E3A426F756E646172794576656E74222C2262706D6E3A496E7465726D6564696174654361';
wwv_flow_imp.g_varchar2_table(51293) := '7463684576656E74225D29262621215A712865297D2874292972657475726E5B5D3B6C6574206E3D5B7B69643A226D657373616765526566222C636F6D706F6E656E743A4B242C69734564697465643A51487D5D3B72657475726E205871287429262628';
wwv_flow_imp.g_varchar2_table(51294) := '6E3D5B2E2E2E6E2C7B69643A226D6573736167654E616D65222C636F6D706F6E656E743A47242C69734564697465643A6F577D5D292C6E7D66756E6374696F6E204B242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C57282262706D6E';
wwv_flow_imp.g_varchar2_table(51295) := '466163746F727922292C6F3D4C572822636F6D6D616E64537461636B22292C733D4C5728227472616E736C61746522292C723D5A712874293B72657475726E205571287B656C656D656E743A742C69643A226D657373616765526566222C6C6162656C3A';
wwv_flow_imp.g_varchar2_table(51296) := '732822476C6F62616C206D657373616765207265666572656E636522292C6175746F466F637573456E7472793A226D6573736167654E616D65222C67657456616C75653A28293D3E7B636F6E737420653D58712874293B72657475726E20653F652E6765';
wwv_flow_imp.g_varchar2_table(51297) := '742822696422293A71247D2C73657456616C75653A653D3E7B636F6E737420693D77242872292C733D5B5D3B6C657420613B696628653D3D3D2424297B636F6E7374206F3D792428224D6573736167655F22293B613D5F24282262706D6E3A4D65737361';
wwv_flow_imp.g_varchar2_table(51298) := '6765222C7B69643A6F2C6E616D653A6F7D2C692C6E292C653D612E6765742822696422292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A74';
wwv_flow_imp.g_varchar2_table(51299) := '2C6D6F64646C65456C656D656E743A692C70726F706572746965733A7B726F6F74456C656D656E74733A5B2E2E2E692E6765742822726F6F74456C656D656E747322292C615D7D7D7D297D72657475726E20613D617C7C532428722C2262706D6E3A4D65';
wwv_flow_imp.g_varchar2_table(51300) := '7373616765222C65292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A742C6D6F64646C65456C656D656E743A722C70726F70657274696573';
wwv_flow_imp.g_varchar2_table(51301) := '3A7B6D6573736167655265663A617D7D7D292C6F2E65786563757465282270726F706572746965732D70616E656C2E6D756C74692D636F6D6D616E642D6578656375746F72222C73297D2C6765744F7074696F6E733A28293D3E7B6C657420653D5B7B76';
wwv_flow_imp.g_varchar2_table(51302) := '616C75653A71242C6C6162656C3A7328223C6E6F6E653E22297D2C7B76616C75653A24242C6C6162656C3A732822437265617465206E6577202E2E2E22297D5D3B766172206E3B72657475726E286E3D43242828302C792E676574427573696E6573734F';
wwv_flow_imp.g_varchar2_table(51303) := '626A656374292874292C2262706D6E3A4D65737361676522292C28302C692E556C29286E2C28653D3E28652E6E616D657C7C2222292E746F4C6F7765724361736528292929292E666F72456163682828743D3E7B652E70757368287B76616C75653A742E';
wwv_flow_imp.g_varchar2_table(51304) := '6765742822696422292C6C6162656C3A742E67657428226E616D6522297D297D29292C657D7D297D66756E6374696F6E2047242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728';
wwv_flow_imp.g_varchar2_table(51305) := '227472616E736C61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D58712874293B72657475726E206957287B656C656D656E743A742C69643A226D6573736167654E616D65222C6C6162656C3A6928224E616D6522292C676574';
wwv_flow_imp.g_varchar2_table(51306) := '56616C75653A28293D3E732E67657428226E616D6522292C73657456616C75653A653D3E6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D';
wwv_flow_imp.g_varchar2_table(51307) := '656E743A732C70726F706572746965733A7B6E616D653A657D7D292C6465626F756E63653A6F7D297D66756E6374696F6E2051242865297B636F6E73747B656C656D656E743A747D3D653B72657475726E2066756E6374696F6E2865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(51308) := '743D65552865293B72657475726E212174262628302C792E69732928742C2262706D6E3A4D756C7469496E7374616E63654C6F6F7043686172616374657269737469637322297D2874293F5B7B69643A226C6F6F7043617264696E616C697479222C636F';
wwv_flow_imp.g_varchar2_table(51309) := '6D706F6E656E743A59242C69734564697465643A6F577D2C7B69643A22636F6D706C6574696F6E436F6E646974696F6E222C636F6D706F6E656E743A5A242C69734564697465643A6F577D5D3A5B5D7D66756E6374696F6E2059242865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(51310) := '7B656C656D656E743A747D3D652C6E3D4C57282262706D6E466163746F727922292C693D4C5728226465626F756E6365496E70757422292C6F3D4C572822636F6D6D616E64537461636B22292C733D4C5728227472616E736C61746522293B7265747572';
wwv_flow_imp.g_varchar2_table(51311) := '6E206957287B656C656D656E743A742C69643A226C6F6F7043617264696E616C697479222C6C6162656C3A7328224C6F6F702063617264696E616C69747922292C67657456616C75653A28293D3E66756E6374696F6E2865297B636F6E737420743D6675';
wwv_flow_imp.g_varchar2_table(51312) := '6E6374696F6E2865297B72657475726E204A2428652C226C6F6F7043617264696E616C69747922297D2865293B72657475726E2058242874297D2874292C73657456616C75653A653D3E6F2E657865637574652822656C656D656E742E7570646174654D';
wwv_flow_imp.g_varchar2_table(51313) := '6F64646C6550726F70657274696573222C745528742C226C6F6F7043617264696E616C697479222C652C6E29292C6465626F756E63653A697D297D66756E6374696F6E205A242865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C57282262';
wwv_flow_imp.g_varchar2_table(51314) := '706D6E466163746F727922292C693D4C5728226465626F756E6365496E70757422292C6F3D4C572822636F6D6D616E64537461636B22292C733D4C5728227472616E736C61746522293B72657475726E206957287B656C656D656E743A742C69643A2263';
wwv_flow_imp.g_varchar2_table(51315) := '6F6D706C6574696F6E436F6E646974696F6E222C6C6162656C3A732822436F6D706C6574696F6E20636F6E646974696F6E22292C67657456616C75653A28293D3E66756E6374696F6E2865297B636F6E737420743D66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(51316) := '75726E204A2428652C22636F6D706C6574696F6E436F6E646974696F6E22297D2865293B72657475726E2058242874297D2874292C73657456616C75653A653D3E6F2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70';
wwv_flow_imp.g_varchar2_table(51317) := '657274696573222C745528742C22636F6D706C6574696F6E436F6E646974696F6E222C652C6E29292C6465626F756E63653A697D297D66756E6374696F6E2058242865297B72657475726E20652626652E6765742822626F647922297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(51318) := '6E204A2428652C74297B636F6E7374206E3D65552865293B72657475726E206E26266E2E6765742874297D66756E6374696F6E2065552865297B72657475726E28302C792E676574427573696E6573734F626A656374292865292E6C6F6F704368617261';
wwv_flow_imp.g_varchar2_table(51319) := '637465726973746963737D66756E6374696F6E20745528652C742C6E2C69297B636F6E7374206F3D65552865292C733D7B7D3B696628216E2972657475726E20735B745D3D766F696420302C7B656C656D656E743A652C6D6F64646C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(51320) := '3A6F2C70726F706572746965733A737D3B636F6E737420723D6F2E6765742874293B72657475726E20723F7B656C656D656E743A652C6D6F64646C65456C656D656E743A722C70726F706572746965733A7B626F64793A6E7D7D3A28735B745D3D66756E';
wwv_flow_imp.g_varchar2_table(51321) := '6374696F6E28652C742C6E297B72657475726E205F24282262706D6E3A466F726D616C45787072657373696F6E222C7B626F64793A747D2C652C6E297D286F2C6E2C69292C7B656C656D656E743A652C6D6F64646C65456C656D656E743A6F2C70726F70';
wwv_flow_imp.g_varchar2_table(51322) := '6572746965733A737D297D66756E6374696F6E206E552865297B636F6E73747B656C656D656E743A747D3D653B72657475726E28302C792E6973416E792928742C5B2262706D6E3A436F6C6C61626F726174696F6E222C2262706D6E3A44617461417373';
wwv_flow_imp.g_varchar2_table(51323) := '6F63696174696F6E222C2262706D6E3A4173736F63696174696F6E225D293F5B5D3A5B7B69643A226E616D65222C636F6D706F6E656E743A69552C69734564697465643A65577D5D7D66756E6374696F6E2069552865297B636F6E73747B656C656D656E';
wwv_flow_imp.g_varchar2_table(51324) := '743A747D3D652C6E3D4C5728226D6F64656C696E6722292C693D4C5728226465626F756E6365496E70757422292C6F3D4C57282263616E76617322292C733D4C57282262706D6E466163746F727922292C723D4C5728227472616E736C61746522293B6C';
wwv_flow_imp.g_varchar2_table(51325) := '657420613D7B656C656D656E743A742C69643A226E616D65222C6C6162656C3A7228224E616D6522292C6465626F756E63653A692C73657456616C75653A653D3E7B6E2E75706461746550726F7065727469657328742C7B6E616D653A657D297D2C6765';
wwv_flow_imp.g_varchar2_table(51326) := '7456616C75653A653D3E652E627573696E6573734F626A6563742E6E616D652C6175746F526573697A653A21307D3B72657475726E28302C792E69732928742C2262706D6E3A54657874416E6E6F746174696F6E22293F613D7B2E2E2E612C7365745661';
wwv_flow_imp.g_varchar2_table(51327) := '6C75653A653D3E7B6E2E75706461746550726F7065727469657328742C7B746578743A657D297D2C67657456616C75653A653D3E652E627573696E6573734F626A6563742E746578747D3A28302C792E69732928742C2262706D6E3A47726F757022293F';
wwv_flow_imp.g_varchar2_table(51328) := '613D7B2E2E2E612C73657456616C75653A653D3E7B636F6E737420693D28302C792E676574427573696E6573734F626A656374292874293B692E63617465676F727956616C75655265667C7C66756E6374696F6E28652C742C6E297B636F6E737420693D';
wwv_flow_imp.g_varchar2_table(51329) := '66756E6374696F6E28652C74297B636F6E7374206E3D742E637265617465282262706D6E3A43617465676F727956616C756522292C693D742E637265617465282262706D6E3A43617465676F7279222C7B63617465676F727956616C75653A5B6E5D7D29';
wwv_flow_imp.g_varchar2_table(51330) := '3B72657475726E204B7428652E6765742822726F6F74456C656D656E747322292C69292C28302C792E676574427573696E6573734F626A656374292869292E24706172656E743D652C28302C792E676574427573696E6573734F626A65637429286E292E';
wwv_flow_imp.g_varchar2_table(51331) := '24706172656E743D692C6E7D2828302C792E676574427573696E6573734F626A656374292874292E24706172656E742C6E293B652E63617465676F727956616C75655265663D697D28692C6F2E676574526F6F74456C656D656E7428292C73292C6E2E75';
wwv_flow_imp.g_varchar2_table(51332) := '70646174654C6162656C28742C65297D2C67657456616C75653A653D3E7B636F6E737420743D28302C792E676574427573696E6573734F626A656374292865292E63617465676F727956616C75655265663B72657475726E20742626742E76616C75657D';
wwv_flow_imp.g_varchar2_table(51333) := '7D3A28302C792E69732928742C2262706D6E3A5061727469636970616E742229262628612E6C6162656C3D7228225061727469636970616E74204E616D652229292C4A482861297D66756E6374696F6E206F552865297B636F6E73747B656C656D656E74';
wwv_flow_imp.g_varchar2_table(51334) := '3A747D3D653B72657475726E2066756E6374696F6E2865297B72657475726E28302C792E69732928652C2262706D6E3A5061727469636970616E7422292626652E627573696E6573734F626A6563742E676574282270726F6365737352656622297D2874';
wwv_flow_imp.g_varchar2_table(51335) := '293F5B7B69643A2270726F636573734964222C636F6D706F6E656E743A72552C69734564697465643A6F577D2C7B69643A2270726F636573734E616D65222C636F6D706F6E656E743A73552C69734564697465643A6F577D5D3A5B5D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(51336) := '6E2073552865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728227472616E736C61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D742E627573696E657373';
wwv_flow_imp.g_varchar2_table(51337) := '4F626A6563742E676574282270726F6365737352656622293B72657475726E206957287B656C656D656E743A742C69643A2270726F636573734E616D65222C6C6162656C3A69282250726F63657373206E616D6522292C67657456616C75653A28293D3E';
wwv_flow_imp.g_varchar2_table(51338) := '732E67657428226E616D6522292C73657456616C75653A653D3E7B6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A732C70726F';
wwv_flow_imp.g_varchar2_table(51339) := '706572746965733A7B6E616D653A657D7D297D2C6465626F756E63653A6F7D297D66756E6374696F6E2072552865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728227472616E736C';
wwv_flow_imp.g_varchar2_table(51340) := '61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D742E627573696E6573734F626A6563742E676574282270726F6365737352656622292C723D4B772828653D3E7A2428732C652C6929292C5B732C695D293B72657475726E2069';
wwv_flow_imp.g_varchar2_table(51341) := '57287B656C656D656E743A742C69643A2270726F636573734964222C6C6162656C3A69282250726F6365737320494422292C67657456616C75653A28293D3E732E6765742822696422292C73657456616C75653A28652C69293D3E7B697C7C6E2E657865';
wwv_flow_imp.g_varchar2_table(51342) := '637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A732C70726F706572746965733A7B69643A657D7D297D2C6465626F756E63653A6F2C76616C';
wwv_flow_imp.g_varchar2_table(51343) := '69646174653A727D297D636F6E73742061553D22222C6C553D226372656174652D6E6577223B66756E6374696F6E2063552865297B636F6E73747B656C656D656E743A747D3D653B6966282166756E6374696F6E2865297B72657475726E28302C792E69';
wwv_flow_imp.g_varchar2_table(51344) := '732928652C2262706D6E3A4576656E7422292626212165242865297D2874292972657475726E5B5D3B6C6574206E3D5B7B69643A227369676E616C526566222C636F6D706F6E656E743A64552C69734564697465643A51487D5D3B72657475726E207424';
wwv_flow_imp.g_varchar2_table(51345) := '2874292626286E3D5B2E2E2E6E2C7B69643A227369676E616C4E616D65222C636F6D706F6E656E743A68552C69734564697465643A6F577D5D292C6E7D66756E6374696F6E2064552865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C5728';
wwv_flow_imp.g_varchar2_table(51346) := '2262706D6E466163746F727922292C6F3D4C572822636F6D6D616E64537461636B22292C733D4C5728227472616E736C61746522292C723D65242874293B72657475726E205571287B656C656D656E743A742C69643A227369676E616C526566222C6C61';
wwv_flow_imp.g_varchar2_table(51347) := '62656C3A732822476C6F62616C207369676E616C207265666572656E636522292C6175746F466F637573456E7472793A227369676E616C4E616D65222C67657456616C75653A28293D3E7B636F6E737420653D74242874293B72657475726E20653F652E';
wwv_flow_imp.g_varchar2_table(51348) := '6765742822696422293A61557D2C73657456616C75653A653D3E7B636F6E737420693D77242872292C733D5B5D3B6C657420613B696628653D3D3D6C55297B636F6E7374206F3D792428225369676E616C5F22293B613D5F24282262706D6E3A5369676E';
wwv_flow_imp.g_varchar2_table(51349) := '616C222C7B69643A6F2C6E616D653A6F7D2C692C6E292C653D612E6765742822696422292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A74';
wwv_flow_imp.g_varchar2_table(51350) := '2C6D6F64646C65456C656D656E743A692C70726F706572746965733A7B726F6F74456C656D656E74733A5B2E2E2E692E6765742822726F6F74456C656D656E747322292C615D7D7D7D297D72657475726E20613D617C7C532428722C2262706D6E3A5369';
wwv_flow_imp.g_varchar2_table(51351) := '676E616C222C65292C732E70757368287B636D643A22656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C636F6E746578743A7B656C656D656E743A742C6D6F64646C65456C656D656E743A722C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(51352) := '7B7369676E616C5265663A617D7D7D292C6F2E65786563757465282270726F706572746965732D70616E656C2E6D756C74692D636F6D6D616E642D6578656375746F72222C73297D2C6765744F7074696F6E733A28293D3E7B6C657420653D5B7B76616C';
wwv_flow_imp.g_varchar2_table(51353) := '75653A61552C6C6162656C3A7328223C6E6F6E653E22297D2C7B76616C75653A6C552C6C6162656C3A732822437265617465206E6577202E2E2E22297D5D3B766172206E3B72657475726E286E3D43242828302C792E676574427573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(51354) := '656374292874292C2262706D6E3A5369676E616C22292C28302C692E556C29286E2C28653D3E28652E6E616D657C7C2222292E746F4C6F7765724361736528292929292E666F72456163682828743D3E7B652E70757368287B76616C75653A742E676574';
wwv_flow_imp.g_varchar2_table(51355) := '2822696422292C6C6162656C3A742E67657428226E616D6522297D297D29292C657D7D297D66756E6374696F6E2068552865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C572822636F6D6D616E64537461636B22292C693D4C5728227472';
wwv_flow_imp.g_varchar2_table(51356) := '616E736C61746522292C6F3D4C5728226465626F756E6365496E70757422292C733D74242874293B72657475726E206957287B656C656D656E743A742C69643A227369676E616C4E616D65222C6C6162656C3A6928224E616D6522292C67657456616C75';
wwv_flow_imp.g_varchar2_table(51357) := '653A28293D3E732E67657428226E616D6522292C73657456616C75653A653D3E6E2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A';
wwv_flow_imp.g_varchar2_table(51358) := '732C70726F706572746965733A7B6E616D653A657D7D292C6465626F756E63653A6F7D297D66756E6374696F6E2075552865297B72657475726E28302C792E6973416E792928652C5B2262706D6E3A53746172744576656E74222C2262706D6E3A496E74';
wwv_flow_imp.g_varchar2_table(51359) := '65726D65646961746543617463684576656E74222C2262706D6E3A426F756E646172794576656E74225D292626212167552865297D66756E6374696F6E2070552865297B696628652972657475726E20766F69642030213D3D652E676574282274696D65';
wwv_flow_imp.g_varchar2_table(51360) := '4461746522293F2274696D6544617465223A766F69642030213D3D652E676574282274696D654379636C6522293F2274696D654379636C65223A766F69642030213D3D652E676574282274696D654475726174696F6E22293F2274696D65447572617469';
wwv_flow_imp.g_varchar2_table(51361) := '6F6E223A766F696420307D66756E6374696F6E2067552865297B72657475726E206D5528652C2262706D6E3A54696D65724576656E74446566696E6974696F6E22297D66756E6374696F6E206D5528652C74297B636F6E7374206E3D28302C792E676574';
wwv_flow_imp.g_varchar2_table(51362) := '427573696E6573734F626A656374292865292E67657428226576656E74446566696E6974696F6E7322297C7C5B5D3B72657475726E28302C692E493629286E2C2866756E6374696F6E2865297B72657475726E28302C792E69732928652C74297D29297D';
wwv_flow_imp.g_varchar2_table(51363) := '66756E6374696F6E2066552865297B636F6E73747B656C656D656E743A742C69645072656669783A6E7D3D653B6C65747B74696D65724576656E74446566696E6974696F6E3A697D3D653B697C7C28693D67552828302C792E676574427573696E657373';
wwv_flow_imp.g_varchar2_table(51364) := '4F626A6563742928742929293B636F6E7374206F3D70552869293B6966282175552874292972657475726E5B5D3B636F6E737420733D5B5D3B72657475726E20732E70757368287B69643A7955286E2C2274696D65724576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(51365) := '6E5479706522292C636F6D706F6E656E743A76552C69734564697465643A51482C74696D65724576656E74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D292C6F2626732E70757368287B69643A79';
wwv_flow_imp.g_varchar2_table(51366) := '55286E2C2274696D65724576656E74446566696E6974696F6E56616C756522292C636F6D706F6E656E743A62552C69734564697465643A6F572C74696D65724576656E74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(51367) := '6E547970653A6F7D292C737D66756E6374696F6E2076552865297B636F6E73747B656C656D656E743A742C74696D65724576656E74446566696E6974696F6E3A6E2C74696D65724576656E74446566696E6974696F6E547970653A697D3D652C6F3D4C57';
wwv_flow_imp.g_varchar2_table(51368) := '2822636F6D6D616E64537461636B22292C733D4C57282262706D6E466163746F727922292C723D4C5728227472616E736C61746522293B72657475726E204748287B656C656D656E743A742C69643A2274696D65724576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(51369) := '54797065222C6C6162656C3A7228225479706522292C67657456616C75653A28293D3E697C7C22222C73657456616C75653A653D3E7B696628653D3D3D692972657475726E3B636F6E737420723D732E637265617465282262706D6E3A466F726D616C45';
wwv_flow_imp.g_varchar2_table(51370) := '787072657373696F6E222C7B626F64793A766F696420307D293B722E24706172656E743D6E3B636F6E737420613D7B74696D654475726174696F6E3A766F696420302C74696D65446174653A766F696420302C74696D654379636C653A766F696420307D';
wwv_flow_imp.g_varchar2_table(51371) := '3B2222213D3D65262628615B655D3D72292C6F2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E743A6E2C70726F706572746965733A61';
wwv_flow_imp.g_varchar2_table(51372) := '7D297D2C6765744F7074696F6E733A653D3E5B7B76616C75653A22222C6C6162656C3A7228223C6E6F6E653E22297D2C7B76616C75653A2274696D6544617465222C6C6162656C3A7228224461746522297D2C7B76616C75653A2274696D654475726174';
wwv_flow_imp.g_varchar2_table(51373) := '696F6E222C6C6162656C3A7228224475726174696F6E22297D2C7B76616C75653A2274696D654379636C65222C6C6162656C3A7228224379636C6522297D5D7D297D66756E6374696F6E2062552865297B636F6E73747B656C656D656E743A742C74696D';
wwv_flow_imp.g_varchar2_table(51374) := '65724576656E74446566696E6974696F6E3A6E2C74696D65724576656E74446566696E6974696F6E547970653A697D3D652C6F3D4C572822636F6D6D616E64537461636B22292C733D4C5728227472616E736C61746522292C723D4C5728226465626F75';
wwv_flow_imp.g_varchar2_table(51375) := '6E6365496E70757422292C613D6E2E6765742869293B72657475726E206957287B656C656D656E743A742C69643A2274696D65724576656E74446566696E6974696F6E56616C7565222C6C6162656C3A73282256616C756522292C67657456616C75653A';
wwv_flow_imp.g_varchar2_table(51376) := '28293D3E612626612E6765742822626F647922292C73657456616C75653A653D3E7B6F2E657865637574652822656C656D656E742E7570646174654D6F64646C6550726F70657274696573222C7B656C656D656E743A742C6D6F64646C65456C656D656E';
wwv_flow_imp.g_varchar2_table(51377) := '743A612C70726F706572746965733A7B626F64793A657D7D297D2C6465626F756E63653A722C746F6F6C7469703A5F5528692C73297D297D66756E6374696F6E205F5528652C74297B7377697463682865297B636173652274696D6544617465223A7265';
wwv_flow_imp.g_varchar2_table(51378) := '7475726E28302C50432E6A737873292822646976222C7B6368696C6472656E3A5B28302C50432E6A737829282270222C7B6368696C6472656E3A7428224120737065636966696320706F696E7420696E2074696D6520646566696E65642061732049534F';
wwv_flow_imp.g_varchar2_table(51379) := '203836303120636F6D62696E6564206461746520616E642074696D6520726570726573656E746174696F6E2E22297D292C28302C50432E6A737873292822756C222C7B6368696C6472656E3A5B28302C50432E6A7378732928226C69222C7B6368696C64';
wwv_flow_imp.g_varchar2_table(51380) := '72656E3A5B28302C50432E6A7378292822636F6465222C7B6368696C6472656E3A22323031392D31302D30315431323A30303A30305A227D292C22202D20222C7428225554432074696D6522295D7D292C28302C50432E6A7378732928226C69222C7B63';
wwv_flow_imp.g_varchar2_table(51381) := '68696C6472656E3A5B28302C50432E6A7378292822636F6465222C7B6368696C6472656E3A22323031392D31302D30325430383A30393A34302B30323A3030227D292C22202D20222C74282255544320706C7573203220686F757273207A6F6E65206F66';
wwv_flow_imp.g_varchar2_table(51382) := '6673657422295D7D295D7D292C28302C50432E6A737829282261222C7B687265663A2268747470733A2F2F646F63732E63616D756E64612E6F72672F6D616E75616C2F6C61746573742F7265666572656E63652F62706D6E32302F6576656E74732F7469';
wwv_flow_imp.g_varchar2_table(51383) := '6D65722D6576656E74732F2374696D652D64617465222C7461726765743A225F626C616E6B222C72656C3A226E6F6F70656E6572222C6368696C6472656E3A742822446F63756D656E746174696F6E3A2054696D6572206576656E747322297D295D7D29';
wwv_flow_imp.g_varchar2_table(51384) := '3B636173652274696D654379636C65223A72657475726E28302C50432E6A737873292822646976222C7B6368696C6472656E3A5B28302C50432E6A737829282270222C7B6368696C6472656E3A74282241206379636C6520646566696E65642061732049';
wwv_flow_imp.g_varchar2_table(51385) := '534F203836303120726570656174696E6720696E74657276616C7320666F726D61742E22297D292C28302C50432E6A737873292822756C222C7B6368696C6472656E3A5B28302C50432E6A7378732928226C69222C7B6368696C6472656E3A5B28302C50';
wwv_flow_imp.g_varchar2_table(51386) := '432E6A7378292822636F6465222C7B6368696C6472656E3A2252352F5054313053227D292C22202D20222C7428226576657279203130207365636F6E64732C20757020746F20352074696D657322295D7D292C28302C50432E6A7378732928226C69222C';
wwv_flow_imp.g_varchar2_table(51387) := '7B6368696C6472656E3A5B28302C50432E6A7378292822636F6465222C7B6368696C6472656E3A22522F503144227D292C22202D20222C7428226576657279206461792C20696E66696E6974656C7922295D7D295D7D292C28302C50432E6A7378292822';
wwv_flow_imp.g_varchar2_table(51388) := '61222C7B687265663A2268747470733A2F2F646F63732E63616D756E64612E6F72672F6D616E75616C2F6C61746573742F7265666572656E63652F62706D6E32302F6576656E74732F74696D65722D6576656E74732F2374696D652D6379636C65222C74';
wwv_flow_imp.g_varchar2_table(51389) := '61726765743A225F626C616E6B222C72656C3A226E6F6F70656E6572222C6368696C6472656E3A742822446F63756D656E746174696F6E3A2054696D6572206576656E747322297D295D7D293B636173652274696D654475726174696F6E223A72657475';
wwv_flow_imp.g_varchar2_table(51390) := '726E28302C50432E6A737873292822646976222C7B6368696C6472656E3A5B28302C50432E6A737829282270222C7B6368696C6472656E3A742822412074696D65206475726174696F6E20646566696E65642061732049534F2038363031206475726174';
wwv_flow_imp.g_varchar2_table(51391) := '696F6E7320666F726D61742E22297D292C28302C50432E6A737873292822756C222C7B6368696C6472656E3A5B28302C50432E6A7378732928226C69222C7B6368696C6472656E3A5B28302C50432E6A7378292822636F6465222C7B6368696C6472656E';
wwv_flow_imp.g_varchar2_table(51392) := '3A225054313553227D292C22202D20222C7428223135207365636F6E647322295D7D292C28302C50432E6A7378732928226C69222C7B6368696C6472656E3A5B28302C50432E6A7378292822636F6465222C7B6368696C6472656E3A225054314833304D';
wwv_flow_imp.g_varchar2_table(51393) := '227D292C22202D20222C7428223120686F757220616E64203330206D696E7574657322295D7D292C28302C50432E6A7378732928226C69222C7B6368696C6472656E3A5B28302C50432E6A7378292822636F6465222C7B6368696C6472656E3A22503134';
wwv_flow_imp.g_varchar2_table(51394) := '44227D292C22202D20222C7428223134206461797322295D7D295D7D292C28302C50432E6A737829282261222C7B687265663A2268747470733A2F2F646F63732E63616D756E64612E6F72672F6D616E75616C2F6C61746573742F7265666572656E6365';
wwv_flow_imp.g_varchar2_table(51395) := '2F62706D6E32302F6576656E74732F74696D65722D6576656E74732F2374696D652D6475726174696F6E222C7461726765743A225F626C616E6B222C72656C3A226E6F6F70656E6572222C6368696C6472656E3A742822446F63756D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(51396) := '3A2054696D6572206576656E747322297D295D7D297D7D66756E6374696F6E20795528652C74297B72657475726E20653F652B743A747D66756E6374696F6E20775528652C74297B636F6E7374206E3D742E67657428227472616E736C61746522292C69';
wwv_flow_imp.g_varchar2_table(51397) := '3D5B2E2E2E6E55287B656C656D656E743A657D292C7B69643A226964222C636F6D706F6E656E743A48242C69734564697465643A6F577D2C2E2E2E6F55287B656C656D656E743A657D292C2E2E2E4F24287B656C656D656E743A657D295D3B7265747572';
wwv_flow_imp.g_varchar2_table(51398) := '6E7B69643A2267656E6572616C222C6C6162656C3A6E282247656E6572616C22292C656E74726965733A692C636F6D706F6E656E743A5A7A7D7D66756E6374696F6E20435528652C74297B636F6E7374206E3D7B6C6162656C3A742E6765742822747261';
wwv_flow_imp.g_varchar2_table(51399) := '6E736C61746522292822436F6D70656E736174696F6E22292C69643A22636F6D70656E736174696F6E222C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E7224287B656C656D656E743A657D295D7D3B72657475726E206E2E656E747269';
wwv_flow_imp.g_varchar2_table(51400) := '65732E6C656E6774683F6E3A6E756C6C7D66756E6374696F6E20535528652C74297B636F6E7374206E3D742E67657428227472616E736C61746522292C693D5B2E2E2E7024287B656C656D656E743A657D295D3B72657475726E7B69643A22646F63756D';
wwv_flow_imp.g_varchar2_table(51401) := '656E746174696F6E222C6C6162656C3A6E2822446F63756D656E746174696F6E22292C656E74726965733A692C636F6D706F6E656E743A5A7A7D7D66756E6374696F6E20785528652C74297B636F6E7374206E3D7B69643A226572726F72222C6C616265';
wwv_flow_imp.g_varchar2_table(51402) := '6C3A742E67657428227472616E736C617465222928224572726F7222292C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E4524287B656C656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A6E';
wwv_flow_imp.g_varchar2_table(51403) := '756C6C7D66756E6374696F6E206B5528652C74297B636F6E7374206E3D7B69643A226D657373616765222C6C6162656C3A742E67657428227472616E736C617465222928224D65737361676522292C636F6D706F6E656E743A5A7A2C656E74726965733A';
wwv_flow_imp.g_varchar2_table(51404) := '5B2E2E2E5524287B656C656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A6E756C6C7D66756E6374696F6E20455528652C74297B636F6E7374206E3D7B69643A227369676E616C222C6C6162656C3A742E67';
wwv_flow_imp.g_varchar2_table(51405) := '657428227472616E736C617465222928225369676E616C22292C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E6355287B656C656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A6E756C6C7D';
wwv_flow_imp.g_varchar2_table(51406) := '66756E6374696F6E204C5528652C74297B636F6E7374206E3D7B6C6162656C3A742E67657428227472616E736C617465222928224C696E6B22292C69643A226C696E6B222C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E5724287B656C';
wwv_flow_imp.g_varchar2_table(51407) := '656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A6E756C6C7D66756E6374696F6E20445528652C74297B636F6E7374206E3D7B69643A22657363616C6174696F6E222C6C6162656C3A742E67657428227472';
wwv_flow_imp.g_varchar2_table(51408) := '616E736C61746522292822457363616C6174696F6E22292C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E4D24287B656C656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A6E756C6C7D6675';
wwv_flow_imp.g_varchar2_table(51409) := '6E6374696F6E20545528652C74297B636F6E7374206E3D7B6C6162656C3A742E67657428227472616E736C6174652229282254696D657222292C69643A2274696D6572222C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E6655287B656C';
wwv_flow_imp.g_varchar2_table(51410) := '656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A6E756C6C7D66756E6374696F6E20495528652C74297B636F6E7374206E3D7B6C6162656C3A742E67657428227472616E736C617465222928224D756C7469';
wwv_flow_imp.g_varchar2_table(51411) := '2D696E7374616E636522292C69643A226D756C7469496E7374616E6365222C636F6D706F6E656E743A5A7A2C656E74726965733A5B2E2E2E5124287B656C656D656E743A657D295D7D3B72657475726E206E2E656E74726965732E6C656E6774683F6E3A';
wwv_flow_imp.g_varchar2_table(51412) := '6E756C6C7D636C617373204D557B636F6E7374727563746F7228652C74297B652E726567697374657250726F76696465722874686973292C746869732E5F696E6A6563746F723D747D67657447726F7570732865297B72657475726E20743D3E28743D74';
wwv_flow_imp.g_varchar2_table(51413) := '2E636F6E6361742866756E6374696F6E28652C74297B72657475726E5B775528652C74292C535528652C74292C435528652C74292C785528652C74292C4C5528652C74292C6B5528652C74292C495528652C74292C455528652C74292C445528652C7429';
wwv_flow_imp.g_varchar2_table(51414) := '2C545528652C74295D2E66696C7465722828653D3E6E756C6C213D3D6529297D28652C746869732E5F696E6A6563746F7229292C74297D7D4D552E24696E6A6563743D5B2270726F7065727469657350616E656C222C22696E6A6563746F72225D3B7661';
wwv_flow_imp.g_varchar2_table(51415) := '722041553D7B5F5F696E69745F5F3A5B2262706D6E50726F7065727469657350726F7669646572225D2C62706D6E50726F7065727469657350726F76696465723A5B2274797065222C4D555D7D3B636F6E7374204E553D7B6765745661726961626C6573';
wwv_flow_imp.g_varchar2_table(51416) := '466F72456C656D656E743A653D3E28302C6B572E4870292865297D2C50553D66756E6374696F6E2865297B72657475726E20743D3E7B636F6E7374206E3D5577282828293D3E7B636F6E737420653D4C572822636F6E66696722293B72657475726E2065';
wwv_flow_imp.g_varchar2_table(51417) := '2626652E70726F7065727469657350616E656C2626652E70726F7065727469657350616E656C2E6665656C546F6F6C746970436F6E7461696E65727D292C5B5D293B72657475726E28302C50432E6A73782928652C7B2E2E2E742C746F6F6C746970436F';
wwv_flow_imp.g_varchar2_table(51418) := '6E7461696E65723A6E7D297D7D282866756E6374696F6E2865297B636F6E73747B656C656D656E743A742C69643A6E2C6465736372697074696F6E3A6F2C6465626F756E63653A732C64697361626C65643A722C6665656C3A612C6C6162656C3A6C2C67';
wwv_flow_imp.g_varchar2_table(51419) := '657456616C75653A632C73657456616C75653A642C746F6F6C746970436F6E7461696E65723A682C686F73744C616E67756167653A752C73696E676C654C696E653A702C76616C69646174653A672C73686F773A6D3D45482C6578616D706C653A662C76';
wwv_flow_imp.g_varchar2_table(51420) := '61726961626C65733A762C6F6E466F6375733A622C6F6E426C75723A5F2C706C616365686F6C6465723A792C746F6F6C7469703A777D3D652C5B432C535D3D5777286E756C6C292C5B782C6B5D3D5777286E756C6C293B6C657420453D632874293B6A77';
wwv_flow_imp.g_varchar2_table(51421) := '282828293D3E7B69662828302C692E546E29286729297B636F6E737420653D672845297C7C6E756C6C3B532865297D7D292C5B452C675D293B636F6E7374204C3D597A2828653D3E7B6C657420743D6E756C6C3B28302C692E546E29286729262628743D';
wwv_flow_imp.g_varchar2_table(51422) := '672865297C7C6E756C6C292C65213D3D4526266428652C74292C532874297D29292C443D4B772828653D3E7B6B2865297D292C5B5D292C543D6A7A286E297C7C787C7C433B72657475726E28302C50432E6A737873292822646976222C7B636C6173733A';
wwv_flow_imp.g_varchar2_table(51423) := '5243282928652E636C6173732C2262696F2D70726F706572746965732D70616E656C2D656E747279222C543F226861732D6572726F72223A2222292C22646174612D656E7472792D6964223A6E2C6368696C6472656E3A5B28302C41772E6E29284C482C';
wwv_flow_imp.g_varchar2_table(51424) := '7B2E2E2E652C6465626F756E63653A732C64697361626C65643A722C6665656C3A612C69643A6E2C6B65793A742C6C6162656C3A6C2C6F6E496E7075743A4C2C6F6E4572726F723A442C6F6E466F6375733A622C6F6E426C75723A5F2C706C616365686F';
wwv_flow_imp.g_varchar2_table(51425) := '6C6465723A792C6578616D706C653A662C686F73744C616E67756167653A752C73696E676C654C696E653A702C73686F773A6D2C76616C75653A452C7661726961626C65733A762C746F6F6C746970436F6E7461696E65723A682C4F7074696F6E616C43';
wwv_flow_imp.g_varchar2_table(51426) := '6F6D706F6E656E743A652E4F7074696F6E616C436F6D706F6E656E742C746F6F6C7469703A777D292C54262628302C50432E6A7378292822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D6572726F72222C636869';
wwv_flow_imp.g_varchar2_table(51427) := '6C6472656E3A547D292C28302C50432E6A7378292865482C7B666F7249643A6E2C656C656D656E743A742C76616C75653A6F7D295D7D297D29293B766172204F553D6F2839353230293B636F6E73742052553D4F626A6563742E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(51428) := '746F537472696E673B66756E6374696F6E2046552865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B7468';
wwv_flow_imp.g_varchar2_table(51429) := '69732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D46552E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C46552E70726F746F747970';
wwv_flow_imp.g_varchar2_table(51430) := '652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D223D3D52552E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F7665286529';
wwv_flow_imp.g_varchar2_table(51431) := '2C74686973297D2C46552E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465';
wwv_flow_imp.g_varchar2_table(51432) := '737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C46552E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869';
wwv_flow_imp.g_varchar2_table(51433) := '732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C46552E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475';
wwv_flow_imp.g_varchar2_table(51434) := '726E2041727261792E66726F6D28746869732E6C697374297D2C46552E70726F746F747970652E6861733D46552E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E746169';
wwv_flow_imp.g_varchar2_table(51435) := '6E732865297D3B7661722042552C56552C7A552C48553D7B7D3B66756E6374696F6E20575528297B42553D77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C';
wwv_flow_imp.g_varchar2_table(51436) := '56553D77696E646F772E72656D6F76654576656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A226465746163684576656E74222C7A553D226164644576656E744C697374656E657222213D3D42553F226F6E223A2222';
wwv_flow_imp.g_varchar2_table(51437) := '7D66756E6374696F6E206A5528652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F722865297D48552E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2042557C7C575528292C65';
wwv_flow_imp.g_varchar2_table(51438) := '5B42555D287A552B742C6E2C697C7C2131292C6E7D2C48552E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2056557C7C575528292C655B56555D287A552B742C6E2C697C7C2131292C6E7D3B7661722071553D6F283334';
wwv_flow_imp.g_varchar2_table(51439) := '3231293B66756E6374696F6E20245528652C74297B72657475726E2071552E6A73782822646976222C7B69643A606D6F64616C2D6469616C6F672D247B747D602C636C6173733A226D6F64616C222C6368696C6472656E3A71552E6A7378282264697622';
wwv_flow_imp.g_varchar2_table(51440) := '2C7B69643A226D6F64616C2D636F6E74656E74222C636C6173733A226D6F64616C2D636F6E74656E74222C6368696C6472656E3A5B71552E6A73782822646976222C7B636C6173733A22627574746F6E2D636F6E7461696E6572207374617274222C6368';
wwv_flow_imp.g_varchar2_table(51441) := '696C6472656E3A5B71552E6A73782822627574746F6E222C7B69643A22756E646F2D62746E222C636C6173733A226469616C6F6720756E646F2066612066612D756E646F227D292C71552E6A73782822627574746F6E222C7B69643A227265646F2D6274';
wwv_flow_imp.g_varchar2_table(51442) := '6E222C636C6173733A226469616C6F67207265646F2066612066612D726570656174227D292C71552E6A73782822627574746F6E222C7B69643A227365617263682D62746E222C636C6173733A226469616C6F67207365617263682066612066612D7365';
wwv_flow_imp.g_varchar2_table(51443) := '61726368227D292C71552E6A73782822627574746F6E222C7B69643A2270617273652D62746E222C636C6173733A226469616C6F672070617273652066612066612D636865636B2D636972636C652D6F227D292C71552E6A737828227370616E222C7B69';
wwv_flow_imp.g_varchar2_table(51444) := '643A226572726F722D74657874227D295D7D292C71552E6A73782822646976222C7B69643A22656469746F722D636F6E7461696E6572227D292C71552E6A73782822646976222C7B636C6173733A22627574746F6E2D636F6E7461696E657220656E6422';
wwv_flow_imp.g_varchar2_table(51445) := '2C6368696C6472656E3A5B71552E6A73782822627574746F6E222C7B69643A22636C6F73652D62746E222C636C6173733A226469616C6F6720636C6F7365222C6368696C6472656E3A65282243616E63656C22297D292C71552E6A73782822627574746F';
wwv_flow_imp.g_varchar2_table(51446) := '6E222C7B69643A22736176652D62746E222C636C6173733A226469616C6F672073617665222C6368696C6472656E3A6528225361766522297D295D7D295D7D297D297D66756E6374696F6E20555528652C742C6E2C692C6F297B636F6E737420733D6A55';
wwv_flow_imp.g_varchar2_table(51447) := '2860236D6F64616C2D6469616C6F672D247B6F7D60292C723D732E706172656E744E6F64652C613D6A5528222E6469616C6F672D636F6E7461696E657222292C6C3D6A55282223756E646F2D62746E222C73292C633D6A552822237265646F2D62746E22';
wwv_flow_imp.g_varchar2_table(51448) := '2C73292C643D6A552822237365617263682D62746E222C73292C683D6A5528222370617273652D62746E222C73292C753D6A55282223636C6F73652D62746E222C73292C703D6A55282223736176652D62746E222C73293B76617220673D21313B636F6E';
wwv_flow_imp.g_varchar2_table(51449) := '7374206D3D646F63756D656E742E676574456C656D656E74734279436C6173734E616D652822666C6F777334617065782D6D6F64656C657220464C4F57532D4441524B22292E6C656E6774683E303F2276732D6461726B223A227673222C663D4F552E65';
wwv_flow_imp.g_varchar2_table(51450) := '6469746F722E637265617465286A55282223656469746F722D636F6E7461696E6572222C73292C7B76616C75653A5B6528295D2E6A6F696E28225C6E22292C6C616E67756167653A2822706C73716C223D3D3D6E3F2273716C223A6E297C7C22706C6169';
wwv_flow_imp.g_varchar2_table(51451) := '6E74657874222C6D696E696D61703A7B656E61626C65643A2266616C7365227D2C6175746F6D617469634C61796F75743A21302C7468656D653A6D7D293B732E7374796C652E646973706C61793D22666C6578222C612E617070656E644368696C642873';
wwv_flow_imp.g_varchar2_table(51452) := '292C6C2E6F6E636C69636B3D66756E6374696F6E28297B662E6765744D6F64656C28292E756E646F28297D2C632E6F6E636C69636B3D66756E6374696F6E28297B662E6765744D6F64656C28292E7265646F28297D2C642E6F6E636C69636B3D66756E63';
wwv_flow_imp.g_varchar2_table(51453) := '74696F6E28297B28673D2167293F662E676574416374696F6E2822616374696F6E732E66696E6422292E72756E28293A662E7472696767657228226B6579626F617264222C22636C6F736546696E6457696467657422297D2C6A552822236572726F722D';
wwv_flow_imp.g_varchar2_table(51454) := '74657874222C73292E696E6E6572546578743D22222C22706C73716C223D3D3D6E7C7C2273716C223D3D3D6E7C7C226A736F6E223D3D3D6E3F682E6F6E636C69636B3D66756E6374696F6E28297B7661727B616A61784964656E7469666965723A657D3D';
wwv_flow_imp.g_varchar2_table(51455) := '617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B617065782E7365727665722E706C7567696E28652C7B7830313A2250415253455F434F4445222C7830323A662E67657456616C756528292C7830';
wwv_flow_imp.g_varchar2_table(51456) := '333A6E2C7830343A697D2C7B7D292E7468656E2828653D3E7B737769746368286A552822236572726F722D74657874222C73292E696E6E6572546578743D652E6D6573736167652E7265706C616365282F5C6E2F672C222022292C652E73756363657373';
wwv_flow_imp.g_varchar2_table(51457) := '297B636173652274727565223A6A552822236572726F722D74657874222C73292E7374796C652E636F6C6F723D2223353242343135223B627265616B3B636173652266616C7365223A6A552822236572726F722D74657874222C73292E7374796C652E63';
wwv_flow_imp.g_varchar2_table(51458) := '6F6C6F723D2223636333333333223B627265616B3B64656661756C743A6A552822236572726F722D74657874222C73292E7374796C652E636F6C6F723D22696E6865726974227D7D29297D3A682E7374796C652E646973706C61793D226E6F6E65222C75';
wwv_flow_imp.g_varchar2_table(51459) := '2E6F6E636C69636B3D66756E6374696F6E28297B732E7374796C652E646973706C61793D226E6F6E65222C722E617070656E644368696C642873292C662E646973706F736528297D2C702E6F6E636C69636B3D66756E6374696F6E28297B732E7374796C';
wwv_flow_imp.g_varchar2_table(51460) := '652E646973706C61793D226E6F6E65222C722E617070656E644368696C642873292C7428662E67657456616C75652829292C662E646973706F736528297D7D766172204B553D6F2833343231293B66756E6374696F6E20475528652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(51461) := '6E204B552E6A73782822646976222C7B636C6173733A226F70656E2D6469616C6F672D6C6162656C222C6368696C6472656E3A5B4B552E6A737828227370616E222C7B6368696C6472656E3A657D292C4B552E6A737828227370616E222C7B636C617373';
wwv_flow_imp.g_varchar2_table(51462) := '3A2266612066612D626F782D6172726F772D696E2D6E65222C6F6E436C69636B3A747D295D7D297D66756E6374696F6E2051552865297B636F6E73747B69643A742C656C656D656E743A6E2C6C697374456C656D656E743A692C6C6162656C3A6F2C6465';
wwv_flow_imp.g_varchar2_table(51463) := '736372697074696F6E3A732C68656C7065723A722C70726F70657274793A617D3D652C6C3D4C5728226D6F64656C696E6722292C633D4C5728226465626F756E6365496E70757422292C643D4C57282262706D6E466163746F727922292C683D697C7C4C';
wwv_flow_imp.g_varchar2_table(51464) := '77286E293B72657475726E205348287B69643A742C656C656D656E743A6E2C6C6162656C3A6F2C6465736372697074696F6E3A732C67657456616C75653A28293D3E723F722E676574457874656E73696F6E50726F7065727479286E2C61293A685B615D';
wwv_flow_imp.g_varchar2_table(51465) := '2C73657456616C75653A653D3E7B723F722E736574457874656E73696F6E50726F7065727479286E2C6C2C642C7B5B615D3A537472696E672865297D293A6C2E7570646174654D6F64646C6550726F70657274696573286E2C682C7B5B615D3A53747269';
wwv_flow_imp.g_varchar2_table(51466) := '6E672865297D297D2C6465626F756E63653A637D297D66756E6374696F6E2059552865297B636F6E73747B69643A742C656C656D656E743A6E2C6C697374456C656D656E743A692C6C6162656C3A6F2C6465736372697074696F6E3A732C68656C706572';
wwv_flow_imp.g_varchar2_table(51467) := '3A722C70726F70657274793A612C706172656E743A6C7D3D652C633D4C5728226D6F64656C696E6722292C643D4C5728226465626F756E6365496E70757422292C683D4C57282262706D6E466163746F727922292C753D697C7C4C77286E293B72657475';
wwv_flow_imp.g_varchar2_table(51468) := '726E206E6577206957287B69643A742C656C656D656E743A6E2C6C6162656C3A6F2C6465736372697074696F6E3A732C67657456616C75653A28293D3E723F722E676574457874656E73696F6E50726F7065727479286E2C612C6C293A755B615D2C7365';
wwv_flow_imp.g_varchar2_table(51469) := '7456616C75653A653D3E7B723F722E736574457874656E73696F6E50726F7065727479286E2C632C682C7B5B615D3A657D2C6C293A632E7570646174654D6F64646C6550726F70657274696573286E2C752C7B5B615D3A657D297D2C6465626F756E6365';
wwv_flow_imp.g_varchar2_table(51470) := '3A647D297D66756E6374696F6E205A552865297B636F6E73747B69643A742C656C656D656E743A6E2C6C697374456C656D656E743A692C6C6162656C3A6F2C6465736372697074696F6E3A732C68656C7065723A722C70726F70657274793A612C646566';
wwv_flow_imp.g_varchar2_table(51471) := '61756C7456616C75653A6C2C6F7074696F6E733A632C636C65616E75703A642C706172656E743A687D3D652C753D4C5728226D6F64656C696E6722292C703D4C5728226465626F756E6365496E70757422292C673D4C57282262706D6E466163746F7279';
wwv_flow_imp.g_varchar2_table(51472) := '22292C6D3D697C7C4C77286E293B72657475726E206E6577204748287B69643A742C656C656D656E743A6E2C6C6162656C3A6F2C6465736372697074696F6E3A732C67657456616C75653A28293D3E7B76617220653B72657475726E206C26262828653D';
wwv_flow_imp.g_varchar2_table(51473) := '723F722E676574457874656E73696F6E50726F7065727479286E2C612C68293A6D5B615D292626632E736F6D652828743D3E742E76616C75653D3D3D6529297C7C28723F722E736574457874656E73696F6E50726F7065727479286E2C752C672C7B5B61';
wwv_flow_imp.g_varchar2_table(51474) := '5D3A6C7D2C68293A752E7570646174654D6F64646C6550726F70657274696573286E2C6D2C7B5B615D3A6C7D2929292C723F722E676574457874656E73696F6E50726F7065727479286E2C612C68293A6D5B615D7D2C73657456616C75653A653D3E7B72';
wwv_flow_imp.g_varchar2_table(51475) := '3F722E736574457874656E73696F6E50726F7065727479286E2C752C672C7B5B615D3A652C2E2E2E642626642865297D2C68293A752E7570646174654D6F64646C6550726F70657274696573286E2C6D2C7B5B615D3A652C2E2E2E642626642865297D29';
wwv_flow_imp.g_varchar2_table(51476) := '7D2C6765744F7074696F6E733A28293D3E632C6465626F756E63653A707D297D66756E6374696F6E2058552865297B636F6E73747B69643A742C656C656D656E743A6E2C6C697374456C656D656E743A692C6C6162656C3A6F2C6465736372697074696F';
wwv_flow_imp.g_varchar2_table(51477) := '6E3A732C68656C7065723A722C70726F70657274793A612C73746174653A6C2C6E65656473526566726573683A637D3D652C643D4C5728226D6F64656C696E6722292C683D4C5728226465626F756E6365496E70757422292C753D4C57282262706D6E46';
wwv_flow_imp.g_varchar2_table(51478) := '6163746F727922292C703D697C7C4C77286E293B72657475726E206E6577204748287B69643A742C656C656D656E743A6E2C6C6162656C3A6F2C6465736372697074696F6E3A732C67657456616C75653A28293D3E723F722E676574457874656E73696F';
wwv_flow_imp.g_varchar2_table(51479) := '6E50726F7065727479286E2C61293A705B615D2C73657456616C75653A653D3E7B723F722E736574457874656E73696F6E50726F7065727479286E2C642C752C7B5B615D3A657D293A642E7570646174654D6F64646C6550726F70657274696573286E2C';
wwv_flow_imp.g_varchar2_table(51480) := '702C7B5B615D3A657D297D2C6465626F756E63653A682C6765744F7074696F6E733A28293D3E7B636F6E737420653D723F722E676574457874656E73696F6E50726F7065727479286E2C61293A705B615D2C743D6E756C6C3D3D657C7C6C26266C2E7661';
wwv_flow_imp.g_varchar2_table(51481) := '6C75657326266C2E76616C7565732E6D61702828653D3E652E76616C756529292E696E636C756465732865292C693D5B5D3B72657475726E206C262621632626286C2E6C6F61646564262665262621742626692E70757368287B6C6162656C3A60247B65';
wwv_flow_imp.g_varchar2_table(51482) := '7D2A602C76616C75653A657D292C6C2E76616C7565732626692E70757368282E2E2E6C2E76616C7565732E6D61702828653D3E287B6C6162656C3A652E6C6162656C2C76616C75653A652E76616C75657D29292929292C697D7D297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(51483) := '204A552865297B636F6E73747B69643A742C656C656D656E743A6E2C6C697374456C656D656E743A692C6C6162656C3A6F2C6465736372697074696F6E3A732C68656C7065723A722C70726F70657274793A612C64656661756C7456616C75653A6C2C69';
wwv_flow_imp.g_varchar2_table(51484) := '6E766572743A632C636C65616E75703A642C636C65616E757048656C7065723A687D3D652C753D4C5728226D6F64656C696E6722292C703D4C5728226465626F756E6365496E70757422292C673D4C57282262706D6E466163746F727922292C6D3D697C';
wwv_flow_imp.g_varchar2_table(51485) := '7C4C77286E293B72657475726E206E6577205F48287B69643A742C656C656D656E743A6E2C6C6162656C3A6F2C6465736372697074696F6E3A732C67657456616C75653A28293D3E286C26262828723F722E676574457874656E73696F6E50726F706572';
wwv_flow_imp.g_varchar2_table(51486) := '7479286E2C61293A6D5B615D297C7C28723F722E736574457874656E73696F6E50726F7065727479286E2C752C672C7B5B615D3A6C7D293A752E7570646174654D6F64646C6550726F70657274696573286E2C6D2C7B5B615D3A6C7D2929292C723F722E';
wwv_flow_imp.g_varchar2_table(51487) := '676574457874656E73696F6E50726F7065727479286E2C61293D3D3D28633F2266616C7365223A227472756522293A6D5B615D3D3D3D28633F2266616C7365223A22747275652229292C73657456616C75653A653D3E7B723F722E736574457874656E73';
wwv_flow_imp.g_varchar2_table(51488) := '696F6E50726F7065727479286E2C752C672C7B5B615D3A653F633F2266616C7365223A2274727565223A633F2274727565223A2266616C7365227D293A752E7570646174654D6F64646C6550726F70657274696573286E2C6D2C7B5B615D3A653F633F22';
wwv_flow_imp.g_varchar2_table(51489) := '66616C7365223A2274727565223A633F2274727565223A2266616C7365227D292C723F722E736574457874656E73696F6E50726F7065727479286E2C752C672C7B2E2E2E642626642865297D293A683F682E736574457874656E73696F6E50726F706572';
wwv_flow_imp.g_varchar2_table(51490) := '7479286E2C752C672C7B2E2E2E642626642865297D293A752E7570646174654D6F64646C6550726F70657274696573286E2C6D2C7B2E2E2E642626642865297D297D2C6465626F756E63653A707D297D66756E6374696F6E20654B2865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(51491) := '7B69643A742C656C656D656E743A6E2C6C697374456C656D656E743A692C6C6162656C3A6F2C6465736372697074696F6E3A732C68656C7065723A722C70726F70657274793A612C706172656E743A6C7D3D652C633D4C5728226D6F64656C696E672229';
wwv_flow_imp.g_varchar2_table(51492) := '2C643D4C5728226465626F756E6365496E70757422292C683D4C57282262706D6E466163746F727922292C753D697C7C4C77286E293B72657475726E206E6577204A48287B69643A742C656C656D656E743A6E2C6C6162656C3A6F2C6465736372697074';
wwv_flow_imp.g_varchar2_table(51493) := '696F6E3A732C67657456616C75653A28293D3E723F722E676574457874656E73696F6E50726F7065727479286E2C612C6C293A755B615D2C73657456616C75653A653D3E7B723F722E736574457874656E73696F6E50726F7065727479286E2C632C682C';
wwv_flow_imp.g_varchar2_table(51494) := '7B5B615D3A657D2C6C293A632E7570646174654D6F64646C6550726F70657274696573286E2C752C7B5B615D3A657D297D2C6465626F756E63653A647D297D66756E6374696F6E20744B2865297B636F6E73747B69643A742C656C656D656E743A6E2C6C';
wwv_flow_imp.g_varchar2_table(51495) := '697374456C656D656E743A692C6C6162656C3A6F2C6465736372697074696F6E3A732C68656C7065723A722C70726F70657274793A612C6C616E67756167653A6C2C747970653A632C706172656E743A647D3D652C683D4C5728226D6F64656C696E6722';
wwv_flow_imp.g_varchar2_table(51496) := '292C753D4C5728227472616E736C61746522292C703D4C5728226465626F756E6365496E70757422292C673D4C57282262706D6E466163746F727922292C6D3D697C7C4C77286E292C663D4755286F2C2828293D3E7B5555282828293D3E723F722E6765';
wwv_flow_imp.g_varchar2_table(51497) := '74457874656E73696F6E50726F7065727479286E2C612C64293A6D5B615D292C2866756E6374696F6E2865297B723F722E736574457874656E73696F6E50726F7065727479286E2C682C672C7B5B615D3A657D2C64293A682E7570646174654D6F64646C';
wwv_flow_imp.g_varchar2_table(51498) := '6550726F70657274696573286E2C6D2C7B5B615D3A657D297D292C6C2C632C74297D29293B72657475726E5B245528752C74292C6E6577204A48287B69643A742C656C656D656E743A6E2C6C6162656C3A662C6465736372697074696F6E3A732C676574';
wwv_flow_imp.g_varchar2_table(51499) := '56616C75653A28293D3E723F722E676574457874656E73696F6E50726F7065727479286E2C612C64293A6D5B615D2C73657456616C75653A653D3E7B723F722E736574457874656E73696F6E50726F7065727479286E2C682C672C7B5B615D3A657D2C64';
wwv_flow_imp.g_varchar2_table(51500) := '293A682E7570646174654D6F64646C6550726F70657274696573286E2C6D2C7B5B615D3A657D297D2C6465626F756E63653A707D295D7D766172206E4B3D6F2833343231293B636F6E737420694B3D6E65772064572822617065783A4578656375746550';
wwv_flow_imp.g_varchar2_table(51501) := '6C73716C22293B66756E6374696F6E206F4B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E67657428227472616E736C61746522292C733D5B5D3B72657475726E2828302C792E6973';
wwv_flow_imp.g_varchar2_table(51502) := '2928742C2262706D6E3A5363726970745461736B22297C7C28302C792E69732928742C2262706D6E3A536572766963655461736B22292626215B2273656E644D61696C225D2E696E636C7564657328692E74797065297C7C28302C792E69732928742C22';
wwv_flow_imp.g_varchar2_table(51503) := '62706D6E3A427573696E65737352756C655461736B22297C7C28302C792E69732928742C2262706D6E3A53656E645461736B222926262265786563757465506C73716C223D3D3D692E747970657C7C28302C792E69732928742C2262706D6E3A52656365';
wwv_flow_imp.g_varchar2_table(51504) := '6976655461736B222926262265786563757465506C73716C223D3D3D692E7479706529262628732E70757368287B69643A22706C73716C436F6465222C656C656D656E743A742C6C6162656C3A6F2822504C2F53514C20436F646522292C646573637269';
wwv_flow_imp.g_varchar2_table(51505) := '7074696F6E3A6F2822456E7465722074686520504C2F53514C20636F646520746F2062652065786563757465642E22292C68656C7065723A694B2C70726F70657274793A22706C73716C436F6465222C6C616E67756167653A22706C73716C222C747970';
wwv_flow_imp.g_varchar2_table(51506) := '653A22706C73716C50726F63657373222C636F6D706F6E656E743A744B2C69734564697465643A65577D2C7B69643A22656E67696E65222C656C656D656E743A742C6C6162656C3A6F2822416C6C6F772042696E64696E6722292C68656C7065723A694B';
wwv_flow_imp.g_varchar2_table(51507) := '2C70726F70657274793A22656E67696E65222C636F6D706F6E656E743A4A552C69734564697465643A79487D292C2274727565223D3D3D694B2E676574457874656E73696F6E50726F706572747928742C22656E67696E6522292626732E70757368287B';
wwv_flow_imp.g_varchar2_table(51508) := '69643A226175746F42696E6473222C656C656D656E743A742C6C6162656C3A6F282242696E6420706172616D657465722076616C75657322292C6465736372697074696F6E3A6E4B2E6A7378282261222C7B6368696C6472656E3A6F2822446F63756D65';
wwv_flow_imp.g_varchar2_table(51509) := '6E746174696F6E22292C687265663A2268747470733A2F2F666C6F7773666F72617065782E6F72672F6C61746573742F7461736B732F23332D62706D6E7363726970747461736B2D2D2D72756E732D612D706C73716C2D736372697074222C7461726765';
wwv_flow_imp.g_varchar2_table(51510) := '743A225F626C616E6B227D292C68656C7065723A694B2C70726F70657274793A226175746F42696E6473222C64656661756C7456616C75653A2266616C7365222C6F7074696F6E733A5B7B6C6162656C3A6F282242696E642070726F6365737320766172';
wwv_flow_imp.g_varchar2_table(51511) := '6961626C657322292C76616C75653A2266616C7365227D2C7B6C6162656C3A6F282242696E642070616765206974656D732028646570726563617465642922292C76616C75653A2274727565227D5D2C636F6D706F6E656E743A5A552C69734564697465';
wwv_flow_imp.g_varchar2_table(51512) := '643A79487D29292C737D636C61737320734B7B636F6E7374727563746F7228652C742C6E2C692C6F2C73297B746869732E747970653D652C746869732E6C697374547970653D742C746869732E6C697374417474723D6E2C746869732E656E7472795479';
wwv_flow_imp.g_varchar2_table(51513) := '70653D692C746869732E656E747279417474723D6F2C746869732E656E7472794E616D653D737D6765744E6578744E616D652865297B72657475726E28746869732E656E7472794E616D657C7C746869732E747970652E73706C697428223A22295B315D';
wwv_flow_imp.g_varchar2_table(51514) := '292B28746869732E676574537562457874656E73696F6E456C656D656E74732865293F605F247B746869732E676574537562457874656E73696F6E456C656D656E74732865292E6C656E6774687D603A225F3022297D6765744E65787453657175656E63';
wwv_flow_imp.g_varchar2_table(51515) := '652865297B72657475726E20537472696E6728746869732E676574537562457874656E73696F6E456C656D656E74732865293F746869732E676574537562457874656E73696F6E456C656D656E74732865292E6C656E6774683A30297D67657453756245';
wwv_flow_imp.g_varchar2_table(51516) := '7874656E73696F6E456C656D656E74732865297B636F6E73747B747970653A742C6C697374417474723A6E2C656E747279417474723A697D3D746869732C6F3D437728652C74293B72657475726E206E756C6C3D3D3D693F6F26266F5B6E5D3A6F26266F';
wwv_flow_imp.g_varchar2_table(51517) := '5B6E5D26266F5B6E5D2E6765742869297D72656D6F7665537562466163746F72792865297B636F6E73747B747970653A742C6C697374417474723A6E2C656E747279417474723A6F7D3D746869732C7B656C656D656E743A732C6C697374456C656D656E';
wwv_flow_imp.g_varchar2_table(51518) := '743A722C6D6F64656C696E673A617D3D652C6C3D4C772873292C7B657874656E73696F6E456C656D656E74733A637D3D6C3B72657475726E206E756C6C3D3D3D6F3F66756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28293B636F';
wwv_flow_imp.g_varchar2_table(51519) := '6E7374206F3D437728732C74293B696628216F2972657475726E3B636F6E737420643D6F5B6E5D3B69662821642972657475726E3B636F6E737420683D28302C692E46462928642C72293B6C657420753D6F2C703D7B5B6E5D3A687D3B303D3D3D682E6C';
wwv_flow_imp.g_varchar2_table(51520) := '656E677468262628753D632C703D7B76616C7565733A632E676574282276616C75657322292E66696C7465722828653D3E65213D3D6F29297D2C632E676574282276616C75657322292E736F6D652828653D3E65213D3D6F29297C7C28753D6C2C703D7B';
wwv_flow_imp.g_varchar2_table(51521) := '657874656E73696F6E456C656D656E74733A766F696420307D29292C612E7570646174654D6F64646C6550726F7065727469657328732C752C70297D3A66756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28293B636F6E73742064';
wwv_flow_imp.g_varchar2_table(51522) := '3D437728732C74293B69662821642972657475726E3B636F6E737420683D645B6E5D2626645B6E5D2E676574286F293B69662821682972657475726E3B636F6E737420753D28302C692E46462928682C72293B6C657420703D645B6E5D2C673D7B5B6F5D';
wwv_flow_imp.g_varchar2_table(51523) := '3A757D3B303D3D3D752E6C656E677468262628703D642C673D7B5B6E5D3A766F696420307D2C4F626A6563742E6B6579732864292E736F6D652828653D3E22247479706522213D3D65262665213D3D6E29297C7C28703D632C673D7B76616C7565733A63';
wwv_flow_imp.g_varchar2_table(51524) := '2E676574282276616C75657322292E66696C7465722828653D3E65213D3D6429297D2C632E676574282276616C75657322292E736F6D652828653D3E65213D3D6429297C7C28703D6C2C673D7B657874656E73696F6E456C656D656E74733A766F696420';
wwv_flow_imp.g_varchar2_table(51525) := '307D2929292C612E7570646174654D6F64646C6550726F7065727469657328732C702C67297D7D616464537562466163746F72792865297B636F6E73747B747970653A742C6C697374547970653A6E2C6C697374417474723A692C656E74727954797065';
wwv_flow_imp.g_varchar2_table(51526) := '3A6F2C656E747279417474723A737D3D746869732C7B656C656D656E743A722C6E657750726F70733A612C6D6F64656C696E673A6C2C62706D6E466163746F72793A637D3D653B72657475726E206E756C6C3D3D3D6E26266E756C6C3D3D3D733F66756E';
wwv_flow_imp.g_varchar2_table(51527) := '6374696F6E2865297B652E73746F7050726F7061676174696F6E28293B636F6E7374206E3D4C772872293B6C657420733D6E2E6765742822657874656E73696F6E456C656D656E747322293B737C7C28733D787728722C63292C6C2E7570646174654D6F';
wwv_flow_imp.g_varchar2_table(51528) := '64646C6550726F7065727469657328722C6E2C7B657874656E73696F6E456C656D656E74733A737D29293B6C657420643D437728722C74293B647C7C28643D6B7728742C7B7D2C732C63292C6C2E7570646174654D6F64646C6550726F70657274696573';
wwv_flow_imp.g_varchar2_table(51529) := '28722C732C7B76616C7565733A5B2E2E2E732E676574282276616C75657322292C645D7D29293B636F6E737420683D5377286F2C612C642C63293B6C2E7570646174654D6F64646C6550726F7065727469657328722C642C7B5B695D3A5B2E2E2E642E67';
wwv_flow_imp.g_varchar2_table(51530) := '65742869292C685D7D297D3A66756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28293B636F6E737420643D4C772872293B6C657420683D642E6765742822657874656E73696F6E456C656D656E747322293B687C7C28683D787728';
wwv_flow_imp.g_varchar2_table(51531) := '722C63292C6C2E7570646174654D6F64646C6550726F7065727469657328722C642C7B657874656E73696F6E456C656D656E74733A687D29293B6C657420753D437728722C74293B757C7C28753D6B7728742C7B7D2C682C63292C6C2E7570646174654D';
wwv_flow_imp.g_varchar2_table(51532) := '6F64646C6550726F7065727469657328722C682C7B76616C7565733A5B2E2E2E682E676574282276616C75657322292C755D7D29293B6C657420703D755B695D3B707C7C28703D6B77286E2C7B7D2C752C63292C6C2E7570646174654D6F64646C655072';
wwv_flow_imp.g_varchar2_table(51533) := '6F7065727469657328722C752C7B5B695D3A707D29293B636F6E737420673D5377286F2C612C702C63293B6C2E7570646174654D6F64646C6550726F7065727469657328722C702C7B5B735D3A5B2E2E2E702E6765742873292C675D7D297D7D61646453';
wwv_flow_imp.g_varchar2_table(51534) := '7562456C656D656E742865297B636F6E73747B747970653A742C6C697374547970653A6E2C6C697374417474723A692C656E747279547970653A6F2C656E747279417474723A737D3D746869732C7B656C656D656E743A722C6E657750726F70733A612C';
wwv_flow_imp.g_varchar2_table(51535) := '6D6F64656C696E673A6C2C62706D6E466163746F72793A637D3D652C643D4C772872293B6C657420683D642E6765742822657874656E73696F6E456C656D656E747322293B6966286E756C6C3D3D3D6E26266E756C6C3D3D3D73297B687C7C28683D7877';
wwv_flow_imp.g_varchar2_table(51536) := '28722C63292C6C2E7570646174654D6F64646C6550726F7065727469657328722C642C7B657874656E73696F6E456C656D656E74733A687D29293B6C657420653D437728722C74293B657C7C28653D6B7728742C7B7D2C682C63292C6C2E757064617465';
wwv_flow_imp.g_varchar2_table(51537) := '4D6F64646C6550726F7065727469657328722C682C7B76616C7565733A5B2E2E2E682E676574282276616C75657322292C655D7D29293B636F6E7374206E3D5377286F2C612C652C63293B6C2E7570646174654D6F64646C6550726F7065727469657328';
wwv_flow_imp.g_varchar2_table(51538) := '722C652C7B5B695D3A5B2E2E2E652E6765742869292C6E5D7D297D656C73657B687C7C28683D787728722C63292C6C2E7570646174654D6F64646C6550726F7065727469657328722C642C7B657874656E73696F6E456C656D656E74733A687D29293B6C';
wwv_flow_imp.g_varchar2_table(51539) := '657420653D437728722C74293B657C7C28653D6B7728742C7B7D2C682C63292C6C2E7570646174654D6F64646C6550726F7065727469657328722C682C7B76616C7565733A5B2E2E2E682E676574282276616C75657322292C655D7D29293B6C65742075';
wwv_flow_imp.g_varchar2_table(51540) := '3D655B695D3B757C7C28753D6B77286E2C7B7D2C652C63292C6C2E7570646174654D6F64646C6550726F7065727469657328722C652C7B5B695D3A757D29293B636F6E737420703D5377286F2C612C752C63293B6C2E7570646174654D6F64646C655072';
wwv_flow_imp.g_varchar2_table(51541) := '6F7065727469657328722C752C7B5B735D3A5B2E2E2E752E6765742873292C705D7D297D7D7D76617220724B3D6F2833343231292C614B3D6F2839313932293B66756E6374696F6E206C4B2865297B636F6E73747B69645072656669783A742C70726F63';
wwv_flow_imp.g_varchar2_table(51542) := '5661723A6E2C656C656D656E743A692C696E6A6563746F723A6F7D3D652C733D6F2E67657428227472616E736C61746522292C723D5B5D2C7B76617245787072657373696F6E547970653A612C76617244617461547970653A6C7D3D6E2C633D5B7B6C61';
wwv_flow_imp.g_varchar2_table(51543) := '62656C3A732822566172636861723222292C76616C75653A225641524348415232227D2C7B6C6162656C3A7328224E756D62657222292C76616C75653A224E554D424552227D2C7B6C6162656C3A7328224461746522292C76616C75653A224441544522';
wwv_flow_imp.g_varchar2_table(51544) := '7D2C7B6C6162656C3A73282254696D657374616D7020776974682054696D65205A6F6E6522292C76616C75653A2254494D455354414D505F574954485F54494D455F5A4F4E45227D2C7B6C6162656C3A732822436C6F6222292C76616C75653A22434C4F';
wwv_flow_imp.g_varchar2_table(51545) := '42227D2C7B6C6162656C3A7328224A534F4E204F626A65637422292C76616C75653A224A534F4E227D5D2C643D7B444154453A7328224461746520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535322297D2C683D5B2E2E2E';
wwv_flow_imp.g_varchar2_table(51546) := '22434C4F4222213D3D6C3F5B7B6C6162656C3A73282253746174696322292C76616C75653A22737461746963227D5D3A5B5D2C7B6C6162656C3A73282250726F63657373205661726961626C6522292C76616C75653A2270726F63657373566172696162';
wwv_flow_imp.g_varchar2_table(51547) := '6C65227D2C2E2E2E22434C4F4222213D3D6C3F5B7B6C6162656C3A73282253514C207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D5D3A5B5D2C2E2E2E225641524348415232223D3D';
wwv_flow_imp.g_varchar2_table(51548) := '3D6C3F5B7B6C6162656C3A73282253514C2071756572792028636F6C6F6E2064656C696D69746564206C6973742922292C76616C75653A2273716C51756572794C697374227D5D3A5B5D2C2E2E2E224A534F4E223D3D3D6C3F5B7B6C6162656C3A732822';
wwv_flow_imp.g_varchar2_table(51549) := '53514C20717565727920284A534F4E2061727261792922292C76616C75653A2273716C51756572794172726179227D5D3A5B5D2C2E2E2E22434C4F4222213D3D6C3F5B7B6C6162656C3A73282245787072657373696F6E22292C76616C75653A22706C73';
wwv_flow_imp.g_varchar2_table(51550) := '716C52617745787072657373696F6E227D5D3A5B5D2C2E2E2E22434C4F4222213D3D6C3F5B7B6C6162656C3A73282245787072657373696F6E20284C65676163792922292C76616C75653A22706C73716C45787072657373696F6E227D5D3A5B5D2C2E2E';
wwv_flow_imp.g_varchar2_table(51551) := '2E22434C4F4222213D3D6C3F5B7B6C6162656C3A73282246756E6374696F6E20426F647922292C76616C75653A22706C73716C52617746756E6374696F6E426F6479227D5D3A5B5D2C2E2E2E22434C4F4222213D3D6C3F5B7B6C6162656C3A7328224675';
wwv_flow_imp.g_varchar2_table(51552) := '6E6374696F6E20426F647920284C65676163792922292C76616C75653A22706C73716C46756E6374696F6E426F6479227D5D3A5B5D5D2C753D7B7374617469633A7B56415243484152323A7328225374617469632076617263686172322076616C756522';
wwv_flow_imp.g_varchar2_table(51553) := '292C4E554D4245523A732822537461746963206E756D6265722076616C756522292C444154453A73282253746174696320646174652076616C756522292C54494D455354414D505F574954485F54494D455F5A4F4E453A7328225374617469632054696D';
wwv_flow_imp.g_varchar2_table(51554) := '657374616D7020776974682054696D65205A6F6E652076616C756522297D2C70726F636573735661726961626C653A7B56415243484152323A7328224E616D65206F66207468652050726F63657373205661726961626C6522292C4E554D4245523A7328';
wwv_flow_imp.g_varchar2_table(51555) := '224E616D65206F66207468652050726F63657373205661726961626C6522292C444154453A7328224E616D65206F66207468652050726F63657373205661726961626C6522292C54494D455354414D505F574954485F54494D455F5A4F4E453A7328224E';
wwv_flow_imp.g_varchar2_table(51556) := '616D65206F66207468652050726F63657373205661726961626C6522292C434C4F423A7328224E616D65206F66207468652050726F63657373205661726961626C6522297D2C73716C517565727953696E676C653A7B56415243484152323A7328225351';
wwv_flow_imp.g_varchar2_table(51557) := '4C2071756572792072657475726E696E6720612073696E676C652076617263686172322076616C756522292C4E554D4245523A73282253514C2071756572792072657475726E696E6720612073696E676C65206E756D6265722076616C756522292C4441';
wwv_flow_imp.g_varchar2_table(51558) := '54453A73282253514C2071756572792072657475726E696E6720612073696E676C6520646174652076616C756522292C54494D455354414D505F574954485F54494D455F5A4F4E453A73282253514C2071756572792072657475726E696E672061207369';
wwv_flow_imp.g_varchar2_table(51559) := '6E676C652054696D657374616D7020776974682054696D65205A6F6E652076616C756522297D2C73716C51756572794C6973743A7B56415243484152323A73282253514C2071756572792072657475726E696E67206120636F6C6F6E2064656C696D6974';
wwv_flow_imp.g_varchar2_table(51560) := '6564206C69737422297D2C706C73716C52617745787072657373696F6E3A7B56415243484152323A732822504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756522292C4E554D4245523A732822';
wwv_flow_imp.g_varchar2_table(51561) := '504C2F53514C2045787072657373696F6E2072657475726E696E672061206E756D6265722076616C756522292C444154453A732822504C2F53514C2045787072657373696F6E2072657475726E696E67206120646174652076616C756522292C54494D45';
wwv_flow_imp.g_varchar2_table(51562) := '5354414D505F574954485F54494D455F5A4F4E453A732822504C2F53514C2045787072657373696F6E2072657475726E696E6720612054696D657374616D7020776974682054696D65205A6F6E652076616C756522297D2C706C73716C45787072657373';
wwv_flow_imp.g_varchar2_table(51563) := '696F6E3A7B56415243484152323A732822504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756522292C4E554D4245523A732822504C2F53514C2045787072657373696F6E2072657475726E696E';
wwv_flow_imp.g_varchar2_table(51564) := '6720612076617263686172322076616C756520696E206E756D62657220666F726D617422292C444154453A732822504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E20666F726D6174';
wwv_flow_imp.g_varchar2_table(51565) := '20595959592D4D4D2D444420484832343A4D493A535322292C54494D455354414D505F574954485F54494D455F5A4F4E453A732822504C2F53514C2045787072657373696F6E2072657475726E696E6720612076617263686172322076616C756520696E';
wwv_flow_imp.g_varchar2_table(51566) := '20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A5222297D2C706C73716C52617746756E6374696F6E426F64793A7B56415243484152323A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E';
wwv_flow_imp.g_varchar2_table(51567) := '6720612076617263686172322076616C756522292C4E554D4245523A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061206E756D6265722076616C756522292C444154453A732822504C2F53514C2046756E637469';
wwv_flow_imp.g_varchar2_table(51568) := '6F6E20426F64792072657475726E696E67206120646174652076616C756522292C54494D455354414D505F574954485F54494D455F5A4F4E453A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612054696D657374';
wwv_flow_imp.g_varchar2_table(51569) := '616D7020776974682054696D65205A6F6E652076616C756522297D2C706C73716C46756E6374696F6E426F64793A7B56415243484152323A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672061207661726368617232';
wwv_flow_imp.g_varchar2_table(51570) := '2076616C756522292C4E554D4245523A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E206E756D62657220666F726D617422292C444154453A732822504C2F53514C';
wwv_flow_imp.g_varchar2_table(51571) := '2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535322292C54494D455354414D505F574954485F54494D455F5A4F4E45';
wwv_flow_imp.g_varchar2_table(51572) := '3A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E6720612076617263686172322076616C756520696E20666F726D617420595959592D4D4D2D444420484832343A4D493A535320545A5222297D2C73716C517565727941';
wwv_flow_imp.g_varchar2_table(51573) := '727261793A7B4A534F4E3A73282253514C2071756572792072657475726E696E672061204A534F4E20617272617922297D7D3B696628614B2E6973416E7928692C5B2262706D6E3A50726F63657373222C2262706D6E3A5061727469636970616E74225D';
wwv_flow_imp.g_varchar2_table(51574) := '297C7C722E70757368287B69643A60247B747D2D76617253657175656E6365602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A73282253657175656E636522292C70726F70657274793A2276617253657175656E6365222C';
wwv_flow_imp.g_varchar2_table(51575) := '636F6D706F6E656E743A51552C69734564697465643A78487D292C722E70757368287B69643A60247B747D2D7661724E616D65602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A7328224E616D6522292C70726F70657274';
wwv_flow_imp.g_varchar2_table(51576) := '793A227661724E616D65222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A60247B747D2D7661724461746154797065602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A732822446174612054';
wwv_flow_imp.g_varchar2_table(51577) := '79706522292C6465736372697074696F6E3A645B6C5D2C70726F70657274793A227661724461746154797065222C6F7074696F6E733A632C636C65616E75703A653D3E287B2E2E2E22434C4F42223D3D3D6526262270726F636573735661726961626C65';
wwv_flow_imp.g_varchar2_table(51578) := '22213D3D6126267B76617245787072657373696F6E547970653A2270726F636573735661726961626C65222C76617245787072657373696F6E3A6E756C6C7D2C2E2E2E22564152434841523222213D3D6526262273716C51756572794C697374223D3D3D';
wwv_flow_imp.g_varchar2_table(51579) := '6126267B76617245787072657373696F6E547970653A22737461746963222C76617245787072657373696F6E3A6E756C6C7D2C2E2E2E224A534F4E22213D3D6526262273716C51756572794172726179223D3D3D6126267B76617245787072657373696F';
wwv_flow_imp.g_varchar2_table(51580) := '6E547970653A22737461746963222C76617245787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C614B2E697328692C2262706D6E3A43616C6C416374697669747922292626722E70757368';
wwv_flow_imp.g_varchar2_table(51581) := '287B69643A60247B747D2D7661724465736372697074696F6E602C656C656D656E743A692C70726F635661723A6E2C636F6D706F6E656E743A634B7D292C614B2E6973416E7928692C5B2262706D6E3A50726F63657373222C2262706D6E3A5061727469';
wwv_flow_imp.g_varchar2_table(51582) := '636970616E74225D2929722E70757368287B69643A60247B747D2D7661724465736372697074696F6E496E707574602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A7328224465736372697074696F6E22292C70726F7065';
wwv_flow_imp.g_varchar2_table(51583) := '7274793A227661724465736372697074696F6E222C636F6D706F6E656E743A59552C69734564697465643A6F577D293B656C736520696628722E70757368287B69643A60247B747D2D76617245787072657373696F6E54797065602C656C656D656E743A';
wwv_flow_imp.g_varchar2_table(51584) := '692C6C697374456C656D656E743A6E2C6C6162656C3A73282245787072657373696F6E205479706522292C70726F70657274793A2276617245787072657373696F6E54797065222C6F7074696F6E733A682C636F6D706F6E656E743A5A552C6973456469';
wwv_flow_imp.g_varchar2_table(51585) := '7465643A51487D292C6E756C6C213D61296966285B2273716C517565727953696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C45787072657373696F6E222C22706C73716C5261';
wwv_flow_imp.g_varchar2_table(51586) := '7746756E6374696F6E426F6479222C22706C73716C46756E6374696F6E426F6479222C2273716C51756572794172726179225D2E696E636C75646573286129297B636F6E737420653D5B2273716C517565727953696E676C65222C2273716C5175657279';
wwv_flow_imp.g_varchar2_table(51587) := '4C697374222C2273716C51756572794172726179225D2E696E636C756465732861293F2273716C223A22706C73716C223B722E70757368287B69643A60247B747D2D76617245787072657373696F6E602C656C656D656E743A692C6C697374456C656D65';
wwv_flow_imp.g_varchar2_table(51588) := '6E743A6E2C6C6162656C3A73282245787072657373696F6E22292C6465736372697074696F6E3A755B615D5B6C5D2C70726F70657274793A2276617245787072657373696F6E222C6C616E67756167653A652C747970653A612C636F6D706F6E656E743A';
wwv_flow_imp.g_varchar2_table(51589) := '744B2C69734564697465643A65577D297D656C736520722E70757368287B69643A60247B747D2D76617245787072657373696F6E602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A73282245787072657373696F6E22292C';
wwv_flow_imp.g_varchar2_table(51590) := '6465736372697074696F6E3A755B615D5B6C5D2C70726F70657274793A2276617245787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D293B72657475726E20727D66756E6374696F6E20634B2865297B636F6E73';
wwv_flow_imp.g_varchar2_table(51591) := '747B70726F635661723A747D3D653B72657475726E206E3D7B746578743A742E7661724465736372697074696F6E7D2C724B2E6A7378282270222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D68656C7074657874222C6368';
wwv_flow_imp.g_varchar2_table(51592) := '696C6472656E3A6E2E746578747D293B766172206E7D76617220644B3D6F2839313932293B66756E6374696F6E20684B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E2C68656C7065723A697D3D652C6F3D6E2E6765742822';
wwv_flow_imp.g_varchar2_table(51593) := '62706D6E466163746F727922292C733D6E2E67657428226D6F64656C696E6722292C723D692E676574537562457874656E73696F6E456C656D656E74732874297C7C5B5D2C613D644B2E6973416E7928742C5B2262706D6E3A50726F63657373222C2262';
wwv_flow_imp.g_varchar2_table(51594) := '706D6E3A5061727469636970616E74225D292C6C3D722E736F7274282828652C74293D3E4E756D62657228652E76617253657175656E6365292D4E756D62657228742E76617253657175656E63652929292E6D6170282828652C6F293D3E7B636F6E7374';
wwv_flow_imp.g_varchar2_table(51595) := '20723D6070726F635661722D247B6F7D603B72657475726E7B69643A722C6C6162656C3A613F652E67657428227661724E616D6522293A60247B652E676574282276617253657175656E636522297D202D20247B652E67657428227661724E616D652229';
wwv_flow_imp.g_varchar2_table(51596) := '7D607C7C22222C656E74726965733A6C4B287B69645072656669783A722C656C656D656E743A742C696E6A6563746F723A6E2C70726F635661723A657D292C6175746F466F637573456E7472793A60247B727D2D6E616D65602C72656D6F76653A692E72';
wwv_flow_imp.g_varchar2_table(51597) := '656D6F7665537562466163746F7279287B656C656D656E743A742C6D6F64656C696E673A732C6C697374456C656D656E743A657D297D7D29293B72657475726E7B6974656D733A6C2C6164643A692E616464537562466163746F7279287B656C656D656E';
wwv_flow_imp.g_varchar2_table(51598) := '743A742C62706D6E466163746F72793A6F2C6D6F64656C696E673A732C6E657750726F70733A7B2E2E2E216126267B76617253657175656E63653A692E6765744E65787453657175656E63652874297D2C7661724E616D653A692E6765744E6578744E61';
wwv_flow_imp.g_varchar2_table(51599) := '6D652874292C76617244617461547970653A225641524348415232222C2E2E2E216126267B76617245787072657373696F6E547970653A22737461746963227D7D7D297D7D66756E6374696F6E20754B28297B69662822756E646566696E656422213D74';
wwv_flow_imp.g_varchar2_table(51600) := '7970656F662061706578297B617065782E64656275672E696E666F28226765744170706C69636174696F6E7322293B7661727B616A61784964656E7469666965723A657D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C6572';
wwv_flow_imp.g_varchar2_table(51601) := '28226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28652C7B7830313A224745545F4150504C49434154494F4E53227D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728';
wwv_flow_imp.g_varchar2_table(51602) := '226765744170706C69636174696F6E7322292C50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A2231202D204131222C76616C75653A2231227D2C7B6C6162656C3A2232202D20413222';
wwv_flow_imp.g_varchar2_table(51603) := '2C76616C75653A2232227D5D297D66756E6374696F6E20704B2865297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F2822676574506167657322293B7661727B616A61784964656E7469';
wwv_flow_imp.g_varchar2_table(51604) := '666965723A747D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28742C7B7830313A224745545F5041474553222C7830323A65';
wwv_flow_imp.g_varchar2_table(51605) := '7D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F672822676574506167657322292C2231223D3D3D653F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C61';
wwv_flow_imp.g_varchar2_table(51606) := '62656C3A2231202D2041315031222C76616C75653A2231227D2C7B6C6162656C3A2232202D2041315032222C76616C75653A2232227D5D293A2232223D3D3D653F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E75';
wwv_flow_imp.g_varchar2_table(51607) := '6C6C7D2C7B6C6162656C3A2231202D2041325031222C76616C75653A2231227D2C7B6C6162656C3A2232202D2041325032222C76616C75653A2232227D2C7B6C6162656C3A2233202D2041325033222C76616C75653A2233227D5D293A50726F6D697365';
wwv_flow_imp.g_varchar2_table(51608) := '2E7265736F6C7665285B5D297D66756E6374696F6E20674B28652C74297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F28226765744974656D7322293B7661727B616A61784964656E74';
wwv_flow_imp.g_varchar2_table(51609) := '69666965723A6E7D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E286E2C7B7830313A224745545F4954454D53222C7830323A';
wwv_flow_imp.g_varchar2_table(51610) := '652C7830333A747D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728226765744974656D7322292C2231223D3D3D6526262231223D3D3D743F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A2222';
wwv_flow_imp.g_varchar2_table(51611) := '2C76616C75653A6E756C6C7D2C7B6C6162656C3A22413150314931222C76616C75653A22413150314931227D2C7B6C6162656C3A22413150314932222C76616C75653A22413150314932227D5D293A50726F6D6973652E7265736F6C7665285B5D297D76';
wwv_flow_imp.g_varchar2_table(51612) := '6172206D4B3D6F2833343231293B66756E6374696F6E20664B2865297B72657475726E206D4B2E6A73782822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D717569636B7069636B222C6368696C6472656E3A5B6D';
wwv_flow_imp.g_varchar2_table(51613) := '4B2E6A7378282261222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D717569636B7069636B2D6C696E6B222C6368696C6472656E3A652E746578742C6F6E436C69636B3A652E68616E646C65727D295D7D297D76617220764B';
wwv_flow_imp.g_varchar2_table(51614) := '3D6F2839313932293B66756E6374696F6E20624B2865297B76617220743D6E756C6C2C6E3D6E756C6C3B636F6E73747B656C656D656E743A692C696E6A6563746F723A6F2C7472616E736C6174653A737D3D652C723D4C772869292C613D5B5D3B696628';
wwv_flow_imp.g_varchar2_table(51615) := '21722E6C6F6F70436861726163746572697374696373297B764B2E6973416E7928692C5B2262706D6E3A5461736B222C2262706D6E3A557365725461736B222C2262706D6E3A5363726970745461736B222C2262706D6E3A536572766963655461736B22';
wwv_flow_imp.g_varchar2_table(51616) := '2C2262706D6E3A4D616E75616C5461736B225D293F28743D7B747970653A22617065783A4265666F72655461736B222C69643A226265666F72655461736B222C6C6162656C3A224265666F7265205461736B227D2C6E3D7B747970653A22617065783A41';
wwv_flow_imp.g_varchar2_table(51617) := '667465725461736B222C69643A2261667465725461736B222C6C6162656C3A224166746572205461736B227D293A764B2E697328692C2262706D6E3A43616C6C416374697669747922297C7C764B2E6973416E7928692C5B2262706D6E3A50726F636573';
wwv_flow_imp.g_varchar2_table(51618) := '73222C2262706D6E3A5061727469636970616E74225D2926262274727565223D3D3D722E697343616C6C61626C653F28743D7B747970653A22617065783A496E5661726961626C6573222C69643A22696E5661726961626C6573222C6C6162656C3A2249';
wwv_flow_imp.g_varchar2_table(51619) := '6E205661726961626C6573222C6E616D653A22496E227D2C6E3D7B747970653A22617065783A4F75745661726961626C6573222C69643A226F75745661726961626C6573222C6C6162656C3A224F7574205661726961626C6573222C6E616D653A224F75';
wwv_flow_imp.g_varchar2_table(51620) := '74227D293A764B2E6973416E7928692C5B2262706D6E3A4578636C757369766547617465776179222C2262706D6E3A506172616C6C656C47617465776179222C2262706D6E3A496E636C757369766547617465776179222C2262706D6E3A4576656E7442';
wwv_flow_imp.g_varchar2_table(51621) := '6173656447617465776179225D293F313D3D3D692E696E636F6D696E672E6C656E6774682626692E6F7574676F696E672E6C656E6774683E313F743D7B747970653A22617065783A4265666F726553706C6974222C69643A226265666F726553706C6974';
wwv_flow_imp.g_varchar2_table(51622) := '222C6C6162656C3A224265666F72652053706C6974227D3A692E696E636F6D696E672E6C656E6774683E312626313D3D3D692E6F7574676F696E672E6C656E6774683F743D7B747970653A22617065783A41667465724D65726765222C69643A22616674';
wwv_flow_imp.g_varchar2_table(51623) := '65724D65726765222C6C6162656C3A224166746572204D65726765227D3A692E696E636F6D696E672E6C656E6774683E312626692E6F7574676F696E672E6C656E6774683E31262628743D7B747970653A22617065783A4265666F726553706C6974222C';
wwv_flow_imp.g_varchar2_table(51624) := '69643A226265666F726553706C6974222C6C6162656C3A224265666F72652053706C6974227D2C6E3D7B747970653A22617065783A41667465724D65726765222C69643A2261667465724D65726765222C6C6162656C3A224166746572204D6572676522';
wwv_flow_imp.g_varchar2_table(51625) := '7D293A764B2E6973416E7928692C5B2262706D6E3A53746172744576656E74222C2262706D6E3A496E7465726D6564696174655468726F774576656E74222C2262706D6E3A496E7465726D65646961746543617463684576656E74222C2262706D6E3A42';
wwv_flow_imp.g_varchar2_table(51626) := '6F756E646172794576656E74222C2262706D6E3A456E644576656E74225D292626284C772869292E6576656E74446566696E6974696F6E7326264C772869292E6576656E74446566696E6974696F6E732E736F6D652828653D3E2262706D6E3A54696D65';
wwv_flow_imp.g_varchar2_table(51627) := '724576656E74446566696E6974696F6E223D3D3D652E24747970652929262628743D7B747970653A22617065783A4265666F72654576656E74222C69643A226265666F72654576656E74222C6C6162656C3A224265666F7265204576656E74227D292C6E';
wwv_flow_imp.g_varchar2_table(51628) := '3D7B747970653A22617065783A4F6E4576656E74222C69643A226F6E4576656E74222C6C6162656C3A224F6E204576656E74227D293B636F6E737420653D743F6E657720734B28742E747970652C6E756C6C2C2270726F6356617273222C22617065783A';
wwv_flow_imp.g_varchar2_table(51629) := '50726F636573735661726961626C65222C6E756C6C2C742E6E616D65293A6E756C6C2C6C3D6E3F6E657720734B286E2E747970652C6E756C6C2C2270726F6356617273222C22617065783A50726F636573735661726961626C65222C6E756C6C2C6E2E6E';
wwv_flow_imp.g_varchar2_table(51630) := '616D65293A6E756C6C3B764B2E697328692C2262706D6E3A43616C6C41637469766974792229262628612E70757368287B656C656D656E743A692C636F6D706F6E656E743A5F4B2C68656C706572313A652C68656C706572323A6C7D292C612E70757368';
wwv_flow_imp.g_varchar2_table(51631) := '287B656C656D656E743A692C636F6D706F6E656E743A794B2C68656C7065723A657D29292C742626612E70757368287B69643A742E69642C656C656D656E743A692C6C6162656C3A7328742E6C6162656C292C636F6D706F6E656E743A57482C2E2E2E68';
wwv_flow_imp.g_varchar2_table(51632) := '4B287B656C656D656E743A692C696E6A6563746F723A6F2C68656C7065723A657D297D292C6E2626612E70757368287B69643A6E2E69642C656C656D656E743A692C6C6162656C3A73286E2E6C6162656C292C636F6D706F6E656E743A57482C2E2E2E68';
wwv_flow_imp.g_varchar2_table(51633) := '4B287B656C656D656E743A692C696E6A6563746F723A6F2C68656C7065723A6C7D297D297D72657475726E20617D66756E6374696F6E205F4B2865297B636F6E73747B656C656D656E743A742C68656C706572313A6E2C68656C706572323A697D3D652C';
wwv_flow_imp.g_varchar2_table(51634) := '6F3D4C5728227472616E736C61746522292C733D4C57282262706D6E466163746F727922292C723D4C5728226D6F64656C696E6722292C613D4C772874293B72657475726E20664B287B746578743A6F28224C6F616420646566696E6564207661726961';
wwv_flow_imp.g_varchar2_table(51635) := '626C657322292C68616E646C65723A28293D3E7B636F6E73747B63616C6C65644469616772616D3A652C63616C6C65644469616772616D56657273696F6E53656C656374696F6E3A6F2C63616C6C65644469616772616D56657273696F6E3A6C7D3D613B';
wwv_flow_imp.g_varchar2_table(51636) := '2866756E6374696F6E28652C742C6E297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F2822676574446566696E65645661726961626C657322293B7661727B616A61784964656E746966';
wwv_flow_imp.g_varchar2_table(51637) := '6965723A697D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28692C7B7830313A224745545F5641524941424C455F4D415050';
wwv_flow_imp.g_varchar2_table(51638) := '494E47222C7830323A652C7830333A742C7830343A6E7D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F672822676574446566696E65645661726961626C657322292C50726F6D6973652E7265736F6C7665287B';
wwv_flow_imp.g_varchar2_table(51639) := '496E5661726961626C65733A5B7B7661724E616D653A22496E31222C76617244617461547970653A225641524348415232222C7661724465736372697074696F6E3A224465736331227D2C7B7661724E616D653A22496E32222C76617244617461547970';
wwv_flow_imp.g_varchar2_table(51640) := '653A224E554D424552222C7661724465736372697074696F6E3A224465736332227D5D2C4F75745661726961626C65733A5B7B7661724E616D653A224F757431222C76617244617461547970653A2244415445222C7661724465736372697074696F6E3A';
wwv_flow_imp.g_varchar2_table(51641) := '224465736333227D2C7B7661724E616D653A224F757432222C76617244617461547970653A2254494D455354414D505F574954485F54494D455F5A4F4E45222C7661724465736372697074696F6E3A224465736334227D5D7D297D2928652C6F2C6C292E';
wwv_flow_imp.g_varchar2_table(51642) := '7468656E2828653D3E7B652E496E5661726961626C65732626652E496E5661726961626C65732E666F72456163682828653D3E7B6E2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A722C62706D6E466163746F72';
wwv_flow_imp.g_varchar2_table(51643) := '793A732C6E657750726F70733A7B76617253657175656E63653A6E2E6765744E65787453657175656E63652874292C7661724E616D653A652E7661724E616D652C76617244617461547970653A652E76617244617461547970652C766172457870726573';
wwv_flow_imp.g_varchar2_table(51644) := '73696F6E547970653A22737461746963222C76617245787072657373696F6E3A22222C7661724465736372697074696F6E3A652E7661724465736372697074696F6E7D7D297D29292C652E4F75745661726961626C65732626652E4F7574566172696162';
wwv_flow_imp.g_varchar2_table(51645) := '6C65732E666F72456163682828653D3E7B692E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A722C62706D6E466163746F72793A732C6E657750726F70733A7B76617253657175656E63653A692E6765744E657874';
wwv_flow_imp.g_varchar2_table(51646) := '53657175656E63652874292C7661724E616D653A652E7661724E616D652C76617244617461547970653A652E76617244617461547970652C76617245787072657373696F6E547970653A22737461746963222C76617245787072657373696F6E3A22222C';
wwv_flow_imp.g_varchar2_table(51647) := '7661724465736372697074696F6E3A652E7661724465736372697074696F6E7D7D297D29297D29297D7D297D66756E6374696F6E20794B2865297B636F6E73747B656C656D656E743A742C68656C7065723A6E7D3D652C693D4C5728227472616E736C61';
wwv_flow_imp.g_varchar2_table(51648) := '746522292C6F3D4C57282262706D6E466163746F727922292C733D4C5728226D6F64656C696E6722293B72657475726E20664B287B746578743A692822436F707920627573696E657373207265666572656E636522292C68616E646C65723A28293D3E7B';
wwv_flow_imp.g_varchar2_table(51649) := '6E2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A732C62706D6E466163746F72793A6F2C6E657750726F70733A7B76617253657175656E63653A6E2E6765744E65787453657175656E63652874292C7661724E61';
wwv_flow_imp.g_varchar2_table(51650) := '6D653A22425553494E4553535F524546222C76617244617461547970653A225641524348415232222C76617245787072657373696F6E547970653A2270726F636573735661726961626C65222C76617245787072657373696F6E3A22425553494E455353';
wwv_flow_imp.g_varchar2_table(51651) := '5F524546227D7D297D7D297D636F6E737420774B3D6E65772064572822617065783A417065785061676522293B66756E6374696F6E20434B2865297B636F6E73747B69645072656669783A742C706167654974656D3A6E2C656C656D656E743A692C696E';
wwv_flow_imp.g_varchar2_table(51652) := '6A6563746F723A6F7D3D652C733D4C772869292C723D6F2E67657428227472616E736C61746522292C613D5B5D3B72657475726E2274727565223D3D3D732E6D616E75616C496E7075743F612E70757368287B69643A60247B747D2D6974656D4E616D65';
wwv_flow_imp.g_varchar2_table(51653) := '54657874602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A7228224974656D204E616D6522292C70726F70657274793A226974656D4E616D65222C636F6D706F6E656E743A59552C69734564697465643A6F577D293A612E';
wwv_flow_imp.g_varchar2_table(51654) := '70757368287B69643A60247B747D2D6974656D4E616D65602C656C656D656E743A692C6C697374456C656D656E743A6E2C636F6D706F6E656E743A534B2C69734564697465643A51487D292C612E70757368287B69643A60247B747D2D6974656D56616C';
wwv_flow_imp.g_varchar2_table(51655) := '7565602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A7228224974656D2056616C756522292C70726F70657274793A226974656D56616C7565222C636F6D706F6E656E743A59552C69734564697465643A6F577D292C617D';
wwv_flow_imp.g_varchar2_table(51656) := '66756E6374696F6E20534B2865297B636F6E73747B656C656D656E743A742C69643A6E2C6C697374456C656D656E743A697D3D652C6F3D4C5728227472616E736C61746522292C5B732C725D3D5777287B7D292C613D774B2E676574457874656E73696F';
wwv_flow_imp.g_varchar2_table(51657) := '6E50726F706572747928742C226170706C69636174696F6E496422292C6C3D774B2E676574457874656E73696F6E50726F706572747928742C2270616765496422293B6A77282828293D3E7B674B28612C6C292E7468656E2828653D3E72287B76616C75';
wwv_flow_imp.g_varchar2_table(51658) := '65733A652C6C6F616465643A21302C6170706C69636174696F6E49643A612C7061676549643A6C7D2929297D292C5B612C6C5D293B636F6E737420633D61213D3D732E6170706C69636174696F6E49647C7C6C213D3D732E7061676549643B7265747572';
wwv_flow_imp.g_varchar2_table(51659) := '6E20546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C697374456C656D656E743D247B697D0A202020206C6162656C3D247B6F28224974656D22297D0A2020202070726F70657274793D6974';
wwv_flow_imp.g_varchar2_table(51660) := '656D4E616D650A2020202073746174653D247B737D0A202020206E65656473526566726573683D247B637D0A20202F3E607D66756E6374696F6E20784B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E2C68656C7065723A69';
wwv_flow_imp.g_varchar2_table(51661) := '7D3D652C6F3D6E2E676574282262706D6E466163746F727922292C733D6E2E67657428226D6F64656C696E6722292C723D28692E676574537562457874656E73696F6E456C656D656E74732874297C7C5B5D292E6D6170282828652C6F293D3E7B636F6E';
wwv_flow_imp.g_varchar2_table(51662) := '737420723D60706167654974656D2D247B6F7D603B72657475726E7B69643A722C6C6162656C3A652E67657428226974656D4E616D6522297C7C22222C656E74726965733A434B287B69645072656669783A722C656C656D656E743A742C696E6A656374';
wwv_flow_imp.g_varchar2_table(51663) := '6F723A6E2C706167654974656D3A657D292C6175746F466F637573456E7472793A60247B727D2D6E616D65602C72656D6F76653A692E72656D6F7665537562466163746F7279287B656C656D656E743A742C6D6F64656C696E673A732C6C697374456C65';
wwv_flow_imp.g_varchar2_table(51664) := '6D656E743A657D297D7D29293B72657475726E7B6974656D733A722C6164643A692E616464537562466163746F7279287B656C656D656E743A742C62706D6E466163746F72793A6F2C6D6F64656C696E673A732C6E657750726F70733A7B6974656D4E61';
wwv_flow_imp.g_varchar2_table(51665) := '6D653A6E756C6C2C6974656D56616C75653A6E756C6C7D7D297D7D636F6E7374206B4B3D6E65772064572822617065783A417065785061676522292C454B3D6E657720734B2822617065783A4170657850616765222C22617065783A506167654974656D';
wwv_flow_imp.g_varchar2_table(51666) := '73222C22706167654974656D73222C22617065783A506167654974656D222C22706167654974656D22293B66756E6374696F6E204C4B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E';
wwv_flow_imp.g_varchar2_table(51667) := '67657428227472616E736C61746522292C733D5B5D3B696628226170657850616765223D3D3D692E747970657C7C21692E74797065297B636F6E737420653D2274727565223D3D3D692E6D616E75616C496E7075743B732E70757368287B69643A22696E';
wwv_flow_imp.g_varchar2_table(51668) := '70757453656C656374696F6E222C656C656D656E743A742C6C6162656C3A6F28225573652041504558206D657461206461746122292C70726F70657274793A226D616E75616C496E707574222C64656661756C7456616C75653A2266616C7365222C696E';
wwv_flow_imp.g_varchar2_table(51669) := '766572743A21302C636F6D706F6E656E743A4A557D292C653F732E70757368287B69643A226170706C69636174696F6E496454657874222C656C656D656E743A742C6C6162656C3A6F28224170706C69636174696F6E20494422292C68656C7065723A6B';
wwv_flow_imp.g_varchar2_table(51670) := '4B2C70726F70657274793A226170706C69636174696F6E4964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A2270616765496454657874222C656C656D656E743A742C6C6162656C3A6F28225061676520494422292C68';
wwv_flow_imp.g_varchar2_table(51671) := '656C7065723A6B4B2C70726F70657274793A22706167654964222C636F6D706F6E656E743A59552C69734564697465643A6F577D293A732E70757368287B69643A226170706C69636174696F6E4964222C656C656D656E743A742C636F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(51672) := '3A444B2C69734564697465643A51487D2C7B69643A22706167654964222C656C656D656E743A742C636F6D706F6E656E743A544B2C69734564697465643A51487D292C732E70757368287B656C656D656E743A742C636F6D706F6E656E743A494B7D2C7B';
wwv_flow_imp.g_varchar2_table(51673) := '69643A22706167654974656D73222C656C656D656E743A742C6C6162656C3A6F282250616765204974656D7322292C636F6D706F6E656E743A57482C2E2E2E784B287B656C656D656E743A742C696E6A6563746F723A6E2C68656C7065723A454B7D297D';
wwv_flow_imp.g_varchar2_table(51674) := '292C732E70757368287B69643A2272657175657374222C656C656D656E743A742C6C6162656C3A6F28225265717565737422292C6465736372697074696F6E3A6F2822526571756573742056616C756520666F7220506167652043616C6C22292C68656C';
wwv_flow_imp.g_varchar2_table(51675) := '7065723A6B4B2C70726F70657274793A2272657175657374222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A226361636865222C656C656D656E743A742C6C6162656C3A6F2822436C65617220436163686522292C646573';
wwv_flow_imp.g_varchar2_table(51676) := '6372697074696F6E3A6F2822436C6561722043616368652056616C756520666F7220506167652043616C6C22292C68656C7065723A6B4B2C70726F70657274793A226361636865222C636F6D706F6E656E743A59552C69734564697465643A6F577D297D';
wwv_flow_imp.g_varchar2_table(51677) := '72657475726E20737D66756E6374696F6E20444B2865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D293B72657475726E206A77282828293D3E7B754B28292E';
wwv_flow_imp.g_varchar2_table(51678) := '7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928224170706C69';
wwv_flow_imp.g_varchar2_table(51679) := '636174696F6E22297D0A2020202068656C7065723D247B6B4B7D0A2020202070726F70657274793D6170706C69636174696F6E49640A2020202073746174653D247B6F7D0A20202F3E607D66756E6374696F6E20544B2865297B636F6E73747B656C656D';
wwv_flow_imp.g_varchar2_table(51680) := '656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D292C723D6B4B2E676574457874656E73696F6E50726F706572747928742C226170706C69636174696F6E496422293B6A77282828293D3E7B70';
wwv_flow_imp.g_varchar2_table(51681) := '4B2872292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21302C6170706C69636174696F6E49643A727D2929297D292C5B725D293B636F6E737420613D72213D3D6F2E6170706C69636174696F6E49643B72657475726E20546C';
wwv_flow_imp.g_varchar2_table(51682) := '603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928225061676522297D0A2020202068656C7065723D247B6B4B7D0A2020202070726F70657274793D7061676549640A202020';
wwv_flow_imp.g_varchar2_table(51683) := '2073746174653D247B6F7D0A202020206E65656473526566726573683D247B617D0A20202F3E607D66756E6374696F6E20494B2865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C5728227472616E736C61746522292C693D4C5728226270';
wwv_flow_imp.g_varchar2_table(51684) := '6D6E466163746F727922292C6F3D4C5728226D6F64656C696E6722293B72657475726E20664B287B746578743A6E282247656E65726174652064656661756C74206974656D7322292C68616E646C65723A28293D3E7B454B2E616464537562456C656D65';
wwv_flow_imp.g_varchar2_table(51685) := '6E74287B656C656D656E743A742C6D6F64656C696E673A6F2C62706D6E466163746F72793A692C6E657750726F70733A7B6974656D4E616D653A2250524F434553535F4944222C6974656D56616C75653A22264634412450524F434553535F49442E227D';
wwv_flow_imp.g_varchar2_table(51686) := '7D292C454B2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A6F2C62706D6E466163746F72793A692C6E657750726F70733A7B6974656D4E616D653A22535542464C4F575F4944222C6974656D56616C75653A2226';
wwv_flow_imp.g_varchar2_table(51687) := '46344124535542464C4F575F49442E227D7D292C454B2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A6F2C62706D6E466163746F72793A692C6E657750726F70733A7B6974656D4E616D653A22535445505F4B45';
wwv_flow_imp.g_varchar2_table(51688) := '59222C6974656D56616C75653A222646344124535445505F4B45592E227D7D297D7D297D66756E6374696F6E204D4B2865297B636F6E73747B69645072656669783A742C706172616D657465723A6E2C656C656D656E743A692C696E6A6563746F723A6F';
wwv_flow_imp.g_varchar2_table(51689) := '7D3D652C733D6F2E67657428227472616E736C61746522293B72657475726E5B7B69643A60247B747D2D7061725374617469634964602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A73282253746174696320494422292C';
wwv_flow_imp.g_varchar2_table(51690) := '70726F70657274793A227061725374617469634964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A60247B747D2D7061724461746154797065602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C616265';
wwv_flow_imp.g_varchar2_table(51691) := '6C3A73282244617461205479706522292C70726F70657274793A227061724461746154797065222C6F7074696F6E733A5B7B6C6162656C3A732822537472696E6722292C76616C75653A22537472696E67227D5D2C636F6D706F6E656E743A5A552C6973';
wwv_flow_imp.g_varchar2_table(51692) := '4564697465643A51487D2C7B69643A60247B747D2D70617256616C7565602C656C656D656E743A692C6C697374456C656D656E743A6E2C6C6162656C3A73282256616C756522292C70726F70657274793A2270617256616C7565222C636F6D706F6E656E';
wwv_flow_imp.g_varchar2_table(51693) := '743A59552C69734564697465643A6F577D5D7D66756E6374696F6E20414B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E2C68656C7065723A697D3D652C6F3D6E2E676574282262706D6E466163746F727922292C733D6E2E';
wwv_flow_imp.g_varchar2_table(51694) := '67657428226D6F64656C696E6722292C723D28692E676574537562457874656E73696F6E456C656D656E74732874297C7C5B5D292E6D6170282828652C6F293D3E7B636F6E737420723D60706172616D657465722D247B6F7D603B72657475726E7B6964';
wwv_flow_imp.g_varchar2_table(51695) := '3A722C6C6162656C3A652E6765742822706172537461746963496422297C7C22222C656E74726965733A4D4B287B69645072656669783A722C656C656D656E743A742C696E6A6563746F723A6E2C706172616D657465723A657D292C6175746F466F6375';
wwv_flow_imp.g_varchar2_table(51696) := '73456E7472793A60247B727D2D6E616D65602C72656D6F76653A692E72656D6F7665537562466163746F7279287B656C656D656E743A742C6D6F64656C696E673A732C6C697374456C656D656E743A657D297D7D29293B72657475726E7B6974656D733A';
wwv_flow_imp.g_varchar2_table(51697) := '722C6164643A692E616464537562466163746F7279287B656C656D656E743A742C62706D6E466163746F72793A6F2C6D6F64656C696E673A732C6E657750726F70733A7B70617253746174696349643A6E756C6C2C70617244617461547970653A225374';
wwv_flow_imp.g_varchar2_table(51698) := '72696E67222C70617256616C75653A6E756C6C7D7D297D7D636F6E7374204E4B3D6E65772064572822617065783A41706578417070726F76616C22292C504B3D6E657720734B2822617065783A41706578417070726F76616C222C22617065783A506172';
wwv_flow_imp.g_varchar2_table(51699) := '616D6574657273222C22706172616D6574657273222C22617065783A506172616D65746572222C22706172616D6574657222293B66756E6374696F6E204F4B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C';
wwv_flow_imp.g_varchar2_table(51700) := '772874292C6F3D6E2E67657428227472616E736C61746522292C733D6E2E676574282262706D6E466163746F727922292C723D6E2E67657428226D6F64656C696E6722292C613D5B5D3B6966282261706578417070726F76616C223D3D3D692E74797065';
wwv_flow_imp.g_varchar2_table(51701) := '297B636F6E737420653D2274727565223D3D3D692E6D616E75616C496E7075743B612E70757368287B69643A22696E70757453656C656374696F6E222C656C656D656E743A742C6C6162656C3A6F28225573652041504558206D65746120646174612229';
wwv_flow_imp.g_varchar2_table(51702) := '2C70726F70657274793A226D616E75616C496E707574222C64656661756C7456616C75653A2266616C7365222C696E766572743A21302C636F6D706F6E656E743A4A557D292C653F612E70757368287B69643A226170706C69636174696F6E4964546578';
wwv_flow_imp.g_varchar2_table(51703) := '74222C656C656D656E743A742C6C6162656C3A6F28224170706C69636174696F6E20494422292C68656C7065723A4E4B2C70726F70657274793A226170706C69636174696F6E4964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C';
wwv_flow_imp.g_varchar2_table(51704) := '7B69643A227461736B537461746963496454657874222C656C656D656E743A742C6C6162656C3A6F28225461736B2053746174696320494422292C68656C7065723A4E4B2C70726F70657274793A227461736B5374617469634964222C636F6D706F6E65';
wwv_flow_imp.g_varchar2_table(51705) := '6E743A59552C69734564697465643A6F577D293A612E70757368287B69643A226170706C69636174696F6E4964222C656C656D656E743A742C636F6D706F6E656E743A524B2C69734564697465643A51487D2C7B69643A227461736B5374617469634964';
wwv_flow_imp.g_varchar2_table(51706) := '222C656C656D656E743A742C636F6D706F6E656E743A464B2C69734564697465643A51487D293B636F6E7374206C3D664B287B746578743A6F2822627573696E6573735F72656622292C68616E646C65723A28293D3E7B4E4B2E736574457874656E7369';
wwv_flow_imp.g_varchar2_table(51707) := '6F6E50726F706572747928742C722C732C7B627573696E6573735265663A222646344124425553494E4553535F5245462E227D297D7D293B612E70757368287B69643A227375626A656374222C656C656D656E743A742C6C6162656C3A6F28225375626A';
wwv_flow_imp.g_varchar2_table(51708) := '65637422292C6465736372697074696F6E3A6F28224F76657277726974652064656661756C742076616C75652073657420696E207461736B20646566696E6974696F6E22292C68656C7065723A4E4B2C70726F70657274793A227375626A656374222C63';
wwv_flow_imp.g_varchar2_table(51709) := '6F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22627573696E657373526566222C656C656D656E743A742C6C6162656C3A6F2822427573696E657373205265666572656E636522292C6465736372697074696F6E3A6C2C68656C';
wwv_flow_imp.g_varchar2_table(51710) := '7065723A4E4B2C70726F70657274793A22627573696E657373526566222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B656C656D656E743A742C636F6D706F6E656E743A424B7D2C7B69643A22706172616D6574657273222C656C';
wwv_flow_imp.g_varchar2_table(51711) := '656D656E743A742C6C6162656C3A22506172616D6574657273222C636F6D706F6E656E743A57482C2E2E2E414B287B656C656D656E743A742C696E6A6563746F723A6E2C68656C7065723A504B7D297D2C7B69643A22726573756C745661726961626C65';
wwv_flow_imp.g_varchar2_table(51712) := '222C656C656D656E743A742C6C6162656C3A6F2822526573756C74205661726961626C6522292C6465736372697074696F6E3A6F28224E616D65206F6620746865207661726961626C6520746F2072657475726E2074686520617070726F76616C207265';
wwv_flow_imp.g_varchar2_table(51713) := '73756C7420696E746F22292C68656C7065723A4E4B2C70726F70657274793A22726573756C745661726961626C65222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22696E69746961746F72222C656C656D656E743A742C';
wwv_flow_imp.g_varchar2_table(51714) := '6C6162656C3A6F2822496E69746961746F7222292C6465736372697074696F6E3A6F2822496E69746961746F72206F66207468697320617070726F76616C207461736B22292C68656C7065723A4E4B2C70726F70657274793A22696E69746961746F7222';
wwv_flow_imp.g_varchar2_table(51715) := '2C636F6D706F6E656E743A59552C69734564697465643A6F577D297D72657475726E20617D66756E6374696F6E20524B2865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D';
wwv_flow_imp.g_varchar2_table(51716) := '5777287B7D293B72657475726E206A77282828293D3E7B754B28292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D65';
wwv_flow_imp.g_varchar2_table(51717) := '6E743D247B747D0A202020206C6162656C3D247B6928224170706C69636174696F6E22297D0A2020202068656C7065723D247B4E4B7D0A2020202070726F70657274793D6170706C69636174696F6E49640A2020202073746174653D247B6F7D0A20202F';
wwv_flow_imp.g_varchar2_table(51718) := '3E607D66756E6374696F6E20464B2865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D292C723D4E4B2E676574457874656E73696F6E50726F70657274792874';
wwv_flow_imp.g_varchar2_table(51719) := '2C226170706C69636174696F6E496422293B6A77282828293D3E7B2866756E6374696F6E2865297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F28226765745461736B7322293B766172';
wwv_flow_imp.g_varchar2_table(51720) := '7B616A61784964656E7469666965723A747D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28742C7B7830313A224745545F54';
wwv_flow_imp.g_varchar2_table(51721) := '41534B53222C7830323A657D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728226765745461736B7322292C2231223D3D3D653F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75';
wwv_flow_imp.g_varchar2_table(51722) := '653A6E756C6C7D2C7B6C6162656C3A2241315431222C76616C75653A2241315431227D2C7B6C6162656C3A2241315432222C76616C75653A2241315432227D5D293A2232223D3D3D653F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A2222';
wwv_flow_imp.g_varchar2_table(51723) := '2C76616C75653A6E756C6C7D2C7B6C6162656C3A2241325431222C76616C75653A2241325431227D2C7B6C6162656C3A2241325432222C76616C75653A2241325432227D2C7B6C6162656C3A2241325433222C76616C75653A2241325433227D5D293A50';
wwv_flow_imp.g_varchar2_table(51724) := '726F6D6973652E7265736F6C7665285B5D297D292872292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21302C6170706C69636174696F6E49643A727D2929297D292C5B725D293B636F6E737420613D72213D3D6F2E6170706C';
wwv_flow_imp.g_varchar2_table(51725) := '69636174696F6E49643B72657475726E20546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928225461736B20446566696E6974696F6E22297D0A2020202068656C706572';
wwv_flow_imp.g_varchar2_table(51726) := '3D247B4E4B7D0A2020202070726F70657274793D7461736B53746174696349640A2020202073746174653D247B6F7D0A202020206E65656473526566726573683D247B617D0A20202F3E607D66756E6374696F6E20424B2865297B636F6E73747B656C65';
wwv_flow_imp.g_varchar2_table(51727) := '6D656E743A747D3D652C6E3D4C5728227472616E736C61746522292C693D4C57282262706D6E466163746F727922292C6F3D4C5728226D6F64656C696E6722292C733D4E4B2E676574457874656E73696F6E50726F706572747928742C226170706C6963';
wwv_flow_imp.g_varchar2_table(51728) := '6174696F6E496422292C723D4E4B2E676574457874656E73696F6E50726F706572747928742C227461736B537461746963496422293B72657475726E20664B287B746578743A6E28224C6F616420506172616D657465727322292C68616E646C65723A28';
wwv_flow_imp.g_varchar2_table(51729) := '293D3E7B2866756E6374696F6E28652C74297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F28226765744A534F4E506172616D657465727322293B7661727B616A61784964656E746966';
wwv_flow_imp.g_varchar2_table(51730) := '6965723A6E7D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E286E2C7B7830313A224745545F4A534F4E5F504152414D455445';
wwv_flow_imp.g_varchar2_table(51731) := '5253222C7830323A652C7830333A747D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728226765744A534F4E506172616D657465727322292C2231223D3D3D6526262241315431223D3D3D743F50726F6D6973';
wwv_flow_imp.g_varchar2_table(51732) := '652E7265736F6C7665285B7B5354415449435F49443A2270617231222C444154415F545950453A22537472696E67222C56414C55453A2231227D2C7B5354415449435F49443A2270617232222C444154415F545950453A22537472696E67222C56414C55';
wwv_flow_imp.g_varchar2_table(51733) := '453A2232227D5D293A50726F6D6973652E7265736F6C7665285B5D297D2928732C72292E7468656E2828653D3E7B652E666F72456163682828653D3E7B504B2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A6F2C';
wwv_flow_imp.g_varchar2_table(51734) := '62706D6E466163746F72793A692C6E657750726F70733A7B70617253746174696349643A652E5354415449435F49442C70617244617461547970653A652E444154415F545950452C70617256616C75653A652E56414C55457D7D297D29297D29297D7D29';
wwv_flow_imp.g_varchar2_table(51735) := '7D636F6E737420564B3D6E65772064572822617065783A4170657853696D706C65466F726D22292C7A4B3D6E657720734B2822617065783A4170657853696D706C65466F726D222C22617065783A506167654974656D73222C22706167654974656D7322';
wwv_flow_imp.g_varchar2_table(51736) := '2C22617065783A506167654974656D222C22706167654974656D22293B66756E6374696F6E20484B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E67657428227472616E736C617465';
wwv_flow_imp.g_varchar2_table(51737) := '22292C733D5B5D3B696628226170657853696D706C65466F726D223D3D3D692E74797065297B636F6E737420653D2274727565223D3D3D692E6D616E75616C496E7075743B732E70757368287B69643A22696E70757453656C656374696F6E222C656C65';
wwv_flow_imp.g_varchar2_table(51738) := '6D656E743A742C6C6162656C3A6F28225573652041504558206D657461206461746122292C70726F70657274793A226D616E75616C496E707574222C64656661756C7456616C75653A2266616C7365222C696E766572743A21302C636F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(51739) := '3A4A557D292C653F732E70757368287B69643A226170706C69636174696F6E496454657874222C656C656D656E743A742C6C6162656C3A6F28224170706C69636174696F6E20494422292C68656C7065723A564B2C70726F70657274793A226170706C69';
wwv_flow_imp.g_varchar2_table(51740) := '636174696F6E4964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A2270616765496454657874222C656C656D656E743A742C6C6162656C3A6F28225061676520494422292C68656C7065723A564B2C70726F7065727479';
wwv_flow_imp.g_varchar2_table(51741) := '3A22706167654964222C636F6D706F6E656E743A59552C69734564697465643A6F577D293A732E70757368287B69643A226170706C69636174696F6E4964222C656C656D656E743A742C636F6D706F6E656E743A6A4B2C69734564697465643A51487D2C';
wwv_flow_imp.g_varchar2_table(51742) := '7B69643A22706167654964222C656C656D656E743A742C636F6D706F6E656E743A714B2C69734564697465643A51487D292C732E70757368287B656C656D656E743A742C636F6D706F6E656E743A554B7D2C7B69643A22706167654974656D73222C656C';
wwv_flow_imp.g_varchar2_table(51743) := '656D656E743A742C6C6162656C3A6F282250616765204974656D7322292C636F6D706F6E656E743A57482C2E2E2E784B287B656C656D656E743A742C696E6A6563746F723A6E2C68656C7065723A7A4B7D297D292C653F732E70757368287B69643A2266';
wwv_flow_imp.g_varchar2_table(51744) := '6F726D54656D706C6174654974656D54657874222C656C656D656E743A742C70726F70657274793A22666F726D54656D706C6174654974656D222C68656C7065723A564B2C6C6162656C3A6F2822466F726D2054656D706C617465204974656D204E616D';
wwv_flow_imp.g_varchar2_table(51745) := '6522292C6465736372697074696F6E3A6F282250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E636522292C636F6D706F6E656E743A59552C69734564697465643A6F577D293A732E70';
wwv_flow_imp.g_varchar2_table(51746) := '757368287B69643A22666F726D54656D706C6174654974656D222C656C656D656E743A742C70726F70657274793A22666F726D54656D706C6174654974656D222C6C6162656C3A6F2822466F726D2054656D706C617465204974656D22292C6465736372';
wwv_flow_imp.g_varchar2_table(51747) := '697074696F6E3A6F282250616765204974656D20636F6E7461696E696E672074686520666F726D2074656D706C617465207265666572656E636522292C636F6D706F6E656E743A244B2C69734564697465643A51487D292C732E70757368287B69643A22';
wwv_flow_imp.g_varchar2_table(51748) := '666F726D54656D706C6174654964222C656C656D656E743A742C636F6D706F6E656E743A574B2C69734564697465643A51487D297D72657475726E20737D66756E6374696F6E20574B2865297B636F6E73747B656C656D656E743A742C69643A6E7D3D65';
wwv_flow_imp.g_varchar2_table(51749) := '2C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D293B72657475726E206A77282828293D3E7B2866756E6374696F6E28297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E';
wwv_flow_imp.g_varchar2_table(51750) := '696E666F2822676574466F726D54656D706C6174657322293B7661727B616A61784964656E7469666965723A657D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E2061706578';
wwv_flow_imp.g_varchar2_table(51751) := '2E7365727665722E706C7567696E28652C7B7830313A224745545F464F524D5F54454D504C41544553227D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F672822676574466F726D54656D706C6174657322292C';
wwv_flow_imp.g_varchar2_table(51752) := '50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A2261646472657373222C76616C75653A223939393939227D5D297D2928292E7468656E2828653D3E73287B76616C7565733A652C6C6F';
wwv_flow_imp.g_varchar2_table(51753) := '616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B692822466F726D2054656D706C61746522297D0A2020202068656C7065723D';
wwv_flow_imp.g_varchar2_table(51754) := '247B564B7D0A2020202070726F70657274793D666F726D54656D706C61746549640A2020202073746174653D247B6F7D0A20202F3E607D66756E6374696F6E206A4B2865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C572822';
wwv_flow_imp.g_varchar2_table(51755) := '7472616E736C61746522292C5B6F2C735D3D5777287B7D293B72657475726E206A77282828293D3E7B754B28292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A202020';
wwv_flow_imp.g_varchar2_table(51756) := '2069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928224170706C69636174696F6E22297D0A2020202068656C7065723D247B564B7D0A2020202070726F70657274793D6170706C69636174696F6E49640A';
wwv_flow_imp.g_varchar2_table(51757) := '2020202073746174653D247B6F7D0A20202F3E607D66756E6374696F6E20714B2865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D292C723D564B2E67657445';
wwv_flow_imp.g_varchar2_table(51758) := '7874656E73696F6E50726F706572747928742C226170706C69636174696F6E496422293B6A77282828293D3E7B704B2872292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21302C6170706C69636174696F6E49643A727D2929';
wwv_flow_imp.g_varchar2_table(51759) := '297D292C5B725D293B636F6E737420613D72213D3D6F2E6170706C69636174696F6E49643B72657475726E20546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928225061';
wwv_flow_imp.g_varchar2_table(51760) := '676522297D0A2020202068656C7065723D247B564B7D0A2020202070726F70657274793D7061676549640A2020202073746174653D247B6F7D0A202020206E65656473526566726573683D247B617D0A20202F3E607D66756E6374696F6E20244B286529';
wwv_flow_imp.g_varchar2_table(51761) := '7B636F6E73747B656C656D656E743A742C69643A6E2C70726F70657274793A692C6C6162656C3A6F2C6465736372697074696F6E3A737D3D652C5B722C615D3D5777287B7D292C6C3D564B2E676574457874656E73696F6E50726F706572747928742C22';
wwv_flow_imp.g_varchar2_table(51762) := '6170706C69636174696F6E496422292C633D564B2E676574457874656E73696F6E50726F706572747928742C2270616765496422293B6A77282828293D3E7B674B286C2C63292E7468656E2828653D3E61287B76616C7565733A652C6C6F616465643A21';
wwv_flow_imp.g_varchar2_table(51763) := '302C6170706C69636174696F6E49643A6C2C7061676549643A637D2929297D292C5B6C2C635D293B636F6E737420643D6C213D3D722E6170706C69636174696F6E49647C7C63213D3D722E7061676549643B72657475726E20546C603C247B58557D0A20';
wwv_flow_imp.g_varchar2_table(51764) := '20202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6F7D0A202020206465736372697074696F6E3D247B737D0A2020202068656C7065723D247B564B7D0A2020202070726F70657274793D247B697D0A20';
wwv_flow_imp.g_varchar2_table(51765) := '20202073746174653D247B727D0A202020206E65656473526566726573683D247B647D0A20202F3E607D66756E6374696F6E20554B2865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C5728227472616E736C61746522292C693D4C572822';
wwv_flow_imp.g_varchar2_table(51766) := '62706D6E466163746F727922292C6F3D4C5728226D6F64656C696E6722293B72657475726E20664B287B746578743A6E282247656E65726174652064656661756C74206974656D7322292C68616E646C65723A28293D3E7B7A4B2E616464537562456C65';
wwv_flow_imp.g_varchar2_table(51767) := '6D656E74287B656C656D656E743A742C6D6F64656C696E673A6F2C62706D6E466163746F72793A692C6E657750726F70733A7B6974656D4E616D653A2250524F434553535F4944222C6974656D56616C75653A22264634412450524F434553535F49442E';
wwv_flow_imp.g_varchar2_table(51768) := '227D7D292C7A4B2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A6F2C62706D6E466163746F72793A692C6E657750726F70733A7B6974656D4E616D653A22535542464C4F575F4944222C6974656D56616C75653A';
wwv_flow_imp.g_varchar2_table(51769) := '222646344124535542464C4F575F49442E227D7D292C7A4B2E616464537562456C656D656E74287B656C656D656E743A742C6D6F64656C696E673A6F2C62706D6E466163746F72793A692C6E657750726F70733A7B6974656D4E616D653A22535445505F';
wwv_flow_imp.g_varchar2_table(51770) := '4B4559222C6974656D56616C75653A222646344124535445505F4B45592E227D7D297D7D297D66756E6374696F6E204B4B2865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D6E2E67657428227472616E736C6174';
wwv_flow_imp.g_varchar2_table(51771) := '6522292C6F3D7B2262706D6E3A557365725461736B223A5B7B6C6162656C3A69282241504558205061676522292C76616C75653A226170657850616765227D2C7B6C6162656C3A6928224150455820417070726F76616C22292C76616C75653A22617065';
wwv_flow_imp.g_varchar2_table(51772) := '78417070726F76616C227D2C7B6C6162656C3A692822415045582053696D706C6520466F726D22292C76616C75653A226170657853696D706C65466F726D227D5D2C2262706D6E3A536572766963655461736B223A5B7B6C6162656C3A69282245786563';
wwv_flow_imp.g_varchar2_table(51773) := '75746520504C2F53514C22292C76616C75653A2265786563757465506C73716C227D2C7B6C6162656C3A69282253656E64204D61696C22292C76616C75653A2273656E644D61696C227D5D2C2262706D6E3A5363726970745461736B223A5B7B6C616265';
wwv_flow_imp.g_varchar2_table(51774) := '6C3A6928224578656375746520504C2F53514C22292C76616C75653A2265786563757465506C73716C227D5D2C2262706D6E3A427573696E65737352756C655461736B223A5B7B6C6162656C3A6928224578656375746520504C2F53514C22292C76616C';
wwv_flow_imp.g_varchar2_table(51775) := '75653A2265786563757465506C73716C227D5D2C2262706D6E3A53656E645461736B223A5B7B6C6162656C3A69282253696D706C65204D65737361676522292C76616C75653A2273696D706C654D657373616765227D2C7B6C6162656C3A692822457865';
wwv_flow_imp.g_varchar2_table(51776) := '6375746520504C2F53514C22292C76616C75653A2265786563757465506C73716C227D5D2C2262706D6E3A526563656976655461736B223A5B7B6C6162656C3A69282253696D706C65204D65737361676522292C76616C75653A2273696D706C654D6573';
wwv_flow_imp.g_varchar2_table(51777) := '73616765227D5D7D3B72657475726E5B7B69643A227461736B54797065222C656C656D656E743A742C6C6162656C3A6928225461736B205479706522292C70726F70657274793A2274797065222C64656661756C7456616C75653A7B2262706D6E3A5573';
wwv_flow_imp.g_varchar2_table(51778) := '65725461736B223A226170657850616765222C2262706D6E3A536572766963655461736B223A2265786563757465506C73716C222C2262706D6E3A5363726970745461736B223A2265786563757465506C73716C222C2262706D6E3A427573696E657373';
wwv_flow_imp.g_varchar2_table(51779) := '52756C655461736B223A2265786563757465506C73716C222C2262706D6E3A53656E645461736B223A2273696D706C654D657373616765222C2262706D6E3A526563656976655461736B223A2273696D706C654D657373616765227D5B742E747970655D';
wwv_flow_imp.g_varchar2_table(51780) := '2C6F7074696F6E733A6F5B742E747970655D2C636C65616E75703A653D3E287B2E2E2E216F5B742E747970655D2E736F6D652828743D3E742E76616C75653D3D3D65292926267B747970653A6E756C6C7D7D292C636F6D706F6E656E743A5A557D5D7D76';
wwv_flow_imp.g_varchar2_table(51781) := '617220474B3D6F2839313932292C514B3D6F2839313932292C594B3D6F28363033292C5A4B3D6E65772064572822617065783A4F7261636C654461746522292C584B3D6E65772064572822617065783A4F7261636C654475726174696F6E22292C4A4B3D';
wwv_flow_imp.g_varchar2_table(51782) := '6E65772064572822617065783A4F7261636C654379636C6522293B66756E6374696F6E2065472865297B636F6E73747B656C656D656E743A747D3D652C6E3D74472874292C693D28286F3D6E29262628766F69642030213D3D6F2E676574282274696D65';
wwv_flow_imp.g_varchar2_table(51783) := '4461746522293F733D2274696D6544617465223A766F69642030213D3D6F2E676574282274696D654379636C6522293F733D2274696D654379636C65223A766F69642030213D3D6F2E676574282274696D654475726174696F6E22293F733D2274696D65';
wwv_flow_imp.g_varchar2_table(51784) := '4475726174696F6E223A766F69642030213D3D6F2E676574282274696D6572547970652229262628733D6F2E676574282274696D657254797065222929292C73293B766172206F2C733B72657475726E2066756E6374696F6E2865297B72657475726E20';
wwv_flow_imp.g_varchar2_table(51785) := '514B2E6973416E7928652C5B2262706D6E3A53746172744576656E74222C2262706D6E3A496E7465726D65646961746543617463684576656E74222C2262706D6E3A426F756E646172794576656E74225D292626212174472865297D2874293F5B7B6964';
wwv_flow_imp.g_varchar2_table(51786) := '3A2274696D6572446566696E6974696F6E54797065222C656C656D656E743A742C636F6D706F6E656E743A6E472C69734564697465643A51482C74696D65724576656E74446566696E6974696F6E3A6E2C74696D65724576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(51787) := '6E547970653A697D2C7B69643A2274696D6572446566696E6974696F6E222C656C656D656E743A742C636F6D706F6E656E743A69472C69734564697465643A6F572C74696D65724576656E74446566696E6974696F6E3A6E2C74696D65724576656E7444';
wwv_flow_imp.g_varchar2_table(51788) := '6566696E6974696F6E547970653A697D2C7B69643A2264617465537472696E67222C656C656D656E743A742C636F6D706F6E656E743A6F472C69734564697465643A6F572C74696D65724576656E74446566696E6974696F6E3A6E2C74696D6572457665';
wwv_flow_imp.g_varchar2_table(51789) := '6E74446566696E6974696F6E547970653A697D2C7B69643A22666F726D61744D61736B222C656C656D656E743A742C636F6D706F6E656E743A73472C69734564697465643A6F572C74696D65724576656E74446566696E6974696F6E3A6E2C74696D6572';
wwv_flow_imp.g_varchar2_table(51790) := '4576656E74446566696E6974696F6E547970653A697D2C7B69643A22696E74657276616C594D222C656C656D656E743A742C636F6D706F6E656E743A72472C69734564697465643A6F572C74696D65724576656E74446566696E6974696F6E3A6E2C7469';
wwv_flow_imp.g_varchar2_table(51791) := '6D65724576656E74446566696E6974696F6E547970653A697D2C7B69643A22696E74657276616C4453222C656C656D656E743A742C636F6D706F6E656E743A61472C69734564697465643A6F572C74696D65724576656E74446566696E6974696F6E3A6E';
wwv_flow_imp.g_varchar2_table(51792) := '2C74696D65724576656E74446566696E6974696F6E547970653A697D2C7B69643A227374617274496E74657276616C4453222C656C656D656E743A742C636F6D706F6E656E743A6C472C69734564697465643A6F572C74696D65724576656E7444656669';
wwv_flow_imp.g_varchar2_table(51793) := '6E6974696F6E3A6E2C74696D65724576656E74446566696E6974696F6E547970653A697D2C7B69643A22726570656174496E74657276616C4453222C656C656D656E743A742C636F6D706F6E656E743A63472C69734564697465643A6F572C74696D6572';
wwv_flow_imp.g_varchar2_table(51794) := '4576656E74446566696E6974696F6E3A6E2C74696D65724576656E74446566696E6974696F6E547970653A697D2C7B69643A226D617852756E73222C656C656D656E743A742C636F6D706F6E656E743A64472C69734564697465643A6F572C74696D6572';
wwv_flow_imp.g_varchar2_table(51795) := '4576656E74446566696E6974696F6E3A6E2C74696D65724576656E74446566696E6974696F6E547970653A697D5D3A5B5D7D66756E6374696F6E2074472865297B636F6E737420743D4C772865292E67657428226576656E74446566696E6974696F6E73';
wwv_flow_imp.g_varchar2_table(51796) := '22297C7C5B5D3B72657475726E20594B2E66696E6428742C2866756E6374696F6E2865297B72657475726E20474B2E697328652C2262706D6E3A54696D65724576656E74446566696E6974696F6E22297D29297D66756E6374696F6E206E472865297B63';
wwv_flow_imp.g_varchar2_table(51797) := '6F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C772874292C723D4C5728227472616E736C61746522292C61';
wwv_flow_imp.g_varchar2_table(51798) := '3D4C5728226465626F756E6365496E70757422292C6C3D4C57282262706D6E466163746F727922292C633D4C5728226D6F64656C696E6722293B72657475726E206E6577204748287B69643A6E2C656C656D656E743A742C6C6162656C3A72282254696D';
wwv_flow_imp.g_varchar2_table(51799) := '657220446566696E6974696F6E205479706522292C67657456616C75653A28293D3E6F7C7C22222C73657456616C75653A653D3E7B696628653D3D3D6F2972657475726E3B636F6E7374206E3D6C2E637265617465282262706D6E3A466F726D616C4578';
wwv_flow_imp.g_varchar2_table(51800) := '7072657373696F6E222C7B626F64793A766F696420307D293B6E2E24706172656E743D693B636F6E737420733D7B74696D654475726174696F6E3A766F696420302C74696D65446174653A766F696420302C74696D654379636C653A766F696420302C74';
wwv_flow_imp.g_varchar2_table(51801) := '696D6572547970653A766F696420307D3B5B226F7261636C6544617465222C226F7261636C654475726174696F6E222C226F7261636C654379636C65225D2E696E636C756465732865293F732E74696D6572547970653D653A735B655D3D6E2C632E7570';
wwv_flow_imp.g_varchar2_table(51802) := '646174654D6F64646C6550726F7065727469657328742C692C73297D2C6465626F756E63653A612C6765744F7074696F6E733A28293D3E2262706D6E3A53746172744576656E74223D3D3D742E747970657C7C2262706D6E3A496E7465726D6564696174';
wwv_flow_imp.g_varchar2_table(51803) := '6543617463684576656E74223D3D3D742E747970657C7C2262706D6E3A426F756E646172794576656E74223D3D3D742E747970652626732E63616E63656C41637469766974793F5B7B76616C75653A226F7261636C6544617465222C6C6162656C3A7228';
wwv_flow_imp.g_varchar2_table(51804) := '224461746520284F7261636C652922297D2C7B76616C75653A226F7261636C654475726174696F6E222C6C6162656C3A7228224475726174696F6E20284F7261636C652922297D2C7B76616C75653A2274696D6544617465222C6C6162656C3A72282244';
wwv_flow_imp.g_varchar2_table(51805) := '617465202849534F20383630312922297D2C7B76616C75653A2274696D654475726174696F6E222C6C6162656C3A7228224475726174696F6E202849534F20383630312922297D5D3A5B7B76616C75653A226F7261636C6544617465222C6C6162656C3A';
wwv_flow_imp.g_varchar2_table(51806) := '7228224461746520284F7261636C652922297D2C7B76616C75653A226F7261636C654475726174696F6E222C6C6162656C3A7228224475726174696F6E20284F7261636C652922297D2C7B76616C75653A226F7261636C654379636C65222C6C6162656C';
wwv_flow_imp.g_varchar2_table(51807) := '3A7228224379636C6520284F7261636C652922297D2C7B76616C75653A2274696D6544617465222C6C6162656C3A72282244617465202849534F20383630312922297D2C7B76616C75653A2274696D654475726174696F6E222C6C6162656C3A72282244';
wwv_flow_imp.g_varchar2_table(51808) := '75726174696F6E202849534F20383630312922297D2C7B76616C75653A2274696D654379636C65222C6C6162656C3A7228224379636C65202849534F20383630312922297D5D7D297D66756E6374696F6E2069472865297B636F6E73747B656C656D656E';
wwv_flow_imp.g_varchar2_table(51809) := '743A742C69643A6E2C74696D65724576656E74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D6F2626692E676574286F292C723D4C5728227472616E736C61746522292C613D4C572822';
wwv_flow_imp.g_varchar2_table(51810) := '6465626F756E6365496E70757422292C6C3D4C5728226D6F64656C696E6722293B6966285B2274696D6544617465222C2274696D654475726174696F6E222C2274696D654379636C65225D2E696E636C75646573286F292972657475726E206E65772069';
wwv_flow_imp.g_varchar2_table(51811) := '57287B69643A6E2C656C656D656E743A742C6C6162656C3A72282254696D657220446566696E6974696F6E22292C67657456616C75653A28293D3E732626732E6765742822626F647922292C73657456616C75653A653D3E7B6C2E7570646174654D6F64';
wwv_flow_imp.g_varchar2_table(51812) := '646C6550726F7065727469657328742C732C7B626F64793A657D297D2C6465626F756E63653A617D297D66756E6374696F6E206F472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E74446566696E6974696F6E3A69';
wwv_flow_imp.g_varchar2_table(51813) := '2C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E70757422292C6C3D4C57282262706D6E4661';
wwv_flow_imp.g_varchar2_table(51814) := '63746F727922293B696628226F7261636C6544617465223D3D3D6F2972657475726E206E6577206957287B69643A6E2C656C656D656E743A742C6C6162656C3A7228224461746520537472696E6722292C6465736372697074696F6E3A722822652E672E';
wwv_flow_imp.g_varchar2_table(51815) := '2032332D4A554E2D323032372031343A31303A303022292C67657456616C75653A28293D3E5A4B2E676574457874656E73696F6E50726F706572747928692C226461746522292C73657456616C75653A653D3E7B5A4B2E736574457874656E73696F6E50';
wwv_flow_imp.g_varchar2_table(51816) := '726F706572747928742C732C6C2C7B646174653A657D2C69297D2C6465626F756E63653A617D297D66756E6374696F6E2073472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E74446566696E6974696F6E3A692C74';
wwv_flow_imp.g_varchar2_table(51817) := '696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E70757422292C6C3D4C57282262706D6E46616374';
wwv_flow_imp.g_varchar2_table(51818) := '6F727922293B696628226F7261636C6544617465223D3D3D6F2972657475726E206E6577206957287B69643A6E2C656C656D656E743A742C6C6162656C3A722822466F726D61744D61736B22292C6465736372697074696F6E3A722822652E672E204444';
wwv_flow_imp.g_varchar2_table(51819) := '2D4D4F4E2D5959595920484832343A4D493A535322292C67657456616C75653A28293D3E5A4B2E676574457874656E73696F6E50726F706572747928692C22666F726D61744D61736B22292C73657456616C75653A653D3E7B5A4B2E736574457874656E';
wwv_flow_imp.g_varchar2_table(51820) := '73696F6E50726F706572747928742C732C6C2C7B666F726D61744D61736B3A657D2C69297D2C6465626F756E63653A617D297D66756E6374696F6E2072472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E74446566';
wwv_flow_imp.g_varchar2_table(51821) := '696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E70757422292C6C3D4C';
wwv_flow_imp.g_varchar2_table(51822) := '57282262706D6E466163746F727922293B696628226F7261636C654475726174696F6E223D3D3D6F2972657475726E206E6577206957287B69643A6E2C656C656D656E743A742C6C6162656C3A72282254696D6572204475726174696F6E22292C646573';
wwv_flow_imp.g_varchar2_table(51823) := '6372697074696F6E3A722822696E20666F726D61742059592D4D4D22292C67657456616C75653A28293D3E584B2E676574457874656E73696F6E50726F706572747928692C22696E74657276616C594D22292C73657456616C75653A653D3E7B584B2E73';
wwv_flow_imp.g_varchar2_table(51824) := '6574457874656E73696F6E50726F706572747928742C732C6C2C7B696E74657276616C594D3A657D2C69297D2C6465626F756E63653A617D297D66756E6374696F6E2061472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D657245';
wwv_flow_imp.g_varchar2_table(51825) := '76656E74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E7075';
wwv_flow_imp.g_varchar2_table(51826) := '7422292C6C3D4C57282262706D6E466163746F727922293B696628226F7261636C654475726174696F6E223D3D3D6F2972657475726E206E6577206957287B69643A6E2C656C656D656E743A742C6C6162656C3A22222C6465736372697074696F6E3A72';
wwv_flow_imp.g_varchar2_table(51827) := '2822696E20666F726D6174204444442048483A4D4D3A535322292C67657456616C75653A28293D3E584B2E676574457874656E73696F6E50726F706572747928692C22696E74657276616C445322292C73657456616C75653A653D3E7B584B2E73657445';
wwv_flow_imp.g_varchar2_table(51828) := '7874656E73696F6E50726F706572747928742C732C6C2C7B696E74657276616C44533A657D2C69297D2C6465626F756E63653A617D297D66756E6374696F6E206C472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E';
wwv_flow_imp.g_varchar2_table(51829) := '74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E7075742229';
wwv_flow_imp.g_varchar2_table(51830) := '2C6C3D4C57282262706D6E466163746F727922293B696628226F7261636C654379636C65223D3D3D6F2972657475726E206E6577206957287B69643A6E2C656C656D656E743A742C6C6162656C3A72282254696D6520756E74696C207468652074696D65';
wwv_flow_imp.g_varchar2_table(51831) := '7220666972657320666972737422292C6465736372697074696F6E3A722822696E20666F726D6174204444442048483A4D4D3A535322292C67657456616C75653A28293D3E4A4B2E676574457874656E73696F6E50726F706572747928692C2273746172';
wwv_flow_imp.g_varchar2_table(51832) := '74496E74657276616C445322292C73657456616C75653A653D3E7B4A4B2E736574457874656E73696F6E50726F706572747928742C732C6C2C7B7374617274496E74657276616C44533A657D2C69297D2C6465626F756E63653A617D297D66756E637469';
wwv_flow_imp.g_varchar2_table(51833) := '6F6E2063472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E74446566696E6974696F6E3A692C74696D65724576656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C';
wwv_flow_imp.g_varchar2_table(51834) := '723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E70757422292C6C3D4C57282262706D6E466163746F727922293B696628226F7261636C654379636C65223D3D3D6F2972657475726E206E6577206957287B69643A6E';
wwv_flow_imp.g_varchar2_table(51835) := '2C656C656D656E743A742C6C6162656C3A72282254696D6520756E74696C207468652074696D657220666972657320616761696E22292C6465736372697074696F6E3A722822696E20666F726D6174204444442048483A4D4D3A535322292C6765745661';
wwv_flow_imp.g_varchar2_table(51836) := '6C75653A28293D3E4A4B2E676574457874656E73696F6E50726F706572747928692C22726570656174496E74657276616C445322292C73657456616C75653A653D3E7B4A4B2E736574457874656E73696F6E50726F706572747928742C732C6C2C7B7265';
wwv_flow_imp.g_varchar2_table(51837) := '70656174496E74657276616C44533A657D2C69297D2C6465626F756E63653A617D297D66756E6374696F6E2064472865297B636F6E73747B656C656D656E743A742C69643A6E2C74696D65724576656E74446566696E6974696F6E3A692C74696D657245';
wwv_flow_imp.g_varchar2_table(51838) := '76656E74446566696E6974696F6E547970653A6F7D3D652C733D4C5728226D6F64656C696E6722292C723D4C5728227472616E736C61746522292C613D4C5728226465626F756E6365496E70757422292C6C3D4C57282262706D6E466163746F72792229';
wwv_flow_imp.g_varchar2_table(51839) := '3B696628226F7261636C654379636C65223D3D3D6F2972657475726E206E6577205348287B69643A6E2C656C656D656E743A742C6C6162656C3A7228224D61782052756E7322292C67657456616C75653A28293D3E4A4B2E676574457874656E73696F6E';
wwv_flow_imp.g_varchar2_table(51840) := '50726F706572747928692C226D617852756E7322292C73657456616C75653A653D3E7B4A4B2E736574457874656E73696F6E50726F706572747928742C732C6C2C7B6D617852756E733A657D2C69297D2C6465626F756E63653A617D297D636F6E737420';
wwv_flow_imp.g_varchar2_table(51841) := '68473D6E65772064572822617065783A506F74656E7469616C557365727322292C75473D6E65772064572822617065783A506F74656E7469616C47726F75707322292C70473D6E65772064572822617065783A4578636C75646564557365727322293B66';
wwv_flow_imp.g_varchar2_table(51842) := '756E6374696F6E2067472865297B636F6E73747B656C656D656E743A747D3D653B72657475726E5B7B69643A22706F74656E7469616C5573657273222C656C656D656E743A742C636F6D706F6E656E743A6D477D2C7B69643A22706F74656E7469616C47';
wwv_flow_imp.g_varchar2_table(51843) := '726F757073222C656C656D656E743A742C636F6D706F6E656E743A66477D2C7B69643A226578636C756465645573657273222C656C656D656E743A742C636F6D706F6E656E743A76477D5D7D66756E6374696F6E206D472865297B636F6E73747B656C65';
wwv_flow_imp.g_varchar2_table(51844) := '6D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A';
wwv_flow_imp.g_varchar2_table(51845) := '69282250726F63657373205661726961626C6522292C76616C75653A2270726F636573735661726961626C65227D2C7B6C6162656C3A69282253514C207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953';
wwv_flow_imp.g_varchar2_table(51846) := '696E676C65227D2C7B6C6162656C3A69282253514C2071756572792028636F6C6F6E2064656C696D69746564206C6973742922292C76616C75653A2273716C51756572794C697374227D2C7B6C6162656C3A69282245787072657373696F6E22292C7661';
wwv_flow_imp.g_varchar2_table(51847) := '6C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A69282246756E6374696F6E20426F647922292C76616C75653A22706C73716C52617746756E6374696F6E426F6479227D5D2C733D68472E676574457874656E73696F6E';
wwv_flow_imp.g_varchar2_table(51848) := '50726F706572747928742C2265787072657373696F6E5479706522292C723D5B5D3B696628722E70757368287B69643A22706F74656E7469616C557365727345787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A6928224578';
wwv_flow_imp.g_varchar2_table(51849) := '7072657373696F6E205479706522292C68656C7065723A68472C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A6F2C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D';
wwv_flow_imp.g_varchar2_table(51850) := '292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C6E756C6C213D73296966285B2273716C517565727953696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C';
wwv_flow_imp.g_varchar2_table(51851) := '52617746756E6374696F6E426F6479225D2E696E636C75646573287329297B636F6E737420653D2273716C517565727953696E676C65223D3D3D737C7C2273716C51756572794C697374223D3D3D733F2273716C223A22706C73716C223B722E70757368';
wwv_flow_imp.g_varchar2_table(51852) := '287B69643A22706F74656E7469616C557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A68472C70726F70657274793A2265787072657373696F6E222C6C616E67';
wwv_flow_imp.g_varchar2_table(51853) := '756167653A652C747970653A732C636F6D706F6E656E743A744B2C69734564697465643A65577D297D656C736520722E70757368287B69643A22706F74656E7469616C557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A';
wwv_flow_imp.g_varchar2_table(51854) := '69282245787072657373696F6E22292C68656C7065723A68472C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D293B72657475726E206E6577205648287B69643A6E2C656C656D65';
wwv_flow_imp.g_varchar2_table(51855) := '6E743A742C6C6162656C3A692822506F74656E7469616C20557365727322292C656E74726965733A727D297D66756E6374696F6E2066472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C6174652229';
wwv_flow_imp.g_varchar2_table(51856) := '2C6F3D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A69282250726F63657373205661726961626C6522292C76616C75653A2270726F';
wwv_flow_imp.g_varchar2_table(51857) := '636573735661726961626C65227D2C7B6C6162656C3A69282253514C207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D2C7B6C6162656C3A69282253514C2071756572792028636F6C';
wwv_flow_imp.g_varchar2_table(51858) := '6F6E2064656C696D69746564206C6973742922292C76616C75653A2273716C51756572794C697374227D2C7B6C6162656C3A69282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C';
wwv_flow_imp.g_varchar2_table(51859) := '3A69282246756E6374696F6E20426F647922292C76616C75653A22706C73716C52617746756E6374696F6E426F6479227D5D2C733D75472E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E5479706522292C723D5B';
wwv_flow_imp.g_varchar2_table(51860) := '5D3B696628722E70757368287B69643A22706F74656E7469616C47726F75707345787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E205479706522292C68656C7065723A75472C70726F7065';
wwv_flow_imp.g_varchar2_table(51861) := '7274793A2265787072657373696F6E54797065222C6F7074696F6E733A6F2C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C6E75';
wwv_flow_imp.g_varchar2_table(51862) := '6C6C213D73296966285B2273716C517565727953696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2E696E636C75646573287329297B';
wwv_flow_imp.g_varchar2_table(51863) := '636F6E737420653D2273716C517565727953696E676C65223D3D3D737C7C2273716C51756572794C697374223D3D3D733F2273716C223A22706C73716C223B722E70757368287B69643A22706F74656E7469616C47726F75707345787072657373696F6E';
wwv_flow_imp.g_varchar2_table(51864) := '222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A75472C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A652C747970653A732C636F6D706F6E656E743A744B2C697345';
wwv_flow_imp.g_varchar2_table(51865) := '64697465643A65577D297D656C736520722E70757368287B69643A22706F74656E7469616C47726F75707345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A75472C70726F';
wwv_flow_imp.g_varchar2_table(51866) := '70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D293B72657475726E206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A692822506F74656E7469616C2047726F7570';
wwv_flow_imp.g_varchar2_table(51867) := '7322292C656E74726965733A727D297D66756E6374696F6E2076472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C';
wwv_flow_imp.g_varchar2_table(51868) := '6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A69282250726F63657373205661726961626C6522292C76616C75653A2270726F636573735661726961626C65227D2C7B6C6162656C3A69282253514C';
wwv_flow_imp.g_varchar2_table(51869) := '207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D2C7B6C6162656C3A69282253514C2071756572792028636F6C6F6E2064656C696D69746564206C6973742922292C76616C75653A22';
wwv_flow_imp.g_varchar2_table(51870) := '73716C51756572794C697374227D2C7B6C6162656C3A69282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A69282246756E6374696F6E20426F647922292C76616C75653A2270';
wwv_flow_imp.g_varchar2_table(51871) := '6C73716C52617746756E6374696F6E426F6479227D5D2C733D70472E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E5479706522292C723D5B5D3B696628722E70757368287B69643A226578636C75646564557365';
wwv_flow_imp.g_varchar2_table(51872) := '727345787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E205479706522292C68656C7065723A70472C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A6F';
wwv_flow_imp.g_varchar2_table(51873) := '2C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C6E756C6C213D73296966285B2273716C517565727953696E676C65222C227371';
wwv_flow_imp.g_varchar2_table(51874) := '6C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2E696E636C75646573287329297B636F6E737420653D2273716C517565727953696E676C65223D3D3D737C7C';
wwv_flow_imp.g_varchar2_table(51875) := '2273716C51756572794C697374223D3D3D733F2273716C223A22706C73716C223B722E70757368287B69643A226578636C75646564557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(51876) := '292C68656C7065723A70472C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A652C747970653A732C636F6D706F6E656E743A744B2C69734564697465643A65577D297D656C736520722E70757368287B69643A226578636C';
wwv_flow_imp.g_varchar2_table(51877) := '75646564557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A70472C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C6973';
wwv_flow_imp.g_varchar2_table(51878) := '4564697465643A65577D293B72657475726E206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6928224578636C7564656420557365727322292C656E74726965733A727D297D66756E6374696F6E2062472865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(51879) := '7B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D6E2E67657428227472616E736C61746522293B72657475726E5B7B69643A22697343616C6C61626C65222C656C656D656E743A742C6C6162656C3A69282249732043616C6C61626C65';
wwv_flow_imp.g_varchar2_table(51880) := '22292C6465736372697074696F6E3A69282253656C6563742069662074686973206469616772616D2073686F756C642062652063616C6C656420696E20612043616C6C20416374697669747922292C70726F70657274793A22697343616C6C61626C6522';
wwv_flow_imp.g_varchar2_table(51881) := '2C636F6D706F6E656E743A4A552C69734564697465643A79487D2C7B69643A226973537461727461626C65222C656C656D656E743A742C6C6162656C3A692822497320537461727461626C6522292C6465736372697074696F6E3A69282253656C656374';
wwv_flow_imp.g_varchar2_table(51882) := '2069662074686973206469616772616D20697320737461727461626C6522292C70726F70657274793A226973537461727461626C65222C636F6D706F6E656E743A4A552C69734564697465643A79487D5D7D66756E6374696F6E205F472865297B636F6E';
wwv_flow_imp.g_varchar2_table(51883) := '73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E67657428227472616E736C61746522292C733D5B5D3B72657475726E20732E70757368287B69643A226973526F6C65222C656C656D656E743A742C6C61';
wwv_flow_imp.g_varchar2_table(51884) := '62656C3A6F2822497320526F6C6522292C70726F70657274793A226973526F6C65222C64656661756C7456616C75653A2266616C7365222C636F6D706F6E656E743A4A552C69734564697465643A79487D292C692E6973526F6C652626732E7075736828';
wwv_flow_imp.g_varchar2_table(51885) := '7B69643A22726F6C65222C656C656D656E743A742C6C6162656C3A6F2822526F6C6522292C70726F70657274793A22726F6C65222C636F6D706F6E656E743A59552C69734564697465643A6F577D292C737D7661722079473D6F2839313932293B636F6E';
wwv_flow_imp.g_varchar2_table(51886) := '73742077473D6E65772064572822617065783A5072696F7269747922292C43473D6E65772064572822617065783A4475654F6E22293B66756E6374696F6E2053472865297B636F6E73747B656C656D656E743A747D3D653B72657475726E5B7B69643A22';
wwv_flow_imp.g_varchar2_table(51887) := '7072696F72697479222C656C656D656E743A742C636F6D706F6E656E743A78477D2C7B69643A226475654F6E222C656C656D656E743A742C636F6D706F6E656E743A6B477D5D7D66756E6374696F6E2078472865297B636F6E73747B656C656D656E743A';
wwv_flow_imp.g_varchar2_table(51888) := '742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D4C5728226D6F64656C696E6722292C733D4C57282262706D6E466163746F727922292C723D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A692822';
wwv_flow_imp.g_varchar2_table(51889) := '53746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A69282250726F63657373205661726961626C6522292C76616C75653A2270726F636573735661726961626C65227D2C7B6C6162656C3A69282253514C2071756572792028';
wwv_flow_imp.g_varchar2_table(51890) := '73696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D2C7B6C6162656C3A69282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A6928';
wwv_flow_imp.g_varchar2_table(51891) := '2246756E6374696F6E20426F647922292C76616C75653A22706C73716C52617746756E6374696F6E426F6479227D5D2C613D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A692822312D557267656E7422292C76616C75653A';
wwv_flow_imp.g_varchar2_table(51892) := '2231227D2C7B6C6162656C3A692822322D4869676822292C76616C75653A2232227D2C7B6C6162656C3A692822332D4D656469756D22292C76616C75653A2233227D2C7B6C6162656C3A692822342D4C6F7722292C76616C75653A2234227D2C7B6C6162';
wwv_flow_imp.g_varchar2_table(51893) := '656C3A692822352D4C6F7765737422292C76616C75653A2235227D5D2C6C3D77472E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E5479706522292C633D5B5D3B696628632E70757368287B69643A226578707265';
wwv_flow_imp.g_varchar2_table(51894) := '7373696F6E54797065222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E205479706522292C68656C7065723A77472C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A722C636C65616E75';
wwv_flow_imp.g_varchar2_table(51895) := '703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C22737461746963223D3D3D6C29632E70757368287B69643A2265787072657373696F6E222C656C';
wwv_flow_imp.g_varchar2_table(51896) := '656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A77472C70726F70657274793A2265787072657373696F6E222C6F7074696F6E733A612C636F6D706F6E656E743A5A552C69734564697465643A51487D293B65';
wwv_flow_imp.g_varchar2_table(51897) := '6C7365206966286E756C6C213D6C296966285B2273716C517565727953696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2E696E636C';
wwv_flow_imp.g_varchar2_table(51898) := '75646573286C29297B636F6E737420653D2273716C517565727953696E676C65223D3D3D6C7C7C2273716C51756572794C697374223D3D3D6C3F2273716C223A22706C73716C223B632E70757368287B69643A2265787072657373696F6E222C656C656D';
wwv_flow_imp.g_varchar2_table(51899) := '656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A77472C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A652C747970653A6C2C636F6D706F6E656E743A744B2C69734564697465643A';
wwv_flow_imp.g_varchar2_table(51900) := '65577D297D656C73657B636F6E737420653D79472E697328742C2262706D6E3A557365725461736B22292626664B287B746578743A69282250726F63657373205072696F7269747922292C68616E646C65723A28293D3E7B77472E736574457874656E73';
wwv_flow_imp.g_varchar2_table(51901) := '696F6E50726F706572747928742C6F2C732C7B65787072657373696F6E3A2250524F434553535F5052494F52495459227D297D7D293B632E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C6C6162656C3A692822457870';
wwv_flow_imp.g_varchar2_table(51902) := '72657373696F6E22292C6465736372697074696F6E3A652C68656C7065723A77472C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D297D72657475726E206E6577205648287B6964';
wwv_flow_imp.g_varchar2_table(51903) := '3A6E2C656C656D656E743A742C6C6162656C3A6928225072696F7269747922292C656E74726965733A637D297D66756E6374696F6E206B472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522';
wwv_flow_imp.g_varchar2_table(51904) := '292C6F3D4C5728226D6F64656C696E6722292C733D4C57282262706D6E466163746F727922292C723D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B';
wwv_flow_imp.g_varchar2_table(51905) := '6C6162656C3A692822496E74657276616C22292C76616C75653A22696E74657276616C227D2C7B6C6162656C3A6928225363686564756C65722045787072657373696F6E22292C76616C75653A226F7261636C655363686564756C6572227D2C7B6C6162';
wwv_flow_imp.g_varchar2_table(51906) := '656C3A69282250726F63657373205661726961626C6522292C76616C75653A2270726F636573735661726961626C65227D2C7B6C6162656C3A69282253514C20717565727922292C76616C75653A2273716C517565727953696E676C65227D2C7B6C6162';
wwv_flow_imp.g_varchar2_table(51907) := '656C3A69282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A69282246756E6374696F6E20426F647922292C76616C75653A22706C73716C52617746756E6374696F6E426F6479';
wwv_flow_imp.g_varchar2_table(51908) := '227D5D2C613D7B7374617469633A69282254696D657374616D7020776974682054696D65205A6F6E6520696E2049534F2038363031206F72204F7261636C6520666F726D617422292C696E74657276616C3A6928224475726174696F6E20696E2049534F';
wwv_flow_imp.g_varchar2_table(51909) := '2038363031206F72204F7261636C6520496E74657276616C204453202744444420484832343A4D493A53532720666F726D617422292C6F7261636C655363686564756C65723A6928224F7261636C65205363686564756C652065787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(51910) := '292C70726F636573735661726961626C653A6928224E616D65206F66207468652050726F63657373205661726961626C6520286F6620747970652054696D657374616D7020776974682054696D65205A6F6E652922292C73716C517565727953696E676C';
wwv_flow_imp.g_varchar2_table(51911) := '653A69282253514C2071756572792072657475726E696E672054696D657374616D7020776974682054696D65205A6F6E6522292C706C73716C52617745787072657373696F6E3A692822504C2F53514C2045787072657373696F6E2072657475726E696E';
wwv_flow_imp.g_varchar2_table(51912) := '672054696D657374616D7020776974682054696D65205A6F6E6522292C706C73716C52617746756E6374696F6E426F64793A692822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E672054696D657374616D7020776974682054';
wwv_flow_imp.g_varchar2_table(51913) := '696D65205A6F6E6522297D2C6C3D5B2273716C517565727953696E676C65222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2C633D43472E676574457874656E73696F6E50726F706572';
wwv_flow_imp.g_varchar2_table(51914) := '747928742C2265787072657373696F6E5479706522292C643D5B5D3B696628642E70757368287B69643A226475654F6E45787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E20547970652229';
wwv_flow_imp.g_varchar2_table(51915) := '2C68656C7065723A43472C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A722C636C65616E75703A653D3E287B2E2E2E2273746174696322213D3D6526267B666F726D61744D61736B3A6E756C6C7D2C2E2E2E2165';
wwv_flow_imp.g_varchar2_table(51916) := '26267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C22737461746963223D3D3D63297B636F6E737420653D66756E6374696F6E2865297B636F6E737420743D5B5D3B72657475726E';
wwv_flow_imp.g_varchar2_table(51917) := '20652E666F72456163682828653D3E7B742E70757368286D4B2E6A7378282261222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D717569636B7069636B2D6C696E6B222C6368696C6472656E3A652E746578742C6F6E436C69';
wwv_flow_imp.g_varchar2_table(51918) := '636B3A652E68616E646C65727D29297D29292C6D4B2E6A73782822646976222C7B636C6173733A2262696F2D70726F706572746965732D70616E656C2D717569636B7069636B73222C6368696C6472656E3A747D297D285B7B746578743A6928224F7261';
wwv_flow_imp.g_varchar2_table(51919) := '636C6522292C68616E646C65723A28293D3E7B43472E736574457874656E73696F6E50726F706572747928742C6F2C732C7B666F726D61744D61736B3A22595959592D4D4D2D444420484832343A4D493A535320545A52227D297D7D2C7B746578743A69';
wwv_flow_imp.g_varchar2_table(51920) := '282249534F22292C68616E646C65723A28293D3E7B43472E736574457874656E73696F6E50726F706572747928742C6F2C732C7B666F726D61744D61736B3A27595959592D4D4D2D4444225422484832343A4D493A535320545A52277D297D7D5D293B64';
wwv_flow_imp.g_varchar2_table(51921) := '2E70757368287B69643A226475654F6E466F726D61744D61736B222C656C656D656E743A742C6C6162656C3A692822466F726D6174204D61736B22292C6465736372697074696F6E3A652C68656C7065723A43472C70726F70657274793A22666F726D61';
wwv_flow_imp.g_varchar2_table(51922) := '744D61736B222C636F6D706F6E656E743A59552C69734564697465643A65577D297D6966286E756C6C213D63297B636F6E737420653D28293D3E7B636F6E737420653D43472E676574457874656E73696F6E50726F706572747928742C22657870726573';
wwv_flow_imp.g_varchar2_table(51923) := '73696F6E5479706522293B72657475726E20615B655D7D3B6966286C2E696E636C75646573286329297B636F6E7374206E3D2273716C517565727953696E676C65223D3D3D633F2273716C223A22706C73716C223B642E70757368287B69643A22657870';
wwv_flow_imp.g_varchar2_table(51924) := '72657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C6465736372697074696F6E3A6528292C68656C7065723A43472C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A6E2C';
wwv_flow_imp.g_varchar2_table(51925) := '747970653A632C636F6D706F6E656E743A744B2C69734564697465643A65577D297D656C736520642E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C6465736372';
wwv_flow_imp.g_varchar2_table(51926) := '697074696F6E3A6528292C68656C7065723A43472C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D297D72657475726E206E6577205648287B69643A6E2C656C656D656E743A742C';
wwv_flow_imp.g_varchar2_table(51927) := '6C6162656C3A692822447565204F6E22292C656E74726965733A647D297D66756E6374696F6E2045472865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E67657428227472616E736C6174';
wwv_flow_imp.g_varchar2_table(51928) := '6522292C733D5B5D2C723D5B7B6C6162656C3A6F28224C61746573742076657273696F6E22292C76616C75653A226C617465737456657273696F6E227D2C7B6C6162656C3A6F28224E616D65642076657273696F6E22292C76616C75653A226E616D6564';
wwv_flow_imp.g_varchar2_table(51929) := '56657273696F6E227D5D2C613D2274727565223D3D3D692E6D616E75616C496E7075742C6C3D692E63616C6C65644469616772616D56657273696F6E53656C656374696F6E3B72657475726E20732E70757368287B69643A22696E70757453656C656374';
wwv_flow_imp.g_varchar2_table(51930) := '696F6E222C656C656D656E743A742C6C6162656C3A6F28225573652041504558206D657461206461746122292C70726F70657274793A226D616E75616C496E707574222C64656661756C7456616C75653A2266616C7365222C696E766572743A21302C63';
wwv_flow_imp.g_varchar2_table(51931) := '6F6D706F6E656E743A4A557D292C613F732E70757368287B69643A2263616C6C65644469616772616D54657874222C656C656D656E743A742C6C6162656C3A6F282243616C6C6564204469616772616D22292C6465736372697074696F6E3A6F28224E61';
wwv_flow_imp.g_varchar2_table(51932) := '6D65206F6620746865206469616772616D22292C70726F70657274793A2263616C6C65644469616772616D222C636F6D706F6E656E743A59552C69734564697465643A6F577D293A732E70757368287B69643A2263616C6C65644469616772616D222C65';
wwv_flow_imp.g_varchar2_table(51933) := '6C656D656E743A742C636F6D706F6E656E743A4C472C69734564697465643A51487D292C732E70757368287B69643A2263616C6C65644469616772616D56657273696F6E53656C656374696F6E222C656C656D656E743A742C6C6162656C3A6F28225665';
wwv_flow_imp.g_varchar2_table(51934) := '7273696F6E696E6722292C6465736372697074696F6E3A6F282255736564206469616772616D2076657273696F6E22292C70726F70657274793A2263616C6C65644469616772616D56657273696F6E53656C656374696F6E222C64656661756C7456616C';
wwv_flow_imp.g_varchar2_table(51935) := '75653A226C617465737456657273696F6E222C6F7074696F6E733A722C636C65616E75703A653D3E287B2E2E2E226C617465737456657273696F6E223D3D3D6526267B63616C6C65644469616772616D56657273696F6E3A6E756C6C7D7D292C636F6D70';
wwv_flow_imp.g_varchar2_table(51936) := '6F6E656E743A5A552C69734564697465643A51487D292C226E616D656456657273696F6E223D3D3D6C2626732E70757368287B69643A2263616C6C65644469616772616D56657273696F6E222C656C656D656E743A742C6C6162656C3A6F282256657273';
wwv_flow_imp.g_varchar2_table(51937) := '696F6E204E616D6522292C70726F70657274793A2263616C6C65644469616772616D56657273696F6E222C636F6D706F6E656E743A59552C69734564697465643A6F577D292C737D66756E6374696F6E204C472865297B636F6E73747B656C656D656E74';
wwv_flow_imp.g_varchar2_table(51938) := '3A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D293B72657475726E206A77282828293D3E7B2866756E6374696F6E28297B69662822756E646566696E656422213D747970656F662061706578297B61';
wwv_flow_imp.g_varchar2_table(51939) := '7065782E64656275672E696E666F28226765744469616772616D7322293B7661727B616A61784964656E7469666965723A657D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E';
wwv_flow_imp.g_varchar2_table(51940) := '20617065782E7365727665722E706C7567696E28652C7B7830313A224745545F4449414752414D53227D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728226765744469616772616D7322292C50726F6D6973';
wwv_flow_imp.g_varchar2_table(51941) := '652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A224469616772616D31222C76616C75653A224469616772616D31227D2C7B6C6162656C3A224469616772616D32222C76616C75653A22446961677261';
wwv_flow_imp.g_varchar2_table(51942) := '6D32227D5D297D2928292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C';
wwv_flow_imp.g_varchar2_table(51943) := '3D247B69282243616C6C6564204469616772616D22297D0A202020206465736372697074696F6E3D247B6928224E616D65206F6620746865206469616772616D22297D0A2020202070726F70657274793D63616C6C65644469616772616D0A2020202073';
wwv_flow_imp.g_varchar2_table(51944) := '746174653D247B6F7D0A20202F3E607D636F6E73742044473D6E65772064572822617065783A506F74656E7469616C5374617274696E67557365727322292C54473D6E65772064572822617065783A506F74656E7469616C5374617274696E6747726F75';
wwv_flow_imp.g_varchar2_table(51945) := '707322292C49473D6E65772064572822617065783A4578636C756465645374617274696E67557365727322293B66756E6374696F6E204D472865297B636F6E73747B656C656D656E743A747D3D653B72657475726E2274727565223D3D3D4C772874292E';
wwv_flow_imp.g_varchar2_table(51946) := '6973537461727461626C653F5B7B69643A22706F74656E7469616C5374617274696E675573657273222C656C656D656E743A742C636F6D706F6E656E743A41477D2C7B69643A22706F74656E7469616C5374617274696E6747726F757073222C656C656D';
wwv_flow_imp.g_varchar2_table(51947) := '656E743A742C636F6D706F6E656E743A4E477D2C7B69643A226578636C756465645374617274696E675573657273222C656C656D656E743A742C636F6D706F6E656E743A50477D5D3A5B5D7D66756E6374696F6E2041472865297B636F6E73747B656C65';
wwv_flow_imp.g_varchar2_table(51948) := '6D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A';
wwv_flow_imp.g_varchar2_table(51949) := '69282253514C207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D2C7B6C6162656C3A69282253514C2071756572792028636F6C6F6E2064656C696D69746564206C6973742922292C76';
wwv_flow_imp.g_varchar2_table(51950) := '616C75653A2273716C51756572794C697374227D2C7B6C6162656C3A69282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A69282246756E6374696F6E20426F647922292C7661';
wwv_flow_imp.g_varchar2_table(51951) := '6C75653A22706C73716C52617746756E6374696F6E426F6479227D5D2C733D44472E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E5479706522292C723D5B5D3B696628722E70757368287B69643A22706F74656E';
wwv_flow_imp.g_varchar2_table(51952) := '7469616C5374617274696E67557365727345787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E205479706522292C68656C7065723A44472C70726F70657274793A2265787072657373696F6E';
wwv_flow_imp.g_varchar2_table(51953) := '54797065222C6F7074696F6E733A6F2C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C6E756C6C213D73296966285B2273716C51';
wwv_flow_imp.g_varchar2_table(51954) := '7565727953696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2E696E636C75646573287329297B636F6E737420653D2273716C517565';
wwv_flow_imp.g_varchar2_table(51955) := '727953696E676C65223D3D3D737C7C2273716C51756572794C697374223D3D3D733F2273716C223A22706C73716C223B722E70757368287B69643A22706F74656E7469616C5374617274696E67557365727345787072657373696F6E222C656C656D656E';
wwv_flow_imp.g_varchar2_table(51956) := '743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A44472C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A652C747970653A732C636F6D706F6E656E743A744B2C69734564697465643A6557';
wwv_flow_imp.g_varchar2_table(51957) := '7D297D656C736520722E70757368287B69643A22706F74656E7469616C5374617274696E67557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A44472C70726F70';
wwv_flow_imp.g_varchar2_table(51958) := '657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D293B72657475726E206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A692822506F74656E7469616C20537461727469';
wwv_flow_imp.g_varchar2_table(51959) := '6E6720557365727322292C656E74726965733A727D297D66756E6374696F6E204E472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D5B7B6C6162656C3A22222C76616C75653A6E';
wwv_flow_imp.g_varchar2_table(51960) := '756C6C7D2C7B6C6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A69282253514C207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D';
wwv_flow_imp.g_varchar2_table(51961) := '2C7B6C6162656C3A69282253514C2071756572792028636F6C6F6E2064656C696D69746564206C6973742922292C76616C75653A2273716C51756572794C697374227D2C7B6C6162656C3A69282245787072657373696F6E22292C76616C75653A22706C';
wwv_flow_imp.g_varchar2_table(51962) := '73716C52617745787072657373696F6E227D2C7B6C6162656C3A69282246756E6374696F6E20426F647922292C76616C75653A22706C73716C52617746756E6374696F6E426F6479227D5D2C733D54472E676574457874656E73696F6E50726F70657274';
wwv_flow_imp.g_varchar2_table(51963) := '7928742C2265787072657373696F6E5479706522292C723D5B5D3B696628722E70757368287B69643A22706F74656E7469616C5374617274696E6747726F75707345787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A692822';
wwv_flow_imp.g_varchar2_table(51964) := '45787072657373696F6E205479706522292C68656C7065723A54472C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A6F2C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C';
wwv_flow_imp.g_varchar2_table(51965) := '7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C6E756C6C213D73296966285B2273716C517565727953696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73';
wwv_flow_imp.g_varchar2_table(51966) := '716C52617746756E6374696F6E426F6479225D2E696E636C75646573287329297B636F6E737420653D2273716C517565727953696E676C65223D3D3D737C7C2273716C51756572794C697374223D3D3D733F2273716C223A22706C73716C223B722E7075';
wwv_flow_imp.g_varchar2_table(51967) := '7368287B69643A22706F74656E7469616C5374617274696E67557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A54472C70726F70657274793A22657870726573';
wwv_flow_imp.g_varchar2_table(51968) := '73696F6E222C6C616E67756167653A652C747970653A732C636F6D706F6E656E743A744B2C69734564697465643A65577D297D656C736520722E70757368287B69643A22706F74656E7469616C5374617274696E6747726F75707345787072657373696F';
wwv_flow_imp.g_varchar2_table(51969) := '6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A54472C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D293B72657475726E';
wwv_flow_imp.g_varchar2_table(51970) := '206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A692822506F74656E7469616C205374617274696E672047726F75707322292C656E74726965733A727D297D66756E6374696F6E2050472865297B636F6E73747B656C656D656E';
wwv_flow_imp.g_varchar2_table(51971) := '743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A69282253746174696322292C76616C75653A22737461746963227D2C7B6C6162656C3A692822';
wwv_flow_imp.g_varchar2_table(51972) := '53514C207175657279202873696E676C652076616C75652922292C76616C75653A2273716C517565727953696E676C65227D2C7B6C6162656C3A69282253514C2071756572792028636F6C6F6E2064656C696D69746564206C6973742922292C76616C75';
wwv_flow_imp.g_varchar2_table(51973) := '653A2273716C51756572794C697374227D2C7B6C6162656C3A69282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A69282246756E6374696F6E20426F647922292C76616C7565';
wwv_flow_imp.g_varchar2_table(51974) := '3A22706C73716C52617746756E6374696F6E426F6479227D5D2C733D49472E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E5479706522292C723D5B5D3B696628722E70757368287B69643A226578636C75646564';
wwv_flow_imp.g_varchar2_table(51975) := '5374617274696E67557365727345787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E205479706522292C68656C7065723A49472C70726F70657274793A2265787072657373696F6E54797065';
wwv_flow_imp.g_varchar2_table(51976) := '222C6F7074696F6E733A6F2C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51487D292C6E756C6C213D73296966285B2273716C5175657279';
wwv_flow_imp.g_varchar2_table(51977) := '53696E676C65222C2273716C51756572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2E696E636C75646573287329297B636F6E737420653D2273716C51756572795369';
wwv_flow_imp.g_varchar2_table(51978) := '6E676C65223D3D3D737C7C2273716C51756572794C697374223D3D3D733F2273716C223A22706C73716C223B722E70757368287B69643A226578636C756465645374617274696E67557365727345787072657373696F6E222C656C656D656E743A742C6C';
wwv_flow_imp.g_varchar2_table(51979) := '6162656C3A69282245787072657373696F6E22292C68656C7065723A49472C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A652C747970653A732C636F6D706F6E656E743A744B2C69734564697465643A65577D297D656C';
wwv_flow_imp.g_varchar2_table(51980) := '736520722E70757368287B69643A226578636C756465645374617274696E67557365727345787072657373696F6E222C656C656D656E743A742C6C6162656C3A69282245787072657373696F6E22292C68656C7065723A49472C70726F70657274793A22';
wwv_flow_imp.g_varchar2_table(51981) := '65787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65577D293B72657475726E206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6928224578636C75646564205374617274696E672055736572';
wwv_flow_imp.g_varchar2_table(51982) := '7322292C656E74726965733A727D297D766172204F473D6F2839313932292C52473D6F28363033293B66756E6374696F6E2046472865297B636F6E73747B656C656D656E743A747D3D652C6E3D66756E6374696F6E2865297B636F6E737420743D4C7728';
wwv_flow_imp.g_varchar2_table(51983) := '65292E67657428226576656E74446566696E6974696F6E7322297C7C5B5D3B72657475726E2052472E66696E6428742C2866756E6374696F6E2865297B72657475726E204F472E697328652C2262706D6E3A5465726D696E6174654576656E7444656669';
wwv_flow_imp.g_varchar2_table(51984) := '6E6974696F6E22297D29297D2874293B72657475726E206E3F5B7B69643A2270726F63657373537461747573222C656C656D656E743A742C636F6D706F6E656E743A42472C7465726D696E6174654576656E74446566696E6974696F6E3A6E7D5D3A5B5D';
wwv_flow_imp.g_varchar2_table(51985) := '7D66756E6374696F6E2042472865297B636F6E73747B69643A742C656C656D656E743A6E2C7465726D696E6174654576656E74446566696E6974696F6E3A697D3D652C6F3D4C5728226D6F64656C696E6722292C733D4C5728226465626F756E6365496E';
wwv_flow_imp.g_varchar2_table(51986) := '70757422292C723D4C5728227472616E736C61746522293B72657475726E206E6577204748287B69643A742C656C656D656E743A6E2C6C6162656C3A72282250726F6365737320737461747573206166746572207465726D696E6174696F6E22292C6765';
wwv_flow_imp.g_varchar2_table(51987) := '7456616C75653A28293D3E28692E676574282270726F6365737353746174757322297C7C6F2E7570646174654D6F64646C6550726F70657274696573286E2C692C7B70726F636573735374617475733A22636F6D706C65746564227D292C692E67657428';
wwv_flow_imp.g_varchar2_table(51988) := '2270726F636573735374617475732229292C73657456616C75653A653D3E7B6F2E7570646174654D6F64646C6550726F70657274696573286E2C692C7B70726F636573735374617475733A657D297D2C6765744F7074696F6E733A28293D3E5B7B6C6162';
wwv_flow_imp.g_varchar2_table(51989) := '656C3A722822436F6D706C6574656422292C76616C75653A22636F6D706C65746564227D2C7B6C6162656C3A7228225465726D696E6174656422292C76616C75653A227465726D696E61746564227D5D2C6465626F756E63653A737D297D66756E637469';
wwv_flow_imp.g_varchar2_table(51990) := '6F6E2056472865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E67657428227472616E736C61746522292C733D5B5D2C723D2274727565223D3D3D692E6D616E75616C496E7075743B7265';
wwv_flow_imp.g_varchar2_table(51991) := '7475726E20732E70757368287B69643A22696E70757453656C656374696F6E222C656C656D656E743A742C6C6162656C3A6F28225573652041504558206D657461206461746122292C70726F70657274793A226D616E75616C496E707574222C64656661';
wwv_flow_imp.g_varchar2_table(51992) := '756C7456616C75653A2266616C7365222C696E766572743A21302C636F6D706F6E656E743A4A557D292C723F732E70757368287B69643A226170706C69636174696F6E496454657874222C656C656D656E743A742C6C6162656C3A6F282244656661756C';
wwv_flow_imp.g_varchar2_table(51993) := '74204170706C69636174696F6E20494422292C70726F70657274793A226170706C69636174696F6E4964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A2270616765496454657874222C656C656D656E743A742C6C6162';
wwv_flow_imp.g_varchar2_table(51994) := '656C3A6F282244656661756C74205061676520494422292C70726F70657274793A22706167654964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22757365726E616D6554657874222C656C656D656E743A742C6C6162';
wwv_flow_imp.g_varchar2_table(51995) := '656C3A6F282244656661756C7420557365726E616D6522292C70726F70657274793A22757365726E616D65222C636F6D706F6E656E743A59552C69734564697465643A6F577D293A732E70757368287B69643A226170706C69636174696F6E4964222C65';
wwv_flow_imp.g_varchar2_table(51996) := '6C656D656E743A742C636F6D706F6E656E743A7A472C69734564697465643A51487D2C7B69643A22706167654964222C656C656D656E743A742C636F6D706F6E656E743A48472C69734564697465643A51487D2C7B69643A22757365726E616D65222C65';
wwv_flow_imp.g_varchar2_table(51997) := '6C656D656E743A742C636F6D706F6E656E743A57472C69734564697465643A51487D292C737D66756E6374696F6E207A472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D';
wwv_flow_imp.g_varchar2_table(51998) := '3D5777287B7D293B72657475726E206A77282828293D3E7B754B28292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D';
wwv_flow_imp.g_varchar2_table(51999) := '656E743D247B747D0A202020206C6162656C3D247B69282244656661756C74204170706C69636174696F6E22297D0A2020202070726F70657274793D6170706C69636174696F6E49640A2020202073746174653D247B6F7D0A20202F3E607D66756E6374';
wwv_flow_imp.g_varchar2_table(52000) := '696F6E2048472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C6F3D4C772874292C5B732C725D3D5777287B6C6F616465643A21317D292C7B6170706C69636174696F6E49643A617D3D';
wwv_flow_imp.g_varchar2_table(52001) := '6F3B6A77282828293D3E7B704B2861292E7468656E2828653D3E72287B76616C7565733A652C6C6F616465643A21302C6170706C69636174696F6E49643A617D2929297D292C5B615D293B636F6E7374206C3D61213D3D732E6170706C69636174696F6E';
wwv_flow_imp.g_varchar2_table(52002) := '49643B72657475726E20546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B69282244656661756C74205061676522297D0A2020202070726F70657274793D7061676549640A';
wwv_flow_imp.g_varchar2_table(52003) := '2020202073746174653D247B737D0A202020206E65656473526566726573683D247B6C7D0A20202F3E607D66756E6374696F6E2057472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C';
wwv_flow_imp.g_varchar2_table(52004) := '5B6F2C735D3D5777287B7D293B72657475726E206A77282828293D3E7B2866756E6374696F6E28297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F2822676574557365726E616D657322';
wwv_flow_imp.g_varchar2_table(52005) := '293B7661727B616A61784964656E7469666965723A657D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28652C7B7830313A22';
wwv_flow_imp.g_varchar2_table(52006) := '4745545F555345524E414D4553227D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F672822676574557365726E616D657322292C50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C7565';
wwv_flow_imp.g_varchar2_table(52007) := '3A6E756C6C7D2C7B6C6162656C3A227573657231222C76616C75653A227573657231227D2C7B6C6162656C3A227573657232222C76616C75653A227573657232227D2C7B6C6162656C3A227573657233222C76616C75653A227573657233227D5D297D29';
wwv_flow_imp.g_varchar2_table(52008) := '28292E7468656E2828653D3E73287B76616C7565733A652C6C6F616465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928224465';
wwv_flow_imp.g_varchar2_table(52009) := '6661756C7420557365726E616D6522297D0A2020202070726F70657274793D757365726E616D650A2020202073746174653D247B6F7D0A20202F3E607D766172206A473D6F2839313932293B636F6E73742071473D5B2262706D6E3A4578636C75736976';
wwv_flow_imp.g_varchar2_table(52010) := '6547617465776179222C2262706D6E3A496E636C757369766547617465776179222C2262706D6E3A436F6D706C657847617465776179225D3B66756E6374696F6E2024472865297B7661727B736F757263655265663A747D3D4C772865292C6E3D4D6174';
wwv_flow_imp.g_varchar2_table(52011) := '682E6D6178282E2E2E742E6F7574676F696E672E6D61702828653D3E652E73657175656E63657C7C302929297C7C303B72657475726E204D6174682E6D6178286E2B31302C31302A742E6F7574676F696E672E6C656E677468297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(52012) := '55472865297B636F6E73747B656C656D656E743A747D3D653B72657475726E5B7B69643A2273657175656E6365222C656C656D656E743A742C636F6D706F6E656E743A4B477D2C7B69643A226C616E6775616765222C656C656D656E743A742C636F6D70';
wwv_flow_imp.g_varchar2_table(52013) := '6F6E656E743A47472C69734564697465643A51487D2C7B69643A22636F6E646974696F6E222C656C656D656E743A742C636F6D706F6E656E743A51472C69734564697465643A65577D5D7D66756E6374696F6E204B472865297B636F6E73747B69643A74';
wwv_flow_imp.g_varchar2_table(52014) := '2C656C656D656E743A6E7D3D652C693D4C77286E292C6F3D4C5728226D6F64656C696E6722292C733D4C5728226465626F756E6365496E70757422292C723D4C5728227472616E736C61746522292C613D653D3E7B7661727B736F757263655265663A74';
wwv_flow_imp.g_varchar2_table(52015) := '7D3D692C6E3D4D6174682E6D6178282E2E2E742E6F7574676F696E672E6D61702828653D3E652E73657175656E63657C7C302929297C7C303B72657475726E204D6174682E6D6178286E2B31302C31302A742E6F7574676F696E672E6C656E677468297D';
wwv_flow_imp.g_varchar2_table(52016) := '3B72657475726E206E6577205348287B69643A742C656C656D656E743A6E2C6C6162656C3A72282253657175656E636522292C67657456616C75653A28293D3E28692E73657175656E63657C7C6F2E75706461746550726F70657274696573286E2C7B73';
wwv_flow_imp.g_varchar2_table(52017) := '657175656E63653A6128297D292C692E73657175656E6365292C73657456616C75653A653D3E7B6F2E75706461746550726F70657274696573286E2C7B73657175656E63653A657D297D2C6465626F756E63653A737D297D66756E6374696F6E20474728';
wwv_flow_imp.g_varchar2_table(52018) := '65297B636F6E73747B69643A742C656C656D656E743A6E7D3D652C693D4C5728226D6F64656C696E6722292C6F3D4C5728226465626F756E6365496E70757422292C733D4C57282262706D6E466163746F727922292C723D4C5728227472616E736C6174';
wwv_flow_imp.g_varchar2_table(52019) := '6522292C613D4C77286E292C7B636F6E646974696F6E45787072657373696F6E3A6C7D3D613B72657475726E206E6577204748287B69643A742C656C656D656E743A6E2C6C6162656C3A722822436F6E646974696F6E205479706522292C67657456616C';
wwv_flow_imp.g_varchar2_table(52020) := '75653A28293D3E6C26266C2E67657428226C616E677561676522292C73657456616C75653A653D3E7B6966286C29653F692E7570646174654D6F64646C6550726F70657274696573286E2C6C2C7B6C616E67756167653A657D293A692E7570646174654D';
wwv_flow_imp.g_varchar2_table(52021) := '6F64646C6550726F70657274696573286E2C612C7B636F6E646974696F6E45787072657373696F6E3A766F696420307D293B656C73657B636F6E737420743D732E637265617465282262706D6E3A466F726D616C45787072657373696F6E222C7B626F64';
wwv_flow_imp.g_varchar2_table(52022) := '793A6E756C6C2C6C616E67756167653A657D293B742E24706172656E743D612C692E7570646174654D6F64646C6550726F70657274696573286E2C612C7B636F6E646974696F6E45787072657373696F6E3A747D297D7D2C6765744F7074696F6E733A28';
wwv_flow_imp.g_varchar2_table(52023) := '293D3E5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A72282245787072657373696F6E22292C76616C75653A22706C73716C45787072657373696F6E227D2C7B6C6162656C3A72282246756E6374696F6E20426F647922292C';
wwv_flow_imp.g_varchar2_table(52024) := '76616C75653A22706C73716C46756E6374696F6E426F6479227D5D2C6465626F756E63653A6F7D297D66756E6374696F6E2051472865297B636F6E73747B69643A742C656C656D656E743A6E7D3D652C693D4C5728226D6F64656C696E6722292C6F3D4C';
wwv_flow_imp.g_varchar2_table(52025) := '5728227472616E736C61746522292C733D4C5728226465626F756E6365496E70757422292C723D4C57282262706D6E466163746F727922292C613D4C77286E292C7B636F6E646974696F6E45787072657373696F6E3A6C7D3D612C633D6C26266C2E6765';
wwv_flow_imp.g_varchar2_table(52026) := '7428226C616E677561676522292C643D47552822436F6E646974696F6E222C2828293D3E7B636F6E73747B636F6E646974696F6E45787072657373696F6E3A657D3D613B5555282866756E6374696F6E28297B72657475726E20652626652E6765742822';
wwv_flow_imp.g_varchar2_table(52027) := '626F647922297D292C2866756E6374696F6E2874297B652E7365742822626F6479222C74292C692E7570646174654D6F64646C6550726F70657274696573286E2C612C7B636F6E646974696F6E45787072657373696F6E3A657D297D292C22706C73716C';
wwv_flow_imp.g_varchar2_table(52028) := '222C60247B637D426F6F6C65616E602C74297D29292C683D7B706C73716C45787072657373696F6E3A6F2822504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C756522292C706C73716C46756E6374';
wwv_flow_imp.g_varchar2_table(52029) := '696F6E426F64793A6F2822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C756522297D5B635D3B696628632972657475726E5B2455286F2C74292C6E6577204A48287B69643A742C656C65';
wwv_flow_imp.g_varchar2_table(52030) := '6D656E743A6E2C6C6162656C3A642C6465736372697074696F6E3A682C67657456616C75653A28293D3E6C26266C2E6765742822626F647922292C73657456616C75653A653D3E7B6966286C296C2E7365742822626F6479222C65292C692E7570646174';
wwv_flow_imp.g_varchar2_table(52031) := '654D6F64646C6550726F70657274696573286E2C612C7B636F6E646974696F6E45787072657373696F6E3A6C7D293B656C73657B636F6E737420743D722E637265617465282262706D6E3A466F726D616C45787072657373696F6E222C7B626F64793A65';
wwv_flow_imp.g_varchar2_table(52032) := '7D293B742E24706172656E743D612C692E7570646174654D6F64646C6550726F70657274696573286E2C612C7B636F6E646974696F6E45787072657373696F6E3A747D297D7D2C6465626F756E63653A737D295D7D636F6E73742059473D6E6577206457';
wwv_flow_imp.g_varchar2_table(52033) := '2822617065783A53656E644D61696C22293B66756E6374696F6E205A472865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D4C772874292C6F3D6E2E67657428227472616E736C61746522292C733D5B5D3B696628';
wwv_flow_imp.g_varchar2_table(52034) := '2273656E644D61696C223D3D3D692E74797065297B636F6E737420653D2274727565223D3D3D692E6D616E75616C496E7075742C6E3D2274727565223D3D3D59472E676574457874656E73696F6E50726F706572747928742C2275736554656D706C6174';
wwv_flow_imp.g_varchar2_table(52035) := '6522293B732E70757368287B69643A22696D6D6564696174656C79222C656C656D656E743A742C6C6162656C3A6F282253656E6420456D61696C20496D6D6564696174656C7922292C68656C7065723A59472C70726F70657274793A22696D6D65646961';
wwv_flow_imp.g_varchar2_table(52036) := '74656C79222C64656661756C7456616C75653A2274727565222C636F6D706F6E656E743A4A557D2C7B69643A22656D61696C46726F6D222C656C656D656E743A742C6C6162656C3A6F282246726F6D22292C6465736372697074696F6E3A6F2822456D61';
wwv_flow_imp.g_varchar2_table(52037) := '696C206F66207468652073656E64657222292C68656C7065723A59472C70726F70657274793A22656D61696C46726F6D222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22656D61696C546F222C656C656D656E743A742C';
wwv_flow_imp.g_varchar2_table(52038) := '6C6162656C3A6F2822546F22292C6465736372697074696F6E3A6F2822456D61696C206F662074686520726563697069656E7428732922292C68656C7065723A59472C70726F70657274793A22656D61696C546F222C636F6D706F6E656E743A59552C69';
wwv_flow_imp.g_varchar2_table(52039) := '734564697465643A6F577D2C7B69643A22656D61696C4343222C656C656D656E743A742C6C6162656C3A6F2822434322292C6465736372697074696F6E3A6F2822436172626F6E20636F707920726563697069656E7428732922292C68656C7065723A59';
wwv_flow_imp.g_varchar2_table(52040) := '472C70726F70657274793A22656D61696C4343222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22656D61696C424343222C656C656D656E743A742C6C6162656C3A6F282242434322292C6465736372697074696F6E3A6F';
wwv_flow_imp.g_varchar2_table(52041) := '2822426C696E6420636172626F6E20636F707920726563697069656E7428732922292C68656C7065723A59472C70726F70657274793A22656D61696C424343222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22656D6169';
wwv_flow_imp.g_varchar2_table(52042) := '6C5265706C79546F222C656C656D656E743A742C6C6162656C3A6F28225265706C7920546F22292C6465736372697074696F6E3A6F2822456D61696C20776865726520746865207265706C792073686F756C642062652073656E6420746F22292C68656C';
wwv_flow_imp.g_varchar2_table(52043) := '7065723A59472C70726F70657274793A22656D61696C5265706C79546F222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A2275736554656D706C617465222C656C656D656E743A742C6C6162656C3A6F2822557365205465';
wwv_flow_imp.g_varchar2_table(52044) := '6D706C61746522292C68656C7065723A59472C70726F70657274793A2275736554656D706C617465222C64656661756C7456616C75653A2266616C7365222C636C65616E75703A653D3E287B2E2E2E21303D3D3D6526267B7375626A6563743A6E756C6C';
wwv_flow_imp.g_varchar2_table(52045) := '2C626F6479546578743A6E756C6C2C626F647948544D4C3A6E756C6C7D2C2E2E2E21313D3D3D6526267B6170706C69636174696F6E49643A6E756C6C2C74656D706C61746549643A6E756C6C2C706C616365686F6C6465723A6E756C6C7D7D292C636F6D';
wwv_flow_imp.g_varchar2_table(52046) := '706F6E656E743A4A557D292C6E3F28732E70757368287B69643A22696E70757453656C656374696F6E222C656C656D656E743A742C6C6162656C3A6F28225573652041504558206D657461206461746122292C70726F70657274793A226D616E75616C49';
wwv_flow_imp.g_varchar2_table(52047) := '6E707574222C64656661756C7456616C75653A2266616C7365222C696E766572743A21302C636F6D706F6E656E743A4A557D292C653F732E70757368287B69643A226170706C69636174696F6E496454657874222C656C656D656E743A742C6C6162656C';
wwv_flow_imp.g_varchar2_table(52048) := '3A6F28224170706C69636174696F6E20494422292C68656C7065723A59472C70726F70657274793A226170706C69636174696F6E4964222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A2274656D706C6174654964546578';
wwv_flow_imp.g_varchar2_table(52049) := '74222C656C656D656E743A742C6C6162656C3A6F282254656D706C61746520494422292C68656C7065723A59472C70726F70657274793A2274656D706C6174654964222C636F6D706F6E656E743A59552C69734564697465643A6F577D293A732E707573';
wwv_flow_imp.g_varchar2_table(52050) := '68287B69643A226170706C69636174696F6E4964222C656C656D656E743A742C636F6D706F6E656E743A58472C69734564697465643A51487D2C7B69643A2274656D706C6174654964222C656C656D656E743A742C636F6D706F6E656E743A4A472C6973';
wwv_flow_imp.g_varchar2_table(52051) := '4564697465643A51487D292C732E70757368287B69643A22706C616365686F6C646572222C656C656D656E743A742C6C6162656C3A6F2822506C616365686F6C64657222292C6465736372697074696F6E3A6F282250726F766964652076616C75657320';
wwv_flow_imp.g_varchar2_table(52052) := '666F7220656D61696C2074656D706C61746522292C68656C7065723A59472C70726F70657274793A22706C616365686F6C646572222C6C616E67756167653A226A736F6E222C636F6D706F6E656E743A744B2C69734564697465643A65577D2C7B656C65';
wwv_flow_imp.g_varchar2_table(52053) := '6D656E743A742C636F6D706F6E656E743A65517D29293A732E70757368287B69643A227375626A656374222C656C656D656E743A742C6C6162656C3A6F28225375626A65637422292C68656C7065723A59472C70726F70657274793A227375626A656374';
wwv_flow_imp.g_varchar2_table(52054) := '222C636F6D706F6E656E743A59552C69734564697465643A6F577D2C7B69643A22626F647954657874222C656C656D656E743A742C6C6162656C3A6F2822426F6479205465787422292C6465736372697074696F6E3A6F2822456D61696C20636F6E7465';
wwv_flow_imp.g_varchar2_table(52055) := '6E7422292C68656C7065723A59472C70726F70657274793A22626F647954657874222C6C616E67756167653A22706C61696E74657874222C636F6D706F6E656E743A744B2C69734564697465643A65577D2C7B69643A22626F647948544D4C222C656C65';
wwv_flow_imp.g_varchar2_table(52056) := '6D656E743A742C6C6162656C3A6F2822426F64792048544D4C22292C6465736372697074696F6E3A6F282248544D4C2076657273696F6E206F662074686520656D61696C22292C68656C7065723A59472C70726F70657274793A22626F647948544D4C22';
wwv_flow_imp.g_varchar2_table(52057) := '2C6C616E67756167653A2268746D6C222C636F6D706F6E656E743A744B2C69734564697465643A65577D292C732E70757368287B69643A226174746163686D656E74222C656C656D656E743A742C6C6162656C3A6F28224174746163686D656E7422292C';
wwv_flow_imp.g_varchar2_table(52058) := '6465736372697074696F6E3A6F282253514C20717565727920746F20676574206174746163686D656E7422292C68656C7065723A59472C70726F70657274793A226174746163686D656E74222C6C616E67756167653A2273716C222C636F6D706F6E656E';
wwv_flow_imp.g_varchar2_table(52059) := '743A744B2C69734564697465643A65577D297D72657475726E20737D66756E6374696F6E2058472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C61746522292C5B6F2C735D3D5777287B7D293B7265';
wwv_flow_imp.g_varchar2_table(52060) := '7475726E206A77282828293D3E7B2866756E6374696F6E28297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275672E696E666F28226765744170706C69636174696F6E734D61696C22293B7661727B616A';
wwv_flow_imp.g_varchar2_table(52061) := '61784964656E7469666965723A657D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28652C7B7830313A224745545F4150504C';
wwv_flow_imp.g_varchar2_table(52062) := '49434154494F4E535F4D41494C227D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728226765744170706C69636174696F6E734D61696C22292C50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22';
wwv_flow_imp.g_varchar2_table(52063) := '222C76616C75653A6E756C6C7D2C7B6C6162656C3A2231202D20414D31222C76616C75653A2231227D2C7B6C6162656C3A2232202D20414D32222C76616C75653A2232227D5D297D2928292E7468656E2828653D3E73287B76616C7565733A652C6C6F61';
wwv_flow_imp.g_varchar2_table(52064) := '6465643A21307D2929297D292C5B5D292C546C603C247B58557D0A2020202069643D247B6E7D0A20202020656C656D656E743D247B747D0A202020206C6162656C3D247B6928224170706C69636174696F6E22297D0A2020202068656C7065723D247B59';
wwv_flow_imp.g_varchar2_table(52065) := '477D0A2020202070726F70657274793D6170706C69636174696F6E49640A2020202073746174653D247B6F7D0A20202F3E607D66756E6374696F6E204A472865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E';
wwv_flow_imp.g_varchar2_table(52066) := '736C61746522292C5B6F2C735D3D5777287B7D292C723D59472E676574457874656E73696F6E50726F706572747928742C226170706C69636174696F6E496422293B6A77282828293D3E7B2866756E6374696F6E2865297B69662822756E646566696E65';
wwv_flow_imp.g_varchar2_table(52067) := '6422213D747970656F662061706578297B617065782E64656275672E696E666F282267657454656D706C6174657322293B7661727B616A61784964656E7469666965723A747D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C';
wwv_flow_imp.g_varchar2_table(52068) := '657228226F7074696F6E22293B72657475726E20617065782E7365727665722E706C7567696E28742C7B7830313A224745545F54454D504C41544553222C7830323A657D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C65';
wwv_flow_imp.g_varchar2_table(52069) := '2E6C6F67282267657454656D706C6174657322292C2231223D3D3D653F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A2241315431222C76616C75653A2241315431227D2C7B6C6162';
wwv_flow_imp.g_varchar2_table(52070) := '656C3A2241315432222C76616C75653A2241315432227D5D293A2232223D3D3D653F50726F6D6973652E7265736F6C7665285B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A2241325431222C76616C75653A2241325431227D';
wwv_flow_imp.g_varchar2_table(52071) := '2C7B6C6162656C3A2241325432222C76616C75653A2241325432227D2C7B6C6162656C3A2241325433222C76616C75653A2241325433227D5D293A50726F6D6973652E7265736F6C7665285B5D297D292872292E7468656E2828653D3E73287B76616C75';
wwv_flow_imp.g_varchar2_table(52072) := '65733A652C6C6F616465643A21302C6170706C69636174696F6E49643A727D2929297D292C5B725D293B636F6E737420613D72213D3D6F2E6170706C69636174696F6E49643B72657475726E20546C603C247B58557D0A2020202069643D247B6E7D0A20';
wwv_flow_imp.g_varchar2_table(52073) := '202020656C656D656E743D247B747D0A202020206C6162656C3D247B69282254656D706C61746522297D0A2020202068656C7065723D247B59477D0A2020202070726F70657274793D74656D706C61746549640A2020202073746174653D247B6F7D0A20';
wwv_flow_imp.g_varchar2_table(52074) := '2020206E65656473526566726573683D247B617D0A20202F3E607D66756E6374696F6E2065512865297B636F6E73747B656C656D656E743A747D3D652C6E3D4C5728227472616E736C61746522292C693D4C57282262706D6E466163746F727922292C6F';
wwv_flow_imp.g_varchar2_table(52075) := '3D4C5728226D6F64656C696E6722292C733D59472E676574457874656E73696F6E50726F706572747928742C226170706C69636174696F6E496422292C723D59472E676574457874656E73696F6E50726F706572747928742C2274656D706C6174654964';
wwv_flow_imp.g_varchar2_table(52076) := '22293B72657475726E20664B287B746578743A6E28224C6F6164204A534F4E22292C68616E646C65723A28293D3E7B2866756E6374696F6E28652C74297B69662822756E646566696E656422213D747970656F662061706578297B617065782E64656275';
wwv_flow_imp.g_varchar2_table(52077) := '672E696E666F28226765744A534F4E506C616365686F6C6465727322293B7661727B616A61784964656E7469666965723A6E7D3D617065782E6A51756572792822236D6F64656C657222292E6D6F64656C657228226F7074696F6E22293B72657475726E';
wwv_flow_imp.g_varchar2_table(52078) := '20617065782E7365727665722E706C7567696E286E2C7B7830313A224745545F4A534F4E5F504C414345484F4C44455253222C7830323A652C7830333A747D2C7B7D292E7468656E2828653D3E6529297D72657475726E20636F6E736F6C652E6C6F6728';
wwv_flow_imp.g_varchar2_table(52079) := '226765744A534F4E506C616365686F6C6465727322292C2231223D3D3D6526262241315431223D3D3D743F50726F6D6973652E7265736F6C7665287B50313A6E756C6C2C50323A6E756C6C7D293A50726F6D6973652E7265736F6C7665287B7D297D2928';
wwv_flow_imp.g_varchar2_table(52080) := '732C72292E7468656E2828653D3E7B59472E736574457874656E73696F6E50726F706572747928742C6F2C692C7B706C616365686F6C6465723A4A534F4E2E737472696E6769667928652C6E756C6C2C31297D297D29297D7D297D636F6E73742074513D';
wwv_flow_imp.g_varchar2_table(52081) := '6E65772064572822617065783A437573746F6D457874656E73696F6E22293B66756E6374696F6E206E512865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D6E2E67657428227472616E736C61746522293B726574';
wwv_flow_imp.g_varchar2_table(52082) := '75726E5B7B69643A22637573746F6D457874656E73696F6E222C656C656D656E743A742C6C6162656C3A692822437573746F6D20457874656E73696F6E22292C6465736372697074696F6E3A692822456E74657220637573746F6D20657874656E73696F';
wwv_flow_imp.g_varchar2_table(52083) := '6E73206173204A534F4E22292C68656C7065723A74512C70726F70657274793A22637573746F6D457874656E73696F6E222C6C616E67756167653A226A736F6E222C636F6D706F6E656E743A744B2C69734564697465643A65577D5D7D7661722069513D';
wwv_flow_imp.g_varchar2_table(52084) := '6F2839313932292C6F513D6F28363033293B636F6E73742073513D6E65772064572822617065783A456E64706F696E7422292C72513D6E65772064572822617065783A4D6573736167654E616D6522292C61513D6E65772064572822617065783A436F72';
wwv_flow_imp.g_varchar2_table(52085) := '72656C6174696F6E4B657922292C6C513D6E65772064572822617065783A436F7272656C6174696F6E56616C756522292C63513D6E65772064572822617065783A5061796C6F616422292C64513D6E65772064572822617065783A5061796C6F61645661';
wwv_flow_imp.g_varchar2_table(52086) := '726961626C6522293B66756E6374696F6E2068512865297B636F6E737420743D4C772865292E67657428226576656E74446566696E6974696F6E7322297C7C5B5D3B72657475726E206F512E66696E6428742C2866756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(52087) := '726E2069512E697328652C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22297D29297D66756E6374696F6E2075512865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D6E2E676574282274';
wwv_flow_imp.g_varchar2_table(52088) := '72616E736C61746522292C6F3D4C772874292C733D5B5D3B72657475726E28302C792E69732928742C2262706D6E3A53656E645461736B22292626215B2265786563757465506C73716C225D2E696E636C75646573286F2E74797065297C7C28302C792E';
wwv_flow_imp.g_varchar2_table(52089) := '69732928742C2262706D6E3A496E7465726D6564696174655468726F774576656E742229262668512874297C7C28302C792E69732928742C2262706D6E3A456E644576656E742229262668512874293F732E70757368287B69643A22656E64706F696E74';
wwv_flow_imp.g_varchar2_table(52090) := '222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A73512C6C6162656C3A692822456E64706F696E7422297D2C7B69643A226D6573736167654E616D65222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C';
wwv_flow_imp.g_varchar2_table(52091) := '7065723A72512C6C6162656C3A6928224D657373616765204E616D6522297D2C7B69643A22636F7272656C6174696F6E4B6579222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A61512C6C6162656C3A692822436F727265';
wwv_flow_imp.g_varchar2_table(52092) := '6C6174696F6E204B657922297D2C7B69643A22636F7272656C6174696F6E56616C7565222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A6C512C6C6162656C3A692822436F7272656C6174696F6E2056616C756522297D2C';
wwv_flow_imp.g_varchar2_table(52093) := '7B69643A227061796C6F6164222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A63512C6C6162656C3A6928225061796C6F616422297D293A2828302C792E69732928742C2262706D6E3A526563656976655461736B22297C';
wwv_flow_imp.g_varchar2_table(52094) := '7C28302C792E69732928742C2262706D6E3A496E7465726D65646961746543617463684576656E742229262668512874297C7C28302C792E69732928742C2262706D6E3A53746172744576656E742229262668512874297C7C28302C792E69732928742C';
wwv_flow_imp.g_varchar2_table(52095) := '2262706D6E3A426F756E646172794576656E74222926266851287429292626732E70757368287B69643A226D6573736167654E616D65222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A72512C6C6162656C3A6928224D65';
wwv_flow_imp.g_varchar2_table(52096) := '7373616765204E616D6522297D2C7B69643A22636F7272656C6174696F6E4B6579222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A61512C6C6162656C3A692822436F7272656C6174696F6E204B657922297D2C7B69643A';
wwv_flow_imp.g_varchar2_table(52097) := '22636F7272656C6174696F6E56616C7565222C656C656D656E743A742C636F6D706F6E656E743A70512C68656C7065723A6C512C6C6162656C3A692822436F7272656C6174696F6E2056616C756522297D2C7B69643A227061796C6F6164566172696162';
wwv_flow_imp.g_varchar2_table(52098) := '6C65222C656C656D656E743A742C6C6162656C3A6928225061796C6F6164205661726961626C6522292C636F6D706F6E656E743A67517D292C737D66756E6374696F6E2070512865297B636F6E73747B656C656D656E743A742C69643A6E2C68656C7065';
wwv_flow_imp.g_varchar2_table(52099) := '723A692C6C6162656C3A6F7D3D652C733D4C5728227472616E736C61746522292C723D68512874292C613D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A73282253746174696322292C76616C75653A22737461746963227D';
wwv_flow_imp.g_varchar2_table(52100) := '2C7B6C6162656C3A73282250726F63657373205661726961626C6522292C76616C75653A2270726F636573735661726961626C65227D2C7B6C6162656C3A73282253514C207175657279202873696E676C652076616C75652922292C76616C75653A2273';
wwv_flow_imp.g_varchar2_table(52101) := '716C517565727953696E676C65227D2C7B6C6162656C3A73282245787072657373696F6E22292C76616C75653A22706C73716C52617745787072657373696F6E227D2C7B6C6162656C3A73282246756E6374696F6E20426F647922292C76616C75653A22';
wwv_flow_imp.g_varchar2_table(52102) := '706C73716C52617746756E6374696F6E426F6479227D5D2C6C3D692E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E54797065222C72292C633D5B5D3B696628632E70757368287B69643A2265787072657373696F';
wwv_flow_imp.g_varchar2_table(52103) := '6E54797065222C656C656D656E743A742C6C6162656C3A73282245787072657373696F6E205479706522292C68656C7065723A692C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A612C636C65616E75703A653D3E';
wwv_flow_imp.g_varchar2_table(52104) := '287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51482C706172656E743A727D292C6E756C6C213D6C296966285B2273716C517565727953696E676C65222C2273716C5175';
wwv_flow_imp.g_varchar2_table(52105) := '6572794C697374222C22706C73716C52617745787072657373696F6E222C22706C73716C52617746756E6374696F6E426F6479225D2E696E636C75646573286C29297B636F6E737420653D2273716C517565727953696E676C65223D3D3D6C7C7C227371';
wwv_flow_imp.g_varchar2_table(52106) := '6C51756572794C697374223D3D3D6C3F2273716C223A22706C73716C223B632E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C6C6162656C3A73282245787072657373696F6E22292C68656C7065723A692C70726F7065';
wwv_flow_imp.g_varchar2_table(52107) := '7274793A2265787072657373696F6E222C6C616E67756167653A652C747970653A6C2C636F6D706F6E656E743A744B2C69734564697465643A65572C706172656E743A727D297D656C736520632E70757368287B69643A2265787072657373696F6E222C';
wwv_flow_imp.g_varchar2_table(52108) := '656C656D656E743A742C6C6162656C3A73282245787072657373696F6E22292C68656C7065723A692C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65572C706172656E743A727D293B72';
wwv_flow_imp.g_varchar2_table(52109) := '657475726E206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6F2C656E74726965733A637D297D66756E6374696F6E2067512865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C5728227472616E736C';
wwv_flow_imp.g_varchar2_table(52110) := '61746522292C6F3D68512874292C733D5B5D3B72657475726E20732E70757368287B69643A227061796C6F61645661726961626C65222C656C656D656E743A742C6C6162656C3A69282250726F63657373205661726961626C6522292C68656C7065723A';
wwv_flow_imp.g_varchar2_table(52111) := '64512C70726F70657274793A2276616C7565222C636F6D706F6E656E743A59552C69734564697465643A6F572C706172656E743A6F7D292C6E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A69282252657475726E205061796C6F';
wwv_flow_imp.g_varchar2_table(52112) := '616420496E746F22292C656E74726965733A737D297D66756E6374696F6E206D512865297B636F6E73747B656C656D656E743A742C696E6A6563746F723A6E7D3D652C693D6E2E67657428227472616E736C61746522292C6F3D7B2262706D6E3A496E74';
wwv_flow_imp.g_varchar2_table(52113) := '65726D6564696174655468726F774576656E74223A5B7B6C6162656C3A69282253696D706C65204D65737361676522292C76616C75653A2273696D706C654D657373616765227D5D2C2262706D6E3A496E7465726D65646961746543617463684576656E';
wwv_flow_imp.g_varchar2_table(52114) := '74223A5B7B6C6162656C3A69282253696D706C65204D65737361676522292C76616C75653A2273696D706C654D657373616765227D5D2C2262706D6E3A53746172744576656E74223A5B7B6C6162656C3A69282253696D706C65204D6573736167652229';
wwv_flow_imp.g_varchar2_table(52115) := '2C76616C75653A2273696D706C654D657373616765227D5D2C2262706D6E3A456E644576656E74223A5B7B6C6162656C3A69282253696D706C65204D65737361676522292C76616C75653A2273696D706C654D657373616765227D5D2C2262706D6E3A42';
wwv_flow_imp.g_varchar2_table(52116) := '6F756E646172794576656E74223A5B7B6C6162656C3A69282253696D706C65204D65737361676522292C76616C75653A2273696D706C654D657373616765227D5D7D3B72657475726E28302C792E69732928742C2262706D6E3A496E7465726D65646961';
wwv_flow_imp.g_varchar2_table(52117) := '74655468726F774576656E742229262668512874297C7C28302C792E69732928742C2262706D6E3A496E7465726D65646961746543617463684576656E742229262668512874297C7C28302C792E69732928742C2262706D6E3A53746172744576656E74';
wwv_flow_imp.g_varchar2_table(52118) := '2229262668512874297C7C28302C792E69732928742C2262706D6E3A456E644576656E742229262668512874297C7C28302C792E69732928742C2262706D6E3A426F756E646172794576656E742229262668512874293F5B7B69643A226576656E745479';
wwv_flow_imp.g_varchar2_table(52119) := '7065222C656C656D656E743A742C6C6162656C3A6928224576656E74205479706522292C70726F70657274793A2274797065222C64656661756C7456616C75653A7B2262706D6E3A496E7465726D6564696174655468726F774576656E74223A2273696D';
wwv_flow_imp.g_varchar2_table(52120) := '706C654D657373616765222C2262706D6E3A496E7465726D65646961746543617463684576656E74223A2273696D706C654D657373616765222C2262706D6E3A53746172744576656E74223A2273696D706C654D657373616765222C2262706D6E3A456E';
wwv_flow_imp.g_varchar2_table(52121) := '644576656E74223A2273696D706C654D657373616765222C2262706D6E3A426F756E646172794576656E74223A2273696D706C654D657373616765227D5B742E747970655D2C6F7074696F6E733A6F5B742E747970655D2C636C65616E75703A653D3E28';
wwv_flow_imp.g_varchar2_table(52122) := '7B2E2E2E216F5B742E747970655D2E736F6D652828743D3E742E76616C75653D3D3D65292926267B747970653A6E756C6C7D7D292C636F6D706F6E656E743A5A557D5D3A5B5D7D636F6E73742066513D6E65772064572822617065783A44657363726970';
wwv_flow_imp.g_varchar2_table(52123) := '74696F6E22292C76513D6E65772064572822617065783A496E707574436F6C6C656374696F6E22292C62513D6E65772064572822617065783A4F7574707574436F6C6C656374696F6E22292C5F513D6E65772064572822617065783A436F6D706C657469';
wwv_flow_imp.g_varchar2_table(52124) := '6F6E436F6E646974696F6E22293B66756E6374696F6E2079512865297B636F6E737420743D4C772865292C7B6C6F6F704368617261637465726973746963733A6E7D3D743B72657475726E206E7D66756E6374696F6E2077512865297B636F6E73747B65';
wwv_flow_imp.g_varchar2_table(52125) := '6C656D656E743A742C696E6A6563746F723A6E7D3D652C693D6E2E67657428227472616E736C61746522292C6F3D4C772874292C733D5B5D3B6966282828302C792E69732928742C2262706D6E3A5461736B22297C7C28302C792E69732928742C226270';
wwv_flow_imp.g_varchar2_table(52126) := '6D6E3A53756250726F6365737322292926266F2E6C6F6F70436861726163746572697374696373297B732E70757368287B69643A226465736372697074696F6E222C656C656D656E743A742C636F6D706F6E656E743A43512C69734564697465643A6F57';
wwv_flow_imp.g_varchar2_table(52127) := '7D293B636F6E737420653D79512874293B28302C792E69732928652C2262706D6E3A5374616E646172644C6F6F7043686172616374657269737469637322297C7C732E70757368287B69643A22696E707574436F6C6C656374696F6E222C656C656D656E';
wwv_flow_imp.g_varchar2_table(52128) := '743A742C636F6D706F6E656E743A53512C68656C7065723A76512C6C6162656C3A692822496E70757420436F6C6C656374696F6E22297D292C732E70757368287B69643A226F7574707574436F6C6C656374696F6E222C656C656D656E743A742C636F6D';
wwv_flow_imp.g_varchar2_table(52129) := '706F6E656E743A78512C68656C7065723A62512C6C6162656C3A6928224F757470757420436F6C6C656374696F6E22297D2C7B69643A22636F6D706C6574696F6E436F6E646974696F6E222C656C656D656E743A742C636F6D706F6E656E743A6B512C68';
wwv_flow_imp.g_varchar2_table(52130) := '656C7065723A5F512C6C6162656C3A692822436F6D706C6574696F6E20436F6E646974696F6E22297D297D72657475726E20737D66756E6374696F6E2043512865297B636F6E73747B656C656D656E743A742C69643A6E7D3D652C693D4C572822747261';
wwv_flow_imp.g_varchar2_table(52131) := '6E736C61746522292C6F3D79512874292C733D5B5D3B72657475726E20732E70757368287B69643A6E2C656C656D656E743A742C6C6162656C3A6928224465736372697074696F6E22292C68656C7065723A66512C70726F70657274793A2276616C7565';
wwv_flow_imp.g_varchar2_table(52132) := '222C636F6D706F6E656E743A59552C69734564697465643A6F572C706172656E743A6F7D292C6E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6928224465736372697074696F6E22292C656E74726965733A737D297D66756E63';
wwv_flow_imp.g_varchar2_table(52133) := '74696F6E2053512865297B636F6E73747B656C656D656E743A742C69643A6E2C68656C7065723A692C6C6162656C3A6F7D3D652C733D4C5728227472616E736C61746522292C723D79512874292C613D5B7B6C6162656C3A22222C76616C75653A6E756C';
wwv_flow_imp.g_varchar2_table(52134) := '6C7D2C7B6C6162656C3A73282250726F63657373205661726961626C6520284C6973742922292C76616C75653A2270726F636573735661726961626C654C697374227D2C7B6C6162656C3A73282250726F63657373205661726961626C65202841727261';
wwv_flow_imp.g_varchar2_table(52135) := '792922292C76616C75653A2270726F636573735661726961626C654172726179227D2C7B6C6162656C3A73282253514C20517565727922292C76616C75653A2273716C51756572794172726179227D5D2C6C3D692E676574457874656E73696F6E50726F';
wwv_flow_imp.g_varchar2_table(52136) := '706572747928742C2265787072657373696F6E54797065222C72292C633D5B5D3B72657475726E20632E70757368287B69643A2265787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A732822436F6C6C656374696F6E205479';
wwv_flow_imp.g_varchar2_table(52137) := '706522292C68656C7065723A692C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A612C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D2C2E2E2E226C69737422213D3D';
wwv_flow_imp.g_varchar2_table(52138) := '6526267B696E736964655661726961626C653A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51482C706172656E743A727D292C6E756C6C213D6C2626285B2273716C51756572794172726179225D2E696E636C7564657328';
wwv_flow_imp.g_varchar2_table(52139) := '6C293F632E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C6C6162656C3A73282245787072657373696F6E22292C68656C7065723A692C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A22';
wwv_flow_imp.g_varchar2_table(52140) := '73716C222C747970653A6C2C636F6D706F6E656E743A744B2C69734564697465643A65572C706172656E743A727D293A632E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C6C6162656C3A73282245787072657373696F';
wwv_flow_imp.g_varchar2_table(52141) := '6E22292C68656C7065723A692C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65572C706172656E743A727D292C2270726F636573735661726961626C654C697374223D3D3D6C2626632E';
wwv_flow_imp.g_varchar2_table(52142) := '70757368287B69643A22696E736964655661726961626C65222C656C656D656E743A742C6C6162656C3A732822496E70757420456C656D656E7422292C68656C7065723A692C70726F70657274793A22696E736964655661726961626C65222C636F6D70';
wwv_flow_imp.g_varchar2_table(52143) := '6F6E656E743A59552C69734564697465643A6F572C706172656E743A727D29292C6E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6F2C656E74726965733A637D297D66756E6374696F6E2078512865297B636F6E73747B656C65';
wwv_flow_imp.g_varchar2_table(52144) := '6D656E743A742C69643A6E2C68656C7065723A692C6C6162656C3A6F7D3D652C733D4C5728227472616E736C61746522292C723D79512874292C613D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A73282250726F63657373';
wwv_flow_imp.g_varchar2_table(52145) := '205661726961626C65202841727261792922292C76616C75653A2270726F636573735661726961626C654172726179227D5D2C6C3D692E676574457874656E73696F6E50726F706572747928742C2265787072657373696F6E54797065222C72292C633D';
wwv_flow_imp.g_varchar2_table(52146) := '5B5D3B72657475726E20632E70757368287B69643A2265787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A732822436F6C6C656374696F6E205479706522292C68656C7065723A692C70726F70657274793A22657870726573';
wwv_flow_imp.g_varchar2_table(52147) := '73696F6E54797065222C6F7074696F6E733A612C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C69734564697465643A51482C706172656E743A727D292C6E756C6C';
wwv_flow_imp.g_varchar2_table(52148) := '213D6C2626285B5D2E696E636C75646573286C293F632E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C6C6162656C3A73282245787072657373696F6E22292C68656C7065723A692C70726F70657274793A2265787072';
wwv_flow_imp.g_varchar2_table(52149) := '657373696F6E222C6C616E67756167653A2273716C222C747970653A6C2C636F6D706F6E656E743A744B2C69734564697465643A65572C706172656E743A727D293A632E70757368287B69643A2265787072657373696F6E222C656C656D656E743A742C';
wwv_flow_imp.g_varchar2_table(52150) := '6C6162656C3A73282245787072657373696F6E22292C68656C7065723A692C70726F70657274793A2265787072657373696F6E222C636F6D706F6E656E743A654B2C69734564697465643A65572C706172656E743A727D29292C632E70757368287B6964';
wwv_flow_imp.g_varchar2_table(52151) := '3A22696E736964655661726961626C65222C656C656D656E743A742C6C6162656C3A7328224F757470757420456C656D656E7422292C68656C7065723A692C70726F70657274793A22696E736964655661726961626C65222C636F6D706F6E656E743A59';
wwv_flow_imp.g_varchar2_table(52152) := '552C69734564697465643A6F572C706172656E743A727D292C6E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6F2C656E74726965733A637D297D66756E6374696F6E206B512865297B636F6E73747B656C656D656E743A742C69';
wwv_flow_imp.g_varchar2_table(52153) := '643A6E2C68656C7065723A692C6C6162656C3A6F7D3D652C733D4C5728227472616E736C61746522292C723D79512874292C613D5B7B6C6162656C3A22222C76616C75653A6E756C6C7D2C7B6C6162656C3A73282245787072657373696F6E22292C7661';
wwv_flow_imp.g_varchar2_table(52154) := '6C75653A22706C73716C45787072657373696F6E227D2C7B6C6162656C3A73282246756E6374696F6E20426F647922292C76616C75653A22706C73716C46756E6374696F6E426F6479227D5D2C6C3D692E676574457874656E73696F6E50726F70657274';
wwv_flow_imp.g_varchar2_table(52155) := '7928742C2265787072657373696F6E54797065222C72292C633D5B5D3B696628632E70757368287B69643A2265787072657373696F6E54797065222C656C656D656E743A742C6C6162656C3A732822436F6E646974696F6E205479706522292C68656C70';
wwv_flow_imp.g_varchar2_table(52156) := '65723A692C70726F70657274793A2265787072657373696F6E54797065222C6F7074696F6E733A612C636C65616E75703A653D3E287B2E2E2E216526267B65787072657373696F6E3A6E756C6C7D7D292C636F6D706F6E656E743A5A552C697345646974';
wwv_flow_imp.g_varchar2_table(52157) := '65643A51482C706172656E743A727D292C6E756C6C213D6C297B636F6E737420653D7B706C73716C45787072657373696F6E3A732822504C2F53514C2045787072657373696F6E2072657475726E696E67206120626F6F6C65616E2076616C756522292C';
wwv_flow_imp.g_varchar2_table(52158) := '706C73716C46756E6374696F6E426F64793A732822504C2F53514C2046756E6374696F6E20426F64792072657475726E696E67206120626F6F6C65616E2076616C756522297D5B6C5D3B632E70757368287B69643A2265787072657373696F6E222C656C';
wwv_flow_imp.g_varchar2_table(52159) := '656D656E743A742C6C6162656C3A732822436F6E646974696F6E22292C6465736372697074696F6E3A652C68656C7065723A692C70726F70657274793A2265787072657373696F6E222C6C616E67756167653A22706C73716C222C747970653A60247B6C';
wwv_flow_imp.g_varchar2_table(52160) := '7D426F6F6C65616E602C636F6D706F6E656E743A744B2C69734564697465643A65572C706172656E743A727D297D72657475726E206E6577205648287B69643A6E2C656C656D656E743A742C6C6162656C3A6F2C656E74726965733A637D297D7661727B';
wwv_flow_imp.g_varchar2_table(52161) := '69733A45517D3D6F2839313932292C4C513D6F2839313932293B7661722044513D6F2839383832293B66756E6374696F6E20545128652C742C6E2C69297B72657475726E7B69643A742C6C6162656C3A6E2C656E74726965733A692865297D7D66756E63';
wwv_flow_imp.g_varchar2_table(52162) := '74696F6E20495128652C742C6E2C692C6F2C732C72297B2166756E6374696F6E28297B636F6E737420653D6A5528222E63616E76617322292C743D6A5528222E70726F706572746965732D70616E656C2D706172656E7422293B766172206E3B66756E63';
wwv_flow_imp.g_varchar2_table(52163) := '74696F6E20692869297B766172206F3D6E2D692E782C733D742E7363726F6C6C57696474682B6F2C723D7061727365496E7428676574436F6D70757465645374796C6528652C2222292E77696474682C3130292F3130302A7061727365496E7428676574';
wwv_flow_imp.g_varchar2_table(52164) := '436F6D70757465645374796C652874292E6D617857696474682C3130293B6E3D692E782C733E3D7061727365496E7428676574436F6D70757465645374796C652874292E6D696E57696474682C3130292626733C72262628742E7374796C652E77696474';
wwv_flow_imp.g_varchar2_table(52165) := '683D60247B737D7078602C742E66697273744368696C642E7374796C652E77696474683D60247B737D707860297D646F63756D656E742E6164644576656E744C697374656E657228226D6F757365646F776E222C2866756E6374696F6E2865297B652E6F';
wwv_flow_imp.g_varchar2_table(52166) := '6666736574583C352626286E3D652E782C646F63756D656E742E6164644576656E744C697374656E657228226D6F7573656D6F7665222C692C213129297D29292C646F63756D656E742E6164644576656E744C697374656E657228226D6F757365757022';
wwv_flow_imp.g_varchar2_table(52167) := '2C2866756E6374696F6E28297B646F63756D656E742E72656D6F76654576656E744C697374656E657228226D6F7573656D6F7665222C692C2131297D29297D28292C6E2E6F6E282273617665584D4C2E7374617274222C2866756E6374696F6E28297B21';
wwv_flow_imp.g_varchar2_table(52168) := '66756E6374696F6E28652C74297B766172206E3D4F626A6563742E76616C75657328652E5F656C656D656E7473292E6D61702828653D3E652E656C656D656E7429293B6E2E666F72456163682828653D3E7B766172206E2C692C6F2C733D4C772865292C';
wwv_flow_imp.g_varchar2_table(52169) := '723D5B5D2C613D5B5D3B226C6162656C22213D3D652E74797065262628723D66756E6374696F6E2865297B72657475726E20455128652C2262706D6E3A4578636C75736976654761746577617922297C7C455128652C2262706D6E3A506172616C6C656C';
wwv_flow_imp.g_varchar2_table(52170) := '4761746577617922297C7C455128652C2262706D6E3A496E636C75736976654761746577617922297C7C455128652C2262706D6E3A4576656E7442617365644761746577617922293F66756E6374696F6E2865297B72657475726E20313D3D3D652E696E';
wwv_flow_imp.g_varchar2_table(52171) := '636F6D696E672E6C656E6774682626652E6F7574676F696E672E6C656E6774683E313F5B22617065783A4265666F726553706C6974225D3A652E696E636F6D696E672E6C656E6774683E312626313D3D3D652E6F7574676F696E672E6C656E6774683F5B';
wwv_flow_imp.g_varchar2_table(52172) := '22617065783A41667465724D65726765225D3A652E696E636F6D696E672E6C656E6774683E312626652E6F7574676F696E672E6C656E6774683E313F5B22617065783A41667465724D65726765222C22617065783A4265666F726553706C6974225D3A5B';
wwv_flow_imp.g_varchar2_table(52173) := '5D7D2865293A455128652C2262706D6E3A53746172744576656E7422297C7C455128652C2262706D6E3A496E7465726D6564696174655468726F774576656E7422297C7C455128652C2262706D6E3A496E7465726D65646961746543617463684576656E';
wwv_flow_imp.g_varchar2_table(52174) := '7422297C7C455128652C2262706D6E3A426F756E646172794576656E7422297C7C455128652C2262706D6E3A456E644576656E7422293F66756E6374696F6E2865297B76617220743D5B5D2C6E3D4C772865293B696628742E707573682822617065783A';
wwv_flow_imp.g_varchar2_table(52175) := '4F6E4576656E7422292C6E2E6576656E74446566696E6974696F6E7326266E2E6576656E74446566696E6974696F6E735B305D296966284551286E2E6576656E74446566696E6974696F6E735B305D2C2262706D6E3A54696D65724576656E7444656669';
wwv_flow_imp.g_varchar2_table(52176) := '6E6974696F6E22292973776974636828742E707573682822617065783A4265666F72654576656E7422292C6E2E6576656E74446566696E6974696F6E735B305D2E74696D657254797065297B63617365226F7261636C6544617465223A742E7075736828';
wwv_flow_imp.g_varchar2_table(52177) := '22617065783A4F7261636C654461746522293B627265616B3B63617365226F7261636C654475726174696F6E223A742E707573682822617065783A4F7261636C654475726174696F6E22293B627265616B3B63617365226F7261636C654379636C65223A';
wwv_flow_imp.g_varchar2_table(52178) := '742E707573682822617065783A4F7261636C654379636C6522297D656C7365204551286E2E6576656E74446566696E6974696F6E735B305D2C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E2229262628455128652C2262706D6E';
wwv_flow_imp.g_varchar2_table(52179) := '3A496E7465726D6564696174655468726F774576656E7422297C7C455128652C2262706D6E3A456E644576656E7422293F28742E707573682822617065783A456E64706F696E7422292C742E707573682822617065783A4D6573736167654E616D652229';
wwv_flow_imp.g_varchar2_table(52180) := '2C742E707573682822617065783A436F7272656C6174696F6E4B657922292C742E707573682822617065783A436F7272656C6174696F6E56616C756522292C742E707573682822617065783A5061796C6F61642229293A28455128652C2262706D6E3A49';
wwv_flow_imp.g_varchar2_table(52181) := '6E7465726D65646961746543617463684576656E7422297C7C455128652C2262706D6E3A53746172744576656E7422297C7C455128652C2262706D6E3A426F756E646172794576656E74222929262628742E707573682822617065783A4D657373616765';
wwv_flow_imp.g_varchar2_table(52182) := '4E616D6522292C742E707573682822617065783A436F7272656C6174696F6E4B657922292C742E707573682822617065783A436F7272656C6174696F6E56616C756522292C742E707573682822617065783A5061796C6F61645661726961626C65222929';
wwv_flow_imp.g_varchar2_table(52183) := '293B72657475726E20747D2865293A455128652C2262706D6E3A5461736B22293F66756E6374696F6E2865297B76617220743D5B5D2C6E3D4C772865293B6966286E2E6C6F6F704368617261637465726973746963737C7C28742E707573682822617065';
wwv_flow_imp.g_varchar2_table(52184) := '783A4265666F72655461736B22292C742E707573682822617065783A41667465725461736B2229292C455128652C2262706D6E3A557365725461736B22292973776974636828742E707573682822617065783A506F74656E7469616C557365727322292C';
wwv_flow_imp.g_varchar2_table(52185) := '742E707573682822617065783A506F74656E7469616C47726F75707322292C742E707573682822617065783A4578636C75646564557365727322292C742E707573682822617065783A5072696F7269747922292C742E707573682822617065783A447565';
wwv_flow_imp.g_varchar2_table(52186) := '4F6E22292C6E2E74797065297B63617365226170657850616765223A742E707573682822617065783A417065785061676522293B627265616B3B636173652261706578417070726F76616C223A742E707573682822617065783A41706578417070726F76';
wwv_flow_imp.g_varchar2_table(52187) := '616C22293B627265616B3B63617365226170657853696D706C65466F726D223A742E707573682822617065783A4170657853696D706C65466F726D22297D656C736520696628455128652C2262706D6E3A5363726970745461736B222929742E70757368';
wwv_flow_imp.g_varchar2_table(52188) := '2822617065783A45786563757465506C73716C22293B656C736520696628455128652C2262706D6E3A536572766963655461736B222929737769746368286E2E74797065297B636173652265786563757465506C73716C223A742E707573682822617065';
wwv_flow_imp.g_varchar2_table(52189) := '783A45786563757465506C73716C22293B627265616B3B636173652273656E644D61696C223A742E707573682822617065783A53656E644D61696C22297D656C736520696628455128652C2262706D6E3A427573696E65737352756C655461736B222929';
wwv_flow_imp.g_varchar2_table(52190) := '742E707573682822617065783A45786563757465506C73716C22293B656C736520696628455128652C2262706D6E3A53656E645461736B222929737769746368286E2E74797065297B636173652265786563757465506C73716C223A742E707573682822';
wwv_flow_imp.g_varchar2_table(52191) := '617065783A45786563757465506C73716C22293B627265616B3B636173652273696D706C654D657373616765223A742E707573682822617065783A456E64706F696E7422292C742E707573682822617065783A4D6573736167654E616D6522292C742E70';
wwv_flow_imp.g_varchar2_table(52192) := '7573682822617065783A436F7272656C6174696F6E4B657922292C742E707573682822617065783A436F7272656C6174696F6E56616C756522292C742E707573682822617065783A5061796C6F616422297D656C736520696628455128652C2262706D6E';
wwv_flow_imp.g_varchar2_table(52193) := '3A526563656976655461736B222929737769746368286E2E74797065297B636173652265786563757465506C73716C223A742E707573682822617065783A45786563757465506C73716C22293B627265616B3B636173652273696D706C654D6573736167';
wwv_flow_imp.g_varchar2_table(52194) := '65223A742E707573682822617065783A4D6573736167654E616D6522292C742E707573682822617065783A436F7272656C6174696F6E4B657922292C742E707573682822617065783A436F7272656C6174696F6E56616C756522292C742E707573682822';
wwv_flow_imp.g_varchar2_table(52195) := '617065783A5061796C6F61645661726961626C6522297D72657475726E20747D2865293A455128652C2262706D6E3A43616C6C416374697669747922293F2828743D5B5D292E707573682822617065783A496E5661726961626C657322292C742E707573';
wwv_flow_imp.g_varchar2_table(52196) := '682822617065783A4F75745661726961626C657322292C74293A455128652C2262706D6E3A50726F6365737322297C7C455128652C2262706D6E3A5061727469636970616E7422293F66756E6374696F6E2865297B76617220743D5B5D2C6E3D4C772865';
wwv_flow_imp.g_varchar2_table(52197) := '293B72657475726E20742E707573682822617065783A5072696F7269747922292C742E707573682822617065783A4475654F6E22292C2274727565223D3D3D6E2E697343616C6C61626C65262628742E707573682822617065783A496E5661726961626C';
wwv_flow_imp.g_varchar2_table(52198) := '657322292C742E707573682822617065783A4F75745661726961626C65732229292C2274727565223D3D3D6E2E6973537461727461626C65262628742E707573682822617065783A506F74656E7469616C5374617274696E67557365727322292C742E70';
wwv_flow_imp.g_varchar2_table(52199) := '7573682822617065783A506F74656E7469616C5374617274696E6747726F75707322292C742E707573682822617065783A4578636C756465645374617274696E6755736572732229292C747D2865293A5B5D3B76617220747D2865292C722E7075736828';
wwv_flow_imp.g_varchar2_table(52200) := '22617065783A437573746F6D457874656E73696F6E22292C6E3D732E6576656E74446566696E6974696F6E732626732E6576656E74446566696E6974696F6E735B305D2C287B6C6F6F704368617261637465726973746963733A697D3D73292C6F3D732E';
wwv_flow_imp.g_varchar2_table(52201) := '657874656E73696F6E456C656D656E74732626732E657874656E73696F6E456C656D656E74732E76616C7565732626732E657874656E73696F6E456C656D656E74732E76616C7565732E66696C7465722828653D3E21722E696E636C7564657328652E24';
wwv_flow_imp.g_varchar2_table(52202) := '747970652929292C6F26266F2E6C656E6774683E3026266F2E666F724561636828286E3D3E7B457728652C732C6E2C74297D29292C6E2626286F3D6E2E657874656E73696F6E456C656D656E747326266E2E657874656E73696F6E456C656D656E74732E';
wwv_flow_imp.g_varchar2_table(52203) := '76616C75657326266E2E657874656E73696F6E456C656D656E74732E76616C7565732E66696C7465722828653D3E21722E696E636C7564657328652E24747970652929292C6F26266F2E6C656E6774683E3026266F2E666F72456163682828693D3E7B45';
wwv_flow_imp.g_varchar2_table(52204) := '7728652C6E2C692C74297D2929292C69262628723D66756E6374696F6E2865297B76617220743D5B5D3B72657475726E20742E707573682822617065783A4465736372697074696F6E22292C742E707573682822617065783A4F7574707574436F6C6C65';
wwv_flow_imp.g_varchar2_table(52205) := '6374696F6E22292C742E707573682822617065783A436F6D706C6574696F6E436F6E646974696F6E22292C455128652C2262706D6E3A5374616E646172644C6F6F7043686172616374657269737469637322297C7C742E707573682822617065783A496E';
wwv_flow_imp.g_varchar2_table(52206) := '707574436F6C6C656374696F6E22292C747D2869292C6F3D692E657874656E73696F6E456C656D656E74732626692E657874656E73696F6E456C656D656E74732E76616C7565732626692E657874656E73696F6E456C656D656E74732E76616C7565732E';
wwv_flow_imp.g_varchar2_table(52207) := '66696C7465722828653D3E21722E696E636C7564657328652E24747970652929292C6F26266F2E6C656E6774683E3026266F2E666F724561636828286E3D3E7B457728652C692C6E2C74297D2929292C613D66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(52208) := '5B5D3B72657475726E204C512E6973416E7928652C5B2262706D6E3A557365725461736B222C2262706D6E3A536572766963655461736B222C2262706D6E3A5363726970745461736B222C2262706D6E3A427573696E65737352756C655461736B222C22';
wwv_flow_imp.g_varchar2_table(52209) := '62706D6E3A53656E645461736B222C2262706D6E3A526563656976655461736B225D297C7C455128652C2262706D6E3A496E7465726D6564696174655468726F774576656E742229262668512865297C7C455128652C2262706D6E3A496E7465726D6564';
wwv_flow_imp.g_varchar2_table(52210) := '6961746543617463684576656E742229262668512865297C7C455128652C2262706D6E3A53746172744576656E742229262668512865297C7C455128652C2262706D6E3A456E644576656E742229262668512865297C7C455128652C2262706D6E3A426F';
wwv_flow_imp.g_varchar2_table(52211) := '756E646172794576656E742229262668512865297C7C742E707573682822617065783A7479706522292C455128652C2262706D6E3A43616C6C416374697669747922297C7C455128652C2262706D6E3A50726F6365737322297C7C455128652C2262706D';
wwv_flow_imp.g_varchar2_table(52212) := '6E3A557365725461736B22292626226170657850616765223D3D3D4C772865292E747970657C7C455128652C2262706D6E3A557365725461736B222926262261706578417070726F76616C223D3D3D4C772865292E747970657C7C455128652C2262706D';
wwv_flow_imp.g_varchar2_table(52213) := '6E3A557365725461736B22292626226170657853696D706C65466F726D223D3D3D4C772865292E747970657C7C455128652C2262706D6E3A536572766963655461736B222926262273656E644D61696C223D3D3D4C772865292E747970657C7C742E7075';
wwv_flow_imp.g_varchar2_table(52214) := '73682822617065783A6D616E75616C496E70757422292C747D2865292C612626612E6C656E6774683E302626612E666F724561636828286E3D3E7B21732E6973496D706C696369742626732E676574286E292626742E7570646174654D6F64646C655072';
wwv_flow_imp.g_varchar2_table(52215) := '6F7065727469657328652C732C7B5B6E5D3A6E756C6C7D297D2929297D29297D286F2C69297D29292C6E2E6F6E2822636F6D6D616E64537461636B2E636F6E6E656374696F6E2E6372656174652E706F737445786563757465222C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(52216) := '2865297B2166756E6374696F6E28652C74297B766172206E2C693D4C772865293B6A472E697328652C2262706D6E3A53657175656E6365466C6F7722292626286E3D652E736F757263652C6A472E6973416E79286E2C714729292626692E736F75726365';
wwv_flow_imp.g_varchar2_table(52217) := '526566262621692E73657175656E63652626742E75706461746550726F7065727469657328652C7B73657175656E63653A24472865297D297D28652E636F6E746578742E636F6E6E656374696F6E2C69297D29292C746869732E67657447726F7570733D';
wwv_flow_imp.g_varchar2_table(52218) := '66756E6374696F6E2865297B72657475726E2066756E6374696F6E286E297B636F6E737420693D5B5D2C6F3D4C772865293B6C657420613B6F2E6C6F6F7043686172616374657269737469637326262828302C792E697329286F2E6C6F6F704368617261';
wwv_flow_imp.g_varchar2_table(52219) := '637465726973746963732C2262706D6E3A4D756C7469496E7374616E63654C6F6F704368617261637465726973746963732229262628613D7328224D756C74692D496E7374616E63652229292C28302C792E697329286F2E6C6F6F704368617261637465';
wwv_flow_imp.g_varchar2_table(52220) := '726973746963732C2262706D6E3A5374616E646172644C6F6F704368617261637465726973746963732229262628613D7328224C6F6F70222929292C28302C792E69732928652C2262706D6E3A5461736B222926262144512E6973416E7928652C5B2262';
wwv_flow_imp.g_varchar2_table(52221) := '706D6E3A557365725461736B222C2262706D6E3A5363726970745461736B222C2262706D6E3A536572766963655461736B222C2262706D6E3A427573696E65737352756C655461736B222C2262706D6E3A53656E645461736B222C2262706D6E3A526563';
wwv_flow_imp.g_varchar2_table(52222) := '656976655461736B225D29262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B2929';
wwv_flow_imp.g_varchar2_table(52223) := '2C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C77512929292C28302C792E69732928652C2262706D6E3A557365725461736B2229262628692E70757368285451';
wwv_flow_imp.g_varchar2_table(52224) := '287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C227461736B54797065222C7328225461736B205479706522292C4B4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C74';
wwv_flow_imp.g_varchar2_table(52225) := '72616E736C6174653A737D2C226170657850616765222C73282241504558205061676522292C4C4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2261706578417070726F7661';
wwv_flow_imp.g_varchar2_table(52226) := '6C222C7328224150455820417070726F76616C22292C4F4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2273696D706C65466F726D222C732822415045582053696D706C6520';
wwv_flow_imp.g_varchar2_table(52227) := '466F726D22292C484B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B29292C69';
wwv_flow_imp.g_varchar2_table(52228) := '2E70757368285451287B656C656D656E743A652C7472616E736C6174653A737D2C2261737369676E6D656E74222C73282241737369676E6D656E7422292C674729292C692E70757368285451287B656C656D656E743A652C7472616E736C6174653A737D';
wwv_flow_imp.g_varchar2_table(52229) := '2C227363686564756C696E67222C7328225363686564756C696E6722292C534729292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C77512929292C28302C792E';
wwv_flow_imp.g_varchar2_table(52230) := '69732928652C2262706D6E3A5363726970745461736B2229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C227461736B54797065222C7328225461736B205479706522292C4B4B';
wwv_flow_imp.g_varchar2_table(52231) := '29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2265786563757465506C73716C222C732822504C2F53514C22292C6F4B29292C692E70757368285451287B656C656D656E743A65';
wwv_flow_imp.g_varchar2_table(52232) := '2C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C74';
wwv_flow_imp.g_varchar2_table(52233) := '72616E736C6174653A737D2C226C6F6F70222C612C77512929292C28302C792E69732928652C2262706D6E3A536572766963655461736B2229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174';
wwv_flow_imp.g_varchar2_table(52234) := '653A737D2C227461736B54797065222C7328225461736B205479706522292C4B4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2265786563757465506C73716C222C73282250';
wwv_flow_imp.g_varchar2_table(52235) := '4C2F53514C22292C6F4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2273656E644D61696C222C7328224D61696C22292C5A4729292C692E70757368285451287B656C656D65';
wwv_flow_imp.g_varchar2_table(52236) := '6E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F72';
wwv_flow_imp.g_varchar2_table(52237) := '3A742C7472616E736C6174653A737D2C226C6F6F70222C612C77512929292C28302C792E69732928652C2262706D6E3A427573696E65737352756C655461736B2229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A74';
wwv_flow_imp.g_varchar2_table(52238) := '2C7472616E736C6174653A737D2C227461736B54797065222C7328225461736B205479706522292C4B4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2265786563757465506C';
wwv_flow_imp.g_varchar2_table(52239) := '73716C222C732822504C2F53514C22292C6F4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E';
wwv_flow_imp.g_varchar2_table(52240) := '7322292C624B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C77512929292C28302C792E69732928652C2262706D6E3A53656E645461736B222926262869';
wwv_flow_imp.g_varchar2_table(52241) := '2E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C227461736B54797065222C7328225461736B205479706522292C4B4B29292C692E70757368285451287B656C656D656E743A652C696E6A65';
wwv_flow_imp.g_varchar2_table(52242) := '63746F723A742C7472616E736C6174653A737D2C2265786563757465506C73716C222C732822504C2F53514C22292C6F4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C227369';
wwv_flow_imp.g_varchar2_table(52243) := '6D706C654D657373616765222C73282253696D706C65204D65737361676522292C755129292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C732822566172';
wwv_flow_imp.g_varchar2_table(52244) := '6961626C652045787072657373696F6E7322292C624B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C77512929292C28302C792E69732928652C2262706D';
wwv_flow_imp.g_varchar2_table(52245) := '6E3A526563656976655461736B2229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C227461736B54797065222C7328225461736B205479706522292C4B4B29292C692E70757368';
wwv_flow_imp.g_varchar2_table(52246) := '285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2265786563757465506C73716C222C732822504C2F53514C22292C6F4B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F72';
wwv_flow_imp.g_varchar2_table(52247) := '3A742C7472616E736C6174653A737D2C2273696D706C654D657373616765222C73282253696D706C65204D65737361676522292C755129292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A73';
wwv_flow_imp.g_varchar2_table(52248) := '7D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B29292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C7751';
wwv_flow_imp.g_varchar2_table(52249) := '2929292C28302C792E69732928652C2262706D6E3A4D616E75616C5461736B22292626692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C775129292C28302C792E69';
wwv_flow_imp.g_varchar2_table(52250) := '732928652C2262706D6E3A43616C6C41637469766974792229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2263616C6C4163746976697479222C73282243616C6C6564204469';
wwv_flow_imp.g_varchar2_table(52251) := '616772616D22292C454729292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C732822496E2F4F7574204D617070696E6722292C624B2929292C2828302C79';
wwv_flow_imp.g_varchar2_table(52252) := '2E69732928652C2262706D6E3A50726F6365737322297C7C28302C792E697329284C772865292C2262706D6E3A50726F63657373222929262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A';
wwv_flow_imp.g_varchar2_table(52253) := '737D2C22657865637574696F6E222C732822457865637574696F6E22292C624729292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C732822496E2F4F7574';
wwv_flow_imp.g_varchar2_table(52254) := '205661726961626C657322292C624B29292C692E70757368285451287B656C656D656E743A652C7472616E736C6174653A737D2C2273746172746572222C732822506F74656E7469616C20537461727465727322292C4D4729292C692E70757368285451';
wwv_flow_imp.g_varchar2_table(52255) := '287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226261636B67726F756E645461736B53657373696F6E222C7328224261636B67726F756E64205461736B2053657373696F6E22292C564729292C692E70757368';
wwv_flow_imp.g_varchar2_table(52256) := '285451287B656C656D656E743A652C7472616E736C6174653A737D2C227363686564756C696E67222C7328225363686564756C696E6722292C53472929292C28302C792E69732928652C2262706D6E3A53756250726F6365737322292626692E70757368';
wwv_flow_imp.g_varchar2_table(52257) := '285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C226C6F6F70222C612C775129292C2828302C792E69732928652C2262706D6E3A496E7465726D65646961746543617463684576656E7422297C7C28302C';
wwv_flow_imp.g_varchar2_table(52258) := '792E69732928652C2262706D6E3A496E7465726D6564696174655468726F774576656E7422297C7C28302C792E69732928652C2262706D6E3A426F756E646172794576656E74222929262628692E70757368285451287B656C656D656E743A652C696E6A';
wwv_flow_imp.g_varchar2_table(52259) := '6563746F723A742C7472616E736C6174653A737D2C226576656E7454797065222C7328224576656E74205479706522292C6D5129292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C22';
wwv_flow_imp.g_varchar2_table(52260) := '73696D706C654D657373616765222C73282253696D706C65204D65737361676522292C75512929292C28302C792E69732928652C2262706D6E3A4C616E6522292626692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472';
wwv_flow_imp.g_varchar2_table(52261) := '616E736C6174653A737D2C22726F6C65222C7328224150455820526F6C6522292C5F4729292C28302C792E69732928652C2262706D6E3A4761746577617922292626692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472';
wwv_flow_imp.g_varchar2_table(52262) := '616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B29292C28302C792E69732928652C2262706D6E3A53657175656E6365466C6F7722292626692E70757368285451287B656C65';
wwv_flow_imp.g_varchar2_table(52263) := '6D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C22636F6E646974696F6E222C732822436F6E646974696F6E22292C554729292C692E70757368285451287B656C656D656E743A652C7472616E736C6174653A737D2C226375';
wwv_flow_imp.g_varchar2_table(52264) := '73746F6D54696D6572222C73282254696D657222292C654729292C28302C792E69732928652C2262706D6E3A53746172744576656E742229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C617465';
wwv_flow_imp.g_varchar2_table(52265) := '3A737D2C226576656E7454797065222C7328224576656E74205479706522292C6D5129292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2273696D706C654D657373616765222C7328';
wwv_flow_imp.g_varchar2_table(52266) := '2253696D706C65204D65737361676522292C75512929292C28302C792E69732928652C2262706D6E3A456E644576656E742229262628692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C22';
wwv_flow_imp.g_varchar2_table(52267) := '6576656E7454797065222C7328224576656E74205479706522292C6D5129292C692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2273696D706C654D657373616765222C73282253696D70';
wwv_flow_imp.g_varchar2_table(52268) := '6C65204D65737361676522292C755129292C692E70757368285451287B656C656D656E743A652C7472616E736C6174653A737D2C22637573746F6D5465726D696E617465222C73282244657461696C7322292C46472929292C28302C792E69732928652C';
wwv_flow_imp.g_varchar2_table(52269) := '2262706D6E3A4576656E7422292626692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C2270726F6356617273222C7328225661726961626C652045787072657373696F6E7322292C624B29';
wwv_flow_imp.g_varchar2_table(52270) := '292C722626692E70757368285451287B656C656D656E743A652C696E6A6563746F723A742C7472616E736C6174653A737D2C22637573746F6D222C732822437573746F6D22292C6E5129292C692E666F72456163682828653D3E7B766F69642030213D3D';
wwv_flow_imp.g_varchar2_table(52271) := '652E656E74726965732626652E656E74726965732E6C656E6774683E3026266E2E707573682865297D29293B636F6E7374206C3D5B2274696D6572222C226D657373616765222C226D756C7469496E7374616E6365225D3B72657475726E206E3D6E2E66';
wwv_flow_imp.g_varchar2_table(52272) := '696C7465722828653D3E216C2E696E636C7564657328652E69642929292C6E7D7D2C652E726567697374657250726F7669646572283530302C74686973297D49512E24696E6A6563743D5B2270726F7065727469657350616E656C222C22696E6A656374';
wwv_flow_imp.g_varchar2_table(52273) := '6F72222C226576656E74427573222C226D6F64656C696E67222C22656C656D656E745265676973747279222C227472616E736C617465222C22636F6E6669672E73686F77437573746F6D457874656E73696F6E73225D3B636F6E7374204D513D7B5F5F69';
wwv_flow_imp.g_varchar2_table(52274) := '6E69745F5F3A5B2270726F7065727469657350726F7669646572225D2C70726F7065727469657350726F76696465723A5B2274797065222C49515D7D3B66756E6374696F6E20415128652C742C6E2C692C6F2C732C722C612C6C2C632C64297B74686973';
wwv_flow_imp.g_varchar2_table(52275) := '2E5F70616C657474653D652C746869732E5F6372656174653D742C746869732E5F656C656D656E74466163746F72793D6E2C746869732E5F7370616365546F6F6C3D692C746869732E5F6C6173736F546F6F6C3D6F2C746869732E5F68616E64546F6F6C';
wwv_flow_imp.g_varchar2_table(52276) := '3D732C746869732E5F676C6F62616C436F6E6E6563743D722C746869732E5F7472616E736C6174653D612C746869732E5F636F6D6D616E64537461636B3D6C2C746869732E5F6576656E744275733D632C746869732E5F63616E7661733D642C652E7265';
wwv_flow_imp.g_varchar2_table(52277) := '67697374657250726F76696465722874686973297D41512E24696E6A6563743D5B2270616C65747465222C22637265617465222C22656C656D656E74466163746F7279222C227370616365546F6F6C222C226C6173736F546F6F6C222C2268616E64546F';
wwv_flow_imp.g_varchar2_table(52278) := '6F6C222C22676C6F62616C436F6E6E656374222C227472616E736C617465222C22636F6D6D616E64537461636B222C226576656E74427573222C2263616E766173225D2C41512E70726F746F747970652E67657450616C65747465456E74726965733D66';
wwv_flow_imp.g_varchar2_table(52279) := '756E6374696F6E2865297B76617220743D7B7D2C6E3D746869732E5F6372656174652C6F3D746869732E5F656C656D656E74466163746F72792C733D746869732E5F7370616365546F6F6C2C723D746869732E5F6C6173736F546F6F6C2C613D74686973';
wwv_flow_imp.g_varchar2_table(52280) := '2E5F68616E64546F6F6C2C6C3D746869732E5F676C6F62616C436F6E6E6563742C633D746869732E5F7472616E736C6174652C643D746869732E5F636F6D6D616E64537461636B2C683D6E6577207861287B7D2C746869732E5F6576656E744275732C74';
wwv_flow_imp.g_varchar2_table(52281) := '6869732E5F63616E766173293B66756E6374696F6E207528652C742C732C722C61297B66756E6374696F6E206C2874297B76617220733D6F2E63726561746553686170652828302C692E6B7029287B747970653A657D2C6129293B61262628732E627573';
wwv_flow_imp.g_varchar2_table(52282) := '696E6573734F626A6563742E64692E6973457870616E6465643D612E6973457870616E646564292C6E2E737461727428742C73297D76617220643D652E7265706C616365282F5E62706D6E3A2F2C2222293B72657475726E7B67726F75703A742C636C61';
wwv_flow_imp.g_varchar2_table(52283) := '73734E616D653A732C7469746C653A727C7C632822437265617465207B747970657D222C7B747970653A647D292C616374696F6E3A7B6472616773746172743A6C2C636C69636B3A6C7D7D7D66756E6374696F6E20702865297B76617220743D6F2E6372';
wwv_flow_imp.g_varchar2_table(52284) := '656174655368617065287B747970653A2262706D6E3A53756250726F63657373222C783A302C793A302C6973457870616E6465643A21307D292C693D6F2E6372656174655368617065287B747970653A2262706D6E3A53746172744576656E74222C783A';
wwv_flow_imp.g_varchar2_table(52285) := '34302C793A38322C706172656E743A747D293B6E2E737461727428652C5B742C695D2C7B68696E74733A7B6175746F53656C6563743A5B695D7D7D297D66756E6374696F6E20672865297B6E2E737461727428652C6F2E63726561746550617274696369';
wwv_flow_imp.g_varchar2_table(52286) := '70616E7453686170652829297D72657475726E28302C692E6B702928742C7B2268616E642D746F6F6C223A7B67726F75703A22746F6F6C73222C636C6173734E616D653A2262706D6E2D69636F6E2D68616E642D746F6F6C222C7469746C653A63282241';
wwv_flow_imp.g_varchar2_table(52287) := '63746976617465207468652068616E6420746F6F6C22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E616374697661746548616E642865297D7D7D2C226C6173736F2D746F6F6C223A7B67726F75703A22746F6F6C73222C63';
wwv_flow_imp.g_varchar2_table(52288) := '6C6173734E616D653A2262706D6E2D69636F6E2D6C6173736F2D746F6F6C222C7469746C653A632822416374697661746520746865206C6173736F20746F6F6C22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B722E6163746976';
wwv_flow_imp.g_varchar2_table(52289) := '61746553656C656374696F6E2865297D7D7D2C2273706163652D746F6F6C223A7B67726F75703A22746F6F6C73222C636C6173734E616D653A2262706D6E2D69636F6E2D73706163652D746F6F6C222C7469746C653A6328224163746976617465207468';
wwv_flow_imp.g_varchar2_table(52290) := '65206372656174652F72656D6F766520737061636520746F6F6C22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B732E616374697661746553656C656374696F6E2865297D7D7D2C22676C6F62616C2D636F6E6E6563742D746F6F';
wwv_flow_imp.g_varchar2_table(52291) := '6C223A7B67726F75703A22746F6F6C73222C636C6173734E616D653A2262706D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C7469222C7469746C653A63282241637469766174652074686520676C6F62616C20636F6E6E65637420746F6F6C2229';
wwv_flow_imp.g_varchar2_table(52292) := '2C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B6C2E73746172742865297D7D7D2C22746F6F6C2D736570617261746F72223A7B67726F75703A22746F6F6C73222C736570617261746F723A21307D2C756E646F3A7B67726F75703A22';
wwv_flow_imp.g_varchar2_table(52293) := '636F6E74726F6C73222C636C6173734E616D653A2266612066612D756E646F2D6172726F77222C7469746C653A632822556E646F22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B642E756E646F28297D7D7D2C7265646F3A7B67';
wwv_flow_imp.g_varchar2_table(52294) := '726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7265646F2D6172726F77222C7469746C653A6328225265646F22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B642E7265646F28297D7D7D2C22';
wwv_flow_imp.g_varchar2_table(52295) := '7A6F6F6D2D696E223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7365617263682D706C7573222C7469746C653A6328225A6F6F6D20496E22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(52296) := '297B682E7A6F6F6D28312C30297D7D7D2C227A6F6F6D2D6F7574223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7365617263682D6D696E7573222C7469746C653A6328225A6F6F6D204F757422292C616374';
wwv_flow_imp.g_varchar2_table(52297) := '696F6E3A7B636C69636B3A66756E6374696F6E2865297B682E7A6F6F6D282D312C30297D7D7D2C22636F6E74726F6C732D736570617261746F72223A7B67726F75703A22636F6E74726F6C73222C736570617261746F723A21307D2C226372656174652E';
wwv_flow_imp.g_varchar2_table(52298) := '73746172742D6576656E74223A75282262706D6E3A53746172744576656E74222C226576656E74222C2262706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E65222C6328224372656174652053746172744576656E742229292C226372656174';
wwv_flow_imp.g_varchar2_table(52299) := '652E696E7465726D6564696174652D6576656E74223A75282262706D6E3A496E7465726D6564696174655468726F774576656E74222C226576656E74222C2262706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E65222C6328';
wwv_flow_imp.g_varchar2_table(52300) := '2243726561746520496E7465726D6564696174652F426F756E64617279204576656E742229292C226372656174652E656E642D6576656E74223A75282262706D6E3A456E644576656E74222C226576656E74222C2262706D6E2D69636F6E2D656E642D65';
wwv_flow_imp.g_varchar2_table(52301) := '76656E742D6E6F6E65222C63282243726561746520456E644576656E742229292C226372656174652E6578636C75736976652D67617465776179223A75282262706D6E3A4578636C757369766547617465776179222C2267617465776179222C2262706D';
wwv_flow_imp.g_varchar2_table(52302) := '6E2D69636F6E2D676174657761792D6E6F6E65222C63282243726561746520476174657761792229292C226372656174652E7461736B223A75282262706D6E3A5461736B222C226163746976697479222C2262706D6E2D69636F6E2D7461736B222C6328';
wwv_flow_imp.g_varchar2_table(52303) := '22437265617465205461736B2229292C226372656174652E646174612D6F626A656374223A75282262706D6E3A446174614F626A6563745265666572656E6365222C22646174612D6F626A656374222C2262706D6E2D69636F6E2D646174612D6F626A65';
wwv_flow_imp.g_varchar2_table(52304) := '6374222C63282243726561746520446174614F626A6563745265666572656E63652229292C226372656174652E646174612D73746F7265223A75282262706D6E3A4461746153746F72655265666572656E6365222C22646174612D73746F7265222C2262';
wwv_flow_imp.g_varchar2_table(52305) := '706D6E2D69636F6E2D646174612D73746F7265222C632822437265617465204461746153746F72655265666572656E63652229292C226372656174652E73756270726F636573732D657870616E646564223A7B67726F75703A226163746976697479222C';
wwv_flow_imp.g_varchar2_table(52306) := '636C6173734E616D653A2262706D6E2D69636F6E2D73756270726F636573732D657870616E646564222C7469746C653A63282243726561746520657870616E6465642053756250726F6365737322292C616374696F6E3A7B6472616773746172743A702C';
wwv_flow_imp.g_varchar2_table(52307) := '636C69636B3A707D7D2C226372656174652E7061727469636970616E742D657870616E646564223A7B67726F75703A22636F6C6C61626F726174696F6E222C636C6173734E616D653A2262706D6E2D69636F6E2D7061727469636970616E74222C746974';
wwv_flow_imp.g_varchar2_table(52308) := '6C653A63282243726561746520506F6F6C2F5061727469636970616E7422292C616374696F6E3A7B6472616773746172743A672C636C69636B3A677D7D2C226372656174652E67726F7570223A75282262706D6E3A47726F7570222C2261727469666163';
wwv_flow_imp.g_varchar2_table(52309) := '74222C2262706D6E2D69636F6E2D67726F7570222C6328224372656174652047726F75702229297D292C747D3B636F6E7374204E513D7B5F5F696E69745F5F3A5B2270616C6574746550726F7669646572225D2C70616C6574746550726F76696465723A';
wwv_flow_imp.g_varchar2_table(52310) := '5B2274797065222C41515D7D3B66756E6374696F6E20505128652C74297B652E6F6E282273617665584D4C2E7374617274222C3265332C2866756E6374696F6E28297B76617220653D742E676574526F6F74456C656D656E747328293B28302C692E6A4A';
wwv_flow_imp.g_varchar2_table(52311) := '2928652C2866756E6374696F6E2865297B76617220742C6E2C6F3D28302C792E6765744469292865293B743D6C74285B655D2C2131292C743D28302C692E70622928742C2866756E6374696F6E2874297B72657475726E2074213D3D65262621742E6C61';
wwv_flow_imp.g_varchar2_table(52312) := '62656C5461726765747D29292C6E3D28302C692E546A2928742C792E6765744469292C652E6973496D706C696369747C7C6F2E7365742822706C616E65456C656D656E74222C6E297D29297D29297D50512E24696E6A6563743D5B226576656E74427573';
wwv_flow_imp.g_varchar2_table(52313) := '222C2263616E766173225D3B636F6E7374204F513D7B5F5F696E69745F5F3A5B2262706D6E44694F72646572696E67225D2C62706D6E44694F72646572696E673A5B2274797065222C50515D7D3B66756E6374696F6E20525128652C74297B636F6E7374';
wwv_flow_imp.g_varchar2_table(52314) := '206E3D746869733B652E6F6E2822726F6F742E6164646564222C2866756E6374696F6E2865297B2262706D6E3A436F6C6C61626F726174696F6E223D3D3D652E656C656D656E742E747970652626286E2E63616E63656C3D2130297D29292C652E6F6E28';
wwv_flow_imp.g_varchar2_table(52315) := '22726F6F742E736574222C2866756E6374696F6E28297B6E2E63616E63656C3F6E2E63616E63656C3D21313A742E7A6F6F6D28226669742D76696577706F7274222C226175746F22297D29297D52512E70726F746F747970652E63616E63656C3D21312C';
wwv_flow_imp.g_varchar2_table(52316) := '52512E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E73742046513D7B5F5F696E69745F5F3A5B226472696C6C646F776E43656E746572696E67225D2C6472696C6C646F776E43656E746572696E673A5B2274797065';
wwv_flow_imp.g_varchar2_table(52317) := '222C52515D7D2C42513D6F2835323537292C56513D7B7D3B42512E6B65797328292E666F72456163682828653D3E7B636F6E737420743D652E7265706C616365282F285C2E5C2F7C5C2E6A736F6E292F672C2222293B56515B745D3D42512865297D2929';
wwv_flow_imp.g_varchar2_table(52318) := '3B636F6E7374207A513D56513B66756E6374696F6E20485128297B7D48512E70726F746F747970652E6170706C795472616E736C6174696F6E3D66756E6374696F6E28297B76617220653B72657475726E20766F69642030213D3D77696E646F772E6634';
wwv_flow_imp.g_varchar2_table(52319) := '61262628653D7A515B77696E646F772E6634612E6C616E67756167655D292C28742C6E293D3E286E3D6E7C7C7B7D2C766F69642030213D3D65262628743D655B745D7C7C74292C742E7265706C616365282F7B285B5E7D5D2B297D2F672C2866756E6374';
wwv_flow_imp.g_varchar2_table(52320) := '696F6E28652C74297B72657475726E206E5B745D7C7C607B247B747D7D607D2929297D3B636F6E73742057513D7B5F5F696E69745F5F3A5B227472616E736C6174696F6E4D6F64756C65225D2C7472616E736C6174696F6E4D6F64756C653A5B22747970';
wwv_flow_imp.g_varchar2_table(52321) := '65222C48515D2C7472616E736C6174653A5B2276616C7565222C48512E70726F746F747970652E6170706C795472616E736C6174696F6E28295D7D3B66756E6374696F6E206A5128652C742C6E297B746869732E616464437573746F6D4E616D65737061';
wwv_flow_imp.g_varchar2_table(52322) := '63653D66756E6374696F6E2865297B636F6E737420743D286E657720444F4D506172736572292E706172736546726F6D537472696E6728652C22746578742F786D6C22293B7661725B6E5D3D742E676574456C656D656E747342795461674E616D652822';
wwv_flow_imp.g_varchar2_table(52323) := '62706D6E3A646566696E6974696F6E7322293B72657475726E206E26266E2E7365744174747269627574652822786D6C6E733A61706578222C2268747470733A2F2F666C6F7773666F72617065782E6F726722292C286E657720584D4C53657269616C69';
wwv_flow_imp.g_varchar2_table(52324) := '7A6572292E73657269616C697A65546F537472696E672874297D2C746869732E616464546F5356475374796C653D66756E6374696F6E28652C74297B636F6E7374206E3D286E657720444F4D506172736572292E706172736546726F6D537472696E6728';
wwv_flow_imp.g_varchar2_table(52325) := '652C22746578742F786D6C22293B76617220692C6F2C732C5B725D3D6E2E676574456C656D656E747342795461674E616D6528226465667322293B72657475726E20727C7C285B695D3D6E2E676574456C656D656E747342795461674E616D6528227376';
wwv_flow_imp.g_varchar2_table(52326) := '6722292C723D646F63756D656E742E637265617465456C656D656E7428226465667322292C692E617070656E644368696C64287229292C286F3D646F63756D656E742E637265617465456C656D656E7428227374796C652229292E736574417474726962';
wwv_flow_imp.g_varchar2_table(52327) := '757465282274797065222C22746578742F63737322292C733D646F63756D656E742E637265617465546578744E6F64652874292C6F2E617070656E644368696C642873292C722E617070656E644368696C64286F292C286E657720584D4C53657269616C';
wwv_flow_imp.g_varchar2_table(52328) := '697A6572292E73657269616C697A65546F537472696E67286E297D2C746869732E7265666163746F72456C656D656E74733D66756E6374696F6E28297B6E2E676574416C6C28292E666F724561636828286E3D3E7B69662828302C792E697329286E2C22';
wwv_flow_imp.g_varchar2_table(52329) := '62706D6E3A557365725461736B222926262261706578417070726F76616C223D3D3D4C77286E292E74797065297B636F6E737420693D6E65772064572822617065783A5072696F7269747922292C6F3D6E65772064572822617065783A41706578417070';
wwv_flow_imp.g_varchar2_table(52330) := '726F76616C22292C733D6F2E676574457874656E73696F6E50726F7065727479286E2C227072696F7269747922293B732626286F2E736574457874656E73696F6E50726F7065727479286E2C742C652C7B7072696F726974793A6E756C6C7D292C692E67';
wwv_flow_imp.g_varchar2_table(52331) := '6574457874656E73696F6E50726F7065727479286E2C2265787072657373696F6E22297C7C692E736574457874656E73696F6E50726F7065727479286E2C742C652C7B65787072657373696F6E547970653A22706C73716C52617745787072657373696F';
wwv_flow_imp.g_varchar2_table(52332) := '6E222C65787072657373696F6E3A737D29297D7D29297D7D6A512E24696E6A6563743D5B2262706D6E466163746F7279222C226D6F64656C696E67222C22656C656D656E745265676973747279225D3B636F6E73742071513D7B4D6F64656C65723A7979';
wwv_flow_imp.g_varchar2_table(52333) := '2C6C696E74696E673A7B617065784C696E74696E673A5F777D2C637573746F6D4D6F64756C65733A7B42706D6E50726F7065727469657350616E656C4D6F64756C653A24712C42706D6E50726F7065727469657350726F76696465724D6F64756C653A41';
wwv_flow_imp.g_varchar2_table(52334) := '552C70726F7065727469657350726F76696465724D6F64756C653A4D512C4164644578706F727465723A742C6C696E744D6F64756C653A542C637573746F6D50616C6574746550726F76696465724D6F64756C653A4E512C7472616E736C6174696F6E4D';
wwv_flow_imp.g_varchar2_table(52335) := '6F64756C653A57512C786D6C4D6F64756C653A7B5F5F696E69745F5F3A5B22786D6C4D6F64756C65225D2C786D6C4D6F64756C653A5B2274797065222C6A515D7D2C6472696C6C646F776E43656E746572696E673A46512C62706D6E44694F7264657269';
wwv_flow_imp.g_varchar2_table(52336) := '6E673A4F512C636F6C6F725069636B65724D6F64756C653A4F7D2C6D6F64646C65457874656E73696F6E733A7B617065784D6F64646C6544657363726970746F723A79777D7D7D2928292C62706D6E4D6F64656C65723D732E64656661756C747D292829';
wwv_flow_imp.g_varchar2_table(52337) := '3B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5452033929537773)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'js/flows4apex.modeler.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '40666F6E742D66616365207B0A2020666F6E742D66616D696C793A202762706D6E273B0A20207372633A2075726C28272E2E2F666F6E742F62706D6E2E656F743F313634303632383927293B0A20207372633A2075726C28272E2E2F666F6E742F62706D';
wwv_flow_imp.g_varchar2_table(2) := '6E2E656F743F3136343036323839236965666978272920666F726D61742827656D6265646465642D6F70656E7479706527292C0A2020202020202075726C28272E2E2F666F6E742F62706D6E2E7376673F31363430363238392362706D6E272920666F72';
wwv_flow_imp.g_varchar2_table(3) := '6D6174282773766727293B0A2020666F6E742D7765696768743A206E6F726D616C3B0A2020666F6E742D7374796C653A206E6F726D616C3B0A7D0A40666F6E742D66616365207B0A2020666F6E742D66616D696C793A202762706D6E273B0A2020737263';
wwv_flow_imp.g_varchar2_table(4) := '3A2075726C2827646174613A6170706C69636174696F6E2F6F637465742D73747265616D3B6261736536342C643039475267414241414141414436454141734141414141756B414141514141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(5) := '4141424855315643414141424341414141447341414142554949736C656B39544C7A49414141464541414141524141414147412B4A45733059323168634141414159674141414A794141414864464E316C2F686E62486C6D414141442F4141414E446341';
wwv_flow_imp.g_varchar2_table(6) := '414B4873755444364647686C5957514141446730414141414D4141414144596A42794A766147686C595141414F47514141414162414141414A4163384137396F625852344141413467414141414245414141477770654141414778765932454141446955';
wwv_flow_imp.g_varchar2_table(7) := '4141414132674141414E72765539455362574634634141414F58414141414166414141414941475742485A755957316C414141356B4141414156494141414939656A68316C584276633351414144726B414141446E674141436967512B4E7937654A786A';
wwv_flow_imp.g_varchar2_table(8) := '59475267594F42694D4743775932427963664D4A5965444C53537A4A5935426959474741414A41384D7073784A7A4D396B5945447867504B735942704469426D673467434143593742556741654A786A5947462B77546942675A574267616D4B61513844';
wwv_flow_imp.g_varchar2_table(9) := '41304D5068475A3877474449794151555A57426C5A73414B41744A635578674F76474238385A4135364838575178547A476F5A70514746474645564D414C586344645A346E4F585652314A555551434634622B6851614A497A6B6D554A45457941674A4B';
wwv_flow_imp.g_varchar2_table(10) := '52736C5273704C746262494579776B4D59485A336F6666306361524C454F716A344E337A4E393346413441734944507169704B5163555969666B62694946354E704B396E6B70652B6E6B7A30784B394C654247765A4952454B4171393454616B776C3134';
wwv_flow_imp.g_varchar2_table(11) := '43452B2F666B47386C677A466F533939375434383674706662346E596C39444F42542F53377A2F54317A4C694979626A4D386E6D47546E6B78752B5854774746504B636F66726669574A5253526A6B5656464A464E545855556B63394454545352444D76';
wwv_flow_imp.g_varchar2_table(12) := '6165455672326D6C4C5435324235323869632B376D783536655573662F517777794244446A44444B4F3859595A344C3354444C464E422F347941797A7A444850416F73737363776E507250434B6D75737338456D5732797A7779353737504F4641773435';
wwv_flow_imp.g_varchar2_table(13) := '34706754546A6E6A4B3938346A362F6F6B69757575654757373654697938722B3539582F663238462B704256397565726C4F3452303730566B685A2F2F6F517330373059736B33335933686D756B39446A71487A5845506E6559624F3877326446356A75';
wwv_flow_imp.g_varchar2_table(14) := '3331426F3650793536646D46496B506E7859624F537779646C31713846776C6C6872626C687259566872615668725A5668726256687259316872613168725A31687262316872594E6872614E68725A4E6872624E6872597644573162444731664764712B';
wwv_flow_imp.g_varchar2_table(15) := '4E7252744E6252744D3752744E3754744D4C54744E4C523959326A625A576A6262576A6259326A62612F7162452F6F4D6266734E6251634D625163742F693454686778317734613645555064714B48756E6146757A464133627169624D4E53394E39524E';
wwv_flow_imp.g_varchar2_table(16) := '4775716D4448585468726F506872715068726F5A513932736F57374F5544647671467377314330613670594D64637547756B2B4775732B477568564433617168627331517432366F327A445562527271746778313234613648555064727146757A314333';
wwv_flow_imp.g_varchar2_table(17) := '62366A37597167374D4E51644775714F4448584868726F54513932706F65374D555066565550664E55486475714C7377314630613671344D6464654775687444336132684C6D576F757A505533527671486778316A78622F487843656A4E5276524D4A44';
wwv_flow_imp.g_varchar2_table(18) := '4C414141654A7A7466516D63484D56316431645633393354505664337A387A75334C737A732B66634D337449753674377462707672533751775357774D4C633568496D4E7751675A38414632754D5268726868384148456334786748766A695959447432';
wwv_flow_imp.g_varchar2_table(19) := '59755059354C4E6A7833627746544279386E3138327546373154327A75354A5731344C457A34366D70362F7136757171563639652F642B723139554D787A427666593330343138795455776E6B3265476D43554D672F69456F4B4577676F315A6A426371';
wwv_flow_imp.g_varchar2_table(20) := '715377716C314C7056444B52546E494A33764A46454132752B6971705A4A78725179547553795131524D4D48554A70306F3959454C78412B6775776F36416D6C6C5A6546783256426B5046374A5547514875556B3376437143326F2F6C5856555143345A';
wwv_flow_imp.g_varchar2_table(21) := '66554E323453476B4B625766317359515161532F746D30527771714F4F374858644D48576854545A6A5742766565424D783739456D426842715166724C70654F71334C49547A4236535666477669653556426D334B2B35385455436652313631396A5646';
wwv_flow_imp.g_varchar2_table(22) := '7733344644636F306A6472664B6E36734B57684939544945796E346E2B524A4A4D4737477A38794363696345785073745A42617171464A4B6F35516734646145546F776B72464653704F73674B644D3153354B776F763236557473717932696645715562';
wwv_flow_imp.g_varchar2_table(23) := '4F46463064455074717470563647714D57594B6559324744434D732B527A636D65316751536441556F67636C4D32416E634D505078794D5A33464753596E676F782B336B71365146366A44504C47544F5A4B356B396B427055674A5046394D7972516971';
wwv_flow_imp.g_varchar2_table(24) := '447542714A64324E30716C304D6956554C427071386C444471585133584B6B4F494B736533376B4549526A6964694D6E726D44613134414A30716B4B524B2F416D63554C706C57314B6C5549684B42556D74635273416F4E457977687A5174702B784A36';
wwv_flow_imp.g_varchar2_table(25) := '34344B7A7473366172616A5647544E584C667572746575765838627A6B6559726C69316652777A333973326A66544E4561656241304D4E504C316D2B49325A59765430506E4C46787A597043476245744C62506D726C7879372B43736557776B4E694E33';
wwv_flow_imp.g_varchar2_table(26) := '7A657A6C497773364F6845614868686174474276736549332F4F6E307A4A476D634E3937657972746E627375366F756B43734857664B43394D35687244525A537654323753686465564C366F5A6151303067715853414A58796873325837447069777448';
wwv_flow_imp.g_varchar2_table(27) := '4D686D6C4F587A4670306333726C70315136614E77336D537A3631617533333934304E7A2B7430646E62632B74575A303974796C4853535858625A793436726C53797339626E6472727244336759574C43783235484F35736E7A2B79664E484E6E566C42';
wwv_flow_imp.g_varchar2_table(28) := '7968664C38326266316A387A30584668704F2B69536B396E2B363733396F5670566E4C427A765A4148724A43656E6F764C4F3243724C5243566C726745734E346F4E346574506D50514230717A464C6D59655941476B5366514B2F6A476668612F427A68';
wwv_flow_imp.g_varchar2_table(29) := '7943627947506B444F77693136596C37754B4A514E654A6C79354E5043724159734F71434557574C31664846476C384775584B57533661545A566A54566C4C6E6F7346426C764A747567784C4D6F7667442F743075583445782F5355486B4F494534564C';
wwv_flow_imp.g_varchar2_table(30) := '3674694168794344376D48525566334550714448546867326F6C78784D466A4F73764638306D6B753743483569664A326C6E41794B394563305A78427974684F673659467964756C6767524A30724366417345303254413075437A686F41516D54525A4B';
wwv_flow_imp.g_varchar2_table(31) := '415A6B5736595A4E316774417977515A48793853686F4A43356A6B6A615765626269326A434374646F684A4E412B4B6B783566712B4A4A6C4F5A703977624A76744D73733275326568347544416D794B647279303877525354784E5370592B49596B6449';
wwv_flow_imp.g_varchar2_table(32) := '51504C4B654F4A326B68784E5351637944654C7949436F44626371447544676F6C3674774759714761534B55544C67595266576330694D496F2B6B69534A716D546B6E59444D6D4A5357463830566C4B2F51594844437030672B79486C476C4761504930';
wwv_flow_imp.g_varchar2_table(33) := '4171526850774353676D51704A6363727859776E645169424535486D3355366F624B6468463456466158526E37572F2F2F654B3761792F637266414B703349636E2B4A6C6B6355676B544450536D77484A3348776B376B49725053414455676774466757';
wwv_flow_imp.g_varchar2_table(34) := '4964674B4B59376E34455A2B503864794549697869465642464F41534C43424B64437868346F455453514B52786F4A777838377152524C4C67377944506B476B47316845466C4A6C5263544B5936397A724D6A424363757173496F4532656D7845744C70';
wwv_flow_imp.g_varchar2_table(35) := '37595444384842436A3052573467534F632F4F59787A6F387A346B6E51464943784D53454A756431795A7A4177346B6F73764351464B5148695171774378465245416955783834625A4267526573784375564D7344655A63543741694438475142514E79';
wwv_flow_imp.g_varchar2_table(36) := '515A43455643524A78433447504231426B6530446A7055674576514D754C34516537562F50456C696D7A68514B6E5139422B574668486779486C5577455351454964437A5145593479636B5070497A7342665949696244436459534642676C3541766B67';
wwv_flow_imp.g_varchar2_table(37) := '374E6A7A6B43776B5271506150347845656B526F4B53457451705069795068466D6E454A2F7735753470307771444D375A5A4E5771517033384644424D68616452777432484D6950654F41524469684937774669772B4D677831694778416E6679444A47';
wwv_flow_imp.g_varchar2_table(38) := '336B614F42547474794379485877506930497351426D6555423153344454736378456F694A78436F5670366A4A6551623930744F375930422F59476D5144706535594830554D4F3046714457594B566341356474486D4670446F4176674765495156685A';
wwv_flow_imp.g_varchar2_table(39) := '434549523676514853746D45467448646B424D6B794D324B344755565941484B42617A6266674B79536139794C7367744A3349704F3047624932337542433645454779546E655671637945576A78316D6843677543626B5179394644326C61435142732F';
wwv_flow_imp.g_varchar2_table(40) := '443631466B5357757A7666416C54364F526F462F617752794C616E45686232303353412F4A59505A61562B4574596E6C57627561614C45494E44414935663349626F47555556697532555733704D486962395A655144333544514E662F764A753948744B';
wwv_flow_imp.g_varchar2_table(41) := '64344669464A736F484A52646174513968385A356C524337596C66526D68636B53556253704E596A2B466B587938596F55396E634C5545726E2F526B3057365A496E49493437524F784D4E39454F77306158567969366172793349536B4B414D4B6C756E';
wwv_flow_imp.g_varchar2_table(42) := '4353656F455570562F79534A4153746E5636626441446A4B6A715442703842416D4743483669496E6956514F4E4E6946526B6E582B55756E684A46554356486D702B78434641436E556B4E717159546C7831736E6E6D69474C444670575355675137394E';
wwv_flow_imp.g_varchar2_table(43) := '6652656E544D53536B30516741717370734B504E44526F595A6B56676954716A63413431454848624D6F306747645566546D6B6A495A7247597A6154306271484B6E4378545A784C6F6D564662494C6C364B564768634C6C5366775A6764552B5A4A3157';
wwv_flow_imp.g_varchar2_table(44) := '316F566F456978626C3867536C7761656B575332414851564B566679346D515735427379327553425A49523177335652346A30514368492F4469736E4138426A555A435445637333436961694E6F64624A53375236414D7344735171377258704C304347';
wwv_flow_imp.g_varchar2_table(45) := '516B52523743727A3638424F496D303444733941307A5341366B68773131756E4C564935454832512F2F756F3849594F51624962744D707A744E79554F55412B32714B4F74515642585659424F396A79445771594A3237436A3163583739534E4D414C78';
wwv_flow_imp.g_varchar2_table(46) := '434B39435137526C6E4A323249784674707045615968545642536C4E485151637A537749624F67427151437A2B7743516B6C4252764E51517347524344447164446451616C6431736E653251472F6F64776B6C45706B6E72634D69722F766F6C454A4738';
wwv_flow_imp.g_varchar2_table(47) := '784E6F3943326B384777517A384E376B487444756268775A7A54414D31646E75494839446B6F774A654C2B504757446D5572537645634435474941386865633230702B412B666153546A6B4C49487366314B514651464A492B3431304B367741302F6576';
wwv_flow_imp.g_varchar2_table(48) := '662F6A5035714B686D663333663337463668765362614441525335667575583874537558392F56626C7458524F58662B6876567231382B5A6B3034526B6F78632F496E427967585A37377A34597542574E4E6F2B4A30455361503631397A2F31384D4467';
wwv_flow_imp.g_varchar2_table(49) := '51696B53766D724671765872317179364D5A584E6F3154726E4C6D726C7A3079504A497475585854374B307358375A7577394B463778313469306B7469582F69316C74523574597A643579313436797A7A6F726B4C456143386A3041754467476D4E6869';
wwv_flow_imp.g_varchar2_table(50) := '566A4C506F4C6E6F6676516675494476685849436D4373615255426867422F68414534423470614C766735555234383232426B6B42774669514478556157507261466A6E6A61674D3449636971716A4C786A67554F476235704130694652736443306B48';
wwv_flow_imp.g_varchar2_table(51) := '596E4955344C49472F4276676C454A563537774F686A454667685131477270735545512B614D5055775254564553464445324479344D564737344F51572B51674E6874334E52446D3543566468334631574F69414F5874783443464C692B427134453134';
wwv_flow_imp.g_varchar2_table(52) := '7075586B6755796F426D566E4264425A4C5A5A74597469346B464130534D6D4137514D4848426272534A53437A324A556F4D3841556C734F474B796A3936796368474E514D64426E642B2F65753376335A56743237345A2F555844784C706551646D6B4F';
wwv_flow_imp.g_varchar2_table(53) := '6F6F415779644A4F32514C4A41723832757547354B48536856415477524159396B58634A72314A5A54796A37557752476B5957494E45416350425855646B73674645345347546F71795A483747494268485563424E6B4563445947756745702F354F4143';
wwv_flow_imp.g_varchar2_table(54) := '676452784A4141516275774E546B4234516F7254434A68324F2F5368647250443948376137476E76596264564B6D7A715851655675786F4647665479424F617955366C4449346944626242446977555369416F616C6863352F4352492F58726E5A497372';
wwv_flow_imp.g_varchar2_table(55) := '754D4C5242733554636345376D4E655770355263474845492B735878364C513745673838624F4E6D4F3434744257576E36485A65614D667345415243424E59425278516C495242642B4174323979367A4F7368346E594945454F55415A5469373633644A';
wwv_flow_imp.g_varchar2_table(56) := '504F2F6E6B4A63584F4F51737A556942486677564B7574746B55737A4D50612F7159697961344A314E65516555554255675542746B494A57494632674B7959754573624578524B5842436A4A5359526941442F32414A4432594A446D30465667414F6F63';
wwv_flow_imp.g_varchar2_table(57) := '747139364B43794C5530626175397343527270324D2F6F3453456445433258336448576F797A71453461437A6849536766437A7441705A4E3446686165734265574E5367642B576465725978412B325076624A494B786C6B7441793455425764506F6546';
wwv_flow_imp.g_varchar2_table(58) := '486F6851315143716866494D5348624B52646752794344765652752F4F7A786956374F64714E4D5A4E58694D696E4B4B2B67696D634D504746725232472B416551643868326E76494B4A5465426C6C3146514475494668746F41744B5057416634454165';
wwv_flow_imp.g_varchar2_table(59) := '55376B504853434C616C2B485239725A4C554C32654678506C3764424F70515541516A6865466D774B6544414D62674B4C51317867703643394B4267684B332F42614B52546742476C46393844745A723467576634504C783048716A7267597630495869';
wwv_flow_imp.g_varchar2_table(60) := '4D6A7335535249684F64367455456A4163316B34686D5974554A577039695256416C6D7142304933523875674970766B456B55536C4776344F72596D4F6D396A48565A514B51536B654E61473752524C7348592F4349436F336834426E584A5550786E76';
wwv_flow_imp.g_varchar2_table(61) := '6C3546542F784B79436339436A32385841514563704A5367523569695741636D7542434776684C427970416866414E54705059394456463757436F746D42593157416E646946712B614C387061446964346950494B6C517252576F726F78306F39677863';
wwv_flow_imp.g_varchar2_table(62) := '74745A72574A6E4F44656F4479324E366939576373494B4A78446B585A7273475456575A7436336B38694A44457A3071502F50386561495558317961677A3955336A4A6A31743671364F325036666374463969505A69343450395065525A71733165666B';
wwv_flow_imp.g_varchar2_table(63) := '6936747A43506D6249486459476A352F6F502B794D35746261425A705076487638423434457144665933796534766A7935673736773376474873587247797445642F724A7235413433434D79436341434335684E7A45584D39637A743149597278414551';
wwv_flow_imp.g_varchar2_table(64) := '7843732B506B6C37663441424642645946424A554B416F51556C62643147655A46596F4C4F49696D49397341574C564E66494E416E496F545944695778414655486B41414C54676E304C3633584B4B706C627352636D4247676C367A37366678366B2B67';
wwv_flow_imp.g_varchar2_table(65) := '6543535A79694B302F38777A30585666323147736662643472747263356F33496F6C3974396F6961464379474E564F526D774F472B4B7559776B6330726A33684E31697462393759362B456D6435506D556741566856326D573962647269416E346A2F33';
wwv_flow_imp.g_varchar2_table(66) := '55396B422B4447473351476635654F783638436E4C525A456F434B3666416D33434D7A7477702F31745554306B4F56704A6178564C5A6336426577612B35635178356F6533374B35466B746150637437654678342F416D55656E7244427651396B4C2B69';
wwv_flow_imp.g_varchar2_table(67) := '356363494A434C746A554368313153715A79325444566449356249444C6C39474F614E4456734F656C4D3856434F6B2B3374335337444A31315654397465397766695873466C335372426B656A66567068666455424D6E4C426257454A58554655694575';
wwv_flow_imp.g_varchar2_table(68) := '714C66366863475A6F6C4A3753724B386B6F7333584C6F6968774970776163683261743558584B6E704F6971456368546E7069774565704D4647723455755A466C4547586F43396944572F45392B4C2F496F764A4C655366324368374873574151507336';
wwv_flow_imp.g_varchar2_table(69) := '424B513158496D41614F6A47746E4558716C5944526F63713741654951356D2F417832336F55356E6A39744D6C7A78524F35304E51303763544D6478527A57704A552F517068626D706A43706C59396F556B73534232366569416C324F685A597A4A3277';
wwv_flow_imp.g_varchar2_table(70) := '4154614A6A746438435452696A3874386D6651353944694B426448696A6D7041544B4C395178646177634461612F746D726B4473334E364F516D7134364E4D365A69316631424F537A4D4479375A492F4444424770417276364B67337051327932747378';
wwv_flow_imp.g_varchar2_table(71) := '79483042494E6337615A446A305057326B76594F5775536B7362382F63597363697A387966544D5A4E2F5A5A423861394D335979445431304444755A35376A4D5A4F776A67435865686C58355039394A6F374934747638644D79717A2B484D6E6244356C';
wwv_flow_imp.g_varchar2_table(72) := '4165757A30374366737039345230794E4C6878364230794E4C4336685266323931343147444F4D3951774D58685977305373786375486777493452366C71794974335957764D6B4B306A323050515554633858666E7267564478724B4F3254476D324733';
wwv_flow_imp.g_varchar2_table(73) := '755866636A49632F383437593864415662394F51646A2B56644F2B6349593073655875574E50797464382F30444572564F32703772763364327A5379417548666E705556644B2B33623564304C433976317A4A3575422F43653569725472596667755766';
wwv_flow_imp.g_varchar2_table(74) := '62424173544C49496E6E792F6738432B665666743237653174575866766F583333586653665173324C3131367A64313358334E33344A3652652B345A59554250504A5465357748464C7A6E70464A2F43646E7A53535433764546507A535362316731505A';
wwv_flow_imp.g_varchar2_table(75) := '70512F3246356F39746239514E61477A5557684B55585951522F45676D3857444F4D7671474A443055627946396F4F4D30366C337A3030333061304F62597139365362612B7159495059724C30425048756E63693144615032475736677A774C5A577069';
wwv_flow_imp.g_varchar2_table(76) := '4373776975307954656164694B354D4F397877386E6B413570474A6650354972554272392B6F4C745A77344F795572767A494856533539657457356F7A6E4A524344646475574C56714574664E6B77726D677A317A68696566317531742B424F5A596153';
wwv_flow_imp.g_varchar2_table(77) := '4B786363795A65484A4B71566A5A7650332F5258433062534B616A792F743737313239637465626D746E595733594C624D764D574C46743455336465316470792B52732F4F544172615A69376A75534D777A41796C50746A3547394A6B6D6C6D7173774B';
wwv_flow_imp.g_varchar2_table(78) := '5A69647A496253634B3569726D66637A4836525553453546687A6F5A4373564A684E425166565446626B6B483357633639484561553646596D455339626D70476361686E324A34396E715150684A677761555676494C783979386168326159523663344F';
wwv_flow_imp.g_varchar2_table(79) := '447A3835756D6E52794C6D473262526C654F48616E6E364F3237523264572B66376D34766C5563575037317154662F4D634C4D6B6435652F7449766A566939625643684A5371576E622F48775066506D642B556966714E537647555A4959766D7A656E6F';
wwv_flow_imp.g_varchar2_table(80) := '354D567175576665334673766A7956774E4E3658326234446464642B56617546586E522B4A4E486474585435317256504C566C614C4C6472657137376F327658505846587065725838716972592F47536A5373666E54732F33533748346B4F4436316150';
wwv_flow_imp.g_varchar2_table(81) := '6268785A64313548522F76777774584C37756D663064546B616B304E446A32346247562F333578634F6A5530613947436D77736C723739707A6344514862506E645551545636713132394131676472544B42304D6A67514361774B424A594541384B4E37';
wwv_flow_imp.g_varchar2_table(82) := '334E3542783334324D452B432B725149335966473844446567373946504F52633870665153793836796B6A5161652B6F303935527039513736714142734F787042366E54446C4B6E4861542B4742326B44686C2F765032306939527046366E544C6C4A2F';
wwv_flow_imp.g_varchar2_table(83) := '6A4335536A446975712F6D5A4E715962644A754B37536B31753648682B436B554C31423974755267656E727570316353394C786B762B4E775247692B2F3671645A383859474A6878397337396A594F72646D335A574B355779787533764E493461447355';
wwv_flow_imp.g_varchar2_table(84) := '5652393067333251502B67472B2B423752384C47387268666C444D576541487A50625146505150305749792F64494B6A662B5330753953373553353177694E682F616464716B36375645335870656F457832485138476D6E71394E4F56322F5036637232';
wwv_flow_imp.g_varchar2_table(85) := '5A534978764837636C386D496C376E362B734B4543784E6576325048432F626638576E2B4A2F4C502B46576D6D566E4C584D3773596169766234495865684874715733584A4C6A624E7256567972326F524B3177744D754F306D36746D43384D49744F67';
wwv_flow_imp.g_varchar2_table(86) := '3354634E4D2B4351646E694A5642616C7971567169666F79706273524842617178597151792F4F3256613967323750547562787055644E526661333445686F79504837374A64634256506155756C4753697863694E464244795869696D77594F49445463';
wwv_flow_imp.g_varchar2_table(87) := '576B41794C7957736949375159715248724C69565830684E7553414441414C7873696F44322F46657A4D75556C6C4B6B4A534A5269736F41726D554E6B4332574570522F31565237537157635850446D2F486362575A395748693344482F65564E35524B';
wwv_flow_imp.g_varchar2_table(88) := '4738706A5838643972514D744C514F7459312B333933683750756B314E5558562F63333451782F437A583564746471542B61796A3239714B717171624C6C337867727745486F48366C4F46487663376F4F6649544D61463533496838514F564256344D66';
wwv_flow_imp.g_varchar2_table(89) := '4277646D37494C46384C736767526156527375315865585245757A527832412F6F32566D6132315836387757324B4F50776436754D366A6E572F4848362F57734D7A3771743059686B354773786F3234554E2B506B737142332B376239787A7548767675';
wwv_flow_imp.g_varchar2_table(90) := '632F55392F766A594A2F463533336E6969536553447A3330554A316E56754B764D4378674E7A2F6C475A705133424F66624F61374133396C374C313478396A64694C7672726731333359572F45687A626A4C2F534351467630764D4E6439466B324C702F';
wwv_flow_imp.g_varchar2_table(91) := '66494B786D43497A36466931442F654F54317154446249487563646277684673692B693164512B3966796F6E6558484E3871573966655A5558764C4C356B3832443548452F4E31544F636D6E5537506E72707A6B4931396555666552522F383457536D64';
wwv_flow_imp.g_varchar2_table(92) := '584437482F372F2F784C332F4B52784D4534686F4552716A4B71534661586A2F482F416B697464646167306E6237684A304F596B4975467243744E34426543666B76504F65376A324635474E3358654376754264307A376E306F38755961595953397A42';
wwv_flow_imp.g_varchar2_table(93) := '6E4866795237627150704D6E667A78727A59516635456B667A4E70653932326B76484D34585863796C353173756E4B48387873766E4877614933775968327042356153542B2F49704F4E7073385230363174592F726247323863485836597974425A3142';
wwv_flow_imp.g_varchar2_table(94) := '31476D4D70443077506835616C7A2B766B632F676C304465647A425A5A675A4936364E326D5233303566566B6F3976306756437668744745675031422B344A322B4F50653967567462517661782F34653934627A7A633335384B57317A3135694833304F';
wwv_flow_imp.g_varchar2_table(95) := '2B57752F7557544A6B75346C532F424C454B5732336F6D4B486F5639446D4C57316B4D38564B7139424D666F555469752F586E744E372B314B743330486D614B5042656E6B5766493773764F63334666506176514C34396E39644A7772726B3539336D61';
wwv_flow_imp.g_varchar2_table(96) := '31645A2F4F5035732F767152624A5A68384B543870592B5674776B49637354386A4833647A73315273744849777146384F575061664F6B3038656B7735766648472B6F3065504F79696659326C5877376E376E7935506362574B414846703339496F7253';
wwv_flow_imp.g_varchar2_table(97) := '396D5636345254304934456C6C7457653975384F3567757143517063304D764C535047624A332B6D69396D314E325A5A7551376A78715833726D685A754774454350734668592F5057557A626D3344592B5072567A46344830352B796B585572635A4242';
wwv_flow_imp.g_varchar2_table(98) := '44504465684555736967347A695A334B38666273344155483234445931766D46795561677A757168567143545069612F64655267513046797876416B4F77484B4832776F4F4179487A6D42475468794848716E646E4467615858626B686E44436D50536C';
wwv_flow_imp.g_varchar2_table(99) := '49375032775755754D33306E58755947787078474753654478684D75316463614D4641593137567058394D4266574556304D6A67386663366C71326167547165744E556B5738636A635072794D625257684E36734E6146763178347A74323362396A3630';
wwv_flow_imp.g_varchar2_table(100) := '72766259356569622B4E566A71707244746576524E5238383935787A6A4C5050506873747665414375372B456A6D7333364A346A7A464E326A39574C2B50475644794F2F5264563673326857653048504C356653525772737A3166534136674556645342';
wwv_flow_imp.g_varchar2_table(101) := '624373436653324A63393530736C397379714B386B437359426173586D585A535645675966697366515A625A6A3878717365414D45335167493034506A627966543861645934685071575459635978653541634A6C7554547659694F4B4A52544D354539';
wwv_flow_imp.g_varchar2_table(102) := '7141423567482B78564551767562777A763554316952694A3771374D7246642B4641707A3770446D346E6D3171556B54413572423637437450632F78724F626A646462466532554F4957726C4538537761736F5963774C42367149374C754A4656685259';
wwv_flow_imp.g_varchar2_table(103) := '2F66646F4149344557613839683352426F6D4D33696C4A372F5A736354336765382F7950667451626962734568486C50792F4E356755583434334C6D75746867494F5A726365555473794968684A4C4E756B64544168474C78507639736B767A6848324B';
wwv_flow_imp.g_varchar2_table(104) := '697542426D69483475723279696C455369554A496B734F7134594B454F643432716E4A71564F4B544C43643766577153353132474B69554A4B3370304F6A61452F47594A5254726C466D2F594B415A766A4C476F5953666167336657357A397962416478';
wwv_flow_imp.g_varchar2_table(105) := '72705672396354504942316A475878393761753157394446364A4B784A72787A374656734A662F357866333761373032586D727763504B496E47744347465250496755686C562F3262753246507734352B3746663446424858312F483243396769312F74';
wwv_flow_imp.g_varchar2_table(106) := '4F614F33747166336A4237596F387468763675337262616E726265334456336531757659707962476B2F715952637A6D45786C4A4F74477536506A476C335A4F70786335726A476F767A6E52767544674F516B717A42417A2F30516C6F2B41336F506F4C';
wwv_flow_imp.g_varchar2_table(107) := '5265644B7175716E5531314E51307065532B63717576686950525A77476536686E3956657548736177764C2F3348303336736C4C7A61616B34784B3365664F58647A76394863575753634357525A41375734385456396178346A67716F51464741385930';
wwv_flow_imp.g_varchar2_table(108) := '6B4B584E4E594C2F4547534A58727467783962427777446B5A5575587253564E3350614E3633763665484857304F7A564B37367765476D754744504E7672354841416B737A78667734746E7A5669362B6132426F4C68754E7A5368635631367863454662';
wwv_flow_imp.g_varchar2_table(109) := '4F316B346332696B6752387A4D3563416153684D505039676D4C675359434B5038366859574C31752B2F7250444D31716176613164793559384E546130646E7A6C335958637374586256783156376D7136656C63336F614A6E646C385638667779497152';
wwv_flow_imp.g_varchar2_table(110) := '477A7537786C4869514C7872617076447563784670386776764A6F4759434763476E667747332F3630346475416B336D37422F2F2B4B536A3730734C68612F75655034716632626D6C5A5550486562484F334F614F6C77446A6B334C63376474416F464E';
wwv_flow_imp.g_varchar2_table(111) := '7831643345756171593875642B414779456B726D5A79496763356C57364761527031696F5145634B76546A6470704943644C625132554E2F4C46417477446E454439512B6A546256507633354E5774584A474F707A4F7265336D676F6C73687835566133';
wwv_flow_imp.g_varchar2_table(112) := '747A6B38702B315A3868396A6C6455722B36354F654F64586D35646E326E65305A464A74795631656632346746572F5943795A3876616C33384E537A512B5A31596D517864666D757A784870654837585A347030484D434C67356836646A702B3448416B';
wwv_flow_imp.g_varchar2_table(113) := '35487052376D6854522B356D575979323035456146335863324C375848737645684E32376E653564644E78774F384973367A3038496E57714F4354617A55647847502F3663535A373650505A6252417864506A54633466524C7352456A30413748566E78';
wwv_flow_imp.g_varchar2_table(114) := '61746F536B6B667A6A45633343502B3445736B725833356D2B42664452796E49543768506A6F3164652B4D72727A69326C44767237307A5445596D44487077514A4E4A2F304A4E6F657039414E3944486F6663646B726853572B426B3433436569445064';
wwv_flow_imp.g_varchar2_table(115) := '52356F7856454F41524143486C4B68636A7944417A6F4363365944523059725A7537576E5A2B7646644E4E625846736F72443262626F3553344F2F5759385047717365477A65452B2F5350546B77557067633656304C6868584E6D656C6D436F464C4B7A';
wwv_flow_imp.g_varchar2_table(116) := '4A6357725A5672504B2F6430646F654372476C3252685A4E51307173774B4867614B6D6E574D713074764A434C467A495870677278514B68513870636D616238452B4C544B68395679365A526D4732505032487A716D4D6E435548664F4A35725544634F';
wwv_flow_imp.g_varchar2_table(117) := '793352686370383444696651617A7532624A7731322F44487A6C7934344850724E7977634F632B304E4E65326B63576A7066544933466B643042336E69715562627073786B45674A674154617A79614A624E667946647657506E56586F5A6A5239477A58';
wwv_flow_imp.g_varchar2_table(118) := '5239657358377668336B715056376D6C7451564130767962692B554F43672B473770773333426D4C483852544953624C39423656766F6630336D6A69726145346146717043524C5047466939374741534E7A636F334E642F437957776E73344D44613974';
wwv_flow_imp.g_varchar2_table(119) := '5758414269414372773732414A486F7147375941576E476F334E7A664E30376C6A7A53496E4D32464B493376474A7956374667624B6930646D2F766866476C69334B7A424939567039704C3231434563786172547373466675335A4E7A38573144364537';
wwv_flow_imp.g_varchar2_table(120) := '767A454E6A726C7A33727A7554624739653548337763506165642F30654C344F6B365A546C49324164365A5269457473364D4A4D39663761576444506E765452714B6E316A4A4F4F44743833685670796B6B4869585963724D6477553777796571766346';
wwv_flow_imp.g_varchar2_table(121) := '54396C62677166773963437078754E6E543263383370474E615A50436F576E5A426965453547335844414A5747707947317674305131794F624F6836355A55755233634451544D503377344966426D7A696C6E486247544F67504C5A4577554A31505352';
wwv_flow_imp.g_varchar2_table(122) := '6278524B522F46713059594A314F306D545231766F456863334E5A3278795061685939546D6A5469556663633631414832327459764C6F74685A76636D526133525A436B4E6732506F4263357447516578317036307056772B384D745378625735714A51';
wwv_flow_imp.g_varchar2_table(123) := '326B696A526A79416F734635745A394833556D4F44656774616B493355484E636675586E50392F3972312F394F6234646F304B75757A755443625331476848444658516E4F7A704931377175654D4C666F69577353444163622B2F75364136484A6B5653';
wwv_flow_imp.g_varchar2_table(124) := '4E5433655A706D646E596D457631564E6D6A52534F6D45596C356A6D7066613277514D544E74587A6D52644F774A71616341794E3436624C504C5664776D3254544A6556617334325856597270645345366249444E59435A6B4D7450746C6E79514F776F';
wwv_flow_imp.g_varchar2_table(125) := '54594471524836425479625368676D616B70476E4E736B4F52453255747257534875594C6A724553716956504F62495870637235556E30434B5067586A3258572F51745A744D344C686C33554E4B6D55326D363679654D6873747644456B4855574E486E';
wwv_flow_imp.g_varchar2_table(126) := '307A695A645974666C2F79636841575A2B6D30547A47496A434671466748462B7831774A637877527A79374F2B5A4241587933675876694D6F4E4433556A377A415A34366D64562B6C2F435A4176574B5538785A777A7031587A32327A546A4436384D65';
wwv_flow_imp.g_varchar2_table(127) := '493633375655746F446E5330593279365A636D6A412B6B6C586D3174566C5776776775536E316644696F5A4D6A744E355967523577583658672B4D736A6B636D63696D4B53496A7031675442464653424F7065366654456A4646543957737A64575A4152';
wwv_flow_imp.g_varchar2_table(128) := '6E562F4D73555866674D2B45492B6A54664677725277325A32394648305563502F4A676B617276776D542F3732657261455072615478696D3454665669613967557378533567626D56755A54304B4C3842692B6B3659753030422B62566C6B6F46323276';
wwv_flow_imp.g_varchar2_table(129) := '74617046642B5769556152314134316A504659565A495546473267756F4C4E5830355671735A784D7061747041545A435561432B6358516D66736F4A686B375A77714B4F467A6F796B6D586139415349536E63485063684B3848367A554B487564616166';
wwv_flow_imp.g_varchar2_table(130) := '5436524B4658535061575A474D6972663079503638336E43653852454D4B4747596C724C46743730614879544A7A4F5356766A65586B484A4C47727A4263384C2B74704732757A34536E7052326A54526768616B5235715652444175656E6E69704E4553';
wwv_flow_imp.g_varchar2_table(131) := '5371704E55533270523575556C6C414C7656416F3041764A5946494E4A4452764C4A7364796D5A6A766D43774E525443567A5133383270364A4F4D4C374178474E7149574C5270536B38474536425A4A4C696449496C733971797243387A4E2B61796379';
wwv_flow_imp.g_varchar2_table(132) := '4C447644765832384369476D655637516D78354A713377316D57746B76796D694A5A476469505073496A7A624B375945375578423870466D4E65456B767A773771377437566A595A617155357164666651654D6E336366324A70686F37594A7434786253';
wwv_flow_imp.g_varchar2_table(133) := '56745554502B5A3443645A7147665441643135373766566139446834666C58744962545275756D44393935622B3566476E484C45672B396859737836356D6F624830496D6A2B685232644178624A644B4B322B50696A684F6C5646734776793452325736';
wwv_flow_imp.g_varchar2_table(134) := '4E456853647064574C6B4563495766556B5544426D54634F5A487535376C455A647A7771305773644C596D30573348335A386F686A47666A59436E546C306B6E57733656754A42626C5669526C393142446153434C4B6B5274706C366A434E3374612F71';
wwv_flow_imp.g_varchar2_table(135) := '746B63576D7168627135743336627861496867725A694932484575593941552B7771364E72557257586B75756975473744642F63564B4931355047486B6E6E326C37396B63386D517632306B4E64646E724B497671746A4F7867694A47434E2F4B473032';
wwv_flow_imp.g_varchar2_table(136) := '65574F535839525A46727539586A646D5756333053776B5763355972476F6F474D6664765350583646564E56464E586B4A5635326556437139356E723466644D4C2B4F302B306C2B68696673597A677458384C6A64523863373949524D77586D4F2F2F55';
wwv_flow_imp.g_varchar2_table(137) := '6555536367726B68316B7732504A35437234636A2B644F64664E763259586A78354E4E34436E68356B6B6D39376C41775375634775493838412B314E5A674C516435615A425344587A6D4F75594B356E507337637A337942655A62354C764E767A482F52';
wwv_flow_imp.g_varchar2_table(138) := '32532B5034466E676F325133675954326E4A645779686D477363642B30796D75336B71683367724F424A62466845426C4A6C576D345935533271346D472F73365A7246536971736E556241424C5163526F4D497231476D4658714A346C39612F50576C6D';
wwv_flow_imp.g_varchar2_table(139) := '6971382F4B31576C5A77314C44355558634A366F6A776A5A31637852343576676A41765336774D6F5A55656777394431474F4E3546657078494C746F2F354738494E5352724970383670617A5659315438792B714F6C455764776C426E51307337476248';
wwv_flow_imp.g_varchar2_table(140) := '2F71444976434A79732B4B734A794330726543523679315739676F7553664A4C53786341557072394B35636D7565575A51633454354E7557697870367636706875525155676D34324E4A6364657A37494B55313877497444627154685633555851546E57';
wwv_flow_imp.g_varchar2_table(141) := '4852444354537A57446E786131776A4F772B4F344C4559752F427364304A7972774F74424D5A794368343039717168594846797465704379724D716A665771483467767145592F4B36577032593170457274704D7855586B6A75306C6D76386479336763';
wwv_flow_imp.g_varchar2_table(142) := '6B43524F317352494B74717559492B72636C616267463034645554504458517064764E42447873306B532F49717175514C384431624A53424A6F58314D53776A67564E45646D41356C48587A454A324B45374F47527952386C49554352394E5935465168';
wwv_flow_imp.g_varchar2_table(143) := '6C314E3953426E71466E7836502F4A6166486D31346C4D337A794B503459363153785469555A65766C725575464E4C4F32714A366B567935636B4355335842362F67595A2B39534E5A34744B44334C4A6E7345357170386F715856646B6E6166782B5158';
wwv_flow_imp.g_varchar2_table(144) := '686F6B337745646D383075495151516247776638434155446771476E66536158794D72494832434E325951676A6B674B386575717A416539524D6B6E4961504D56504C3933464D31756E5A714274564F305767616C6565753858637336587349716D3370';
wwv_flow_imp.g_varchar2_table(145) := '443444652B785530447A32415873564676492F4F50484B4539304A50763158357272315675666E67643232336E6E356E387651376B394E395A374A35796A65776364667056794E50767872354E75656A70324D323379564A2F43766F74565536757A644B';
wwv_flow_imp.g_varchar2_table(146) := '4A4B457A5366754E49753154414B736D3863586666786C762B666D58786736674B343332676433345677662B41322B376166506D73515034713672524D6173787638474544574970637A467A4F584D566379337A67524F774F77704A4455315963423044';
wwv_flow_imp.g_varchar2_table(147) := '376D54447247504146656841696546766D41576F41546435614B78447A6266484D6D793848394268707935616867525563666C61323443733357342F775337524C2F70453165334A7476336665303346306951542B2B3149577670656E2B444457424D4E';
wwv_flow_imp.g_varchar2_table(148) := '33696370626A3937395858587A62396D353358485952665A684A737257644D564D4253507175756D4563544E5A6A446739536D47364663394C72665043416443486930554E4532586853454959766B737432794666424248384C6C6F484D7576716B4F71';
wwv_flow_imp.g_varchar2_table(149) := '4F73762B48324C76625765794A324142737172555069676369306A636D322F5758476A2F2F7A754F417037786B592B556171386961322F64746A694D483675502F572B7A5A2B424D4F4D7145783637416D47326A385A516353305239574A6B663931644D';
wwv_flow_imp.g_varchar2_table(150) := '4F344E6B42627536433551446A456B586A614F487877344E522F743362386C46715A644553797937446F6E727372476B674952454E4C646C3939576A485345507A3375436E5A74653239515A704965686A744576516F4E734B6D31356330757053574439';
wwv_flow_imp.g_varchar2_table(151) := '3957742B396969684E4E6C36384A72614768714D482F4D72626B2B49726257472F42374A373563387669623049344A434872666954774A4453624973615A4C5042787334636B6E2B3834477A564C396631646732525861754B484C753649467654415461';
wwv_flow_imp.g_varchar2_table(152) := '33324C59522F3447634B4F6A6D3161597863776D5A69647A445850624357756A6A6F376F71486A4F4F41746666392B424B707949717048386C47706C6576776A445056303757387732496F6C3145367855476D30325350726965376C5751563531613362';
wwv_flow_imp.g_varchar2_table(153) := '585271766476796471724E4B613677704A415663664D387164757731576545564A647347516930595A467537574A4D565866674A55506449494D6A7151534561457568584745446634374A55766579692B74356E4A576F39457974725655683631787237';
wwv_flow_imp.g_varchar2_table(154) := '437778556E5A747A4A753856645A644832396F502B494D2F6D765A324D645A423536476145656843796A4B7176595861347A6D5A4D35547A2B346D4352465A52756866706975375239626C5A7A734F4A50713332416D7253437A7536514775544B377348';
wwv_flow_imp.g_varchar2_table(155) := '424D6D4C517671356D366A4F742F45632B674547364A636C6D5732785147386C7757477139586B74726A65457557414142664A30427151703744746E6E587A723257515867354F75594B3263354A42777373656A44334A666D4754504552696443544F64';
wwv_flow_imp.g_varchar2_table(156) := '7A41437A4443693869376D6132634E38696E6D552B534C7A446559487A47387076644F43466139556F656B6B5155435A35452F616A49502F596346744C3976574E6A57512B3858773444585858504D2F776E794448696964652F66593341396E526A3732';
wwv_flow_imp.g_varchar2_table(157) := '5374654744576A546E367A4A5A684C7630322F336D457772553257476D56486D484F5A53356F504D52356E376D6338787A7A486659583578304A64382F70535A66764B6E675862386A3244336959384F7666776E792B6A7669722B525548633050506D6A';
wwv_flow_imp.g_varchar2_table(158) := '497263744748644D504E6D6A49656557476F364D386A6A575A426D4E38544D4A515072447A48726D624F5A397A4637626B2B42772F375A3344576D6D44334E375939394669496E65504D776C447233324C6B484C2B726670566D4566395354334F627872';
wwv_flow_imp.g_varchar2_table(159) := '4E7062363539657178755278342B35786F743852616B70324A627053715543544F39596644376645413062555A536E4E6F5A614F5645636D3256794965384F5647555A54554739796932686B49463171386774385144653070704C686B61576D514D4962';
wwv_flow_imp.g_varchar2_table(160) := '435439555458543533614951394856487455435434412B30574E334E476E50494F364A4C6D4D75594A77434E50587343316F56442F466D53682F6D7A51497566374D3553504E53644257494A645863574F6766504A486557717045556A75544F6B6A7947';
wwv_flow_imp.g_varchar2_table(161) := '4F387578744F36464C6933594852424A736F566F3053676D436D666F707167626F7458506867525730774C5A6F456861576A67686C4132702B6D795848737947524461524A474967473543396E61594542445863427165774F424C42524F557374796D36';
wwv_flow_imp.g_varchar2_table(162) := '2F5A49702B54796936625A346D634F514D69647A707473555044354A38596644626547776F6272646C747439484F702B77654E6C78574132344A566E75387865552F4A363459456D7033416F476D45566E42784B304D74426C7A5A625679463341746653';
wwv_flow_imp.g_varchar2_table(163) := '536D6941356B4B7A6B65774E644164344C6D464545577358546F4338495174794C55422B49466334466F4E637379624E74552B714638666B5649494C3455776B6B676D624E4A75572B3642334D45396B7A6F706A7A573131624149306646753234475567';
wwv_flow_imp.g_varchar2_table(164) := '2F564B674F56435570446C656961624655526C56646B53567035524B434E774D4B72384535337356715851462F5A6345314F666D373533764167597179356147502F6770326453774C794457666F4F774E2F317A334C6E7A36717678556E756D314F7957';
wwv_flow_imp.g_varchar2_table(165) := '724A77557673337A666D586668683130687835516466484C34597561465733646E665A7634596F56545032626A493573646E53614C6D594F7334725A796C7A433348693857737A4A4638714836786676657A646C3869476F66384F374A59385078796F37';
wwv_flow_imp.g_varchar2_table(166) := '5473574D5536646F73716C544D6330555132647571332B2F59664C343655626D4B5353687865682B564D4D4C386333343238524C7A694E665A4447372B47696A7161632F354844365177366E39454D4F687777696E3358365577366E502B56772B6C4D4F';
wwv_flow_imp.g_varchar2_table(167) := '66355366636A6A434748373239446364546E2F54346651334866346F762B6E673648782F6A57385A6E3165614471505461526F425047624A6E767A597472316274754262786D3746462B5847666F324E7356387A4D63436A76794F503432384448705559';
wwv_flow_imp.g_varchar2_table(168) := '4454545641424D4872617A437A474B574D6D75594463775A397379797530424465782B7A6D2F6B776377767A53655A2B356D486D4D387A6E6D62396B76737738792F77763568764D7477436E466F726C70445831706D4A565578306F6E684373436A576D';
wwv_flow_imp.g_varchar2_table(169) := '56386F706A6F376830532F6863665454654B62396154784F513641746D4956696F567143634B4F59717159356D734C786243596C59317231644B4D497A756B706652446F4845664A59546B706C4D70786A363951394D53726676714B4861672B2B573277';
wwv_flow_imp.g_varchar2_table(170) := '6271337637574E574345426A4D50786A7633577045744634323556716D3966467952374F48786772426E7963346862636D697A6A31785737716D57585635415050436A6B4564394E797044476765646851325965396169666B336A46492B7163327A7A77';
wwv_flow_imp.g_varchar2_table(171) := '4C4F2F4A4B43782B78514F6148476D79496D4F3570694448595A3962304C5A507A6C34676B4E73432B374E674C64632B4739327A7835356E383537382B412F68484359353276774E56706770756145374553775830553071546279433237735779516F6F';
wwv_flow_imp.g_varchar2_table(172) := '6C79675345674E686E3648666E692F6E62386C585943336E623456313149534771704267452B46637A63456D72322B5779716C425366436C3237324331792F78716D5330545477766E336A384D37584855452F7431343959675378444F664B746277462F';
wwv_flow_imp.g_varchar2_table(173) := '2F68343053596C784D52374759494A4D6C456E6162776C42424975617665696B70314F74734732464E55373331434D49317536384F3738317638315A63363738676376797043312F34484A67395150664C34786D4A6D556C6E786E6473776C2B4E324E39';
wwv_flow_imp.g_varchar2_table(174) := '375055636571713278486B6E3857377950496E5A3755574433444449553751584A46683036745657514F76556933645836766C5562666D6E503731354D3136315A6375444A486267476E49395857762F397543444635363336774B303838494871623379';
wwv_flow_imp.g_varchar2_table(175) := '72562B515430457A7443416C3648366A7942515144397371716B54704842692B536F72635874754F305A6B5931396F7737674B4A2F7A4A4C526B483250774A742F4B3048344F414D516D6F5A516A704138482B666B4133415837636A58482B4837712F78';
wwv_flow_imp.g_varchar2_table(176) := '32585A65375A5A4E4A324346566E336749644B4F7A7835374462747259616463314D627943486D53524F70796F45486E566A704C44414A61636E5761576A6131756670717A2B6C74487958706C544C4B6E6C4F372F3466332F2B67445632664764702B44';
wwv_flow_imp.g_varchar2_table(177) := '396D6379562B7762753366664654395A5353492F2F4F462F6E514F2F534F61796538373934512F334C566E793155737A64364E374D7064646C736B6375353539396671636371336E4955373364666C31314872477678397479303336745933655A466330';
wwv_flow_imp.g_varchar2_table(178) := '705569757467513942566F32383961626B4A2F6E6F4D5944544450497642596D773351794F6162453944417A6D4B48783264536436666F4D6D38756F526261636E4371543342526839597051345866672B7837347A64375779504C59367646442F4E7750';
wwv_flow_imp.g_varchar2_table(179) := '616D37385175666A2B532F6D4833734D4E684F2F583034634E7559486265545A735245342B575A38515754502B35363048654B4F6B4D5078334E43387A4A37302B4E7254746576682B62576635476F2F512B464A564775387439667776564F67505A684D';
wwv_flow_imp.g_varchar2_table(180) := '654E7A2F7A6E472F73354A705A324A694F69304E4A64426B58377A6475332B32632B6448727479306165664F756B76656C32325076442B37494442762B616272313635644F7A746A74376E4A7A7A414F66344C6A4F583934796F636B75686E53644E3478';
wwv_flow_imp.g_varchar2_table(181) := '2B7A36354750386E6379487A37383458455741423554615652666E4732325455696C34334F4558726336594B3970764145384D4A5565726235377A504F2F35794775384D30355A4C355970746F334C53316E473250722B495542514B6554715A59515246';
wwv_flow_imp.g_varchar2_table(182) := '71642F534948624D6B50326F34446744436B595531642F3473336F524864386448324C5755547956486C3847734A4F48367354376236686163624A4733315347584D46446E666C4D66713846514159542B6D467342414A635554772B4B787745634D6D35';
wwv_flow_imp.g_varchar2_table(183) := '56553530385336336C473478665A59377A4F476731744A6C4E66656D335278614441714F366D395341724A626B486B32344E47615A612F4F5339526A562B534E6F436D34614F596B6E6E434351507346696E6B417755457752587A784548556446514451';
wwv_flow_imp.g_varchar2_table(184) := '5558396352505559464A4F39626C467A79616F6B416F7A6C58614C6646776743734B37395749763352515064536455484D54326D486B303068363277793633784C6833414D3468476C36457171716A4C666B2B73726C344B6742312F70366E2B65504E67';
wwv_flow_imp.g_varchar2_table(185) := '5A6F374C496C5A4D443771446B7149674A654A4C6D766D5572366C67716271593041425361553252514D7A543274306358393976434B71727537706C51584E2F633165304D365262644570485431494F75426435576974577771506F697552704D764D74';
wwv_flow_imp.g_varchar2_table(186) := '32574A7364695470566A55555A336D316430477770366354335A374D2B79304A5641473472546B346C4C35504D4C4C74336F684C426A5649386955444B624E596E4C484C5372643653364F74346535575061434A71687478726F6756613949726777577A';
wwv_flow_imp.g_varchar2_table(187) := '72637362306B4737354945634557386D6C4F7667432F33746B666E4E515930662F3962576A38683738452F7364747875663231724D624F564F617642723336546D764E6F705676304657574F4970494B5A5A39697156784B64324E673179536947496575';
wwv_flow_imp.g_varchar2_table(188) := '2F767277463431527246544C6953525035377168562B68306D6833494B42524E616F594676725876514C686A524B45366541477175684C377763674F4A47657A4E2F633352316B4961656D4E536A3570374F6C4341582B3155426962335A58304E376E6A';
wwv_flow_imp.g_varchar2_table(189) := '515A565641483969643754614645306A7547616D7A4F5343704C39743573784B41704B71336448646A582F63322B4731744B6F32503763386B2B6A436556544935396C775A4F68545454304C57324F394C5643317451583552666C2F54692F77794C6A68';
wwv_flow_imp.g_varchar2_table(190) := '4B6738614342484B3858576A566E735479694F757454656D6851336C6D2F6D4744487155334572386B36796A44414B5A56303643734B4F2B6F5471615750464F31507172583955756D7A6B773830755456754B766A6452475A7544394D326F7644387763';
wwv_flow_imp.g_varchar2_table(191) := '47476973384A2B59362F78782F453137584B624B4C44695275516834434445685667584F5534664E6F666E6474726D5A7A4E77325043387A4C77502F735766777647677043762B785A364C6C614C51384931577470724353716C525359332F4153694352';
wwv_flow_imp.g_varchar2_table(192) := '43497A39495A6849344A666772747053357937304A4B53536750693170665A4E5566516B62504B56564F304439455A3062616F433939552B514F3947317759536A5864746E795533342F2B474D6A554478545153496451594C3651485554634374535343';
wwv_flow_imp.g_varchar2_table(193) := '716E4341482B686333682F6D4D334E57642B5857394376336671447634635436326E2F5737694C527649553252375034445A4B5A743362446976347749646B6C7565716976583278574F32653273664E664A53674864347159342F4C76765654386D4838';
wwv_flow_imp.g_varchar2_table(194) := '4F7030397A4235526F584D494F6E4237454145454A78396573667A706A66353034746D2F5743316F797569545436375062384376743255326448687034426F493350446B552B7650644F5A332B6C6579423739686F3454783148513853434168704B4D71';
wwv_flow_imp.g_varchar2_table(195) := '32554D544D7A756158767832357239783742755156433354644638497630485438336332765A543437347A2B647939436172574C37772F64373944697035446D36777850665145515A794659364D6431794A3761696F3231655448306C6447786C39424F';
wwv_flow_imp.g_varchar2_table(196) := '2F5072334E39526D7864445852752F743647442B5078705244614D41654A786A594752675941446939324C6D4A7648384E6C385A754A6C66414555593776392F6E3436672F3263787632414F416E4935474A68416F67426F6867306A654A786A59475267';
wwv_flow_imp.g_varchar2_table(197) := '594137366E77556B587A417767456C47426C535141774264594151444148696359333742774D4138696F634D426741525A474D6C41414141414141414141422B414F49427667626142306F4B634172454374344C3042456D456434536C684D4145337755';
wwv_flow_imp.g_varchar2_table(198) := '53426C73476459644B683145486834655242357148746F6654422F34494C5968476946304963516941694A6F4979776B486953594A506F6C5843592B4A6C776D6C43636B4A35596F4D696A6B4B5577706A436F714B6D6F716C6972714B32517277437755';
wwv_flow_imp.g_varchar2_table(199) := '4C4859733369302B4C6667756F6938514C3651776F6A43364D5A6F78376A4B654D76497A6F4452574E65493269446D344F6477366E44726F4F3651386B44302B507278414D4544615162354344454D6551317844714553475253684B566B707753365A4C';
wwv_flow_imp.g_varchar2_table(200) := '376B77575445524D576B7961544F4A4E504531325461684E3045386954376850366C4255554970517346446155505941414869635932426B5947444959636C69554741414153596735674A43426F622F594434444143465141684541654A78646A37314F';
wwv_flow_imp.g_varchar2_table(201) := '777A415568552F61744541724D59424159764F41454149702F574641394147617A7133555054394F326971786F385374314B646835416B5947586B4B4A425A65684A505564434357342B392B3931784841584342627A67345046666342336267736A7077';
wwv_flow_imp.g_varchar2_table(202) := '437965347364796D46355A64726C764C4866527862376C4C2F32533568306338572B376A45694676634E777A56672F59576E5A77696C664C4C5A7A6A7A584B622F743279532F3677334D45315069313336623873393744456A2B552B377079584B4D6933';
wwv_flow_imp.g_varchar2_table(203) := '4B6737455170613764535172346566684C4378794E5A66704E67764B477575396C475731316B714D764746642B6C4C4A4D6A417946754665564C7430624577696B6C4C6E597171566B566D6D525648716A59794D747A4B6D6D4177476966566570484E45';
wwv_flow_imp.g_varchar2_table(204) := '434A447A357852696B73414345695632574C4D6A55644834374965596352636B68546C39796F6D4D2B664A6F2F38356C4D31397858724D53474D4844384E6A313256564E496F446847544D525973393378572B6D474E4D614A4B77545A6A526E424B624E';
wwv_flow_imp.g_varchar2_table(205) := '54585536343949305264506230455430486C624E5649454A426C7A4A76377A4846472F3642576239596E3441414869636C56623565397047454F576C506D72414159506A4A473264773436544E71317939307A6239456A762B3736505252724478737575';
wwv_flow_imp.g_varchar2_table(206) := '7572734335372F765369755143496A503451632B4E4C4D7A3839366232524731557A582F716463576677524F34526D7359425672574D657A324541644454537869644E6F6F593074644E44464E7335674232647844756678484A374843396A4642567A45';
wwv_flow_imp.g_varchar2_table(207) := '4A567A4748765A7842516534696D743445532F684F6C37474B776877417A6478433764784233647844362F694E62794F4E2F416D33734A397649313338433465344432386A772F77495237694933794D542F41705073506E2B414A66346974386A572F77';
wwv_flow_imp.g_varchar2_table(208) := '4C623744392F6742502B496E2F4978663843742B772B2F3441332F694C2F794E662F417647486F494559467769443447344869454977674D613674574D7A4E6F39356D6C4D5873637845777A49556863354E4B53486C4C456E534F6745556B62684D7947';
wwv_flow_imp.g_varchar2_table(209) := '412F637451784B334B2F31537953427A366953325850614449526E442B6E544F574B6274354B67617869514E73317A4A47325848585051455544424D684F57786F495A514B67364754422B52376852656E7076326C32597A76432B5A75486C79384A5950';
wwv_flow_imp.g_varchar2_table(210) := '53562B7650442B483771426174784C6C786B5475593658624A4B507077565461765355705A4D54542B50736E4A7A4348384D7873482F4B4D6530746C793154594E765266347479636C65546553417A7077444A7A744E6C4C444A65753134464F4248564D';
wwv_flow_imp.g_varchar2_table(211) := '3067746972634C5534492F756C6B764D77646F716531316C70617448304866785171552F4339387036567153667473426D2B414B6C5241734E685231533059366A706D4D4B46704A5362574B4A466E532F6571614A6D51697131434E4B354E785A34626F';
wwv_flow_imp.g_varchar2_table(212) := '4E4B70544E6E75436E526C464D354858686B776D544B7872436F6D50614E4E46693443466C6F2B346654776A595661725737626B392F4473416E6975346252624356747765625264456D4B4B656230584439326B714E5A6B6E464F68425231334A73395A';
wwv_flow_imp.g_varchar2_table(213) := '51493835685A735455317171506E6C51756C766B5461747A3654796C472B47464F4630593076424F385469646E704C4A30797A467050677656624C4C7A792B36754861673166694A36536B4C6D6864664D36486D73573334336D5239576A47752F4C7137';
wwv_flow_imp.g_varchar2_table(214) := '47694D65556A50766C76656B463662397847326A5258506C717864715836366D6B414F35642F4B31554B5264314864664F74587436744B394D4630666A59685A46716A654977707477387552736431496463682B31624D547869704E3135626D4C4A4174';
wwv_flow_imp.g_varchar2_table(215) := '36706C486C7666737A6C4F3868484B4A62703038784D2F654974567A45486E4B4B307670354641335752514D564A6976776D592B4756366A39437562676D353531504B6A4238757A357867573755715030724F3465334C6152552F646A72593835473464';
wwv_flow_imp.g_varchar2_table(216) := '32765035645A78666B3175435358495A48434D623945696F636433454C4B576D6C4769375A4E4B4E5245596E686271536E71344C5A6F7A4B44737845733534616B626445627146466C46496761733159787370504570647859764F7853367A3776544667';
wwv_flow_imp.g_varchar2_table(217) := '36616935704B7439725A4B345A656E59355A525357662F4F645839306E4C515A6D4B596255526F4859303079484E514C6B4F307065586550447832585A6B53487A414850486D71312F774776784A30534141413D272920666F726D61742827776F666627';
wwv_flow_imp.g_varchar2_table(218) := '292C0A2020202020202075726C2827646174613A6170706C69636174696F6E2F6F637465742D73747265616D3B6261736536342C414145414141414C414941414177417752314E565169434C4A586F414141453441414141564539544C7A492B4A457330';
wwv_flow_imp.g_varchar2_table(219) := '414141426A4141414147426A62574677553357582B41414141357741414164305A3278355A726B772B68514141417673414143683747686C5957516A42794A76414141413441414141445A6F61475668427A774476774141414C77414141416B61473130';
wwv_flow_imp.g_varchar2_table(220) := '654B58674141414141414873414141427347787659324876553945534141414C45414141414E707459586877415A5945646741414152674141414167626D46745A586F34645A5541414B33594141414350584276633351512B4E79374141437747414141';
wwv_flow_imp.g_varchar2_table(221) := '436967414151414141314C2F61674141412B674141414141412B67414151414141414141414141414141414141414141414777414151414141414541414F38574E7A5266447A7A314141734436414141414144662F2B396E41414141414E2F2F37326341';
wwv_flow_imp.g_varchar2_table(222) := '41503971412B6744556741414141674141674141414141414141414241414141624152714143414141414141414149414141414B41416F414141442F4141414141414141414145414141414B414441415067414352455A4D5641414F6247463062674161';
wwv_flow_imp.g_varchar2_table(223) := '414151414141414141414141415141414141514141414141414141414151414141414673615764684141674141414142414141414151414541415141414141424141674141514147414141414151414141415144364147514141554141414A3641727741';
wwv_flow_imp.g_varchar2_table(224) := '4141434D416E6F4376414141416541414D5145434141414341415544414141414141414141414141414141414141414141414141414141414146426D52575141774F6742364F45445576397141466F447241435741414141415141414141414141414141';
wwv_flow_imp.g_varchar2_table(225) := '4141414141414143412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F41414144';
wwv_flow_imp.g_varchar2_table(226) := '36414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141';
wwv_flow_imp.g_varchar2_table(227) := '412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B6741';
wwv_flow_imp.g_varchar2_table(228) := '4141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F';
wwv_flow_imp.g_varchar2_table(229) := '4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F41414144';
wwv_flow_imp.g_varchar2_table(230) := '36414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141414141414251414141414D4141414173';
wwv_flow_imp.g_varchar2_table(231) := '4141414142414141416D4141415141414141414257674144414145414141417341414D4143674141416D414142414575414141414567415141414D414175674236412F6F4C2B68703647766F784F6A63364F482F2F7741413641486F424F67523644486F';
wwv_flow_imp.g_varchar2_table(232) := '612B6A45364E766F34502F2F414141414141414141414141414141414141414141414142414249414567416F4147514131414455414E51413167414141414541416741444141514142514147414163414341414A41416F414377414D4141304144674150';
wwv_flow_imp.g_varchar2_table(233) := '414241414551415341424D4146414156414259414677415941426B414767416241427741485141654142384149414168414349414977416B414355414A67416E414367414B514171414373414C414174414334414C774177414445414D67417A41445141';
wwv_flow_imp.g_varchar2_table(234) := '4E514132414463414F41413541446F414F774138414430415067412F414541415151424341454D4152414246414559415277424941456B415367424C414577415451424F4145384155414252414649415577425541465541566742584146674157514261';
wwv_flow_imp.g_varchar2_table(235) := '41467341584142644146344158774267414745415967426A414751415A51426D414763416141427041476F416177414141515941414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(236) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(237) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(238) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414144414141';
wwv_flow_imp.g_varchar2_table(239) := '414141464641414141414141414142724141446F4151414136414541414141424141446F4241414136415141414141434141446F4251414136415541414141444141446F4267414136415941414141454141446F4277414136416341414141464141446F';
wwv_flow_imp.g_varchar2_table(240) := '4341414136416741414141474141446F4351414136416B41414141484141446F4367414136416F41414141494141446F43774141364173414141414A4141446F44414141364177414141414B4141446F44514141364130414141414C4141446F44674141';
wwv_flow_imp.g_varchar2_table(241) := '364134414141414D4141446F44774141364138414141414E4141446F45514141364245414141414F4141446F4567414136424941414141504141446F4577414136424D41414141514141446F4641414136425141414141524141446F4651414136425541';
wwv_flow_imp.g_varchar2_table(242) := '414141534141446F4667414136425941414141544141446F4677414136426341414141554141446F4741414136426741414141564141446F4751414136426B41414141574141446F4767414136426F41414141584141446F477741413642734141414159';
wwv_flow_imp.g_varchar2_table(243) := '4141446F48414141364277414141415A4141446F4851414136423041414141614141446F4867414136423441414141624141446F4877414136423841414141634141446F4941414136434141414141644141446F4951414136434541414141654141446F';
wwv_flow_imp.g_varchar2_table(244) := '4967414136434941414141664141446F4977414136434D41414141674141446F4A41414136435141414141684141446F4A51414136435541414141694141446F4A674141364359414141416A4141446F4A774141364363414141416B4141446F4B414141';
wwv_flow_imp.g_varchar2_table(245) := '364367414141416C4141446F4B51414136436B414141416D4141446F4B67414136436F414141416E4141446F4B774141364373414141416F4141446F4C41414136437741414141704141446F4C51414136433041414141714141446F4C67414136433441';
wwv_flow_imp.g_varchar2_table(246) := '414141724141446F4C77414136433841414141734141446F4D51414136444541414141744141446F4D67414136444941414141754141446F4D77414136444D41414141764141446F4E41414136445141414141774141446F4E5141413644554141414178';
wwv_flow_imp.g_varchar2_table(247) := '4141446F4E67414136445941414141794141446F4E774141364463414141417A4141446F4F41414136446741414141304141446F4F51414136446B41414141314141446F4F67414136446F41414141324141446F4F77414136447341414141334141446F';
wwv_flow_imp.g_varchar2_table(248) := '5041414136447741414141344141446F5051414136443041414141354141446F5067414136443441414141364141446F5077414136443841414141374141446F5141414136454141414141384141446F5151414136454541414141394141446F51674141';
wwv_flow_imp.g_varchar2_table(249) := '364549414141412B4141446F5177414136454D414141412F4141446F5241414136455141414142414141446F5251414136455541414142424141446F5267414136455941414142434141446F5277414136456341414142444141446F5341414136456741';
wwv_flow_imp.g_varchar2_table(250) := '414142454141446F5351414136456B41414142464141446F5367414136456F41414142474141446F5377414136457341414142484141446F5441414136457741414142494141446F54514141364530414141424A4141446F54674141364534414141424B';
wwv_flow_imp.g_varchar2_table(251) := '4141446F54774141364538414141424C4141446F55414141364641414141424D4141446F55514141364645414141424E4141446F55674141364649414141424F4141446F5577414136464D41414142504141446F5641414136465141414142514141446F';
wwv_flow_imp.g_varchar2_table(252) := '5651414136465541414142524141446F5667414136465941414142534141446F5677414136466341414142544141446F5741414136466741414142554141446F5751414136466B41414142564141446F5767414136466F41414142574141446F57774141';
wwv_flow_imp.g_varchar2_table(253) := '36467341414142584141446F5841414136467741414142594141446F58514141364630414141425A4141446F5867414136463441414142614141446F5877414136463841414142624141446F5941414136474141414142634141446F5951414136474541';
wwv_flow_imp.g_varchar2_table(254) := '414142644141446F5967414136474941414142654141446F5977414136474D41414142664141446F5A41414136475141414142674141446F5A51414136475541414142684141446F5A67414136475941414142694141446F5A774141364763414141426A';
wwv_flow_imp.g_varchar2_table(255) := '4141446F61414141364767414141426B4141446F6151414136476B414141426C4141446F61774141364773414141426D4141446F78414141364D51414141426E4141446F32774141364E73414141426F4141446F33414141364E7741414142704141446F';
wwv_flow_imp.g_varchar2_table(256) := '34414141364F4141414142714141446F34514141364F454141414272414141414141422B414F49427667626142306F4B634172454374344C3042456D456434536C684D414533775553426C73476459644B683145486834655242357148746F6654422F34';
wwv_flow_imp.g_varchar2_table(257) := '494C5968476946304963516941694A6F4979776B486953594A506F6C5843592B4A6C776D6C43636B4A35596F4D696A6B4B5577706A436F714B6D6F716C6972714B325172774377554C4859733369302B4C6667756F6938514C3651776F6A43364D5A6F78';
wwv_flow_imp.g_varchar2_table(258) := '376A4B654D76497A6F4452574E65493269446D344F6477366E44726F4F3651386B44302B507278414D4544615162354344454D6551317844714553475253684B566B707753365A4C376B77575445524D576B7961544F4A4E504531325461684E30453869';
wwv_flow_imp.g_varchar2_table(259) := '54376850366C4255554970517346446155505941414141464141442F77414D374175634147774173414445415141424E4141414242694948446745644151634F4152597A495449324A6938424E54516D4A79596A4969636A4253494746784D6541544D68';
wwv_flow_imp.g_varchar2_table(260) := '4D6A5933457A596D497945464B51454449524D694977344246784D65415434424A774D754153556942676344426834424E6A63544E6959427251736C42676F4872416F4842776F4363416B4842776D6F42516B474652494D522F3769436738424D67454E';
wwv_flow_imp.g_varchar2_table(261) := '4367484A436730435141454F432F37692F763042417745444F2F356953774543444138434C414953466730434C41494E4151344B45414573416730584551497341673843357745434178555A435467434477304E4477493343686F55417749427A41384C';
wwv_flow_imp.g_varchar2_table(262) := '2F64554A4451774B41696F4C4544482B427747774152494D2F73414C446749554377452F436730424467722B775173554167344C4155414D456741444141442F6D674F34417949414541415541454541414145694277454746426342466A493341545930';
wwv_flow_imp.g_varchar2_table(263) := '4A77456D42776B434A5349504178556A44774D5648774D7A465238444D7A38444E544D2F417A557641794D314C774D423941384C2F6D454B436747664378384B415A384C432F356843773842687635362F6E6F426577494342414D427767514541774542';
wwv_flow_imp.g_varchar2_table(264) := '417751457767454442415157424151444163494542414D4241514D45424D4942417751454179494C2F6D454B4877762B59516F4B415A384C48776F426E77732B2F6E722B65674747355145444241544341514D454242554642414D427767514541774542';
wwv_flow_imp.g_varchar2_table(265) := '417751457767454442415157424151444163494542414D424141594141502B56413734444A414162414445415351426741486B41696741414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A595846686357';
wwv_flow_imp.g_varchar2_table(266) := '46785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E67634742786347427859584E7863324E79636D';
wwv_flow_imp.g_varchar2_table(267) := '4A7A63324E79596E426738424A693842466863334677635842796347427963324E79636D4A77487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D744531515A434156';
wwv_flow_imp.g_varchar2_table(268) := '467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B47783036634467324B69787563546F654A6A495A4A5445594B69775A4D43555A';
wwv_flow_imp.g_varchar2_table(269) := '4D6959354F473430623345316353524B4E456F6C4A6A495A417949434E6A566158577863746B6C4B4B43674C4842313370466C6255314F474B436B46416A45444D544254566D4E59724542444F7841724C492B7A56566C4352453472417A417654314A62';
wwv_flow_imp.g_varchar2_table(270) := '5531424F4E6A6751454355774D6F7969535577794B7A417741697771526B7051533473734C77634A4D544D3152554B514F7A30694B3238654F6E45324F437771626E41364853597947535577475377714744456C475449444F446C764E4735784E58456C';
wwv_flow_imp.g_varchar2_table(271) := '536A524B4A43597947514141455141412F364D4475414D6941414D414267414C4145344170674438415438426C414878416A774366674C434177554458414F70412F554550774141415245684551557A427A6356495455584554456A42794D484978556A';
wwv_flow_imp.g_varchar2_table(272) := '42794D504278556642444D334D7A637A4E7A4D334D7A637A467A4D584D78637A467A4D584D7A38464E5338464979636A4E534D6E497963584977384648786B2F4244557641794D6E4E5363314A794D7641534D764154556E497963314C77456A4C774531';
wwv_flow_imp.g_varchar2_table(273) := '4A7A556E497A556E4979636A4C7745314C77456A4A7A556E4979384242534D50416855484977384246513843465163564278555041534D50415255504168555041534D5041534D50415255484651384249773843465238464D7A385A4E5338454954456A';
wwv_flow_imp.g_varchar2_table(274) := '46534D504178556642444D334D7A637A467A4D584D78637A467A4D584D7838474D7A38464E5338434979384A4979636A4A794D6E497A554849773843497738424651636A4477456A427855484977636A42794D4846513844497855504152555041694D50';
wwv_flow_imp.g_varchar2_table(275) := '415238464D7A38644D7A38444C774D46447755664668556642444D2F4244556E4E5338494E5363314C77516A4A794D6E4E533842497963314A7A55764154556A4C7745314A794D6E4E5338434E53384442534D504252556A465163564278556A46516356';
wwv_flow_imp.g_varchar2_table(276) := '4678557A46526356467855584652384A4D7A38454E5338434E5363314A7A556E4E5363314A7A55334E5463314E7A55334E5463314C77514649773844465163584651635642785548465163564477675648774D7A507759314E7A552F427A55334E544D31';
wwv_flow_imp.g_varchar2_table(277) := '4E7A55334E5363314C774D46497738444652635646785558465263564877635646785566416A4D5648774D7A507751314C7773314A7A556E4E5363314A7A55764241556A447755564278555044785566425438434E5438424E54637A4E7A552F416A4D2F';
wwv_flow_imp.g_varchar2_table(278) := '436A55334C77514644775566416855584652637A467A4D66416A4D6641544D56467855584652637A4877457A467A4D584652635648774556487749564877497A507755314C787746497738494977636A42794D484977636A42794D504242556642544D33';
wwv_flow_imp.g_varchar2_table(279) := '4D7A637A4E7A4D334D7A384C4D7A637A50774531507745314E7A552F42445576424155504252556642544D66415255584D78637A487745564877457A4678556642444D584D7838474D7A38464E53385749534D5046785566426A4D2F43444D2F42445533';
wwv_flow_imp.g_varchar2_table(280) := '4D7A637A4E7A552F4154552F41544D2F424455764241456E415A722B776552796E5037496E4173474377554D425155474A67594B4341514341774542416759454351517242516B46425155464367556542516F4642515546436751594351554541775145';
wwv_flow_imp.g_varchar2_table(281) := '41514545417751484A675547425173474377623042515146417751454167494941677748434163454177514442414D484267635041676B43417845454177514A435151454177514241674D4341514944416745434567454A424159424177514441514D49';
wwv_flow_imp.g_varchar2_table(282) := '42414D42417745444151674542415142424167424241723938515545434155454151514542417745424151494177454442414D454177514A415138434151494441775543415151444177454341774D4942416B4642775546454159434267495042775948';
wwv_flow_imp.g_varchar2_table(283) := '4177514442414D45427767454241634341514943417751494151515344516F464277594341674D49434151424341516D42416744424151454277514941786F444341634841776B46424151454177514242414D4841514D46424151454241514A42435945';
wwv_flow_imp.g_varchar2_table(284) := '435155454241554E7251514942676342417767444152554441514D4441516B424441454A43514D444167454341774D49424145454167494341774D494241554543514D49417749454177494441674D434177494441774D4341774D4441774D4441774D47';
wwv_flow_imp.g_varchar2_table(285) := '41794D434177514541674946424167426841554942414D444177454741774D434177494441674D4341776357415151424241454741774943424151444241554A424151454177514241674943415149424167454341674942415145494151454241674945';
wwv_flow_imp.g_varchar2_table(286) := '415149484177494241674D434151494741776B4441774D452F634D464241674441774943415149424151454241514543415167434151454241774D45424151464351514441775142416755444167454241514542415149424151494441776B4337675545';
wwv_flow_imp.g_varchar2_table(287) := '434159434151454241514543434149424167494541525942415151444441554A4241594642414D4B4167674241674543416749484151454241514545417751492F4B634643416745416745424151494741674943415151424267494B4177514241775945';
wwv_flow_imp.g_varchar2_table(288) := '42516B45424151444241494245674543415149424167494342774942415145424167634442514C774241554542414D454167494841674D464167514241674D4D43674D4541675142415151444241514A4341554841773843415159464341454241515942';
wwv_flow_imp.g_varchar2_table(289) := '416745434151494341676B424167494442416A397251514942414D434167494642677747415177424267634441514D4441516348417745484277454441514D4543415145444151454241514A4241514542514942415151454178554442416F4847514D4B';
wwv_flow_imp.g_varchar2_table(290) := '41674D4441774D4441774D4342674D4341774944416767426E415545424145484368774C42784945437751484241514842416745454167454177494341515145417751464441554E42415545425167464A67514A42415145424151454151514441514D42';
wwv_flow_imp.g_varchar2_table(291) := '417751454341514A4241494341514947417751462F6B5145425151474167494241674D44425151424241304A4151304242415546424145454251554B42526B4242414555426755464251734B4351554542414D4541514944417751484577554542515545';
wwv_flow_imp.g_varchar2_table(292) := '425155454A5234494241514A44414D4E41684946424155444152514542416B494669774642515146425155454252734542675142415149444177514542416B444267554C42515546426851424867554B4251554541515142424155634451514242415544';
wwv_flow_imp.g_varchar2_table(293) := '4167454341674D45434148362F7367424F4446615072713666514879415145424151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B';
wwv_flow_imp.g_varchar2_table(294) := '41516B484267634442414D454177514843416355424130454243414441774943416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D45';
wwv_flow_imp.g_varchar2_table(295) := '4177454444414D42417745444151674542415142424151454151514E467755464241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D4541514943';
wwv_flow_imp.g_varchar2_table(296) := '425177464351514442674942415145424151494342774943417749434167454341774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B4243515144417745444177454443776348';
wwv_flow_imp.g_varchar2_table(297) := '43516B45417751454151454541777744424159444177494441774D4441774D4341774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48';
wwv_flow_imp.g_varchar2_table(298) := '417767444177494241514D434241674A42414945435151454241514542514D4241774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E';
wwv_flow_imp.g_varchar2_table(299) := '4351514543515142424349454251454542414D444167454341674D4543416B464242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B';
wwv_flow_imp.g_varchar2_table(300) := '424449454251514942415943416759494367555A41515142464159464251554C426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F424241594341514544';
wwv_flow_imp.g_varchar2_table(301) := '41675149435167424B5151464251514642516B464967554A4251554642516F4646775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C41516351';
wwv_flow_imp.g_varchar2_table(302) := '4241514D42415145424151454351516D4251554942415144424B414242414D4442416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B43';
wwv_flow_imp.g_varchar2_table(303) := '4151594445414D474177494441674D43417749444267494441774D444177644B415149424177594D41774D46417749424151454541774D454351554543414D44416745424151454343514943416745434151494241514543416749424151454541514542';
wwv_flow_imp.g_varchar2_table(304) := '4251514442515146434167444167456E415145444267514A42515145424149464177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D4541674543415149424167455145415943';
wwv_flow_imp.g_varchar2_table(305) := '4177554A41776F4241674943447749444251594D46414543415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D4541414141';
wwv_flow_imp.g_varchar2_table(306) := '425141412F35594476514D6A414259414D51413641443441524141414153594F4178595848674933506745334E6A63324A7934424A7959484E6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B41684D47447745584E526352';
wwv_flow_imp.g_varchar2_table(307) := '427963554653636C4642556E4A6963423946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D656370512F4E6D77763063724B4749384257537044';
wwv_flow_imp.g_varchar2_table(308) := '49674D6941555A2B6F624F6D506A394A43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C77507638414A6B30686C492B50415369505947526C5A47566C5A5234774677414A';
wwv_flow_imp.g_varchar2_table(309) := '4141442F6F674F3441794141437741584146494175774645416145423641497941703441414145564978557A46544D314D7A556A4E51637A46544D564978556A4E534D314D784D724151636A42794D4846513846465238464D7A38444D7A637A4E7A4D33';
wwv_flow_imp.g_varchar2_table(310) := '4D78637A467A4D584D7838424D7A38444E533845497A556A4A794D6E467738474652384B4D783847465238434D78384E4D7A38454E5338424E53636A4C77596A4C7745314979384C4979384249793848497A556E4E5338454977555041534D5042425550';
wwv_flow_imp.g_varchar2_table(311) := '424255484977635644774D6A4651635642794D564477515642794D50415255504168555041694D5041785550417855484651384B465163564877512F42444D2F4244552F4A6A557641774550425255584651635642785548465163564278554846516356';
wwv_flow_imp.g_varchar2_table(312) := '42785548465163564278555042785566424438464D7A38424D7A38424E5438424D7A637A4E7A55334E544D314E7A55334E5463314E7A55334E5463314E7A55334E5363314C77514644775556467855584652637A4877557A487745564678555846526356';
wwv_flow_imp.g_varchar2_table(313) := '4D78635646785566424438454E53384E4E5363314A7A556E4E533844415138584877512F42444D2F417A4D334D7A637A4E7A4D334D7A63314E7A4D334E54637A5077497A4E7A4D3150774D314C7751464477555648774D564877457A4877497A48774956';
wwv_flow_imp.g_varchar2_table(314) := '4877457A487745564877457A467A4D584D78637A4877497A467A4D5846544D66427A4D584652637A46544D584D7A38454E5338454979636A4A794D6E4979384B4979384549793846497747756658324D66583131586E3139586E31394D77634E4267304E';
wwv_flow_imp.g_varchar2_table(315) := '4279634E446751444177514241674D4443515146426777474677594C4267594742696B4742675947426755664241554D41774D4341675944436963474277594E422B6B464241514441774543416749474167494442675545417767424467494941675943';
wwv_flow_imp.g_varchar2_table(316) := '4241454341674543417749444251514442414D4B425159444351514A4241514442414945426745454177494441674D434151494941515544424149454167494641676343416745434351454341674D4841774944416745434177494741676F462F664D46';
wwv_flow_imp.g_varchar2_table(317) := '427745434177494441674D43417749444241454341674D4342414545424145434167494341674942416749434241494342414542415149444167494B41514943416745454151494241674543415149434151514541773445434151444151454341774543';
wwv_flow_imp.g_varchar2_table(318) := '41674942416745434151494241674944416745434341494241674943415151434241454741676F4342674D4B4177594442514D434151514743415543736751464177594341514542415145424151454341514D464177554442414D4342674D4241674D47';
wwv_flow_imp.g_varchar2_table(319) := '42416B4A42415144416745424177494241674D44416745464151774441514942415145424151454241515144424151492F4B594542514D454241454241774942417749424241454B4151514441674D43415149444151494542776B4A4241514442414945';
wwv_flow_imp.g_varchar2_table(320) := '41674D43427751424267454341514949415145424151554943414B784241514A4241554B42413846425173504267554C425345474378414942415543416751444241304A4267595542514553426763464151554242514546415277424377554242515542';
wwv_flow_imp.g_varchar2_table(321) := '425173504151514241774D4341515144424151492F643445424151444167494241674D454451494241674D4341514944417773434151674441775542416745434151494241674D44415149424167454342414D4741773044485149444451514444516B46';
wwv_flow_imp.g_varchar2_table(322) := '434155434151514442415144424167444641495241776B464551494742514D464251554341513843425149434151514442424545424155434958324D6658324D66526439586E312B58514754415149474151494541674D4543416B464241514442414543';
wwv_flow_imp.g_varchar2_table(323) := '4167494541674542415145424251454742414D4A4251674941675147415145425477454241774D4542415146435151474151494242674D454167674F4177674442674D45415149434177514442414D4842774D494178494B43414945416749444177674B';
wwv_flow_imp.g_varchar2_table(324) := '4277634244416745424151454241514543774548417759434267494442514D484177494443514D43416763434167494341514542416749454167554D41515143416749434167454341674943416745454167454341674D45415151424241454341774944';
wwv_flow_imp.g_varchar2_table(325) := '4167454341774942416759434151494741774D434251494241673844416745434151494442674D4441774D4441774D444151514A4251674441774D4242414D4442415946417749464151494441674D43417749444177494641674D434441494441674D43';
wwv_flow_imp.g_varchar2_table(326) := '4177514442414D4741776F444267494B415159434251514542416B4A426751422F735942416749494241514542444D4443514D474167594441774D4441774D4741674D444351494F417767424451554C4251594B42775146435151474167494341674D44';
wwv_flow_imp.g_varchar2_table(327) := '41774D4742675946415155484479594443674D4442774D4442414D4442414D4442414D48417734444C41554A43415143417749544151494441776745477759484577634E4577594844515966445155424251454641515542425145464151454542415143';
wwv_flow_imp.g_varchar2_table(328) := '4167494441776B4A434159474251595143775952425159474253384742515947444159484251634741763679415149474241514742416B454177554A41674D454177774242414D454177634A4351674441774D43416745474167594441674D4341774D50';
wwv_flow_imp.g_varchar2_table(329) := '42674544417745444241634D424145444241514543516745417749434167454441675145435151464241514441516F434167494341674942415163434251454241514D434167454341514942415145424151494341675143435145424241454541515148';
wwv_flow_imp.g_varchar2_table(330) := '4251514A4341514341774544427759444177594341674D424177494441676B4341774942424145454451454341414141415141414141414451414B4741444D414141456944674548426859584A696348466863324E79596E427934424E6A632B41525958';
wwv_flow_imp.g_varchar2_table(331) := '486749484467496E4A675965415263794E7A597A506749334E6934424A79594345543531566849564679677357677969554341504A4263634968635A49694A6E627938745078594D433056694E4130534152554F4342454D426A31725251674A49557730';
wwv_flow_imp.g_varchar2_table(332) := '51774B464E563438515977334342493749412B67554163456B536873617967714C514D624631526E4D544E554D4145424642734E4151494343556872506A74315942776B41414141417741414141414337674B4B41414D414277414C4141415445544D52';
wwv_flow_imp.g_varchar2_table(333) := '4D78457A45544D524D7848365A47526B5A4751436976326F416C6A3971414A592F6167435741414141416B4141502B69413777444951414441416741496741784145634158414278414951416C5141414151594849514D57467945324577596A42676347';
wwv_flow_imp.g_varchar2_table(334) := '42785958466A63324E7A59584E686357467A596E4A69636D427959584268635746785958466863574E69596E4A696346426763474477454742775958466A63324E7A59334E6A38424E6A633241515948426863574651594842676347466A34424E543442';
wwv_flow_imp.g_varchar2_table(335) := '4A793442425159484268635746525958466863574E54516E4A69636D4E533442415159484267634742794947427759584E6A63324E7A5975415155474678595846686357467A596E4C67456A4A69384241665267594147417747517A2F74497A61417763';
wwv_flow_imp.g_varchar2_table(336) := '4B52496543676755444277524341344A47544D644468594C4368775946516A7149417347486734464B6949554651514F4F6B5839385230624542734F4451734D41775164445259514367385144526B4643414B5A46415543416745424177736741684159';
wwv_flow_imp.g_varchar2_table(337) := '457863544267494E2F4B5158424149484241734944524D69454167434577454E417134544A423450476863524A514D45467A63314E4377484167333932526F464242595245303945467751444A5246514F4159434D71797441536130576C6F4231514942';
wwv_flow_imp.g_varchar2_table(338) := '4251675846414942427755424167494342674D424651344D426751424155384B4651306144415576506730544B4174664B776F4D4852456D45773059476738544268416B48413057447777574442542B30515555437830514341304A5154775244675154';
wwv_flow_imp.g_varchar2_table(339) := '446A4A744E67634A4567555A44694958435330594A686F464751386C4641632F5051674C2F724D4A4678494A445159564451384C43686F594A6763544467454B4567345344516F7343517350444255594D514D41414141524141442F6F774F3441794941';
wwv_flow_imp.g_varchar2_table(340) := '44774166414445416441444B41536742637747324167344357774B654176594454414F4F41394D4548775270414141424A675948426834434E7A34424E7A596D4A7959484E68344344674D75416A59335067455842673842446745574678592B41547342';
wwv_flow_imp.g_varchar2_table(341) := '4E534D324E79596E4B77455649773844465238454D7A637A4E7A4D584D78637A467A4D584D78637A4877597A507755314C77496A4C776B6A4A794D6E4979636A4E513845497738424651636A4477456A427855484977636A42794D484651384449785550';
wwv_flow_imp.g_varchar2_table(342) := '4152555041694D50415238464D7A38644D7A38444C774D6A42513846487859564877517A507751314A7A55764344556E4E5338454979636A4A7A557641534D6E4E5363314C774531497938424E53636A4A7A5576416A5576424155504252556A46516356';
wwv_flow_imp.g_varchar2_table(343) := '4278556A465163564678557A46526356467855584652384A4D7A38454E5338434E5363314A7A556E4E5363314A7A55334E5463314E7A55334E5463314C775546447755564278555044785566425438434E5438424E54637A4E7A552F416A4D2F436A5533';
wwv_flow_imp.g_varchar2_table(344) := '4C77516A4251384648774956467855584D78637A4877497A4877457A46526356467855584D7838424D78637A467855584652384246523843465238434D7A38464E533864425138494977636A42794D484977636A42794D504242556642544D314D7A637A';
wwv_flow_imp.g_varchar2_table(345) := '4E7A4D334D7A384C4D7A637A50774531507745314E7A552F4244557642434D444B7745484977636A46534D4849773848465238454D7A637A4E7A4D334D7A637A4E7A4D584D78637A467A4D584D78637A507755314C77556A4A794D314979636A4A786350';
wwv_flow_imp.g_varchar2_table(346) := '4252385A507751314C774D6A4A7A556E4E53636A4C77456A4C7745314A794D6E4E533842497938424E5363314A794D314A794D6E497938424E533842497963314A794D7641675550416855484977384246513843465163564278555041534D5041525550';
wwv_flow_imp.g_varchar2_table(347) := '4168555041534D5041534D50415255484651384249773843465238464D7A385A4E533845497745504178554846785548465163564278554846513849465238444D7A38474E546331507763314E7A557A4E5463314E7A556E4E5338444977555042425558';
wwv_flow_imp.g_varchar2_table(348) := '465263564678555846523848465263564877497A465238444D7A38454E53384C4E5363314A7A556E4E5363314C77516A45773845465238464D7838424652637A467A4D664152556641544D58465238454D78637A4877597A507755314C78634644786356';
wwv_flow_imp.g_varchar2_table(349) := '4877597A5077677A507751314E7A4D334D7A6331507745315077457A507751314C77516A416652416278635A47465A2B4F6A3152415152454F5373794A6B677A457734725156424C4F426F4A4668685159776B5548516B4A424167454351304557566B53';
wwv_flow_imp.g_varchar2_table(350) := '4A67342F4241344E436755484267494341776749424145494243594543414D45424151484241674447674D494277634443515545424151444241454541776342417755454241514542416B454A67514A425151454251327842514D474277454443414D42';
wwv_flow_imp.g_varchar2_table(351) := '46514D4241774D424351454D41516B4A41774D4341514944417767454151514341674944417767454251514A417767444167514441674D434177494441674D444177494441774D4441774D44417759444977494442415143416755454341554268415145';
wwv_flow_imp.g_varchar2_table(352) := '42414D444177454741774D434177494441674D4341776357415151424241454741774943424151444241554A424151454177514241674943415149424167454341674942415145494151454241674945415149484177494241674D434151494741776B44';
wwv_flow_imp.g_varchar2_table(353) := '41774D45436633484241674441774943415149424151454241514543415167434151454241774D45424151464351514441775142416755444167454241514542415149424151494441776B45416F30464241514442414943427749444251494541514944';
wwv_flow_imp.g_varchar2_table(354) := '44416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A415149434177514942663275424151454177494341675547444159424441454742774D4241774D42427763444151634841514D42';
wwv_flow_imp.g_varchar2_table(355) := '417751494241514D4241514542416B4542415146416745424241514446514D454367635A41776F4341774D4441774D44417749474177494441674D4343413442705151454151634B484173484567514C4241634542416345434151514341514441674942';
wwv_flow_imp.g_varchar2_table(356) := '42415144424155524451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D454251536E425159474377554D425155474A67594B4341514341774542416759454351517242516B4642515546';
wwv_flow_imp.g_varchar2_table(357) := '4367556542516F464251554643675159435155454177514541514545417751484A6755474251734743776276424155444241514341676743444163494277514442414D454177634742773843435149444551514442416B4A424151444241454341774942';
wwv_flow_imp.g_varchar2_table(358) := '41674D434151495341516B454267454442414D42417767454177454441514D4243415145424145454341454543676A39394151494251514242415145444151454241674441514D454177514442416B424477494241674D444251494242414D4441514944';
wwv_flow_imp.g_varchar2_table(359) := '41776745435155484251555142674947416738484267634442414D45417751484341514542774942416749444241674541713845434159434151454241514543434149424167494541525942415151444441554A4241594642414D4B4167674241674543';
wwv_flow_imp.g_varchar2_table(360) := '416749484151454241514545417751494250796D42415149424149424151454342674943416745454151594343674D4541514D474241554A4241514541775143415249424167454341514943416763434151454241514948417755456C41554542674943';
wwv_flow_imp.g_varchar2_table(361) := '41514944417755454151514E4351454E4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D4642415546424155464243556543415145435177444451304347675146417745554241514A';
wwv_flow_imp.g_varchar2_table(362) := '43425973425155454251554642415562424159454151454341774D454241514A417759464377554642515955415234464367554642414545415151464841304541515146417749424167494442416745416A5142537A733567466B654652567451443578';
wwv_flow_imp.g_varchar2_table(363) := '4768556E415349395355772F4B4163614F453152495355734D68496A4E67455045514D444151595A496B5149375145434167554D42516B454177594341514542415145434167634341674D434167494241674D444341554A43414D464167454341514942';
wwv_flow_imp.g_varchar2_table(364) := '41674943435149424151456E4151454442514945415149504177494241676B4D4351454A42414D4441514D4441514D4C4277634A43515144424151424151514444414D4542674D4441674D4441774D44417749444177494441674D434177494442414D57';
wwv_flow_imp.g_varchar2_table(365) := '41774D4943516B4841775138415145444177514E4251734341774D4441774D4441674D4443694D4442774D484241344C4177634443414D44416745424177494543416B454167514A42415145424151464177454441514D4541514D5142414D4241776744';
wwv_flow_imp.g_varchar2_table(366) := '41516F4241774D4241774D4241774D424267514A41514D4341774D437177454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D444167454341674D4543416B4642424945437751484241514842416745';
wwv_flow_imp.g_varchar2_table(367) := '48675149424163454241634542416B45424151444241463341514944417767484241634547674D4C4377634742414D4846413844427745494251514643414D44416749434167634241785542417773424278414542417745424151454241514A42435946';
wwv_flow_imp.g_varchar2_table(368) := '4251674542414D456F51494341774D4543516B4A4267454D4151594D42675544417749424241454541514946424149434151454242414542415159424151454341514543417763464241554543414D444351494242674D514177594441674D4341774944';
wwv_flow_imp.g_varchar2_table(369) := '41674D4741674D4441774D4442774E4E415149424177594D41774D46417749424151454541774D454351554543414D4441674542415145434351494341674543415149424151454341674942415145454151454242515144425151464341674441674543';
wwv_flow_imp.g_varchar2_table(370) := '7A67454241514548416749454177514542416B454251594441676B4341514542415145424167554241674D444341514642416B4441774D484151454241564D424167494542776B4A4367454A427759484177514442414D45427767484641514E42415167';
wwv_flow_imp.g_varchar2_table(371) := '41774D434167494341774D49435155474251554541515142424155634451514243415142424151454341454441514D42417751494177454442414D424267514841676F42424151424177514441514D4D4177454441514D42434151454241454542415142';
wwv_flow_imp.g_varchar2_table(372) := '4241305842515545415151424351554B425177454251514541775142416755484442344942416B45464163494277514442414D454177634742414D4842515145435151454177542B78514545434151454241516542516F46425155464351556E42515146';
wwv_flow_imp.g_varchar2_table(373) := '43516F454D67514642416745426749434267674B42526B424241455542675546425173474A675547425173474377595742676B4941774D4545414542426767494351595242515946426773464951594C4251554B426738424241455A42516F4242415943';
wwv_flow_imp.g_varchar2_table(374) := '4151454441675149435167424B5151464251514642516B464967554A4251554642516F4646775545427749432F72494241775945435155454241514342514D454351454743514D4341514944416745434177514443674949415149424167494441514944';
wwv_flow_imp.g_varchar2_table(375) := '4177674642416B4541774D444241494241674543415149424542414741674D4643514D4B41774D4241674943447749444251594D46414543415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D43';
wwv_flow_imp.g_varchar2_table(376) := '41514944416745434567454A42414D464241514542516B4541774D454141594141502B56413734444A414162414445415351426741473041656741414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A5958';
wwv_flow_imp.g_varchar2_table(377) := '4668635746785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E68635546534D564D78557A4E544D31';
wwv_flow_imp.g_varchar2_table(378) := '497A55484D6A4D564D78556A46534D31497A557A41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B';
wwv_flow_imp.g_varchar2_table(379) := '4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E50556F596E3539366E3539684A5353666E306D676F414D69416A5931576C3173584C5A4A5369676F437877646436525A57314E54';
wwv_flow_imp.g_varchar2_table(380) := '6869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B44733949697464';
wwv_flow_imp.g_varchar2_table(381) := '546B35386E4A78386E4269645370326453674141427741412F35554476674D6B414273414D51424A414741416151427441484D414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A6763324678595846686357';
wwv_flow_imp.g_varchar2_table(382) := '4267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A595842673842467A55584551636E4642556E4A525156';
wwv_flow_imp.g_varchar2_table(383) := '4A79596E41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B32655030464642423467';
wwv_flow_imp.g_varchar2_table(384) := '50444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570464E6D77763063724B474938425753704449674D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A';
wwv_flow_imp.g_varchar2_table(385) := '574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969756A4A6B30686C492B50415369505947526C';
wwv_flow_imp.g_varchar2_table(386) := '5A47566C5A523477467741444141442F6D674F34417949414541415541454941414145694277454746426342466A4933415459304A77456D42776B434E7949504242384344774966424438434877492F4243384350774976424138434A7A556E41665150';
wwv_flow_imp.g_varchar2_table(387) := '432F356843676F426E777366436747664377762B595173504159622B6576353639414943424138444151454469596B4441514544447751454251534A69515146424151504177454241346D4A41774542417738454241554569596B454179494C2F6D454B';
wwv_flow_imp.g_varchar2_table(388) := '4877762B59516F4B415A384C48776F426E77732B2F6E722B6567474772514544447751454251534A69515146424151504177454241346D4A41774542417738454241554569596B454251514544774D4241514F4A695145434141414141414D4141502B57';
wwv_flow_imp.g_varchar2_table(389) := '4137384449674162414449415377414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442427759484677594846686333467A5933';
wwv_flow_imp.g_varchar2_table(390) := '4A79596E4E7A59334A6963474477456D4A77487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E443039495279737341514E414F547849527041334F5449514A69684149314A48485470774F4459714C473578';
wwv_flow_imp.g_varchar2_table(391) := '4F68346D4D686B6C4D5267714C426B774A526B79417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A35424978555762683436635459344C437075';
wwv_flow_imp.g_varchar2_table(392) := '63446F644A6A495A4A54415A4C436F594D53555A4D674141436741412F35494477514D6A414277414E77425241476F416277427A414863416577422F41494D414141456949794948426763474277595746785958486745334E6A632B415463324C67456E';
wwv_flow_imp.g_varchar2_table(393) := '4A69636D427A497A4E68635746785958466759484267634F4153636D4A79596E4A6A63324E7A34424679496A496763474277594842685958466863574E6A63324E7A34424A79596E4C6745484D6A4D794678595846686357426763474277597541536375';
wwv_flow_imp.g_varchar2_table(394) := '415463324E7A344242785552495245464D78456A4578557A4E5163564D7A554846544D314278557A4E51487A41514A6A586C74415168595648693476534569795756784C536D67564668746553456C574F4473464256785756446B36447841714E44564B';
wwv_flow_imp.g_varchar2_table(395) := '544C5254565473394852774A436934317547344642565250537A4930435173324F44704D534A314652693077486851564E6A4F4F54774D44533056444B797747434463314F4556456A3359674967496649546F6F593251424C7637712F7634617973724B';
wwv_flow_imp.g_varchar2_table(396) := '7973724B79674D694C69314F554746577330314F4D7A5571446738774C704657563632624E6A6355446A45424C53744D54567453714552474A796F4B49434641503164555756744B56326B724B797049535652506E5473384778734E4A53592F514B4E50';
wwv_flow_imp.g_varchar2_table(397) := '556A7336517A416E4A6B42425330654C4D6A515346427456506B4357516B557248794A3544503651415877592F7251424A786B5A53686759565267595452675941414141454141412F364D4475414D694141734146774261414C49424341464C41614142';
wwv_flow_imp.g_varchar2_table(398) := '2F514A49416F6F437A674D52413267447451514242457341414145564978557A46544D314D7A556A4E51637A46544D564978556A4E534D314D784D784977636A42794D564977636A447763564877517A4E7A4D334D7A637A4E7A4D334D78637A467A4D58';
wwv_flow_imp.g_varchar2_table(399) := '4D78637A467A4D2F4254557642534D6E497A556A4A794D6E46794D504252385A507751314C774D6A4A7A556E4E53636A4C77456A4C7745314A794D6E4E533842497938424E5363314A794D314A794D6E497938424E533842497963314A794D764151556A';
wwv_flow_imp.g_varchar2_table(400) := '4477495642794D504152555041685548465163564477456A44774556447749564477456A4477456A447745564278555041534D504168556642544D2F47545576424345784978556A44774D564877517A4E7A4D334D78637A467A4D584D78637A467A4D66';
wwv_flow_imp.g_varchar2_table(401) := '426A4D2F4254557641694D7643534D6E4979636A4A794D3142794D5041694D5041525548497738424977635642794D484977636A4278555041794D56447745564477496A4477456642544D2F48544D2F4179384442513846487859564877517A50775131';
wwv_flow_imp.g_varchar2_table(402) := '4A7A55764344556E4E5338454979636A4A7A557641534D6E4E5363314C774531497938424E53636A4A7A5576416A55764177556A44775556497855484651635649785548465263564D785558465263564678556643544D2F42445576416A556E4E536331';
wwv_flow_imp.g_varchar2_table(403) := '4A7A556E4E5363314E7A55334E5463314E7A55334E53384542534D504178554846785548465163564278554846513849465238444D7A38474E546331507763314E7A557A4E5463314E7A556E4E53384442534D5041785558465263564678555846523848';
wwv_flow_imp.g_varchar2_table(404) := '465263564877497A465238444D7A38454E53384C4E5363314A7A556E4E5363314C7751464977384646516356447738564877552F416A552F415455334D7A63315077497A50776F314E7938454251384648774956467855584D78637A4877497A4877457A';
wwv_flow_imp.g_varchar2_table(405) := '46526356467855584D7838424D78637A467855584652384246523843465238434D7A38464E53386342534D5043434D484977636A42794D484977636A447751564877557A4E7A4D334D7A637A4E7A4D2F437A4D334D7A38424E5438424E54633150775131';
wwv_flow_imp.g_varchar2_table(406) := '4C775146447755564877557A48774556467A4D584D783842465238424D7863564877517A467A4D66426A4D2F425455764669456A447863564877597A5077677A507751314E7A4D334D7A6331507745315077457A507751314C775142726E31396A483139';
wwv_flow_imp.g_varchar2_table(407) := '64563539665635396653384C4267734644415546426959474367674541674D424151494742416B454B77554A4251554642516F464867554B4251554642516F4547416B4642414D454241454242414D45427959464267554C426773473941554542514D45';
wwv_flow_imp.g_varchar2_table(408) := '424149434341494D4277674842414D4541775144427759484477494A41674D5242414D4543516B4542414D45415149444167454341774942416849424351514741514D45417745444341514441514D424177454942415145415151494151514B2F664546';
wwv_flow_imp.g_varchar2_table(409) := '42416746424145454241514D4241514543414D424177514442414D45435145504167454341774D464167454541774D4241674D444341514A4251634642524147416759434477634742774D454177514442416349424151484167454341674D4543414545';
wwv_flow_imp.g_varchar2_table(410) := '4567304B425163474167494443416745415167454A675149417751454241634543414D614177674842774D4A4251514542414D45415151444277454442515145424151454351516D42416B4642415146446130454341594841514D494177455641774544';
wwv_flow_imp.g_varchar2_table(411) := '4177454A4151774243516B444177494241674D44434151424241494341674D444341514642416B4443414D4342414D434177494441674D4341774D4441674D4441774D4441774D4442674D6A41674D454241494342515149415951464341514441774D42';
wwv_flow_imp.g_varchar2_table(412) := '42674D4441674D434177494441674D48466745454151514242674D4341675145417751464351514542414D45415149434167454341514942416749434151454243414542415149434241454342774D43415149444167454342674D4A41774D4442503344';
wwv_flow_imp.g_varchar2_table(413) := '4251514941774D43416745434151454241514542416745494167454241514D444241514542516B4541774D45415149464177494241514542415145434151454341774D4A4175344642416747416745424151454241676743415149434241455741514545';
wwv_flow_imp.g_varchar2_table(414) := '417777464351514742515144436749494151494241674943427745424151454242414D454350796E42516749424149424151454342674943416745454151594343674D4541514D474241554A424151454177514341524942416745434151494341676343';
wwv_flow_imp.g_varchar2_table(415) := '41514542415149484177554338415146424151444241494342774944425149454151494444416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A41514943417751492F61304543415144';
wwv_flow_imp.g_varchar2_table(416) := '416749434251594D4267454D41515948417745444177454842774D42427763424177454442416745424177454241514543515145424155434151454542414D564177514B42786B444367494441774D4441774D444167594441674D4341774949415A7746';
wwv_flow_imp.g_varchar2_table(417) := '4241514242776F63437763534241734542775145427751494242414942414D434167454542414D45425177464451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D454266354542415545';
wwv_flow_imp.g_varchar2_table(418) := '4267494341514944417755454151514E4351454E4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D464241554642415546424355654341514543517744445149534251514641774555';
wwv_flow_imp.g_varchar2_table(419) := '4241514A43425973425155454251554642415562424159454151454341774D454241514A4177594643775546425159554152344643675546424145454151514648413045415151464177494241674944424167434958324D6658324D66526439586E312B';
wwv_flow_imp.g_varchar2_table(420) := '58514756415145424151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B41516B484267634442414D45417751484341635542413045';
wwv_flow_imp.g_varchar2_table(421) := '4243414441774943416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D454177454444414D4241774544415167454241514242415145';
wwv_flow_imp.g_varchar2_table(422) := '4151514E467755464241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D4541514943425177464351514442674942415145424151494342774943';
wwv_flow_imp.g_varchar2_table(423) := '417749434167454341774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B424351514441774544417745444377634843516B454177514541514545417777444241594441774944';
wwv_flow_imp.g_varchar2_table(424) := '41774D4441774D4341774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48417767444177494241514D434241674A4241494543515145';
wwv_flow_imp.g_varchar2_table(425) := '4241514542514D4241774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D4441674543';
wwv_flow_imp.g_varchar2_table(426) := '41674D4543416B464242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B424449454251514942415943416759494367555A41515142';
wwv_flow_imp.g_varchar2_table(427) := '464159464251554C426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F42424159434151454441675149435167424B5151464251514642516B464967554A';
wwv_flow_imp.g_varchar2_table(428) := '4251554642516F4646775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C415163514241514D42415145424151454351516D4251554942415144';
wwv_flow_imp.g_varchar2_table(429) := '424B414242414D4442416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B434151594445414D474177494441674D434177494442674944';
wwv_flow_imp.g_varchar2_table(430) := '41774D444177644B415149424177594D41774D46417749424151454541774D454351554543414D444167454241514543435149434167454341514942415145434167494241514545415145424251514442515146434167444167456E415145444267514A';
wwv_flow_imp.g_varchar2_table(431) := '42515145424149464177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D45416745434151494241674551454159434177554A41776F4241674943447749444251594D46414543';
wwv_flow_imp.g_varchar2_table(432) := '415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D45414141414141674141502B61413767444967415541436B414C674179';
wwv_flow_imp.g_varchar2_table(433) := '414459414F67412B41454941414145694277594842685158466863574D6A63324E7A59304A79596E4A6763794678595846685148426763474969636D4A7959304E7A59334E6763564553455242544D5249784D564D7A554846544D314278557A4E516356';
wwv_flow_imp.g_varchar2_table(434) := '4D7A5542394870715A6A772B506A786D617652715A6A772B506A786D616E7075586C73314E7A633157313763586C73314E7A6331573134704153372B3676372B4773724B7973724B79736F44496A34385A6D7230616D5938506A34385A6D7230616D5938';
wwv_flow_imp.g_varchar2_table(435) := '506A45334E567465334635624E5463334E567465334635624E54665644503651415877592F7251424A786B5A53686759565267595452675941414141436741412F36494475414D67414138414877417841477741315146654162734341674A4D41726741';
wwv_flow_imp.g_varchar2_table(436) := '4141456D4267634748674933506745334E69596E4A6763324867494F417934434E6A632B415263474477454F41525958466A34424F774531497A59334A674D724151636A42794D4846513846465238464D7A38444D7A637A4E7A4D334D78637A467A4D58';
wwv_flow_imp.g_varchar2_table(437) := '4D7838424D7A38444E533845497A556A4A794D6E467738474652384B4D783847465238434D78384E4D7A38454E5338424E53636A4C77596A4C7745314979384C4979384249793848497A556E4E5338454977555041534D50424255504242554849776356';
wwv_flow_imp.g_varchar2_table(438) := '44774D6A4651635642794D564477515642794D50415255504168555041694D5041785550417855484651384B465163564877512F42444D2F4244552F4A6A5576417745504252555846516356427855484651635642785548465163564278554846516356';
wwv_flow_imp.g_varchar2_table(439) := '4278555042785566424438464D7A38424D7A38424E5438424D7A637A4E7A55334E544D314E7A55334E5463314E7A55334E5463314E7A55334E5363314C77514644775556467855584652637A4877557A4877455646785558465263564D78635646785566';
wwv_flow_imp.g_varchar2_table(440) := '424438454E53384E4E5363314A7A556E4E533844415138584877512F42444D2F417A4D334D7A637A4E7A4D334D7A63314E7A4D334E54637A5077497A4E7A4D3150774D314C7751464477555648774D564877457A4877497A487749564877457A48774556';
wwv_flow_imp.g_varchar2_table(441) := '4877457A467A4D584D78637A4877497A467A4D5846544D66427A4D584652637A46544D584D7A38454E5338454979636A4A794D6E4979384B4979384549793846497748305147385847526857666A6F395551454552446B724D695A494D784D4F4B304651';
wwv_flow_imp.g_varchar2_table(442) := '537A67614352595955474D4A4642304A4351514942416B4E42466C5A4569594F4F77634E4267304E4279634E446751444177514241674D4443515146426777474677594C4267594742696B4742675947426755664241554D41774D434167594443696347';
wwv_flow_imp.g_varchar2_table(443) := '4277594E422B6B4642415144417745434167494741674944426755454177674244674949416759434241454341674543417749444251514442414D4B425159444351514A4241514442414945426745454177494441674D43415149494151554442414945';
wwv_flow_imp.g_varchar2_table(444) := '4167494641676343416745434351454341674D4841774944416745434177494741676F462F664D46427745434177494441674D43417749444241454341674D4342414545424145434167494341674942416749434241494342414542415149444167494B';
wwv_flow_imp.g_varchar2_table(445) := '4151494341674545415149424167454341514943415151454177344543415144415145434177454341674942416745434151494241674944416745434341494241674943415151434241454741676F4342674D4B4177594442514D434151514743415543';
wwv_flow_imp.g_varchar2_table(446) := '736751464177594341514542415145424151454341514D464177554442414D4342674D4241674D4742416B4A42415144416745424177494241674D44416745464151774441514942415145424151454241515144424151492F4B594542514D4542414542';
wwv_flow_imp.g_varchar2_table(447) := '41774942417749424241454B4151514441674D43415149444151494542776B4A424151444241494541674D43427751424267454341514949415145424151554943414B784241514A4241554B42413846425173504267554C425345474378414942415543';
wwv_flow_imp.g_varchar2_table(448) := '416751444241304A4267595542514553426763464151554242514546415277424377554242515542425173504151514241774D4341515144424151492F643445424151444167494241674D454451494241674D4341514944417773434151674441775542';
wwv_flow_imp.g_varchar2_table(449) := '416745434151494241674D44415149424167454342414D4741773044485149444451514444516B46434155434151514442415144424167444641495241776B464551494742514D464251554341513843425149434151514442424545424155434E41464C';
wwv_flow_imp.g_varchar2_table(450) := '4F7A6D415752345646573141506E456146536342496A314A5444386F42786F34545645684A53777945694D324151385241774D4242686B69524167425341454342674543424149444241674A425151454177514241674943424149424151454241515542';
wwv_flow_imp.g_varchar2_table(451) := '426751444351554943414945426745424155384241514D444241514542516B4542674543415159444241494944674D49417759444241454341674D45417751444277634443414D53436767434241494341774D4943676348415177494241514542415145';
wwv_flow_imp.g_varchar2_table(452) := '4241734242774D47416759434177554442774D4341776B44416749484167494341674542415149434241494644414545416749434167494241674943416749424241494241674944424145454151514241674D434177494241674D434151494741674543';
wwv_flow_imp.g_varchar2_table(453) := '42674D44416755434151495041774942416745434177594441774D4441774D44417745454351554941774D44415151444177514742514D43425145434177494441674D4341774D4342514944416777434177494441674D454177514442674D4B41775943';
wwv_flow_imp.g_varchar2_table(454) := '43674547416755454241514A435159454166374741514943434151454241517A41776B444267494741774D4441774D444267494441776B4344674D4941513046437755474367634542516B45426749434167494441774D4442675947425145464277386D';
wwv_flow_imp.g_varchar2_table(455) := '41776F444177634441775144417751444177514442774D4F417977464351674541674D434577454341774D494242734742784D4844524D47427730474877304641515542425145464151554242514542424151454167494341774D4A4351674742675547';
wwv_flow_imp.g_varchar2_table(456) := '45417347455155474267557642675547426777474277554842674C2B73674543426751454267514A42414D464351494442414D4D4151514442414D4843516B4941774D4441674942426749474177494441674D444477594241774D424177514844415142';
wwv_flow_imp.g_varchar2_table(457) := '4177514542416B4942414D43416749424177494542416B45425151454177454B4167494341674943415145484167554241514544416749424167454341514542415145434167494541676B424151514242414545427755454351674541674D4241776347';
wwv_flow_imp.g_varchar2_table(458) := '41774D474167494441514D434177494A41674D43415151424241304241674141417741414141414449414A5941414D414277414C4141415446534531425255684E51555649545849416C6A3971414A592F61674357414A595A4754495A4754495A475141';
wwv_flow_imp.g_varchar2_table(459) := '4141554141502F544139514336514163414659416467434B414A34414141456942676335415251584668634742775950415255684E53636D4A79596E4E6A55354154516D427A497A4678595846683842466863574D7A4579507745574652514842676358';
wwv_flow_imp.g_varchar2_table(460) := '466863574652595646413842446745694A6938424A6A55304E7A51334E6A38424A7934424E5451334D6A637A4E6763774D51595846686365415449324E7A59334E6963774D52595846534D314978556A4E534D56497A55324579494F4152555246423442';
wwv_flow_imp.g_varchar2_table(461) := '4D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B415146494A5449424367594A49686365447745425441455048686368467A464A4167494544776B47426749464177594B44416F454267554745674947';
wwv_flow_imp.g_varchar2_table(462) := '436749424151454A48695165435145424151494B4251494543673449417745434353494341514947444359714A677747416745434D684977464A77564C784D4F4E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C';
wwv_flow_imp.g_varchar2_table(463) := '5069516B50674A6A4D534D534667344C4441385548414B46685149634641384D46796F6A4D5338424151494342414545415149464177775046673050437849424241594742416B434167454B43676F4B41514943435151474267514246414D4949673452';
wwv_flow_imp.g_varchar2_table(464) := '45414544676777474441554E4451304E42517747444259676245784D544578734967464C4E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B414141464141414141414F5041704D4141774148';
wwv_flow_imp.g_varchar2_table(465) := '4141734144774154414141544553455242544D56497A6368465345484D78556A4E79455649566B444E767A746E352F434169373930734B666E3849434C763353417050396C774A703061327472534F6C70615541417741414141414455674B3841415141';
wwv_flow_imp.g_varchar2_table(466) := '434141554141415446524568455155684553454246534D564D78557A4E544D31497A575741727A3963414A6B2F5A7742425A7562577075624172775A2F56304376437A396E4148366D3171626D317162414141414141514141502B574137304449674158';
wwv_flow_imp.g_varchar2_table(467) := '41444D415077424C414141424967344446686365416A632B415463324E7A596E4C67456E4A694D584D6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B4168634846534D564D78557A4E544D31497A55484D78557A46534D56';
wwv_flow_imp.g_varchar2_table(468) := '497A556A4E544D423846656C66305142514430376F6242525649596E4B514D4748683532546C357243465651546A6B36466863584B797845526C7059566C68445179636D41774D6A486E4B5554305A3966597839665856656658316566583044496B5A39';
wwv_flow_imp.g_varchar2_table(469) := '6F624F6D506A394A43523464656C4654574664565534636D4C7A456E4A6B4A45556B2B6E53456F764E424150466859354E5646505631704F5358412B416442396A4831396A48305866563539666C304141414141424141412F35594476514D6A41425941';
wwv_flow_imp.g_varchar2_table(470) := '4D514137414551414141456D44674D57467834434E7A34424E7A59334E6963754153636D427A5958466863574678594742775948426763474A79596E4A69636D4A79593350674958426738424A774D334E6A635841785958466863334279634841665259';
wwv_flow_imp.g_varchar2_table(471) := '706F4645415541394F364777555653474A796B4442683465646B356561315A5355446F37467863584B797845526C7059566C68445179636D41774D6A486E4B552F4245694D3442304630676A686F6B48446B4D69486831384D674D6941555A2B6F624F6D';
wwv_flow_imp.g_varchar2_table(472) := '506A394A43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C7750744D6A52576D6D2F716F65577936614151594A456C55715133535254514141426741412F35554476674D6B';
wwv_flow_imp.g_varchar2_table(473) := '414273414D51424A414741415A414270414141424A6763474277594842685958466863654154632B416A63324A7934424A79596E497959484E68635746785958466759484467456D4A7934434E7A5933506745584A676347427759484268635746785958';
wwv_flow_imp.g_varchar2_table(474) := '466A59335067496E4A696375415163324678595846676357426763474277596D4A79596E4A6A59334E6A63324677594849514D574679453241664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A';
wwv_flow_imp.g_varchar2_table(475) := '4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E5055705659474142674D426B4D2F3753';
wwv_flow_imp.g_varchar2_table(476) := '4D774D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D697377';
wwv_flow_imp.g_varchar2_table(477) := '4D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969746A724B30424A72526157674141414141474141442F6C514F2B417951414777417841456B4159414271414855414141456D427759484267634746686357467834424E7A3443';
wwv_flow_imp.g_varchar2_table(478) := '4E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A6332';
wwv_flow_imp.g_varchar2_table(479) := '4E7A5946426738424A774D334E6A6358417859584668633342796348426763423832786C59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66';
wwv_flow_imp.g_varchar2_table(480) := '573156524D6A55424243516B51555253545A342F51555545486941384D487843554570484B7977424155672B514574486A444D32464255554A796339536745434553497A6748515853434F476951634F517949654858774F47517344496749324E567064';
wwv_flow_imp.g_varchar2_table(481) := '6246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C';
wwv_flow_imp.g_varchar2_table(482) := '6979777642776B784D7A5646517041375053497264694E466161622B716835624C706F4242676B5356537044644A45574A424D4141414D4141502B574137384449674162414449414F77414141534948426763474277595746785958486745334E6A632B';
wwv_flow_imp.g_varchar2_table(483) := '415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442467759504152633146784548416574735932412F51416F4C4F54302B56453630553164415131414942783062655646545751305054306848';
wwv_flow_imp.g_varchar2_table(484) := '4B79774241304135504568476B4463354D68416D4B45416A55686B3262432F5279736F44496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B774D596558506B456A';
wwv_flow_imp.g_varchar2_table(485) := '465261694A6B30686C492B504153695041414141424141412F2F414471774C4D41424D414B7741764144774141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F41537342455345524979497541545552';
wwv_flow_imp.g_varchar2_table(486) := '4E443442457945524954636441534D564D78557A4E544D31497A58594B6B63714B6B6371416A6B7152796B7052797239787749354854456348444564645036756378307848427778727745552F75787A54553075545530437A436C484B7635594B6B6370';
wwv_flow_imp.g_varchar2_table(487) := '4B5563714161677152796B77484445642F6C67644D5277424E50374D48444564416167644D527A2B6D663773375263324C6B314E4C6B304141414141424141412F2F414471774C4D41424D414B77417641444D4141424D69446745564552516541544D68';
wwv_flow_imp.g_varchar2_table(488) := '4D6A34424E5245304C67456A42534579486745564552514F415373424553455249794975415455524E44344245794552495463564D7A58584B6B63704B556371416A6F7152796B7052797239786749364854456348444564645036756442307748427777';
wwv_flow_imp.g_varchar2_table(489) := '734145552F75776C79774C4D4B5563712F6C677152796B7052796F42714370484B5441634D52332B57423078484145302F7377634D523042714230784850365A2F75756E4C7938414141494141502F77413673437A4141544143634141424D6944674556';
wwv_flow_imp.g_varchar2_table(490) := '4552516541544D684D6A34424E5245304C67456A42534579486745564552514F41534D68496934424E524530506748584B6B63704B556371416A6F7152796B70527972397867493648544563484445642F6359644D4277634D414C4D4B5563712F6C6771';
wwv_flow_imp.g_varchar2_table(491) := '52796B7052796F42714370484B5441634D52332B57423078484277784851476F48544563414141444141442F6C674F2F41794941477741794144774141414569427759484267634746686357467834424E7A5933506745334E6963754153636D4A795948';
wwv_flow_imp.g_varchar2_table(492) := '4E6863574678595846675948426763474A696375415459334E6A632B415263474477456E417A63324E7863423632786A5944394143677335505435555472525456304244554167484852743555564E5A44513950534563724C41454451446B3853456151';
wwv_flow_imp.g_varchar2_table(493) := '4E7A6B794543596F51434E53316845694D3442304630676A68674D694E7A5A62585774637430644B4A79594C484230374F61465957314E5669796B714241474F41696B6F5255645053596B754D51774F4B5441786835632B51534D56466E556A52576D6D';
wwv_flow_imp.g_varchar2_table(494) := '2F716F6557793661414141474141442F6C514F2B417951414777417841456B415941427241486B414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C674933';
wwv_flow_imp.g_varchar2_table(495) := '4E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A5958426749484E6A63324E78636D4C7745574877456E42676347427759334E6A6332';
wwv_flow_imp.g_varchar2_table(496) := '41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238';
wwv_flow_imp.g_varchar2_table(497) := '516C424B5279737341514649506B424C5234777A4E6851564643636E505570564745305846796F6E4648305A4D54494D46694A4543426B5342676F4243785157417949434E6A566158577863746B6C4B4B43674C4842313370466C6255314F474B436B46';
wwv_flow_imp.g_varchar2_table(498) := '416A45444D544254566D4E59724542444F7841724C492B7A56566C4352453472417A417654314A625531424F4E6A6751454355774D6F7969535577794B7A417741697771526B7051533473734C77634A4D544D3152554B514F7A30694B3239432F764E42';
wwv_flow_imp.g_varchar2_table(499) := '467A41724659644F6E6C456B5357354B427830554277734749554E4D414141414141634141502B5341384544497741634144634155514271414873416A4143654141414249694D69427759484267634746686357467834424E7A5933506745334E693442';
wwv_flow_imp.g_varchar2_table(500) := '4A79596E4A6763794D7A59584668635746785947427759484467456E4A69636D4A7959334E6A632B4152636949794948426763474277595746785958466A59334E6A632B4153636D4A793442427A497A4D6863574678595846675948426763474C67456E';
wwv_flow_imp.g_varchar2_table(501) := '4C6745334E6A632B415263694267634748674933506745334E69596E4A694D584D68344344674D75416A593350674566415159504151344246686357506745374154556A4E6A636D41664D42416D4E6557304243466855654C693949534C4A5A5845744B';
wwv_flow_imp.g_varchar2_table(502) := '6142555747313549535659344F77554658465A554F546F5045436F304E55704D74464E564F7A306448416B4B4C6A5734626755465645394C4D6A514A437A59344F6B78496E5556474C544165464255324D34355041774E4C52554D724C4159494E7A5534';
wwv_flow_imp.g_varchar2_table(503) := '5255535064694169416838684F69686A4C7A397346786B59566E343650564542424551354B7A49454A555979457734725156424C4F426F4A466868514C44634A4642304A4351514942416B4E42466C5A4569594F417949754C5535515956617A5455347A';
wwv_flow_imp.g_varchar2_table(504) := '4E536F4F447A41756B565A58725A73324E78514F4D5145744B30784E57314B6F5245596E4B676F674955412F5631525A57307058615373724B6B684A56452B644F7A77624777306C4A6A39416F3039534F7A70444D43636D5145464C523473794E424955';
wwv_flow_imp.g_varchar2_table(505) := '4731552B514A5A4352537366496D464B4F7A6D415752345646573141506E45614653636A5045684D50796748476A684E5553456C4C41457845694D324151385241774D4242686B6952416741414141454141442F6C674F3941794D414667417841447741';
wwv_flow_imp.g_varchar2_table(506) := '536741414153594F4178595848674933506745334E6A63324A7934424A7959484E6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B41686347416763324E7A593346795976415259664153634742775948426A63324E7A5942';
wwv_flow_imp.g_varchar2_table(507) := '3946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D65637052504745305846796F6E4648305A4D54494D46694A4543426B5342676F4243785157';
wwv_flow_imp.g_varchar2_table(508) := '41794942526E36687336592B50306B4A4868313655564E5956315654687959764D51456D4A554E4556452B6E53456F764E424150466859354E6C42505631704F5358412B7A454C2B383045584D437356683036655553524A626B6F484852514843775968';
wwv_flow_imp.g_varchar2_table(509) := '51307741424141412F35594476514D6A414259414D51413141446F414141456D44674D57467834434E7A34424E7A59334E6963754153636D427A5958466863574678594742775948426763474A79596E4A69636D4A795933506749584267636841785958';
wwv_flow_imp.g_varchar2_table(510) := '495459423946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D656370525059474142674D426B4D2F37534D774D6941555A2B6F624F6D506A394A';
wwv_flow_imp.g_varchar2_table(511) := '43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C77507343737251456D744670614141634141502F544139514336514154414363414B77417A414463414F77412F41414154';
wwv_flow_imp.g_varchar2_table(512) := '49673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A49534975415455524E4434424678456845515568465345314978556A46544D56497A63684653454446534531317A565A4E54565A4E5149364E566F30';
wwv_flow_imp.g_varchar2_table(513) := '4E466F312F6359434F69552B4A43512B4A6633474A54346B4A4434424166722B477748502F716B57596D4A69654146582F716C32416330433654525A4E6635754E566B304E466B31415A4931575451384A44306C2F6D346C5053516B505355426B695539';
wwv_flow_imp.g_varchar2_table(514) := '4A456A2B684146386732686E5A78566D5A6D5942546D7873414141434141414141414E3941704D415367437A4141414249676335415159484F514547427A6B424267634748514555467A4178466863574D7859334F5145794E6A55304A7A4D794E7A5933';
wwv_flow_imp.g_varchar2_table(515) := '4D54596E506745304A7934424B7745324E546B424E43637541534D464E7A592F415459335067456E4C674576415445484D4449564D68633541525947427A6B4242673842446745564642637848674558466A7342466A637A4D6859584668514842697342';
wwv_flow_imp.g_varchar2_table(516) := '46534579466863574654455542694D684653457946686357427A6B424467456A4952557A4D68595846685535415251484467456A426963354153496E4A6963314A6A30424E4463324E7A59334D5459334D54597A4E444D427A4130535062677645776743';
wwv_flow_imp.g_varchar2_table(517) := '415167514C536842334E7361485155514767344E4267594D4778734F4342674F465159504342674F2F734D464267514F457759504241304745676F464151454642515543427767644442594B4167494642774D4344457557635159494241674842412F79';
wwv_flow_imp.g_varchar2_table(518) := '415434474341514843672F2B7767455042776B4543414D444377762B3863304642674D4742674947427476624F52346844516342416759524A4D4D784277514241704D4B4B494167507867674579514E4D534A4248686F4241534D634478454F43786765';
wwv_flow_imp.g_varchar2_table(519) := '46774D684F78514B4451345248524D4C4441454642774D4F465163544C68494B444149424977454942786F4A4368304D46513047417759464267454241514545425177664351596A4241554B45684D4D497759474452554D43534D444241675244776744';
wwv_flow_imp.g_varchar2_table(520) := '416745424642593041523473436951534852557A475963674241454141414D414141414141346F436167414441415941437741414578456845515568425355464A52456858774D722F5367436850362B2F6F34426367467A2F527343617633704168636A';
wwv_flow_imp.g_varchar2_table(521) := '314D7230395034354141494141502F54413951433651415441434D4141424D69446745564552516541544D684D6A34424E5245304C67456A42534579466855524641596A4953496D4E5245304E75633559546B3559546B43476A6C684F546C684F66336D';
wwv_flow_imp.g_varchar2_table(522) := '41686F724F6A6F722F6559724F6A6F43365468664F66364B4F5638344F46383541585935587A68754F536E2B69696B354F536B4264696B35414141464141442F6D674F34417949414641417041446F415377426441414142496763474277595546785958';
wwv_flow_imp.g_varchar2_table(523) := '466A49334E6A63324E43636D4A7959484D68635746785955427759484269496E4A69636D4E4463324E7A595849675948426834434E7A34424E7A596D4A79596A467A4965416734444C6749324E7A3442487745474477454F41525958466A34424F774531';
wwv_flow_imp.g_varchar2_table(524) := '497A59334A674830656D706D5044342B50475A713947706D5044342B50475A71656D3565577A55334E7A566258747865577A55334E7A5662586D6F2F6242635A47465A2B4F6A3152415152454F537379424356474D684D4F4B304651537A676143525959';
wwv_flow_imp.g_varchar2_table(525) := '554377334352516443516B454341514A4451525A5752496D44674D69506A786D617652715A6A772B506A786D617652715A6A772B4D54633157313763586C73314E7A633157313763586C73314E37314B4F7A6D415752345646573141506E45614653636A';
wwv_flow_imp.g_varchar2_table(526) := '5045684D50796748476A684E5553456C4C41457845694D324151385241774D4242686B6952416741414141464141442F6C674F3941794D41466741784144594151414247414141424A67344446686365416A632B415463324E7A596E4C67456E4A676332';
wwv_flow_imp.g_varchar2_table(527) := '467859584668635742676347427759484269636D4A79596E4A69636D4E7A344342785156495245464D6A4D47427759484267636D4E7851564954555841665259706F4645415541394F364777555653474A796B4442683465646B356561315A5355446F37';
wwv_flow_imp.g_varchar2_table(528) := '467863584B797845526C7059566C68445179636D41774D6A486E4B55666747612F73467963673867474130564545446A2F73696341794942526E36687336592B50306B4A4868313655564E5956315654687959764D51456D4A554E4556452B6E53456F76';
wwv_flow_imp.g_varchar2_table(529) := '4E424150466859354E6C42505631704F5358412B2B4A79634154677843527757435138434E41566458627039414141454141442F6C514F2B41794D414777417A41456F41595141414153594842676347427759574678595848674533506749334E696375';
wwv_flow_imp.g_varchar2_table(530) := '4153636D4A794D6D427A59584668635746785947427759484269596E4A696375415463324E7A344246794948426763474651595746785958466A59335067496E4A696375415163794678595846676355426763474277596D4A79596E4A6A59334E6A6332';
wwv_flow_imp.g_varchar2_table(531) := '416642735A47452F5167734D4E7A773955302B33566C69455477594748687831546B395741787346593174594F446F4743454641516C52527355784F4D444D67466859364F71644E57314A514D54494354454A46556B7962506B42454242386750444B41';
wwv_flow_imp.g_varchar2_table(532) := '4E56464A52796B7141306B39514570486A444D32464255554A79673954514D6941545931576C3172584C5A4A5369676F437877646436525A57314E53686967704267497841544D795646646A574B74415152736345796F735230657A566C6C43526B3475';
wwv_flow_imp.g_varchar2_table(533) := '4D6A4251553174546D7A55334467386E4D44474D6F6B6C4D4D6977764D53307253457052536F63734C51634A4D544D3152554B514F7A34684C514141414141474141442F6C514F2B417951414777417841456B415941426F414845414141456D42775948';
wwv_flow_imp.g_varchar2_table(534) := '4267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947';
wwv_flow_imp.g_varchar2_table(535) := '427759484269596E4A69636D4E6A63324E7A59584642556A46544D564E796357487745484E534D314D77487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D74453151';
wwv_flow_imp.g_varchar2_table(536) := '5A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B682B4C6970596B52496A4E6D33393844496749324E56706462467932';
wwv_flow_imp.g_varchar2_table(537) := '53556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C69797776';
wwv_flow_imp.g_varchar2_table(538) := '42776B784D7A5646517041375053497264444979766D54446568516F50586B326851414141414D4141502B574137384449674162414449415051414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A676332';
wwv_flow_imp.g_varchar2_table(539) := '4678595846686357426763474277596D4A7934424E6A63324E7A344246775943427A59334E6A63584A6963423632786A5944394143677335505435555472525456304244554167484852743555564E5A44513950534563724C41454451446B3853456151';
wwv_flow_imp.g_varchar2_table(540) := '4E7A6B794543596F51434E534B52684E467863714A78523947544544496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B774D596558506B456A46525A755176377A';
wwv_flow_imp.g_varchar2_table(541) := '515263774B78574854703441414141454141442F61674B694131494141774155414234414B5141414A534556495145524D7A4932505145304A7A3442505145304A79596A427A4D7946683042464159724151637A4D686357485145554269734241714C2B';
wwv_flow_imp.g_varchar2_table(542) := '704146632F71537756565A524979416D4B4651354F523861494349774254556C4542496348554D707677506F2F545A55556A703749684A474E7878514B43706B4A43676D4B534E754568517750695968414141414141514141502B614137674449674151';
wwv_flow_imp.g_varchar2_table(543) := '4142514161674276414141424967634242685158415259794E7745324E4363424A67634A4169557844774D564C7749504242384349773844465238444D7738434877512F41685566417A4D2F417A5566416A38454C77497A507749314C77496A50774976';
wwv_flow_imp.g_varchar2_table(544) := '424138434E533843427A4135415441423941384C2F6D454B436747664378384B415A384C432F356843773842687635362F6E6F42665151454167466A4177514542413043415145435934774541774942415149444249786A416745424167304542415144';
wwv_flow_imp.g_varchar2_table(545) := '59774543424151534241514341574D44424151454451494241514A6A6A41514441774D444249786A41674542416730454241514459774543424973444967762B59516F66432F356843676F426E77736643674766437A372B657635364159624741514944';
wwv_flow_imp.g_varchar2_table(546) := '4249786A41674542416730454241514459774543424151534241514341574D44424151454451494241514A6A6A4151444167454241674D456A474D43415145434451514542415269415149454767514341574D44424151454451494241514A6A6A415144';
wwv_flow_imp.g_varchar2_table(547) := '417A4141414141454141442F6D674F34417949414541415541426F41487741414153494841515955467745574D6A63424E6A516E415359484351496C447745584954636E4677636A4A7748304477762B59516F4B415A384C48776F426E77734C2F6D454C';
wwv_flow_imp.g_varchar2_table(548) := '447747472F6E722B65674747423942534151705331377449356B67444967762B59516F66432F356843676F426E77736643674766437A372B6576353641596267425A66392F583648334E77414141494141502B61413767444967415041424D4141424D47';
wwv_flow_imp.g_varchar2_table(549) := '46426342466A4933415459304A77456D4967634A417A734B436747664378384B415A384C432F35684368384C2F705142686747472F6E6F4265416F66432F356843676F426E777366436747664377762B527747472F6E722B65674141414141454141442F';
wwv_flow_imp.g_varchar2_table(550) := '6D674F344179494145414155414345414C6741414153494841515955467745574D6A63424E6A516E415359484351496C49673442464234424D6A34424E433442427A49654152514F415349754154512B415148304477762B59516F4B415A384C48776F42';
wwv_flow_imp.g_varchar2_table(551) := '6E77734C2F6D454C447747472F6E722B656747474F5745344F4746795954673459546B7A566A4979566D5A574D6A4A574179494C2F6D454B4877762B59516F4B415A384C48776F426E77732B2F6E722B65674747306A6868636D45344F47467959546758';
wwv_flow_imp.g_varchar2_table(552) := '4D6C5A6D566A4979566D5A574D674141414141444141442F6C674F2F417949414777417941456F4141414569427759484267634746686357467834424E7A5933506745334E6963754153636D4A7959484E6863574678595846675948426763474A696375';
wwv_flow_imp.g_varchar2_table(553) := '415459334E6A632B4152636D427734424277595846686365415463324E7A59335067456E4A6963754151487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E443039495279737341514E414F54784952704133';
wwv_flow_imp.g_varchar2_table(554) := '4F5449514A696841493149704E6A497651676B4C4567346F4A576B314F43777547686B4546685973486B7344496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B77';
wwv_flow_imp.g_varchar2_table(555) := '4D596558506B456A46525A5241686F5A575451344D7A516F4A535547427941644D6939764D44516747426F41417741412F35594476774D69414273414D6741324141414249676347427759484268595846686365415463324E7A34424E7A596E4C67456E';
wwv_flow_imp.g_varchar2_table(556) := '4A69636D427A59584668635746785947427759484269596E4C6745324E7A59335067455842676368416574735932412F51416F4C4F54302B564536305531644151314149427830626556465457513050543068484B79774241304135504568476B446335';
wwv_flow_imp.g_varchar2_table(557) := '4D68416D4B45416A55696C6759414741417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A354249785557597179744141494141502B5341384544';
wwv_flow_imp.g_varchar2_table(558) := '497741614144454141414569427759484267634748674558486745334E6A632B415463324A7934424A79596E4A67637946785958466863574267634F4153596E4A696375415463324E7A34424166426B586C7442516855554947424A52363959576B6C4B';
wwv_flow_imp.g_varchar2_table(559) := '6152595844673169536B785A4E43644B524545724C51634A4D444D30687041385069496D427838675043706D417949764C564252596C617A6D7A497A4B4134504C79325256566857577034324F42494C6A69556B506A394A526F737A4E5373554A796739';
wwv_flow_imp.g_varchar2_table(560) := '514A7046534377674951414141414D4141502B574137384449674161414338414F51414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E427A59584668635746785947427734424A696375415459334E6A6332';
wwv_flow_imp.g_varchar2_table(561) := '46775950415263684E6A38424A67487262474E675030414B437A6B38506C525074464E5851454E514341636447336C5255316B63543068484B797742413041364F3436514E7A6B794479636F514568574A4564735567454B4679735152774D694F445A61';
wwv_flow_imp.g_varchar2_table(562) := '586D7463746B644B4A79594C484277374F71465957314E5669796B71424930434B5368465230394A6953387747696B774D5965575030456A4B3159614E453739524967784E414141414141454141442F6C674F2F41794941477741794144634150514141';
wwv_flow_imp.g_varchar2_table(563) := '41534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442427859584E6A634646425568455163423632786A594439414367733550543555';
wwv_flow_imp.g_varchar2_table(564) := '5472525456304244554167484852743555564E5A44513950534563724C41454451446B38534561514E7A6B794543596F51434E53666C5A564F484C2B6851476179514D694E7A5A62585774637430644B4A79594C484230374F61465957314E5669796B71';
wwv_flow_imp.g_varchar2_table(565) := '4241474F41696B6F5255645053596B754D51774F4B5441786835632B51534D5646707046525335634949794D41524B6A41414141417741412F35594476774D69414273414D6741364141414249676347427759484268595846686365415463324E7A3442';
wwv_flow_imp.g_varchar2_table(566) := '4E7A596E4C67456E4A69636D427A59584668635746785947427759484269596E4C6745324E7A5933506745584642556A46544D564E77487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E4430394952797373';
wwv_flow_imp.g_varchar2_table(567) := '41514E414F547849527041334F5449514A69684149314A6234754B6C417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A354249785557637A4979';
wwv_flow_imp.g_varchar2_table(568) := '766D544441414141427741412F35554476674D6B414273414D51424A414741415A514276414855414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C674933';
wwv_flow_imp.g_varchar2_table(569) := '4E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A594846425568455155794D7759484267634742795933464255684E5263423832786C';
wwv_flow_imp.g_varchar2_table(570) := '59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545486941384D48784355457048';
wwv_flow_imp.g_varchar2_table(571) := '4B7977424155672B514574486A444D32464255554A796339536E67426D763742636E49504942674E46524241342F37496E414D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841';
wwv_flow_imp.g_varchar2_table(572) := '517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B447339496975626E4A77424F44454A4842594A4477493042563164';
wwv_flow_imp.g_varchar2_table(573) := '756E3041425141412F35554476674D6B414273414D51424A41474141615141414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A59584668635746785947427734424A696375416A63324E7A344246795948';
wwv_flow_imp.g_varchar2_table(574) := '426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E686347447745584E5263524277487A624756685155494C4444633850564E5074315A596845384742683463';
wwv_flow_imp.g_varchar2_table(575) := '6430395156774D5645474E6457546F3843416B39506B436D744531515A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B';
wwv_flow_imp.g_varchar2_table(576) := '52545A734C39484B79674D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D';
wwv_flow_imp.g_varchar2_table(577) := '6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969756A4A6B30686C492B5041536950414141414141514141502B574137304449774157414445414F774243414141424A67344446686365416A632B41546332';
wwv_flow_imp.g_varchar2_table(578) := '4E7A596E4C67456E4A676332467859584668635742676347427759484269636D4A79596E4A69636D4E7A344346775950415263684E6A38424A6963574677636A4A7A59423946696D67555142514430376F6242525649596E4B514D4748683532546C3572';
wwv_flow_imp.g_varchar2_table(579) := '566C4A514F6A7358467863724C455247576C685757454E444A79594441794D65637052504A4564735567454B467973515235423850306A6D53443844496746476671477A706A342F53516B65485870525531685856564F484A6938784153596C51305255';
wwv_flow_imp.g_varchar2_table(580) := '543664495369383045413857466A6B3255453958576B354A63443630476A524F2F5553494D54524B5769336333433041414141474141414141414E46417055414B51425041464D415677426241463841414145504151594842676355467859584D525958';
wwv_flow_imp.g_varchar2_table(581) := '4668635742676347447745684E7A4D2B4153636D4A7959764153596E4A6A55304E7A592F41515568426763474651595846686378466863574678594842676347427945324E7A596E4A69636D4C77456D4A7959334E4463324678557A4E5163564D7A5548';
wwv_flow_imp.g_varchar2_table(582) := '46544D314278557A4E51463842414A554B5359434778416F4A4241584177454A444274495367484B4251464E525155454677386A445349514642306B54556E2B524145614A78556E415273514B43515146774D424241514E4755582B3552385149775545';
wwv_flow_imp.g_varchar2_table(583) := '4741386B444349504651456349517263356556393362376C41705543415449774C69346F4B4267704A5255654651305A45434D724B774D74567930684968516B4469495848686B6449536F754B793464476934754B4367594B5355564868554E44413450';
wwv_flow_imp.g_varchar2_table(584) := '49536B5846697773496949554A51776A4668345A4853456E49685556637859576442555663785957414141414141514141502F54413951433651415441436341617744494141415449673442465245554867457A4954492B415455524E43344249775568';
wwv_flow_imp.g_varchar2_table(585) := '4D683442465245554467456A49534975415455524E443442467949484F51454744774547427A6B424267634748514578464263774D5234424D7859334F5145794E6A55304A7A4D794E6A63774D54596E506745334E6A516D4B7745324E546B424E436375';
wwv_flow_imp.g_varchar2_table(586) := '415373424E7A59335067456E4A6963484D444579467A6B42466759484F51454744774547467A45574877457A466A637A4D686357464163474979496E4652597A4D6859564D525148446745724152557A4D6859484F51454F4153734246544D784D685956';
wwv_flow_imp.g_varchar2_table(587) := '4F514555427759484954456D4A79596E4F51456D4E5445304E7A59334E6A38424E6A38424E6A50584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B50716F4B434264704752304E4251454242517330';
wwv_flow_imp.g_varchar2_table(588) := '4B596D4A455245444368415242414D484341344543424D544467554B4242414978676B5542516B4342776F4D41775144417749454168555A42414D43427749434D5752454351494642514D495A6A4E446851634A42414D45426369724277734441516348';
wwv_flow_imp.g_varchar2_table(589) := '7134494742674D444276377549684D57427755424151514C466B46494477494541514C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B4B415950534245564A7738554442634848426772';
wwv_flow_imp.g_varchar2_table(590) := '4B6749434668414B43524550464134424351594D4A52774D4442494C4267634A4641594D4851734F41525946425138474178555A42676348415145424151554646775547415259424451734C43414D444668414F427763574277774842674D4241684154';
wwv_flow_imp.g_varchar2_table(591) := '4942556147517755446941514C44494B41514541414141434141414141414F47416D41414167414841414154425355464553455242574D426B5147522F4E384449763575416D446A3431542B5141484134414141414141464141414141414D73416E6341';
wwv_flow_imp.g_varchar2_table(592) := '4A67424F414959416A774359414141424642554742796348467759484978557A46686331427A557A4E7A592F41536333467A6332507745314D78557A4A69636D4A7A5548465159484A7763584267636A46546357467763584E78595846544D314E6A6358';
wwv_flow_imp.g_varchar2_table(593) := '4E7963324E7A4D314979596E4E7963484A696333427A4D484678596641546358427863574877457A46513842426738424677636E427759504152556A4E53636D4C7745484A7A636E4A693842427A557A4E7A592F41536333467A63325077455849675955';
wwv_flow_imp.g_varchar2_table(594) := '466A49324E4359484D6859554269496D4E4459426E5259574B456F6F444159344F4167554D5445444268454949686B6944426F674469526542685952446759624553684B4A7773474F546B484379684C4B524D5A61526B544B556F70444159344F41674C';
wwv_flow_imp.g_varchar2_table(595) := '4A30736E4668594252795142447834634379495A4951675342674D784D514D474551676B47694D4D4778384F497738664777736B47695149456759444D6A49444268454949786B6A44426769446849674C7939414C79386745786B5A4A526F61416E6363';
wwv_flow_imp.g_varchar2_table(596) := '4841594D4A306F6F45786871475235624153514F48786F4D49786B6943424149417A417742776B494244646C4E77674C4B45736F46426471415255584B456F6F444159354F67594D4B45736F46685A704752496E5369634D426A636A4D414D4745516769';
wwv_flow_imp.g_varchar2_table(597) := '4753494D4778344F4977454F48786F4D49786F6B43424947417A4D79417759534343515A49777762487734424A413465484177694753494945416744554339424C6935424C794D614A526B5A4A526F4141414141425141412F394D4431414C7041424D41';
wwv_flow_imp.g_varchar2_table(598) := '4A774172414334414D7741414579494F41525552464234424D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B41516352495245464951636E467A63524964633157545531575455434F6A56614E445261';
wwv_flow_imp.g_varchar2_table(599) := '4E663347416A6F6C5069516B506958397869552B4A43512B4151494F2F6967426F7448773850482B48774C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B552F366C4156735869594F65';
wwv_flow_imp.g_varchar2_table(600) := '6E76375A41414141417741414141414445514B644143414157414237414141424967634F41525535415251584668634742775950415255684E53636D4A79596E4E6A55354154516D4A7959484D6863574678596641525958466863784E6A38424E6A6357';
wwv_flow_imp.g_varchar2_table(601) := '46525148426763664168595642673842446745694A6938424A69633050774D6D4A7934424A7959314E4438424E6763774651595846686357467859794E7A59334E6A63324E7A596E4E52595846534D31497855684E534D56497A5532416641724A43496E';
wwv_flow_imp.g_varchar2_table(602) := '454173514F796731476749435167495A4E4367364B4363694A47674A42526F5144416B454341594B45426B4F4167514343676B4D4867516342414542415145514E7A6F33454145424151454547774D454177635142673050426777304177494343785969';
wwv_flow_imp.g_varchar2_table(603) := '4945676749685948417749424177525749464D6A2F76416A557941436E425554524359694A526F5246426F6A4D51546E3577517749786F554B556F6D52424D565577454242515147416759434177454243414943415251614A7859624569414A46416750';
wwv_flow_imp.g_varchar2_table(604) := '4241514345424953454149454241384946416B6942414946467730664768385A4167586841517753464173574441734C444259474351594B445245424A6A6D3768495345684C7335414141414141494141502B57413730444967415841444D4141414569';
wwv_flow_imp.g_varchar2_table(605) := '44674D57467834434E7A34424E7A59334E6963754153636D49786379467859584668635742676347427759484269636D4A79596E4A69636D4E7A3443467748775636562F5241464150547568734646556869637041775965486E5A4F586D73495656424F';
wwv_flow_imp.g_varchar2_table(606) := '4F546F57467863724C455247576C685757454E444A79594441794D656370525041794A476661477A706A342F53516B65485870525531685856564F484A6938784A795A4352464A507030684B4C7A5151447859574F545A5154316461546B6C7750674541';
wwv_flow_imp.g_varchar2_table(607) := '4141554141502B56413734444A4141624144454153514267414773414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D42775948';
wwv_flow_imp.g_varchar2_table(608) := '4267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A5958426749484E6A63324E78636D4A77487A624756685155494C4444633850564E5074315A596845384742683463';
wwv_flow_imp.g_varchar2_table(609) := '6430395156774D5645474E6457546F3843416B39506B436D744531515A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B';
wwv_flow_imp.g_varchar2_table(610) := '5652684E467863714A78523947544544496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F424151';
wwv_flow_imp.g_varchar2_table(611) := '4A5441796A4B4A4A544449724D4441434C437047536C424C6979777642776B784D7A5646517041375053497262304C2B383045584D43735668303665414141414141594141502B56413734444A414162414445415351426741476F416351414141535948';
wwv_flow_imp.g_varchar2_table(612) := '42676347427759574678595848674533506749334E6963754153636D4A794D6D427A59584668635746785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E68635746785948';
wwv_flow_imp.g_varchar2_table(613) := '46675948426763474A69636D4A7959324E7A59334E686347447745584954592F4153596E466863484979633241664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B6130';
wwv_flow_imp.g_varchar2_table(614) := '5456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570564A4564735567454B467973515235423850306A6D53443844';
wwv_flow_imp.g_varchar2_table(615) := '496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D444143';
wwv_flow_imp.g_varchar2_table(616) := '4C437047536C424C6979777642776B784D7A5646517041375053497256786F305476314569444530536C6F74334E7774414141514141442F6F414F374179494143674159414359414E5142484146674161514233414951416B774368414C454176774453';
wwv_flow_imp.g_varchar2_table(617) := '414F45413967414141515943427A59334E6A63584A693842466838424A775948426763474E7A59334E684D4742773442466A6332467859324A69636D46795947466863574678592B415363754153636D425159484267634742775948426859794E7A5933';
wwv_flow_imp.g_varchar2_table(618) := '4E6934424D7949484967634F415234424E7A5958466A59304A795948426763474477454742775965415463324E7A59304A67556D42685958466863574D6A596E4A69636D42535948426863654154596E4A6A63324A67556D42686357427759654154632B';
wwv_flow_imp.g_varchar2_table(619) := '415363754151556D426863574678592B4153636D4E7934424253594842676347427759654154632B415463754151556942685958466863574E69596E4A69636D425134424277594842673842446745574E7A34424E7A34424A6755694268595848674558';
wwv_flow_imp.g_varchar2_table(620) := '466A596D4A79596E4A675547427759484267634742775948446745574E7A34424E7A5975415148304745305846796F6E4648305A4D54494D46694A4543426B5342676F424378515744456F76444145544446356D444134464444484B4441384443307774';
wwv_flow_imp.g_varchar2_table(621) := '42786B504242684A4C6754393951734B42677349425545684242455942796C524267454E2F77514B4567634E43516B55435535484442494C51756F4E44676B51436A305A4252455A42696C51434134426677774F41676F304751635A4541516152415439';
wwv_flow_imp.g_varchar2_table(622) := '77786B4643787347474249434768414244674C7044773044415441454542674848527345416737387041384F4177497842786B504253384341513043374138484251454E4D675950475167644A6759424466326F43777743434439554442454243303833';
wwv_flow_imp.g_varchar2_table(623) := '426747664443734C45786B504868454D4251384D4C31736E4341454E2F6A304C44514D4B4B324D3044413446444752504267495943516B4643673449486959664B677343455130325A536B48416730434A6B4C2B383045584D437356683036655553524A';
wwv_flow_imp.g_varchar2_table(624) := '626B6F484852514843775968513077426441495142686B5242426B5741524D5A4241785441524D59425468624367455444444A594941494B4151634643776745506C414D4567746451416354446745434242555243414D4748775152475159664A774949';
wwv_flow_imp.g_varchar2_table(625) := '425177484D44414D4577454C514334484577383741524958426A565543784D4D5855454471514972566B304C4178454D5546514B446930424767356C5867775341516F3265543449436841424767357257676F43457778625A67674C4F41454E4368452F';
wwv_flow_imp.g_varchar2_table(626) := '517777554177736D5679304A4471415246675A4A48514D534741596551675A4E4178554442775144417749454742514241526B59427855504A784D5742534976436745554741515651674D4441515544435173444641384D4367595A45674D4C4D534D48';
wwv_flow_imp.g_varchar2_table(627) := '45773441414141464141442F6C514F2B417951414777417841456B415941426F414141424A6763474277594842685958466863654154632B416A63324A7934424A79596E497959484E68635746785958466759484467456D4A7934434E7A593350674558';
wwv_flow_imp.g_varchar2_table(628) := '4A676347427759484268635746785958466A59335067496E4A696375415163324678595846676357426763474277596D4A79596E4A6A59334E6A6332467851564978557A465463423832786C595546434377773350443154543764575749525042675965';
wwv_flow_imp.g_varchar2_table(629) := '48486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545486941384D487843554570484B7977424155672B514574486A444D32464255554A796339';
wwv_flow_imp.g_varchar2_table(630) := '536F666934715544496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A';
wwv_flow_imp.g_varchar2_table(631) := '544449724D4441434C437047536C424C6979777642776B784D7A5646517041375053497264444979766D5444414141414141304141502B69413767444941414541416741444141514142514147414254414C77425251476941656B434D774B6641414142';
wwv_flow_imp.g_varchar2_table(632) := '465245684551557A45534D5446544D314278557A4E5163564D7A554846544D314179734242794D4849776356447755564877557A50774D7A4E7A4D334D7A637A467A4D584D78637A4877457A50774D314C77516A4E534D6E497963584477595648776F7A';
wwv_flow_imp.g_varchar2_table(633) := '487759564877497A4877307A507751314C7745314A794D7642694D764154556A4C77736A4C77456A4C77636A4E5363314C77516A4251384249773845465138454651636A4278555041794D56427855484978555042425548497738424651384346513843';
wwv_flow_imp.g_varchar2_table(634) := '49773844465138444651635644776F5642785566424438454D7A38454E54386D4E53384441513846465263564278554846516356427855484651635642785548465163564278554846513848465238455077557A5077457A507745315077457A4E7A4D33';
wwv_flow_imp.g_varchar2_table(635) := '4E5463314D7A55334E5463314E7A55334E5463314E7A55334E5463314A7A5576424155504252555846526356467A4D6642544D6641525558465263564678557A4678555846523845507751314C7730314A7A556E4E5363314C774D424478636642443845';
wwv_flow_imp.g_varchar2_table(636) := '4D7A38444D7A637A4E7A4D334D7A637A4E7A55334D7A63314E7A4D2F416A4D334D7A552F417A557642415550425255664178556641544D66416A4D664168556641544D664152556641544D584D78637A467A4D66416A4D584D7863564D7838484D786356';
wwv_flow_imp.g_varchar2_table(637) := '467A4D564D78637A507751314C77516A4A794D6E4979636A4C776F6A4C77516A4C77556A415630424C7637712F7634617973724B7973724B796D45484451594E4451636E4451344541774D454151494441776B454251594D426863474377594742675970';
wwv_flow_imp.g_varchar2_table(638) := '42675947426759464877514644414D444167494741776F6E42676347445166704251514541774D4241674943426749434177594642414D494151344343414947416751424167494241674D4341775545417751444367554741776B454351514541775143';
wwv_flow_imp.g_varchar2_table(639) := '4241594242414D434177494441674543434145464177514342414943425149484167494241676B424167494442774D434177494241674D434267494B4266337A4251634241674D434177494441674D434177514241674944416751424241514241674943';
wwv_flow_imp.g_varchar2_table(640) := '41674943415149434167514341675142415145434177494343674543416749424241454341514942416745434167454542414D4F424167454177454241674D42416749434151494241674543415149434177494241676743415149434167454541675142';
wwv_flow_imp.g_varchar2_table(641) := '4267494B4167594443674D474177554441674545426767464172494542514D474167454241514542415145424167454442514D464177514441675944415149444267514A435151454177494241514D4341514944417749424251454D4177454341514542';
wwv_flow_imp.g_varchar2_table(642) := '4151454241514545417751454350796D424155444241514241514D4341514D4341515142436745454177494441674543417745434241634A4351514541775143424149444167634541515942416745434341454241514546434167437351514543515146';
wwv_flow_imp.g_varchar2_table(643) := '436751504251554C44775946437755684267735143415146416749454177514E43515947464155424567594842514546415155424251456341517346415155464151554C4477454541514D44416745454177514543503365424151454177494341514944';
wwv_flow_imp.g_varchar2_table(644) := '42413043415149444167454341774D4C4167454941774D4641514942416745434151494441774543415149424167514442674D4E41783043417730454177304A425167464167454541775145417751494178514345514D4A425245434267554442515546';
wwv_flow_imp.g_varchar2_table(645) := '41674550416755434167454541775152424151464168774D2F70414266426A2B7441456E47526C4B474268564742684E474267434C51454342674543424149444241674A4251514541775142416749434241494241514542415155424267514443515549';
wwv_flow_imp.g_varchar2_table(646) := '43414945426745424155384241514D444241514542516B4542674543415159444241494944674D49417759444241454341674D45417751444277634443414D53436767434241494341774D49436763484151774942415145424151454241734242774D47';
wwv_flow_imp.g_varchar2_table(647) := '416759434177554442774D4341776B44416749484167494341674542415149434241494644414545416749434167494241674943416749424241494241674944424145454151514241674D434177494241674D43415149474167454342674D4441675543';
wwv_flow_imp.g_varchar2_table(648) := '4151495041774942416745434177594441774D4441774D44417745454351554941774D44415151444177514742514D43425145434177494441674D4341774D4342514944416777434177494441674D454177514442674D4B417759434367454741675545';
wwv_flow_imp.g_varchar2_table(649) := '4241514A435159454166374741514943434151454241517A41776B444267494741774D4441774D444267494441776B4344674D4941513046437755474367634542516B45426749434167494441774D4442675947425145464277386D41776F4441776344';
wwv_flow_imp.g_varchar2_table(650) := '41775144417751444177514442774D4F417977464351674541674D434577454341774D494242734742784D4844524D47427730474877304641515542425145464151554242514542424151454167494341774D4A43516747426755474541734745515547';
wwv_flow_imp.g_varchar2_table(651) := '4267557642675547426777474277554842674C2B73674543426751454267514A42414D464351494442414D4D4151514442414D4843516B4941774D4441674942426749474177494441674D444477594241774D4241775148444151424177514542416B49';
wwv_flow_imp.g_varchar2_table(652) := '42414D43416749424177494542416B45425151454177454B4167494341674943415145484167554241514544416749424167454341514542415145434167494541676B424151514242414545427755454351674541674D424177634741774D4741674944';
wwv_flow_imp.g_varchar2_table(653) := '41514D434177494A41674D4341515142424130424167414141414D4141502F5341794D433667414641417741455141414153496A455345524A7851564D784568455155574877456A416E4C5731774A6535626A392F41463546536F2B66514C712F4F6743';
wwv_flow_imp.g_varchar2_table(654) := '596F6C64586633384172344D46537442414141414141674141502F5441395143365141544143634154674279414859416567422B4149494141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F41534D68';
wwv_flow_imp.g_varchar2_table(655) := '496934424E5245305067455842794D4F4152515846686378466863574678594842673842495463324E7A596E4A69636D4C77456D4A7959314E446332507745484D7759484268555546785966415259584668635742775948497A59334E69636D4A795976';
wwv_flow_imp.g_varchar2_table(656) := '4153596E4A6A55304E7A595846544D314278557A4E5163564D7A554846544D31317A565A4E54565A4E5149364E566F304E466F312F6359434F69552B4A43512B4A6633474A54346B4A44352F417745774C4138494678554A4451454344524D6C4B514542';
wwv_flow_imp.g_varchar2_table(657) := '4179345146414D434451675543424D49444241524C796E356E68594C4677344A46674955435130424167304F4A35345442784D4341673449465159544351735146415237674942476647714141756B305754582B626A565A4E44525A4E5147534E566B30';
wwv_flow_imp.g_varchar2_table(658) := '504351394A6635754A54306B4A44306C415A496C50535263416877324C78594E4742554C45517750447859564751496346686B5945684D4C465167554442454E45424D564852676145513461475259574452634346417752444138504578635143686361';
wwv_flow_imp.g_varchar2_table(659) := '45784D4C465163544452454E45424D584641774D5141774D5151774D5151774D4141514141502F544139514336514154414363414B6741764141415449673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A';
wwv_flow_imp.g_varchar2_table(660) := '49534975415455524E4434424278633342524568455166584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B506758362B76344E4166543741756B305754582B626A565A4E44525A4E5147534E566B30';
wwv_flow_imp.g_varchar2_table(661) := '504351394A6635754A54306B4A44306C415A496C505352666A5930302F756B4246347741425141414141414453414B70414273414D67424B414749416567414141534948426763474477455246686357467859674E7A59334E6A63524E43636D4A79596E';
wwv_flow_imp.g_varchar2_table(662) := '4A6763794678595846686347427759484269496E4A69636D4A7A59334E6A6332427A496641525958466A49334E6A384246515948426763474969636D4A79596E4654496641525958466A49334E6A384246515948426763474969636D4A79596E46544966';
wwv_flow_imp.g_varchar2_table(663) := '41525958466941334E6A384246515948426763474969636D4A79596E41665239586A416649676342426951674C3163424346637649434D4841516369487A42656658745A4B786F5242675952475378633846777347524547426845614B316D3241514D44';
wwv_flow_imp.g_varchar2_table(664) := '477A52652B6C34304777634546426B73585042634C426B554241454441787330587670654E4273484242515A4C467A775843775A4641514241774D624E466342434663304777634546426B73566635564C426B5542414B704641735145526F452F695561';
wwv_flow_imp.g_varchar2_table(665) := '4642454A4642514A45524D624164734441526F52454173554978514A44516B4B43676B4F43524D544351344A43676F4A44516B5561774943446777554641774F42436B4C4367344A45784D4A4467734B4D414943446777554641774F42436B4C4367344A';
wwv_flow_imp.g_varchar2_table(666) := '45784D4A4467734B4D414943446777554641774F42504D4C4367344A45784D4A4467734B41416B4141502B66413730444941414B414267414A6741324145774158414271414877416B41414141515943427A59334E6A63584A693842466838424A775948';
wwv_flow_imp.g_varchar2_table(667) := '426763474E7A59334E684D4742773442466A6332467859324A69636D467959474668635746785958466A34424A79596E4A675547427759504151594842676347466A59334E6A632B415463324E4359424A67595846675948426834424E7A34424A793442';
wwv_flow_imp.g_varchar2_table(668) := '4253594746785958466A34424A79596E4C67454242676347427759484267634F415259334E6A63324C67454649675957467859664152597A4D6A596D4A7959764153596E4A6748304745305846796F6E4648305A4D54494D46694A4543426B5342676F42';
wwv_flow_imp.g_varchar2_table(669) := '4378515745464176437745534447466A4451344744437646444138454379556747786F4A474130474F464D452F66414B4377594C437938704351494447526B454A5330454667514944514B74447730444178675A4241385A427838614277494E2F4B5150';
wwv_flow_imp.g_varchar2_table(670) := '44674D464C77635A447751744167454E4171344A4351594B445167325667774245677875565163434466335A43773044436B4E674268494944773052446D4537417759454267496D5176377A515263774B785748547035524A456C75536763644641634C';
wwv_flow_imp.g_varchar2_table(671) := '426946445441467941673847475249454742514246426745433038424578674647696F684D416F46465174724F774D4C41516745437773755377384C44784550443051764252454643424D4F2F736742477738795A43304D4577454B4E6E302B42776B53';
wwv_flow_imp.g_varchar2_table(672) := '41526F506146774B41524D4D57326349432F367A4151594443516F454A426347474249444755674845773442456863464F526F4342526B594152677841775543424141474141442F6C514F2B417951414777417841456B415941426C414773414141456D';
wwv_flow_imp.g_varchar2_table(673) := '427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A595846686357';
wwv_flow_imp.g_varchar2_table(674) := '42785947427759484269596E4A69636D4E6A63324E7A5948466863324E775555465345524277487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D744531515A434156';
wwv_flow_imp.g_varchar2_table(675) := '467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B556C5A564F484C2B6851476179514D69416A5931576C3173584C5A4A5369676F';
wwv_flow_imp.g_varchar2_table(676) := '437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A';
wwv_flow_imp.g_varchar2_table(677) := '4E5556436B44733949697562525555755843434D6A4145536F774141414141514141442F6F414F374179494142774150414230414C41412B41453841594142754148734169674359414B67417467444A414E6741375141414153596E427863684E6A636E';
wwv_flow_imp.g_varchar2_table(678) := '4267636A4A7A593346674D4742773442466A6332467859324A69636D46795947466863574678592B415363754153636D425159484267634742775948426859794E7A59334E6934424D7949484967634F415234424E7A5958466A59304A79594842676347';
wwv_flow_imp.g_varchar2_table(679) := '4477454742775965415463324E7A59304A67556D42685958466863574D6A596E4A69636D42535948426863654154596E4A6A63324A67556D42686357427759654154632B415363754151556D426863574678592B4153636D4E7934424253594842676347';
wwv_flow_imp.g_varchar2_table(680) := '427759654154632B415463754151556942685958466863574E69596E4A69636D425134424277594842673842446745574E7A34424E7A34424A6755694268595848674558466A596D4A79596E4A675547427759484267634742775948446745574E7A3442';
wwv_flow_imp.g_varchar2_table(681) := '4E7A597541514C4C523544585567454B4679734D4744446D534439386648784B4C777742457778655A67774F42517778796777504177744D4C51635A44775159535334452F66554C4367594C434156424951515247416370555159424466384543684948';
wwv_flow_imp.g_varchar2_table(682) := '44516B4A46416C4F5277775343304C714451344A45416F3947515552475159705541674F4158384D4467494B4E426B4847524145476B51452F634D5A425173624268675341686F51415134433651384E4177457742424159427830624241494F2F4B5150';
wwv_flow_imp.g_varchar2_table(683) := '44674D434D51635A447755764167454E41757750427755424454494744786B4948535947415133397141734D4167672F56417752415174504E7759426E77777243784D5A4478345244415550444339624A77674244663439437730444369746A4E41774F';
wwv_flow_imp.g_varchar2_table(684) := '4251786B5477594347416B4A42516F4F4342346D48796F4C4168454E4E6D55704277494E41614930614A7A395249676F53704C634C567061415677434541595A4551515A466745544751514D557745544741553457776F42457777795743414343674548';
wwv_flow_imp.g_varchar2_table(685) := '42517349424435514442494C585541484577344241675156455167444268384545526B47487963434341554D427A417744424D424330417542784D504F77455346775931564173544446314241366B434B315A4E43774D52444642554367347441526F4F';
wwv_flow_imp.g_varchar2_table(686) := '5A56344D4567454B4E6E6B2B43416F5141526F4F61316F4B41684D4D57325949437A674244516F5250304D4D46414D4C4A6C637443513667455259475352304445686747486B494754514D564177634541774D43424267554151455A4741635644796354';
wwv_flow_imp.g_varchar2_table(687) := '466755694C776F4246426745465549444177454641776B4C4178515044416F4747524944437A456A42784D4F414141414142414141502B674137734449674144414167414667416C414463415341425A4147634164414344414A45416F514376414D4941';
wwv_flow_imp.g_varchar2_table(688) := '3051446D414141424267636841785958495459544267634F415259334E6863574E69596E4A68636D42685958466863575067456E4C67456E4A6755474277594842676347427759574D6A63324E7A597541544D6942794948446745654154633246785932';
wwv_flow_imp.g_varchar2_table(689) := '4E43636D427759484267384242676347486745334E6A63324E4359464A67595746785958466A49324A79596E4A67556D42775958486745324A7959334E6959464A67595846676347486745335067456E4C6745464A675958466863575067456E4A6A6375';
wwv_flow_imp.g_varchar2_table(690) := '4151556D427759484267634748674533506745334C6745464967595746785958466A596D4A79596E4A67554F415163474277595041513442466A632B4154632B415359464967595746783442467859324A69636D4A795946426763474277594842676347';
wwv_flow_imp.g_varchar2_table(691) := '42773442466A632B415463324C67454239474267415944415A44502B306A4E6B5369384D41524D4D586D594D4467554D4D636F4D44774D4C544330484751384547456B754250333143776F474377674651534545455267484B5645474151332F42416F53';
wwv_flow_imp.g_varchar2_table(692) := '4277304A4352514A546B634D456774433667304F4352414B50526B4645526B474B5641494467462F44413443436A515A42786B5142427045425033444751554C47775959456749614541454F41756B5044514D424D41515147416364477751434476796B';
wwv_flow_imp.g_varchar2_table(693) := '44773444416A4548475138464C77494244514C7344776346415130794267385A4342306D4267454E2F61674C444149495031514D4551454C547A6347415A384D4B777354475138654551774644777776577963494151332B5051734E41776F72597A514D';
wwv_flow_imp.g_varchar2_table(694) := '4467554D5A4538474168674A4351554B446767654A6838714377495244545A6C4B51634344514979724B30424A7252615767485841684147475245454752594245786B4544464D42457867464F46734B41524D4D4D6C676741676F424277554C4341512B';
wwv_flow_imp.g_varchar2_table(695) := '554177534331314142784D4F4151494546524549417759664242455A4268386E41676746444163774D417754415174414C676354447A7342456863474E56514C4577786451514F7041697457545173444551785156416F4F4C514561446D566544424942';
wwv_flow_imp.g_varchar2_table(696) := '436A5A355067674B45414561446D7461436749544446746D434173344151304B455439444442514443795A584C516B4F6F424557426B6B644178495942683543426B304446514D4842414D444167515946414542475267484651386E457859464969384B';
wwv_flow_imp.g_varchar2_table(697) := '415251594242564341774D4242514D4A43774D554477774B42686B534177737849776354446741414141554141502B56413734444A414162414445415351426741476B414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E';
wwv_flow_imp.g_varchar2_table(698) := '4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A595842676358';
wwv_flow_imp.g_varchar2_table(699) := '4954592F415359423832786C59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545';
wwv_flow_imp.g_varchar2_table(700) := '486941384D487843554570484B7977424155672B514574486A444D32464255554A796339536C5751523149424368637245456344496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E5759316973';
wwv_flow_imp.g_varchar2_table(701) := '51454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C6979777642776B784D7A56465170413750534972563267302F5553494D5451414141414B4141442F';
wwv_flow_imp.g_varchar2_table(702) := '6E774F39417941414241414F4142514149674179414567415741426D414867416A41414141525156495245464D6A4D47427759484267636D4E7851564954555845775948446745574E7A5958466A596D4A7959584A67595746785958466863575067456E';
wwv_flow_imp.g_varchar2_table(703) := '4A69636D425159484267384242676347427759574E6A63324E7A34424E7A59304A67456D4268635742676347486745335067456E4C6745464A675958466863575067456E4A69637541514547427759484267634742773442466A63324E7A597541515569';
wwv_flow_imp.g_varchar2_table(704) := '4268595846683842466A4D794E69596E4A6938424A69636D415363426D763742636E49504942674E46524241342F37496E4152514C777342456778685977304F42677772785177504241736C494273614352674E426A6854425033774367734743777376';
wwv_flow_imp.g_varchar2_table(705) := '4B516B4341786B5A4243557442425945434130437251384E41774D594751515047516366476763434466796B4477344442533848475138454C51494244514B7543516B47436730494E6C594D4152494D626C5548416733393251734E4177704459415953';
wwv_flow_imp.g_varchar2_table(706) := '4341384E455135684F774D47424159422B7079634154677843527757435138434E41566458627039416641434477595A45675159464145554741514C54774554474155614B6945774367555643327337417773424341514C4379354C4477735045513850';
wwv_flow_imp.g_varchar2_table(707) := '52433846455155494577372B79414562447A4A6B4C51775441516F3266543448435249424767396F58416F42457778625A77674C2F724D4242674D4A4367516B4677595945674D5A53416354446745534677553547674946475267424744454442514945';
wwv_flow_imp.g_varchar2_table(708) := '414141424141414141414E5441684D414C674141457A59334E6A6332467859584668635746785958466A6332507745324E7A593346515948426763474A79596E4A69636D4A7934424267634742775948426765574768736A4C5349744A69595947784167';
wwv_flow_imp.g_varchar2_table(709) := '4F7945644A4345594652384E46777363476951724A69736F49787779495249644E6A775647786B504778414941556F2B4A7A51624641634747413856446873304652454B435273594968496548615533496930554541674847524D754877345947776355';
wwv_flow_imp.g_varchar2_table(710) := '474351584C68774F414141484141442F3077505541756B414577416E4145304164514374414C5941767741414579494F41525552464234424D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B41526355';
wwv_flow_imp.g_varchar2_table(711) := '465159484A7763584267636A46544D57467A556A4E544D334E6A38424A7A63584E7A592F4154557A46544D75415363314278554742796348467759484978557A46686348467A63574678557A4E545933467A636E4E6A38424E51636D4A7A636E4279596E';
wwv_flow_imp.g_varchar2_table(712) := '4E51637A465263574877453346776358466838424E78556A42775950415263484A77634744774556497A556E4A693842427963334A79597641534D314D7A63325077456E4E7863334E6A384246794947464259794E6A516D427A4957464159694A6A5132';
wwv_flow_imp.g_varchar2_table(713) := '317A565A4E54565A4E5149364E566F304E466F312F6359434F69552B4A43512B4A6633474A54346B4A44354A4451345A4C68674941794D6B4177346648774944437755564478594944785549467A734547676345446734594C786B494179516B42516361';
wwv_flow_imp.g_varchar2_table(714) := '4C786F4D4430494E44786B764767674549694D444342677647416F534C42594A4642414946524156425173454168346541674D4D425263514667675146416B5743524D52434259514677594B4251496648774946436755574542594845524D4A43785164';
wwv_flow_imp.g_varchar2_table(715) := '48536B644852554D45424158454241433654525A4E6635754E566B304E466B31415A4931575451384A44306C2F6D346C5053516B505355426B6955394A4449524567514947533859456770434452593546676B5345676756454259464377554248783445';
wwv_flow_imp.g_varchar2_table(716) := '4377496A5143494543426B764751304F5167384D475338614277556B4A514D494753385A446730425167454B4568677547415946496855664151514C425255504667635146416B4246776B55454163574542594643675543494341434177774546684157';
wwv_flow_imp.g_varchar2_table(717) := '434241544352594A464241494652415742517744416A49644B4234654B42305745426351454263514141494141502F5441395143365141544143634141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F';
wwv_flow_imp.g_varchar2_table(718) := '41534D68496934424E524530506748584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B50674C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A514753';
wwv_flow_imp.g_varchar2_table(719) := '4A54306B414141444141414141414E65416B38414967416D4143774141414547427734424477454742775957467755575067456E4E525958466A34424A7845304A694948425477424A793442427851564A7955554653596E4E67483243516F4646675647';
wwv_flow_imp.g_varchar2_table(720) := '6A45594E426738424E516F5844674B446D416F574467495447416A2B374145434569666C416978716533734354674547417841444C31347643694D487A77594746417566576D51474268514C4161494D4477693648584563437735586D7071616D707161';
wwv_flow_imp.g_varchar2_table(721) := '535646524141414141416B4141502B664137304449414148414138414851417441454D415577426841484D41687741414153596E427863684E6A636E4267636A4A7A593346674D4742773442466A6332467859324A69636D467959474668635746785958';
wwv_flow_imp.g_varchar2_table(722) := '466A34424A79596E4A675547427759504151594842676347466A59334E6A632B415463324E4359424A67595846675948426834424E7A34424A7934424253594746785958466A34424A79596E4C67454242676347427759484267634F415259334E6A6332';
wwv_flow_imp.g_varchar2_table(723) := '4C67454649675957467859664152597A4D6A596D4A7959764153596E4A674C4C523544585567454B4679734D4744446D53443938664868514C777342456778685977304F42677772785177504241736C494273614352674E426A68544250337743677347';
wwv_flow_imp.g_varchar2_table(724) := '437773764B516B4341786B5A4243557442425945434130437251384E41774D594751515047516366476763434466796B4477344442533848475138454C51494244514B7543516B47436730494E6C594D4152494D626C5548416733393251734E41777044';
wwv_flow_imp.g_varchar2_table(725) := '594159534341384E455135684F774D47424159426F6A526F6E5031456943684B6B747774576C6F425767495042686B5342426755415251594241745041524D5942526F714954414B4252554C617A7344437745494241734C4C6B73504377385244773945';
wwv_flow_imp.g_varchar2_table(726) := '4C7755524251675444763749415273504D6D517444424D42436A5A395067634A4567456144326863436745544446746E4341762B7377454741776B4B424351584268675341786C4942784D4F4152495842546B614167555A474145594D514D4641675141';
wwv_flow_imp.g_varchar2_table(727) := '4141554141502B56413734444A4141624144454153514267414751414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D42775948';
wwv_flow_imp.g_varchar2_table(728) := '4267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A59584267636841664E735A5746425167734D4E7A773955302B33566C694554775947486878335431425841785551';
wwv_flow_imp.g_varchar2_table(729) := '5931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570565947414267414D69';
wwv_flow_imp.g_varchar2_table(730) := '416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D414973';
wwv_flow_imp.g_varchar2_table(731) := '4B6B5A4B5545754C4C4338484354457A4E5556436B4473394969746A724B30414142514141502B6A413767444967414541416741444141514142514147414262414C4D424351464D416145422F674A4A416F73437A774D5341326B447467514342457741';
wwv_flow_imp.g_varchar2_table(732) := '414145564553455242544D5249784D564D7A554846544D314278557A4E5163564D7A55444D534D484977636A46534D4849773848465238454D7A637A4E7A4D334D7A637A4E7A4D584D78637A467A4D584D78637A507755314C77556A4A794D314979636A';
wwv_flow_imp.g_varchar2_table(733) := '4A78636A44775566475438454E533844497963314A7A556E49793842497938424E53636A4A7A557641534D764154556E4E53636A4E53636A4A794D764154557641534D6E4E53636A4C774546497738434651636A44774556447749564278554846513842';
wwv_flow_imp.g_varchar2_table(734) := '4977384246513843465138424977384249773842465163564477456A447749564877557A50786B314C7751684D534D5649773844465238454D7A637A4E7A4D584D78637A467A4D584D78637A4877597A507755314C77496A4C776B6A4A794D6E4979636A';
wwv_flow_imp.g_varchar2_table(735) := '4E51636A4477496A4477455642794D5041534D484651636A42794D484977635644774D6A4651384246513843497738424877557A5078307A50774D764177555042523857465238454D7A38454E5363314C7767314A7A557642434D6E497963314C77456A';
wwv_flow_imp.g_varchar2_table(736) := '4A7A556E4E5338424E534D764154556E497963314C7749314C774D464977384646534D564278554846534D564278555846544D56467855584652635648776B7A507751314C7749314A7A556E4E5363314A7A556E4E5463314E7A55334E5463314E7A5576';
wwv_flow_imp.g_varchar2_table(737) := '4241556A44774D564278635642785548465163564278555043425566417A4D2F426A55334E5438484E5463314D7A55334E5463314A7A55764177556A44774D5646785558465263564678556642785558465238434D785566417A4D2F42445576437A556E';
wwv_flow_imp.g_varchar2_table(738) := '4E5363314A7A556E4E53384542534D5042525548465138504652384650774931507745314E7A4D334E5438434D7A384B4E546376424155504252384346526356467A4D584D7838434D7838424D78555846526356467A4D6641544D584D78635646785566';
wwv_flow_imp.g_varchar2_table(739) := '4152556641685566416A4D2F425455764841556A4477676A42794D484977636A42794D4849773845465238464D7A637A4E7A4D334D7A637A5077737A4E7A4D2F4154552F415455334E5438454E53384542513846465238464D7838424652637A467A4D66';
wwv_flow_imp.g_varchar2_table(740) := '4152556641544D58465238454D78637A4877597A507755314C78596849773858465238474D7A38494D7A38454E54637A4E7A4D334E5438424E5438424D7A38454E533845415630424C7637712F7634617973724B7973724B796D554C4267734644415546';
wwv_flow_imp.g_varchar2_table(741) := '426959474367674541674D424151494742416B454B77554A4251554642516F464867554B4251554642516F4547416B4642414D454241454242414D45427959464267554C426773473941554542514D45424149434341494D4277674842414D4541775144';
wwv_flow_imp.g_varchar2_table(742) := '427759484477494A41674D5242414D4543516B4542414D45415149444167454341774942416849424351514741514D45417745444341514441514D424177454942415145415151494151514B2F66454642416746424145454241514D4241514543414D42';
wwv_flow_imp.g_varchar2_table(743) := '4177514442414D45435145504167454341774D464167454541774D4241674D444341514A4251634642524147416759434477634742774D454177514442416349424151484167454341674D45434145454567304B42516347416749444341674541516745';
wwv_flow_imp.g_varchar2_table(744) := '4A675149417751454241634543414D614177674842774D4A4251514542414D45415151444277454442515145424151454351516D42416B4642415146446130454341594841514D4941774556417745444177454A4151774243516B444177494241674D44';
wwv_flow_imp.g_varchar2_table(745) := '434151424241494341674D444341514642416B4443414D4342414D434177494441674D4341774D4441674D4441774D4441774D4442674D6A41674D454241494342515149415951464341514441774D4242674D4441674D434177494441674D4846674545';
wwv_flow_imp.g_varchar2_table(746) := '4151514242674D4341675145417751464351514542414D45415149434167454341514942416749434151454243414542415149434241454342774D43415149444167454342674D4A41774D44425033444251514941774D43416745434151454241514542';
wwv_flow_imp.g_varchar2_table(747) := '416745494167454241514D444241514542516B4541774D45415149464177494241514542415145434151454341774D4A41753446424167474167454241514542416767434151494342414557415145454177774643515147425151444367494941514942';
wwv_flow_imp.g_varchar2_table(748) := '41674943427745424151454242414D454350796E42516749424149424151454342674943416745454151594343674D4541514D474241554A4241514541775143415249424167454341514943416763434151454241514948417755433841514642415144';
wwv_flow_imp.g_varchar2_table(749) := '4241494342774944425149454151494444416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A41514943417751492F61304543415144416749434251594D4267454D4151594841774544';
wwv_flow_imp.g_varchar2_table(750) := '4177454842774D42427763424177454442416745424177454241514543515145424155434151454542414D564177514B42786B444367494441774D4441774D444167594441674D4341774949415A77464241514242776F63437763534241734542775145';
wwv_flow_imp.g_varchar2_table(751) := '427751494242414942414D434167454542414D45425177464451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D4542663545424155454267494341514944417755454151514E4351454E';
wwv_flow_imp.g_varchar2_table(752) := '4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D4642415546424155464243556543415145435177444451495342515146417745554241514A43425973425155454251554642415562';
wwv_flow_imp.g_varchar2_table(753) := '424159454151454341774D454241514A41775946437755464251595541523446436755464241454541515146484130454151514641774942416749444241674348417A2B6B414638475036304153635A47556F5947465559474530594741497641514542';
wwv_flow_imp.g_varchar2_table(754) := '4151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B41516B484267634442414D454177514843416355424130454243414441774943';
wwv_flow_imp.g_varchar2_table(755) := '416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D454177454444414D42417745444151674542415142424151454151514E46775546';
wwv_flow_imp.g_varchar2_table(756) := '4241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D45415149434251774643515144426749424151454241514943427749434177494341674543';
wwv_flow_imp.g_varchar2_table(757) := '41774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B424351514441774544417745444377634843516B45417751454151454541777744424159444177494441774D4441774D43';
wwv_flow_imp.g_varchar2_table(758) := '41774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48417767444177494241514D434241674A42414945435151454241514542514D42';
wwv_flow_imp.g_varchar2_table(759) := '41774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D444167454341674D4543416B46';
wwv_flow_imp.g_varchar2_table(760) := '4242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B424449454251514942415943416759494367555A41515142464159464251554C';
wwv_flow_imp.g_varchar2_table(761) := '426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F42424159434151454441675149435167424B5151464251514642516B464967554A4251554642516F46';
wwv_flow_imp.g_varchar2_table(762) := '46775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C415163514241514D42415145424151454351516D4251554942415144424B414242414D44';
wwv_flow_imp.g_varchar2_table(763) := '42416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B434151594445414D474177494441674D43417749444267494441774D444177644B';
wwv_flow_imp.g_varchar2_table(764) := '415149424177594D41774D46417749424151454541774D454351554543414D444167454241514543435149434167454341514942415145434167494241514545415145424251514442515146434167444167456E415145444267514A4251514542414946';
wwv_flow_imp.g_varchar2_table(765) := '4177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D45416745434151494241674551454159434177554A41776F4241674943447749444251594D464145434151494241674543';
wwv_flow_imp.g_varchar2_table(766) := '42674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D454141414141414D414141414141376B436A67414441416341437741414578456845516352';
wwv_flow_imp.g_varchar2_table(767) := '4952456A4D78456A4C774F4B4D6631696A463565416F37396A774A784D50337241685839367741674141442F37674F73417338414241414A4141344145774159414345414C514132414545415467425641466F415877426B41476B416267427A41486741';
wwv_flow_imp.g_varchar2_table(768) := '66514349414934416C774368414B594171774377414C55417567432F414D51417951444F414141424D6A4D31497863794D7A556A467A497A4E534D584D6A4D31497863794D7A556A467A497A4E6863334A69734249534948467A59794E69636D4E6A556D';
wwv_flow_imp.g_varchar2_table(769) := '425259584E6A63324E79596E4251594846686357467A59334A79594644674558466759574D6A4D794E7A516E425159564D7959334A7755794D7A556A4254497A4E534D464D6A4D31497755794D7A556A4254497A4E534D464D6A4D31497755794D7A556A';
wwv_flow_imp.g_varchar2_table(770) := '4254497A4E534D4642676357467859584E6A636E4A675557467A636D4A77554742785966415459334A775557467A63324E79596E427759584D6A4D31497863794D7A556A467A497A4E534D584D6A4D31497863794D7A556A467A497A4E534D484E445568';
wwv_flow_imp.g_varchar2_table(771) := '45524D794D7845684E7851564D7A554242526B594D57495A474446684752677859686B594D57495A47444668424163594377594C465254393751304D43514D4F42674D42416745435968494E42516F52425251592F544D594577554C4541635144676F4B';
wwv_flow_imp.g_varchar2_table(772) := '4176454C417751434151494B445249484376796A427A4542426934444E526B594D667A4447526778417A305A4744483877786B594D514D39475267782F4D4D5A4744454450526B594D667A4447526778417A73464351594C45516750425241572F4C3847';
wwv_flow_imp.g_varchar2_table(773) := '4553674C42414C634552454643414D62467837394D42735A4251554345784148446D4D5A474446684752677859686B594D57495947444265475267785A526B594D54582B72682B4B697637734A6373436E5445784D5445784D5445784D544542416A4143';
wwv_flow_imp.g_varchar2_table(774) := '417A4142424167454651514850516B5142416B4D4278634E4177385742416B4E4242494845424A5741516F4C416738474152346143426764457855506C5445314D5934784E6A474F4D5455786A7A45314D566B5744774D4843774D5A47774D464452775A';
wwv_flow_imp.g_varchar2_table(775) := '477849545151774644426B4A42784D6E4B6849484568514A4267774A46536B784D5445784D5445784D5445784D534B73712F367041546A2B36366358474338414141734141502F4F41376B433867414641416B4144514152414255414751416641434D41';
wwv_flow_imp.g_varchar2_table(776) := '4A77417241433841414263314D78557A46544D314D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A557A4E544D564A54557A465345314D78556C455345524A78456845533478454446684D574978595446694D5745774454483864544544';
wwv_flow_imp.g_varchar2_table(777) := '4B54483864674F4B4D667A574D6C6B6F4D5445784D5445784D5445784D5445784B466D4B5846786358497343442F33784D41477A2F6B30414141514141502B6341384D444941414441416341446741564141414245544D524D78457A45514548467A557A';
wwv_flow_imp.g_varchar2_table(778) := '4E534D6C465163564D7855334157346D7779622B554B536B58563043553135656F774D672F487744685078384134542B34614F6A62326C756241467162364D41415141412F2B59446D414D41414263414141454642685166415259484151596641525933';
wwv_flow_imp.g_varchar2_table(779) := '41545966415259794E784D324A674F562F6D4D434157414341763470416749744177514231775144575145444161634241674C2F6F67454441563844412F346F41774D7241774D4231674D4457674543415A5542416741434141414141414F35416D5941';
wwv_flow_imp.g_varchar2_table(780) := '41774148414141544553455241524568455338446976796C41796F435A7633774168442B4851477A2F6B304141416B4141502B6E413749444867414441416341437741524142554147514166414355414B5141414152557A4E5155564D7A557A46544D31';
wwv_flow_imp.g_varchar2_table(781) := '4678557A46544D314252557A4E5155564D7A554846534D564D7A554646544D31497A555846544D314153396E2F7148616F64754365796A39665763423943676F64352F396E7039333446494448747261396D646E5A3263654B485764614E72616E30314E';
wwv_flow_imp.g_varchar2_table(782) := '766E516F6E4147644B4856314B436741437741412F38344475514C79414155414351414E414245414651415A414238414977416E414373414C7741414578557A4E544D314D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A557A46544D56';
wwv_flow_imp.g_varchar2_table(783) := '4D7A554646544D314952557A4E51555249524548455345524C6A45514D574578596A46684D5749785954414E4D6678314D514D704D66783241346F782F4E5943386C6B704D4441774D4441774D4441774D4441774B566D4A584678635849763938414951';
wwv_flow_imp.g_varchar2_table(784) := '4D50354E41624D41444141412F2F6F4475514C434141514147414163414341414A41416F414377414D414130414467415041424141414154465245684551556846534D564D78556A46544D564954557A4E534D314D7A556A4D78557A4E544D564D7A557A';
wwv_flow_imp.g_varchar2_table(785) := '46544D314D78557A4E544D564D7A554646544D314D78557A4E544D564D7A557A46544D314D78557A4E5338446976796C41796F4D4441774D2F4E595245524552516D4978595446694D57457859763155596A46684D5749785954466941734C592F684143';
wwv_flow_imp.g_varchar2_table(786) := '794379734D62597871616B78746A45784D5445784D5445784D544578357A45784D5445784D5445784D54454141414141427741412F2F6F4475514C43414151414541415541426741484141674143514141424D5A41534552425345524978557A45534552';
wwv_flow_imp.g_varchar2_table(787) := '4D7A556A4D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A55764134723870514D7144417A3831684552516D4978595446694D57457859674C432F72542B68414C494C5037674D50376A415230774D4441774D4441774D4441774D414141';
wwv_flow_imp.g_varchar2_table(788) := '414141464141442F30674D6A41756F414251414C41413441466741644141414249694D524952456E46544D524952454646794D6E4851456A46544D564E796358427A556A4E544D4363746258416C376C7550333841586C3966654E71616F313558467871';
wwv_flow_imp.g_varchar2_table(789) := '61674C712F4F6743596F6D362F667743766779426242684655467945566C5A5751696741424141412F39494449774C71414155414377414F414255414141456949784568455363564D78456845515558497963564978557A4654634363746258416C376C';
wwv_flow_imp.g_varchar2_table(790) := '7550333841586C3966654E71616F304336767A6F416D4B4A757633384172344D6757786455467945414141434141442F31674E79417538416277446B414141424967594842676347487745564A6938424D53636D4A79596E4A69636D4278554742775958';
wwv_flow_imp.g_varchar2_table(791) := '46686357467859664153636D4A79596E4A676347427A6B4242686357467859584668635746785966415345334E6A38424E6A38424E6A63324E7A596E4C67456E4A67594842676347447745314E4455324A79596E4C674569426763474277595041693842';
wwv_flow_imp.g_varchar2_table(792) := '4A69636D4A793442427A4D484D6A457A4D6859584867456641525966415438434E6A63324E7A34424F774579466838424668635742785566415459334E6A63324E7A59584F51456541526357427759484267384242676347447745684A69636D4A79596E';
wwv_flow_imp.g_varchar2_table(793) := '4A69636D4A79592B41686357467859664154636E4A69636D4A79596E4A6A632B4154633246686357467859584D525966415438424E6938424A6A63324E7A34424166494F4741634C41774D424151594941516B4D4277734C45524D5848526B4841776346';
wwv_flow_imp.g_varchar2_table(794) := '45417746434130474452414A4A79515745786351485155434751346B4C5263634F5363514251464D4177514B444251624378674B4541634B42675159455134634368495042676B47415149454341595647525948445163474277594A42674D464277634D';
wwv_flow_imp.g_varchar2_table(795) := '4278634E41514942415155464241634E42774947434167684767594842516348424155464167514341674547416749424153414B456841494467304B44416B494167514A4267304946424D594751554A4350376644694536487867754977775441674547';
wwv_flow_imp.g_varchar2_table(796) := '4552595048794963485263644452414F4267305042415944415155474452554D4377774944776F55455341424167454241674D44427751474175344F444251684844386F517730584178636744786B5147516B4C4377454C48684D6A466A456D45787379';
wwv_flow_imp.g_varchar2_table(797) := '467777504343494F4341454344687365474341524A533463495667374651634D44533433586B63634F78777448797761447863444177734C45534D4B4742424C45535532467949524377384C43524562466A456B4C7A4D675168346A4541774F41534545';
wwv_flow_imp.g_varchar2_table(798) := '4267773552786B344F4377426C534D784642634A4251494241774D4C48426C414A364148465338714568344E4367454242776B544978676D466A4D7A504734584A7955534E466B6C4853346C4478674F434177514151554E4868636747773832507A4957';
wwv_flow_imp.g_varchar2_table(799) := '4B5330534767384842774D47436849514868496F476A4172426A49374B68354748426B4F4267514141414141434141412F39734462514C674142514147414171414334414D67424D414745415A51414141534947427759484642594846544D314A6A632B';
wwv_flow_imp.g_varchar2_table(800) := '4152637A4E534D6D42544D31497863324678594846544D304E54516E4C67496E4A67636A41544D314977557A4E534D4646425958466863574E7A59584E6863574D7A59334E53496A4269637541546331497755554467456A426973424654497A466A3443';
wwv_flow_imp.g_varchar2_table(801) := '4E7A59314E44556A42544D31497745434B306F4C424149424154494241675132494E684B5A41454B4C792B4C4F787766424449424169513548776B54436632304D6A4943766A49792F554974497851624543455A4441514C43515146416841664E787366';
wwv_flow_imp.g_varchar2_table(802) := '4A774579417234574A68596A52794D554B5430394E69494241544C2B6C693475417438354B784958446A634F526A42514B434974416A45424D6A457842423065514A67624F456B6C49446B6B415149422F6B6378537A48554A3063524367494341514542';
wwv_flow_imp.g_varchar2_table(803) := '415145424151517441514D484E53465857526371477745784151556C4F53414F4852554C7A54454141414141425141412F3667446A774D554141674144414151414251414741414141526B424954556A45544D31415163584E773842467A635041526333';
wwv_flow_imp.g_varchar2_table(804) := '447745584E774A714153587136763531505434397544302B50626739506A3234505434394178542B5376354B50414C3050503758506A302B506A3439506A342B5054342B5054342B414141414141514141502F77413677437A514154414363414E774248';
wwv_flow_imp.g_varchar2_table(805) := '4141415449673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A49534975415455524E4434424679494746524555466A4D684D6A59314554516D497755684D68595645525147497945694A6A55524E446253';
wwv_flow_imp.g_varchar2_table(806) := '4B55516F4B455170416B556F5253676F52536A3975774A46487A5166487A51662F6273664E5238664E54776D4E7A636D4167736D4E6A596D2F6655434378676949686A3939526B6949674C4D4B4551702F6B346F5253676F5253674273696C454B434966';
wwv_flow_imp.g_varchar2_table(807) := '4E522F2B546838314878383148774779487A55664D54596D2F6F496D4E6A596D4158346D4E69496947503643474349694741462B4743494141414141416741412F37384469774C3341424D41484141414151344448674D33506749334279632F41533442';
wwv_flow_imp.g_varchar2_table(808) := '435145474867453341533442417149735544736442696844564330775654734C6E6F493670694A592F752F2B6D774D664D5263425852387641764D444B455657576C453748514D444C3030774E30754D4F6941672F70332B6B78597848774D425A424933';
wwv_flow_imp.g_varchar2_table(809) := '41414141415141412F2B494469414C7841424D4141414547427759484668384242775948466838424E6A3842467A593341346852554C526246436369763670554277344C57624B7957444661417645704B466F7245696369763670564277344C57724B7A';
wwv_flow_imp.g_varchar2_table(810) := '574743744141494141502F6441346F4338774152414255414141454742775948466838424477492F417863324E77455041546344696C4651744673574B78764B7A796A334169444A574446612F6967626F426F4338796B6F576973554C42764D4976636F';
wwv_flow_imp.g_varchar2_table(811) := '4438584B574743742F6E4B68477145414141494141502F6941346F433851414741416F41414145464677455841526346465345314134722B5556762B5253414276466E397A414671417648575776354249414841575A34724B77414141414153414E3441';
wwv_flow_imp.g_varchar2_table(812) := '415141414141414141414156414141414151414141414141415141454142554141514141414141414167414841426B41415141414141414141774145414341414151414141414141424141454143514141514141414141414251414C4143674141514141';
wwv_flow_imp.g_varchar2_table(813) := '414141414267414541444D4141514141414141414367417241446341415141414141414143774154414749414177414242416B4141414171414855414177414242416B4141514149414A38414177414242416B414167414F414B63414177414242416B41';
wwv_flow_imp.g_varchar2_table(814) := '41774149414C55414177414242416B4142414149414C30414177414242416B4142514157414D55414177414242416B4142674149414E73414177414242416B4143674257414F4D414177414242416B414377416D41546C6A59573131626D526849464E6C';
wwv_flow_imp.g_varchar2_table(815) := '636E5A705932567A49456474596B686963473175556D566E64577868636D4A776257356963473175566D567963326C76626941784C6A426963473175523256755A584A686447566B49474A3549484E325A7A4A30644759675A6E4A766253424762323530';
wwv_flow_imp.g_varchar2_table(816) := '5A57787362794277636D39715A574E304C6D6830644841364C79396D623235305A5778736279356A62323041597742684147304164514275414751415951416741464D415A514279414859416151426A4147554163774167414563416251426941456741';
wwv_flow_imp.g_varchar2_table(817) := '596742774147304162674253414755415A7742314147774159514279414749416341427441473441596742774147304162674257414755416367427A41476B4162774275414341414D51417541444141596742774147304162674248414755416267426C';
wwv_flow_imp.g_varchar2_table(818) := '4148494159514230414755415A414167414749416551416741484D416467426E4144494164414230414759414941426D41484941627742744143414152674276414734416441426C41477741624142764143414163414279414738416167426C41474D41';
wwv_flow_imp.g_varchar2_table(819) := '644141754147674164414230414841414F674176414338415A674276414734416441426C41477741624142764143344159774276414730414141414141674141414141414141414B41414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(820) := '4141427341514942417745454151554242674548415167424351454B415173424441454E415134424477455141524542456745544152514246514557415263424741455A41526F42477745634152304248674566415341424951456941534D424A41456C';
wwv_flow_imp.g_varchar2_table(821) := '415359424A77456F41536B424B674572415377424C514575415338424D414578415449424D774530415455424E674533415467424F5145364154734250414539415434425077464141554542516746444155514252514647415563425341464A41556F42';
wwv_flow_imp.g_varchar2_table(822) := '5377464D4155304254674650415641425551465341564D4256414656415659425677465941566B425767466241567742585146654156384259414668415749425977466B415755425A67466E4157674261514671415773426241467441415630636D467A';
wwv_flow_imp.g_varchar2_table(823) := '6142426E5958526C643246354C584268636D46736247567348326C75644756796257566B615746305A53316C646D56756443316A5958526A6143316A5957356A5A577778615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F';
wwv_flow_imp.g_varchar2_table(824) := '4C57357662693170626E526C636E4A3163485270626D63746257567A6332466E5A52687A644746796443316C646D56756443316A623231775A57357A595852706232347563335268636E51745A585A6C626E5174626D39754C576C7564475679636E5677';
wwv_flow_imp.g_varchar2_table(825) := '64476C755A79317759584A686247786C6243317464577830615842735A517473623239774C573168636D746C63684A7759584A686247786C624331746153317459584A725A58496A63335268636E51745A585A6C626E5174626D39754C576C7564475679';
wwv_flow_imp.g_varchar2_table(826) := '636E567764476C755A79317A6157647559577776615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C57357662693170626E526C636E4A3163485270626D637464476C745A584971615735305A584A745A5752705958526C';
wwv_flow_imp.g_varchar2_table(827) := '4C5756325A5735304C574E6864474E6F4C584268636D4673624756734C573131624852706347786C4A576C75644756796257566B615746305A53316C646D56756443316A5958526A6143316A623231775A57357A595852706232344C5A3246305A586468';
wwv_flow_imp.g_varchar2_table(828) := '65533134623349515A57356B4C5756325A5735304C574E68626D4E6C62434A70626E526C636D316C5A476C68644755745A585A6C626E51745932463059326774593239755A476C30615739754F326C75644756796257566B615746305A53316C646D5675';
wwv_flow_imp.g_varchar2_table(829) := '6443316A5958526A6143317562323474615735305A584A79645842306157356E4C584268636D4673624756734C573131624852706347786C46584E3059584A304C5756325A5735304C574E76626D527064476C7662694A7A644746796443316C646D5675';
wwv_flow_imp.g_varchar2_table(830) := '6443317562323474615735305A584A79645842306157356E4C5852706257567946484E6C6358566C626E52705957777462576B7462574679613256794358567A5A5849746447467A6177316964584E70626D567A637931796457786C456E4E3159693177';
wwv_flow_imp.g_varchar2_table(831) := '636D396A5A584E7A4C573168636D746C6368317A644746796443316C646D56756443317759584A686247786C6243317464577830615842735A52467A644746796443316C646D56756443316C636E4A7663683970626E526C636D316C5A476C6864475574';
wwv_flow_imp.g_varchar2_table(832) := '5A585A6C626E5174593246305932677463326C6E626D4673486D6C75644756796257566B615746305A53316C646D56756443316A5958526A6143316C636E4A7663685A6C626D51745A585A6C626E51745932397463475675633246306157397546484E31';
wwv_flow_imp.g_varchar2_table(833) := '596E427962324E6C63334D7459323973624746776332566B45334E31596E427962324E6C63334D745A5868775957356B5A5751456447467A6177396C626D51745A585A6C626E51745A584A796233496A615735305A584A745A5752705958526C4C575632';
wwv_flow_imp.g_varchar2_table(834) := '5A5735304C574E6864474E6F4C57567A593246735958527062323465615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C58527062575679466E4E3059584A304C5756325A5735304C57567A593246735958527062323453';
wwv_flow_imp.g_varchar2_table(835) := '63335268636E51745A585A6C626E517463326C6E626D4673456D4A3163326C755A584E7A4C584A31624755746447467A61775A745957353159577748636D566A5A576C325A51316A595778734C57466A64476C326158523545584E3059584A304C575632';
wwv_flow_imp.g_varchar2_table(836) := '5A5735304C5852706257567945334E3059584A304C5756325A5735304C57316C63334E685A325558615735305A584A745A5752705958526C4C5756325A5735304C573576626D5564615735305A584A745A5752705958526C4C5756325A5735304C574E68';
wwv_flow_imp.g_varchar2_table(837) := '64474E6F4C577870626D73555A57356B4C5756325A5735304C57567A593246735958527062323448596E4274626931706277396E5958526C643246354C574E76625842735A5867535A3246305A5864686553316C646D567564474A686332566B44476468';
wwv_flow_imp.g_varchar2_table(838) := '6447563359586B74626D39755A51706E5958526C643246354C573979453256755A43316C646D5675644331305A584A7461573568644755515A57356B4C5756325A5735304C584E705A3235686241356C626D51745A585A6C626E5174626D39755A524A6C';
wwv_flow_imp.g_varchar2_table(839) := '626D51745A585A6C626E51746258567364476C77624755525A57356B4C5756325A5735304C57316C63334E685A32554F5A57356B4C5756325A5735304C577870626D7367615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F';
wwv_flow_imp.g_varchar2_table(840) := '4C57316C63334E685A32556C615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C574E766258426C626E4E6864476C766268527A644746796443316C646D56756443317464577830615842735A515A7A59334A706348514C';
wwv_flow_imp.g_varchar2_table(841) := '62574675645746734C58526863327345633256755A41647A5A584A3261574E6C44484A6C59325670646D55746447467A617752316332567945484E3059584A304C5756325A5735304C573576626D556A615735305A584A745A5752705958526C4C575632';
wwv_flow_imp.g_varchar2_table(842) := '5A5735304C58526F636D39334C57567A593246735958527062323468615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C573131624852706347786C4E476C75644756796257566B615746305A53316C646D56756443316A';
wwv_flow_imp.g_varchar2_table(843) := '5958526A6143317562323474615735305A584A79645842306157356E4C57567A593246735958527062323464615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C577870626D736D63335268636E51745A585A6C626E5174';
wwv_flow_imp.g_varchar2_table(844) := '626D39754C576C7564475679636E567764476C755A79316A6232356B615852706232344C5A47463059533176596D706C5933514C63324E79615842304C5852686332734A633256755A43313059584E72436D52686447457463335276636D556E63335268';
wwv_flow_imp.g_varchar2_table(845) := '636E51745A585A6C626E5174626D39754C576C7564475679636E567764476C755A79316C63324E68624746306157397549476C75644756796257566B615746305A53316C646D56756443313061484A76647931745A584E7A5957646C4D6D6C7564475679';
wwv_flow_imp.g_varchar2_table(846) := '6257566B615746305A53316C646D56756443316A5958526A6143317562323474615735305A584A79645842306157356E4C573131624852706347786C4D476C75644756796257566B615746305A53316C646D56756443316A5958526A6143317562323474';
wwv_flow_imp.g_varchar2_table(847) := '615735305A584A79645842306157356E4C584E705A32356862434670626E526C636D316C5A476C68644755745A585A6C626E517464476879623363746258567364476C776247556B63335268636E51745A585A6C626E5174626D39754C576C7564475679';
wwv_flow_imp.g_varchar2_table(848) := '636E567764476C755A7931745A584E7A5957646C4457466B4C5768765979317459584A725A58494D63325679646D6C6A5A53313059584E724358526863327374626D39755A524E6A623231775A57357A595852706232347462574679613256794A584E30';
wwv_flow_imp.g_varchar2_table(849) := '59584A304C5756325A5735304C57357662693170626E526C636E4A3163485270626D63746258567364476C7762475566615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C584E705A32356862444E70626E526C636D316C';
wwv_flow_imp.g_varchar2_table(850) := '5A476C68644755745A585A6C626E51745932463059326774626D39754C576C7564475679636E567764476C755A79316A6232356B615852706232344C6347467964476C6A61584268626E515A5A585A6C626E51746333566963484A765932567A6379316C';
wwv_flow_imp.g_varchar2_table(851) := '65484268626D526C5A4246735957356C4C576C7563325679644331695A5778766477707A6347466A5A5331306232397345474E76626D356C59335270623234746258567364476B45624746755A51707359584E7A627931306232397345577868626D5574';
wwv_flow_imp.g_varchar2_table(852) := '6157357A5A584A304C57466962335A6C45577868626D55745A476C326157526C4C58526F636D566C44327868626D55745A476C326157526C4C5852336277706B595852684C576C75634856304332526864474574623356306348563043576868626D5174';
wwv_flow_imp.g_varchar2_table(853) := '644739766241566E636D3931634139305A5868304C574675626D3930595852706232344C64484A68626E4E68593352706232344D63324E795A58637464334A6C626D4E6F436D4E76626D356C5933527062323451593239755A476C306157397559577774';
wwv_flow_imp.g_varchar2_table(854) := '5A6D78766477786B5A575A68645778304C575A736233634141413D3D272920666F726D61742827747275657479706527293B0A7D0A2F2A204368726F6D65206861636B3A205356472069732072656E6465726564206D6F726520736D6F6F746820696E20';
wwv_flow_imp.g_varchar2_table(855) := '57696E646F7A7A652E2031303025206D616769632C20756E636F6D6D656E7420696620796F75206E6565642069742E202A2F0A2F2A204E6F74652C20746861742077696C6C20627265616B2068696E74696E672120496E206F74686572204F532D657320';
wwv_flow_imp.g_varchar2_table(856) := '666F6E742077696C6C206265206E6F7420617320736861727020617320697420636F756C64206265202A2F0A2F2A0A406D656469612073637265656E20616E6420282D7765626B69742D6D696E2D6465766963652D706978656C2D726174696F3A302920';
wwv_flow_imp.g_varchar2_table(857) := '7B0A202040666F6E742D66616365207B0A20202020666F6E742D66616D696C793A202762706D6E273B0A202020207372633A2075726C28272E2E2F666F6E742F62706D6E2E7376673F31363430363238392362706D6E272920666F726D61742827737667';
wwv_flow_imp.g_varchar2_table(858) := '27293B0A20207D0A7D0A2A2F0A0A5B636C6173735E3D2262706D6E2D69636F6E2D225D3A6265666F72652C205B636C6173732A3D222062706D6E2D69636F6E2D225D3A6265666F7265207B0A2020666F6E742D66616D696C793A202262706D6E223B0A20';
wwv_flow_imp.g_varchar2_table(859) := '20666F6E742D7374796C653A206E6F726D616C3B0A2020666F6E742D7765696768743A206E6F726D616C3B0A2020737065616B3A206E657665723B0A0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A2020746578742D6465636F726174';
wwv_flow_imp.g_varchar2_table(860) := '696F6E3A20696E68657269743B0A202077696474683A2031656D3B0A20202F2A206D617267696E2D72696768743A202E32656D3B202A2F0A2020746578742D616C69676E3A2063656E7465723B0A20202F2A206F7061636974793A202E383B202A2F0A0A';
wwv_flow_imp.g_varchar2_table(861) := '20202F2A20466F7220736166657479202D20726573657420706172656E74207374796C65732C20746861742063616E20627265616B20676C79706820636F6465732A2F0A2020666F6E742D76617269616E743A206E6F726D616C3B0A2020746578742D74';
wwv_flow_imp.g_varchar2_table(862) := '72616E73666F726D3A206E6F6E653B0A0A20202F2A2066697820627574746F6E73206865696768742C20666F72207477697474657220626F6F747374726170202A2F0A20206C696E652D6865696768743A2031656D3B0A0A20202F2A20416E696D617469';
wwv_flow_imp.g_varchar2_table(863) := '6F6E2063656E74657220636F6D70656E736174696F6E202D206D617267696E732073686F756C642062652073796D6D6574726963202A2F0A20202F2A2072656D6F7665206966206E6F74206E6565646564202A2F0A20202F2A206D617267696E2D6C6566';
wwv_flow_imp.g_varchar2_table(864) := '743A202E32656D3B202A2F0A0A20202F2A20796F752063616E206265206D6F726520636F6D666F727461626C65207769746820696E637265617365642069636F6E732073697A65202A2F0A20202F2A20666F6E742D73697A653A20313230253B202A2F0A';
wwv_flow_imp.g_varchar2_table(865) := '20200A20202F2A20466F6E7420736D6F6F7468696E672E2054686174207761732074616B656E2066726F6D2054574253202A2F0A20202D7765626B69742D666F6E742D736D6F6F7468696E673A20616E7469616C69617365643B0A20202D6D6F7A2D6F73';
wwv_flow_imp.g_varchar2_table(866) := '782D666F6E742D736D6F6F7468696E673A20677261797363616C653B0A0A20202F2A20556E636F6D6D656E7420666F7220334420656666656374202A2F0A20202F2A20746578742D736861646F773A203170782031707820317078207267626128313237';
wwv_flow_imp.g_varchar2_table(867) := '2C203132372C203132372C20302E33293B202A2F0A7D0A0A2E62706D6E2D69636F6E2D74726173683A6265666F7265207B20636F6E74656E743A20275C65383031273B207D202F2A2027EEA08127202A2F0A2E62706D6E2D69636F6E2D67617465776179';
wwv_flow_imp.g_varchar2_table(868) := '2D706172616C6C656C3A6265666F7265207B20636F6E74656E743A20275C65383034273B207D202F2A2027EEA08427202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D63616E63656C3A6265666F7265';
wwv_flow_imp.g_varchar2_table(869) := '207B20636F6E74656E743A20275C65383035273B207D202F2A2027EEA08527202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D6573736167653A6265666F';
wwv_flow_imp.g_varchar2_table(870) := '7265207B20636F6E74656E743A20275C65383036273B207D202F2A2027EEA08627202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383037273B20';
wwv_flow_imp.g_varchar2_table(871) := '7D202F2A2027EEA08727202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D706172616C6C656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383038273B207D';
wwv_flow_imp.g_varchar2_table(872) := '202F2A2027EEA08827202A2F0A2E62706D6E2D69636F6E2D6C6F6F702D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383039273B207D202F2A2027EEA08927202A2F0A2E62706D6E2D69636F6E2D706172616C6C656C2D6D692D';
wwv_flow_imp.g_varchar2_table(873) := '6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383061273B207D202F2A2027EEA08A27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D7369676E616C3A6265666F72';
wwv_flow_imp.g_varchar2_table(874) := '65207B20636F6E74656E743A20275C65383062273B207D202F2A2027EEA08B27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D74696D65723A6265666F72';
wwv_flow_imp.g_varchar2_table(875) := '65207B20636F6E74656E743A20275C65383063273B207D202F2A2027EEA08C27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D706172616C6C656C2D6D756C7469706C653A6265666F7265207B2063';
wwv_flow_imp.g_varchar2_table(876) := '6F6E74656E743A20275C65383064273B207D202F2A2027EEA08D27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(877) := '65383065273B207D202F2A2027EEA08E27202A2F0A2E62706D6E2D69636F6E2D676174657761792D786F723A6265666F7265207B20636F6E74656E743A20275C65383066273B207D202F2A2027EEA08F27202A2F0A2E62706D6E2D69636F6E2D656E642D';
wwv_flow_imp.g_varchar2_table(878) := '6576656E742D63616E63656C3A6265666F7265207B20636F6E74656E743A20275C65383131273B207D202F2A2027EEA09127202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6E646974696F6E3A';
wwv_flow_imp.g_varchar2_table(879) := '6265666F7265207B20636F6E74656E743A20275C65383132273B207D202F2A2027EEA09227202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D706172616C6C';
wwv_flow_imp.g_varchar2_table(880) := '656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383133273B207D202F2A2027EEA09327202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D636F6E646974696F6E3A6265666F7265207B20636F6E7465';
wwv_flow_imp.g_varchar2_table(881) := '6E743A20275C65383134273B207D202F2A2027EEA09427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D74696D65723A6265666F7265207B20636F6E74656E743A20275C65383135273B20';
wwv_flow_imp.g_varchar2_table(882) := '7D202F2A2027EEA09527202A2F0A2E62706D6E2D69636F6E2D73657175656E7469616C2D6D692D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383136273B207D202F2A2027EEA09627202A2F0A2E62706D6E2D69636F6E2D7573';
wwv_flow_imp.g_varchar2_table(883) := '65722D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383137273B207D202F2A2027EEA09727202A2F0A2E62706D6E2D69636F6E2D627573696E6573732D72756C653A6265666F7265207B20636F6E74656E743A20275C65383138273B';
wwv_flow_imp.g_varchar2_table(884) := '207D202F2A2027EEA09827202A2F0A2E62706D6E2D69636F6E2D7375622D70726F636573732D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383139273B207D202F2A2027EEA09927202A2F0A2E62706D6E2D69636F6E2D737461';
wwv_flow_imp.g_varchar2_table(885) := '72742D6576656E742D706172616C6C656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383161273B207D202F2A2027EEA09A27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6572726F723A626566';
wwv_flow_imp.g_varchar2_table(886) := '6F7265207B20636F6E74656E743A20275C65383162273B207D202F2A2027EEA09B27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D7369676E616C3A6265666F7265207B20636F6E74656E743A2027';
wwv_flow_imp.g_varchar2_table(887) := '5C65383163273B207D202F2A2027EEA09C27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6572726F723A6265666F7265207B20636F6E74656E743A20275C65383164273B207D202F2A2027EEA09D';
wwv_flow_imp.g_varchar2_table(888) := '27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383165273B207D202F2A2027EEA09E27202A2F0A2E62706D6E2D69636F6E2D73756270726F636573';
wwv_flow_imp.g_varchar2_table(889) := '732D636F6C6C61707365643A6265666F7265207B20636F6E74656E743A20275C65383166273B207D202F2A2027EEA09F27202A2F0A2E62706D6E2D69636F6E2D73756270726F636573732D657870616E6465643A6265666F7265207B20636F6E74656E74';
wwv_flow_imp.g_varchar2_table(890) := '3A20275C65383230273B207D202F2A2027EEA0A027202A2F0A2E62706D6E2D69636F6E2D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383231273B207D202F2A2027EEA0A127202A2F0A2E62706D6E2D69636F6E2D656E642D657665';
wwv_flow_imp.g_varchar2_table(891) := '6E742D6572726F723A6265666F7265207B20636F6E74656E743A20275C65383232273B207D202F2A2027EEA0A227202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D657363616C6174696F6E3A626566';
wwv_flow_imp.g_varchar2_table(892) := '6F7265207B20636F6E74656E743A20275C65383233273B207D202F2A2027EEA0A327202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D74696D65723A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(893) := '65383234273B207D202F2A2027EEA0A427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383235273B207D202F2A2027EEA0A527202A2F0A2E62706D';
wwv_flow_imp.g_varchar2_table(894) := '6E2D69636F6E2D73746172742D6576656E742D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383236273B207D202F2A2027EEA0A627202A2F0A2E62706D6E2D69636F6E2D627573696E6573732D72756C652D7461736B3A626566';
wwv_flow_imp.g_varchar2_table(895) := '6F7265207B20636F6E74656E743A20275C65383237273B207D202F2A2027EEA0A727202A2F0A2E62706D6E2D69636F6E2D6D616E75616C3A6265666F7265207B20636F6E74656E743A20275C65383238273B207D202F2A2027EEA0A827202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(896) := '6D6E2D69636F6E2D726563656976653A6265666F7265207B20636F6E74656E743A20275C65383239273B207D202F2A2027EEA0A927202A2F0A2E62706D6E2D69636F6E2D63616C6C2D61637469766974793A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(897) := '275C65383261273B207D202F2A2027EEA0AA27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D74696D65723A6265666F7265207B20636F6E74656E743A20275C65383262273B207D202F2A2027EEA0AB27202A2F0A2E62706D6E2D69';
wwv_flow_imp.g_varchar2_table(898) := '636F6E2D73746172742D6576656E742D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383263273B207D202F2A2027EEA0AC27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E653A';
wwv_flow_imp.g_varchar2_table(899) := '6265666F7265207B20636F6E74656E743A20275C65383264273B207D202F2A2027EEA0AD27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6C696E6B3A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(900) := '275C65383265273B207D202F2A2027EEA0AE27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383266273B207D202F2A2027EEA0AF27202A2F0A2E62706D';
wwv_flow_imp.g_varchar2_table(901) := '6E2D69636F6E2D62706D6E2D696F3A6265666F7265207B20636F6E74656E743A20275C65383331273B207D202F2A2027EEA0B127202A2F0A2E62706D6E2D69636F6E2D676174657761792D636F6D706C65783A6265666F7265207B20636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(902) := '20275C65383332273B207D202F2A2027EEA0B227202A2F0A2E62706D6E2D69636F6E2D676174657761792D6576656E7462617365643A6265666F7265207B20636F6E74656E743A20275C65383333273B207D202F2A2027EEA0B327202A2F0A2E62706D6E';
wwv_flow_imp.g_varchar2_table(903) := '2D69636F6E2D676174657761792D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C65383334273B207D202F2A2027EEA0B427202A2F0A2E62706D6E2D69636F6E2D676174657761792D6F723A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(904) := '275C65383335273B207D202F2A2027EEA0B527202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D7465726D696E6174653A6265666F7265207B20636F6E74656E743A20275C65383336273B207D202F2A2027EEA0B627202A2F0A2E62706D6E';
wwv_flow_imp.g_varchar2_table(905) := '2D69636F6E2D656E642D6576656E742D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383337273B207D202F2A2027EEA0B727202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6E6F6E653A6265666F7265207B2063';
wwv_flow_imp.g_varchar2_table(906) := '6F6E74656E743A20275C65383338273B207D202F2A2027EEA0B827202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383339273B207D202F2A2027EEA0B927202A';
wwv_flow_imp.g_varchar2_table(907) := '2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383361273B207D202F2A2027EEA0BA27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6C696E6B3A6265';
wwv_flow_imp.g_varchar2_table(908) := '666F7265207B20636F6E74656E743A20275C65383362273B207D202F2A2027EEA0BB27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D6573736167653A6265666F7265207B20636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(909) := '20275C65383363273B207D202F2A2027EEA0BC27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383364273B20';
wwv_flow_imp.g_varchar2_table(910) := '7D202F2A2027EEA0BD27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383365273B207D202F2A2027EEA0BE27202A2F0A2E62706D6E2D69636F6E2D7363';
wwv_flow_imp.g_varchar2_table(911) := '726970743A6265666F7265207B20636F6E74656E743A20275C65383366273B207D202F2A2027EEA0BF27202A2F0A2E62706D6E2D69636F6E2D6D616E75616C2D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383430273B207D202F2A';
wwv_flow_imp.g_varchar2_table(912) := '2027EEA18027202A2F0A2E62706D6E2D69636F6E2D73656E643A6265666F7265207B20636F6E74656E743A20275C65383431273B207D202F2A2027EEA18127202A2F0A2E62706D6E2D69636F6E2D736572766963653A6265666F7265207B20636F6E7465';
wwv_flow_imp.g_varchar2_table(913) := '6E743A20275C65383432273B207D202F2A2027EEA18227202A2F0A2E62706D6E2D69636F6E2D726563656976652D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383433273B207D202F2A2027EEA18327202A2F0A2E62706D6E2D6963';
wwv_flow_imp.g_varchar2_table(914) := '6F6E2D757365723A6265666F7265207B20636F6E74656E743A20275C65383434273B207D202F2A2027EEA18427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C653834';
wwv_flow_imp.g_varchar2_table(915) := '35273B207D202F2A2027EEA18527202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383436273B207D202F2A2027EEA1';
wwv_flow_imp.g_varchar2_table(916) := '8627202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383437273B207D202F2A2027EEA18727202A2F0A2E62706D6E2D6963';
wwv_flow_imp.g_varchar2_table(917) := '6F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383438273B207D202F2A2027EEA18827202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(918) := '6D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6C696E6B3A6265666F7265207B20636F6E74656E743A20275C65383439273B207D202F2A2027EEA18927202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E';
wwv_flow_imp.g_varchar2_table(919) := '742D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E3A6265666F7265207B20636F6E74656E743A20275C65383461273B207D202F2A2027EEA18A27202A2F0A2E62706D6E2D69636F6E2D646174612D6F626A6563743A6265666F726520';
wwv_flow_imp.g_varchar2_table(920) := '7B20636F6E74656E743A20275C65383462273B207D202F2A2027EEA18B27202A2F0A2E62706D6E2D69636F6E2D7363726970742D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383463273B207D202F2A2027EEA18C27202A2F0A2E62';
wwv_flow_imp.g_varchar2_table(921) := '706D6E2D69636F6E2D73656E642D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383464273B207D202F2A2027EEA18D27202A2F0A2E62706D6E2D69636F6E2D646174612D73746F72653A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(922) := '275C65383465273B207D202F2A2027EEA18E27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383466273B';
wwv_flow_imp.g_varchar2_table(923) := '207D202F2A2027EEA18F27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383530273B207D202F2A2027EEA19027202A2F0A';
wwv_flow_imp.g_varchar2_table(924) := '2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383531273B207D202F2A2027EEA1912720';
wwv_flow_imp.g_varchar2_table(925) := '2A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383532273B207D202F2A2027EEA19227';
wwv_flow_imp.g_varchar2_table(926) := '202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383533273B207D202F2A2027EEA19327202A2F0A2E62706D6E2D69636F6E';
wwv_flow_imp.g_varchar2_table(927) := '2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383534273B207D202F2A2027EEA19427202A2F0A2E62706D6E2D69636F6E2D61642D686F632D6D6172';
wwv_flow_imp.g_varchar2_table(928) := '6B65723A6265666F7265207B20636F6E74656E743A20275C65383535273B207D202F2A2027EEA19527202A2F0A2E62706D6E2D69636F6E2D736572766963652D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383536273B207D202F2A';
wwv_flow_imp.g_varchar2_table(929) := '2027EEA19627202A2F0A2E62706D6E2D69636F6E2D7461736B2D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C65383537273B207D202F2A2027EEA19727202A2F0A2E62706D6E2D69636F6E2D636F6D70656E736174696F6E2D6D61726B';
wwv_flow_imp.g_varchar2_table(930) := '65723A6265666F7265207B20636F6E74656E743A20275C65383538273B207D202F2A2027EEA19827202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D6D756C7469706C653A6265666F726520';
wwv_flow_imp.g_varchar2_table(931) := '7B20636F6E74656E743A20275C65383539273B207D202F2A2027EEA19927202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C653835';
wwv_flow_imp.g_varchar2_table(932) := '61273B207D202F2A2027EEA19A27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E3A6265666F7265207B20636F6E74656E743A2027';
wwv_flow_imp.g_varchar2_table(933) := '5C65383562273B207D202F2A2027EEA19B27202A2F0A2E62706D6E2D69636F6E2D7061727469636970616E743A6265666F7265207B20636F6E74656E743A20275C65383563273B207D202F2A2027EEA19C27202A2F0A2E62706D6E2D69636F6E2D657665';
wwv_flow_imp.g_varchar2_table(934) := '6E742D73756270726F636573732D657870616E6465643A6265666F7265207B20636F6E74656E743A20275C65383564273B207D202F2A2027EEA19D27202A2F0A2E62706D6E2D69636F6E2D6C616E652D696E736572742D62656C6F773A6265666F726520';
wwv_flow_imp.g_varchar2_table(935) := '7B20636F6E74656E743A20275C65383565273B207D202F2A2027EEA19E27202A2F0A2E62706D6E2D69636F6E2D73706163652D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383566273B207D202F2A2027EEA19F27202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(936) := '6D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C74693A6265666F7265207B20636F6E74656E743A20275C65383630273B207D202F2A2027EEA1A027202A2F0A2E62706D6E2D69636F6E2D6C616E653A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(937) := '275C65383631273B207D202F2A2027EEA1A127202A2F0A2E62706D6E2D69636F6E2D6C6173736F2D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383632273B207D202F2A2027EEA1A227202A2F0A2E62706D6E2D69636F6E2D6C616E';
wwv_flow_imp.g_varchar2_table(938) := '652D696E736572742D61626F76653A6265666F7265207B20636F6E74656E743A20275C65383633273B207D202F2A2027EEA1A327202A2F0A2E62706D6E2D69636F6E2D6C616E652D6469766964652D74687265653A6265666F7265207B20636F6E74656E';
wwv_flow_imp.g_varchar2_table(939) := '743A20275C65383634273B207D202F2A2027EEA1A427202A2F0A2E62706D6E2D69636F6E2D6C616E652D6469766964652D74776F3A6265666F7265207B20636F6E74656E743A20275C65383635273B207D202F2A2027EEA1A527202A2F0A2E62706D6E2D';
wwv_flow_imp.g_varchar2_table(940) := '69636F6E2D646174612D696E7075743A6265666F7265207B20636F6E74656E743A20275C65383636273B207D202F2A2027EEA1A627202A2F0A2E62706D6E2D69636F6E2D646174612D6F75747075743A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(941) := '65383637273B207D202F2A2027EEA1A727202A2F0A2E62706D6E2D69636F6E2D68616E642D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383638273B207D202F2A2027EEA1A827202A2F0A2E62706D6E2D69636F6E2D67726F75703A';
wwv_flow_imp.g_varchar2_table(942) := '6265666F7265207B20636F6E74656E743A20275C65383639273B207D202F2A2027EEA1A927202A2F0A2E62706D6E2D69636F6E2D746578742D616E6E6F746174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383662273B207D202F2A20';
wwv_flow_imp.g_varchar2_table(943) := '27EEA1AB27202A2F0A2E62706D6E2D69636F6E2D7472616E73616374696F6E3A6265666F7265207B20636F6E74656E743A20275C65386334273B207D202F2A2027EEA38427202A2F0A2E62706D6E2D69636F6E2D73637265772D7772656E63683A626566';
wwv_flow_imp.g_varchar2_table(944) := '6F7265207B20636F6E74656E743A20275C65386462273B207D202F2A2027EEA39B27202A2F0A2E62706D6E2D69636F6E2D636F6E6E656374696F6E3A6265666F7265207B20636F6E74656E743A20275C65386463273B207D202F2A2027EEA39C27202A2F';
wwv_flow_imp.g_varchar2_table(945) := '0A2E62706D6E2D69636F6E2D636F6E646974696F6E616C2D666C6F773A6265666F7265207B20636F6E74656E743A20275C65386530273B207D202F2A2027EEA3A027202A2F0A2E62706D6E2D69636F6E2D64656661756C742D666C6F773A6265666F7265';
wwv_flow_imp.g_varchar2_table(946) := '207B20636F6E74656E743A20275C65386531273B207D202F2A2027EEA3A127202A2F0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5453098251539078)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/bpmn-embedded.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E626A732D636F6E7461696E6572207B0D0A20202D2D626A732D666F6E742D66616D696C793A20417269616C2C2073616E732D73657269663B0D0A0D0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130252C';
wwv_flow_imp.g_varchar2_table(2) := '20313525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525293B';
wwv_flow_imp.g_varchar2_table(3) := '0D0A20202D2D636F6C6F722D677265792D3232352D31302D37353A2068736C283232352C203130252C20373525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(4) := '636F6C6F722D677265792D3232352D31302D38353A2068736C283232352C203130252C20383525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0D0A20202D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(5) := '677265792D3232352D31302D39353A2068736C283232352C203130252C20393525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0D0A0D0A20202D2D636F6C6F722D626C7565';
wwv_flow_imp.g_varchar2_table(6) := '2D3230352D3130302D34353A2068736C283230352C20313030252C20343525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D33303A2068736C61283230352C20313030252C203435252C20333025293B0D';
wwv_flow_imp.g_varchar2_table(7) := '0A20202D2D636F6C6F722D626C75652D3230352D3130302D35303A2068736C283230352C20313030252C20353025293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0D0A0D';
wwv_flow_imp.g_varchar2_table(8) := '0A20202D2D636F6C6F722D677265656E2D3135302D38362D34343A2068736C283135302C203836252C20343425293B0D0A0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0D0A20';
wwv_flow_imp.g_varchar2_table(9) := '202D2D636F6C6F722D7265642D3336302D3130302D34353A2068736C283336302C20313030252C20343525293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0D0A20202D2D63';
wwv_flow_imp.g_varchar2_table(10) := '6F6C6F722D7265642D3336302D3130302D39373A2068736C283336302C20313030252C20393725293B0D0A0D0A20202D2D636F6C6F722D77686974653A2068736C28302C2030252C2031303025293B0D0A20202D2D636F6C6F722D626C61636B3A206873';
wwv_flow_imp.g_varchar2_table(11) := '6C28302C2030252C203025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D30353A2068736C6128302C2030252C2030252C203525293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D31303A2068736C6128302C';
wwv_flow_imp.g_varchar2_table(12) := '2030252C2030252C20313025293B0D0A0D0A20202D2D62726561646372756D62732D666F6E742D66616D696C793A20766172282D2D626A732D666F6E742D66616D696C79293B0D0A20202D2D62726561646372756D62732D6974656D2D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(13) := '766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D62726561646372756D62732D6172726F772D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A20202D2D6472696C6C646F776E2D66696C6C2D';
wwv_flow_imp.g_varchar2_table(14) := '636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D6472696C6C646F776E2D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A7D0D0A0D0A2E626A73';
wwv_flow_imp.g_varchar2_table(15) := '2D62726561646372756D6273207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020646973706C61793A206E6F6E653B0D0A2020666C65782D777261703A20777261703B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D';
wwv_flow_imp.g_varchar2_table(16) := '0A2020746F703A20333070783B0D0A20206C6566743A20333070783B0D0A202070616464696E673A203070783B0D0A20206D617267696E3A203070783B0D0A2020666F6E742D66616D696C793A20766172282D2D62726561646372756D62732D666F6E74';
wwv_flow_imp.g_varchar2_table(17) := '2D66616D696C79293B0D0A2020666F6E742D73697A653A20313670783B0D0A20206C696E652D6865696768743A206E6F726D616C3B0D0A7D0D0A0D0A2E626A732D62726561646372756D62732D73686F776E202E626A732D62726561646372756D627320';
wwv_flow_imp.g_varchar2_table(18) := '7B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D70616C657474652D73686F776E202E626A732D62726561646372756D6273207B0D0A20206C6566743A20393070783B0D0A7D0D0A0D0A2E646A732D70616C657474652D7368';
wwv_flow_imp.g_varchar2_table(19) := '6F776E2E646A732D70616C657474652D74776F2D636F6C756D6E202E626A732D62726561646372756D6273207B0D0A20206C6566743A2031343070783B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C69207B0D0A2020646973706C6179';
wwv_flow_imp.g_varchar2_table(20) := '3A20696E6C696E652D666C65783B0D0A202070616464696E672D626F74746F6D3A203570783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C692061207B0D0A202063757273';
wwv_flow_imp.g_varchar2_table(21) := '6F723A20706F696E7465723B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6974656D2D636F6C6F72293B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C693A6C6173742D6F662D747970652061207B0D0A2020';
wwv_flow_imp.g_varchar2_table(22) := '636F6C6F723A20696E68657269743B0D0A2020637572736F723A2064656661756C743B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C693A6E6F74283A66697273742D6368696C64293A3A6265666F7265207B0D0A2020636F6E74656E74';
wwv_flow_imp.g_varchar2_table(23) := '3A2075726C2827646174613A696D6167652F7376672B786D6C3B757466382C3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22313722206865696768743D223137222076696577426F';
wwv_flow_imp.g_varchar2_table(24) := '783D22302030203234203234223E3C7061746820643D224D313020364C382E353920372E34312031332E31372031326C2D342E353820342E35394C31302031386C362D367A22202F3E3C7061746820643D224D30203068323476323448307A222066696C';
wwv_flow_imp.g_varchar2_table(25) := '6C3D226E6F6E6522202F3E3C2F7376673E27293B0D0A202070616464696E673A2030203870783B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6172726F772D636F6C6F72293B0D0A20206865696768743A2031656D3B0D0A7D';
wwv_flow_imp.g_varchar2_table(26) := '0D0A0D0A2E626A732D62726561646372756D6273202E626A732D6372756D62207B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A20206D61782D77696474683A2032303070783B0D0A20206F766572666C6F773A2068696464656E';
wwv_flow_imp.g_varchar2_table(27) := '3B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A2E626A732D6472696C6C646F776E207B0D0A202077696474683A20323070783B0D0A202068656967';
wwv_flow_imp.g_varchar2_table(28) := '68743A20323070783B0D0A0D0A202070616464696E673A203070783B0D0A20206D617267696E2D6C6566743A202D323070783B0D0A0D0A2020637572736F723A20706F696E7465723B0D0A2020626F726465723A206E6F6E653B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(29) := '2D7261646975733A203270783B0D0A20206F75746C696E653A206E6F6E653B0D0A0D0A202066696C6C3A20766172282D2D6472696C6C646F776E2D66696C6C2D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D64';
wwv_flow_imp.g_varchar2_table(30) := '72696C6C646F776E2D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E626A732D6472696C6C646F776E2D656D707479207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E73656C6563746564202E626A732D6472696C';
wwv_flow_imp.g_varchar2_table(31) := '6C646F776E2D656D707479207B0D0A2020646973706C61793A20696E68657269743B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D726573756C7473207B0D0A2020646973706C';
wwv_flow_imp.g_varchar2_table(32) := '61793A20666C65783B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D626F6479205B646174612D67726F75705D202B205B646174612D67726F75705D207B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(33) := '722D6C6566743A2031707820736F6C696420766172282D2D706F7075702D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D205B646174612D67726F75703D22616C69676E22';
wwv_flow_imp.g_varchar2_table(34) := '5D207B0D0A2020646973706C61793A20677269643B0D0A2020677269642D74656D706C6174652D636F6C756D6E733A2072657065617428332C20316672293B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D20';
wwv_flow_imp.g_varchar2_table(35) := '2E646A732D706F7075702D626F6479202E656E747279207B0D0A202070616464696E673A20367078203870783B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D626F6479202E65';
wwv_flow_imp.g_varchar2_table(36) := '6E7472793A6E6F74283A66697273742D6368696C6429207B0D0A20206D617267696E2D746F703A20303B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D656E7472792D69636F6E';
wwv_flow_imp.g_varchar2_table(37) := '207B0D0A2020646973706C61793A20626C6F636B3B0D0A20206D617267696E3A20303B0D0A20206865696768743A20323070783B0D0A202077696474683A20323070783B0D0A7D0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5453345734539078)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/bpmn-js.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E646A732D706172656E74207B0D0A20202D2D626A736C2D636F6C6F722D696E666F3A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D626A736C2D636F6C6F722D7761726E696E673A20236637633731613B0D';
wwv_flow_imp.g_varchar2_table(2) := '0A20202D2D626A736C2D636F6C6F722D6572726F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3430293B0D0A20202D2D626A736C2D636F6C6F722D737563636573733A20233532623431353B0D0A0D0A20202D2D626A736C2D666F';
wwv_flow_imp.g_varchar2_table(3) := '6E742D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0D0A20202D2D626A736C2D666F6E742D66616D696C793A2027417269616C272C2073616E732D73657269663B0D0A20202D2D626A736C2D666F6E742D7369';
wwv_flow_imp.g_varchar2_table(4) := '7A653A20313370783B0D0A7D0D0A0D0A2E626A736C2D6F7665726C6179207B0D0A20207A2D696E6465783A203530303B0D0A7D0D0A0D0A2E626A736C2D6F7665726C6179202A207B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D';
wwv_flow_imp.g_varchar2_table(5) := '0A7D0D0A0D0A2E626A736C2D6F7665726C61793A686F766572207B0D0A20207A2D696E6465783A20313030303B0D0A7D0D0A0D0A2E626A736C2D64726F70646F776E207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E626A736C2D6F';
wwv_flow_imp.g_varchar2_table(6) := '7665726C61793A686F766572202E626A736C2D64726F70646F776E2C0D0A2E626A736C2D64726F70646F776E2E6F70656E207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E626A736C2D697373756573207B0D0A20207061646469';
wwv_flow_imp.g_varchar2_table(7) := '6E673A203870783B0D0A2020636F6C6F723A20766172282D2D626A736C2D666F6E742D636F6C6F72293B0D0A2020666F6E742D66616D696C793A20766172282D2D626A736C2D666F6E742D66616D696C79293B0D0A2020666F6E742D73697A653A207661';
wwv_flow_imp.g_varchar2_table(8) := '72282D2D626A736C2D666F6E742D73697A65293B0D0A20206261636B67726F756E643A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D636F6C6F722D6772';
wwv_flow_imp.g_varchar2_table(9) := '65792D3232352D31302D3735293B0D0A2020626F726465722D7261646975733A203270783B0D0A7D0D0A0D0A2E626A736C2D69636F6E207B0D0A20202D2D69636F6E2D636F6C6F723A2077686974653B0D0A20206261636B67726F756E643A2076617228';
wwv_flow_imp.g_varchar2_table(10) := '2D2D69636F6E2D62672D636F6C6F72293B0D0A2020636F6C6F723A20766172282D2D69636F6E2D636F6C6F72293B0D0A2020626F726465722D7261646975733A20313030253B0D0A20206865696768743A20323070783B0D0A202077696474683A203230';
wwv_flow_imp.g_varchar2_table(11) := '70783B0D0A202070616464696E673A203570783B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A7D0D0A0D0A2E626A';
wwv_flow_imp.g_varchar2_table(12) := '736C2D69636F6E20737667207B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A7D0D0A0D0A2E626A736C2D69636F6E2D6572726F72207B0D0A20202D2D69636F6E2D62672D636F6C6F723A20766172282D2D626A';
wwv_flow_imp.g_varchar2_table(13) := '736C2D636F6C6F722D6572726F72293B0D0A7D0D0A0D0A2E626A736C2D69636F6E2D7761726E696E67207B0D0A20202D2D69636F6E2D62672D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D7761726E696E67293B0D0A7D0D0A0D0A2E626A';
wwv_flow_imp.g_varchar2_table(14) := '736C2D69636F6E2D696E666F207B0D0A20202D2D69636F6E2D62672D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D696E666F293B0D0A7D0D0A0D0A2E626A736C2D6F7665726C6179207B0D0A2020706F736974696F6E3A2072656C617469';
wwv_flow_imp.g_varchar2_table(15) := '76653B0D0A7D0D0A0D0A2E626A736C2D6973737565732D746F702D7269676874202E626A736C2D64726F70646F776E2C0D0A2E626A736C2D6973737565732D626F74746F6D2D7269676874202E626A736C2D64726F70646F776E2D636F6E74656E74207B';
wwv_flow_imp.g_varchar2_table(16) := '0D0A2020746F703A20303B0D0A20206C6566743A20303B0D0A7D0D0A0D0A2E626A736C2D6973737565732D626F74746F6D2D7269676874202E626A736C2D64726F70646F776E2C0D0A2E626A736C2D6973737565732D746F702D7269676874202E626A73';
wwv_flow_imp.g_varchar2_table(17) := '6C2D64726F70646F776E2D636F6E74656E74207B0D0A2020626F74746F6D3A20303B0D0A20206C6566743A20303B0D0A7D0D0A0D0A2E626A736C2D6973737565732D746F702D7269676874202E626A736C2D64726F70646F776E2D636F6E74656E74207B';
wwv_flow_imp.g_varchar2_table(18) := '0D0A202070616464696E672D626F74746F6D3A203570783B0D0A7D0D0A0D0A2E626A736C2D6973737565732D626F74746F6D2D7269676874202E626A736C2D64726F70646F776E2D636F6E74656E74207B0D0A202070616464696E672D746F703A203570';
wwv_flow_imp.g_varchar2_table(19) := '783B0D0A7D0D0A0D0A2E626A736C2D64726F70646F776E2D636F6E74656E74207B0D0A20206D696E2D77696474683A2032363070783B0D0A2020706F736974696F6E3A20206162736F6C7574653B0D0A7D0D0A0D0A2E626A736C2D64726F70646F776E20';
wwv_flow_imp.g_varchar2_table(20) := '7B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A7D0D0A0D0A2E626A736C2D697373756573207B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A20206D617267696E3A20303B0D0A7D0D0A0D0A2E626A736C2D69737375657320';
wwv_flow_imp.g_varchar2_table(21) := '756C207B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A20206D617267696E3A20303B0D0A202070616464696E673A20303B0D0A7D0D0A0D0A2E626A736C2D697373756573206C69207B0D0A2020646973706C61793A20666C65783B0D0A2020';
wwv_flow_imp.g_varchar2_table(22) := '666C65782D646972656374696F6E3A20726F773B0D0A202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A2E626A736C2D697373756573202E69636F6E207B0D0A202077696474683A2031656D3B0D0A20206865696768743A203165';
wwv_flow_imp.g_varchar2_table(23) := '6D3B0D0A20206D617267696E2D746F703A203170783B0D0A7D0D0A0D0A2E626A736C2D697373756573206C69202B206C69207B0D0A20206D617267696E2D746F703A202E3572656D3B0D0A7D0D0A0D0A2E626A736C2D697373756573202E69636F6E207B';
wwv_flow_imp.g_varchar2_table(24) := '0D0A20202D2D69636F6E2D636F6C6F723A20766172282D2D626A736C2D666F6E742D636F6C6F72293B0D0A0D0A2020636F6C6F723A20766172282D2D69636F6E2D636F6C6F72293B0D0A7D0D0A0D0A2E626A736C2D697373756573202E6572726F72202E';
wwv_flow_imp.g_varchar2_table(25) := '69636F6E207B0D0A20202D2D69636F6E2D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D6572726F72293B0D0A7D0D0A0D0A2E626A736C2D697373756573202E7761726E696E67202E69636F6E207B0D0A20202D2D69636F6E2D636F6C6F72';
wwv_flow_imp.g_varchar2_table(26) := '3A20766172282D2D626A736C2D636F6C6F722D7761726E696E67293B0D0A7D0D0A0D0A2E626A736C2D697373756573202E696E666F202E69636F6E207B0D0A20202D2D69636F6E2D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D696E666F';
wwv_flow_imp.g_varchar2_table(27) := '293B0D0A7D0D0A0D0A2E626A736C2D6973737565732061207B0D0A2020636F6C6F723A20766172282D2D626A736C2D666F6E742D636F6C6F72293B0D0A20206D617267696E2D6C6566743A203870783B0D0A2020746578742D6465636F726174696F6E3A';
wwv_flow_imp.g_varchar2_table(28) := '206E6F6E653B0D0A7D0D0A0D0A2E626A736C2D697373756573202E626A736C2D69737375652D68656164696E67207B0D0A20206D617267696E2D6C6566743A203070783B0D0A2020666F6E742D7765696768743A20626F6C643B0D0A20206D617267696E';
wwv_flow_imp.g_varchar2_table(29) := '2D626F74746F6D3A2031303070783B0D0A7D0D0A0D0A2E626A736C2D6368696C642D697373756573206872207B0D0A2020646973706C61793A20626C6F636B3B0D0A20206865696768743A203170783B0D0A2020626F726465723A20303B0D0A2020626F';
wwv_flow_imp.g_varchar2_table(30) := '726465722D746F703A2031707820736F6C696420236363633B0D0A7D0D0A0D0A2E626A736C2D6368696C642D69737375657320756C207B0D0A20206D617267696E2D746F703A203770783B0D0A7D0D0A0D0A2E626A736C2D69737375657320613A686F76';
wwv_flow_imp.g_varchar2_table(31) := '6572207B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A0D0A2E626A736C2D69642D68696E74207B0D0A20206261636B67726F756E642D636F6C6F723A20236264626462643B0D0A202070616464696E673A203170783B0D';
wwv_flow_imp.g_varchar2_table(32) := '0A202070616464696E672D6C6566743A203570783B0D0A202070616464696E672D72696768743A203570783B0D0A2020666F6E742D7765696768743A20626F6C643B0D0A2020626F726465722D7261646975733A20323070783B0D0A7D0D0A0D0A0D0A2F';
wwv_flow_imp.g_varchar2_table(33) := '2A2A0D0A202A2053756D6D61727920627574746F6E207374796C65730D0A202A2F0D0A0D0A2E626A736C2D627574746F6E207B0D0A2020626F726465722D7261646975733A2031303070783B0D0A2020706F736974696F6E3A206162736F6C7574653B0D';
wwv_flow_imp.g_varchar2_table(34) := '0A2020626F74746F6D3A20323070783B0D0A20206C6566743A203530253B0D0A20207472616E73666F726D3A207472616E736C617465282D353025293B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A20207061646469';
wwv_flow_imp.g_varchar2_table(35) := '6E673A2035707820313070783B0D0A2020626F726465723A206E6F6E653B0D0A2020636F6C6F723A20236464643B0D0A2020646973706C61793A20666C65783B0D0A20206F75746C696E653A206E6F6E653B0D0A2020666F6E742D7765696768743A2062';
wwv_flow_imp.g_varchar2_table(36) := '6F6C643B0D0A2020666F6E742D73697A653A20766172282D2D626A736C2D666F6E742D73697A65293B0D0A7D0D0A0D0A2E626A736C2D627574746F6E2D696E6163746976653A686F766572207B0D0A2020636F6C6F723A20233434343B0D0A7D0D0A0D0A';
wwv_flow_imp.g_varchar2_table(37) := '2E626A736C2D627574746F6E202E69636F6E207B0D0A20206D617267696E2D72696768743A20313070783B0D0A20206D617267696E2D746F703A203170783B0D0A202077696474683A202E39656D3B0D0A20206865696768743A202E39656D3B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(38) := '0A0D0A2E626A736C2D627574746F6E2D73756363657373207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D73756363657373293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A0D0A2E626A';
wwv_flow_imp.g_varchar2_table(39) := '736C2D627574746F6E2D6572726F72207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D6572726F72293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A0D0A2E626A736C2D627574746F6E2D';
wwv_flow_imp.g_varchar2_table(40) := '7761726E696E67207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D626A736C2D636F6C6F722D7761726E696E67293B0D0A2020636F6C6F723A2077686974653B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5453754540539078)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/bpmn-js-bpmnlint.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20434F4C4F52205049434B4552202A2F0D0A0D0A2E646A732D706F7075702E636F6C6F722D7069636B6572202E656E747279207B0D0A202020206D617267696E3A20303B0D0A7D0D0A0D0A2E646A732D706F7075702E636F6C6F722D7069636B6572';
wwv_flow_imp.g_varchar2_table(2) := '202E646A732D706F7075702D67726F7570207B0D0A2020646973706C61793A20677269643B0D0A2020677269643A206175746F2D666C6F77202F2031667220316672203166723B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5454126112539079)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/color-picker.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2A0D0A202A20636F6C6F7220646566696E6974696F6E730D0A202A2F0D0A2E646A732D706172656E74207B0D0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130252C20313525293B0D0A20202D2D636F';
wwv_flow_imp.g_varchar2_table(2) := '6C6F722D677265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525293B0D0A20202D2D636F6C6F722D6772';
wwv_flow_imp.g_varchar2_table(3) := '65792D3232352D31302D37353A2068736C283232352C203130252C20373525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0D0A20202D2D636F6C6F722D677265792D323235';
wwv_flow_imp.g_varchar2_table(4) := '2D31302D38353A2068736C283232352C203130252C20383525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D3935';
wwv_flow_imp.g_varchar2_table(5) := '3A2068736C283232352C203130252C20393525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0D0A0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34353A2068';
wwv_flow_imp.g_varchar2_table(6) := '736C283230352C20313030252C20343525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D33303A2068736C61283230352C20313030252C203435252C20333025293B0D0A20202D2D636F6C6F722D626C75';
wwv_flow_imp.g_varchar2_table(7) := '652D3230352D3130302D35303A2068736C283230352C20313030252C20353025293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D35302D6F7061636974792D31353A2068736C61283230352C20313030252C203530252C20313525293B';
wwv_flow_imp.g_varchar2_table(8) := '0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D37303A2068736C283230352C20313030252C20373525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0D0A';
wwv_flow_imp.g_varchar2_table(9) := '0D0A20202D2D636F6C6F722D677265656E2D3135302D38362D34343A2068736C283135302C203836252C20343425293B0D0A0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0D0A';
wwv_flow_imp.g_varchar2_table(10) := '20202D2D636F6C6F722D7265642D3336302D3130302D34353A2068736C283336302C20313030252C20343525293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(11) := '636F6C6F722D7265642D3336302D3130302D39373A2068736C283336302C20313030252C20393725293B0D0A0D0A20202D2D636F6C6F722D77686974653A2068736C28302C2030252C2031303025293B0D0A20202D2D636F6C6F722D626C61636B3A2068';
wwv_flow_imp.g_varchar2_table(12) := '736C28302C2030252C203025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D31303A2068736C6128302C2030252C2030252C20313025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D33303A2068736C6128';
wwv_flow_imp.g_varchar2_table(13) := '302C2030252C2030252C20333025293B0D0A0D0A20202D2D63616E7661732D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A0D0A20202D2D62656E64706F696E742D66696C6C2D636F6C6F723A20766172282D2D636F';
wwv_flow_imp.g_varchar2_table(14) := '6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D62656E64706F696E742D7374726F6B652D636F6C6F723A20766172282D2D63616E7661732D66696C6C2D636F6C6F72293B0D0A0D0A20202D2D636F6E746578742D7061642D656E7472';
wwv_flow_imp.g_varchar2_table(15) := '792D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D636F6E746578742D7061642D656E7472792D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D67';
wwv_flow_imp.g_varchar2_table(16) := '7265792D3232352D31302D3935293B0D0A0D0A20202D2D656C656D656E742D647261676765722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D656C656D656E742D686F7665722D6F75746C69';
wwv_flow_imp.g_varchar2_table(17) := '6E652D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F72';
wwv_flow_imp.g_varchar2_table(18) := '2D626C75652D3230352D3130302D3530293B0D0A20202D2D656C656D656E742D73656C65637465642D6F75746C696E652D7365636F6E646172792D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3730';
wwv_flow_imp.g_varchar2_table(19) := '293B0D0A0D0A20202D2D6C6173736F2D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D35302D6F7061636974792D3135293B0D0A20202D2D6C6173736F2D7374726F6B652D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(20) := '656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F72293B0D0A0D0A20202D2D70616C657474652D656E7472792D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0D0A2020';
wwv_flow_imp.g_varchar2_table(21) := '2D2D70616C657474652D656E7472792D686F7665722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D70616C657474652D656E7472792D73656C65637465642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(22) := '636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D70616C657474652D736570617261746F722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D70616C657474652D746F6767';
wwv_flow_imp.g_varchar2_table(23) := '6C652D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D70616C657474652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D67';
wwv_flow_imp.g_varchar2_table(24) := '7265792D3232352D31302D3937293B0D0A20202D2D70616C657474652D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D706F7075702D666F6E742D66616D696C793A202249';
wwv_flow_imp.g_varchar2_table(25) := '424D20506C65782053616E73222C2073616E732D73657269663B0D0A20202D2D706F7075702D666F6E742D73697A653A20313470783B0D0A20202D2D706F7075702D6865616465722D656E7472792D73656C65637465642D636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(26) := '2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D706F7075702D6865616465722D666F6E742D7765696768743A20626F6C6465723B0D0A20202D2D706F7075702D6865616465722D67726F75702D646976696465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(27) := '723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D706F7075702D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D706F7075702D626F726465722D63';
wwv_flow_imp.g_varchar2_table(28) := '6F6C6F723A207472616E73706172656E743B0D0A20202D2D706F7075702D736861646F772D636F6C6F723A20766172282D2D636F6C6F722D626C61636B2D6F7061636974792D3330293B0D0A20202D2D706F7075702D6465736372697074696F6E2D636F';
wwv_flow_imp.g_varchar2_table(29) := '6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D706F7075702D6E6F2D726573756C74732D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D706F70';
wwv_flow_imp.g_varchar2_table(30) := '75702D656E7472792D7469746C652D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D706F7075702D656E7472792D686F7665722D636F6C6F723A2020766172282D2D636F6C6F722D677265792D32';
wwv_flow_imp.g_varchar2_table(31) := '32352D31302D3935293B0D0A20202D2D706F7075702D7365617263682D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D706F7075702D7365617263682D666F6375732D626F7264';
wwv_flow_imp.g_varchar2_table(32) := '65722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D706F7075702D7365617263682D666F6375732D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D32';
wwv_flow_imp.g_varchar2_table(33) := '30352D3130302D3935293B0D0A0D0A20202D2D726573697A65722D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D726573697A65722D7374726F6B652D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(34) := '2D2D63616E7661732D66696C6C2D636F6C6F72293B0D0A0D0A20202D2D7365617263682D636F6E7461696E65722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D7365';
wwv_flow_imp.g_varchar2_table(35) := '617263682D636F6E7461696E65722D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D636F6C6F723A2076';
wwv_flow_imp.g_varchar2_table(36) := '6172282D2D636F6C6F722D626C75652D3230352D3130302D3935293B0D0A20202D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D696E7365742D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D38';
wwv_flow_imp.g_varchar2_table(37) := '30293B0D0A20202D2D7365617263682D696E7075742D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D7365617263682D726573756C742D626F726465722D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(38) := '72282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D7365617263682D726573756C742D686967686C696768742D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A20202D2D7365617263682D726573756C';
wwv_flow_imp.g_varchar2_table(39) := '742D73656C65637465642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D3330293B0D0A0D0A20202D2D73686170652D6174746163682D616C6C6F7765642D7374726F6B652D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(40) := '20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D73686170652D636F6E6E6563742D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A';
wwv_flow_imp.g_varchar2_table(41) := '20202D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C';
wwv_flow_imp.g_varchar2_table(42) := '6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3937293B0D0A20202D2D73686170652D726573697A652D707265766965772D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530';
wwv_flow_imp.g_varchar2_table(43) := '293B0D0A0D0A20202D2D736E61702D6C696E652D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D3330293B0D0A0D0A20202D2D73706163652D746F6F6C2D63726F73736861';
wwv_flow_imp.g_varchar2_table(44) := '69722D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A0D0A20202D2D746F6F6C7469702D6572726F722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D';
wwv_flow_imp.g_varchar2_table(45) := '3937293B0D0A20202D2D746F6F6C7469702D6572726F722D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A20202D2D746F6F6C7469702D6572726F722D636F6C6F723A20766172282D2D63';
wwv_flow_imp.g_varchar2_table(46) := '6F6C6F722D7265642D3336302D3130302D3435293B0D0A7D0D0A0D0A2F2A2A0D0A202A206F75746C696E65207374796C65730D0A202A2F0D0A0D0A2E646A732D6F75746C696E652C0D0A2E646A732D73656C656374696F6E2D6F75746C696E65207B0D0A';
wwv_flow_imp.g_varchar2_table(47) := '202066696C6C3A206E6F6E653B0D0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0D0A20207374726F6B652D77696474683A203270783B0D0A7D0D0A0D0A2E646A732D6F75746C696E65207B0D0A2020';
wwv_flow_imp.g_varchar2_table(48) := '7669736962696C6974793A2068696464656E3B0D0A7D0D0A0D0A2E646A732D73656C656374696F6E2D6F75746C696E65207B0D0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D';
wwv_flow_imp.g_varchar2_table(49) := '636F6C6F72293B0D0A7D0D0A0D0A2E646A732D656C656D656E742E73656C6563746564202E646A732D6F75746C696E65207B0D0A20207669736962696C6974793A2076697369626C653B0D0A0D0A20207374726F6B653A20766172282D2D656C656D656E';
wwv_flow_imp.g_varchar2_table(50) := '742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D636F6E6E656374696F6E2E73656C6563746564202E646A732D6F75746C696E65207B0D0A2020646973706C61793A206E6F6E653B0D0A7D';
wwv_flow_imp.g_varchar2_table(51) := '0D0A0D0A2E646A732D6D756C74692D73656C656374202E646A732D656C656D656E742E73656C6563746564202E646A732D6F75746C696E65207B0D0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E65';
wwv_flow_imp.g_varchar2_table(52) := '2D7365636F6E646172792D7374726F6B652D636F6C6F72293B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E646A732D73686170652E636F6E6E6563742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129';
wwv_flow_imp.g_varchar2_table(53) := '207B0D0A202066696C6C3A20766172282D2D73686170652D636F6E6E6563742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D73686170652E636F6E6E6563742D6E6F742D6F6B202E646A73';
wwv_flow_imp.g_varchar2_table(54) := '2D76697375616C203E203A6E74682D6368696C642831292C0D0A2E646A732D73686170652E64726F702D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A202066696C6C3A20766172282D2D73686170652D';
wwv_flow_imp.g_varchar2_table(55) := '64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D73686170652E6E65772D706172656E74202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A';
wwv_flow_imp.g_varchar2_table(56) := '202066696C6C3A20766172282D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A7376672E64726F702D6E6F742D6F6B207B0D0A20206261636B67726F756E643A2076617228';
wwv_flow_imp.g_varchar2_table(57) := '2D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A7376672E6E65772D706172656E74207B0D0A20206261636B67726F756E643A20766172282D2D73686170652D64';
wwv_flow_imp.g_varchar2_table(58) := '726F702D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A0D0A2F2A204F76657272696465206D6F766520637572736F7220647572696E672064726F7020616E6420636F6E6E656374202A2F0D0A2E64726F';
wwv_flow_imp.g_varchar2_table(59) := '702D6E6F742D6F6B2C0D0A2E636F6E6E6563742D6E6F742D6F6B2C0D0A2E64726F702D6E6F742D6F6B202A2C0D0A2E636F6E6E6563742D6E6F742D6F6B202A207B0D0A2020637572736F723A206E6F742D616C6C6F7765642021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(60) := '0D0A7D0D0A0D0A2E64726F702D6F6B2C0D0A2E636F6E6E6563742D6F6B2C0D0A2E64726F702D6F6B202A2C0D0A2E636F6E6E6563742D6F6B202A207B0D0A2020637572736F723A2064656661756C742021696D706F7274616E743B0D0A7D0D0A0D0A2E64';
wwv_flow_imp.g_varchar2_table(61) := '6A732D656C656D656E742E6174746163682D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A20207374726F6B652D77696474683A203570782021696D706F7274616E743B0D0A20207374726F6B653A20766172282D';
wwv_flow_imp.g_varchar2_table(62) := '2D73686170652D6174746163682D616C6C6F7765642D7374726F6B652D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D6672616D652E636F6E6E6563742D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(63) := '68696C642831292C0D0A2E646A732D6672616D652E64726F702D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A20207374726F6B652D77696474683A203370782021696D706F7274616E743B0D0A202073';
wwv_flow_imp.g_varchar2_table(64) := '74726F6B653A20766172282D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A202066696C6C3A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2F2A2A0D0A2A2053';
wwv_flow_imp.g_varchar2_table(65) := '656C656374696F6E20626F78207374796C650D0A2A0D0A2A2F0D0A2E646A732D6C6173736F2D6F7665726C6179207B0D0A202066696C6C3A20766172282D2D6C6173736F2D66696C6C2D636F6C6F72293B0D0A20207374726F6B653A20766172282D2D6C';
wwv_flow_imp.g_varchar2_table(66) := '6173736F2D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D77696474683A203270783B0D0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0D0A2020706F696E7465722D6576656E74733A';
wwv_flow_imp.g_varchar2_table(67) := '206E6F6E653B0D0A7D0D0A0D0A2F2A2A0D0A202A20526573697A65207374796C65730D0A202A2F0D0A2E646A732D726573697A652D6F7665726C6179207B0D0A202066696C6C3A206E6F6E653B0D0A0D0A20207374726F6B652D6461736861727261793A';
wwv_flow_imp.g_varchar2_table(68) := '20352031203320313B0D0A20207374726F6B653A20766172282D2D73686170652D726573697A652D707265766965772D7374726F6B652D636F6C6F72293B0D0A0D0A2020706F696E7465722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(69) := '2D726573697A65722D686974207B0D0A202066696C6C3A206E6F6E653B0D0A2020706F696E7465722D6576656E74733A20616C6C3B0D0A7D0D0A0D0A2E646A732D726573697A65722D76697375616C207B0D0A202066696C6C3A20766172282D2D726573';
wwv_flow_imp.g_varchar2_table(70) := '697A65722D66696C6C2D636F6C6F72293B0D0A20207374726F6B652D77696474683A203170783B0D0A20207374726F6B653A20766172282D2D726573697A65722D7374726F6B652D636F6C6F72293B0D0A202073686170652D72656E646572696E673A20';
wwv_flow_imp.g_varchar2_table(71) := '67656F6D6574726963507265636973696F6E3B0D0A7D0D0A0D0A2E646A732D726573697A65723A686F766572202E646A732D726573697A65722D76697375616C207B0D0A20207374726F6B653A20766172282D2D726573697A65722D7374726F6B652D63';
wwv_flow_imp.g_varchar2_table(72) := '6F6C6F72293B0D0A20207374726F6B652D6F7061636974793A20313B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6E732C0D0A2E646A732D726573697A65722D6E2C0D0A2E646A732D726573697A65722D73207B0D0A202063757273';
wwv_flow_imp.g_varchar2_table(73) := '6F723A206E732D726573697A653B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D65772C0D0A2E646A732D726573697A65722D652C0D0A2E646A732D726573697A65722D77207B0D0A2020637572736F723A2065772D726573697A653B';
wwv_flow_imp.g_varchar2_table(74) := '0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6E7773652C0D0A2E646A732D726573697A65722D6E772C0D0A2E646A732D726573697A65722D7365207B0D0A2020637572736F723A206E7773652D726573697A653B0D0A7D0D0A0D0A2E';
wwv_flow_imp.g_varchar2_table(75) := '646A732D637572736F722D726573697A652D6E6573772C0D0A2E646A732D726573697A65722D6E652C0D0A2E646A732D726573697A65722D7377207B0D0A2020637572736F723A206E6573772D726573697A653B0D0A7D0D0A0D0A2E646A732D73686170';
wwv_flow_imp.g_varchar2_table(76) := '652E646A732D726573697A696E67203E202E646A732D6F75746C696E65207B0D0A20207669736962696C6974793A2068696464656E2021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D73686170652E646A732D726573697A696E67203E202E64';
wwv_flow_imp.g_varchar2_table(77) := '6A732D726573697A6572207B0D0A20207669736962696C6974793A2068696464656E3B0D0A7D0D0A0D0A2E646A732D64726167676572203E202E646A732D726573697A6572207B0D0A20207669736962696C6974793A2068696464656E3B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(78) := '0A2F2A2A0D0A202A2064726167207374796C65730D0A202A2F0D0A2E646A732D64726167676572202A207B0D0A202066696C6C3A206E6F6E652021696D706F7274616E743B0D0A20207374726F6B653A20766172282D2D656C656D656E742D6472616767';
wwv_flow_imp.g_varchar2_table(79) := '65722D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D6472616767657220747370616E2C0D0A2E646A732D647261676765722074657874207B0D0A202066696C6C3A20766172282D2D656C656D656E742D647261676765722D';
wwv_flow_imp.g_varchar2_table(80) := '636F6C6F72292021696D706F7274616E743B0D0A20207374726F6B653A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D64726167676572206D61726B657220636972636C652C0D0A2E646A732D64726167676572206D61726B65';
wwv_flow_imp.g_varchar2_table(81) := '7220706174682C0D0A2E646A732D64726167676572206D61726B657220706F6C79676F6E2C0D0A2E646A732D64726167676572206D61726B657220706F6C796C696E652C0D0A2E646A732D64726167676572206D61726B65722072656374207B0D0A2020';
wwv_flow_imp.g_varchar2_table(82) := '66696C6C3A20766172282D2D656C656D656E742D647261676765722D636F6C6F72292021696D706F7274616E743B0D0A20207374726F6B653A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D64726167676572206D61726B6572';
wwv_flow_imp.g_varchar2_table(83) := '20746578742C0D0A2E646A732D64726167676572206D61726B657220747370616E207B0D0A202066696C6C3A206E6F6E652021696D706F7274616E743B0D0A20207374726F6B653A20766172282D2D656C656D656E742D647261676765722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(84) := '292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D6472616767696E672C0D0A2E646A732D6472616767696E67203E202A207B0D0A20206F7061636974793A20302E332021696D706F7274616E743B0D0A2020706F696E7465722D6576656E74';
wwv_flow_imp.g_varchar2_table(85) := '733A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2F2A2A0D0A202A206E6F20706F696E746572206576656E747320666F722076697375616C0D0A202A2F0D0A2E646A732D76697375616C2C0D0A2E646A732D6F75746C696E65207B0D0A20';
wwv_flow_imp.g_varchar2_table(86) := '20706F696E7465722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2E646A732D656C656D656E742E6174746163682D6F6B202E646A732D686974207B0D0A20207374726F6B652D77696474683A20363070782021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(87) := '0A0D0A2F2A2A0D0A202A20616C6C20706F696E746572206576656E747320666F72206869742073686170650D0A202A2F0D0A2E646A732D656C656D656E74203E202E646A732D6869742D616C6C2C0D0A2E646A732D656C656D656E74203E202E646A732D';
wwv_flow_imp.g_varchar2_table(88) := '6869742D6E6F2D6D6F7665207B0D0A2020706F696E7465722D6576656E74733A20616C6C3B0D0A7D0D0A0D0A2E646A732D656C656D656E74203E202E646A732D6869742D7374726F6B652C0D0A2E646A732D656C656D656E74203E202E646A732D686974';
wwv_flow_imp.g_varchar2_table(89) := '2D636C69636B2D7374726F6B65207B0D0A2020706F696E7465722D6576656E74733A207374726F6B653B0D0A7D0D0A0D0A2F2A2A0D0A202A207368617065202F20636F6E6E656374696F6E206261736963207374796C65730D0A202A2F0D0A2E646A732D';
wwv_flow_imp.g_varchar2_table(90) := '636F6E6E656374696F6E202E646A732D76697375616C207B0D0A20207374726F6B652D77696474683A203270783B0D0A202066696C6C3A206E6F6E653B0D0A7D0D0A0D0A2E646A732D637572736F722D67726162207B0D0A2020637572736F723A202D77';
wwv_flow_imp.g_varchar2_table(91) := '65626B69742D677261623B0D0A2020637572736F723A202D6D6F7A2D677261623B0D0A2020637572736F723A20677261623B0D0A7D0D0A0D0A2E646A732D637572736F722D6772616262696E67207B0D0A2020637572736F723A202D7765626B69742D67';
wwv_flow_imp.g_varchar2_table(92) := '72616262696E673B0D0A2020637572736F723A202D6D6F7A2D6772616262696E673B0D0A2020637572736F723A206772616262696E673B0D0A7D0D0A0D0A2E646A732D637572736F722D63726F737368616972207B0D0A2020637572736F723A2063726F';
wwv_flow_imp.g_varchar2_table(93) := '7373686169723B0D0A7D0D0A0D0A2E646A732D637572736F722D6D6F7665207B0D0A2020637572736F723A206D6F76653B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6E73207B0D0A2020637572736F723A206E732D726573697A65';
wwv_flow_imp.g_varchar2_table(94) := '3B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6577207B0D0A2020637572736F723A2065772D726573697A653B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A20736E617070696E670D0A202A2F0D0A2E646A732D736E61702D6C696E6520';
wwv_flow_imp.g_varchar2_table(95) := '7B0D0A20207374726F6B653A20766172282D2D736E61702D6C696E652D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D6C696E656361703A20726F756E643B0D0A20207374726F6B652D77696474683A203270783B0D0A2020706F696E74';
wwv_flow_imp.g_varchar2_table(96) := '65722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2F2A2A0D0A202A20736E617070696E670D0A202A2F0D0A2E646A732D63726F737368616972207B0D0A20207374726F6B653A20766172282D2D73706163652D746F6F6C2D63726F737368616972';
wwv_flow_imp.g_varchar2_table(97) := '2D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D6C696E656361703A20726F756E643B0D0A20207374726F6B652D77696474683A203170783B0D0A2020706F696E7465722D6576656E74733A206E6F6E653B0D0A202073686170652D7265';
wwv_flow_imp.g_varchar2_table(98) := '6E646572696E673A2067656F6D6574726963507265636973696F6E3B0D0A20207374726F6B652D6461736861727261793A20352C20353B0D0A7D0D0A0D0A2F2A2A0D0A202A2070616C657474650D0A202A2F0D0A0D0A2E646A732D70616C65747465207B';
wwv_flow_imp.g_varchar2_table(99) := '0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20206C6566743A20323070783B0D0A2020746F703A20323070783B0D0A0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A202077696474683A20343870783B0D0A7D';
wwv_flow_imp.g_varchar2_table(100) := '0D0A0D0A2E646A732D70616C65747465202E736570617261746F72207B0D0A20206D617267696E3A203570783B0D0A202070616464696E672D746F703A203570783B0D0A0D0A2020626F726465723A206E6F6E653B0D0A2020626F726465722D626F7474';
wwv_flow_imp.g_varchar2_table(101) := '6F6D3A20736F6C69642031707820766172282D2D70616C657474652D736570617261746F722D636F6C6F72293B0D0A0D0A2020636C6561723A20626F74683B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E7472793A6265666F7265207B0D0A';
wwv_flow_imp.g_varchar2_table(102) := '2020766572746963616C2D616C69676E3A20696E697469616C3B0D0A7D0D0A0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A2E646A732D70';
wwv_flow_imp.g_varchar2_table(103) := '616C65747465202E656E7472792C0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0D0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D636F6C6F72293B0D0A2020666F6E742D73697A';
wwv_flow_imp.g_varchar2_table(104) := '653A20333070783B0D0A0D0A2020746578742D616C69676E3A2063656E7465723B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E747279207B0D0A2020666C6F61743A206C6566743B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E';
wwv_flow_imp.g_varchar2_table(105) := '74727920696D67207B0D0A20206D61782D77696474683A20313030253B0D0A7D0D0A0D0A2E646A732D70616C65747465202E646A732D70616C657474652D656E74726965733A6166746572207B0D0A2020636F6E74656E743A2027273B0D0A2020646973';
wwv_flow_imp.g_varchar2_table(106) := '706C61793A207461626C653B0D0A2020636C6561723A20626F74683B0D0A7D0D0A0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C653A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D70616C';
wwv_flow_imp.g_varchar2_table(107) := '657474652D746F67676C652D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E7472793A686F766572207B0D0A2020636F6C6F723A20766172282D2D70616C657474652D656E747279';
wwv_flow_imp.g_varchar2_table(108) := '2D686F7665722D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D70616C65747465202E686967686C6967687465642D656E747279207B0D0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D73656C65637465642D636F6C6F7229';
wwv_flow_imp.g_varchar2_table(109) := '2021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E7472792C0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0D0A202077696474683A20343670783B0D0A20206865696768';
wwv_flow_imp.g_varchar2_table(110) := '743A20343670783B0D0A20206C696E652D6865696768743A20343670783B0D0A2020637572736F723A2064656661756C743B0D0A7D0D0A0D0A2F2A2A0D0A202A2050616C65747465206F70656E202F2074776F2D636F6C756D6E206C61796F7574206973';
wwv_flow_imp.g_varchar2_table(111) := '20636F6E74726F6C6C6564207669610D0A202A20636C6173736573206F6E207468652070616C657474652E204576656E747320746F20686F6F6B20696E746F2070616C657474650D0A202A206368616E676564206C6966652D6379636C65206172652061';
wwv_flow_imp.g_varchar2_table(112) := '7661696C61626C6520696E206164646974696F6E2E0D0A202A2F0D0A2E646A732D70616C657474652E74776F2D636F6C756D6E2E6F70656E207B0D0A202077696474683A20393470783B0D0A7D0D0A0D0A2E646A732D70616C657474653A6E6F74282E6F';
wwv_flow_imp.g_varchar2_table(113) := '70656E29202E646A732D70616C657474652D656E7472696573207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D70616C657474653A6E6F74282E6F70656E29207B0D0A20206F766572666C6F773A2068696464656E3B0D0A';
wwv_flow_imp.g_varchar2_table(114) := '7D0D0A0D0A2E646A732D70616C657474652E6F70656E202E646A732D70616C657474652D746F67676C65207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2F2A2A0D0A202A20636F6E746578742D7061640D0A202A2F0D0A2E646A732D';
wwv_flow_imp.g_varchar2_table(115) := '636F6E746578742D706164207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020646973706C61793A206E6F6E653B0D0A2020706F696E7465722D6576656E74733A206E6F6E653B0D0A20206C696E652D6865696768743A20313B0D0A';
wwv_flow_imp.g_varchar2_table(116) := '202077696474683A20373270783B0D0A20207A2D696E6465783A203130303B0D0A7D0D0A0D0A2E646A732D636F6E746578742D706164202E656E747279207B0D0A202077696474683A20323270783B0D0A20206865696768743A20323270783B0D0A2020';
wwv_flow_imp.g_varchar2_table(117) := '746578742D616C69676E3A2063656E7465723B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A2020666F6E742D73697A653A20323270783B0D0A20206D617267696E3A2030203270782032707820303B0D0A0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(118) := '722D7261646975733A203370783B0D0A0D0A2020637572736F723A2064656661756C743B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(119) := '293B0D0A2020626F782D736861646F773A20302030203270782031707820766172282D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F6C6F72293B0D0A2020706F696E7465722D6576656E74733A20616C6C3B0D0A2020';
wwv_flow_imp.g_varchar2_table(120) := '766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A0D0A2E646A732D636F6E746578742D706164202E656E7472793A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D636F6E746578742D7061642D656E747279';
wwv_flow_imp.g_varchar2_table(121) := '2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D636F6E746578742D7061642E6F70656E207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2F2A2A0D0A202A20706F707570207374796C65';
wwv_flow_imp.g_varchar2_table(122) := '730D0A202A2F0D0A2E646A732D706F707570207B0D0A20206C696E652D6865696768743A20313B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A202077696474683A206D696E2D636F6E74656E743B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(123) := '756E643A20766172282D2D706F7075702D6261636B67726F756E642D636F6C6F72293B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020706F736974696F6E3A2066697865643B0D0A20207A2D696E6465783A203230303B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(124) := '2D736861646F773A20307078203270782036707820766172282D2D706F7075702D736861646F772D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D626F726465722D636F6C6F72293B0D0A20206D';
wwv_flow_imp.g_varchar2_table(125) := '696E2D77696474683A2031323070783B0D0A20206F75746C696E653A206E6F6E653B0D0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A65293B0D0A2020666F6E742D66616D696C793A20766172282D2D706F707570';
wwv_flow_imp.g_varchar2_table(126) := '2D666F6E742D66616D696C79293B0D0A7D0D0A0D0A2E646A732D706F7075702D73656172636820696E707574207B0D0A202077696474683A20313030253B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A2020666F6E742D7369';
wwv_flow_imp.g_varchar2_table(127) := '7A653A20766172282D2D706F7075702D666F6E742D73697A65293B0D0A202070616464696E673A20337078203670783B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465723A20736F6C69642031707820766172282D2D70';
wwv_flow_imp.g_varchar2_table(128) := '6F7075702D7365617263682D626F726465722D636F6C6F72293B0D0A20206C696E652D6865696768743A20323170783B0D0A7D0D0A0D0A2E646A732D706F7075702D73656172636820696E7075743A666F637573207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(129) := '2D636F6C6F723A20766172282D2D706F7075702D7365617263682D666F6375732D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D7365617263682D666F6375732D626F';
wwv_flow_imp.g_varchar2_table(130) := '726465722D636F6C6F72293B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A0D0A2E646A732D706F7075702D686561646572207B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D6974656D733A20737472657463683B0D';
wwv_flow_imp.g_varchar2_table(131) := '0A20206C696E652D6865696768743A20323070783B0D0A20206D617267696E3A20313070782031327078203130707820313270783B0D0A7D0D0A0D0A2E646A732D706F7075702D686561646572202E656E747279207B0D0A2020626F726465722D726164';
wwv_flow_imp.g_varchar2_table(132) := '6975733A203270783B0D0A7D0D0A0D0A2E646A732D706F70757020627574746F6E2E656E747279207B0D0A202070616464696E673A20303B0D0A20206261636B67726F756E643A207472616E73706172656E743B0D0A2020626F726465723A20303B0D0A';
wwv_flow_imp.g_varchar2_table(133) := '7D0D0A0D0A2E646A732D706F7075702D686561646572202E656E7472792E616374697665207B0D0A2020636F6C6F723A20766172282D2D706F7075702D6865616465722D656E7472792D73656C65637465642D636F6C6F72293B0D0A7D0D0A0D0A2E646A';
wwv_flow_imp.g_varchar2_table(134) := '732D706F7075702D686561646572202E656E7472792E64697361626C6564207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A0D0A2E646A732D706F7075702D6865616465722D67726F7570207B0D0A2020646973706C61793A20666C6578';
wwv_flow_imp.g_varchar2_table(135) := '3B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A20206D617267696E3A20303B0D0A202070616464696E673A20303B0D';
wwv_flow_imp.g_varchar2_table(136) := '0A7D0D0A0D0A2E646A732D706F7075702D6865616465722D67726F7570202E656E747279207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E';
wwv_flow_imp.g_varchar2_table(137) := '7465723B0D0A7D0D0A0D0A2E646A732D706F7075702D6865616465722D67726F7570202B202E646A732D706F7075702D6865616465722D67726F75703A6265666F7265207B0D0A2020636F6E74656E743A2027273B0D0A202077696474683A203170783B';
wwv_flow_imp.g_varchar2_table(138) := '0D0A20206865696768743A20323070783B0D0A20206261636B67726F756E643A20766172282D2D706F7075702D6865616465722D67726F75702D646976696465722D636F6C6F72293B0D0A20206D617267696E3A2030203570783B0D0A7D0D0A0D0A2E64';
wwv_flow_imp.g_varchar2_table(139) := '6A732D706F7075702D736561726368207B0D0A20206D617267696E3A203130707820313270783B0D0A7D0D0A0D0A2E646A732D706F7075702D7469746C65207B0D0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A65';
wwv_flow_imp.g_varchar2_table(140) := '293B0D0A2020666F6E742D7765696768743A20766172282D2D706F7075702D6865616465722D666F6E742D776569676874293B0D0A2020666C65783A20313B0D0A20206D617267696E3A20303B0D0A7D0D0A0D0A2E646A732D706F7075702D7365617263';
wwv_flow_imp.g_varchar2_table(141) := '68207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A202077696474683A206175746F3B0D0A7D0D0A0D0A2E646A732D706F7075702D7365617263682D69636F6E207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020';
wwv_flow_imp.g_varchar2_table(142) := '6C6566743A203870783B0D0A2020746F703A203770783B0D0A7D0D0A0D0A2E646A732D706F7075702D73656172636820696E707574207B0D0A202070616464696E672D6C6566743A20323570783B0D0A7D0D0A0D0A2E646A732D706F7075702D72657375';
wwv_flow_imp.g_varchar2_table(143) := '6C7473207B0D0A20206D617267696E3A20377078203370782037707820313270783B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A20206D61782D6865696768743A2032383070783B0D0A20206F766572666C6F773A206175746F3B0D0A2020';
wwv_flow_imp.g_varchar2_table(144) := '70616464696E672D72696768743A203970783B0D0A7D0D0A0D0A2E646A732D706F7075702D67726F7570207B0D0A20206D617267696E3A20303B0D0A202070616464696E673A20303B0D0A202077696474683A20313030253B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(145) := '2D706F7075702D626F6479202E656E7472792C0D0A2E646A732D706F7075702D626F6479202E656E7472792D686561646572207B0D0A202070616464696E673A20357078203770783B0D0A2020637572736F723A2064656661756C743B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(146) := '6465722D7261646975733A203470783B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E7472792D686561646572207B0D0A2020666F6E742D7765696768743A20766172282D2D706F7075702D6865616465722D666F6E742D7765696768';
wwv_flow_imp.g_varchar2_table(147) := '74293B0D0A2020636F6C6F723A20766172282D2D706F7075702D656E7472792D7469746C652D636F6C6F72293B0D0A202070616464696E672D6C6566743A20303B0D0A7D0D0A0D0A2E646A732D706F707570205B636C6173732A3D2269636F6E225D202E';
wwv_flow_imp.g_varchar2_table(148) := '646A732D706F7075702D6C6162656C2C0D0A2E646A732D706F7075702D6C6162656C3A6E6F74283A66697273742D6368696C6429207B0D0A20206D617267696E2D6C6566743A202E35656D3B0D0A7D0D0A0D0A2E646A732D706F707570205B636C617373';
wwv_flow_imp.g_varchar2_table(149) := '2A3D2269636F6E225D3A6265666F72652C0D0A2E646A732D706F7075702D656E7472792D69636F6E207B0D0A202077696474683A2031656D3B0D0A20206865696768743A2031656D3B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D';
wwv_flow_imp.g_varchar2_table(150) := '0A2020666F6E742D73697A653A20312E34656D3B0D0A2020766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E7472792D6865616465723A6E6F74283A66697273742D6368696C64';
wwv_flow_imp.g_varchar2_table(151) := '29207B0D0A20206D617267696E2D746F703A203870783B0D0A20206D617267696E2D626F74746F6D3A203270783B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E747279207B0D0A2020646973706C61793A20666C65783B0D0A202066';
wwv_flow_imp.g_varchar2_table(152) := '6C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A20737472657463683B0D0A20206865696768743A206D696E2D636F6E74656E743B0D0A7D0D0A0D0A2E646A732D706F707570202E656E7472792E73656C65637465';
wwv_flow_imp.g_varchar2_table(153) := '64207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706F7075702D656E7472792D686F7665722D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E7472793A6E6F74283A66697273742D636869';
wwv_flow_imp.g_varchar2_table(154) := '6C6429207B0D0A20206D617267696E2D746F703A203270783B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D636F6E74656E74207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20636F6C75';
wwv_flow_imp.g_varchar2_table(155) := '6D6E3B0D0A2020666C65783A20313B0D0A20206F766572666C6F773A2068696464656E3B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E207B0D0A2020636F6C6F723A20766172282D2D706F7075702D64657363';
wwv_flow_imp.g_varchar2_table(156) := '72697074696F6E2D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D706F7075702D6C6162656C2C0D0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E207B0D0A20206C696E652D6865696768743A20312E34656D3B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(157) := '0A2E646A732D706F707570202E656E7472792C0D0A2E646A732D706F707570202E656E7472792D686561646572207B0D0A20206D617267696E3A203170783B0D0A7D0D0A0D0A2E646A732D706F7075702D7469746C652C0D0A2E646A732D706F7075702D';
wwv_flow_imp.g_varchar2_table(158) := '6C6162656C2C0D0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E2C0D0A2E646A732D706F707570202E656E7472792D686561646572207B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020746578742D6F76657266';
wwv_flow_imp.g_varchar2_table(159) := '6C6F773A20656C6C69707369733B0D0A202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D6E616D65207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D706F';
wwv_flow_imp.g_varchar2_table(160) := '7075702D626F6479207B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A202077696474683A206175746F3B0D0A7D0D0A0D0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C626172207B0D0A2020776964';
wwv_flow_imp.g_varchar2_table(161) := '74683A203670783B0D0A7D0D0A0D0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A2020626F726465722D7261646975733A203370783B0D0A20206261636B67726F756E642D636F6C6F723A2072';
wwv_flow_imp.g_varchar2_table(162) := '67626128302C20302C20302C20302E32293B0D0A7D0D0A0D0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A20206261636B67726F756E643A';
wwv_flow_imp.g_varchar2_table(163) := '207472616E73706172656E743B0D0A20206D617267696E3A20303B0D0A202070616464696E673A203570783B0D0A7D0D0A0D0A2E646A732D706F7075702D6E6F2D726573756C7473207B0D0A202070616464696E673A2030203132707820313270782031';
wwv_flow_imp.g_varchar2_table(164) := '3270783B0D0A2020636F6C6F723A20766172282D2D706F7075702D6E6F2D726573756C74732D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D646F6373207B0D0A2020666C65783A20303B0D0A2020666C65782D64697265';
wwv_flow_imp.g_varchar2_table(165) := '6374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A202070616464696E672D6C6566743A203570783B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E65';
wwv_flow_imp.g_varchar2_table(166) := '6E7472793A686F766572202E646A732D706F7075702D656E7472792D646F6373207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D646F637320737667207B0D0A2020766572746963616C2D61';
wwv_flow_imp.g_varchar2_table(167) := '6C69676E3A206D6964646C653B0D0A20206D617267696E3A206175746F20327078206175746F203570783B0D0A7D0D0A0D0A2F2A2A0D0A202A202070616C65747465207374796C65730D0A202A2F0D0A2E646A732D70616C65747465207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(168) := '636B67726F756E643A20766172282D2D70616C657474652D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D70616C657474652D626F726465722D636F6C6F72293B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(169) := '65722D7261646975733A203270783B0D0A7D0D0A0D0A2F2A2A0D0A202A2062656E64706F696E74730D0A202A2F0D0A2E646A732D7365676D656E742D647261676765722C0D0A2E646A732D62656E64706F696E74207B0D0A2020646973706C61793A206E';
wwv_flow_imp.g_varchar2_table(170) := '6F6E653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D64726167676572202E646A732D76697375616C207B0D0A2020646973706C61793A206E6F6E653B0D0A0D0A202066696C6C3A20766172282D2D62656E64706F696E742D66696C6C2D636F6C6F';
wwv_flow_imp.g_varchar2_table(171) := '72293B0D0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D77696474683A203170783B0D0A20207374726F6B652D6F7061636974793A20313B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(172) := '2D7365676D656E742D647261676765723A686F766572202E646A732D76697375616C207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E646A732D62656E64706F696E74202E646A732D76697375616C207B0D0A202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(173) := '766172282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0D0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D77696474683A203170783B0D0A7D0D0A0D0A2E';
wwv_flow_imp.g_varchar2_table(174) := '646A732D7365676D656E742D647261676765723A686F7665722C0D0A2E646A732D62656E64706F696E74732E686F766572202E646A732D7365676D656E742D647261676765722C0D0A2E646A732D62656E64706F696E74732E73656C6563746564202E64';
wwv_flow_imp.g_varchar2_table(175) := '6A732D7365676D656E742D647261676765722C0D0A2E646A732D62656E64706F696E743A686F7665722C0D0A2E646A732D62656E64706F696E74732E686F766572202E646A732D62656E64706F696E742C0D0A2E646A732D62656E64706F696E74732E73';
wwv_flow_imp.g_varchar2_table(176) := '656C6563746564202E646A732D62656E64706F696E74207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E646A732D647261672D616374697665202E646A732D62656E64706F696E7473202A207B0D0A2020646973706C61793A206E';
wwv_flow_imp.g_varchar2_table(177) := '6F6E653B0D0A7D0D0A0D0A2E646A732D62656E64706F696E74733A6E6F74282E686F76657229202E666C6F6174696E67207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765723A686F7665';
wwv_flow_imp.g_varchar2_table(178) := '72202E646A732D76697375616C2C0D0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E67202E646A732D76697375616C2C0D0A2E646A732D62656E64706F696E743A686F766572202E646A732D76697375616C2C0D0A2E';
wwv_flow_imp.g_varchar2_table(179) := '646A732D62656E64706F696E742E666C6F6174696E67202E646A732D76697375616C207B0D0A202066696C6C3A20766172282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0D0A20207374726F6B653A20766172282D2D62656E64706F696E';
wwv_flow_imp.g_varchar2_table(180) := '742D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D6F7061636974793A20313B0D0A7D0D0A0D0A2E646A732D62656E64706F696E742E666C6F6174696E67202E646A732D686974207B0D0A2020706F696E7465722D6576656E74733A206E';
wwv_flow_imp.g_varchar2_table(181) := '6F6E653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D64726167676572202E646A732D6869742C0D0A2E646A732D62656E64706F696E74202E646A732D686974207B0D0A202066696C6C3A206E6F6E653B0D0A2020706F696E7465722D6576656E74';
wwv_flow_imp.g_varchar2_table(182) := '733A20616C6C3B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765722E686F72697A6F6E74616C202E646A732D686974207B0D0A2020637572736F723A206E732D726573697A653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D6472';
wwv_flow_imp.g_varchar2_table(183) := '61676765722E766572746963616C202E646A732D686974207B0D0A2020637572736F723A2065772D726573697A653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E67202E646A732D686974207B0D0A';
wwv_flow_imp.g_varchar2_table(184) := '2020706F696E7465722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2E646A732D7570646174696E672C0D0A2E646A732D7570646174696E67203E202A207B0D0A2020706F696E7465722D6576656E74733A206E6F6E652021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(185) := '3B0D0A7D0D0A0D0A2E646A732D7570646174696E67202E646A732D636F6E746578742D7061642C0D0A2E646A732D7570646174696E67202E646A732D6F75746C696E652C0D0A2E646A732D7570646174696E67202E646A732D62656E64706F696E742C0D';
wwv_flow_imp.g_varchar2_table(186) := '0A2E646A732D6D756C74692D73656C656374202E646A732D62656E64706F696E742C0D0A2E646A732D6D756C74692D73656C656374202E646A732D7365676D656E742D647261676765722C0D0A2E636F6E6E6563742D6F6B202E646A732D62656E64706F';
wwv_flow_imp.g_varchar2_table(187) := '696E742C0D0A2E636F6E6E6563742D6E6F742D6F6B202E646A732D62656E64706F696E742C0D0A2E64726F702D6F6B202E646A732D62656E64706F696E742C0D0A2E64726F702D6E6F742D6F6B202E646A732D62656E64706F696E74207B0D0A20206469';
wwv_flow_imp.g_varchar2_table(188) := '73706C61793A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E672C0D0A2E646A732D62656E64706F696E742E646A732D6472616767696E67207B0D0A202064';
wwv_flow_imp.g_varchar2_table(189) := '6973706C61793A20626C6F636B3B0D0A20206F7061636974793A20312E303B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A20746F6F6C746970730D0A202A2F0D0A2E646A732D746F6F6C7469702D6572726F72207B0D0A202077696474683A2031363070783B';
wwv_flow_imp.g_varchar2_table(190) := '0D0A202070616464696E673A203670783B0D0A0D0A20206261636B67726F756E643A20766172282D2D746F6F6C7469702D6572726F722D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D';
wwv_flow_imp.g_varchar2_table(191) := '2D746F6F6C7469702D6572726F722D626F726465722D636F6C6F72293B0D0A2020626F726465722D7261646975733A203270783B0D0A2020636F6C6F723A20766172282D2D746F6F6C7469702D6572726F722D636F6C6F72293B0D0A2020666F6E742D73';
wwv_flow_imp.g_varchar2_table(192) := '697A653A20313270783B0D0A20206C696E652D6865696768743A20313670783B0D0A0D0A20206F7061636974793A20302E37353B0D0A7D0D0A0D0A2E646A732D746F6F6C7469702D6572726F723A686F766572207B0D0A20206F7061636974793A20313B';
wwv_flow_imp.g_varchar2_table(193) := '0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A20736561726368207061640D0A202A2F0D0A2E646A732D7365617263682D636F6E7461696E6572207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A20323070783B0D0A20206C65';
wwv_flow_imp.g_varchar2_table(194) := '66743A20303B0D0A202072696768743A20303B0D0A20206D617267696E2D6C6566743A206175746F3B0D0A20206D617267696E2D72696768743A206175746F3B0D0A0D0A202077696474683A203235253B0D0A20206D696E2D77696474683A2033303070';
wwv_flow_imp.g_varchar2_table(195) := '783B0D0A20206D61782D77696474683A2034303070783B0D0A20207A2D696E6465783A2031303B0D0A0D0A2020666F6E742D73697A653A20312E3035656D3B0D0A20206F7061636974793A20302E393B0D0A20206261636B67726F756E643A2076617228';
wwv_flow_imp.g_varchar2_table(196) := '2D2D7365617263682D636F6E7461696E65722D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D7365617263682D636F6E7461696E65722D626F726465722D636F6C6F72293B0D0A2020';
wwv_flow_imp.g_varchar2_table(197) := '626F726465722D7261646975733A203270783B0D0A2020626F782D736861646F773A2030203020302032707820766172282D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D636F6C6F72292C2030203020302031707820766172';
wwv_flow_imp.g_varchar2_table(198) := '282D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D696E7365742D636F6C6F722920696E7365743B0D0A7D0D0A0D0A2E646A732D7365617263682D636F6E7461696E65723A6E6F74282E6F70656E29207B0D0A2020646973706C';
wwv_flow_imp.g_varchar2_table(199) := '61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D7365617263682D696E70757420696E707574207B0D0A2020666F6E742D73697A653A20312E3035656D3B0D0A202077696474683A20313030253B0D0A202070616464696E673A203670782031307078';
wwv_flow_imp.g_varchar2_table(200) := '3B0D0A2020626F726465723A2031707820736F6C696420766172282D2D7365617263682D696E7075742D626F726465722D636F6C6F72293B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A7D0D0A0D0A2E646A732D7365617263';
wwv_flow_imp.g_varchar2_table(201) := '682D696E70757420696E7075743A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F726465722D636F6C6F723A20766172282D2D7365617263682D696E7075742D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E646A';
wwv_flow_imp.g_varchar2_table(202) := '732D7365617263682D726573756C7473207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A20206F766572666C6F772D793A206175746F3B0D0A20206D61782D6865696768743A2032303070783B0D0A7D0D0A0D0A2E646A732D73656172';
wwv_flow_imp.g_varchar2_table(203) := '63682D726573756C74733A686F766572207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C74207B0D0A202077696474683A20313030253B0D0A202070616464696E673A20367078203130';
wwv_flow_imp.g_varchar2_table(204) := '70783B0D0A20206261636B67726F756E643A2077686974653B0D0A2020626F726465722D626F74746F6D3A20736F6C69642031707820766172282D2D7365617263682D726573756C742D626F726465722D636F6C6F72293B0D0A2020626F726465722D72';
wwv_flow_imp.g_varchar2_table(205) := '61646975733A203170783B0D0A7D0D0A0D0A2E646A732D7365617263682D686967686C69676874207B0D0A2020636F6C6F723A20766172282D2D7365617263682D726573756C742D686967686C696768742D636F6C6F72293B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(206) := '2D7365617263682D726573756C742D7072696D617279207B0D0A20206D617267696E3A2030203020313070783B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C742D7365636F6E64617279207B0D0A2020666F6E742D66616D696C793A206D';
wwv_flow_imp.g_varchar2_table(207) := '6F6E6F73706163653B0D0A20206D617267696E3A20303B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C743A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C6563746564';
wwv_flow_imp.g_varchar2_table(208) := '2D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C742D73656C6563746564207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(209) := '0A0D0A2E646A732D7365617263682D726573756C742D73656C65637465643A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0D0A7D0D0A0D0A2E646A';
wwv_flow_imp.g_varchar2_table(210) := '732D7365617263682D6F7665726C6179207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0D0A7D0D0A0D0A2F2A2A0D0A202A2068696464656E207374796C65730D0A';
wwv_flow_imp.g_varchar2_table(211) := '202A2F0D0A2E646A732D656C656D656E742D68696464656E2C0D0A2E646A732D656C656D656E742D68696464656E202E646A732D6869742C0D0A2E646A732D656C656D656E742D68696464656E202E646A732D6F75746C696E652C0D0A2E646A732D6C61';
wwv_flow_imp.g_varchar2_table(212) := '62656C2D68696464656E202E646A732D6C6162656C207B0D0A2020646973706C61793A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D656C656D656E74202E646A732D6869742D7374726F6B652C0D0A2E646A732D656C656D65';
wwv_flow_imp.g_varchar2_table(213) := '6E74202E646A732D6869742D636C69636B2D7374726F6B652C0D0A2E646A732D656C656D656E74202E646A732D6869742D616C6C207B0D0A2020637572736F723A206D6F76653B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5454524647539079)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/diagram-js.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E666C6F777334617065782D6D6F64656C6572207B0D0A20202D2D636F6C6F722D666C6F77732D627574746F6E2D677265656E3A20233532423431353B0D0A7D0D0A2F2A2A0D0A202A2067656E6572616C0D0A202A2F0D0A2E63616E766173207B0D0A20';
wwv_flow_imp.g_varchar2_table(2) := '206865696768743A20383076683B0D0A20206261636B67726F756E642D636F6C6F723A20236630663066303B0D0A7D0D0A2E666C6F777334617065782D6D6F64656C6572207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A7D20200D0A';
wwv_flow_imp.g_varchar2_table(3) := '2E70726F706572746965732D70616E656C2D706172656E74207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A20323070783B0D0A2020626F74746F6D3A20303B0D0A202072696768743A20323070783B0D0A2020776964';
wwv_flow_imp.g_varchar2_table(4) := '74683A2032363070783B0D0A20206D696E2D77696474683A2032363070783B0D0A20206D61782D77696474683A203530253B0D0A20207A2D696E6465783A2031303B0D0A2020626F726465723A2031707820736F6C696420236363633B0D0A20206F7665';
wwv_flow_imp.g_varchar2_table(5) := '72666C6F773A206175746F3B0D0A2020646973706C61793A20626C6F636B3B0D0A20206865696768743A203930253B0D0A7D0D0A2E70726F706572746965732D70616E656C2D706172656E743A656D707479207B0D0A2020646973706C61793A206E6F6E';
wwv_flow_imp.g_varchar2_table(6) := '653B0D0A7D0D0A2F2A2A200D0A202A20637573746F6D20636F6C6F72730D0A202A2F0D0A202E626A732D636F6E7461696E6572207B0D0A20202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B0D0A20202D2D64656661756C742D73';
wwv_flow_imp.g_varchar2_table(7) := '74726F6B652D636F6C6F723A20626C61636B3B0D0A7D0D0A2F2A2A0D0A202A2070726F706572746965732070616E656C0D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682D656E747279203E202E';
wwv_flow_imp.g_varchar2_table(8) := '62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E207B0D0A20206D617267696E2D6C6566743A203070782021696D706F7274616E743B0D0A7D0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D';
wwv_flow_imp.g_varchar2_table(9) := '7377697463682D656E747279202B202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682D656E747279207B0D0A20206D617267696E2D746F703A203070782021696D706F7274616E743B0D0A7D0D0A2F2A2A0D0A20';
wwv_flow_imp.g_varchar2_table(10) := '2A20726573697A652069636F6E0D0A202A2F0D0A202E70726F706572746965732D70616E656C2D706172656E743A6166746572207B0D0A2020636F6E74656E743A202220223B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20206C6566';
wwv_flow_imp.g_varchar2_table(11) := '743A20303B0D0A2020746F703A20303B0D0A202077696474683A203570783B0D0A20206865696768743A20313030253B0D0A2020637572736F723A20772D726573697A653B0D0A7D0D0A2F2A2A0D0A202A206F70656E206469616C6F6720627574746F6E';
wwv_flow_imp.g_varchar2_table(12) := '0D0A202A2F0D0A2E6F70656E2D6469616C6F672D6C6162656C207B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B0D0A7D0D0A2E6F70656E2D6469616C6F672D6C61';
wwv_flow_imp.g_varchar2_table(13) := '62656C202E66612E66612D626F782D6172726F772D696E2D6E65207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A2F2A2A0D0A202A20717569636B7069636B7320696E206465736372697074696F6E730D0A202A2F0D0A2E62696F2D70';
wwv_flow_imp.g_varchar2_table(14) := '726F706572746965732D70616E656C2D6465736372697074696F6E202E62696F2D70726F706572746965732D70616E656C2D717569636B7069636B2D6C696E6B207B0D0A2020637572736F723A20706F696E7465723B0D0A20206D617267696E2D696E6C';
wwv_flow_imp.g_varchar2_table(15) := '696E652D656E643A20313270783B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A7D0D0A2F2A2A0D0A202A20627574746F6E2D6C696B6520717569636B7069636B730D0A202A2F0D0A2E62696F2D7072';
wwv_flow_imp.g_varchar2_table(16) := '6F706572746965732D70616E656C2D67726F75702D656E7472696573203E202E62696F2D70726F706572746965732D70616E656C2D717569636B7069636B207B0D0A20206D617267696E3A2036707820333270782030707820313270783B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(17) := '62696F2D70726F706572746965732D70616E656C2D67726F75702D656E7472696573203E202E62696F2D70726F706572746965732D70616E656C2D717569636B7069636B203E202E62696F2D70726F706572746965732D70616E656C2D717569636B7069';
wwv_flow_imp.g_varchar2_table(18) := '636B2D6C696E6B207B0D0A2020637572736F723A20706F696E7465723B0D0A2020636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D627574746F6E2D677265656E293B0D0A20206D617267696E2D696E6C696E652D656E643A20313270783B';
wwv_flow_imp.g_varchar2_table(19) := '0D0A7D0D0A2F2A2A0D0A202A2068656C70746578740D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D68656C7074657874207B0D0A20206D617267696E3A2032707820333270782036707820313270783B0D0A2020666F6E742D73';
wwv_flow_imp.g_varchar2_table(20) := '74796C653A206974616C69633B0D0A7D0D0A2F2A2A0D0A202A2041646420626F7264657220746F2066697273742067726F757020696E206E65737465642067726F7570730D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F';
wwv_flow_imp.g_varchar2_table(21) := '75702D656E7472696573202E62696F2D70726F706572746965732D70616E656C2D67726F75703A66697273742D6368696C640D0A7B0D0A2020626F726465722D746F703A2031707820736F6C696420766172282D2D67726F75702D626F74746F6D2D626F';
wwv_flow_imp.g_varchar2_table(22) := '726465722D636F6C6F72293B0D0A7D0D0A2F2A2A200D0A202A2052656D6F766520646F75626C6520626F726465722061742074686520656E64206F66206E65737465642067726F7570730D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(23) := '656C2D7363726F6C6C2D636F6E7461696E6572203E202E62696F2D70726F706572746965732D70616E656C2D67726F75703A68617328203E202E62696F2D70726F706572746965732D70616E656C2D67726F75702D656E74726965732E6F70656E203E20';
wwv_flow_imp.g_varchar2_table(24) := '2E62696F2D70726F706572746965732D70616E656C2D67726F75703A6C6173742D6368696C6429207B0D0A2020626F726465722D626F74746F6D3A206E6F6E653B0D0A7D0D0A2F2A2A0D0A202A20486967686C6967687420746F70206C6576656C206772';
wwv_flow_imp.g_varchar2_table(25) := '6F757020686561646572730D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D7363726F6C6C2D636F6E7461696E6572203E202E62696F2D70726F706572746965732D70616E656C2D67726F7570203E202E62696F2D70726F706572';
wwv_flow_imp.g_varchar2_table(26) := '746965732D70616E656C2D67726F75702D686561646572203E202E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D7469746C65207B0D0A2020666F6E742D7765696768743A203630303B0D0A7D0D0A2F2A2A0D0A20';
wwv_flow_imp.g_varchar2_table(27) := '2A2052656D6F766520626F726465722061742074686520656E64206F6620706167654974656D732067726F75700D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75705B646174612D67726F75702D69643D2267726F7570';
wwv_flow_imp.g_varchar2_table(28) := '2D706167654974656D73225D207B0D0A2020626F726465722D626F74746F6D2D7374796C653A206E6F6E653B0D0A7D0D0A2F2A2A200D0A202A206D6F6E61636F20656469746F720D0A202A2F0D0A202E6D6F64616C207B0D0A2020646973706C61793A20';
wwv_flow_imp.g_varchar2_table(29) := '6E6F6E653B0D0A2020706F736974696F6E3A2066697865643B0D0A20207A2D696E6465783A203939393B0D0A20206C6566743A20303B0D0A2020746F703A20303B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A';
wwv_flow_imp.g_varchar2_table(30) := '20206F766572666C6F773A206175746F3B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C302C302C302E34293B0D0A7D0D0A2E6D6F64616C2D636F6E74656E74207B0D0A20206261636B67726F756E642D636F6C6F723A207768';
wwv_flow_imp.g_varchar2_table(31) := '6974653B0D0A20206D617267696E3A206175746F3B0D0A202070616464696E673A203020313070783B0D0A2020626F726465723A2031707820736F6C696420233838383B0D0A202077696474683A203130303070783B0D0A20206865696768743A203530';
wwv_flow_imp.g_varchar2_table(32) := '3070783B0D0A2020646973706C61793A20677269643B0D0A2020677269642D74656D706C6174652D636F6C756D6E733A20313030253B0D0A2020677269642D74656D706C6174652D726F77733A2031302520383025203130253B0D0A7D0D0A2E62757474';
wwv_flow_imp.g_varchar2_table(33) := '6F6E2D636F6E7461696E6572207B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A7D0D0A2E627574746F6E2D636F6E7461696E65722E656E64207B0D0A20206A7573746966792D636F6E74';
wwv_flow_imp.g_varchar2_table(34) := '656E743A20656E643B0D0A7D0D0A2E627574746F6E2D636F6E7461696E65722E737461727420627574746F6E2E6469616C6F67207B0D0A20206D617267696E2D72696768743A203570783B0D0A7D0D0A2E627574746F6E2D636F6E7461696E65722E656E';
wwv_flow_imp.g_varchar2_table(35) := '6420627574746F6E2E6469616C6F67207B0D0A20206D617267696E2D6C6566743A203570783B0D0A7D0D0A627574746F6E2E6469616C6F67207B0D0A2020706F736974696F6E3A207374617469633B0D0A20206865696768743A20333070783B0D0A2020';
wwv_flow_imp.g_varchar2_table(36) := '6D696E2D77696474683A20363070783B0D0A2020637572736F723A20706F696E7465723B0D0A2020626F726465723A2031707820736F6C696420236363633B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(37) := '2D636F6C6F723A20236638663866383B0D0A7D0D0A627574746F6E2E6469616C6F673A686F766572207B0D0A2020636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D627574746F6E2D677265656E293B0D0A7D0D0A627574746F6E2E646961';
wwv_flow_imp.g_varchar2_table(38) := '6C6F672E6661207B0D0A202077696474683A20343070783B0D0A7D0D0A23736176652D62746E207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D627574746F6E2D677265656E293B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(39) := '6C6F723A2077686974653B0D0A7D0D0A236572726F722D74657874207B0D0A202077696474683A20313030253B0D0A20206D61782D6865696768743A20343070783B0D0A20206F766572666C6F773A206175746F3B0D0A7D0D0A23656469746F722D636F';
wwv_flow_imp.g_varchar2_table(40) := '6E7461696E6572207B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A2020626F726465723A2031707820736F6C696420233838383B0D0A7D0D0A2F2A2A0D0A202A206461726B206D6F6465200D0A202A2F0D0A2E';
wwv_flow_imp.g_varchar2_table(41) := '464C4F57532D4441524B207B0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E643A20233262333033353B0D0A20202D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B67726F756E643A202333';
wwv_flow_imp.g_varchar2_table(42) := '32333833643B0D0A0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D70726F706572746965732D70616E656C2D696E7075743A20233238326333303B0D0A0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D696E7075742D666F6375733A';
wwv_flow_imp.g_varchar2_table(43) := '20233165323633303B0D0A20200D0A20202D2D636F6C6F722D666C6F77732D6461726B2D686F7665723A20233165323332383B0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D64726F702D6E6F742D616C6C6F7765643A20233366333033353B';
wwv_flow_imp.g_varchar2_table(44) := '0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D6C696E743A20233463346535303B0D0A7D0D0A2F2A2A0D0A202A20637573746F6D20636F6C6F72730D0A202A2F0D0A2E464C4F57532D4441524B202E63616E766173207B0D0A20206261636B67';
wwv_flow_imp.g_varchar2_table(45) := '726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D636F6E7461696E6572207B0D0A20202D2D64656661756C742D66696C6C2D';
wwv_flow_imp.g_varchar2_table(46) := '636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E646A732D706F';
wwv_flow_imp.g_varchar2_table(47) := '707570207B0D0A20202D2D706F7075702D626F64792D6261636B67726F756E642D636F6C6F723A2020766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A20202D2D706F7075702D6261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(48) := '6F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E646A732D706F7075702D73656172636820696E707574207B';
wwv_flow_imp.g_varchar2_table(49) := '0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D70726F706572746965732D70616E656C2D696E707574293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441';
wwv_flow_imp.g_varchar2_table(50) := '524B202E646A732D706F7075702D73656172636820696E7075743A666F637573207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D';
wwv_flow_imp.g_varchar2_table(51) := '0A7D0D0A2E464C4F57532D4441524B202E646A732D706F707570202E656E7472792E73656C6563746564207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D626163';
wwv_flow_imp.g_varchar2_table(52) := '6B67726F756E64293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E646A732D636F6E746578742D706164202E656E747279207B0D0A20202D2D636F6E746578742D7061642D656E7472792D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(53) := '6E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A20202D2D636F6E746578742D7061642D656E7472792D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D63';
wwv_flow_imp.g_varchar2_table(54) := '6F6C6F722D666C6F77732D6461726B2D686F766572293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E646A732D70616C65747465207B0D0A20202D2D70616C657474652D6261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(55) := '723A20766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D0A20202D2D70616C657474652D656E7472792D636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E646A73';
wwv_flow_imp.g_varchar2_table(56) := '2D6469726563742D65646974696E672D706172656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64292021696D706F7274616E743B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(57) := '723A2077686974652021696D706F7274616E743B0D0A7D0D0A2E464C4F57532D4441524B202E646A732D636F6E7461696E6572207B0D0A20202D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(58) := '636F6C6F722D666C6F77732D6461726B2D64726F702D6E6F742D616C6C6F776564293B0D0A20202D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67';
wwv_flow_imp.g_varchar2_table(59) := '726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B202E646A732D73686170652E636F6E6E6563742D6F6B207B0D0A20202D2D73686170652D636F6E6E6563742D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D66';
wwv_flow_imp.g_varchar2_table(60) := '6C6F77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D706F77657265642D6279207B0D0A2020636F6C6F723A2077686974652021696D706F7274616E743B0D0A7D0D0A2E464C';
wwv_flow_imp.g_varchar2_table(61) := '4F57532D4441524B202E626A736C2D627574746F6E3A6E6F74282E626A736C2D627574746F6E2D6572726F7229207B0D0A2020636F6C6F723A20233830383038303B0D0A7D0D0A2E464C4F57532D4441524B202E626A736C2D627574746F6E2D696E6163';
wwv_flow_imp.g_varchar2_table(62) := '74697665207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6C696E74292021696D706F7274616E743B0D0A7D0D0A2E464C4F57532D4441524B202E626A736C2D627574746F6E2D696E';
wwv_flow_imp.g_varchar2_table(63) := '6163746976653A686F766572207B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B207376672E6E65772D706172656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C';
wwv_flow_imp.g_varchar2_table(64) := '6F77732D6461726B2D6261636B67726F756E64292021696D706F7274616E743B0D0A7D0D0A2E464C4F57532D4441524B202E626A736C2D697373756573207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F';
wwv_flow_imp.g_varchar2_table(65) := '77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B202E626A736C2D6973737565732061207B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2F2A2A0D0A202A20637573746F6D207072';
wwv_flow_imp.g_varchar2_table(66) := '6F706572746965732070616E656C20636F6C6F72730D0A202A2F0D0A2E464C4F5753202E62696F2D70726F706572746965732D70616E656C2D636F6E7461696E6572207B0D0A20206261636B67726F756E642D636F6C6F723A2068736C283232352C2031';
wwv_flow_imp.g_varchar2_table(67) := '30252C20393525293B0D0A7D0D0A2E464C4F57532D4441524B202E62696F2D70726F706572746965732D70616E656C2D636F6E7461696E65722C0D0A2E464C4F57532D4441524B202E62696F2D70726F706572746965732D70616E656C2D686561646572';
wwv_flow_imp.g_varchar2_table(68) := '207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E62696F2D7072';
wwv_flow_imp.g_varchar2_table(69) := '6F706572746965732D70616E656C2D67726F75702C0D0A2E464C4F57532D4441524B202E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722E737469636B79207B0D0A2020206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(70) := '20766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D0A202020636F6C6F723A2077686974653B0D0A207D0D0A2E464C4F57532D4441524B202E62696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(71) := '6C207B0D0A20202D2D696E7075742D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D70726F706572746965732D70616E656C2D696E707574293B0D0A20202D2D696E7075742D666F6375732D6261';
wwv_flow_imp.g_varchar2_table(72) := '636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D696E7075742D666F637573293B0D0A20202D2D696E7075742D6572726F722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(73) := '666C6F77732D6461726B2D70726F706572746965732D70616E656C2D696E707574293B0D0A20202D2D706C616365686F6C6465722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D70726F706572';
wwv_flow_imp.g_varchar2_table(74) := '746965732D70616E656C2D696E707574293B0D0A20202D2D6164642D656E7472792D66696C6C2D636F6C6F723A2077686974653B0D0A20202D2D6172726F772D66696C6C2D636F6C6F723A2077686974653B0D0A20202D2D646F742D636F6C6F723A2077';
wwv_flow_imp.g_varchar2_table(75) := '686974653B0D0A20202D2D6172726F772D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6461726B2D70726F706572746965732D70616E656C2D696E707574293B0D0A7D0D0A2E464C4F57532D';
wwv_flow_imp.g_varchar2_table(76) := '4441524B202E62696F2D70726F706572746965732D70616E656C2D696E7075742C0D0A2E464C4F57532D4441524B202E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E207B0D0A2020636F6C6F723A2077686974653B0D';
wwv_flow_imp.g_varchar2_table(77) := '0A7D0D0A2E464C4F57532D4441524B202E62696F2D70726F706572746965732D70616E656C2D6865616465722D69636F6E20207B0D0A202066696C6C3A2077686974653B0D0A7D0D0A2F2A2A0D0A202A20637573746F6D206D6F6E61636F20656469746F';
wwv_flow_imp.g_varchar2_table(78) := '7220636F6C6F72730D0A202A2F0D0A2E464C4F57532D4441524B202E6D6F64616C2D636F6E74656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B';
wwv_flow_imp.g_varchar2_table(79) := '67726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B20627574746F6E2E6469616C6F67207B0D0A2020636F6C6F723A2077686974653B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D646172';
wwv_flow_imp.g_varchar2_table(80) := '6B2D70726F706572746965732D70616E656C2D696E707574293B0D0A7D0D0A2E464C4F57532D4441524B20627574746F6E2E6469616C6F673A686F766572207B0D0A2020636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D627574746F6E2D';
wwv_flow_imp.g_varchar2_table(81) := '677265656E293B0D0A7D0D0A2F2A204F7665727772697465207465787420636F6C6F72207768656E207573696E672062706D6E20657874656E73696F6E202A2F0D0A2E646A732D76697375616C203E202A3A6E6F74285B7374796C652A3D227374726F6B';
wwv_flow_imp.g_varchar2_table(82) := '653A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B225D29202B2074657874207B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5454925771539079)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/flows4apex.modeler.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2A0D0A202A205468656D696E670D0A202A2F0D0A202E62696F2D70726F706572746965732D70616E656C2C0D0A202E646A732D706172656E74207B0D0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130';
wwv_flow_imp.g_varchar2_table(2) := '252C20313525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525';
wwv_flow_imp.g_varchar2_table(3) := '293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D37353A2068736C283232352C203130252C20373525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0D0A2020';
wwv_flow_imp.g_varchar2_table(4) := '2D2D636F6C6F722D677265792D3232352D31302D38353A2068736C283232352C203130252C20383525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0D0A20202D2D636F6C6F';
wwv_flow_imp.g_varchar2_table(5) := '722D677265792D3232352D31302D39353A2068736C283232352C203130252C20393525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0D0A20202D2D636F6C6F722D67726579';
wwv_flow_imp.g_varchar2_table(6) := '2D302D302D32323A2068736C28302C2030252C20323225293B0D0A0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D33353A2068736C283230352C20313030252C20333525293B0D0A20202D2D636F6C6F722D626C75652D3230352D313030';
wwv_flow_imp.g_varchar2_table(7) := '2D34353A2068736C283230352C20313030252C20343525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D35303A2068736C283230352C20313030252C20353025293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D38';
wwv_flow_imp.g_varchar2_table(8) := '353A2068736C283230352C20313030252C20383525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0D0A20202D2D636F6C6F722D626C75652D3231392D39392D35333A20';
wwv_flow_imp.g_varchar2_table(9) := '68736C283231392C203939252C20353325293B0D0A20202D2D636F6C6F722D626C75652D3231382D3130302D37343A2068736C283231382C20313030252C20373425293B0D0A20202D2D636F6C6F722D677265656E2D3135302D38362D34343A2068736C';
wwv_flow_imp.g_varchar2_table(10) := '283135302C203836252C20343425293B0D0A0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34353A2068736C283336';
wwv_flow_imp.g_varchar2_table(11) := '302C20313030252C20343525293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39373A2068736C283336302C2031';
wwv_flow_imp.g_varchar2_table(12) := '3030252C20393725293B0D0A20202D2D636F6C6F722D77686974653A2077686974653B0D0A20202D2D636F6C6F722D626C61636B3A20626C61636B3B0D0A20202D2D636F6C6F722D7472616E73706172656E743A207472616E73706172656E743B0D0A0D';
wwv_flow_imp.g_varchar2_table(13) := '0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C207B0D0A20202D2D746578742D626173652D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0D0A20202D2D746578742D6572726F722D636F6C';
wwv_flow_imp.g_varchar2_table(14) := '6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A20202D2D6C696E6B2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A0D0A20202D2D6465736372697074696F6E2D63';
wwv_flow_imp.g_varchar2_table(15) := '6F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D6465736372697074696F6E2D636F64652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D39';
wwv_flow_imp.g_varchar2_table(16) := '37293B0D0A20202D2D6465736372697074696F6E2D636F64652D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3835293B0D0A20202D2D6465736372697074696F6E2D6C6973742D6974656D2D636F6C6F';
wwv_flow_imp.g_varchar2_table(17) := '723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A0D0A20202D2D706C616365686F6C6465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D706C616365686F6C';
wwv_flow_imp.g_varchar2_table(18) := '6465722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3935293B0D0A0D0A20202D2D6865616465722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D';
wwv_flow_imp.g_varchar2_table(19) := '3232352D31302D3935293B0D0A20202D2D6865616465722D69636F6E2D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0D0A20202D2D6865616465722D626F74746F6D2D626F726465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(20) := '723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D67726F75702D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D67726F75702D626F74746F6D';
wwv_flow_imp.g_varchar2_table(21) := '2D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D737469636B792D67726F75702D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D32';
wwv_flow_imp.g_varchar2_table(22) := '32352D31302D3935293B0D0A20202D2D737469636B792D67726F75702D626F74746F6D2D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D6164642D656E7472792D66696C6C';
wwv_flow_imp.g_varchar2_table(23) := '2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D6164642D656E7472792D686F7665722D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D6164642D65';
wwv_flow_imp.g_varchar2_table(24) := '6E7472792D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D6164642D656E7472792D6C6162656C2D636F6C6F723A20766172282D2D636F6C6F722D77';
wwv_flow_imp.g_varchar2_table(25) := '68697465293B0D0A0D0A20202D2D72656D6F76652D656E7472792D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A20202D2D72656D6F76652D656E7472792D686F7665722D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(26) := '6E642D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3932293B0D0A0D0A20202D2D6172726F772D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D6172';
wwv_flow_imp.g_varchar2_table(27) := '726F772D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3935293B0D0A0D0A20202D2D646F742D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D33';
wwv_flow_imp.g_varchar2_table(28) := '35293B0D0A20202D2D646F742D636F6C6F722D6572726F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A0D0A20202D2D6C6973742D62616467652D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D';
wwv_flow_imp.g_varchar2_table(29) := '0A20202D2D6C6973742D62616467652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A0D0A20202D2D696E7075742D6261636B67726F756E642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(30) := '636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D696E7075742D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D696E7075742D666F6375732D6261636B';
wwv_flow_imp.g_varchar2_table(31) := '67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3935293B0D0A20202D2D696E7075742D666F6375732D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D';
wwv_flow_imp.g_varchar2_table(32) := '3530293B0D0A0D0A20202D2D696E7075742D6572726F722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3937293B0D0A20202D2D696E7075742D6572726F722D626F726465722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(33) := '3A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A20202D2D696E7075742D6572726F722D666F6375732D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A0D0A';
wwv_flow_imp.g_varchar2_table(34) := '20202D2D696E7075742D64697361626C65642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D696E7075742D64697361626C65642D6261636B67726F756E642D636F6C6F723A20766172282D2D63';
wwv_flow_imp.g_varchar2_table(35) := '6F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D696E7075742D64697361626C65642D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3930293B0D0A0D0A20202D2D746F67676C652D73';
wwv_flow_imp.g_varchar2_table(36) := '77697463682D6F6E2D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D746F67676C652D7377697463682D6F66662D6261636B67726F756E642D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(37) := '72282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D746F67676C652D7377697463682D73776974636865722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(38) := '736964652D6C696E652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D736964652D6C696E652D657874656E73696F6E2D6261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(39) := '766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A0D0A20202D2D6C6973742D656E7472792D646F742D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20';
wwv_flow_imp.g_varchar2_table(40) := '202D2D6C6973742D656E7472792D6865616465722D627574746F6E2D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D6C6973742D656E7472792D6164642D656E7472792D656D707479';
wwv_flow_imp.g_varchar2_table(41) := '2D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D6C6973742D656E7472792D6164642D656E7472792D656D7074792D686F7665722D6261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(42) := '6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D6C6973742D656E7472792D6164642D656E7472792D6C6162656C2D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D6C';
wwv_flow_imp.g_varchar2_table(43) := '6973742D656E7472792D6164642D656E7472792D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D6C6973742D656E7472792D6164642D656E7472792D66696C6C2D63';
wwv_flow_imp.g_varchar2_table(44) := '6F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A0D0A20202D2D64726F70646F776E2D6974656D2D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D64726F70646F776E2D69';
wwv_flow_imp.g_varchar2_table(45) := '74656D2D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3935293B0D0A20202D2D64726F70646F776E2D736570617261746F722D6261636B67726F756E642D636F6C6F723A2076';
wwv_flow_imp.g_varchar2_table(46) := '6172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D6665656C2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D6665656C2D6163746976652D636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(47) := '2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D6665656C2D696E6163746976652D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3335293B0D0A20202D2D6665656C2D686F7665722D636F6C6F';
wwv_flow_imp.g_varchar2_table(48) := '723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0D0A20202D2D6665656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(49) := '6665656C2D6163746976652D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D6665656C2D72657175697265642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20';
wwv_flow_imp.g_varchar2_table(50) := '202D2D6665656C2D6F70656E2D706F7075702D636F6C6F723A2068736C6128302C2030252C203332252C2031293B0D0A20202D2D6665656C2D6F70656E2D706F7075702D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768';
wwv_flow_imp.g_varchar2_table(51) := '697465293B0D0A20202D2D6665656C2D6F70656E2D706F7075702D686F7665722D636F6C6F723A2068736C61283231392C203939252C203533252C2031293B0D0A0D0A20202D2D6665656C2D696E64696361746F722D6261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(52) := '6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3930293B0D0A0D0A20202D2D6665656C6572732D73656C6563742D636F6C6F723A2020766172282D2D636F6C6F722D626C75652D3230352D3130302D3835293B0D0A0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(53) := '746578742D73697A652D626173653A20313470783B0D0A20202D2D746578742D73697A652D736D616C6C3A20313370783B0D0A20202D2D746578742D73697A652D736D616C6C6573743A20313270783B0D0A20202D2D746578742D6C696E652D68656967';
wwv_flow_imp.g_varchar2_table(54) := '68743A20323170783B0D0A20202D2D6C696E652D6865696768742D636F6E64656E7365643A20313770783B0D0A0D0A20202D2D666F6E742D66616D696C793A2073616E732D73657269663B0D0A20202D2D666F6E742D66616D696C792D6D6F6E6F737061';
wwv_flow_imp.g_varchar2_table(55) := '63653A206D6F6E6F73706163653B0D0A0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A2020666C65783A20313B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A2020';
wwv_flow_imp.g_varchar2_table(56) := '6865696768743A20313030253B0D0A202077696474683A20313030253B0D0A20206F766572666C6F773A2068696464656E3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C207B0D0A2020636F6C6F723A20766172282D2D746578';
wwv_flow_imp.g_varchar2_table(57) := '742D626173652D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C202A207B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A20206C696E652D6865696768743A20';
wwv_flow_imp.g_varchar2_table(58) := '766172282D2D746578742D6C696E652D686569676874293B0D0A2020666F6E742D7765696768743A203430303B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C';
wwv_flow_imp.g_varchar2_table(59) := '207B0D0A2020666F6E742D66616D696C793A20766172282D2D666F6E742D66616D696C79293B0D0A7D0D0A0D0A2F2A2A0D0A202A20506C616365686F6C6465722028656D7074792C206D756C74692073656C6563742C202E2E2E290D0A202A2F0D0A2E62';
wwv_flow_imp.g_varchar2_table(60) := '696F2D70726F706572746965732D70616E656C2D706C616365686F6C646572207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E';
wwv_flow_imp.g_varchar2_table(61) := '3B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A2020746F703A20303B0D0A202072696768743A20303B0D0A2020626F74746F6D3A20303B0D0A20206C6566743A';
wwv_flow_imp.g_varchar2_table(62) := '20303B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706C616365686F6C6465722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706C616365686F6C6465';
wwv_flow_imp.g_varchar2_table(63) := '722D74657874207B0D0A2020636F6C6F723A20766172282D2D706C616365686F6C6465722D636F6C6F72293B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A2020746578742D616C69676E3A2063656E';
wwv_flow_imp.g_varchar2_table(64) := '7465723B0D0A20206D617267696E3A203132707820343870783B0D0A7D0D0A0D0A2F2A2A0D0A202A204865616465720D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D686561646572207B0D0A2020646973706C61793A20666C65';
wwv_flow_imp.g_varchar2_table(65) := '783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A202070616464696E673A20';
wwv_flow_imp.g_varchar2_table(66) := '3136707820313070783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6865616465722D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D6865';
wwv_flow_imp.g_varchar2_table(67) := '616465722D626F74746F6D2D626F726465722D636F6C6F72293B0D0A202077696474683A20313030253B0D0A20207A2D696E6465783A2031303B0D0A20206D61782D6865696768743A20363470783B0D0A20206F766572666C6F773A2068696464656E3B';
wwv_flow_imp.g_varchar2_table(68) := '0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6865616465722D69636F6E207B0D0A202066696C6C3A20766172282D2D6865616465722D69636F6E2D66696C6C2D636F6C6F72293B0D0A2020646973706C61793A20666C65783B';
wwv_flow_imp.g_varchar2_table(69) := '0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A202077696474683A20333270783B0D0A202068656967';
wwv_flow_imp.g_varchar2_table(70) := '68743A20333270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6865616465722D6C6162656C73207B0D0A20206F766572666C6F773A2068696464656E3B0D0A20206D617267696E2D6C6566743A20313270783B0D0A2020';
wwv_flow_imp.g_varchar2_table(71) := '757365722D73656C6563743A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6865616465722D74797065207B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C65737429';
wwv_flow_imp.g_varchar2_table(72) := '3B0D0A2020666F6E742D7765696768743A203630303B0D0A202077686974652D73706163653A206E6F777261703B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A20206F766572666C6F773A2068696464656E3B0D0A202074';
wwv_flow_imp.g_varchar2_table(73) := '6578742D7472616E73666F726D3A207570706572636173653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6865616465722D6C6162656C207B0D0A202077686974652D73706163653A206E6F777261703B0D0A202074657874';
wwv_flow_imp.g_varchar2_table(74) := '2D6F766572666C6F773A20656C6C69707369733B0D0A20206F766572666C6F773A2068696464656E3B0D0A20206D617267696E2D746F703A202D3670783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6865616465722D6163';
wwv_flow_imp.g_varchar2_table(75) := '74696F6E73207B0D0A20206D617267696E2D6C6566743A206175746F3B0D0A20206D617267696E2D746F703A206175746F3B0D0A7D0D0A0D0A2F2A2A0D0A202A205363726F6C6C20636F6E7461696E65720D0A202A2F0D0A2E62696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(76) := '6965732D70616E656C2D7363726F6C6C2D636F6E7461696E6572207B0D0A20206F766572666C6F772D793A206175746F3B0D0A20206F766572666C6F772D783A2068696464656E3B0D0A2020666C65783A20313B0D0A7D0D0A0D0A2F2A2A0D0A202A2047';
wwv_flow_imp.g_varchar2_table(77) := '726F7570730D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F7570207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D67726F75702D6261636B67726F756E642D636F6C6F72293B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(78) := '6465722D626F74746F6D3A2031707820736F6C696420766172282D2D67726F75702D626F74746F6D2D626F726465722D636F6C6F72293B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A7D0D0A0D0A2E62696F2D70726F70657274696573';
wwv_flow_imp.g_varchar2_table(79) := '2D70616E656C2D67726F75702D686561646572207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A2020666F6E742D73697A65';
wwv_flow_imp.g_varchar2_table(80) := '3A20766172282D2D746578742D73697A652D62617365293B0D0A20206865696768743A20333270783B0D0A2020757365722D73656C6563743A206E6F6E653B0D0A20206A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B0D0A';
wwv_flow_imp.g_varchar2_table(81) := '20206D617267696E2D626F74746F6D3A202D3170783B202F2A2061766F696420646F75626C6520626F7264657273202A2F0D0A2020706F736974696F6E3A2072656C61746976653B20202F2A2062726F7773657273206E6F7420737570706F7274696E67';
wwv_flow_imp.g_varchar2_table(82) := '20737469636B79202A2F0D0A2020706F736974696F6E3A202D7765626B69742D737469636B793B20202F2A20666F7220736166617269202A2F0D0A2020706F736974696F6E3A20737469636B793B0D0A2020746F703A20303B0D0A20207A2D696E646578';
wwv_flow_imp.g_varchar2_table(83) := '3A2031303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D686561646572202E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D7469746C65207B0D0A202077686974652D73';
wwv_flow_imp.g_varchar2_table(84) := '706163653A206E6F777261703B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A20206D617267696E3A20317078203132707820303B0D0A7D0D0A0D0A2E62696F2D70726F';
wwv_flow_imp.g_varchar2_table(85) := '706572746965732D70616E656C2D67726F75702D6865616465722E6F70656E202E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D7469746C65207B0D0A2020666F6E742D7765696768743A203530303B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(86) := '0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722E737469636B79207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D737469636B792D67726F75702D6261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(87) := '6F72293B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C696420766172282D2D737469636B792D67726F75702D626F74746F6D2D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(88) := '6C2D67726F75702D6865616465722D627574746F6E73207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D627574746F6E73202E62696F2D70726F';
wwv_flow_imp.g_varchar2_table(89) := '706572746965732D70616E656C2D67726F75702D6865616465722D627574746F6E207B0D0A2020646973706C61793A20696E6C696E652D666C65783B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020616C69676E2D6974';
wwv_flow_imp.g_varchar2_table(90) := '656D733A2063656E7465723B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A20206865696768743A20323270783B0D0A20206C696E652D6865696768743A20323270783B0D0A20206D696E2D77696474683A20323270783B0D0A20206D61';
wwv_flow_imp.g_varchar2_table(91) := '7267696E3A203570783B0D0A202070616464696E673A2030203370783B0D0A2020626F726465723A206E6F6E653B0D0A20206261636B67726F756E643A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75';
wwv_flow_imp.g_varchar2_table(92) := '702D6865616465722D627574746F6E73202E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722D627574746F6E733A6C6173742D6368696C64207B0D0A20206D617267696E2D72696768743A20303B0D0A7D0D0A0D0A2E';
wwv_flow_imp.g_varchar2_table(93) := '62696F2D70726F706572746965732D70616E656C2D6164642D656E747279207B0D0A202066696C6C3A20766172282D2D6164642D656E7472792D66696C6C2D636F6C6F72293B0D0A2020626F726465722D7261646975733A20313170783B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(94) := '0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722E656D707479202E62696F2D70726F706572746965732D70616E656C2D6164642D656E747279207B0D0A20206D617267696E2D72696768743A20363970783B0D0A';
wwv_flow_imp.g_varchar2_table(95) := '7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722E656D707479202E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472793A686F766572207B0D0A20206D617267696E2D72696768';
wwv_flow_imp.g_varchar2_table(96) := '743A20313970783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D6865616465722E656D707479202E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472792D6C6162656C207B0D0A202064';
wwv_flow_imp.g_varchar2_table(97) := '6973706C61793A206E6F6E653B0D0A2020636F6C6F723A20766172282D2D6164642D656E7472792D6C6162656C2D636F6C6F72293B0D0A202070616464696E673A2030203670782030203270783B0D0A7D0D0A0D0A2E62696F2D70726F70657274696573';
wwv_flow_imp.g_varchar2_table(98) := '2D70616E656C2D67726F75702D6865616465722D627574746F6E2E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472793A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6164642D656E74';
wwv_flow_imp.g_varchar2_table(99) := '72792D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A202066696C6C3A20766172282D2D6164642D656E7472792D686F7665722D66696C6C2D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D';
wwv_flow_imp.g_varchar2_table(100) := '67726F75702D6865616465722D627574746F6E2E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472793A686F766572202E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472792D6C6162656C207B0D0A2020';
wwv_flow_imp.g_varchar2_table(101) := '646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D67726F75702D656E7472696573207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D';
wwv_flow_imp.g_varchar2_table(102) := '70616E656C2D67726F75702D656E74726965732E6F70656E207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6172726F77207B0D0A2020646973706C61793A20666C65783B0D';
wwv_flow_imp.g_varchar2_table(103) := '0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020746578742D616C69676E3A2063656E7465723B0D0A202066696C6C3A20766172282D2D6172726F772D66696C6C2D636F6C6F72293B0D0A20206D696E2D77696474683A2032';
wwv_flow_imp.g_varchar2_table(104) := '3270783B0D0A2020626F726465722D7261646975733A20313170783B0D0A2020626F726465723A206E6F6E653B0D0A20206261636B67726F756E643A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6172726F77';
wwv_flow_imp.g_varchar2_table(105) := '3A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6172726F772D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6172726F77';
wwv_flow_imp.g_varchar2_table(106) := '2D646F776E207B0D0A20207472616E73666F726D3A20726F74617465283930646567293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D646F74207B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A2020686569';
wwv_flow_imp.g_varchar2_table(107) := '6768743A203870783B0D0A20206D696E2D77696474683A203870783B0D0A2020626F726465722D7261646975733A203530253B0D0A20206D617267696E3A20313270783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D646F742D';
wwv_flow_imp.g_varchar2_table(108) := '636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D646F742D2D6572726F72207B0D0A20202D2D646F742D636F6C6F723A20766172282D2D646F742D636F6C6F722D6572726F72293B0D0A7D0D0A0D0A2F2A2A0D0A';
wwv_flow_imp.g_varchar2_table(109) := '202A204C697374730D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D6C697374207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742E6F70656E20';
wwv_flow_imp.g_varchar2_table(110) := '7B0D0A2020646973706C61793A20626C6F636B3B0D0A20206D617267696E2D626F74746F6D3A203670783B0D0A202070616464696E672D626F74746F6D3A203270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C697374';
wwv_flow_imp.g_varchar2_table(111) := '2D6261646765207B0D0A20206865696768743A20323270783B0D0A20206D696E2D77696474683A20323270783B0D0A2020636F6C6F723A20766172282D2D6C6973742D62616467652D636F6C6F72293B0D0A2020626F726465722D7261646975733A2031';
wwv_flow_imp.g_varchar2_table(112) := '3170783B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A20206C696E652D6865696768743A20323270783B0D0A2020746578742D616C69676E3A2063656E7465723B0D0A2020757365722D73656C65';
wwv_flow_imp.g_varchar2_table(113) := '63743A206E6F6E653B0D0A202070616464696E673A2030203570783B0D0A20206D617267696E3A203570783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6C6973742D62616467652D6261636B67726F756E642D636F6C6F7229';
wwv_flow_imp.g_varchar2_table(114) := '3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D62616467652D2D6572726F72207B0D0A20202D2D6C6973742D62616467652D6261636B67726F756E642D636F6C6F723A20766172282D2D646F742D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(115) := '6572726F72293B0D0A7D0D0A0D0A2F2A2A0D0A202A20426173696320656E74726965730D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D656E747279207B0D0A20206D617267696E3A203270782033327078203670782031327078';
wwv_flow_imp.g_varchar2_table(116) := '3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D656E7472793A6C6173742D6368696C64207B0D0A202070616464696E672D626F74746F6D3A20313070783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(117) := '6C2D6C6162656C207B0D0A2020646973706C61793A20626C6F636B3B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A20206D617267696E3A203270782030203170783B0D0A7D0D0A0D0A2E62696F2D';
wwv_flow_imp.g_varchar2_table(118) := '70726F706572746965732D70616E656C2D6465736372697074696F6E2C0D0A2E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E20702C0D0A2E62696F2D70726F706572746965732D70616E656C2D646573637269707469';
wwv_flow_imp.g_varchar2_table(119) := '6F6E207370616E2C0D0A2E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E20646976207B0D0A2020636F6C6F723A20766172282D2D6465736372697074696F6E2D636F6C6F72293B0D0A2020646973706C61793A20626C';
wwv_flow_imp.g_varchar2_table(120) := '6F636B3B0D0A20206D617267696E3A203270782030203470783B0D0A20206C696E652D6865696768743A20766172282D2D6C696E652D6865696768742D636F6E64656E736564293B0D0A2020666F6E742D7765696768743A203430303B0D0A2020666F6E';
wwv_flow_imp.g_varchar2_table(121) := '742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E20636F6465207B0D0A2020636F6C6F723A20766172282D2D6465736372';
wwv_flow_imp.g_varchar2_table(122) := '697074696F6E2D636F6C6F72293B0D0A2020666F6E742D66616D696C793A20766172282D2D666F6E742D66616D696C79293B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A20206C696E652D686569';
wwv_flow_imp.g_varchar2_table(123) := '6768743A20766172282D2D6C696E652D6865696768742D636F6E64656E736564293B0D0A202070616464696E673A2030203270783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6465736372697074696F6E2D636F64652D6261';
wwv_flow_imp.g_varchar2_table(124) := '636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A2031707820736F6C696420766172282D2D6465736372697074696F6E2D636F64652D626F726465722D636F6C6F72293B0D0A2020626F726465722D7261646975733A203370783B0D0A';
wwv_flow_imp.g_varchar2_table(125) := '7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E2070726520636F6465207B0D0A202077696474683A20313030253B0D0A2020646973706C61793A20626C6F636B3B0D0A20206F766572666C6F772D783A20';
wwv_flow_imp.g_varchar2_table(126) := '6175746F3B0D0A202070616464696E673A20347078203670783B0D0A2020666F6E742D66616D696C793A20766172282D2D666F6E742D66616D696C792D6D6F6E6F7370616365293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C';
wwv_flow_imp.g_varchar2_table(127) := '2D6465736372697074696F6E20756C207B0D0A202070616464696E673A20303B0D0A20206D617267696E3A20302030203020313270783B0D0A20206C6973742D7374796C652D747970653A20646973633B0D0A7D0D0A0D0A2E62696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(128) := '6965732D70616E656C2D6465736372697074696F6E206C69207B0D0A2020636F6C6F723A20766172282D2D6465736372697074696F6E2D6C6973742D6974656D2D636F6C6F72293B0D0A20206D617267696E3A20302030203020313270783B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(129) := '0D0A2E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E2061207B0D0A2020636F6C6F723A20766172282D2D6C696E6B2D636F6C6F72293B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D73';
wwv_flow_imp.g_varchar2_table(130) := '6D616C6C293B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722E62696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(131) := '6C2D696E707574207B0D0A202070616464696E673A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D696E707574202E636D2D656469746F720D0A7B0D0A20206D696E2D6865696768743A2033327078';
wwv_flow_imp.g_varchar2_table(132) := '3B0D0A20206D61782D6865696768743A2032313570783B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F72';
wwv_flow_imp.g_varchar2_table(133) := '202E636D2D656469746F722E636D2D666F63757365642C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D696E707574202E636D2D656469746F722E636D2D666F6375736564207B0D0A20206F75746C696E653A206E6F6E';
wwv_flow_imp.g_varchar2_table(134) := '653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A202070616464696E673A2033707820367078203270783B0D0A2020626F726465723A2031707820736F6C696420766172282D2D696E7075742D626F72';
wwv_flow_imp.g_varchar2_table(135) := '6465722D636F6C6F72293B0D0A2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D696E7075742D6261636B67726F756E642D636F6C6F72293B0D0A2020666F6E742D73697A653A';
wwv_flow_imp.g_varchar2_table(136) := '20766172282D2D746578742D73697A652D62617365293B0D0A2020666F6E742D66616D696C793A20696E68657269743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075745B747970653D6E756D6265725D2C0D0A7365';
wwv_flow_imp.g_varchar2_table(137) := '6C6563742E62696F2D70726F706572746965732D70616E656C2D696E7075742C0D0A74657874617265612E62696F2D70726F706572746965732D70616E656C2D696E7075742C0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075745B';
wwv_flow_imp.g_varchar2_table(138) := '747970653D746578745D207B0D0A2020646973706C61793A20626C6F636B3B0D0A202077696474683A20313030253B0D0A7D0D0A0D0A74657874617265612E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A20206D696E2D68';
wwv_flow_imp.g_varchar2_table(139) := '65696768743A20323870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075743A666F6375732C0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075743A666F6375732D77697468696E207B0D0A20';
wwv_flow_imp.g_varchar2_table(140) := '206F75746C696E653A206E6F6E653B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D696E7075742D666F6375732D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A2031707820736F6C696420766172282D';
wwv_flow_imp.g_varchar2_table(141) := '2D696E7075742D666F6375732D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746578746669656C643A666F6375732D77697468696E2C0D0A2E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(142) := '656C2D6665656C2D656E7472793A666F6375732D77697468696E207B0D0A20202D2D696E7075742D6261636B67726F756E642D636F6C6F723A20766172282D2D696E7075742D666F6375732D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(143) := '696E7075742D626F726465722D636F6C6F723A20766172282D2D696E7075742D666F6375732D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075743A64697361626C6564207B0D0A20';
wwv_flow_imp.g_varchar2_table(144) := '20626F726465722D636F6C6F723A20766172282D2D696E7075742D64697361626C65642D626F726465722D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D696E7075742D64697361626C65642D6261636B67726F';
wwv_flow_imp.g_varchar2_table(145) := '756E642D636F6C6F72293B0D0A2020636F6C6F723A20766172282D2D696E7075742D64697361626C65642D636F6C6F72293B0D0A7D0D0A0D0A73656C6563742E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A202070616464';
wwv_flow_imp.g_varchar2_table(146) := '696E673A20347078203670783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075742D6D6F6E6F7370616365207B0D0A2020666F6E742D66616D696C793A20766172282D2D666F6E742D66616D696C792D6D6F6E6F7370';
wwv_flow_imp.g_varchar2_table(147) := '616365293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075745B747970653D22636865636B626F78225D2C202E62696F2D70726F706572746965732D70616E656C2D696E7075745B747970653D22726164696F225D20';
wwv_flow_imp.g_varchar2_table(148) := '7B0D0A20206D617267696E3A20303B0D0A2020766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D696E7075745B747970653D22636865636B626F78225D3A666F63757320';
wwv_flow_imp.g_varchar2_table(149) := '7B0D0A20206F75746C696E653A2032707820736F6C696420766172282D2D696E7075742D666F6375732D626F726465722D636F6C6F72293B0D0A20206F75746C696E652D6F66667365743A20303B0D0A7D0D0A0D0A2E62696F2D70726F70657274696573';
wwv_flow_imp.g_varchar2_table(150) := '2D70616E656C2D636865636B626F78203E202E62696F2D70726F706572746965732D70616E656C2D6C6162656C207B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73';
wwv_flow_imp.g_varchar2_table(151) := '697A652D62617365293B0D0A20206D617267696E2D6C6566743A203670783B0D0A20206D617267696E2D746F703A206175746F3B0D0A2020766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(152) := '732D70616E656C2D636865636B626F782D656E747279202B202E62696F2D70726F706572746965732D70616E656C2D636865636B626F782D656E74727920207B0D0A20206D617267696E2D746F703A202D3870783B0D0A7D0D0A0D0A2E62696F2D70726F';
wwv_flow_imp.g_varchar2_table(153) := '706572746965732D70616E656C2D636865636B626F782D656E747279203E202E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E20207B0D0A20206D617267696E2D6C6566743A20313870783B0D0A7D0D0A0D0A74657874';
wwv_flow_imp.g_varchar2_table(154) := '617265612E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A2020726573697A653A20766572746963616C3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D656E7472792E6861732D6572726F72202E';
wwv_flow_imp.g_varchar2_table(155) := '62696F2D70726F706572746965732D70616E656C2D696E7075742C0D0A2E62696F2D70726F706572746965732D70616E656C2D656E7472792E6861732D6572726F72202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F72';
wwv_flow_imp.g_varchar2_table(156) := '5F5F6F70656E2D706F7075702D706C616365686F6C646572207B0D0A2020626F726465722D636F6C6F723A20766172282D2D696E7075742D6572726F722D626F726465722D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(157) := '72282D2D696E7075742D6572726F722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D656E7472792E6861732D6572726F72202E62696F2D70726F706572746965732D70616E656C';
wwv_flow_imp.g_varchar2_table(158) := '2D6665656C2D696E64696361746F72207B0D0A2020626F726465722D636F6C6F723A20766172282D2D696E7075742D6572726F722D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D656E7472';
wwv_flow_imp.g_varchar2_table(159) := '792E6861732D6572726F72202E62696F2D70726F706572746965732D70616E656C2D696E7075743A666F6375732C0D0A2E62696F2D70726F706572746965732D70616E656C2D656E7472792E6861732D6572726F72202E62696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(160) := '732D70616E656C2D6665656C2D696E64696361746F723A666F637573207B0D0A2020626F726465722D636F6C6F723A20766172282D2D696E7075742D6572726F722D666F6375732D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D7072';
wwv_flow_imp.g_varchar2_table(161) := '6F706572746965732D70616E656C2D656E747279202E62696F2D70726F706572746965732D70616E656C2D6572726F72207B0D0A2020636F6C6F723A20766172282D2D746578742D6572726F722D636F6C6F72293B0D0A20206D617267696E3A20347078';
wwv_flow_imp.g_varchar2_table(162) := '20303B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D73696D706C65207B0D0A202077696474683A20313030253B0D0A20206D61';
wwv_flow_imp.g_varchar2_table(163) := '7267696E2D72696768743A203870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D73696D706C65202B202E62696F2D70726F706572746965732D70616E656C2D72656D6F76652D656E747279207B0D0A20206D617267696E';
wwv_flow_imp.g_varchar2_table(164) := '3A206175746F3B0D0A7D0D0A0D0A2F2A2A0D0A202A20546F67676C65205377697463680D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682D656E747279202B202E62696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(165) := '732D70616E656C2D746F67676C652D7377697463682D656E74727920207B0D0A20206D617267696E2D746F703A202D3870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682D656E74727920';
wwv_flow_imp.g_varchar2_table(166) := '3E202E62696F2D70726F706572746965732D70616E656C2D6465736372697074696F6E207B0D0A20206D617267696E2D6C6566743A20333870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463';
wwv_flow_imp.g_varchar2_table(167) := '68202E62696F2D70726F706572746965732D70616E656C2D6669656C642D77726170706572207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A206365';
wwv_flow_imp.g_varchar2_table(168) := '6E7465723B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682E696E6C696E65207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A';
wwv_flow_imp.g_varchar2_table(169) := '7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682E696E6C696E65202E62696F2D70726F706572746965732D70616E656C2D6669656C642D77726170706572207B0D0A20206D617267696E2D6C656674';
wwv_flow_imp.g_varchar2_table(170) := '3A206175746F3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368203E202E62696F2D70726F706572746965732D70616E656C2D6C6162656C207B0D0A2020666F6E742D73697A653A2076617228';
wwv_flow_imp.g_varchar2_table(171) := '2D2D746578742D73697A652D62617365293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463682E696E6C696E65203E202E62696F2D70726F706572746965732D70616E656C2D6C6162656C207B0D';
wwv_flow_imp.g_varchar2_table(172) := '0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E65';
wwv_flow_imp.g_varchar2_table(173) := '6C2D746F67676C652D7377697463685F5F6C6162656C207B0D0A20206D617267696E3A20303B0D0A20206D617267696E2D6C6566743A203670783B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(174) := '0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F7377697463686572207B0D0A2020706F736974696F6E3A20';
wwv_flow_imp.g_varchar2_table(175) := '72656C61746976653B0D0A202077696474683A20333270783B0D0A20206865696768743A20313670783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F70657274696573';
wwv_flow_imp.g_varchar2_table(176) := '2D70616E656C2D746F67676C652D7377697463685F5F73776974636865723A666F6375732D77697468696E207B0D0A20206F75746C696E653A2032707820736F6C696420766172282D2D696E7075742D666F6375732D626F726465722D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(177) := '0D0A20206F75746C696E652D6F66667365743A203170783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D73776974';
wwv_flow_imp.g_varchar2_table(178) := '63685F5F737769746368657220696E7075745B747970653D27636865636B626F78275D207B0D0A20206F7061636974793A20303B0D0A202077696474683A20303B0D0A20206865696768743A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(179) := '732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F7377697463686572202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769';
wwv_flow_imp.g_varchar2_table(180) := '7463685F5F736C69646572207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020637572736F723A20706F696E7465723B0D0A2020746F703A20303B0D0A20206C6566743A20303B0D0A202072696768743A20303B0D0A2020626F7474';
wwv_flow_imp.g_varchar2_table(181) := '6F6D3A20303B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D746F67676C652D7377697463682D6F66662D6261636B67726F756E642D636F6C6F72293B0D0A20202D7765626B69742D7472616E736974696F6E3A20302E34733B0D';
wwv_flow_imp.g_varchar2_table(182) := '0A20207472616E736974696F6E3A20302E34733B0D0A2020626F726465722D7261646975733A20333470783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F7065727469';
wwv_flow_imp.g_varchar2_table(183) := '65732D70616E656C2D746F67676C652D7377697463685F5F7377697463686572202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F736C696465723A6265666F7265207B0D0A2020706F736974696F6E3A2061';
wwv_flow_imp.g_varchar2_table(184) := '62736F6C7574653B0D0A2020636F6E74656E743A2022223B0D0A20206865696768743A20313270783B0D0A202077696474683A20313270783B0D0A20206C6566743A203270783B0D0A2020626F74746F6D3A203270783B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(185) := '642D636F6C6F723A20766172282D2D746F67676C652D7377697463682D73776974636865722D6261636B67726F756E642D636F6C6F72293B0D0A20202D7765626B69742D7472616E736974696F6E3A20302E34733B0D0A20207472616E736974696F6E3A';
wwv_flow_imp.g_varchar2_table(186) := '20302E34733B0D0A2020626F726465722D7261646975733A203530253B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D746F67676C65';
wwv_flow_imp.g_varchar2_table(187) := '2D7377697463685F5F737769746368657220696E7075745B747970653D27636865636B626F78275D3A636865636B6564202B202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F736C69646572207B0D0A2020';
wwv_flow_imp.g_varchar2_table(188) := '6261636B67726F756E642D636F6C6F723A20766172282D2D746F67676C652D7377697463682D6F6E2D6261636B67726F756E642D636F6C6F72293B0D0A2020626F782D736861646F773A2030203020317078203B0D0A7D0D0A0D0A2E62696F2D70726F70';
wwv_flow_imp.g_varchar2_table(189) := '6572746965732D70616E656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F737769746368657220696E7075745B747970653D27636865636B626F78275D3A63686563';
wwv_flow_imp.g_varchar2_table(190) := '6B6564202B202E62696F2D70726F706572746965732D70616E656C2D746F67676C652D7377697463685F5F736C696465723A6265666F7265207B0D0A20202D7765626B69742D7472616E73666F726D3A207472616E736C617465582831367078293B0D0A';
wwv_flow_imp.g_varchar2_table(191) := '20202D6D732D7472616E73666F726D3A207472616E736C617465582831367078293B0D0A20207472616E73666F726D3A207472616E736C617465582831367078293B0D0A7D0D0A0D0A2F2A2A0D0A202A20436F6C6C61707369626C6520656E7472696573';
wwv_flow_imp.g_varchar2_table(192) := '0D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A2020646973706C61793A206E6F6E653B0D0A7D';
wwv_flow_imp.g_varchar2_table(193) := '0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573202E62696F2D70726F706572746965732D70616E656C2D656E7472793A6C6173742D6368696C64207B0D0A202070616464';
wwv_flow_imp.g_varchar2_table(194) := '696E672D626F74746F6D3A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E74726965732E6F70656E207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(195) := '0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E747269657320207B0D0A202070616464696E672D6C6566743A20323070783B0D0A20206D617267696E2D626F74746F6D3A20313070783B0D0A';
wwv_flow_imp.g_varchar2_table(196) := '2020706F736974696F6E3A2072656C61746976653B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D686561646572207B0D0A2020706F';
wwv_flow_imp.g_varchar2_table(197) := '736974696F6E3A2072656C61746976653B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206F76';
wwv_flow_imp.g_varchar2_table(198) := '6572666C6F773A2068696464656E3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D686561646572202E62696F2D70726F706572746965732D70616E656C2D636F6C6C6170736962';
wwv_flow_imp.g_varchar2_table(199) := '6C652D656E7472792D6865616465722D7469746C65207B0D0A202070616464696E673A2032707820323470782032707820333270783B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A20207768697465';
wwv_flow_imp.g_varchar2_table(200) := '2D73706163653A206E6F777261703B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A2020757365722D73656C6563743A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D7072';
wwv_flow_imp.g_varchar2_table(201) := '6F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D6172726F77207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A203270783B0D0A20206C6566743A203670783B0D0A202070616464696E';
wwv_flow_imp.g_varchar2_table(202) := '673A2030203370783B0D0A20206865696768743A20323270783B0D0A2020646973706C61793A20696E6C696E652D666C65783B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020616C69676E2D6974656D733A2063656E74';
wwv_flow_imp.g_varchar2_table(203) := '65723B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D72656D6F76652D656E747279207B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D697465';
wwv_flow_imp.g_varchar2_table(204) := '6D733A2063656E7465723B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A20206D617267696E2D72696768743A203570783B0D0A202070616464696E673A20303B0D0A202077696474683A20323270783B0D0A202068656967';
wwv_flow_imp.g_varchar2_table(205) := '68743A20323270783B0D0A202066696C6C3A20766172282D2D72656D6F76652D656E7472792D66696C6C2D636F6C6F72293B0D0A2020626F726465722D7261646975733A203530253B0D0A2020626F726465723A206E6F6E653B0D0A20206261636B6772';
wwv_flow_imp.g_varchar2_table(206) := '6F756E643A206E6F6E653B0D0A20207669736962696C6974793A2068696464656E3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D72656D6F76652D656E7472793A686F766572207B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(207) := '6C6F723A20766172282D2D72656D6F76652D656E7472792D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D3A686F766572202E';
wwv_flow_imp.g_varchar2_table(208) := '62696F2D70726F706572746965732D70616E656C2D72656D6F76652D6C6973742D656E7472792C0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472793A686F766572203E202E62696F2D70726F706572';
wwv_flow_imp.g_varchar2_table(209) := '746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D686561646572202E62696F2D70726F706572746965732D70616E656C2D72656D6F76652D656E7472792C0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61';
wwv_flow_imp.g_varchar2_table(210) := '707369626C652D656E7472793A666F6375732D77697468696E203E202E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D686561646572202E62696F2D70726F706572746965732D70616E656C2D72656D';
wwv_flow_imp.g_varchar2_table(211) := '6F76652D656E7472790D0A7B0D0A20207669736962696C6974793A2076697369626C653B0D0A7D0D0A0D0A2F2A2053696465206C696E65202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D';
wwv_flow_imp.g_varchar2_table(212) := '656E74726965733A3A6265666F7265207B0D0A2020636F6E74656E743A2022223B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20206C6566743A20313670783B0D0A202077696474683A203270783B0D0A2020746F703A202D3670783B';
wwv_flow_imp.g_varchar2_table(213) := '0D0A2020626F74746F6D3A20313270783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D736964652D6C696E652D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465722D7261646975733A203170783B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(214) := '0A0D0A2F2A2053696465206C696E6520657874656E73696F6E20666F72206E6F6E2D6C69737420656E747279206F72206F70656E206C69737420656E74727920706F736974696F6E656420617320746865206C617374206F6E652E202A2F0D0A2E62696F';
wwv_flow_imp.g_varchar2_table(215) := '2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573202E62696F2D70726F706572746965732D70616E656C2D656E7472793A6E6F74282E62696F2D70726F706572746965732D70616E656C2D6C69';
wwv_flow_imp.g_varchar2_table(216) := '73742D656E747279293A6C6173742D6368696C642C0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792E6F70656E3A6C6173742D6368696C64207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(217) := '0A0D0A2E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573202E62696F2D70726F706572746965732D70616E656C2D656E7472793A6E6F74282E62696F2D70726F706572746965732D70';
wwv_flow_imp.g_varchar2_table(218) := '616E656C2D6C6973742D656E747279293A6C6173742D6368696C643A3A61667465722C0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792E6F70656E3A6C6173742D6368696C643A3A6166746572207B0D0A2020636F';
wwv_flow_imp.g_varchar2_table(219) := '6E74656E743A2022223B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20206C6566743A202D313670783B0D0A202077696474683A203270783B0D0A2020746F703A20303B0D0A2020626F74746F6D3A202D3470783B0D0A20206261636B';
wwv_flow_imp.g_varchar2_table(220) := '67726F756E642D636F6C6F723A20766172282D2D736964652D6C696E652D657874656E73696F6E2D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465722D7261646975733A203170783B0D0A7D0D0A0D0A2E62696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(221) := '6965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573202E62696F2D70726F706572746965732D70616E656C2D656E7472';
wwv_flow_imp.g_varchar2_table(222) := '793A6C6173742D6368696C643A3A6166746572207B0D0A20206C6566743A202D313870783B0D0A7D0D0A0D0A2F2A0D0A202A204C69737420656E7472790D0A202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E747279';
wwv_flow_imp.g_varchar2_table(223) := '207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A20206D617267696E2D72696768743A203570783B0D0A20206D617267696E2D626F74746F6D3A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973';
wwv_flow_imp.g_varchar2_table(224) := '742D656E747279202E62696F2D70726F706572746965732D70616E656C2D656E747279207B0D0A20206D617267696E2D72696768743A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D686561';
wwv_flow_imp.g_varchar2_table(225) := '646572207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2073706163652D626574776565';
wwv_flow_imp.g_varchar2_table(226) := '6E3B0D0A20206865696768743A20333270783B0D0A7D0D0A0D0A2F2A204E6573746564206C69737420646F74202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472793A3A6265666F7265207B0D0A2020636F6E7465';
wwv_flow_imp.g_varchar2_table(227) := '6E743A2022223B0D0A202077696474683A203870783B0D0A20206865696768743A203870783B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20206C6566743A202D313970783B0D0A2020746F703A20313370783B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(228) := '722D7261646975733A203530253B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6C6973742D656E7472792D646F742D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D7061';
wwv_flow_imp.g_varchar2_table(229) := '6E656C2D6C6973742D656E7472792D6865616465722D7469746C65207B0D0A2020646973706C61793A20626C6F636B3B0D0A20206D617267696E3A206175746F20303B0D0A202070616464696E673A2032707820303B0D0A2020666F6E742D73697A653A';
wwv_flow_imp.g_varchar2_table(230) := '20766172282D2D746578742D73697A652D62617365293B0D0A202077686974652D73706163653A206E6F777261703B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(231) := '0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6865616465722D7469746C652E6F70656E207B0D0A2020666F6E742D7765696768743A203530303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70';
wwv_flow_imp.g_varchar2_table(232) := '616E656C2D6C6973742D656E7472792D6865616465722D627574746F6E73207B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(233) := '656C2D6C6973742D656E7472792D6865616465722D627574746F6E73203E20627574746F6E207B0D0A2020646973706C61793A20696E6C696E652D666C65783B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020616C6967';
wwv_flow_imp.g_varchar2_table(234) := '6E2D6974656D733A2063656E7465723B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A20206865696768743A20323270783B0D0A20206C696E652D6865696768743A20323270783B0D0A20206D696E2D77696474683A20323270783B0D0A';
wwv_flow_imp.g_varchar2_table(235) := '20206D617267696E3A203570783B0D0A202070616464696E673A2030203370783B0D0A2020626F726465723A206E6F6E653B0D0A20206261636B67726F756E643A206E6F6E653B0D0A202066696C6C3A20766172282D2D6C6973742D656E7472792D6865';
wwv_flow_imp.g_varchar2_table(236) := '616465722D627574746F6E2D66696C6C2D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6865616465722D627574746F6E73203E203A6C6173742D6368696C64207B0D0A20206D61';
wwv_flow_imp.g_varchar2_table(237) := '7267696E2D72696768743A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D73207B0D0A202070616464696E673A20303B0D0A20206D617267696E3A20303B0D0A0D0A20206C697374';
wwv_flow_imp.g_varchar2_table(238) := '2D7374796C653A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D733A6E6F74282E6F70656E29207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E62696F';
wwv_flow_imp.g_varchar2_table(239) := '2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D207B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B0D0A7D0D0A0D0A2E62696F2D';
wwv_flow_imp.g_varchar2_table(240) := '70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D72656D6F76652D656E747279207B0D0A20206D617267696E2D72696768743A203170783B0D0A7D0D0A0D0A2E62';
wwv_flow_imp.g_varchar2_table(241) := '696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E747279207B0D0A202077696474683A20313030253B0D0A20206D6172';
wwv_flow_imp.g_varchar2_table(242) := '67696E2D72696768743A203470783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D';
wwv_flow_imp.g_varchar2_table(243) := '686561646572207B0D0A20206D617267696E2D6C6566743A202D3870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D636F6C';
wwv_flow_imp.g_varchar2_table(244) := '6C61707369626C652D656E7472792D6172726F77207B0D0A20206C6566743A203270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(245) := '656C2D636F6C6C61707369626C652D656E7472792D6865616465722D7469746C65207B0D0A202070616464696E672D6C6566743A20333070783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974';
wwv_flow_imp.g_varchar2_table(246) := '656D202E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E7472696573207B0D0A202070616464696E672D6C6566743A20313070783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D7061';
wwv_flow_imp.g_varchar2_table(247) := '6E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D636F6C6C61707369626C652D656E7472792D656E74726965733A3A6265666F7265207B0D0A20206C6566743A203470783B0D0A7D0D0A0D0A2E62';
wwv_flow_imp.g_varchar2_table(248) := '696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792E656D707479202E62696F2D70726F706572746965732D70616E656C2D6164642D656E747279207B0D0A20206D617267696E2D72696768743A20313670783B0D0A2020706164';
wwv_flow_imp.g_varchar2_table(249) := '64696E672D6C6566743A203670783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792E656D707479202E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472792D6C6162656C207B';
wwv_flow_imp.g_varchar2_table(250) := '0D0A2020636F6C6F723A20766172282D2D6C6973742D656E7472792D6164642D656E7472792D6C6162656C2D636F6C6F72293B0D0A202070616464696E673A203470782036707820337078203270783B0D0A7D0D0A0D0A2E62696F2D70726F7065727469';
wwv_flow_imp.g_varchar2_table(251) := '65732D70616E656C2D6C6973742D656E7472792D6865616465722D627574746F6E73202E62696F2D70726F706572746965732D70616E656C2D6164642D656E7472793A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(252) := '2D2D6C6973742D656E7472792D6164642D656E7472792D6261636B67726F756E642D636F6C6F72293B0D0A202066696C6C3A20766172282D2D6C6973742D656E7472792D6164642D656E7472792D66696C6C2D636F6C6F72293B0D0A7D0D0A0D0A2E6269';
wwv_flow_imp.g_varchar2_table(253) := '6F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D202E62696F2D70726F706572746965732D70616E656C2D73696D706C65202E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(254) := '6465722D7261646975733A20303B0D0A20206D617267696E2D626F74746F6D3A202D3270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D3A66697273742D6368696C64202E62696F2D';
wwv_flow_imp.g_varchar2_table(255) := '70726F706572746965732D70616E656C2D73696D706C65202E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A2020626F726465722D746F702D6C6566742D7261646975733A203270783B0D0A2020626F726465722D746F702D';
wwv_flow_imp.g_varchar2_table(256) := '72696768742D7261646975733A203270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6C6973742D656E7472792D6974656D3A6C6173742D6368696C64202E62696F2D70726F706572746965732D70616E656C2D73696D70';
wwv_flow_imp.g_varchar2_table(257) := '6C65202E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A2020626F726465722D626F74746F6D2D6C6566742D7261646975733A203270783B0D0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A2032';
wwv_flow_imp.g_varchar2_table(258) := '70783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F6E207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A0D0A20202D2D64726F70646F776E2D627574746F6E2D6D617267';
wwv_flow_imp.g_varchar2_table(259) := '696E3A203570783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F6E3A6E6F74282E6F70656E29202E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F';
wwv_flow_imp.g_varchar2_table(260) := '6E5F5F6D656E75207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F6E5F5F6D656E75207B0D0A20206D696E2D77696474683A2063616C632831';
wwv_flow_imp.g_varchar2_table(261) := '303025202D20766172282D2D64726F70646F776E2D627574746F6E2D6D617267696E29202A2032293B0D0A20206D61782D77696474683A2032343070783B0D0A0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A2063616C63';
wwv_flow_imp.g_varchar2_table(262) := '2831303025202D20766172282D2D64726F70646F776E2D627574746F6E2D6D617267696E29293B0D0A202072696768743A20766172282D2D64726F70646F776E2D627574746F6E2D6D617267696E293B0D0A20207A2D696E6465783A203130313B0D0A0D';
wwv_flow_imp.g_varchar2_table(263) := '0A20206261636B67726F756E642D636F6C6F723A20766172282D2D64726F70646F776E2D6974656D2D6261636B67726F756E642D636F6C6F72293B0D0A0D0A202070616464696E673A2038707820303B0D0A0D0A2020626F782D736861646F773A203020';
wwv_flow_imp.g_varchar2_table(264) := '31707820347078203020766172282D2D636F6C6F722D677265792D3232352D31302D3835292C2030203270782031367078203020766172282D2D636F6C6F722D677265792D3232352D31302D3735290D0A7D0D0A0D0A2E62696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(265) := '732D70616E656C2D64726F70646F776E2D627574746F6E5F5F6D656E752D6974656D207B0D0A2020646973706C61793A20626C6F636B3B0D0A202077696474683A20313030253B0D0A202070616464696E673A2034707820313270783B0D0A0D0A202066';
wwv_flow_imp.g_varchar2_table(266) := '6F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A2020617070656172616E63653A207265766572743B0D0A2020626F726465723A20756E7365743B0D0A20206261636B67726F756E643A20756E7365743B0D0A2020';
wwv_flow_imp.g_varchar2_table(267) := '746578742D616C69676E3A20756E7365743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F6E5F5F6D656E752D6974656D2D2D736570617261746F72207B0D0A202077696474683A20313030';
wwv_flow_imp.g_varchar2_table(268) := '253B0D0A20206865696768743A203170783B0D0A0D0A202070616464696E673A20303B0D0A20206D617267696E3A2038707820303B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D64726F70646F776E2D736570617261746F';
wwv_flow_imp.g_varchar2_table(269) := '722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F6E5F5F6D656E752D6974656D2D2D616374696F6E61626C65207B0D0A2020666F6E742D7369';
wwv_flow_imp.g_varchar2_table(270) := '7A653A20766172282D2D746578742D73697A652D62617365293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D64726F70646F776E2D627574746F6E5F5F6D656E752D6974656D2D2D616374696F6E61626C653A686F76657220';
wwv_flow_imp.g_varchar2_table(271) := '7B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D64726F70646F776E2D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C';
wwv_flow_imp.g_varchar2_table(272) := '2D696E707574207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D696E70757420696E707574207B0D0A202070616464696E672D72696768743A2032656D';
wwv_flow_imp.g_varchar2_table(273) := '0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656E747279202E62696F2D70726F706572746965732D70616E656C2D6C6162656C207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E62696F2D70';
wwv_flow_imp.g_varchar2_table(274) := '726F706572746965732D70616E656C2D6665656C2D69636F6E207B0D0A2020646973706C61793A20696E6C696E652D666C65783B0D0A20206865696768743A20313870783B0D0A202077696474683A20323270783B0D0A2020766572746963616C2D616C';
wwv_flow_imp.g_varchar2_table(275) := '69676E3A20746578742D626F74746F6D3B0D0A202070616464696E673A20303B0D0A20206D617267696E3A2030203370783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A20';
wwv_flow_imp.g_varchar2_table(276) := '206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020626F726465723A206E6F6E653B0D0A20206261636B67726F756E643A206E6F6E653B0D0A2020626F726465722D7261646975733A203370783B0D0A7D0D0A0D0A2E62696F2D7072';
wwv_flow_imp.g_varchar2_table(277) := '6F706572746965732D70616E656C2D6665656C2D69636F6E2E6F7074696F6E616C207B0D0A2020637572736F723A20706F696E7465723B0D0A20206261636B67726F756E643A20766172282D2D6665656C2D6261636B67726F756E642D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(278) := '0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D69636F6E20737667202A207B0D0A202066696C6C3A20766172282D2D6665656C2D696E6163746976652D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F7065';
wwv_flow_imp.g_varchar2_table(279) := '72746965732D70616E656C2D6665656C2D69636F6E3A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D6665656C2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F7065727469';
wwv_flow_imp.g_varchar2_table(280) := '65732D70616E656C2D6665656C2D69636F6E3A686F76657220737667202A207B0D0A202066696C6C3A20766172282D2D6665656C2D686F7665722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D';
wwv_flow_imp.g_varchar2_table(281) := '69636F6E2E616374697665207B0D0A20206261636B67726F756E643A20766172282D2D6665656C2D6163746976652D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D69';
wwv_flow_imp.g_varchar2_table(282) := '636F6E2E6163746976653A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D6665656C2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665';
wwv_flow_imp.g_varchar2_table(283) := '656C2D69636F6E2E72657175697265642E616374697665207B0D0A20206261636B67726F756E643A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D69636F6E2E61637469766520737667202A207B0D';
wwv_flow_imp.g_varchar2_table(284) := '0A202066696C6C3A20766172282D2D6665656C2D6163746976652D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D69636F6E2E72657175697265642E61637469766520737667202A207B0D0A2020';
wwv_flow_imp.g_varchar2_table(285) := '66696C6C3A20766172282D2D6665656C2D72657175697265642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572207B0D0A2020706F736974696F6E3A2072';
wwv_flow_imp.g_varchar2_table(286) := '656C61746976653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E65722E616374697665207B0D0A2020666F6E742D66616D696C793A20766172282D2D666F6E742D66616D696C';
wwv_flow_imp.g_varchar2_table(287) := '792D6D6F6E6F7370616365293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E6572207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A7D0D0A0D0A2E62696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(288) := '6965732D70616E656C2D6665656C2D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E65723E646976207B0D0A2020706F736974696F6E3A207374617469633B0D0A202070';
wwv_flow_imp.g_varchar2_table(289) := '616464696E672D6C6566743A20322E34656D2021696D706F7274616E743B0D0A20206D696E2D6865696768743A20323870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D696E64696361746F72207B0D0A2020';
wwv_flow_imp.g_varchar2_table(290) := '706F736974696F6E3A206162736F6C7574653B0D0A2020626F726465723A2031707820736F6C696420766172282D2D696E7075742D626F726465722D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6665656C2D';
wwv_flow_imp.g_varchar2_table(291) := '696E64696361746F722D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465722D72696768743A203070783B0D0A2020626F726465722D7261646975733A2032707820302030203270783B0D0A20207A2D696E6465783A20313B0D0A2020';
wwv_flow_imp.g_varchar2_table(292) := '6865696768743A20313030253B0D0A202077696474683A2032656D3B0D0A2020746578742D616C69676E3A2063656E7465723B0D0A202070616464696E673A20327078203670783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C';
wwv_flow_imp.g_varchar2_table(293) := '2D6665656C2D656469746F722D636F6E7461696E6572202E636D2D7363726F6C6C6572207B0D0A20206F766572666C6F773A2068696464656E2021696D706F7274616E743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665';
wwv_flow_imp.g_varchar2_table(294) := '656C6572732D656469746F72202E636D2D656469746F72207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D0A0D0A0D0A2F2A20404E6F74652870696E757373696C76657374727573293A206D69746967';
wwv_flow_imp.g_varchar2_table(295) := '617465206C6F7720636F6E7472617374202D2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F636D2D7468656D652F6973737565732F34202A2F0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D6564';
wwv_flow_imp.g_varchar2_table(296) := '69746F72202E636D2D636F6E74656E74203A3A73656C656374696F6E207B0D0A20206261636B67726F756E643A20766172282D2D6665656C6572732D73656C6563742D636F6C6F722C2068736C283230352C20313030252C2038352529293B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(297) := '0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F72202E636D2D656469746F722E636D2D666F6375736564207B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(298) := '0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A2020726573697A653A206E6F6E653B0D0A20206F7665';
wwv_flow_imp.g_varchar2_table(299) := '72666C6F773A2068696464656E3B0D0A20206F766572666C6F772D793A206175746F3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E65722C0D0A2E62696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(300) := '6965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D696E7075742C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E6572202E';
wwv_flow_imp.g_varchar2_table(301) := '636D2D656469746F72207B0D0A20206D696E2D6865696768743A20313030253B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636865636B626F782C0D0A2E62696F2D70726F706572746965732D70616E656C2D66';
wwv_flow_imp.g_varchar2_table(302) := '65656C2D746F67676C652D737769746368207B0D0A202070616464696E672D746F703A203170783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636865636B626F78202E62696F2D70726F706572746965732D70';
wwv_flow_imp.g_varchar2_table(303) := '616E656C2D6665656C2D656E7472793A6E6F74282E6665656C2D616374697665292C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D66';
wwv_flow_imp.g_varchar2_table(304) := '65656C2D656E7472793A6E6F74282E6665656C2D61637469766529207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(305) := '0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636865636B626F78202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656E7472793A6E6F74282E6665656C2D61637469766529202E62696F2D70726F706572';
wwv_flow_imp.g_varchar2_table(306) := '746965732D70616E656C2D6665656C2D636F6E7461696E65722C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D746F67676C652D737769746368202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656E7472';
wwv_flow_imp.g_varchar2_table(307) := '793A6E6F74282E6665656C2D61637469766529202E62696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E6572207B0D0A20206D617267696E2D6C6566743A206175746F3B0D0A7D0D0A0D0A2E62696F2D70726F7065727469';
wwv_flow_imp.g_varchar2_table(308) := '65732D70616E656C2D746F6F6C7469702D77726170706572207B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A2020746578742D6465636F726174696F6E2D7374796C653A20646F747465643B0D0A2020746578742D';
wwv_flow_imp.g_varchar2_table(309) := '756E6465726C696E652D6F66667365743A203270783B0D0A2020666F6E743A20696E68657269743B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A202077696474683A20666974';
wwv_flow_imp.g_varchar2_table(310) := '2D636F6E74656E743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C746970207B0D0A20202D2D746F6F6C7469702D756E6465726C696E652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3231392D39';
wwv_flow_imp.g_varchar2_table(311) := '392D3533293B0D0A20202D2D746F6F6C7469702D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D302D302D3232293B0D0A20202D2D746F6F6C7469702D6C696E6B3A20766172282D2D636F6C6F722D626C75652D';
wwv_flow_imp.g_varchar2_table(312) := '3231382D3130302D3734293B0D0A20202D2D746F6F6C7469702D636F64652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D746F6F6C7469702D636F64652D626F7264';
wwv_flow_imp.g_varchar2_table(313) := '65722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3835293B0D0A0D0A2020646973706C61793A20666C65783B0D0A2020636F6C6F723A20766172282D2D636F6C6F722D77686974652C207768697465293B0D0A202070';
wwv_flow_imp.g_varchar2_table(314) := '6F736974696F6E3A2066697865643B0D0A20207A2D696E6465783A20313030303B0D0A20206D61782D77696474683A2033303070783B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A2020666F6E74';
wwv_flow_imp.g_varchar2_table(315) := '2D66616D696C793A20766172282D2D666F6E742D66616D696C79293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702E7269676874207B0D0A202070616464696E672D72696768743A203670783B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(316) := '0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702E746F70207B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C746970';
wwv_flow_imp.g_varchar2_table(317) := '2D636F6E74656E74207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D746F6F6C7469702D6261636B67726F756E642D636F6C6F72293B0D0A202070616464696E673A20313670783B0D0A2020626F726465722D7261646975733A';
wwv_flow_imp.g_varchar2_table(318) := '203270783B0D0A2020666F6E742D7765696768743A203430303B0D0A202077686974652D73706163653A207072652D777261703B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702D636F6E74656E7420683120';
wwv_flow_imp.g_varchar2_table(319) := '7B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D62617365293B0D0A2020666F6E742D7765696768743A20626F6C643B0D0A20206D617267696E3A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(320) := '656C2D746F6F6C7469702D636F6E74656E7420636F64652C0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702D636F6E74656E7420707265207B0D0A2020636F6C6F723A20766172282D2D6465736372697074696F6E2D636F';
wwv_flow_imp.g_varchar2_table(321) := '6C6F72293B0D0A2020666F6E742D66616D696C793A20766172282D2D666F6E742D66616D696C79293B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73697A652D736D616C6C293B0D0A20206C696E652D6865696768743A2076617228';
wwv_flow_imp.g_varchar2_table(322) := '2D2D6C696E652D6865696768742D636F6E64656E736564293B0D0A202070616464696E673A2030203270783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D746F6F6C7469702D636F64652D6261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(323) := '72293B0D0A2020626F726465723A2031707820736F6C696420766172282D2D746F6F6C7469702D636F64652D626F726465722D636F6C6F72293B0D0A2020626F726465722D7261646975733A203370783B0D0A7D0D0A0D0A2E62696F2D70726F70657274';
wwv_flow_imp.g_varchar2_table(324) := '6965732D70616E656C2D746F6F6C7469702D636F6E74656E742070726520636F6465207B0D0A2020626F726465723A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C74697020703A66697273742D6368';
wwv_flow_imp.g_varchar2_table(325) := '696C64207B0D0A20206D617267696E2D746F703A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C74697020703A6C6173742D6368696C64207B0D0A20206D617267696E2D626F74746F6D3A20303B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(326) := '0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702D636F6E74656E742061207B0D0A2020636F6C6F723A20766172282D2D746F6F6C7469702D6C696E6B293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E';
wwv_flow_imp.g_varchar2_table(327) := '656C2D746F6F6C746970202E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702D6172726F77207B0D0A202077696474683A20303B200D0A20206865696768743A20303B200D0A2020626F726465722D746F703A2035707820736F6C';
wwv_flow_imp.g_varchar2_table(328) := '6964207472616E73706172656E743B0D0A2020626F726465722D626F74746F6D3A2035707820736F6C6964207472616E73706172656E743B0D0A2020626F726465722D6C6566743A2035707820736F6C696420766172282D2D746F6F6C7469702D626163';
wwv_flow_imp.g_varchar2_table(329) := '6B67726F756E642D636F6C6F72293B0D0A20206D617267696E2D746F703A20313670783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D746F6F6C7469702E746F70202E62696F2D70726F706572746965732D70616E656C2D74';
wwv_flow_imp.g_varchar2_table(330) := '6F6F6C7469702D6172726F77207B0D0A20206D617267696E2D746F703A202D3370783B0D0A20206D617267696E2D6C6566743A2063616C6328353025202D20322E357078293B0D0A20207472616E73666F726D3A20726F74617465283930646567293B0D';
wwv_flow_imp.g_varchar2_table(331) := '0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F725F5F6F70656E2D706F7075';
wwv_flow_imp.g_varchar2_table(332) := '702D706C616365686F6C6465722C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F725F5F6F70656E2D';
wwv_flow_imp.g_varchar2_table(333) := '706F7075702D706C616365686F6C646572207B0D0A2020646973706C61793A206E6F6E653B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A2020636F6C6F';
wwv_flow_imp.g_varchar2_table(334) := '723A2068736C6128302C2030252C2039252C20302E3235293B0D0A202070616464696E673A2033707820367078203270783B0D0A2020626F726465723A2031707820736F6C696420766172282D2D696E7075742D626F726465722D636F6C6F72293B0D0A';
wwv_flow_imp.g_varchar2_table(335) := '2020626F726465722D7261646975733A203270783B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D696E7075742D6261636B67726F756E642D636F6C6F72293B0D0A2020666F6E742D73697A653A20766172282D2D746578742D73';
wwv_flow_imp.g_varchar2_table(336) := '697A652D62617365293B0D0A2020666F6E742D66616D696C793A20696E68657269743B0D0A202077696474683A20313030253B0D0A20206D696E2D6865696768743A20313030253B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C';
wwv_flow_imp.g_varchar2_table(337) := '2D6665656C6572732D656469746F722D636F6E7461696E65722E706F7075704F70656E202E62696F2D70726F706572746965732D70616E656C2D696E7075742C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D';
wwv_flow_imp.g_varchar2_table(338) := '636F6E7461696E65722E706F7075704F70656E202E62696F2D70726F706572746965732D70616E656C2D696E707574207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C';
wwv_flow_imp.g_varchar2_table(339) := '6572732D656469746F722D636F6E7461696E65722E706F7075704F70656E202E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F725F5F6F70656E2D706F7075702D706C616365686F6C6465722C0D0A2E62696F2D70';
wwv_flow_imp.g_varchar2_table(340) := '726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E65722E706F7075704F70656E202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F725F5F6F70656E2D706F7075702D706C61636568';
wwv_flow_imp.g_varchar2_table(341) := '6F6C646572207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570207B0D0A20202D2D706F7075702D6261636B67726F756E642D636F6C6F723A2068736C6128302C2030';
wwv_flow_imp.g_varchar2_table(342) := '252C203936252C2031293B0D0A20202D2D706F7075702D6865616465722D6261636B67726F756E642D636F6C6F723A2077686974653B0D0A20202D2D706F7075702D666F6E742D636F6C6F723A2068736C6128302C2030252C2030252C2031293B0D0A20';
wwv_flow_imp.g_varchar2_table(343) := '202D2D706F7075702D7469746C652D636F6C6F723A2068736C6128302C2030252C2030252C2031293B0D0A0D0A20202D2D6665656C2D706F7075702D636C6F73652D6261636B67726F756E642D636F6C6F723A2068736C61283231392C203939252C2035';
wwv_flow_imp.g_varchar2_table(344) := '33252C2031293B0D0A20202D2D6665656C2D706F7075702D677574746572732D6261636B67726F756E642D636F6C6F723A2068736C6128302C2030252C203930252C2031293B0D0A0D0A2020706F736974696F6E3A2066697865643B0D0A202064697370';
wwv_flow_imp.g_varchar2_table(345) := '6C61793A20666C65783B0D0A2020666C65783A206175746F3B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A2020666F6E742D66616D696C793A2049424D20506C65782053616E732C2073616E732D73657269663B0D0A202070';
wwv_flow_imp.g_varchar2_table(346) := '616464696E673A20303B0D0A20207A2D696E6465783A20313030313B0D0A2020626F782D736861646F773A203070782032707820367078203070782068736C6128302C2030252C2030252C20302E33293B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(347) := '723A20766172282D2D706F7075702D6261636B67726F756E642D636F6C6F72293B0D0A2020636F6C6F723A20766172282D2D706F7075702D666F6E742D636F6C6F72293B0D0A20206865696768743A206175746F3B0D0A202077696474683A206175746F';
wwv_flow_imp.g_varchar2_table(348) := '3B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020666F6E742D73697A653A20313470783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F7075702068312C200D0A2E62696F2D70726F706572746965732D70';
wwv_flow_imp.g_varchar2_table(349) := '616E656C2D706F7075702068322C200D0A2E62696F2D70726F706572746965732D70616E656C2D706F7075702068332C200D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570206834207B0D0A2020666F6E742D7765696768743A20';
wwv_flow_imp.g_varchar2_table(350) := '3530303B0D0A2020666F6E742D73697A653A20696E68657269743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F6865616465722C0D0A';
wwv_flow_imp.g_varchar2_table(351) := '2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F626F64792C0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F';
wwv_flow_imp.g_varchar2_table(352) := '706572746965732D70616E656C2D706F7075705F5F666F6F746572207B0D0A202070616464696E673A20313270783B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A2020616C69';
wwv_flow_imp.g_varchar2_table(353) := '676E2D6974656D733A2063656E7465723B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F626F64793A6E6F74283A66697273742D636869';
wwv_flow_imp.g_varchar2_table(354) := '6C6429207B0D0A202070616464696E672D746F703A20303B0D0A202070616464696E672D6C6566743A20303B0D0A202070616464696E672D72696768743A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F70757020';
wwv_flow_imp.g_varchar2_table(355) := '2E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F686561646572207B0D0A20202D2D706F7075702D6865616465722D6C696E652D6865696768743A20313670783B0D0A20206261636B67726F756E642D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(356) := '2D2D706F7075702D6865616465722D6261636B67726F756E642D636F6C6F72293B0D0A20206D617267696E3A20303B0D0A2020666F6E742D73697A653A20313270783B0D0A2020666F6E742D7765696768743A203430303B0D0A20206C696E652D686569';
wwv_flow_imp.g_varchar2_table(357) := '6768743A20766172282D2D706F7075702D6865616465722D6C696E652D686569676874293B0D0A2020746578742D616C69676E3A206C6566743B0D0A2020636F6C6F723A20766172282D2D706F7075702D7469746C652D636F6C6F72293B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(358) := '0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F6865616465722E647261676761626C65207B0D0A2020637572736F723A20677261623B0D0A7D0D0A0D0A';
wwv_flow_imp.g_varchar2_table(359) := '2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F647261672D68616E646C65207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E62696F2D';
wwv_flow_imp.g_varchar2_table(360) := '70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F647261672D70726576696577207B0D0A202077696474683A203170783B0D0A20206865696768743A203170783B0D0A20';
wwv_flow_imp.g_varchar2_table(361) := '20706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F7469746C65';
wwv_flow_imp.g_varchar2_table(362) := '207B0D0A20206D617267696E2D6C6566743A203870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F7469746C653A3A66697273742D';
wwv_flow_imp.g_varchar2_table(363) := '6C6574746572207B0D0A2020746578742D7472616E73666F726D3A206361706974616C697A653B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075';
wwv_flow_imp.g_varchar2_table(364) := '705F5F636C6F7365207B0D0A20206D617267696E3A202D313270783B0D0A20206D617267696E2D6C6566743A20313270783B0D0A202077696474683A20343070783B0D0A20206865696768743A20343070783B0D0A2020626F726465723A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(365) := '0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706F7075702D6865616465722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70';
wwv_flow_imp.g_varchar2_table(366) := '726F706572746965732D70616E656C2D706F7075705F5F636C6F73653A686F7665722C0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F636C6F73653A';
wwv_flow_imp.g_varchar2_table(367) := '666F6375732D76697369626C65207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706F7075702D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F7075';
wwv_flow_imp.g_varchar2_table(368) := '70202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F636C6F73653A666F6375732D76697369626C65207B0D0A20206F75746C696E652D6F66667365743A202D3270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D';
wwv_flow_imp.g_varchar2_table(369) := '70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F636C6F736520737667207B0D0A202077696474683A20313670783B0D0A20206865696768743A20313670783B0D0A202066696C6C3A206375727265';
wwv_flow_imp.g_varchar2_table(370) := '6E74436F6C6F723B0D0A20206D617267696E2D746F703A203270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F686561646572202E';
wwv_flow_imp.g_varchar2_table(371) := '62696F2D70726F706572746965732D70616E656C2D706F7075705F5F647261672D68616E646C6520737667207B0D0A20206D617267696E2D6C6566743A202D3470783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F7075';
wwv_flow_imp.g_varchar2_table(372) := '70202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F626F6479207B0D0A2020666F6E742D73697A653A20696E68657269743B0D0A20206865696768743A20313030253B0D0A2020646973706C61793A20666C65783B0D0A20206F';
wwv_flow_imp.g_varchar2_table(373) := '766572666C6F773A206175746F3B0D0A202070616464696E672D626F74746F6D3A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F';
wwv_flow_imp.g_varchar2_table(374) := '666F6F746572207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020626F74746F6D3A20303B0D0A202072696768743A203870783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F70757020';
wwv_flow_imp.g_varchar2_table(375) := '7B0D0A20206D696E2D6865696768743A2034303070783B0D0A202077696474683A206669742D636F6E74656E743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965';
wwv_flow_imp.g_varchar2_table(376) := '732D70616E656C2D6665656C2D706F7075705F5F626F6479207B0D0A2020646973706C61793A20666C65783B0D0A20206D617267696E3A20303B0D0A202070616464696E673A20303B0D0A20206865696768743A20313030253B0D0A202077696474683A';
wwv_flow_imp.g_varchar2_table(377) := '20313030253B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F7075705F5F7469746C652D6C696E6B207B0D0A20206D617267696E2D6C6566743A206175746F3B200D0A2020646973706C61793A20666C65783B';
wwv_flow_imp.g_varchar2_table(378) := '0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F7075705F5F7469746C652D6C696E6B20737667207B0D0A202077696474683A20766172282D2D706F7075702D6865616465722D6C696E652D686569676874293B';
wwv_flow_imp.g_varchar2_table(379) := '0D0A20206865696768743A20766172282D2D706F7075702D6865616465722D6C696E652D686569676874293B0D0A202066696C6C3A2063757272656E74436F6C6F723B0D0A20206D617267696E3A203020302E35656D3B0D0A7D0D0A0D0A2E62696F2D70';
wwv_flow_imp.g_varchar2_table(380) := '726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572207B0D0A2020646973706C61793A20666C65783B0D0A20206D696E2D7769';
wwv_flow_imp.g_varchar2_table(381) := '6474683A20313030253B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572202E636D2D7363';
wwv_flow_imp.g_varchar2_table(382) := '726F6C6C6572207B0D0A20206F766572666C6F773A206175746F2021696D706F7274616E743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D';
wwv_flow_imp.g_varchar2_table(383) := '6665656C6572732D656469746F722D636F6E7461696E6572207B0D0A202077696474683A20313030253B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F70757020';
wwv_flow_imp.g_varchar2_table(384) := '2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F72207B0D0A2020646973706C61793A20666C';
wwv_flow_imp.g_varchar2_table(385) := '65783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E6572202E62696F2D70726F7065';
wwv_flow_imp.g_varchar2_table(386) := '72746965732D70616E656C2D6665656C6572732D656469746F72202E636D2D656469746F72207B0D0A202077696474683A20313030253B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D';
wwv_flow_imp.g_varchar2_table(387) := '70726F706572746965732D70616E656C2D696E707574207B0D0A202077696474683A20313030253B0D0A2020726573697A653A206E6F6E653B0D0A202070616464696E673A20303B0D0A20206F766572666C6F773A2068696464656E3B0D0A20206F7665';
wwv_flow_imp.g_varchar2_table(388) := '72666C6F772D793A206175746F0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F707570207B0D0A202064697370';
wwv_flow_imp.g_varchar2_table(389) := '6C61793A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6F7065';
wwv_flow_imp.g_varchar2_table(390) := '6E2D6665656C2D706F7075702C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F707570207B0D0A2020706F736974';
wwv_flow_imp.g_varchar2_table(391) := '696F6E3A206162736F6C7574653B0D0A2020746F703A20303B0D0A202072696768743A20303B0D0A20206C696E652D6865696768743A20313B0D0A202070616464696E673A20327078203470783B0D0A20206D617267696E3A203370783B0D0A20206469';
wwv_flow_imp.g_varchar2_table(392) := '73706C61793A206E6F6E653B0D0A20206261636B67726F756E643A206E6F6E653B0D0A2020626F726465723A206E6F6E653B0D0A2020636F6C6F723A20766172282D2D6665656C2D6F70656E2D706F7075702D636F6C6F72293B0D0A2020637572736F72';
wwv_flow_imp.g_varchar2_table(393) := '3A20706F696E7465723B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E65723A686F766572202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D666565';
wwv_flow_imp.g_varchar2_table(394) := '6C2D706F7075702C0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E65723A686F766572202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F7075702C0D0A2E62696F2D7072';
wwv_flow_imp.g_varchar2_table(395) := '6F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E65723A666F6375732D77697468696E202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F7075702C0D0A2E62696F2D7072';
wwv_flow_imp.g_varchar2_table(396) := '6F706572746965732D70616E656C2D6665656C2D636F6E7461696E65723A666F6375732D77697468696E202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F707570207B0D0A2020646973706C61793A20626C6F636B';
wwv_flow_imp.g_varchar2_table(397) := '3B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C6572732D656469746F722D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F7075703A686F7665722C0D';
wwv_flow_imp.g_varchar2_table(398) := '0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D636F6E7461696E6572202E62696F2D70726F706572746965732D70616E656C2D6F70656E2D6665656C2D706F7075703A686F766572207B0D0A2020636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(399) := '6665656C2D6F70656E2D706F7075702D686F7665722D636F6C6F72293B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D706F7075705F5F666F';
wwv_flow_imp.g_varchar2_table(400) := '6F746572202E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F7075705F5F636C6F73652D62746E207B0D0A20206261636B67726F756E643A20766172282D2D6665656C2D706F7075702D636C6F73652D6261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(401) := '636F6C6F72293B0D0A202077696474683A20363670783B0D0A2020666F6E742D7765696768743A203430303B0D0A2020666F6E742D73697A653A20313470783B0D0A2020666F6E742D66616D696C793A20696E68657269743B0D0A2020636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(402) := '77686974653B0D0A2020626F726465723A206E6F6E653B0D0A20206865696768743A20333270783B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F70757020';
wwv_flow_imp.g_varchar2_table(403) := '2E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572202E636D2D656469746F72207B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A7D0D0A0D0A2E62696F';
wwv_flow_imp.g_varchar2_table(404) := '2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E62696F2D70726F706572746965732D70616E656C2D6665656C2D656469746F722D636F6E7461696E6572202E636D2D656469746F72202E636D2D636F6E74656E74207B0D0A20';
wwv_flow_imp.g_varchar2_table(405) := '2070616464696E672D6C6566743A203470783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E636D2D67757474657273207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(406) := '6665656C2D706F7075702D677574746572732D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A206E6F6E653B0D0A202070616464696E673A20303B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665';
wwv_flow_imp.g_varchar2_table(407) := '656C2D706F707570202E636D2D677574746572207B0D0A20206D696E2D77696474683A20333270783B0D0A7D0D0A0D0A2E62696F2D70726F706572746965732D70616E656C2D6665656C2D706F707570202E636D2D67757474657273202E636D2D6C696E';
wwv_flow_imp.g_varchar2_table(408) := '654E756D62657273202E636D2D677574746572456C656D656E74207B0D0A2020746578742D616C69676E3A2063656E7465723B0D0A7D0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5455341942539080)
,p_plugin_id=>wwv_flow_imp.id(116648167005824213)
,p_file_name=>'css/properties-panel.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_manage_step_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(151286992364012459)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.MANAGE_STEP.PROCESS'
,p_display_name=>'Flows for APEX - Manage Flow Instance Step'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.MANAGE_STEP.PROCESS'),'')
,p_api_version=>2
,p_execution_function=>'flow_plugin_manage_instance_step.execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151287222331012470)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Flow Instance info'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'item'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When a <i>Flows for APEX</i> task is completed, the application needs to send a <i> flow_step_complete </i> call to move the Flow Instance onto its next task / next step.  The call needs to provide the current context to the engine, so that the fl'
||'ow engine knows which task you were completing.  The context is made up of the process_id and subflow_id of the current task.</p>',
'',
'<p>Typically a <i>Flows for APEX </i> userTask (a page in APEX) will download its context when the page loads.  This download is defined in the Flow Modeller, using the Flow Modeller Properties Panel -- once you have created your userTask on your dia'
||'gram, click on the APEX tab in the Properties Panel, define the Page Items to set, and set them to the Process ID and Subflow ID.  </p>',
'',
'<p>For example, one way to do this is to define Application Level items in your application named PROCESS_ID and SUBFLOW_ID.  Then in the Flow Modeller Properties Panel for your userTask, specify that the page call sets variables PROCESS_ID, SUBFLOW_'
||'ID with values of &F4A$process_id.,&F4A$subflow_id.</p>',
'',
'<p>Alternatively, you could retrieve the Flow context (process_id and subflow_id) by retrieving these in a SQL Query.</p>',
'',
'<p>Specify which method you will use to supply the Flow Instance context (process_id and subflow_id)?</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(151287667400012470)
,p_plugin_attribute_id=>wwv_flow_imp.id(151287222331012470)
,p_display_sequence=>10
,p_display_value=>'In Page Items'
,p_return_value=>'item'
,p_help_text=>'Use this when the Flow Instance context (process_id and subflow_id) are stored in APEX Page Items.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(151288176006012472)
,p_plugin_attribute_id=>wwv_flow_imp.id(151287222331012470)
,p_display_sequence=>20
,p_display_value=>'from SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this when the Flow Instance context (process_id and subflow_id) are to be returned by a SQL Query.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151288593063012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Process ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151287222331012470)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance process_id.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named PROCESS_ID.</li>',
'<li>A Global Page Item, for example P0_PROCESS_ID.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151289068503012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Subflow ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151287222331012470)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance subflow_id.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named SUBFLOW_ID.</li>',
'<li>A Global Page Item, for example P0_SUBFLOW_ID.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151289433100012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151287222331012470)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>SQL Query which returns one row with two or three columns:</p>',
'<ul>',
'<li>First column needs to contain the Instance Id (prcs_id)</li>',
'<li>Second column needs to contain the Subflow Id (sbfl_id)</li>',
'<li>Third column can contain the Step Key (step_key)</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151293410221019612)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Action'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'complete'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Allows you to define the action you want to apply to the Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(151293761015022797)
,p_plugin_attribute_id=>wwv_flow_imp.id(151293410221019612)
,p_display_sequence=>10
,p_display_value=>'Complete Step'
,p_return_value=>'complete'
,p_help_text=>'This option is used to complete a Flow Instance Step.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(151294108771025073)
,p_plugin_attribute_id=>wwv_flow_imp.id(151293410221019612)
,p_display_sequence=>20
,p_display_value=>'Reserve Step'
,p_return_value=>'reserve'
,p_help_text=>'This option is used to reserve a Flow Instance Step.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(151294540530027137)
,p_plugin_attribute_id=>wwv_flow_imp.id(151293410221019612)
,p_display_sequence=>30
,p_display_value=>'Release Step'
,p_return_value=>'release'
,p_help_text=>'This option is used to release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151289804975012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Set Gateway Routing?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151293410221019612)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'complete'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this Process to also set up the routing for a data driven Gateway?</p>',
'<p>BPMN Flow Diagrams contain two gateway types that are data-driven gateways.  These are ',
'<ul>',
'<li>Exclusive Gateways - which choose 1 forward route from several options.</li>',
'<li>Inclusive Gateways - which choose 1 or more routes from several options.</li>',
'</ul></p>',
'<p>In <i>Flows for APEX,</i> the routing instruction for a gateway is set up by creating a Process Variable (named <gateway_bpmn_name>||'':route'') with the BPMN name of the paths to be chosen.</p>',
'<p>If you want this APEX process to set up routing for a forward gateway using information that is known on this page, you can get up the gateway routing here.</p>',
'<p>Set the switch to ''On'' to set up routing for a future Inclusive Gateway or Exclusive Gateway.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151290203459012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Gateway ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151289804975012472)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Gateway ID of the Gateway to set.  If the field is empty, the plugin will automatically fill it with the next object id, if it is an Inclusive or Exclusive Gateway.</p>',
'',
'<p>Note that BPMN objects have an Object ID and an Object Name -  the routing variable needs the Object ID.</p>',
'<p>The plug-in will create a Flows for APEX Process Variable with a name of this field with '':route'' appended to it, as required by the gateway.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151290679913012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Route ID'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151289804975012472)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Example 1:</b>  Inclusive Gateway with required route in Page Item named ''approval_decision'':</p>',
'',
'<pre>&approval_decision.</pre>',
'',
'<p> Page Item approval_decision contains the approval decision route, ''Flow_yes'' or ''Flow_no''. </p>',
'<p><b>Example 2:</b>  Exclusive Gateway with required route in Page Item named ''ship_modes'':</p>',
'',
'<pre>&ship_modes.</pre>',
'',
'<p> Page Item ship_modes contains the required shipping modes for the order.  In this case, the order is to ship by ''air'' and ''sea'', the routes for which have IDs of ''Flow_air'' and ''Flow_sea''.  The contents of Page Item ship_modes would have been set'
||' to ''Flow_air:Flow_sea''. </p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the ID of the route(s) that you want the Flow Instance to take at the Gateway.</p>',
'',
'<p>The Route ID is the ID (not the name) of the sequence Flow leaving the gateway.  To get this from your Flow diagram, open your Flow diagram with the Flow Modeller, select the outbound path (line) from the gateway object.  The Properties Panel will'
||' show its ID and name.  </p>',
'<ul>',
'<li>An Exclusive Gateway (+ sign) allows only 1 forward path.  Set the Routing field to the ID of the path you want, or a substitution variable for a Page Item containing the required link ID.</li>',
'<li>An Inclusive Gateway (o sign) allows multiple forward paths.  If there are more than 1 desired paths, these should be colon (:) delimited.  Set the Routing field to a colon delimited list of the paths you want, or a substitution variable for a Pa'
||'ge Item containing the list IDs of the required links.</li>',
'<ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(151291009553012472)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Auto-Branching?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151293410221019612)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'complete'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>After issuing the step_complete instruction to the Flow engine, Auto Branching will then branch your APEX application to the application page required for the next userTask in the Flow -- without the user needing to return to a task inbox.',
'<p>Auto Branching will only occur when:',
'<ul>',
'<li>the next object in the Flow is also a userTask</li>',
'<li>if Lanes are defined for the Flow, both the last and next task are in the same lane</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(161386843148607242)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Reservation'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151293410221019612)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'reserve'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Reserve with the connected user name</p>',
'<pre>&APP_USER.</pre>'))
,p_help_text=>'Use this to define the value for the reservation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(168020992549891765)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Return  Flow Instance and Subflow ID [deprecated]'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'This attribute is deprecated starting from Flows for APEX 22.2 and will probably be removed in a future release.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133131748772449152)
,p_plugin_id=>wwv_flow_imp.id(151286992364012459)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>35
,p_prompt=>'Step Key'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(151287222331012470)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance step_key.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named STEP_KEY.</li>',
'<li>A Global Page Item, for example P0_STEP_KEY.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_return_to_flows_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12315927534327459869)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.RETURN.TO.FLOWS.PROCESS'
,p_display_name=>'Flows for APEX - Return to Flows for APEX'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_TASKDEF_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.RETURN.TO.FLOWS.PROCESS'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function execution',
'  ( p_process in apex_plugin.t_process',
'  , p_plugin  in apex_plugin.t_plugin ',
'  )',
'return apex_plugin.t_process_exec_result',
'as',
'    l_result     apex_plugin.t_process_exec_result;',
'',
'    --attributes',
'    l_attribute1 p_process.attribute_01%type := p_process.attribute_01;',
'',
'begin',
'',
'    --debug',
'    if apex_application.g_debug ',
'    then',
'        apex_plugin_util.debug_process',
'          ( p_plugin         => p_plugin',
'          , p_process        => p_process',
'          );',
'    end if;',
'',
'    flow_api_pkg.return_approval_result ( p_process_id   => apex_util.get_session_state(l_attribute1),',
'                                          p_apex_task_id => apex_util.get_session_state(''APEX$TASK_ID''),',
'                                          p_result       => apex_util.get_session_state(''APEX$TASK_OUTCOME''));',
'',
'    return l_result;',
'end execution;    '))
,p_api_version=>2
,p_execution_function=>'execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(12315927733718459871)
,p_plugin_id=>wwv_flow_imp.id(12315927534327459869)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Parameter Name containing Process ID'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'PROCESS_ID'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/com_flows4apex_viewer_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(52324545630147899359)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.FLOWS4APEX.VIEWER.REGION'
,p_display_name=>'Flows for APEX - Viewer'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.FLOWS4APEX.VIEWER.REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#js/flows4apex.apex.viewer.js',
'#PLUGIN_FILES#js/flows4apex.viewer.min.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#css/diagram-js.css',
'#PLUGIN_FILES#css/bpmn-js.css',
'#PLUGIN_FILES#css/bpmn-embedded.css',
'#PLUGIN_FILES#css/flows4apex.viewer.css'))
,p_api_version=>1
,p_render_function=>'flow_viewer.render'
,p_ajax_function=>'flow_viewer.ajax'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY:NO_DATA_FOUND_MESSAGE:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
,p_files_version=>922
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49041559670646437847)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Diagram XML'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'CLOB'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the diagram XML.<br />',
'You can choose from any CLOB column of the region source.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49041558490616432029)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Current Nodes'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'ALL_CURRENT'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(48872363434558962706)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding ID(s) of the current node(s).<br />',
'For multiple values verify to use colons as delimiters.<br/>',
'Leave empty if you don''t want to highlight current nodes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48925434507723838082)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>70
,p_prompt=>'Diagram Identifier'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'PRDG_ID'
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_help_text=>'Choose the column containing the diagram identifier of the currently displayed diagram (normally the prdg_id for running instances and the dgrm_id for displaying plain models).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49047760679593436066)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Completed Nodes'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'ALL_COMPLETED'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(48872363434558962706)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding ID(s) of the completed node(s).<br/>',
'For multiple values verify to use colons as delimiters.<br/>',
'Leave empty if you don''t want to highlight completed nodes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48925435916496839839)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>'Calling Diagram Identifier'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'PRDG_PRDG_ID'
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(104132057364667011)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the diagram identifier of the parent diagram.<br/>',
'In the context of call activities this is the diagram that contains the activity which called the currently displayed diagram (normally the prdg_prdg_id for running instances and the calling_dgrm for displaying plain models).'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49047759420063427098)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Error Nodes'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'ALL_ERRORS'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(48872363434558962706)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding ID(s) of the error node(s).<br/>',
'For multiple values verify to use colons as delimiters.<br/>',
'Leave empty if you don''t want to highlight error nodes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48925437461211841205)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>'Calling Object ID'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'CALLING_OBJT'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(104132057364667011)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the object id of the parent diagram''s call activity.<br/>',
'In the context of call activities this is the call activity which called the current displayed diagram (normally the prdg_prdg_id for running instances or the calling dgrm_id).'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48886261588328959501)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>'Refresh On Load'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Leaving this at "Yes" will make the plugin try to refresh itself on page load.<br />',
'This typically makes sense if your query will immediately return a row.<br />',
'If your query doesn''t return a row on page load you should set this to "No".<br />',
'Then use a dynamic action to listen on your driving page item(s) and trigger a refresh on the plugin region.<br />',
'Remember to add your driving page items to "Page Items to Submit" for this to work properly.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48872363434558962706)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>20
,p_prompt=>'Add Highlighting'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want the plugin to highlight certain nodes based on the current state of process.<br />',
'You can map the region source columns in the other attributes.<br />',
'The highlighting colors will always take precedence over the bpmn colors defined in the diagram.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48872280664970943403)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Show Toolbar'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enable this to show a toolbar in the viewer to control the zoom level and be able to download a svg file from the currently shown model.<br/>',
'Can be further configured by using the JavaScript Initialization Code in the region attributes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49803907314390654371)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>'Breadcrumb Text'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'BREADCRUMB'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(104132057364667011)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the breadcrumb text when navigating through multiple diagrams using call activities.<br/>',
'You can click on the breadcrumb entries in the viewer to move up to the parent diagrams of the curently displayed diagram.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49804713902910666897)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>'Allow Drilldown On Diagram Level'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'DRILLDOWN_ALLOWED'
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(104132057364667011)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want to allow users to drill down into the underlying diagram on a specific call activity.<br/>',
'The value can be set separately for each diagram level and thus each call activity.<br/>',
'This option can be used to fulfill security requirements when you want to hide implementation details of single subprocesses.<br/>',
'Allowed column values:<br/>',
'<ul>',
'<li><b>0</b> - Drilldown is prohibited. The call activity will work as a normal task and users can not display the called diagram.</li>',
'<li><b>1</b> - Drilldown is allowed. Users can click the plus icon on the call activity to display the called diagram.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(104132057364667011)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>60
,p_prompt=>'Enable Call Activities'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want the plugin to support call activities.<br/>',
'This option has to be enabled, if you use call cativities in any of your models to ensure displaying the correct diagram.',
'Be sure to setup the other attributes for building up the correct diagram call structure.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3653257702162964)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Enable Mousewheel Zoom'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enable this to control the zoom level with the mousewheel.<br/>',
'Makes most sense if you''re putting the viewer full screen on a separate page, otherwise this might interfere with normal web page navigation.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(36109064230444913)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>15
,p_prompt=>'Use BPMN Colors'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want the plugin to show the colors defined in the diagram using the bpmn color standard.<br />',
'If you additionally enable the following option <strong>Add Highlighting</strong>, this will take precedence over the bpmn colors.<br />',
'As this can lead to unexpected results, we strongly recommend to only use one option at once.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(36702621479317294)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>55
,p_prompt=>'Iteration Data'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'CLOB'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding the data of iterating elements in the diagram.<br/>',
'If existing, according elements will show an option to open the list of instances and select the highlighted instance.<br/>',
'Leave empty if you don''t want to show iteration data in the viewer.<br/>',
'<br/>',
'See view <em>FLOW_INSTANCE_DETAILS_VW</em> on how to build up the JSON structure of the iteration data.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(5461417218678527)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'User Task URLs'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'CLOB'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding the URLs generated for APEX Page or APEX Simple Form User Tasks.<br/>',
'If existing, users that are eligible to work on a task can directly click on the icon next to the User Tasks to open the referenced page.<br/>',
'Leave empty if you don''t want to link User Tasks directly in the viewer.<br/>',
'<br/>',
'The URLs for a single process instance need to be wrapped in a JSON object. See view <em>FLOW_INSTANCE_DETAILS_VW</em> on how to build up the required JSON structure of this attribute.'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(48859105243699546287)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p></p>',
'<pre>',
'function( config ) {',
'    config.currentStyle = {',
'        ''fill'': ''green'',',
'        ''border'': ''black'',',
'        ''label'': ''black''',
'    }',
'    config.completedStyle = {',
'        ''fill'': ''grey'',',
'        ''border'': ''black'',',
'        ''label'': ''black''',
'    }',
'    config.errorStyle = {',
'        ''fill'': ''red'',',
'        ''border'': ''black'',',
'        ''label'': ''white''',
'    };',
'    config.allowDownload = false;',
'    return config;',
'}',
'</pre>',
'<p></p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a JavaScript function that takes a configuration object for the Flow Viewer, modifies the object, and returns it.<br/>',
'This allows advanced customization of the Flow Viewer including:<br/>',
'<ul>',
'<li>Change highlighting options for elements depending on the process status</li>',
'<li>Disable button for downloading model as svg in the viewer toolbar</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(49042060333655360973)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48877354741159920984)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_diagram_loaded'
,p_display_name=>'Diagram Loaded'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48875481319341258612)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_element_click'
,p_display_name=>'Click on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48875481743923258612)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_element_dblclick'
,p_display_name=>'Doubleclick on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48875480580920258597)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_element_hover'
,p_display_name=>'Hover on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48875482155076258613)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_element_mousedown'
,p_display_name=>'Mousedown on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48875482539600258613)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_element_mouseup'
,p_display_name=>'Mouseup on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48875480930145258612)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_name=>'mtbv_element_out'
,p_display_name=>'Leave Element'
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20676C6F62616C20617065782C2042706D6E4A53202A2F0D0A0D0A2866756E6374696F6E2820242C20726567696F6E2C206576656E742C206D65737361676520297B0D0A0D0A2020242E776964676574282022666C6F777334617065782E76696577';
wwv_flow_imp.g_varchar2_table(2) := '6572222C207B0D0A202020206F7074696F6E733A207B0D0A202020202020616A61784964656E7469666965723A206E756C6C2C0D0A2020202020206974656D73546F5375626D69743A206E756C6C2C0D0A2020202020206E6F44617461466F756E644D65';
wwv_flow_imp.g_varchar2_table(3) := '73736167653A2022436F756C64206E6F74206C6F6164204469616772616D222C0D0A202020202020726566726573684F6E4C6F61643A2066616C73652C0D0A20202020202073686F77546F6F6C6261723A2066616C73652C0D0A202020202020656E6162';
wwv_flow_imp.g_varchar2_table(4) := '6C654D6F757365776865656C5A6F6F6D3A2066616C73652C0D0A202020202020616464486967686C69676874696E673A2066616C73652C0D0A20202020202075736542504D4E636F6C6F72733A2066616C73652C0D0A202020202020656E61626C654361';
wwv_flow_imp.g_varchar2_table(5) := '6C6C416374697669746965733A2066616C73652C0D0A202020202020636F6E6669673A207B0D0A202020202020202063757272656E745374796C653A207B0D0A202020202020202020202266696C6C223A202223366161643432222C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(6) := '2020202022626F72646572223A2022626C61636B222C0D0A20202020202020202020226C6162656C223A2022626C61636B220D0A20202020202020207D2C0D0A2020202020202020636F6D706C657465645374796C653A207B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(7) := '202266696C6C223A202223386339656230222C0D0A2020202020202020202022626F72646572223A2022626C61636B222C0D0A20202020202020202020226C6162656C223A2022626C61636B220D0A20202020202020207D2C0D0A202020202020202065';
wwv_flow_imp.g_varchar2_table(8) := '72726F725374796C653A207B0D0A202020202020202020202266696C6C223A202223643234323362222C0D0A2020202020202020202022626F72646572223A2022626C61636B222C0D0A20202020202020202020226C6162656C223A2022776869746522';
wwv_flow_imp.g_varchar2_table(9) := '0D0A20202020202020207D2C0D0A2020202020202020616C6C6F77446F776E6C6F61643A20747275652C0D0A2020202020207D0D0A202020207D2C0D0A0D0A202020205F6372656174653A2066756E6374696F6E2829207B0D0A0D0A2020202020207468';
wwv_flow_imp.g_varchar2_table(10) := '69732E5F64656661756C74586D6C203D0D0A2020202020202020223C3F786D6C2076657273696F6E3D27312E302720656E636F64696E673D275554462D38273F3E22202B0D0A2020202020202020223C62706D6E3A646566696E6974696F6E7320786D6C';
wwv_flow_imp.g_varchar2_table(11) := '6E733A7873693D27687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E63652720786D6C6E733A62706D6E3D27687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F3230313030353234';
wwv_flow_imp.g_varchar2_table(12) := '2F4D4F44454C2720786D6C6E733A62706D6E64693D27687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4449272069643D27446566696E6974696F6E735F31777A6234373527207461726765744E616D6573';
wwv_flow_imp.g_varchar2_table(13) := '706163653D27687474703A2F2F62706D6E2E696F2F736368656D612F62706D6E27206578706F727465723D2762706D6E2D6A73202868747470733A2F2F64656D6F2E62706D6E2E696F2927206578706F7274657256657273696F6E3D27372E322E30273E';
wwv_flow_imp.g_varchar2_table(14) := '22202B0D0A2020202020202020223C62706D6E3A70726F636573732069643D2750726F636573735F30727865726D682720697345786563757461626C653D2766616C736527202F3E22202B0D0A2020202020202020223C62706D6E64693A42504D4E4469';
wwv_flow_imp.g_varchar2_table(15) := '616772616D2069643D2742504D4E4469616772616D5F31273E22202B0D0A2020202020202020223C62706D6E64693A42504D4E506C616E652069643D2742504D4E506C616E655F31272062706D6E456C656D656E743D2750726F636573735F3072786572';
wwv_flow_imp.g_varchar2_table(16) := '6D6827202F3E22202B0D0A2020202020202020223C2F62706D6E64693A42504D4E4469616772616D3E22202B0D0A2020202020202020223C2F62706D6E3A646566696E6974696F6E733E223B0D0A202020202020746869732E726567696F6E4964202020';
wwv_flow_imp.g_varchar2_table(17) := '203D20746869732E656C656D656E745B305D2E69643B0D0A202020202020746869732E7669657765725772617020203D20746869732E726567696F6E4964202B20225F766965776572223B0D0A202020202020746869732E63616E766173496420202020';
wwv_flow_imp.g_varchar2_table(18) := '3D20746869732E726567696F6E4964202B20225F63616E766173223B0D0A202020202020746869732E656E61626C65644D6F64756C6573203D205B0D0A202020202020202062706D6E5669657765722E637573746F6D4D6F64756C65732E6472696C6C64';
wwv_flow_imp.g_varchar2_table(19) := '6F776E43656E746572696E672C0D0A202020202020202062706D6E5669657765722E637573746F6D4D6F64756C65732E6D756C7469496E7374616E63654D6F64756C652C0D0A202020202020202062706D6E5669657765722E637573746F6D4D6F64756C';
wwv_flow_imp.g_varchar2_table(20) := '65732E757365725461736B4D6F64756C650D0A2020202020205D3B0D0A0D0A2020202020202F2F20616464207374796C65206D6F64756C6520696620616464486967686C69676874696E67206F722062706D6E436F6C6F7273206F7074696F6E73206973';
wwv_flow_imp.g_varchar2_table(21) := '20656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E67207C7C20746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A2020202020202020746869732E656E';
wwv_flow_imp.g_varchar2_table(22) := '61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E7374796C654D6F64756C65293B0D0A2020202020207D0D0A0D0A2020202020202F2F206164642063616C6C41637469766974794D6F64756C65';
wwv_flow_imp.g_varchar2_table(23) := '2069662063616C6C2061637469766974696573206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E656E61626C6543616C6C416374697669746965732029207B0D0A2020202020202020746869';
wwv_flow_imp.g_varchar2_table(24) := '732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E63616C6C41637469766974794D6F64756C65293B0D0A2020202020207D0D0A0D0A2020202020202F2F207365742064656661756C74';
wwv_flow_imp.g_varchar2_table(25) := '20636F6C6F72730D0A202020202020746869732E62706D6E52656E6465726572203D207B0D0A202020202020202064656661756C7446696C6C436F6C6F723A2022766172282D2D64656661756C742D66696C6C2D636F6C6F7229222C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(26) := '202064656661756C745374726F6B65436F6C6F723A2022766172282D2D64656661756C742D7374726F6B652D636F6C6F7229222C0D0A202020202020202064656661756C744C6162656C436F6C6F723A2022766172282D2D64656661756C742D7374726F';
wwv_flow_imp.g_varchar2_table(27) := '6B652D636F6C6F7229222C0D0A2020202020207D0D0A0D0A2020202020202F2F2061646420637573746F6D2070616C657474652069662073686F77546F6F6C626172206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869';
wwv_flow_imp.g_varchar2_table(28) := '732E6F7074696F6E732E73686F77546F6F6C6261722029207B0D0A2020202020202020746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E637573746F6D50616C657474655072';
wwv_flow_imp.g_varchar2_table(29) := '6F76696465724D6F64756C65293B0D0A2020202020207D0D0A2020202020202F2F20616464207A6F6F6D5363726F6C6C206D6F64756C65206966206D6F75736520776865656C207A6F6F6D206F7074696F6E20697320656E61626C65640D0A2020202020';
wwv_flow_imp.g_varchar2_table(30) := '206966202820746869732E6F7074696F6E732E656E61626C654D6F757365776865656C5A6F6F6D2029207B0D0A2020202020202020746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C';
wwv_flow_imp.g_varchar2_table(31) := '65732E5A6F6F6D5363726F6C6C4D6F64756C65293B0D0A2020202020207D0D0A2020202020202F2F20616464206D6F76652063616E766173206D6F64756C652069662073686F77546F6F6C626172206F7074696F6E206F72206D6F75736520776865656C';
wwv_flow_imp.g_varchar2_table(32) := '207A6F6F6D206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E73686F77546F6F6C626172207C7C20746869732E6F7074696F6E732E656E61626C654D6F757365776865656C5A6F6F6D29207B';
wwv_flow_imp.g_varchar2_table(33) := '0D0A2020202020202020746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E4D6F766543616E7661734D6F64756C65293B0D0A2020202020207D0D0A0D0A202020202020746869';
wwv_flow_imp.g_varchar2_table(34) := '732E62706D6E56696577657224203D206E65772062706D6E5669657765722E566965776572287B0D0A20202020202020202020636F6E7461696E65723A20222322202B20746869732E63616E76617349642C0D0A20202020202020202020616464697469';
wwv_flow_imp.g_varchar2_table(35) := '6F6E616C4D6F64756C65733A20746869732E656E61626C65644D6F64756C65732C0D0A2020202020202020202062706D6E52656E64657265723A20746869732E62706D6E52656E64657265722C0D0A20202020202020202020636F6E6669673A20746869';
wwv_flow_imp.g_varchar2_table(36) := '732E6F7074696F6E732E636F6E6669670D0A2020202020207D293B0D0A0D0A2020202020202F2F2070726576656E742070616765207375626D6974202B2072656C6F616420616674657220627574746F6E20636C69636B0D0A202020202020242820646F';
wwv_flow_imp.g_varchar2_table(37) := '63756D656E7420292E6F6E282022617065786265666F7265706167657375626D6974222C2028205F2C20726571756573742029203D3E207B0D0A20202020202020206966202821726571756573742920617065782E6576656E742E6743616E63656C466C';
wwv_flow_imp.g_varchar2_table(38) := '6167203D20747275653B0D0A2020202020207D20293B0D0A0D0A2020202020206966202820746869732E6F7074696F6E732E726566726573684F6E4C6F61642029207B0D0A2020202020202020746869732E7265667265736828293B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(39) := '7D0D0A0D0A202020202020746869732E5F72656769737465724576656E747328293B0D0A2020202020200D0A202020202020726567696F6E2E63726561746528746869732E726567696F6E49642C207B0D0A20202020202020207769646765743A202829';
wwv_flow_imp.g_varchar2_table(40) := '203D3E207B2072657475726E20746869732E656C656D656E743B207D2C0D0A2020202020202020726566726573683A202829203D3E207B20746869732E7265667265736828293B207D2C0D0A202020202020202072657365743A202829203D3E207B2074';
wwv_flow_imp.g_varchar2_table(41) := '6869732E726573657428293B207D2C0D0A20202020202020206C6F61644469616772616D3A202829203D3E207B20746869732E6C6F61644469616772616D28293B207D2C0D0A20202020202020206765745356473A202829203D3E20746869732E676574';
wwv_flow_imp.g_varchar2_table(42) := '53564728292C0D0A2020202020202020676574566965776572496E7374616E63653A202829203D3E207B2072657475726E20746869732E62706D6E566965776572243B207D2C0D0A20202020202020206765744576656E744275733A202829203D3E207B';
wwv_flow_imp.g_varchar2_table(43) := '2072657475726E20746869732E62706D6E566965776572242E6765742820226576656E744275732220293B207D2C0D0A20202020202020207769646765744E616D653A202262706D6E766965776572222C0D0A2020202020202020747970653A2022666C';
wwv_flow_imp.g_varchar2_table(44) := '6F777334617065782E766965776572220D0A2020202020207D293B0D0A202020207D2C0D0A0D0A202020206C6F61644469616772616D3A206173796E632066756E6374696F6E2829207B0D0A2020202020200D0A202020202020242820222322202B2074';
wwv_flow_imp.g_varchar2_table(45) := '6869732E63616E766173496420292E73686F7728293B0D0A202020202020242820222322202B20746869732E726567696F6E4964202B2022207370616E2E6E6F64617461666F756E642220292E6869646528293B0D0A2020202020200D0A202020202020';
wwv_flow_imp.g_varchar2_table(46) := '636F6E73742062706D6E56696577657224203D20746869732E62706D6E566965776572243B0D0A2020202020200D0A202020202020747279207B0D0A2020202020202020636F6E737420726573756C74203D2061776169742062706D6E56696577657224';
wwv_flow_imp.g_varchar2_table(47) := '2E696D706F7274584D4C2820746869732E6469616772616D207C7C20746869732E5F64656661756C74586D6C20293B0D0A2020202020202020636F6E7374207B207761726E696E6773207D203D20726573756C743B0D0A20202020202020200D0A202020';
wwv_flow_imp.g_varchar2_table(48) := '202020202069662028207761726E696E67732E6C656E677468203E20302029207B0D0A20202020202020202020617065782E64656275672E7761726E2820225761726E696E677320647572696E6720584D4C20496D706F7274222C207761726E696E6773';
wwv_flow_imp.g_varchar2_table(49) := '20293B0D0A20202020202020207D0D0A20202020202020200D0A2020202020202020746869732E7A6F6F6D2820226669742D76696577706F72742220293B0D0A20202020202020200D0A20202020202020200D0A20202020202020202F2F206765742076';
wwv_flow_imp.g_varchar2_table(50) := '6965776572206D6F64756C65730D0A2020202020202020636F6E7374206576656E74427573203D2062706D6E566965776572242E67657428276576656E7442757327293B0D0A2020202020202020636F6E7374206D756C7469496E7374616E63654D6F64';
wwv_flow_imp.g_varchar2_table(51) := '756C65203D2062706D6E566965776572242E67657428276D756C7469496E7374616E63654D6F64756C6527293B0D0A0D0A20202020202020202F2F2075706461746520636F6C6F72732077697468207468652063757272656E7420686967686C69676874';
wwv_flow_imp.g_varchar2_table(52) := '696E6720696E666F0D0A2020202020202020746869732E757064617465436F6C6F727328746869732E63757272656E742C20746869732E636F6D706C657465642C20746869732E6572726F72293B0D0A202020202020202020200D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(53) := '2F2F20726F6F742E736574202D3E206472696C6C656420646F776E20696E746F206F72206D6F766564206F75742066726F6D207375622070726F636573730D0A20202020202020206576656E744275732E6F6E2827726F6F742E736574272C2028657665';
wwv_flow_imp.g_varchar2_table(54) := '6E7429203D3E207B0D0A20202020202020202020636F6E7374207B656C656D656E747D203D206576656E743B0D0A202020202020202020202F2F2069662063757272656E7420656C656D656E74206973206E6F7420697465726174696E67202D3E206974';
wwv_flow_imp.g_varchar2_table(55) := '65726174696E6720656C656D656E7473206172652068616E646C656420696E73696465206D6F64756C650D0A2020202020202020202069662028216D756C7469496E7374616E63654D6F64756C652E69734D756C7469496E7374616E636553756250726F';
wwv_flow_imp.g_varchar2_table(56) := '6365737328656C656D656E742929207B0D0A2020202020202020202020202F2F2075706461746520636F6C6F72730D0A202020202020202020202020746869732E757064617465436F6C6F727328746869732E63757272656E742C20746869732E636F6D';
wwv_flow_imp.g_varchar2_table(57) := '706C657465642C20746869732E6572726F72293B0D0A202020202020202020207D0D0A20202020202020207D293B0D0A0D0A20202020202020202F2F20616464206F7665726C61797320696620697465726174696F6E4461746120697320657869737469';
wwv_flow_imp.g_varchar2_table(58) := '6E670D0A202020202020202069662028746869732E697465726174696F6E4461746129207B0D0A20202020202020202020746869732E62706D6E566965776572242E67657428276D756C7469496E7374616E63654D6F64756C6527292E6164644F766572';
wwv_flow_imp.g_varchar2_table(59) := '6C61797328293B0D0A20202020202020207D0D0A0D0A20202020202020202F2F20616464206F7665726C61797320696620757365725461736B44617461206973206578697374696E670D0A202020202020202069662028746869732E757365725461736B';
wwv_flow_imp.g_varchar2_table(60) := '4461746129207B0D0A20202020202020202020746869732E62706D6E566965776572242E6765742827757365725461736B4D6F64756C6527292E6164644F7665726C61797328293B0D0A20202020202020207D0D0A0D0A20202020202020202F2F207472';
wwv_flow_imp.g_varchar2_table(61) := '6967676572206C6F6164206576656E740D0A20202020202020206576656E742E747269676765722820222322202B20746869732E726567696F6E49642C20226D7462765F6469616772616D5F6C6F61646564222C200D0A202020202020202020207B200D';
wwv_flow_imp.g_varchar2_table(62) := '0A2020202020202020202020206469616772616D4964656E7469666965723A20746869732E6469616772616D4964656E7469666965722C200D0A20202020202020202020202063616C6C696E674469616772616D4964656E7469666965723A2074686973';
wwv_flow_imp.g_varchar2_table(63) := '2E63616C6C696E674469616772616D4964656E7469666965722C200D0A20202020202020202020202063616C6C696E674F626A65637449643A20746869732E63616C6C696E674F626A65637449640D0A202020202020202020207D200D0A202020202020';
wwv_flow_imp.g_varchar2_table(64) := '2020293B0D0A0D0A2020202020207D206361746368202865727229207B0D0A2020202020202020617065782E64656275672E6572726F722820224C6F6164696E67204469616772616D206661696C65642E222C206572722C20746869732E646961677261';
wwv_flow_imp.g_varchar2_table(65) := '6D20293B0D0A2020202020207D0D0A202020207D2C0D0A0D0A20202020757064617465436F6C6F72733A2066756E6374696F6E2863757272656E742C20636F6D706C657465642C206572726F7229207B0D0A2020202020202F2F20696620616E7920636F';
wwv_flow_imp.g_varchar2_table(66) := '6C6F72206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E67207C7C20746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A2020';
wwv_flow_imp.g_varchar2_table(67) := '2020202020202F2F2067657420766965776572206D6F64756C650D0A2020202020202020636F6E7374207374796C654D6F64756C65203D20746869732E62706D6E566965776572242E67657428277374796C654D6F64756C6527293B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(68) := '20202F2F2072657365742063757272656E7420636F6C6F72730D0A2020202020202020746869732E7265736574436F6C6F727328293B0D0A20202020202020202F2F2061646420686967686C69676874696E67206966206F7074696F6E20697320656E61';
wwv_flow_imp.g_varchar2_table(69) := '626C65640D0A20202020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E672029207B0D0A202020202020202020207374796C654D6F64756C652E686967686C69676874456C656D656E74732863757272656E74';
wwv_flow_imp.g_varchar2_table(70) := '2C20636F6D706C657465642C206572726F72293B0D0A20202020202020207D0D0A2020202020207D0D0A202020207D2C0D0A0D0A202020207265736574436F6C6F72733A2066756E6374696F6E2829207B0D0A2020202020202F2F20696620616E792063';
wwv_flow_imp.g_varchar2_table(71) := '6F6C6F72206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E67207C7C20746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A20';
wwv_flow_imp.g_varchar2_table(72) := '202020202020202F2F2067657420766965776572206D6F64756C650D0A2020202020202020636F6E7374207374796C654D6F64756C65203D20746869732E62706D6E566965776572242E67657428277374796C654D6F64756C6527293B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(73) := '2020202F2F2072657365742062706D6E20636F6C6F7273206966206F7074696F6E206973206E6F7420656E61626C65640D0A2020202020202020696620282021746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(74) := '2020202020207374796C654D6F64756C652E726573657442504D4E636F6C6F727328293B0D0A20202020202020207D0D0A20202020202020202F2F20726573657420686967686C69676874696E670D0A20202020202020207374796C654D6F64756C652E';
wwv_flow_imp.g_varchar2_table(75) := '7265736574486967686C69676874696E6728293B0D0A2020202020207D0D0A202020207D2C0D0A0D0A202020207A6F6F6D3A2066756E6374696F6E28207A6F6F6D4F7074696F6E2029207B0D0A202020202020746869732E62706D6E566965776572242E';
wwv_flow_imp.g_varchar2_table(76) := '67657428202263616E7661732220292E7A6F6F6D28207A6F6F6D4F7074696F6E2C20276175746F2720293B0D0A202020207D2C0D0A0D0A202020206765745356473A206173796E632066756E6374696F6E2829207B0D0A0D0A202020202020747279207B';
wwv_flow_imp.g_varchar2_table(77) := '0D0A2020202020202020636F6E737420726573756C74203D20617761697420746869732E62706D6E566965776572242E73617665535647287B20666F726D61743A2074727565207D293B0D0A2020202020202020636F6E7374207B20737667207D203D20';
wwv_flow_imp.g_varchar2_table(78) := '726573756C743B0D0A20202020202020200D0A20202020202020202F2F2061646420686967686C69676874696E6720636F6C6F727320746F20696D616765206966206F7074696F6E20697320656E61626C65640D0A202020202020202069662028207468';
wwv_flow_imp.g_varchar2_table(79) := '69732E6F7074696F6E732E616464486967686C69676874696E672029207B0D0A2020202020202020202072657475726E20746869732E62706D6E566965776572242E67657428277374796C654D6F64756C6527292E6164645374796C65546F5356472873';
wwv_flow_imp.g_varchar2_table(80) := '7667293B0D0A20202020202020207D0D0A0D0A202020202020202072657475726E207376673B0D0A2020202020200D0A2020202020207D206361746368202865727229207B0D0A2020202020202020617065782E64656275672E6572726F722820224765';
wwv_flow_imp.g_varchar2_table(81) := '7420535647206661696C65642E222C2065727220293B0D0A20202020202020207468726F77206572723B0D0A2020202020207D0D0A202020207D2C0D0A0D0A20202020726566726573683A2066756E6374696F6E2829207B0D0A0D0A2020202020206170';
wwv_flow_imp.g_varchar2_table(82) := '65782E64656275672E696E666F282022456E7465722052656672657368222C20746869732E6F7074696F6E7320293B0D0A2020202020200D0A202020202020617065782E7365727665722E706C7567696E2820746869732E6F7074696F6E732E616A6178';
wwv_flow_imp.g_varchar2_table(83) := '4964656E7469666965722C207B0D0A2020202020202020706167654974656D733A20242820746869732E6F7074696F6E732E6974656D73546F5375626D69742C20617065782E6750616765436F6E746578742420290D0A2020202020207D2C207B0D0A20';
wwv_flow_imp.g_varchar2_table(84) := '20202020202020726566726573684F626A6563743A20222322202B20746869732E63616E76617349642C0D0A20202020202020206C6F6164696E67496E64696361746F723A20222322202B20746869732E63616E76617349640D0A2020202020207D290D';
wwv_flow_imp.g_varchar2_table(85) := '0A2020202020202E7468656E28207044617461203D3E207B0D0A2020202020202020696620282070446174612E666F756E642029207B0D0A0D0A20202020202020202020766172206469616772616D3B0D0A20202020202020202020766172206F6C644C';
wwv_flow_imp.g_varchar2_table(86) := '6F61646564203D20747275653B0D0A0D0A202020202020202020202F2F2073657420776964676574207265666572656E63650D0A20202020202020202020746869732E62706D6E566965776572242E67657428276D756C7469496E7374616E63654D6F64';
wwv_flow_imp.g_varchar2_table(87) := '756C6527292E7365745769646765742874686973293B0D0A20202020202020202020746869732E62706D6E566965776572242E6765742827757365725461736B4D6F64756C6527292E7365745769646765742874686973293B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(88) := '200D0A202020202020202020202F2F2069662063616C6C2061637469766974696573206F7074696F6E20656E61626C65640D0A2020202020202020202069662028746869732E6F7074696F6E732E656E61626C6543616C6C416374697669746965732920';
wwv_flow_imp.g_varchar2_table(89) := '7B0D0A2020202020202020202020202F2F2073657420776964676574207265666572656E63650D0A202020202020202020202020746869732E62706D6E566965776572242E676574282763616C6C41637469766974794D6F64756C6527292E7365745769';
wwv_flow_imp.g_varchar2_table(90) := '646765742874686973293B0D0A2020202020202020202020202F2F206C6F6164206F6C64206469616772616D2028696620706F737369626C65290D0A2020202020202020202020206469616772616D203D2070446174612E646174612E66696E64286420';
wwv_flow_imp.g_varchar2_table(91) := '3D3E20642E6469616772616D4964656E746966696572203D3D3D20746869732E6469616772616D4964656E746966696572293B0D0A2020202020202020202020202F2F206F74686572776973653A2067657420726F6F7420656E7472790D0A2020202020';
wwv_flow_imp.g_varchar2_table(92) := '2020202020202069662028216469616772616D29207B0D0A20202020202020202020202020206F6C644C6F61646564203D2066616C73653B0D0A20202020202020202020202020206469616772616D203D2070446174612E646174612E66696E64286420';
wwv_flow_imp.g_varchar2_table(93) := '3D3E20747970656F6628642E63616C6C696E674469616772616D4964656E74696669657229203D3D3D2027756E646566696E656427293B0D0A2020202020202020202020207D200D0A2020202020202020202020202F2F20736574207265666572656E63';
wwv_flow_imp.g_varchar2_table(94) := '657320746F20686965726172636879202B2063757272656E74206469616772616D0D0A202020202020202020202020746869732E64617461203D2070446174612E646174613B0D0A202020202020202020202020746869732E6469616772616D4964656E';
wwv_flow_imp.g_varchar2_table(95) := '746966696572203D206469616772616D2E6469616772616D4964656E7469666965723B0D0A202020202020202020202020746869732E63616C6C696E674469616772616D4964656E746966696572203D206469616772616D2E63616C6C696E6744696167';
wwv_flow_imp.g_varchar2_table(96) := '72616D4964656E7469666965723B0D0A202020202020202020202020746869732E63616C6C696E674F626A6563744964203D206469616772616D2E63616C6C696E674F626A65637449643B0D0A0D0A2020202020202020202020202F2F20726573657420';
wwv_flow_imp.g_varchar2_table(97) := '26207570646174652062726561646372756D620D0A20202020202020202020202069662028216F6C644C6F6164656429207B0D0A20202020202020202020202020202020746869732E62706D6E566965776572242E676574282763616C6C416374697669';
wwv_flow_imp.g_varchar2_table(98) := '74794D6F64756C6527292E726573657442726561646372756D6228293B0D0A20202020202020202020202020202020746869732E62706D6E566965776572242E676574282763616C6C41637469766974794D6F64756C6527292E75706461746542726561';
wwv_flow_imp.g_varchar2_table(99) := '646372756D6228293B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A202020202020202020202F2F2063616C6C2061637469766974696573206E6F74206163746976617465640D0A20202020202020202020656C7365207B0D';
wwv_flow_imp.g_varchar2_table(100) := '0A2020202020202020202020202F2F2067657420666972737420286F6E6C792920656E7472790D0A2020202020202020202020206469616772616D203D2070446174612E646174615B305D3B0D0A202020202020202020202020746869732E6469616772';
wwv_flow_imp.g_varchar2_table(101) := '616D4964656E746966696572203D206469616772616D2E6469616772616D4964656E7469666965723B0D0A202020202020202020207D0D0A0D0A202020202020202020202F2F2061646420686967686C69676874696E67206966206F7074696F6E206973';
wwv_flow_imp.g_varchar2_table(102) := '20656E61626C65640D0A2020202020202020202069662028746869732E6F7074696F6E732E616464486967686C69676874696E6729207B0D0A202020202020202020202020746869732E63757272656E742020203D206469616772616D2E63757272656E';
wwv_flow_imp.g_varchar2_table(103) := '743B0D0A202020202020202020202020746869732E636F6D706C65746564203D206469616772616D2E636F6D706C657465643B0D0A202020202020202020202020746869732E6572726F7220202020203D206469616772616D2E6572726F723B0D0A2020';
wwv_flow_imp.g_varchar2_table(104) := '20202020202020207D0D0A0D0A202020202020202020202F2F20736574206469616772616D20636F6E74656E740D0A20202020202020202020746869732E6469616772616D203D206469616772616D2E6469616772616D3B0D0A0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(105) := '20202F2F20706172736520697465726174696F6E4461746120616E642061747461636820746F20696E7374616E63650D0A20202020202020202020747279207B0D0A202020202020202020202020746869732E697465726174696F6E44617461203D204A';
wwv_flow_imp.g_varchar2_table(106) := '534F4E2E7061727365286469616772616D2E697465726174696F6E44617461293B0D0A202020202020202020207D0D0A202020202020202020206361746368286529207B0D0A202020202020202020202020746869732E697465726174696F6E44617461';
wwv_flow_imp.g_varchar2_table(107) := '203D206E756C6C3B0D0A202020202020202020207D0D0A202020202020202020200D0A202020202020202020202F2F20706172736520757365725461736B4461746120616E642061747461636820746F20696E7374616E63650D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(108) := '20747279207B0D0A202020202020202020202020746869732E757365725461736B44617461203D204A534F4E2E7061727365286469616772616D2E757365725461736B44617461293B0D0A202020202020202020207D0D0A202020202020202020206361';
wwv_flow_imp.g_varchar2_table(109) := '746368286529207B0D0A202020202020202020202020746869732E757365725461736B44617461203D206E756C6C3B0D0A202020202020202020207D0D0A0D0A202020202020202020202F2F206C6F6164206469616772616D0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(110) := '20746869732E6C6F61644469616772616D28293B0D0A20202020202020207D20656C7365207B0D0A0D0A20202020202020202020242820222322202B20746869732E63616E766173496420292E6869646528293B0D0A202020202020202020200D0A2020';
wwv_flow_imp.g_varchar2_table(111) := '20202020202020206966202870446174612E6D65737361676529207B0D0A202020202020202020202020617065782E6D6573736167652E636C6561724572726F727328293B0D0A2020202020202020202020206D6573736167652E73686F774572726F72';
wwv_flow_imp.g_varchar2_table(112) := '7328205B0D0A20202020202020202020202020207B0D0A20202020202020202020202020202020747970653A20226572726F72222C0D0A202020202020202020202020202020206C6F636174696F6E3A205B2270616765225D2C0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(113) := '20202020202020206D6573736167653A2070446174612E6D6573736167652C0D0A20202020202020202020202020202020756E736166653A2066616C73652C0D0A20202020202020202020202020207D2C0D0A2020202020202020202020205D20293B0D';
wwv_flow_imp.g_varchar2_table(114) := '0A202020202020202020207D0D0A20202020202020202020656C7365207B0D0A202020202020202020202020242820222322202B20746869732E726567696F6E4964202B2022207370616E2E6E6F64617461666F756E642220292E73686F7728293B0D0A';
wwv_flow_imp.g_varchar2_table(115) := '202020202020202020207D0D0A20202020202020207D0D0A2020202020207D293B0D0A202020207D2C0D0A0D0A202020205F72656769737465724576656E74733A2066756E6374696F6E2829207B0D0A202020202020636F6E7374206361707475726564';
wwv_flow_imp.g_varchar2_table(116) := '4576656E7473203D205B0D0A202020202020202022656C656D656E742E686F766572222C0D0A202020202020202022656C656D656E742E6F7574222C0D0A202020202020202022656C656D656E742E636C69636B222C0D0A202020202020202022656C65';
wwv_flow_imp.g_varchar2_table(117) := '6D656E742E64626C636C69636B222C0D0A202020202020202022656C656D656E742E6D6F757365646F776E222C0D0A202020202020202022656C656D656E742E6D6F7573657570220D0A2020202020205D3B0D0A0D0A2020202020206C6574206576656E';
wwv_flow_imp.g_varchar2_table(118) := '74427573203D20746869732E62706D6E566965776572242E6765742820226576656E744275732220293B0D0A20202020202063617074757265644576656E74732E666F7245616368282063757272656E744576656E74203D3E207B0D0A20202020202020';
wwv_flow_imp.g_varchar2_table(119) := '206576656E744275732E6F6E282063757272656E744576656E742C206576656E7444617461203D3E207B0D0A202020202020202020206576656E742E747269676765722820222322202B20746869732E726567696F6E49642C20226D7462765F22202B20';
wwv_flow_imp.g_varchar2_table(120) := '63757272656E744576656E742E7265706C61636528222E222C20225F22292C206576656E744461746120293B0D0A20202020202020207D293B0D0A2020202020207D293B0D0A202020207D0D0A20207D290D0A0D0A7D292820617065782E6A5175657279';
wwv_flow_imp.g_varchar2_table(121) := '2C20617065782E726567696F6E2C20617065782E6576656E742C20617065782E6D65737361676520293B0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5457683071562451)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_file_name=>'js/flows4apex.apex.viewer.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '40666F6E742D66616365207B0A2020666F6E742D66616D696C793A202762706D6E273B0A20207372633A2075726C28272E2E2F666F6E742F62706D6E2E656F743F313634303632383927293B0A20207372633A2075726C28272E2E2F666F6E742F62706D';
wwv_flow_imp.g_varchar2_table(2) := '6E2E656F743F3136343036323839236965666978272920666F726D61742827656D6265646465642D6F70656E7479706527292C0A2020202020202075726C28272E2E2F666F6E742F62706D6E2E7376673F31363430363238392362706D6E272920666F72';
wwv_flow_imp.g_varchar2_table(3) := '6D6174282773766727293B0A2020666F6E742D7765696768743A206E6F726D616C3B0A2020666F6E742D7374796C653A206E6F726D616C3B0A7D0A40666F6E742D66616365207B0A2020666F6E742D66616D696C793A202762706D6E273B0A2020737263';
wwv_flow_imp.g_varchar2_table(4) := '3A2075726C2827646174613A6170706C69636174696F6E2F6F637465742D73747265616D3B6261736536342C643039475267414241414141414436454141734141414141756B414141514141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(5) := '4141424855315643414141424341414141447341414142554949736C656B39544C7A49414141464541414141524141414147412B4A45733059323168634141414159674141414A794141414864464E316C2F686E62486C6D414141442F4141414E446341';
wwv_flow_imp.g_varchar2_table(6) := '414B4873755444364647686C5957514141446730414141414D4141414144596A42794A766147686C595141414F47514141414162414141414A4163384137396F625852344141413467414141414245414141477770654141414778765932454141446955';
wwv_flow_imp.g_varchar2_table(7) := '4141414132674141414E72765539455362574634634141414F58414141414166414141414941475742485A755957316C414141356B4141414156494141414939656A68316C584276633351414144726B414141446E674141436967512B4E7937654A786A';
wwv_flow_imp.g_varchar2_table(8) := '59475267594F42694D4743775932427963664D4A5965444C53537A4A5935426959474741414A41384D7073784A7A4D396B5945447867504B735942704469426D673467434143593742556741654A786A5947462B77546942675A574267616D4B61513844';
wwv_flow_imp.g_varchar2_table(9) := '41304D5068475A3877474449794151555A57426C5A73414B41744A635578674F76474238385A4135364838575178547A476F5A70514746474645564D414C586344645A346E4F585652314A555551434634622B6851614A497A6B6D554A45457941674A4B';
wwv_flow_imp.g_varchar2_table(10) := '52736C5273704C746262494579776B4D59485A336F6666306361524C454F716A344E337A4E393346413441734944507169704B5163555969666B62694946354E704B396E6B70652B6E6B7A30784B394C654247765A4952454B4171393454616B776C3134';
wwv_flow_imp.g_varchar2_table(11) := '43452B2F666B47386C677A466F533939375434383674706662346E596C39444F42542F53377A2F54317A4C694979626A4D386E6D47546E6B78752B5854774746504B636F66726669574A5253526A6B5656464A464E545855556B63394454545352444D76';
wwv_flow_imp.g_varchar2_table(12) := '6165455672326D6C4C5435324235323869632B376D783536655573662F517777794244446A44444B4F3859595A344C3354444C464E422F347941797A7A444850416F73737363776E507250434B6D75737338456D5732797A7779353737504F4641773435';
wwv_flow_imp.g_varchar2_table(13) := '34706754546A6E6A4B3938346A362F6F6B69757575654757373654697938722B3539582F663238462B704256397565726C4F3452303730566B685A2F2F6F517330373059736B33335933686D756B39446A71487A5845506E6559624F3877326446356A75';
wwv_flow_imp.g_varchar2_table(14) := '3331426F3650793536646D46496B506E7859624F537779646C31713846776C6C6872626C687259566872615668725A5668726256687259316872613168725A31687262316872594E6872614E68725A4E6872624E6872597644573162444731664764712B';
wwv_flow_imp.g_varchar2_table(15) := '4E7252744E6252744D3752744E3754744D4C54744E4C523959326A625A576A6262576A6259326A62612F7162452F6F4D6266734E6251634D625163742F693454686778317734613645555064714B48756E6146757A464133627169624D4E53394E39524E';
wwv_flow_imp.g_varchar2_table(16) := '4775716D4448585468726F506872715068726F5A513932736F57374F5544647671467377314330613670594D64637547756B2B4775732B477568564433617168627331517432366F327A445562527271746778313234613648555064727146757A314333';
wwv_flow_imp.g_varchar2_table(17) := '62366A37597167374D4E51644775714F4448584868726F54513932706F65374D555066565550664E55486475714C7377314630613671344D6464654775687444336132684C6D576F757A505533527671486778316A78622F487843656A4E5276524D4A44';
wwv_flow_imp.g_varchar2_table(18) := '4C414141654A7A7466516D63484D56316431645633393354505664337A387A75334C737A732B66634D337449753674377462707672533751775357774D4C633568496D4E7751675A38414632754D5268726868384148456334786748766A695959447432';
wwv_flow_imp.g_varchar2_table(19) := '59755059354C4E6A7833627746544279386E3138327546373154327A75354A5731344C457A34366D70362F7136757171563639652F642B723139554D787A427666593330343138795455776E6B3265476D43554D672F69456F4B4577676F315A6A426371';
wwv_flow_imp.g_varchar2_table(20) := '715377716C314C7056444B52546E494A33764A46454132752B6971705A4A78725179547553795131524D4D48554A70306F3959454C78412B6775776F36416D6C6C5A6546783256426B5046374A5547514875556B3376437143326F2F6C5856555143345A';
wwv_flow_imp.g_varchar2_table(21) := '66554E323453476B4B625766317359515161532F746D30527771714F4F374858644D48576854545A6A5742766565424D783739456D426842715166724C70654F71334C49547A4236535666477669653556426D334B2B35385455436652313631396A5646';
wwv_flow_imp.g_varchar2_table(22) := '7733344644636F306A6472664B6E36734B57684939544945796E346E2B524A4A4D4737477A38794363696345785073745A42617171464A4B6F35516734646145546F776B72464653704F73674B644D3153354B776F763236557473717932696645715562';
wwv_flow_imp.g_varchar2_table(23) := '4F46463064455074717470563647714D57594B6559324744434D732B527A636D65316751536441556F67636C4D32416E634D505078794D5A33464753596E676F782B336B71365146366A44504C47544F5A4B356B396B427055674A5046394D7972516971';
wwv_flow_imp.g_varchar2_table(24) := '447542714A64324E30716C304D6956554C427071386C444471585133584B6B4F494B736533376B4549526A6964694D6E726D44613134414A30716B4B524B2F416D63554C706C57314B6C5549684B42556D74635273416F4E457977687A5174702B784A36';
wwv_flow_imp.g_varchar2_table(25) := '34344B7A7473366172616A5647544E584C667572746575765838627A6B6559726C69316652777A333973326A66544E4561656241304D4E504C316D2B49325A59765430506E4C46787A597043476245744C62506D726C7879372B43736557776B4E694E33';
wwv_flow_imp.g_varchar2_table(26) := '7A657A6C497773364F6845614868686174474276736549332F4F6E307A4A476D634E3937657972746E627375366F756B43734857664B43394D35687244525A537654323753686465564C366F5A6151303067715853414A58796873325837447069777448';
wwv_flow_imp.g_varchar2_table(27) := '4D686D6C4F587A4670306333726C70315136614E77336D537A3631617533333934304E7A2B7430646E62632B74575A303974796C4853535858625A793436726C53797339626E6472727244336759574C43783235484F35736E7A2B79664E484E6E566C42';
wwv_flow_imp.g_varchar2_table(28) := '7968664C38326266316A387A30584668704F2B69536B396E2B363733396F5670566E4C427A765A4148724A43656E6F764C4F3243724C5243566C726745734E346F4E346574506D50514230717A464C6D59655941476B5366514B2F6A476668612F427A68';
wwv_flow_imp.g_varchar2_table(29) := '7943627947506B444F77693136596C37754B4A514E654A6C79354E5043724159734F71434557574C31664846476C384775584B57533661545A566A54566C4C6E6F7346426C764A747567784C4D6F7667442F743075583445782F5355486B4F494534564C';
wwv_flow_imp.g_varchar2_table(30) := '3674694168794344376D48525566334550714448546867326F6C78784D466A4F73764638306D6B753743483569664A326C6E41794B394563305A78427974684F673659467964756C6767524A30724366417345303254413075437A686F41516D54525A4B';
wwv_flow_imp.g_varchar2_table(31) := '415A6B5736595A4E316774417977515A48793853686F4A43356A6B6A615765626269326A434374646F684A4E412B4B6B783566712B4A4A6C4F5A703977624A76744D73733275326568347544416D794B647279303877525354784E5370592B49596B6449';
wwv_flow_imp.g_varchar2_table(32) := '51504C4B654F4A326B68784E5351637944654C7949436F44626371447544676F6C3674774759714761534B55544C67595266576330694D496F2B6B69534A716D546B6E59444D6D4A5357463830566C4B2F51594844437030672B79486C476C4761504930';
wwv_flow_imp.g_varchar2_table(33) := '4171526850774353676D51704A6363727859776E645169424535486D3355366F624B6468463456466158526E37572F2F2F654B3761792F637266414B703349636E2B4A6C6B6355676B544450536D77484A3348776B376B49725053414455676774466757';
wwv_flow_imp.g_varchar2_table(34) := '4964674B4B59376E34455A2B503864794549697869465642464F41534C43424B64437868346F455453514B52786F4A777838377152524C4C67377944506B476B47316845466C4A6C5263544B5936397A724D6A424363757173496F4532656D7845744C70';
wwv_flow_imp.g_varchar2_table(35) := '37595444384842436A3052573467534F632F4F59787A6F387A346B6E51464943784D53454A756431795A7A4177346B6F73764351464B5148695171774378465245416955783834625A4267526573784375564D7344655A63543741694438475142514E79';
wwv_flow_imp.g_varchar2_table(36) := '515A43455643524A78433447504231426B6530446A7055674576514D754C34516537562F50456C696D7A68514B6E5139422B574668486779486C5577455351454964437A5145593479636B5070497A7342665949696244436459534642676C3541766B67';
wwv_flow_imp.g_varchar2_table(37) := '374E6A7A6B43776B5271506150347845656B526F4B53457451705069795068466D6E454A2F7735753470307771444D375A5A4E5771517033384644424D68616452777432484D6950654F41524469684937774669772B4D677831694778416E6679444A47';
wwv_flow_imp.g_varchar2_table(38) := '336B614F42547474794379485877506930497351426D6555423153344454736378456F694A78436F5670366A4A6551623930744F375930422F59476D5144706535594830554D4F3046714457594B566341356474486D4670446F4176674765495156685A';
wwv_flow_imp.g_varchar2_table(39) := '434549523676514853746D45467448646B424D6B794D324B344755565941484B42617A6266674B79536139794C7367744A3349704F3047624932337542433645454779546E655671637945576A78316D6843677543626B5179394644326C61435142732F';
wwv_flow_imp.g_varchar2_table(40) := '443631466B5357757A7666416C54364F526F462F617752794C616E45686232303353412F4A59505A61562B4574596E6C57627561614C45494E44414935663349626F47555556697532555733704D486962395A655144333544514E662F764A753948744B';
wwv_flow_imp.g_varchar2_table(41) := '64344669464A736F484A52646174513968385A356C524337596C66526D68636B53556253704E596A2B466B587938596F55396E634C5545726E2F526B3057365A496E49493437524F784D4E39454F77306158567969366172793349536B4B414D4B6C756E';
wwv_flow_imp.g_varchar2_table(42) := '4353656F455570562F79534A4153746E5636626441446A4B6A715442703842416D4743483669496E6956514F4E4E6946526B6E582B55756E684A46554356486D702B78434641436E556B4E717159546C7831736E6E6D69474C444670575355675137394E';
wwv_flow_imp.g_varchar2_table(43) := '6652656E544D53536B30516741717370734B504E44526F595A6B56676954716A63413431454848624D6F306747645566546D6B6A495A7247597A6154306271484B6E4378545A784C6F6D564662494C6C364B564768634C6C5366775A6764552B5A4A3157';
wwv_flow_imp.g_varchar2_table(44) := '316F566F456978626C3867536C7761656B575332414851564B566679346D515735427379327553425A49523177335652346A30514368492F4469736E4138426A555A435445637333436961694E6F64624A53375236414D7344735171377258704C304347';
wwv_flow_imp.g_varchar2_table(45) := '516B52523743727A3638424F496D303444733941307A5341366B68773131756E4C564935454832512F2F756F3849594F51624962744D707A744E79554F55412B32714B4F74515642585659424F396A79445771594A3237436A3163583739534E4D414C78';
wwv_flow_imp.g_varchar2_table(46) := '434B39435137526C6E4A323249784674707045615968545642536C4E485151637A537749624F67427151437A2B7743516B6C4252764E51517347524344447164446451616C6431736E653251472F6F64776B6C45706B6E72634D69722F766F6C454A4738';
wwv_flow_imp.g_varchar2_table(47) := '784E6F3943326B384777517A384E376B487444756268775A7A54414D31646E75494839446B6F774A654C2B504757446D5572537645634435474941386865633230702B412B666153546A6B4C49487366314B514651464A492B3431304B367741302F6576';
wwv_flow_imp.g_varchar2_table(48) := '662F6A5035714B686D663333663337463668765362614441525335667575583874537558392F56626C7458524F58662B6876567231382B5A6B3034526B6F78632F496E427967585A37377A34597542574E4E6F2B4A30455361503631397A2F31384D4467';
wwv_flow_imp.g_varchar2_table(49) := '51696B53766D724671765872317179364D5A584E6F3154726E4C6D726C7A3079504A497475585854374B307358375A7577394B463778313469306B7469582F69316C74523574597A643579313436797A7A6F726B4C456143386A3041754467476D4E6869';
wwv_flow_imp.g_varchar2_table(50) := '566A4C506F4C6E6F6676516675494476685849436D4373615255426867422F68414534423470614C766735555234383232426B6B42774669514478556157507261466A6E6A61674D3449636971716A4C786A67554F476235704130694652736443306B48';
wwv_flow_imp.g_varchar2_table(51) := '596E4955344C49472F4276676C454A563537774F686A454667685131477270735545512B614D5055775254564553464445324479344D564737344F51572B51674E6874334E52446D3543566468334631574F69414F5874783443464C692B427134453134';
wwv_flow_imp.g_varchar2_table(52) := '7075586B6755796F426D566E4264425A4C5A5A74597469346B464130534D6D4137514D4848426272534A53437A324A556F4D3841556C734F474B796A3936796368474E514D64426E642B2F65753376335A56743237345A2F555844784C706551646D6B4F';
wwv_flow_imp.g_varchar2_table(53) := '6F6F415779644A4F32514C4A41723832757547354B48536856415477524159396B58634A72314A5A54796A37557752476B5957494E45416350425855646B73674645345347546F71795A483747494268485563424E6B4563445947756745702F354F4143';
wwv_flow_imp.g_varchar2_table(54) := '676452784A4141516275774E546B4234516F7254434A68324F2F5368647250443948376137476E76596264564B6D7A715851655675786F4647665479424F617955366C4449346944626242446977555369416F616C6863352F4352492F58726E5A497372';
wwv_flow_imp.g_varchar2_table(55) := '754D4C5242733554636345376D4E655770355263474845492B735878364C513745673838624F4E6D4F3434744257576E36485A65614D667345415243424E59425278516C495242642B4174323979367A4F7368346E594945454F55415A5469373633644A';
wwv_flow_imp.g_varchar2_table(56) := '504F2F6E6B4A63584F4F51737A556942486677564B7574746B55737A4D50612F7159697961344A314E65516555554255675542746B494A57494632674B7959754573624578524B5842436A4A5359526941442F32414A4432594A446D30465667414F6F63';
wwv_flow_imp.g_varchar2_table(57) := '747139364B43794C5530626175397343527270324D2F6F3453456445433258336448576F797A71453461437A6849536766437A7441705A4E3446686165734265574E5367642B576465725978412B325076624A494B786C6B7441793455425764506F6546';
wwv_flow_imp.g_varchar2_table(58) := '486F6851315143716866494D5348624B52646752794344765652752F4F7A786956374F64714E4D5A4E58694D696E4B4B2B67696D634D504746725232472B416551643868326E76494B4A5465426C6C3146514475494668746F41744B5057416634454165';
wwv_flow_imp.g_varchar2_table(59) := '55376B504853434C616C2B485239725A4C554C32654678506C3764424F70515541516A6865466D774B6544414D62674B4C51317867703643394B4267684B332F42614B52546742476C46393844745A723467576634504C783048716A7267597630495869';
wwv_flow_imp.g_varchar2_table(60) := '4D6A7335535249684F64367455456A4163316B34686D5974554A577039695256416C6D7142304933523875674970766B456B55536C4776344F72596D4F6D396A48565A514B51536B654E61473752524C7348592F4349436F336834426E584A5550786E76';
wwv_flow_imp.g_varchar2_table(61) := '6C3546542F784B79436339436A32385841514563704A5367523569695741636D7542434776684C427970416866414E54705059394456463757436F746D42593157416E646946712B614C387061446964346950494B6C517252576F726F78306F39677863';
wwv_flow_imp.g_varchar2_table(62) := '74745A72574A6E4F44656F4479324E366939576373494B4A78446B585A7273475456575A7436336B38694A44457A3071502F50386561495558317961677A3955336A4A6A31743671364F325036666374463969505A69343450395065525A71733165666B';
wwv_flow_imp.g_varchar2_table(63) := '6936747A43506D6249486459476A352F6F502B794D35746261425A705076487638423434457144665933796534766A7935673736773376474873587247797445642F724A7235413433434D79436341434335684E7A45584D39637A743149597278414551';
wwv_flow_imp.g_varchar2_table(64) := '7843732B506B6C37663441424642645946424A554B416F51556C62643147655A46596F4C4F49696D49397341574C564E66494E416E496F545944695778414655486B41414C54676E304C3633584B4B706C627352636D4247676C367A37366678366B2B67';
wwv_flow_imp.g_varchar2_table(65) := '6543535A79694B302F38777A30585666323147736662643472747263356F33496F6C3974396F6961464379474E564F526D774F472B4B7559776B6330726A33684E31697462393759362B456D6435506D556741566856326D573962647269416E346A2F33';
wwv_flow_imp.g_varchar2_table(66) := '55396B422B4447473351476635654F783638436E4C525A456F434B3666416D33434D7A7477702F31745554306B4F56704A6178564C5A6336426577612B35635178356F6533374B35466B746150637437654678342F416D55656E7244427651396B4C2B69';
wwv_flow_imp.g_varchar2_table(67) := '356363494A434C746A554368313153715A79325444566449356249444C6C39474F614E4456734F656C4D3856434F6B2B3374335337444A31315654397465397766695873466C335372426B656A66567068666455424D6E4C426257454A58554655694575';
wwv_flow_imp.g_varchar2_table(68) := '714C66366863475A6F6C4A3753724B386B6F7333584C6F6968774970776163683261743558584B6E704F6971456368546E7069774565704D4647723455755A466C4547586F43396944572F45392B4C2F496F764A4C655366324368374873574151507336';
wwv_flow_imp.g_varchar2_table(69) := '424B513158496D41614F6A47746E4558716C5944526F63713741654951356D2F417832336F55356E6A39744D6C7A78524F35304E51303763544D6478527A57704A552F517068626D706A43706C59396F556B73534232366569416C324F685A597A4A3277';
wwv_flow_imp.g_varchar2_table(70) := '4154614A6A746438435452696A3874386D6651353944694B426448696A6D7041544B4C395178646177634461612F746D726B4473334E364F516D7134364E4D365A69316631424F537A4D4479375A492F4444424770417276364B67337051327932747378';
wwv_flow_imp.g_varchar2_table(71) := '79483042494E6337615A446A305057326B76594F5775536B7362382F63597363697A387966544D5A4E2F5A5A423861394D335979445431304444755A35376A4D5A4F776A67435865686C58355039394A6F374934747638644D79717A2B484D6E6244356C';
wwv_flow_imp.g_varchar2_table(72) := '4165757A30374366737039345230794E4C6878364230794E4C4336685266323931343147444F4D3951774D58685977305373786375486777493452366C71794974335957764D6B4B306A323050515554633858666E7267564478724B4F3254476D324733';
wwv_flow_imp.g_varchar2_table(73) := '755866636A49632F383437593864415662394F51646A2B56644F2B6349593073655875574E50797464382F30444572564F32703772763364327A5379417548666E705556644B2B33623564304C433976317A4A3575422F43653569725472596667755766';
wwv_flow_imp.g_varchar2_table(74) := '62424173544C49496E6E792F6738432B665666743237653174575866766F583333586653665173324C3131367A64313358334E33344A3652652B345A59554250504A5465357748464C7A6E70464A2F43646E7A53535433764546507A535362316731505A';
wwv_flow_imp.g_varchar2_table(75) := '70512F3246356F39746239514E61477A5557684B55585951522F45676D3857444F4D7671474A443055627946396F4F4D30366C337A3030333061304F62597139365362612B7159495059724C30425048756E63693144615032475736677A774C5A577069';
wwv_flow_imp.g_varchar2_table(76) := '4373776975307954656164694B354D4F397877386E6B413570474A6650354972554272392B6F4C745A77344F795572767A494856533539657457356F7A6E4A524344646475574C56714574664E6B77726D677A317A68696566317531742B424F5A596153';
wwv_flow_imp.g_varchar2_table(77) := '4B786363795A65484A4B71566A5A7650332F5258433062534B616A792F743737313239637465626D746E595733594C624D764D574C46743455336465316470792B52732F4F544172615A69376A75534D777A41796C50746A3547394A6B6D6C6D7173774B';
wwv_flow_imp.g_varchar2_table(78) := '5A69647A496253634B3569726D66637A4836525553453546687A6F5A4373564A684E425166565446626B6B483357633639484561553646596D455339626D70476361686E324A34396E715150684A677761555676494C783979386168326159523663344F';
wwv_flow_imp.g_varchar2_table(79) := '447A3835756D6E52794C6D473262526C654F48616E6E364F3237523264572B66376D34766C5563575037317154662F4D634C4D6B6435652F7449766A566939625643684A5371576E622F48775066506D642B556966714E537647555A4959766D7A656E6F';
wwv_flow_imp.g_varchar2_table(80) := '354D567175576665334673766A7956774E4E3658326234446464642B56617546586E522B4A4E486474585435317256504C566C614C4C6472657137376F327658505846587065725838716972592F47536A5373666E54732F33533748346B4F4436316150';
wwv_flow_imp.g_varchar2_table(81) := '6268785A64313548522F76777774584C37756D663064546B616B304E446A32346247562F333578634F6A5530613947436D77736C723739707A6344514862506E645551545636713132394131676472544B42304D6A67514361774B424A594541384B4E37';
wwv_flow_imp.g_varchar2_table(82) := '334E3542783334324D452B432B725149335966473844446567373946504F52633870665153793836796B6A5161652B6F303935527039513736714142734F787042366E54446C4B6E4861542B4742326B44686C2F765032306939527046366E544C6C4A2F';
wwv_flow_imp.g_varchar2_table(83) := '6A4335536A446975712F6D5A4E715962644A754B37536B31753648682B436B554C31423974755267656E727570316353394C786B762B4E775247692B2F3671645A383859474A6878397337396A594F72646D335A574B355779787533764E493461447355';
wwv_flow_imp.g_varchar2_table(84) := '5652393067333251502B67472B2B423752384C47387268666C444D576541487A50625146505150305749792F64494B6A662B5330753953373553353177694E682F616464716B36375645335870656F457832485138476D6E71394E4F56322F5036637232';
wwv_flow_imp.g_varchar2_table(85) := '5A534978764837636C386D496C376E362B734B4543784E6576325048432F626638576E2B4A2F4C502B46576D6D566E4C584D3773596169766234495865684874715733584A4C6A624E7256567972326F524B3177744D754F306D36746D43384D49744F67';
wwv_flow_imp.g_varchar2_table(86) := '3354634E4D2B4351646E694A5642616C7971567169666F79706273524842617178597151792F4F3256613967323750547562787055644E526661333445686F79504837374A64634256506155756C4753697863694E464244795869696D77594F49445463';
wwv_flow_imp.g_varchar2_table(87) := '576B41794C7957736949375159715248724C69565830684E7553414441414C7873696F44322F46657A4D75556C6C4B6B4A534A5269736F41726D554E6B4332574570522F31565237537157635850446D2F486362575A395748693344482F65564E35524B';
wwv_flow_imp.g_varchar2_table(88) := '4738706A5838643972514D744C514F7459312B333933683750756B314E5558562F63333451782F437A583564746471542B61796A3239714B717171624C6C337867727745486F48366C4F46487663376F4F6649544D61463533496838514F564256344D66';
wwv_flow_imp.g_varchar2_table(89) := '4277646D37494C46384C736767526156527375315865585245757A527832412F6F32566D6132315836387757324B4F50776436754D366A6E572F4848362F57734D7A3771743059686B354773786F3234554E2B506B737142332B376239787A7548767675';
wwv_flow_imp.g_varchar2_table(90) := '632F55392F766A594A2F463533336E6969536553447A3330554A316E56754B764D4378674E7A2F6C475A705133424F66624F61374133396C374C313478396A64694C7672726731333359572F45687A626A4C2F534351467630764D4E6439466B324C702F';
wwv_flow_imp.g_varchar2_table(91) := '66494B786D43497A36466931442F654F54317154446249487563646277684673692B693164512B3966796F6E6558484E3871573966655A5558764C4C356B3832443548452F4E31544F636D6E5537506E72707A6B4931396555666552522F383457536D64';
wwv_flow_imp.g_varchar2_table(92) := '584437482F372F2F784C332F4B52784D4534686F4552716A4B71534661586A2F482F416B697464646167306E6237684A304F596B4975467243744E34426543666B76504F65376A324635474E3358654376754264307A376E306F38755961595953397A42';
wwv_flow_imp.g_varchar2_table(93) := '6E4866795237627150704D6E667A78727A59516635456B667A4E70653932326B76484D34585863796C353173756E4B48387873766E4877614933775968327042356153542B2F49704F4E7073385230363174592F726247323863485836597974425A3142';
wwv_flow_imp.g_varchar2_table(94) := '31476D4D70443077506835616C7A2B766B632F676C304465647A425A5A675A4936364E326D5233303566566B6F3976306756437668744745675031422B344A322B4F50653967567462517661782F34653934627A7A633335384B57317A3135694833304F';
wwv_flow_imp.g_varchar2_table(95) := '2B57752F7557544A6B75346C532F424C454B5732336F6D4B486F5639446D4C57316B4D38564B7139424D666F555469752F586E744E372B314B743330486D614B5042656E6B5766493773764F63334666506176514C34396E39644A7772726B3539336D61';
wwv_flow_imp.g_varchar2_table(96) := '31645A2F4F5035732F767152624A5A68384B543870592B5674776B49637354386A4833647A73315273744849777146384F575061664F6B3038656B7735766648472B6F3065504F79696659326C5877376E376E7935506362574B414846703339496F7253';
wwv_flow_imp.g_varchar2_table(97) := '396D5636345254304934456C6C7457653975384F3567757143517063304D764C535047624A332B6D69396D314E325A5A7551376A78715833726D685A754774454350734668592F5057557A626D3344592B5072567A46344830352B796B585572635A4242';
wwv_flow_imp.g_varchar2_table(98) := '44504465684555736967347A695A334B38666273344155483234445931766D46795561677A757168567143545069612F64655267513046797876416B4F77484B4832776F4F4179487A6D42475468794848716E646E4467615858626B686E44436D50536C';
wwv_flow_imp.g_varchar2_table(99) := '49375032775755754D33306E58755947787078474753654478684D75316463614D4641593137567058394D4266574556304D6A67386663366C71326167547165744E556B5738636A635072794D625257684E36734E6146763178347A74323362396A3630';
wwv_flow_imp.g_varchar2_table(100) := '72766259356569622B4E566A71707244746576524E5238383935787A6A4C5050506873747665414375372B456A6D7333364A346A7A464E326A39574C2B50475644794F2F5264563673326857653048504C356653525772737A3166534136674556645342';
wwv_flow_imp.g_varchar2_table(101) := '624373436653324A63393530736C397379714B386B437359426173586D585A535645675966697366515A625A6A3878717365414D45335167493034506A627966543861645934685071575459635978653541634A6C7554547659694F4B4A52544D354539';
wwv_flow_imp.g_varchar2_table(102) := '7141423567482B78564551767562777A763554316952694A3771374D7246642B4641707A3770446D346E6D3171556B54413572423637437450632F78724F626A646462466532554F4957726C4538537761736F5963774C42367149374C754A4656685259';
wwv_flow_imp.g_varchar2_table(103) := '2F66646F4149344557613839683352426F6D4D33696C4A372F5A736354336765382F7950667451626962734568486C50792F4E356755583434334C6D75746867494F5A726365555473794968684A4C4E756B64544168474C78507639736B767A6848324B';
wwv_flow_imp.g_varchar2_table(104) := '697542426D69483475723279696C455369554A496B734F7134594B454F643432716E4A71564F4B544C43643766577153353132474B69554A4B3370304F6A61452F47594A5254726C466D2F594B415A766A4C476F5953666167336657357A397962416478';
wwv_flow_imp.g_varchar2_table(105) := '72705672396354504942316A475878393761753157394446364A4B784A72787A374656734A662F357866333761373032586D727763504B496E47744347465250496755686C562F3262753246507734352B3746663446424858312F483243396769312F74';
wwv_flow_imp.g_varchar2_table(106) := '4F614F33747166336A4237596F387468763675337262616E726265334456336531757659707962476B2F715952637A6D45786C4A4F74477536506A476C335A4F70786335726A476F767A6E52767544674F516B717A42417A2F30516C6F2B41336F506F4C';
wwv_flow_imp.g_varchar2_table(107) := '5265644B7175716E5531314E51307065532B63717576686950525A77476536686E3956657548736177764C2F3348303336736C4C7A61616B34784B3365664F58647A76394863575753634357525A41375734385456396178346A67716F51464741385930';
wwv_flow_imp.g_varchar2_table(108) := '6B4B584E4E594C2F4547534A58727467783962427777446B5A5575587253564E3350614E3633763665484857304F7A564B37367765476D754744504E7672354841416B737A78667734746E7A5669362B6132426F4C68754E7A5368635631367863454662';
wwv_flow_imp.g_varchar2_table(109) := '4F316B346332696B6752387A4D3563416153684D505039676D4C675359434B5038366859574C31752B2F7250444D31716176613164793559384E546130646E7A6C335958637374586256783156376D7136656C63336F614A6E646C385638667779497152';
wwv_flow_imp.g_varchar2_table(110) := '477A7537786C4869514C7872617076447563784670386776764A6F4759434763476E667747332F3630346475416B336D37422F2F2B4B536A3730734C68612F75655034716632626D6C5A5550486562484F334F614F6C77446A6B334C63376474416F464E';
wwv_flow_imp.g_varchar2_table(111) := '7831643345756171593875642B414779456B726D5A79496763356C57364761527031696F5145634B76546A6470704943644C625132554E2F4C46417477446E454439512B6A546256507633354E5774584A474F707A4F7265336D676F6C73687835566133';
wwv_flow_imp.g_varchar2_table(112) := '747A6B38702B315A3868396A6C6455722B36354F654F64586D35646E326E65305A464A74795631656632346746572F5943795A3876616C33384E537A512B5A31596D517864666D757A784870654837585A347030484D434C67356836646A702B3448416B';
wwv_flow_imp.g_varchar2_table(113) := '35487052376D6854522B356D575979323035456146335863324C375848737645684E32376E653564644E78774F384973367A3038496E57714F4354617A55647847502F3663535A373650505A6252417864506A54633466524C7352456A30413748566E78';
wwv_flow_imp.g_varchar2_table(114) := '61746F536B6B667A6A45633343502B3445736B725833356D2B42664452796E49543768506A6F3164652B4D72727A69326C44767237307A5445596D44487077514A4E4A2F304A4E6F657039414E3944486F6663646B726853572B426B3433436569445064';
wwv_flow_imp.g_varchar2_table(115) := '52356F7856454F41524143486C4B68636A7944417A6F4363365944523059725A7537576E5A2B7646644E4E625846736F72443262626F3553344F2F5759385047717365477A65452B2F5350546B77557067633656304C6868584E6D656C6D436F464C4B7A';
wwv_flow_imp.g_varchar2_table(116) := '4A6357725A5672504B2F6430646F654372476C3252685A4E51307173774B4867614B6D6E574D713074764A434C467A495870677278514B68513870636D616238452B4C544B68395679365A526D4732505032487A716D4D6E435548664F4A35725544634F';
wwv_flow_imp.g_varchar2_table(117) := '793352686370383444696651617A7532624A7731322F44487A6C7934344850724E7977634F632B304E4E65326B63576A7066544933466B643042336E69715562627073786B45674A674154617A79614A624E667946647657506E56586F5A6A5239477A58';
wwv_flow_imp.g_varchar2_table(118) := '5239657358377668336B715056376D6C7451564130767962692B554F43672B473770773333426D4C483852544953624C39423656766F6630336D6A69726145346146717043524C5047466939374741534E7A636F334E642F437957776E73344D44613974';
wwv_flow_imp.g_varchar2_table(119) := '5758414269414372773732414A486F7147375941576E476F334E7A664E30376C6A7A53496E4D32464B493376474A7956374667624B6930646D2F766866476C69334B7A424939567039704C3231434563786172547373466675335A4E7A38573144364537';
wwv_flow_imp.g_varchar2_table(120) := '767A454E6A726C7A33727A7554624739653548337763506165642F30654C344F6B365A546C49324164365A5269457473364D4A4D39663761576444506E765452714B6E316A4A4F4F44743833685670796B6B4869585963724D6477553777796571766346';
wwv_flow_imp.g_varchar2_table(121) := '54396C62677166773963437078754E6E543263383370474E615A50436F576E5A426965453547335844414A5747707947317674305131794F624F6836355A55755233634451544D503377344966426D7A696C6E486247544F67504C5A4577554A31505352';
wwv_flow_imp.g_varchar2_table(122) := '6278524B522F46713059594A314F306D545231766F456863334E5A3278795061685939546D6A5469556663633631414832327459764C6F74685A76636D526133525A436B4E6732506F4263357447516578317036307056772B384D745378625735714A51';
wwv_flow_imp.g_varchar2_table(123) := '326B696A526A79416F734635745A394833556D4F44656774616B493355484E636675586E50392F3972312F394F6234646F304B75757A755443625331476848444658516E4F7A704931377175654D4C666F69577353444163622B2F75364136484A6B5653';
wwv_flow_imp.g_varchar2_table(124) := '4E5433655A706D646E596D457631564E6D6A52534F6D45596C356A6D7066613277514D544E74587A6D52644F774A71616341794E3436624C504C5664776D3254544A6556617334325856597270645345366249444E59435A6B4D7450746C6E79514F776F';
wwv_flow_imp.g_varchar2_table(125) := '54594471524836425479625368676D616B70476E4E736B4F52453255747257534875594C6A724553716956504F62495870637235556E30434B5067586A3258572F51745A744D344C686C33554E4B6D55326D363679654D6873747644456B4855574E486E';
wwv_flow_imp.g_varchar2_table(126) := '307A695A645974666C2F79636841575A2B6D30547A47496A434671466748462B7831774A637877527A79374F2B5A4241587933675876694D6F4E4433556A377A415A34366D64562B6C2F435A4176574B5538785A777A7031587A32327A546A4436384D65';
wwv_flow_imp.g_varchar2_table(127) := '493633375655746F446E5330593279365A636D6A412B6B6C586D3174566C5776776775536E316644696F5A4D6A744E355967523577583658672B4D736A6B636D63696D4B53496A7031675442464653424F7065366654456A4646543957737A64575A4152';
wwv_flow_imp.g_varchar2_table(128) := '6E562F4D73555866674D2B45492B6A54664677725277325A32394648305563502F4A676B617276776D542F3732657261455072615478696D3454665669613967557378533567626D56755A54304B4C3842692B6B3659753030422B62566C6B6F46323276';
wwv_flow_imp.g_varchar2_table(129) := '74617046642B5769556152314134316A504659565A495546473267756F4C4E5830355671735A784D7061747041545A435561432B6358516D66736F4A686B375A77714B4F467A6F796B6D586139415349536E63485063684B3848367A554B487564616166';
wwv_flow_imp.g_varchar2_table(130) := '5436524B4658535061575A474D6972663079503638336E43653852454D4B4747596C724C46743730614879544A7A4F5356766A65586B484A4C47727A4263384C2B74704732757A34536E7052326A54526768616B5235715652444175656E6E69704E4553';
wwv_flow_imp.g_varchar2_table(131) := '5371704E55533270523575556C6C414C7656416F3041764A5946494E4A4452764C4A7364796D5A6A766D43774E525443567A5133383270364A4F4D4C374178474E7149574C5270536B38474536425A4A4C696449496C733971797243387A4E2B61796379';
wwv_flow_imp.g_varchar2_table(132) := '4C447644765832384369476D655637516D78354A713377316D57746B76796D694A5A476469505073496A7A624B375945375578423870466D4E65456B767A773771377437566A595A617155357164666651654D6E336366324A70686F37594A7434786253';
wwv_flow_imp.g_varchar2_table(133) := '56745554502B5A3443645A7147665441643135373766566139446834666C58744962545275756D44393935622B3566476E484C45672B396859737836356D6F624830496D6A2B685232644178624A644B4B322B50696A684F6C5646734776793452325736';
wwv_flow_imp.g_varchar2_table(134) := '4E456853647064574C6B4563495766556B5544426D54634F5A487535376C455A647A7771305773644C596D30573348335A386F686A47666A59436E546C306B6E57733656754A42626C5669526C393142446153434C4B6B5274706C366A434E3374612F71';
wwv_flow_imp.g_varchar2_table(135) := '746B63576D7168627135743336627861496867725A694932484575593941552B7771364E72557257586B75756975473744642F63564B4931355047486B6E6E326C37396B63386D517632306B4E64646E724B497671746A4F7867694A47434E2F4B473032';
wwv_flow_imp.g_varchar2_table(136) := '65574F535839525A46727539586A646D5756333053776B5763355972476F6F474D6664765350583646564E56464E586B4A5635326556437139356E723466644D4C2B4F302B306C2B68696673597A677458384C6A64523863373949524D77586D4F2F2F55';
wwv_flow_imp.g_varchar2_table(137) := '6555536367726B68316B7732504A35437234636A2B644F64664E763259586A78354E4E34436E68356B6B6D39376C41775375634775493838412B314E5A674C516435615A425344587A6D4F75594B356E507337637A337942655A62354C764E767A482F52';
wwv_flow_imp.g_varchar2_table(138) := '32532B5034466E676F325133675954326E4A645779686D477363642B30796D75336B71683367724F424A62466845426C4A6C576D345935533271346D472F73365A7246536971736E556241424C5163526F4D497231476D4658714A346C39612F50576C6D';
wwv_flow_imp.g_varchar2_table(139) := '6971382F4B31576C5A77314C44355558634A366F6A776A5A31637852343576676A41765336774D6F5A55656777394431474F4E3546657078494C746F2F354738494E5352724970383670617A5659315438792B714F6C455764776C426E51307337476248';
wwv_flow_imp.g_varchar2_table(140) := '2F71444976434A79732B4B734A794330726543523679315739676F7553664A4C53786341557072394B35636D7565575A51633454354E7557697870367636706875525155676D34324E4A6364657A37494B55313877497444627154685633555851546E57';
wwv_flow_imp.g_varchar2_table(141) := '4852444354537A57446E786131776A4F772B4F344C4559752F427364304A7972774F74424D5A794368343039717168594846797465704379724D716A665771483467767145592F4B36577032593170457274704D7855586B6A75306C6D76386479336763';
wwv_flow_imp.g_varchar2_table(142) := '6B43524F317352494B74717559492B72636C616267463034645554504458517064764E42447873306B532F49717175514C384431624A53424A6F58314D53776A67564E45646D41356C48587A454A324B45374F47527952386C49554352394E5935465168';
wwv_flow_imp.g_varchar2_table(143) := '6C314E3953426E71466E7836502F4A6166486D31346C4D337A794B503459363153785469555A65766C725575464E4C4F32714A366B567935636B4355335842362F67595A2B39534E5A34744B44334C4A6E7345357170386F715856646B6E6166782B5158';
wwv_flow_imp.g_varchar2_table(144) := '686F6B337745646D383075495151516247776638434155446771476E66536158794D72494832434E325951676A6B674B386575717A416539524D6B6E4961504D56504C3933464D31756E5A714274564F305767616C6565753858637336587349716D3370';
wwv_flow_imp.g_varchar2_table(145) := '443444652B785530447A32415873564676492F4F50484B4539304A50763158357272315675666E67643232336E6E356E387651376B394E395A374A35796A65776364667056794E50767872354E75656A70324D323379564A2F43766F74565536757A644B';
wwv_flow_imp.g_varchar2_table(146) := '4A4B457A5366754E49753154414B736D3863586666786C762B666D58786736674B343332676433345677662B41322B376166506D73515034713672524D6173787638474544574970637A467A4F584D566379337A67524F774F77704A4455315963423044';
wwv_flow_imp.g_varchar2_table(147) := '376D54447247504146656841696546766D41576F41546435614B78447A6266484D6D793848394268707935616867525563666C61323443733357342F775337524C2F70453165334A7476336665303346306951542B2B3149577670656E2B444457424D4E';
wwv_flow_imp.g_varchar2_table(148) := '33696370626A3937395858587A62396D353358485952665A684A737257644D564D4253507175756D4563544E5A6A446739536D47364663394C72665043416443486930554E4532586853454959766B737432794666424248384C6C6F484D7576716B4F71';
wwv_flow_imp.g_varchar2_table(149) := '4F73762B48324C76625765794A324142737172555069676369306A636D322F5758476A2F2F7A754F417037786B592B556171386961322F64746A694D483675502F572B7A5A2B424D4F4D7145783637416D47326A385A516353305239574A6B663931644D';
wwv_flow_imp.g_varchar2_table(150) := '4F344E6B42627536433551446A456B586A614F487877344E522F743362386C46715A644553797937446F6E727372476B674952454E4C646C3939576A485345507A3375436E5A74653239515A704965686A744576516F4E734B6D31356330757053574439';
wwv_flow_imp.g_varchar2_table(151) := '3957742B396969684E4E6C36384A72614768714D482F4D72626B2B49726257472F42374A373563387669623049344A434872666954774A4453624973615A4C5042787334636B6E2B3834477A564C396631646732525861754B484C753649467654415461';
wwv_flow_imp.g_varchar2_table(152) := '33324C59522F3447634B4F6A6D3161597863776D5A69647A445850624357756A6A6F376F71486A4F4F41746666392B424B707949717048386C47706C6576776A445056303757387732496F6C3145367855476D30325350726965376C5751563531613362';
wwv_flow_imp.g_varchar2_table(153) := '585271766476796471724E4B613677704A415663664D387164757731576545564A647347516930595A467537574A4D565866674A55506449494D6A7151534561457568584745446634374A55766579692B74356E4A576F39457974725655683631787237';
wwv_flow_imp.g_varchar2_table(154) := '437778556E5A747A4A753856645A644832396F502B494D2F6D765A324D645A423536476145656843796A4B7176595861347A6D5A4D35547A2B346D4352465A52756866706975375239626C5A7A734F4A50713332416D7253437A7536514775544B377348';
wwv_flow_imp.g_varchar2_table(155) := '424D6D4C517671356D366A4F742F45632B674547364A636C6D5732785147386C7757477139586B74726A65457557414142664A30427151703744746E6E587A723257515867354F75594B3263354A42777373656A44334A666D4754504552696443544F64';
wwv_flow_imp.g_varchar2_table(156) := '7A41437A4443693869376D6132634E38696E6D552B534C7A446559487A47387076644F43466139556F656B6B5155435A35452F616A49502F596346744C3976574E6A57512B3858773444585858504D2F776E794448696964652F66593341396E526A3732';
wwv_flow_imp.g_varchar2_table(157) := '5374654744576A546E367A4A5A684C7630322F336D457772553257476D56486D484F5A53356F504D52356E376D6338787A7A486659583578304A64382F70535A66764B6E675862386A3244336959384F7666776E792B6A7669722B525548633050506D6A';
wwv_flow_imp.g_varchar2_table(158) := '497263744748644D504E6D6A49656557476F364D386A6A575A426D4E38544D4A515072447A48726D624F5A397A4637626B2B42772F375A3344576D6D44334E375939394669496E65504D776C447233324C6B484C2B726670566D4566395354334F627872';
wwv_flow_imp.g_varchar2_table(159) := '4E7062363539657178755278342B35786F743852616B70324A627053715543544F39596644376645413062555A536E4E6F5A614F5645636D3256794965384F5647555A54554739796932686B49463171386774385144653070704C686B61576D514D4962';
wwv_flow_imp.g_varchar2_table(160) := '435439555458543533614951394856487455435434412B30574E334E476E50494F364A4C6D4D75594A77434E50587343316F56442F466D53682F6D7A51497566374D3553504E53644257494A645863574F6766504A486557717045556A75544F6B6A7947';
wwv_flow_imp.g_varchar2_table(161) := '4F387578744F36464C6933594852424A736F566F3053676D436D666F707167626F7458506867525730774C5A6F456861576A67686C4132702B6D795848737947524461524A474967473543396E61594542445863427165774F424C42524F557374796D36';
wwv_flow_imp.g_varchar2_table(162) := '2F5A49702B54796936625A346D634F514D69647A707473555044354A38596644626547776F6272646C747439484F702B77654E6C78574132344A566E75387865552F4A363459456D7033416F476D45566E42784B304D74426C7A5A625679463341746653';
wwv_flow_imp.g_varchar2_table(163) := '536D6941356B4B7A6B65774E644164344C6D464545577358546F4338495174794C55422B49466334466F4E637379624E74552B714638666B5649494C3455776B6B676D624E4A75572B3642334D45396B7A6F706A7A573131624149306646753234475567';
wwv_flow_imp.g_varchar2_table(164) := '2F564B674F56435570446C656961624655526C56646B53567035524B434E774D4B72384535337356715851462F5A6345314F666D373533764167597179356147502F6770326453774C794457666F4F774E2F317A334C6E7A36717678556E756D314F7957';
wwv_flow_imp.g_varchar2_table(165) := '724A77557673337A666D586668683130687835516466484C34597561465733646E665A7634596F56545032626A493573646E53614C6D594F7334725A796C7A433348693857737A4A4638714836786676657A646C3869476F66384F374A59385078796F37';
wwv_flow_imp.g_varchar2_table(166) := '5473574D5536646F73716C544D6330555132647571332B2F59664C343655626D4B5353687865682B564D4D4C386333343238524C7A694E665A4447372B47696A7161632F354844365177366E39454D4F687777696E3358365577366E502B56772B6C4D4F';
wwv_flow_imp.g_varchar2_table(167) := '66355366636A6A434748373239446364546E2F54346651334866346F762B6E673648782F6A57385A6E3165614471505461526F425047624A6E767A597472316274754262786D3746462B5847666F324E7356387A4D63436A76794F503432384448705559';
wwv_flow_imp.g_varchar2_table(168) := '4454545641424D4872617A437A474B574D6D75594463775A397379797530424465782B7A6D2F6B776377767A53655A2B356D486D4D387A6E6D62396B76737738792F77763568764D7477436E466F726C70445831706D4A565578306F6E684373436A576D';
wwv_flow_imp.g_varchar2_table(169) := '56386F706A6F376830532F6863665454654B62396154784F513641746D4956696F567143634B4F59717159356D734C786243596C59317231644B4D497A756B706652446F4845664A59546B706C4D70786A363951394D53726676714B4861672B2B573277';
wwv_flow_imp.g_varchar2_table(170) := '6271337637574E574345426A4D50786A7633577045744634323556716D3966467952374F48786772426E7963346862636D697A6A31785737716D57585635415050436A6B4564394E797044476765646851325965396169666B336A46492B7163327A7A77';
wwv_flow_imp.g_varchar2_table(171) := '4C4F2F4A4B43782B78514F6148476D79496D4F3570694448595A3962304C5A507A6C34676B4E73432B374E674C64632B4739327A7835356E383537382B412F68484359353276774E56706770756145374553775830553071546279433237735779516F6F';
wwv_flow_imp.g_varchar2_table(172) := '6C79675345674E686E3648666E692F6E62386C585943336E623456313149534771704267452B46637A63456D72322B5779716C425366436C3237324331792F78716D5330545477766E336A384D37584855452F7431343959675378444F664B746277462F';
wwv_flow_imp.g_varchar2_table(173) := '2F68343053596C784D52374759494A4D6C456E6162776C42424975617665696B70314F74734732464E55373331434D49317536384F3738317638315A63363738676376797043312F34484A67395150664C34786D4A6D556C6E786E6473776C2B4E324E39';
wwv_flow_imp.g_varchar2_table(174) := '375055636571713278486B6E3857377950496E5A3755574433444449553751584A46683036745657514F76556933645836766C5562666D6E503731354D3136315A6375444A486267476E49395857762F397543444635363336774B303838494871623379';
wwv_flow_imp.g_varchar2_table(175) := '72562B515430457A7443416C3648366A7942515144397371716B54704842692B536F72635874754F305A6B5931396F7737674B4A2F7A4A4C526B483250774A742F4B3048344F414D516D6F5A516A704138482B666B4133415837636A58482B4837712F78';
wwv_flow_imp.g_varchar2_table(176) := '32585A65375A5A4E4A324346566E336749644B4F7A7835374462747259616463314D627943486D53524F70796F45486E566A704C44414A61636E5761576A6131756670717A2B6C74487958706C544C4B6E6C4F372F3466332F2B67445632664764702B44';
wwv_flow_imp.g_varchar2_table(177) := '396D6379562B7762753366664654395A5353492F2F4F462F6E514F2F534F61796538373934512F334C566E793155737A64364E374D7064646C736B6375353539396671636371336E4955373364666C31314872477678397479303336745933655A466330';
wwv_flow_imp.g_varchar2_table(178) := '705569757467513942566F32383961626B4A2F6E6F4D5944544450497642596D773351794F6162453944417A6D4B48783264536436666F4D6D38756F526261636E4371543342526839597051345866672B7837347A64375779504C59367646442F4E7750';
wwv_flow_imp.g_varchar2_table(179) := '616D37385175666A2B532F6D4833734D4E684F2F583034634E7559486265545A735245342B575A38515754502B35363048654B4F6B4D5078334E43387A4A37302B4E7254746576682B62576635476F2F512B464A564775387439667776564F67505A684D';
wwv_flow_imp.g_varchar2_table(180) := '654E7A2F7A6E472F73354A705A324A694F69304E4A64426B58377A6475332B32632B6448727479306165664F756B76656C32325076442B37494442762B616272313635644F7A746A74376E4A7A7A414F66344C6A4F583934796F636B75686E53644E3478';
wwv_flow_imp.g_varchar2_table(181) := '2B7A36354750386E6379487A37383458455741423554615652666E4732325455696C34334F4558726336594B3970764145384D4A5565726235377A504F2F35794775384D30355A4C355970746F334C53316E473250722B495542514B6554715A59515246';
wwv_flow_imp.g_varchar2_table(182) := '71642F534948624D6B50326F34446744436B595531642F3473336F524864386448324C5755547956486C3847734A4F48367354376236686163624A4733315347584D46446E666C4D66713846514159542B6D467342414A635554772B4B787745634D6D35';
wwv_flow_imp.g_varchar2_table(183) := '56553530385336336C473478665A59377A4F476731744A6C4E66656D335278614441714F366D395341724A626B486B32344E47615A612F4F5339526A562B534E6F436D34614F596B6E6E434351507346696E6B417755457752587A784548556446514451';
wwv_flow_imp.g_varchar2_table(184) := '5558396352505559464A4F39626C467A79616F6B416F7A6C58614C6646776743734B37395749763352515064536455484D54326D486B303068363277793633784C6833414D3468476C36457171716A4C666B2B73726C344B6742312F70366E2B65504E67';
wwv_flow_imp.g_varchar2_table(185) := '5A6F374C496C5A4D443771446B7149674A654A4C6D766D5572366C67716271593041425361553252514D7A543274306358393976434B71727537706C51584E2F633165304D365262644570485431494F75426435576974577771506F697552704D764D74';
wwv_flow_imp.g_varchar2_table(186) := '32574A7364695470566A55555A336D316430477770366354335A374D2B79304A5641473472546B346C4C35504D4C4C74336F684C426A5649386955444B624E596E4C484C5372643653364F74346535575061434A71687478726F6756613949726777577A';
wwv_flow_imp.g_varchar2_table(187) := '72637362306B4737354945634557386D6C4F7667432F33746B666E4E515930662F3962576A38683738452F7364747875663231724D624F564F617642723336546D764E6F705676304657574F4970494B5A5A39697156784B64324E673179536947496575';
wwv_flow_imp.g_varchar2_table(188) := '2F767277463431527246544C6953525035377168562B68306D6833494B42524E616F594676725876514C686A524B45366541477175684C377763674F4A47657A4E2F633352316B4961656D4E536A3570374F6C4341582B3155426962335A58304E376E6A';
wwv_flow_imp.g_varchar2_table(189) := '515A565641483969643754614645306A7547616D7A4F5343704C39743573784B41704B71336448646A582F63322B4731744B6F32503763386B2B6A436556544935396C775A4F68545454304C57324F394C5643317451583552666C2F54692F77794C6A68';
wwv_flow_imp.g_varchar2_table(190) := '4B6738614342484B3858576A566E735479694F757454656D6851336C6D2F6D4744487155334572386B36796A44414B5A56303643734B4F2B6F5471615750464F31507172583955756D7A6B773830755456754B766A6452475A7544394D326F7644387763';
wwv_flow_imp.g_varchar2_table(191) := '47476973384A2B59362F78782F453137584B624B4C44695275516834434445685667584F5534664E6F666E6474726D5A7A4E77325043387A4C77502F735766777647677043762B785A364C6C614C51384931577470724353716C525359332F4153694352';
wwv_flow_imp.g_varchar2_table(192) := '43497A39495A6849344A666772747053357937304A4B53536750693170665A4E5566516B62504B56564F304439455A3062616F433939552B514F3947317759536A5864746E795533342F2B474D6A554478545153496451594C3651485554634374535343';
wwv_flow_imp.g_varchar2_table(193) := '716E4341482B686333682F6D4D334E57642B5857394376336671447634635436326E2F5737694C527649553252375034445A4B5A743362446976347749646B6C7565716976583278574F32653273664E664A53674864347159342F4C76765654386D4838';
wwv_flow_imp.g_varchar2_table(194) := '4F7030397A4235526F584D494F6E4237454145454A78396573667A706A66353034746D2F5743316F797569545436375062384376743255326448687034426F493350446B552B7650644F5A332B6C6579423739686F3454783148513853434168704B4D71';
wwv_flow_imp.g_varchar2_table(195) := '32554D544D7A756158767832357239783742755156433354644638497630485438336332765A543437347A2B647939436172574C37772F64373944697035446D36777850665145515A794659364D6431794A3761696F3231655448306C6447786C39424F';
wwv_flow_imp.g_varchar2_table(196) := '2F5072334E39526D7864445852752F743647442B5078705244614D41654A786A594752675941446939324C6D4A7648384E6C385A754A6C66414555593776392F6E3436672F3263787632414F416E4935474A68416F67426F6867306A654A786A59475267';
wwv_flow_imp.g_varchar2_table(197) := '594137366E77556B587A417767456C47426C535141774264594151444148696359333742774D4138696F634D426741525A474D6C41414141414141414141422B414F49427667626142306F4B634172454374344C3042456D456434536C684D4145337755';
wwv_flow_imp.g_varchar2_table(198) := '53426C73476459644B683145486834655242357148746F6654422F34494C5968476946304963516941694A6F4979776B486953594A506F6C5843592B4A6C776D6C43636B4A35596F4D696A6B4B5577706A436F714B6D6F716C6972714B32517277437755';
wwv_flow_imp.g_varchar2_table(199) := '4C4859733369302B4C6667756F6938514C3651776F6A43364D5A6F78376A4B654D76497A6F4452574E65493269446D344F6477366E44726F4F3651386B44302B507278414D4544615162354344454D6551317844714553475253684B566B707753365A4C';
wwv_flow_imp.g_varchar2_table(200) := '376B77575445524D576B7961544F4A4E504531325461684E3045386954376850366C4255554970517346446155505941414869635932426B5947444959636C69554741414153596735674A43426F622F594434444143465141684541654A78646A37314F';
wwv_flow_imp.g_varchar2_table(201) := '777A415568552F61744541724D59424159764F41454149702F574641394147617A7133555054394F326971786F385374314B646835416B5947586B4B4A425A65684A505564434357342B392B3931784841584342627A67345046666342336267736A7077';
wwv_flow_imp.g_varchar2_table(202) := '437965347364796D46355A64726C764C4866527862376C4C2F32533568306338572B376A45694676634E777A56672F59576E5A77696C664C4C5A7A6A7A584B622F743279532F3677334D45315069313336623873393744456A2B552B377079584B4D6933';
wwv_flow_imp.g_varchar2_table(203) := '4B6737455170613764535172346566684C4378794E5A66704E67764B477575396C475731316B714D764746642B6C4C4A4D6A417946754665564C7430624577696B6C4C6E597171566B566D6D525648716A59794D747A4B6D6D4177476966566570484E45';
wwv_flow_imp.g_varchar2_table(204) := '434A447A357852696B73414345695632574C4D6A55644834374965596352636B68546C39796F6D4D2B664A6F2F38356C4D31397858724D53474D4844384E6A313256564E496F446847544D525973393378572B6D474E4D614A4B77545A6A526E424B624E';
wwv_flow_imp.g_varchar2_table(205) := '54585536343949305264506230455430486C624E5649454A426C7A4A76377A4846472F3642576239596E3441414869636C56623565397047454F576C506D72414159506A4A473264773436544E71317939307A6239456A762B3736505252724478737575';
wwv_flow_imp.g_varchar2_table(206) := '7572734335372F765369755143496A503451632B4E4C4D7A3839366232524731557A582F716463576677524F34526D7359425672574D657A324541644454537869644E6F6F593074644E44464E7335674232647844756678484A374843396A4642567A45';
wwv_flow_imp.g_varchar2_table(207) := '4A567A4748765A7842516534696D743445532F684F6C37474B776877417A6478433764784233647844362F694E62794F4E2F416D33734A397649313338433465344432386A772F77495237694933794D542F41705073506E2B414A66346974386A572F77';
wwv_flow_imp.g_varchar2_table(208) := '4C623744392F6742502B496E2F4978663843742B772B2F3441332F694C2F794E662F417647486F494559467769443447344869454977674D613674574D7A4E6F39356D6C4D5873637845777A49556863354E4B53486C4C456E534F6745556B62684D7947';
wwv_flow_imp.g_varchar2_table(209) := '412F637451784B334B2F31537953427A366953325850614449526E442B6E544F574B6274354B67617869514E73317A4A47325848585051455544424D684F57786F495A514B67364754422B52376852656E7076326C32597A76432B5A75486C79384A5950';
wwv_flow_imp.g_varchar2_table(210) := '53562B7650442B483771426174784C6C786B5475593658624A4B507077565461765355705A4D54542B50736E4A7A4348384D7873482F4B4D6530746C793154594E765266347479636C65546553417A7077444A7A744E6C4C444A65753134464F4248564D';
wwv_flow_imp.g_varchar2_table(211) := '3067746972634C5534492F756C6B764D77646F716531316C70617448304866785171552F4339387036567153667473426D2B414B6C5241734E685231533059366A706D4D4B46704A5362574B4A466E532F6571614A6D51697131434E4B354E785A34626F';
wwv_flow_imp.g_varchar2_table(212) := '4E4B70544E6E75436E526C464D354858686B776D544B7872436F6D50614E4E46693443466C6F2B346654776A595661725737626B392F4473416E6975346252624356747765625264456D4B4B656230584439326B714E5A6B6E464F68425231334A73395A';
wwv_flow_imp.g_varchar2_table(213) := '51493835685A735455317171506E6C51756C766B5461747A3654796C472B47464F4630593076424F385469646E704C4A30797A467050677656624C4C7A792B36754861673166694A36536B4C6D6864664D36486D73573334336D5239576A47752F4C7137';
wwv_flow_imp.g_varchar2_table(214) := '47694D65556A50766C76656B463662397847326A5258506C717864715836366D6B414F35642F4B31554B5264314864664F74587436744B394D4630666A59685A46716A654977707477387552736431496463682B31624D547869704E3135626D4C4A4174';
wwv_flow_imp.g_varchar2_table(215) := '36706C486C7666737A6C4F3868484B4A62703038784D2F654974567A45486E4B4B307670354641335752514D564A6976776D592B4756366A39437562676D353531504B6A4238757A357867573755715030724F3465334C6152552F646A72593835473464';
wwv_flow_imp.g_varchar2_table(216) := '32765035645A78666B3175435358495A48434D623945696F636433454C4B576D6C4769375A4E4B4E5245596E686271536E71344C5A6F7A4B44737845733534616B626445627146466C46496761733159787370504570647859764F7853367A3776544667';
wwv_flow_imp.g_varchar2_table(217) := '36616935704B7439725A4B345A656E59355A525357662F4F645839306E4C515A6D4B596255526F4859303079484E514C6B4F307065586550447832585A6B53487A414850486D71312F774776784A30534141413D272920666F726D61742827776F666627';
wwv_flow_imp.g_varchar2_table(218) := '292C0A2020202020202075726C2827646174613A6170706C69636174696F6E2F6F637465742D73747265616D3B6261736536342C414145414141414C414941414177417752314E565169434C4A586F414141453441414141564539544C7A492B4A457330';
wwv_flow_imp.g_varchar2_table(219) := '414141426A4141414147426A62574677553357582B41414141357741414164305A3278355A726B772B68514141417673414143683747686C5957516A42794A76414141413441414141445A6F61475668427A774476774141414C77414141416B61473130';
wwv_flow_imp.g_varchar2_table(220) := '654B58674141414141414873414141427347787659324876553945534141414C45414141414E707459586877415A5945646741414152674141414167626D46745A586F34645A5541414B33594141414350584276633351512B4E79374141437747414141';
wwv_flow_imp.g_varchar2_table(221) := '436967414151414141314C2F61674141412B674141414141412B67414151414141414141414141414141414141414141414777414151414141414541414F38574E7A5266447A7A314141734436414141414144662F2B396E41414141414E2F2F37326341';
wwv_flow_imp.g_varchar2_table(222) := '41503971412B6744556741414141674141674141414141414141414241414141624152714143414141414141414149414141414B41416F414141442F4141414141414141414145414141414B414441415067414352455A4D5641414F6247463062674161';
wwv_flow_imp.g_varchar2_table(223) := '414151414141414141414141415141414141514141414141414141414151414141414673615764684141674141414142414141414151414541415141414141424141674141514147414141414151414141415144364147514141554141414A3641727741';
wwv_flow_imp.g_varchar2_table(224) := '4141434D416E6F4376414141416541414D5145434141414341415544414141414141414141414141414141414141414141414141414141414146426D52575141774F6742364F45445576397141466F447241435741414141415141414141414141414141';
wwv_flow_imp.g_varchar2_table(225) := '4141414141414143412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F41414144';
wwv_flow_imp.g_varchar2_table(226) := '36414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141';
wwv_flow_imp.g_varchar2_table(227) := '412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B6741';
wwv_flow_imp.g_varchar2_table(228) := '4141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F';
wwv_flow_imp.g_varchar2_table(229) := '4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F41414144';
wwv_flow_imp.g_varchar2_table(230) := '36414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141414141414251414141414D4141414173';
wwv_flow_imp.g_varchar2_table(231) := '4141414142414141416D4141415141414141414257674144414145414141417341414D4143674141416D414142414575414141414567415141414D414175674236412F6F4C2B68703647766F784F6A63364F482F2F7741413641486F424F67523644486F';
wwv_flow_imp.g_varchar2_table(232) := '612B6A45364E766F34502F2F414141414141414141414141414141414141414141414142414249414567416F4147514131414455414E51413167414141414541416741444141514142514147414163414341414A41416F414377414D4141304144674150';
wwv_flow_imp.g_varchar2_table(233) := '414241414551415341424D4146414156414259414677415941426B414767416241427741485141654142384149414168414349414977416B414355414A67416E414367414B514171414373414C414174414334414C774177414445414D67417A41445141';
wwv_flow_imp.g_varchar2_table(234) := '4E514132414463414F41413541446F414F774138414430415067412F414541415151424341454D4152414246414559415277424941456B415367424C414577415451424F4145384155414252414649415577425541465541566742584146674157514261';
wwv_flow_imp.g_varchar2_table(235) := '41467341584142644146344158774267414745415967426A414751415A51426D414763416141427041476F416177414141515941414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(236) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(237) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(238) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414144414141';
wwv_flow_imp.g_varchar2_table(239) := '414141464641414141414141414142724141446F4151414136414541414141424141446F4241414136415141414141434141446F4251414136415541414141444141446F4267414136415941414141454141446F4277414136416341414141464141446F';
wwv_flow_imp.g_varchar2_table(240) := '4341414136416741414141474141446F4351414136416B41414141484141446F4367414136416F41414141494141446F43774141364173414141414A4141446F44414141364177414141414B4141446F44514141364130414141414C4141446F44674141';
wwv_flow_imp.g_varchar2_table(241) := '364134414141414D4141446F44774141364138414141414E4141446F45514141364245414141414F4141446F4567414136424941414141504141446F4577414136424D41414141514141446F4641414136425141414141524141446F4651414136425541';
wwv_flow_imp.g_varchar2_table(242) := '414141534141446F4667414136425941414141544141446F4677414136426341414141554141446F4741414136426741414141564141446F4751414136426B41414141574141446F4767414136426F41414141584141446F477741413642734141414159';
wwv_flow_imp.g_varchar2_table(243) := '4141446F48414141364277414141415A4141446F4851414136423041414141614141446F4867414136423441414141624141446F4877414136423841414141634141446F4941414136434141414141644141446F4951414136434541414141654141446F';
wwv_flow_imp.g_varchar2_table(244) := '4967414136434941414141664141446F4977414136434D41414141674141446F4A41414136435141414141684141446F4A51414136435541414141694141446F4A674141364359414141416A4141446F4A774141364363414141416B4141446F4B414141';
wwv_flow_imp.g_varchar2_table(245) := '364367414141416C4141446F4B51414136436B414141416D4141446F4B67414136436F414141416E4141446F4B774141364373414141416F4141446F4C41414136437741414141704141446F4C51414136433041414141714141446F4C67414136433441';
wwv_flow_imp.g_varchar2_table(246) := '414141724141446F4C77414136433841414141734141446F4D51414136444541414141744141446F4D67414136444941414141754141446F4D77414136444D41414141764141446F4E41414136445141414141774141446F4E5141413644554141414178';
wwv_flow_imp.g_varchar2_table(247) := '4141446F4E67414136445941414141794141446F4E774141364463414141417A4141446F4F41414136446741414141304141446F4F51414136446B41414141314141446F4F67414136446F41414141324141446F4F77414136447341414141334141446F';
wwv_flow_imp.g_varchar2_table(248) := '5041414136447741414141344141446F5051414136443041414141354141446F5067414136443441414141364141446F5077414136443841414141374141446F5141414136454141414141384141446F5151414136454541414141394141446F51674141';
wwv_flow_imp.g_varchar2_table(249) := '364549414141412B4141446F5177414136454D414141412F4141446F5241414136455141414142414141446F5251414136455541414142424141446F5267414136455941414142434141446F5277414136456341414142444141446F5341414136456741';
wwv_flow_imp.g_varchar2_table(250) := '414142454141446F5351414136456B41414142464141446F5367414136456F41414142474141446F5377414136457341414142484141446F5441414136457741414142494141446F54514141364530414141424A4141446F54674141364534414141424B';
wwv_flow_imp.g_varchar2_table(251) := '4141446F54774141364538414141424C4141446F55414141364641414141424D4141446F55514141364645414141424E4141446F55674141364649414141424F4141446F5577414136464D41414142504141446F5641414136465141414142514141446F';
wwv_flow_imp.g_varchar2_table(252) := '5651414136465541414142524141446F5667414136465941414142534141446F5677414136466341414142544141446F5741414136466741414142554141446F5751414136466B41414142564141446F5767414136466F41414142574141446F57774141';
wwv_flow_imp.g_varchar2_table(253) := '36467341414142584141446F5841414136467741414142594141446F58514141364630414141425A4141446F5867414136463441414142614141446F5877414136463841414142624141446F5941414136474141414142634141446F5951414136474541';
wwv_flow_imp.g_varchar2_table(254) := '414142644141446F5967414136474941414142654141446F5977414136474D41414142664141446F5A41414136475141414142674141446F5A51414136475541414142684141446F5A67414136475941414142694141446F5A774141364763414141426A';
wwv_flow_imp.g_varchar2_table(255) := '4141446F61414141364767414141426B4141446F6151414136476B414141426C4141446F61774141364773414141426D4141446F78414141364D51414141426E4141446F32774141364E73414141426F4141446F33414141364E7741414142704141446F';
wwv_flow_imp.g_varchar2_table(256) := '34414141364F4141414142714141446F34514141364F454141414272414141414141422B414F49427667626142306F4B634172454374344C3042456D456434536C684D414533775553426C73476459644B683145486834655242357148746F6654422F34';
wwv_flow_imp.g_varchar2_table(257) := '494C5968476946304963516941694A6F4979776B486953594A506F6C5843592B4A6C776D6C43636B4A35596F4D696A6B4B5577706A436F714B6D6F716C6972714B325172774377554C4859733369302B4C6667756F6938514C3651776F6A43364D5A6F78';
wwv_flow_imp.g_varchar2_table(258) := '376A4B654D76497A6F4452574E65493269446D344F6477366E44726F4F3651386B44302B507278414D4544615162354344454D6551317844714553475253684B566B707753365A4C376B77575445524D576B7961544F4A4E504531325461684E30453869';
wwv_flow_imp.g_varchar2_table(259) := '54376850366C4255554970517346446155505941414141464141442F77414D374175634147774173414445415141424E4141414242694948446745644151634F4152597A495449324A6938424E54516D4A79596A4969636A4253494746784D6541544D68';
wwv_flow_imp.g_varchar2_table(260) := '4D6A5933457A596D497945464B51454449524D694977344246784D65415434424A774D754153556942676344426834424E6A63544E6959427251736C42676F4872416F4842776F4363416B4842776D6F42516B474652494D522F3769436738424D67454E';
wwv_flow_imp.g_varchar2_table(261) := '4367484A436730435141454F432F37692F763042417745444F2F356953774543444138434C414953466730434C41494E4151344B45414573416730584551497341673843357745434178555A435467434477304E4477493343686F55417749427A41384C';
wwv_flow_imp.g_varchar2_table(262) := '2F64554A4451774B41696F4C4544482B427747774152494D2F73414C446749554377452F436730424467722B775173554167344C4155414D456741444141442F6D674F34417949414541415541454541414145694277454746426342466A493341545930';
wwv_flow_imp.g_varchar2_table(263) := '4A77456D42776B434A5349504178556A44774D5648774D7A465238444D7A38444E544D2F417A557641794D314C774D423941384C2F6D454B436747664378384B415A384C432F356843773842687635362F6E6F426577494342414D427767514541774542';
wwv_flow_imp.g_varchar2_table(264) := '417751457767454442415157424151444163494542414D4241514D45424D4942417751454179494C2F6D454B4877762B59516F4B415A384C48776F426E77732B2F6E722B65674747355145444241544341514D454242554642414D427767514541774542';
wwv_flow_imp.g_varchar2_table(265) := '417751457767454442415157424151444163494542414D424141594141502B56413734444A414162414445415351426741486B41696741414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A595846686357';
wwv_flow_imp.g_varchar2_table(266) := '46785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E67634742786347427859584E7863324E79636D';
wwv_flow_imp.g_varchar2_table(267) := '4A7A63324E79596E426738424A693842466863334677635842796347427963324E79636D4A77487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D744531515A434156';
wwv_flow_imp.g_varchar2_table(268) := '467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B47783036634467324B69787563546F654A6A495A4A5445594B69775A4D43555A';
wwv_flow_imp.g_varchar2_table(269) := '4D6959354F473430623345316353524B4E456F6C4A6A495A417949434E6A566158577863746B6C4B4B43674C4842313370466C6255314F474B436B46416A45444D544254566D4E59724542444F7841724C492B7A56566C4352453472417A417654314A62';
wwv_flow_imp.g_varchar2_table(270) := '5531424F4E6A6751454355774D6F7969535577794B7A417741697771526B7051533473734C77634A4D544D3152554B514F7A30694B3238654F6E45324F437771626E41364853597947535577475377714744456C475449444F446C764E4735784E58456C';
wwv_flow_imp.g_varchar2_table(271) := '536A524B4A43597947514141455141412F364D4475414D6941414D414267414C4145344170674438415438426C414878416A774366674C434177554458414F70412F554550774141415245684551557A427A6356495455584554456A42794D484978556A';
wwv_flow_imp.g_varchar2_table(272) := '42794D504278556642444D334D7A637A4E7A4D334D7A637A467A4D584D78637A467A4D584D7A38464E5338464979636A4E534D6E497963584977384648786B2F4244557641794D6E4E5363314A794D7641534D764154556E497963314C77456A4C774531';
wwv_flow_imp.g_varchar2_table(273) := '4A7A556E497A556E4979636A4C7745314C77456A4A7A556E4979384242534D50416855484977384246513843465163564278555041534D50415255504168555041534D5041534D50415255484651384249773843465238464D7A385A4E5338454954456A';
wwv_flow_imp.g_varchar2_table(274) := '46534D504178556642444D334D7A637A467A4D584D78637A467A4D584D7838474D7A38464E5338434979384A4979636A4A794D6E497A554849773843497738424651636A4477456A427855484977636A42794D4846513844497855504152555041694D50';
wwv_flow_imp.g_varchar2_table(275) := '415238464D7A38644D7A38444C774D46447755664668556642444D2F4244556E4E5338494E5363314C77516A4A794D6E4E533842497963314A7A55764154556A4C7745314A794D6E4E5338434E53384442534D504252556A465163564278556A46516356';
wwv_flow_imp.g_varchar2_table(276) := '4678557A46526356467855584652384A4D7A38454E5338434E5363314A7A556E4E5363314A7A55334E5463314E7A55334E5463314C77514649773844465163584651635642785548465163564477675648774D7A507759314E7A552F427A55334E544D31';
wwv_flow_imp.g_varchar2_table(277) := '4E7A55334E5363314C774D46497738444652635646785558465263564877635646785566416A4D5648774D7A507751314C7773314A7A556E4E5363314A7A55764241556A447755564278555044785566425438434E5438424E54637A4E7A552F416A4D2F';
wwv_flow_imp.g_varchar2_table(278) := '436A55334C77514644775566416855584652637A467A4D66416A4D6641544D56467855584652637A4877457A467A4D584652635648774556487749564877497A507755314C787746497738494977636A42794D484977636A42794D504242556642544D33';
wwv_flow_imp.g_varchar2_table(279) := '4D7A637A4E7A4D334D7A384C4D7A637A50774531507745314E7A552F42445576424155504252556642544D66415255584D78637A487745564877457A4678556642444D584D7838474D7A38464E53385749534D5046785566426A4D2F43444D2F42445533';
wwv_flow_imp.g_varchar2_table(280) := '4D7A637A4E7A552F4154552F41544D2F424455764241456E415A722B776552796E5037496E4173474377554D425155474A67594B4341514341774542416759454351517242516B46425155464367556542516F4642515546436751594351554541775145';
wwv_flow_imp.g_varchar2_table(281) := '41514545417751484A675547425173474377623042515146417751454167494941677748434163454177514442414D484267635041676B43417845454177514A435151454177514241674D4341514944416745434567454A424159424177514441514D49';
wwv_flow_imp.g_varchar2_table(282) := '42414D42417745444151674542415142424167424241723938515545434155454151514542417745424151494177454442414D454177514A415138434151494441775543415151444177454341774D4942416B4642775546454159434267495042775948';
wwv_flow_imp.g_varchar2_table(283) := '4177514442414D45427767454241634341514943417751494151515344516F464277594341674D49434151424341516D42416744424151454277514941786F444341634841776B46424151454177514242414D4841514D46424151454241514A42435945';
wwv_flow_imp.g_varchar2_table(284) := '435155454241554E7251514942676342417767444152554441514D4441516B424441454A43514D444167454341774D49424145454167494341774D494241554543514D49417749454177494441674D434177494441774D4341774D4441774D4441774D47';
wwv_flow_imp.g_varchar2_table(285) := '41794D434177514541674946424167426841554942414D444177454741774D434177494441674D4341776357415151424241454741774943424151444241554A424151454177514241674943415149424167454341674942415145494151454241674945';
wwv_flow_imp.g_varchar2_table(286) := '415149484177494241674D434151494741776B4441774D452F634D464241674441774943415149424151454241514543415167434151454241774D45424151464351514441775142416755444167454241514542415149424151494441776B4337675545';
wwv_flow_imp.g_varchar2_table(287) := '434159434151454241514543434149424167494541525942415151444441554A4241594642414D4B4167674241674543416749484151454241514545417751492F4B634643416745416745424151494741674943415151424267494B4177514241775945';
wwv_flow_imp.g_varchar2_table(288) := '42516B45424151444241494245674543415149424167494342774942415145424167634442514C774241554542414D454167494841674D464167514241674D4D43674D4541675142415151444241514A4341554841773843415159464341454241515942';
wwv_flow_imp.g_varchar2_table(289) := '416745434151494341676B424167494442416A397251514942414D434167494642677747415177424267634441514D4441516348417745484277454441514D4543415145444151454241514A4241514542514942415151454178554442416F4847514D4B';
wwv_flow_imp.g_varchar2_table(290) := '41674D4441774D4441774D4342674D4341774944416767426E415545424145484368774C42784945437751484241514842416745454167454177494341515145417751464441554E42415545425167464A67514A42415145424151454151514441514D42';
wwv_flow_imp.g_varchar2_table(291) := '417751454341514A4241494341514947417751462F6B5145425151474167494241674D44425151424241304A4151304242415546424145454251554B42526B4242414555426755464251734B4351554542414D4541514944417751484577554542515545';
wwv_flow_imp.g_varchar2_table(292) := '425155454A5234494241514A44414D4E41684946424155444152514542416B494669774642515146425155454252734542675142415149444177514542416B444267554C42515546426851424867554B4251554541515142424155634451514242415544';
wwv_flow_imp.g_varchar2_table(293) := '4167454341674D45434148362F7367424F4446615072713666514879415145424151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B';
wwv_flow_imp.g_varchar2_table(294) := '41516B484267634442414D454177514843416355424130454243414441774943416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D45';
wwv_flow_imp.g_varchar2_table(295) := '4177454444414D42417745444151674542415142424151454151514E467755464241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D4541514943';
wwv_flow_imp.g_varchar2_table(296) := '425177464351514442674942415145424151494342774943417749434167454341774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B4243515144417745444177454443776348';
wwv_flow_imp.g_varchar2_table(297) := '43516B45417751454151454541777744424159444177494441774D4441774D4341774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48';
wwv_flow_imp.g_varchar2_table(298) := '417767444177494241514D434241674A42414945435151454241514542514D4241774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E';
wwv_flow_imp.g_varchar2_table(299) := '4351514543515142424349454251454542414D444167454341674D4543416B464242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B';
wwv_flow_imp.g_varchar2_table(300) := '424449454251514942415943416759494367555A41515142464159464251554C426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F424241594341514544';
wwv_flow_imp.g_varchar2_table(301) := '41675149435167424B5151464251514642516B464967554A4251554642516F4646775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C41516351';
wwv_flow_imp.g_varchar2_table(302) := '4241514D42415145424151454351516D4251554942415144424B414242414D4442416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B43';
wwv_flow_imp.g_varchar2_table(303) := '4151594445414D474177494441674D43417749444267494441774D444177644B415149424177594D41774D46417749424151454541774D454351554543414D44416745424151454343514943416745434151494241514543416749424151454541514542';
wwv_flow_imp.g_varchar2_table(304) := '4251514442515146434167444167456E415145444267514A42515145424149464177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D4541674543415149424167455145415943';
wwv_flow_imp.g_varchar2_table(305) := '4177554A41776F4241674943447749444251594D46414543415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D4541414141';
wwv_flow_imp.g_varchar2_table(306) := '425141412F35594476514D6A414259414D51413641443441524141414153594F4178595848674933506745334E6A63324A7934424A7959484E6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B41684D47447745584E526352';
wwv_flow_imp.g_varchar2_table(307) := '427963554653636C4642556E4A6963423946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D656370512F4E6D77763063724B4749384257537044';
wwv_flow_imp.g_varchar2_table(308) := '49674D6941555A2B6F624F6D506A394A43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C77507638414A6B30686C492B50415369505947526C5A47566C5A5234774677414A';
wwv_flow_imp.g_varchar2_table(309) := '4141442F6F674F3441794141437741584146494175774645416145423641497941703441414145564978557A46544D314D7A556A4E51637A46544D564978556A4E534D314D784D724151636A42794D4846513846465238464D7A38444D7A637A4E7A4D33';
wwv_flow_imp.g_varchar2_table(310) := '4D78637A467A4D584D7838424D7A38444E533845497A556A4A794D6E467738474652384B4D783847465238434D78384E4D7A38454E5338424E53636A4C77596A4C7745314979384C4979384249793848497A556E4E5338454977555041534D5042425550';
wwv_flow_imp.g_varchar2_table(311) := '424255484977635644774D6A4651635642794D564477515642794D50415255504168555041694D5041785550417855484651384B465163564877512F42444D2F4244552F4A6A557641774550425255584651635642785548465163564278554846516356';
wwv_flow_imp.g_varchar2_table(312) := '42785548465163564278555042785566424438464D7A38424D7A38424E5438424D7A637A4E7A55334E544D314E7A55334E5463314E7A55334E5463314E7A55334E5363314C77514644775556467855584652637A4877557A487745564678555846526356';
wwv_flow_imp.g_varchar2_table(313) := '4D78635646785566424438454E53384E4E5363314A7A556E4E533844415138584877512F42444D2F417A4D334D7A637A4E7A4D334D7A63314E7A4D334E54637A5077497A4E7A4D3150774D314C7751464477555648774D564877457A4877497A48774956';
wwv_flow_imp.g_varchar2_table(314) := '4877457A487745564877457A467A4D584D78637A4877497A467A4D5846544D66427A4D584652637A46544D584D7A38454E5338454979636A4A794D6E4979384B4979384549793846497747756658324D66583131586E3139586E31394D77634E4267304E';
wwv_flow_imp.g_varchar2_table(315) := '4279634E446751444177514241674D4443515146426777474677594C4267594742696B4742675947426755664241554D41774D4341675944436963474277594E422B6B464241514441774543416749474167494442675545417767424467494941675943';
wwv_flow_imp.g_varchar2_table(316) := '4241454341674543417749444251514442414D4B425159444351514A4241514442414945426745454177494441674D434151494941515544424149454167494641676343416745434351454341674D4841774944416745434177494741676F462F664D46';
wwv_flow_imp.g_varchar2_table(317) := '427745434177494441674D43417749444241454341674D4342414545424145434167494341674942416749434241494342414542415149444167494B41514943416745454151494241674543415149434151514541773445434151444151454341774543';
wwv_flow_imp.g_varchar2_table(318) := '41674942416745434151494241674944416745434341494241674943415151434241454741676F4342674D4B4177594442514D434151514743415543736751464177594341514542415145424151454341514D464177554442414D4342674D4241674D47';
wwv_flow_imp.g_varchar2_table(319) := '42416B4A42415144416745424177494241674D44416745464151774441514942415145424151454241515144424151492F4B594542514D454241454241774942417749424241454B4151514441674D43415149444151494542776B4A4241514442414945';
wwv_flow_imp.g_varchar2_table(320) := '41674D43427751424267454341514949415145424151554943414B784241514A4241554B42413846425173504267554C425345474378414942415543416751444241304A4267595542514553426763464151554242514546415277424377554242515542';
wwv_flow_imp.g_varchar2_table(321) := '425173504151514241774D4341515144424151492F643445424151444167494241674D454451494241674D4341514944417773434151674441775542416745434151494241674D44415149424167454342414D4741773044485149444451514444516B46';
wwv_flow_imp.g_varchar2_table(322) := '434155434151514442415144424167444641495241776B464551494742514D464251554341513843425149434151514442424545424155434958324D6658324D66526439586E312B58514754415149474151494541674D4543416B464241514442414543';
wwv_flow_imp.g_varchar2_table(323) := '4167494541674542415145424251454742414D4A4251674941675147415145425477454241774D4542415146435151474151494242674D454167674F4177674442674D45415149434177514442414D4842774D494178494B43414945416749444177674B';
wwv_flow_imp.g_varchar2_table(324) := '4277634244416745424151454241514543774548417759434267494442514D484177494443514D43416763434167494341514542416749454167554D41515143416749434167454341674943416745454167454341674D45415151424241454341774944';
wwv_flow_imp.g_varchar2_table(325) := '4167454341774942416759434151494741774D434251494241673844416745434151494442674D4441774D4441774D444151514A4251674441774D4242414D4442415946417749464151494441674D43417749444177494641674D434441494441674D43';
wwv_flow_imp.g_varchar2_table(326) := '4177514442414D4741776F444267494B415159434251514542416B4A426751422F735942416749494241514542444D4443514D474167594441774D4441774D4741674D444351494F417767424451554C4251594B42775146435151474167494341674D44';
wwv_flow_imp.g_varchar2_table(327) := '41774D4742675946415155484479594443674D4442774D4442414D4442414D4442414D48417734444C41554A43415143417749544151494441776745477759484577634E4577594844515966445155424251454641515542425145464151454542415143';
wwv_flow_imp.g_varchar2_table(328) := '4167494441776B4A434159474251595143775952425159474253384742515947444159484251634741763679415149474241514742416B454177554A41674D454177774242414D454177634A4351674441774D43416745474167594441674D4341774D50';
wwv_flow_imp.g_varchar2_table(329) := '42674544417745444241634D424145444241514543516745417749434167454441675145435151464241514441516F434167494341674942415163434251454241514D434167454341514942415145424151494341675143435145424241454541515148';
wwv_flow_imp.g_varchar2_table(330) := '4251514A4341514341774544427759444177594341674D424177494441676B4341774942424145454451454341414141415141414141414451414B4741444D414141456944674548426859584A696348466863324E79596E427934424E6A632B41525958';
wwv_flow_imp.g_varchar2_table(331) := '486749484467496E4A675965415263794E7A597A506749334E6934424A79594345543531566849564679677357677969554341504A4263634968635A49694A6E627938745078594D433056694E4130534152554F4342454D426A31725251674A49557730';
wwv_flow_imp.g_varchar2_table(332) := '51774B464E563438515977334342493749412B67554163456B536873617967714C514D624631526E4D544E554D4145424642734E4151494343556872506A74315942776B41414141417741414141414337674B4B41414D414277414C4141415445544D52';
wwv_flow_imp.g_varchar2_table(333) := '4D78457A45544D524D7848365A47526B5A4751436976326F416C6A3971414A592F6167435741414141416B4141502B69413777444951414441416741496741784145634158414278414951416C5141414151594849514D57467945324577596A42676347';
wwv_flow_imp.g_varchar2_table(334) := '42785958466A63324E7A59584E686357467A596E4A69636D427959584268635746785958466863574E69596E4A696346426763474477454742775958466A63324E7A59334E6A38424E6A633241515948426863574651594842676347466A34424E543442';
wwv_flow_imp.g_varchar2_table(335) := '4A793442425159484268635746525958466863574E54516E4A69636D4E533442415159484267634742794947427759584E6A63324E7A5975415155474678595846686357467A596E4C67456A4A69384241665267594147417747517A2F74497A61417763';
wwv_flow_imp.g_varchar2_table(336) := '4B52496543676755444277524341344A47544D644468594C4368775946516A7149417347486734464B6949554651514F4F6B5839385230624542734F4451734D41775164445259514367385144526B4643414B5A46415543416745424177736741684159';
wwv_flow_imp.g_varchar2_table(337) := '457863544267494E2F4B5158424149484241734944524D69454167434577454E417134544A423450476863524A514D45467A63314E4377484167333932526F464242595245303945467751444A5246514F4159434D71797441536130576C6F4231514942';
wwv_flow_imp.g_varchar2_table(338) := '4251675846414942427755424167494342674D424651344D426751424155384B4651306144415576506730544B4174664B776F4D4852456D45773059476738544268416B48413057447777574442542B30515555437830514341304A5154775244675154';
wwv_flow_imp.g_varchar2_table(339) := '446A4A744E67634A4567555A44694958435330594A686F464751386C4641632F5051674C2F724D4A4678494A445159564451384C43686F594A6763544467454B4567345344516F7343517350444255594D514D41414141524141442F6F774F3441794941';
wwv_flow_imp.g_varchar2_table(340) := '44774166414445416441444B41536742637747324167344357774B654176594454414F4F41394D4548775270414141424A675948426834434E7A34424E7A596D4A7959484E68344344674D75416A59335067455842673842446745574678592B41547342';
wwv_flow_imp.g_varchar2_table(341) := '4E534D324E79596E4B77455649773844465238454D7A637A4E7A4D584D78637A467A4D584D78637A4877597A507755314C77496A4C776B6A4A794D6E4979636A4E513845497738424651636A4477456A427855484977636A42794D484651384449785550';
wwv_flow_imp.g_varchar2_table(342) := '4152555041694D50415238464D7A38644D7A38444C774D6A42513846487859564877517A507751314A7A55764344556E4E5338454979636A4A7A557641534D6E4E5363314C774531497938424E53636A4A7A5576416A5576424155504252556A46516356';
wwv_flow_imp.g_varchar2_table(343) := '4278556A465163564678557A46526356467855584652384A4D7A38454E5338434E5363314A7A556E4E5363314A7A55334E5463314E7A55334E5463314C775546447755564278555044785566425438434E5438424E54637A4E7A552F416A4D2F436A5533';
wwv_flow_imp.g_varchar2_table(344) := '4C77516A4251384648774956467855584D78637A4877497A4877457A46526356467855584D7838424D78637A467855584652384246523843465238434D7A38464E533864425138494977636A42794D484977636A42794D504242556642544D314D7A637A';
wwv_flow_imp.g_varchar2_table(345) := '4E7A4D334D7A384C4D7A637A50774531507745314E7A552F4244557642434D444B7745484977636A46534D4849773848465238454D7A637A4E7A4D334D7A637A4E7A4D584D78637A467A4D584D78637A507755314C77556A4A794D314979636A4A786350';
wwv_flow_imp.g_varchar2_table(346) := '4252385A507751314C774D6A4A7A556E4E53636A4C77456A4C7745314A794D6E4E533842497938424E5363314A794D314A794D6E497938424E533842497963314A794D7641675550416855484977384246513843465163564278555041534D5041525550';
wwv_flow_imp.g_varchar2_table(347) := '4168555041534D5041534D50415255484651384249773843465238464D7A385A4E533845497745504178554846785548465163564278554846513849465238444D7A38474E546331507763314E7A557A4E5463314E7A556E4E5338444977555042425558';
wwv_flow_imp.g_varchar2_table(348) := '465263564678555846523848465263564877497A465238444D7A38454E53384C4E5363314A7A556E4E5363314C77516A45773845465238464D7838424652637A467A4D664152556641544D58465238454D78637A4877597A507755314C78634644786356';
wwv_flow_imp.g_varchar2_table(349) := '4877597A5077677A507751314E7A4D334D7A6331507745315077457A507751314C77516A416652416278635A47465A2B4F6A3152415152454F5373794A6B677A457734725156424C4F426F4A4668685159776B5548516B4A424167454351304557566B53';
wwv_flow_imp.g_varchar2_table(350) := '4A67342F4241344E436755484267494341776749424145494243594543414D45424151484241674447674D494277634443515545424151444241454541776342417755454241514542416B454A67514A425151454251327842514D474277454443414D42';
wwv_flow_imp.g_varchar2_table(351) := '46514D4241774D424351454D41516B4A41774D4341514944417767454151514341674944417767454251514A417767444167514441674D434177494441674D444177494441774D4441774D44417759444977494442415143416755454341554268415145';
wwv_flow_imp.g_varchar2_table(352) := '42414D444177454741774D434177494441674D4341776357415151424241454741774943424151444241554A424151454177514241674943415149424167454341674942415145494151454241674945415149484177494241674D434151494741776B44';
wwv_flow_imp.g_varchar2_table(353) := '41774D45436633484241674441774943415149424151454241514543415167434151454241774D45424151464351514441775142416755444167454241514542415149424151494441776B45416F30464241514442414943427749444251494541514944';
wwv_flow_imp.g_varchar2_table(354) := '44416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A415149434177514942663275424151454177494341675547444159424441454742774D4241774D42427763444151634841514D42';
wwv_flow_imp.g_varchar2_table(355) := '417751494241514D4241514542416B4542415146416745424241514446514D454367635A41776F4341774D4441774D44417749474177494441674D4343413442705151454151634B484173484567514C4241634542416345434151514341514441674942';
wwv_flow_imp.g_varchar2_table(356) := '42415144424155524451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D454251536E425159474377554D425155474A67594B4341514341774542416759454351517242516B4642515546';
wwv_flow_imp.g_varchar2_table(357) := '4367556542516F464251554643675159435155454177514541514545417751484A6755474251734743776276424155444241514341676743444163494277514442414D454177634742773843435149444551514442416B4A424151444241454341774942';
wwv_flow_imp.g_varchar2_table(358) := '41674D434151495341516B454267454442414D42417767454177454441514D4243415145424145454341454543676A39394151494251514242415145444151454241674441514D454177514442416B424477494241674D444251494242414D4441514944';
wwv_flow_imp.g_varchar2_table(359) := '41776745435155484251555142674947416738484267634442414D45417751484341514542774942416749444241674541713845434159434151454241514543434149424167494541525942415151444441554A4241594642414D4B4167674241674543';
wwv_flow_imp.g_varchar2_table(360) := '416749484151454241514545417751494250796D42415149424149424151454342674943416745454151594343674D4541514D474241554A4241514541775143415249424167454341514943416763434151454241514948417755456C41554542674943';
wwv_flow_imp.g_varchar2_table(361) := '41514944417755454151514E4351454E4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D4642415546424155464243556543415145435177444451304347675146417745554241514A';
wwv_flow_imp.g_varchar2_table(362) := '43425973425155454251554642415562424159454151454341774D454241514A417759464377554642515955415234464367554642414545415151464841304541515146417749424167494442416745416A5142537A733567466B654652567451443578';
wwv_flow_imp.g_varchar2_table(363) := '4768556E415349395355772F4B4163614F453152495355734D68496A4E67455045514D444151595A496B5149375145434167554D42516B454177594341514542415145434167634341674D434167494241674D444341554A43414D464167454341514942';
wwv_flow_imp.g_varchar2_table(364) := '41674943435149424151456E4151454442514945415149504177494241676B4D4351454A42414D4441514D4441514D4C4277634A43515144424151424151514444414D4542674D4441674D4441774D44417749444177494441674D434177494442414D57';
wwv_flow_imp.g_varchar2_table(365) := '41774D4943516B4841775138415145444177514E4251734341774D4441774D4441674D4443694D4442774D484241344C4177634443414D44416745424177494543416B454167514A42415145424151464177454441514D4541514D5142414D4241776744';
wwv_flow_imp.g_varchar2_table(366) := '41516F4241774D4241774D4241774D424267514A41514D4341774D437177454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D444167454341674D4543416B4642424945437751484241514842416745';
wwv_flow_imp.g_varchar2_table(367) := '48675149424163454241634542416B45424151444241463341514944417767484241634547674D4C4377634742414D4846413844427745494251514643414D44416749434167634241785542417773424278414542417745424151454241514A42435946';
wwv_flow_imp.g_varchar2_table(368) := '4251674542414D456F51494341774D4543516B4A4267454D4151594D42675544417749424241454541514946424149434151454242414542415159424151454341514543417763464241554543414D444351494242674D514177594441674D4341774944';
wwv_flow_imp.g_varchar2_table(369) := '41674D4741674D4441774D4442774E4E415149424177594D41774D46417749424151454541774D454351554543414D4441674542415145434351494341674543415149424151454341674942415145454151454242515144425151464341674441674543';
wwv_flow_imp.g_varchar2_table(370) := '7A67454241514548416749454177514542416B454251594441676B4341514542415145424167554241674D444341514642416B4441774D484151454241564D424167494542776B4A4367454A427759484177514442414D45427767484641514E42415167';
wwv_flow_imp.g_varchar2_table(371) := '41774D434167494341774D49435155474251554541515142424155634451514243415142424151454341454441514D42417751494177454442414D424267514841676F42424151424177514441514D4D4177454441514D42434151454241454542415142';
wwv_flow_imp.g_varchar2_table(372) := '4241305842515545415151424351554B425177454251514541775142416755484442344942416B45464163494277514442414D454177634742414D4842515145435151454177542B78514545434151454241516542516F46425155464351556E42515146';
wwv_flow_imp.g_varchar2_table(373) := '43516F454D67514642416745426749434267674B42526B424241455542675546425173474A675547425173474377595742676B4941774D4545414542426767494351595242515946426773464951594C4251554B426738424241455A42516F4242415943';
wwv_flow_imp.g_varchar2_table(374) := '4151454441675149435167424B5151464251514642516B464967554A4251554642516F4646775545427749432F72494241775945435155454241514342514D454351454743514D4341514944416745434177514443674949415149424167494441514944';
wwv_flow_imp.g_varchar2_table(375) := '4177674642416B4541774D444241494241674543415149424542414741674D4643514D4B41774D4241674943447749444251594D46414543415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D43';
wwv_flow_imp.g_varchar2_table(376) := '41514944416745434567454A42414D464241514542516B4541774D454141594141502B56413734444A414162414445415351426741473041656741414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A5958';
wwv_flow_imp.g_varchar2_table(377) := '4668635746785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E68635546534D564D78557A4E544D31';
wwv_flow_imp.g_varchar2_table(378) := '497A55484D6A4D564D78556A46534D31497A557A41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B';
wwv_flow_imp.g_varchar2_table(379) := '4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E50556F596E3539366E3539684A5353666E306D676F414D69416A5931576C3173584C5A4A5369676F437877646436525A57314E54';
wwv_flow_imp.g_varchar2_table(380) := '6869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B44733949697464';
wwv_flow_imp.g_varchar2_table(381) := '546B35386E4A78386E4269645370326453674141427741412F35554476674D6B414273414D51424A414741416151427441484D414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A6763324678595846686357';
wwv_flow_imp.g_varchar2_table(382) := '4267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A595842673842467A55584551636E4642556E4A525156';
wwv_flow_imp.g_varchar2_table(383) := '4A79596E41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B32655030464642423467';
wwv_flow_imp.g_varchar2_table(384) := '50444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570464E6D77763063724B474938425753704449674D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A';
wwv_flow_imp.g_varchar2_table(385) := '574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969756A4A6B30686C492B50415369505947526C';
wwv_flow_imp.g_varchar2_table(386) := '5A47566C5A523477467741444141442F6D674F34417949414541415541454941414145694277454746426342466A4933415459304A77456D42776B434E7949504242384344774966424438434877492F4243384350774976424138434A7A556E41665150';
wwv_flow_imp.g_varchar2_table(387) := '432F356843676F426E777366436747664377762B595173504159622B6576353639414943424138444151454469596B4441514544447751454251534A69515146424151504177454241346D4A41774542417738454241554569596B454179494C2F6D454B';
wwv_flow_imp.g_varchar2_table(388) := '4877762B59516F4B415A384C48776F426E77732B2F6E722B6567474772514544447751454251534A69515146424151504177454241346D4A41774542417738454241554569596B454251514544774D4241514F4A695145434141414141414D4141502B57';
wwv_flow_imp.g_varchar2_table(389) := '4137384449674162414449415377414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442427759484677594846686333467A5933';
wwv_flow_imp.g_varchar2_table(390) := '4A79596E4E7A59334A6963474477456D4A77487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E443039495279737341514E414F547849527041334F5449514A69684149314A48485470774F4459714C473578';
wwv_flow_imp.g_varchar2_table(391) := '4F68346D4D686B6C4D5267714C426B774A526B79417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A35424978555762683436635459344C437075';
wwv_flow_imp.g_varchar2_table(392) := '63446F644A6A495A4A54415A4C436F594D53555A4D674141436741412F35494477514D6A414277414E77425241476F416277427A414863416577422F41494D414141456949794948426763474277595746785958486745334E6A632B415463324C67456E';
wwv_flow_imp.g_varchar2_table(393) := '4A69636D427A497A4E68635746785958466759484267634F4153636D4A79596E4A6A63324E7A34424679496A496763474277594842685958466863574E6A63324E7A34424A79596E4C6745484D6A4D794678595846686357426763474277597541536375';
wwv_flow_imp.g_varchar2_table(394) := '415463324E7A344242785552495245464D78456A4578557A4E5163564D7A554846544D314278557A4E51487A41514A6A586C74415168595648693476534569795756784C536D67564668746553456C574F4473464256785756446B36447841714E44564B';
wwv_flow_imp.g_varchar2_table(395) := '544C5254565473394852774A436934317547344642565250537A4930435173324F44704D534A314652693077486851564E6A4F4F54774D44533056444B797747434463314F4556456A3359674967496649546F6F593251424C7637712F7634617973724B';
wwv_flow_imp.g_varchar2_table(396) := '7973724B79674D694C69314F554746577330314F4D7A5571446738774C704657563632624E6A6355446A45424C53744D54567453714552474A796F4B49434641503164555756744B56326B724B797049535652506E5473384778734E4A53592F514B4E50';
wwv_flow_imp.g_varchar2_table(397) := '556A7336517A416E4A6B42425330654C4D6A515346427456506B4357516B557248794A3544503651415877592F7251424A786B5A53686759565267595452675941414141454141412F364D4475414D694141734146774261414C49424341464C41614142';
wwv_flow_imp.g_varchar2_table(398) := '2F514A49416F6F437A674D52413267447451514242457341414145564978557A46544D314D7A556A4E51637A46544D564978556A4E534D314D784D784977636A42794D564977636A447763564877517A4E7A4D334D7A637A4E7A4D334D78637A467A4D58';
wwv_flow_imp.g_varchar2_table(399) := '4D78637A467A4D2F4254557642534D6E497A556A4A794D6E46794D504252385A507751314C774D6A4A7A556E4E53636A4C77456A4C7745314A794D6E4E533842497938424E5363314A794D314A794D6E497938424E533842497963314A794D764151556A';
wwv_flow_imp.g_varchar2_table(400) := '4477495642794D504152555041685548465163564477456A44774556447749564477456A4477456A447745564278555041534D504168556642544D2F47545576424345784978556A44774D564877517A4E7A4D334D78637A467A4D584D78637A467A4D66';
wwv_flow_imp.g_varchar2_table(401) := '426A4D2F4254557641694D7643534D6E4979636A4A794D3142794D5041694D5041525548497738424977635642794D484977636A4278555041794D56447745564477496A4477456642544D2F48544D2F4179384442513846487859564877517A50775131';
wwv_flow_imp.g_varchar2_table(402) := '4A7A55764344556E4E5338454979636A4A7A557641534D6E4E5363314C774531497938424E53636A4A7A5576416A55764177556A44775556497855484651635649785548465263564D785558465263564678556643544D2F42445576416A556E4E536331';
wwv_flow_imp.g_varchar2_table(403) := '4A7A556E4E5363314E7A55334E5463314E7A55334E53384542534D504178554846785548465163564278554846513849465238444D7A38474E546331507763314E7A557A4E5463314E7A556E4E53384442534D5041785558465263564678555846523848';
wwv_flow_imp.g_varchar2_table(404) := '465263564877497A465238444D7A38454E53384C4E5363314A7A556E4E5363314C7751464977384646516356447738564877552F416A552F415455334D7A63315077497A50776F314E7938454251384648774956467855584D78637A4877497A4877457A';
wwv_flow_imp.g_varchar2_table(405) := '46526356467855584D7838424D78637A467855584652384246523843465238434D7A38464E53386342534D5043434D484977636A42794D484977636A447751564877557A4E7A4D334D7A637A4E7A4D2F437A4D334D7A38424E5438424E54633150775131';
wwv_flow_imp.g_varchar2_table(406) := '4C775146447755564877557A48774556467A4D584D783842465238424D7863564877517A467A4D66426A4D2F425455764669456A447863564877597A5077677A507751314E7A4D334D7A6331507745315077457A507751314C775142726E31396A483139';
wwv_flow_imp.g_varchar2_table(407) := '64563539665635396653384C4267734644415546426959474367674541674D424151494742416B454B77554A4251554642516F464867554B4251554642516F4547416B4642414D454241454242414D45427959464267554C426773473941554542514D45';
wwv_flow_imp.g_varchar2_table(408) := '424149434341494D4277674842414D4541775144427759484477494A41674D5242414D4543516B4542414D45415149444167454341774942416849424351514741514D45417745444341514441514D424177454942415145415151494151514B2F664546';
wwv_flow_imp.g_varchar2_table(409) := '42416746424145454241514D4241514543414D424177514442414D45435145504167454341774D464167454541774D4241674D444341514A4251634642524147416759434477634742774D454177514442416349424151484167454341674D4543414545';
wwv_flow_imp.g_varchar2_table(410) := '4567304B425163474167494443416745415167454A675149417751454241634543414D614177674842774D4A4251514542414D45415151444277454442515145424151454351516D42416B4642415146446130454341594841514D494177455641774544';
wwv_flow_imp.g_varchar2_table(411) := '4177454A4151774243516B444177494241674D44434151424241494341674D444341514642416B4443414D4342414D434177494441674D4341774D4441674D4441774D4441774D4442674D6A41674D454241494342515149415951464341514441774D42';
wwv_flow_imp.g_varchar2_table(412) := '42674D4441674D434177494441674D48466745454151514242674D4341675145417751464351514542414D45415149434167454341514942416749434151454243414542415149434241454342774D43415149444167454342674D4A41774D4442503344';
wwv_flow_imp.g_varchar2_table(413) := '4251514941774D43416745434151454241514542416745494167454241514D444241514542516B4541774D45415149464177494241514542415145434151454341774D4A4175344642416747416745424151454241676743415149434241455741514545';
wwv_flow_imp.g_varchar2_table(414) := '417777464351514742515144436749494151494241674943427745424151454242414D454350796E42516749424149424151454342674943416745454151594343674D4541514D474241554A424151454177514341524942416745434151494341676343';
wwv_flow_imp.g_varchar2_table(415) := '41514542415149484177554338415146424151444241494342774944425149454151494444416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A41514943417751492F61304543415144';
wwv_flow_imp.g_varchar2_table(416) := '416749434251594D4267454D41515948417745444177454842774D42427763424177454442416745424177454241514543515145424155434151454542414D564177514B42786B444367494441774D4441774D444167594441674D4341774949415A7746';
wwv_flow_imp.g_varchar2_table(417) := '4241514242776F63437763534241734542775145427751494242414942414D434167454542414D45425177464451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D454266354542415545';
wwv_flow_imp.g_varchar2_table(418) := '4267494341514944417755454151514E4351454E4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D464241554642415546424355654341514543517744445149534251514641774555';
wwv_flow_imp.g_varchar2_table(419) := '4241514A43425973425155454251554642415562424159454151454341774D454241514A4177594643775546425159554152344643675546424145454151514648413045415151464177494241674944424167434958324D6658324D66526439586E312B';
wwv_flow_imp.g_varchar2_table(420) := '58514756415145424151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B41516B484267634442414D45417751484341635542413045';
wwv_flow_imp.g_varchar2_table(421) := '4243414441774943416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D454177454444414D4241774544415167454241514242415145';
wwv_flow_imp.g_varchar2_table(422) := '4151514E467755464241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D4541514943425177464351514442674942415145424151494342774943';
wwv_flow_imp.g_varchar2_table(423) := '417749434167454341774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B424351514441774544417745444377634843516B454177514541514545417777444241594441774944';
wwv_flow_imp.g_varchar2_table(424) := '41774D4441774D4341774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48417767444177494241514D434241674A4241494543515145';
wwv_flow_imp.g_varchar2_table(425) := '4241514542514D4241774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D4441674543';
wwv_flow_imp.g_varchar2_table(426) := '41674D4543416B464242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B424449454251514942415943416759494367555A41515142';
wwv_flow_imp.g_varchar2_table(427) := '464159464251554C426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F42424159434151454441675149435167424B5151464251514642516B464967554A';
wwv_flow_imp.g_varchar2_table(428) := '4251554642516F4646775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C415163514241514D42415145424151454351516D4251554942415144';
wwv_flow_imp.g_varchar2_table(429) := '424B414242414D4442416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B434151594445414D474177494441674D434177494442674944';
wwv_flow_imp.g_varchar2_table(430) := '41774D444177644B415149424177594D41774D46417749424151454541774D454351554543414D444167454241514543435149434167454341514942415145434167494241514545415145424251514442515146434167444167456E415145444267514A';
wwv_flow_imp.g_varchar2_table(431) := '42515145424149464177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D45416745434151494241674551454159434177554A41776F4241674943447749444251594D46414543';
wwv_flow_imp.g_varchar2_table(432) := '415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D45414141414141674141502B61413767444967415541436B414C674179';
wwv_flow_imp.g_varchar2_table(433) := '414459414F67412B41454941414145694277594842685158466863574D6A63324E7A59304A79596E4A6763794678595846685148426763474969636D4A7959304E7A59334E6763564553455242544D5249784D564D7A554846544D314278557A4E516356';
wwv_flow_imp.g_varchar2_table(434) := '4D7A5542394870715A6A772B506A786D617652715A6A772B506A786D616E7075586C73314E7A633157313763586C73314E7A6331573134704153372B3676372B4773724B7973724B79736F44496A34385A6D7230616D5938506A34385A6D7230616D5938';
wwv_flow_imp.g_varchar2_table(435) := '506A45334E567465334635624E5463334E567465334635624E54665644503651415877592F7251424A786B5A53686759565267595452675941414141436741412F36494475414D67414138414877417841477741315146654162734341674A4D41726741';
wwv_flow_imp.g_varchar2_table(436) := '4141456D4267634748674933506745334E69596E4A6763324867494F417934434E6A632B415263474477454F41525958466A34424F774531497A59334A674D724151636A42794D4846513846465238464D7A38444D7A637A4E7A4D334D78637A467A4D58';
wwv_flow_imp.g_varchar2_table(437) := '4D7838424D7A38444E533845497A556A4A794D6E467738474652384B4D783847465238434D78384E4D7A38454E5338424E53636A4C77596A4C7745314979384C4979384249793848497A556E4E5338454977555041534D50424255504242554849776356';
wwv_flow_imp.g_varchar2_table(438) := '44774D6A4651635642794D564477515642794D50415255504168555041694D5041785550417855484651384B465163564877512F42444D2F4244552F4A6A5576417745504252555846516356427855484651635642785548465163564278554846516356';
wwv_flow_imp.g_varchar2_table(439) := '4278555042785566424438464D7A38424D7A38424E5438424D7A637A4E7A55334E544D314E7A55334E5463314E7A55334E5463314E7A55334E5363314C77514644775556467855584652637A4877557A4877455646785558465263564D78635646785566';
wwv_flow_imp.g_varchar2_table(440) := '424438454E53384E4E5363314A7A556E4E533844415138584877512F42444D2F417A4D334D7A637A4E7A4D334D7A63314E7A4D334E54637A5077497A4E7A4D3150774D314C7751464477555648774D564877457A4877497A487749564877457A48774556';
wwv_flow_imp.g_varchar2_table(441) := '4877457A467A4D584D78637A4877497A467A4D5846544D66427A4D584652637A46544D584D7A38454E5338454979636A4A794D6E4979384B4979384549793846497748305147385847526857666A6F395551454552446B724D695A494D784D4F4B304651';
wwv_flow_imp.g_varchar2_table(442) := '537A67614352595955474D4A4642304A4351514942416B4E42466C5A4569594F4F77634E4267304E4279634E446751444177514241674D4443515146426777474677594C4267594742696B4742675947426755664241554D41774D434167594443696347';
wwv_flow_imp.g_varchar2_table(443) := '4277594E422B6B4642415144417745434167494741674944426755454177674244674949416759434241454341674543417749444251514442414D4B425159444351514A4241514442414945426745454177494441674D43415149494151554442414945';
wwv_flow_imp.g_varchar2_table(444) := '4167494641676343416745434351454341674D4841774944416745434177494741676F462F664D46427745434177494441674D43417749444241454341674D4342414545424145434167494341674942416749434241494342414542415149444167494B';
wwv_flow_imp.g_varchar2_table(445) := '4151494341674545415149424167454341514943415151454177344543415144415145434177454341674942416745434151494241674944416745434341494241674943415151434241454741676F4342674D4B4177594442514D434151514743415543';
wwv_flow_imp.g_varchar2_table(446) := '736751464177594341514542415145424151454341514D464177554442414D4342674D4241674D4742416B4A42415144416745424177494241674D44416745464151774441514942415145424151454241515144424151492F4B594542514D4542414542';
wwv_flow_imp.g_varchar2_table(447) := '41774942417749424241454B4151514441674D43415149444151494542776B4A424151444241494541674D43427751424267454341514949415145424151554943414B784241514A4241554B42413846425173504267554C425345474378414942415543';
wwv_flow_imp.g_varchar2_table(448) := '416751444241304A4267595542514553426763464151554242514546415277424377554242515542425173504151514241774D4341515144424151492F643445424151444167494241674D454451494241674D4341514944417773434151674441775542';
wwv_flow_imp.g_varchar2_table(449) := '416745434151494241674D44415149424167454342414D4741773044485149444451514444516B46434155434151514442415144424167444641495241776B464551494742514D464251554341513843425149434151514442424545424155434E41464C';
wwv_flow_imp.g_varchar2_table(450) := '4F7A6D415752345646573141506E456146536342496A314A5444386F42786F34545645684A53777945694D324151385241774D4242686B69524167425341454342674543424149444241674A425151454177514241674943424149424151454241515542';
wwv_flow_imp.g_varchar2_table(451) := '426751444351554943414945426745424155384241514D444241514542516B4542674543415159444241494944674D49417759444241454341674D45417751444277634443414D53436767434241494341774D4943676348415177494241514542415145';
wwv_flow_imp.g_varchar2_table(452) := '4241734242774D47416759434177554442774D4341776B44416749484167494341674542415149434241494644414545416749434167494241674943416749424241494241674944424145454151514241674D434177494241674D434151494741674543';
wwv_flow_imp.g_varchar2_table(453) := '42674D44416755434151495041774942416745434177594441774D4441774D44417745454351554941774D44415151444177514742514D43425145434177494441674D4341774D4342514944416777434177494441674D454177514442674D4B41775943';
wwv_flow_imp.g_varchar2_table(454) := '43674547416755454241514A435159454166374741514943434151454241517A41776B444267494741774D4441774D444267494441776B4344674D4941513046437755474367634542516B45426749434167494441774D4442675947425145464277386D';
wwv_flow_imp.g_varchar2_table(455) := '41776F444177634441775144417751444177514442774D4F417977464351674541674D434577454341774D494242734742784D4844524D47427730474877304641515542425145464151554242514542424151454167494341774D4A4351674742675547';
wwv_flow_imp.g_varchar2_table(456) := '45417347455155474267557642675547426777474277554842674C2B73674543426751454267514A42414D464351494442414D4D4151514442414D4843516B4941774D4441674942426749474177494441674D444477594241774D424177514844415142';
wwv_flow_imp.g_varchar2_table(457) := '4177514542416B4942414D43416749424177494542416B45425151454177454B4167494341674943415145484167554241514544416749424167454341514542415145434167494541676B424151514242414545427755454351674541674D4241776347';
wwv_flow_imp.g_varchar2_table(458) := '41774D474167494441514D434177494A41674D43415151424241304241674141417741414141414449414A5941414D414277414C4141415446534531425255684E51555649545849416C6A3971414A592F61674357414A595A4754495A4754495A475141';
wwv_flow_imp.g_varchar2_table(459) := '4141554141502F544139514336514163414659416467434B414A34414141456942676335415251584668634742775950415255684E53636D4A79596E4E6A55354154516D427A497A4678595846683842466863574D7A4579507745574652514842676358';
wwv_flow_imp.g_varchar2_table(460) := '466863574652595646413842446745694A6938424A6A55304E7A51334E6A38424A7934424E5451334D6A637A4E6763774D51595846686365415449324E7A59334E6963774D52595846534D314978556A4E534D56497A55324579494F4152555246423442';
wwv_flow_imp.g_varchar2_table(461) := '4D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B415146494A5449424367594A49686365447745425441455048686368467A464A4167494544776B47426749464177594B44416F454267554745674947';
wwv_flow_imp.g_varchar2_table(462) := '436749424151454A48695165435145424151494B4251494543673449417745434353494341514947444359714A677747416745434D684977464A77564C784D4F4E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C';
wwv_flow_imp.g_varchar2_table(463) := '5069516B50674A6A4D534D534667344C4441385548414B46685149634641384D46796F6A4D5338424151494342414545415149464177775046673050437849424241594742416B434167454B43676F4B41514943435151474267514246414D4949673452';
wwv_flow_imp.g_varchar2_table(464) := '45414544676777474441554E4451304E42517747444259676245784D544578734967464C4E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B414141464141414141414F5041704D4141774148';
wwv_flow_imp.g_varchar2_table(465) := '4141734144774154414141544553455242544D56497A6368465345484D78556A4E79455649566B444E767A746E352F434169373930734B666E3849434C763353417050396C774A703061327472534F6C70615541417741414141414455674B3841415141';
wwv_flow_imp.g_varchar2_table(466) := '434141554141415446524568455155684553454246534D564D78557A4E544D31497A575741727A3963414A6B2F5A7742425A7562577075624172775A2F56304376437A396E4148366D3171626D317162414141414141514141502B574137304449674158';
wwv_flow_imp.g_varchar2_table(467) := '41444D415077424C414141424967344446686365416A632B415463324E7A596E4C67456E4A694D584D6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B4168634846534D564D78557A4E544D31497A55484D78557A46534D56';
wwv_flow_imp.g_varchar2_table(468) := '497A556A4E544D423846656C66305142514430376F6242525649596E4B514D4748683532546C357243465651546A6B36466863584B797845526C7059566C68445179636D41774D6A486E4B5554305A3966597839665856656658316566583044496B5A39';
wwv_flow_imp.g_varchar2_table(469) := '6F624F6D506A394A43523464656C4654574664565534636D4C7A456E4A6B4A45556B2B6E53456F764E424150466859354E5646505631704F5358412B416442396A4831396A48305866563539666C304141414141424141412F35594476514D6A41425941';
wwv_flow_imp.g_varchar2_table(470) := '4D514137414551414141456D44674D57467834434E7A34424E7A59334E6963754153636D427A5958466863574678594742775948426763474A79596E4A69636D4A79593350674958426738424A774D334E6A635841785958466863334279634841665259';
wwv_flow_imp.g_varchar2_table(471) := '706F4645415541394F364777555653474A796B4442683465646B356561315A5355446F37467863584B797845526C7059566C68445179636D41774D6A486E4B552F4245694D3442304630676A686F6B48446B4D69486831384D674D6941555A2B6F624F6D';
wwv_flow_imp.g_varchar2_table(472) := '506A394A43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C7750744D6A52576D6D2F716F65577936614151594A456C55715133535254514141426741412F35554476674D6B';
wwv_flow_imp.g_varchar2_table(473) := '414273414D51424A414741415A414270414141424A6763474277594842685958466863654154632B416A63324A7934424A79596E497959484E68635746785958466759484467456D4A7934434E7A5933506745584A676347427759484268635746785958';
wwv_flow_imp.g_varchar2_table(474) := '466A59335067496E4A696375415163324678595846676357426763474277596D4A79596E4A6A59334E6A63324677594849514D574679453241664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A';
wwv_flow_imp.g_varchar2_table(475) := '4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E5055705659474142674D426B4D2F3753';
wwv_flow_imp.g_varchar2_table(476) := '4D774D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D697377';
wwv_flow_imp.g_varchar2_table(477) := '4D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969746A724B30424A72526157674141414141474141442F6C514F2B417951414777417841456B4159414271414855414141456D427759484267634746686357467834424E7A3443';
wwv_flow_imp.g_varchar2_table(478) := '4E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A6332';
wwv_flow_imp.g_varchar2_table(479) := '4E7A5946426738424A774D334E6A6358417859584668633342796348426763423832786C59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66';
wwv_flow_imp.g_varchar2_table(480) := '573156524D6A55424243516B51555253545A342F51555545486941384D487843554570484B7977424155672B514574486A444D32464255554A796339536745434553497A6748515853434F476951634F517949654858774F47517344496749324E567064';
wwv_flow_imp.g_varchar2_table(481) := '6246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C';
wwv_flow_imp.g_varchar2_table(482) := '6979777642776B784D7A5646517041375053497264694E466161622B716835624C706F4242676B5356537044644A45574A424D4141414D4141502B574137384449674162414449414F77414141534948426763474277595746785958486745334E6A632B';
wwv_flow_imp.g_varchar2_table(483) := '415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442467759504152633146784548416574735932412F51416F4C4F54302B56453630553164415131414942783062655646545751305054306848';
wwv_flow_imp.g_varchar2_table(484) := '4B79774241304135504568476B4463354D68416D4B45416A55686B3262432F5279736F44496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B774D596558506B456A';
wwv_flow_imp.g_varchar2_table(485) := '465261694A6B30686C492B504153695041414141424141412F2F414471774C4D41424D414B7741764144774141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F41537342455345524979497541545552';
wwv_flow_imp.g_varchar2_table(486) := '4E443442457945524954636441534D564D78557A4E544D31497A58594B6B63714B6B6371416A6B7152796B7052797239787749354854456348444564645036756378307848427778727745552F75787A54553075545530437A436C484B7635594B6B6370';
wwv_flow_imp.g_varchar2_table(487) := '4B5563714161677152796B77484445642F6C67644D5277424E50374D48444564416167644D527A2B6D663773375263324C6B314E4C6B304141414141424141412F2F414471774C4D41424D414B77417641444D4141424D69446745564552516541544D68';
wwv_flow_imp.g_varchar2_table(488) := '4D6A34424E5245304C67456A42534579486745564552514F415373424553455249794975415455524E44344245794552495463564D7A58584B6B63704B556371416A6F7152796B7052797239786749364854456348444564645036756442307748427777';
wwv_flow_imp.g_varchar2_table(489) := '734145552F75776C79774C4D4B5563712F6C677152796B7052796F42714370484B5441634D52332B57423078484145302F7377634D523042714230784850365A2F75756E4C7938414141494141502F77413673437A4141544143634141424D6944674556';
wwv_flow_imp.g_varchar2_table(490) := '4552516541544D684D6A34424E5245304C67456A42534579486745564552514F41534D68496934424E524530506748584B6B63704B556371416A6F7152796B70527972397867493648544563484445642F6359644D4277634D414C4D4B5563712F6C6771';
wwv_flow_imp.g_varchar2_table(491) := '52796B7052796F42714370484B5441634D52332B57423078484277784851476F48544563414141444141442F6C674F2F41794941477741794144774141414569427759484267634746686357467834424E7A5933506745334E6963754153636D4A795948';
wwv_flow_imp.g_varchar2_table(492) := '4E6863574678595846675948426763474A696375415459334E6A632B415263474477456E417A63324E7863423632786A5944394143677335505435555472525456304244554167484852743555564E5A44513950534563724C41454451446B3853456151';
wwv_flow_imp.g_varchar2_table(493) := '4E7A6B794543596F51434E53316845694D3442304630676A68674D694E7A5A62585774637430644B4A79594C484230374F61465957314E5669796B714241474F41696B6F5255645053596B754D51774F4B5441786835632B51534D56466E556A52576D6D';
wwv_flow_imp.g_varchar2_table(494) := '2F716F6557793661414141474141442F6C514F2B417951414777417841456B415941427241486B414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C674933';
wwv_flow_imp.g_varchar2_table(495) := '4E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A5958426749484E6A63324E78636D4C7745574877456E42676347427759334E6A6332';
wwv_flow_imp.g_varchar2_table(496) := '41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238';
wwv_flow_imp.g_varchar2_table(497) := '516C424B5279737341514649506B424C5234777A4E6851564643636E505570564745305846796F6E4648305A4D54494D46694A4543426B5342676F4243785157417949434E6A566158577863746B6C4B4B43674C4842313370466C6255314F474B436B46';
wwv_flow_imp.g_varchar2_table(498) := '416A45444D544254566D4E59724542444F7841724C492B7A56566C4352453472417A417654314A625531424F4E6A6751454355774D6F7969535577794B7A417741697771526B7051533473734C77634A4D544D3152554B514F7A30694B3239432F764E42';
wwv_flow_imp.g_varchar2_table(499) := '467A41724659644F6E6C456B5357354B427830554277734749554E4D414141414141634141502B5341384544497741634144634155514271414873416A4143654141414249694D69427759484267634746686357467834424E7A5933506745334E693442';
wwv_flow_imp.g_varchar2_table(500) := '4A79596E4A6763794D7A59584668635746785947427759484467456E4A69636D4A7959334E6A632B4152636949794948426763474277595746785958466A59334E6A632B4153636D4A793442427A497A4D6863574678595846675948426763474C67456E';
wwv_flow_imp.g_varchar2_table(501) := '4C6745334E6A632B415263694267634748674933506745334E69596E4A694D584D68344344674D75416A593350674566415159504151344246686357506745374154556A4E6A636D41664D42416D4E6557304243466855654C693949534C4A5A5845744B';
wwv_flow_imp.g_varchar2_table(502) := '6142555747313549535659344F77554658465A554F546F5045436F304E55704D74464E564F7A306448416B4B4C6A5734626755465645394C4D6A514A437A59344F6B78496E5556474C544165464255324D34355041774E4C52554D724C4159494E7A5534';
wwv_flow_imp.g_varchar2_table(503) := '5255535064694169416838684F69686A4C7A397346786B59566E343650564542424551354B7A49454A555979457734725156424C4F426F4A466868514C44634A4642304A4351514942416B4E42466C5A4569594F417949754C5535515956617A5455347A';
wwv_flow_imp.g_varchar2_table(504) := '4E536F4F447A41756B565A58725A73324E78514F4D5145744B30784E57314B6F5245596E4B676F674955412F5631525A57307058615373724B6B684A56452B644F7A77624777306C4A6A39416F3039534F7A70444D43636D5145464C523473794E424955';
wwv_flow_imp.g_varchar2_table(505) := '4731552B514A5A4352537366496D464B4F7A6D415752345646573141506E45614653636A5045684D50796748476A684E5553456C4C41457845694D324151385241774D4242686B6952416741414141454141442F6C674F3941794D414667417841447741';
wwv_flow_imp.g_varchar2_table(506) := '536741414153594F4178595848674933506745334E6A63324A7934424A7959484E6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B41686347416763324E7A593346795976415259664153634742775948426A63324E7A5942';
wwv_flow_imp.g_varchar2_table(507) := '3946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D65637052504745305846796F6E4648305A4D54494D46694A4543426B5342676F4243785157';
wwv_flow_imp.g_varchar2_table(508) := '41794942526E36687336592B50306B4A4868313655564E5956315654687959764D51456D4A554E4556452B6E53456F764E424150466859354E6C42505631704F5358412B7A454C2B383045584D437356683036655553524A626B6F484852514843775968';
wwv_flow_imp.g_varchar2_table(509) := '51307741424141412F35594476514D6A414259414D51413141446F414141456D44674D57467834434E7A34424E7A59334E6963754153636D427A5958466863574678594742775948426763474A79596E4A69636D4A795933506749584267636841785958';
wwv_flow_imp.g_varchar2_table(510) := '495459423946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D656370525059474142674D426B4D2F37534D774D6941555A2B6F624F6D506A394A';
wwv_flow_imp.g_varchar2_table(511) := '43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C77507343737251456D744670614141634141502F544139514336514154414363414B77417A414463414F77412F41414154';
wwv_flow_imp.g_varchar2_table(512) := '49673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A49534975415455524E4434424678456845515568465345314978556A46544D56497A63684653454446534531317A565A4E54565A4E5149364E566F30';
wwv_flow_imp.g_varchar2_table(513) := '4E466F312F6359434F69552B4A43512B4A6633474A54346B4A4434424166722B477748502F716B57596D4A69654146582F716C32416330433654525A4E6635754E566B304E466B31415A4931575451384A44306C2F6D346C5053516B505355426B695539';
wwv_flow_imp.g_varchar2_table(514) := '4A456A2B684146386732686E5A78566D5A6D5942546D7873414141434141414141414E3941704D415367437A4141414249676335415159484F514547427A6B424267634748514555467A4178466863574D7859334F5145794E6A55304A7A4D794E7A5933';
wwv_flow_imp.g_varchar2_table(515) := '4D54596E506745304A7934424B7745324E546B424E43637541534D464E7A592F415459335067456E4C674576415445484D4449564D68633541525947427A6B4242673842446745564642637848674558466A7342466A637A4D6859584668514842697342';
wwv_flow_imp.g_varchar2_table(516) := '46534579466863574654455542694D684653457946686357427A6B424467456A4952557A4D68595846685535415251484467456A426963354153496E4A6963314A6A30424E4463324E7A59334D5459334D54597A4E444D427A4130535062677645776743';
wwv_flow_imp.g_varchar2_table(517) := '415167514C536842334E7361485155514767344E4267594D4778734F4342674F465159504342674F2F734D464267514F457759504241304745676F464151454642515543427767644442594B4167494642774D4344457557635159494241674842412F79';
wwv_flow_imp.g_varchar2_table(518) := '415434474341514843672F2B7767455042776B4543414D444377762B3863304642674D4742674947427476624F52346844516342416759524A4D4D784277514241704D4B4B494167507867674579514E4D534A4248686F4241534D634478454F43786765';
wwv_flow_imp.g_varchar2_table(519) := '46774D684F78514B4451345248524D4C4441454642774D4F465163544C68494B444149424977454942786F4A4368304D46513047417759464267454241514545425177664351596A4241554B45684D4D497759474452554D43534D444241675244776744';
wwv_flow_imp.g_varchar2_table(520) := '416745424642593041523473436951534852557A475963674241454141414D414141414141346F436167414441415941437741414578456845515568425355464A52456858774D722F5367436850362B2F6F34426367467A2F527343617633704168636A';
wwv_flow_imp.g_varchar2_table(521) := '314D7230395034354141494141502F54413951433651415441434D4141424D69446745564552516541544D684D6A34424E5245304C67456A42534579466855524641596A4953496D4E5245304E75633559546B3559546B43476A6C684F546C684F66336D';
wwv_flow_imp.g_varchar2_table(522) := '41686F724F6A6F722F6559724F6A6F43365468664F66364B4F5638344F46383541585935587A68754F536E2B69696B354F536B4264696B35414141464141442F6D674F34417949414641417041446F415377426441414142496763474277595546785958';
wwv_flow_imp.g_varchar2_table(523) := '466A49334E6A63324E43636D4A7959484D68635746785955427759484269496E4A69636D4E4463324E7A595849675948426834434E7A34424E7A596D4A79596A467A4965416734444C6749324E7A3442487745474477454F41525958466A34424F774531';
wwv_flow_imp.g_varchar2_table(524) := '497A59334A674830656D706D5044342B50475A713947706D5044342B50475A71656D3565577A55334E7A566258747865577A55334E7A5662586D6F2F6242635A47465A2B4F6A3152415152454F537379424356474D684D4F4B304651537A676143525959';
wwv_flow_imp.g_varchar2_table(525) := '554377334352516443516B454341514A4451525A5752496D44674D69506A786D617652715A6A772B506A786D617652715A6A772B4D54633157313763586C73314E7A633157313763586C73314E37314B4F7A6D415752345646573141506E45614653636A';
wwv_flow_imp.g_varchar2_table(526) := '5045684D50796748476A684E5553456C4C41457845694D324151385241774D4242686B6952416741414141464141442F6C674F3941794D41466741784144594151414247414141424A67344446686365416A632B415463324E7A596E4C67456E4A676332';
wwv_flow_imp.g_varchar2_table(527) := '467859584668635742676347427759484269636D4A79596E4A69636D4E7A344342785156495245464D6A4D47427759484267636D4E7851564954555841665259706F4645415541394F364777555653474A796B4442683465646B356561315A5355446F37';
wwv_flow_imp.g_varchar2_table(528) := '467863584B797845526C7059566C68445179636D41774D6A486E4B55666747612F73467963673867474130564545446A2F73696341794942526E36687336592B50306B4A4868313655564E5956315654687959764D51456D4A554E4556452B6E53456F76';
wwv_flow_imp.g_varchar2_table(529) := '4E424150466859354E6C42505631704F5358412B2B4A79634154677843527757435138434E41566458627039414141454141442F6C514F2B41794D414777417A41456F41595141414153594842676347427759574678595848674533506749334E696375';
wwv_flow_imp.g_varchar2_table(530) := '4153636D4A794D6D427A59584668635746785947427759484269596E4A696375415463324E7A344246794948426763474651595746785958466A59335067496E4A696375415163794678595846676355426763474277596D4A79596E4A6A59334E6A6332';
wwv_flow_imp.g_varchar2_table(531) := '416642735A47452F5167734D4E7A773955302B33566C69455477594748687831546B395741787346593174594F446F4743454641516C52527355784F4D444D67466859364F71644E57314A514D54494354454A46556B7962506B42454242386750444B41';
wwv_flow_imp.g_varchar2_table(532) := '4E56464A52796B7141306B39514570486A444D32464255554A79673954514D6941545931576C3172584C5A4A5369676F437877646436525A57314E53686967704267497841544D795646646A574B74415152736345796F735230657A566C6C43526B3475';
wwv_flow_imp.g_varchar2_table(533) := '4D6A4251553174546D7A55334467386E4D44474D6F6B6C4D4D6977764D53307253457052536F63734C51634A4D544D3152554B514F7A34684C514141414141474141442F6C514F2B417951414777417841456B415941426F414845414141456D42775948';
wwv_flow_imp.g_varchar2_table(534) := '4267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947';
wwv_flow_imp.g_varchar2_table(535) := '427759484269596E4A69636D4E6A63324E7A59584642556A46544D564E796357487745484E534D314D77487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D74453151';
wwv_flow_imp.g_varchar2_table(536) := '5A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B682B4C6970596B52496A4E6D33393844496749324E56706462467932';
wwv_flow_imp.g_varchar2_table(537) := '53556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C69797776';
wwv_flow_imp.g_varchar2_table(538) := '42776B784D7A5646517041375053497264444979766D54446568516F50586B326851414141414D4141502B574137384449674162414449415051414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A676332';
wwv_flow_imp.g_varchar2_table(539) := '4678595846686357426763474277596D4A7934424E6A63324E7A344246775943427A59334E6A63584A6963423632786A5944394143677335505435555472525456304244554167484852743555564E5A44513950534563724C41454451446B3853456151';
wwv_flow_imp.g_varchar2_table(540) := '4E7A6B794543596F51434E534B52684E467863714A78523947544544496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B774D596558506B456A46525A755176377A';
wwv_flow_imp.g_varchar2_table(541) := '515263774B78574854703441414141454141442F61674B694131494141774155414234414B5141414A534556495145524D7A4932505145304A7A3442505145304A79596A427A4D7946683042464159724151637A4D686357485145554269734241714C2B';
wwv_flow_imp.g_varchar2_table(542) := '704146632F71537756565A524979416D4B4651354F523861494349774254556C4542496348554D707677506F2F545A55556A703749684A474E7878514B43706B4A43676D4B534E754568517750695968414141414141514141502B614137674449674151';
wwv_flow_imp.g_varchar2_table(543) := '4142514161674276414141424967634242685158415259794E7745324E4363424A67634A4169557844774D564C7749504242384349773844465238444D7738434877512F41685566417A4D2F417A5566416A38454C77497A507749314C77496A50774976';
wwv_flow_imp.g_varchar2_table(544) := '424138434E533843427A4135415441423941384C2F6D454B436747664378384B415A384C432F356843773842687635362F6E6F42665151454167466A4177514542413043415145435934774541774942415149444249786A416745424167304542415144';
wwv_flow_imp.g_varchar2_table(545) := '59774543424151534241514341574D44424151454451494241514A6A6A41514441774D444249786A41674542416730454241514459774543424973444967762B59516F66432F356843676F426E77736643674766437A372B657635364159624741514944';
wwv_flow_imp.g_varchar2_table(546) := '4249786A41674542416730454241514459774543424151534241514341574D44424151454451494241514A6A6A4151444167454241674D456A474D43415145434451514542415269415149454767514341574D44424151454451494241514A6A6A415144';
wwv_flow_imp.g_varchar2_table(547) := '417A4141414141454141442F6D674F34417949414541415541426F41487741414153494841515955467745574D6A63424E6A516E415359484351496C447745584954636E4677636A4A7748304477762B59516F4B415A384C48776F426E77734C2F6D454C';
wwv_flow_imp.g_varchar2_table(548) := '447747472F6E722B65674747423942534151705331377449356B67444967762B59516F66432F356843676F426E77736643674766437A372B6576353641596267425A66392F583648334E77414141494141502B61413767444967415041424D4141424D47';
wwv_flow_imp.g_varchar2_table(549) := '46426342466A4933415459304A77456D4967634A417A734B436747664378384B415A384C432F35684368384C2F705142686747472F6E6F4265416F66432F356843676F426E777366436747664377762B527747472F6E722B65674141414141454141442F';
wwv_flow_imp.g_varchar2_table(550) := '6D674F344179494145414155414345414C6741414153494841515955467745574D6A63424E6A516E415359484351496C49673442464234424D6A34424E433442427A49654152514F415349754154512B415148304477762B59516F4B415A384C48776F42';
wwv_flow_imp.g_varchar2_table(551) := '6E77734C2F6D454C447747472F6E722B656747474F5745344F4746795954673459546B7A566A4979566D5A574D6A4A574179494C2F6D454B4877762B59516F4B415A384C48776F426E77732B2F6E722B65674747306A6868636D45344F47467959546758';
wwv_flow_imp.g_varchar2_table(552) := '4D6C5A6D566A4979566D5A574D674141414141444141442F6C674F2F417949414777417941456F4141414569427759484267634746686357467834424E7A5933506745334E6963754153636D4A7959484E6863574678595846675948426763474A696375';
wwv_flow_imp.g_varchar2_table(553) := '415459334E6A632B4152636D427734424277595846686365415463324E7A59335067456E4A6963754151487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E443039495279737341514E414F54784952704133';
wwv_flow_imp.g_varchar2_table(554) := '4F5449514A696841493149704E6A497651676B4C4567346F4A576B314F43777547686B4546685973486B7344496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B77';
wwv_flow_imp.g_varchar2_table(555) := '4D596558506B456A46525A5241686F5A575451344D7A516F4A535547427941644D6939764D44516747426F41417741412F35594476774D69414273414D6741324141414249676347427759484268595846686365415463324E7A34424E7A596E4C67456E';
wwv_flow_imp.g_varchar2_table(556) := '4A69636D427A59584668635746785947427759484269596E4C6745324E7A59335067455842676368416574735932412F51416F4C4F54302B564536305531644151314149427830626556465457513050543068484B79774241304135504568476B446335';
wwv_flow_imp.g_varchar2_table(557) := '4D68416D4B45416A55696C6759414741417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A354249785557597179744141494141502B5341384544';
wwv_flow_imp.g_varchar2_table(558) := '497741614144454141414569427759484267634748674558486745334E6A632B415463324A7934424A79596E4A67637946785958466863574267634F4153596E4A696375415463324E7A34424166426B586C7442516855554947424A52363959576B6C4B';
wwv_flow_imp.g_varchar2_table(559) := '6152595844673169536B785A4E43644B524545724C51634A4D444D30687041385069496D427838675043706D417949764C564252596C617A6D7A497A4B4134504C79325256566857577034324F42494C6A69556B506A394A526F737A4E5373554A796739';
wwv_flow_imp.g_varchar2_table(560) := '514A7046534377674951414141414D4141502B574137384449674161414338414F51414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E427A59584668635746785947427734424A696375415459334E6A6332';
wwv_flow_imp.g_varchar2_table(561) := '46775950415263684E6A38424A67487262474E675030414B437A6B38506C525074464E5851454E514341636447336C5255316B63543068484B797742413041364F3436514E7A6B794479636F514568574A4564735567454B4679735152774D694F445A61';
wwv_flow_imp.g_varchar2_table(562) := '586D7463746B644B4A79594C484277374F71465957314E5669796B71424930434B5368465230394A6953387747696B774D5965575030456A4B3159614E453739524967784E414141414141454141442F6C674F2F41794941477741794144634150514141';
wwv_flow_imp.g_varchar2_table(563) := '41534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442427859584E6A634646425568455163423632786A594439414367733550543555';
wwv_flow_imp.g_varchar2_table(564) := '5472525456304244554167484852743555564E5A44513950534563724C41454451446B38534561514E7A6B794543596F51434E53666C5A564F484C2B6851476179514D694E7A5A62585774637430644B4A79594C484230374F61465957314E5669796B71';
wwv_flow_imp.g_varchar2_table(565) := '4241474F41696B6F5255645053596B754D51774F4B5441786835632B51534D5646707046525335634949794D41524B6A41414141417741412F35594476774D69414273414D6741364141414249676347427759484268595846686365415463324E7A3442';
wwv_flow_imp.g_varchar2_table(566) := '4E7A596E4C67456E4A69636D427A59584668635746785947427759484269596E4C6745324E7A5933506745584642556A46544D564E77487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E4430394952797373';
wwv_flow_imp.g_varchar2_table(567) := '41514E414F547849527041334F5449514A69684149314A6234754B6C417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A354249785557637A4979';
wwv_flow_imp.g_varchar2_table(568) := '766D544441414141427741412F35554476674D6B414273414D51424A414741415A514276414855414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C674933';
wwv_flow_imp.g_varchar2_table(569) := '4E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A594846425568455155794D7759484267634742795933464255684E5263423832786C';
wwv_flow_imp.g_varchar2_table(570) := '59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545486941384D48784355457048';
wwv_flow_imp.g_varchar2_table(571) := '4B7977424155672B514574486A444D32464255554A796339536E67426D763742636E49504942674E46524241342F37496E414D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841';
wwv_flow_imp.g_varchar2_table(572) := '517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B447339496975626E4A77424F44454A4842594A4477493042563164';
wwv_flow_imp.g_varchar2_table(573) := '756E3041425141412F35554476674D6B414273414D51424A41474141615141414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A59584668635746785947427734424A696375416A63324E7A344246795948';
wwv_flow_imp.g_varchar2_table(574) := '426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E686347447745584E5263524277487A624756685155494C4444633850564E5074315A596845384742683463';
wwv_flow_imp.g_varchar2_table(575) := '6430395156774D5645474E6457546F3843416B39506B436D744531515A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B';
wwv_flow_imp.g_varchar2_table(576) := '52545A734C39484B79674D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D';
wwv_flow_imp.g_varchar2_table(577) := '6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969756A4A6B30686C492B5041536950414141414141514141502B574137304449774157414445414F774243414141424A67344446686365416A632B41546332';
wwv_flow_imp.g_varchar2_table(578) := '4E7A596E4C67456E4A676332467859584668635742676347427759484269636D4A79596E4A69636D4E7A344346775950415263684E6A38424A6963574677636A4A7A59423946696D67555142514430376F6242525649596E4B514D4748683532546C3572';
wwv_flow_imp.g_varchar2_table(579) := '566C4A514F6A7358467863724C455247576C685757454E444A79594441794D65637052504A4564735567454B467973515235423850306A6D53443844496746476671477A706A342F53516B65485870525531685856564F484A6938784153596C51305255';
wwv_flow_imp.g_varchar2_table(580) := '543664495369383045413857466A6B3255453958576B354A63443630476A524F2F5553494D54524B5769336333433041414141474141414141414E46417055414B51425041464D415677426241463841414145504151594842676355467859584D525958';
wwv_flow_imp.g_varchar2_table(581) := '4668635742676347447745684E7A4D2B4153636D4A7959764153596E4A6A55304E7A592F41515568426763474651595846686378466863574678594842676347427945324E7A596E4A69636D4C77456D4A7959334E4463324678557A4E5163564D7A5548';
wwv_flow_imp.g_varchar2_table(582) := '46544D314278557A4E51463842414A554B5359434778416F4A4241584177454A444274495367484B4251464E525155454677386A445349514642306B54556E2B524145614A78556E415273514B43515146774D424241514E4755582B3552385149775545';
wwv_flow_imp.g_varchar2_table(583) := '4741386B444349504651456349517263356556393362376C41705543415449774C69346F4B4267704A5255654651305A45434D724B774D74567930684968516B4469495848686B6449536F754B793464476934754B4367594B5355564868554E44413450';
wwv_flow_imp.g_varchar2_table(584) := '49536B5846697773496949554A51776A4668345A4853456E49685556637859576442555663785957414141414141514141502F54413951433651415441436341617744494141415449673442465245554867457A4954492B415455524E43344249775568';
wwv_flow_imp.g_varchar2_table(585) := '4D683442465245554467456A49534975415455524E443442467949484F51454744774547427A6B424267634748514578464263774D5234424D7859334F5145794E6A55304A7A4D794E6A63774D54596E506745334E6A516D4B7745324E546B424E436375';
wwv_flow_imp.g_varchar2_table(586) := '415373424E7A59335067456E4A6963484D444579467A6B42466759484F51454744774547467A45574877457A466A637A4D686357464163474979496E4652597A4D6859564D525148446745724152557A4D6859484F51454F4153734246544D784D685956';
wwv_flow_imp.g_varchar2_table(587) := '4F514555427759484954456D4A79596E4F51456D4E5445304E7A59334E6A38424E6A38424E6A50584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B50716F4B434264704752304E4251454242517330';
wwv_flow_imp.g_varchar2_table(588) := '4B596D4A455245444368415242414D484341344543424D544467554B4242414978676B5542516B4342776F4D41775144417749454168555A42414D43427749434D5752454351494642514D495A6A4E446851634A42414D45426369724277734441516348';
wwv_flow_imp.g_varchar2_table(589) := '7134494742674D444276377549684D57427755424151514C466B46494477494541514C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B4B415950534245564A7738554442634848426772';
wwv_flow_imp.g_varchar2_table(590) := '4B6749434668414B43524550464134424351594D4A52774D4442494C4267634A4641594D4851734F41525946425138474178555A42676348415145424151554646775547415259424451734C43414D444668414F427763574277774842674D4241684154';
wwv_flow_imp.g_varchar2_table(591) := '4942556147517755446941514C44494B41514541414141434141414141414F47416D41414167414841414154425355464553455242574D426B5147522F4E384449763575416D446A3431542B5141484134414141414141464141414141414D73416E6341';
wwv_flow_imp.g_varchar2_table(592) := '4A67424F414959416A774359414141424642554742796348467759484978557A46686331427A557A4E7A592F41536333467A6332507745314D78557A4A69636D4A7A5548465159484A7763584267636A46546357467763584E78595846544D314E6A6358';
wwv_flow_imp.g_varchar2_table(593) := '4E7963324E7A4D314979596E4E7963484A696333427A4D484678596641546358427863574877457A46513842426738424677636E427759504152556A4E53636D4C7745484A7A636E4A693842427A557A4E7A592F41536333467A63325077455849675955';
wwv_flow_imp.g_varchar2_table(594) := '466A49324E4359484D6859554269496D4E4459426E5259574B456F6F444159344F4167554D5445444268454949686B6944426F674469526542685952446759624553684B4A7773474F546B484379684C4B524D5A61526B544B556F70444159344F41674C';
wwv_flow_imp.g_varchar2_table(595) := '4A30736E4668594252795142447834634379495A4951675342674D784D514D474551676B47694D4D4778384F497738664777736B47695149456759444D6A49444268454949786B6A44426769446849674C7939414C79386745786B5A4A526F61416E6363';
wwv_flow_imp.g_varchar2_table(596) := '4841594D4A306F6F45786871475235624153514F48786F4D49786B6943424149417A417742776B494244646C4E77674C4B45736F46426471415255584B456F6F444159354F67594D4B45736F46685A704752496E5369634D426A636A4D414D4745516769';
wwv_flow_imp.g_varchar2_table(597) := '4753494D4778344F4977454F48786F4D49786F6B43424947417A4D79417759534343515A49777762487734424A413465484177694753494945416744554339424C6935424C794D614A526B5A4A526F4141414141425141412F394D4431414C7041424D41';
wwv_flow_imp.g_varchar2_table(598) := '4A774172414334414D7741414579494F41525552464234424D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B41516352495245464951636E467A63524964633157545531575455434F6A56614E445261';
wwv_flow_imp.g_varchar2_table(599) := '4E663347416A6F6C5069516B506958397869552B4A43512B4151494F2F6967426F7448773850482B48774C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B552F366C4156735869594F65';
wwv_flow_imp.g_varchar2_table(600) := '6E76375A41414141417741414141414445514B644143414157414237414141424967634F41525535415251584668634742775950415255684E53636D4A79596E4E6A55354154516D4A7959484D6863574678596641525958466863784E6A38424E6A6357';
wwv_flow_imp.g_varchar2_table(601) := '46525148426763664168595642673842446745694A6938424A69633050774D6D4A7934424A7959314E4438424E6763774651595846686357467859794E7A59334E6A63324E7A596E4E52595846534D31497855684E534D56497A5532416641724A43496E';
wwv_flow_imp.g_varchar2_table(602) := '454173514F796731476749435167495A4E4367364B4363694A47674A42526F5144416B454341594B45426B4F4167514343676B4D4867516342414542415145514E7A6F33454145424151454547774D454177635142673050426777304177494343785969';
wwv_flow_imp.g_varchar2_table(603) := '4945676749685948417749424177525749464D6A2F76416A557941436E425554524359694A526F5246426F6A4D51546E3577517749786F554B556F6D52424D565577454242515147416759434177454243414943415251614A7859624569414A46416750';
wwv_flow_imp.g_varchar2_table(604) := '4241514345424953454149454241384946416B6942414946467730664768385A4167586841517753464173574441734C444259474351594B445245424A6A6D3768495345684C7335414141414141494141502B57413730444967415841444D4141414569';
wwv_flow_imp.g_varchar2_table(605) := '44674D57467834434E7A34424E7A59334E6963754153636D49786379467859584668635742676347427759484269636D4A79596E4A69636D4E7A3443467748775636562F5241464150547568734646556869637041775965486E5A4F586D73495656424F';
wwv_flow_imp.g_varchar2_table(606) := '4F546F57467863724C455247576C685757454E444A79594441794D656370525041794A476661477A706A342F53516B65485870525531685856564F484A6938784A795A4352464A507030684B4C7A5151447859574F545A5154316461546B6C7750674541';
wwv_flow_imp.g_varchar2_table(607) := '4141554141502B56413734444A4141624144454153514267414773414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D42775948';
wwv_flow_imp.g_varchar2_table(608) := '4267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A5958426749484E6A63324E78636D4A77487A624756685155494C4444633850564E5074315A596845384742683463';
wwv_flow_imp.g_varchar2_table(609) := '6430395156774D5645474E6457546F3843416B39506B436D744531515A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B';
wwv_flow_imp.g_varchar2_table(610) := '5652684E467863714A78523947544544496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F424151';
wwv_flow_imp.g_varchar2_table(611) := '4A5441796A4B4A4A544449724D4441434C437047536C424C6979777642776B784D7A5646517041375053497262304C2B383045584D43735668303665414141414141594141502B56413734444A414162414445415351426741476F416351414141535948';
wwv_flow_imp.g_varchar2_table(612) := '42676347427759574678595848674533506749334E6963754153636D4A794D6D427A59584668635746785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E68635746785948';
wwv_flow_imp.g_varchar2_table(613) := '46675948426763474A69636D4A7959324E7A59334E686347447745584954592F4153596E466863484979633241664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B6130';
wwv_flow_imp.g_varchar2_table(614) := '5456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570564A4564735567454B467973515235423850306A6D53443844';
wwv_flow_imp.g_varchar2_table(615) := '496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D444143';
wwv_flow_imp.g_varchar2_table(616) := '4C437047536C424C6979777642776B784D7A5646517041375053497256786F305476314569444530536C6F74334E7774414141514141442F6F414F374179494143674159414359414E5142484146674161514233414951416B774368414C454176774453';
wwv_flow_imp.g_varchar2_table(617) := '414F45413967414141515943427A59334E6A63584A693842466838424A775948426763474E7A59334E684D4742773442466A6332467859324A69636D46795947466863574678592B415363754153636D425159484267634742775948426859794E7A5933';
wwv_flow_imp.g_varchar2_table(618) := '4E6934424D7949484967634F415234424E7A5958466A59304A795948426763474477454742775965415463324E7A59304A67556D42685958466863574D6A596E4A69636D42535948426863654154596E4A6A63324A67556D42686357427759654154632B';
wwv_flow_imp.g_varchar2_table(619) := '415363754151556D426863574678592B4153636D4E7934424253594842676347427759654154632B415463754151556942685958466863574E69596E4A69636D425134424277594842673842446745574E7A34424E7A34424A6755694268595848674558';
wwv_flow_imp.g_varchar2_table(620) := '466A596D4A79596E4A675547427759484267634742775948446745574E7A34424E7A5975415148304745305846796F6E4648305A4D54494D46694A4543426B5342676F424378515744456F76444145544446356D444134464444484B4441384443307774';
wwv_flow_imp.g_varchar2_table(621) := '42786B504242684A4C6754393951734B42677349425545684242455942796C524267454E2F77514B4567634E43516B55435535484442494C51756F4E44676B51436A305A4252455A42696C51434134426677774F41676F304751635A4541516152415439';
wwv_flow_imp.g_varchar2_table(622) := '77786B4643787347474249434768414244674C7044773044415441454542674848527345416737387041384F4177497842786B504253384341513043374138484251454E4D675950475167644A6759424466326F43777743434439554442454243303833';
wwv_flow_imp.g_varchar2_table(623) := '426747664443734C45786B504868454D4251384D4C31736E4341454E2F6A304C44514D4B4B324D3044413446444752504267495943516B4643673449486959664B677343455130325A536B48416730434A6B4C2B383045584D437356683036655553524A';
wwv_flow_imp.g_varchar2_table(624) := '626B6F484852514843775968513077426441495142686B5242426B5741524D5A4241785441524D59425468624367455444444A594941494B4151634643776745506C414D4567746451416354446745434242555243414D4748775152475159664A774949';
wwv_flow_imp.g_varchar2_table(625) := '425177484D44414D4577454C514334484577383741524958426A565543784D4D5855454471514972566B304C4178454D5546514B446930424767356C5867775341516F3265543449436841424767357257676F43457778625A67674C4F41454E4368452F';
wwv_flow_imp.g_varchar2_table(626) := '517777554177736D5679304A4471415246675A4A48514D534741596551675A4E4178554442775144417749454742514241526B59427855504A784D5742534976436745554741515651674D4441515544435173444641384D4367595A45674D4C4D534D48';
wwv_flow_imp.g_varchar2_table(627) := '45773441414141464141442F6C514F2B417951414777417841456B415941426F414141424A6763474277594842685958466863654154632B416A63324A7934424A79596E497959484E68635746785958466759484467456D4A7934434E7A593350674558';
wwv_flow_imp.g_varchar2_table(628) := '4A676347427759484268635746785958466A59335067496E4A696375415163324678595846676357426763474277596D4A79596E4A6A59334E6A6332467851564978557A465463423832786C595546434377773350443154543764575749525042675965';
wwv_flow_imp.g_varchar2_table(629) := '48486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545486941384D487843554570484B7977424155672B514574486A444D32464255554A796339';
wwv_flow_imp.g_varchar2_table(630) := '536F666934715544496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A';
wwv_flow_imp.g_varchar2_table(631) := '544449724D4441434C437047536C424C6979777642776B784D7A5646517041375053497264444979766D5444414141414141304141502B69413767444941414541416741444141514142514147414254414C77425251476941656B434D774B6641414142';
wwv_flow_imp.g_varchar2_table(632) := '465245684551557A45534D5446544D314278557A4E5163564D7A554846544D314179734242794D4849776356447755564877557A50774D7A4E7A4D334D7A637A467A4D584D78637A4877457A50774D314C77516A4E534D6E497963584477595648776F7A';
wwv_flow_imp.g_varchar2_table(633) := '487759564877497A4877307A507751314C7745314A794D7642694D764154556A4C77736A4C77456A4C77636A4E5363314C77516A4251384249773845465138454651636A4278555041794D56427855484978555042425548497738424651384346513843';
wwv_flow_imp.g_varchar2_table(634) := '49773844465138444651635644776F5642785566424438454D7A38454E54386D4E53384441513846465263564278554846516356427855484651635642785548465163564278554846513848465238455077557A5077457A507745315077457A4E7A4D33';
wwv_flow_imp.g_varchar2_table(635) := '4E5463314D7A55334E5463314E7A55334E5463314E7A55334E5463314A7A5576424155504252555846526356467A4D6642544D6641525558465263564678557A4678555846523845507751314C7730314A7A556E4E5363314C774D424478636642443845';
wwv_flow_imp.g_varchar2_table(636) := '4D7A38444D7A637A4E7A4D334D7A637A4E7A55334D7A63314E7A4D2F416A4D334D7A552F417A557642415550425255664178556641544D66416A4D664168556641544D664152556641544D584D78637A467A4D66416A4D584D7863564D7838484D786356';
wwv_flow_imp.g_varchar2_table(637) := '467A4D564D78637A507751314C77516A4A794D6E4979636A4C776F6A4C77516A4C77556A415630424C7637712F7634617973724B7973724B796D45484451594E4451636E4451344541774D454151494441776B454251594D426863474377594742675970';
wwv_flow_imp.g_varchar2_table(638) := '42675947426759464877514644414D444167494741776F6E42676347445166704251514541774D4241674943426749434177594642414D494151344343414947416751424167494241674D4341775545417751444367554741776B454351514541775143';
wwv_flow_imp.g_varchar2_table(639) := '4241594242414D434177494441674543434145464177514342414943425149484167494241676B424167494442774D434177494241674D434267494B4266337A4251634241674D434177494441674D434177514241674944416751424241514241674943';
wwv_flow_imp.g_varchar2_table(640) := '41674943415149434167514341675142415145434177494343674543416749424241454341514942416745434167454542414D4F424167454177454241674D42416749434151494241674543415149434177494241676743415149434167454541675142';
wwv_flow_imp.g_varchar2_table(641) := '4267494B4167594443674D474177554441674545426767464172494542514D474167454241514542415145424167454442514D464177514441675944415149444267514A435151454177494241514D4341514944417749424251454D4177454341514542';
wwv_flow_imp.g_varchar2_table(642) := '4151454241514545417751454350796D424155444241514241514D4341514D4341515142436745454177494441674543417745434241634A4351514541775143424149444167634541515942416745434341454241514546434167437351514543515146';
wwv_flow_imp.g_varchar2_table(643) := '436751504251554C44775946437755684267735143415146416749454177514E43515947464155424567594842514546415155424251456341517346415155464151554C4477454541514D44416745454177514543503365424151454177494341514944';
wwv_flow_imp.g_varchar2_table(644) := '42413043415149444167454341774D4C4167454941774D4641514942416745434151494441774543415149424167514442674D4E41783043417730454177304A425167464167454541775145417751494178514345514D4A425245434267554442515546';
wwv_flow_imp.g_varchar2_table(645) := '41674550416755434167454541775152424151464168774D2F70414266426A2B7441456E47526C4B474268564742684E474267434C51454342674543424149444241674A4251514541775142416749434241494241514542415155424267514443515549';
wwv_flow_imp.g_varchar2_table(646) := '43414945426745424155384241514D444241514542516B4542674543415159444241494944674D49417759444241454341674D45417751444277634443414D53436767434241494341774D49436763484151774942415145424151454241734242774D47';
wwv_flow_imp.g_varchar2_table(647) := '416759434177554442774D4341776B44416749484167494341674542415149434241494644414545416749434167494241674943416749424241494241674944424145454151514241674D434177494241674D43415149474167454342674D4441675543';
wwv_flow_imp.g_varchar2_table(648) := '4151495041774942416745434177594441774D4441774D44417745454351554941774D44415151444177514742514D43425145434177494441674D4341774D4342514944416777434177494441674D454177514442674D4B417759434367454741675545';
wwv_flow_imp.g_varchar2_table(649) := '4241514A435159454166374741514943434151454241517A41776B444267494741774D4441774D444267494441776B4344674D4941513046437755474367634542516B45426749434167494441774D4442675947425145464277386D41776F4441776344';
wwv_flow_imp.g_varchar2_table(650) := '41775144417751444177514442774D4F417977464351674541674D434577454341774D494242734742784D4844524D47427730474877304641515542425145464151554242514542424151454167494341774D4A43516747426755474541734745515547';
wwv_flow_imp.g_varchar2_table(651) := '4267557642675547426777474277554842674C2B73674543426751454267514A42414D464351494442414D4D4151514442414D4843516B4941774D4441674942426749474177494441674D444477594241774D4241775148444151424177514542416B49';
wwv_flow_imp.g_varchar2_table(652) := '42414D43416749424177494542416B45425151454177454B4167494341674943415145484167554241514544416749424167454341514542415145434167494541676B424151514242414545427755454351674541674D424177634741774D4741674944';
wwv_flow_imp.g_varchar2_table(653) := '41514D434177494A41674D4341515142424130424167414141414D4141502F5341794D433667414641417741455141414153496A455345524A7851564D784568455155574877456A416E4C5731774A6535626A392F41463546536F2B66514C712F4F6743';
wwv_flow_imp.g_varchar2_table(654) := '596F6C64586633384172344D46537442414141414141674141502F5441395143365141544143634154674279414859416567422B4149494141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F41534D68';
wwv_flow_imp.g_varchar2_table(655) := '496934424E5245305067455842794D4F4152515846686378466863574678594842673842495463324E7A596E4A69636D4C77456D4A7959314E446332507745484D7759484268555546785966415259584668635742775948497A59334E69636D4A795976';
wwv_flow_imp.g_varchar2_table(656) := '4153596E4A6A55304E7A595846544D314278557A4E5163564D7A554846544D31317A565A4E54565A4E5149364E566F304E466F312F6359434F69552B4A43512B4A6633474A54346B4A44352F417745774C4138494678554A4451454344524D6C4B514542';
wwv_flow_imp.g_varchar2_table(657) := '4179345146414D434451675543424D49444241524C796E356E68594C4677344A46674955435130424167304F4A35345442784D4341673449465159544351735146415237674942476647714141756B305754582B626A565A4E44525A4E5147534E566B30';
wwv_flow_imp.g_varchar2_table(658) := '504351394A6635754A54306B4A44306C415A496C50535263416877324C78594E4742554C45517750447859564751496346686B5945684D4C465167554442454E45424D564852676145513461475259574452634346417752444138504578635143686361';
wwv_flow_imp.g_varchar2_table(659) := '45784D4C465163544452454E45424D584641774D5141774D5151774D5151774D4141514141502F544139514336514154414363414B6741764141415449673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A';
wwv_flow_imp.g_varchar2_table(660) := '49534975415455524E4434424278633342524568455166584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B506758362B76344E4166543741756B305754582B626A565A4E44525A4E5147534E566B30';
wwv_flow_imp.g_varchar2_table(661) := '504351394A6635754A54306B4A44306C415A496C505352666A5930302F756B4246347741425141414141414453414B70414273414D67424B414749416567414141534948426763474477455246686357467859674E7A59334E6A63524E43636D4A79596E';
wwv_flow_imp.g_varchar2_table(662) := '4A6763794678595846686347427759484269496E4A69636D4A7A59334E6A6332427A496641525958466A49334E6A384246515948426763474969636D4A79596E4654496641525958466A49334E6A384246515948426763474969636D4A79596E46544966';
wwv_flow_imp.g_varchar2_table(663) := '41525958466941334E6A384246515948426763474969636D4A79596E41665239586A416649676342426951674C3163424346637649434D4841516369487A42656658745A4B786F5242675952475378633846777347524547426845614B316D3241514D44';
wwv_flow_imp.g_varchar2_table(664) := '477A52652B6C34304777634546426B73585042634C426B554241454441787330587670654E4273484242515A4C467A775843775A4641514241774D624E466342434663304777634546426B73566635564C426B5542414B704641735145526F452F695561';
wwv_flow_imp.g_varchar2_table(665) := '4642454A4642514A45524D624164734441526F52454173554978514A44516B4B43676B4F43524D544351344A43676F4A44516B5561774943446777554641774F42436B4C4367344A45784D4A4467734B4D414943446777554641774F42436B4C4367344A';
wwv_flow_imp.g_varchar2_table(666) := '45784D4A4467734B4D414943446777554641774F42504D4C4367344A45784D4A4467734B41416B4141502B66413730444941414B414267414A6741324145774158414271414877416B41414141515943427A59334E6A63584A693842466838424A775948';
wwv_flow_imp.g_varchar2_table(667) := '426763474E7A59334E684D4742773442466A6332467859324A69636D467959474668635746785958466A34424A79596E4A675547427759504151594842676347466A59334E6A632B415463324E4359424A67595846675948426834424E7A34424A793442';
wwv_flow_imp.g_varchar2_table(668) := '4253594746785958466A34424A79596E4C67454242676347427759484267634F415259334E6A63324C67454649675957467859664152597A4D6A596D4A7959764153596E4A6748304745305846796F6E4648305A4D54494D46694A4543426B5342676F42';
wwv_flow_imp.g_varchar2_table(669) := '4378515745464176437745534447466A4451344744437646444138454379556747786F4A474130474F464D452F66414B4377594C437938704351494447526B454A5330454667514944514B74447730444178675A4241385A427838614277494E2F4B5150';
wwv_flow_imp.g_varchar2_table(670) := '44674D464C77635A447751744167454E4171344A4351594B445167325667774245677875565163434466335A43773044436B4E674268494944773052446D4537417759454267496D5176377A515263774B785748547035524A456C75536763644641634C';
wwv_flow_imp.g_varchar2_table(671) := '426946445441467941673847475249454742514246426745433038424578674647696F684D416F46465174724F774D4C41516745437773755377384C44784550443051764252454643424D4F2F736742477738795A43304D4577454B4E6E302B42776B53';
wwv_flow_imp.g_varchar2_table(672) := '41526F506146774B41524D4D57326349432F367A4151594443516F454A426347474249444755674845773442456863464F526F4342526B594152677841775543424141474141442F6C514F2B417951414777417841456B415941426C414773414141456D';
wwv_flow_imp.g_varchar2_table(673) := '427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A595846686357';
wwv_flow_imp.g_varchar2_table(674) := '42785947427759484269596E4A69636D4E6A63324E7A5948466863324E775555465345524277487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D744531515A434156';
wwv_flow_imp.g_varchar2_table(675) := '467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B556C5A564F484C2B6851476179514D69416A5931576C3173584C5A4A5369676F';
wwv_flow_imp.g_varchar2_table(676) := '437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A';
wwv_flow_imp.g_varchar2_table(677) := '4E5556436B44733949697562525555755843434D6A4145536F774141414141514141442F6F414F374179494142774150414230414C41412B41453841594142754148734169674359414B67417467444A414E6741375141414153596E427863684E6A636E';
wwv_flow_imp.g_varchar2_table(678) := '4267636A4A7A593346674D4742773442466A6332467859324A69636D46795947466863574678592B415363754153636D425159484267634742775948426859794E7A59334E6934424D7949484967634F415234424E7A5958466A59304A79594842676347';
wwv_flow_imp.g_varchar2_table(679) := '4477454742775965415463324E7A59304A67556D42685958466863574D6A596E4A69636D42535948426863654154596E4A6A63324A67556D42686357427759654154632B415363754151556D426863574678592B4153636D4E7934424253594842676347';
wwv_flow_imp.g_varchar2_table(680) := '427759654154632B415463754151556942685958466863574E69596E4A69636D425134424277594842673842446745574E7A34424E7A34424A6755694268595848674558466A596D4A79596E4A675547427759484267634742775948446745574E7A3442';
wwv_flow_imp.g_varchar2_table(681) := '4E7A597541514C4C523544585567454B4679734D4744446D534439386648784B4C777742457778655A67774F42517778796777504177744D4C51635A44775159535334452F66554C4367594C434156424951515247416370555159424466384543684948';
wwv_flow_imp.g_varchar2_table(682) := '44516B4A46416C4F5277775343304C714451344A45416F3947515552475159705541674F4158384D4467494B4E426B4847524145476B51452F634D5A425173624268675341686F51415134433651384E4177457742424159427830624241494F2F4B5150';
wwv_flow_imp.g_varchar2_table(683) := '44674D434D51635A447755764167454E41757750427755424454494744786B4948535947415133397141734D4167672F56417752415174504E7759426E77777243784D5A4478345244415550444339624A77674244663439437730444369746A4E41774F';
wwv_flow_imp.g_varchar2_table(684) := '4251786B5477594347416B4A42516F4F4342346D48796F4C4168454E4E6D55704277494E41614930614A7A395249676F53704C634C567061415677434541595A4551515A466745544751514D557745544741553457776F42457777795743414343674548';
wwv_flow_imp.g_varchar2_table(685) := '42517349424435514442494C585541484577344241675156455167444268384545526B47487963434341554D427A417744424D424330417542784D504F77455346775931564173544446314241366B434B315A4E43774D52444642554367347441526F4F';
wwv_flow_imp.g_varchar2_table(686) := '5A56344D4567454B4E6E6B2B43416F5141526F4F61316F4B41684D4D57325949437A674244516F5250304D4D46414D4C4A6C637443513667455259475352304445686747486B494754514D564177634541774D43424267554151455A4741635644796354';
wwv_flow_imp.g_varchar2_table(687) := '466755694C776F4246426745465549444177454641776B4C4178515044416F4747524944437A456A42784D4F414141414142414141502B674137734449674144414167414667416C414463415341425A4147634164414344414A45416F514376414D4941';
wwv_flow_imp.g_varchar2_table(688) := '3051446D414141424267636841785958495459544267634F415259334E6863574E69596E4A68636D42685958466863575067456E4C67456E4A6755474277594842676347427759574D6A63324E7A597541544D6942794948446745654154633246785932';
wwv_flow_imp.g_varchar2_table(689) := '4E43636D427759484267384242676347486745334E6A63324E4359464A67595746785958466A49324A79596E4A67556D42775958486745324A7959334E6959464A67595846676347486745335067456E4C6745464A675958466863575067456E4A6A6375';
wwv_flow_imp.g_varchar2_table(690) := '4151556D427759484267634748674533506745334C6745464967595746785958466A596D4A79596E4A67554F415163474277595041513442466A632B4154632B415359464967595746783442467859324A69636D4A795946426763474277594842676347';
wwv_flow_imp.g_varchar2_table(691) := '42773442466A632B415463324C67454239474267415944415A44502B306A4E6B5369384D41524D4D586D594D4467554D4D636F4D44774D4C544330484751384547456B754250333143776F474377674651534545455267484B5645474151332F42416F53';
wwv_flow_imp.g_varchar2_table(692) := '4277304A4352514A546B634D456774433667304F4352414B50526B4645526B474B5641494467462F44413443436A515A42786B5142427045425033444751554C47775959456749614541454F41756B5044514D424D41515147416364477751434476796B';
wwv_flow_imp.g_varchar2_table(693) := '44773444416A4548475138464C77494244514C7344776346415130794267385A4342306D4267454E2F61674C444149495031514D4551454C547A6347415A384D4B777354475138654551774644777776577963494151332B5051734E41776F72597A514D';
wwv_flow_imp.g_varchar2_table(694) := '4467554D5A4538474168674A4351554B446767654A6838714377495244545A6C4B51634344514979724B30424A7252615767485841684147475245454752594245786B4544464D42457867464F46734B41524D4D4D6C676741676F424277554C4341512B';
wwv_flow_imp.g_varchar2_table(695) := '554177534331314142784D4F4151494546524549417759664242455A4268386E41676746444163774D417754415174414C676354447A7342456863474E56514C4577786451514F7041697457545173444551785156416F4F4C514561446D566544424942';
wwv_flow_imp.g_varchar2_table(696) := '436A5A355067674B45414561446D7461436749544446746D434173344151304B455439444442514443795A584C516B4F6F424557426B6B644178495942683543426B304446514D4842414D444167515946414542475267484651386E457859464969384B';
wwv_flow_imp.g_varchar2_table(697) := '415251594242564341774D4242514D4A43774D554477774B42686B534177737849776354446741414141554141502B56413734444A414162414445415351426741476B414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E';
wwv_flow_imp.g_varchar2_table(698) := '4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A595842676358';
wwv_flow_imp.g_varchar2_table(699) := '4954592F415359423832786C59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545';
wwv_flow_imp.g_varchar2_table(700) := '486941384D487843554570484B7977424155672B514574486A444D32464255554A796339536C5751523149424368637245456344496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E5759316973';
wwv_flow_imp.g_varchar2_table(701) := '51454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C6979777642776B784D7A56465170413750534972563267302F5553494D5451414141414B4141442F';
wwv_flow_imp.g_varchar2_table(702) := '6E774F39417941414241414F4142514149674179414567415741426D414867416A41414141525156495245464D6A4D47427759484267636D4E7851564954555845775948446745574E7A5958466A596D4A7959584A67595746785958466863575067456E';
wwv_flow_imp.g_varchar2_table(703) := '4A69636D425159484267384242676347427759574E6A63324E7A34424E7A59304A67456D4268635742676347486745335067456E4C6745464A675958466863575067456E4A69637541514547427759484267634742773442466A63324E7A597541515569';
wwv_flow_imp.g_varchar2_table(704) := '4268595846683842466A4D794E69596E4A6938424A69636D415363426D763742636E49504942674E46524241342F37496E4152514C777342456778685977304F42677772785177504241736C494273614352674E426A6854425033774367734743777376';
wwv_flow_imp.g_varchar2_table(705) := '4B516B4341786B5A4243557442425945434130437251384E41774D594751515047516366476763434466796B4477344442533848475138454C51494244514B7543516B47436730494E6C594D4152494D626C5548416733393251734E4177704459415953';
wwv_flow_imp.g_varchar2_table(706) := '4341384E455135684F774D47424159422B7079634154677843527757435138434E41566458627039416641434477595A45675159464145554741514C54774554474155614B6945774367555643327337417773424341514C4379354C4477735045513850';
wwv_flow_imp.g_varchar2_table(707) := '52433846455155494577372B79414562447A4A6B4C51775441516F3266543448435249424767396F58416F42457778625A77674C2F724D4242674D4A4367516B4677595945674D5A53416354446745534677553547674946475267424744454442514945';
wwv_flow_imp.g_varchar2_table(708) := '414141424141414141414E5441684D414C674141457A59334E6A6332467859584668635746785958466A6332507745324E7A593346515948426763474A79596E4A69636D4A7934424267634742775948426765574768736A4C5349744A69595947784167';
wwv_flow_imp.g_varchar2_table(709) := '4F7945644A4345594652384E46777363476951724A69736F49787779495249644E6A775647786B504778414941556F2B4A7A51624641634747413856446873304652454B435273594968496548615533496930554541674847524D754877345947776355';
wwv_flow_imp.g_varchar2_table(710) := '474351584C68774F414141484141442F3077505541756B414577416E4145304164514374414C5941767741414579494F41525552464234424D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B41526355';
wwv_flow_imp.g_varchar2_table(711) := '465159484A7763584267636A46544D57467A556A4E544D334E6A38424A7A63584E7A592F4154557A46544D75415363314278554742796348467759484978557A46686348467A63574678557A4E545933467A636E4E6A38424E51636D4A7A636E4279596E';
wwv_flow_imp.g_varchar2_table(712) := '4E51637A465263574877453346776358466838424E78556A42775950415263484A77634744774556497A556E4A693842427963334A79597641534D314D7A63325077456E4E7863334E6A384246794947464259794E6A516D427A4957464159694A6A5132';
wwv_flow_imp.g_varchar2_table(713) := '317A565A4E54565A4E5149364E566F304E466F312F6359434F69552B4A43512B4A6633474A54346B4A44354A4451345A4C68674941794D6B4177346648774944437755564478594944785549467A734547676345446734594C786B494179516B42516361';
wwv_flow_imp.g_varchar2_table(714) := '4C786F4D4430494E44786B764767674549694D444342677647416F534C42594A4642414946524156425173454168346541674D4D425263514667675146416B5743524D52434259514677594B4251496648774946436755574542594845524D4A43785164';
wwv_flow_imp.g_varchar2_table(715) := '48536B644852554D45424158454241433654525A4E6635754E566B304E466B31415A4931575451384A44306C2F6D346C5053516B505355426B6955394A4449524567514947533859456770434452593546676B5345676756454259464377554248783445';
wwv_flow_imp.g_varchar2_table(716) := '4377496A5143494543426B764751304F5167384D475338614277556B4A514D494753385A446730425167454B4568677547415946496855664151514C425255504667635146416B4246776B55454163574542594643675543494341434177774546684157';
wwv_flow_imp.g_varchar2_table(717) := '434241544352594A464241494652415742517744416A49644B4234654B42305745426351454263514141494141502F5441395143365141544143634141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F';
wwv_flow_imp.g_varchar2_table(718) := '41534D68496934424E524530506748584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B50674C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A514753';
wwv_flow_imp.g_varchar2_table(719) := '4A54306B414141444141414141414E65416B38414967416D4143774141414547427734424477454742775957467755575067456E4E525958466A34424A7845304A694948425477424A793442427851564A7955554653596E4E67483243516F4646675647';
wwv_flow_imp.g_varchar2_table(720) := '6A45594E426738424E516F5844674B446D416F574467495447416A2B374145434569666C416978716533734354674547417841444C31347643694D487A77594746417566576D51474268514C4161494D4477693648584563437735586D7071616D707161';
wwv_flow_imp.g_varchar2_table(721) := '535646524141414141416B4141502B664137304449414148414138414851417441454D415577426841484D41687741414153596E427863684E6A636E4267636A4A7A593346674D4742773442466A6332467859324A69636D467959474668635746785958';
wwv_flow_imp.g_varchar2_table(722) := '466A34424A79596E4A675547427759504151594842676347466A59334E6A632B415463324E4359424A67595846675948426834424E7A34424A7934424253594746785958466A34424A79596E4C67454242676347427759484267634F415259334E6A6332';
wwv_flow_imp.g_varchar2_table(723) := '4C67454649675957467859664152597A4D6A596D4A7959764153596E4A674C4C523544585567454B4679734D4744446D53443938664868514C777342456778685977304F42677772785177504241736C494273614352674E426A68544250337743677347';
wwv_flow_imp.g_varchar2_table(724) := '437773764B516B4341786B5A4243557442425945434130437251384E41774D594751515047516366476763434466796B4477344442533848475138454C51494244514B7543516B47436730494E6C594D4152494D626C5548416733393251734E41777044';
wwv_flow_imp.g_varchar2_table(725) := '594159534341384E455135684F774D47424159426F6A526F6E5031456943684B6B747774576C6F425767495042686B5342426755415251594241745041524D5942526F714954414B4252554C617A7344437745494241734C4C6B73504377385244773945';
wwv_flow_imp.g_varchar2_table(726) := '4C7755524251675444763749415273504D6D517444424D42436A5A395067634A4567456144326863436745544446746E4341762B7377454741776B4B424351584268675341786C4942784D4F4152495842546B614167555A474145594D514D4641675141';
wwv_flow_imp.g_varchar2_table(727) := '4141554141502B56413734444A4141624144454153514267414751414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D42775948';
wwv_flow_imp.g_varchar2_table(728) := '4267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A59584267636841664E735A5746425167734D4E7A773955302B33566C694554775947486878335431425841785551';
wwv_flow_imp.g_varchar2_table(729) := '5931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570565947414267414D69';
wwv_flow_imp.g_varchar2_table(730) := '416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D414973';
wwv_flow_imp.g_varchar2_table(731) := '4B6B5A4B5545754C4C4338484354457A4E5556436B4473394969746A724B30414142514141502B6A413767444967414541416741444141514142514147414262414C4D424351464D416145422F674A4A416F73437A774D5341326B447467514342457741';
wwv_flow_imp.g_varchar2_table(732) := '414145564553455242544D5249784D564D7A554846544D314278557A4E5163564D7A55444D534D484977636A46534D4849773848465238454D7A637A4E7A4D334D7A637A4E7A4D584D78637A467A4D584D78637A507755314C77556A4A794D314979636A';
wwv_flow_imp.g_varchar2_table(733) := '4A78636A44775566475438454E533844497963314A7A556E49793842497938424E53636A4A7A557641534D764154556E4E53636A4E53636A4A794D764154557641534D6E4E53636A4C774546497738434651636A44774556447749564278554846513842';
wwv_flow_imp.g_varchar2_table(734) := '4977384246513843465138424977384249773842465163564477456A447749564877557A50786B314C7751684D534D5649773844465238454D7A637A4E7A4D584D78637A467A4D584D78637A4877597A507755314C77496A4C776B6A4A794D6E4979636A';
wwv_flow_imp.g_varchar2_table(735) := '4E51636A4477496A4477455642794D5041534D484651636A42794D484977635644774D6A4651384246513843497738424877557A5078307A50774D764177555042523857465238454D7A38454E5363314C7767314A7A557642434D6E497963314C77456A';
wwv_flow_imp.g_varchar2_table(736) := '4A7A556E4E5338424E534D764154556E497963314C7749314C774D464977384646534D564278554846534D564278555846544D56467855584652635648776B7A507751314C7749314A7A556E4E5363314A7A556E4E5463314E7A55334E5463314E7A5576';
wwv_flow_imp.g_varchar2_table(737) := '4241556A44774D564278635642785548465163564278555043425566417A4D2F426A55334E5438484E5463314D7A55334E5463314A7A55764177556A44774D5646785558465263564678556642785558465238434D785566417A4D2F42445576437A556E';
wwv_flow_imp.g_varchar2_table(738) := '4E5363314A7A556E4E53384542534D5042525548465138504652384650774931507745314E7A4D334E5438434D7A384B4E546376424155504252384346526356467A4D584D7838434D7838424D78555846526356467A4D6641544D584D78635646785566';
wwv_flow_imp.g_varchar2_table(739) := '4152556641685566416A4D2F425455764841556A4477676A42794D484977636A42794D4849773845465238464D7A637A4E7A4D334D7A637A5077737A4E7A4D2F4154552F415455334E5438454E53384542513846465238464D7838424652637A467A4D66';
wwv_flow_imp.g_varchar2_table(740) := '4152556641544D58465238454D78637A4877597A507755314C78596849773858465238474D7A38494D7A38454E54637A4E7A4D334E5438424E5438424D7A38454E533845415630424C7637712F7634617973724B7973724B796D554C4267734644415546';
wwv_flow_imp.g_varchar2_table(741) := '426959474367674541674D424151494742416B454B77554A4251554642516F464867554B4251554642516F4547416B4642414D454241454242414D45427959464267554C426773473941554542514D45424149434341494D4277674842414D4541775144';
wwv_flow_imp.g_varchar2_table(742) := '427759484477494A41674D5242414D4543516B4542414D45415149444167454341774942416849424351514741514D45417745444341514441514D424177454942415145415151494151514B2F66454642416746424145454241514D4241514543414D42';
wwv_flow_imp.g_varchar2_table(743) := '4177514442414D45435145504167454341774D464167454541774D4241674D444341514A4251634642524147416759434477634742774D454177514442416349424151484167454341674D45434145454567304B42516347416749444341674541516745';
wwv_flow_imp.g_varchar2_table(744) := '4A675149417751454241634543414D614177674842774D4A4251514542414D45415151444277454442515145424151454351516D42416B4642415146446130454341594841514D4941774556417745444177454A4151774243516B444177494241674D44';
wwv_flow_imp.g_varchar2_table(745) := '434151424241494341674D444341514642416B4443414D4342414D434177494441674D4341774D4441674D4441774D4441774D4442674D6A41674D454241494342515149415951464341514441774D4242674D4441674D434177494441674D4846674545';
wwv_flow_imp.g_varchar2_table(746) := '4151514242674D4341675145417751464351514542414D45415149434167454341514942416749434151454243414542415149434241454342774D43415149444167454342674D4A41774D44425033444251514941774D43416745434151454241514542';
wwv_flow_imp.g_varchar2_table(747) := '416745494167454241514D444241514542516B4541774D45415149464177494241514542415145434151454341774D4A41753446424167474167454241514542416767434151494342414557415145454177774643515147425151444367494941514942';
wwv_flow_imp.g_varchar2_table(748) := '41674943427745424151454242414D454350796E42516749424149424151454342674943416745454151594343674D4541514D474241554A4241514541775143415249424167454341514943416763434151454241514948417755433841514642415144';
wwv_flow_imp.g_varchar2_table(749) := '4241494342774944425149454151494444416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A41514943417751492F61304543415144416749434251594D4267454D4151594841774544';
wwv_flow_imp.g_varchar2_table(750) := '4177454842774D42427763424177454442416745424177454241514543515145424155434151454542414D564177514B42786B444367494441774D4441774D444167594441674D4341774949415A77464241514242776F63437763534241734542775145';
wwv_flow_imp.g_varchar2_table(751) := '427751494242414942414D434167454542414D45425177464451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D4542663545424155454267494341514944417755454151514E4351454E';
wwv_flow_imp.g_varchar2_table(752) := '4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D4642415546424155464243556543415145435177444451495342515146417745554241514A43425973425155454251554642415562';
wwv_flow_imp.g_varchar2_table(753) := '424159454151454341774D454241514A41775946437755464251595541523446436755464241454541515146484130454151514641774942416749444241674348417A2B6B414638475036304153635A47556F5947465559474530594741497641514542';
wwv_flow_imp.g_varchar2_table(754) := '4151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B41516B484267634442414D454177514843416355424130454243414441774943';
wwv_flow_imp.g_varchar2_table(755) := '416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D454177454444414D42417745444151674542415142424151454151514E46775546';
wwv_flow_imp.g_varchar2_table(756) := '4241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D45415149434251774643515144426749424151454241514943427749434177494341674543';
wwv_flow_imp.g_varchar2_table(757) := '41774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B424351514441774544417745444377634843516B45417751454151454541777744424159444177494441774D4441774D43';
wwv_flow_imp.g_varchar2_table(758) := '41774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48417767444177494241514D434241674A42414945435151454241514542514D42';
wwv_flow_imp.g_varchar2_table(759) := '41774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D444167454341674D4543416B46';
wwv_flow_imp.g_varchar2_table(760) := '4242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B424449454251514942415943416759494367555A41515142464159464251554C';
wwv_flow_imp.g_varchar2_table(761) := '426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F42424159434151454441675149435167424B5151464251514642516B464967554A4251554642516F46';
wwv_flow_imp.g_varchar2_table(762) := '46775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C415163514241514D42415145424151454351516D4251554942415144424B414242414D44';
wwv_flow_imp.g_varchar2_table(763) := '42416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B434151594445414D474177494441674D43417749444267494441774D444177644B';
wwv_flow_imp.g_varchar2_table(764) := '415149424177594D41774D46417749424151454541774D454351554543414D444167454241514543435149434167454341514942415145434167494241514545415145424251514442515146434167444167456E415145444267514A4251514542414946';
wwv_flow_imp.g_varchar2_table(765) := '4177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D45416745434151494241674551454159434177554A41776F4241674943447749444251594D464145434151494241674543';
wwv_flow_imp.g_varchar2_table(766) := '42674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D454141414141414D414141414141376B436A67414441416341437741414578456845516352';
wwv_flow_imp.g_varchar2_table(767) := '4952456A4D78456A4C774F4B4D6631696A463565416F37396A774A784D50337241685839367741674141442F37674F73417338414241414A4141344145774159414345414C514132414545415467425641466F415877426B41476B416267427A41486741';
wwv_flow_imp.g_varchar2_table(768) := '66514349414934416C774368414B594171774377414C55417567432F414D51417951444F414141424D6A4D31497863794D7A556A467A497A4E534D584D6A4D31497863794D7A556A467A497A4E6863334A69734249534948467A59794E69636D4E6A556D';
wwv_flow_imp.g_varchar2_table(769) := '425259584E6A63324E79596E4251594846686357467A59334A79594644674558466759574D6A4D794E7A516E425159564D7959334A7755794D7A556A4254497A4E534D464D6A4D31497755794D7A556A4254497A4E534D464D6A4D31497755794D7A556A';
wwv_flow_imp.g_varchar2_table(770) := '4254497A4E534D4642676357467859584E6A636E4A675557467A636D4A77554742785966415459334A775557467A63324E79596E427759584D6A4D31497863794D7A556A467A497A4E534D584D6A4D31497863794D7A556A467A497A4E534D484E445568';
wwv_flow_imp.g_varchar2_table(771) := '45524D794D7845684E7851564D7A554242526B594D57495A474446684752677859686B594D57495A47444668424163594377594C465254393751304D43514D4F42674D42416745435968494E42516F52425251592F544D594577554C4541635144676F4B';
wwv_flow_imp.g_varchar2_table(772) := '4176454C417751434151494B445249484376796A427A4542426934444E526B594D667A4447526778417A305A4744483877786B594D514D39475267782F4D4D5A4744454450526B594D667A4447526778417A73464351594C45516750425241572F4C3847';
wwv_flow_imp.g_varchar2_table(773) := '4553674C42414C634552454643414D62467837394D42735A4251554345784148446D4D5A474446684752677859686B594D57495947444265475267785A526B594D54582B72682B4B697637734A6373436E5445784D5445784D5445784D544542416A4143';
wwv_flow_imp.g_varchar2_table(774) := '417A4142424167454651514850516B5142416B4D4278634E4177385742416B4E4242494845424A5741516F4C416738474152346143426764457855506C5445314D5934784E6A474F4D5455786A7A45314D566B5744774D4843774D5A47774D464452775A';
wwv_flow_imp.g_varchar2_table(775) := '477849545151774644426B4A42784D6E4B6849484568514A4267774A46536B784D5445784D5445784D5445784D534B73712F367041546A2B36366358474338414141734141502F4F41376B433867414641416B4144514152414255414751416641434D41';
wwv_flow_imp.g_varchar2_table(776) := '4A77417241433841414263314D78557A46544D314D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A557A4E544D564A54557A465345314D78556C455345524A78456845533478454446684D574978595446694D5745774454483864544544';
wwv_flow_imp.g_varchar2_table(777) := '4B54483864674F4B4D667A574D6C6B6F4D5445784D5445784D5445784D5445784B466D4B5846786358497343442F33784D41477A2F6B30414141514141502B6341384D444941414441416341446741564141414245544D524D78457A45514548467A557A';
wwv_flow_imp.g_varchar2_table(778) := '4E534D6C465163564D7855334157346D7779622B554B536B58563043553135656F774D672F487744685078384134542B34614F6A62326C756241467162364D41415141412F2B59446D414D41414263414141454642685166415259484151596641525933';
wwv_flow_imp.g_varchar2_table(779) := '41545966415259794E784D324A674F562F6D4D434157414341763470416749744177514231775144575145444161634241674C2F6F67454441563844412F346F41774D7241774D4231674D4457674543415A5542416741434141414141414F35416D5941';
wwv_flow_imp.g_varchar2_table(780) := '41774148414141544553455241524568455338446976796C41796F435A7633774168442B4851477A2F6B304141416B4141502B6E413749444867414441416341437741524142554147514166414355414B5141414152557A4E5155564D7A557A46544D31';
wwv_flow_imp.g_varchar2_table(781) := '4678557A46544D314252557A4E5155564D7A554846534D564D7A554646544D31497A555846544D314153396E2F7148616F64754365796A39665763423943676F64352F396E7039333446494448747261396D646E5A3263654B485764614E72616E30314E';
wwv_flow_imp.g_varchar2_table(782) := '766E516F6E4147644B4856314B436741437741412F38344475514C79414155414351414E414245414651415A414238414977416E414373414C7741414578557A4E544D314D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A557A46544D56';
wwv_flow_imp.g_varchar2_table(783) := '4D7A554646544D314952557A4E51555249524548455345524C6A45514D574578596A46684D5749785954414E4D6678314D514D704D66783241346F782F4E5943386C6B704D4441774D4441774D4441774D4441774B566D4A584678635849763938414951';
wwv_flow_imp.g_varchar2_table(784) := '4D50354E41624D41444141412F2F6F4475514C434141514147414163414341414A41416F414377414D414130414467415041424141414154465245684551556846534D564D78556A46544D564954557A4E534D314D7A556A4D78557A4E544D564D7A557A';
wwv_flow_imp.g_varchar2_table(785) := '46544D314D78557A4E544D564D7A554646544D314D78557A4E544D564D7A557A46544D314D78557A4E5338446976796C41796F4D4441774D2F4E595245524552516D4978595446694D57457859763155596A46684D5749785954466941734C592F684143';
wwv_flow_imp.g_varchar2_table(786) := '794379734D62597871616B78746A45784D5445784D5445784D544578357A45784D5445784D5445784D54454141414141427741412F2F6F4475514C43414151414541415541426741484141674143514141424D5A41534552425345524978557A45534552';
wwv_flow_imp.g_varchar2_table(787) := '4D7A556A4D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A55764134723870514D7144417A3831684552516D4978595446694D57457859674C432F72542B68414C494C5037674D50376A415230774D4441774D4441774D4441774D414141';
wwv_flow_imp.g_varchar2_table(788) := '414141464141442F30674D6A41756F414251414C41413441466741644141414249694D524952456E46544D524952454646794D6E4851456A46544D564E796358427A556A4E544D4363746258416C376C7550333841586C3966654E71616F313558467871';
wwv_flow_imp.g_varchar2_table(789) := '61674C712F4F6743596F6D362F667743766779426242684655467945566C5A5751696741424141412F39494449774C71414155414377414F414255414141456949784568455363564D78456845515558497963564978557A4654634363746258416C376C';
wwv_flow_imp.g_varchar2_table(790) := '7550333841586C3966654E71616F304336767A6F416D4B4A757633384172344D6757786455467945414141434141442F31674E79417538416277446B414141424967594842676347487745564A6938424D53636D4A79596E4A69636D4278554742775958';
wwv_flow_imp.g_varchar2_table(791) := '46686357467859664153636D4A79596E4A676347427A6B4242686357467859584668635746785966415345334E6A38424E6A38424E6A63324E7A596E4C67456E4A67594842676347447745314E4455324A79596E4C674569426763474277595041693842';
wwv_flow_imp.g_varchar2_table(792) := '4A69636D4A793442427A4D484D6A457A4D6859584867456641525966415438434E6A63324E7A34424F774579466838424668635742785566415459334E6A63324E7A59584F51456541526357427759484267384242676347447745684A69636D4A79596E';
wwv_flow_imp.g_varchar2_table(793) := '4A69636D4A79592B41686357467859664154636E4A69636D4A79596E4A6A632B4154633246686357467859584D525966415438424E6938424A6A63324E7A34424166494F4741634C41774D424151594941516B4D4277734C45524D5848526B4841776346';
wwv_flow_imp.g_varchar2_table(794) := '45417746434130474452414A4A79515745786351485155434751346B4C5263634F5363514251464D4177514B444251624378674B4541634B42675159455134634368495042676B47415149454341595647525948445163474277594A42674D464277634D';
wwv_flow_imp.g_varchar2_table(795) := '4278634E41514942415155464241634E42774947434167684767594842516348424155464167514341674547416749424153414B456841494467304B44416B494167514A4267304946424D594751554A4350376644694536487867754977775441674547';
wwv_flow_imp.g_varchar2_table(796) := '4552595048794963485263644452414F4267305042415944415155474452554D4377774944776F55455341424167454241674D44427751474175344F444251684844386F517730584178636744786B5147516B4C4377454C48684D6A466A456D45787379';
wwv_flow_imp.g_varchar2_table(797) := '467777504343494F4341454344687365474341524A533463495667374651634D44533433586B63634F78777448797761447863444177734C45534D4B4742424C45535532467949524377384C43524562466A456B4C7A4D675168346A4541774F41534545';
wwv_flow_imp.g_varchar2_table(798) := '4267773552786B344F4377426C534D784642634A4251494241774D4C48426C414A364148465338714568344E4367454242776B544978676D466A4D7A504734584A7955534E466B6C4853346C4478674F434177514151554E4868636747773832507A4957';
wwv_flow_imp.g_varchar2_table(799) := '4B5330534767384842774D47436849514868496F476A4172426A49374B68354748426B4F4267514141414141434141412F39734462514C674142514147414171414334414D67424D414745415A51414141534947427759484642594846544D314A6A632B';
wwv_flow_imp.g_varchar2_table(800) := '4152637A4E534D6D42544D31497863324678594846544D304E54516E4C67496E4A67636A41544D314977557A4E534D4646425958466863574E7A59584E6863574D7A59334E53496A4269637541546331497755554467456A426973424654497A466A3443';
wwv_flow_imp.g_varchar2_table(801) := '4E7A59314E44556A42544D31497745434B306F4C424149424154494241675132494E684B5A41454B4C792B4C4F787766424449424169513548776B54436632304D6A4943766A49792F554974497851624543455A4441514C43515146416841664E787366';
wwv_flow_imp.g_varchar2_table(802) := '4A774579417234574A68596A52794D554B5430394E69494241544C2B6C693475417438354B784958446A634F526A42514B434974416A45424D6A457842423065514A67624F456B6C49446B6B415149422F6B6378537A48554A3063524367494341514542';
wwv_flow_imp.g_varchar2_table(803) := '415145424151517441514D484E53465857526371477745784151556C4F53414F4852554C7A54454141414141425141412F3667446A774D554141674144414151414251414741414141526B424954556A45544D31415163584E773842467A635041526333';
wwv_flow_imp.g_varchar2_table(804) := '447745584E774A714153587136763531505434397544302B50626739506A3234505434394178542B5376354B50414C3050503758506A302B506A3439506A342B5054342B5054342B414141414141514141502F77413677437A514154414363414E774248';
wwv_flow_imp.g_varchar2_table(805) := '4141415449673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A49534975415455524E4434424679494746524555466A4D684D6A59314554516D497755684D68595645525147497945694A6A55524E446253';
wwv_flow_imp.g_varchar2_table(806) := '4B55516F4B455170416B556F5253676F52536A3975774A46487A5166487A51662F6273664E5238664E54776D4E7A636D4167736D4E6A596D2F6655434378676949686A3939526B6949674C4D4B4551702F6B346F5253676F5253674273696C454B434966';
wwv_flow_imp.g_varchar2_table(807) := '4E522F2B546838314878383148774779487A55664D54596D2F6F496D4E6A596D4158346D4E69496947503643474349694741462B4743494141414141416741412F37384469774C3341424D41484141414151344448674D33506749334279632F41533442';
wwv_flow_imp.g_varchar2_table(808) := '435145474867453341533442417149735544736442696844564330775654734C6E6F493670694A592F752F2B6D774D664D5263425852387641764D444B455657576C453748514D444C3030774E30754D4F6941672F70332B6B78597848774D425A424933';
wwv_flow_imp.g_varchar2_table(809) := '41414141415141412F2B494469414C7841424D4141414547427759484668384242775948466838424E6A3842467A593341346852554C526246436369763670554277344C57624B7957444661417645704B466F7245696369763670564277344C57724B7A';
wwv_flow_imp.g_varchar2_table(810) := '574743744141494141502F6441346F4338774152414255414141454742775948466838424477492F417863324E77455041546344696C4651744673574B78764B7A796A334169444A574446612F6967626F426F4338796B6F576973554C42764D4976636F';
wwv_flow_imp.g_varchar2_table(811) := '4438584B574743742F6E4B68477145414141494141502F6941346F433851414741416F41414145464677455841526346465345314134722B5556762B5253414276466E397A414671417648575776354249414841575A34724B77414141414153414E3441';
wwv_flow_imp.g_varchar2_table(812) := '415141414141414141414156414141414151414141414141415141454142554141514141414141414167414841426B41415141414141414141774145414341414151414141414141424141454143514141514141414141414251414C4143674141514141';
wwv_flow_imp.g_varchar2_table(813) := '414141414267414541444D4141514141414141414367417241446341415141414141414143774154414749414177414242416B4141414171414855414177414242416B4141514149414A38414177414242416B414167414F414B63414177414242416B41';
wwv_flow_imp.g_varchar2_table(814) := '41774149414C55414177414242416B4142414149414C30414177414242416B4142514157414D55414177414242416B4142674149414E73414177414242416B4143674257414F4D414177414242416B414377416D41546C6A59573131626D526849464E6C';
wwv_flow_imp.g_varchar2_table(815) := '636E5A705932567A49456474596B686963473175556D566E64577868636D4A776257356963473175566D567963326C76626941784C6A426963473175523256755A584A686447566B49474A3549484E325A7A4A30644759675A6E4A766253424762323530';
wwv_flow_imp.g_varchar2_table(816) := '5A57787362794277636D39715A574E304C6D6830644841364C79396D623235305A5778736279356A62323041597742684147304164514275414751415951416741464D415A514279414859416151426A4147554163774167414563416251426941456741';
wwv_flow_imp.g_varchar2_table(817) := '596742774147304162674253414755415A7742314147774159514279414749416341427441473441596742774147304162674257414755416367427A41476B4162774275414341414D51417541444141596742774147304162674248414755416267426C';
wwv_flow_imp.g_varchar2_table(818) := '4148494159514230414755415A414167414749416551416741484D416467426E4144494164414230414759414941426D41484941627742744143414152674276414734416441426C41477741624142764143414163414279414738416167426C41474D41';
wwv_flow_imp.g_varchar2_table(819) := '644141754147674164414230414841414F674176414338415A674276414734416441426C41477741624142764143344159774276414730414141414141674141414141414141414B41414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(820) := '4141427341514942417745454151554242674548415167424351454B415173424441454E415134424477455141524542456745544152514246514557415263424741455A41526F42477745634152304248674566415341424951456941534D424A41456C';
wwv_flow_imp.g_varchar2_table(821) := '415359424A77456F41536B424B674572415377424C514575415338424D414578415449424D774530415455424E674533415467424F5145364154734250414539415434425077464141554542516746444155514252514647415563425341464A41556F42';
wwv_flow_imp.g_varchar2_table(822) := '5377464D4155304254674650415641425551465341564D4256414656415659425677465941566B425767466241567742585146654156384259414668415749425977466B415755425A67466E4157674261514671415773426241467441415630636D467A';
wwv_flow_imp.g_varchar2_table(823) := '6142426E5958526C643246354C584268636D46736247567348326C75644756796257566B615746305A53316C646D56756443316A5958526A6143316A5957356A5A577778615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F';
wwv_flow_imp.g_varchar2_table(824) := '4C57357662693170626E526C636E4A3163485270626D63746257567A6332466E5A52687A644746796443316C646D56756443316A623231775A57357A595852706232347563335268636E51745A585A6C626E5174626D39754C576C7564475679636E5677';
wwv_flow_imp.g_varchar2_table(825) := '64476C755A79317759584A686247786C6243317464577830615842735A517473623239774C573168636D746C63684A7759584A686247786C624331746153317459584A725A58496A63335268636E51745A585A6C626E5174626D39754C576C7564475679';
wwv_flow_imp.g_varchar2_table(826) := '636E567764476C755A79317A6157647559577776615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C57357662693170626E526C636E4A3163485270626D637464476C745A584971615735305A584A745A5752705958526C';
wwv_flow_imp.g_varchar2_table(827) := '4C5756325A5735304C574E6864474E6F4C584268636D4673624756734C573131624852706347786C4A576C75644756796257566B615746305A53316C646D56756443316A5958526A6143316A623231775A57357A595852706232344C5A3246305A586468';
wwv_flow_imp.g_varchar2_table(828) := '65533134623349515A57356B4C5756325A5735304C574E68626D4E6C62434A70626E526C636D316C5A476C68644755745A585A6C626E51745932463059326774593239755A476C30615739754F326C75644756796257566B615746305A53316C646D5675';
wwv_flow_imp.g_varchar2_table(829) := '6443316A5958526A6143317562323474615735305A584A79645842306157356E4C584268636D4673624756734C573131624852706347786C46584E3059584A304C5756325A5735304C574E76626D527064476C7662694A7A644746796443316C646D5675';
wwv_flow_imp.g_varchar2_table(830) := '6443317562323474615735305A584A79645842306157356E4C5852706257567946484E6C6358566C626E52705957777462576B7462574679613256794358567A5A5849746447467A6177316964584E70626D567A637931796457786C456E4E3159693177';
wwv_flow_imp.g_varchar2_table(831) := '636D396A5A584E7A4C573168636D746C6368317A644746796443316C646D56756443317759584A686247786C6243317464577830615842735A52467A644746796443316C646D56756443316C636E4A7663683970626E526C636D316C5A476C6864475574';
wwv_flow_imp.g_varchar2_table(832) := '5A585A6C626E5174593246305932677463326C6E626D4673486D6C75644756796257566B615746305A53316C646D56756443316A5958526A6143316C636E4A7663685A6C626D51745A585A6C626E51745932397463475675633246306157397546484E31';
wwv_flow_imp.g_varchar2_table(833) := '596E427962324E6C63334D7459323973624746776332566B45334E31596E427962324E6C63334D745A5868775957356B5A5751456447467A6177396C626D51745A585A6C626E51745A584A796233496A615735305A584A745A5752705958526C4C575632';
wwv_flow_imp.g_varchar2_table(834) := '5A5735304C574E6864474E6F4C57567A593246735958527062323465615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C58527062575679466E4E3059584A304C5756325A5735304C57567A593246735958527062323453';
wwv_flow_imp.g_varchar2_table(835) := '63335268636E51745A585A6C626E517463326C6E626D4673456D4A3163326C755A584E7A4C584A31624755746447467A61775A745957353159577748636D566A5A576C325A51316A595778734C57466A64476C326158523545584E3059584A304C575632';
wwv_flow_imp.g_varchar2_table(836) := '5A5735304C5852706257567945334E3059584A304C5756325A5735304C57316C63334E685A325558615735305A584A745A5752705958526C4C5756325A5735304C573576626D5564615735305A584A745A5752705958526C4C5756325A5735304C574E68';
wwv_flow_imp.g_varchar2_table(837) := '64474E6F4C577870626D73555A57356B4C5756325A5735304C57567A593246735958527062323448596E4274626931706277396E5958526C643246354C574E76625842735A5867535A3246305A5864686553316C646D567564474A686332566B44476468';
wwv_flow_imp.g_varchar2_table(838) := '6447563359586B74626D39755A51706E5958526C643246354C573979453256755A43316C646D5675644331305A584A7461573568644755515A57356B4C5756325A5735304C584E705A3235686241356C626D51745A585A6C626E5174626D39755A524A6C';
wwv_flow_imp.g_varchar2_table(839) := '626D51745A585A6C626E51746258567364476C77624755525A57356B4C5756325A5735304C57316C63334E685A32554F5A57356B4C5756325A5735304C577870626D7367615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F';
wwv_flow_imp.g_varchar2_table(840) := '4C57316C63334E685A32556C615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C574E766258426C626E4E6864476C766268527A644746796443316C646D56756443317464577830615842735A515A7A59334A706348514C';
wwv_flow_imp.g_varchar2_table(841) := '62574675645746734C58526863327345633256755A41647A5A584A3261574E6C44484A6C59325670646D55746447467A617752316332567945484E3059584A304C5756325A5735304C573576626D556A615735305A584A745A5752705958526C4C575632';
wwv_flow_imp.g_varchar2_table(842) := '5A5735304C58526F636D39334C57567A593246735958527062323468615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C573131624852706347786C4E476C75644756796257566B615746305A53316C646D56756443316A';
wwv_flow_imp.g_varchar2_table(843) := '5958526A6143317562323474615735305A584A79645842306157356E4C57567A593246735958527062323464615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C577870626D736D63335268636E51745A585A6C626E5174';
wwv_flow_imp.g_varchar2_table(844) := '626D39754C576C7564475679636E567764476C755A79316A6232356B615852706232344C5A47463059533176596D706C5933514C63324E79615842304C5852686332734A633256755A43313059584E72436D52686447457463335276636D556E63335268';
wwv_flow_imp.g_varchar2_table(845) := '636E51745A585A6C626E5174626D39754C576C7564475679636E567764476C755A79316C63324E68624746306157397549476C75644756796257566B615746305A53316C646D56756443313061484A76647931745A584E7A5957646C4D6D6C7564475679';
wwv_flow_imp.g_varchar2_table(846) := '6257566B615746305A53316C646D56756443316A5958526A6143317562323474615735305A584A79645842306157356E4C573131624852706347786C4D476C75644756796257566B615746305A53316C646D56756443316A5958526A6143317562323474';
wwv_flow_imp.g_varchar2_table(847) := '615735305A584A79645842306157356E4C584E705A32356862434670626E526C636D316C5A476C68644755745A585A6C626E517464476879623363746258567364476C776247556B63335268636E51745A585A6C626E5174626D39754C576C7564475679';
wwv_flow_imp.g_varchar2_table(848) := '636E567764476C755A7931745A584E7A5957646C4457466B4C5768765979317459584A725A58494D63325679646D6C6A5A53313059584E724358526863327374626D39755A524E6A623231775A57357A595852706232347462574679613256794A584E30';
wwv_flow_imp.g_varchar2_table(849) := '59584A304C5756325A5735304C57357662693170626E526C636E4A3163485270626D63746258567364476C7762475566615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C584E705A32356862444E70626E526C636D316C';
wwv_flow_imp.g_varchar2_table(850) := '5A476C68644755745A585A6C626E51745932463059326774626D39754C576C7564475679636E567764476C755A79316A6232356B615852706232344C6347467964476C6A61584268626E515A5A585A6C626E51746333566963484A765932567A6379316C';
wwv_flow_imp.g_varchar2_table(851) := '65484268626D526C5A4246735957356C4C576C7563325679644331695A5778766477707A6347466A5A5331306232397345474E76626D356C59335270623234746258567364476B45624746755A51707359584E7A627931306232397345577868626D5574';
wwv_flow_imp.g_varchar2_table(852) := '6157357A5A584A304C57466962335A6C45577868626D55745A476C326157526C4C58526F636D566C44327868626D55745A476C326157526C4C5852336277706B595852684C576C75634856304332526864474574623356306348563043576868626D5174';
wwv_flow_imp.g_varchar2_table(853) := '644739766241566E636D3931634139305A5868304C574675626D3930595852706232344C64484A68626E4E68593352706232344D63324E795A58637464334A6C626D4E6F436D4E76626D356C5933527062323451593239755A476C306157397559577774';
wwv_flow_imp.g_varchar2_table(854) := '5A6D78766477786B5A575A68645778304C575A736233634141413D3D272920666F726D61742827747275657479706527293B0A7D0A2F2A204368726F6D65206861636B3A205356472069732072656E6465726564206D6F726520736D6F6F746820696E20';
wwv_flow_imp.g_varchar2_table(855) := '57696E646F7A7A652E2031303025206D616769632C20756E636F6D6D656E7420696620796F75206E6565642069742E202A2F0A2F2A204E6F74652C20746861742077696C6C20627265616B2068696E74696E672120496E206F74686572204F532D657320';
wwv_flow_imp.g_varchar2_table(856) := '666F6E742077696C6C206265206E6F7420617320736861727020617320697420636F756C64206265202A2F0A2F2A0A406D656469612073637265656E20616E6420282D7765626B69742D6D696E2D6465766963652D706978656C2D726174696F3A302920';
wwv_flow_imp.g_varchar2_table(857) := '7B0A202040666F6E742D66616365207B0A20202020666F6E742D66616D696C793A202762706D6E273B0A202020207372633A2075726C28272E2E2F666F6E742F62706D6E2E7376673F31363430363238392362706D6E272920666F726D61742827737667';
wwv_flow_imp.g_varchar2_table(858) := '27293B0A20207D0A7D0A2A2F0A0A5B636C6173735E3D2262706D6E2D69636F6E2D225D3A6265666F72652C205B636C6173732A3D222062706D6E2D69636F6E2D225D3A6265666F7265207B0A2020666F6E742D66616D696C793A202262706D6E223B0A20';
wwv_flow_imp.g_varchar2_table(859) := '20666F6E742D7374796C653A206E6F726D616C3B0A2020666F6E742D7765696768743A206E6F726D616C3B0A2020737065616B3A206E657665723B0A0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A2020746578742D6465636F726174';
wwv_flow_imp.g_varchar2_table(860) := '696F6E3A20696E68657269743B0A202077696474683A2031656D3B0A20202F2A206D617267696E2D72696768743A202E32656D3B202A2F0A2020746578742D616C69676E3A2063656E7465723B0A20202F2A206F7061636974793A202E383B202A2F0A0A';
wwv_flow_imp.g_varchar2_table(861) := '20202F2A20466F7220736166657479202D20726573657420706172656E74207374796C65732C20746861742063616E20627265616B20676C79706820636F6465732A2F0A2020666F6E742D76617269616E743A206E6F726D616C3B0A2020746578742D74';
wwv_flow_imp.g_varchar2_table(862) := '72616E73666F726D3A206E6F6E653B0A0A20202F2A2066697820627574746F6E73206865696768742C20666F72207477697474657220626F6F747374726170202A2F0A20206C696E652D6865696768743A2031656D3B0A0A20202F2A20416E696D617469';
wwv_flow_imp.g_varchar2_table(863) := '6F6E2063656E74657220636F6D70656E736174696F6E202D206D617267696E732073686F756C642062652073796D6D6574726963202A2F0A20202F2A2072656D6F7665206966206E6F74206E6565646564202A2F0A20202F2A206D617267696E2D6C6566';
wwv_flow_imp.g_varchar2_table(864) := '743A202E32656D3B202A2F0A0A20202F2A20796F752063616E206265206D6F726520636F6D666F727461626C65207769746820696E637265617365642069636F6E732073697A65202A2F0A20202F2A20666F6E742D73697A653A20313230253B202A2F0A';
wwv_flow_imp.g_varchar2_table(865) := '20200A20202F2A20466F6E7420736D6F6F7468696E672E2054686174207761732074616B656E2066726F6D2054574253202A2F0A20202D7765626B69742D666F6E742D736D6F6F7468696E673A20616E7469616C69617365643B0A20202D6D6F7A2D6F73';
wwv_flow_imp.g_varchar2_table(866) := '782D666F6E742D736D6F6F7468696E673A20677261797363616C653B0A0A20202F2A20556E636F6D6D656E7420666F7220334420656666656374202A2F0A20202F2A20746578742D736861646F773A203170782031707820317078207267626128313237';
wwv_flow_imp.g_varchar2_table(867) := '2C203132372C203132372C20302E33293B202A2F0A7D0A0A2E62706D6E2D69636F6E2D74726173683A6265666F7265207B20636F6E74656E743A20275C65383031273B207D202F2A2027EEA08127202A2F0A2E62706D6E2D69636F6E2D67617465776179';
wwv_flow_imp.g_varchar2_table(868) := '2D706172616C6C656C3A6265666F7265207B20636F6E74656E743A20275C65383034273B207D202F2A2027EEA08427202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D63616E63656C3A6265666F7265';
wwv_flow_imp.g_varchar2_table(869) := '207B20636F6E74656E743A20275C65383035273B207D202F2A2027EEA08527202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D6573736167653A6265666F';
wwv_flow_imp.g_varchar2_table(870) := '7265207B20636F6E74656E743A20275C65383036273B207D202F2A2027EEA08627202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383037273B20';
wwv_flow_imp.g_varchar2_table(871) := '7D202F2A2027EEA08727202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D706172616C6C656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383038273B207D';
wwv_flow_imp.g_varchar2_table(872) := '202F2A2027EEA08827202A2F0A2E62706D6E2D69636F6E2D6C6F6F702D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383039273B207D202F2A2027EEA08927202A2F0A2E62706D6E2D69636F6E2D706172616C6C656C2D6D692D';
wwv_flow_imp.g_varchar2_table(873) := '6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383061273B207D202F2A2027EEA08A27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D7369676E616C3A6265666F72';
wwv_flow_imp.g_varchar2_table(874) := '65207B20636F6E74656E743A20275C65383062273B207D202F2A2027EEA08B27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D74696D65723A6265666F72';
wwv_flow_imp.g_varchar2_table(875) := '65207B20636F6E74656E743A20275C65383063273B207D202F2A2027EEA08C27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D706172616C6C656C2D6D756C7469706C653A6265666F7265207B2063';
wwv_flow_imp.g_varchar2_table(876) := '6F6E74656E743A20275C65383064273B207D202F2A2027EEA08D27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(877) := '65383065273B207D202F2A2027EEA08E27202A2F0A2E62706D6E2D69636F6E2D676174657761792D786F723A6265666F7265207B20636F6E74656E743A20275C65383066273B207D202F2A2027EEA08F27202A2F0A2E62706D6E2D69636F6E2D656E642D';
wwv_flow_imp.g_varchar2_table(878) := '6576656E742D63616E63656C3A6265666F7265207B20636F6E74656E743A20275C65383131273B207D202F2A2027EEA09127202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6E646974696F6E3A';
wwv_flow_imp.g_varchar2_table(879) := '6265666F7265207B20636F6E74656E743A20275C65383132273B207D202F2A2027EEA09227202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D706172616C6C';
wwv_flow_imp.g_varchar2_table(880) := '656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383133273B207D202F2A2027EEA09327202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D636F6E646974696F6E3A6265666F7265207B20636F6E7465';
wwv_flow_imp.g_varchar2_table(881) := '6E743A20275C65383134273B207D202F2A2027EEA09427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D74696D65723A6265666F7265207B20636F6E74656E743A20275C65383135273B20';
wwv_flow_imp.g_varchar2_table(882) := '7D202F2A2027EEA09527202A2F0A2E62706D6E2D69636F6E2D73657175656E7469616C2D6D692D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383136273B207D202F2A2027EEA09627202A2F0A2E62706D6E2D69636F6E2D7573';
wwv_flow_imp.g_varchar2_table(883) := '65722D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383137273B207D202F2A2027EEA09727202A2F0A2E62706D6E2D69636F6E2D627573696E6573732D72756C653A6265666F7265207B20636F6E74656E743A20275C65383138273B';
wwv_flow_imp.g_varchar2_table(884) := '207D202F2A2027EEA09827202A2F0A2E62706D6E2D69636F6E2D7375622D70726F636573732D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383139273B207D202F2A2027EEA09927202A2F0A2E62706D6E2D69636F6E2D737461';
wwv_flow_imp.g_varchar2_table(885) := '72742D6576656E742D706172616C6C656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383161273B207D202F2A2027EEA09A27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6572726F723A626566';
wwv_flow_imp.g_varchar2_table(886) := '6F7265207B20636F6E74656E743A20275C65383162273B207D202F2A2027EEA09B27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D7369676E616C3A6265666F7265207B20636F6E74656E743A2027';
wwv_flow_imp.g_varchar2_table(887) := '5C65383163273B207D202F2A2027EEA09C27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6572726F723A6265666F7265207B20636F6E74656E743A20275C65383164273B207D202F2A2027EEA09D';
wwv_flow_imp.g_varchar2_table(888) := '27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383165273B207D202F2A2027EEA09E27202A2F0A2E62706D6E2D69636F6E2D73756270726F636573';
wwv_flow_imp.g_varchar2_table(889) := '732D636F6C6C61707365643A6265666F7265207B20636F6E74656E743A20275C65383166273B207D202F2A2027EEA09F27202A2F0A2E62706D6E2D69636F6E2D73756270726F636573732D657870616E6465643A6265666F7265207B20636F6E74656E74';
wwv_flow_imp.g_varchar2_table(890) := '3A20275C65383230273B207D202F2A2027EEA0A027202A2F0A2E62706D6E2D69636F6E2D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383231273B207D202F2A2027EEA0A127202A2F0A2E62706D6E2D69636F6E2D656E642D657665';
wwv_flow_imp.g_varchar2_table(891) := '6E742D6572726F723A6265666F7265207B20636F6E74656E743A20275C65383232273B207D202F2A2027EEA0A227202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D657363616C6174696F6E3A626566';
wwv_flow_imp.g_varchar2_table(892) := '6F7265207B20636F6E74656E743A20275C65383233273B207D202F2A2027EEA0A327202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D74696D65723A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(893) := '65383234273B207D202F2A2027EEA0A427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383235273B207D202F2A2027EEA0A527202A2F0A2E62706D';
wwv_flow_imp.g_varchar2_table(894) := '6E2D69636F6E2D73746172742D6576656E742D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383236273B207D202F2A2027EEA0A627202A2F0A2E62706D6E2D69636F6E2D627573696E6573732D72756C652D7461736B3A626566';
wwv_flow_imp.g_varchar2_table(895) := '6F7265207B20636F6E74656E743A20275C65383237273B207D202F2A2027EEA0A727202A2F0A2E62706D6E2D69636F6E2D6D616E75616C3A6265666F7265207B20636F6E74656E743A20275C65383238273B207D202F2A2027EEA0A827202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(896) := '6D6E2D69636F6E2D726563656976653A6265666F7265207B20636F6E74656E743A20275C65383239273B207D202F2A2027EEA0A927202A2F0A2E62706D6E2D69636F6E2D63616C6C2D61637469766974793A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(897) := '275C65383261273B207D202F2A2027EEA0AA27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D74696D65723A6265666F7265207B20636F6E74656E743A20275C65383262273B207D202F2A2027EEA0AB27202A2F0A2E62706D6E2D69';
wwv_flow_imp.g_varchar2_table(898) := '636F6E2D73746172742D6576656E742D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383263273B207D202F2A2027EEA0AC27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E653A';
wwv_flow_imp.g_varchar2_table(899) := '6265666F7265207B20636F6E74656E743A20275C65383264273B207D202F2A2027EEA0AD27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6C696E6B3A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(900) := '275C65383265273B207D202F2A2027EEA0AE27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383266273B207D202F2A2027EEA0AF27202A2F0A2E62706D';
wwv_flow_imp.g_varchar2_table(901) := '6E2D69636F6E2D62706D6E2D696F3A6265666F7265207B20636F6E74656E743A20275C65383331273B207D202F2A2027EEA0B127202A2F0A2E62706D6E2D69636F6E2D676174657761792D636F6D706C65783A6265666F7265207B20636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(902) := '20275C65383332273B207D202F2A2027EEA0B227202A2F0A2E62706D6E2D69636F6E2D676174657761792D6576656E7462617365643A6265666F7265207B20636F6E74656E743A20275C65383333273B207D202F2A2027EEA0B327202A2F0A2E62706D6E';
wwv_flow_imp.g_varchar2_table(903) := '2D69636F6E2D676174657761792D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C65383334273B207D202F2A2027EEA0B427202A2F0A2E62706D6E2D69636F6E2D676174657761792D6F723A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(904) := '275C65383335273B207D202F2A2027EEA0B527202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D7465726D696E6174653A6265666F7265207B20636F6E74656E743A20275C65383336273B207D202F2A2027EEA0B627202A2F0A2E62706D6E';
wwv_flow_imp.g_varchar2_table(905) := '2D69636F6E2D656E642D6576656E742D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383337273B207D202F2A2027EEA0B727202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6E6F6E653A6265666F7265207B2063';
wwv_flow_imp.g_varchar2_table(906) := '6F6E74656E743A20275C65383338273B207D202F2A2027EEA0B827202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383339273B207D202F2A2027EEA0B927202A';
wwv_flow_imp.g_varchar2_table(907) := '2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383361273B207D202F2A2027EEA0BA27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6C696E6B3A6265';
wwv_flow_imp.g_varchar2_table(908) := '666F7265207B20636F6E74656E743A20275C65383362273B207D202F2A2027EEA0BB27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D6573736167653A6265666F7265207B20636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(909) := '20275C65383363273B207D202F2A2027EEA0BC27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383364273B20';
wwv_flow_imp.g_varchar2_table(910) := '7D202F2A2027EEA0BD27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383365273B207D202F2A2027EEA0BE27202A2F0A2E62706D6E2D69636F6E2D7363';
wwv_flow_imp.g_varchar2_table(911) := '726970743A6265666F7265207B20636F6E74656E743A20275C65383366273B207D202F2A2027EEA0BF27202A2F0A2E62706D6E2D69636F6E2D6D616E75616C2D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383430273B207D202F2A';
wwv_flow_imp.g_varchar2_table(912) := '2027EEA18027202A2F0A2E62706D6E2D69636F6E2D73656E643A6265666F7265207B20636F6E74656E743A20275C65383431273B207D202F2A2027EEA18127202A2F0A2E62706D6E2D69636F6E2D736572766963653A6265666F7265207B20636F6E7465';
wwv_flow_imp.g_varchar2_table(913) := '6E743A20275C65383432273B207D202F2A2027EEA18227202A2F0A2E62706D6E2D69636F6E2D726563656976652D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383433273B207D202F2A2027EEA18327202A2F0A2E62706D6E2D6963';
wwv_flow_imp.g_varchar2_table(914) := '6F6E2D757365723A6265666F7265207B20636F6E74656E743A20275C65383434273B207D202F2A2027EEA18427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C653834';
wwv_flow_imp.g_varchar2_table(915) := '35273B207D202F2A2027EEA18527202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383436273B207D202F2A2027EEA1';
wwv_flow_imp.g_varchar2_table(916) := '8627202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383437273B207D202F2A2027EEA18727202A2F0A2E62706D6E2D6963';
wwv_flow_imp.g_varchar2_table(917) := '6F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383438273B207D202F2A2027EEA18827202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(918) := '6D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6C696E6B3A6265666F7265207B20636F6E74656E743A20275C65383439273B207D202F2A2027EEA18927202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E';
wwv_flow_imp.g_varchar2_table(919) := '742D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E3A6265666F7265207B20636F6E74656E743A20275C65383461273B207D202F2A2027EEA18A27202A2F0A2E62706D6E2D69636F6E2D646174612D6F626A6563743A6265666F726520';
wwv_flow_imp.g_varchar2_table(920) := '7B20636F6E74656E743A20275C65383462273B207D202F2A2027EEA18B27202A2F0A2E62706D6E2D69636F6E2D7363726970742D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383463273B207D202F2A2027EEA18C27202A2F0A2E62';
wwv_flow_imp.g_varchar2_table(921) := '706D6E2D69636F6E2D73656E642D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383464273B207D202F2A2027EEA18D27202A2F0A2E62706D6E2D69636F6E2D646174612D73746F72653A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(922) := '275C65383465273B207D202F2A2027EEA18E27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383466273B';
wwv_flow_imp.g_varchar2_table(923) := '207D202F2A2027EEA18F27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383530273B207D202F2A2027EEA19027202A2F0A';
wwv_flow_imp.g_varchar2_table(924) := '2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383531273B207D202F2A2027EEA1912720';
wwv_flow_imp.g_varchar2_table(925) := '2A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383532273B207D202F2A2027EEA19227';
wwv_flow_imp.g_varchar2_table(926) := '202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383533273B207D202F2A2027EEA19327202A2F0A2E62706D6E2D69636F6E';
wwv_flow_imp.g_varchar2_table(927) := '2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383534273B207D202F2A2027EEA19427202A2F0A2E62706D6E2D69636F6E2D61642D686F632D6D6172';
wwv_flow_imp.g_varchar2_table(928) := '6B65723A6265666F7265207B20636F6E74656E743A20275C65383535273B207D202F2A2027EEA19527202A2F0A2E62706D6E2D69636F6E2D736572766963652D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383536273B207D202F2A';
wwv_flow_imp.g_varchar2_table(929) := '2027EEA19627202A2F0A2E62706D6E2D69636F6E2D7461736B2D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C65383537273B207D202F2A2027EEA19727202A2F0A2E62706D6E2D69636F6E2D636F6D70656E736174696F6E2D6D61726B';
wwv_flow_imp.g_varchar2_table(930) := '65723A6265666F7265207B20636F6E74656E743A20275C65383538273B207D202F2A2027EEA19827202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D6D756C7469706C653A6265666F726520';
wwv_flow_imp.g_varchar2_table(931) := '7B20636F6E74656E743A20275C65383539273B207D202F2A2027EEA19927202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C653835';
wwv_flow_imp.g_varchar2_table(932) := '61273B207D202F2A2027EEA19A27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E3A6265666F7265207B20636F6E74656E743A2027';
wwv_flow_imp.g_varchar2_table(933) := '5C65383562273B207D202F2A2027EEA19B27202A2F0A2E62706D6E2D69636F6E2D7061727469636970616E743A6265666F7265207B20636F6E74656E743A20275C65383563273B207D202F2A2027EEA19C27202A2F0A2E62706D6E2D69636F6E2D657665';
wwv_flow_imp.g_varchar2_table(934) := '6E742D73756270726F636573732D657870616E6465643A6265666F7265207B20636F6E74656E743A20275C65383564273B207D202F2A2027EEA19D27202A2F0A2E62706D6E2D69636F6E2D6C616E652D696E736572742D62656C6F773A6265666F726520';
wwv_flow_imp.g_varchar2_table(935) := '7B20636F6E74656E743A20275C65383565273B207D202F2A2027EEA19E27202A2F0A2E62706D6E2D69636F6E2D73706163652D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383566273B207D202F2A2027EEA19F27202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(936) := '6D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C74693A6265666F7265207B20636F6E74656E743A20275C65383630273B207D202F2A2027EEA1A027202A2F0A2E62706D6E2D69636F6E2D6C616E653A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(937) := '275C65383631273B207D202F2A2027EEA1A127202A2F0A2E62706D6E2D69636F6E2D6C6173736F2D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383632273B207D202F2A2027EEA1A227202A2F0A2E62706D6E2D69636F6E2D6C616E';
wwv_flow_imp.g_varchar2_table(938) := '652D696E736572742D61626F76653A6265666F7265207B20636F6E74656E743A20275C65383633273B207D202F2A2027EEA1A327202A2F0A2E62706D6E2D69636F6E2D6C616E652D6469766964652D74687265653A6265666F7265207B20636F6E74656E';
wwv_flow_imp.g_varchar2_table(939) := '743A20275C65383634273B207D202F2A2027EEA1A427202A2F0A2E62706D6E2D69636F6E2D6C616E652D6469766964652D74776F3A6265666F7265207B20636F6E74656E743A20275C65383635273B207D202F2A2027EEA1A527202A2F0A2E62706D6E2D';
wwv_flow_imp.g_varchar2_table(940) := '69636F6E2D646174612D696E7075743A6265666F7265207B20636F6E74656E743A20275C65383636273B207D202F2A2027EEA1A627202A2F0A2E62706D6E2D69636F6E2D646174612D6F75747075743A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(941) := '65383637273B207D202F2A2027EEA1A727202A2F0A2E62706D6E2D69636F6E2D68616E642D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383638273B207D202F2A2027EEA1A827202A2F0A2E62706D6E2D69636F6E2D67726F75703A';
wwv_flow_imp.g_varchar2_table(942) := '6265666F7265207B20636F6E74656E743A20275C65383639273B207D202F2A2027EEA1A927202A2F0A2E62706D6E2D69636F6E2D746578742D616E6E6F746174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383662273B207D202F2A20';
wwv_flow_imp.g_varchar2_table(943) := '27EEA1AB27202A2F0A2E62706D6E2D69636F6E2D7472616E73616374696F6E3A6265666F7265207B20636F6E74656E743A20275C65386334273B207D202F2A2027EEA38427202A2F0A2E62706D6E2D69636F6E2D73637265772D7772656E63683A626566';
wwv_flow_imp.g_varchar2_table(944) := '6F7265207B20636F6E74656E743A20275C65386462273B207D202F2A2027EEA39B27202A2F0A2E62706D6E2D69636F6E2D636F6E6E656374696F6E3A6265666F7265207B20636F6E74656E743A20275C65386463273B207D202F2A2027EEA39C27202A2F';
wwv_flow_imp.g_varchar2_table(945) := '0A2E62706D6E2D69636F6E2D636F6E646974696F6E616C2D666C6F773A6265666F7265207B20636F6E74656E743A20275C65386530273B207D202F2A2027EEA3A027202A2F0A2E62706D6E2D69636F6E2D64656661756C742D666C6F773A6265666F7265';
wwv_flow_imp.g_varchar2_table(946) := '207B20636F6E74656E743A20275C65386531273B207D202F2A2027EEA3A127202A2F0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5458747919563021)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_file_name=>'css/bpmn-embedded.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E626A732D636F6E7461696E6572207B0D0A20202D2D626A732D666F6E742D66616D696C793A20417269616C2C2073616E732D73657269663B0D0A0D0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130252C';
wwv_flow_imp.g_varchar2_table(2) := '20313525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525293B';
wwv_flow_imp.g_varchar2_table(3) := '0D0A20202D2D636F6C6F722D677265792D3232352D31302D37353A2068736C283232352C203130252C20373525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(4) := '636F6C6F722D677265792D3232352D31302D38353A2068736C283232352C203130252C20383525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0D0A20202D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(5) := '677265792D3232352D31302D39353A2068736C283232352C203130252C20393525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0D0A0D0A20202D2D636F6C6F722D626C7565';
wwv_flow_imp.g_varchar2_table(6) := '2D3230352D3130302D34353A2068736C283230352C20313030252C20343525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D33303A2068736C61283230352C20313030252C203435252C20333025293B0D';
wwv_flow_imp.g_varchar2_table(7) := '0A20202D2D636F6C6F722D626C75652D3230352D3130302D35303A2068736C283230352C20313030252C20353025293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0D0A0D';
wwv_flow_imp.g_varchar2_table(8) := '0A20202D2D636F6C6F722D677265656E2D3135302D38362D34343A2068736C283135302C203836252C20343425293B0D0A0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0D0A20';
wwv_flow_imp.g_varchar2_table(9) := '202D2D636F6C6F722D7265642D3336302D3130302D34353A2068736C283336302C20313030252C20343525293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0D0A20202D2D63';
wwv_flow_imp.g_varchar2_table(10) := '6F6C6F722D7265642D3336302D3130302D39373A2068736C283336302C20313030252C20393725293B0D0A0D0A20202D2D636F6C6F722D77686974653A2068736C28302C2030252C2031303025293B0D0A20202D2D636F6C6F722D626C61636B3A206873';
wwv_flow_imp.g_varchar2_table(11) := '6C28302C2030252C203025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D30353A2068736C6128302C2030252C2030252C203525293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D31303A2068736C6128302C';
wwv_flow_imp.g_varchar2_table(12) := '2030252C2030252C20313025293B0D0A0D0A20202D2D62726561646372756D62732D666F6E742D66616D696C793A20766172282D2D626A732D666F6E742D66616D696C79293B0D0A20202D2D62726561646372756D62732D6974656D2D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(13) := '766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D62726561646372756D62732D6172726F772D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A20202D2D6472696C6C646F776E2D66696C6C2D';
wwv_flow_imp.g_varchar2_table(14) := '636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D6472696C6C646F776E2D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A7D0D0A0D0A2E626A73';
wwv_flow_imp.g_varchar2_table(15) := '2D62726561646372756D6273207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020646973706C61793A206E6F6E653B0D0A2020666C65782D777261703A20777261703B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D';
wwv_flow_imp.g_varchar2_table(16) := '0A2020746F703A20333070783B0D0A20206C6566743A20333070783B0D0A202070616464696E673A203070783B0D0A20206D617267696E3A203070783B0D0A2020666F6E742D66616D696C793A20766172282D2D62726561646372756D62732D666F6E74';
wwv_flow_imp.g_varchar2_table(17) := '2D66616D696C79293B0D0A2020666F6E742D73697A653A20313670783B0D0A20206C696E652D6865696768743A206E6F726D616C3B0D0A7D0D0A0D0A2E626A732D62726561646372756D62732D73686F776E202E626A732D62726561646372756D627320';
wwv_flow_imp.g_varchar2_table(18) := '7B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D70616C657474652D73686F776E202E626A732D62726561646372756D6273207B0D0A20206C6566743A20393070783B0D0A7D0D0A0D0A2E646A732D70616C657474652D7368';
wwv_flow_imp.g_varchar2_table(19) := '6F776E2E646A732D70616C657474652D74776F2D636F6C756D6E202E626A732D62726561646372756D6273207B0D0A20206C6566743A2031343070783B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C69207B0D0A2020646973706C6179';
wwv_flow_imp.g_varchar2_table(20) := '3A20696E6C696E652D666C65783B0D0A202070616464696E672D626F74746F6D3A203570783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C692061207B0D0A202063757273';
wwv_flow_imp.g_varchar2_table(21) := '6F723A20706F696E7465723B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6974656D2D636F6C6F72293B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C693A6C6173742D6F662D747970652061207B0D0A2020';
wwv_flow_imp.g_varchar2_table(22) := '636F6C6F723A20696E68657269743B0D0A2020637572736F723A2064656661756C743B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C693A6E6F74283A66697273742D6368696C64293A3A6265666F7265207B0D0A2020636F6E74656E74';
wwv_flow_imp.g_varchar2_table(23) := '3A2075726C2827646174613A696D6167652F7376672B786D6C3B757466382C3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22313722206865696768743D223137222076696577426F';
wwv_flow_imp.g_varchar2_table(24) := '783D22302030203234203234223E3C7061746820643D224D313020364C382E353920372E34312031332E31372031326C2D342E353820342E35394C31302031386C362D367A22202F3E3C7061746820643D224D30203068323476323448307A222066696C';
wwv_flow_imp.g_varchar2_table(25) := '6C3D226E6F6E6522202F3E3C2F7376673E27293B0D0A202070616464696E673A2030203870783B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6172726F772D636F6C6F72293B0D0A20206865696768743A2031656D3B0D0A7D';
wwv_flow_imp.g_varchar2_table(26) := '0D0A0D0A2E626A732D62726561646372756D6273202E626A732D6372756D62207B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A20206D61782D77696474683A2032303070783B0D0A20206F766572666C6F773A2068696464656E';
wwv_flow_imp.g_varchar2_table(27) := '3B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A2E626A732D6472696C6C646F776E207B0D0A202077696474683A20323070783B0D0A202068656967';
wwv_flow_imp.g_varchar2_table(28) := '68743A20323070783B0D0A0D0A202070616464696E673A203070783B0D0A20206D617267696E2D6C6566743A202D323070783B0D0A0D0A2020637572736F723A20706F696E7465723B0D0A2020626F726465723A206E6F6E653B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(29) := '2D7261646975733A203270783B0D0A20206F75746C696E653A206E6F6E653B0D0A0D0A202066696C6C3A20766172282D2D6472696C6C646F776E2D66696C6C2D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D64';
wwv_flow_imp.g_varchar2_table(30) := '72696C6C646F776E2D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E626A732D6472696C6C646F776E2D656D707479207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E73656C6563746564202E626A732D6472696C';
wwv_flow_imp.g_varchar2_table(31) := '6C646F776E2D656D707479207B0D0A2020646973706C61793A20696E68657269743B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D726573756C7473207B0D0A2020646973706C';
wwv_flow_imp.g_varchar2_table(32) := '61793A20666C65783B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D626F6479205B646174612D67726F75705D202B205B646174612D67726F75705D207B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(33) := '722D6C6566743A2031707820736F6C696420766172282D2D706F7075702D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D205B646174612D67726F75703D22616C69676E22';
wwv_flow_imp.g_varchar2_table(34) := '5D207B0D0A2020646973706C61793A20677269643B0D0A2020677269642D74656D706C6174652D636F6C756D6E733A2072657065617428332C20316672293B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D20';
wwv_flow_imp.g_varchar2_table(35) := '2E646A732D706F7075702D626F6479202E656E747279207B0D0A202070616464696E673A20367078203870783B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D626F6479202E65';
wwv_flow_imp.g_varchar2_table(36) := '6E7472793A6E6F74283A66697273742D6368696C6429207B0D0A20206D617267696E2D746F703A20303B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D656E7472792D69636F6E';
wwv_flow_imp.g_varchar2_table(37) := '207B0D0A2020646973706C61793A20626C6F636B3B0D0A20206D617267696E3A20303B0D0A20206865696768743A20323070783B0D0A202077696474683A20323070783B0D0A7D0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5459049022563022)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_file_name=>'css/bpmn-js.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2A0D0A202A20636F6C6F7220646566696E6974696F6E730D0A202A2F0D0A2E646A732D706172656E74207B0D0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130252C20313525293B0D0A20202D2D636F';
wwv_flow_imp.g_varchar2_table(2) := '6C6F722D677265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525293B0D0A20202D2D636F6C6F722D6772';
wwv_flow_imp.g_varchar2_table(3) := '65792D3232352D31302D37353A2068736C283232352C203130252C20373525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0D0A20202D2D636F6C6F722D677265792D323235';
wwv_flow_imp.g_varchar2_table(4) := '2D31302D38353A2068736C283232352C203130252C20383525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D3935';
wwv_flow_imp.g_varchar2_table(5) := '3A2068736C283232352C203130252C20393525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0D0A0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34353A2068';
wwv_flow_imp.g_varchar2_table(6) := '736C283230352C20313030252C20343525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D33303A2068736C61283230352C20313030252C203435252C20333025293B0D0A20202D2D636F6C6F722D626C75';
wwv_flow_imp.g_varchar2_table(7) := '652D3230352D3130302D35303A2068736C283230352C20313030252C20353025293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D35302D6F7061636974792D31353A2068736C61283230352C20313030252C203530252C20313525293B';
wwv_flow_imp.g_varchar2_table(8) := '0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D37303A2068736C283230352C20313030252C20373525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0D0A';
wwv_flow_imp.g_varchar2_table(9) := '0D0A20202D2D636F6C6F722D677265656E2D3135302D38362D34343A2068736C283135302C203836252C20343425293B0D0A0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0D0A';
wwv_flow_imp.g_varchar2_table(10) := '20202D2D636F6C6F722D7265642D3336302D3130302D34353A2068736C283336302C20313030252C20343525293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(11) := '636F6C6F722D7265642D3336302D3130302D39373A2068736C283336302C20313030252C20393725293B0D0A0D0A20202D2D636F6C6F722D77686974653A2068736C28302C2030252C2031303025293B0D0A20202D2D636F6C6F722D626C61636B3A2068';
wwv_flow_imp.g_varchar2_table(12) := '736C28302C2030252C203025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D31303A2068736C6128302C2030252C2030252C20313025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D33303A2068736C6128';
wwv_flow_imp.g_varchar2_table(13) := '302C2030252C2030252C20333025293B0D0A0D0A20202D2D63616E7661732D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A0D0A20202D2D62656E64706F696E742D66696C6C2D636F6C6F723A20766172282D2D636F';
wwv_flow_imp.g_varchar2_table(14) := '6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D62656E64706F696E742D7374726F6B652D636F6C6F723A20766172282D2D63616E7661732D66696C6C2D636F6C6F72293B0D0A0D0A20202D2D636F6E746578742D7061642D656E7472';
wwv_flow_imp.g_varchar2_table(15) := '792D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D636F6E746578742D7061642D656E7472792D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D67';
wwv_flow_imp.g_varchar2_table(16) := '7265792D3232352D31302D3935293B0D0A0D0A20202D2D656C656D656E742D647261676765722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D656C656D656E742D686F7665722D6F75746C69';
wwv_flow_imp.g_varchar2_table(17) := '6E652D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F72';
wwv_flow_imp.g_varchar2_table(18) := '2D626C75652D3230352D3130302D3530293B0D0A20202D2D656C656D656E742D73656C65637465642D6F75746C696E652D7365636F6E646172792D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3730';
wwv_flow_imp.g_varchar2_table(19) := '293B0D0A0D0A20202D2D6C6173736F2D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D35302D6F7061636974792D3135293B0D0A20202D2D6C6173736F2D7374726F6B652D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(20) := '656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F72293B0D0A0D0A20202D2D70616C657474652D656E7472792D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0D0A2020';
wwv_flow_imp.g_varchar2_table(21) := '2D2D70616C657474652D656E7472792D686F7665722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D70616C657474652D656E7472792D73656C65637465642D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(22) := '636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D70616C657474652D736570617261746F722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D70616C657474652D746F6767';
wwv_flow_imp.g_varchar2_table(23) := '6C652D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D70616C657474652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D67';
wwv_flow_imp.g_varchar2_table(24) := '7265792D3232352D31302D3937293B0D0A20202D2D70616C657474652D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A0D0A20202D2D706F7075702D666F6E742D66616D696C793A202249';
wwv_flow_imp.g_varchar2_table(25) := '424D20506C65782053616E73222C2073616E732D73657269663B0D0A20202D2D706F7075702D666F6E742D73697A653A20313470783B0D0A20202D2D706F7075702D6865616465722D656E7472792D73656C65637465642D636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(26) := '2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D706F7075702D6865616465722D666F6E742D7765696768743A20626F6C6465723B0D0A20202D2D706F7075702D6865616465722D67726F75702D646976696465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(27) := '723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D706F7075702D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D706F7075702D626F726465722D63';
wwv_flow_imp.g_varchar2_table(28) := '6F6C6F723A207472616E73706172656E743B0D0A20202D2D706F7075702D736861646F772D636F6C6F723A20766172282D2D636F6C6F722D626C61636B2D6F7061636974792D3330293B0D0A20202D2D706F7075702D6465736372697074696F6E2D636F';
wwv_flow_imp.g_varchar2_table(29) := '6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D706F7075702D6E6F2D726573756C74732D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D706F70';
wwv_flow_imp.g_varchar2_table(30) := '75702D656E7472792D7469746C652D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0D0A20202D2D706F7075702D656E7472792D686F7665722D636F6C6F723A2020766172282D2D636F6C6F722D677265792D32';
wwv_flow_imp.g_varchar2_table(31) := '32352D31302D3935293B0D0A20202D2D706F7075702D7365617263682D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D706F7075702D7365617263682D666F6375732D626F7264';
wwv_flow_imp.g_varchar2_table(32) := '65722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D706F7075702D7365617263682D666F6375732D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D32';
wwv_flow_imp.g_varchar2_table(33) := '30352D3130302D3935293B0D0A0D0A20202D2D726573697A65722D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0D0A20202D2D726573697A65722D7374726F6B652D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(34) := '2D2D63616E7661732D66696C6C2D636F6C6F72293B0D0A0D0A20202D2D7365617263682D636F6E7461696E65722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D7365';
wwv_flow_imp.g_varchar2_table(35) := '617263682D636F6E7461696E65722D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D636F6C6F723A2076';
wwv_flow_imp.g_varchar2_table(36) := '6172282D2D636F6C6F722D626C75652D3230352D3130302D3935293B0D0A20202D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D696E7365742D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D38';
wwv_flow_imp.g_varchar2_table(37) := '30293B0D0A20202D2D7365617263682D696E7075742D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D7365617263682D726573756C742D626F726465722D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(38) := '72282D2D636F6C6F722D677265792D3232352D31302D3735293B0D0A20202D2D7365617263682D726573756C742D686967686C696768742D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A20202D2D7365617263682D726573756C';
wwv_flow_imp.g_varchar2_table(39) := '742D73656C65637465642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D3330293B0D0A0D0A20202D2D73686170652D6174746163682D616C6C6F7765642D7374726F6B652D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(40) := '20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D73686170652D636F6E6E6563742D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A';
wwv_flow_imp.g_varchar2_table(41) := '20202D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0D0A20202D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C';
wwv_flow_imp.g_varchar2_table(42) := '6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3937293B0D0A20202D2D73686170652D726573697A652D707265766965772D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530';
wwv_flow_imp.g_varchar2_table(43) := '293B0D0A0D0A20202D2D736E61702D6C696E652D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D3330293B0D0A0D0A20202D2D73706163652D746F6F6C2D63726F73736861';
wwv_flow_imp.g_varchar2_table(44) := '69722D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A0D0A20202D2D746F6F6C7469702D6572726F722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D';
wwv_flow_imp.g_varchar2_table(45) := '3937293B0D0A20202D2D746F6F6C7469702D6572726F722D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0D0A20202D2D746F6F6C7469702D6572726F722D636F6C6F723A20766172282D2D63';
wwv_flow_imp.g_varchar2_table(46) := '6F6C6F722D7265642D3336302D3130302D3435293B0D0A7D0D0A0D0A2F2A2A0D0A202A206F75746C696E65207374796C65730D0A202A2F0D0A0D0A2E646A732D6F75746C696E652C0D0A2E646A732D73656C656374696F6E2D6F75746C696E65207B0D0A';
wwv_flow_imp.g_varchar2_table(47) := '202066696C6C3A206E6F6E653B0D0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0D0A20207374726F6B652D77696474683A203270783B0D0A7D0D0A0D0A2E646A732D6F75746C696E65207B0D0A2020';
wwv_flow_imp.g_varchar2_table(48) := '7669736962696C6974793A2068696464656E3B0D0A7D0D0A0D0A2E646A732D73656C656374696F6E2D6F75746C696E65207B0D0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D';
wwv_flow_imp.g_varchar2_table(49) := '636F6C6F72293B0D0A7D0D0A0D0A2E646A732D656C656D656E742E73656C6563746564202E646A732D6F75746C696E65207B0D0A20207669736962696C6974793A2076697369626C653B0D0A0D0A20207374726F6B653A20766172282D2D656C656D656E';
wwv_flow_imp.g_varchar2_table(50) := '742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D636F6E6E656374696F6E2E73656C6563746564202E646A732D6F75746C696E65207B0D0A2020646973706C61793A206E6F6E653B0D0A7D';
wwv_flow_imp.g_varchar2_table(51) := '0D0A0D0A2E646A732D6D756C74692D73656C656374202E646A732D656C656D656E742E73656C6563746564202E646A732D6F75746C696E65207B0D0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E65';
wwv_flow_imp.g_varchar2_table(52) := '2D7365636F6E646172792D7374726F6B652D636F6C6F72293B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E646A732D73686170652E636F6E6E6563742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129';
wwv_flow_imp.g_varchar2_table(53) := '207B0D0A202066696C6C3A20766172282D2D73686170652D636F6E6E6563742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D73686170652E636F6E6E6563742D6E6F742D6F6B202E646A73';
wwv_flow_imp.g_varchar2_table(54) := '2D76697375616C203E203A6E74682D6368696C642831292C0D0A2E646A732D73686170652E64726F702D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A202066696C6C3A20766172282D2D73686170652D';
wwv_flow_imp.g_varchar2_table(55) := '64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D73686170652E6E65772D706172656E74202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A';
wwv_flow_imp.g_varchar2_table(56) := '202066696C6C3A20766172282D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A7376672E64726F702D6E6F742D6F6B207B0D0A20206261636B67726F756E643A2076617228';
wwv_flow_imp.g_varchar2_table(57) := '2D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A7376672E6E65772D706172656E74207B0D0A20206261636B67726F756E643A20766172282D2D73686170652D64';
wwv_flow_imp.g_varchar2_table(58) := '726F702D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A0D0A2F2A204F76657272696465206D6F766520637572736F7220647572696E672064726F7020616E6420636F6E6E656374202A2F0D0A2E64726F';
wwv_flow_imp.g_varchar2_table(59) := '702D6E6F742D6F6B2C0D0A2E636F6E6E6563742D6E6F742D6F6B2C0D0A2E64726F702D6E6F742D6F6B202A2C0D0A2E636F6E6E6563742D6E6F742D6F6B202A207B0D0A2020637572736F723A206E6F742D616C6C6F7765642021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(60) := '0D0A7D0D0A0D0A2E64726F702D6F6B2C0D0A2E636F6E6E6563742D6F6B2C0D0A2E64726F702D6F6B202A2C0D0A2E636F6E6E6563742D6F6B202A207B0D0A2020637572736F723A2064656661756C742021696D706F7274616E743B0D0A7D0D0A0D0A2E64';
wwv_flow_imp.g_varchar2_table(61) := '6A732D656C656D656E742E6174746163682D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A20207374726F6B652D77696474683A203570782021696D706F7274616E743B0D0A20207374726F6B653A20766172282D';
wwv_flow_imp.g_varchar2_table(62) := '2D73686170652D6174746163682D616C6C6F7765642D7374726F6B652D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D6672616D652E636F6E6E6563742D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D63';
wwv_flow_imp.g_varchar2_table(63) := '68696C642831292C0D0A2E646A732D6672616D652E64726F702D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0D0A20207374726F6B652D77696474683A203370782021696D706F7274616E743B0D0A202073';
wwv_flow_imp.g_varchar2_table(64) := '74726F6B653A20766172282D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A202066696C6C3A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2F2A2A0D0A2A2053';
wwv_flow_imp.g_varchar2_table(65) := '656C656374696F6E20626F78207374796C650D0A2A0D0A2A2F0D0A2E646A732D6C6173736F2D6F7665726C6179207B0D0A202066696C6C3A20766172282D2D6C6173736F2D66696C6C2D636F6C6F72293B0D0A20207374726F6B653A20766172282D2D6C';
wwv_flow_imp.g_varchar2_table(66) := '6173736F2D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D77696474683A203270783B0D0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0D0A2020706F696E7465722D6576656E74733A';
wwv_flow_imp.g_varchar2_table(67) := '206E6F6E653B0D0A7D0D0A0D0A2F2A2A0D0A202A20526573697A65207374796C65730D0A202A2F0D0A2E646A732D726573697A652D6F7665726C6179207B0D0A202066696C6C3A206E6F6E653B0D0A0D0A20207374726F6B652D6461736861727261793A';
wwv_flow_imp.g_varchar2_table(68) := '20352031203320313B0D0A20207374726F6B653A20766172282D2D73686170652D726573697A652D707265766965772D7374726F6B652D636F6C6F72293B0D0A0D0A2020706F696E7465722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(69) := '2D726573697A65722D686974207B0D0A202066696C6C3A206E6F6E653B0D0A2020706F696E7465722D6576656E74733A20616C6C3B0D0A7D0D0A0D0A2E646A732D726573697A65722D76697375616C207B0D0A202066696C6C3A20766172282D2D726573';
wwv_flow_imp.g_varchar2_table(70) := '697A65722D66696C6C2D636F6C6F72293B0D0A20207374726F6B652D77696474683A203170783B0D0A20207374726F6B653A20766172282D2D726573697A65722D7374726F6B652D636F6C6F72293B0D0A202073686170652D72656E646572696E673A20';
wwv_flow_imp.g_varchar2_table(71) := '67656F6D6574726963507265636973696F6E3B0D0A7D0D0A0D0A2E646A732D726573697A65723A686F766572202E646A732D726573697A65722D76697375616C207B0D0A20207374726F6B653A20766172282D2D726573697A65722D7374726F6B652D63';
wwv_flow_imp.g_varchar2_table(72) := '6F6C6F72293B0D0A20207374726F6B652D6F7061636974793A20313B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6E732C0D0A2E646A732D726573697A65722D6E2C0D0A2E646A732D726573697A65722D73207B0D0A202063757273';
wwv_flow_imp.g_varchar2_table(73) := '6F723A206E732D726573697A653B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D65772C0D0A2E646A732D726573697A65722D652C0D0A2E646A732D726573697A65722D77207B0D0A2020637572736F723A2065772D726573697A653B';
wwv_flow_imp.g_varchar2_table(74) := '0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6E7773652C0D0A2E646A732D726573697A65722D6E772C0D0A2E646A732D726573697A65722D7365207B0D0A2020637572736F723A206E7773652D726573697A653B0D0A7D0D0A0D0A2E';
wwv_flow_imp.g_varchar2_table(75) := '646A732D637572736F722D726573697A652D6E6573772C0D0A2E646A732D726573697A65722D6E652C0D0A2E646A732D726573697A65722D7377207B0D0A2020637572736F723A206E6573772D726573697A653B0D0A7D0D0A0D0A2E646A732D73686170';
wwv_flow_imp.g_varchar2_table(76) := '652E646A732D726573697A696E67203E202E646A732D6F75746C696E65207B0D0A20207669736962696C6974793A2068696464656E2021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D73686170652E646A732D726573697A696E67203E202E64';
wwv_flow_imp.g_varchar2_table(77) := '6A732D726573697A6572207B0D0A20207669736962696C6974793A2068696464656E3B0D0A7D0D0A0D0A2E646A732D64726167676572203E202E646A732D726573697A6572207B0D0A20207669736962696C6974793A2068696464656E3B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(78) := '0A2F2A2A0D0A202A2064726167207374796C65730D0A202A2F0D0A2E646A732D64726167676572202A207B0D0A202066696C6C3A206E6F6E652021696D706F7274616E743B0D0A20207374726F6B653A20766172282D2D656C656D656E742D6472616767';
wwv_flow_imp.g_varchar2_table(79) := '65722D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D6472616767657220747370616E2C0D0A2E646A732D647261676765722074657874207B0D0A202066696C6C3A20766172282D2D656C656D656E742D647261676765722D';
wwv_flow_imp.g_varchar2_table(80) := '636F6C6F72292021696D706F7274616E743B0D0A20207374726F6B653A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D64726167676572206D61726B657220636972636C652C0D0A2E646A732D64726167676572206D61726B65';
wwv_flow_imp.g_varchar2_table(81) := '7220706174682C0D0A2E646A732D64726167676572206D61726B657220706F6C79676F6E2C0D0A2E646A732D64726167676572206D61726B657220706F6C796C696E652C0D0A2E646A732D64726167676572206D61726B65722072656374207B0D0A2020';
wwv_flow_imp.g_varchar2_table(82) := '66696C6C3A20766172282D2D656C656D656E742D647261676765722D636F6C6F72292021696D706F7274616E743B0D0A20207374726F6B653A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D64726167676572206D61726B6572';
wwv_flow_imp.g_varchar2_table(83) := '20746578742C0D0A2E646A732D64726167676572206D61726B657220747370616E207B0D0A202066696C6C3A206E6F6E652021696D706F7274616E743B0D0A20207374726F6B653A20766172282D2D656C656D656E742D647261676765722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(84) := '292021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D6472616767696E672C0D0A2E646A732D6472616767696E67203E202A207B0D0A20206F7061636974793A20302E332021696D706F7274616E743B0D0A2020706F696E7465722D6576656E74';
wwv_flow_imp.g_varchar2_table(85) := '733A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2F2A2A0D0A202A206E6F20706F696E746572206576656E747320666F722076697375616C0D0A202A2F0D0A2E646A732D76697375616C2C0D0A2E646A732D6F75746C696E65207B0D0A20';
wwv_flow_imp.g_varchar2_table(86) := '20706F696E7465722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2E646A732D656C656D656E742E6174746163682D6F6B202E646A732D686974207B0D0A20207374726F6B652D77696474683A20363070782021696D706F7274616E743B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(87) := '0A0D0A2F2A2A0D0A202A20616C6C20706F696E746572206576656E747320666F72206869742073686170650D0A202A2F0D0A2E646A732D656C656D656E74203E202E646A732D6869742D616C6C2C0D0A2E646A732D656C656D656E74203E202E646A732D';
wwv_flow_imp.g_varchar2_table(88) := '6869742D6E6F2D6D6F7665207B0D0A2020706F696E7465722D6576656E74733A20616C6C3B0D0A7D0D0A0D0A2E646A732D656C656D656E74203E202E646A732D6869742D7374726F6B652C0D0A2E646A732D656C656D656E74203E202E646A732D686974';
wwv_flow_imp.g_varchar2_table(89) := '2D636C69636B2D7374726F6B65207B0D0A2020706F696E7465722D6576656E74733A207374726F6B653B0D0A7D0D0A0D0A2F2A2A0D0A202A207368617065202F20636F6E6E656374696F6E206261736963207374796C65730D0A202A2F0D0A2E646A732D';
wwv_flow_imp.g_varchar2_table(90) := '636F6E6E656374696F6E202E646A732D76697375616C207B0D0A20207374726F6B652D77696474683A203270783B0D0A202066696C6C3A206E6F6E653B0D0A7D0D0A0D0A2E646A732D637572736F722D67726162207B0D0A2020637572736F723A202D77';
wwv_flow_imp.g_varchar2_table(91) := '65626B69742D677261623B0D0A2020637572736F723A202D6D6F7A2D677261623B0D0A2020637572736F723A20677261623B0D0A7D0D0A0D0A2E646A732D637572736F722D6772616262696E67207B0D0A2020637572736F723A202D7765626B69742D67';
wwv_flow_imp.g_varchar2_table(92) := '72616262696E673B0D0A2020637572736F723A202D6D6F7A2D6772616262696E673B0D0A2020637572736F723A206772616262696E673B0D0A7D0D0A0D0A2E646A732D637572736F722D63726F737368616972207B0D0A2020637572736F723A2063726F';
wwv_flow_imp.g_varchar2_table(93) := '7373686169723B0D0A7D0D0A0D0A2E646A732D637572736F722D6D6F7665207B0D0A2020637572736F723A206D6F76653B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6E73207B0D0A2020637572736F723A206E732D726573697A65';
wwv_flow_imp.g_varchar2_table(94) := '3B0D0A7D0D0A0D0A2E646A732D637572736F722D726573697A652D6577207B0D0A2020637572736F723A2065772D726573697A653B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A20736E617070696E670D0A202A2F0D0A2E646A732D736E61702D6C696E6520';
wwv_flow_imp.g_varchar2_table(95) := '7B0D0A20207374726F6B653A20766172282D2D736E61702D6C696E652D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D6C696E656361703A20726F756E643B0D0A20207374726F6B652D77696474683A203270783B0D0A2020706F696E74';
wwv_flow_imp.g_varchar2_table(96) := '65722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2F2A2A0D0A202A20736E617070696E670D0A202A2F0D0A2E646A732D63726F737368616972207B0D0A20207374726F6B653A20766172282D2D73706163652D746F6F6C2D63726F737368616972';
wwv_flow_imp.g_varchar2_table(97) := '2D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D6C696E656361703A20726F756E643B0D0A20207374726F6B652D77696474683A203170783B0D0A2020706F696E7465722D6576656E74733A206E6F6E653B0D0A202073686170652D7265';
wwv_flow_imp.g_varchar2_table(98) := '6E646572696E673A2067656F6D6574726963507265636973696F6E3B0D0A20207374726F6B652D6461736861727261793A20352C20353B0D0A7D0D0A0D0A2F2A2A0D0A202A2070616C657474650D0A202A2F0D0A0D0A2E646A732D70616C65747465207B';
wwv_flow_imp.g_varchar2_table(99) := '0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20206C6566743A20323070783B0D0A2020746F703A20323070783B0D0A0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A202077696474683A20343870783B0D0A7D';
wwv_flow_imp.g_varchar2_table(100) := '0D0A0D0A2E646A732D70616C65747465202E736570617261746F72207B0D0A20206D617267696E3A203570783B0D0A202070616464696E672D746F703A203570783B0D0A0D0A2020626F726465723A206E6F6E653B0D0A2020626F726465722D626F7474';
wwv_flow_imp.g_varchar2_table(101) := '6F6D3A20736F6C69642031707820766172282D2D70616C657474652D736570617261746F722D636F6C6F72293B0D0A0D0A2020636C6561723A20626F74683B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E7472793A6265666F7265207B0D0A';
wwv_flow_imp.g_varchar2_table(102) := '2020766572746963616C2D616C69676E3A20696E697469616C3B0D0A7D0D0A0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A2E646A732D70';
wwv_flow_imp.g_varchar2_table(103) := '616C65747465202E656E7472792C0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0D0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D636F6C6F72293B0D0A2020666F6E742D73697A';
wwv_flow_imp.g_varchar2_table(104) := '653A20333070783B0D0A0D0A2020746578742D616C69676E3A2063656E7465723B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E747279207B0D0A2020666C6F61743A206C6566743B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E';
wwv_flow_imp.g_varchar2_table(105) := '74727920696D67207B0D0A20206D61782D77696474683A20313030253B0D0A7D0D0A0D0A2E646A732D70616C65747465202E646A732D70616C657474652D656E74726965733A6166746572207B0D0A2020636F6E74656E743A2027273B0D0A2020646973';
wwv_flow_imp.g_varchar2_table(106) := '706C61793A207461626C653B0D0A2020636C6561723A20626F74683B0D0A7D0D0A0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C653A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D70616C';
wwv_flow_imp.g_varchar2_table(107) := '657474652D746F67676C652D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E7472793A686F766572207B0D0A2020636F6C6F723A20766172282D2D70616C657474652D656E747279';
wwv_flow_imp.g_varchar2_table(108) := '2D686F7665722D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D70616C65747465202E686967686C6967687465642D656E747279207B0D0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D73656C65637465642D636F6C6F7229';
wwv_flow_imp.g_varchar2_table(109) := '2021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D70616C65747465202E656E7472792C0D0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0D0A202077696474683A20343670783B0D0A20206865696768';
wwv_flow_imp.g_varchar2_table(110) := '743A20343670783B0D0A20206C696E652D6865696768743A20343670783B0D0A2020637572736F723A2064656661756C743B0D0A7D0D0A0D0A2F2A2A0D0A202A2050616C65747465206F70656E202F2074776F2D636F6C756D6E206C61796F7574206973';
wwv_flow_imp.g_varchar2_table(111) := '20636F6E74726F6C6C6564207669610D0A202A20636C6173736573206F6E207468652070616C657474652E204576656E747320746F20686F6F6B20696E746F2070616C657474650D0A202A206368616E676564206C6966652D6379636C65206172652061';
wwv_flow_imp.g_varchar2_table(112) := '7661696C61626C6520696E206164646974696F6E2E0D0A202A2F0D0A2E646A732D70616C657474652E74776F2D636F6C756D6E2E6F70656E207B0D0A202077696474683A20393470783B0D0A7D0D0A0D0A2E646A732D70616C657474653A6E6F74282E6F';
wwv_flow_imp.g_varchar2_table(113) := '70656E29202E646A732D70616C657474652D656E7472696573207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D70616C657474653A6E6F74282E6F70656E29207B0D0A20206F766572666C6F773A2068696464656E3B0D0A';
wwv_flow_imp.g_varchar2_table(114) := '7D0D0A0D0A2E646A732D70616C657474652E6F70656E202E646A732D70616C657474652D746F67676C65207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2F2A2A0D0A202A20636F6E746578742D7061640D0A202A2F0D0A2E646A732D';
wwv_flow_imp.g_varchar2_table(115) := '636F6E746578742D706164207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020646973706C61793A206E6F6E653B0D0A2020706F696E7465722D6576656E74733A206E6F6E653B0D0A20206C696E652D6865696768743A20313B0D0A';
wwv_flow_imp.g_varchar2_table(116) := '202077696474683A20373270783B0D0A20207A2D696E6465783A203130303B0D0A7D0D0A0D0A2E646A732D636F6E746578742D706164202E656E747279207B0D0A202077696474683A20323270783B0D0A20206865696768743A20323270783B0D0A2020';
wwv_flow_imp.g_varchar2_table(117) := '746578742D616C69676E3A2063656E7465723B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A2020666F6E742D73697A653A20323270783B0D0A20206D617267696E3A2030203270782032707820303B0D0A0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(118) := '722D7261646975733A203370783B0D0A0D0A2020637572736F723A2064656661756C743B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(119) := '293B0D0A2020626F782D736861646F773A20302030203270782031707820766172282D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F6C6F72293B0D0A2020706F696E7465722D6576656E74733A20616C6C3B0D0A2020';
wwv_flow_imp.g_varchar2_table(120) := '766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A0D0A2E646A732D636F6E746578742D706164202E656E7472793A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D636F6E746578742D7061642D656E747279';
wwv_flow_imp.g_varchar2_table(121) := '2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D636F6E746578742D7061642E6F70656E207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2F2A2A0D0A202A20706F707570207374796C65';
wwv_flow_imp.g_varchar2_table(122) := '730D0A202A2F0D0A2E646A732D706F707570207B0D0A20206C696E652D6865696768743A20313B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A202077696474683A206D696E2D636F6E74656E743B0D0A20206261636B67726F';
wwv_flow_imp.g_varchar2_table(123) := '756E643A20766172282D2D706F7075702D6261636B67726F756E642D636F6C6F72293B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020706F736974696F6E3A2066697865643B0D0A20207A2D696E6465783A203230303B0D0A2020626F78';
wwv_flow_imp.g_varchar2_table(124) := '2D736861646F773A20307078203270782036707820766172282D2D706F7075702D736861646F772D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D626F726465722D636F6C6F72293B0D0A20206D';
wwv_flow_imp.g_varchar2_table(125) := '696E2D77696474683A2031323070783B0D0A20206F75746C696E653A206E6F6E653B0D0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A65293B0D0A2020666F6E742D66616D696C793A20766172282D2D706F707570';
wwv_flow_imp.g_varchar2_table(126) := '2D666F6E742D66616D696C79293B0D0A7D0D0A0D0A2E646A732D706F7075702D73656172636820696E707574207B0D0A202077696474683A20313030253B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A2020666F6E742D7369';
wwv_flow_imp.g_varchar2_table(127) := '7A653A20766172282D2D706F7075702D666F6E742D73697A65293B0D0A202070616464696E673A20337078203670783B0D0A2020626F726465722D7261646975733A203270783B0D0A2020626F726465723A20736F6C69642031707820766172282D2D70';
wwv_flow_imp.g_varchar2_table(128) := '6F7075702D7365617263682D626F726465722D636F6C6F72293B0D0A20206C696E652D6865696768743A20323170783B0D0A7D0D0A0D0A2E646A732D706F7075702D73656172636820696E7075743A666F637573207B0D0A20206261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(129) := '2D636F6C6F723A20766172282D2D706F7075702D7365617263682D666F6375732D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D7365617263682D666F6375732D626F';
wwv_flow_imp.g_varchar2_table(130) := '726465722D636F6C6F72293B0D0A20206F75746C696E653A206E6F6E653B0D0A7D0D0A0D0A2E646A732D706F7075702D686561646572207B0D0A2020646973706C61793A20666C65783B0D0A2020616C69676E2D6974656D733A20737472657463683B0D';
wwv_flow_imp.g_varchar2_table(131) := '0A20206C696E652D6865696768743A20323070783B0D0A20206D617267696E3A20313070782031327078203130707820313270783B0D0A7D0D0A0D0A2E646A732D706F7075702D686561646572202E656E747279207B0D0A2020626F726465722D726164';
wwv_flow_imp.g_varchar2_table(132) := '6975733A203270783B0D0A7D0D0A0D0A2E646A732D706F70757020627574746F6E2E656E747279207B0D0A202070616464696E673A20303B0D0A20206261636B67726F756E643A207472616E73706172656E743B0D0A2020626F726465723A20303B0D0A';
wwv_flow_imp.g_varchar2_table(133) := '7D0D0A0D0A2E646A732D706F7075702D686561646572202E656E7472792E616374697665207B0D0A2020636F6C6F723A20766172282D2D706F7075702D6865616465722D656E7472792D73656C65637465642D636F6C6F72293B0D0A7D0D0A0D0A2E646A';
wwv_flow_imp.g_varchar2_table(134) := '732D706F7075702D686561646572202E656E7472792E64697361626C6564207B0D0A2020636F6C6F723A20696E68657269743B0D0A7D0D0A0D0A2E646A732D706F7075702D6865616465722D67726F7570207B0D0A2020646973706C61793A20666C6578';
wwv_flow_imp.g_varchar2_table(135) := '3B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A20206D617267696E3A20303B0D0A202070616464696E673A20303B0D';
wwv_flow_imp.g_varchar2_table(136) := '0A7D0D0A0D0A2E646A732D706F7075702D6865616465722D67726F7570202E656E747279207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E';
wwv_flow_imp.g_varchar2_table(137) := '7465723B0D0A7D0D0A0D0A2E646A732D706F7075702D6865616465722D67726F7570202B202E646A732D706F7075702D6865616465722D67726F75703A6265666F7265207B0D0A2020636F6E74656E743A2027273B0D0A202077696474683A203170783B';
wwv_flow_imp.g_varchar2_table(138) := '0D0A20206865696768743A20323070783B0D0A20206261636B67726F756E643A20766172282D2D706F7075702D6865616465722D67726F75702D646976696465722D636F6C6F72293B0D0A20206D617267696E3A2030203570783B0D0A7D0D0A0D0A2E64';
wwv_flow_imp.g_varchar2_table(139) := '6A732D706F7075702D736561726368207B0D0A20206D617267696E3A203130707820313270783B0D0A7D0D0A0D0A2E646A732D706F7075702D7469746C65207B0D0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A65';
wwv_flow_imp.g_varchar2_table(140) := '293B0D0A2020666F6E742D7765696768743A20766172282D2D706F7075702D6865616465722D666F6E742D776569676874293B0D0A2020666C65783A20313B0D0A20206D617267696E3A20303B0D0A7D0D0A0D0A2E646A732D706F7075702D7365617263';
wwv_flow_imp.g_varchar2_table(141) := '68207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A202077696474683A206175746F3B0D0A7D0D0A0D0A2E646A732D706F7075702D7365617263682D69636F6E207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020';
wwv_flow_imp.g_varchar2_table(142) := '6C6566743A203870783B0D0A2020746F703A203770783B0D0A7D0D0A0D0A2E646A732D706F7075702D73656172636820696E707574207B0D0A202070616464696E672D6C6566743A20323570783B0D0A7D0D0A0D0A2E646A732D706F7075702D72657375';
wwv_flow_imp.g_varchar2_table(143) := '6C7473207B0D0A20206D617267696E3A20377078203370782037707820313270783B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A20206D61782D6865696768743A2032383070783B0D0A20206F766572666C6F773A206175746F3B0D0A2020';
wwv_flow_imp.g_varchar2_table(144) := '70616464696E672D72696768743A203970783B0D0A7D0D0A0D0A2E646A732D706F7075702D67726F7570207B0D0A20206D617267696E3A20303B0D0A202070616464696E673A20303B0D0A202077696474683A20313030253B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(145) := '2D706F7075702D626F6479202E656E7472792C0D0A2E646A732D706F7075702D626F6479202E656E7472792D686561646572207B0D0A202070616464696E673A20357078203770783B0D0A2020637572736F723A2064656661756C743B0D0A2020626F72';
wwv_flow_imp.g_varchar2_table(146) := '6465722D7261646975733A203470783B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E7472792D686561646572207B0D0A2020666F6E742D7765696768743A20766172282D2D706F7075702D6865616465722D666F6E742D7765696768';
wwv_flow_imp.g_varchar2_table(147) := '74293B0D0A2020636F6C6F723A20766172282D2D706F7075702D656E7472792D7469746C652D636F6C6F72293B0D0A202070616464696E672D6C6566743A20303B0D0A7D0D0A0D0A2E646A732D706F707570205B636C6173732A3D2269636F6E225D202E';
wwv_flow_imp.g_varchar2_table(148) := '646A732D706F7075702D6C6162656C2C0D0A2E646A732D706F7075702D6C6162656C3A6E6F74283A66697273742D6368696C6429207B0D0A20206D617267696E2D6C6566743A202E35656D3B0D0A7D0D0A0D0A2E646A732D706F707570205B636C617373';
wwv_flow_imp.g_varchar2_table(149) := '2A3D2269636F6E225D3A6265666F72652C0D0A2E646A732D706F7075702D656E7472792D69636F6E207B0D0A202077696474683A2031656D3B0D0A20206865696768743A2031656D3B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D';
wwv_flow_imp.g_varchar2_table(150) := '0A2020666F6E742D73697A653A20312E34656D3B0D0A2020766572746963616C2D616C69676E3A206D6964646C653B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E7472792D6865616465723A6E6F74283A66697273742D6368696C64';
wwv_flow_imp.g_varchar2_table(151) := '29207B0D0A20206D617267696E2D746F703A203870783B0D0A20206D617267696E2D626F74746F6D3A203270783B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E747279207B0D0A2020646973706C61793A20666C65783B0D0A202066';
wwv_flow_imp.g_varchar2_table(152) := '6C65782D646972656374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A20737472657463683B0D0A20206865696768743A206D696E2D636F6E74656E743B0D0A7D0D0A0D0A2E646A732D706F707570202E656E7472792E73656C65637465';
wwv_flow_imp.g_varchar2_table(153) := '64207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706F7075702D656E7472792D686F7665722D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E656E7472793A6E6F74283A66697273742D636869';
wwv_flow_imp.g_varchar2_table(154) := '6C6429207B0D0A20206D617267696E2D746F703A203270783B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D636F6E74656E74207B0D0A2020646973706C61793A20666C65783B0D0A2020666C65782D646972656374696F6E3A20636F6C75';
wwv_flow_imp.g_varchar2_table(155) := '6D6E3B0D0A2020666C65783A20313B0D0A20206F766572666C6F773A2068696464656E3B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E207B0D0A2020636F6C6F723A20766172282D2D706F7075702D64657363';
wwv_flow_imp.g_varchar2_table(156) := '72697074696F6E2D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D706F7075702D6C6162656C2C0D0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E207B0D0A20206C696E652D6865696768743A20312E34656D3B0D0A7D0D0A0D';
wwv_flow_imp.g_varchar2_table(157) := '0A2E646A732D706F707570202E656E7472792C0D0A2E646A732D706F707570202E656E7472792D686561646572207B0D0A20206D617267696E3A203170783B0D0A7D0D0A0D0A2E646A732D706F7075702D7469746C652C0D0A2E646A732D706F7075702D';
wwv_flow_imp.g_varchar2_table(158) := '6C6162656C2C0D0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E2C0D0A2E646A732D706F707570202E656E7472792D686561646572207B0D0A20206F766572666C6F773A2068696464656E3B0D0A2020746578742D6F76657266';
wwv_flow_imp.g_varchar2_table(159) := '6C6F773A20656C6C69707369733B0D0A202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D6E616D65207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D706F';
wwv_flow_imp.g_varchar2_table(160) := '7075702D626F6479207B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A202077696474683A206175746F3B0D0A7D0D0A0D0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C626172207B0D0A2020776964';
wwv_flow_imp.g_varchar2_table(161) := '74683A203670783B0D0A7D0D0A0D0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0D0A2020626F726465722D7261646975733A203370783B0D0A20206261636B67726F756E642D636F6C6F723A2072';
wwv_flow_imp.g_varchar2_table(162) := '67626128302C20302C20302C20302E32293B0D0A7D0D0A0D0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0D0A2020626F782D736861646F773A206E6F6E653B0D0A20206261636B67726F756E643A';
wwv_flow_imp.g_varchar2_table(163) := '207472616E73706172656E743B0D0A20206D617267696E3A20303B0D0A202070616464696E673A203570783B0D0A7D0D0A0D0A2E646A732D706F7075702D6E6F2D726573756C7473207B0D0A202070616464696E673A2030203132707820313270782031';
wwv_flow_imp.g_varchar2_table(164) := '3270783B0D0A2020636F6C6F723A20766172282D2D706F7075702D6E6F2D726573756C74732D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D646F6373207B0D0A2020666C65783A20303B0D0A2020666C65782D64697265';
wwv_flow_imp.g_varchar2_table(165) := '6374696F6E3A20726F773B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A202070616464696E672D6C6566743A203570783B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D706F7075702D626F6479202E65';
wwv_flow_imp.g_varchar2_table(166) := '6E7472793A686F766572202E646A732D706F7075702D656E7472792D646F6373207B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D706F7075702D656E7472792D646F637320737667207B0D0A2020766572746963616C2D61';
wwv_flow_imp.g_varchar2_table(167) := '6C69676E3A206D6964646C653B0D0A20206D617267696E3A206175746F20327078206175746F203570783B0D0A7D0D0A0D0A2F2A2A0D0A202A202070616C65747465207374796C65730D0A202A2F0D0A2E646A732D70616C65747465207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(168) := '636B67726F756E643A20766172282D2D70616C657474652D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D70616C657474652D626F726465722D636F6C6F72293B0D0A2020626F7264';
wwv_flow_imp.g_varchar2_table(169) := '65722D7261646975733A203270783B0D0A7D0D0A0D0A2F2A2A0D0A202A2062656E64706F696E74730D0A202A2F0D0A2E646A732D7365676D656E742D647261676765722C0D0A2E646A732D62656E64706F696E74207B0D0A2020646973706C61793A206E';
wwv_flow_imp.g_varchar2_table(170) := '6F6E653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D64726167676572202E646A732D76697375616C207B0D0A2020646973706C61793A206E6F6E653B0D0A0D0A202066696C6C3A20766172282D2D62656E64706F696E742D66696C6C2D636F6C6F';
wwv_flow_imp.g_varchar2_table(171) := '72293B0D0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D77696474683A203170783B0D0A20207374726F6B652D6F7061636974793A20313B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(172) := '2D7365676D656E742D647261676765723A686F766572202E646A732D76697375616C207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E646A732D62656E64706F696E74202E646A732D76697375616C207B0D0A202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(173) := '766172282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0D0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D77696474683A203170783B0D0A7D0D0A0D0A2E';
wwv_flow_imp.g_varchar2_table(174) := '646A732D7365676D656E742D647261676765723A686F7665722C0D0A2E646A732D62656E64706F696E74732E686F766572202E646A732D7365676D656E742D647261676765722C0D0A2E646A732D62656E64706F696E74732E73656C6563746564202E64';
wwv_flow_imp.g_varchar2_table(175) := '6A732D7365676D656E742D647261676765722C0D0A2E646A732D62656E64706F696E743A686F7665722C0D0A2E646A732D62656E64706F696E74732E686F766572202E646A732D62656E64706F696E742C0D0A2E646A732D62656E64706F696E74732E73';
wwv_flow_imp.g_varchar2_table(176) := '656C6563746564202E646A732D62656E64706F696E74207B0D0A2020646973706C61793A20626C6F636B3B0D0A7D0D0A0D0A2E646A732D647261672D616374697665202E646A732D62656E64706F696E7473202A207B0D0A2020646973706C61793A206E';
wwv_flow_imp.g_varchar2_table(177) := '6F6E653B0D0A7D0D0A0D0A2E646A732D62656E64706F696E74733A6E6F74282E686F76657229202E666C6F6174696E67207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765723A686F7665';
wwv_flow_imp.g_varchar2_table(178) := '72202E646A732D76697375616C2C0D0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E67202E646A732D76697375616C2C0D0A2E646A732D62656E64706F696E743A686F766572202E646A732D76697375616C2C0D0A2E';
wwv_flow_imp.g_varchar2_table(179) := '646A732D62656E64706F696E742E666C6F6174696E67202E646A732D76697375616C207B0D0A202066696C6C3A20766172282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0D0A20207374726F6B653A20766172282D2D62656E64706F696E';
wwv_flow_imp.g_varchar2_table(180) := '742D7374726F6B652D636F6C6F72293B0D0A20207374726F6B652D6F7061636974793A20313B0D0A7D0D0A0D0A2E646A732D62656E64706F696E742E666C6F6174696E67202E646A732D686974207B0D0A2020706F696E7465722D6576656E74733A206E';
wwv_flow_imp.g_varchar2_table(181) := '6F6E653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D64726167676572202E646A732D6869742C0D0A2E646A732D62656E64706F696E74202E646A732D686974207B0D0A202066696C6C3A206E6F6E653B0D0A2020706F696E7465722D6576656E74';
wwv_flow_imp.g_varchar2_table(182) := '733A20616C6C3B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765722E686F72697A6F6E74616C202E646A732D686974207B0D0A2020637572736F723A206E732D726573697A653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D6472';
wwv_flow_imp.g_varchar2_table(183) := '61676765722E766572746963616C202E646A732D686974207B0D0A2020637572736F723A2065772D726573697A653B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E67202E646A732D686974207B0D0A';
wwv_flow_imp.g_varchar2_table(184) := '2020706F696E7465722D6576656E74733A206E6F6E653B0D0A7D0D0A0D0A2E646A732D7570646174696E672C0D0A2E646A732D7570646174696E67203E202A207B0D0A2020706F696E7465722D6576656E74733A206E6F6E652021696D706F7274616E74';
wwv_flow_imp.g_varchar2_table(185) := '3B0D0A7D0D0A0D0A2E646A732D7570646174696E67202E646A732D636F6E746578742D7061642C0D0A2E646A732D7570646174696E67202E646A732D6F75746C696E652C0D0A2E646A732D7570646174696E67202E646A732D62656E64706F696E742C0D';
wwv_flow_imp.g_varchar2_table(186) := '0A2E646A732D6D756C74692D73656C656374202E646A732D62656E64706F696E742C0D0A2E646A732D6D756C74692D73656C656374202E646A732D7365676D656E742D647261676765722C0D0A2E636F6E6E6563742D6F6B202E646A732D62656E64706F';
wwv_flow_imp.g_varchar2_table(187) := '696E742C0D0A2E636F6E6E6563742D6E6F742D6F6B202E646A732D62656E64706F696E742C0D0A2E64726F702D6F6B202E646A732D62656E64706F696E742C0D0A2E64726F702D6E6F742D6F6B202E646A732D62656E64706F696E74207B0D0A20206469';
wwv_flow_imp.g_varchar2_table(188) := '73706C61793A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E672C0D0A2E646A732D62656E64706F696E742E646A732D6472616767696E67207B0D0A202064';
wwv_flow_imp.g_varchar2_table(189) := '6973706C61793A20626C6F636B3B0D0A20206F7061636974793A20312E303B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A20746F6F6C746970730D0A202A2F0D0A2E646A732D746F6F6C7469702D6572726F72207B0D0A202077696474683A2031363070783B';
wwv_flow_imp.g_varchar2_table(190) := '0D0A202070616464696E673A203670783B0D0A0D0A20206261636B67726F756E643A20766172282D2D746F6F6C7469702D6572726F722D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D';
wwv_flow_imp.g_varchar2_table(191) := '2D746F6F6C7469702D6572726F722D626F726465722D636F6C6F72293B0D0A2020626F726465722D7261646975733A203270783B0D0A2020636F6C6F723A20766172282D2D746F6F6C7469702D6572726F722D636F6C6F72293B0D0A2020666F6E742D73';
wwv_flow_imp.g_varchar2_table(192) := '697A653A20313270783B0D0A20206C696E652D6865696768743A20313670783B0D0A0D0A20206F7061636974793A20302E37353B0D0A7D0D0A0D0A2E646A732D746F6F6C7469702D6572726F723A686F766572207B0D0A20206F7061636974793A20313B';
wwv_flow_imp.g_varchar2_table(193) := '0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A20736561726368207061640D0A202A2F0D0A2E646A732D7365617263682D636F6E7461696E6572207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020746F703A20323070783B0D0A20206C65';
wwv_flow_imp.g_varchar2_table(194) := '66743A20303B0D0A202072696768743A20303B0D0A20206D617267696E2D6C6566743A206175746F3B0D0A20206D617267696E2D72696768743A206175746F3B0D0A0D0A202077696474683A203235253B0D0A20206D696E2D77696474683A2033303070';
wwv_flow_imp.g_varchar2_table(195) := '783B0D0A20206D61782D77696474683A2034303070783B0D0A20207A2D696E6465783A2031303B0D0A0D0A2020666F6E742D73697A653A20312E3035656D3B0D0A20206F7061636974793A20302E393B0D0A20206261636B67726F756E643A2076617228';
wwv_flow_imp.g_varchar2_table(196) := '2D2D7365617263682D636F6E7461696E65722D6261636B67726F756E642D636F6C6F72293B0D0A2020626F726465723A20736F6C69642031707820766172282D2D7365617263682D636F6E7461696E65722D626F726465722D636F6C6F72293B0D0A2020';
wwv_flow_imp.g_varchar2_table(197) := '626F726465722D7261646975733A203270783B0D0A2020626F782D736861646F773A2030203020302032707820766172282D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D636F6C6F72292C2030203020302031707820766172';
wwv_flow_imp.g_varchar2_table(198) := '282D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D696E7365742D636F6C6F722920696E7365743B0D0A7D0D0A0D0A2E646A732D7365617263682D636F6E7461696E65723A6E6F74282E6F70656E29207B0D0A2020646973706C';
wwv_flow_imp.g_varchar2_table(199) := '61793A206E6F6E653B0D0A7D0D0A0D0A2E646A732D7365617263682D696E70757420696E707574207B0D0A2020666F6E742D73697A653A20312E3035656D3B0D0A202077696474683A20313030253B0D0A202070616464696E673A203670782031307078';
wwv_flow_imp.g_varchar2_table(200) := '3B0D0A2020626F726465723A2031707820736F6C696420766172282D2D7365617263682D696E7075742D626F726465722D636F6C6F72293B0D0A2020626F782D73697A696E673A20626F726465722D626F783B0D0A7D0D0A0D0A2E646A732D7365617263';
wwv_flow_imp.g_varchar2_table(201) := '682D696E70757420696E7075743A666F637573207B0D0A20206F75746C696E653A206E6F6E653B0D0A2020626F726465722D636F6C6F723A20766172282D2D7365617263682D696E7075742D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A2E646A';
wwv_flow_imp.g_varchar2_table(202) := '732D7365617263682D726573756C7473207B0D0A2020706F736974696F6E3A2072656C61746976653B0D0A20206F766572666C6F772D793A206175746F3B0D0A20206D61782D6865696768743A2032303070783B0D0A7D0D0A0D0A2E646A732D73656172';
wwv_flow_imp.g_varchar2_table(203) := '63682D726573756C74733A686F766572207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C74207B0D0A202077696474683A20313030253B0D0A202070616464696E673A20367078203130';
wwv_flow_imp.g_varchar2_table(204) := '70783B0D0A20206261636B67726F756E643A2077686974653B0D0A2020626F726465722D626F74746F6D3A20736F6C69642031707820766172282D2D7365617263682D726573756C742D626F726465722D636F6C6F72293B0D0A2020626F726465722D72';
wwv_flow_imp.g_varchar2_table(205) := '61646975733A203170783B0D0A7D0D0A0D0A2E646A732D7365617263682D686967686C69676874207B0D0A2020636F6C6F723A20766172282D2D7365617263682D726573756C742D686967686C696768742D636F6C6F72293B0D0A7D0D0A0D0A2E646A73';
wwv_flow_imp.g_varchar2_table(206) := '2D7365617263682D726573756C742D7072696D617279207B0D0A20206D617267696E3A2030203020313070783B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C742D7365636F6E64617279207B0D0A2020666F6E742D66616D696C793A206D';
wwv_flow_imp.g_varchar2_table(207) := '6F6E6F73706163653B0D0A20206D617267696E3A20303B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C743A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C6563746564';
wwv_flow_imp.g_varchar2_table(208) := '2D636F6C6F72293B0D0A7D0D0A0D0A2E646A732D7365617263682D726573756C742D73656C6563746564207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(209) := '0A0D0A2E646A732D7365617263682D726573756C742D73656C65637465643A686F766572207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0D0A7D0D0A0D0A2E646A';
wwv_flow_imp.g_varchar2_table(210) := '732D7365617263682D6F7665726C6179207B0D0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0D0A7D0D0A0D0A2F2A2A0D0A202A2068696464656E207374796C65730D0A';
wwv_flow_imp.g_varchar2_table(211) := '202A2F0D0A2E646A732D656C656D656E742D68696464656E2C0D0A2E646A732D656C656D656E742D68696464656E202E646A732D6869742C0D0A2E646A732D656C656D656E742D68696464656E202E646A732D6F75746C696E652C0D0A2E646A732D6C61';
wwv_flow_imp.g_varchar2_table(212) := '62656C2D68696464656E202E646A732D6C6162656C207B0D0A2020646973706C61793A206E6F6E652021696D706F7274616E743B0D0A7D0D0A0D0A2E646A732D656C656D656E74202E646A732D6869742D7374726F6B652C0D0A2E646A732D656C656D65';
wwv_flow_imp.g_varchar2_table(213) := '6E74202E646A732D6869742D636C69636B2D7374726F6B652C0D0A2E646A732D656C656D656E74202E646A732D6869742D616C6C207B0D0A2020637572736F723A206D6F76653B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5459459970563022)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_file_name=>'css/diagram-js.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E666C6F777334617065782D766965776572207B0D0A20202D2D636F6C6F722D666C6F77732D627574746F6E2D677265656E3A20233532423431353B0D0A0D0A20202F2A20636F706965642066726F6D206D6F64656C6572202A2F0D0A20202D2D636F6C';
wwv_flow_imp.g_varchar2_table(2) := '6F722D666C6F77732D6469616C6F672D6261636B67726F756E643A2077686974653B0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D627574746F6E3A20236638663866383B0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D';
wwv_flow_imp.g_varchar2_table(3) := '696E7075743A2068736C283232352C203130252C20393725293B0D0A7D0D0A2F2A2A0D0A202A2067656E6572616C0D0A202A2F0D0A2E63616E766173207B0D0A20206865696768743A20383076683B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(4) := '20236630663066303B0D0A7D0D0A2E626A732D636F6E7461696E6572207B0D0A20202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(5) := '0A2F2A2A0D0A202A206461726B206D6F64650D0A202A2F0D0A2E464C4F57532D4441524B207B0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E643A20233262333033353B0D0A20202D2D636F6C6F722D666C6F77732D6C';
wwv_flow_imp.g_varchar2_table(6) := '6967687465722D6461726B2D6261636B67726F756E643A20233332333833643B0D0A0D0A20202F2A20636F706965642066726F6D206D6F64656C6572202A2F0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D6261636B67726F756E643A20';
wwv_flow_imp.g_varchar2_table(7) := '766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D627574746F6E3A20233238326333303B0D0A20202D2D636F6C6F722D666C6F77';
wwv_flow_imp.g_varchar2_table(8) := '732D6469616C6F672D696E7075743A20233238326333303B0D0A7D0D0A2F2A2A0D0A202A20637573746F6D20636F6C6F72730D0A202A2F20200D0A2E464C4F57532D4441524B202E63616E766173207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(9) := '3A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D636F6E7461696E6572207B0D0A20202D2D64656661756C742D66696C6C2D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(10) := '2D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D62726561646372756D6273206C';
wwv_flow_imp.g_varchar2_table(11) := '693A6C6173742D6F662D74797065207370616E207B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D706F77657265642D6279207B0D0A2020636F6C6F723A2077686974652021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(12) := '0D0A7D0D0A2E464C4F57532D4441524B202E646A732D70616C65747465207B0D0A20202D2D70616C657474652D6261636B67726F756E642D636F6C6F723A20233262333033353B0D0A20202D2D70616C657474652D656E7472792D636F6C6F723A207768';
wwv_flow_imp.g_varchar2_table(13) := '6974653B0D0A7D0D0A2F2A204F7665727772697465207465787420636F6C6F72207768656E207573696E672062706D6E20657874656E73696F6E202A2F0D0A2E646A732D76697375616C3A6E6F74282E72657365742D62706D6E2D636F6C6F727329203E';
wwv_flow_imp.g_varchar2_table(14) := '202A3A6E6F74285B7374796C652A3D227374726F6B653A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B225D29202B2074657874207B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B0D0A';
wwv_flow_imp.g_varchar2_table(15) := '7D0D0A2F2A2052657365742042504D4E20436F6C6F7273202A2F0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F727320726563742C0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F727320636972636C';
wwv_flow_imp.g_varchar2_table(16) := '652C0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F727320706F6C79676F6E2C0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F72732070617468207B0D0A202066696C6C3A20766172282D2D64656661';
wwv_flow_imp.g_varchar2_table(17) := '756C742D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A20207374726F6B653A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E7265736574';
wwv_flow_imp.g_varchar2_table(18) := '2D62706D6E2D636F6C6F72732074657874207B0D0A202066696C6C3A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A2F2A2A0D0A202A20486967686C69676874696E673A20436F6D706C';
wwv_flow_imp.g_varchar2_table(19) := '657465640D0A202A2F0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420726563742C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420636972636C652C0D0A2E646A732D76697375';
wwv_flow_imp.g_varchar2_table(20) := '616C2E686967686C696768742D636F6D706C6574656420706F6C79676F6E2C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C657465642070617468207B0D0A202066696C6C3A20766172282D2D686967686C696768742D636F6D';
wwv_flow_imp.g_varchar2_table(21) := '706C657465642D66696C6C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420726563742C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420';
wwv_flow_imp.g_varchar2_table(22) := '636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420706F6C79676F6E207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D636F6D706C657465642D626F72646572292021696D70';
wwv_flow_imp.g_varchar2_table(23) := '6F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C657465642074657874207B0D0A202066696C6C3A20766172282D2D686967686C696768742D636F6D706C657465642D6C6162656C292021696D706F7274';
wwv_flow_imp.g_varchar2_table(24) := '616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C657465642070617468207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D636F6D706C657465642D6C6162656C292021696D706F727461';
wwv_flow_imp.g_varchar2_table(25) := '6E743B0D0A7D0D0A2F2A2A0D0A202A20486967686C69676874696E673A2043757272656E740D0A202A2F0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420726563742C0D0A2E646A732D76697375616C2E686967686C6967';
wwv_flow_imp.g_varchar2_table(26) := '68742D63757272656E7420636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420706F6C79676F6E2C0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E742070617468207B0D0A2020';
wwv_flow_imp.g_varchar2_table(27) := '66696C6C3A20766172282D2D686967686C696768742D63757272656E742D66696C6C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420726563742C0D0A2E646A732D76697375616C';
wwv_flow_imp.g_varchar2_table(28) := '2E686967686C696768742D63757272656E7420636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420706F6C79676F6E207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D6375727265';
wwv_flow_imp.g_varchar2_table(29) := '6E742D626F72646572292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E742074657874207B0D0A202066696C6C3A20766172282D2D686967686C696768742D63757272656E742D6C6162';
wwv_flow_imp.g_varchar2_table(30) := '656C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E742070617468207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D63757272656E742D6C6162656C292021';
wwv_flow_imp.g_varchar2_table(31) := '696D706F7274616E743B0D0A7D0D0A2F2A2A0D0A202A20486967686C69676874696E673A204572726F720D0A202A2F0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220726563742C0D0A2E646A732D76697375616C2E68696768';
wwv_flow_imp.g_varchar2_table(32) := '6C696768742D6572726F7220636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220706F6C79676F6E2C0D0A2E646A732D76697375616C2E686967686C696768742D6572726F722070617468207B0D0A202066696C';
wwv_flow_imp.g_varchar2_table(33) := '6C3A20766172282D2D686967686C696768742D6572726F722D66696C6C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220726563742C0D0A2E646A732D76697375616C2E686967686C69';
wwv_flow_imp.g_varchar2_table(34) := '6768742D6572726F7220636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220706F6C79676F6E207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D6572726F722D626F7264657229202169';
wwv_flow_imp.g_varchar2_table(35) := '6D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D6572726F722074657874207B0D0A202066696C6C3A20766172282D2D686967686C696768742D6572726F722D6C6162656C292021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(36) := '7D0D0A2E646A732D76697375616C2E686967686C696768742D6572726F722070617468207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D6572726F722D6C6162656C292021696D706F7274616E743B0D0A7D0D0A2F2A20436F6E';
wwv_flow_imp.g_varchar2_table(37) := '74657874206D656E75202A2F0D0A23636F6E746578742D6D656E75207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20200D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6469616C';
wwv_flow_imp.g_varchar2_table(38) := '6F672D6261636B67726F756E64293B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465723A2031707820736F6C696420233838383B0D0A7D0D0A0D0A23636F6E746578742D6D';
wwv_flow_imp.g_varchar2_table(39) := '656E75202E6D656E752D6F7074696F6E73207B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A202070616464696E672D6C6566743A20303B0D0A20206D617267696E3A20313070783B0D0A0D0A2020666F6E742D66616D696C793A2073616E73';
wwv_flow_imp.g_varchar2_table(40) := '2D73657269663B0D0A2020666F6E742D73697A653A20313270783B0D0A2020666F6E742D7765696768743A206E6F726D616C3B0D0A7D0D0A0D0A23636F6E746578742D6D656E75202E6D656E752D6F7074696F6E207B0D0A2020637572736F723A20706F';
wwv_flow_imp.g_varchar2_table(41) := '696E7465723B0D0A7D0D0A0D0A23636F6E746578742D6D656E75202E6D656E752D6F7074696F6E2061207B0D0A2020636F6C6F723A20696E68657269743B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A2F2A2044697361';
wwv_flow_imp.g_varchar2_table(42) := '626C652063726F73736861697220637572736F72207768656E20686F766572696E67206F76657220656C656D656E7473202A2F0D0A2E646A732D6869742C202E646A732D6869742D616C6C207B0D0A2020637572736F723A2064656661756C742021696D';
wwv_flow_imp.g_varchar2_table(43) := '706F7274616E743B0D0A7D0D0A2F2A20497465726174696F6E206469616C6F67202A2F0D0A236D6F64616C207B0D0A2020646973706C61793A206E6F6E653B0D0A2020706F736974696F6E3A2066697865643B0D0A20207A2D696E6465783A203939393B';
wwv_flow_imp.g_varchar2_table(44) := '0D0A20206C6566743A20303B0D0A2020746F703A20303B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A20206F766572666C6F773A206175746F3B0D0A20206261636B67726F756E642D636F6C6F723A20726762';
wwv_flow_imp.g_varchar2_table(45) := '6128302C302C302C302E34293B0D0A0D0A2020666F6E742D66616D696C793A2073616E732D73657269663B0D0A7D0D0A236D6F64616C2D636F6E74656E74207B0D0A202077696474683A2037353070783B0D0A20206865696768743A2035303070783B0D';
wwv_flow_imp.g_varchar2_table(46) := '0A0D0A20206D617267696E3A206175746F3B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6469616C6F672D6261636B67726F756E64293B0D0A2020626F726465723A2031707820736F6C6964';
wwv_flow_imp.g_varchar2_table(47) := '20233838383B0D0A7D0D0A23697465726174696F6E2D7469746C65207B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B0D0A20200D0A20206D617267696E3A203130';
wwv_flow_imp.g_varchar2_table(48) := '70783B0D0A7D0D0A23697465726174696F6E2D7469746C65207370616E207B0D0A2020666F6E742D73697A653A20323470783B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A7D0D0A2369746572';
wwv_flow_imp.g_varchar2_table(49) := '6174696F6E2D7469746C6520627574746F6E2E66612D74696D6573207B0D0A20206865696768743A20333070783B0D0A202077696474683A20333070783B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C';
wwv_flow_imp.g_varchar2_table(50) := '6F77732D6469616C6F672D627574746F6E293B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465723A2031707820736F6C696420236363633B0D0A2020626F726465722D7261';
wwv_flow_imp.g_varchar2_table(51) := '646975733A203270783B0D0A0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A23697465726174696F6E2D7469746C6520627574746F6E2E66612D74696D65733A686F766572207B0D0A2020636F6C6F723A20766172282D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(52) := '666C6F77732D627574746F6E2D677265656E293B0D0A7D0D0A23697465726174696F6E2D736561726368207B0D0A20206D617267696E3A20313070783B0D0A7D0D0A23697465726174696F6E2D73656172636820696E707574207B0D0A20207769647468';
wwv_flow_imp.g_varchar2_table(53) := '3A202D7765626B69742D66696C6C2D617661696C61626C653B0D0A20206D696E2D6865696768743A20323070783B0D0A202070616464696E673A20313070783B0D0A20200D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F';
wwv_flow_imp.g_varchar2_table(54) := '722D666C6F77732D6469616C6F672D696E707574293B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465723A2031707820736F6C696420233838383B0D0A7D0D0A2369746572';
wwv_flow_imp.g_varchar2_table(55) := '6174696F6E2D6C697374207B0D0A20206865696768743A2034303070783B0D0A20206F766572666C6F772D793A206175746F3B0D0A7D0D0A23697465726174696F6E2D6C697374207461626C65207B0D0A202077696474683A20313030253B0D0A20200D';
wwv_flow_imp.g_varchar2_table(56) := '0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465722D73706163696E673A20313070783B0D0A7D0D0A23697465726174696F6E2D6C697374207468207B0D0A2020746578742D61';
wwv_flow_imp.g_varchar2_table(57) := '6C69676E3A206C6566743B0D0A7D0D0A23697465726174696F6E2D6C6973742074722E636C69636B61626C65207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A2F2A2042726561646372756D62202A2F0D0A2F2A204F76657277726974';
wwv_flow_imp.g_varchar2_table(58) := '652064656661756C742073657474696E67206F66206C696E6520627265616B202A2F0D0A2E626A732D62726561646372756D6273202E626A732D6372756D62207B0D0A20206D61782D77696474683A2034303070782021696D706F7274616E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(59) := '0D0A2F2A20576869746520636F6C6F7220666F722069636F6E7320696E73696465206472696C6C646F776E20627574746F6E73202A2F0D0A2E626A732D6472696C6C646F776E2E66612D6C6973742C202E626A732D6472696C6C646F776E2E66612D6578';
wwv_flow_imp.g_varchar2_table(60) := '7465726E616C2D6C696E6B207B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2F2A204C656674206D617267696E20666F72206472696C6C646F776E20627574746F6E7320616E6420697465726174696F6E206465736372697074696F6E20696E';
wwv_flow_imp.g_varchar2_table(61) := '2062726561646372756D62202A2F0D0A2E626A732D6372756D62202B202E626A732D6472696C6C646F776E2C0D0A2E626A732D6372756D622E697465726174696F6E2D646573632C0D0A2E626A732D6372756D622E697465726174696F6E2D627574746F';
wwv_flow_imp.g_varchar2_table(62) := '6E207B0D0A20206D617267696E2D6C6566743A203870783B0D0A7D0D0A2E626A732D62726561646372756D6273206C693A6E6F74283A6C6173742D6368696C6429202E626A732D6372756D622E697465726174696F6E2D646573632C0D0A2E626A732D62';
wwv_flow_imp.g_varchar2_table(63) := '726561646372756D6273206C693A6E6F74283A6C6173742D6368696C6429202E626A732D6372756D622E697465726174696F6E2D627574746F6E207B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6974656D2D636F6C6F7229';
wwv_flow_imp.g_varchar2_table(64) := '3B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A2E626A732D6372756D622E697465726174696F6E2D627574746F6E207B0D0A2020626F726465723A2031707820736F6C696420766172282D2D62726561646372756D62732D6974656D2D';
wwv_flow_imp.g_varchar2_table(65) := '636F6C6F72293B0D0A2020626F726465722D7261646975733A203270783B0D0A202070616464696E673A203170783B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(5459877752563023)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_file_name=>'css/flows4apex.viewer.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7661722062706D6E5669657765723B2828293D3E7B2275736520737472696374223B76617220653D7B643A28742C6E293D3E7B666F7228766172206920696E206E29652E6F286E2C6929262621652E6F28742C692926264F626A6563742E646566696E65';
wwv_flow_imp.g_varchar2_table(2) := '50726F706572747928742C692C7B656E756D657261626C653A21302C6765743A6E5B695D7D297D2C6F3A28652C74293D3E4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C74297D2C743D7B7D3B282829';
wwv_flow_imp.g_varchar2_table(3) := '3D3E7B66756E6374696F6E206E28652C74297B74262628652E73757065725F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A652C656E756D6572';
wwv_flow_imp.g_varchar2_table(4) := '61626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D29297D652E6428742C7B64656661756C743A28293D3E426F7D293B636F6E737420693D4F626A6563742E70726F746F747970652E746F537472696E672C723D';
wwv_flow_imp.g_varchar2_table(5) := '4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E206F2865297B72657475726E20766F696420303D3D3D657D66756E6374696F6E20612865297B72657475726E20766F69642030213D3D657D66756E63';
wwv_flow_imp.g_varchar2_table(6) := '74696F6E20732865297B72657475726E225B6F626A6563742041727261795D223D3D3D692E63616C6C2865297D66756E6374696F6E206C2865297B72657475726E225B6F626A656374204F626A6563745D223D3D3D692E63616C6C2865297D66756E6374';
wwv_flow_imp.g_varchar2_table(7) := '696F6E20632865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D692E63616C6C2865297D66756E6374696F6E20702865297B636F6E737420743D692E63616C6C2865293B72657475726E225B6F626A6563742046756E6374696F6E';
wwv_flow_imp.g_varchar2_table(8) := '5D223D3D3D747C7C225B6F626A656374204173796E6346756E6374696F6E5D223D3D3D747C7C225B6F626A6563742047656E657261746F7246756E6374696F6E5D223D3D3D747C7C225B6F626A656374204173796E6347656E657261746F7246756E6374';
wwv_flow_imp.g_varchar2_table(9) := '696F6E5D223D3D3D747C7C225B6F626A6563742050726F78795D223D3D3D747D66756E6374696F6E20752865297B72657475726E225B6F626A65637420537472696E675D223D3D3D692E63616C6C2865297D66756E6374696F6E206828652C74297B7265';
wwv_flow_imp.g_varchar2_table(10) := '7475726E20722E63616C6C28652C74297D66756E6374696F6E206428652C74297B636F6E7374206E3D782874293B6C657420693B72657475726E206628652C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D652C21';
wwv_flow_imp.g_varchar2_table(11) := '317D29292C697D66756E6374696F6E206D28652C74297B636F6E7374206E3D782874293B6C657420693D5B5D3B72657475726E206628652C2866756E6374696F6E28652C74297B6E28652C74292626692E707573682865297D29292C697D66756E637469';
wwv_flow_imp.g_varchar2_table(12) := '6F6E206628652C74297B6C6574206E2C693B6966286F2865292972657475726E3B636F6E737420723D732865293F5F3A773B666F72286C6574206F20696E2065296966286828652C6F292626286E3D655B6F5D2C693D74286E2C72286F29292C21313D3D';
wwv_flow_imp.g_varchar2_table(13) := '3D69292972657475726E206E7D66756E6374696F6E207928652C742C6E297B72657475726E206628652C2866756E6374696F6E28652C69297B6E3D74286E2C652C69297D29292C6E7D66756E6374696F6E206728652C74297B72657475726E2121792865';
wwv_flow_imp.g_varchar2_table(14) := '2C2866756E6374696F6E28652C6E2C69297B72657475726E2065262674286E2C69297D292C2130297D66756E6374696F6E207628652C74297B72657475726E21216428652C74297D66756E6374696F6E20622865297B72657475726E2066756E6374696F';
wwv_flow_imp.g_varchar2_table(15) := '6E2874297B72657475726E206728652C2866756E6374696F6E28652C6E297B72657475726E20745B6E5D3D3D3D657D29297D7D66756E6374696F6E20782865297B72657475726E20702865293F653A743D3E743D3D3D657D66756E6374696F6E20772865';
wwv_flow_imp.g_varchar2_table(16) := '297B72657475726E20657D66756E6374696F6E205F2865297B72657475726E204E756D6265722865297D66756E6374696F6E204528652C74297B72657475726E20652E62696E642874297D66756E6374696F6E205328652C2E2E2E74297B72657475726E';
wwv_flow_imp.g_varchar2_table(17) := '204F626A6563742E61737369676E28652C2E2E2E74297D76617220413D3165333B66756E6374696F6E204328652C74297B766172206E3D746869733B743D747C7C412C652E6F6E285B2272656E6465722E7368617065222C2272656E6465722E636F6E6E';
wwv_flow_imp.g_varchar2_table(18) := '656374696F6E225D2C742C2866756E6374696F6E28652C74297B76617220693D652E747970652C723D742E656C656D656E742C6F3D742E6766782C613D742E61747472733B6966286E2E63616E52656E6465722872292972657475726E2272656E646572';
wwv_flow_imp.g_varchar2_table(19) := '2E7368617065223D3D3D693F6E2E647261775368617065286F2C722C61293A6E2E64726177436F6E6E656374696F6E286F2C722C61297D29292C652E6F6E285B2272656E6465722E676574536861706550617468222C2272656E6465722E676574436F6E';
wwv_flow_imp.g_varchar2_table(20) := '6E656374696F6E50617468225D2C742C2866756E6374696F6E28652C74297B6966286E2E63616E52656E6465722874292972657475726E2272656E6465722E676574536861706550617468223D3D3D652E747970653F6E2E676574536861706550617468';
wwv_flow_imp.g_varchar2_table(21) := '2874293A6E2E676574436F6E6E656374696F6E506174682874297D29297D66756E6374696F6E206B28652C74297B766172206E3D4D2865293B72657475726E206E26262266756E6374696F6E223D3D747970656F66206E2E24696E7374616E63654F6626';
wwv_flow_imp.g_varchar2_table(22) := '266E2E24696E7374616E63654F662874297D66756E6374696F6E205228652C74297B72657475726E207628742C2866756E6374696F6E2874297B72657475726E206B28652C74297D29297D66756E6374696F6E204D2865297B72657475726E2065262665';
wwv_flow_imp.g_varchar2_table(23) := '2E627573696E6573734F626A6563747C7C657D66756E6374696F6E20502865297B72657475726E20652626652E64697D66756E6374696F6E204428652C74297B72657475726E216B28652C2262706D6E3A43616C6C416374697669747922292626286B28';
wwv_flow_imp.g_varchar2_table(24) := '652C2262706D6E3A53756250726F6365737322293F21282128743D747C7C50286529297C7C216B28742C2262706D6E64693A42504D4E506C616E652229297C7C7426262121742E6973457870616E6465643A216B28652C2262706D6E3A50617274696369';
wwv_flow_imp.g_varchar2_table(25) := '70616E7422297C7C21214D2865292E70726F63657373526566297D66756E6374696F6E20422865297B6966286B28652C2262706D6E3A5061727469636970616E7422297C7C6B28652C2262706D6E3A4C616E652229297B76617220743D502865292E6973';
wwv_flow_imp.g_varchar2_table(26) := '486F72697A6F6E74616C3B72657475726E20766F696420303D3D3D747C7C747D7D432E70726F746F747970652E63616E52656E6465723D66756E6374696F6E2865297B7D2C432E70726F746F747970652E6472617753686170653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(27) := '652C74297B7D2C432E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C74297B7D2C432E70726F746F747970652E6765745368617065506174683D66756E6374696F6E2865297B7D2C432E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(28) := '2E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B7D3B766172204F3D7B77696474683A39302C6865696768743A32307D2C543D31353B66756E6374696F6E204E28652C74297B766172206E2C692C722C6F3D652E6C6162656C';
wwv_flow_imp.g_varchar2_table(29) := '3B72657475726E206F26266F2E626F756E64733F28723D6F2E626F756E64732C693D7B77696474683A4D6174682E6D6178284F2E77696474682C722E7769647468292C6865696768743A722E6865696768747D2C6E3D7B783A722E782B722E7769647468';
wwv_flow_imp.g_varchar2_table(30) := '2F322C793A722E792B722E6865696768742F327D293A286E3D66756E6374696F6E2865297B72657475726E20652E776179706F696E74733F66756E6374696F6E2865297B76617220743D652E6C656E6774682F322D312C6E3D655B4D6174682E666C6F6F';
wwv_flow_imp.g_varchar2_table(31) := '722874295D2C693D655B4D6174682E6365696C28742B2E3031295D2C723D66756E6374696F6E2865297B76617220743D652E6C656E6774682F322D312C6E3D655B4D6174682E666C6F6F722874295D2C693D655B4D6174682E6365696C28742B2E303129';
wwv_flow_imp.g_varchar2_table(32) := '5D3B72657475726E7B783A6E2E782B28692E782D6E2E78292F322C793A6E2E792B28692E792D6E2E79292F327D7D2865292C6F3D4D6174682E6174616E2828692E792D6E2E79292F28692E782D6E2E7829292C613D722E782C733D722E793B7265747572';
wwv_flow_imp.g_varchar2_table(33) := '6E204D6174682E616273286F293C4D6174682E50492F323F732D3D543A612B3D542C7B783A612C793A737D7D28652E776179706F696E7473293A6B28652C2262706D6E3A47726F757022293F7B783A652E782B652E77696474682F322C793A652E792B4F';
wwv_flow_imp.g_varchar2_table(34) := '2E6865696768742F327D3A7B783A652E782B652E77696474682F322C793A652E792B652E6865696768742B4F2E6865696768742F327D7D2874292C693D4F292C53287B783A6E2E782D692E77696474682F322C793A6E2E792D692E6865696768742F327D';
wwv_flow_imp.g_varchar2_table(35) := '2C69297D66756E6374696F6E20492865297B76617220743D652E627573696E6573734F626A6563742C6E3D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A466C6F77456C656D656E7422297C7C6B28652C2262706D6E3A506172';
wwv_flow_imp.g_varchar2_table(36) := '7469636970616E7422297C7C6B28652C2262706D6E3A4C616E6522297C7C6B28652C2262706D6E3A53657175656E6365466C6F7722297C7C6B28652C2262706D6E3A4D657373616765466C6F7722297C7C6B28652C2262706D6E3A44617461496E707574';
wwv_flow_imp.g_varchar2_table(37) := '22297C7C6B28652C2262706D6E3A446174614F757470757422293F226E616D65223A6B28652C2262706D6E3A54657874416E6E6F746174696F6E22293F2274657874223A6B28652C2262706D6E3A47726F757022293F2263617465676F727956616C7565';
wwv_flow_imp.g_varchar2_table(38) := '526566223A766F696420307D2874293B6966286E2972657475726E2263617465676F727956616C7565526566223D3D3D6E3F66756E6374696F6E2865297B76617220743D652E63617465676F727956616C75655265663B72657475726E20742626742E76';
wwv_flow_imp.g_varchar2_table(39) := '616C75657C7C22227D2874293A745B6E5D7C7C22227D66756E6374696F6E204C28652C74297B72657475726E20742E617070656E644368696C642866756E6374696F6E28652C74297B696628652E6F776E6572446F63756D656E74213D3D742E6F776E65';
wwv_flow_imp.g_varchar2_table(40) := '72446F63756D656E74297472797B72657475726E20742E6F776E6572446F63756D656E742E696D706F72744E6F646528652C2130297D63617463682865297B7D72657475726E20657D28652C7429297D66756E6374696F6E206A28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(41) := '726E204C28742C65292C657D76617220463D322C563D7B22616C69676E6D656E742D626173656C696E65223A312C22626173656C696E652D7368696674223A312C636C69703A312C22636C69702D70617468223A312C22636C69702D72756C65223A312C';
wwv_flow_imp.g_varchar2_table(42) := '636F6C6F723A312C22636F6C6F722D696E746572706F6C6174696F6E223A312C22636F6C6F722D696E746572706F6C6174696F6E2D66696C74657273223A312C22636F6C6F722D70726F66696C65223A312C22636F6C6F722D72656E646572696E67223A';
wwv_flow_imp.g_varchar2_table(43) := '312C637572736F723A312C646972656374696F6E3A312C646973706C61793A312C22646F6D696E616E742D626173656C696E65223A312C22656E61626C652D6261636B67726F756E64223A312C66696C6C3A312C2266696C6C2D6F706163697479223A31';
wwv_flow_imp.g_varchar2_table(44) := '2C2266696C6C2D72756C65223A312C66696C7465723A312C22666C6F6F642D636F6C6F72223A312C22666C6F6F642D6F706163697479223A312C666F6E743A312C22666F6E742D66616D696C79223A312C22666F6E742D73697A65223A462C22666F6E74';
wwv_flow_imp.g_varchar2_table(45) := '2D73697A652D61646A757374223A312C22666F6E742D73747265746368223A312C22666F6E742D7374796C65223A312C22666F6E742D76617269616E74223A312C22666F6E742D776569676874223A312C22676C7970682D6F7269656E746174696F6E2D';
wwv_flow_imp.g_varchar2_table(46) := '686F72697A6F6E74616C223A312C22676C7970682D6F7269656E746174696F6E2D766572746963616C223A312C22696D6167652D72656E646572696E67223A312C6B65726E696E673A312C226C65747465722D73706163696E67223A312C226C69676874';
wwv_flow_imp.g_varchar2_table(47) := '696E672D636F6C6F72223A312C6D61726B65723A312C226D61726B65722D656E64223A312C226D61726B65722D6D6964223A312C226D61726B65722D7374617274223A312C6D61736B3A312C6F7061636974793A312C6F766572666C6F773A312C22706F';
wwv_flow_imp.g_varchar2_table(48) := '696E7465722D6576656E7473223A312C2273686170652D72656E646572696E67223A312C2273746F702D636F6C6F72223A312C2273746F702D6F706163697479223A312C7374726F6B653A312C227374726F6B652D646173686172726179223A312C2273';
wwv_flow_imp.g_varchar2_table(49) := '74726F6B652D646173686F6666736574223A312C227374726F6B652D6C696E65636170223A312C227374726F6B652D6C696E656A6F696E223A312C227374726F6B652D6D697465726C696D6974223A312C227374726F6B652D6F706163697479223A312C';
wwv_flow_imp.g_varchar2_table(50) := '227374726F6B652D7769647468223A462C22746578742D616E63686F72223A312C22746578742D6465636F726174696F6E223A312C22746578742D72656E646572696E67223A312C22756E69636F64652D62696469223A312C7669736962696C6974793A';
wwv_flow_imp.g_varchar2_table(51) := '312C22776F72642D73706163696E67223A312C2277726974696E672D6D6F6465223A317D3B66756E6374696F6E202428652C742C6E297B76617220693D742E7265706C616365282F285B612D7A5D29285B412D5A5D292F672C2224312D243222292E746F';
wwv_flow_imp.g_varchar2_table(52) := '4C6F7765724361736528292C723D565B695D3B723F28723D3D3D462626226E756D626572223D3D747970656F66206E2626286E3D537472696E67286E292B22707822292C652E7374796C655B695D3D6E293A652E7365744174747269627574654E53286E';
wwv_flow_imp.g_varchar2_table(53) := '756C6C2C742C6E297D66756E6374696F6E207A28652C742C6E297B69662822737472696E67223D3D747970656F662074297B696628766F696420303D3D3D6E2972657475726E2066756E6374696F6E28652C74297B72657475726E20565B745D3F652E73';
wwv_flow_imp.g_varchar2_table(54) := '74796C655B745D3A652E6765744174747269627574654E53286E756C6C2C74297D28652C74293B2428652C742C6E297D656C73652166756E6374696F6E28652C74297B766172206E2C692C723D4F626A6563742E6B6579732874293B666F72286E3D303B';
wwv_flow_imp.g_varchar2_table(55) := '693D725B6E5D3B6E2B2B292428652C692C745B695D297D28652C74293B72657475726E20657D636F6E737420573D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E20472865297B72657475726E206E657720482865';
wwv_flow_imp.g_varchar2_table(56) := '297D66756E6374696F6E20482865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C';
wwv_flow_imp.g_varchar2_table(57) := '746869732E6C6973743D652E636C6173734C6973747D66756E6374696F6E204B2865297B666F722876617220743B743D652E66697273744368696C643B29652E72656D6F76654368696C642874293B72657475726E20657D482E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(58) := '6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C482E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D22';
wwv_flow_imp.g_varchar2_table(59) := '3D3D572E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C482E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(60) := '297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C482E70726F';
wwv_flow_imp.g_varchar2_table(61) := '746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C69';
wwv_flow_imp.g_varchar2_table(62) := '73742E746F67676C652865292C746869737D2C482E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C482E70726F746F747970652E6861733D482E70726F74';
wwv_flow_imp.g_varchar2_table(63) := '6F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B76617220553D7B7376673A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D2C713D';
wwv_flow_imp.g_varchar2_table(64) := '273C73766720786D6C6E733D22272B552E7376672B2722273B66756E6374696F6E20592865297B76617220743D21313B223C737667223D3D3D652E737562737472696E6728302C34293F2D313D3D3D652E696E6465784F6628552E73766729262628653D';
wwv_flow_imp.g_varchar2_table(65) := '712B652E737562737472696E67283429293A28653D712B223E222B652B223C2F7376673E222C743D2130293B766172206E3D66756E6374696F6E2865297B76617220743B72657475726E28743D6E657720444F4D506172736572292E6173796E633D2131';
wwv_flow_imp.g_varchar2_table(66) := '2C742E706172736546726F6D537472696E6728652C22746578742F786D6C22297D2865293B69662821742972657475726E206E3B666F722876617220693D646F63756D656E742E637265617465446F63756D656E74467261676D656E7428292C723D6E2E';
wwv_flow_imp.g_varchar2_table(67) := '66697273744368696C643B722E66697273744368696C643B29692E617070656E644368696C6428722E66697273744368696C64293B72657475726E20697D66756E6374696F6E205828652C74297B766172206E3B72657475726E223C223D3D3D28653D65';
wwv_flow_imp.g_varchar2_table(68) := '2E7472696D2829292E6368617241742830293F286E3D592865292E66697273744368696C642C6E3D646F63756D656E742E696D706F72744E6F6465286E2C213029293A6E3D646F63756D656E742E637265617465456C656D656E744E5328552E7376672C';
wwv_flow_imp.g_varchar2_table(69) := '65292C7426267A286E2C74292C6E7D766172205A3D6E756C6C3B66756E6374696F6E204A28297B72657475726E206E756C6C3D3D3D5A2626285A3D5828227376672229292C5A7D66756E6374696F6E205128652C74297B766172206E2C692C723D4F626A';
wwv_flow_imp.g_varchar2_table(70) := '6563742E6B6579732874293B666F72286E3D303B693D725B6E5D3B6E2B2B29655B695D3D745B695D3B72657475726E20657D66756E6374696F6E2065652865297B72657475726E20653F4A28292E6372656174655356475472616E73666F726D46726F6D';
wwv_flow_imp.g_varchar2_table(71) := '4D61747269782865293A4A28292E6372656174655356475472616E73666F726D28297D7661722074653D2F285B263C3E5D7B317D292F672C6E653D2F285B5C6E5C72225D7B317D292F672C69653D7B2226223A2226616D703B222C223C223A22266C743B';
wwv_flow_imp.g_varchar2_table(72) := '222C223E223A222667743B222C2722273A2227227D3B66756E6374696F6E20726528652C74297B72657475726E20652E7265706C61636528742C2866756E6374696F6E28652C74297B72657475726E2069655B745D7C7C747D29297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(73) := '206F6528652C74297B766172206E2C692C722C6F2C613B73776974636828652E6E6F646554797065297B6361736520333A742E7075736828726528652E74657874436F6E74656E742C746529293B627265616B3B6361736520313A696628742E70757368';
wwv_flow_imp.g_varchar2_table(74) := '28223C222C652E7461674E616D65292C652E68617341747472696275746573282929666F72286E3D302C693D28723D652E61747472696275746573292E6C656E6774683B6E3C693B2B2B6E296F3D722E6974656D286E292C742E70757368282220222C6F';
wwv_flow_imp.g_varchar2_table(75) := '2E6E616D652C273D22272C7265286F2E76616C75652C6E65292C272227293B696628652E6861734368696C644E6F6465732829297B666F7228742E7075736828223E22292C6E3D302C693D28613D652E6368696C644E6F646573292E6C656E6774683B6E';
wwv_flow_imp.g_varchar2_table(76) := '3C693B2B2B6E296F6528612E6974656D286E292C74293B742E7075736828223C2F222C652E7461674E616D652C223E22297D656C736520742E7075736828222F3E22293B627265616B3B6361736520383A742E7075736828225C783363212D2D222C7265';
wwv_flow_imp.g_varchar2_table(77) := '28652E6E6F646556616C75652C7465292C222D2D5C78336522293B627265616B3B6361736520343A742E7075736828223C215B43444154415B222C652E6E6F646556616C75652C225D5D3E22293B627265616B3B64656661756C743A7468726F77206E65';
wwv_flow_imp.g_varchar2_table(78) := '77204572726F722822756E61626C6520746F2068616E646C65206E6F646520222B652E6E6F646554797065297D72657475726E20747D66756E6374696F6E20616528652C74297B696628766F69642030213D3D74297B7472797B2166756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(79) := '652C74297B766172206E3D592874293B6966284B2865292C74297B2866756E6374696F6E2865297B72657475726E2223646F63756D656E742D667261676D656E74223D3D3D652E6E6F64654E616D657D29286E297C7C286E3D6E2E646F63756D656E7445';
wwv_flow_imp.g_varchar2_table(80) := '6C656D656E74293B666F722876617220692C723D28693D6E2E6368696C644E6F6465732C41727261792E70726F746F747970652E736C6963652E63616C6C286929292C6F3D303B6F3C722E6C656E6774683B6F2B2B294C28725B6F5D2C65297D7D28652C';
wwv_flow_imp.g_varchar2_table(81) := '74297D63617463682865297B7468726F77206E6577204572726F7228226572726F722070617273696E67205356473A20222B652E6D657373616765297D72657475726E20657D72657475726E2066756E6374696F6E2865297B666F722876617220743D65';
wwv_flow_imp.g_varchar2_table(82) := '2E66697273744368696C642C6E3D5B5D3B743B296F6528742C6E292C743D742E6E6578745369626C696E673B72657475726E206E2E6A6F696E282222297D2865297D66756E6374696F6E2073652865297B76617220743D652E706172656E744E6F64653B';
wwv_flow_imp.g_varchar2_table(83) := '72657475726E20742626742E72656D6F76654368696C642865292C657D66756E6374696F6E206C6528652C74297B72657475726E207420696E7374616E63656F66205356474D61747269783F652E6372656174655356475472616E73666F726D46726F6D';
wwv_flow_imp.g_varchar2_table(84) := '4D61747269782874293A747D66756E6374696F6E20636528652C74297B766172206E3D652E7472616E73666F726D2E6261736556616C3B72657475726E207426262841727261792E697341727261792874297C7C28743D5B745D292C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(85) := '28652C74297B766172206E2C693B666F7228652E636C65617228292C6E3D303B693D745B6E5D3B6E2B2B29652E617070656E644974656D286C6528652C6929297D286E2C7429292C6E2E636F6E736F6C696461746528297D66756E6374696F6E20706528';
wwv_flow_imp.g_varchar2_table(86) := '65297B72657475726E20652E666C617428292E6A6F696E28222C22292E7265706C616365282F2C3F285B412D7A5D292C3F2F672C22243122297D66756E6374696F6E2075652865297B72657475726E5B224C222C652E782C652E795D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(87) := '6E20686528652C74297B636F6E7374206E3D652E6C656E6774682C693D5B28723D655B305D2C5B224D222C722E782C722E795D295D3B76617220722C6F2C612C733B666F72286C657420723D313B723C6E3B722B2B297B636F6E7374206E3D655B722D31';
wwv_flow_imp.g_varchar2_table(88) := '5D2C6C3D655B725D2C633D655B722B315D3B69662821637C7C2174297B692E70757368287565286C29293B636F6E74696E75657D636F6E737420703D4D6174682E6D696E28742C6D65286C2E782D6E2E782C6C2E792D6E2E79292C6D6528632E782D6C2E';
wwv_flow_imp.g_varchar2_table(89) := '782C632E792D6C2E7929293B6966282170297B692E70757368287565286C29293B636F6E74696E75657D636F6E737420753D6465286C2C6E2C70292C683D6465286C2C6E2C2E352A70292C643D6465286C2C632C70292C6D3D6465286C2C632C2E352A70';
wwv_flow_imp.g_varchar2_table(90) := '293B692E70757368287565287529292C692E707573682828613D6D2C733D642C5B2243222C286F3D68292E782C6F2E792C612E782C612E792C732E782C732E795D29297D72657475726E20697D66756E6374696F6E20646528652C742C6E297B636F6E73';
wwv_flow_imp.g_varchar2_table(91) := '7420693D742E782D652E782C723D742E792D652E792C6F3D6E2F6D6528692C72293B72657475726E7B783A652E782B692A6F2C793A652E792B722A6F7D7D66756E6374696F6E206D6528652C74297B72657475726E204D6174682E73717274284D617468';
wwv_flow_imp.g_varchar2_table(92) := '2E706F7728652C32292B4D6174682E706F7728742C3229297D66756E6374696F6E20666528652C742C6E297B632874292626286E3D742C743D6E756C6C292C747C7C28743D7B7D293B636F6E737420693D58282270617468222C74293B72657475726E20';
wwv_flow_imp.g_varchar2_table(93) := '63286E29262628692E646174617365742E636F726E65725261646975733D537472696E67286E29292C796528692C65297D66756E6374696F6E20796528652C74297B72657475726E207A28652C7B643A706528686528742C7061727365496E7428652E64';
wwv_flow_imp.g_varchar2_table(94) := '6174617365742E636F726E65725261646975732C3130297C7C3029297D292C657D7661722067653D2268736C283232352C203130252C2031352529222C76653D227768697465223B66756E6374696F6E20626528652C74297B72657475726E207628652E';
wwv_flow_imp.g_varchar2_table(95) := '6576656E74446566696E6974696F6E732C2866756E6374696F6E2865297B72657475726E20652E24747970653D3D3D747D29297D66756E6374696F6E20786528652C742C6E297B76617220693D502865293B72657475726E206E7C7C692E676574282263';
wwv_flow_imp.g_varchar2_table(96) := '6F6C6F723A6261636B67726F756E642D636F6C6F7222297C7C692E676574282262696F633A66696C6C22297C7C747C7C76657D66756E6374696F6E20776528652C742C6E297B76617220693D502865293B72657475726E206E7C7C692E6765742822636F';
wwv_flow_imp.g_varchar2_table(97) := '6C6F723A626F726465722D636F6C6F7222297C7C692E676574282262696F633A7374726F6B6522297C7C747C7C67657D66756E6374696F6E205F6528652C742C6E2C69297B76617220723D502865292E67657428226C6162656C22293B72657475726E20';
wwv_flow_imp.g_varchar2_table(98) := '697C7C722626722E6765742822636F6C6F723A636F6C6F7222297C7C747C7C776528652C6E297D66756E6374696F6E20456528652C743D7B7D297B72657475726E7B77696474683A536528652C74292C6865696768743A416528652C74297D7D66756E63';
wwv_flow_imp.g_varchar2_table(99) := '74696F6E20536528652C743D7B7D297B72657475726E206828742C22776964746822293F742E77696474683A652E77696474687D66756E6374696F6E20416528652C743D7B7D297B72657475726E206828742C2268656967687422293F742E6865696768';
wwv_flow_imp.g_varchar2_table(100) := '743A652E6865696768747D66756E6374696F6E20436528652C74297B72657475726E20742E666F7245616368282866756E6374696F6E2874297B74262622737472696E6722213D747970656F66207426262141727261792E697341727261792874292626';
wwv_flow_imp.g_varchar2_table(101) := '4F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B6966282264656661756C7422213D3D6E262621286E20696E206529297B76617220693D4F626A6563742E6765744F776E50726F70657274794465736372697074';
wwv_flow_imp.g_varchar2_table(102) := '6F7228742C6E293B4F626A6563742E646566696E6550726F706572747928652C6E2C692E6765743F693A7B656E756D657261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20745B6E5D7D7D297D7D29297D29292C4F626A656374';
wwv_flow_imp.g_varchar2_table(103) := '2E667265657A652865297D636F6E7374206B653D4F626A6563742E70726F746F747970652E746F537472696E672C52653D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E204D6528652C74297B7265';
wwv_flow_imp.g_varchar2_table(104) := '7475726E2052652E63616C6C28652C74297D66756E6374696F6E20506528652C74297B6C6574206E2C693B696628766F696420303D3D3D652972657475726E3B636F6E737420723D286F3D652C225B6F626A6563742041727261795D223D3D3D6B652E63';
wwv_flow_imp.g_varchar2_table(105) := '616C6C286F293F42653A4465293B766172206F3B666F72286C6574206F20696E2065296966284D6528652C6F292626286E3D655B6F5D2C693D74286E2C72286F29292C21313D3D3D69292972657475726E206E7D66756E6374696F6E2044652865297B72';
wwv_flow_imp.g_varchar2_table(106) := '657475726E20657D66756E6374696F6E2042652865297B72657475726E204E756D6265722865297D66756E6374696F6E204F6528652C2E2E2E74297B636F6E7374206E3D652E7374796C653B72657475726E20506528742C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(107) := '7B652626506528652C2866756E6374696F6E28652C74297B6E5B745D3D657D29297D29292C657D66756E6374696F6E20546528652C742C6E297B72657475726E20323D3D617267756D656E74732E6C656E6774683F652E67657441747472696275746528';
wwv_flow_imp.g_varchar2_table(108) := '74293A6E756C6C3D3D3D6E3F652E72656D6F76654174747269627574652874293A28652E73657441747472696275746528742C6E292C65297D636F6E7374204E653D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(109) := '2049652865297B72657475726E206E6577204C652865297D66756E6374696F6E204C652865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E63652069';
wwv_flow_imp.g_varchar2_table(110) := '7320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D66756E6374696F6E206A652865297B666F722876617220743B743D652E66697273744368696C643B29652E72656D6F76654368696C6428';
wwv_flow_imp.g_varchar2_table(111) := '74293B72657475726E20657D66756E6374696F6E20466528652C742C6E297B76617220693D6E3F653A652E706172656E744E6F64653B72657475726E206926262266756E6374696F6E223D3D747970656F6620692E636C6F736573742626692E636C6F73';
wwv_flow_imp.g_varchar2_table(112) := '6573742874297C7C6E756C6C7D4C652E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C4C652E70726F746F747970652E72656D6F76653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(113) := '2865297B72657475726E225B6F626A656374205265674578705D223D3D4E652E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C4C652E70726F746F74';
wwv_flow_imp.g_varchar2_table(114) := '7970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E7265';
wwv_flow_imp.g_varchar2_table(115) := '6D6F766528745B6E5D293B72657475726E20746869737D2C4C652E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74';
wwv_flow_imp.g_varchar2_table(116) := '292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C4C652E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869';
wwv_flow_imp.g_varchar2_table(117) := '732E6C697374297D2C4C652E70726F746F747970652E6861733D4C652E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B7661722056652C24652C';
wwv_flow_imp.g_varchar2_table(118) := '7A652C57653D7B7D3B66756E6374696F6E20476528297B56653D77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C24653D77696E646F772E72656D6F766545';
wwv_flow_imp.g_varchar2_table(119) := '76656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A226465746163684576656E74222C7A653D226164644576656E744C697374656E657222213D3D56653F226F6E223A22227D7661722048652C4B653D57652E62696E';
wwv_flow_imp.g_varchar2_table(120) := '643D66756E6374696F6E28652C742C6E2C69297B72657475726E2056657C7C476528292C655B56655D287A652B742C6E2C697C7C2131292C6E7D2C55653D57652E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2024657C';
wwv_flow_imp.g_varchar2_table(121) := '7C476528292C655B24655D287A652B742C6E2C697C7C2131292C6E7D2C71653D4365287B5F5F70726F746F5F5F3A6E756C6C2C62696E643A4B652C756E62696E643A55652C64656661756C743A57657D2C5B57655D292C59653D5B22666F637573222C22';
wwv_flow_imp.g_varchar2_table(122) := '626C7572225D2C58653D7B62696E643A66756E6374696F6E28652C742C6E2C692C72297B72657475726E2D31213D3D59652E696E6465784F66286E29262628723D2130292C71652E62696E6428652C6E2C2866756E6374696F6E286E297B76617220723D';
wwv_flow_imp.g_varchar2_table(123) := '6E2E7461726765747C7C6E2E737263456C656D656E743B6E2E64656C65676174655461726765743D466528722C742C2130292C6E2E64656C65676174655461726765742626692E63616C6C28652C6E297D292C72297D2C756E62696E643A66756E637469';
wwv_flow_imp.g_varchar2_table(124) := '6F6E28652C742C6E2C69297B72657475726E2D31213D3D59652E696E6465784F66287429262628693D2130292C71652E756E62696E6428652C742C6E2C69297D7D2C5A653D21313B22756E646566696E656422213D747970656F6620646F63756D656E74';
wwv_flow_imp.g_varchar2_table(125) := '2626282848653D646F63756D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E707574207479';
wwv_flow_imp.g_varchar2_table(126) := '70653D22636865636B626F78222F3E272C5A653D2148652E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C48653D766F69642030293B766172204A653D7B6C6567656E643A5B312C223C6669656C647365743E';
wwv_flow_imp.g_varchar2_table(127) := '222C223C2F6669656C647365743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E';
wwv_flow_imp.g_varchar2_table(128) := '222C223C2F636F6C67726F75703E3C2F7461626C653E225D2C5F64656661756C743A5A653F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B4A652E74643D4A652E74683D5B332C223C7461626C653E3C74626F64793E';
wwv_flow_imp.g_varchar2_table(129) := '3C74723E222C223C2F74723E3C2F74626F64793E3C2F7461626C653E225D2C4A652E6F7074696F6E3D4A652E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C';
wwv_flow_imp.g_varchar2_table(130) := '4A652E74686561643D4A652E74626F64793D4A652E636F6C67726F75703D4A652E63617074696F6E3D4A652E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C4A652E706F6C796C696E653D4A652E656C6C697073653D4A65';
wwv_flow_imp.g_varchar2_table(131) := '2E706F6C79676F6E3D4A652E636972636C653D4A652E746578743D4A652E6C696E653D4A652E706174683D4A652E726563743D4A652E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220';
wwv_flow_imp.g_varchar2_table(132) := '76657273696F6E3D22312E31223E272C223C2F7376673E225D3B7661722051653D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870';
wwv_flow_imp.g_varchar2_table(133) := '656374656422293B747C7C28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B';
wwv_flow_imp.g_varchar2_table(134) := '7C5C732B242F672C2222293B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E28723D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C722E72656D6F76654368696C6428722E6C61';
wwv_flow_imp.g_varchar2_table(135) := '73744368696C64293B76617220722C6F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C284A652C69293F4A655B695D3A4A652E5F64656661756C742C613D6F5B305D2C733D6F5B315D2C6C3D6F5B325D3B66';
wwv_flow_imp.g_varchar2_table(136) := '6F722828723D742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D732B652B6C3B612D2D3B29723D722E6C6173744368696C643B696628722E66697273744368696C643D3D722E6C6173744368696C642972657475726E';
wwv_flow_imp.g_varchar2_table(137) := '20722E72656D6F76654368696C6428722E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B722E66697273744368696C643B29632E617070656E644368696C6428722E72656D6F';
wwv_flow_imp.g_varchar2_table(138) := '76654368696C6428722E66697273744368696C6429293B72657475726E20637D3B66756E6374696F6E20657428652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F722865297D66756E6374696F6E207474';
wwv_flow_imp.g_varchar2_table(139) := '2865297B652E706172656E744E6F64652626652E706172656E744E6F64652E72656D6F76654368696C642865297D66756E6374696F6E206E7428652C742C6E2C692C72297B766172206F3D656528293B6F2E7365745472616E736C61746528742C6E293B';
wwv_flow_imp.g_varchar2_table(140) := '76617220613D656528293B612E736574526F7461746528697C7C302C302C30293B76617220733D656528293B732E7365745363616C6528727C7C312C727C7C31292C636528652C5B6F2C612C735D297D66756E6374696F6E20697428652C742C6E297B76';
wwv_flow_imp.g_varchar2_table(141) := '617220693D656528293B692E7365745472616E736C61746528742C6E292C636528652C69297D7661722072742C6F742C61743D2872743D66756E6374696F6E2865297B76617220743D652E6578706F7274733D66756E6374696F6E28652C6E297B696628';
wwv_flow_imp.g_varchar2_table(142) := '6E7C7C286E3D3136292C766F696420303D3D3D65262628653D313238292C653C3D302972657475726E2230223B666F722876617220693D4D6174682E6C6F67284D6174682E706F7728322C6529292F4D6174682E6C6F67286E292C723D323B693D3D3D31';
wwv_flow_imp.g_varchar2_table(143) := '2F303B722A3D3229693D4D6174682E6C6F67284D6174682E706F7728322C652F7229292F4D6174682E6C6F67286E292A723B766172206F3D692D4D6174682E666C6F6F722869292C613D22223B666F7228723D303B723C4D6174682E666C6F6F72286929';
wwv_flow_imp.g_varchar2_table(144) := '3B722B2B29613D4D6174682E666C6F6F72284D6174682E72616E646F6D28292A6E292E746F537472696E67286E292B613B6966286F297B76617220733D4D6174682E706F77286E2C6F293B613D4D6174682E666C6F6F72284D6174682E72616E646F6D28';
wwv_flow_imp.g_varchar2_table(145) := '292A73292E746F537472696E67286E292B617D766172206C3D7061727365496E7428612C6E293B72657475726E206C213D3D312F3026266C3E3D4D6174682E706F7728322C65293F7428652C6E293A617D3B742E7261636B3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(146) := '6E2C69297B76617220723D66756E6374696F6E2872297B76617220613D303B646F7B696628612B2B3E3130297B6966282169297468726F77206E6577204572726F722822746F6F206D616E7920494420636F6C6C6973696F6E732C20757365206D6F7265';
wwv_flow_imp.g_varchar2_table(147) := '206269747322293B652B3D697D76617220733D7428652C6E297D7768696C65284F626A6563742E6861734F776E50726F70657274792E63616C6C286F2C7329293B72657475726E206F5B735D3D722C737D2C6F3D722E686174733D7B7D3B72657475726E';
wwv_flow_imp.g_varchar2_table(148) := '20722E6765743D66756E6374696F6E2865297B72657475726E20722E686174735B655D7D2C722E7365743D66756E6374696F6E28652C74297B72657475726E20722E686174735B655D3D742C727D2C722E626974733D657C7C3132382C722E626173653D';
wwv_flow_imp.g_varchar2_table(149) := '6E7C7C31362C727D7D2C7274286F743D7B6578706F7274733A7B7D7D292C6F742E6578706F727473293B66756E6374696F6E2073742865297B69662821287468697320696E7374616E63656F66207374292972657475726E206E65772073742865293B65';
wwv_flow_imp.g_varchar2_table(150) := '3D657C7C5B3132382C33362C315D2C746869732E5F736565643D652E6C656E6774683F61742E7261636B28655B305D2C655B315D2C655B325D293A657D73742E70726F746F747970652E6E6578743D66756E6374696F6E2865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(151) := '69732E5F7365656428657C7C2130297D2C73742E70726F746F747970652E6E65787450726566697865643D66756E6374696F6E28652C74297B766172206E3B646F7B6E3D652B746869732E6E657874282130297D7768696C6528746869732E6173736967';
wwv_flow_imp.g_varchar2_table(152) := '6E6564286E29293B72657475726E20746869732E636C61696D286E2C74292C6E7D2C73742E70726F746F747970652E636C61696D3D66756E6374696F6E28652C74297B746869732E5F736565642E73657428652C747C7C2130297D2C73742E70726F746F';
wwv_flow_imp.g_varchar2_table(153) := '747970652E61737369676E65643D66756E6374696F6E2865297B72657475726E20746869732E5F736565642E6765742865297C7C21317D2C73742E70726F746F747970652E756E636C61696D3D66756E6374696F6E2865297B64656C6574652074686973';
wwv_flow_imp.g_varchar2_table(154) := '2E5F736565642E686174735B655D7D2C73742E70726F746F747970652E636C6561723D66756E6374696F6E28297B76617220652C743D746869732E5F736565642E686174733B666F72286520696E207429746869732E756E636C61696D2865297D3B7661';
wwv_flow_imp.g_varchar2_table(155) := '72206C743D6E65772073742C63743D2E39353B66756E6374696F6E20707428652C742C6E2C692C722C6F2C61297B432E63616C6C28746869732C742C61293B76617220733D652626652E64656661756C7446696C6C436F6C6F722C633D652626652E6465';
wwv_flow_imp.g_varchar2_table(156) := '6661756C745374726F6B65436F6C6F722C703D652626652E64656661756C744C6162656C436F6C6F723B66756E6374696F6E20752865297B72657475726E206E2E636F6D707574655374796C6528652C7B7374726F6B654C696E656361703A22726F756E';
wwv_flow_imp.g_varchar2_table(157) := '64222C7374726F6B654C696E656A6F696E3A22726F756E64222C7374726F6B653A67652C7374726F6B6557696474683A322C66696C6C3A227768697465227D297D66756E6374696F6E20682865297B72657475726E206E2E636F6D707574655374796C65';
wwv_flow_imp.g_varchar2_table(158) := '28652C5B226E6F2D66696C6C225D2C7B7374726F6B654C696E656361703A22726F756E64222C7374726F6B654C696E656A6F696E3A22726F756E64222C7374726F6B653A67652C7374726F6B6557696474683A327D297D66756E6374696F6E206428652C';
wwv_flow_imp.g_varchar2_table(159) := '74297B7661727B7265663A6E3D7B783A302C793A307D2C7363616C653A693D312C656C656D656E743A6F2C706172656E744766783A613D722E5F7376677D3D742C733D5828226D61726B6572222C7B69643A652C76696577426F783A2230203020323020';
wwv_flow_imp.g_varchar2_table(160) := '3230222C726566583A6E2E782C726566593A6E2E792C6D61726B657257696474683A32302A692C6D61726B65724865696768743A32302A692C6F7269656E743A226175746F227D293B6A28732C6F293B766172206C3D657428223A73636F7065203E2064';
wwv_flow_imp.g_varchar2_table(161) := '656673222C61293B6C7C7C6A28612C6C3D582822646566732229292C6A286C2C73297D66756E6374696F6E206D28652C742C6E2C69297B76617220723D6C742E6E657874507265666978656428226D61726B65722D22293B72657475726E2066756E6374';
wwv_flow_imp.g_varchar2_table(162) := '696F6E28652C742C6E2C692C72297B2273657175656E6365666C6F772D656E64223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D20312035204C203131203130204C2031203135205A222C2E2E2E75287B66696C6C3A';
wwv_flow_imp.g_varchar2_table(163) := '722C7374726F6B653A722C7374726F6B6557696474683A317D297D292C7265663A7B783A31312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C226D657373616765666C6F772D7374617274223D3D3D6E26266428742C7B656C';
wwv_flow_imp.g_varchar2_table(164) := '656D656E743A582822636972636C65222C7B63783A362C63793A362C723A332E352C2E2E2E75287B66696C6C3A692C7374726F6B653A722C7374726F6B6557696474683A312C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265';
wwv_flow_imp.g_varchar2_table(165) := '663A7B783A362C793A367D2C706172656E744766783A657D292C226D657373616765666C6F772D656E64223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A226D20312035206C2030202D33206C20372033206C202D372033';
wwv_flow_imp.g_varchar2_table(166) := '207A222C2E2E2E75287B66696C6C3A692C7374726F6B653A722C7374726F6B6557696474683A312C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A382E352C793A357D2C706172656E744766783A657D292C2261';
wwv_flow_imp.g_varchar2_table(167) := '73736F63696174696F6E2D7374617274223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D2031312035204C2031203130204C203131203135222C2E2E2E68287B66696C6C3A226E6F6E65222C7374726F6B653A722C73';
wwv_flow_imp.g_varchar2_table(168) := '74726F6B6557696474683A312E352C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C226173736F63696174696F6E2D656E64223D3D';
wwv_flow_imp.g_varchar2_table(169) := '3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D20312035204C203131203130204C2031203135222C2E2E2E68287B66696C6C3A226E6F6E65222C7374726F6B653A722C7374726F6B6557696474683A312E352C7374726F6B';
wwv_flow_imp.g_varchar2_table(170) := '654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A31312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C22636F6E646974696F6E616C2D666C6F772D6D61726B6572223D3D3D6E26266428742C7B656C';
wwv_flow_imp.g_varchar2_table(171) := '656D656E743A58282270617468222C7B643A224D2030203130204C20382036204C203136203130204C2038203134205A222C2E2E2E75287B66696C6C3A692C7374726F6B653A727D297D292C7265663A7B783A2D312C793A31307D2C7363616C653A2E35';
wwv_flow_imp.g_varchar2_table(172) := '2C706172656E744766783A657D292C22636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D20362034204C203130203136222C2E2E2E7528';
wwv_flow_imp.g_varchar2_table(173) := '7B7374726F6B653A722C66696C6C3A226E6F6E65227D297D292C7265663A7B783A302C793A31307D2C7363616C653A2E352C706172656E744766783A657D297D28652C722C742C6E2C69292C2275726C2823222B722B2229227D66756E6374696F6E2079';
wwv_flow_imp.g_varchar2_table(174) := '28652C742C6E2C692C723D7B7D297B6C286929262628723D692C693D30292C693D697C7C302C723D752872293B766172206F3D582822636972636C65222C7B63783A742F322C63793A6E2F322C723A4D6174682E726F756E642828742B6E292F342D6929';
wwv_flow_imp.g_varchar2_table(175) := '2C2E2E2E727D293B72657475726E206A28652C6F292C6F7D66756E6374696F6E206728652C742C6E2C692C722C6F297B6C2872292626286F3D722C723D30292C723D727C7C302C6F3D75286F293B76617220613D58282272656374222C7B783A722C793A';
wwv_flow_imp.g_varchar2_table(176) := '722C77696474683A742D322A722C6865696768743A6E2D322A722C72783A692C72793A692C2E2E2E6F7D293B72657475726E206A28652C61292C617D66756E6374696F6E207628652C742C6E2C69297B76617220723D666528742C6E3D68286E292C6929';
wwv_flow_imp.g_varchar2_table(177) := '3B72657475726E206A28652C72292C727D66756E6374696F6E206228652C742C6E297B72657475726E207628652C742C6E2C35297D66756E6374696F6E207828652C742C6E297B6E3D68286E293B76617220693D58282270617468222C7B2E2E2E6E2C64';
wwv_flow_imp.g_varchar2_table(178) := '3A747D293B72657475726E206A28652C69292C697D66756E6374696F6E207728652C742C6E2C69297B72657475726E207828742C6E2C53287B22646174612D6D61726B6572223A657D2C6929297D66756E6374696F6E205F2865297B72657475726E205A';
wwv_flow_imp.g_varchar2_table(179) := '5B655D7D66756E6374696F6E20452865297B72657475726E2066756E6374696F6E28742C6E2C69297B72657475726E205F28652928742C6E2C69297D7D66756E6374696F6E204128652C742C6E3D7B7D297B76617220722C6F3D4D2865292C613D226270';
wwv_flow_imp.g_varchar2_table(180) := '6D6E3A496E7465726D6564696174655468726F774576656E74223D3D3D28723D6F292E24747970657C7C2262706D6E3A456E644576656E74223D3D3D722E24747970653B72657475726E206F2E67657428226576656E74446566696E6974696F6E732229';
wwv_flow_imp.g_varchar2_table(181) := '26266F2E67657428226576656E74446566696E6974696F6E7322292E6C656E6774683E313F6F2E6765742822706172616C6C656C4D756C7469706C6522293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207828652C692E6765745363';
wwv_flow_imp.g_varchar2_table(182) := '616C65645061746828224556454E545F504152414C4C454C5F4D554C5449504C45222C7B785363616C65466163746F723A312E322C795363616C65466163746F723A312E322C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E';
wwv_flow_imp.g_varchar2_table(183) := '65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3435382C6D793A2E3139347D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B655769';
wwv_flow_imp.g_varchar2_table(184) := '6474683A317D297D28742C652C6E293A66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4D554C5449504C45222C7B785363616C65466163746F723A312E312C79';
wwv_flow_imp.g_varchar2_table(185) := '5363616C65466163746F723A312E312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3232322C6D793A2E33367D7D292C7B66696C6C3A723F';
wwv_flow_imp.g_varchar2_table(186) := '776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22293F66756E637469';
wwv_flow_imp.g_varchar2_table(187) := '6F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4D455353414745222C7B785363616C65466163746F723A2E392C795363616C65466163746F723A2E392C636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(188) := '57696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3233352C6D793A2E3331357D7D292C7B66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C';
wwv_flow_imp.g_varchar2_table(189) := '6E2E66696C6C292C7374726F6B653A723F786528742C732C6E2E66696C6C293A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A54696D65724576656E7444656669';
wwv_flow_imp.g_varchar2_table(190) := '6E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B76617220723D7928652C742E77696474682C742E6865696768742C2E322A742E6865696768742C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C';
wwv_flow_imp.g_varchar2_table(191) := '632C6E2E7374726F6B65292C7374726F6B6557696474683A327D293B7828652C692E6765745363616C65645061746828224556454E545F54494D45525F5748222C7B785363616C65466163746F723A2E37352C795363616C65466163746F723A2E37352C';
wwv_flow_imp.g_varchar2_table(192) := '636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E357D7D292C7B7374726F6B653A776528742C632C6E2E7374726F6B65292C7374';
wwv_flow_imp.g_varchar2_table(193) := '726F6B6557696474683A327D293B666F7228766172206F3D303B6F3C31323B6F2B2B297B76617220613D692E6765745363616C65645061746828224556454E545F54494D45525F4C494E45222C7B785363616C65466163746F723A2E37352C795363616C';
wwv_flow_imp.g_varchar2_table(194) := '65466163746F723A2E37352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E357D7D292C6C3D742E77696474682F322C703D74';
wwv_flow_imp.g_varchar2_table(195) := '2E6865696768742F323B7828652C612C7B7374726F6B6557696474683A312C7374726F6B653A776528742C632C6E2E7374726F6B65292C7472616E73666F726D3A22726F7461746528222B33302A6F2B222C222B702B222C222B6C2B2229227D297D7265';
wwv_flow_imp.g_varchar2_table(196) := '7475726E20727D28742C652C6E293A6265286F2C2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207828652C692E6765745363616C656450617468';
wwv_flow_imp.g_varchar2_table(197) := '28224556454E545F434F4E444954494F4E414C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C';
wwv_flow_imp.g_varchar2_table(198) := '706F736974696F6E3A7B6D783A2E352C6D793A2E3232327D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E293A6265286F';
wwv_flow_imp.g_varchar2_table(199) := '2C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F5349474E414C222C7B785363616C';
wwv_flow_imp.g_varchar2_table(200) := '65466163746F723A2E392C795363616C65466163746F723A2E392C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E327D7D292C';
wwv_flow_imp.g_varchar2_table(201) := '7B7374726F6B6557696474683A312C66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D28742C652C6E2C61293A6265286F2C2262706D6E';
wwv_flow_imp.g_varchar2_table(202) := '3A457363616C6174696F6E4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F455343414C4154494F4E222C7B785363';
wwv_flow_imp.g_varchar2_table(203) := '616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E327D7D292C';
wwv_flow_imp.g_varchar2_table(204) := '7B66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E';
wwv_flow_imp.g_varchar2_table(205) := '3A4C696E6B4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4C494E4B222C7B785363616C65466163746F723A312C';
wwv_flow_imp.g_varchar2_table(206) := '795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E35372C6D793A2E3236337D7D292C7B66696C6C3A723F77';
wwv_flow_imp.g_varchar2_table(207) := '6528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A4572726F72457665';
wwv_flow_imp.g_varchar2_table(208) := '6E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4552524F52222C7B785363616C65466163746F723A312E312C795363616C';
wwv_flow_imp.g_varchar2_table(209) := '65466163746F723A312E312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E322C6D793A2E3732327D7D292C7B66696C6C3A723F776528742C';
wwv_flow_imp.g_varchar2_table(210) := '632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A43616E63656C4576656E7444';
wwv_flow_imp.g_varchar2_table(211) := '6566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B766172206F2C612C733D7828652C692E6765745363616C65645061746828224556454E545F43414E43454C5F3435222C7B785363616C65466163746F723A312C795363';
wwv_flow_imp.g_varchar2_table(212) := '616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3633382C6D793A2D2E3035357D7D292C7B66696C6C3A723F7765';
wwv_flow_imp.g_varchar2_table(213) := '28742C632C6E2E7374726F6B65293A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D293B72657475726E206F3D732C28613D65652829292E736574526F746174652834352C302C30292C';
wwv_flow_imp.g_varchar2_table(214) := '6365286F2C61292C737D28742C652C6E2C61293A6265286F2C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C';
wwv_flow_imp.g_varchar2_table(215) := '65645061746828224556454E545F434F4D50454E534154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E';
wwv_flow_imp.g_varchar2_table(216) := '6865696768742C706F736974696F6E3A7B6D783A2E32322C6D793A2E357D7D292C7B66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(217) := '6F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A5465726D696E6174654576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207928652C742E77696474682C74';
wwv_flow_imp.g_varchar2_table(218) := '2E6865696768742C382C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A347D297D28742C652C6E293A6E756C6C7D76617220523D7B50617274696369';
wwv_flow_imp.g_varchar2_table(219) := '70616E744D756C7469706C69636974794D61726B65723A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D536528742C6E292C6F3D416528742C6E293B7728227061727469636970616E742D6D756C7469706C6963697479222C652C692E67';
wwv_flow_imp.g_varchar2_table(220) := '65745363616C65645061746828224D41524B45525F504152414C4C454C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F73';
wwv_flow_imp.g_varchar2_table(221) := '6974696F6E3A7B6D783A28722F322D36292F722C6D793A286F2D3135292F6F7D7D292C7B7374726F6B6557696474683A322C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C537562';
wwv_flow_imp.g_varchar2_table(222) := '50726F636573734D61726B65723A66756E6374696F6E28652C742C6E3D7B7D297B6974286728652C31342C31342C302C7B7374726F6B6557696474683A312C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E73';
wwv_flow_imp.g_varchar2_table(223) := '74726F6B65297D292C742E77696474682F322D372E352C742E6865696768742D3230292C7728227375622D70726F63657373222C652C692E6765745363616C65645061746828224D41524B45525F5355425F50524F43455353222C7B785363616C654661';
wwv_flow_imp.g_varchar2_table(224) := '63746F723A312E352C795363616C65466163746F723A312E352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322D372E';
wwv_flow_imp.g_varchar2_table(225) := '35292F742E77696474682C6D793A28742E6865696768742D3230292F742E6865696768747D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C506172616C6C656C4D61726B';
wwv_flow_imp.g_varchar2_table(226) := '65723A66756E6374696F6E28652C742C6E297B76617220723D536528742C6E292C6F3D416528742C6E293B772822706172616C6C656C222C652C692E6765745363616C65645061746828224D41524B45525F504152414C4C454C222C7B785363616C6546';
wwv_flow_imp.g_varchar2_table(227) := '6163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F736974696F6E3A7B6D783A28722F322B6E2E706172616C6C656C292F722C6D793A286F2D3230292F';
wwv_flow_imp.g_varchar2_table(228) := '6F7D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C53657175656E7469616C4D61726B65723A66756E6374696F6E28652C742C6E297B77282273657175656E7469616C22';
wwv_flow_imp.g_varchar2_table(229) := '2C652C692E6765745363616C65645061746828224D41524B45525F53455155454E5449414C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E';
wwv_flow_imp.g_varchar2_table(230) := '65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322B6E2E736571292F742E77696474682C6D793A28742E6865696768742D3139292F742E6865696768747D7D292C7B66696C6C3A786528742C732C6E';
wwv_flow_imp.g_varchar2_table(231) := '2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C436F6D70656E736174696F6E4D61726B65723A66756E6374696F6E28652C742C6E297B772822636F6D70656E736174696F6E222C652C692E6765745363616C656450';
wwv_flow_imp.g_varchar2_table(232) := '61746828224D41524B45525F434F4D50454E534154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865';
wwv_flow_imp.g_varchar2_table(233) := '696768742C706F736974696F6E3A7B6D783A28742E77696474682F322B6E2E636F6D70656E736174696F6E292F742E77696474682C6D793A28742E6865696768742D3133292F742E6865696768747D7D292C7B7374726F6B6557696474683A312C66696C';
wwv_flow_imp.g_varchar2_table(234) := '6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C4C6F6F704D61726B65723A66756E6374696F6E28652C742C6E297B76617220723D536528742C6E292C6F3D416528742C6E293B7728226C6F';
wwv_flow_imp.g_varchar2_table(235) := '6F70222C652C692E6765745363616C65645061746828224D41524B45525F4C4F4F50222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A';
wwv_flow_imp.g_varchar2_table(236) := '6F2C706F736974696F6E3A7B6D783A28722F322B6E2E6C6F6F70292F722C6D793A286F2D37292F6F7D7D292C7B7374726F6B6557696474683A312E352C66696C6C3A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(237) := '6F6B654D697465726C696D69743A2E357D297D2C4164686F634D61726B65723A66756E6374696F6E28652C742C6E297B76617220723D536528742C6E292C6F3D416528742C6E293B7728226164686F63222C652C692E6765745363616C65645061746828';
wwv_flow_imp.g_varchar2_table(238) := '224D41524B45525F4144484F43222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F736974696F6E3A7B6D783A28722F322B6E';
wwv_flow_imp.g_varchar2_table(239) := '2E6164686F63292F722C6D793A286F2D3135292F6F7D7D292C7B7374726F6B6557696474683A312C66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D7D3B66756E6374696F6E204F';
wwv_flow_imp.g_varchar2_table(240) := '28652C742C6E2C69297B525B655D28742C6E2C69297D66756E6374696F6E205428652C742C6E2C693D7B7D297B693D7B66696C6C3A692E66696C6C2C7374726F6B653A692E7374726F6B652C77696474683A536528742C69292C6865696768743A416528';
wwv_flow_imp.g_varchar2_table(241) := '742C69297D3B76617220723D4D2874292C6F3D6E26266E2E696E636C75646573282253756250726F636573734D61726B657222293B693D6F3F7B2E2E2E692C7365713A2D32312C706172616C6C656C3A2D32322C636F6D70656E736174696F6E3A2D3432';
wwv_flow_imp.g_varchar2_table(242) := '2C6C6F6F703A2D31382C6164686F633A31307D3A7B2E2E2E692C7365713A2D352C706172616C6C656C3A2D362C636F6D70656E736174696F6E3A2D32372C6C6F6F703A302C6164686F633A31307D2C66286E2C2866756E6374696F6E286E297B4F286E2C';
wwv_flow_imp.g_varchar2_table(243) := '652C742C69297D29292C722E67657428226973466F72436F6D70656E736174696F6E222926264F2822436F6D70656E736174696F6E4D61726B6572222C652C742C69292C6B28722C2262706D6E3A4164486F6353756250726F63657373222926264F2822';
wwv_flow_imp.g_varchar2_table(244) := '4164686F634D61726B6572222C652C742C69293B76617220613D722E67657428226C6F6F7043686172616374657269737469637322292C733D612626612E6765742822697353657175656E7469616C22293B61262628766F696420303D3D3D7326264F28';
wwv_flow_imp.g_varchar2_table(245) := '224C6F6F704D61726B6572222C652C742C69292C21313D3D3D7326264F2822506172616C6C656C4D61726B6572222C652C742C69292C21303D3D3D7326264F282253657175656E7469616C4D61726B6572222C652C742C6929297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(246) := '4E28652C742C6E3D7B7D297B6E3D53287B73697A653A7B77696474683A3130307D7D2C6E293B76617220693D6F2E6372656174655465787428747C7C22222C6E293B72657475726E20472869292E6164642822646A732D6C6162656C22292C6A28652C69';
wwv_flow_imp.g_varchar2_table(247) := '292C697D66756E6374696F6E204C28652C742C6E2C693D7B7D297B76617220723D4D2874292C6F3D4565287B783A742E782C793A742E792C77696474683A742E77696474682C6865696768743A742E6865696768747D2C69293B72657475726E204E2865';
wwv_flow_imp.g_varchar2_table(248) := '2C722E6E616D652C7B616C69676E3A6E2C626F783A6F2C70616464696E673A372C7374796C653A7B66696C6C3A5F6528742C702C632C692E7374726F6B65297D7D297D66756E6374696F6E204628652C742C6E2C693D7B7D297B76617220723D42286E29';
wwv_flow_imp.g_varchar2_table(249) := '2C6F3D4E28652C742C7B626F783A7B6865696768743A33302C77696474683A723F4165286E2C69293A5365286E2C69297D2C616C69676E3A2263656E7465722D6D6964646C65222C7374796C653A7B66696C6C3A5F65286E2C702C632C692E7374726F6B';
wwv_flow_imp.g_varchar2_table(250) := '65297D7D293B7226266E74286F2C302C312A4165286E2C69292C323730297D66756E6374696F6E205628652C742C6E3D7B7D297B7661727B77696474683A692C6865696768743A727D3D456528742C6E293B72657475726E206728652C692C722C31302C';
wwv_flow_imp.g_varchar2_table(251) := '7B2E2E2E6E2C66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A63742C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D66756E6374696F6E202428652C742C6E3D7B7D297B76617220693D4D2874292C72';
wwv_flow_imp.g_varchar2_table(252) := '3D786528742C732C6E2E66696C6C292C6F3D776528742C632C6E2E7374726F6B65293B72657475726E224F6E6522213D3D692E67657428226173736F63696174696F6E446972656374696F6E2229262622426F746822213D3D692E67657428226173736F';
wwv_flow_imp.g_varchar2_table(253) := '63696174696F6E446972656374696F6E22297C7C286E2E6D61726B6572456E643D6D28652C226173736F63696174696F6E2D656E64222C722C6F29292C22426F7468223D3D3D692E67657428226173736F63696174696F6E446972656374696F6E222926';
wwv_flow_imp.g_varchar2_table(254) := '26286E2E6D61726B657253746172743D6D28652C226173736F63696174696F6E2D7374617274222C722C6F29292C6E3D7574286E2C5B226D61726B65725374617274222C226D61726B6572456E64225D292C6228652C742E776179706F696E74732C7B2E';
wwv_flow_imp.g_varchar2_table(255) := '2E2E6E2C7374726F6B653A6F2C7374726F6B654461736861727261793A22302C2035227D297D66756E6374696F6E205728652C742C6E3D7B7D297B76617220723D786528742C732C6E2E66696C6C292C6F3D776528742C632C6E2E7374726F6B65292C61';
wwv_flow_imp.g_varchar2_table(256) := '3D7828652C692E6765745363616C6564506174682822444154415F4F424A4543545F50415448222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E746169';
wwv_flow_imp.g_varchar2_table(257) := '6E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3437342C6D793A2E3239367D7D292C7B66696C6C3A722C66696C6C4F7061636974793A63742C7374726F6B653A6F7D293B72657475726E2066756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(258) := '7B76617220743D652E646174614F626A6563745265663B72657475726E20652E6973436F6C6C656374696F6E7C7C742626742E6973436F6C6C656374696F6E7D284D2874292926267828652C692E6765745363616C6564506174682822444154415F4F42';
wwv_flow_imp.g_varchar2_table(259) := '4A4543545F434F4C4C454354494F4E5F50415448222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E686569676874';
wwv_flow_imp.g_varchar2_table(260) := '2C706F736974696F6E3A7B6D783A2E33332C6D793A28742E6865696768742D3138292F742E6865696768747D7D292C7B7374726F6B6557696474683A322C66696C6C3A722C7374726F6B653A6F7D292C617D66756E6374696F6E204828652C742C6E3D7B';
wwv_flow_imp.g_varchar2_table(261) := '7D297B72657475726E207928652C742E77696474682C742E6865696768742C7B66696C6C4F7061636974793A63742C2E2E2E6E2C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D6675';
wwv_flow_imp.g_varchar2_table(262) := '6E6374696F6E204B28652C742C6E3D7B7D297B72657475726E2066756E6374696F6E28652C742C6E2C69297B76617220723D742F322C6F3D6E2F322C613D5B7B783A722C793A307D2C7B783A742C793A6F7D2C7B783A722C793A6E7D2C7B783A302C793A';
wwv_flow_imp.g_varchar2_table(263) := '6F7D5D2E6D6170282866756E6374696F6E2865297B72657475726E20652E782B222C222B652E797D29292E6A6F696E28222022293B693D752869293B76617220733D582822706F6C79676F6E222C7B2E2E2E692C706F696E74733A617D293B7265747572';
wwv_flow_imp.g_varchar2_table(264) := '6E206A28652C73292C737D28652C742E77696474682C742E6865696768742C7B66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A63742C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(265) := '6E205528652C742C6E3D7B7D297B76617220693D6728652C536528742C6E292C416528742C6E292C302C7B66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A6E2E66696C6C4F7061636974797C7C63742C7374726F6B653A';
wwv_flow_imp.g_varchar2_table(266) := '776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E357D292C723D4D2874293B72657475726E206B28722C2262706D6E3A4C616E65222926264628652C722E67657428226E616D6522292C742C6E292C697D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(267) := '207128652C742C6E3D7B7D297B76617220693D5628652C742C6E293B2866756E6374696F6E2865297B72657475726E2065262621214D2865292E74726967676572656442794576656E747D2928742926267A28692C7B7374726F6B654461736861727261';
wwv_flow_imp.g_varchar2_table(268) := '793A22302C20352E35222C7374726F6B6557696474683A322E357D293B76617220723D442874293B72657475726E204C28652C742C723F2263656E7465722D746F70223A2263656E7465722D6D6964646C65222C6E292C5428652C742C723F766F696420';
wwv_flow_imp.g_varchar2_table(269) := '303A5B2253756250726F636573734D61726B6572225D2C6E292C697D66756E6374696F6E205928652C742C6E3D7B7D297B76617220693D5628652C742C6E293B72657475726E204C28652C742C2263656E7465722D6D6964646C65222C6E292C5428652C';
wwv_flow_imp.g_varchar2_table(270) := '742C766F696420302C6E292C697D766172205A3D746869732E68616E646C6572733D7B2262706D6E3A4164486F6353756250726F63657373223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207128652C742C6E3D442874293F757428';
wwv_flow_imp.g_varchar2_table(271) := '6E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A4173736F63696174696F6E223A66756E6374696F6E28652C742C6E3D7B7D';
wwv_flow_imp.g_varchar2_table(272) := '297B72657475726E202428652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A426F756E646172794576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D';
wwv_flow_imp.g_varchar2_table(273) := '21307D3D6E3B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D4D2874292E676574282263616E63656C416374697669747922293B6E3D7B7374726F6B6557696474683A312E352C66696C6C3A786528742C732C6E2E6669';
wwv_flow_imp.g_varchar2_table(274) := '6C6C292C66696C6C4F7061636974793A312C7374726F6B653A776528742C632C6E2E7374726F6B65297D2C727C7C286E2E7374726F6B654461736861727261793D223622293B766172206F3D4828652C742C6E293B72657475726E207928652C742E7769';
wwv_flow_imp.g_varchar2_table(275) := '6474682C742E6865696768742C332C7B2E2E2E6E2C66696C6C3A226E6F6E65227D292C6926264128742C652C6E292C6F7D2C2262706D6E3A427573696E65737352756C655461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D59';
wwv_flow_imp.g_varchar2_table(276) := '28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207A287828652C692E6765745363616C65645061746828225441534B5F545950455F425553494E4553535F52554C455F4D41494E222C7B616273706F733A';
wwv_flow_imp.g_varchar2_table(277) := '7B783A382C793A387D7D29292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C7A287828652C692E6765745363616C6564506174682822544153';
wwv_flow_imp.g_varchar2_table(278) := '4B5F545950455F425553494E4553535F52554C455F484541444552222C7B616273706F733A7B783A382C793A387D7D29292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(279) := '6F6B6557696474683A317D292C727D2C2262706D6E3A43616C6C4163746976697479223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C7128652C742C7B7374726F6B';
wwv_flow_imp.g_varchar2_table(280) := '6557696474683A352C2E2E2E6E7D297D2C2262706D6E3A436F6D706C657847617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D4B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B726574';
wwv_flow_imp.g_varchar2_table(281) := '75726E207828652C692E6765745363616C6564506174682822474154455741595F434F4D504C4558222C7B785363616C65466163746F723A2E352C795363616C65466163746F723A2E352C636F6E7461696E657257696474683A742E77696474682C636F';
wwv_flow_imp.g_varchar2_table(282) := '6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E34362C6D793A2E32367D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(283) := '6F6B6557696474683A317D292C727D2C2262706D6E3A44617461496E707574223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D692E6765745261775061746828224441';
wwv_flow_imp.g_varchar2_table(284) := '54415F4152524F5722292C6F3D5728652C742C6E293B72657475726E207828652C722C7B66696C6C3A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C6F7D2C2262706D6E3A446174';
wwv_flow_imp.g_varchar2_table(285) := '61496E7075744173736F63696174696F6E223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C2428652C742C7B2E2E2E6E2C6D61726B6572456E643A6D28652C226173';
wwv_flow_imp.g_varchar2_table(286) := '736F63696174696F6E2D656E64222C786528742C732C6E2E66696C6C292C776528742C632C6E2E7374726F6B6529297D297D2C2262706D6E3A446174614F626A656374223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E205728652C74';
wwv_flow_imp.g_varchar2_table(287) := '2C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A446174614F626A6563745265666572656E6365223A45282262706D6E3A446174614F626A65637422292C2262706D6E3A446174614F7574707574223A66756E6374';
wwv_flow_imp.g_varchar2_table(288) := '696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D692E676574526177506174682822444154415F4152524F5722292C6F3D5728652C742C6E293B72657475726E207828652C722C7B7374';
wwv_flow_imp.g_varchar2_table(289) := '726F6B6557696474683A312C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D292C6F7D2C2262706D6E3A446174614F75747075744173736F63696174696F6E223A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(290) := '2C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C2428652C742C7B2E2E2E6E2C6D61726B6572456E643A6D28652C226173736F63696174696F6E2D656E64222C786528742C732C6E2E66696C6C29';
wwv_flow_imp.g_varchar2_table(291) := '2C776528742C632C6E2E7374726F6B6529297D297D2C2262706D6E3A4461746153746F72655265666572656E6365223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C';
wwv_flow_imp.g_varchar2_table(292) := '7828652C692E6765745363616C6564506174682822444154415F53544F5245222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E657248656967';
wwv_flow_imp.g_varchar2_table(293) := '68743A742E6865696768742C706F736974696F6E3A7B6D783A302C6D793A2E3133337D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A63742C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374';
wwv_flow_imp.g_varchar2_table(294) := '726F6B6557696474683A327D297D2C2262706D6E3A456E644576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76';
wwv_flow_imp.g_varchar2_table(295) := '617220723D4828652C742C7B2E2E2E6E2C7374726F6B6557696474683A347D293B72657475726E206926264128742C652C6E292C727D2C2262706D6E3A4576656E74426173656447617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B6E';
wwv_flow_imp.g_varchar2_table(296) := '3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D4D2874292C6F3D4B28652C742C6E293B7928652C742E77696474682C742E6865696768742C2E322A742E6865696768742C7B66696C6C3A786528742C226E6F6E65222C6E2E';
wwv_flow_imp.g_varchar2_table(297) := '66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D293B76617220613D722E67657428226576656E74476174657761795479706522292C733D2121722E6765742822696E7374616E7469617465';
wwv_flow_imp.g_varchar2_table(298) := '22293B69662822506172616C6C656C223D3D3D61297B766172206C3D692E6765745363616C6564506174682822474154455741595F504152414C4C454C222C7B785363616C65466163746F723A2E342C795363616C65466163746F723A2E342C636F6E74';
wwv_flow_imp.g_varchar2_table(299) := '61696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3437342C6D793A2E3239367D7D293B7828652C6C2C7B66696C6C3A226E6F6E65222C7374726F6B653A77';
wwv_flow_imp.g_varchar2_table(300) := '6528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D656C7365224578636C7573697665223D3D3D61262628737C7C7928652C742E77696474682C742E6865696768742C2E32362A742E6865696768742C7B66696C6C3A226E6F';
wwv_flow_imp.g_varchar2_table(301) := '6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C66756E6374696F6E28297B76617220723D692E6765745363616C6564506174682822474154455741595F4556454E545F4241534544222C7B';
wwv_flow_imp.g_varchar2_table(302) := '785363616C65466163746F723A2E31382C795363616C65466163746F723A2E31382C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E33362C6D';
wwv_flow_imp.g_varchar2_table(303) := '793A2E34347D7D293B7828652C722C7B66696C6C3A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A327D297D2829293B72657475726E206F7D2C2262706D6E3A4578636C7573697665476174';
wwv_flow_imp.g_varchar2_table(304) := '65776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D4B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29292C6F3D692E6765745363616C6564506174682822474154455741595F4558434C5553495645';
wwv_flow_imp.g_varchar2_table(305) := '222C7B785363616C65466163746F723A2E342C795363616C65466163746F723A2E342C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E33322C';
wwv_flow_imp.g_varchar2_table(306) := '6D793A2E337D7D293B72657475726E20502874292E676574282269734D61726B657256697369626C65222926267828652C6F2C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374';
wwv_flow_imp.g_varchar2_table(307) := '726F6B6557696474683A317D292C727D2C2262706D6E3A47617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A4772';
wwv_flow_imp.g_varchar2_table(308) := '6F7570223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D292C6728652C742E77696474682C742E6865696768742C31302C7B73';
wwv_flow_imp.g_varchar2_table(309) := '74726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E352C7374726F6B654461736861727261793A2231302C20362C20302C2036222C66696C6C3A226E6F6E65222C706F696E7465724576656E74733A226E6F6E65';
wwv_flow_imp.g_varchar2_table(310) := '222C77696474683A536528742C6E292C6865696768743A416528742C6E297D297D2C2262706D6E3A496E636C757369766547617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4B28652C742C6E3D7574286E2C5B226669';
wwv_flow_imp.g_varchar2_table(311) := '6C6C222C227374726F6B65225D29293B72657475726E207928652C742E77696474682C742E6865696768742C2E32342A742E6865696768742C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65';
wwv_flow_imp.g_varchar2_table(312) := '292C7374726F6B6557696474683A322E357D292C697D2C2262706D6E3A496E7465726D6564696174654576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D7574286E2C5B2266';
wwv_flow_imp.g_varchar2_table(313) := '696C6C222C227374726F6B65225D293B76617220723D4828652C742C7B2E2E2E6E2C7374726F6B6557696474683A312E357D293B72657475726E207928652C742E77696474682C742E6865696768742C332C7B66696C6C3A226E6F6E65222C7374726F6B';
wwv_flow_imp.g_varchar2_table(314) := '653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E357D292C6926264128742C652C6E292C727D2C2262706D6E3A496E7465726D65646961746543617463684576656E74223A45282262706D6E3A496E7465726D65646961';
wwv_flow_imp.g_varchar2_table(315) := '74654576656E7422292C2262706D6E3A496E7465726D6564696174655468726F774576656E74223A45282262706D6E3A496E7465726D6564696174654576656E7422292C2262706D6E3A4C616E65223A66756E6374696F6E28652C742C6E3D7B7D297B72';
wwv_flow_imp.g_varchar2_table(316) := '657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D292C5528652C742C7B2E2E2E6E2C66696C6C4F7061636974793A2E32357D297D2C2262706D6E3A4D616E75616C5461736B223A6675';
wwv_flow_imp.g_varchar2_table(317) := '6E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F4D414E55414C';
wwv_flow_imp.g_varchar2_table(318) := '222C7B616273706F733A7B783A31372C793A31357D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C727D2C2262706D6E3A4D65737361';
wwv_flow_imp.g_varchar2_table(319) := '6765466C6F77223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D4D2874292C6F3D502874292C613D786528742C732C6E2E66696C6C292C6C3D776528742C632C6E2E73';
wwv_flow_imp.g_varchar2_table(320) := '74726F6B65292C703D6228652C742E776179706F696E74732C7B6D61726B6572456E643A6D28652C226D657373616765666C6F772D656E64222C612C6C292C6D61726B657253746172743A6D28652C226D657373616765666C6F772D7374617274222C61';
wwv_flow_imp.g_varchar2_table(321) := '2C6C292C7374726F6B653A6C2C7374726F6B654461736861727261793A2231302C203131222C7374726F6B6557696474683A312E357D293B696628722E67657428226D6573736167655265662229297B76617220753D702E676574506F696E7441744C65';
wwv_flow_imp.g_varchar2_table(322) := '6E67746828702E676574546F74616C4C656E67746828292F32292C683D692E6765745363616C65645061746828224D4553534147455F464C4F575F4D41524B4552222C7B616273706F733A7B783A752E782C793A752E797D7D292C643D7B7374726F6B65';
wwv_flow_imp.g_varchar2_table(323) := '57696474683A317D3B22696E6974696174696E67223D3D3D6F2E67657428226D65737361676556697369626C654B696E6422293F28642E66696C6C3D612C642E7374726F6B653D6C293A28642E66696C6C3D6C2C642E7374726F6B653D61293B76617220';
wwv_flow_imp.g_varchar2_table(324) := '663D7828652C682C64292C793D4E28652C722E67657428226D65737361676552656622292E67657428226E616D6522292C7B616C69676E3A2263656E7465722D746F70222C666974426F783A21302C7374796C653A7B66696C6C3A6C7D7D292C673D662E';
wwv_flow_imp.g_varchar2_table(325) := '67657442426F7828292C763D792E67657442426F7828293B6E7428792C752E782D762E77696474682F322C752E792B672E6865696768742F322B31302C30297D72657475726E20707D2C2262706D6E3A506172616C6C656C47617465776179223A66756E';
wwv_flow_imp.g_varchar2_table(326) := '6374696F6E28652C742C6E3D7B7D297B76617220723D4B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C6564506174682822474154455741595F504152414C4C454C22';
wwv_flow_imp.g_varchar2_table(327) := '2C7B785363616C65466163746F723A2E362C795363616C65466163746F723A2E362C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E34362C6D';
wwv_flow_imp.g_varchar2_table(328) := '793A2E327D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A5061727469636970616E74223A66756E6374696F';
wwv_flow_imp.g_varchar2_table(329) := '6E28652C742C6E3D7B7D297B76617220693D5528652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D29292C723D442874292C6F3D422874292C613D4D2874292C733D612E67657428226E61';
wwv_flow_imp.g_varchar2_table(330) := '6D6522293B69662872297628652C6F3F5B7B783A33302C793A307D2C7B783A33302C793A416528742C6E297D5D3A5B7B783A302C793A33307D2C7B783A536528742C6E292C793A33307D5D2C7B7374726F6B653A776528742C632C6E2E7374726F6B6529';
wwv_flow_imp.g_varchar2_table(331) := '2C7374726F6B6557696474683A312E357D292C4628652C732C742C6E293B656C73657B766172206C3D456528742C6E293B6F7C7C286C2E6865696768743D536528742C6E292C6C2E77696474683D416528742C6E29293B76617220753D4E28652C732C7B';
wwv_flow_imp.g_varchar2_table(332) := '626F783A6C2C616C69676E3A2263656E7465722D6D6964646C65222C7374796C653A7B66696C6C3A5F6528742C702C632C6E2E7374726F6B65297D7D293B6F7C7C6E7428752C302C312A416528742C6E292C323730297D72657475726E20612E67657428';
wwv_flow_imp.g_varchar2_table(333) := '227061727469636970616E744D756C7469706C6963697479222926264F28225061727469636970616E744D756C7469706C69636974794D61726B6572222C652C742C6E292C697D2C2262706D6E3A526563656976655461736B223A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(334) := '652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220722C6F3D4D2874292C613D5928652C742C6E293B72657475726E206F2E6765742822696E7374616E746961746522293F287928652C32382C32382C34';
wwv_flow_imp.g_varchar2_table(335) := '2E342C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C723D692E6765745363616C65645061746828225441534B5F545950455F494E5354414E54';
wwv_flow_imp.g_varchar2_table(336) := '494154494E475F53454E44222C7B616273706F733A7B783A372E37372C793A392E35327D7D29293A723D692E6765745363616C65645061746828225441534B5F545950455F53454E44222C7B785363616C65466163746F723A2E392C795363616C654661';
wwv_flow_imp.g_varchar2_table(337) := '63746F723A2E392C636F6E7461696E657257696474683A32312C636F6E7461696E65724865696768743A31342C706F736974696F6E3A7B6D783A2E332C6D793A2E347D7D292C7828652C722C7B66696C6C3A786528742C732C6E2E66696C6C292C737472';
wwv_flow_imp.g_varchar2_table(338) := '6F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C617D2C2262706D6E3A5363726970745461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D7574286E2C5B226669';
wwv_flow_imp.g_varchar2_table(339) := '6C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F534352495054222C7B616273706F733A7B783A31352C793A32307D7D292C7B66696C6C3A786528742C732C6E2E66';
wwv_flow_imp.g_varchar2_table(340) := '696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A53656E645461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D757428';
wwv_flow_imp.g_varchar2_table(341) := '6E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F53454E44222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E';
wwv_flow_imp.g_varchar2_table(342) := '7461696E657257696474683A32312C636F6E7461696E65724865696768743A31342C706F736974696F6E3A7B6D783A2E3238352C6D793A2E3335377D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A786528742C732C';
wwv_flow_imp.g_varchar2_table(343) := '6E2E66696C6C292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A53657175656E6365466C6F77223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220693D7865';
wwv_flow_imp.g_varchar2_table(344) := '28742C732C6E2E66696C6C292C723D776528742C632C6E2E7374726F6B65292C6F3D6228652C742E776179706F696E74732C7B6D61726B6572456E643A6D28652C2273657175656E6365666C6F772D656E64222C692C72292C7374726F6B653A727D292C';
wwv_flow_imp.g_varchar2_table(345) := '613D4D2874292C7B736F757263653A6C7D3D743B6966286C297B76617220703D4D286C293B612E6765742822636F6E646974696F6E45787072657373696F6E222926266B28702C2262706D6E3A4163746976697479222926267A286F2C7B6D61726B6572';
wwv_flow_imp.g_varchar2_table(346) := '53746172743A6D28652C22636F6E646974696F6E616C2D666C6F772D6D61726B6572222C692C72297D292C702E676574282264656661756C7422292626286B28702C2262706D6E3A4761746577617922297C7C6B28702C2262706D6E3A41637469766974';
wwv_flow_imp.g_varchar2_table(347) := '792229292626702E676574282264656661756C7422293D3D3D6126267A286F2C7B6D61726B657253746172743A6D28652C22636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572222C692C72297D297D72657475726E206F7D2C';
wwv_flow_imp.g_varchar2_table(348) := '2262706D6E3A536572766963655461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207928652C31302C31302C7B66696C6C3A';
wwv_flow_imp.g_varchar2_table(349) := '786528742C732C6E2E66696C6C292C7374726F6B653A226E6F6E65222C7472616E73666F726D3A227472616E736C61746528362C203629227D292C7828652C692E6765745363616C65645061746828225441534B5F545950455F53455256494345222C7B';
wwv_flow_imp.g_varchar2_table(350) := '616273706F733A7B783A31322C793A31387D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C7928652C31302C31302C7B66696C6C3A7865';
wwv_flow_imp.g_varchar2_table(351) := '28742C732C6E2E66696C6C292C7374726F6B653A226E6F6E65222C7472616E73666F726D3A227472616E736C6174652831312C20313029227D292C7828652C692E6765745363616C65645061746828225441534B5F545950455F53455256494345222C7B';
wwv_flow_imp.g_varchar2_table(352) := '616273706F733A7B783A31372C793A32327D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A53746172744576656E';
wwv_flow_imp.g_varchar2_table(353) := '74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C4D2874292E67657428226973496E74657272757074696E6722297C7C28';
wwv_flow_imp.g_varchar2_table(354) := '6E3D7B2E2E2E6E2C7374726F6B654461736861727261793A2236227D293B76617220723D4828652C742C6E293B72657475726E206926264128742C652C6E292C727D2C2262706D6E3A53756250726F63657373223A66756E6374696F6E28652C742C6E3D';
wwv_flow_imp.g_varchar2_table(355) := '7B7D297B72657475726E207128652C742C6E3D442874293F7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A546173';
wwv_flow_imp.g_varchar2_table(356) := '6B223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E205928652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A54657874416E6E6F746174696F6E223A66756E6374696F6E28652C742C6E3D';
wwv_flow_imp.g_varchar2_table(357) := '7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293B7661727B77696474683A722C6865696768743A6F7D3D456528742C6E292C613D6728652C722C6F2C302C302C7B66696C6C3A226E6F';
wwv_flow_imp.g_varchar2_table(358) := '6E65222C7374726F6B653A226E6F6E65227D293B72657475726E207828652C692E6765745363616C6564506174682822544558545F414E4E4F544154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E74';
wwv_flow_imp.g_varchar2_table(359) := '61696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F736974696F6E3A7B6D783A302C6D793A307D7D292C7B7374726F6B653A776528742C632C6E2E7374726F6B65297D292C4E28652C4D2874292E67657428227465787422';
wwv_flow_imp.g_varchar2_table(360) := '297C7C22222C7B616C69676E3A226C6566742D746F70222C626F783A456528742C6E292C70616464696E673A372C7374796C653A7B66696C6C3A5F6528742C702C632C6E2E7374726F6B65297D7D292C617D2C2262706D6E3A5472616E73616374696F6E';
wwv_flow_imp.g_varchar2_table(361) := '223A66756E6374696F6E28652C742C693D7B7D297B693D442874293F757428692C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A757428692C5B2266696C6C222C227374726F6B65225D293B76617220723D71';
wwv_flow_imp.g_varchar2_table(362) := '28652C742C7B7374726F6B6557696474683A312E352C2E2E2E697D292C6F3D6E2E7374796C65285B226E6F2D66696C6C222C226E6F2D6576656E7473225D2C7B7374726F6B653A776528742C632C692E7374726F6B65292C7374726F6B6557696474683A';
wwv_flow_imp.g_varchar2_table(363) := '312E357D293B72657475726E20442874297C7C28693D7B7D292C6728652C536528742C69292C416528742C69292C372C332C6F292C727D2C2262706D6E3A557365725461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D592865';
wwv_flow_imp.g_varchar2_table(364) := '2C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F555345525F31222C7B616273706F733A7B783A31352C793A31327D7D292C7B66';
wwv_flow_imp.g_varchar2_table(365) := '696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C7828652C692E6765745363616C65645061746828225441534B5F545950455F555345525F32222C7B';
wwv_flow_imp.g_varchar2_table(366) := '616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C7828652C692E6765745363616C65645061';
wwv_flow_imp.g_varchar2_table(367) := '746828225441534B5F545950455F555345525F33222C7B616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B65576964';
wwv_flow_imp.g_varchar2_table(368) := '74683A2E357D292C727D2C6C6162656C3A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E2066756E6374696F6E28652C742C6E3D7B7D297B76617220693D7B77696474683A39302C6865696768743A33302C783A742E77696474682F322B';
wwv_flow_imp.g_varchar2_table(369) := '742E782C793A742E6865696768742F322B742E797D3B72657475726E204E28652C492874292C7B626F783A692C666974426F783A21302C7374796C653A53287B7D2C6F2E67657445787465726E616C5374796C6528292C7B66696C6C3A5F6528742C702C';
wwv_flow_imp.g_varchar2_table(370) := '632C6E2E7374726F6B65297D297D297D28652C742C6E297D7D3B746869732E5F64726177506174683D782C746869732E5F72656E64657265723D5F7D66756E6374696F6E20757428652C743D5B5D297B72657475726E20742E726564756365282828742C';
wwv_flow_imp.g_varchar2_table(371) := '6E293D3E28655B6E5D262628745B6E5D3D655B6E5D292C7429292C7B7D297D6E2870742C43292C70742E24696E6A6563743D5B22636F6E6669672E62706D6E52656E6465726572222C226576656E74427573222C227374796C6573222C22706174684D61';
wwv_flow_imp.g_varchar2_table(372) := '70222C2263616E766173222C227465787452656E6465726572225D2C70742E70726F746F747970652E63616E52656E6465723D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A42617365456C656D656E7422297D2C70742E7072';
wwv_flow_imp.g_varchar2_table(373) := '6F746F747970652E6472617753686170653D66756E6374696F6E28652C742C6E3D7B7D297B7661727B747970653A697D3D743B72657475726E20746869732E5F72656E646572657228692928652C742C6E297D2C70742E70726F746F747970652E647261';
wwv_flow_imp.g_varchar2_table(374) := '77436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E3D7B7D297B7661727B747970653A697D3D743B72657475726E20746869732E5F72656E646572657228692928652C742C6E297D2C70742E70726F746F747970652E676574536861706550';
wwv_flow_imp.g_varchar2_table(375) := '6174683D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A4576656E7422293F7065285B5B224D222C28743D65292E782B742E77696474682F322C742E792B742E6865696768742F325D2C5B226D222C302C2D286E3D742E776964';
wwv_flow_imp.g_varchar2_table(376) := '74682F32295D2C5B2261222C6E2C6E2C302C312C312C302C322A6E5D2C5B2261222C6E2C6E2C302C312C312C302C2D322A6E5D2C5B227A225D5D293A6B28652C2262706D6E3A416374697669747922293F66756E6374696F6E28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(377) := '3D652E782C693D652E792C723D652E77696474682C6F3D652E6865696768743B72657475726E207065285B5B224D222C6E2B742C695D2C5B226C222C722D32302C305D2C5B2261222C742C742C302C302C312C742C745D2C5B226C222C302C6F2D32305D';
wwv_flow_imp.g_varchar2_table(378) := '2C5B2261222C742C742C302C302C312C2D31302C745D2C5B226C222C32302D722C305D2C5B2261222C742C742C302C302C312C2D31302C2D31305D2C5B226C222C302C32302D6F5D2C5B2261222C742C742C302C302C312C742C2D31305D2C5B227A225D';
wwv_flow_imp.g_varchar2_table(379) := '5D297D28652C3130293A6B28652C2262706D6E3A4761746577617922293F66756E6374696F6E2865297B76617220743D652E77696474682F322C6E3D652E6865696768742F323B72657475726E207065285B5B224D222C652E782B742C652E795D2C5B22';
wwv_flow_imp.g_varchar2_table(380) := '6C222C742C6E5D2C5B226C222C2D742C6E5D2C5B226C222C2D742C2D6E5D2C5B227A225D5D297D2865293A66756E6374696F6E2865297B76617220743D652E782C6E3D652E792C693D652E77696474683B72657475726E207065285B5B224D222C742C6E';
wwv_flow_imp.g_varchar2_table(381) := '5D2C5B226C222C692C305D2C5B226C222C302C652E6865696768745D2C5B226C222C2D692C305D2C5B227A225D5D297D2865293B76617220742C6E7D3B7661722068743D302C64743D7B77696474683A3135302C6865696768743A35307D3B66756E6374';
wwv_flow_imp.g_varchar2_table(382) := '696F6E206D7428652C74297B766172206E3B742E74657874436F6E74656E743D653B7472797B76617220692C723D22223D3D3D653B72657475726E20742E74657874436F6E74656E743D723F2264756D6D79223A652C693D7B77696474683A286E3D742E';
wwv_flow_imp.g_varchar2_table(383) := '67657442426F782829292E77696474682B322A6E2E782C6865696768743A6E2E6865696768747D2C72262628692E77696474683D30292C697D63617463682865297B72657475726E7B77696474683A302C6865696768743A307D7D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(384) := '20667428652C742C6E297B666F722876617220692C723D652E736869667428292C6F3D723B3B297B69662828693D6D74286F2C6E29292E77696474683D6F3F692E77696474683A302C2220223D3D3D6F7C7C22223D3D3D6F7C7C692E77696474683C4D61';
wwv_flow_imp.g_varchar2_table(385) := '74682E726F756E642874297C7C6F2E6C656E6774683C322972657475726E20797428652C6F2C722C69293B6F3D7674286F2C692E77696474682C74297D7D66756E6374696F6E20797428652C742C6E2C69297B696628742E6C656E6774683C6E2E6C656E';
wwv_flow_imp.g_varchar2_table(386) := '677468297B76617220723D6E2E736C69636528742E6C656E677468292E7472696D28293B652E756E73686966742872297D72657475726E7B77696474683A692E77696474682C6865696768743A692E6865696768742C746578743A747D7D766172206774';
wwv_flow_imp.g_varchar2_table(387) := '3D22C2AD223B66756E6374696F6E20767428652C742C6E297B76617220693D4D6174682E6D617828652E6C656E6774682A286E2F74292C31292C723D66756E6374696F6E28652C74297B766172206E2C693D652E73706C6974282F285C737C2D7C5C7530';
wwv_flow_imp.g_varchar2_table(388) := '304144292F67292C723D5B5D2C6F3D303B696628692E6C656E6774683E3129666F72283B6E3D692E736869667428293B297B69662821286E2E6C656E6774682B6F3C7429297B222D22213D3D6E26266E213D3D67747C7C722E706F7028293B627265616B';
wwv_flow_imp.g_varchar2_table(389) := '7D722E70757368286E292C6F2B3D6E2E6C656E6774687D76617220613D725B722E6C656E6774682D315D3B72657475726E20612626613D3D3D6774262628725B722E6C656E6774682D315D3D222D22292C722E6A6F696E282222297D28652C69293B7265';
wwv_flow_imp.g_varchar2_table(390) := '7475726E20727C7C28723D652E736C69636528302C4D6174682E6D6178284D6174682E726F756E6428692D31292C312929292C727D66756E6374696F6E2062742865297B746869732E5F636F6E6669673D53287B7D2C7B73697A653A64742C7061646469';
wwv_flow_imp.g_varchar2_table(391) := '6E673A68742C7374796C653A7B7D2C616C69676E3A2263656E7465722D746F70227D2C657C7C7B7D297D66756E6374696F6E2078742865297B76617220743D53287B666F6E7446616D696C793A22417269616C2C2073616E732D7365726966222C666F6E';
wwv_flow_imp.g_varchar2_table(392) := '7453697A653A31322C666F6E745765696768743A226E6F726D616C222C6C696E654865696768743A312E327D2C652626652E64656661756C745374796C657C7C7B7D292C6E3D7061727365496E7428742E666F6E7453697A652C3130292D312C693D5328';
wwv_flow_imp.g_varchar2_table(393) := '7B7D2C742C7B666F6E7453697A653A6E7D2C652626652E65787465726E616C5374796C657C7C7B7D292C723D6E6577206274287B7374796C653A747D293B746869732E67657445787465726E616C4C6162656C426F756E64733D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(394) := '2C74297B766172206E3D722E67657444696D656E73696F6E7328742C7B626F783A7B77696474683A39302C6865696768743A33307D2C7374796C653A697D293B72657475726E7B783A4D6174682E726F756E6428652E782B652E77696474682F322D6E2E';
wwv_flow_imp.g_varchar2_table(395) := '77696474682F32292C793A4D6174682E726F756E6428652E79292C77696474683A4D6174682E6365696C286E2E7769647468292C6865696768743A4D6174682E6365696C286E2E686569676874297D7D2C746869732E67657454657874416E6E6F746174';
wwv_flow_imp.g_varchar2_table(396) := '696F6E426F756E64733D66756E6374696F6E28652C6E297B76617220693D722E67657444696D656E73696F6E73286E2C7B626F783A652C7374796C653A742C616C69676E3A226C6566742D746F70222C70616464696E673A357D293B72657475726E7B78';
wwv_flow_imp.g_varchar2_table(397) := '3A652E782C793A652E792C77696474683A652E77696474682C6865696768743A4D6174682E6D61782833302C4D6174682E726F756E6428692E68656967687429297D7D2C746869732E637265617465546578743D66756E6374696F6E28652C74297B7265';
wwv_flow_imp.g_varchar2_table(398) := '7475726E20722E6372656174655465787428652C747C7C7B7D297D2C746869732E67657444656661756C745374796C653D66756E6374696F6E28297B72657475726E20747D2C746869732E67657445787465726E616C5374796C653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(399) := '28297B72657475726E20697D7D62742E70726F746F747970652E637265617465546578743D66756E6374696F6E28652C74297B72657475726E20746869732E6C61796F75745465787428652C74292E656C656D656E747D2C62742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(400) := '2E67657444696D656E73696F6E733D66756E6374696F6E28652C74297B72657475726E20746869732E6C61796F75745465787428652C74292E64696D656E73696F6E737D2C62742E70726F746F747970652E6C61796F7574546578743D66756E6374696F';
wwv_flow_imp.g_varchar2_table(401) := '6E28652C74297B766172206E2C693D53287B7D2C746869732E5F636F6E6669672E73697A652C742E626F78292C723D53287B7D2C746869732E5F636F6E6669672E7374796C652C742E7374796C65292C6F3D66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(402) := '652E73706C697428222D22293B72657475726E7B686F72697A6F6E74616C3A745B305D7C7C2263656E746572222C766572746963616C3A745B315D7C7C22746F70227D7D28742E616C69676E7C7C746869732E5F636F6E6669672E616C69676E292C613D';
wwv_flow_imp.g_varchar2_table(403) := '66756E6374696F6E2865297B72657475726E206C2865293F53287B746F703A302C6C6566743A302C72696768743A302C626F74746F6D3A307D2C65293A7B746F703A652C6C6566743A652C72696768743A652C626F74746F6D3A657D7D28766F69642030';
wwv_flow_imp.g_varchar2_table(404) := '213D3D742E70616464696E673F742E70616464696E673A746869732E5F636F6E6669672E70616464696E67292C733D742E666974426F787C7C21312C633D66756E6374696F6E2865297B69662822666F6E7453697A6522696E20652626226C696E654865';
wwv_flow_imp.g_varchar2_table(405) := '6967687422696E20652972657475726E20652E6C696E654865696768742A7061727365496E7428652E666F6E7453697A652C3130297D2872292C703D652E73706C6974282F5C75303041443F5C723F5C6E2F292C753D5B5D2C683D692E77696474682D61';
wwv_flow_imp.g_varchar2_table(406) := '2E6C6566742D612E72696768742C643D5828227465787422293B666F72287A28642C7B783A302C793A307D292C7A28642C72292C6A28286E3D766F696420302C286E3D646F63756D656E742E676574456C656D656E7442794964282268656C7065722D73';
wwv_flow_imp.g_varchar2_table(407) := '76672229297C7C287A286E3D58282273766722292C7B69643A2268656C7065722D737667227D292C4F65286E2C7B7669736962696C6974793A2268696464656E222C706F736974696F6E3A226669786564222C77696474683A302C6865696768743A307D';
wwv_flow_imp.g_varchar2_table(408) := '292C646F63756D656E742E626F64792E617070656E644368696C64286E29292C6E292C64293B702E6C656E6774683B29752E7075736828667428702C682C6429293B226D6964646C65223D3D3D6F2E766572746963616C262628612E746F703D612E626F';
wwv_flow_imp.g_varchar2_table(409) := '74746F6D3D30293B766172206D3D7928752C2866756E6374696F6E28652C742C6E297B72657475726E20652B28637C7C742E686569676874297D292C30292B612E746F702B612E626F74746F6D2C673D7928752C2866756E6374696F6E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(410) := '7B72657475726E20742E77696474683E653F742E77696474683A657D292C30292C763D612E746F703B226D6964646C65223D3D3D6F2E766572746963616C262628762B3D28692E6865696768742D6D292F32292C762D3D28637C7C755B305D2E68656967';
wwv_flow_imp.g_varchar2_table(411) := '6874292F343B76617220623D5828227465787422293B72657475726E207A28622C72292C6628752C2866756E6374696F6E2865297B76617220743B73776974636828762B3D637C7C652E6865696768742C6F2E686F72697A6F6E74616C297B6361736522';
wwv_flow_imp.g_varchar2_table(412) := '6C656674223A743D612E6C6566743B627265616B3B63617365227269676874223A743D28733F673A68292D612E72696768742D652E77696474683B627265616B3B64656661756C743A743D4D6174682E6D6178282828733F673A68292D652E7769647468';
wwv_flow_imp.g_varchar2_table(413) := '292F322B612E6C6566742C30297D766172206E3D582822747370616E22293B7A286E2C7B783A742C793A767D292C6E2E74657874436F6E74656E743D652E746578742C6A28622C6E297D29292C73652864292C7B64696D656E73696F6E733A7B77696474';
wwv_flow_imp.g_varchar2_table(414) := '683A672C6865696768743A6D7D2C656C656D656E743A627D7D2C78742E24696E6A6563743D5B22636F6E6669672E7465787452656E6465726572225D3B7661722077743D2F5C7B285B5E7B7D5D2B295C7D2F672C5F743D2F283F3A283F3A5E7C5C2E2928';
wwv_flow_imp.g_varchar2_table(415) := '2E2B3F29283F3D5C5B7C5C2E7C247C5C28297C5C5B28277C2229282E2B3F295C325C5D29285C285C29293F2F673B636F6E73742045743D7B5F5F696E69745F5F3A5B2262706D6E52656E6465726572225D2C62706D6E52656E64657265723A5B22747970';
wwv_flow_imp.g_varchar2_table(416) := '65222C70745D2C7465787452656E64657265723A5B2274797065222C78745D2C706174684D61703A5B2274797065222C66756E6374696F6E28297B746869732E706174684D61703D7B4556454E545F4D4553534147453A7B643A226D207B6D787D2C7B6D';
wwv_flow_imp.g_varchar2_table(417) := '797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D222C6865696768743A33362C77696474683A33362C686569676874456C';
wwv_flow_imp.g_varchar2_table(418) := '656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C4556454E545F5349474E414C3A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78317D2C30205A222C68';
wwv_flow_imp.g_varchar2_table(419) := '65696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B31385D2C7769647468456C656D656E74733A5B31302C32305D7D2C4556454E545F455343414C4154494F4E3A7B643A224D207B6D787D2C7B6D797D206C207B652E78';
wwv_flow_imp.g_varchar2_table(420) := '307D2C7B652E79307D206C202D7B652E78307D2C2D7B652E79317D206C202D7B652E78307D2C7B652E79317D205A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B32302C375D2C7769647468456C656D656E';
wwv_flow_imp.g_varchar2_table(421) := '74733A5B385D7D2C4556454E545F434F4E444954494F4E414C3A7B643A224D207B652E78307D2C7B652E79307D206C207B652E78317D2C30206C20302C7B652E79327D206C202D7B652E78317D2C30205A204D207B652E78327D2C7B652E79337D206C20';
wwv_flow_imp.g_varchar2_table(422) := '7B652E78307D2C30204D207B652E78327D2C7B652E79347D206C207B652E78307D2C30204D207B652E78327D2C7B652E79357D206C207B652E78307D2C30204D207B652E78327D2C7B652E79367D206C207B652E78307D2C30204D207B652E78327D2C7B';
wwv_flow_imp.g_varchar2_table(423) := '652E79377D206C207B652E78307D2C30204D207B652E78327D2C7B652E79387D206C207B652E78307D2C3020222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B382E352C31342E352C31382C31312E352C3134';
wwv_flow_imp.g_varchar2_table(424) := '2E352C31372E352C32302E352C32332E352C32362E355D2C7769647468456C656D656E74733A5B31302E352C31342E352C31322E355D7D2C4556454E545F4C494E4B3A7B643A226D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78317D2C';
wwv_flow_imp.g_varchar2_table(425) := '3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79327D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B342E';
wwv_flow_imp.g_varchar2_table(426) := '343337352C362E37352C372E383132355D2C7769647468456C656D656E74733A5B392E38343337352C31332E355D7D2C4556454E545F4552524F523A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D207B652E78317D2C2D7B';
wwv_flow_imp.g_varchar2_table(427) := '652E79317D207B652E78327D2C7B652E79327D207B652E78337D2C2D7B652E79337D202D7B652E78347D2C7B652E79347D202D7B652E78357D2C2D7B652E79357D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E';
wwv_flow_imp.g_varchar2_table(428) := '74733A5B2E3032332C382E3733372C382E3135312C31362E3536342C31302E3539312C382E3731345D2C7769647468456C656D656E74733A5B2E3038352C362E3637322C362E39372C342E3237332C352E3333372C362E3633365D7D2C4556454E545F43';
wwv_flow_imp.g_varchar2_table(429) := '414E43454C5F34353A7B643A226D207B6D787D2C7B6D797D202D7B652E78317D2C3020302C7B652E78307D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C3020302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D20';
wwv_flow_imp.g_varchar2_table(430) := '2D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B342E37352C382E355D2C7769647468456C656D656E74733A5B342E37352C382E';
wwv_flow_imp.g_varchar2_table(431) := '355D7D2C4556454E545F434F4D50454E534154494F4E3A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D20302C7B652E79317D207A206D207B652E78317D2C2D7B652E79327D207B652E78327D2C2D7B652E79337D20302C7B';
wwv_flow_imp.g_varchar2_table(432) := '652E79317D202D7B652E78327D2C2D7B652E79337D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B362E352C31332C2E342C362E315D2C7769647468456C656D656E74733A5B392C392E332C382E375D';
wwv_flow_imp.g_varchar2_table(433) := '7D2C4556454E545F54494D45525F57483A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C2D7B652E79307D206D202D7B652E78307D2C7B652E79307D206C207B652E78317D2C7B652E79317D20222C6865696768743A33362C7769647468';
wwv_flow_imp.g_varchar2_table(434) := '3A33362C686569676874456C656D656E74733A5B31302C325D2C7769647468456C656D656E74733A5B332C375D7D2C4556454E545F54494D45525F4C494E453A7B643A224D207B6D787D2C7B6D797D206D207B652E78307D2C7B652E79307D206C202D7B';
wwv_flow_imp.g_varchar2_table(435) := '652E78317D2C7B652E79317D20222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B31302C335D2C7769647468456C656D656E74733A5B302C305D7D2C4556454E545F4D554C5449504C453A7B643A226D207B6D';
wwv_flow_imp.g_varchar2_table(436) := '787D2C7B6D797D207B652E78317D2C2D7B652E79307D207B652E78317D2C7B652E79307D202D7B652E78307D2C7B652E79317D202D7B652E78327D2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B';
wwv_flow_imp.g_varchar2_table(437) := '362E32383039392C31322E35363139395D2C7769647468456C656D656E74733A5B332E313430352C392E34323134392C31322E35363139385D7D2C4556454E545F504152414C4C454C5F4D554C5449504C453A7B643A226D207B6D787D2C7B6D797D207B';
wwv_flow_imp.g_varchar2_table(438) := '652E78307D2C3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D202D7B652E78307D2C3020302C2D7B652E79317D202D7B652E78317D2C3020302C2D7B652E79307D207B652E78317D';
wwv_flow_imp.g_varchar2_table(439) := '2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B322E35363232382C372E36383638335D2C7769647468456C656D656E74733A5B322E35363232382C372E36383638335D7D2C474154455741595F45';
wwv_flow_imp.g_varchar2_table(440) := '58434C55534956453A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78317D2C7B652E79307D207B652E78327D2C30207B652E78347D2C7B652E79327D207B652E78347D2C7B652E79317D207B652E78327D2C30207B';
wwv_flow_imp.g_varchar2_table(441) := '652E78317D2C7B652E79337D207B652E78307D2C7B652E79337D207B652E78337D2C30207B652E78357D2C7B652E79317D207B652E78357D2C7B652E79327D207B652E78337D2C30207A222C6865696768743A31372E352C77696474683A31372E352C68';
wwv_flow_imp.g_varchar2_table(442) := '6569676874456C656D656E74733A5B382E352C362E353331322C2D362E353331322C2D382E355D2C7769647468456C656D656E74733A5B362E352C2D362E352C332C2D332C352C2D355D7D2C474154455741595F504152414C4C454C3A7B643A226D207B';
wwv_flow_imp.g_varchar2_table(443) := '6D787D2C7B6D797D20302C7B652E79317D202D7B652E78317D2C3020302C7B652E79307D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C3020302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D';
wwv_flow_imp.g_varchar2_table(444) := '2C3020302C2D7B652E79317D202D7B652E78307D2C30207A222C6865696768743A33302C77696474683A33302C686569676874456C656D656E74733A5B352C31322E355D2C7769647468456C656D656E74733A5B352C31322E355D7D2C47415445574159';
wwv_flow_imp.g_varchar2_table(445) := '5F4556454E545F42415345443A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79327D207B652E78327D2C30207A222C6865696768743A31312C77696474683A31';
wwv_flow_imp.g_varchar2_table(446) := '312C686569676874456C656D656E74733A5B2D362C362C31322C2D31325D2C7769647468456C656D656E74733A5B392C2D332C2D31325D7D2C474154455741595F434F4D504C45583A7B643A226D207B6D787D2C7B6D797D20302C7B652E79307D202D7B';
wwv_flow_imp.g_varchar2_table(447) := '652E78307D2C2D7B652E79317D202D7B652E78317D2C7B652E79327D207B652E78307D2C7B652E79317D202D7B652E78327D2C3020302C7B652E79337D207B652E78327D2C3020202D7B652E78307D2C7B652E79317D206C207B652E78317D2C7B652E79';
wwv_flow_imp.g_varchar2_table(448) := '327D207B652E78307D2C2D7B652E79317D20302C7B652E79307D207B652E78337D2C3020302C2D7B652E79307D207B652E78307D2C7B652E79317D207B652E78317D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79317D207B652E78327D2C3020';
wwv_flow_imp.g_varchar2_table(449) := '302C2D7B652E79337D202D7B652E78327D2C30207B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79327D202D7B652E78307D2C7B652E79317D20302C2D7B652E79307D202D7B652E78337D2C30207A222C6865696768743A31372E31';
wwv_flow_imp.g_varchar2_table(450) := '32352C77696474683A31372E3132352C686569676874456C656D656E74733A5B342E3837352C332E343337352C322E3132352C335D2C7769647468456C656D656E74733A5B332E343337352C322E3132352C342E3837352C335D7D2C444154415F4F424A';
wwv_flow_imp.g_varchar2_table(451) := '4543545F504154483A7B643A226D20302C30207B652E78317D2C30207B652E78307D2C7B652E79307D20302C7B652E79317D202D7B652E78327D2C3020302C2D7B652E79327D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C30222C68';
wwv_flow_imp.g_varchar2_table(452) := '65696768743A36312C77696474683A35312C686569676874456C656D656E74733A5B31302C35302C36305D2C7769647468456C656D656E74733A5B31302C34302C35302C36305D7D2C444154415F4F424A4543545F434F4C4C454354494F4E5F50415448';
wwv_flow_imp.g_varchar2_table(453) := '3A7B643A226D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C3130222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C776964';
wwv_flow_imp.g_varchar2_table(454) := '7468456C656D656E74733A5B5D7D2C444154415F4152524F573A7B643A226D20352C3920392C3020302C2D3320352C35202D352C3520302C2D33202D392C30207A222C6865696768743A36312C77696474683A35312C686569676874456C656D656E7473';
wwv_flow_imp.g_varchar2_table(455) := '3A5B5D2C7769647468456C656D656E74733A5B5D7D2C444154415F53544F52453A7B643A226D20207B6D787D2C7B6D797D206C2020302C7B652E79327D206320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D';
wwv_flow_imp.g_varchar2_table(456) := '2C30206C2020302C2D7B652E79327D2063202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79317D202D7B652E78327D2C306320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C3020';
wwv_flow_imp.g_varchar2_table(457) := '6D20202D7B652E78327D2C7B652E79307D6320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D207B652E78327D2C306D20202D7B652E78327D2C7B652E79307D6320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E';
wwv_flow_imp.g_varchar2_table(458) := '79317D20207B652E78327D2C30222C6865696768743A36312C77696474683A36312C686569676874456C656D656E74733A5B372C31302C34355D2C7769647468456C656D656E74733A5B322C35382C36305D7D2C544558545F414E4E4F544154494F4E3A';
wwv_flow_imp.g_varchar2_table(459) := '7B643A226D207B6D787D2C207B6D797D206D2031302C30206C202D31302C30206C20302C7B652E79307D206C2031302C30222C6865696768743A33302C77696474683A31302C686569676874456C656D656E74733A5B33305D2C7769647468456C656D65';
wwv_flow_imp.g_varchar2_table(460) := '6E74733A5B31305D7D2C4D41524B45525F5355425F50524F434553533A7B643A226D7B6D787D2C7B6D797D206D20372C32206C20302C3130206D202D352C2D35206C2031302C30222C6865696768743A31302C77696474683A31302C686569676874456C';
wwv_flow_imp.g_varchar2_table(461) := '656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F504152414C4C454C3A7B643A226D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C31';
wwv_flow_imp.g_varchar2_table(462) := '30222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F53455155454E5449414C3A7B643A226D7B6D787D2C7B6D797D206D20302C33206C2031';
wwv_flow_imp.g_varchar2_table(463) := '302C30206D202D31302C33206C2031302C30206D202D31302C33206C2031302C30222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F434F4D';
wwv_flow_imp.g_varchar2_table(464) := '50454E534154494F4E3A7B643A226D207B6D787D2C7B6D797D20372C2D3520302C3130207A206D20372E312C2D302E3320362E392C2D342E3720302C3130202D362E392C2D342E37207A222C6865696768743A31302C77696474683A32312C6865696768';
wwv_flow_imp.g_varchar2_table(465) := '74456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F4C4F4F503A7B643A226D207B6D787D2C7B6D797D206320332E3532363937392C3020362E3338363136312C2D322E38323938353820362E3338363136312C';
wwv_flow_imp.g_varchar2_table(466) := '2D362E33323036363120302C2D332E343930383036202D322E3835393138322C2D362E333230363631202D362E3338363136312C2D362E333230363631202D332E3532363937382C30202D362E33383631362C322E383239383535202D362E3338363136';
wwv_flow_imp.g_varchar2_table(467) := '2C362E33323036363120302C312E37343534303220302E3731343739372C332E33323535363720312E3837303436332C342E34363933383120302E3537373833342C302E35373139303820312E3236353838352C312E30333437323820322E3032393931';
wwv_flow_imp.g_varchar2_table(468) := '362C312E3335343537206C202D302E3731383136332C2D332E393039373933206D20302E3731383136332C332E393039373933202D332E3838353231312C302E383032393032222C6865696768743A31332E392C77696474683A31332E372C6865696768';
wwv_flow_imp.g_varchar2_table(469) := '74456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F4144484F433A7B643A226D207B6D787D2C7B6D797D206D20302E38343436312C322E3634343131206320312E30353533332C2D312E323337383039393620';
wwv_flow_imp.g_varchar2_table(470) := '322E36343333372C2D322E303738383220342E32393635332C2D312E393739393739393620322E30353136332C302E3038303520332E38353537392C312E313538303320352E37363038322C312E373931303720312E30363338352C302E333431333939';
wwv_flow_imp.g_varchar2_table(471) := '393620322E32343435342C302E3134333820332E31383735392C2D302E343337363720302E36313734332C2D302E333336343220312E323737352C2D302E363430373820312E373534322C2D312E313735313120302C302E353630323320302C312E3132';
wwv_flow_imp.g_varchar2_table(472) := '30343620302C312E36383037202D302E39383730362C302E3936323337393936202D322E32393739322C312E3632333933393936202D332E363931382C312E3636313831393936202D312E32343435392C302E30393237202D322E34363637312C2D302E';
wwv_flow_imp.g_varchar2_table(473) := '32343931202D332E35393530352C2D302E3734383132202D312E33353738392C2D302E3535393635202D322E37353133332C2D312E3333343336393936202D342E32373032372C2D312E3138313231393936202D312E33373734312C302E313436303120';
wwv_flow_imp.g_varchar2_table(474) := '2D322E34313834322C312E3133363835393936202D332E34343238382C312E3936373832393936207A222C6865696768743A342C77696474683A31352C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C544153';
wwv_flow_imp.g_varchar2_table(475) := '4B5F545950455F53454E443A7B643A226D207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D222C6865';
wwv_flow_imp.g_varchar2_table(476) := '696768743A31342C77696474683A32312C686569676874456C656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C5441534B5F545950455F5343524950543A7B643A226D207B6D787D2C7B6D797D20632039';
wwv_flow_imp.g_varchar2_table(477) := '2E3936363535332C2D362E3237323736202D382E3030303932362C2D372E393139333220322E3936383936382C2D31342E393338206C202D382E3830323732382C302063202D31302E3936393839342C372E303138363820362E3939373538352C382E36';
wwv_flow_imp.g_varchar2_table(478) := '36353234202D322E3936383936372C31342E393338207A206D202D372C2D3132206C20352C30206D202D342E352C33206C20342E352C30206D202D332C33206C20352C306D202D342C33206C20352C30222C6865696768743A31352C77696474683A3132';
wwv_flow_imp.g_varchar2_table(479) := '2E362C686569676874456C656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C5441534B5F545950455F555345525F313A7B643A226D207B6D787D2C7B6D797D206320302E3930392C2D302E38343520312E';
wwv_flow_imp.g_varchar2_table(480) := '3539342C2D322E30343920312E3539342C2D332E33383520302C2D322E353534202D312E3830352C2D342E3632313939393939202D342E3335372C2D342E3632313939393939202D322E35353139393939382C30202D342E32383739393939382C322E30';
wwv_flow_imp.g_varchar2_table(481) := '36373939393939202D342E32383739393939382C342E363231393939393920302C312E33343820302E3937342C322E35363220312E38393539393939382C332E343035202D302E35323839393939382C302E313837202D352E3636392C322E303937202D';
wwv_flow_imp.g_varchar2_table(482) := '352E3739342C342E37353630303035207620362E37313820682031372076202D362E373138206320302C2D322E32393830303035202D352E353237393939362C2D342E35393530303035202D362E303530393939362C2D342E37373630303035207A6D20';
wwv_flow_imp.g_varchar2_table(483) := '2D382C36206C20302C352E35206D2031312C30206C20302C2D35227D2C5441534B5F545950455F555345525F323A7B643A226D207B6D787D2C7B6D797D206D20322E3136322C312E303039206320302C322E34343730303035202D322E3135382C342E34';
wwv_flow_imp.g_varchar2_table(484) := '333130303035202D342E3832312C342E34333130303035202D322E36363439393939382C30202D342E3832322C2D312E393831202D342E3832322C2D342E3433313030303520227D2C5441534B5F545950455F555345525F333A7B643A226D207B6D787D';
wwv_flow_imp.g_varchar2_table(485) := '2C7B6D797D206D202D362E392C2D332E3830206320302C3020322E32353039393939382C2D322E33353820342E32373339393939382C2D312E31373720322E3032342C312E31383120342E3232312C312E35333720342E3132342C302E393635202D302E';
wwv_flow_imp.g_varchar2_table(486) := '3039382C2D302E3537202D302E3131372C2D332E3739303939393939202D342E3139312C2D342E3133353939393939202D332E35373439393939382C302E303031202D342E32303739393939382C332E3336363939393939202D342E3230363939393938';
wwv_flow_imp.g_varchar2_table(487) := '2C342E3334373939393939207A227D2C5441534B5F545950455F4D414E55414C3A7B643A226D207B6D787D2C7B6D797D206320302E3233342C2D302E303120352E3630342C302E30303820382E3032392C302E30303420302E3830382C3020312E323731';
wwv_flow_imp.g_varchar2_table(488) := '2C2D302E31373220312E3431372C2D302E37353220302E3232372C2D302E383938202D302E3333342C2D312E333134202D312E3333382C2D312E333136202D322E3436372C2D302E3031202D372E3838362C2D302E303034202D382E3130382C2D302E30';
wwv_flow_imp.g_varchar2_table(489) := '3034202D302E3031342C2D302E30373920302E3031362C2D302E35333320302C2D302E363120302E3139352C2D302E30343220382E3530372C302E30303620392E3631362C302E30303220302E3837372C2D302E30303720312E33352C2D302E34333820';
wwv_flow_imp.g_varchar2_table(490) := '312E3335332C2D312E32303820302E3030332C2D302E373638202D302E3437392C2D312E3039202D312E33352C2D312E303931202D322E3936382C2D302E303032202D392E3631392C2D302E303133202D392E3631392C2D302E3031332076202D302E35';
wwv_flow_imp.g_varchar2_table(491) := '3931206320302C3020352E3035322C2D302E30313620372E3232352C2D302E30313620302E3838382C2D302E30303220312E3335342C2D302E34313620312E3335312C2D312E313933202D302E3030362C2D302E373631202D302E3439322C2D312E3139';
wwv_flow_imp.g_varchar2_table(492) := '36202D312E3336312C2D312E313936202D332E3437332C2D302E303035202D31302E38362C2D302E303033202D31312E303832393939352C2D302E303033202D302E3032322C2D302E303437202D302E3034352C2D302E303934202D302E3036392C2D30';
wwv_flow_imp.g_varchar2_table(493) := '2E31333920302E333933393939352C2D302E33313920322E303430393939352C2D312E36323620322E343134393939352C2D322E30313720302E3436392C2D302E3438373030303520302E3531392C2D312E3136353030303520302E3136322C2D312E36';
wwv_flow_imp.g_varchar2_table(494) := '303430303035202D302E3431342C2D302E353131202D302E3937332C2D302E35202D312E34382C2D302E323336202D312E343630393939352C302E373634202D362E353939393939352C332E36343330303035202D372E373332393939352C342E323731';
wwv_flow_imp.g_varchar2_table(495) := '30303035202D302E392C302E343939202D312E3531362C312E323533202D312E3838322C322E3139202D302E33373030303030322C302E3935202D302E31372C322E3031202D302E3136362C322E39373920302E3030342C302E373138202D302E323733';
wwv_flow_imp.g_varchar2_table(496) := '30303030322C312E333435202D302E3035352C322E30363320302E3632392C322E30383720322E3432352C332E33313220342E3835392C332E33313820342E363137393939352C302E30313420392E323337393939352C2D302E3133392031332E383536';
wwv_flow_imp.g_varchar2_table(497) := '393939352C2D302E31353820302E3735352C2D302E30303420312E3137312C2D302E33303120312E3138322C2D312E30333320302E3031322C2D302E373534202D302E3432332C2D302E393639202D312E3138332C2D302E393733202D312E3737382C2D';
wwv_flow_imp.g_varchar2_table(498) := '302E3031202D352E3832342C2D302E303034202D362E30342C2D302E303034203130652D342C2D302E30383420302E3030332C2D302E353836203130652D342C2D302E3637207A227D2C5441534B5F545950455F494E5354414E54494154494E475F5345';
wwv_flow_imp.g_varchar2_table(499) := '4E443A7B643A226D207B6D787D2C7B6D797D206C20302C382E34206C2031322E362C30206C20302C2D382E34207A206C20362E332C332E36206C20362E332C2D332E36227D2C5441534B5F545950455F534552564943453A7B643A226D207B6D787D2C7B';
wwv_flow_imp.g_varchar2_table(500) := '6D797D2076202D312E3731333335206320302E3335323332362C2D302E3037303520302E3730333933322C2D302E313738333820312E3034373632382C2D302E333231333320302E3334343431362C2D302E313434363520302E3636353832322C2D302E';
wwv_flow_imp.g_varchar2_table(501) := '333231333320302E3936363337372C2D302E3532313435206C20312E31393433312C312E313830303520312E3536373438372C2D312E3537363838202D312E3139353032382C2D312E3138303134206320302E3430333337362C2D302E36313339342030';
wwv_flow_imp.g_varchar2_table(502) := '2E3638333037392C2D312E323939303820302E3832353434372C2D322E3031383234206C20312E3632323133332C2D302E30312076202D322E32313936206C202D312E3633363531342C302E30312063202D302E30373333332C2D302E3335313533202D';
wwv_flow_imp.g_varchar2_table(503) := '302E3137383331392C2D302E3730303234202D302E3332333536342C2D312E3034333732202D302E3134353234342C2D302E3334343036202D302E3332313430372C2D302E36363434202D302E3532323733352C2D302E3936323137206C20312E313331';
wwv_flow_imp.g_varchar2_table(504) := '3033352C2D312E3133363331202D312E3538333330352C2D312E3536323933202D312E3132393539382C312E31333538392063202D302E3631343035322C2D302E3430313038202D312E3330323838332C2D302E3638303933202D322E3032323633332C';
wwv_flow_imp.g_varchar2_table(505) := '2D302E3832323437206C20302E303039332C2D312E36313835322068202D322E323431313733206C20302E303034322C312E36333132342063202D302E3335333736332C302E30373336202D302E3730353336392C302E3137393737202D312E30343937';
wwv_flow_imp.g_varchar2_table(506) := '38352C302E3332333731202D302E3334343431352C302E3134343337202D302E3636353130322C302E3332303932202D302E393633353030362C302E3532303436206C202D312E313639383632382C2D312E3135383233202D312E353636373639312C31';
wwv_flow_imp.g_varchar2_table(507) := '2E3537393220312E313638343236352C312E31353636392063202D302E343032363537332C302E3631323833202D302E36383330382C312E3239373937202D302E383234373238372C322E3031373133206C202D312E363538383034312C302E30303320';
wwv_flow_imp.g_varchar2_table(508) := '7620322E3232313734206C20312E363732343634382C2D302E303036206320302E3037333332372C302E333530373720302E313739373539382C302E373032343320302E333234323835312C312E303434373220302E313435323432382C302E33343434';
wwv_flow_imp.g_varchar2_table(509) := '3820302E333231343036342C302E3636343420302E353232373333392C302E3936303636206C202D312E313939333433312C312E313937323320312E353834303235362C312E353630313120312E313936343636382C2D312E3139333438206320302E36';
wwv_flow_imp.g_varchar2_table(510) := '3134303531372C302E343033343620312E333032383832372C302E363832333220322E303233333531372C302E3832333331206C20372E3139652D342C312E3639383932206820322E323236383438207A206D20302E3232313436322C2D332E39393537';
wwv_flow_imp.g_varchar2_table(511) := '2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036352C2D312E373833323120302E3039303539382C2D332E383436323720312E38383032';
wwv_flow_imp.g_varchar2_table(512) := '3634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E3630383938372C312E383734333720302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E38';
wwv_flow_imp.g_varchar2_table(513) := '37393534362C342E3539363035207A227D2C5441534B5F545950455F534552564943455F46494C4C3A7B643A226D207B6D787D2C7B6D797D2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E3630393730';
wwv_flow_imp.g_varchar2_table(514) := '35352C2D312E3837343338202D302E373532313036352C2D312E373833323120302E3039303539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E303932';
wwv_flow_imp.g_varchar2_table(515) := '3920342E3630383938372C312E383734333720302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A227D2C5441534B5F545950455F425553494E4553535F52554C455F4845';
wwv_flow_imp.g_varchar2_table(516) := '414445523A7B643A226D207B6D787D2C7B6D797D20302C342032302C3020302C2D34207A227D2C5441534B5F545950455F425553494E4553535F52554C455F4D41494E3A7B643A226D207B6D787D2C7B6D797D20302C31322032302C3020302C2D313220';
wwv_flow_imp.g_varchar2_table(517) := '7A6D20302C38206C2032302C30206D202D31332C2D34206C20302C38227D2C4D4553534147455F464C4F575F4D41524B45523A7B643A226D207B6D787D2C7B6D797D206D202D31302E35202C2D37206C20302C3134206C2032312C30206C20302C2D3134';
wwv_flow_imp.g_varchar2_table(518) := '207A206C2031302E352C36206C2031302E352C2D36227D7D2C746869732E676574526177506174683D66756E6374696F6E2865297B72657475726E20746869732E706174684D61705B655D2E647D2C746869732E6765745363616C6564506174683D6675';
wwv_flow_imp.g_varchar2_table(519) := '6E6374696F6E28652C74297B766172206E2C692C723D746869732E706174684D61705B655D3B742E616273706F733F286E3D742E616273706F732E782C693D742E616273706F732E79293A286E3D742E636F6E7461696E657257696474682A742E706F73';
wwv_flow_imp.g_varchar2_table(520) := '6974696F6E2E6D782C693D742E636F6E7461696E65724865696768742A742E706F736974696F6E2E6D79293B766172206F2C612C733D7B7D3B696628742E706F736974696F6E297B666F7228766172206C3D742E636F6E7461696E65724865696768742F';
wwv_flow_imp.g_varchar2_table(521) := '722E6865696768742A742E795363616C65466163746F722C633D742E636F6E7461696E657257696474682F722E77696474682A742E785363616C65466163746F722C703D303B703C722E686569676874456C656D656E74732E6C656E6774683B702B2B29';
wwv_flow_imp.g_varchar2_table(522) := '735B2279222B705D3D722E686569676874456C656D656E74735B705D2A6C3B666F722876617220753D303B753C722E7769647468456C656D656E74732E6C656E6774683B752B2B29735B2278222B755D3D722E7769647468456C656D656E74735B755D2A';
wwv_flow_imp.g_varchar2_table(523) := '637D72657475726E206F3D722E642C613D7B6D783A6E2C6D793A692C653A737D2C537472696E67286F292E7265706C6163652877742C2866756E6374696F6E28652C74297B72657475726E2066756E6374696F6E28652C742C6E297B76617220693D6E3B';
wwv_flow_imp.g_varchar2_table(524) := '72657475726E20742E7265706C616365285F742C2866756E6374696F6E28652C742C6E2C722C6F297B743D747C7C722C692626287420696E2069262628693D695B745D292C2266756E6374696F6E223D3D747970656F66206926266F262628693D692829';
wwv_flow_imp.g_varchar2_table(525) := '29297D29292C693D286E756C6C3D3D697C7C693D3D6E3F653A69292B22227D28652C742C61297D29297D7D5D7D2C53743D7B7472616E736C6174653A5B2276616C7565222C66756E6374696F6E28652C74297B72657475726E20743D747C7C7B7D2C652E';
wwv_flow_imp.g_varchar2_table(526) := '7265706C616365282F7B285B5E7D5D2B297D2F672C2866756E6374696F6E28652C6E297B72657475726E20745B6E5D7C7C227B222B6E2B227D227D29297D5D7D3B7661722041743D4D6174683B66756E6374696F6E2043742865297B72657475726E206C';
wwv_flow_imp.g_varchar2_table(527) := '28652926266828652C226C6162656C54617267657422297D66756E6374696F6E206B742865297B72657475726E7B746F703A652E792C72696768743A652E782B28652E77696474687C7C30292C626F74746F6D3A652E792B28652E6865696768747C7C30';
wwv_flow_imp.g_varchar2_table(528) := '292C6C6566743A652E787D7D66756E6374696F6E2052742865297B72657475726E206C286E3D6529262668286E2C22776179706F696E747322293F66756E6374696F6E2865297B666F722876617220743D652E776179706F696E74732C6E3D742E726564';
wwv_flow_imp.g_varchar2_table(529) := '756365282866756E6374696F6E28652C6E2C69297B76617220722C6F2C613D745B692D315D3B69662861297B76617220733D655B652E6C656E6774682D315D2C6C3D732626732E656E644C656E6774687C7C302C633D28723D612C6F3D6E2C4D6174682E';
wwv_flow_imp.g_varchar2_table(530) := '73717274284D6174682E706F7728722E782D6F2E782C32292B4D6174682E706F7728722E792D6F2E792C322929293B652E70757368287B73746172743A612C656E643A6E2C73746172744C656E6774683A6C2C656E644C656E6774683A6C2B632C6C656E';
wwv_flow_imp.g_varchar2_table(531) := '6774683A637D297D72657475726E20657D292C5B5D292C693D6E2E726564756365282866756E6374696F6E28652C74297B72657475726E20652B742E6C656E6774687D292C30292F322C723D302C6F3D6E5B725D3B6F2E656E644C656E6774683C693B29';
wwv_flow_imp.g_varchar2_table(532) := '6F3D6E5B2B2B725D3B76617220613D28692D6F2E73746172744C656E677468292F6F2E6C656E6774683B72657475726E7B783A6F2E73746172742E782B286F2E656E642E782D6F2E73746172742E78292A612C793A6F2E73746172742E792B286F2E656E';
wwv_flow_imp.g_varchar2_table(533) := '642E792D6F2E73746172742E79292A617D7D2865293A28743D7B783A28693D65292E782B28692E77696474687C7C30292F322C793A692E792B28692E6865696768747C7C30292F327D2C7B783A4D6174682E726F756E6428742E78292C793A4D6174682E';
wwv_flow_imp.g_varchar2_table(534) := '726F756E6428742E79297D293B76617220742C6E2C697D66756E6374696F6E204D742865297B72657475726E20653F223C222B652E24747970652B28652E69643F272069643D22272B652E69643A2222292B2722202F3E273A223C6E756C6C3E227D6675';
wwv_flow_imp.g_varchar2_table(535) := '6E6374696F6E20507428652C742C6E297B72657475726E2053287B69643A652E69642C747970653A652E24747970652C627573696E6573734F626A6563743A652C64693A747D2C6E297D66756E6374696F6E20447428652C742C6E297B76617220693D65';
wwv_flow_imp.g_varchar2_table(536) := '2E776179706F696E743B72657475726E21697C7C692E6C656E6774683C323F5B52742874292C5274286E295D3A692E6D6170282866756E6374696F6E2865297B72657475726E7B783A652E782C793A652E797D7D29297D66756E6374696F6E2042742865';
wwv_flow_imp.g_varchar2_table(537) := '2C742C6E297B72657475726E206E6577204572726F722860656C656D656E7420247B4D742874297D207265666572656E63656420627920247B4D742865297D23247B6E7D206E6F742079657420647261776E60297D66756E6374696F6E204F7428652C74';
wwv_flow_imp.g_varchar2_table(538) := '2C6E2C692C72297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D742C746869732E5F656C656D656E74466163746F72793D6E2C746869732E5F656C656D656E7452656769737472793D692C746869732E5F7465787452656E';
wwv_flow_imp.g_varchar2_table(539) := '64657265723D727D41742E50492C41742E6D696E2C41742E6D61782C41742E706F772C41742E6162732C41727261792E697341727261792C4F742E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22656C656D656E7446616374';
wwv_flow_imp.g_varchar2_table(540) := '6F7279222C22656C656D656E745265676973747279222C227465787452656E6465726572225D2C4F742E70726F746F747970652E6164643D66756E6374696F6E28652C742C6E297B76617220692C722C6F2C612C732C6C2C633B6966286B28742C226270';
wwv_flow_imp.g_varchar2_table(541) := '6D6E64693A42504D4E506C616E652229297B76617220703D6B28652C2262706D6E3A53756250726F6365737322293F7B69643A652E69642B225F706C616E65227D3A7B7D3B693D746869732E5F656C656D656E74466163746F72792E637265617465526F';
wwv_flow_imp.g_varchar2_table(542) := '6F7428507428652C742C7029292C746869732E5F63616E7661732E616464526F6F74456C656D656E742869297D656C7365206966286B28742C2262706D6E64693A42504D4E53686170652229297B76617220753D214428652C74292C683D66756E637469';
wwv_flow_imp.g_varchar2_table(543) := '6F6E2865297B72657475726E206B28652C2262706D6E3A47726F757022297D2865293B723D6E2626286E2E68696464656E7C7C6E2E636F6C6C6170736564293B76617220643D742E626F756E64733B693D746869732E5F656C656D656E74466163746F72';
wwv_flow_imp.g_varchar2_table(544) := '792E637265617465536861706528507428652C742C7B636F6C6C61707365643A752C68696464656E3A722C783A4D6174682E726F756E6428642E78292C793A4D6174682E726F756E6428642E79292C77696474683A4D6174682E726F756E6428642E7769';
wwv_flow_imp.g_varchar2_table(545) := '647468292C6865696768743A4D6174682E726F756E6428642E686569676874292C69734672616D653A687D29292C6B28652C2262706D6E3A426F756E646172794576656E7422292626746869732E5F617474616368426F756E6461727928652C69292C6B';
wwv_flow_imp.g_varchar2_table(546) := '28652C2262706D6E3A4C616E6522292626286F3D30292C6B28652C2262706D6E3A4461746153746F72655265666572656E63652229262628613D6E2C6C3D28733D5274286429292E782C633D732E792C6C3E3D612E7826266C3C3D612E782B612E776964';
wwv_flow_imp.g_varchar2_table(547) := '74682626633E3D612E792626633C3D612E792B612E6865696768747C7C286E3D746869732E5F63616E7661732E66696E64526F6F74286E2929292C746869732E5F63616E7661732E616464536861706528692C6E2C6F297D656C73657B696628216B2874';
wwv_flow_imp.g_varchar2_table(548) := '2C2262706D6E64693A42504D4E456467652229297468726F77206E6577204572726F722860756E6B6E6F776E20646920247B4D742874297D20666F7220656C656D656E7420247B4D742865297D60293B766172206D3D746869732E5F676574536F757263';
wwv_flow_imp.g_varchar2_table(549) := '652865292C663D746869732E5F6765745461726765742865293B723D6E2626286E2E68696464656E7C7C6E2E636F6C6C6170736564292C693D746869732E5F656C656D656E74466163746F72792E637265617465436F6E6E656374696F6E28507428652C';
wwv_flow_imp.g_varchar2_table(550) := '742C7B68696464656E3A722C736F757263653A6D2C7461726765743A662C776179706F696E74733A447428742C6D2C66297D29292C6B28652C2262706D6E3A446174614173736F63696174696F6E22292626286E3D746869732E5F63616E7661732E6669';
wwv_flow_imp.g_varchar2_table(551) := '6E64526F6F74286E29292C746869732E5F63616E7661732E616464436F6E6E656374696F6E28692C6E2C6F297D72657475726E2066756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A4576656E7422297C7C6B28652C2262706D6E3A';
wwv_flow_imp.g_varchar2_table(552) := '4761746577617922297C7C6B28652C2262706D6E3A4461746153746F72655265666572656E636522297C7C6B28652C2262706D6E3A446174614F626A6563745265666572656E636522297C7C6B28652C2262706D6E3A44617461496E70757422297C7C6B';
wwv_flow_imp.g_varchar2_table(553) := '28652C2262706D6E3A446174614F757470757422297C7C6B28652C2262706D6E3A53657175656E6365466C6F7722297C7C6B28652C2262706D6E3A4D657373616765466C6F7722297C7C6B28652C2262706D6E3A47726F757022297D2865292626492869';
wwv_flow_imp.g_varchar2_table(554) := '292626746869732E6164644C6162656C28652C742C69292C746869732E5F6576656E744275732E66697265282262706D6E456C656D656E742E6164646564222C7B656C656D656E743A697D292C697D2C4F742E70726F746F747970652E5F617474616368';
wwv_flow_imp.g_varchar2_table(555) := '426F756E646172793D66756E6374696F6E28652C74297B766172206E3D652E6174746163686564546F5265663B696628216E297468726F77206E6577204572726F7228606D697373696E6720247B4D742865297D236174746163686564546F5265666029';
wwv_flow_imp.g_varchar2_table(556) := '3B76617220693D746869732E5F656C656D656E7452656769737472792E676574286E2E6964292C723D692626692E6174746163686572733B6966282169297468726F7720427428652C6E2C226174746163686564546F52656622293B742E686F73743D69';
wwv_flow_imp.g_varchar2_table(557) := '2C727C7C28692E6174746163686572733D723D5B5D292C2D313D3D3D722E696E6465784F662874292626722E707573682874297D2C4F742E70726F746F747970652E6164644C6162656C3D66756E6374696F6E28652C742C6E297B76617220692C722C6F';
wwv_flow_imp.g_varchar2_table(558) := '3B72657475726E20693D4E28742C6E292C28723D49286E2929262628693D746869732E5F7465787452656E64657265722E67657445787465726E616C4C6162656C426F756E647328692C7229292C6F3D746869732E5F656C656D656E74466163746F7279';
wwv_flow_imp.g_varchar2_table(559) := '2E6372656174654C6162656C28507428652C742C7B69643A652E69642B225F6C6162656C222C6C6162656C5461726765743A6E2C747970653A226C6162656C222C68696464656E3A6E2E68696464656E7C7C2149286E292C783A4D6174682E726F756E64';
wwv_flow_imp.g_varchar2_table(560) := '28692E78292C793A4D6174682E726F756E6428692E79292C77696474683A4D6174682E726F756E6428692E7769647468292C6865696768743A4D6174682E726F756E6428692E686569676874297D29292C746869732E5F63616E7661732E616464536861';
wwv_flow_imp.g_varchar2_table(561) := '7065286F2C6E2E706172656E74297D2C4F742E70726F746F747970652E5F676574436F6E6E6563746564456C656D656E743D66756E6374696F6E28652C74297B766172206E2C692C723D652E24747970653B696628693D655B742B22526566225D2C2273';
wwv_flow_imp.g_varchar2_table(562) := '6F75726365223D3D3D7426262262706D6E3A44617461496E7075744173736F63696174696F6E223D3D3D72262628693D692626695B305D292C2822736F75726365223D3D3D7426262262706D6E3A446174614F75747075744173736F63696174696F6E22';
wwv_flow_imp.g_varchar2_table(563) := '3D3D3D727C7C22746172676574223D3D3D7426262262706D6E3A44617461496E7075744173736F63696174696F6E223D3D3D7229262628693D652E24706172656E74292C6E3D692626746869732E5F676574456C656D656E742869292972657475726E20';
wwv_flow_imp.g_varchar2_table(564) := '6E3B7468726F7720693F427428652C692C742B2252656622293A6E6577204572726F722860247B4D742865297D23247B747D20526566206E6F742073706563696669656460297D2C4F742E70726F746F747970652E5F676574536F757263653D66756E63';
wwv_flow_imp.g_varchar2_table(565) := '74696F6E2865297B72657475726E20746869732E5F676574436F6E6E6563746564456C656D656E7428652C22736F7572636522297D2C4F742E70726F746F747970652E5F6765745461726765743D66756E6374696F6E2865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(566) := '732E5F676574436F6E6E6563746564456C656D656E7428652C2274617267657422297D2C4F742E70726F746F747970652E5F676574456C656D656E743D66756E6374696F6E2865297B72657475726E20746869732E5F656C656D656E7452656769737472';
wwv_flow_imp.g_varchar2_table(567) := '792E67657428652E6964297D3B636F6E73742054743D7B5F5F646570656E64735F5F3A5B45742C7B5F5F646570656E64735F5F3A5B53745D2C62706D6E496D706F727465723A5B2274797065222C4F745D7D5D7D3B66756E6374696F6E204E7428652C74';
wwv_flow_imp.g_varchar2_table(568) := '297B766172206E2C692C722C6F3B72657475726E20743D2121742C732865297C7C28653D5B655D292C6628652C2866756E6374696F6E2865297B76617220613D653B652E776179706F696E747326262174262628613D4E7428652E776179706F696E7473';
wwv_flow_imp.g_varchar2_table(569) := '2C213029293B76617220733D612E782C6C3D612E792C633D612E6865696768747C7C302C703D612E77696474687C7C303B28733C6E7C7C766F696420303D3D3D6E292626286E3D73292C286C3C697C7C766F696420303D3D3D6929262628693D6C292C28';
wwv_flow_imp.g_varchar2_table(570) := '732B703E727C7C766F696420303D3D3D7229262628723D732B70292C286C2B633E6F7C7C766F696420303D3D3D6F292626286F3D6C2B63297D29292C7B783A6E2C793A692C6865696768743A6F2D692C77696474683A722D6E7D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(571) := '49742865297B72657475726E22776179706F696E747322696E20653F22636F6E6E656374696F6E223A227822696E20653F227368617065223A22726F6F74227D66756E6374696F6E204C742865297B72657475726E212821657C7C21652E69734672616D';
wwv_flow_imp.g_varchar2_table(572) := '65297D66756E6374696F6E206A742865297B746869732E5F636F756E7465723D302C746869732E5F7072656669783D28653F652B222D223A2222292B4D6174682E666C6F6F72283165392A4D6174682E72616E646F6D2829292B222D227D6A742E70726F';
wwv_flow_imp.g_varchar2_table(573) := '746F747970652E6E6578743D66756E6374696F6E28297B72657475726E20746869732E5F7072656669782B202B2B746869732E5F636F756E7465727D3B7661722046743D6E6577206A7428226F7622293B66756E6374696F6E20567428652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(574) := '297B76617220722C6F3B746869732E5F6576656E744275733D742C746869732E5F63616E7661733D6E2C746869732E5F656C656D656E7452656769737472793D692C746869732E5F6964733D46742C746869732E5F6F7665726C617944656661756C7473';
wwv_flow_imp.g_varchar2_table(575) := '3D53287B73686F773A6E756C6C2C7363616C653A21307D2C652626652E64656661756C7473292C746869732E5F6F7665726C6179733D7B7D2C746869732E5F6F7665726C6179436F6E7461696E6572733D5B5D2C746869732E5F6F7665726C6179526F6F';
wwv_flow_imp.g_varchar2_table(576) := '743D28723D6E2E676574436F6E7461696E657228292C4F65286F3D516528273C64697620636C6173733D22646A732D6F7665726C61792D636F6E7461696E657222202F3E27292C7B706F736974696F6E3A226162736F6C757465222C77696474683A302C';
wwv_flow_imp.g_varchar2_table(577) := '6865696768743A307D292C722E696E736572744265666F7265286F2C722E66697273744368696C64292C6F292C746869732E5F696E697428297D66756E6374696F6E20247428652C742C6E297B4F6528652C7B6C6566743A742B227078222C746F703A6E';
wwv_flow_imp.g_varchar2_table(578) := '2B227078227D297D66756E6374696F6E207A7428652C74297B652E7374796C652E646973706C61793D21313D3D3D743F226E6F6E65223A22227D66756E6374696F6E20577428652C74297B652E7374796C655B227472616E73666F726D2D6F726967696E';
wwv_flow_imp.g_varchar2_table(579) := '225D3D22746F70206C656674222C5B22222C222D6D732D222C222D7765626B69742D225D2E666F7245616368282866756E6374696F6E286E297B652E7374796C655B6E2B227472616E73666F726D225D3D747D29297D56742E24696E6A6563743D5B2263';
wwv_flow_imp.g_varchar2_table(580) := '6F6E6669672E6F7665726C617973222C226576656E74427573222C2263616E766173222C22656C656D656E745265676973747279225D2C56742E70726F746F747970652E6765743D66756E6374696F6E2865297B69662875286529262628653D7B69643A';
wwv_flow_imp.g_varchar2_table(581) := '657D292C7528652E656C656D656E7429262628652E656C656D656E743D746869732E5F656C656D656E7452656769737472792E67657428652E656C656D656E7429292C652E656C656D656E74297B76617220743D746869732E5F6765744F7665726C6179';
wwv_flow_imp.g_varchar2_table(582) := '436F6E7461696E657228652E656C656D656E742C2130293B72657475726E20743F652E747970653F6D28742E6F7665726C6179732C62287B747970653A652E747970657D29293A742E6F7665726C6179732E736C69636528293A5B5D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(583) := '652E747970653F6D28746869732E5F6F7665726C6179732C62287B747970653A652E747970657D29293A652E69643F746869732E5F6F7665726C6179735B652E69645D3A6E756C6C7D2C56742E70726F746F747970652E6164643D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(584) := '652C742C6E297B6966286C2874292626286E3D742C743D6E756C6C292C652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C216E2E706F736974696F6E297468726F77206E6577204572726F7228226D7573';
wwv_flow_imp.g_varchar2_table(585) := '74207370656369666979206F7665726C617920706F736974696F6E22293B696628216E2E68746D6C297468726F77206E6577204572726F7228226D757374207370656369666979206F7665726C61792068746D6C22293B6966282165297468726F77206E';
wwv_flow_imp.g_varchar2_table(586) := '6577204572726F722822696E76616C696420656C656D656E742073706563696669656422293B76617220693D746869732E5F6964732E6E65787428293B72657475726E206E3D53287B7D2C746869732E5F6F7665726C617944656661756C74732C6E2C7B';
wwv_flow_imp.g_varchar2_table(587) := '69643A692C747970653A742C656C656D656E743A652C68746D6C3A6E2E68746D6C7D292C746869732E5F6164644F7665726C6179286E292C697D2C56742E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869';
wwv_flow_imp.g_varchar2_table(588) := '732E6765742865297C7C5B5D3B732874297C7C28743D5B745D293B766172206E3D746869733B6628742C2866756E6374696F6E2865297B76617220743D6E2E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E742C2130293B6966';
wwv_flow_imp.g_varchar2_table(589) := '2865262628747428652E68746D6C292C747428652E68746D6C436F6E7461696E6572292C64656C65746520652E68746D6C436F6E7461696E65722C64656C65746520652E656C656D656E742C64656C657465206E2E5F6F7665726C6179735B652E69645D';
wwv_flow_imp.g_varchar2_table(590) := '292C74297B76617220693D742E6F7665726C6179732E696E6465784F662865293B2D31213D3D692626742E6F7665726C6179732E73706C69636528692C31297D7D29297D2C56742E70726F746F747970652E697353686F776E3D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(591) := '7B72657475726E226E6F6E6522213D3D746869732E5F6F7665726C6179526F6F742E7374796C652E646973706C61797D2C56742E70726F746F747970652E73686F773D66756E6374696F6E28297B7A7428746869732E5F6F7665726C6179526F6F74297D';
wwv_flow_imp.g_varchar2_table(592) := '2C56742E70726F746F747970652E686964653D66756E6374696F6E28297B7A7428746869732E5F6F7665726C6179526F6F742C2131297D2C56742E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E5F6F7665726C617973';
wwv_flow_imp.g_varchar2_table(593) := '3D7B7D2C746869732E5F6F7665726C6179436F6E7461696E6572733D5B5D2C6A6528746869732E5F6F7665726C6179526F6F74297D2C56742E70726F746F747970652E5F7570646174654F7665726C6179436F6E7461696E65723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(594) := '65297B76617220743D652E656C656D656E742C6E3D652E68746D6C2C693D742E782C723D742E793B696628742E776179706F696E7473297B766172206F3D4E742874293B693D6F2E782C723D6F2E797D2474286E2C692C72292C546528652E68746D6C2C';
wwv_flow_imp.g_varchar2_table(595) := '22646174612D636F6E7461696E65722D6964222C742E6964297D2C56742E70726F746F747970652E5F7570646174654F7665726C61793D66756E6374696F6E2865297B76617220742C6E2C693D652E706F736974696F6E2C723D652E68746D6C436F6E74';
wwv_flow_imp.g_varchar2_table(596) := '61696E65722C6F3D652E656C656D656E742C613D692E6C6566742C733D692E746F703B766F69642030213D3D692E7269676874262628743D6F2E776179706F696E74733F4E74286F292E77696474683A6F2E77696474682C613D2D312A692E7269676874';
wwv_flow_imp.g_varchar2_table(597) := '2B74292C766F69642030213D3D692E626F74746F6D2626286E3D6F2E776179706F696E74733F4E74286F292E6865696768743A6F2E6865696768742C733D2D312A692E626F74746F6D2B6E292C247428722C617C7C302C737C7C30292C746869732E5F75';
wwv_flow_imp.g_varchar2_table(598) := '70646174654F7665726C61795669736962696C747928652C746869732E5F63616E7661732E76696577626F782829297D2C56742E70726F746F747970652E5F6372656174654F7665726C6179436F6E7461696E65723D66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(599) := '7220743D516528273C64697620636C6173733D22646A732D6F7665726C61797322202F3E27293B4F6528742C7B706F736974696F6E3A226162736F6C757465227D292C746869732E5F6F7665726C6179526F6F742E617070656E644368696C642874293B';
wwv_flow_imp.g_varchar2_table(600) := '766172206E3D7B68746D6C3A742C656C656D656E743A652C6F7665726C6179733A5B5D7D3B72657475726E20746869732E5F7570646174654F7665726C6179436F6E7461696E6572286E292C746869732E5F6F7665726C6179436F6E7461696E6572732E';
wwv_flow_imp.g_varchar2_table(601) := '70757368286E292C6E7D2C56742E70726F746F747970652E5F757064617465526F6F743D66756E6374696F6E2865297B76617220743D652E7363616C657C7C312C6E3D226D617472697828222B5B742C302C302C742C2D312A652E782A742C2D312A652E';
wwv_flow_imp.g_varchar2_table(602) := '792A745D2E6A6F696E28222C22292B2229223B577428746869732E5F6F7665726C6179526F6F742C6E297D2C56742E70726F746F747970652E5F6765744F7665726C6179436F6E7461696E65723D66756E6374696F6E28652C74297B766172206E3D6428';
wwv_flow_imp.g_varchar2_table(603) := '746869732E5F6F7665726C6179436F6E7461696E6572732C2866756E6374696F6E2874297B72657475726E20742E656C656D656E743D3D3D657D29293B72657475726E206E7C7C743F6E3A746869732E5F6372656174654F7665726C6179436F6E746169';
wwv_flow_imp.g_varchar2_table(604) := '6E65722865297D2C56742E70726F746F747970652E5F6164644F7665726C61793D66756E6374696F6E2865297B76617220742C6E2C693D652E69642C723D652E656C656D656E742C6F3D652E68746D6C3B6F2E67657426266F2E636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(605) := '722E70726F746F747970652E6A71756572792626286F3D6F2E676574283029292C75286F292626286F3D5165286F29292C6E3D746869732E5F6765744F7665726C6179436F6E7461696E65722872292C4F6528743D516528273C64697620636C6173733D';
wwv_flow_imp.g_varchar2_table(606) := '22646A732D6F7665726C61792220646174612D6F7665726C61792D69643D22272B692B27223E27292C7B706F736974696F6E3A226162736F6C757465227D292C742E617070656E644368696C64286F292C652E74797065262649652874292E6164642822';
wwv_flow_imp.g_varchar2_table(607) := '646A732D6F7665726C61792D222B652E74797065292C7A7428742C746869732E5F63616E7661732E66696E64526F6F742872293D3D3D746869732E5F63616E7661732E676574526F6F74456C656D656E742829292C652E68746D6C436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(608) := '3D742C6E2E6F7665726C6179732E707573682865292C6E2E68746D6C2E617070656E644368696C642874292C746869732E5F6F7665726C6179735B695D3D652C746869732E5F7570646174654F7665726C61792865292C746869732E5F7570646174654F';
wwv_flow_imp.g_varchar2_table(609) := '7665726C61795669736962696C747928652C746869732E5F63616E7661732E76696577626F782829297D2C56742E70726F746F747970652E5F7570646174654F7665726C61795669736962696C74793D66756E6374696F6E28652C74297B766172206E3D';
wwv_flow_imp.g_varchar2_table(610) := '652E73686F772C693D746869732E5F63616E7661732E66696E64526F6F7428652E656C656D656E74292C723D6E26266E2E6D696E5A6F6F6D2C6F3D6E26266E2E6D61785A6F6F6D2C733D652E68746D6C436F6E7461696E65722C6C3D21303B2869213D3D';
wwv_flow_imp.g_varchar2_table(611) := '746869732E5F63616E7661732E676574526F6F74456C656D656E7428297C7C6E262628612872292626723E742E7363616C657C7C61286F2926266F3C742E7363616C6529292626286C3D2131292C7A7428732C6C292C746869732E5F7570646174654F76';
wwv_flow_imp.g_varchar2_table(612) := '65726C61795363616C6528652C74297D2C56742E70726F746F747970652E5F7570646174654F7665726C61795363616C653D66756E6374696F6E28652C74297B766172206E2C692C722C6F3D652E7363616C652C733D652E68746D6C436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(613) := '722C6C3D22223B2130213D3D6F26262821313D3D3D6F3F286E3D312C693D31293A286E3D6F2E6D696E2C693D6F2E6D6178292C61286E292626742E7363616C653C6E262628723D28312F742E7363616C657C7C31292A6E292C612869292626742E736361';
wwv_flow_imp.g_varchar2_table(614) := '6C653E69262628723D28312F742E7363616C657C7C31292A6929292C612872292626286C3D227363616C6528222B722B222C222B722B222922292C577428732C6C297D2C56742E70726F746F747970652E5F7570646174654F7665726C61797356697369';
wwv_flow_imp.g_varchar2_table(615) := '62696C74793D66756E6374696F6E2865297B76617220743D746869733B6628746869732E5F6F7665726C6179732C2866756E6374696F6E286E297B742E5F7570646174654F7665726C61795669736962696C7479286E2C65297D29297D2C56742E70726F';
wwv_flow_imp.g_varchar2_table(616) := '746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D746869732E5F6576656E744275732C743D746869733B652E6F6E282263616E7661732E76696577626F782E6368616E67696E67222C2866756E6374696F6E2865297B742E6869';
wwv_flow_imp.g_varchar2_table(617) := '646528297D29292C652E6F6E282263616E7661732E76696577626F782E6368616E676564222C2866756E6374696F6E2865297B766172206E3B6E3D652E76696577626F782C742E5F757064617465526F6F74286E292C742E5F7570646174654F7665726C';
wwv_flow_imp.g_varchar2_table(618) := '6179735669736962696C7479286E292C742E73686F7728297D29292C652E6F6E285B2273686170652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C2866756E6374696F6E2865297B766172206E3D652E656C656D656E743B66';
wwv_flow_imp.g_varchar2_table(619) := '28742E676574287B656C656D656E743A6E7D292C2866756E6374696F6E2865297B742E72656D6F766528652E6964297D29293B76617220693D742E5F6765744F7665726C6179436F6E7461696E6572286E293B69662869297B747428692E68746D6C293B';
wwv_flow_imp.g_varchar2_table(620) := '76617220723D742E5F6F7665726C6179436F6E7461696E6572732E696E6465784F662869293B2D31213D3D722626742E5F6F7665726C6179436F6E7461696E6572732E73706C69636528722C31297D7D29292C652E6F6E2822656C656D656E742E636861';
wwv_flow_imp.g_varchar2_table(621) := '6E676564222C3530302C2866756E6374696F6E2865297B766172206E3D652E656C656D656E742C693D742E5F6765744F7665726C6179436F6E7461696E6572286E2C2130293B692626286628692E6F7665726C6179732C2866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(622) := '742E5F7570646174654F7665726C61792865297D29292C742E5F7570646174654F7665726C6179436F6E7461696E6572286929297D29292C652E6F6E2822656C656D656E742E6D61726B65722E757064617465222C2866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(623) := '72206E3D742E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E742C2130293B6E26264965286E2E68746D6C295B652E6164643F22616464223A2272656D6F7665225D28652E6D61726B6572297D29292C652E6F6E2822726F6F74';
wwv_flow_imp.g_varchar2_table(624) := '2E736574222C2866756E6374696F6E28297B742E5F7570646174654F7665726C6179735669736962696C747928742E5F63616E7661732E76696577626F782829297D29292C652E6F6E28226469616772616D2E636C656172222C746869732E636C656172';
wwv_flow_imp.g_varchar2_table(625) := '2C74686973297D3B636F6E73742047743D7B5F5F696E69745F5F3A5B226F7665726C617973225D2C6F7665726C6179733A5B2274797065222C56745D7D3B66756E6374696F6E20487428652C742C6E2C69297B652E6F6E2822656C656D656E742E636861';
wwv_flow_imp.g_varchar2_table(626) := '6E676564222C2866756E6374696F6E2869297B76617220723D692E656C656D656E743B28722E706172656E747C7C723D3D3D742E676574526F6F74456C656D656E74282929262628692E6766783D6E2E6765744772617068696373287229292C692E6766';
wwv_flow_imp.g_varchar2_table(627) := '782626652E666972652849742872292B222E6368616E676564222C69297D29292C652E6F6E2822656C656D656E74732E6368616E676564222C2866756E6374696F6E2874297B766172206E3D742E656C656D656E74733B6E2E666F724561636828286675';
wwv_flow_imp.g_varchar2_table(628) := '6E6374696F6E2874297B652E666972652822656C656D656E742E6368616E676564222C7B656C656D656E743A747D297D29292C692E757064617465436F6E7461696E6D656E7473286E297D29292C652E6F6E282273686170652E6368616E676564222C28';
wwv_flow_imp.g_varchar2_table(629) := '66756E6374696F6E2865297B692E75706461746528227368617065222C652E656C656D656E742C652E676678297D29292C652E6F6E2822636F6E6E656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B692E7570646174652822636F';
wwv_flow_imp.g_varchar2_table(630) := '6E6E656374696F6E222C652E656C656D656E742C652E676678297D29297D48742E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22656C656D656E745265676973747279222C226772617068696373466163746F7279225D3B63';
wwv_flow_imp.g_varchar2_table(631) := '6F6E7374204B743D7B5F5F696E69745F5F3A5B226368616E6765537570706F7274225D2C6368616E6765537570706F72743A5B2274797065222C48745D7D3B66756E6374696F6E2055742865297B746869732E5F6576656E744275733D657D66756E6374';
wwv_flow_imp.g_varchar2_table(632) := '696F6E2071742865297B72657475726E2066756E6374696F6E28742C6E2C692C722C6F297B28702874297C7C63287429292626286F3D722C723D692C693D6E2C6E3D742C743D6E756C6C292C746869732E6F6E28742C652C6E2C692C722C6F297D7D6675';
wwv_flow_imp.g_varchar2_table(633) := '6E6374696F6E20597428652C74297B742E696E766F6B652855742C74686973292C746869732E6578656375746564282866756E6374696F6E2874297B766172206E3D742E636F6E746578743B6E2E726F6F74456C656D656E743F652E736574526F6F7445';
wwv_flow_imp.g_varchar2_table(634) := '6C656D656E74286E2E726F6F74456C656D656E74293A6E2E726F6F74456C656D656E743D652E676574526F6F74456C656D656E7428297D29292C746869732E726576657274282866756E6374696F6E2874297B766172206E3D742E636F6E746578743B6E';
wwv_flow_imp.g_varchar2_table(635) := '2E726F6F74456C656D656E742626652E736574526F6F74456C656D656E74286E2E726F6F74456C656D656E74297D29297D55742E24696E6A6563743D5B226576656E74427573225D2C55742E70726F746F747970652E6F6E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(636) := '742C6E2C692C722C6F297B69662828702874297C7C63287429292626286F3D722C723D692C693D6E2C6E3D742C743D6E756C6C292C70286E292626286F3D722C723D692C693D6E2C6E3D316533292C6C2872292626286F3D722C723D2131292C21702869';
wwv_flow_imp.g_varchar2_table(637) := '29297468726F77206E6577204572726F72282268616E646C6572466E206D75737420626520612066756E6374696F6E22293B732865297C7C28653D5B655D293B76617220613D746869732E5F6576656E744275733B6628652C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(638) := '297B76617220733D5B22636F6D6D616E64537461636B222C652C745D2E66696C746572282866756E6374696F6E2865297B72657475726E20657D29292E6A6F696E28222E22293B612E6F6E28732C6E2C723F66756E6374696F6E28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(639) := '726E2066756E6374696F6E286E297B72657475726E20652E63616C6C28747C7C6E756C6C2C6E2E636F6E746578742C6E2E636F6D6D616E642C6E297D7D28692C6F293A692C6F297D29297D2C55742E70726F746F747970652E63616E457865637574653D';
wwv_flow_imp.g_varchar2_table(640) := '7174282263616E4578656375746522292C55742E70726F746F747970652E707265457865637574653D717428227072654578656375746522292C55742E70726F746F747970652E70726545786563757465643D7174282270726545786563757465642229';
wwv_flow_imp.g_varchar2_table(641) := '2C55742E70726F746F747970652E657865637574653D717428226578656375746522292C55742E70726F746F747970652E65786563757465643D71742822657865637574656422292C55742E70726F746F747970652E706F7374457865637574653D7174';
wwv_flow_imp.g_varchar2_table(642) := '2822706F73744578656375746522292C55742E70726F746F747970652E706F737445786563757465643D71742822706F7374457865637574656422292C55742E70726F746F747970652E7265766572743D7174282272657665727422292C55742E70726F';
wwv_flow_imp.g_varchar2_table(643) := '746F747970652E72657665727465643D71742822726576657274656422292C6E2859742C5574292C59742E24696E6A6563743D5B2263616E766173222C22696E6A6563746F72225D3B636F6E73742058743D7B5F5F696E69745F5F3A5B22726F6F74456C';
wwv_flow_imp.g_varchar2_table(644) := '656D656E74734265686176696F72225D2C726F6F74456C656D656E74734265686176696F723A5B2274797065222C59745D7D3B766172205A743D7B2226223A2226616D703B222C223C223A22266C743B222C223E223A222667743B222C2722273A222671';
wwv_flow_imp.g_varchar2_table(645) := '756F743B222C2227223A22262333393B227D2C4A743D225F706C616E65223B66756E6374696F6E2051742865297B76617220743D652E69643B72657475726E206B28652C2262706D6E3A53756250726F6365737322293F66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(646) := '657475726E20652B4A747D2874293A747D66756E6374696F6E20656E28652C742C6E297B76617220693D516528273C756C20636C6173733D22626A732D62726561646372756D6273223E3C2F756C3E27292C723D6E2E676574436F6E7461696E65722829';
wwv_flow_imp.g_varchar2_table(647) := '2C6F3D49652872293B722E617070656E644368696C642869293B76617220613D5B5D3B66756E6374696F6E20732865297B65262628613D66756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D4D2865293B6E3B6E3D6E2E24706172656E74';
wwv_flow_imp.g_varchar2_table(648) := '29286B286E2C2262706D6E3A53756250726F6365737322297C7C6B286E2C2262706D6E3A50726F636573732229292626742E70757368286E293B72657475726E20742E7265766572736528297D286529293B76617220723D612E666C61744D6170282866';
wwv_flow_imp.g_varchar2_table(649) := '756E6374696F6E2865297B76617220693D6E2E66696E64526F6F74285174286529297C7C6E2E66696E64526F6F7428652E6964293B696628216926266B28652C2262706D6E3A50726F636573732229297B76617220723D742E66696E64282866756E6374';
wwv_flow_imp.g_varchar2_table(650) := '696F6E2874297B766172206E3D4D2874293B72657475726E206E26266E2E676574282270726F6365737352656622293D3D3D657D29293B693D7226266E2E66696E64526F6F7428722E6964297D69662821692972657475726E5B5D3B766172206F2C613D';
wwv_flow_imp.g_varchar2_table(651) := '286F3D22222B286F3D652E6E616D657C7C652E6964292926266F2E7265706C616365282F5B263C3E22275D2F672C2866756E6374696F6E2865297B72657475726E205A745B655D7D29292C733D516528273C6C693E3C7370616E20636C6173733D22626A';
wwv_flow_imp.g_varchar2_table(652) := '732D6372756D62223E3C61207469746C653D22272B612B27223E272B612B223C2F613E3C2F7370616E3E3C2F6C693E22293B72657475726E20732E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B6E2E7365';
wwv_flow_imp.g_varchar2_table(653) := '74526F6F74456C656D656E742869297D29292C737D29293B692E696E6E657248544D4C3D22223B76617220733D722E6C656E6774683E313B6F2E746F67676C652822626A732D62726561646372756D62732D73686F776E222C73292C722E666F72456163';
wwv_flow_imp.g_varchar2_table(654) := '68282866756E6374696F6E2865297B692E617070656E644368696C642865297D29297D652E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E2865297B76617220743D4D28652E656C656D656E74293B6428612C2866756E6374';
wwv_flow_imp.g_varchar2_table(655) := '696F6E2865297B72657475726E20653D3D3D747D292926267328297D29292C652E6F6E2822726F6F742E736574222C2866756E6374696F6E2865297B7328652E656C656D656E74297D29297D66756E6374696F6E20746E28652C74297B766172206E3D6E';
wwv_flow_imp.g_varchar2_table(656) := '756C6C2C693D6E6577206E6E3B652E6F6E2822726F6F742E736574222C2866756E6374696F6E2865297B76617220723D652E656C656D656E742C6F3D742E76696577626F7828292C613D692E6765742872293B696628692E736574286E2C7B783A6F2E78';
wwv_flow_imp.g_varchar2_table(657) := '2C793A6F2E792C7A6F6F6D3A6F2E7363616C657D292C6E3D722C6B28722C2262706D6E3A53756250726F6365737322297C7C61297B613D617C7C7B783A302C793A302C7A6F6F6D3A317D3B76617220733D286F2E782D612E78292A6F2E7363616C652C6C';
wwv_flow_imp.g_varchar2_table(658) := '3D286F2E792D612E79292A6F2E7363616C653B303D3D3D732626303D3D3D6C7C7C742E7363726F6C6C287B64783A732C64793A6C7D292C612E7A6F6F6D213D3D6F2E7363616C652626742E7A6F6F6D28612E7A6F6F6D2C7B783A302C793A307D297D7D29';
wwv_flow_imp.g_varchar2_table(659) := '292C652E6F6E28226469616772616D2E636C656172222C2866756E6374696F6E28297B692E636C65617228292C6E3D6E756C6C7D29297D66756E6374696F6E206E6E28297B746869732E5F656E74726965733D5B5D2C746869732E7365743D66756E6374';
wwv_flow_imp.g_varchar2_table(660) := '696F6E28652C74297B766172206E3D21313B666F7228766172206920696E20746869732E5F656E747269657329696628746869732E5F656E74726965735B695D5B305D3D3D3D65297B746869732E5F656E74726965735B695D5B315D3D742C6E3D21303B';
wwv_flow_imp.g_varchar2_table(661) := '627265616B7D6E7C7C746869732E5F656E74726965732E70757368285B652C745D297D2C746869732E6765743D66756E6374696F6E2865297B666F7228766172207420696E20746869732E5F656E747269657329696628746869732E5F656E7472696573';
wwv_flow_imp.g_varchar2_table(662) := '5B745D5B305D3D3D3D652972657475726E20746869732E5F656E74726965735B745D5B315D3B72657475726E206E756C6C7D2C746869732E636C6561723D66756E6374696F6E28297B746869732E5F656E74726965732E6C656E6774683D307D2C746869';
wwv_flow_imp.g_varchar2_table(663) := '732E72656D6F76653D66756E6374696F6E2865297B76617220743D2D313B666F7228766172206E20696E20746869732E5F656E747269657329696628746869732E5F656E74726965735B6E5D5B305D3D3D3D65297B743D6E3B627265616B7D2D31213D3D';
wwv_flow_imp.g_varchar2_table(664) := '742626746869732E5F656E74726965732E73706C69636528742C31297D7D656E2E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279222C2263616E766173225D2C746E2E24696E6A6563743D5B226576656E7442';
wwv_flow_imp.g_varchar2_table(665) := '7573222C2263616E766173225D3B66756E6374696F6E20726E28652C74297B746869732E5F6576656E744275733D652C746869732E5F6D6F64646C653D743B766172206E3D746869733B652E6F6E2822696D706F72742E72656E6465722E737461727422';
wwv_flow_imp.g_varchar2_table(666) := '2C313530302C2866756E6374696F6E28652C74297B6E2E5F68616E646C65496D706F727428742E646566696E6974696F6E73297D29297D66756E6374696F6E206F6E2865297B72657475726E206B28652C2262706D6E64693A42504D4E4469616772616D';
wwv_flow_imp.g_varchar2_table(667) := '22293F653A6F6E28652E24706172656E74297D726E2E70726F746F747970652E5F68616E646C65496D706F72743D66756E6374696F6E2865297B696628652E6469616772616D73297B76617220743D746869733B746869732E5F646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(668) := '733D652C746869732E5F70726F63657373546F4469616772616D4D61703D7B7D2C652E6469616772616D732E666F7245616368282866756E6374696F6E2865297B652E706C616E652626652E706C616E652E62706D6E456C656D656E74262628742E5F70';
wwv_flow_imp.g_varchar2_table(669) := '726F63657373546F4469616772616D4D61705B652E706C616E652E62706D6E456C656D656E742E69645D3D65297D29292C652E6469616772616D732E66696C7465722828653D3E652E706C616E6529292E666C61744D61702828653D3E742E5F63726561';
wwv_flow_imp.g_varchar2_table(670) := '74654E65774469616772616D7328652E706C616E652929292E666F7245616368282866756E6374696F6E2865297B742E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E28652E706C616E65297D29297D7D2C726E2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(671) := '652E5F6372656174654E65774469616772616D733D66756E6374696F6E2865297B76617220743D746869732C6E3D5B5D2C693D5B5D3B652E6765742822706C616E65456C656D656E7422292E666F7245616368282866756E6374696F6E2874297B766172';
wwv_flow_imp.g_varchar2_table(672) := '20723D742E62706D6E456C656D656E743B69662872297B766172206F3D722E24706172656E743B6B28722C2262706D6E3A53756250726F636573732229262621742E6973457870616E64656426266E2E707573682872292C66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(673) := '297B766172206E3D652E24706172656E743B72657475726E2128216B286E2C2262706D6E3A53756250726F6365737322297C7C6E3D3D3D742E62706D6E456C656D656E74292626215228652C5B2262706D6E3A44617461496E7075744173736F63696174';
wwv_flow_imp.g_varchar2_table(674) := '696F6E222C2262706D6E3A446174614F75747075744173736F63696174696F6E225D297D28722C65292626692E70757368287B6469456C656D656E743A742C706172656E743A6F7D297D7D29293B76617220723D5B5D3B72657475726E206E2E666F7245';
wwv_flow_imp.g_varchar2_table(675) := '616368282866756E6374696F6E2865297B69662821742E5F70726F63657373546F4469616772616D4D61705B652E69645D297B766172206E3D742E5F6372656174654469616772616D2865293B742E5F70726F63657373546F4469616772616D4D61705B';
wwv_flow_imp.g_varchar2_table(676) := '652E69645D3D6E2C722E70757368286E297D7D29292C692E666F7245616368282866756E6374696F6E2865297B666F722876617220693D652E6469456C656D656E742C723D652E706172656E743B7226262D313D3D3D6E2E696E6465784F662872293B29';
wwv_flow_imp.g_varchar2_table(677) := '723D722E24706172656E743B69662872297B766172206F3D742E5F70726F63657373546F4469616772616D4D61705B722E69645D3B742E5F6D6F7665546F4469506C616E6528692C6F2E706C616E65297D7D29292C727D2C726E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(678) := '2E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E3D66756E6374696F6E2865297B76617220743D652E6765742822706C616E65456C656D656E7422292C6E3D66756E6374696F6E2865297B76617220742C6E3D7B746F703A312F302C72';
wwv_flow_imp.g_varchar2_table(679) := '696768743A2D312F302C626F74746F6D3A2D312F302C6C6566743A312F307D3B72657475726E20652E706C616E65456C656D656E742E666F7245616368282866756E6374696F6E2865297B696628652E626F756E6473297B76617220743D6B7428652E62';
wwv_flow_imp.g_varchar2_table(680) := '6F756E6473293B6E2E746F703D4D6174682E6D696E28742E746F702C6E2E746F70292C6E2E6C6566743D4D6174682E6D696E28742E6C6566742C6E2E6C656674297D7D29292C7B783A28743D6E292E6C6566742C793A742E746F702C77696474683A742E';
wwv_flow_imp.g_varchar2_table(681) := '72696768742D742E6C6566742C6865696768743A742E626F74746F6D2D742E746F707D7D2865292C693D6E2E782D3138302C723D6E2E792D3136303B742E666F7245616368282866756E6374696F6E2865297B652E776179706F696E743F652E77617970';
wwv_flow_imp.g_varchar2_table(682) := '6F696E742E666F7245616368282866756E6374696F6E2865297B652E783D652E782D692C652E793D652E792D727D29293A652E626F756E6473262628652E626F756E64732E783D652E626F756E64732E782D692C652E626F756E64732E793D652E626F75';
wwv_flow_imp.g_varchar2_table(683) := '6E64732E792D72297D29297D2C726E2E70726F746F747970652E5F6D6F7665546F4469506C616E653D66756E6374696F6E28652C74297B766172206E3D6F6E2865292E706C616E652E6765742822706C616E65456C656D656E7422293B6E2E73706C6963';
wwv_flow_imp.g_varchar2_table(684) := '65286E2E696E6465784F662865292C31292C742E6765742822706C616E65456C656D656E7422292E707573682865297D2C726E2E70726F746F747970652E5F6372656174654469616772616D3D66756E6374696F6E2865297B76617220743D746869732E';
wwv_flow_imp.g_varchar2_table(685) := '5F6D6F64646C652E637265617465282262706D6E64693A42504D4E506C616E65222C7B62706D6E456C656D656E743A657D292C6E3D746869732E5F6D6F64646C652E637265617465282262706D6E64693A42504D4E4469616772616D222C7B706C616E65';
wwv_flow_imp.g_varchar2_table(686) := '3A747D293B72657475726E20742E24706172656E743D6E2C742E62706D6E456C656D656E743D652C6E2E24706172656E743D746869732E5F646566696E6974696F6E732C746869732E5F646566696E6974696F6E732E6469616772616D732E7075736828';
wwv_flow_imp.g_varchar2_table(687) := '6E292C6E7D2C726E2E24696E6A6563743D5B226576656E74427573222C226D6F64646C65225D3B76617220616E3D3235303B66756E6374696F6E20736E28652C742C6E2C692C72297B55742E63616C6C28746869732C74292C746869732E5F63616E7661';
wwv_flow_imp.g_varchar2_table(688) := '733D652C746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F6F7665726C6179733D692C746869732E5F7472616E736C6174653D723B766172206F3D746869733B746869732E65786563';
wwv_flow_imp.g_varchar2_table(689) := '75746564282273686170652E746F67676C65436F6C6C61707365222C616E2C2866756E6374696F6E2865297B76617220743D652E73686170653B6F2E5F63616E4472696C6C446F776E2874293F6F2E5F6164644F7665726C61792874293A6F2E5F72656D';
wwv_flow_imp.g_varchar2_table(690) := '6F76654F7665726C61792874297D292C2130292C746869732E7265766572746564282273686170652E746F67676C65436F6C6C61707365222C616E2C2866756E6374696F6E2865297B76617220743D652E73686170653B6F2E5F63616E4472696C6C446F';
wwv_flow_imp.g_varchar2_table(691) := '776E2874293F6F2E5F6164644F7665726C61792874293A6F2E5F72656D6F76654F7665726C61792874297D292C2130292C746869732E6578656375746564285B2273686170652E637265617465222C2273686170652E6D6F7665222C2273686170652E64';
wwv_flow_imp.g_varchar2_table(692) := '656C657465225D2C616E2C2866756E6374696F6E2865297B76617220743D652E6F6C64506172656E742C6E3D652E6E6577506172656E747C7C652E706172656E742C693D652E73686170653B6F2E5F63616E4472696C6C446F776E28692926266F2E5F61';
wwv_flow_imp.g_varchar2_table(693) := '64644F7665726C61792869292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792874292C6F2E5F7570646174654472696C6C646F776E4F7665726C6179286E292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792869297D';
wwv_flow_imp.g_varchar2_table(694) := '292C2130292C746869732E7265766572746564285B2273686170652E637265617465222C2273686170652E6D6F7665222C2273686170652E64656C657465225D2C616E2C2866756E6374696F6E2865297B76617220743D652E6F6C64506172656E742C6E';
wwv_flow_imp.g_varchar2_table(695) := '3D652E6E6577506172656E747C7C652E706172656E742C693D652E73686170653B6F2E5F63616E4472696C6C446F776E28692926266F2E5F6164644F7665726C61792869292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792874292C6F';
wwv_flow_imp.g_varchar2_table(696) := '2E5F7570646174654472696C6C646F776E4F7665726C6179286E292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792869297D292C2130292C742E6F6E2822696D706F72742E72656E6465722E636F6D706C657465222C2866756E637469';
wwv_flow_imp.g_varchar2_table(697) := '6F6E28297B6E2E66696C746572282866756E6374696F6E2865297B72657475726E206F2E5F63616E4472696C6C446F776E2865297D29292E6D6170282866756E6374696F6E2865297B6F2E5F6164644F7665726C61792865297D29297D29297D6E28736E';
wwv_flow_imp.g_varchar2_table(698) := '2C5574292C736E2E70726F746F747970652E5F7570646174654472696C6C646F776E4F7665726C61793D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661733B69662865297B766172206E3D742E66696E64526F6F742865293B6E';
wwv_flow_imp.g_varchar2_table(699) := '2626746869732E5F7570646174654F7665726C61795669736962696C697479286E297D7D2C736E2E70726F746F747970652E5F63616E4472696C6C446F776E3D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661733B7265747572';
wwv_flow_imp.g_varchar2_table(700) := '6E206B28652C2262706D6E3A53756250726F6365737322292626742E66696E64526F6F74285174286529297D2C736E2E70726F746F747970652E5F7570646174654F7665726C61795669736962696C6974793D66756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(701) := '3D746869732E5F6F7665726C6179732C6E3D4D2865292C693D742E676574287B656C656D656E743A6E2E69642C747970653A226472696C6C646F776E227D295B305D3B69662869297B76617220723D6E26266E2E6765742822666C6F77456C656D656E74';
wwv_flow_imp.g_varchar2_table(702) := '73222926266E2E6765742822666C6F77456C656D656E747322292E6C656E6774683B496528692E68746D6C292E746F67676C652822626A732D6472696C6C646F776E2D656D707479222C2172297D7D2C736E2E70726F746F747970652E5F6164644F7665';
wwv_flow_imp.g_varchar2_table(703) := '726C61793D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732C6E3D746869732E5F6F7665726C6179732C693D4D2865293B6E2E676574287B656C656D656E743A652C747970653A226472696C6C646F776E227D292E6C656E67';
wwv_flow_imp.g_varchar2_table(704) := '74682626746869732E5F72656D6F76654F7665726C61792865293B76617220723D516528273C627574746F6E20747970653D22627574746F6E2220636C6173733D22626A732D6472696C6C646F776E223E3C73766720786D6C6E733D22687474703A2F2F';
wwv_flow_imp.g_varchar2_table(705) := '7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C706174682066696C6C2D72756C653D226576656E6F64642220643D224D342E38313830';
wwv_flow_imp.g_varchar2_table(706) := '313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E363839363839342C31302E34393936383934204C332E3735';
wwv_flow_imp.g_varchar2_table(707) := '3733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C332E35303733353933312043342E30353032353235332C332E32';
wwv_flow_imp.g_varchar2_table(708) := '3134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E3C2F627574746F6E3E27292C6F3D692E67657428226E616D6522297C7C692E67657428226964';
wwv_flow_imp.g_varchar2_table(709) := '22292C613D746869732E5F7472616E736C61746528224F70656E207B656C656D656E747D222C7B656C656D656E743A6F7D293B722E73657441747472696275746528227469746C65222C61292C722E6164644576656E744C697374656E65722822636C69';
wwv_flow_imp.g_varchar2_table(710) := '636B222C2866756E6374696F6E28297B742E736574526F6F74456C656D656E7428742E66696E64526F6F7428517428652929297D29292C6E2E61646428652C226472696C6C646F776E222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768';
wwv_flow_imp.g_varchar2_table(711) := '743A2D387D2C68746D6C3A727D292C746869732E5F7570646174654F7665726C61795669736962696C6974792865297D2C736E2E70726F746F747970652E5F72656D6F76654F7665726C61793D66756E6374696F6E2865297B746869732E5F6F7665726C';
wwv_flow_imp.g_varchar2_table(712) := '6179732E72656D6F7665287B656C656D656E743A652C747970653A226472696C6C646F776E227D297D2C736E2E24696E6A6563743D5B2263616E766173222C226576656E74427573222C22656C656D656E745265676973747279222C226F7665726C6179';
wwv_flow_imp.g_varchar2_table(713) := '73222C227472616E736C617465225D3B636F6E7374206C6E3D7B5F5F646570656E64735F5F3A5B47742C4B742C58745D2C5F5F696E69745F5F3A5B226472696C6C646F776E42726561646372756D6273222C226472696C6C646F776E4F7665726C617942';
wwv_flow_imp.g_varchar2_table(714) := '65686176696F72222C226472696C6C646F776E43656E746572696E67222C2273756270726F63657373436F6D7061746962696C697479225D2C6472696C6C646F776E42726561646372756D62733A5B2274797065222C656E5D2C6472696C6C646F776E43';
wwv_flow_imp.g_varchar2_table(715) := '656E746572696E673A5B2274797065222C746E5D2C6472696C6C646F776E4F7665726C61794265686176696F723A5B2274797065222C736E5D2C73756270726F63657373436F6D7061746962696C6974793A5B2274797065222C726E5D7D3B66756E6374';
wwv_flow_imp.g_varchar2_table(716) := '696F6E20636E28652C74297B746869732E5F6576656E744275733D652C746869732E6F66667365743D353B766172206E3D742E636C732822646A732D6F75746C696E65222C5B226E6F2D66696C6C225D292C693D746869733B66756E6374696F6E207228';
wwv_flow_imp.g_varchar2_table(717) := '65297B76617220743D5828227265637422293B72657475726E207A28742C53287B783A302C793A302C72783A342C77696474683A3130302C6865696768743A3130307D2C6E29292C747D652E6F6E285B2273686170652E6164646564222C227368617065';
wwv_flow_imp.g_varchar2_table(718) := '2E6368616E676564225D2C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766782C6F3D657428222E646A732D6F75746C696E65222C6E293B6F7C7C6A286E2C6F3D692E6765744F75746C696E652874297C';
wwv_flow_imp.g_varchar2_table(719) := '7C722829292C692E75706461746553686170654F75746C696E65286F2C74297D29292C652E6F6E285B22636F6E6E656374696F6E2E6164646564222C22636F6E6E656374696F6E2E6368616E676564225D2C2866756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(720) := '3D652E656C656D656E742C6E3D652E6766782C6F3D657428222E646A732D6F75746C696E65222C6E293B6F7C7C6A286E2C6F3D722829292C692E757064617465436F6E6E656374696F6E4F75746C696E65286F2C74297D29297D636E2E70726F746F7479';
wwv_flow_imp.g_varchar2_table(721) := '70652E75706461746553686170654F75746C696E653D66756E6374696F6E28652C74297B766172206E3D21312C693D746869732E5F67657450726F76696465727328293B692E6C656E67746826266628692C2866756E6374696F6E2869297B6E3D6E7C7C';
wwv_flow_imp.g_varchar2_table(722) := '692E7570646174654F75746C696E6528742C65297D29292C6E7C7C7A28652C7B783A2D746869732E6F66667365742C793A2D746869732E6F66667365742C77696474683A742E77696474682B322A746869732E6F66667365742C6865696768743A742E68';
wwv_flow_imp.g_varchar2_table(723) := '65696768742B322A746869732E6F66667365747D297D2C636E2E70726F746F747970652E757064617465436F6E6E656374696F6E4F75746C696E653D66756E6374696F6E28652C74297B766172206E3D4E742874293B7A28652C7B783A6E2E782D746869';
wwv_flow_imp.g_varchar2_table(724) := '732E6F66667365742C793A6E2E792D746869732E6F66667365742C77696474683A6E2E77696474682B322A746869732E6F66667365742C6865696768743A6E2E6865696768742B322A746869732E6F66667365747D297D2C636E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(725) := '2E726567697374657250726F76696465723D66756E6374696F6E28652C74297B747C7C28743D652C653D316533292C746869732E5F6576656E744275732E6F6E28226F75746C696E652E67657450726F766964657273222C652C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(726) := '65297B652E70726F7669646572732E707573682874297D29297D2C636E2E70726F746F747970652E5F67657450726F7669646572733D66756E6374696F6E28297B76617220653D746869732E5F6576656E744275732E6372656174654576656E74287B74';
wwv_flow_imp.g_varchar2_table(727) := '7970653A226F75746C696E652E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E666972652865292C652E70726F7669646572737D2C636E2E70726F746F747970652E6765';
wwv_flow_imp.g_varchar2_table(728) := '744F75746C696E653D66756E6374696F6E2865297B76617220743B72657475726E206628746869732E5F67657450726F76696465727328292C2866756E6374696F6E286E297B70286E2E6765744F75746C696E6529262628743D747C7C6E2E6765744F75';
wwv_flow_imp.g_varchar2_table(729) := '746C696E65286529297D29292C747D2C636E2E24696E6A6563743D5B226576656E74427573222C227374796C6573222C22656C656D656E745265676973747279225D3B636F6E737420706E3D7B5F5F696E69745F5F3A5B226F75746C696E65225D2C6F75';
wwv_flow_imp.g_varchar2_table(730) := '746C696E653A5B2274797065222C636E5D7D2C756E3D7B77696474683A33362C6865696768743A35307D2C686E3D7B77696474683A35302C6865696768743A35307D3B66756E6374696F6E20646E28652C742C6E297B72657475726E2058282270617468';
wwv_flow_imp.g_varchar2_table(731) := '222C7B643A652C7374726F6B6557696474683A322C7472616E73666F726D3A607472616E736C61746528247B742E787D2C20247B742E797D29602C2E2E2E6E7D297D66756E6374696F6E206D6E28652C74297B746869732E5F7374796C65733D742C652E';
wwv_flow_imp.g_varchar2_table(732) := '726567697374657250726F76696465722874686973297D66756E6374696F6E20666E28652C74297B766172206E3B72657475726E2262706D6E3A446174614F626A6563745265666572656E6365223D3D3D743F6E3D756E3A2262706D6E3A446174615374';
wwv_flow_imp.g_varchar2_table(733) := '6F72655265666572656E6365223D3D3D742626286E3D686E292C652E77696474683D3D3D6E2E77696474682626652E6865696768743D3D3D6E2E6865696768747D6D6E2E24696E6A6563743D5B226F75746C696E65222C227374796C6573225D2C6D6E2E';
wwv_flow_imp.g_varchar2_table(734) := '70726F746F747970652E6765744F75746C696E653D66756E6374696F6E2865297B636F6E737420743D746869732E5F7374796C65732E636C732822646A732D6F75746C696E65222C5B226E6F2D66696C6C225D293B766172206E3B696628214374286529';
wwv_flow_imp.g_varchar2_table(735) := '2972657475726E206B28652C2262706D6E3A4761746577617922293F285328286E3D582822726563742229292E7374796C652C7B227472616E73666F726D2D626F78223A2266696C6C2D626F78222C7472616E73666F726D3A22726F7461746528343564';
wwv_flow_imp.g_varchar2_table(736) := '656729222C227472616E73666F726D2D6F726967696E223A2263656E746572227D292C7A286E2C53287B783A322C793A322C72783A342C77696474683A652E77696474682D342C6865696768743A652E6865696768742D347D2C742929293A5228652C5B';
wwv_flow_imp.g_varchar2_table(737) := '2262706D6E3A5461736B222C2262706D6E3A53756250726F63657373222C2262706D6E3A47726F7570222C2262706D6E3A43616C6C4163746976697479225D293F7A286E3D5828227265637422292C53287B783A2D352C793A2D352C72783A31342C7769';
wwv_flow_imp.g_varchar2_table(738) := '6474683A652E77696474682B31302C6865696768743A652E6865696768742B31307D2C7429293A6B28652C2262706D6E3A456E644576656E7422293F7A286E3D582822636972636C6522292C53287B63783A652E77696474682F322C63793A652E686569';
wwv_flow_imp.g_varchar2_table(739) := '6768742F322C723A652E77696474682F322B352B317D2C7429293A6B28652C2262706D6E3A4576656E7422293F7A286E3D582822636972636C6522292C53287B63783A652E77696474682F322C63793A652E6865696768742F322C723A652E7769647468';
wwv_flow_imp.g_varchar2_table(740) := '2F322B357D2C7429293A6B28652C2262706D6E3A446174614F626A6563745265666572656E636522292626666E28652C2262706D6E3A446174614F626A6563745265666572656E636522293F6E3D646E28224D34342E373634382031312E333236334C33';
wwv_flow_imp.g_varchar2_table(741) := '362E3938393220322E36343037344333362E3034353120312E35383632382033342E3536353120302E3938383730382033332E3139303420302E39383837303848352E393836363743332E323236383820302E39383837303820302E3938393632342033';
wwv_flow_imp.g_varchar2_table(742) := '2E333438393220302E39383936323420362E32363033395635352E3032333543302E3938393632342035372E3933343920332E32323638382036302E3239353220352E39383636372036302E323935324834302E3936364334332E373235372036302E32';
wwv_flow_imp.g_varchar2_table(743) := '3935322034352E3936332035372E393334392034352E3936332035352E303233355631342E393435394334352E3936332031332E353939382034352E363430372031322E333034382034342E373634382031312E333236335A222C7B783A2D362C793A2D';
wwv_flow_imp.g_varchar2_table(744) := '367D2C74293A6B28652C2262706D6E3A4461746153746F72655265666572656E636522292626666E28652C2262706D6E3A4461746153746F72655265666572656E636522292626286E3D646E28224D312E30333834352034382E3133343743312E303338';
wwv_flow_imp.g_varchar2_table(745) := '34352034392E3335313120312E30373239352035302E37353820312E33383334322035322E30363443312E36393934392035332E3339333820322E33323432382035342E3731353420332E35363338332035352E3634323843362E30323533332035372E';
wwv_flow_imp.g_varchar2_table(746) := '343834312031302E313136312035382E373638352031342E383231322035392E363036374331392E353737322036302E343533382032352E313338382036302E383733382033302E363833312036302E383733384333362E323237362036302E38373338';
wwv_flow_imp.g_varchar2_table(747) := '2034312E373839312036302E343533382034362E3534352035392E363036374335312E323530342035382E373638372035352E333431322035372E343834322035372E383032382035352E363432394335392E303432342035342E373135362035392E36';
wwv_flow_imp.g_varchar2_table(748) := '3637332035332E333933382035392E393833342035322E3036344336302E323933382035302E373537392036302E333238352034392E3335312036302E333238352034382E313334345631332E383431354336302E333238352031322E36323439203630';
wwv_flow_imp.g_varchar2_table(749) := '2E323933382031312E3231382035392E3938333420392E39313137314335392E3636373320382E35383139342035392E3034323320372E323630322035372E3830323720362E33333239344335352E33343120342E34393136382035312E323530332033';
wwv_flow_imp.g_varchar2_table(750) := '2E32303732332034362E35343520322E33363931344334312E3738393120312E3532322033362E3232373620312E31303230342033302E3638333120312E31303230354332352E3133383820312E31303230362031392E3537373220312E353232303620';
wwv_flow_imp.g_varchar2_table(751) := '31342E3832313320322E33363932334331302E3131363220332E323037333420362E303235343320342E343931383320332E3536333920362E333333313443322E333234333320372E323630333820312E363939353120382E353832303620312E333833';
wwv_flow_imp.g_varchar2_table(752) := '343320392E393131383143312E30373239352031312E3231373920312E30333834352031322E3632343720312E30333834352031332E383431315634382E313334375A222C7B783A2D362C793A2D367D2C7429292C6E7D2C6D6E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(753) := '2E7570646174654F75746C696E653D66756E6374696F6E28652C74297B6966282143742865292972657475726E205228652C5B2262706D6E3A53756250726F63657373222C2262706D6E3A47726F7570225D293F287A28742C7B77696474683A652E7769';
wwv_flow_imp.g_varchar2_table(754) := '6474682B31302C6865696768743A652E6865696768742B31307D292C2130293A21215228652C5B2262706D6E3A4576656E74222C2262706D6E3A47617465776179222C2262706D6E3A4461746153746F72655265666572656E6365222C2262706D6E3A44';
wwv_flow_imp.g_varchar2_table(755) := '6174614F626A6563745265666572656E6365225D297D3B636F6E737420796E3D7B5F5F646570656E64735F5F3A5B706E5D2C5F5F696E69745F5F3A5B226F75746C696E6550726F7669646572225D2C6F75746C696E6550726F76696465723A5B22747970';
wwv_flow_imp.g_varchar2_table(756) := '65222C6D6E5D7D3B66756E6374696F6E20676E2865297B72657475726E20652E6F726967696E616C4576656E747C7C652E7372634576656E747D66756E6374696F6E20766E2865297B72657475726E20652E706F696E746572732626652E706F696E7465';
wwv_flow_imp.g_varchar2_table(757) := '72732E6C656E677468262628653D652E706F696E746572735B305D292C652E746F75636865732626652E746F75636865732E6C656E677468262628653D652E746F75636865735B305D292C653F7B783A652E636C69656E74582C793A652E636C69656E74';
wwv_flow_imp.g_varchar2_table(758) := '597D3A6E756C6C7D66756E6374696F6E20626E28652C74297B72657475726E28676E2865297C7C65292E627574746F6E3D3D3D747D66756E6374696F6E20786E2865297B72657475726E20626E28652C30297D66756E6374696F6E20776E2865297B7265';
wwv_flow_imp.g_varchar2_table(759) := '7475726E21307D66756E6374696F6E205F6E2865297B72657475726E20786E2865297C7C66756E6374696F6E2865297B72657475726E20626E28652C31297D2865297D66756E6374696F6E20456E28652C742C6E297B76617220693D746869733B66756E';
wwv_flow_imp.g_varchar2_table(760) := '6374696F6E2072286E2C692C72297B766172206F2C613B2866756E6374696F6E28652C74297B72657475726E21286C5B655D7C7C786E292874297D29286E2C69297C7C28723F613D742E67657447726170686963732872293A286F3D692E64656C656761';
wwv_flow_imp.g_varchar2_table(761) := '74655461726765747C7C692E74617267657429262628613D6F2C723D742E676574286129292C61262672262621313D3D3D652E66697265286E2C7B656C656D656E743A722C6766783A612C6F726967696E616C4576656E743A697D29262628692E73746F';
wwv_flow_imp.g_varchar2_table(762) := '7050726F7061676174696F6E28292C692E70726576656E7444656661756C74282929297D766172206F3D7B7D3B66756E6374696F6E20612865297B72657475726E206F5B655D7D76617220733D7B636C69636B3A22656C656D656E742E636C69636B222C';
wwv_flow_imp.g_varchar2_table(763) := '636F6E746578746D656E753A22656C656D656E742E636F6E746578746D656E75222C64626C636C69636B3A22656C656D656E742E64626C636C69636B222C6D6F757365646F776E3A22656C656D656E742E6D6F757365646F776E222C6D6F7573656D6F76';
wwv_flow_imp.g_varchar2_table(764) := '653A22656C656D656E742E6D6F7573656D6F7665222C6D6F7573656F7665723A22656C656D656E742E686F766572222C6D6F7573656F75743A22656C656D656E742E6F7574222C6D6F75736575703A22656C656D656E742E6D6F7573657570227D2C6C3D';
wwv_flow_imp.g_varchar2_table(765) := '7B22656C656D656E742E636F6E746578746D656E75223A776E2C22656C656D656E742E6D6F757365646F776E223A5F6E2C22656C656D656E742E6D6F7573657570223A5F6E2C22656C656D656E742E636C69636B223A5F6E2C22656C656D656E742E6462';
wwv_flow_imp.g_varchar2_table(766) := '6C636C69636B223A5F6E7D3B66756E6374696F6E206328652C742C6E2C69297B76617220613D6F5B6E5D3D66756E6374696F6E2865297B72286E2C65297D3B692626286C5B6E5D3D69292C612E2464656C65676174653D58652E62696E6428652C227376';
wwv_flow_imp.g_varchar2_table(767) := '672C202E646A732D656C656D656E74222C742C61297D66756E6374696F6E207028652C742C6E297B76617220693D61286E293B69262658652E756E62696E6428652C742C692E2464656C6567617465297D652E6F6E282263616E7661732E64657374726F';
wwv_flow_imp.g_varchar2_table(768) := '79222C2866756E6374696F6E2865297B76617220743B743D652E7376672C6628732C2866756E6374696F6E28652C6E297B7028742C6E2C65297D29297D29292C652E6F6E282263616E7661732E696E6974222C2866756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(769) := '743B743D652E7376672C6628732C2866756E6374696F6E28652C6E297B6328742C6E2C65297D29297D29292C652E6F6E285B2273686170652E6164646564222C22636F6E6E656374696F6E2E6164646564225D2C2866756E6374696F6E2874297B766172';
wwv_flow_imp.g_varchar2_table(770) := '206E3D742E656C656D656E742C693D742E6766783B652E666972652822696E746572616374696F6E4576656E74732E637265617465486974222C7B656C656D656E743A6E2C6766783A697D297D29292C652E6F6E285B2273686170652E6368616E676564';
wwv_flow_imp.g_varchar2_table(771) := '222C22636F6E6E656374696F6E2E6368616E676564225D2C3530302C2866756E6374696F6E2874297B766172206E3D742E656C656D656E742C693D742E6766783B652E666972652822696E746572616374696F6E4576656E74732E757064617465486974';
wwv_flow_imp.g_varchar2_table(772) := '222C7B656C656D656E743A6E2C6766783A697D297D29292C652E6F6E2822696E746572616374696F6E4576656E74732E637265617465486974222C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766783B';
wwv_flow_imp.g_varchar2_table(773) := '692E63726561746544656661756C7448697428742C6E297D29292C652E6F6E2822696E746572616374696F6E4576656E74732E757064617465486974222C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766783B69';
wwv_flow_imp.g_varchar2_table(774) := '2E75706461746544656661756C7448697428742C6E297D29293B76617220753D6D2822646A732D68697420646A732D6869742D7374726F6B6522292C683D6D2822646A732D68697420646A732D6869742D636C69636B2D7374726F6B6522292C643D7B61';
wwv_flow_imp.g_varchar2_table(775) := '6C6C3A6D2822646A732D68697420646A732D6869742D616C6C22292C22636C69636B2D7374726F6B65223A682C7374726F6B653A752C226E6F2D6D6F7665223A6D2822646A732D68697420646A732D6869742D6E6F2D6D6F766522297D3B66756E637469';
wwv_flow_imp.g_varchar2_table(776) := '6F6E206D28652C74297B72657475726E20743D53287B7374726F6B653A227768697465222C7374726F6B6557696474683A31357D2C747C7C7B7D292C6E2E636C7328652C5B226E6F2D66696C6C222C226E6F2D626F72646572225D2C74297D66756E6374';
wwv_flow_imp.g_varchar2_table(777) := '696F6E207928652C74297B766172206E3D645B745D3B696628216E297468726F77206E6577204572726F722822696E76616C6964206869742074797065203C222B742B223E22293B72657475726E207A28652C6E292C657D66756E6374696F6E20672865';
wwv_flow_imp.g_varchar2_table(778) := '2C74297B6A28652C74297D746869732E72656D6F7665486974733D66756E6374696F6E2865297B662828657C7C646F63756D656E74292E717565727953656C6563746F72416C6C28222E646A732D68697422292C7365297D2C746869732E637265617465';
wwv_flow_imp.g_varchar2_table(779) := '44656661756C744869743D66756E6374696F6E28652C74297B766172206E2C693D652E776179706F696E74732C723D652E69734672616D653B72657475726E20693F746869732E637265617465576179706F696E747348697428742C69293A286E3D723F';
wwv_flow_imp.g_varchar2_table(780) := '227374726F6B65223A22616C6C222C746869732E637265617465426F7848697428742C6E2C7B77696474683A652E77696474682C6865696768743A652E6865696768747D29297D2C746869732E637265617465576179706F696E74734869743D66756E63';
wwv_flow_imp.g_varchar2_table(781) := '74696F6E28652C74297B766172206E3D66652874293B72657475726E2079286E2C227374726F6B6522292C6728652C6E292C6E7D2C746869732E637265617465426F784869743D66756E6374696F6E28652C742C6E297B6E3D53287B783A302C793A307D';
wwv_flow_imp.g_varchar2_table(782) := '2C6E293B76617220693D5828227265637422293B72657475726E207928692C74292C7A28692C6E292C6728652C69292C697D2C746869732E75706461746544656661756C744869743D66756E6374696F6E28652C74297B766172206E3D657428222E646A';
wwv_flow_imp.g_varchar2_table(783) := '732D686974222C74293B6966286E2972657475726E20652E776179706F696E74733F7965286E2C652E776179706F696E7473293A7A286E2C7B77696474683A652E77696474682C6865696768743A652E6865696768747D292C6E7D2C746869732E666972';
wwv_flow_imp.g_varchar2_table(784) := '653D722C746869732E747269676765724D6F7573654576656E743D66756E6374696F6E28652C742C6E297B76617220693D735B655D3B6966282169297468726F77206E6577204572726F722822756E6D617070656420444F4D206576656E74206E616D65';
wwv_flow_imp.g_varchar2_table(785) := '203C222B652B223E22293B72657475726E207228692C742C6E297D2C746869732E6D6F75736548616E646C65723D612C746869732E72656769737465724576656E743D632C746869732E756E72656769737465724576656E743D707D456E2E24696E6A65';
wwv_flow_imp.g_varchar2_table(786) := '63743D5B226576656E74427573222C22656C656D656E745265676973747279222C227374796C6573225D3B636F6E737420536E3D7B5F5F696E69745F5F3A5B22696E746572616374696F6E4576656E7473225D2C696E746572616374696F6E4576656E74';
wwv_flow_imp.g_varchar2_table(787) := '733A5B2274797065222C456E5D7D3B66756E6374696F6E20416E28652C74297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D742C746869732E5F73656C6563746564456C656D656E74733D5B5D3B766172206E3D74686973';
wwv_flow_imp.g_varchar2_table(788) := '3B652E6F6E285B2273686170652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B6E2E646573656C6563742874297D29292C652E6F6E285B2264696167';
wwv_flow_imp.g_varchar2_table(789) := '72616D2E636C656172222C22726F6F742E736574225D2C2866756E6374696F6E2865297B6E2E73656C656374286E756C6C297D29297D416E2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C416E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(790) := '646573656C6563743D66756E6374696F6E2865297B76617220743D746869732E5F73656C6563746564456C656D656E74732C6E3D742E696E6465784F662865293B6966282D31213D3D6E297B76617220693D742E736C69636528293B742E73706C696365';
wwv_flow_imp.g_varchar2_table(791) := '286E2C31292C746869732E5F6576656E744275732E66697265282273656C656374696F6E2E6368616E676564222C7B6F6C6453656C656374696F6E3A692C6E657753656C656374696F6E3A747D297D7D2C416E2E70726F746F747970652E6765743D6675';
wwv_flow_imp.g_varchar2_table(792) := '6E6374696F6E28297B72657475726E20746869732E5F73656C6563746564456C656D656E74737D2C416E2E70726F746F747970652E697353656C65637465643D66756E6374696F6E2865297B72657475726E2D31213D3D746869732E5F73656C65637465';
wwv_flow_imp.g_varchar2_table(793) := '64456C656D656E74732E696E6465784F662865297D2C416E2E70726F746F747970652E73656C6563743D66756E6374696F6E28652C74297B766172206E3D746869732E5F73656C6563746564456C656D656E74732C693D6E2E736C69636528293B732865';
wwv_flow_imp.g_varchar2_table(794) := '297C7C28653D653F5B655D3A5B5D293B76617220723D746869732E5F63616E7661732C6F3D722E676574526F6F74456C656D656E7428293B653D652E66696C746572282866756E6374696F6E2865297B76617220743D722E66696E64526F6F742865293B';
wwv_flow_imp.g_varchar2_table(795) := '72657475726E206F3D3D3D747D29292C743F6628652C2866756E6374696F6E2865297B2D313D3D3D6E2E696E6465784F6628652926266E2E707573682865297D29293A746869732E5F73656C6563746564456C656D656E74733D6E3D652E736C69636528';
wwv_flow_imp.g_varchar2_table(796) := '292C746869732E5F6576656E744275732E66697265282273656C656374696F6E2E6368616E676564222C7B6F6C6453656C656374696F6E3A692C6E657753656C656374696F6E3A6E7D297D3B76617220436E3D22686F766572222C6B6E3D2273656C6563';
wwv_flow_imp.g_varchar2_table(797) := '746564223B66756E6374696F6E20526E28652C742C6E297B746869732E5F63616E7661733D653B76617220693D746869733B66756E6374696F6E207228742C6E297B652E6164644D61726B657228742C6E297D66756E6374696F6E206F28742C6E297B65';
wwv_flow_imp.g_varchar2_table(798) := '2E72656D6F76654D61726B657228742C6E297D746869732E5F6D756C746953656C656374696F6E426F783D6E756C6C2C742E6F6E2822656C656D656E742E686F766572222C2866756E6374696F6E2865297B7228652E656C656D656E742C436E297D2929';
wwv_flow_imp.g_varchar2_table(799) := '2C742E6F6E2822656C656D656E742E6F7574222C2866756E6374696F6E2865297B6F28652E656C656D656E742C436E297D29292C742E6F6E282273656C656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B76617220743D652E6F6C';
wwv_flow_imp.g_varchar2_table(800) := '6453656C656374696F6E2C6E3D652E6E657753656C656374696F6E3B6628742C2866756E6374696F6E2865297B2D313D3D3D6E2E696E6465784F6628652926266F28652C6B6E297D29292C66286E2C2866756E6374696F6E2865297B2D313D3D3D742E69';
wwv_flow_imp.g_varchar2_table(801) := '6E6465784F6628652926267228652C6B6E297D29292C692E5F75706461746553656C656374696F6E4F75746C696E65286E297D29292C742E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E2865297B6E2E697353656C656374';
wwv_flow_imp.g_varchar2_table(802) := '656428652E656C656D656E74292626692E5F75706461746553656C656374696F6E4F75746C696E65286E2E6765742829297D29297D66756E6374696F6E204D6E28652C742C6E2C69297B652E6F6E28226372656174652E656E64222C3530302C2866756E';
wwv_flow_imp.g_varchar2_table(803) := '6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E63616E457865637574652C723D6E2E656C656D656E74732C6F3D286E2E68696E74737C7C7B7D292E6175746F53656C6563743B69662869297B69662821313D3D3D6F2972657475';
wwv_flow_imp.g_varchar2_table(804) := '726E3B73286F293F742E73656C656374286F293A742E73656C65637428722E66696C74657228506E29297D7D29292C652E6F6E2822636F6E6E6563742E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742E63';
wwv_flow_imp.g_varchar2_table(805) := '6F6E6E656374696F6E3B6E2626742E73656C656374286E297D29292C652E6F6E282273686170652E6D6F76652E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E70726576696F757353656C656374696F6E7C7C5B5D2C723D69';
wwv_flow_imp.g_varchar2_table(806) := '2E67657428652E636F6E746578742E73686170652E6964293B64286E2C2866756E6374696F6E2865297B72657475726E20722E69643D3D3D652E69647D29297C7C742E73656C6563742872297D29292C652E6F6E2822656C656D656E742E636C69636B22';
wwv_flow_imp.g_varchar2_table(807) := '2C2866756E6374696F6E2865297B696628786E286529297B76617220693D652E656C656D656E743B693D3D3D6E2E676574526F6F74456C656D656E742829262628693D6E756C6C293B76617220723D742E697353656C65637465642869292C6F3D742E67';
wwv_flow_imp.g_varchar2_table(808) := '657428292E6C656E6774683E312C613D66756E6374696F6E2865297B76617220743D676E2865297C7C653B72657475726E20786E2865292626742E73686966744B65797D2865293B6966287226266F2972657475726E20613F742E646573656C65637428';
wwv_flow_imp.g_varchar2_table(809) := '69293A742E73656C6563742869293B723F742E646573656C6563742869293A742E73656C65637428692C61297D7D29297D66756E6374696F6E20506E2865297B72657475726E21652E68696464656E7D526E2E24696E6A6563743D5B2263616E76617322';
wwv_flow_imp.g_varchar2_table(810) := '2C226576656E74427573222C2273656C656374696F6E225D2C526E2E70726F746F747970652E5F75706461746553656C656374696F6E4F75746C696E653D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732E6765744C617965';
wwv_flow_imp.g_varchar2_table(811) := '72282273656C656374696F6E4F75746C696E6522293B4B2874293B766172206E3D652E6C656E6774683E313B6966284728746869732E5F63616E7661732E676574436F6E7461696E65722829295B6E3F22616464223A2272656D6F7665225D2822646A73';
wwv_flow_imp.g_varchar2_table(812) := '2D6D756C74692D73656C65637422292C6E297B76617220693D66756E6374696F6E2865297B72657475726E7B783A652E782D362C793A652E792D362C77696474683A652E77696474682B31322C6865696768743A652E6865696768742B31327D7D284E74';
wwv_flow_imp.g_varchar2_table(813) := '286529292C723D5828227265637422293B7A28722C53287B72783A337D2C6929292C472872292E6164642822646A732D73656C656374696F6E2D6F75746C696E6522292C6A28742C72297D7D2C4D6E2E24696E6A6563743D5B226576656E74427573222C';
wwv_flow_imp.g_varchar2_table(814) := '2273656C656374696F6E222C2263616E766173222C22656C656D656E745265676973747279225D3B636F6E737420446E3D7B5F5F696E69745F5F3A5B2273656C656374696F6E56697375616C73222C2273656C656374696F6E4265686176696F72225D2C';
wwv_flow_imp.g_varchar2_table(815) := '5F5F646570656E64735F5F3A5B536E2C706E5D2C73656C656374696F6E3A5B2274797065222C416E5D2C73656C656374696F6E56697375616C733A5B2274797065222C526E5D2C73656C656374696F6E4265686176696F723A5B2274797065222C4D6E5D';
wwv_flow_imp.g_varchar2_table(816) := '7D2C426E3D2F5E636C6173735B207B5D2F3B66756E6374696F6E204F6E2865297B72657475726E2041727261792E697341727261792865297D66756E6374696F6E20546E28652C74297B72657475726E204F626A6563742E70726F746F747970652E6861';
wwv_flow_imp.g_varchar2_table(817) := '734F776E50726F70657274792E63616C6C28652C74297D66756E6374696F6E204E6E282E2E2E65297B313D3D3D652E6C656E67746826264F6E28655B305D29262628653D655B305D293B636F6E737420743D28653D5B2E2E2E655D292E706F7028293B72';
wwv_flow_imp.g_varchar2_table(818) := '657475726E20742E24696E6A6563743D652C747D636F6E737420496E3D2F636F6E7374727563746F725C732A5B5E285D2A5C285C732A285B5E295D2A295C292F6D2C4C6E3D2F5E283F3A6173796E635C732B293F283F3A66756E6374696F6E5C732A5B5E';
wwv_flow_imp.g_varchar2_table(819) := '285D2A293F283F3A5C285C732A285B5E295D2A295C297C285C772B29292F6D2C6A6E3D2F5C2F5C2A285B5E2A5D2A295C2A5C2F2F6D3B66756E6374696F6E20466E2865297B6966282266756E6374696F6E22213D747970656F662065297468726F77206E';
wwv_flow_imp.g_varchar2_table(820) := '6577204572726F72286043616E6E6F7420616E6E6F746174652022247B657D222E20457870656374656420612066756E6374696F6E2160293B636F6E737420743D652E746F537472696E6728292E6D617463682866756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(821) := '726E20426E2E7465737428652E746F537472696E672829297D2865293F496E3A4C6E293B69662821742972657475726E5B5D3B636F6E7374206E3D745B315D7C7C745B325D3B72657475726E206E26266E2E73706C697428222C22292E6D61702828653D';
wwv_flow_imp.g_varchar2_table(822) := '3E7B636F6E737420743D652E6D61746368286A6E293B72657475726E28742626745B315D7C7C65292E7472696D28297D29297C7C5B5D7D66756E6374696F6E20566E28652C74297B636F6E7374206E3D747C7C7B6765743A66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(823) := '297B696628692E707573682865292C21313D3D3D742972657475726E206E756C6C3B7468726F77207328604E6F2070726F766964657220666F722022247B657D222160297D7D2C693D5B5D2C723D746869732E5F70726F7669646572733D4F626A656374';
wwv_flow_imp.g_varchar2_table(824) := '2E637265617465286E2E5F70726F7669646572737C7C6E756C6C292C6F3D746869732E5F696E7374616E6365733D4F626A6563742E637265617465286E756C6C292C613D6F2E696E6A6563746F723D746869732C733D66756E6374696F6E2865297B636F';
wwv_flow_imp.g_varchar2_table(825) := '6E737420743D692E6A6F696E2822202D3E2022293B72657475726E20692E6C656E6774683D302C6E6577204572726F7228743F60247B657D20285265736F6C76696E673A20247B747D29603A65297D3B66756E6374696F6E206C28652C74297B69662821';
wwv_flow_imp.g_varchar2_table(826) := '725B655D2626652E696E636C7564657328222E2229297B636F6E737420743D652E73706C697428222E22293B6C6574206E3D6C28742E73686966742829293B666F72283B742E6C656E6774683B296E3D6E5B742E736869667428295D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(827) := '6E7D696628546E286F2C65292972657475726E206F5B655D3B696628546E28722C6529297B6966282D31213D3D692E696E6465784F66286529297468726F7720692E707573682865292C73282243616E6E6F74207265736F6C76652063697263756C6172';
wwv_flow_imp.g_varchar2_table(828) := '20646570656E64656E63792122293B72657475726E20692E707573682865292C6F5B655D3D725B655D5B305D28725B655D5B315D292C692E706F7028292C6F5B655D7D72657475726E206E2E67657428652C74297D66756E6374696F6E206328652C7429';
wwv_flow_imp.g_varchar2_table(829) := '7B696628766F696420303D3D3D74262628743D7B7D292C2266756E6374696F6E22213D747970656F662065297B696628214F6E286529297468726F772073286043616E6E6F7420696E766F6B652022247B657D222E20457870656374656420612066756E';
wwv_flow_imp.g_varchar2_table(830) := '6374696F6E2160293B653D4E6E28652E736C6963652829297D72657475726E7B666E3A652C646570656E64656E636965733A28652E24696E6A6563747C7C466E286529292E6D61702828653D3E546E28742C65293F745B655D3A6C28652929297D7D6675';
wwv_flow_imp.g_varchar2_table(831) := '6E6374696F6E20702865297B636F6E73747B666E3A742C646570656E64656E636965733A6E7D3D632865293B72657475726E206E65772846756E6374696F6E2E70726F746F747970652E62696E642E63616C6C28742C6E756C6C2C2E2E2E6E29297D6675';
wwv_flow_imp.g_varchar2_table(832) := '6E6374696F6E207528652C742C6E297B636F6E73747B666E3A692C646570656E64656E636965733A727D3D6328652C6E293B72657475726E20692E6170706C7928742C72297D66756E6374696F6E20682865297B72657475726E204E6E2828743D3E652E';
wwv_flow_imp.g_varchar2_table(833) := '67657428742929297D66756E6374696F6E206428652C74297B696628742626742E6C656E677468297B636F6E7374206E3D4F626A6563742E637265617465286E756C6C292C693D4F626A6563742E637265617465286E756C6C292C6F3D5B5D2C613D5B5D';
wwv_flow_imp.g_varchar2_table(834) := '2C733D5B5D3B6C6574206C2C632C702C753B666F72286C6574206520696E2072296C3D725B655D2C2D31213D3D742E696E6465784F662865292626282270726976617465223D3D3D6C5B325D3F28633D6F2E696E6465784F66286C5B335D292C2D313D3D';
wwv_flow_imp.g_varchar2_table(835) := '3D633F28703D6C5B335D2E6372656174654368696C64285B5D2C74292C753D682870292C6F2E70757368286C5B335D292C612E707573682870292C732E707573682875292C6E5B655D3D5B752C652C2270726976617465222C705D293A6E5B655D3D5B73';
wwv_flow_imp.g_varchar2_table(836) := '5B635D2C652C2270726976617465222C615B635D5D293A6E5B655D3D5B6C5B325D2C6C5B315D5D2C695B655D3D2130292C22666163746F727922213D3D6C5B325D2626227479706522213D3D6C5B325D7C7C216C5B315D2E2473636F70657C7C742E666F';
wwv_flow_imp.g_varchar2_table(837) := '72456163682828743D3E7B2D31213D3D6C5B315D2E2473636F70652E696E6465784F662874292626286E5B655D3D5B6C5B325D2C6C5B315D5D2C695B745D3D2130297D29293B742E666F72456163682828653D3E7B69662821695B655D297468726F7720';
wwv_flow_imp.g_varchar2_table(838) := '6E6577204572726F7228274E6F2070726F766964657220666F722022272B652B27222E2043616E6E6F74207573652070726F76696465722066726F6D2074686520706172656E742127297D29292C652E756E7368696674286E297D72657475726E206E65';
wwv_flow_imp.g_varchar2_table(839) := '7720566E28652C61297D636F6E7374206D3D7B666163746F72793A752C747970653A702C76616C75653A66756E6374696F6E2865297B72657475726E20657D7D3B66756E6374696F6E206628652C74297B636F6E7374206E3D652E5F5F696E69745F5F7C';
wwv_flow_imp.g_varchar2_table(840) := '7C5B5D3B72657475726E2066756E6374696F6E28297B6E2E666F72456163682828653D3E7B22737472696E67223D3D747970656F6620653F742E6765742865293A742E696E766F6B652865297D29297D7D66756E6374696F6E20792865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(841) := '20743D652E5F5F6578706F7274735F5F3B69662874297B636F6E7374206E3D652E5F5F6D6F64756C65735F5F2C693D4F626A6563742E6B6579732865292E726564756365282828742C6E293D3E28225F5F6578706F7274735F5F22213D3D6E2626225F5F';
wwv_flow_imp.g_varchar2_table(842) := '6D6F64756C65735F5F22213D3D6E2626225F5F696E69745F5F22213D3D6E2626225F5F646570656E64735F5F22213D3D6E262628745B6E5D3D655B6E5D292C7429292C4F626A6563742E637265617465286E756C6C29292C6F3D6428286E7C7C5B5D292E';
wwv_flow_imp.g_varchar2_table(843) := '636F6E636174286929292C613D4E6E282866756E6374696F6E2865297B72657475726E206F2E6765742865297D29293B742E666F7245616368282866756E6374696F6E2865297B725B655D3D5B612C652C2270726976617465222C6F5D7D29293B636F6E';
wwv_flow_imp.g_varchar2_table(844) := '737420733D28652E5F5F696E69745F5F7C7C5B5D292E736C69636528293B72657475726E20732E756E7368696674282866756E6374696F6E28297B6F2E696E697428297D29292C6628653D4F626A6563742E61737369676E287B7D2C652C7B5F5F696E69';
wwv_flow_imp.g_varchar2_table(845) := '745F5F3A737D292C6F297D72657475726E204F626A6563742E6B6579732865292E666F7245616368282866756E6374696F6E2874297B696628225F5F696E69745F5F223D3D3D747C7C225F5F646570656E64735F5F223D3D3D742972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(846) := '6E7374206E3D655B745D3B6966282270726976617465223D3D3D6E5B325D2972657475726E20766F696428725B745D3D6E293B636F6E737420693D6E5B305D2C6F3D6E5B315D3B725B745D3D5B6D5B695D2C246E28692C6F292C695D7D29292C6628652C';
wwv_flow_imp.g_varchar2_table(847) := '61297D66756E6374696F6E206728652C74297B72657475726E2D31213D3D652E696E6465784F662874297C7C2D31213D3D28653D28742E5F5F646570656E64735F5F7C7C5B5D292E72656475636528672C6529292E696E6465784F662874293F653A652E';
wwv_flow_imp.g_varchar2_table(848) := '636F6E6361742874297D746869732E6765743D6C2C746869732E696E766F6B653D752C746869732E696E7374616E74696174653D702C746869732E6372656174654368696C643D642C746869732E696E69743D66756E6374696F6E2865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(849) := '20743D652E72656475636528672C5B5D292E6D61702879293B6C6574206E3D21313B72657475726E2066756E6374696F6E28297B6E7C7C286E3D21302C742E666F72456163682828653D3E6528292929297D7D2865297D66756E6374696F6E20246E2865';
wwv_flow_imp.g_varchar2_table(850) := '2C74297B72657475726E2276616C756522213D3D6526264F6E287429262628743D4E6E28742E736C696365282929292C747D66756E6374696F6E207A6E28652C74297B432E63616C6C28746869732C652C31292C746869732E434F4E4E454354494F4E5F';
wwv_flow_imp.g_varchar2_table(851) := '5354594C453D742E7374796C65285B226E6F2D66696C6C225D2C7B7374726F6B6557696474683A352C7374726F6B653A2266756368736961227D292C746869732E53484150455F5354594C453D742E7374796C65287B66696C6C3A227768697465222C73';
wwv_flow_imp.g_varchar2_table(852) := '74726F6B653A2266756368736961222C7374726F6B6557696474683A327D292C746869732E4652414D455F5354594C453D742E7374796C65285B226E6F2D66696C6C225D2C7B7374726F6B653A2266756368736961222C7374726F6B6544617368617272';
wwv_flow_imp.g_varchar2_table(853) := '61793A342C7374726F6B6557696474683A327D297D6E287A6E2C43292C7A6E2E70726F746F747970652E63616E52656E6465723D66756E6374696F6E28297B72657475726E21307D2C7A6E2E70726F746F747970652E6472617753686170653D66756E63';
wwv_flow_imp.g_varchar2_table(854) := '74696F6E28652C742C6E297B76617220693D5828227265637422293B72657475726E207A28692C7B783A302C793A302C77696474683A742E77696474687C7C302C6865696768743A742E6865696768747C7C307D292C4C742874293F7A28692C53287B7D';
wwv_flow_imp.g_varchar2_table(855) := '2C746869732E4652414D455F5354594C452C6E7C7C7B7D29293A7A28692C53287B7D2C746869732E53484150455F5354594C452C6E7C7C7B7D29292C6A28652C69292C697D2C7A6E2E70726F746F747970652E64726177436F6E6E656374696F6E3D6675';
wwv_flow_imp.g_varchar2_table(856) := '6E6374696F6E28652C742C6E297B76617220693D666528742E776179706F696E74732C53287B7D2C746869732E434F4E4E454354494F4E5F5354594C452C6E7C7C7B7D29293B72657475726E206A28652C69292C697D2C7A6E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(857) := '6765745368617065506174683D66756E6374696F6E2865297B76617220743D652E782C6E3D652E792C693D652E77696474683B72657475726E207065285B5B224D222C742C6E5D2C5B226C222C692C305D2C5B226C222C302C652E6865696768745D2C5B';
wwv_flow_imp.g_varchar2_table(858) := '226C222C2D692C305D2C5B227A225D5D297D2C7A6E2E70726F746F747970652E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B76617220742C6E2C693D652E776179706F696E74732C723D5B5D3B666F7228743D303B6E3D69';
wwv_flow_imp.g_varchar2_table(859) := '5B745D3B742B2B296E3D6E2E6F726967696E616C7C7C6E2C722E70757368285B303D3D3D743F224D223A224C222C6E2E782C6E2E795D293B72657475726E2070652872297D2C7A6E2E24696E6A6563743D5B226576656E74427573222C227374796C6573';
wwv_flow_imp.g_varchar2_table(860) := '225D3B636F6E737420576E3D7B5F5F696E69745F5F3A5B2264656661756C7452656E6465726572225D2C64656661756C7452656E64657265723A5B2274797065222C7A6E5D2C7374796C65733A5B2274797065222C66756E6374696F6E28297B76617220';
wwv_flow_imp.g_varchar2_table(861) := '653D7B226E6F2D66696C6C223A7B66696C6C3A226E6F6E65227D2C226E6F2D626F72646572223A7B7374726F6B654F7061636974793A307D2C226E6F2D6576656E7473223A7B706F696E7465724576656E74733A226E6F6E65227D7D2C743D746869733B';
wwv_flow_imp.g_varchar2_table(862) := '746869732E636C733D66756E6374696F6E28652C742C6E297B72657475726E205328746869732E7374796C6528742C6E292C7B636C6173733A657D297D2C746869732E7374796C653D66756E6374696F6E28742C6E297B732874297C7C6E7C7C286E3D74';
wwv_flow_imp.g_varchar2_table(863) := '2C743D5B5D293B76617220693D7928742C2866756E6374696F6E28742C6E297B72657475726E205328742C655B6E5D7C7C7B7D297D292C7B7D293B72657475726E206E3F5328692C6E293A697D2C746869732E636F6D707574655374796C653D66756E63';
wwv_flow_imp.g_varchar2_table(864) := '74696F6E28652C6E2C69297B72657475726E2073286E297C7C28693D6E2C6E3D5B5D292C742E7374796C65286E7C7C5B5D2C53287B7D2C692C657C7C7B7D29297D7D5D7D3B66756E6374696F6E20476E28652C74297B72657475726E204D6174682E726F';
wwv_flow_imp.g_varchar2_table(865) := '756E6428652A74292F747D66756E6374696F6E20486E2865297B72657475726E20632865293F652B227078223A657D66756E6374696F6E204B6E28652C742C6E297B636F6E737420693D5828226722293B472869292E6164642874293B636F6E73742072';
wwv_flow_imp.g_varchar2_table(866) := '3D766F69642030213D3D6E3F6E3A652E6368696C644E6F6465732E6C656E6774682D313B72657475726E20652E696E736572744265666F726528692C652E6368696C644E6F6465735B725D7C7C6E756C6C292C697D636F6E737420556E3D7B7368617065';
wwv_flow_imp.g_varchar2_table(867) := '3A5B2278222C2279222C227769647468222C22686569676874225D2C636F6E6E656374696F6E3A5B22776179706F696E7473225D7D3B66756E6374696F6E20716E28652C742C6E2C69297B746869732E5F6576656E744275733D742C746869732E5F656C';
wwv_flow_imp.g_varchar2_table(868) := '656D656E7452656769737472793D692C746869732E5F6772617068696373466163746F72793D6E2C746869732E5F726F6F74734964783D302C746869732E5F6C61796572733D7B7D2C746869732E5F706C616E65733D5B5D2C746869732E5F726F6F7445';
wwv_flow_imp.g_varchar2_table(869) := '6C656D656E743D6E756C6C2C746869732E5F696E697428657C7C7B7D297D66756E6374696F6E20596E28652C74297B636F6E7374206E3D226D617472697828222B742E612B222C222B742E622B222C222B742E632B222C222B742E642B222C222B742E65';
wwv_flow_imp.g_varchar2_table(870) := '2B222C222B742E662B2229223B652E73657441747472696275746528227472616E73666F726D222C6E297D716E2E24696E6A6563743D5B22636F6E6669672E63616E766173222C226576656E74427573222C226772617068696373466163746F7279222C';
wwv_flow_imp.g_varchar2_table(871) := '22656C656D656E745265676973747279225D2C716E2E70726F746F747970652E5F696E69743D66756E6374696F6E2865297B636F6E737420743D746869732E5F6576656E744275732C6E3D746869732E5F636F6E7461696E65723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(872) := '65297B636F6E737420743D28653D53287B7D2C7B77696474683A2231303025222C6865696768743A2231303025227D2C6529292E636F6E7461696E65727C7C646F63756D656E742E626F64792C6E3D646F63756D656E742E637265617465456C656D656E';
wwv_flow_imp.g_varchar2_table(873) := '74282264697622293B72657475726E206E2E7365744174747269627574652822636C617373222C22646A732D636F6E7461696E657220646A732D706172656E7422292C4F65286E2C7B706F736974696F6E3A2272656C6174697665222C6F766572666C6F';
wwv_flow_imp.g_varchar2_table(874) := '773A2268696464656E222C77696474683A486E28652E7769647468292C6865696768743A486E28652E686569676874297D292C742E617070656E644368696C64286E292C6E7D2865292C693D746869732E5F7376673D58282273766722293B7A28692C7B';
wwv_flow_imp.g_varchar2_table(875) := '77696474683A2231303025222C6865696768743A2231303025227D292C6A286E2C69293B636F6E737420723D746869732E5F76696577706F72743D4B6E28692C2276696577706F727422293B652E6465666572557064617465262628746869732E5F7669';
wwv_flow_imp.g_varchar2_table(876) := '6577626F784368616E6765643D66756E6374696F6E28652C74297B6C6574206E2C692C722C6F3B66756E6374696F6E2061286E297B6C657420613D446174652E6E6F7728292C633D6E3F303A6F2B742D613B696628633E302972657475726E2073286329';
wwv_flow_imp.g_varchar2_table(877) := '3B652E6170706C7928722C69292C6C28297D66756E6374696F6E20732865297B6E3D73657454696D656F757428612C65297D66756E6374696F6E206C28297B6E2626636C65617254696D656F7574286E292C6E3D6F3D693D723D766F696420307D66756E';
wwv_flow_imp.g_varchar2_table(878) := '6374696F6E2063282E2E2E65297B6F3D446174652E6E6F7728292C693D652C723D746869732C6E7C7C732874297D72657475726E20632E666C7573683D66756E6374696F6E28297B6E262661282130292C6C28297D2C632E63616E63656C3D6C2C637D28';
wwv_flow_imp.g_varchar2_table(879) := '4528746869732E5F76696577626F784368616E6765642C74686973292C33303029292C742E6F6E28226469616772616D2E696E6974222C2828293D3E7B742E66697265282263616E7661732E696E6974222C7B7376673A692C76696577706F72743A727D';
wwv_flow_imp.g_varchar2_table(880) := '297D29292C742E6F6E285B2273686170652E6164646564222C22636F6E6E656374696F6E2E6164646564222C2273686170652E72656D6F766564222C22636F6E6E656374696F6E2E72656D6F766564222C22656C656D656E74732E6368616E676564222C';
wwv_flow_imp.g_varchar2_table(881) := '22726F6F742E736574225D2C2828293D3E7B64656C65746520746869732E5F63616368656456696577626F787D29292C742E6F6E28226469616772616D2E64657374726F79222C3530302C746869732E5F64657374726F792C74686973292C742E6F6E28';
wwv_flow_imp.g_varchar2_table(882) := '226469616772616D2E636C656172222C3530302C746869732E5F636C6561722C74686973297D2C716E2E70726F746F747970652E5F64657374726F793D66756E6374696F6E28297B746869732E5F6576656E744275732E66697265282263616E7661732E';
wwv_flow_imp.g_varchar2_table(883) := '64657374726F79222C7B7376673A746869732E5F7376672C76696577706F72743A746869732E5F76696577706F72747D293B636F6E737420653D746869732E5F636F6E7461696E65722E706172656E744E6F64653B652626652E72656D6F76654368696C';
wwv_flow_imp.g_varchar2_table(884) := '6428746869732E5F636F6E7461696E6572292C64656C65746520746869732E5F7376672C64656C65746520746869732E5F636F6E7461696E65722C64656C65746520746869732E5F6C61796572732C64656C65746520746869732E5F706C616E65732C64';
wwv_flow_imp.g_varchar2_table(885) := '656C65746520746869732E5F726F6F74456C656D656E742C64656C65746520746869732E5F76696577706F72747D2C716E2E70726F746F747970652E5F636C6561723D66756E6374696F6E28297B746869732E5F656C656D656E7452656769737472792E';
wwv_flow_imp.g_varchar2_table(886) := '676574416C6C28292E666F72456163682828653D3E7B636F6E737420743D49742865293B22726F6F74223D3D3D743F746869732E72656D6F7665526F6F74456C656D656E742865293A746869732E5F72656D6F7665456C656D656E7428652C74297D2929';
wwv_flow_imp.g_varchar2_table(887) := '2C746869732E5F706C616E65733D5B5D2C746869732E5F726F6F74456C656D656E743D6E756C6C2C64656C65746520746869732E5F63616368656456696577626F787D2C716E2E70726F746F747970652E67657444656661756C744C617965723D66756E';
wwv_flow_imp.g_varchar2_table(888) := '6374696F6E28297B72657475726E20746869732E6765744C61796572282262617365222C30297D2C716E2E70726F746F747970652E6765744C617965723D66756E6374696F6E28652C74297B6966282165297468726F77206E6577204572726F7228226D';
wwv_flow_imp.g_varchar2_table(889) := '75737420737065636966792061206E616D6522293B6C6574206E3D746869732E5F6C61796572735B655D3B6966286E7C7C286E3D746869732E5F6C61796572735B655D3D746869732E5F6372656174654C6179657228652C7429292C766F69642030213D';
wwv_flow_imp.g_varchar2_table(890) := '3D7426266E2E696E646578213D3D74297468726F77206E6577204572726F7228226C61796572203C222B652B223E20616C7265616479206372656174656420617420696E646578203C222B742B223E22293B72657475726E206E2E67726F75707D2C716E';
wwv_flow_imp.g_varchar2_table(891) := '2E70726F746F747970652E5F6765744368696C64496E6465783D66756E6374696F6E2865297B72657475726E207928746869732E5F6C61796572732C2866756E6374696F6E28742C6E297B72657475726E206E2E76697369626C652626653E3D6E2E696E';
wwv_flow_imp.g_varchar2_table(892) := '6465782626742B2B2C747D292C30297D2C716E2E70726F746F747970652E5F6372656174654C617965723D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D31293B636F6E7374206E3D746869732E5F6765744368696C64496E64';
wwv_flow_imp.g_varchar2_table(893) := '65782874293B72657475726E7B67726F75703A4B6E28746869732E5F76696577706F72742C226C617965722D222B652C6E292C696E6465783A742C76697369626C653A21307D7D2C716E2E70726F746F747970652E73686F774C617965723D66756E6374';
wwv_flow_imp.g_varchar2_table(894) := '696F6E2865297B6966282165297468726F77206E6577204572726F7228226D75737420737065636966792061206E616D6522293B636F6E737420743D746869732E5F6C61796572735B655D3B6966282174297468726F77206E6577204572726F7228226C';
wwv_flow_imp.g_varchar2_table(895) := '61796572203C222B652B223E20646F6573206E6F7420657869737422293B636F6E7374206E3D746869732E5F76696577706F72742C693D742E67726F75702C723D742E696E6465783B696628742E76697369626C652972657475726E20693B636F6E7374';
wwv_flow_imp.g_varchar2_table(896) := '206F3D746869732E5F6765744368696C64496E6465782872293B72657475726E206E2E696E736572744265666F726528692C6E2E6368696C644E6F6465735B6F5D7C7C6E756C6C292C742E76697369626C653D21302C697D2C716E2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(897) := '652E686964654C617965723D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F7228226D75737420737065636966792061206E616D6522293B636F6E737420743D746869732E5F6C61796572735B655D3B69662821742974';
wwv_flow_imp.g_varchar2_table(898) := '68726F77206E6577204572726F7228226C61796572203C222B652B223E20646F6573206E6F7420657869737422293B636F6E7374206E3D742E67726F75703B72657475726E20742E76697369626C653F287365286E292C742E76697369626C653D21312C';
wwv_flow_imp.g_varchar2_table(899) := '6E293A6E7D2C716E2E70726F746F747970652E5F72656D6F76654C617965723D66756E6374696F6E2865297B636F6E737420743D746869732E5F6C61796572735B655D3B7426262864656C65746520746869732E5F6C61796572735B655D2C736528742E';
wwv_flow_imp.g_varchar2_table(900) := '67726F757029297D2C716E2E70726F746F747970652E6765744163746976654C617965723D66756E6374696F6E28297B636F6E737420653D746869732E5F66696E64506C616E65466F72526F6F7428746869732E676574526F6F74456C656D656E742829';
wwv_flow_imp.g_varchar2_table(901) := '293B72657475726E20653F652E6C617965723A6E756C6C7D2C716E2E70726F746F747970652E66696E64526F6F743D66756E6374696F6E2865297B69662822737472696E67223D3D747970656F662065262628653D746869732E5F656C656D656E745265';
wwv_flow_imp.g_varchar2_table(902) := '6769737472792E676574286529292C21652972657475726E3B636F6E737420743D746869732E5F66696E64506C616E65466F72526F6F742866756E6374696F6E2865297B666F72283B652E706172656E743B29653D652E706172656E743B72657475726E';
wwv_flow_imp.g_varchar2_table(903) := '20657D286529297C7C7B7D3B72657475726E20742E726F6F74456C656D656E747D2C716E2E70726F746F747970652E676574526F6F74456C656D656E74733D66756E6374696F6E28297B72657475726E20746869732E5F706C616E65732E6D6170282866';
wwv_flow_imp.g_varchar2_table(904) := '756E6374696F6E2865297B72657475726E20652E726F6F74456C656D656E747D29297D2C716E2E70726F746F747970652E5F66696E64506C616E65466F72526F6F743D66756E6374696F6E2865297B72657475726E206428746869732E5F706C616E6573';
wwv_flow_imp.g_varchar2_table(905) := '2C2866756E6374696F6E2874297B72657475726E20742E726F6F74456C656D656E743D3D3D657D29297D2C716E2E70726F746F747970652E676574436F6E7461696E65723D66756E6374696F6E28297B72657475726E20746869732E5F636F6E7461696E';
wwv_flow_imp.g_varchar2_table(906) := '65727D2C716E2E70726F746F747970652E5F7570646174654D61726B65723D66756E6374696F6E28652C742C6E297B6C657420693B652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C652E6D61726B6572';
wwv_flow_imp.g_varchar2_table(907) := '733D652E6D61726B6572737C7C6E6577205365742C693D746869732E5F656C656D656E7452656769737472792E5F656C656D656E74735B652E69645D2C6926262866285B692E6766782C692E7365636F6E646172794766785D2C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(908) := '69297B692626286E3F28652E6D61726B6572732E6164642874292C472869292E616464287429293A28652E6D61726B6572732E64656C6574652874292C472869292E72656D6F766528742929297D29292C746869732E5F6576656E744275732E66697265';
wwv_flow_imp.g_varchar2_table(909) := '2822656C656D656E742E6D61726B65722E757064617465222C7B656C656D656E743A652C6766783A692E6766782C6D61726B65723A742C6164643A21216E7D29297D2C716E2E70726F746F747970652E6164644D61726B65723D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(910) := '2C74297B746869732E5F7570646174654D61726B657228652C742C2130297D2C716E2E70726F746F747970652E72656D6F76654D61726B65723D66756E6374696F6E28652C74297B746869732E5F7570646174654D61726B657228652C742C2131297D2C';
wwv_flow_imp.g_varchar2_table(911) := '716E2E70726F746F747970652E6861734D61726B65723D66756E6374696F6E28652C74297B72657475726E20652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C2121652E6D61726B6572732626652E6D61';
wwv_flow_imp.g_varchar2_table(912) := '726B6572732E6861732874297D2C716E2E70726F746F747970652E746F67676C654D61726B65723D66756E6374696F6E28652C74297B746869732E6861734D61726B657228652C74293F746869732E72656D6F76654D61726B657228652C74293A746869';
wwv_flow_imp.g_varchar2_table(913) := '732E6164644D61726B657228652C74297D2C716E2E70726F746F747970652E676574526F6F74456C656D656E743D66756E6374696F6E28297B636F6E737420653D746869732E5F726F6F74456C656D656E743B72657475726E20657C7C746869732E5F70';
wwv_flow_imp.g_varchar2_table(914) := '6C616E65732E6C656E6774683F653A746869732E736574526F6F74456C656D656E7428746869732E616464526F6F74456C656D656E74286E756C6C29297D2C716E2E70726F746F747970652E616464526F6F74456C656D656E743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(915) := '65297B636F6E737420743D746869732E5F726F6F74734964782B2B3B657C7C28653D7B69643A225F5F696D706C69636974726F6F745F222B742C6368696C6472656E3A5B5D2C6973496D706C696369743A21307D293B636F6E7374206E3D652E6C617965';
wwv_flow_imp.g_varchar2_table(916) := '723D22726F6F742D222B743B746869732E5F656E7375726556616C69642822726F6F74222C65293B636F6E737420693D746869732E6765744C61796572286E2C30293B72657475726E20746869732E686964654C61796572286E292C746869732E5F6164';
wwv_flow_imp.g_varchar2_table(917) := '64526F6F7428652C69292C746869732E5F706C616E65732E70757368287B726F6F74456C656D656E743A652C6C617965723A697D292C657D2C716E2E70726F746F747970652E72656D6F7665526F6F74456C656D656E743D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(918) := '69662822737472696E67223D3D747970656F662065262628653D746869732E5F656C656D656E7452656769737472792E676574286529292C746869732E5F66696E64506C616E65466F72526F6F742865292972657475726E20746869732E5F72656D6F76';
wwv_flow_imp.g_varchar2_table(919) := '65526F6F742865292C746869732E5F72656D6F76654C6179657228652E6C61796572292C746869732E5F706C616E65733D746869732E5F706C616E65732E66696C746572282866756E6374696F6E2874297B72657475726E20742E726F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(920) := '6E74213D3D657D29292C746869732E5F726F6F74456C656D656E743D3D3D65262628746869732E5F726F6F74456C656D656E743D6E756C6C292C657D2C716E2E70726F746F747970652E736574526F6F74456C656D656E743D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(921) := '7B696628653D3D3D746869732E5F726F6F74456C656D656E742972657475726E20653B6C657420743B6966282165297468726F77206E6577204572726F722822726F6F74456C656D656E7420726571756972656422293B72657475726E20743D74686973';
wwv_flow_imp.g_varchar2_table(922) := '2E5F66696E64506C616E65466F72526F6F742865292C747C7C28653D746869732E616464526F6F74456C656D656E74286529292C746869732E5F736574526F6F742865292C657D2C716E2E70726F746F747970652E5F72656D6F7665526F6F743D66756E';
wwv_flow_imp.g_varchar2_table(923) := '6374696F6E2865297B636F6E737420743D746869732E5F656C656D656E7452656769737472792C6E3D746869732E5F6576656E744275733B6E2E666972652822726F6F742E72656D6F7665222C7B656C656D656E743A657D292C6E2E666972652822726F';
wwv_flow_imp.g_varchar2_table(924) := '6F742E72656D6F766564222C7B656C656D656E743A657D292C742E72656D6F76652865297D2C716E2E70726F746F747970652E5F616464526F6F743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F656C656D656E745265676973';
wwv_flow_imp.g_varchar2_table(925) := '7472792C693D746869732E5F6576656E744275733B692E666972652822726F6F742E616464222C7B656C656D656E743A657D292C6E2E61646428652C74292C692E666972652822726F6F742E6164646564222C7B656C656D656E743A652C6766783A747D';
wwv_flow_imp.g_varchar2_table(926) := '297D2C716E2E70726F746F747970652E5F736574526F6F743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F726F6F74456C656D656E743B6E262628746869732E5F656C656D656E7452656769737472792E757064617465477261';
wwv_flow_imp.g_varchar2_table(927) := '7068696373286E2C6E756C6C2C2130292C746869732E686964654C61796572286E2E6C6179657229292C65262628747C7C28743D746869732E5F66696E64506C616E65466F72526F6F742865292E6C61796572292C746869732E5F656C656D656E745265';
wwv_flow_imp.g_varchar2_table(928) := '6769737472792E757064617465477261706869637328652C746869732E5F7376672C2130292C746869732E73686F774C6179657228652E6C6179657229292C746869732E5F726F6F74456C656D656E743D652C746869732E5F6576656E744275732E6669';
wwv_flow_imp.g_varchar2_table(929) := '72652822726F6F742E736574222C7B656C656D656E743A657D297D2C716E2E70726F746F747970652E5F656E7375726556616C69643D66756E6374696F6E28652C74297B69662821742E6964297468726F77206E6577204572726F722822656C656D656E';
wwv_flow_imp.g_varchar2_table(930) := '74206D757374206861766520616E20696422293B696628746869732E5F656C656D656E7452656769737472792E67657428742E696429297468726F77206E6577204572726F722822656C656D656E74203C222B742E69642B223E20616C72656164792065';
wwv_flow_imp.g_varchar2_table(931) := '786973747322293B636F6E7374206E3D556E5B655D2C693D67286E2C2866756E6374696F6E2865297B72657475726E20766F69642030213D3D745B655D7D29293B6966282169297468726F77206E6577204572726F7228226D75737420737570706C7920';
wwv_flow_imp.g_varchar2_table(932) := '7B20222B6E2E6A6F696E28222C2022292B22207D207769746820222B65297D2C716E2E70726F746F747970652E5F736574506172656E743D66756E6374696F6E28652C742C6E297B2166756E6374696F6E28652C742C6E297B69662865262674297B226E';
wwv_flow_imp.g_varchar2_table(933) := '756D62657222213D747970656F66206E2626286E3D2D31293B76617220693D652E696E6465784F662874293B6966282D31213D3D69297B696628693D3D3D6E2972657475726E3B6966282D313D3D3D6E2972657475726E3B652E73706C69636528692C31';
wwv_flow_imp.g_varchar2_table(934) := '297D2D31213D3D6E3F652E73706C696365286E2C302C74293A652E707573682874297D7D28742E6368696C6472656E2C652C6E292C652E706172656E743D747D2C716E2E70726F746F747970652E5F616464456C656D656E743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(935) := '2C742C6E2C69297B6E3D6E7C7C746869732E676574526F6F74456C656D656E7428293B636F6E737420723D746869732E5F6576656E744275732C6F3D746869732E5F6772617068696373466163746F72793B746869732E5F656E7375726556616C696428';
wwv_flow_imp.g_varchar2_table(936) := '652C74292C722E6669726528652B222E616464222C7B656C656D656E743A742C706172656E743A6E7D292C746869732E5F736574506172656E7428742C6E2C69293B636F6E737420613D6F2E63726561746528652C742C69293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(937) := '732E5F656C656D656E7452656769737472792E61646428742C61292C6F2E75706461746528652C742C61292C722E6669726528652B222E6164646564222C7B656C656D656E743A742C6766783A617D292C747D2C716E2E70726F746F747970652E616464';
wwv_flow_imp.g_varchar2_table(938) := '53686170653D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F616464456C656D656E7428227368617065222C652C742C6E297D2C716E2E70726F746F747970652E616464436F6E6E656374696F6E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(939) := '742C6E297B72657475726E20746869732E5F616464456C656D656E742822636F6E6E656374696F6E222C652C742C6E297D2C716E2E70726F746F747970652E5F72656D6F7665456C656D656E743D66756E6374696F6E28652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(940) := '746869732E5F656C656D656E7452656769737472792C693D746869732E5F6772617068696373466163746F72792C723D746869732E5F6576656E744275733B696628653D6E2E67657428652E69647C7C65292972657475726E20722E6669726528742B22';
wwv_flow_imp.g_varchar2_table(941) := '2E72656D6F7665222C7B656C656D656E743A657D292C692E72656D6F76652865292C66756E6374696F6E28652C74297B69662821657C7C21742972657475726E2D313B766172206E3D652E696E6465784F662874293B2D31213D3D6E2626652E73706C69';
wwv_flow_imp.g_varchar2_table(942) := '6365286E2C31297D28652E706172656E742626652E706172656E742E6368696C6472656E2C65292C652E706172656E743D6E756C6C2C722E6669726528742B222E72656D6F766564222C7B656C656D656E743A657D292C6E2E72656D6F76652865292C65';
wwv_flow_imp.g_varchar2_table(943) := '7D2C716E2E70726F746F747970652E72656D6F766553686170653D66756E6374696F6E2865297B72657475726E20746869732E5F72656D6F7665456C656D656E7428652C22736861706522297D2C716E2E70726F746F747970652E72656D6F7665436F6E';
wwv_flow_imp.g_varchar2_table(944) := '6E656374696F6E3D66756E6374696F6E2865297B72657475726E20746869732E5F72656D6F7665456C656D656E7428652C22636F6E6E656374696F6E22297D2C716E2E70726F746F747970652E67657447726170686963733D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(945) := '74297B72657475726E20746869732E5F656C656D656E7452656769737472792E676574477261706869637328652C74297D2C716E2E70726F746F747970652E5F6368616E676556696577626F783D66756E6374696F6E2865297B746869732E5F6576656E';
wwv_flow_imp.g_varchar2_table(946) := '744275732E66697265282263616E7661732E76696577626F782E6368616E67696E6722292C652E6170706C792874686973292C746869732E5F63616368656456696577626F783D6E756C6C2C746869732E5F76696577626F784368616E67656428297D2C';
wwv_flow_imp.g_varchar2_table(947) := '716E2E70726F746F747970652E5F76696577626F784368616E6765643D66756E6374696F6E28297B746869732E5F6576656E744275732E66697265282263616E7661732E76696577626F782E6368616E676564222C7B76696577626F783A746869732E76';
wwv_flow_imp.g_varchar2_table(948) := '696577626F7828297D297D2C716E2E70726F746F747970652E76696577626F783D66756E6374696F6E2865297B696628766F696420303D3D3D652626746869732E5F63616368656456696577626F782972657475726E20746869732E5F63616368656456';
wwv_flow_imp.g_varchar2_table(949) := '696577626F783B636F6E737420743D746869732E5F76696577706F72742C6E3D746869732E67657453697A6528293B6C657420692C722C6F2C612C732C6C2C633B72657475726E20653F28746869732E5F6368616E676556696577626F78282866756E63';
wwv_flow_imp.g_varchar2_table(950) := '74696F6E28297B733D4D6174682E6D696E286E2E77696474682F652E77696474682C6E2E6865696768742F652E686569676874293B636F6E737420693D746869732E5F7376672E6372656174655356474D617472697828292E7363616C652873292E7472';
wwv_flow_imp.g_varchar2_table(951) := '616E736C617465282D652E782C2D652E79293B636528742C69297D29292C65293A286F3D746869732E5F726F6F74456C656D656E743F746869732E6765744163746976654C6179657228293A6E756C6C2C693D6F26266F2E67657442426F7828297C7C7B';
wwv_flow_imp.g_varchar2_table(952) := '7D2C613D63652874292C723D613F612E6D61747269783A66756E6374696F6E28652C742C6E2C692C722C6F297B76617220613D4A28292E6372656174655356474D617472697828293B73776974636828617267756D656E74732E6C656E677468297B6361';
wwv_flow_imp.g_varchar2_table(953) := '736520303A72657475726E20613B6361736520313A72657475726E205128612C65293B6361736520363A72657475726E205128612C7B613A652C623A742C633A6E2C643A692C653A722C663A6F7D297D7D28292C733D476E28722E612C316533292C6C3D';
wwv_flow_imp.g_varchar2_table(954) := '476E282D722E657C7C302C316533292C633D476E282D722E667C7C302C316533292C653D746869732E5F63616368656456696577626F783D7B783A6C3F6C2F733A302C793A633F632F733A302C77696474683A6E2E77696474682F732C6865696768743A';
wwv_flow_imp.g_varchar2_table(955) := '6E2E6865696768742F732C7363616C653A732C696E6E65723A7B77696474683A692E77696474687C7C302C6865696768743A692E6865696768747C7C302C783A692E787C7C302C793A692E797C7C307D2C6F757465723A6E7D297D2C716E2E70726F746F';
wwv_flow_imp.g_varchar2_table(956) := '747970652E7363726F6C6C3D66756E6374696F6E2865297B636F6E737420743D746869732E5F76696577706F72743B6C6574206E3D742E67657443544D28293B72657475726E20652626746869732E5F6368616E676556696577626F78282866756E6374';
wwv_flow_imp.g_varchar2_table(957) := '696F6E28297B653D53287B64783A302C64793A307D2C657C7C7B7D292C6E3D746869732E5F7376672E6372656174655356474D617472697828292E7472616E736C61746528652E64782C652E6479292E6D756C7469706C79286E292C596E28742C6E297D';
wwv_flow_imp.g_varchar2_table(958) := '29292C7B783A6E2E652C793A6E2E667D7D2C716E2E70726F746F747970652E7363726F6C6C546F456C656D656E743D66756E6374696F6E28652C74297B6C6574206E3D3130303B22737472696E67223D3D747970656F662065262628653D746869732E5F';
wwv_flow_imp.g_varchar2_table(959) := '656C656D656E7452656769737472792E676574286529293B636F6E737420693D746869732E66696E64526F6F742865293B69662869213D3D746869732E676574526F6F74456C656D656E7428292626746869732E736574526F6F74456C656D656E742869';
wwv_flow_imp.g_varchar2_table(960) := '292C693D3D3D652972657475726E3B747C7C28743D7B7D292C226E756D626572223D3D747970656F6620742626286E3D74292C743D7B746F703A742E746F707C7C6E2C72696768743A742E72696768747C7C6E2C626F74746F6D3A742E626F74746F6D7C';
wwv_flow_imp.g_varchar2_table(961) := '7C6E2C6C6566743A742E6C6566747C7C6E7D3B636F6E737420723D4E742865292C6F3D6B742872292C613D746869732E76696577626F7828292C733D746869732E7A6F6F6D28293B6C6574206C2C633B612E792B3D742E746F702F732C612E782B3D742E';
wwv_flow_imp.g_varchar2_table(962) := '6C6566742F732C612E77696474682D3D28742E72696768742B742E6C656674292F732C612E6865696768742D3D28742E626F74746F6D2B742E746F70292F733B636F6E737420703D6B742861293B696628722E77696474683C612E77696474682626722E';
wwv_flow_imp.g_varchar2_table(963) := '6865696768743C612E686569676874297B636F6E737420653D4D6174682E6D617828302C6F2E72696768742D702E7269676874292C743D4D6174682E6D696E28302C6F2E6C6566742D702E6C656674292C6E3D4D6174682E6D617828302C6F2E626F7474';
wwv_flow_imp.g_varchar2_table(964) := '6F6D2D702E626F74746F6D292C693D4D6174682E6D696E28302C6F2E746F702D702E746F70293B6C3D657C7C742C633D6E7C7C697D656C7365206C3D722E782D612E782C633D722E792D612E793B746869732E7363726F6C6C287B64783A2D6C2A732C64';
wwv_flow_imp.g_varchar2_table(965) := '793A2D632A737D297D2C716E2E70726F746F747970652E7A6F6F6D3D66756E6374696F6E28652C74297B69662821652972657475726E20746869732E76696577626F782865292E7363616C653B696628226669742D76696577706F7274223D3D3D652972';
wwv_flow_imp.g_varchar2_table(966) := '657475726E20746869732E5F66697456696577706F72742874293B6C6574206E2C693B72657475726E20746869732E5F6368616E676556696577626F78282866756E6374696F6E28297B226F626A65637422213D747970656F6620742626286E3D746869';
wwv_flow_imp.g_varchar2_table(967) := '732E76696577626F7828292E6F757465722C743D7B783A6E2E77696474682F322C793A6E2E6865696768742F327D292C693D746869732E5F7365745A6F6F6D28652C74297D29292C476E28692E612C316533297D2C716E2E70726F746F747970652E5F66';
wwv_flow_imp.g_varchar2_table(968) := '697456696577706F72743D66756E6374696F6E2865297B636F6E737420743D746869732E76696577626F7828292C6E3D742E6F757465722C693D742E696E6E65723B6C657420722C6F3B72657475726E20692E783E3D302626692E793E3D302626692E78';
wwv_flow_imp.g_varchar2_table(969) := '2B692E77696474683C3D6E2E77696474682626692E792B692E6865696768743C3D6E2E686569676874262621653F6F3D7B783A302C793A302C77696474683A4D6174682E6D617828692E77696474682B692E782C6E2E7769647468292C6865696768743A';
wwv_flow_imp.g_varchar2_table(970) := '4D6174682E6D617828692E6865696768742B692E792C6E2E686569676874297D3A28723D4D6174682E6D696E28312C6E2E77696474682F692E77696474682C6E2E6865696768742F692E686569676874292C6F3D7B783A692E782B28653F692E77696474';
wwv_flow_imp.g_varchar2_table(971) := '682F322D6E2E77696474682F722F323A30292C793A692E792B28653F692E6865696768742F322D6E2E6865696768742F722F323A30292C77696474683A6E2E77696474682F722C6865696768743A6E2E6865696768742F727D292C746869732E76696577';
wwv_flow_imp.g_varchar2_table(972) := '626F78286F292C746869732E76696577626F78282131292E7363616C657D2C716E2E70726F746F747970652E5F7365745A6F6F6D3D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F7376672C693D746869732E5F76696577706F72';
wwv_flow_imp.g_varchar2_table(973) := '742C723D6E2E6372656174655356474D617472697828292C6F3D6E2E637265617465535647506F696E7428293B6C657420612C732C6C2C632C703B6C3D692E67657443544D28293B636F6E737420753D6C2E613B72657475726E20743F28613D53286F2C';
wwv_flow_imp.g_varchar2_table(974) := '74292C733D612E6D61747269785472616E73666F726D286C2E696E76657273652829292C633D722E7472616E736C61746528732E782C732E79292E7363616C6528312F752A65292E7472616E736C617465282D732E782C2D732E79292C703D6C2E6D756C';
wwv_flow_imp.g_varchar2_table(975) := '7469706C79286329293A703D722E7363616C652865292C596E28746869732E5F76696577706F72742C70292C707D2C716E2E70726F746F747970652E67657453697A653D66756E6374696F6E28297B72657475726E7B77696474683A746869732E5F636F';
wwv_flow_imp.g_varchar2_table(976) := '6E7461696E65722E636C69656E7457696474682C6865696768743A746869732E5F636F6E7461696E65722E636C69656E744865696768747D7D2C716E2E70726F746F747970652E6765744162736F6C75746542426F783D66756E6374696F6E2865297B63';
wwv_flow_imp.g_varchar2_table(977) := '6F6E737420743D746869732E76696577626F7828293B6C6574206E3B72657475726E206E3D652E776179706F696E74733F746869732E67657447726170686963732865292E67657442426F7828293A652C7B783A6E2E782A742E7363616C652D742E782A';
wwv_flow_imp.g_varchar2_table(978) := '742E7363616C652C793A6E2E792A742E7363616C652D742E792A742E7363616C652C77696474683A6E2E77696474682A742E7363616C652C6865696768743A6E2E6865696768742A742E7363616C657D7D2C716E2E70726F746F747970652E726573697A';
wwv_flow_imp.g_varchar2_table(979) := '65643D66756E6374696F6E28297B64656C65746520746869732E5F63616368656456696577626F782C746869732E5F6576656E744275732E66697265282263616E7661732E726573697A656422297D3B76617220586E3D22646174612D656C656D656E74';
wwv_flow_imp.g_varchar2_table(980) := '2D6964223B66756E6374696F6E205A6E2865297B746869732E5F656C656D656E74733D7B7D2C746869732E5F6576656E744275733D657D66756E6374696F6E204A6E28652C742C6E297B76617220693D66756E6374696F6E28652C742C6E2C69297B7661';
wwv_flow_imp.g_varchar2_table(981) := '7220723D6E2E696E76657273653B72657475726E204F626A6563742E646566696E6550726F706572747928652C2272656D6F7665222C7B76616C75653A66756E6374696F6E2865297B766172206E3D746869732E696E6465784F662865293B7265747572';
wwv_flow_imp.g_varchar2_table(982) := '6E2D31213D3D6E262628746869732E73706C696365286E2C31292C742E756E73657428652C722C6929292C657D7D292C4F626A6563742E646566696E6550726F706572747928652C22636F6E7461696E73222C7B76616C75653A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(983) := '297B72657475726E2D31213D3D746869732E696E6465784F662865297D7D292C4F626A6563742E646566696E6550726F706572747928652C22616464222C7B76616C75653A66756E6374696F6E28652C6E297B766172206F3D746869732E696E6465784F';
wwv_flow_imp.g_varchar2_table(984) := '662865293B696628766F696420303D3D3D6E297B6966282D31213D3D6F2972657475726E3B6E3D746869732E6C656E6774687D2D31213D3D6F2626746869732E73706C696365286F2C31292C746869732E73706C696365286E2C302C65292C2D313D3D3D';
wwv_flow_imp.g_varchar2_table(985) := '6F2626742E73657428652C722C69297D7D292C4F626A6563742E646566696E6550726F706572747928652C225F5F726566735F636F6C6C656374696F6E222C7B76616C75653A21307D292C657D286E5B742E6E616D655D7C7C5B5D2C652C742C6E293B4F';
wwv_flow_imp.g_varchar2_table(986) := '626A6563742E646566696E6550726F7065727479286E2C742E6E616D652C7B656E756D657261626C653A742E656E756D657261626C652C76616C75653A697D292C692E6C656E6774682626692E666F7245616368282866756E6374696F6E2869297B652E';
wwv_flow_imp.g_varchar2_table(987) := '73657428692C742E696E76657273652C6E297D29297D66756E6374696F6E20516E28652C74297B69662821287468697320696E7374616E63656F6620516E292972657475726E206E657720516E28652C74293B652E696E76657273653D742C742E696E76';
wwv_flow_imp.g_varchar2_table(988) := '657273653D652C746869732E70726F70733D7B7D2C746869732E70726F70735B652E6E616D655D3D652C746869732E70726F70735B742E6E616D655D3D747D5A6E2E24696E6A6563743D5B226576656E74427573225D2C5A6E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(989) := '6164643D66756E6374696F6E28652C742C6E297B76617220693D652E69643B746869732E5F76616C696461746549642869292C7A28742C586E2C69292C6E26267A286E2C586E2C69292C746869732E5F656C656D656E74735B695D3D7B656C656D656E74';
wwv_flow_imp.g_varchar2_table(990) := '3A652C6766783A742C7365636F6E646172794766783A6E7D7D2C5A6E2E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869732E5F656C656D656E74732C6E3D652E69647C7C652C693D6E2626745B6E5D3B69';
wwv_flow_imp.g_varchar2_table(991) := '2626287A28692E6766782C586E2C2222292C692E7365636F6E6461727947667826267A28692E7365636F6E646172794766782C586E2C2222292C64656C65746520745B6E5D297D2C5A6E2E70726F746F747970652E75706461746549643D66756E637469';
wwv_flow_imp.g_varchar2_table(992) := '6F6E28652C74297B746869732E5F76616C696461746549642874292C22737472696E67223D3D747970656F662065262628653D746869732E676574286529292C746869732E5F6576656E744275732E666972652822656C656D656E742E75706461746549';
wwv_flow_imp.g_varchar2_table(993) := '64222C7B656C656D656E743A652C6E657749643A747D293B766172206E3D746869732E67657447726170686963732865292C693D746869732E676574477261706869637328652C2130293B746869732E72656D6F76652865292C652E69643D742C746869';
wwv_flow_imp.g_varchar2_table(994) := '732E61646428652C6E2C69297D2C5A6E2E70726F746F747970652E75706461746547726170686963733D66756E6374696F6E28652C742C6E297B76617220693D652E69647C7C652C723D746869732E5F656C656D656E74735B695D3B72657475726E206E';
wwv_flow_imp.g_varchar2_table(995) := '3F722E7365636F6E646172794766783D743A722E6766783D742C7426267A28742C586E2C69292C747D2C5A6E2E70726F746F747970652E6765743D66756E6374696F6E2865297B76617220743B743D22737472696E67223D3D747970656F6620653F653A';
wwv_flow_imp.g_varchar2_table(996) := '6526267A28652C586E293B766172206E3D746869732E5F656C656D656E74735B745D3B72657475726E206E26266E2E656C656D656E747D2C5A6E2E70726F746F747970652E66696C7465723D66756E6374696F6E2865297B76617220743D5B5D3B726574';
wwv_flow_imp.g_varchar2_table(997) := '75726E20746869732E666F7245616368282866756E6374696F6E286E2C69297B65286E2C69292626742E70757368286E297D29292C747D2C5A6E2E70726F746F747970652E66696E643D66756E6374696F6E2865297B666F722876617220743D74686973';
wwv_flow_imp.g_varchar2_table(998) := '2E5F656C656D656E74732C6E3D4F626A6563742E6B6579732874292C693D303B693C6E2E6C656E6774683B692B2B297B76617220723D745B6E5B695D5D2C6F3D722E656C656D656E743B69662865286F2C722E676678292972657475726E206F7D7D2C5A';
wwv_flow_imp.g_varchar2_table(999) := '6E2E70726F746F747970652E676574416C6C3D66756E6374696F6E28297B72657475726E20746869732E66696C746572282866756E6374696F6E2865297B72657475726E20657D29297D2C5A6E2E70726F746F747970652E666F72456163683D66756E63';
wwv_flow_imp.g_varchar2_table(1000) := '74696F6E2865297B76617220743D746869732E5F656C656D656E74733B4F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B76617220693D745B6E5D2C723D692E656C656D656E742C6F3D692E6766783B72657475';
wwv_flow_imp.g_varchar2_table(1001) := '726E206528722C6F297D29297D2C5A6E2E70726F746F747970652E67657447726170686963733D66756E6374696F6E28652C74297B766172206E3D652E69647C7C652C693D746869732E5F656C656D656E74735B6E5D3B72657475726E2069262628743F';
wwv_flow_imp.g_varchar2_table(1002) := '692E7365636F6E646172794766783A692E676678297D2C5A6E2E70726F746F747970652E5F76616C696461746549643D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F722822656C656D656E74206D7573742068617665';
wwv_flow_imp.g_varchar2_table(1003) := '20616E20696422293B696628746869732E5F656C656D656E74735B655D297468726F77206E6577204572726F722822656C656D656E74207769746820696420222B652B2220616C726561647920616464656422297D2C516E2E70726F746F747970652E62';
wwv_flow_imp.g_varchar2_table(1004) := '696E643D66756E6374696F6E28652C74297B69662822737472696E67223D3D747970656F662074297B69662821746869732E70726F70735B745D297468726F77206E6577204572726F7228226E6F2070726F7065727479203C222B742B223E20696E2072';
wwv_flow_imp.g_varchar2_table(1005) := '656622293B743D746869732E70726F70735B745D7D742E636F6C6C656374696F6E3F4A6E28746869732C742C65293A66756E6374696F6E28652C742C6E297B76617220693D742E696E76657273652C723D6E5B742E6E616D655D3B4F626A6563742E6465';
wwv_flow_imp.g_varchar2_table(1006) := '66696E6550726F7065727479286E2C742E6E616D652C7B636F6E666967757261626C653A742E636F6E666967757261626C652C656E756D657261626C653A742E656E756D657261626C652C6765743A66756E6374696F6E28297B72657475726E20727D2C';
wwv_flow_imp.g_varchar2_table(1007) := '7365743A66756E6374696F6E2874297B69662874213D3D72297B766172206F3D723B723D6E756C6C2C6F2626652E756E736574286F2C692C6E292C723D742C652E73657428722C692C6E297D7D7D297D28746869732C742C65297D2C516E2E70726F746F';
wwv_flow_imp.g_varchar2_table(1008) := '747970652E656E7375726552656673436F6C6C656374696F6E3D66756E6374696F6E28652C74297B766172206E3D655B742E6E616D655D3B72657475726E2066756E6374696F6E2865297B72657475726E21303D3D3D652E5F5F726566735F636F6C6C65';
wwv_flow_imp.g_varchar2_table(1009) := '6374696F6E7D286E297C7C4A6E28746869732C742C65292C6E7D2C516E2E70726F746F747970652E656E73757265426F756E643D66756E6374696F6E28652C74297B2866756E6374696F6E28652C74297B72657475726E204F626A6563742E70726F746F';
wwv_flow_imp.g_varchar2_table(1010) := '747970652E6861734F776E50726F70657274792E63616C6C28652C742E6E616D657C7C74297D2928652C74297C7C746869732E62696E6428652C74297D2C516E2E70726F746F747970652E756E7365743D66756E6374696F6E28652C742C6E297B652626';
wwv_flow_imp.g_varchar2_table(1011) := '28746869732E656E73757265426F756E6428652C74292C742E636F6C6C656374696F6E3F746869732E656E7375726552656673436F6C6C656374696F6E28652C74292E72656D6F7665286E293A655B742E6E616D655D3D766F69642030297D2C516E2E70';
wwv_flow_imp.g_varchar2_table(1012) := '726F746F747970652E7365743D66756E6374696F6E28652C742C6E297B65262628746869732E656E73757265426F756E6428652C74292C742E636F6C6C656374696F6E3F746869732E656E7375726552656673436F6C6C656374696F6E28652C74292E61';
wwv_flow_imp.g_varchar2_table(1013) := '6464286E293A655B742E6E616D655D3D6E297D3B7661722065693D6E657720516E287B6E616D653A226368696C6472656E222C656E756D657261626C653A21302C636F6C6C656374696F6E3A21307D2C7B6E616D653A22706172656E74227D292C74693D';
wwv_flow_imp.g_varchar2_table(1014) := '6E657720516E287B6E616D653A226C6162656C73222C656E756D657261626C653A21302C636F6C6C656374696F6E3A21307D2C7B6E616D653A226C6162656C546172676574227D292C6E693D6E657720516E287B6E616D653A2261747461636865727322';
wwv_flow_imp.g_varchar2_table(1015) := '2C636F6C6C656374696F6E3A21307D2C7B6E616D653A22686F7374227D292C69693D6E657720516E287B6E616D653A226F7574676F696E67222C636F6C6C656374696F6E3A21307D2C7B6E616D653A22736F75726365227D292C72693D6E657720516E28';
wwv_flow_imp.g_varchar2_table(1016) := '7B6E616D653A22696E636F6D696E67222C636F6C6C656374696F6E3A21307D2C7B6E616D653A22746172676574227D293B66756E6374696F6E206F6928297B4F626A6563742E646566696E6550726F706572747928746869732C22627573696E6573734F';
wwv_flow_imp.g_varchar2_table(1017) := '626A656374222C7B7772697461626C653A21307D292C4F626A6563742E646566696E6550726F706572747928746869732C226C6162656C222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E6C6162656C735B305D7D2C7365743A';
wwv_flow_imp.g_varchar2_table(1018) := '66756E6374696F6E2865297B76617220743D746869732E6C6162656C2C6E3D746869732E6C6162656C733B21652626743F6E2E72656D6F76652874293A6E2E61646428652C30297D7D292C65692E62696E6428746869732C22706172656E7422292C7469';
wwv_flow_imp.g_varchar2_table(1019) := '2E62696E6428746869732C226C6162656C7322292C69692E62696E6428746869732C226F7574676F696E6722292C72692E62696E6428746869732C22696E636F6D696E6722297D66756E6374696F6E20616928297B6F692E63616C6C2874686973292C65';
wwv_flow_imp.g_varchar2_table(1020) := '692E62696E6428746869732C226368696C6472656E22292C6E692E62696E6428746869732C22686F737422292C6E692E62696E6428746869732C2261747461636865727322297D66756E6374696F6E20736928297B6F692E63616C6C2874686973292C65';
wwv_flow_imp.g_varchar2_table(1021) := '692E62696E6428746869732C226368696C6472656E22297D66756E6374696F6E206C6928297B61692E63616C6C2874686973292C74692E62696E6428746869732C226C6162656C54617267657422297D66756E6374696F6E20636928297B6F692E63616C';
wwv_flow_imp.g_varchar2_table(1022) := '6C2874686973292C69692E62696E6428746869732C22736F7572636522292C72692E62696E6428746869732C2274617267657422297D6E2861692C6F69292C6E2873692C6169292C6E286C692C6169292C6E2863692C6F69293B7661722070693D7B636F';
wwv_flow_imp.g_varchar2_table(1023) := '6E6E656374696F6E3A63692C73686170653A61692C6C6162656C3A6C692C726F6F743A73697D3B66756E6374696F6E20756928297B746869732E5F7569643D31327D75692E70726F746F747970652E637265617465526F6F743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1024) := '297B72657475726E20746869732E6372656174652822726F6F74222C65297D2C75692E70726F746F747970652E6372656174654C6162656C3D66756E6374696F6E2865297B72657475726E20746869732E63726561746528226C6162656C222C65297D2C';
wwv_flow_imp.g_varchar2_table(1025) := '75692E70726F746F747970652E63726561746553686170653D66756E6374696F6E2865297B72657475726E20746869732E63726561746528227368617065222C65297D2C75692E70726F746F747970652E637265617465436F6E6E656374696F6E3D6675';
wwv_flow_imp.g_varchar2_table(1026) := '6E6374696F6E2865297B72657475726E20746869732E6372656174652822636F6E6E656374696F6E222C65297D2C75692E70726F746F747970652E6372656174653D66756E6374696F6E28652C74297B72657475726E28743D53287B7D2C747C7C7B7D29';
wwv_flow_imp.g_varchar2_table(1027) := '292E69647C7C28742E69643D652B225F222B746869732E5F7569642B2B292C66756E6374696F6E28652C74297B766172206E3D70695B655D3B696628216E297468726F77206E6577204572726F722822756E6B6E6F776E20747970653A203C222B652B22';
wwv_flow_imp.g_varchar2_table(1028) := '3E22293B72657475726E2053286E6577206E2C74297D28652C74297D3B7661722068693D225F5F666E222C64693D41727261792E70726F746F747970652E736C6963653B66756E6374696F6E206D6928297B746869732E5F6C697374656E6572733D7B7D';
wwv_flow_imp.g_varchar2_table(1029) := '2C746869732E6F6E28226469616772616D2E64657374726F79222C312C746869732E5F64657374726F792C74686973297D66756E6374696F6E20666928297B7D66756E6374696F6E20796928652C74297B746869732E5F6576656E744275733D652C7468';
wwv_flow_imp.g_varchar2_table(1030) := '69732E5F656C656D656E7452656769737472793D747D66756E6374696F6E20676928652C742C6E297B76617220693D6E7C7C742E66697273744368696C643B65213D3D692626742E696E736572744265666F726528652C69297D6D692E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1031) := '70652E6F6E3D66756E6374696F6E28652C742C6E2C69297B696628653D732865293F653A5B655D2C70287429262628693D6E2C6E3D742C743D316533292C2163287429297468726F77206E6577204572726F7228227072696F72697479206D7573742062';
wwv_flow_imp.g_varchar2_table(1032) := '652061206E756D62657222293B76617220723D6E3B6926262828723D45286E2C6929295B68695D3D6E5B68695D7C7C6E293B766172206F3D746869733B652E666F7245616368282866756E6374696F6E2865297B6F2E5F6164644C697374656E65722865';
wwv_flow_imp.g_varchar2_table(1033) := '2C7B7072696F726974793A742C63616C6C6261636B3A722C6E6578743A6E756C6C7D297D29297D2C6D692E70726F746F747970652E6F6E63653D66756E6374696F6E28652C742C6E2C69297B76617220723D746869733B69662870287429262628693D6E';
wwv_flow_imp.g_varchar2_table(1034) := '2C6E3D742C743D316533292C2163287429297468726F77206E6577204572726F7228227072696F72697479206D7573742062652061206E756D62657222293B66756E6374696F6E206F28297B6F2E5F5F6973546F6D623D21303B76617220743D6E2E6170';
wwv_flow_imp.g_varchar2_table(1035) := '706C7928692C617267756D656E7473293B72657475726E20722E6F666628652C6F292C747D6F5B68695D3D6E2C746869732E6F6E28652C742C6F297D2C6D692E70726F746F747970652E6F66663D66756E6374696F6E28652C74297B653D732865293F65';
wwv_flow_imp.g_varchar2_table(1036) := '3A5B655D3B766172206E3D746869733B652E666F7245616368282866756E6374696F6E2865297B6E2E5F72656D6F76654C697374656E657228652C74297D29297D2C6D692E70726F746F747970652E6372656174654576656E743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1037) := '65297B76617220743D6E65772066693B72657475726E20742E696E69742865292C747D2C6D692E70726F746F747970652E666972653D66756E6374696F6E28652C74297B766172206E2C692C722C6F3B6966286F3D64692E63616C6C28617267756D656E';
wwv_flow_imp.g_varchar2_table(1038) := '7473292C226F626A656374223D3D747970656F662065262628653D28743D65292E74797065292C2165297468726F77206E6577204572726F7228226E6F206576656E7420747970652073706563696669656422293B696628693D746869732E5F6C697374';
wwv_flow_imp.g_varchar2_table(1039) := '656E6572735B655D297B6E3D7420696E7374616E63656F662066693F743A746869732E6372656174654576656E742874292C6F5B305D3D6E3B76617220613D6E2E747970653B65213D3D612626286E2E747970653D65293B7472797B723D746869732E5F';
wwv_flow_imp.g_varchar2_table(1040) := '696E766F6B654C697374656E657273286E2C6F2C69297D66696E616C6C797B65213D3D612626286E2E747970653D61297D72657475726E20766F696420303D3D3D7226266E2E64656661756C7450726576656E746564262628723D2131292C727D7D2C6D';
wwv_flow_imp.g_varchar2_table(1041) := '692E70726F746F747970652E68616E646C654572726F723D66756E6374696F6E2865297B72657475726E21313D3D3D746869732E6669726528226572726F72222C7B6572726F723A657D297D2C6D692E70726F746F747970652E5F64657374726F793D66';
wwv_flow_imp.g_varchar2_table(1042) := '756E6374696F6E28297B746869732E5F6C697374656E6572733D7B7D7D2C6D692E70726F746F747970652E5F696E766F6B654C697374656E6572733D66756E6374696F6E28652C742C6E297B666F722876617220693B6E262621652E63616E63656C4275';
wwv_flow_imp.g_varchar2_table(1043) := '62626C653B29693D746869732E5F696E766F6B654C697374656E657228652C742C6E292C6E3D6E2E6E6578743B72657475726E20697D2C6D692E70726F746F747970652E5F696E766F6B654C697374656E65723D66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(1044) := '76617220693B6966286E2E63616C6C6261636B2E5F5F6973546F6D622972657475726E20693B7472797B693D66756E6374696F6E28652C74297B72657475726E20652E6170706C79286E756C6C2C74297D286E2E63616C6C6261636B2C74292C766F6964';
wwv_flow_imp.g_varchar2_table(1045) := '2030213D3D69262628652E72657475726E56616C75653D692C652E73746F7050726F7061676174696F6E2829292C21313D3D3D692626652E70726576656E7444656661756C7428297D63617463682865297B69662821746869732E68616E646C65457272';
wwv_flow_imp.g_varchar2_table(1046) := '6F72286529297468726F7720636F6E736F6C652E6572726F722822756E68616E646C6564206572726F7220696E206576656E74206C697374656E6572222C65292C657D72657475726E20697D2C6D692E70726F746F747970652E5F6164644C697374656E';
wwv_flow_imp.g_varchar2_table(1047) := '65723D66756E6374696F6E28652C74297B766172206E2C693D746869732E5F6765744C697374656E6572732865293B69662869297B666F72283B693B297B696628692E7072696F726974793C742E7072696F726974792972657475726E20742E6E657874';
wwv_flow_imp.g_varchar2_table(1048) := '3D692C766F6964286E3F6E2E6E6578743D743A746869732E5F7365744C697374656E65727328652C7429293B6E3D692C693D692E6E6578747D6E2E6E6578743D747D656C736520746869732E5F7365744C697374656E65727328652C74297D2C6D692E70';
wwv_flow_imp.g_varchar2_table(1049) := '726F746F747970652E5F6765744C697374656E6572733D66756E6374696F6E2865297B72657475726E20746869732E5F6C697374656E6572735B655D7D2C6D692E70726F746F747970652E5F7365744C697374656E6572733D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1050) := '74297B746869732E5F6C697374656E6572735B655D3D747D2C6D692E70726F746F747970652E5F72656D6F76654C697374656E65723D66756E6374696F6E28652C74297B766172206E2C692C722C6F3D746869732E5F6765744C697374656E6572732865';
wwv_flow_imp.g_varchar2_table(1051) := '293B6966287429666F72283B6F3B296E3D6F2E6E6578742C28723D6F2E63616C6C6261636B29213D3D742626725B68695D213D3D747C7C28693F692E6E6578743D6E3A746869732E5F7365744C697374656E65727328652C6E29292C693D6F2C6F3D6E3B';
wwv_flow_imp.g_varchar2_table(1052) := '656C736520746869732E5F7365744C697374656E65727328652C6E756C6C297D2C66692E70726F746F747970652E73746F7050726F7061676174696F6E3D66756E6374696F6E28297B746869732E63616E63656C427562626C653D21307D2C66692E7072';
wwv_flow_imp.g_varchar2_table(1053) := '6F746F747970652E70726576656E7444656661756C743D66756E6374696F6E28297B746869732E64656661756C7450726576656E7465643D21307D2C66692E70726F746F747970652E696E69743D66756E6374696F6E2865297B5328746869732C657C7C';
wwv_flow_imp.g_varchar2_table(1054) := '7B7D297D2C79692E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279225D2C79692E70726F746F747970652E5F6765744368696C6472656E436F6E7461696E65723D66756E6374696F6E2865297B76617220742C';
wwv_flow_imp.g_varchar2_table(1055) := '6E3D746869732E5F656C656D656E7452656769737472792E67657447726170686963732865293B72657475726E20652E706172656E743F28743D66756E6374696F6E2865297B72657475726E20652E706172656E744E6F64652E6368696C644E6F646573';
wwv_flow_imp.g_varchar2_table(1056) := '5B315D7D286E292C747C7C284728743D582822672229292E6164642822646A732D6368696C6472656E22292C6A286E2E706172656E744E6F64652C742929293A743D6E2C747D2C79692E70726F746F747970652E5F636C6561723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1057) := '65297B76617220743D66756E6374696F6E2865297B72657475726E20652E6368696C644E6F6465735B305D7D2865293B72657475726E206A652874292C747D2C79692E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E637469';
wwv_flow_imp.g_varchar2_table(1058) := '6F6E28652C742C6E2C69297B76617220723D5828226722293B472872292E6164642822646A732D67726F757022292C766F69642030213D3D6E3F676928722C742C742E6368696C644E6F6465735B6E5D293A6A28742C72293B766172206F3D5828226722';
wwv_flow_imp.g_varchar2_table(1059) := '293B47286F292E6164642822646A732D656C656D656E7422292C47286F292E6164642822646A732D222B65292C69262647286F292E6164642822646A732D6672616D6522292C6A28722C6F293B76617220613D5828226722293B72657475726E20472861';
wwv_flow_imp.g_varchar2_table(1060) := '292E6164642822646A732D76697375616C22292C6A286F2C61292C6F7D2C79692E70726F746F747970652E6372656174653D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F6765744368696C6472656E436F6E7461696E65722874';
wwv_flow_imp.g_varchar2_table(1061) := '2E706172656E74293B72657475726E20746869732E5F637265617465436F6E7461696E657228652C692C6E2C4C74287429297D2C79692E70726F746F747970652E757064617465436F6E7461696E6D656E74733D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(1062) := '742C6E3D746869732C693D746869732E5F656C656D656E7452656769737472793B743D7928652C2866756E6374696F6E28652C74297B72657475726E20742E706172656E74262628655B742E706172656E742E69645D3D742E706172656E74292C657D29';
wwv_flow_imp.g_varchar2_table(1063) := '2C7B7D292C6628742C2866756E6374696F6E2865297B76617220743D652E6368696C6472656E3B69662874297B76617220723D6E2E5F6765744368696C6472656E436F6E7461696E65722865293B6628742E736C69636528292E7265766572736528292C';
wwv_flow_imp.g_varchar2_table(1064) := '2866756E6374696F6E2865297B676928692E67657447726170686963732865292E706172656E744E6F64652C72297D29297D7D29297D2C79692E70726F746F747970652E6472617753686170653D66756E6374696F6E28652C742C6E3D7B7D297B726574';
wwv_flow_imp.g_varchar2_table(1065) := '75726E20746869732E5F6576656E744275732E66697265282272656E6465722E7368617065222C7B6766783A652C656C656D656E743A742C61747472733A6E7D297D2C79692E70726F746F747970652E6765745368617065506174683D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1066) := '6E2865297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E676574536861706550617468222C65297D2C79692E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(1067) := '3D7B7D297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E636F6E6E656374696F6E222C7B6766783A652C656C656D656E743A742C61747472733A6E7D297D2C79692E70726F746F747970652E676574436F6E6E';
wwv_flow_imp.g_varchar2_table(1068) := '656374696F6E506174683D66756E6374696F6E2865297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E676574436F6E6E656374696F6E50617468222C65297D2C79692E70726F746F747970652E757064617465';
wwv_flow_imp.g_varchar2_table(1069) := '3D66756E6374696F6E28652C742C6E297B696628742E706172656E74297B76617220693D746869732E5F636C656172286E293B696628227368617065223D3D3D6529746869732E64726177536861706528692C74292C6974286E2C742E782C742E79293B';
wwv_flow_imp.g_varchar2_table(1070) := '656C73657B69662822636F6E6E656374696F6E22213D3D65297468726F77206E6577204572726F722822756E6B6E6F776E20747970653A20222B65293B746869732E64726177436F6E6E656374696F6E28692C74297D742E68696464656E3F7A286E2C22';
wwv_flow_imp.g_varchar2_table(1071) := '646973706C6179222C226E6F6E6522293A7A286E2C22646973706C6179222C22626C6F636B22297D7D2C79692E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B736528746869732E5F656C656D656E7452656769737472792E67';
wwv_flow_imp.g_varchar2_table(1072) := '657447726170686963732865292E706172656E744E6F6465297D3B636F6E73742076693D7B5F5F646570656E64735F5F3A5B576E5D2C5F5F696E69745F5F3A5B2263616E766173225D2C63616E7661733A5B2274797065222C716E5D2C656C656D656E74';
wwv_flow_imp.g_varchar2_table(1073) := '52656769737472793A5B2274797065222C5A6E5D2C656C656D656E74466163746F72793A5B2274797065222C75695D2C6576656E744275733A5B2274797065222C6D695D2C6772617068696373466163746F72793A5B2274797065222C79695D7D3B6675';
wwv_flow_imp.g_varchar2_table(1074) := '6E6374696F6E20626928652C74297B746869732E5F696E6A6563746F723D747C7C66756E6374696F6E2865297B72657475726E20743D5B7B636F6E6669673A5B2276616C7565222C653D657C7C7B7D5D7D2C76695D2E636F6E63617428652E6D6F64756C';
wwv_flow_imp.g_varchar2_table(1075) := '65737C7C5B5D292C286E3D6E657720566E287429292E696E697428292C6E3B76617220742C6E7D2865292C746869732E67657428226576656E7442757322292E6669726528226469616772616D2E696E697422297D66756E6374696F6E20786928297B7D';
wwv_flow_imp.g_varchar2_table(1076) := '66756E6374696F6E20776928652C74297B746869732E6D6F64656C3D652C746869732E70726F706572746965733D747D62692E70726F746F747970652E6765743D66756E6374696F6E28652C74297B72657475726E20746869732E5F696E6A6563746F72';
wwv_flow_imp.g_varchar2_table(1077) := '2E67657428652C74297D2C62692E70726F746F747970652E696E766F6B653D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F696E6A6563746F722E696E766F6B6528652C742C6E297D2C62692E70726F746F747970652E646573';
wwv_flow_imp.g_varchar2_table(1078) := '74726F793D66756E6374696F6E28297B746869732E67657428226576656E7442757322292E6669726528226469616772616D2E64657374726F7922297D2C62692E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E676574';
wwv_flow_imp.g_varchar2_table(1079) := '28226576656E7442757322292E6669726528226469616772616D2E636C65617222297D2C78692E70726F746F747970652E6765743D66756E6374696F6E2865297B72657475726E20746869732E246D6F64656C2E70726F706572746965732E6765742874';
wwv_flow_imp.g_varchar2_table(1080) := '6869732C65297D2C78692E70726F746F747970652E7365743D66756E6374696F6E28652C74297B746869732E246D6F64656C2E70726F706572746965732E73657428746869732C652C74297D2C77692E70726F746F747970652E63726561746554797065';
wwv_flow_imp.g_varchar2_table(1081) := '3D66756E6374696F6E2865297B76617220743D746869732E6D6F64656C2C6E3D746869732E70726F706572746965732C693D4F626A6563742E6372656174652878692E70726F746F74797065293B6628652E70726F706572746965732C2866756E637469';
wwv_flow_imp.g_varchar2_table(1082) := '6F6E2865297B652E69734D616E797C7C766F696420303D3D3D652E64656661756C747C7C28695B652E6E616D655D3D652E64656661756C74297D29292C6E2E646566696E654D6F64656C28692C74292C6E2E646566696E6544657363726970746F722869';
wwv_flow_imp.g_varchar2_table(1083) := '2C65293B76617220723D652E6E732E6E616D653B66756E6374696F6E206F2865297B6E2E646566696E6528746869732C222474797065222C7B76616C75653A722C656E756D657261626C653A21307D292C6E2E646566696E6528746869732C2224617474';
wwv_flow_imp.g_varchar2_table(1084) := '7273222C7B76616C75653A7B7D7D292C6E2E646566696E6528746869732C2224706172656E74222C7B7772697461626C653A21307D292C6628652C45282866756E6374696F6E28652C74297B746869732E73657428742C65297D292C7468697329297D72';
wwv_flow_imp.g_varchar2_table(1085) := '657475726E206F2E70726F746F747970653D692C6F2E686173547970653D692E24696E7374616E63654F663D746869732E6D6F64656C2E686173547970652C6E2E646566696E654D6F64656C286F2C74292C6E2E646566696E6544657363726970746F72';
wwv_flow_imp.g_varchar2_table(1086) := '286F2C65292C6F7D3B766172205F693D7B537472696E673A21302C426F6F6C65616E3A21302C496E74656765723A21302C5265616C3A21302C456C656D656E743A21307D2C45693D7B537472696E673A66756E6374696F6E2865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(1087) := '7D2C426F6F6C65616E3A66756E6374696F6E2865297B72657475726E2274727565223D3D3D657D2C496E74656765723A66756E6374696F6E2865297B72657475726E207061727365496E7428652C3130297D2C5265616C3A66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(1088) := '72657475726E207061727365466C6F61742865297D7D3B66756E6374696F6E20536928652C74297B766172206E3D45695B655D3B72657475726E206E3F6E2874293A747D66756E6374696F6E2041692865297B72657475726E21215F695B655D7D66756E';
wwv_flow_imp.g_varchar2_table(1089) := '6374696F6E2043692865297B72657475726E212145695B655D7D66756E6374696F6E206B6928652C74297B766172206E2C692C723D652E73706C6974282F3A2F293B696628313D3D3D722E6C656E677468296E3D652C693D743B656C73657B6966283221';
wwv_flow_imp.g_varchar2_table(1090) := '3D3D722E6C656E677468297468726F77206E6577204572726F7228226578706563746564203C7072656669783A6C6F63616C4E616D653E206F72203C6C6F63616C4E616D653E2C20676F7420222B65293B6E3D725B315D2C693D725B305D7D7265747572';
wwv_flow_imp.g_varchar2_table(1091) := '6E7B6E616D653A653D28693F692B223A223A2222292B6E2C7072656669783A692C6C6F63616C4E616D653A6E7D7D66756E6374696F6E2052692865297B746869732E6E733D652C746869732E6E616D653D652E6E616D652C746869732E616C6C54797065';
wwv_flow_imp.g_varchar2_table(1092) := '733D5B5D2C746869732E616C6C547970657342794E616D653D7B7D2C746869732E70726F706572746965733D5B5D2C746869732E70726F7065727469657342794E616D653D7B7D7D66756E6374696F6E204D6928652C74297B746869732E7061636B6167';
wwv_flow_imp.g_varchar2_table(1093) := '654D61703D7B7D2C746869732E747970654D61703D7B7D2C746869732E7061636B616765733D5B5D2C746869732E70726F706572746965733D742C6628652C4528746869732E72656769737465725061636B6167652C7468697329297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1094) := '6E20506928652C742C6E297B76617220693D745B6E5D3B6966286920696E2065297468726F77206E6577204572726F7228227061636B616765207769746820222B6E2B22203C222B692B223E20616C726561647920646566696E656422297D66756E6374';
wwv_flow_imp.g_varchar2_table(1095) := '696F6E2044692865297B746869732E6D6F64656C3D657D66756E6374696F6E20426928652C742C6E297B4F626A6563742E646566696E6550726F706572747928652C742E6E616D652C7B656E756D657261626C653A21742E69735265666572656E63652C';
wwv_flow_imp.g_varchar2_table(1096) := '7772697461626C653A21302C76616C75653A6E2C636F6E666967757261626C653A21307D297D66756E6374696F6E204F692865297B72657475726E20652E7265706C616365282F5E3A2F2C2222297D66756E6374696F6E20546928652C743D7B7D297B74';
wwv_flow_imp.g_varchar2_table(1097) := '6869732E70726F706572746965733D6E65772044692874686973292C746869732E666163746F72793D6E657720776928746869732C746869732E70726F70657274696573292C746869732E72656769737472793D6E6577204D6928652C746869732E7072';
wwv_flow_imp.g_varchar2_table(1098) := '6F70657274696573292C746869732E7479706543616368653D7B7D2C746869732E636F6E6669673D747D52692E70726F746F747970652E6275696C643D66756E6374696F6E28297B72657475726E2066756E6374696F6E2865297B6C657420743D7B7D2C';
wwv_flow_imp.g_varchar2_table(1099) := '6E3D4F626A6563742865293B72657475726E2066285B226E73222C226E616D65222C22616C6C5479706573222C22616C6C547970657342794E616D65222C2270726F70657274696573222C2270726F7065727469657342794E616D65222C22626F647950';
wwv_flow_imp.g_varchar2_table(1100) := '726F7065727479222C22696450726F7065727479225D2C2866756E6374696F6E2869297B6920696E206E262628745B695D3D655B695D297D29292C747D2874686973297D2C52692E70726F746F747970652E61646450726F70657274793D66756E637469';
wwv_flow_imp.g_varchar2_table(1101) := '6F6E28652C742C6E297B22626F6F6C65616E223D3D747970656F6620742626286E3D742C743D766F69642030292C746869732E6164644E616D656450726F706572747928652C2131213D3D6E293B76617220693D746869732E70726F706572746965733B';
wwv_flow_imp.g_varchar2_table(1102) := '766F69642030213D3D743F692E73706C69636528742C302C65293A692E707573682865297D2C52692E70726F746F747970652E7265706C61636550726F70657274793D66756E6374696F6E28652C742C6E297B76617220693D652E6E732C723D74686973';
wwv_flow_imp.g_varchar2_table(1103) := '2E70726F706572746965732C6F3D746869732E70726F7065727469657342794E616D652C613D652E6E616D65213D3D742E6E616D653B696628652E69734964297B69662821742E69734964297468726F77206E6577204572726F72282270726F70657274';
wwv_flow_imp.g_varchar2_table(1104) := '79203C222B742E6E732E6E616D652B223E206D7573742062652069642070726F706572747920746F20726566696E65203C222B652E6E732E6E616D652B223E22293B746869732E736574496450726F706572747928742C2131297D696628652E6973426F';
wwv_flow_imp.g_varchar2_table(1105) := '6479297B69662821742E6973426F6479297468726F77206E6577204572726F72282270726F7065727479203C222B742E6E732E6E616D652B223E206D75737420626520626F64792070726F706572747920746F20726566696E65203C222B652E6E732E6E';
wwv_flow_imp.g_varchar2_table(1106) := '616D652B223E22293B746869732E736574426F647950726F706572747928742C2131297D76617220733D722E696E6465784F662865293B6966282D313D3D3D73297468726F77206E6577204572726F72282270726F7065727479203C222B692E6E616D65';
wwv_flow_imp.g_varchar2_table(1107) := '2B223E206E6F7420666F756E6420696E2070726F7065727479206C69737422293B722E73706C69636528732C31292C746869732E61646450726F706572747928742C6E3F766F696420303A732C61292C6F5B692E6E616D655D3D6F5B692E6C6F63616C4E';
wwv_flow_imp.g_varchar2_table(1108) := '616D655D3D747D2C52692E70726F746F747970652E7265646566696E6550726F70657274793D66756E6374696F6E28652C742C6E297B76617220693D652E6E732E7072656669782C723D742E73706C697428222322292C6F3D6B6928725B305D2C69292C';
wwv_flow_imp.g_varchar2_table(1109) := '613D6B6928725B315D2C6F2E707265666978292E6E616D652C733D746869732E70726F7065727469657342794E616D655B615D3B6966282173297468726F77206E6577204572726F722822726566696E65642070726F7065727479203C222B612B223E20';
wwv_flow_imp.g_varchar2_table(1110) := '6E6F7420666F756E6422293B746869732E7265706C61636550726F706572747928732C652C6E292C64656C65746520652E7265646566696E65737D2C52692E70726F746F747970652E6164644E616D656450726F70657274793D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1111) := '2C74297B766172206E3D652E6E732C693D746869732E70726F7065727469657342794E616D653B74262628746869732E6173736572744E6F74446566696E656428652C6E2E6E616D65292C746869732E6173736572744E6F74446566696E656428652C6E';
wwv_flow_imp.g_varchar2_table(1112) := '2E6C6F63616C4E616D6529292C695B6E2E6E616D655D3D695B6E2E6C6F63616C4E616D655D3D657D2C52692E70726F746F747970652E72656D6F76654E616D656450726F70657274793D66756E6374696F6E2865297B76617220743D652E6E732C6E3D74';
wwv_flow_imp.g_varchar2_table(1113) := '6869732E70726F7065727469657342794E616D653B64656C657465206E5B742E6E616D655D2C64656C657465206E5B742E6C6F63616C4E616D655D7D2C52692E70726F746F747970652E736574426F647950726F70657274793D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1114) := '2C74297B696628742626746869732E626F647950726F7065727479297468726F77206E6577204572726F722822626F64792070726F706572747920646566696E6564206D756C7469706C652074696D657320283C222B746869732E626F647950726F7065';
wwv_flow_imp.g_varchar2_table(1115) := '7274792E6E732E6E616D652B223E2C203C222B652E6E732E6E616D652B223E2922293B746869732E626F647950726F70657274793D657D2C52692E70726F746F747970652E736574496450726F70657274793D66756E6374696F6E28652C74297B696628';
wwv_flow_imp.g_varchar2_table(1116) := '742626746869732E696450726F7065727479297468726F77206E6577204572726F72282269642070726F706572747920646566696E6564206D756C7469706C652074696D657320283C222B746869732E696450726F70657274792E6E732E6E616D652B22';
wwv_flow_imp.g_varchar2_table(1117) := '3E2C203C222B652E6E732E6E616D652B223E2922293B746869732E696450726F70657274793D657D2C52692E70726F746F747970652E6173736572744E6F7454726169743D66756E6374696F6E2865297B69662828652E657874656E64737C7C5B5D292E';
wwv_flow_imp.g_varchar2_table(1118) := '6C656E677468297468726F77206E6577204572726F72286063616E6E6F7420637265617465203C247B652E6E616D657D3E20657874656E64696E67203C247B652E657874656E64737D3E60297D2C52692E70726F746F747970652E6173736572744E6F74';
wwv_flow_imp.g_varchar2_table(1119) := '446566696E65643D66756E6374696F6E28652C74297B766172206E3D652E6E616D652C693D746869732E70726F7065727469657342794E616D655B6E5D3B69662869297468726F77206E6577204572726F72282270726F7065727479203C222B6E2B223E';
wwv_flow_imp.g_varchar2_table(1120) := '20616C726561647920646566696E65643B206F76657272696465206F66203C222B692E646566696E656442792E6E732E6E616D652B2223222B692E6E732E6E616D652B223E206279203C222B652E646566696E656442792E6E732E6E616D652B2223222B';
wwv_flow_imp.g_varchar2_table(1121) := '652E6E732E6E616D652B223E206E6F7420616C6C6F77656420776974686F7574207265646566696E657322297D2C52692E70726F746F747970652E68617350726F70657274793D66756E6374696F6E2865297B72657475726E20746869732E70726F7065';
wwv_flow_imp.g_varchar2_table(1122) := '727469657342794E616D655B655D7D2C52692E70726F746F747970652E61646454726169743D66756E6374696F6E28652C74297B742626746869732E6173736572744E6F7454726169742865293B766172206E3D746869732E616C6C547970657342794E';
wwv_flow_imp.g_varchar2_table(1123) := '616D652C693D746869732E616C6C54797065732C723D652E6E616D653B7220696E206E7C7C286628652E70726F706572746965732C45282866756E6374696F6E286E297B6E3D53287B7D2C6E2C7B6E616D653A6E2E6E732E6C6F63616C4E616D652C696E';
wwv_flow_imp.g_varchar2_table(1124) := '686572697465643A747D292C4F626A6563742E646566696E6550726F7065727479286E2C22646566696E65644279222C7B76616C75653A657D293B76617220693D6E2E7265706C616365732C723D6E2E7265646566696E65733B697C7C723F746869732E';
wwv_flow_imp.g_varchar2_table(1125) := '7265646566696E6550726F7065727479286E2C697C7C722C69293A286E2E6973426F64792626746869732E736574426F647950726F7065727479286E292C6E2E697349642626746869732E736574496450726F7065727479286E292C746869732E616464';
wwv_flow_imp.g_varchar2_table(1126) := '50726F7065727479286E29297D292C7468697329292C692E707573682865292C6E5B725D3D65297D2C4D692E70726F746F747970652E6765745061636B6167653D66756E6374696F6E2865297B72657475726E20746869732E7061636B6167654D61705B';
wwv_flow_imp.g_varchar2_table(1127) := '655D7D2C4D692E70726F746F747970652E6765745061636B616765733D66756E6374696F6E28297B72657475726E20746869732E7061636B616765737D2C4D692E70726F746F747970652E72656769737465725061636B6167653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1128) := '65297B653D53287B7D2C65293B76617220743D746869732E7061636B6167654D61703B506928742C652C2270726566697822292C506928742C652C2275726922292C6628652E74797065732C45282866756E6374696F6E2874297B746869732E72656769';
wwv_flow_imp.g_varchar2_table(1129) := '737465725479706528742C65297D292C7468697329292C745B652E7572695D3D745B652E7072656669785D3D652C746869732E7061636B616765732E707573682865297D2C4D692E70726F746F747970652E7265676973746572547970653D66756E6374';
wwv_flow_imp.g_varchar2_table(1130) := '696F6E28652C74297B766172206E3D6B692828653D53287B7D2C652C7B7375706572436C6173733A28652E7375706572436C6173737C7C5B5D292E736C69636528292C657874656E64733A28652E657874656E64737C7C5B5D292E736C69636528292C70';
wwv_flow_imp.g_varchar2_table(1131) := '726F706572746965733A28652E70726F706572746965737C7C5B5D292E736C69636528292C6D6574613A5328652E6D6574617C7C7B7D297D29292E6E616D652C742E707265666978292C693D6E2E6E616D652C723D7B7D3B6628652E70726F7065727469';
wwv_flow_imp.g_varchar2_table(1132) := '65732C45282866756E6374696F6E2865297B76617220743D6B6928652E6E616D652C6E2E707265666978292C693D742E6E616D653B416928652E74797065297C7C28652E747970653D6B6928652E747970652C742E707265666978292E6E616D65292C53';
wwv_flow_imp.g_varchar2_table(1133) := '28652C7B6E733A742C6E616D653A697D292C725B695D3D657D292C7468697329292C5328652C7B6E733A6E2C6E616D653A692C70726F7065727469657342794E616D653A727D292C6628652E657874656E64732C45282866756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(1134) := '617220743D6B6928652C6E2E707265666978292C723D746869732E747970654D61705B742E6E616D655D3B722E7472616974733D722E7472616974737C7C5B5D2C722E7472616974732E707573682869297D292C7468697329292C746869732E64656669';
wwv_flow_imp.g_varchar2_table(1135) := '6E655061636B61676528652C74292C746869732E747970654D61705B695D3D657D2C4D692E70726F746F747970652E6D617054797065733D66756E6374696F6E28652C742C6E297B76617220693D416928652E6E616D65293F7B6E616D653A652E6E616D';
wwv_flow_imp.g_varchar2_table(1136) := '657D3A746869732E747970654D61705B652E6E616D655D2C723D746869733B66756E6374696F6E206F286E2C69297B766172206F3D6B69286E2C4169286E293F22223A652E707265666978293B722E6D61705479706573286F2C742C69297D66756E6374';
wwv_flow_imp.g_varchar2_table(1137) := '696F6E20612865297B72657475726E206F28652C2130297D6966282169297468726F77206E6577204572726F722822756E6B6E6F776E2074797065203C222B652E6E616D652B223E22293B6628692E7375706572436C6173732C6E3F613A66756E637469';
wwv_flow_imp.g_varchar2_table(1138) := '6F6E2865297B72657475726E206F28652C2131297D292C7428692C216E292C6628692E7472616974732C61297D2C4D692E70726F746F747970652E67657445666665637469766544657363726970746F723D66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(1139) := '6B692865292C6E3D6E65772052692874293B746869732E6D6170547970657328742C2866756E6374696F6E28652C74297B6E2E616464547261697428652C74297D29293B76617220693D6E2E6275696C6428293B72657475726E20746869732E64656669';
wwv_flow_imp.g_varchar2_table(1140) := '6E655061636B61676528692C692E616C6C54797065735B692E616C6C54797065732E6C656E6774682D315D2E24706B67292C697D2C4D692E70726F746F747970652E646566696E655061636B6167653D66756E6374696F6E28652C74297B746869732E70';
wwv_flow_imp.g_varchar2_table(1141) := '726F706572746965732E646566696E6528652C2224706B67222C7B76616C75653A747D297D2C44692E70726F746F747970652E7365743D66756E6374696F6E28652C742C6E297B69662821752874297C7C21742E6C656E677468297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(1142) := '20547970654572726F72282270726F7065727479206E616D65206D7573742062652061206E6F6E2D656D70747920737472696E6722293B76617220693D746869732E67657450726F706572747928652C74292C723D692626692E6E616D653B766F696420';
wwv_flow_imp.g_varchar2_table(1143) := '303D3D3D6E3F693F64656C65746520655B725D3A64656C65746520652E2461747472735B4F692874295D3A693F7220696E20653F655B725D3D6E3A426928652C692C6E293A652E2461747472735B4F692874295D3D6E7D2C44692E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1144) := '2E6765743D66756E6374696F6E28652C74297B766172206E3D746869732E67657450726F706572747928652C74293B696628216E2972657475726E20652E2461747472735B4F692874295D3B76617220693D6E2E6E616D653B72657475726E21655B695D';
wwv_flow_imp.g_varchar2_table(1145) := '26266E2E69734D616E792626426928652C6E2C5B5D292C655B695D7D2C44692E70726F746F747970652E646566696E653D66756E6374696F6E28652C742C6E297B696628216E2E7772697461626C65297B76617220693D6E2E76616C75653B64656C6574';
wwv_flow_imp.g_varchar2_table(1146) := '65286E3D53287B7D2C6E2C7B6765743A66756E6374696F6E28297B72657475726E20697D7D29292E76616C75657D4F626A6563742E646566696E6550726F706572747928652C742C6E297D2C44692E70726F746F747970652E646566696E654465736372';
wwv_flow_imp.g_varchar2_table(1147) := '6970746F723D66756E6374696F6E28652C74297B746869732E646566696E6528652C222464657363726970746F72222C7B76616C75653A747D297D2C44692E70726F746F747970652E646566696E654D6F64656C3D66756E6374696F6E28652C74297B74';
wwv_flow_imp.g_varchar2_table(1148) := '6869732E646566696E6528652C22246D6F64656C222C7B76616C75653A747D297D2C44692E70726F746F747970652E67657450726F70657274793D66756E6374696F6E28652C74297B766172206E3D746869732E6D6F64656C2C693D6E2E67657450726F';
wwv_flow_imp.g_varchar2_table(1149) := '706572747944657363726970746F7228652C74293B696628692972657475726E20693B696628742E696E636C7564657328223A22292972657475726E206E756C6C3B636F6E737420723D6E2E636F6E6669672E7374726963743B696628766F6964203021';
wwv_flow_imp.g_varchar2_table(1150) := '3D3D72297B636F6E7374206E3D6E657720547970654572726F722860756E6B6E6F776E2070726F7065727479203C247B747D3E206F6E203C247B652E24747970657D3E60293B69662872297468726F77206E3B22756E646566696E656422213D74797065';
wwv_flow_imp.g_varchar2_table(1151) := '6F6620636F6E736F6C652626636F6E736F6C652E7761726E286E297D72657475726E206E756C6C7D2C54692E70726F746F747970652E6372656174653D66756E6374696F6E28652C74297B766172206E3D746869732E676574547970652865293B696628';
wwv_flow_imp.g_varchar2_table(1152) := '216E297468726F77206E6577204572726F722822756E6B6E6F776E2074797065203C222B652B223E22293B72657475726E206E6577206E2874297D2C54692E70726F746F747970652E676574547970653D66756E6374696F6E2865297B76617220743D74';
wwv_flow_imp.g_varchar2_table(1153) := '6869732E7479706543616368652C6E3D752865293F653A652E6E732E6E616D652C693D745B6E5D3B72657475726E20697C7C28653D746869732E72656769737472792E67657445666665637469766544657363726970746F72286E292C693D745B6E5D3D';
wwv_flow_imp.g_varchar2_table(1154) := '746869732E666163746F72792E63726561746554797065286529292C697D2C54692E70726F746F747970652E637265617465416E793D66756E6374696F6E28652C742C6E297B76617220693D6B692865292C723D7B24747970653A652C24696E7374616E';
wwv_flow_imp.g_varchar2_table(1155) := '63654F663A66756E6374696F6E2865297B72657475726E20653D3D3D746869732E24747970657D2C6765743A66756E6374696F6E2865297B72657475726E20746869735B655D7D2C7365743A66756E6374696F6E28652C74297B2166756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1156) := '652C742C6E297B6C657420693D653B6628742C2866756E6374696F6E28652C72297B696628226E756D62657222213D747970656F662065262622737472696E6722213D747970656F662065297468726F77206E6577204572726F722822696C6C6567616C';
wwv_flow_imp.g_varchar2_table(1157) := '206B657920747970653A20222B747970656F6620652B222E204B65792073686F756C64206265206F662074797065206E756D626572206F7220737472696E672E22293B69662822636F6E7374727563746F72223D3D3D65297468726F77206E6577204572';
wwv_flow_imp.g_varchar2_table(1158) := '726F722822696C6C6567616C206B65793A20636F6E7374727563746F7222293B696628225F5F70726F746F5F5F223D3D3D65297468726F77206E6577204572726F722822696C6C6567616C206B65793A205F5F70726F746F5F5F22293B6C657420733D74';
wwv_flow_imp.g_varchar2_table(1159) := '5B722B315D2C6C3D695B655D3B6128732926266E756C6C3D3D6C2626286C3D695B655D3D69734E614E282B73293F7B7D3A5B5D292C6F2873293F6F286E293F64656C65746520695B655D3A695B655D3D6E3A693D6C7D29297D28746869732C5B655D2C74';
wwv_flow_imp.g_varchar2_table(1160) := '297D7D2C733D7B6E616D653A652C697347656E657269633A21302C6E733A7B7072656669783A692E7072656669782C6C6F63616C4E616D653A692E6C6F63616C4E616D652C7572693A747D7D3B72657475726E20746869732E70726F706572746965732E';
wwv_flow_imp.g_varchar2_table(1161) := '646566696E6544657363726970746F7228722C73292C746869732E70726F706572746965732E646566696E654D6F64656C28722C74686973292C746869732E70726F706572746965732E646566696E6528722C22676574222C7B656E756D657261626C65';
wwv_flow_imp.g_varchar2_table(1162) := '3A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E6528722C22736574222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E65';
wwv_flow_imp.g_varchar2_table(1163) := '28722C2224706172656E74222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E6528722C2224696E7374616E63654F66222C7B656E756D657261626C653A21312C77726974';
wwv_flow_imp.g_varchar2_table(1164) := '61626C653A21307D292C66286E2C2866756E6374696F6E28652C74297B6C2865292626766F69642030213D3D652E76616C75653F725B652E6E616D655D3D652E76616C75653A725B745D3D657D29292C727D2C54692E70726F746F747970652E67657450';
wwv_flow_imp.g_varchar2_table(1165) := '61636B6167653D66756E6374696F6E2865297B72657475726E20746869732E72656769737472792E6765745061636B6167652865297D2C54692E70726F746F747970652E6765745061636B616765733D66756E6374696F6E28297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(1166) := '69732E72656769737472792E6765745061636B6167657328297D2C54692E70726F746F747970652E676574456C656D656E7444657363726970746F723D66756E6374696F6E2865297B72657475726E20652E2464657363726970746F727D2C54692E7072';
wwv_flow_imp.g_varchar2_table(1167) := '6F746F747970652E686173547970653D66756E6374696F6E28652C74297B72657475726E20766F696420303D3D3D74262628743D652C653D74686973292C7420696E20652E246D6F64656C2E676574456C656D656E7444657363726970746F722865292E';
wwv_flow_imp.g_varchar2_table(1168) := '616C6C547970657342794E616D657D2C54692E70726F746F747970652E67657450726F706572747944657363726970746F723D66756E6374696F6E28652C74297B72657475726E20746869732E676574456C656D656E7444657363726970746F72286529';
wwv_flow_imp.g_varchar2_table(1169) := '2E70726F7065727469657342794E616D655B745D7D2C54692E70726F746F747970652E6765745479706544657363726970746F723D66756E6374696F6E2865297B72657475726E20746869732E72656769737472792E747970654D61705B655D7D3B7661';
wwv_flow_imp.g_varchar2_table(1170) := '72204E693D537472696E672E66726F6D43686172436F64652C49693D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C4C693D2F2623285C642B293B7C262378285B302D39612D665D2B293B7C26285C772B293B2F67692C';
wwv_flow_imp.g_varchar2_table(1171) := '6A693D7B616D703A2226222C61706F733A2227222C67743A223E222C6C743A223C222C71756F743A2722277D3B66756E6374696F6E20466928652C742C6E2C69297B72657475726E20693F49692E63616C6C286A692C69293F6A695B695D3A2226222B69';
wwv_flow_imp.g_varchar2_table(1172) := '2B223B223A4E6928747C7C7061727365496E74286E2C313629297D66756E6374696F6E2056692865297B72657475726E20652E6C656E6774683E3326262D31213D3D652E696E6465784F6628222622293F652E7265706C616365284C692C4669293A657D';
wwv_flow_imp.g_varchar2_table(1173) := '4F626A6563742E6B657973286A69292E666F7245616368282866756E6374696F6E2865297B6A695B652E746F55707065724361736528295D3D6A695B655D7D29293B7661722024693D227873693A74797065222C7A693D226E6F6E2D7768697465737061';
wwv_flow_imp.g_varchar2_table(1174) := '6365206F757473696465206F6620726F6F74206E6F6465223B66756E6374696F6E2057692865297B72657475726E206E6577204572726F722865297D66756E6374696F6E2047692865297B72657475726E226D697373696E67206E616D65737061636520';
wwv_flow_imp.g_varchar2_table(1175) := '666F7220707265666978203C222B652B223E227D66756E6374696F6E2048692865297B72657475726E7B6765743A652C656E756D657261626C653A21307D7D66756E6374696F6E204B692865297B76617220742C6E3D7B7D3B666F72287420696E206529';
wwv_flow_imp.g_varchar2_table(1176) := '6E5B745D3D655B745D3B72657475726E206E7D66756E6374696F6E2055692865297B72657475726E20652B2224757269227D66756E6374696F6E20716928297B72657475726E7B6C696E653A302C636F6C756D6E3A307D7D66756E6374696F6E20596928';
wwv_flow_imp.g_varchar2_table(1177) := '65297B7468726F7720657D66756E6374696F6E2058692865297B69662821746869732972657475726E206E65772058692865293B76617220742C6E2C692C722C6F2C612C732C6C2C632C703D652626652E70726F78792C753D59692C683D71692C643D21';
wwv_flow_imp.g_varchar2_table(1178) := '312C6D3D21312C663D6E756C6C2C793D21313B66756E6374696F6E20672865297B6520696E7374616E63656F66204572726F727C7C28653D5769286529292C663D652C7528652C68297D66756E6374696F6E20762865297B6F2626286520696E7374616E';
wwv_flow_imp.g_varchar2_table(1179) := '63656F66204572726F727C7C28653D5769286529292C6F28652C6829297D746869732E6F6E3D66756E6374696F6E28652C63297B6966282266756E6374696F6E22213D747970656F662063297468726F7720576928227265717569726564206172677320';
wwv_flow_imp.g_varchar2_table(1180) := '3C6E616D652C2063623E22293B7377697463682865297B63617365226F70656E546167223A6E3D633B627265616B3B636173652274657874223A743D633B627265616B3B6361736522636C6F7365546167223A693D633B627265616B3B63617365226572';
wwv_flow_imp.g_varchar2_table(1181) := '726F72223A753D633B627265616B3B63617365227761726E223A6F3D633B627265616B3B63617365226364617461223A723D633B627265616B3B6361736522617474656E74696F6E223A6C3D633B627265616B3B63617365227175657374696F6E223A73';
wwv_flow_imp.g_varchar2_table(1182) := '3D633B627265616B3B6361736522636F6D6D656E74223A613D633B627265616B3B64656661756C743A7468726F772057692822756E737570706F72746564206576656E743A20222B65297D72657475726E20746869737D2C746869732E6E733D66756E63';
wwv_flow_imp.g_varchar2_table(1183) := '74696F6E2865297B696628766F696420303D3D3D65262628653D7B7D292C226F626A65637422213D747970656F662065297468726F77205769282272657175697265642061726773203C6E734D61703D7B7D3E22293B76617220742C6E3D7B7D3B666F72';
wwv_flow_imp.g_varchar2_table(1184) := '287420696E2065296E5B745D3D655B745D3B72657475726E206E5B22687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365225D3D22787369222C6D3D21302C633D6E2C746869737D2C746869732E7061';
wwv_flow_imp.g_varchar2_table(1185) := '7273653D66756E6374696F6E2865297B69662822737472696E6722213D747970656F662065297468726F77205769282272657175697265642061726773203C786D6C3D737472696E673E22293B72657475726E20663D6E756C6C2C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1186) := '65297B766172206F2C752C662C622C782C772C5F2C452C532C412C432C6B3D6D3F5B5D3A6E756C6C2C523D6D3F66756E6374696F6E2865297B76617220742C6E2C693D7B7D3B666F72287420696E206529695B6E3D655B745D5D3D6E2C695B5569286E29';
wwv_flow_imp.g_varchar2_table(1187) := '5D3D743B72657475726E20697D2863293A6E756C6C2C4D3D5B5D2C503D302C443D21312C423D21312C4F3D302C543D302C4E3D22222C493D303B66756E6374696F6E204C28297B6966286E756C6C213D3D432972657475726E20433B76617220652C742C';
wwv_flow_imp.g_varchar2_table(1188) := '6E2C692C722C6F2C612C732C6C2C702C752C683D6D2626522E786D6C6E732C663D6D2626643F5B5D3A6E756C6C2C793D492C673D4E2C623D672E6C656E6774682C783D7B7D2C773D7B7D3B653A666F72283B793C623B792B2B296966286C3D21312C2128';
wwv_flow_imp.g_varchar2_table(1189) := '33323D3D3D28703D672E63686172436F64654174287929297C7C703C31342626703E3829297B666F722828703C36357C7C703E3132327C7C703E39302626703C39372926263935213D3D7026263538213D3D70262628762822696C6C6567616C20666972';
wwv_flow_imp.g_varchar2_table(1190) := '7374206368617220617474726962757465206E616D6522292C6C3D2130292C753D792B313B753C623B752B2B29696628212828703D672E63686172436F64654174287529293E39362626703C3132337C7C703E36342626703C39317C7C703E3437262670';
wwv_flow_imp.g_varchar2_table(1191) := '3C35397C7C34363D3D3D707C7C34353D3D3D707C7C39353D3D3D7029297B69662833323D3D3D707C7C703C31342626703E38297B7628226D697373696E67206174747269627574652076616C756522292C793D753B636F6E74696E756520657D69662836';
wwv_flow_imp.g_varchar2_table(1192) := '313D3D3D7029627265616B3B762822696C6C6567616C20617474726962757465206E616D65206368617222292C6C3D21307D69662822786D6C6E733A786D6C6E73223D3D3D28733D672E737562737472696E6728792C752929262628762822696C6C6567';
wwv_flow_imp.g_varchar2_table(1193) := '616C206465636C61726174696F6E206F6620786D6C6E7322292C6C3D2130292C33343D3D3D28703D672E63686172436F6465417428752B312929292D313D3D3D28753D672E696E6465784F66282722272C793D752B32292926262D31213D3D28753D672E';
wwv_flow_imp.g_varchar2_table(1194) := '696E6465784F66282227222C7929292626287628226174747269627574652076616C75652071756F7465206D6973736D6174636822292C6C3D2130293B656C73652069662833393D3D3D70292D313D3D3D28753D672E696E6465784F66282227222C793D';
wwv_flow_imp.g_varchar2_table(1195) := '752B32292926262D31213D3D28753D672E696E6465784F66282722272C7929292626287628226174747269627574652076616C75652071756F7465206D6973736D6174636822292C6C3D2130293B656C736520666F72287628226D697373696E67206174';
wwv_flow_imp.g_varchar2_table(1196) := '747269627574652076616C75652071756F74657322292C6C3D21302C752B3D313B753C622626212833323D3D3D28703D672E63686172436F6465417428752B3129297C7C703C31342626703E38293B752B2B293B666F72282D313D3D3D75262628762822';
wwv_flow_imp.g_varchar2_table(1197) := '6D697373696E6720636C6F73696E672071756F74657322292C753D622C6C3D2130292C6C7C7C286F3D672E737562737472696E6728792C7529292C793D753B752B313C622626212833323D3D3D28703D672E63686172436F6465417428752B3129297C7C';
wwv_flow_imp.g_varchar2_table(1198) := '703C31342626703E38293B752B2B29793D3D3D75262628762822696C6C6567616C206368617261637465722061667465722061747472696275746520656E6422292C6C3D2130293B696628793D752B312C216C296966287320696E207729762822617474';
wwv_flow_imp.g_varchar2_table(1199) := '726962757465203C222B732B223E20616C726561647920646566696E656422293B656C736520696628775B735D3D21302C6D2969662864297B6966286E756C6C213D3D28723D22786D6C6E73223D3D3D733F22786D6C6E73223A3132303D3D3D732E6368';
wwv_flow_imp.g_varchar2_table(1200) := '6172436F64654174283029262622786D6C6E733A223D3D3D732E73756273747228302C36293F732E7375627374722836293A6E756C6C29297B696628653D5669286F292C743D55692872292C2128613D635B655D29297B69662822786D6C6E73223D3D3D';
wwv_flow_imp.g_varchar2_table(1201) := '727C7C7420696E20522626525B745D213D3D6529646F7B613D226E73222B502B2B7D7768696C6528766F69642030213D3D525B615D293B656C736520613D723B635B655D3D617D525B725D213D3D61262628697C7C28523D4B692852292C693D2130292C';
wwv_flow_imp.g_varchar2_table(1202) := '525B725D3D612C22786D6C6E73223D3D3D72262628525B55692861295D3D652C683D61292C525B745D3D65292C785B735D3D6F3B636F6E74696E75657D662E7075736828732C6F297D656C73652D31213D3D28703D732E696E6465784F6628223A222929';
wwv_flow_imp.g_varchar2_table(1203) := '3F286E3D525B732E737562737472696E6728302C70295D293F2828733D683D3D3D6E3F732E73756273747228702B31293A6E2B732E737562737472287029293D3D3D24692626282D31213D3D28703D6F2E696E6465784F6628223A2229293F286E3D6F2E';
wwv_flow_imp.g_varchar2_table(1204) := '737562737472696E6728302C70292C6F3D286E3D525B6E5D7C7C6E292B6F2E737562737472696E67287029293A6F3D682B223A222B6F292C785B735D3D6F293A7628476928732E737562737472696E6728302C702929293A785B735D3D6F3B656C736520';
wwv_flow_imp.g_varchar2_table(1205) := '785B735D3D6F7D6966286429666F7228793D302C623D662E6C656E6774683B793C623B792B2B297B696628733D665B792B2B5D2C6F3D665B795D2C2D31213D3D28703D732E696E6465784F6628223A222929297B69662821286E3D525B732E7375627374';
wwv_flow_imp.g_varchar2_table(1206) := '72696E6728302C70295D29297B7628476928732E737562737472696E6728302C702929293B636F6E74696E75657D28733D683D3D3D6E3F732E73756273747228702B31293A6E2B732E737562737472287029293D3D3D24692626282D31213D3D28703D6F';
wwv_flow_imp.g_varchar2_table(1207) := '2E696E6465784F6628223A2229293F286E3D6F2E737562737472696E6728302C70292C6F3D286E3D525B6E5D7C7C6E292B6F2E737562737472696E67287029293A6F3D682B223A222B6F297D785B735D3D6F7D72657475726E20433D787D666F7228683D';
wwv_flow_imp.g_varchar2_table(1208) := '66756E6374696F6E28297B666F722876617220742C6E2C693D2F285C725C6E7C5C727C5C6E292F672C723D302C6F3D302C613D302C733D543B4F3E3D61262628743D692E65786563286529292626212828733D745B305D2E6C656E6774682B742E696E64';
wwv_flow_imp.g_varchar2_table(1209) := '6578293E4F293B29722B3D312C613D733B72657475726E2D313D3D4F3F286F3D732C6E3D652E737562737472696E67285429293A303D3D3D543F6E3D652E737562737472696E6728542C4F293A286F3D4F2D612C6E3D2D313D3D543F652E737562737472';
wwv_flow_imp.g_varchar2_table(1210) := '696E67284F293A652E737562737472696E67284F2C542B3129292C7B646174613A6E2C6C696E653A722C636F6C756D6E3A6F7D7D2C70262628413D4F626A6563742E637265617465287B7D2C7B6E616D653A4869282866756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(1211) := '75726E20457D29292C6F726967696E616C4E616D653A4869282866756E6374696F6E28297B72657475726E20537D29292C61747472733A4869284C292C6E733A4869282866756E6374696F6E28297B72657475726E20527D29297D29293B2D31213D3D54';
wwv_flow_imp.g_varchar2_table(1212) := '3B297B6966282D313D3D3D284F3D36303D3D3D652E63686172436F646541742854293F543A652E696E6465784F6628223C222C5429292972657475726E204D2E6C656E6774683F672822756E657870656374656420656E64206F662066696C6522293A30';
wwv_flow_imp.g_varchar2_table(1213) := '3D3D3D543F6728226D697373696E672073746172742074616722293A766F696428543C652E6C656E6774682626652E737562737472696E672854292E7472696D2829262676287A6929293B69662854213D3D4F296966284D2E6C656E677468297B696628';
wwv_flow_imp.g_varchar2_table(1214) := '742626287428652E737562737472696E6728542C4F292C56692C68292C79292972657475726E7D656C736520696628652E737562737472696E6728542C4F292E7472696D282926262876287A69292C79292972657475726E3B69662833333D3D3D28783D';
wwv_flow_imp.g_varchar2_table(1215) := '652E63686172436F64654174284F2B312929297B69662839313D3D3D28623D652E63686172436F64654174284F2B32292926262243444154415B223D3D3D652E737562737472284F2B332C3629297B6966282D313D3D3D28543D652E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(1216) := '225D5D3E222C4F29292972657475726E20672822756E636C6F73656420636461746122293B696628722626287228652E737562737472696E67284F2B392C54292C68292C79292972657475726E3B542B3D333B636F6E74696E75657D69662834353D3D3D';
wwv_flow_imp.g_varchar2_table(1217) := '62262634353D3D3D652E63686172436F64654174284F2B3329297B6966282D313D3D3D28543D652E696E6465784F6628222D2D5C783365222C4F29292972657475726E20672822756E636C6F73656420636F6D6D656E7422293B69662861262628612865';
wwv_flow_imp.g_varchar2_table(1218) := '2E737562737472696E67284F2B342C54292C56692C68292C79292972657475726E3B542B3D333B636F6E74696E75657D7D6966283633213D3D78297B666F7228753D4F2B313B3B752B2B297B696628773D652E63686172436F646541742875292C69734E';
wwv_flow_imp.g_varchar2_table(1219) := '614E2877292972657475726E20543D2D312C672822756E636C6F7365642074616722293B69662833343D3D3D7729753D2D31213D3D28623D652E696E6465784F66282722272C752B3129293F623A753B656C73652069662833393D3D3D7729753D2D3121';
wwv_flow_imp.g_varchar2_table(1220) := '3D3D28623D652E696E6465784F66282227222C752B3129293F623A753B656C73652069662836323D3D3D77297B543D753B627265616B7D7D6966283333213D3D78297B696628433D7B7D2C34373D3D3D78297B696628443D21312C423D21302C214D2E6C';
wwv_flow_imp.g_varchar2_table(1221) := '656E6774682972657475726E206728226D697373696E67206F70656E2074616722293B696628753D453D4D2E706F7028292C623D4F2B322B752E6C656E6774682C652E737562737472696E67284F2B322C6229213D3D752972657475726E20672822636C';
wwv_flow_imp.g_varchar2_table(1222) := '6F73696E6720746167206D69736D6174636822293B666F72283B623C543B622B2B29696628212833323D3D3D28783D652E63686172436F64654174286229297C7C783E382626783C3134292972657475726E20672822636C6F73652074616722297D656C';
wwv_flow_imp.g_varchar2_table(1223) := '73657B69662834373D3D3D652E63686172436F6465417428542D31293F28753D453D652E737562737472696E67284F2B312C542D31292C443D21302C423D2130293A28753D453D652E737562737472696E67284F2B312C54292C443D21302C423D213129';
wwv_flow_imp.g_varchar2_table(1224) := '2C2128783E39362626783C3132337C7C783E36342626783C39317C7C39353D3D3D787C7C35383D3D3D78292972657475726E20672822696C6C6567616C2066697273742063686172206E6F64654E616D6522293B666F7228623D312C663D752E6C656E67';
wwv_flow_imp.g_varchar2_table(1225) := '74683B623C663B622B2B29696628212828783D752E63686172436F64654174286229293E39362626783C3132337C7C783E36342626783C39317C7C783E34372626783C35397C7C34353D3D3D787C7C39353D3D3D787C7C34363D3D7829297B6966283332';
wwv_flow_imp.g_varchar2_table(1226) := '3D3D3D787C7C783C31342626783E38297B453D752E737562737472696E6728302C62292C433D6E756C6C3B627265616B7D72657475726E20672822696E76616C6964206E6F64654E616D6522297D427C7C4D2E707573682845297D6966286D297B696628';
wwv_flow_imp.g_varchar2_table(1227) := '6F3D522C44262628427C7C6B2E70757368286F292C6E756C6C3D3D3D43262628643D2D31213D3D752E696E6465784F662822786D6C6E73222C622929262628493D622C4E3D752C4C28292C643D213129292C533D452C2D31213D3D28783D452E696E6465';
wwv_flow_imp.g_varchar2_table(1228) := '784F6628223A222929297B69662821285F3D525B452E737562737472696E6728302C78295D292972657475726E206728226D697373696E67206E616D657370616365206F6E203C222B532B223E22293B453D452E73756273747228782B31297D656C7365';
wwv_flow_imp.g_varchar2_table(1229) := '205F3D522E786D6C6E733B5F262628453D5F2B223A222B45297D69662844262628493D622C4E3D752C6E262628703F6E28412C56692C422C68293A6E28452C4C2C56692C422C68292C7929292972657475726E3B69662842297B69662869262628692870';
wwv_flow_imp.g_varchar2_table(1230) := '3F413A452C56692C442C68292C79292972657475726E3B6D262628523D443F6F3A6B2E706F702829297D542B3D317D656C73657B6966286C2626286C28652E737562737472696E67284F2C542B31292C56692C68292C79292972657475726E3B542B3D31';
wwv_flow_imp.g_varchar2_table(1231) := '7D7D656C73657B6966282D313D3D3D28543D652E696E6465784F6628223F3E222C4F29292972657475726E20672822756E636C6F736564207175657374696F6E22293B696628732626287328652E737562737472696E67284F2C542B32292C68292C7929';
wwv_flow_imp.g_varchar2_table(1232) := '2972657475726E3B542B3D327D7D7D2865292C683D71692C793D21312C667D2C746869732E73746F703D66756E6374696F6E28297B793D21307D7D66756E6374696F6E205A692865297B72657475726E20652E786D6C2626226C6F77657243617365223D';
wwv_flow_imp.g_varchar2_table(1233) := '3D3D652E786D6C2E746167416C6961737D766172204A693D7B7873693A22687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365222C786D6C3A22687474703A2F2F7777772E77332E6F72672F584D4C2F';
wwv_flow_imp.g_varchar2_table(1234) := '313939382F6E616D657370616365227D2C51693D227873693A74797065223B66756E6374696F6E2065722865297B72657475726E20652E786D6C2626652E786D6C2E73657269616C697A657D66756E6374696F6E2074722865297B72657475726E206572';
wwv_flow_imp.g_varchar2_table(1235) := '2865293D3D3D51697D66756E6374696F6E206E7228652C74297B72657475726E205A692874293F652E7072656669782B223A222B28286E3D652E6C6F63616C4E616D65292E6368617241742830292E746F55707065724361736528292B6E2E736C696365';
wwv_flow_imp.g_varchar2_table(1236) := '283129293A652E6E616D653B766172206E7D66756E6374696F6E2069722865297B72657475726E206E6577204572726F722865297D66756E6374696F6E2072722865297B72657475726E20652E2464657363726970746F727D66756E6374696F6E206F72';
wwv_flow_imp.g_varchar2_table(1237) := '2865297B5328746869732C65292C746869732E656C656D656E7473427949643D7B7D2C746869732E7265666572656E6365733D5B5D2C746869732E7761726E696E67733D5B5D2C746869732E6164645265666572656E63653D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(1238) := '7B746869732E7265666572656E6365732E707573682865297D2C746869732E616464456C656D656E743D66756E6374696F6E2865297B6966282165297468726F772069722822657870656374656420656C656D656E7422293B76617220742C6E3D746869';
wwv_flow_imp.g_varchar2_table(1239) := '732E656C656D656E7473427949642C693D72722865292E696450726F70657274793B69662869262628743D652E67657428692E6E616D652929297B696628212F5E285B612D7A5D5B5C772D2E5D2A3A293F5B612D7A5F5D5B5C772D2E5D2A242F692E7465';
wwv_flow_imp.g_varchar2_table(1240) := '7374287429297468726F77206E6577204572726F722822696C6C6567616C204944203C222B742B223E22293B6966286E5B745D297468726F7720697228226475706C6963617465204944203C222B742B223E22293B6E5B745D3D657D7D2C746869732E61';
wwv_flow_imp.g_varchar2_table(1241) := '64645761726E696E673D66756E6374696F6E2865297B746869732E7761726E696E67732E707573682865297D7D66756E6374696F6E20617228297B7D66756E6374696F6E20737228297B7D66756E6374696F6E206C7228297B7D66756E6374696F6E2063';
wwv_flow_imp.g_varchar2_table(1242) := '7228652C74297B746869732E70726F70657274793D652C746869732E636F6E746578743D747D66756E6374696F6E20707228652C74297B746869732E656C656D656E743D742C746869732E70726F7065727479446573633D657D66756E6374696F6E2075';
wwv_flow_imp.g_varchar2_table(1243) := '7228297B7D66756E6374696F6E20687228652C742C6E297B746869732E6D6F64656C3D652C746869732E747970653D652E676574547970652874292C746869732E636F6E746578743D6E7D66756E6374696F6E20647228652C742C6E297B68722E63616C';
wwv_flow_imp.g_varchar2_table(1244) := '6C28746869732C652C742C6E297D66756E6374696F6E206D7228652C742C6E297B746869732E6D6F64656C3D652C746869732E636F6E746578743D6E7D66756E6374696F6E2066722865297B6520696E7374616E63656F66205469262628653D7B6D6F64';
wwv_flow_imp.g_varchar2_table(1245) := '656C3A657D292C5328746869732C7B6C61783A21317D2C65297D61722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B7D2C61722E70726F746F747970652E68616E646C65546578743D66756E6374696F6E28297B7D2C61';
wwv_flow_imp.g_varchar2_table(1246) := '722E70726F746F747970652E68616E646C654E6F64653D66756E6374696F6E28297B7D2C73722E70726F746F747970653D4F626A6563742E6372656174652861722E70726F746F74797065292C73722E70726F746F747970652E68616E646C654E6F6465';
wwv_flow_imp.g_varchar2_table(1247) := '3D66756E6374696F6E28297B72657475726E20746869737D2C6C722E70726F746F747970653D4F626A6563742E6372656174652861722E70726F746F74797065292C6C722E70726F746F747970652E68616E646C65546578743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1248) := '297B746869732E626F64793D28746869732E626F64797C7C2222292B657D2C63722E70726F746F747970653D4F626A6563742E637265617465286C722E70726F746F74797065292C63722E70726F746F747970652E68616E646C654E6F64653D66756E63';
wwv_flow_imp.g_varchar2_table(1249) := '74696F6E2865297B696628746869732E656C656D656E74297468726F7720697228226578706563746564206E6F20737562206E6F64657322293B72657475726E20746869732E656C656D656E743D746869732E6372656174655265666572656E63652865';
wwv_flow_imp.g_varchar2_table(1250) := '292C746869737D2C63722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B746869732E656C656D656E742E69643D746869732E626F64797D2C63722E70726F746F747970652E6372656174655265666572656E63653D6675';
wwv_flow_imp.g_varchar2_table(1251) := '6E6374696F6E2865297B72657475726E7B70726F70657274793A746869732E70726F70657274792E6E732E6E616D652C69643A22227D7D2C70722E70726F746F747970653D4F626A6563742E637265617465286C722E70726F746F74797065292C70722E';
wwv_flow_imp.g_varchar2_table(1252) := '70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B76617220653D746869732E626F64797C7C22222C743D746869732E656C656D656E742C6E3D746869732E70726F7065727479446573633B653D5369286E2E747970652C6529';
wwv_flow_imp.g_varchar2_table(1253) := '2C6E2E69734D616E793F742E676574286E2E6E616D65292E707573682865293A742E736574286E2E6E616D652C65297D2C75722E70726F746F747970653D4F626A6563742E637265617465286C722E70726F746F74797065292C75722E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1254) := '70652E68616E646C654E6F64653D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E656C656D656E743B72657475726E206E3F743D746869732E68616E646C654368696C642865293A286E3D746869732E656C656D656E743D74';
wwv_flow_imp.g_varchar2_table(1255) := '6869732E637265617465456C656D656E742865292C746869732E636F6E746578742E616464456C656D656E74286E29292C747D2C68722E70726F746F747970653D4F626A6563742E6372656174652875722E70726F746F74797065292C68722E70726F74';
wwv_flow_imp.g_varchar2_table(1256) := '6F747970652E6164645265666572656E63653D66756E6374696F6E2865297B746869732E636F6E746578742E6164645265666572656E63652865297D2C68722E70726F746F747970652E68616E646C65546578743D66756E6374696F6E2865297B696628';
wwv_flow_imp.g_varchar2_table(1257) := '21727228746869732E656C656D656E74292E626F647950726F7065727479297468726F772069722822756E657870656374656420626F64792074657874203C222B652B223E22293B6C722E70726F746F747970652E68616E646C65546578742E63616C6C';
wwv_flow_imp.g_varchar2_table(1258) := '28746869732C65297D2C68722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B76617220653D746869732E626F64792C743D746869732E656C656D656E742C6E3D72722874292E626F647950726F70657274793B6E262676';
wwv_flow_imp.g_varchar2_table(1259) := '6F69642030213D3D65262628653D5369286E2E747970652C65292C742E736574286E2E6E616D652C6529297D2C68722E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220742C6E3D652E617474726962';
wwv_flow_imp.g_varchar2_table(1260) := '757465732C693D746869732E747970652C723D72722869292C6F3D746869732E636F6E746578742C613D6E65772069287B7D292C733D746869732E6D6F64656C3B72657475726E2066286E2C2866756E6374696F6E28652C6E297B76617220693D722E70';
wwv_flow_imp.g_varchar2_table(1261) := '726F7065727469657342794E616D655B6E5D3B692626692E69735265666572656E63653F692E69734D616E793F6628652E73706C697428222022292C2866756E6374696F6E2865297B6F2E6164645265666572656E6365287B656C656D656E743A612C70';
wwv_flow_imp.g_varchar2_table(1262) := '726F70657274793A692E6E732E6E616D652C69643A657D297D29293A6F2E6164645265666572656E6365287B656C656D656E743A612C70726F70657274793A692E6E732E6E616D652C69643A657D293A28693F653D536928692E747970652C65293A2278';
wwv_flow_imp.g_varchar2_table(1263) := '6D6C6E7322213D3D6E262628743D6B69286E2C722E6E732E707265666978292C732E6765745061636B61676528742E7072656669782926266F2E6164645761726E696E67287B6D6573736167653A22756E6B6E6F776E20617474726962757465203C222B';
wwv_flow_imp.g_varchar2_table(1264) := '6E2B223E222C656C656D656E743A612C70726F70657274793A6E2C76616C75653A657D29292C612E736574286E2C6529297D29292C617D2C68722E70726F746F747970652E67657450726F7065727479466F724E6F64653D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(1265) := '76617220742C6E2C693D6B6928652E6E616D65292C723D746869732E747970652C6F3D746869732E6D6F64656C2C613D72722872292C733D692E6E616D652C6C3D612E70726F7065727469657342794E616D655B735D3B6966286C2626216C2E69734174';
wwv_flow_imp.g_varchar2_table(1266) := '74722972657475726E207472286C29262628743D652E617474726962757465735B51695D293F28743D66756E6374696F6E28652C74297B766172206E3D6B692865293B72657475726E2066756E6374696F6E28652C74297B766172206E3D652E6E616D65';
wwv_flow_imp.g_varchar2_table(1267) := '2C693D652E6C6F63616C4E616D652C723D742E786D6C2626742E786D6C2E747970655072656669783B72657475726E20722626303D3D3D692E696E6465784F662872293F652E7072656669782B223A222B692E736C69636528722E6C656E677468293A6E';
wwv_flow_imp.g_varchar2_table(1268) := '7D286E2C742E6765745061636B616765286E2E70726566697829297D28742C6F292C53287B7D2C6C2C7B656666656374697665547970653A7272286E3D6F2E67657454797065287429292E6E616D657D29293A6C3B76617220633D6F2E6765745061636B';
wwv_flow_imp.g_varchar2_table(1269) := '61676528692E707265666978293B69662863297B696628743D6E7228692C63292C6E3D6F2E676574547970652874292C6C3D6428612E70726F706572746965732C2866756E6374696F6E2865297B72657475726E21652E69735669727475616C26262165';
wwv_flow_imp.g_varchar2_table(1270) := '2E69735265666572656E6365262621652E697341747472696275746526266E2E6861735479706528652E74797065297D29292972657475726E2053287B7D2C6C2C7B656666656374697665547970653A7272286E292E6E616D657D297D656C7365206966';
wwv_flow_imp.g_varchar2_table(1271) := '286C3D6428612E70726F706572746965732C2866756E6374696F6E2865297B72657475726E21652E69735265666572656E6365262621652E6973417474726962757465262622456C656D656E74223D3D3D652E747970657D29292972657475726E206C3B';
wwv_flow_imp.g_varchar2_table(1272) := '7468726F772069722822756E7265636F676E697A656420656C656D656E74203C222B692E6E616D652B223E22297D2C68722E70726F746F747970652E746F537472696E673D66756E6374696F6E28297B72657475726E22456C656D656E74446573637269';
wwv_flow_imp.g_varchar2_table(1273) := '70746F725B222B727228746869732E74797065292E6E616D652B225D227D2C68722E70726F746F747970652E76616C756548616E646C65723D66756E6374696F6E28652C74297B72657475726E206E657720707228652C74297D2C68722E70726F746F74';
wwv_flow_imp.g_varchar2_table(1274) := '7970652E7265666572656E636548616E646C65723D66756E6374696F6E2865297B72657475726E206E657720637228652C746869732E636F6E74657874297D2C68722E70726F746F747970652E68616E646C65723D66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(1275) := '75726E22456C656D656E74223D3D3D653F6E6577206D7228746869732E6D6F64656C2C652C746869732E636F6E74657874293A6E657720687228746869732E6D6F64656C2C652C746869732E636F6E74657874297D2C68722E70726F746F747970652E68';
wwv_flow_imp.g_varchar2_table(1276) := '616E646C654368696C643D66756E6374696F6E2865297B76617220742C6E2C692C723B696628743D746869732E67657450726F7065727479466F724E6F64652865292C693D746869732E656C656D656E742C4369286E3D742E6566666563746976655479';
wwv_flow_imp.g_varchar2_table(1277) := '70657C7C742E74797065292972657475726E20746869732E76616C756548616E646C657228742C69293B766172206F3D28723D742E69735265666572656E63653F746869732E7265666572656E636548616E646C65722874292E68616E646C654E6F6465';
wwv_flow_imp.g_varchar2_table(1278) := '2865293A746869732E68616E646C6572286E292E68616E646C654E6F6465286529292E656C656D656E743B72657475726E20766F69642030213D3D6F262628742E69734D616E793F692E67657428742E6E616D65292E70757368286F293A692E73657428';
wwv_flow_imp.g_varchar2_table(1279) := '742E6E616D652C6F292C742E69735265666572656E63653F2853286F2C7B656C656D656E743A697D292C746869732E636F6E746578742E6164645265666572656E6365286F29293A6F2E24706172656E743D69292C727D2C64722E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1280) := '3D4F626A6563742E6372656174652868722E70726F746F74797065292C64722E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220743D652E6E616D652C6E3D6B692874292C693D746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(1281) := '6C2C723D746869732E747970652C6F3D692E6765745061636B616765286E2E707265666978292C613D6F26266E72286E2C6F297C7C743B69662821722E68617354797065286129297468726F772069722822756E657870656374656420656C656D656E74';
wwv_flow_imp.g_varchar2_table(1282) := '203C222B652E6F726967696E616C4E616D652B223E22293B72657475726E2068722E70726F746F747970652E637265617465456C656D656E742E63616C6C28746869732C65297D2C6D722E70726F746F747970653D4F626A6563742E6372656174652875';
wwv_flow_imp.g_varchar2_table(1283) := '722E70726F746F74797065292C6D722E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220743D652E6E616D652C6E3D6B692874292E7072656669782C693D652E6E735B6E2B2224757269225D2C723D65';
wwv_flow_imp.g_varchar2_table(1284) := '2E617474726962757465733B72657475726E20746869732E6D6F64656C2E637265617465416E7928742C692C72297D2C6D722E70726F746F747970652E68616E646C654368696C643D66756E6374696F6E2865297B76617220743D6E6577206D72287468';
wwv_flow_imp.g_varchar2_table(1285) := '69732E6D6F64656C2C22456C656D656E74222C746869732E636F6E74657874292E68616E646C654E6F64652865292C6E3D746869732E656C656D656E742C693D742E656C656D656E743B72657475726E20766F69642030213D3D69262628286E2E246368';
wwv_flow_imp.g_varchar2_table(1286) := '696C6472656E3D6E2E246368696C6472656E7C7C5B5D292E707573682869292C692E24706172656E743D6E292C747D2C6D722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B746869732E626F6479262628746869732E65';
wwv_flow_imp.g_varchar2_table(1287) := '6C656D656E742E24626F64793D746869732E626F6479297D2C66722E70726F746F747970652E66726F6D584D4C3D66756E6374696F6E28652C742C6E297B76617220693D742E726F6F7448616E646C65723B7420696E7374616E63656F662068723F2869';
wwv_flow_imp.g_varchar2_table(1288) := '3D742C743D7B7D293A22737472696E67223D3D747970656F6620743F28693D746869732E68616E646C65722874292C743D7B7D293A22737472696E67223D3D747970656F662069262628693D746869732E68616E646C6572286929293B76617220723D74';
wwv_flow_imp.g_varchar2_table(1289) := '6869732E6D6F64656C2C6F3D746869732E6C61782C613D6E6577206F722853287B7D2C742C7B726F6F7448616E646C65723A697D29292C733D6E6577205869287B70726F78793A21307D292C6C3D66756E6374696F6E28297B76617220653D5B5D3B7265';
wwv_flow_imp.g_varchar2_table(1290) := '7475726E204F626A6563742E646566696E6550726F706572747928652C227065656B222C7B76616C75653A66756E6374696F6E28297B72657475726E20746869735B746869732E6C656E6774682D315D7D7D292C657D28293B66756E6374696F6E206328';
wwv_flow_imp.g_varchar2_table(1291) := '652C742C6E297B76617220693D7428292C723D692E6C696E652C6F3D692E636F6C756D6E2C733D692E646174613B223C223D3D3D732E63686172417428302926262D31213D3D732E696E6465784F662822202229262628733D732E736C69636528302C73';
wwv_flow_imp.g_varchar2_table(1292) := '2E696E6465784F662822202229292B223E22293B766172206C3D22756E7061727361626C6520636F6E74656E7420222B28733F732B2220223A2222292B2264657465637465645C6E5C746C696E653A20222B722B225C6E5C74636F6C756D6E3A20222B6F';
wwv_flow_imp.g_varchar2_table(1293) := '2B225C6E5C746E6573746564206572726F723A20222B652E6D6573736167653B6966286E2972657475726E20612E6164645761726E696E67287B6D6573736167653A6C2C6572726F723A657D292C21303B7468726F77206972286C297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1294) := '6E207028652C74297B72657475726E206328652C742C2130297D692E636F6E746578743D612C6C2E707573682869293B76617220753D2F5E3C5C3F786D6C202F692C683D2F20656E636F64696E673D22285B5E225D2B29222F692C643D2F5E7574662D38';
wwv_flow_imp.g_varchar2_table(1295) := '242F693B66756E6374696F6E206D28652C74297B7472797B6C2E7065656B28292E68616E646C65546578742865297D63617463682865297B7028652C74297D7D76617220663D722E6765745061636B6167657328292E726564756365282866756E637469';
wwv_flow_imp.g_varchar2_table(1296) := '6F6E28652C74297B72657475726E20655B742E7572695D3D742E7072656669782C657D292C7B22687474703A2F2F7777772E77332E6F72672F584D4C2F313939382F6E616D657370616365223A22786D6C227D293B72657475726E20732E6E732866292E';
wwv_flow_imp.g_varchar2_table(1297) := '6F6E28226F70656E546167222C2866756E6374696F6E28652C742C6E2C69297B76617220723D652E61747472737C7C7B7D2C613D4F626A6563742E6B6579732872292E726564756365282866756E6374696F6E28652C6E297B76617220693D7428725B6E';
wwv_flow_imp.g_varchar2_table(1298) := '5D293B72657475726E20655B6E5D3D692C657D292C7B7D293B2166756E6374696F6E28652C74297B766172206E3D6C2E7065656B28293B7472797B6C2E70757368286E2E68616E646C654E6F6465286529297D63617463682865297B6328652C742C6F29';
wwv_flow_imp.g_varchar2_table(1299) := '26266C2E70757368286E6577207372297D7D287B6E616D653A652E6E616D652C6F726967696E616C4E616D653A652E6F726967696E616C4E616D652C617474726962757465733A612C6E733A652E6E737D2C69297D29292E6F6E28227175657374696F6E';
wwv_flow_imp.g_varchar2_table(1300) := '222C2866756E6374696F6E2865297B696628752E74657374286529297B76617220743D682E657865632865292C6E3D742626745B315D3B6E262621642E74657374286E292626612E6164645761726E696E67287B6D6573736167653A22756E737570706F';
wwv_flow_imp.g_varchar2_table(1301) := '7274656420646F63756D656E7420656E636F64696E67203C222B6E2B223E2C2066616C6C696E67206261636B20746F205554462D38227D297D7D29292E6F6E2822636C6F7365546167222C2866756E6374696F6E28297B6C2E706F7028292E68616E646C';
wwv_flow_imp.g_varchar2_table(1302) := '65456E6428297D29292E6F6E28226364617461222C6D292E6F6E282274657874222C2866756E6374696F6E28652C742C6E297B2166756E6374696F6E28652C74297B652E7472696D282926266D28652C74297D28742865292C6E297D29292E6F6E282265';
wwv_flow_imp.g_varchar2_table(1303) := '72726F72222C63292E6F6E28227761726E222C70292C6E65772050726F6D697365282866756E6374696F6E28742C6E297B76617220723B7472797B732E70617273652865292C66756E6374696F6E28297B76617220652C742C6E3D612E656C656D656E74';
wwv_flow_imp.g_varchar2_table(1304) := '73427949642C693D612E7265666572656E6365733B666F7228653D303B743D695B655D3B652B2B297B76617220723D742E656C656D656E742C6F3D6E5B742E69645D2C733D72722872292E70726F7065727469657342794E616D655B742E70726F706572';
wwv_flow_imp.g_varchar2_table(1305) := '74795D3B6966286F7C7C612E6164645761726E696E67287B6D6573736167653A22756E7265736F6C766564207265666572656E6365203C222B742E69642B223E222C656C656D656E743A742E656C656D656E742C70726F70657274793A742E70726F7065';
wwv_flow_imp.g_varchar2_table(1306) := '7274792C76616C75653A742E69647D292C732E69734D616E79297B766172206C3D722E67657428732E6E616D65292C633D6C2E696E6465784F662874293B2D313D3D3D63262628633D6C2E6C656E677468292C6F3F6C5B635D3D6F3A6C2E73706C696365';
wwv_flow_imp.g_varchar2_table(1307) := '28632C31297D656C736520722E73657428732E6E616D652C6F297D7D28297D63617463682865297B723D657D766172206F3D692E656C656D656E743B727C7C6F7C7C28723D697228226661696C656420746F20706172736520646F63756D656E74206173';
wwv_flow_imp.g_varchar2_table(1308) := '203C222B692E747970652E2464657363726970746F722E6E616D652B223E2229293B766172206C3D612E7761726E696E67732C633D612E7265666572656E6365732C703D612E656C656D656E7473427949643B72657475726E20723F28722E7761726E69';
wwv_flow_imp.g_varchar2_table(1309) := '6E67733D6C2C6E287229293A74287B726F6F74456C656D656E743A6F2C656C656D656E7473427949643A702C7265666572656E6365733A632C7761726E696E67733A6C7D297D29297D2C66722E70726F746F747970652E68616E646C65723D66756E6374';
wwv_flow_imp.g_varchar2_table(1310) := '696F6E2865297B72657475726E206E657720647228746869732E6D6F64656C2C65297D3B7661722079723D2F3C7C3E7C277C227C267C5C6E5C727C5C6E2F672C67723D2F3C7C3E7C262F673B66756E6374696F6E2076722865297B76617220743D7B7D2C';
wwv_flow_imp.g_varchar2_table(1311) := '6E3D7B7D2C693D7B7D2C723D5B5D2C6F3D5B5D3B746869732E62795572693D66756E6374696F6E2874297B72657475726E206E5B745D7C7C652626652E62795572692874297D2C746869732E6164643D66756E6374696F6E28652C74297B6E5B652E7572';
wwv_flow_imp.g_varchar2_table(1312) := '695D3D652C743F722E707573682865293A6F2E707573682865292C746869732E6D617050726566697828652E7072656669782C652E757269297D2C746869732E75726942795072656669783D66756E6374696F6E2865297B72657475726E20745B657C7C';
wwv_flow_imp.g_varchar2_table(1313) := '22786D6C6E73225D7D2C746869732E6D61705072656669783D66756E6374696F6E28652C6E297B745B657C7C22786D6C6E73225D3D6E7D2C746869732E6765744E534B65793D66756E6374696F6E2865297B72657475726E20766F69642030213D3D652E';
wwv_flow_imp.g_varchar2_table(1314) := '7072656669783F652E7572692B227C222B652E7072656669783A652E7572697D2C746869732E6C6F67557365643D66756E6374696F6E2874297B766172206E3D742E7572692C723D746869732E6765744E534B65792874293B695B725D3D746869732E62';
wwv_flow_imp.g_varchar2_table(1315) := '79557269286E292C652626652E6C6F67557365642874297D2C746869732E676574557365643D66756E6374696F6E2865297B76617220743D746869733B72657475726E5B5D2E636F6E63617428722C6F292E66696C746572282866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1316) := '297B766172206E3D742E6765744E534B65792865293B72657475726E20695B6E5D7D29297D7D66756E6374696F6E20627228652C74297B652E73757065725F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F74';
wwv_flow_imp.g_varchar2_table(1317) := '7970652C7B636F6E7374727563746F723A7B76616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D297D66756E6374696F6E2078722865297B72657475726E20752865293F653A';
wwv_flow_imp.g_varchar2_table(1318) := '28652E7072656669783F652E7072656669782B223A223A2222292B652E6C6F63616C4E616D657D7661722077723D7B225C6E223A22233130222C225C6E5C72223A22233130222C2722273A22233334222C2227223A22233339222C223C223A2223363022';
wwv_flow_imp.g_varchar2_table(1319) := '2C223E223A22233632222C2226223A22233338227D2C5F723D7B223C223A226C74222C223E223A226774222C2226223A22616D70227D3B66756E6374696F6E20457228652C742C6E297B72657475726E28653D752865293F653A22222B65292E7265706C';
wwv_flow_imp.g_varchar2_table(1320) := '61636528742C2866756E6374696F6E2865297B72657475726E2226222B6E5B655D2B223B227D29297D66756E6374696F6E2053722865297B746869732E7461674E616D653D657D66756E6374696F6E20417228297B7D66756E6374696F6E204372286529';
wwv_flow_imp.g_varchar2_table(1321) := '7B746869732E7461674E616D653D657D66756E6374696F6E206B7228652C74297B746869732E626F64793D5B5D2C746869732E61747472733D5B5D2C746869732E706172656E743D652C746869732E70726F706572747944657363726970746F723D747D';
wwv_flow_imp.g_varchar2_table(1322) := '66756E6374696F6E20527228652C74297B6B722E63616C6C28746869732C652C74297D66756E6374696F6E204D7228297B746869732E76616C75653D22222C746869732E77726974653D66756E6374696F6E2865297B746869732E76616C75652B3D657D';
wwv_flow_imp.g_varchar2_table(1323) := '7D66756E6374696F6E20507228652C74297B766172206E3D5B22225D3B746869732E617070656E643D66756E6374696F6E2874297B72657475726E20652E77726974652874292C746869737D2C746869732E617070656E644E65774C696E653D66756E63';
wwv_flow_imp.g_varchar2_table(1324) := '74696F6E28297B72657475726E20742626652E777269746528225C6E22292C746869737D2C746869732E617070656E64496E64656E743D66756E6374696F6E28297B72657475726E20742626652E7772697465286E2E6A6F696E282220202229292C7468';
wwv_flow_imp.g_varchar2_table(1325) := '69737D2C746869732E696E64656E743D66756E6374696F6E28297B72657475726E206E2E70757368282222292C746869737D2C746869732E756E696E64656E743D66756E6374696F6E28297B72657475726E206E2E706F7028292C746869737D7D66756E';
wwv_flow_imp.g_varchar2_table(1326) := '6374696F6E2044722865297B72657475726E20653D53287B666F726D61743A21312C707265616D626C653A21307D2C657C7C7B7D292C7B746F584D4C3A66756E6374696F6E28742C6E297B76617220693D6E7C7C6E6577204D722C723D6E657720507228';
wwv_flow_imp.g_varchar2_table(1327) := '692C652E666F726D6174293B696628652E707265616D626C652626722E617070656E6428273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D225554462D38223F3E5C6E27292C286E6577206B72292E6275696C642874292E7365';
wwv_flow_imp.g_varchar2_table(1328) := '7269616C697A65546F2872292C216E2972657475726E20692E76616C75657D7D7D66756E6374696F6E20427228652C74297B54692E63616C6C28746869732C652C74297D53722E70726F746F747970652E6275696C643D66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(1329) := '657475726E20746869732E656C656D656E743D652C746869737D2C53722E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E746167';
wwv_flow_imp.g_varchar2_table(1330) := '4E616D652B223E222B746869732E656C656D656E742E69642B223C2F222B746869732E7461674E616D652B223E22292E617070656E644E65774C696E6528297D2C41722E70726F746F747970652E73657269616C697A6556616C75653D41722E70726F74';
wwv_flow_imp.g_varchar2_table(1331) := '6F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E6428746869732E6573636170653F457228746869732E76616C75652C67722C5F72293A746869732E76616C7565297D2C41722E70726F746F747970652E6275';
wwv_flow_imp.g_varchar2_table(1332) := '696C643D66756E6374696F6E28652C74297B72657475726E20746869732E76616C75653D742C22537472696E67223D3D3D652E7479706526262D31213D3D742E73656172636828677229262628746869732E6573636170653D2130292C746869737D2C62';
wwv_flow_imp.g_varchar2_table(1333) := '722843722C4172292C43722E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D652B223E22292C746869732E736572';
wwv_flow_imp.g_varchar2_table(1334) := '69616C697A6556616C75652865292C652E617070656E6428223C2F222B746869732E7461674E616D652B223E22292E617070656E644E65774C696E6528297D2C6B722E70726F746F747970652E6275696C643D66756E6374696F6E2865297B746869732E';
wwv_flow_imp.g_varchar2_table(1335) := '656C656D656E743D653B76617220742C6E2C693D652E2464657363726970746F722C723D746869732E70726F706572747944657363726970746F722C6F3D692E697347656E657269633B72657475726E20743D6F3F746869732E706172736547656E6572';
wwv_flow_imp.g_varchar2_table(1336) := '69632865293A746869732E70617273654E73417474726962757465732865292C746869732E6E733D723F746869732E6E7350726F70657274795461674E616D652872293A746869732E6E735461674E616D652869292C746869732E7461674E616D653D74';
wwv_flow_imp.g_varchar2_table(1337) := '6869732E6164645461674E616D6528746869732E6E73292C6F7C7C286E3D66756E6374696F6E2865297B72657475726E206D28652E2464657363726970746F722E70726F706572746965732C2866756E6374696F6E2874297B766172206E3D742E6E616D';
wwv_flow_imp.g_varchar2_table(1338) := '653B696628742E69735669727475616C2972657475726E21313B696628216828652C6E292972657475726E21313B76617220693D655B6E5D3B72657475726E2069213D3D742E64656661756C7426266E756C6C213D3D6926262821742E69734D616E797C';
wwv_flow_imp.g_varchar2_table(1339) := '7C692E6C656E677468297D29297D2865292C746869732E706172736541747472696275746573286D286E2C2866756E6374696F6E2865297B72657475726E20652E6973417474727D2929292C746869732E7061727365436F6E7461696E6D656E7473286D';
wwv_flow_imp.g_varchar2_table(1340) := '286E2C2866756E6374696F6E2865297B72657475726E21652E6973417474727D292929292C746869732E706172736547656E657269634174747269627574657328652C74292C746869737D2C6B722E70726F746F747970652E6E735461674E616D653D66';
wwv_flow_imp.g_varchar2_table(1341) := '756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E20742E697347656E657269633F53287B6C6F63616C4E616D653A742E6E732E6C6F63616C4E616D657D2C65293A53287B6C6F63616C4E616D653A286E3D74';
wwv_flow_imp.g_varchar2_table(1342) := '2E6E732E6C6F63616C4E616D652C693D742E24706B672C5A692869293F28723D6E292E6368617241742830292E746F4C6F7765724361736528292B722E736C6963652831293A6E297D2C65293B766172206E2C692C727D28746869732E6C6F674E616D65';
wwv_flow_imp.g_varchar2_table(1343) := '73706163655573656428652E6E73292C65297D2C6B722E70726F746F747970652E6E7350726F70657274795461674E616D653D66756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E2053287B6C6F63616C4E';
wwv_flow_imp.g_varchar2_table(1344) := '616D653A742E6E732E6C6F63616C4E616D657D2C65297D28746869732E6C6F674E616D6573706163655573656428652E6E73292C65297D2C6B722E70726F746F747970652E69734C6F63616C4E733D66756E6374696F6E2865297B72657475726E20652E';
wwv_flow_imp.g_varchar2_table(1345) := '7572693D3D3D746869732E6E732E7572697D2C6B722E70726F746F747970652E6E734174747269627574654E616D653D66756E6374696F6E2865297B76617220743B696628743D752865293F6B692865293A652E6E732C652E696E686572697465642972';
wwv_flow_imp.g_varchar2_table(1346) := '657475726E7B6C6F63616C4E616D653A742E6C6F63616C4E616D657D3B766172206E3D746869732E6C6F674E616D657370616365557365642874293B72657475726E20746869732E6765744E616D6573706163657328292E6C6F6755736564286E292C74';
wwv_flow_imp.g_varchar2_table(1347) := '6869732E69734C6F63616C4E73286E293F7B6C6F63616C4E616D653A742E6C6F63616C4E616D657D3A53287B6C6F63616C4E616D653A742E6C6F63616C4E616D657D2C6E297D2C6B722E70726F746F747970652E706172736547656E657269633D66756E';
wwv_flow_imp.g_varchar2_table(1348) := '6374696F6E2865297B76617220743D746869732C6E3D746869732E626F64792C693D5B5D3B72657475726E206628652C2866756E6374696F6E28722C6F297B2224626F6479223D3D3D6F3F6E2E7075736828286E6577204172292E6275696C64287B7479';
wwv_flow_imp.g_varchar2_table(1349) := '70653A22537472696E67227D2C7229293A22246368696C6472656E223D3D3D6F3F6628722C2866756E6374696F6E2865297B6E2E70757368286E6577206B722874292E6275696C64286529297D29293A30213D3D6F2E696E6465784F6628222422292626';
wwv_flow_imp.g_varchar2_table(1350) := '742E70617273654E7341747472696275746528652C6F2C72292626692E70757368287B6E616D653A6F2C76616C75653A727D297D29292C697D2C6B722E70726F746F747970652E70617273654E734174747269627574653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(1351) := '2C6E297B76617220692C723D652E246D6F64656C2C6F3D6B692874293B69662822786D6C6E73223D3D3D6F2E707265666978262628693D7B7072656669783A6F2E6C6F63616C4E616D652C7572693A6E7D292C6F2E7072656669787C7C22786D6C6E7322';
wwv_flow_imp.g_varchar2_table(1352) := '213D3D6F2E6C6F63616C4E616D657C7C28693D7B7572693A6E7D292C21692972657475726E7B6E616D653A742C76616C75653A6E7D3B696628722626722E6765745061636B616765286E2929746869732E6C6F674E616D65737061636528692C21302C21';
wwv_flow_imp.g_varchar2_table(1353) := '30293B656C73657B76617220613D746869732E6C6F674E616D6573706163655573656428692C2130293B746869732E6765744E616D6573706163657328292E6C6F67557365642861297D7D2C6B722E70726F746F747970652E70617273654E7341747472';
wwv_flow_imp.g_varchar2_table(1354) := '6962757465733D66756E6374696F6E28652C74297B766172206E3D746869732C693D652E2461747472732C723D5B5D3B72657475726E206628692C2866756E6374696F6E28742C69297B766172206F3D6E2E70617273654E734174747269627574652865';
wwv_flow_imp.g_varchar2_table(1355) := '2C692C74293B6F2626722E70757368286F297D29292C727D2C6B722E70726F746F747970652E706172736547656E65726963417474726962757465733D66756E6374696F6E28652C74297B766172206E3D746869733B6628742C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1356) := '74297B696628742E6E616D65213D3D5169297472797B6E2E616464417474726962757465286E2E6E734174747269627574654E616D6528742E6E616D65292C742E76616C7565297D6361746368286E297B636F6E736F6C652E7761726E28226D69737369';
wwv_flow_imp.g_varchar2_table(1357) := '6E67206E616D65737061636520696E666F726D6174696F6E20666F7220222C742E6E616D652C223D222C742E76616C75652C226F6E222C652C6E297D7D29297D2C6B722E70726F746F747970652E7061727365436F6E7461696E6D656E74733D66756E63';
wwv_flow_imp.g_varchar2_table(1358) := '74696F6E2865297B76617220743D746869732C6E3D746869732E626F64792C693D746869732E656C656D656E743B6628652C2866756E6374696F6E2865297B76617220723D692E67657428652E6E616D65292C6F3D652E69735265666572656E63653B69';
wwv_flow_imp.g_varchar2_table(1359) := '6628652E69734D616E797C7C28723D5B725D292C652E6973426F6479296E2E7075736828286E6577204172292E6275696C6428652C725B305D29293B656C736520696628436928652E7479706529296628722C2866756E6374696F6E2869297B6E2E7075';
wwv_flow_imp.g_varchar2_table(1360) := '7368286E657720437228742E6164645461674E616D6528742E6E7350726F70657274795461674E616D6528652929292E6275696C6428652C6929297D29293B656C7365206966286F296628722C2866756E6374696F6E2869297B6E2E70757368286E6577';
wwv_flow_imp.g_varchar2_table(1361) := '20537228742E6164645461674E616D6528742E6E7350726F70657274795461674E616D6528652929292E6275696C64286929297D29293B656C73657B76617220613D74722865292C733D66756E6374696F6E2865297B72657475726E2270726F70657274';
wwv_flow_imp.g_varchar2_table(1362) := '79223D3D3D65722865297D2865293B6628722C2866756E6374696F6E2869297B76617220723B723D613F6E657720527228742C65293A733F6E6577206B7228742C65293A6E6577206B722874292C6E2E7075736828722E6275696C64286929297D29297D';
wwv_flow_imp.g_varchar2_table(1363) := '7D29297D2C6B722E70726F746F747970652E6765744E616D657370616365733D66756E6374696F6E2865297B76617220742C6E3D746869732E6E616D657370616365732C693D746869732E706172656E743B72657475726E206E7C7C28743D692626692E';
wwv_flow_imp.g_varchar2_table(1364) := '6765744E616D6573706163657328292C657C7C21743F746869732E6E616D657370616365733D6E3D6E65772076722874293A6E3D74292C6E7D2C6B722E70726F746F747970652E6C6F674E616D6573706163653D66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(1365) := '76617220693D746869732E6765744E616D65737061636573286E292C723D652E7572692C6F3D652E7072656669783B72657475726E20692E62795572692872292626216E7C7C692E61646428652C74292C692E6D6170507265666978286F2C72292C657D';
wwv_flow_imp.g_varchar2_table(1366) := '2C6B722E70726F746F747970652E6C6F674E616D657370616365557365643D66756E6374696F6E28652C74297B766172206E2C692C722C6F3D746869732E656C656D656E742E246D6F64656C2C613D746869732E6765744E616D65737061636573287429';
wwv_flow_imp.g_varchar2_table(1367) := '2C733D652E7072656669782C6C3D652E7572693B69662821732626216C2972657475726E7B6C6F63616C4E616D653A652E6C6F63616C4E616D657D3B696628723D4A695B735D7C7C6F2626286F2E6765745061636B6167652873297C7C7B7D292E757269';
wwv_flow_imp.g_varchar2_table(1368) := '2C21286C3D6C7C7C727C7C612E757269427950726566697828732929297468726F77206E6577204572726F7228226E6F206E616D6573706163652075726920676976656E20666F7220707265666978203C222B732B223E22293B6966282128653D612E62';
wwv_flow_imp.g_varchar2_table(1369) := '79557269286C2929297B666F72286E3D732C693D313B612E7572694279507265666978286E293B296E3D732B225F222B692B2B3B653D746869732E6C6F674E616D657370616365287B7072656669783A6E2C7572693A6C7D2C723D3D3D6C297D72657475';
wwv_flow_imp.g_varchar2_table(1370) := '726E20732626612E6D617050726566697828732C6C292C657D2C6B722E70726F746F747970652E7061727365417474726962757465733D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E656C656D656E743B6628652C286675';
wwv_flow_imp.g_varchar2_table(1371) := '6E6374696F6E2865297B76617220693D6E2E67657428652E6E616D65293B696628652E69735265666572656E636529696628652E69734D616E79297B76617220723D5B5D3B6628692C2866756E6374696F6E2865297B722E7075736828652E6964297D29';
wwv_flow_imp.g_varchar2_table(1372) := '292C693D722E6A6F696E28222022297D656C736520693D692E69643B742E61646441747472696275746528742E6E734174747269627574654E616D652865292C69297D29297D2C6B722E70726F746F747970652E6164645461674E616D653D66756E6374';
wwv_flow_imp.g_varchar2_table(1373) := '696F6E2865297B76617220743D746869732E6C6F674E616D657370616365557365642865293B72657475726E20746869732E6765744E616D6573706163657328292E6C6F67557365642874292C78722865297D2C6B722E70726F746F747970652E616464';
wwv_flow_imp.g_varchar2_table(1374) := '4174747269627574653D66756E6374696F6E28652C74297B766172206E3D746869732E61747472733B75287429262628743D457228742C79722C777229293B76617220693D66756E6374696F6E2874297B636F6E7374206E3D78282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1375) := '2874297B72657475726E20742E6E616D652E6C6F63616C4E616D653D3D3D652E6C6F63616C4E616D652626742E6E616D652E7572693D3D3D652E7572692626742E6E616D652E7072656669783D3D3D652E7072656669787D29293B6C657420693D732874';
wwv_flow_imp.g_varchar2_table(1376) := '293F2D313A766F696420303B72657475726E206628742C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D742C21317D29292C697D286E292C723D7B6E616D653A652C76616C75653A747D3B2D31213D3D693F6E2E73';
wwv_flow_imp.g_varchar2_table(1377) := '706C69636528692C312C72293A6E2E707573682872297D2C6B722E70726F746F747970652E73657269616C697A65417474726962757465733D66756E6374696F6E2865297B76617220743D746869732E61747472732C6E3D746869732E6E616D65737061';
wwv_flow_imp.g_varchar2_table(1378) := '6365733B6E262628743D66756E6374696F6E2865297B72657475726E20652E6765745573656428292E66696C746572282866756E6374696F6E2865297B72657475726E22786D6C22213D3D652E7072656669787D29292E6D6170282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1379) := '2865297B72657475726E7B6E616D653A22786D6C6E73222B28652E7072656669783F223A222B652E7072656669783A2222292C76616C75653A652E7572697D7D29297D286E292E636F6E636174287429292C6628742C2866756E6374696F6E2874297B65';
wwv_flow_imp.g_varchar2_table(1380) := '2E617070656E6428222022292E617070656E6428787228742E6E616D6529292E617070656E6428273D2227292E617070656E6428742E76616C7565292E617070656E6428272227297D29297D2C6B722E70726F746F747970652E73657269616C697A6554';
wwv_flow_imp.g_varchar2_table(1381) := '6F3D66756E6374696F6E2865297B76617220743D746869732E626F64795B305D2C6E3D742626742E636F6E7374727563746F72213D3D41723B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D65292C74';
wwv_flow_imp.g_varchar2_table(1382) := '6869732E73657269616C697A65417474726962757465732865292C652E617070656E6428743F223E223A22202F3E22292C742626286E2626652E617070656E644E65774C696E6528292E696E64656E7428292C6628746869732E626F64792C2866756E63';
wwv_flow_imp.g_varchar2_table(1383) := '74696F6E2874297B742E73657269616C697A65546F2865297D29292C6E2626652E756E696E64656E7428292E617070656E64496E64656E7428292C652E617070656E6428223C2F222B746869732E7461674E616D652B223E2229292C652E617070656E64';
wwv_flow_imp.g_varchar2_table(1384) := '4E65774C696E6528297D2C62722852722C6B72292C52722E70726F746F747970652E70617273654E73417474726962757465733D66756E6374696F6E2865297B76617220743D6B722E70726F746F747970652E70617273654E7341747472696275746573';
wwv_flow_imp.g_varchar2_table(1385) := '2E63616C6C28746869732C65292C6E3D652E2464657363726970746F723B6966286E2E6E616D653D3D3D746869732E70726F706572747944657363726970746F722E747970652972657475726E20743B76617220693D746869732E747970654E733D7468';
wwv_flow_imp.g_varchar2_table(1386) := '69732E6E735461674E616D65286E293B746869732E6765744E616D6573706163657328292E6C6F675573656428746869732E747970654E73293B76617220723D652E246D6F64656C2E6765745061636B61676528692E757269292C6F3D722E786D6C2626';
wwv_flow_imp.g_varchar2_table(1387) := '722E786D6C2E747970655072656669787C7C22223B72657475726E20746869732E61646441747472696275746528746869732E6E734174747269627574654E616D65285169292C28692E7072656669783F692E7072656669782B223A223A2222292B6F2B';
wwv_flow_imp.g_varchar2_table(1388) := '6E2E6E732E6C6F63616C4E616D65292C747D2C52722E70726F746F747970652E69734C6F63616C4E733D66756E6374696F6E2865297B72657475726E20652E7572693D3D3D28746869732E747970654E737C7C746869732E6E73292E7572697D2C42722E';
wwv_flow_imp.g_varchar2_table(1389) := '70726F746F747970653D4F626A6563742E6372656174652854692E70726F746F74797065292C42722E70726F746F747970652E66726F6D584D4C3D66756E6374696F6E28652C742C6E297B752874297C7C286E3D742C743D2262706D6E3A446566696E69';
wwv_flow_imp.g_varchar2_table(1390) := '74696F6E7322293B76617220693D6E65772066722853287B6D6F64656C3A746869732C6C61783A21307D2C6E29292C723D692E68616E646C65722874293B72657475726E20692E66726F6D584D4C28652C72297D2C42722E70726F746F747970652E746F';
wwv_flow_imp.g_varchar2_table(1391) := '584D4C3D66756E6374696F6E28652C74297B766172206E3D6E65772044722874293B72657475726E206E65772050726F6D697365282866756E6374696F6E28742C69297B7472797B72657475726E2074287B786D6C3A6E2E746F584D4C2865297D297D63';
wwv_flow_imp.g_varchar2_table(1392) := '617463682865297B72657475726E20692865297D7D29297D3B766172204F723D7B62706D6E3A7B6E616D653A2242504D4E3230222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4D4F4445';
wwv_flow_imp.g_varchar2_table(1393) := '4C222C7072656669783A2262706D6E222C6173736F63696174696F6E733A5B5D2C74797065733A5B7B6E616D653A22496E74657266616365222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(1394) := '6D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226F7065726174696F6E73222C747970653A224F7065726174696F6E222C69734D616E793A21307D2C7B6E616D653A22696D706C656D656E746174';
wwv_flow_imp.g_varchar2_table(1395) := '696F6E526566222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224F7065726174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E';
wwv_flow_imp.g_varchar2_table(1396) := '616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E4D657373616765526566222C747970653A224D657373616765222C69735265666572656E63653A21307D2C7B6E616D653A226F75744D65737361676552';
wwv_flow_imp.g_varchar2_table(1397) := '6566222C747970653A224D657373616765222C69735265666572656E63653A21307D2C7B6E616D653A226572726F72526566222C747970653A224572726F72222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22696D';
wwv_flow_imp.g_varchar2_table(1398) := '706C656D656E746174696F6E526566222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22456E64506F696E74222C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A2241756469';
wwv_flow_imp.g_varchar2_table(1399) := '74696E67222C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22476C6F62616C5461736B222C7375706572436C6173733A5B2243616C6C61626C65456C656D656E74225D2C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(1400) := '653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C69734D616E793A21307D5D7D2C7B6E616D653A224D6F6E69746F72696E67222C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1401) := '22506572666F726D6572222C7375706572436C6173733A5B225265736F75726365526F6C65225D7D2C7B6E616D653A2250726F63657373222C7375706572436C6173733A5B22466C6F77456C656D656E7473436F6E7461696E6572222C2243616C6C6162';
wwv_flow_imp.g_varchar2_table(1402) := '6C65456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2270726F6365737354797065222C747970653A2250726F6365737354797065222C6973417474723A21307D2C7B6E616D653A226973436C6F736564222C6973417474723A2130';
wwv_flow_imp.g_varchar2_table(1403) := '2C747970653A22426F6F6C65616E227D2C7B6E616D653A226175646974696E67222C747970653A224175646974696E67227D2C7B6E616D653A226D6F6E69746F72696E67222C747970653A224D6F6E69746F72696E67227D2C7B6E616D653A2270726F70';
wwv_flow_imp.g_varchar2_table(1404) := '657274696573222C747970653A2250726F7065727479222C69734D616E793A21307D2C7B6E616D653A226C616E6553657473222C69734D616E793A21302C7265706C616365733A22466C6F77456C656D656E7473436F6E7461696E6572236C616E655365';
wwv_flow_imp.g_varchar2_table(1405) := '7473222C747970653A224C616E65536574227D2C7B6E616D653A22666C6F77456C656D656E7473222C69734D616E793A21302C7265706C616365733A22466C6F77456C656D656E7473436F6E7461696E657223666C6F77456C656D656E7473222C747970';
wwv_flow_imp.g_varchar2_table(1406) := '653A22466C6F77456C656D656E74227D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D2C7B6E616D653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C';
wwv_flow_imp.g_varchar2_table(1407) := '69734D616E793A21307D2C7B6E616D653A22636F7272656C6174696F6E537562736372697074696F6E73222C747970653A22436F7272656C6174696F6E537562736372697074696F6E222C69734D616E793A21307D2C7B6E616D653A22737570706F7274';
wwv_flow_imp.g_varchar2_table(1408) := '73222C747970653A2250726F63657373222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22646566696E6974696F6E616C436F6C6C61626F726174696F6E526566222C747970653A22436F6C6C61626F726174696F6E';
wwv_flow_imp.g_varchar2_table(1409) := '222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22697345786563757461626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A224C616E65536574222C7375706572436C';
wwv_flow_imp.g_varchar2_table(1410) := '6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226C616E6573222C747970653A224C616E65222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A225374';
wwv_flow_imp.g_varchar2_table(1411) := '72696E67227D5D7D2C7B6E616D653A224C616E65222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B';
wwv_flow_imp.g_varchar2_table(1412) := '6E616D653A22706172746974696F6E456C656D656E74526566222C747970653A2242617365456C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22706172746974696F6E456C656D656E74222C747970';
wwv_flow_imp.g_varchar2_table(1413) := '653A2242617365456C656D656E74227D2C7B6E616D653A22666C6F774E6F6465526566222C747970653A22466C6F774E6F6465222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226368696C644C616E65536574222C';
wwv_flow_imp.g_varchar2_table(1414) := '747970653A224C616E65536574222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A22476C6F62616C4D616E75616C5461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1415) := '6D653A224D616E75616C5461736B222C7375706572436C6173733A5B225461736B225D7D2C7B6E616D653A22557365725461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A2272656E64657269';
wwv_flow_imp.g_varchar2_table(1416) := '6E6773222C747970653A2252656E646572696E67222C69734D616E793A21307D2C7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2252656E646572696E6722';
wwv_flow_imp.g_varchar2_table(1417) := '2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A2248756D616E506572666F726D6572222C7375706572436C6173733A5B22506572666F726D6572225D7D2C7B6E616D653A22506F74656E7469616C4F776E657222';
wwv_flow_imp.g_varchar2_table(1418) := '2C7375706572436C6173733A5B2248756D616E506572666F726D6572225D7D2C7B6E616D653A22476C6F62616C557365725461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1419) := '696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2272656E646572696E6773222C747970653A2252656E646572696E67222C69734D616E793A21307D5D7D2C7B6E616D653A22476174';
wwv_flow_imp.g_varchar2_table(1420) := '65776179222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A2267617465776179446972656374696F6E222C747970653A2247617465776179446972656374';
wwv_flow_imp.g_varchar2_table(1421) := '696F6E222C64656661756C743A22556E737065636966696564222C6973417474723A21307D5D7D2C7B6E616D653A224576656E74426173656447617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(1422) := '5B7B6E616D653A22696E7374616E7469617465222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226576656E744761746577617954797065222C747970653A224576656E74426173656447';
wwv_flow_imp.g_varchar2_table(1423) := '61746577617954797065222C6973417474723A21302C64656661756C743A224578636C7573697665227D5D7D2C7B6E616D653A22436F6D706C657847617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965';
wwv_flow_imp.g_varchar2_table(1424) := '733A5B7B6E616D653A2261637469766174696F6E436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2264656661756C74222C747970653A2253';
wwv_flow_imp.g_varchar2_table(1425) := '657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224578636C757369766547617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(1426) := '5B7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22496E636C757369766547617465776179222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(1427) := '3A5B2247617465776179225D2C70726F706572746965733A5B7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2250617261';
wwv_flow_imp.g_varchar2_table(1428) := '6C6C656C47617465776179222C7375706572436C6173733A5B2247617465776179225D7D2C7B6E616D653A22526F6F74456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B';
wwv_flow_imp.g_varchar2_table(1429) := '6E616D653A2252656C6174696F6E73686970222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2274797065222C6973417474723A21302C747970653A22537472696E67227D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1430) := '6D653A22646972656374696F6E222C747970653A2252656C6174696F6E73686970446972656374696F6E222C6973417474723A21307D2C7B6E616D653A22736F75726365222C69734D616E793A21302C69735265666572656E63653A21302C747970653A';
wwv_flow_imp.g_varchar2_table(1431) := '22456C656D656E74227D2C7B6E616D653A22746172676574222C69734D616E793A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D5D7D2C7B6E616D653A2242617365456C656D656E74222C697341627374726163743A';
wwv_flow_imp.g_varchar2_table(1432) := '21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C747970653A22537472696E67222C697349643A21307D2C7B6E616D653A22646F63756D656E746174696F6E222C747970653A22446F63756D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(1433) := '222C69734D616E793A21307D2C7B6E616D653A22657874656E73696F6E446566696E6974696F6E73222C747970653A22457874656E73696F6E446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(1434) := '3A22657874656E73696F6E456C656D656E7473222C747970653A22457874656E73696F6E456C656D656E7473227D5D7D2C7B6E616D653A22457874656E73696F6E222C70726F706572746965733A5B7B6E616D653A226D757374556E6465727374616E64';
wwv_flow_imp.g_varchar2_table(1435) := '222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22646566696E6974696F6E222C747970653A22457874656E73696F6E446566696E6974696F6E222C6973417474723A21302C6973526566';
wwv_flow_imp.g_varchar2_table(1436) := '6572656E63653A21307D5D7D2C7B6E616D653A22457874656E73696F6E446566696E6974696F6E222C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226578';
wwv_flow_imp.g_varchar2_table(1437) := '74656E73696F6E417474726962757465446566696E6974696F6E73222C747970653A22457874656E73696F6E417474726962757465446566696E6974696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A22457874656E73696F6E417474726962';
wwv_flow_imp.g_varchar2_table(1438) := '757465446566696E6974696F6E222C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2274797065222C6973417474723A21302C747970653A22537472696E67';
wwv_flow_imp.g_varchar2_table(1439) := '227D2C7B6E616D653A2269735265666572656E6365222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22657874656E73696F6E446566696E6974696F6E222C747970653A22457874656E73';
wwv_flow_imp.g_varchar2_table(1440) := '696F6E446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22457874656E73696F6E456C656D656E7473222C70726F706572746965733A5B7B6E616D653A2276616C7565526566222C6973';
wwv_flow_imp.g_varchar2_table(1441) := '417474723A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D2C7B6E616D653A2276616C756573222C747970653A22456C656D656E74222C69734D616E793A21307D2C7B6E616D653A22657874656E73696F6E41747472';
wwv_flow_imp.g_varchar2_table(1442) := '6962757465446566696E6974696F6E222C747970653A22457874656E73696F6E417474726962757465446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446F63756D656E746174696F';
wwv_flow_imp.g_varchar2_table(1443) := '6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2274657874222C747970653A22537472696E67222C6973426F64793A21307D2C7B6E616D653A2274657874466F726D6174222C64';
wwv_flow_imp.g_varchar2_table(1444) := '656661756C743A22746578742F706C61696E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224576656E74222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465222C2249';
wwv_flow_imp.g_varchar2_table(1445) := '6E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2270726F70657274696573222C747970653A2250726F7065727479222C69734D616E793A21307D5D7D2C7B6E616D653A22496E7465726D65646961746543617463';
wwv_flow_imp.g_varchar2_table(1446) := '684576656E74222C7375706572436C6173733A5B2243617463684576656E74225D7D2C7B6E616D653A22496E7465726D6564696174655468726F774576656E74222C7375706572436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1447) := '456E644576656E74222C7375706572436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A2253746172744576656E74222C7375706572436C6173733A5B2243617463684576656E74225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1448) := '226973496E74657272757074696E67222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A225468726F774576656E74222C697341627374726163743A21302C7375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(1449) := '5B224576656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461496E70757473222C747970653A2244617461496E707574222C69734D616E793A21307D2C7B6E616D653A2264617461496E7075744173736F63696174696F6E73222C74';
wwv_flow_imp.g_varchar2_table(1450) := '7970653A2244617461496E7075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A22696E707574536574222C747970653A22496E707574536574227D2C7B6E616D653A226576656E74446566696E6974696F6E73222C747970';
wwv_flow_imp.g_varchar2_table(1451) := '653A224576656E74446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A226576656E74446566696E6974696F6E526566222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21302C69735265666572656E';
wwv_flow_imp.g_varchar2_table(1452) := '63653A21307D5D7D2C7B6E616D653A2243617463684576656E74222C697341627374726163743A21302C7375706572436C6173733A5B224576656E74225D2C70726F706572746965733A5B7B6E616D653A22706172616C6C656C4D756C7469706C65222C';
wwv_flow_imp.g_varchar2_table(1453) := '6973417474723A21302C747970653A22426F6F6C65616E222C64656661756C743A21317D2C7B6E616D653A22646174614F757470757473222C747970653A22446174614F7574707574222C69734D616E793A21307D2C7B6E616D653A22646174614F7574';
wwv_flow_imp.g_varchar2_table(1454) := '7075744173736F63696174696F6E73222C747970653A22446174614F75747075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A226F7574707574536574222C747970653A224F7574707574536574227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1455) := '6576656E74446566696E6974696F6E73222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A226576656E74446566696E6974696F6E526566222C747970653A224576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(1456) := '222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22426F756E646172794576656E74222C7375706572436C6173733A5B2243617463684576656E74225D2C70726F706572746965733A5B7B6E616D653A2263616E';
wwv_flow_imp.g_varchar2_table(1457) := '63656C4163746976697479222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226174746163686564546F526566222C747970653A224163746976697479222C6973417474723A21302C6973';
wwv_flow_imp.g_varchar2_table(1458) := '5265666572656E63653A21307D5D7D2C7B6E616D653A224576656E74446566696E6974696F6E222C697341627374726163743A21302C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A2243616E63656C4576656E74';
wwv_flow_imp.g_varchar2_table(1459) := '446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D7D2C7B6E616D653A224572726F724576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(1460) := '6E225D2C70726F706572746965733A5B7B6E616D653A226572726F72526566222C747970653A224572726F72222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225465726D696E6174654576656E74446566696E';
wwv_flow_imp.g_varchar2_table(1461) := '6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D7D2C7B6E616D653A22457363616C6174696F6E4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(1462) := '6E225D2C70726F706572746965733A5B7B6E616D653A22657363616C6174696F6E526566222C747970653A22457363616C6174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22457363616C6174696F';
wwv_flow_imp.g_varchar2_table(1463) := '6E222C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226E616D65222C697341';
wwv_flow_imp.g_varchar2_table(1464) := '7474723A21302C747970653A22537472696E67227D2C7B6E616D653A22657363616C6174696F6E436F6465222C6973417474723A21302C747970653A22537472696E67227D5D2C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B';
wwv_flow_imp.g_varchar2_table(1465) := '6E616D653A22436F6D70656E736174654576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A2277616974466F72436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(1466) := '222C6973417474723A21302C747970653A22426F6F6C65616E222C64656661756C743A21307D2C7B6E616D653A226163746976697479526566222C747970653A224163746976697479222C6973417474723A21302C69735265666572656E63653A21307D';
wwv_flow_imp.g_varchar2_table(1467) := '5D7D2C7B6E616D653A2254696D65724576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A2274696D6544617465222C747970653A224578';
wwv_flow_imp.g_varchar2_table(1468) := '7072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2274696D654379636C65222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D';
wwv_flow_imp.g_varchar2_table(1469) := '7D2C7B6E616D653A2274696D654475726174696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A224C696E6B4576656E74446566696E6974696F6E222C73';
wwv_flow_imp.g_varchar2_table(1470) := '75706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22746172676574222C747970653A';
wwv_flow_imp.g_varchar2_table(1471) := '224C696E6B4576656E74446566696E6974696F6E222C69735265666572656E63653A21307D2C7B6E616D653A22736F75726365222C747970653A224C696E6B4576656E74446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1472) := '653A21307D5D7D2C7B6E616D653A224D6573736167654576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A226D65737361676552656622';
wwv_flow_imp.g_varchar2_table(1473) := '2C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1474) := '653A21307D5D7D2C7B6E616D653A22436F6E646974696F6E616C4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A22636F6E64697469';
wwv_flow_imp.g_varchar2_table(1475) := '6F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A225369676E616C4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74';
wwv_flow_imp.g_varchar2_table(1476) := '446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A227369676E616C526566222C747970653A225369676E616C222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225369676E616C222C';
wwv_flow_imp.g_varchar2_table(1477) := '7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C6973526566657265';
wwv_flow_imp.g_varchar2_table(1478) := '6E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22496D706C696369745468726F774576656E74222C7375706572436C6173733A5B225468726F774576656E74225D';
wwv_flow_imp.g_varchar2_table(1479) := '7D2C7B6E616D653A22446174615374617465222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(1480) := '6E616D653A224974656D4177617265456C656D656E74222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226974656D5375626A656374526566222C747970653A224974656D44656669';
wwv_flow_imp.g_varchar2_table(1481) := '6E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22646174615374617465222C747970653A22446174615374617465227D5D7D2C7B6E616D653A22446174614173736F63696174696F6E222C73757065';
wwv_flow_imp.g_varchar2_table(1482) := '72436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365526566222C747970653A224974656D4177617265456C656D656E74222C69734D616E793A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1483) := '307D2C7B6E616D653A22746172676574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A227472616E73666F726D6174696F6E222C747970653A22466F726D616C45787072';
wwv_flow_imp.g_varchar2_table(1484) := '657373696F6E222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A2261737369676E6D656E74222C747970653A2241737369676E6D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A2244617461496E70';
wwv_flow_imp.g_varchar2_table(1485) := '7574222C7375706572436C6173733A5B224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C65';
wwv_flow_imp.g_varchar2_table(1486) := '6374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22696E707574536574526566222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A';
wwv_flow_imp.g_varchar2_table(1487) := '21302C69735265666572656E63653A21307D2C7B6E616D653A22696E707574536574576974684F7074696F6E616C222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1488) := '307D2C7B6E616D653A22696E707574536574576974685768696C65457865637574696E67222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(1489) := '3A22446174614F7574707574222C7375706572436C6173733A5B224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1490) := '653A226973436F6C6C656374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226F7574707574536574526566222C747970653A224F7574707574536574222C69734D616E793A21';
wwv_flow_imp.g_varchar2_table(1491) := '302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574536574576974684F7074696F6E616C222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A2130';
wwv_flow_imp.g_varchar2_table(1492) := '2C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574536574576974685768696C65457865637574696E67222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572';
wwv_flow_imp.g_varchar2_table(1493) := '656E63653A21307D5D7D2C7B6E616D653A22496E707574536574222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A2253747269';
wwv_flow_imp.g_varchar2_table(1494) := '6E67227D2C7B6E616D653A2264617461496E70757452656673222C747970653A2244617461496E707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7074696F6E616C496E70757452656673222C74797065';
wwv_flow_imp.g_varchar2_table(1495) := '3A2244617461496E707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227768696C65457865637574696E67496E70757452656673222C747970653A2244617461496E707574222C69734D616E793A21302C6973';
wwv_flow_imp.g_varchar2_table(1496) := '5265666572656E63653A21307D2C7B6E616D653A226F757470757453657452656673222C747970653A224F7574707574536574222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224F7574707574536574222C73';
wwv_flow_imp.g_varchar2_table(1497) := '75706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22646174614F757470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(1498) := '3A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E70757453657452656673222C747970653A22496E707574536574222C69734D616E793A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1499) := '653A21307D2C7B6E616D653A226F7074696F6E616C4F757470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227768696C65457865637574696E674F75';
wwv_flow_imp.g_varchar2_table(1500) := '7470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2250726F7065727479222C7375706572436C6173733A5B224974656D4177617265456C656D65';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '6E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2244617461496E7075744173736F63696174696F6E222C7375706572436C6173733A5B2244';
wwv_flow_imp.g_varchar2_table(1502) := '6174614173736F63696174696F6E225D7D2C7B6E616D653A22446174614F75747075744173736F63696174696F6E222C7375706572436C6173733A5B22446174614173736F63696174696F6E225D7D2C7B6E616D653A22496E7075744F75747075745370';
wwv_flow_imp.g_varchar2_table(1503) := '6563696669636174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461496E70757473222C747970653A2244617461496E707574222C69734D616E793A21307D2C7B';
wwv_flow_imp.g_varchar2_table(1504) := '6E616D653A22646174614F757470757473222C747970653A22446174614F7574707574222C69734D616E793A21307D2C7B6E616D653A22696E70757453657473222C747970653A22496E707574536574222C69734D616E793A21307D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1505) := '6F757470757453657473222C747970653A224F7574707574536574222C69734D616E793A21307D5D7D2C7B6E616D653A22446174614F626A656374222C7375706572436C6173733A5B22466C6F77456C656D656E74222C224974656D4177617265456C65';
wwv_flow_imp.g_varchar2_table(1506) := '6D656E74225D2C70726F706572746965733A5B7B6E616D653A226973436F6C6C656374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A22496E7075744F757470757442696E';
wwv_flow_imp.g_varchar2_table(1507) := '64696E67222C70726F706572746965733A5B7B6E616D653A22696E70757444617461526566222C747970653A22496E707574536574222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574446174615265';
wwv_flow_imp.g_varchar2_table(1508) := '66222C747970653A224F7574707574536574222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C697352656665';
wwv_flow_imp.g_varchar2_table(1509) := '72656E63653A21307D5D7D2C7B6E616D653A2241737369676E6D656E74222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2266726F6D222C747970653A2245787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(1510) := '2C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22746F222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A224461746153';
wwv_flow_imp.g_varchar2_table(1511) := '746F7265222C7375706572436C6173733A5B22526F6F74456C656D656E74222C224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E6722';
wwv_flow_imp.g_varchar2_table(1512) := '7D2C7B6E616D653A226361706163697479222C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226973556E6C696D69746564222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E22';
wwv_flow_imp.g_varchar2_table(1513) := '7D5D7D2C7B6E616D653A224461746153746F72655265666572656E6365222C7375706572436C6173733A5B224974656D4177617265456C656D656E74222C22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461';
wwv_flow_imp.g_varchar2_table(1514) := '53746F7265526566222C747970653A224461746153746F7265222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446174614F626A6563745265666572656E6365222C7375706572436C6173733A5B224974656D';
wwv_flow_imp.g_varchar2_table(1515) := '4177617265456C656D656E74222C22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22646174614F626A656374526566222C747970653A22446174614F626A656374222C6973417474723A21302C69735265666572656E';
wwv_flow_imp.g_varchar2_table(1516) := '63653A21307D5D7D2C7B6E616D653A22436F6E766572736174696F6E4C696E6B222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365526566222C747970653A22496E74';
wwv_flow_imp.g_varchar2_table(1517) := '6572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E';
wwv_flow_imp.g_varchar2_table(1518) := '63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6E766572736174696F6E4173736F63696174696F6E222C7375706572436C6173733A5B2242617365456C656D';
wwv_flow_imp.g_varchar2_table(1519) := '656E74225D2C70726F706572746965733A5B7B6E616D653A22696E6E6572436F6E766572736174696F6E4E6F6465526566222C747970653A22436F6E766572736174696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D';
wwv_flow_imp.g_varchar2_table(1520) := '2C7B6E616D653A226F75746572436F6E766572736174696F6E4E6F6465526566222C747970653A22436F6E766572736174696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243616C6C436F6E';
wwv_flow_imp.g_varchar2_table(1521) := '766572736174696F6E222C7375706572436C6173733A5B22436F6E766572736174696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2263616C6C6564436F6C6C61626F726174696F6E526566222C747970653A22436F6C6C61626F72';
wwv_flow_imp.g_varchar2_table(1522) := '6174696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E';
wwv_flow_imp.g_varchar2_table(1523) := '793A21307D5D7D2C7B6E616D653A22436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6E766572736174696F6E4E6F6465225D7D2C7B6E616D653A22537562436F6E766572736174696F6E222C7375706572436C6173733A5B2243';
wwv_flow_imp.g_varchar2_table(1524) := '6F6E766572736174696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A22636F6E766572736174696F6E4E6F646573222C747970653A22436F6E766572736174696F6E4E6F6465222C69734D616E793A21307D5D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1525) := '436F6E766572736174696F6E4E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B22496E746572616374696F6E4E6F6465222C2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65';
wwv_flow_imp.g_varchar2_table(1526) := '222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(1527) := '3A226D657373616765466C6F7752656673222C747970653A224D657373616765466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C';
wwv_flow_imp.g_varchar2_table(1528) := '6174696F6E4B6579222C69734D616E793A21307D5D7D2C7B6E616D653A22476C6F62616C436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6C6C61626F726174696F6E225D7D2C7B6E616D653A22506172746E6572456E74697479';
wwv_flow_imp.g_varchar2_table(1529) := '222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566';
wwv_flow_imp.g_varchar2_table(1530) := '222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22506172746E6572526F6C65222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F70';
wwv_flow_imp.g_varchar2_table(1531) := '6572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C6973';
wwv_flow_imp.g_varchar2_table(1532) := '5265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F7065727479222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F';
wwv_flow_imp.g_varchar2_table(1533) := '6E50726F706572747952657472696576616C45787072657373696F6E222C747970653A22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E222C69734D616E793A21307D2C7B6E616D653A226E616D65222C';
wwv_flow_imp.g_varchar2_table(1534) := '6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2274797065222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224572726F72';
wwv_flow_imp.g_varchar2_table(1535) := '222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C697352656665';
wwv_flow_imp.g_varchar2_table(1536) := '72656E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226572726F72436F6465222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1537) := '436F7272656C6174696F6E4B6579222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F6E50726F7065727479526566222C747970653A22436F7272656C6174';
wwv_flow_imp.g_varchar2_table(1538) := '696F6E50726F7065727479222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2245787072657373696F6E222C7375';
wwv_flow_imp.g_varchar2_table(1539) := '706572436C6173733A5B2242617365456C656D656E74225D2C697341627374726163743A21312C70726F706572746965733A5B7B6E616D653A22626F6479222C6973426F64793A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22466F';
wwv_flow_imp.g_varchar2_table(1540) := '726D616C45787072657373696F6E222C7375706572436C6173733A5B2245787072657373696F6E225D2C70726F706572746965733A5B7B6E616D653A226C616E6775616765222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1541) := '653A226576616C7561746573546F54797065526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224D657373616765222C7375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(1542) := '5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226974656D526566222C747970653A224974656D446566696E697469';
wwv_flow_imp.g_varchar2_table(1543) := '6F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224974656D446566696E6974696F6E222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1544) := '226974656D4B696E64222C747970653A224974656D4B696E64222C6973417474723A21307D2C7B6E616D653A22737472756374757265526566222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C656374';
wwv_flow_imp.g_varchar2_table(1545) := '696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22696D706F7274222C747970653A22496D706F7274222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(1546) := '6E616D653A22466C6F77456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A';
wwv_flow_imp.g_varchar2_table(1547) := '22537472696E67227D2C7B6E616D653A226175646974696E67222C747970653A224175646974696E67227D2C7B6E616D653A226D6F6E69746F72696E67222C747970653A224D6F6E69746F72696E67227D2C7B6E616D653A2263617465676F727956616C';
wwv_flow_imp.g_varchar2_table(1548) := '7565526566222C747970653A2243617465676F727956616C7565222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2253657175656E6365466C6F77222C7375706572436C6173733A5B22466C6F77456C656D656E';
wwv_flow_imp.g_varchar2_table(1549) := '74225D2C70726F706572746965733A5B7B6E616D653A226973496D6D656469617465222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22636F6E646974696F6E45787072657373696F6E222C747970653A2245787072';
wwv_flow_imp.g_varchar2_table(1550) := '657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22736F75726365526566222C747970653A22466C6F774E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1551) := '653A22746172676574526566222C747970653A22466C6F774E6F6465222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22466C6F77456C656D656E7473436F6E7461696E6572222C697341627374726163743A21';
wwv_flow_imp.g_varchar2_table(1552) := '302C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226C616E6553657473222C747970653A224C616E65536574222C69734D616E793A21307D2C7B6E616D653A22666C6F77456C656D65';
wwv_flow_imp.g_varchar2_table(1553) := '6E7473222C747970653A22466C6F77456C656D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A2243616C6C61626C65456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B22526F6F74456C656D656E7422';
wwv_flow_imp.g_varchar2_table(1554) := '5D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696F53706563696669636174696F6E222C747970653A22496E7075744F757470757453706563696669';
wwv_flow_imp.g_varchar2_table(1555) := '636174696F6E222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A22737570706F72746564496E74657266616365526566222C747970653A22496E74657266616365222C69734D616E793A21302C69735265666572';
wwv_flow_imp.g_varchar2_table(1556) := '656E63653A21307D2C7B6E616D653A22696F42696E64696E67222C747970653A22496E7075744F757470757442696E64696E67222C69734D616E793A21302C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D5D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1557) := '466C6F774E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22696E636F6D696E67222C747970653A2253657175656E6365466C6F77222C';
wwv_flow_imp.g_varchar2_table(1558) := '69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574676F696E67222C747970653A2253657175656E6365466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226C616E65';
wwv_flow_imp.g_varchar2_table(1559) := '73222C747970653A224C616E65222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F';
wwv_flow_imp.g_varchar2_table(1560) := '6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226D65737361676550617468222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A226D6573736167';
wwv_flow_imp.g_varchar2_table(1561) := '65526566222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F706572747942696E64696E67222C7375706572436C6173733A5B22426173';
wwv_flow_imp.g_varchar2_table(1562) := '65456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226461746150617468222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A22636F7272656C6174696F6E50726F7065727479526566222C74797065';
wwv_flow_imp.g_varchar2_table(1563) := '3A22436F7272656C6174696F6E50726F7065727479222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225265736F75726365222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F7065';
wwv_flow_imp.g_varchar2_table(1564) := '72746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227265736F75726365506172616D6574657273222C747970653A225265736F75726365506172616D65746572222C69734D';
wwv_flow_imp.g_varchar2_table(1565) := '616E793A21307D5D7D2C7B6E616D653A225265736F75726365506172616D65746572222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C7479';
wwv_flow_imp.g_varchar2_table(1566) := '70653A22537472696E67227D2C7B6E616D653A2269735265717569726564222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2274797065222C747970653A224974656D446566696E6974696F6E222C6973417474723A';
wwv_flow_imp.g_varchar2_table(1567) := '21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E537562736372697074696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(1568) := '6F7272656C6174696F6E4B6579526566222C747970653A22436F7272656C6174696F6E4B6579222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E50726F706572747942696E64696E6722';
wwv_flow_imp.g_varchar2_table(1569) := '2C747970653A22436F7272656C6174696F6E50726F706572747942696E64696E67222C69734D616E793A21307D5D7D2C7B6E616D653A224D657373616765466C6F77222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F7065';
wwv_flow_imp.g_varchar2_table(1570) := '72746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736F75726365526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265';
wwv_flow_imp.g_varchar2_table(1571) := '666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D657373616765526566222C7479';
wwv_flow_imp.g_varchar2_table(1572) := '70653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224D657373616765466C6F774173736F63696174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70';
wwv_flow_imp.g_varchar2_table(1573) := '726F706572746965733A5B7B6E616D653A22696E6E65724D657373616765466C6F77526566222C747970653A224D657373616765466C6F77222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F757465724D657373';
wwv_flow_imp.g_varchar2_table(1574) := '616765466C6F77526566222C747970653A224D657373616765466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22496E746572616374696F6E4E6F6465222C697341627374726163743A21302C70726F';
wwv_flow_imp.g_varchar2_table(1575) := '706572746965733A5B7B6E616D653A22696E636F6D696E67436F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1576) := '653A21307D2C7B6E616D653A226F7574676F696E67436F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1577) := '307D5D7D2C7B6E616D653A225061727469636970616E74222C7375706572436C6173733A5B22496E746572616374696F6E4E6F6465222C2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474';
wwv_flow_imp.g_varchar2_table(1578) := '723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E74657266616365526566222C747970653A22496E74657266616365222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22706172746963697061';
wwv_flow_imp.g_varchar2_table(1579) := '6E744D756C7469706C6963697479222C747970653A225061727469636970616E744D756C7469706C6963697479227D2C7B6E616D653A22656E64506F696E7452656673222C747970653A22456E64506F696E74222C69734D616E793A21302C6973526566';
wwv_flow_imp.g_varchar2_table(1580) := '6572656E63653A21307D2C7B6E616D653A2270726F63657373526566222C747970653A2250726F63657373222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061727469636970616E744173736F6369617469';
wwv_flow_imp.g_varchar2_table(1581) := '6F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22696E6E65725061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C';
wwv_flow_imp.g_varchar2_table(1582) := '69735265666572656E63653A21307D2C7B6E616D653A226F757465725061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061';
wwv_flow_imp.g_varchar2_table(1583) := '727469636970616E744D756C7469706C6963697479222C70726F706572746965733A5B7B6E616D653A226D696E696D756D222C64656661756C743A302C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226D6178696D75';
wwv_flow_imp.g_varchar2_table(1584) := '6D222C64656661756C743A312C6973417474723A21302C747970653A22496E7465676572227D5D2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22436F6C6C61626F726174696F6E222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(1585) := '3A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436C6F736564222C6973417474723A21302C747970653A22';
wwv_flow_imp.g_varchar2_table(1586) := '426F6F6C65616E227D2C7B6E616D653A227061727469636970616E7473222C747970653A225061727469636970616E74222C69734D616E793A21307D2C7B6E616D653A226D657373616765466C6F7773222C747970653A224D657373616765466C6F7722';
wwv_flow_imp.g_varchar2_table(1587) := '2C69734D616E793A21307D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D2C7B6E616D653A22636F6E766572736174696F6E73222C747970653A22436F6E766572736174696F6E4E6F64';
wwv_flow_imp.g_varchar2_table(1588) := '65222C69734D616E793A21307D2C7B6E616D653A22636F6E766572736174696F6E4173736F63696174696F6E73222C747970653A22436F6E766572736174696F6E4173736F63696174696F6E227D2C7B6E616D653A227061727469636970616E74417373';
wwv_flow_imp.g_varchar2_table(1589) := '6F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A226D657373616765466C6F774173736F63696174696F6E73222C747970653A224D657373616765466C6F';
wwv_flow_imp.g_varchar2_table(1590) := '774173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D616E793A21307D2C7B6E616D653A2263686F72656F6772617068';
wwv_flow_imp.g_varchar2_table(1591) := '79526566222C747970653A2243686F72656F677261706879222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B';
wwv_flow_imp.g_varchar2_table(1592) := '222C69734D616E793A21307D5D7D2C7B6E616D653A2243686F72656F6772617068794163746976697479222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1593) := '227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22696E6974696174696E675061727469636970616E74526566222C747970653A';
wwv_flow_imp.g_varchar2_table(1594) := '225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D616E793A21307D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1595) := '6D653A226C6F6F7054797065222C747970653A2243686F72656F6772617068794C6F6F7054797065222C64656661756C743A224E6F6E65222C6973417474723A21307D5D7D2C7B6E616D653A2243616C6C43686F72656F677261706879222C7375706572';
wwv_flow_imp.g_varchar2_table(1596) := '436C6173733A5B2243686F72656F6772617068794163746976697479225D2C70726F706572746965733A5B7B6E616D653A2263616C6C656443686F72656F677261706879526566222C747970653A2243686F72656F677261706879222C6973417474723A';
wwv_flow_imp.g_varchar2_table(1597) := '21302C69735265666572656E63653A21307D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1598) := '2253756243686F72656F677261706879222C7375706572436C6173733A5B2243686F72656F6772617068794163746976697479222C22466C6F77456C656D656E7473436F6E7461696E6572225D2C70726F706572746965733A5B7B6E616D653A22617274';
wwv_flow_imp.g_varchar2_table(1599) := '696661637473222C747970653A224172746966616374222C69734D616E793A21307D5D7D2C7B6E616D653A2243686F72656F6772617068795461736B222C7375706572436C6173733A5B2243686F72656F6772617068794163746976697479225D2C7072';
wwv_flow_imp.g_varchar2_table(1600) := '6F706572746965733A5B7B6E616D653A226D657373616765466C6F77526566222C747970653A224D657373616765466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243686F72656F67726170687922';
wwv_flow_imp.g_varchar2_table(1601) := '2C7375706572436C6173733A5B22436F6C6C61626F726174696F6E222C22466C6F77456C656D656E7473436F6E7461696E6572225D7D2C7B6E616D653A22476C6F62616C43686F72656F6772617068795461736B222C7375706572436C6173733A5B2243';
wwv_flow_imp.g_varchar2_table(1602) := '686F72656F677261706879225D2C70726F706572746965733A5B7B6E616D653A22696E6974696174696E675061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(1603) := '21307D5D7D2C7B6E616D653A2254657874416E6E6F746174696F6E222C7375706572436C6173733A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D653A2274657874222C747970653A22537472696E67227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1604) := '74657874466F726D6174222C64656661756C743A22746578742F706C61696E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2247726F7570222C7375706572436C6173733A5B224172746966616374225D2C7072';
wwv_flow_imp.g_varchar2_table(1605) := '6F706572746965733A5B7B6E616D653A2263617465676F727956616C7565526566222C747970653A2243617465676F727956616C7565222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224173736F6369617469';
wwv_flow_imp.g_varchar2_table(1606) := '6F6E222C7375706572436C6173733A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D653A226173736F63696174696F6E446972656374696F6E222C747970653A224173736F63696174696F6E446972656374696F6E222C697341';
wwv_flow_imp.g_varchar2_table(1607) := '7474723A21307D2C7B6E616D653A22736F75726365526566222C747970653A2242617365456C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A224261736545';
wwv_flow_imp.g_varchar2_table(1608) := '6C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243617465676F7279222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(1609) := '617465676F727956616C7565222C747970653A2243617465676F727956616C7565222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2241727469666163';
wwv_flow_imp.g_varchar2_table(1610) := '74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A2243617465676F727956616C7565222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572';
wwv_flow_imp.g_varchar2_table(1611) := '746965733A5B7B6E616D653A2263617465676F72697A6564466C6F77456C656D656E7473222C747970653A22466C6F77456C656D656E74222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1612) := '653A2276616C7565222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224163746976697479222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F7065727469';
wwv_flow_imp.g_varchar2_table(1613) := '65733A5B7B6E616D653A226973466F72436F6D70656E736174696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F';
wwv_flow_imp.g_varchar2_table(1614) := '77222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22696F53706563696669636174696F6E222C747970653A22496E7075744F757470757453706563696669636174696F6E222C786D6C3A7B73657269616C697A653A';
wwv_flow_imp.g_varchar2_table(1615) := '2270726F7065727479227D7D2C7B6E616D653A22626F756E646172794576656E7452656673222C747970653A22426F756E646172794576656E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A2270726F70657274';
wwv_flow_imp.g_varchar2_table(1616) := '696573222C747970653A2250726F7065727479222C69734D616E793A21307D2C7B6E616D653A2264617461496E7075744173736F63696174696F6E73222C747970653A2244617461496E7075744173736F63696174696F6E222C69734D616E793A21307D';
wwv_flow_imp.g_varchar2_table(1617) := '2C7B6E616D653A22646174614F75747075744173736F63696174696F6E73222C747970653A22446174614F75747075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A2273746172745175616E74697479222C64656661756C';
wwv_flow_imp.g_varchar2_table(1618) := '743A312C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C69734D616E793A21307D2C7B6E616D653A22636F6D706C6574696F6E5175616E';
wwv_flow_imp.g_varchar2_table(1619) := '74697479222C64656661756C743A312C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226C6F6F70436861726163746572697374696373222C747970653A224C6F6F70436861726163746572697374696373227D5D7D2C';
wwv_flow_imp.g_varchar2_table(1620) := '7B6E616D653A22536572766963655461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C';
wwv_flow_imp.g_varchar2_table(1621) := '7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2253756250726F63657373222C7375706572436C6173733A5B224163';
wwv_flow_imp.g_varchar2_table(1622) := '746976697479222C22466C6F77456C656D656E7473436F6E7461696E6572222C22496E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2274726967676572656442794576656E74222C64656661756C743A21312C69';
wwv_flow_imp.g_varchar2_table(1623) := '73417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D5D7D2C7B6E616D653A224C6F6F70436861726163746572697374696373222C';
wwv_flow_imp.g_varchar2_table(1624) := '697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A224D756C7469496E7374616E63654C6F6F70436861726163746572697374696373222C7375706572436C6173733A5B224C6F6F70';
wwv_flow_imp.g_varchar2_table(1625) := '436861726163746572697374696373225D2C70726F706572746965733A5B7B6E616D653A22697353657175656E7469616C222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226265686176';
wwv_flow_imp.g_varchar2_table(1626) := '696F72222C747970653A224D756C7469496E7374616E63654265686176696F72222C64656661756C743A22416C6C222C6973417474723A21307D2C7B6E616D653A226C6F6F7043617264696E616C697479222C747970653A2245787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(1627) := '2C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A226C6F6F7044617461496E707574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1628) := '226C6F6F70446174614F7574707574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A22696E707574446174614974656D222C747970653A2244617461496E707574222C78';
wwv_flow_imp.g_varchar2_table(1629) := '6D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A226F7574707574446174614974656D222C747970653A22446174614F7574707574222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1630) := '653A22636F6D706C65784265686176696F72446566696E6974696F6E222C747970653A22436F6D706C65784265686176696F72446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A22636F6D706C6574696F6E436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(1631) := '222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A226F6E654265686176696F724576656E74526566222C747970653A224576656E74446566696E6974696F6E222C69';
wwv_flow_imp.g_varchar2_table(1632) := '73417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226E6F6E654265686176696F724576656E74526566222C747970653A224576656E74446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1633) := '307D5D7D2C7B6E616D653A225374616E646172644C6F6F70436861726163746572697374696373222C7375706572436C6173733A5B224C6F6F70436861726163746572697374696373225D2C70726F706572746965733A5B7B6E616D653A227465737442';
wwv_flow_imp.g_varchar2_table(1634) := '65666F7265222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226C6F6F70436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A22';
wwv_flow_imp.g_varchar2_table(1635) := '7873693A74797065227D7D2C7B6E616D653A226C6F6F704D6178696D756D222C747970653A22496E7465676572222C6973417474723A21307D5D7D2C7B6E616D653A2243616C6C4163746976697479222C7375706572436C6173733A5B22416374697669';
wwv_flow_imp.g_varchar2_table(1636) := '7479222C22496E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2263616C6C6564456C656D656E74222C747970653A22537472696E67222C6973417474723A21307D5D7D2C7B6E616D653A225461736B222C737570';
wwv_flow_imp.g_varchar2_table(1637) := '6572436C6173733A5B224163746976697479222C22496E746572616374696F6E4E6F6465225D7D2C7B6E616D653A2253656E645461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C';
wwv_flow_imp.g_varchar2_table(1638) := '656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D';
wwv_flow_imp.g_varchar2_table(1639) := '2C7B6E616D653A226D657373616765526566222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22526563656976655461736B222C7375706572436C6173733A5B225461736B';
wwv_flow_imp.g_varchar2_table(1640) := '225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E7374616E7469617465222C64656661756C743A21312C697341747472';
wwv_flow_imp.g_varchar2_table(1641) := '3A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D6573736167655265';
wwv_flow_imp.g_varchar2_table(1642) := '66222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225363726970745461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(1643) := '6D653A22736372697074466F726D6174222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736372697074222C747970653A22537472696E67227D5D7D2C7B6E616D653A22427573696E65737352756C655461736B222C';
wwv_flow_imp.g_varchar2_table(1644) := '7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224164486F6353756250726F';
wwv_flow_imp.g_varchar2_table(1645) := '63657373222C7375706572436C6173733A5B2253756250726F63657373225D2C70726F706572746965733A5B7B6E616D653A22636F6D706C6574696F6E436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B7365726961';
wwv_flow_imp.g_varchar2_table(1646) := '6C697A653A227873693A74797065227D7D2C7B6E616D653A226F72646572696E67222C747970653A224164486F634F72646572696E67222C6973417474723A21307D2C7B6E616D653A2263616E63656C52656D61696E696E67496E7374616E636573222C';
wwv_flow_imp.g_varchar2_table(1647) := '64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A225472616E73616374696F6E222C7375706572436C6173733A5B2253756250726F63657373225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(1648) := '6D653A2270726F746F636F6C222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226D6574686F64222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22476C6F62616C536372697074';
wwv_flow_imp.g_varchar2_table(1649) := '5461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A227363726970744C616E6775616765222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2273';
wwv_flow_imp.g_varchar2_table(1650) := '6372697074222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22476C6F62616C427573696E65737352756C655461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965';
wwv_flow_imp.g_varchar2_table(1651) := '733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6D706C65784265686176696F72446566696E6974696F6E222C7375706572436C6173733A5B22';
wwv_flow_imp.g_varchar2_table(1652) := '42617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F6E646974696F6E222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A226576656E74222C747970653A22496D706C69636974546872';
wwv_flow_imp.g_varchar2_table(1653) := '6F774576656E74227D5D7D2C7B6E616D653A225265736F75726365526F6C65222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A227265736F75726365526566222C747970653A225265';
wwv_flow_imp.g_varchar2_table(1654) := '736F75726365222C69735265666572656E63653A21307D2C7B6E616D653A227265736F75726365506172616D6574657242696E64696E6773222C747970653A225265736F75726365506172616D6574657242696E64696E67222C69734D616E793A21307D';
wwv_flow_imp.g_varchar2_table(1655) := '2C7B6E616D653A227265736F7572636541737369676E6D656E7445787072657373696F6E222C747970653A225265736F7572636541737369676E6D656E7445787072657373696F6E227D2C7B6E616D653A226E616D65222C6973417474723A21302C7479';
wwv_flow_imp.g_varchar2_table(1656) := '70653A22537472696E67227D5D7D2C7B6E616D653A225265736F75726365506172616D6574657242696E64696E67222C70726F706572746965733A5B7B6E616D653A2265787072657373696F6E222C747970653A2245787072657373696F6E222C786D6C';
wwv_flow_imp.g_varchar2_table(1657) := '3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22706172616D65746572526566222C747970653A225265736F75726365506172616D65746572222C6973417474723A21302C69735265666572656E63653A21307D5D2C7375';
wwv_flow_imp.g_varchar2_table(1658) := '706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A225265736F7572636541737369676E6D656E7445787072657373696F6E222C70726F706572746965733A5B7B6E616D653A2265787072657373696F6E222C747970653A22';
wwv_flow_imp.g_varchar2_table(1659) := '45787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22496D706F7274222C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(1660) := '653A22696D706F727454797065222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226C6F636174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226E616D657370616365222C';
wwv_flow_imp.g_varchar2_table(1661) := '6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22446566696E6974696F6E73222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C69';
wwv_flow_imp.g_varchar2_table(1662) := '73417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227461726765744E616D657370616365222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2265787072657373696F6E4C616E6775616765222C';
wwv_flow_imp.g_varchar2_table(1663) := '64656661756C743A22687474703A2F2F7777772E77332E6F72672F313939392F5850617468222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22747970654C616E6775616765222C64656661756C743A22687474703A2F';
wwv_flow_imp.g_varchar2_table(1664) := '2F7777772E77332E6F72672F323030312F584D4C536368656D61222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696D706F727473222C747970653A22496D706F7274222C69734D616E793A21307D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1665) := '22657874656E73696F6E73222C747970653A22457874656E73696F6E222C69734D616E793A21307D2C7B6E616D653A22726F6F74456C656D656E7473222C747970653A22526F6F74456C656D656E74222C69734D616E793A21307D2C7B6E616D653A2264';
wwv_flow_imp.g_varchar2_table(1666) := '69616772616D73222C69734D616E793A21302C747970653A2262706D6E64693A42504D4E4469616772616D227D2C7B6E616D653A226578706F72746572222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2272656C6174';
wwv_flow_imp.g_varchar2_table(1667) := '696F6E7368697073222C747970653A2252656C6174696F6E73686970222C69734D616E793A21307D2C7B6E616D653A226578706F7274657256657273696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D657261';
wwv_flow_imp.g_varchar2_table(1668) := '74696F6E733A5B7B6E616D653A2250726F6365737354797065222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A225075626C6963227D2C7B6E616D653A2250726976617465227D5D7D2C7B6E616D653A224761';
wwv_flow_imp.g_varchar2_table(1669) := '7465776179446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A22556E737065636966696564227D2C7B6E616D653A22436F6E76657267696E67227D2C7B6E616D653A22446976657267696E67227D2C7B6E616D653A224D69';
wwv_flow_imp.g_varchar2_table(1670) := '786564227D5D7D2C7B6E616D653A224576656E7442617365644761746577617954797065222C6C69746572616C56616C7565733A5B7B6E616D653A22506172616C6C656C227D2C7B6E616D653A224578636C7573697665227D5D7D2C7B6E616D653A2252';
wwv_flow_imp.g_varchar2_table(1671) := '656C6174696F6E73686970446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A22466F7277617264227D2C7B6E616D653A224261636B77617264227D2C7B6E616D653A22426F7468227D5D';
wwv_flow_imp.g_varchar2_table(1672) := '7D2C7B6E616D653A224974656D4B696E64222C6C69746572616C56616C7565733A5B7B6E616D653A22506879736963616C227D2C7B6E616D653A22496E666F726D6174696F6E227D5D7D2C7B6E616D653A2243686F72656F6772617068794C6F6F705479';
wwv_flow_imp.g_varchar2_table(1673) := '7065222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A225374616E64617264227D2C7B6E616D653A224D756C7469496E7374616E636553657175656E7469616C227D2C7B6E616D653A224D756C7469496E7374';
wwv_flow_imp.g_varchar2_table(1674) := '616E6365506172616C6C656C227D5D7D2C7B6E616D653A224173736F63696174696F6E446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A224F6E65227D2C7B6E616D653A22426F746822';
wwv_flow_imp.g_varchar2_table(1675) := '7D5D7D2C7B6E616D653A224D756C7469496E7374616E63654265686176696F72222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A224F6E65227D2C7B6E616D653A22416C6C227D2C7B6E616D653A22436F6D70';
wwv_flow_imp.g_varchar2_table(1676) := '6C6578227D5D7D2C7B6E616D653A224164486F634F72646572696E67222C6C69746572616C56616C7565733A5B7B6E616D653A22506172616C6C656C227D2C7B6E616D653A2253657175656E7469616C227D5D7D5D2C786D6C3A7B746167416C6961733A';
wwv_flow_imp.g_varchar2_table(1677) := '226C6F77657243617365222C747970655072656669783A2274227D7D2C62706D6E64693A7B6E616D653A2242504D4E4449222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4449222C7072';
wwv_flow_imp.g_varchar2_table(1678) := '656669783A2262706D6E6469222C74797065733A5B7B6E616D653A2242504D4E4469616772616D222C70726F706572746965733A5B7B6E616D653A22706C616E65222C747970653A2242504D4E506C616E65222C7265646566696E65733A2264693A4469';
wwv_flow_imp.g_varchar2_table(1679) := '616772616D23726F6F74456C656D656E74227D2C7B6E616D653A226C6162656C5374796C65222C747970653A2242504D4E4C6162656C5374796C65222C69734D616E793A21307D5D2C7375706572436C6173733A5B2264693A4469616772616D225D7D2C';
wwv_flow_imp.g_varchar2_table(1680) := '7B6E616D653A2242504D4E506C616E65222C70726F706572746965733A5B7B6E616D653A2262706D6E456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C72';
wwv_flow_imp.g_varchar2_table(1681) := '65646566696E65733A2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74227D5D2C7375706572436C6173733A5B2264693A506C616E65225D7D2C7B6E616D653A2242504D4E5368617065222C70726F706572746965733A5B7B';
wwv_flow_imp.g_varchar2_table(1682) := '6E616D653A2262706D6E456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A4469616772616D456C656D656E74236D6F64';
wwv_flow_imp.g_varchar2_table(1683) := '656C456C656D656E74227D2C7B6E616D653A226973486F72697A6F6E74616C222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226973457870616E646564222C6973417474723A21302C747970653A22426F6F6C6561';
wwv_flow_imp.g_varchar2_table(1684) := '6E227D2C7B6E616D653A2269734D61726B657256697369626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226C6162656C222C747970653A2242504D4E4C6162656C227D2C7B6E616D653A2269734D65737361';
wwv_flow_imp.g_varchar2_table(1685) := '676556697369626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A227061727469636970616E7442616E644B696E64222C747970653A225061727469636970616E7442616E644B696E64222C6973417474723A21';
wwv_flow_imp.g_varchar2_table(1686) := '307D2C7B6E616D653A2263686F72656F67726170687941637469766974795368617065222C747970653A2242504D4E5368617065222C6973417474723A21302C69735265666572656E63653A21307D5D2C7375706572436C6173733A5B2264693A4C6162';
wwv_flow_imp.g_varchar2_table(1687) := '656C65645368617065225D7D2C7B6E616D653A2242504D4E45646765222C70726F706572746965733A5B7B6E616D653A226C6162656C222C747970653A2242504D4E4C6162656C227D2C7B6E616D653A2262706D6E456C656D656E74222C697341747472';
wwv_flow_imp.g_varchar2_table(1688) := '3A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74227D2C7B6E616D653A22736F75726365';
wwv_flow_imp.g_varchar2_table(1689) := '456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2264693A4469616772616D456C656D656E74222C7265646566696E65733A2264693A4564676523736F75726365227D2C7B6E616D653A22746172676574';
wwv_flow_imp.g_varchar2_table(1690) := '456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2264693A4469616772616D456C656D656E74222C7265646566696E65733A2264693A4564676523746172676574227D2C7B6E616D653A226D6573736167';
wwv_flow_imp.g_varchar2_table(1691) := '6556697369626C654B696E64222C747970653A224D65737361676556697369626C654B696E64222C6973417474723A21302C64656661756C743A22696E6974696174696E67227D5D2C7375706572436C6173733A5B2264693A4C6162656C656445646765';
wwv_flow_imp.g_varchar2_table(1692) := '225D7D2C7B6E616D653A2242504D4E4C6162656C222C70726F706572746965733A5B7B6E616D653A226C6162656C5374796C65222C747970653A2242504D4E4C6162656C5374796C65222C6973417474723A21302C69735265666572656E63653A21302C';
wwv_flow_imp.g_varchar2_table(1693) := '7265646566696E65733A2264693A4469616772616D456C656D656E74237374796C65227D5D2C7375706572436C6173733A5B2264693A4C6162656C225D7D2C7B6E616D653A2242504D4E4C6162656C5374796C65222C70726F706572746965733A5B7B6E';
wwv_flow_imp.g_varchar2_table(1694) := '616D653A22666F6E74222C747970653A2264633A466F6E74227D5D2C7375706572436C6173733A5B2264693A5374796C65225D7D5D2C656E756D65726174696F6E733A5B7B6E616D653A225061727469636970616E7442616E644B696E64222C6C697465';
wwv_flow_imp.g_varchar2_table(1695) := '72616C56616C7565733A5B7B6E616D653A22746F705F696E6974696174696E67227D2C7B6E616D653A226D6964646C655F696E6974696174696E67227D2C7B6E616D653A22626F74746F6D5F696E6974696174696E67227D2C7B6E616D653A22746F705F';
wwv_flow_imp.g_varchar2_table(1696) := '6E6F6E5F696E6974696174696E67227D2C7B6E616D653A226D6964646C655F6E6F6E5F696E6974696174696E67227D2C7B6E616D653A22626F74746F6D5F6E6F6E5F696E6974696174696E67227D5D7D2C7B6E616D653A224D6573736167655669736962';
wwv_flow_imp.g_varchar2_table(1697) := '6C654B696E64222C6C69746572616C56616C7565733A5B7B6E616D653A22696E6974696174696E67227D2C7B6E616D653A226E6F6E5F696E6974696174696E67227D5D7D5D2C6173736F63696174696F6E733A5B5D7D2C64633A7B6E616D653A22444322';
wwv_flow_imp.g_varchar2_table(1698) := '2C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F4443222C7072656669783A226463222C74797065733A5B7B6E616D653A22426F6F6C65616E227D2C7B6E616D653A22496E7465676572227D2C7B';
wwv_flow_imp.g_varchar2_table(1699) := '6E616D653A225265616C227D2C7B6E616D653A22537472696E67227D2C7B6E616D653A22466F6E74222C70726F706572746965733A5B7B6E616D653A226E616D65222C747970653A22537472696E67222C6973417474723A21307D2C7B6E616D653A2273';
wwv_flow_imp.g_varchar2_table(1700) := '697A65222C747970653A225265616C222C6973417474723A21307D2C7B6E616D653A226973426F6C64222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E616D653A2269734974616C6963222C747970653A22426F6F6C65616E22';
wwv_flow_imp.g_varchar2_table(1701) := '2C6973417474723A21307D2C7B6E616D653A226973556E6465726C696E65222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E616D653A226973537472696B655468726F756768222C747970653A22426F6F6C65616E222C697341';
wwv_flow_imp.g_varchar2_table(1702) := '7474723A21307D5D7D2C7B6E616D653A22506F696E74222C70726F706572746965733A5B7B6E616D653A2278222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A2279222C747970653A22526561';
wwv_flow_imp.g_varchar2_table(1703) := '6C222C64656661756C743A2230222C6973417474723A21307D5D7D2C7B6E616D653A22426F756E6473222C70726F706572746965733A5B7B6E616D653A2278222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C';
wwv_flow_imp.g_varchar2_table(1704) := '7B6E616D653A2279222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A227769647468222C747970653A225265616C222C6973417474723A21307D2C7B6E616D653A22686569676874222C747970';
wwv_flow_imp.g_varchar2_table(1705) := '653A225265616C222C6973417474723A21307D5D7D5D2C6173736F63696174696F6E733A5B5D7D2C64693A7B6E616D653A224449222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F4449222C70';
wwv_flow_imp.g_varchar2_table(1706) := '72656669783A226469222C74797065733A5B7B6E616D653A224469616772616D456C656D656E74222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C74797065';
wwv_flow_imp.g_varchar2_table(1707) := '3A22537472696E67227D2C7B6E616D653A22657874656E73696F6E222C747970653A22457874656E73696F6E227D2C7B6E616D653A226F776E696E674469616772616D222C747970653A224469616772616D222C6973526561644F6E6C793A21302C6973';
wwv_flow_imp.g_varchar2_table(1708) := '5669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F776E696E67456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C6973';
wwv_flow_imp.g_varchar2_table(1709) := '5265666572656E63653A21307D2C7B6E616D653A226D6F64656C456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1710) := '7374796C65222C747970653A225374796C65222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F776E6564456C656D656E74222C747970653A224469616772616D456C65';
wwv_flow_imp.g_varchar2_table(1711) := '6D656E74222C6973526561644F6E6C793A21302C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A224E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B224469616772616D456C656D656E74';
wwv_flow_imp.g_varchar2_table(1712) := '225D7D2C7B6E616D653A2245646765222C697341627374726163743A21302C7375706572436C6173733A5B224469616772616D456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365222C747970653A22446961677261';
wwv_flow_imp.g_varchar2_table(1713) := '6D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C79';
wwv_flow_imp.g_varchar2_table(1714) := '3A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A22776179706F696E74222C6973556E697175653A21312C69734D616E793A21302C747970653A2264633A506F696E74222C786D6C3A7B73657269616C69';
wwv_flow_imp.g_varchar2_table(1715) := '7A653A227873693A74797065227D7D5D7D2C7B6E616D653A224469616772616D222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E';
wwv_flow_imp.g_varchar2_table(1716) := '67227D2C7B6E616D653A22726F6F74456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970';
wwv_flow_imp.g_varchar2_table(1717) := '653A22537472696E67227D2C7B6E616D653A22646F63756D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227265736F6C7574696F6E222C6973417474723A21302C747970653A225265616C227D';
wwv_flow_imp.g_varchar2_table(1718) := '2C7B6E616D653A226F776E65645374796C65222C747970653A225374796C65222C6973526561644F6E6C793A21302C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A225368617065222C697341627374726163743A2130';
wwv_flow_imp.g_varchar2_table(1719) := '2C7375706572436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22626F756E6473222C747970653A2264633A426F756E6473227D5D7D2C7B6E616D653A22506C616E65222C697341627374726163743A21302C73757065';
wwv_flow_imp.g_varchar2_table(1720) := '72436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22706C616E65456C656D656E74222C747970653A224469616772616D456C656D656E74222C73756273657474656450726F70657274793A224469616772616D456C65';
wwv_flow_imp.g_varchar2_table(1721) := '6D656E742D6F776E6564456C656D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A224C6162656C656445646765222C697341627374726163743A21302C7375706572436C6173733A5B2245646765225D2C70726F706572746965733A5B7B6E';
wwv_flow_imp.g_varchar2_table(1722) := '616D653A226F776E65644C6162656C222C747970653A224C6162656C222C6973526561644F6E6C793A21302C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D656E74222C69734D616E793A21';
wwv_flow_imp.g_varchar2_table(1723) := '302C69735669727475616C3A21307D5D7D2C7B6E616D653A224C6162656C65645368617065222C697341627374726163743A21302C7375706572436C6173733A5B225368617065225D2C70726F706572746965733A5B7B6E616D653A226F776E65644C61';
wwv_flow_imp.g_varchar2_table(1724) := '62656C222C747970653A224C6162656C222C6973526561644F6E6C793A21302C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D656E74222C69734D616E793A21302C69735669727475616C3A';
wwv_flow_imp.g_varchar2_table(1725) := '21307D5D7D2C7B6E616D653A224C6162656C222C697341627374726163743A21302C7375706572436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22626F756E6473222C747970653A2264633A426F756E6473227D5D7D';
wwv_flow_imp.g_varchar2_table(1726) := '2C7B6E616D653A225374796C65222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22457874656E73';
wwv_flow_imp.g_varchar2_table(1727) := '696F6E222C70726F706572746965733A5B7B6E616D653A2276616C756573222C69734D616E793A21302C747970653A22456C656D656E74227D5D7D5D2C6173736F63696174696F6E733A5B5D2C786D6C3A7B746167416C6961733A226C6F776572436173';
wwv_flow_imp.g_varchar2_table(1728) := '65227D7D2C62696F633A7B6E616D653A2262706D6E2E696F20636F6C6F727320666F722042504D4E222C7572693A22687474703A2F2F62706D6E2E696F2F736368656D612F62706D6E2F62696F636F6C6F722F312E30222C7072656669783A2262696F63';
wwv_flow_imp.g_varchar2_table(1729) := '222C74797065733A5B7B6E616D653A22436F6C6F7265645368617065222C657874656E64733A5B2262706D6E64693A42504D4E5368617065225D2C70726F706572746965733A5B7B6E616D653A227374726F6B65222C6973417474723A21302C74797065';
wwv_flow_imp.g_varchar2_table(1730) := '3A22537472696E67227D2C7B6E616D653A2266696C6C222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F72656445646765222C657874656E64733A5B2262706D6E64693A42504D4E45646765225D2C70';
wwv_flow_imp.g_varchar2_table(1731) := '726F706572746965733A5B7B6E616D653A227374726F6B65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2266696C6C222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D65726174';
wwv_flow_imp.g_varchar2_table(1732) := '696F6E733A5B5D2C6173736F63696174696F6E733A5B5D7D2C636F6C6F723A7B6E616D653A2242504D4E20696E20436F6C6F72222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F6E6F6E2D6E6F726D6174697665';
wwv_flow_imp.g_varchar2_table(1733) := '2F636F6C6F722F312E30222C7072656669783A22636F6C6F72222C74797065733A5B7B6E616D653A22436F6C6F7265644C6162656C222C657874656E64733A5B2262706D6E64693A42504D4E4C6162656C225D2C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(1734) := '653A22636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F7265645368617065222C657874656E64733A5B2262706D6E64693A42504D4E5368617065225D2C70726F706572746965733A5B7B';
wwv_flow_imp.g_varchar2_table(1735) := '6E616D653A226261636B67726F756E642D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22626F726465722D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1736) := '6D653A22436F6C6F72656445646765222C657874656E64733A5B2262706D6E64693A42504D4E45646765225D2C70726F706572746965733A5B7B6E616D653A22626F726465722D636F6C6F72222C6973417474723A21302C747970653A22537472696E67';
wwv_flow_imp.g_varchar2_table(1737) := '227D5D7D5D2C656E756D65726174696F6E733A5B5D2C6173736F63696174696F6E733A5B5D7D7D3B66756E6374696F6E20547228652C74297B72657475726E206E65772042722853287B7D2C4F722C65292C74297D766172204E723D2254726965642074';
wwv_flow_imp.g_varchar2_table(1738) := '6F206163636573732064692066726F6D2074686520627573696E6573734F626A6563742E2054686520646920697320617661696C61626C65207468726F75676820746865206469616772616D20656C656D656E74206F6E6C792E20466F72206D6F726520';
wwv_flow_imp.g_varchar2_table(1739) := '696E666F726D6174696F6E2C207365652068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F31343732223B66756E6374696F6E20497228652C74297B72657475726E20652E24696E7374616E6365';
wwv_flow_imp.g_varchar2_table(1740) := '4F662874297D66756E6374696F6E204C722865297B76617220743D7B7D2C6E3D5B5D2C693D7B7D3B66756E6374696F6E207228652C74297B72657475726E2066756E6374696F6E286E297B65286E2C74297D7D66756E6374696F6E206F2865297B745B65';
wwv_flow_imp.g_varchar2_table(1741) := '2E69645D3D657D66756E6374696F6E206128742C6E297B7472797B76617220723D695B742E69645D262666756E6374696F6E28742C6E297B696628742E676678297468726F77206E6577204572726F722860616C72656164792072656E64657265642024';
wwv_flow_imp.g_varchar2_table(1742) := '7B4D742874297D60293B72657475726E20652E656C656D656E7428742C695B742E69645D2C6E297D28742C6E293B72657475726E206F2874292C727D63617463682865297B7328652E6D6573736167652C7B656C656D656E743A742C6572726F723A657D';
wwv_flow_imp.g_varchar2_table(1743) := '292C636F6E736F6C652E6572726F7228606661696C656420746F20696D706F727420247B4D742874297D602C65297D7D66756E6374696F6E207328742C6E297B652E6572726F7228742C6E297D766172206C3D746869732E726567697374657244693D66';
wwv_flow_imp.g_varchar2_table(1744) := '756E6374696F6E2865297B76617220742C6E3D652E62706D6E456C656D656E743B6E3F695B6E2E69645D3F7328606D756C7469706C6520444920656C656D656E747320646566696E656420666F7220247B4D74286E297D602C7B656C656D656E743A6E7D';
wwv_flow_imp.g_varchar2_table(1745) := '293A28695B6E2E69645D3D652C6828743D6E2C22646922297C7C4F626A6563742E646566696E6550726F706572747928742C226469222C7B656E756D657261626C653A21312C6765743A66756E6374696F6E28297B7468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(1746) := '284E72297D7D29293A7328606E6F2062706D6E456C656D656E74207265666572656E63656420696E20247B4D742865297D602C7B656C656D656E743A657D297D3B66756E6374696F6E20632865297B6C2865297D746869732E68616E646C65446566696E';
wwv_flow_imp.g_varchar2_table(1747) := '6974696F6E733D66756E6374696F6E286F2C61297B76617220683D6F2E6469616772616D733B6966286126262D313D3D3D682E696E6465784F66286129297468726F77206E6577204572726F7228226469616772616D206E6F742070617274206F66203C';
wwv_flow_imp.g_varchar2_table(1748) := '62706D6E3A446566696E6974696F6E73202F3E22293B69662821612626682626682E6C656E677468262628613D685B305D292C2161297468726F77206E6577204572726F7228226E6F206469616772616D20746F20646973706C617922293B693D7B7D2C';
wwv_flow_imp.g_varchar2_table(1749) := '66756E6374696F6E2865297B76617220743B743D652E706C616E652C6C2874292C6628742E706C616E65456C656D656E742C63297D2861293B76617220673D612E706C616E653B6966282167297468726F77206E6577204572726F7228606E6F20706C61';
wwv_flow_imp.g_varchar2_table(1750) := '6E6520666F7220247B4D742861297D60293B76617220763D672E62706D6E456C656D656E743B6966282176297B696628763D66756E6374696F6E2865297B72657475726E206428652E726F6F74456C656D656E74732C2866756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(1751) := '657475726E20497228652C2262706D6E3A50726F6365737322297C7C497228652C2262706D6E3A436F6C6C61626F726174696F6E22297D29297D286F292C2176297468726F77206E6577204572726F7228226E6F2070726F63657373206F7220636F6C6C';
wwv_flow_imp.g_varchar2_table(1752) := '61626F726174696F6E20746F20646973706C617922293B732860636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E20247B4D742867297D20746F20247B4D742876297D60292C672E62706D6E456C656D656E743D762C6C';
wwv_flow_imp.g_varchar2_table(1753) := '2867297D76617220622C782C5F3D66756E6374696F6E28742C6E297B72657475726E20652E726F6F7428742C695B742E69645D2C6E297D28762C67293B696628497228762C2262706D6E3A50726F6365737322297C7C497228762C2262706D6E3A537562';
wwv_flow_imp.g_varchar2_table(1754) := '50726F636573732229297528762C5F293B656C73657B69662821497228762C2262706D6E3A436F6C6C61626F726174696F6E2229297468726F77206E6577204572726F722860756E737570706F727465642062706D6E456C656D656E7420666F7220247B';
wwv_flow_imp.g_varchar2_table(1755) := '4D742867297D3A20247B4D742876297D60293B783D5F2C662828623D76292E7061727469636970616E74732C7228522C7829292C7728622E6172746966616374732C78292C6E2E70757368282866756E6374696F6E28297B2166756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1756) := '74297B6628652C7228792C7429297D28622E6D657373616765466C6F77732C78297D29292C66756E6374696F6E28652C6E297B76617220693D6D28652C2866756E6374696F6E2865297B72657475726E21745B652E69645D2626497228652C2262706D6E';
wwv_flow_imp.g_varchar2_table(1757) := '3A50726F6365737322292626652E6C616E65536574737D29293B692E666F7245616368287228752C6E29297D286F2E726F6F74456C656D656E74732C5F297D70286E297D3B76617220703D746869732E68616E646C6544656665727265643D66756E6374';
wwv_flow_imp.g_varchar2_table(1758) := '696F6E28297B666F72283B6E2E6C656E6774683B296E2E7368696674282928297D3B66756E6374696F6E207528652C74297B6B28652C74292C5F28652E696F53706563696669636174696F6E2C74292C7728652E6172746966616374732C74292C6F2865';
wwv_flow_imp.g_varchar2_table(1759) := '297D66756E6374696F6E207928652C74297B6128652C74297D66756E6374696F6E206728652C74297B6128652C74297D66756E6374696F6E207628652C74297B6128652C74297D66756E6374696F6E206228652C74297B6128652C74297D66756E637469';
wwv_flow_imp.g_varchar2_table(1760) := '6F6E207828652C74297B6128652C74297D66756E6374696F6E207728652C74297B6628652C2866756E6374696F6E2865297B497228652C2262706D6E3A4173736F63696174696F6E22293F6E2E70757368282866756E6374696F6E28297B7828652C7429';
wwv_flow_imp.g_varchar2_table(1761) := '7D29293A7828652C74297D29297D66756E6374696F6E205F28652C74297B652626286628652E64617461496E707574732C7228762C7429292C6628652E646174614F7574707574732C7228622C742929297D76617220453D746869732E68616E646C6553';
wwv_flow_imp.g_varchar2_table(1762) := '756250726F636573733D66756E6374696F6E28652C74297B6B28652C74292C7728652E6172746966616374732C74297D3B66756E6374696F6E205328652C74297B76617220693D6128652C74293B497228652C2262706D6E3A53756250726F6365737322';
wwv_flow_imp.g_varchar2_table(1763) := '2926264528652C697C7C74292C497228652C2262706D6E3A4163746976697479222926265F28652E696F53706563696669636174696F6E2C74292C6E2E70757368282866756E6374696F6E28297B6628652E64617461496E7075744173736F6369617469';
wwv_flow_imp.g_varchar2_table(1764) := '6F6E732C7228672C7429292C6628652E646174614F75747075744173736F63696174696F6E732C7228672C7429297D29297D66756E6374696F6E204128652C74297B6E2E70757368282866756E6374696F6E28297B766172206E3D6128652C74293B652E';
wwv_flow_imp.g_varchar2_table(1765) := '6368696C644C616E6553657426264328652E6368696C644C616E655365742C6E7C7C74292C66756E6374696F6E2865297B6628652E666C6F774E6F64655265662C2866756E6374696F6E2874297B766172206E3D742E67657428226C616E657322293B6E';
wwv_flow_imp.g_varchar2_table(1766) := '26266E2E707573682865297D29297D2865297D29297D66756E6374696F6E204328652C74297B6628652E6C616E65732C7228412C7429297D66756E6374696F6E206B28652C74297B2166756E6374696F6E28652C74297B6628652C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1767) := '2865297B497228652C2262706D6E3A53657175656E6365466C6F7722293F6E2E70757368282866756E6374696F6E28297B2166756E6374696F6E28652C74297B6128652C74297D28652C74297D29293A497228652C2262706D6E3A426F756E6461727945';
wwv_flow_imp.g_varchar2_table(1768) := '76656E7422293F6E2E756E7368696674282866756E6374696F6E28297B5328652C74297D29293A497228652C2262706D6E3A466C6F774E6F646522293F5328652C74293A497228652C2262706D6E3A446174614F626A65637422297C7C28497228652C22';
wwv_flow_imp.g_varchar2_table(1769) := '62706D6E3A4461746153746F72655265666572656E636522297C7C497228652C2262706D6E3A446174614F626A6563745265666572656E636522293F66756E6374696F6E28652C74297B6128652C74297D28652C74293A732860756E7265636F676E697A';
wwv_flow_imp.g_varchar2_table(1770) := '656420666C6F77456C656D656E7420247B4D742865297D20696E20636F6E7465787420247B4D7428742626742E627573696E6573734F626A656374297D602C7B656C656D656E743A652C636F6E746578743A747D29297D29297D28652E666C6F77456C65';
wwv_flow_imp.g_varchar2_table(1771) := '6D656E74732C74292C652E6C616E6553657473262666756E6374696F6E28652C74297B6628652C7228432C7429297D28652E6C616E65536574732C74297D66756E6374696F6E205228652C74297B766172206E3D6128652C74292C693D652E70726F6365';
wwv_flow_imp.g_varchar2_table(1772) := '73735265663B6926267528692C6E7C7C74297D7D66756E6374696F6E206A7228652C742C6E297B76617220692C722C6F2C613D5B5D3B66756E6374696F6E207328652C74297B766172206E3D6E6577204C72287B726F6F743A66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1773) := '74297B72657475726E20692E61646428652C74297D2C656C656D656E743A66756E6374696F6E28652C742C6E297B72657475726E20692E61646428652C742C6E297D2C6572726F723A66756E6374696F6E28652C74297B612E70757368287B6D65737361';
wwv_flow_imp.g_varchar2_table(1774) := '67653A652C636F6E746578743A747D297D7D293B743D747C7C652E6469616772616D732626652E6469616772616D735B305D3B76617220723D66756E6374696F6E28652C74297B696628742626742E706C616E65297B766172206E2C693D742E706C616E';
wwv_flow_imp.g_varchar2_table(1775) := '652E62706D6E456C656D656E742C723D693B6B28692C2262706D6E3A50726F6365737322297C7C6B28692C2262706D6E3A436F6C6C61626F726174696F6E22297C7C28723D66756E6374696F6E2865297B666F722876617220743D653B743B297B696628';
wwv_flow_imp.g_varchar2_table(1776) := '6B28742C2262706D6E3A50726F6365737322292972657475726E20743B743D742E24706172656E747D7D286929292C6E3D6B28722C2262706D6E3A436F6C6C61626F726174696F6E22293F723A6428652E726F6F74456C656D656E74732C2866756E6374';
wwv_flow_imp.g_varchar2_table(1777) := '696F6E2865297B6966286B28652C2262706D6E3A436F6C6C61626F726174696F6E22292972657475726E206428652E7061727469636970616E74732C2866756E6374696F6E2865297B72657475726E20652E70726F636573735265663D3D3D727D29297D';
wwv_flow_imp.g_varchar2_table(1778) := '29293B766172206F3D5B725D3B6E2626286F3D66756E6374696F6E28652C74297B6C6574206E3D5B5D3B72657475726E206628652C2866756E6374696F6E28652C69297B6E2E70757368287428652C6929297D29292C6E7D286E2E706172746963697061';
wwv_flow_imp.g_varchar2_table(1779) := '6E74732C2866756E6374696F6E2865297B72657475726E20652E70726F636573735265667D2929292E70757368286E293B76617220613D4672286F292C733D5B745D2C6C3D5B695D3B72657475726E206628652E6469616772616D732C2866756E637469';
wwv_flow_imp.g_varchar2_table(1780) := '6F6E2865297B696628652E706C616E65297B76617220743D652E706C616E652E62706D6E456C656D656E743B2D31213D3D612E696E6465784F6628742926262D313D3D3D6C2E696E6465784F66287429262628732E707573682865292C6C2E7075736828';
wwv_flow_imp.g_varchar2_table(1781) := '7429297D7D29292C737D7D28652C74293B6966282172297468726F77206E6577204572726F7228226E6F206469616772616D20746F20646973706C617922293B6628722C2866756E6374696F6E2874297B6E2E68616E646C65446566696E6974696F6E73';
wwv_flow_imp.g_varchar2_table(1782) := '28652C74297D29293B76617220733D742E706C616E652E62706D6E456C656D656E742E69643B6F2E736574526F6F74456C656D656E74286F2E66696E64526F6F7428732B225F706C616E6522297C7C6F2E66696E64526F6F74287329297D72657475726E';
wwv_flow_imp.g_varchar2_table(1783) := '206E65772050726F6D697365282866756E6374696F6E286C2C63297B7472797B72657475726E20693D652E676574282262706D6E496D706F7274657222292C723D652E67657428226576656E7442757322292C6F3D652E676574282263616E7661732229';
wwv_flow_imp.g_varchar2_table(1784) := '2C722E666972652822696D706F72742E72656E6465722E7374617274222C7B646566696E6974696F6E733A747D292C7328742C6E292C722E666972652822696D706F72742E72656E6465722E636F6D706C657465222C7B6572726F723A766F696420302C';
wwv_flow_imp.g_varchar2_table(1785) := '7761726E696E67733A617D292C6C287B7761726E696E67733A617D297D63617463682865297B72657475726E20652E7761726E696E67733D612C632865297D7D29297D66756E6374696F6E2046722865297B76617220743D5B5D3B72657475726E206628';
wwv_flow_imp.g_varchar2_table(1786) := '652C2866756E6374696F6E2865297B65262628742E707573682865292C743D742E636F6E63617428467228652E666C6F77456C656D656E74732929297D29292C747D7661722056722C24723D273C73766720786D6C6E733D22687474703A2F2F7777772E';
wwv_flow_imp.g_varchar2_table(1787) := '77332E6F72672F323030302F737667222076696577426F783D223020302031342E303220352E3537222077696474683D22353322206865696768743D223231223E3C706174682066696C6C3D2263757272656E74436F6C6F722220643D224D312E38382E';
wwv_flow_imp.g_varchar2_table(1788) := '3932762E31346330202E34312D2E31332E36382D2E342E382E33332E31342E34362E34342E34362E3836762E33336330202E36312D2E33332E39352D2E39352E393548305630682E3935632E36352030202E39332E332E39332E39327A4D2E36332E3537';
wwv_flow_imp.g_varchar2_table(1789) := '76312E3036682E3234632E32342030202E33382D2E312E33382D2E3433562E393863302D2E32382D2E312D2E342D2E33322D2E347A6D3020312E363376312E3232682E3336632E322030202E33322D2E312E33322D2E3339762D2E333563302D2E33372D';
wwv_flow_imp.g_varchar2_table(1790) := '2E31322D2E34382D2E342D2E3438482E36337A4D342E31382E3939762E35326330202E36342D2E33312E39382D2E39342E3938682D2E335634682D2E36325630682E3932632E36332030202E39342E33352E39342E39397A4D322E39342E353776312E33';
wwv_flow_imp.g_varchar2_table(1791) := '35682E33632E322030202E332D2E30392E332D2E3337762D2E3663302D2E32392D2E312D2E33382D2E332D2E3338682D2E337A6D322E383920322E32374C362E32352030682E38387634682D2E3656312E31324C362E3120332E3939682D2E366C2D2E34';
wwv_flow_imp.g_varchar2_table(1792) := '362D322E383276322E3832682D2E35355630682E38377A4D382E313420312E315634682D2E35365630682E37394C3920322E345630682E35367634682D2E36347A6D322E343920322E3239762E36682D2E36762D2E367A4D31322E3132203163302D2E36';
wwv_flow_imp.g_varchar2_table(1793) := '332E33332D31202E39352D31202E36312030202E39352E33372E3935203176322E30346330202E36342D2E333420312D2E393520312D2E363220302D2E39352D2E33372D2E39352D317A6D2E363220322E30386330202E32382E31332E33392E33332E33';
wwv_flow_imp.g_varchar2_table(1794) := '39732E33322D2E312E33322D2E34562E393863302D2E32392D2E31322D2E342D2E33322D2E34732D2E33332E31312D2E33332E347A222F3E3C706174682066696C6C3D2263757272656E74436F6C6F722220643D224D3020342E35336831342E30327631';
wwv_flow_imp.g_varchar2_table(1795) := '2E303448307A4D31312E30382030682E3633762E3632682D2E36337A6D2E363320345631682D2E363376322E39387A222F3E3C2F7376673E272C7A723D7B766572746963616C416C69676E3A226D6964646C65227D2C57723D7B636F6C6F723A22233430';
wwv_flow_imp.g_varchar2_table(1796) := '34303430227D2C47723D7B7A496E6465783A2231303031222C706F736974696F6E3A226669786564222C746F703A2230222C6C6566743A2230222C72696768743A2230222C626F74746F6D3A2230227D2C48723D7B77696474683A2231303025222C6865';
wwv_flow_imp.g_varchar2_table(1797) := '696768743A2231303025222C6261636B67726F756E643A22726762612834302C34302C34302C302E3229227D2C4B723D7B706F736974696F6E3A226162736F6C757465222C6C6566743A22353025222C746F703A22343025222C7472616E73666F726D3A';
wwv_flow_imp.g_varchar2_table(1798) := '227472616E736C617465282D35302529222C77696474683A223236307078222C70616464696E673A2231307078222C6261636B67726F756E643A227768697465222C626F78536861646F773A22302031707820347078207267626128302C302C302C302E';
wwv_flow_imp.g_varchar2_table(1799) := '3329222C666F6E7446616D696C793A2248656C7665746963612C20417269616C2C2073616E732D7365726966222C666F6E7453697A653A2231347078222C646973706C61793A22666C6578222C6C696E654865696768743A22312E33227D2C55723D273C';
wwv_flow_imp.g_varchar2_table(1800) := '64697620636C6173733D22626A732D706F77657265642D62792D6C69676874626F78223E3C64697620636C6173733D226261636B64726F70223E3C2F6469763E3C64697620636C6173733D226E6F74696365223E3C6120687265663D2268747470733A2F';
wwv_flow_imp.g_varchar2_table(1801) := '2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E65722220636C6173733D226C696E6B223E272B24722B273C2F613E3C7370616E3E5765622D626173656420746F6F6C696E6720666F722042504D4E2C20444D';
wwv_flow_imp.g_varchar2_table(1802) := '4E20616E6420666F726D7320706F7765726564206279203C6120687265663D2268747470733A2F2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E6572223E62706D6E2E696F3C2F613E2E3C2F7370616E3E3C';
wwv_flow_imp.g_varchar2_table(1803) := '2F6469763E3C2F6469763E273B66756E6374696F6E2071722865297B653D53287B7D2C58722C65292C746869732E5F6D6F64646C653D746869732E5F6372656174654D6F64646C652865292C746869732E5F636F6E7461696E65723D746869732E5F6372';
wwv_flow_imp.g_varchar2_table(1804) := '65617465436F6E7461696E65722865292C66756E6374696F6E2865297B636F6E737420743D516528273C6120687265663D22687474703A2F2F62706D6E2E696F22207461726765743D225F626C616E6B2220636C6173733D22626A732D706F7765726564';
wwv_flow_imp.g_varchar2_table(1805) := '2D627922207469746C653D22506F77657265642062792062706D6E2E696F22203E272B24722B223C2F613E22293B4F652865742822737667222C74292C7A72292C4F6528742C57722C7B706F736974696F6E3A226162736F6C757465222C626F74746F6D';
wwv_flow_imp.g_varchar2_table(1806) := '3A2231357078222C72696768743A2231357078222C7A496E6465783A22313030227D292C652E617070656E644368696C642874292C71652E62696E6428742C22636C69636B222C2866756E6374696F6E2865297B56727C7C284F652856723D5165285572';
wwv_flow_imp.g_varchar2_table(1807) := '292C4772292C4F652865742822737667222C5672292C7A72292C4F6528657428222E6261636B64726F70222C5672292C4872292C4F6528657428222E6E6F74696365222C5672292C4B72292C4F6528657428222E6C696E6B222C5672292C57722C7B6D61';
wwv_flow_imp.g_varchar2_table(1808) := '7267696E3A2231357078203230707820313570782031307078222C616C69676E53656C663A2263656E746572227D292C58652E62696E642856722C222E6261636B64726F70222C22636C69636B222C2866756E6374696F6E2865297B646F63756D656E74';
wwv_flow_imp.g_varchar2_table(1809) := '2E626F64792E72656D6F76654368696C64285672297D2929292C646F63756D656E742E626F64792E617070656E644368696C64285672292C652E70726576656E7444656661756C7428297D29297D28746869732E5F636F6E7461696E6572292C74686973';
wwv_flow_imp.g_varchar2_table(1810) := '2E5F696E697428746869732E5F636F6E7461696E65722C746869732E5F6D6F64646C652C65297D66756E6374696F6E20597228652C74297B72657475726E20652E7761726E696E67733D742C657D6E2871722C6269292C71722E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(1811) := '696D706F7274584D4C3D6173796E632066756E6374696F6E28652C74297B636F6E7374206E3D746869733B6C657420693D5B5D3B7472797B6C6574206F3B653D746869732E5F656D69742822696D706F72742E70617273652E7374617274222C7B786D6C';
wwv_flow_imp.g_varchar2_table(1812) := '3A657D297C7C653B7472797B6F3D617761697420746869732E5F6D6F64646C652E66726F6D584D4C28652C2262706D6E3A446566696E6974696F6E7322297D63617463682865297B7468726F7720746869732E5F656D69742822696D706F72742E706172';
wwv_flow_imp.g_varchar2_table(1813) := '73652E636F6D706C657465222C7B6572726F723A657D292C657D6C657420613D6F2E726F6F74456C656D656E743B636F6E737420733D6F2E7265666572656E6365732C6C3D6F2E7761726E696E67732C633D6F2E656C656D656E7473427949643B693D69';
wwv_flow_imp.g_varchar2_table(1814) := '2E636F6E636174286C292C613D746869732E5F656D69742822696D706F72742E70617273652E636F6D706C657465222C28723D7B6572726F723A6E756C6C2C646566696E6974696F6E733A612C656C656D656E7473427949643A632C7265666572656E63';
wwv_flow_imp.g_varchar2_table(1815) := '65733A732C7761726E696E67733A697D2C6E2E67657428226576656E7442757322292E6372656174654576656E7428722929297C7C613B636F6E737420703D617761697420746869732E696D706F7274446566696E6974696F6E7328612C74293B726574';
wwv_flow_imp.g_varchar2_table(1816) := '75726E20693D692E636F6E63617428702E7761726E696E6773292C746869732E5F656D69742822696D706F72742E646F6E65222C7B6572726F723A6E756C6C2C7761726E696E67733A697D292C7B7761726E696E67733A697D7D63617463682865297B6C';
wwv_flow_imp.g_varchar2_table(1817) := '657420743D653B7468726F7720693D692E636F6E63617428742E7761726E696E67737C7C5B5D292C597228742C69292C743D66756E6374696F6E2865297B636F6E737420743D2F756E7061727361626C6520636F6E74656E74203C285B5E3E5D2B293E20';
wwv_flow_imp.g_varchar2_table(1818) := '6465746563746564285B5C735C535D2A29242F2E6578656328652E6D657373616765293B72657475726E2074262628652E6D6573736167653D22756E7061727361626C6520636F6E74656E74203C222B745B315D2B223E2064657465637465643B207468';
wwv_flow_imp.g_varchar2_table(1819) := '6973206D617920696E64696361746520616E20696E76616C69642042504D4E20322E30206469616772616D2066696C65222B745B325D292C657D2874292C746869732E5F656D69742822696D706F72742E646F6E65222C7B6572726F723A742C7761726E';
wwv_flow_imp.g_varchar2_table(1820) := '696E67733A742E7761726E696E67737D292C747D76617220727D2C71722E70726F746F747970652E696D706F7274446566696E6974696F6E733D6173796E632066756E6374696F6E28652C74297B72657475726E20746869732E5F736574446566696E69';
wwv_flow_imp.g_varchar2_table(1821) := '74696F6E732865292C7B7761726E696E67733A28617761697420746869732E6F70656E287429292E7761726E696E67737D7D2C71722E70726F746F747970652E6F70656E3D6173796E632066756E6374696F6E2865297B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(1822) := '5F646566696E6974696F6E733B6C6574206E3D653B6966282174297B636F6E737420653D6E6577204572726F7228226E6F20584D4C20696D706F7274656422293B7468726F7720597228652C5B5D292C657D69662822737472696E67223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1823) := '6620652626286E3D66756E6374696F6E28652C74297B72657475726E207426266428652E6469616772616D732C2866756E6374696F6E2865297B72657475726E20652E69643D3D3D747D29297C7C6E756C6C7D28742C65292C216E29297B636F6E737420';
wwv_flow_imp.g_varchar2_table(1824) := '743D6E6577204572726F72282242504D4E4469616772616D203C222B652B223E206E6F7420666F756E6422293B7468726F7720597228742C5B5D292C747D7472797B746869732E636C65617228297D63617463682865297B7468726F7720597228652C5B';
wwv_flow_imp.g_varchar2_table(1825) := '5D292C657D636F6E73747B7761726E696E67733A697D3D6177616974206A7228746869732C742C6E293B72657475726E7B7761726E696E67733A697D7D2C71722E70726F746F747970652E73617665584D4C3D6173796E632066756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(1826) := '7B653D657C7C7B7D3B6C657420742C6E2C693D746869732E5F646566696E6974696F6E733B7472797B6966282169297468726F77206E6577204572726F7228226E6F20646566696E6974696F6E73206C6F6164656422293B693D746869732E5F656D6974';
wwv_flow_imp.g_varchar2_table(1827) := '282273617665584D4C2E7374617274222C7B646566696E6974696F6E733A697D297C7C692C6E3D28617761697420746869732E5F6D6F64646C652E746F584D4C28692C6529292E786D6C2C6E3D746869732E5F656D6974282273617665584D4C2E736572';
wwv_flow_imp.g_varchar2_table(1828) := '69616C697A6564222C7B786D6C3A6E7D297C7C6E7D63617463682865297B743D657D636F6E737420723D743F7B6572726F723A747D3A7B786D6C3A6E7D3B696628746869732E5F656D6974282273617665584D4C2E646F6E65222C72292C74297468726F';
wwv_flow_imp.g_varchar2_table(1829) := '7720743B72657475726E20727D2C71722E70726F746F747970652E736176655356473D6173796E632066756E6374696F6E28297B6C657420652C743B746869732E5F656D69742822736176655356472E737461727422293B7472797B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(1830) := '746869732E676574282263616E76617322292C6E3D742E6765744163746976654C6179657228292C693D657428223A73636F7065203E2064656673222C742E5F737667292C723D6165286E292C6F3D693F223C646566733E222B61652869292B223C2F64';
wwv_flow_imp.g_varchar2_table(1831) := '6566733E223A22222C613D6E2E67657442426F7828293B653D273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D227574662D38223F3E5C6E5C783363212D2D206372656174656420776974682062706D6E2D6A73202F20687474';
wwv_flow_imp.g_varchar2_table(1832) := '703A2F2F62706D6E2E696F202D2D5C7833655C6E3C21444F435459504520737667205055424C494320222D2F2F5733432F2F4454442053564720312E312F2F454E222022687474703A2F2F7777772E77332E6F72672F47726170686963732F5356472F31';
wwv_flow_imp.g_varchar2_table(1833) := '2E312F4454442F73766731312E647464223E5C6E3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220786D6C6E733A786C696E6B3D22687474703A2F2F7777772E77332E6F72672F313939392F786C696E';
wwv_flow_imp.g_varchar2_table(1834) := '6B222077696474683D22272B612E77696474682B2722206865696768743D22272B612E6865696768742B27222076696577426F783D22272B612E782B2220222B612E792B2220222B612E77696474682B2220222B612E6865696768742B27222076657273';
wwv_flow_imp.g_varchar2_table(1835) := '696F6E3D22312E31223E272B6F2B722B223C2F7376673E227D63617463682865297B743D657D696628746869732E5F656D69742822736176655356472E646F6E65222C7B6572726F723A742C7376673A657D292C74297468726F7720743B72657475726E';
wwv_flow_imp.g_varchar2_table(1836) := '7B7376673A657D7D2C71722E70726F746F747970652E5F736574446566696E6974696F6E733D66756E6374696F6E2865297B746869732E5F646566696E6974696F6E733D657D2C71722E70726F746F747970652E6765744D6F64756C65733D66756E6374';
wwv_flow_imp.g_varchar2_table(1837) := '696F6E28297B72657475726E20746869732E5F6D6F64756C65737D2C71722E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E676574446566696E6974696F6E732829262662692E70726F746F747970652E636C6561722E';
wwv_flow_imp.g_varchar2_table(1838) := '63616C6C2874686973297D2C71722E70726F746F747970652E64657374726F793D66756E6374696F6E28297B62692E70726F746F747970652E64657374726F792E63616C6C2874686973292C747428746869732E5F636F6E7461696E6572297D2C71722E';
wwv_flow_imp.g_varchar2_table(1839) := '70726F746F747970652E6F6E3D66756E6374696F6E28652C742C6E2C69297B72657475726E20746869732E67657428226576656E7442757322292E6F6E28652C742C6E2C69297D2C71722E70726F746F747970652E6F66663D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1840) := '74297B746869732E67657428226576656E7442757322292E6F666628652C74297D2C71722E70726F746F747970652E617474616368546F3D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F722822706172656E744E6F64';
wwv_flow_imp.g_varchar2_table(1841) := '6520726571756972656422293B746869732E64657461636828292C652E6765742626652E636F6E7374727563746F722E70726F746F747970652E6A7175657279262628653D652E676574283029292C22737472696E67223D3D747970656F662065262628';
wwv_flow_imp.g_varchar2_table(1842) := '653D6574286529292C652E617070656E644368696C6428746869732E5F636F6E7461696E6572292C746869732E5F656D69742822617474616368222C7B7D292C746869732E676574282263616E76617322292E726573697A656428297D2C71722E70726F';
wwv_flow_imp.g_varchar2_table(1843) := '746F747970652E676574446566696E6974696F6E733D66756E6374696F6E28297B72657475726E20746869732E5F646566696E6974696F6E737D2C71722E70726F746F747970652E6465746163683D66756E6374696F6E28297B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(1844) := '69732E5F636F6E7461696E65722C743D652E706172656E744E6F64653B74262628746869732E5F656D69742822646574616368222C7B7D292C742E72656D6F76654368696C64286529297D2C71722E70726F746F747970652E5F696E69743D66756E6374';
wwv_flow_imp.g_varchar2_table(1845) := '696F6E28652C742C6E297B636F6E737420693D6E2E6D6F64756C65737C7C746869732E6765744D6F64756C6573286E292C723D6E2E6164646974696F6E616C4D6F64756C65737C7C5B5D2C6F3D5B5D2E636F6E636174285B7B62706D6E6A733A5B227661';
wwv_flow_imp.g_varchar2_table(1846) := '6C7565222C746869735D2C6D6F64646C653A5B2276616C7565222C745D7D5D2C692C72292C613D532866756E6374696F6E28652C74297B6C6574206E3D7B7D3B72657475726E2066284F626A6563742865292C2866756E6374696F6E28652C69297B2D31';
wwv_flow_imp.g_varchar2_table(1847) := '3D3D3D742E696E6465784F662869292626286E5B695D3D65297D29292C6E7D286E2C5B226164646974696F6E616C4D6F64756C6573225D292C7B63616E7661733A53287B7D2C6E2E63616E7661732C7B636F6E7461696E65723A657D292C6D6F64756C65';
wwv_flow_imp.g_varchar2_table(1848) := '733A6F7D293B62692E63616C6C28746869732C61292C6E26266E2E636F6E7461696E65722626746869732E617474616368546F286E2E636F6E7461696E6572297D2C71722E70726F746F747970652E5F656D69743D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(1849) := '657475726E20746869732E67657428226576656E7442757322292E6669726528652C74297D2C71722E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E6374696F6E2865297B636F6E737420743D516528273C64697620636C61';
wwv_flow_imp.g_varchar2_table(1850) := '73733D22626A732D636F6E7461696E6572223E3C2F6469763E27293B72657475726E204F6528742C7B77696474683A5A7228652E7769647468292C6865696768743A5A7228652E686569676874292C706F736974696F6E3A652E706F736974696F6E7D29';
wwv_flow_imp.g_varchar2_table(1851) := '2C747D2C71722E70726F746F747970652E5F6372656174654D6F64646C653D66756E6374696F6E2865297B72657475726E206E65772054722853287B7D2C746869732E5F6D6F64646C65457874656E73696F6E732C652E6D6F64646C65457874656E7369';
wwv_flow_imp.g_varchar2_table(1852) := '6F6E7329297D2C71722E70726F746F747970652E5F6D6F64756C65733D5B5D3B636F6E73742058723D7B77696474683A2231303025222C6865696768743A2231303025222C706F736974696F6E3A2272656C6174697665227D3B66756E6374696F6E205A';
wwv_flow_imp.g_varchar2_table(1853) := '722865297B72657475726E20652B28632865293F227078223A2222297D66756E6374696F6E204A722865297B71722E63616C6C28746869732C65297D6E284A722C7172292C4A722E70726F746F747970652E5F6D6F64756C65733D5B54742C6C6E2C796E';
wwv_flow_imp.g_varchar2_table(1854) := '2C47742C446E2C53745D2C4A722E70726F746F747970652E5F6D6F64646C65457874656E73696F6E733D7B7D3B7661722051723D2F5E646A732D637572736F722D2E2A242F3B66756E6374696F6E20656F2865297B76617220743D496528646F63756D65';
wwv_flow_imp.g_varchar2_table(1855) := '6E742E626F6479293B742E72656D6F76654D61746368696E67285172292C652626742E6164642822646A732D637572736F722D222B65297D66756E6374696F6E20746F28652C74297B72657475726E7B783A652E782D742E782C793A652E792D742E797D';
wwv_flow_imp.g_varchar2_table(1856) := '7D66756E6374696F6E206E6F28652C74297B766172206E3B66756E6374696F6E20692869297B76617220722C6F3D6E2E73746172742C613D6E2E627574746F6E2C733D766E2869292C6C3D746F28732C6F293B216E2E6472616767696E67262628723D6C';
wwv_flow_imp.g_varchar2_table(1857) := '2C4D6174682E73717274284D6174682E706F7728722E782C32292B4D6174682E706F7728722E792C3229293E3135292626286E2E6472616767696E673D21302C303D3D3D61262666756E6374696F6E28652C74297B743D747C7C22656C656D656E742E63';
wwv_flow_imp.g_varchar2_table(1858) := '6C69636B222C652E6F6E636528742C3565332C2866756E6374696F6E28297B72657475726E21317D29297D2865292C656F2822677261622229292C6E2E6472616767696E672626286C3D746F28732C6E2E6C6173747C7C6E2E7374617274292C742E7363';
wwv_flow_imp.g_varchar2_table(1859) := '726F6C6C287B64783A6C2E782C64793A6C2E797D292C6E2E6C6173743D73292C692E70726576656E7444656661756C7428297D66756E6374696F6E20722865297B71652E756E62696E6428646F63756D656E742C226D6F7573656D6F7665222C69292C71';
wwv_flow_imp.g_varchar2_table(1860) := '652E756E62696E6428646F63756D656E742C226D6F7573657570222C72292C6E3D6E756C6C2C656F286E756C6C297D652E6F6E2822656C656D656E742E6D6F757365646F776E222C3530302C2866756E6374696F6E2865297B72657475726E2066756E63';
wwv_flow_imp.g_varchar2_table(1861) := '74696F6E2865297B69662821466528652E7461726765742C222E646A732D647261676761626C652229297B76617220743D652E627574746F6E3B6966282128743E3D327C7C652E6374726C4B65797C7C652E73686966744B65797C7C652E616C744B6579';
wwv_flow_imp.g_varchar2_table(1862) := '292972657475726E206E3D7B627574746F6E3A742C73746172743A766E2865297D2C71652E62696E6428646F63756D656E742C226D6F7573656D6F7665222C69292C71652E62696E6428646F63756D656E742C226D6F7573657570222C72292C21307D7D';
wwv_flow_imp.g_varchar2_table(1863) := '28652E6F726967696E616C4576656E74297D29292C746869732E69734163746976653D66756E6374696F6E28297B72657475726E21216E7D7D6E6F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E737420696F3D7B';
wwv_flow_imp.g_varchar2_table(1864) := '5F5F696E69745F5F3A5B226D6F766543616E766173225D2C6D6F766543616E7661733A5B2274797065222C6E6F5D7D3B66756E6374696F6E20726F2865297B72657475726E204D6174682E6C6F672865292F4D6174682E6C6F67283130297D66756E6374';
wwv_flow_imp.g_varchar2_table(1865) := '696F6E206F6F28652C74297B766172206E3D726F28652E6D696E292C693D726F28652E6D6178293B72657475726E284D6174682E616273286E292B4D6174682E616273286929292F747D76617220616F3D4D6174682E7369676E7C7C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1866) := '2865297B72657475726E20653E3D303F313A2D317D2C736F3D7B6D696E3A2E322C6D61783A347D2C6C6F3D2E37353B66756E6374696F6E20636F28652C742C6E297B653D657C7C7B7D2C746869732E5F656E61626C65643D21312C746869732E5F63616E';
wwv_flow_imp.g_varchar2_table(1867) := '7661733D6E2C746869732E5F636F6E7461696E65723D6E2E5F636F6E7461696E65722C746869732E5F68616E646C65576865656C3D4528746869732E5F68616E646C65576865656C2C74686973292C746869732E5F746F74616C44656C74613D302C7468';
wwv_flow_imp.g_varchar2_table(1868) := '69732E5F7363616C653D652E7363616C657C7C6C6F3B76617220693D746869733B742E6F6E282263616E7661732E696E6974222C2866756E6374696F6E2874297B692E5F696E6974282131213D3D652E656E61626C6564297D29297D636F2E24696E6A65';
wwv_flow_imp.g_varchar2_table(1869) := '63743D5B22636F6E6669672E7A6F6F6D5363726F6C6C222C226576656E74427573222C2263616E766173225D2C636F2E70726F746F747970652E7363726F6C6C3D66756E6374696F6E2865297B746869732E5F63616E7661732E7363726F6C6C2865297D';
wwv_flow_imp.g_varchar2_table(1870) := '2C636F2E70726F746F747970652E72657365743D66756E6374696F6E28297B746869732E5F63616E7661732E7A6F6F6D28226669742D76696577706F727422297D2C636F2E70726F746F747970652E7A6F6F6D3D66756E6374696F6E28652C74297B7661';
wwv_flow_imp.g_varchar2_table(1871) := '72206E3D6F6F28736F2C3230293B746869732E5F746F74616C44656C74612B3D652C4D6174682E61627328746869732E5F746F74616C44656C7461293E2E31262628746869732E5F7A6F6F6D28652C742C6E292C746869732E5F746F74616C44656C7461';
wwv_flow_imp.g_varchar2_table(1872) := '3D30297D2C636F2E70726F746F747970652E5F68616E646C65576865656C3D66756E6374696F6E2865297B69662821466528652E7461726765742C222E646A732D7363726F6C6C61626C65222C213029297B76617220743D746869732E5F636F6E746169';
wwv_flow_imp.g_varchar2_table(1873) := '6E65723B652E70726576656E7444656661756C7428293B766172206E2C693D652E6374726C4B65797C7C2F6D61632F692E74657374286E6176696761746F722E706C6174666F726D292626652E6D6574614B65792C723D652E73686966744B65792C6F3D';
wwv_flow_imp.g_varchar2_table(1874) := '2D312A746869732E5F7363616C653B6966286F2A3D693F303D3D3D652E64656C74614D6F64653F2E30323A2E33323A303D3D3D652E64656C74614D6F64653F313A31362C69297B76617220613D742E676574426F756E64696E67436C69656E7452656374';
wwv_flow_imp.g_varchar2_table(1875) := '28292C733D7B783A652E636C69656E74582D612E6C6566742C793A652E636C69656E74592D612E746F707D3B6E3D4D6174682E73717274284D6174682E706F7728652E64656C7461592C32292B4D6174682E706F7728652E64656C7461582C3229292A61';
wwv_flow_imp.g_varchar2_table(1876) := '6F28652E64656C746159292A6F2C746869732E7A6F6F6D286E2C73297D656C7365206E3D723F7B64783A6F2A652E64656C7461592C64793A307D3A7B64783A6F2A652E64656C7461582C64793A6F2A652E64656C7461597D2C746869732E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(1877) := '286E297D7D2C636F2E70726F746F747970652E737465705A6F6F6D3D66756E6374696F6E28652C74297B766172206E3D6F6F28736F2C3130293B746869732E5F7A6F6F6D28652C742C6E297D2C636F2E70726F746F747970652E5F7A6F6F6D3D66756E63';
wwv_flow_imp.g_varchar2_table(1878) := '74696F6E28652C742C6E297B76617220693D746869732E5F63616E7661732C723D653E303F313A2D312C6F3D726F28692E7A6F6F6D2829292C613D4D6174682E726F756E64286F2F6E292A6E3B612B3D6E2A723B76617220732C6C2C633D4D6174682E70';
wwv_flow_imp.g_varchar2_table(1879) := '6F772831302C61293B692E7A6F6F6D2828733D736F2C6C3D632C4D6174682E6D617828732E6D696E2C4D6174682E6D696E28732E6D61782C6C2929292C74297D2C636F2E70726F746F747970652E746F67676C653D66756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(1880) := '20743D746869732E5F636F6E7461696E65722C6E3D746869732E5F68616E646C65576865656C2C693D746869732E5F656E61626C65643B72657475726E20766F696420303D3D3D65262628653D2169292C69213D3D65262671655B653F2262696E64223A';
wwv_flow_imp.g_varchar2_table(1881) := '22756E62696E64225D28742C22776865656C222C6E2C2131292C746869732E5F656E61626C65643D652C657D2C636F2E70726F746F747970652E5F696E69743D66756E6374696F6E2865297B746869732E746F67676C652865297D3B636F6E737420706F';
wwv_flow_imp.g_varchar2_table(1882) := '3D7B5F5F696E69745F5F3A5B227A6F6F6D5363726F6C6C225D2C7A6F6F6D5363726F6C6C3A5B2274797065222C636F5D7D3B76617220756F3D222E646A732D70616C657474652D746F67676C65222C686F3D222E656E747279222C6D6F3D756F2B222C20';
wwv_flow_imp.g_varchar2_table(1883) := '222B686F2C666F3D22646A732D70616C657474652D222C796F3D226F70656E222C676F3D2274776F2D636F6C756D6E223B66756E6374696F6E20766F28652C74297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D743B7661';
wwv_flow_imp.g_varchar2_table(1884) := '72206E3D746869733B652E6F6E2822746F6F6C2D6D616E616765722E757064617465222C2866756E6374696F6E2865297B76617220743D652E746F6F6C3B6E2E757064617465546F6F6C486967686C696768742874297D29292C652E6F6E28226931386E';
wwv_flow_imp.g_varchar2_table(1885) := '2E6368616E676564222C2866756E6374696F6E28297B6E2E5F75706461746528297D29292C652E6F6E28226469616772616D2E696E6974222C2866756E6374696F6E28297B6E2E5F6469616772616D496E697469616C697A65643D21302C6E2E5F726562';
wwv_flow_imp.g_varchar2_table(1886) := '75696C6428297D29297D66756E6374696F6E20626F28652C74297B766172206E3D742E67657450616C65747465456E747269657328293B72657475726E2070286E293F6E2865293A2866286E2C2866756E6374696F6E28742C6E297B655B6E5D3D747D29';
wwv_flow_imp.g_varchar2_table(1887) := '292C65297D766F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C766F2E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E28652C74297B747C7C28743D652C653D316533292C746869';
wwv_flow_imp.g_varchar2_table(1888) := '732E5F6576656E744275732E6F6E282270616C657474652E67657450726F766964657273222C652C2866756E6374696F6E2865297B652E70726F7669646572732E707573682874297D29292C746869732E5F72656275696C6428297D2C766F2E70726F74';
wwv_flow_imp.g_varchar2_table(1889) := '6F747970652E676574456E74726965733D66756E6374696F6E28297B72657475726E20746869732E5F67657450726F76696465727328292E72656475636528626F2C7B7D297D2C766F2E70726F746F747970652E5F72656275696C643D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1890) := '6E28297B746869732E5F6469616772616D496E697469616C697A65642626746869732E5F67657450726F76696465727328292E6C656E677468262628746869732E5F636F6E7461696E65727C7C746869732E5F696E697428292C746869732E5F75706461';
wwv_flow_imp.g_varchar2_table(1891) := '74652829297D2C766F2E70726F746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D746869732C743D746869732E5F6576656E744275732C6E3D746869732E5F676574506172656E74436F6E7461696E657228292C693D74686973';
wwv_flow_imp.g_varchar2_table(1892) := '2E5F636F6E7461696E65723D516528766F2E48544D4C5F4D41524B5550293B6E2E617070656E644368696C642869292C4965286E292E61646428666F2B2273686F776E22292C58652E62696E6428692C6D6F2C22636C69636B222C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1893) := '2874297B766172206E2C692C723D742E64656C65676174655461726765743B696628693D756F2C286E3D722926262266756E6374696F6E223D3D747970656F66206E2E6D61746368657326266E2E6D6174636865732869292972657475726E20652E746F';
wwv_flow_imp.g_varchar2_table(1894) := '67676C6528293B652E747269676765722822636C69636B222C74297D29292C71652E62696E6428692C226D6F757365646F776E222C2866756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28297D29292C58652E62696E6428692C68';
wwv_flow_imp.g_varchar2_table(1895) := '6F2C22647261677374617274222C2866756E6374696F6E2874297B652E747269676765722822647261677374617274222C74297D29292C742E6F6E282263616E7661732E726573697A6564222C746869732E5F6C61796F75744368616E6765642C746869';
wwv_flow_imp.g_varchar2_table(1896) := '73292C742E66697265282270616C657474652E637265617465222C7B636F6E7461696E65723A697D297D2C766F2E70726F746F747970652E5F67657450726F7669646572733D66756E6374696F6E2865297B76617220743D746869732E5F6576656E7442';
wwv_flow_imp.g_varchar2_table(1897) := '75732E6372656174654576656E74287B747970653A2270616C657474652E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E666972652874292C742E70726F766964657273';
wwv_flow_imp.g_varchar2_table(1898) := '7D2C766F2E70726F746F747970652E5F746F67676C6553746174653D66756E6374696F6E2865297B653D657C7C7B7D3B76617220742C6E3D746869732E5F676574506172656E74436F6E7461696E657228292C693D746869732E5F636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(1899) := '2C723D746869732E5F6576656E744275732C6F3D49652869292C613D4965286E293B743D2274776F436F6C756D6E22696E20653F652E74776F436F6C756D6E3A746869732E5F6E65656473436F6C6C61707365286E2E636C69656E744865696768742C74';
wwv_flow_imp.g_varchar2_table(1900) := '6869732E5F656E74726965737C7C7B7D292C6F2E746F67676C6528676F2C74292C612E746F67676C6528666F2B676F2C74292C226F70656E22696E20652626286F2E746F67676C6528796F2C652E6F70656E292C612E746F67676C6528666F2B796F2C65';
wwv_flow_imp.g_varchar2_table(1901) := '2E6F70656E29292C722E66697265282270616C657474652E6368616E676564222C7B74776F436F6C756D6E3A742C6F70656E3A746869732E69734F70656E28297D297D2C766F2E70726F746F747970652E5F7570646174653D66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(1902) := '76617220653D657428222E646A732D70616C657474652D656E7472696573222C746869732E5F636F6E7461696E6572292C743D746869732E5F656E74726965733D746869732E676574456E747269657328293B6A652865292C6628742C2866756E637469';
wwv_flow_imp.g_varchar2_table(1903) := '6F6E28742C6E297B76617220692C723D742E67726F75707C7C2264656661756C74222C6F3D657428225B646174612D67726F75703D222B28693D722C4353532E6573636170652869292B225D22292C65293B6F7C7C285465286F3D516528273C64697620';
wwv_flow_imp.g_varchar2_table(1904) := '636C6173733D2267726F7570223E3C2F6469763E27292C22646174612D67726F7570222C72292C652E617070656E644368696C64286F29293B76617220613D742E68746D6C7C7C28742E736570617261746F723F273C687220636C6173733D2273657061';
wwv_flow_imp.g_varchar2_table(1905) := '7261746F7222202F3E273A273C64697620636C6173733D22656E7472792220647261676761626C653D2274727565223E3C2F6469763E27292C6C3D51652861293B6966286F2E617070656E644368696C64286C292C21742E736570617261746F72262628';
wwv_flow_imp.g_varchar2_table(1906) := '5465286C2C22646174612D616374696F6E222C6E292C742E7469746C6526265465286C2C227469746C65222C742E7469746C65292C742E636C6173734E616D65262666756E6374696F6E28652C74297B766172206E3D49652865293B28732874293F743A';
wwv_flow_imp.g_varchar2_table(1907) := '742E73706C6974282F5C732B2F6729292E666F7245616368282866756E6374696F6E2865297B6E2E6164642865297D29297D286C2C742E636C6173734E616D65292C742E696D61676555726C29297B76617220633D516528223C696D673E22293B546528';
wwv_flow_imp.g_varchar2_table(1908) := '632C22737263222C742E696D61676555726C292C6C2E617070656E644368696C642863297D7D29292C746869732E6F70656E28297D2C766F2E70726F746F747970652E747269676765723D66756E6374696F6E28652C742C6E297B76617220692C722C6F';
wwv_flow_imp.g_varchar2_table(1909) := '3D742E64656C65676174655461726765747C7C742E7461726765743B72657475726E206F3F28693D5465286F2C22646174612D616374696F6E22292C723D742E6F726967696E616C4576656E747C7C742C746869732E74726967676572456E7472792869';
wwv_flow_imp.g_varchar2_table(1910) := '2C652C722C6E29293A742E70726576656E7444656661756C7428297D2C766F2E70726F746F747970652E74726967676572456E7472793D66756E6374696F6E28652C742C6E2C69297B76617220722C6F3B69662828723D746869732E5F656E7472696573';
wwv_flow_imp.g_varchar2_table(1911) := '5B655D292626286F3D722E616374696F6E2C2131213D3D746869732E5F6576656E744275732E66697265282270616C657474652E74726967676572222C7B656E7472793A722C6576656E743A6E7D2929297B69662870286F29297B69662822636C69636B';
wwv_flow_imp.g_varchar2_table(1912) := '223D3D3D742972657475726E206F286E2C69297D656C7365206966286F5B745D2972657475726E206F5B745D286E2C69293B6E2E70726576656E7444656661756C7428297D7D2C766F2E70726F746F747970652E5F6C61796F75744368616E6765643D66';
wwv_flow_imp.g_varchar2_table(1913) := '756E6374696F6E28297B746869732E5F746F67676C655374617465287B7D297D2C766F2E70726F746F747970652E5F6E65656473436F6C6C617073653D66756E6374696F6E28652C74297B72657475726E20653C34362A4F626A6563742E6B6579732874';
wwv_flow_imp.g_varchar2_table(1914) := '292E6C656E6774682B35307D2C766F2E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B6F70656E3A21312C74776F436F6C756D6E3A21317D297D2C766F2E70726F746F747970652E6F';
wwv_flow_imp.g_varchar2_table(1915) := '70656E3D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B6F70656E3A21307D297D2C766F2E70726F746F747970652E746F67676C653D66756E6374696F6E28297B746869732E69734F70656E28293F746869732E636C6F7365';
wwv_flow_imp.g_varchar2_table(1916) := '28293A746869732E6F70656E28297D2C766F2E70726F746F747970652E6973416374697665546F6F6C3D66756E6374696F6E2865297B72657475726E20652626746869732E5F616374697665546F6F6C3D3D3D657D2C766F2E70726F746F747970652E75';
wwv_flow_imp.g_varchar2_table(1917) := '7064617465546F6F6C486967686C696768743D66756E6374696F6E2865297B76617220743B746869732E5F746F6F6C73436F6E7461696E65727C7C28743D657428222E646A732D70616C657474652D656E7472696573222C746869732E5F636F6E746169';
wwv_flow_imp.g_varchar2_table(1918) := '6E6572292C746869732E5F746F6F6C73436F6E7461696E65723D657428225B646174612D67726F75703D746F6F6C735D222C7429292C6628746869732E5F746F6F6C73436F6E7461696E65722E6368696C6472656E2C2866756E6374696F6E2874297B76';
wwv_flow_imp.g_varchar2_table(1919) := '6172206E3D742E6765744174747269627574652822646174612D616374696F6E22293B6966286E297B76617220693D49652874293B6E3D6E2E7265706C61636528222D746F6F6C222C2222292C692E636F6E7461696E732822656E747279222926266E3D';
wwv_flow_imp.g_varchar2_table(1920) := '3D3D653F692E6164642822686967686C6967687465642D656E74727922293A692E72656D6F76652822686967686C6967687465642D656E74727922297D7D29297D2C766F2E70726F746F747970652E69734F70656E3D66756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(1921) := '75726E20496528746869732E5F636F6E7461696E6572292E68617328796F297D2C766F2E70726F746F747970652E5F676574506172656E74436F6E7461696E65723D66756E6374696F6E28297B72657475726E20746869732E5F63616E7661732E676574';
wwv_flow_imp.g_varchar2_table(1922) := '436F6E7461696E657228297D2C766F2E48544D4C5F4D41524B55503D273C64697620636C6173733D22646A732D70616C65747465223E3C64697620636C6173733D22646A732D70616C657474652D656E7472696573223E3C2F6469763E3C64697620636C';
wwv_flow_imp.g_varchar2_table(1923) := '6173733D22646A732D70616C657474652D746F67676C65223E3C2F6469763E3C2F6469763E273B636F6E737420786F3D7B5F5F696E69745F5F3A5B2270616C65747465225D2C70616C657474653A5B2274797065222C766F5D7D3B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1924) := '776F28652C742C6E2C692C72297B652E5F6E65656473436F6C6C617073653D66756E6374696F6E28652C74297B72657475726E21317D2C746869732E67657450616C65747465456E74726965733D66756E6374696F6E2865297B766172206F3D7B7D2C61';
wwv_flow_imp.g_varchar2_table(1925) := '3D6E657720636F287B7D2C6E2C69293B72657475726E2053286F2C7B227A6F6F6D2D696E223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7365617263682D706C7573222C7469746C653A7428225A6F6F6D20';
wwv_flow_imp.g_varchar2_table(1926) := '496E22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E7A6F6F6D28312C30297D7D7D2C227A6F6F6D2D6F7574223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7365617263682D6D';
wwv_flow_imp.g_varchar2_table(1927) := '696E7573222C7469746C653A7428225A6F6F6D204F757422292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E7A6F6F6D282D312C30297D7D7D2C227A6F6F6D2D7265736574223A7B67726F75703A22636F6E74726F6C73222C63';
wwv_flow_imp.g_varchar2_table(1928) := '6C6173734E616D653A2266612066612D6669742D746F2D73697A65222C7469746C653A7428225265736574205A6F6F6D22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E726573657428297D7D7D2C2E2E2E722E616C6C6F77';
wwv_flow_imp.g_varchar2_table(1929) := '446F776E6C6F616426267B22646F776E6C6F61642D737667223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D696D616765222C7469746C653A742822446F776E6C6F61642053564722292C616374696F6E3A7B';
wwv_flow_imp.g_varchar2_table(1930) := '636C69636B3A66756E6374696F6E2865297B646F776E6C6F616441735356472865297D7D7D7D7D292C6F7D2C652E726567697374657250726F76696465722874686973297D776F2E24696E6A6563743D5B2270616C65747465222C227472616E736C6174';
wwv_flow_imp.g_varchar2_table(1931) := '65222C226576656E74427573222C2263616E766173222C22636F6E6669672E636F6E666967225D3B636F6E7374205F6F3D7B5F5F646570656E64735F5F3A5B786F2C53745D2C5F5F696E69745F5F3A5B2270616C6574746550726F7669646572225D2C70';
wwv_flow_imp.g_varchar2_table(1932) := '616C6574746550726F76696465723A5B2274797065222C776F5D7D3B66756E6374696F6E20456F28652C742C6E2C692C72297B746869732E5F63616E7661733D652C746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769';
wwv_flow_imp.g_varchar2_table(1933) := '737472793D6E2C746869732E5F6F7665726C6179733D692C746869732E5F6D6F64646C653D723B766172206F3D746869733B746869732E5F62726561646372756D623D516528273C756C20636C6173733D22626A732D62726561646372756D6273222069';
wwv_flow_imp.g_varchar2_table(1934) := '643D2263616C6C416374697669747942726561646372756D62223E3C2F756C3E27292C652E676574436F6E7461696E657228292E617070656E644368696C6428746869732E5F62726561646372756D62292C742E6F6E2822696D706F72742E72656E6465';
wwv_flow_imp.g_varchar2_table(1935) := '722E636F6D706C657465222C2866756E6374696F6E28297B6E2E66696C746572282866756E6374696F6E2865297B72657475726E206F2E63616E4472696C6C446F776E2865297D29292E666F7245616368282866756E6374696F6E2865297B6F2E616464';
wwv_flow_imp.g_varchar2_table(1936) := '4F7665726C61792865297D29297D29297D456F2E70726F746F747970652E63616E4472696C6C446F776E3D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A43616C6C416374697669747922297D2C456F2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1937) := '2E6164644F7665726C61793D66756E6374696F6E2865297B76617220743D746869732E5F6F7665726C6179732C6E3D746869732C693D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E223E3C73766720786D6C6E733D22';
wwv_flow_imp.g_varchar2_table(1938) := '687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C706174682066696C6C2D72756C653D226576656E6F64642220643D22';
wwv_flow_imp.g_varchar2_table(1939) := '4D342E38313830313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E363839363839342C31302E343939363839';
wwv_flow_imp.g_varchar2_table(1940) := '34204C332E37353733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C332E35303733353933312043342E3035303235';
wwv_flow_imp.g_varchar2_table(1941) := '3235332C332E323134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E3C2F627574746F6E3E27293B742E676574287B656C656D656E743A652C7479';
wwv_flow_imp.g_varchar2_table(1942) := '70653A226472696C6C646F776E227D292E6C656E6774682626746869732E72656D6F76654F7665726C61792865292C692E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E2874297B76617220693D652E69642C7B64';
wwv_flow_imp.g_varchar2_table(1943) := '6174613A722C6469616772616D4964656E7469666965723A6F7D3D6E2E5F7769646765742C613D722E66696E642828653D3E652E63616C6C696E674469616772616D4964656E7469666965723D3D3D6F2626652E63616C6C696E674F626A65637449643D';
wwv_flow_imp.g_varchar2_table(1944) := '3D3D6929293B612626313D3D3D612E696E73696768742626286E2E5F7769646765742E6469616772616D4964656E7469666965723D612E6469616772616D4964656E7469666965722C6E2E5F7769646765742E63616C6C696E674469616772616D496465';
wwv_flow_imp.g_varchar2_table(1945) := '6E7469666965723D612E63616C6C696E674469616772616D4964656E7469666965722C6E2E5F7769646765742E63616C6C696E674F626A65637449643D612E63616C6C696E674F626A65637449642C6E2E5F7769646765742E6469616772616D3D612E64';
wwv_flow_imp.g_varchar2_table(1946) := '69616772616D2C6E2E5F7769646765742E63757272656E743D612E63757272656E742C6E2E5F7769646765742E636F6D706C657465643D612E636F6D706C657465642C6E2E5F7769646765742E6572726F723D612E6572726F722C6E2E75706461746542';
wwv_flow_imp.g_varchar2_table(1947) := '726561646372756D6228292C646F63756D656E742E717565727953656C6563746F7228222E626A732D62726561646372756D62733A6E6F74282363616C6C416374697669747942726561646372756D622922292E7374796C652E746F703D223630707822';
wwv_flow_imp.g_varchar2_table(1948) := '2C6E2E5F7769646765742E6C6F61644469616772616D2829297D29292C742E61646428652C226472696C6C646F776E222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A697D297D2C456F2E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1949) := '70652E72656D6F76654F7665726C61793D66756E6374696F6E2865297B746869732E5F6F7665726C6179732E72656D6F7665287B656C656D656E743A652C747970653A226472696C6C646F776E227D297D2C456F2E70726F746F747970652E7365745769';
wwv_flow_imp.g_varchar2_table(1950) := '646765743D66756E6374696F6E2865297B746869732E5F7769646765743D657D2C456F2E70726F746F747970652E75706461746542726561646372756D623D66756E6374696F6E28297B76617220653D746869733B636F6E73747B646174613A742C6469';
wwv_flow_imp.g_varchar2_table(1951) := '616772616D4964656E7469666965723A6E2C63616C6C696E674469616772616D4964656E7469666965723A692C63616C6C696E674F626A65637449643A727D3D746869732E5F7769646765743B7661727B62726561646372756D623A6F7D3D742E66696E';
wwv_flow_imp.g_varchar2_table(1952) := '642828653D3E652E6469616772616D4964656E7469666965723D3D3D6E2626652E63616C6C696E674469616772616D4964656E7469666965723D3D3D692626652E63616C6C696E674F626A65637449643D3D3D7229292C613D516528603C6C6920646174';
wwv_flow_imp.g_varchar2_table(1953) := '612D696E6465783D22247B746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774687D225C6E20202020247B6E3F6020646174612D6469616772616D4964656E7469666965723D22247B6E7D22603A22227D5C6E2020202024';
wwv_flow_imp.g_varchar2_table(1954) := '7B693F6020646174612D63616C6C696E674469616772616D4964656E7469666965723D22247B697D22603A22227D5C6E20202020247B723F6020646174612D63616C6C696E674F626A65637449643D2224247B727D22603A22227D3E3C7370616E20636C';
wwv_flow_imp.g_varchar2_table(1955) := '6173733D22626A732D6372756D62223E3C615C6E20202020247B723F60207469746C653D2263616C6C656420627920247B727D22603A22227D3E247B6F7D3C2F613E3C2F7370616E3E3C2F6C693E60293B612E6164644576656E744C697374656E657228';
wwv_flow_imp.g_varchar2_table(1956) := '22636C69636B222C2866756E6374696F6E28297B7661727B696E6465783A742C6469616772616D6964656E7469666965723A6E7D3D612E646174617365743B636F6E73747B646174613A697D3D652E5F7769646765743B76617220723D692E66696E6428';
wwv_flow_imp.g_varchar2_table(1957) := '28653D3E652E6469616772616D4964656E7469666965723D3D6E29293B743C652E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774682D31262628652E7472696D42726561646372756D62546F2874292C652E5F7769646765742E64';
wwv_flow_imp.g_varchar2_table(1958) := '69616772616D4964656E7469666965723D722E6469616772616D4964656E7469666965722C652E5F7769646765742E63616C6C696E674469616772616D4964656E7469666965723D722E63616C6C696E674469616772616D4964656E7469666965722C65';
wwv_flow_imp.g_varchar2_table(1959) := '2E5F7769646765742E63616C6C696E674F626A65637449643D722E63616C6C696E674F626A65637449642C652E5F7769646765742E6469616772616D3D722E6469616772616D2C652E5F7769646765742E63757272656E743D722E63757272656E742C65';
wwv_flow_imp.g_varchar2_table(1960) := '2E5F7769646765742E636F6D706C657465643D722E636F6D706C657465642C652E5F7769646765742E6572726F723D722E6572726F722C652E5F7769646765742E6C6F61644469616772616D2829297D29292C746869732E5F62726561646372756D622E';
wwv_flow_imp.g_varchar2_table(1961) := '617070656E644368696C642861292C746869732E746F67676C6542726561646372756D625669736962696C69747928297D2C456F2E70726F746F747970652E726573657442726561646372756D623D66756E6374696F6E28297B666F72283B746869732E';
wwv_flow_imp.g_varchar2_table(1962) := '5F62726561646372756D622E66697273744368696C643B29746869732E5F62726561646372756D622E72656D6F76654368696C6428746869732E5F62726561646372756D622E66697273744368696C64293B746869732E746F67676C6542726561646372';
wwv_flow_imp.g_varchar2_table(1963) := '756D625669736962696C69747928297D2C456F2E70726F746F747970652E7472696D42726561646372756D62546F3D66756E6374696F6E2865297B76617220743D21312C6E3D5B5D3B666F72286C657420693D303B693C746869732E5F62726561646372';
wwv_flow_imp.g_varchar2_table(1964) := '756D622E6368696C644E6F6465732E6C656E6774683B692B2B29743F6E2E7075736828746869732E5F62726561646372756D622E6368696C644E6F6465735B695D293A746869732E5F62726561646372756D622E6368696C644E6F6465735B695D2E6461';
wwv_flow_imp.g_varchar2_table(1965) := '74617365742E696E6465783D3D3D65262628743D2130293B6E2E666F72456163682828653D3E746869732E5F62726561646372756D622E72656D6F76654368696C6428652929292C746869732E746F67676C6542726561646372756D625669736962696C';
wwv_flow_imp.g_varchar2_table(1966) := '69747928297D2C456F2E70726F746F747970652E746F67676C6542726561646372756D625669736962696C6974793D66756E6374696F6E28297B696628746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774683E31297B63';
wwv_flow_imp.g_varchar2_table(1967) := '6F6E737420653D746869732E5F62726561646372756D622E6F66667365744865696768743B746869732E5F62726561646372756D622E7374796C652E646973706C61793D22666C6578222C746869732E5F63616E7661732E7363726F6C6C287B64783A30';
wwv_flow_imp.g_varchar2_table(1968) := '2C64793A33302B652B33307D297D656C73657B636F6E737420653D646F63756D656E742E717565727953656C6563746F7228222E626A732D62726561646372756D62733A6E6F74282363616C6C416374697669747942726561646372756D622922293B74';
wwv_flow_imp.g_varchar2_table(1969) := '6869732E5F62726561646372756D622E7374796C652E646973706C61793D226E6F6E65222C652E7374796C652E746F703D2233307078227D7D2C456F2E70726F746F747970652E736574506F736974696F6E696E673D66756E6374696F6E28297B7D2C45';
wwv_flow_imp.g_varchar2_table(1970) := '6F2E24696E6A6563743D5B2263616E766173222C226576656E74427573222C22656C656D656E745265676973747279222C226F7665726C617973222C226D6F64646C65225D3B636F6E737420536F3D7B5F5F696E69745F5F3A5B2263616C6C4163746976';
wwv_flow_imp.g_varchar2_table(1971) := '6974794D6F64756C65225D2C63616C6C41637469766974794D6F64756C653A5B2274797065222C456F5D7D3B66756E6374696F6E20416F28652C74297B652E6F6E2822726F6F742E736574222C2866756E6374696F6E28297B742E7A6F6F6D2822666974';
wwv_flow_imp.g_varchar2_table(1972) := '2D76696577706F7274222C226175746F22297D29297D416F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E737420436F3D7B5F5F696E69745F5F3A5B226472696C6C646F776E43656E746572696E67225D2C647269';
wwv_flow_imp.g_varchar2_table(1973) := '6C6C646F776E43656E746572696E673A5B2274797065222C416F5D7D3B66756E6374696F6E206B6F28652C742C6E297B636F6E737420693D646F63756D656E742E717565727953656C6563746F7228222E63616E76617322293B692E7374796C652E7365';
wwv_flow_imp.g_varchar2_table(1974) := '7450726F706572747928222D2D686967686C696768742D63757272656E742D66696C6C222C652E63757272656E745374796C652E66696C6C292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D63757272656E742D62';
wwv_flow_imp.g_varchar2_table(1975) := '6F72646572222C652E63757272656E745374796C652E626F72646572292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D63757272656E742D6C6162656C222C652E63757272656E745374796C652E6C6162656C292C';
wwv_flow_imp.g_varchar2_table(1976) := '692E7374796C652E73657450726F706572747928222D2D686967686C696768742D636F6D706C657465642D66696C6C222C652E636F6D706C657465645374796C652E66696C6C292C692E7374796C652E73657450726F706572747928222D2D686967686C';
wwv_flow_imp.g_varchar2_table(1977) := '696768742D636F6D706C657465642D626F72646572222C652E636F6D706C657465645374796C652E626F72646572292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D636F6D706C657465642D6C6162656C222C652E';
wwv_flow_imp.g_varchar2_table(1978) := '636F6D706C657465645374796C652E6C6162656C292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D6572726F722D66696C6C222C652E6572726F725374796C652E66696C6C292C692E7374796C652E73657450726F';
wwv_flow_imp.g_varchar2_table(1979) := '706572747928222D2D686967686C696768742D6572726F722D626F72646572222C652E6572726F725374796C652E626F72646572292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D6572726F722D6C6162656C222C';
wwv_flow_imp.g_varchar2_table(1980) := '652E6572726F725374796C652E6C6162656C292C746869732E6164645374796C65546F456C656D656E74733D66756E6374696F6E28652C74297B6C6574206E3B666F7228636F6E73742069206F662065296E3D646F63756D656E742E717565727953656C';
wwv_flow_imp.g_varchar2_table(1981) := '6563746F722860675B646174612D656C656D656E742D69643D22247B697D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60292C6E26266E2E636C6173734C6973742E6164642874297D2C746869732E68696768';
wwv_flow_imp.g_varchar2_table(1982) := '6C69676874456C656D656E74733D66756E6374696F6E28652C742C6E297B652626652E6C656E6774683E302626746869732E6164645374796C65546F456C656D656E747328652C22686967686C696768742D63757272656E7422292C742626742E6C656E';
wwv_flow_imp.g_varchar2_table(1983) := '6774683E302626746869732E6164645374796C65546F456C656D656E747328742C22686967686C696768742D636F6D706C6574656422292C6E26266E2E6C656E6774683E302626746869732E6164645374796C65546F456C656D656E7473286E2C226869';
wwv_flow_imp.g_varchar2_table(1984) := '67686C696768742D6572726F7222297D2C746869732E7265736574486967686C69676874696E673D66756E6374696F6E28297B636F6E737420653D4F626A6563742E6B657973286E2E5F656C656D656E7473293B6C657420743B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(1985) := '6E206F66206529743D646F63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D22247B6E7D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60292C74262628742E';
wwv_flow_imp.g_varchar2_table(1986) := '636C6173734C6973742E72656D6F76652822686967686C696768742D63757272656E7422292C742E636C6173734C6973742E72656D6F76652822686967686C696768742D636F6D706C6574656422292C742E636C6173734C6973742E72656D6F76652822';
wwv_flow_imp.g_varchar2_table(1987) := '686967686C696768742D6572726F722229297D2C746869732E726573657442504D4E636F6C6F72733D66756E6374696F6E28297B636F6E737420653D4F626A6563742E6B657973286E2E5F656C656D656E7473293B6C657420743B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(1988) := '206E206F66206529743D646F63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D22247B6E7D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60292C742626742E';
wwv_flow_imp.g_varchar2_table(1989) := '636C6173734C6973742E616464282272657365742D62706D6E2D636F6C6F727322297D2C746869732E6164645374796C65546F5356473D66756E6374696F6E2865297B636F6E737420743D286E657720444F4D506172736572292E706172736546726F6D';
wwv_flow_imp.g_varchar2_table(1990) := '537472696E6728652C22746578742F786D6C22292C5B6E5D3D742E676574456C656D656E747342795461674E616D6528226465667322292C693D646F63756D656E742E637265617465456C656D656E7428227374796C6522293B692E7365744174747269';
wwv_flow_imp.g_varchar2_table(1991) := '62757465282274797065222C22746578742F63737322293B636F6E737420723D646F63756D656E742E637265617465546578744E6F646528222E646A732D67726F7570207B202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B202D';
wwv_flow_imp.g_varchar2_table(1992) := '2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B207D22293B72657475726E20692E617070656E644368696C642872292C6E2E617070656E644368696C642869292C286E657720584D4C53657269616C697A6572292E7365726961';
wwv_flow_imp.g_varchar2_table(1993) := '6C697A65546F537472696E672874297D7D6B6F2E24696E6A6563743D5B22636F6E6669672E636F6E666967222C22636F6E6669672E62706D6E52656E6465726572222C22656C656D656E745265676973747279225D3B636F6E737420526F3D7B5F5F696E';
wwv_flow_imp.g_varchar2_table(1994) := '69745F5F3A5B227374796C654D6F64756C65225D2C7374796C654D6F64756C653A5B2274797065222C6B6F5D7D3B636C617373204D6F7B636F6E7374727563746F7228652C742C6E2C692C72297B746869732E5F63616E7661733D652C746869732E5F65';
wwv_flow_imp.g_varchar2_table(1995) := '76656E744275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F7472616E736C6174653D692C746869732E5F6F7665726C6179733D722C746869732E62726561646372756D62497465726174696F6E3D5B5D2C746869';
wwv_flow_imp.g_varchar2_table(1996) := '732E62726561646372756D6253656C656374696F6E3D5B5D3B636F6E7374206F3D516528275C6E2020202020203C6469762069643D226D6F64616C223E5C6E20202020202020203C646976206964203D226D6F64616C2D636F6E74656E74223E5C6E2020';
wwv_flow_imp.g_varchar2_table(1997) := '20202020202020203C6469762069643D22697465726174696F6E2D7469746C65223E5C6E2020202020202020202020203C7370616E3E3C2F7370616E3E5C6E2020202020202020202020203C627574746F6E20636C6173733D2266612066612D74696D65';
wwv_flow_imp.g_varchar2_table(1998) := '73223E3C2F627574746F6E3E5C6E202020202020202020203C2F6469763E5C6E202020202020202020203C6469762069643D22697465726174696F6E2D736561726368223E5C6E2020202020202020202020203C696E70757420747970653D2274657874';
wwv_flow_imp.g_varchar2_table(1999) := '2220706C616365686F6C6465723D225365617263682E2E222F3E5C6E202020202020202020203C2F6469763E5C6E202020202020202020203C6469762069643D22697465726174696F6E2D6C697374223E5C6E20202020202020202020202020203C7461';
wwv_flow_imp.g_varchar2_table(2000) := '626C653E5C6E202020202020202020202020202020203C74686561643E5C6E2020202020202020202020202020202020203C74723E5C6E20202020202020202020202020202020202020203C74683E4C6F6F7020436F756E7465723C2F74683E5C6E2020';
wwv_flow_imp.g_varchar2_table(2001) := '2020202020202020202020202020202020203C74683E4465736372697074696F6E3C2F74683E5C6E20202020202020202020202020202020202020203C74683E5374617475733C2F74683E5C6E2020202020202020202020202020202020203C2F74723E';
wwv_flow_imp.g_varchar2_table(2002) := '5C6E202020202020202020202020202020203C2F74686561643E5C6E202020202020202020202020202020203C74626F64793E3C2F74626F64793E5C6E2020202020202020202020203C2F7461626C653E5C6E202020202020202020203C2F6469763E5C';
wwv_flow_imp.g_varchar2_table(2003) := '6E20202020202020203C2F6469763E5C6E2020202020203C2F6469763E5C6E2020202027293B652E676574436F6E7461696E657228292E617070656E644368696C64286F292C742E6F6E2822696D706F72742E72656E6465722E636F6D706C657465222C';
wwv_flow_imp.g_varchar2_table(2004) := '2828293D3E7B6574282223697465726174696F6E2D73656172636820696E70757422292E6164644576656E744C697374656E657228226B65797570222C28653D3E7B746869732E66696C746572497465726174696F6E732865297D29292C657428222369';
wwv_flow_imp.g_varchar2_table(2005) := '7465726174696F6E2D7469746C6520627574746F6E2E66612D74696D657322292E6164644576656E744C697374656E65722822636C69636B222C28653D3E7B746869732E636C6F7365497465726174696F6E7328297D29297D29292C742E6F6E2822726F';
wwv_flow_imp.g_varchar2_table(2006) := '6F742E736574222C28653D3E7B636F6E73747B656C656D656E743A747D3D653B746869732E726573657442726561646372756D624461746128292C6B28742C2262706D6E3A53756250726F636573732229262628746869732E686173497465726174696F';
wwv_flow_imp.g_varchar2_table(2007) := '6E44617461287429262628746869732E62726561646372756D62497465726174696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3D21302C746869732E617070656E6442726561646372756D62427574746F6E287429';
wwv_flow_imp.g_varchar2_table(2008) := '292C746869732E75706461746542726561646372756D622829292C746869732E757064617465486967686C69676874696E6728297D29297D7365745769646765742865297B746869732E5F7769646765743D657D676574497465726174696F6E44617461';
wwv_flow_imp.g_varchar2_table(2009) := '2865297B636F6E73747B69643A747D3D4D2865292C6E3D746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828292D315D3B72657475726E20746869732E5F776964676574';
wwv_flow_imp.g_varchar2_table(2010) := '2E697465726174696F6E446174612626746869732E5F7769646765742E697465726174696F6E446174615B745D2626746869732E5F7769646765742E697465726174696F6E446174615B745D2E66696C7465722828653D3E216E262621652E706172656E';
wwv_flow_imp.g_varchar2_table(2011) := '74537465704B65797C7C6E2626652E706172656E74537465704B65793D3D6E2E737465704B657929297C7C5B5D7D6164644F7665726C61797328297B746869732E5F656C656D656E7452656769737472792E66696C7465722828653D3E216B28652C2262';
wwv_flow_imp.g_varchar2_table(2012) := '706D6E3A53756250726F6365737322292626746869732E686173497465726174696F6E4461746128652929292E666F72456163682828653D3E7B746869732E6164644F7665726C61792865297D29297D6164644F7665726C61792865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(2013) := '743D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D6C697374223E3C2F627574746F6E3E27293B742E6164644576656E744C697374656E65722822636C69636B222C28743D3E7B746869732E6F70656E';
wwv_flow_imp.g_varchar2_table(2014) := '497465726174696F6E732865297D29292C746869732E5F6F7665726C6179732E61646428652C22697465726174696F6E73222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A747D297D69734D756C7469496E';
wwv_flow_imp.g_varchar2_table(2015) := '7374616E636553756250726F636573732865297B636F6E737420743D4D2865293B72657475726E206B28652C2262706D6E3A53756250726F6365737322292626742E6C6F6F704368617261637465726973746963737D686173497465726174696F6E4461';
wwv_flow_imp.g_varchar2_table(2016) := '74612865297B72657475726E20746869732E676574497465726174696F6E446174612865292E6C656E6774683E307D67657442726561646372756D62456C656D656E747328297B72657475726E5B2E2E2E657428222E626A732D62726561646372756D62';
wwv_flow_imp.g_varchar2_table(2017) := '7322292E6368696C6472656E5D7D6765744C61737442726561646372756D62496E64657828297B72657475726E20746869732E67657442726561646372756D62456C656D656E747328292E6C656E6774682D317D726573657442726561646372756D6244';
wwv_flow_imp.g_varchar2_table(2018) := '61746128297B636F6E737420653D746869732E6765744C61737442726561646372756D62496E64657828293B746869732E62726561646372756D62497465726174696F6E2E73706C69636528652B31292C746869732E62726561646372756D6253656C65';
wwv_flow_imp.g_varchar2_table(2019) := '6374696F6E2E73706C69636528652B31297D617070656E6442726561646372756D62427574746F6E2865297B636F6E737420743D746869732E67657442726561646372756D62456C656D656E747328292E706F7028293B69662874297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(2020) := '3D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D6C697374223E3C2F627574746F6E3E27293B6E2E6164644576656E744C697374656E65722822636C69636B222C28743D3E7B746869732E6F70656E49';
wwv_flow_imp.g_varchar2_table(2021) := '7465726174696F6E732865297D29292C742E617070656E64286E297D7D75706461746542726561646372756D6228297B636F6E737420653D746869732E67657442726561646372756D62456C656D656E747328293B666F72286C657420743D303B743C65';
wwv_flow_imp.g_varchar2_table(2022) := '2E6C656E6774683B742B2B297B696628746869732E62726561646372756D62497465726174696F6E5B745D2626743C652E6C656E6774682D31297B636F6E7374206E3D657428227370616E2E697465726174696F6E2D627574746F6E222C655B745D292C';
wwv_flow_imp.g_varchar2_table(2023) := '693D516528273C7370616E20636C6173733D22626A732D6372756D6220697465726174696F6E2D627574746F6E2066612066612D6C697374223E3C2F7370616E3E27293B6E3F6E2E7265706C616365576974682869293A655B745D2E617070656E642869';
wwv_flow_imp.g_varchar2_table(2024) := '297D636F6E7374206E3D746869732E62726561646372756D6253656C656374696F6E5B745D3B6966286E297B636F6E737420693D657428227370616E2E697465726174696F6E2D64657363222C655B745D292C723D516528603C7370616E20636C617373';
wwv_flow_imp.g_varchar2_table(2025) := '3D22626A732D6372756D6220697465726174696F6E2D64657363223E247B6E2E6465736372697074696F6E7D3C2F7370616E3E60293B693F692E7265706C616365576974682872293A655B745D2E617070656E642872297D7D7D6F70656E4469616C6F67';
wwv_flow_imp.g_varchar2_table(2026) := '28297B636F6E737420653D6574282223697465726174696F6E2D73656172636820696E70757422292C743D65742822236D6F64616C22293B652E76616C75653D22222C742E7374796C652E646973706C61793D22666C6578227D6C6F61645461626C6528';
wwv_flow_imp.g_varchar2_table(2027) := '65297B6574282223697465726174696F6E2D6C6973742074626F647922292E7265706C6163654368696C6472656E282E2E2E28657C7C746869732E6469616C6F6744617461292E6D61702828653D3E7B636F6E737420743D516528605C6E202020202020';
wwv_flow_imp.g_varchar2_table(2028) := '20203C747220247B746869732E6469616C6F67436C69636B61626C653F27636C6173733D22636C69636B61626C6522273A22227D3E5C6E202020202020202020203C74643E247B652E6C6F6F70436F756E7465727D3C2F74643E5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2029) := '20203C74643E247B652E6465736372697074696F6E7D3C2F74643E5C6E202020202020202020203C74643E247B652E7374617475737D3C2F74643E5C6E20202020202020203C2F74723E5C6E20202020202060293B72657475726E20746869732E646961';
wwv_flow_imp.g_varchar2_table(2030) := '6C6F67436C69636B61626C652626742E6164644576656E744C697374656E65722822636C69636B222C28743D3E7B746869732E6C6F6164497465726174696F6E28652E6C6F6F70436F756E746572292C746869732E636C6F7365497465726174696F6E73';
wwv_flow_imp.g_varchar2_table(2031) := '28297D29292C747D2929297D6F70656E497465726174696F6E732865297B746869732E6469616C6F67446174613D746869732E676574497465726174696F6E446174612865292C746869732E6469616C6F67436C69636B61626C653D6B28652C2262706D';
wwv_flow_imp.g_varchar2_table(2032) := '6E3A53756250726F6365737322292C746869732E6469616C6F6744617461262628746869732E6C6F61645461626C6528292C6574282223697465726174696F6E2D7469746C65207370616E22292E74657874436F6E74656E743D4D2865292E6E616D652C';
wwv_flow_imp.g_varchar2_table(2033) := '746869732E6F70656E4469616C6F672829297D636C6F7365497465726174696F6E7328297B65742822236D6F64616C22292E7374796C652E646973706C61793D226E6F6E65227D6C6F6164497465726174696F6E2865297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(2034) := '2E6469616C6F67446174612E66696E642828743D3E742E6C6F6F70436F756E7465723D3D6529293B746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3D742C7468';
wwv_flow_imp.g_varchar2_table(2035) := '69732E75706461746542726561646372756D6228292C746869732E757064617465486967686C69676874696E6728297D66696C746572497465726174696F6E732865297B636F6E73747B76616C75653A747D3D652E7461726765742C6E3D746869732E64';
wwv_flow_imp.g_varchar2_table(2036) := '69616C6F67446174612E66696C7465722828653D3E652E6465736372697074696F6E2E696E636C756465732874297C7C652E7374617475732E696E636C7564657328742929293B746869732E6C6F61645461626C65286E297D757064617465486967686C';
wwv_flow_imp.g_varchar2_table(2037) := '69676874696E6728297B696628746869732E5F776964676574297B636F6E737420653D746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3B69662865297B636F6E';
wwv_flow_imp.g_varchar2_table(2038) := '73747B63757272656E743A742C636F6D706C657465643A6E2C6572726F723A697D3D652E686967686C69676874696E673B746869732E5F7769646765742E757064617465436F6C6F727328742C6E2C69297D656C736520746869732E5F7769646765742E';
wwv_flow_imp.g_varchar2_table(2039) := '7265736574436F6C6F727328297D7D7D4D6F2E24696E6A6563743D5B2263616E766173222C226576656E74427573222C22656C656D656E745265676973747279222C227472616E736C617465222C226F7665726C617973225D3B636F6E737420506F3D7B';
wwv_flow_imp.g_varchar2_table(2040) := '5F5F696E69745F5F3A5B226D756C7469496E7374616E63654D6F64756C65225D2C6D756C7469496E7374616E63654D6F64756C653A5B2274797065222C4D6F5D7D3B636C61737320446F7B636F6E7374727563746F7228652C742C6E2C692C72297B7468';
wwv_flow_imp.g_varchar2_table(2041) := '69732E5F63616E7661733D652C746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F7472616E736C6174653D692C746869732E5F6F7665726C6179733D727D6164644F7665726C617973';
wwv_flow_imp.g_varchar2_table(2042) := '28297B636F6E73747B757365725461736B446174613A657D3D746869732E5F7769646765743B746869732E5F656C656D656E7452656769737472792E66696C7465722828743D3E7B636F6E7374206E3D4D2874293B72657475726E206B28742C2262706D';
wwv_flow_imp.g_varchar2_table(2043) := '6E3A557365725461736B22292626652626655B742E69645D2626216E2E6C6F6F704368617261637465726973746963732626216E2E24706172656E742E6C6F6F704368617261637465726973746963737D29292E666F72456163682828743D3E7B746869';
wwv_flow_imp.g_varchar2_table(2044) := '732E6164644F7665726C617928742C655B742E69645D297D29297D6164644F7665726C617928652C74297B636F6E7374206E3D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D65787465726E616C2D6C';
wwv_flow_imp.g_varchar2_table(2045) := '696E6B223E3C2F627574746F6E3E27293B6E2E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B77696E646F772E6F70656E28742C225F73656C6622297D29292C746869732E5F6F7665726C6179732E616464';
wwv_flow_imp.g_varchar2_table(2046) := '28652C22697465726174696F6E73222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A6E7D297D7365745769646765742865297B746869732E5F7769646765743D657D7D446F2E24696E6A6563743D5B226361';
wwv_flow_imp.g_varchar2_table(2047) := '6E766173222C226576656E74427573222C22656C656D656E745265676973747279222C227472616E736C617465222C226F7665726C617973225D3B636F6E737420426F3D7B5669657765723A4A722C637573746F6D4D6F64756C65733A7B4D6F76654361';
wwv_flow_imp.g_varchar2_table(2048) := '6E7661734D6F64756C653A696F2C5A6F6F6D5363726F6C6C4D6F64756C653A706F2C6472696C6C646F776E43656E746572696E673A436F2C63616C6C41637469766974794D6F64756C653A536F2C6D756C7469496E7374616E63654D6F64756C653A506F';
wwv_flow_imp.g_varchar2_table(2049) := '2C7374796C654D6F64756C653A526F2C637573746F6D50616C6574746550726F76696465724D6F64756C653A5F6F2C757365725461736B4D6F64756C653A7B5F5F696E69745F5F3A5B22757365725461736B4D6F64756C65225D2C757365725461736B4D';
wwv_flow_imp.g_varchar2_table(2050) := '6F64756C653A5B2274797065222C446F5D7D7D7D7D2928292C62706D6E5669657765723D742E64656661756C747D2928293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(15858978863996991)
,p_plugin_id=>wwv_flow_imp.id(52324545630147899359)
,p_file_name=>'js/flows4apex.viewer.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(12495499263265880052)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>42
,p_home_url=>'f?p=&APP_ID.:3:&SESSION.'
,p_login_url=>'f?p=&APP_ID.:LOGIN:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_navigation_list_id=>wwv_flow_imp.id(12495635966008880385)
,p_navigation_list_position=>'SIDE'
,p_navigation_list_template_id=>wwv_flow_imp.id(12495533999726880152)
,p_nav_list_template_options=>'#DEFAULT#:js-defaultCollapsed:js-navCollapsed--hidden:t-TreeNav--styleA'
,p_css_file_urls=>'#APP_IMAGES#css/flows4apex#MIN#.css'
,p_javascript_file_urls=>'#APP_IMAGES#js/flows4apex#MIN#.js'
,p_nav_bar_type=>'LIST'
,p_nav_bar_list_id=>wwv_flow_imp.id(12495499558192880054)
,p_nav_bar_list_template_id=>wwv_flow_imp.id(12495534382344880154)
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Getting Started'
,p_alias=>'GETTING-STARTED'
,p_step_title=>'Getting Started - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10603774502745437)
,p_plug_name=>'Getting Started'
,p_region_template_options=>'#DEFAULT#:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Flows for APEX</h2>',
'<h3>A Low code, BPMN-based Process Flow system for APEX.</h3>',
'<h4> Features</h4>',
'<ul>',
'<li>Flows for APEX enables APEX developers to model and run process flows in APEX using a combination of visual process design and low-code techniques.</li>',
'<li>Designed primarily for APEX developers, Flows for APEX uses the technologies that you are already familiar with - APEX, PL/SQL, and SQL - to create powerful and flexible process flows in your APEX environment.</li>',
'<li>Used to create and execute a process flow of APEX pages, PL/SQL scripts, send email.</li>',
'<li> The low-code diagrammatic process definition can also be understood and edited by business users to increase business flexibility.  Flows use the Business Process Modeling Notation (BPMN) V2 style</li>',
'<li>Built as an APEX community project, and released on an open source, MIT licence.</li>',
'</ul>',
'<p>',
'<h4>Download</h4>',
'<a href="https://flowsforapex.org" target="_blank">flowsforapex.org</a>',
'<p>',
'<h4>Documentation</h4>',
'<a href="https://flowsforapex.org/latest/getting-started/" target="_blank">Latest Documentation Online</a>',
'<p>',
'<h4>BPMN Tutorials</h4>',
'To get you started with modelling flows, try out the preinstalled tutorial flows. For further information on the tutorials have a look <a href="https://flowsforapex.org/latest/tutorials/" target="_blank">here</a>.',
'<p>',
'<h4>Demo App</h4>',
'<p>Take a look at our <a href="https://flowsforapex.org" target="_blank">website</a> to see how the integration of a flow can be done.'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16518361588787101)
,p_plug_name=>'Getting Started'
,p_region_template_options=>'#DEFAULT#:t-HeroRegion--hideIcon'
,p_plug_template=>wwv_flow_imp.id(12495589722092880240)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_imp_page.create_page(
 p_id=>2
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Flow Management'
,p_alias=>'FLOW-MANAGEMENT'
,p_step_title=>'Flow Management - &APP_NAME_TITLE.'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'initPage2();'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5522803511864949)
,p_plug_name=>'Action Menu'
,p_region_name=>'actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(7927640106409064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7938769092499710)
,p_plug_name=>'Copy Model'
,p_region_name=>'copy_flow_reg'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24213241311956116)
,p_plug_name=>'Flow Management'
,p_region_name=>'parsed_drgm'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>30
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0002_DIAGRAMS_VW'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Flow Management'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(24214476360956128)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'1000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_display_row_count=>'Y'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'FLOWS4APEX'
,p_internal_uid=>24214476360956128
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24214554954956129)
,p_db_column_name=>'DGRM_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24214647255956130)
,p_db_column_name=>'DGRM_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24214759985956131)
,p_db_column_name=>'DGRM_VERSION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24214844713956132)
,p_db_column_name=>'DGRM_STATUS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#DGRM_STATUS#</span>',
'</div>'))
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2496678063177011)
,p_db_column_name=>'DGRM_STATUS_ICON'
,p_display_order=>50
,p_column_identifier=>'Z'
,p_column_label=>'Dgrm Status Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24214982358956133)
,p_db_column_name=>'DGRM_CATEGORY'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Category'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24215092633956134)
,p_db_column_name=>'DGRM_LAST_UPDATE'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Last Update'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&APP_DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24215123061956135)
,p_db_column_name=>'BTN'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'<button type="button" title="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="header-action" data-menu="header_actions_menu"><span aria-hidde'
||'n="true" class="t-Icon fa fa-bars"></span></button>'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P2_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" ',
'        data-menu="row_actions_menu"',
'        data-dgrm="#DGRM_ID#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'action_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(24215292671956136)
,p_db_column_name=>'INSTANCES'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Instances'
,p_column_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:RIR,RP:IR_PRCS_DGRM_NAME,IR_PRCS_DGRM_VERSION:#DGRM_NAME#,#DGRM_VERSION#'
,p_column_linktext=>'#INSTANCES#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26092727630304614)
,p_db_column_name=>'DIAGRAM_PARSED'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Flow Parsed'
,p_column_html_expression=>'<span aria-hidden="true" class="fa #DIAGRAM_PARSED_ICON#"></span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26093269879304619)
,p_db_column_name=>'DIAGRAM_PARSED_ICON'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Diagram Parsed Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34401608353171402)
,p_db_column_name=>'INSTANCE_CREATED'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'<i class="status_icon fa fa-plus-circle-o" data-status="created"></i>&APP_TEXT$APP_STATUS_CREATED.'
,p_column_html_expression=>'<a href=#INSTANCE_CREATED_LINK#>#INSTANCE_CREATED#</a>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34401735853171403)
,p_db_column_name=>'INSTANCE_RUNNING'
,p_display_order=>130
,p_column_identifier=>'N'
,p_column_label=>'<i class="status_icon fa fa-play-circle-o" data-status="running"></i>&APP_TEXT$APP_STATUS_RUNNING.'
,p_column_html_expression=>'<a href=#INSTANCE_RUNNING_LINK#>#INSTANCE_RUNNING#</a>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34401808911171404)
,p_db_column_name=>'INSTANCE_COMPLETED'
,p_display_order=>140
,p_column_identifier=>'O'
,p_column_label=>'<i class="status_icon fa fa-check-circle-o" data-status="completed"></i>&APP_TEXT$APP_STATUS_COMPLETED.'
,p_column_html_expression=>'<a href=#INSTANCE_COMPLETED_LINK#>#INSTANCE_COMPLETED#</a>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34403520844171421)
,p_db_column_name=>'INSTANCE_TERMINATED'
,p_display_order=>150
,p_column_identifier=>'T'
,p_column_label=>'<i class="status_icon fa fa-stop-circle-o" data-status="terminated"></i>&APP_TEXT$APP_STATUS_TERMINATED.'
,p_column_html_expression=>'<a href=#INSTANCE_TERMINATED_LINK#>#INSTANCE_TERMINATED#</a>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34401973271171405)
,p_db_column_name=>'INSTANCE_ERROR'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'<i class="status_icon fa fa-exclamation-circle-o" data-status="error"></i>&APP_TEXT$APP_STATUS_ERROR.'
,p_column_html_expression=>'<a href=#INSTANCE_ERROR_LINK#>#INSTANCE_ERROR#</a>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34402061088171406)
,p_db_column_name=>'INSTANCE_CREATED_LINK'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Instance Created Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34403349213171419)
,p_db_column_name=>'INSTANCE_RUNNING_LINK'
,p_display_order=>180
,p_column_identifier=>'R'
,p_column_label=>'Instance Running Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34403481804171420)
,p_db_column_name=>'INSTANCE_COMPLETED_LINK'
,p_display_order=>190
,p_column_identifier=>'S'
,p_column_label=>'Instance Completed Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34403626861171422)
,p_db_column_name=>'INSTANCE_TERMINATED_LINK'
,p_display_order=>200
,p_column_identifier=>'U'
,p_column_label=>'Instance Terminated Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34403765313171423)
,p_db_column_name=>'INSTANCE_ERROR_LINK'
,p_display_order=>210
,p_column_identifier=>'V'
,p_column_label=>'Instance Error Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34631762547575819)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>220
,p_column_identifier=>'W'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34631865848575820)
,p_db_column_name=>'CREATE_INSTANCE_LINK'
,p_display_order=>230
,p_column_identifier=>'X'
,p_column_label=>'Create Instance Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34632066723575822)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>240
,p_column_identifier=>'Y'
,p_column_label=>'<input type="checkbox" id="check-all">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'checkbox_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(26034946443441850)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'260350'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKBOX:BTN:DGRM_NAME:DGRM_VERSION:DGRM_STATUS:DGRM_CATEGORY:DGRM_LAST_UPDATE:INSTANCE_CREATED:INSTANCE_RUNNING:INSTANCE_COMPLETED:INSTANCE_TERMINATED:INSTANCE_ERROR:'
,p_sort_column_1=>'DGRM_CATEGORY'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'DGRM_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'DGRM_VERSION'
,p_sort_direction_3=>'DESC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'DGRM_CATEGORY:0:0:0:0:0'
,p_break_enabled_on=>'0:0:0:0:0:DGRM_CATEGORY'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(11245398850667810)
,p_report_id=>wwv_flow_imp.id(26034946443441850)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'DIAGRAM_PARSED'
,p_operator=>'='
,p_expr=>'Yes'
,p_condition_sql=>'"DIAGRAM_PARSED" = #APXWS_EXPR#'
,p_condition_display=>'#APXWS_COL_NAME# = ''Yes''  '
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34402625223171412)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34634863225575850)
,p_plug_name=>'Row Action Menu'
,p_region_name=>'row_actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609667684880263)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(39902352324857428)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40001574962317105)
,p_plug_name=>'Header Action Menu'
,p_region_name=>'header_actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609667684880263)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(40402255178815218)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(71488161436297107)
,p_plug_name=>'New Version'
,p_region_name=>'new_version_reg'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7938939101499712)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7938769092499710)
,p_button_name=>'COPY_MODEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Model'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-plus'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26400953036736995)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(71488161436297107)
,p_button_name=>'ADD_VERSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Version'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-chevron-circle-up'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24212654778956110)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34402625223171412)
,p_button_name=>'CREATE_MODEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft:t-Button--padRight'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Model'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7::'
,p_icon_css_classes=>'fa-plus'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5522753745864948)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34402625223171412)
,p_button_name=>'ACTION_MENU'
,p_button_static_id=>'action-menu-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_button_image_alt=>'Action Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-bars'
,p_button_cattributes=>'data-menu="actions_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34403897960171424)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(24213241311956116)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP,2,RIR::'
,p_icon_css_classes=>'fa-undo-alt'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34632313238575825)
,p_branch_name=>'Go To Page 5'
,p_branch_action=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:5:P5_MULTI:Y&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EXPORT_FLOW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40001200556317102)
,p_branch_action=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7:P7_DGRM_ID:&P2_DGRM_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_FLOW'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7938841081499711)
,p_name=>'P2_NEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7938769092499710)
,p_prompt=>'New Name/Suffix'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_inline_help_text=>'In case of single model copy, the new model will have the entered name but if you have selected more than one row then the value entered will be used as a suffix.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15356359428942511)
,p_name=>'P2_BULK_ACTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(24213241311956116)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26093937239304626)
,p_name=>'P2_DGRM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(24213241311956116)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26401222533737000)
,p_name=>'P2_NEW_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(71488161436297107)
,p_prompt=>'New Version'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(26401796293739221)
,p_validation_name=>'Flow exists (bulk new version)'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.validate_flow_exists_bulk(',
'  pi_dgrm_id_list => :P2_DGRM_ID',
', pi_new_version => :P2_NEW_VERSION',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':request = ''ADD_VERSION'' and :P2_BULK_ACTION = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(26401222533737000)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15356574500942513)
,p_validation_name=>'Flow exists (new version)'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.validate_flow_exists(',
'  pi_dgrm_id => :P2_DGRM_ID',
', pi_new_version => :P2_NEW_VERSION',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':request = ''ADD_VERSION'' and :P2_BULK_ACTION = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(26401222533737000)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(40001878906317108)
,p_validation_name=>'Flow exists (bulk copy)'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.validate_flow_copy_bulk(',
'  pi_dgrm_id_list => :P2_DGRM_ID',
', pi_new_name => :P2_NEW_NAME',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':request = ''COPY_MODEL'' and :P2_BULK_ACTION = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(7938841081499711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15356425922942512)
,p_validation_name=>'Flow exists (copy)'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.validate_flow_copy(',
'  pi_new_name => :P2_NEW_NAME',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':request = ''COPY_MODEL'' and :P2_BULK_ACTION = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(7938841081499711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15356651838942514)
,p_validation_name=>'New name is not null'
,p_validation_sequence=>50
,p_validation=>'P2_NEW_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'COPY_MODEL'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(7938841081499711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15356707920942515)
,p_validation_name=>'New version is not null'
,p_validation_sequence=>60
,p_validation=>'P2_NEW_VERSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'ADD_VERSION'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(26401222533737000)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19019347638332911)
,p_name=>'Imported - Refresh Report'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#actions_menu'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.data.dialogPageId == "6"'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19023277699332950)
,p_event_id=>wwv_flow_imp.id(19019347638332911)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_MODEL_IMPORTED"));'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(26091408686304601)
,p_event_id=>wwv_flow_imp.id(19019347638332911)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(24213241311956116)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(26093728782304624)
,p_name=>'Clickable Action clicked - Forward to Process or Selection'
,p_event_sequence=>80
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.clickable-action'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(26093894432304625)
,p_event_id=>wwv_flow_imp.id(26093728782304624)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myElement = apex.jQuery( this.triggeringElement );',
'var myAction  = myElement.data( "action" );',
'var myDiagram = myElement.data( "dgrm" );',
'',
'apex.item( "P2_DGRM_ID" ).setValue( myDiagram );',
'',
'switch (myAction) {',
'    case ''new_version'': {',
'        apex.item( "P2_NEW_VERSION" ).setValue( "" );',
'        apex.theme.openRegion( "new_version_reg" );    ',
'        break;',
'    }',
'    case ''copy_flow'': {',
'        apex.item( "P2_NEW_NAME" ).setValue( "" );',
'        apex.theme.openRegion( "copy_flow_reg" );    ',
'        break;',
'    }',
'}',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34718198447581242)
,p_name=>'Dialog closed - Refresh Report & Show Success'
,p_event_sequence=>90
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(24213241311956116)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34718524685581254)
,p_event_id=>wwv_flow_imp.id(34718198447581242)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(24213241311956116)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34719055685581256)
,p_event_id=>wwv_flow_imp.id(34718198447581242)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.data.successMessage !== undefined) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5521840396864939)
,p_name=>'Flow Management Report refreshed'
,p_event_sequence=>100
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(24213241311956116)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5521906942864940)
,p_event_id=>wwv_flow_imp.id(5521840396864939)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#parsed_drgm table th.a-IRR-header--group").attr("colspan", "6").after(''<th colspan="5" class="a-IRR-header a-IRR-header--group" id="instances_column_group_heading" style="text-align: center;">Instances</th>'');',
'',
'$( ".a-IRR-headerLabel, .a-IRR-headerLink" ).each( function () {',
'      var status = $( this ).children("i").data("status");',
'      if ( status == "created" ) {',
'        $( this ).parent().addClass( "ffa-color--created" );',
'      } else if ( status == "completed" ) {',
'        $( this ).parent().addClass( "ffa-color--completed" );',
'      } else if ( status == "running" ) {',
'        $( this ).parent().addClass( "ffa-color--running" );',
'      } else if ( status == "terminated" ) {',
'        $( this ).parent().addClass( "ffa-color--terminated" );',
'      } else if ( status == "error" ) {',
'        $( this ).parent().addClass( "ffa-color--error" );',
'      }',
'    } );',
'',
'//if ($("li.a-IRR-controls-item--controlBreak").length > 0) {',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'            apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'            apex.jQuery(this).find(''button#header-action'').hide();',
'        } else {',
'            apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(40001392180317103)
,p_name=>'Change checkAll'
,p_event_sequence=>110
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#check-all'
,p_bind_type=>'live'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(40001401094317104)
,p_event_id=>wwv_flow_imp.id(40001392180317103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#parsed_drgm #check-all'' ).is('':checked'') ) {',
'      $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#parsed_drgm input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(26094153642304628)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add new version'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.add_new_version(',
'  pi_dgrm_id_list => :P2_DGRM_ID',
', pi_new_version => :P2_NEW_VERSION',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'ADD_VERSION'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'&APP_TEXT$APP_NEW_VERSION_ADDED.'
);
end;
/
begin
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7939199045499714)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Model'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.copy_model(',
'  pi_dgrm_id_list => :P2_DGRM_ID',
', pi_new_name => :P2_NEW_NAME',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'COPY_MODEL'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'&APP_TEXT$APP_MODEL_COPIED.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34632414579575826)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Selection in Collection'
,p_process_sql_clob=>'flow_engine_app_api.copy_selection_to_collection;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'EXPORT_FLOW,ADD_VERSION,COPY_FLOW'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_imp_page.create_page(
 p_id=>3
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Dashboard'
,p_alias=>'DASHBOARD'
,p_step_title=>'Dashboard - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'initPage3();'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'13'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2036577010569044)
,p_plug_name=>'Instance Errors in the last 14 days'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2036635440569045)
,p_region_id=>wwv_flow_imp.id(2036577010569044)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2036784998569046)
,p_chart_id=>wwv_flow_imp.id(2036635440569045)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with period as (',
'    select sysdate - 13 + level - 1 dt',
'    from   dual',
'    connect by level <= (',
'      sysdate - sysdate  + 14',
'    )',
'  ), ',
'  error_counts as (',
'    select trunc(cast(lgpr.lgpr_timestamp as date)) as day, count(lgpr.lgpr_prcs_id) as error_count',
'    from flow_instance_event_log lgpr',
'    where lgpr.lgpr_prcs_event = ''error''',
'    and   lgpr.lgpr_timestamp > systimestamp - to_dsinterval (''P14D'')',
'    group by trunc(cast(lgpr.lgpr_timestamp as date))',
'  )',
'  select    to_char(trunc(p.dt), ''YYYY-MM-DD'') label, e.error_count as value',
'  from      period p',
'  left join error_counts e',
'  on        e.day = trunc(p.dt)',
'  order by  to_char(trunc(p.dt), ''YYYY-MM-DD'')'))
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#D2433B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2036882857569047)
,p_chart_id=>wwv_flow_imp.id(2036635440569045)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2036981184569048)
,p_chart_id=>wwv_flow_imp.id(2036635440569045)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2037037389569049)
,p_plug_name=>'Current Overdue Flow Instances'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2037143803569050)
,p_region_id=>wwv_flow_imp.id(2037037389569049)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2141783765493901)
,p_chart_id=>wwv_flow_imp.id(2037143803569050)
,p_seq=>10
,p_name=>'Running'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   select prcs.prcs_dgrm_id Diagram, dgrm.dgrm_name Process_Name, count(prcs_id)',
'     from flow_processes prcs',
'left join flow_diagrams dgrm',
'       on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'    where prcs.prcs_due_on < systimestamp',
'      and prcs.prcs_status = ''running''',
' group by prcs_dgrm_id, dgrm.dgrm_name',
' order by count(prcs_id) desc',
'fetch first 10 rows only'))
,p_items_value_column_name=>'COUNT(PRCS_ID)'
,p_items_label_column_name=>'PROCESS_NAME'
,p_color=>'#6AAD42'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2142032851493904)
,p_chart_id=>wwv_flow_imp.id(2037143803569050)
,p_seq=>20
,p_name=>'Error'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   select prcs.prcs_dgrm_id Diagram, dgrm.dgrm_name Process_Name, count(prcs_id)',
'     from flow_processes prcs',
'left join flow_diagrams dgrm',
'       on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'    where prcs.prcs_due_on < systimestamp',
'      and prcs.prcs_status = ''error''',
' group by prcs_dgrm_id, dgrm.dgrm_name',
' order by count(prcs_id) desc',
'fetch first 10 rows only'))
,p_items_value_column_name=>'COUNT(PRCS_ID)'
,p_items_label_column_name=>'PROCESS_NAME'
,p_color=>'#D2433B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2141803901493902)
,p_chart_id=>wwv_flow_imp.id(2037143803569050)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2141997113493903)
,p_chart_id=>wwv_flow_imp.id(2037143803569050)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3511439830851727)
,p_plug_name=>'Errors'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--warning:t-Alert--accessibleHeading'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3_APEX_UPGRADE_DETECTED is not null or',
':P3_VERSION_MISMATCH is not null or',
'flow_timers_pkg.get_timer_status = ''FALSE'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3508800535851701)
,p_plug_name=>'Version mismatch'
,p_parent_plug_id=>wwv_flow_imp.id(3511439830851727)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495604368136880259)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'&P3_VERSION_MISMATCH!RAW.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3_VERSION_MISMATCH'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3511545006851728)
,p_plug_name=>'Timers disabled'
,p_parent_plug_id=>wwv_flow_imp.id(3511439830851727)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495604368136880259)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Models containing one or more timers could not work properly on this system because they are disabled.<br>You can enable it in the Configuration page.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'flow_timers_pkg.get_timer_status = ''FALSE'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3511637925851729)
,p_plug_name=>'APEX upgrade detected'
,p_parent_plug_id=>wwv_flow_imp.id(3511439830851727)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495604368136880259)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'&P3_APEX_UPGRADE_DETECTED!RAW.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3_APEX_UPGRADE_DETECTED'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34404686490171432)
,p_name=>'Flow Instances per status'
,p_region_name=>'flow-instances-per-status'
,p_template=>wwv_flow_imp.id(12495582446800880234)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-BadgeList--large:t-BadgeList--dash:t-BadgeList--cols t-BadgeList--5cols:t-Report--hideNoPagination'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''created'', p_clear_cache => ''RP,RIR'') as instance_created_link,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''running'', p_clear_cache => ''RP,RIR'') as instance_running_link,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0) as completed_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0) as error_instances,',
'    apex_page.get_url(p_page => 10, p_items => ''IR_PRCS_STATUS'', p_values => ''error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'from flow_instances_vw i'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495570578125880206)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34404729118171433)
,p_query_column_id=>1
,p_column_alias=>'CREATED_INSTANCES'
,p_column_display_sequence=>1
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<a href="#INSTANCE_CREATED_LINK#"><span class="instance-counter-link" data-status="created">#CREATED_INSTANCES#</span></a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405276469171438)
,p_query_column_id=>2
,p_column_alias=>'INSTANCE_CREATED_LINK'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34404808882171434)
,p_query_column_id=>3
,p_column_alias=>'RUNNING_INSTANCES'
,p_column_display_sequence=>2
,p_column_heading=>'Running'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<a href="#INSTANCE_RUNNING_LINK#"><span class="instance-counter-link" data-status="running">#RUNNING_INSTANCES#</span></a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405310659171439)
,p_query_column_id=>4
,p_column_alias=>'INSTANCE_RUNNING_LINK'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34404982371171435)
,p_query_column_id=>5
,p_column_alias=>'COMPLETED_INSTANCES'
,p_column_display_sequence=>3
,p_column_heading=>'Completed'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<a href="#INSTANCE_COMPLETED_LINK#"><span class="instance-counter-link" data-status="completed">#COMPLETED_INSTANCES#</span></a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405470286171440)
,p_query_column_id=>6
,p_column_alias=>'INSTANCE_COMPLETED_LINK'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405020184171436)
,p_query_column_id=>7
,p_column_alias=>'TERMINATED_INSTANCES'
,p_column_display_sequence=>4
,p_column_heading=>'Terminated'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<a href="#INSTANCE_TERMINATED_LINK#"><span class="instance-counter-link" data-status="terminated">#TERMINATED_INSTANCES#</span></a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405533448171441)
,p_query_column_id=>8
,p_column_alias=>'INSTANCE_TERMINATED_LINK'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405145511171437)
,p_query_column_id=>9
,p_column_alias=>'ERROR_INSTANCES'
,p_column_display_sequence=>5
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<a href="#INSTANCE_ERROR_LINK#"><span class="instance-counter-link" data-status="error">#ERROR_INSTANCES#</span></a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34405630954171442)
,p_query_column_id=>10
,p_column_alias=>'INSTANCE_ERROR_LINK'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34405803831171444)
,p_plug_name=>'Current Flow Instances per Model - Top 10'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(34405931132171445)
,p_region_id=>wwv_flow_imp.id(34405803831171444)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'on'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(34406094116171446)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_seq=>10
,p_name=>'Created'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top_procs as ',
'(',
'select d.dgrm_id, d.dgrm_name, count(i.prcs_id)',
'from  flow_diagrams d',
'join  flow_processes i',
'  on d.dgrm_id = i.prcs_dgrm_id',
'group by d.dgrm_id, d.dgrm_name',
'order by count(i.prcs_id) desc',
'fetch first 15 rows only',
')',
'select p.dgrm_id, p.dgrm_name label, count(i.prcs_id) value',
'from top_procs p',
'left join flow_processes i',
' on p.dgrm_id = i.prcs_dgrm_id',
'where i.prcs_status = ''created''',
'group by p.dgrm_id, p.dgrm_name'))
,p_max_row_count=>20
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#D9B13B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::P16_DGRM_ID,P16_DGRM_NAME_VERSION:&DGRM_ID.,&LABEL.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(34406322852171449)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_seq=>20
,p_name=>'Running'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top_procs as ',
'(',
'select d.dgrm_id, d.dgrm_name, count(i.prcs_id)',
'from  flow_diagrams d',
'join  flow_processes i',
'  on d.dgrm_id = i.prcs_dgrm_id',
'group by d.dgrm_id, d.dgrm_name',
'order by count(i.prcs_id) desc',
'fetch first 15 rows only',
')',
'select p.dgrm_id, p.dgrm_name label, count(i.prcs_id) value',
'from top_procs p',
'left join flow_processes i',
' on p.dgrm_id = i.prcs_dgrm_id',
'where i.prcs_status = ''running''',
'group by p.dgrm_id, p.dgrm_name'))
,p_max_row_count=>20
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#6AAD42'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::P16_DGRM_ID,P16_DGRM_NAME_VERSION:&DGRM_ID.,&LABEL.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(34406421411171450)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_seq=>30
,p_name=>'Completed'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top_procs as ',
'(',
'select d.dgrm_id, d.dgrm_name, count(i.prcs_id)',
'from  flow_diagrams d',
'join  flow_processes i',
'  on d.dgrm_id = i.prcs_dgrm_id',
'group by d.dgrm_id, d.dgrm_name',
'order by count(i.prcs_id) desc',
'fetch first 15 rows only',
')',
'select p.dgrm_id, p.dgrm_name label, count(i.prcs_id) value',
'from top_procs p',
'left join flow_processes i',
' on p.dgrm_id = i.prcs_dgrm_id',
'where i.prcs_status = ''completed''',
'group by p.dgrm_id, p.dgrm_name'))
,p_max_row_count=>20
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#8C9EB0 '
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::P16_DGRM_ID,P16_DGRM_NAME_VERSION:&DGRM_ID.,&LABEL.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(34629958268575801)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_seq=>40
,p_name=>'Terminated'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top_procs as ',
'(',
'select d.dgrm_id, d.dgrm_name, count(i.prcs_id)',
'from  flow_diagrams d',
'join  flow_processes i',
'  on d.dgrm_id = i.prcs_dgrm_id',
'group by d.dgrm_id, d.dgrm_name',
'order by count(i.prcs_id) desc',
'fetch first 15 rows only',
')',
'select p.dgrm_id, p.dgrm_name label, count(i.prcs_id) value',
'from top_procs p',
'left join flow_processes i',
' on p.dgrm_id = i.prcs_dgrm_id',
'where i.prcs_status = ''terminated''',
'group by p.dgrm_id, p.dgrm_name'))
,p_max_row_count=>20
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#D76A27'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::P16_DGRM_ID,P16_DGRM_NAME_VERSION:&DGRM_ID.,&LABEL.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(34630038161575802)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_seq=>50
,p_name=>'Error'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top_procs as ',
'(',
'select d.dgrm_id, d.dgrm_name, count(i.prcs_id)',
'from  flow_diagrams d',
'join  flow_processes i',
'  on d.dgrm_id = i.prcs_dgrm_id',
'group by d.dgrm_id, d.dgrm_name',
'order by count(i.prcs_id) desc',
'fetch first 15 rows only',
')',
'select p.dgrm_id, p.dgrm_name label, count(i.prcs_id) value',
'from top_procs p',
'left join flow_processes i',
' on p.dgrm_id = i.prcs_dgrm_id',
'where i.prcs_status = ''error''',
'group by p.dgrm_id, p.dgrm_name'))
,p_max_row_count=>20
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#D2433B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::P16_DGRM_ID,P16_DGRM_NAME_VERSION:&DGRM_ID.,&LABEL.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(34406178037171447)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(34406265588171448)
,p_chart_id=>wwv_flow_imp.id(34405931132171445)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34586934772532100)
,p_plug_name=>'Flow Instances started in the last 14 days'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(34587344445532101)
,p_region_id=>wwv_flow_imp.id(34586934772532100)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(34589026072532104)
,p_chart_id=>wwv_flow_imp.id(34587344445532101)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with period as (',
'    select sysdate - 13 + level - 1 dt',
'    from   dual',
'    connect by level <= (',
'      sysdate - sysdate  + 14',
'    )',
'  )',
'  select  to_char(trunc(p.dt), ''YYYY-MM-DD'') label, count(ins.prcs_id) as value',
'  from period p',
'  left join flow_instances_vw ins on trunc(cast(ins.prcs_start_ts as date)) = trunc(p.dt)',
'  group by to_char(trunc(p.dt), ''YYYY-MM-DD'')',
'  order by  to_char(trunc(p.dt), ''YYYY-MM-DD'')'))
,p_max_row_count=>20
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_color=>'#D9B13B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.::P15_DATE:&LABEL.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(34587853181532103)
,p_chart_id=>wwv_flow_imp.id(34587344445532101)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(34588414131532104)
,p_chart_id=>wwv_flow_imp.id(34587344445532101)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34631684166575818)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3508955560851702)
,p_name=>'P3_VERSION_MISMATCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(34631684166575818)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3511819715851731)
,p_name=>'P3_APEX_UPGRADE_DETECTED'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(34631684166575818)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3509091092851703)
,p_computation_sequence=>10
,p_computation_item=>'P3_VERSION_MISMATCH'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return flow_engine_app_api.check_version_mismatch( p_app_id => :app_id);',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3512045963851733)
,p_computation_sequence=>20
,p_computation_item=>'P3_APEX_UPGRADE_DETECTED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return flow_engine_app_api.check_apex_upgrade( p_app_id => :app_id);',
'end;'))
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_imp_page.create_page(
 p_id=>4
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Flow Modeler'
,p_alias=>'MODELER'
,p_step_title=>'Flow Modeler - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initPage4();',
'window.f4a = window.f4a || {};',
'window.f4a.language = ''&BROWSER_LANGUAGE.'';'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'17'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7938399981499706)
,p_plug_name=>'Action Menu'
,p_region_name=>'actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(7959288629726086)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22800510543488044)
,p_plug_name=>'&P4_REGION_TITLE.'
,p_region_name=>'modeler'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_DIAGRAMS'
,p_query_where=>'dgrm_id = :p4_dgrm_id'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.MODELER.REGION'
,p_ajax_items_to_submit=>'P4_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24418438259878743)
,p_plug_name=>'Flow XML'
,p_region_name=>'diagram_xml_region'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34403031827171416)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15683484308738625)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(34403031827171416)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7938283749499705)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(34403031827171416)
,p_button_name=>'ACTION_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_button_image_alt=>'Action Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-bars'
,p_button_cattributes=>'data-menu="actions_menu"'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15681777930738608)
,p_name=>'P4_DGRM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22800510543488044)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22800638443488045)
,p_name=>'P4_REGION_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22800510543488044)
,p_source=>'No valid Flow selected.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24418616934878745)
,p_name=>'P4_DIAGRAM_XML'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(24418438259878743)
,p_prompt=>'Diagram Xml'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cHeight=>20
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_imp.id(12495523145758880138)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--stretchInputs'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(22800733881488046)
,p_computation_sequence=>10
,p_computation_item=>'P4_REGION_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_region_title(',
'  pi_dgrm_id => :P4_DGRM_ID',
')'))
,p_compute_when=>'P4_DGRM_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15683695432738627)
,p_name=>'Apply Changes Clicked'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(15683484308738625)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(22801024059488049)
,p_event_id=>wwv_flow_imp.id(15683695432738627)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.region(''modeler'').save();'
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_imp_page.create_page(
 p_id=>5
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Export'
,p_alias=>'EXPORT'
,p_page_mode=>'MODAL'
,p_step_title=>'Export - &APP_NAME_TITLE.'
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
,p_last_updated_by=>'DAMTHOR'
,p_last_upd_yyyymmddhh24miss=>'20220106135541'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17600327473220601)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17601866805220616)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft:t-Button--gapTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'BELOW_BOX'
,p_icon_css_classes=>'fa-download'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17600676567220604)
,p_name=>'P5_DGRM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17601343709220611)
,p_name=>'P5_FILENAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_prompt=>'File Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>300
,p_display_when=>'P5_MULTI'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17601485306220612)
,p_name=>'P5_INCLUDE_VERSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_prompt=>'Include Version'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'filename-changer'
,p_display_when=>'P5_MULTI'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17601505679220613)
,p_name=>'P5_INCLUDE_CATEGORY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_prompt=>'Include Category'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'filename-changer'
,p_display_when=>'P5_MULTI'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17601607926220614)
,p_name=>'P5_INCLUDE_LAST_CHANGE_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_prompt=>'Include Last Change Date'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_display_when=>'P5_MULTI'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_css_classes=>'filename-changer'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17601740723220615)
,p_name=>'P5_DOWNLOAD_AS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_item_default=>'BPMN'
,p_prompt=>'Download As'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P5_DOWNLOAD_AS'
,p_lov=>'.'||wwv_flow_imp.id(11258952541008552)||'.'
,p_tag_css_classes=>'filename-changer'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17602168797220619)
,p_name=>'P5_INCLUDE_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_prompt=>'Include Status'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_display_when=>'P5_MULTI'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_css_classes=>'filename-changer'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34632201368575824)
,p_name=>'P5_MULTI'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17600327473220601)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(17601968120220617)
,p_name=>'Set File Name On Change'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.filename-changer'
,p_bind_type=>'live'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P5_MULTI'
,p_display_when_cond2=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17602048410220618)
,p_event_id=>wwv_flow_imp.id(17601968120220617)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5_FILENAME'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.get_file_name(',
'    p_dgrm_id => :P5_DGRM_ID,',
'    p_include_version => :P5_INCLUDE_VERSION,',
'    p_include_status => :P5_INCLUDE_STATUS,',
'    p_include_category => :P5_INCLUDE_CATEGORY,',
'    p_include_last_change_date => :P5_INCLUDE_LAST_CHANGE_DATE,',
'    p_download_as => :P5_DOWNLOAD_AS',
');',
''))
,p_attribute_07=>'P5_INCLUDE_VERSION,P5_INCLUDE_CATEGORY,P5_INCLUDE_LAST_CHANGE_DATE,P5_DOWNLOAD_AS,P5_DGRM_ID,P5_INCLUDE_STATUS'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17602291110220620)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Download File'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_engine_app_api.download_file(',
'        p_dgrm_id => :P5_DGRM_ID,',
'        p_file_name => :P5_FILENAME,',
'        p_download_as => :P5_DOWNLOAD_AS,',
'        p_multi_file => case :P5_MULTI when ''Y'' then true else false end',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(17601866805220616)
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_imp_page.create_page(
 p_id=>6
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Import'
,p_alias=>'IMPORT'
,p_page_mode=>'MODAL'
,p_step_title=>'Import - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19000369704190884)
,p_plug_name=>'Import Flow'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24211779219956101)
,p_plug_name=>'Import Warning'
,p_region_template_options=>'#DEFAULT#:t-Alert--colorBG:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--accessibleHeading:margin-top-none:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source=>'We encourage you to import models that were built using Flows for APEX to make sure that they can be run by the engine.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19019657971332914)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_button_name=>'IMPORT_AND_IMPORT_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--gapTop'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Import and import another'
,p_button_position=>'BELOW_BOX'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19019773259332915)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_button_name=>'IMPORT_AND_EDIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft:t-Button--gapTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Import and edit'
,p_button_position=>'BELOW_BOX'
,p_icon_css_classes=>'fa-edit'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19018929080332907)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_button_name=>'IMPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft:t-Button--gapTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import'
,p_button_position=>'BELOW_BOX'
,p_icon_css_classes=>'fa-upload'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19019818946332916)
,p_branch_action=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:4:P4_DGRM_ID:&P6_DGRM_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'IMPORT_AND_EDIT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10431588640468049)
,p_name=>'P6_IMPORT_FROM'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_item_default=>'file'
,p_prompt=>'Import From'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P6_IMPORT_FROM'
,p_lov=>'.'||wwv_flow_imp.id(11250367144948655)||'.'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19000655987190889)
,p_name=>'P6_DGRM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19001062236190895)
,p_name=>'P6_DGRM_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>600
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19001433995190900)
,p_name=>'P6_DGRM_CONTENT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_prompt=>'Paste  BPMN file content (30 000 characters max.)'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>30000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19001891912190900)
,p_name=>'P6_DGRM_VERSION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_item_default=>'0'
,p_prompt=>'Version'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>40
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19002654728190900)
,p_name=>'P6_DGRM_CATEGORY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DIAGRAM_CATEGORIES_LOV'
,p_lov_display_null=>'YES'
,p_cSize=>60
,p_cMaxlength=>120
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19018652597332904)
,p_name=>'P6_FILE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_prompt=>'File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--large'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24211819068956102)
,p_name=>'P6_FORCE_OVERWRITE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_item_default=>'N'
,p_prompt=>'Force Overwrite'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34632505849575827)
,p_name=>'P6_MODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19000369704190884)
,p_item_default=>'single'
,p_prompt=>'Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P6_MODE'
,p_lov=>'.'||wwv_flow_imp.id(13102745982982601)||'.'
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_imp.id(12495523145758880138)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--stretchInputs:t-Form-fieldContainer--xlarge:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>One Model: Import a single model by providing all the attributes</li>',
'    <li>Multiple Models: Import several models by providing a zip file*</li>',
'</ul>',
'<p>',
'    * The zip file must contain:',
'    <ul>',
'        <li>The bpmn files to import</li>',
'        <li>An import.json file which is an array of objects (see example below) with the following attributes:',
'            <ul>',
'                <li>dgrm_name: The model''s name</li>',
'                <li>dgrm_version: The model''s version</li>',
'                <li>dgrm_category: The model''s category</li>',
'                <li>file: The name of the bpmn file in the archive</li>',
'            </ul>',
'        </li>',
'    </ul>',
'Example of an import.json file with two models<br>',
'<pre><code>[',
'  {',
'    "dgrm_name": "The Pizza Collaboration",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "The Pizza Collaboration_0.bpmn"',
'  },',
'  {',
'    "dgrm_name": "Holidays",',
'    "dgrm_version": "0",',
'    "dgrm_status": "draft",',
'    "dgrm_category": null,',
'    "file": "Holidays_0.bpmn"',
'  }',
']',
'</code></pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19023151364332949)
,p_validation_name=>'DGRM_CONTENT is not null'
,p_validation_sequence=>10
,p_validation=>'P6_DGRM_CONTENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please paste BPMN file content'
,p_validation_condition=>'P6_IMPORT_FROM'
,p_validation_condition2=>'text'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(19001433995190900)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19023037485332948)
,p_validation_name=>'File is not null'
,p_validation_sequence=>20
,p_validation=>'return flow_engine_app_api.is_file_uploaded(pi_file_name => :P6_FILE);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Please select a #LABEL#.'
,p_validation_condition=>':P6_IMPORT_FROM = ''file'' or :P6_MODE = ''multi'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(19018652597332904)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19019544229332913)
,p_validation_name=>'Validate XML'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.is_valid_xml(',
'        pi_import_from => :P6_IMPORT_FROM,',
'        pi_dgrm_content => :P6_DGRM_CONTENT,',
'        pi_file_name => :P6_FILE',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Please check the flow provided.'
,p_validation_condition=>'apex_error.have_errors_occurred = false and :P6_MODE = ''single'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(34633435811575836)
,p_validation_name=>'Validate ZIP'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.is_valid_multi_file_archive(',
'        pi_file_name => :P6_FILE',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'apex_error.have_errors_occurred = false and :P6_MODE = ''multi'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(34633545177575837)
,p_validation_name=>'DGRM_NAME is not null'
,p_validation_sequence=>50
,p_validation=>'P6_DGRM_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P6_MODE'
,p_validation_condition2=>'single'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(19001062236190895)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(34633648852575838)
,p_validation_name=>'DGRM_VERSION is not null'
,p_validation_sequence=>60
,p_validation=>'P6_DGRM_VERSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P6_MODE'
,p_validation_condition2=>'single'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(19001891912190900)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10431642957468050)
,p_name=>'Show/Hide Import Options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6_IMPORT_FROM'
,p_condition_element=>'P6_IMPORT_FROM'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'text'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19018371683332901)
,p_event_id=>wwv_flow_imp.id(10431642957468050)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_DGRM_CONTENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19018703760332905)
,p_event_id=>wwv_flow_imp.id(10431642957468050)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_FILE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19018463856332902)
,p_event_id=>wwv_flow_imp.id(10431642957468050)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_DGRM_CONTENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19018502280332903)
,p_event_id=>wwv_flow_imp.id(10431642957468050)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_FILE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(24211903521956103)
,p_name=>'Ask for confirmation'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6_FORCE_OVERWRITE'
,p_condition_element=>'P6_FORCE_OVERWRITE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(24212041561956104)
,p_event_id=>wwv_flow_imp.id(24211903521956103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.confirm( apex.lang.getMessage("APP_OVERWRITE_WARN"), function( okPressed ) {',
'    if( !okPressed ) {',
'        apex.item("P6_FORCE_OVERWRITE").setValue("N");',
'    }',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34632685881575828)
,p_name=>'Change Mode'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6_MODE'
,p_condition_element=>'P6_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'multiple'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34633042798575832)
,p_event_id=>wwv_flow_imp.id(34632685881575828)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_IMPORT_FROM'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'file'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34632715356575829)
,p_event_id=>wwv_flow_imp.id(34632685881575828)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_DGRM_CATEGORY,P6_DGRM_NAME,P6_DGRM_VERSION,P6_IMPORT_FROM,P6_DGRM_CONTENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34632977015575831)
,p_event_id=>wwv_flow_imp.id(34632685881575828)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_DGRM_CATEGORY,P6_DGRM_NAME,P6_DGRM_VERSION,P6_IMPORT_FROM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34633150335575833)
,p_event_id=>wwv_flow_imp.id(34632685881575828)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(19019773259332915)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34633301884575835)
,p_event_id=>wwv_flow_imp.id(34632685881575828)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(19019773259332915)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19018865821332906)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upload & Parse (Single Flow)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'begin',
'    l_dgrm_id := flow_engine_app_api.upload_and_parse(',
'                     pi_import_from => :P6_IMPORT_FROM,',
'                     pi_dgrm_name => :P6_DGRM_NAME,',
'                     pi_dgrm_category => :P6_DGRM_CATEGORY,',
'                     pi_dgrm_version => :P6_DGRM_VERSION,',
'                     pi_dgrm_content => :P6_DGRM_CONTENT,',
'                     pi_file_name => :P6_FILE,',
'                     pi_force_overwrite => :P6_FORCE_OVERWRITE',
'                 );',
'    :P6_DGRM_ID := l_dgrm_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Model already exists. Use force overwrite.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P6_MODE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'single'
,p_process_success_message=>'Model imported.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34633718670575839)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upload & Parse (Multiple Flows)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.multiple_flow_import(',
'    pi_file_name => :P6_FILE,',
'    pi_force_overwrite => :P6_FORCE_OVERWRITE',
');',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Model already exists. Use force overwrite.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P6_MODE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'multiple'
,p_process_success_message=>'Model imported.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19019994508332917)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'IMPORT_AND_IMPORT_ANOTHER'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19008825550190910)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P6_DGRM_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'IMPORT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_imp_page.create_page(
 p_id=>7
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Flow'
,p_alias=>'FLOW'
,p_step_title=>'Flow - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APP_IMAGES#lib/prismjs/js/prism.js'
,p_javascript_code=>'initPage7();'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240930064036'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7937843762499701)
,p_plug_name=>'Action Menu'
,p_region_name=>'actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(7935522414465879)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26003019626877931)
,p_plug_name=>'Attributes'
,p_region_name=>'attributes'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>8
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_DIAGRAMS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60862347292537221)
,p_plug_name=>'Diagram Details'
,p_parent_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495604368136880259)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P7_DGRM_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60862870630537226)
,p_plug_name=>'Tab'
,p_parent_plug_id=>wwv_flow_imp.id(60862347292537221)
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_imp.id(12495575615770880223)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63513911250355404)
,p_plug_name=>'Called Diagrams'
,p_parent_plug_id=>wwv_flow_imp.id(60862870630537226)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0007_CALLED_DIAGRAMS_VW'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'root_dgrm = :P7_DGRM_ID',
'and calling_dgrm is not null'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Called Models'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(63514135027355406)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Called Diagrams found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7:P7_DGRM_ID:#DGRM_ID#'
,p_detail_link_text=>'<span class="fa fa-edit" aria-hidden="true"></span>'
,p_owner=>'LMOREAUX'
,p_internal_uid=>63514135027355406
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63514228675355407)
,p_db_column_name=>'DGRM_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63514302661355408)
,p_db_column_name=>'CALLING_DGRM'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Calling Dgrm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63514438411355409)
,p_db_column_name=>'CALLING_OBJT'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Calling Object'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63514708342355412)
,p_db_column_name=>'ROOT_DGRM'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Root Dgrm'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515879418355423)
,p_db_column_name=>'DGRM_NAME'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Called Diagram'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515990329355424)
,p_db_column_name=>'DGRM_VERSION'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63516512604355430)
,p_db_column_name=>'HAS_RECURSION'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Has Recursion'
,p_column_html_expression=>'<span class="#HAS_RECURSION_ICON#" aria-label="&APP_TEXT$APP_P7_HAS_RECURSION." title="&APP_TEXT$APP_P7_HAS_RECURSION."></span>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63516662153355431)
,p_db_column_name=>'HAS_RECURSION_ICON'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Has Recursion Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(64613740907593919)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'646138'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DGRM_NAME:DGRM_VERSION:CALLING_OBJT::HAS_RECURSION:HAS_RECURSION_ICON'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63514877350355413)
,p_plug_name=>'Calling Diagrams'
,p_parent_plug_id=>wwv_flow_imp.id(60862870630537226)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0007_CALLING_DIAGRAMS_VW'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_current_diagram(',
'   pi_dgrm_name           => called_diagram,',
'   pi_dgrm_calling_method => called_diagram_version_selection,',
'   pi_dgrm_version        => called_diagram_version',
') = :P7_DGRM_ID'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Calling Diagrams'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(63514930517355414)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Calling Diagrams found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7:P7_DGRM_ID:#DGRM_ID#'
,p_detail_link_text=>'<span class="fa fa-edit" aria-hidden="true"></span>'
,p_owner=>'LMOREAUX'
,p_internal_uid=>63514930517355414
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515059362355415)
,p_db_column_name=>'DGRM_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515140710355416)
,p_db_column_name=>'DGRM_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Calling Diagram'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515215281355417)
,p_db_column_name=>'DGRM_VERSION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515316439355418)
,p_db_column_name=>'OBJT_NAME'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Calling Object'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515571460355420)
,p_db_column_name=>'CALLED_DIAGRAM'
,p_display_order=>50
,p_column_identifier=>'F'
,p_column_label=>'Diagram'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515621004355421)
,p_db_column_name=>'CALLED_DIAGRAM_VERSION_SELECTION'
,p_display_order=>60
,p_column_identifier=>'G'
,p_column_label=>'Called Diagram Version Selection'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(63515771897355422)
,p_db_column_name=>'CALLED_DIAGRAM_VERSION'
,p_display_order=>70
,p_column_identifier=>'H'
,p_column_label=>'Called Diagram Version'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(64619529927716691)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'646196'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DGRM_NAME:DGRM_VERSION:OBJT_NAME'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(73725012982147304)
,p_name=>'In/Out Variables'
,p_region_name=>'vars-cr'
,p_parent_plug_id=>wwv_flow_imp.id(60862870630537226)
,p_template=>wwv_flow_imp.id(12495582446800880234)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--textContent:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--altRowsDefault:t-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0007_DIAGRAMS_VAR_VW'
,p_query_where=>'objt_dgrm_id = :P7_DGRM_ID'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495559701953880190)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No In/Out variables found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60864578114537243)
,p_query_column_id=>1
,p_column_alias=>'OBJT_DGRM_ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60864662910537244)
,p_query_column_id=>2
,p_column_alias=>'VAR_DIRECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Direction'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60864798356537245)
,p_query_column_id=>3
,p_column_alias=>'VAR_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60864809349537246)
,p_query_column_id=>4
,p_column_alias=>'VAR_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60864944171537247)
,p_query_column_id=>5
,p_column_alias=>'VAR_DESC'
,p_column_display_sequence=>5
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(117321296215490847)
,p_name=>'Attributes'
,p_region_name=>'attributes-cr'
,p_parent_plug_id=>wwv_flow_imp.id(60862870630537226)
,p_template=>wwv_flow_imp.id(12495584334308880235)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-AVPList--leftAligned:t-Report--hideNoPagination'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0007_DIAGRAMS_ATTRIBUTES_VW'
,p_query_where=>'objt_dgrm_id = :P7_DGRM_ID'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495548550946880181)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No attributes found.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60863664430537234)
,p_query_column_id=>1
,p_column_alias=>'OBJT_DGRM_ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60863751015537235)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60863889314537236)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Page Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60863981218537237)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(60864072957537238)
,p_query_column_id=>5
,p_column_alias=>'IS_CALLABLE'
,p_column_display_sequence=>5
,p_column_heading=>'Is Callable'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28425138174759832)
,p_plug_name=>'Flow Viewer'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0007_VW'
,p_query_where=>'dgrm_id = :p7_dgrm_id'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P7_DGRM_ID'
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_03=>'DGRM_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34402779943171413)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(36450747308745933)
,p_name=>'Process instances per status'
,p_region_name=>'instances_counter'
,p_template=>wwv_flow_imp.id(12495582446800880234)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-BadgeList--large:t-BadgeList--circular:t-BadgeList--cols t-BadgeList--3cols:t-Report--hideNoPagination'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    nvl(sum(case when i.prcs_status = ''created'' then 1 else 0 end), 0)  as created_instances,',
'    nvl(sum(case when i.prcs_status = ''running'' then 1 else 0 end), 0)  as running_instances,',
'    nvl(sum(case when i.prcs_status = ''completed'' then 1 else 0 end), 0)  as completed_instances,',
'    nvl(sum(case when i.prcs_status = ''terminated'' then 1 else 0 end), 0)  as terminated_instances,',
'    nvl(sum(case when i.prcs_status = ''error'' then 1 else 0 end), 0)  as error_instances',
'from flow_instances_vw i',
'where i.prcs_id in (',
'   select prdg.prdg_prcs_id',
'   from flow_diagrams_vw d',
'   left join flow_instance_diagrams prdg ',
'   on (prdg.prdg_dgrm_id = d.dgrm_id or prdg.prdg_calling_dgrm = d.dgrm_id)',
'   where d.dgrm_id = :P7_DGRM_ID',
')'))
,p_display_when_condition=>'P7_DGRM_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495570578125880206)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26021760516277918)
,p_query_column_id=>1
,p_column_alias=>'CREATED_INSTANCES'
,p_column_display_sequence=>1
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span data-status="created">#CREATED_INSTANCES#</a>',
''))
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26022166035277918)
,p_query_column_id=>2
,p_column_alias=>'RUNNING_INSTANCES'
,p_column_display_sequence=>2
,p_column_heading=>'Running'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span data-status="running">#RUNNING_INSTANCES#</a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26022532889277920)
,p_query_column_id=>3
,p_column_alias=>'COMPLETED_INSTANCES'
,p_column_display_sequence=>3
,p_column_heading=>'Completed'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span data-status="completed">#COMPLETED_INSTANCES#</a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34402829743171414)
,p_query_column_id=>4
,p_column_alias=>'TERMINATED_INSTANCES'
,p_column_display_sequence=>4
,p_column_heading=>'Terminated'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span data-status="terminated">#TERMINATED_INSTANCES#</a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34402963356171415)
,p_query_column_id=>5
,p_column_alias=>'ERROR_INSTANCES'
,p_column_display_sequence=>5
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span data-status="error">#ERROR_INSTANCES#</a>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45087523137560136)
,p_plug_name=>'New Version'
,p_region_name=>'new_version_reg'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45089270532561391)
,p_plug_name=>'Delete Model'
,p_region_name=>'delete_reg'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(45089418627561392)
,p_name=>'Associated process instances'
,p_parent_plug_id=>wwv_flow_imp.id(45089270532561391)
,p_template=>wwv_flow_imp.id(12495613507239880288)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--danger'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--staticRowColors:t-Report--rowHighlightOff:t-Report--noBorders:t-Report--hideNoPagination'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_lang.message(p_name => ''APP_DIAGRAM_INSTANCES_NB'', p0 => nb_instances) as nb_instances',
'from (',
'    select count(*) as nb_instances',
'    from flow_instances_vw ins',
'    where ins.prcs_id in (',
'        select prdg.prdg_prcs_id',
'        from flow_instance_diagrams prdg',
'        where prdg.prdg_dgrm_id = :P7_DGRM_ID',
'    )',
')   '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P7_DGRM_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495559701953880190)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26069606115228470)
,p_query_column_id=>1
,p_column_alias=>'NB_INSTANCES'
,p_column_display_sequence=>1
,p_column_heading=>'Nb Instances'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45090112965561399)
,p_plug_name=>'Form'
,p_parent_plug_id=>wwv_flow_imp.id(45089270532561391)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26067817325227237)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45087523137560136)
,p_button_name=>'ADD_VERSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Version'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-chevron-circle-up'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24215404585956138)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_button_name=>'NEW_VERSION'
,p_button_static_id=>'new_version_btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--simple:t-Button--iconLeft:t-Button--stretch:t-Button--padTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'New Version'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P7_DGRM_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'fa-plus'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>3
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24215607769956140)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_button_name=>'DEPRECATE'
,p_button_static_id=>'deprecate_btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--simple:t-Button--iconLeft:t-Button--stretch:t-Button--padTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Deprecate'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P7_DGRM_STATUS = flow_constants_pkg.gc_dgrm_status_released'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-ban'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>3
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24215581832956139)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_button_name=>'RELEASE'
,p_button_static_id=>'release_btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--simple:t-Button--iconLeft:t-Button--stretch:t-Button--padTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Release'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P7_DGRM_ID is not null and :P7_DGRM_STATUS = flow_constants_pkg.gc_dgrm_status_draft'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-check'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24215790121956141)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_button_name=>'ARCHIVE'
,p_button_static_id=>'archive_btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--simple:t-Button--iconLeft:t-Button--stretch:t-Button--padTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Archive'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P7_DGRM_STATUS = flow_constants_pkg.gc_dgrm_status_deprecated'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-archive'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34404258251171428)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45089270532561391)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26068946058228467)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45089270532561391)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'fa-trash-o'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26091600150304603)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(28425138174759832)
,p_button_name=>'MODIFY_DIAGRAM'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Modify Diagram'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_diagram.diagram_is_modifiable(',
'  pi_dgrm_id => :P7_DGRM_ID',
')'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-apex'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26009257493877978)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34402779943171413)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P7_DGRM_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'fa-save'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5522981517864950)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34402779943171413)
,p_button_name=>'ACTION_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_button_image_alt=>'Action Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P7_DGRM_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-bars'
,p_button_cattributes=>'data-menu="actions_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26009611434877978)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(34402779943171413)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P7_DGRM_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'fa-plus'
,p_database_action=>'INSERT'
);
end;
/
begin
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24216692251956150)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'DELETE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34402504419171411)
,p_branch_name=>'Go To Page 4'
,p_branch_action=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:4:P4_DGRM_ID:&P7_DGRM_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'MODIFY_DIAGRAM'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7336178189307043)
,p_name=>'P7_OBJT_LIST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28425138174759832)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7336335344307045)
,p_name=>'P7_OBJT_BPMN_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(28425138174759832)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7336470700307046)
,p_name=>'P7_OBJT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(28425138174759832)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8026927386825638)
,p_name=>'P7_ENGINE_APP_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7937843762499701)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24212748636956111)
,p_name=>'P7_DGRM_LAST_UPDATE'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_source_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_source=>'DGRM_LAST_UPDATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26003369119877940)
,p_name=>'P7_DGRM_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_source_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_source=>'DGRM_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26003724086877950)
,p_name=>'P7_DGRM_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_source_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_prompt=>'Name'
,p_source=>'DGRM_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>150
,p_read_only_when=>'P7_DGRM_STATUS'
,p_read_only_when2=>'draft'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26004107468877957)
,p_name=>'P7_DGRM_VERSION'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_source_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_default=>'0'
,p_prompt=>'Version'
,p_source=>'DGRM_VERSION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>10
,p_read_only_when=>'P7_DGRM_STATUS'
,p_read_only_when2=>'draft'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26004547057877957)
,p_name=>'P7_DGRM_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_source_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_default=>'flow_constants_pkg.gc_dgrm_status_draft'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Status'
,p_source=>'DGRM_STATUS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P7_DGRM_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26004901378877959)
,p_name=>'P7_DGRM_CATEGORY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_item_source_plug_id=>wwv_flow_imp.id(26003019626877931)
,p_prompt=>'Category'
,p_source=>'DGRM_CATEGORY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DIAGRAM_CATEGORIES_LOV'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Category'
,p_cSize=>60
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26068279548227242)
,p_name=>'P7_NEW_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(45087523137560136)
,p_prompt=>'New Version'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26070342430228478)
,p_name=>'P7_CASCADE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(45090112965561399)
,p_prompt=>'Cascade'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'Delete associated process instances'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44803477939176616)
,p_name=>'P7_LOADED_DIAGRAM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(28425138174759832)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34403109564171417)
,p_computation_sequence=>10
,p_computation_item=>'FLOW_PAGE_TITLE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_page_title(',
'  pi_dgrm_id => :P7_DGRM_ID',
', pi_dgrm_name => :P7_DGRM_NAME',
', pi_dgrm_version => :P7_DGRM_VERSION',
')'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8027046376825639)
,p_computation_sequence=>10
,p_computation_item=>'P7_ENGINE_APP_MODE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'  p_config_key => ''engine_app_mode''',
', p_default_value => flow_constants_pkg.gc_config_default_engine_app_mode',
');'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(26093582071304622)
,p_validation_name=>'Version'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_app_api.validate_new_version(',
'  pi_dgrm_name => :P7_DGRM_NAME',
', pi_dgrm_version => :P7_NEW_VERSION',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'ADD_VERSION'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(26068279548227242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63516446869355429)
,p_validation_name=>'Archive Model Validation'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from flow_instances_vw ins',
'where ins.prcs_id in (',
'    select prdg.prdg_prcs_id',
'    from flow_instance_diagrams prdg',
'    where prdg.prdg_dgrm_id = :P7_DGRM_ID',
')',
'and ins.prcs_status not in (''completed'', ''terminated'')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'You cannot archived a model which is associated with running instances.'
,p_validation_condition=>'ARCHIVE'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(24216185870956145)
,p_name=>'Open new version'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(24215404585956138)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(26093383508304620)
,p_event_id=>wwv_flow_imp.id(24216185870956145)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7_NEW_VERSION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(24216276371956146)
,p_event_id=>wwv_flow_imp.id(24216185870956145)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(45087523137560136)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(26096043786304647)
,p_name=>'Click on instances counter'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.instance-counter-link'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(26096178250304648)
,p_event_id=>wwv_flow_imp.id(26096043786304647)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let myElement = $( this.triggeringElement ).children().first();',
'let prcsStatus  = myElement.data( "status" );',
'let dgrmId = apex.item("P7_DGRM_ID").getValue();',
'apex.navigation.redirect( "f?p=" + $v( "pFlowId" ) + ":10:" + $v( "pInstance" ) + "::" + (apex.debug.getLevel() >= 4 ? "LEVEL" + apex.debug.getLevel() : "") + ":RIR,RP:P10_FILTER_DGRM_ID,IR_PRCS_STATUS:" + dgrmId + "," + prcsStatus);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34402165369171407)
,p_name=>'Click on Modify Diagram'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(26091600150304603)
,p_condition_element=>'P7_DGRM_STATUS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'draft'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34402245490171408)
,p_event_id=>wwv_flow_imp.id(34402165369171407)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'MODIFY_DIAGRAM'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34402409828171410)
,p_event_id=>wwv_flow_imp.id(34402165369171407)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'&APP_TEXT$APP_CONFIRM_EDIT_RELEASE_DIAGRAM.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34402353637171409)
,p_event_id=>wwv_flow_imp.id(34402165369171407)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'MODIFY_DIAGRAM'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34404369417171429)
,p_name=>'Click on Cancel'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(34404258251171428)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34404485254171430)
,p_event_id=>wwv_flow_imp.id(34404369417171429)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(45089270532561391)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34630409664575806)
,p_name=>'Click On Release'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(24215581832956139)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34630565554575807)
,p_event_id=>wwv_flow_imp.id(34630409664575806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'&APP_TEXT$APP_CONFIRM_RELEASE_MODEL.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34630686363575808)
,p_event_id=>wwv_flow_imp.id(34630409664575806)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'RELEASE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34630711735575809)
,p_name=>'Click on Deprecate'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(24215607769956140)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34630828651575810)
,p_event_id=>wwv_flow_imp.id(34630711735575809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'&APP_TEXT$APP_CONFIRM_DEPRECATE_MODEL.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34630931054575811)
,p_event_id=>wwv_flow_imp.id(34630711735575809)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DEPRECATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8024957923825618)
,p_name=>'Click on Archive'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(24215790121956141)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8025177637825620)
,p_event_id=>wwv_flow_imp.id(8024957923825618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'&APP_TEXT$APP_CONFIRM_ARCHIVE_MODEL.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8025291955825621)
,p_event_id=>wwv_flow_imp.id(8024957923825618)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ARCHIVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16955083547047750)
,p_name=>'Viewer Diagram Loaded'
,p_event_sequence=>100
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(28425138174759832)
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_diagram_loaded'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(44803522247176617)
,p_event_id=>wwv_flow_imp.id(16955083547047750)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7_LOADED_DIAGRAM'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.diagramIdentifier'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16955942968047775)
,p_event_id=>wwv_flow_imp.id(16955083547047750)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7_OBJT_LIST'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_dgrm_id => :P7_LOADED_DIAGRAM);',
'end if;'))
,p_attribute_07=>'P7_LOADED_DIAGRAM'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16956960300047776)
,p_event_id=>wwv_flow_imp.id(16955083547047750)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'changeCursor($v(''P7_OBJT_LIST''));'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16957375066050250)
,p_name=>'Element clicked'
,p_event_sequence=>110
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(28425138174759832)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'clickCondition($v(''P7_OBJT_LIST''), this.data);'
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_element_click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16957799465050250)
,p_event_id=>wwv_flow_imp.id(16957375066050250)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7_OBJT_BPMN_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.element.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16958247692050251)
,p_event_id=>wwv_flow_imp.id(16957375066050250)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7_OBJT_NAME'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P7_OBJT_BPMN_ID',
'  , p_dgrm_id => :P7_LOADED_DIAGRAM',
');',
'end if;'))
,p_attribute_07=>'P7_OBJT_BPMN_ID,P7_LOADED_DIAGRAM'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16958768897050251)
,p_event_id=>wwv_flow_imp.id(16957375066050250)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'openObjectDialog($v(''P7_OBJT_BPMN_ID''), $v(''P7_OBJT_NAME''), 7);'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22799930478488038)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'PROCESS_PAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.process_page_p7',
'(',
'  pio_dgrm_id      => :p7_dgrm_id',
', pi_dgrm_name     => :p7_dgrm_name',
', pi_dgrm_version  => :p7_dgrm_version',
', pi_dgrm_category => :p7_dgrm_category',
', pi_new_version   => :p7_new_version',
', pi_cascade       => :p7_cascade',
', pi_request       => :request',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':request not in ( ''DARK_MODE'', ''LIGHT_MODE'', ''RESET_LIGHT'', ''RESET_DARK'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action processed.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22800039236488039)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Session State on Delete'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(26010056924877981)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(26003019626877931)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Diagram'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(16966670195163768)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_url_p13(',
'  pi_dgrm_id => :P7_LOADED_DIAGRAM',
', pi_objt_id => apex_application.g_x01',
', pi_title => apex_application.g_x02',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_imp_page.create_page(
 p_id=>8
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Flow Instance Details'
,p_alias=>'FLOW-INSTANCE-DETAILS'
,p_step_title=>'Flow Instance Details  - &APP_NAME_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APP_IMAGES#lib/prismjs/js/prism.js'
,p_javascript_code=>'initPage8();'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Remove border around Instance Details alert region */',
'.t-Alert.remove-alert-border { border: none;}',
'',
'/* Make active tab in Instance Events bold */',
'.is-active .t-Tabs-link {',
'    font-weight: 700;',
'}'))
,p_step_template=>wwv_flow_imp.id(12495618547053880299)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'23'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241009095549'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3510821361851721)
,p_plug_name=>'Receive Message'
,p_region_name=>'receive_message_dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5681179787037011)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5681250057037012)
,p_plug_name=>'Flow Instance'
,p_region_name=>'instance-data'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_PROCESSES'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5684323221037043)
,p_plug_name=>'Instance Details'
,p_region_name=>'flow-instances'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6433334615417643)
,p_plug_name=>'Instance Details'
,p_parent_plug_id=>wwv_flow_imp.id(5684323221037043)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:is-expanded:t-Region--stacked:t-Region--scrollBody:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(12495604368136880259)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5682136171037021)
,p_name=>'Instance Details'
,p_region_name=>'flow-instance-detail'
,p_parent_plug_id=>wwv_flow_imp.id(6433334615417643)
,p_template=>wwv_flow_imp.id(12495613507239880288)
,p_display_sequence=>10
,p_region_css_classes=>'js-react-on-prcs remove-alert-border'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--accessibleHeading:margin-bottom-none'
,p_component_template_options=>'#DEFAULT#:t-AVPList--leftAligned:t-Report--hideNoPagination'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0008_INSTANCE_DETAILS_VW'
,p_query_where=>'prcs_id = :P8_PRCS_ID'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P8_PRCS_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495548550946880181)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8023653162825605)
,p_query_column_id=>1
,p_column_alias=>'PRCS_ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8023758985825606)
,p_query_column_id=>2
,p_column_alias=>'PRCS_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15355984569942507)
,p_query_column_id=>3
,p_column_alias=>'DGRM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Model'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#DGRM_NAME# - Version #DGRM_VERSION#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15356093907942508)
,p_query_column_id=>4
,p_column_alias=>'DGRM_VERSION'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5683966799037039)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2142146265493905)
,p_query_column_id=>6
,p_column_alias=>'PRIORITY'
,p_column_display_sequence=>46
,p_column_heading=>'Priority'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5684069475037040)
,p_query_column_id=>7
,p_column_alias=>'INITIALIZED_ON'
,p_column_display_sequence=>6
,p_column_heading=>'Initialized On'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5684163968037041)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATE_ON'
,p_column_display_sequence=>26
,p_column_heading=>'Last Update On'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2142255235493906)
,p_query_column_id=>9
,p_column_alias=>'DUE_ON'
,p_column_display_sequence=>16
,p_column_heading=>'Due On'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5684296657037042)
,p_query_column_id=>10
,p_column_alias=>'BUSINESS_REFERENCE'
,p_column_display_sequence=>36
,p_column_heading=>'Business Reference'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8024125104825610)
,p_plug_name=>'Instance Events'
,p_parent_plug_id=>wwv_flow_imp.id(5684323221037043)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:is-collapsed:t-Region--stacked:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495604368136880259)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29001516138505995)
,p_plug_name=>'Instance Events'
,p_region_name=>'flow-instance-events'
,p_parent_plug_id=>wwv_flow_imp.id(8024125104825610)
,p_region_template_options=>'#DEFAULT#:t-IRR-region--noBorders'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0008_INSTANCE_LOG_VW'
,p_query_where=>'lgpr_prcs_id = :P8_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P8_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Instance Events'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(13471539909181525)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'20'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>13471539909181525
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8318159619792316)
,p_db_column_name=>'LGPR_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Lgpr Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8318543391792317)
,p_db_column_name=>'LGPR_PRCS_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8318997702792318)
,p_db_column_name=>'LGPR_BUSINESS_ID'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Business Reference'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8319379673792319)
,p_db_column_name=>'LGPR_PRCS_EVENT'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Event'
,p_column_html_expression=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'instance_event_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8319757479792319)
,p_db_column_name=>'LGPR_TIMESTAMP'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8320162530792319)
,p_db_column_name=>'LGPR_USER'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8320570260792319)
,p_db_column_name=>'LGPR_COMMENT'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8321340756792320)
,p_db_column_name=>'LGPR_ERROR_INFO'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Error Stack'
,p_column_html_expression=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8320935355792320)
,p_db_column_name=>'LGPR_PRCS_EVENT_ICON'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Lgpr Prcs Event Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8028177005825650)
,p_db_column_name=>'PRETAG'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Pretag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12631588555220601)
,p_db_column_name=>'POSTTAG'
,p_display_order=>110
,p_column_identifier=>'L'
,p_column_label=>'Posttag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12632064663220606)
,p_db_column_name=>'LGPR_OBJT_ID'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Object'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(13861584261230054)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'83217'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'LGPR_USER:LGPR_TIMESTAMP:LGPR_PRCS_EVENT:LGPR_COMMENT::LGPR_PRCS_EVENT_ICON:LGPR_ERROR_INFO:PRETAG:POSTTAG:LGPR_OBJT_ID'
,p_sort_column_1=>'LGPR_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30368937979343097)
,p_plug_name=>'Tab Holder'
,p_parent_plug_id=>wwv_flow_imp.id(5684323221037043)
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_imp.id(12495575615770880223)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2570542357060505)
,p_plug_name=>'Task List Entries'
,p_region_name=>'task-list'
,p_parent_plug_id=>wwv_flow_imp.id(30368937979343097)
,p_region_css_classes=>'js-react-on-prcs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1792064716043263)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from table (',
'      flow_api_pkg.get_current_tasks',
'            ( p_context => ''SINGLE_PROCESS''',
'            , p_prcs_id => :P8_PRCS_ID ))'))
,p_optimizer_hint=>'APEX$USE_NO_GROUPING_SETS'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_ajax_items_to_submit=>'P8_PRCS_ID'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'No Tasks'
,p_show_total_row_count=>false
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(2570671262060506)
,p_region_id=>wwv_flow_imp.id(2570542357060505)
,p_layout_type=>'ROW'
,p_title_adv_formatting=>false
,p_title_column_name=>'SUBJECT'
,p_sub_title_adv_formatting=>true
,p_sub_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_badge_column_name=>'BADGE_TEXT'
,p_badge_css_classes=>'&BADGE_CSS_CLASSES.'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'TASK_ID'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(2570792162060507)
,p_card_id=>wwv_flow_imp.id(2570671262060506)
,p_action_type=>'TITLE'
,p_display_sequence=>10
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'&DETAILS_LINK_TARGET.'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(2570853105060508)
,p_card_id=>wwv_flow_imp.id(2570671262060506)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>20
,p_label=>'Approve'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_link_attributes=>'data-id="&TASK_ID."'
,p_button_display_type=>'TEXT_WITH_ICON'
,p_icon_css_classes=>'fa-check-square u-success-text'
,p_action_css_classes=>'approve'
,p_is_hot=>false
,p_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_condition_expr1=>'TASK_TYPE'
,p_condition_expr2=>'APPROVAL'
,p_exec_cond_for_each_row=>true
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(2570994574060509)
,p_card_id=>wwv_flow_imp.id(2570671262060506)
,p_action_type=>'BUTTON'
,p_position=>'SECONDARY'
,p_display_sequence=>30
,p_label=>'Reject'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_link_attributes=>'data-id="&TASK_ID."'
,p_button_display_type=>'TEXT_WITH_ICON'
,p_icon_css_classes=>'fa-times u-danger-text'
,p_action_css_classes=>'reject'
,p_is_hot=>false
,p_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_condition_expr1=>'TASK_TYPE'
,p_condition_expr2=>'APPROVAL'
,p_exec_cond_for_each_row=>true
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3509332876851706)
,p_plug_name=>'Message Subscriptions'
,p_region_name=>'message-subscriptions'
,p_parent_plug_id=>wwv_flow_imp.id(30368937979343097)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mes.msub_id,',
'       mes.msub_message_name,',
'       mes.msub_key_name,',
'       mes.msub_key_value,',
'       mes.msub_payload_var,',
'       mes.msub_created,',
'       action',
'  from flow_p0008_message_subscriptions_vw mes',
' where mes.msub_prcs_id = :P8_PRCS_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P8_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Message Subscriptions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3509425289851707)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'C##LMOREAUX'
,p_internal_uid=>3509425289851707
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3509591891851708)
,p_db_column_name=>'MSUB_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Msub Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3509620456851709)
,p_db_column_name=>'MSUB_MESSAGE_NAME'
,p_display_order=>60
,p_column_identifier=>'B'
,p_column_label=>'Message Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3509701785851710)
,p_db_column_name=>'MSUB_KEY_NAME'
,p_display_order=>70
,p_column_identifier=>'C'
,p_column_label=>'Key Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3509835519851711)
,p_db_column_name=>'MSUB_KEY_VALUE'
,p_display_order=>80
,p_column_identifier=>'D'
,p_column_label=>'Key Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3510437164851717)
,p_db_column_name=>'MSUB_PAYLOAD_VAR'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Payload Variable'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3510565399851718)
,p_db_column_name=>'MSUB_CREATED'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3510601685851719)
,p_db_column_name=>'ACTION'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Quick Action'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." aria-label="&APP_TEXT$APP_P8_RECEIVE_MESSAGE." class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" data-action="receive-message" data-message="#MSUB_MESSAGE'
||'_NAME#" data-key="#MSUB_KEY_NAME#" data-value="#MSUB_KEY_VALUE#"><span aria-hidden="true" class="t-Icon t-Icon--left fa fa-box-arrow-in-east"></span>&APP_TEXT$APP_P8_RECEIVE_MESSAGE.</button>',
''))
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3587249378535438)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'35873'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ACTION:MSUB_MESSAGE_NAME:MSUB_KEY_NAME:MSUB_KEY_VALUE:MSUB_PAYLOAD_VAR:MSUB_CREATED:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8392311025345610)
,p_plug_name=>'Variables'
,p_region_name=>'process-variables'
,p_parent_plug_id=>wwv_flow_imp.id(30368937979343097)
,p_region_css_classes=>'js-react-on-prcs'
,p_region_template_options=>'#DEFAULT#:t-IRR-region--noBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select CHECKBOX,',
'       ACTION,',
'       PROV_PRCS_ID,',
'       PROV_VAR_NAME,',
'       PROV_VAR_TYPE,',
'       PROV_SCOPE,',
'       CALLING_OBJECT,',
'       PROV_VAR_VALUE,',
'       IS_GATEWAY_ROUTE,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = prov_scope then 1 else 0',
'       end as current_scope',
'  from FLOW_P0008_VARIABLES_VW',
'where prov_prcs_id = :P8_PRCS_iD'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P8_PRCS_ID,P8_DIAGRAM_LEVEL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Variables'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(8393401240345621)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_display_row_count=>'Y'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'LMOREAUX'
,p_internal_uid=>8393401240345621
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5974128075464466)
,p_db_column_name=>'PROV_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Process ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5974553661464467)
,p_db_column_name=>'PROV_VAR_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5974908646464467)
,p_db_column_name=>'PROV_VAR_TYPE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5975357132464467)
,p_db_column_name=>'PROV_VAR_VALUE'
,p_display_order=>40
,p_column_identifier=>'H'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_static_id=>'prov_var_value'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5975755489464467)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>50
,p_column_identifier=>'I'
,p_column_label=>'<input type="checkbox" id="check-all-variables">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'variable_checkbox_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5976199322464468)
,p_db_column_name=>'ACTION'
,p_display_order=>60
,p_column_identifier=>'J'
,p_column_label=>'<button type="button" title="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="variable_header_action_menu"><span aria-hidden="'
||'true" class="t-Icon fa fa-bars"></span></button>'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_VAR_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# variable-actions-btn js-menuButton" ',
'data-menu="variable_row_action_menu"',
'data-name="#PROV_VAR_NAME#"',
'data-type="#PROV_VAR_TYPE#"',
'data-prcs="#PROV_PRCS_ID#"',
'data-scope="#PROV_SCOPE#"',
'data-gateway-route="#IS_GATEWAY_ROUTE#"',
'>',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'variable_action_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6432711704417637)
,p_db_column_name=>'IS_GATEWAY_ROUTE'
,p_display_order=>70
,p_column_identifier=>'K'
,p_column_label=>'Is Gateway Route'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55103738997434701)
,p_db_column_name=>'PROV_SCOPE'
,p_display_order=>80
,p_column_identifier=>'L'
,p_column_label=>'Scope'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55103850324434702)
,p_db_column_name=>'CALLING_OBJECT'
,p_display_order=>90
,p_column_identifier=>'M'
,p_column_label=>'Calling Object'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55108405946434748)
,p_db_column_name=>'CURRENT_CLASS'
,p_display_order=>100
,p_column_identifier=>'O'
,p_column_label=>'Current Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55108556668434749)
,p_db_column_name=>'CURRENT_SCOPE'
,p_display_order=>110
,p_column_identifier=>'P'
,p_column_label=>'Current Scope'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10983804979667357)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'59765'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKBOX:ACTION:PROV_VAR_NAME:PROV_VAR_TYPE:PROV_VAR_VALUE:PROV_SCOPE:'
,p_sort_column_1=>'CURRENT_SCOPE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
end;
/
begin
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6432353612417633)
,p_plug_name=>'Variables - Row Actions'
,p_region_name=>'variable_row_action'
,p_parent_plug_id=>wwv_flow_imp.id(8392311025345610)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(7074608790273038)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6433033616417640)
,p_plug_name=>'Variables - Header Actions'
,p_region_name=>'variable_header_action'
,p_parent_plug_id=>wwv_flow_imp.id(8392311025345610)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(7390393853616382)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166753193485966384)
,p_plug_name=>'Subflows'
,p_region_name=>'subflows'
,p_parent_plug_id=>wwv_flow_imp.id(30368937979343097)
,p_region_css_classes=>'js-react-on-prcs'
,p_region_template_options=>'#DEFAULT#:t-IRR-region--noBorders'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SBFL_ID,',
'       SBFL_PRCS_ID,',
'       SBFL_CURRENT,',
'       SBFL_STEP_KEY,',
'       SBFL_SBFL_DGRM_ID,',
'       SBFL_DIAGRAM_LEVEL,',
'       CALLING_OBJECT,',
'       SBFL_STARTING_OBJECT,',
'       SBFL_LAST_UPDATE,',
'       SBFL_STATUS,',
'       SBFL_STATUS_ICON,',
'       SBFL_PRIORITY,',
'       SBFL_DUE_ON,',
'       SBFL_TIMR_START_ON,',
'       SBFL_CURRENT_LANE,',
'       SBFL_RESERVATION,',
'       SBFL_POTENTIAL_USERS,',
'       SBFL_POTENTIAL_GROUPS,',
'       SBFL_EXCLUDED_USERS,',
'       ACTIONS,',
'       CHECKBOX,',
'       QUICK_ACTION_ICON,',
'       QUICK_ACTION_LABEL,',
'       QUICK_ACTION,',
'       TIMER_STATUS_INFO,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then ''t-Button--success''',
'       end as current_class,',
'       case when :P8_DIAGRAM_LEVEL = SBFL_DIAGRAM_LEVEL then 1 else 0',
'       end as current_level,',
'       SBFL_ITERATION_PATH',
'  from FLOW_P0008_SUBFLOWS_VW',
'where sbfl_prcs_id = :P8_PRCS_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P8_PRCS_ID,P8_DIAGRAM_LEVEL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Subflows'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(8390422207345591)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_display_row_count=>'Y'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'LMOREAUX'
,p_internal_uid=>8390422207345591
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5958060753464437)
,p_db_column_name=>'SBFL_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Subflow ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5958314416464441)
,p_db_column_name=>'SBFL_PRCS_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Process ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5958746107464441)
,p_db_column_name=>'SBFL_CURRENT'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Current'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5959198304464442)
,p_db_column_name=>'SBFL_STARTING_OBJECT'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Starting Object'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2142712189493911)
,p_db_column_name=>'SBFL_DUE_ON'
,p_display_order=>50
,p_column_identifier=>'AF'
,p_column_label=>'Due On'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5959540044464442)
,p_db_column_name=>'SBFL_LAST_UPDATE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Last Update'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2142388218493907)
,p_db_column_name=>'SBFL_PRIORITY'
,p_display_order=>70
,p_column_identifier=>'AB'
,p_column_label=>'Priority'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5959935453464442)
,p_db_column_name=>'SBFL_STATUS'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Status'
,p_column_html_expression=>'<span class="sbfl_status_badge"><i class="status_icon fa #SBFL_STATUS_ICON#"></i>#SBFL_STATUS#</span><span class="sbfl_timer_start">#TIMER_STATUS_INFO#</span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'subflow_status_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5960359099464442)
,p_db_column_name=>'SBFL_CURRENT_LANE'
,p_display_order=>90
,p_column_identifier=>'G'
,p_column_label=>'Lane'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5960748117464443)
,p_db_column_name=>'SBFL_RESERVATION'
,p_display_order=>110
,p_column_identifier=>'H'
,p_column_label=>'Reserved For'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2142460053493908)
,p_db_column_name=>'SBFL_POTENTIAL_USERS'
,p_display_order=>120
,p_column_identifier=>'AC'
,p_column_label=>'Potential Users'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2142511739493909)
,p_db_column_name=>'SBFL_POTENTIAL_GROUPS'
,p_display_order=>130
,p_column_identifier=>'AD'
,p_column_label=>'Potential Groups'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2142648848493910)
,p_db_column_name=>'SBFL_EXCLUDED_USERS'
,p_display_order=>140
,p_column_identifier=>'AE'
,p_column_label=>'Excluded Users'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5961953081464444)
,p_db_column_name=>'ACTIONS'
,p_display_order=>150
,p_column_identifier=>'K'
,p_column_label=>'<button type="button" title="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" data-menu="subflow_header_action_menu"><span aria-hidden='
||'"true" class="t-Icon fa fa-bars"></span></button>'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P8_SBFL_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon #CURRENT_CLASS# subflow-actions-btn js-menuButton" ',
'data-menu="subflow_row_action_menu"',
'data-prcs="#SBFL_PRCS_ID#"',
'data-sbfl="#SBFL_ID#"',
'data-key = "#SBFL_STEP_KEY#"',
'data-status="#SBFL_STATUS#"',
'data-reservation="#SBFL_RESERVATION#">',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'subflow_action_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5962397543464444)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>160
,p_column_identifier=>'L'
,p_column_label=>'<input type="checkbox" id="check-all-subflows">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'subflow_checkbox_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8025464938825623)
,p_db_column_name=>'QUICK_ACTION_ICON'
,p_display_order=>170
,p_column_identifier=>'N'
,p_column_label=>'Quick Action Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8025569156825624)
,p_db_column_name=>'QUICK_ACTION'
,p_display_order=>180
,p_column_identifier=>'O'
,p_column_label=>'Quick Action'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" class="t-Button t-Button--icon t-Button--link t-Button--iconLeft js-actionButton" ',
'data-prcs="#SBFL_PRCS_ID#" data-sbfl="#SBFL_ID#" data-key = "#SBFL_STEP_KEY#" data-action="#QUICK_ACTION#">',
'    <span aria-hidden="true" class="t-Icon t-Icon--left fa #QUICK_ACTION_ICON#"></span>#QUICK_ACTION_LABEL#',
'</button>'))
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'quick_action_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8025669951825625)
,p_db_column_name=>'QUICK_ACTION_LABEL'
,p_display_order=>190
,p_column_identifier=>'P'
,p_column_label=>'Quick Action Label'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7335900830307041)
,p_db_column_name=>'SBFL_STATUS_ICON'
,p_display_order=>200
,p_column_identifier=>'Q'
,p_column_label=>'Sbfl Status Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(62703712227232507)
,p_db_column_name=>'SBFL_STEP_KEY'
,p_display_order=>210
,p_column_identifier=>'R'
,p_column_label=>'Step Key'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(62707325166232543)
,p_db_column_name=>'SBFL_TIMR_START_ON'
,p_display_order=>220
,p_column_identifier=>'S'
,p_column_label=>'Timer Start On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(62707438405232544)
,p_db_column_name=>'TIMER_STATUS_INFO'
,p_display_order=>230
,p_column_identifier=>'T'
,p_column_label=>'Timer Status Info'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55104508785434709)
,p_db_column_name=>'SBFL_SBFL_DGRM_ID'
,p_display_order=>240
,p_column_identifier=>'U'
,p_column_label=>'Calling Diagram ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55104683966434710)
,p_db_column_name=>'SBFL_DIAGRAM_LEVEL'
,p_display_order=>250
,p_column_identifier=>'V'
,p_column_label=>'Level'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55104753757434711)
,p_db_column_name=>'CALLING_OBJECT'
,p_display_order=>260
,p_column_identifier=>'W'
,p_column_label=>'Calling Object'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55108288395434746)
,p_db_column_name=>'CURRENT_CLASS'
,p_display_order=>270
,p_column_identifier=>'Z'
,p_column_label=>'Current Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55108363460434747)
,p_db_column_name=>'CURRENT_LEVEL'
,p_display_order=>280
,p_column_identifier=>'AA'
,p_column_label=>'Current Level'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9074998747505001)
,p_db_column_name=>'SBFL_ITERATION_PATH'
,p_display_order=>290
,p_column_identifier=>'AG'
,p_column_label=>'Iteration Path'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(8498061205860315)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'59631'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKBOX:ACTIONS:QUICK_ACTION:SBFL_CURRENT:SBFL_ITERATION_PATH:SBFL_LAST_UPDATE:SBFL_STATUS:SBFL_CURRENT_LANE:SBFL_RESERVATION:SBFL_DIAGRAM_LEVEL:SBFL_PRIORITY:SBFL_POTENTIAL_USERS:SBFL_POTENTIAL_GROUPS:SBFL_EXCLUDED_USERS:SBFL_DUE_ON:'
,p_sort_column_1=>'CURRENT_LEVEL'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(9080997864512051)
,p_report_id=>wwv_flow_imp.id(8498061205860315)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'SBFL_STATUS'
,p_operator=>'in'
,p_expr=>'running,error,waiting for timer'
,p_condition_sql=>'"SBFL_STATUS" in (#APXWS_EXPR_VAL1#, #APXWS_EXPR_VAL2#, #APXWS_EXPR_VAL3#)'
,p_condition_display=>'#APXWS_COL_NAME# #APXWS_OP_NAME# ''running, error, waiting for timer''  '
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8367243423910488)
,p_plug_name=>'Subflows - Row Actions'
,p_region_name=>'subflow_row_action'
,p_parent_plug_id=>wwv_flow_imp.id(166753193485966384)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(2407587958394790)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8392021138345607)
,p_plug_name=>'Subflows - Header Actions'
,p_region_name=>'subflow_header_action'
,p_parent_plug_id=>wwv_flow_imp.id(166753193485966384)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(4409050172512221)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8354985158946288)
,p_plug_name=>'Add Gateway Route'
,p_region_name=>'gateway_selector'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8391710661345604)
,p_plug_name=>'Reserve Step'
,p_region_name=>'reservation_dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8394514514345632)
,p_plug_name=>'Add/Edit Process Variable'
,p_region_name=>'variable_dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13245209048329626)
,p_plug_name=>'Instance Action'
,p_region_name=>'instance_action_dialog'
,p_region_css_classes=>'f4a-dynamic-title'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13891898475964091)
,p_plug_name=>'Action Menu'
,p_region_name=>'actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(6338940478461643)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62707563129232545)
,p_plug_name=>'Reschedule Timer'
,p_region_name=>'reschedule_timer_dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6133652177393567089)
,p_plug_name=>'Flow Viewer'
,p_region_name=>'flow-monitor'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:js-showMaximizeButton:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0008_VW'
,p_query_where=>'prcs_id = :P8_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P8_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'No process selected'
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_02=>'ALL_CURRENT'
,p_attribute_03=>'PRDG_ID'
,p_attribute_04=>'ALL_COMPLETED'
,p_attribute_05=>'PRDG_PRDG_ID'
,p_attribute_06=>'ALL_ERRORS'
,p_attribute_07=>'CALLING_OBJT'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_11=>'Y'
,p_attribute_12=>'BREADCRUMB'
,p_attribute_13=>'DRILLDOWN_ALLOWED'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
,p_attribute_17=>'ITERATION_DATA'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5981427830464471)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8391710661345604)
,p_button_name=>'RESERVE_STEP'
,p_button_static_id=>'reserve-step-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reserve'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_button_cattributes=>'data-action="" data-prcs="" data-sbfl="" data-no-update="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5954728604464411)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_button_name=>'UNSELECT'
,p_button_static_id=>'unselect_btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--gapTop'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Unselect all'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5955186680464411)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_button_name=>'SELECT'
,p_button_static_id=>'select_btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--gapTop'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Select all'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5955586107464411)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_button_name=>'ADD_PROV_VAR_ROUTE'
,p_button_static_id=>'add-prov-var-route-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_icon_css_classes=>'fa-plus'
,p_button_cattributes=>'data-action="add-process-variable" data-gateway-route="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5982997862464473)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_button_name=>'ADD_PROV_VAR'
,p_button_static_id=>'add-prov-var-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_icon_css_classes=>'fa-plus'
,p_button_cattributes=>'data-action="add-process-variable" data-gateway-route="false"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5954353112464407)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_button_name=>'SAVE_PROV_VAR_ROUTE'
,p_button_static_id=>'save-prov-var-route-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_icon_css_classes=>'fa-save'
,p_button_cattributes=>'data-action="update-process-variable" data-gateway-route="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5982517441464472)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_button_name=>'SAVE_PROV_VAR'
,p_button_static_id=>'save-prov-var-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_icon_css_classes=>'fa-save'
,p_button_cattributes=>'data-action="update-process-variable" data-gateway-route="false"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6431406612417624)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5681179787037011)
,p_button_name=>'SHOW_HISTORY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Show History'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_icon_css_classes=>'fa-info-circle-o'
,p_button_cattributes=>'data-action="flow-instance-audit" data-prcs="&P8_PRCS_ID." data-name="&P8_PRCS_NAME."'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62707677337232546)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(62707563129232545)
,p_button_name=>'RESCHEDULE_TIMER'
,p_button_static_id=>'reschedule-timer-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reschedule Timer'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_button_cattributes=>'data-action="" data-prcs="" data-sbfl="" data-key=""'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3511050226851723)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3510821361851721)
,p_button_name=>'RECEIVE_MESSAGE'
,p_button_static_id=>'receive-message-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Receive Message'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_button_cattributes=>'data-action="receive-message" data-message="" data-key="" data-value=""'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5978892614464469)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5681179787037011)
,p_button_name=>'ACTION_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_button_image_alt=>'Action Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-bars'
,p_button_cattributes=>'data-menu="actions_menu" data-prcs="&P8_PRCS_ID." data-dgrm="&P8_PRCS_DGRM_ID." data-name="&P8_PRCS_NAME."'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7068041536119722)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13245209048329626)
,p_button_name=>'CONFIRM'
,p_button_static_id=>'confirm-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Confirm'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_button_cattributes=>'data-action="" data-prcs="" data-sbfl="" data-key="" data-no-update="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3511139234851724)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3510821361851721)
,p_button_name=>'CANCEL_RECEIVE_MESSAGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7067605023119721)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13245209048329626)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5963945833464455)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(166753193485966384)
,p_button_name=>'RESET_SUBFLOW_IR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:RP,8,RIR:P8_PRCS_ID:&P8_PRCS_ID.'
,p_icon_css_classes=>'fa-undo-alt'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5977760271464469)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8392311025345610)
,p_button_name=>'ADD_GATEWAY_ROUTE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Set Gateway Route'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P8_PRCS_STATUS'
,p_button_condition2=>'created:running:error'
,p_button_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_button_css_classes=>'js-hide-no-prcs js-actionButton'
,p_button_cattributes=>'data-action="add-process-variable" data-gateway-route="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5976915633464468)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8392311025345610)
,p_button_name=>'ADD_PROCESS_VARIABLE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Process Variable'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P8_PRCS_STATUS'
,p_button_condition2=>'created:running:error'
,p_button_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_button_css_classes=>'js-hide-no-prcs js-actionButton'
,p_icon_css_classes=>'fa-plus'
,p_button_cattributes=>'data-action="add-process-variable" data-gateway-route="false"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5977391209464468)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8392311025345610)
,p_button_name=>'RESET_VARIABLE_IR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:RP,8,RIR:P8_PRCS_ID:&P8_PRCS_ID.'
,p_icon_css_classes=>'fa-undo-alt'
);
end;
/
begin
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3510991975851722)
,p_name=>'P8_PAYLOAD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3510821361851721)
,p_prompt=>'Payload'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3747988967530343)
,p_name=>'P8_PROV_VAR_TSTZ'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_inline_help_text=>'Required format: YYYY-MM-DD HH24:MI:SS TZR'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3748085871530344)
,p_name=>'P8_PROV_VAR_TSTZ_VALID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5681449489037014)
,p_name=>'P8_PRCS_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_item_source_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_source=>'PRCS_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5681551841037015)
,p_name=>'P8_PRCS_DGRM_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_item_source_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_source=>'PRCS_DGRM_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5681628052037016)
,p_name=>'P8_PRCS_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_item_source_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_source=>'PRCS_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5681710279037017)
,p_name=>'P8_PRCS_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_item_source_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_source=>'PRCS_STATUS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5681806442037018)
,p_name=>'P8_PRCS_INIT_TS'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_item_source_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_source=>'PRCS_INIT_TS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5681957862037019)
,p_name=>'P8_PRCS_LAST_UPDATE'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_item_source_plug_id=>wwv_flow_imp.id(5681250057037012)
,p_source=>'PRCS_LAST_UPDATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5955943099464415)
,p_name=>'P8_SELECT_OPTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5956326391464421)
,p_name=>'P8_GATEWAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_prompt=>'Gateway'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P8_INSTANCE_GATEWAYS_LOV'
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P8_PRDG_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5956770983464421)
,p_name=>'P8_CONNECTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_prompt=>'Connection'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P8_INSTANCE_CONNECTIONS_LOV'
,p_lov_cascade_parent_items=>'P8_PRCS_ID,P8_GATEWAY'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5972826023464463)
,p_name=>'P8_SBFL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(166753193485966384)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5979272276464470)
,p_name=>'P8_DISPLAY_SETTING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6133652177393567089)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5979971726464470)
,p_name=>'P8_OBJT_LIST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6133652177393567089)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5980365397464471)
,p_name=>'P8_OBJT_BPMN_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6133652177393567089)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5980714077464471)
,p_name=>'P8_OBJT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6133652177393567089)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5981800867464472)
,p_name=>'P8_RESERVATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8391710661345604)
,p_prompt=>'Reservation'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_inline_help_text=>'If left blank, the task will be reserved for the current user (app_user).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5983384367464473)
,p_name=>'P8_PROV_VAR_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_prompt=>'Variable Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5983769209464473)
,p_name=>'P8_PROV_VAR_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_item_default=>'VARCHAR2'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Varchar2;VARCHAR2,Number;NUMBER,Date;DATE,Clob;CLOB,Timestamp With Time Zone;TIMESTAMP WITH TIME ZONE,JSON;JSON'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5984111734464474)
,p_name=>'P8_PROV_VAR_VC2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5984552376464474)
,p_name=>'P8_PROV_VAR_NUM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5984956372464474)
,p_name=>'P8_PROV_VAR_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_prompt=>'Value'
,p_format_mask=>'&APP_DATE_TIME_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5985303463464474)
,p_name=>'P8_PROV_VAR_CLOB'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6429631498417606)
,p_name=>'P8_PROV_VAR_DATE_VALID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6429967240417609)
,p_name=>'P8_PROV_VAR_NUM_VALID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7068442550119727)
,p_name=>'P8_CONFIRM_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13245209048329626)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_imp.id(12495523037429880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7068819919119733)
,p_name=>'P8_COMMENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13245209048329626)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44803138381176613)
,p_name=>'P8_LOADED_DIAGRAM'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6133652177393567089)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(55103924099434703)
,p_name=>'P8_DIAGRAM_LEVEL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6133652177393567089)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(55107419799434738)
,p_name=>'P8_PROV_SCOPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8394514514345632)
,p_item_default=>'P8_DIAGRAM_LEVEL'
,p_item_default_type=>'ITEM'
,p_prompt=>'Scope'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   iscp_valid_scope as d, ',
'   iscp_valid_scope as r',
'from flow_instance_scopes_vw',
'where iscp_prcs_id = :P8_PRCS_ID',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(55107680657434740)
,p_name=>'P8_PRDG_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8354985158946288)
,p_prompt=>'Calling Diagram'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLOW_INSTANCE_DIAGRAMS_LOV'
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P8_PRCS_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62707796384232547)
,p_name=>'P8_RESCHEDULE_TIMER_NOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(62707563129232545)
,p_item_default=>'Y'
,p_prompt=>'Reschedule timer now'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62707843061232548)
,p_name=>'P8_RESCHEDULE_TIMER_AT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(62707563129232545)
,p_prompt=>'Reschedule timer at'
,p_format_mask=>'&APP_DATE_TIME_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'+0d'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73479633336995802)
,p_name=>'P8_RESCHEDULE_TIMER_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(62707563129232545)
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5996686614464519)
,p_name=>'Subflows Report refreshed - Mark currently running'
,p_event_sequence=>140
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(166753193485966384)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5997186082464520)
,p_event_id=>wwv_flow_imp.id(5996686614464519)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var runningSelector = "button.clickable-action";',
'var processRows = apex.jQuery( "#subflows tr" );',
'',
'processRows.has( runningSelector ).addClass( "flow-running" );',
'',
'apex.jQuery(".subflow-actions-btn").each(function(){',
'  var sbflStatus = apex.jQuery(this).data("status");',
'  apex.jQuery(this).prop("disabled", sbflStatus === "running" || sbflStatus === "error" || sbflStatus === "waiting for timer" ? false : true );',
'});',
'',
'$("td[headers*=subflow_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
'',
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#subflow-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6011636562464528)
,p_name=>'Viewer Diagram Loaded'
,p_event_sequence=>160
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6133652177393567089)
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_diagram_loaded'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6012103981464528)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'initViewer($v(''P8_PRCS_ID''), $v(''P8_PRCS_NAME''), $v(''P8_DISPLAY_SETTING''));'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(44803077743176612)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_LOADED_DIAGRAM'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.diagramIdentifier'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55104290877434706)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_CALLING_DIAGRAM'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.callingDiagramIdentifier'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55104339991434707)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_CALLING_OBJT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.callingObjectId'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6006917102464525)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_OBJT_LIST'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P8_LOADED_DIAGRAM);',
'end if;'))
,p_attribute_07=>'P8_LOADED_DIAGRAM'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55104408483434708)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_DIAGRAM_LEVEL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prdg_diagram_level',
'from FLOW_INSTANCE_DIAGRAMS',
'where prdg_id = :P8_LOADED_DIAGRAM',
'and prdg_diagram_level is not null'))
,p_attribute_07=>'P8_LOADED_DIAGRAM'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55104910048434713)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8392311025345610)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55105202562434716)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(166753193485966384)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6180462025209949)
,p_event_id=>wwv_flow_imp.id(6011636562464528)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'changeCursor($v(''P8_OBJT_LIST''));'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6014453052464529)
,p_name=>'Set Connection Select Option '
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_GATEWAY'
,p_condition_element=>'P8_GATEWAY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6014962408464530)
,p_event_id=>wwv_flow_imp.id(6014453052464529)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_SELECT_OPTION'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_connection_select_option(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_attribute_07=>'P8_GATEWAY,P8_PRDG_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55107869454434742)
,p_event_id=>wwv_flow_imp.id(6014453052464529)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_PROV_SCOPE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_scope(',
'  pi_gateway => :P8_GATEWAY',
', pi_prdg_id => :P8_PRDG_ID',
')'))
,p_attribute_07=>'P8_GATEWAY,P8_PRDG_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5998415156464520)
,p_name=>'Select all connection'
,p_event_sequence=>200
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5955186680464411)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5998953651464521)
,p_event_id=>wwv_flow_imp.id(5998415156464520)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = true;',
'});'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5999457497464521)
,p_event_id=>wwv_flow_imp.id(5998415156464520)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5955186680464411)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5999918515464521)
,p_event_id=>wwv_flow_imp.id(5998415156464520)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5954728604464411)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6000312821464522)
,p_name=>'Unselect all connection'
,p_event_sequence=>210
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5954728604464411)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6000816148464522)
,p_event_id=>wwv_flow_imp.id(6000312821464522)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P8_CONNECTION").find(''input[type="checkbox"]'').toArray().forEach(function(e) {',
'  e.checked = false;',
'});'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6001349512464522)
,p_event_id=>wwv_flow_imp.id(6000312821464522)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5954728604464411)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6001834654464522)
,p_event_id=>wwv_flow_imp.id(6000312821464522)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5955186680464411)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6002207343464522)
,p_name=>'Display Button Based on Gateway Type'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_SELECT_OPTION'
,p_condition_element=>'P8_SELECT_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'multi'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6002775114464523)
,p_event_id=>wwv_flow_imp.id(6002207343464522)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5955186680464411)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6003299003464523)
,p_event_id=>wwv_flow_imp.id(6002207343464522)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5955186680464411)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6004548451464524)
,p_name=>'Element clicked'
,p_event_sequence=>240
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6133652177393567089)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'clickCondition($v(''P8_OBJT_LIST''), this.data);'
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_element_click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6005591668464524)
,p_event_id=>wwv_flow_imp.id(6004548451464524)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_OBJT_BPMN_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.element.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6006044910464525)
,p_event_id=>wwv_flow_imp.id(6004548451464524)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_OBJT_NAME'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P8_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P8_OBJT_BPMN_ID',
'  , p_prdg_id => :P8_LOADED_DIAGRAM',
');',
'end if;'))
,p_attribute_07=>'P8_OBJT_BPMN_ID,P8_LOADED_DIAGRAM'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6005023363464524)
,p_event_id=>wwv_flow_imp.id(6004548451464524)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'openObjectDialog($v(''P8_OBJT_BPMN_ID''), $v(''P8_OBJT_NAME''),8);'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6007809031464526)
,p_name=>'On Change Display Setting'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_DISPLAY_SETTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6008377992464526)
,p_event_id=>wwv_flow_imp.id(6007809031464526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_viewport(:P8_DISPLAY_SETTING);',
''))
,p_attribute_02=>'P8_DISPLAY_SETTING'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6008810667464526)
,p_event_id=>wwv_flow_imp.id(6007809031464526)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(166753193485966384)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6016280779464530)
,p_name=>'Change check-all-subflows'
,p_event_sequence=>280
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#check-all-subflows'
,p_bind_type=>'live'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6016777800464530)
,p_event_id=>wwv_flow_imp.id(6016280779464530)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#subflows #check-all-subflows'' ).is('':checked'') ) {',
'      $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',true);',
'     } else {',
'     $(''#subflows input[type=checkbox][name=f02]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6432898825417638)
,p_name=>'Change check-all-variables'
,p_event_sequence=>290
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#check-all-variables'
,p_bind_type=>'live'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6432965813417639)
,p_event_id=>wwv_flow_imp.id(6432898825417638)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#process-variables #check-all-variables'' ).is('':checked'') ) {',
'      $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',true);',
'     } else {',
'     $(''#process-variables input[type=checkbox][name=f03]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6017148201464531)
,p_name=>'On Change Variable Type'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_PROV_VAR_TYPE'
,p_condition_element=>'P8_PROV_VAR_TYPE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6017642167464531)
,p_event_id=>wwv_flow_imp.id(6017148201464531)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var varType = apex.item("P8_PROV_VAR_TYPE").getValue();',
'apex.item("P8_PROV_VAR_VC2").hide();',
'apex.item("P8_PROV_VAR_NUM").hide();',
'apex.item("P8_PROV_VAR_DATE").hide();',
'apex.item("P8_PROV_VAR_TSTZ").hide();',
'apex.item("P8_PROV_VAR_CLOB").hide();',
'switch(varType) {',
'    case "VARCHAR2" : ',
'        apex.item("P8_PROV_VAR_VC2").show();',
'        break;',
'    case "NUMBER":',
'        apex.item("P8_PROV_VAR_NUM").show();',
'        break;',
'    case "DATE":',
'        apex.item("P8_PROV_VAR_DATE").show();',
'        break;',
'    case "TIMESTAMP WITH TIME ZONE":',
'        apex.item("P8_PROV_VAR_TSTZ").show();',
'        break;',
'    case "CLOB":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;',
'    case "JSON":',
'        apex.item("P8_PROV_VAR_CLOB").show();',
'        break;    ',
'    default:',
'        break;',
'}',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6027025508464536)
,p_name=>'Variables Report Refreshed'
,p_event_sequence=>310
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(8392311025345610)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6027533621464536)
,p_event_id=>wwv_flow_imp.id(6027025508464536)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("th.a-IRR-header").each(function(i){',
'    if ( apex.jQuery(this).attr("id") === undefined) {',
'      apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'      apex.jQuery(this).find(''button#variables_ir-header-action'').hide();',
'    } else {',
'      apex.jQuery(this).addClass("u-alignMiddle");',
'    }',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6429724013417607)
,p_name=>'On change Prov Var Date Value'
,p_event_sequence=>320
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_PROV_VAR_DATE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430356385417613)
,p_event_id=>wwv_flow_imp.id(6429724013417607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982997862464473)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430410242417614)
,p_event_id=>wwv_flow_imp.id(6429724013417607)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982517441464472)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6429852264417608)
,p_event_id=>wwv_flow_imp.id(6429724013417607)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_PROV_VAR_DATE_VALID'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_date(',
'  pi_value => :P8_PROV_VAR_DATE',
', pi_format_mask => :APP_DATE_TIME_FORMAT',
')'))
,p_attribute_07=>'P8_PROV_VAR_DATE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430710216417617)
,p_event_id=>wwv_flow_imp.id(6429724013417607)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982997862464473)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430596040417615)
,p_event_id=>wwv_flow_imp.id(6429724013417607)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982517441464472)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6430047364417610)
,p_name=>'On Change Prov Var Num Value'
,p_event_sequence=>330
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_PROV_VAR_NUM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430812751417618)
,p_event_id=>wwv_flow_imp.id(6430047364417610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982997862464473)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430913570417619)
,p_event_id=>wwv_flow_imp.id(6430047364417610)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982517441464472)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6430261684417612)
,p_event_id=>wwv_flow_imp.id(6430047364417610)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_PROV_VAR_NUM_VALID'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_number(',
'  pi_value => :P8_PROV_VAR_NUM',
')'))
,p_attribute_07=>'P8_PROV_VAR_NUM'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6431062033417620)
,p_event_id=>wwv_flow_imp.id(6430047364417610)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982997862464473)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6431104642417621)
,p_event_id=>wwv_flow_imp.id(6430047364417610)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982517441464472)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6433167803417641)
,p_name=>'Click on Cancel Dialog'
,p_event_sequence=>340
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7067605023119721)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6433270075417642)
,p_event_id=>wwv_flow_imp.id(6433167803417641)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(13245209048329626)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8324051646815474)
,p_name=>'Instances Events Report Refreshed'
,p_event_sequence=>350
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(29001516138505995)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8324491461815477)
,p_event_id=>wwv_flow_imp.id(8324051646815474)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62707920017232549)
,p_name=>'Change Set Now'
,p_event_sequence=>360
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_RESCHEDULE_TIMER_NOW'
,p_condition_element=>'P8_RESCHEDULE_TIMER_NOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62708058684232550)
,p_event_id=>wwv_flow_imp.id(62707920017232549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_RESCHEDULE_TIMER_AT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(73479552347995801)
,p_event_id=>wwv_flow_imp.id(62707920017232549)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_RESCHEDULE_TIMER_AT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3511206012851725)
,p_name=>'Cancel Receive Message'
,p_event_sequence=>370
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3511139234851724)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3511347587851726)
,p_event_id=>wwv_flow_imp.id(3511206012851725)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3510821361851721)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3748125304530345)
,p_name=>'On Change Prob Var Timestamp With Time Zone Value'
,p_event_sequence=>380
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_PROV_VAR_TSTZ'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3748214983530346)
,p_event_id=>wwv_flow_imp.id(3748125304530345)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982997862464473)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3748394460530347)
,p_event_id=>wwv_flow_imp.id(3748125304530345)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982517441464472)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3748406279530348)
,p_event_id=>wwv_flow_imp.id(3748125304530345)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P8_PROV_VAR_TSTZ_VALID'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.check_is_tstz(',
'  pi_value => :P8_PROV_VAR_TSTZ',
', pi_format_mask => flow_constants_pkg.gc_prov_default_tstz_format',
')'))
,p_attribute_07=>'P8_PROV_VAR_TSTZ'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3748529700530349)
,p_event_id=>wwv_flow_imp.id(3748125304530345)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982997862464473)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3748626209530350)
,p_event_id=>wwv_flow_imp.id(3748125304530345)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5982517441464472)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3509125998851704)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Donwload Instance Summary'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_engine_app_api.download_instance_summary(',
'        pi_prcs_id => :P8_PRCS_ID',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'INSTANCE_SUMMARY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3510761242851720)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Step Timers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    flow_api_pkg.step_timers;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'STEP_TIMERS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5987781654464507)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Viewport for BPMN-Viewer'
,p_process_sql_clob=>'flow_engine_app_api.add_viewport_script(''P8_DISPLAY_SETTING'');'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5681318530037013)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(5681250057037012)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Flow Instance Detail'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5987345331464507)
,p_process_sequence=>30
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_url_p13(',
'  pi_prcs_id => :P8_PRCS_ID ',
', pi_prdg_id => :P8_LOADED_DIAGRAM',
', pi_objt_id => apex_application.g_x01',
', pi_title => apex_application.g_x02',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5986975396464506)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_VARIABLE'
,p_process_sql_clob=>'flow_engine_app_api.pass_variable;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_imp_page.create_page(
 p_id=>9
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration'
,p_alias=>'CONFIGURATION'
,p_step_title=>'Configuration'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'06'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3286177375239502)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(3291351989268379)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495537187789880157)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17585395174953770)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8026807639825637)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_settings(',
'  pi_logging_language => :P9_LOGGING_LANGUAGE',
', pi_logging_level => :P9_LOGGING_LEVEL',
', pi_logging_hide_userid => :P9_LOGGING_HIDE_USERID',
', pi_engine_app_mode => :P9_ENGINE_APP_MODE',
', pi_duplicate_step_prevention => :P9_DUPLICATE_STEP_PREVENTION',
', pi_default_workspace    => :P9_DEFAULT_WORKSPACE',
', pi_default_email_sender => :P9_DEFAULT_EMAIL_SENDER ',
', pi_default_application  => :P9_DEFAULT_APPLICATION ',
', pi_default_pageid       => :P9_DEFAULT_PAGEID   ',
', pi_default_username     => :P9_DEFAULT_USERNAME',
', pi_timer_max_cycles     => :P9_TIMER_MAX_CYCLES',
', pi_timer_status         => :P9_TIMER_STATUS',
', pi_timer_repeat_interval=> :P9_TIMER_REPEAT_INTERVAL',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_imp_page.create_page(
 p_id=>10
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Flow Monitor'
,p_alias=>'FLOW-MONITOR'
,p_step_title=>'Flow Monitor - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'initPage10();'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Adjust width of IRR Settings to be auto */',
'.a-IRR-controls-cell--label {',
'    width: auto;',
'}'))
,p_step_template=>wwv_flow_imp.id(12495618547053880299)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241009095530'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6177850959209923)
,p_plug_name=>'Instance Action'
,p_region_name=>'instance_action_dialog'
,p_region_css_classes=>'f4a-dynamic-title'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(12495608896288880263)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7938158412499704)
,p_plug_name=>'Action Menu'
,p_region_name=>'actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(7946860874526805)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34403200187171418)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6127698437330102702)
,p_plug_name=>'Flow Viewer'
,p_region_name=>'flow-monitor'
,p_region_css_classes=>'js-react-on-prcs'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:js-showMaximizeButton:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0010_VW'
,p_query_where=>'prcs_id = :P10_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P10_PRCS_ID,P10_PRCS_NAME'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'No process selected'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( config ) {',
'    config.allowDownload = false;',
'    return config;',
'}'))
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_02=>'ALL_CURRENT'
,p_attribute_03=>'PRDG_ID'
,p_attribute_04=>'ALL_COMPLETED'
,p_attribute_05=>'PRDG_PRDG_ID'
,p_attribute_06=>'ALL_ERRORS'
,p_attribute_07=>'CALLING_OBJT'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_11=>'Y'
,p_attribute_12=>'BREADCRUMB'
,p_attribute_13=>'DRILLDOWN_ALLOWED'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
,p_attribute_17=>'ITERATION_DATA'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12493545854579486121)
,p_plug_name=>'Flow Instances'
,p_region_name=>'flow-instances'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRCS_DGRM_ID,',
'       PRCS_DGRM_NAME,',
'       PRCS_DGRM_VERSION,',
'       PRCS_DGRM_STATUS,',
'       PRCS_DGRM_CATEGORY,',
'       PRCS_STATUS,',
'       PRCS_DGRM_STATUS_ICON,',
'       PRCS_STATUS_ICON,',
'       PRCS_INIT_DATE,',
'       PRCS_LAST_UPDATE,',
'       PRCS_BUSINESS_REF,',
'       BTN,',
'       CHECKBOX,',
'       QUICK_ACTION',
'  from FLOW_P0010_INSTANCES_VW',
'  where :P10_FILTER_DGRM_ID is null',
'  or (',
'      :P10_FILTER_DGRM_ID is not null',
'      and prcs_id in (',
'          select prdg.prdg_prcs_id ',
'          from flow_instance_diagrams prdg ',
'          where prdg.prdg_dgrm_id = :P10_FILTER_DGRM_ID',
'      )',
'  )'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P10_FILTER_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Flow Instances'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(26094211779304629)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'1000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_display_row_count=>'Y'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'FLOWS4APEX'
,p_internal_uid=>26094211779304629
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094452210304631)
,p_db_column_name=>'PRCS_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'javascript:void(0);'
,p_column_linktext=>'#PRCS_NAME#'
,p_column_link_attr=>'title="&APP_TEXT$APP_VIEW." class="view-link" data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#"'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'PRCS_NAME'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094567431304632)
,p_db_column_name=>'PRCS_DGRM_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Model Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094640100304633)
,p_db_column_name=>'PRCS_DGRM_VERSION'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Model Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094739199304634)
,p_db_column_name=>'PRCS_DGRM_STATUS'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Model Status'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="ffa-dgrm-badge">',
'    <i class="#PRCS_DGRM_STATUS_ICON#"></i>',
'    <span class="ffa-dgrm-badge-text">#PRCS_DGRM_STATUS#</span>',
'</div>'))
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094816603304635)
,p_db_column_name=>'PRCS_DGRM_CATEGORY'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Model Category'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094928056304636)
,p_db_column_name=>'PRCS_STATUS'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Status'
,p_column_html_expression=>'<span class="prcs_status_badge"><i class="status_icon fa #PRCS_STATUS_ICON#"></i>#PRCS_STATUS#</span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'instance_status_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26095045075304637)
,p_db_column_name=>'PRCS_INIT_DATE'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Creation Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&APP_DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26095177493304638)
,p_db_column_name=>'PRCS_LAST_UPDATE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Last Update'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&APP_DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26095284298304639)
,p_db_column_name=>'BTN'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'<button type="button" title="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_HEADER_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon js-menuButton" id="instance-header-action" data-menu="instance_header_action_men'
||'u"><span aria-hidden="true" class="t-Icon fa fa-bars"></span></button>'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." aria-label="&APP_TEXT$APP_P10_ROW_BUTTON_TITLE." class="t-Button t-Button--noLabel t-Button--icon flow-instance-actions-btn js-menuButton" ',
'        data-menu="instance_row_action_menu"',
'        data-prcs="#PRCS_ID#"',
'        data-status="#PRCS_STATUS#"',
'        data-name="#PRCS_NAME#"',
'        data-dgrm="#PRCS_DGRM_ID#"',
'        >',
'    <span aria-hidden="true" class="t-Icon fa fa-bars"></span>',
'</button>'))
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'instance_action_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26094328735304630)
,p_db_column_name=>'PRCS_ID'
,p_display_order=>110
,p_column_identifier=>'A'
,p_column_label=>'Process ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34631054458575812)
,p_db_column_name=>'PRCS_BUSINESS_REF'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Business Reference'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7938514653499708)
,p_db_column_name=>'PRCS_DGRM_ID'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Prcs Dgrm Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40002069571317110)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'<input type="checkbox" id="check-all-instances">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'instance_checkbox_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6176739527209912)
,p_db_column_name=>'PRCS_STATUS_ICON'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'Prcs Status Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8024079343825609)
,p_db_column_name=>'QUICK_ACTION'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Quick Action'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" title="&APP_TEXT$APP_P10_ACTION_DETAILS." aria-label="&APP_TEXT$APP_P10_ACTION_DETAILS." class="t-Button t-Button--icon t-Button--iconLeft t-Button--link js-actionButton"',
'data-prcs="#PRCS_ID#" data-name="#PRCS_NAME#" data-action="open-flow-instance-details">',
'<span aria-hidden="true" class="t-Icon t-Icon--left fa fa-search"></span>&APP_TEXT$APP_P10_ACTION_DETAILS.</button>'))
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_static_id=>'quick_action_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15357984541942527)
,p_db_column_name=>'PRCS_DGRM_STATUS_ICON'
,p_display_order=>180
,p_column_identifier=>'R'
,p_column_label=>'Prcs Dgrm Status Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(26608389028834346)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'266084'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'CHECKBOX:BTN:QUICK_ACTION:PRCS_NAME:PRCS_BUSINESS_REF:PRCS_DGRM_CATEGORY:PRCS_DGRM_NAME:PRCS_DGRM_VERSION:PRCS_STATUS:PRCS_INIT_DATE:PRCS_LAST_UPDATE:PRCS_DGRM_STATUS_ICON'
,p_sort_column_1=>'PRCS_DGRM_CATEGORY'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PRCS_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'PRCS_DGRM_VERSION'
,p_sort_direction_3=>'DESC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'PRCS_DGRM_CATEGORY:0:0:0:0:0'
,p_break_enabled_on=>'0:0:0:0:0:PRCS_DGRM_CATEGORY'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2436340351881201)
,p_plug_name=>'Instances - Header Actions'
,p_region_name=>'instance_header_action'
,p_parent_plug_id=>wwv_flow_imp.id(12493545854579486121)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(2431522092873048)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40001946826317109)
,p_plug_name=>'Instances - Row Actions'
,p_region_name=>'instance_row_action'
,p_parent_plug_id=>wwv_flow_imp.id(12493545854579486121)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(40423692118997018)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(12495525309455880143)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12491866636991262848)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34403200187171418)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--mobileHideLabel:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create instance'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RP,11::'
,p_icon_css_classes=>'fa-plus'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6178284555209927)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6177850959209923)
,p_button_name=>'CONFIRM'
,p_button_static_id=>'confirm-btn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Confirm'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton'
,p_button_cattributes=>'data-action="" data-prcs="" data-sbfl="" data-no-update="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7937992279499702)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34403200187171418)
,p_button_name=>'ACTION_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495522463331880131)
,p_button_image_alt=>'Action Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-bars'
,p_button_cattributes=>'data-menu="actions_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6179972139209944)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6177850959209923)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34569800907098125)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(12493545854579486121)
,p_button_name=>'RESET_INSTANCE_IR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:RP,10,RIR::'
,p_icon_css_classes=>'fa-undo-alt'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2448762581538242)
,p_name=>'P10_OBJT_BPMN_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6127698437330102702)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2448870230538243)
,p_name=>'P10_OBJT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6127698437330102702)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5522035116864941)
,p_name=>'P10_OBJT_LIST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6127698437330102702)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6177972762209924)
,p_name=>'P10_COMMENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6177850959209923)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6179426398209939)
,p_name=>'P10_CONFIRM_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6177850959209923)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_imp.id(12495523037429880132)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7334592520307027)
,p_name=>'P10_PRCS_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12493545854579486121)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34634208559575844)
,p_name=>'P10_DISPLAY_SETTING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(34403200187171418)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42701880150211103)
,p_name=>'P10_LOADED_DIAGRAM'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6127698437330102702)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63516095778355425)
,p_name=>'P10_FILTER_DGRM_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12493545854579486121)
,p_prompt=>'Model'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DIAGRAMS_INSTANCIATED_LOV'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#:margin-left-none:margin-right-none'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12491864731021262829)
,p_name=>'P10_PRCS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12493545854579486121)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(160797771746501981)
,p_name=>'Create Process Dialog closed - refresh Instances'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(12491866636991262848)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(33737253943406143)
,p_event_id=>wwv_flow_imp.id(160797771746501981)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_PRCS_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P11_PRCS_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6433779174417647)
,p_event_id=>wwv_flow_imp.id(160797771746501981)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_PRCS_NAME'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P11_PRCS_NAME'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(160797694678501980)
,p_event_id=>wwv_flow_imp.id(160797771746501981)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(12493545854579486121)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8023336794825602)
,p_event_id=>wwv_flow_imp.id(160797771746501981)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6127698437330102702)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29602959246125302)
,p_event_id=>wwv_flow_imp.id(160797771746501981)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25020236512509606)
,p_name=>'Create Process Dialog (Report) closed - refresh Instances'
,p_event_sequence=>110
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(12493545854579486121)
,p_bind_type=>'live'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(33737390268406144)
,p_event_id=>wwv_flow_imp.id(25020236512509606)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_PRCS_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P11_PRCS_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25020304399509607)
,p_event_id=>wwv_flow_imp.id(25020236512509606)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(12493545854579486121)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(33737098416406141)
,p_event_id=>wwv_flow_imp.id(25020236512509606)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(apex.lang.getMessage("APP_INSTANCE_CREATED"));'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(24414763832878706)
,p_name=>'Instances Report Refreshed'
,p_event_sequence=>150
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(12493545854579486121)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(24414806355878707)
,p_event_id=>wwv_flow_imp.id(24414763832878706)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6127698437330102702)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var prcsId= apex.item( "P10_PRCS_ID" ).getValue();',
'if (prcsId !== "" ) { ',
'  markAsCurrent( prcsId ); ',
'}',
'',
'if ($("th.a-IRR-header--group").length > 0) {',
'    $("th.a-IRR-header").each(function(i){',
'        if ( apex.jQuery(this).attr("id") === undefined) {',
'          apex.jQuery(this).find(''input[type="checkbox"]'').hide();',
'          apex.jQuery(this).find(''button#instance-header-action'').hide();',
'        } else {',
'          apex.jQuery(this).addClass("u-alignMiddle");',
'        }',
'    });',
'}',
'',
'$("td[headers*=instance_status_col]").each(function() {',
'    var className = ''ffa-color--'' + $(this).text();',
'    $(this).addClass(className);',
'  }',
');',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(24417684477878735)
,p_name=>'Viewer Diagram Loaded'
,p_event_sequence=>160
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6127698437330102702)
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_diagram_loaded'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(33736700260406138)
,p_event_id=>wwv_flow_imp.id(24417684477878735)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'initViewer($v(''P10_PRCS_ID''), $v(''P10_PRCS_NAME''), $v(''P10_DISPLAY_SETTING''));'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(42701983528211104)
,p_event_id=>wwv_flow_imp.id(24417684477878735)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_LOADED_DIAGRAM'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.diagramIdentifier'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5522598629864946)
,p_event_id=>wwv_flow_imp.id(24417684477878735)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_OBJT_LIST'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P10_LOADED_DIAGRAM);',
'end if;'))
,p_attribute_07=>'P10_LOADED_DIAGRAM'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5522653812864947)
,p_event_id=>wwv_flow_imp.id(24417684477878735)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'changeCursor($v(''P10_OBJT_LIST''));'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5522150485864942)
,p_name=>'Element clicked'
,p_event_sequence=>240
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6127698437330102702)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'clickCondition($v(''P10_OBJT_LIST''), this.data);'
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_element_click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2448959260538244)
,p_event_id=>wwv_flow_imp.id(5522150485864942)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_OBJT_BPMN_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.element.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2449082180538245)
,p_event_id=>wwv_flow_imp.id(5522150485864942)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P10_OBJT_NAME'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P10_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P10_OBJT_BPMN_ID',
'  , p_prdg_id => :P10_LOADED_DIAGRAM',
');',
'end if;'))
,p_attribute_07=>'P10_OBJT_BPMN_ID,P10_LOADED_DIAGRAM'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5522263817864943)
,p_event_id=>wwv_flow_imp.id(5522150485864942)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'openObjectDialog($v(''P10_OBJT_BPMN_ID''), $v(''P10_OBJT_NAME''), 10);'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34634407162575846)
,p_name=>'On Change Display Setting'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P10_DISPLAY_SETTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34634644617575848)
,p_event_id=>wwv_flow_imp.id(34634407162575846)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'flow_engine_app_api.set_viewport(:P10_DISPLAY_SETTING);'
,p_attribute_02=>'P10_DISPLAY_SETTING'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4300450048764256)
,p_name=>'Change check-all-instances'
,p_event_sequence=>270
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#check-all-instances'
,p_bind_type=>'live'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4300813188764310)
,p_event_id=>wwv_flow_imp.id(4300450048764256)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($(''#flow-instances #check-all-instances'' ).is('':checked'') ) {',
'      $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',true);',
'     } else {',
'     $(''#flow-instances input[type=checkbox][name=f01]'').prop(''checked'',false);',
' } '))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6180087025209945)
,p_name=>'Cancel Dialog'
,p_event_sequence=>290
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6179972139209944)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6180129920209946)
,p_event_id=>wwv_flow_imp.id(6180087025209945)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6177850959209923)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8023857502825607)
,p_name=>'Click on Flow Name'
,p_event_sequence=>300
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.view-link'
,p_bind_type=>'live'
,p_bind_delegate_to_selector=>'#flow-instances'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8023966198825608)
,p_event_id=>wwv_flow_imp.id(8023857502825607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.actions.invoke("view-flow-instance", "", this.triggeringElement);'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(63516126981355426)
,p_name=>'On change Model'
,p_event_sequence=>310
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P10_FILTER_DGRM_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(63516252784355427)
,p_event_id=>wwv_flow_imp.id(63516126981355426)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(12493545854579486121)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33735382808406124)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Viewport for BPMN-Viewer'
,p_process_sql_clob=>'flow_engine_app_api.add_viewport_script(''P10_DISPLAY_SETTING'');'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5522324613864944)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_url_p13(',
'  pi_prcs_id => :P10_PRCS_ID',
', pi_prdg_id => :P10_LOADED_DIAGRAM',
', pi_objt_id => apex_application.g_x01',
', pi_title => apex_application.g_x02',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_imp_page.create_page(
 p_id=>11
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Create Flow Instance'
,p_alias=>'CREATE_FLOW_INSTANCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Flow Instance - &APP_NAME_TITLE.'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#PopupLov_11_P11_DGRM_ID_dlg").parent(".ui-dialog").on( "dialogopen", function( event, ui ) {',
'    console.log(event);',
'    console.log(ui);',
'} );'))
,p_step_template=>wwv_flow_imp.id(12495624331342880306)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'N'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10603847781745438)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495606500823880260)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12491866042341262842)
,p_plug_name=>'Create Flow Instance'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--textContent:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12491865858754262840)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10603847781745438)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--mobileHideLabel:t-Button--iconLeft:t-Button--padTop'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'TEMPLATE_DEFAULT'
,p_icon_css_classes=>'fa-plus'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6433507492417645)
,p_name=>'P11_PRCS_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12491866042341262842)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34631117879575813)
,p_name=>'P11_BUSINESS_REF'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12491866042341262842)
,p_prompt=>'Business Reference (Process Variable)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12491865492429262836)
,p_name=>'P11_PRCS_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12491866042341262842)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12491865909625262841)
,p_name=>'P11_DGRM_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12491866042341262842)
,p_prompt=>'Model'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DIAGRAMS_PARSED_LOV'
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(options) {',
'    console.log(options);',
'    var col, columns = options.columns;',
'    ',
'    //options.minWidth = 600;',
'',
'    col = columns.DGRM_NAME;',
'    col.noStretch = false;',
'',
'    col = columns.DGRM_STATUS;',
'    col.width = 100;',
'    col.noStretch = true;',
'    ',
'    col = columns.DGRM_VERSION;',
'    col.width = 100;',
'    col.noStretch = true;',
'    ',
'    options.persistState = false;',
'',
'    ',
'    return options;',
'}'))
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12491865217503262834)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CREATE_INSTANCE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_prcs_id flow_processes.prcs_id%type;',
'begin',
'    l_prcs_id := flow_engine_app_api.create_instance(',
'                     pi_dgrm_id => :P11_DGRM_ID',
'                   , pi_prcs_name => :P11_PRCS_NAME',
'                   , pi_business_ref => :P11_BUSINESS_REF',
'                 );',
'    :P11_PRCS_ID := l_prcs_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160797930317501982)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P11_PRCS_ID,P11_PRCS_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'&APP_TEXT$APP_INSTANCE_CREATED.'
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_imp_page.create_page(
 p_id=>12
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Viewer'
,p_alias=>'VIEWER'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Flow Monitor - &APP_NAME_TITLE.'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#:ui-dialog--stretch:t-Dialog--noPadding'
,p_page_component_map=>'17'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240930064036'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6161598858353963900)
,p_plug_name=>'Flow Monitor (&P12_PRCS_NAME.)'
,p_region_name=>'flow-monitor'
,p_region_css_classes=>'js-react-on-prcs'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_INSTANCE_DETAILS_VW'
,p_query_where=>'prcs_id = :P12_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P12_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_02=>'ALL_CURRENT'
,p_attribute_03=>'PRDG_ID'
,p_attribute_04=>'ALL_COMPLETED'
,p_attribute_05=>'PRDG_PRDG_ID'
,p_attribute_06=>'ALL_ERRORS'
,p_attribute_07=>'CALLING_OBJT'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_11=>'Y'
,p_attribute_12=>'BREADCRUMB'
,p_attribute_13=>'DRILLDOWN_ALLOWED'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7334819132307030)
,p_name=>'P12_OBJT_LIST'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6161598858353963900)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7335361967307035)
,p_name=>'P12_OBJT_BPMN_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6161598858353963900)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7335483836307036)
,p_name=>'P12_OBJT_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6161598858353963900)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33735715098406128)
,p_name=>'P12_PRCS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6161598858353963900)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33737496021406145)
,p_name=>'P12_PRCS_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6161598858353963900)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44803255576176614)
,p_name=>'P12_LOADED_DIAGRAM'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6161598858353963900)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(33737563010406146)
,p_computation_sequence=>10
,p_computation_item=>'P12_PRCS_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_prcs_name(',
'  pi_prcs_id => :P12_PRCS_ID',
')'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8049983261140649)
,p_name=>'Viewer Diagram Loaded'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6161598858353963900)
,p_condition_element=>'P12_PRCS_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_diagram_loaded'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(44803326871176615)
,p_event_id=>wwv_flow_imp.id(8049983261140649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P12_LOADED_DIAGRAM'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.diagramIdentifier'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8051357622140676)
,p_event_id=>wwv_flow_imp.id(8049983261140649)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P12_OBJT_LIST'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_list(p_prdg_id => :P12_LOADED_DIAGRAM);',
'end if;'))
,p_attribute_07=>'P12_LOADED_DIAGRAM'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8051867682140677)
,p_event_id=>wwv_flow_imp.id(8049983261140649)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'changeCursor($v(''P12_OBJT_LIST''));'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8052795498141983)
,p_name=>'Element clicked'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6161598858353963900)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'clickCondition($v(''P12_OBJT_LIST''), this.data);'
,p_bind_type=>'bind'
,p_bind_event_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION|REGION TYPE|mtbv_element_click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8053641230141984)
,p_event_id=>wwv_flow_imp.id(8052795498141983)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P12_OBJT_BPMN_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.data.element.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8054174771141984)
,p_event_id=>wwv_flow_imp.id(8052795498141983)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P12_OBJT_NAME'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P12_LOADED_DIAGRAM is not null then',
'return flow_engine_app_api.get_objt_name(',
'    p_objt_bpmn_id => :P12_OBJT_BPMN_ID',
'  , p_prdg_id => :P12_LOADED_DIAGRAM',
');',
'end if;'))
,p_attribute_07=>'P12_OBJT_BPMN_ID,P12_LOADED_DIAGRAM'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8053186121141984)
,p_event_id=>wwv_flow_imp.id(8052795498141983)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'openObjectDialog($v(''P12_OBJT_BPMN_ID''), $v(''P12_OBJT_NAME''), 12);'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7335772142307039)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.get_url_p13(',
'  pi_prcs_id => :P12_PRCS_ID',
', pi_prdg_id => :P12_LOADED_DIAGRAM',
', pi_objt_id => apex_application.g_x01',
', pi_title => apex_application.g_x02',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_imp_page.create_page(
 p_id=>13
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Object Details'
,p_alias=>'OBJECT-DETAILS'
,p_page_mode=>'MODAL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APP_IMAGES#lib/prismjs/js/prism.js'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.util.getTopApex().jQuery(".f4a-dynamic-title .ui-dialog-content").dialog("option", "title", $v("P13_TITLE"));',
'',
'apex.jQuery("#last-error-alert").find("pre.language-log").parent().prev().addClass("ffa-highlight-label");',
'apex.jQuery("#attibutes-cr").find("pre.language-plsql").parent().prev().addClass("ffa-highlight-label");'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Remove border around Instance Details alert region */',
'.t-Alert.remove-alert-border { border: none;}',
'',
'/* Make active tab in Instance Events bold */',
'.is-active .t-Tabs-link {',
'    font-weight: 700;',
'}'))
,p_page_template_options=>'#DEFAULT#:t-Dialog--noPadding'
,p_dialog_width=>'70%'
,p_dialog_css_classes=>'f4a-dynamic-title'
,p_page_component_map=>'18'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12635446510220640)
,p_plug_name=>'Tabs Holder'
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_imp.id(12495575615770880223)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2444768214538202)
,p_plug_name=>'Variable History'
,p_parent_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--textContent:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_VARIABLE_LOG_VW'
,p_query_where=>'lgvr_prcs_id = :P13_PRCS_ID and lgvr_objt_id = :P13_OBJT_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_DGRM_ID,P13_OBJT_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P13_PRCS_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Variable History'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5519619992437209)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'The variable history is empty.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>5519619992437209
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519751631437210)
,p_db_column_name=>'LGVR_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Lgvr Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519852365437211)
,p_db_column_name=>'LGVR_OBJT_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Lgvr Objt Id'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519982605437212)
,p_db_column_name=>'LGVR_VAR_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5520039666437213)
,p_db_column_name=>'LGVR_EXPR_SET'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Execution'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5520162288437214)
,p_db_column_name=>'LGVR_TIMESTAMP'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5520261763437215)
,p_db_column_name=>'LGVR_VAR_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Data Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5520341426437216)
,p_db_column_name=>'LGVR_VALUE'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5578279062735662)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'55783'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'LGVR_EXPR_SET:LGVR_VAR_NAME:LGVR_VAR_TYPE:LGVR_VALUE:LGVR_TIMESTAMP:'
,p_sort_column_1=>'LGVR_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11504924392020455)
,p_plug_name=>'&P13_VAR_TAB_NAME.'
,p_parent_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--textContent:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_EXPRESSIONS_VW'
,p_query_where=>'objt_bpmn_id = :P13_OBJT_ID and objt_dgrm_id = :P13_DGRM_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_OBJT_ID,P13_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&P13_VAR_TAB_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(16967786479177907)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No variable expressions found.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>16967786479177907
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16967924181177909)
,p_db_column_name=>'EXPR_SET'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Execution'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(15901843917364053)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968036863177910)
,p_db_column_name=>'EXPR_VAR_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968146627177911)
,p_db_column_name=>'EXPR_VAR_TYPE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Data Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968285150177912)
,p_db_column_name=>'EXPR_TYPE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Expression Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(15214828485777501)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968337862177913)
,p_db_column_name=>'EXPR_EXPRESSION'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Expression'
,p_column_html_expression=>'#PRETAG##EXPR_EXPRESSION##POSTTAG#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968441007177914)
,p_db_column_name=>'OBJT_DGRM_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Diagram'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968566434177915)
,p_db_column_name=>'PRETAG'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Pretag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16968656354177916)
,p_db_column_name=>'POSTTAG'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Posttag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(17022295850637761)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'170223'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'EXPR_SET:EXPR_VAR_NAME:EXPR_VAR_TYPE:EXPR_TYPE:EXPR_EXPRESSION:OBJT_DGRM_ID:PRETAG:POSTTAG'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12632550341220611)
,p_plug_name=>'Step Errors'
,p_region_name=>'instance-log'
,p_parent_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--textContent:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_INSTANCE_LOG_VW'
,p_query_where=>'lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_PRCS_ID,P13_OBJT_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P13_PRCS_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Step Errors'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(12632654932220612)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'The step error history is empty.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'LMOREAUX'
,p_internal_uid=>12632654932220612
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12633913021220625)
,p_db_column_name=>'LGPR_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Process ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634089221220626)
,p_db_column_name=>'LGPR_OBJT_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Object'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634112364220627)
,p_db_column_name=>'LGPR_PRCS_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Instance Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634221363220628)
,p_db_column_name=>'LGPR_BUSINESS_ID'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Business Reference'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634312423220629)
,p_db_column_name=>'LGPR_PRCS_EVENT'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Event'
,p_column_html_expression=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'instance_event_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634464623220630)
,p_db_column_name=>'LGPR_PRCS_EVENT_ICON'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Lgpr Prcs Event Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634561735220631)
,p_db_column_name=>'LGPR_TIMESTAMP'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634624072220632)
,p_db_column_name=>'LGPR_USER'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634757568220633)
,p_db_column_name=>'LGPR_COMMENT'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634874560220634)
,p_db_column_name=>'LGPR_ERROR_INFO'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Error Stack'
,p_column_html_expression=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12634921498220635)
,p_db_column_name=>'PRETAG'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Pretag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12635022832220636)
,p_db_column_name=>'POSTTAG'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Posttag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15205577267584527)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'152056'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'LGPR_USER:LGPR_TIMESTAMP:LGPR_PRCS_EVENT:LGPR_COMMENT:LGPR_ERROR_INFO:'
,p_sort_column_1=>'LGPR_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16213590277416087)
,p_plug_name=>'Called Diagram'
,p_region_name=>'runtime-ca-cr'
,p_parent_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_CALLED_DIAGRAMS_VW'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'prdg_prdg_id = :P13_PRDG_ID',
'and prdg_calling_dgrm = :P13_DGRM_ID',
'and prdg_calling_objt = :P13_OBJT_ID'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_PRDG_ID,P13_DGRM_ID,P13_OBJT_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   1',
'from flow_instance_diagrams prdg',
'join flow_diagrams dgrm ',
'  on dgrm.dgrm_id = prdg.prdg_dgrm_id',
'join flow_objects objt ',
'  on objt.objt_bpmn_id = prdg.prdg_calling_objt',
'  and objt.objt_dgrm_id = prdg.prdg_calling_dgrm',
'where prdg.prdg_prdg_id = :P13_PRDG_ID',
'and prdg.prdg_calling_dgrm = :P13_DGRM_ID',
'and prdg.prdg_calling_objt = :P13_OBJT_ID',
'and objt.objt_tag_name = ''bpmn:callActivity'''))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Called Diagram'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(60861002375537208)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'LMOREAUX'
,p_internal_uid=>60861002375537208
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861128182537209)
,p_db_column_name=>'PRDG_DIAGRAM_LEVEL'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861297901537210)
,p_db_column_name=>'DGRM_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861339168537211)
,p_db_column_name=>'DGRM_VERSION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861474746537212)
,p_db_column_name=>'DGRM_STATUS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861543233537213)
,p_db_column_name=>'SCOPE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Scope'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861857847537216)
,p_db_column_name=>'PRDG_PRDG_ID'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Prdg Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60861933808537217)
,p_db_column_name=>'PRDG_CALLING_DGRM'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Calling Diagram'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60862034420537218)
,p_db_column_name=>'PRDG_CALLING_OBJT'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Prdg Calling Objt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(61816521543045737)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'618166'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DGRM_NAME:DGRM_VERSION:DGRM_STATUS:PRDG_DIAGRAM_LEVEL:SCOPE::PRDG_PRDG_ID:PRDG_CALLING_DGRM:PRDG_CALLING_OBJT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16967621768177906)
,p_plug_name=>'Step Events'
,p_parent_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--textContent:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P13_PRCS_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16212173591416073)
,p_plug_name=>'Completed Subflows'
,p_parent_plug_id=>wwv_flow_imp.id(16967621768177906)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--textContent:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_STEP_LOG_VW'
,p_query_where=>'lgsf_prcs_id = :P13_PRCS_ID and lgsf_objt_id = :P13_OBJT_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_PRCS_ID,P13_OBJT_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Completed Subflows'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2497980793177024)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No completed subflows found.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>2497980793177024
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499725670177042)
,p_db_column_name=>'LGSF_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>'Lgsf Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499855288177043)
,p_db_column_name=>'LGSF_OBJT_ID'
,p_display_order=>20
,p_column_identifier=>'I'
,p_column_label=>'Lgsf Objt Id'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498080603177025)
,p_db_column_name=>'LGSF_SBFL_ID'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Subflow'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498104800177026)
,p_db_column_name=>'LGSF_SBFL_PROCESS_LEVEL'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'Process Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499950017177044)
,p_db_column_name=>'LGSF_LAST_COMPLETED'
,p_display_order=>50
,p_column_identifier=>'J'
,p_column_label=>'Last Completed'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2500043890177045)
,p_db_column_name=>'LGSF_STATUS_WHEN_COMPLETE'
,p_display_order=>60
,p_column_identifier=>'K'
,p_column_label=>'Status When Complete'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498307868177028)
,p_db_column_name=>'LGSF_WAS_CURRENT'
,p_display_order=>90
,p_column_identifier=>'D'
,p_column_label=>'Became Current'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498470720177029)
,p_db_column_name=>'LGSF_STARTED'
,p_display_order=>100
,p_column_identifier=>'E'
,p_column_label=>'Work Started'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498574679177030)
,p_db_column_name=>'LGSF_COMPLETED'
,p_display_order=>110
,p_column_identifier=>'F'
,p_column_label=>'Completed'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2500227841177047)
,p_db_column_name=>'LGSF_RESERVATION'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Reservation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498234451177027)
,p_db_column_name=>'LGSF_USER'
,p_display_order=>130
,p_column_identifier=>'C'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498623112177031)
,p_db_column_name=>'LGSF_COMMENT'
,p_display_order=>140
,p_column_identifier=>'G'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5121788220250659)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'51218'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LGSF_SBFL_ID:LGSF_SBFL_PROCESS_LEVEL:LGSF_USER:LGSF_WAS_CURRENT:LGSF_STARTED:LGSF_COMPLETED:LGSF_COMMENT'
,p_sort_column_1=>'LGSF_COMPLETED'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23845375832515291)
,p_plug_name=>'Current Subflows'
,p_parent_plug_id=>wwv_flow_imp.id(16967621768177906)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--textContent:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_SUBFLOWS_VW'
,p_query_where=>'sbfl_prcs_id = :P13_PRCS_ID and sbfl_current = :P13_OBJT_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_PRCS_ID,P13_OBJT_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Current Subflows'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2497368023177018)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No current subflows found.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>2497368023177018
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2498769981177032)
,p_db_column_name=>'SBFL_ID'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Subflow'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
end;
/
begin
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5151886864389209)
,p_db_column_name=>'SBFL_PRCS_ID'
,p_display_order=>70
,p_column_identifier=>'P'
,p_column_label=>'Sbfl Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2497514462177020)
,p_db_column_name=>'SBFL_PROCESS_LEVEL'
,p_display_order=>80
,p_column_identifier=>'B'
,p_column_label=>'Process Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499246622177037)
,p_db_column_name=>'SBFL_LAST_COMPLETED'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Last Completed'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499312713177038)
,p_db_column_name=>'SBFL_CURRENT'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Current'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499485991177039)
,p_db_column_name=>'SBFL_STATUS'
,p_display_order=>110
,p_column_identifier=>'M'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2497666535177021)
,p_db_column_name=>'SBFL_BECAME_CURRENT'
,p_display_order=>120
,p_column_identifier=>'C'
,p_column_label=>'Became Current'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2497713489177022)
,p_db_column_name=>'SBFL_WORK_STARTED'
,p_display_order=>130
,p_column_identifier=>'D'
,p_column_label=>'Work Started'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2499658547177041)
,p_db_column_name=>'SBFL_RESERVATION'
,p_display_order=>140
,p_column_identifier=>'O'
,p_column_label=>'Reservation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2497849830177023)
,p_db_column_name=>'SBFL_LAST_UPDATE'
,p_display_order=>150
,p_column_identifier=>'E'
,p_column_label=>'Last Update'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(62703949642232509)
,p_db_column_name=>'SBFL_STEP_KEY'
,p_display_order=>160
,p_column_identifier=>'Q'
,p_column_label=>'Step Key'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5132231896296558)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'51323'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'SBFL_ID:SBFL_STEP_KEY:SBFL_PROCESS_LEVEL:SBFL_BECAME_CURRENT:SBFL_WORK_STARTED:SBFL_LAST_UPDATE:'
,p_sort_column_1=>'SBFL_LAST_UPDATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(55105327231434717)
,p_plug_name=>'Attributes'
,p_region_name=>'attributes-ir'
,p_parent_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0013_ATTRIBUTES_VW'
,p_query_where=>'dgrm_id = :P13_DGRM_ID and bpmn_id = :P13_OBJT_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P13_OBJT_ID,P13_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Attributes'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(55107181775434735)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No attributes found.'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'LMOREAUX'
,p_internal_uid=>55107181775434735
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(55107985121434743)
,p_db_column_name=>'JSON_ATTRIBUTES'
,p_display_order=>10
,p_column_identifier=>'B'
,p_column_label=>'Json Attributes'
,p_column_html_expression=>'<pre><code class="language-json">#JSON_ATTRIBUTES#</code></pre>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'CLOB'
,p_static_id=>'JSON'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60862183787537219)
,p_db_column_name=>'DGRM_ID'
,p_display_order=>20
,p_column_identifier=>'E'
,p_column_label=>'Dgrm Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(60862209443537220)
,p_db_column_name=>'BPMN_ID'
,p_display_order=>30
,p_column_identifier=>'F'
,p_column_label=>'Bpmn Id'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(57429429784782883)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'574295'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'JSON_ATTRIBUTES:OBJT_OBJT_DGRM_ID:BPMN_ID'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(12635705433220643)
,p_name=>'Last Error'
,p_region_name=>'last-error-alert'
,p_template=>wwv_flow_imp.id(12495613507239880288)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'remove-alert-border'
,p_icon_css_classes=>'fa-exclamation-circle-o'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--danger:margin-top-none:margin-bottom-none'
,p_component_template_options=>'#DEFAULT#:t-AVPList--leftAligned:t-Report--hideNoPagination'
,p_display_point=>'REGION_POSITION_01'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LGPR_TIMESTAMP,',
'       LGPR_USER,',
'       LGPR_COMMENT,',
'       LGPR_ERROR_INFO,',
'       PRETAG,',
'       POSTTAG',
'  from FLOW_P0013_INSTANCE_LOG_VW',
' where lgpr_prcs_id = :P13_PRCS_ID and lgpr_objt_id = :P13_OBJT_ID    ',
' order by lgpr_timestamp desc',
' fetch first 1 rows only'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.has_error(',
'  pi_prcs_id => :P13_PRCS_ID',
', pi_objt_id => :P13_OBJT_ID',
')'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495548550946880181)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12636412647220650)
,p_query_column_id=>1
,p_column_alias=>'LGPR_TIMESTAMP'
,p_column_display_sequence=>2
,p_column_heading=>'Timestamp'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15355370045942501)
,p_query_column_id=>2
,p_column_alias=>'LGPR_USER'
,p_column_display_sequence=>1
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15355453502942502)
,p_query_column_id=>3
,p_column_alias=>'LGPR_COMMENT'
,p_column_display_sequence=>3
,p_column_heading=>'Comment'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15355565536942503)
,p_query_column_id=>4
,p_column_alias=>'LGPR_ERROR_INFO'
,p_column_display_sequence=>4
,p_column_heading=>'Error Stack'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15355677768942504)
,p_query_column_id=>5
,p_column_alias=>'PRETAG'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15355730359942505)
,p_query_column_id=>6
,p_column_alias=>'POSTTAG'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104199777320970)
,p_name=>'P13_DGRM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104565818320974)
,p_name=>'P13_OBJT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104945910320975)
,p_name=>'P13_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16967195584177901)
,p_name=>'P13_PRCS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(55108658269434750)
,p_name=>'P13_PRDG_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(12635446510220640)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60861623457537214)
,p_name=>'P13_VAR_TAB_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11504924392020455)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(60861703352537215)
,p_computation_sequence=>10
,p_computation_item=>'P13_VAR_TAB_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_objt_tag_name flow_objects.objt_tag_name%type;',
'    l_tab_name varchar2(100);',
'begin',
'    select objt.objt_tag_name',
'    into l_objt_tag_name',
'    from flow_diagrams dgrm',
'    join flow_objects objt ',
'       on objt.objt_dgrm_id = dgrm.dgrm_id',
'    where dgrm.dgrm_id = :P13_DGRM_ID',
'    and objt.objt_bpmn_id = :P13_OBJT_ID;',
'    ',
'    if l_objt_tag_name = ''bpmn:callActivity'' then',
'        l_tab_name := apex_lang.message(''APP_TAB_IN_OUT_MAPPING'');',
'    else',
'        l_tab_name := apex_lang.message(''APP_TAB_VAR_EXP'');',
'    end if;',
'    return l_tab_name;',
'exception when no_data_found then',
'    return apex_lang.message(''APP_TAB_VAR_EXP'');',
'end;',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15209155775614352)
,p_name=>'Instances Report Refreshed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(12632550341220611)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15209592603614397)
,p_event_id=>wwv_flow_imp.id(15209155775614352)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15357032894942518)
,p_name=>'Variable Expressions Report Refreshed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(11504924392020455)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15357188013942519)
,p_event_id=>wwv_flow_imp.id(15357032894942518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'Prism.highlightAll();'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_imp_page.create_page(
 p_id=>14
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Logs'
,p_alias=>'LOGS'
,p_page_mode=>'MODAL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APP_IMAGES#lib/prismjs/js/prism.js'
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(".f4a-dynamic-title .ui-dialog-content").dialog("option", "title", $v("P14_TITLE"));'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Make active tab in Instance Events bold */',
'.is-active .t-Tabs-link {',
'    font-weight: 700;',
'}'))
,p_page_template_options=>'#DEFAULT#:t-Dialog--noPadding'
,p_dialog_width=>'70%'
,p_dialog_css_classes=>'f4a-dynamic-title'
,p_page_component_map=>'18'
,p_last_updated_by=>'FLOWS4APEX'
,p_last_upd_yyyymmddhh24miss=>'20211126143202'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16968778051177917)
,p_plug_name=>'Tabs Holder'
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_imp.id(12495575615770880223)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2447308339538228)
,p_plug_name=>'Completed Steps'
,p_parent_plug_id=>wwv_flow_imp.id(16968778051177917)
,p_region_template_options=>'#DEFAULT#:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0014_STEP_LOG_VW'
,p_query_where=>'lgsf_prcs_id = :P14_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P14_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Completed Steps'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5155579215389246)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No completed steps found.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>5155579215389246
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155663147389247)
,p_db_column_name=>'LGSF_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Lgsf Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155719517389248)
,p_db_column_name=>'COMPLETED_OBJECT'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Step'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155819906389249)
,p_db_column_name=>'LGSF_SBFL_ID'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Subflow'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155989994389250)
,p_db_column_name=>'LGSF_SBFL_PROCESS_LEVEL'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Process Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5518828206437201)
,p_db_column_name=>'LGSF_LAST_COMPLETED'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Last Completed'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5518927623437202)
,p_db_column_name=>'LGSF_STATUS_WHEN_COMPLETE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Status When Complete'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519010082437203)
,p_db_column_name=>'LGSF_WAS_CURRENT'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Became Current'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519121253437204)
,p_db_column_name=>'LGSF_STARTED'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Work Started'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519206569437205)
,p_db_column_name=>'LGSF_COMPLETED'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Completed'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519340927437206)
,p_db_column_name=>'LGSF_RESERVATION'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Reservation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519468528437207)
,p_db_column_name=>'LGSF_USER'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5519571677437208)
,p_db_column_name=>'LGSF_COMMENT'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5545078108437780)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'55451'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LGSF_SBFL_ID:LGSF_SBFL_PROCESS_LEVEL:COMPLETED_OBJECT:LGSF_WAS_CURRENT:LGSF_STARTED:LGSF_COMPLETED:LGSF_USER:LGSF_COMMENT:'
,p_sort_column_1=>'LGSF_COMPLETED'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7332140854307003)
,p_plug_name=>'Variable History'
,p_parent_plug_id=>wwv_flow_imp.id(16968778051177917)
,p_region_template_options=>'#DEFAULT#:margin-bottom-none'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0014_VARIABLE_LOG_VW'
,p_query_where=>'lgvr_prcs_id = :P14_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P14_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Variable History'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(7332204855307004)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'The variable history is empty.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>7332204855307004
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333560161307017)
,p_db_column_name=>'LGVR_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Lgvr Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333692011307018)
,p_db_column_name=>'LGVR_SBFL_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Subflow'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333781214307019)
,p_db_column_name=>'LGVR_OBJT_ID'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Step'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333803701307020)
,p_db_column_name=>'LGVR_VAR_NAME'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333938342307021)
,p_db_column_name=>'LGVR_EXPR_SET'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Execution'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7334095231307022)
,p_db_column_name=>'LGVR_TIMESTAMP'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7334155877307023)
,p_db_column_name=>'LGVR_VAR_TYPE'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Data Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7334292029307024)
,p_db_column_name=>'LGVR_VALUE'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(7637495741285560)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'76375'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'LGVR_SBFL_ID:LGVR_OBJT_ID:LGVR_EXPR_SET:LGVR_VAR_NAME:LGVR_VAR_TYPE:LGVR_VALUE:LGVR_TIMESTAMP:'
,p_sort_column_1=>'LGVR_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16453181626752830)
,p_plug_name=>'Current Steps'
,p_parent_plug_id=>wwv_flow_imp.id(16968778051177917)
,p_region_template_options=>'#DEFAULT#:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0014_SUBFLOWS_VW'
,p_query_where=>'sbfl_prcs_id = :P14_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P14_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Current Steps'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5154410837389235)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No current steps found.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>5154410837389235
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154592436389236)
,p_db_column_name=>'SBFL_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Subflow'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154601391389237)
,p_db_column_name=>'SBFL_PRCS_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Sbfl Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154732961389238)
,p_db_column_name=>'SBFL_PROCESS_LEVEL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Process Level'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154803602389239)
,p_db_column_name=>'SBFL_LAST_COMPLETED'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Last Completed'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154978160389240)
,p_db_column_name=>'CURRENT_OBJECT'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Step'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155010144389241)
,p_db_column_name=>'SBFL_STATUS'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155119332389242)
,p_db_column_name=>'SBFL_BECAME_CURRENT'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Became Current'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155200599389243)
,p_db_column_name=>'SBFL_WORK_STARTED'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Work Started'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155393549389244)
,p_db_column_name=>'SBFL_RESERVATION'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Reservation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5155440068389245)
,p_db_column_name=>'SBFL_LAST_UPDATE'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Last Update'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(62704084243232510)
,p_db_column_name=>'SBFL_STEP_KEY'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Step Key'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5544387693437777)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'55444'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'SBFL_ID:SBFL_STEP_KEY:SBFL_PROCESS_LEVEL:CURRENT_OBJECT:SBFL_BECAME_CURRENT:SBFL_WORK_STARTED:SBFL_LAST_UPDATE:'
,p_sort_column_1=>'SBFL_LAST_UPDATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20683667255713697)
,p_plug_name=>'Instance Events'
,p_parent_plug_id=>wwv_flow_imp.id(16968778051177917)
,p_region_template_options=>'#DEFAULT#:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0014_INSTANCE_LOG_VW'
,p_query_where=>'lgpr_prcs_id = :P14_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P14_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Instance Events'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5153691026389227)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'The instance event history is empty.'
,p_max_rows_per_page=>'10'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAMTHOR'
,p_internal_uid=>5153691026389227
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5153710452389228)
,p_db_column_name=>'LGPR_PRCS_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Lgpr Prcs Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12632277733220608)
,p_db_column_name=>'LGPR_OBJT_ID'
,p_display_order=>20
,p_column_identifier=>'M'
,p_column_label=>'Object'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5153860078389229)
,p_db_column_name=>'LGPR_PRCS_NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5153901442389230)
,p_db_column_name=>'LGPR_BUSINESS_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Business Reference'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154065346389231)
,p_db_column_name=>'LGPR_PRCS_EVENT'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Event'
,p_column_html_expression=>'<span class="prcs_event_badge"><i class="status_icon fa #LGPR_PRCS_EVENT_ICON#"></i>#LGPR_PRCS_EVENT#</span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_static_id=>'instance_event_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154181074389232)
,p_db_column_name=>'LGPR_TIMESTAMP'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154237026389233)
,p_db_column_name=>'LGPR_USER'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5154394973389234)
,p_db_column_name=>'LGPR_COMMENT'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6177795465209922)
,p_db_column_name=>'LGPR_ERROR_INFO'
,p_display_order=>90
,p_column_identifier=>'J'
,p_column_label=>'Error Stack'
,p_column_html_expression=>'#PRETAG##LGPR_ERROR_INFO##POSTTAG#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6176982328209914)
,p_db_column_name=>'LGPR_PRCS_EVENT_ICON'
,p_display_order=>100
,p_column_identifier=>'I'
,p_column_label=>'Lgpr Prcs Event Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8027944385825648)
,p_db_column_name=>'PRETAG'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Pretag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8028057953825649)
,p_db_column_name=>'POSTTAG'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Posttag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5543735378437756)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'55438'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>20
,p_report_columns=>'LGPR_USER:LGPR_TIMESTAMP:LGPR_PRCS_EVENT:LGPR_COMMENT::LGPR_PRCS_EVENT_ICON:LGPR_ERROR_INFO:PRETAG:POSTTAG:LGPR_OBJT_ID'
,p_sort_column_1=>'LGPR_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5152076251389211)
,p_name=>'P14_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(16968778051177917)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7129192978323670)
,p_name=>'P14_PRCS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(16968778051177917)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5520422670437217)
,p_name=>'Instances Report Refreshed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(20683667255713697)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5520525401437218)
,p_event_id=>wwv_flow_imp.id(5520422670437217)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("td[headers*=instance_event_col]").each(function() {',
'  var text = $( this ).text();',
'  if ( text == "created" || text == "reset" || text == "restart step") {',
'    $( this ).addClass( "ffa-color--created" );',
'  } else if ( text == "completed" ) {',
'    $( this ).addClass( "ffa-color--completed" );',
'  } else if ( text == "started" || text == "running" ) {',
'    $( this ).addClass( "ffa-color--running" );',
'  } else if ( text == "terminated" ) {',
'    $( this ).addClass( "ffa-color--terminated" );',
'  } else if ( text == "error" ) {',
'    $( this ).addClass( "ffa-color--error" );',
'  }',
'});',
'',
'Prism.highlightAll();'))
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_imp_page.create_page(
 p_id=>15
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Daily Statistics'
,p_alias=>'DAILY-STATISTICS'
,p_step_title=>'Daily Statistics'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'04'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2541571424137177)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2542117955137179)
,p_plug_name=>'Processes Started On &P15_DATE.'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stpr_dgrm_id, dgrm.dgrm_name "flow name", stpr_created created, stpr_started started, stpr_error error, stpr_completed completed, stpr_terminated terminated, stpr_reset reset',
'  from flow_instance_stats stpr',
'  join flow_diagrams dgrm',
'    on dgrm.dgrm_id = stpr.stpr_dgrm_id',
' where stpr_period = ''DAY''',
'   and stpr_period_start  = to_date(:P15_DATE,''YYYY-MM-DD'')',
' order by stpr_started desc'))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P15_DATE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2542556204137179)
,p_region_id=>wwv_flow_imp.id(2542117955137179)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_title=>'Instances'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2544212410137182)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_seq=>10
,p_name=>'Created'
,p_max_row_count=>20
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'CREATED'
,p_items_label_column_name=>'flow name'
,p_color=>'#D9B13B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2142905983493913)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_seq=>20
,p_name=>'Started'
,p_max_row_count=>20
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STARTED'
,p_items_label_column_name=>'flow name'
,p_color=>'#6AAD42'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143009590493914)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_seq=>30
,p_name=>'Errors'
,p_max_row_count=>20
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ERROR'
,p_items_label_column_name=>'flow name'
,p_color=>'#D2433B'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143160145493915)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_seq=>40
,p_name=>'Completed'
,p_max_row_count=>20
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'COMPLETED'
,p_items_label_column_name=>'flow name'
,p_color=>'#8C9EB0'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143222807493916)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_seq=>50
,p_name=>'Terminated'
,p_max_row_count=>20
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'TERMINATED'
,p_items_label_column_name=>'flow name'
,p_color=>'#D76A27'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143393414493917)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_seq=>60
,p_name=>'Reset'
,p_max_row_count=>20
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'RESET'
,p_items_label_column_name=>'flow name'
,p_color=>'#C7C7CC'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2543039883137181)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>true
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2543649056137182)
,p_chart_id=>wwv_flow_imp.id(2542556204137179)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2142839389493912)
,p_name=>'P15_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2542117955137179)
,p_prompt=>'Date'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_imp_page.create_page(
 p_id=>16
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Process Statistics'
,p_alias=>'PROCESS-STATISTICS'
,p_step_title=>'Process Statistics'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'04'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2143958569493923)
,p_plug_name=>'Process Performance (Period Summaries)'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
' with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'--        , approx_percentile (0.10 )',
'--               within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'--        , approx_percentile (0.50 )',
'--               within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'--        , approx_percentile (0.90 )',
'--               within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'--        , max (lgpr_duration) duration_Max_ivl',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P16_DGRM_ID'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2144034250493924)
,p_region_id=>wwv_flow_imp.id(2143958569493923)
,p_chart_type=>'combo'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'on'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2144120727493925)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_seq=>10
,p_name=>'Instances Started'
,p_location=>'REGION_SOURCE'
,p_series_type=>'bar'
,p_items_value_column_name=>'STPR_STARTED'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#D9B13B'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2144430910493928)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_seq=>20
,p_name=>'Instances Completed'
,p_location=>'REGION_SOURCE'
,p_series_type=>'bar'
,p_items_value_column_name=>'STPR_COMPLETED'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#8C9EB0'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_stack_category=>'completions'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2144581361493929)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_seq=>30
,p_name=>'Instances Terminated'
,p_location=>'REGION_SOURCE'
,p_series_type=>'bar'
,p_items_value_column_name=>'STPR_TERMINATED'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#D76A27'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_stack_category=>'completions'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2144612523493930)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_seq=>40
,p_name=>'Instances Errors'
,p_location=>'REGION_SOURCE'
,p_series_type=>'bar'
,p_items_value_column_name=>'STPR_ERROR'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#D2433B'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_stack_category=>'completions'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2144795267493931)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_seq=>50
,p_name=>'Median Duration'
,p_location=>'REGION_SOURCE'
,p_series_type=>'line'
,p_items_value_column_name=>'STPR_DURATION_50PC_SEC'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#000000'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2144947294493933)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_seq=>60
,p_name=>'90pc Duration'
,p_location=>'REGION_SOURCE'
,p_series_type=>'line'
,p_items_value_column_name=>'STPR_DURATION_90PC_SEC'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF3B30'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2144270836493926)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2144335477493927)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_title=>'Instances'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2144842592493932)
,p_chart_id=>wwv_flow_imp.id(2144034250493924)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_title=>'sec'
,p_format_scaling=>'auto'
,p_scaling=>'log'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2549667804373355)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2550204271373356)
,p_plug_name=>'Task Step Performance (current month) - &P16_DGRM_NAME_VERSION. (dgrm_id : &P16_DGRM_ID. )'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'' label',
'     , objt.objt_name name',
'     , stsf_objt_bpmn_id',
'     , sum(stsf_completed)',
'     , avg(stsf_duration_10pc_sec)',
'     , avg(stsf_duration_50pc_sec)',
'     , avg(stsf_duration_90pc_sec)',
'     , max(stsf_duration_max_sec)',
'from  flow_step_stats stsf',
'left join flow_objects objt',
'  on objt.objt_dgrm_id = stsf.stsf_dgrm_id',
' and objt.objt_bpmn_id = stsf.stsf_objt_bpmn_id',
'where stsf_period_start >= sysdate - :P16_period',
'and stsf_period = ''DAY''',
'and stsf_dgrm_id = :P16_DGRM_ID',
'group by stsf_objt_bpmn_id||'' (''||stsf_tag_name || '')'', objt.objt_name, stsf_objt_bpmn_id',
'order by max(stsf_duration_max_sec) desc'))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P16_DGRM_ID,P16_PERIOD'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2550693860373356)
,p_region_id=>wwv_flow_imp.id(2550204271373356)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_indicator_size=>1
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2552379943373356)
,p_chart_id=>wwv_flow_imp.id(2550693860373356)
,p_seq=>10
,p_name=>'10 Percentile'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'AVG(STSF_DURATION_10PC_SEC)'
,p_group_short_desc_column_name=>'LABEL'
,p_items_label_column_name=>'NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_DGRM_ID,P17_OBJT_BPMN_ID,P17_OBJT_NAME:&P16_DGRM_ID.,&STSF_OBJT_BPMN_ID.,&NAME.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143658369493920)
,p_chart_id=>wwv_flow_imp.id(2550693860373356)
,p_seq=>20
,p_name=>'50 Percentile'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'AVG(STSF_DURATION_50PC_SEC)'
,p_group_short_desc_column_name=>'LABEL'
,p_items_label_column_name=>'NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_DGRM_ID,P17_OBJT_BPMN_ID,P17_OBJT_NAME:&P16_DGRM_ID.,&STSF_OBJT_BPMN_ID.,&NAME.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143732834493921)
,p_chart_id=>wwv_flow_imp.id(2550693860373356)
,p_seq=>30
,p_name=>'90 Percentile'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'AVG(STSF_DURATION_90PC_SEC)'
,p_group_short_desc_column_name=>'LABEL'
,p_items_label_column_name=>'NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_DGRM_ID,P17_OBJT_BPMN_ID,P17_OBJT_NAME:&P16_DGRM_ID.,&STSF_OBJT_BPMN_ID.,&NAME.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2143869603493922)
,p_chart_id=>wwv_flow_imp.id(2550693860373356)
,p_seq=>40
,p_name=>'Max'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'MAX(STSF_DURATION_MAX_SEC)'
,p_group_short_desc_column_name=>'LABEL'
,p_items_label_column_name=>'NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_DGRM_ID,P17_OBJT_BPMN_ID,P17_OBJT_NAME:&P16_DGRM_ID.,&STSF_OBJT_BPMN_ID.,&NAME.'
,p_link_target_type=>'REDIRECT_PAGE'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2551102899373356)
,p_chart_id=>wwv_flow_imp.id(2550693860373356)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>true
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2551732940373356)
,p_chart_id=>wwv_flow_imp.id(2550693860373356)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2143450803493918)
,p_name=>'P16_DGRM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2550204271373356)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2143539142493919)
,p_name=>'P16_DGRM_NAME_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2550204271373356)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_imp_page.create_page(
 p_id=>17
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Task Statistics'
,p_alias=>'TASK-STATISTICS'
,p_step_title=>'Task Statistics'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'04'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2146022401493944)
,p_plug_name=>'Historic Step Waiting Times for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')|| '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM "MTD"'')|| '' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')|| '' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')|| '' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P17_DGRM_ID,P17_OBJT_BPMN_ID'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2146135245493945)
,p_region_id=>wwv_flow_imp.id(2146022401493944)
,p_chart_type=>'bar'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2146229575493946)
,p_chart_id=>wwv_flow_imp.id(2146135245493945)
,p_seq=>10
,p_name=>'Waiting-Max'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_MAX_SEC'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF2D55'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2146557171493949)
,p_chart_id=>wwv_flow_imp.id(2146135245493945)
,p_seq=>20
,p_name=>'Waiting-90pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_90PC_SEC'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF9500'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2146692991493950)
,p_chart_id=>wwv_flow_imp.id(2146135245493945)
,p_seq=>30
,p_name=>'Waiting-50pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_50PC_SEC'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#000000'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2570196315060501)
,p_chart_id=>wwv_flow_imp.id(2146135245493945)
,p_seq=>40
,p_name=>'Waiting-10pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_10PC_SEC'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#C7C7CC'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2146340173493947)
,p_chart_id=>wwv_flow_imp.id(2146135245493945)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2146498314493948)
,p_chart_id=>wwv_flow_imp.id(2146135245493945)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2561368308878606)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2561999301878606)
,p_plug_name=>'Historic Step Performance for &P17_OBJT_NAME. ( &P17_OBJT_BPMN_ID. )'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select trunc(sysdate,''MM'') dt, ''MTD'' as period, 9 sort_order',
'    from dual',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')  || '' DAY''',
'          when ''MTD''     then to_char(dt,''YYYY-MM'')||'' MTD''',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')||'' MONTH''',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')||'' QUARTER''',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P17_DGRM_ID,P17_OBJT_BPMN_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(2562347006878607)
,p_region_id=>wwv_flow_imp.id(2561999301878606)
,p_chart_type=>'lineWithArea'
,p_height=>'400'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2564030625878607)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>10
,p_name=>'Duration-Max'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_DURATION_MAX_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF2D55'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145050239493934)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>20
,p_name=>'Duration-90pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_DURATION_90PC_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF9500'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145180896493935)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>30
,p_name=>'Duration-10pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_DURATION_10PC_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#C7C7CC'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145203533493936)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>40
,p_name=>'Duration-50pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_DURATION_50PC_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#000000'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145388121493937)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>50
,p_name=>'Waiting-Max'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_MAX_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF2D55'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145474164493938)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>60
,p_name=>'Waiting-90pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_90PC_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#FF9500'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145521870493939)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>70
,p_name=>'Waiting-50pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_50PC_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#000000'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(2145684188493940)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_seq=>80
,p_name=>'Waiting-10pc'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'STSF_WAITING_10PC_SEC'
,p_group_short_desc_column_name=>'PERIOD'
,p_items_label_column_name=>'PERIODLABEL'
,p_color=>'#C7C7CC'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2562894890878607)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>true
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(2563491063878607)
,p_chart_id=>wwv_flow_imp.id(2562347006878607)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>true
,p_zoom_order_weeks=>true
,p_zoom_order_months=>true
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2145742635493941)
,p_name=>'P17_DGRM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2561999301878606)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2145861612493942)
,p_name=>'P17_OBJT_BPMN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2561999301878606)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2145950517493943)
,p_name=>'P17_OBJT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2561999301878606)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_imp_page.create_page(
 p_id=>20
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Instance Timeline - &P20_PRCS_NAME.'
,p_alias=>'INSTANCE-TIMELINE-P20-PRCS-NAME'
,p_step_title=>'Instance Timeline - &P20_PRCS_NAME.'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(12495635610083880376)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'22'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2033643917569015)
,p_name=>'Search Results'
,p_region_name=>'instance-timeline-cr'
,p_template=>wwv_flow_imp.id(12495582446800880234)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-Timeline--compact'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_P0020_INSTANCE_TIMELINE_VW'
,p_query_where=>'prcs_id = :p20_prcs_id'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P20_PRCS_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495551963420880184)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2033795760569016)
,p_query_column_id=>1
,p_column_alias=>'PRCS_ID'
,p_column_display_sequence=>80
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2033826985569017)
,p_query_column_id=>2
,p_column_alias=>'EVENT_DATE'
,p_column_display_sequence=>90
,p_column_heading=>'Event Date'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2033971970569018)
,p_query_column_id=>3
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>100
,p_column_heading=>'User Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034066823569019)
,p_query_column_id=>4
,p_column_alias=>'EVENT_TITLE'
,p_column_display_sequence=>110
,p_column_heading=>'Event Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034198035569020)
,p_query_column_id=>5
,p_column_alias=>'EVENT_TYPE'
,p_column_display_sequence=>160
,p_column_heading=>'Event Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034206989569021)
,p_query_column_id=>6
,p_column_alias=>'EVENT_STATUS'
,p_column_display_sequence=>130
,p_column_heading=>'Event Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034344167569022)
,p_query_column_id=>7
,p_column_alias=>'EVENT_DESC'
,p_column_display_sequence=>140
,p_column_heading=>'Event Desc'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034410284569023)
,p_query_column_id=>8
,p_column_alias=>'USER_COLOR'
,p_column_display_sequence=>150
,p_column_heading=>'User Color'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034561911569024)
,p_query_column_id=>9
,p_column_alias=>'EVENT_ICON'
,p_column_display_sequence=>170
,p_column_heading=>'Event Icon'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034609242569025)
,p_query_column_id=>10
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034718627569026)
,p_query_column_id=>11
,p_column_alias=>'OBJT'
,p_column_display_sequence=>20
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034875865569027)
,p_query_column_id=>12
,p_column_alias=>'PROC_VAR'
,p_column_display_sequence=>50
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2034999078569028)
,p_query_column_id=>13
,p_column_alias=>'VALUE'
,p_column_display_sequence=>60
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2035024196569029)
,p_query_column_id=>14
,p_column_alias=>'SUBFLOW'
,p_column_display_sequence=>30
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2035187927569030)
,p_query_column_id=>15
,p_column_alias=>'PROCESS_LEVEL'
,p_column_display_sequence=>40
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2035208015569031)
,p_query_column_id=>16
,p_column_alias=>'PERFORMED_BY'
,p_column_display_sequence=>70
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2035348203569032)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(2033643917569015)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'10000'
,p_attribute_13=>'Y'
,p_attribute_15=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2116559170571265)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2035540233569034)
,p_name=>'P20_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Search'
,p_source=>'OPERATION,DESCRIPTION,OBJT,PROC_VAR,EVENT_COMMENT,PERFORMED_BY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2035670797569035)
,p_name=>'P20_OPERATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Operation'
,p_source=>'OPERATION'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>7
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2035771457569036)
,p_name=>'P20_OBJT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Step'
,p_source=>'OBJT'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2035831132569037)
,p_name=>'P20_PROC_VAR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Process Variable'
,p_source=>'PROC_VAR'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2035945696569038)
,p_name=>'P20_SUBFLOW'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Subflow'
,p_source=>'SUBFLOW'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Subflow Logged'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2036063537569039)
,p_name=>'P20_PROCESS_LEVEL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Process Level'
,p_source=>'PROCESS_LEVEL'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Process Level Logged'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>7
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2036173097569040)
,p_name=>'P20_PERFORMED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_prompt=>'Performed By'
,p_source=>'PERFORMED_BY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2036250500569041)
,p_name=>'P20_PRCS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2036320570569042)
,p_name=>'P20_PRCS_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2035348203569032)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_imp_page.create_page(
 p_id=>30
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - REST'
,p_alias=>'CONFIGURATION-REST'
,p_step_title=>'Configuration - REST'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2362908411158415)
,p_plug_name=>'Content'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>'return flow_rest_install.is_rest_enabled and flow_rest_install.is_module_published;'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2343931822104541)
,p_plug_name=>'OAUTH Clients'
,p_parent_plug_id=>wwv_flow_imp.id(2362908411158415)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select oc.id',
'     , oc.name',
'     , oc.description',
'     , oc.client_id',
'     , oc.support_uri',
'     , oc.support_email',
'  from user_ords_clients oc'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'ORDS Client Report'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2344349165104542)
,p_name=>'Report 1'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No data found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:RP,:P31_ID:#ID#'
,p_detail_link_text=>'<span aria-label="Edit"><span class="fa fa-edit" aria-hidden="true" title="Edit"></span></span>'
,p_owner=>'C##JDOPPELREITER'
,p_internal_uid=>2344349165104542
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2362185830158407)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'L'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2344837977104545)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2345216929104546)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2346812012104546)
,p_db_column_name=>'CLIENT_ID'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>'Client Id'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2348040743104547)
,p_db_column_name=>'SUPPORT_EMAIL'
,p_display_order=>60
,p_column_identifier=>'J'
,p_column_label=>'Support Email'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2348409591104547)
,p_db_column_name=>'SUPPORT_URI'
,p_display_order=>70
,p_column_identifier=>'K'
,p_column_label=>'Support Uri'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2358966194119402)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'23590'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:DESCRIPTION:CLIENT_ID:SUPPORT_EMAIL:SUPPORT_URI'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4722613539681901)
,p_plug_name=>'Configuration'
,p_parent_plug_id=>wwv_flow_imp.id(2362908411158415)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2363080166158416)
,p_plug_name=>'Prerequisites missing'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>'return not flow_rest_install.is_rest_enabled or not flow_rest_install.is_module_published;'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'<ul>'
,p_plug_footer=>'</ul>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2363132666158417)
,p_plug_name=>'Not REST Enabled'
,p_parent_plug_id=>wwv_flow_imp.id(2363080166158416)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<li>Schema is not REST Enabled</li>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>'return not flow_rest_install.is_rest_enabled;'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2363247042158418)
,p_plug_name=>'Module missing'
,p_parent_plug_id=>wwv_flow_imp.id(2363080166158416)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<li>REST module not installed. Please follow the installation guide at: <a href="https://flowsforapex.org/latest/installation" target="_blank">https://flowsforapex.org/latest/installation</a></li>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>'return not flow_rest_install.is_module_published;'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19992522503359785)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2353415432104550)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2343931822104541)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:31'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4723087919681905)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4722613539681901)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_condition=>'return flow_rest_install.is_rest_enabled and flow_rest_install.is_module_published;'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4722790490681902)
,p_name=>'P30_LOGGING_REST_INCOMING_CALLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4722613539681901)
,p_prompt=>'Log Incoming Rest Calls'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4722861639681903)
,p_name=>'P30_LOGGING_REST_RETAIN_LOGS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4722613539681901)
,p_prompt=>'Retain Logs (Days)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5655634694360001)
,p_name=>'P30_BASE_URL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4722613539681901)
,p_prompt=>'Base-URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5655772217360002)
,p_computation_sequence=>10
,p_computation_item=>'P30_BASE_URL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_rest_constants.c_config_prefix || flow_rest_constants.c_config_key_base',
'         , p_default_value => null',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4723201073681907)
,p_computation_sequence=>20
,p_computation_item=>'P30_LOGGING_REST_INCOMING_CALLS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_rest_logging.c_log_rest_incoming',
'         , p_default_value => flow_rest_logging.c_log_rest_incoming_default',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4723389675681908)
,p_computation_sequence=>30
,p_computation_item=>'P30_LOGGING_REST_RETAIN_LOGS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_rest_logging.c_log_rest_incoming_retain_days',
'         , p_default_value => flow_rest_logging.c_log_rest_incoming_retain_days_default',
'       );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2352493486104549)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(2343931822104541)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2352945371104550)
,p_event_id=>wwv_flow_imp.id(2352493486104549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2343931822104541)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4723167093681906)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Config'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_rest_install.set_base_url( pi_base_url => :P30_BASE_URL );',
'',
'flow_rest_logging.set_logging_config( pi_log_rest_incoming         => :P30_LOGGING_REST_INCOMING_CALLS',
'                                    , pi_log_rest_incoming_retain  => :P30_LOGGING_REST_RETAIN_LOGS );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4723087919681905)
,p_process_when=>'return flow_rest_install.is_rest_enabled and flow_rest_install.is_module_published;'
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Rest Configuration saved!'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_imp_page.create_page(
 p_id=>31
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - REST - Client'
,p_alias=>'CONFIGURATION-REST-CLIENT'
,p_page_mode=>'MODAL'
,p_step_title=>'Configuration - REST - Client'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2333314435104525)
,p_plug_name=>'Configuration - REST - Client'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from user_ords_clients'))
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2339381920104534)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495606500823880260)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2362292353158408)
,p_plug_name=>'Roles'
,p_region_template_options=>'#DEFAULT#:t-Region--stacked:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2361808004158404)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2339381920104534)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'BELOW_BOX'
,p_button_condition=>'P31_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2339755735104535)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2339381920104534)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2341363963104538)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2339381920104534)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P31_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2342112923104539)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2339381920104534)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P31_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2333737125104527)
,p_name=>'P31_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2334144599104530)
,p_name=>'P31_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2334540817104531)
,p_name=>'P31_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2334919752104531)
,p_name=>'P31_CLIENT_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Client Id'
,p_source=>'CLIENT_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>32
,p_display_when=>'P31_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2335329517104532)
,p_name=>'P31_CLIENT_SECRET'
,p_source_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Client Secret'
,p_source=>'CLIENT_SECRET'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>32
,p_display_when=>'P31_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2335706591104532)
,p_name=>'P31_REDIRECT_URI'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Redirect Uri'
,p_source=>'REDIRECT_URI'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2336147036104532)
,p_name=>'P31_SUPPORT_EMAIL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Support Email'
,p_source=>'SUPPORT_EMAIL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2336591473104532)
,p_name=>'P31_SUPPORT_URI'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_prompt=>'Support Uri'
,p_source=>'SUPPORT_URI'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2361513976158401)
,p_name=>'P31_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_source_plug_id=>wwv_flow_imp.id(2333314435104525)
,p_item_default=>'APP_USER'
,p_item_default_type=>'ITEM'
,p_prompt=>'Owner'
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2362364494158409)
,p_name=>'P31_ROLE_SELECTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2362292353158408)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return apex_string.table_to_string(',
'            flow_rest_auth.get_client_roles( pi_id => :P31_ID )',
'                , '':'' );'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FLOW_REST_ROLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select role_name',
'     , role_id',
'  from table(flow_rest_auth.get_rest_roles)'))
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2339843445104535)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2339755735104535)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2340610943104537)
,p_event_id=>wwv_flow_imp.id(2339843445104535)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2342942427104540)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Client'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_rest_auth.create_client( pi_name           => :P31_NAME',
'                            , pi_owner          => :P31_OWNER',
'                            , pi_description    => :P31_DESCRIPTION',
'                            , pi_support_email  => :P31_SUPPORT_EMAIL',
'                            , pi_support_uri    => :P31_SUPPORT_URI );',
'',
':P31_ID := flow_rest_auth.get_client_id(pi_name => :P31_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2342112923104539)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2361967412158405)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Client'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'OAUTH.UPDATE_CLIENT(',
'  p_name             => :P31_NAME,',
'  p_description      => :P31_DESCRIPTION,',
'  p_redirect_uri     => :P31_REDIRECT_URI,',
'  p_support_email    => :P31_SUPPORT_EMAIL,',
'  p_support_uri      => :P31_SUPPORT_URI);',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2361808004158404)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2362553451158411)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Role Grants'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_rest_auth.update_client_roles( pi_id    => :P31_ID',
'                                  , pi_roles => apex_string.string_to_table(:P31_ROLE_SELECTION,'':''));'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''CREATE'',''SAVE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2361644591158402)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Client'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'OAUTH.DELETE_CLIENT(',
'   p_name => :P31_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2341363963104538)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2343368358104541)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2342584370104540)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2333314435104525)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Configuration - REST - Client'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_imp_page.create_page(
 p_id=>32
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Logging'
,p_alias=>'CONFIGURATION-LOGGING'
,p_step_title=>'Configuration - Logging'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APP_IMAGES#lib/prismjs/js/prism.js'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11160422865040074)
,p_plug_name=>'Logging'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7537546705451722)
,p_name=>'JSON Configuration'
,p_parent_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_template=>wwv_flow_imp.id(12495609856182880263)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--altRowsDefault:t-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_bpmn_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_header=>'BPMN Location'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495559701953880190)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3791697231921401)
,p_query_column_id=>1
,p_column_alias=>'D'
,p_column_display_sequence=>10
,p_column_heading=>'D'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<pre><code class="language-json">#D#</code></pre>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20892351125255012)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3791980243921403)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7537546705451722)
,p_button_name=>'EDIT_CONFIGURATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Edit Configuration'
,p_button_position=>'BOTTOM'
,p_button_alignment=>'LEFT'
,p_button_redirect_url=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:38:P38_CFIG_KEY:logging_bpmn_location'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3138033307214457)
,p_button_sequence=>20
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3307218597301243)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(20892351125255012)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3133819152214452)
,p_name=>'P32_LOGGING_LANGUAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_prompt=>'Language'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct ',
'    fmsg_lang d',
'  , fmsg_lang r',
'from flow_messages',
'order by fmsg_lang'))
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>'Language used to display error messages and log events.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'12'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3134229968214453)
,p_name=>'P32_LOGGING_LEVEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_prompt=>'Level'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:off;off,standard;standard,secure;secure,full;full'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3134666000214454)
,p_name=>'P32_LOGGING_HIDE_USERID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_prompt=>'Hide User ID'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'true'
,p_attribute_03=>'Yes'
,p_attribute_04=>'false'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3136262120214455)
,p_name=>'P32_LOGGING_MESSAGE_FLOW_RECD'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_prompt=>'Log Inbound MessageFlow'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'true'
,p_attribute_03=>'Yes'
,p_attribute_04=>'false'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3136630459214455)
,p_name=>'P32_LOGGING_RETAIN_MSG_FLOW'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_prompt=>'Message Flow Log Retention (Days)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3325454520527225)
,p_name=>'P32_LOGGING_RETAIN_LOGS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11160422865040074)
,p_prompt=>'Retain Logs (Days after Process Instance Completion)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'1 Year'
,p_quick_pick_value_01=>'365'
,p_quick_pick_label_02=>'9 Months'
,p_quick_pick_value_02=>'273'
,p_quick_pick_label_03=>'6 Months'
,p_quick_pick_value_03=>'182'
,p_quick_pick_label_04=>'3 Months'
,p_quick_pick_value_04=>'90'
,p_quick_pick_label_05=>'30 Days'
,p_quick_pick_value_05=>'30'
,p_quick_pick_label_06=>'14 Days'
,p_quick_pick_value_06=>'14'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3146072745214471)
,p_computation_sequence=>10
,p_computation_item=>'P32_LOGGING_LANGUAGE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_language',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_language',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3146443044214471)
,p_computation_sequence=>20
,p_computation_item=>'P32_LOGGING_LEVEL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_constants_pkg.gc_config_logging_level',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_level',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3146858608214471)
,p_computation_sequence=>30
,p_computation_item=>'P32_LOGGING_HIDE_USERID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_level',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_level',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3286665275239507)
,p_computation_sequence=>40
,p_computation_item=>'P32_LOGGING_RETAIN_LOGS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_retain_logs',
'         , p_default_value => flow_constants_pkg.gc_config_default_log_retain_logs',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3286988755239510)
,p_computation_sequence=>60
,p_computation_item=>'P32_LOGGING_MESSAGE_FLOW_RECD'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_message_flow_recd',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_recd_msg',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3287265563239513)
,p_computation_sequence=>70
,p_computation_item=>'P32_LOGGING_RETAIN_MSG_FLOW'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_retain_msg_flow',
'         , p_default_value => flow_constants_pkg.gc_config_default_log_retain_msg_flow_logs',
'       );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3792574755923554)
,p_name=>'On dialog close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3791980243921403)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3792909625923555)
,p_event_id=>wwv_flow_imp.id(3792574755923554)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(7537546705451722)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3795925272966657)
,p_name=>'On Refresh JSON'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(7537546705451722)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3796393337966657)
,p_event_id=>wwv_flow_imp.id(3795925272966657)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'Prism.highlightAll();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3150354905214473)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_logging_settings(',
'  pi_logging_language          => :P32_LOGGING_LANGUAGE',
', pi_logging_level             => :P32_LOGGING_LEVEL',
', pi_logging_hide_userid       => :P32_LOGGING_HIDE_USERID',
', pi_logging_retain_logs       => :P32_LOGGING_RETAIN_LOGS',
', pi_logging_message_flow_recd => :P32_LOGGING_MESSAGE_FLOW_RECD',
', pi_logging_retain_msg_flow   => :P32_LOGGING_RETAIN_MSG_FLOW',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3138033307214457)
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_imp_page.create_page(
 p_id=>33
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Archiving'
,p_alias=>'CONFIGURATION-ARCHIVING'
,p_step_title=>'Configuration - Archiving'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APP_IMAGES#lib/prismjs/js/prism.js'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11186537419048718)
,p_plug_name=>'Archiving'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3746146895530325)
,p_name=>'JSON Configuration'
,p_parent_plug_id=>wwv_flow_imp.id(11186537419048718)
,p_template=>wwv_flow_imp.id(12495609856182880263)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--altRowsDefault:t-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select json_query( (select flow_engine_util.get_config_value(',
'           p_config_key => ''logging_archive_location''',
'         , p_default_value => null',
'       ) from dual), ''$'' returning varchar2(4000) pretty) as d',
'from dual'))
,p_header=>'Archive Location'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(12495559701953880190)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3746305351530327)
,p_query_column_id=>1
,p_column_alias=>'D'
,p_column_display_sequence=>10
,p_column_heading=>'D'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<pre><code class="language-json">#D#</code></pre>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24201499202577457)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3512936201851742)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3746146895530325)
,p_button_name=>'EDIT_CONFIGURATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Edit Configuration'
,p_button_position=>'BELOW_BOX'
,p_button_alignment=>'LEFT'
,p_button_redirect_url=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:38:P38_CFIG_KEY:logging_archive_location'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3164119045223081)
,p_button_sequence=>20
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3309455839322446)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(24201499202577457)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3161511927223080)
,p_name=>'P33_LOGGING_ARCHIVE_ENABLED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11186537419048718)
,p_prompt=>'Enable Instance Summary Archiving'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'true'
,p_attribute_03=>'Yes'
,p_attribute_04=>'false'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3161978411223080)
,p_name=>'P33_LOGGING_ARCHIVE_LOCATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11186537419048718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3170508084223084)
,p_computation_sequence=>50
,p_computation_item=>'P33_LOGGING_ARCHIVE_ENABLED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_archive_enabled',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_archive_enabled',
'       );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3746400769530328)
,p_name=>'On dialog close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3512936201851742)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3746576221530329)
,p_event_id=>wwv_flow_imp.id(3746400769530328)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3746146895530325)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3747022152530334)
,p_name=>'On Refresh JSON'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(3746146895530325)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3747195167530335)
,p_event_id=>wwv_flow_imp.id(3747022152530334)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'Prism.highlightAll();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3176434129223085)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_archiving_settings(',
'  pi_archiving_enabled  => :P33_LOGGING_ARCHIVE_ENABLED',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3164119045223081)
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_imp_page.create_page(
 p_id=>34
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Engine App'
,p_alias=>'CONFIGURATION-ENGINE-APP'
,p_step_title=>'Configuration - Engine App'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11214749648054909)
,p_plug_name=>'Engine App'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24202222744578370)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3192334722229270)
,p_button_sequence=>20
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3310158364323358)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(24202222744578370)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3191696373229270)
,p_name=>'P34_ENGINE_APP_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11214749648054909)
,p_prompt=>'Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Production;production,Development;development'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3201508723229275)
,p_computation_sequence=>70
,p_computation_item=>'P34_ENGINE_APP_MODE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_constants_pkg.gc_config_engine_app_mode',
'         , p_default_value => flow_constants_pkg.gc_config_default_engine_app_mode',
'       );'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3204611384229276)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_engine_app_settings(',
'  pi_engine_app_mode => :P34_ENGINE_APP_MODE',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3192334722229270)
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00035
begin
wwv_flow_imp_page.create_page(
 p_id=>35
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Engine'
,p_alias=>'CONFIGURATION-ENGINE'
,p_step_title=>'Configuration - Engine'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24202901353579047)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(65920170325464220)
,p_plug_name=>'Engine'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3221271791231712)
,p_button_sequence=>10
,p_button_name=>'REST_CONFIG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'REST Config'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP,30::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3220853426231712)
,p_button_sequence=>20
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3310860026324035)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(24202901353579047)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3221987342231713)
,p_name=>'P35_DUPLICATE_STEP_PREVENTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(65920170325464220)
,p_prompt=>'Duplicate Step Prevention'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:strict;strict,legacy;legacy'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3222333263231713)
,p_name=>'P35_DEFAULT_WORKSPACE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(65920170325464220)
,p_prompt=>'Default Workspace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3222763777231713)
,p_name=>'P35_DEFAULT_EMAIL_SENDER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(65920170325464220)
,p_prompt=>'Default Email Sender'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3223134552231713)
,p_name=>'P35_DEFAULT_APPLICATIONID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(65920170325464220)
,p_prompt=>'Default Application Id'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'The application ID of one of your APEX apps that will be provided to create a session'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3223533554231713)
,p_name=>'P35_DEFAULT_PAGEID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(65920170325464220)
,p_prompt=>'Default Page Id'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'The page ID of one of your apps that will be provided to create a session'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3223946439231713)
,p_name=>'P35_DEFAULT_USERNAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(65920170325464220)
,p_prompt=>'Default Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'The username to be user on the APEX session to create a session if no other username is provided	'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3232080558231716)
,p_computation_sequence=>80
,p_computation_item=>'P35_DUPLICATE_STEP_PREVENTION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_dup_step_prevention',
'         , p_default_value => flow_constants_pkg.gc_config_default_dup_step_prevention',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3230456644231715)
,p_computation_sequence=>90
,p_computation_item=>'P35_DEFAULT_WORKSPACE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_default_workspace',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_workspace',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3231617409231716)
,p_computation_sequence=>100
,p_computation_item=>'P35_DEFAULT_EMAIL_SENDER'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_default_email_sender',
'         , p_default_value => null ',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3230878635231716)
,p_computation_sequence=>110
,p_computation_item=>'P35_DEFAULT_APPLICATIONID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_constants_pkg.gc_config_default_application',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_application',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3231247954231716)
,p_computation_sequence=>120
,p_computation_item=>'P35_DEFAULT_PAGEID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>flow_constants_pkg.gc_config_default_pageid',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_pageid',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3232449117231716)
,p_computation_sequence=>130
,p_computation_item=>'P35_DEFAULT_USERNAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>flow_constants_pkg.gc_config_default_username',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_username',
'       );'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3233135486231716)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_engine_settings(',
'  pi_duplicate_step_prevention => :P35_DUPLICATE_STEP_PREVENTION',
', pi_default_workspace         => :P35_DEFAULT_WORKSPACE',
', pi_default_email_sender      => :P35_DEFAULT_EMAIL_SENDER',
', pi_default_application       => :P35_DEFAULT_APPLICATIONID',
', pi_default_pageid            => :P35_DEFAULT_PAGEID',
', pi_default_username          => :P35_DEFAULT_USERNAME',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3220853426231712)
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_imp_page.create_page(
 p_id=>36
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Timers'
,p_alias=>'CONFIGURATION-TIMERS'
,p_step_title=>'Configuration - Timers'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4548240290043011)
,p_plug_name=>'Additonal Installation Step Not Complete'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--warning'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'To use the Timers feature of Flows for APEX, you must complete additional installation step that can be found <a href="https://flowsforapex.org/latest/installation/#post-installation-task-1-additional-step-to-use-timers" target="_blank">here</a>.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not flow_timers_pkg.timer_job_exists'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5273399411803742)
,p_plug_name=>'Timers'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'flow_timers_pkg.timer_job_exists'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24203633870580280)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3311591865325268)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(24203633870580280)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'flow_timers_pkg.timer_job_exists'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3249682912234740)
,p_name=>'P36_TIMER_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5273399411803742)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Timers Enabled'
,p_source=>'flow_timers_pkg.get_timer_status'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TRUE'
,p_attribute_03=>'enabled'
,p_attribute_04=>'FALSE'
,p_attribute_05=>'disabled'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3250052219234740)
,p_name=>'P36_TIMER_REPEAT_INTERVAL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5273399411803742)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Timer Repeat Interval'
,p_source=>'flow_timers_pkg.get_timer_repeat_interval'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Hourly'
,p_quick_pick_value_01=>'FREQ=HOURLY;INTERVAL=1'
,p_quick_pick_label_02=>'10 Min'
,p_quick_pick_value_02=>'FREQ=MINUTELY;INTERVAL=10'
,p_quick_pick_label_03=>'5 Min'
,p_quick_pick_value_03=>'FREQ=MINUTELY;INTERVAL=10'
,p_quick_pick_label_04=>'1 Min'
,p_quick_pick_value_04=>'FREQ=MINUTELY;INTERVAL=10'
,p_quick_pick_label_05=>'10 Sec (Production Use - not for apex.oracle.com)'
,p_quick_pick_value_05=>'FREQ=SECONDLY;INTERVAL=10'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3317563907227906)
,p_name=>'P36_TIMER_MAX_CYCLES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5273399411803742)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Timer Max Cycles'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_util.get_config_value(',
'           p_config_key =>flow_constants_pkg.gc_config_timer_max_cycles',
'         , p_default_value => flow_constants_pkg.gc_config_default_timer_max_cycles',
'       )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'For cycle timers, this will defined the maximum number of execution.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'left'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3257766356234742)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_timers_settings(',
'  pi_timer_max_cycles      => :P36_TIMER_MAX_CYCLES',
', pi_timer_status          => :P36_TIMER_STATUS',
', pi_timer_repeat_interval => :P36_TIMER_REPEAT_INTERVAL',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_imp_page.create_page(
 p_id=>37
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Statistics'
,p_alias=>'CONFIGURATION-STATISTICS'
,p_step_title=>'Configuration - Statistics'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8608203121575437)
,p_plug_name=>'Statistics'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27538437580351975)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3337626931771697)
,p_button_sequence=>20
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3336931358771696)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(27538437580351975)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3287364553239514)
,p_name=>'P37_STATS_RETAIN_MONTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8608203121575437)
,p_prompt=>'Retain Monthly Summaries (Months)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'1 Year'
,p_quick_pick_value_01=>'12'
,p_quick_pick_label_02=>'9 Months'
,p_quick_pick_value_02=>'9'
,p_quick_pick_label_03=>'6 Months'
,p_quick_pick_value_03=>'6'
,p_quick_pick_label_04=>'3 Months'
,p_quick_pick_value_04=>'3'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3287449524239515)
,p_name=>'P37_STATS_RETAIN_QTR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8608203121575437)
,p_prompt=>'Retain Quarterly Summaries (Months)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'5 Years'
,p_quick_pick_value_01=>'60'
,p_quick_pick_label_02=>'4 Years'
,p_quick_pick_value_02=>'48'
,p_quick_pick_label_03=>'3 Years'
,p_quick_pick_value_03=>'36'
,p_quick_pick_label_04=>'2 Years'
,p_quick_pick_value_04=>'24'
,p_quick_pick_label_05=>'1 Year'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3341734890779729)
,p_name=>'P37_STATS_RETAIN_DAILY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8608203121575437)
,p_prompt=>'Retain Daily Summaries (Days)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'1 Year'
,p_quick_pick_value_01=>'365'
,p_quick_pick_label_02=>'9 Months'
,p_quick_pick_value_02=>'273'
,p_quick_pick_label_03=>'6 Months'
,p_quick_pick_value_03=>'182'
,p_quick_pick_label_04=>'3 Months'
,p_quick_pick_value_04=>'90'
,p_quick_pick_label_05=>'30 Days'
,p_quick_pick_value_05=>'30'
,p_quick_pick_label_06=>'14 Days'
,p_quick_pick_value_06=>'14'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3287570384239516)
,p_computation_sequence=>10
,p_computation_item=>'P37_STATS_RETAIN_DAILY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_daily',
'         , p_default_value => flow_constants_pkg.gc_config_default_stats_retain_summary_daily',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3287640183239517)
,p_computation_sequence=>20
,p_computation_item=>'P37_STATS_RETAIN_MONTH'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_month',
'         , p_default_value => flow_constants_pkg.gc_config_default_stats_retain_summary_month',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3287793538239518)
,p_computation_sequence=>30
,p_computation_item=>'P37_STATS_RETAIN_QTR'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_qtr',
'         , p_default_value => flow_constants_pkg.gc_config_default_stats_retain_summary_qtr',
'       );'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3339267970771698)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_timers_settings(',
'  pi_timer_max_cycles      => :P37_TIMER_MAX_CYCLES',
', pi_timer_status          => :P37_TIMER_STATUS',
', pi_timer_repeat_interval => :P37_TIMER_REPEAT_INTERVAL',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3337626931771697)
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_imp_page.create_page(
 p_id=>38
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - Location'
,p_alias=>'CONFIGURATION-LOCATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Configuration - Location'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3512217433851735)
,p_plug_name=>'Location'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_CONFIGURATION'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3747249703530336)
,p_plug_name=>'Choose the active destination'
,p_parent_plug_id=>wwv_flow_imp.id(3512217433851735)
,p_icon_css_classes=>'fa-number-1-o'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3747347338530337)
,p_plug_name=>'Fill in the details'
,p_parent_plug_id=>wwv_flow_imp.id(3512217433851735)
,p_icon_css_classes=>'fa-number-2-o'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3745995977530323)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495606500823880260)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3745589259530319)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3745995977530323)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3745670019530320)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3745995977530323)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3512603514851739)
,p_name=>'P38_CFIG_KEY'
,p_source_data_type=>'VARCHAR2'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3512217433851735)
,p_item_source_plug_id=>wwv_flow_imp.id(3512217433851735)
,p_source=>'CFIG_KEY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3512743931851740)
,p_name=>'P38_CFIG_VALUE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3512217433851735)
,p_item_source_plug_id=>wwv_flow_imp.id(3512217433851735)
,p_source=>'CFIG_VALUE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3513035181851743)
,p_name=>'P38_DESTINATION_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3747249703530336)
,p_prompt=>'Destination Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Table;TABLE,OCI (API);OCI-API,OCI (PreAuth);OCI-PREAUTH'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3513116353851744)
,p_name=>'P38_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_name r',
'from user_tables'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3513290888851745)
,p_name=>'P38_ID_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Id Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'from user_tab_columns',
'where table_name = :P38_TABLE_NAME',
'and data_type = ''NUMBER'';'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P38_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3513352883851746)
,p_name=>'P38_TIMESTAMP_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Timestamp Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'from user_tab_columns',
'where table_name = :P38_TABLE_NAME',
'and data_type like ''TIMESTAMP%WITH TIME ZONE%'';'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P38_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3513454878851747)
,p_name=>'P38_BLOB_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Blob Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'from user_tab_columns',
'where table_name = :P38_TABLE_NAME',
'and data_type = ''BLOB'';'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P38_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3743758890530301)
,p_name=>'P38_BASE_URL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3743862263530302)
,p_name=>'P38_BUCKET_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Bucket Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3743975741530303)
,p_name=>'P38_API_DOCUMENT_PREFIX'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Document Prefix'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3744055656530304)
,p_name=>'P38_API_CREDENTIAL_APEX_STATIC_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'APEX Credential Static Id'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name||'' (''||credential_type||'')'' d, static_id',
'from apex_workspace_credentials;'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3744138186530305)
,p_name=>'P38_PRE_AUTH_URL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Pre Auth URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3747558988530339)
,p_name=>'P38_PREAUTH_DOCUMENT_PREFIX'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'Document Prefix'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3747603686530340)
,p_name=>'P38_PREAUTH_CREDENTIAL_APEX_STATIC_ID'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(3747347338530337)
,p_prompt=>'APEX Credential Static Id'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name||'' (''||credential_type||'')'' d, static_id',
'from apex_workspace_credentials;'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3746058063530324)
,p_computation_sequence=>10
,p_computation_item=>'P38_CFIG_VALUE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob clob;',
'begin',
'    apex_json.initialize_clob_output;',
'',
'    apex_json.open_object;',
'    apex_json.write(''destinationType'', :P38_DESTINATION_TYPE);',
'',
'    apex_json.open_object(''tableDetails'');',
'    apex_json.write(''tableName'', :P38_TABLE_NAME);',
'    apex_json.write(''idColumn'', :P38_ID_COLUMN);',
'    apex_json.write(''timestampColumn'', :P38_TIMESTAMP_COLUMN);',
'    apex_json.write(''blobColumn'', :P38_BLOB_COLUMN);',
'    apex_json.close_object;',
'',
'    apex_json.open_object(''ociApiDetails'');',
'    apex_json.write(''baseUrl'', :P38_BASE_URL);',
'    apex_json.write(''bucketName'', :P38_BUCKET_NAME);',
'    apex_json.write(''documentPrefix'', :P38_API_DOCUMENT_PREFIX);',
'    apex_json.write(''credentialApexStaticId'', :P38_API_CREDENTIAL_APEX_STATIC_ID);',
'    apex_json.close_object;',
'',
'    apex_json.open_object(''ociPreAuthDetails'');',
'    apex_json.write(''preAuthUrl'', :P38_PRE_AUTH_URL);',
'    apex_json.write(''documentPrefix'', :P38_PREAUTH_DOCUMENT_PREFIX);',
'    apex_json.write(''credentialApexStaticId'', :P38_PREAUTH_CREDENTIAL_APEX_STATIC_ID);',
'    apex_json.close_object;',
'',
'    apex_json.close_object;',
'',
'    l_clob := apex_json.get_clob_output( p_free => true );',
'',
'    return l_clob;',
'end;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3744327033530307)
,p_name=>'Hide/Show Table Fields'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P38_DESTINATION_TYPE'
,p_condition_element=>'P38_DESTINATION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3744474525530308)
,p_event_id=>wwv_flow_imp.id(3744327033530307)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P38_TABLE_NAME,P38_ID_COLUMN,P38_TIMESTAMP_COLUMN,P38_BLOB_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3744597361530309)
,p_event_id=>wwv_flow_imp.id(3744327033530307)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P38_TABLE_NAME,P38_ID_COLUMN,P38_TIMESTAMP_COLUMN,P38_BLOB_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3744633233530310)
,p_name=>'Hide/Show OCI-API Fields'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P38_DESTINATION_TYPE,P38_API_DOCUMENT_PREFIX,P38_API_CREDENTIAL_APEX_STATIC_ID'
,p_condition_element=>'P38_DESTINATION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI-API'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3744771169530311)
,p_event_id=>wwv_flow_imp.id(3744633233530310)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P38_BASE_URL,P38_BUCKET_NAME,P38_API_DOCUMENT_PREFIX,P38_API_CREDENTIAL_APEX_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3747744242530341)
,p_event_id=>wwv_flow_imp.id(3744633233530310)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P38_BASE_URL,P38_BUCKET_NAME,P38_API_DOCUMENT_PREFIX,P38_API_CREDENTIAL_APEX_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3744919862530313)
,p_name=>'Hide/Show OCI-PREAUTH Fields'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P38_DESTINATION_TYPE'
,p_condition_element=>'P38_DESTINATION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI-PREAUTH'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3745034758530314)
,p_event_id=>wwv_flow_imp.id(3744919862530313)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P38_PRE_AUTH_URL,P38_PREAUTH_DOCUMENT_PREFIX,P38_PREAUTH_CREDENTIAL_APEX_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3747827765530342)
,p_event_id=>wwv_flow_imp.id(3744919862530313)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P38_PRE_AUTH_URL,P38_PREAUTH_DOCUMENT_PREFIX,P38_PREAUTH_CREDENTIAL_APEX_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3745700945530321)
,p_name=>'Click on Cancel'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3745670019530320)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3745870785530322)
,p_event_id=>wwv_flow_imp.id(3745700945530321)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3512846601851741)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3512217433851735)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Location'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3746695353530330)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3512551612851738)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(3512217433851735)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Configuration - Location'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3744274227530306)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parse JSON'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'   select destination_type,',
'          table_name,',
'          id_column,',
'          timestamp_column,',
'          blob_column,',
'          base_url,',
'          bucket_name,',
'          oci_api_doc_prefix, ',
'          oci_api_cred,',
'          preauth_url,',
'          oci_preauth_doc_prefix, ',
'          oci_preauth_cred',
'     into :p38_destination_type,',
'          :p38_table_name,',
'          :p38_id_column,',
'          :p38_timestamp_column,',
'          :p38_blob_column,',
'          :p38_base_url,',
'          :p38_bucket_name,',
'          :p38_api_document_prefix,',
'          :p38_api_credential_apex_static_id,',
'          :p38_pre_auth_url,',
'          :p38_preauth_document_prefix,',
'          :p38_preauth_credential_apex_static_id',
'     from json_table(',
'             (',
'                select cfig_value',
'                  from flow_configuration',
'                 where cfig_key = :P38_CFIG_KEY',
'             ),',
'             ''$''',
'             columns (',
'                destination_type       varchar2 path ''$.destinationType'',',
'                table_name             varchar2 path ''$.tableDetails.tableName'',',
'                id_column              varchar2 path ''$.tableDetails.idColumn'',',
'                timestamp_column       varchar2 path ''$.tableDetails.timestampColumn'',',
'                blob_column            varchar2 path ''$.tableDetails.blobColumn'',',
'                base_url               varchar2 path ''$.ociApiDetails.baseUrl'',',
'                bucket_name            varchar2 path ''$.ociApiDetails.bucketName'',',
'                oci_api_doc_prefix     varchar2 path ''$.ociApiDetails.documentPrefix'',',
'                oci_api_cred           varchar2 path ''$.ociApiDetails.credentialApexStaticId'',',
'                preauth_url            varchar2 path ''$.ociPreAuthDetails.preAuthUrl'',',
'                oci_preauth_doc_prefix varchar2 path ''$.ociPreAuthDetails.documentPrefix'',',
'                oci_preauth_cred       varchar2 path ''$.ociPreAuthDetails.credentialApexStaticId''',
'             )',
'          );',
'exception',
'    when no_data_found then',
'        --Don''t need to raise an exception there, it''s just because there is no configuration',
'        null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_imp_page.create_page(
 p_id=>39
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration - License'
,p_alias=>'CONFIGURATION-LICENSE'
,p_step_title=>'Configuration - License'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
,p_last_updated_by=>'RALLEN2010@GMAIL.COM'
,p_last_upd_yyyymmddhh24miss=>'20241002141934'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20088203370380088)
,p_plug_name=>'License'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39018437829156626)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11480685064804664)
,p_name=>'P39_LICENSE_EDITION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20088203370380088)
,p_prompt=>'License Edition'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11481033389804665)
,p_name=>'P39_LICENSE_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20088203370380088)
,p_prompt=>'License Key'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11481474672804666)
,p_name=>'P39_LICENSED_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20088203370380088)
,p_prompt=>'Licensed To'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11488208038948201)
,p_name=>'P39_LICENSE_EXPIRY_DATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20088203370380088)
,p_prompt=>'License Expiry Date'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11483338180804669)
,p_computation_sequence=>10
,p_computation_item=>'P39_LICENSE_EDITION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_license_edition',
'         , p_default_value => flow_constants_pkg.gc_config_edition_community',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11483722523804669)
,p_computation_sequence=>20
,p_computation_item=>'P39_LICENSE_KEY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_license_key',
'         , p_default_value => ''no license key''',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11484126133804670)
,p_computation_sequence=>30
,p_computation_item=>'P39_LICENSED_TO'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_licensed_to',
'         , p_default_value => ''not registered''',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11488312431948202)
,p_computation_sequence=>40
,p_computation_item=>'P39_LICENSE_EXPIRY_DATE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_license_expiry_date',
'         , p_default_value => ''not registered''',
'       );'))
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_imp_page.create_page(
 p_id=>50
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Simple Form Templates'
,p_alias=>'SIMPLE-FORM-TEMPLATES'
,p_step_title=>'Simple Form Templates'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240930074949'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5570494030899126)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'On this page you can manage the JSON definitions of your Simple Form templates. Your templates can be used in two ways:',
'<ul>',
'    <li>Select them on User Tasks of type "Simple Forms" in your flow models</li>',
'    <li>Utilize them in the <strong>Simple Process Starter App</strong> from the Flows distribution to start process instances by filling out a form',
'</ul>',
'<br/>',
'The Simple Form functionality for User Tasks is provided by integrating the <a href="https://github.com/simonuwe/oracle-apex-json-region" target="_blank">JSON-region plug-in</a>.',
'For more information on how to work with Simple Forms in Flows for APEX, see the latest <a href="https://flowsforapex.org/latest/getting-started/" target="_blank">documentation</a>.'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5598277955964021)
,p_plug_name=>'Simple Form Templates'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495584334308880235)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte.sfte_id,',
'       sfte.sfte_name,',
'       sfte.sfte_static_id,',
'       sfte.sfte_content',
'  from flow_simple_form_templates sfte'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Simple Form Templates'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5598315428964021)
,p_name=>'Simple Form Template Management'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No data found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:RP:P51_SFTE_ID:\#SFTE_ID#\'
,p_detail_link_text=>'<span aria-label="Edit"><span class="fa fa-edit" aria-hidden="true" title="Edit"></span></span>'
,p_owner=>'DENNIS.AMTHOR@HYAND.COM'
,p_internal_uid=>5598315428964021
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5599113851964022)
,p_db_column_name=>'SFTE_ID'
,p_display_order=>0
,p_column_identifier=>'B'
,p_column_label=>'Sfte ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5599594716964022)
,p_db_column_name=>'SFTE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5570545939899127)
,p_db_column_name=>'SFTE_STATIC_ID'
,p_display_order=>13
,p_column_identifier=>'E'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5599982855964022)
,p_db_column_name=>'SFTE_CONTENT'
,p_display_order=>23
,p_column_identifier=>'D'
,p_column_label=>'JSON'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'CLOB'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5604142286971113)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'56042'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SFTE_NAME:SFTE_STATIC_ID'
,p_sort_column_1=>'SFTE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'SFTE_STATIC_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5602132190964023)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495573047450880221)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_imp.id(12495636486941880396)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(12495520300515880126)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5600473513964022)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5598277955964021)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Template'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:51'
,p_icon_css_classes=>'fa-plus'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5600706745964022)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5598277955964021)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5601276240964023)
,p_event_id=>wwv_flow_imp.id(5600706745964022)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5598277955964021)
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_imp_page.create_page(
 p_id=>51
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Edit Simple Form Template'
,p_alias=>'EDIT-SIMPLE-FORM-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Simple Form Template'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240930133238'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5590953265964017)
,p_plug_name=>'Edit Simple Form Template'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_SIMPLE_FORM_TEMPLATES'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5571513551899137)
,p_plug_name=>'Links'
,p_parent_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_plug_template=>wwv_flow_imp.id(12495613507239880288)
,p_plug_display_sequence=>70
,p_plug_source=>'For an easy way to build your own form definitions declaratively, you can use the <a href="https://flowsforapex.com/ords/preview/r/simple-form-builder/json-sfb" target="_blank"><span style="white-space: nowrap">Simple Form Builder</span></a> to gener'
||'ate the required JSON.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5593476220964019)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495606500823880260)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5593882060964019)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5593476220964019)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5595272506964020)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5593476220964019)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_execute_validations=>'N'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>'P51_SFTE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'fa-trash-o'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5595617458964020)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5593476220964019)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P51_SFTE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'fa-save'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5596037362964020)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5593476220964019)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P51_SFTE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'fa-plus'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5570664007899128)
,p_name=>'P51_SFTE_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_item_source_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_prompt=>'Static ID'
,p_source=>'SFTE_STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>600
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5591377686964017)
,p_name=>'P51_SFTE_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_item_source_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sfte Id'
,p_source=>'SFTE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5591745755964018)
,p_name=>'P51_SFTE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_item_source_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_prompt=>'Name'
,p_source=>'SFTE_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>600
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5592198462964018)
,p_name=>'P51_SFTE_CONTENT'
,p_source_data_type=>'CLOB'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_item_source_plug_id=>wwv_flow_imp.id(5590953265964017)
,p_prompt=>'JSON'
,p_source=>'SFTE_CONTENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5571393661899135)
,p_validation_name=>'Validate JSON'
,p_validation_sequence=>10
,p_validation=>':P51_SFTE_CONTENT is json(strict)'
,p_validation2=>'SQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid JSON format'
,p_associated_item=>wwv_flow_imp.id(5592198462964018)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5593903400964019)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5593882060964019)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5594701152964020)
,p_event_id=>wwv_flow_imp.id(5593903400964019)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5596802589964021)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process form Edit Simple Form Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.process_page_p51',
'(',
'  pio_sfte_id       => :p51_sfte_id',
', pi_sfte_name      => :p51_sfte_name',
', pi_sfte_static_id => :p51_sfte_static_id',
', pi_sfte_content   => :p51_sfte_content',
', pi_request        => :request',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':request not in ( ''DARK_MODE'', ''LIGHT_MODE'', ''RESET_LIGHT'', ''RESET_DARK'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5597222661964021)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5596462717964021)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(5590953265964017)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Simple Form Template'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_imp_page.create_page(
 p_id=>100
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Configuration [OLD,BACKUP]'
,p_alias=>'CONFIGURATION-OLD-BACKUP'
,p_step_title=>'Configuration [OLD,BACKUP]'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.t-Form-inlineHelp ul li {',
'    font-size: 1.1rem;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(88199069651756122)
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5301292362807367)
,p_plug_name=>'Timers'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11295717440064001)
,p_plug_name=>'Logging'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11295777694064002)
,p_plug_name=>'Engine App'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(65972703397470872)
,p_plug_name=>'Engine'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(12495582446800880234)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3273786813238364)
,p_button_sequence=>10
,p_button_name=>'REST_CONFIG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_image_alt=>'REST Config'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP,30::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3273384211238364)
,p_button_sequence=>20
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(12495521691135880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'fa-save'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3269101148238362)
,p_name=>'P100_LOGGING_LANGUAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Language'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct ',
'    fmsg_lang d',
'  , fmsg_lang r',
'from flow_messages'))
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>'Language used to display error messages and log events.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3269559694238363)
,p_name=>'P100_LOGGING_LEVEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Level'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:off;off,standard;standard,secure;secure,full;full'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>off</strong> - logging is disabled	</li>',
'    <li><strong>standard</strong> (default) - logs instance events</li>',
'    <li><strong>secure</strong> - logs model events and instance events	</li>',
'    <li><strong>full</strong> - logs model, instance and process variable events		</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3269996682238363)
,p_name=>'P100_LOGGING_HIDE_USERID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Hide User ID'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>enabled</strong> - does not capture user information about the step	</li>',
'    <li><strong>disabled</strong> (default) - captures userid of the process step as known to the Flow Engine	</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'true'
,p_attribute_03=>'Yes'
,p_attribute_04=>'false'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3270397696238363)
,p_name=>'P100_LOGGING_RETAIN_LOGS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Retain Logs (Days after Process Instance Completion)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'I Year'
,p_quick_pick_value_01=>'365'
,p_quick_pick_label_02=>'9 Months'
,p_quick_pick_value_02=>'273'
,p_quick_pick_label_03=>'6 Months'
,p_quick_pick_value_03=>'182'
,p_quick_pick_label_04=>'3 Months'
,p_quick_pick_value_04=>'90'
,p_quick_pick_label_05=>'30 Days'
,p_quick_pick_value_05=>'30'
,p_quick_pick_label_06=>'14 Days'
,p_quick_pick_value_06=>'14'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3270703706238363)
,p_name=>'P100_LOGGING_ARCHIVE_ENABLED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Enable Instance Summary Archiving'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3271184455238363)
,p_name=>'P100_LOGGING_ARCHIVE_LOCATION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Instance Archive Location'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3271519975238363)
,p_name=>'P100_LOGGING_MSG_FLOW_RECD'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Log Inbound MessageFlow (not yet implemented)'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3271952589238363)
,p_name=>'P100_LOGGING_MSG_FLOW_RETENTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(11295717440064001)
,p_prompt=>'Message Flow Log Retention (Days) (not yet implemented)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3272674870238364)
,p_name=>'P100_ENGINE_APP_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11295777694064002)
,p_prompt=>'Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Production;production,Development;development'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>production</strong> (default) - prevents editing of diagram for released models</li>',
'    <li><strong>development</strong> - allows editing of diagram for released models</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3274466716238365)
,p_name=>'P100_DUPLICATE_STEP_PREVENTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Duplicate Step Prevention'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:strict;strict,legacy;legacy'
,p_field_template=>wwv_flow_imp.id(12495522548744880132)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>legacy</strong> - Use this option only to support applications that have been developped with Flows for APEX 21.1 and lower without additional development. The engine does not use the step key to prevent duplicate action on a single s'
||'tep.</li>',
'    <li><strong>strict</strong> (recommended) - Use this option for new development and/or fully migrated application. The engine uses the step key to avoid duplicate actions on a single step.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3274892542238365)
,p_name=>'P100_DEFAULT_WORKSPACE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Default Workspace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'Should be set to your default APEX workspace used for Flows for APEX. This is used as a last-resort for scriptTasks and serviceTasks when creating an APEX session or looking for mail templates'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3275221261238365)
,p_name=>'P100_DEFAULT_EMAIL_SENDER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Default Email Sender'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'Should be set to your default email sender, in case outbound mail serviceTasks do not have a sender defined.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3275605822238365)
,p_name=>'P100_DEFAULT_APPLICATION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Default Application Id'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'the application ID of one of your APEX apps that will be provided to create a session'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3276036417238366)
,p_name=>'P100_DEFAULT_PAGEID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Default Page Id'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'the page ID of one of your apps that will be provided to create a session'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3276448525238366)
,p_name=>'P100_DEFAULT_USERNAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Default Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'the username to be user on the APEX session to create a session if no other username is provided	'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3276827580238366)
,p_name=>'P100_TIMER_MAX_CYCLES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(65972703397470872)
,p_prompt=>'Timer Max Cycles'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'For cycle timers, this will defined the maximum number of execution.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3277540906238367)
,p_name=>'P100_TIMER_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5301292362807367)
,p_prompt=>'Timers Enabled'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TRUE'
,p_attribute_03=>'enabled'
,p_attribute_04=>'FALSE'
,p_attribute_05=>'disabled'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3277996439238367)
,p_name=>'P100_TIMER_REPEAT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5301292362807367)
,p_prompt=>'New'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(12495522847445880132)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Hourly'
,p_quick_pick_value_01=>'FREQ=HOURLY;INTERVAL=1'
,p_quick_pick_label_02=>'10 Min'
,p_quick_pick_value_02=>'FREQ=MINUTELY;INTERVAL=10'
,p_quick_pick_label_03=>'5 Min'
,p_quick_pick_value_03=>'FREQ=MINUTELY;INTERVAL=10'
,p_quick_pick_label_04=>'1 Min'
,p_quick_pick_value_04=>'FREQ=MINUTELY;INTERVAL=10'
,p_quick_pick_label_05=>'10 Sec (Production Use - not for apex.oracle.com)'
,p_quick_pick_value_05=>'FREQ=SECONDLY;INTERVAL=10'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3281319608238368)
,p_computation_sequence=>10
,p_computation_item=>'P100_LOGGING_LANGUAGE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_language',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_language',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3281763648238368)
,p_computation_sequence=>20
,p_computation_item=>'P100_LOGGING_LEVEL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_constants_pkg.gc_config_logging_level',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_level',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3282115391238369)
,p_computation_sequence=>30
,p_computation_item=>'P100_LOGGING_HIDE_USERID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_level',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_level',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3279360474238368)
,p_computation_sequence=>40
,p_computation_item=>'P100_LOGGING_RETAIN_LOGS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_retain_logs',
'         , p_default_value => flow_constants_pkg.gc_config_default_log_retain_logs',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3279743741238368)
,p_computation_sequence=>50
,p_computation_item=>'P100_LOGGING_ARCHIVE_ENABLED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_archive_enabled',
'         , p_default_value => flow_constants_pkg.gc_config_default_logging_archive_enabled',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3280148117238368)
,p_computation_sequence=>60
,p_computation_item=>'P100_LOGGING_ARCHIVE_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_logging_archive_location',
'         , p_default_value => null',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3282519076238369)
,p_computation_sequence=>70
,p_computation_item=>'P100_ENGINE_APP_MODE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_constants_pkg.gc_config_engine_app_mode',
'         , p_default_value => flow_constants_pkg.gc_config_default_engine_app_mode',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3284590448238369)
,p_computation_sequence=>80
,p_computation_item=>'P100_DUPLICATE_STEP_PREVENTION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_dup_step_prevention',
'         , p_default_value => flow_constants_pkg.gc_config_default_dup_step_prevention',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3282969427238369)
,p_computation_sequence=>90
,p_computation_item=>'P100_DEFAULT_WORKSPACE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_default_workspace',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_workspace',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3284175664238369)
,p_computation_sequence=>100
,p_computation_item=>'P100_DEFAULT_EMAIL_SENDER'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key => flow_constants_pkg.gc_config_default_email_sender',
'         , p_default_value => null ',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3283383241238369)
,p_computation_sequence=>110
,p_computation_item=>'P100_DEFAULT_APPLICATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>  flow_constants_pkg.gc_config_default_application',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_application',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3283760405238369)
,p_computation_sequence=>120
,p_computation_item=>'P100_DEFAULT_PAGEID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>flow_constants_pkg.gc_config_default_pageid',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_pageid',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3284935282238370)
,p_computation_sequence=>130
,p_computation_item=>'P100_DEFAULT_USERNAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>flow_constants_pkg.gc_config_default_username',
'         , p_default_value => flow_constants_pkg.gc_config_default_default_username',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3285316954238370)
,p_computation_sequence=>140
,p_computation_item=>'P100_TIMER_MAX_CYCLES'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return flow_engine_util.get_config_value(',
'           p_config_key =>flow_constants_pkg.gc_config_timer_max_cycles',
'         , p_default_value => flow_constants_pkg.gc_config_default_timer_max_cycles',
'       );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3280579549238368)
,p_computation_sequence=>150
,p_computation_item=>'P100_TIMER_STATUS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return flow_timers_pkg.get_timer_status;'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3280978951238368)
,p_computation_sequence=>160
,p_computation_item=>'P100_TIMER_REPEAT_INTERVAL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return flow_timers_pkg.get_timer_repeat_interval;'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3285684485238370)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_engine_app_api.set_settings(',
'  pi_logging_language => :P100_LOGGING_LANGUAGE',
', pi_logging_level => :P100_LOGGING_LEVEL',
', pi_logging_hide_userid => :P100_LOGGING_HIDE_USERID',
', pi_engine_app_mode => :P100_ENGINE_APP_MODE',
', pi_duplicate_step_prevention => :P100_DUPLICATE_STEP_PREVENTION',
', pi_default_workspace    => :P100_DEFAULT_WORKSPACE',
', pi_default_email_sender => :P100_DEFAULT_EMAIL_SENDER ',
', pi_default_application  => :P100_DEFAULT_APPLICATION ',
', pi_default_pageid       => :P100_DEFAULT_PAGEID   ',
', pi_default_username     => :P100_DEFAULT_USERNAME',
', pi_timer_max_cycles     => :P100_TIMER_MAX_CYCLES',
', pi_timer_status         => :P100_TIMER_STATUS',
', pi_timer_repeat_interval=> :P100_TIMER_REPEAT_INTERVAL',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3273384211238364)
,p_process_success_message=>'Changes saved.'
);
end;
/
prompt --application/pages/page_09999
begin
wwv_flow_imp_page.create_page(
 p_id=>9999
,p_user_interface_id=>wwv_flow_imp.id(12495499263265880052)
,p_name=>'Login Page'
,p_alias=>'LOGIN'
,p_step_title=>'Flows for APEX'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'[media="(prefers-color-scheme: dark)"]#THEME_DB_IMAGES#5633999520827555.css',
'[media="(prefers-color-scheme: light)"]#THEME_DB_IMAGES#26992397294947328.css'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.login-page-logo {',
'    background-image: url(#APP_IMAGES#workflow_black.svg);',
'    background-repeat: no-repeat;',
'    background-size: cover;',
'    background-color: inherit;',
'}',
'',
'@media (prefers-color-scheme: dark){',
'    .login-page-logo {',
'        background-image: url(#APP_IMAGES#workflow_white.svg);',
'    }',
'}'))
,p_step_template=>wwv_flow_imp.id(12495629732925880320)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_component_map=>'12'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926144145'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12495495236065879932)
,p_plug_name=>'Flows for APEX'
,p_icon_css_classes=>'login-page-logo'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(12495583796584880235)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12495490587764879882)
,p_plug_name=>'Language Selector'
,p_parent_plug_id=>wwv_flow_imp.id(12495495236065879932)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(12495609856182880263)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'apex_lang.emit_language_selector_list;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12495492448748879893)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(12495495236065879932)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(12495521767510880126)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sign In'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_grid_new_row=>'Y'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6176260695209907)
,p_name=>'P9999_THEME_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12495495236065879932)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12495493384485879899)
,p_name=>'P9999_REMEMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12495495236065879932)
,p_prompt=>'Remember username'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'LOGIN_REMEMBER_USERNAME'
,p_lov=>'.'||wwv_flow_imp.id(12495494129921879909)||'.'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(12495523145758880138)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12495494409843879910)
,p_name=>'P9999_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12495495236065879932)
,p_prompt=>'Password'
,p_placeholder=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(12495523145758880138)
,p_item_icon_css_classes=>'fa-key'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12495494855941879918)
,p_name=>'P9999_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12495495236065879932)
,p_prompt=>'Username'
,p_placeholder=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(12495523145758880138)
,p_item_icon_css_classes=>'fa-user'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6176061925209905)
,p_name=>'Get OS Theme Mode Preference'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6176192014209906)
,p_event_id=>wwv_flow_imp.id(6176061925209905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9999_THEME_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(window.matchMedia && window.matchMedia(''(prefers-color-scheme: dark)'').matches) ? ''Vita - Dark'' : ''Vita'';',
''))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6176556209209910)
,p_event_id=>wwv_flow_imp.id(6176061925209905)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.set_session_state(',
'    p_name => ''P9999_THEME_MODE''',
'  , p_value => :P9999_THEME_MODE',
');'))
,p_attribute_02=>'P9999_THEME_MODE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12495491676374879884)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => lower(:P9999_USERNAME),',
'    p_consent  => :P9999_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12495492056597879887)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.login(',
'    p_username => :P9999_USERNAME,',
'    p_password => :P9999_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12495490821799879882)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12495491262319879882)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P9999_USERNAME := apex_authentication.get_login_username_cookie;',
':P9999_REMEMBER := case when :P9999_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(17031066408817192)
,p_welcome_message=>'This application installer will guide you through the process of creating your database objects and seed data.'
,p_configuration_message=>'You can configure the following attributes of your application.'
,p_build_options_message=>'You can choose to include the following build options.'
,p_validation_message=>'The following validations will be performed to ensure your system is compatible with this application.'
,p_install_message=>'Please confirm that you would like to install this application''s supporting objects.'
,p_upgrade_message=>'The application installer has detected that this application''s supporting objects were previously installed.  This wizard will guide you through the process of upgrading these supporting objects.'
,p_upgrade_confirm_message=>'Please confirm that you would like to install this application''s supporting objects.'
,p_upgrade_success_message=>'Your application''s supporting objects have been installed.'
,p_upgrade_failure_message=>'Installation of database objects and seed data has failed.'
,p_deinstall_success_message=>'Deinstallation complete.'
,p_deinstall_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'PROMPT >> Removing Flows4APEX Database Objects',
'PROMPT >> ====================================',
'',
'PROMPT >> Packages',
'drop package flow_logging;',
'drop package flow_plsql_runner_pkg;',
'drop package flow_services;',
'drop package flow_usertask_pkg;',
'drop package flow_tasks;',
'drop package flow_boundary_events;',
'drop package flow_bpmn_parser_pkg;',
'drop package flow_parser_util;',
'drop package flow_migrate_xml_pkg;',
'drop package flow_expressions;',
'drop package flow_settings;',
'drop package flow_db_exec;',
'drop package flow_message_flow;',
'drop package flow_message_util;',
'drop package flow_message_util_ee;',
'drop package flow_proc_vars_int;',
'drop package flow_instances;',
'drop package flow_engine;',
'drop package flow_api_pkg;',
'drop package flow_admin_api;',
'drop package flow_timers_pkg;',
'drop package flow_reservations;',
'drop package flow_gateways;',
'drop package flow_iteration;',
'drop package flow_engine_util;',
'drop package flow_types_pkg;',
'drop package flow_constants_pkg;',
'drop package flow_engine_app_api;',
'drop package flow_call_activities;',
'drop package flow_subprocesses;',
'drop package flow_apex_session;',
'drop package flow_errors;',
'drop package flow_globals;',
'drop package flow_diagram;',
'drop package flow_theme_api;',
'drop package flow_apex_env;',
'drop package flow_log_admin;',
'drop package flow_process_vars;',
'drop package flow_statistics;',
'drop package flow_simple_form_template;',
'drop package flow_rest_constants;',
'drop package flow_rest;',
'drop package flow_rest_auth;',
'drop package flow_rest_logging;',
'drop package flow_rest_response;',
'drop package flow_rest_errors;',
'drop package flow_rest_api_v1;',
'drop package flow_rest_install;',
'',
'PROMPT >> Modeler Plugin Objects',
'drop package flow_modeler;',
'',
'PROMPT >> Viewer Plugin Objects',
'drop package flow_viewer;',
'',
'PROMPT >> Process Plugin Objects',
'drop package flow_plugin_manage_instance;',
'drop package flow_plugin_manage_instance_step;',
'drop package flow_plugin_manage_instance_variables;',
'',
'PROMPT >> Views',
'drop view flow_p0002_diagrams_vw;',
'drop view flow_p0007_vw;',
'drop view flow_p0007_diagrams_var_vw;',
'drop view flow_p0007_diagrams_attributes_vw;',
'drop view flow_p0008_instance_details_vw;',
'drop view flow_p0007_called_diagrams_vw;',
'drop view flow_p0007_calling_diagrams_vw;',
'drop view flow_p0008_instance_log_vw;',
'drop view flow_p0008_message_subscriptions_vw;',
'drop view flow_p0008_subflows_vw;',
'drop view flow_p0008_variables_vw;',
'drop view flow_p0008_vw;',
'drop view flow_p0010_instances_vw;',
'drop view flow_p0010_vw;',
'drop view flow_p0013_attributes_vw;',
'drop view flow_p0013_expressions_vw;',
'drop view flow_p0013_instance_log_vw;',
'drop view flow_p0013_step_log_vw;',
'drop view flow_p0013_subflows_vw;',
'drop view flow_p0013_variable_log_vw;',
'drop view flow_p0013_called_diagrams_vw;',
'drop view flow_p0014_instance_log_vw;',
'drop view flow_p0014_step_log_vw;',
'drop view flow_p0014_subflows_vw;',
'drop view flow_p0014_variable_log_vw;',
'drop view flow_p0020_instance_timeline_vw;',
'drop view flow_task_inbox_vw;',
'drop view flow_instance_connections_lov;',
'drop view flow_instance_scopes_vw;',
'drop view flow_instance_gateways_lov;',
'drop view flow_instance_details_vw;',
'drop view flow_instance_timeline_vw;',
'drop view flow_instance_variables_vw;',
'drop view flow_instances_vw;',
'drop view flow_subflows_vw;',
'drop view flow_diagram_categories_lov;',
'drop view flow_diagrams_parsed_lov;',
'drop view flow_diagrams_vw;',
'drop view flow_instance_diagrams_lov;',
'drop view flow_diagrams_instanciated_lov;',
'drop view flow_startable_diagrams_vw;',
'drop view flow_message_subscriptions_vw;',
'drop view flow_rest_diagrams_vw;',
'drop view flow_rest_message_subscriptions_vw;',
'drop view flow_rest_process_vars_vw;',
'drop view flow_rest_processes_vw;',
'drop view flow_rest_subflows_vw;',
'drop view flow_apex_my_combined_task_list_vw;',
'drop view flow_apex_task_inbox_my_tasks_vw;',
'drop view flow_apex_task_inbox_vw;',
'',
'',
'PROMPT >> Tables',
'drop table flow_connections cascade constraints;',
'drop table flow_objects cascade constraints;',
'drop table flow_message_subscriptions cascade constraints;',
'drop table flow_processes cascade constraints;',
'drop table flow_iterations cascade constraints;',
'drop table flow_iterated_objects cascade constraints;',
'drop table flow_subflows cascade constraints;',
'drop table flow_subflow_log cascade constraints;',
'drop table flow_diagrams cascade constraints;',
'drop table flow_timers cascade constraints;',
'drop table flow_process_variables cascade constraints;',
'drop table flow_object_expressions cascade constraints;',
'drop table flow_flow_event_log cascade constraints;',
'drop table flow_instance_event_log cascade constraints;',
'drop table flow_instance_diagrams cascade constraints;',
'drop table flow_step_event_log cascade constraints;',
'drop table flow_variable_event_log cascade constraints;',
'drop table flow_configuration cascade constraints;',
'drop table flow_messages cascade constraints;',
'drop table flow_instance_stats cascade constraints;',
'drop table flow_message_received_log cascade constraints;',
'drop table flow_parser_log cascade constraints;',
'drop table flow_stats_history cascade constraints;',
'drop table flow_step_stats cascade constraints;',
'drop table flow_rest_event_log cascade constraints;',
'drop table flow_iterations cascade constraints;',
'drop table flow_iterated_objects cascade constraints;',
'drop table flow_simple_form_templates cascade constraints;',
'',
'PROMPT >> Finished Removal of Flows4APEX Database Objects',
'PROMPT >> ===============================================',
''))
,p_required_free_kb=>100
,p_required_sys_privs=>'CREATE PROCEDURE:CREATE TABLE:CREATE TRIGGER:CREATE VIEW'
);
end;
/
prompt --application/deployment/install/install_tables
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10373674600425210)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Tables'
,p_sequence=>10
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Generated by Oracle SQL Developer Data Modeler 20.2.0.167.1538',
'--   at:        2020-09-29 10:41:45 CEST',
'--   site:      Oracle Database 12cR2',
'--   type:      Oracle Database 12cR2',
'',
'-- edited by Richard Allen (Oracle) Feb 2022',
'-- (c) Copyright, Oracle Corporation and/or its associates.  2020-2023.',
'-- edited by Richard Allen (Flowquest) Jan 2024',
'-- (c) Copyright, Flowquest Limited. 2024',
'',
'',
'-- predefined type, no DDL - SDO_GEOMETRY',
'',
'-- predefined type, no DDL - XMLTYPE',
'',
'CREATE TABLE flow_connections (',
'    conn_id           NUMBER',
'        GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 CACHE 20 )',
'    NOT NULL,',
'    conn_bpmn_id      VARCHAR2(50 CHAR) NOT NULL,',
'    conn_dgrm_id      NUMBER NOT NULL,',
'    conn_name         VARCHAR2(200 CHAR),',
'    conn_src_objt_id  NUMBER,',
'    conn_tgt_objt_id  NUMBER,',
'    conn_tag_name     VARCHAR2(50 CHAR),',
'    conn_origin       VARCHAR2(50 CHAR),',
'    conn_is_default   NUMBER DEFAULT 0 NOT NULL,',
'    conn_sequence     NUMBER,               ',
'    conn_attributes   CLOB      ',
');  ',
'',
'ALTER TABLE flow_connections ADD CONSTRAINT conn_pk PRIMARY KEY ( conn_id );',
'',
'ALTER TABLE flow_connections ADD CONSTRAINT conn_uk UNIQUE ( conn_dgrm_id,',
'                                                             conn_bpmn_id );',
'',
'ALTER TABLE flow_connections ADD CONSTRAINT conn_default_ck CHECK ( conn_is_default IN ( 0, 1 ) );',
'',
'alter table flow_connections add constraint conn_attributes_ck check ( conn_attributes is json );',
'',
'CREATE TABLE flow_diagrams (',
'    dgrm_id       NUMBER',
'        GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 NOCACHE )',
'    NOT NULL,',
'    dgrm_name     VARCHAR2(150 CHAR) NOT NULL,',
'    dgrm_version  VARCHAR2(10 CHAR) DEFAULT ''0'' NOT NULL,',
'    dgrm_status   VARCHAR2(10 CHAR) DEFAULT ''draft'' NOT NULL,',
'    dgrm_category VARCHAR2(30 CHAR),',
'    dgrm_last_update TIMESTAMP WITH TIME ZONE DEFAULT systimestamp NOT NULL,',
'    dgrm_content  CLOB',
');',
'',
'ALTER TABLE flow_diagrams ADD CONSTRAINT dgrm_pk PRIMARY KEY ( dgrm_id );',
'',
'ALTER TABLE flow_diagrams ADD CONSTRAINT dgrm_uk UNIQUE ( dgrm_name , dgrm_version);',
'',
'ALTER TABLE flow_diagrams ADD CONSTRAINT dgrm_status_ck CHECK ( dgrm_status in (''draft'',''released'',''deprecated'',''archived''));',
'',
'-- ensure only 1 released version of a diagram exists',
'CREATE UNIQUE INDEX dgrm_uk2 ON FLOW_DIAGRAMS ( DGRM_NAME, case DGRM_STATUS when ''released'' then null else dgrm_version end );',
'',
'CREATE TABLE flow_objects (',
'    objt_id            NUMBER',
'        GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 CACHE 20 )',
'    NOT NULL,',
'    objt_bpmn_id       VARCHAR2(50 CHAR) NOT NULL,',
'    objt_dgrm_id       NUMBER NOT NULL,',
'    objt_name          VARCHAR2(200 CHAR),',
'    objt_tag_name      VARCHAR2(50 CHAR),',
'    objt_sub_tag_name  VARCHAR2(50 CHAR),',
'    objt_objt_id       NUMBER,',
'    objt_objt_lane_id  NUMBER,',
'    objt_attached_to   VARCHAR2(50 CHAR),',
'    objt_interrupting  NUMBER,',
'    objt_attributes    CLOB',
');',
'',
'COMMENT ON COLUMN flow_objects.objt_objt_lane_id IS',
'    ''Reference to Lane if any.'';',
'',
'ALTER TABLE flow_objects ADD CONSTRAINT objt_pk PRIMARY KEY ( objt_id );',
'',
'ALTER TABLE flow_objects ADD CONSTRAINT objt_uk UNIQUE ( objt_dgrm_id,',
'                                                         objt_bpmn_id );',
'',
'alter table flow_objects add constraint objt_attributes_ck check ( objt_attributes is json );',
'',
'CREATE TABLE flow_processes (',
'    prcs_id             NUMBER',
'        GENERATED ALWAYS AS IDENTITY ( START WITH 1 NOCACHE )',
'    NOT NULL,',
'    prcs_dgrm_id        NUMBER NOT NULL,',
'    prcs_name           VARCHAR2(150 CHAR) NOT NULL,',
'    prcs_status         VARCHAR2(20 CHAR) NOT NULL,',
'    prcs_init_ts        TIMESTAMP WITH TIME ZONE NOT NULL,',
'    prcs_init_by        VARCHAR2(255 CHAR),',
'    prcs_start_ts       TIMESTAMP WITH TIME ZONE,',
'    prcs_complete_ts    TIMESTAMP WITH TIME ZONE,  ',
'    prcs_due_on         TIMESTAMP WITH TIME ZONE,',
'    prcs_archived_ts    TIMESTAMP WITH TIME ZONE,',
'    prcs_priority       NUMBER,',
'    prcs_last_update    TIMESTAMP WITH TIME ZONE,',
'    prcs_last_update_by VARCHAR2(255 CHAR)',
');',
'',
'ALTER TABLE flow_processes ADD CONSTRAINT prcs_pk PRIMARY KEY ( prcs_id );',
'',
'create index flow_prcs_dgrm_status_ix on flow_processes (prcs_dgrm_id, prcs_status);',
'',
'CREATE TABLE flow_subflow_log (',
'    sflg_prcs_id                NUMBER NOT NULL,',
'    sflg_objt_id                VARCHAR2(50) NOT NULL,',
'    sflg_sbfl_id                NUMBER NOT NULL,',
'    sflg_step_key               VARCHAR2(20 CHAR),',
'    sflg_dgrm_id                NUMBER,',
'    sflg_scope                  NUMBER,',
'    sflg_diagram_level          NUMBER,',
'    sflg_iter_id                NUMBER,',
'    sflg_last_updated           DATE,',
'    sflg_notes                  VARCHAR2(200)',
');',
'',
'create index flow_sflg_iter_ix on flow_subflow_log (sflg_prcs_id, sflg_dgrm_id  , sflg_diagram_level );',
'',
'CREATE TABLE flow_subflows (',
'    sbfl_id                         NUMBER',
'        GENERATED ALWAYS AS IDENTITY ( START WITH 1 NOCACHE )',
'    NOT NULL,',
'    sbfl_prcs_id                    NUMBER NOT NULL,',
'    sbfl_dgrm_id                    NUMBER NOT NULL,',
'    sbfl_sbfl_id                    NUMBER,',
'    sbfl_process_level              NUMBER,',
'    sbfl_diagram_level              NUMBER,',
'    sbfl_calling_sbfl               NUMBER,',
'    sbfl_scope                      NUMBER,',
'    sbfl_starting_object            VARCHAR2(50 CHAR),',
'    sbfl_route                      VARCHAR2(100 CHAR),',
'    sbfl_last_completed             VARCHAR2(50 CHAR),',
'    sbfl_current                    VARCHAR2(50 CHAR),',
'    sbfl_step_key                   VARCHAR2(20 CHAR) not null,',
'    sbfl_due_on                     TIMESTAMP WITH TIME ZONE,',
'    sbfl_priority                   NUMBER,',
'    sbfl_status                     VARCHAR2(20 CHAR),',
'    sbfl_became_current             TIMESTAMP WITH TIME ZONE,',
'    sbfl_work_started               TIMESTAMP WITH TIME ZONE,',
'    sbfl_has_events                 VARCHAR2(200 CHAR),',
'    sbfl_is_following_ebg           VARCHAR2(1 CHAR),',
'    sbfl_lane                       VARCHAR2(50 CHAR),',
'    sbfl_lane_name                  VARCHAR2(200 CHAR), /*cannot always be looked up with callActivities so must include */',
'    sbfl_lane_isRole                VARCHAR2(10 CHAR), /*cannot always be looked up with callActivities so must include */',
'    sbfl_lane_role                  VARCHAR2(200 CHAR), /*cannot always be looked up with callActivities so must include */',
'    sbfl_reservation                VARCHAR2(255 CHAR),',
'    sbfl_potential_users            VARCHAR2(4000 CHAR),',
'    sbfl_potential_groups           VARCHAR2(4000 CHAR),',
'    sbfl_excluded_users             VARCHAR2(4000 CHAR),',
'    sbfl_iteration_type             VARCHAR2(10 CHAR),',
'    sbfl_iobj_id                    NUMBER,',
'    sbfl_iter_id                    NUMBER,',
'    sbfl_iteration_var              VARCHAR2(50 CHAR),  -- remove after rewrite - acessible through flow_iterated_objects',
'    sbfl_iteration_var_scope        NUMBER, -- remove after rewrite - acessible through flow_iterated_objects',
'    sbfl_loop_counter               NUMBER,',
'    sbfl_loop_total_instances       NUMBER,',
'    sbfl_last_update                TIMESTAMP WITH TIME ZONE NOT NULL,',
'    sbfl_last_update_by             VARCHAR2(255 CHAR)',
');',
'',
'ALTER TABLE flow_subflows ADD CONSTRAINT sbfl_pk PRIMARY KEY ( sbfl_id );',
'',
'ALTER TABLE flow_subflows ADD CONSTRAINT sbfl_ck_following_ebg_yn CHECK (sbfl_is_following_ebg in (''Y'',''N''));',
'',
'create index flow_sbfl_dgrm_prcs_ix on flow_subflows( sbfl_dgrm_id, sbfl_prcs_id );',
'',
'CREATE TABLE flow_instance_diagrams (',
'    prdg_id             NUMBER GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 NOCACHE ORDER )',
'                        NOT NULL,',
'    prdg_prdg_id        NUMBER,                    ',
'    prdg_prcs_id        NUMBER NOT NULL,',
'    prdg_dgrm_id        NUMBER NOT NULL,',
'    prdg_calling_dgrm   NUMBER,',
'    prdg_calling_objt   VARCHAR2(50 CHAR),',
'    prdg_diagram_level  NUMBER',
');',
'',
'alter table flow_instance_diagrams',
'  add constraint flow_prdg_pk primary key ( prdg_id )',
';',
'',
'create index flow_prdg_dgrm_prcs_ix',
'  on flow_instance_diagrams (prdg_prcs_id, prdg_dgrm_id);',
'',
'create table flow_iterated_objects (',
'    iobj_id             NUMBER GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 NOCACHE ORDER )',
'                        NOT NULL,',
'    iobj_prcs_id        NUMBER NOT NULL,',
'    iobj_diagram_level  NUMBER NOT NULL,',
'    iobj_dgrm_id        NUMBER NOT NULL,',
'    iobj_parent_bpmn_id VARCHAR2(50 CHAR) not null,',
'    iobj_step_key       VARCHAR2(20 CHAR) not null,',
'    iobj_iteration_var  VARCHAR2(50 CHAR) not null,',
'    iobj_var_scope      NUMBER not null,',
'    iobj_objt_type      VARCHAR2(15 char),',
'    iobj_iteration_type VARCHAR2(10 char),',
'    iobj_parent_iter_id NUMBER,',
'    iobj_display_name   VARCHAR2 (400 CHAR)',
');',
'',
'alter table flow_iterated_objects',
'  add constraint flow_iobj_pk primary key (iobj_id);',
'',
'alter table flow_iterated_objects',
'  add constraint flow_iobj_uk unique    ( iobj_prcs_id',
'                                        , iobj_iteration_var',
'                                        , iobj_var_scope);',
'',
'create index flow_iobj_step_key_ix on flow_iterated_objects',
'                                        ( iobj_prcs_id',
'                                        , iobj_step_key);',
'',
'create table flow_iterations (',
'    iter_id             NUMBER GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 NOCACHE ORDER )',
'                        NOT NULL,',
'    iter_prcs_id        number not null,',
'    iter_iobj_id        number not null,',
'    iter_loop_counter   number not null,',
'    iter_sbfl_id        number,',
'    iter_scope          number,',
'    iter_step_key       varchar2(20 char),',
'    iter_status         varchar2(10 char),',
'    iter_description    varchar2(200 char),',
'    iter_display_name   VARCHAR2 (400 CHAR),',
'    iter_inputs         clob,',
'    iter_outputs        clob',
');',
'',
'alter table flow_iterations',
'    add constraint flow_iter_pk primary key (iter_id);',
'',
'alter table flow_iterations',
'    add constraint flow_iter_uk unique  ( iter_prcs_id ',
'                                        , iter_iobj_id',
'                                        , iter_loop_counter);',
'',
'alter table flow_iterations add constraint iter_iobj_fk foreign key (iter_iobj_id) ',
'                                           references flow_iterated_objects (iobj_id)',
'                                           on delete cascade;        ',
'',
'alter table flow_iterated_objects add constraint iobj_parent_iter_fk foreign key (iobj_parent_iter_id) ',
'                                           references flow_iterations (iter_id)',
'                                           on delete cascade;                                                ',
'                                                                                                                                                              ',
'',
'alter table flow_iterations add constraint iter_inputs_is_json_ck check ( iter_inputs is json );',
'',
'alter table flow_iterations add constraint iter_outputs_is_json_ck check ( iter_outputs is json );',
'',
'CREATE TABLE flow_timers (',
'    timr_id            NUMBER',
'        GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 NOCACHE ORDER )',
'    NOT NULL,',
'    timr_run           NUMBER DEFAULT 1 NOT NULL,',
'    timr_prcs_id       NUMBER NOT NULL,',
'    timr_sbfl_id       NUMBER NOT NULL,',
'    timr_step_key      VARCHAR2(20 CHAR),',
'    timr_type          VARCHAR2(50 CHAR) NOT NULL,',
'    timr_last_run      TIMESTAMP WITH TIME ZONE,',
'    timr_created_on    TIMESTAMP WITH TIME ZONE NOT NULL,',
'    timr_status        VARCHAR2(1 CHAR) NOT NULL,',
'    timr_start_on      TIMESTAMP WITH TIME ZONE,',
'    timr_interval_ym   INTERVAL YEAR TO MONTH,',
'    timr_interval_ds   INTERVAL DAY TO SECOND,',
'    timr_repeat_times  NUMBER,',
'    timr_callback      VARCHAR2(200 CHAR),',
'    timr_callback_par  varchar2(200 CHAR)',
');',
'',
'CREATE INDEX timr_prcs_sbfl_ix ON',
'    flow_timers (',
'        timr_prcs_id',
'    ASC,',
'        timr_sbfl_id',
'    ASC );',
'',
'ALTER TABLE flow_timers ADD CONSTRAINT timr_pk PRIMARY KEY ( timr_id , timr_run);',
'',
'create table flow_message_subscriptions (',
'    msub_id                 number GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 ) NOT NULL, ',
'    msub_message_name	    varchar2(200 char),	',
'    msub_key_name	        varchar2(200 char),	',
'    msub_key_value	        varchar2(200 char),	',
'    msub_prcs_id	        number,	',
'    msub_sbfl_id	        number,	',
'    msub_step_key	        varchar2( 20 char),	',
'    msub_dgrm_id            number,',
'    msub_callback           varchar2(200 char),',
'    msub_callback_par       varchar2(200 char),',
'    msub_payload_var        varchar2(50 char),',
'    msub_created	        timestamp with time zone	',
');',
'',
'',
'alter table flow_message_subscriptions',
'  add constraint flow_msub_pk primary key ( msub_id )',
';',
'',
'alter table flow_message_subscriptions',
'    add constraint flow_msub_uk UNIQUE (msub_message_name, msub_key_name, msub_key_value);',
'',
'create index flow_msub_prcs_sbfl_ix on flow_message_subscriptions( msub_prcs_id, msub_sbfl_id );  ',
'',
'',
'',
'ALTER TABLE flow_connections',
'    ADD CONSTRAINT conn_dgrm_fk FOREIGN KEY ( conn_dgrm_id )',
'        REFERENCES flow_diagrams ( dgrm_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_connections',
'    ADD CONSTRAINT conn_src_objt_fk FOREIGN KEY ( conn_src_objt_id )',
'        REFERENCES flow_objects ( objt_id )',
'            ON DELETE SET NULL;',
'',
'ALTER TABLE flow_connections',
'    ADD CONSTRAINT conn_tgt_objt_fk FOREIGN KEY ( conn_tgt_objt_id )',
'        REFERENCES flow_objects ( objt_id )',
'            ON DELETE SET NULL;',
'',
'ALTER TABLE flow_objects',
'    ADD CONSTRAINT objt_dgrm_fk FOREIGN KEY ( objt_dgrm_id )',
'        REFERENCES flow_diagrams ( dgrm_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_objects',
'    ADD CONSTRAINT objt_objt_fk FOREIGN KEY ( objt_objt_id )',
'        REFERENCES flow_objects ( objt_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_objects',
'    ADD CONSTRAINT objt_objt_lane_fk FOREIGN KEY ( objt_objt_lane_id )',
'        REFERENCES flow_objects ( objt_id )',
'            ON DELETE SET NULL;',
'',
'ALTER TABLE flow_processes',
'    ADD CONSTRAINT prcs_dgrm_fk FOREIGN KEY ( prcs_dgrm_id )',
'        REFERENCES flow_diagrams ( dgrm_id );',
'',
'ALTER TABLE flow_subflows',
'    ADD CONSTRAINT sbfl_parent_sbfl_fk FOREIGN KEY ( sbfl_sbfl_id )',
'        REFERENCES flow_subflows ( sbfl_id )',
'            ON DELETE SET NULL;',
'',
'ALTER TABLE flow_subflows',
'    ADD CONSTRAINT sbfl_dgrm_fk FOREIGN KEY ( sbfl_dgrm_id )',
'        REFERENCES flow_diagrams ( dgrm_id );',
'',
'ALTER TABLE flow_subflows',
'    ADD CONSTRAINT sbfl_prcs_fk FOREIGN KEY ( sbfl_prcs_id )',
'        REFERENCES flow_processes ( prcs_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_instance_diagrams',
'    ADD CONSTRAINT prdg_prcs_fk FOREIGN KEY ( prdg_prcs_id )',
'        REFERENCES flow_processes ( prcs_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_instance_diagrams',
'    ADD CONSTRAINT prdg_dgrm_fk FOREIGN KEY ( prdg_dgrm_id )',
'        REFERENCES flow_diagrams ( dgrm_id );',
'',
'ALTER TABLE flow_instance_diagrams',
'    ADD CONSTRAINT prdg_calling_dgrm_fk FOREIGN KEY ( prdg_calling_dgrm )',
'        REFERENCES flow_diagrams ( dgrm_id );',
'',
'ALTER TABLE flow_timers',
'    ADD CONSTRAINT timr_prcs_fk FOREIGN KEY ( timr_prcs_id )',
'        REFERENCES flow_processes ( prcs_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_timers',
'    ADD CONSTRAINT timr_sbfl_fk FOREIGN KEY ( timr_sbfl_id )',
'        REFERENCES flow_subflows ( sbfl_id )',
'            ON DELETE CASCADE;',
'    ',
'alter table flow_message_subscriptions',
'    add constraint flow_msub_prcs_fk FOREIGN KEY ( msub_prcs_id )',
'        references flow_processes (prcs_id)',
'            ON DELETE CASCADE;',
'',
'alter table flow_message_subscriptions',
'    add constraint flow_msub_sbfl_fk FOREIGN KEY ( msub_sbfl_id )',
'        references flow_subflows (sbfl_id)',
'            ON DELETE CASCADE;',
'',
'alter table flow_message_subscriptions',
'    add constraint flow_msub_dgrm_fk FOREIGN KEY ( msub_dgrm_id )',
'        references flow_diagrams (dgrm_id)',
'            ON DELETE CASCADE;',
'            ',
'-- Oracle SQL Developer Data Modeler Summary Report: ',
'-- ',
'-- CREATE TABLE                             8',
'-- CREATE INDEX                             1',
'-- ALTER TABLE                             23',
'-- CREATE VIEW                              0',
'-- ALTER VIEW                               0',
'-- CREATE PACKAGE                           0',
'-- CREATE PACKAGE BODY                      0',
'-- CREATE PROCEDURE                         0',
'-- CREATE FUNCTION                          0',
'-- CREATE TRIGGER                           0',
'-- ALTER TRIGGER                            0',
'-- CREATE COLLECTION TYPE                   0',
'-- CREATE STRUCTURED TYPE                   0',
'-- CREATE STRUCTURED TYPE BODY              0',
'-- CREATE CLUSTER                           0',
'-- CREATE CONTEXT                           0',
'-- CREATE DATABASE                          0',
'-- CREATE DIMENSION                         0',
'-- CREATE DIRECTORY                         0',
'-- CREATE DISK GROUP                        0',
'-- CREATE ROLE                              0',
'-- CREATE ROLLBACK SEGMENT                  0',
'-- CREATE SEQUENCE                          0',
'-- CREATE MATERIALIZED VIEW                 0',
'-- CREATE MATERIALIZED VIEW LOG             0',
'-- CREATE SYNONYM                           0',
'-- CREATE TABLESPACE                        0',
'-- CREATE USER                              0',
'-- ',
'-- DROP TABLESPACE                          0',
'-- DROP DATABASE                            0',
'-- ',
'-- REDACTION POLICY                         0',
'-- ',
'-- ORDS DROP SCHEMA                         0',
'-- ORDS ENABLE SCHEMA                       0',
'-- ORDS ENABLE OBJECT                       0',
'-- ',
'-- ERRORS                                   0',
'-- WARNINGS                                 0',
'',
'-- Additional Objects not yet engineered in data modeler',
'',
'create table flow_process_variables',
'( prov_prcs_id      number not null',
', prov_scope        number not null',
', prov_var_name     varchar2(50 char) not null',
', prov_var_type     varchar2(50 char) not null ',
', prov_var_vc2      varchar2(4000 char)',
', prov_var_num      number',
', prov_var_date     date',
', prov_var_tstz     timestamp with time zone',
', prov_var_clob     clob',
', prov_var_json     clob',
', prov_var_name_uc  varchar2(50 char) generated always as ( upper(prov_var_name) )',
');',
'',
'alter table flow_process_variables add constraint prov_pk primary key (prov_prcs_id, prov_scope, prov_var_name_uc);',
'',
'',
'alter table flow_process_variables add constraint prov_prcs_fk foreign key (prov_prcs_id)',
'   references flow_processes (prcs_id)',
'   on delete cascade;',
'',
'alter table flow_process_variables add constraint prov_is_json check ( prov_var_json is json);',
'',
'',
'CREATE TABLE flow_object_expressions (',
'    expr_id          NUMBER',
'        GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 CACHE 20 )',
'    NOT NULL,',
'    expr_objt_id     NUMBER NOT NULL,',
'    expr_set         VARCHAR2(20 CHAR) NOT NULL,',
'    expr_order       NUMBER NOT NULL,',
'    expr_var_name    VARCHAR2(50 CHAR) NOT NULL,',
'    expr_var_type    VARCHAR2(50 CHAR) NOT NULL,',
'    expr_type        VARCHAR2(130 CHAR) NOT NULL,',
'    expr_expression  VARCHAR2(4000 CHAR) ',
' );',
'',
'ALTER TABLE flow_object_expressions ADD CONSTRAINT expr_pk PRIMARY KEY (expr_id);                                                     ',
'',
'ALTER TABLE flow_object_expressions ',
'    ADD CONSTRAINT expr_uk UNIQUE ( expr_objt_id, expr_set, expr_order);',
'  ',
'ALTER TABLE flow_object_expressions',
'    ADD CONSTRAINT expr_objt_fk FOREIGN KEY ( expr_objt_id )',
'        REFERENCES flow_objects ( objt_id )',
'            ON DELETE CASCADE;',
'',
'ALTER TABLE flow_object_expressions',
'    ADD CONSTRAINT expr_set_ck',
'      CHECK ( expr_set in (''beforeEvent'', ''onEvent'', ''beforeTask'', ''afterTask'', ''beforeSplit'', ''afterMerge'', ''inVariables'', ''outVariables'') );',
'',
'/* Event logging Tables */',
'',
'create table flow_flow_event_log',
'( lgfl_dgrm_id       		    NUMBER NOT NULL',
', lgfl_dgrm_name     		    VARCHAR2(150 CHAR)',
', lgfl_dgrm_version  		    VARCHAR2(10 CHAR) ',
', lgfl_dgrm_status   		    VARCHAR2(10 CHAR) ',
', lgfl_dgrm_category 		    VARCHAR2(30 CHAR)',
', lgfl_timestamp 			    TIMESTAMP WITH TIME ZONE NOT NULL',
', lgfl_user				        VARCHAR2(255 char)',
', lgfl_comment                  VARCHAR2(2000 CHAR)',
', lgfl_dgrm_archive_location    VARCHAR2(2000 CHAR)',
');',
'',
'create table flow_instance_event_log',
'( lgpr_prcs_id           	NUMBER NOT NULL',
', lgpr_objt_id              VARCHAR2(50 CHAR) NULL',
', lgpr_dgrm_id      		NUMBER NOT NULL',
', lgpr_prcs_name         	VARCHAR2(150 CHAR) NOT NULL',
', lgpr_business_id			VARCHAR2(4000 char)',
', lgpr_prcs_event       	VARCHAR2(20 CHAR) NOT NULL',
', lgpr_timestamp     		TIMESTAMP WITH TIME ZONE NOT NULL',
', lgpr_duration             interval day(3) to second (3)',
', lgpr_user 				VARCHAR2(255 char)',
', lgpr_comment				VARCHAR2(2000 CHAR)',
', lgpr_error_info           VARCHAR2(2000 CHAR)',
');',
'',
'create index flow_lgpr_ix on flow_instance_event_log (lgpr_prcs_id, lgpr_objt_id );',
'',
'create table flow_step_event_log',
'( lgsf_prcs_id       		NUMBER NOT NULL',
', lgsf_objt_id       		VARCHAR2(50) NOT NULL',
', lgsf_sbfl_id      		NUMBER NOT NULL',
', lgsf_step_key             VARCHAR2(20 CHAR)',
', lgsf_sbfl_process_level   NUMBER',
', lgsf_last_completed 	    VARCHAR2(50) ',
', lgsf_status_when_complete VARCHAR2(20)',
', lgsf_sbfl_dgrm_id   	    NUMBER NOT NULL',
', lgsf_was_current		    TIMESTAMP WITH TIME ZONE',
', lgsf_started 			    TIMESTAMP WITH TIME ZONE',
', lgsf_completed 			TIMESTAMP WITH TIME ZONE ',
', lgsf_reservation		    VARCHAR2(255 char)',
', lgsf_due_on               TIMESTAMP WITH TIME ZONE ',
', lgsf_priority             NUMBER',
', lgsf_user				    VARCHAR2(255 char)	',
', lgsf_comment         	    VARCHAR2(2000 CHAR)',
');',
'',
'create index flow_lgsf_ix on flow_step_event_log (lgsf_prcs_id, lgsf_objt_id );',
'',
'create table flow_variable_event_log',
'( lgvr_prcs_id			    number not null',
', lgvr_scope                number not null',
', lgvr_var_name			    varchar2(50 char) not null',
', lgvr_objt_id			    VARCHAR2(50 char) ',
', lgvr_sbfl_id			    NUMBER',
', lgvr_expr_set			    VARCHAR2(20 CHAR) ',
', lgvr_timestamp			TIMESTAMP WITH TIME ZONE NOT NULL',
', lgvr_var_type			    varchar2(50 char) not null ',
', lgvr_var_vc2 			    varchar2(4000 char)',
', lgvr_var_num 			    number',
', lgvr_var_date 			date',
', lgvr_var_tstz 			timestamp with time zone',
', lgvr_var_clob 			clob',
', lgvr_var_json             clob',
');',
'',
'create index flow_lgvr_ix on flow_variable_event_log (lgvr_prcs_id, lgvr_scope, lgvr_var_name);',
'',
'create table flow_message_received_log',
'( lgrx_id                   number generated always as identity (start with 1) not null',
', lgrx_message_name	        varchar2(200 char)',
', lgrx_key_name	            varchar2(200 char)',
', lgrx_key_value	          varchar2(200 char)',
', lgrx_payload              clob',
', lgrx_prcs_id	            number',
', lgrx_sbfl_id	            number',
', lgrx_received_on          timestamp with time zone',
', lgrx_was_correlated       varchar2(1 char)',
', lgrx_comment              varchar2(200 char)',
');',
'',
'alter table flow_message_received_log',
'  add constraint flow_lgrx_pk primary key ( lgrx_id )',
';',
'',
'',
'/* Statistics Tables */',
'',
'create table flow_instance_stats',
'( stpr_dgrm_id              number',
', stpr_period_start         date',
', stpr_period               varchar2(10 char)',
', stpr_created              number',
', stpr_started              number',
', stpr_error                number',
', stpr_completed            number',
', stpr_terminated           number',
', stpr_reset                number',
', stpr_duration_10pc_ivl    interval day(3) to second(0)',
', stpr_duration_50pc_ivl    interval day(3) to second(0)',
', stpr_duration_90pc_ivl    interval day(3) to second(0)',
', stpr_duration_max_ivl     interval day(3) to second(0)',
', stpr_duration_10pc_sec    number',
', stpr_duration_50pc_sec    number',
', stpr_duration_90pc_sec    number',
', stpr_duration_max_sec     number',
');',
'',
'create unique index flow_stpr_ux on flow_instance_stats (stpr_dgrm_id, stpr_period, stpr_period_start);',
'',
'alter table flow_instance_stats',
'    add constraint flow_stpr_period_type_ck',
'      check ( stpr_period in (''DAY'' ,''MONTH'', ''MTD'', ''QUARTER'',''YEAR'') );',
'',
'create table flow_step_stats',
'( stsf_dgrm_id             number',
', stsf_objt_bpmn_id        varchar2(50 char)',
', stsf_tag_name            varchar2(50 char)',
', stsf_period_start        date',
', stsf_period              varchar2(10 char)',
', stsf_completed           number',
', stsf_duration_10pc_ivl   interval day(3) to second(3)',
', stsf_duration_50pc_ivl   interval day(3) to second(3)',
', stsf_duration_90pc_ivl   interval day(3) to second(3)',
', stsf_duration_max_ivl    interval day(3) to second(3)',
', stsf_duration_10pc_sec   number',
', stsf_duration_50pc_sec   number',
', stsf_duration_90pc_sec   number',
', stsf_duration_max_sec    number',
', stsf_waiting_10pc_ivl    interval day(3) to second(3)',
', stsf_waiting_50pc_ivl    interval day(3) to second(3)',
', stsf_waiting_90pc_ivl    interval day(3) to second(3)',
', stsf_waiting_max_ivl     interval day(3) to second(3)',
', stsf_waiting_10pc_sec    number',
', stsf_waiting_50pc_sec    number',
', stsf_waiting_90pc_sec    number',
', stsf_waiting_max_sec     number',
');',
'',
'create unique index flow_stsf_ux on flow_step_stats (stsf_dgrm_id, stsf_objt_bpmn_id, stsf_period, stsf_period_start);',
'',
'alter table flow_step_stats',
'    add constraint flow_stsf_period_type_ck',
'      check ( stsf_period in (''DAY'' , ''MTD'', ''MONTH'', ''QUARTER'',''YEAR'') );',
'',
'/* Configurations & Error Messages Tables */',
'',
'create table flow_configuration',
'( cfig_key                  varchar2(50 char) NOT NULL',
', cfig_value                varchar2(2000 char)',
');',
'',
'alter table flow_configuration ADD CONSTRAINT cfig_pk PRIMARY KEY ( cfig_key );',
'',
'create table flow_messages',
'( fmsg_message_key          varchar2(30 char) not null',
', fmsg_lang                 varchar2(10 char) not null',
', fmsg_message_content      varchar2(2000 char) ',
');',
'',
'alter table flow_messages ADD CONSTRAINT fmsg_pk PRIMARY KEY ( fmsg_message_key, fmsg_lang );',
'',
'create table flow_stats_history',
'( sths_id         number generated always as identity ( start with 1 nocache order ) not null',
', sths_date       date',
', sths_status     varchar2(50 char)',
', sths_type       varchar2(20 char)',
', sths_operation  varchar2(20 char)',
', sths_errors     varchar2(4000 char)',
', sths_comments   varchar2(4000 char)',
', sths_created_on timestamp with time zone',
', sths_updated_on timestamp with time zone',
', sths_updated_by varchar2(50 char)',
');',
'',
'create index flow_sths_ix on flow_stats_history (sths_date);',
'',
'alter table flow_stats_history',
'  add constraint flow_sths_pk',
'    primary key (sths_id)',
';',
'',
'alter table flow_stats_history',
'  add constraint flow_sths_status_ck',
'    check (sths_status in (''SUCCESS'', ''ERROR'') );',
'',
'alter table flow_stats_history',
'  add constraint flow_sths_type_ck',
'  check (sths_type in (''DAY'', ''MONTH'', ''MTD'', ''QUARTER'', ''YEAR'') );',
'',
'create table flow_parser_log ',
'(',
'  plog_id         number generated always as identity increment by 1 start with 1 not null',
', plog_dgrm_id    number not null',
', plog_bpmn_id    varchar2( 50 char)',
', plog_log_time   timestamp not null',
', plog_parse_step varchar2(128 char) ',
', plog_payload    clob',
');',
'',
'alter table flow_parser_log',
'  add constraint flow_plog_pk primary key (plog_id)',
';',
'',
'create index flow_plog_ix1',
'  on flow_parser_log( plog_dgrm_id, plog_log_time )',
';',
'',
'create table flow_rest_event_log (',
'  lgrt_id                   number generated always as identity (start with 1) not null',
', lgrt_call_guid            RAW(16) not null',
', lgrt_client_id            VARCHAR2(400 char)   ',
', lgrt_log_info             VARCHAR2(400 char)',
', lgrt_token                VARCHAR2(400 char) ',
', lgrt_timestamp        		TIMESTAMP WITH TIME ZONE NOT NULL',
', lgrt_http_method          VARCHAR2(20 char)',
', lgrt_endpoint           	VARCHAR2(4000 char)',
', lgrt_payload              CLOB ',
', lgrt_error_code           number',
', lgrt_error_msg            VARCHAR2(2000 CHAR)',
', lgrt_error_stacktrace     CLOB',
');',
'',
'create table flow_simple_form_templates (',
'  sfte_id        number generated by default as identity (start with 1) not null',
', sfte_name      varchar2(150 char) not null',
', sfte_static_id varchar2(150 char) not null',
', sfte_content   clob',
');',
'',
'alter table flow_simple_form_templates add constraint sfte_pk primary key ( sfte_id );',
'',
'alter table flow_simple_form_templates add constraint sfte_uk unique ( sfte_static_id );',
'',
'alter table flow_simple_form_templates add constraint sfte_ck check ( sfte_content is json(strict) );',
''))
);
end;
/
prompt --application/deployment/install/install_packages_specifications
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Packages Specifications'
,p_sequence=>20
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  lf  varchar2(1) := chr(10);',
'  vr  number;',
'  v   number;',
'  r   number;',
'  blk varchar(4000);',
'',
'  procedure add_line ( p_line in varchar2 ) is',
'  begin',
'    blk := blk || case when blk is not null then lf end || p_line;',
'  end;',
'',
'  function add_bool ( p_current_version in number, p_a_version in number ) return varchar2 is',
'  begin',
'    return case when p_current_version <= p_a_version then ''true'' else ''false'' end;',
'  end; ',
'begin',
'  select to_number(substr(version_no, 1, instr(version_no, ''.'', 1, 2) - 1), ''99D9'',''NLS_NUMERIC_CHARACTERS=''''.,'''''')',
'       , to_number(substr(version_no, 1, instr(version_no, ''.'', 1, 1) - 1))',
'       , to_number(substr(version_no, instr(version_no, ''.'', 1, 1) + 1, instr(version_no, ''.'', 1, 1) - 2))',
'    into vr',
'       , v',
'       , r',
'    from apex_release',
'  ;',
'',
'  add_line( ''create or replace package flow_apex_env authid definer is'' );',
'  add_line( ''  version     constant pls_integer := '' || v || '';'' );',
'  add_line( ''  release     constant pls_integer := '' || r || '';'' );',
'  add_line( ''  ee          constant boolean := false;'');',
'   ',
'  for yr in 19..v+4 loop',
'    add_line(''  ver_le_'' || yr || ''   constant boolean     := '' || add_bool(trunc(vr), yr    ) || '';'');',
'    add_line(''  ver_le_'' || yr || ''_1 constant boolean     := '' || add_bool(vr       , yr +.1) || '';'');',
'    add_line(''  ver_le_'' || yr || ''_2 constant boolean     := '' || add_bool(vr       , yr +.2) || '';'');',
'  end loop;',
'   ',
'  add_line(''end;'');',
'   ',
'  execute immediate blk;',
'end;',
'/',
'',
'create or replace package flow_types_pkg',
'/* ',
'-- Flows for APEX - flow_types_pkg.pks',
'-- ',
'-- (c) Copyright MT AG, 2020-2022.',
'-- (c) Copyright Flowquest Limited. 2024.',
'--',
'-- Created  11-Sep-2020  Moritz Klein (MT AG)',
'-- Modified 09-Jan-2024  Richard Allen, Flowquest Limited',
'--',
'*/',
'  authid definer',
'as',
'',
'  subtype t_bpmn_id             is varchar2(50 char);',
'  subtype t_bpmn_attributes_key is varchar2(50 char);',
'  subtype t_bpmn_attribute_vc2  is varchar2(4000 char);',
'',
'  subtype t_vc200              is varchar2(200 char);',
'  subtype t_vc50               is varchar2(50 char);',
'  subtype t_vc20               is varchar2(20 char);',
'  subtype t_single_vc2         is varchar2(1 char);',
'  subtype t_boolean_num        is number(1);',
'',
'  subtype t_expr_type          is varchar2(130 char);',
'  subtype t_expr_set           is varchar2(20 char);',
'',
'  type flow_step_info is record',
'  ( dgrm_id                   flow_diagrams.dgrm_id%type',
'  , source_objt_tag           flow_objects.objt_tag_name%type',
'  , source_objt_id            flow_objects.objt_id%type',
'  , target_objt_id            flow_objects.objt_id%type',
'  , target_objt_name          flow_objects.objt_name%type',
'  , target_objt_ref           flow_objects.objt_bpmn_id%type',
'  , target_objt_tag           flow_objects.objt_tag_name%type',
'  , target_objt_treat_as_tag  flow_objects.objt_tag_name%type',
'  , target_objt_subtag        flow_objects.objt_sub_tag_name%type',
'  , target_objt_lane          flow_objects.objt_bpmn_id%type',
'  , target_objt_lane_name     flow_objects.objt_name%type',
'  , target_objt_lane_isRole   varchar2(10 char)',
'  , target_objt_lane_role     flow_subflows.sbfl_potential_groups%type',
'  , target_objt_attributes    flow_objects.objt_attributes%type',
'  , target_objt_iteration     flow_subflows.sbfl_iteration_type%type',
'  , target_objt_step_key      flow_subflows.sbfl_step_key%type',
'  );',
'',
'  type t_subflow_context is record',
'  ( sbfl_id           flow_subflows.sbfl_id%type',
'  , step_key          flow_subflows.sbfl_step_key%type',
'  , route             flow_subflows.sbfl_route%type',
'  , scope             flow_subflows.sbfl_scope%type',
'  );',
'',
'  -- Type              -- t_iteration_vars',
'  -- Purpose           -- used to hold the input, output, or description expression sub-components of an iteration definition',
'  -- type              -- gc_expr_type_sql_json_array',
'                       -- gc_expr_type_list',
'                       -- gc_expr_type_array ',
'  -- collection_var    -- if the expression is a process varuable, this contains the variable name',
'  -- collection_expr   -- if the expression is a SQL Query, PLSql function, etc., this contains the expression text',
'                       -- note that the expresion can be longer than a variable name, so you need to use this for the actual',
'                       -- expression',
'  -- inside_var        -- variable name to be used inside the iteration (so inport to these / export from these)',
'  -- description       -- the description string, typically contains substitution parameters',
'  type t_iteration_vars is record',
'  ( type            flow_types_pkg.t_vc20',
'  , collection_var  flow_process_variables.prov_var_name%type',
'  , collection_expr t_bpmn_attribute_vc2',
'  , inside_var      flow_process_variables.prov_var_name%type',
'  , description     varchar2(4000)',
'  );',
'  ',
'  type t_iteration_status is record',
'  ( iteration_var   flow_process_variables.prov_var_name%type',
'  , var_scope       flow_subflows.sbfl_scope%type',
'  , iobj_id         flow_iterated_objects.iobj_id%type',
'  , num_iterations  number',
'  , is_complete     boolean',
'  );',
'',
'end flow_types_pkg;',
'/',
'',
'create or replace package flow_constants_pkg',
'/* ',
'-- Flows for APEX - flow_constants_pkg.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates. 2022-23.',
'-- (c) Copyright Flowquest Consulting Limited. 2024.',
'--',
'-- Created 2020        Moritz Klein - MT AG  ',
'-- Edited  14-Mar-2022 R Allen, Oracle',
'-- Edited  10-Mar-2023 Moritz Klein, MT GmbH',
'-- Edited  03-Jan-2024 R Allen, Flowquest Consulting',
'--',
'*/',
'  authid definer',
'as',
'',
'  gc_version constant varchar2(10 char) := ''24.1'';',
'',
'  gc_true          constant varchar2(1 byte)  := ''Y'';',
'  gc_false         constant varchar2(1 byte)  := ''N'';',
'  gc_vcbool_true   constant varchar2(10 char) := ''true'';',
'  gc_vcbool_false  constant varchar2(10 char) := ''false'';',
'  gc_numbool_true  constant number            := 1;',
'  gc_numbool_false constant number            := 0;',
'',
'  gc_nsmap       constant varchar2(200 char) := ''xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL"'';',
'  gc_nsbpmn      constant varchar2(200 char) := ''http://www.omg.org/spec/BPMN/20100524/MODEL'';',
'  gc_nsapex      constant varchar2(200 char) := ''https://flowsforapex.org'';',
'  gc_bpmn_prefix constant varchar2(10 char)  := ''bpmn:'';',
'  gc_apex_prefix constant varchar2(10 char)  := ''apex:'';',
'',
'  ge_invalid_session_params   exception;',
'  pragma exception_init (ge_invalid_session_params, -20987);',
'',
'  -- BPMN Keys',
'  gc_bpmn_participant                  constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''participant'';',
'  gc_bpmn_collaboration                constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''collaboration'';',
'  gc_bpmn_lane_set                     constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''laneSet'';',
'  gc_bpmn_child_lane_set               constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''childLaneSet'';',
'  gc_bpmn_lane                         constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''lane'';',
'',
'  gc_bpmn_process                      constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''process'';',
'  gc_bpmn_subprocess                   constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''subProcess'';',
'  gc_bpmn_call_activity                constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''callActivity'';',
'',
'  gc_bpmn_start_event                  constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''startEvent'';',
'  gc_bpmn_end_event                    constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''endEvent'';',
'  gc_bpmn_intermediate_throw_event     constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''intermediateThrowEvent'';',
'  gc_bpmn_intermediate_catch_event     constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''intermediateCatchEvent'';',
'  gc_bpmn_boundary_event               constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''boundaryEvent'';',
'',
'  gc_bpmn_terminate_event_definition   constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''terminateEventDefinition'';',
'  gc_bpmn_error_event_definition       constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''errorEventDefinition'';',
'  gc_bpmn_escalation_event_definition  constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''escalationEventDefinition'';',
'  gc_bpmn_link_event_definition        constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''linkEventDefinition'';',
'  gc_bpmn_message_event_definition     constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''messageEventDefinition'';',
'  gc_bpmn_conditional_event_definition constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''conditionalEventDefinition'';',
'  gc_bpmn_signal_event_definition      constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''signalEventDefinition'';',
'',
'  gc_bpmn_timer_event_definition       constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''timerEventDefinition'';',
'  gc_timer_type_date                   constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''timeDate'';',
'  gc_timer_type_duration               constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''timeDuration'';',
'  gc_timer_type_cycle                  constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''timeCycle'';',
'',
'  gc_bpmn_object_documentation         constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''documentation'';',
'',
'  gc_bpmn_gateway_exclusive            constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''exclusiveGateway'';',
'  gc_bpmn_gateway_inclusive            constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''inclusiveGateway'';',
'  gc_bpmn_gateway_parallel             constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''parallelGateway'';',
'  gc_bpmn_gateway_event_based          constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''eventBasedGateway'';',
'',
'  gc_bpmn_sequence_flow                constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''sequenceFlow'';',
'',
'  gc_bpmn_task                         constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''task'';',
'  gc_bpmn_usertask                     constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''userTask'';',
'  gc_bpmn_servicetask                  constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''serviceTask'';',
'  gc_bpmn_manualtask                   constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''manualTask'';',
'  gc_bpmn_scripttask                   constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''scriptTask'';',
'  gc_bpmn_businessruletask             constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''businessRuleTask'';',
'  gc_bpmn_sendtask                     constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''sendTask'';',
'  gc_bpmn_receivetask                  constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''receiveTask'';',
'  ',
'  gc_bpmn_text                         constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''text'';',
'',
'  gc_bpmn_multi_instance_loop         constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''multiInstanceLoopCharacteristics'';',
'  gc_bpmn_standard_loop               constant flow_types_pkg.t_bpmn_id := gc_bpmn_prefix || ''standardLoopCharacteristics'';',
'',
'  -- APEX Extensions to BPMN',
'  -- bpmnProcess',
'  gc_apex_process_workspace           constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''workspace'';',
'  gc_apex_process_application_id      constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''applicationId'';',
'  gc_apex_process_page_id             constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''pageId'';',
'  gc_apex_process_username            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''username'';',
'  ',
'  -- userTask',
'  gc_apex_usertask_apex_page          constant flow_types_pkg.t_bpmn_id := ''apexPage'';',
'  gc_apex_usertask_apex_approval      constant flow_types_pkg.t_bpmn_id := ''apexApproval'';',
'  gc_apex_usertask_apex_simple_form   constant flow_types_pkg.t_bpmn_id := ''apexSimpleForm'';',
'  gc_apex_usertask_external_url       constant flow_types_pkg.t_bpmn_id := ''externalUrl'';',
'',
'  gc_apex_usertask_application_id     constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''applicationId'';',
'  gc_apex_usertask_page_id            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''pageId'';',
'  gc_apex_usertask_request            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''request'';',
'  gc_apex_usertask_cache              constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''cache'';',
'',
'  gc_apex_usertask_page_items         constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''pageItems'';',
'  gc_apex_usertask_item               constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''itemName'';',
'  gc_apex_usertask_value              constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''itemValue'';',
'',
'  gc_apex_usertask_url                constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''url'';',
'',
'  gc_apex_usertask_static_id          constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''taskStaticId'';',
'  gc_apex_usertask_subject            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''subject'';',
'  gc_apex_usertask_business_ref       constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''businessRef'';',
'  gc_apex_usertask_task_comment       constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''taskComment'';',
'  gc_apex_usertask_parameters         constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''parameters'';',
'',
'  --serviceTask',
'  gc_apex_servicetask_send_mail       constant flow_types_pkg.t_bpmn_id := ''sendMail'';',
'',
'  gc_apex_servicetask_email_from      constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''emailFrom'';',
'  gc_apex_servicetask_email_to        constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''emailTo'';',
'  gc_apex_servicetask_email_cc        constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''emailCC'';',
'  gc_apex_servicetask_email_bcc       constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''emailBCC'';',
'  gc_apex_servicetask_email_reply_to  constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''emailReplyTo'';',
'  gc_apex_servicetask_use_template    constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''useTemplate'';',
'  gc_apex_servicetask_application_id  constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''applicationId'';',
'  gc_apex_servicetask_template_id     constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''templateId'';',
'  gc_apex_servicetask_placeholder     constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''placeholder'';',
'  gc_apex_servicetask_subject         constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''subject'';',
'  gc_apex_servicetask_body_text       constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''bodyText'';',
'  gc_apex_servicetask_body_html       constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''bodyHTML'';',
'  gc_apex_servicetask_attachment      constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''attachment'';',
'  gc_apex_servicetask_immediately     constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''immediately'';',
'',
'  --messageFlow messaging protocol',
'  gc_simple_message   constant flow_types_pkg.t_bpmn_id := ''simpleMessage'';',
'   ',
'  -- execute PL/SQL tasks',
'  gc_apex_task_execute_plsql    constant flow_types_pkg.t_bpmn_id := ''executePlsql'';',
'',
'  gc_apex_task_plsql_engine     constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''engine'';',
'  gc_apex_task_plsql_code       constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''plsqlCode'';',
'  gc_apex_task_plsql_auto_binds constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''autoBinds'';',
'',
'  --terminateEndEvent',
'  gc_apex_process_status              constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''processStatus'';',
'',
'  -- Oracle format timer definitions',
'  gc_timer_type_oracle_date           constant flow_types_pkg.t_bpmn_id := ''oracleDate'';',
'  gc_timer_type_oracle_duration       constant flow_types_pkg.t_bpmn_id := ''oracleDuration'';',
'  gc_timer_type_oracle_cycle          constant flow_types_pkg.t_bpmn_id := ''oracleCycle'';',
'',
'  gc_apex_timer_date                  constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''date'';',
'  gc_apex_timer_format_mask           constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''formatMask'';',
'  gc_apex_timer_interval_ym           constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''intervalYM'';',
'  gc_apex_timer_interval_ds           constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''intervalDS'';',
'  gc_apex_timer_start_interval_ds     constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''startIntervalDS'';',
'  gc_apex_timer_repeat_interval_ds    constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''repeatIntervalDS'';',
'  gc_apex_timer_max_runs              constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''maxRuns'';',
'',
'  -- Process Tags',
'  gc_apex_process_callable            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''isCallable'';',
'  gc_apex_process_startable           constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''isStartable'';',
'',
'  -- callActivity tags',
'  gc_apex_called_diagram                    constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''calledDiagram'';',
'  gc_apex_called_diagram_version_selection  constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''calledDiagramVersionSelection'';',
'  gc_apex_called_diagram_version            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''calledDiagramVersion'';',
'',
'  -- Iterator Tags',
'  gc_apex_iterator_input            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''inputCollection'';',
'  gc_apex_iterator_output           constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''outputCollection'';',
'  gc_apex_iterator_completion_cond  constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''completionCondition'';',
'  gc_apex_iterator_description      constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''description'';',
'',
'  -- Custom Extension Tag',
'  gc_apex_custom_extension            constant flow_types_pkg.t_bpmn_id := gc_apex_prefix || ''customExtension'';',
'',
'  -- Diagram calling methods',
'  gc_dgrm_version_named_version       constant flow_types_pkg.t_bpmn_attributes_key := ''namedVersion'';',
'  gc_dgrm_version_latest_version      constant flow_types_pkg.t_bpmn_attributes_key := ''latestVersion'';',
'',
'  -- Special Keys from FLOW_OBJECTS.OBJT_ATTRIBUTES',
'  gc_timer_type_key                   constant flow_types_pkg.t_bpmn_id := ''timerType'';',
'  gc_timer_def_key                    constant flow_types_pkg.t_bpmn_id := ''timerDefinition'';',
'  ',
'  gc_task_type_key                    constant flow_types_pkg.t_bpmn_id := ''taskType'';',
'',
'  gc_terminate_result                 constant flow_types_pkg.t_bpmn_id := ''processStatus'';',
'',
'  gc_iteration_parallel               constant flow_types_pkg.t_vc20 := ''parallel'';',
'  gc_iteration_sequential             constant flow_types_pkg.t_vc20 := ''sequential'';',
'  gc_iteration_loop                   constant flow_types_pkg.t_vc20 := ''loop'';',
'',
'  gc_iteration_object_task            constant flow_types_pkg.t_vc20 := ''task'';',
'  gc_iteration_object_subprocess      constant flow_types_pkg.t_vc20 := ''subProcess'';',
'',
'  gc_iteration_status_not_started     constant flow_types_pkg.t_vc20 := ''notStarted'';',
'  gc_iteration_status_running         constant flow_types_pkg.t_vc20 := ''running'';',
'  gc_iteration_status_completed       constant flow_types_pkg.t_vc20 := ''completed'';',
'  gc_iteration_status_terminated      constant flow_types_pkg.t_vc20 := ''terminated'';',
'',
'  -- Flows 4 APEX Substitution Strings',
'  gc_substitution_flow_identifier       constant varchar2(10 char)                    := ''F4A$'';',
'  gc_substitution_prefix                constant flow_types_pkg.t_single_vc2          := ''&'';',
'  gc_substitution_postfix               constant flow_types_pkg.t_single_vc2          := ''.'';',
'  gc_substitution_process_id            constant flow_types_pkg.t_bpmn_attributes_key := ''PROCESS_ID'';',
'  gc_substitution_subflow_id            constant flow_types_pkg.t_bpmn_attributes_key := ''SUBFLOW_ID'';',
'  gc_substitution_step_key              constant flow_types_pkg.t_bpmn_attributes_key := ''STEP_KEY'';',
'  gc_substitution_scope                 constant flow_types_pkg.t_bpmn_attributes_key := ''SCOPE'';',
'  gc_substitution_process_priority      constant flow_types_pkg.t_bpmn_attributes_key := ''PROCESS_PRIORITY'';',
'  gc_substitution_loop_counter          constant flow_types_pkg.t_bpmn_attributes_key := ''LOOP_COUNTER'';',
'  gc_substitution_total_instances       constant flow_types_pkg.t_bpmn_attributes_key := ''TOTAL_INSTANCES'';',
'  gc_substitution_active_instances      constant flow_types_pkg.t_bpmn_attributes_key := ''ACTIVE_INSTANCES'';',
'  gc_substitution_completed_instances   constant flow_types_pkg.t_bpmn_attributes_key := ''COMPLETED_INSTANCES'';',
'  gc_substitution_terminated_instances  constant flow_types_pkg.t_bpmn_attributes_key := ''TERMINATED_INSTANCES'';',
'  ',
'',
'  gc_substitution_pattern             constant flow_types_pkg.t_bpmn_attributes_key := gc_substitution_prefix || ''F4A\$([a-zA-Z0-9:\_\-]+)'' || gc_substitution_postfix;',
'  gc_bind_prefix                      constant flow_types_pkg.t_single_vc2          := '':'';',
'  gc_bind_pattern                     constant flow_types_pkg.t_bpmn_attributes_key := gc_bind_prefix || ''F4A\$([a-zA-Z0-9:\_]+)'';',
'',
'  -- Diagram Versioning Status',
'  gc_dgrm_status_draft                constant  varchar2(10 char) := ''draft'';',
'  gc_dgrm_status_released             constant  varchar2(10 char) := ''released'';',
'  gc_dgrm_status_deprecated           constant  varchar2(10 char) := ''deprecated'';',
'  gc_dgrm_status_archived             constant  varchar2(10 char) := ''archived'';',
'',
'  -- Subflow status',
'  gc_sbfl_status_created              constant  varchar2(20 char) := ''created'';',
'  gc_sbfl_status_running              constant  varchar2(20 char) := ''running'';',
'  gc_sbfl_status_waiting_timer        constant  varchar2(20 char) := ''waiting for timer'';',
'  gc_sbfl_status_waiting_gateway      constant  varchar2(20 char) := ''waiting at gateway'';',
'  gc_sbfl_status_waiting_event        constant  varchar2(20 char) := ''waiting for event'';',
'  gc_sbfl_status_waiting_approval     constant  varchar2(20 char) := ''waiting for approval'';',
'  gc_sbfl_status_waiting_message      constant  varchar2(20 char) := ''waiting for message'';',
'  gc_sbfl_status_waiting_iter         constant  varchar2(20 char) := ''waiting iterations'';',
'  gc_sbfl_status_proceed_gateway      constant  varchar2(20 char) := ''proceed from gateway'';',
'  gc_sbfl_status_split                constant  varchar2(20 char) := ''split'';',
'  gc_sbfl_status_iterating            constant  varchar2(20 char) := ''iterating'';',
'  gc_sbfl_status_in_subprocess        constant  varchar2(20 char) := ''in subprocess'';',
'  gc_sbfl_status_in_callactivity      constant  varchar2(20 char) := ''in call activity'';',
'  gc_sbfl_status_error                constant  varchar2(20 char) := ''error'';',
'  gc_sbfl_status_completed            constant  varchar2(20 char) := ''completed'';  -- note sbfl deleted after completion',
'',
'  -- Process Instance Status',
'  gc_prcs_status_created              constant  varchar2(20 char) := ''created'';',
'  gc_prcs_status_running              constant  varchar2(20 char) := ''running'';',
'  gc_prcs_status_completed            constant  varchar2(20 char) := ''completed'';',
'  gc_prcs_status_terminated           constant  varchar2(20 char) := ''terminated'';',
'  gc_prcs_status_error                constant  varchar2(20 char) := ''error'';',
'',
'  -- Process Instance Events',
'  gc_prcs_event_created               constant  varchar2(20 char) := gc_prcs_status_created;',
'  gc_prcs_event_started               constant  varchar2(20 char) := ''started'';',
'  gc_prcs_event_completed             constant  varchar2(20 char) := gc_prcs_status_completed;',
'  gc_prcs_event_terminated            constant  varchar2(20 char) := gc_prcs_status_terminated;',
'  gc_prcs_event_reset                 constant  varchar2(20 char) := ''reset'';',
'  gc_prcs_event_error                 constant  varchar2(20 char) := gc_prcs_status_error;',
'  gc_prcs_event_restart_step          constant  varchar2(20 char) := ''restart step'';',
'  gc_prcs_event_deleted               constant  varchar2(20 char) := ''deleted'';',
'  gc_prcs_event_rescheduled           constant  varchar2(20 char) := ''rescheduled'';',
'  gc_prcs_event_enter_call            constant  varchar2(20 char) := ''start called model'';',
'  gc_prcs_event_leave_call            constant  varchar2(20 char) := ''finish called model'';',
'  gc_prcs_event_priority_set          constant  varchar2(20 char) := ''priority set'';',
'  gc_prcs_event_due_on_set            constant  varchar2(20 char) := ''due on set'';',
'  gc_prcs_event_warning               constant  varchar2(20 char) := ''warning'';',
'',
'  -- Process Variable Datatypes',
'',
'  gc_prov_var_type_varchar2           constant  varchar2(50 char) := ''VARCHAR2'';',
'  gc_prov_var_type_date               constant  varchar2(50 char) := ''DATE'';',
'  gc_prov_var_type_number             constant  varchar2(50 char) := ''NUMBER'';',
'  gc_prov_var_type_clob               constant  varchar2(50 char) := ''CLOB'';',
'  gc_prov_var_type_tstz               constant  varchar2(50 char) := ''TIMESTAMP WITH TIME ZONE'';',
'  gc_prov_var_type_json               constant  varchar2(50 char) := ''JSON'';',
'  gc_prov_var_type_boolean            constant  varchar2(50 char) := ''BOOLEAN'';   -- not a proper Proc Var type',
'',
'  gc_prov_default_date_format         constant  varchar2(30 char) := ''YYYY-MM-DD HH24:MI:SS'';',
'  gc_prov_default_tstz_format         constant  varchar2(30 char) := ''YYYY-MM-DD HH24:MI:SS TZR'';',
'',
'  gc_prov_content_list                constant  varchar2(50 char) := ''LIST'';',
'  gc_prov_content_array               constant  varchar2(50 char) := ''ARRAY'';',
'',
'  -- Standard Process Variables',
'',
'  gc_prov_builtin_business_ref        constant  varchar2(50 char) := ''BUSINESS_REF'';',
'',
'  -- Standard Process Variable Suffixes',
'',
'  gc_prov_suffix_task_id              constant  varchar2(50 char) := '':task_id'';',
'  gc_prov_suffix_route                constant  varchar2(50 char) := '':route'';  ',
'',
'  -- Task List Contexts',
'',
'  gc_task_list_context_single         constant varchar2(30 char) := ''SINGLE_PROCESS'';',
'  gc_task_list_context_my_tasks       constant varchar2(30 char) := ''MY_TASKS'';',
'',
'  -- Process Variable and Gateway Routing Variable Expression Types',
'  gc_apex_expression constant flow_types_pkg.t_bpmn_attribute_vc2 := ''conditionExpression'';',
'',
'  gc_expr_type_static                   constant flow_types_pkg.t_expr_type := ''static'';',
'  gc_expr_type_proc_var                 constant flow_types_pkg.t_expr_type := ''processVariable'';',
'  gc_expr_type_item                     constant flow_types_pkg.t_expr_type := ''item'';',
'  gc_expr_type_array                    constant flow_types_pkg.t_expr_type := ''processVariableArray'';',
'  gc_expr_type_list                     constant flow_types_pkg.t_expr_type := ''processVariableList'';',
'  gc_expr_type_sql                      constant flow_types_pkg.t_expr_type := ''sqlQuerySingle'';',
'  gc_expr_type_sql_delimited_list       constant flow_types_pkg.t_expr_type := ''sqlQueryList'';',
'  gc_expr_type_sql_json_array           constant flow_types_pkg.t_expr_type := ''sqlQueryArray'';',
'  gc_expr_type_plsql_function_body      constant flow_types_pkg.t_expr_type := ''plsqlFunctionBody'';  -- vc2 typed functionbody (e.g., date returns vc2)',
'  gc_expr_type_plsql_expression         constant flow_types_pkg.t_expr_type := ''plsqlExpression'';    -- vc2 typed expression  (e.g., date returns vc2)',
'  gc_expr_type_plsql_raw_function_body  constant flow_types_pkg.t_expr_type := ''plsqlRawFunctionBody'';  -- raw functionbody  (e.g., date returns date)',
'  gc_expr_type_plsql_raw_expression     constant flow_types_pkg.t_expr_type := ''plsqlRawExpression'';    -- raw expression  (e.g., date returns date)',
'',
'',
'  gc_date_value_type_date             constant flow_types_pkg.t_expr_type := ''date'';',
'  gc_date_value_type_time_of_day      constant flow_types_pkg.t_expr_type := ''timeOfDay'';',
'  gc_date_value_type_interval         constant flow_types_pkg.t_expr_type := ''interval'';',
'  gc_date_value_type_oracle_scheduler constant flow_types_pkg.t_expr_type := ''oracleScheduler'';',
'',
'-- Process Variable Expression sets and CallActivity in-Out sets',
'  gc_expr_set_before_task             constant flow_types_pkg.t_expr_set := ''beforeTask'';',
'  gc_expr_set_after_task              constant flow_types_pkg.t_expr_set := ''afterTask'';',
'  gc_expr_set_before_split            constant flow_types_pkg.t_expr_set := ''beforeSplit'';',
'  gc_expr_set_after_merge             constant flow_types_pkg.t_expr_set := ''afterMerge'';',
'  gc_expr_set_before_event            constant flow_types_pkg.t_expr_set := ''beforeEvent'';',
'  gc_expr_set_on_event                constant flow_types_pkg.t_expr_set := ''onEvent'';',
'  gc_expr_set_in_variables            constant flow_types_pkg.t_expr_set := ''inVariables'';',
'  gc_expr_set_out_variables           constant flow_types_pkg.t_expr_set := ''outVariables'';',
'',
'-- ASync Session Parameter Keys',
'',
'  gc_async_parameter_username          constant flow_types_pkg.t_expr_set := ''username'';',
'  gc_async_parameter_applicationId     constant flow_types_pkg.t_expr_set := ''applicationId'';',
'  gc_async_parameter_pageId            constant flow_types_pkg.t_expr_set := ''pageId'';',
'',
'-- Config Parameter Keys',
'',
'  gc_config_logging_level               constant varchar2(50 char) := ''logging_level'';',
'  gc_config_logging_hide_userid         constant varchar2(50 char) := ''logging_hide_userid'';',
'  gc_config_logging_language            constant varchar2(50 char) := ''logging_language'';',
'  gc_config_logging_retain_logs         constant varchar2(50 char) := ''logging_retain_logs_after_prcs_completion_days'';',
'  gc_config_logging_archive_location    constant varchar2(50 char) := ''logging_archive_location'';',
'  gc_config_logging_archive_enabled     constant varchar2(50 char) := ''logging_archive_instance_summaries'';',
'  gc_config_logging_message_flow_recd   constant varchar2(50 char) := ''logging_received_message_flow'';'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'  gc_config_logging_retain_msg_flow     constant varchar2(50 char) := ''logging_retain_message_flow_days'';',
'  gc_config_logging_bpmn_location       constant varchar2(50 char) := ''logging_bpmn_location'';',
'  gc_config_engine_app_mode             constant varchar2(50 char) := ''engine_app_mode'';',
'  gc_config_dup_step_prevention         constant varchar2(50 char) := ''duplicate_step_prevention'';',
'  gc_config_timer_max_cycles            constant varchar2(50 char) := ''timer_max_cycles'';',
'  gc_config_default_workspace           constant varchar2(50 char) := ''default_workspace'';',
'  gc_config_default_application         constant varchar2(50 char) := ''default_application'';',
'  gc_config_default_pageid              constant varchar2(50 char) := ''default_pageid'';',
'  gc_config_default_username            constant varchar2(50 char) := ''default_username'';',
'  gc_config_default_email_sender        constant varchar2(50 char) := ''default_email_sender'';',
'  gc_config_stats_retain_summary_daily  constant varchar2(50 char) := ''stats_retain_daily_summaries_days'';',
'  gc_config_stats_retain_summary_month  constant varchar2(50 char) := ''stats_retain_monthly_summaries_months'';',
'  gc_config_stats_retain_summary_qtr    constant varchar2(50 char) := ''stats_retain_quarterly_summaries_months'';',
'  gc_config_license_edition             constant varchar2(50 char) := ''license_edition'';',
'  gc_config_license_key                 constant varchar2(50 char) := ''license_key'';',
'  gc_config_licensed_to                 constant varchar2(50 char) := ''licensed_to'';',
'  gc_config_license_expiry_date         constant varchar2(50 char) := ''license_expiry_date'';',
'',
'',
'-- Config Parameter Valid Values (when not true / false or numeric)',
'',
'  gc_config_logging_level_none               constant varchar2(2000 char) := ''none'';        -- none',
'  gc_config_logging_level_standard           constant varchar2(2000 char) := ''standard'';    -- instances and tasks',
'  gc_config_logging_level_secure             constant varchar2(2000 char) := ''secure'';      -- standard + diagram changes',
'  gc_config_logging_level_full               constant varchar2(2000 char) := ''full'';        -- secure + variable changes',
'  gc_config_engine_app_mode_dev              constant varchar2(2000 char) := ''development'';',
'  gc_config_engine_app_mode_prod             constant varchar2(2000 char) := ''production'';',
'  gc_config_dup_step_prevention_legacy       constant varchar2(2000 char) := ''legacy'';      -- null step key allowed',
'  gc_config_dup_step_prevention_strict       constant varchar2(2000 char) := ''strict'';      -- step key enforced',
'  gc_config_archive_destination_table        constant varchar2(2000 char) := ''TABLE'';       -- To Database Table',
'  gc_config_archive_destination_oci_api      constant varchar2(2000 char) := ''OCI-API'';     -- OCI using API Key',
'  gc_config_archive_destination_oci_preauth  constant varchar2(2000 char) := ''OCI-PREAUTH''; -- OCI using PreAuth',
'  gc_config_edition_community                constant varchar2(2000 char) := ''community'';',
'  gc_config_edition_enterprise               constant varchar2(2000 char) := ''enterprise'';',
'',
'-- Config Parameter Default Values',
'',
'  gc_config_default_logging_level               constant varchar2(2000 char) := gc_config_logging_level_standard;',
'  gc_config_default_logging_hide_userid         constant varchar2(2000 char) := gc_vcbool_false;',
'  gc_config_default_logging_language            constant varchar2(2000 char) := ''en'';',
'  gc_config_default_logging_archive_enabled     constant varchar2(2000 char) := gc_vcbool_false;',
'  gc_config_default_logging_recd_msg            constant varchar2(2000 char) := gc_vcbool_false;',
'  gc_config_default_engine_app_mode             constant varchar2(2000 char) := ''production'';',
'  gc_config_default_dup_step_prevention         constant varchar2(2000 char) := ''legacy'';',
'  gc_config_default_default_workspace           constant varchar2(2000 char) := ''FLOWS4APEX'';',
'  gc_config_default_default_application         constant varchar2(2000 char) := ''100'';',
'  gc_config_default_default_pageID              constant varchar2(2000 char) := ''1'';',
'  gc_config_default_default_username            constant varchar2(2000 char) := ''FLOWS4APEX'';',
'  gc_config_default_timer_max_cycles            constant varchar2(2000 char) := ''1000'';',
'  gc_config_default_log_retain_logs             constant varchar2(2000 char) := ''60'';',
'  gc_config_default_log_retain_msg_flow_logs    constant varchar2(2000 char) := ''7'';',
'  gc_config_default_stats_retain_summary_daily  constant varchar2(2000 char) := ''180'';',
'  gc_config_default_stats_retain_summary_month  constant varchar2(2000 char) := ''9'';',
'  gc_config_default_stats_retain_summary_qtr    constant varchar2(2000 char) := ''36'';',
'',
'-- Staistics Period',
'  gc_stats_period_day                   constant varchar2(20 char) := ''DAY'';',
'  gc_stats_period_month                 constant varchar2(20 char) := ''MONTH'';',
'  gc_stats_period_quarter               constant varchar2(20 char) := ''QUARTER'';',
'',
'  gc_stats_outcome_success              constant varchar2(50 char) := ''SUCCESS'';',
'  gc_stats_outcome_error                constant varchar2(50 char) := ''ERROR'';',
'',
'  gc_stats_operation_generate           constant varchar2(20 char) := ''GENERATE'';',
'  gc_stats_operation_purge              constant varchar2(20 char) := ''PURGE'';',
'',
'-- MIME types',
'',
'  gc_mime_type_bpmn                     constant varchar2(50 char) := ''application/bpmn-xml'';',
'  gc_mime_type_json                     constant varchar2(50 char) := ''application/json'';',
'',
'  -- Default XML for new diagrams',
'  gc_default_xml constant varchar2(4000) := ''<?xml version="1.0" encoding="UTF-8"?>',
'<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" ',
'xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" id="Definitions_1wzb475" targetNamespace="http://bpmn.io/schema/b" ',
'exporter="Flows for APEX" exporterVersion="'' || gc_version || ''">',
'<bpmn:process id="Process_#RANDOM_PRCS_ID#" isExecutable="false" />',
'<bpmndi:BPMNDiagram id="BPMNDiagram_1">',
'<bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_#RANDOM_PRCS_ID#" />',
'</bpmndi:BPMNDiagram>',
'</bpmn:definitions>',
''';',
'',
'end flow_constants_pkg;',
'/',
'',
'create or replace package flow_migrate_xml_pkg',
'  authid definer',
'as',
'  procedure migrate_xml(',
'    p_dgrm_content in out clob',
'  , p_has_changed out boolean',
'  );',
'end flow_migrate_xml_pkg;',
'/',
'',
'create or replace package flow_parser_util',
'  authid definer',
'as',
'-- Holds all types needed during parsing and utility methods',
'-- The types are fitted to use natural keys',
'-- and are converted using the utility methods',
'',
'-- Types',
' type t_objt_rec is',
'    record',
'    (',
'      objt_name           flow_types_pkg.t_vc200',
'    , objt_tag_name       flow_types_pkg.t_bpmn_id',
'    , objt_parent_bpmn_id flow_types_pkg.t_bpmn_id',
'    , objt_sub_tag_name   flow_types_pkg.t_bpmn_id',
'    , objt_attached_to    flow_types_pkg.t_bpmn_id',
'    , objt_interrupting   flow_types_pkg.t_boolean_num',
'    , objt_attributes     sys.json_object_t',
'    );',
'  type t_objt_tab is table of t_objt_rec index by flow_types_pkg.t_bpmn_id;',
'',
'  type t_expr_rec is',
'    record',
'    (',
'      expr_set        flow_object_expressions.expr_set%type',
'    , expr_order      flow_object_expressions.expr_order%type',
'    , expr_var_name   flow_object_expressions.expr_var_name%type',
'    , expr_var_type   flow_object_expressions.expr_var_type%type',
'    , expr_type       flow_object_expressions.expr_type%type',
'    , expr_expression flow_object_expressions.expr_expression%type',
'    );',
'  type t_expr_tab is table of t_expr_rec index by pls_integer;',
'  type t_objt_expr_tab is table of t_expr_tab index by flow_types_pkg.t_bpmn_id;',
'',
'  type t_conn_rec is',
'    record',
'    (',
'      conn_name        flow_types_pkg.t_vc200',
'    , conn_src_bpmn_id flow_types_pkg.t_bpmn_id',
'    , conn_tgt_bpmn_id flow_types_pkg.t_bpmn_id',
'    , conn_tag_name    flow_types_pkg.t_bpmn_id',
'    , conn_origin      flow_types_pkg.t_bpmn_id',
'    , conn_sequence    number',
'    , conn_attributes  sys.json_object_t',
'    );',
'  type t_conn_tab is table of t_conn_rec index by flow_types_pkg.t_bpmn_id;',
'',
'  type t_bpmn_ref_tab is table of flow_types_pkg.t_bpmn_id index by flow_types_pkg.t_bpmn_id;',
'  type t_bpmn_id_tab is table of number index by flow_types_pkg.t_bpmn_id;',
'',
'  type t_id_lookup_tab is table of number index by flow_types_pkg.t_bpmn_id;',
'',
'  -- Methods',
'  procedure split_property_name',
'  (',
'    pi_property_name  in        varchar2',
'  , po_namespace     out nocopy varchar2',
'  , po_key           out nocopy varchar2',
'  );',
'',
'  function get_property_key( pi_property_name in varchar2 )',
'    return varchar2;',
'',
'  procedure guarantee_apex_object',
'  (',
'    pio_attributes in out nocopy sys.json_object_t',
'  );',
'',
'  procedure guarantee_bpmn_object',
'  (',
'    pio_attributes in out nocopy sys.json_object_t',
'  );',
'',
'  procedure guarantee_named_object',
'  (',
'    pio_attributes in out nocopy sys.json_object_t',
'  , pi_key         in varchar2',
'  );',
'',
'  function get_lines_array',
'  (',
'    pi_str in clob',
'  ) return sys.json_array_t;',
'',
'  procedure property_to_json',
'  (',
'    pi_property_name  in varchar2',
'  , pi_value          in clob',
'  , po_namespace     out nocopy varchar2',
'  , po_key           out nocopy varchar2',
'  , po_json_element  out nocopy sys.json_element_t',
'  );',
'',
'  procedure log',
'  (',
'    pi_plog_dgrm_id    in flow_parser_log.plog_dgrm_id%type',
'  , pi_plog_bpmn_id    in flow_parser_log.plog_bpmn_id%type',
'  , pi_plog_parse_step in flow_parser_log.plog_parse_step%type',
'  , pi_plog_payload    in flow_parser_log.plog_payload%type',
'  );',
'',
'  procedure log',
'  (',
'    pi_plog_dgrm_id    in flow_parser_log.plog_dgrm_id%type',
'  , pi_plog_bpmn_id    in flow_parser_log.plog_bpmn_id%type',
'  , pi_plog_parse_step in flow_parser_log.plog_parse_step%type',
'  , pi_plog_payload    in sys.xmltype',
'  );',
'',
'  function is_log_enabled',
'    return boolean',
'  ;',
'',
'  procedure clear_log',
'  (',
'    pi_plog_dgrm_id in flow_parser_log.plog_dgrm_id%type',
'  );',
'  ',
'end flow_parser_util;',
'/',
'',
'create or replace package flow_bpmn_parser_pkg',
'  authid definer',
'as',
'',
'  function upload_diagram',
'  (',
'    pi_dgrm_name       in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version    in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category   in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content    in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status     in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_force_overwrite in boolean default false',
'  ) return flow_diagrams.dgrm_id%type;',
'',
'  procedure upload_diagram',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_force_overwrite in boolean default false',
'  );',
'',
'  procedure upload_and_parse',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_force_overwrite in boolean default false',
'  );',
'',
'  procedure parse',
'  (',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type',
'  );',
'',
'  procedure parse',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  );',
'',
'  procedure update_diagram',
'  (',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_dgrm_content in flow_diagrams.dgrm_content%type',
'  );',
'',
'end flow_bpmn_parser_pkg;',
'/',
'',
'create or replace package flow_message_flow as',
'/* ',
'-- Flows for APEX - flow_message_flow.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created  04-Mar-2023  Richard Allen (Oracle Corporation)',
'-- Edited      May 2024  Richard Allen (Flowquest)',
'*/',
'',
'  type t_subscription_details is record',
'  ( message_name  flow_message_subscriptions.msub_message_name%type',
'  , key_name      flow_message_subscriptions.msub_key_name%type',
'  , key_value     flow_message_subscriptions.msub_key_value%type',
'  , prcs_id       flow_message_subscriptions.msub_prcs_id%type',
'  , sbfl_id       flow_message_subscriptions.msub_sbfl_id%type',
'  , step_key      flow_message_subscriptions.msub_step_key%type',
'  , dgrm_id       flow_message_subscriptions.msub_dgrm_id%type',
'  , callback      flow_message_subscriptions.msub_callback%type',
'  , callback_par  flow_message_subscriptions.msub_callback_par%type',
'  , payload_var   flow_message_subscriptions.msub_payload_var%type',
'  );   ',
'',
'  type t_flow_simple_message is record',
'  ( endpoint      flow_types_pkg.t_vc200',
'  , message_name  flow_message_subscriptions.msub_message_name%type',
'  , key_name      flow_message_subscriptions.msub_key_name%type',
'  , key_value     flow_message_subscriptions.msub_key_value%type',
'  , payload       clob ',
'  );  ',
'',
'  e_msgflow_msg_not_correlated exception;',
'  e_msgflow_correlated_msg_locked exception;',
'  e_msgflow_mag_already_consumed exception;',
'  e_msgflow_feature_requires_ee exception;',
'',
'  function subscribe',
'  ( p_subscription_details     in t_subscription_details',
'  ) return flow_message_subscriptions.msub_id%type;',
'',
'  procedure receive_message',
'  ( p_message_name  flow_message_subscriptions.msub_message_name%type',
'  , p_key_name      flow_message_subscriptions.msub_key_name%type',
'  , p_key_value     flow_message_subscriptions.msub_key_value%type',
'  , p_payload       clob default null',
'  );',
'',
'  procedure send_message',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'end flow_message_flow;',
'/',
'',
'create or replace package flow_message_util',
'/* ',
'-- Flows for APEX - flow_message_util',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created  04-Mar-2023  Richard Allen (Oracle Corporation)',
'--',
'-- Contains utility and common routines for messageFlow used by',
'-- bpmn:sendTask, bpmn:receiveTask, message catch and throw events, message start events, etc.',
'--',
'*/',
'  accessible by ( flow_message_flow, flow_tasks, flow_engine , flow_instances ',
'                , flow_engine_util , flow_boundary_events , flow_diagram, flow_message_util_ee )',
'as  ',
'',
'  function get_msg_subscription_details',
'  ( p_msg_object_bpmn_id        flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id                   flow_diagrams.dgrm_id%type',
'  , p_sbfl_info                 flow_subflows%rowtype',
'  ) return flow_message_flow.t_subscription_details;',
'',
'  function prepare_message',
'  ( p_msg_object_bpmn_id        flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id                   flow_diagrams.dgrm_id%type',
'  , p_sbfl_info                 flow_subflows%rowtype',
'  ) return flow_message_flow.t_flow_simple_message;',
'',
'  procedure lock_subscription',
'  ( p_process_id                 flow_processes.prcs_id%type',
'  , p_subflow_id                 flow_subflows.sbfl_id%type',
'  );',
'  ',
'  procedure cancel_subscription',
'  ( p_process_id                 flow_processes.prcs_id%type',
'  , p_subflow_id                 flow_subflows.sbfl_id%type',
'  );',
'',
'  procedure cancel_subscription',
'  ( p_msub_id                    flow_message_subscriptions.msub_id%type',
'  );',
'',
'  procedure lock_instance_subscriptions',
'  ( p_process_id                 flow_processes.prcs_id%type',
'  );',
'  procedure cancel_instance_subscriptions',
'  ( p_process_id                 flow_processes.prcs_id%type',
'  );',
'',
'  procedure save_payload',
'  ( p_process_id             in  flow_processes.prcs_id%type',
'  , p_subflow_id             in  flow_subflows.sbfl_id%type default null',
'  , p_payload_var            in  flow_process_variables.prov_var_name%type',
'  , p_payload                in  clob',
'  , p_scope                  in  flow_subflows.sbfl_scope%type default 0',
'  , p_objt_bpmn_id           in  flow_objects.objt_bpmn_id%type ',
'  );',
'',
'  procedure autonomous_write_to_messageflow_log',
'  ( p_message_name           in  flow_message_received_log.lgrx_message_name%type ',
'  , p_key_name               in  flow_message_received_log.lgrx_key_name%type   ',
'  , p_key_value              in  flow_message_received_log.lgrx_key_value%type ',
'  , p_payload                in  flow_message_received_log.lgrx_payload%type ',
'  , p_was_correlated         in  flow_message_received_log.lgrx_was_correlated%type    ',
'  , p_prcs_id                in  flow_message_received_log.lgrx_prcs_id%type ',
'  , p_sbfl_id                in  flow_message_received_log.lgrx_sbfl_id%type    ',
'  );',
'',
'  procedure intermed_save_payload_and_callback',
'   ( p_msub           in flow_message_subscriptions%rowtype',
'   , p_payload        in clob default null',
'   , p_current        in flow_objects.objt_bpmn_id%type ',
'   , p_scope          in flow_subflows.sbfl_scope%type',
'   );',
'',
'  function correlate_catch_event',
'    ( p_message_name  flow_message_subscriptions.msub_message_name%type ',
'    , p_key_name      flow_message_subscriptions.msub_key_name%type',
'    , p_key_value     flow_message_subscriptions.msub_key_value%type',
'    ) return flow_message_subscriptions%rowtype;',
'  ',
'end flow_message_util;',
'/',
'',
'create or replace package flow_api_pkg',
'   authid definer as',
' /* Flows for APEX - flow_api_pkg.pks',
'--',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG. 2020-22',
'--',
'-- Created    20-Jun-2020   Moritz Klein, MT AG ',
'-- Modified   01-May-2022   Richard Allen, Oracle',
'*/',
' /**',
'FLOWS FOR APEX ENGINE API',
'=========================',
'',
'Types',
'=====',
'',
'Type flows_api_pkg.task_list_item.',
'',
'**/',
'',
'type t_task_list_item is record ',
'   ( manager                 varchar2( 20)',
'   , app_id                  number',
'   , task_id                 number',
'   , task_def_id             number',
'   , task_def_name           varchar2( 255)',
'   , task_def_static_id      varchar2( 255)',
'   , subject                 varchar2(1000)',
'   , task_type               varchar2(  32)',
'   , details_app_id          number',
'   , details_app_name        varchar2( 255)',
'   , details_link_target     varchar2(4000)',
'   , due_on                  timestamp with time zone',
'   , due_in_hours            number',
'   , due_in                  varchar2( 255)',
'   , due_code                varchar2(  32)',
'   , priority                number(1)',
'   , priority_level          varchar2( 255)',
'   , initiator               varchar2( 255)',
'   , initiator_lower         varchar2( 255)',
'   , actual_owner            varchar2( 255)',
'   , actual_owner_lower      varchar2( 255)',
'   , potential_owners        varchar2(4000)',
'   , potential_groups        varchar2(4000)',
'   , excluded_owners         varchar2(4000)',
'   , state_code              varchar2(  32)',
'   , state                   varchar2( 255)',
'   , is_completed            varchar2(   1)',
'   , outcome_code            varchar2(  32)',
'   , outcome                 varchar2( 255)',
'   , badge_css_classes       varchar2( 255)',
'   , badge_text              varchar2( 255)',
'   , created_ago_hours       number',
'   , created_ago             varchar2( 255)',
'   , created_by              varchar2( 255)',
'   , created_on              timestamp with time zone',
'   , last_updated_by         varchar2( 255)',
'   , last_updated_on         timestamp with time zone',
'   , process_id              number',
'   , subflow_id              number',
'   , step_key                varchar2(20)',
'   , current_obj             varchar2(50)',
');',
'',
' type t_task_list_items is table of t_task_list_item;',
'',
'/**',
'package',
'=======',
'',
'The `flow_api_pkg` package gives you access to the Flows for APEX engine, and allows you to perform:',
'-  Flow Instance Operations, allowing you to Create, Start, Reset, Terminate and Delete a Process Instance.',
'-  Flow Step Operations, allowing you to Complete, Reserve, Release, or signal Starting a Process Step.',
'',
'Flow Instance Operations:',
'-------------------------',
'',
'These API functions allow you to control a process instance, i.e., one operation of the process defined in its process model / process diagram.  These commands allow you to:',
'- Create a process instance',
'- Start an instance',
'- Terminate an instance (stop all processing of an instance)',
'- Reset an instance back to its newly created state',
'- Delete an instance',
'- Set the Instance priority',
'- Set the Instance Due On timestamp.',
'',
'Flow Step Operations:',
'---------------------',
'',
'These API functions allow you to control individual steps in a process instance.  These commands allow you to:',
'- Complete a Step, and move to the next process step',
'- Reserve a Step ',
'- Release a reserved step',
'- record that you are Starting work on a Step',
'- Reschedule a step that is waiting on a timer',
'',
'Application Helper Functions:',
'-----------------------------',
'',
'These API functions are provided as Application Helper functions from the Flows for APEX API.   these commands allow you to:',
'- get the URL of the current userTask',
'- get an engine Error Message in a supported language',
'- return the result of an APEX Approval task to its Flows for APEX process instance upon completion',
'',
'**/',
'   function flow_create (',
'      pi_dgrm_name in flow_diagrams.dgrm_name%type -- Name of the model to instanciate',
',',
'      pi_dgrm_version in flow_diagrams.dgrm_version%type default null -- Version of the model to instanciate (optional)',
',',
'      pi_prcs_name in flow_processes.prcs_name%type -- Name of the process instance to create',
'   ) return flow_processes.prcs_id%type;',
' /**',
'Function flow_create - Signature 1',
'This function creates a new process instance based on a diagram name and version (process specification)',
'If the version is not specified,',
'  first lookup is to use dgrm_status = ''released''',
'  second lookup is to use dgrm_version = ''0'' and dgrm_status = ''draft''',
'If nothing is found based on above rules an exception will be raised.  For accuracy, it is recommended that you specify a version or use the form of flow_create specifying dgrm_id directly.',
'',
'This function returns the Process ID of the newly created process.',
'',
'EXAMPLE',
'',
unistr('This example will create a new process instance called \201CMy Instance Name\201D based on the model \201CMy Model\201D in version \201C0\201D.'),
'',
'```sql',
'declare',
'   l_prcs_id flow_processes.prcs_id%type;',
'begin',
'   l_prcs_id := flow_api_pkg.flow_create(',
'        pi_dgrm_name    => ''My Model''',
'      , pi_dgrm_version => ''0''',
'      , pi_prcs_name    => ''My Instance Name''',
'   );',
'end;',
'```',
'**/',
'   function flow_create (',
'      pi_dgrm_id in flow_diagrams.dgrm_id%type -- ID of the model to instanciate',
',',
'      pi_prcs_name in flow_processes.prcs_name%type -- Name of the process instance to create',
'   ) return flow_processes.prcs_id%type;',
' /**',
'Function flow_create - Signature 2',
'This function creates a new process instance based on a diagram id (process specification) and returns the Process ID of the newly created process',
'',
'EXAMPLE',
'',
unistr('This example will create a new process instance called \201CMy Instance Name\201D based on the model ID 1.'),
'',
'```sql',
'declare',
'   l_prcs_id flow_processes.prcs_id%type;',
'begin',
'   l_prcs_id := flow_api_pkg.flow_create (',
'        pi_dgrm_id    => 1',
'      , pi_prcs_name    => ''My Instance Name''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_create (',
'      pi_dgrm_name in flow_diagrams.dgrm_name%type -- Name of the model to instanciate',
',',
'      pi_dgrm_version in flow_diagrams.dgrm_version%type default null -- Version of the model to instanciate (optional)',
',',
'      pi_prcs_name in flow_processes.prcs_name%type -- Name of the process instance to create',
'   );',
' /**',
'Procedure flow_create - Signature 1',
'Creates a new process instance based on a diagram name and version (process specification).',
'',
'If the version is not specified:',
'',
unistr('  - first lookup is to use dgrm_status = \2018released\2019'),
unistr('  - second lookup is to use dgrm_version = \20180\2019 and dgrm_status = \2018draft\2019'),
'',
unistr('If nothing is found based on above rules an exception will be raised. For accuracy, it\2019s recommended that you specify a version or use the form of flow_create specifying dgrm_id directly.'),
'',
'EXAMPLE',
'',
unistr('This example will create a new process instance called \201CMy Instance Name\201D based on the model \201CMy Model\201D in version \201C0\201D.'),
'',
'```sql',
'begin',
'   flow_api_pkg.flow_create(',
'        pi_dgrm_name    => ''My Model''',
'      , pi_dgrm_version => ''0''',
'      , pi_prcs_name    => ''My Instance Name''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_create (',
'      pi_dgrm_id in flow_diagrams.dgrm_id%type -- ID of the model to instanciate',
',',
'      pi_prcs_name in flow_processes.prcs_name%type -- Name of the process instance to create',
'   );',
' /**',
'Procedure flow_create - Signature 2',
'',
'This procedure creates a new process instance based on a diagram id and version (process specification)',
'',
'',
'EXAMPLE',
'',
unistr('This example will create a new process instance called \201CMy Instance Name\201D based on the model ID 1.'),
'',
'```sql',
'begin',
'   flow_api_pkg.flow_create(',
'         pi_dgrm_id    => 1',
'      , pi_prcs_name    => ''My Instance Name''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_start (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID to start',
'   );',
' /**',
'Procedure flow_start',
'',
'This procedure is use to start a process that was previously created by flow_create. It will will find the none Start event in the Flow diagram, and step the instance forward from the Start event.',
'',
'',
'EXAMPLE',
'',
unistr('This example will create a new process instance called \201CMy Instance Name\201D based on the model \201CMy Model\201D in version \201C0\201D and start it.'),
'',
'```sql',
'declare',
'   l_prcs_id flow_processes.prcs_id%type;',
'begin',
'   l_prcs_id := flow_api_pkg.flow_create(',
'        pi_dgrm_name    => ''My Model''',
'      , pi_dgrm_version => ''0''',
'      , pi_prcs_name    => ''My Instance Name''',
'   );',
'',
'   flow_api_pkg.flow_start(',
'      p_process_id => l_prcs_id',
'   );',
'end;',
'```',
'**/',
'   procedure flow_reset (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID to reset',
',',
'      p_comment in flow_instance_event_log.lgpr_comment%type default null -- Optional comment to be added to the instance event logs',
'   );',
' /**',
'Procedure flow_reset',
'This procedure is used, typically during model development and testing only, to reset an existing Instance to the state it would be at after it was created, but not yet started. ',
'All Process Variables, except built-ins, are deleted. **This is not meant for use in Production Systems.**',
'',
'EXAMPLE',
'',
'This example will reset the process instance that have the ID 1.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_reset(',
'        p_process_id   => 1',
'      , p_comment      => ''Reset Process Instance using the PL/SQL API''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_terminate (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID to terminate',
',',
'      p_comment in flow_instance_event_log.lgpr_comment%type default null -- Optional comment to be added to the instance event logs',
'   );',
' /**',
'Procedure flow_terminate',
'This procedure is used, typically by an administrator, to permanently stop processing of the Instance (which will be lefty in a status of terminated).',
'',
'EXAMPLE',
'',
'This example will terminate the process instance that have the ID 1.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_terminate(',
'        p_process_id    => 1',
'      , p_comment => ''Process Instance Terminated using the PL/SQL API''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_delete (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID to delete',
',',
'      p_comment in flow_instance_event_log.lgpr_comment%type default null -- Optional comment to be added to the instance event logs',
'   );',
' /**',
'Procedure flow_delete',
'This procedure is used to remove an Instance from the system. All instances, subflows, and variables are deleted from the operational system. ',
'If event logging was enabled while the process was running, records in the event logs are maintained for auditting purposes.',
'',
'EXAMPLE',
'',
'This example will delete the process instance that have the ID 1.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_delete(',
'        p_process_id => 1',
'      , p_comment    => ''Delete Process Instance using the PL/SQL API''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_set_priority (',
'      p_process_id in flow_processes.prcs_id%type       -- Process ID to update,',
',',
'      p_priority   in flow_processes.prcs_priority%type -- New Instance Priority ( values 1 (highest) to 5 (lowest).)',
'   );',
' /**',
'Procedure flow_set_priority.',
'This procedure is used to update the priority of a process instance.  The initial process priority will be set from the process diagram definition, ',
'but this procedure can be used to reset the priority while the instance is running.  Values from 1 (highest priority) to 5 (lowest priority)',
'',
'EXAMPLE',
'',
'This example will update the process instance priority to 1 (most urgent) for process instance 345.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_reset(',
'        p_process_id => 345',
'      , p_priority   => 1',
'   );',
'end;',
'```',
'**/',
'   procedure flow_set_due_on (',
'      p_process_id in flow_processes.prcs_id%type     -- Process ID to update',
',',
'      p_due_on     in flow_processes.prcs_due_on%type -- New Instance Due On timestamp',
'   );',
' /**',
'Procedure flow_set_due_on',
'This procedure is used to update the Due On timestamp of a process instance.  The initial process Due On date (actually a timestamp with time zone) will be set from the process diagram definition, ',
'but this procedure can be used to reset the Due On while the instance is running. Due On date values should be a Timestamp with Time Zone.',
'',
'EXAMPLE',
'',
'This example will update the process instance due_on timestamp to 31 Dec 2027 at 14:30 GMT for process instance 345.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_reset(',
'        p_process_id => 345',
'      , p_due_on     => to_timestamp_tz ( ''31-DEC-2027 14:30:00 GMT'', ''DD-MON-YYYY HH24:MI:SS TZR'')',
'   );',
'e'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nd;',
'```',
'**/',
'   procedure flow_start_step (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
'   );',
' /**',
'Procedure flow_start_step',
'This procedure is an optional command that can be used in applications to signal that a user is about to start working on a task. ',
unistr('This is only used to differentiate \2018waiting\2019 time from \2018processing\2019 time in system logs to aid process management and statistics. '),
unistr('A \2018good-practice\2019 app would issue this call when work is about to start on a task, for example, from a page loading process.'),
'',
'EXAMPLE',
'',
'This example will use this procedure to indicate that the work is started for the task that have the subflow ID 3 in the process ID 1.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_start_step(',
'        p_process_id => 1',
'      , p_subflow_id => 3 ',
'      , p_step_key   => ''NqOiEHUbAF''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_reserve_step (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
',',
'      p_reservation in flow_subflows.sbfl_reservation%type -- Value of the reservation, typically the username',
'   );',
' /**',
'Procedure flow_reserve_step',
'This procedure is used to signal to other users that a user is going to handle this task (see the documentation on reservations).',
'',
'EXAMPLE',
'',
'This example will reserve the step in proces ID 1 and subflow ID 3 for the current user.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_reserve_step(',
'        p_process_id  => 1',
'      , p_subflow_id  => 3 ',
'      , p_step_key    => ''NqOiEHUbAF''',
'      , p_reservation => :APP_USER',
'   );',
'end;',
'```',
'**/',
'   procedure flow_release_step (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
'   );',
' /**',
'Procedure flow_release_step',
'This procedure is used to remove a reservation (see the documentation on reservations).',
'',
'EXAMPLE',
'',
'This example will release the reservation for a step in proces ID 1 and subflow ID 3 for the current user.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_release_step(',
'        p_process_id => 1',
'      , p_subflow_id => 3 ',
'      , p_step_key   => ''NqOiEHUbAF''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_complete_step (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
'   );',
' /**',
'Procedure flow_complete_step',
'This procedure is used to tell the flow engine that the current step is complete, and to move the instance forward to the next step.',
'',
'EXAMPLE',
'',
'This example will complete a step in proces ID 1 and subflow ID 3 for the current user.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_complete_step(',
'        p_process_id  => 1',
'      , p_subflow_id  => 3 ',
'      , p_step_key    => ''NqOiEHUbAF''',
'   );',
'end;',
'```',
'**/',
'   procedure flow_restart_step (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
',',
'      p_comment in flow_instance_event_log.lgpr_comment%type default null -- Optional comment to be added to the instance event logs',
'   );',
' /** Procedure flow_restart_step',
'This procedure is designed to be called by an administrator to restart, for example, a scriptTask or serviceTask that has failed due to an error. ',
'The intended usage is that the adminstrator can fix the script or edit the process data that caused the task to fail, and then restart the task using this call.',
unistr('A comment can optionally be provided, which will be added to the task event log entry. It should only be used on a subflow having a status of \2018error\2019'),
'',
'EXAMPLE',
'',
'This example will restart a step in proces ID 1 and subflow ID 3.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_restart_step(',
'        p_process_id  => 1',
'      , p_subflow_id  => 3',
'      , p_step_key    => ''NqOiEHUbAF'' ',
'   );',
'end;',
'```',
'**/',
'   procedure flow_reschedule_timer (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
',',
'      p_is_immediate in boolean default false -- Causes the step to occur immediately',
',',
'      p_new_timestamp in flow_timers.timr_start_on%type default null -- Causes the step to be rescheduled at the supplied timestamp',
',',
'      p_comment in flow_instance_event_log.lgpr_comment%type default null -- Optional comment to be added to the event logs',
'   );',
' /**',
'Procedure flow_reschedulule_timer',
'flow_reschedule_timer can be called to change the next scheduled time of a timer on a running timer. ',
'It can change the currently scheduled time to a future time, or can instruct the timer to fire immediately. ',
'If the Timer event is a single event timer (timer types Date or Duration), it will change the time at which the event is scheduled to occur to the new time. ',
'If the timer is a Cycle Timer, this changes the time that the next firing is scheduled to occur.  If later cycles exist, the following cycle will be scheduled at the new firing time + the repeat interval. ',
'To fire the timer immediately, set p_is_immediate = true. It should then run on the next timer cycle, usually within a few seconds.',
'To change the firing time to another future time, supply a new timestamp with time zone contaiing the new time. ',
'A comment can be provided, which is passed to the log file for explanation of any rescheduling.',
'',
'EXAMPLE',
'',
'This example causes a waiting step in proces ID 1 and subflow ID 3 to occur immediately.',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_reschedule_timer(',
'        p_process_id   => 1',
'      , p_subflow_id   => 3 ',
'      , p_step_key     => ''NqOiEHUbAF''',
'      , p_is_immediate => true',
'   );',
'end;',
'```',
'',
'This example causes a waiting step in proces ID 1 and subflow ID 3 to be rescheduled for a future time (+2 days).',
'',
'```sql',
'begin',
'   flow_api_pkg.flow_reschedule_timer(',
'        p_process_id    => 1',
'      , p_subflow_id    => 3 ',
'      , p_step_key      => ''NqOiEHUbAF''',
'      , p_new_timestamp => systimestamp + 2',
'   );',
'end;',
'```',
'**/',
'',
'  function get_current_tasks',
'  ( p_context    in varchar2 default flow_constants_pkg.gc_task_list_context_my_tasks',
'  , p_prcs_id    in flow_processes.prcs_id%type default null',
'  , p_user       in varchar2 default null',
'  , p_groups     in varchar2 default null',
'  )',
'  return t_task_list_items pipelined;',
'  /**',
'Function get_current_tasks',
'This function is a pipelined table function which is used to create the Flows for APEX task list.',
'Depending upon the value of p_context, the data returned by the function varies.',
'',
'For p_context = ''MY_TASKS'', the task list generated shows the current userTasks for the user.',
'For p_context = ''SINGLE_PROCESS'', the task list generated shows all of current userTasks and Approval tasks for process instance p_prcs_id.   This is used by the Task Monitor of the Flows for APEX application.',
'',
'  **/',
'   function get_current_usertask_url (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_subflow_id in flow_subflows.sbfl_id%type -- Subflow ID',
',',
'      p_step_key in flow_subflows.sbfl_step_key%type default null -- Step Key',
',',
'      p_scope in flow_subflows.sbfl_scope%type default 0 -- Scope',
'   ) return varchar2;',
' /** get_current_usertask_url',
'This function returns the URL for the current task on the specified subflow.',
'',
'EXAMPLE',
'',
'This example show how to get the current task url for process ID 1 and subflow ID 3.',
'',
'```sql',
'declare',
'   l_url varchar2(4000);',
'begin',
'   l_url := flow_api_pkg.get_current_usertask_url(',
'        p_process_id => 1',
'      , p_subflow_id => 3',
'      , p_step_key   => ''NqOiEHUbAF''',
'   );',
'end;',
'```',
'**/',
'   function message (',
'      p_message_key in varchar2 -- Key of the message that shoud exists in the flow_messages table',
',',
unistr('      p_lang in varchar2 default ''en'' -- Lang code to retrieve the message, default is \201Cen\201D'),
',',
'      p0 in varchar2 default null -- Value for substitution: %0 in the message will be replaced by p0, %1 by p1, etc',
',',
'      p1 in varchar2 default null,',
'      p2 in varchar2 default null,',
'      p3 in varchar2 default null,',
'      p4 in varchar2 default null,',
'      p5 in varchar2 default null,',
'      p6 in varchar2 default null,',
'      p7 in varchar2 default null,',
'      p8 in varchar2 default null,',
'      p9 in varchar2 default null',
'   ) return varchar2;',
' /** message function',
unistr('This function returns a Flows for APEX error message with p0\2026p9 substitutions in p_lang.'),
'',
'EXAMPLE',
'',
unistr('This example show how to get the \201Cgateway-no-route\201D message in french.'),
'',
'```sql',
'declare',
'   l_message varchar2(4000);',
'begin',
'   l_message := flow_api_pkg.message(',
'        p_message_key => ''gateway-no-route''',
'      , p_lang        => ''fr''',
'      , p0            => ''Variable Name''',
'   );',
'end;',
'```',
'**/',
'   procedure return_approval_result (',
'      p_process_id in flow_processes.prcs_id%type -- Process ID',
',',
'      p_apex_task_id in number -- APEX Task ID',
',',
'      p_result in flow_process_variables.prov_var_vc2%type default null -- Approval Result',
'   );',
' /**',
'return_approval_result Procedure',
'A convenience procedure for returning an APEX Approval result into a Flows for APEX process when the task has ben completed.',
'This procedure checks the Task ID is valid, stores p_result into the return variable (as defined in the process diagram),',
'then performs a flow_complete_step to move to the next step.',
'',
'This can be called from an APEX Approval Task Action step.  Note that you can also use the APEX Approval Return Result process plug-in to do this declaratively in your application.',
'',
'EXAMPLE',
'',
'This code could be defined in an APEX Approval Task Action definition when a task is `completed` (on approval and on rejection).  ',
'In this example, we have an APEX Approval parameter PROCESS_ID which contains the Flows for APEX process ID.  The values for p_task_id and p_result are ',
'',
'```sql',
'flow_api_pkg.return_approval_result ( p_process_id      => :PROCESS_ID,',
'                                      p_apex_task_id    => :APEX$TASK_ID,',
'                                      p_result          => :APEX$TASK_OUTCOME);',
'```',
'**/',
'',
'  procedure receive_message',
'  ( p_message_name  flow_message_subscriptions.msub_message_name%type',
'  , p_key_name      flow_message_subscriptions.msub_key_name%type',
'  , p_key_value     flow_message_subscriptions.msub_key_value%type',
'  , p_payload       clob default null',
'  );',
'',
'',
'',
'',
'  function intervalDStoSec (',
'    p_intervalDS  interval day to second',
'  ) return number;',
'',
'    function intervalDStoHours (',
'    p_intervalDS  interval day to second',
'  ) return number;',
'',
'',
'-- Manually Step Timers forward',
'',
'  procedure step_timers;',
'',
'',
'end flow_api_pkg;',
'/',
'create or replace package flow_engine_util',
'  authid definer',
'-- accessible by (flow_engine, flow_gateways, flow_boundary_events, flow_timers_pkg, flow_logging, flow_instances, flow_plsql_runner_pkg, flow_admin_api)',
'as ',
'/* ',
'-- Flows for APEX - flow_engine_util.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created  April-2021  Richard Allen (Flowquest) - for  MT AG',
'-- Modified 2022-07-18  Moritz Klein (MT AG)',
'-- Modified 09-Jan-2024  Richard Allen, Flowquest Consulting',
'--',
'*/',
'',
'  function get_config_value',
'  ( ',
'    p_config_key    in flow_configuration.cfig_key%type,',
'    p_default_value in flow_configuration.cfig_value%type',
'  ) return flow_configuration.cfig_value%type;',
'',
'  procedure set_config_value',
'  ( p_config_key      in flow_configuration.cfig_key%type,',
'    p_value           in flow_configuration.cfig_value%type,',
'    p_update_if_set   in boolean default true',
'  );',
'',
'  function get_object_tag',
'  ( p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id      in flow_diagrams.dgrm_id%type  ',
'  ) return flow_objects.objt_tag_name%type;',
'',
'  function get_object_tag',
'  ( p_sbfl_info   in flow_subflows%rowtype',
'  ) return flow_objects.objt_tag_name%type;',
'  ',
'  function get_object_subtag',
'  (',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id      in flow_diagrams.dgrm_id%type  ',
'  )',
'  return varchar2;',
'',
'  function check_subflow_exists',
'  (',
'    p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  ) return boolean;',
'',
'  --function is_multi_instance',
'  --( ',
'  --  p_objt_attribute   in flow_objects.objt_attributes%type',
'  --) return boolean;',
'',
'  function get_subprocess_parent_subflow',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  , p_current    in flow_objects.objt_bpmn_id%type -- an object in the subprocess',
'  ) return flow_types_pkg.t_subflow_context;',
'',
'  procedure get_number_of_connections',
'  ( pi_dgrm_id                  in flow_diagrams.dgrm_id%type',
'  , pi_target_objt_id           in flow_connections.conn_tgt_objt_id%type',
'  , pi_conn_type                in flow_connections.conn_tag_name%type ',
'  , po_num_forward_connections  out number',
'  , po_num_back_connections     out number',
'  );',
'  ',
'  function get_subflow_info',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_lock_subflow  in boolean default false',
'  , p_lock_process  in boolean default false',
'  ) return flow_subflows%rowtype;',
'',
'  function get_iteration_type',
'  ( p_step_info     in flow_types_pkg.flow_step_info',
'  ) return varchar2;',
'',
'  function get_loop_counter',
'  ( pi_sbfl_id       in  flow_subflows.sbfl_id%type',
'  ) return flow_subflows.sbfl_loop_counter%type;',
'',
'  function step_key',
'  ( pi_sbfl_id        in flow_subflows.sbfl_id%type default null',
'  , pi_current        in flow_subflows.sbfl_current%type default null',
'  , pi_became_current in flow_subflows.sbfl_became_current%type default null',
'  ) return flow_subflows.sbfl_step_key%type;',
'',
'  function step_key_valid',
'  ( pi_prcs_id              in flow_processes.prcs_id%type',
'  , pi_sbfl_id              in flow_subflows.sbfl_id%type',
'  , pi_step_key_supplied    in flow_subflows.sbfl_step_key%type',
'  , pi_step_key_required    in flow_subflows.sbfl_step_key%type default null',
'  ) return boolean;',
'',
'  procedure subflow_complete',
'  ( p_process_id        in flow_processes.prcs_id%type',
'  , p_subflow_id        in flow_subflows.sbfl_id%type',
'  );',
'',
'  procedure terminate_level',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_process_level in flow_subflows.sbfl_process_level%type',
'  );',
'',
'  function subflow_start',
'    ( ',
'      p_process_id                in flow_processes.prcs_id%type',
'    , p_parent_subflow            in flow_subflows.sbfl_id%type',
'    , p_starting_object           in flow_objects.objt_bpmn_id%type',
'    , p_current_object            in flow_objects.objt_bpmn_id%type',
'    , p_route                     in flow_subflows.sbfl_route%type',
'    , p_last_completed            in flow_objects.objt_bpmn_id%type',
'    , p_status                    in flow_subflows.sbfl_status%type default flow_constants_pkg.gc_sbfl_status_running',
'    , p_parent_sbfl_proc_level    in flow_subflows.sbfl_process_level%type',
'    , p_new_proc_level            in boolean default false',
'    , p_new_scope                 in boolean default false',
'    , p_new_diagram               in boolean default false',
'    , p_dgrm_id                   in flow_diagrams.dgrm_id%type',
'    , p_follows_ebg               in boolean default false',
'    , p_loop_counter              in number default null',
'    , p_iteration_type            in flow_subflows.sbfl_iteration_type%type default null',
'    , p_loop_total_instances      in flow_subflows.sbfl_loop_total_instances%type default null',
'    , p_iteration_var             in flow_process_variables.prov_var_name%type default null',
'    , p_iteration_var_scope       in flow_subflows.sbfl_scope%type default null',
'    , p_iter_id                   in flow_iterations.iter_id%type default null',
'    , p_iterated_object           in flow_iterated_objects.iobj_id%type default null',
'    ) return flow_types_pkg.t_subflow_context',
'    ;',
'',
'  function lock_subflow',
'  ( p_subflow_id    in flow_subflows.sbfl_id%type',
'  ) return boolean;',
'',
'  function get_scope',
'  (  p_process_id  in flow_processes.prcs_id%type',
'  ,  p_subflow_id  in flow_subflows.sbfl_id%type',
'  ) return flow_subflows.sbfl_scope%type;',
'',
'  function json_array_join',
'  (',
'    p_json_array in sys.json_array_t',
'  ) return clob;',
'',
'  function json_array_join',
'  (',
'    p_json_array in clob',
'  ) return clob;',
'',
'  function apex_json_array_join',
'  ( p_json_array in apex_t_varchar2',
'  )',
'  return clob;',
'',
'  function clob_to_blob',
'  ( ',
'    pi_clob in clob',
'  ) return blob;',
'',
'end flow_engine_util;',
'/',
'',
'create or replace package flow_gateways',
'/* ',
'-- Flows for APEX - flow_gateways.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created    06-May-2021  Richard Allen (Flowquest, for MT AG)',
'-- Modified   20-Jan-2024  Richard Allen, Flowquest Consulting Limited',
'--',
'*/',
'  authid definer',
'  accessible by (flow_engine, flow_settings)',
'as ',
'',
'procedure process_para_incl_Gateway',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'procedure process_exclusiveGateway',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
' procedure process_eventBasedGateway',
'  ( p_sbfl_info  in flow_subflows%rowtype',
'  , p_step_info  in flow_types_pkg.flow_step_info',
'  );',
'',
'end flow_gateways;',
'/',
'',
'create or replace package flow_boundary_events',
'  authid definer',
'  accessible by (flow_engine, flow_tasks, flow_timers_pkg, flow_subprocesses ',
'                , flow_call_activities)',
'is ',
'',
'  procedure set_boundary_events ',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  , p_sbfl_info  in flow_subflows%rowtype',
'  );  ',
'',
'  procedure unset_boundary_events ',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  );  ',
'',
'  procedure lock_child_boundary_timers',
'  ( p_process_id          in flow_processes.prcs_id%type',
'  , p_subflow_id          in flow_subflows.sbfl_id%type',
'  , p_parent_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  ); ',
'',
'  procedure handle_interrupting_boundary_event',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  , p_event_type in flow_objects.objt_sub_tag_name%type',
'  , p_boundary_object in flow_objects.objt_bpmn_id%type default null',
'  );',
'  procedure process_escalation',
'  ( pi_sbfl_info        in  flow_subflows%rowtype',
'  , pi_step_info        in  flow_types_pkg.flow_step_info',
'  , pi_par_sbfl         in  flow_subflows.sbfl_id%type',
'  , pi_source_type      in  flow_types_pkg.t_bpmn_id',
'  , po_step_key         out flow_subflows.sbfl_step_key%type',
'  , po_is_interrupting  out boolean',
'  );',
'',
'end flow_boundary_events;',
'/',
'',
'create or replace package flow_tasks',
'  authid definer',
'--  accessible by (flow_engine, flow_engine_util, flow_api_pkg)',
'as  ',
'',
'  procedure process_task',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure process_userTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure process_scriptTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure process_serviceTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure process_manualTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure process_businessRuleTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure process_sendTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'  ',
'  procedure process_receiveTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'',
'  procedure receiveTask_callback',
'  ( p_process_id    flow_processes.prcs_id%type',
'  , p_subflow_id    flow_subflows.sbfl_id%type',
'  , p_step_key      flow_subflows.sbfl_step_key%type',
'  , p_msub_id       flow_message_subscriptions.msub_id%type',
'  );',
'  ',
'end flow_tasks;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_services.pks',
'-- ',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created 21-Nov-2021  Louis Moreaux (Insum, for MT AG) ',
'--',
'*/',
'',
'create or replace package flow_services',
'  authid current_user',
'  -- accessible by ( flow_tasks )',
'as',
'  e_no_default_workspace exception;',
'  e_wrong_default_workspace exception;',
'  e_workspace_not_found exception;',
'  e_email_no_from exception;',
'  e_email_no_to exception;',
'  e_email_no_template exception;',
'  e_email_no_body exception;',
'  e_email_failed exception;',
'  e_json_not_valid exception;',
'',
'  procedure send_email(',
'      pi_prcs_id in flow_processes.prcs_id%type',
'    , pi_sbfl_id in flow_subflows.sbfl_id%type',
'    , pi_objt_id in flow_objects.objt_id%type',
'  );',
'',
'end flow_services;',
'/',
'',
'create or replace package flow_timers_pkg',
'/* ',
'-- Flows for APEX - flow_timers_pkg.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates. 2022-23.',
'--',
'-- Created 2020        Franco Soldaro',
'-- Edited  2020        Moritz Klein - MT AG  ',
'-- Edited  24-Feb-2023 Richard Allen, Oracle',
'--',
'Purpose:',
'   Provides support to timers in Flows for APEX.',
'',
' Grants required:',
'   CREATE JOB',
'',
'',
'******************************************************************************/',
'  authid definer',
'-- accessible by ( flow_engine, flow_instances, flow_boundary_events, flow_api_pkg',
'--               , flow_admin_api )',
'as',
'',
'',
'/******************************************************************************',
'  CONSTANTS',
'******************************************************************************/',
'  c_created    constant varchar2(1) := ''C''; -- Created and waiting for the first action.',
'  c_active     constant varchar2(1) := ''A''; -- The time has already completed 1 action',
'                                            -- but will perform more actions.',
'  c_ended      constant varchar2(1) := ''E''; -- The timer has naturally completed his',
'                                            -- action/s with no external intervention.',
'  c_expired    constant varchar2(1) := ''X''; -- The timers is stopped by call from the',
'                                            -- flow when stepping forward, before his',
'                                            -- natural end.',
'  c_terminated constant varchar2(1) := ''T''; -- Abnormal termination by manual',
'                                            -- intervention.',
'  c_broken     constant varchar2(1) := ''B''; -- Error occured in timer flow.',
'                                            -- Timer will be ignored until manually',
'                                            -- reset to created or active.',
'',
'',
'/******************************************************************************',
'  step_timers',
'    check update status of active timers.',
'******************************************************************************/',
'  procedure step_timers;',
'',
'',
'/******************************************************************************',
'  start_timer',
'    create a new timer instance.',
'******************************************************************************/',
'  procedure start_timer',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type',
'  , pi_step_key     in flow_subflows.sbfl_step_key%type default null',
'  , pi_callback     in flow_timers.timr_callback%type',
'  , pi_callback_par in flow_timers.timr_callback_par%type default null',
'  , pi_run          in flow_timers.timr_run%type default 1 -- 1 original, 2-> repeats',
'  , pi_timr_id      in flow_timers.timr_id%type default null -- only set on repeats',
'  );',
'',
'/******************************************************************************',
'  reschedule_timer',
'    change the time that a timer is scheduled to fire to a new time, or now.',
'******************************************************************************/',
'',
'procedure reschedule_timer',
'(',
'    p_process_id        in flow_processes.prcs_id%type',
'  , p_subflow_id        in flow_subflows.sbfl_id%type',
'  , p_step_key          in flow_subflows.sbfl_step_key%type default null',
'  , p_is_immediate      in boolean default false',
'  , p_restart_immediate in boolean default false',
'  , p_new_timestamp     in flow_timers.timr_start_on%type default null',
'  , p_comment           in flow_instance_event_log.lgpr_comment%type default null',
');',
'',
'',
'/******************************************************************************',
'  expire_timer',
'    increment the progress in a flow pushing it to the next step.',
'******************************************************************************/',
'',
'  procedure expire_timer',
'  (',
'    pi_prcs_id  in  flow_processes.prcs_id%type',
'  , pi_sbfl_id  in  flow_subflows.sbfl_id%type',
'  );',
'',
'/******************************************************************************',
'  lock_timer',
'    locks the specified timer.',
'******************************************************************************/',
'',
'  procedure lock_timer',
'  (',
'    pi_prcs_id  in  flow_processes.prcs_id%type',
'  , pi_sbfl_id  in  flow_subflows.sbfl_id%type',
'  );',
'',
'/******************************************************************************',
'  kill_timer',
'    remove a timer instance before the expiration time.',
'******************************************************************************/',
'',
'  procedure terminate_timer ',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type',
'  , po_return_code out number',
'  );',
'',
'',
'/******************************************************************************',
'  lock_process_timers',
'    locks all the timers of a process.',
'******************************************************************************/',
'',
'  procedure lock_process_timers',
'  (',
'    pi_prcs_id  in  flow_processes.prcs_id%type',
'  );',
'',
'/******************************************************************************',
'  terminate_process_timers',
'    terminate all the timers of a process.',
'******************************************************************************/',
'',
'  procedure terminate_process_timers',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , po_return_code out number',
'  );',
'',
'/******************************************************************************',
'  delete_process_timers',
'    delete all the timers of a process.',
'******************************************************************************/',
'',
'  procedure delete_process_timers',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , po_return_code out number',
'  );',
'',
'/******************************************************************************',
'  terminate_all_timers',
'    termintate all the timers of all processes.',
'******************************************************************************/',
'',
'  procedure terminate_all_timers',
'  (',
'    po_return_code  out  number',
'  );',
'',
'',
'/******************************************************************************',
'  get_timer_repeat_interval',
'    get the repeat interval of the timer scheduler job.',
'******************************************************************************/',
'  function get_timer_repeat_interval',
'  return sys.all_scheduler_jobs.repeat_interval%type',
'  ;',
'',
'/******************************************************************************',
'  set_timer_repeat_interval',
'    set the repeat interval of the timer scheduler job (uses dbms_scheduler syntax)',
'******************************************************************************/',
'',
'  procedure set_timer_repeat_interval ',
'  ( p_repeat_interval  in  varchar2',
'  );',
'',
'/******************************************************************************',
'  get_timer_status',
'    disable the scheduled job processing of timers.',
'******************************************************************************/',
'',
'  function get_timer_status',
'  return varchar2;',
'',
'/******************************************************************************',
'  timer_job_exists',
'    Tells if the job for running timers exists.',
'******************************************************************************/',
'  function timer_job_exists',
'    return boolean;',
'',
'/******************************************************************************',
'  disable_scheduled_job',
'    disable the scheduled job processing of timers.',
'******************************************************************************/',
'',
'  procedure disable_scheduled_job;',
'',
'/******************************************************************************',
'  enable_scheduled_job',
'    enable the scheduled job processing of timers.',
'******************************************************************************/',
'',
'  procedure enable_scheduled_job;',
'',
'end flow_timers_pkg;',
'/',
'',
'create or replace package flow_instances',
'/* ',
'-- Flows for APEX - flow_instances.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyrigh'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
't MT AG, 2021-2022.',
'--',
'-- Created 25-May-2021  Richard Allen (Flowquest) for  MT AG  - refactor from flow_engine',
'--',
'*/',
'  authid definer',
'  accessible by (flow_api_pkg, flow_engine, flow_proc_vars_int, flow_diagram, flow_message_util_ee)',
'as',
'',
'  function create_process',
'    ( p_dgrm_id   in flow_diagrams.dgrm_id%type',
'    , p_prcs_name in flow_processes.prcs_name%type',
'    ) return flow_processes.prcs_id%type',
'    ;',
'',
'  procedure start_process',
'    ( p_process_id             in flow_processes.prcs_id%type',
'    , p_event_starting_object  in flow_objects.objt_bpmn_id%type default null    -- only for messageStart, etc.',
'    );',
'',
'  procedure reset_process',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'    );',
'',
'  procedure terminate_process',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'    );',
'',
'  procedure delete_process',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'    );',
'',
'  procedure set_priority',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_priority    in flow_processes.prcs_priority%type',
'    );',
'',
'  function priority',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    ) return flow_processes.prcs_priority%type',
'    ;',
'',
'  procedure set_due_on',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_due_on      in flow_processes.prcs_due_on%type',
'    );',
'',
'  function due_on',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    ) return flow_processes.prcs_due_on%type',
'    ;',
'',
'end flow_instances;',
'/',
'',
'create or replace package flow_engine',
'/* ',
'-- Flows for APEX - flow_engine.pks',
'-- ',
'-- (c) Copyright Flowquest Consulting Limited. 2020-24.',
'--',
'-- Created  11-Sep-2020  Richard Allen (Flowquest)',
'-- Modified 09-Jan-2024  Richard Allen, Flowquest Consulting',
'--',
'*/',
'  authid definer',
'  accessible by ( flow_api_pkg, flow_instances, flow_gateways, flow_tasks',
'                , flow_boundary_events, flow_timers_pkg, flow_subprocesses',
'                , flow_call_activities, flow_usertask_pkg',
'                , flow_message_util, flow_message_util_ee, flow_message_flow',
'                , flow_iteration)',
'as ',
'  procedure timer_callback',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_step_key      in flow_subflows.sbfl_step_key%type',
'  , p_timr_id       in flow_timers.timr_id%type default null',
'  , p_run           in flow_timers.timr_run%type default null',
'  , p_callback      in flow_timers.timr_callback%type default null',
'  , p_callback_par  in flow_timers.timr_callback_par%type default null',
'  , p_event_type    in flow_objects.objt_sub_tag_name%type',
'  ); ',
'procedure flow_complete_step',
'  ( p_process_id        in flow_processes.prcs_id%type',
'  , p_subflow_id        in flow_subflows.sbfl_id%type',
'  , p_step_key          in flow_subflows.sbfl_step_key%type default null',
'  , p_forward_route     in flow_connections.conn_bpmn_id%type default null   ',
'  , p_log_as_completed  in boolean default true',
'  , p_reset_step_key    in boolean default false',
'  , p_recursive_call    in boolean default true',
'  );',
'',
'procedure start_step',
'  ( p_process_id          in flow_processes.prcs_id%type',
'  , p_subflow_id          in flow_subflows.sbfl_id%type',
'  , p_step_key            in flow_subflows.sbfl_step_key%type default null',
'  , p_called_internally   in boolean default false',
'  );',
'',
'procedure restart_step',
'  ( p_process_id          in flow_processes.prcs_id%type',
'  , p_subflow_id          in flow_subflows.sbfl_id%type',
'  , p_step_key            in flow_subflows.sbfl_step_key%type default null',
'  , p_comment             in flow_instance_event_log.lgpr_comment%type default null',
'  );',
'',
'procedure handle_event_gateway_event',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  , p_parent_subflow_id  in flow_subflows.sbfl_id%type',
'  , p_cleared_subflow_id in flow_subflows.sbfl_id%type',
'  );',
'  ',
'end flow_engine;',
'/',
'',
'create or replace package flow_settings',
'as ',
'/* ',
'-- Flows for APEX - flow_settings.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created    21-Nov-2022  Richard Allen (Oracle)',
'-- Modified   11-Feb-2024  Richard Allen (Flowquest Consulting)',
'--',
'*/',
'',
'  --- Datatype Specific Settings Getters - Use if setting has no special options',
'  function get_vc2_expression',
'  ( pi_prcs_id       flow_processes.prcs_id%type default null',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type default null',
'  , pi_expr          flow_types_pkg.t_bpmn_attribute_vc2 default null',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return   flow_types_pkg.t_bpmn_attribute_vc2;',
'',
'  function get_clob_expression',
'  ( pi_prcs_id       flow_processes.prcs_id%type  default null',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type  default null',
'  , pi_expr          clob',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return   clob;',
'',
'  -- setting-specific getters - use if the setting is not standard...',
'  function get_due_on',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type default null',
'  , pi_expr          flow_objects.objt_attributes%type',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return timestamp with time zone;',
'',
'  function get_priority',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type default null',
'  , pi_expr          flow_types_pkg.t_bpmn_attribute_vc2',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return flow_processes.prcs_priority%type;',
'',
'  function get_endpoint',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type',
'  , pi_expr          flow_types_pkg.t_bpmn_attribute_vc2',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return   flow_types_pkg.t_bpmn_attribute_vc2;  ',
'',
'  function get_iteration_settings',
'  ( pi_expr          sys.json_object_t',
'  ) return   flow_types_pkg.t_iteration_vars;    ',
'',
'end flow_settings;',
'/',
'',
'create or replace package flow_reservations',
'  authid definer',
'  accessible by (flow_api_pkg, flow_engine)',
'as ',
'',
'    procedure reserve_step',
'    ( p_process_id         in flow_processes.prcs_id%type',
'    , p_subflow_id         in flow_subflows.sbfl_id%type',
'    , p_step_key           in flow_subflows.sbfl_step_key%type',
'    , p_reservation        in flow_subflows.sbfl_reservation%type',
'    , p_called_internally  in boolean default false',
'    );',
'',
'    procedure release_step',
'    ( p_process_id         in flow_processes.prcs_id%type',
'    , p_subflow_id         in flow_subflows.sbfl_id%type',
'    , p_step_key           in flow_subflows.sbfl_step_key%type default null',
'    , p_called_internally  in boolean default false',
'    );',
'',
'end flow_reservations;',
'/',
'',
'create or replace package flow_proc_vars_int',
'  authid definer',
'as ',
'/* ',
'-- Flows for APEX - flow_proc_vars_int.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created    12-Apr-2022  Richard Allen (Oracle)',
'-- Modified   11-Aug-2022  Moritz Klein (MT AG)',
'-- Modified   10-Jan-2024  Richard Allen (Flowquest Consulting Ltd)',
'--',
'*/',
'',
' /********************************************************************************',
'**',
'**        PROCESS VARIABLE SYSTEM (get / set / etc) ',
'**        FOR USE ONLY BY THE FLOW ENGINE (PRIVATE TO ENGINE)',
'**',
'********************************************************************************/ ',
' type t_proc_var_value is record',
' ( var_name     flow_process_variables.prov_var_name%type',
' , var_type     flow_process_variables.prov_var_type%type',
' , var_vc2      flow_process_variables.prov_var_vc2%type',
' , var_num      flow_process_variables.prov_var_num%type',
' , var_date     flow_process_variables.prov_var_date%type',
' , var_clob     flow_process_variables.prov_var_clob%type',
' , var_tstz     flow_process_variables.prov_var_tstz%type',
' , var_json     flow_process_variables.prov_var_json%type',
' ); ',
' ',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_vc2_value    in flow_process_variables.prov_var_vc2%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_num_value    in flow_process_variables.prov_var_num%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_date_value   in flow_process_variables.prov_var_date%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_clob_value   in flow_process_variables.prov_var_clob%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_tstz_value   in flow_process_variables.prov_var_tstz%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_json_value   in flow_process_variables.prov_var_json%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_json_element in sys.json_element_t',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_value    in t_proc_var_value',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
');',
'-- getters return',
'',
'function get_var_vc2',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_vc2%type;',
'',
'function get_var_num',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_num%type;',
'',
'function get_var_date',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_date%type;',
'',
'function get_var_clob',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_clob%type;',
'',
'function get_var_tstz',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_tstz%type;',
'',
'function get_var_json',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_json%type;',
'',
'function get_var_json_element',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return sys.json_element_t;',
'',
'function get_var_value',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return t_proc_var_value;',
'  ',
'function get_var_type',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_type%type;',
'',
'procedure delete_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
');',
'',
'/********************************************************************************',
'**',
'**        SPECIAL CASE / BUILT-IN PROCESS VARIABLES',
'**',
'********************************************************************************/ ',
'',
'procedure set_business_ref',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_vc2_value    in flow_process_variables.prov_var_vc2%type',
', pi_scope        in flow_subflows.sbfl_scope%type default 0',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
');',
'',
'function get_business_ref',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_scope   in flow_subflows.sbfl_scope%type default 0',
')',
'return flow_process_variables.prov_var_vc2%type;',
'',
'',
' /********************************************************************************',
'**',
'**        FOR FLOW_ENGINE USE',
'**',
'********************************************************************************/ ',
'',
'function lock_var ',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
') return boolean;',
'',
'procedure set_vars_from_json_object',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_scope        in flow_subflows.sbfl_scope%type default 0',
', pi_json         in sys.json_object_t',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null',
');',
'-- note  that if a json element is null, the process variable does not get created.',
'',
'procedure delete_all_for_process',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_retain_builtins in boolean default false',
');',
'',
'procedure do_substitution',
'(',
'  pi_prcs_id  in flow_processes.prcs_id%type',
', pi_sbfl_id  in flow_subflows.sbfl_id%type default null',
', pi_scope    in flow_subflows.sbfl_scope%type',
', pi_step_key in flow_subflows.sbfl_step_key%type default null',
', pio_string  in out nocopy varchar2',
');',
'',
'procedure do_substitution',
'(',
'  pi_prcs_id  in flow_processes.prcs_id%type',
', pi_sbfl_id  in flow_subflows.sbfl_id%type default null',
', pi_scope    in flow_subflows.sbfl_scope%type',
', pi_step_key in flow_subflows.sbfl_step_key%type default null',
', pio_string  in out nocopy clob',
');',
'',
'function scope_is_valid',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_scope   in flow_subflows.sbfl_scope%type',
') return boolean;',
'',
'  /*procedure get_var_as_parameter',
'  (',
'    pi_prcs_id            in flow_process_variables.prov_prcs_id%type',
'  , pi_var_name           in flow_process_variables.prov_var_name%type',
'  , pi_scope              in flow_process_variables.prov_scope%type',
'  , pi_exception_on_null  in boolean default true',
'  , po_data_type         out apex_exec.t_data_type',
'  , po_value             out apex_exec.t_value',
'  );*/',
'  function get_var_as_parameter',
'  (',
'    pi_prcs_id            in flow_process_variables.prov_prcs_id%type',
'  , pi_var_name           in flow_process_variables.prov_var_name%type',
'  , pi_scope              in flow_process_variables.prov_scope%type',
'  , pi_exception_on_null  in boolean default true',
'  ) return apex_exec.t_parameter;',
'',
'  function get_parameter_list',
'  (',
'    pi_expr           in  varchar2',
'  , pi_prcs_id        in  flow_processes.prcs_id%type',
'  , pi_sbfl_id        in  flow_subflows.sbfl_id%type',
'  , pi_scope          in  flow_subflows.sbfl_scope%type',
'  , pi_state_params   in  apex_exec.t_parameters default apex_exec.c_empty_parameters',
'  ) return apex_exec.t_parameters;',
'',
'  function get_var_as_vc2',
'  (',
'    pi_prcs_id           in flow_process_variables.prov_prcs_id%type',
'  , pi_var_name          in flow_process_variables.prov_var_name%type',
'  , pi_scope             in flow_process_variables.prov_scope%type',
'  , pi_exception_on_null in boolean default true',
'  ) return varchar2;',
'',
'  function get_bind_list',
'  (',
'    pi_expr in clob',
'  , pi_prcs_id  in  flow_processes.prcs_id%type',
'  , pi_sbfl_id  in  flow_subflows.sbfl_id%type',
'  , pi_scope    in  flow_subflows.sbfl_scope%type',
'  ) return apex_plugin_util.t_bind_list;',
'',
'  function get_vars_as_json_object',
'  ( pi_prcs_id   in flow_processes.prcs_id%type',
'  , pi_scope     in flow_subflows.sbfl_scope%type',
'  , pi_var_list  in flow_types_pkg.t_bpmn_attribute_vc2',
'  ) return sys.json_object_t;',
'',
'end flow_proc_vars_int;',
'/',
'',
'create or replace package flow_db_exec',
'as ',
'/* ',
'-- Flows for APEX - flow_db_exec.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright Flowquest Consulting Limited. 2024.',
'--',
'-- Created  08-Dec-2022  Richard Allen (Oracle Corporation)',
'-- Changed  21-FEB-2023  Moritz Klein (MT GmbH)',
'-- Changed  11-feb-2024  Richard Allen (Flowquest Consulting)',
'--',
'*/',
'  c_wrap_vc2_expr_pre       constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := #'';',
'  c_wrap_vc2_expr_post      constant flow_types_pkg.t_expr_type := q''# ; end;#'';',
'  c_wrap_vc2_func_pre       constant flow_types_pkg.t_expr_type := q''#declare function x return varchar2 is begin #'';',
'  c_wrap_vc2_func_post      constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := x; end;#'';',
'',
'  c_wrap_num_expr_pre       constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := #'';',
'  c_wrap_num_expr_post      constant flow_types_pkg.t_expr_type := q''# ; end;#'';',
'  c_wrap_num_raw_expr_pre   constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := to_char( #'';',
'  c_wrap_num_raw_expr_post  constant flow_types_pkg.t_expr_type := q''# ) ; end;#'';',
'  c_wrap_num_func_pre       constant flow_types_pkg.t_expr_type := q''#declare function x return varchar2 is begin #'';',
'  c_wrap_num_func_post      constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := x; end;#'';',
'  c_wrap_num_raw_func_pre   constant flow_types_pkg.t_expr_type := q''#declare function x return number is begin #'';',
'  c_wrap_num_raw_func_post  constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := cast (x as varchar2); end;#'';',
'',
'  c_wrap_date_expr_pre      constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := #'';',
'  c_wrap_date_expr_post     constant flow_types_pkg.t_expr_type := q''#; end;#'';',
'  c_wrap_date_raw_expr_pre  constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := to_char( #'';',
'  c_wrap_date_raw_expr_post constant flow_types_pkg.t_expr_type := q''# ,''#''||flow_constants_pkg.gc_prov_default_date_format||q''#''); end;#'';',
'  c_wrap_date_func_pre      constant flow_types_pkg.t_expr_type := q''#declare function x return varchar2 is begin #'';',
'  c_wrap_date_func_post     constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := x; end;#'';',
'  c_wrap_date_raw_func_pre  constant flow_types_pkg.t_expr_type := q''#declare function x return date is begin #'';',
'  c_wrap_date_raw_func_post constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := to_char(x, ''#''||flow_constants_pkg.gc_prov_default_date_format||q''#''); end;#'';',
'',
'  c_wrap_tstz_expr_pre      constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := #'';',
'  c_wrap_tstz_expr_post     constant flow_types_pkg.t_expr_type := q''#; end;#'';',
'  c_wrap_tstz_raw_expr_pre  constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := to_char( #'';',
'  c_wrap_tstz_raw_expr_post constant flow_types_pkg.t_expr_type := q''# ,''#''||flow_constants_pkg.gc_prov_default_tstz_format||q''#''); end;#'';',
'  c_wrap_tstz_func_pre      constant flow_types_pkg.t_expr_type := q''#declare function x return varchar2 is begin #'';',
'  c_wrap_tstz_func_post     constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := x; end;#'';',
'  c_wrap_tstz_raw_func_pre  constant flow_types_pkg.t_expr_type := q''#declare function x return timestamp with time zone is begin #'';',
'  c_wrap_tstz_raw_func_post constant flow_types_pkg.t_expr_type := q''#return null; end; begin :BIND_OUT_VAR := to_char(x, ''#''||flow_constants_pkg.gc_prov_default_tstz_format||q''#''); end;#'';',
'',
'  c_wrap_bool_expr_pre      constant flow_types_pkg.t_expr_type := q''#begin :BIND_OUT_VAR := case #'';',
'  c_wrap_bool_expr_post     constant flow_types_pkg.t_expr_type := q''# when true then ''true'' else ''false'' end; end;#'';',
'',
'',
'  function exec_flows_sql',
'  ( pi_prcs_id        flow_processes.prcs_id%type  default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_sql_text       varchar2',
'  , pi_result_type    varchar2  ',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  ) return flow_proc_vars_int.t_proc_var_value;',
'',
'  function exec_flows_plsql',
'  ( pi_prcs_id        flow_processes.prcs_id%type  default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text     varchar2',
'  , pi_result_type    varchar2  ',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  , pi_state_params   apex_exec.t_parameters default apex_exec.c_empty_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value;',
'',
'  -- pi_expr_type    = flow_constants_pkg.gc_expr_type_plsql_function_body ',
'  --                 = flow_constants_pkg.gc_expr_type_plsql_raw_function_body',
'  --                 = flow_constants_pkg.gc_expr_type_plsql_expression',
'  --                 = flow_constants_pkg.gc_expr_type_plsql_raw_expression',
'',
'',
'',
'end flow_db_exec;',
'/',
'',
'create or replace package flow_process_vars',
'  authid definer',
'as /* ',
'-- Flows for APEX - flow_process_vars.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2020-2022.',
'-- (c) Copyright Flowquest Consulting Limited and / or its affiliates.  2020-2024.',
'-- (c) Copyright Insum Solutions 2020-2024.',
'--',
'-- Created 22-SEP-2020  Richard Allen (Flowquest) ',
'-- Edited  13-APR-2022 - Richard Allen (Oracle)',
'-- edited  24-May-2024 - Richard Allen (Flowquest)',
'-- edited  18-Sep-2024 - Louis Moreaux (Insum Solutions)',
'--',
'*/',
'/*',
'**',
'**        PROCESS VARIABLE SYSTEM (get / set / etc)',
'**        Process Variable System API for Application Developers',
'**',
'*/ ',
' ',
'/**',
'PROCESS VARIABLE SYSTEM API',
'===========================',
'',
'The `flow_process_vars` package give you access to be able to set and get Process Variables making up the Flows for APEX Process Variable System.help',
'',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                      -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type        -- Name of the process variable',
', pi_vc2_value  in flow_process_variables.prov_var_vc2%type         -- Value of variable (VARCHAR2)',
', pi_scope      in flow_process_variables.prov_scope%type default 0 -- Variable Scope, defaults to 0 ',
');',
'/**',
'SIGNATURE 1a - VARCHAR2 - Using Scope.',
'',
'This procedure is used to set a VARCHAR2 value of a process variable using a supplied scope (defaulting to 0, the top level scope) ',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_VAR" to "MY_VAR_VALUE" in the process instance ID 1 in scope 0.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id   => 1',
'      , pi_var_name  => ''MY_VAR''',
'      , pi_scope     => 0',
'      , pi_vc2_value => ''MY_VAR_VALUE''',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_vc2_value  in flow_process_variables.prov_var_vc2%type   -- Value of variable (VARCHAR2)',
', pi_sbfl_id    in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 1b - VARCHAR2 - Using Subflow_id.',
'',
'This procedure is used to set a VARCHAR2 value of a process variable, using the current `subflow_id` to set the correct scope.   This will look up the current scope for this subflow, before setting the process variable.',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_VAR" to "MY_VAR_VALUE" in the process instance ID 1, with a scope used in subflow 12.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id   => 1',
'      , pi_var_name  => ''MY_VAR''',
'      , pi_sbfl_id   => 12',
'      , pi_vc2_value => ''MY_VAR_VALUE''',
'   );',
'end;',
'```',
'',
'**/',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_num_value  in flow_process_variables.prov_var_num%type          -- Value of variable (NUMBER)',
', pi_scope      in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 2a - NUMBER - Using Scope.',
'',
'This procedure is used to set a NUMBER value of a process variable using a supplied scope (defaulting to 0, the top level scope) ',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_VAR" to 1234 in the process instance ID 1 in scope 0.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id   => 1',
'      , pi_var_name  => ''MY_VAR''',
'      , pi_scope     => 0',
'      , pi_num_value => 1234',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id   in flow_processes.prcs_id%type               -- Process ID',
', pi_var_name  in flow_process_variables.prov_var_name%type -- Name of the process variable',
', pi_num_value in flow_process_variables.prov_var_num%type  -- Value of the variable (NUMBER)',
', pi_sbfl_id   in flow_subflows.sbfl_id%type                -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 2b - NUMBER - Using Subflow_id.',
'',
'This procedure is used to set a NUMBER value of a process variable using a supplied using the current `subflow_id` to set the correct scope.   This will look up the current scope for this subflow, before setting the process variable.',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_VAR" to 1234 in the process instance ID 1, with a scope used in subflow 12.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id   => 1',
'      , pi_var_name  => ''MY_VAR''',
'      , pi_sbfl_id   => 12',
'      , pi_num_value => 1234',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                      -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type        -- Name of the process variable',
', pi_date_value in flow_process_variables.prov_var_date%type        -- Value of the variable (DATE)',
', pi_scope      in flow_process_variables.prov_scope%type default 0 -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 3a - DATE - Using Scope.',
'',
'This procedure is used to set a DATE value of a process variable using a sup'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'plied scope (defaulting to 0, the top level scope) ',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_DATE" to the current date, sysdate, in the process instance ID 1 in scope 0.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_DATE''',
'      , pi_scope      => 0',
'      , pi_date_value => sysdate',
'   );',
'end;',
'```',
'**/',
'',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_date_value in flow_process_variables.prov_var_date%type  -- Value of the variable (DATE)',
', pi_sbfl_id    in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 3b - DATE - Using Subflow_id.',
'',
'This procedure is used to set a DATE value of a process variable usingthe current `subflow_id` to set the correct scope.   This will look up the current scope for this subflow, before setting the process variable.',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_DATE" to the current date, sysdate, in the process instance ID 1, with a scope used in subflow 12.',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_DATE''',
'      , pi_sbfl_id    => 1',
'      , pi_date_value => sysdate',
'   );',
'end;',
'```',
'**/',
'  ',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                      -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type        -- Name of the process variable',
', pi_clob_value in flow_process_variables.prov_var_clob%type        -- Value of the variable (CLOB)',
', pi_scope      in flow_process_variables.prov_scope%type default 0 -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 4a - CLOB - Using Scope.',
'',
'This procedure is used to set a CLOB value of a process variable using a supplied scope (defaulting to 0, the top level scope) ',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_CLOB" to the CLOB provided for the process instance ID 1 in scope 0.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_CLOB''',
'      , pi_scope      => 0',
'      , pi_clob_value => to_clob(''This is a long text'')',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_clob_value in flow_process_variables.prov_var_clob%type  -- Value of the variable (CLOB)',
', pi_sbfl_id    in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 4b - CLOB - Using Subflow_id.',
'',
'This procedure is used to set a CLOB value of a process variable usingthe current `subflow_id` to set the correct scope.   This will look up the current scope for this subflow, before setting the process variable.',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_CLOB" to the CLOB provided in the process instance ID 1, with a scope used in subflow 12.',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_CLOB''',
'      , pi_sbfl_id    => 12',
'      , pi_clob_value => to_clob(''This is a long text'')',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                      -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type        -- Name of the process variable',
', pi_tstz_value in flow_process_variables.prov_var_tstz%type        -- Value of the variable (TIMESTAMP WITH TIME ZONE)',
', pi_scope      in flow_process_variables.prov_scope%type default 0 -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 5a - TIMESTAMP WITH TIMEZONE - Using Scope.',
'',
'This procedure is used to set a TIMESTAMP WITH TIME ZONE value of a process variable using a supplied scope (defaulting to 0, the top level scope) ',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_TSTZ" to the current date, systimestamp, in the process instance ID 1 in scope 0.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_TSTZ''',
'      , pi_scope      => 0',
'      , pi_date_value => systimestamp',
'   );',
'end;',
'```',
'**/',
'',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_tstz_value in flow_process_variables.prov_var_tstz%type  -- Value of the variable (TIMESTAMP WITH TIME ZONE)',
', pi_sbfl_id    in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 5b - TIMESTAMP WITH TIMEZONE - Using Subflow_id.',
'',
'This procedure is used to set a TIMESTAMP WITH TIME ZONE value of a process variable using the current `subflow_id` to set the correct scope.   This will look up the current scope for this subflow, before setting the process variable.',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_TSTZ" to the current date, systimestamp, in the process instance ID 1, with a scope used in subflow 12.',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_TSTZ''',
'      , pi_sbfl_id    => 1',
'      , pi_date_value => systimestamp',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                      -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type        -- Name of the process variable',
', pi_json_value in flow_process_variables.prov_var_json%type        -- Value of the variable (JSON)',
', pi_scope      in flow_process_variables.prov_scope%type default 0 -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 6a - JSON - Using Scope.',
'',
'This procedure is used to set a JSON value of a process variable using a supplied scope (defaulting to 0, the top level scope) ',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_JSON" to the JSON provided for the process instance ID 1 in scope 0.',
'',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_JSON''',
'      , pi_scope      => 0',
'      , pi_json_value => ''{"myAttribute":"myValue"}''',
'   );',
'end;',
'```',
'**/',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type                -- Process ID',
', pi_var_name   in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_json_value in flow_process_variables.prov_var_json%type  -- Value of the variable (JSON)',
', pi_sbfl_id    in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 6b - JSON - Using Subflow_id.',
'',
'This procedure is used to set a JSON value of a process variable usingthe current `subflow_id` to set the correct scope.   This will look up the current scope for this subflow, before setting the process variable.',
'',
'EXAMPLE',
'',
'This example will set the value of the process variable "MY_JSON" to the JSON provided in the process instance ID 1, with a scope used in subflow 12.',
'```sql',
'begin',
'   flow_process_vars.set_var(',
'        pi_prcs_id    => 1',
'      , pi_var_name   => ''MY_JSON''',
'      , pi_sbfl_id    => 12',
'      , pi_clob_value => ''{"myAttribute":"myValue"}''',
'   );',
'end;',
'```',
'**/',
'  ',
'-- getters return',
'',
'-- get_var_vc2:  varchar2 type - SIGNATURE 1',
'',
'function get_var_vc2',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID ',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_vc2%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a VARCHAR2 process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_vc2%type;',
'begin',
'   l_value := flow_process_vars.get_var_vc2(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_vc2',
'( pi_prcs_id           in flow_processes.prcs_id%type                -- Process ID ',
', pi_var_name          in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                      -- If true, return an exception if null',
') return flow_process_variables.prov_var_vc2%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id',
'',
'This function is used to get the value of a VARCHAR2 process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR", in the scope used in subflow 12.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_vc2%type;',
'begin',
'   l_value := flow_process_vars.get_var_vc2(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_num',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_num%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a NUMBER process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_num%type;',
'begin',
'   l_value := flow_process_vars.get_var_num(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_num',
'( pi_prcs_id in flow_processes.prcs_id%type                    -- Process ID',
', pi_var_name in flow_process_variables.prov_var_name%type     -- Name of the process variable',
', pi_sbfl_id in flow_subflows.sbfl_id%type                     -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                -- If true, return an exception if null',
') return flow_process_variables.prov_var_num%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the value of a NUMBER process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR", in the scope used in subflow 12.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_num%type;',
'begin',
'   l_value := flow_process_vars.get_var_num(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_date',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_date%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a DATE process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_date%type;',
'begin',
'   l_value := flow_process_vars.get_var_date(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_date',
'( pi_prcs_id           in flow_processes.prcs_id%type                 -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type   -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                  -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                       -- If true, return an exception if null',
') return flow_process_variables.prov_var_date%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the value of a DATE process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR", in the scope used in subflow 12.',
'',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_date%type;',
'begin',
'   l_value := flow_process_vars.get_var_date(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_clob',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_clob%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a CLOB process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_clob%type;',
'begin',
'   l_value := flow_process_vars.get_var_clob(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_clob',
'( pi_prcs_id           in flow_processes.prcs_id%type                 -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type   -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                  -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                       -- If true, return an exception if null',
') return flow_process_variables.prov_var_clob%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the value of a CLOB process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR", in the scope used in subflow 12.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_clob%type;',
'begin',
'   l_value := flow_process_vars.get_var_clob(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_json',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_json%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a JSON process variable in string format (CLOB).  To get as a JSON object (json_element_t) see ',
'get_var_json_element.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_json%type;',
'begin',
'   l_value := flow_process_vars.get_var_json(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_json',
'( pi_prcs_id           in flow_processes.prcs_id%type                 -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type   -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                  -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                       -- If true, return an exception if null',
') return flow_process_variables.prov_var_json%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the value of a JSON process variable in string format (CLOB).  To get as a JSON object (json_element_t) see ',
'get_var_json_element.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR", in the scope used in subflow 12.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_json%type;',
'begin',
'   l_value := flow_process_vars.get_var_json(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_json_element',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return sys.json_element_t;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a JSON process variable as a JSON object (json_element_t).  To get in string format (CLOB) see ',
'get_var_json.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value sys.json_element_t;',
'begin',
'   l_value := flow_process_vars.get_var_json_element(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_json_element',
'( pi_prcs_id           in flow_processes.prcs_id%type                 -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type   -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                  -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                       -- If true, return an exception if null',
') return sys.json_element_t;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the value of a JSON process variable as a JSON object (json_element_t).  To get as a string, see ',
'get_var_json.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_VAR", in the scope used in subflow 12.',
'',
'```sql',
'declare',
'   l_value sys.json_elent_t;',
'begin',
'   l_value := flow_process_vars.get_var_json_element(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_VAR''',
'              );',
'end;',
'```',
'**/',
'',
'',
'function get_var_tstz',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_tstz%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of a TIMESTAMP process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_TSTZ" in the main diagram scope.',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_tstz%type;',
'begin',
'   l_value := flow_process_vars.get_var_date(',
'                   pi_prcs_id   => 1',
'                 , pi_scope     => 0',
'                 , pi_var_name  => ''MY_TSTZ''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_tstz',
'( pi_prcs_id           in flow_processes.prcs_id%type                 -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type   -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                  -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                       -- If true, return an exception if null',
') return flow_process_variables.prov_var_tstz%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the value of a TIMESTAMP process variable.',
'',
'EXAMPLE',
'',
'This example will get the value of the process variable "MY_TSTZ", in the scope used in subflow 12.',
'',
'',
'```sql',
'declare',
'   l_value flow_process_variables.prov_var_tstz%type;',
'begin',
'   l_value := flow_process_vars.get_var_date(',
'                   pi_prcs_id   => 1',
'                 , pi_sbfl_id   => 12',
'                 , pi_var_name  => ''MY_TSTZ''',
'              );',
'end;',
'```',
'**/',
'',
'function get_var_type',
'( pi_prcs_id           in flow_processes.prcs_id%type                       -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type         -- Name of the process variable',
', pi_scope             in flow_process_variables.prov_scope%type default 0  -- Variable Scope, defaults to 0',
', pi_exception_on_null in boolean default false                             -- If true, return an exception if null',
') return flow_process_variables.prov_var_type%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the type of the given process variable, using scope to explicitly identify the variable. If not supplied, the scope defaults to scope 0, the top level for this process instance.',
'',
'EXAMPLE ',
'',
'This example will get the type of the process variable "MY_VARIABLE" in process instance ID 1.',
'```sql',
'declare',
'   l_prov_var_type flow_process_variables.prov_var_type%type;',
'begin',
'   l_prov_var_type := flow_process_vars.get_var_type( ',
'        pi_prcs_id   => 1 ',
'      , pi_scope     => 0',
'      , pi_var_name => ''MY_VARIABLE''',
'   );',
'end;',
'```',
'',
'**/',
'',
'function get_var_type',
'( pi_prcs_id           in flow_processes.prcs_id%type                -- Process ID',
', pi_var_name          in flow_process_variables.prov_var_name%type  -- Name of the process variable',
', pi_sbfl_id           in flow_subflows.sbfl_id%type                 -- Subflow ID, used to set scope',
', pi_exception_on_null in boolean default false                      -- If true, return an exception if null',
') return flow_process_variables.prov_var_type%type;',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to get the type of the given process variable, using a `subflow ID` to identify the variable''s scope. ',
'',
'EXAMPLE ',
'',
'This example will get the type of the process variable "MY_VARIABLE" in process instance ID 1 in the same scope as subflow 12.',
'```sql',
'declare',
'   l_prov_var_type flow_process_variables.prov_var_type%type;',
'begin',
'   l_prov_var_type := flow_process_vars.get_var_type( ',
'        pi_prcs_id   => 1 ',
'      , pi_sbfl_id   => 12',
'      , pi_var_name => ''MY_VARIABLE''',
'   );',
'end;',
'```',
'',
'**/',
'',
'procedure delete_var    ',
'( pi_prcs_id  in flow_processes.prcs_id%type                        -- Process ID',
', pi_var_name in flow_process_variables.prov_var_name%type          -- Name of the process variable',
', pi_scope    in flow_process_variables.prov_scope%type default 0   -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 1 - Using Scope',
'',
'This procedure is used to delete a process variable, using scope to explicitly identify the variable. If not supplied, the scope defaults to scope 0, the top level for this process instance.',
'',
'EXAMPLE ',
'',
'This example will delete the process variable "MY_VAR" in process instance ID 1.',
'```sql',
'begin',
'   flow_process_vars.delete_var(',
'        pi_prcs_id   => 1',
'      , pi_scope     => 0',
'      , pi_var_name  => ''MY_VAR''',
'   );',
'end;',
'```',
'',
'**/',
'-- delete_var - SIGNATURE 2 - by subflow_id',
'',
'procedure delete_var',
'( pi_prcs_id  in flow_processes.prcs_id%type                 -- Process ID',
', pi_var_name in flow_process_variables.prov_var_name%type   -- Name of the process variable',
', pi_sbfl_id  in flow_subflows.sbfl_id%type                  -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This procedure is used to delete a process variable, using a `subflow ID` to identify the variable''s scope. ',
'',
'EXAMPLE ',
'',
'This example will delete the process variable "MY_VAR" in process instance ID 1, in the scope used by subflow 12.',
'```sql',
'begin',
'   flow_process_vars.delete_var(',
'        pi_prcs_id   => 1',
'      , pi_sbfl_id   => 12',
'      , pi_var_name  => ''MY_VAR''',
'   );',
'end;',
'```',
' **/',
'',
'',
'procedure set_business_ref',
'( pi_prcs_id    in flow_processes.prcs_id%type               -- Process ID',
', pi_vc2_value  in flow_process_variables.prov_var_vc2%type  -- Business Reference (underlying PK) (VARCHAR2)',
', pi_scope      in flow_subflows.sbfl_scope%type default 0   -- Variable Scope, defaults to 0',
');',
'/**',
'SIGNATURE 1 - Usinfg Scope.',
'',
'This function is used to set the value of the built-in BUSINESS_REF process variable in scope 0.',
'',
'EXAMPLE ',
'',
'This example will set the value of the process variable "BUSINESS_REFERENCE" in process instance ID 1.',
'```sql',
'begin',
'   flow_process_vars.set_business_ref( ',
'        pi_prcs_id   => 1 ',
'      , pi_scope     => 0',
'      , pi_vc2_value => ''NEW_VALUE''',
'   );',
'end;',
'```',
'',
'**/',
'',
'procedure set_business_ref',
'( pi_prcs_id    in flow_processes.prcs_id%type               -- Process ID',
', pi_vc2_value  in flow_process_variables.prov_var_vc2%type  -- Business Reference (underlying PK) (VARCHAR2)',
', pi_sbfl_id    in flow_subflows.sbfl_id%type                -- Subflow ID, used to set scope',
');',
'/**',
'SIGNATURE 2 - Using Subflow_id.',
'',
'This function is used to set the value of the built-in BUSINESS_REF process variable in scope used by the given `subflow_id`.',
'',
'EXAMPLE ',
'',
'This example will set the value of the process variable "BUSINESS_REFERENCE" in process instance ID 1.',
'```sql',
'begin',
'   flow_process_vars.set_business_ref( ',
'        pi_prcs_id   => 1 ',
'      , pi_sbfl_id   => 12',
'      , pi_vc2_value => ''NEW_VALUE''',
'   );',
'end;',
'```',
'',
'**/',
'function get_business_ref',
'( pi_prcs_id in flow_processes.prcs_id%type                 -- Process ID',
', pi_scope   in flow_subflows.sbfl_scope%type default 0     -- Variable Scope, defaults to 0',
')',
'return flow_process_variables.prov_var_vc2%type;',
'/**',
'SIGNATURE 1 - Using Scope.',
'',
'This function is used to get the value of the built-in BUSINESS_REF process variable.',
'',
'EXAMPLE ',
'',
'This example will get the value of the process variable "BUSINESS_REFERENCE" in process instance ID 1 in scope 0.',
'```sql',
'declare',
'   l_business_ref flow_process_variables.prov_var_vc2%type;',
'begin',
'   l_business_ref := flow_process_vars.get_business_ref( pi_prcs_id => 1, pi_scope => 0);',
'end;',
'```',
'',
'**/',
'function get_business_ref',
'( pi_prcs_id    in flow_processes.prcs_id%type  -- Process ID',
', pi_sbfl_id    in flow_subflows.sbfl_id%type   -- Subflow ID, used to set scope',
')',
'return flow_process_variables.prov_var_vc2%type;',
'/**',
'SIGNATURE 2 - Using Subflow_ID.',
'',
'This function is used to get the value of the built-in BUSINESS_REF process variable.',
'',
'EXAMPLE ',
'',
'This example will get the value of the process variable "BUSINESS_REFERENCE" in process instance ID 1 in scope 0.',
'```sql',
'declare',
'   l_business_ref flow_process_variables.prov_var_vc2%type;',
'begin',
'   l_business_ref := flow_process_vars.get_business_ref( pi_prcs_id => 1, pi_sbfl_id => 12);',
'end;',
'```',
'',
'**/',
'',
'',
'end flow_process_vars;',
'/',
'',
'create or replace package flow_expressions',
'/* ',
'-- Flows for APEX - flow_expressions.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created    13-Mar-2021  Richard Allen (Flowquest, for MT AG)',
'-- Modified   12-Apr-2022  Richard Allen (Oracle)',
'-- Modified   11-Feb-2024  Richard Allen (Flowquest Consulting Limited)',
'--',
'*/',
'',
'',
'  authid current_user',
'  accessible by ( flow_engine, flow_boundary_events, flow_call_activities, ',
'                  flow_gateways, flow_instances, flow_subprocesses, flow_iteration)',
'as ',
'  e_var_exp_date_format_error exception;',
'  e_var_exp_json_format_error exception;',
'',
'  -- Call using objt_id if you have available',
'  procedure process_expressions',
'  ( pi_objt_id      flow_objects.objt_id%type default null',
'  , pi_set          flow_object_expressions.expr_set%type',
'  , pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type',
'  );',
'',
'  -- oterwise overload provided, usung objt_bpmn_id...',
'  procedure process_expressions',
'  ( pi_objt_bpmn_id flow_objects.objt_bpmn_id%type',
'  , pi_set          flow_object_expressions.expr_set%type',
'  , pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type',
'  );',
'',
'end flow_expressions;',
'/',
'',
'create or replace package flow_usertask_pkg',
'/*'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' ',
'-- Flows for APEX - flow_usertask_pkg.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2020-2022.',
'--',
'-- Created 12-Nov-2020  Moritz Klein ( MT AG) ',
'-- Edited  13-Apr-2022 - Richard Allen (Oracle)',
'--',
'*/',
'  authid definer',
'as',
'',
'  function get_url',
'  (',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_sbfl_id in flow_subflows.sbfl_id%type',
'  , pi_objt_id in flow_objects.objt_id%type',
'  , pi_step_key in flow_subflows.sbfl_step_key%type default null',
'  , pi_scope    in flow_subflows.sbfl_scope%type default 0',
'  ) return varchar2;',
'',
'  procedure process_apex_page_task',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'  ',
'  procedure process_apex_approval_task',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  );',
'  ',
'  procedure cancel_apex_task',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_objt_bpmn_id  in flow_objects.objt_bpmn_id%type',
'  , p_apex_task_id  in number    ',
'  );',
'',
'  procedure return_approval_result',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_apex_task_id  in number',
'  , p_result        in flow_process_variables.prov_var_vc2%type default null',
'  );',
'',
'end flow_usertask_pkg;',
'/',
'',
'create or replace package flow_plsql_runner_pkg',
'  authid current_user',
'as',
'',
'  e_plsql_script_requested_stop exception;',
'  e_plsql_script_failed exception;',
'',
'  function get_current_prcs_id',
'    return flow_processes.prcs_id%type',
'  ;',
'  pragma deprecate (get_current_prcs_id, ''flow_plsql_runner_pkg.get_current_prcs_id is deprecated.  Use flow_globals.process_id instead'');',
'',
'  function get_current_sbfl_id',
'    return flow_subflows.sbfl_id%type',
'  ;',
'  pragma deprecate (get_current_sbfl_id, ''flow_plsql_runner_pkg.get_current_sbfl_id is deprecated.  Use flow_globals.subflow_id instead'');',
'  ',
'  procedure run_task_script',
'  (',
'    pi_prcs_id  in flow_processes.prcs_id%type',
'  , pi_sbfl_id  in flow_subflows.sbfl_id%type',
'  , pi_objt_id  in flow_objects.objt_id%type',
'  , pi_step_key in flow_subflows.sbfl_step_key%type default null',
'  );',
'',
'end flow_plsql_runner_pkg;',
'/',
'',
'create or replace package flow_apex_session ',
'  authid current_user',
'-- accessible by ( flow_timers_pkg, flow_engine )',
'as',
'',
'  procedure set_async_proc_vars',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  , p_subflow_id         in flow_subflows.sbfl_id%type',
'  );',
'',
'  function create_async_session',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  , p_subflow_id         in flow_subflows.sbfl_id%type',
'  ) return number;',
'',
'  function create_api_session',
'  ( p_process_id         in flow_processes.prcs_id%type default null',
'  ) return number;',
'',
'  function create_api_session',
'  ( p_subflow_id         in flow_subflows.sbfl_id%type',
'  ) return number;',
'',
'  function create_api_session',
'  ( p_function          in varchar2',
'  ) return number;',
'',
'  procedure delete_session',
'  ( p_session_id         in number);',
'',
'end flow_apex_session;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_subprocesses.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2020,2022.',
'--',
'-- Created  22-Feb-2022   Richard Allen - Refactor SubProcess code from flow_engine',
'-- Modified 15-Jun-2022   Moritz Klein (MT AG)',
'--',
'*/',
'create or replace package flow_subprocesses',
'  authid definer',
'  accessible by ( flow_engine )',
'as',
'',
'  procedure process_process_level_endEvent',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    , p_sbfl_context_par  in flow_types_pkg.t_subflow_context',
'    );',
'',
'  procedure process_subProcess',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    );',
'',
'end flow_subprocesses;',
'/',
'',
'create or replace package flow_call_activities',
'  authid definer',
'  accessible by ( flow_engine )',
'  ',
'as',
'/* ',
'-- Flows for APEX - flow_call_activities.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2020,2022.',
'--',
'-- Created 19-Feb-2022   Richard Allen - Create ',
'--',
'*/',
'  procedure process_callActivity',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    );',
'',
'  function is_called_activity',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type  ',
'    ) return boolean;',
'',
'end flow_call_activities;',
'/',
'',
'create or replace package flow_logging',
'/* ',
'-- Flows for APEX - flow_logging.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created 29-Jul-2021  Richard Allen (Flowquest) for  MT AG  ',
'-- Updated 10-Feb-2023  Richard Allen, Oracle',
'--',
'*/',
'  authid definer',
'  accessible by ( flow_diagram, flow_engine, flow_instances, flow_proc_vars_int, flow_expressions ',
'                , flow_boundary_events, flow_gateways, flow_tasks, flow_errors, flow_timers_pkg',
'                , flow_call_activities, flow_subprocesses , flow_usertask_pkg, flow_settings',
'                , flow_iteration )',
'as',
'',
'  procedure log_diagram_event',
'  ( p_dgrm_id           in flow_diagrams.dgrm_id%type',
'  , p_dgrm_name         in flow_diagrams.dgrm_name%type default null',
'  , p_dgrm_version      in flow_diagrams.dgrm_version%type default null',
'  , p_dgrm_status       in flow_diagrams.dgrm_status%type default null',
'  , p_dgrm_category     in flow_diagrams.dgrm_category%type default null',
'  , p_dgrm_content      in flow_diagrams.dgrm_content%type default null',
'  , p_comment           in flow_flow_event_log.lgfl_comment%type default null',
'  );',
'',
'',
'  procedure log_instance_event',
'  ( p_process_id        in flow_subflow_log.sflg_prcs_id%type',
'  , p_objt_bpmn_id      in flow_objects.objt_bpmn_id%type default null',
'  , p_event             in flow_instance_event_log.lgpr_prcs_event%type ',
'  , p_comment           in flow_instance_event_log.lgpr_comment%type default null',
'  , p_error_info        in flow_instance_event_log.lgpr_error_info%type default null',
'  );',
'',
'  procedure log_step_completion',
'  ( p_process_id        in flow_subflow_log.sflg_prcs_id%type',
'  , p_subflow_id        in flow_subflow_log.sflg_sbfl_id%type',
'  , p_completed_object  in flow_subflow_log.sflg_objt_id%type',
'  , p_iteration_status  in flow_types_pkg.t_iteration_status default null',
'  , p_notes             in flow_subflow_log.sflg_notes%type default null',
'  );',
'',
'  procedure log_variable_event -- logs process variable set events',
'  ( p_process_id        in flow_subflow_log.sflg_prcs_id%type',
'  , p_scope             in flow_process_variables.prov_scope%type',
'  , p_var_name          in flow_process_variables.prov_var_name%type',
'  , p_objt_bpmn_id      in flow_objects.objt_bpmn_id%type default null',
'  , p_subflow_id        in flow_subflow_log.sflg_sbfl_id%type default null',
'  , p_expr_set          in flow_object_expressions.expr_set%type default null',
'  , p_var_type          in flow_process_variables.prov_var_type%type',
'  , p_var_vc2           in flow_process_variables.prov_var_vc2%type default null',
'  , p_var_num           in flow_process_variables.prov_var_num%type default null',
'  , p_var_date          in flow_process_variables.prov_var_date%type default null',
'  , p_var_clob          in flow_process_variables.prov_var_clob%type default null',
'  , p_var_tstz          in flow_process_variables.prov_var_tstz%type default null',
'  , p_var_json          in flow_process_variables.prov_var_json%type default null',
'  );',
'',
'end flow_logging;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_globals.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created    25-Aug-2021  Richard Allen (Flowquest, for MT AG)',
'-- Modified   12-Apr-2022  Richard Allen (Oracle)',
'--',
'*/',
'',
'create or replace package flow_globals',
'  authid definer',
'as',
'',
'  process_id    flow_processes.prcs_id%type;',
'  subflow_id    flow_subflows.sbfl_id%type;',
'  step_key      flow_subflows.sbfl_step_key%type;',
'  scope         flow_subflows.sbfl_scope%type;',
'  rest_call     boolean;',
'  loop_counter  flow_subflows.sbfl_loop_counter%type;',
'',
'  function business_ref',
'  (pi_scope       flow_subflows.sbfl_scope%type default 0)',
'  return flow_process_variables.prov_var_vc2%type;',
'',
'  function business_ref',
'  (pi_sbfl_id     flow_subflows.sbfl_id%type)',
'  return flow_process_variables.prov_var_vc2%type;',
'',
'  procedure set_context',
'  ( pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
'  , pi_step_key     in flow_subflows.sbfl_step_key%type default null',
'  , pi_scope        in flow_subflows.sbfl_scope%type default null',
'  , pi_loop_counter in flow_subflows.sbfl_loop_counter%type default null',
'  );',
'',
'  procedure set_step_error',
'  ( p_has_error  in boolean default false',
'  );',
'',
'  function get_step_error',
'  return boolean;',
'',
'  procedure set_is_recursive_step',
'  ( p_is_recursive_step  in boolean default false',
'  );',
'',
'  function get_is_recursive_step',
'  return boolean;',
'',
'  procedure set_call_origin',
'  (',
'    p_origin in varchar2',
'  );',
'',
'  procedure unset_call_origin;',
'  ',
'end flow_globals;',
'/',
'',
'create or replace package flow_errors',
'  authid definer',
'as',
'',
'  procedure handle_instance_error',
'  ( pi_prcs_id        in flow_processes.prcs_id%type',
'  , pi_sbfl_id        in flow_subflows.sbfl_id%type default null',
'  , pi_message_key    in varchar2',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  );',
'',
'  procedure handle_general_error',
'  ( pi_message_key    in varchar2',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  );',
'  procedure set_error_status',
'  ( pi_prcs_id        in flow_processes.prcs_id%type',
'  , pi_sbfl_id        in flow_subflows.sbfl_id%type',
'  );',
'  ',
'  function make_error_message',
'  ( pi_message_key    in flow_messages.fmsg_message_key%type ',
'  , pi_lang           in flow_messages.fmsg_lang%type',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  ) return flow_messages.fmsg_message_content%type;',
'',
'   e_gateway_invalid_route exception;',
'',
'end flow_errors;',
'/',
'',
'create or replace package flow_diagram',
'/* ',
'-- Flows for APEX - flow_diagram.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-23.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created  10-Dec-2021  Dennis Amthor - MT AG',
'-- Modified 22-May-2022  Moritz Klein - MT AG',
'-- Modified 16-Mar-2023  Richard Allen - Oracle ',
'--',
'*/',
'  authid definer',
'as',
'',
'  diagram_exists exception;',
'  diagram_not_draft exception;',
'  pragma exception_init(diagram_exists, -20001);',
'  pragma exception_init(diagram_not_draft, -20002);',
'',
'  function create_diagram(',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type)',
'  return flow_diagrams.dgrm_id%type;',
'',
'  function upload_diagram',
'  (',
'    pi_dgrm_name       in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version    in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category   in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content    in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status     in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_log_comment     in flow_flow_event_log.lgfl_comment%type default null',
'  , pi_force_overwrite in boolean default false',
'  ) return flow_diagrams.dgrm_id%type;',
'',
'  procedure upload_diagram',
'  (',
'    pi_dgrm_name       in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version    in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category   in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content    in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status     in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_log_comment     in flow_flow_event_log.lgfl_comment%type default null',
'  , pi_force_overwrite in boolean default false',
'  );',
'',
'  procedure upload_and_parse',
'  (',
'    pi_dgrm_name       in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version    in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category   in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content    in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status     in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_log_comment     in flow_flow_event_log.lgfl_comment%type default null',
'  , pi_force_overwrite in boolean default false',
'  );',
'',
'  procedure update_diagram',
'  (',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_dgrm_content in flow_diagrams.dgrm_content%type',
'  );',
'',
'  function add_diagram_version(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type)',
'  return flow_diagrams.dgrm_id%type;',
'',
'',
'  function import_diagram(',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type,',
'    pi_dgrm_content in flow_diagrams.dgrm_content%type,',
'    pi_force_overwrite in varchar2 default flow_constants_pkg.gc_false) ',
'  return flow_diagrams.dgrm_id%type;',
'  ',
'  ',
'  function diagram_is_modifiable(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type)',
'  return boolean;',
'',
'',
'  procedure delete_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type,',
'    pi_cascade in varchar2);',
'',
'',
'  procedure edit_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type,',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type);',
'',
'',
'  procedure release_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type);',
'',
'',
'  -- Exposed as Public API through flow_admin_api',
'  procedure release_diagram(',
'    pi_dgrm_name    in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type default ''0'');',
'',
'',
'  procedure deprecate_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type);',
'',
'',
'  procedure archive_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type);   ',
'',
'  -- get_start_event',
'  --',
'  -- gets the start event for a diagram. returning the object as a flow_objects rowtype',
'  -- if p_event_starting_object is null (default), this will return the null start event or a timer start event - the main starting object in the diagram',
'  -- if p_event_starting_object is specified, it will return the row for that object.   You would use this if, for example, you were getting the message start ',
'  --    event from a model containing multiple start events.',
'  --',
'  function get_start_event(',
'    p_dgrm_id               in flow_diagrams.dgrm_id%type,',
'    p_process_id           in flow_processes.prcs_id%type,',
'    p_event_starting_object in flow_objects.objt_bpmn_id%type default null)',
'  return flow_objects%rowtype;',
'',
'-- get the current dgrm_id to be used for a diagram name.',
'-- returns the current ''released'' diagram or a ''draft'' of version ''0'' ',
'  function get_current_diagram',
'    ( pi_dgrm_name              in flow_diagrams.dgrm_name%type',
'    , pi_dgrm_calling_method    in flow_types_pkg.t_bpmn_attribute_vc2',
'    , pi_dgrm_version           in flow_diagrams.dgrm_version%type',
'    , pi_prcs_id                in flow_processes.prcs_id%type default null',
'    )',
'  return flow_diagrams.dgrm_id%type;',
'',
'  function get_diagram_name',
'    ( pi_dgrm_id            in flow_diagrams.dgrm_id%type',
'    )',
'  return flow_diagramS.dgrm_name%type;',
'',
'end flow_diagram;',
'/',
'',
'create or replace package flow_log_admin ',
'  /* ',
'  -- Flows for APEX - flow_log_admin.pks',
'  -- ',
'  -- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'',
'  --',
'  -- Created    18-Feb-2021  Richard Allen (Oracle)',
'  --',
'  -- Package flow_log_admin manaes the Flows for APEX log tables, including',
'  --    - creation of instance archive summary',
'  --    - archiving of instance logs',
'  --    - purging of instance log tables ',
'  */  ',
'  authid definer',
'  accessible by ( flow_admin_api, flow_instances , flow_diagram, flow_logging)',
'  as',
'',
'  function get_instance_json_summary',
'  ( p_process_id        in flow_processes.prcs_id%type',
'  ) return clob;',
'',
'  -- archive_completed_instances is normally called by apex_automations after midnight',
'  -- each day to prepare archive summaries for all processes that completed or terminated during',
'  -- the previous day.  This can be done without specifying any parameters.',
'  --',
'  -- p_process_id should only be specified when you need to archive a specific process.  ',
'  -- Use Case for this is if a process instance is deleted (flow_api_pkg.flow_delete), archiving is enabled',
'  -- and the instance has not yet been archived. Call archive_completed_instances specifying the process ID.',
'',
'  procedure archive_completed_instances',
'  ( p_completed_before         in date default trunc(sysdate)',
'  , p_process_id               in flow_processes.prcs_id%type default null  ',
'  );',
'',
'  procedure purge_instance_logs',
'  ( p_retention_period_days  in number default null',
'  );',
'',
'  procedure purge_message_logs',
'  ( p_retention_period_days    in number default null',
'  );',
'',
'  procedure purge_rest_logs',
'  ( p_retention_period_days    in number default null',
'  );',
'',
'  function archive_bpmn_diagram',
'  ( p_dgrm_id            flow_diagrams.dgrm_id%type',
'  , p_dgrm_content       flow_diagrams.dgrm_content%type',
'  ) return flow_flow_event_log.lgfl_dgrm_archive_location%type;',
'',
'end flow_log_admin;',
'/',
'',
'create or replace package flow_admin_api',
'   authid definer as',
' /* Flows for APEX - flow_admin_api.pks',
'--',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created    11-Feb-2023   Richard Allen, Oracle',
'*/',
'',
'/**',
'FLOWS FOR APEX ADMIN API',
'=========================',
'',
'The `flow_admin_api` package gives you access to the Flows for APEX engine admin procedures, and allows you to perform the following from the PL/SQL API:',
'-  Maintenance, Archiving and Purging of the Flows for APEX log files',
'-  Maintenance, Archiving, and Purging of the Flows for APEX performance statistics all_summaries',
'-  Maintenance of Flows for APEX instance configuration parameters',
'-  Release of Diagrams (useful when introducing a new model into a production system).',
'',
'*/',
'-- Log File Functions',
'',
'',
'  function instance_summary',
'  ( p_process_id            in flow_processes.prcs_id%type',
'  ) return clob;',
'',
'  procedure archive_completed_instances',
'  ( p_completed_before      in date default trunc(sysdate)',
'  );',
'',
'  procedure purge_instance_logs',
'  ( p_retention_period_days  in number default null',
'  );',
'',
'-- Performance Summary Functions',
'',
'  procedure run_daily_stats;',
'',
'  procedure purge_statistics;',
'',
'-- set configuration parameters',
'',
'  procedure set_config_value',
'  ( p_config_key        in flow_configuration.cfig_key%type,',
'    p_value             in flow_configuration.cfig_value%type,',
'    p_update_if_set     in boolean default true',
'  );',
'',
'  function get_config_value',
'  ( p_config_key        in flow_configuration.cfig_key%type',
'  , p_default_value     in flow_configuration.cfig_value%type',
'  ) return flow_configuration.cfig_value%type;',
'',
'-- release a diagram',
'',
'  procedure release_diagram',
'  ( pi_dgrm_name    in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type default ''0''',
'  );',
'',
'end flow_admin_api;',
'/',
'',
'create or replace package flow_statistics',
'--accessible by ( flow_admin_api)',
'as',
'/* ',
'-- Flows for APEX - flow_statistics.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created    11-Jan-2023  Richard Allen (Oracle)',
'--',
'*/',
'',
'  procedure run_daily_stats;',
'',
'  procedure purge_statistics;',
'',
'',
'end flow_statistics;',
'/',
'',
'create or replace package flow_iteration',
'as',
'/* ',
'-- Flows for APEX Enterprise Edition - flow_iteration.pks',
'-- ',
'-- (c) Copyright Flowquest Consulting Limited, 2024.',
'--',
'-- Created    30-Jan-2024  Richard Allen (Flowquest)',
'--',
'*/',
'',
'  procedure add_iteration_to_step_info',
'  ( p_step_info             in out NOCOPY flow_types_pkg.flow_step_info',
'  , p_sbfl_rec              in            flow_subflows%rowtype',
'  , p_iteration_is_complete in            boolean default false',
'  );',
'',
'  function get_iteration_id ',
'  ( p_prcs_id        in flow_processes.prcs_id%type',
'  , p_iobj_id        in flow_iterated_objects.iobj_id%type ',
'  , p_loop_counter   in flow_subflows.sbfl_loop_counter%type ',
'  ) return flow_iterations.iter_id%type;',
'',
'  procedure parallel_split',
'  ( p_subflow_id            in flow_subflows.sbfl_id%type ',
'  , p_sbfl_info             in flow_subflows%rowtype',
'  , p_step_info             in flow_types_pkg.flow_step_info',
'  );',
'',
'  function parallel_merge',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  , p_step_info             in flow_types_pkg.flow_step_info',
'  ) return varchar2; -- returns forward status ''wait'' or ''proceed''',
'',
'  function sequential_init',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  , p_step_info             in flow_types_pkg.flow_step_info',
'  ) return flow_types_pkg.t_iteration_status;',
'',
'  procedure sequential_start_step',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  );',
'',
'  function sequential_complete_step',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  ) return flow_types_pkg.t_iteration_status;',
'',
'  procedure sequential_close_iteration',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  , p_step_info             in flow_types_pkg.flow_step_info',
'  );',
'',
'  function loop_init',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  , p_step_info             in flow_types_pkg.flow_step_info',
'  ) return flow_types_pkg.t_iteration_status;',
'',
'  procedure loop_start_step',
'  ( p_sbfl_info            in flow_subflows%rowtype',
'  );',
'',
'  function loop_complete_step',
'  ( p_sbfl_info             in flow_subflows%rowtype',
'  ) return flow_types_pkg.t_iteration_status;',
'  ',
'  function get_iteration_array',
'  ( pi_prcs_id              in flow_processes.prcs_id%type',
'  , pi_sbfl_id              in flow_subflows.sbfl_id%type',
'  , pi_scope                in flow_subflows.sbfl_scope%type ',
'  , pi_prov_var_name        in flow_process_variables.prov_var_name%type ',
'  ) return sys.json_array_t;  ',
'',
'',
'  procedure set_iteration_status ',
'  ( pi_prcs_id          in flow_processes.prcs_id%type',
'  , pi_sbfl_id          in flow_subflows.sbfl_id%type default null',
'  , pi_step_key         in flow_subflows.sbfl_step_key%type default null',
'  , pi_scope            in flow_subflows.sbfl_scope%type',
'  , pi_prov_var_name    in flow_process_variables.prov_var_name%type',
'  , pi_loop_counter     in flow_subflows.sbfl_loop_counter%type',
'  , pi_new_status       in varchar2',
'  , pi_iobj_id          in flow_iterated_objects.iobj_id%type default null -- remove default null later',
'  );',
'',
'end flow_iteration;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_simple_form_template.pks',
'-- ',
'-- (c) Copyright Hyand, 2024',
'--',
'-- Created  20-Aug-2024  Dennis Amthor - Hyand',
'--',
'*/',
'create or replace package flow_simple_form_template',
'  authid definer',
'as',
'  template_exists exception;',
'  pragma exception_init(template_exists, -20003);',
'',
'  function create_template(',
'    pi_sfte_name      in flow_simple_form_templates.sfte_name%type',
'  , pi_sfte_static_id in flow_simple_form_templates.sfte_static_id%type',
'  , pi_sfte_content   in flow_simple_form_templates.sfte_content%type)',
'  return flow_simple_form_templates.sfte_id%type;',
'',
'  procedure edit_template(',
'    pi_sfte_id        in flow_simple_form_templates.sfte_id%type',
'  , pi_sfte_name      in flow_simple_form_templates.sfte_name%type',
'  , pi_sfte_static_id in flow_simple_form_templates.sfte_static_id%type',
'  , pi_sfte_content   in flow_simple_form_templates.sfte_content%type);',
'',
'  procedure delete_template(',
'    pi_sfte_id in flow_simple_form_templates.sfte_id%type);',
'',
'end flow_simple_form_template;',
'/',
'',
'create or replace package flow_rest_constants',
'  authid definer',
'as',
'  c_config_prefix    constant varchar2(50 char)  := ''rest_'';',
'  c_config_key_base  constant varchar2(50 char)  := ''base'';',
'  c_config_origin    constant varchar2(4  char)  := ''REST'';',
'',
'  c_cgi_env_base_path   constant varchar2(50 char)  := ''X-APEX-BASE'';',
'',
'  c_split_sep   constant varchar2(1 char) := '':'';',
'',
'  c_module    constant varchar2(200 char) := ''v1/'';      ',
'',
'  -- Path definitions (used for links)',
'  c_path_diagrams           constant varchar2(200 char) := ''diagrams/:id'';',
'  c_path_diagram_processes  constant varchar2(200 char) := ''diagrams/:id/processes'';',
'  c_path_processes          constant varchar2(200 char) := ''processes/:id'';',
'  c_path_process_vars       constant varchar2(200 char) := ''processes/:id/process_vars'';',
'  c_path_process_start      constant varchar2(200 char) := ''processes/:id/start'';',
'  c_path_process_reset      constant varchar2(200 char) := ''processes/:id/reset'';',
'  c_path_process_terminate  constant varchar2(200 char) := ''processes/:id/terminate'';',
'  c_path_steps              constant varchar2(200 char) := ''steps/:id'';',
'  c_path_steps_start        constant varchar2(200 char) := ''steps/:id/start'';',
'  c_path_steps_reserve      constant varchar2(200 char) := ''steps/:id/reserve'';',
'  c_path_steps_release      constant varchar2(200 char) := ''steps/:id/release'';',
'  c_path_steps_complete     constant varchar2(200 char) := ''steps/:id/complete'';',
'  c_path_steps_restart      constant varchar2(200 char) := ''steps/:id/restart'';',
'  c_path_steps_reschedule_timer  constant varchar2(200 char) := ''steps/:id/reschedule_timer'';',
'  c_path_message_subscriptions   constant varchar2(200 char) := ''processes/:id/message_subscriptions'';',
'',
'  -- Allowed HTTP Action Definition',
'  c_http_action_get     constant varchar2(3 char)   := ''GET'';',
'  c_http_action_post    constant varchar2(4 char)   := ''POST'';',
'  c_http_action_put     constant varchar2(3 char)   := ''PUT'';',
'  c_http_action_delete  constant varchar2(6 char)   := ''DELETE'';',
'',
'  -- Response Codes',
'  c_http_code_OK        constant number := 200;',
'  c_http_code_ERROR     constant number := 500;',
'',
'  c_object_type_diagram        constant varchar2(100 char) := ''diagram'';',
'  c_object_type_process        constant varchar2(100 char) := ''process'';',
'  c_object_type_process_vars   constant varchar2(100 char) := ''process_vars'';',
'  c_object_type_step           constant varchar2(100 char) := ''step'';',
'  c_object_type_step_usertask  constant varchar2(100 char) := ''usertask_url'';',
'',
'  c_process_status            constant varchar2(20 char) := ''status'';',
'  c_process_status_start      constant varchar2(20 char) := ''start'';',
'  c_process_status_reset      constant varchar2(20 char) := ''reset'';',
'  c_process_status_terminate  constant varchar2(20 char) := ''terminate'';',
'  c_process_status_delete     constant varchar2(20 char) := ''delete'';',
'',
'  ',
'  c_step_status_status            constant varchar2(20 char) := ''status'';',
'  c_step_status_start             constant varchar2(20 char) := ''start'';',
'  c_step_status_reserve           constant varchar2(20 char) := ''reserve'';',
'  c_step_status_release           constant varchar2(20 char) := ''release'';',
'  c_step_status_complete          constant varchar2(20 char) := ''complete'';',
'  c_step_status_restart           constant varchar2(20 char) := ''restart'';',
'  c_step_status_reschedule_timer  constant varchar2(20 char) := ''reschedule_timer'';',
'',
'  c_pvar_type_varchar   constant varchar2(10 char) := ''varchar'';',
'  c_pvar_type_number    constant varchar2(10 char) := ''number'';',
'  c_pvar_type_date      constant varchar2(10 char) := ''date'';',
'  c_pvar_type_clob      constant varchar2(10 char) := ''clob'';',
'',
'  c_json_errors_key   constant varchar2(20 char) := ''errors'';',
'  c_json_error_type   constant varchar2(20 char) := ''type'';',
'  c_json_error_value  constant varchar2(20 char) := ''value'';',
'  c_json_error_type_missing_attr    constant varchar2(20 char) := ''missing attribute'';',
'  c_json_error_type_item_not_found  constant varchar2(20 char) := ''item not found'';',
'  c_json_error_type_processing_error  constant varchar2(20 char) := ''processing error'';',
'',
'  -- JSON attributes key-names Process variables',
'  c_json_prov_sbfl_id    constant varchar2(20 char) := ''sbfl_id'';',
'  c_json_prov_name       constant varchar2(20 char) := ''name'';',
'  c_json_prov_type       constant varchar2(20 char) := ''type'';',
'  c_json_prov_scope      constant varchar2(20 char) := ''scope'';',
'  c_json_prov_value      constant varchar2(20 char) := ''value'';',
'',
'  -- mandatory JSON attributes '))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373794645443069)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'to be checked for objects',
'  c_check_attr_process_create     constant varchar2(20 char) := ''name'';',
'  c_check_attr_process_update     constant varchar2(20 char) := ''status'';',
'  c_check_attr_process_var_update constant varchar2(20 char) := ''name:type:value'';',
'  c_check_attr_process_var_delete constant varchar2(20 char) := ''name'';',
'  c_check_attr_step_update        constant varchar2(20 char) := ''status:step_key'';',
'  c_check_attr_message_update     constant varchar2(20 char) := ''key:value:payload'';',
'',
'  c_check_item_dgrm_version    constant varchar2(20 char) := ''version'';',
'  ',
'  -- Rest Roles and Privileges',
'  c_rest_grant_type    constant varchar2(50 char) := ''client_credentials'';',
'  c_rest_priv_access   constant varchar2(50 char) := ''flowsforapex.access'';',
'  c_rest_priv_read     constant varchar2(50 char) := ''flowsforapex.read'';',
'  c_rest_priv_write    constant varchar2(50 char) := ''flowsforapex.write'';',
'  c_rest_priv_admin    constant varchar2(50 char) := ''flowsforapex.admin'';',
'  c_rest_priv_messages constant varchar2(50 char) := ''flowsforapex.messages'';',
'  c_rest_role_read     constant varchar2(50 char) := ''Flows for Apex - Read'';',
'  c_rest_role_write    constant varchar2(50 char) := ''Flows for Apex - Write'';',
'  c_rest_role_admin    constant varchar2(50 char) := ''Flows for Apex - Admin'';',
'  c_rest_role_messages constant varchar2(50 char) := ''Flows for Apex - Messages'';',
'  c_rest_role_sep      constant varchar2(50 char) := '':'';',
'  ',
'  c_rest_schema_status_enabled    constant varchar2(50 char) := ''ENABLED'';',
'  c_rest_schema_status_disabled   constant varchar2(50 char) := ''DISABLED'';',
'  c_rest_module_status_published  constant varchar2(50 char) := ''PUBLISHED'';',
'  c_rest_current_version          constant varchar2(50 char) := ''v1'';',
'',
'  e_payload_not_acceptable exception;',
'  e_multiple_object_error  exception;',
'  e_attribute_not_found    exception;',
'  e_item_not_found         exception;',
'  e_processing_error       exception;',
'  e_process_unknown_status exception;',
'  e_step_unknown_operation exception;',
'  e_privilege_not_granted  exception;',
'  e_payload_processing     exception;',
'  e_not_implemented        exception;',
'',
'  PRAGMA EXCEPTION_INIT (e_payload_not_acceptable , -20101);',
'  PRAGMA EXCEPTION_INIT (e_multiple_object_error  , -20102);',
'  PRAGMA EXCEPTION_INIT (e_attribute_not_found    , -20103);',
'  PRAGMA EXCEPTION_INIT (e_item_not_found         , -20104);',
'  PRAGMA EXCEPTION_INIT (e_processing_error       , -20105);',
'  PRAGMA EXCEPTION_INIT (e_process_unknown_status , -20106);',
'  PRAGMA EXCEPTION_INIT (e_step_unknown_operation , -20107);',
'  PRAGMA EXCEPTION_INIT (e_privilege_not_granted  , -20108);',
'  PRAGMA EXCEPTION_INIT (e_payload_processing     , -20109);',
'  PRAGMA EXCEPTION_INIT (e_not_implemented        , -20200);',
'',
'end flow_rest_constants;',
'/',
'',
'create or replace package flow_rest',
'  authid definer',
'as',
'/* ',
'-- Flows for APEX - flow_rest.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
unistr('-- Created  19-JAN-2023  J\00F6rg Doppelreiter (solicon IT GmbH)'),
'--',
'*/',
'  function get_apex_host',
'    return varchar2;',
'',
'  procedure set_apex_host;',
'',
'  function get_config_value( pi_key  flow_configuration.cfig_key%type )',
'    return flow_configuration.cfig_value%type;',
'    ',
'  procedure initialize( pi_client_id varchar2',
'                      , pi_method    varchar2',
'                      , pi_endpoint  varchar2 );',
'',
'  procedure initialize( pi_client_id        varchar2',
'                      , pi_check_privilege  varchar2 );',
'',
'  procedure cleanup; ',
'',
'  function blob_to_json( pi_body  blob)',
'    return json_element_t;    ',
'',
'  function get_json_array_t( pi_json_object_t  json_object_t)',
'    return json_array_t;',
'',
'  procedure verify_and_prepare_payload( pi_payload              json_element_t ',
'                                      , pi_array_allowed        boolean ',
'                                      , po_payload_object   out json_object_t',
'                                      , po_payload_array    out json_array_t );     ',
'',
'  procedure verify_and_prepare_payload( pi_payload              json_element_t ',
'                                      , pi_array_allowed        boolean ',
'                                      , po_payload_object   out json_object_t);',
'',
'  procedure verify_and_prepare_payload( pi_payload              json_element_t ',
'                                      , pi_array_allowed        boolean ',
'                                      , po_payload_array    out json_array_t);                                      ',
'',
'  procedure verify_diagram_exists( pi_dgrm_id       flow_diagrams.dgrm_id%type',
'                                 , pi_dgrm_version  flow_diagrams.dgrm_version%type default null );',
'',
'  procedure verify_process_exists( pi_prcs_id  flow_processes.prcs_id%type );',
'',
'  procedure verify_subflow_exists( pi_sbfl_id  flow_subflows.sbfl_id%type );',
'',
'  function get_process_id( p_sbfl_id  flow_subflows.sbfl_id%type )',
'    return flow_processes.prcs_id%type;',
'  ',
'  function get_process_id( pi_message_name   flow_message_subscriptions.msub_message_name%type',
'                         , pi_msub_key_name  flow_message_subscriptions.msub_key_name%type',
'                         , pi_msub_key_value flow_message_subscriptions.msub_key_value%type )',
'    return flow_processes.prcs_id%type;',
'',
'  function get_step_key( p_sbfl_id  flow_subflows.sbfl_id%type )',
'    return flow_subflows.sbfl_step_key%type;',
'',
'  procedure process_status_update( pi_prcs_id   flow_processes.prcs_id%type ',
'                                 , pi_payload   in out nocopy json_object_t );',
'',
'  procedure process_vars_update( pi_prcs_id    flow_processes.prcs_id%type ',
'                               , pio_prov_arr  in out nocopy json_array_t ',
'                               , pi_add_error_msg   boolean default true );',
'',
'  procedure process_vars_delete( pi_prcs_id    flow_processes.prcs_id%type ',
'                               , pio_prov_arr  in out nocopy json_array_t ',
'                               , pi_add_error_msg   boolean default true );                               ',
'',
'  procedure step_update( pi_sbfl_id  flow_subflows.sbfl_id%type',
'                       , pi_payload   in out nocopy json_object_t );',
'',
'  procedure messages_update( pi_message_name   flow_message_subscriptions.msub_message_name%type ',
'                           , pi_msg_arr        in out nocopy json_array_t );',
'',
'end flow_rest;',
'/',
'',
'create or replace package flow_rest_auth',
'  authid definer',
'as',
'  type flow_rest_role_ot is record',
'  (',
'    role_id   number,',
'    role_name varchar2(255)',
'  );',
'  type flow_rest_roles_nt is table of flow_rest_role_ot;',
'',
'  function get_rest_roles',
'    return flow_rest_roles_nt',
'    pipelined;',
'',
'  function get_client_id( pi_name  user_ords_clients.name%type )',
'    return user_ords_clients.id%type;',
'',
'  function get_client_roles( pi_id  user_ords_clients.id%type )',
'    return apex_application_global.vc_arr2;',
'',
'  -- check if client has flowsforapex.read privilege (used for GET operations)',
'  -- return 1 if true or 0 if false',
'  function has_privilege_read( pi_client_id       varchar2)',
'    return number;',
'',
'  -- check if client has flowsforapex.admin privilege (used for GET operations)',
'  -- return 1 if true or 0 if false',
'  function has_privilege_admin( pi_client_id      varchar2)',
'    return number;',
'',
'  procedure check_privilege( pi_client_id       varchar2 -- client_id is returned by implicit parameter :current_user',
'                           , pi_privilege_name  varchar2 );',
'',
'  procedure create_client( pi_name           varchar2',
'                         , pi_owner          varchar2',
'                         , pi_description    varchar2',
'                         , pi_support_email  varchar2',
'                         , pi_support_uri    varchar2 );',
'',
'  procedure update_client_roles( pi_id     user_ords_clients.id%type',
'                               , pi_roles  apex_application_global.vc_arr2); -- array of user_ords_roles.id',
'',
'end flow_rest_auth;',
'/',
'',
'create or replace package flow_rest_logging',
'  authid definer',
'as',
'',
'  c_log_info_enter     constant varchar2(10 char) := ''ENTER'';',
'  c_log_info_finished  constant varchar2(10 char) := ''FINISHED'';',
'  c_log_info_error     constant varchar2(10 char) := ''ERROR'';',
'',
'  c_log_rest_incoming              constant varchar2(50 char) := ''logging_rest_incoming_calls'';',
'  c_log_rest_incoming_retain_days  constant varchar2(50 char) := ''logging_rest_incoming_calls_retain_days'';',
'',
'  c_log_rest_incoming_default              constant varchar2(50 char) := ''Y'';',
'  c_log_rest_incoming_retain_days_default  constant varchar2(50 char) := ''60'';',
'',
'  procedure initialize;',
'  procedure cleanup;',
'',
'  procedure enter( pi_payload            json_element_t',
'                 );',
'',
'  procedure finished( pi_payload            json_element_t',
'                    );',
'',
'  procedure error( pi_payload            json_element_t',
'                 , pi_error_code         flow_rest_event_log.lgrt_error_code%type',
'                 , pi_error_msg          flow_rest_event_log.lgrt_error_msg%type',
'                 , pi_error_stacktrace   flow_rest_event_log.lgrt_error_stacktrace%type',
'                 );',
'',
'  procedure set_logging_config( pi_log_rest_incoming         varchar2',
'                              , pi_log_rest_incoming_retain  varchar2 );',
'',
'end flow_rest_logging;',
'/',
'',
'create or replace package flow_rest_response',
'  authid definer',
'as',
'/* ',
'-- Flows for APEX - flow_rest_response.pks',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
unistr('-- Created  14-MAY-2023  J\00F6rg Doppelreiter (solicon IT GmbH)'),
'--',
'*/',
'',
'  procedure send_error( pi_sqlerrm            varchar2 ',
'                      , pi_stacktrace         varchar2 default null',
'                      , pi_payload            json_element_t default null',
'                      , pi_payload_attr_name  varchar2 default null',
'                      , po_status_code        out number );',
'',
'  procedure send_success( pi_success_message   varchar2',
'                        , pi_payload           json_element_t default null',
'                        , pi_payload_attr_name varchar2 default null',
'                        , po_status_code       out number );                       ',
'',
'',
'end flow_rest_response;',
'/',
'',
'create or replace package flow_rest_errors',
'  authid definer',
'as',
'',
'  procedure handle_error( pi_sqlcode            number ',
'                        , pi_message            varchar2 ',
'                        , pi_stacktrace         varchar2 ',
'                        , pi_payload            json_element_t default null',
'                        , pi_payload_attr_name  varchar2 default null',
'                        , po_status_code        out number );',
'',
'end flow_rest_errors;',
'/',
'',
'create or replace package flow_rest_api_v1',
'  authid definer',
'as',
'',
'  procedure dispatch( pi_method           varchar2 ',
'                    , pi_endpoint         varchar2',
'                    , pi_dgrm_id          flow_diagrams.dgrm_id%type default null',
'                    , pi_prcs_id          flow_processes.prcs_id%type default null',
'                    , pi_sbfl_id          flow_subflows.sbfl_id%type default null',
'                    , pi_message_name     flow_message_subscriptions.msub_message_name%type default null',
'                    , pi_payload          blob ',
'                    , pi_current_user     varchar2',
'                    , po_status_code      out number ',
'                    , po_forward_location out varchar2',
'                    );',
'',
'',
'',
'  function get_links_string_http_GET ( pi_object_type  varchar2',
'                                     , pi_object_id    varchar2)',
'    return clob;    ',
'',
'  function get_path( pi_path_endpoint  varchar2, pi_object_id  varchar2)',
'    return varchar2;',
'',
'end flow_rest_api_v1;',
'/',
'',
'create or replace package flow_rest_install',
'  authid definer',
'as',
'',
'  function is_rest_enabled( pi_schema varchar2 default apex_application.g_flow_owner)',
'    return boolean;',
'  ',
'  function is_module_published( pi_schema varchar2 default apex_application.g_flow_owner',
'                              , pi_module_prefix varchar2 default flow_rest_constants.c_rest_current_version )',
'    return boolean;',
'',
'  procedure set_base_url( pi_base_url  varchar2 );',
'',
'end flow_rest_install;',
'/',
'',
'create or replace package flow_engine_app_api',
'  authid definer',
'as',
'',
'  function apex_error_handling (',
'    p_error in apex_error.t_error ',
'  )',
'  return apex_error.t_error_result;',
'',
'  procedure handle_ajax;',
'',
'  /* general */',
'  function get_objt_list(',
'    p_prcs_id in flow_processes.prcs_id%type',
'  ) return varchar2;',
'  ',
'  function get_objt_list(',
'    p_dgrm_id in flow_diagrams.dgrm_id%type',
'  ) return varchar2;',
'',
'    function get_objt_list(',
'    p_prdg_id in flow_instance_diagrams.prdg_id%type',
'  ) return varchar2;',
'  ',
'  function get_objt_name(',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id      in flow_diagrams.dgrm_id%type',
'  ) return flow_objects.objt_name%type;',
'',
'  function get_objt_name(',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_prcs_id      in flow_processes.prcs_id%type',
'  ) return flow_objects.objt_name%type;',
'',
'  function get_objt_name(',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_prdg_id      in flow_instance_diagrams.prdg_id%type',
'  ) return flow_objects.objt_name%type;',
'',
'  procedure set_viewport(',
'    p_display_setting in varchar2);',
'',
'  procedure add_viewport_script(',
'    p_item in varchar2',
'  );',
'',
'  procedure get_url_p13(',
'    pi_dgrm_id flow_diagrams.dgrm_id%type',
'  , pi_objt_id varchar2',
'  , pi_title varchar2',
'  );',
'',
'  procedure get_url_p13(',
'    pi_prcs_id flow_processes.prcs_id%type',
'  , pi_prdg_id flow_instance_diagrams.prdg_id%type',
'  , pi_objt_id varchar2',
'  , pi_title varchar2',
'  );',
'',
'  /* page 2 */',
'',
'  function validate_flow_exists_bulk(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_version  in flow_diagrams.dgrm_version%type ',
'  ) return varchar2;',
'',
'  function validate_flow_exists(',
'    pi_dgrm_id     in flow_diagrams.dgrm_id%type',
'  , pi_new_version in flow_diagrams.dgrm_version%type ',
'  ) return varchar2;',
'    ',
'  function validate_flow_copy_bulk(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_name     in flow_diagrams.dgrm_name%type ',
'  ) return varchar2;',
'    ',
'  function validate_flow_copy(',
'    pi_new_name in flow_diagrams.dgrm_name%type ',
'  ) return varchar2;',
'',
'  procedure copy_selection_to_collection;',
'',
'  procedure add_new_version(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_version  in flow_diagrams.dgrm_version%type ',
'  );',
'  ',
'  procedure copy_model(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_name     in flow_diagrams.dgrm_name%type ',
'  );',
'',
'  /* page 3 */',
'  function check_version_mismatch(',
'    p_app_id number default apex_application.g_flow_id',
'  ) return varchar2;',
'',
'  function check_apex_upgrade(',
'    p_app_id number default apex_application.g_flow_id',
'  ) return varchar2;',
'',
'  /* page 4 */',
'',
'  function get_region_title(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type',
'  )',
'  return varchar2;',
'',
'  /* page 5 */',
'',
'  function get_file_name(',
'      p_dgrm_id                  in number,',
'      p_include_version          in varchar2,',
'      p_include_status           in varchar2,',
'      p_include_category         in varchar2,',
'      p_include_last_change_date in varchar2,',
'      p_download_as              in varchar2',
'  ) return varchar2;',
'',
'  procedure download_file(',
'      p_dgrm_id     in number,',
'      p_file_name   in varchar2,',
'      p_download_as in varchar2,',
'      p_multi_file  in boolean default false',
'  );',
'',
'  /* page 6 */',
'',
'  function is_file_uploaded(',
'      pi_file_name in varchar2',
'  )',
'  return boolean;',
'    ',
'  function is_valid_xml(',
'      pi_import_from  in varchar2,',
'      pi_dgrm_content in flow_diagrams.dgrm_content%type,',
'      pi_file_name    in varchar2',
'  )',
'  return boolean;',
'  ',
'  function is_valid_multi_file_archive(',
'      pi_file_name in varchar2',
'  )',
'  return varchar2;',
'',
'  function upload_and_parse(',
'      pi_import_from     in varchar2,',
'      pi_dgrm_name       in flow_diagrams.dgrm_name%type,',
'      pi_dgrm_category   in flow_diagrams.dgrm_category%type,',
'      pi_dgrm_version    in flow_diagrams.dgrm_version%type,',
'      pi_dgrm_content    in flow_diagrams.dgrm_content%type,',
'      pi_file_name       in varchar2,',
'      pi_force_overwrite in varchar2',
'  )',
'  return flow_diagrams.dgrm_id%type;',
'  ',
'  procedure multiple_flow_import(',
'      pi_file_name       in varchar2,',
'      pi_force_overwrite in varchar2',
'  );',
'',
'  /* page 7 */',
'  ',
'  function validate_new_version(',
'    pi_dgrm_name    in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version in flow_diagrams.dgrm_version%type',
'  )',
'  return varchar2;',
'    ',
'  procedure process_page_p7',
'  (',
'    pio_dgrm_id      in out nocopy flow_diagrams.dgrm_id%type',
'  , pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_new_version   in flow_diagrams.dgrm_version%type',
'  , pi_cascade       in varchar2',
'  , pi_request       in varchar2',
'  );',
'  ',
'  function get_page_title(',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_dgrm_name    in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version in flow_diagrams.dgrm_version%type',
'  )',
'  return varchar2;',
'',
'  function get_current_diagram',
'    ( pi_dgrm_name              in flow_diagrams.dgrm_name%type',
'    , pi_dgrm_calling_method    in flow_types_pkg.t_bpmn_attribute_vc2',
'    , pi_dgrm_version           in flow_diagrams.dgrm_version%type',
'    )',
'  return flow_diagrams.dgrm_id%type;',
'',
'  /* page 8 */',
'',
'  function check_is_date(',
'    pi_value       in varchar2,',
'    pi_format_mask in varchar2)',
'    return varchar2;',
'',
'  function check_is_tstz(',
'    pi_value       in varchar2,',
'    pi_format_mask in varchar2)',
'    return varchar2;',
'',
'  function check_is_number(',
'    pi_value in varchar2)',
'    return varchar2;',
'    ',
'  procedure pass_variable;',
'  ',
'  function get_connection_select_option(',
'    pi_gateway in flow_objects.objt_bpmn_id%type',
'  , pi_prdg_id in flow_instance_diagrams.prdg_id%type',
'  )',
'  return varchar2;',
'',
'  function get_scope(',
'      pi_gateway in flow_objects.objt_bpmn_id%type',
'    , pi_prdg_id in flow_instance_diagrams.prdg_id%type',
'  ) return number;',
'',
'  procedure download_instance_summary(',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  );',
'',
'  /* page 11 */',
'',
'  function create_instance(',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_prcs_name    in flow_processes.prcs_name%type',
'  , pi_business_ref in flow_process_variables.prov_var_vc2%type',
'  )',
'  return flow_processes.prcs_id%type;',
'',
'  /* page 12 */',
'  ',
'  function get_prcs_name(',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  )',
'  return flow_processes.prcs_name%type;',
'',
'  /* page 13 */',
'',
'  function has_error(',
'    pi_prcs_id in flow_processes.prcs_id%type,',
'    pi_objt_id in flow_subflows.sbfl_current%type)',
'  return boolean;',
'',
'  /* page 51 */',
'',
'  procedure process_page_p51',
'  (',
'    pio_sfte_id       in out nocopy flow_simple_form_templates.sfte_id%type',
'  , pi_sfte_name      in flow_simple_form_templates.sfte_name%type',
'  , pi_sfte_static_id in flow_simple_form_templates.sfte_static_id%type',
'  , pi_sfte_content   in flow_simple_form_templates.sfte_content%type',
'  , pi_request        in varchar2',
'  );',
'',
'  /* configuration */',
'  procedure set_logging_settings(',
'    pi_logging_language          in flow_configuration.cfig_value%type',
'  , pi_logging_level             in flow_configuration.cfig_value%type',
'  , pi_logging_hide_userid       in flow_configuration.cfig_value%type',
'  , pi_logging_retain_logs       in flow_configuration.cfig_value%type',
'  , pi_logging_message_flow_recd in flow_configuration.cfig_value%type',
'  , pi_logging_retain_msg_flow   in flow_configuration.cfig_value%type',
'  );',
'',
'  procedure set_archiving_settings(',
'    pi_archiving_enabled  in flow_configuration.cfig_value%type',
'  );',
'',
'  procedure set_statictis_settings(',
'    pi_stats_retain_daily in flow_configuration.cfig_value%type',
'  , pi_stats_retain_month in flow_configuration.cfig_value%type',
'  , pi_stats_retain_qtr   in flow_configuration.cfig_value%type',
'  );',
'',
'  procedure set_engine_app_settings(',
'    pi_engine_app_mode in flow_configuration.cfig_value%type',
'  );',
'',
'  procedure set_engine_settings(',
'    pi_duplicate_step_prevention in flow_configuration.cfig_value%type',
'  , pi_default_workspace         in flow_configuration.cfig_value%type',
'  , pi_default_email_sender      in flow_configuration.cfig_value%type',
'  , pi_default_application       in flow_configuration.cfig_value%type',
'  , pi_default_pageid            in flow_configuration.cfig_value%type',
'  , pi_default_username          in flow_configuration.cfig_value%type',
'  );',
'',
'  procedure set_timers_settings(',
'    pi_timer_max_cycles       in flow_configuration.cfig_value%type',
'  , pi_timer_status           in sys.all_scheduler_jobs.enabled%type',
'  , pi_timer_repeat_interval  in sys.all_scheduler_jobs.repeat_interval%type',
'  );',
'',
'end flow_engine_app_api;',
'/',
'',
'create or replace package flow_theme_api',
'  authid definer',
'as',
'',
'  procedure switch_theme_mode(',
'    pi_request in varchar2',
'  );  ',
'',
'  procedure reset_theme_mode(',
'    pi_request in varchar2',
'  );  ',
'  ',
'  procedure set_init_theme_mode;',
'    ',
'  procedure css_tricks(',
'    pi_theme_plugin_class in varchar2',
'  );',
'  ',
'end flow_theme_api;',
'/',
'create or replace package flow_plugin_manage_instance authid current_user as',
'   function execution (',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   ) return apex_plugin.t_process_exec_result;',
'',
'end flow_plugin_manage_instance;',
'/',
'',
'create or replace package flow_plugin_manage_instance_step authid current_user as',
'   function execution (',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   ) return apex_plugin.t_process_exec_result;',
'',
'end flow_plugin_manage_instance_step;',
'/',
'',
'create or replace package flow_plugin_manage_instance_variables authid current_user as',
'',
'   function execution (',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   ) return apex_plugin.t_process_exec_result;',
'',
'end flow_plugin_manage_instance_variables;',
'/',
'',
'create or replace package flow_modeler',
'as',
'',
'  function render',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  , p_is_printer_friendly in  boolean',
'  )',
'    return apex_plugin.t_region_render_result;',
'',
'  function ajax',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  )',
'    return apex_plugin.t_region_ajax_result;',
'',
'end flow_modeler;',
'/',
'',
'create or replace package flow_viewer',
'as',
'',
'  function render',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  , p_is_printer_friendly in  boolean',
'  )',
'    return apex_plugin.t_region_render_result;',
'',
'  function ajax',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  )',
'    return apex_plugin.t_region_ajax_result;',
'',
'end flow_viewer;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_views
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10373921319456959)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Views'
,p_sequence=>30
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'create or replace view flow_instances_vw',
'as',
'  select prcs.prcs_id',
'       , prcs.prcs_name',
'       , dgrm.dgrm_id',
'       , dgrm.dgrm_name',
'       , dgrm.dgrm_version',
'       , dgrm.dgrm_status',
'       , prcs.prcs_priority',
'       , dgrm.dgrm_category',
'       , prcs.prcs_status',
'       , prcs.prcs_init_ts',
'       , prcs.prcs_init_by',
'       , prcs.prcs_start_ts',
'       , prcs.prcs_due_on',
'       , prcs.prcs_complete_ts',
'       , prcs.prcs_last_update',
'       , prcs.prcs_last_update_by',
'       , prov.prov_var_vc2 as prcs_business_ref',
'    from flow_processes prcs',
'    join flow_diagrams dgrm',
'      on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'    left join flow_process_variables prov',
'      on prov.prov_prcs_id = prcs.prcs_id',
'     and prov.prov_var_name = ''BUSINESS_REF''',
'     and prov.prov_var_type = ''VARCHAR2'' ',
'     and prov.prov_scope = 0',
'with read only;',
'',
'create or replace view flow_subflows_vw',
'as',
'   select sbfl.sbfl_id',
'        , sbfl.sbfl_sbfl_id',
'        , sbfl.sbfl_prcs_id',
'        , coalesce( prcs.prcs_name, to_char(sbfl.sbfl_prcs_id)) as sbfl_process_name  -- flow instance ref',
'        , prcs.prcs_dgrm_id as sbfl_dgrm_id',
'        , sbfl.sbfl_dgrm_id as sbfl_sbfl_dgrm_id -- sbfl level dgrm id',
'        , dgrm.dgrm_name as sbfl_dgrm_name  -- flow name',
'        , dgrm.dgrm_version as sbfl_dgrm_version',
'        , dgrm.dgrm_status as sbfl_dgrm_status',
'        , dgrm.dgrm_category as sbfl_dgrm_category',
'        , sbfl.sbfl_starting_object',
'        , coalesce( objt_start.objt_name, sbfl.sbfl_starting_object ) as sbfl_starting_object_name',
'        , sbfl.sbfl_route',
'        , coalesce( conn.conn_name, sbfl.sbfl_route ) as sbfl_route_name',
'        , sbfl.sbfl_last_completed',
'        , coalesce( objt_last.objt_name, sbfl.sbfl_last_completed ) as sbfl_last_completed_name',
'        , sbfl.sbfl_current',
'        , coalesce( objt_curr.objt_name ||case ',
'                                          when sbfl_loop_counter is null then ''''',
'                                          else ''[''||sbfl_loop_counter||'']''',
'                                          end',
'                  , sbfl.sbfl_current ',
'                  ) as sbfl_current_name',
'        , iter.iter_display_name as sbfl_iteration_path',
'        , sbfl.sbfl_iter_id    -- remove from prod',
'        , sbfl.sbfl_iobj_id    -- remove from prod',
'        , sbfl.sbfl_iteration_type -- remove from prod',
'        , sbfl.sbfl_step_key',
'        , objt_curr.objt_tag_name as sbfl_current_tag_name',
'        , sbfl.sbfl_became_current',
'        , sbfl.sbfl_due_on',
'        , sbfl.sbfl_last_update',
'        , sbfl.sbfl_last_update_by',
'        , sbfl.sbfl_priority',
'        , sbfl.sbfl_status',
'        , sbfl.sbfl_lane as sbfl_current_lane',
'        , sbfl.sbfl_lane_name as sbfl_current_lane_name',
'        , sbfl.sbfl_lane_isrole',
'        , sbfl.sbfl_lane_role',
'        , sbfl.sbfl_process_level',
'        , sbfl.sbfl_diagram_level',
'        , sbfl.sbfl_loop_counter',
'        , sbfl.sbfl_loop_total_instances',
'        , sbfl.sbfl_scope',
'        , sbfl.sbfl_calling_sbfl',
'        , sbfl.sbfl_reservation',
'        , sbfl.sbfl_potential_users',
'        , sbfl.sbfl_potential_groups',
'        , sbfl.sbfl_excluded_users',
'        , objt_curr.objt_id as sbfl_current_objt_id',
'        , prcs.prcs_init_ts as sbfl_prcs_init_ts',
'        , case sbfl.sbfl_status ',
'          when ''waiting for timer'' then timr.timr_start_on',
'          else null',
'          end as timr_start_on',
'     from flow_subflows sbfl',
'     join flow_processes prcs',
'       on prcs.prcs_id = sbfl.sbfl_prcs_id',
'left join flow_objects objt_start',
'       on objt_start.objt_bpmn_id = sbfl.sbfl_starting_object',
'      and objt_start.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'left join flow_objects objt_curr',
'       on objt_curr.objt_bpmn_id = sbfl.sbfl_current',
'      and objt_curr.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'left join flow_objects objt_last',
'       on objt_last.objt_bpmn_id = sbfl.sbfl_last_completed',
'      and objt_last.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'left join flow_connections conn',
'       on conn.conn_bpmn_id = sbfl.sbfl_route',
'      and conn.conn_dgrm_id = sbfl.sbfl_dgrm_id',
'     join flow_diagrams dgrm ',
'       on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'left join flow_timers timr',
'       on timr.timr_prcs_id = sbfl.sbfl_prcs_id',
'      and timr.timr_sbfl_id = sbfl.sbfl_id',
'      and timr.timr_status in (''C'', ''A'', ''B'')',
'left join flow_iterations iter',
'       on iter.iter_id = sbfl.sbfl_iter_id',
'with read only',
';',
'',
'create or replace view flow_diagrams_parsed_lov',
'as',
'  select dgrm.dgrm_id',
'       , dgrm.dgrm_name',
'       , dgrm.dgrm_version',
'       , dgrm.dgrm_status',
'       , dgrm.dgrm_category',
'    from flow_diagrams dgrm',
'   where exists ',
'         ( select null',
'             from flow_objects objt',
'            where objt.objt_dgrm_id = dgrm.dgrm_id',
'         )',
'    and dgrm_status in (''draft'',''released'')',
'  with read only',
'  ;',
'',
'create or replace view flow_diagram_categories_lov',
'as',
'  select distinct',
'         dgrm_category d',
'       , dgrm_category r',
'    from flow_diagrams',
'with read only;',
'',
'create or replace view flow_apex_task_inbox_vw ',
'     ( app_id',
'     , task_id',
'     , task_def_id',
'     , task_def_name',
'     , task_def_static_id',
'     , subject',
'     , details_app_id',
'     , details_app_name',
'     , details_link_target',
'     , due_on',
'     , due_in_hours',
'     , due_in ',
'     , due_code',
'     , priority',
'     , priority_level',
'     , initiator',
'     , initiator_lower',
'     , actual_owner',
'     , actual_owner_lower',
'     , state_code',
'     , state',
'     , is_completed',
'     , outcome_code',
'     , outcome',
'     , badge_css_classes',
'     , badge_text',
'     , created_ago_hours',
'     , created_ago',
'     , created_by',
'     , created_on',
'     , last_updated_by',
'     , last_updated_on',
'     , process_id',
'     , subflow_id',
'     , step_key',
'     , lane_name',
'     , lane_role',
'     , business_ref',
'     )',
'as',
'select null as app_id',
'     , null as task_id',
'     , null as task_def_id',
'     , coalesce( objt_curr.objt_name, sbfl.sbfl_current ) as task_def_name',
'     , null as task_def_static_id',
'     , prcs.prcs_name||'' (''||bref.prov_var_vc2||'') - ''||coalesce( objt_curr.objt_name, sbfl.sbfl_current) as subject',
'     , null as details_app_id',
'     , dgrm.dgrm_name as details_app_name',
'     , case objt_curr.objt_tag_name',
'            when ''bpmn:userTask'' then',
'              flow_usertask_pkg.get_url',
'              (',
'                pi_prcs_id  => sbfl_prcs_id',
'              , pi_sbfl_id  => sbfl_id',
'              , pi_objt_id  => objt_curr.objt_id   ',
'              , pi_step_key => sbfl_step_key',
'              , pi_scope    => sbfl_scope',
'              )',
'            else null ',
'            end as details_link_target',
'     , sbfl.sbfl_due_on   ',
'     , flow_api_pkg.intervalDStoHours(sbfl.sbfl_due_on - systimestamp) as due_in_hours',
'     , apex_util.get_since (p_value => sbfl.sbfl_due_on ) as due_in',
'     , case ',
'            when flow_api_pkg.intervalDStoHours(sbfl.sbfl_due_on - systimestamp) <= 0 then ',
'              ''OVERDUE''',
'            when flow_api_pkg.intervalDStoHours(sbfl.sbfl_due_on - systimestamp) < 1 then',
'              ''NEXT_HOUR''',
'            when flow_api_pkg.intervalDStoHours(sbfl.sbfl_due_on - systimestamp) < 24 then',
'              ''NEXT_24_HOURS''',
'            when flow_api_pkg.intervalDStoHours(sbfl.sbfl_due_on - systimestamp) < 168 then',
'              ''NEXT_WEEK''',
'            else null',
'            end as due_code  ',
'     , sbfl.sbfl_priority as priority',
'     , case sbfl.sbfl_priority',
'          when 1 then ''urgent''',
'          when 2 then ''high''',
'          when 3 then ''medium''',
'          when 4 then ''low''',
'          when 5 then ''lowest''',
'        end as priority_level',
'     , prcs.prcs_init_by as initiator',
'     , lower(prcs.prcs_init_by) as initiator_lower',
'     , sbfl.sbfl_reservation as actual_owner',
'     , lower(sbfl.sbfl_reservation) as actual_owner_lower',
'     , null as state_code',
'     , sbfl.sbfl_status as state',
'     , null as is_completed',
'     , null as outcome_code',
'     , null as outcome',
'     , null as badge_css_classes',
'     , nvl2 (sbfl.sbfl_reservation, null, ''unassigned'') as badge_text',
'     , floor((sysdate - cast(sbfl_became_current as date) )*24) as created_ago_hours',
'     , apex_util.get_since(p_value => sbfl_became_current)  as created_ago',
'     , prcs.prcs_init_by as created_by     ',
'     , sbfl.sbfl_became_current as created_on',
'     , sbfl.sbfl_last_update_by as last_updated_by     ',
'     , sbfl.sbfl_last_update as last_updated_on',
'     , prcs.prcs_id',
'     , sbfl.sbfl_id',
'     , sbfl.sbfl_step_key',
'     , sbfl.sbfl_lane_name',
'     , sbfl.sbfl_lane_role',
'     , bref.prov_var_vc2',
'     from flow_subflows sbfl',
'     join flow_processes prcs',
'       on prcs.prcs_id = sbfl.sbfl_prcs_id',
'     join flow_diagrams dgrm ',
'       on dgrm.dgrm_id = prcs.prcs_dgrm_id  ',
'left join flow_objects objt_curr',
'       on objt_curr.objt_bpmn_id = sbfl.sbfl_current',
'      and objt_curr.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'left join flow_process_variables bref',
'       on bref.prov_prcs_id = sbfl.sbfl_prcs_id',
'      and bref.prov_var_name = ''BUSINESS_REF''',
'      and bref.prov_scope = 0',
'/*left join flow_timers timr',
'       on timr.timr_prcs_id = sbfl.sbfl_prcs_id',
'      and timr.timr_sbfl_id = sbfl.sbfl_id',
'      and timr.timr_status != ''E'' */',
'where objt_curr.objt_tag_name = ''bpmn:userTask'' ',
'  and sbfl.sbfl_status = ''running''',
'with read only;',
'',
'create or replace view flow_apex_task_inbox_my_tasks_vw ',
'     ( task_type',
'     , app_id',
'     , task_id',
'     , task_def_id',
'     , task_def_name',
'     , task_def_static_id',
'     , subject',
'     , details_app_id',
'     , details_app_name',
'     , details_link_target',
'     , due_on',
'     , due_in_hours',
'     , due_in ',
'     , due_code',
'     , priority',
'     , priority_level',
'     , initiator',
'     , initiator_lower',
'     , actual_owner',
'     , actual_owner_lower',
'     , state_code',
'     , state',
'     , is_completed',
'     , outcome_code',
'     , outcome',
'     , badge_css_classes',
'     , badge_text',
'     , created_ago_hours',
'     , created_ago',
'     , created_by',
'     , created_on',
'     , last_updated_by',
'     , last_updated_on',
'     , process_id',
'     , subflow_id',
'     , step_key',
'     )',
'as select   ',
'      ''APEX_APPROVAL''',
'     , app_id',
'     , task_id',
'     , task_def_id',
'     , task_def_name',
'     , task_def_static_id',
'     , subject',
'     , details_app_id',
'     , details_app_name',
'     , details_link_target',
'     , due_on',
'     , due_in_hours',
'     , due_in ',
'     , due_code',
'     , priority',
'     , priority_level',
'     , initiator',
'     , initiator_lower',
'     , actual_owner',
'     , actual_owner_lower',
'     , state_code',
'     , state',
'     , is_completed',
'     , outcome_code',
'     , outcome',
'     , badge_css_classes',
'     , badge_text',
'     , created_ago_hours',
'     , created_ago',
'     , created_by',
'     , created_on',
'     , last_updated_by',
'     , last_updated_on',
'     , null',
'     , null',
'     , null',
'    from table ( apex_approval.get_tasks ( p_context => ''MY_TASKS'' ) )',
'    UNION ALL',
'    select  ',
'       ''F4A_USERTASK''',
'     , fati.app_id',
'     , fati.task_id',
'     , fati.task_def_id',
'     , fati.task_def_name',
'     , fati.task_def_static_id',
'     , fati.subject',
'     , fati.details_app_id',
'     , fati.details_app_name',
'     , fati.details_link_target',
'     , fati.due_on',
'     , fati.due_in_hours',
'     , fati.due_in ',
'     , fati.due_code',
'     , fati.priority',
'     , fati.priority_level',
'     , fati.initiator',
'     , fati.initiator_lower',
'     , fati.actual_owner',
'     , fati.actual_owner_lower',
'     , fati.state_code',
'     , fati.state',
'     , fati.is_completed',
'     , fati.outcome_code',
'     , fati.outcome',
'     , fati.badge_css_classes',
'     , fati.badge_text',
'     , fati.created_ago_hours',
'     , fati.created_ago',
'     , fati.created_by',
'     , fati.created_on',
'     , fati.last_updated_by',
'     , fati.last_updated_on',
'     , fati.process_id',
'     , fati.subflow_id',
'     , fati.step_key',
'     from flow_apex_task_inbox_vw fati',
'    where fati.state = ''running''',
'      and ( fati.actual_owner = SYS_CONTEXT(''APEX$SESSION'',''APP_USER'') ',
'          OR fati.actual_owner is null )',
'      and fati.lane_name in ( select roles.role_static_id',
'                              from   apex_appl_acl_user_roles roles',
'                              where  roles.user_name = SYS_CONTEXT(''APEX$SESSION'',''APP_USER'')',
'                              and    roles.workspace_id = SYS_CONTEXT(''APEX$SESSION'',''WORKSPACE_ID'')',
'                              )',
'          --- if lanes not always being used, change this to your situation',
'     ;',
'',
'create or replace view flow_apex_my_combined_task_list_vw',
'     ( manager',
'     , app_id',
'     , task_id',
'     , task_def_id',
'     , task_def_name',
'     , task_def_static_id',
'     , subject',
'     , task_type',
'     , details_app_id',
'     , details_app_name',
'     , details_link_target',
'     , due_on',
'     , due_in_hours',
'     , due_in ',
'     , due_code',
'     , priority',
'     , priority_level',
'     , initiator',
'     , initiator_lower',
'     , actual_owner',
'     , actual_owner_lower',
'     , state_code',
'     , state',
'     , is_completed',
'     , outcome_code',
'     , outcome',
'     , badge_css_classes',
'     , badge_text',
'     , created_ago_hours',
'     , created_ago',
'     , created_by',
'     , created_on',
'     , last_updated_by',
'     , last_updated_on',
'     , process_id',
'     , subflow_id',
'     , step_key',
'     , current_obj',
'     )',
'as select   ',
'      ''APEX'' as manager',
'     , app_id',
'     , task_id',
'     , task_def_id',
'     , task_def_name',
'     , task_def_static_id',
'     , subject',
'     , ''APPROVAL'' as task_type',
'     , details_app_id',
'     , details_app_name',
'     , details_link_target',
'     , due_on',
'     , due_in_hours',
'     , due_in ',
'     , due_code',
'     , priority',
'     , priority_level',
'     , initiator',
'     , initiator_lower',
'     , actual_owner',
'     , actual_owner_lower',
'     , state_code',
'     , state',
'     , is_completed',
'     , outcome_code',
'     , outcome',
'     , badge_css_classes',
'     , badge_text',
'     , created_ago_hours',
'     , created_ago',
'     , created_by',
'     , created_on',
'     , last_updated_by',
'     , last_updated_on',
'     , null',
'     , null',
'     , null',
'     , null',
'    from table ( apex_approval.get_tasks ( p_context => ''MY_TASKS'' ) )',
'    UNION ALL',
'    select  ',
'       manager',
'     , app_id',
'     , task_id',
'     , task_def_id',
'     , task_def_name',
'     , task_def_static_id',
'     , subject',
'     , task_type',
'     , details_app_id',
'     , details_app_name',
'     , details_link_target',
'     , due_on',
'     , due_in_hours',
'     , due_in ',
'     , due_code',
'     , priority',
'     , priority_level',
'     , initiator',
'     , initiator_lower',
'     , actual_owner',
'     , actual_owner_lower',
'     , state_code',
'     , state',
'     , is_completed',
'     , outcome_code',
'     , outcome',
'     , badge_css_classes',
'     , badge_text',
'     , created_ago_hours',
'     , created_ago',
'     , created_by',
'     , created_on',
'     , last_updated_by',
'     , last_updated_on',
'     , process_id',
'     , subflow_id',
'     , step_key',
'     , current_obj',
'     from table ( flow_api_pkg.get_current_tasks ( p_context => ''MY_TASKS''))',
'     ;',
'/* ',
'-- Flows for APEX - flow_instance_details_vw.sql',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created    Nov-2020 Moritz Klein,  MT AG',
'-- Edited  16-Mar-2022 Richard Allen, Oracle Corporation',
'-- Edited  21-Jun-2024 Dennis Amthor, Hyand Solutions GmbH',
'--',
'-- NOTE THAT THIS VIEW HAS AN ENTERPRISE EDITION VERSION WHICH INCLUDES COMPLEX',
'-- PROCESSING TO GENERATE THE ITERATION_DATA COLUMN.',
'-- ANY CHANGES TO THIS VIEW SHOULD ALSO UPDATE THE ENTERPRISE EDITION VERSION IN ADDITION.',
'*/',
'create or replace view flow_instance_details_vw',
'as',
'with completed_objects as (',
'        select distinct sflg.sflg_prcs_id as prcs_id',
'                      , sflg.sflg_dgrm_id  as dgrm_id',
'                      , sflg.sflg_diagram_level as diagram_level',
'                      , sflg.sflg_objt_id as objt_id',
'          from flow_subflow_log sflg',
'         where sflg.sflg_objt_id not in (   ',
'                                          select sbfl.sbfl_current',
'                                            from flow_subflows sbfl',
'                                           where sbfl.sbfl_prcs_id = sflg.sflg_prcs_id',
'                                             and sbfl.sbfl_diagram_level = sflg.sflg_diagram_level',
'                                             and sbfl.sbfl_current is not null',
'                                        )',
'), all_completed as ( ',
'    select prcs_id, dgrm_id, diagram_level,',
'           listagg( objt_id, '':'') within group (order by objt_id) as bpmn_ids',
'    from completed_objects',
'    group by prcs_id, dgrm_id, diagram_level',
'), all_current as (',
'  select sbfl_prcs_id as prcs_id',
'       , sbfl_dgrm_id as dgrm_id',
'       , sbfl_diagram_level as diagram_level ',
'       , listagg(sbfl_current, '':'') within group ( order by sbfl_current ) as bpmn_ids',
'    from flow_subflows',
'   where sbfl_current is not null  ',
'group by sbfl_prcs_id, sbfl_dgrm_id, sbfl_diagram_level',
'), all_errors as (',
'  select sbfl_prcs_id as prcs_id',
'       , sbfl_dgrm_id as dgrm_id',
'       , sbfl_diagram_level as diagram_level',
'       , listagg(sbfl_current, '':'') within group (order by sbfl_current) as bpmn_ids',
'    from flow_subflows',
'   where sbfl_current is not null',
'     and sbfl_status = ''error''',
'group by sbfl_prcs_id, sbfl_dgrm_id, sbfl_diagram_level',
'), user_tasks as (',
'    select process_id as prcs_id',
'         , json_objectagg',
'           (',
'               key current_obj',
'               value details_link_target',
'               absent on null',
'               returning clob',
'           ) as user_task_urls',
'      from flow_apex_my_combined_task_list_vw',
'     group by process_id',
')',
'  select prcs.prcs_id',
'       , prcs.prcs_name',
'       , prdg.prdg_id',
'       , prdg.prdg_prdg_id',
'       , prdg.prdg_diagram_level as diagram_level',
'       , prdg.prdg_calling_dgrm as calling_dgrm',
'       , prdg.prdg_calling_objt as calling_objt',
'       , dgrm.dgrm_name || case when prdg.prdg_diagram_level is not null then '' ( Level: '' || prdg.prdg_diagram_level || '' )'' else '''' end as breadcrumb',
'       , 1 as drilldown_allowed',
'       , dgrm.dgrm_id',
'       , dgrm.dgrm_name',
'       , dgrm.dgrm_version',
'       , dgrm.dgrm_status',
'       , dgrm.dgrm_category',
'       , dgrm.dgrm_content',
'       , ( select acomp.bpmn_ids',
'             from all_completed acomp',
'            where acomp.prcs_id = prcs.prcs_id',
'              and acomp.dgrm_id = dgrm.dgrm_id',
'              and acomp.diagram_level =  prdg.prdg_diagram_level',
'         ) as all_completed',
'       , null as last_completed     -- remove in v22.1',
'       , ( select acurr.bpmn_ids',
'             from all_current acurr',
'            where acurr.prcs_id = prcs.prcs_id',
'              and acurr.dgrm_id = dgrm.dgrm_id',
'              and acurr.diagram_level =  prdg.prdg_diagram_level',
'         ) as all_current',
'       , ( select aerr.bpmn_ids',
'             from all_errors aerr',
'            where aerr.prcs_id = prcs.prcs_id',
'              and aerr.dgrm_id = dgrm.dgrm_id',
'              and aerr.diagram_level =  prdg.prdg_diagram_level',
'         ) as all_errors',
'       , usta.user_task_urls',
'       , to_clob(null) as iteration_data',
'       , prov.prov_var_vc2 as prcs_business_ref',
'    from flow_processes prcs',
'    join flow_instance_diagrams prdg',
'      on prdg.prdg_prcs_id = prcs.prcs_id',
'    join flow_diagrams dgrm',
'      on prdg.prdg_dgrm_id = dgrm.dgrm_id',
'    left join flow_process_variables prov',
'      on prov.prov_prcs_id  = prcs.prcs_id',
'     and prov.prov_var_name = ''BUSINESS_REF''',
'     and prov.prov_var_type = ''VARCHAR2''',
'     and prov.prov_scope    = 0',
'    left join user_tasks usta',
'      on prcs.prcs_id = usta.prcs_id',
'with read only;',
'',
'create or replace view flow_instance_variables_vw',
'as',
'  select prov.prov_prcs_id',
'       , prov.prov_var_name',
'       , prov.prov_scope',
'       , prov.prov_var_type',
'       , prov.prov_var_vc2',
'       , prov.prov_var_num',
'       , prov.prov_var_date',
'       , prov.prov_var_tstz',
'       , prov.prov_var_clob',
'       , prov.prov_var_json',
'       , prcs.prcs_name',
'       , prcs.prcs_status',
'    from flow_process_variables prov',
'    join flow_processes prcs',
'      on prcs.prcs_id = prov.prov_prcs_id',
'with read only;',
'',
'create or replace view flow_task_inbox_vw',
'as ',
'   select sbfl_id',
'        , sbfl_sbfl_id',
'        , sbfl_prcs_id',
'        , sbfl_process_name',
'        , sbfl_prcs_init_ts',
'        , sbfl_dgrm_id',
'        , sbfl_dgrm_name',
'        , sbfl_dgrm_version',
'        , sbfl_dgrm_status',
'        , sbfl_dgrm_category',
'        , sbfl_starting_object',
'        , sbfl_starting_object_name',
'        , sbfl_route',
'        , sbfl_route_name',
'        , sbfl_last_completed',
'        , sbfl_last_completed_name',
'        , sbfl_current',
'        , sbfl_current_name',
'        , sbfl_step_key',
'        , sbfl_scope',
'        , case sbfl_current_tag_name',
'            when ''bpmn:userTask'' then',
'              flow_usertask_pkg.get_url',
'              (',
'                pi_prcs_id  => sbfl_prcs_id',
'              , pi_sbfl_id  => sbfl_id',
'              , pi_objt_id  => sbfl_current_objt_id',
'              , pi_step_key => sbfl_step_key',
'              , pi_scope    => sbfl_scope',
'              )',
'            else null',
'          end link_text',
'        , sbfl_current_tag_name',
'        , sbfl_became_current',
'        , sbfl_last_update',
'        , sbfl_last_update_by',
'        , sbfl_status',
'        , sbfl_current_lane',
'        , sbfl_current_lane_name',
'        , sbfl_potential_users',
'        , sbfl_potential_groups',
'        , sbfl_excluded_users        ',
'        , sbfl_reservation',
'        , sbfl.sbfl_priority',
'        , sbfl.sbfl_due_on',
'        , prov.prov_var_vc2 as sbfl_business_ref',
'     from flow_subflows_vw sbfl',
'     left join flow_process_variables prov',
'        on prov.prov_prcs_id = sbfl.sbfl_prcs_id',
'       and prov.prov_var_name = ''BUSINESS_REF''',
'       and prov.prov_var_type = ''VARCHAR2'' ',
'       and prov.prov_scope = 0',
'    where sbfl_status = ''running''',
'with read only',
';',
'',
'create or replace view flow_instance_connections_lov',
'as',
'  select cn.conn_bpmn_id',
'       , coalesce(cn.conn_name,conn_bpmn_id) conn_name',
'       , cn.conn_src_objt_id',
'       , objt.objt_bpmn_id as src_objt_bpmn_id',
'       , ins.prcs_id',
'       , prdg.prdg_id',
'    from flow_instances_vw ins',
'    join flow_instance_diagrams prdg',
'      on prdg.prdg_prcs_id = ins.prcs_id',
'    join flow_connections cn ',
'      on cn.conn_dgrm_id = prdg.prdg_dgrm_id',
'     and cn.conn_tag_name = ''bpmn:sequenceFlow''',
'    join flow_objects objt',
'      on objt.objt_id = cn.conn_src_objt_id',
'with read only;',
'',
'create or replace view flow_instance_gateways_lov',
'as',
'  select obj.objt_id',
'       , obj.objt_bpmn_id',
'       , case when callobj.objt_id is null then ''Main Diagram'' else callobj.objt_name end calling_object',
'       , case when obj.objt_name is null then obj.objt_bpmn_id else obj.objt_name || '' ('' || obj.objt_bpmn_id ||'')'' end objt_name',
'       , case obj.objt_tag_name',
'           when ''bpmn:exclusiveGateway'' then ''single''',
'           when ''bpmn:inclusiveGateway'' then ''multi''',
'           else null',
'         end as select_option',
'       , ins.prcs_id',
'       , prdg.prdg_diagram_level',
'       , prdg.prdg_dgrm_id',
'       , prdg.prdg_prdg_id',
'       , prdg.prdg_id',
'    from flow_instances_vw ins',
'    join flow_instance_diagrams prdg',
'      on prdg.prdg_prcs_id = ins.prcs_id',
'     and prdg.prdg_diagram_level is not null',
'    join flow_objects obj',
'      on obj.objt_dgrm_id = prdg.prdg_dgrm_id',
'    left join flow_objects callobj',
'      on callobj.objt_dgrm_id = prdg.prdg_calling_dgrm',
'      and callobj.objt_bpmn_id = prdg.prdg_calling_objt',
'   where obj.objt_tag_name in (''bpmn:exclusiveGateway'', ''bpmn:inclusiveGateway'')',
'     and ( select count(*) ',
'           from flow_connections conn ',
'           where conn.conn_src_objt_id = obj.objt_id ',
'           and conn.conn_tag_name = ''bpmn:sequenceFlow'') > 1',
'with read only;',
'',
'create or replace view flow_instance_scopes_vw',
'as',
'  select prdg_prcs_id         iscp_prcs_id',
'       , prdg_diagram_level   iscp_valid_scope',
'    from flow_instance_diagrams',
'   where prdg_diagram_level is not null',
'  union',
'  select distinct iter_prcs_id iscp_prcs_id',
'       , iter_scope            iscp_valid_scope',
'    from flow_iterations',
'with read only;',
'',
'create or replace view flow_diagrams_vw',
'as',
'  select dgrm.dgrm_id',
'       , dgrm.dgrm_name',
'       , dgrm.dgrm_version',
'       , dgrm.dgrm_status',
'       , dgrm.dgrm_category',
'       , dgrm.dgrm_last_update',
'       , dgrm.dgrm_content',
'  from flow_diagrams dgrm',
'with read only;',
'',
'create or replace view flow_instance_diagrams_lov',
'as',
'  select distinct',
'    case when callobj.objt_id is null then ''Main Diagram'' else callobj.objt_name end as calling_diagram,',
'    prdg.prdg_id,',
'    prdg.prdg_prcs_id',
'  from flow_instance_diagrams prdg',
'  join flow_objects obj',
'        on obj.objt_dgrm_id = prdg.prdg_dgrm_id',
'  left join flow_objects callobj ',
'    on callobj.objt_dgrm_id = prdg.prdg_calling_dgrm',
'        and callobj.objt_bpmn_id = prdg.prdg_calling_objt',
'  where obj.objt_tag_name in (''bpmn:exclusiveGateway'', ''bpmn:inclusiveGateway'')',
'  and ( select count(*) from flow_connections conn where conn.conn_src_objt_id = obj.objt_id ) > 1',
'with read only;',
'',
'create or replace view flow_diagrams_instanciated_lov',
'as',
'  select dgrm.dgrm_id',
'       , dgrm.dgrm_name',
'       , dgrm.dgrm_version',
'       , dgrm.dgrm_status',
'       , dgrm.dgrm_category',
'    from flow_diagrams dgrm',
'   where exists ',
'         ( select null',
'             from flow_objects objt',
'            where objt.objt_dgrm_id = dgrm.dgrm_id',
'         )',
'    and exists (',
'      select 1',
'      from flow_instance_diagrams prdg',
'      where prdg.prdg_dgrm_id = dgrm.dgrm_id',
'    )',
'  with read only',
'  ;',
'',
'/* ',
'-- Flows for APEX - flow_instance_timeline_vw.sql',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created    01-Feb-2023  Richard Allen (Oracle)',
'-- Edited     05-Jun-2023  Louis Moreaux, Insum',
'--',
'-- This view shows timeline of all logged events for a process',
'--',
'--',
'*/',
'create or replace view flow_instance_timeline_vw as',
'select ''created'' operation',
'     , ''Instance Created'' description',
'     , null as objt',
'     , null as subflow',
'     , 0 as process_level',
'     , null as proc_var',
'     , prcs.prcs_name as value',
'     , null as event_comment',
'     , prcs_init_ts performed_on',
'     , prcs_init_by performed_by',
'     , prcs_id ',
'  from flow_processes prcs',
'union',
'select ''started'' operation',
'     , ''Instance Started'' description',
'     , null as objt',
'     , null as subflow',
'     , 0 as process_level',
'     , null as proc_var ',
'     , prcs.prcs_name as value',
'     , null as event_comment',
'     , prcs_start_ts performed_on',
'     , null',
'     , prcs_id ',
'  from flow_processes prcs',
'union',
'select ''completed'' operation',
'     , ''Instance completed'' description',
'     , null as objt',
'     , null as subflow',
'     , 0 as process_level',
'     , null as proc_var',
'     , null as value',
'     , null as event_comment',
'     , prcs_start_ts performed_on',
'     , null',
'     , prcs_id ',
'  from flow_processes prcs',
' where prcs.prcs_complete_ts is not null',
'union',
'select lgpr_prcs_event operation',
'     , lgpr_prcs_event ',
'     , lgpr_objt_id',
'     , null as subflow',
'     , null as process_level',
'     , null as proc_var',
'     , null as value',
'     , lgpr_comment as event_comment',
'     , lgpr_timestamp performed_on',
'     , lgpr_user',
'     , lgpr_prcs_id as prcs_id',
'  from    flow_instance_event_log lgpr',
'union ',
'select ''step current'' as operation',
'     , ''Became Current after'' as description',
'     , lgsf_objt_id as objt',
'     , lgsf_sbfl_id as subflow',
'     , lgsf_sbfl_process_level as process_level',
'     , null as proc_var',
'     , lgsf_last_completed as value',
'     , lgsf_comment as event_comment',
'     , lgsf_was_current as performed_on',
'     , null as performed_by',
'     , lgsf_prcs_id as prcs_id ',
'  from flow_step_event_log',
'union',
'select ''step started'' as operation',
'     , ''Work Started on Step'' description',
'     , lgsf_objt_id as objt',
'     , lgsf_sbfl_id as subflow',
'     , lgsf_sbfl_process_level as process_level',
'     , null as proc_var',
'     , null as value',
'     , lgsf_comment as event_comment',
'     , lgsf_started as performed_on',
'     , null as performed_by',
'     , lgsf_prcs_id as prcs_id ',
'  from flow_step_event_log',
' where lgsf_started is not null',
'union ',
'select ''step completed'' as operation',
'     , ''Step completed'' description',
'     , lgsf_objt_id as objt',
'     , lgsf_sbfl_id as subflow',
'     , lgsf_sbfl_process_level as process_level',
'     , null as proc_var',
'     , null as value',
'     , lgsf_comment as event_comment',
'     , lgsf_completed as performed_on',
'     , lgsf_user as performed_by',
'     , lgsf_prcs_id as prcs_id ',
'  from flow_step_event_log   ',
'union ',
'select ''variable set'' as operation',
'     , ''Variable set'' as description',
'     , lgvr_objt_id as objt',
'     , lgvr_sbfl_id as subflow',
'     , null as process_level',
'     , lgvr_var_name as proc_var',
'     , case lgvr_var_type ',
'          when ''VARCHAR2'' then lgvr_var_vc2',
'          when ''NUMBER'' then to_char(lgvr_var_num)',
'          when ''DATE'' then to_char (lgvr_var_date, ''DD-MON-YY HH24:MI:SS'')',
'          when ''TIMESTAMP WITH TIME ZONE'' then to_char (lgvr_var_tstz, ''DD-MON-YY HH24:MI:SS TZR'')',
'          when ''CLOB'' then ''CLOB Value''',
'          end as value',
'     , lgvr_expr_set as event_comment',
'     , lgvr_timestamp as performed_on',
'     , null as performed_by',
'     , lgvr_prcs_id as prcs_id ',
'  from    flow_variable_event_log',
'order by performed_on',
'with read only;',
'',
'/* ',
'-- Flows for APEX - flow_startable_diagrams_vw.sql',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created    05-Apr-2023  Richard Allen (Oracle)',
'-- Edited     05-Jun-2023  Louis Moreaux, Insum',
'-- Edited '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373921319456959)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    07-Oct-2024  Dennis Amthor, Hyand Solutions GmbH',
'--',
'-- This view shows any process diagrams that are marked as startable, along with users and groups that can start them',
'-- and excluded uses who cannot start them (takes precedence over positive grants in potentialStartingGroups).',
'--',
'--  -- Note this View can only be queried inside an APEX session',
'--',
'*/',
'create or replace view flow_startable_diagrams_vw',
'as ',
'select dgrm.dgrm_id',
'     , dgrm.dgrm_name',
'     , dgrm.dgrm_version',
'     , dgrm.dgrm_status',
'     , objt.objt_name process_name',
'     , objt.objt_bpmn_id process_bpmn_id',
'     , nvl2(objt.objt_attributes."apex"."potentialStartingUsers", flow_settings.get_vc2_expression(pi_expr=> objt.objt_attributes."apex"."potentialStartingUsers"),null) potential_starting_users',
'     , nvl2(objt.objt_attributes."apex"."potentialStartingGroups", flow_settings.get_vc2_expression(pi_expr=> objt.objt_attributes."apex"."potentialStartingGroups"),null) potential_starting_groups',
'     , nvl2(objt.objt_attributes."apex"."excludedStartingUsers", flow_settings.get_vc2_expression(pi_expr=> objt.objt_attributes."apex"."excludedStartingUsers"),null) excluded_starting_users',
'  from flow_diagrams dgrm',
'  join flow_objects objt',
'    on dgrm.dgrm_id = objt.objt_dgrm_id',
'   and objt.objt_attributes."apex"."isStartable" = ''true''',
'  with read only;',
'',
'',
'create or replace view flow_message_subscriptions_vw',
'as',
'   select mes.msub_id,',
'          mes.msub_message_name,',
'          mes.msub_key_name,',
'          mes.msub_key_value,',
'          mes.msub_prcs_id,',
'          mes.msub_sbfl_id,',
'          mes.msub_step_key,',
'          mes.msub_dgrm_id,',
'          mes.msub_callback,',
'          mes.msub_callback_par,',
'          mes.msub_payload_var,',
'          mes.msub_created',
'     from flow_message_subscriptions mes',
'with read only;',
'create or replace view flow_rest_diagrams_vw',
'      (',
'          dgrm_id',
'        , name ',
'        , version',
'        , status ',
'        , category ',
'        , links',
'      )',
'  as',
'  select  d.dgrm_id',
'        , d.dgrm_name     as name',
'        , d.dgrm_version  as version',
'        , d.dgrm_status   as status',
'        , d.dgrm_category as category',
'        , json_array(',
'            flow_rest_api_v1.get_links_string_http_GET(''diagram'',d.dgrm_id) format json',
'          ) links',
'    from flow_diagrams d;',
'create or replace view flow_rest_message_subscriptions_vw',
'      (',
'         msub_id',
'       , name',
'       , key',
'       , value',
'       , prcs_id',
'       , sbfl_id',
'       , step_key    ',
'      )',
'  as',
'  select ms.msub_id',
'       , ms.msub_message_name as name',
'       , ms.msub_key_name     as key',
'       , ms.msub_key_value    as value',
'       , ms.msub_prcs_id      as prcs_id',
'       , ms.msub_sbfl_id      as sbfl_id',
'       , ms.msub_step_key     as step_key',
'  from flow_message_subscriptions ms;',
'create or replace view flow_rest_process_vars_vw',
'      (',
'          prcs_id',
'        , scope ',
'        , name ',
'        , type ',
'        , value',
'      )',
'  as',
'  select  pv.prov_prcs_id  as prcs_id',
'        , pv.prov_scope    as scope',
'        , pv.prov_var_name as name',
'        , pv.prov_var_type as type',
'        , decode( lower(pv.prov_var_type) ',
'              , ''varchar2'', pv.prov_var_vc2',
'              , ''number'',   pv.prov_var_num',
'              , ''date'',     pv.prov_var_date',
'              , ''clob'',     pv.prov_var_clob',
'              , ''timestamp with time zone'', pv.prov_var_tstz',
'              , ''json'', pv.prov_var_json',
'              , null ) as value',
'  from flow_process_variables pv;',
'create or replace view flow_rest_processes_vw',
'      (',
'          dgrm_id',
'        , prcs_id',
'        , name',
'        , status',
'        , init_ts',
'        , init_by',
'        , process_vars',
'        , links',
'      )',
'  as',
'  SELECT  ',
'          d.dgrm_id',
'        , p.prcs_id',
'        , p.prcs_name     as name',
'        , p.prcs_status   as status',
'        , p.prcs_init_ts  as init_ts',
'        , p.prcs_init_by  as init_by',
'        , json_array( ',
'            listagg( ',
'                json_object (',
'                  ''scope'' value pv.prov_scope',
'                 , ''name'' value pv.prov_var_name',
'                 , ''type'' value pv.prov_var_type',
'                 , ''value'' value decode( lower(pv.prov_var_type) ',
'                                      , ''varchar2'', pv.prov_var_vc2',
'                                      , ''number'',   pv.prov_var_num',
'                                      , ''date'',     pv.prov_var_num',
'                                      , ''clob'',     pv.prov_var_num',
'                                      , null )',
'                )     ',
'            ,'','') format json',
'          ) process_vars',
'        , json_array(',
'            flow_rest_api_v1.get_links_string_http_GET(''process'',p.prcs_id) format json',
'          ) links',
'  from flow_diagrams d',
'  join flow_processes p on d.dgrm_id = p.prcs_dgrm_id',
'  left join flow_process_variables pv on p.prcs_id = pv.prov_prcs_id',
'  group by  d.dgrm_id',
'          , p.prcs_id',
'          , p.prcs_name',
'          , p.prcs_status',
'          , p.prcs_init_ts',
'          , p.prcs_init_by;',
'create or replace view flow_rest_subflows_vw',
'      (',
'         prcs_id',
'       , sbfl_id',
'       , sbfl_sbfl_id',
'       , process_level',
'       , diagram_level',
'       , calling_sbfl',
'       , scope',
'       , "current"',
'       , step_key',
'       , status',
'       , became_current',
'       , reservation',
'       , links',
'      )',
'  as',
'  select p.prcs_id',
'       , s.sbfl_id',
'       , s.sbfl_sbfl_id',
'       , s.sbfl_process_level   as process_level',
'       , s.sbfl_diagram_level   as diagram_level',
'       , s.sbfl_calling_sbfl    as calling_sbfl',
'       , s.sbfl_scope           as scope',
'       , s.sbfl_current         as "current"',
'       , s.sbfl_step_key        as step_key',
'       , s.sbfl_status          as status',
'       , s.sbfl_became_current  as became_current',
'       , s.sbfl_reservation     as reservation',
'       , json_array(',
'           flow_rest_api_v1.get_links_string_http_GET(''step'',s.sbfl_id) format json',
'         ) links',
'  from flow_processes p',
'  join flow_subflows s on p.prcs_id = s.sbfl_prcs_id;',
'',
'create or replace view flow_p0002_diagrams_vw',
'as',
'  with instance_numbers as',
'  (',
'    select prdg_dgrm_id as dgrm_id',
'         , created_cnt',
'         , running_cnt',
'         , completed_cnt',
'         , terminated_cnt',
'         , error_cnt',
'         , created_cnt + running_cnt + completed_cnt + terminated_cnt + error_cnt as total_cnt ',
'      from (',
'             select prdg.prdg_dgrm_id',
'                  , prcs.prcs_status',
'               from flow_processes prcs',
'               join flow_instance_diagrams prdg',
'                 on prdg.prdg_prcs_id = prcs.prcs_id',
'           group by prcs.prcs_id, prdg.prdg_dgrm_id, prcs.prcs_status',
'           )',
'     pivot (',
'             count(*) for',
'               prcs_status in ( ''created'' created_cnt, ''running'' running_cnt, ''completed'' completed_cnt',
'                              , ''terminated'' terminated_cnt, ''error'' as error_cnt',
'                              )',
'           )',
'  )',
'    select d.dgrm_id',
'         , d.dgrm_name',
'         , d.dgrm_version',
'         , d.dgrm_status',
'         , d.dgrm_category',
'         , d.dgrm_last_update at time zone sessiontimezone as dgrm_last_update',
'         , null as btn',
'         , apex_page.get_url(p_page => 7, p_items => ''P7_DGRM_ID'', p_values => d.dgrm_id) as edit_link',
'         , apex_page.get_url(p_page => 11, p_items => ''P11_DGRM_ID'', p_values => d.dgrm_id) as create_instance_link',
'         , decode(inst_nums.total_cnt, 0, null, inst_nums.total_cnt) as instances ',
'         , case when not exists( select null from flow_objects objt where objt.objt_dgrm_id = d.dgrm_id ) then ''No'' else ''Yes'' end as diagram_parsed',
'         , case when not exists( select null from flow_objects objt where objt.objt_dgrm_id = d.dgrm_id ) then ''fa-times-circle-o fa-lg u-danger-text'' else ''fa-check-circle-o fa-lg u-success-text'' end as diagram_parsed_icon',
'         , case dgrm_status',
'             when ''draft''      then ''fa fa-wrench''',
'             when ''released''   then ''fa fa-check''',
'             when ''deprecated'' then ''fa fa-ban''',
'             when ''archived''   then ''fa fa-archive''',
'           end as dgrm_status_icon',
'         , nullif(inst_nums.created_cnt, 0) as instance_created',
'         , apex_page.get_url(p_page => 10, p_items => ''P10_FILTER_DGRM_ID,IR_PRCS_STATUS'', p_values => d.dgrm_id||'',created'', p_clear_cache => ''RP,RIR'') as instance_created_link',
'         , nullif(inst_nums.running_cnt, 0) as instance_running',
'         , apex_page.get_url(p_page => 10, p_items => ''P10_FILTER_DGRM_ID,IR_PRCS_STATUS'', p_values => d.dgrm_id||'',running'', p_clear_cache => ''RP,RIR'') as instance_running_link',
'         , nullif(inst_nums.completed_cnt, 0) as instance_completed',
'         , apex_page.get_url(p_page => 10, p_items => ''P10_FILTER_DGRM_ID,IR_PRCS_STATUS'', p_values => d.dgrm_id||'',completed'', p_clear_cache => ''RP,RIR'') as instance_completed_link',
'         , nullif(inst_nums.terminated_cnt, 0) as instance_terminated',
'         , apex_page.get_url(p_page => 10, p_items => ''P10_FILTER_DGRM_ID,IR_PRCS_STATUS'', p_values => d.dgrm_id||'',terminated'', p_clear_cache => ''RP,RIR'') as instance_terminated_link',
'         , nullif(inst_nums.error_cnt, 0) as instance_error',
'         , apex_page.get_url(p_page => 10, p_items => ''P10_FILTER_DGRM_ID,IR_PRCS_STATUS'', p_values => d.dgrm_id||'',error'', p_clear_cache => ''RP,RIR'') as instance_error_link',
'         , apex_item.checkbox2(p_idx => 1, p_value => d.dgrm_id, p_attributes => ''data-name = "'' || dgrm_name || ''" data-version = "'' || dgrm_version || ''"'') as checkbox',
'      from flow_diagrams_vw d',
' left join instance_numbers inst_nums',
'        on inst_nums.dgrm_id = d.dgrm_id',
'with read only',
';',
'',
'create or replace view flow_p0007_vw',
'as',
'  select ',
'      dgrm.dgrm_content',
'    , dgrm.dgrm_id',
'  from flow_diagrams dgrm',
'with read only;',
'',
'create or replace view flow_p0007_diagrams_var_vw',
'as',
'   select ',
'      objt_dgrm_id,',
'      ''In'' as var_direction,',
'      jt.var_name,',
'      jt.var_type,',
'      jt.var_desc',
'   from flow_objects objt,',
'   json_table( objt.objt_attributes, ''$.apex.inVariables[*]''',
'      columns',
'           var_name varchar2(4000) path ''$.varName''',
'         , var_type varchar2(4000) path ''$.varDataType''',
'         , var_desc varchar2(4000) path ''$.varDescription''',
'   ) jt',
'   where objt_attributes is not null',
'     and objt_tag_name = ''bpmn:process''',
'   union',
'   select ',
'      objt_dgrm_id,',
'      ''Out'' as var_direction,',
'      jt.var_name,',
'      jt.var_type,',
'      jt.var_desc',
'   from flow_objects objt,',
'   json_table( objt.objt_attributes, ''$.apex.outVariables[*]''',
'      columns',
'           var_name varchar2(4000) path ''$.varName''',
'         , var_type varchar2(4000) path ''$.varDataType''',
'         , var_desc varchar2(4000) path ''$.varDescription''',
'   ) jt',
'      where objt_attributes is not null',
'      and objt_tag_name = ''bpmn:process''',
'with read only;',
'',
'create or replace view flow_p0007_diagrams_attributes_vw',
'as',
'   select ',
'   objt_dgrm_id,',
'   jt.application_id,',
'   jt.page_id,',
'   jt.username,',
'   jt.is_callable',
'from flow_objects objt,',
'json_table( objt.objt_attributes, ''$.apex''',
'   columns',
'        application_id     varchar2(4000) path ''$.applicationId''',
'      , page_id            varchar2(4000) path ''$.pageId''',
'      , username           varchar2(4000) path ''$.username''',
'      , is_callable        varchar2(4000) path ''$.isCallable''',
'   ) jt',
'   where objt_attributes is not null',
'   and objt_tag_name = ''bpmn:process''',
'with read only;',
'',
'create or replace view flow_p0007_called_diagrams_vw',
'as',
'  with diagrams as',
'      (',
'         select dgrm.dgrm_id,',
'                null    as calling_dgrm,',
'                null    as calling_objt,',
'                dgrm.dgrm_name,',
'                dgrm.dgrm_version',
'           from flow_diagrams dgrm',
'         union all',
'         select dgrm.dgrm_id,',
'                objt.objt_dgrm_id as calling_dgrm,',
'                objt.objt_bpmn_id as calling_objt,',
'                dgrm.dgrm_name,',
'                dgrm.dgrm_version',
'           from flow_objects  objt',
'           join flow_diagrams dgrm',
'             on objt.objt_tag_name = ''bpmn:callActivity''',
'            and dgrm_id = flow_engine_app_api.get_current_diagram(',
'                   pi_dgrm_name           => objt.objt_attributes."apex"."calledDiagram",',
'                   pi_dgrm_calling_method => objt.objt_attributes."apex"."calledDiagramVersionSelection",',
'                   pi_dgrm_version        => objt.objt_attributes."apex"."calledDiagramVersion"',
'                )',
'      )',
'   select dgrm.dgrm_id,',
'          dgrm.calling_dgrm,',
'          dgrm.calling_objt,',
'          dgrm.dgrm_name,',
'          dgrm_version,',
'          connect_by_root(dgrm.dgrm_id) as root_dgrm,',
'          connect_by_iscycle as has_recursion,',
'          case when connect_by_iscycle = 1 then',
'            ''fa fa-exclamation-triangle-o fa-lg u-warning-text''',
'          end has_recursion_icon',
'     from diagrams dgrm',
'    start with dgrm.calling_dgrm is null',
'  connect by nocycle dgrm.calling_dgrm = prior dgrm.dgrm_id',
'with read only;',
'',
'create or replace view flow_p0007_calling_diagrams_vw',
'as',
'  select ',
'    dgrm.dgrm_id,',
'    dgrm.dgrm_name,',
'    dgrm.dgrm_version,',
'    objt.objt_name,',
'    objt.objt_attributes."apex"."calledDiagram" as called_diagram,',
'    objt.objt_attributes."apex"."calledDiagramVersionSelection" as called_diagram_version_selection,',
'    objt.objt_attributes."apex"."calledDiagramVersion" as called_diagram_version',
'  from flow_objects  objt',
'  join flow_diagrams dgrm',
'    on objt.objt_tag_name = ''bpmn:callActivity''',
'  and objt.objt_dgrm_id = dgrm.dgrm_id',
'with read only;',
'',
'create or replace view flow_p0008_instance_details_vw',
'as',
'  select ',
'       prcs_id,',
'       prcs_name,',
'       dgrm_name,',
'       dgrm_version,',
'       prcs_status as status,',
'       prcs_priority as priority,',
'       prcs_init_ts at time zone sessiontimezone as initialized_on,',
'       prcs_last_update at time zone sessiontimezone as last_update_on,',
'       prcs_due_on at time zone sessiontimezone as due_on,',
'       prcs_business_ref as business_reference',
'  from flow_instances_vw',
'with read only;',
'',
'create or replace view flow_p0008_instance_log_vw',
'as',
'  select lgpr.lgpr_prcs_id',
'       , lgpr.lgpr_prcs_name',
'       , lgpr.lgpr_business_id',
'       , lgpr.lgpr_prcs_event',
'       , case lgpr.lgpr_prcs_event',
'           when ''started'' then ''fa-play-circle-o''',
'           when ''running'' then ''fa-play-circle-o''',
'           when ''created'' then ''fa-plus-circle-o''',
'           when ''completed'' then ''fa-check-circle-o''',
'           when ''terminated'' then ''fa-stop-circle-o''',
'           when ''error'' then ''fa-exclamation-circle-o''',
'           when ''reset'' then ''fa-undo''',
'           when ''restart step'' then ''fa-undo''',
'           when ''rescheduled'' then ''fa-clock-o''',
'         end as lgpr_prcs_event_icon',
'       , lgpr.lgpr_timestamp at time zone sessiontimezone as lgpr_timestamp',
'       , lgpr.lgpr_user',
'       , lgpr.lgpr_comment',
'       , lgpr_error_info',
'       , case when lgpr_error_info is not null then ''<pre><code class="language-log">'' end as pretag',
'       , case when lgpr_error_info is not null then ''</code></pre>'' end as posttag',
'       , lgpr.lgpr_objt_id',
'    from flow_instance_event_log lgpr',
'with read only;',
'',
'create or replace view flow_p0008_subflows_vw',
'as',
'  select sbfl.sbfl_id',
'       , sbfl.sbfl_prcs_id',
'       , sbfl.sbfl_current_name as sbfl_current',
'       , sbfl.sbfl_iteration_path',
'       , sbfl.sbfl_step_key',
'       , sbfl.sbfl_sbfl_dgrm_id',
'       , sbfl.sbfl_diagram_level',
'       , sbfl.sbfl_process_level',
'       , sbfl.sbfl_loop_counter',
'       , sbfl.sbfl_loop_total_instances',
'       , sbfl.sbfl_scope',
'       , sbfl.sbfl_calling_sbfl',
'       , ( select nvl(objt.objt_name ,''Main Diagram'')',
'             from flow_objects objt',
'             join flow_instance_diagrams prdg ',
'               on prdg.prdg_calling_objt = objt.objt_bpmn_id',
'              and prdg.prdg_calling_dgrm = objt.objt_dgrm_id',
'            where prdg.prdg_diagram_level = sbfl.sbfl_diagram_level ) as Calling_object',
'       , sbfl.sbfl_starting_object_name as sbfl_starting_object',
'       , sbfl.sbfl_last_update at time zone sessiontimezone as sbfl_last_update',
'       , sbfl.sbfl_status',
'       , case sbfl.sbfl_status',
'             when ''running'' then ''fa-play-circle-o''',
'             when ''created'' then ''fa-plus-circle-o''',
'             when ''completed'' then ''fa-check-circle-o''',
'             when ''terminated'' then ''fa-stop-circle-o''',
'             when ''error'' then ''fa-exclamation-circle-o''',
'             when ''split'' then ''fa fa-share-alt''',
'             when ''in subprocess'' then ''fa fa-share-alt''',
'             when ''in call activity'' then ''fa fa-share-alt''',
'             when ''waiting at gateway'' then ''fa fa-hand-stop-o''',
'             when ''waiting for timer'' then ''fa fa-clock-o''',
'             when ''waiting for event'' then ''fa fa-hand-stop-o''',
'             when ''waiting for approval'' then ''fa fa-question-square-o''',
'             when ''waiting for message'' then ''fa fa-envelope-o''',
'             when ''waiting iterations'' then ''fa fa-align-justify fa-rotate-90''',
'             when ''iterating'' then ''fa fa-align-justify fa-rotate-90''',
'         end as sbfl_status_icon',
'       , sbfl.sbfl_priority',
'       , sbfl.sbfl_due_on',
'       , sbfl.timr_start_on at time zone sessiontimezone as sbfl_timr_start_on',
'       , sbfl.sbfl_current_lane_name as sbfl_current_lane',
'       , sbfl.sbfl_reservation',
'       , sbfl.sbfl_potential_users',
'       , sbfl.sbfl_potential_groups',
'       , sbfl.sbfl_excluded_users',
'       , null as actions   ',
'       , apex_item.checkbox2(p_idx => 2, p_value => sbfl.sbfl_id, p_attributes => ''data-status="''|| sbfl.sbfl_status ||''" data-prcs="''|| sbfl.sbfl_prcs_id ||''" data-key="''|| sbfl.sbfl_step_key ||''" data-reservation="''|| sbfl.sbfl_reservation ||''"'') a'
||'s checkbox',
'        , case ',
'            when sbfl.sbfl_status = ''error'' then ''fa-redo-arrow''',
'            when sbfl.sbfl_status = ''running'' then ''fa-sign-out''',
'            when sbfl.sbfl_status = ''waiting for timer'' then ''fa-clock-o''',
'          end as quick_action_icon ',
'        , case ',
'            when sbfl.sbfl_status = ''error'' then apex_lang.message(''APP_RESTART_STEP'')',
'            when sbfl.sbfl_status = ''running'' then apex_lang.message(''APP_COMPLETE_STEP'')',
'            when sbfl.sbfl_status = ''waiting for timer'' then apex_lang.message(''APP_RESCHEDULE_TIMER'')',
'          end as quick_action_label ',
'        , case ',
'            when sbfl.sbfl_status = ''error'' then ''restart-step''',
'            when sbfl.sbfl_status = ''running'' then ''complete-step''',
'            when sbfl.sbfl_status = ''waiting for timer'' then ''reschedule-timer''',
'          end as quick_action ',
'        , case when sbfl.sbfl_status = ''waiting for timer'' then '' @ '' || sbfl.timr_start_on at time zone sessiontimezone end as timer_status_info',
'    from flow_subflows_vw sbfl',
'with read only',
';',
'',
'create or replace view flow_p0008_variables_vw',
'as',
'  select apex_item.checkbox( p_idx => 3, p_value => prov_var_name, p_attributes => ''data-prcs="''|| prov_prcs_id || ''"'') as checkbox,',
'       null as action,',
'       prov_prcs_id,',
'       prov_var_name,',
'       prov_var_type,',
'       prov_scope, ',
'       ( select nvl(objt.objt_name, ''Main Diagram'')',
'           from flow_instance_diagrams prdg ',
'         left join flow_objects objt',
'             on prdg.prdg_calling_objt = objt.objt_bpmn_id',
'            and prdg.prdg_calling_dgrm = objt.objt_dgrm_id',
'          where prdg.prdg_diagram_level = prov_scope ',
'            and prdg.prdg_prcs_id =prov_prcs_id) as Calling_object,',
'       case',
'            when prov_var_vc2  is not null then prov_var_vc2',
'            when prov_var_num  is not null then cast(prov_var_num as varchar2(4000))',
'            when prov_var_date is not null then to_char(prov_var_date, v(''APP_DATE_TIME_FORMAT''))',
'            when prov_var_clob is not null then cast(dbms_lob.substr(prov_var_clob, 4000) as  varchar2(4000))',
'            when prov_var_tstz is not null then to_char(prov_var_tstz, ''YYYY-MM-DD HH24:MI:SS TZR'')',
'            when prov_var_json is not null then to_char(prov_var_json)',
'        end as prov_var_value,',
'        case when instr(prov_var_name, '':route'') > 0 then ''true'' else ''false'' end is_gateway_route',
'    from flow_instance_variables_vw',
'with read only;',
'',
'create or replace view flow_p0008_message_subscriptions_vw',
'as',
'   select mes.msub_id,',
'          mes.msub_message_name,',
'          mes.msub_key_name,',
'          mes.msub_key_value,',
'          mes.msub_prcs_id,',
'          mes.msub_payload_var,',
'          mes.msub_created,',
'          null as action',
'     from flow_message_subscriptions_vw mes',
'with read only;',
'create or replace view flow_p0008_vw',
'as',
'  select dgrm_content',
'       , prcs_id',
'       , all_completed',
'       , all_errors',
'       , all_current',
'       , dgrm_id',
'       , calling_dgrm',
'       , calling_objt',
'       , breadcrumb',
'       , drilldown_allowed',
'       , iteration_data',
'       , prdg_id',
'       , prdg_prdg_id',
'       , user_task_urls',
'    from flow_instance_details_vw',
'with read only;',
'',
'create or replace view flow_p0010_instances_vw',
'as',
'   select prcs_id',
'        , prcs_name',
'        , prcs_dgrm_id',
'        , prcs_dgrm_name',
'        , prcs_dgrm_version',
'        , prcs_dgrm_status',
'        , prcs_dgrm_category',
'        , prcs_status',
'        , prcs_dgrm_status_icon',
'        , prcs_priority',
'        , prcs_status_icon',
'        , prcs_due_on',
'        , prcs_init_date',
'        , prcs_last_update',
'        , prcs_business_ref',
'        , null as btn',
'        , apex_item.checkbox2(p_idx => 1, p_value => prcs_id, p_attributes => ''data-prcs = "'' || prcs_id || ''" data-status = "'' || prcs_status ||''"'') as checkbox',
'        , null as quick_action',
'     from ( select prcs_id',
'                 , prcs_name',
'                 , dgrm_id as prcs_dgrm_id',
'                 , dgrm_name as prcs_dgrm_name',
'                 , dgrm_version as prcs_dgrm_version',
'                 , dgrm_status as prcs_dgrm_status',
'                 , case dgrm_status',
'                  when ''draft'' then ''fa fa-wrench''',
'                  when ''released'' then ''fa fa-check''',
'                  when ''deprecated'' then ''fa fa-ban''',
'                  when ''archived'' then ''fa fa-archive''',
'                end as prcs_dgrm_status_icon',
'                 , prcs_priority',
'                 , dgrm_category as prcs_dgrm_category',
'                 , prcs_status',
'                 , prcs_due_on at time zone sessiontimezone as prcs_due_on',
'                 , prcs_init_ts at time zone sessiontimezone as prcs_init_date',
'                 , prcs_last_update at time zone sessiontimezone as prcs_last_update',
'                 , prcs_business_ref',
'                 , case prcs_status',
'                     when ''running'' then ''fa-play-circle-o''',
'                     when ''created'' then ''fa-plus-circle-o''',
'                     when ''completed'' then ''fa-check-circle-o''',
'                     when ''terminated'' then ''fa-stop-circle-o''',
'                     when ''error'' then ''fa-exclamation-circle-o''',
'                   end as prcs_status_icon',
'              from flow_instances_vw',
'          )',
'with read only',
';',
'',
'create or replace view flow_p0010_vw',
'as',
'  select dgrm_content',
'       , prcs_id',
'       , all_completed',
'       , all_errors',
'       , all_current',
'       , dgrm_id',
'       , calling_dgrm',
'       , calling_objt',
'       , breadcrumb',
'       , drilldown_allowed',
'       , prdg_id',
'       , prdg_prdg_id',
'       , user_task_urls',
'       , iteration_data',
'    from flow_instance_details_vw',
'with read only;',
'',
'create or replace view flow_p0013_attributes_vw',
'as',
'   with datas as (',
'      select ',
'         objt_attributes as attributes,',
'         objt_dgrm_id as dgrm_id,',
'         objt_bpmn_id as bpmn_id',
'      from flow_objects',
'      where objt_attributes is not null',
'      union all',
'      select ',
'         conn_attributes as attributes,',
'         conn_dgrm_id as dgrm_id,',
'         conn_bpmn_id as bpmn_id',
'      from flow_connections',
'      where conn_attributes is not null',
'   )',
'   select ',
'      json_query(attributes, ''$'' returning clob pretty) as json_attributes,',
'      dgrm_id,',
'      bpmn_id ',
'   from datas',
'with read only;',
'',
'create or replace view flow_p0013_expressions_vw',
'as',
'  select objt.objt_bpmn_id',
'       , expr.expr_set',
'       , expr.expr_var_name',
'       , expr.expr_var_type',
'       , expr.expr_type',
'       , expr.expr_expression',
'       , objt.objt_dgrm_id',
'       , case when instr(expr.expr_type, ''sql'') > 0 then ''<pre><code class="language-'' || case when instr(expr.expr_type, ''plsql'') > 0 then ''plsql'' else ''sql'' end ||''">'' end as pretag',
'       , case when instr(expr.expr_type, ''sql'') > 0 then ''</code></pre>'' end as posttag',
'    from flow_object_expressions expr',
'    join flow_objects objt',
'      on expr.expr_objt_id = objt.objt_id',
'with read only;',
'',
'create or replace view flow_p0013_instance_log_vw',
'as',
'  select lgpr.lgpr_prcs_id',
'       , lgpr.lgpr_objt_id',
'       , lgpr.lgpr_prcs_name',
'       , lgpr.lgpr_business_id',
'       , lgpr.lgpr_prcs_event',
'       , case lgpr.lgpr_prcs_event',
'           when ''started'' then ''fa-play-circle-o''',
'           when ''running'' then ''fa-play-circle-o''',
'           when ''created'' then ''fa-plus-circle-o''',
'           when ''completed'' then ''fa-check-circle-o''',
'           when ''terminated'' then ''fa-stop-circle-o''',
'           when ''error'' then ''fa-exclamation-circle-o''',
'           when ''reset'' then ''fa-undo''',
'           when ''restart step'' then ''fa-undo''',
'         end as lgpr_prcs_event_icon',
'       , lgpr.lgpr_timestamp at time zone sessiontimezone as lgpr_timestamp',
'       , lgpr.lgpr_user',
'       , lgpr.lgpr_comment',
'       , lgpr_error_info',
'       , case when lgpr_error_info is not null then ''<pre><code class="language-log">'' end as pretag',
'       , case when lgpr_error_info is not null then ''</code></pre>'' end as posttag',
'    from flow_instance_event_log lgpr',
'with read only;',
'',
'create or replace view flow_p0013_step_log_vw',
'as',
'  select lgsf.lgsf_prcs_id',
'       , lgsf.lgsf_objt_id',
'       , lgsf.lgsf_sbfl_id',
'       , lgsf.lgsf_sbfl_process_level',
'       , lgsf.lgsf_last_completed',
'       , lgsf.lgsf_status_when_complete',
'       , lgsf.lgsf_was_current at time zone sessiontimezone as lgsf_was_current',
'       , lgsf.lgsf_started at time zone sessiontimezone as lgsf_started',
'       , lgsf.lgsf_completed at time zone sessiontimezone as lgsf_completed',
'       , lgsf.lgsf_reservation',
'       , lgsf.lgsf_user',
'       , lgsf.lgsf_comment',
'    from flow_step_event_log lgsf',
'with read only;',
'',
'create or replace view flow_p0013_subflows_vw',
'as',
'  select sbfl.sbfl_id',
'       , sbfl.sbfl_prcs_id',
'       , sbfl.sbfl_step_key',
'       , sbfl.sbfl_process_level',
'       , sbfl.sbfl_diagram_level',
'       , sbfl.sbfl_scope',
'       , sbfl.sbfl_last_completed',
'       , sbfl.sbfl_current',
'       , sbfl.sbfl_status',
'       , sbfl.sbfl_became_current at time zone sessiontimezone as sbfl_became_current',
'       , sbfl.sbfl_work_started at time zone sessiontimezone as sbfl_work_started',
'       , sbfl.sbfl_reservation',
'       , sbfl.sbfl_last_update at time zone sessiontimezone as sbfl_last_update',
'    from flow_subflows sbfl',
'with read only;',
'',
'create or replace view flow_p0013_variable_log_vw',
'as',
'  select lgvr_prcs_id',
'       , lgvr_objt_id',
'       , lgvr_var_name',
'       , lgvr_scope',
'       , lgvr_expr_set',
'       , lgvr_timestamp at time zone sessiontimezone as lgvr_timestamp',
'       , lgvr_var_type',
'       , case',
'           when lgvr_var_vc2 is not null then lgvr_var_vc2',
'           when lgvr_var_num is not null then cast (lgvr_var_num as varchar2(4000))',
'           when lgvr_var_date is not null then to_char(lgvr_var_date, v(''APP_DATE_TIME_FORMAT''))',
'           when lgvr_var_tstz is not null then to_char(lgvr_var_tstz, v(''NLS_TIMESTAMP_TZ_FORMAT''))',
'           when lgvr_var_clob is not null then ''[clob]''',
'           when lgvr_var_json is not null then cast(dbms_lob.substr(lgvr_var_json, 4000) as  varchar2(4000))',
'         end as lgvr_value',
'    from flow_variable_event_log',
'with read only;',
'',
'',
'create or replace view flow_p0013_called_diagrams_vw',
'as',
'   select ',
'      prdg.prdg_prdg_id,',
'      prdg.prdg_calling_dgrm,',
'      prdg.prdg_calling_objt,',
'      prdg.prdg_diagram_level,',
'      dgrm.dgrm_name,',
'      dgrm.dgrm_version,',
'      dgrm.dgrm_status,',
'      prdg.prdg_diagram_level as scope',
'   from flow_instance_diagrams prdg',
'   join flow_diagrams dgrm on dgrm.dgrm_id = prdg.prdg_dgrm_id',
'with read only;',
'',
'create or replace view flow_p0014_instance_log_vw',
'as',
'  select lgpr.lgpr_prcs_id',
'       , lgpr.lgpr_objt_id',
'       , lgpr.lgpr_prcs_name',
'       , lgpr.lgpr_business_id',
'       , lgpr.lgpr_prcs_event',
'       , case lgpr.lgpr_prcs_event',
'           when ''started'' then ''fa-play-circle-o''',
'           when ''running'' then ''fa-play-circle-o''',
'           when ''created'' then ''fa-plus-circle-o''',
'           when ''completed'' then ''fa-check-circle-o''',
'           when ''terminated'' then ''fa-stop-circle-o''',
'           when ''error'' then ''fa-exclamation-circle-o''',
'           when ''reset'' then ''fa-undo''',
'           when ''restart step'' then ''fa-undo''',
'           when ''rescheduled'' then ''fa-clock-o''',
'         end as lgpr_prcs_event_icon',
'       , lgpr.lgpr_timestamp at time zone sessiontimezone as lgpr_timestamp',
'       , lgpr.lgpr_user',
'       , lgpr.lgpr_comment',
'       , lgpr_error_info',
'       , case when lgpr_error_info is not null then ''<pre><code class="language-log">'' end as pretag',
'       , case when lgpr_error_info is not null then ''</code></pre>'' end as posttag',
'    from flow_instance_event_log lgpr',
'with read only;',
'',
'create or replace view flow_p0014_step_log_vw',
'as',
'  select distinct lgsf.lgsf_prcs_id',
'                , coalesce(objt.objt_name, lgsf.lgsf_objt_id) as completed_object',
'                , lgsf.lgsf'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10373921319456959)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'_sbfl_id',
'                , lgsf.lgsf_sbfl_process_level',
'                , lgsf.lgsf_last_completed',
'                , lgsf.lgsf_status_when_complete',
'                , lgsf.lgsf_was_current at time zone sessiontimezone as lgsf_was_current',
'                , lgsf.lgsf_started at time zone sessiontimezone as lgsf_started',
'                , lgsf.lgsf_completed at time zone sessiontimezone as lgsf_completed',
'                , lgsf.lgsf_reservation',
'                , lgsf.lgsf_user',
'                , lgsf.lgsf_comment',
'             from flow_step_event_log lgsf',
'             join flow_objects objt',
'               on lgsf.lgsf_objt_id = objt.objt_bpmn_id',
'              and lgsf.lgsf_sbfl_dgrm_id = objt.objt_dgrm_id',
'with read only;',
'',
'create or replace view flow_p0014_subflows_vw',
'as',
'  select distinct sbfl.sbfl_id',
'                , sbfl.sbfl_prcs_id',
'                , sbfl.sbfl_step_key',
'                , sbfl.sbfl_process_level',
'                , sbfl.sbfl_diagram_level',
'                , sbfl.sbfl_scope',
'                , sbfl.sbfl_last_completed',
'                , coalesce(objt.objt_name, sbfl.sbfl_current) as current_object',
'                , sbfl.sbfl_status',
'                , sbfl.sbfl_became_current at time zone sessiontimezone as sbfl_became_current',
'                , sbfl.sbfl_work_started at time zone sessiontimezone as sbfl_work_started',
'                , sbfl.sbfl_reservation',
'                , sbfl.sbfl_last_update at time zone sessiontimezone as sbfl_last_update',
'             from flow_subflows sbfl',
'             join flow_objects objt',
'               on sbfl.sbfl_current = objt.objt_bpmn_id',
'              and sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'with read only;',
'',
'create or replace view flow_p0014_variable_log_vw',
'as',
'  select lgvr_prcs_id',
'       , lgvr_sbfl_id',
'       , lgvr_objt_id',
'       , lgvr_var_name',
'       , lgvr_scope',
'       , lgvr_expr_set',
'       , lgvr_timestamp at time zone sessiontimezone as lgvr_timestamp',
'       , lgvr_var_type',
'       , case',
'           when lgvr_var_vc2 is not null then lgvr_var_vc2',
'           when lgvr_var_num is not null then cast(lgvr_var_num as varchar2(4000))',
'           when lgvr_var_date is not null then cast(lgvr_var_date as varchar2(4000))',
'           when lgvr_var_clob is not null then ''[clob]''',
'           when lgvr_var_json is not null then cast(dbms_lob.substr(lgvr_var_json, 4000) as  varchar2(4000))',
'         end as lgvr_value',
'    from flow_variable_event_log',
'with read only;',
'',
'create or replace view flow_p0020_instance_timeline_vw as',
'select prcs_id',
'     , to_char(performed_on, ''YYYY-MM-DD HH24:MI:SSXFF TZR'') event_date',
'     , lower(performed_by) user_name',
'     , case operation',
'        when ''variable set'' then ''Variable "''||proc_var||''" set to "''||value||''".''',
'        when ''step current'' then ''Step ''||objt||'' became Current''',
'        when ''step started'' then ''Step ''||objt||'' started work''',
'        when ''step completed'' then ''Step ''||objt||'' completed''',
'        when ''created'' then ''Process Instance Created''',
'        when ''started'' then ''Process Instance Started''',
'        else description',
'       end as event_title',
'     , operation as event_type',
'     , case operation',
'        when ''step current'' then ''is-new''',
'        when ''step started'' then ''is-updated''',
'        when ''step completed'' then ''is-new''',
'        when ''completed'' then ''is-removed''',
'        when ''started'' then ''is-new''',
'        when ''created'' then ''is-new''',
'        when ''reset'' then ''is-removed''',
'        when ''error'' then ''is-removed''',
'        when ''variable set'' then ''is-updated''',
'        when ''Gateway Processed'' then ''is-updated''',
'        when ''start called model'' then ''is-new''',
'        when ''finish called model'' then ''is-new''',
'       end as event_status',
'     , case operation',
unistr('        when ''step current'' then ''subflow ''||subflow|| '' \2022 process level ''||process_level||nvl2(value,'' \2022 previous step  ''||value,'''')'),
unistr('        when ''step started'' then ''subflow ''||subflow|| nvl2(value,'' \2022 reserved by ''||value,'' \2022 not reserved'')'),
'        when ''step completed'' then null',
unistr('        when ''created'' then ''process ''||prcs_id||nvl2(value,'' \2022 name ''||value,'''')'),
unistr('        when ''started'' then ''process ''||prcs_id||nvl2(value,'' \2022 name ''||value,'''')    '),
'        when ''variable set'' then ',
'                  nvl2(objt,''step ''||objt||'' '','''')',
unistr('                ||nvl2(subflow,''\2022 subflow ''||subflow||'' '','''')'),
unistr('                ||nvl2(event_comment,''\2022 expression set ''||event_comment,'''')'),
unistr('        when ''Gateway Processed'' then ''subflow ''||subflow||'' \2022 forward paths - ''||event_comment'),
'        when ''start called model'' then event_comment',
'        when ''finish called model'' then event_comment',
unistr('        else ''Object ''||objt||''  subflow '' ||subflow||'' \2022 variable ''||proc_var||'' \2022 value ''||value        '),
'       end as event_desc',
'     , ''u-color-44 fa fa-clock-o'' as USER_COLOR',
'     , case operation',
'        when ''step current'' then ''fa fa-circle-o''',
'        when ''step started'' then ''fa fa-play-circle-o''',
'        when ''step completed'' then ''fa fa-check-circle-o''',
'        when ''completed'' then ''fa fa-dot-circle-o''',
'        when ''started'' then ''fa fa-circle-o''',
'        when ''created'' then ''fa fa-server-new''',
'        when ''reset'' then ''fa fa-fast-backward''',
'        when ''error'' then ''fa fa-exclamation-circle''',
'        when ''variable set'' then ''fa fa-window-terminal''',
'        when ''Gateway Processed'' then ''fa fa-index''   ',
'        when ''start called model'' then ''fa fa-box-arrow-in-south''',
'        when ''finish called model'' then ''fa fa-box-arrow-out-north''',
'       end as event_icon',
'     , operation',
'     , objt',
'     , proc_var',
'     , value',
'     , subflow',
'     , process_level',
'     , performed_by',
'from flow_instance_timeline_vw;',
''))
);
null;
end;
/
prompt --application/deployment/install/install_packages_bodies
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Packages Bodies'
,p_sequence=>40
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'create or replace package body flow_proc_vars_int',
'as',
'',
'/* ',
'-- Flows for APEX - flow_proc_vars_int.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created    12-Apr-2022  Richard Allen (Oracle)',
'-- Modified   11-Aug-2022  Moritz Klein (MT AG)',
'-- Modified   11-jan-2024  Richard Allen (Flowquest Consulting Ltd)',
'--',
'*/',
'',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'function scope_is_valid',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_scope   in flow_subflows.sbfl_scope%type',
') return boolean',
'is ',
'  l_count number;',
'begin',
'  -- first check if the scope is valid from a call activity',
'  select count(prdg_id)',
'    into l_count',
'    from flow_instance_diagrams',
'   where prdg_prcs_id = pi_prcs_id',
'     and prdg_diagram_level = pi_scope;',
'  -- if not, check if it comes from an iteration',
'  -- initially check by seeing if a variable already exists in the scope',
'  -- replace this later with a check on the iteration scopes',
'  if l_count = 0 then ',
'    select count (prov_var_name)',
'      into l_count',
'      from flow_process_variables',
'     where prov_prcs_id = pi_prcs_id',
'       and prov_scope   = pi_scope;',
'  end if;',
'  return (l_count > 0);',
'end;',
'',
'-- set_var signature 1 - set varchar2',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_vc2_value    in flow_process_variables.prov_var_vc2%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
')',
'is ',
'  l_action  varchar2(20);',
'begin',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_vc2',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_name',
'      , flow_constants_pkg.gc_prov_var_type_varchar2 ',
'      , pi_vc2_value',
'      );      ',
'  exception',
'    when dup_val_on_index then',
'      l_action := ''var-update-error'';',
'      update flow_process_variables prov ',
'         set prov.prov_var_vc2          = pi_vc2_value',
'       where prov.prov_prcs_id          = pi_prcs_id',
'         and prov.prov_scope            = pi_scope',
'         and upper(prov.prov_var_name)  = upper(pi_var_name)',
'         and prov.prov_var_type         = flow_constants_pkg.gc_prov_var_type_varchar2 ',
'           ;',
'    when others',
'    then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => flow_constants_pkg.gc_prov_var_type_varchar2 ',
'  , p_var_vc2           => pi_vc2_value',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'    -- $F4AMESSAGE ''var-update-error'' || ''Error updating process variable %0 for process id %1 in scope %2.''   ',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_num_value in flow_process_variables.prov_var_num%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set in flow_object_expressions.expr_set%type default null',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_action  varchar2(20);',
'begin ',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_num',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_name',
'      , flow_constants_pkg.gc_prov_var_type_number',
'      , pi_num_value',
'      );',
'  exception',
'    when dup_val_on_index then',
'      l_action := ''var-update-error'';',
'      update flow_process_variables prov ',
'         set prov.prov_var_num          = pi_num_value',
'       where prov.prov_prcs_id          = pi_prcs_id',
'         and prov.prov_scope            = pi_scope',
'         and upper(prov.prov_var_name)  = upper(pi_var_name)',
'         and prov.prov_var_type         = flow_constants_pkg.gc_prov_var_type_number',
'           ;',
'    when others then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => flow_constants_pkg.gc_prov_var_type_number',
'  , p_var_num           => pi_num_value',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action         ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'    -- $F4AMESSAGE ''var-update-error'' || ''Error updating process variable %0 for process id %1 in scope %2.''   ',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_date_value in flow_process_variables.prov_var_date%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set in flow_object_expressions.expr_set%type default null',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_action  varchar2(20);',
'begin ',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_date',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_name',
'      , flow_constants_pkg.gc_prov_var_type_date',
'      , pi_date_value',
'      );',
'  exception',
'    when dup_val_on_index then',
'      l_action := ''var-update-error'';',
'      update flow_process_variables prov ',
'         set prov.prov_var_date         = pi_date_value',
'       where prov.prov_prcs_id          = pi_prcs_id',
'         and prov.prov_scope            = pi_scope',
'         and upper(prov.prov_var_name)  = upper(pi_var_name)',
'         and prov.prov_var_type         = flow_constants_pkg.gc_prov_var_type_date',
'           ;',
'    when others',
'    then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => flow_constants_pkg.gc_prov_var_type_date ',
'  , p_var_date          => pi_date_value',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action         ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'    -- $F4AMESSAGE ''var-update-error'' || ''Error updating process variable %0 for process id %1 in scope %2.''   ',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_clob_value in flow_process_variables.prov_var_clob%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set in flow_object_expressions.expr_set%type default null',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_action  varchar2(20);',
'begin ',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_clob',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_name',
'      , flow_constants_pkg.gc_prov_var_type_clob',
'      , pi_clob_value',
'      );',
'  exception',
'    when dup_val_on_index then',
'      update flow_process_variables prov ',
'         set prov.prov_var_clob          = pi_clob_value',
'       where prov.prov_prcs_id           = pi_prcs_id',
'         and prov.prov_scope             = pi_scope',
'         and upper(prov.prov_var_name)   = upper(pi_var_name)',
'         and prov.prov_var_type          = flow_constants_pkg.gc_prov_var_type_clob',
'           ;',
'    when others then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => flow_constants_pkg.gc_prov_var_type_clob ',
'  , p_var_clob           => pi_clob_value',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action         ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_tstz_value in flow_process_variables.prov_var_tstz%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set in flow_object_expressions.expr_set%type default null',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_action  varchar2(20);',
'begin ',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_tstz',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_name',
'      , flow_constants_pkg.gc_prov_var_type_tstz',
'      , pi_tstz_value',
'      );',
'  exception',
'    when dup_val_on_index then',
'      l_action := ''var-update-error'';',
'      update flow_process_variables prov ',
'         set prov.prov_var_tstz         = pi_tstz_value',
'       where prov.prov_prcs_id          = pi_prcs_id',
'         and prov.prov_scope            = pi_scope',
'         and upper(prov.prov_var_name)  = upper(pi_var_name)',
'         and prov.prov_var_type         = flow_constants_pkg.gc_prov_var_type_tstz',
'           ;',
'    when others',
'    then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => flow_constants_pkg.gc_prov_var_type_tstz ',
'  , p_var_tstz          => pi_tstz_value',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action         ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'    -- $F4AMESSAGE ''var-update-error'' || ''Error updating process variable %0 for process id %1 in scope %2.''   ',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_json_value   in flow_process_variables.prov_var_json%type',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_action  varchar2(20);',
'begin ',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_json',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_name',
'      , flow_constants_pkg.gc_prov_var_type_json',
'      , pi_json_value',
'      );',
'  exception',
'    when dup_val_on_index then',
'      l_action := ''var-update-error'';',
'      update flow_process_variables prov ',
'         set prov.prov_var_json         = pi_json_value',
'       where prov.prov_prcs_id          = pi_prcs_id',
'         and prov.prov_scope            = pi_scope',
'         and upper(prov.prov_var_name)  = upper(pi_var_name)',
'         and prov.prov_var_type         = flow_constants_pkg.gc_prov_var_type_json',
'           ;',
'    when others',
'    then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => flow_constants_pkg.gc_prov_var_type_json ',
'  , p_var_json          => pi_json_value',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action         ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'    -- $F4AMESSAGE ''var-update-error'' || ''Error updating process variable %0 for process id %1 in scope %2.''   ',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id      in flow_processes.prcs_id%type',
', pi_var_name     in flow_process_variables.prov_var_name%type',
', pi_json_element in sys.json_element_t',
', pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set     in flow_object_expressions.expr_set%type default null',
', pi_scope        in flow_process_variables.prov_scope%type default 0',
')',
'is',
'  l_json_val      clob;',
'begin ',
'  l_json_val := pi_json_element.to_clob;',
'',
'  set_var',
'  ( pi_prcs_id      => pi_prcs_id ',
'  , pi_var_name     => pi_var_name',
'  , pi_json_value   => l_json_val',
'  , pi_sbfl_id      => pi_sbfl_id',
'  , pi_objt_bpmn_id => pi_objt_bpmn_id',
'  , pi_expr_set     => pi_expr_set',
'  , pi_scope        => pi_scope ',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => ''var-set-error''         ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'end set_var;',
'',
'procedure set_var',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_value in t_proc_var_value',
', pi_sbfl_id in flow_subflows.sbfl_id%type default null',
', pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
', pi_expr_set in flow_object_expressions.expr_set%type default null',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_action  varchar2(20);',
'begin ',
'  begin',
'      insert into flow_process_variables ',
'      ( prov_prcs_id',
'      , prov_scope',
'      , prov_var_name',
'      , prov_var_type',
'      , prov_var_vc2',
'      , prov_var_num',
'      , prov_var_date',
'      , prov_var_tstz',
'      , prov_var_clob',
'      , prov_var_json',
'      ) values',
'      ( pi_prcs_id',
'      , pi_scope',
'      , pi_var_value.var_name',
'      , pi_var_value.var_type',
'      , pi_var_value.var_vc2',
'      , pi_var_value.var_num',
'      , pi_var_value.var_date',
'      , pi_var_value.var_tstz',
'      , pi_var_value.var_clob',
'      , pi_var_value.var_json',
'      );',
'  exception',
'    when dup_val_on_index then',
'      update flow_process_variables prov ',
'         set prov.prov_var_type          = pi_var_value.var_type',
'           , prov.prov_var_vc2           = pi_var_value.var_vc2',
'           , prov.prov_var_num           = pi_var_value.var_num',
'           , prov.prov_var_date          = pi_var_value.var_date',
'           , prov.prov_var_clob          = pi_var_value.var_clob',
'           , prov.prov_var_tstz          = pi_var_value.var_tstz',
'       where prov.prov_prcs_id           = pi_prcs_id',
'         and prov.prov_scope             = pi_scope',
'         and upper(prov.prov_var_name)   = upper(pi_var_value.var_name)',
'      ;',
'    when others then',
'      l_action := ''var-set-error'';',
'      raise;',
'  end;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope',
'  , p_var_name          => pi_var_value.var_name',
'  , p_objt_bpmn_id      => pi_objt_bpmn_id',
'  , p_subflow_id        => pi_sbfl_id',
'  , p_expr_set          => pi_expr_set',
'  , p_var_type          => pi_var_value.var_type ',
'  , p_var_vc2           => pi_var_value.var_vc2',
'  , p_var_num           => pi_var_value.var_num',
'  , p_var_date          => pi_var_value.var_date',
'  , p_var_clob          => pi_var_value.var_clob',
'  , p_var_tstz          => pi_var_value.var_tstz',
'  , p_var_json          => pi_var_value.var_json',
'  );',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_message_key    => l_action         ',
'    , p0 => pi_var_value.var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-set-error'' || ''Error setting process variable %0 for process id %1 in scope %2.''',
'end set_var;',
'',
'-- getters return',
'',
'function get_var_vc2',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_vc2%type',
'is ',
'   po_vc2_value  flow_process_variables.prov_var_vc2%type;',
'begin ',
'   select prov.prov_var_vc2',
'     into po_vc2_value',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return po_vc2_value;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'    -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_vc2;',
'',
'function get_var_num',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_num%type',
'is ',
'   po_num_value  flow_process_variables.prov_var_num%type;',
'begin ',
'   select prov.prov_var_num',
'     into po_num_value',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return po_num_value;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_num;',
'',
'function get_var_date',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_date%type',
'is ',
'   po_date_value  flow_process_variables.prov_var_date%type;',
'begin ',
'   select prov.prov_var_date',
'     into po_date_value',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return po_date_value;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_date;',
'',
'function get_var_clob',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_clob%type',
'is ',
'   po_clob_value  flow_process_variables.prov_var_clob%type;',
'begin ',
'   select prov.prov_var_clob',
'     into po_clob_value',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return po_clob_value;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_clob;',
'',
'function get_var_tstz',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_tstz%type',
'is ',
'   po_tstz_value  flow_process_variables.prov_var_tstz%type;',
'begin ',
'   select prov.prov_var_tstz',
'     into po_tstz_value',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return po_tstz_value;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_tstz;',
'',
'function get_var_json',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_json%type',
'is ',
'   po_json_value  flow_process_variables.prov_var_json%type;',
'begin ',
'   select prov.prov_var_json',
'     into po_json_value',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return po_json_value;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_json;',
'',
'function get_var_json_element',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return sys.json_element_t',
'is ',
'   l_json_value   flow_process_variables.prov_var_json%type;',
'begin ',
'   l_json_value := get_var_json ( pi_prcs_id            => pi_prcs_id',
'                                , pi_var_name           => pi_var_name',
'                                , pi_scope              => pi_scope',
'                                , pi_exception_on_null  => pi_exception_on_null',
'                                );',
'   return sys.json_element_t.parse(l_json_value);',
'end get_var_json_element;',
'',
'function get_var_value',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return t_proc_var_value',
'is ',
'   l_value_rec  t_proc_var_value;',
'begin ',
'   select prov.prov_var_name',
'        , prov.prov_var_type',
'        , prov.prov_var_vc2',
'        , prov.prov_var_num',
'        , prov.prov_var_date',
'        , prov.prov_var_clob',
'        , prov.prov_var_tstz',
'        , prov.prov_var_json',
'     into l_value_rec',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id         = pi_prcs_id',
'      and prov.prov_scope           = pi_scope',
'      and upper(prov.prov_var_name) = upper(pi_var_name)',
'        ;',
'   return l_value_rec;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_value;',
'',
'-- get type of a variable',
'',
'function get_var_type',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_type%type',
'is ',
'   l_var_type  flow_process_variables.prov_var_clob%type;',
'begin ',
'   select prov.prov_var_type',
'     into l_var_type',
'     from flow_process_variables prov',
'    where prov.prov_prcs_id           = pi_prcs_id',
'      and prov.prov_scope             = pi_scope',
'      and upper(prov.prov_var_name)   = upper(pi_var_name)',
'        ;',
'   return l_var_type;',
'exception',
'  when no_data_found then',
'    if pi_exception_on_null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-get-error''      ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-get-error'' || ''Error getting process variable %0 for process id %1 with scope %2.''',
'      raise;',
'    else',
'      return null;',
'    end if;',
'end get_var_type;',
'',
'-- delete a variable',
'',
'procedure delete_var ',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is',
'  l_var_type   flow_process_variables.prov_var_type%type;',
'begin ',
'  select prov_var_type',
'    into l_var_type',
'    from flow_process_variables prov',
'   where prov.prov_prcs_id          = pi_prcs_id',
'     and prov.prov_scope            = pi_scope',
'     and upper(prov.prov_var_name)  = upper(pi_var_name)',
'     for update wait 2;',
'',
'  delete ',
'    from flow_process_variables prov',
'   where prov.prov_prcs_id          = pi_prcs_id',
'     and prov.prov_scope            = pi_scope',
'     and upper(prov.prov_var_name)  = upper(pi_var_name)',
'  ;',
'  flow_logging.log_variable_event',
'  ( p_process_id        => pi_prcs_id',
'  , p_scope             => pi_scope               ',
'  , p_var_name          => pi_var_name',
'  , p_var_type          => l_var_type',
'  );',
'exception',
'  when no_data_found then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''var-delete-error''        ',
'      , p0 => pi_var_name',
'      , p1 => pi_prcs_id',
'      , p2 => pi_scope',
'      );',
'      -- $F4AMESSAGE ''var-delete-error'' || ''Error deletin'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'g process variable %0 for process id %1 with scope %2.''',
'  when lock_timeout then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_message_key    => ''var-lock-error''       ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-lock-error'' || ''Error locking process variable %0 for process id %1.''',
'end delete_var;',
'',
'-- special cases / built-in standard variables',
'',
'  procedure set_business_ref',
'  ( pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_vc2_value in flow_process_variables.prov_var_vc2%type',
'  , pi_scope in flow_subflows.sbfl_scope%type default 0',
'  , pi_sbfl_id in flow_subflows.sbfl_id%type default null',
'  , pi_objt_bpmn_id in flow_objects.objt_bpmn_id%type default null ',
'  , pi_expr_set in flow_object_expressions.expr_set%type default null',
'  )',
'  is',
'  begin',
'    flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_scope        => pi_scope ',
'    , pi_var_name     => flow_constants_pkg.gc_prov_builtin_business_ref',
'    , pi_vc2_value    => pi_vc2_value',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => pi_objt_bpmn_id',
'    , pi_expr_set     => pi_expr_set',
'    );',
'  end set_business_ref;',
'',
'  function get_business_ref',
'  ( pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_scope   in flow_subflows.sbfl_scope%type default 0',
'  )',
'  return flow_process_variables.prov_var_vc2%type',
'  is ',
'  begin',
'    return get_var_vc2 ',
'           ( pi_prcs_id  => pi_prcs_id',
'           , pi_var_name => flow_constants_pkg.gc_prov_builtin_business_ref',
'           , pi_scope    => pi_scope',
'           );',
'  end get_business_ref;',
'',
'function lock_var ',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
') return boolean',
'is',
'  l_is_locked   boolean;',
'  l_prcs_id     flow_processes.prcs_id%type;',
'begin',
'  select prov_prcs_id',
'    into l_prcs_id',
'    from flow_process_variables',
'   where prov_prcs_id  = pi_prcs_id',
'     and upper(prov_var_name)  = upper(pi_var_name)',
'     and prov_scope    = pi_scope',
'  for update of prov_var_type wait 2;',
'  return true;',
'exception',
'  when  others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_message_key    => ''var-lock-error''       ',
'    , p0 => pi_var_name',
'    , p1 => pi_prcs_id',
'    , p2 => pi_scope',
'    );',
'    -- $F4AMESSAGE ''var-lock-error'' || ''Error locking process variable %0 for process id %1.''',
'    return false;',
'end lock_var;',
'',
'  procedure set_vars_from_json_object',
'  ( pi_prcs_id      in  flow_processes.prcs_id%type',
'  , pi_sbfl_id      in  flow_subflows.sbfl_id%type default null',
'  , pi_scope        in  flow_subflows.sbfl_scope%type default 0',
'  , pi_json         in  sys.json_object_t',
'  , pi_objt_bpmn_id in  flow_objects.objt_bpmn_id%type default null',
'  )',
'  is',
'    l_key               varchar2(4000);',
'    l_keys              json_key_list;',
'    l_element_type      varchar2(50);',
'    l_var               t_proc_var_value;',
'  begin',
'    l_keys := pi_json.get_keys;',
'',
'    for i in 1..l_keys.count loop',
'      l_var             := t_proc_var_value();',
'',
'      l_var.var_name     := l_keys(i);',
'',
'      l_element_type := pi_json.get_type(l_keys(i));',
'',
'      apex_debug.info',
'      ( p_message => ''Creating proc var name %0 Json type %1''',
'      , p0        => l_var.var_name',
'      , p1        => l_element_type',
'      );',
'',
'      case l_element_type',
'      when ''SCALAR'' then ',
'        case ',
'        when pi_json.get(l_keys(i)).is_string then',
'          l_var.var_type  := flow_constants_pkg.gc_prov_var_type_varchar2;',
'          l_var.var_vc2   := pi_json.get_string(l_keys(i));',
'        when pi_json.get(l_keys(i)).is_number then',
'          l_var.var_type  := flow_constants_pkg.gc_prov_var_type_number;',
'          l_var.var_num   := pi_json.get_number(l_keys(i));      ',
'        when pi_json.get(l_keys(i)).is_date then',
'          l_var.var_type  := flow_constants_pkg.gc_prov_var_type_date;',
'          l_var.var_date  := pi_json.get_date(l_keys(i));  ',
'        when pi_json.get(l_keys(i)).is_timestamp then',
'          l_var.var_type  := flow_constants_pkg.gc_prov_var_type_tstz;',
'          l_var.var_tstz  := pi_json.get_timestamp(l_keys(i));  ',
'        when  pi_json.get(l_keys(i)).is_null then',
'          apex_debug.info (p_message => ''Element name %0 is null - not creating proc var'', p0 => l_var.var_name);',
'          continue;',
'        end case;',
'      when ''OBJECT'' then',
'          l_var.var_type  := flow_constants_pkg.gc_prov_var_type_json;',
'          l_var.var_json  := pi_json.get_object(l_keys(i)).to_clob;',
'      when ''ARRAY'' then',
'          l_var.var_type  := flow_constants_pkg.gc_prov_var_type_json;',
'          l_var.var_json   := pi_json.get_array(l_keys(i)).to_clob;',
'      end case;',
'',
'      apex_debug.info',
'      ( p_message => ''Creating proc var name %0 Proc var type %1''',
'      , p0        => l_var.var_name',
'      , p1        => l_var.var_type',
'      );',
'      ',
'      set_var ',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_value    => l_var',
'      , pi_sbfl_id      => pi_sbfl_id',
'      , pi_objt_bpmn_id => pi_objt_bpmn_id',
'      , pi_expr_set     => ''Iteration ''|| to_char(i,''9999'')',
'      , pi_scope        => pi_scope',
'      );',
'    end loop;',
'  end set_vars_from_json_object;',
'',
'-- group delete for all vars in a process (used at process deletion, process reset)',
'',
'  procedure delete_all_for_process',
'  ( pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_retain_builtins in boolean default false',
'  )',
'  is',
'  begin',
'    if pi_retain_builtins then ',
'      delete',
'        from flow_process_variables prov',
'       where prov.prov_prcs_id = pi_prcs_id',
'         and prov.prov_var_name not in ( flow_constants_pkg.gc_prov_builtin_business_ref )',
'      ;',
'    else',
'      delete',
'        from flow_process_variables prov',
'       where prov.prov_prcs_id = pi_prcs_id',
'      ;',
'    end if;',
'  end delete_all_for_process;',
'',
'  procedure do_substitution',
'  (',
'    pi_prcs_id  in flow_processes.prcs_id%type',
'  , pi_sbfl_id  in flow_subflows.sbfl_id%type',
'  , pi_scope    in flow_subflows.sbfl_scope%type',
'  , pi_step_key in flow_subflows.sbfl_step_key%type default null',
'  , pio_string  in out nocopy varchar2',
'  )',
'  as',
'    l_f4a_substitutions apex_t_varchar2;',
'    l_replacement_value flow_types_pkg.t_bpmn_attribute_vc2;',
'  ',
'    function get_replacement_pattern',
'    (',
'      pi_substitution_variable in varchar2',
'    ) return varchar2',
'    as',
'    begin',
'      return',
'        flow_constants_pkg.gc_substitution_prefix || flow_constants_pkg.gc_substitution_flow_identifier || ',
'        pi_substitution_variable || flow_constants_pkg.gc_substitution_postfix',
'      ;',
'    end get_replacement_pattern;',
'  begin',
'    l_f4a_substitutions :=',
'      apex_string.grep',
'      (',
'        p_str           => pio_string',
'      , p_pattern       => flow_constants_pkg.gc_substitution_pattern',
'      , p_modifier      => ''i''',
'      , p_subexpression => ''1''',
'      )',
'    ;',
'    if l_f4a_substitutions is not null then',
'      for i in 1..l_f4a_substitutions.count',
'      loop',
'        case upper(l_f4a_substitutions(i))',
'          when flow_constants_pkg.gc_substitution_process_id then',
'            pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), pi_prcs_id );',
'          when flow_constants_pkg.gc_substitution_subflow_id then',
'            pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), pi_sbfl_id );',
'          when flow_constants_pkg.gc_substitution_step_key then',
'            pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), pi_step_key );',
'          when flow_constants_pkg.gc_substitution_process_priority then',
'            pio_string := replace ( pio_string',
'                                  , get_replacement_pattern( l_f4a_substitutions(i) )',
'                                  , flow_instances.priority (p_process_id => pi_prcs_id)',
'                                  );',
'          else',
'            -- own implementation of get_vc_var',
'            -- Reason:',
'            -- The general implementation immediately adds to APEX error stack',
'            begin',
'              select prov.prov_var_vc2',
'                into l_replacement_value',
'                from flow_process_variables prov',
'               where prov.prov_prcs_id          = pi_prcs_id',
'                 and prov.prov_scope            = pi_scope',
'                 and upper(prov.prov_var_name)  = upper(l_f4a_substitutions(i))',
'              ;',
'              pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), l_replacement_value );',
'            exception',
'              when no_data_found then',
'                -- no data found will be ignored',
'                -- do like APEX and leave original in place',
'                null;',
'            end;',
'        end case;',
'      end loop;',
'    end if;',
'  end do_substitution;',
'',
'  procedure do_substitution',
'  (',
'    pi_prcs_id  in flow_processes.prcs_id%type',
'  , pi_sbfl_id  in flow_subflows.sbfl_id%type default null',
'  , pi_scope    in flow_subflows.sbfl_scope%type',
'  , pi_step_key in flow_subflows.sbfl_step_key%type default null',
'  , pio_string  in out nocopy clob',
'  )',
'  as',
'    l_f4a_substitutions apex_t_varchar2;',
'    l_replacement_value flow_types_pkg.t_bpmn_attribute_vc2;',
'  ',
'    function get_replacement_pattern',
'    (',
'      pi_substitution_variable in varchar2',
'    ) return varchar2',
'    as',
'    begin',
'      return',
'        flow_constants_pkg.gc_substitution_prefix || flow_constants_pkg.gc_substitution_flow_identifier || ',
'        pi_substitution_variable || flow_constants_pkg.gc_substitution_postfix',
'      ;',
'    end get_replacement_pattern;',
'  begin',
'    l_f4a_substitutions :=',
'      apex_string.grep',
'      (',
'        p_str           => pio_string',
'      , p_pattern       => flow_constants_pkg.gc_substitution_pattern',
'      , p_modifier      => ''i''',
'      , p_subexpression => ''1''',
'      )',
'    ;',
'    if l_f4a_substitutions is not null then',
'      for i in 1..l_f4a_substitutions.count',
'      loop',
'        case upper(l_f4a_substitutions(i))',
'          when flow_constants_pkg.gc_substitution_process_id then',
'            pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), pi_prcs_id );',
'          when flow_constants_pkg.gc_substitution_subflow_id then',
'            pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), pi_sbfl_id );',
'          when flow_constants_pkg.gc_substitution_step_key then',
'            pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), pi_step_key );',
'          when flow_constants_pkg.gc_substitution_process_priority then',
'            pio_string := replace ( pio_string',
'                                  , get_replacement_pattern( l_f4a_substitutions(i) )',
'                                  , flow_instances.priority (p_process_id => pi_prcs_id)',
'                                  );',
'          else',
'            l_replacement_value :=',
'              get_var_as_vc2',
'              (',
'                pi_prcs_id           => pi_prcs_id',
'              , pi_var_name          => l_f4a_substitutions(i)',
'              , pi_scope             => pi_scope',
'              , pi_exception_on_null => false',
'              );',
'            if l_replacement_value is not null then',
'              pio_string := replace( pio_string, get_replacement_pattern( l_f4a_substitutions(i) ), l_replacement_value );',
'            end if;',
'        end case;',
'      end loop;',
'    end if;',
'  end do_substitution;',
'',
'/*',
'  procedure get_var_as_parameter',
'  (',
'    pi_prcs_id            in flow_process_variables.prov_prcs_id%type',
'  , pi_var_name           in flow_process_variables.prov_var_name%type',
'  , pi_scope              in flow_process_variables.prov_scope%type',
'  , pi_exception_on_null  in boolean default true',
'  , po_data_type         out apex_exec.t_data_type',
'  , po_value             out apex_exec.t_value',
'  )',
'  as',
'  begin',
'    select case prov.prov_var_type',
'             when flow_constants_pkg.gc_prov_var_type_varchar2 then 1',
'             when flow_constants_pkg.gc_prov_var_type_number   then 2',
'             when flow_constants_pkg.gc_prov_var_type_date     then 3',
'             when flow_constants_pkg.gc_prov_var_type_clob     then 11',
'             when flow_constants_pkg.gc_prov_var_type_tstz     then 5',
'             else 1',
'           end as data_type',
'         , prov.prov_var_vc2',
'         , prov.prov_var_num',
'         , prov.prov_var_date',
'         , prov.prov_var_clob',
'      into po_data_type',
'         , po_value.varchar2_value',
'         , po_value.number_value',
'         , po_value.date_value',
'         , po_value.clob_value',
'      from flow_process_variables prov',
'     where prov.prov_prcs_id    = pi_prcs_id',
'       and prov.prov_scope      = pi_scope',
'       and upper(prov_var_name) = upper(pi_var_name)',
'    ;',
'  exception',
'    when no_data_found then',
'      if pi_exception_on_null then',
'        flow_errors.handle_instance_error',
'        ( ',
'          pi_prcs_id     => pi_prcs_id',
'        , pi_message_key => ''var-get-error''      ',
'        , p0             => pi_var_name',
'        , p1             => pi_prcs_id',
'        , p2             => pi_scope',
'        );',
'      end if;',
'  end get_var_as_parameter;',
'  */',
'',
'  function get_var_as_parameter',
'  (',
'    pi_prcs_id            in flow_process_variables.prov_prcs_id%type',
'  , pi_var_name           in flow_process_variables.prov_var_name%type',
'  , pi_scope              in flow_process_variables.prov_scope%type',
'  , pi_exception_on_null  in boolean default true',
'  ) return apex_exec.t_parameter ',
'  is ',
'    l_parameter          apex_exec.t_parameter := apex_exec.t_parameter();',
'  begin',
'    begin',
'      select case prov.prov_var_type',
'               when flow_constants_pkg.gc_prov_var_type_varchar2 then apex_exec.c_data_type_varchar2',
'               when flow_constants_pkg.gc_prov_var_type_number   then apex_exec.c_data_type_number',
'               when flow_constants_pkg.gc_prov_var_type_date     then apex_exec.c_data_type_date',
'               when flow_constants_pkg.gc_prov_var_type_tstz     then apex_exec.c_data_type_timestamp_tz',
'               when flow_constants_pkg.gc_prov_var_type_clob     then apex_exec.c_data_type_clob',
'               when flow_constants_pkg.gc_prov_var_type_json     then apex_exec.c_data_type_json',
'               else 1',
'             end as data_type',
'           , prov.prov_var_vc2',
'           , prov.prov_var_num',
'           , prov.prov_var_date',
'           , prov.prov_var_tstz',
'           , case prov.prov_var_type',
'               when flow_constants_pkg.gc_prov_var_type_clob     then prov.prov_var_clob',
'               when flow_constants_pkg.gc_prov_var_type_json     then prov.prov_var_json',
'               else null',
'             end ',
'           , upper(prov.prov_var_name)',
'        into l_parameter.data_type',
'           , l_parameter.value.varchar2_value',
'           , l_parameter.value.number_value',
'           , l_parameter.value.date_value',
'           , l_parameter.value.timestamp_tz_value',
'           , l_parameter.value.clob_value',
'           , l_parameter.name',
'        from flow_process_variables prov',
'       where prov.prov_prcs_id    = pi_prcs_id',
'         and prov.prov_scope      = pi_scope',
'         and upper(prov_var_name) = upper(pi_var_name)',
'      ;',
'    exception',
'      when no_data_found then',
'        if pi_exception_on_null then',
'          flow_errors.handle_instance_error',
'          ( ',
'            pi_prcs_id     => pi_prcs_id',
'          , pi_message_key => ''var-get-error''      ',
'          , p0             => pi_var_name',
'          , p1             => pi_prcs_id',
'          , p2             => pi_scope',
'          );',
'        end if;',
'    end;',
'    return l_parameter;',
'  end get_var_as_parameter;',
'',
'  function get_var_as_vc2',
'  (',
'    pi_prcs_id           in flow_process_variables.prov_prcs_id%type',
'  , pi_var_name          in flow_process_variables.prov_var_name%type',
'  , pi_scope             in flow_process_variables.prov_scope%type',
'  , pi_exception_on_null in boolean default true',
'  ) return varchar2',
'  as',
'    l_return flow_process_variables.prov_var_vc2%type;',
'  begin',
'    select case prov.prov_var_type',
'             when flow_constants_pkg.gc_prov_var_type_varchar2 then prov.prov_var_vc2',
'             when flow_constants_pkg.gc_prov_var_type_number   then to_char(prov.prov_var_num)',
'             when flow_constants_pkg.gc_prov_var_type_date     then to_char(prov.prov_var_date, flow_constants_pkg.gc_prov_default_date_format)',
'             when flow_constants_pkg.gc_prov_var_type_tstz     then to_char(prov.prov_var_tstz, flow_constants_pkg.gc_prov_default_tstz_format)',
'             else null',
'           end as prov_var_value',
'      into l_return',
'      from flow_process_variables prov',
'     where prov.prov_prcs_id    = pi_prcs_id',
'       and prov.prov_scope      = pi_scope',
'       and upper(prov_var_name) = upper(pi_var_name)',
'    ;',
'',
'    return l_return;',
'  exception',
'    when no_data_found then',
'      if pi_exception_on_null then',
'        flow_errors.handle_instance_error',
'        ( ',
'          pi_prcs_id     => pi_prcs_id',
'        , pi_message_key => ''var-get-error''      ',
'        , p0             => pi_var_name',
'        , p1             => pi_prcs_id',
'        , p2             => pi_scope',
'        );',
'      else',
'        return null;',
'      end if;',
'  end get_var_as_vc2;',
'',
'  function get_bind_list',
'  (',
'    pi_expr in clob',
'  , pi_prcs_id  in  flow_processes.prcs_id%type',
'  , pi_sbfl_id  in  flow_subflows.sbfl_id%type',
'  , pi_scope    in  flow_subflows.sbfl_scope%type',
'  ) return apex_plugin_util.t_bind_list',
'  is',
'    l_bind                  apex_plugin_util.t_bind;',
'    l_bind_list             apex_plugin_util.t_bind_list;',
'    l_var_list              apex_t_varchar2 := apex_t_varchar2();',
'    l_indx                  pls_integer;',
'  begin',
'    l_bind_list := apex_plugin_util.c_empty_bind_list;',
'    l_var_list  := apex_string.grep ',
'                ( p_str => pi_expr',
'                , p_pattern =>  flow_constants_pkg.gc_bind_pattern',
'                , p_modifier => ''i''',
'                , p_subexpression => ''1''',
'                );',
'    if l_var_list is not null then',
'      l_indx := l_var_list.first;',
'      -- create bind list and get bind values',
'      apex_debug.info(''Expression : '' ||pi_expr|| '' Contains Bind Tokens : ''|| apex_string.join(l_var_list, '':''));',
'      while l_indx is not null ',
'      loop',
'        l_bind.name  := flow_constants_pkg.gc_substitution_flow_identifier || l_var_list(l_indx);',
'        case upper(l_var_list(l_indx))',
'          when flow_constants_pkg.gc_substitution_process_id then',
'            l_bind.value := pi_prcs_id;',
'          when flow_constants_pkg.gc_substitution_subflow_id then',
'            l_bind.value := pi_sbfl_id;',
'          when flow_constants_pkg.gc_substitution_scope then',
'            l_bind.value := pi_scope;   ',
'          when flow_constants_pkg.gc_substitution_process_priority then',
'            l_bind.value := flow_instances.priority (p_process_id => pi_prcs_id);   ',
'          else  ',
'            l_bind.value := get_var_as_vc2',
'                          ( pi_prcs_id            => pi_prcs_id',
'                          , pi_var_name           => l_var_list(l_indx)',
'                          , pi_scope              => pi_scope',
'                          , pi_exception_on_null  => false',
'                          );',
'          end case;',
'',
'        apex_debug.info (p_message => ''bind variables found : %0 value : %1 scope : %2 ''',
'          , p0 => l_bind.name',
'          , p1 => l_bind.value',
'          , p2 => pi_scope',
'          );                              ',
'        l_bind_list(l_indx) := l_bind;',
'        l_indx := l_var_list.next (l_indx);',
'      end loop; ',
'    end if;',
'    return l_bind_list;',
'  end get_bind_list; ',
'',
'  function get_parameter_list',
'  (',
'    pi_expr     in  varchar2',
'  , pi_prcs_id  in  flow_processes.prcs_id%type',
'  , pi_sbfl_id  in  flow_subflows.sbfl_id%type',
'  , pi_scope    in  flow_subflows.sbfl_scope%type',
'  , pi_state_params   in  apex_exec.t_parameters default apex_exec.c_empty_parameters',
'  ) return apex_exec.t_parameters',
'  is',
'    l_parameter             apex_exec.t_parameter;',
'    l_parameters            apex_exec.t_parameters;',
'    l_var_list              apex_t_varchar2 := apex_t_varchar2();',
'    l_indx                  pls_integer;',
'    l_bind_name             apex_exec.t_column_name;',
'',
'    function check_state_params',
'    ( pi_state_params  in  apex_exec.t_parameters default apex_exec.c_empty_parameters',
'    , pi_var           in  varchar2    ',
'    ) return apex_exec.t_parameter',
'    is ',
'      l_value     apex_exec.t_parameter;',
'    begin',
'      for i in pi_state_params.first..pi_state_params.last loop',
'        if upper(pi_var) = pi_state_params(i).name then',
'          apex_debug.message (''Found State Param %0'', p0=> pi_var);',
'          return pi_state_params(i);',
'        end if;',
'      end loop;',
'      return null;',
'    end check_state_params;',
'',
'  begin',
'    l_parameters := apex_exec.t_parameters();',
'    apex_debug.info(''t_parameters initialised'');',
'    l_var_list  := apex_string.grep ',
'                ( p_str => pi_expr',
'                , p_pattern =>  flow_constants_pkg.gc_bind_pattern',
'                , p_modifier => ''i''',
'                , p_subexpression => ''1''',
'                );',
'    if l_var_list is not null then',
'      l_indx := l_var_list.first;',
'      -- create bind list and get bind values',
'      apex_debug.info(''Expression : '' ||pi_expr|| '' Contains Bind Tokens : ''|| apex_string.join(l_var_list, '':''));',
'      while l_indx is not null ',
'      loop',
'        l_parameter.name  := flow_constants_pkg.gc_substitution_flow_identifier || l_var_list(l_indx);',
'        l_bind_name := upper(l_var_list(l_indx));',
'        case ',
'          when l_bind_name = flow_constants_pkg.gc_substitution_process_id then',
'            l_parameter.value.number_value  := pi_prcs_id;',
'            l_parameter.data_type           := apex_exec.c_data_type_number;',
'          when l_bind_name = flow_constants_pkg.gc_substitution_subflow_id then',
'            l_parameter.value.number_value  := pi_sbfl_id;',
'            l_parameter.data_type           := apex_exec.c_data_type_number;',
'          when l_bind_name = flow_constants_pkg.gc_substitution_scope then',
'            l_parameter.value.number_value  := pi_scope;',
'            l_parameter.data_type           := apex_exec.c_data_type_number;      ',
'          when l_bind_name = flow_constants_pkg.gc_substitution_process_priority then',
'            l_parameter.value.number_value  := flow_instances.priority (p_process_id => pi_prcs_id);',
'            l_parameter.data_type           := apex_exec.c_data_type_number;   ',
'          when l_bind_name  in ( flow_constants_pkg.gc_substitution_loop_counter ',
'                               , flow_constants_pkg.gc_substitution_total_instances',
'                               , flow_constants_pkg.gc_substitution_active_instances',
'                               , flow_constants_pkg.gc_substitution_completed_instances',
'                               , flow_constants_pkg.gc_substitution_terminated_instances ) then',
'            l_parameter := check_state_params ( pi_state_params => pi_state_params',
'                                              , pi_var => upper(l_var_list(l_indx)));  ',
'            l_parameter.name := flow_constants_pkg.gc_substitution_flow_identifier||l_parameter.name;                            ',
'          else  ',
'            l_parameter := get_var_as_parameter',
'                          ( pi_prcs_id            => pi_prcs_id',
'                          , pi_var_name           => l_var_list(l_indx) ',
'                          , pi_scope              => pi_scope',
'                          , pi_exception_on_null  => false',
'                          );',
'            l_parameter.name := flow_constants_pkg.gc_substitution_flow_identifier||l_parameter.name;',
'          end case;',
'',
'        apex_debug.info (p_message => ''bind variables found : %0 scope : %5 data type: %2 numvalue : %1  dateval : %3 vc2val : %4''',
'          , p0 => l_parameter.name',
'          , p1 => to_char(l_parameter.value.number_value)',
'          , p2 => l_parameter.data_type',
'          , p3 => to_char(l_parameter.value.date_value)',
'          , p4 => l_parameter.value.varchar2_value',
'          , p5 => pi_scope',
'          );                              ',
'        l_parameters(l_indx) := l_parameter;',
'        l_indx := l_var_list.next (l_indx);',
'      end loop; ',
'    else',
'      apex_debug.info(''Parameter list is empty'');',
'    end if;',
'    return l_parameters;',
'  end get_parameter_list; ',
'',
'  function get_vars_as_json_object',
'  ( pi_prcs_id   in flow_processes.prcs_id%type',
'  , pi_scope     in flow_subflows.sbfl_scope%type',
'  , pi_var_list  in flow_types_pkg.t_bpmn_attribute_vc2',
'  ) return sys.json_object_t',
'  is',
'    l_var_list   apex_t_varchar2;',
'    l_var_value  t_proc_var_value;',
'    l_var_obj    sys.json_object_t;',
'  begin',
'    apex_debug.enter ( ''get_vars_as_json_object''',
'    ,''pi_prcs_id'', pi_prcs_id',
'    ,''pi_scope'', pi_scope',
'    ,''pi_var_list'', pi_var_list',
'    );',
'    -- split var list',
'    l_var_list := apex_string.split ( p_str => pi_var_list, p_sep => '':'');',
'',
'    l_var_obj := new sys.json_object_t;',
'    if l_var_list.count > 0 then ',
'      for i in l_var_list.first..l_var_list.last Loop',
'        apex_debug.message (''Var name %0'', p0 => l_var_list(i));',
'        l_var_value := get_var_value  ( pi_prcs_id   => pi_prcs_id',
'                                      , pi_var_name  => l_var_list(i)',
'                                      , pi_scope     => pi_scope',
'                                      );',
'        apex_debug.message (''Var type: %0 vc2: %1 num: %2'', ',
'        p0 => l_var_value.var_type, p1 => l_var_value.var_vc2, p2 => l_var_value.var_num',
'        );',
'        case l_var_value.var_type',
'        when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'          l_var_obj.put(l_var_value.var_name,l_var_value.var_vc2);',
'        when flow_constants_pkg.gc_prov_var_type_date then',
'          l_var_obj.put(l_var_value.var_name,l_var_value.var_date);',
'        when flow_constants_pkg.gc_prov_var_type_number then',
'          l_var_obj.put(l_var_value.var_name,l_var_value.var_num);',
'        when flow_constants_pkg.gc_prov_var_type_tstz then',
'          l_var_obj.put(l_var_value.var_name,cast( l_var_value.var_tstz as timestamp));',
'        when flow_constants_pkg.gc_prov_var_type_json then',
'          l_var_obj.put(l_var_value.var_name,l_var_value.var_json);',
'        when flow_constants_pkg.gc_prov_var_type_clob then',
'          l_var_obj.put(l_var_value.var_name,l_var_value.var_clob);',
'        else',
'          l_var_obj.put_null(l_var_list(i));',
'        end case;',
'      end loop;',
'    end if;',
'    return l_var_obj;',
'  end get_vars_as_json_object;',
'',
'end flow_proc_vars_int;',
'/',
'',
'create or replace package body flow_process_vars as',
'/* ',
'-- Flows for APEX - flow_process_vars.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2020-2022.',
'-- (c) Copyright Flowquest Consulting Limited, 2020-2024.',
'-- (c) Copyright Insum Solutions 2020-2024.',
'--',
'-- Created september-2020  Richard Allen (Flowquest) ',
'-- Edited  April 2022 - Richard Allen (Oracle)',
'-- Edited 24-May-2024 - Richard Allen (Flowquest Consulting Limited)',
'-- Edited  18-Sep-2024 - Louis Moreaux (Insum Solutions)',
'--',
'*/',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'',
'',
'-- Signature 1a - set varchar2 process variable with known or default scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_vc2_value  in flow_process_variables.prov_var_vc2%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_current     flow_subflows.sbfl_current%type;',
'  e_bad_scope   exception;',
'begin',
'  -- if scope is not 0, validate',
'  if pi_scope = 0 ',
'  or  flow_proc_vars_int.scope_is_valid (pi_prcs_id => pi_prcs_id, pi_scope => pi_scope) then',
'    -- call internal set_var signature 1',
'    flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_name     => pi_var_name',
'      , pi_vc2_value    => pi_vc2_value',
'      , pi_scope        => pi_scope',
'      );',
'  else',
'    raise e_bad_scope;',
'  end if;',
'exception',
'  when e_bad_scope then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''var-bad-scope''',
'      , p0 => pi_scope',
'      , p1 => pi_var_name ',
'      );',
'      -- $F4AMESSAGE ''var-bad-scope'' || ''Invalid scope (%0) supplied for process variable %1.''  ',
'end set_var;',
'',
'-- signature 1b - set varchar2 process variable using subflow_id for scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_vc2_value  in flow_process_variables.prov_var_vc2%type',
', pi_sbfl_id    in flow_subflows.sbfl_id%type ',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'  l_current     flow_subflows.sbfl_current%type;',
'begin',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'       , sbfl.sbfl_current',
'    into l_scope',
'       , l_current',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  -- call internal set_var signature 1',
'  flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_var_name     => pi_var_name',
'    , pi_vc2_value    => pi_vc2_value',
'    , pi_scope        => l_scope',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => l_current',
'    );',
'exception',
'  when no_data_found then',
'    flow_e'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rrors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_prcs_id',
'      , p1 => pi_sbfl_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end set_var;',
'',
'-- Signature 2a - set number process variable with known or default scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_num_value  in flow_process_variables.prov_var_num%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_current     flow_subflows.sbfl_current%type;',
'  e_bad_scope   exception;',
'begin',
'  -- if scope is not 0, validate',
'  if pi_scope = 0 ',
'  or  flow_proc_vars_int.scope_is_valid (pi_prcs_id => pi_prcs_id, pi_scope => pi_scope) then',
'    -- call internal set_var signature 2',
'    flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_name     => pi_var_name',
'      , pi_num_value    => pi_num_value',
'      , pi_scope        => pi_scope',
'      );',
'  else',
'    raise e_bad_scope;',
'  end if;',
'exception',
'  when e_bad_scope then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''var-bad-scope''',
'      , p0 => pi_scope',
'      , p1 => pi_var_name ',
'      );',
'      -- $F4AMESSAGE ''var-bad-scope'' || ''Invalid scope (%0) supplied for process variable %1.''  ',
'end set_var;',
'',
'-- signature 2b - set number process variable using subflow_id for scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_num_value  in flow_process_variables.prov_var_num%type',
', pi_sbfl_id    in flow_subflows.sbfl_id%type ',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'  l_current     flow_subflows.sbfl_current%type;',
'begin',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'       , sbfl.sbfl_current',
'    into l_scope',
'       , l_current',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  -- call internal set_var signature 2',
'  flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_var_name     => pi_var_name',
'    , pi_num_value    => pi_num_value',
'    , pi_scope        => l_scope',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => l_current',
'    );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end set_var;',
'',
'-- Signature 3a - set date process variable with known or default scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_date_value in flow_process_variables.prov_var_date%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_current     flow_subflows.sbfl_current%type;',
'  e_bad_scope   exception;',
'begin',
'  if pi_scope = 0 ',
'  or  flow_proc_vars_int.scope_is_valid (pi_prcs_id => pi_prcs_id, pi_scope => pi_scope) then',
'    -- call internal set_var signature 3',
'    flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_name     => pi_var_name',
'      , pi_date_value   => pi_date_value',
'      , pi_scope        => pi_scope',
'      );',
'  else',
'    raise e_bad_scope;',
'  end if;',
'exception',
'  when e_bad_scope then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''var-bad-scope''',
'      , p0 => pi_scope',
'      , p1 => pi_var_name ',
'      );',
'      -- $F4AMESSAGE ''var-bad-scope'' || ''Invalid scope (%0) supplied for process variable %1.''  ',
'end set_var;',
'',
'-- signature 3b - set date process variable using subflow_id for scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_date_value in flow_process_variables.prov_var_date%type',
', pi_sbfl_id    in flow_subflows.sbfl_id%type ',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'  l_current     flow_subflows.sbfl_current%type;',
'begin',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'       , sbfl.sbfl_current',
'    into l_scope',
'       , l_current',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  -- call internal set_var signature 3',
'  flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_var_name     => pi_var_name',
'    , pi_date_value   => pi_date_value',
'    , pi_scope        => l_scope',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => l_current',
'    );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end set_var;',
'',
'-- Signature 4a - set CLOB process variable with known or default scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_clob_value in flow_process_variables.prov_var_clob%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_current     flow_subflows.sbfl_current%type;',
'  e_bad_scope   exception;',
'begin',
'  -- if scope is not 0, validate',
'  if pi_scope = 0 ',
'  or  flow_proc_vars_int.scope_is_valid (pi_prcs_id => pi_prcs_id, pi_scope => pi_scope) then',
'    -- call internal set_var signature 4',
'    flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_name     => pi_var_name',
'      , pi_clob_value   => pi_clob_value',
'      , pi_scope        => pi_scope',
'      );',
'  else',
'    raise e_bad_scope;',
'  end if;',
'exception',
'  when e_bad_scope then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''var-bad-scope''',
'      , p0 => pi_scope',
'      , p1 => pi_var_name ',
'      );',
'      -- $F4AMESSAGE ''var-bad-scope'' || ''Invalid scope (%0) supplied for process variable %1.''  ',
'end set_var;',
'',
'-- signature 4b - set CLOB process variable using subflow_id for scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_clob_value  in flow_process_variables.prov_var_clob%type',
', pi_sbfl_id    in flow_subflows.sbfl_id%type ',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'  l_current     flow_subflows.sbfl_current%type;',
'begin',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'       , sbfl.sbfl_current',
'    into l_scope',
'       , l_current',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  -- call internal set_var signature 4',
'  flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_var_name     => pi_var_name',
'    , pi_clob_value   => pi_clob_value',
'    , pi_scope        => l_scope',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => l_current',
'    );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end set_var;',
'',
'-- Signature 5a - set timestamp process variable with known or default scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_tstz_value   in flow_process_variables.prov_var_tstz%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_current     flow_subflows.sbfl_current%type;',
'  e_bad_scope   exception;',
'begin',
'  if pi_scope = 0 ',
'  or  flow_proc_vars_int.scope_is_valid (pi_prcs_id => pi_prcs_id, pi_scope => pi_scope) then',
'    -- call internal set_var signature 3',
'    flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_name     => pi_var_name',
'      , pi_tstz_value   => pi_tstz_value',
'      , pi_scope        => pi_scope',
'      );',
'  else',
'    raise e_bad_scope;',
'  end if;',
'exception',
'  when e_bad_scope then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''var-bad-scope''',
'      , p0 => pi_scope',
'      , p1 => pi_var_name ',
'      );',
'      -- $F4AMESSAGE ''var-bad-scope'' || ''Invalid scope (%0) supplied for process variable %1.''  ',
'end set_var;',
'',
'-- signature 5b - set timestamp process variable using subflow_id for scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_tstz_value in flow_process_variables.prov_var_tstz%type',
', pi_sbfl_id    in flow_subflows.sbfl_id%type ',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'  l_current     flow_subflows.sbfl_current%type;',
'begin',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'       , sbfl.sbfl_current',
'    into l_scope',
'       , l_current',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  -- call internal set_var signature 5',
'  flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_var_name     => pi_var_name',
'    , pi_tstz_value   => pi_tstz_value',
'    , pi_scope        => l_scope',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => l_current',
'    );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end set_var;',
'',
'-- Signature 6a - set JSON process variable with known or default scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_json_value in flow_process_variables.prov_var_json%type',
', pi_scope      in flow_process_variables.prov_scope%type default 0',
')',
'is ',
'  l_current     flow_subflows.sbfl_current%type;',
'  e_bad_scope   exception;',
'begin',
'  -- if scope is not 0, validate',
'  if pi_scope = 0 ',
'  or  flow_proc_vars_int.scope_is_valid (pi_prcs_id => pi_prcs_id, pi_scope => pi_scope) then',
'    -- call internal set_var signature 4',
'    flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_var_name     => pi_var_name',
'      , pi_json_value   => pi_json_value',
'      , pi_scope        => pi_scope',
'      );',
'  else',
'    raise e_bad_scope;',
'  end if;',
'exception',
'  when e_bad_scope then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''var-bad-scope''',
'      , p0 => pi_scope',
'      , p1 => pi_var_name ',
'      );',
'      -- $F4AMESSAGE ''var-bad-scope'' || ''Invalid scope (%0) supplied for process variable %1.''  ',
'end set_var;',
'',
'-- signature 6b - set JSON process variable using subflow_id for scope',
'',
'procedure set_var',
'( pi_prcs_id    in flow_processes.prcs_id%type',
', pi_var_name   in flow_process_variables.prov_var_name%type',
', pi_json_value  in flow_process_variables.prov_var_json%type',
', pi_sbfl_id    in flow_subflows.sbfl_id%type ',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'  l_current     flow_subflows.sbfl_current%type;',
'begin',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'       , sbfl.sbfl_current',
'    into l_scope',
'       , l_current',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  -- call internal set_var signature 4',
'  flow_proc_vars_int.set_var',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_var_name     => pi_var_name',
'    , pi_json_value   => pi_json_value',
'    , pi_scope        => l_scope',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_objt_bpmn_id => l_current',
'    );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end set_var;',
'',
'-- getters return',
'',
'-- get_var_vc2:  varchar2 type - signature 1 - scope (or no scope) supplied',
'',
'function get_var_vc2',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_vc2%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_vc2',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_vc2;',
'',
'-- get_var_vc2:  varchar2 type - signature 2 - subflow_id supplied',
'',
'function get_var_vc2',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_sbfl_id            in flow_subflows.sbfl_id%type',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_vc2%type',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_vc2',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_vc2;',
'',
'-- get_var_num:  number type - signature 1 - scope (or no scope) supplied',
'',
'function get_var_num',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_num%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_num',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_num;',
'',
'-- get_var_num:  number type - signature 2 - subflow_id supplied',
'',
'function get_var_num',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_num%type',
'is',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_num',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_num;',
'',
'-- get_var_date: date type - signature 1 - scope (or no scope) supplied',
'',
'function get_var_date',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_date%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_date',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_date;',
'',
'-- get_var_date: date type - signature 2 - subflow_id supplied',
'',
'function get_var_date',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_date%type',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_date',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_date;',
'',
'-- get_var_CLOB:  CLOB type - signature 1 - scope (or no scope) supplied',
'',
'function get_var_clob',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_clob%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_clob',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_clob;',
'',
'-- get_var_CLOB:  CLOB type - signature 2 - subflow_id supplied',
'',
'function get_var_clob',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_clob%type',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_clob',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_clob;',
'',
'-- get_var_JSON:  JSON type - signature 1 - scope (or no scope) supplied',
'',
'function get_var_json',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_json%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_json',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_json;',
'',
'-- get_var_JSON:  JSON type - signature 2 - subflow_id supplied',
'',
'function get_var_json',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_json%type',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_json',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_json;',
'',
'-- get_var_JSON_element:  JSON type returning json_element_t - signature 1 - scope (or no scope) supplied',
'',
'function get_var_json_element',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return sys.json_element_t',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_json_element',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_json_element;',
'',
'-- get_var_JSON_element:  JSON type returning json_element_t - signature 2 - subflow_id supplied',
'',
'function get_var_json_element',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
', pi_exception_on_null in boolean default false',
') return sys.json_element_t',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_json_element',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_json_element;',
'',
'-- get_var_date: timestamp type - signature 1 - scope (or no scope) supplied',
'',
'function get_var_tstz',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_scope              in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_tstz%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_tstz',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_tstz;',
'',
'-- get_var_date: timestamp type - signature 2 - subflow_id supplied',
'',
'function get_var_tstz',
'( pi_prcs_id            in flow_processes.prcs_id%type',
', pi_var_name           in flow_process_variables.prov_var_name%type',
', pi_sbfl_id            in flow_subflows.sbfl_id%type',
', pi_exception_on_null  in boolean default false',
') return flow_process_variables.prov_var_tstz%type',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_tstz',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_tstz;',
'',
'-- get type of a variable - signature 1 - with scope including default scope',
'',
'function get_var_type',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_type%type',
'is ',
'begin',
'  return flow_proc_vars_int.get_var_type',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'end get_var_type;',
'',
'-- get_var_type - signature 2 - subflow_id supplied',
'',
'function get_var_type',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
', pi_exception_on_null in boolean default false',
') return flow_process_variables.prov_var_type%type',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  return flow_proc_vars_int.get_var_type',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_sc'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ope              => l_scope',
'              , pi_exception_on_null  => pi_exception_on_null',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'    raise;',
'end get_var_type;',
'',
'-- delete a variable - signature 1 - with scope including default scope',
'',
'procedure delete_var ',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_scope in flow_process_variables.prov_scope%type default 0',
')',
'is',
'begin',
'  flow_proc_vars_int.delete_var',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => pi_scope',
'              );',
'end delete_var;',
'',
'-- get_var_type - signature 2 - subflow_id supplied',
'',
'procedure delete_var ',
'( pi_prcs_id in flow_processes.prcs_id%type',
', pi_var_name in flow_process_variables.prov_var_name%type',
', pi_sbfl_id in flow_subflows.sbfl_id%type',
')',
'is ',
'  l_scope       flow_process_variables.prov_scope%type;',
'begin ',
'  -- get the scope and current object for the supplied subflow',
'  select sbfl.sbfl_scope',
'    into l_scope',
'    from flow_subflows sbfl',
'   where sbfl.sbfl_id = pi_sbfl_id',
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'  ;',
'  flow_proc_vars_int.delete_var',
'              ( pi_prcs_id            => pi_prcs_id',
'              , pi_var_name           => pi_var_name',
'              , pi_scope              => l_scope',
'              );',
'exception',
'  when no_data_found then',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_prcs_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'end delete_var;',
'',
'',
'-- special cases / built-in standard variables',
'',
'-- set_business_ref - signature 1 - in scope 0 or in a known scope',
'',
'  procedure set_business_ref',
'  ( pi_prcs_id    in flow_processes.prcs_id%type',
'  , pi_vc2_value  in flow_process_variables.prov_var_vc2%type',
'  , pi_scope      in flow_subflows.sbfl_scope%type default 0',
'  )',
'  is',
'  begin',
'    flow_proc_vars_int.set_business_ref',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_scope        => pi_scope',
'    , pi_vc2_value    => pi_vc2_value',
'    );',
'  end set_business_ref;',
'',
'-- set_business_ref - signature 2 - in scope determined by given subflow id',
'',
'  procedure set_business_ref',
'  ( pi_prcs_id    in flow_processes.prcs_id%type',
'  , pi_vc2_value  in flow_process_variables.prov_var_vc2%type',
'  , pi_sbfl_id    in flow_subflows.sbfl_id%type',
'  )',
'  is',
'    l_scope  flow_subflows.sbfl_scope%type;',
'  begin',
'    l_scope := flow_engine_util.get_scope',
'                 ( p_process_id => pi_prcs_id',
'                 , p_subflow_id => pi_sbfl_id',
'                 );',
'    flow_proc_vars_int.set_business_ref',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_scope        => l_scope',
'    , pi_vc2_value    => pi_vc2_value',
'    );',
'  end set_business_ref;',
'',
'-- get_business_ref - signature 1 - in scope 0 or in a known scope',
'',
'  function get_business_ref',
'  ( pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_scope in flow_subflows.sbfl_scope%type default 0',
'  )',
'  return flow_process_variables.prov_var_vc2%type',
'  is ',
'  begin',
'    return flow_proc_vars_int.get_business_ref ',
'           ( pi_prcs_id => pi_prcs_id',
'           , pi_scope   => pi_scope',
'           );',
'  end get_business_ref;',
'',
'-- get_business_ref - signature 2 - in scope determined by given subflow id',
'',
'  function get_business_ref',
'  ( pi_prcs_id    in flow_processes.prcs_id%type',
'  , pi_sbfl_id    in flow_subflows.sbfl_id%type',
'  )',
'  return flow_process_variables.prov_var_vc2%type',
'  is',
'    l_scope  flow_subflows.sbfl_scope%type;',
'  begin',
'    l_scope := flow_engine_util.get_scope',
'                 ( p_process_id => pi_prcs_id',
'                 , p_subflow_id => pi_sbfl_id',
'                 );',
'    return flow_proc_vars_int.get_business_ref ',
'           ( pi_prcs_id => pi_prcs_id',
'           , pi_scope   => l_scope',
'           );',
'  end get_business_ref;',
'',
'end flow_process_vars;',
'/',
'',
'create or replace package body flow_expressions',
'as ',
'  /* ',
'  -- Flows for APEX - flow_expressions.pkb',
'  -- ',
'  -- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'  -- (c) Copyright MT AG, 2021-2022.',
'  -- (c) Copyright Flowquest Limited. 2021-2024.',
'  --',
'  -- Created    22-Mar-2021  Richard Allen (Flowquest, for MT AG)',
'  -- Modified   12-Apr-2022  Richard Allen (Oracle)',
'  -- Modified   11-Feb-2024  Richard Allen (Flowquest)',
'  --',
'  */  ',
'  type t_expr_rec is record',
'  ( expr_id             flow_object_expressions.expr_id%type',
'  , expr_objt_id        flow_object_expressions.expr_objt_id%type',
'  , expr_set            flow_object_expressions.expr_set%type',
'  , expr_order          flow_object_expressions.expr_order%type',
'  , expr_var_name       flow_object_expressions.expr_var_name%type',
'  , expr_var_type       flow_object_expressions.expr_var_type%type',
'  , expr_type           flow_object_expressions.expr_type%type',
'  , expr_expression     flow_object_expressions.expr_expression%type',
'  , expr_objt_bpmn_id   flow_objects.objt_bpmn_id%type',
'  );',
'',
'  type t_expr_set is table of t_expr_rec;',
'',
'  function get_expression_set',
'  ( pi_objt_id      flow_objects.objt_id%type',
'  , pi_set          flow_object_expressions.expr_set%type',
'  ) return t_expr_set',
'  as',
'    l_expressions   t_expr_set;',
'  begin',
'    select expr.expr_id',
'         , expr.expr_objt_id',
'         , expr.expr_set',
'         , expr.expr_order',
'         , expr.expr_var_name',
'         , expr.expr_var_type',
'         , expr.expr_type',
'         , expr.expr_expression',
'         , objt.objt_bpmn_id as expr_objt_bpmn_id',
'    bulk collect into l_expressions',
'      from flow_object_expressions expr',
'      join flow_objects objt',
'        on objt.objt_id = expr.expr_objt_id',
'     where expr.expr_objt_id = pi_objt_id',
'       and expr.expr_set = pi_set',
'     order by expr.expr_order asc',
'    ;',
'    return l_expressions;',
'  end get_expression_set;',
'',
'  /**********************************************************************',
'  **',
'  ** Process various expression types',
'  **',
'  ***********************************************************************',
'  */',
'',
'  procedure set_static',
'  ( pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_expression   t_expr_rec',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type  ',
'  )',
'  as ',
'    l_expression_text   flow_object_expressions.expr_expression%type;',
'    l_result_rec        flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_expressions.set_static''',
'    , ''expr_var_name'', pi_expression.expr_var_name',
'    , ''pi_expression.expr_var_type'', pi_expression.expr_var_type',
'    , ''pi_expression.expr_expression'' , pi_expression.expr_expression',
'    );',
'',
'    l_expression_text := pi_expression.expr_expression;',
'    -- substitute any F4A Process Variables',
'    flow_proc_vars_int.do_substitution',
'    ( pi_prcs_id => pi_prcs_id',
'    , pi_sbfl_id => pi_sbfl_id',
'    , pi_scope   => pi_expr_scope',
'    , pio_string => l_expression_text',
'    );',
'',
'    l_result_rec.var_name := pi_expression.expr_var_name;',
'    l_result_rec.var_type := pi_expression.expr_var_type;',
'    ',
'    case pi_expression.expr_var_type ',
'    when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'        l_result_rec.var_vc2   := l_expression_text;',
'    when flow_constants_pkg.gc_prov_var_type_number then',
'        l_result_rec.var_num   := l_expression_text;',
'    when flow_constants_pkg.gc_prov_var_type_date then',
'        -- test date is in our required format',
'        begin',
'          if l_expression_text != to_char  ( to_date ( l_expression_text',
'                                                    , flow_constants_pkg.gc_prov_default_date_format )',
'                                          , flow_constants_pkg.gc_prov_default_date_format ) then ',
'          raise e_var_exp_date_format_error;',
'          end if;',
'        exception',
'          when others then',
'            raise e_var_exp_date_format_error;',
'        end;',
'        l_result_rec.var_date   := to_date(l_expression_text, flow_constants_pkg.gc_prov_default_date_format);',
'    when flow_constants_pkg.gc_prov_var_type_tstz then',
'        -- test timestamp is in our required format',
'        begin',
'          if l_expression_text != to_char ( to_timestamp_tz ( l_expression_text',
'                                          , flow_constants_pkg.gc_prov_default_tstz_format )',
'                                          , flow_constants_pkg.gc_prov_default_tstz_format ) then ',
'            raise e_var_exp_date_format_error;',
'          end if;',
'        exception',
'          when others then',
'            raise e_var_exp_date_format_error;',
'        end;',
'        l_result_rec.var_tstz := to_timestamp_tz(l_expression_text, flow_constants_pkg.gc_prov_default_tstz_format);',
'    when flow_constants_pkg.gc_prov_var_type_json then',
'        -- test is correct json (lax)',
'        begin',
'          if l_expression_text is not json then',
'            raise e_var_exp_json_format_error;',
'          end if;',
'        exception',
'          when others then',
'            raise e_var_exp_json_format_error;',
'        end;',
'        l_result_rec.var_json := l_expression_text;',
'    end case;',
'    -- set proc variable',
'    flow_proc_vars_int.set_var ',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_var_value      => l_result_rec',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_objt_bpmn_id   => pi_expression.expr_objt_bpmn_id',
'    , pi_expr_set       => pi_expression.expr_set    ',
'    , pi_scope          => pi_var_scope',
'    );',
'  exception',
'    when e_var_exp_date_format_error then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_date_format''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_expression.expr_var_name',
'      , p2 => pi_expression.expr_set',
'      );',
'      -- $F4AMESSAGE ''var_exp_date_format'' || ''Error setting Process Variable %1: Incorrect Date Format (Subflow: %0, Set: %3.)''   ',
'    when e_var_exp_json_format_error then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_json_format''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_expression.expr_var_name',
'      , p2 => pi_expression.expr_set',
'      );',
'      -- $F4AMESSAGE ''var_exp_json_format'' || ''Error setting Process Variable %1: Incorrect JSON Format (Subflow: %0, Set: %3.)''     ',
'    when others then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_static_general''',
'      , p0 => pi_prcs_id',
'      , p1 => pi_expression.expr_var_name',
'      , p2 => pi_expression.expr_set',
'      );',
'      -- $F4AMESSAGE ''var_exp_static_general'' || ''Error setting process variable %1 in process id %0 (set %2).  See error in event log.''',
'  end set_static;',
'',
'  procedure set_proc_var',
'  ( pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_expression   t_expr_rec',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type',
'  )',
'  as ',
'    l_result_rec        flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_expressions.set_proc_var''',
'    , ''expr_var_name'', pi_expression.expr_var_name',
'    , ''proc var'' , pi_expression.expr_expression',
'    );',
'',
'    l_result_rec.var_name := pi_expression.expr_var_name;',
'    l_result_rec.var_type := pi_expression.expr_var_type;',
'',
'    case pi_expression.expr_var_type ',
'    when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'        l_result_rec.var_vc2 :=   flow_proc_vars_int.get_var_vc2 ',
'                                    ( pi_prcs_id  => pi_prcs_id',
'                                    , pi_var_name => pi_expression.expr_expression',
'                                    , pi_scope    => pi_expr_scope',
'                                    );    ',
'    when flow_constants_pkg.gc_prov_var_type_date then',
'        l_result_rec.var_date  := flow_proc_vars_int.get_var_date ',
'                                    ( pi_prcs_id  => pi_prcs_id',
'                                    , pi_var_name => pi_expression.expr_expression',
'                                    , pi_scope    => pi_expr_scope',
'                                    );  ',
'    when flow_constants_pkg.gc_prov_var_type_number then',
'        l_result_rec.var_num   := flow_proc_vars_int.get_var_num',
'                                    ( pi_prcs_id  => pi_prcs_id',
'                                    , pi_var_name => pi_expression.expr_expression',
'                                    , pi_scope    => pi_expr_scope                             ',
'                                    );   ',
'    when flow_constants_pkg.gc_prov_var_type_clob then',
'        l_result_rec.var_clob  := flow_proc_vars_int.get_var_clob ',
'                                    ( pi_prcs_id  => pi_prcs_id',
'                                    , pi_var_name => pi_expression.expr_expression',
'                                    , pi_scope    => pi_expr_scope',
'                                    );',
'    when flow_constants_pkg.gc_prov_var_type_tstz then',
'        l_result_rec.var_tstz :=  flow_proc_vars_int.get_var_tstz',
'                                    ( pi_prcs_id  => pi_prcs_id',
'                                    , pi_var_name => pi_expression.expr_expression',
'                                    , pi_scope    => pi_expr_scope',
'                                    );  ',
'    when flow_constants_pkg.gc_prov_var_type_json then',
'        l_result_rec.var_json  := flow_proc_vars_int.get_var_json ',
'                                    ( pi_prcs_id  => pi_prcs_id',
'                                    , pi_var_name => pi_expression.expr_expression',
'                                    , pi_scope    => pi_expr_scope',
'                                    );',
'    end case; ',
'    -- set proc variable',
'    flow_proc_vars_int.set_var ',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_var_value      => l_result_rec',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_objt_bpmn_id   => pi_expression.expr_objt_bpmn_id',
'    , pi_expr_set       => pi_expression.expr_set    ',
'    , pi_scope          => pi_var_scope',
'    );',
'  exception',
'    when others then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_static_general''',
'      , p0 => pi_prcs_id',
'      , p1 => pi_expression.expr_var_name',
'      , p2 => pi_expression.expr_set',
'      );',
'      -- $F4AMESSAGE ''var_exp_static_general'' || ''Error setting process variable %1 in process id %0 (set %2).  See error in event log.''      ',
'  end set_proc_var;',
'',
'  procedure set_sql',
'  ( pi_prcs_id        flow_processes.prcs_id%type',
'  , pi_expression     t_expr_rec',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type',
'  , pi_var_scope      flow_subflows.sbfl_scope%type',
'  , pi_expr_scope     flow_subflows.sbfl_scope%type',
'  ) ',
'  as  ',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'  begin',
'      apex_debug.enter',
'    ( ''flow_expressions.set_sql''',
'    , ''expr_var_name'', pi_expression.expr_var_name',
'    , ''sql text'' , pi_expression.expr_expression',
'    );',
'',
'    l_result_rec := flow_db_exec.exec_flows_sql',
'                    ( pi_prcs_id      => pi_prcs_id',
'                    , pi_sbfl_id      => pi_sbfl_id',
'                    , pi_sql_text     => pi_expression.expr_expression',
'                    , pi_result_type  => pi_expression.expr_var_type',
'                    , pi_scope        => pi_expr_scope',
'                    , pi_expr_type    => pi_expression.expr_type',
'                    );',
'',
'    l_result_rec.var_name   := pi_expression.expr_var_name;',
'',
'    flow_proc_vars_int.set_var ',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_var_value      => l_result_rec',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_objt_bpmn_id   => pi_expression.expr_objt_bpmn_id',
'    , pi_expr_set       => pi_expression.expr_set',
'    , pi_scope          => pi_var_scope',
'    );',
'',
'  exception',
'    when others then',
'      apex_debug.error',
'      ( p_message => ''Error setting process variable %0 for process id %1. SQLERRM: %2''',
'      , p0        => pi_expression.expr_var_name',
'      , p1        => pi_prcs_id',
'      , p2        => sqlerrm',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_sql_other''',
'      , p0 => pi_prcs_id',
'      , p1 => pi_expression.expr_var_name',
'      , p2 => pi_expression.expr_set',
'      );',
'      -- $F4AMESSAGE ''var_exp_sql_other'' || ''Error setting process variable %1 in process id %0 (set %2).  SQL error shown in event log.''    ',
'  end set_sql;',
'',
'  procedure set_plsql         ',
'  ( pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_expression   t_expr_rec',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type',
'  )',
'  as ',
'    l_result_rec                flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_expressions.set_plsql''',
'    , ''expr_var_name'', pi_expression.expr_var_name',
'    , ''plsql text'' , pi_expression.expr_expression',
'    );',
'',
'    l_result_rec := flow_db_exec.exec_flows_plsql',
'                    ( pi_prcs_id      => pi_prcs_id',
'                    , pi_sbfl_id      => pi_sbfl_id',
'                    , pi_plsql_text   => pi_expression.expr_expression',
'                    , pi_result_type  => pi_expression.expr_var_type',
'                    , pi_scope        => pi_expr_scope',
'                    , pi_expr_type   => pi_expression.expr_type',
'                    );',
'    l_result_rec.var_name   := pi_expression.expr_var_name;',
'',
'    -- set proc variable',
'    flow_proc_vars_int.set_var ',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_var_value      => l_result_rec',
'    , pi_sbfl_id        => pi_sbfl_id',
'    , pi_objt_bpmn_id   => pi_expression.expr_objt_bpmn_id',
'    , pi_expr_set       => pi_expression.expr_set    ',
'    , pi_scope          => pi_var_scope',
'    );',
'',
'  exception',
'    when others then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_plsql_error''',
'      , p0 => pi_sbfl_id',
'      , p1 => pi_expression.expr_var_name',
'      , p2 => pi_expression.expr_set',
'      );',
'      -- $F4AMESSAGE ''var_exp_plsql_error'' || ''Subflow : %0 Error in %2 expression for Variable : %1''',
'  end set_plsql;  ',
'',
'  /**********************************************************************',
'  **',
'  ** Main Procedure',
'  **',
'  ***********************************************************************',
'  */',
'',
'  procedure process_expressions',
'  ( pi_objt_id      flow_objects.objt_id%type',
'  , pi_set          flow_object_expressions.expr_set%type',
'  , pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type',
'  )',
'  as',
'    l_expressions   t_expr_set;',
'  begin',
'    apex_debug.enter',
'    ( ''process_expressions''',
'    , ''pi_objt_id'', pi_objt_id',
'    , ''pi_set'' , pi_set',
'    , ''pi_var_scope'' , pi_var_scope',
'    , ''pi_expr_scope'', pi_expr_scope',
'    );',
'',
'    l_expressions := get_expression_set',
'    ( pi_objt_id => pi_objt_id',
'    , pi_set     => pi_set',
'    );',
'    if l_expressions.count > 0 then ',
'      -- set context',
'      flow_globals.set_context',
'      ( pi_prcs_id      => pi_prcs_id',
'      , pi_sbfl_id      => pi_sbfl_id',
'      , pi_scope        => pi_expr_scope',
'      , pi_loop_counter => flow_engine_util.get_loop_counter(pi_sbfl_id => pi_sbfl_id)',
'      );',
'      apex_debug.trace ',
'      ( p_message => ''l_expressions.count: %0''',
'      , p0        => l_expressions.count',
'      );',
'      -- step through expressions',
'      for i in 1..l_expressions.count loop',
'        -- process expression',
'        case ',
'          when l_expressions(i).expr_type = flow_constants_pkg.gc_expr_type_static then',
'            set_static ',
'            ( pi_prcs_id      => pi_prcs_id',
'            , pi_sbfl_id      => pi_sbfl_id',
'            , pi_expression   => l_expressions(i)',
'            , pi_var_scope    => pi_var_scope',
'            , pi_expr_scope   => pi_expr_scope ',
'            );',
'          when l_expressions(i).expr_type = flow_constants_pkg.gc_expr_type_proc_var then',
'            set_proc_var',
'            ( pi_prcs_id      => pi_prcs_id',
'            , pi_sbfl_id      => pi_sbfl_id',
'            , pi_expression   => l_expressions(i)',
'            , pi_var_scope    => pi_var_scope',
'            , pi_expr_scope   => pi_expr_scope ',
'            );',
'          when l_expressions(i).expr_type = flow_constants_pkg.gc_expr_type_sql  ',
'            or l_expressions(i).expr_type = flow_constants_pkg.gc_expr_type_sql_delimited_list',
'            or l_expressions(i).expr_type = flow_constants_pkg.gc_expr_type_sql_json_array',
'          then',
'            set_sql',
'            ( pi_prcs_id      => pi_prcs_id',
'            , pi_expression   => l_expressions(i)',
'            , pi_sbfl_id      => pi_sbfl_id',
'            , pi_var_scope    => pi_var_scope',
'            , pi_expr_scope   => pi_expr_scope             ',
'            );  ',
'          when l_expressions(i).expr_type in ( flow_constants_pkg.gc_expr_type_plsql_expression',
'                                             , flow_constants_pkg.gc_expr_type_plsql_raw_expression',
'                                             , flow_constants_pkg.gc_expr_type_plsql_function_body',
'                                             , flow_constants_pkg.gc_expr_type_plsql_raw_function_body )',
'          then',
'            set_plsql',
'            ( pi_prcs_id      => pi_prcs_id',
'            , pi_expression   => l_expressions(i)',
'            , pi_sbfl_id      => pi_sbfl_id',
'            , pi_var_scope    => pi_var_scope',
'            , pi_expr_scope   => pi_expr_scope             ',
'            );  ',
'          else',
'              pragma coverage (''not_feasible'');',
'              null;',
'        end case;',
'      end loop;',
'    end if;',
'  end process_expressions;',
'',
'  -- overloaded process_expressions that accepts a objt_bpmn_id rather than an objt_id',
'  procedure process_expressions',
'  ( pi_objt_bpmn_id flow_objects.objt_bpmn_id%type',
'  , pi_set          flow_object_expressions.expr_set%type',
'  , pi_prcs_id      flow_processes.prcs_id%type',
'  , pi_sbfl_id      flow_subflows.sbfl_id%type',
'  , pi_var_scope    flow_subflows.sbfl_scope%type',
'  , pi_expr_scope   flow_subflows.sbfl_scope%type',
'  )',
'  is ',
'    l_objt_id       flow_objects.objt_id%type;',
'  begin ',
'    apex_debug.enter',
'    ( ''process_expressions''',
'    , ''pi_objt_bpmn_id'', pi_objt_bpmn_id',
'    , ''pi_set'' , pi_set',
'    , ''pi_var_scope'' , pi_var_scope',
'    , ''pi_expr_scope'', pi_expr_scope',
'    );',
'    -- look up the objt_id',
'    select objt.objt_id',
'      into l_objt_id',
'      from flow_objects objt',
'      join flow_subflows sbfl ',
'        on sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'     where sbfl.sbfl_id = pi_sbfl_id ',
'       and objt.objt_bpmn_id = pi_objt_bpmn_id',
'    ;',
'    process_expressions',
'    ( pi_objt_id      => l_objt_id',
'    , pi_set          => pi_set',
'    , pi_prcs_id      => pi_prcs_id',
'    , pi_sbfl_id      => pi_sbfl_id',
'    , pi_var_scope    => pi_var_scope',
'    , pi_expr_scope   => pi_expr_scope ',
'    );',
'  exception',
'    when no_data_found then',
'      pragma coverage (''not_feasible'');',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_object_not_found''',
'      , p0 => pi_objt_bpmn_id',
'      );',
'      -- $F4AMESSAGE ''var_exp_object_not_found'' || ''Internal error looking up object %0 in process_expressions.  SQL error shown in debug output.''  ',
'  end process_expressions; ',
'  ',
'end flow_expressions;',
'/',
'',
'create or replace package body flow_settings',
'as ',
'/* ',
'-- Flows for APEX - flow_settings.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright Flowquest Limited. 2024',
'--',
'-- Created    23-Nov-2022  Richard Allen (Oracle)',
'-- Modified   13-Apr-2023  Moritz Klein (MT GmbH)',
'-- Modified   11-Feb-2024  Richard Allen (Flowquest Limited)',
'--',
'*/',
'',
'  type expression_details_t is',
'    record',
'    (',
'      expr_type         flow_types_pkg.t_bpmn_attribute_vc2',
'    , expr_value        clob',
'    , expr_fmt          flow_types_pkg.t_bpmn_attribute_vc2',
'    , expr_inside_var   flow_types_pkg.t_bpmn_attribute_vc2',
'    , expr_description  flow_types_pkg.t_bpmn_attribute_vc2',
'    );',
'',
'  function get_expression_details( pi_expr_json in json_object_t )',
'    return expression_details_t',
'  as',
'    l_return    expression_details_t;',
'  begin',
'    apex_debug.enter (''get_expression_details'',''pi_expr_json'',pi_expr_json.to_string);',
'    l_return.expr_type := pi_expr_json.get_string( key => ''expressionType'' );',
'',
'    case pi_expr_json.get_type( key => ''expression'' )',
'      when ''SCALAR'' then',
'        l_return.expr_value := pi_expr_json.get_string( key => ''expression'' );',
'      when ''ARRAY'' then',
'        l_return.expr_value := flow_engine_util.json_array_join( pi_expr_json.get_array( key => ''expression'' ) );',
'      else',
'       null;',
'    end case;',
'    ',
'    l_return.expr_fmt               := pi_expr_json.get_string( key => ''formatMask'' );',
'    l_return.expr_inside_var        := pi_expr_json.get_string( key => ''insideVariable'' );',
'    l_return.expr_description       := pi_expr_json.get_string( key => ''description'');',
'',
'    apex_debug.message (p_message => ''get_expression_details - results.  expr_value %0 expr_type %1 expr_fmt %2 expr_inside_var %3 expr_desc %4''',
'    , p0 => l_return.expr_value',
'    , p1 => l_return.expr_type',
'    , p2 => l_return.expr_fmt',
'    , p3 => l_return.expr_inside_var',
'    , p4 => l_return.expr_description',
'    );',
'    return l_return;',
'  end get_expression_details;',
'',
'  function get_expression_details( pi_expr_data in flow_objects.objt_attributes%type )',
'    return expression_details_t',
'  as',
'    l_expr_json sys.json_object_t;',
'    l_return    expression_details_t;',
'  begin',
'    l_expr_json        := sys.json_object_t( jsn => pi_expr_data );',
'    return get_expression_details (pi_expr_json => l_expr_json);',
'  end get_expression_details;',
'',
'  function get_due_on',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type default null',
'  , pi_expr          flow_objects.objt_attributes%type',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return timestamp with time zone',
'  is',
'',
'    l_expr_details      expression_details_t;',
'    l_result_rec        flow_proc_vars_int.t_proc_var_value;',
'    l_return_tstz       timestamp with time zone;',
'',
'    e_invalid_interval_spec    exception;',
'    pragma exception_init (e_invalid_interval_spec , -1867);  ',
'',
'  begin',
'    apex_debug.enter',
'    ( p_routine_name => ''flow_settings.get_due_on''',
'    , p_name01       => ''scope''',
'    , p_value01      => pi_scope',
'    , p_name02       => ''expr''',
'    , p_value02      => substr(pi_expr, 4000)',
'    );',
'',
'    l_expr_details := get_expression_details( pi_expr_data  => pi_expr );',
'',
'    apex_debug.message',
'    ( p_message => '' --- JSON Content - expression type: %1, expression :%0, formatMask :%2''',
'    , p0        => substr(l_expr_details.expr_value, 4000)',
'    , p1        => l_expr_details.expr_type',
'    , p2        => l_expr_details.expr_fmt',
'    );',
'',
'    if l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_static ',
'                                   , flow_constants_pkg.gc_date_value_type_interval',
'                                   , flow_constants_pkg.gc_date_value_type_oracle_scheduler',
'                                   ) then',
'      -- static types - timestamp, duration and scheduler statics - start by doing substitutions',
'      flow_proc_vars_int.do_substitution',
'        ( pi_prcs_id => pi_prcs_id',
'        , pi_sbfl_id => pi_sbfl_id',
'        , pi_scope   => pi_scope',
'        , pio_string => l_expr_details.expr_value ',
'        );',
'    end if;',
'',
'    case ',
'    when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_static then    ',
'      if l_expr_details.expr_fmt is null then',
'        -- log warning then try to use the F4A default mask',
'        flow_logging.log_instance_event ( p_process_id      => pi_prcs_id',
'                                        , p_event           => flow_constants_pkg.gc_prcs_event_warning',
'                                        , p_comment         => ''Timestamp formatMask not present.   Attempting to convert using default Flows for APEX format''',
'                                        );',
'        l_expr_details.expr_fmt := flow_constants_pkg.gc_prov_default_tstz_format;',
'      end if;',
'      l_return_tstz := to_timestamp_tz ( l_expr_details.expr_value, l_expr_details.expr_fmt);',
'    when l_expr_details.expr_type = flow_constants_pkg.gc_date_value_type_interval then',
'      l_return_tstz := systimestamp + to_dsinterval( l_expr_details.expr_value );',
'    when l_exp'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'r_details.expr_type = flow_constants_pkg.gc_date_value_type_oracle_scheduler then',
'      sys.dbms_scheduler.evaluate_calendar_string ( calendar_string   => l_expr_details.expr_value',
'                                                  , start_date        => systimestamp -- to get correct TZ, should this be localtimestamp?',
'                                                  , return_date_after => systimestamp',
'                                                  , next_run_date     => l_return_tstz',
'                                                  );',
'      l_return_tstz := l_return_tstz;',
'',
'    when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_proc_var then',
'      l_return_tstz := flow_proc_vars_int.get_var_tstz  ( pi_prcs_id    => pi_prcs_id',
'                                                        , pi_var_name   => l_expr_details.expr_value',
'                                                        , pi_scope      => pi_scope',
'                                                        );       ',
'  ',
'    when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_sql then',
'      l_result_rec := flow_db_exec.exec_flows_sql ',
'                      ( pi_prcs_id      => pi_prcs_id',
'                      , pi_sbfl_id      => pi_sbfl_id',
'                      , pi_sql_text     => l_expr_details.expr_value',
'                      , pi_result_type  => flow_constants_pkg.gc_prov_var_type_tstz',
'                      , pi_scope        => pi_scope',
'                      , pi_expr_type    => flow_constants_pkg.gc_expr_type_sql ',
'                      );',
'      l_return_tstz := l_result_rec.var_tstz;',
'    when l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_plsql_function_body ',
'                                     , flow_constants_pkg.gc_expr_type_plsql_raw_function_body ',
'                                     , flow_constants_pkg.gc_expr_type_plsql_expression',
'                                     , flow_constants_pkg.gc_expr_type_plsql_raw_expression )   ',
'    then',
'      l_result_rec := flow_db_exec.exec_flows_plsql ',
'                      ( pi_prcs_id      => pi_prcs_id',
'                      , pi_sbfl_id      => pi_sbfl_id',
'                      , pi_plsql_text   => l_expr_details.expr_value',
'                      , pi_result_type  => flow_constants_pkg.gc_prov_var_type_tstz',
'                      , pi_scope        => pi_scope',
'                      , pi_expr_type    => l_expr_details.expr_type ',
'                      );',
'      l_return_tstz := l_result_rec.var_tstz;',
'    else ',
'      l_return_tstz := null;',
'    end case;',
'    return l_return_tstz;',
'  exception',
'    when e_invalid_interval_spec then',
'      apex_debug.info ',
'      ( p_message => '' --- Error evaluating Due On.  Interval expression is invalid.  Interval: %0.''',
'      , p0        => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''due-on-interval-error''',
'      , p0                => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      -- $F4AMESSAGE ''due-on-interval-error'' || ''Error evaluating Due On.  Interval expression is invalid.  Interval: %0.''  ',
'      return null;  ',
'    when others then',
'      apex_debug.info ',
'      ( p_message => '' --- Error evaluating Due On.  Due On expression is invalid.  Interval Expression: %0.  ''',
'      , p0 => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''due-on-error''',
'      , p0 => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      -- $F4AMESSAGE ''due-on-error'' || ''Error evaluating Due On.  Due On expression is invalid.  Interval Expression: %0.''  ',
'      return null;  ',
'  end get_due_on;',
'',
'  function get_priority',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type default null',
'  , pi_expr          flow_types_pkg.t_bpmn_attribute_vc2',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return flow_processes.prcs_priority%type',
'  is',
'    l_expr_details                expression_details_t;',
'    l_result_rec                  flow_proc_vars_int.t_proc_var_value;',
'    l_priority                    flow_processes.prcs_priority%type;',
'',
'    e_param_proc_var_invalid_type exception;',
'    e_param_expr_invalid_type     exception;',
'    e_priority_invalid            exception;',
'  begin',
'',
'    l_expr_details := get_expression_details( pi_expr_data  => pi_expr );',
'',
'    case ',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_static then',
'        flow_proc_vars_int.do_substitution ',
'        ( pi_prcs_id   => pi_prcs_id',
'        , pi_sbfl_id   => pi_sbfl_id',
'        , pi_scope     => pi_scope',
'        , pio_string   => l_expr_details.expr_value',
'        );',
'        apex_debug.info (P_message => ''Set Priority Evaluation : %0 '', p0 => to_number (l_expr_details.expr_value));',
'        l_priority := to_number (l_expr_details.expr_value);',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_proc_var then',
'        if l_expr_details.expr_value = flow_constants_pkg.gc_substitution_process_priority then',
'          select prcs_priority',
'            into l_priority',
'            from flow_processes',
'          where prcs_id = pi_prcs_id; ',
'        else',
'          case flow_proc_vars_int.get_var_type ( pi_prcs_id   => pi_prcs_id',
'                                              , pi_var_name  => l_expr_details.expr_value',
'                                              , pi_scope     => pi_scope',
'                                              )',
'          when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'            l_priority :=  to_number ( flow_proc_vars_int.get_var_vc2 ( pi_prcs_id   => pi_prcs_id',
'                                                                      , pi_scope     => pi_scope',
'                                                                      , pi_var_name  => l_expr_details.expr_value',
'                                                                      ) );',
'          when flow_constants_pkg.gc_prov_var_type_number then',
'            l_priority :=  flow_proc_vars_int.get_var_num ( pi_prcs_id   => pi_prcs_id',
'                                                          , pi_scope     => pi_scope',
'                                                          , pi_var_name  => l_expr_details.expr_value',
'                                                          );',
'          else',
'            raise e_param_proc_var_invalid_type;',
'          end case;',
'        end if;',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_sql then',
'        l_result_rec := flow_db_exec.exec_flows_sql ',
'                        ( pi_prcs_id      => pi_prcs_id',
'                        , pi_sbfl_id      => pi_sbfl_id',
'                        , pi_sql_text     => l_expr_details.expr_value',
'                        , pi_result_type  => flow_constants_pkg.gc_prov_var_type_number',
'                        , pi_scope        => pi_scope',
'                        , pi_expr_type    => flow_constants_pkg.gc_expr_type_sql ',
'                        );',
'        l_priority := l_result_rec.var_num;',
'      when l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_plsql_expression ',
'                                , flow_constants_pkg.gc_expr_type_plsql_raw_expression',
'                                , flow_constants_pkg.gc_expr_type_plsql_function_body',
'                                , flow_constants_pkg.gc_expr_type_plsql_raw_function_body) ',
'      then',
'        l_result_rec := flow_db_exec.exec_flows_plsql ',
'                        ( pi_prcs_id      => pi_prcs_id',
'                        , pi_sbfl_id      => pi_sbfl_id',
'                        , pi_plsql_text   => l_expr_details.expr_value',
'                        , pi_result_type  => flow_constants_pkg.gc_prov_var_type_number',
'                        , pi_scope        => pi_scope',
'                        , pi_expr_type    => l_expr_details.expr_type ',
'                        );',
'        l_priority := l_result_rec.var_num;',
'      else',
'        pragma coverage (''not_feasible'');',
'        raise e_param_expr_invalid_type;',
'    end case;',
'    -- test priority is valid (1-5)',
'    if l_priority not between 1 and 5 then',
'      raise e_priority_invalid;',
'    end if;',
'    return l_priority;',
'  exception',
'    when e_priority_invalid then',
'      apex_debug.info ',
'      ( p_message => '' --- Error evaluating Priority.  Priority be between 1 and 5.  Priority: %0''',
'      , p0 => l_priority',
'      );  ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''apex-task-priority-error''',
'      , p0 => l_priority',
'      );  ',
'      -- $F4AMESSAGE ''apex-task-priority-error'' || ''Error evaluating Priority.  Priority must be between 1 and 5.  Priority: %0. Priority 3 used instead.''   ',
'      return null; ',
'    when others then ',
'      apex_debug.info ',
'      ( p_message => '' --- Error evaluating Priority.  Priority expression is invalid.  Expression: %0.  priority 3 returned.''',
'      , p0        => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''settings-priority-error''',
'      , p0             => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      -- $F4AMESSAGE ''settings-priority-error'' || ''Error evaluating Priority. Priority expression is invalid.  Expression: %0.  Priority 3 used instead.''  ',
'      return 3;',
'  end get_priority;',
'',
'  function get_vc2_expression',
'  ( pi_prcs_id       flow_processes.prcs_id%type default null',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type default null',
'  , pi_expr          flow_types_pkg.t_bpmn_attribute_vc2 default null',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return flow_types_pkg.t_bpmn_attribute_vc2',
'  is',
'    l_expr_details expression_details_t;',
'    l_result_rec   flow_proc_vars_int.t_proc_var_value;',
'    l_return_value flow_types_pkg.t_bpmn_attribute_vc2;',
'',
'    e_param_proc_var_invalid_type exception;',
'    e_param_expr_invalid_type     exception;',
'    e_param_type_requires_prcs_id exception;',
'  begin',
'    apex_debug.enter ',
'    ( ''get_vc2_expression''',
'    , ''pi_expr''   , pi_expr',
'    );',
'    ',
'    if pi_expr is null then',
'      return null;',
'    end if;',
'',
'    l_expr_details := get_expression_details( pi_expr_data  => pi_expr );',
'',
'   case ',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_static then',
'        flow_proc_vars_int.do_substitution ',
'        ( pi_prcs_id   => pi_prcs_id',
'        , pi_sbfl_id   => pi_sbfl_id',
'        , pi_scope     => pi_scope',
'        , pio_string   => l_expr_details.expr_value',
'        );',
'        l_return_value := l_expr_details.expr_value;',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_proc_var then',
'        if pi_prcs_id is null then ',
'          -- proc var setting type cannot be used without a prcs_id',
'          raise e_param_type_requires_prcs_id; ',
'        end if;',
'        case flow_proc_vars_int.get_var_type ( pi_prcs_id   => pi_prcs_id',
'                                             , pi_var_name  => l_expr_details.expr_value',
'                                             , pi_scope     => pi_scope',
'                                             )',
'          when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'            l_return_value := ( flow_proc_vars_int.get_var_vc2  ( pi_prcs_id   => pi_prcs_id',
'                                                                , pi_scope     => pi_scope',
'                                                                , pi_var_name  => l_expr_details.expr_value',
'                                                                ) );',
'          when flow_constants_pkg.gc_prov_var_type_number then',
'            l_return_value := to_char ( flow_proc_vars_int.get_var_num  ( pi_prcs_id   => pi_prcs_id',
'                                                                , pi_scope     => pi_scope',
'                                                                , pi_var_name  => l_expr_details.expr_value',
'                                                                ) );',
'          when flow_constants_pkg.gc_prov_var_type_clob then',
'            l_return_value := ( flow_proc_vars_int.get_var_clob ( pi_prcs_id   => pi_prcs_id',
'                                                                , pi_scope     => pi_scope',
'                                                                , pi_var_name  => l_expr_details.expr_value',
'                                                                ) );                                                         ',
'          else',
'            raise e_param_proc_var_invalid_type;',
'          end case;',
'      when l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_sql, flow_constants_pkg.gc_expr_type_sql_delimited_list ) then',
'        l_result_rec := flow_db_exec.exec_flows_sql',
'                        ( pi_prcs_id      => pi_prcs_id',
'                        , pi_sbfl_id      => pi_sbfl_id',
'                        , pi_sql_text     => l_expr_details.expr_value',
'                        , pi_result_type  => flow_constants_pkg.gc_prov_var_type_varchar2',
'                        , pi_scope        => pi_scope',
'                        , pi_expr_type    => l_expr_details.expr_type',
'                        );',
'        l_return_value := l_result_rec.var_vc2;',
'      when l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_plsql_expression ',
'                                       , flow_constants_pkg.gc_expr_type_plsql_raw_expression ',
'                                       , flow_constants_pkg.gc_expr_type_plsql_function_body',
'                                       , flow_constants_pkg.gc_expr_type_plsql_raw_function_body',
'                                       )',
'      then',
'        l_result_rec := flow_db_exec.exec_flows_plsql ',
'                        ( pi_prcs_id      => pi_prcs_id',
'                        , pi_sbfl_id      => pi_sbfl_id',
'                        , pi_plsql_text   => l_expr_details.expr_value',
'                        , pi_result_type  => flow_constants_pkg.gc_prov_var_type_varchar2',
'                        , pi_scope        => pi_scope',
'                        , pi_expr_type    => l_expr_details.expr_type ',
'                        );',
'        l_return_value := l_result_rec.var_vc2;',
'      else',
'        raise e_param_expr_invalid_type;',
'    end case;',
'    return l_return_value;',
'  exception',
'    when e_param_type_requires_prcs_id then',
'      flow_errors.handle_general_error (pi_message_key => ''settings-procvar-no-prcs'');',
'      return null;',
'      -- $F4AMESSAGE ''settings-procvar-no-prcs'' || ''Settings cannot specify Process Variable without a Process ID.''',
'    when others then ',
'      apex_debug.info ',
'      ( p_message => '' --- Error evaluating Setting.  Expression is invalid.  Expression: %0. SQL Error: %1''',
'      , p0 => substr(l_expr_details.expr_value, 4000)',
'      , p1 => sqlerrm',
'      );  ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_message_key    => ''settings-error''',
'      , p0 => substr(l_expr_details.expr_value, 4000)',
'      , p1 => sqlerrm',
'      ); ',
'      return null;',
'      -- $F4AMESSAGE ''settings-error'' || ''Error evaluating Setting. Expression is invalid.  Expression: %0. SQL Error: %1'' ',
'  end get_vc2_expression;',
'',
'  function get_clob_expression',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type',
'  , pi_expr          clob',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return clob',
'  is',
'    l_expr_details expression_details_t;',
'    l_return_value clob;',
'    l_result_rec   flow_proc_vars_int.t_proc_var_value;',
'',
'    e_param_proc_var_invalid_type exception;',
'    e_param_expr_invalid_type     exception;',
'  begin',
'    apex_debug.enter ',
'    ( p_routine_name => ''get_clob_expression''',
'    , p_name01       => ''pi_expr''',
'    , p_value01      => dbms_lob.substr(pi_expr, 4000)',
'    );',
'',
'    l_expr_details := get_expression_details( pi_expr_data  => pi_expr );',
'',
'   case ',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_static then',
'        flow_proc_vars_int.do_substitution ',
'        ( pi_prcs_id   => pi_prcs_id',
'        , pi_sbfl_id   => pi_sbfl_id',
'        , pi_scope     => pi_scope',
'        , pio_string   => l_expr_details.expr_value',
'        );',
'        l_return_value := l_expr_details.expr_value;',
'      when l_expr_details.expr_type = flow_constants_pkg.gc_expr_type_proc_var then',
'        case flow_proc_vars_int.get_var_type ( pi_prcs_id   => pi_prcs_id',
'                                             , pi_var_name  => l_expr_details.expr_value',
'                                             , pi_scope     => pi_scope',
'                                             )',
'        when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'          l_return_value := ( flow_proc_vars_int.get_var_vc2  ( pi_prcs_id   => pi_prcs_id',
'                                                              , pi_scope     => pi_scope',
'                                                              , pi_var_name  => l_expr_details.expr_value',
'                                                              ) );',
'        when flow_constants_pkg.gc_prov_var_type_clob then',
'          l_return_value := ( flow_proc_vars_int.get_var_clob ( pi_prcs_id   => pi_prcs_id',
'                                                              , pi_scope     => pi_scope',
'                                                              , pi_var_name  => l_expr_details.expr_value',
'                                                              ) );',
'        else',
'          raise e_param_proc_var_invalid_type;',
'        end case;',
'      when l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_sql, flow_constants_pkg.gc_expr_type_sql_delimited_list ) then',
'        l_result_rec := flow_db_exec.exec_flows_sql',
'                        ( pi_prcs_id      => pi_prcs_id',
'                        , pi_sbfl_id      => pi_sbfl_id',
'                        , pi_sql_text     => l_expr_details.expr_value',
'                        , pi_result_type  => flow_constants_pkg.gc_prov_var_type_varchar2',
'                        , pi_scope        => pi_scope',
'                        , pi_expr_type    => l_expr_details.expr_type',
'                        );',
'        l_return_value := l_result_rec.var_vc2;',
'      when l_expr_details.expr_type in ( flow_constants_pkg.gc_expr_type_plsql_expression ',
'                                       , flow_constants_pkg.gc_expr_type_plsql_raw_expression ',
'                                       , flow_constants_pkg.gc_expr_type_plsql_function_body',
'                                       , flow_constants_pkg.gc_expr_type_plsql_raw_function_body',
'                                       )',
'      then',
'        l_result_rec := flow_db_exec.exec_flows_plsql ',
'                        ( pi_prcs_id      => pi_prcs_id',
'                        , pi_sbfl_id      => pi_sbfl_id',
'                        , pi_plsql_text   => l_expr_details.expr_value',
'                        , pi_result_type  => flow_constants_pkg.gc_prov_var_type_varchar2',
'                        , pi_scope        => pi_scope',
'                        , pi_expr_type    => l_expr_details.expr_type ',
'                        );',
'        l_return_value := l_result_rec.var_vc2;',
'      else',
'        raise e_param_expr_invalid_type;',
'    end case;',
'    return l_return_value;',
'  exception',
'    when others then',
'      apex_debug.info ',
'      ( p_message => '' --- Error evaluating Setting.  Expression is invalid.  Expression: %0. ''',
'      , p0        => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_message_key => ''settings-error''',
'      , p0             => substr(l_expr_details.expr_value, 4000)',
'      );  ',
'      -- $F4AMESSAGE ''settings-error'' || ''Error evaluating Setting. Expression is invalid.  Expression: %0.'' ',
'      return null;',
'  end get_clob_expression;',
'',
'  function get_endpoint',
'  ( pi_prcs_id       flow_processes.prcs_id%type',
'  , pi_sbfl_id       flow_subflows.sbfl_id%type',
'  , pi_expr          flow_types_pkg.t_bpmn_attribute_vc2',
'  , pi_scope         flow_subflows.sbfl_scope%type default 0',
'  ) return   flow_types_pkg.t_bpmn_attribute_vc2',
'  is',
'  begin',
'    return get_vc2_expression ( pi_prcs_id     => pi_prcs_id',
'                              , pi_sbfl_id     => pi_sbfl_id',
'                              , pi_expr        => pi_expr',
'                              , pi_scope       => pi_scope',
'                              );',
'  end get_endpoint;',
'',
'  function get_iteration_settings',
'  ( pi_expr          sys.json_object_t',
'  ) return   flow_types_pkg.t_iteration_vars',
'  is',
'    l_settings       flow_types_pkg.t_iteration_vars;',
'    l_details        expression_details_t;',
'  begin',
'    apex_debug.enter ( ''get_iteration_settings'');',
'    l_details := get_expression_details ( pi_expr_json  => pi_expr);',
'',
'    l_settings.type              := l_details.expr_type;',
'    case  l_settings.type ',
'    when flow_constants_pkg.gc_expr_type_sql_json_array then',
'          l_settings.collection_expr   := l_details.expr_value;',
'    else ',
'          l_settings.collection_var    := l_details.expr_value;',
'    end case;',
'    l_settings.inside_var        := l_details.expr_inside_var;',
'    l_settings.description       := l_details.expr_description;',
'    return l_settings;',
'  end get_iteration_settings;   ',
'',
'end flow_settings;',
'/',
'',
'create or replace package body flow_db_exec',
'as ',
'/* ',
'-- Flows for APEX - flow_db_exec.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created  08-Dec-2022  Richard Allen (Oracle Corporation)',
'-- Changed  21-FEB-2023  Moritz Klein (MT GmbH)',
'-- Changed  11-Feb-2024  Richard Allen (Flowquest)',
'--',
'*/',
'',
'  function exec_flows_sql',
'  ( pi_prcs_id        flow_processes.prcs_id%type default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_sql_text       varchar2',
'  , pi_result_type    varchar2  ',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  as  ',
'    l_sql_text        varchar2(4000) := pi_sql_text;',
'    l_bind_parameters apex_exec.t_parameters;',
'    l_context         apex_exec.t_context;',
'    l_result_column   apex_exec.t_column;',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'    l_result_set_vc2  apex_t_varchar2;',
'    l_result          flow_process_variables.prov_var_vc2%type;',
'    l_indx            pls_integer;',
'',
'    e_var_exp_must_return_one_column exception;',
'    e_var_exp_sql_too_many_rows      exception;',
'  begin',
'      apex_debug.enter',
'    ( ''flow_expressions.exec_flows_sql''',
'    , ''type'', pi_result_type',
'    , ''sql text'' , pi_sql_text',
'    );',
'    l_result_rec.var_name   := ''result'';',
'    l_result_rec.var_type   := pi_result_type;',
'',
'    l_sql_text := rtrim ( l_sql_text, '';'');',
'',
'    if pi_prcs_id is not null then',
'      -- substitute any F4A Process Variables',
'      flow_proc_vars_int.do_substitution',
'      ( pi_prcs_id => pi_prcs_id',
'      , pi_sbfl_id => pi_sbfl_id',
'      , pi_scope   => pi_scope',
'      , pio_string => l_sql_text',
'      );',
'      -- get bind parameters',
'      l_bind_parameters := flow_proc_vars_int.get_parameter_list',
'                              ( pi_expr               => l_sql_text',
'                              , pi_prcs_id            => pi_prcs_id',
'                              , pi_sbfl_id            => pi_sbfl_id',
'                              , pi_scope              => pi_scope',
'                              );',
'    end if;',
'    l_context := apex_exec.open_query_context',
'                      ( p_location          => apex_exec.c_location_local_db',
'                      , p_sql_query         => l_sql_text',
'                      , p_sql_parameters    => l_bind_parameters',
'                      , p_total_row_count   => true',
'                      );',
'',
'    -- check row and column limits for single and list options for ',
'    if (   pi_expr_type in ( flow_constants_pkg.gc_expr_type_sql ',
'                           , flow_constants_pkg.gc_expr_type_sql_delimited_list)',
'       and apex_exec.get_column_count (p_context => l_context) <> 1 )',
'    then',
'      raise e_var_exp_must_return_one_column;',
'    end if;',
'    if (   pi_expr_type = flow_constants_pkg.gc_expr_type_sql ',
'       and apex_exec.get_total_row_count (p_context => l_context) > 1  )    ',
'    then',
'      raise e_var_exp_sql_too_many_rows;',
'    end if;',
'    -- for SQl Single we can return several datatypes, and convert to other datatypes',
'    -- for SQl multi, we can only return vc2 or number datatypes, but need to loop to return into array',
'    -- and then build concatenated colon separated string',
'    if pi_expr_type = flow_constants_pkg.gc_expr_type_sql  then',
'      -- SQl Single row',
'      -- result must be in only row/column returned',
'      if apex_exec.next_row (p_context => l_context) then',
'        -- if query returns values, set them.  If not, all values will be null (correctly)',
'        l_result_column := apex_exec.get_column ( p_context => l_context',
'                                                , p_column_idx => 1',
'                                                );',
'        case pi_result_type ',
'        when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'          if l_result_column.data_type = apex_exec.c_data_type_varchar2 then',
'            l_result_rec.var_vc2 := apex_exec.get_varchar2  ( p_context => l_context',
'                                                            , p_column_idx => 1',
'                                                            );',
'          elsif l_result_column.data_type = apex_exec.c_data_type_date then',
'            l_result_rec.var_vc2 := to_char ( apex_exec.get_date ( p_context => l_context',
'                                                                 , p_column_idx => 1 )',
'                                            , flow_constants_pkg.gc_prov_default_date_format',
'                                            );',
'          elsif l_result_column.data_type = apex_exec.c_data_type_number then',
'            l_result_rec.var_vc2 := to_char ( apex_exec.get_number ( p_context => l_context',
'                                                                   , p_column_idx => 1 )',
'                                            );',
'          elsif l_result_column.data_type = apex_exec.c_data_type_timestamp_tz then',
'            l_result_rec.var_vc2 := to_char ( apex_exec.get_timestamp_tz ( p_context => l_context',
'                                                                         , p_column_idx => 1 )',
'                                            , flow_constants_pkg.gc_prov_default_tstz_format',
'                                            );',
'          -- add conversion CLOB to varchar2 if length OK?',
'          end if;',
'',
'        when flow_constants_pkg.gc_prov_var_type_date then',
'          if l_result_column.data_type = apex_exec.c_data_type_date then',
'            l_result_rec.var_date := apex_exec.get_date ( p_context => l_context',
'                                                        , p_column_idx => 1 );',
'          elsif l_result_column.data_type = apex_exec.c_data_type_varchar2 then',
'            begin',
'              l_result_rec.var_date := to_date ( apex_exec.get_varchar2 ( p_context => l_context',
'                                                                        , p_column_idx => 1 )',
'                                               , flow_constants_pkg.gc_prov_default_date_format',
'                                               );  ',
'            exception',
'              when others then',
'                l_result_rec.var_date := null;',
'            end;',
'          elsif l_result_column.data_type = apex_exec.c_data_type_timestamp_tz then',
'            l_result_rec.var_date := cast (apex_exec.get_timestamp_tz ( p_context => l_context',
'                                                        , p_column_idx => 1 )',
'                                          as date );',
'          end if;',
'',
'        when flow_constants_pkg.gc_prov_var_type_number then',
'          if l_result_column.data_type = apex_exec.c_data_type_number then',
'            l_result_rec.var_num := apex_exec.get_number ( p_context => l_context',
'                                                         , p_column_idx => 1 );',
'          elsif l_result_column.data_type = apex_exec.c_data_type_varchar2 then',
'            begin',
'              l_result_rec.var_num := to_number ( apex_exec.get_varchar2 ( p_context => l_context',
'                                                                         , p_column_idx => 1 )',
'                                                );  ',
'            exception',
'              when others then',
'                l_result_rec.var_num := null;',
'            end;',
'          end if;',
'',
'',
'        when flow_constants_pkg.gc_prov_var_type_tstz then',
'          if l_result_column.data_type = apex_exec.c_data_type_timestamp_tz then',
'            l_result_rec.var_tstz := apex_exec.get_timestamp_tz ( p_context => l_context',
'                                                              , p_column_idx => 1 );',
'          elsif l_result_column.data_type = apex_exec.c_data_type_varchar2 then',
'            begin',
'              l_result_rec.var_tstz := to_timestamp_tz ( apex_exec.get_varchar2 ( p_context => l_context',
'                                                                              , p_column_idx => 1 )',
'                                                     , flow_constants_pkg.gc_prov_default_tstz_format',
'                                                     );  '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'            exception',
'              when others then',
'                l_result_rec.var_tstz := null;',
'            end;',
'          elsif l_result_column.data_type = apex_exec.c_data_type_date then',
'            -- convert date to timestamp_tz using current session timezone',
'             l_result_rec.var_tstz := cast (apex_exec.get_date ( p_context => l_context',
'                                                              , p_column_idx => 1 )',
'                                          as timestamp with time zone);         ',
'          end if;',
'        end case;',
'      end if;',
'    elsif pi_expr_type = flow_constants_pkg.gc_expr_type_sql_delimited_list  then',
'      -- get the returned column info...',
'      l_result_column := apex_exec.get_column ( p_context => l_context',
'                                              , p_column_idx => 1',
'                                              );',
'      l_result_set_vc2 := apex_t_varchar2();',
'      loop ',
'        -- result must be in only row/column returned',
'        exit when not apex_exec.next_row (p_context => l_context); ',
'        l_result_set_vc2.extend;',
'        l_indx := l_result_set_vc2.last;',
'        if l_result_column.data_type = apex_exec.c_data_type_varchar2 then',
'          l_result_set_vc2(l_indx)  := apex_exec.get_varchar2  ( p_context => l_context',
'                                                               , p_column_idx => 1',
'                                                               );',
'        elsif l_result_column.data_type = apex_exec.c_data_type_number then',
'          l_result_set_vc2(l_indx)  := to_char ( apex_exec.get_number ( p_context => l_context',
'                                                                      , p_column_idx => 1 )',
'                                               );',
'        end if;',
'      end loop; ',
'      -- create delimited string output',
'      l_result_rec.var_vc2 := apex_string.join',
'                            ( p_table => l_result_set_vc2',
'                            , p_sep => '':''',
'                            );',
'      apex_debug.message(p_message => ''Delimited String created %s'', p0 => l_result_rec.var_vc2, p_level => 3);',
'    elsif pi_expr_type = flow_constants_pkg.gc_expr_type_sql_json_array  then',
'      ',
'      apex_json.initialize_clob_output (p_preserve => true);',
'      apex_json.write_context ( p_name       => null',
'                              , p_context    => l_context',
'                              , p_write_null => true);',
'      l_result_rec.var_json := apex_json.get_clob_output;',
'      apex_json.free_output;',
'      apex_debug.message(p_message => ''JSON Array created %s'', p0 => l_result_rec.var_json, p_level => 3);',
'    end if;',
'    -- close the cursor',
'    apex_exec.close (l_context);',
'    return l_result_rec;',
'  exception',
'    when e_var_exp_sql_too_many_rows then',
'      apex_exec.close (l_context);',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''exec_sql_too_many_rows''',
'      );',
'      -- $F4AMESSAGE ''var_exp_sql_too_many_rows'' || ''Error executing SQL Query - query returns more than one row.''  ',
'    when e_var_exp_must_return_one_column then',
'      apex_exec.close (l_context);',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''exec_sql_too_many_values''',
'      );',
'      -- $F4AMESSAGE ''exec_sql_too_many_cols'' || ''Error executing SQl Query - query returns more than one column.''  ',
'    when others then',
'      apex_debug.error',
'      ( p_message => ''Error executing SQL query for process id %1. SQLERRM: %2''',
'      , p1        => pi_prcs_id',
'      , p2        => sqlerrm',
'      );',
'      apex_exec.close (l_context);',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_sql_other''',
'      );',
'      -- $F4AMESSAGE ''exec_sql_other'' || ''Error executing SQL Query.  SQL error shown in event log.''    ',
'  end exec_flows_sql;',
'',
'  function exec_flows_plsql_vc2',
'  ( pi_prcs_id         flow_processes.prcs_id%type default null',
'  , pi_sbfl_id         flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text      varchar2',
'  , pi_scope           flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type       flow_types_pkg.t_expr_type',
'  , pi_bind_parameters apex_exec.t_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  is',
'    l_wrap_begin        varchar2(100);',
'    l_wrap_end          varchar2(100);',
'    l_expr              varchar2(4000) := pi_plsql_text;',
'    l_bind_parameters   apex_exec.t_parameters := pi_bind_parameters;',
'    l_result_rec        flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_db_exec.exec_flows_plsql_vc2''',
'    , ''plsql text'', pi_plsql_text',
'    );',
'    case ',
'    when pi_expr_type = flow_constants_pkg.gc_expr_type_plsql_expression ',
'      or pi_expr_type = flow_constants_pkg.gc_expr_type_plsql_raw_expression ',
'    then',
'      l_wrap_begin  := c_wrap_vc2_expr_pre;',
'      l_wrap_end    := c_wrap_vc2_expr_post;',
'    when pi_expr_type = flow_constants_pkg.gc_expr_type_plsql_function_body ',
'      or pi_expr_type = flow_constants_pkg.gc_expr_type_plsql_raw_function_body ',
'    then',
'      l_wrap_begin  := c_wrap_vc2_func_pre;',
'      l_wrap_end    := c_wrap_vc2_func_post;',
'    end case;',
'',
'    apex_exec.add_parameter ( l_bind_parameters, ''BIND_OUT_VAR'','''');',
'',
'    apex_exec.execute_plsql(',
'        p_plsql_code      => l_wrap_begin||pi_plsql_text||l_wrap_end,',
'        p_auto_bind_items => false,',
'        p_sql_parameters  => l_bind_parameters );',
'',
'    l_result_rec.var_vc2  := apex_exec.get_parameter_varchar2',
'                             ( p_parameters => l_bind_parameters',
'                             , p_name       => ''BIND_OUT_VAR''); ',
'',
'    l_result_rec.var_name   := ''result'';',
'    l_result_rec.var_type   := flow_constants_pkg.gc_prov_var_type_varchar2;',
'',
'    return l_result_rec;   ',
'  end exec_flows_plsql_vc2;',
'',
'  function exec_flows_plsql_num',
'  ( pi_prcs_id        flow_processes.prcs_id%type default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text     varchar2',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  , pi_bind_parameters apex_exec.t_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  is',
'    l_wrap_begin      varchar2(100);',
'    l_wrap_end        varchar2(100);',
'    l_expr            varchar2(4000) := pi_plsql_text;',
'    l_bind_parameters apex_exec.t_parameters := pi_bind_parameters;',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_db_exec.exec_flows_plsql_num''',
'    , ''plsql text'', pi_plsql_text',
'    );',
'    case ',
'    when pi_expr_type  = flow_constants_pkg.gc_expr_type_plsql_expression then',
'      l_wrap_begin  := c_wrap_num_expr_pre;',
'      l_wrap_end    := c_wrap_num_expr_post;',
'    when pi_expr_type = flow_constants_pkg.gc_expr_type_plsql_raw_expression then',
'      l_wrap_begin  := c_wrap_num_raw_expr_pre;',
'      l_wrap_end    := c_wrap_num_raw_expr_post;',
'    when pi_expr_type  = flow_constants_pkg.gc_expr_type_plsql_function_body then',
'      l_wrap_begin  := c_wrap_num_func_pre;',
'      l_wrap_end    := c_wrap_num_func_post;',
'    when pi_expr_type  = flow_constants_pkg.gc_expr_type_plsql_raw_function_body then',
'      l_wrap_begin  := c_wrap_num_raw_func_pre;',
'      l_wrap_end    := c_wrap_num_raw_func_post;',
'    end case;',
'',
'    apex_exec.add_parameter ( l_bind_parameters, ''BIND_OUT_VAR'','''');',
'',
'    apex_exec.execute_plsql(',
'        p_plsql_code      => l_wrap_begin||pi_plsql_text||l_wrap_end,',
'        p_auto_bind_items => false,',
'        p_sql_parameters  => l_bind_parameters );',
'',
'    l_result_rec.var_num  := cast ( apex_exec.get_parameter_varchar2',
'                                    ( p_parameters => l_bind_parameters',
'                                    , p_name       => ''BIND_OUT_VAR'')',
'                                  as number ); ',
'',
'    l_result_rec.var_name   := ''result'';',
'    l_result_rec.var_type   := flow_constants_pkg.gc_prov_var_type_number;',
'',
'    apex_debug.message(p_message => ''Number result %0'', p0 => l_result_rec.var_num, p_level => 3);',
'',
'    return l_result_rec;   ',
'  end exec_flows_plsql_num;',
'',
'  function exec_flows_plsql_date',
'  ( pi_prcs_id        flow_processes.prcs_id%type default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text     varchar2',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  , pi_bind_parameters apex_exec.t_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  is',
'    l_wrap_begin      varchar2(100);',
'    l_wrap_end        varchar2(100);',
'    l_expr            varchar2(4000) := pi_plsql_text;',
'    l_bind_parameters apex_exec.t_parameters := pi_bind_parameters;',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_db_exec.exec_flows_plsql_date''',
'    , ''plsql text'', pi_plsql_text',
'    );',
'    case pi_expr_type ',
'    when flow_constants_pkg.gc_expr_type_plsql_expression then',
'      -- legacy mode - expression will return a vc2 in our format',
'      l_wrap_begin  := c_wrap_date_expr_pre;',
'      l_wrap_end    := c_wrap_date_expr_post;',
'    when flow_constants_pkg.gc_expr_type_plsql_raw_expression then',
'      -- new ''raw'' mode - expression will return a date',
'      l_wrap_begin  := c_wrap_date_raw_expr_pre;',
'      l_wrap_end    := c_wrap_date_raw_expr_post;',
'    when flow_constants_pkg.gc_expr_type_plsql_function_body then',
'      -- legacy mode - function will return a vc2 in our format',
'      l_wrap_begin  := c_wrap_date_func_pre;',
'      l_wrap_end    := c_wrap_date_func_post;',
'    when flow_constants_pkg.gc_expr_type_plsql_raw_function_body then',
'      -- new ''raw'' mode - function will return a date',
'      l_wrap_begin  := c_wrap_date_raw_func_pre;',
'      l_wrap_end    := c_wrap_date_raw_func_post;',
'    end case;',
'',
'    apex_exec.add_parameter ( l_bind_parameters, ''BIND_OUT_VAR'','''');',
'',
'    apex_exec.execute_plsql(',
'        p_plsql_code      => l_wrap_begin||pi_plsql_text||l_wrap_end,',
'        p_auto_bind_items => false,',
'        p_sql_parameters  => l_bind_parameters );',
'',
'    l_result_rec.var_date  := to_date ( apex_exec.get_parameter_varchar2',
'                                      ( p_parameters => l_bind_parameters',
'                                      , p_name       => ''BIND_OUT_VAR'')',
'                                     , flow_constants_pkg.gc_prov_default_date_format ); ',
'',
'    l_result_rec.var_name   := ''result'';',
'    l_result_rec.var_type   := flow_constants_pkg.gc_prov_var_type_date;',
'',
'    return l_result_rec;   ',
'  end exec_flows_plsql_date;',
'',
'  function exec_flows_plsql_tstz',
'  ( pi_prcs_id        flow_processes.prcs_id%type default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text     varchar2',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  , pi_bind_parameters apex_exec.t_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  is',
'    l_wrap_begin      varchar2(100);',
'    l_wrap_end        varchar2(100);',
'    l_expr            varchar2(4000) := pi_plsql_text;',
'    l_bind_parameters apex_exec.t_parameters := pi_bind_parameters;',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'    l_statement       varchar2(4000);',
'  begin',
'    apex_debug.enter',
'    ( ''flow_db_exec.exec_flows_plsql_tstz''',
'    , ''plsql text'', pi_plsql_text',
'    );',
'    case pi_expr_type ',
'    when flow_constants_pkg.gc_expr_type_plsql_expression then',
'      -- legacy mode - expression will return a vc2 in our format     ',
'      l_wrap_begin  := c_wrap_tstz_expr_pre;',
'      l_wrap_end    := c_wrap_tstz_expr_post;',
'    when flow_constants_pkg.gc_expr_type_plsql_raw_expression then',
'      -- new ''raw'' mode - expression will return a tstz      ',
'      l_wrap_begin  := c_wrap_tstz_raw_expr_pre;',
'      l_wrap_end    := c_wrap_tstz_raw_expr_post;',
'    when flow_constants_pkg.gc_expr_type_plsql_function_body then',
'      -- legacy mode - function will return a vc2 in our format   ',
'      l_wrap_begin  := c_wrap_tstz_func_pre;',
'      l_wrap_end    := c_wrap_tstz_func_post;',
'    when flow_constants_pkg.gc_expr_type_plsql_raw_function_body then',
'      -- new ''raw'' mode - function will return a tstz',
'      l_wrap_begin  := c_wrap_tstz_raw_func_pre;',
'      l_wrap_end    := c_wrap_tstz_raw_func_post;',
'    end case;',
'',
'    apex_exec.add_parameter ( l_bind_parameters, ''BIND_OUT_VAR'','''');',
'',
'    l_statement := l_wrap_begin||pi_plsql_text||l_wrap_end;',
'   ',
'    apex_exec.execute_plsql(',
'        p_plsql_code      => l_statement,',
'        p_auto_bind_items => false,',
'        p_sql_parameters  => l_bind_parameters );',
'',
'    l_result_rec.var_tstz  := to_timestamp_tz ( apex_exec.get_parameter_varchar2',
'                                                ( p_parameters => l_bind_parameters',
'                                                , p_name       => ''BIND_OUT_VAR'')',
'                                              , flow_constants_pkg.gc_prov_default_tstz_format ); ',
'',
'    l_result_rec.var_name   := ''result'';',
'    l_result_rec.var_type   := flow_constants_pkg.gc_prov_var_type_tstz;',
'',
'    return l_result_rec;   ',
'  end exec_flows_plsql_tstz;',
'',
'  function exec_flows_plsql_bool',
'  ( pi_prcs_id        flow_processes.prcs_id%type default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text     varchar2',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  , pi_bind_parameters apex_exec.t_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  is',
'    l_wrap_begin      varchar2(100);',
'    l_wrap_end        varchar2(100);',
'    l_expr            varchar2(4000) := pi_plsql_text;',
'    l_bind_parameters apex_exec.t_parameters := pi_bind_parameters;',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_db_exec.exec_flows_plsql_bool''',
'    , ''plsql text'', pi_plsql_text',
'    );',
'    case pi_expr_type ',
'    when flow_constants_pkg.gc_expr_type_plsql_expression then',
'      -- legacy mode - expression will return a vc2 in our format',
'      l_wrap_begin  := c_wrap_bool_expr_pre;',
'      l_wrap_end    := c_wrap_bool_expr_post;',
'  --  when flow_constants_pkg.gc_expr_type_plsql_raw_expression then',
'  --    -- new ''raw'' mode - expression will return a date',
'  --    l_wrap_begin  := c_wrap_bool_raw_expr_pre;',
'  --    l_wrap_end    := c_wrap_bool_raw_expr_post;',
'  --  when flow_constants_pkg.gc_expr_type_plsql_function_body then',
'  --    -- legacy mode - function will return a vc2 in our format',
'  --    l_wrap_begin  := c_wrap_bool_func_pre;',
'  --    l_wrap_end    := c_wrap_bool_func_post;',
'  --  when flow_constants_pkg.gc_expr_type_plsql_raw_function_body then',
'  --    -- new ''raw'' mode - function will return a date',
'  --    l_wrap_begin  := c_wrap_bool_raw_func_pre;',
'  --    l_wrap_end    := c_wrap_bool_raw_func_post;',
'    end case;',
'',
'    apex_exec.add_parameter ( l_bind_parameters, ''BIND_OUT_VAR'','''');',
'',
'    apex_exec.execute_plsql(',
'        p_plsql_code      => l_wrap_begin||pi_plsql_text||l_wrap_end,',
'        p_auto_bind_items => false,',
'        p_sql_parameters  => l_bind_parameters );',
'',
'    l_result_rec.var_vc2  :=  apex_exec.get_parameter_varchar2',
'                              ( p_parameters => l_bind_parameters',
'                              , p_name       => ''BIND_OUT_VAR'')',
'                              ; ',
'',
'    l_result_rec.var_name   := ''result'';',
'    l_result_rec.var_type   := flow_constants_pkg.gc_prov_var_type_varchar2;',
'',
'    return l_result_rec;   ',
'  end exec_flows_plsql_bool;',
'',
'  function exec_flows_plsql',
'  ( pi_prcs_id        flow_processes.prcs_id%type default null',
'  , pi_sbfl_id        flow_subflows.sbfl_id%type default null',
'  , pi_plsql_text     varchar2',
'  , pi_result_type    varchar2  ',
'  , pi_scope          flow_subflows.sbfl_scope%type default 0',
'  , pi_expr_type      flow_types_pkg.t_expr_type',
'  , pi_state_params   apex_exec.t_parameters default apex_exec.c_empty_parameters',
'  ) return flow_proc_vars_int.t_proc_var_value',
'  is',
'    l_wrap_begin      varchar2(100);',
'    l_wrap_end        varchar2(100);',
'    l_bind_parameters apex_exec.t_parameters;',
'    l_expr            varchar2(4000) := pi_plsql_text;',
'    l_result_rec      flow_proc_vars_int.t_proc_var_value;',
'  begin',
'    apex_debug.enter',
'    ( ''flow_db_exec.exec_flows_plsql''',
'    , ''plsql text'', pi_plsql_text',
'    , ''plsql type'' , pi_expr_type ',
'    );',
'    if pi_prcs_id is not null then',
'      -- substitute any F4A Process Variables',
'      flow_proc_vars_int.do_substitution',
'      ( pi_prcs_id => pi_prcs_id',
'      , pi_sbfl_id => pi_sbfl_id',
'      , pi_scope   => pi_scope',
'      , pio_string => l_expr',
'      );',
'',
'      -- strip any trailing ; as our wrapper code adds it.',
'      -- But only for expressions, functions need it still.',
'      if pi_expr_type in ( flow_constants_pkg.gc_expr_type_plsql_expression, flow_constants_pkg.gc_expr_type_plsql_raw_expression )',
'      then',
'        l_expr := rtrim(l_expr, '';'');',
'      end if;',
'',
'      -- get bind parameters',
'      l_bind_parameters := flow_proc_vars_int.get_parameter_list',
'                              ( pi_expr               => l_expr',
'                              , pi_prcs_id            => pi_prcs_id',
'                              , pi_sbfl_id            => pi_sbfl_id',
'                              , pi_scope              => pi_scope',
'                              , pi_state_params       => pi_state_params',
'                              );    ',
'    end if;',
'',
'    case pi_result_type ',
'    when flow_constants_pkg.gc_prov_var_type_varchar2 then ',
'      l_result_rec := exec_flows_plsql_vc2  ( pi_prcs_id         => pi_prcs_id',
'                                            , pi_sbfl_id         => pi_sbfl_id',
'                                            , pi_plsql_text      => l_expr',
'                                            , pi_scope           => pi_scope',
'                                            , pi_expr_type       => pi_expr_type',
'                                            , pi_bind_parameters => l_bind_parameters',
'                                            );',
'    when flow_constants_pkg.gc_prov_var_type_number then',
'      l_result_rec := exec_flows_plsql_num  ( pi_prcs_id         => pi_prcs_id',
'                                            , pi_sbfl_id         => pi_sbfl_id',
'                                            , pi_plsql_text      => l_expr',
'                                            , pi_scope           => pi_scope',
'                                            , pi_expr_type       => pi_expr_type ',
'                                            , pi_bind_parameters => l_bind_parameters',
'                                            );',
'    when flow_constants_pkg.gc_prov_var_type_date then',
'      l_result_rec := exec_flows_plsql_date ( pi_prcs_id         => pi_prcs_id',
'                                            , pi_sbfl_id         => pi_sbfl_id',
'                                            , pi_plsql_text      => l_expr',
'                                            , pi_scope           => pi_scope',
'                                            , pi_expr_type       => pi_expr_type ',
'                                            , pi_bind_parameters => l_bind_parameters',
'                                            );',
'    when flow_constants_pkg.gc_prov_var_type_tstz then',
'      l_result_rec := exec_flows_plsql_tstz ( pi_prcs_id         => pi_prcs_id',
'                                            , pi_sbfl_id         => pi_sbfl_id',
'                                            , pi_plsql_text      => l_expr',
'                                            , pi_scope           => pi_scope',
'                                            , pi_expr_type       => pi_expr_type ',
'                                            , pi_bind_parameters => l_bind_parameters',
'                                            );',
'    when flow_constants_pkg.gc_prov_var_type_json then -- use vc2',
'      l_result_rec := exec_flows_plsql_vc2  ( pi_prcs_id         => pi_prcs_id',
'                                            , pi_sbfl_id         => pi_sbfl_id',
'                                            , pi_plsql_text      => l_expr',
'                                            , pi_scope           => pi_scope',
'                                            , pi_expr_type       => pi_expr_type',
'                                            , pi_bind_parameters => l_bind_parameters',
'                                            );    ',
'    when flow_constants_pkg.gc_prov_var_type_boolean then ',
'      l_result_rec := exec_flows_plsql_bool ( pi_prcs_id         => pi_prcs_id',
'                                            , pi_sbfl_id         => pi_sbfl_id',
'                                            , pi_plsql_text      => l_expr',
'                                            , pi_scope           => pi_scope',
'                                            , pi_expr_type       => pi_expr_type',
'                                            , pi_bind_parameters => l_bind_parameters',
'                                            );                                          ',
'    end case;    ',
'    return l_result_rec;',
'  exception',
'    when others then',
'      apex_debug.error',
'      ( p_message => ''Error executing PL/SQL (%0) for process id %1. SQLERRM: %2''',
'      , p0        => l_wrap_begin||pi_plsql_text||l_wrap_end',
'      , p1        => pi_prcs_id',
'      , p2        => sqlerrm',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''var_exp_plsql_other''',
'      );',
'      -- $F4AMESSAGE ''exec_plsql_other'' || ''Error executing PL/SQL.  PL/SQL error shown in event log.''    ',
'',
'  end exec_flows_plsql;',
'',
'end flow_db_exec;',
'/',
'',
'create or replace package body flow_message_flow as',
'/* ',
'-- Flows for APEX - flow_message_flow.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'-- (c) Copyright Flowquest Limited, 2023-24',
'--',
'-- Created  04-Mar-2023  Richard Allen (Oracle Corporation)',
'-- Edited      May-2024  Richard Allen, (Flowquest)',
'--',
'*/',
'  e_lock_timeout exception;',
'  pragma exception_init (e_lock_timeout, -3006);',
'',
'',
'  function subscribe',
'  ( p_subscription_details     in t_subscription_details',
'  ) return flow_message_subscriptions.msub_id%type',
'  is',
'    l_msub_id      flow_message_subscriptions.msub_id%type;',
'  begin',
'    apex_debug.message ( p_message => ''Trying to create subscription for Message %0 Key %1 Value %2 Payload %3''',
'    , p0 => p_subscription_details.message_name',
'    , p1 => p_subscription_details.key_name',
'    , p2 => p_subscription_details.key_value',
'    , p3 => p_subscription_details.payload_var',
'    );',
'',
'    insert into flow_message_subscriptions',
'    ( msub_message_name',
'    , msub_key_name',
'    , msub_key_value',
'    , msub_prcs_id',
'    , msub_sbfl_id',
'    , msub_step_key',
'    , msub_dgrm_id',
'    , msub_callback',
'    , msub_callback_par',
'    , msub_created',
'    , msub_payload_var',
'    )',
'    values ',
'    ( p_subscription_details.message_name',
'    , p_subscription_details.key_name',
'    , p_subscription_details.key_value',
'    , p_subscription_details.prcs_id',
'    , p_subscription_details.sbfl_id',
'    , p_subscription_details.step_key',
'    , p_subscription_details.dgrm_id',
'    , p_subscription_details.callback',
'    , p_subscription_details.callback_par',
'    , systimestamp',
'    , p_subscription_details.payload_var',
'    ) returning msub_id into l_msub_id;',
'',
'    apex_debug.message ( p_message => ''Message subscription %0 created for Message %1 Key %2 Value %3 Payload %4''',
'    , p0 => l_msub_id',
'    , p1 => p_subscription_details.message_name',
'    , p2 => p_subscription_details.key_name',
'    , p3 => p_subscription_details.key_value',
'    , p4 => p_subscription_details.payload_var',
'    );',
'    return l_msub_id;',
'  end subscribe;',
'',
'  procedure receive_message',
'    ( p_message_name  flow_message_subscriptions.msub_message_name%type',
'    , p_key_name      flow_message_subscriptions.msub_key_name%type',
'    , p_key_value     flow_message_subscriptions.msub_key_value%type',
'    , p_payload       clob default null',
'    )',
'  is',
'    l_prcs_id           flow_processes.prcs_id%type;',
'    l_scope             flow_subflows.sbfl_scope%type;',
'    l_current           flow_subflows.sbfl_current%type;',
'    l_msub              flow_message_subscriptions%rowtype;',
'    l_log_msg           flow_configuration.cfig_value%type;',
'    l_was_correlated    flow_types_pkg.t_single_vc2 := flow_constants_pkg.gc_false;',
'    l_session_id        number;',
'  begin',
'    if (p_key_name is null and p_key_value is null) then',
'      $IF flow_apex_env.ee $THEN',
'        l_msub := flow_message_util_ee.correlate_start_event ( p_message_name => p_message_name);',
'        l_was_correlated  := flow_constants_pkg.gc_true;',
'        -- message is correlated.  create an APEX session if coming from outside',
'        if v(''APP_SESSION'') is null then',
'          l_session_id := flow_apex_session.create_api_session (p_subflow_id => l_msub.msub_sbfl_id);',
'        end if; ',
'      $ELSE',
'        raise e_msgflow_feature_requires_ee;',
'      $END',
'    else',
'      -- intermediate message catch / receive',
'      l_msub := flow_message_util.correlate_catch_event  ( p_message_name => p_message_name',
'                                                        , p_key_name      => p_key_name',
'                                                        , p_key_value     => p_key_value  ',
'                                                        );',
'      apex_debug.message ( p_message => ''intermediate catch or receive correlated'');                                                  ',
'      -- message is correlated.  create an APEX session if coming from outside',
'      -- and then validate the step key to make sure the receive / catch is still current',
'      if v(''APP_SESSION'') is null then',
'        l_session_id := flow_apex_session.create_api_session (p_subflow_id => l_msub.msub_sbfl_id);',
'      end if; ',
'      -- validate step key, get scope and current object, and lock subflow',
'      begin',
'        select sbfl_scope',
'             , sbfl_current',
'          into l_scope',
'             , l_current',
'          from flow_subflows',
'         where sbfl_id        = l_msub.msub_sbfl_id',
'           and sbfl_prcs_id   = l_msub.msub_prcs_id',
'           and sbfl_step_key  = l_msub.msub_step_key',
'           for update of sbfl_current',
'        ;',
'        l_was_correlated  := flow_constants_pkg.gc_true;',
'        apex_debug.message ( p_message => ''intermediate catch or receive step key validated'');                                                  ',
'',
'      exception',
'        when no_data_found then',
'            -- add some message-specific logging capability into here.',
'            raise e_msgflow_mag_already_consumed ;',
'        when e_lock_timeout then',
'            raise e_msgflow_correlated_msg_locked;          ',
'      end;',
'    end if;',
'',
'    l_log_msg := flow_engine_util.get_config_value ( p_config_key     => flow_constants_pkg.gc_config_logging_message_flow_recd',
'                                                   , p_default_value  => flow_constants_pkg.gc_config_default_logging_recd_msg ',
'                                                   );',
'',
'    if l_log_msg = flow_constants_pkg.gc_vcbool_true then',
'      flow_message_util.autonomous_write_to_messageflow_log',
'      ( p_message_name        => p_message_name ',
'      , p_key_name            => p_key_name',
'      , p_key_value           => p_key_value',
'      , p_payload             => p_payload',
'      , p_was_correlated      => l_was_correlated',
'      , p_prcs_id             => l_msub.msub_prcs_id',
'      , p_sbfl_id             => l_msub.msub_sbfl_id   ',
'      );',
'    end if;',
'',
'    case ',
'    when l_msub.msub_callback = flow_constants_pkg.gc_bpmn_receivetask then',
'      apex_debug.message ',
'      ( p_message => ''receivetask callback. prcs_id %0 sbfl_id %1 l_current %2 scope %3 msub_id %4''',
'      , p0 => l_msub.msub_prcs_id',
'      , p1 => l_msub.msub_sbfl_id',
'      , p2 => l_current',
'      , p3 => l_scope',
'      , p4 => l_msub.msub_id',
'      );',
'      -- Call Back is for a bpmn:receiveTask message',
'      flow_message_util.save_payload',
'      ( p_process_id      => l_msub.msub_prcs_id',
'      , p_subflow_id      => l_msub.msub_sbfl_id',
'      , p_payload_var     => l_msub.msub_payload_var',
'      , p_payload         => p_payload',
'      , p_objt_bpmn_id    => l_current',
'      , p_scope           => l_scope',
'      );',
'',
'      -- do the delete before the callback because the callback will do a next-step, which commits at step end',
'      delete from flow_message_subscriptions',
'       where msub_id = l_msub.msub_id;',
'',
'      flow_tasks.receiveTask_callback ',
'      ( p_process_id    => l_msub.msub_prcs_id',
'      , p_subflow_id    => l_msub.msub_sbfl_id',
'      , p_step_key      => l_msub.msub_step_key',
'      , p_msub_id       => l_msub.msub_id',
'      );',
'    when l_msub.msub_callback = flow_constants_pkg.gc_bpmn_intermediate_catch_event then',
'      apex_debug.message ',
'      ( p_message => ''ICE callback. prcs_id %0 sbfl_id %1 l_current %2 scope %3 msub_id %4 callback param: %5''',
'      , p0 => l_msub.msub_prcs_id',
'      , p1 => l_msub.msub_sbfl_id',
'      , p2 => l_current',
'      , p3 => l_scope',
'      , p4 => l_msub.msub_id',
'      , p5 => l_msub.msub_callback_par',
'      );',
'      flow_message_util.intermed_save_payload_and_callback',
'      ( p_msub     => l_msub',
'      , p_payload  => p_payload',
'      , p_current  => l_current',
'      , p_scope    => l_scope',
'      );',
'    when  l_msub.msub_callb'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ack = flow_constants_pkg.gc_bpmn_boundary_event then',
'      $IF flow_apex_env.ee $THEN',
'        flow_message_util_ee.b_event_save_payload_and_callback',
'        ( p_msub     => l_msub',
'        , p_payload  => p_payload',
'        , p_current  => l_current',
'        , p_scope    => l_scope',
'        );',
'      $ELSE',
'        raise e_msgflow_feature_requires_ee;',
'      $END',
'    when l_msub.msub_callback = flow_constants_pkg.gc_bpmn_start_event then',
'      $IF flow_apex_env.ee $THEN',
'        flow_message_util_ee.start_event_save_payload_and_callback',
'        ( p_msub     => l_msub',
'        , p_payload  => p_payload',
'        );',
'      $ELSE',
'        raise e_msgflow_feature_requires_ee;',
'      $END',
'',
'    end case;',
'',
'    -- tear down APEX Session if this was an external call.',
'    if l_session_id is not null then',
'      flow_apex_session.delete_session (p_session_id => l_session_id );',
'    end if;',
'  exception',
'    when others then',
'      if l_session_id is not null then',
'        flow_apex_session.delete_session (p_session_id => l_session_id );',
'      end if;',
'      raise;',
'  end receive_message;',
'',
'  procedure send_message',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is',
'    l_message               flow_message_flow.t_flow_simple_message;',
'    e_msgflow_bad_endpoint  exception;',
'  begin',
'    apex_debug.enter ',
'    ( ''send_message''',
'    , ''p_msg_object_bpmn_id'', p_step_info.target_objt_ref',
'    );',
'    l_message := flow_message_util.prepare_message( p_msg_object_bpmn_id  => p_step_info.target_objt_ref',
'                                              , p_dgrm_id             => p_sbfl_info.sbfl_dgrm_id',
'                                              , p_sbfl_info           => p_sbfl_info ',
'                                              );',
'',
'    apex_debug.trace',
'    (',
'      p_message => ''Received message details -- %0;%1;%2;%3''',
'    , p0 => l_message.message_name',
'    , p1 => l_message.key_name',
'    , p2 => l_message.key_value',
'    , p3 => l_message.payload',
'    );',
'',
'    case l_message.endpoint ',
'    when ''local'' then',
'      begin',
'        flow_message_flow.receive_message',
'        ( p_message_name    => l_message.message_name',
'        , p_key_name        => l_message.key_name',
'        , p_key_value       => l_message.key_value',
'        , p_payload         => l_message.payload',
'        );',
'      exception',
'        when e_msgflow_msg_not_correlated then',
'          -- message sent did not match an existing subscription',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'          , pi_message_key  => ''msgflow-not-correlated'' ',
'          );',
'        when e_msgflow_correlated_msg_locked then',
'          -- message sent correated but is locked by another message',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'          , pi_message_key  => ''msgflow-lock-timeout-msub'' ',
'          );',
'        when e_msgflow_mag_already_consumed then',
'          -- message correlated but receiving object is no longer the current object in its subflow',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'          , pi_message_key  => ''msgflow-no-longer-current-step''',
'          );',
'        when e_msgflow_feature_requires_ee then',
'          -- feature not supported without Enterprise Edition licence',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'          , pi_message_key  => ''feature-requires-ee''',
'          );',
'      end;',
'    else',
'      begin',
'        raise e_msgflow_bad_endpoint;',
'      exception',
'        when e_msgflow_bad_endpoint then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'          , pi_message_key  => ''msgflow-endpoint-not-supported'' ',
'          , p0 => l_message.endpoint',
'          );',
'      end;',
'    end case;',
'',
'  end;',
'',
'end flow_message_flow;',
'/',
'',
'create or replace package body flow_message_util as',
'/* ',
'-- Flows for APEX - flow_message_util.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created  04-Mar-2023  Richard Allen (Oracle Corporation)',
'--',
'-- Contains utility and common routines for messageFlow used by',
'-- bpmn:sendTask, bpmn:receiveTask, message catch and throw events, message start events, etc.',
'--',
'*/',
'  e_lock_timeout exception;',
'  pragma exception_init (e_lock_timeout, -3006);',
'',
'  procedure autonomous_write_to_messageflow_log',
'    ( p_message_name     in flow_message_received_log.lgrx_message_name%type ',
'    , p_key_name         in flow_message_received_log.lgrx_key_name%type   ',
'    , p_key_value        in flow_message_received_log.lgrx_key_value%type ',
'    , p_payload          in flow_message_received_log.lgrx_payload%type ',
'    , p_was_correlated   in flow_message_received_log.lgrx_was_correlated%type    ',
'    , p_prcs_id          in flow_message_received_log.lgrx_prcs_id%type ',
'    , p_sbfl_id          in flow_message_received_log.lgrx_sbfl_id%type    ',
'    )',
'  is',
'    pragma autonomous_transaction;',
'  begin',
'',
'      insert into flow_message_received_log',
'      ( lgrx_message_name',
'      , lgrx_key_name',
'      , lgrx_key_value',
'      , lgrx_payload',
'      , lgrx_was_correlated',
'      , lgrx_prcs_id',
'      , lgrx_sbfl_id',
'      , lgrx_received_on',
'      )',
'      values',
'      ( p_message_name',
'      , p_key_name',
'      , p_key_value',
'      , p_payload',
'      , p_was_correlated',
'      , p_prcs_id',
'      , p_sbfl_id',
'      , systimestamp',
'      );',
'      -- commit as an autonomous transaction',
'      commit;',
'  end autonomous_write_to_messageflow_log;',
'',
'  function get_msg_subscription_details',
'  ( p_msg_object_bpmn_id        flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id                   flow_diagrams.dgrm_id%type',
'  , p_sbfl_info                 flow_subflows%rowtype',
'  ) return flow_message_flow.t_subscription_details',
'  is ',
'    l_message_name_json flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_message_name      flow_message_subscriptions.msub_message_name%type;',
'    l_key_json          flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_key               flow_message_subscriptions.msub_key_name%type;',
'    l_value_json        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_value             flow_message_subscriptions.msub_key_value%type;',
'    l_msub_id           flow_message_subscriptions.msub_id%type;',
'    l_msg_sub           flow_message_flow.t_subscription_details;',
'    l_payload_variable  flow_process_variables.prov_var_name%type;',
'',
'  begin',
'    apex_debug.enter ',
'    ( ''get_msg_subscription_details''',
'    , ''p_msg_object_bpmn_id'', p_msg_object_bpmn_id',
'    );',
'',
'    l_msg_sub   := flow_message_flow.t_subscription_details();',
'',
'    -- get message and correlation settings and evaluate them',
'      -- get the userTask subtype  ',
'    select objt.objt_attributes."apex"."messageName"',
'         , objt.objt_attributes."apex"."correlationKey"',
'         , objt.objt_attributes."apex"."correlationValue"',
'         , objt.objt_attributes."apex"."payloadVariable"',
'      into l_message_name_json',
'         , l_key_json',
'         , l_value_json',
'         , l_msg_sub.payload_var',
'      from flow_objects objt',
'     where objt.objt_bpmn_id = p_msg_object_bpmn_id',
'       and objt.objt_dgrm_id = p_dgrm_id ',
'       ;',
'',
'    apex_debug.message ',
'    ( p_message => ''-- message settings: messageName %0, key %1, value %2, payload var %3''',
'    , p0 => l_message_name_json',
'    , p1 => l_key_json',
'    , p2 => l_value_json',
'    , p3 => l_msg_sub.payload_var',
'    );',
'',
'      if l_message_name_json is not null then',
'        l_msg_sub.message_name := flow_settings.get_vc2_expression ',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_message_name_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'      if l_key_json is not null then ',
'        l_msg_sub.key_name     := flow_settings.get_vc2_expression ',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_key_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'      if l_value_json is not null then ',
'        l_msg_sub.key_value    := flow_settings.get_vc2_expression',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_value_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'',
'    apex_debug.message ',
'    ( p_message => ''-- ReceiveTask settings: messageName "%0", key "%1", value "%2", payload var "%3".''',
'    , p0 => l_msg_sub.message_name',
'    , p1 => l_msg_sub.key_name',
'    , p2 => l_msg_sub.key_value',
'    , p3 => l_msg_sub.payload_var',
'    );',
'',
'    l_msg_sub.prcs_id        := p_sbfl_info.sbfl_prcs_id;',
'    l_msg_sub.sbfl_id        := p_sbfl_info.sbfl_id;',
'    l_msg_sub.step_key       := p_sbfl_info.sbfl_step_key;',
'  ',
'    return l_msg_sub;',
'  end get_msg_subscription_details;',
'  ',
'  function prepare_message',
'  ( p_msg_object_bpmn_id        flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id                   flow_diagrams.dgrm_id%type',
'  , p_sbfl_info                 flow_subflows%rowtype',
'  ) return flow_message_flow.t_flow_simple_message',
'  is',
'    l_endpoint_json     flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_endpoint          flow_types_pkg.t_vc200;',
'    l_message_name_json flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_message_name      flow_message_subscriptions.msub_message_name%type;',
'    l_key_json          flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_key               flow_message_subscriptions.msub_key_name%type;',
'    l_value_json        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_value             flow_message_subscriptions.msub_key_value%type;',
'    l_payload_json      clob;',
'    l_payload           clob;',
'    l_message           flow_message_flow.t_flow_simple_message;',
'',
'  begin',
'    apex_debug.enter ',
'    ( ''prepare_message''',
'    , ''p_msg_object_bpmn_id'', p_msg_object_bpmn_id',
'    );',
'',
'    l_message   := flow_message_flow.t_flow_simple_message();',
'',
'    -- get message and correlation settings and evaluate them',
'      -- get the userTask subtype  ',
'    select objt.objt_attributes."apex"."endpoint"',
'         , objt.objt_attributes."apex"."messageName"',
'         , objt.objt_attributes."apex"."correlationKey"',
'         , objt.objt_attributes."apex"."correlationValue"',
'         , objt.objt_attributes."apex"."payload"',
'      into l_endpoint_json',
'         , l_message_name_json',
'         , l_key_json',
'         , l_value_json',
'         , l_payload_json',
'      from flow_objects objt',
'     where objt.objt_bpmn_id = p_msg_object_bpmn_id',
'       and objt.objt_dgrm_id = p_dgrm_id ',
'       ;',
'',
'    apex_debug.message ',
'    ( p_message => ''-- message settings: messageName %0, key %1, value %2, payload %3, endpoint %4''',
'    , p0 => l_message_name_json',
'    , p1 => l_key_json',
'    , p2 => l_value_json',
'    , p3 => l_payload_json',
'    , p4 => l_endpoint_json',
'    );',
'',
'      if l_message_name_json is not null then',
'        l_message.message_name := flow_settings.get_vc2_expression ',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_message_name_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'      if l_key_json is not null then ',
'        l_message.key_name     := flow_settings.get_vc2_expression ',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_key_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'      if l_value_json is not null then ',
'        l_message.key_value    := flow_settings.get_vc2_expression',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_value_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'      if l_payload_json is not null then ',
'        l_message.payload    := flow_settings.get_clob_expression',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_payload_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;',
'      if l_endpoint_json is not null then ',
'        l_message.endpoint    := flow_settings.get_vc2_expression',
'                                ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                                , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                                , pi_expr    => l_endpoint_json',
'                                , pi_scope   => p_sbfl_info.sbfl_scope',
'                                );',
'      end if;      ',
'',
'    apex_debug.message ',
'    ( p_message => ''-- ReceiveTask settings: messageName "%0", key "%1", value "%2", payload "%3", endpoint "%4%".''',
'    , p0 => l_message.message_name',
'    , p1 => l_message.key_name',
'    , p2 => l_message.key_value',
'    , p3 => l_message.payload',
'    , p4 => l_message.endpoint',
'    );',
'  ',
'    return l_message;',
'  end prepare_message;',
'',
'',
'  procedure save_payload',
'  ( p_process_id             in  flow_processes.prcs_id%type',
'  , p_subflow_id             in  flow_subflows.sbfl_id%type default null',
'  , p_payload_var            in  flow_process_variables.prov_var_name%type',
'  , p_payload                in  clob',
'  , p_scope                  in  flow_subflows.sbfl_scope%type default 0',
'  , p_objt_bpmn_id           in  flow_objects.objt_bpmn_id%type',
'  )',
'  is',
'  begin',
'    apex_debug.enter ',
'    ( ''save_payload''',
'    , ''p_payload_var'', p_payload_var',
'    , ''p_payload'', p_payload',
'    );',
'',
'    if ( p_payload is not null ',
'       and p_payload_var is not null ) then ',
'',
'      flow_proc_vars_int.set_var',
'      ( pi_prcs_id      => p_process_id',
'      , pi_sbfl_id      => p_subflow_id',
'      , pi_var_name     => p_payload_var',
'      , pi_clob_value   => p_payload',
'      , pi_objt_bpmn_id => p_objt_bpmn_id',
'      , pi_scope        => p_scope',
'      );',
'      apex_debug.message ',
'      ( p_message => ''-- incoming mesage payload stored in proc var %0''',
'      , p0 => p_payload_var',
'      );    ',
'    end if;',
'  end save_payload;',
'',
'  function correlate_catch_event',
'    ( p_message_name  flow_message_subscriptions.msub_message_name%type ',
'    , p_key_name      flow_message_subscriptions.msub_key_name%type',
'    , p_key_value     flow_message_subscriptions.msub_key_value%type',
'    ) return flow_message_subscriptions%rowtype',
'  is',
'    l_msub              flow_message_subscriptions%rowtype;',
'  begin',
'    begin',
'      -- attempt the correlation based on 100% match of message name, key and value',
'      select msub.*',
'        into l_msub',
'        from flow_message_subscriptions msub',
'       where msub.msub_message_name    = p_message_name',
'         and msub.msub_key_name        = p_key_name',
'         and msub.msub_key_value       = p_key_value',
'         for update of msub_id wait 2',
'      ;',
'    exception',
'        when no_data_found then',
'          raise flow_message_flow.e_msgflow_msg_not_correlated;',
'          -- logging of incorrect message handled in procedure exceptions below...',
'        when e_lock_timeout then',
'          raise flow_message_flow.e_msgflow_correlated_msg_locked;          ',
'    end;',
'    return l_msub;',
'  end correlate_catch_event;',
'',
'  procedure intermed_save_payload_and_callback',
'   ( p_msub           in flow_message_subscriptions%rowtype',
'   , p_payload        in clob default null',
'   , p_current        in flow_objects.objt_bpmn_id%type ',
'   , p_scope          in flow_subflows.sbfl_scope%type',
'   ) ',
'  is',
'  begin',
'      -- Call Back is for a bpmn:intermediateCatchEvent - message subtype (Message Catch Event)',
'      save_payload',
'      ( p_process_id      => p_msub.msub_prcs_id',
'      , p_subflow_id      => p_msub.msub_sbfl_id',
'      , p_payload_var     => p_msub.msub_payload_var',
'      , p_payload         => p_payload',
'      , p_objt_bpmn_id    => p_current',
'      , p_scope           => p_scope',
'      );',
'',
'      -- do the delete before the callback because the callback will do a next-step, which commits at step end',
'      delete from flow_message_subscriptions',
'       where msub_id = p_msub.msub_id;',
'',
'      flow_engine.timer_callback ',
'      ( p_process_id    => p_msub.msub_prcs_id',
'      , p_subflow_id    => p_msub.msub_sbfl_id',
'      , p_step_key      => p_msub.msub_step_key',
'      , p_callback      => p_msub.msub_callback',
'      , p_callback_par  => p_msub.msub_callback_par',
'      , p_event_type    => flow_constants_pkg.gc_bpmn_message_event_definition',
'      );',
'',
'  end intermed_save_payload_and_callback;',
'',
'  procedure lock_subscription',
'  ( p_process_id                    flow_processes.prcs_id%type',
'  , p_subflow_id                    flow_subflows.sbfl_id%type',
'  )',
'  is',
'    cursor c_lock_sub is',
'      select msub_id',
'        from flow_message_subscriptions',
'       where msub_prcs_id = p_process_id',
'         and msub_sbfl_id = p_subflow_id',
'         for update of msub_id;',
'  begin',
'    apex_debug.enter',
'    ( ''lock_subscription''',
'    , ''process_id'', p_process_id',
'    , ''subflow_id'', p_subflow_id',
'    );',
'    open c_lock_sub;',
'    close c_lock_sub;',
'  end lock_subscription;',
'  ',
'  procedure cancel_subscription',
'  ( p_process_id                    flow_processes.prcs_id%type',
'  , p_subflow_id                    flow_subflows.sbfl_id%type',
'  )',
'  is',
'  begin',
'    delete from flow_message_subscriptions',
'          where msub_prcs_id = p_process_id',
'            and msub_sbfl_id = p_subflow_id;',
'  end cancel_subscription;',
'  ',
'  procedure cancel_subscription',
'  ( p_msub_id                       flow_message_subscriptions.msub_id%type',
'  )',
'  is',
'  begin',
'    delete from flow_message_subscriptions',
'          where msub_id = p_msub_id;',
'  end cancel_subscription;',
'',
'  procedure lock_instance_subscriptions',
'  ( p_process_id                    flow_processes.prcs_id%type',
'  )',
'  is',
'    cursor c_lock_subs is',
'      select msub_id',
'        from flow_message_subscriptions',
'       where msub_prcs_id = p_process_id',
'         for update of msub_id;',
'  begin',
'    apex_debug.enter',
'    ( ''lock_subscription''',
'    , ''process_id'', p_process_id',
'    );',
'    open c_lock_subs;',
'    close c_lock_subs;',
'',
'  end lock_instance_subscriptions;',
'',
'  procedure cancel_instance_subscriptions',
'  ( p_process_id                    flow_processes.prcs_id%type',
'  )',
'  is',
'  begin',
'    delete from flow_message_subscriptions',
'          where msub_prcs_id = p_process_id;',
'  end cancel_instance_subscriptions;',
'',
'end flow_message_util;',
'/',
'',
'create or replace package body flow_reservations',
'as ',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'  procedure reserve_step',
'    ( p_process_id         in flow_processes.prcs_id%type',
'    , p_subflow_id         in flow_subflows.sbfl_id%type',
'    , p_step_key           in flow_subflows.sbfl_step_key%type ',
'    , p_reservation        in flow_subflows.sbfl_reservation%type ',
'    , p_called_internally  in boolean default false',
'    )',
'  is',
'    l_existing_reservation  flow_subflows.sbfl_reservation%type;',
'    e_reserved_by_other     exception;',
'    e_reserved_by_same      exception;',
'    l_step_key_required     flow_subflows.sbfl_step_key%type;',
'  begin',
'    apex_debug.enter',
'    (''reserve_step''',
'    , ''Subflow '', p_subflow_id',
'    , ''Process '', p_process_id',
'    , ''Step Key'', p_step_key',
'    , ''Reservation'', p_reservation',
'    );',
'',
'    -- check step is not already reserved and lock the subflow',
'    select sbfl_reservation',
'         , sbfl_step_key',
'      into l_existing_reservation',
'         , l_step_key_required',
'      from flow_subflows sbfl ',
'     where sbfl.sbfl_id = p_subflow_id',
'       and sbfl.sbfl_prcs_id = p_process_id',
'       for update of sbfl_reservation wait 2',
'    ;',
'    -- first check the step key',
'    if flow_engine_util.step_key_valid( pi_prcs_id  => p_process_id',
'                                      , pi_sbfl_id  => p_subflow_id',
'                                      , pi_step_key_supplied  => p_step_key',
'                                      , pi_step_key_required => l_step_key_required',
'                                      ) ',
'    then ',
'      -- step key valid',
'      if l_existing_reservation is not null then',
'        if p_reservation = l_existing_reservation then ',
'          -- step already reserved by required reservation',
'          raise e_reserved_by_same;',
'        else ',
'          raise e_reserved_by_other;',
'        end if;',
'      end if;',
'      -- place the reservation',
'      update flow_subflows sbfl',
'         set sbfl_reservation         = p_reservation',
'           , sbfl.sbfl_last_update    = systimestamp',
'           , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'       where sbfl_prcs_id = p_process_id',
'         and sbfl_id = p_subflow_id',
'      ;',
'      -- commit reservation if this is an external call',
'      if not p_called_internally then ',
'        commit;',
'      end if;',
'    end if;',
'',
'  exception',
'    when no_data_found then',
'        flow_errors.handle_general_error',
'        ( pi_message_key    => ''reservation-failed-not-found''',
'        , p0 => p_subflow_id         ',
'	      , p1 => p_process_id',
'        , p2 => p_reservation',
'        );',
'        -- $F4AMESSAGE ''reservation-failed-not-found'' || ''Reservation for %2 unsuccessful.  Subflow %0 in Process %1 not found.''',
'    when e_reserved_by_other then',
'        flow_errors.handle_general_error',
'        ( pi_message_key    => ''reservation-by-other_user''',
'        , p0 => p_reservation',
'        , p1 => l_existing_reservation',
'        );',
'        -- $F4AMESSAGE ''reservation-by-other_user'' || ''Reservation for %0 unsuccessful.  Step already reserved by another user (%1).''           ',
'    when e_reserved_by_same then',
'        flow_errors.handle_general_error',
'        ( pi_message_key    => ''reservation-already-placed''',
'        );',
'        -- $F4AMESSAGE ''reservation-already-placed'' || ''Reservation already placed on next task for you.''',
'    when lock_timeout then',
'        flow_errors.handle_general_error',
'        ( pi_message_key    => ''reservation-lock-timeout''',
'        );',
'        -- $F4AMESSAGE ''reservation-lock-timeout'' || ''Subflow currently locked (not reserved) by another user.  Try your reservation again later.''     ',
'  end reserve_step;',
'',
'  procedure release_step',
'    ( p_process_id         in flow_processes.prcs_id%type',
'    , p_subflow_id         in flow_subflows.sbfl_id%type',
'    , p_step_key           in flow_subflows.sbfl_step_key%type default null',
'    , p_called_internally  in boolean default false',
'    )',
'  is',
'    l_existing_reservation      flow_subflows.sbfl_reservation%type;',
'    l_step_key_required         flow_subflows.sbfl_step_key%type;',
'    e_reserved_wrong_step_key   exception;',
'  begin',
'    apex_debug.enter',
'    ( ''release_step''',
'    , ''Subflow '', p_subflow_id',
'    , ''Process '', p_process_id ',
'    , ''Step Key'', p_step_key',
'    );',
'    -- subflow should already be locked when calling internally',
'    if not p_called_internally then ',
'      -- lock  subflow if called externally',
'      select sbfl_reservation',
'           , sbfl_step_key',
'        into l_existing_reservation',
'           , l_step_key_required ',
'        from flow_subflows sbfl ',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'         for update of sbfl_reservation wait 2',
'      ;',
'      -- check step key is valid (internal calls have already checked this so no need to check again)',
'      if not flow_engine_util.step_key_valid( pi_prcs_id  => p_process_id',
'                                            , pi_sbfl_id  => p_subflow_id',
'                                            , pi_step_key_supplied  => p_step_key',
'                                            , pi_step_key_required => l_step_key_required',
'                                            ) ',
'      then ',
'        raise e_reserved_wrong_step_key;',
'      end if;',
'',
'    end if;',
'    -- release the reservation',
'    update flow_subflows sbfl',
'       set sbfl_reservation         = null',
'         , sbfl.sbfl_last_update    = systimestamp',
'         , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                               , sys_context(''userenv'',''os_user'')',
'                                               , sys_context(''userenv'',''session_user'')',
'                                               )  ',
'    where sbfl_prcs_id = p_process_id',
'      and sbfl_id = p_subflow_id',
'    ;',
'    -- commit reservation if this is an external call',
'    if not p_called_internally then ',
'      commit;',
'    end if;',
'',
'  exception',
'    when no_data_found then',
'      flow_errors.handle_general_error',
'      ( pi_message_key    => ''reservation-release-not-found''',
'      , p0 => p_subflow_id',
'      , p1 => p_process_id',
'      );',
'      -- $F4AMESSAGE ''reservation-release-not-found'' || ''Reservation release unsuccessful.  Subflow %0 in Process %1 not found.''',
'    when lock_timeout then',
'      flow_errors.handle_general_error',
'      ( pi_message_key    => ''reservation-lock-timeout''',
'      , p0 => p_subflow_id',
'      , p1 => p_process_id',
'      );',
'      -- $F4AMESSAGE ''reservation-lock-timeout'' || ''Subflow currently locked (not reserved) by another user.  Try your reservation again later.''',
'    when e_reserved_wrong_step_key then',
'      flow_errors.handle_general_error',
'      ( pi_message_key    => ''reservation-incorrect-step-key''',
'      , p0 => p_subflow_id',
'      , p1 => p_process_id',
'      );      ',
'      -- $F4AMESSAGE ''reservation-incorrect-step-key'' || ''Task is no longer current.  Please refresh your Inbox.''',
'  end release_step;',
'',
'end flow_reservations;',
'/',
'',
'create or replace package body flow_engine_util',
'as ',
'/* ',
'-- Flows for APEX - flow_engine_util.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2024',
'--',
'-- Created  April-2021  Richard Allen (Flowquest) - from flow_engine.pkb',
'-- Modified 2022-07-18  Moritz Klein (MT AG)',
'-- Modified 09-Jan-2024  Richard Allen, Flowquest Consulting',
'--',
'*/',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'  g_step_keys_enforced    boolean;',
'',
'  function get_config_value',
'  ( ',
'    p_config_key    in flow_configuration.cfig_key%type',
'  , p_default_value in flow_configuration.cfig_value%type',
'  ) return flow_configuration.cfig_value%type',
'  as  ',
'    l_config_value   flow_configuration.cfig_value%type;',
'  begin ',
'    select cfig.cfig_value',
'      into l_config_value',
'      from flow_configuration cfig',
'     where cfig.cfig_key = p_config_key',
'    ;',
'    return l_config_value;',
'  exception ',
'    when no_data_found then ',
'      return p_default_value;',
'  end get_config_value;',
'',
'  procedure set_config_value',
'  (',
'    p_config_key      in flow_configuration.cfig_key%type',
'  , p_value           in flow_configuration.cfig_value%type',
'  , p_update_if_set   in boolean default true',
'  )',
'  is',
'    l_exists      number;',
'  begin',
'    select count(cfig_key)',
'      into l_exists',
'      from flow_configuration',
'     where cfig_key = p_config_key;',
'    ',
'    if l_exists > 0 and p_update_if_set then ',
'      update flow_configuration',
'         set cfig_value = p_value',
'       where cfig_key = p_config_key;',
'    elsif l_exists = 0 then',
'      insert into flow_configuration',
'      ( cfig_key',
'      , cfig_value',
'      )',
'      values',
'      ( p_config_key',
'      , p_value',
'      );',
'    end if;',
'  end set_config_value;',
'',
'  function step_key',
'  ( pi_sbfl_id        in flow_subflows.sbfl_id%type default null',
'  , pi_current        in flow_subflows.sbfl_current%type default null',
'  , pi_became_current in flow_subflows.sbfl_became_current%type default null',
'  ) return flow_subflows.sbfl_step_key%type',
'  is',
'  begin',
'',
'      return sys.dbms_random.string(''A'', 10);',
'  end step_key;',
'',
'  function step_key_valid',
'  ( pi_prcs_id              in flow_processes.prcs_id%type',
'  , pi_sbfl_id              in flow_subflows.sbfl_id%type',
'  , pi_step_key_supplied    in flow_subflows.sbfl_step_key%type',
'  , pi_step_key_required    in flow_subflows.sbfl_step_key%type default null',
'  ) return boolean',
'  is ',
'    l_step_key_required   flow_subflows.sbfl_step_key%type := pi_step_key_required;',
'  begin',
'    if pi_step_key_required is null then',
'',
'      select sbfl.sbfl_step_key',
'        into l_step_key_required',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_id = pi_sbfl_id',
'    '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'     and sbfl.sbfl_prcs_id = pi_prcs_id',
'      ;',
'    end if;',
'',
'    apex_debug.info ',
'    ( p_message => ''Step Key Required: %0  Step Key Supplied: %1''',
'    , p0 => l_step_key_required',
'    , p1 => pi_step_key_supplied',
'    );',
'',
'    if pi_step_key_supplied = l_step_key_required then',
'      return true;',
'    elsif (pi_step_key_supplied is null ',
'           and not g_step_keys_enforced) then',
'      return true;',
'    else',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_id',
'      , pi_message_key => ''step-key-incorrect''',
'      , p0 => nvl(pi_step_key_supplied, ''"null"'')',
'      , p1 => l_step_key_required',
'      );',
'      -- $F4AMESSAGE ''step-key-incorrect'' || ''This Process Step has already occurred.  (Incorrect step key %0 supplied while exopecting step key %1).'' ',
'      return false;',
'    end if;',
'  end step_key_valid;',
'',
'  function check_subflow_exists',
'  ( ',
'    p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  ) return boolean',
'  is',
'    l_cnt number;',
'  begin',
'    select count(*)',
'      into l_cnt',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_id = p_subflow_id',
'       and sbfl.sbfl_prcs_id = p_process_id',
'    ;',
'    return ( l_cnt = 1 );',
'  end check_subflow_exists;',
'',
'function get_subprocess_parent_subflow',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  , p_current    in flow_objects.objt_bpmn_id%type -- an object in the subprocess',
'  ) return flow_types_pkg.t_subflow_context',
'  is',
'    l_parent_subflow          flow_types_pkg.t_subflow_context;',
'    l_parent_subproc_activity flow_objects.objt_bpmn_id%type;',
'  begin',
'',
'    select calling_sbfl.sbfl_id',
'         , calling_sbfl.sbfl_step_key',
'         , calling_sbfl.sbfl_scope',
'      into l_parent_subflow.sbfl_id',
'         , l_parent_subflow.step_key',
'         , l_parent_subflow.scope',
'      from flow_subflows calling_sbfl',
'      join flow_subflows called_sbfl',
'        on called_sbfl.sbfl_calling_sbfl = calling_sbfl.sbfl_id',
'       and called_sbfl.sbfl_prcs_id = calling_sbfl.sbfl_prcs_id',
'     where called_sbfl.sbfl_id = p_subflow_id',
'       and called_sbfl.sbfl_prcs_id = p_process_id',
'       ;',
'    return l_parent_subflow;',
'  exception',
'      when no_data_found then',
'        -- no subflow found running the parent process ',
'        return null;',
'  end get_subprocess_parent_subflow;',
'',
'procedure get_number_of_connections ',
'    ( pi_dgrm_id                  in flow_diagrams.dgrm_id%type',
'    , pi_target_objt_id           in flow_connections.conn_tgt_objt_id%type',
'    , pi_conn_type                in flow_connections.conn_tag_name%type  ',
'    , po_num_forward_connections  out number',
'    , po_num_back_connections     out number',
'    )',
'  is ',
'  begin   ',
'    select count(*)',
'      into po_num_back_connections',
'      from flow_connections conn ',
'     where conn.conn_tgt_objt_id = pi_target_objt_id',
'       and conn.conn_tag_name = pi_conn_type',
'       and conn.conn_dgrm_id = pi_dgrm_id',
'    ;',
'    select count(*)',
'      into po_num_forward_connections',
'      from flow_connections conn ',
'     where conn.conn_src_objt_id = pi_target_objt_id',
'       and conn.conn_tag_name = pi_conn_type',
'       and conn.conn_dgrm_id = pi_dgrm_id',
'    ;',
'  end get_number_of_connections;',
'',
'  function get_object_subtag',
'  ( p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id      in flow_diagrams.dgrm_id%type  ',
'  )',
'  return varchar2',
'  is',
'    l_objt_sub_tag_name  flow_objects.objt_bpmn_id%type;',
'  begin',
'    select objt.objt_sub_tag_name',
'      into l_objt_sub_tag_name',
'      from flow_objects objt',
'     where objt.objt_bpmn_id = p_objt_bpmn_id',
'       and objt.objt_dgrm_id = p_dgrm_id',
'       ;',
'    return l_objt_sub_tag_name;',
'  end get_object_subtag;',
'',
'  function get_object_tag',
'  ( p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id      in flow_diagrams.dgrm_id%type  ',
'  ) return flow_objects.objt_tag_name%type',
'  is',
'    l_objt_tag_name  flow_objects.objt_bpmn_id%type;',
'  begin',
'    select objt.objt_tag_name',
'      into l_objt_tag_name',
'      from flow_objects objt',
'     where objt.objt_bpmn_id = p_objt_bpmn_id',
'       and objt.objt_dgrm_id = p_dgrm_id',
'       ;',
'    return l_objt_tag_name;',
'  end get_object_tag;',
'',
'function get_object_tag',
'( p_sbfl_info   in flow_subflows%rowtype',
') return flow_objects.objt_tag_name%type',
'is',
'  l_objt_tag_name   flow_objects.objt_tag_name%type;',
'begin',
'  select objt.objt_tag_name',
'    into l_objt_tag_name',
'    from flow_objects objt',
'   where objt.objt_bpmn_id = p_sbfl_info.sbfl_current',
'     and objt.objt_dgrm_id = p_sbfl_info.sbfl_dgrm_id',
'  ;',
'  return l_objt_tag_name;',
'end get_object_tag;',
'  ',
'  function get_subflow_info',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_lock_subflow  in boolean default false',
'  , p_lock_process  in boolean default false',
'  ) return flow_subflows%rowtype',
'  is ',
'    l_sbfl_rec          flow_subflows%rowtype;',
'    l_prcs_check_id     flow_processes.prcs_id%type;',
'  begin',
'    begin ',
'      if p_lock_process then',
'        begin',
'          select prcs.prcs_id',
'            into l_prcs_check_id',
'            from flow_processes prcs',
'          where prcs.prcs_id = p_process_id',
'          ;',
'        exception',
'          when no_data_found then',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id     => p_process_id',
'            , pi_sbfl_id     => p_subflow_id',
'            , pi_message_key => ''engine-util-prcs-not-found''',
'            , p0 => p_process_id',
'            );',
'            -- $F4AMESSAGE ''engine-util-prcs-not-found'' || ''Application Error: Process ID %0 not found).''  ',
'        end;',
'      end if;',
'      if p_lock_subflow then ',
'        select *',
'        into l_sbfl_rec',
'        from flow_subflows sbfl',
'        where sbfl.sbfl_prcs_id = p_process_id',
'        and sbfl.sbfl_id = p_subflow_id',
'        for update wait 2',
'        ;',
'      else ',
'        select *',
'        into l_sbfl_rec',
'        from flow_subflows sbfl',
'        where sbfl.sbfl_prcs_id = p_process_id',
'        and sbfl.sbfl_id = p_subflow_id',
'        ;',
'      end if;',
'    exception',
'      when no_data_found then',
'        -- check if subflow valid in process',
'        select sbfl.sbfl_prcs_id',
'          into l_prcs_check_id',
'          from flow_subflows sbfl',
'         where sbfl.sbfl_id = p_subflow_id',
'         ;',
'        if l_prcs_check_id != p_process_id then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id     => p_process_id',
'          , pi_sbfl_id     => p_subflow_id',
'          , pi_message_key => ''engine-util-sbfl-not-in-prcs''',
'          , p0 => p_subflow_id',
'          , p1 => p_process_id',
'          );',
'          -- $F4AMESSAGE ''engine-util-sbfl-not-in-prcs'' || ''Application Error: Subflow ID supplied ( %0 ) exists but is not child of Process ID Supplied ( %1 ).''  ',
'        end if;',
'      when lock_timeout then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => p_subflow_id',
'        , pi_message_key => ''timeout_locking_subflow''',
'        , p0 => p_subflow_id',
'        );',
'        -- $F4AMESSAGE ''timeout_locking_subflow'' || ''Unable to lock subflow %0 as currently locked by another user.  Retry your transaction later.''  ',
'    end;',
'    return l_sbfl_rec;',
'  exception',
'    when no_data_found then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_process_id',
'      , pi_sbfl_id     => p_subflow_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => p_subflow_id',
'      );',
'      return null;',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'  end get_subflow_info;',
'',
'  function get_iteration_type',
'  ( p_step_info         flow_types_pkg.flow_step_info',
'  ) return varchar2',
'  is',
'    l_iteration_type          varchar2(10);',
'    l_sequential              boolean;',
'    l_target_objt_attributes  sys.json_object_t;',
'    l_target_iter_attributes  sys.json_object_t;',
'    l_multi_attributes        sys.json_object_t;',
'  begin',
'    -- get loop characteristics',
'    l_target_objt_attributes := sys.json_object_t.parse(p_step_info.target_objt_attributes);',
'    apex_debug.message (p_message => ''l_target_objt_atributes: %0'', p0 => l_target_objt_attributes.to_string);',
'    if l_target_objt_attributes.has(''apex'') then',
'      apex_debug.message (p_message => ''has apex'');',
'      l_target_iter_attributes := l_target_objt_attributes.get_object(''apex'');',
'      if l_target_objt_attributes.get_object(''apex'').has(''standardLoopCharacteristics'') then',
'        apex_debug.message (p_message => ''has standardLoop'');',
'        l_iteration_type := flow_constants_pkg.gc_iteration_loop;',
'      elsif l_target_objt_attributes.get_object(''apex'').has(''multiInstanceLoopCharacteristics'') then',
'        apex_debug.message (p_message => ''has multiIstanceLoop'');',
'        l_multi_attributes := l_target_objt_attributes.get_object(''apex'').get_object(''multiInstanceLoopCharacteristics'');',
'        l_sequential := l_multi_attributes.get_boolean(''isSequential'');',
'        case l_sequential',
'        when true then',
'          l_iteration_type := flow_constants_pkg.gc_iteration_sequential;',
'        when false then',
'          l_iteration_type := flow_constants_pkg.gc_iteration_parallel;',
'        end case;',
'      end if;',
'    else ',
'      l_iteration_type := null;',
'    end if;',
'    apex_debug.message (p_message => ''Iteration Type: %0'', p0 => l_iteration_type);',
'    return l_iteration_type;',
'  end get_iteration_type;',
'',
'  function get_loop_counter',
'  ( pi_sbfl_id       in  flow_subflows.sbfl_id%type',
'  ) return flow_subflows.sbfl_loop_counter%type',
'  is',
'    l_loop_counter   flow_subflows.sbfl_loop_counter%type;',
'  begin',
'    select it.iter_loop_counter',
'      into l_loop_counter',
'      from flow_iterations it',
'      join flow_subflows s',
'        on s.sbfl_iter_id = it.iter_id',
'     where s.sbfl_id = pi_sbfl_id;',
'    apex_debug.message (p_message=>''--> get_loop_counter - value = %0'', p0=> l_loop_counter);',
'    return l_loop_counter;',
'  exception',
'    when others then',
'      return null;',
'  end get_loop_counter;',
'',
'',
'  function subflow_start',
'    ( ',
'      p_process_id                in flow_processes.prcs_id%type',
'    , p_parent_subflow            in flow_subflows.sbfl_id%type',
'    , p_starting_object           in flow_objects.objt_bpmn_id%type',
'    , p_current_object            in flow_objects.objt_bpmn_id%type',
'    , p_route                     in flow_subflows.sbfl_route%type',
'    , p_last_completed            in flow_objects.objt_bpmn_id%type',
'    , p_status                    in flow_subflows.sbfl_status%type default flow_constants_pkg.gc_sbfl_status_running',
'    , p_parent_sbfl_proc_level    in flow_subflows.sbfl_process_level%type  --- can remove?',
'    , p_new_proc_level            in boolean default false',
'    , p_new_scope                 in boolean default false',
'    , p_new_diagram               in boolean default false',
'    , p_dgrm_id                   in flow_diagrams.dgrm_id%type',
'    , p_follows_ebg               in boolean default false',
'    , p_loop_counter              in number default null',
'    , p_iteration_type            in flow_subflows.sbfl_iteration_type%type default null',
'    , p_loop_total_instances      in flow_subflows.sbfl_loop_total_instances%type default null',
'    , p_iteration_var             in flow_process_variables.prov_var_name%type default null',
'    , p_iteration_var_scope       in flow_subflows.sbfl_scope%type default null',
'    , p_iter_id                   in flow_iterations.iter_id%type default null    ',
'    , p_iterated_object           in flow_iterated_objects.iobj_id%type default null                 ',
'    ) return flow_types_pkg.t_subflow_context',
'  is ',
'    l_timestamp           flow_subflows.sbfl_became_current%type;',
'    l_process_level       flow_subflows.sbfl_process_level%type := p_parent_sbfl_proc_level;',
'    l_diagram_level       flow_subflows.sbfl_diagram_level%type := 0;',
'    l_new_subflow_context flow_types_pkg.t_subflow_context;',
'    l_lane                flow_objects.objt_bpmn_id%type;',
'    l_lane_name           flow_objects.objt_name%type;',
'    l_lane_isRole         flow_subflows.sbfl_lane_isRole%type;',
'    l_lane_role           flow_subflows.sbfl_lane_role%type;',
'    l_scope               flow_subflows.sbfl_scope%type := 0;',
'    l_level_parent        flow_subflows.sbfl_id%type := 0;',
'    l_is_new_level        varchar2(1 byte) := flow_constants_pkg.gc_false;',
'    l_is_new_scope        varchar2(1 byte) := flow_constants_pkg.gc_false;',
'    l_follows_ebg         flow_subflows.sbfl_is_following_ebg%type;',
'    l_new_iter_id         flow_iterations.iter_id%type;',
'  begin',
'    apex_debug.enter ',
'    ( ''subflow_start''',
'    , ''Process'', p_process_id',
'    , ''Parent Subflow'', p_parent_subflow ',
'    , ''Loop Counter'', p_loop_counter',
'    );',
'    ',
'    -- convert boolean in parameters to varchar2 for use in SQL',
'    if p_new_proc_level then ',
'      l_is_new_level := flow_constants_pkg.gc_true;',
'    end if;',
'    if p_follows_ebg then',
'      l_follows_ebg := flow_constants_pkg.gc_true;',
'    end if;',
'',
'    if p_parent_subflow is  null then',
'    -- initial subflow in process.   Get starting Lane info. (could be null)',
'    -- database 23.3 bug 35862529 means this will return NDF if there are no lanes so we handle (ignore) the NDF',
'      begin',
'        select lane_objt.objt_bpmn_id',
'             , lane_objt.objt_name',
'             , lane_objt.objt_attributes."apex"."isRole"',
'             , lane_objt.objt_attributes."apex"."role"',
'          into l_lane',
'             , l_lane_name',
'             , l_lane_isRole',
'             , l_lane_role',
'          from flow_objects start_objt',
'          left join flow_objects lane_objt',
'            on start_objt.objt_objt_lane_id = lane_objt.objt_id',
'           and start_objt.objt_dgrm_id      = lane_objt.objt_dgrm_id',
'         where start_objt.objt_dgrm_id = p_dgrm_id',
'           and start_objt.objt_bpmn_id = p_starting_object',
'        ;',
'      exception',
'        when no_data_found then',
'          null;',
'      end;',
'    else',
'    -- new subflow in existing process',
'    -- get process level, diagram level, scope, calling subflow for copy down unless this is the initial subflow in a process',
'      select sbfl.sbfl_process_level',
'           , sbfl.sbfl_diagram_level',
'           , sbfl.sbfl_scope',
'           , sbfl.sbfl_lane',
'           , sbfl.sbfl_lane_name',
'           , sbfl.sbfl_lane_isRole',
'           , sbfl.sbfl_lane_role',
'           , case l_is_new_level',
'                when ''Y'' then p_parent_subflow  ',
'                when ''N'' then sbfl.sbfl_calling_sbfl',
'             end ',
'           , coalesce(p_iter_id, sbfl_iter_id)',
'        into l_process_level',
'           , l_diagram_level',
'           , l_scope',
'           , l_lane',
'           , l_lane_name',
'           , l_lane_isRole',
'           , l_lane_role',
'           , l_level_parent',
'           , l_new_iter_id',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_id = p_parent_subflow;',
'    end if;',
'',
'    -- create the new subflow',
'',
'    insert',
'      into flow_subflows',
'         ( sbfl_prcs_id',
'         , sbfl_sbfl_id',
'         , sbfl_process_level',
'         , sbfl_starting_object',
'         , sbfl_route',
'         , sbfl_last_completed',
'         , sbfl_became_current',
'         , sbfl_current',
'         , sbfl_status',
'         , sbfl_last_update',
'         , sbfl_last_update_by',
'         , sbfl_dgrm_id',
'         , sbfl_diagram_level',
'         , sbfl_step_key',
'         , sbfl_calling_sbfl',
'         , sbfl_scope',
'         , sbfl_lane',
'         , sbfl_lane_name',
'         , sbfl_lane_isRole',
'         , sbfl_lane_role',
'         , sbfl_is_following_ebg',
'         , sbfl_loop_counter',
'         , sbfl_iteration_type',
'         , sbfl_loop_total_instances',
'         , sbfl_iteration_var',
'         , sbfl_iteration_var_scope',
'         , sbfl_iter_id',
'         , sbfl_iobj_id',
'         )',
'    values',
'         ( p_process_id',
'         , p_parent_subflow',
'         , l_process_level',
'         , p_starting_object',
'         , p_route',
'         , p_last_completed',
'         , systimestamp',
'         , p_current_object',
'         , p_status',
'         , systimestamp',
'         , coalesce ( sys_context(''apex$session'',''app_user'') ',
'                    , sys_context(''userenv'',''os_user'')',
'                    , sys_context(''userenv'',''session_user'')',
'                    )  ',
'         , p_dgrm_id',
'         , l_diagram_level',
'         , flow_engine_util.step_key',
'         , l_level_parent',
'         , l_scope',
'         , l_lane',
'         , l_lane_name',
'         , l_lane_isRole',
'         , l_lane_role',
'         , l_follows_ebg',
'         , p_loop_counter',
'         , p_iteration_type',
'         , p_loop_total_instances ',
'         , p_iteration_var',
'         , p_iteration_var_scope',
'         , l_new_iter_id  ',
'         , p_iterated_object         ',
'         )',
'    returning sbfl_id, sbfl_step_key, sbfl_route, sbfl_scope into l_new_subflow_context',
'    ;                                 ',
'',
'    if p_new_proc_level then',
'      -- starting new subprocess.  Reset sbfl_process_level to new sbfl_id (change on new subProcesss, callActivity)',
'      l_process_level := l_new_subflow_context.sbfl_id;',
'',
'      if p_new_scope then',
'        -- starting new variable scope.  Reset sbfl_scope to new sbfl_id. (change on callActivity (maybe others later...iteration, etc.) )',
'        l_new_subflow_context.scope := l_new_subflow_context.sbfl_id;',
'      end if;',
'',
'      if p_new_diagram then',
'        -- starting a new diagram.   set the diagram_level to new sbfl_id (change on new callActivity)',
'        l_diagram_level := l_new_subflow_context.sbfl_id;',
'      end if;',
'',
'      update flow_subflows',
'         set sbfl_process_level   = l_process_level',
'           , sbfl_scope           = l_new_subflow_context.scope',
'           , sbfl_diagram_level   = l_diagram_level',
'       where sbfl_id = l_new_subflow_context.sbfl_id;',
'',
'    end if;',
'',
'    apex_debug.info',
'    ( p_message => ''New Subflow started.  Process: %0 Subflow: %1 Step Key: %2 Scope: %3 Lane: %4 ( %5 ) LoopCounter: %6. Iter_id: %7''',
'    , p0        => p_process_id',
'    , p1        => l_new_subflow_context.sbfl_id',
'    , p2        => l_new_subflow_context.step_key',
'    , p3        => l_new_subflow_context.scope',
'    , p4        => l_lane',
'    , p5        => l_lane_name',
'    , p6        => p_loop_counter',
'    , p7        => l_new_iter_id',
'    );',
'    return l_new_subflow_context;',
'  end subflow_start;',
'',
'  procedure terminate_level',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_process_level in flow_subflows.sbfl_process_level%type',
'    )',
'  is',
'    l_apex_task_id  number;',
'  begin',
'    apex_debug.enter',
'    ( ''terminate_level''',
'    , ''Process'',  p_process_id',
'    , ''Process Level'', p_process_level',
'    );',
'    -- find any running subprocesses with parent at this level',
'    begin',
'      for child_proc_levels in (',
'        select distinct child_sbfl.sbfl_process_level',
'          from flow_subflows parent_sbfl',
'          join flow_subflows child_sbfl',
'            on parent_sbfl.sbfl_current = child_sbfl.sbfl_starting_object',
'           and parent_sbfl.sbfl_prcs_id = child_sbfl.sbfl_prcs_id',
'           and parent_sbfl.sbfl_id      = child_sbfl.sbfl_calling_sbfl',
'--         where parent_sbfl.sbfl_status =  flow_constants_pkg.gc_sbfl_status_in_subprocess',
'         where parent_sbfl.sbfl_status in ( flow_constants_pkg.gc_sbfl_status_in_subprocess',
'                                          , flow_constants_pkg.gc_sbfl_status_in_callactivity ',
'                                          , flow_constants_pkg.gc_sbfl_status_iterating)',
'           and parent_sbfl.sbfl_process_level = p_process_level',
'           and parent_sbfl.sbfl_prcs_id = p_process_id',
'      )',
'      loop',
'        terminate_level',
'        ( p_process_id     => p_process_id',
'        , p_process_level  => child_proc_levels.sbfl_process_level);',
'      end loop;',
'    end;',
'    -- end all subflows in this level',
'',
'      -- first check if any subflows have current tasks that running external tasks, e,g., APEX approvals',
'      begin',
'        for subflows_with_tasks in (',
'          select sbfl.sbfl_id',
'               , sbfl.sbfl_current',
'               , sbfl.sbfl_scope',
'               , objt.objt_tag_name',
'               , objt.objt_sub_tag_name',
'               , objt.objt_attributes."taskType" tasktype',
'            from flow_subflows sbfl',
'            join flow_objects objt',
'              on sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'             and sbfl.sbfl_current = objt.objt_bpmn_id',
'           where sbfl.sbfl_prcs_id = p_process_id',
'             and sbfl.sbfl_process_level = p_process_level',
'             and objt.objt_tag_name in ( flow_constants_pkg.gc_bpmn_usertask',
'                                       , flow_constants_pkg.gc_bpmn_receiveTask',
'                                       , flow_constants_pkg.gc_bpmn_intermediate_catch_event )',
'--             and objt.objt_sub_tag_name = flow_constants_pkg.gc_apex_usertask_apex_approval',
'        )',
'        loop',
'          -- clear any approval tasks (only runs on APEX 22.1 upwards)',
'          $IF NOT FLOW_APEX_ENV.VER_LE_21_2  ',
'          $THEN',
'            if subflows_with_tasks.tasktype = flow_constants_pkg.gc_apex_usertask_apex_approval then',
'              -- get apex taskID',
'              l_apex_task_id := flow_proc_vars_int.get_var_num',
'                                  ( pi_prcs_id   => p_process_id',
'                                  , pi_var_name  => subflows_with_tasks.sbfl_current||flow_constants_pkg.gc_prov_suffix_task_id',
'                                  , pi_scope     => subflows_with_tasks.sbfl_scope',
'                                  );',
'              -- cancel apex workflow task',
'              flow_usertask_pkg.cancel_apex_task',
'              ( p_process_id    => p_process_id',
'              , p_objt_bpmn_id  => subflows_with_tasks.sbfl_current',
'              , p_apex_task_id  => l_apex_task_id',
'              );',
'            end if;',
'          $END ',
'          -- cancel any message subscriptions',
'          if subflows_with_tasks.tasktype = flow_constants_pkg.gc_simple_message then',
'            flow_message_util.cancel_subscription ( p_process_id  => p_process_id ',
'                                                  , p_subflow_id  => subflows_with_tasks.sbfl_id',
'                                                  );',
'          end if;',
'        end loop;',
'      end;',
'',
'     -- then delete the subflows',
'    delete from flow_subflows',
'    where sbfl_process_level = p_process_level ',
'      and sbfl_prcs_id = p_process_id',
'      ;',
'    apex_debug.info ',
'    ( p_message => ''Process %0 : All subflows at process level %1 terminated''',
'    , p0 => p_process_id',
'    , p1 => p_process_level',
'    );',
'  end terminate_level;',
'',
'  procedure subflow_complete',
'    ( p_process_id        in flow_processes.prcs_id%type',
'    , p_subflow_id        in flow_subflows.sbfl_id%type',
'    )',
'  is',
'    l_remaining_subflows              number;',
'    l_remaining_siblings              number;',
'    l_current_object                  flow_subflows.sbfl_current%type;',
'    l_current_subflow_status          flow_subflows.sbfl_status%type;',
'    l_current_subflow_process_level   flow_subflows.sbfl_process_level%type;',
'    l_parent_subflow_id               flow_subflows.sbfl_sbfl_id%type;',
'    l_parent_subflow_status           flow_subflows.sbfl_status%type;',
'    l_parent_subflow_last_completed   flow_subflows.sbfl_last_completed%type;',
'    l_parent_subflow_current          flow_subflows.sbfl_current%type;',
'  begin',
'    apex_debug.enter',
'    ( ''subflow_complete''',
'    , ''Subflow'' , p_subflow_id ',
'    );',
'    select sbfl.sbfl_sbfl_id',
'         , sbfl.sbfl_current',
'         , sbfl.sbfl_status',
'         , sbfl.sbfl_process_level',
'      into l_parent_subflow_id',
'         , l_current_object',
'         , l_current_subflow_status',
'         , l_current_subflow_process_level',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_id = p_subflow_id',
'       and sbfl.sbfl_prcs_id = p_process_id',
'    ; ',
'    ',
'    if l_parent_subflow_id is not null then   ',
'      -- get parent subflow info',
'      select sbfl.sbfl_status',
'           , sbfl.sbfl_last_completed',
'           , sbfl.sbfl_current',
'        into l_parent_subflow_status',
'           , l_parent_subflow_last_completed',
'           , l_parent_subflow_current',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_id = l_parent_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'      ;',
'    end if;',
'    -- delete the subflow',
'    delete from flow_subflows',
'     where sbfl_id = p_subflow_id',
'       and sbfl_prcs_id = p_process_id',
'    ;',
'',
'    -- handle parallel flows with their own end events.  Last one completing needs to clear up the parent ''split'' sbfl.',
'    -- if subflow has parent with   ',
'    -- a)  status ''split''  (flow_constants_pkg.gc_sbfl_status_split)',
'    -- b)  no other children, AND',
'    -- c)  is not a merging gateway',
'    -- then we have an ophan parent process to clean up (all opening gateway paths have run to conclusion)',
'    -- need to call this recursively in case you have nested open parallel gateways',
'',
'    if l_parent_subflow_id is not null then   ',
'        ',
'      select count(*)',
'        into l_remaining_siblings',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_prcs_id = p_process_id',
'         and sbfl.sbfl_starting_object = l_parent_subflow_last_completed',
'         and sbfl.sbfl_process_level   = l_current_subflow_process_level',
'      ;',
'      ',
'      if (   l_remaining_siblings = 0',
'         and l_parent_subflow_status =  flow_constants_pkg.gc_sbfl_status_split    ',
'         and l_current_subflow_status not in ( flow_constants_pkg.gc_sbfl_status_waiting_gateway',
'                                             , flow_constants_pkg.gc_sbfl_status_waiting_iter )',
'         )',
'      then',
'        -- call subflow_complete again recursively in case it has orphan grandparent',
'        subflow_complete ( p_process_id => p_process_id',
'                         , p_subflow_id => l_parent_subflow_id',
'                         );',
'      end if;  ',
'    end if;',
'  end subflow_complete;',
'',
'  function lock_subflow',
'  ( p_subflow_id    in flow_subflows.sbfl_id%type',
'  ) return boolean',
'  is ',
'    l_sbfl_prcs_id   flow_subflows.sbfl_prcs_id%type;',
'  begin ',
'',
'    apex_debug.enter ',
'    ( ''lock_subflow''',
'    , ''Subflow'', p_subflow_id ',
'    );',
'',
'    select sbfl.sbfl_prcs_id',
'      into l_sbfl_prcs_id',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_id = p_subflow_id',
'    for update wait 2',
'    ;',
'    return true;',
'  exception',
'    when no_data_found then',
'      return false;',
'    when lock_timeout then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id => l_sbfl_prcs_id',
'      , pi_sbfl_id => p_subflow_id',
'      , pi_message_key => ''timeout_locking_subflow''',
'      , p0 => p_subflow_id',
'      );',
'      -- $F4AMESSAGE ''timeout_locking_subflow'' || ''Unable to lock subflow %0 as currently locked by another user.  Try again later.''',
'      return false;',
'  end lock_subflow;',
'',
'  function get_scope',
'  (  p_process_id  in flow_processes.prcs_id%type',
'  ,  p_subflow_id  in flow_subflows.sbfl_id%type',
'  ) return flow_subflows.sbfl_scope%type',
'  is',
'    l_scope   flow_subflows.sbfl_scope%type;',
'  begin',
'    select sbfl_scope',
'      into l_scope',
'      from flow_subflows',
'     where sbfl_id = p_subflow_id',
'       and sbfl_prcs_id = p_process_id',
'    ;',
'    return l_scope;',
'  exception',
'    when no_data_found then ',
'    flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_process_id',
'      , pi_sbfl_id     => p_subflow_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => p_subflow_id',
'      , p1 => p_process_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).'' ',
'  end get_scope;',
'',
'  function json_array_join',
'  (',
'    p_json_array in sys.json_array_t',
'  ) return clob',
'  as',
'    l_return clob;',
'  begin',
'    apex_debug.info( p_message => ''-- Joining JSON Array to CLOB, size %0'', p0 => p_json_array.get_size );',
'    for i in 0..p_json_array.get_size - 1 loop',
'      l_return := l_return || p_json_array.get_string( i ) || apex_application.lf;',
'    end loop;',
'    return l_return;',
'  end json_array_join;',
'',
'  function json_array_join',
'  (',
'    p_json_array in clob',
'  ) return clob',
'  as',
'    l_json sys.json_array_t;',
'  begin',
'    if p_json_array is not null then',
'      apex_debug.info( p_message => ''-- Got CLOB parsing to JSON_ARRAY_T'' );',
'      l_json := sys.json_array_t.parse( p_json_array );',
'      return json_array_join( p_json_array => l_json );',
'    else',
'      return null;',
'    end if;',
'  end json_array_join;',
'',
'  function apex_json_array_join',
'  ( p_json_array in apex_t_varchar2',
'  )',
'  return clob',
'  is ',
'    l_return clob;',
'  begin',
'    apex_debug.info( p_message => ''-- Joining APEX JSON Array to vc2, size %0'', p0 => p_json_array.count );',
'',
'    l_return := apex_string.join_clob( p_table => p_json_array );',
'',
'    apex_debug.info( p_message => ''-- returned string'', p0 => l_return);',
'    return l_return;',
'  end apex_json_array_join;',
'',
'  function clob_to_blob',
'  ( ',
'    pi_clob in clob',
'  ) return blob',
'  as',
'  $if flow_apex_env.ver_le_22_1 $then',
'    l_blob   blob;',
'    l_dstoff pls_integer := 1;',
'    l_srcoff pls_integer := 1;',
'    l_lngctx pls_integer := 0;',
'    l_warn   pls_integer;',
'  $end',
'  begin',
'',
'  $if flow_apex_env.ver_le_22_1 $then',
'    sys.dbms_lob.createtemporary',
'    ( lob_loc => l_blob',
'    , cache   => true',
'    , dur     => sys.dbms_lob.call',
'    );    ',
'',
'    sys.dbms_lob.converttoblob',
'    ( dest_lob     => l_blob',
'    , src_clob     => pi_clob',
'    , amount       =>'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' sys.dbms_lob.lobmaxsize',
'    , dest_offset  => l_dstoff',
'    , src_offset   => l_srcoff',
'    , blob_csid    => nls_charset_id( ''AL32UTF8'' )',
'    , lang_context => l_lngctx',
'    , warning      => l_warn',
'    );',
'',
'    return l_blob;',
'  $else',
'    return apex_util.clob_to_blob( p_clob => pi_clob );',
'  $end',
'',
'  end clob_to_blob;',
'',
'',
'  -- initialise step key enforcement parameter',
'',
'  begin',
'    g_step_keys_enforced :=  (  flow_engine_util.get_config_value',
'                                ( p_config_key => flow_constants_pkg.gc_config_dup_step_prevention',
'                                , p_default_value => flow_constants_pkg.gc_config_default_dup_step_prevention ',
'                                )',
'                                = flow_constants_pkg.gc_config_dup_step_prevention_strict',
'                             );',
'',
'end flow_engine_util;',
'/',
'',
'create or replace package body flow_gateways',
'as ',
'/* ',
'-- Flows for APEX - flow_gateways.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'-- (c) Copyright Flowquest Consulting Limited. 2021-24',
'--',
'-- Created    06-May-2021  Richard Allen (Flowquest, for MT AG)',
'-- Modified   12-Apr-2022  Richard Allen (Oracle)',
'-- Modified   2022-07-18   Moritz Klein (MT AG)',
'-- Modified   09-Jan-2024  Richard Allen, Flowquest Consulting',
'--',
'*/',
'  type t_new_sbfls is table of flow_types_pkg.t_subflow_context;',
'',
'  e_no_route_found          exception;',
'  e_bad_routing_expression  exception;',
'  lock_timeout              exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'  function get_valid_routing_variable_routes',
'    ( pi_prcs_id            in flow_processes.prcs_id%type',
'    , pi_sbfl_id            in flow_subflows.sbfl_id%type',
'    , pi_objt_bpmn_id       in flow_objects.objt_bpmn_id%type',
'    , pi_objt_tag           in flow_objects.objt_tag_name%type ',
'    , pi_routing_variable   in flow_process_variables.prov_var_vc2%type  ',
'    ) return apex_t_varchar2',
'  is ',
'    l_forward_routes   apex_t_varchar2;  -- routes specified in the routing variable',
'    l_possible_routes  apex_t_varchar2;  -- all possible forward routes from the splitting gateway',
'    l_bad_routes       apex_t_varchar2;  -- specified routes which are not valid routes',
'    l_bad_route_string varchar2 (2000);',
'  begin',
'    begin',
'      l_forward_routes := apex_string.split ( p_str => pi_routing_variable',
'                                            , p_sep => '':''',
'                                            );',
'      if pi_objt_tag = flow_constants_pkg.gc_bpmn_gateway_exclusive then',
'        if (l_forward_routes.count > 1) then',
'          l_bad_route_string := pi_routing_variable;',
'          apex_debug.info ( p_message => ''-- exclusive gateway - routing variable contains more than one forward route %0''',
'                          , p0 => l_bad_route_string',
'                          );',
'          raise flow_errors.e_gateway_invalid_route;',
'        end if;',
'      end if;',
'      -- get the possible forward routes',
'      select conn.conn_bpmn_id',
'        bulk collect into l_possible_routes',
'        from flow_connections conn',
'        join flow_objects objt ',
'          on objt.objt_id      = conn.conn_src_objt_id',
'         and objt.objt_dgrm_id = conn.conn_dgrm_id ',
'        join flow_subflows sbfl',
'          on sbfl.sbfl_dgrm_id = conn.conn_dgrm_id',
'       where sbfl.sbfl_id      = pi_sbfl_id',
'         and objt.objt_bpmn_id = pi_objt_bpmn_id',
'      ;',
'      -- check all specified routes are valid',
'      l_bad_routes := l_forward_routes multiset except l_possible_routes;',
'',
'      if l_bad_routes.count > 0 then',
'        -- we have some invalid routes in the routing variable',
'        l_bad_route_string := apex_string.join(l_bad_routes,'','');',
'        apex_debug.message ( ',
'          p_message => ''Invalid routes found - count %0, bad routes: %1)''',
'        , p0 => l_bad_routes.count',
'        , p1 => l_bad_route_string ',
'        );',
'        raise flow_errors.e_gateway_invalid_route;',
'      end if;',
'    exception',
'      when flow_errors.e_gateway_invalid_route then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => pi_prcs_id',
'        , pi_sbfl_id        => pi_sbfl_id',
'        , pi_message_key    => ''gateway-invalid-route''',
'        , p0 => pi_objt_bpmn_id ',
'        , p1 => pi_objt_bpmn_id||flow_constants_pkg.gc_prov_suffix_route',
'        , p2 => l_bad_route_string',
'        );',
'        -- $F4AMESSAGE ''gateway-invalid-route'' || ''Error at gateway %0. Supplied variable %1 contains invalid route: %2''  ',
'    end;',
'    return l_forward_routes;',
'  end get_valid_routing_variable_routes;',
'',
'  function get_valid_routing_expression_routes',
'    ( pi_prcs_id            in flow_processes.prcs_id%type',
'    , pi_sbfl_id            in flow_subflows.sbfl_id%type',
'    , pi_scope              in flow_subflows.sbfl_scope%type',
'    , pi_objt_bpmn_id       in flow_objects.objt_bpmn_id%type',
'    , pi_objt_tag           in flow_objects.objt_tag_name%type ',
'    ) return apex_t_varchar2',
'  is',
'    l_forward_routes    apex_t_varchar2 := apex_t_varchar2();',
'    type t_possible_route  is record ',
'      ( conn_id         flow_connections.conn_id%type',
'      , conn_is_default flow_connections.conn_is_default%type',
'      , conn_sequence   flow_connections.conn_sequence%type',
'      , conn_bpmn_id    flow_connections.conn_bpmn_id%type',
'      , conn_expression clob',
'      , conn_language   flow_types_pkg.t_expr_type',
'      );',
'    type t_possible_routes is table of t_possible_route;',
'    l_possible_routes       t_possible_routes;',
'    l_take_route            boolean;',
'    l_expr                  clob;',
'    l_expr_type             flow_types_pkg.t_expr_type;',
'    l_bind_list             apex_plugin_util.t_bind_list;',
'    l_expressions           number;',
'    l_has_default           boolean;',
'    l_default_has_condition boolean;',
'    l_num_expected_exprs    number;',
'  begin',
'    -- get all valid forward routes, ordered by ',
'    select conn.conn_id',
'         , conn.conn_is_default',
'         , conn.conn_sequence',
'         , conn.conn_bpmn_id',
'         , conn.conn_attributes."conditionExpression"."expression" as conn_expression',
'         , conn.conn_attributes."conditionExpression"."language"   as conn_language',
'      bulk collect into l_possible_routes',
'      from flow_connections conn',
'      join flow_objects objt',
'        on conn.conn_dgrm_id      = objt.objt_dgrm_id',
'       and conn.conn_src_objt_id  = objt.objt_id',
'      join flow_subflows sbfl',
'        on sbfl.sbfl_dgrm_id      = objt.objt_dgrm_id',
'     where objt.objt_bpmn_id      = pi_objt_bpmn_id',
'       and sbfl.sbfl_id           = pi_sbfl_id',
'       and conn.conn_tag_name     = flow_constants_pkg.gc_bpmn_sequence_flow',
'     order by conn.conn_is_default asc, conn.conn_sequence asc',
'    ;',
'',
'    apex_debug.info( p_message => ''-- Found %0 possible routes.'', p0 => l_possible_routes.count );',
'',
'    -- check whether expressions are being used',
'    -- if so, raise exception if any non default path is missing an expression - assume a missing gw routing var)',
'',
'    l_expressions           := 0;',
'    l_has_default           := false;',
'    l_default_has_condition  := false;',
'',
'    for route in 1 ..l_possible_routes.count',
'    loop',
'      if l_possible_routes(route).conn_expression is not null then',
'        l_expressions := l_expressions +1;',
'      end if;',
'      if l_possible_routes(route).conn_is_default = 1 then',
'        l_has_default           := true;',
'        if l_possible_routes(route).conn_expression is not null then',
'          l_default_has_condition  := true;',
'        end if;',
'      end if;',
'    end loop;',
'',
'    l_num_expected_exprs := l_possible_routes.count;',
'    if l_has_default and not l_default_has_condition then',
'      l_num_expected_exprs := l_num_expected_exprs - 1;',
'    end if;',
'',
'    if l_expressions > 0  then',
'      if l_num_expected_exprs > l_expressions then',
'        raise e_no_route_found;',
'      end if;',
'    end if;',
'',
'    -- evaluate each routing condition in sequence.  Treat no expression as unconditional',
'',
'    if l_possible_routes.count > 0 then',
'      -- loop over routes',
'      for route in 1 .. l_possible_routes.count',
'      loop',
'        l_bind_list := apex_plugin_util.c_empty_bind_list;',
'        apex_debug.info( p_message => ''-- Evaluating Route #%0, Language: %1, Expression: %2'', p0 => route, p1 => l_possible_routes(route).conn_language, p2 => l_possible_routes(route).conn_expression );',
'        l_take_route := false;',
'        -- evaluate route expression',
'        l_expr      :=',
'          flow_engine_util.json_array_join',
'          ( ',
'            p_json_array => l_possible_routes(route).conn_expression',
'          );',
'        l_expr_type := l_possible_routes(route).conn_language;',
'',
'        apex_debug.info (p_message => ''--- unpacked gateway expression : %0 type : %1  ''',
'          , p0 => l_expr',
'          , p1 => l_expr_type);',
'',
'        if l_expr is null and l_possible_routes(route).conn_is_default = 0 then',
'          -- treat forward path as being false',
'          l_take_route := false;',
'',
'          apex_debug.info (p_message => ''Expression contains no condition and will not be taken.''); ',
'        else ',
'          -- evaluate condition',
'',
'          flow_proc_vars_int.do_substitution  ( pi_prcs_id   => pi_prcs_id ',
'                                              , pi_sbfl_id   => pi_sbfl_id ',
'                                              , pi_scope     => pi_scope ',
'                                              , pio_string   => l_expr ',
'                                              );      ',
'',
'          apex_debug.info (p_message => ''--- after substitution - expression : %0 type : %1  ''',
'            , p0 => l_expr',
'            , p1 => l_expr_type);',
'',
'          l_bind_list := flow_proc_vars_int.get_bind_list ( pi_expr    => l_expr',
'                                                          , pi_prcs_id => pi_prcs_id',
'                                                          , pi_sbfl_id => pi_sbfl_id',
'                                                          , pi_scope   => pi_scope',
'                                                          );',
'',
'          begin',
'            case l_expr_type  ',
'            when flow_constants_pkg.gc_expr_type_plsql_expression then',
'              l_take_route := apex_plugin_util.get_plsql_expr_result_boolean ( p_plsql_expression => l_expr ',
'                                                                             , p_auto_bind_items  => false',
'                                                                             , p_bind_list        => l_bind_list',
'                                                                             );',
'            when flow_constants_pkg.gc_expr_type_plsql_function_body then',
'              l_take_route := apex_plugin_util.get_plsql_func_result_boolean ( p_plsql_function => l_expr ',
'                                                                             , p_auto_bind_items  => false',
'                                                                             , p_bind_list        => l_bind_list',
'                                                                             );          ',
'            else       ',
'              l_take_route := false;',
'            end case;',
'          exception',
'            when others then',
'              raise e_bad_routing_expression;',
'          end;',
'        end if;',
'',
'        apex_debug.info (p_message => ''Routing Expresion evaluation result : %0  ''',
'            , p0 => case l_take_route when true then ''true'' else ''false'' end );',
'',
'        -- if valid, add to forward_routes',
'        if l_take_route or ( l_possible_routes(route).conn_is_default = 1 ',
'                             and l_forward_routes.count = 0 )',
'        then',
'          l_forward_routes.extend;',
'          l_forward_routes(l_forward_routes.last) := l_possible_routes(route).conn_bpmn_id;',
'          if l_possible_routes(route).conn_is_default = 1 then',
'            apex_debug.info ( p_message => ''--- gateway routing using default routing''); ',
'          end if;',
'          -- if exclusive gateway, break out - we have our route',
'          if pi_objt_tag = flow_constants_pkg.gc_bpmn_gateway_exclusive then',
'            return l_forward_routes;',
'          end if;',
'        end if;',
'      end loop;',
'    else',
'      raise e_no_route_found;',
'    end if;',
'    -- check that some routes were found',
'    if l_forward_routes.count = 0 then',
'      raise e_no_route_found;',
'    end if;',
'    return l_forward_routes;',
'  end get_valid_routing_expression_routes;',
'',
'  function get_gateway_route',
'    ( pi_prcs_id        in flow_processes.prcs_id%type',
'    , pi_sbfl_id        in flow_subflows.sbfl_id%type',
'    , pi_objt_bpmn_id   in flow_objects.objt_bpmn_id%type',
'    , pi_objt_tag       in flow_objects.objt_tag_name%type',
'    , pi_scope          in flow_subflows.sbfl_scope%type',
'    ) return apex_t_varchar2',
'  is',
'    l_routing_variable      varchar2(2000);  -- 1 route for exclusiveGateway, 1 or more for inclusive (:sep)',
'    l_forward_routes        apex_t_varchar2 := apex_t_varchar2();',
'    l_num_routes            number := 0;',
'    l_default_route         flow_connections.conn_bpmn_id%type;',
'',
'  begin',
'    begin',
'      -- check if route is in process variable',
'      l_routing_variable := flow_proc_vars_int.get_var_vc2 ',
'                            ( pi_prcs_id  => pi_prcs_id',
'                            , pi_var_name => pi_objt_bpmn_id||flow_constants_pkg.gc_prov_suffix_route',
'                            , pi_scope    => pi_scope',
'                            );',
'      if l_routing_variable is not null then',
'        apex_debug.info( p_message => ''-- Using Routing Variable (Legacy Mode).'' );',
'        -- route from routing variable',
'        l_forward_routes := get_valid_routing_variable_routes ( pi_prcs_id          => pi_prcs_id',
'                                                              , pi_sbfl_id          => pi_sbfl_id',
'                                                              , pi_objt_bpmn_id     => pi_objt_bpmn_id',
'                                                              , pi_objt_tag         => pi_objt_tag',
'                                                              , pi_routing_variable => l_routing_variable',
'                                                              );   ',
'        apex_debug.info ( p_message => ''-- gateway routing using gateway routing variable.  Forward path: %0''',
'                        , p0 => l_routing_variable',
'                        );                                                                ',
'      else ',
'        apex_debug.info( p_message => ''-- Using Gateway Route Expressions or Default Routing.'' );',
'        -- look for gateway routing expressions or default routing',
'        l_forward_routes := get_valid_routing_expression_routes ( pi_prcs_id          => pi_prcs_id',
'                                                                , pi_sbfl_id          => pi_sbfl_id',
'                                                                , pi_objt_bpmn_id     => pi_objt_bpmn_id',
'                                                                , pi_objt_tag         => pi_objt_tag',
'                                                                , pi_scope            => pi_scope',
'                                                                ); ',
'        apex_debug.info ( p_message => ''-- gateway routing using gateway routing expressions or default path. Forward path: %0''',
'                        , p0 => apex_string.join (p_table => l_forward_routes, p_sep => '':'')',
'                        );   ',
'      end if; ',
'      if l_forward_routes.count = 0 then',
'        raise e_no_route_found;',
'      end if;',
'    exception',
'      when e_no_route_found then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => pi_prcs_id',
'        , pi_sbfl_id        => pi_sbfl_id',
'        , pi_message_key    => ''gateway-no-route''',
'        , p0 => pi_objt_bpmn_id||flow_constants_pkg.gc_prov_suffix_route',
'        );',
'        -- $F4AMESSAGE ''gateway-no-route'' || ''No gateway routing instruction provided in variable %0 and model contains no default route.''  ',
'      when e_bad_routing_expression then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => pi_prcs_id',
'        , pi_sbfl_id        => pi_sbfl_id',
'        , pi_message_key    => ''gateway-bad-expression''',
'        , p0 => pi_objt_bpmn_id||flow_constants_pkg.gc_prov_suffix_route',
'        );',
'        -- $F4AMESSAGE ''gateway-bad_expression'' || ''Bad gateway routing expression.  This can occur if you attempt to bind a variable with embedded colon (:).''  ',
'      when too_many_rows then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => pi_prcs_id',
'        , pi_sbfl_id        => pi_sbfl_id',
'        , pi_message_key    => ''gateway-too-many-defaults''',
'        , p0 => pi_objt_bpmn_id',
'        );',
'        -- $F4AMESSAGE ''gateway-too-many-defaults'' || ''More than one default route specified in model for Gateway %0.'' ',
'    end;',
'    return l_forward_routes;',
'  end get_gateway_route;',
'',
'  function gateway_merge',
'    ( p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    ) return varchar2 -- returns forward status ''wait'' or ''proceed''',
'  is ',
'    l_num_unfinished_subflows   number;',
'    l_gateway_forward_status    varchar2(10)  := ''wait'';',
'    l_subflow                   flow_subflows.sbfl_id%type;',
'  begin  ',
'    apex_debug.enter ',
'    ( ''gateway_merge''',
'    , ''p_sbfl_info.sbfl_current'' , p_sbfl_info.sbfl_current',
'    , ''p_step_info.target_objt_ref'' , p_step_info.target_objt_ref',
'    , ''p_sbfl_info.sbfl_last_completed'', p_sbfl_info.sbfl_last_completed',
'    );',
'    -- set current subflow to status waiting,       ',
'    update flow_subflows sbfl',
'        set sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_waiting_gateway',
'          , sbfl.sbfl_current        = p_step_info.target_objt_ref',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )            ',
'      where sbfl.sbfl_id = p_sbfl_info.sbfl_id',
'        and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'    ;',
'    -- check if we are waiting for other flows or can proceed',
'    select count(*)',
'      into l_num_unfinished_subflows',
'      from flow_subflows sbfl',
'      where sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'        and sbfl.sbfl_diagram_level = p_sbfl_info.sbfl_diagram_level',
'        and sbfl.sbfl_starting_object = p_sbfl_info.sbfl_starting_object',
'        and (  sbfl.sbfl_current != p_step_info.target_objt_ref',
'            or sbfl.sbfl_status != flow_constants_pkg.gc_sbfl_status_waiting_gateway',
'            )',
'    ;',
'    if l_num_unfinished_subflows = 0 then',
'      -- all task to be merged have completed.  So we do the merge... ',
'      -- lock parent subflow first',
'      if flow_engine_util.lock_subflow(p_sbfl_info.sbfl_sbfl_id) then',
'        begin',
'          -- proceed from gateway, locking child subflows',
'          for completed_subflows in ( select completed_sbfl.sbfl_id',
'                                        from flow_subflows completed_sbfl ',
'                                        where completed_sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'                                          and completed_sbfl.sbfl_diagram_level = p_sbfl_info.sbfl_diagram_level',
'                                          and completed_sbfl.sbfl_starting_object = p_sbfl_info.sbfl_starting_object',
'                                          and completed_sbfl.sbfl_current = p_step_info.target_objt_ref ',
'                                          and completed_sbfl.sbfl_status = flow_constants_pkg.gc_sbfl_status_waiting_gateway',
'                                          for update wait 2',
'                                    )',
'          loop',
'            l_subflow := completed_subflows.sbfl_id;',
'            flow_engine_util.subflow_complete',
'            ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'            , p_subflow_id => completed_subflows.sbfl_id',
'            );',
'          end loop;',
'',
'          --mark parent split subflow ready to restart',
'          l_subflow := p_sbfl_info.sbfl_sbfl_id;',
'          update flow_subflows parent_sbfl',
'              set parent_sbfl.sbfl_status                   = flow_constants_pkg.gc_sbfl_status_proceed_gateway',
'                , parent_sbfl.sbfl_current                  = p_step_info.target_objt_ref',
'                , parent_sbfl.sbfl_iteration_type           = null',
'                , parent_sbfl.sbfl_loop_counter             = null',
'                , parent_sbfl.sbfl_loop_total_instances     = null',
'                , parent_sbfl.sbfl_last_completed           = p_sbfl_info.sbfl_current  -- last step of final child sbfl pre-merge',
'                , parent_sbfl.sbfl_last_update              = systimestamp',
'                , parent_sbfl.sbfl_last_update_by           = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                                       , sys_context(''userenv'',''os_user'')',
'                                                                       , sys_context(''userenv'',''session_user'')',
'                                                                       )  ',
'            where parent_sbfl.sbfl_last_completed           = p_sbfl_info.sbfl_starting_object',
'              and parent_sbfl.sbfl_status                   = flow_constants_pkg.gc_sbfl_status_split  ',
'              and parent_sbfl.sbfl_id                       = p_sbfl_info.sbfl_sbfl_id',
'          ;',
'        exception',
'          when lock_timeout then',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'            , pi_sbfl_id => l_subflow',
'            , pi_message_key => ''timeout_locking_subflow''',
'            , p0 => l_subflow',
'            );',
'          when others then',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'            , pi_message_key => ''gateway-merge-error''',
'            , p0 => l_subflow',
'            );          ',
'            -- $F4AMESSAGE ''gateway-merge-error'' || ''Internal error processing merging gateway on subflow %0'' ',
'        end;',
'        -- test for any errors so far ',
'        if not flow_globals.get_step_error then ',
'          -- process any after-merge expression set',
'          flow_expressions.process_expressions',
'          ( pi_objt_id     => p_step_info.target_objt_id',
'          , pi_set         => flow_constants_pkg.gc_expr_set_after_merge',
'          , pi_prcs_id     => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id     => p_sbfl_info.sbfl_sbfl_id',
'          , pi_var_scope   => p_sbfl_info.sbfl_scope',
'          , pi_expr_scope  => p_sbfl_info.sbfl_scope',
'          );',
'          -- test again for any errors so far - if so, don''t commit',
'          if not flow_globals.get_step_error then ',
'            -- commit tx',
'            commit;',
'            -- start new tx by locking parent subflow',
'            if not flow_engine_util.lock_subflow(p_sbfl_info.sbfl_sbfl_id) then',
'              -- unable to lock parent ''split'' subflow.',
'              flow_errors.handle_instance_error',
'              ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'              , pi_sbfl_id => p_sbfl_info.sbfl_sbfl_id',
'              , pi_message_key => ''timeout_locking_subflow''',
'              , p0 => p_sbfl_info.sbfl_sbfl_id',
'              );',
'            end if;',
'            l_gateway_forward_status := ''proceed'';',
'          else',
'            -- has step errors from expressions',
'            flow_errors.set_error_status',
'            ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'            , pi_sbfl_id => p_sbfl_info.sbfl_sbfl_id',
'            );',
'          end if;  ',
'        else ',
'          -- has step errors from merge',
'          flow_errors.set_error_status',
'          ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id => p_sbfl_info.sbfl_sbfl_id',
'          );',
'        end if;       ',
'      else ',
'        -- unable to lock parent ''split'' subflow.',
'        -- exception already handled in lock_subflow so no need to throw an error here.',
'        -- has step errors from locking',
'        flow_errors.set_error_status',
'        ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => p_sbfl_info.sbfl_sbfl_id',
'        );',
'      end if;',
'    end if; ',
'    return l_gateway_forward_status;',
'  end gateway_merge;',
'',
'  procedure gateway_split',
'    ( p_subflow_id     in flow_subflows.sbfl_id%type ',
'    , p_sbfl_info      in flow_subflows%rowtype',
'    , p_step_info      in flow_types_pkg.flow_step_info',
'    , p_gateway_routes in apex_t_varchar2',
'    )',
'  is ',
'    l_new_subflows      t_new_sbfls := t_new_sbfls();',
'    l_new_subflow       flow_types_pkg.t_subflow_context;',
'  begin ',
'    apex_debug.enter ',
'    ( ''gateway_split''',
'    , ''p_sbfl_info.sbfl_current'' , p_sbfl_info.sbfl_current',
'    , ''p_step_info.target_objt_ref'' , p_step_info.target_objt_ref',
'    );',
'    -- note that p_subflow_id might be different to the subflow in p_sbfl_info.sbfl_id',
'    -- we have splitting gateway going forward',
'    -- Current Subflow into status split ',
'    update flow_subflows sbfl',
'        set sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'          , sbfl.sbfl_current        = p_step_info.target_objt_ref',
'          , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_split  ',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'      where sbfl.sbfl_id = p_subflow_id',
'        and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'    ;',
'    -- get all forward parallel paths and create subflows for them',
'    -- these are paths forward of p_step_info.target_objt_ref as we are doing double step',
'    -- create subflows in one loop then step through them again in second loop',
'    -- to prevent some subflows getting to following merge gateway before all subflows are created (causes race condition)',
'',
'    for new_path in ( select conn.conn_bpmn_id route',
'                           , ultimate_tgt_objt.objt_bpmn_id target',
'                        from flow_connections conn',
'                        join flow_objects ultimate_tgt_objt -- first object in each child',
'                          on ultimate_tgt_objt.objt_id = conn.conn_tgt_objt_id',
'                         and conn.conn_dgrm_id = ultimate_tgt_objt.objt_dgrm_id',
'                        join flow_objects objt  -- gateway object',
'                          on objt.objt_id = conn.conn_src_objt_id',
'                         and conn.conn_dgrm_id = objt.objt_dgrm_id',
'                       where conn.conn_dgrm_id = p_step_info.dgrm_id',
'                         and conn.conn_src_objt_id = p_step_info.target_objt_id',
'                         and conn.conn_tag_name = flow_constants_pkg.gc_bpmn_sequence_flow',
'                         and ( objt.objt_tag_name = flow_constants_pkg.gc_bpmn_gateway_parallel',
'                             OR ',
'                             ( objt.objt_tag_name = flow_constants_pkg.gc_bpmn_gateway_inclusive',
'                             and ',
'                               conn.conn_bpmn_id member of p_gateway_routes',
'                             ))',
'                    )',
'    loop',
'      -- path is included in list of chosen forward paths.',
'      apex_debug.info',
'      ( p_message => ''starting parallel flow for %0''',
'      , p0        => p_step_info.target_objt_tag',
'      );',
'',
'      l_new_subflow :=',
'        flow_engine_util.subflow_start',
'        ( p_process_id             => p_sbfl_info.sbfl_prcs_id         ',
'        , p_parent_subflow         => p_subflow_id       ',
'        , p_starting_object        => p_step_info.target_objt_ref         ',
'        , p_current_object         => p_step_info.target_objt_ref          ',
'        , p_route                  => new_path.route         ',
'        , p_last_completed         => p_sbfl_info.sbfl_current ',
'        , p_status                 => flow_constants_pkg.gc_sbfl_status_created',
'        , p_parent_sbfl_proc_level => p_sbfl_info.sbfl_process_level',
'        , p_new_proc_level         => false',
'        , p_dgrm_id                => p_sbfl_info.sbfl_dgrm_id',
'        )',
'      ;',
'      l_new_subflow.route   := new_path.route;',
'      l_new_subflows.extend;',
'      l_new_subflows (l_new_subflows.last) := l_new_subflow;',
'    end loop;',
'    -- log gateway as completed',
'    flow_logging.log_step_completion   ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_subflow_id',
'    , p_completed_object => p_step_info.target_objt_ref ',
'    );',
'    -- update parent status now split and no current object',
'     update flow_subflows sbfl',
'        set sbfl.sbfl_current        = null',
'          , sbfl.sbfl_last_completed = p_step_info.target_objt_ref',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'      where sbfl.sbfl_id = p_subflow_id',
'        and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id;',
'',
'    -- commit the transaction',
'    commit;',
'    ',
'    apex_debug.info ( p_message => ''New Subflow Creation Commited'');',
'    ',
'    for new_subflow in 1.. l_new_subflows.count'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    loop',
'      -- reset step_had_error flag',
'      flow_globals.set_step_error ( p_has_error => false);',
'      -- check subflow still exists and lock it(in case earlier loop terminated everything in level)',
'      if flow_engine_util.lock_subflow( p_subflow_id => l_new_subflows(new_subflow).sbfl_id)',
'      then',
'        -- step into first step on the new path',
'        flow_engine.flow_complete_step    ',
'        ( p_process_id        => p_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id        => l_new_subflows(new_subflow).sbfl_id',
'        , p_step_key          => l_new_subflows(new_subflow).step_key',
'        , p_forward_route     => l_new_subflows(new_subflow).route',
'        , p_log_as_completed  => false',
'        );',
'      end if;',
'    end loop;',
'    -- reset step_had_error flag',
'    flow_globals.set_step_error ( p_has_error => false);',
'  end gateway_split;',
'',
'  procedure process_para_incl_Gateway',
'    ( p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is',
'    l_gateway_forward_status    varchar2(10);',
'    l_sbfl_id                   flow_subflows.sbfl_id%type;',
'    l_sbfl_id_sub               flow_subflows.sbfl_id%type;',
'    l_sbfl_id_par               flow_subflows.sbfl_id%type; ',
'    l_num_back_connections      number;   -- number of connections leading into object',
'    l_num_forward_connections   number;   -- number of connections forward from object',
'    l_num_unfinished_subflows   number;',
'    l_forward_routes            apex_t_varchar2 := apex_t_varchar2();',
'    l_step_key                  flow_subflows.sbfl_step_key%type;',
'    l_is_actual_gateway         boolean;  -- set if the object is really a gateway (vs. an iteration acting as a gateway)',
'/*    l_new_subflows              t_new_sbfls := t_new_sbfls();',
'    l_new_subflow               flow_types_pkg.t_subflow_context; */ -- think these not used',
'  begin',
'    apex_debug.enter ',
'    ( ''process_para_incl_Gateway''',
'    , ''p_step_info.target_objt_tag''       , p_step_info.target_objt_tag',
'    , ''p_step_info.target_objt_ref''       , p_step_info.target_objt_ref',
'    , ''p_step_info.target_objt_iteration'' , nvl( p_step_info.target_objt_iteration, ''Null'')',
'    );',
'    if p_step_info.target_objt_treat_as_tag is null and p_sbfl_info.sbfl_loop_counter is null then ',
'      -- for actual gateway get number of forward and backward connections',
'      flow_engine_util.get_number_of_connections',
'      ( pi_dgrm_id => p_step_info.dgrm_id',
'      , pi_target_objt_id => p_step_info.target_objt_id',
'      , pi_conn_type => flow_constants_pkg.gc_bpmn_sequence_flow',
'      , po_num_back_connections => l_num_back_connections',
'      , po_num_forward_connections => l_num_forward_connections',
'      );',
'      l_is_actual_gateway := true;',
'    elsif p_step_info.target_objt_treat_as_tag = flow_constants_pkg.gc_bpmn_gateway_parallel ',
'    and p_sbfl_info.sbfl_loop_counter is null then',
'      l_is_actual_gateway := false;',
'      l_num_back_connections    := 1;',
'      l_num_forward_connections := 99;',
'    elsif p_step_info.target_objt_treat_as_tag = flow_constants_pkg.gc_bpmn_gateway_parallel ',
'    and p_sbfl_info.sbfl_loop_counter is not null then',
'      l_is_actual_gateway := false;',
'      l_num_back_connections    := 99;',
'      l_num_forward_connections := 1;',
'    end if;',
'',
'    l_gateway_forward_status := ''proceed'';',
'    l_sbfl_id  := p_sbfl_info.sbfl_id;',
'',
'    if l_num_back_connections > 1  then',
'      apex_debug.info',
'      ( p_message => ''%0 Parallel Merging %1''',
'      , p0        => p_step_info.target_objt_tag',
'      , p1        => p_step_info.target_objt_ref',
'      );  ',
'      if p_sbfl_info.sbfl_iteration_type = flow_constants_pkg.gc_iteration_parallel ',
'         and p_sbfl_info.sbfl_loop_counter is not null ',
'      then',
'        -- we have merging gateway.  do the merge. returns ''wait'' if flow is waiting at gateway, ''proceed'' if merged',
'        l_gateway_forward_status := flow_iteration.parallel_merge ( p_sbfl_info  => p_sbfl_info',
'                                                                    , p_step_info  => p_step_info',
'                                                                    );',
'      else      ',
'        -- we have merging gateway.  do the merge. returns ''wait'' if flow is waiting at gateway, ''proceed'' if merged',
'        l_gateway_forward_status := gateway_merge ( p_sbfl_info  => p_sbfl_info',
'                                                  , p_step_info  => p_step_info',
'                                                  );',
'      end if;                                        ',
'      -- switch to parent subflow ',
'      l_sbfl_id := p_sbfl_info.sbfl_sbfl_id;',
'    end if;',
'    ',
'    -- now do forward path, if you have token to ''proceed''',
'    if l_gateway_forward_status = ''proceed'' then ',
'      if l_num_forward_connections > 1 then',
'        -- we have splitting gateway going forward',
'        apex_debug.info ',
'        ( p_message => ''%0 Parallel Splitting %1 - %2 forward paths''',
'        , p0 => p_step_info.target_objt_tag',
'        , p1 => p_step_info.target_objt_ref',
'        , p2 => l_num_forward_connections',
'        );       ',
'        if l_is_actual_gateway then',
'          -- process any before-split expression set',
'          flow_expressions.process_expressions',
'          ( pi_objt_id     => p_step_info.target_objt_id',
'          , pi_set         => flow_constants_pkg.gc_expr_set_before_split',
'          , pi_prcs_id     => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id     => l_sbfl_id',
'          , pi_var_scope   => p_sbfl_info.sbfl_scope',
'          , pi_expr_scope  => p_sbfl_info.sbfl_scope',
'          );',
'        end if;      ',
'        -- test for any errors so far - if so, skip finding a route',
'        if not flow_globals.get_step_error then ',
'          apex_debug.info ( p_message => ''process_para_incl_Gateway: step has no errors after evaluating expressions'');',
'',
'          if l_is_actual_gateway then',
'            case p_step_info.target_objt_tag',
'            when flow_constants_pkg.gc_bpmn_gateway_inclusive then ',
'              -- actual inclusive gateway',
'              l_forward_routes := get_gateway_route',
'              ( pi_prcs_id       => p_sbfl_info.sbfl_prcs_id',
'              , pi_sbfl_id       => l_sbfl_id --l_sbfl_id?',
'              , pi_objt_bpmn_id   => p_step_info.target_objt_ref',
'              , pi_objt_tag       => p_step_info.target_objt_tag',
'              , pi_scope          => p_sbfl_info.sbfl_scope',
'              );',
'              apex_debug.info',
'              ( p_message => ''Forward routes for inclusiveGateway %0 : %1''',
'              , p0 => p_step_info.target_objt_ref',
'              , p1 => apex_string.join(l_forward_routes,'':'')',
'              );',
'              flow_logging.log_instance_event',
'              ( p_process_id  => p_sbfl_info.sbfl_prcs_id',
'              , p_objt_bpmn_id  => p_step_info.target_objt_ref',
'              , p_event  => ''Gateway Processed''',
'              , p_comment  => ''Chosen Paths : ''||apex_string.join(l_forward_routes,'':'')',
'              );',
'            when flow_constants_pkg.gc_bpmn_gateway_parallel then ',
'              -- actual parallel gateway',
'              l_forward_routes.extend;',
'              l_forward_routes(l_forward_routes.first) := ''parallel'';  -- just needs to be some not null string',
'            end case;',
'          end if; ',
'          -- test for any errors again - if so, skip doing the split',
'          if not flow_globals.get_step_error then ',
'            apex_debug.info ( p_message => ''process_para_incl_Gateway: step has no errors after evaluating routes'');',
'            if l_is_actual_gateway then',
'              gateway_split',
'              ( p_subflow_id => l_sbfl_id',
'              , p_sbfl_info  => p_sbfl_info',
'              , p_step_info  => p_step_info',
'              , p_gateway_routes => l_forward_routes',
'              );',
'            else',
'              -- is a parallel iteration split...',
'              ---- Add Edition IFDEF code here... If Enterprise compile this',
'              flow_iteration.parallel_split',
'              ( p_subflow_id => l_sbfl_id',
'              , p_sbfl_info  => p_sbfl_info',
'              , p_step_info  => p_step_info',
'              );   ',
'              ---- Add Edition IFDEF code here... else include this stubb',
'              -- raise feature_not_in_this_edition error',
'              --',
'              --',
'              -- End of Edition IFDEF code.       ',
'            end if;',
'          else',
'            -- has step errors from evaluating route',
'            flow_errors.set_error_status',
'            ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'            , pi_sbfl_id => l_sbfl_id',
'            );',
'          end if;',
'        else',
'          -- has step errors from expressions',
'          flow_errors.set_error_status',
'          ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'          , pi_sbfl_id => l_sbfl_id',
'          );',
'        end if;',
'      elsif l_num_forward_connections = 1 then',
'        -- only single path going forward',
'        update  flow_subflows sbfl',
'            set sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'              , sbfl.sbfl_current = p_step_info.target_objt_ref',
'              , sbfl.sbfl_status = flow_constants_pkg.gc_sbfl_status_running',
'              , sbfl.sbfl_last_update = systimestamp ',
'          where sbfl.sbfl_id = l_sbfl_id',
'            and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'        ;',
'        -- get step key from parent ',
'        select sbfl.sbfl_step_key',
'          into l_step_key',
'          from flow_subflows sbfl',
'         where sbfl.sbfl_id = l_sbfl_id; ',
'',
'        -- step into first step on the new path',
'        flow_engine.flow_complete_step   ',
'        ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id => l_sbfl_id',
'        , p_step_key   => l_step_key',
'        , p_forward_route => null',
'        );',
'      end if;  -- single path',
'    end if;  -- forward token',
'  end process_para_incl_Gateway;',
'',
'  procedure process_exclusiveGateway',
'    ( p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is ',
'    l_num_forward_connections   number;   -- number of connections forward from object',
'    l_num_back_connections      number;   -- number of connections back from object',
'    l_forward_routes            apex_t_varchar2 := apex_t_varchar2();',
'    l_forward_route             flow_connections.conn_bpmn_id%type;',
'  begin',
'    -- handles opening and closing and closing and reopening',
'    apex_debug.enter ',
'    ( ''process_exclusiveGateway''',
'    , ''p_step_info.target_objt_tag'' , p_step_info.target_objt_tag',
'    );',
'    flow_engine_util.get_number_of_connections',
'    ( pi_dgrm_id => p_step_info.dgrm_id',
'    , pi_target_objt_id => p_step_info.target_objt_id',
'    , pi_conn_type => flow_constants_pkg.gc_bpmn_sequence_flow',
'    , po_num_back_connections => l_num_back_connections',
'    , po_num_forward_connections => l_num_forward_connections',
'    );',
'',
'    if l_num_forward_connections > 1 then',
'      -- opening gateway ',
'      -- process any before-split expression set before gateway chooses route',
'      flow_expressions.process_expressions',
'      ( pi_objt_id     => p_step_info.target_objt_id',
'      , pi_set         => flow_constants_pkg.gc_expr_set_before_split',
'      , pi_prcs_id     => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_info.sbfl_id',
'      , pi_var_scope   => p_sbfl_info.sbfl_scope',
'      , pi_expr_scope  => p_sbfl_info.sbfl_scope',
'      );',
'      -- test for any errors so far - if so, skip finding a route',
'      if not flow_globals.get_step_error then ',
'        -- get route choice',
'        l_forward_routes := get_gateway_route',
'        ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'        , pi_objt_bpmn_id   => p_step_info.target_objt_ref',
'        , pi_objt_tag       => p_step_info.target_objt_tag',
'        , pi_scope          => p_sbfl_info.sbfl_scope',
'        );',
'        if l_forward_routes.count > 0 then',
'          l_forward_route := l_forward_routes(l_forward_routes.first);',
'        end if;',
'      else',
'        -- has step errors from expressions',
'        flow_errors.set_error_status',
'        ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => p_sbfl_info.sbfl_id',
'        );',
'      end if;',
'    else ',
'      -- closing gateway ',
'      -- process any after-merge expression set',
'      flow_expressions.process_expressions',
'      ( pi_objt_id     => p_step_info.target_objt_id',
'      , pi_set         => flow_constants_pkg.gc_expr_set_after_merge',
'      , pi_prcs_id     => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_info.sbfl_id',
'      , pi_var_scope   => p_sbfl_info.sbfl_scope',
'      , pi_expr_scope  => p_sbfl_info.sbfl_scope',
'      );      ',
'      -- keep going',
'      l_forward_route := null;',
'    end if;  ',
'',
'    if not flow_globals.get_step_error then ',
'      -- all good so step forward',
'      update flow_subflows sbfl',
'         set sbfl.sbfl_current        = p_step_info.target_objt_ref',
'           , sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'           , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'           , sbfl.sbfl_last_update    = systimestamp',
'           , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'       where sbfl.sbfl_id = p_sbfl_info.sbfl_id',
'         and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'      ;  ',
'      flow_engine.flow_complete_step   ',
'      ( p_process_id    => p_sbfl_info.sbfl_prcs_id',
'      , p_subflow_id    => p_sbfl_info.sbfl_id',
'      , p_step_key      => p_sbfl_info.sbfl_step_key',
'      , p_forward_route => l_forward_route',
'      );',
'    else        ',
'      -- has step errors from evaluating route',
'      flow_errors.set_error_status',
'      ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id => p_sbfl_info.sbfl_id',
'      );',
'    end if;',
'',
'  end process_exclusiveGateway; ',
'',
'  procedure process_eventBasedGateway',
'    ( p_sbfl_info  in flow_subflows%rowtype',
'    , p_step_info  in flow_types_pkg.flow_step_info',
'    )',
'  is ',
'    l_new_subflow       flow_types_pkg.t_subflow_context;',
'    l_new_subflows      t_new_sbfls := t_new_sbfls();',
'  begin',
'    -- eventGateway can have multiple inputs and outputs, but there is no waiting, etc.',
'    -- incoming subflow continues on the first output path.',
'    -- additional output paths create new subflows',
'    apex_debug.enter',
'    (',
'      p_routine_name => ''process_EventBasedGateway''',
'    , p_name01       => ''p_step_info.target_objt_ref''',
'    , p_value01      => p_step_info.target_objt_ref',
'    );',
'    -- process any before-split expression set',
'    flow_expressions.process_expressions',
'    ( pi_objt_id     => p_step_info.target_objt_id',
'    , pi_set         => flow_constants_pkg.gc_expr_set_before_split',
'    , pi_prcs_id     => p_sbfl_info.sbfl_prcs_id',
'    , pi_sbfl_id     => p_sbfl_info.sbfl_id',
'    , pi_var_scope   => p_sbfl_info.sbfl_scope',
'    , pi_expr_scope  => p_sbfl_info.sbfl_scope',
'    );',
'',
'    -- log gateway as completed here so only logged once',
'    flow_logging.log_step_completion   ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_completed_object => p_step_info.target_objt_ref ',
'    );',
'    -- get all forward parallel paths and create subflows for them',
'    -- these are paths forward of p_step_info.target_objt_ref as we are doing double step',
'    for new_path in ( select conn.conn_bpmn_id route',
'                           , objt.objt_bpmn_id target',
'                        from flow_connections conn',
'                        join flow_objects objt',
'                          on objt.objt_id = conn.conn_tgt_objt_id',
'                         and conn.conn_dgrm_id = objt.objt_dgrm_id',
'                       where conn.conn_dgrm_id = p_step_info.dgrm_id',
'                         and conn.conn_tag_name = flow_constants_pkg.gc_bpmn_sequence_flow',
'                         and conn.conn_src_objt_id = p_step_info.target_objt_id',
'                    )',
'    loop',
'      -- create new subflows for forward event paths starting here',
'      -- don''t start them yet...',
'      apex_debug.info',
'      ( p_message => ''starting parallel flow from Event Based Gateway for %0''',
'      , p0        => p_step_info.target_objt_tag',
'      );',
'',
'     l_new_subflow :=  flow_engine_util.subflow_start',
'        ( ',
'          p_process_id             => p_sbfl_info.sbfl_prcs_id        ',
'        , p_parent_subflow         => p_sbfl_info.sbfl_id       ',
'        , p_starting_object        => p_step_info.target_objt_ref         ',
'        , p_current_object         => p_step_info.target_objt_ref          ',
'        , p_route                  => new_path.route         ',
'        , p_last_completed         => p_step_info.target_objt_ref ',
'        , p_status                 => flow_constants_pkg.gc_sbfl_status_created   ',
'        , p_parent_sbfl_proc_level => p_sbfl_info.sbfl_process_level',
'        , p_new_proc_level         => false    ',
'        , p_dgrm_id                => p_sbfl_info.sbfl_dgrm_id',
'        , p_follows_ebg            => true',
'        )',
'      ;',
'      l_new_subflow.route   := new_path.route;',
'      l_new_subflows.extend;',
'      l_new_subflows (l_new_subflows.last) := l_new_subflow;',
'    end loop;      ',
'    -- mark parent flow as split',
'    update flow_subflows sbfl',
'       set sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'         , sbfl.sbfl_current        = p_step_info.target_objt_ref',
'         , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_split  ',
'         , sbfl.sbfl_last_update    = systimestamp',
'         , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                               , sys_context(''userenv'',''os_user'')',
'                                               , sys_context(''userenv'',''session_user'')',
'                                               )  ',
'     where sbfl.sbfl_id = p_sbfl_info.sbfl_id',
'       and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'    ;',
'    -- commit the transaction',
'    commit;',
'    apex_debug.info ( p_message => ''New Subflow Creation Commited'');',
'    ',
'    for new_subflow in 1.. l_new_subflows.count',
'    loop',
'      -- reset step_had_error flag',
'      flow_globals.set_step_error ( p_has_error => false);',
'      -- check subflow still exists and lock it(in case earlier loop terminated everything in level)',
'      if flow_engine_util.lock_subflow',
'        ( p_subflow_id => l_new_subflows(new_subflow).sbfl_id',
'        )',
'      then    ',
'        -- step into first step on the new path',
'        flow_engine.flow_complete_step   ',
'        (',
'          p_process_id        => p_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id        => l_new_subflows(new_subflow).sbfl_id',
'        , p_step_key          => l_new_subflows(new_subflow).step_key',
'        , p_forward_route     => l_new_subflows(new_subflow).route',
'        , p_log_as_completed  => false',
'        );',
'      end if;',
'    end loop;',
'    -- reset step_had_error flag',
'    flow_globals.set_step_error ( p_has_error => false);',
'  end process_eventBasedGateway;',
'',
'end flow_gateways;',
'/',
'',
'create or replace package body flow_boundary_events',
'is ',
'',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'  procedure set_boundary_events',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_sbfl_info     in flow_subflows%rowtype',
'  )',
'  is ',
'    l_new_non_int_event_sbfl      flow_types_pkg.t_subflow_context;',
'    l_new_non_int_event_sbfl_info flow_subflows%rowtype;',
'    l_subscription_detail         flow_message_flow.t_subscription_details;',
'    l_status                      flow_subflows.sbfl_status%type;',
'    l_parent_tag                  varchar2(50);',
'    l_child_tag                   varchar2(50);',
'    l_msg_sub                     flow_message_subscriptions.msub_id%type;',
'  begin',
'    apex_debug.enter ',
'    ( ''set_boundary_events''',
'    , ''subflow'', p_subflow_id',
'    );',
'    begin',
'      for boundary_events in ',
'        (',
'        select objt.objt_bpmn_id as objt_bpmn_id ',
'             , objt.objt_sub_tag_name as objt_sub_tag_name',
'             , objt.objt_interrupting as objt_interrupting',
'             , sbfl.sbfl_process_level as sbfl_process_level',
'             , sbfl.sbfl_dgrm_id as sbfl_dgrm_id',
'             , sbfl.sbfl_current as parent_current_object',
'             , objt.objt_id as objt_id',
'             , sbfl.sbfl_scope as sbfl_scope',
'          from flow_objects objt',
'          join flow_subflows sbfl ',
'            on sbfl.sbfl_current = objt.objt_attached_to',
'           and sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'         where objt.objt_tag_name = flow_constants_pkg.gc_bpmn_boundary_event  ',
'           and objt.objt_sub_tag_name in ( flow_constants_pkg.gc_bpmn_timer_event_definition',
'                                         , flow_constants_pkg.gc_bpmn_message_event_definition )',
'           and sbfl.sbfl_id = p_subflow_id',
'           and sbfl.sbfl_prcs_id = p_process_id',
'        )',
'      loop',
'        apex_debug.message ',
'        ( p_message => ''Boundary Event found.  ID: %0 SubTag:  %1  Interupting: %2''',
'        , p0 => boundary_events.objt_bpmn_id',
'        , p1 => boundary_events.objt_sub_tag_name',
'        , p2 => boundary_events.objt_interrupting',
'        );',
'        case boundary_events.objt_interrupting',
'        when 1 then',
'          -- process any before-event variable expressions on the starting object',
'          flow_expressions.process_expressions',
'          ( pi_objt_id     => boundary_events.objt_id ',
'          , pi_set         => flow_constants_pkg.gc_expr_set_before_event',
'          , pi_prcs_id     => p_process_id',
'          , pi_sbfl_id     => p_subflow_id',
'          , pi_var_scope   => boundary_events.sbfl_scope',
'          , pi_expr_scope  => boundary_events.sbfl_scope',
'          );',
'          -- test for any step errors',
'          if not flow_globals.get_step_error then ',
'            case boundary_events.objt_sub_tag_name',
'            when flow_constants_pkg.gc_bpmn_timer_event_definition then',
'              -- interupting timer.  set timer on current object in current subflow',
'              flow_timers_pkg.start_timer',
'              ( pi_prcs_id      => p_process_id',
'              , pi_sbfl_id      => p_subflow_id',
'              , pi_callback     => flow_constants_pkg.gc_bpmn_boundary_event',
'              , pi_callback_par => ''interrupting''',
'              );',
'              l_parent_tag := '':SIT'';  -- (Self, Interrupting, Timer)',
'            when flow_constants_pkg.gc_bpmn_message_event_definition then',
'              -- interupting message.  set message subscription on current object in current subflow',
'              l_subscription_detail := flow_message_util.get_msg_subscription_details ( p_msg_object_bpmn_id  => boundary_events.objt_bpmn_id',
'                                                                                      , p_dgrm_id  => boundary_events.sbfl_dgrm_id',
'                                                                                      , p_sbfl_info  => p_sbfl_info',
'                                                                                      );',
'              l_subscription_detail.callback     := flow_constants_pkg.gc_bpmn_boundary_event;',
'              l_subscription_detail.callback_par := boundary_events.objt_bpmn_id;',
'              l_msg_sub := flow_message_flow.subscribe ( p_subscription_details  => l_subscription_detail);',
'  ',
'              l_parent_tag := '':SIM'';  -- (Self, Interrupting, Message)',
'            end case;',
'          end if;',
'        when 0 then',
'            case boundary_events.objt_sub_tag_name',
'            when flow_constants_pkg.gc_bpmn_timer_event_definition   then ',
'              l_status      := flow_constants_pkg.gc_sbfl_status_waiting_timer;',
'              l_child_tag   := '':SNT'';  -- (Self, Non-Interrupting, Timer)',
'              l_parent_tag  := '':CNT'';  -- (Child, Non-Interrupting, Timer)',
'            when flow_constants_pkg.gc_bpmn_message_event_definition then ',
'              l_status := flow_constants_pkg.gc_sbfl_status_waiting_message;',
'              l_child_tag   := '':SNM'';  -- (Self, Non-Interrupting, Message)  ',
'              l_parent_tag  := '':CNM'';  -- (Child, Non-U=Interrupting, Message)            ',
'            end case;',
'',
'          -- non-interupting event.  create child subflow starting at boundary event and start timer/subscribe message / etc',
'          l_new_non_int_event_sbfl := flow_engine_util.subflow_start',
'          ( p_process_id => p_process_id',
'          , p_parent_subflow => p_subflow_id',
'          , p_starting_object => boundary_events.objt_bpmn_id',
'          , p_current_object => boundary_events.objt_bpmn_id',
'          , p_route => ''from boundary event - run 1''',
'          , p_last_completed => boundary_events.parent_current_object ',
'          , p_status => l_status',
'          , p_parent_sbfl_proc_level => boundary_events.sbfl_process_level',
'          , p_new_proc_level => false',
'          , p_dgrm_id => boundary_events.sbfl_dgrm_id',
'          );',
' ',
'          -- process any before-event variable expressions on the starting object',
'          flow_expressions.process_expressions',
'          ( pi_objt_id     => boundary_events.objt_id',
'          , pi_set         => flow_constants_pkg.gc_expr_set_before_event',
'          , pi_prcs_id     => p_process_id',
'          , pi_sbfl_id     => l_new_non_int_event_sbfl.sbfl_id',
'          , pi_var_scope   => boundary_events.sbfl_scope',
'          , pi_expr_scope  => boundary_events.sbfl_scope',
'          );',
'          -- test for any step errors',
'          if not flow_globals.get_step_error then ',
'            case boundary_events.objt_sub_tag_name',
'            when flow_constants_pkg.gc_bpmn_timer_event_definition then',
'              -- non-interrupting timer - start timer on event subflow',
'              flow_timers_pkg.start_timer',
'              ( pi_prcs_id      => p_process_id',
'              , pi_sbfl_id      => l_new_non_int_event_sbfl.sbfl_id',
'              , pi_step_key     => l_new_non_int_event_sbfl.step_key',
'              , pi_callback     => flow_constants_pkg.gc_bpmn_boundary_event',
'              , pi_callback_par => ''non-interrupting''                -----  RA NOTE  move to constants_pkg',
'              );',
'            when flow_constants_pkg.gc_bpmn_message_event_definition then',
'              -- non-interupting message.  set message subscription on event subflow',
'              select *',
'                into l_new_non_int_event_sbfl_info',
'                from flow_subflows',
'               where sbfl_id = l_new_non_int_event_sbfl.sbfl_id;',
'',
'              l_subscription_detail := flow_message_util.get_msg_subscription_details ( p_msg_object_bpmn_id  => boundary_events.objt_bpmn_id',
'                                                                                      , p_dgrm_id             => boundary_events.sbfl_dgrm_id',
'                                                                                      , p_sbfl_info           => l_new_non_int_event_sbfl_info',
'                                                                                      );  ',
'              l_subscription_detail.callback      := flow_constants_pkg.gc_bpmn_boundary_event;',
'              l_subscription_detail.callback_par  := boundary_events.objt_bpmn_id;',
'              l_msg_sub := flow_message_flow.subscribe(p_subscription_details  => l_subscription_detail);',
'            end case;',
'',
'            -- test again for any step errors',
'            if not flow_globals.get_step_error then ',
'              -- set timer flag on child (Self, Noninterrupting, Timer)',
'              update flow_subflows sbfl',
'                  set sbfl.sbfl_has_events      = sbfl.sbfl_has_events||l_child_tag',
'                    , sbfl.sbfl_last_update     = systimestamp',
'                    , sbfl.sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                           , sys_context(''userenv'',''os_user'')',
'                                                           , sys_context(''userenv'',''session_user'')',
'                                                           )  ',
'                where sbfl.sbfl_id = l_new_non_int_event_sbfl.sbfl_id',
'                  and sbfl.sbfl_prcs_id = p_process_id',
'              ;',
'            end if;',
'          end if;',
'        end case;',
'        --- set timer flag on parent (it can get more than 1)',
'        update flow_subflows sbfl',
'          set sbfl.sbfl_has_events      = sbfl.sbfl_has_events||l_parent_tag',
'            , sbfl.sbfl_last_update     = systimestamp',
'            , sbfl.sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                   , sys_context(''userenv'',''os_user'')',
'                                                   , sys_context(''userenv'',''session_user'')',
'                                                   )  ',
'        where sbfl.sbfl_id      = p_subflow_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'        ;',
'      end loop;',
'    exception',
'      when no_data_found then',
'        return;',
'    end;',
'  end set_boundary_events;',
'',
'  procedure unset_boundary_events',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  )',
'  is ',
'    l_non_int_timer_sbfl  flow_subflows.sbfl_id%type;',
'    l_return_code         number;',
'  begin',
'    apex_debug.enter ',
'    ( ''unset_boundary_events''',
'    , ''subflow'', p_subflow_id',
'    );',
'    begin',
'      for boundary_events in ',
'        (',
'        select objt.objt_bpmn_id as objt_bpmn_id ',
'             , objt.objt_interrupt'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ing as objt_interrupting',
'          from flow_objects objt',
'          join flow_subflows sbfl ',
'            on sbfl.sbfl_current = objt.objt_attached_to',
'           and sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'         where objt.objt_tag_name = flow_constants_pkg.gc_bpmn_boundary_event  ',
'           and objt.objt_sub_tag_name in ( flow_constants_pkg.gc_bpmn_timer_event_definition',
'                                         , flow_constants_pkg.gc_bpmn_message_event_definition )',
'           and sbfl.sbfl_id = p_subflow_id',
'           and sbfl.sbfl_prcs_id = p_process_id',
'        )',
'      loop',
'        case boundary_events.objt_interrupting',
'        when 1 then',
'          -- interupting timer.  terminate timer on current object in current subflow',
'          flow_timers_pkg.terminate_timer',
'          ( pi_prcs_id => p_process_id',
'          , pi_sbfl_id => p_subflow_id',
'          , po_return_code => l_return_code',
'          );',
'        when 0 then',
'          -- non-interupting timer.  find child subflow starting at boundary event and delete if not yet fired',
'          -- timer will delete cascade',
'          delete from flow_subflows',
'          where sbfl_starting_object = boundary_events.objt_bpmn_id',
'          and sbfl_sbfl_id = p_subflow_id',
'          and sbfl_prcs_id = p_process_id',
'          and sbfl_status = flow_constants_pkg.gc_sbfl_status_waiting_timer',
'          ;',
'        end case;',
'      end loop;',
'      -- remove the event flags from the subflow',
'      update flow_subflows sbfl',
'         set sbfl_has_events      = ''''',
'           , sbfl_last_update     = systimestamp',
'           , sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                             , sys_context(''userenv'',''os_user'')',
'                                             , sys_context(''userenv'',''session_user'')',
'                                             )  ',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'      ;',
'    exception',
'      when no_data_found then',
'        return;',
'    end;',
'  end unset_boundary_events;',
'',
'  procedure lock_child_boundary_timers',
'  ( p_process_id          in flow_processes.prcs_id%type',
'  , p_subflow_id          in flow_subflows.sbfl_id%type',
'  , p_parent_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  ) ',
'  is ',
'    cursor c is ',
'        select child_sbfl.sbfl_id, child_timr.timr_id',
'          from flow_subflows child_sbfl',
'          join flow_timers child_timr',
'            on child_timr.timr_prcs_id = child_sbfl.sbfl_prcs_id',
'           and child_timr.timr_sbfl_id = child_sbfl.sbfl_id',
'         where child_sbfl.sbfl_starting_object = p_parent_objt_bpmn_id ',
'           and child_sbfl.sbfl_current = p_parent_objt_bpmn_id ',
'           and child_sbfl.sbfl_prcs_id = p_process_id',
'           and child_sbfl.sbfl_status = flow_constants_pkg.gc_sbfl_status_waiting_timer',
'         order by child_sbfl.sbfl_id',
'        for update of child_sbfl.sbfl_id, child_timr.timr_id wait 3;',
'  begin ',
'    open c;',
'    close c;',
'  exception ',
'    when lock_timeout then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_process_id',
'      , pi_sbfl_id     => p_subflow_id',
'      , pi_message_key => ''boundary-event-child-lock-to''',
'      , p0             => p_subflow_id',
'      );',
'      -- $F4AMESSAGE ''boundary-event-child-lock-to'' || ''Child Boundary Subflows or Timers of %0 currently locked by another user.  Retry your transaction later.''  ',
'  end lock_child_boundary_timers; ',
'',
'  procedure handle_interrupting_boundary_event',
'    ( p_process_id      in flow_processes.prcs_id%type',
'    , p_subflow_id      in flow_subflows.sbfl_id%type',
'    , p_event_type      in flow_objects.objt_sub_tag_name%type',
'    , p_boundary_object in flow_objects.objt_bpmn_id%type default null',
'    ) ',
'      -- used for Interrupting Timer   Boundary events, called by flow_engine.timer_callback',
'      -- used for Interrupting Message Boundary events, called by flow_message_flow.receive_message',
'  is',
'    l_boundary_objt_bpmn_id  flow_objects.objt_bpmn_id%type;',
'    l_parent_objt_tag        flow_objects.objt_tag_name%type;',
'    l_parent_objt_bpmn_id    flow_objects.objt_bpmn_id%type;',
'    l_child_process_level    flow_subflows.sbfl_process_level%type; ',
'    l_step_key               flow_subflows.sbfl_step_key%type;',
'    l_timestamp              flow_subflows.sbfl_became_current%type;',
'    l_scope                  flow_subflows.sbfl_scope%type;',
'  begin',
'    apex_debug.enter ',
'    ( ''handle_interrupting_boundary_event''',
'    , ''subflow'', p_subflow_id',
'    , ''event type'', p_event_type',
'    , ''boundary object'',p_boundary_object',
'    );',
'    -- we are migrating boundary event callback structure over next few releases but will handle old and new way',
'    -- result will be to allow multiple boundary events of the same type on an object',
'    if p_boundary_object is null or p_boundary_object in (''interrupting'', ''non-interrupting'') then ',
'      -- old style - should be only one event of type on parent',
'      select boundary_objt.objt_bpmn_id',
'           , main_objt.objt_tag_name',
'           , main_objt.objt_bpmn_id',
'           , sbfl.sbfl_scope',
'        into l_boundary_objt_bpmn_id',
'           , l_parent_objt_tag',
'           , l_parent_objt_bpmn_id',
'           , l_scope',
'        from flow_subflows sbfl',
'        join flow_objects main_objt',
'          on main_objt.objt_bpmn_id = sbfl.sbfl_current',
'         and main_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'        join flow_objects boundary_objt',
'          on boundary_objt.objt_attached_to = main_objt.objt_bpmn_id',
'         and boundary_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'         and boundary_objt.objt_sub_tag_name = p_event_type',
'         and boundary_objt.objt_interrupting = 1',
'          ;',
'    else',
'      -- newstyle - event callback contained a bpmn id of the object to callback',
'      select boundary_objt.objt_bpmn_id',
'           , main_objt.objt_tag_name',
'           , main_objt.objt_bpmn_id',
'           , sbfl.sbfl_scope',
'        into l_boundary_objt_bpmn_id',
'           , l_parent_objt_tag',
'           , l_parent_objt_bpmn_id',
'           , l_scope',
'        from flow_subflows sbfl',
'        join flow_objects main_objt',
'          on main_objt.objt_bpmn_id = sbfl.sbfl_current',
'         and main_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'        join flow_objects boundary_objt',
'          on boundary_objt.objt_attached_to = main_objt.objt_bpmn_id',
'         and boundary_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'         and boundary_objt.objt_bpmn_id = p_boundary_object',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'         and boundary_objt.objt_sub_tag_name = p_event_type',
'         and boundary_objt.objt_interrupting = 1',
'          ;',
'    end if;',
'',
'    if l_parent_objt_tag in ( flow_constants_pkg.gc_bpmn_subprocess',
'                            , flow_constants_pkg.gc_bpmn_call_activity )',
'    then',
'       -- if the boundary event is on a subprocess or call activity (rather than a task type), terminate the subprocess level',
'       -- find the process level inside the subprocess and then stop all processing at that level and below',
'      select distinct sbfl.sbfl_process_level',
'        into l_child_process_level',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_sbfl_id = p_subflow_id',
'       ;',
'       if l_child_process_level is not null ',
'       then ',
'          flow_engine_util.terminate_level',
'          ( p_process_id    => p_process_id',
'          , p_process_level => l_child_process_level',
'          );',
'       end if;',
'    end if;',
'    -- clean up any other boundary events on the object',
'    flow_boundary_events.unset_boundary_events ',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    );',
'    -- clean up any subscriptions for message events on the object',
'    flow_message_util.cancel_subscription',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    );',
'    -- generate a step key & insert in the update...use later',
'    l_timestamp := systimestamp;',
'    l_step_key := flow_engine_util.step_key ( pi_sbfl_id   => p_subflow_id',
'                                            , pi_current => l_boundary_objt_bpmn_id',
'                                            , pi_became_current => l_timestamp ',
'                                            );',
'    -- switch processing onto boundaryEvent path and do next step',
'    update flow_subflows sbfl',
'       set sbfl.sbfl_current        = l_boundary_objt_bpmn_id',
'         , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'         , sbfl.sbfl_last_completed = l_parent_objt_bpmn_id',
'         , sbfl.sbfl_became_current = l_timestamp',
'         , sbfl.sbfl_step_key       = l_step_key',
'         , sbfl.sbfl_last_update    = l_timestamp ',
'         , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                               , sys_context(''userenv'',''os_user'')',
'                                               , sys_context(''userenv'',''session_user'')',
'                                               )  ',
'     where sbfl.sbfl_id = p_subflow_id ',
'       and sbfl.sbfl_prcs_id = p_process_id',
'    ;',
'    -- process on-event variable expressions for the boundary event',
'    flow_expressions.process_expressions',
'    ( pi_objt_bpmn_id => l_boundary_objt_bpmn_id  ',
'    , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'    , pi_prcs_id      => p_process_id',
'    , pi_sbfl_id      => p_subflow_id',
'    , pi_var_scope    => l_scope',
'    , pi_expr_scope   => l_scope',
'    );',
'    -- test for errors',
'    if flow_globals.get_step_error then ',
'      -- has step errors from expressions - set error status',
'      flow_errors.set_error_status',
'      ( pi_prcs_id => p_process_id',
'      , pi_sbfl_id => p_subflow_id',
'      );',
'    else',
'      -- If not, step off on new path...',
'      flow_engine.flow_complete_step ',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id ',
'      , p_step_key => l_step_key',
'      );',
'    end if;',
'',
'  end handle_interrupting_boundary_event;',
'',
'  procedure get_boundary_event',
'  ( pi_dgrm_id                  in  flow_diagrams.dgrm_id%type',
'  , pi_throw_objt_bpmn_id       in  flow_objects.objt_bpmn_id%type',
'  , pi_par_sbfl                 in  flow_subflows.sbfl_id%type',
'  , pi_sub_tag_name             in  flow_objects.objt_sub_tag_name%type ',
'  , po_boundary_objt            out flow_objects.objt_bpmn_id%type',
'  , po_is_interrupting          out boolean',
'  , po_par_sbfl_scope           out flow_subflows.sbfl_scope%type',
'  )',
'  is ',
'    l_process_id    flow_processes.prcs_id%type;',
'      l_interrupting  flow_objects.objt_interrupting%type;',
'  begin',
'    -- in later release if named errors and escalations are supported, change this to look for specific event',
'    select boundary_objt.objt_bpmn_id',
'         , boundary_objt.objt_interrupting',
'         , parent_sbfl.sbfl_prcs_id',
'         , parent_sbfl.sbfl_scope',
'      into po_boundary_objt',
'         , l_interrupting',
'         , l_process_id',
'         , po_par_sbfl_scope',
'      from flow_objects boundary_objt',
'      join flow_subflows parent_sbfl',
'        on parent_sbfl.sbfl_current = boundary_objt.objt_attached_to',
'       and parent_sbfl.sbfl_dgrm_id = boundary_objt.objt_dgrm_id',
'     where parent_sbfl.sbfl_id = pi_par_sbfl',
'       and boundary_objt.objt_sub_tag_name = pi_sub_tag_name',
'    ;',
'    if l_interrupting = 1 then',
'      po_is_interrupting := true;',
'    else',
'      po_is_interrupting := false;',
'    end if;',
'  exception',
'    when no_data_found then',
'        -- no boundary event found -- returned flow should continue from normal return',
'        if pi_sub_tag_name in (flow_constants_pkg.gc_bpmn_error_event_definition) then',
'           po_is_interrupting := true;',
'        else ',
'           po_is_interrupting := false;',
'        end if;',
'    when too_many_rows then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => l_process_id',
'        , pi_sbfl_id     => pi_par_sbfl',
'        , pi_message_key => ''boundary-event-too-many''',
'        , p0 => pi_sub_tag_name',
'        );',
'        -- $F4AMESSAGE ''boundary-event-too-many'' || ''More than one %0 boundaryEvent found on sub process.''  ',
'  end get_boundary_event;',
'',
'  procedure process_escalation',
'    ( pi_sbfl_info        in  flow_subflows%rowtype',
'    , pi_step_info        in  flow_types_pkg.flow_step_info',
'    , pi_par_sbfl         in  flow_subflows.sbfl_id%type',
'    , pi_source_type      in  flow_types_pkg.t_bpmn_id',
'    , po_step_key         out flow_subflows.sbfl_step_key%type',
'    , po_is_interrupting  out boolean',
'    )',
'  is ',
'    l_boundary_event        flow_objects.objt_bpmn_id%type;',
'    l_interrupting          flow_objects.objt_interrupting%type;',
'    l_new_sbfl              flow_types_pkg.t_subflow_context;',
'    l_parent_processs_level flow_subflows.sbfl_process_level%type;',
'    l_parent_sbfl_scope     flow_subflows.sbfl_scope%type;',
'    l_parent_dgrm_id        flow_diagrams.dgrm_id%type;',
'    l_parent_step_key       flow_subflows.sbfl_step_key%type;',
'    l_timestamp             flow_subflows.sbfl_became_current%type;',
'    l_step_key              flow_subflows.sbfl_step_key%type;',
'  begin ',
'    apex_debug.enter ',
'    ( ''process_escalation''',
'    , ''subflow'', pi_sbfl_info.sbfl_id',
'    );',
'    -- called to process an escallation from an Escalation ITE or an Escalation End Event',
'    -- both can be Interrupting or Non interrupting',
'    --',
'    -- set the throwing event to completed',
'/*    flow_logging.log_step_completion   ',
'    ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => pi_sbfl_info.sbfl_id',
'    , p_completed_object => pi_step_info.target_objt_ref',
'    );  */',
'    -- find matching boundary event of its type',
'    get_boundary_event',
'    ( pi_dgrm_id            => pi_step_info.dgrm_id',
'    , pi_throw_objt_bpmn_id => pi_step_info.target_objt_ref',
'    , pi_par_sbfl           => pi_par_sbfl',
'    , pi_sub_tag_name       => pi_step_info.target_objt_subtag',
'    , po_boundary_objt      => l_boundary_event',
'    , po_is_interrupting    => po_is_interrupting',
'    , po_par_sbfl_scope     => l_parent_sbfl_scope',
'    );',
'    if l_boundary_event is null then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => pi_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id     => pi_sbfl_info.sbfl_id',
'      , pi_message_key => ''boundary-event-no-catch-found''',
'      , p0 => pi_step_info.target_objt_subtag',
'      );',
'      -- $F4AMESSAGE ''boundary-event-no-catch-found'' || ''No boundaryEvent of type %0 found to catch event.''  ',
'    end if;',
'',
'    if po_is_interrupting then',
'      -- interrupting escalation event',
'      if pi_source_type = flow_constants_pkg.gc_bpmn_intermediate_throw_event then ',
'        -- set the throwing event to completed if an ITE',
'        flow_logging.log_step_completion   ',
'        ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id => pi_sbfl_info.sbfl_id',
'        , p_completed_object => pi_step_info.target_objt_ref',
'        );  ',
'      end if;',
'      -- first remove any non-interrupting timers that are on the parent event',
'      unset_boundary_events (pi_sbfl_info.sbfl_prcs_id, pi_par_sbfl);',
'      -- stop processing in process level and all lower (child) levels',
'      flow_engine_util.terminate_level',
'      ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'      , p_process_level => pi_sbfl_info.sbfl_process_level',
'      );        ',
'      -- generate a step key & insert in the update...use later',
'      l_timestamp := systimestamp;',
'      l_step_key := flow_engine_util.step_key ( pi_sbfl_id   => pi_par_sbfl --p_sbfl_info.sbfl_id',
'                                              , pi_current => l_boundary_event',
'                                              , pi_became_current => l_timestamp ',
'                                              );                       ',
'      -- set parent subflow to boundary event and do flow_complete_step',
'      update flow_subflows sbfl',
'          set sbfl.sbfl_current         = l_boundary_event',
'            , sbfl.sbfl_last_completed  = pi_step_info.target_objt_ref ',
'            , sbfl.sbfl_status          = flow_constants_pkg.gc_sbfl_status_running',
'            , sbfl.sbfl_became_current  = l_timestamp',
'            , sbfl.sbfl_step_key        = l_step_key',
'            , sbfl.sbfl_last_update     = l_timestamp',
'            , sbfl.sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                   , sys_context(''userenv'',''os_user'')',
'                                                   , sys_context(''userenv'',''session_user'')',
'                                                   )  ',
'        where sbfl.sbfl_id = pi_par_sbfl',
'          and sbfl.sbfl_prcs_id = pi_sbfl_info.sbfl_prcs_id',
'      ;',
'      -- process on-event expressions for boundary event',
'      flow_expressions.process_expressions',
'      ( pi_objt_bpmn_id => l_boundary_event  ',
'      , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'      , pi_prcs_id      => pi_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id      => pi_par_sbfl',
'      , pi_var_scope    => l_parent_sbfl_scope',
'      , pi_expr_scope   => l_parent_sbfl_scope',
'      );',
'',
'        flow_engine.flow_complete_step',
'        ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id => pi_par_sbfl',
'        , p_step_key   => l_step_key',
'        ); ',
'',
'    else  --( = not po_is_interrupting)',
'      -- non interrupting.  ',
'      select par_sbfl.sbfl_process_level',
'           , par_sbfl.sbfl_dgrm_id',
'        into l_parent_processs_level ',
'           , l_parent_dgrm_id',
'        from flow_subflows par_sbfl',
'        where par_sbfl.sbfl_id = pi_par_sbfl',
'          and par_sbfl.sbfl_prcs_id = pi_sbfl_info.sbfl_prcs_id',
'          ;',
'',
'      -- fork first, then procced on main, then step off on child',
'',
'      -- start new subflow starting at the boundary event and step to next task',
'      l_new_sbfl := flow_engine_util.subflow_start',
'      ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'      , p_parent_subflow => pi_par_sbfl',
'      , p_starting_object => l_boundary_event',
'      , p_current_object => l_boundary_event',
'      , p_route => ''from ''||l_boundary_event',
'      , p_last_completed => pi_step_info.target_objt_ref -- even thou it hasnt yet completed ',
'      , p_status => flow_constants_pkg.gc_sbfl_status_running',
'      , p_parent_sbfl_proc_level => l_parent_processs_level',
'      , p_new_proc_level => false',
'      , p_dgrm_id => l_parent_dgrm_id',
'      );',
'      ',
'      apex_debug.message',
'      (',
'        p_message => ''process_boundary_event.  target_objt_tag :''||pi_step_info.target_objt_subtag',
'      , p_level => 3',
'      );',
'      -- process on-event expressions for boundary event',
'      flow_expressions.process_expressions',
'      ( pi_objt_bpmn_id => l_boundary_event  ',
'      , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'      , pi_prcs_id      => pi_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id      => l_new_sbfl.sbfl_id',
'      , pi_var_scope    => l_parent_sbfl_scope',
'      , pi_expr_scope   => l_parent_sbfl_scope',
'      );     ',
'',
'      if not flow_globals.get_step_error then',
'',
'',
'        if pi_source_type = flow_constants_pkg.gc_bpmn_intermediate_throw_event  ',
'        then ',
'            -- do next_step on triggering subflow if an ITE ',
'            flow_engine.flow_complete_step ',
'            ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'            , p_subflow_id => pi_sbfl_info.sbfl_id ',
'            , p_step_key   => pi_sbfl_info.sbfl_step_key',
'            );',
'        elsif pi_source_type = flow_constants_pkg.gc_bpmn_end_event  ',
'        then',
'            -- normal end event',
'            flow_engine_util.subflow_complete',
'            ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'            , p_subflow_id => pi_sbfl_info.sbfl_id',
'            );',
'        end if;',
'',
'        -- step forward from boundary event',
'        flow_engine.flow_complete_step ',
'        ( p_process_id => pi_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id => l_new_sbfl.sbfl_id',
'        , p_step_key   => l_new_sbfl.step_key',
'        );',
'      else',
'        -- set error status on instance and subflow',
'        flow_errors.set_error_status',
'        ( pi_prcs_id => pi_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => pi_sbfl_info.sbfl_id',
'        );',
'      end if;',
'    end if;',
'  end process_escalation;',
'',
'',
'end flow_boundary_events;',
'/',
'',
'create or replace package body flow_tasks as ',
'/* ',
'-- Flows for APEX - flow_tasks.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created 13-May-2021  Richard Allen (Flowquest Consuting, for MT AG) ',
'-- Edited  13-Apr-2022  Richard Allen (Oracle)',
'-- Edited  23-May-2022  Moritz Klein (MT AG)',
'--',
'*/',
'  function get_task_type',
'  (',
'    pi_objt_id in flow_objects.objt_id%type',
'  )',
'    return flow_types_pkg.t_bpmn_attribute_vc2',
'  as',
'    l_return flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'',
'    select objt.objt_attributes."taskType"',
'      into l_return',
'      from flow_objects objt',
'     where objt_id = pi_objt_id',
'    ;',
'    if l_return is null then',
'      apex_debug.warn',
'      (',
'        p_message => ''No task type found for object %0''',
'      , p0        =>  pi_objt_id',
'      );',
'    else',
'      apex_debug.message',
'      (',
'        p_message => ''Task type %0''',
'      , p0        =>  l_return',
'      );    ',
'    end if;',
'',
'    return l_return;',
'  end get_task_type;',
'',
'  procedure handle_script_error -- largely duplicates flow_errors.handle_instance_error',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_script_object in flow_objects.objt_bpmn_id%type ',
'  , p_error_type    in varchar2',
'  , p_error_stack   in varchar2 default null',
'  )',
'  is ',
'    l_prcs_id   flow_processes.prcs_id%type;',
'    l_sbfl_id   flow_subflows.sbfl_id%type;',
'  begin ',
'        apex_debug.enter ',
'      ( ''handle_script_error''',
'      , ''p_script_object: '', p_script_object',
'      , ''p_error_type '', p_error_type ',
'      );',
'       -- lock process and subflow',
'      select prcs.prcs_id, sbfl.sbfl_id',
'        into l_prcs_id, l_sbfl_id',
'        from flow_processes prcs',
'        join flow_subflows sbfl ',
'          on prcs.prcs_id = sbfl.sbfl_prcs_id',
'       where prcs.prcs_id = p_process_id',
'         and sbfl.sbfl_id = p_subflow_id',
'      for update wait 2;',
'      -- set subflow to error status',
'      update flow_subflows sbfl',
'         set sbfl.sbfl_current        = p_script_object',
'           , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_error',
'           , sbfl.sbfl_last_update    = systimestamp ',
'           , sbfl.sbfl_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )         ',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'      ;',
'      -- set instance to error status',
'      update flow_processes prcs',
'         set prcs.prcs_status         = flow_constants_pkg.gc_prcs_status_error',
'           , prcs.prcs_last_update    = systimestamp',
'           , prcs.prcs_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )  ',
'       where prcs.prcs_id = p_process_id',
'      ;',
'      -- log error as instance event',
'      flow_logging.log_instance_event',
'      ( p_process_id  => p_process_id ',
'      , p_objt_bpmn_id => p_script_object',
'      , p_event       => flow_constants_pkg.gc_prcs_event_error',
'      , p_comment     => case p_error_type',
'                         when ''failed''      then ''ScriptTask failed on object ''',
'                         when ''stop_engine'' then ''User Script Requested ScriptTask Stop on object ''',
'                         end ',
'                         || p_script_object|| '' error data....''||p_error_stack',
'      );',
'',
'      apex_debug.message ',
'      ( p_message => ''Script failed in ScriptTask.  Object: %0.''',
'      , p0        => p_script_object',
'      , p_level   => 2',
'      );',
'  end handle_script_error;',
'',
'  procedure process_task',
'    ( p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is',
'  begin',
'    apex_debug.enter ',
'    ( ''process_task''',
'    , ''object: '', p_step_info.target_objt_tag ',
'    );',
'    -- set boundaryEvent Events, if any',
'    flow_boundary_events.set_boundary_events',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_sbfl_info  => p_sbfl_info',
'    );  ',
'  end process_task;',
'',
'  procedure process_userTask',
'    ( p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is ',
'    l_usertask_type         flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_priority_json         flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_priority              flow_subflows.sbfl_priority%type;',
'    l_due_on_json         flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_due_on              flow_subflows.sbfl_due_on%type;',
'  begin',
'  -- current implementation is limited to two userTask types, which are:',
'  --   - to run a user defined APEX page via the Task Inbox View',
'  --   - to call an APEX Approval Task (from APEX v22.1 onwards)',
'  -- future userTask types could include parameterised, standarised template pages , template scripts ??',
'    apex_debug.enter ',
'    ( ''process_userTask''',
'    , ''p_step_info.target_objt_tag''   , p_step_info.target_objt_tag ',
'    , ''p_step_info.target_objt_subtag'', p_step_info.target_objt_subtag ',
'    );',
'    -- set boundaryEvent Events, if any',
'    flow_boundary_events.set_boundary_events ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_sbfl_info  => p_sbfl_info',
'    );  ',
'    -- get the userTask subtype  ',
'    select objt.objt_attributes."taskType"',
'      into l_usertask_type',
'      from flow_objects objt',
'     where objt.objt_bpmn_id = p_step_info.target_objt_ref',
'       and objt.objt_dgrm_id = p_sbfl_info.sbfl_dgrm_id',
'       ;',
'',
'    case l_usertask_type',
'      when flow_constants_pkg.gc_apex_usertask_apex_approval then',
'       flow_usertask_pkg.process_apex_approval_task',
'       ( p_sbfl_info => p_sbfl_info',
'       , p_step_info => p_step_info',
'       );',
'      when flow_constants_pkg.gc_apex_usertask_apex_page then',
'       flow_usertask_pkg.process_apex_page_task',
'       ( p_sbfl_info => p_sbfl_info',
'       , p_step_info => p_step_info',
'       );',
'      when flow_constants_pkg.gc_apex_usertask_apex_simple_form then',
'       flow_usertask_pkg.process_apex_page_task',
'       ( p_sbfl_info => p_sbfl_info',
'       , p_step_info => p_step_info',
'       );',
'      else',
'        null;',
'    end case;',
'',
'  end process_userTask;',
'',
'  procedure process_scriptTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'    l_usertask_type    flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'    apex_debug.enter ',
'    ( ''process_scriptTask''',
'    , ''p_step_info.target_objt_tag'', p_step_info.target_objt_tag ',
'    );',
'    -- current implementation is limited to one scriptTask type, which is to run a user defined PL/SQL script',
'    -- future scriptTask types could include standarised template scripts ??',
'    -- current implementation is limited to synchronous script execution (i.e., script is run as part of Flows for APEX process)',
'    -- future implementations could include async scriptTasks, where script execution is queued.',
'  ',
'    -- set work started time',
'    flow_engine.start_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    , p_called_internally => true',
'    );',
'    ',
'    flow_plsql_runner_pkg.run_task_script(',
'      pi_prcs_id  => p_sbfl_info.sbfl_prcs_id',
'    , pi_sbfl_id  => p_sbfl_info.sbfl_id',
'    , pi_objt_id  => p_step_info.target_objt_id',
'    , pi_step_key => p_sbfl_info.sbfl_step_key',
'    );',
'',
'    flow_engine.flow_complete_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    );',
'',
'  exception',
'    when flow_plsql_runner_pkg.e_plsql_script_failed then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script failed in plsql script runner''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_failed''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'      -- $F4AMESSAGE ''plsql_script_failed'' || ''Process %0: ScriptTask %1 failed due to PL/SQL error - see event log.''',
'    when flow_plsql_runner_pkg.e_plsql_script_requested_stop then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script requested stop_engine in plsql script runner''',
'      ); ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_requested_stop''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );  ',
'      -- $F4AMESSAGE ''plsql_script_requested_stop'' || ''Process %0: ScriptTask %1 requested processing stop - see event log.''',
'  end process_scriptTask'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
';',
'',
'  procedure process_serviceTask ',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'  begin',
'    apex_debug.enter ',
'    ( ''process_serviceTask''',
'    , ''p_step_info.target_objt_tag'', p_step_info.target_objt_tag ',
'    );',
'  ',
'    -- future serviceTask types could include text message, tweet, AOP document via email, etc.',
'    -- current implementation is limited to synchronous email send (i.e., email sent as part of Flows for APEX process).',
'    -- future implementations could include async serviceTask, where message generation is queued, or non-email services',
'',
'    flow_engine.start_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    , p_called_internally => true',
'    );',
'',
'    case get_task_type( pi_objt_id => p_step_info.target_objt_id )',
'      when flow_constants_pkg.gc_apex_task_execute_plsql then',
'        flow_plsql_runner_pkg.run_task_script',
'        ( pi_prcs_id  => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id  => p_sbfl_info.sbfl_id',
'        , pi_objt_id  => p_step_info.target_objt_id',
'        , pi_step_key => p_sbfl_info.sbfl_step_key',
'        );',
'      when flow_constants_pkg.gc_apex_servicetask_send_mail then',
'        flow_services.send_email',
'        ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => p_sbfl_info.sbfl_id',
'        , pi_objt_id => p_step_info.target_objt_id',
'        );',
'      else',
'        null;',
'    end case;',
'',
'    flow_engine.flow_complete_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id ',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    );',
'',
'  exception',
'    when flow_services.e_wrong_default_workspace then',
'      rollback;',
'      apex_debug.info( p_message => ''Rollback initiated after default workspace not valid''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''wrong-default-workspace''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_services.e_workspace_not_found then',
'      rollback;',
'      apex_debug.info( p_message => ''Rollback initiated after workspace not found''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''workspace-not-found''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_services.e_email_no_from then ',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after from attribute not found''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''email-no-from''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_services.e_email_no_to then ',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after to attribute not found''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''email-no-to''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_services.e_email_no_template then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after template or app_alias attributes not found''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''email-no-template''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      ); ',
'    when flow_services.e_email_no_body then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after body attribute not found''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''email-no-body''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_services.e_json_not_valid then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after placeholder JSON object not valid''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''email-placeholder-json-invalid''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_services.e_email_failed then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after send_email failed in service task''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''email-failed''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'    when flow_plsql_runner_pkg.e_plsql_script_failed then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script failed in plsql script runner''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_failed''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'      -- $F4AMESSAGE ''plsql_script_failed'' || ''Process %0: PLSQL Script %1 failed due to PL/SQL error - see event log.''',
'    when flow_plsql_runner_pkg.e_plsql_script_requested_stop then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script requested stop_engine in plsql script runner''',
'      ); ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_requested_stop''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );  ',
'      -- $F4AMESSAGE ''plsql_script_requested_stop'' || ''Process %0: PL/SQL Script %1 requested processing stop - see event log.''',
'',
'  end process_serviceTask;',
'',
'  procedure process_manualTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'  begin',
'    apex_debug.enter ',
'    (''process_manualTask''',
'    , ''p_step_info.target_objt_tag'', p_step_info.target_objt_tag ',
'    );',
'',
'    -- current implementation of manualTask performs exactly like a standard Task, without attached boundary timers',
'    -- future implementation could include auto-call of an APEX page telling you what the manual task is and providing information about it?',
'',
'    -- set boundaryEvent Events, if any',
'    flow_boundary_events.set_boundary_events ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_sbfl_info  => p_sbfl_info',
'    );  ',
'  end process_manualTask;',
'',
'  procedure process_businessRuleTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'  begin',
'    apex_debug.enter ',
'    ( ''process_businessRuleTask''',
'    , ''p_step_info.target_objt_tag'', p_step_info.target_objt_tag ',
'    );',
'    -- current implementation is limited to one businessRuleTask type, ',
'    -- which is to run a user defined PL/SQL script',
'    -- future scriptTask types could include DMN or REST calls to other DecisionRule Engines',
'    -- current implementation is limited to synchronous script execution (i.e., script is run as part of Flows for APEX process)',
'    -- future implementations could include async scriptTasks, where script execution is queued.',
'  ',
'    -- set work started time',
'    flow_engine.start_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    , p_called_internally => true',
'    );',
'    ',
'    case get_task_type( p_step_info.target_objt_id )',
'      when flow_constants_pkg.gc_apex_task_execute_plsql then',
'        flow_plsql_runner_pkg.run_task_script',
'        ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => p_sbfl_info.sbfl_id',
'        , pi_objt_id => p_step_info.target_objt_id',
'        );',
'      else',
'        null;',
'    end case;',
'    ',
'    flow_engine.flow_complete_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    );',
'',
'  exception',
'    when flow_plsql_runner_pkg.e_plsql_script_failed then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script failed in plsql script runner''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_failed''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'      -- $F4AMESSAGE ''plsql_script_failed'' || ''Process %0: PL/SQL Script %1 failed due to PL/SQL error - see event log.''',
'    when flow_plsql_runner_pkg.e_plsql_script_requested_stop then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script requested stop_engine in plsql script runner''',
'      ); ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_requested_stop''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );  ',
'      -- $F4AMESSAGE ''plsql_script_requested_stop'' || ''Process %0: PL/SQL Script %1 requested processing stop - see event log.''',
'  end process_businessRuleTask;',
'',
'  procedure process_sendTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'  begin',
'    apex_debug.enter ',
'    ( ''process_sendTask''',
'    , ''p_step_info.target_objt_ref'', p_step_info.target_objt_ref',
'    , ''p_step_info.target_objt_id'', p_step_info.target_objt_id',
'    , ''taret object task type'', get_task_type( pi_objt_id => p_step_info.target_objt_id )',
'    );',
'    -- current implementation is limited to one sendTask type, ',
'    -- which is to run a user defined PL/SQL script',
'    -- future scriptTask types could include pre-built REST calls',
'    -- current implementation is limited to synchronous script execution (i.e., script is run as part of Flows for APEX process)',
'  ',
'    -- set work started time',
'    flow_engine.start_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    , p_called_internally => true',
'    );',
'    ',
'    case get_task_type( pi_objt_id => p_step_info.target_objt_id )',
'    when flow_constants_pkg.gc_simple_message then',
'        -- Flows for APEX Basic MessageFlow',
'        flow_message_flow.send_message',
'        ( p_sbfl_info => p_sbfl_info',
'        , p_step_info => p_step_info',
'        );',
'    when flow_constants_pkg.gc_apex_task_execute_plsql then',
'        flow_plsql_runner_pkg.run_task_script',
'        ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => p_sbfl_info.sbfl_id',
'        , pi_objt_id => p_step_info.target_objt_id',
'        );',
'    end case;',
'    ',
'    flow_engine.flow_complete_step ',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_step_key   => p_sbfl_info.sbfl_step_key',
'    );',
'',
'  exception',
'    when flow_plsql_runner_pkg.e_plsql_script_failed then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script failed in plsql script runner''',
'      );',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_failed''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );',
'      -- $F4AMESSAGE ''plsql_script_failed'' || ''Process %0: PL/SQL Script %1 failed due to PL/SQL error - see event log.''',
'    when flow_plsql_runner_pkg.e_plsql_script_requested_stop then',
'      rollback;',
'      apex_debug.info ',
'      ( p_message => ''Rollback initiated after script requested stop_engine in plsql script runner''',
'      ); ',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_info.sbfl_id',
'      , pi_message_key    => ''plsql_script_requested_stop''',
'      , p0 => p_sbfl_info.sbfl_prcs_id',
'      , p1 => p_step_info.target_objt_ref',
'      );  ',
'      -- $F4AMESSAGE ''plsql_script_requested_stop'' || ''Process %0: PL/SQL Script %1 requested processing stop - see event log.''',
'  end process_sendTask;  ',
'',
'  procedure process_receiveTask',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'    l_message_name_json flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_message_name      flow_message_subscriptions.msub_message_name%type;',
'    l_key_json          flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_key               flow_message_subscriptions.msub_key_name%type;',
'    l_value_json        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_value             flow_message_subscriptions.msub_key_value%type;',
'    l_payload_variable  flow_process_variables.prov_var_name%type;',
'    l_msub_id           flow_message_subscriptions.msub_id%type;',
'    l_msg_sub           flow_message_flow.t_subscription_details;',
'  begin',
'    apex_debug.enter ',
'    ( ''process_receiveTask''',
'    , ''p_step_info.target_objt_tag'', p_step_info.target_objt_tag ',
'    );',
'',
'    -- set boundaryEvent Events, if any',
'    flow_boundary_events.set_boundary_events',
'    ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'    , p_subflow_id => p_sbfl_info.sbfl_id',
'    , p_sbfl_info  => p_sbfl_info',
'    );  ',
'        ',
'    case get_task_type( p_step_info.target_objt_id )',
'      when flow_constants_pkg.gc_simple_message then',
' ',
'        l_msg_sub            := flow_message_util.get_msg_subscription_details',
'                                ( p_msg_object_bpmn_id      => p_step_info.target_objt_ref',
'                                , p_dgrm_id                 => p_sbfl_info.sbfl_dgrm_id',
'                                , p_sbfl_info               => p_sbfl_info',
'                                );',
'        l_msg_sub.callback  := flow_constants_pkg.gc_bpmn_receivetask;',
'',
'        if not flow_globals.get_step_error then',
'',
'          -- create subscription for the awaited message ',
'          l_msub_id := flow_message_flow.subscribe ( p_subscription_details => l_msg_sub);',
'    ',
'          -- update subflow into ''waiting for message'' status',
'          update flow_subflows sbfl',
'            set sbfl.sbfl_last_update    = systimestamp',
'              , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_waiting_message',
'              , sbfl.sbfl_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                      , sys_context(''userenv'',''os_user'')',
'                                                      , sys_context(''userenv'',''session_user'')',
'                                                      )  ',
'          where sbfl.sbfl_id       = p_sbfl_info.sbfl_id',
'            and sbfl.sbfl_prcs_id  = p_sbfl_info.sbfl_prcs_id',
'            ;',
'          -- log subscription event',
'          apex_debug.message ',
'          ( p_message => ''-- ReceiveTask subscription created - message subscription id: %0''',
'          , p0 => l_msub_id',
'          );',
'        end if;',
'',
'      when  flow_constants_pkg.gc_apex_task_execute_plsql then',
'        -- set work started time',
'        flow_engine.start_step ',
'        ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id => p_sbfl_info.sbfl_id',
'        , p_step_key   => p_sbfl_info.sbfl_step_key',
'        , p_called_internally => true',
'        );',
'',
'        flow_plsql_runner_pkg.run_task_script',
'        ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'        , pi_sbfl_id => p_sbfl_info.sbfl_id',
'        , pi_objt_id => p_step_info.target_objt_id',
'        );',
'',
'        flow_engine.flow_complete_step   --- remove the complete step?',
'        ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'        , p_subflow_id => p_sbfl_info.sbfl_id',
'        , p_step_key   => p_sbfl_info.sbfl_step_key',
'        );',
'',
'    end case;',
'',
'  end process_receiveTask;  ',
'',
'  procedure receiveTask_callback',
'  ( p_process_id    flow_processes.prcs_id%type',
'  , p_subflow_id    flow_subflows.sbfl_id%type',
'  , p_step_key      flow_subflows.sbfl_step_key%type',
'  , p_msub_id       flow_message_subscriptions.msub_id%type',
'  )',
'  is',
'    l_msub_id             flow_message_subscriptions.msub_id%type;',
'    l_required_step_key   flow_subflows.sbfl_step_key%type;',
'    l_current             flow_objects.objt_bpmn_id%type;',
'    l_scope               flow_process_variables.prov_scope%type;',
'    l_dgrm_id             flow_diagrams.dgrm_id%type;',
'    l_follows_ebg         flow_subflows.sbfl_is_following_ebg%type; ',
'    l_parent_sbfl         flow_subflows.sbfl_sbfl_id%type;',
'    e_incorrect_step_key  exception;',
'  begin',
'    apex_debug.enter ',
'    ( ''receiveTask_callback''',
'    , ''p_process_id'', p_process_id',
'    , ''p_subflow_id'', p_subflow_id',
'    , ''p_step_key'', p_step_key',
'    );',
'',
'    -- get subflow info, step info, validate step key',
'    flow_engine.start_step ',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    , p_step_key   => p_step_key',
'    , p_called_internally => true',
'    );',
'',
'    begin',
'      select sbfl.sbfl_step_key',
'           , sbfl.sbfl_current',
'           , sbfl.sbfl_dgrm_id',
'           , sbfl.sbfl_is_following_ebg',
'           , sbfl.sbfl_sbfl_id',
'        into l_required_step_key',
'           , l_current',
'           , l_dgrm_id',
'           , l_follows_ebg',
'           , l_parent_sbfl',
'        from flow_objects objt',
'        join flow_subflows sbfl',
'          on sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'         and sbfl.sbfl_current = objt.objt_bpmn_id',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl_prcs_id = p_process_id',
'         ;',
'      if l_required_step_key != p_step_key then',
'        raise e_incorrect_step_key;',
'      end if;',
'    exception',
'      when no_data_found then',
'        null; -- tbi',
'      when e_incorrect_step_key then',
'        null; -- tbi',
'      when others then',
'        null; -- tbi',
'    end; ',
'',
'    -- handle a receivetask following an Event Based Gateway',
'',
'    case  l_follows_ebg ',
'    when  ''Y'' then',
'        -- we have an eventBasedGateway - handle cleaning up the other forward paths',
'        flow_engine.handle_event_gateway_event ',
'        (',
'          p_process_id => p_process_id',
'        , p_parent_subflow_id => l_parent_sbfl',
'        , p_cleared_subflow_id => p_subflow_id',
'        );      ',
'',
'    else ',
'      -- set subflow to running',
'      update flow_subflows sbfl',
'         set sbfl.sbfl_last_update    = systimestamp',
'           , sbfl.sbfl_work_started   = systimestamp',
'           , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'           , sbfl.sbfl_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )  ',
'       where sbfl.sbfl_id       = p_subflow_id',
'         and sbfl.sbfl_prcs_id  = p_process_id',
'        ;',
'      -- log message receipt event',
'',
'',
'      -- step subflow forward',
'      flow_engine.flow_complete_step ',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_step_key   => p_step_key',
'      );',
'    end case;',
'',
'  end receiveTask_callback;',
'  ',
'',
'end flow_tasks;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_services.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created  21-Nov-2021  Louis Moreaux (Insum, for MT AG) ',
'-- Edited   13-Apr-2022  Richard Allen (Oracle)',
'-- Modified 01-Jun-2022  Moritz Klein (MT AG)',
'--',
'*/',
'',
'create or replace package body flow_services',
'as',
'  g_workspace varchar2(100) := flow_engine_util.get_config_value(',
'                                   p_config_key    => ''default_workspace''',
'                                 , p_default_value => flow_constants_pkg.gc_config_default_default_workspace',
'                               );',
'',
'  g_email_sender varchar2(100) := flow_engine_util.get_config_value(',
'                                   p_config_key    => ''default_email_sender''',
'                                 , p_default_value => ''''  ',
'                               );',
'',
'  procedure set_workspace_id',
'  (',
'    p_workspace_name in varchar2',
'  )',
'  is',
'    l_workspace_id number;',
'  begin',
'    l_workspace_id := apex_util.find_security_group_id (p_workspace => p_workspace_name);',
'    if (l_workspace_id is null) then',
'      raise e_wrong_default_workspace;',
'    end if;',
'    apex_util.set_security_group_id (p_security_group_id => l_workspace_id);',
'  end set_workspace_id;',
'',
'  procedure get_config',
'  (',
'    pi_objt_id           in flow_objects.objt_id%type',
'  , po_from             out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_to               out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_cc               out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_bcc              out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_reply_to         out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_use_template     out nocopy boolean',
'  , po_template_id      out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_placeholders     out nocopy clob',
'  , po_immediate        out nocopy boolean',
'  , po_application_id   out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_subject          out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  , po_body             out nocopy clob',
'  , po_body_html        out nocopy clob',
'  , po_attachment_query out nocopy flow_types_pkg.t_bpmn_attribute_vc2',
'  )',
'  as',
'    l_plain_config     clob;',
'    l_json_config      sys.json_object_t;',
'    l_body             sys.json_array_t;',
'    l_body_html        sys.json_array_t;',
'    l_attachment_query sys.json_array_t;',
'    l_placeholders     sys.json_object_t;',
'    procedure json_array_to_clob',
'    (',
'      pi_array  in sys.json_array_t',
'    , po_clob  out nocopy clob',
'    )',
'    as',
'    begin',
'      if pi_array is not null then',
'        for i in 0..pi_array.get_size - 1 loop',
'          po_clob := po_clob || pi_array.get_string(i) || apex_application.lf;',
'        end loop;',
'      end if;',
'    end json_array_to_clob;',
'  begin',
'    select json_query( objt.objt_attributes format json, ''$.apex'' returning clob ) as json_data',
'      into l_plain_config',
'      from flow_objects objt',
'     where objt.objt_id = pi_objt_id',
'    ;',
'    l_json_config      := sys.json_object_t.parse( l_plain_config );',
'',
'    po_from           := l_json_config.get_string( ''emailFrom'' );',
'    po_to             := l_json_config.get_string( ''emailTo'' );',
'    po_cc             := l_json_config.get_string( ''emailCC'' );',
'    po_bcc            := l_json_config.get_string( ''emailBCC'' );',
'    po_reply_to       := l_json_config.get_string( ''emailReplyTo'' );',
'    po_use_template   := coalesce( l_json_config.get_boolean( ''useTemplate'' ), false );',
'    po_application_id := l_json_config.get_string( ''applicationId'' );',
'    po_template_id    := l_json_config.get_string( ''templateId'' );',
'    po_subject        := l_json_config.get_string( ''subject'' );',
'    po_immediate      := coalesce( l_json_config.get_boolean( ''immediately'' ), false );',
'',
'    if l_json_config.has( ''placeholder'' ) then',
'      l_placeholders  := l_json_config.get_object( ''placeholder'' );',
'      po_placeholders := l_placeholders.to_clob;',
'    end if;',
'',
'    json_array_to_clob( pi_array => l_json_config.get_array( ''bodyText'' ),   po_clob => po_body );',
'    json_array_to_clob( pi_array => l_json_config.get_array( ''bodyHTML'' ),   po_clob => po_body_html );',
'    json_array_to_clob( pi_array => l_json_config.get_array( ''attachment'' ), po_clob => po_attachment_query );',
'',
'  end get_config;',
'',
'  procedure send_email',
'  (',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_sbfl_id in flow_subflows.sbfl_id%type',
'  , pi_objt_id in flow_objects.objt_id%type',
'  )',
'  is',
'    l_from             flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_to               flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_cc               flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_bcc              flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_reply_to         flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_use_template     boolean := false;',
'    l_template_id      flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_placeholders     clob;',
'    l_immediate        boolean := false;',
'    l_application_id   flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_subject          flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_body             clob;',
'    l_body_html        clob;',
'    l_attachment_query flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_mail_id          number;',
'    type t_attachment  is record (file_name varchar2(200), mime_type varchar2(200), blob_content blob );',
'    type t_attachments is table of t_attachment;',
'    l_attachments      t_attachments;',
'    l_workspace        varchar2(100);',
'    l_session          varchar2(20) := v(''APP_SESSION'');',
'    l_json_object      sys.json_object_t;',
'    l_scope            flow_subflows.sbfl_scope%type;',
'  begin',
'    apex_debug.enter( p_routine_name => ''send_email'', p_name01 => ''pi_objt_id'', p_value01 => pi_objt_id );',
'',
'    l_scope := flow_engine_util.get_scope ( p_process_id => pi_prcs_id, p_subflow_id => pi_sbfl_id );',
'    flow_globals.set_context( pi_prcs_id        => pi_prcs_id',
'                            , pi_sbfl_id        => pi_sbfl_id',
'                            , pi_scope          => l_scope ',
'                            , pi_loop_counter   => flow_engine_util.get_loop_counter (pi_sbfl_id => pi_sbfl_id));',
'',
'    -- Pull all configuration from objt_attributes JSON structure',
'    get_config',
'    (',
'      pi_objt_id          => pi_objt_id',
'    , po_from             => l_from',
'    , po_to               => l_to',
'    , po_cc               => l_cc',
'    , po_bcc              => l_bcc',
'    , po_reply_to         => l_reply_to',
'    , po_use_template     => l_use_template',
'    , po_template_id      => l_template_id',
'    , po_placeholders     => l_placeholders',
'    , po_immediate        => l_immediate',
'    , po_application_id   => l_application_id',
'    , po_subject          => l_subject',
'    , po_body             => l_body',
'    , po_body_html        => l_body_html',
'    , po_attachment_query => l_attachment_query',
'    );',
'',
'    -- Substitute process variables where needed',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_from );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_to );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_cc );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_bcc );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_reply_to );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_application_id );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_template_id );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_placeholders );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_subject );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_body );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_body_html );',
'    flow_proc_vars_int.do_substitution( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_scope => l_scope, pio_string => l_attachment_query );',
'',
'    l_from := coalesce( l_from, g_email_sender );',
'    -- Raise error if needed',
'    -- no sender',
'    if l_from is null then',
'        raise e_email_no_from;',
'    end if;',
'    --no recipient',
'    if l_to is null then',
'      raise e_email_no_to;',
'    end if;',
'',
'    -- Set the workspace if no session',
'    -- Useful for timers',
'    if ( l_session is null ) then',
'      if ( l_use_template ) then',
'        begin',
'          select workspace ',
'            into l_workspace',
'            from apex_applications',
'           where application_id = l_application_id;',
'        exception when no_data_found then',
'          raise e_workspace_not_found;',
'        end;',
'      else',
'        l_workspace := g_workspace;         ',
'      end if;'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
'      set_workspace_id(p_workspace_name => l_workspace);',
'    end if;',
'',
'    if l_use_template then',
'      if l_application_id is null or l_template_id is null then',
'        raise e_email_no_template;',
'      end if;',
'',
'      apex_debug.message(''sys.dbms_lob.getlength(l_placeholders) '' ||sys.dbms_lob.getlength(l_placeholders));',
'      if sys.dbms_lob.getlength(l_placeholders) > 0  then',
'        begin',
'          l_json_object := json_object_t(l_placeholders);',
'        exception',
'          when others then',
'            raise e_json_not_valid;',
'        end;',
'      end if;',
'',
'      l_mail_id := apex_mail.send(',
'        p_template_static_id => l_template_id,',
'        p_placeholders       => l_placeholders,',
'        p_to                 => l_to,',
'        p_cc                 => l_cc,',
'        p_bcc                => l_bcc,',
'        p_from               => l_from,',
'        p_replyto            => l_reply_to,',
'        p_application_id     => l_application_id',
'      );',
'',
'    else',
'',
'      if l_body is null then',
'        raise e_email_no_body;',
'      end if;',
'',
'      l_mail_id := apex_mail.send(',
'        p_to        => l_to, ',
'        p_from      => l_from,',
'        p_cc        => l_cc,',
'        p_bcc       => l_bcc,',
'        p_replyto   => l_reply_to,',
'        p_body      => l_body,',
'        p_body_html => l_body_html,',
'        p_subj      => l_subject',
'      );',
'',
'    end if;',
'',
'    if (l_attachment_query is not null ) then',
'',
'      execute immediate l_attachment_query ',
'      bulk collect into  l_attachments;',
'',
'      for i in 1..l_attachments.count()',
'      loop',
'        apex_mail.add_attachment(',
'          p_mail_id    => l_mail_id,',
'          p_attachment => l_attachments(i).blob_content,',
'          p_filename   => l_attachments(i).file_name,',
'          p_mime_type  => l_attachments(i).mime_type',
'        );',
'      end loop;',
'    end if;',
'',
'    if (l_immediate ) then',
'      apex_mail.push_queue;',
'    end if;',
'    ',
'  exception',
'    when e_wrong_default_workspace then',
'      apex_debug.error',
'      (',
'        p_message => ''Default workspace %s is not valid''',
'      , p0        => g_workspace',
'      );',
'      raise e_wrong_default_workspace;',
'    when e_workspace_not_found then',
'      apex_debug.error',
'      (',
'        p_message => ''Unable to find the workspace for application id %s''',
'      , p0        => l_application_id',
'      );',
'      raise e_workspace_not_found;',
'    when e_email_no_from then ',
'      apex_debug.error',
'      (',
'        p_message => ''Email service task requires from attribute''',
'      );',
'      raise e_email_no_from; ',
'    when e_email_no_to then ',
'      apex_debug.error',
'      (',
'        p_message => ''Email service task requires to attribute''',
'      );',
'      raise e_email_no_to;  ',
'    when e_email_no_template then',
'      apex_debug.error',
'      (',
'        p_message => ''Email service task use email template but no template id define''',
'      );',
'      raise e_email_no_template;  ',
'    when e_email_no_body then',
'      apex_debug.error',
'      (',
'        p_message => ''Email service task body is missing''',
'      );',
'      raise e_email_no_body;',
'    when e_json_not_valid then',
'      apex_debug.error',
'      (',
'        p_message => ''Placeholder JSON object is invalid.''',
'      );',
'      apex_debug.log_long_message',
'      (',
'          p_message => l_placeholders',
'        , p_level   => apex_debug.c_log_level_error',
'      );',
'      raise e_json_not_valid;',
'    when others then',
'      apex_debug.error',
'      (',
'        p_message => ''Error during flow_services.send_email. SQLERRM: %s''',
'      , p0        => sqlerrm',
'      );',
'      raise e_email_failed;',
'',
'    end send_email;',
'',
'end flow_services;',
'/',
'',
'create or replace package body flow_instances as',
'/* ',
'-- Flows for APEX - flow_instances.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created  25-May-2021  Richard Allen (Flowquest) for  MT AG  - refactor from flow_engine',
'-- Modified 30-May-2022  Moritz Klein (MT AG)',
'--',
'*/',
'',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'  e_unsupported_start_event exception;',
'',
'  type t_call_def is record',
'    ( dgrm_name              flow_diagrams.dgrm_name%type',
'    , dgrm_version           flow_diagrams.dgrm_version%type',
'    , dgrm_id                flow_diagrams.dgrm_id%type',
'    , dgrm_version_selection flow_types_pkg.t_bpmn_attribute_vc2',
'    );',
'',
'  function call_is_recursive',
'    ( p_prcs_id   flow_processes.prcs_id%type',
'    , p_prdg_id   flow_instance_diagrams.prdg_id%type',
'    , p_dgrm_id   flow_diagrams.dgrm_id%type  ',
'    ) return boolean',
'  is',
'    l_num_recursive_nodes number;',
'  begin',
'    -- tests id p_dgrm_id exists in the instance diagram tree above p_prdg_id',
'    select  count(1)',
'    into    l_num_recursive_nodes',
'    from    flow_instance_diagrams',
'    where   prdg_prcs_id = p_prcs_id',
'    and     prdg_dgrm_id = p_dgrm_id',
'    and     level        > 1',
'    start with prdg_id   = p_prdg_id',
'    connect by prior prdg_prdg_id = prdg_id',
'    ;',
'    return l_num_recursive_nodes > 0;',
'  end call_is_recursive;',
'',
'  function diagram_is_callable',
'    ( p_dgrm_id   flow_diagrams.dgrm_id%type',
'    ) return boolean',
'  is',
'    l_is_callable   flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'      select nvl( objt.objt_attributes."apex"."isCallable" ,''false'')',
'        into l_is_callable',
'        from flow_objects objt',
'       where objt.objt_tag_name = flow_constants_pkg.gc_bpmn_process',
'         and objt.objt_dgrm_id = p_dgrm_id',
'      ;',
'      return l_is_callable = ''true'';',
'  end diagram_is_callable;',
'',
'  procedure find_nested_calls',
'    ( p_dgrm_id         flow_diagrams.dgrm_id%type',
'    , p_prcs_id         flow_processes.prcs_id%type',
'    , p_parent_prdg_id  flow_instance_diagrams.prdg_id%type',
'    )',
'  is ',
'    l_child_dgrm_id                         flow_diagrams.dgrm_id%type;',
'    l_call_def                              t_call_def;',
'    l_current_prdg_id                       flow_instance_diagrams.prdg_id%type;',
'  begin',
'    for call_activity in (',
'      select objt.objt_bpmn_id',
'           , objt.objt_id',
'           , objt.objt_attributes."apex"."calledDiagram" as dgrm_name',
'           , objt.objt_attributes."apex"."calledDiagramVersion" as dgrm_version',
'           , objt.objt_attributes."apex"."calledDiagramVersionSelection" as dgrm_version_selection',
'        from flow_objects objt',
'       where objt.objt_tag_name = flow_constants_pkg.gc_bpmn_call_activity',
'         and objt.objt_dgrm_id = p_dgrm_id',
'      )',
'    loop',
'      l_child_dgrm_id :=',
'        flow_diagram.get_current_diagram',
'        ( pi_dgrm_name            => call_activity.dgrm_name',
'        , pi_dgrm_calling_method  => call_activity.dgrm_version_selection',
'        , pi_dgrm_version         => call_activity.dgrm_version',
'        , pi_prcs_id              => p_prcs_id',
'        );',
'      -- check diagram is callable',
'      if  diagram_is_callable (p_dgrm_id => l_child_dgrm_id) then',
'        -- diagram is callable ',
'        -- Check for self-reference',
'        -- If Diagram is calling itself stop processing and error out.',
'        if l_child_dgrm_id = p_dgrm_id then',
'          flow_errors.handle_general_error',
'          ( pi_message_key => ''start-diagram-calls-itself''',
'          , p0 => p_dgrm_id',
'          );',
'          -- $F4AMESSAGE ''start-diagram-calls-itself'' || ''You tried to start a diagram %0 that contains a callActivity calling itself.'' ',
'        else',
'          -- insert an instance_diagram record',
'          insert into flow_instance_diagrams',
'          ( prdg_prcs_id',
'          , prdg_dgrm_id',
'          , prdg_calling_dgrm',
'          , prdg_calling_objt',
'          , prdg_prdg_id',
'          )',
'          values ',
'          ( p_prcs_id',
'          , l_child_dgrm_id',
'          , p_dgrm_id',
'          , call_activity.objt_bpmn_id',
'          , p_parent_prdg_id',
'          )',
'          returning prdg_id into l_current_prdg_id',
'          ;',
'          -- check for indirect recursion',
'          if call_is_recursive  ( p_prcs_id => p_prcs_id',
'                                , p_dgrm_id => l_child_dgrm_id',
'                                , p_prdg_id => l_current_prdg_id) ',
'          then',
'            flow_errors.handle_general_error',
'            ( pi_message_key => ''start-diagram-calls-itself''',
'            , p0 => p_dgrm_id',
'            );',
'            -- $F4AMESSAGE ''start-diagram-calls-itself'' || ''You tried to start a diagram %0 that contains a callActivity calling itself.''           ',
'          -- find any nested calls in child',
'          end if;',
'          find_nested_calls ( p_dgrm_id         => l_child_dgrm_id',
'                            , p_prcs_id         => p_prcs_id ',
'                            , p_parent_prdg_id  => l_current_prdg_id',
'                            );',
'        end if;',
'      else',
'        -- diagram is not callable - raise error',
'        apex_debug.info',
'        ( p_message  => ''Building Diagram Call Tree - Diagram %0 (called by diagram %1 is set as not-callable''',
'        , p0  => l_child_dgrm_id',
'        , p1  => p_dgrm_id',
'        );',
'        flow_errors.handle_general_error',
'        ( pi_message_key => ''call-diagram-not-callable''',
'        , p0 => l_child_dgrm_id',
'        );',
'        -- $F4AMESSAGE ''call-diagram-not-callable'' || ''You tried to call a diagram %0 that is marked as being not callable.''        ',
'      end if;',
'    end loop; ',
'  end find_nested_calls;',
'',
'  procedure create_call_structure',
'    ( p_prcs_id  in flow_processes.prcs_id%type',
'    , p_dgrm_id  in flow_diagrams.dgrm_id%type',
'    )',
'  is ',
'    l_parent_prdg_id  flow_instance_diagrams.prdg_id%type;',
'  begin',
'    -- put top level diagram into the call structure',
'    insert into flow_instance_diagrams',
'      ( prdg_prcs_id',
'      , prdg_dgrm_id',
'      , prdg_diagram_level',
'      )',
'    values ',
'      ( p_prcs_id',
'      , p_dgrm_id',
'      , 0',
'      )',
'    returning prdg_id into l_parent_prdg_id;',
'    -- find any nested calls ',
'    find_nested_calls ( p_dgrm_id         => p_dgrm_id',
'                      , p_prcs_id         => p_prcs_id',
'                      , p_parent_prdg_id  => l_parent_prdg_id',
'                      );',
'  end create_call_structure;',
'',
'  function create_process',
'    ( p_dgrm_id   in flow_diagrams.dgrm_id%type',
'    , p_prcs_name in flow_processes.prcs_name%type',
'    ) return flow_processes.prcs_id%type',
'  is',
'    l_ret flow_processes.prcs_id%type;',
'  begin',
'    apex_debug.enter',
'    (''create_process''',
'    , ''dgrm_id'', p_dgrm_id',
'    , ''p_prcs_name'', p_prcs_name ',
'    );',
'    insert into flow_processes prcs',
'          ( prcs.prcs_name',
'          , prcs.prcs_dgrm_id',
'          , prcs.prcs_status',
'          , prcs.prcs_init_ts',
'          , prcs.prcs_last_update',
'          , prcs.prcs_init_by',
'          )',
'    values',
'          ( p_prcs_name',
'          , p_dgrm_id',
'          , flow_constants_pkg.gc_prcs_status_created',
'          , systimestamp',
'          , systimestamp',
'          , coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                      , sys_context(''userenv'',''os_user'')',
'                      , sys_context(''userenv'',''session_user'')',
'                      )  ',
'          )',
'      returning prcs.prcs_id into l_ret',
'    ;',
'    -- build the call structure for the process instance and any diagram calls ',
'    create_call_structure ( p_prcs_id => l_ret, p_dgrm_id => p_dgrm_id);',
'',
'    -- log the process creation',
'    flow_logging.log_instance_event',
'    ( p_process_id => l_ret',
'    , p_event      => flow_constants_pkg.gc_prcs_event_created',
'    );',
'    commit;',
'',
'    apex_debug.info',
'    ( p_message => ''Flow Instance created.  DGRM_ID : %0, PRCS_ID : %1''',
'    , p0 => p_dgrm_id',
'    , p1 => l_ret ',
'    );',
'    return l_ret;',
'  end create_process;',
'',
'  procedure start_process',
'  ( p_process_id              in flow_processes.prcs_id%type',
'  , p_event_starting_object   in flow_objects.objt_bpmn_id%type default null  -- only for messageStart, etc.',
'  )',
'  is',
'    l_dgrm_id               flow_diagrams.dgrm_id%type;',
'    l_process_status        flow_processes.prcs_status%type;',
'    l_main_subflow          flow_types_pkg.t_subflow_context;',
'    l_new_subflow_status    flow_subflows.sbfl_status%type;',
'    l_priority_json         flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_priority              flow_processes.prcs_priority%type;',
'    l_due_on_json           flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_due_on                flow_processes.prcs_due_on%type;',
'    l_starting_object       flow_objects%rowtype;',
'  begin',
'    apex_debug.enter',
'    (''start_process''',
'    , ''Process_ID'', p_process_id ',
'    , ''Event Starting Object'' , p_event_starting_object',
'    );',
'    -- check process exists, is not running, and lock it',
'    begin',
'',
'      flow_globals.set_is_recursive_step (p_is_recursive_step => false);',
'      -- initialise step_had_error flag',
'      flow_globals.set_step_error ( p_has_error => false);',
'',
'      select prcs.prcs_status',
'           , prcs.prcs_dgrm_id',
'        into l_process_status',
'           , l_dgrm_id',
'        from flow_processes prcs ',
'       where prcs.prcs_id = p_process_id',
'      for update wait 2',
'      ;',
'      if l_process_status != ''created'' then',
'        flow_errors.handle_general_error',
'        ( pi_message_key => ''start-already-running''',
'        , p0 => p_process_id',
'        );',
'        -- $F4AMESSAGE ''start-already-running'' || ''You tried to start a process (id %0) that is already running.''',
'      end if;',
'      ',
'    exception',
'      when no_data_found then',
'        flow_errors.handle_general_error',
'        ( pi_message_key => ''start-not-created''',
'        , p0 => p_process_id',
'        );',
'        -- $F4AMESSAGE ''start-not-created'' || ''You tried to start a process (id %0) that does not exist.'' ',
'      when too_many_rows then',
'        flow_errors.handle_general_error',
'        ( pi_message_key => ''start-multiple-already-running''',
'        , p0 => p_process_id',
'        );',
'        -- $F4AMESSAGE ''start-multiple-already-running'' || ''You tried to start a process (id %0) with multiple copies already running.'' ',
'    end;',
'',
'    l_starting_object := flow_diagram.get_start_event ( p_dgrm_id               => l_dgrm_id',
'                                                      , p_process_id            => p_process_id',
'                                                      , p_event_starting_object => p_event_starting_object);',
'',
'    begin',
'      -- get instance scheduling information for the process being started',
'      select objt.objt_attributes."apex"."priority"',
'           , objt.objt_attributes."apex"."dueOn"',
'        into l_priority_json',
'           , l_due_on_json',
'        from flow_objects objt',
'       where objt.objt_dgrm_id  = l_dgrm_id',
'         and objt.objt_tag_name = flow_constants_pkg.gc_bpmn_process',
'         and objt.objt_id       = l_starting_object.objt_objt_id',
'      ;',
'      if l_priority_json is not null then',
'        l_priority := flow_settings.get_priority ( pi_prcs_id => p_process_id, pi_expr => l_priority_json);',
'      end if;',
'      if l_due_on_json is not null then ',
'        l_due_on   := flow_settings.get_due_on (pi_prcs_id => p_process_id, pi_expr => l_due_on_json);',
'      end if;',
'      apex_debug.info (p_message => ''Process Priority : %0  Due On : %1'', p0 => l_priority, p1 => l_due_on );',
'    end;',
'',
'',
'    -- mark process as running',
'    update flow_processes prcs',
'       set prcs.prcs_status         = flow_constants_pkg.gc_prcs_status_running',
'         , prcs.prcs_start_ts       = systimestamp',
'         , prcs.prcs_last_update    = systimestamp',
'         , prcs.prcs_last_update_by =  coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'         , prcs.prcs_priority       = l_priority',
'         , prcs.prcs_due_on         = l_due_on',
'     where prcs.prcs_dgrm_id   = l_dgrm_id',
'       and prcs.prcs_id        = p_process_id',
'         ;    ',
'    -- log the start',
'    flow_logging.log_instance_event',
'    ( p_process_id => p_process_id',
'    , p_event      => flow_constants_pkg.gc_prcs_event_started',
'    );',
'    -- create the status for new subflow based on start subtype',
'    case',
'      when l_starting_object.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_timer_event_definition then',
'        l_new_subflow_status := flow_constants_pkg.gc_sbfl_status_waiting_timer;',
'      when (   l_starting_object.objt_sub_tag_name is null ',
'           or  l_starting_object.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_message_event_definition ) then',
'        l_new_subflow_status := flow_constants_pkg.gc_sbfl_status_running;',
'      else',
'        raise e_unsupported_start_event;',
'    end case;',
'',
'    l_main_subflow := flow_engine_util.subflow_start ',
'      ( p_process_id => p_process_id',
'      , p_parent_subflow => null',
'      , p_starting_object => l_starting_object.objt_bpmn_id',
'      , p_current_object  => l_starting_object.objt_bpmn_id',
'      , p_route => ''main''',
'      , p_last_completed => null',
'      , p_status => l_new_subflow_status ',
'      , p_parent_sbfl_proc_level => 0 ',
'      , p_new_proc_level => false',
'      , p_dgrm_id => l_dgrm_id',
'      );',
'',
'    apex_debug.info',
'    ( p_message => ''Initial Subflow created %0 with Step Key %1''',
'    , p0 => l_main_subflow.sbfl_id',
'    , p1 => l_main_subflow.step_key',
'    );',
'    if l_starting_object.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_timer_event_definition then ',
'      -- process any before-event variable expressions on the starting object',
'      flow_expressions.process_expressions',
'      ( pi_objt_bpmn_id   => l_starting_object.objt_bpmn_id',
'      , pi_set            => flow_constants_pkg.gc_expr_set_before_event',
'      , pi_prcs_id        => p_process_id',
'      , pi_sbfl_id        => l_main_subflow.sbfl_id',
'      , pi_var_scope      => l_main_subflow.scope',
'      , pi_expr_scope     => l_main_subflow.scope',
'      );',
'      -- test for any step errors',
'      if not flow_globals.get_step_error then ',
'        flow_timers_pkg.start_timer',
'        (',
'          pi_prcs_id    => p_process_id',
'        , pi_sbfl_id    => l_main_subflow.sbfl_id',
'        , pi_step_key   => l_main_subflow.step_key',
'        , pi_callback   => flow_constants_pkg.gc_bpmn_start_event',
'        ); ',
'      end if;       ',
'',
'    elsif (  l_starting_object.objt_sub_tag_name is null ',
'          or l_starting_object.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_message_event_definition ) then',
'      -- plain (none) startEvent or messageStartEvent',
'      -- process any variable expressions on the starting object',
'      flow_expressions.process_expressions',
'      ( pi_objt_bpmn_id  => l_starting_object.objt_bpmn_id',
'      , pi_set           => flow_constants_pkg.gc_expr_set_on_event',
'      , pi_prcs_id       => p_process_id',
'      , pi_sbfl_id       => l_main_subflow.sbfl_id',
'      , pi_var_scope     => l_main_subflow.scope',
'      , pi_expr_scope    => l_main_subflow.scope      ',
'      );',
'',
'      if not flow_globals.get_step_error then ',
'        -- step into first step',
'        flow_engine.flow_complete_step  ',
'        ( p_process_id => p_process_id',
'        , p_subflow_id => l_main_subflow.sbfl_id',
'        , p_step_key   => l_main_subflow.step_key',
'        , p_forward_route => null',
'        , p_recursive_call => false',
'        );',
'      end if;',
'    else ',
'      raise e_unsupported_start_event;',
'    end if;',
'',
'  exception',
'    when e_unsupported_start_event then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_process_id',
'      , pi_sbfl_id        => l_main_subflow.sbfl_id',
'      , pi_message_key    => ''start-type-unsupported''',
'      , p0                => l_starting_object.objt_sub_tag_name       ',
'      );',
'      -- $F4AMESSAGE ''start-type-unsupported'' || ''Unsupported start event type (%0). Only None (standard) Start Event, Message and Timer Start Event are currently supported.''',
'  end start_process;',
'',
'  procedure reset_process',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'    )',
'  is',
'    l_return_code   number;',
'    cursor c_lock_all is ',
'        select prcs.prcs_id, sbfl.sbfl_id, sflg.sflg_last_updated, prdg_id',
'          from flow_subflows sbfl',
'          join flow_processes prcs',
'            on prcs.prcs_id = sbfl.sbfl_prcs_id ',
'          join flow_subflow_log sflg ',
'            on prcs.prcs_id = sflg.sflg_prcs_id',
'          join flow_instance_diagrams prdg',
'            on prcs.prcs_id = prdg.prdg_prcs_id',
'          where prcs.prcs_id = p_process_id',
'          order by sbfl.sbfl_process_level, sbfl.sbfl_id',
'            for update of prcs.prcs_id, sbfl.sbfl_id, sflg.sflg_last_updated, prdg.prdg_id wait 2',
'    ;',
'  begin',
'    apex_debug.enter',
'    ( ''reset_process''',
'    , ''process_id'', p_process_id',
'    );',
'    -- lock all objects',
'    begin',
'      open c_lock_all;',
'      flow_timers_pkg.lock_process_timers ( pi_prcs_id => p_process_id );  ',
'      flow_message_util.lock_instance_subscriptions ( p_process_id => p_process_id );',
'      close c_lock_all;',
'    exception ',
'      when lock_timeout then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => p_process_id',
'        , pi_message_key    => ''process-lock-timeout''',
'        , p0 => p_process_id          ',
'        );',
'        -- $F4AMESSAGE ''process-lock-timeout'' || ''Process objects for %0 currently locked by another user.  Try again later.''',
'    end;',
'',
'    -- kill any timers still running in the process',
'    flow_timers_pkg.terminate_process_timers',
'    ( pi_prcs_id => p_process_id',
'    , po_return_code => l_return_code',
'    );  ',
'    -- cancel any message subscriptions',
'    flow_message_util.cancel_instance_subscriptions',
'    ( p_process_id => p_process_id',
'    );',
'    -- clear out run-time object_log',
'    delete',
'      from flow_subflow_log sflg ',
'     where sflg_prcs_id = p_process_id',
'    ;',
'    -- clean up iteration arrays',
'    delete',
'      from flow_iterated_objects',
'     where iobj_prcs_id = p_process_id',
'     ;',
'    -- delete the subflows',
'    delete',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_prcs_id = p_process_id',
'    ;',
'    -- delete all process variables except the builtins (new behaviour in 21.1)',
'    flow_proc_vars_int.delete_all_for_process ',
'    ( pi_prcs_id => p_process_id',
'    , pi_retain_builtins => true',
'    );',
'    -- reset the instance diagrams / call structure',
'    update flow_instance_diagrams prdg',
'    set prdg.prdg_diagram_level = null',
'    where prdg.prdg_prcs_id = p_process_id',
'      and prdg.prdg_diagram_level != 0',
'    ;',
'    -- reset the process status to ''created''',
'    update flow_processes prcs',
'       set prcs.prcs_status         = flow_constants_pkg.gc_prcs_status_created',
'         , prcs_start_ts            = null',
'         , prcs_complete_ts         = null',
'         , prcs_archived_ts         = null',
'         , prcs.prcs_last_update    = systimestamp',
'         , prcs.prcs_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'     where prcs.prcs_id = p_process_id',
'    ;',
'    -- log the reset',
'    flow_logging.log_instance_event',
'    ( p_process_id => p_process_id',
'    , p_event      => flow_constants_pkg.gc_prcs_event_reset',
'    , p_comment    => p_comment',
'    );',
'    commit;',
'  end reset_process;',
'',
'  procedure terminate_process',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'    )',
'  is',
'    l_return_code   number;',
'    cursor c_lock_all is ',
'      select prcs.prcs_id, sbfl.sbfl_id, sflg.sflg_last_updated',
'        from flow_subflows sbfl',
'        join flow_processes prcs',
'          on prcs.prcs_id = sbfl.sbfl_prcs_id ',
'        join flow_subflow_log sflg ',
'          on prcs.prcs_id = sflg.sflg_prcs_id',
'       where prcs.prcs_id = p_process_id',
'       order by sbfl.sbfl_process_level, sbfl.sbfl_id',
'         for update of prcs.prcs_id, sbfl.sbfl_id, sflg.sflg_last_updated wait 2;',
'  begin',
'    apex_debug.enter',
'    ( ''terminate_process''',
'    , ''process_id'', p_process_id',
'    );',
'    begin ',
'      -- lock all timers, logs, subflows and the process.  ',
'      open c_lock_all;',
'      flow_message_util.lock_instance_subscriptions ( p_process_id => p_process_id );',
'      flow_timers_pkg.lock_process_timers ( pi_prcs_id => p_process_id ); ',
'      close c_lock_all; ',
'    exception ',
'      when lock_timeout then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => p_process_id',
'        , pi_message_key    => ''process-lock-timeout''',
'        , p0 => p_process_id          ',
'        );',
'        -- $F4AMESSAGE ''process-lock-timeout'' || ''Process objects for %0 currently locked by another user.  Try again later.''',
'    end;',
'',
'    -- kill any message subscriptions or timers sill running in the process',
'    flow_message_util.cancel_instance_subscriptions ( p_process_id => p_process_id );',
'    flow_timers_pkg.delete_process_timers',
'    (',
'        pi_prcs_id => p_process_id',
'      , po_return_code => l_return_code',
'    );  ',
'    -- stop processing ',
'    flow_engine_util.terminate_level',
'    ( p_process_id => p_process_id',
'    , p_process_level => 0',
'    );',
'    apex_debug.info',
'    ( p_message => ''Flow Instance %0 terminated''',
'    , p0        => p_process_id',
'    );',
'    -- mark process as terminated',
'    update flow_processes prcs',
'       set prcs.prcs_status = flow_constants_pkg.gc_prcs_status_terminated',
'         , prcs.prcs_last_update = systimestamp',
'         , prcs.prcs_complete_ts = systimestamp',
'         , prcs.prcs_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'     where prcs.prcs_id = p_process_id',
'    ; ',
'    -- log termination',
'    flow_logging.log_instance_event',
'    ( p_process_id => p_process_id',
'    , p_event      => flow_constants_pkg.gc_prcs_event_terminated',
'    , p_comment    => p_comment',
'    );',
'    -- finalize',
'    commit;',
'  end terminate_process;',
'',
'  procedure delete_process',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'    )',
'  is',
'    l_return_code             number;',
'    l_is_not_archived         boolean := false;',
'    l_cur_prcs_id             flow_processes.prcs_id%type;',
'    l_cur_sbfl_id             flow_subflows.sbfl_id%type;',
'    l_cur_sflg_updated        flow_subflow_log.sflg_last_updated%type;',
'    l_cur_prdg_id             flow_instance_diagrams.prdg_id%type;',
'    l_cur_prcs_archived_ts    flow_processes.prcs_archived_ts%type;',
'    cursor c_lock_all is ',
'      select prcs.prcs_id, sbfl.sbfl_id, sflg.sflg_last_updated, prdg.prdg_id, prcs.prcs_archived_ts',
'        from flow_subflows sbfl',
'        join flow_processes prcs',
'          on prcs.prcs_id = sbfl.sbfl_prcs_id ',
'        join flow_subflow_log sflg ',
'          on prcs.prcs_id = sflg.sflg_prcs_id',
'        join flow_instance_diagrams prdg',
'          on prcs.prcs_id = prdg.prdg_prcs_id',
'       where prcs.prcs_id = p_process_id',
'       order by sbfl.sbfl_process_level, sbfl.sbfl_id',
'         for update of prcs.prcs_id, sbfl.sbfl_id, sflg.sflg_last_updated, prdg.prdg_id wait 2;',
'  begin',
'    apex_debug.enter',
'    ( ''delete_process''',
'    , ''process_id'', p_process_id',
'    );',
'    begin ',
'      -- lock all timers, logs, subflows, instance diagrams and the process',
'      open c_lock_all;',
'      fetch c_lock_all into l_cur_prcs_id',
'                          , l_cur_sbfl_id',
'                          , l_cur_sflg_updated',
'                          , l_cur_prdg_id',
'                          , l_cur_prcs_archived_ts;',
'      flow_message_util.lock_instance_subscriptions (p_process_id => p_process_id);',
'      flow_timers_pkg.lock_process_timers',
'      ( pi_prcs_id => p_process_id',
'      ); ',
'      if l_cur_prcs_archived_ts is null then',
'        l_is_not_archived := true;',
'      end if;',
'      close c_lock_all; ',
'',
'    exception ',
'      when lock_timeout then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => p_process_id',
'        , pi_message_key    => ''process-lock-timeout''',
'        , p0 => p_process_id          ',
'        );',
'        -- $F4AMESSAGE ''process-lock-timeout'' || ''Process objects for %0 currently locked by another user.  Try again later.''',
'    end;',
'    -- log the deletion before process data deleted',
'    flow_logging.log_instance_event',
'    ( p_process_id => p_process_id',
'    , p_event      => flow_constants_pkg.gc_prcs_event_deleted',
'    , p_comment    => p_comment',
'    );',
'    -- kill any message subscriptions or  timers still running in the instance',
'    flow_message_util.cancel_instance_subscriptions (p_process_id => p_process_id);',
'    flow_timers_pkg.delete_process_timers(',
'        pi_prcs_id => p_process_id',
'      , po_return_code => l_return_code',
'    );  ',
'    -- if instance archiving is enabled and instance is not yet archived, run instance archive now before',
'    -- process data is deleted from run time tables to ensure arcchive is full audit trail',
'    if l_is_not_archived then',
'      if flow_engine_util.get_config_value ( p_config_key => flow_constants_pkg.gc_config_logging_archive_enabled ',
'                                           , p_default_value => flow_constants_pkg.gc_config_default_logging_archive_enabled',
'                                           ) = ''true'' ',
'      then',
'        flow_log_admin.archive_completed_instances (p_process_id ='))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'> p_process_id);',
'      end if;',
'    end if;',
'    -- clear out run-time object_log',
'    delete',
'      from flow_subflow_log sflg ',
'     where sflg_prcs_id = p_process_id',
'    ;',
'    -- clear out any iterations',
'    delete',
'      from flow_iterated_objects',
'     where iobj_prcs_id = p_process_id',
'     ;',
'    delete',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_prcs_id = p_process_id',
'    ;',
'    flow_proc_vars_int.delete_all_for_process ',
'    ( pi_prcs_id => p_process_id',
'    , pi_retain_builtins => false',
'    );',
'    delete ',
'      from flow_instance_diagrams prdg',
'     where prdg_prcs_id = p_process_id',
'    ;',
'    delete',
'      from flow_processes prcs',
'     where prcs.prcs_id = p_process_id',
'    ;',
'',
'    commit;',
'  end delete_process;',
'',
'  procedure set_priority',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_priority    in flow_processes.prcs_priority%type',
'    )',
'  is',
'  begin',
'      update flow_processes prcs',
'      set prcs.prcs_priority = p_priority',
'        , prcs.prcs_last_update = systimestamp',
'        , prcs.prcs_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                              , sys_context(''userenv'',''os_user'')',
'                                              , sys_context(''userenv'',''session_user'')',
'                                              )  ',
'      where prcs.prcs_id = p_process_id;',
'      -- log the priority change',
'      flow_logging.log_instance_event',
'      ( p_process_id => p_process_id',
'      , p_event      => flow_constants_pkg.gc_prcs_event_priority_set',
'      , p_comment    => ''Priority set to ''||p_priority',
'      );      ',
'  end set_priority;',
'',
'  function priority',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    ) return flow_processes.prcs_priority%type',
'  is',
'      l_priority    flow_processes.prcs_priority%type;',
'  begin',
'      select prcs_priority',
'        into l_priority',
'        from flow_processes',
'       where prcs_id = p_process_id;',
'      return l_priority;',
'  end priority;',
'',
'  procedure set_due_on',
'    (',
'      p_process_id  in flow_processes.prcs_id%type',
'    , p_due_on      in flow_processes.prcs_due_on%type',
'    )',
'  is',
'  begin',
'      update flow_processes prcs',
'      set prcs.prcs_due_on = p_due_on',
'        , prcs.prcs_last_update = systimestamp',
'        , prcs.prcs_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                              , sys_context(''userenv'',''os_user'')',
'                                              , sys_context(''userenv'',''session_user'')',
'                                              )  ',
'      where prcs.prcs_id = p_process_id;',
'      -- log the priority change',
'      flow_logging.log_instance_event',
'      ( p_process_id => p_process_id',
'      , p_event      => flow_constants_pkg.gc_prcs_event_due_on_set',
'      , p_comment    => ''Instance Due On set to ''||to_char(p_due_on, flow_constants_pkg.gc_prov_default_tstz_format)',
'      );  ',
'  end set_due_on;',
'',
'  function due_on',
'    ( p_process_id  in flow_processes.prcs_id%type',
'    ) return flow_processes.prcs_due_on%type',
'  is',
'      l_due_on    flow_processes.prcs_due_on%type;',
'  begin',
'      select prcs_due_on',
'        into l_due_on',
'        from flow_processes',
'       where prcs_id = p_process_id;',
'      return l_due_on;',
'  end due_on;',
'',
'end flow_instances;',
'/',
'',
'create or replace package body flow_engine as ',
'/* ',
'-- Flows for APEX - flow_engine.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2020-2022.',
'-- (c) Copyright Flowquest Limited. 2024.',
'--',
'-- Created  11-Sep-2020  Richard Allen (Flowquest)',
'-- Modified 30-May-2022  Moritz Klein (MT AG)',
'-- Modified 09-Jan-2024  Richard Allen, Flowquest Ltd',
'--',
'*/',
'',
'  lock_timeout exception;',
'  pragma exception_init (lock_timeout, -3006);',
'',
'  e_feature_requires_ee exception;',
'',
'  function flow_get_matching_link_object',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , pi_dgrm_id      in flow_diagrams.dgrm_id%type ',
'  , pi_link_bpmn_id in flow_objects.objt_name%type',
'  ) return varchar2',
'  is ',
'      l_matching_catch_event  flow_objects.objt_bpmn_id%type;',
'  begin ',
'      select catch_objt.objt_bpmn_id',
'        into l_matching_catch_event',
'        from flow_objects catch_objt',
'        join flow_objects throw_objt',
'          on catch_objt.objt_name = throw_objt.objt_name',
'          and catch_objt.objt_dgrm_id = throw_objt.objt_dgrm_id',
'          and catch_objt.objt_objt_id = throw_objt.objt_objt_id',
'        where throw_objt.objt_dgrm_id = pi_dgrm_id',
'          and throw_objt.objt_bpmn_id = pi_link_bpmn_id',
'          and catch_objt.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_link_event_definition',
'          and throw_objt.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_link_event_definition',
'          and catch_objt.objt_tag_name = flow_constants_pkg.gc_bpmn_intermediate_catch_event        ',
'          and throw_objt.objt_tag_name = flow_constants_pkg.gc_bpmn_intermediate_throw_event   ',
'          ;',
'      return l_matching_catch_event;',
'  exception',
'    when no_data_found then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => p_subflow_id',
'        , pi_message_key => ''link-no-catch''',
'        , p0 => pi_link_bpmn_id',
'        );',
'        return null;',
'        -- $F4AMESSAGE ''link-no-catch'' || ''Unable to find matching link catch event named %0.''  ',
'    when too_many_rows then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => p_subflow_id',
'        , pi_message_key => ''link-too-many-catches''',
'        , p0 => pi_link_bpmn_id',
'        );',
'        return null;',
'        -- $F4AMESSAGE ''link-too-many-catches'' || ''More than one matching link catch event named %0.''  ',
'  end flow_get_matching_link_object;',
'',
'procedure flow_process_link_event',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'is ',
'    l_next_objt      flow_objects.objt_bpmn_id%type;',
'begin ',
'    apex_debug.enter ',
'    ( ''flow_process_link_event''',
'    , ''Process'', p_process_id',
'    , ''Subflow'', p_subflow_id',
'    );',
'    -- find matching link catching event and step to it',
'    l_next_objt := flow_get_matching_link_object ',
'      ( p_process_id    => p_process_id',
'      , p_subflow_id    => p_subflow_id',
'      , pi_dgrm_id      => p_step_info.dgrm_id',
'      , pi_link_bpmn_id => p_step_info.target_objt_ref',
'      );',
'  ',
'    -- proceed if link found cleanly',
'    if not flow_globals.get_step_error then',
'      -- update current step info before logging',
'      update flow_subflows sbfl',
'          set sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'            , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'            , sbfl.sbfl_last_update    = systimestamp',
'            , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )  ',
'        where sbfl.sbfl_id = p_subflow_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'      ;',
'      -- log throw event as complete',
'      flow_logging.log_step_completion   ',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_completed_object => p_step_info.target_objt_ref',
'      );',
'      -- jump into matching catch event',
'      update flow_subflows sbfl',
'      set   sbfl.sbfl_current        = l_next_objt',
'          , sbfl.sbfl_last_completed = p_step_info.target_objt_ref',
'          , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'          , sbfl.sbfl_became_current = systimestamp ',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'      where sbfl.sbfl_id = p_subflow_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'      ;',
'      -- pass the step_key through unchanged and use on the receiving ICE',
'      flow_complete_step',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_step_key   => p_sbfl_info.sbfl_step_key',
'      );',
'    else',
'      apex_debug.error(p_message  => ''error finding matching link object found'');    ',
'    end if;',
'end flow_process_link_event;',
'',
'--============================================================================================',
'--  B P M N   O B J E C T   P R O C E S S O R S ',
'--============================================================================================',
'',
'',
'  procedure process_endEvent',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is',
'    l_sbfl_context_par      flow_types_pkg.t_subflow_context;  ',
'    -- l_boundary_event        flow_objects.objt_bpmn_id%type;',
'    -- l_subproc_objt          flow_objects.objt_bpmn_id%type;',
'    l_exit_type             flow_objects.objt_sub_tag_name%type default null;',
'    l_remaining_subflows    number;',
'    l_process_end_status    flow_processes.prcs_status%type;',
'    -- l_parent_step_key       flow_subflows.sbfl_step_key%type;',
'    l_calling_subflow       flow_subflows.sbfl_id%type;   -- expected temporary variable',
'  begin',
'    apex_debug.enter ',
'    ( ''process_endEvent''',
'    , ''Process'', p_process_id',
'    , ''Subflow'', p_subflow_id',
'    );',
'    --next step can be either end of process, end of a call activity, or a sub-process returning to its parent',
'    -- get parent subflow',
'    l_sbfl_context_par := flow_engine_util.get_subprocess_parent_subflow',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_current    => p_sbfl_info.sbfl_current',
'      );',
'    -- process any variable expressions in the onEvent set',
'    flow_expressions.process_expressions',
'    ( pi_objt_id     => p_step_info.target_objt_id',
'    , pi_set         => flow_constants_pkg.gc_expr_set_on_event',
'    , pi_prcs_id     => p_process_id',
'    , pi_sbfl_id     => p_subflow_id',
'    , pi_var_scope   => p_sbfl_info.sbfl_scope',
'    , pi_expr_scope  => p_sbfl_info.sbfl_scope',
'    );',
'    -- check for message throw end Event',
'    if p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_message_event_definition then',
'      $IF flow_apex_env.ee $THEN',
'        flow_message_util_ee.end_event_send_message',
'        ( p_sbfl_info  => p_sbfl_info',
'        , p_step_info  => p_step_info',
'        ); ',
'      $ELSE',
'        raise e_feature_requires_ee;',
'      $END ',
'    end if;',
'',
'    -- update the subflow before logging',
'     update flow_subflows sbfl',
'        set sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'          , sbfl.sbfl_current        = p_step_info.target_objt_ref',
'          , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_completed  ',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'      where sbfl.sbfl_id = p_subflow_id',
'        and sbfl.sbfl_prcs_id = p_process_id',
'    ;',
'    -- log the current endEvent as completed',
'    flow_logging.log_step_completion',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_completed_object => p_step_info.target_objt_ref',
'      );  ',
'',
'    if p_sbfl_info.sbfl_calling_sbfl = 0 then   ',
'      -- in a top level process on the starting diagram',
'      apex_debug.info ',
'      ( p_message => ''Next Step is Process End %0''',
'      , p0        => p_step_info.target_objt_ref ',
'      );',
'      -- check for Terminate sub-Event',
'      if p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_terminate_event_definition then',
'        -- get desired process status after termination from model',
'        select coalesce( objt.objt_attributes."processStatus", flow_constants_pkg.gc_prcs_status_completed )',
'          into l_process_end_status',
'          from flow_objects objt',
'         where objt.objt_id = p_step_info.target_objt_id',
'        ;',
'        -- terminate the main level',
'        flow_engine_util.terminate_level',
'        ( ',
'          p_process_id     => p_process_id',
'        , p_process_level  => p_sbfl_info.sbfl_process_level',
'        );',
'      else ',
'        -- top process level but not a terminate end...',
'        flow_engine_util.subflow_complete',
'        ( p_process_id => p_process_id',
'        , p_subflow_id => p_subflow_id',
'        );',
'        l_process_end_status := flow_constants_pkg.gc_prcs_status_completed;',
'      end if;',
'',
'      -- check if there are ANY remaining subflows.  If not, close process',
'      select count(*)',
'        into l_remaining_subflows',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_prcs_id = p_process_id;',
'      ',
'      if l_remaining_subflows = 0 then ',
'',
'        update flow_processes prcs ',
'           set prcs.prcs_status         = l_process_end_status',
'             , prcs.prcs_last_update    = systimestamp',
'             , prcs.prcs_complete_ts    = systimestamp',
'             , prcs.prcs_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                    , sys_context(''userenv'',''os_user'')',
'                                                    , sys_context(''userenv'',''session_user'')',
'                                                    )  ',
'         where prcs.prcs_id = p_process_id',
'        ;',
'        -- log the completion',
'        flow_logging.log_instance_event',
'        ( p_process_id => p_process_id',
'        , p_event      => l_process_end_status',
'        );',
'        apex_debug.info ',
'        ( p_message => ''Process Completed with %1 Status: Process %0  ''',
'        , p0        => p_process_id',
'        , p1        => l_process_end_status',
'        );',
'',
'      end if;',
'    else  ',
'      -- in a lower process level (subProcess or CallActivity on another diagram) - process the Process Level endEvent (ouch)',
'      flow_subprocesses.process_process_level_endEvent',
'        ( p_process_id        => p_process_id',
'        , p_subflow_id        => p_subflow_id',
'        , p_sbfl_info         => p_sbfl_info',
'        , p_step_info         => p_step_info',
'        , p_sbfl_context_par  => l_sbfl_context_par',
'        );',
'    end if; ',
'  end process_endEvent;',
'',
'  procedure process_intermediateCatchEvent',
'  ( p_sbfl_info  in flow_subflows%rowtype',
'  , p_step_info  in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'    l_new_status        flow_subflows.sbfl_status%type;',
'    l_msg_sub           flow_message_flow.t_subscription_details;',
'    l_msub_id           flow_message_subscriptions.msub_id%type;',
'  begin',
'    -- then we make everything behave like a simple activity unless specifically supported',
'    -- currently only supports timer and without checking its type is timer',
'    -- but this will have a case type = timer, emailReceive. ....',
'    -- this is currently just a stub.',
'    apex_debug.enter',
'    ( ''process_IntermediateCatchEvent''',
'    , ''p_step_info.target_objt_ref'', p_step_info.target_objt_ref',
'    );',
'',
'    case p_step_info.target_objt_subtag ',
'    when flow_constants_pkg.gc_bpmn_timer_event_definition then',
'      -- we have a timer.  Set status to waiting and schedule the timer.',
'      l_new_status  := flow_constants_pkg.gc_sbfl_status_waiting_timer;',
'',
'      flow_timers_pkg.start_timer',
'      ( ',
'        pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'      , pi_step_key     => p_sbfl_info.sbfl_step_key',
'      , pi_callback     => flow_constants_pkg.gc_bpmn_intermediate_catch_event',
'      );',
'    when flow_constants_pkg.gc_bpmn_message_event_definition then    ',
'      -- message catch event',
'      l_new_status  := flow_constants_pkg.gc_sbfl_status_waiting_message;',
'',
'      l_msg_sub            := flow_message_util.get_msg_subscription_details',
'                              ( p_msg_object_bpmn_id      => p_step_info.target_objt_ref',
'                              , p_dgrm_id                 => p_sbfl_info.sbfl_dgrm_id',
'                              , p_sbfl_info               => p_sbfl_info',
'                              );',
'      l_msg_sub.callback  := flow_constants_pkg.gc_bpmn_intermediate_catch_event;',
'',
'      -- create subscription for the awaited message ',
'      l_msub_id := flow_message_flow.subscribe ( p_subscription_details => l_msg_sub);',
'    else',
'      -- not a timer.  Just set it to running for now.  (other types to be implemented later)',
'      -- this includes bpmn:linkEventDefinition which should come here',
'      l_new_status  := flow_constants_pkg.gc_sbfl_status_running;',
'    end case;',
'',
'    update flow_subflows sbfl',
'       set sbfl.sbfl_current        = p_step_info.target_objt_ref',
'         , sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'         , sbfl.sbfl_status         = l_new_status',
'         , sbfl.sbfl_last_update    = systimestamp',
'         , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                               , sys_context(''userenv'',''os_user'')',
'                                               , sys_context(''userenv'',''session_user'')',
'                                               )  ',
'     where sbfl.sbfl_id = p_sbfl_info.sbfl_id',
'       and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'    ;',
'  end process_intermediateCatchEvent;',
'',
'  procedure process_intermediateThrowEvent',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'    l_par_sbfl            flow_types_pkg.t_subflow_context;',
'    l_injected_step_key   flow_subflows.sbfl_step_key%type;',
'    l_is_interrupting     boolean;',
'  begin',
'    -- currently  supports none, link, and escalation Intermediate throw event ',
'    -- but this might later have other case type =  message throw, etc. ....',
'    apex_debug.enter ',
'    ( ''process_IntermediateThrowEvent''',
'    , ''p_step_info.target_objt_ref'', p_step_info.target_objt_ref',
'    );',
'    -- process on-event expressions for the ITE',
'    flow_expressions.process_expressions',
'    ( pi_objt_id      => p_step_info.target_objt_id  ',
'    , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'    , pi_prcs_id      => p_sbfl_info.sbfl_prcs_id',
'    , pi_sbfl_id      => p_sbfl_info.sbfl_id',
'    , pi_var_scope    => p_sbfl_info.sbfl_scope',
'    , pi_expr_scope   => p_sbfl_info.sbfl_scope',
'    );',
'',
'    if p_step_info.target_objt_subtag is null then',
'      -- a none event.  Make the ITE the current event then just call flow_complete_step.  ',
'      update flow_subflows sbfl',
'      set   sbfl.sbfl_current        = p_step_info.target_objt_ref',
'          , sbfl.sbfl_last_completed = p_sbfl_info.sbfl_last_completed',
'          , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'      where sbfl.sbfl_id      = p_sbfl_info.sbfl_id',
'        and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'      ;',
'      flow_complete_step',
'      ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_info.sbfl_id',
'      , p_step_key   => p_sbfl_info.sbfl_step_key',
'      );',
'    elsif p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_link_event_definition then',
'      flow_process_link_event',
'      ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_info.sbfl_id',
'      , p_sbfl_info  => p_sbfl_info',
'      , p_step_info  => p_step_info',
'      );   ',
'    elsif p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_message_event_definition then',
'      flow_message_flow.send_message',
'      ( p_sbfl_info  => p_sbfl_info',
'      , p_step_info  => p_step_info',
'      );',
'      flow_complete_step',
'      ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_info.sbfl_id',
'      , p_step_key   => p_sbfl_info.sbfl_step_key',
'      );',
'    elsif p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_escalation_event_definition then',
'      -- make the ITE the current step',
'      update  flow_subflows sbfl',
'          set sbfl.sbfl_current = p_step_info.target_objt_ref',
'            , sbfl.sbfl_last_completed = p_sbfl_info.sbfl_current',
'            , sbfl.sbfl_last_update = systimestamp',
'            , sbfl.sbfl_status = flow_constants_pkg.gc_sbfl_status_running',
'        where sbfl.sbfl_id = p_sbfl_info.sbfl_id',
'          and sbfl.sbfl_prcs_id = p_sbfl_info.sbfl_prcs_id',
'      ;',
'      -- find the subProcess event in the parent level',
'      l_par_sbfl := flow_engine_util.get_subprocess_parent_subflow',
'      ( p_process_id => p_sbfl_info.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_info.sbfl_id',
'      , p_current => p_step_info.target_objt_ref',
'      );',
'      -- escalate it to the boundary Event',
'      flow_boundary_events.process_escalation',
'      ( pi_sbfl_info        => p_sbfl_info',
'      , pi_step_info        => p_step_info',
'      , pi_par_sbfl         => l_par_sbfl.sbfl_id',
'      , pi_source_type      => flow_constants_pkg.gc_bpmn_intermediate_throw_event',
'      , po_step_key         => l_injected_step_key',
'      , po_is_interrupting  => l_is_interrupting',
'      ); ',
'',
'    else ',
'      --- other type of intermediateThrowEvent that is not currently supported',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_sbfl_info.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_info.sbfl_id',
'      , pi_message_key => ''ITE-unsupported-type''',
'      , p0 => p_sbfl_info.sbfl_current',
'      );',
'      -- $F4AMESSAGE ''ITE-unsupported-type'' || ''Currently unsupported type of Intermediate Throw Event encountered at %0 .''  ',
'    end if;',
'end process_intermediateThrowEvent;',
'',
'',
'/* ',
'================================================================================',
'   E V E N T   H A N D L I N G ',
'================================================================================',
'*/',
'',
'procedure handle_event_gateway_event',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  , p_parent_subflow_id  in flow_subflows.sbfl_id%type',
'  , p_cleared_subflow_id in flow_subflows.sbfl_id%type',
'  )',
'is ',
'    l_forward_route         flow_connections.conn_id%type;',
'    l_current_object        flow_subflows.sbfl_current%type;',
'    l_child_starting_object flow_subflows.sbfl_starting_object%type;',
'    l_parent_sbfl           flow_subflows.sbfl_id%type;',
'    l_timestamp             flow_subflows.sbfl_became_current%type;',
'    l_forward_step_key      flow_subflows.sbfl_step_key%type;',
'    l_return                varchar2(50);',
'begin',
'    -- called from any event that has cleared (so expired timer, received message or signal, etc) to move eBG forwards',
'    -- procedure has to:',
'    -- - check that gateway has not already been cleared by another event',
'    -- - resume the incoming subflow on the path of the first event to occur and call next_step',
'    -- - stop / terminate all of the child subflows that were created to wait for other events',
'    -- - including making sure any timers, message receivers, etc., are cleared up.',
'',
'    apex_debug.enter',
'    ( ''handle_event_gateway_event'' ',
'    , ''p_process_id'', p_process_id',
'    , ''parent_subflow'', p_parent_subflow_id',
'    , ''p_cleared_subflow_id'', p_cleared_subflow_id',
'    );',
'    begin',
'      select sbfl.sbfl_id',
'        into l_parent_sbfl',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_id = p_parent_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'         and sbfl.sbfl_status =  flow_constants_pkg.gc_sbfl_status_split  ',
'          ;',
'    exception',
'       when no_data_found then',
'        -- gateway aready cleared',
'         raise; ',
'    end;',
'    -- make the incoming (main) (split) parent subflow proceed along the path of the cleared event.clear(',
'    ',
'     select conn.conn_id',
'          , sbfl.sbfl_current',
'          , sbfl.sbfl_starting_object',
'       into l_forward_route',
'          , l_current_object',
'          , l_child_starting_object',
'       from flow_objects objt',
'       join flow_subflows sbfl ',
'         on sbfl.sbfl_current = objt.objt_bpmn_id',
'        and sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'       join flow_connections conn ',
'         on conn.conn_src_objt_id = objt.objt_id',
'        and conn.conn_dgrm_id = sbfl.sbfl_dgrm_id',
'      where sbfl.sbfl_id = p_cleared_subflow_id',
'        and sbfl.sbfl_prcs_id = p_process_id',
'        and conn.conn_tag_name = flow_constants_pkg.gc_bpmn_sequence_flow',
'          ; ',
'    -- generate a step key and insert in the update...use later',
'',
'    l_forward_step_key := flow_engine_util.step_key ( pi_sbfl_id   => p_parent_subflow_id',
'                                                    , pi_current => l_current_object',
'                                                    );',
'    l_timestamp := systimestamp;',
'',
'     update flow_subflows sbfl',
'        set sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'          , sbfl_current        = l_current_object',
'          , sbfl_last_completed = l_child_starting_object',
'          , sbfl_became_current = l_timestamp',
'          , sbfl_step_key       = l_forward_step_key',
'          , sbfl_last_update    = l_timestamp ',
'          , sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                           , sys_context(''userenv'',''os_user'')',
'                                           , sys_context(''userenv'',''session_user'')',
'                                           )  ',
'      where sbfl.sbfl_prcs_id = p_process_id',
'        and sbfl.sbfl_id = p_parent_subflow_id',
'        and sbfl.sbfl_status =  flow_constants_pkg.gc_sbfl_status_split  ',
'          ;',
'    -- now clear up all of the sibling subflows',
'    begin',
'      for child_subflows in (',
'        select sbfl.sbfl_id',
'             , sbfl.sbfl_current',
'             , objt.objt_sub_tag_name',
'          from flow_subflows sbfl',
'          join flow_objects objt ',
'            on objt.objt_bpmn_id = sbfl.sbfl_current',
'           and objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'         where sbfl.sbfl_sbfl_id = p_parent_subflow_id',
'           and sbfl.sbfl_starting_object = l_child_starting_object',
'           and sbfl.sbfl_prcs_id = p_process_id',
'      )',
'      loop',
'        -- clean up any event handlers (timers, etc.) (add more here when supporting messageEvent, SignalEvent, etc.)',
'        if child_subflows.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_timer_event_definition then',
'          flow_timers_pkg.terminate_timer',
'            ( pi_prcs_id => p_process_id',
'            , pi_sbfl_id => child_subflows.sbfl_id',
'            , po_return_code => l_return',
'            );',
'        end if;',
'        -- delete the completed subflow and log it as complete',
'            ',
'        delete',
'          from flow_subflows sbfl',
'         where sbfl.sbfl_prcs_id = p_process_id',
'           and sbfl.sbfl_id = child_subflows.sbfl_id',
'            ;',
'        -- logging - tbd',
'      end loop;',
'    end;  -- cleanup block',
'    -- now step forward on the forward path',
'    flow_complete_step           ',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_parent_subflow_id',
'    , p_step_key   => l_forward_step_key',
'    , p_forward_route => null',
'    );',
'end handle_event_gateway_event;',
'',
'procedure handle_intermediate_catch_event',
'  ( p_process_id   in flow_processes.prcs_id%type',
'  , p_subflow_id   in flow_subflows.sbfl_id%type',
'  , p_step_key     in flow_subflows.sbfl_step_key%type',
'  , p_current_objt in flow_subflows.sbfl_current%type',
'  ) ',
'is',
'  l_sbfl_scope    flow_subflows.sbfl_scope%type;',
'begin',
'  apex_debug.enter',
'  ( ''handle_intermediate_catch_event''',
'  , ''Subflow'', p_subflow_id',
'  , ''Step Key'', p_step_key',
'  );',
'  update flow_subflows sbfl ',
'     set sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'       , sbfl.sbfl_last_update    = systimestamp',
'       , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                             , sys_context(''userenv'',''os_user'')',
'                                             , sys_context(''userenv'',''session_user'')',
'                                             )  ',
'   where sbfl.sbfl_prcs_id = p_process_id',
'     and sbfl.sbfl_id = p_subflow_id',
'  returning sbfl_scope into l_sbfl_scope',
'  ;',
'  --  process any variable expressions in the OnEvent set',
'  flow_expressions.process_expressions',
'  ( pi_objt_bpmn_id => p_current_objt  ',
'  , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'  , pi_prcs_id      => p_process_id',
'  , pi_sbfl_id      => p_subflow_id',
'  , pi_var_scope    => l_sbfl_scope',
'  , pi_expr_scope   => l_sbfl_scope',
'  );',
'  -- test for any errors so far ',
'  if flow_globals.get_step_error then ',
'    -- has step errors from expressions',
'    flow_errors.set_error_status',
'    ( pi_prcs_id => p_process_id',
'    , pi_sbfl_id => p_subflow_id',
'    );',
'  else',
'    -- move onto next step',
'    flow_complete_step ',
'    ( p_process_id => p_p'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rocess_id',
'    , p_subflow_id => p_subflow_id',
'    , p_step_key   => p_step_key',
'    , p_forward_route => null',
'    );',
'  end if;  ',
'end handle_intermediate_catch_event;',
'',
'procedure create_repeat_subflow ',
'  ( p_process_id      in flow_processes.prcs_id%type',
'  , p_last_subflow_id in flow_subflows.sbfl_id%type',
'  , p_timr_id         in flow_timers.timr_id%type default null',
'  , p_next_run        in flow_timers.timr_run%type default null',
'  )',
'is',
'  l_new_subflow_context  flow_types_pkg.t_subflow_context;',
'  l_last_subflow         flow_subflows%rowtype;',
'begin',
'  select * ',
'    into l_last_subflow',
'    from flow_subflows',
'   where sbfl_id = p_last_subflow_id',
'     and sbfl_prcs_id = p_process_id',
'  ;',
'',
'  l_new_subflow_context := flow_engine_util.subflow_start',
'          (',
'            p_process_id      => p_process_id',
'          , p_parent_subflow  => l_last_subflow.sbfl_sbfl_id',
'          , p_starting_object => l_last_subflow.sbfl_starting_object',
'          , p_current_object  => l_last_subflow.sbfl_starting_object',
'          , p_route           => ''from boundary event - run ''||to_char(p_next_run)',
'          , p_last_completed  => l_last_subflow.sbfl_last_completed',
'          , p_status          => flow_constants_pkg.gc_sbfl_status_waiting_timer',
'          , p_parent_sbfl_proc_level => l_last_subflow.sbfl_process_level',
'          , p_dgrm_id                => l_last_subflow.sbfl_dgrm_id',
'          );',
'',
'  flow_timers_pkg.start_timer',
'  ( pi_prcs_id      => p_process_id',
'  , pi_sbfl_id      => l_new_subflow_context.sbfl_id',
'  , pi_step_key     => l_new_subflow_context.step_key',
'  , pi_callback     => flow_constants_pkg.gc_bpmn_intermediate_catch_event',
'  , pi_callback_par => ''non-interrupting'' ',
'  , pi_timr_id      => p_timr_id',
'  , pi_run          => p_next_run',
'  );',
'',
'  if not flow_globals.get_step_error then ',
'      -- set timer flag on child (Self, Noninterrupting, Timer)',
'      update flow_subflows sbfl',
'          set sbfl.sbfl_has_events     = sbfl.sbfl_has_events||'':SNT''',
'            , sbfl.sbfl_last_update    = systimestamp',
'            , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )  ',
'        where sbfl.sbfl_id = l_new_subflow_context.sbfl_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'      ;',
'  end if;',
'    ',
'end create_repeat_subflow;',
'',
'procedure timer_callback',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  , p_step_key   in flow_subflows.sbfl_step_key%type',
'  , p_timr_id    in flow_timers.timr_id%type default null',
'  , p_run        in flow_timers.timr_run%type default null',
'  , p_callback      in flow_timers.timr_callback%type default null',
'  , p_callback_par  in flow_timers.timr_callback_par%type default null',
'  , p_event_type    in flow_objects.objt_sub_tag_name%type',
'  ) ',
'is',
'  l_parent_subflow          flow_subflows.sbfl_id%type;',
'  l_prev_objt_tag_name      flow_objects.objt_tag_name%type;',
'  l_curr_objt_tag_name      flow_objects.objt_tag_name%type;',
'  l_curr_objt_sub_tag_name  flow_objects.objt_sub_tag_name%type;',
'  l_sbfl_current            flow_subflows.sbfl_current%type;',
'  l_follows_ebg             flow_subflows.sbfl_is_following_ebg%type;',
'begin',
'  -- currently handles callbacks from flow_timers and flow_message_flow when a timer fires / message is received',
'  apex_debug.enter ',
'  ( ''flow_handle_event''',
'  , ''subflow_id'',     p_subflow_id',
'  , ''process_id'',     p_process_id',
'  , ''event_type'',     p_event_type',
'  , ''p_callback'',     p_callback',
'  , ''p_callback_par'', p_callback_par',
'  );',
'  -- look at current event to check if it is a startEvent.  (this also has no previous event!)',
'  -- if not, examine previous event on the subflow to determine if it was eventBasedGateway (eBG)',
'  -- an intermediateCatchEvent (iCE) following an eBG will always have exactly 1 input (from the eBG)',
'  -- an independant iCE (not following an eBG) can have >1 inputs',
'  -- so look for preceding eBG.  If previous event not eBG or there are multiple prev events, it did not follow an eBG.',
'',
'  -- set context for scripts and variable expressions',
'  flow_globals.set_context',
'  ( pi_prcs_id  => p_process_id',
'  , pi_sbfl_id  => p_subflow_id',
'  , pi_step_key => p_step_key',
'  , pi_scope    => flow_engine_util.get_scope (p_process_id => p_process_id, p_subflow_id => p_subflow_id)',
'  );',
'  flow_globals.set_is_recursive_step (p_is_recursive_step => true);',
'  -- initialise step_had_error flag',
'  flow_globals.set_step_error ( p_has_error => false);',
'',
'',
'  -- lock subflow containing event',
'  if flow_engine_util.lock_subflow(p_subflow_id) then',
'    -- subflow_locked',
'    select curr_objt.objt_tag_name',
'         , curr_objt.objt_sub_tag_name',
'         , sbfl.sbfl_sbfl_id',
'         , sbfl.sbfl_current',
'         , sbfl.sbfl_is_following_ebg',
'      into l_curr_objt_tag_name',
'         , l_curr_objt_sub_tag_name',
'         , l_parent_subflow',
'         , l_sbfl_current',
'         , l_follows_ebg',
'      from flow_objects curr_objt ',
'      join flow_subflows sbfl ',
'        on sbfl.sbfl_current = curr_objt.objt_bpmn_id',
'       and sbfl.sbfl_dgrm_id = curr_objt.objt_dgrm_id',
'     where sbfl.sbfl_id = p_subflow_id',
'       and sbfl.sbfl_prcs_id = p_process_id',
'        ;',
'',
'    if l_curr_objt_tag_name = flow_constants_pkg.gc_bpmn_start_event then',
'      -- startEvent with associated event.',
'      handle_intermediate_catch_event -- startEvent behaves same as ICE',
'      (',
'        p_process_id   => p_process_id',
'      , p_subflow_id   => p_subflow_id',
'      , p_step_key     => p_step_key',
'      , p_current_objt => l_sbfl_current',
'      );',
'    elsif l_curr_objt_tag_name = flow_constants_pkg.gc_bpmn_boundary_event then',
'      -- if a repeating cycle timer, start next cycle before handling',
'      if p_timr_id is not null and p_run is not null then',
'        create_repeat_subflow ',
'        ( p_process_id      => p_process_id',
'        , p_last_subflow_id => p_subflow_id',
'        , p_timr_id         => p_timr_id',
'        , p_next_run        => p_run + 1',
'        );',
'      end if;',
'      -- Non-Interrupting Timer Boundary Event has required functionality same as iCE currently',
'      handle_intermediate_catch_event ',
'      (',
'        p_process_id   => p_process_id',
'      , p_subflow_id   => p_subflow_id',
'      , p_step_key     => p_step_key',
'      , p_current_objt => l_sbfl_current',
'      );',
'    elsif l_curr_objt_tag_name in ( flow_constants_pkg.gc_bpmn_subProcess',
'                                  , flow_constants_pkg.gc_bpmn_task ',
'                                  , flow_constants_pkg.gc_bpmn_userTask',
'                                  , flow_constants_pkg.gc_bpmn_manualTask',
'                                  , flow_constants_pkg.gc_bpmn_call_activity',
'                                  , flow_constants_pkg.gc_bpmn_receiveTask',
'                                  )   -- add any objects that can support timer boundary events here',
'          -- if any of these events have a timer on them, it must be an interrupting timer.',
'          -- because non-interupting timers are set on the boundary event itself',
'      then',
'      -- we have an interrupting timer boundary event',
'      flow_boundary_events.handle_interrupting_boundary_event',
'      ( p_process_id      => p_process_id',
'      , p_subflow_id      => p_subflow_id',
'      , p_event_type      => p_event_type',
'      , p_boundary_object => p_callback_par',
'      );',
'    elsif l_curr_objt_tag_name = flow_constants_pkg.gc_bpmn_intermediate_catch_event  then ',
'      -- we need to look at previous step to see if this follows an eventBasedGateway...',
'      case l_follows_ebg ',
'      when ''Y'' then',
'        -- we have an eventBasedGateway',
'        handle_event_gateway_event ',
'        (',
'          p_process_id => p_process_id',
'        , p_parent_subflow_id => l_parent_subflow',
'        , p_cleared_subflow_id => p_subflow_id',
'        );',
'      else ',
'        -- independant iCE not following an eBG',
'        -- set subflow status to running and call flow_complete_step',
'        handle_intermediate_catch_event ',
'        (',
'          p_process_id => p_process_id',
'        , p_subflow_id => p_subflow_id',
'        , p_step_key   => p_step_key',
'        , p_current_objt => l_sbfl_current',
'        );',
'      end case;',
'    end if;',
'  end if; -- sbfl locked',
'exception',
'  when others then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id  => p_process_id',
'    , pi_sbfl_id  => p_subflow_id',
'    , pi_message_key  => ''eng_handle_event_int''',
'    , p0  => p_process_id',
'    , p1  => p_subflow_id ',
'    , p2  => ''flow_handle_event''',
'    , p3  => l_curr_objt_tag_name',
'    , p4  => l_sbfl_current',
'    );',
'      -- $F4AMESSAGE ''eng_handle_event_int'' || ''Flow Engine Internal Error: Process %0 Subflow %1 Module %2 Current %4 Current Tag %3''',
'',
'end timer_callback;',
'',
'/************************************************************************************************************',
'****',
'****                       SUBFLOW  NEXT_STEP',
'****',
'*************************************************************************************************************/',
'',
'function finish_current_step',
'( p_sbfl_rec          in flow_subflows%rowtype',
', p_log_as_completed  in boolean default true',
', p_reset_step_key    in boolean default false',
') return flow_types_pkg.t_iteration_status',
'is',
'  l_current_step_tag      flow_objects.objt_tag_name%type;',
'  l_iteration_status      flow_types_pkg.t_iteration_status;',
'begin',
'  -- runs all of the post-step operations for the old current task (handling post- expressionsa, releasing reservations, etc.)',
'  apex_debug.enter ',
'  ( ''finish_current_step''',
'  , ''Process ID'',  p_sbfl_rec.sbfl_prcs_id',
'  , ''Subflow ID'', p_sbfl_rec.sbfl_id',
'  , ''Current Step'', p_sbfl_rec.sbfl_current',
'  , ''p_reset_step_key'', case p_reset_step_key when true then ''True'' when false then ''False'' else ''null'' end',
'  );',
'',
'  l_current_step_tag := flow_engine_util.get_object_tag (p_sbfl_info => p_sbfl_rec);',
'',
'  -- evaluate and set any post-step variable expressions on the last object',
'  if l_current_step_tag in ',
'  ( flow_constants_pkg.gc_bpmn_task, flow_constants_pkg.gc_bpmn_usertask, flow_constants_pkg.gc_bpmn_servicetask',
'  , flow_constants_pkg.gc_bpmn_manualtask, flow_constants_pkg.gc_bpmn_scripttask, flow_constants_pkg.gc_bpmn_businessruletask ',
'  , flow_constants_pkg.gc_bpmn_sendtask , flow_constants_pkg.gc_bpmn_receivetask )',
'  and p_sbfl_rec.sbfl_iteration_type is null ',
'  then ',
'    flow_expressions.process_expressions',
'      ( pi_objt_bpmn_id   => p_sbfl_rec.sbfl_current',
'      , pi_set            => flow_constants_pkg.gc_expr_set_after_task',
'      , pi_prcs_id        => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_rec.sbfl_id',
'      , pi_var_scope      => p_sbfl_rec.sbfl_scope',
'      , pi_expr_scope     => p_sbfl_rec.sbfl_scope',
'    );',
'  end if;',
'  -- clean up any boundary events left over from the previous activity',
'  if (l_current_step_tag in ( flow_constants_pkg.gc_bpmn_subprocess',
'                            , flow_constants_pkg.gc_bpmn_call_activity',
'                            , flow_constants_pkg.gc_bpmn_task',
'                            , flow_constants_pkg.gc_bpmn_usertask',
'                            , flow_constants_pkg.gc_bpmn_manualtask',
'                            , flow_constants_pkg.gc_bpmn_receivetask',
'                            ) -- boundary event attachable types',
'      and p_sbfl_rec.sbfl_has_events is not null )            -- subflow has events attached',
'  then',
'      -- ',
'      apex_debug.info ',
'      ( p_message => ''boundary event cleanup triggered for subflow %0''',
'      , p0        => p_sbfl_rec.sbfl_id',
'      );',
'      flow_boundary_events.unset_boundary_events ',
'      ( p_process_id => p_sbfl_rec.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_rec.sbfl_id);',
'  end if;',
'',
'  if p_sbfl_rec.sbfl_loop_counter is not null then',
'    case p_sbfl_rec.sbfl_iteration_type',
'    when flow_constants_pkg.gc_iteration_sequential then',
'      l_iteration_status := flow_iteration.sequential_complete_step (p_sbfl_info => p_sbfl_rec);',
'    when flow_constants_pkg.gc_iteration_loop then ',
'     if not p_reset_step_key then',
'        -- skip complete_step on the step after loop_init has run...',
'        l_iteration_status := flow_iteration.loop_complete_step (p_sbfl_info => p_sbfl_rec); ',
'     end if;',
'    else ',
'      null;   ',
'    end case;',
'  end if;',
'',
'  if p_log_as_completed then',
'    -- log current step as completed before releasing the reservation',
'    flow_logging.log_step_completion   ',
'    ( p_process_id        => p_sbfl_rec.sbfl_prcs_id',
'    , p_subflow_id        => p_sbfl_rec.sbfl_id',
'    , p_completed_object  => p_sbfl_rec.sbfl_current',
'    , p_iteration_status  => l_iteration_status',
'    );',
'  end if;',
'  -- release subflow reservation',
'  if p_sbfl_rec.sbfl_reservation is not null then',
'    flow_reservations.release_step',
'    ( p_process_id        => p_sbfl_rec.sbfl_prcs_id',
'    , p_subflow_id        => p_sbfl_rec.sbfl_id',
'    , p_called_internally => true',
'    );',
'  end if;',
'',
'  apex_debug.info',
'  ( p_message => ''Post Step Operations completed for current step %1 on subflow %0. Iteration Complete: %2''',
'  , p0        => p_sbfl_rec.sbfl_id',
'  , p1        => p_sbfl_rec.sbfl_current',
'  , p2        => case l_iteration_status.is_complete when true then ''True'' when false then ''False'' else ''Null'' end',
'  );',
'  return l_iteration_status;',
'end finish_current_step;',
'',
'function get_step_info',
'( p_sbfl_rec                in flow_subflows%rowtype',
', p_forward_route           in flow_connections.conn_bpmn_id%type default null',
', p_is_restart              in boolean default false',
', p_iteration_is_complete   in boolean default false',
', p_previous_step           in flow_objects.objt_bpmn_id%type default null',
') return flow_types_pkg.flow_step_info',
'is',
'  l_dgrm_id               flow_diagrams.dgrm_id%type;',
'  l_step_info             flow_types_pkg.flow_step_info;',
'  l_iteration_type        varchar2(10);',
'begin',
'  apex_debug.enter ',
'  ( ''get_step_info''',
'  , ''Process ID'',    p_sbfl_rec.sbfl_prcs_id',
'  , ''Subflow ID'',    p_sbfl_rec.sbfl_id',
'  , ''Restart'',       case p_is_restart when true then ''True'' else ''False'' end',
'  , ''Forward Route'', p_forward_route',
'  , ''Iteration Complete'', case p_iteration_is_complete when true then ''True'' else ''False'' end',
'  , ''Loop Counter'', p_sbfl_rec.sbfl_loop_counter',
'  );',
'  begin',
'    case',
'    when ( p_sbfl_rec.sbfl_iteration_type is null and not p_is_restart )  -- usual next step case',
'      or ( p_sbfl_rec.sbfl_iteration_type in ( flow_constants_pkg.gc_iteration_sequential ',
'                                             , flow_constants_pkg.gc_iteration_loop)',
'           and p_iteration_is_complete',
'           and p_sbfl_rec.sbfl_loop_counter is null) -- current step is final sequential or loop iteration',
'    then',
'      -- Find next subflow step',
'      -- rewritten original LEFT JOIN query because of database 23.3 bug 35862529 (fixed db 23.4) which returns incorrect values on left join when including json attributes',
'      -- workaround - remove json columns from select list and query separately if lane_bpmn_is is not null',
'      apex_debug.message (''Getting next step using standard query...'');',
'      select p_sbfl_rec.sbfl_dgrm_id',
'           , objt_source.objt_tag_name',
'           , objt_source.objt_id',
'           , conn.conn_tgt_objt_id',
'           , objt_target.objt_name',
'           , objt_target.objt_bpmn_id',
'           , objt_target.objt_tag_name   ',
'           , null ',
'           , objt_target.objt_sub_tag_name',
'           , objt_lane.objt_bpmn_id',
'           , objt_lane.objt_name',
'           , null -- objt_lane.objt_attributes."apex"."isRole"',
'           , null -- objt_lane.objt_attributes."apex"."role"',
'           , objt_target.objt_attributes',
'           , null',
'           , null',
'        into l_step_info',
'        from flow_connections conn',
'        join flow_objects objt_source',
'          on conn.conn_src_objt_id = objt_source.objt_id',
'         and conn.conn_dgrm_id     = objt_source.objt_dgrm_id',
'        join flow_objects objt_target',
'          on conn.conn_tgt_objt_id = objt_target.objt_id',
'         and conn.conn_dgrm_id     = objt_target.objt_dgrm_id',
'        left ',
'        join flow_objects objt_lane',
'          on objt_target.objt_objt_lane_id = objt_lane.objt_id',
'         and objt_target.objt_dgrm_id      = objt_lane.objt_dgrm_id',
'       where conn.conn_tag_name  = flow_constants_pkg.gc_bpmn_sequence_flow',
'         and ( p_forward_route is null',
'               OR  ( p_forward_route is not null AND conn.conn_bpmn_id = p_forward_route )',
'             )',
'         and conn.conn_dgrm_id        = p_sbfl_rec.sbfl_dgrm_id',
'         and objt_source.objt_bpmn_id = coalesce (p_previous_step, p_sbfl_rec.sbfl_current)',
'      ;',
'    else',
'      apex_debug.message (''Getting next step using restart and iteration query...'');',
'      select p_sbfl_rec.sbfl_dgrm_id',
'           , null ',
'           , null',
'           , objt_current.objt_id',
'           , objt_current.objt_name',
'           , objt_current.objt_bpmn_id',
'           , objt_current.objt_tag_name  ',
'           , null  ',
'           , objt_current.objt_sub_tag_name',
'           , objt_lane.objt_bpmn_id',
'           , objt_lane.objt_name',
'           , null -- objt_lane.objt_attributes."apex"."isRole"',
'           , null -- objt_lane.objt_attributes."apex"."role"',
'           , objt_current.objt_attributes',
'           , null',
'           , null',
'        into l_step_info',
'        from flow_objects objt_current',
'        left ',
'        join flow_objects objt_lane',
'          on objt_current.objt_objt_lane_id = objt_lane.objt_id',
'         and objt_current.objt_dgrm_id      = objt_lane.objt_dgrm_id',
'       where objt_current.objt_bpmn_id = p_sbfl_rec.sbfl_current',
'         and objt_current.objt_dgrm_id = p_sbfl_rec.sbfl_dgrm_id',
'      ;',
'    end case;',
'',
'    if l_step_info.target_objt_lane is not null then',
'      begin',
'        -- workaround for database 23.3 bug 35862529 ',
'        select lane.objt_attributes."apex"."isRole"',
'             , lane.objt_attributes."apex"."role"',
'          into l_step_info.target_objt_lane_isRole',
'             , l_step_info.target_objt_lane_role',
'          from flow_objects lane',
'         where lane.objt_bpmn_id  = l_step_info.target_objt_lane',
'           and lane.objt_dgrm_id  = l_step_info.dgrm_id',
'        ;',
'      exception',
'        when no_data_found then ',
'          apex_debug.message ',
'          ( p_message => ''-- Lane %0 json attributes data not found''',
'          , p0 => l_step_info.target_objt_lane',
'          );',
'          raise;',
'      end;',
'    end if;',
'',
'    if l_step_info.target_objt_attributes is not null then',
'      l_step_info.target_objt_iteration := flow_engine_util.get_iteration_type (l_step_info);',
'      if l_step_info.target_objt_iteration is not null then',
'        flow_iteration.add_iteration_to_step_info ',
'        ( p_step_info             => l_step_info',
'        , p_sbfl_rec              => p_sbfl_rec',
'        , p_iteration_is_complete => p_iteration_is_complete',
'        );',
'      end if;',
'    end if;',
'',
'    if l_step_info.target_objt_treat_as_tag is not null then',
'      apex_debug.message (p_message => ''--treat as tag set to %0'',',
'      p0 => l_step_info.target_objt_treat_as_tag);',
'    end if;',
'',
'  exception',
'    when no_data_found then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_rec.sbfl_id',
'      , pi_message_key    => ''no_next_step_found''',
'      , p0 => p_sbfl_rec.sbfl_id',
'      );',
'      -- $F4AMESSAGE ''no_next_step_found'' || ''No Next Step Found on subflow %0.  Check your process diagram.''',
'    when too_many_rows then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id        => p_sbfl_rec.sbfl_id',
'      , pi_message_key    => ''more_than_1_forward_path''',
'      , p0 => p_sbfl_rec.sbfl_id',
'      );',
'      -- $F4AMESSAGE ''more_than_1_forward_path'' || ''More than 1 forward path found when only 1 allowed.''',
'    when others then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id  => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id  => p_sbfl_rec.sbfl_id',
'      , pi_message_key  => ''eng_handle_event_int''',
'      , p0  => p_sbfl_rec.sbfl_prcs_id',
'      , p1  => p_sbfl_rec.sbfl_id',
'      , p2  => ''get_step_info''',
'      , p3  => null',
'      , p4  => null',
'      );',
'      -- $F4AMESSAGE ''eng_handle_event_int'' || ''Flow Engine Internal Error: Process %0 Subflow %1 Module %2 Current %4 Current Tag %3''',
'  end;',
'  return l_step_info;',
'end get_step_info;',
'',
'procedure restart_failed_timer_step',
'( p_sbfl_rec    in flow_subflows%rowtype',
', p_step_info   in flow_types_pkg.flow_step_info',
')',
'is',
'begin',
'  -- if an event with timer fails when the timer fires, we restart it by ignoring the timer',
'  -- and immediately running the on-event variable set and then moving forwards on the subflow',
'  apex_debug.enter ',
'  ( ''restart_failed_timer_step''',
'  , ''Process ID'',  p_sbfl_rec.sbfl_prcs_id',
'  , ''Subflow ID'', p_sbfl_rec.sbfl_id',
'  );',
'',
'  apex_debug.info ',
'  ( p_message => ''Restart Timer Step - Target object: %s.  More info at APP_TRACE level.''',
'  , p0        => coalesce(p_step_info.target_objt_tag, ''!NULL!'') ',
'  );',
'  apex_debug.trace',
'  ( p_message => ''Restart Timer Info - dgrm_id : %0, source_objt_tag : %1, target_objt_id : %2, target_objt_ref : %3''',
'  , p0  => p_step_info.dgrm_id',
'  , p1  => p_step_info.source_objt_tag',
'  , p2  => p_step_info.target_objt_id',
'  , p3  => p_step_info.target_objt_ref',
'  );',
'  apex_debug.trace',
'  ( p_message => ''Timer Step Info - target_objt_tag : %0, target_objt_subtag : %1''',
'  , p0 => p_step_info.target_objt_tag',
'  , p1 => p_step_info.target_objt_subtag',
'  );',
'  apex_debug.trace',
'  ( p_message => ''Runing Step Context - sbfl_id : %0, sbfl_last_completed : %1, sbfl_prcs_id : %2''',
'  , p0 => p_sbfl_rec.sbfl_id',
'  , p1 => p_sbfl_rec.sbfl_last_completed',
'  , p2 => p_sbfl_rec.sbfl_prcs_id',
'  );   ',
'  --  Set status to waiting and reschedule the timer with current time.',
'      update flow_subflows sbfl',
'         set sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_waiting_timer',
'           , sbfl.sbfl_last_update    = systimestamp',
'           , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'       where sbfl.sbfl_id = p_sbfl_rec.sbfl_id',
'         and sbfl.sbfl_prcs_id = p_sbfl_rec.sbfl_prcs_id',
'      ;',
'      flow_timers_pkg.reschedule_timer',
'      ( ',
'        p_process_id          => p_sbfl_rec.sbfl_prcs_id',
'      , p_subflow_id          => p_sbfl_rec.sbfl_id',
'      , p_step_key            => p_sbfl_rec.sbfl_step_key',
'      , p_restart_immediate   => true',
'      , p_is_immediate        => true',
'      , p_comment             => ''Restart Immediate Broken Timer''',
'      );',
'',
'end restart_failed_timer_step;',
'',
'procedure run_step',
'( p_sbfl_rec              in flow_subflows%rowtype',
', p_step_info             in flow_types_pkg.flow_step_info',
', p_iteration_is_complete in boolean default false',
')',
'is',
'  l_iteration_status        flow_types_pkg.t_iteration_status;',
'  l_iteration_is_complete   boolean;',
'begin',
'  apex_debug.enter ',
'  ( ''run_step''',
'  , ''Process ID'',  p_sbfl_rec.sbfl_prcs_id',
'  , ''Subflow ID'', p_sbfl_rec.sbfl_id',
'  , ''Loop Counter'', p_sbfl_rec.sbfl_loop_counter',
'  , ''SBFL Iteration Type'', p_sbfl_rec.sbfl_iteration_type',
'  , ''Step Iteration Type'', p_step_info.target_objt_iteration',
'  , ''iteration_is_complete'' , case p_iteration_is_complete when true then ''True'' when false then ''False'' else ''null'' end',
'  );',
'',
'  apex_debug.info ',
'  ( p_message => ''Running Step - Target object: %s.  More info at APP_TRACE level.''',
'  , p0        => coalesce(p_step_info.target_objt_tag, ''!NULL!'') ',
'  );',
'  apex_debug.trace',
'  ( p_message => ''Running Step Info - dgrm_id : %0, source_objt_tag : %1, target_objt_id : %2, target_objt_ref : %3''',
'  , p0  => p_step_info.dgrm_id',
'  , p1  => p_step_info.source_objt_tag',
'  , p2  => p_step_info.target_objt_id',
'  , p3  => p_step_info.target_objt_ref',
'  );',
'  apex_debug.trace',
'  ( p_message => ''Running Step Info - target_objt_tag : %0 (treat like %2 ), target_objt_subtag : %1, iteration: %3 (loop: %4), iter_id: %5, iobj_id: %6 iteration var %7''',
'  , p0 => p_step_info.target_objt_tag',
'  , p1 => p_step_info.target_objt_subtag',
'  , p2 => coalesce (p_step_info.target_objt_treat_as_tag, p_step_info.target_objt_tag)',
'  , p3 => nvl ( p_step_info.target_objt_iteration, ''None'')',
'  , p4 => p_sbfl_rec.sbfl_loop_counter',
'  , p5 => p_sbfl_rec.sbfl_iter_id',
'  , p6 => p_sbfl_rec.sbfl_iobj_id',
'  , p7 => p_sbfl_rec.sbfl_iteration_var',
'  );',
'  apex_debug.trace',
'  ( p_message => ''Running Step Context - sbfl_id : %0, sbfl_last_completed : %1, sbfl_prcs_id : %2''',
'  , p0 => p_sbfl_rec.sbfl_id',
'  , p1 => p_sbfl_rec.sbfl_last_completed',
'  , p2 => p_sbfl_rec.sbfl_prcs_id',
'  );    ',
'',
'  -- evaluate and set any pre-step variable expressions on the next object',
'  if p_step_info.target_objt_tag in ',
'  ( flow_constants_pkg.gc_bpmn_task, flow_constants_pkg.gc_bpmn_usertask, flow_constants_pkg.gc_bpmn_servicetask',
'  , flow_constants_pkg.gc_bpmn_manualtask, flow_constants_pkg.gc_bpmn_scripttask, flow_constants_pkg.gc_bpmn_businessruletask ',
'  , flow_constants_pkg.gc_bpmn_sendtask , flow_constants_pkg.gc_bpmn_receivetask )',
'  and p_sbfl_rec.sbfl_loop_counter is null',
'  then ',
'    flow_expressions.process_expressions',
'      ( pi_objt_id     => p_step_info.target_objt_id',
'      , pi_set         => flow_constants_pkg.gc_expr_set_before_task',
'      , pi_prcs_id     => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_rec.sbfl_id',
'      , pi_var_scope   => p_sbfl_rec.sbfl_scope',
'      , pi_expr_scope  => p_sbfl_rec.sbfl_scope',
'    );',
'  elsif p_step_info.target_objt_tag in ',
'  ( flow_constants_pkg.gc_bpmn_start_event, flow_constants_pkg.gc_bpmn_end_event ',
'  , flow_constants_pkg.gc_bpmn_intermediate_throw_event, flow_constants_pkg.gc_bpmn_intermediate_catch_event',
'  , flow_constants_pkg.gc_bpmn_boundary_event )',
'  then',
'    flow_expressions.process_expressions',
'      ( pi_objt_id     => p_step_info.target_objt_id',
'      , pi_set         => flow_constants_pkg.gc_expr_set_before_event',
'      , pi_prcs_id     => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_rec.sbfl_id',
'      , pi_var_scope   => p_sbfl_rec.sbfl_scope',
'      , pi_expr_scope  => p_sbfl_rec.sbfl_scope',
'    );',
'  end if;',
'',
'  l_iteration_is_complete := p_iteration_is_complete;',
'  if l_iteration_is_complete is null then',
'    l_iteration_is_complete := false;',
'  end if;',
'',
'  apex_debug.message (p_message => ''run step --> start iterated step? Loop Counter %0 Iter_complete %1 iter_type %2''',
'  , p0 => p_sbfl_rec.sbfl_loop_counter',
'  , p1 => case l_iteration_is_complete when true then ''True'' when false then ''False'' else ''null'' end',
'  , p2 => p_sbfl_rec.sbfl_iteration_type',
'  );',
'',
'  if  ( p_sbfl_rec.sbfl_loop_counter is not null ',
'        and l_iteration_is_complete != true)  then',
'    case p_sbfl_rec.sbfl_iteration_type ',
'    when flow_constants_pkg.gc_iteration_sequential then',
'      apex_debug.message (p_message => ''run step --> calling sequential start step'');',
'      flow_iteration.sequential_start_step ( p_sbfl_info => p_sbfl_rec);',
'    when flow_constants_pkg.gc_iteration_loop then',
'      apex_debug.message (p_message => ''run step --> calling loop start step'');',
'      flow_iteration.loop_start_step ( p_sbfl_info => p_sbfl_rec);   ',
'    else',
'      null;',
'    end case;   ',
'  end if;',
'',
'  case coalesce (p_step_info.target_objt_treat_as_tag, p_step_info.target_objt_tag)',
'    when flow_constants_pkg.gc_bpmn_end_event then  --next step is either end of process or sub-process returning to its parent',
'      flow_engine.process_endEvent',
'      ( p_process_id => p_sbfl_rec.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_rec.sbfl_id',
'      , p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when flow_constants_pkg.gc_bpmn_gateway_exclusive then',
'      flow_gateways.process_exclusiveGateway',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when flow_constants_pkg.gc_bpmn_gateway_inclusive then',
'      flow_gateways.process_para_incl_Gateway',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when flow_constants_pkg.gc_bpmn_gateway_parallel then',
'      flow_gateways.process_para_incl_Gateway',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when flow_constants_pkg.gc_bpmn_subprocess then',
'      flow_subprocesses.process_subProcess',
'      ( p_process_id => p_sbfl_rec.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_rec.sbfl_id',
'      , p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when flow_constants_pkg.gc_bpmn_call_activity then',
'      flow_call_activities.process_callActivity',
'      ( p_process_id => p_sbfl_rec.sbfl_prcs_id',
'      , p_subflow_id => p_sbfl_rec.sbfl_id',
'      , p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when flow_constants_pkg.gc_bpmn_gateway_event_based then',
'      flow_gateways.process_eventBasedGateway',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when  flow_constants_pkg.gc_bpmn_intermediate_catch_event then ',
'      flow_engine.process_intermediateCatchEvent',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when  flow_constants_pkg.gc_bpmn_intermediate_throw_event then ',
'      flow_engine.process_intermediateThrowEvent',
'      ( p_sbfl_info => p_sbfl'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'_rec',
'      , p_step_info => p_step_info',
'      ); ',
'    when  flow_constants_pkg.gc_bpmn_task then ',
'      flow_tasks.process_task',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      );',
'    when  flow_constants_pkg.gc_bpmn_usertask then',
'      flow_tasks.process_userTask',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      );',
'    when  flow_constants_pkg.gc_bpmn_scripttask then ',
'      flow_tasks.process_scriptTask',
'      (p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      );',
'    when  flow_constants_pkg.gc_bpmn_manualtask then ',
'      flow_tasks.process_manualTask',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      );',
'    when  flow_constants_pkg.gc_bpmn_servicetask then ',
'      flow_tasks.process_serviceTask',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      );',
'    when  flow_constants_pkg.gc_bpmn_businessruletask then ',
'      flow_tasks.process_businessRuleTask',
'         ( p_sbfl_info => p_sbfl_rec',
'         , p_step_info => p_step_info',
'         );',
'    when  flow_constants_pkg.gc_bpmn_sendtask then ',
'      flow_tasks.process_sendTask',
'      ( p_sbfl_info => p_sbfl_rec',
'      , p_step_info => p_step_info',
'      );',
'    when  flow_constants_pkg.gc_bpmn_receivetask then ',
'      flow_tasks.process_receiveTask',
'         ( p_sbfl_info => p_sbfl_rec',
'         , p_step_info => p_step_info',
'         );',
'    when flow_constants_pkg.gc_iteration_sequential then',
'      l_iteration_status := flow_iteration.sequential_init',
'         ( p_sbfl_info => p_sbfl_rec',
'         , p_step_info => p_step_info',
'         );',
'    when flow_constants_pkg.gc_iteration_loop then',
'      l_iteration_status := flow_iteration.loop_init',
'         ( p_sbfl_info => p_sbfl_rec',
'         , p_step_info => p_step_info',
'         );',
'    when ''sequentialIterationClose'' then',
'      flow_iteration.sequential_close_iteration',
'         ( p_sbfl_info => p_sbfl_rec',
'         , p_step_info => p_step_info',
'         );',
'    end case;',
'',
'  exception',
'    when case_not_found then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_rec.sbfl_id',
'      , pi_message_key => ''engine-unsupported-object''',
'      , p0 => p_step_info.target_objt_tag',
'      );',
'      -- $F4AMESSAGE ''engine-unsupported-object'' || ''Model Error: Process BPMN model next step uses unsupported object %0''  ',
'    when no_data_found then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_rec.sbfl_id',
'      , pi_message_key => ''no_next_step_found''',
'      , p0 => p_sbfl_rec.sbfl_id',
'      );',
'      -- $F4AMESSAGE ''no_next_step_found'' || ''No Next Step Found on subflow %0.  Check your process diagram.''  ',
'    when e_feature_requires_ee then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_sbfl_rec.sbfl_prcs_id',
'      , pi_sbfl_id     => p_sbfl_rec.sbfl_id',
'      , pi_message_key => ''feature-requires-ee''',
'      );',
'      -- $F4AMESSAGE ''no_next_step_found'' || ''Processing this feature requires licensing Flows for APEX Enterprise Edition.'' ',
'    when flow_plsql_runner_pkg.e_plsql_script_failed then',
'      null;',
'  -- let error run back to run_step',
'end run_step;',
'',
'',
'procedure flow_complete_step',
'( p_process_id        in flow_processes.prcs_id%type',
', p_subflow_id        in flow_subflows.sbfl_id%type ',
', p_step_key          in flow_subflows.sbfl_step_key%type default null',
', p_forward_route     in flow_connections.conn_bpmn_id%type default null',
', p_log_as_completed  in boolean default true',
', p_reset_step_key    in boolean default false -- only set for initial call after splitting parallel iteration',
', p_recursive_call    in boolean default true',
')',
'is',
'  l_sbfl_rec                  flow_subflows%rowtype;',
'  l_step_info                 flow_types_pkg.flow_step_info;',
'  l_dgrm_id                   flow_diagrams.dgrm_id%type;',
'  l_timestamp                 flow_subflows.sbfl_became_current%type;',
'  l_step_key                  flow_subflows.sbfl_step_key%type;',
'  l_previous_step             flow_objects.objt_bpmn_id%type;  ',
'  l_next_loop_counter         number;',
'  l_existing_iter_id          flow_iterations.iter_id%type;',
'  l_existing_iobj_id          flow_iterated_objects.iobj_id%type;',
'  l_next_iter_id              flow_iterations.iter_id%type;',
'  l_next_iobj_id              flow_iterated_objects.iobj_id%type;',
'  l_total_loop_instances      number;',
'  l_iteration_status          flow_types_pkg.t_iteration_status;',
'  l_iter_info                 flow_types_pkg.t_iteration_status;',
'  l_next_step_confirmed       boolean := false;',
' -- l_prcs_check_id         flow_processes.prcs_id%type;',
'begin',
'  apex_debug.enter ',
'  ( ''flow_complete_step''',
'  , ''Process ID'',  p_process_id',
'  , ''Subflow ID'', p_subflow_id',
'  , ''Supplied Step Key'', p_step_key',
'  , ''recursive_call'', case when p_recursive_call then ''true''  else ''false''  end',
'  , ''reset_step_key'', case when p_reset_step_key then ''true''  else ''false''  end',
'  );',
'  flow_globals.set_is_recursive_step (p_is_recursive_step => p_recursive_call);',
'  -- Get current object and current subflow info and lock it',
'  l_sbfl_rec := flow_engine_util.get_subflow_info ',
'  ( p_process_id => p_process_id',
'  , p_subflow_id => p_subflow_id',
'  , p_lock_process => false ',
'  , p_lock_subflow => true',
'  );',
'',
'  -- check step key is valid',
'  if flow_engine_util.step_key_valid( pi_prcs_id  => p_process_id',
'                                    , pi_sbfl_id  => p_subflow_id',
'                                    , pi_step_key_supplied  => p_step_key',
'                                    , pi_step_key_required  => l_sbfl_rec.sbfl_step_key) then ',
'    -- step key is valid ',
'    -- if subflow has any associated non-interrupting timers on current object, lock the subflows and timers',
'    -- (other boundary event types only create a subflow when they fire)',
'    if l_sbfl_rec.sbfl_has_events like ''%:CNT%'' then ',
'      flow_boundary_events.lock_child_boundary_timers',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_parent_objt_bpmn_id => l_sbfl_rec.sbfl_current ',
'      ); ',
'    end if;',
'    -- lock associated timers for interrupting boundary events',
'    if l_sbfl_rec.sbfl_has_events like ''%:S_T%'' then ',
'      flow_timers_pkg.lock_timer(p_process_id, p_subflow_id);',
'    end if;',
'',
'    -- complete the current step by doing the post-step operations',
'    l_iteration_status  :=  finish_current_step',
'                            ( p_sbfl_rec         => l_sbfl_rec',
'                            , p_log_as_completed => p_log_as_completed',
'                            , p_reset_step_key   => p_reset_step_key',
'                            );',
'',
'    if flow_globals.get_step_error then',
'      rollback;',
'      if p_recursive_call then',
'        -- set error status on instance and subflow',
'        flow_errors.set_error_status',
'        ( pi_prcs_id => p_process_id',
'        , pi_sbfl_id => p_subflow_id',
'        );',
'      end if;',
'      apex_debug.info',
'      ( p_message => ''Subflow %0 : Step End Rollback due to earlier Error on Step %1''',
'      , p0        => p_subflow_id',
'      , p1        => l_sbfl_rec.sbfl_current',
'      );      ',
'    else',
'      l_previous_step := l_sbfl_rec.sbfl_current;',
'        --',
'        -- if next step is an iteration over a collection, check that the collection has members before confirming ',
'        -- it is the next step.  If not, step forward again by picking the next step',
'        -- start by finding the next subflow step',
'        l_step_info := get_step_info  ( p_sbfl_rec              => l_sbfl_rec',
'                                      , p_forward_route         => p_forward_route',
'                                      , p_iteration_is_complete => l_iteration_status.is_complete',
'                                      , p_previous_step         => l_previous_step',
'                                      );  ',
'        -- get next step key',
'        l_step_info.target_objt_step_key  := flow_engine_util.step_key ( pi_sbfl_id         => p_subflow_id',
'                                                                  , pi_current         => l_step_info.target_objt_ref',
'                                                                  );',
'        -- control iteration progression',
'        l_existing_iter_id        := l_sbfl_rec.sbfl_iter_id;',
'        l_existing_iobj_id        := l_sbfl_rec.sbfl_iobj_id;',
'        case l_step_info.target_objt_iteration ',
'        when flow_constants_pkg.gc_iteration_sequential then',
'          if l_sbfl_rec.sbfl_current != l_step_info.target_objt_ref',
'          then',
'--            -- next step is a new sequential iteration',
'--            -- sequential iteration info is set when iteration subflows are create',
'            null;                                                           ',
'          elsif p_reset_step_key then',
'            -- the next step is the iterating object (not the 2nd phase of sequential init)',
'            -- so reset the step key in the iteration array',
'            apex_debug.message (''call from flow_engine...'');',
'            l_next_loop_counter    := 1;',
'            l_total_loop_instances := l_sbfl_rec.sbfl_loop_total_instances;',
'            l_next_iobj_id         := l_existing_iobj_id;',
'            l_next_step_confirmed  := true;',
'            l_next_iter_id := flow_iteration.get_iteration_id ( p_prcs_id      => p_process_id',
'                                                              , p_iobj_id      => l_next_iobj_id',
'                                                              , p_loop_counter => l_next_loop_counter',
'                                                              );                                                         ',
'          elsif l_sbfl_rec.sbfl_loop_counter is not null then',
'            if l_step_info.target_objt_treat_as_tag = ''sequentialIterationClose'' then',
'              -- this is the extra ''closing gateway'' step that we add to close the iteration subflow & return',
'              -- processing back to the parent subflow.',
'              null;',
'            else',
'            -- loop counter has value - so sequentia iteration is in progress',
'            -- next step is the next sequential iteration of an existing iteration',
'            l_next_loop_counter    := l_sbfl_rec.sbfl_loop_counter +1;',
'            l_total_loop_instances := l_sbfl_rec.sbfl_loop_total_instances;',
'            l_next_iobj_id         := l_existing_iobj_id;',
'',
'            l_next_iter_id := flow_iteration.get_iteration_id ( p_prcs_id      => p_process_id',
'                                                               , p_iobj_id      => l_next_iobj_id',
'                                                               , p_loop_counter => l_next_loop_counter',
'                                                               );  ',
'            end if;',
'          else',
'            null;',
'          end if; -- loop counter',
'        when flow_constants_pkg.gc_iteration_parallel then',
'          if p_reset_step_key then',
'            -- the next step is the iterating object (not the 2nd phase ogf the implicit parallel gateway)',
'            -- so reset the step key in the iteration array',
'            apex_debug.message (''call from flow_engine...'');',
'            flow_iteration.set_iteration_status',
'            ( pi_prcs_id        => p_process_id',
'            , pi_loop_counter   => l_sbfl_rec.sbfl_loop_counter',
'            , pi_new_status     => flow_constants_pkg.gc_iteration_status_running ',
'            , pi_step_key       => l_step_info.target_objt_step_key',
'            , pi_scope          => l_sbfl_rec.sbfl_iteration_var_scope',
'            , pi_prov_var_name  => l_sbfl_rec.sbfl_iteration_var',
'            , pi_iobj_id        => l_sbfl_rec.sbfl_iobj_id',
'            );',
'          end if;',
'          l_next_loop_counter := l_sbfl_rec.sbfl_loop_counter;',
'          l_total_loop_instances := l_sbfl_rec.sbfl_loop_total_instances;',
'',
'          l_next_iobj_id         := l_existing_iobj_id;',
'          l_next_iter_id         := l_existing_iter_id;',
'',
'        when flow_constants_pkg.gc_iteration_loop then',
'          if l_sbfl_rec.sbfl_current != l_step_info.target_objt_ref then',
'            -- next step is a new bpmn loop ',
'            -- for loop iteration we use the original subflow for the iterands so need ',
'            -- to set loop info on the original subflow. ',
'            -- loop iteration info is set when iteration subflows are created',
'            null;',
'          elsif p_reset_step_key then',
'            -- the next step is the iterating object (not the 2nd phase of sequential init)',
'            -- so reset the step key in the iteration array',
'            apex_debug.message (''call from flow_engine...'');',
'            l_next_loop_counter    := 1;',
'            l_total_loop_instances := 1;',
'            l_next_iobj_id         := l_existing_iobj_id;',
'         ',
'          elsif l_sbfl_rec.sbfl_loop_counter is not null then',
'            if l_step_info.target_objt_treat_as_tag = ''sequentialIterationClose'' then',
'              -- this is the extra ''closing gateway'' step that we add to close the iteration subflow & return',
'              -- processing back to the parent subflow.',
'              null;',
'            else',
'              -- loop counter has value - so sequentia iteration is in progress',
'              -- next step is the next sequential iteration of an existing iteration',
'              l_next_loop_counter    := l_sbfl_rec.sbfl_loop_counter +1;',
'              l_total_loop_instances := l_sbfl_rec.sbfl_loop_total_instances +1;',
'              l_next_iobj_id         := l_existing_iobj_id;',
'',
'              -- create new iteration and extend the iteration array',
'',
'              l_next_iter_id := flow_iteration.get_iteration_id ( p_prcs_id      => p_process_id',
'                                                                 , p_iobj_id      => l_next_iobj_id',
'                                                                 , p_loop_counter => l_next_loop_counter',
'                                                                 );  ',
'            end if; --treat as tag',
'          end if; -- loop counter',
'        else ',
'          apex_debug.message (p_message => ''next step not an iteration or loop'');',
'          -- next step is not an iteration or loop ',
'          l_next_loop_counter := null;',
'          l_total_loop_instances := l_sbfl_rec.sbfl_loop_total_instances; ',
'          l_next_step_confirmed  := true;',
'          l_next_iter_id := l_existing_iter_id;',
'        end case; -- iteration type',
'    end if; -- step error',
'  end if; -- step key valid',
'',
'  -- end of post-step operations for previous step',
'  if flow_globals.get_step_error then',
'    rollback;',
'    if p_recursive_call then',
'      -- set error status on instance and subflow',
'      flow_errors.set_error_status',
'      ( pi_prcs_id => p_process_id',
'      , pi_sbfl_id => p_subflow_id',
'      );',
'    end if;',
'    apex_debug.info',
'    ( p_message => ''Subflow %0 : Step End Rollback due to earlier Error on Step %1''',
'    , p0        => p_subflow_id',
'    , p1        => l_sbfl_rec.sbfl_current',
'    );',
'  else',
'    l_timestamp := systimestamp;',
'',
'    -- update subflow with step completed, and prepare for next step before committing',
'    update flow_subflows sbfl',
'      set sbfl.sbfl_current             = l_step_info.target_objt_ref',
'        , sbfl.sbfl_last_completed      = l_sbfl_rec.sbfl_current',
'        , sbfl.sbfl_became_current      = l_timestamp',
'        , sbfl.sbfl_step_key            = l_step_info.target_objt_step_key',
'        , sbfl.sbfl_status              = flow_constants_pkg.gc_sbfl_status_running',
'        , sbfl.sbfl_work_started        = null',
'        , sbfl.sbfl_potential_users     = null',
'        , sbfl.sbfl_potential_groups    = null',
'        , sbfl.sbfl_excluded_users      = null',
'        , sbfl.sbfl_lane                = coalesce( l_step_info.target_objt_lane       , sbfl.sbfl_lane        , null)',
'        , sbfl.sbfl_lane_name           = coalesce( l_step_info.target_objt_lane_name  , sbfl.sbfl_lane_name   , null)',
'        , sbfl.sbfl_lane_isRole         = coalesce( l_step_info.target_objt_lane_isRole, sbfl.sbfl_lane_isRole , null)',
'        , sbfl.sbfl_lane_role           = case l_step_info.target_objt_lane_isRole',
'                                          when ''true'' then l_step_info.target_objt_lane_role',
'                                          when ''false'' then null',
'                                          else coalesce( sbfl.sbfl_lane_role   , null)',
'                                          end',
'        , sbfl.sbfl_iter_id             = coalesce(l_next_iter_id, sbfl.sbfl_iter_id)',
'        , sbfl.sbfl_iobj_id             = l_next_iobj_id                                  ',
'        , sbfl.sbfl_loop_counter        = l_next_loop_counter',
'        , sbfl.sbfl_iteration_type      = l_step_info.target_objt_iteration',
'        , sbfl.sbfl_loop_total_instances',
'                                        = coalesce(l_total_loop_instances, sbfl.sbfl_loop_total_instances)',
'        , sbfl.sbfl_iteration_var       = l_iteration_status.iteration_var',
'        , sbfl.sbfl_iteration_var_scope = l_iteration_status.var_scope',
'        , sbfl.sbfl_last_update         = l_timestamp',
'        , sbfl.sbfl_last_update_by      = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'    where sbfl.sbfl_prcs_id = p_process_id',
'      and sbfl.sbfl_id = p_subflow_id',
'    ;',
'    commit;',
'',
'    apex_debug.info',
'    ( p_message => ''Subflow %0 : Step End Committed for step %1''',
'    , p0        => p_subflow_id',
'    , p1        => l_sbfl_rec.sbfl_current',
'    , p2        => case l_sbfl_rec.sbfl_loop_counter ',
'                        when null then ''''',
'                        else '' [''||l_sbfl_rec.sbfl_loop_counter ||'']''',
'                        end',
'    );',
'  ',
'    -- start of pre-phase for next step',
'    -- reset step_had_error flag',
'    flow_globals.set_step_error ( p_has_error => false);',
'    -- now into next step so is not part of users current step',
'    flow_globals.set_is_recursive_step (p_is_recursive_step => true);',
'    apex_debug.info ( p_message => ''Step now counted as recursive'');',
'    -- relock subflow',
'    l_sbfl_rec := flow_engine_util.get_subflow_info ',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    , p_lock_process => false',
'    , p_lock_subflow => true',
'    );',
'',
'    -- Run the step',
'    run_step ',
'    ( p_sbfl_rec                => l_sbfl_rec',
'    , p_step_info               => l_step_info ',
'    , p_iteration_is_complete   => l_iteration_status.is_complete',
'    );',
'    -- Commit transaction before returning',
'    if flow_globals.get_step_error then',
'      rollback;',
' ',
'      -- set error status on instance and subflow',
'      flow_errors.set_error_status',
'      ( pi_prcs_id => p_process_id',
'      , pi_sbfl_id => p_subflow_id',
'      );',
'      commit;',
' ',
'      apex_debug.info',
'      ( p_message => ''Subflow %0 : Step End Rollback due to earlier Error.  (Error Status Just Committed.)''',
'      , p0        => p_subflow_id',
'      );',
'      ',
'    else',
'      commit;',
'',
'      apex_debug.info',
'      ( p_message => ''Subflow %0 : Step End Committed''',
'      , p0        => p_subflow_id',
'      );',
'    end if;',
'  end if;',
'  end flow_complete_step;',
'',
'  procedure start_step -- just (optionally) records the start time of work on the current step',
'    ( p_process_id         in flow_processes.prcs_id%type',
'    , p_subflow_id         in flow_subflows.sbfl_id%type',
'    , p_step_key           in flow_subflows.sbfl_step_key%type default null',
'    , p_called_internally  in boolean default false',
'    )',
'  is',
'    l_existing_start       flow_subflows.sbfl_work_started%type;',
'  begin',
'    apex_debug.enter',
'    ( ''start_step''',
'    , ''Subflow '', p_subflow_id',
'    , ''Process '', p_process_id ',
'    , ''Step Key'', p_step_key',
'    );',
'    -- subflow should already be locked when calling internally',
'    if not p_called_internally then ',
'      -- lock  subflow if called externally',
'      select sbfl_work_started',
'        into l_existing_start',
'        from flow_subflows sbfl ',
'       where sbfl.sbfl_id = p_subflow_id',
'         and sbfl.sbfl_prcs_id = p_process_id',
'         for update of sbfl_work_started wait 3',
'      ;',
'    end if;',
'    -- check the step key',
'    if flow_engine_util.step_key_valid( pi_prcs_id  => p_process_id',
'                                      , pi_sbfl_id  => p_subflow_id',
'                                      , pi_step_key_supplied  => p_step_key',
'                                      ) ',
'    then ',
'      -- set the start time if null',
'      if l_existing_start is null then',
'        update flow_subflows sbfl',
'           set sbfl_work_started        = systimestamp',
'             , sbfl.sbfl_last_update    = systimestamp',
'             , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                   , sys_context(''userenv'',''os_user'')',
'                                                   , sys_context(''userenv'',''session_user'')',
'                                                   )  ',
'        where sbfl_prcs_id = p_process_id',
'          and sbfl_id = p_subflow_id',
'        ;',
'        -- commit reservation if this is an external call',
'        if not p_called_internally then ',
'          commit;',
'        end if;',
'      end if;',
'    end if;',
'  exception',
'    when no_data_found then',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''startwork-sbfl-not-found''',
'      , p0 => p_subflow_id',
'      , p1 => p_process_id',
'      );',
'      -- $F4AMESSAGE ''startwork-sbfl-not-found'' || ''Start Work time recording unsuccessful.  Subflow %0 in Process %1 not found.''  ',
'    when lock_timeout then',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''timeout_locking_subflow''',
'      , p0 => p_subflow_id',
'      );',
'      -- $F4AMESSAGE ''timeout_locking_subflow'' || ''Unable to lock subflow %0 as currently locked by another user.  Try again later.''        ',
'  end start_step;',
'',
'procedure restart_step',
'  ( p_process_id          in flow_processes.prcs_id%type',
'  , p_subflow_id          in flow_subflows.sbfl_id%type',
'  , p_step_key            in flow_subflows.sbfl_step_key%type default null',
'  , p_comment             in flow_instance_event_log.lgpr_comment%type default null',
'  )',
'is ',
'  l_sbfl_rec            flow_subflows%rowtype;',
'  l_step_info           flow_types_pkg.flow_step_info;',
'  l_num_error_subflows  number;',
'begin ',
'  apex_debug.enter ',
'  ( ''flow_restart_step''',
'  , ''Process ID'',  p_process_id',
'  , ''Subflow ID'', p_subflow_id',
'  );',
'  flow_globals.set_is_recursive_step (p_is_recursive_step => true);',
'   -- reset step_had_error flag',
'  flow_globals.set_step_error ( p_has_error => false);',
'',
'  -- lock the process and subflow',
'  l_sbfl_rec := flow_engine_util.get_subflow_info ',
'                ( p_process_id => p_process_id',
'                , p_subflow_id => p_subflow_id',
'                , p_lock_process => true',
'                , p_lock_subflow => true',
'                );',
'  -- check subflow current task is in error status',
'  if l_sbfl_rec.sbfl_status <> flow_constants_pkg.gc_sbfl_status_error then ',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''restart-no-error''',
'      );',
'      -- $F4AMESSAGE ''restart-no-error'' || ''No Current Error Found.  Check your process diagram.''  ',
'  end if;',
'  ',
'  if flow_engine_util.step_key_valid( pi_prcs_id  => p_process_id',
'                                    , pi_sbfl_id  => p_subflow_id',
'                                    , pi_step_key_supplied  => p_step_key',
'                                    ) ',
'  then ',
'    -- valid step key was supplied',
'    -- set up step context',
'    l_step_info :=  get_step_info',
'                    ( p_sbfl_rec        => l_sbfl_rec',
'                    , p_is_restart      => true',
'                    );',
'    -- set subflow status to running',
'    update flow_subflows sbfl',
'       set sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_running',
'         , sbfl.sbfl_last_update    = systimestamp',
'         , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                               , sys_context(''userenv'',''os_user'')',
'                                               , sys_context(''userenv'',''session_user'')',
'                                               )  ',
'     where sbfl.sbfl_prcs_id = p_process_id',
'       and sbfl.sbfl_id      = p_subflow_id',
'    ;',
'    -- log the restart',
'    flow_logging.log_instance_event',
'    ( p_process_id    => p_process_id',
'    , p_event         => flow_constants_pkg.gc_prcs_event_restart_step',
'    , p_objt_bpmn_id  => l_sbfl_rec.sbfl_current',
'    , p_comment       => ''restart step ''||l_sbfl_rec.sbfl_current||''. Comment: ''||p_comment',
'    );',
'    -- see if instance can be reset to running',
'    select count(sbfl_id)',
'      into l_num_error_subflows',
'      from flow_subflows sbfl ',
'     where sbfl.sbfl_prcs_id = p_process_id',
'       and sbfl.sbfl_status = flow_constants_pkg.gc_sbfl_status_error ',
'    ;',
'    if l_num_error_subflows = 0 then',
'      update flow_processes prcs',
'         set prcs.prcs_status = flow_constants_pkg.gc_prcs_status_running',
'           , prcs.prcs_last_update = systimestamp',
'           , prcs.prcs_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )  ',
'       where prcs.prcs_id = p_process_id',
'      ;',
'      flow_logging.log_instance_event',
'      ( p_process_id    => p_process_id',
'      , p_objt_bpmn_id  => l_sbfl_rec.sbfl_current',
'      , p_event         => flow_constants_pkg.gc_prcs_status_running',
'      );',
'    end if;',
'',
'    if l_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_timer_event_definition then',
'      -- restart object contains a timer.  run var exps and step forward immediately',
'      restart_failed_timer_step',
'      ( p_sbfl_rec => l_sbfl_rec',
'      , p_step_info => l_step_info',
'      );',
'    else',
'      -- all other object types.  restart current task',
'      run_step ',
'      ( p_sbfl_rec => l_sbfl_rec',
'      , p_step_info => l_step_info',
'      );',
'    end if;',
'  end if;  -- valid step key',
'',
'  -- commit or rollback based on errors',
'  if flow_globals.get_step_error then',
'    rollback;',
'  else',
'    commit;',
'  end if;',
'end restart_step;',
'',
'end flow_engine;',
'/',
'',
'create or replace package body flow_api_pkg as',
'/* ',
'-- Flows for APEX - flow_api_pkg.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG. 2020-22',
'--',
'-- Created    20-Jun-2020   Moritz Klein, MT AG ',
'-- Modified   01-May-2022   Richard Allen, Oracle',
'-- ',
'*/',
'',
'  e_lock_timeout exception;',
'  pragma exception_init (e_lock_timeout, -3006);',
'',
'  function get_dgrm_name',
'  (',
'    p_prcs_id in flow_processes.prcs_id%type',
'  ) return varchar2',
'  is',
'    l_dgrm_name flow_diagrams.dgrm_name%type;',
'  begin',
'',
'    select dgrm.dgrm_name',
'      into l_dgrm_name',
'      from flow_processes prcs',
'      join flow_diagrams dgrm',
'        on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'     where prcs.prcs_id = p_prcs_id',
'    ;',
'         ',
'    return l_dgrm_name;',
'  end get_dgrm_name;',
'',
'  function flow_create',
'  (',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version in flow_diagrams.dgrm_version%type default null',
'  , pi_prcs_name in flow_processes.prcs_name%type',
'  ) return flow_processes.prcs_id%type',
'  as',
'    l_dgrm_id         flow_diagrams.dgrm_id%type;',
'    l_dgrm_version    flow_diagrams.dgrm_version%type;',
'    l_calling_method  flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'  ',
'    if pi_dgrm_version is null then',
'      -- this is the former way of calling the latest release',
'      l_calling_method := flow_constants_pkg.gc_dgrm_version_latest_version;',
'    else',
'      -- dgrm_version was specified - use ''namedVersion'' call...                                                      ',
'      l_calling_method := flow_constants_pkg.gc_dgrm_version_named_version;',
'    end if;',
'',
'    -- get the released diagram or ''draft'' version ''0'' diagram (or error...)',
'    l_dgrm_id := flow_diagram.get_current_diagram ( pi_dgrm_name            => pi_dgrm_name ',
'                                                  , pi_dgrm_calling_method  => l_calling_method',
'                                                  , pi_dgrm_version         => pi_dgrm_version',
'                                                  );',
'',
'    return  flow_instances.create_process',
'            ( p_dgrm_id   => l_dgrm_id',
'            , p_prcs_name => pi_prcs_name',
'            );',
'  end flow_create;',
'',
'  function flow_create',
'  (',
'    pi_dgrm_id   in flow_diagrams.dgrm_id%type',
'  , pi_prcs_name in flow_processes.prcs_name%type',
'  ) return flow_processes.prcs_id%type',
'  is',
'    l_ret flow_processes.prcs_id%type;',
'  begin',
'    return flow_instances.create_process',
'           ( p_dgrm_id => pi_dgrm_id',
'           , p_prcs_name => pi_prcs_name',
'           )',
'    ;',
'  end flow_create;',
'',
'  procedure flow_create',
'  (',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version in flow_diagrams.dgrm_version%type default null',
'  , pi_prcs_name in flow_processes.prcs_name%type',
'  )',
'  as',
'    l_prcs_id flow_processes.prcs_id%type;',
'  begin',
'    l_prcs_id :=',
'      flow_create',
'      (',
'        pi_dgrm_name => pi_dgrm_name',
'      , pi_dgrm_version => pi_dgrm_version',
'      , pi_prcs_name => pi_prcs_name',
'      );',
'  end flow_create;',
'',
'  procedure flow_create',
'  (',
'    pi_dgrm_id   in flow_diagrams.dgrm_id%type',
'  , pi_prcs_name in'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' flow_processes.prcs_name%type',
'  )',
'  as',
'    l_prcs_id flow_processes.prcs_id%type;',
'  begin',
'    l_prcs_id :=',
'      flow_instances.create_process',
'      (',
'        p_dgrm_id   => pi_dgrm_id',
'      , p_prcs_name => pi_prcs_name',
'      );',
'  end flow_create;',
'',
'  procedure flow_start',
'    ( p_process_id in flow_processes.prcs_id%type',
'    )',
'    is',
'      l_session_id   number;',
'    begin  ',
'        if v(''APP_SESSION'') is null then',
'          l_session_id := flow_apex_session.create_api_session (p_process_id => p_process_id);',
'        end if;',
'',
'        apex_debug.message(p_message => ''Begin flow_start'', p_level => 3) ;',
'',
'        flow_globals.set_context',
'        ( pi_prcs_id => p_process_id',
'        , pi_scope   => 0   -- initial scope is always 0',
'        );',
'  ',
'        flow_instances.start_process ',
'        ( p_process_id => p_process_id',
'        );',
'',
'        if l_session_id is not null then',
'          flow_apex_session.delete_session (p_session_id => l_session_id );',
'        end if;',
'    exception',
'      when others then',
'        if l_session_id is not null then',
'          flow_apex_session.delete_session (p_session_id => l_session_id );',
'        end if;',
'        raise;',
'  end flow_start;',
'',
'  procedure flow_set_priority ',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_priority   in flow_processes.prcs_priority%type ',
'  )',
'  is',
'  begin',
'    flow_instances.set_priority ( p_process_id  => p_process_id',
'                                , p_priority    => p_priority',
'                                );',
'  end flow_set_priority;',
'',
'  procedure flow_set_due_on',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_due_on     in flow_processes.prcs_due_on%type ',
'  )',
'  is',
'  begin',
'    flow_instances.set_due_on ( p_process_id  => p_process_id',
'                              , p_due_on      => p_due_on',
'                                );',
'  end flow_set_due_on;',
'',
'  procedure flow_reserve_step',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_step_key      in flow_subflows.sbfl_step_key%type default null',
'  , p_reservation   in flow_subflows.sbfl_reservation%type',
'  )',
'  is ',
'  begin',
'',
'    flow_reservations.reserve_step',
'    ( p_process_id  => p_process_id',
'    , p_subflow_id  => p_subflow_id',
'    , p_reservation => p_reservation',
'    , p_step_key    => p_step_key',
'    );',
'  end flow_reserve_step;',
'',
'  procedure flow_release_step',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_step_key      in flow_subflows.sbfl_step_key%type default null',
'  )',
'  is ',
'  begin',
'',
'    flow_reservations.release_step',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    , p_step_key   => p_step_key',
'    );',
'  end flow_release_step;',
'',
'  procedure flow_start_step',
'  (',
'    p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_step_key      in flow_subflows.sbfl_step_key%type default null',
'  )',
'  is ',
'  begin',
'    flow_engine.start_step',
'    ( p_process_id  => p_process_id',
'    , p_subflow_id  => p_subflow_id',
'    , p_step_key    => p_step_key',
'    );',
'  end flow_start_step;',
'',
'  procedure flow_restart_step',
'  (',
'    p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_step_key      in flow_subflows.sbfl_step_key%type default null',
'  , p_comment       in flow_instance_event_log.lgpr_comment%type default null',
'  )',
'  is ',
'    l_session_id   number;',
'  begin ',
'    -- create an APEX session if this has come in from outside APEX',
'    if v(''APP_SESSION'') is null then',
'      l_session_id := flow_apex_session.create_api_session (p_subflow_id => p_subflow_id);',
'    end if;',
'',
'    flow_globals.set_context',
'    ( pi_prcs_id      => p_process_id',
'    , pi_sbfl_id      => p_subflow_id',
'    , pi_step_key     => p_step_key',
'    , pi_scope        => flow_engine_util.get_scope (p_process_id => p_process_id, p_subflow_id => p_subflow_id)',
'    , pi_loop_counter => flow_engine_util.get_loop_counter (pi_sbfl_id => p_subflow_id)',
'    );',
'    flow_engine.restart_step',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    , p_step_key   => p_step_key',
'    , p_comment    => p_comment',
'    );',
'',
'    if l_session_id is not null then',
'      flow_apex_session.delete_session (p_session_id => l_session_id );',
'    end if;',
'  exception',
'    when others then',
'      if l_session_id is not null then',
'        flow_apex_session.delete_session (p_session_id => l_session_id );',
'      end if;',
'      raise;',
'  end flow_restart_step;',
'',
'',
'  procedure flow_complete_step',
'  ( p_process_id    in flow_processes.prcs_id%type',
'  , p_subflow_id    in flow_subflows.sbfl_id%type',
'  , p_step_key      in flow_subflows.sbfl_step_key%type default null',
'  )',
'  is ',
'      l_session_id   number;',
'  begin',
'    -- create an APEX session if this has come in from outside APEX',
'    if v(''APP_SESSION'') is null then',
'      l_session_id := flow_apex_session.create_api_session (p_subflow_id => p_subflow_id);',
'    end if; ',
'',
'    flow_globals.set_context',
'    ( pi_prcs_id  => p_process_id',
'    , pi_sbfl_id  => p_subflow_id',
'    , pi_step_key => p_step_key',
'    , pi_scope    => flow_engine_util.get_scope (p_process_id => p_process_id, p_subflow_id => p_subflow_id)',
'    );',
'    flow_engine.flow_complete_step',
'    ( p_process_id => p_process_id',
'    , p_subflow_id => p_subflow_id',
'    , p_step_key   => p_step_key',
'    , p_recursive_call => false',
'    );',
'',
'    if l_session_id is not null then',
'      flow_apex_session.delete_session (p_session_id => l_session_id );',
'    end if;',
'  exception',
'    when others then',
'      if l_session_id is not null then',
'        flow_apex_session.delete_session (p_session_id => l_session_id );',
'      end if;',
'      raise;',
'  end flow_complete_step;',
'',
'  procedure flow_reschedule_timer',
'  (',
'      p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_step_key      in flow_subflows.sbfl_step_key%type default null',
'    , p_is_immediate  in boolean default false',
'    , p_new_timestamp in flow_timers.timr_start_on%type default null',
'    , p_comment       in flow_instance_event_log.lgpr_comment%type default null',
'  )',
'  is',
'  begin',
'    flow_timers_pkg.reschedule_timer',
'    ( ',
'      p_process_id    => p_process_id',
'    , p_subflow_id    => p_subflow_id',
'    , p_step_key      => p_step_key ',
'    , p_is_immediate  => p_is_immediate',
'    , p_new_timestamp => p_new_timestamp',
'    , p_comment       => p_comment',
'    );',
'  end flow_reschedule_timer;',
'',
'  procedure flow_reset',
'  ( p_process_id in flow_processes.prcs_id%type',
'  , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'  )',
'  is',
'  begin',
'    apex_debug.enter ',
'    ( p_routine_name => ''flow_reset''',
'    );',
'    flow_instances.reset_process ',
'    ( p_process_id  => p_process_id',
'    , p_comment     => p_comment',
'    );',
'  end flow_reset;',
'',
'  procedure flow_terminate',
'  ( p_process_id  in flow_processes.prcs_id%type',
'  , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'  )',
'  is',
'  begin',
'    apex_debug.enter ',
'    ( p_routine_name => ''flow_terminate''',
'    );',
'    flow_instances.terminate_process ',
'    ( p_process_id => p_process_id',
'    , p_comment    => p_comment',
'    );',
'  end flow_terminate;',
'',
'  procedure flow_delete',
'  ( p_process_id  in flow_processes.prcs_id%type',
'  , p_comment     in flow_instance_event_log.lgpr_comment%type default null',
'  )',
'  is',
'  begin',
'    apex_debug.enter',
'    (p_routine_name => ''flow_delete''',
'    );',
'    flow_instances.delete_process ',
'    ( p_process_id => p_process_id',
'    , p_comment    => p_comment',
'    );',
'  end flow_delete;',
'',
'  function get_current_usertask_url',
'  (',
'    p_process_id in flow_processes.prcs_id%type',
'  , p_subflow_id in flow_subflows.sbfl_id%type',
'  , p_step_key   in flow_subflows.sbfl_step_key%type default null',
'  , p_scope      in flow_subflows.sbfl_scope%type default 0',
'  ) return varchar2',
'  as',
'    l_objt_id flow_objects.objt_id%type;',
'  begin',
'    apex_debug.trace ( p_message => ''Entering GET_CURRENT_USERTASK_URL'' );',
'',
'    select objt.objt_id',
'      into l_objt_id',
'      from flow_subflows sbfl',
'      join flow_processes prcs',
'        on prcs.prcs_id = sbfl.sbfl_prcs_id',
'      join flow_objects objt',
'        on objt.objt_dgrm_id = prcs.prcs_dgrm_id',
'       and objt.objt_bpmn_id = sbfl.sbfl_current',
'     where sbfl.sbfl_prcs_id = p_process_id',
'       and sbfl.sbfl_id = p_subflow_id',
'       and objt.objt_tag_name = flow_constants_pkg.gc_bpmn_usertask',
'    ;',
'',
'    apex_debug.trace( p_message => ''Found OBJT_ID %s'', p0 => l_objt_id );',
'',
'    return ',
'      flow_usertask_pkg.get_url',
'      (',
'        pi_prcs_id  => p_process_id',
'      , pi_sbfl_id  => p_subflow_id',
'      , pi_step_key => p_step_key',
'      , pi_objt_id  => l_objt_id',
'      , pi_scope    => p_scope',
'      );',
'  end get_current_usertask_url;',
'',
'  function message',
'  ( p_message_key    in varchar2',
'  , p_lang            in varchar2 default ''en''',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  ) return varchar2',
'  is',
'  begin',
'    return flow_errors.make_error_message',
'           ( pi_message_key => p_message_key',
'           , pi_lang        => p_lang',
'           , p0   => p0',
'           , p1   => p1',
'           , p2   => p2',
'           , p3   => p3',
'           , p4   => p4',
'           , p5   => p5',
'           , p6   => p6',
'           , p7   => p7',
'           , p8   => p8',
'           , p9   => p9',
'           );',
'',
'  end message;',
'',
'  function get_tasks ',
'  ( p_context      in varchar2',
'  , p_prcs_id      in flow_processes.prcs_id%type',
'  , p_user         in varchar2 default null ',
'  , p_groups       in varchar2 default null',
'  )',
'  return sys_refcursor',
'  is',
'    l_cur     sys_refcursor;',
'    l_user    varchar2(250);',
'  begin ',
'    l_user := coalesce( p_user, SYS_CONTEXT(''APEX$SESSION'',''APP_USER'') ); ',
'',
'    case p_context',
'    when flow_constants_pkg.gc_task_list_context_my_tasks then',
'      ',
'        open l_cur for',
'        select curr_objt.objt_name',
'             , curr_objt.objt_tag_name',
'             , curr_objt.objt_id',
'             , sbfl.sbfl_current',
'             , prcs.prcs_name',
'             , bref.prov_var_vc2',
'             , dgrm.dgrm_name',
'             , sbfl.sbfl_due_on',
'             , round((cast(sbfl.sbfl_due_on as date) - sysdate) * 24, 1) ',
'             , sbfl.sbfl_priority',
'             , prcs.prcs_init_by',
'             , sbfl.sbfl_reservation',
'             , sbfl.sbfl_status',
'             , sbfl.sbfl_became_current',
'             , sbfl.sbfl_last_update_by',
'             , sbfl.sbfl_last_update',
'             , prcs.prcs_id',
'             , sbfl.sbfl_id',
'             , sbfl.sbfl_step_key',
'             , sbfl.sbfl_scope',
'             , sbfl.sbfl_potential_users',
'             , sbfl.sbfl_potential_groups',
'             , sbfl.sbfl_excluded_users',
'             , sbfl.sbfl_lane_name',
'             , sbfl.sbfl_lane_role',
'          from flow_subflows sbfl',
'          join flow_processes prcs',
'            on prcs.prcs_id = sbfl.sbfl_prcs_id',
'     left join flow_objects curr_objt',
'            on curr_objt.objt_bpmn_id = sbfl.sbfl_current',
'           and curr_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'          join flow_diagrams dgrm ',
'            on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'     left join flow_process_variables bref',
'            on bref.prov_prcs_id = sbfl.sbfl_prcs_id',
'           and bref.prov_var_name = ''BUSINESS_REF''',
'           and bref.prov_scope = 0',
'         where curr_objt.objt_tag_name = ''bpmn:userTask'' ',
'           and sbfl.sbfl_status = ''running''',
'           and (instr ( sbfl.sbfl_excluded_users, l_user) = 0',
'               or sbfl.sbfl_excluded_users is null)',
'           and ( sbfl.sbfl_reservation = l_user',
'               OR   sbfl.sbfl_reservation is null );',
'',
'    when flow_constants_pkg.gc_task_list_context_single then',
'        open l_cur for',
'        select curr_objt.objt_name',
'             , curr_objt.objt_tag_name',
'             , curr_objt.objt_id',
'             , sbfl.sbfl_current',
'             , prcs.prcs_name',
'             , bref.prov_var_vc2',
'             , dgrm.dgrm_name',
'             , sbfl.sbfl_due_on',
'             , round((cast(sbfl.sbfl_due_on as date) - sysdate) * 24, 1) ',
'             , sbfl.sbfl_priority',
'             , prcs.prcs_init_by',
'             , sbfl.sbfl_reservation',
'             , sbfl.sbfl_status',
'             , sbfl.sbfl_became_current',
'             , sbfl.sbfl_last_update_by',
'             , sbfl.sbfl_last_update',
'             , prcs.prcs_id',
'             , sbfl.sbfl_id',
'             , sbfl.sbfl_step_key',
'             , sbfl.sbfl_scope',
'             , sbfl.sbfl_potential_users',
'             , sbfl.sbfl_potential_groups',
'             , sbfl.sbfl_excluded_users',
'             , sbfl.sbfl_lane_name',
'             , sbfl.sbfl_lane_role',
'          from flow_subflows sbfl',
'          join flow_processes prcs',
'            on prcs.prcs_id = sbfl.sbfl_prcs_id',
'     left join flow_objects curr_objt',
'            on curr_objt.objt_bpmn_id = sbfl.sbfl_current',
'           and curr_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'          join flow_diagrams dgrm ',
'            on dgrm.dgrm_id = prcs.prcs_dgrm_id',
'     left join flow_process_variables bref',
'            on bref.prov_prcs_id = sbfl.sbfl_prcs_id',
'           and bref.prov_var_name = ''BUSINESS_REF''',
'           and bref.prov_scope = 0',
'         where curr_objt.objt_tag_name = ''bpmn:userTask'' ',
'           and sbfl.sbfl_status in ( flow_constants_pkg.gc_sbfl_status_running',
'                                   , flow_constants_pkg.gc_sbfl_status_waiting_approval)',
'           and prcs.prcs_id = p_prcs_id;',
'    end case;',
'',
'    return l_cur;',
'  end get_tasks;',
'',
'',
'  function get_current_tasks',
'  ( p_context    in varchar2 default flow_constants_pkg.gc_task_list_context_my_tasks',
'  , p_prcs_id    in flow_processes.prcs_id%type default null',
'  , p_user       in varchar2 default null',
'  , p_groups     in varchar2 default null',
'  ) return t_task_list_items pipelined ',
'  is',
'    type t_sbfl_row is record ',
'      ( curr_objt_name        varchar2( 200 char)',
'      , curr_objt_tag_name    varchar2(  50 char)',
'      , curr_objt_id          number',
'      , sbfl_current          varchar2(  50 char)',
'      , prcs_name             varchar2( 150 char)',
'      , prcs_business_ref     varchar2(4000 char)',
'      , prcs_dgrm_name        varchar2( 150 char)',
'      , sbfl_due_on           timestamp with time zone',
'      , sbfl_due_in_hours     number',
'      , sbfl_priority         number',
'      , prcs_init_by          varchar2( 255 char)',
'      , sbfl_reservation      varchar2( 255 char)',
'      , sbfl_status           varchar2(  20 char)',
'      , sbfl_became_current   timestamp with time zone',
'      , sbfl_last_update_by   varchar2( 255 char)',
'      , sbfl_last_update      timestamp with time zone',
'      , prcs_id               number',
'      , sbfl_id               number',
'      , sbfl_step_key              varchar2(  20 char)',
'      , sbfl_scope            number',
'      , sbfl_potential_users  varchar2(4000 char)',
'      , sbfl_potential_groups varchar2(4000 char)',
'      , sbfl_excluded_users   varchar2(4000 char)',
'      , sbfl_lane_name        varchar2( 200 char)',
'      , sbfl_lane_role        varchar2( 200 char)',
'      );',
'',
'    --',
'',
'    --',
'    l_row               t_sbfl_row;',
'    l_cur               sys_refcursor;',
'    l_task              flow_api_pkg.t_task_list_item;  ',
'    l_current_groups    apex_t_varchar2;',
'    l_user              varchar2 (255 char);',
'    --',
'    procedure process_row is',
'    begin',
'        l_task.manager                 := ''FlowsForAPEX'';',
'        l_task.app_id                  := null;',
'        l_task.task_id                 := null;',
'        l_task.task_def_id             := null;',
'        l_task.task_def_name           := coalesce( l_row.curr_objt_name, l_row.sbfl_current );',
'        l_task.task_def_static_id      := null;',
'        l_task.subject                 := l_row.prcs_name||'' (''||l_row.prcs_business_ref||'') - ''||coalesce( l_row.curr_objt_name, l_row.sbfl_current);',
'        l_task.task_type               := case l_row.sbfl_status',
'                                              when flow_constants_pkg.gc_sbfl_status_waiting_approval then',
'                                                  ''APPROVAL''',
'                                              else',
'                                                  ''F4A_USERTASK''',
'                                          end;',
'        l_task.details_app_id          := null;',
'        l_task.details_app_name        := l_row.prcs_dgrm_name;',
'        l_task.details_link_target     := case l_row.curr_objt_tag_name',
'                                              when ''bpmn:userTask'' then',
'                                                flow_usertask_pkg.get_url',
'                                                (',
'                                                  pi_prcs_id  => l_row.prcs_id',
'                                                , pi_sbfl_id  => l_row.sbfl_id',
'                                                , pi_objt_id  => l_row.curr_objt_id   ',
'                                                , pi_step_key => l_row.sbfl_step_key',
'                                                , pi_scope    => l_row.sbfl_scope',
'                                                )',
'                                              else null ',
'                                              end;',
'        l_task.due_on                  := l_row.sbfl_due_on;',
'        l_task.due_in_hours            := l_row.sbfl_due_in_hours;',
'        l_task.due_in                  := apex_util.get_since( l_row.sbfl_due_on );',
'        l_task.due_code                := case',
'                                              when l_row.sbfl_due_in_hours <   0 then ''OVERDUE''',
'                                              when l_row.sbfl_due_in_hours <   1 then ''NEXT_HOUR''',
'                                              when l_row.sbfl_due_in_hours <  24 then ''NEXT_24_HOURS''',
'                                              when l_row.sbfl_due_in_hours < 168 then ''NEXT_7_DAYS''',
'                                              when l_row.sbfl_due_in_hours < 720 then ''NEXT_30_DAYS''',
'                                              else                               ''MORE_THAN_30_DAYS''',
'                                          end;',
'        l_task.priority                := l_row.sbfl_priority;',
'        l_task.priority_level          := case l_row.sbfl_priority',
'                                              when 1 then ''urgent''',
'                                              when 2 then ''high''',
'                                              when 3 then ''medium''',
'                                              when 4 then ''low''',
'                                              when 5 then ''lowest''',
'                                          end;',
'        l_task.initiator               := l_row.prcs_init_by;',
'        l_task.initiator_lower         := lower(l_row.prcs_init_by);',
'        l_task.actual_owner            := l_row.sbfl_reservation;',
'        l_task.actual_owner_lower      := lower (l_row.sbfl_reservation);',
'        l_task.potential_owners        := l_row.sbfl_potential_users;',
'        l_task.potential_groups        := l_row.sbfl_potential_groups;',
'        l_task.excluded_owners         := l_row.sbfl_excluded_users;',
'        l_task.badge_css_classes       := --> no class, if unassigned or assigned (also see next case)',
'                                          case ',
'                                              when l_row.sbfl_status = flow_constants_pkg.gc_sbfl_status_error ',
'                                                  then ''u-danger''',
'                                          end;',
'        l_task.badge_text              := case ',
'                                            when p_context = flow_constants_pkg.gc_task_list_context_my_tasks then',
'                                                case ',
'                                                  when l_row.sbfl_status = flow_constants_pkg.gc_sbfl_status_error ',
'                                                      then flow_constants_pkg.gc_sbfl_status_error',
'                                                  when l_row.sbfl_reservation is null',
'                                                      then ''unassigned''',
'                                                end',
'                                            when p_context = flow_constants_pkg.gc_task_list_context_single then',
'                                                case',
'                                                  when l_row.sbfl_reservation is not null',
'                                                    then ''assigned : ''||l_row.sbfl_reservation',
'                                                  when l_row.sbfl_reservation is null ',
'                                                    then',
'                                                      case when l_row.sbfl_potential_users is not null then ''potential users : '' end ||',
'                                                      l_row.sbfl_potential_users ||',
'                                                      case when l_row.sbfl_potential_groups is not null then '' potential groups : '' end ||',
'                                                      l_row.sbfl_potential_groups ||',
'                                                      case when l_row.sbfl_excluded_users is not null then '' excluded users : '' end ||',
'                                                      l_row.sbfl_excluded_users',
'                                                end',
'                                          end;',
'        l_task.state_code              := null;',
'        l_task.state                   := l_row.sbfl_status;',
'        l_task.is_completed            := ''N'';',
'        l_task.outcome_code            := null;',
'        l_task.outcome                 := null;',
'',
'        l_task.created_ago_hours       := floor((sysdate - cast(l_row.sbfl_became_current as date) )*24);',
'        l_task.created_ago             := apex_util.get_since( l_row.sbfl_became_current );',
'        l_task.created_by              := l_row.prcs_init_by;',
'        l_task.created_on              := l_row.sbfl_became_current;',
'        l_task.last_updated_by         := l_row.sbfl_last_update_by;',
'        l_task.last_updated_on         := l_row.sbfl_last_update;',
'        l_task.process_id              := l_row.prcs_id;',
'        l_task.subflow_id              := l_row.sbfl_id;',
'        l_task.step_key                := l_row.sbfl_step_key;',
'        l_task.current_obj             := l_row.sbfl_current;',
'',
'    end process_row;',
'',
'    function user_is_eligible',
'    ( p_task            in flow_api_pkg.t_task_list_item',
'    , p_user            in varchar2',
'    , p_current_groups  in apex_t_varchar2',
'    ) return boolean',
'    is',
'      l_potential_users   apex_t_varchar2;',
'      l_potential_groups  apex_t_varchar2;',
'      l_group_intersect   apex_t_varchar2;',
'    begin ',
'      if p_task.potential_owners is not null then',
'        l_potential_users    := apex_string.split ( p_str => p_task.potential_owners',
'                                                  , p_sep => '':'' ',
'                                                  );',
'        if p_user member of l_potential_users then',
'          return true;',
'        end if;',
'      end if;',
'',
'      if p_task.potential_groups is not null then',
'         l_potential_groups  := apex_string.split ( p_str => p_task.potential_groups',
'                                                  , p_sep => '':''',
'                                                  );',
'          l_group_intersect   := l_potential_groups multiset intersect p_current_groups;',
'          if l_group_intersect is not empty then',
'            return true;',
'          end if;',
'      end if;',
'      return false;',
'    end user_is_eligible;',
'',
'',
'  begin',
'        l_user    := upper(coalesce( p_user, v(''APP_USER'')));',
'',
'        if p_groups is not null then',
'          l_current_groups  := apex_string.split ( p_str => p_groups',
'                                                 , p_sep => '':''',
'                                                 );',
'        else',
'          select roles.role_static_id',
'          bulk   collect into l_current_groups',
'            from apex_appl_acl_user_roles roles',
'           where roles.user_name     = v(''APP_USER'')',
'             and roles.workspace_id  = v(''WORKSPACE_ID'')',
'          ;',
'        end if;',
'',
'        l_task := flow_api_pkg.t_task_list_item ',
'                  ( null, null, null, null, null, null, null, null, null, null',
'                  , null, null, null, null, null, null, null, null, null, null',
'                  , null, null, null, null, null, null, null, null, null, null',
'                  , null, null, null, null, null, null, null, null, null, null ',
'                  );',
'        l_cur  := get_tasks',
'                  ( p_context  => p_context',
'                  , p_prcs_id  => p_prcs_id',
'                  , p_user     => l_user',
'                  , p_groups   => p_groups',
'                  );',
'',
'',
'        loop',
'            fetch l_cur into l_row;',
'            exit when l_cur%notfound;',
'            pragma inline(process_row, ''YES'');',
'            process_row;',
'            if    p_context = flow_constants_pkg.gc_task_list_context_single',
'               or user_is_eligible  ( p_task            => l_task',
'                                    , p_user            => l_user',
'                                    , p_current_groups  => l_current_groups',
'                                    ) ',
'            then ',
'               pipe row( l_task );',
'            end if;',
'        end loop;',
'',
'        if l_cur%isopen then',
'            close l_cur;',
'        end if;',
'',
'  exception',
'    when no_data_needed then',
'        close l_cur;',
'    when others then',
'        if l_cur%isopen then',
'            close l_cur;',
'        end if;',
'        raise;',
'  end get_current_tasks;',
'      ',
'',
'  procedure return_approval_result',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_apex_task_id  in number',
'    , p_result        in flow_process_variables.prov_var_vc2%type default null',
'    )',
'  is',
'  begin',
'    flow_usertask_pkg.return_approval_result  ( p_process_id    => p_process_id',
'                                              , p_apex_task_id  => p_apex_task_id',
'                                              , p_result        => p_result',
'                                              );',
'  end return_approval_result;',
'',
'',
'  procedure receive_message',
'  ( p_message_name  flow_message_subscriptions.msub_message_name%type',
'  , p_key_name      flow_message_subscriptions.msub_key_name%type',
'  , p_key_value     flow_message_subscriptions.msub_key_value%type',
'  , p_payload       clob default null',
'  )',
'  is',
'  begin',
'    -- Note:  Unlike other API calls, we cannot create an  APEX session here if this has come in from outside APEX',
'    -- as we do not yet have Flows information.  Wait until correlation completed to ',
'    -- create a session (inside flow_message_flow.receive_message)',
'    flow_message_flow.receive_message ( p_message_name  =>p_message_name',
'                                          , p_key_name  =>  p_key_name',
'                                          , p_key_value  => p_key_value',
'                                          , p_payload  => p_payload ',
'                                          );',
'  end receive_message;',
'',
'  function intervalDStoSec (',
'    p_intervalDS  interval day to second',
'  ) return number',
'  is',
'    l_sec number;',
'  begin',
'    return ( extract( day   from p_intervalDS) * 86400',
'           + extract( hour  from p_intervalDS) *  3600',
'           + extract(minute from p_intervalDS) *    60',
'           + extract(second from p_intervalDS)        ',
'           );',
'  end intervalDStoSec;',
'',
'  function intervalDStoHours (',
'    p_intervalDS  interval day to second',
'  ) return number',
'  is',
'    l_sec number;',
'  begin',
'    return ( extract( day   from p_intervalDS) * 24',
'           + extract( hour  from p_intervalDS)      ',
'           );',
'  end intervalDStoHours;',
'',
'-- Manually Step Forward Timers',
'',
'  procedure step_timers',
'  is',
'  begin',
'    flow_timers_pkg.step_timers;',
'  end;',
'',
'end flow_api_pkg;',
'/',
'',
'create or replace package body flow_migrate_xml_pkg',
'as',
'',
'  function is_exporter_version_current(',
'    p_domdoc dbms_xmldom.DOMDocument',
'  ) return boolean',
'  as',
'    l_exporter varchar2(50);',
'    l_exporter_version varchar2(10);',
'    l_domnodelist dbms_xmldom.DOMNodeList;',
'    l_domnode dbms_xmldom.DOMNode;',
'    l_domelement dbms_xmldom.DOMElement;',
'    l_exporter_below_22 boolean;',
'  begin',
'    l_domnodelist := dbms_xmldom.getelementsbytagname(',
'      doc => p_domdoc',
'    , tagname => ''definitions''',
'    );',
'    for i in 0 .. dbms_xmldom.getlength(l_domnodelist) - 1',
'      loop',
'        l_domnode := dbms_xmldom.item(l_domnodelist, i);',
'        l_domelement := dbms_xmldom.makeelement(l_domnode);',
'        l_exporter := dbms_xmldom.getattribute(',
'                        elem => l_domelement',
'                      , name => ''exporter''',
'                      );',
'        l_exporter_version := dbms_xmldom.getattribute(',
'                              elem => l_domelement',
'                            , name => ''exporterVersion''',
'                            );',
'        l_exporter_below_22 := ( to_number(substr(l_exporter_version, 1, instr(l_exporter_version, ''.'') - 1)) < 22 );',
'      end loop;    ',
'    return (l_exporte'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'r = ''Flows for APEX'' and ( not l_exporter_below_22 or l_exporter_version = flow_constants_pkg.gc_version ));',
'  end is_exporter_version_current;',
'  ',
'  procedure set_exporter(',
'    p_domdoc in out dbms_xmldom.DOMDocument',
'  , p_exporter varchar2',
'  , p_exporter_version varchar2',
'  )',
'  as',
'    l_domnodelist dbms_xmldom.DOMNodeList;',
'    l_domnode dbms_xmldom.DOMNode;',
'    l_domelement dbms_xmldom.DOMElement;',
'  begin',
'    l_domnodelist := dbms_xmldom.getelementsbytagname(',
'      doc => p_domdoc',
'    , tagname => ''definitions''',
'    );',
'    for i in 0 .. dbms_xmldom.getlength(l_domnodelist) - 1',
'      loop',
'        l_domnode := dbms_xmldom.item(l_domnodelist, i);',
'        l_domelement := dbms_xmldom.makeelement(l_domnode);',
'        dbms_xmldom.setattribute(',
'          elem => l_domelement',
'        , name => ''exporter''',
'        , newValue => p_exporter',
'        );',
'        dbms_xmldom.setattribute(',
'          elem => l_domelement',
'        , name => ''exporterVersion''',
'        , newValue => p_exporter_version',
'        );',
'      end loop;    ',
'  end set_exporter;',
'',
'  procedure append_page_item(',
'    p_domdoc in out dbms_xmldom.DOMDocument',
'  , p_page_items in out dbms_xmldom.DOMNode',
'  , p_item_name varchar2',
'  , p_item_value varchar2',
'  )',
'  as',
'    l_item_node dbms_xmldom.DOMNode;',
'    l_item_name_node dbms_xmldom.DOMNode;',
'    l_item_value_node dbms_xmldom.DOMNode;',
'    l_item_text_node dbms_xmldom.DOMNode;',
'  begin',
'    -- create page item node',
'    l_item_node := dbms_xmldom.makenode( ',
'      elem => dbms_xmldom.createelement( ',
'                doc => p_domdoc',
'              , tagName => ''apex:pageItem''',
'              , ns => flow_constants_pkg.gc_nsapex',
'              )',
'    );',
'    -- append',
'    l_item_node := dbms_xmldom.appendchild(',
'      n => p_page_items',
'    , newchild => l_item_node',
'    );',
'    -- create item name node ',
'    l_item_name_node := dbms_xmldom.makenode( ',
'      elem => dbms_xmldom.createelement( ',
'                doc => p_domdoc',
'              , tagName => ''apex:itemName''',
'              , ns => flow_constants_pkg.gc_nsapex',
'              ) ',
'    );',
'    -- create text node',
'    l_item_text_node := dbms_xmldom.makenode( ',
'      t => dbms_xmldom.createtextnode(',
'            doc => p_domdoc',
'          , data => p_item_name',
'          )',
'    );',
'    -- append text',
'    l_item_text_node := dbms_xmldom.appendchild(',
'      n => l_item_name_node',
'    , newchild => l_item_text_node',
'    );',
'    -- append',
'    l_item_name_node := dbms_xmldom.appendchild(',
'      n => l_item_node',
'    , newchild => l_item_name_node',
'    );',
'    -- create item value node ',
'    l_item_value_node := dbms_xmldom.makenode( ',
'      elem => dbms_xmldom.createelement( ',
'                doc => p_domdoc',
'              , tagName => ''apex:itemValue''',
'              , ns => flow_constants_pkg.gc_nsapex',
'              )',
'    );',
'     -- create text node',
'    l_item_text_node := dbms_xmldom.makenode( ',
'      t => dbms_xmldom.createtextnode(',
'            doc => p_domdoc',
'          , data => p_item_value',
'          )',
'    );',
'    -- append text',
'    l_item_text_node := dbms_xmldom.appendchild(',
'      n => l_item_value_node',
'    , newchild => l_item_text_node',
'    );',
'    -- append',
'    l_item_value_node := dbms_xmldom.appendchild(',
'      n => l_item_node',
'    , newchild => l_item_value_node',
'    );',
'  end append_page_item;    ',
'',
'  procedure update_apex_namespace(',
'    p_domdoc in out dbms_xmldom.DOMDocument',
'  )',
'  as',
'    l_domnodelist dbms_xmldom.DOMNodeList;',
'    l_domnode dbms_xmldom.DOMNode;',
'    l_domelement dbms_xmldom.DOMElement;',
'  begin',
'    l_domnodelist := dbms_xmldom.getelementsbytagname(',
'      doc => p_domdoc',
'    , tagname => ''definitions''',
'    );',
'    for i in 0 .. dbms_xmldom.getlength(l_domnodelist) - 1',
'      loop',
'        l_domnode := dbms_xmldom.item(l_domnodelist, i);',
'        l_domelement := dbms_xmldom.makeelement(l_domnode);',
'        dbms_xmldom.setattribute(',
'          elem => l_domelement',
'        , name => ''xmlns:apex''',
'        , newValue => flow_constants_pkg.gc_nsapex',
'        );',
'      end loop; ',
'  end update_apex_namespace;',
'',
'  procedure migrate_xml(',
'    p_dgrm_content in out clob',
'  , p_has_changed out boolean  ',
'  )',
'  as',
'    l_data XMLTYPE;',
'    l_domdoc dbms_xmldom.DOMDocument;',
'    l_domnodelist dbms_xmldom.DOMNodeList;',
'    -- task',
'    l_domnode dbms_xmldom.DOMNode;',
'    l_domelement dbms_xmldom.DOMElement;',
'    -- extension element',
'    l_extension_node dbms_xmldom.DOMNode;',
'    -- task type',
'    l_task_type_node dbms_xmldom.DOMNode;',
'    -- children (old)',
'    l_children dbms_xmldom.DOMNodeList;',
'    l_children_count number;',
'    l_child_node dbms_xmldom.DOMNode;',
'    -- child value',
'    l_child_text_node dbms_xmldom.DOMNode;',
'    -- children (new)',
'    l_ext_child_node dbms_xmldom.DOMNode;',
'    l_ext_child_tag_name varchar2(50);',
'',
'    -- user task',
'    l_items varchar2(4000);',
'    l_items_arr apex_t_varchar2;',
'    l_values varchar2(4000);',
'    l_values_arr apex_t_varchar2;',
'    l_valid_items number;',
'',
'    l_return clob;',
'',
'    function get_or_create_ext_elements',
'    (',
'      p_domdoc  dbms_xmldom.DOMDocument',
'    , p_domnode dbms_xmldom.DOMNode',
'    , p_elem    dbms_xmldom.DOMElement',
'    )',
'      return dbms_xmldom.DOMNode',
'    as',
'      l_new_ext_node     dbms_xmldom.DOMNode;',
'      l_cur_ext_elements dbms_xmldom.DOMNodeList;',
'    begin',
'        ',
'      l_cur_ext_elements :=',
'        dbms_xmldom.getchildrenbytagname',
'        (',
'          elem => p_elem',
'        , name => ''extensionElements''',
'        );',
'',
'      if dbms_xmldom.getlength(l_cur_ext_elements) > 0 then',
'        l_new_ext_node := dbms_xmldom.item(l_cur_ext_elements, 0);',
'      else',
'        -- create extension element node ',
'        l_new_ext_node :=',
'          dbms_xmldom.makenode( elem => ',
'            dbms_xmldom.createelement',
'            ( ',
'              doc     => p_domdoc',
'            , tagName => ''extensionElements''',
'            )',
'          );',
'        -- append',
'        l_new_ext_node :=',
'          dbms_xmldom.appendchild',
'          (',
'            n        => p_domnode',
'          , newchild => l_new_ext_node',
'          );',
'      end if;',
'      return l_new_ext_node;',
'    end get_or_create_ext_elements',
'    ;',
'  begin',
'    -- get xml document',
'    l_data := XMLTYPE(p_dgrm_content);',
'    l_domdoc := dbms_xmldom.newDOMDocument(l_data);',
'',
'    -- retrieve exporter version',
'    if not is_exporter_version_current(l_domdoc) then',
'',
'      -- get tags',
'      l_domnodelist := dbms_xmldom.getelementsbytagname(',
'        doc => l_domdoc',
'      , tagname => ''*''',
'      );',
'  ',
'      -- loop over all tags',
'      for i in 0 .. dbms_xmldom.getlength(l_domnodelist) - 1',
'      loop',
'        l_domnode := dbms_xmldom.item(l_domnodelist, i);',
'        case',
'          -- user tasks',
'          when dbms_xmldom.getnodename(l_domnode) = ''bpmn:userTask'' then',
'            l_domelement := dbms_xmldom.makeelement(l_domnode);',
'            -- set task type attribute',
'            dbms_xmldom.setattribute(',
'              elem => l_domelement',
'            , name => ''apex:type''',
'            , newValue => ''apexPage''',
'            , ns => flow_constants_pkg.gc_nsapex',
'            );',
'',
'            l_extension_node :=',
'              get_or_create_ext_elements',
'              ( ',
'                p_domdoc  => l_domdoc',
'              , p_domnode => l_domnode',
'              , p_elem    => l_domelement',
'              );',
'',
'            -- create apex page node ',
'            l_task_type_node := dbms_xmldom.makenode( ',
'              elem => dbms_xmldom.createelement( ',
'                doc => l_domdoc',
'              , tagName => ''apex:apexPage''',
'              , ns => flow_constants_pkg.gc_nsapex',
'              ) ',
'            );',
'            -- append',
'            l_task_type_node := dbms_xmldom.appendchild(',
'              n => l_extension_node',
'            , newchild => l_task_type_node',
'            );  ',
'            -- get child nodes',
'            l_children := dbms_xmldom.getchildnodes(l_domnode);',
'            l_children_count := dbms_xmldom.getlength(l_children);',
'            -- loop over child nodes',
'            for j in 0 .. l_children_count - 1',
'            loop',
'              l_child_node := dbms_xmldom.item(l_children, j);',
'              case dbms_xmldom.getnodename(l_child_node)',
'                when ''apex:apex-application'' then',
'                  l_ext_child_tag_name := ''apex:applicationId'';',
'                when ''apex:apex-page'' then',
'                  l_ext_child_tag_name := ''apex:pageId'';',
'                when ''apex:apex-request'' then',
'                  l_ext_child_tag_name := ''apex:request'';',
'                when ''apex:apex-cache'' then',
'                  l_ext_child_tag_name := ''apex:cache'';',
'                when ''apex:apex-item'' then',
'                  l_ext_child_tag_name := '''';',
'                  -- get text',
'                  l_items := dbms_xmldom.getnodevalue(dbms_xmldom.getfirstchild(l_child_node));',
'                  -- remove old child',
'                  l_child_node := dbms_xmldom.removechild(',
'                    n => l_domnode',
'                  , oldchild => l_child_node',
'                  ); ',
'                when ''apex:apex-value'' then',
'                  l_ext_child_tag_name := '''';',
'                  -- get text',
'                  l_values := dbms_xmldom.getnodevalue(dbms_xmldom.getfirstchild(l_child_node));',
'                  -- remove old child',
'                  l_child_node := dbms_xmldom.removechild(',
'                    n => l_domnode',
'                  , oldchild => l_child_node',
'                  ); ',
'                else',
'                  l_ext_child_tag_name := '''';',
'              end case;',
'              if length(l_ext_child_tag_name) > 0 then',
'                  -- create new child element node ',
'                  l_ext_child_node := dbms_xmldom.makenode( ',
'                    elem => dbms_xmldom.createelement( ',
'                              doc => l_domdoc',
'                            , tagName => l_ext_child_tag_name',
'                            , ns => flow_constants_pkg.gc_nsapex',
'                            ) ',
'                  );',
'                  -- get text node',
'                  l_child_text_node := dbms_xmldom.getfirstchild(l_child_node);',
'                  if not dbms_xmldom.isnull(l_child_text_node) then',
'                      -- add text node',
'                      l_child_text_node := dbms_xmldom.appendchild(',
'                        n => l_ext_child_node',
'                      , newchild => l_child_text_node',
'                      );',
'                      -- append',
'                      l_ext_child_node := dbms_xmldom.appendchild(',
'                        n => l_task_type_node',
'                      , newchild => l_ext_child_node',
'                      );',
'                  end if;      ',
'                  -- remove old child',
'                  l_child_node := dbms_xmldom.removechild(',
'                    n => l_domnode',
'                  , oldchild => l_child_node',
'                  );  ',
'              end if;',
'            end loop;',
'            -- add page items',
'            if (length(l_items) > 0 or length(l_values) > 0) then',
'              -- create new page items node ',
'              l_ext_child_node := dbms_xmldom.makenode( ',
'                elem => dbms_xmldom.createelement( ',
'                          doc => l_domdoc',
'                        , tagName => ''apex:pageItems''',
'                        , ns => flow_constants_pkg.gc_nsapex',
'                        )',
'              );',
'              -- append',
'              l_ext_child_node := dbms_xmldom.appendchild(',
'                n => l_task_type_node',
'              , newchild => l_ext_child_node',
'              );',
'              l_items_arr := apex_string.split(p_str => l_items, p_sep => '','');',
'              l_values_arr := apex_string.split(p_str => l_values, p_sep => '','');',
'              l_valid_items := least(l_items_arr.count, l_values_arr.count);',
'              for i in 1 .. l_valid_items',
'              loop',
'                append_page_item(',
'                  p_domdoc => l_domdoc',
'                , p_page_items => l_ext_child_node',
'                , p_item_name => l_items_arr(i)',
'                , p_item_value => l_values_arr(i)',
'                );',
'              end loop;',
'              -- item names without values',
'              if l_items_arr.count > l_valid_items then',
'                for i in l_valid_items+1 .. l_items_arr.count',
'                loop',
'                  append_page_item(',
'                    p_domdoc => l_domdoc',
'                  , p_page_items => l_ext_child_node',
'                  , p_item_name => l_items_arr(i)',
'                  , p_item_value => ''''',
'                  );',
'                end loop;',
'              end if;    ',
'              -- item values without names',
'              if l_values_arr.count > l_valid_items then',
'                for i in l_valid_items+1 .. l_values_arr.count',
'                loop',
'                  append_page_item(',
'                    p_domdoc => l_domdoc',
'                  , p_page_items => l_ext_child_node',
'                  , p_item_name => ''''',
'                  , p_item_value => l_values_arr(i)',
'                  );',
'                end loop;',
'              end if;    ',
'              -- reset variables',
'              l_items := null;',
'              l_values := null;',
'            end if;',
'            -- script + service tasks',
'          when dbms_xmldom.getnodename(l_domnode) = ''bpmn:scriptTask'' or dbms_xmldom.getnodename(l_domnode) = ''bpmn:serviceTask'' then  ',
'              l_domelement := dbms_xmldom.makeelement(l_domnode);',
'              -- set task type attribute',
'              dbms_xmldom.setattribute(',
'                elem => l_domelement',
'              , name => ''apex:type''',
'              , newValue => ''executePlsql''',
'              , ns => flow_constants_pkg.gc_nsapex',
'              );',
'',
'            l_extension_node :=',
'              get_or_create_ext_elements',
'              ( ',
'                p_domdoc  => l_domdoc',
'              , p_domnode => l_domnode',
'              , p_elem    => l_domelement',
'              );',
'',
'              -- create execute Plsql node ',
'              l_task_type_node := dbms_xmldom.makenode( ',
'                elem => dbms_xmldom.createelement( ',
'                          doc => l_domdoc',
'                        , tagName => ''apex:executePlsql''',
'                        , ns => flow_constants_pkg.gc_nsapex',
'                        )',
'              );',
'              -- append',
'              l_task_type_node := dbms_xmldom.appendchild(',
'                n => l_extension_node',
'              , newchild => l_task_type_node',
'              );  ',
'              -- get child nodes',
'              l_children := dbms_xmldom.getchildnodes(l_domnode);',
'              l_children_count := dbms_xmldom.getlength(l_children);',
'              -- loop over child nodes',
'              for j in 0 .. l_children_count - 1',
'              loop',
'                l_child_node := dbms_xmldom.item(l_children, j);',
'                case dbms_xmldom.getnodename(l_child_node)',
'                  when ''apex:engine'' then',
'                    l_ext_child_tag_name := ''apex:engine'';',
'                  when ''apex:autoBinds'' then',
'                    l_ext_child_tag_name := ''apex:autoBinds'';',
'                  when ''apex:plsqlCode'' then',
'                    l_ext_child_tag_name := ''apex:plsqlCode'';',
'                  else',
'                    l_ext_child_tag_name := '''';',
'                end case;',
'                if length(l_ext_child_tag_name) > 0 then',
'                  -- create new child node ',
'                  l_ext_child_node := dbms_xmldom.makenode( ',
'                    elem => dbms_xmldom.createelement( ',
'                              doc => l_domdoc',
'                            , tagName => l_ext_child_tag_name',
'                            , ns => flow_constants_pkg.gc_nsapex',
'                            )',
'                  );',
'                  -- get text node',
'                  l_child_text_node := dbms_xmldom.getfirstchild(l_child_node);',
'                  if not dbms_xmldom.isnull(l_child_text_node) then',
'                      -- add text node',
'                      l_child_text_node := dbms_xmldom.appendchild(',
'                        n => l_ext_child_node',
'                      , newchild => l_child_text_node',
'                      );',
'                      -- append',
'                      l_ext_child_node := dbms_xmldom.appendchild(',
'                        n => l_task_type_node',
'                      , newchild => l_ext_child_node',
'                      );',
'                  end if;      ',
'                  -- remove old child',
'                  l_child_node := dbms_xmldom.removechild(',
'                    n => l_domnode',
'                  , oldchild => l_child_node',
'                  );  ',
'                end if;',
'              end loop;',
'          else null;',
'        end case;    ',
'      end loop;',
'  ',
'      -- set new exporter',
'      set_exporter(',
'        p_domdoc => l_domdoc',
'      , p_exporter => ''Flows for APEX''',
'      , p_exporter_version => flow_constants_pkg.gc_version',
'      );',
'',
'      -- update apex namespace',
'      update_apex_namespace(l_domdoc);',
'  ',
'      dbms_lob.createtemporary(l_return, false); ',
'      dbms_xmldom.writetoclob(',
'        doc => l_domdoc ',
'      , cl => l_return',
'      );',
'      p_dgrm_content := l_return;',
'      p_has_changed := true;',
'    else',
'      p_has_changed := false;',
'    end if;',
'  end migrate_xml;',
'',
'end flow_migrate_xml_pkg;',
'/',
'',
'create or replace package body flow_parser_util',
'as',
'',
'  procedure split_property_name',
'  (',
'    pi_property_name  in        varchar2',
'  , po_namespace     out nocopy varchar2',
'  , po_key           out nocopy varchar2',
'  )',
'  as',
'    l_token_pos pls_integer;',
'  begin',
'    l_token_pos := instr( pi_property_name, '':'' );',
'    if l_token_pos is not null then',
'      po_namespace := substr( pi_property_name, 1, instr(pi_property_name, '':'') - 1);',
'      po_key       := substr( pi_property_name, instr(pi_property_name, '':'') + 1 );',
'    else',
'      po_namespace := null;',
'      po_key       := pi_property_name;',
'    end if;',
'',
'  end split_property_name;',
'',
'  function get_property_key( pi_property_name in varchar2 )',
'    return varchar2',
'  as',
'    l_namespace varchar2(32767);',
'    l_key       varchar2(32767);',
'  begin',
'    split_property_name',
'    (',
'      pi_property_name => pi_property_name',
'    , po_namespace     => l_namespace',
'    , po_key           => l_key',
'    );',
'    return l_key;',
'  end get_property_key;',
'',
'  procedure guarantee_apex_object',
'  (',
'    pio_attributes in out nocopy sys.json_object_t',
'  )',
'  as',
'    c_key constant varchar2(20) := ''apex'';',
'  begin',
'    -- Initialize the main object if not done already',
'    pio_attributes := coalesce( pio_attributes, sys.json_object_t() );',
'    -- Create empty "apex" object if not existing',
'    if not pio_attributes.has( c_key ) then',
'      pio_attributes.put( c_key, sys.json_object_t() );',
'    end if;',
'  end guarantee_apex_object;',
'',
'  procedure guarantee_bpmn_object',
'  (',
'    pio_attributes in out nocopy sys.json_object_t',
'  )',
'  as',
'    c_key constant varchar2(20) := ''bpmn'';',
'  begin',
'    -- Initialize the main object if not done already',
'    pio_attributes := coalesce( pio_attributes, sys.json_object_t() );',
'    -- Create empty "bpmn" object if not existing',
'    if not pio_attributes.has( c_key ) then',
'      pio_attributes.put( c_key, sys.json_object_t() );',
'    end if;',
'  end guarantee_bpmn_object;',
'',
'  procedure guarantee_named_object',
'  (',
'    pio_attributes in out nocopy sys.json_object_t',
'  , pi_key         in varchar2',
'  )',
'  as',
'  begin',
'    -- Initialize the main object if not done already',
'    pio_attributes := coalesce( pio_attributes, sys.json_object_t() );',
'    -- Create empty "pi_key" object if not existing',
'    if not pio_attributes.has( pi_key ) then',
'      pio_attributes.put( pi_key, sys.json_object_t() );',
'    end if;',
'  end guarantee_named_object;',
'',
'  /**',
'   * Description: Takes a CLOB and splits it of linefeed or 4000 characters and emits a JSON_ARRAY_T representation',
'   *',
'   * Author:  Moritz Klein',
'   * Created: 4/20/2022',
'   *',
'   * Param: pi_str Input to tokenize at linefeed or 4000 characters',
'   * Return: JSON_ARRAY_T representation of input',
'   */',
'  function get_lines_array',
'  (',
'    pi_str in clob',
'  ) return sys.json_array_t',
'  as',
'    l_values apex_t_varchar2;',
'    l_return sys.json_array_t := sys.json_array_t();',
'  begin',
'    l_values := apex_string.split( p_str => pi_str );',
'    for i in 1..l_values.count loop',
'      if l_values(i) is not null then',
'        l_return.append( l_values(i) );',
'      else -- seems awkward, but this gives you an empty string instead of null into the JSON',
'        l_return.append( '''' );',
'      end if;',
'    end loop;',
'    return l_return;',
'  end get_lines_array;',
'',
'  procedure property_to_json',
'  (',
'    pi_property_name  in        varchar2',
'  , pi_value          in        clob',
'  , po_namespace     out nocopy varchar2',
'  , po_key           out nocopy varchar2',
'  , po_json_element  out nocopy sys.json_element_t',
'  )',
'  as',
'  begin',
'',
'    split_property_name',
'    (',
'      pi_property_name => pi_property_name',
'    , po_namespace     => po_namespace',
'    , po_key           => po_key',
'    );',
'',
'    if pi_property_name in ( flow_constants_pkg.gc_apex_task_plsql_code',
'                           , flow_constants_pkg.gc_bpmn_text',
'                           , flow_constants_pkg.gc_apex_servicetask_body_text',
'                           , flow_constants_pkg.gc_apex_servicetask_body_html',
'                           , flow_constants_pkg.gc_apex_servicetask_attachment',
'                           , flow_constants_pkg.gc_apex_expression',
'                           )',
'    then',
'      po_json_element := get_lines_array( pi_str => pi_value );',
'    elsif pi_property_name in ( flow_constants_pkg.gc_apex_servicetask_placeholder',
'                              , flow_constants_pkg.gc_apex_custom_extension',
'                              )',
'    then',
'      -- this is already JSON, better store differently',
'      po_json_element := sys.json_object_t.parse( replace( replace( pi_value, chr(38)||''amp;'', chr(38) ), chr(10) ) );',
'    ',
'    elsif po_key = ''priority''',
'    then',
'      -- if the attribute priority ends up here it is the pre 23.1 way',
'      -- we don''t touch the diagram but will store the new definition in objt_attributes',
'      po_json_element := sys.json_object_t.parse( ''{ "expressionType":"plsqlRawExpression","expression":["'' || pi_value || ''"]}'' );',
'    else',
'      po_json_element := null;',
'    end if; ',
'  end property_to_json;',
'',
'  function is_log_enabled',
'    return boolean',
'  as',
'    l_value flow_configuration.cfig_value%type;',
'  begin',
'',
'    select cfig_value',
'      into l_value',
'      from flow_configuration',
'     where cfig_key = ''parser_log_enabled''',
'    ;',
'',
'    return ( l_value = flow_constants_pkg.gc_vcbool_true );',
'',
'  exception',
'    when no_data_found then',
'      return false;',
'  end is_log_enabled;',
'',
'  procedure log_internal',
'  (',
'    pi_plog_dgrm_id    in flow_parser_log.plog_dgrm_id%type',
'  , pi_plog_bpmn_id    in flow_parser_log.plog_bpmn_id%type',
'  , pi_plog_parse_step in flow_parser_log.plog_parse_step%type',
'  , pi_plog_payload    in flow_parser_log.plog_payload%type',
'  )',
'  as',
'    pragma autonomous_transaction;',
'  begin',
'    insert into flow_parser_log ( plog_dgrm_id, plog_bpmn_id, plog_parse_step, plog_payload, plog_log_time )',
'      values ( pi_plog_dgrm_id, pi_plog_bpmn_id, pi_plog_parse_step, pi_plog_payload, systimestamp )',
'    ;',
'    commit;',
'  end log_internal;',
'',
'  procedure log',
'  (',
'    pi_plog_dgrm_id    in flow_parser_log.plog_dgrm_id%type',
'  , pi_plog_bpmn_id    in flow_parser_log.plog_bpmn_id%type',
'  , pi_plog_parse_step in flow_parser_log.plog_parse_step%type',
'  , pi_plog_payload    in flow_parser_log.plog_payload%type',
'  )',
'  as',
'  begin',
'',
'    flow_parser_util.log_internal',
'    (',
'      pi_plog_dgrm_id    => pi_plog_dgrm_id',
'    , pi_plog_bpmn_id    => pi_plog_bpmn_id',
'    , pi_plog_parse_step => pi_plog_parse_step',
'    , pi_plog_payload    => pi_plog_payload',
'    );',
'',
'  end log;',
'',
'  procedure log',
'  (',
'    pi_plog_dgrm_id    in flow_parser_log.plog_dgrm_id%type',
'  , pi_plog_bpmn_id    in flow_parser_log.plog_bpmn_id%type',
'  , pi_plog_parse_step in flow_parser_log.plog_parse_step%type',
'  , pi_plog_payload    in sys.xmltype',
'  )',
'  as',
'  begin',
'',
'    flow_parser_util.log_internal',
'    (',
'        pi_plog_dgrm_id    => pi_plog_dgrm_id',
'      , pi_plog_bpmn_id    => pi_plog_bpmn_id',
'      , pi_plog_parse_step => pi_plog_parse_step',
'      , pi_plog_payload    => case when pi_plog_payload is not null then pi_plog_payload.getclobval else null end',
'    );',
'',
'  end log;',
'',
'  procedure clear_log',
'  (',
'    pi_plog_dgrm_id in flow_parser_log.plog_dgrm_id%type',
'  )',
'  as',
'  begin',
'    delete from flow_parser_log where plog_dgrm_id = pi_plog_dgrm_id;',
'  end clear_log;',
'',
'end flow_parser_util;',
'/',
'',
'create or replace package body flow_bpmn_parser_pkg',
'as',
'/* ',
'-- Flows for APEX - flow_bpmn_parser_pkg.pkb',
'-- ',
'-- (c) Copyright MT AG, 2021-2022.',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'--',
'-- Created    2020         Moritz Klein (MT AG)',
'-- Modified   2022-08-10   Moritz Klein (MT AG)',
'-- Modified   2023-03-10   Moritz Klein (MT GmbH)',
'-- Modified   2023-04-12   Moritz Klein (MT GmbH)',
'-- Modified   2023-05-16   Moritz Klein (MT GmbH)',
'-- Modified   2024-07-19   Moritz Klein (Hyand Solutions GmbH)',
'--',
'*/',
'',
'  -- Configuration Settings',
'  g_log_enabled    boolean := false;',
'',
'  -- Variables to hold data during parse run',
'  g_dgrm_id        flow_diagrams.dgrm_id%type;',
'  g_objects        flow_parser_util.t_objt_tab;',
'  g_objt_expr      flow_parser_util.t_objt_expr_tab;',
'  g_connections    flow_parser_util.t_conn_tab;',
'  g_lane_refs      flow_parser_util.t_bpmn_ref_tab;',
'  g_collab_refs    flow_parser_util.t_bpmn_ref_tab;',
'  g_default_cons   flow_parser_util.t_bpmn_id_tab;',
'  g_objt_lookup    flow_parser_util.t_id_lookup_tab;',
'',
'  procedure register_object',
'  (',
'    pi_objt_bpmn_id        in flow_objects.objt_bpmn_id%type',
'  , pi_objt_name           in flow_objects.objt_name%type default null',
'  , pi_objt_tag_name       in flow_objects.objt_tag_name%type default null',
'  , pi_objt_sub_tag_name   in flow_objects.objt_sub_tag_name%type default null',
'  , pi_objt_parent_bpmn_id in flow_objects.objt_bpmn_id%type default null',
'  , pi_objt_attached_to    in flow_objects.objt_attached_to%type default null ',
'  , pi_objt_interrupting   in flow_objects.objt_interrupting%type default null',
'  )',
'  as',
'    l_objt_rec flow_parser_util.t_objt_rec;',
'  begin',
'    if pi_objt_bpmn_id is not null then',
'      if g_objects.exists( pi_objt_bpmn_id ) then',
'        l_objt_rec := g_objects( pi_objt_bpmn_id );',
'      end if;',
'      l_objt_rec.objt_name           := coalesce( pi_objt_name, l_objt_rec.objt_name );',
'      l_objt_rec.objt_tag_name       := coalesce( pi_objt_tag_name, l_objt_rec.objt_tag_name );',
'      l_objt_rec.objt_sub_tag_name   := coalesce( pi_objt_sub_tag_name, l_objt_rec.objt_sub_tag_name );',
'      l_objt_rec.objt_parent_bpmn_id := coalesce( pi_objt_parent_bpmn_id, l_objt_rec.objt_parent_bpmn_id );',
'      l_objt_rec.objt_attached_to    := coalesce( pi_objt_attached_to, l_objt_rec.objt_attached_to );',
'      l_objt_rec.objt_interrupting   := coalesce( pi_objt_interrupting, l_objt_rec.objt_interrupting );',
'',
'      g_objects( pi_objt_bpmn_id ) := l_objt_rec;',
'    end if;',
'  end register_object;',
'',
'  procedure register_object_attribute',
'  (',
'    pi_objt_bpmn_id   in flow_types_pkg.t_bpmn_id',
'  , pi_attribute_name in flow_types_pkg.t_bpmn_attributes_key',
'  , pi_value          in clob',
'  )',
'  as',
'    l_namespace        flow_types_pkg.t_vc200;',
'    l_attribute        flow_types_pkg.t_vc200;',
'    l_namespace_object sys.json_object_t;',
'    l_json_element     sys.json_element_t;',
'  begin',
'',
'    if not g_objects.exists( pi_objt_bpmn_id ) then',
'      register_object( pi_objt_bpmn_id => pi_objt_bpmn_id );',
'    end if;',
'',
'    if g_objects(pi_objt_bpmn_id).objt_attributes is null then',
'            g_objects(pi_objt_bpmn_id).objt_attributes := sys.json_object_t();',
'    end if;',
'',
'    flow_parser_util.property_to_json',
'    (',
'      pi_property_name => pi_attribute_name',
'    , pi_value         => pi_value',
'    , po_namespace     => l_namespace',
'    , po_key           => l_attribute',
'    , po_json_element  => l_json_element',
'    );',
'',
'    if l_namespace is not null then',
'      flow_parser_util.guarantee_named_object',
'      (',
'        pio_attributes => g_objects(pi_objt_bpmn_id).objt_attributes',
'      , pi_key         => l_namespace',
'      );',
'      l_namespace_object := g_objects(pi_objt_bpmn_id).objt_attributes.get_object( l_namespace );',
'    else',
'      l_namespace_object := g_objects(pi_objt_bpmn_id).objt_attributes;',
'    end if;',
'',
'    if l_json_element is not null then',
'      l_namespace_object.put( l_attribute, l_json_element );',
'    elsif pi_value in ( flow_constants_pkg.gc_vcbool_true, flow_constants_pkg.gc_vcbool_false ) then',
'      l_namespace_object.put( l_attribute, (pi_value = flow_constants_pkg.gc_vcbool_true) );',
'    else',
'      l_namespace_object.put( l_attribute, pi_value );',
'    end if;',
'',
'  end register_object_attribute;',
'',
'  procedure register_object_expression',
'  (',
'    pi_objt_bpmn_id    in flow_objects.objt_bpmn_id%type',
'  , pi_expr_set        in flow_object_expressions.expr_set%type',
'  , pi_expr_order      in flow_object_expressions.expr_order%type',
'  , pi_expr_var_name   in flow_object_expressions.expr_var_name%type',
'  , pi_expr_var_type   in flow_object_expressions.expr_var_type%type',
'  , pi_expr_type       in flow_object_expressions.expr_type%type',
'  , pi_expr_expression in flow_object_expressions.expr_expression%type',
'  )',
'  as',
'    l_object_expression flow_parser_util.t_expr_rec;',
'    l_insert_index      pls_integer := 0;',
'  begin',
'    if pi_objt_bpmn_id is not null th'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'en',
'      l_object_expression.expr_set        := pi_expr_set;',
'      l_object_expression.expr_order      := pi_expr_order;',
'      l_object_expression.expr_var_name   := pi_expr_var_name;',
'      l_object_expression.expr_var_type   := pi_expr_var_type;',
'      l_object_expression.expr_type       := pi_expr_type;',
'      l_object_expression.expr_expression := pi_expr_expression;    ',
'',
'      -- Verify if we already have some variable expression for same object',
'      if g_objt_expr.exists(pi_objt_bpmn_id) then',
'        l_insert_index := g_objt_expr(pi_objt_bpmn_id).count + 1;',
'      else',
'        l_insert_index := 1;',
'      end if;',
'',
'      g_objt_expr(pi_objt_bpmn_id)(l_insert_index) := l_object_expression;',
'    end if;',
'  end register_object_expression;',
'',
'  procedure register_connection',
'  (',
'    pi_conn_bpmn_id     in flow_connections.conn_bpmn_id%type',
'  , pi_conn_name        in flow_connections.conn_name%type',
'  , pi_conn_src_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , pi_conn_tgt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , pi_conn_tag_name    in flow_connections.conn_tag_name%type',
'  , pi_conn_origin      in flow_connections.conn_origin%type',
'  , pi_conn_sequence    in flow_connections.conn_sequence%type',
'  , pi_conn_attributes  in sys.json_object_t default null',
'  )',
'  as',
'    l_conn_rec flow_parser_util.t_conn_rec;',
'  begin',
'    if pi_conn_bpmn_id is not null then',
'      l_conn_rec.conn_name        := pi_conn_name;',
'      l_conn_rec.conn_src_bpmn_id := pi_conn_src_bpmn_id;',
'      l_conn_rec.conn_tgt_bpmn_id := pi_conn_tgt_bpmn_id;',
'      l_conn_rec.conn_tag_name    := pi_conn_tag_name;',
'      l_conn_rec.conn_origin      := pi_conn_origin;',
'      l_conn_rec.conn_sequence    := pi_conn_sequence;',
'      l_conn_rec.conn_attributes  := pi_conn_attributes;',
'',
'      g_connections( pi_conn_bpmn_id ) := l_conn_rec;',
'    end if;',
'  end register_connection;',
'',
'  procedure register_connection_attribute',
'  (',
'    pi_conn_bpmn_id   in flow_types_pkg.t_bpmn_id',
'  , pi_attribute_name in flow_types_pkg.t_bpmn_attributes_key',
'  , pi_value          in clob',
'  )',
'  as',
'    l_namespace        flow_types_pkg.t_vc200;',
'    l_attribute        flow_types_pkg.t_vc200;',
'    l_namespace_object sys.json_object_t;',
'    l_json_element     sys.json_object_t;',
'  begin',
'',
'    if g_connections(pi_conn_bpmn_id).conn_attributes is null then',
'      g_connections(pi_conn_bpmn_id).conn_attributes := sys.json_object_t();',
'    end if;',
'',
'    flow_parser_util.property_to_json',
'    (',
'      pi_property_name => pi_attribute_name',
'    , pi_value         => pi_value',
'    , po_namespace     => l_namespace',
'    , po_key           => l_attribute',
'    , po_json_element  => l_json_element',
'    );',
'',
'    if l_namespace is not null then',
'      flow_parser_util.guarantee_named_object',
'      (',
'        pio_attributes => g_connections(pi_conn_bpmn_id).conn_attributes',
'      , pi_key         => l_namespace',
'      );',
'      l_namespace_object := g_connections(pi_conn_bpmn_id).conn_attributes.get_object( l_namespace );',
'    else',
'      l_namespace_object := g_connections(pi_conn_bpmn_id).conn_attributes;',
'    end if;',
'',
'    if l_json_element is not null then',
'      l_namespace_object.put( l_attribute, l_json_element );',
'    elsif pi_value in ( flow_constants_pkg.gc_vcbool_true, flow_constants_pkg.gc_vcbool_false ) then',
'      l_namespace_object.put( l_attribute, (pi_value = flow_constants_pkg.gc_vcbool_true) );',
'    else',
'      l_namespace_object.put( l_attribute, pi_value );',
'    end if;',
'',
'  end register_connection_attribute;',
'',
'  procedure insert_object',
'  (',
'    pi_objt_bpmn_id       in flow_objects.objt_bpmn_id%type',
'  , pi_objt_name          in flow_objects.objt_name%type default null',
'  , pi_objt_tag_name      in flow_objects.objt_tag_name%type default null',
'  , pi_objt_objt_id       in flow_objects.objt_objt_id%type default null',
'  , pi_objt_sub_tag_name  in flow_objects.objt_sub_tag_name%type default null',
'  , pi_objt_objt_lane_id  in flow_objects.objt_objt_lane_id%type default null',
'  , pi_objt_attached_to   in flow_objects.objt_attached_to%type default null',
'  , pi_objt_interrupting  in flow_objects.objt_interrupting%type default null',
'  , pi_objt_attributes    in flow_objects.objt_attributes%type default null',
'  , po_objt_id           out nocopy flow_objects.objt_id%type',
'  )',
'  as',
'  begin',
'    insert',
'      into flow_objects',
'           (',
'             objt_dgrm_id',
'           , objt_bpmn_id',
'           , objt_name',
'           , objt_tag_name',
'           , objt_sub_tag_name',
'           , objt_objt_id',
'           , objt_objt_lane_id',
'           , objt_attached_to',
'           , objt_interrupting',
'           , objt_attributes',
'           )',
'    values (',
'             g_dgrm_id',
'           , pi_objt_bpmn_id',
'           , pi_objt_name',
'           , pi_objt_tag_name',
'           , pi_objt_sub_tag_name',
'           , pi_objt_objt_id',
'           , pi_objt_objt_lane_id',
'           , pi_objt_attached_to',
'           , pi_objt_interrupting',
'           , pi_objt_attributes',
'           )',
'      returning objt_id into po_objt_id',
'    ;',
'  end insert_object;',
'',
'  procedure insert_object_expression',
'  (',
'    pi_expr_objt_id    in flow_object_expressions.expr_objt_id%type',
'  , pi_expr_set        in flow_object_expressions.expr_set%type',
'  , pi_expr_order      in flow_object_expressions.expr_order%type',
'  , pi_expr_var_name   in flow_object_expressions.expr_var_name%type',
'  , pi_expr_var_type   in flow_object_expressions.expr_var_type%type',
'  , pi_expr_type       in flow_object_expressions.expr_type%type',
'  , pi_expr_expression in flow_object_expressions.expr_expression%type',
'  )',
'  as',
'  begin',
'    insert',
'      into flow_object_expressions',
'           (',
'             expr_objt_id',
'           , expr_set',
'           , expr_order',
'           , expr_var_name',
'           , expr_var_type',
'           , expr_type',
'           , expr_expression',
'           )',
'    values (',
'             pi_expr_objt_id',
'           , pi_expr_set',
'           , pi_expr_order',
'           , pi_expr_var_name',
'           , upper(pi_expr_var_type)',
'           , pi_expr_type',
'           , pi_expr_expression',
'           )',
'    ;',
'  end insert_object_expression;',
'',
'  procedure insert_connection',
'  (',
'    pi_conn_bpmn_id      in flow_connections.conn_bpmn_id%type',
'  , pi_conn_name         in flow_connections.conn_name%type',
'  , pi_conn_src_objt_id  in flow_connections.conn_src_objt_id%type',
'  , pi_conn_tgt_objt_id  in flow_connections.conn_tgt_objt_id%type',
'  , pi_conn_tag_name     in flow_connections.conn_tag_name%type',
'  , pi_conn_origin       in flow_connections.conn_origin%type',
'  , pi_conn_sequence     in flow_connections.conn_sequence%type',
'  , pi_conn_attributes   in flow_connections.conn_attributes%type',
'  , po_conn_id          out flow_connections.conn_id%type',
'  )',
'  as',
'    l_conn_is_default flow_connections.conn_is_default%type := 0;',
'  begin',
'    l_conn_is_default := case when g_default_cons.exists(pi_conn_bpmn_id) then 1 else 0 end;',
'    insert',
'      into flow_connections',
'            (',
'              conn_dgrm_id',
'            , conn_bpmn_id',
'            , conn_name',
'            , conn_src_objt_id',
'            , conn_tgt_objt_id',
'            , conn_tag_name',
'            , conn_origin',
'            , conn_is_default',
'            , conn_sequence',
'            , conn_attributes',
'            )',
'    values (',
'              g_dgrm_id',
'            , pi_conn_bpmn_id',
'            , pi_conn_name',
'            , pi_conn_src_objt_id',
'            , pi_conn_tgt_objt_id',
'            , pi_conn_tag_name',
'            , pi_conn_origin',
'            , l_conn_is_default',
'            , pi_conn_sequence',
'            , pi_conn_attributes',
'            )',
'      returning conn_id into po_conn_id',
'    ;',
'  end insert_connection;',
'',
'  procedure process_object_expressions',
'  (',
'    pi_objt_id       in flow_object_expressions.expr_objt_id%type',
'  , pi_objt_bpmn_id  in flow_types_pkg.t_bpmn_id    ',
'  )',
'  as',
'    l_cur_expressions flow_parser_util.t_expr_tab;',
'    l_cur_index       pls_integer;',
'  begin',
'    if g_objt_expr.exists(pi_objt_bpmn_id) then',
'      l_cur_index       := g_objt_expr(pi_objt_bpmn_id).first;',
'      while l_cur_index is not null loop',
'        insert_object_expression',
'        (',
'          pi_expr_objt_id    => pi_objt_id',
'        , pi_expr_set        => g_objt_expr(pi_objt_bpmn_id)(l_cur_index).expr_set',
'        , pi_expr_order      => g_objt_expr(pi_objt_bpmn_id)(l_cur_index).expr_order',
'        , pi_expr_var_name   => g_objt_expr(pi_objt_bpmn_id)(l_cur_index).expr_var_name',
'        , pi_expr_var_type   => g_objt_expr(pi_objt_bpmn_id)(l_cur_index).expr_var_type',
'        , pi_expr_type       => g_objt_expr(pi_objt_bpmn_id)(l_cur_index).expr_type',
'        , pi_expr_expression => g_objt_expr(pi_objt_bpmn_id)(l_cur_index).expr_expression',
'        );',
'        l_cur_index := g_objt_expr(pi_objt_bpmn_id).next(l_cur_index);',
'      end loop;',
'    end if;',
'  end process_object_expressions;',
'',
'  procedure process_objects',
'  as',
'    l_cur_objt_bpmn_id  flow_types_pkg.t_bpmn_id;',
'    l_next_objt_bpmn_id flow_types_pkg.t_bpmn_id;',
'    l_cur_object        flow_parser_util.t_objt_rec;',
'    l_objt_id           flow_objects.objt_id%type;',
'    l_parent_check      boolean;',
'    l_lane_check        boolean;',
'  begin',
'',
'    l_cur_objt_bpmn_id := g_objects.first;',
'    while l_cur_objt_bpmn_id is not null',
'    loop',
'      -- reset object id, we get it if insert done',
'      l_objt_id      := null;',
'      l_cur_object   := g_objects( l_cur_objt_bpmn_id );',
'',
'      -- check possible parent and lane',
'      -- either not set or ID already known',
'      l_parent_check :=',
'           l_cur_object.objt_parent_bpmn_id is null',
'        or (   l_cur_object.objt_parent_bpmn_id is not null',
'           and g_objt_lookup.exists( l_cur_object.objt_parent_bpmn_id )',
'           )',
'      ;',
'      l_lane_check :=',
'           not g_lane_refs.exists( l_cur_objt_bpmn_id )',
'        or ( g_lane_refs.exists( l_cur_objt_bpmn_id )',
'           and g_objt_lookup.exists( g_lane_refs( l_cur_objt_bpmn_id ) )',
'           )',
'      ;',
'',
'      -- checks passed insert into table',
'      if l_parent_check and l_lane_check  then',
'',
'        insert_object',
'        (',
'          pi_objt_bpmn_id      => l_cur_objt_bpmn_id',
'        , pi_objt_name         => l_cur_object.objt_name',
'        , pi_objt_tag_name     => l_cur_object.objt_tag_name',
'        , pi_objt_objt_id      => case when l_cur_object.objt_parent_bpmn_id is not null then g_objt_lookup( l_cur_object.objt_parent_bpmn_id ) else null end',
'        , pi_objt_objt_lane_id => case when g_lane_refs.exists( l_cur_objt_bpmn_id ) then g_objt_lookup( g_lane_refs( l_cur_objt_bpmn_id ) ) else null end',
'        , pi_objt_sub_tag_name => l_cur_object.objt_sub_tag_name',
'        , pi_objt_attached_to  => l_cur_object.objt_attached_to',
'        , pi_objt_interrupting => l_cur_object.objt_interrupting',
'        , pi_objt_attributes   => case when l_cur_object.objt_attributes is not null then l_cur_object.objt_attributes.to_clob else null end',
'        , po_objt_id           => l_objt_id',
'        );',
'',
'        process_object_expressions',
'        (',
'          pi_objt_id      => l_objt_id',
'        , pi_objt_bpmn_id => l_cur_objt_bpmn_id',
'        );',
'',
'      -- checks not passed skip record for now',
'      else',
'        null;',
'      end if;',
'',
'      -- Get next ID for lookup and if object was processed',
'      -- put it into lookup and remove from things to process',
'      l_next_objt_bpmn_id := g_objects.next( l_cur_objt_bpmn_id );',
'      if l_objt_id is not null then',
'',
'        g_objt_lookup( l_cur_objt_bpmn_id ) := l_objt_id;',
'        g_objects.delete( l_cur_objt_bpmn_id );',
'',
'      end if;',
'',
'      l_cur_objt_bpmn_id := l_next_objt_bpmn_id;',
'    end loop;',
'',
'    -- restart with remaining set if still objects to process',
'    if g_objects.count > 0 then',
'      process_objects;',
'    end if;',
'  end process_objects;',
'',
'  procedure process_connections',
'  as',
'    l_cur_conn_bpmn_id flow_types_pkg.t_bpmn_id;',
'    l_cur_conn         flow_parser_util.t_conn_rec;',
'    l_conn_id          flow_connections.conn_id%type;',
'  begin',
'',
'    l_cur_conn_bpmn_id := g_connections.first;',
'    while l_cur_conn_bpmn_id is not null',
'    loop',
'      l_conn_id  := null;',
'      l_cur_conn := g_connections( l_cur_conn_bpmn_id );',
'',
'      -- verify if we know the IDs for source and target connection if set',
'      -- anything strange stop all processing and raise error',
'      if (  ( l_cur_conn.conn_src_bpmn_id is not null and not g_objt_lookup.exists( l_cur_conn.conn_src_bpmn_id ) )',
'         or ( l_cur_conn.conn_tgt_bpmn_id is not null and not g_objt_lookup.exists( l_cur_conn.conn_tgt_bpmn_id ) )',
'         )',
'      then',
'        raise_application_error(-20000, ''Connection Source or Target not found!'');',
'      else',
'        insert_connection',
'        (',
'          pi_conn_bpmn_id      => l_cur_conn_bpmn_id',
'        , pi_conn_name         => l_cur_conn.conn_name',
'        , pi_conn_src_objt_id  => case when l_cur_conn.conn_src_bpmn_id is not null then g_objt_lookup( l_cur_conn.conn_src_bpmn_id ) else null end',
'        , pi_conn_tgt_objt_id  => case when l_cur_conn.conn_tgt_bpmn_id is not null then g_objt_lookup( l_cur_conn.conn_tgt_bpmn_id ) else null end',
'        , pi_conn_tag_name     => l_cur_conn.conn_tag_name',
'        , pi_conn_origin       => l_cur_conn.conn_origin',
'        , pi_conn_sequence     => l_cur_conn.conn_sequence',
'        , pi_conn_attributes   => case when l_cur_conn.conn_attributes is not null then l_cur_conn.conn_attributes.to_clob else null end',
'        , po_conn_id           => l_conn_id',
'        );',
'      end if;',
'',
'      l_cur_conn_bpmn_id := g_connections.next( l_cur_conn_bpmn_id );',
'    end loop;',
'',
'  end process_connections;',
'',
'  procedure finalize',
'  as',
'  begin',
'',
'    process_objects;',
'    process_connections;',
'',
'  end finalize;',
'',
'  function upload_diagram',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_force_overwrite in boolean default false',
'  )',
'    return flow_diagrams.dgrm_id%type',
'  as',
'    l_cnt     number;',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'  begin',
'',
'    begin',
'      select dgrm_id',
'        into l_dgrm_id',
'        from flow_diagrams',
'       where dgrm_name = pi_dgrm_name',
'         and dgrm_version = pi_dgrm_version',
'      ;',
'    exception',
'      when no_data_found then',
'        l_dgrm_id := null;',
'    end;',
'',
'    if l_dgrm_id is null then',
'      insert',
'        into flow_diagrams ( dgrm_name, dgrm_version, dgrm_category, dgrm_status, dgrm_last_update, dgrm_content )',
'        values ( pi_dgrm_name, pi_dgrm_version, pi_dgrm_category, ',
'                 pi_dgrm_status,  systimestamp, pi_dgrm_content )',
'      returning dgrm_id into l_dgrm_id',
'      ;',
'    else',
'      if (pi_force_overwrite) then',
'        update flow_diagrams',
'          set dgrm_content = pi_dgrm_content',
'            , dgrm_last_update = systimestamp',
'            , dgrm_status  = pi_dgrm_status',
'        where dgrm_id = l_dgrm_id',
'        ;',
'      end if;',
'    end if;',
'',
'    return l_dgrm_id;',
'',
'  end upload_diagram;',
'',
'  procedure upload_diagram',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_force_overwrite in boolean default false',
'  )',
'  as',
'  begin',
'    g_dgrm_id := upload_diagram( pi_dgrm_name => pi_dgrm_name, pi_dgrm_version => pi_dgrm_version,',
'                                 pi_dgrm_category => pi_dgrm_category, pi_dgrm_content => pi_dgrm_content,',
'                                 pi_dgrm_status => pi_dgrm_status, pi_force_overwrite => pi_force_overwrite',
'                                  );',
'  end upload_diagram;',
'',
'  procedure cleanup_parsing_tables',
'  as',
'  begin',
'    delete',
'      from flow_connections conn',
'     where conn.conn_dgrm_id = g_dgrm_id',
'    ;',
'',
'    delete',
'      from flow_objects objt',
'     where objt.objt_dgrm_id = g_dgrm_id',
'    ;',
'  end cleanup_parsing_tables;',
'',
'  procedure parse_page_items',
'  (',
'    pi_bpmn_id         in flow_types_pkg.t_bpmn_id',
'  , pi_page_items_xml  in sys.xmltype',
'  )',
'  as',
'    l_page_item   sys.json_object_t;',
'    l_page_items  sys.json_array_t := sys.json_array_t();',
'    l_apex_object sys.json_object_t;',
'  begin',
'    for rec in (',
'                select items.item_name',
'                     , items.item_value',
'                  from xmltable',
'                       (',
'                         xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn", ''https://flowsforapex.org'' as "apex" )',
'                       , ''*'' passing pi_page_items_xml',
'                         columns',
'                           item_name  varchar2(  50 char) path ''apex:itemName''',
'                         , item_value varchar2(4000 char) path ''apex:itemValue''',
'                       ) items',
'               )',
'    loop',
'      l_page_item := sys.json_object_t();',
'      l_page_item.put( ''name'', rec.item_name );',
'      l_page_item.put( ''value'', rec.item_value );',
'      l_page_items.append( l_page_item );',
'    end loop;',
'    flow_parser_util.guarantee_apex_object( pio_attributes => g_objects(pi_bpmn_id).objt_attributes);',
'',
'    -- Complex JSON types are handled by reference',
'    l_apex_object := g_objects(pi_bpmn_id).objt_attributes.get_object( ''apex'' );',
'    l_apex_object.put( ''pageItems'', l_page_items );',
'  end parse_page_items;',
'  ',
'  procedure parse_parameters',
'  (',
'    pi_bpmn_id        in flow_types_pkg.t_bpmn_id',
'  , pi_parameters_xml in sys.xmltype',
'  )',
'  as',
'    l_param_array clob;',
'    l_apex_object sys.json_object_t;',
'  begin',
'',
'    select json_arrayagg( json_object',
'                          (',
'                            key ''parStaticId'' is parameter_static_id',
'                          , key ''parDataType'' is parameter_data_type',
'                          , key ''parValue''    is parameter_value',
'                          )',
'                        ) as par_obj',
'      into l_param_array',
'      from xmltable',
'           (',
'             xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn", ''https://flowsforapex.org'' as "apex" )',
'           , ''*'' passing pi_parameters_xml',
'             columns',
'               parameter_static_id varchar2(  50 char) path ''apex:parStaticId''',
'             , parameter_data_type varchar2(  50 char) path ''apex:parDataType''',
'             , parameter_value     varchar2(4000 char) path ''apex:parValue''',
'           )',
'    ;',
'',
'    if l_param_array is not null then',
'      flow_parser_util.guarantee_apex_object( pio_attributes => g_objects(pi_bpmn_id).objt_attributes );',
'      l_apex_object := g_objects(pi_bpmn_id).objt_attributes.get_object( ''apex'' );',
'      l_apex_object.put( ''parameters'', sys.json_array_t.parse( l_param_array ) );',
'    end if;',
'  end parse_parameters;',
'',
'  procedure parse_task_subtypes',
'  (',
'    pi_bpmn_id     in flow_types_pkg.t_bpmn_id',
'  , pi_subtype_xml in sys.xmltype',
'  )',
'  as',
'    l_namespace        flow_types_pkg.t_vc200;',
'    l_attribute        flow_types_pkg.t_vc200;',
'    l_json_element     sys.json_element_t;',
'    l_namespace_object sys.json_object_t;',
'  begin',
'',
'    for rec in (',
'                select props.prop_name',
'                     , props.prop_value',
'                     , props.prop_children',
'                  from xmltable',
'                       (',
'                         xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                                      , ''https://flowsforapex.org'' as "apex")',
'                       , ''*'' passing pi_subtype_xml',
'                         columns',
'                           prop_name     varchar2(50 char) path ''name()''',
'                         , prop_value    clob              path ''text()''',
'                         , prop_children sys.xmltype       path ''* except bpmn:incoming except bpmn:outgoing''',
'                       ) props',
'               )',
'    loop',
'      -- User Task: nested page items are handled separately',
'      if rec.prop_name = flow_constants_pkg.gc_apex_usertask_page_items then',
'        parse_page_items',
'        (',
'          pi_bpmn_id        => pi_bpmn_id',
'        , pi_page_items_xml => rec.prop_children',
'        );',
'      -- Array of Parameter Bindings, used by Unified Tasklist Integration',
'      elsif rec.prop_name = flow_constants_pkg.gc_apex_usertask_parameters then',
'        parse_parameters',
'        (',
'          pi_bpmn_id        => pi_bpmn_id',
'        , pi_parameters_xml => rec.prop_children',
'        );',
'      elsif length(rec.prop_value) > 0 then',
'        flow_parser_util.property_to_json',
'        (',
'          pi_property_name => rec.prop_name',
'        , pi_value         => rec.prop_value',
'        , po_namespace     => l_namespace',
'        , po_key           => l_attribute',
'        , po_json_element  => l_json_element',
'        );',
'',
'        flow_parser_util.guarantee_named_object( pio_attributes => g_objects(pi_bpmn_id).objt_attributes, pi_key => l_namespace );',
'        l_namespace_object := g_objects(pi_bpmn_id).objt_attributes.get_object( l_namespace );',
'        if l_json_element is not null then',
'          l_namespace_object.put( l_attribute, l_json_element );',
'        else',
'          -- Need to create real booleans in JSON',
'          if rec.prop_value in ( flow_constants_pkg.gc_vcbool_true, flow_constants_pkg.gc_vcbool_false ) then',
'            l_namespace_object.put( l_attribute, ( rec.prop_value = flow_constants_pkg.gc_vcbool_true ) );',
'          else',
'            l_namespace_object.put( l_attribute, rec.prop_value );',
'          end if;',
'        end if;',
'      --Empty properties will not be stored',
'      else',
'        null;',
'      end if;',
'    end loop;',
'  end parse_task_subtypes;',
'',
'  procedure parse_process_variables',
'  (',
'    pi_bpmn_id         in flow_types_pkg.t_bpmn_id',
'  , pi_execution_point in varchar2',
'  , pi_proc_vars_xml   in sys.xmltype',
'  )',
'  as',
'  begin',
'    for rec in (',
'                select variable_sequence',
'                     , variable_name',
'                     , case variable_type',
'                         when ''TIMESTAMP_WITH_TIME_ZONE'' then ''TIMESTAMP WITH TIME ZONE''',
'                         else variable_type',
'                       end as variable_type',
'                     , expression_type',
'                     , expression_value',
'                  from xmltable',
'                       (',
'                         xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn", ''https://flowsforapex.org'' as "apex" )',
'                       , ''*'' passing pi_proc_vars_xml',
'                         columns',
'                           variable_sequence number              path ''apex:varSequence''',
'                         , variable_name     varchar2(50 char)   path ''apex:varName''',
'                         , variable_type     varchar2(50 char)   path ''apex:varDataType''',
'                         , expression_type   varchar2(200 char)  path ''apex:varExpressionType''',
'                         , expression_value  varchar2(4000 char) path ''apex:varExpression''',
'                       )',
'               )',
'    loop',
'      register_object_expression',
'      (',
'        pi_objt_bpmn_id    => pi_bpmn_id',
'      , pi_expr_set        => pi_execution_point',
'      , pi_expr_order      => rec.variable_sequence',
'      , pi_expr_var_name   => rec.variable_name',
'      , pi_expr_var_type   => rec.variable_type',
'      , pi_expr_type       => rec.expression_type',
'      , pi_expr_expression => rec.expression_value',
'      );',
'    end loop;',
'  end parse_process_variables;',
'',
'  procedure parse_custom_timers',
'  (',
'    pi_bpmn_id     in flow_types_pkg.t_bpmn_id',
'  , pi_subtype_xml in sys.xmltype',
'  )',
'  as',
'    l_namespace        flow_types_pkg.t_vc200;',
'    l_attribute        flow_types_pkg.t_vc200;',
'    l_namespace_object sys.json_object_t;',
'    l_json_element     sys.json_element_t;',
'  begin',
'',
'    for rec in (',
'                select props.prop_name',
'                     , props.prop_value',
'                     , props.prop_children',
'                  from xmltable',
'                       (',
'                         xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                                      , ''https://flowsforapex.org'' as "apex")',
'                       , ''*'' passing pi_subtype_xml',
'                         columns',
'                           prop_name     varchar2(50 char)    path ''name()''',
'                         , prop_value    varchar2(4000 char)  path ''text()''',
'                         , prop_children sys.xmltype          path ''* except bpmn:incoming except bpmn:outgoing''',
'                       ) props',
'               )',
'    loop',
'      if length(rec.prop_value) > 0 then',
'        flow_parser_util.property_to_json',
'        (',
'          pi_property_name => rec.prop_name',
'        , pi_value         => rec.prop_value',
'        , po_namespace     => l_namespace',
'        , po_key           => l_attribute',
'        , po_json_element  => l_json_element',
'        );',
'',
'        flow_parser_util.guarantee_named_object( pio_attributes => g_objects(pi_bpmn_id).objt_attributes, pi_key => l_namespace );',
'        l_namespace_object := g_objects(pi_bpmn_id).objt_attributes.get_object( l_namespace );',
'        if l_json_element is not null then',
'          l_namespace_object.put( l_attribute, l_json_element );',
'        else',
'          l_namespace_object.put( l_attribute, rec.prop_value );',
'        end if;',
'      end if;',
'    end loop;',
'  end parse_custom_timers;',
'',
'  procedure parse_simple_expression',
'  (',
'    pi_objt_bpmn_id in flow_types_pkg.t_bpmn_id',
'  , pi_ext_type     in varchar2',
'  , pi_exp_type     in varchar2',
'  , pi_exp_fmt_mask in varchar2',
'  , pi_exp_val      in clob',
'  )',
'  as',
'    l_apex_object sys.json_object_t;',
'    l_ext_object  sys.json_object_t := sys.json_object_t();',
'  begin',
'    if not g_objects.exists( pi_objt_bpmn_id ) then',
'      register_object( pi_objt_bpmn_id => pi_objt_bpmn_id );',
'      g_objects(pi_objt_bpmn_id).objt_attributes := sys.json_object_t();',
'    end if;',
'    flow_parser_util.guarantee_apex_object( pio_attributes => g_objects(pi_objt_bpmn_id).objt_attributes );',
'    l_apex_object := g_objects(pi_objt_bpmn_id).objt_attributes.get_object( ''apex'' );',
'',
'    l_ext_object.put( ''expressionType'', pi_exp_type );',
'    if pi_exp_type in ( flow_constants_pkg.gc_expr_type_sql, flow_constants_pkg.gc_expr_type_sql_delimited_list',
'                      , flow_constants_pkg.gc_expr_type_plsql_expression, flow_constants_pkg.gc_expr_type_plsql_function_body',
'                      , flow_constants_pkg.gc_expr_type_plsql_raw_expression, flow_constants_pkg.gc_expr_type_plsql_raw_function_body',
'                      )',
'    then',
'      l_ext_object.put( ''expression'', flow_parser_util.get_lines_array( pi_str => pi_exp_val ) );',
'    else',
'      l_ext_object.put( ''expression'', pi_exp_val );',
'    end if;',
'',
'    if pi_exp_fmt_mask is not null then',
'      l_ext_object.put( ''formatMask'', pi_exp_fmt_mask );',
'    end if;',
'',
'    l_apex_object.put( replace(pi_ext_type, ''apex:''), l_ext_object );',
'  end parse_simple_expression;',
'',
'  procedure parse_extension_elements',
'  (',
'    pi_bpmn_id       in flow_types_pkg.t_bpmn_id',
'  , pi_extension_xml in sys.xmltype',
'  )',
'  as',
'  begin',
'',
'    if g_log_enabled then',
'      flow_parser_util.log',
'      (',
'        pi_plog_dgrm_id    => g_dgrm_id',
'      , pi_plog_bpmn_id    => pi_bpmn_id',
'      , pi_plog_parse_step => ''parse_extension_elements''',
'      , pi_plog_payload    => pi_extension_xml',
'      );',
'    end if;',
'    ',
'    for rec in (',
'                select replace(extension_type, ''apex:'') as extension_type',
'                     , extension_type as orig_extension_type',
'                     , extension_data',
'                     , extension_exp_type',
'                     , extension_exp_val',
'                     , extension_fmt_mask',
'                     , extension_text',
'                  from xmltable',
'                       (',
'                         xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn", ''https://flowsforapex.org'' as "apex" )',
'                       , ''/bpmn:extensionElements/*'' passing pi_extension_xml',
'                         columns',
'                           extension_type     varchar2( 50 char) path ''name()''',
'                         , extension_data     sys.xmltype        path ''*''',
'                         , extension_exp_type varchar2( 50 char) path ''apex:expressionType''',
'                         , extension_exp_val  clob               path ''apex:expression''',
'                         , extension_fmt_mask varchar2(200 char) path ''apex:formatMask''',
'                         , extension_text     clob               path ''text()''',
'                       ) ',
'               )',
'    loop',
'      -- Process Variables',
'      if rec.extension_type in ( flow_constants_pkg.gc_expr_set_before_task, flow_constants_pkg.gc_expr_set_after_task',
'                               , flow_constants_pkg.gc_expr_set_before_split, flow_constants_pkg.gc_expr_set_after_merge',
'                               , flow_constants_pkg.gc_expr_set_before_event, flow_constants_pkg.gc_expr_set_on_event',
'                               , flow_constants_pkg.gc_expr_set_in_variables, flow_constants_pkg.gc_expr_set_out_variables',
'                               )',
'      then',
'        parse_process_variables',
'        (',
'          pi_bpmn_id         => pi_bpmn_id',
'        , pi_execution_point => rec.extension_type',
'        , pi_proc_vars_xml   => rec.extension_data',
'        );',
'      -- Task Subtypes',
'  '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    elsif rec.extension_type in ( flow_constants_pkg.gc_apex_usertask_apex_page',
'                                  , flow_constants_pkg.gc_apex_usertask_apex_approval',
'                                  , flow_constants_pkg.gc_apex_usertask_apex_simple_form',
'                                  , flow_constants_pkg.gc_apex_usertask_external_url',
'                                  , flow_constants_pkg.gc_apex_servicetask_send_mail',
'                                  , flow_constants_pkg.gc_apex_task_execute_plsql',
'                                  )',
'      then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_bpmn_id',
'        , pi_attribute_name => flow_constants_pkg.gc_task_type_key',
'        , pi_value          => rec.extension_type',
'        );',
'  ',
'        -- parse properties',
'        parse_task_subtypes',
'        (',
'          pi_bpmn_id     => pi_bpmn_id',
'        , pi_subtype_xml => rec.extension_data',
'        );',
'      -- Custom Timers',
'      elsif rec.extension_type in ( flow_constants_pkg.gc_timer_type_oracle_date',
'                                  , flow_constants_pkg.gc_timer_type_oracle_duration',
'                                  , flow_constants_pkg.gc_timer_type_oracle_cycle',
'                                  )',
'      then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_bpmn_id',
'        , pi_attribute_name => flow_constants_pkg.gc_timer_type_key',
'        , pi_value          => rec.extension_type',
'        );',
'        g_objects(pi_bpmn_id).objt_sub_tag_name := flow_constants_pkg.gc_bpmn_timer_event_definition;',
'',
'        -- parse properties',
'        parse_custom_timers',
'        (',
'          pi_bpmn_id     => pi_bpmn_id',
'        , pi_subtype_xml => rec.extension_data',
'        );',
'      -- Standard Expressions with expressionType and expression nested',
'      elsif rec.extension_exp_type is not null then',
'        if g_log_enabled then',
'          flow_parser_util.log',
'          (',
'            pi_plog_dgrm_id    => g_dgrm_id',
'          , pi_plog_bpmn_id    => pi_bpmn_id',
'          , pi_plog_parse_step => ''when standard expression''',
'          , pi_plog_payload    => ''extension_type: '' || rec.extension_type',
'          );',
'        end if;',
'',
'        parse_simple_expression',
'        (',
'          pi_objt_bpmn_id => pi_bpmn_id',
'        , pi_ext_type     => rec.extension_type',
'        , pi_exp_type     => rec.extension_exp_type',
'        , pi_exp_fmt_mask => rec.extension_fmt_mask',
'        , pi_exp_val      => rec.extension_exp_val',
'        );',
'      else',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_bpmn_id',
'        , pi_attribute_name => rec.orig_extension_type',
'        , pi_value          => rec.extension_text',
'        );',
'      end if;',
'    end loop;',
'  end parse_extension_elements;',
'',
'  procedure parse_iterator_attributes',
'  (',
'    pi_objt_bpmn_id       in flow_types_pkg.t_bpmn_id',
'  , pi_iterator_type      in varchar2',
'  , pi_is_sequential      in varchar2',
'  , pi_extension_elements in sys.xmltype',
'  )',
'  as',
'    l_apex_object      sys.json_object_t;',
'    l_iterator_object  sys.json_object_t := sys.json_object_t();',
'    l_ext_object       sys.json_object_t;',
'  begin',
'    if g_log_enabled then',
'      flow_parser_util.log',
'      (',
'        pi_plog_dgrm_id    => g_dgrm_id',
'      , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'      , pi_plog_parse_step => ''parse_iterator_attributes''',
'      , pi_plog_payload    => pi_extension_elements',
'      );',
'    end if;',
'',
'    if not g_objects.exists( pi_objt_bpmn_id ) then',
'      register_object( pi_objt_bpmn_id => pi_objt_bpmn_id );',
'      g_objects(pi_objt_bpmn_id).objt_attributes := sys.json_object_t();',
'    end if;',
'    flow_parser_util.guarantee_apex_object( pio_attributes => g_objects(pi_objt_bpmn_id).objt_attributes );',
'    l_apex_object := g_objects(pi_objt_bpmn_id).objt_attributes.get_object( ''apex'' );',
'',
'    l_iterator_object.put( key => ''isSequential'', val => case when pi_is_sequential = flow_constants_pkg.gc_vcbool_true then true else false end );',
'',
'    for rec in (',
'                select replace(extension_type, ''apex:'') as extension_type',
'                     , extension_type as orig_extension_type',
'                     , extension_data',
'                     , extension_exp_type',
'                     , extension_exp_val',
'                     , inside_variable',
'                     , extension_text',
'                  from xmltable',
'                       (',
'                         xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn", ''https://flowsforapex.org'' as "apex" )',
'                       , ''/bpmn:extensionElements/*'' passing pi_extension_elements',
'                         columns',
'                           extension_type     varchar2(  50 char) path ''name()''',
'                         , extension_data     sys.xmltype         path ''*''',
'                         , extension_exp_type varchar2(  50 char) path ''apex:expressionType''',
'                         , extension_exp_val  clob                path ''apex:expression''',
'                         , inside_variable    varchar2(4000 char) path ''apex:insideVariable''',
'                         , extension_text     clob                path ''text()''',
'                       ) ',
'               )',
'    loop',
'',
'      l_ext_object := sys.json_object_t();',
'',
'      if rec.extension_exp_type != flow_constants_pkg.gc_apex_iterator_description then',
'        l_ext_object.put( key => ''expressionType'', val => rec.extension_exp_type );',
'',
'        if rec.extension_exp_type in ( flow_constants_pkg.gc_expr_type_sql, flow_constants_pkg.gc_expr_type_sql_delimited_list',
'                                    , flow_constants_pkg.gc_expr_type_plsql_expression, flow_constants_pkg.gc_expr_type_plsql_function_body',
'                                    , flow_constants_pkg.gc_expr_type_plsql_raw_expression, flow_constants_pkg.gc_expr_type_plsql_raw_function_body',
'                                    )',
'        then',
'          l_ext_object.put( ''expression'', flow_parser_util.get_lines_array( pi_str => rec.extension_exp_val ) );',
'        else',
'          l_ext_object.put( ''expression'', rec.extension_exp_val );',
'        end if;',
'',
'        if rec.inside_variable is not null then',
'          l_ext_object.put( key => ''insideVariable'', val => rec.inside_variable );',
'        end if;',
'',
'        l_iterator_object.put( key => rec.extension_type, val => l_ext_object );',
'      else',
'        if rec.extension_text is not null then',
'          l_iterator_object.put( key => ''description'', val => rec.extension_text );',
'        end if;',
'      end if;',
'    end loop;',
'    ',
'    l_apex_object.put( key => replace( pi_iterator_type, ''bpmn:'' ), val => l_iterator_object );',
'',
'  end parse_iterator_attributes;',
'',
'  procedure parse_flow_node_refs',
'  (',
'    pi_lane_refs_xml  in sys.xmltype',
'  , pi_parent_bpmn_id in flow_types_pkg.t_bpmn_id',
'  )',
'  as',
'  begin',
'    for node_rec in (',
'        select nodes.node_ref',
'          from xmltable',
'             (',
'               xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'             , ''*'' passing pi_lane_refs_xml',
'               columns',
'                 node_ref   varchar2(50 char) path ''text()''',
'             ) nodes',
'    ) loop',
'      g_lane_refs( node_rec.node_ref ) := pi_parent_bpmn_id;',
'    end loop;',
'  end parse_flow_node_refs;',
'',
'  procedure parse_laneset',
'  (',
'    pi_laneset_xml    in sys.xmltype',
'  , pi_parent_bpmn_id in flow_types_pkg.t_bpmn_id',
'  )',
'  as',
'    l_laneset_id  flow_types_pkg.t_bpmn_id;',
'    l_laneset_tag flow_types_pkg.t_bpmn_id;',
'    l_lanes_xml   sys.xmltype;',
'  begin',
'',
'    select laneset_id',
'         , laneset_tag',
'         , lanes_xml',
'      into l_laneset_id',
'         , l_laneset_tag',
'         , l_lanes_xml',
'      from xmltable',
'           (',
'             xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                           , ''https://flowsforapex.org'' as "apex")',
'           , ''*'' passing pi_laneset_xml',
'             columns',
'               laneset_id    varchar2(50 char) path ''@id''',
'             , laneset_tag   varchar2(50 char) path ''name()''',
'             , lanes_xml     sys.xmltype       path ''*''',
'           )',
'    ;',
'',
'    register_object',
'    (',
'      pi_objt_bpmn_id        => l_laneset_id',
'    , pi_objt_tag_name       => l_laneset_tag',
'    , pi_objt_parent_bpmn_id => pi_parent_bpmn_id',
'    );',
'',
'    for lane_rec in (',
'      select lane_id',
'           , lane_name',
'           , lane_type',
'           , lane_is_role',
'           , lane_role',
'           , node_refs',
'           , child_laneset',
'           , lane_extensions',
'        from xmltable',
'             (',
'               xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                             , ''https://flowsforapex.org'' as "apex"',
'                             )',
'             , ''*'' passing l_lanes_xml',
'               columns',
'                 lane_id         varchar2( 50 char) path ''@id''',
'               , lane_name       varchar2(200 char) path ''@name''',
'               , lane_type       varchar2( 50 char) path ''name()''',
'               , lane_is_role    varchar2( 50 char) path ''@apex:isRole''',
'               , lane_role       varchar2(200 char) path ''@apex:role''',
'               , node_refs       sys.xmltype        path ''* except bpmn:childLaneSet except bpmn:extensionElements''',
'               , child_laneset   sys.xmltype        path ''bpmn:childLaneSet''',
'               , lane_extensions sys.xmltype        path ''bpmn:extensionElements''',
'             )',
'    ) loop',
'',
'      register_object',
'      (',
'        pi_objt_bpmn_id        => lane_rec.lane_id',
'      , pi_objt_name           => lane_rec.lane_name',
'      , pi_objt_tag_name       => lane_rec.lane_type',
'      , pi_objt_parent_bpmn_id => l_laneset_id',
'      );',
'',
'      if lane_rec.lane_is_role is not null then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => lane_rec.lane_id',
'        , pi_attribute_name => ''apex:isRole''',
'        , pi_value          => lane_rec.lane_is_role',
'        );',
'      end if;',
'',
'      if lane_rec.lane_is_role is not null then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => lane_rec.lane_id',
'        , pi_attribute_name => ''apex:role''',
'        , pi_value          => lane_rec.lane_role',
'        );',
'      end if;',
'',
'      parse_extension_elements',
'      (',
'        pi_bpmn_id       => lane_rec.lane_id',
'      , pi_extension_xml => lane_rec.lane_extensions',
'      );',
'',
'      if lane_rec.child_laneset is not null then',
'        -- ignore flowNodeRefs on this level as they duplicate lower levels',
'        -- jump into childLaneSet parsing (recursion)',
'        parse_laneset',
'        (',
'          pi_laneset_xml    => lane_rec.child_laneset',
'        , pi_parent_bpmn_id => lane_rec.lane_id',
'        );',
'      else',
'        parse_flow_node_refs',
'        (',
'          pi_lane_refs_xml  => lane_rec.node_refs',
'        , pi_parent_bpmn_id => lane_rec.lane_id',
'        );',
'      end if;',
'',
'    end loop;',
'',
'  end parse_laneset;',
'',
'  function find_subtag_name',
'  (',
'    pi_xml in sys.xmltype',
'  )',
'    return flow_types_pkg.t_bpmn_id',
'  as',
'    c_nsmap        constant flow_types_pkg.t_vc200 := flow_constants_pkg.gc_nsmap;',
'    l_return                flow_types_pkg.t_bpmn_id;',
'  begin',
'    l_return :=',
'      case',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_terminate_event_definition, nsmap => c_nsmap ) = 1   then flow_constants_pkg.gc_bpmn_terminate_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_timer_event_definition, nsmap => c_nsmap ) = 1       then flow_constants_pkg.gc_bpmn_timer_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_timer_type_date, nsmap => c_nsmap ) = 1                   then flow_constants_pkg.gc_timer_type_date',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_timer_type_duration, nsmap => c_nsmap ) = 1               then flow_constants_pkg.gc_timer_type_duration',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_timer_type_cycle, nsmap => c_nsmap ) = 1                  then flow_constants_pkg.gc_timer_type_cycle',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_error_event_definition, nsmap => c_nsmap ) = 1       then flow_constants_pkg.gc_bpmn_error_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_escalation_event_definition, nsmap => c_nsmap ) = 1  then flow_constants_pkg.gc_bpmn_escalation_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_link_event_definition, nsmap => c_nsmap ) = 1        then flow_constants_pkg.gc_bpmn_link_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_message_event_definition, nsmap => c_nsmap ) = 1     then flow_constants_pkg.gc_bpmn_message_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_conditional_event_definition, nsmap => c_nsmap ) = 1 then flow_constants_pkg.gc_bpmn_conditional_event_definition',
'        when pi_xml.existsNode( xpath => ''/'' || flow_constants_pkg.gc_bpmn_signal_event_definition, nsmap => c_nsmap ) = 1      then flow_constants_pkg.gc_bpmn_signal_event_definition',
'        else null',
'      end',
'    ;',
'',
'    return l_return;',
'  end find_subtag_name;',
'',
'  procedure parse_process_extensions',
'  (',
'    pi_objt_bpmn_id in flow_types_pkg.t_bpmn_id',
'  , pi_xml          in sys.xmltype',
'  )',
'  as',
'    l_apex_object  sys.json_object_t;',
'    l_var_array    flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'    flow_parser_util.guarantee_apex_object( pio_attributes => g_objects(pi_objt_bpmn_id).objt_attributes );',
'    l_apex_object := g_objects(pi_objt_bpmn_id).objt_attributes.get_object( ''apex'' );',
'',
'    -- Extensions which use expressionType + expression structure',
'    for rec in (',
'      select ext_type',
'           , exp_type',
'           , exp_value',
'           , exp_fmt_mask',
'           , ext_text',
'        from xmltable',
'             (',
'               xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                             , ''https://flowsforapex.org'' as "apex")',
'             , ''/bpmn:extensionElements/*'' passing pi_xml',
'               columns',
'                 ext_type     varchar2( 50 char) path ''name()''',
'               , exp_type     varchar2( 50 char) path ''apex:expressionType''',
'               , exp_value    clob               path ''apex:expression''',
'               , exp_fmt_mask varchar2(200 char) path ''apex:formatMask''',
'               , ext_text     clob               path ''text()''',
'             ) ext',
'    ) loop',
'      if rec.exp_type is not null then',
'        parse_simple_expression',
'        (',
'          pi_objt_bpmn_id => pi_objt_bpmn_id',
'        , pi_ext_type     => rec.ext_type',
'        , pi_exp_type     => rec.exp_type',
'        , pi_exp_fmt_mask => rec.exp_fmt_mask',
'        , pi_exp_val      => rec.exp_value',
'        );',
'      elsif rec.ext_type = flow_constants_pkg.gc_apex_custom_extension then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_objt_bpmn_id',
'        , pi_attribute_name => rec.ext_type',
'        , pi_value          => rec.ext_text',
'        );',
'      end if;',
'    end loop;',
'',
'    -- Parse in vs. out variables separately',
'    -- Makes it easier to understand in the code',
'    -- while not hitting performance too much',
'',
'    select json_arrayagg',
'           (',
'             json_object',
'             (',
'               key ''varName''        is var_name',
'             , key ''varDataType''    is var_datatype',
'             , key ''varDescription'' is var_description',
'             )',
'           ) in_var_array',
'      into l_var_array',
'      from xmltable',
'           (',
'             xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                           , ''https://flowsforapex.org'' as "apex")',
'           , ''/bpmn:extensionElements/apex:inVariables/apex:processVariable[*]'' passing pi_xml',
'             columns',
'               var_name        varchar2(50 char) path ''apex:varName''',
'             , var_datatype    varchar2(50 char) path ''apex:varDataType''',
'             , var_description varchar2(50 char) path ''apex:varDescription''',
'           )',
'    ;',
'',
'    -- If no inVariables are found the variable is null',
'    if l_var_array is not null then',
'      l_apex_object.put( ''inVariables'', sys.json_array_t.parse( l_var_array ) );',
'    end if;',
'',
'    select json_arrayagg',
'           (',
'             json_object',
'             (',
'               key ''varName''        is var_name',
'             , key ''varDataType''    is var_datatype',
'             , key ''varDescription'' is var_description',
'             )',
'           ) in_var_array',
'      into l_var_array',
'      from xmltable',
'           (',
'             xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                           , ''https://flowsforapex.org'' as "apex")',
'           , ''/bpmn:extensionElements/apex:outVariables/apex:processVariable[*]'' passing pi_xml',
'             columns',
'               var_name        varchar2(50 char) path ''apex:varName''',
'             , var_datatype    varchar2(50 char) path ''apex:varDataType''',
'             , var_description varchar2(50 char) path ''apex:varDescription''',
'           )',
'    ;',
'',
'    if l_var_array is not null then',
'      l_apex_object.put( ''outVariables'', sys.json_array_t.parse( l_var_array ) );',
'    end if;',
'',
'  end parse_process_extensions;',
'',
'  procedure parse_child_elements',
'  (',
'    pi_objt_bpmn_id in flow_types_pkg.t_bpmn_id',
'  , pi_xml          in sys.xmltype',
'  )',
'  as',
'    l_child_type         flow_types_pkg.t_bpmn_id;',
'    l_child_id           flow_types_pkg.t_bpmn_id;',
'    l_child_value        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_child_details      sys.xmltype;',
'    l_detail_type        flow_types_pkg.t_bpmn_id;',
'    l_detail_id          flow_types_pkg.t_bpmn_id;',
'    l_detail_value       flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'',
'    if g_log_enabled then',
'      flow_parser_util.log',
'      (',
'        pi_plog_dgrm_id    => g_dgrm_id',
'      , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'      , pi_plog_parse_step => ''parse_child_elements''',
'      , pi_plog_payload    => pi_xml',
'      );',
'    end if;',
'',
'',
'    for rec in (',
'                select children.child_type',
'                     , children.child_id',
'                     , children.child_value',
'                     , children.child_details',
'                     , children.extension_elements',
'                     , children.message_ref',
'                     , children.is_sequential',
'                  from xmltable',
'                       (',
'                         xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                                      , ''https://flowsforapex.org'' as "apex")',
'                       , ''*'' passing pi_xml',
'                         columns',
'                           child_type         varchar2(  50 char)  path ''name()''',
'                         , child_id           varchar2(  50 char)  path ''@id''',
'                         , child_value        varchar2(4000 char)  path ''text()''',
'                         , message_ref        varchar2(  50 char)  path ''@messageRef''',
'                         , is_sequential      varchar2(  50 char)  path ''@isSequential''',
'                         , child_details      sys.xmltype          path ''* except bpmn:incoming except bpmn:outgoing except bpmn:extensionElements''',
'                         , extension_elements sys.xmltype          path ''bpmn:extensionElements''',
'                       ) children',
'               )',
'    loop',
'',
'      if rec.child_details is null then',
'        -- register the child which does not have details',
'        if rec.child_value is not null then',
'          -- if needed distinguish here between different attributes',
'',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id    => pi_objt_bpmn_id',
'          , pi_attribute_name  => rec.child_type',
'          , pi_value           => rec.child_value',
'          );',
'        end if;',
'      end if;',
'      -- register the child which has details',
'      case rec.child_type',
'        when flow_constants_pkg.gc_bpmn_timer_event_definition then',
'        -- if custom (Flows) type then all processing is done by using the extension element',
'          if rec.extension_elements is not null then',
'            parse_extension_elements',
'            ( ',
'              pi_bpmn_id       => pi_objt_bpmn_id',
'            , pi_extension_xml => rec.extension_elements',
'            );',
'          -- if standard type just register value inside tag',
'          elsif rec.child_details is not null then',
'            if g_log_enabled then',
'              flow_parser_util.log',
'              (',
'                pi_plog_dgrm_id    => g_dgrm_id',
'              , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'              , pi_plog_parse_step => ''parse_child_elements - not timer''',
'              , pi_plog_payload    => rec.child_details',
'              );',
'            end if;',
'',
'            select details.detail_type',
'                 , details.detail_id',
'                 , details.detail_value',
'              into l_detail_type',
'                 , l_detail_id',
'                 , l_detail_value',
'              from xmltable',
'                   (',
'                     xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'                   , ''*'' passing rec.child_details',
'                     columns',
'                       detail_type        varchar2(50 char)    path ''name()''',
'                     , detail_id          varchar2(50 char)    path ''@id''',
'                     , detail_value       varchar2(4000 char)  path ''text()''',
'                   ) details',
'            ;',
'',
'            -- register the timer type',
'            register_object_attribute',
'            (',
'              pi_objt_bpmn_id   => pi_objt_bpmn_id',
'            , pi_attribute_name => flow_constants_pkg.gc_timer_type_key',
'            , pi_value          => l_detail_type',
'            );',
'',
'            register_object_attribute',
'            (',
'              pi_objt_bpmn_id   => pi_objt_bpmn_id',
'            , pi_attribute_name => flow_constants_pkg.gc_timer_def_key',
'            , pi_value          => l_detail_value',
'            );',
'          end if;',
'        -- custom processStatus attribute on terminateEndEvents',
'        when flow_constants_pkg.gc_bpmn_terminate_event_definition then',
'          if g_log_enabled then',
'            flow_parser_util.log',
'            (',
'              pi_plog_dgrm_id    => g_dgrm_id',
'            , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'            , pi_plog_parse_step => ''when '' || flow_constants_pkg.gc_bpmn_terminate_event_definition',
'            , pi_plog_payload    => rec.child_details',
'            );',
'          end if;',
'',
'          if rec.child_details is not null then',
'            select details.detail_type',
'                 , details.detail_value',
'              into l_detail_type',
'                 , l_detail_value',
'              from xmltable',
'                    (',
'                      xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'                    , ''*'' passing rec.child_details',
'                      columns',
'                        detail_type  varchar2(50 char) path   ''name()''',
'                      , detail_value varchar2(4000 char) path ''text()''',
'                    ) details',
'            ;',
'            if l_detail_type = flow_constants_pkg.gc_apex_process_status then',
'              register_object_attribute',
'              (',
'                pi_objt_bpmn_id   => pi_objt_bpmn_id',
'              , pi_attribute_name => flow_constants_pkg.gc_terminate_result',
'              , pi_value          => l_detail_value',
'              );',
'            end if;',
'          end if;',
'        when flow_constants_pkg.gc_bpmn_message_event_definition then',
'',
'          if g_log_enabled then',
'            flow_parser_util.log',
'            (',
'              pi_plog_dgrm_id    => g_dgrm_id',
'            , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'            , pi_plog_parse_step => ''when '' || flow_constants_pkg.gc_bpmn_message_event_definition',
'            , pi_plog_payload    => rec.extension_elements',
'            );',
'          end if;',
'',
'          if rec.message_ref is not null then',
'            register_object_attribute',
'            (',
'              pi_objt_bpmn_id   => pi_objt_bpmn_id',
'            , pi_attribute_name => ''messageRef''',
'            , pi_value          => rec.message_ref',
'            );',
'          end if;',
'          if rec.extension_elements is not null then',
'            parse_extension_elements',
'            ( ',
'              pi_bpmn_id       => pi_objt_bpmn_id',
'            , pi_extension_xml => rec.extension_elements',
'            );',
'          end if;',
'        when flow_constants_pkg.gc_bpmn_multi_instance_loop then',
'          if g_log_enabled then',
'            flow_parser_util.log',
'            (',
'              pi_plog_dgrm_id    => g_dgrm_id',
'            , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'            , pi_plog_parse_step => ''when '' || flow_constants_pkg.gc_bpmn_multi_instance_loop',
'            , pi_plog_payload    => ''isSequential: '' || rec.is_sequential',
'            );',
'          end if;',
'',
'          parse_iterator_attributes',
'          (',
'            pi_objt_bpmn_id       => pi_objt_bpmn_id',
'          , pi_iterator_type      => rec.child_type',
'          , pi_is_sequential      => rec.is_sequential',
'          , pi_extension_elements => rec.extension_elements',
'          );',
'        when flow_constants_pkg.gc_bpmn_standard_loop then',
'          if g_log_enabled then',
'            flow_parser_util.log',
'            (',
'              pi_plog_dgrm_id    => g_dgrm_id',
'            , pi_plog_bpmn_id    => pi_objt_bpmn_id',
'            , pi_plog_parse_step => ''when '' || flow_constants_pkg.gc_bpmn_standard_loop',
'            , pi_plog_payload    => ''isSequential: '' || rec.is_sequential',
'            );',
'          end if;',
'',
'          parse_iterator_attributes',
'          (',
'            pi_objt_bpmn_id       => pi_objt_bpmn_id',
'          , pi_iterator_type      => rec.child_type',
'          , pi_is_sequential      => rec.is_sequential',
'          , pi_extension_elements => rec.extension_elements',
'          );',
'        else',
'          null;',
'      end case;',
'',
'    end loop;',
'',
'  end parse_child_elements;',
'',
'  procedure parse_call_activity',
'  (',
'    pi_xml          in sys.xmltype',
'  , pi_objt_bpmn_id in flow_types_pkg.t_bpmn_id',
'  )',
'  as',
'  begin',
'',
'    for rec in (',
'                select activity.activity_diagram',
'                     , activity.activity_versionSelection',
'                     , activity.activity_version',
'                  from xmltable',
'                       (',
'                         xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                                       , ''https://flowsforapex.org'' as "apex")',
'                       , ''*'' passing pi_xml',
'                         columns',
'                           activity_diagram          varchar2(50 char) path ''@apex:calledDiagram''',
'                         , activity_versionSelection varchar2(50 char) path ''@apex:calledDiagramVersionSelection''',
'                         , activity_version          varchar2(50 char) path ''@apex:calledDiagramVersion''',
'                       ) activity',
'               )',
'    loop',
'',
'      if rec.activity_diagram is not null then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_objt_bpmn_id',
'        , pi_attribute_name => flow_constants_pkg.gc_apex_called_diagram',
'        , pi_value          => rec.activity_diagram',
'        );',
'      end if;',
'',
'      if rec.activity_versionSelection is not null then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_objt_bpmn_id',
'        , pi_attribute_name => flow_constants_pkg.gc_apex_called_diagram_version_selection',
'        , pi_value          => rec.activity_versionSelection',
'        );',
'      end if;',
'',
'      if rec.activity_version is not null then',
'        register_object_attribute',
'        (',
'          pi_objt_bpmn_id   => pi_objt_bpmn_id',
'        , pi_attribute_name => flow_constants_pkg.gc_apex_called_diagram_version',
'        , pi_value          => rec.activity_version',
'        );',
'      end if;',
'',
'    end loop;',
'',
'  end parse_call_activity;',
'',
'  function get_connection_attributes',
'  (',
'    pi_conn_bpmn_id in flow_types_pkg.t_bpmn_id',
'  , pi_xml          in sys.xmltype',
'  ) return sys.json_object_t',
'  as',
'    l_condition_base       flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_condition_expression clob;',
'    l_condition_object     sys.json_object_t;',
'    l_expression_array     sys.json_array_t;',
'    l_attributes_json      sys.json_object_t := sys.json_object_t();',
'  begin',
'    select json_object( key ''language'' is condition_language )',
'         , condition_value',
'      into l_condition_base',
'         , l_condition_expression',
'      from xmltable',
'           (',
'             xmlnamespaces( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                          , ''https://flowsforapex.org'' as "apex")',
'           , ''/bpmn:conditionExpression'' passing pi_xml',
'             columns',
'               condition_language varchar2(50 char) path ''@language''',
'             , condition_value    clob              path ''text()''',
'           )',
'    ;',
'    l_condition_object := sys.json_object_t.parse( l_condition_base );',
'    l_expression_array := flow_parser_util.get_lines_array( pi_str => l_condition_expression );',
'    l_condition_object.put( ''expression'', l_expression_array );',
'',
'    l_attributes_json.put( ''conditionExpression'', l_condition_object );',
'    return l_attributes_json;',
'  exception',
'    when no_data_found then',
'      return null;'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'  end get_connection_attributes;',
'',
'  procedure parse_connection_extensions',
'  (',
'    pi_conn_bpmn_id     in     flow_types_pkg.t_bpmn_id',
'  , pi_xml              in     sys.xmltype',
'  , pio_conn_attributes in out sys.json_object_t',
'  )',
'  as',
'    l_apex_object sys.json_object_t;',
'    l_namespace    flow_types_pkg.t_bpmn_id;',
'    l_key          flow_types_pkg.t_bpmn_attributes_key;',
'    l_json_element sys.json_element_t;',
'  begin',
'    flow_parser_util.guarantee_apex_object( pio_attributes => pio_conn_attributes );',
'    l_apex_object := pio_conn_attributes.get_object( ''apex'' );',
'',
'    for rec in (',
'      select ext_type',
'           , ext_text',
'        from xmltable',
'             (',
'               xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                             , ''https://flowsforapex.org'' as "apex")',
'             , ''/bpmn:extensionElements/*'' passing pi_xml',
'               columns',
'                 ext_type  varchar2( 50 char) path ''name()''',
'               , ext_text  clob               path ''text()''',
'             ) ext',
'       where ext_type = flow_constants_pkg.gc_apex_custom_extension',
'    ) loop',
'      flow_parser_util.property_to_json',
'      (',
'        pi_property_name => rec.ext_type',
'      , pi_value         => rec.ext_text',
'      , po_namespace     => l_namespace',
'      , po_key           => l_key',
'      , po_json_element  => l_json_element',
'      );',
'      if l_json_element is not null then',
'        l_apex_object.put( l_key, l_json_element );',
'      end if;',
'    end loop;',
'  end parse_connection_extensions;',
'',
'  procedure parse_steps',
'  (',
'    pi_xml          in sys.xmltype',
'  , pi_proc_type    in flow_types_pkg.t_bpmn_id',
'  , pi_proc_bpmn_id in flow_types_pkg.t_bpmn_id',
'  )',
'  as',
'    l_objt_sub_tag_name flow_objects.objt_sub_tag_name%type;',
'    l_conn_attributes   sys.json_object_t;',
'  begin',
'    if g_log_enabled then',
'      flow_parser_util.log',
'      (',
'        pi_plog_dgrm_id    => g_dgrm_id',
'      , pi_plog_bpmn_id    => pi_proc_bpmn_id',
'      , pi_plog_parse_step => ''parse_steps''',
'      , pi_plog_payload    => pi_xml',
'      );',
'    end if;',
'',
'    for rec in (',
'                select steps.steps_type',
'                     , steps.steps_name',
'                     , steps.steps_id',
'                     , steps.source_ref',
'                     , steps.target_ref',
'                     , steps.default_conn',
'                     , steps.attached_to',
'                     , case steps.steps_type',
'                         when flow_constants_pkg.gc_bpmn_boundary_event then',
'                           case steps.interrupting',
'                             when flow_constants_pkg.gc_vcbool_false then 0',
'                             else 1',
'                           end',
'                         else',
'                           null',
'                       end as interrupting',
'                     , steps.conn_sequence',
'                     , steps.task_type',
'                     , steps.is_sequential',
'                     , steps.child_elements',
'                     , steps.extension_elements',
'                     , steps.step',
'                  from xmltable',
'                       (',
'                         xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                                       , ''https://flowsforapex.org'' as "apex")',
'                       , ''*'' passing pi_xml',
'                         columns',
'                           steps_type         varchar2( 50 char) path ''name()''',
'                         , steps_name         varchar2(200 char) path ''@name''',
'                         , steps_id           varchar2( 50 char) path ''@id''',
'                         , source_ref         varchar2( 50 char) path ''@sourceRef''',
'                         , target_ref         varchar2( 50 char) path ''@targetRef''',
'                         , default_conn       varchar2( 50 char) path ''@default''',
'                         , attached_to        varchar2( 50 char) path ''@attachedToRef''',
'                         , interrupting       varchar2( 50 char) path ''@cancelActivity''',
'                         , conn_sequence      number             path ''@apex:sequence''',
'                         , task_type          varchar2( 50 char) path ''@apex:type''',
'                         , is_sequential      varchar2( 50 char) path ''@isSequential''',
'                         , child_elements     sys.xmltype        path ''* except bpmn:incoming except bpmn:outgoing except bpmn:extensionElements''',
'                         , extension_elements sys.xmltype        path ''bpmn:extensionElements''',
'                         , step               sys.xmltype        path ''.''',
'                       ) steps',
'               )',
'    loop',
'      if g_log_enabled then',
'',
'        if rec.steps_id is null then',
'          flow_parser_util.log',
'          (',
'            pi_plog_dgrm_id    => g_dgrm_id',
'          , pi_plog_bpmn_id    => pi_proc_bpmn_id',
'          , pi_plog_parse_step => ''parse_steps - loop''',
'          , pi_plog_payload    => ''No step_id. In process of type '' || pi_proc_type || '' with id '' || pi_proc_bpmn_id',
'          );',
'        end if;',
'',
'        flow_parser_util.log',
'        (',
'          pi_plog_dgrm_id    => g_dgrm_id',
'        , pi_plog_bpmn_id    => rec.steps_id',
'        , pi_plog_parse_step => ''parse_steps - loop step data''',
'        , pi_plog_payload    => rec.step',
'        );',
'',
'        flow_parser_util.log',
'        (',
'          pi_plog_dgrm_id    => g_dgrm_id',
'        , pi_plog_bpmn_id    => rec.steps_id',
'        , pi_plog_parse_step => ''parse_steps - loop childElements data''',
'        , pi_plog_payload    => rec.child_elements',
'        );',
'',
'        flow_parser_util.log',
'        (',
'          pi_plog_dgrm_id    => g_dgrm_id',
'        , pi_plog_bpmn_id    => rec.steps_id',
'        , pi_plog_parse_step => ''parse_steps - loop extensionElements data''',
'        , pi_plog_payload    => rec.extension_elements',
'        );',
'',
'      end if;',
'',
'      -- Iterator found as step, shortcut other processing',
'      if rec.steps_type in ( flow_constants_pkg.gc_bpmn_multi_instance_loop, flow_constants_pkg.gc_bpmn_standard_loop ) then',
'        if g_log_enabled then',
'          flow_parser_util.log',
'          (',
'            pi_plog_dgrm_id    => g_dgrm_id',
'          , pi_plog_bpmn_id    => pi_proc_bpmn_id',
'          , pi_plog_parse_step => ''parse_steps - loop -> found iterator of type '' || rec.steps_type',
'          , pi_plog_payload    => rec.extension_elements',
'          );',
'        end if;',
'',
'        parse_iterator_attributes',
'        (',
'          pi_objt_bpmn_id       => pi_proc_bpmn_id',
'        , pi_iterator_type      => rec.steps_type',
'        , pi_is_sequential      => rec.is_sequential',
'        , pi_extension_elements => rec.extension_elements',
'        );',
'      elsif rec.source_ref is null then -- assume objects don''t have a sourceRef attribute',
'',
'        -- Parse additional information from child elements',
'        -- relevant for e.g. terminateEndEvent',
'        -- Additionally collect generic attributes if possible',
'        if rec.child_elements is not null then',
'          l_objt_sub_tag_name := find_subtag_name( pi_xml => rec.child_elements );',
'          parse_child_elements',
'          (',
'            pi_objt_bpmn_id => rec.steps_id',
'          , pi_xml          => rec.child_elements',
'          );',
'        else',
'          l_objt_sub_tag_name := null;',
'        end if;',
'',
'        if rec.extension_elements is not null then',
'          parse_extension_elements',
'          ( ',
'            pi_bpmn_id       => rec.steps_id',
'          , pi_extension_xml => rec.extension_elements',
'          );',
'        end if;',
'',
'        if rec.default_conn is not null then',
'          g_default_cons(rec.default_conn) := 1;',
'        end if;',
'',
'        register_object',
'        (',
'          pi_objt_bpmn_id        => rec.steps_id',
'        , pi_objt_name           => rec.steps_name',
'        , pi_objt_tag_name       => rec.steps_type',
'        , pi_objt_sub_tag_name   => l_objt_sub_tag_name',
'        , pi_objt_parent_bpmn_id => pi_proc_bpmn_id',
'        , pi_objt_attached_to    => rec.attached_to',
'        , pi_objt_interrupting   => rec.interrupting',
'        );',
'',
'        if rec.task_type is not null then',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id   => rec.steps_id',
'          , pi_attribute_name => flow_constants_pkg.gc_task_type_key',
'          , pi_value          => rec.task_type',
'          );',
'        end if;',
'',
'        if rec.steps_type = ''bpmn:callActivity'' then',
'          parse_call_activity',
'          (',
'            pi_xml          => rec.step',
'          , pi_objt_bpmn_id => rec.steps_id',
'          );',
'        end if;',
'      else',
'        l_conn_attributes := null;',
'        if rec.child_elements is not null then',
'          l_conn_attributes := ',
'            get_connection_attributes',
'            (',
'              pi_conn_bpmn_id   => rec.steps_id',
'            , pi_xml            => rec.child_elements',
'            );',
'        end if;',
'        if rec.extension_elements is not null then',
'          parse_connection_extensions',
'          (',
'            pi_conn_bpmn_id     => rec.steps_id',
'          , pi_xml              => rec.extension_elements',
'          , pio_conn_attributes => l_conn_attributes',
'          );',
'        end if;',
'        register_connection',
'        (',
'          pi_conn_bpmn_id     => rec.steps_id',
'        , pi_conn_name        => rec.steps_name',
'        , pi_conn_src_bpmn_id => rec.source_ref',
'        , pi_conn_tgt_bpmn_id => rec.target_ref',
'        , pi_conn_tag_name    => rec.steps_type',
'        , pi_conn_origin      => pi_proc_bpmn_id',
'        , pi_conn_sequence    => rec.conn_sequence',
'        , pi_conn_attributes  => l_conn_attributes',
'        );        ',
'      end if;',
'    end loop;  ',
'  end parse_steps;',
'',
'  procedure parse_xml',
'  (',
'    pi_xml       in sys.xmltype',
'  , pi_parent_id in flow_types_pkg.t_bpmn_id',
'  )',
'  as',
'  begin',
'',
'    if g_log_enabled then',
'',
'      flow_parser_util.log',
'      (',
'        pi_plog_dgrm_id    => g_dgrm_id',
'      , pi_plog_bpmn_id    => pi_parent_id',
'      , pi_plog_parse_step => ''parse_xml''',
'      , pi_plog_payload    => pi_xml',
'      );',
'',
'    end if;',
'',
'    if pi_parent_id is null then',
'      for rec in (',
'                 select proc.proc_id',
'                      , case proc.proc_type when ''bpmn:subProcess'' then ''SUB_PROCESS'' else ''PROCESS'' end as proc_type_rem',
'                      , proc.proc_type',
'                      , proc.proc_callable',
'                      , proc.proc_startable',
'                      , proc.proc_application_id',
'                      , proc.proc_page_id',
'                      , proc.proc_username',
'                      , proc.proc_steps',
'                      , proc.proc_sub_procs',
'                      , proc.proc_name',
'                      , proc.proc_laneset',
'                      , proc.proc_extensions',
'                   from xmltable',
'                      (',
'                        xmlnamespaces ( ''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn"',
'                                      , ''https://flowsforapex.org'' as "apex")',
'                      , ''/bpmn:definitions/bpmn:process'' passing pi_xml',
'                        columns',
'                          proc_id             varchar2( 50 char) path ''@id''',
'                        , proc_type           varchar2( 50 char) path ''name()''',
'                        , proc_name           varchar2(200 char) path ''@name''',
'                        , proc_callable       varchar2( 50 char) path ''@apex:isCallable''',
'                        , proc_startable      varchar2( 50 char) path ''@apex:isStartable''',
'                        , proc_application_id varchar2( 50 char) path ''@apex:applicationId''',
'                        , proc_page_id        varchar2( 50 char) path ''@apex:pageId''',
'                        , proc_username       varchar2( 50 char) path ''@apex:username''',
'                        , proc_steps          sys.xmltype        path ''* except bpmn:subProcess except bpmn:extensionElements except bpmn:laneSet''',
'                        , proc_sub_procs      sys.xmltype        path ''bpmn:subProcess''',
'                        , proc_laneset        sys.xmltype        path ''bpmn:laneSet''',
'                        , proc_extensions     sys.xmltype        path ''bpmn:extensionElements''',
'                      ) proc',
'                 )',
'      loop',
'',
'        -- register each process as an object so we can reference later',
'        register_object',
'        (',
'          pi_objt_bpmn_id        => rec.proc_id',
'        , pi_objt_tag_name       => rec.proc_type',
'        , pi_objt_name           => rec.proc_name',
'        , pi_objt_parent_bpmn_id => case when g_collab_refs.exists( rec.proc_id ) then g_collab_refs( rec.proc_id ) else null end',
'        );',
'',
'        if rec.proc_application_id is not null then',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id   => rec.proc_id',
'          , pi_attribute_name => flow_constants_pkg.gc_apex_process_application_id',
'          , pi_value          => rec.proc_application_id',
'          );',
'        end if;',
'',
'        if rec.proc_page_id is not null then',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id   => rec.proc_id',
'          , pi_attribute_name => flow_constants_pkg.gc_apex_process_page_id',
'          , pi_value          => rec.proc_page_id',
'          );',
'        end if;',
'',
'        if rec.proc_username is not null then',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id   => rec.proc_id',
'          , pi_attribute_name => flow_constants_pkg.gc_apex_process_username',
'          , pi_value          => rec.proc_username',
'          );',
'        end if;',
'',
'        if rec.proc_callable is not null then',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id   => rec.proc_id',
'          , pi_attribute_name => flow_constants_pkg.gc_apex_process_callable',
'          , pi_value          => rec.proc_callable',
'          );',
'        end if;',
'',
'        if rec.proc_startable is not null then',
'          register_object_attribute',
'          (',
'            pi_objt_bpmn_id   => rec.proc_id',
'          , pi_attribute_name => flow_constants_pkg.gc_apex_process_startable',
'          , pi_value          => rec.proc_startable',
'          );',
'        end if;',
'',
'        if rec.proc_extensions is not null then',
'          parse_process_extensions',
'          (',
'            pi_objt_bpmn_id => rec.proc_id',
'          , pi_xml          => rec.proc_extensions',
'          );',
'        end if;',
'',
'        -- parse LaneSet if existing',
'        if rec.proc_laneset is not null then',
'          parse_laneset',
'          (  ',
'            pi_laneset_xml    => rec.proc_laneset',
'          , pi_parent_bpmn_id => rec.proc_id',
'          );',
'        end if;',
'',
'        -- parse immediate steps        ',
'        parse_steps',
'        ( ',
'          pi_xml          => rec.proc_steps',
'        , pi_proc_type    => rec.proc_type_rem',
'        , pi_proc_bpmn_id => rec.proc_id',
'        );',
'',
'        -- recurse if sub processes found',
'        if rec.proc_sub_procs is not null then',
'',
'          parse_xml',
'          ( ',
'            pi_xml => rec.proc_sub_procs',
'          , pi_parent_id => rec.proc_id',
'          );',
'',
'        end if;',
'',
'      end loop;',
'    else',
'      for rec in (',
'                 select proc.proc_id',
'                      , proc.proc_name',
'                      , case proc.proc_type when ''bpmn:subProcess'' then ''SUB_PROCESS'' else ''PROCESS'' end as proc_type_rem',
'                      , proc.proc_type',
'                      , proc.proc_steps',
'                      , proc.proc_sub_procs',
'                      , proc.proc_extensions',
'                   from xmltable',
'                      (',
'                        xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'                      , ''bpmn:subProcess'' passing pi_xml',
'                        columns',
'                          proc_id         varchar2(50  char) path ''@id''',
'                        , proc_name       varchar2(200 char) path ''@name''',
'                        , proc_type       varchar2(50  char) path ''name()''',
'                        , proc_steps      sys.xmltype        path ''* except bpmn:subProcess except bpmn:extensionElements''',
'                        , proc_sub_procs  sys.xmltype        path ''bpmn:subProcess''',
'                        , proc_extensions sys.xmltype        path ''bpmn:extensionElements''',
'                      ) proc',
'                 )',
'      loop',
'        -- We add an entry for a sub process here,',
'        -- as it is an object within the master process',
'        register_object',
'        (',
'          pi_objt_bpmn_id        => rec.proc_id',
'        , pi_objt_tag_name       => rec.proc_type',
'        , pi_objt_name           => rec.proc_name',
'        , pi_objt_parent_bpmn_id => pi_parent_id',
'        );',
'',
'        if rec.proc_extensions is not null then',
'          parse_extension_elements',
'          (',
'            pi_bpmn_id       => rec.proc_id',
'          , pi_extension_xml => rec.proc_extensions',
'          );',
'        end if;',
'',
'        -- parse any immediate steps',
'        parse_steps',
'        ( ',
'          pi_xml          => rec.proc_steps',
'        , pi_proc_type    => rec.proc_type_rem',
'        , pi_proc_bpmn_id => rec.proc_id',
'        );',
'',
'        -- recurse if we found any sub process',
'        if rec.proc_sub_procs is not null then',
'          parse_xml',
'          (',
'            pi_xml       => rec.proc_sub_procs',
'          , pi_parent_id => rec.proc_id',
'          );',
'        end if;        ',
'      end loop;',
'    end if;',
'  end parse_xml;',
'',
'  procedure parse_collaboration',
'  (',
'    pi_xml in sys.xmltype',
'  )',
'  as',
'    l_collab_id         flow_types_pkg.t_bpmn_id;',
'    l_collab_name       flow_types_pkg.t_vc200;',
'    l_collab_type       flow_types_pkg.t_bpmn_id;',
'    l_collab_extensions sys.xmltype;',
'    l_collab_nodes      sys.xmltype;',
'',
'    l_conn_attributes   sys.json_object_t;',
'  begin',
'',
'    select collab_id',
'         , collab_name',
'         , collab_type',
'         , collab_extensions',
'         , collab_nodes',
'      into l_collab_id',
'         , l_collab_name',
'         , l_collab_type',
'         , l_collab_extensions',
'         , l_collab_nodes',
'      from xmltable',
'           (',
'             xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'           , ''/bpmn:definitions/bpmn:collaboration'' passing pi_xml',
'             columns',
'               collab_id         varchar2(50  char) path ''@id''',
'             , collab_name       varchar2(200 char) path ''@name''',
'             , collab_type       varchar2(50  char) path ''name()''',
'             , collab_extensions sys.xmltype        path ''bpmn:extensionElements''',
'             , collab_nodes      sys.xmltype        path ''*''',
'           ) collab',
'    ;',
'',
'    register_object',
'    (',
'      pi_objt_bpmn_id        => l_collab_id',
'    , pi_objt_tag_name       => l_collab_type',
'    , pi_objt_name           => l_collab_name',
'    );',
'',
'    if l_collab_extensions is not null then',
'      parse_extension_elements',
'      (',
'        pi_bpmn_id       => l_collab_id',
'      , pi_extension_xml => l_collab_extensions',
'      );',
'    end if;',
'',
'    for rec in (',
'                 select node_id',
'                      , node_name',
'                      , node_type',
'                      , node_proc_ref',
'                      , node_src_ref',
'                      , node_tgt_ref',
'                      , node_cat_ref',
'                      , node_extensions',
'                   from xmltable',
'                        (',
'                          xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'                        , ''*'' passing l_collab_nodes',
'                          columns',
'                            node_id         varchar2( 50 char) path ''@id''',
'                          , node_name       varchar2(200 char) path ''@name''',
'                          , node_type       varchar2( 50 char) path ''name()''',
'                          , node_proc_ref   varchar2( 50 char) path ''@processRef''',
'                          , node_src_ref    varchar2( 50 char) path ''@sourceRef''',
'                          , node_tgt_ref    varchar2( 50 char) path ''@targetRef''',
'                          , node_cat_ref    varchar2( 50 char) path ''@categoryValueRef''',
'                          , node_extensions sys.xmltype        path ''bpmn:extensionElements''',
'                        ) collab_nodes',
'    ) loop',
'',
'      l_conn_attributes := null;',
'',
'      case',
'        when rec.node_src_ref is null then',
'          register_object',
'          (',
'            pi_objt_bpmn_id        => rec.node_id',
'          , pi_objt_tag_name       => rec.node_type',
'          , pi_objt_name           => rec.node_name',
'          , pi_objt_parent_bpmn_id => l_collab_id',
'          );',
'          if rec.node_extensions is not null then',
'            parse_extension_elements',
'            (',
'              pi_bpmn_id       => rec.node_id',
'            , pi_extension_xml => rec.node_extensions',
'            );',
'          end if;',
'          case rec.node_type',
'            when flow_constants_pkg.gc_bpmn_participant then',
'              if rec.node_proc_ref is not null then',
'                g_collab_refs(rec.node_proc_ref) := rec.node_id;',
'              end if;',
'            else',
'              null;',
'          end case;',
'        else',
'',
'          if rec.node_extensions is not null then',
'            parse_connection_extensions',
'            (',
'              pi_conn_bpmn_id     => rec.node_id',
'            , pi_xml              => rec.node_extensions',
'            , pio_conn_attributes => l_conn_attributes',
'            );',
'          end if;',
'          register_connection',
'          (',
'            pi_conn_bpmn_id     => rec.node_id',
'          , pi_conn_name        => rec.node_name',
'          , pi_conn_src_bpmn_id => rec.node_src_ref',
'          , pi_conn_tgt_bpmn_id => rec.node_tgt_ref',
'          , pi_conn_tag_name    => rec.node_type',
'          , pi_conn_origin      => null',
'          , pi_conn_sequence    => null',
'          , pi_conn_attributes  => l_conn_attributes',
'          );',
'      end case;',
'    end loop;',
'  exception',
'    when no_data_found then',
'      -- if no collaboration present we can skip',
'      null;',
'  end parse_collaboration;',
'',
'  procedure parse_messages',
'  (',
'    pi_xml in sys.xmltype',
'  )',
'  as',
'  begin',
'',
'    for rec in (',
'      select message_id',
'           , message_name',
'           , message_type',
'        from xmltable',
'             (',
'               xmlnamespaces (''http://www.omg.org/spec/BPMN/20100524/MODEL'' as "bpmn")',
'             , ''/bpmn:definitions/bpmn:message'' passing pi_xml',
'               columns',
'                 message_id   varchar2(50  char) path ''@id''',
'               , message_name varchar2(200 char) path ''@name''',
'               , message_type varchar2(50  char) path ''name()''',
'             )',
'    ) loop',
'',
'      register_object',
'      (',
'        pi_objt_bpmn_id => rec.message_id',
'      , pi_objt_tag_name => rec.message_type',
'      , pi_objt_name => rec.message_name',
'      );',
'',
'    end loop;',
'',
'  end parse_messages;',
'',
'  procedure reset',
'  as',
'  begin',
'    g_dgrm_id := null;',
'    g_objects.delete;',
'    g_objt_expr.delete;',
'    g_connections.delete;',
'    g_lane_refs.delete;',
'    g_collab_refs.delete;',
'    g_default_cons.delete;',
'    g_objt_lookup.delete;',
'  end reset;',
'',
'  procedure parse',
'  as',
'    l_dgrm_content clob;',
'    l_has_changed boolean;',
'  begin',
'    -- Check if logging is enabled',
'    g_log_enabled := flow_parser_util.is_log_enabled;',
'',
'    -- delete any existing parsed information before parsing again',
'    cleanup_parsing_tables;',
'',
'    -- get the CLOB content',
'    select dgrm_content',
'      into l_dgrm_content',
'      from flow_diagrams',
'     where dgrm_id = g_dgrm_id',
'    ;',
'',
'    -- migrate old diagrams',
'    flow_migrate_xml_pkg.migrate_xml(',
'      p_dgrm_content => l_dgrm_content',
'    , p_has_changed => l_has_changed',
'    );',
'',
'    -- update diagram after change',
'    if l_has_changed then',
'      update flow_diagrams',
'         set dgrm_content = l_dgrm_content',
'       where dgrm_id = g_dgrm_id',
'      ;',
'    end if;',
'',
'    -- parse out collaboration part first',
'    parse_collaboration( pi_xml => sys.xmltype(l_dgrm_content) );',
'    -- grab any message definitions',
'    parse_messages( pi_xml => sys.xmltype(l_dgrm_content) );',
'    -- start recursive processsing of xml',
'    parse_xml( pi_xml => sys.xmltype(l_dgrm_content), pi_parent_id => null );',
'',
'    -- finally insert all parsed data',
'    finalize;',
'',
'  end parse;',
'',
'  procedure parse',
'  (',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type',
'  )',
'  as',
'  begin',
'    reset;',
'    g_dgrm_id := pi_dgrm_id;',
'    parse;',
'  end parse;',
'',
'  procedure parse',
'  (',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  )',
'  as',
'  begin',
'    reset;',
'    select dgrm_id',
'      into g_dgrm_id',
'      from flow_diagrams',
'     where dgrm_name = pi_dgrm_name',
'       and dgrm_version = pi_dgrm_version',
'    ;',
'    parse;',
'  end parse;',
'',
'  procedure upload_and_parse',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_force_overwrite in boolean default false',
'  )',
'  as',
'  begin',
'    reset;',
'',
'    upload_diagram( pi_dgrm_name => pi_dgrm_name, pi_dgrm_version => pi_dgrm_version,',
'                    pi_dgrm_category => pi_dgrm_category, pi_dgrm_content => pi_dgrm_content,',
'                    pi_dgrm_status => pi_dgrm_status, pi_force_overwrite => pi_force_overwrite',
'                  );',
'    parse;',
'',
'  end upload_and_parse;',
'',
'  procedure update_diagram',
'  (',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_dgrm_content in flow_diagrams.dgrm_content%type',
'  )',
'  as',
'  begin',
'    reset;',
'    g_dgrm_id := pi_dgrm_id;',
'',
'    update flow_diagrams',
'       set dgrm_content = pi_dgrm_content',
'         , dgrm_last_update = systimestamp',
'     where dgrm_id = g_dgrm_id',
'    ;',
'',
'    parse;',
'  end update_diagram;',
'',
'end flow_bpmn_parser_pkg;',
'/',
'',
'create or replace package body flow_timers_pkg as',
'/* ',
'-- Flows for APEX - flow_timers_pkg.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates. 2022.',
'--',
'-- Created 2020        Franco Soldaro',
'-- Edited  2020        Moritz Klein - MT AG  ',
'-- Edited  24-Feb-2023 Richard Allen, Oracle',
'-- Edited  05-Jun-2023 Louis Moreaux, Insum',
'--',
'*/',
'  lock_timeout             exception;',
'  e_invalid_duration       exception;',
'  pragma exception_init (lock_timeout, -3006);  ',
'',
'  type t_timer_def is record',
'  ( timer_type            flow_types_pkg.t_bpmn_attribute_vc2',
'  , timer_definition      flow_types_pkg.t_bpmn_attribute_vc2',
'  , oracle_date           flow_types_pkg.t_bpmn_attribute_vc2',
'  , oracle_format_mask    flow_types_pkg.t_bpmn_attribute_vc2',
'  , oracle_duration_ds    flow_types_pkg.t_bpmn_attribute_vc2',
'  , oracle_duration_ym    flow_types_pkg.t_bpmn_attribute_vc2',
'  , start_interval_ds     flow_types_pkg.t_bpmn_attribute_vc2',
'  , repeat_interval_ds    flow_types_pkg.t_bpmn_attribute_vc2',
'  , max_runs              flow_types_pkg.t_bpmn_attribute_vc2',
'  );',
'',
'  function timer_exists',
'  (',
'    pi_timr_id in flow_timers.timr_id%type',
'  ) return boolean',
'  as',
'    l_cnt number;',
'  begin',
'    select count(*)',
'      into l_cnt',
'      from flow_timers',
'     where timr_id = pi_timr_id',
'    ;',
'    return ( l_cnt = 1 );',
'  end timer_exists;',
'',
'  procedure lock_timer',
'  (',
'    pi_prcs_id  in  flow_processes.prcs_id%type',
'  , pi_sbfl_id  in  flow_subflows.sbfl_id%type',
'  )',
'  as',
'    cursor c_lock is ',
'      select timr.timr_id ',
'        from flow_timers timr',
'       where timr.timr_prcs_id = pi_prcs_id',
'         and timr.timr_sbfl_id = pi_sbfl_id',
'      for update of timr.timr_id wait 2;',
'  begin',
'    open c_lock;',
'    close c_lock;',
'  exception',
'    when lock_timeout then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''timer-lock-timeout''',
'      , p0 => pi_sbfl_id         ',
'      );',
'      -- $F4AMESSAGE ''timer-lock-timeout'' || ''Timer for subflow %0 currently locked by another user.  Try again later.''',
'  end lock_timer;',
'',
'  procedure lock_process_timers',
'  (',
'    pi_prcs_id  in  flow_processes.prcs_id%type',
'  )',
'  as',
'    cursor c_lock is ',
'      select timr.timr_id ',
'        from flow_timers timr',
'       where timr.timr_prcs_id = pi_prcs_id',
'       order by timr.timr_id',
'      for update of timr.timr_id;',
'  begin',
'    open c_lock;',
'    close c_lock;',
'  exception',
'  when lock_timeout then',
'    flow_errors.handle_instance_error',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_message_key    => ''timers-lock-timeout''',
'    , p0 => pi_prcs_id        ',
'    );',
'    -- $F4AMESSAGE ''timers-lock-timeout'' || ''Timers for process %0 currently locked by another user.  Try again later.''',
'  end lock_process_timers;',
'',
'  function get_timer_definition',
'  (',
'    pi_prcs_id    in         flow_processes.prcs_id%type',
'  , pi_sbfl_id    in         flow_subflows.sbfl_id%type',
'  --, po_timer_type out nocopy flow_object_attributes.obat_vc_value%type',
'  --, po_timer_def  out nocopy flow_object_attributes.obat_vc_value%type',
'  ) return t_timer_def',
'  is',
'    l_timer_def                   t_timer_def;',
'    l_objt_with_timer             flow_objects.objt_id%type;',
'    l_objt_with_timer_bpmn_id     flow_objects.objt_bpmn_id%type;',
'  begin',
'    -- get objt that timers are attached to (object or attached boundaryEvent)',
'    begin ',
'      select objt.objt_id',
'           , objt.objt_bpmn_id',
'        into l_objt_with_timer',
'           , l_objt_with_timer_bpmn_id',
'        from flow_sub'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flows sbfl',
'        join flow_objects objt',
'          on objt.objt_bpmn_id = sbfl.sbfl_current',
'         and objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'       where sbfl.sbfl_id = pi_sbfl_id',
'         and sbfl.sbfl_prcs_id = pi_prcs_id',
'         and objt.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_timer_event_definition',
'      ;',
'    exception',
'      when no_data_found then',
'        -- check for an interupting timer boundary event attached',
'        begin',
'          select boundary_objt.objt_id',
'            into l_objt_with_timer',
'            from flow_subflows sbfl',
'            join flow_objects main_objt',
'              on main_objt.objt_bpmn_id = sbfl.sbfl_current',
'             and main_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'            join flow_objects boundary_objt',
'              on boundary_objt.objt_attached_to = main_objt.objt_bpmn_id',
'             and boundary_objt.objt_dgrm_id = sbfl.sbfl_dgrm_id',
'           where sbfl.sbfl_id = pi_sbfl_id',
'             and sbfl.sbfl_prcs_id = pi_prcs_id',
'             and boundary_objt.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_timer_event_definition',
'             and boundary_objt.objt_interrupting = 1',
'          ;',
'        exception',
'          when no_data_found then',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id        => pi_prcs_id',
'            , pi_sbfl_id        => pi_sbfl_id',
'            , pi_message_key    => ''timer-object-not-found''',
'            , p0 => pi_sbfl_id          ',
'            );',
'            -- $F4AMESSAGE ''timer-object-not-found'' || ''Object with timer not found in get_timer_definition. Subflow %0.''',
'          when too_many_rows then',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id     => pi_prcs_id',
'            , pi_sbfl_id     => pi_sbfl_id',
'            , pi_message_key => ''boundary-event-too-many''',
'            , p0 => flow_constants_pkg.gc_bpmn_timer_event_definition',
'            );',
'            -- $F4AMESSAGE ''boundary-event-too-many'' || ''More than one %0 boundaryEvent found on sub process.''              ',
'        end;',
'    end;',
'    apex_debug.info',
'    (',
'      p_message => ''get_timer_definition.  Getting timer definition for object %s on subflow %s''',
'    , p0        => l_objt_with_timer_bpmn_id',
'    , p1        => pi_sbfl_id',
'    );',
'    ',
'    select jt.timer_type',
'         , jt.timer_definition',
'         , jt.oracle_date',
'         , jt.oracle_format_mask',
'         , jt.oracle_duration_ds',
'         , jt.oracle_duration_ym',
'         , jt.start_interval_ds',
'         , jt.repeat_interval_ds',
'         , jt.max_runs',
'      into l_timer_def',
'      from flow_objects objt',
'         , json_table( objt.objt_attributes, ''$''',
'             columns',
'               timer_type         varchar2(4000) path ''$.timerType''',
'             , timer_definition   varchar2(4000) path ''$.timerDefinition''',
'             , oracle_date        varchar2(4000) path ''$.apex.date''',
'             , oracle_format_mask varchar2(4000) path ''$.apex.formatMask''',
'             , oracle_duration_ds varchar2(4000) path ''$.apex.intervalDS''',
'             , oracle_duration_ym varchar2(4000) path ''$.apex.intervalYM''',
'             , start_interval_ds  varchar2(4000) path ''$.apex.startIntervalDS''',
'             , repeat_interval_ds varchar2(4000) path ''$.apex.repeatIntervalDS''',
'             , max_runs           varchar2(4000) path ''$.apex.maxRuns''',
'           ) jt',
'     where objt.objt_id = l_objt_with_timer',
'    ;',
'',
'    if l_timer_def.timer_type is null',
'       or',
'       ( l_timer_def.timer_type in  ( flow_constants_pkg.gc_timer_type_date ',
'                                    , flow_constants_pkg.gc_timer_type_duration',
'                                    , flow_constants_pkg.gc_timer_type_cycle',
'                                    )',
'         and  l_timer_def.timer_definition is null )',
'       or ',
'       ( l_timer_def.timer_type = flow_constants_pkg.gc_timer_type_oracle_date',
'         and  (l_timer_def.oracle_date is null ',
'              or l_timer_def.oracle_format_mask is null )',
'       )',
'       or ',
'       ( l_timer_def.timer_type = flow_constants_pkg.gc_timer_type_oracle_duration',
'         and  l_timer_def.oracle_duration_ds is null ',
'         and  l_timer_def.oracle_duration_ym is null',
'       )',
'       or ',
'       ( l_timer_def.timer_type = flow_constants_pkg.gc_timer_type_oracle_cycle',
'         and  (l_timer_def.start_interval_ds is null ',
'              or l_timer_def.repeat_interval_ds is null ',
'               )  -- note - maxRuns is allowed to be null (means no limit)',
'       )',
'    then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => pi_prcs_id',
'      , pi_sbfl_id        => pi_sbfl_id',
'      , pi_message_key    => ''timer-incomplete-definition''',
'      , p0 => l_objt_with_timer_bpmn_id         ',
'	    , p1 => coalesce ( l_timer_def.timer_type,  ''!NULL!'')',
'      , p2 => coalesce ( l_timer_def.timer_definition, l_timer_def.oracle_date',
'                       , l_timer_def.oracle_duration_ds, l_timer_def.start_interval_ds , ''!NULL!'')',
'      , p3 => coalesce ( l_timer_def.oracle_format_mask',
'                       , l_timer_def.oracle_duration_ym, l_timer_def.repeat_interval_ds,''!NULL!'')',
'      , p4 => coalesce ( l_timer_def.max_runs,''!NULL!'')                       ',
'      );',
'      -- $F4AMESSAGE ''timer-incomplete-definition'' || ''Incomplete timer definitions for object %0. Type: %1; Value1: %2 Value2: %3  Value3: %4''',
'    end if;',
'    return l_timer_def;',
'  end get_timer_definition;',
'',
'  procedure step_timers',
'  as',
'    e_resource_timeout      exception;',
'    pragma                  exception_init(e_resource_timeout, -30006);',
'',
'    l_timers                flow_timers%rowtype;',
'    l_run_time              flow_timers.timr_last_run%type := systimestamp;',
'    l_new_status            flow_timers.timr_status%type;',
'    l_timr_id               flow_timers.timr_id%type;',
'    l_timr_run              flow_timers.timr_run%type;',
'    l_apex_session          number;',
'  begin',
'    -- set error_handling to recursive step mode',
'    flow_globals.set_is_recursive_step (p_is_recursive_step => true);',
'    loop -- until no records found',
'      -- could add a functional index on flow_timers to improve performance of this query',
'      -- eg. create index flow_timr_n1 on flow_timers (',
'      --          case when timr_status in ( ''C'', ''A'' ) then coalesce( timr_last_run, timr_created_on ) end);',
'      select * into l_timers',
'        from flow_timers',
'       where rowid in (',
'          select max(rowid) keep (dense_rank first order by coalesce( timr_last_run, timr_created_on )) trowid',
'            from flow_timers',
'           where timr_status = c_created',
'             --and coalesce( timr_last_run, timr_created_on )  < l_run_time ',
'             and timr_start_on <= l_run_time',
'          )',
'      for update wait 5',
'      ;',
'',
'      update flow_timers',
'      set timr_last_run = systimestamp',
'          , timr_status = c_ended',
'      where timr_id = l_timers.timr_id',
'        and timr_run = l_timers.timr_run',
'      ;',
'',
'      begin',
'        -- create an APEX session for the timer operation',
'        l_apex_session := flow_apex_session.create_async_session  ( p_process_id => l_timers.timr_prcs_id',
'                                                                  , p_subflow_id => l_timers.timr_sbfl_id',
'                                                                  );',
'',
'        -- ideally the flow_engine should lock the subflow and this procedure should handle the resource ',
'        -- timeout, deadlock and not found exceptions. This would happen if the subflow is locked waiting ',
'        -- to delete the timer through a cascade delete.',
'        if l_timers.timr_type in  ( flow_constants_pkg.gc_timer_type_cycle',
'                                  , flow_constants_pkg.gc_timer_type_oracle_cycle ',
'                                  ) ',
'        then ',
unistr('          -- repeating / cycle timer.  If unlimited or less than max repeats, run again...\220F'),
'          if l_timers.timr_run < l_timers.timr_repeat_times ',
'          or l_timers.timr_repeat_times is null then ',
'            l_timr_id   := l_timers.timr_id;',
'            l_timr_run  := l_timers.timr_run;',
'          end if;',
'        else',
'          l_timr_id   := null;      ',
'          l_timr_run  := null;',
'        end if;',
'        flow_engine.timer_callback',
'        (',
'          p_process_id    => l_timers.timr_prcs_id',
'        , p_subflow_id    => l_timers.timr_sbfl_id',
'        , p_step_key      => l_timers.timr_step_key',
'        , p_timr_id       => l_timr_id',
'        , p_run           => l_timr_run',
'        , p_callback      => l_timers.timr_callback',
'        , p_callback_par  => l_timers.timr_callback_par',
'        , p_event_type    => flow_constants_pkg.gc_bpmn_timer_event_definition',
'        );',
'        -- drop the session',
'        if l_apex_session is not null then',
'          flow_apex_session.delete_session ( p_session_id => l_apex_session );',
'        end if;',
'        commit;',
'      exception ',
'        -- Some exception happened during processing the timer',
'        -- We trap it here and mark respective timer as broken.',
'        when others then',
'          update flow_timers',
'            set timr_status = c_broken',
'          where timr_id = l_timers.timr_id',
'            and timr_run = l_timers.timr_run',
'          ;',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id    => l_timers.timr_prcs_id',
'          , pi_sbfl_id    => l_timers.timr_sbfl_id',
'          , pi_message_key => ''timer-broken''',
'          , p0 => l_timers.timr_id',
'          , p1 => l_timers.timr_prcs_id',
'          , p2 => l_timers.timr_sbfl_id',
'          , p3 => l_timers.timr_run',
'          );',
'          -- $F4AMESSAGE ''timer-broken'' || ''Timer %0 Run %4 broken in process %1 , subflow : %2.  See error_info.''',
'          -- set error status on subflow & Process',
'          flow_errors.set_error_status ( pi_prcs_id  => l_timers.timr_prcs_id ',
'                                       , pi_sbfl_id  => l_timers.timr_sbfl_id',
'                                       );',
'          commit;',
'      end;',
'',
'    end loop;',
'    exception ',
'      when no_data_found then return;',
'      when e_resource_timeout then',
'        -- record requiring update is locked by another process, could put some logging in here',
'        rollback;',
'        return;',
'',
'  end step_timers;',
'',
'  procedure get_iso_duration',
'  (',
'    in_string       in     varchar2',
'  , in_start_tstz   in     timestamp with time zone default null',
'  , out_start_tstz  out    timestamp with time zone',
'  , out_interv_ym   in out interval year to month',
'  , out_interv_ds   in out interval day to second',
'  )',
'  as',
'    type t_duration_components is table of number index by varchar2(1 char);',
'',
'    l_start_pos_time  pls_integer;',
'    l_token_count     pls_integer;',
'    l_before_t        varchar2(200 char);',
'    l_after_t         varchar2(200 char);',
'    l_ym_part         varchar2(200 char);',
'    l_ds_part         varchar2(200 char);',
'',
'    l_cur_component   varchar2(200 char);    ',
'  begin',
'    -- first split the string to year-month and day-second parts',
'    -- afterwards operate on both separately',
'    -- because M before T means months and M after T means minutes',
'',
'    l_start_pos_time := instr( in_string, ''T'' );',
'    if l_start_pos_time = 0 then',
'      l_before_t := in_string;',
'    else',
'      l_before_t       := substr( in_string, 1, l_start_pos_time - 1 );',
'      l_after_t        := substr( in_string, l_start_pos_time);',
'    end if;',
'',
'    -- The day indicator comes before the "T"',
'    -- however day needs to be handle with ds_interval',
'    l_token_count := regexp_count( l_before_t, ''\d+\w'' );',
'    for i in 1..l_token_count loop',
'      l_cur_component := regexp_substr(l_before_t, ''\d+\w'', 1, i);',
'',
'      case substr(l_cur_component, -1)',
'        when ''Y'' then l_ym_part := l_ym_part || l_cur_component;',
'        when ''M'' then l_ym_part := l_ym_part || l_cur_component;',
'        when ''D'' then l_ds_part := l_ds_part || l_cur_component;',
'        else null;',
'      end case;',
'    end loop;',
'',
'    l_ds_part := l_ds_part || l_after_t;',
'',
'    if l_ym_part is not null or l_ds_part is not null then',
'      out_interv_ym := to_yminterval( ''P'' || coalesce(l_ym_part, ''0Y'') );',
'      out_interv_ds := to_dsinterval( ''P'' || coalesce(l_ds_part, ''0D'') );',
'',
'      out_start_tstz  := coalesce( in_start_tstz, systimestamp ) + out_interv_ym + out_interv_ds;',
'    else',
'      raise e_invalid_duration;',
'    end if;',
'',
'  end get_iso_duration;',
'',
'/******************************************************************************',
'  START_TIMER',
'******************************************************************************/',
'',
'  procedure start_new_timer',
'  (',
'    pi_prcs_id    in flow_processes.prcs_id%type',
'  , pi_sbfl_id    in flow_subflows.sbfl_id%type ',
'  , pi_step_key   in flow_subflows.sbfl_step_key%type default null',
'  , pi_callback     in flow_timers.timr_callback%type',
'  , pi_callback_par in flow_timers.timr_callback_par%type  ',
'  )',
'  as',
'    l_parsed_tstz         flow_timers.timr_start_on%type;',
'    l_parsed_duration_ym  flow_timers.timr_interval_ym%type;',
'    l_parsed_duration_ds  flow_timers.timr_interval_ds%type;',
'    l_repeat_times        flow_timers.timr_repeat_times%type;',
'    l_repeat_def          varchar2(200);',
'    l_timer_def           t_timer_def;',
'    l_time_string         varchar2(20);',
'    e_invalid_repeat      exception;',
'    l_scope               flow_subflows.sbfl_scope%type;',
'  begin',
'    apex_debug.enter ',
'    ( ''start_new_timer''',
'    , ''prcs_id'', pi_prcs_id',
'    , ''sbfl_id'', pi_sbfl_id',
'    , ''step_key'', pi_step_key',
'    );',
'    -- preset async session parameters in proc variables',
'    flow_apex_session.set_async_proc_vars',
'        ( p_process_id  => pi_prcs_id',
'        , p_subflow_id  => pi_sbfl_id',
'        );',
'    -- set up scheduled firing time',
'    l_timer_def := get_timer_definition',
'                  (',
'                    pi_prcs_id    => pi_prcs_id',
'                  , pi_sbfl_id    => pi_sbfl_id',
'                  );',
'    apex_debug.info',
'    (',
'      p_message => ''starting new timer on subflow %0, type %1, key1: %2, key2 : %3 , key3: %4''',
'    , p0        => pi_sbfl_id',
'    , p1        => l_timer_def.timer_type',
'    , p2        => coalesce( l_timer_def.timer_definition , l_timer_def.oracle_date',
'                           , l_timer_def.oracle_duration_DS,  l_timer_def.start_Interval_DS , ''<null>'')',
'    , p3        => coalesce( l_timer_def.oracle_format_mask, l_timer_def.repeat_interval_ds, ''<null>'')',
'    , p4        => coalesce( l_timer_def.max_runs, ''<null>'')',
'    );',
'',
'    l_scope := flow_engine_util.get_scope (p_process_id => pi_prcs_id, p_subflow_id => pi_sbfl_id );',
'',
'    begin',
'      case l_timer_def.timer_type',
'        when flow_constants_pkg.gc_timer_type_date then',
'          -- ISO 8601 date - check for substitution of process variable',
'          if upper(substr(l_timer_def.timer_definition,1,5)) = flow_constants_pkg.gc_substitution_prefix || flow_constants_pkg.gc_substitution_flow_identifier then',
'            case flow_proc_vars_int.get_var_type ( pi_prcs_id  => pi_prcs_id',
'                                                 , pi_var_name => substr(l_timer_def.timer_definition,6,length(l_timer_def.timer_definition)-6)',
'                                                 , pi_scope    => l_scope',
'                                                )',
'            when flow_constants_pkg.gc_prov_var_type_date then',
'                -- substitution parameter is a date process var = already an Oracle date',
'                l_parsed_tstz :=',
'                  flow_proc_vars_int.get_var_date',
'                  ( ',
'                    pi_prcs_id  => pi_prcs_id',
'                  , pi_var_name => substr(l_timer_def.timer_definition,6,length(l_timer_def.timer_definition)-6)',
'                  , pi_scope    => l_scope',
'                  )',
'                ;',
'            when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'                l_parsed_tstz := to_timestamp_tz ( flow_proc_vars_int.get_var_vc2',
'                                                  ( pi_prcs_id  => pi_prcs_id',
'                                                  , pi_var_name => substr  ( l_timer_def.timer_definition,6',
'                                                                           , length(l_timer_def.timer_definition)-6',
'                                                                           )',
'                                                  , pi_scope    => l_scope',
'                                                  ),',
'                                                   flow_constants_pkg.gc_prov_default_date_format',
'                                                 );',
'            end case;',
'          elsif substr(l_timer_def.timer_definition,1,1) = ''T'' then',
'            -- check for just an ISO Time, and then get next time that time of day occurs (today/tomorrow)',
'            l_time_string := substr(l_timer_def.timer_definition,2,8);',
'            case ',
'              when  (sysdate - to_date(to_char(sysdate,''YYYY-MM-DD '')||l_time_string,''YYYY-MM-DD HH24:MI:SS'')) < 0 then',
'                -- today',
'                l_parsed_tstz := to_timestamp_tz( to_char (sysdate,''YYYY-MM-DD '')||l_time_string, ''YYYY-MM-DD HH24:MI:SS'');',
'              else',
'                -- tomorrow',
'                l_parsed_tstz := to_timestamp_tz(to_char ( sysdate+1,''YYYY-MM-DD '')||l_time_string,''YYYY-MM-DD HH24:MI:SS'');',
'            end case;',
'',
'          else',
'            -- assume we have an ISO date-time',
'            l_parsed_tstz := to_timestamp_tz( replace ( l_timer_def.timer_definition, ''T'', '' '' ), ''YYYY-MM-DD HH24:MI:SS TZR'' );',
'          end if;',
'        when flow_constants_pkg.gc_timer_type_duration then',
'          -- ISO 8601 Duration - check for substitution of process variable',
'          if upper(substr(l_timer_def.timer_definition,1,5)) = flow_constants_pkg.gc_substitution_prefix || flow_constants_pkg.gc_substitution_flow_identifier then',
'            l_timer_def.timer_definition :=',
'              flow_proc_vars_int.get_var_vc2',
'              ( ',
'                pi_prcs_id  => pi_prcs_id',
'              , pi_var_name => substr(l_timer_def.timer_definition,6,length(l_timer_def.timer_definition)-6)',
'              , pi_scope    => l_scope',
'              )',
'            ;',
'          end if;     ',
'          get_iso_duration',
'          (',
'            in_string       => l_timer_def.timer_definition',
'          , in_start_tstz   => systimestamp',
'          , out_start_tstz  => l_parsed_tstz',
'          , out_interv_ym   => l_parsed_duration_ym',
'          , out_interv_ds   => l_parsed_duration_ds',
'          );',
'        when flow_constants_pkg.gc_timer_type_cycle then',
'          -- ISO 8601 Cycle - check for substitution of process variable',
'          flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id',
'                                             , pi_sbfl_id => pi_sbfl_id',
'                                             , pi_scope   => l_scope',
'                                             , pio_string => l_timer_def.timer_definition',
'                                             );',
'          l_repeat_def := regexp_substr (l_timer_def.timer_definition, ''^''||''R([0-9]*|-1)\/''); -- using concatenation to prevent substitution on installation via script',
'          if l_repeat_def is null then',
'            raise e_invalid_repeat;',
'          end if;',
'          l_repeat_times := substr ( l_timer_def.timer_definition, 2',
'                                   , instr( l_timer_def.timer_definition, ''/'', 1, 1 ) - 2 ',
'                                   );',
'          if l_repeat_times = -1 or l_repeat_times is null then ',
'            -- ISO8601 repeat -1 means unlimited so set repeat_times to max cycles',
'            l_repeat_times := flow_engine_util.get_config_value ',
'            ( p_config_key    => flow_constants_pkg.gc_config_timer_max_cycles',
'            , p_default_value => flow_constants_pkg.gc_config_default_timer_max_cycles',
'            );',
'          elsif l_repeat_times = 0 then',
'            -- according to ISO 8601 it should run 1 time but not repeat',
'            l_repeat_times := 1;',
'          end if;',
'',
'          l_timer_def.timer_definition := substr  ( l_timer_def.timer_definition',
'                                                  , instr( l_timer_def.timer_definition, ''/'', 1, 1 ) + 1  ',
'                                                  );',
'          get_iso_duration',
'          (',
'            in_string       => l_timer_def.timer_definition',
'          , in_start_tstz   => systimestamp',
'          , out_start_tstz  => l_parsed_tstz',
'          , out_interv_ym   => l_parsed_duration_ym',
'          , out_interv_ds   => l_parsed_duration_ds',
'          );',
'        when flow_constants_pkg.gc_timer_type_oracle_date then',
'',
'          if upper(substr(l_timer_def.oracle_date,1,5)) = flow_constants_pkg.gc_substitution_prefix || flow_constants_pkg.gc_substitution_flow_identifier then',
'            case flow_proc_vars_int.get_var_type ( pi_prcs_id  => pi_prcs_id',
'                                                 , pi_var_name => substr(l_timer_def.oracle_date,6,length(l_timer_def.oracle_date)-6)',
'                                                 , pi_scope    => l_scope',
'                                                 )',
'            when flow_constants_pkg.gc_prov_var_type_date then',
'                -- substitution parameter is a date process var = already an Oracle date',
'                l_parsed_tstz :=',
'                  flow_proc_vars_int.get_var_date',
'                  ( ',
'                    pi_prcs_id  => pi_prcs_id',
'                  , pi_var_name => substr(l_timer_def.oracle_date,6,length(l_timer_def.oracle_date)-6)',
'                  , pi_scope    => l_scope',
'                  )',
'                ;',
'            when flow_constants_pkg.gc_prov_var_type_varchar2 then',
'                -- substitution parameter is a vc2 - use the specified format mask',
'                l_parsed_tstz := to_timestamp_tz ( flow_proc_vars_int.get_var_vc2',
'                                                  ( pi_prcs_id  => pi_prcs_id',
'                                                  , pi_var_name => substr  ( l_timer_def.oracle_date,6',
'                                                                                    , length(l_timer_def.oracle_date)-6',
'                                                                                    )',
'                                                  , pi_scope    => l_scope',
'                                                  )',
'                                                , l_timer_def.oracle_format_mask',
'                                                );',
'            end case;',
'          else',
'            -- just use the specified date and format mask',
'            l_parsed_tstz := to_timestamp ( l_timer_def.oracle_date, l_timer_def.oracle_format_mask);',
'          end if;',
'        when flow_constants_pkg.gc_timer_type_oracle_duration then ',
'          -- handle possible vc2-typed subsitutions for both parameters',
'          flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id',
'                                             , pi_sbfl_id => pi_sbfl_id',
'                                             , pio_string => l_timer_def.oracle_duration_ds',
'                                             , pi_scope   => l_scope',
'                                             );',
'          flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id',
'                                             , pi_sbfl_id => pi_sbfl_id',
'                                             , pio_string => l_timer_def.oracle_duration_ym',
'                                             , pi_scope   => l_scope',
'                                             );',
'          l_parsed_duration_ds := to_dsinterval ( nvl ( l_timer_def.oracle_duration_ds , ''000 00:00:00'') );',
'          l_parsed_duration_ym := to_yminterval ( nvl ( l_timer_def.oracle_duration_ym, ''0-0'') );',
'          l_parsed_tstz := systimestamp + l_parsed_duration_ym + l_parsed_duration_ds;',
'',
'        when flow_constants_pkg.gc_timer_type_oracle_cycle then',
'          -- oracle cycle timer - all 3 parameters can be substituted with vc2-type proc var',
'          flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id',
'                                             , pi_sbfl_id => pi_sbfl_id',
'                                             , pi_scope   => l_scope',
'                                             , pio_string => l_timer_def.start_interval_ds',
'                                             );',
'          flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id',
'                                             , pi_sbfl_id => pi_sbfl_id',
'                                             , pi_scope   => l_scope',
'                                             , pio_string => l_timer_def.repeat_interval_ds',
'                                             ); ',
'          if l_timer_def.max_runs is not null then            ',
'            flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id',
'                                               , pi_sbfl_id => pi_sbfl_id',
'                                               , pi_scope   => l_scope',
'                                               , pio_string => l_timer_def.max_runs',
'                                               );                                                       ',
'            l_repeat_times  := to_number ( l_timer_def.max_runs );',
'          else',
'            l_repeat_times := flow_engine_util.get_config_value ',
'                              ( p_config_key    => flow_constants_pkg.gc_config_timer_max_cycles',
'                              , p_default_value => flow_constants_pkg.gc_config_default_timer_max_cycles',
'                              );',
'          end if;',
'          l_parsed_tstz         := systimestamp + to_dsinterval ( l_timer_def.start_interval_ds );',
'          l_parsed_duration_ym  := to_yminterval (''0-0'');  -- UI currently does not allow YM input so set to 0',
'          l_parsed_duration_ds  := to_dsinterval ( l_timer_def.repeat_interval_ds );',
'        else',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id        => pi_prcs_id',
'          , pi_sbfl_id        => pi_sbfl_id',
'          , pi_message_key    => ''timer-incomplete-definition''',
'          , p0 => pi_sbfl_id         ',
'	        , p1 => l_timer_def.timer_type',
'          , p2 => l_timer_def.timer_definition',
'          );',
'          -- $F4AMESSAGE ''timer-incomplete-definition'' || ''Incomplete timer definitions for object %0. Type: %1; Value: %2''',
'      end case;',
'    exception',
'      when e_invalid_repeat or e_invalid_duration then',
'        flow_errors.handle_instance_error',
'        (',
'          pi_prcs_id     => pi_prcs_id',
'        , pi_sbfl_id     => pi_sbfl_id',
'        , pi_message_key => ''timer_definition_error''',
'        , p0             => pi_prcs_id',
'        , p1             => pi_sbfl_id',
'        , p2             => l_timer_def.timer_type',
'        , p3             => l_timer_def.timer_definition',
'        );',
'      when others then',
'        flow_errors.handle_instance_error',
'        (',
'          pi_prcs_id     => pi_prcs_id',
'        , pi_sbfl_id     => pi_sbfl_id',
'        , pi_message_key => ''timer_definition_error''',
'        , p0             => pi_prcs_id',
'        , p1             => pi_sbfl_id',
'        , p2             => l_timer_def.timer_type',
'        , p3             => l_timer_def.timer_definition',
'        );',
'    end;    ',
'',
'    insert into flow_timers',
'      (',
'        timr_prcs_id',
'      , timr_sbfl_id',
'      , timr_step_key',
'      , timr_run',
'      , timr_type',
'      , timr_created_on',
'      , timr_status',
'      , timr_start_on',
'      , timr_interval_ym',
'      , timr_interval_ds',
'      , timr_repeat_times',
'      , timr_callback',
'      , timr_callback_par',
'      )',
'      values',
'      (',
'        pi_prcs_id',
'      , pi_sbfl_id',
'      , pi_step_key',
'      , 1',
'      , l_timer_def.timer_type',
'      , systimestamp',
'      , c_created',
'      , l_parsed_tstz',
'      , l_parsed_duration_ym',
'      , l_parsed_duration_ds',
'      , l_repeat_times',
'      , pi_callback ',
'      , pi_callback_par ',
'      )',
'    ;',
'',
'  end start_new_timer;',
'',
'  procedure start_repeat_timer',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type ',
'  , pi_step_key     in flow_subflows.sbfl_step_key%type default null',
'  , pi_callback     in flow_timers.timr_callback%type',
'  , pi_callback_par in flow_timers.timr_callback_par%type  ',
'  , pi_run          in flow_timers.timr_run%type default 1 -- 1 original, 2-> repeats',
'  , pi_timr_id      in flow_timers.timr_id%type default null -- only set on repeats',
'  )',
'  as',
'    l_parsed_tstz         flow_timers.timr_start_on%type;',
'    l_parsed_duration_ym  flow_timers.timr_interval_ym%type;',
'    l_parsed_duration_ds  flow_timers.timr_interval_ds%type;',
'    l_repeat_times        flow_timers.timr_repeat_times%type;',
'    l_timer_def           t_timer_def;',
'  begin',
'    apex_debug.enter ',
'    ( ''start_repeat_timer''',
'    , ''prcs_id'', pi_prcs_id',
'    , ''sbfl_id'', pi_sbfl_id',
'    , ''step_key'', pi_step_key',
'    , ''timr_id (repeats)'', pi_timr_id',
'    , ''run'', pi_run',
'    );',
'',
'    insert into flow_timers',
'    ( timr_id',
'    , timr_run',
'    , timr_prcs_id',
'    , timr_sbfl_id',
'    , timr_step_key',
'    , timr_type',
'    , timr_created_on',
'    , timr_status',
'    , timr_start_on',
'    , timr_interval_ym',
'    , timr_interval_ds',
'    , timr_repeat_times',
'    , timr_callback',
'    , timr_callback_par',
'    ) ',
'    select',
'      pi_timr_id',
'    , pi_run',
'    , pi_prcs_id',
'    , pi_sbfl_id',
'    , pi_step_key',
'    , old_timr.timr_type',
'    , systimestamp',
'    , c_created',
'    , systimestamp + nvl(old_timr.timr_interval_ym,''0-0'') + nvl(old_timr.timr_interval_ds,''0 00:00:00'')',
'    , old_timr.timr_interval_ym',
'    , old_timr.timr_interval_ds',
'    , old_timr.timr_repeat_times',
'    , pi_callback ',
'    , pi_callback_par ',
'    from flow_timers'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' old_timr',
'    where old_timr.timr_id = pi_timr_id',
'      and old_timr.timr_run = pi_run - 1',
'      and old_timr.timr_prcs_id = pi_prcs_id',
'    ;',
'',
'  end start_repeat_timer;',
'',
'  procedure start_timer',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type ',
'  , pi_step_key     in flow_subflows.sbfl_step_key%type default null',
'  , pi_callback     in flow_timers.timr_callback%type',
'  , pi_callback_par in flow_timers.timr_callback_par%type default null',
'  , pi_run          in flow_timers.timr_run%type default 1 -- 1 original, 2-> repeats',
'  , pi_timr_id      in flow_timers.timr_id%type default null -- only set on repeats',
'  )',
'  as',
'    l_parsed_tstz         flow_timers.timr_start_on%type;',
'    l_parsed_duration_ym  flow_timers.timr_interval_ym%type;',
'    l_parsed_duration_ds  flow_timers.timr_interval_ds%type;',
'    l_repeat_times        flow_timers.timr_repeat_times%type;',
'    l_timer_def           t_timer_def;',
'  begin',
'    apex_debug.enter ',
'    ( ''start_timer''',
'    , ''prcs_id'', pi_prcs_id',
'    , ''sbfl_id'', pi_sbfl_id',
'    , ''step_key'', pi_step_key',
'    , ''callback'', pi_callback',
'    , ''timr_id (repeats)'', pi_timr_id',
'    , ''timer run'', pi_run',
'    );',
'    if pi_run = 1 and pi_timr_id is null then',
'      -- starting the first run of a new timer',
'      start_new_timer',
'      ( pi_prcs_id      => pi_prcs_id   ',
'      , pi_sbfl_id      => pi_sbfl_id  ',
'      , pi_step_key     => pi_step_key ',
'      , pi_callback     => pi_callback',
'      , pi_callback_par => pi_callback_par',
'      );',
'    elsif pi_run > 1 and pi_timr_id is not null then',
'        -- starting a repeat cycle of a existing timer (on a new sbfl)',
'      start_repeat_timer',
'      ( pi_prcs_id      => pi_prcs_id   ',
'      , pi_sbfl_id      => pi_sbfl_id  ',
'      , pi_step_key     => pi_step_key ',
'      , pi_callback     => pi_callback',
'      , pi_callback_par => pi_callback_par',
'      , pi_run          => pi_run',
'      , pi_timr_id      => pi_timr_id',
'      );  ',
'    else',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => pi_prcs_id',
'        , pi_sbfl_id        => pi_sbfl_id',
'        , pi_message_key    => ''timer-internal-error''',
'        , p0 => pi_sbfl_id         ',
'	      , p1 => pi_run',
'        , p2 => pi_timr_id',
'        );',
'        -- $F4AMESSAGE ''timer-internal-error'' || ''Timer internal error  for object %0. Type: %1; Value: %2''',
'    end if;',
'  end start_timer;',
'',
'/******************************************************************************',
'  RESCHEDULE_TIMER',
'*******************************************************************************/',
'',
'procedure reschedule_timer',
'(',
'    p_process_id        in flow_processes.prcs_id%type',
'  , p_subflow_id        in flow_subflows.sbfl_id%type',
'  , p_step_key          in flow_subflows.sbfl_step_key%type default null',
'  , p_is_immediate      in boolean default false',
'  , p_restart_immediate in boolean default false',
'  , p_new_timestamp     in flow_timers.timr_start_on%type default null',
'  , p_comment           in flow_instance_event_log.lgpr_comment%type default null',
')',
'is',
'  l_timer_rec       flow_timers%rowtype;',
'  e_bad_new_timer   exception;',
'  l_current_object  flow_subflows.sbfl_current%type;',
'begin',
'  apex_debug.enter ',
'  ( ''reschedule_timer''',
'  , ''Process ID'',  p_process_id',
'  , ''Subflow ID'', p_subflow_id',
'  , ''Step Key'', p_step_key',
'  , ''Immediate'', case when p_is_immediate then ''true'' else ''false'' end',
'  , ''New Timestamp'', p_new_timestamp',
'  );',
'  -- lock the timer',
'  -- first try to lock a current active (i.e., ''created'') timer on the subflow',
'  begin',
'    select *',
'      into l_timer_rec',
'      from flow_timers timr ',
'     where timr.timr_prcs_id = p_process_id',
'       and timr.timr_sbfl_id = p_subflow_id',
'       and timr.timr_status = flow_timers_pkg.c_created',
'       for update wait 5',
'    ;',
'  exception',
'    when no_data_found then',
'      if p_restart_immediate then',
'        -- handle timer event restarts where timer has already fired but step needs to be re-started',
'        -- requires the old ''nded'' timer to be restarted with an imediate schedule. (See test case 3h2 Issue #710)',
'        select *',
'          into l_timer_rec',
'          from flow_timers timr ',
'         where timr.timr_last_run = ( select max (timr_last_run )',
'                                      from   flow_timers ',
'                                      where  timr_prcs_id = p_process_id',
'                                      and    timr_sbfl_id = p_subflow_id',
'                                      and    timr.timr_status = flow_timers_pkg.c_ended',
'                                    )',
'           and timr_prcs_id = p_process_id',
'           and timr_sbfl_id = p_subflow_id',
'           and timr.timr_status = flow_timers_pkg.c_ended',
'           for update wait 5',
'        ;',
'      else',
'        raise;',
'      end if;',
'  end;',
'  if flow_engine_util.step_key_valid( pi_prcs_id  => p_process_id',
'                                    , pi_sbfl_id  => p_subflow_id',
'                                    , pi_step_key_supplied  => p_step_key',
'                                    , pi_step_key_required  => l_timer_rec.timr_step_key) then ',
'    if p_is_immediate then',
'      l_timer_rec.timr_start_on := systimestamp;',
'    elsif p_new_timestamp >= systimestamp then',
'      l_timer_rec.timr_start_on := p_new_timestamp;',
'    elsif not p_is_immediate  and p_new_timestamp is null then',
'      raise e_bad_new_timer;',
'    end if;',
'',
'    update flow_timers',
'       set timr_start_on = l_timer_rec.timr_start_on',
'         , timr_status = c_created',
'     where timr_id = l_timer_rec.timr_id',
'       and timr_run = l_timer_rec.timr_run',
'    ;',
'',
'    select sbfl.sbfl_current',
'      into l_current_object',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_id = p_subflow_id',
'       and sbfl.sbfl_prcs_id = p_process_id',
'    ;',
'',
'    flow_logging.log_instance_event',
'    ( p_process_id  => p_process_id',
'    , p_objt_bpmn_id  => l_current_object',
'    , p_event  => flow_constants_pkg.gc_prcs_event_rescheduled',
'    , p_comment  => p_comment',
'    );',
'',
'  end if;',
'exception',
'  when no_data_found then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_process_id',
'      , pi_sbfl_id     => p_subflow_id',
'      , pi_message_key => ''engine-util-sbfl-not-found''',
'      , p0 => p_subflow_id',
'      );',
'      -- $F4AMESSAGE ''engine-util-sbfl-not-found'' || ''Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).''  ',
'  when lock_timeout then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_process_id',
'      , pi_sbfl_id     => p_subflow_id',
'      , pi_message_key => ''timeout_locking_subflow''',
'      , p0 => p_subflow_id',
'      );',
'      -- $F4AMESSAGE ''timeout_locking_subflow'' || ''Unable to lock subflow %0 as currently locked by another user.  Retry your transaction later.''  ',
'  when e_bad_new_timer then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => p_process_id',
'        , pi_sbfl_id        => p_subflow_id',
'        , pi_message_key    => ''timer-incomplete-definition''',
'        , p0 => p_subflow_id       ',
'	      , p1 => case when p_is_immediate then ''true'' else ''false'' end',
'        , p2 => p_new_timestamp',
'        );',
'        -- $F4AMESSAGE ''timer-incomplete-definition'' || ''Incomplete timer definitions for object %0. Type: %1; Value: %2''',
'',
'end reschedule_timer;',
'',
'',
'',
'',
'/******************************************************************************',
'  EXPIRE_TIMER',
'******************************************************************************/',
'',
'  procedure expire_timer',
'  (',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_sbfl_id in flow_subflows.sbfl_id%type ',
'  )',
'  is',
'  begin',
'    update flow_timers',
'       set timr_status = c_expired',
'     where timr_prcs_id = pi_prcs_id',
'       and timr_sbfl_id = pi_sbfl_id',
'       and timr_status not in (c_ended, c_expired, c_terminated)',
'    ;',
'  end expire_timer;',
'',
'/******************************************************************************',
'  TERMINATE_TIMER',
'******************************************************************************/',
'',
'  procedure terminate_timer',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type',
'  , po_return_code out number',
'  )',
'  is',
'  begin',
'    update flow_timers',
'       set timr_status = c_terminated',
'     where timr_prcs_id = pi_prcs_id',
'       and timr_sbfl_id = pi_sbfl_id',
'       and timr_status not in (c_ended, c_expired, c_terminated)',
'    ;',
'  end terminate_timer;',
'',
'/******************************************************************************',
'  TERMINATE_PROCESS_TIMERS',
'******************************************************************************/',
'',
'  procedure terminate_process_timers',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , po_return_code out number',
'  )',
'  is',
'  begin',
'    update flow_timers',
'       set timr_status = c_terminated',
'     where timr_prcs_id = pi_prcs_id',
'       and timr_status not in (c_ended, c_expired, c_terminated)',
'    ;',
'  end terminate_process_timers;',
'',
'/******************************************************************************',
'  TERMINATE_ALL_TIMERS',
'******************************************************************************/',
'',
'  procedure terminate_all_timers',
'  (',
'    po_return_code  out  number',
'  )',
'  is',
'  begin',
'    update flow_timers',
'       set timr_status = c_terminated',
'     where timr_status not in (c_ended, c_expired, c_terminated)',
'    ;',
'  end terminate_all_timers;',
'',
'/******************************************************************************',
'  delete_process_timers',
'    delete all the timers of a process.',
'******************************************************************************/',
'',
'  procedure delete_process_timers',
'  (',
'    pi_prcs_id      in flow_processes.prcs_id%type',
'  , po_return_code out number',
'  )',
'  is ',
'  begin',
'    delete',
'      from flow_timers',
'     where timr_prcs_id = pi_prcs_id',
'    ;',
'  end delete_process_timers;',
'',
'  function get_timer_repeat_interval',
'  return sys.all_scheduler_jobs.repeat_interval%type',
'  as',
'    l_repeat_interval  sys.all_scheduler_jobs.repeat_interval%type;',
'  begin',
'    begin',
'      select repeat_interval',
'        into l_repeat_interval',
'        from sys.user_scheduler_jobs',
'       where job_name = ''APEX_FLOW_STEP_TIMERS_J'';',
'    exception',
'      when no_data_found then',
'        l_repeat_interval := null;',
'    end;',
'    return l_repeat_interval;',
'  end get_timer_repeat_interval;',
'',
'  procedure set_timer_repeat_interval ',
'  ( p_repeat_interval  in  varchar2',
'  )',
'  is',
'    l_existing_value                sys.all_scheduler_jobs.repeat_interval%type;',
'    l_host_url                      varchar2(4000);',
'    e_scheduler_repeat_too_small  exception;',
'  begin',
'    apex_debug.enter',
'    ( ''set_timer_repeat_interval''',
'    , ''p_repeat_interval'', p_repeat_interval ',
'    );',
'    -- check if this is actually an update, if not, ignore it.',
'    l_existing_value := get_timer_repeat_interval;',
'',
'    if l_existing_value = p_repeat_interval then',
'      -- no chages required',
'      null;',
'    else',
'      -- changes required',
'      l_host_url := apex_util.host_url;',
'      ',
'      if ( l_host_url like ''%apex.oracle.com%''',
'         or l_host_url like ''%apex.oraclecorp.com%'' ',
'         )',
'      then ',
'        if p_repeat_interval like ''%SECONDLY%'' then',
'          raise e_scheduler_repeat_too_small;',
'        end if;',
'      end if;      ',
'      -- go ahead with the update',
'      sys.dbms_scheduler.set_attribute',
'      ( name => ''APEX_FLOW_STEP_TIMERS_J''',
'      , attribute => ''repeat_interval''',
'      , value => p_repeat_interval',
'      );',
'      apex_debug.message',
'      ( p_message => ''--- Timer scheduler repeat interval set.  Host: %0 Requested Interval %1''',
'      , p0 => l_host_url',
'      , p1 => p_repeat_interval',
'      );',
'    end if;',
'  exception',
'    when e_scheduler_repeat_too_small then',
'      apex_debug.message',
'      ( p_message => ''Attempt to set timer repeat interval too frequent.  Host: %0 Requested Interval %1''',
'      , p0 => l_host_url',
'      , p1 => p_repeat_interval',
'      );',
'      flow_errors.handle_general_error',
'      (pi_message_key  => ''scheduler-repeat-shared-env''',
'      , p0  => l_host_url',
'      , p1  => p_repeat_interval',
'      );',
'      -- $F4AMESSAGE ''scheduler-repeat-shared-env'' || ''Timer repeat interval too frequent for host (%0) Requested Interval %1.  Must be greater than 1 Minute.''',
'  end set_timer_repeat_interval;',
'',
'  function get_timer_status',
'  return varchar2',
'  as',
'    l_status  sys.user_scheduler_jobs.enabled%type;',
'  begin',
'    begin',
'      select enabled',
'        into l_status',
'        from sys.user_scheduler_jobs',
'       where job_name = ''APEX_FLOW_STEP_TIMERS_J'';',
'    exception ',
'      when no_data_found then',
'      l_status := ''FALSE'';',
'    end;',
'    return l_status;',
'  end get_timer_status;',
'    ',
'  procedure disable_scheduled_job',
'  as',
'  begin',
'    execute immediate',
'    q''[begin',
'    sys.dbms_scheduler.disable( name => ''apex_flow_step_timers_j'' );',
'    end;]'';',
'  end disable_scheduled_job;',
'',
'  procedure enable_scheduled_job',
'  as',
'  begin',
'    execute immediate',
'    q''[begin',
'    sys.dbms_scheduler.enable( name => ''apex_flow_step_timers_j'' );',
'    end;]'';',
'  end enable_scheduled_job;',
'',
'  function timer_job_exists',
'    return boolean',
'  as',
'    l_dummy number;',
'  begin',
'    select 1',
'      into l_dummy',
'      from sys.user_scheduler_jobs',
'     where job_name = ''APEX_FLOW_STEP_TIMERS_J''',
'    ;',
'    return true;',
'  exception',
'    when no_data_found then',
'      return false;',
'',
'  end timer_job_exists;',
'',
'end flow_timers_pkg;',
'/',
'',
'create or replace package body flow_usertask_pkg',
'as',
'/* ',
'-- Flows for APEX - flow_usertask_pkg.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2020-2022.',
'--',
'-- Created 12-Nov-2020 Moritz Klein (MT AG) ',
'-- Edited  13-Apr-2022 Richard Allen (Oracle)',
'-- Edited  23-May-2022 Moritz Klein (MT AG)',
'--',
'*/',
'  e_lock_timeout exception;',
'  pragma exception_init (e_lock_timeout, -3006);',
'  ',
'  function get_url',
'  (',
'    pi_prcs_id  in flow_processes.prcs_id%type',
'  , pi_sbfl_id  in flow_subflows.sbfl_id%type',
'  , pi_objt_id  in flow_objects.objt_id%type',
'  , pi_step_key in flow_subflows.sbfl_step_key%type default null',
'  , pi_scope    in flow_subflows.sbfl_scope%type default 0',
'  ) return varchar2',
'  as',
'    l_application        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_page               flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_request            flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_clear_cache        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_items              flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_values             flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_form_template_item flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_form_template_id   flow_types_pkg.t_bpmn_attribute_vc2;',
'  begin',
'    select max(ut_application)',
'         , max(ut_page_id)',
'         , max(ut_request)',
'         , max(ut_clear_cache)',
'         , listagg( ut_item_name, '','' ) within group ( order by order_key ) as item_names',
'         , listagg( ut_item_value, '','' ) within group ( order by order_key ) as item_values',
'         , max(ut_form_template_item)',
'         , max(ut_form_template_id)',
'      into l_application',
'         , l_page',
'         , l_request',
'         , l_clear_cache',
'         , l_items',
'         , l_values',
'         , l_form_template_item',
'         , l_form_template_id',
'      from flow_objects objt',
'      join json_table( objt.objt_attributes',
'           , ''$.apex''',
'             columns',
'               ut_application        varchar2(4000) path ''$.applicationId''',
'             , ut_page_id            varchar2(4000) path ''$.pageId''',
'             , ut_request            varchar2(4000) path ''$.request''',
'             , ut_clear_cache        varchar2(4000) path ''$.cache''',
'             , nested path ''$.pageItems[*]''',
'                 columns ( order_key for ordinality',
'                         , ut_item_name varchar2(4000) path ''$.name''',
'                         , ut_item_value varchar2(4000) path ''$.value''',
'                         )',
'             , ut_form_template_item varchar2(4000) path ''$.formTemplateItem''',
'             , ut_form_template_id   varchar2(4000) path ''$.formTemplateId''',
'           ) jt',
'        on objt.objt_id = pi_objt_id',
'    ;',
'',
'    -- substitution for all attributes (was values only pre-23.1)',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_application );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_page );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_request );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_clear_cache );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_items );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_values );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_form_template_item );',
'    flow_proc_vars_int.do_substitution ( pi_prcs_id => pi_prcs_id, pi_sbfl_id => pi_sbfl_id, pi_step_key => pi_step_key, pi_scope => pi_scope, pio_string  => l_form_template_id );',
'',
'    -- apex_simple_form',
'    if l_form_template_id is not null',
'       and',
'       l_form_template_item is not null',
'    then',
'      -- append item name',
'      if l_items is null then',
'        l_items := l_form_template_item;',
'      else',
'        l_items := l_items || '','' || l_form_template_item;',
'      end if;',
'      -- append item value',
'      if l_values is null then',
'        l_values := l_form_template_id;',
'      else',
'        l_values := l_values || '','' || l_form_template_id;',
'      end if;',
'    end if;',
'',
'    return',
'      apex_page.get_url',
'      (',
'        p_application => l_application',
'      , p_page        => l_page',
'      , p_request     => l_request',
'      , p_clear_cache => l_clear_cache',
'      , p_items       => l_items',
'      , p_values      => l_values',
'      )',
'    ;',
'  end get_url;',
'',
'  procedure process_apex_page_task',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'    l_priority_json           flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_priority                flow_subflows.sbfl_priority%type;',
'    l_due_on_json             flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_due_on                  flow_subflows.sbfl_due_on%type;',
'    l_potential_users_json    flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_potential_users         flow_subflows.sbfl_potential_users%type;',
'    l_potential_users_t       apex_t_varchar2;',
'    l_potential_groups_json   flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_potential_groups        flow_subflows.sbfl_potential_groups%type;',
'    l_excluded_users_json     flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_excluded_users          flow_subflows.sbfl_excluded_users%type;',
'    l_reservation             flow_subflows.sbfl_reservation%type;',
'    l_is_unallocated          varchar2(10) := flow_constants_pkg.gc_vcbool_true;',
'  begin',
'    apex_debug.enter ',
'    ( ''process_APEX_page_task''',
'    , ''p_step_info.target_objt_tag''   , p_step_info.target_objt_tag ',
'    , ''p_step_info.target_objt_subtag'', p_step_info.target_objt_subtag ',
'    );',
'      -- get the userTask subtype  ',
'    select objt.objt_attributes."apex"."priority"',
'         , objt.objt_attributes."apex"."dueOn"',
'         , objt.objt_attributes."apex"."potentialUsers"',
'         , objt.objt_attributes."apex"."potentialGroups"',
'         , objt.objt_attributes."apex"."excludedUsers"',
'      into l_priority_json',
'         , l_due_on_json',
'         , l_potential_users_json',
'         , l_potential_groups_json ',
'         , l_excluded_users_json',
'      from flow_objects objt',
'     where objt.objt_bpmn_id = p_step_info.target_objt_ref',
'       and objt.objt_dgrm_id = p_sbfl_info.sbfl_dgrm_id',
'       ;',
'',
'      if l_priority_json is not null then',
'        l_priority := flow_settings.get_priority ',
'                      ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                      , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                      , pi_expr    => l_priority_json',
'                      , pi_scope   => p_sbfl_info.sbfl_scope',
'                      );',
'      end if;',
'      if l_due_on_json is not null then ',
'        l_due_on   := flow_settings.get_due_on ',
'                      ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                      , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                      , pi_expr    => l_due_on_json',
'                      , pi_scope   => p_sbfl_info.sbfl_scope',
'                      );',
'      end if;',
'',
'      if l_potential_groups_json is not null then ',
'        l_potential_groups := flow_settings.get_vc2_expression',
'                      ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                      , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                      , pi_expr    => l_potential_groups_json',
'                      , pi_scope   => p_sbfl_info.sbfl_scope',
'                      );',
'        l_is_unallocated := flow_constants_pkg.gc_vcbool_false;',
'      end if;',
'      if l_excluded_users_json is not null then ',
'        l_excluded_users := flow_settings.get_vc2_expression',
'                      ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                      , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                      , pi_expr    => l_excluded_users_json',
'                      , pi_scope   => p_sbfl_info.sbfl_scope',
'                      );',
'        l_is_unallocated := flow_constants_pkg.gc_vcbool_false;',
'      end if;',
'      if l_potential_users_json is not null then ',
'        l_potential_users := flow_settings.get_vc2_expression ',
'                      ( pi_prcs_id => p_sbfl_info.sbfl_prcs_id',
'                      , pi_sbfl_id => p_sbfl_info.sbfl_id',
'                      , pi_expr    => l_potential_users_json',
'                      , pi_scope   => p_sbfl_info.sbfl_scope',
'                      );',
'        l_is_unallocated := flow_constants_pkg.gc_vcbool_false;',
'        -- check if only 1 potential user & if so, auto-reserve',
'        if l_potential_groups is null then',
'          l_potential_users_t := apex_string.split ( p_str => l_potential_users, p_sep => '':'');',
'          if l_potential_users_t is not null then',
'            if l_potential_users_t.count = 1 then',
'              if not apex_string_util.phrase_exists (p_phrase => l_potential_users_t(1), p_string => l_excluded_users) then',
'                -- only 1 potential user who is not excluded so auto-reserve',
'                l_reservation := l_potential_users_t(1);',
'              end if;',
'            end if;',
'          end if;',
'        end if;       ',
'      end if;',
'',
'      -- if no specific task allocation was found, (i.e., l_is_unallocated is true ) use the lane role already set on the subflow ',
'      -- as the potential_group if it has a lane role',
'',
'      update flow_subflows sbfl',
'         set sbfl.sbfl_last_update        = systimestamp',
'           , sbfl.sbfl_priority           = l_priority',
'           , sbfl.sbfl_due_on             = l_due_on',
'           , sbfl.sbfl_reservation        = l_reservation',
'           , sbfl.sbfl_potential_users    = l_potential_users',
'           , sbfl.sbfl_potential_groups   = coalesce ( l_potential_groups',
'                                                     , case ',
'                                                       when l_is_unallocated = flow_constants_pkg.gc_vcbool_true ',
'                                                        and sbfl_lane_isRole = flow_constants_pkg.gc_vcbool_true',
'                                                       then ',
'                                                         sbfl_lane_role',
'                                                       else null end',
'                                                      , null )                                                         ',
'           , sbfl.sbfl_excluded_users     = l_excluded_users',
'           , sbfl.sbfl_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                  , sys_context(''userenv'',''os_user'')',
'                                                  , sys_context(''userenv'',''session_user'')',
'                                                  )  ',
'       where sbfl.sbfl_id       = p_sbfl_info.sbfl_id',
'         and sbfl.sbfl_prcs_id  = p_sbfl_info.sbfl_prcs_id',
'      ;',
'  end process_apex_page_task;',
'',
'  function apex_task_pk_is_required',
'  ( p_app_id          flow_types_pkg.t_bpmn_attribute_vc2',
'  , p_task_static_id  flow_types_pkg.t_bpmn_attribute_vc2',
'  ) return boolean',
'  is',
'    l_task_pk_required  boolean;',
'$IF NOT flow_apex_env.ver_le_21 $THEN',
'    l_static_id            apex_appl_taskdefs.static_id%type;',
'    l_actions_table_name   apex_appl_taskdefs.actions_table_name%type;',
'    l_actions_sql_query    apex_appl_taskdefs.actions_sql_query%type;',
'$END',
'  begin',
'    --',
'    --  See if  the APEX Task needs a PK to be supplied. (for Actions Source Table or Actions Source Query)',
'    --',
'$IF NOT flow_apex_env.ver_le_21 $THEN',
'    select td.static_id',
'         , td.actions_table_name',
'         , td.actions_sql_query',
'      into l_static_id',
'         , l_actions_table_name',
'         , l_actions_sql_query ',
'      from apex_appl_taskdefs td',
'     where td.application_id = p_app_id',
'       and td.static_id      = p_task_static_id;',
'  ',
'    return (l_actions_sql_query is not null) or (l_actions_table_name is not null);',
'$ELSE',
'    return null;',
'$END',
'  end apex_task_pk_is_required;',
'',
'',
'  procedure process_apex_approval_task',
'  ( p_sbfl_info     in flow_subflows%rowtype',
'  , p_step_info     in flow_types_pkg.flow_step_info',
'  )',
'  is ',
'    l_prcs_id          flow_processes.prcs_id%type      := p_sbfl_info.sbfl_prcs_id;',
'    l_sbfl_id          flow_subflows.sbfl_id%type       := p_sbfl_info.sbfl_id;',
'    l_scope            flow_subflows.sbfl_scope%type    := p_sbfl_info.sbfl_scope;',
'    l_step_key         flow_subflows.sbfl_step_key%type := p_sbfl_info.sbfl_step_key;',
'    l_app_id           flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_static_id        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_subject          flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_parameters       flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_business_ref     flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_initiator        flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_priority_setting flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_priority         flow_subflows.sbfl_priority%type;',
'    l_due_on_setting   flow_types_pkg.t_bpmn_attribute_vc2; ',
'    l_due_on           flow_subflows.sbfl_due_on%type;',
'    l_result_var       flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_apex_task_id     number;',
'',
'    e_priority_invalid   exception;',
'    e_business_ref_null  exception;',
'    $IF flow_apex_env.ver_le_21 $THEN',
'      -- only need this for testing as apex_approval should fail if attempt to run without apex 22.1+',
'      type t_task_parameter  is record',
'      ( static_id     varchar2(255)',
'      , string_value  varchar2(255)',
'      );',
'      type t_task_parameters is table of t_task_parameter;',
'      l_task_parameter    t_task_parameter;',
'      l_task_parameters   t_task_parameters := t_task_parameters();',
'    $else',
'      -- APEX 22.1 supports Approval Components and has apex_approval package',
'      l_task_parameters  apex_approval.t_task_parameters := apex_approval.t_task_parameters();',
'      l_task_parameter   apex_approval.t_task_parameter;',
'    $end',
'  begin',
'    apex_debug.enter ',
'    ( ''process_apex_approval_task''',
'    , ''step_bpmn_id: '', p_step_info.target_objt_ref',
'    );',
'    -- check that APEX is >= v22.1 (required for APEX approval component)',
'    if flow_apex_env.ver_le_21_2 then ',
'      apex_debug.info (p_message  => ''APEX Version v22.1 or higher required for APEX Approval tasks.'');',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id        => l_prcs_id',
'      , pi_sbfl_id        => l_sbfl_id',
'      , pi_message_key    => ''apex-task-not-supported''',
'      , p0 => ''22.1''',
'      , p1 => p_step_info.target_objt_ref',
'      );  ',
'      -- $F4AMESSAGE ''apex-task-not-supported'' || ''APEX Workflow Feature use requires Oracle APEX v%0.''',
'    else',
'      -- get the parameters for the Approval Task creation',
'      select objt.objt_attributes."apex"."applicationId"',
'           , objt.objt_attributes."apex"."taskStaticId"',
'           , objt.objt_attributes."apex"."subject"',
'           , objt.objt_attributes."apex"."parameters"',
'           , objt.objt_attributes."apex"."businessRef"',
'           , objt.objt_attributes."apex"."resultVariable"',
'           , objt.objt_attributes."apex"."initiator"  ',
'           , objt.objt_attributes."apex"."priority"',
'           , objt.objt_attributes."apex"."dueOn"',
'        into l_app_id',
'           , l_static_id',
'           , l_subject',
'           , l_parameters',
'           , l_business_ref',
'           , l_result_var',
'           , l_initiator',
'           , l_priority_setting',
'           , l_due_on_setting',
'        from flow_objects objt',
'       where objt.objt_bpmn_id = p_step_info.target_objt_ref',
'         and objt.objt_dgrm_id = p_sbfl_info.sbfl_dgrm_id',
'         ;',
'      apex_debug.info ',
'        ( p_message => ''APEX Approval Task parameter  %0 '''))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'        , p0 => l_parameters',
'        );',
'      -- do substitutions',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_app_id);',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_static_id);',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_subject);',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_parameters);',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_business_ref);',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_result_var);',
'      flow_proc_vars_int.do_substitution( pi_prcs_id => l_prcs_id, pi_sbfl_id => l_sbfl_id, pi_scope => l_scope, pio_string => l_initiator);',
'',
'      if l_priority_setting is not null then',
'        l_priority := flow_settings.get_priority ( pi_prcs_id  => l_prcs_id',
'                                                 , pi_sbfl_id  => l_sbfl_id',
'                                                 , pi_expr     => l_priority_setting',
'                                                 , pi_scope    => l_scope',
'                                                 );',
'      end if;',
'',
'      if l_due_on_setting is not null then                                          ',
'        l_due_on :=   flow_settings.get_due_on   ( pi_prcs_id  => l_prcs_id',
'                                                 , pi_sbfl_id  => l_sbfl_id',
'                                                 , pi_expr     => l_due_on_setting',
'                                                 , pi_scope    => l_scope',
'                                                 );',
'      end if; ',
'',
'      -- create parameters table',
'      for parameters in (',
'        select static_id',
'             , data_type',
'             , value',
'        from json_table (l_parameters, ''$[*]''',
'                         columns(',
'                                  static_id path ''$.parStaticId'',',
'                                  data_type path ''$.parDataType'',',
'                                  value     path ''$.parValue''',
'                                )',
'                        )',
'      )',
'      loop',
'        l_task_parameter.static_id    := parameters.static_id;',
'        l_task_parameter.string_value := parameters.value;',
'        l_task_parameters(l_task_parameters.count+1) := l_task_parameter;',
'        apex_debug.info ',
'        ( p_message => ''APEX Approval Task parameter created - parameter %0 value %1''',
'        , p0 => parameters.static_id',
'        , p1 => parameters.value',
'        );',
'      end loop;',
'      -- check that priority is a valid priority 1-5 before passing',
'      begin',
'        if l_priority is not null then',
'          if l_priority not between 1 and 5 then',
'            raise e_priority_invalid;',
'          end if;',
'        end if;',
'      exception',
'        when value_error then',
'          apex_debug.error',
'          ( p_message => ''APEX Approval Task priority (%0) must be between 1 and 5''',
'          , p0 => l_priority',
'          );',
'          raise e_priority_invalid;',
'      end;',
'      -- check that business_ref is not null before passing (prevents "lost" tasks in APEX)',
'      l_business_ref := coalesce(l_business_ref, flow_globals.business_ref);',
'      if l_business_ref is null then',
'        if apex_task_pk_is_required (p_app_id => l_app_id, p_task_static_id => l_static_id) then ',
'          apex_debug.error',
'          ( p_message => ''APEX Approval Task business ref is null''',
'          , p0 => coalesce(l_business_ref, flow_globals.business_ref)',
'          );',
'          raise e_business_ref_null;',
'        end if;',
'      end if;',
'',
'      $IF not flow_apex_env.ver_le_21_2 $THEN     ',
'        -- create the task in APEX Approvals if APEX >= v22.1',
'        -- include due date if APEX >= 23.1',
'        begin',
'          l_apex_task_id := apex_approval.create_task',
'                         ( p_application_id     => l_app_id',
'                         , p_task_def_static_id => l_static_id',
'                         , p_subject            => l_subject',
'                         , p_detail_pk          => coalesce(l_business_ref, flow_globals.business_ref) ',
'                         , p_parameters         => l_task_parameters',
'                         , p_initiator          => coalesce ( l_initiator',
'                                                      , sys_context(''apex$session'',''app_user'') ',
'                                                      , sys_context(''userenv'',''os_user'')',
'                                                      , sys_context(''userenv'',''session_user'')',
'                                                      ) ',
'                         , p_priority           => l_priority',
'                         $IF not flow_apex_env.ver_le_22_2 $THEN',
'                         , p_due_date           => l_due_on',
'                         $END',
'                         );',
'          apex_debug.info ',
'          ( p_message => ''APEX Approval Task created - Approval Task Reference %0 created''',
'          , p0 => l_apex_task_id',
'          );  ',
'',
'          flow_proc_vars_int.set_var ',
'          ( pi_prcs_id      => l_prcs_id',
'          , pi_scope        => l_scope',
'          , pi_var_name     => p_step_info.target_objt_ref||flow_constants_pkg.gc_prov_suffix_task_id',
'          , pi_num_value    => l_apex_task_id',
'          , pi_sbfl_id      => l_sbfl_id',
'          , pi_objt_bpmn_id => p_step_info.target_objt_ref',
'          );',
'          -- set the status to ''waiting for approval''',
'          update flow_subflows sbfl',
'             set sbfl.sbfl_last_update    = systimestamp',
'               , sbfl.sbfl_status         = flow_constants_pkg.gc_sbfl_status_waiting_approval',
'               , sbfl.sbfl_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                      , sys_context(''userenv'',''os_user'')',
'                                                      , sys_context(''userenv'',''session_user'')',
'                                                      )  ',
'           where sbfl.sbfl_id       = l_sbfl_id',
'             and sbfl.sbfl_prcs_id  = l_prcs_id',
'          ;',
'        exception',
'          when e_priority_invalid then',
'            apex_debug.info ',
'            ( p_message => '' --- Error creating Approval Task.  Priority should evaluate to number between 1 and 5.  Priority: %0''',
'            , p0 => l_priority',
'            );  ',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id        => l_prcs_id',
'            , pi_message_key    => ''apex-task-priority-error''',
'            , p0 => l_priority',
'            );  ',
'            -- $F4AMESSAGE ''apex-task-priority-error'' || ''Error creating APEX Workflow task - invalid priority %0.''    ',
'          when e_business_ref_null then',
'            apex_debug.info',
'            ( p_message => '' --- Error creating Approval Task - Business Ref / System of Record Primary Key must be not null.''',
'            );',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id        => l_prcs_id',
'            , pi_message_key    => ''apex-task-business-ref-null''',
'            );  ',
'            -- $F4AMESSAGE ''apex-task-business-ref-null'' || ''Error creating Approval Task - Business Ref / System of Record Primary Key must be not null.''             ',
'',
'          when others then',
'            apex_debug.info ',
'            ( p_message => '' --- Error creating APEX Approval Task.  AppID %0 TaskStaticID %1 Subject %2 DetailPK %3 Initiator %4 Priority %5.''',
'            , p0 => l_app_id',
'            , p1 => l_static_id',
'            , p2 => l_subject',
'            , p3 => coalesce(l_business_ref, flow_globals.business_ref, null) ',
'            , p4 => l_initiator',
'            , p5 => l_priority',
'            );  ',
'            flow_errors.handle_instance_error',
'            ( pi_prcs_id        => l_prcs_id',
'            , pi_sbfl_id        => l_sbfl_id',
'            , pi_message_key    => ''apex-task-creation-error''',
'            , p0 => l_static_id',
'            , p1 => l_app_id',
'            );  ',
'            -- $F4AMESSAGE ''apex-task-creation-error'' || ''Error creating APEX Workflow task %0 in application %1.  see debug for details.'' ',
'        end; ',
'      $END',
'    end if;',
'  end process_apex_approval_task;',
'',
'  procedure cancel_apex_task',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_objt_bpmn_id  in flow_objects.objt_bpmn_id%type',
'    , p_apex_task_id  in number    ',
'    )',
'  is',
'  begin',
'    apex_debug.enter ',
'    ( ''cancel_apex_task''',
'    , ''apex task_id: '', p_apex_task_id ',
'    );',
'    $IF flow_apex_env.ver_le_21_2 $THEN',
'      null;',
'      apex_debug.info ',
'      ( p_message => ''APEX Workflow Task : %0  cancelled on object : %1 -- BUT APEX VERSION HAS NO APPROVALS!''',
'      , p0 => p_apex_task_id',
'      , p1 => p_objt_bpmn_id',
'      );',
'    $ELSE',
'      -- cancel task',
'      apex_approval.cancel_task (p_task_id => p_apex_task_id);',
'      apex_debug.info ',
'      ( p_message => ''APEX Workflow Task : %0  cancelled on object : %1''',
'      , p0 => p_apex_task_id',
'      , p1 => p_objt_bpmn_id',
'      );',
'    $END',
'  exception',
'    when others then',
'      flow_errors.handle_instance_error',
'      ( pi_prcs_id     => p_process_id',
'      , pi_message_key => ''apex-task-cancelation-error''',
'      , p0 => p_objt_bpmn_id',
'      , p1 => p_apex_task_id',
'      , p2 => sqlerrm',
'      );',
'      -- $F4AMESSAGE ''apex-task-cancelation-error'' || ''Error attempting to cancel APEX workflow task (task_id: %1 ) for process step : %0.)'' ',
'  end cancel_apex_task;',
'',
'  procedure return_approval_result',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_apex_task_id  in number',
'    , p_result        in flow_process_variables.prov_var_vc2%type default null',
'    )',
'    is',
'      l_sbfl_id             flow_subflows.sbfl_id%type;',
'      l_dgrm_id             flow_subflows.sbfl_dgrm_id%type;',
'      l_current_bpmn_id     flow_objects.objt_bpmn_id%type;',
'      l_scope               flow_subflows.sbfl_scope%type;',
'      l_step_key            flow_subflows.sbfl_step_key%type;',
'      l_var_name            flow_process_variables.prov_var_name%type;',
'      l_potential_current   flow_objects.objt_bpmn_id%type;',
'      l_result_var          flow_process_variables.prov_var_name%type;',
'',
'      e_task_id_proc_var_not_found  exception;',
'      e_task_id_duplicate_found     exception;',
'      e_task_not_current_step       exception;',
'      e_task_no_return_var          exception;',
'    begin',
'      apex_debug.enter',
'      (p_routine_name => ''return_approval_result''',
'      );',
'      -- check task belongs to this process by looking for a process variable with content = task id and name ending in task id suffix.',
'      begin',
'        select prov.prov_var_name',
'             , replace (prov.prov_var_name , flow_constants_pkg.gc_prov_suffix_task_id) l_potential_current',
'             , prov.prov_scope',
'          into l_var_name',
'             , l_potential_current',
'             , l_scope',
'          from flow_process_variables prov',
'         where prov.prov_prcs_id = p_process_id',
'           and prov.prov_var_num = p_apex_task_id',
'           and prov.prov_var_type = flow_constants_pkg.gc_prov_var_type_number',
'           and prov.prov_var_name like ''%''||flow_constants_pkg.gc_prov_suffix_task_id',
'        ;',
'        apex_debug.info ',
'        ( p_message => ''--- Returning Approval Result - Found current step %0 scope %1''',
'        , p0 => l_potential_current',
'        , p1 => l_scope',
'        );',
'      exception',
'        when no_data_found then',
'          raise e_task_id_proc_var_not_found;',
'        when too_many_rows then',
'          raise e_task_id_duplicate_found;',
'      end;',
'',
'      begin',
'        -- find and lock the subflow',
'        select sbfl.sbfl_id',
'             , sbfl.sbfl_step_key',
'             , sbfl.sbfl_dgrm_id',
'          into l_sbfl_id',
'             , l_step_key',
'             , l_dgrm_id',
'          from flow_subflows sbfl',
'         where sbfl.sbfl_prcs_id = p_process_id',
'           and sbfl.sbfl_scope = l_scope',
'           and sbfl.sbfl_current = l_potential_current',
'        for update of sbfl.sbfl_step_key wait 5;',
'      exception',
'        when no_data_found then',
'          raise e_task_not_current_step;',
'        when e_lock_timeout then',
'          raise e_lock_timeout;',
'      end;',
'      apex_debug.info ',
'      ( p_message => ''--- Returning Approval Result - Found Subflow %0 step Key %1 Diagram %2''',
'      , p0 => l_sbfl_id',
'      , p1 => l_step_key',
'      , p2 => l_dgrm_id',
'      );',
'      -- get name of return variable',
'      begin',
'        select objt.objt_attributes."apex"."resultVariable"',
'          into l_result_var',
'          from flow_objects objt',
'         where objt.objt_bpmn_id = l_potential_current',
'           and objt.objt_dgrm_id = l_dgrm_id;',
'        apex_debug.info ',
'        ( p_message => ''--- Returning Approval Result - Found result variable id %0''',
'        , p0 => l_result_var',
'        );',
'      exception',
'        when no_data_found then',
'          raise e_task_no_return_var;',
'      end;',
'',
'      -- create result variable',
'      flow_proc_vars_int.set_var',
'       ( pi_prcs_id       => p_process_id',
'       , pi_var_name      => l_result_var',
'       , pi_scope         => l_scope',
'       , pi_vc2_value     => p_result',
'       , pi_sbfl_id       => l_sbfl_id',
'       , pi_objt_bpmn_id  => l_potential_current',
'       );',
'      -- do next step',
'      flow_engine.flow_complete_step',
'        ( p_process_id    => p_process_id',
'        , p_subflow_id    => l_sbfl_id',
'        , p_step_key      => l_step_key',
'        );',
'    exception',
'      when e_lock_timeout then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => l_sbfl_id',
'        , pi_message_key => ''timeout_locking_subflow''',
'        , p0 => l_sbfl_id',
'        );',
'      when e_task_id_proc_var_not_found then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => l_sbfl_id',
'        , pi_message_key => ''apex-task-not-found''',
'        , p0 => p_apex_task_id ',
'        );',
'      when e_task_id_duplicate_found then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => l_sbfl_id',
'        , pi_message_key => ''apex-task-on-multiple-steps''',
'        , p0 => p_apex_task_id',
'        );',
'      when e_task_not_current_step then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => l_sbfl_id',
'        , pi_message_key => ''apex-task-not-current-step''',
'        , p0 => p_apex_task_id',
'        );',
'      when e_task_no_return_var then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => l_sbfl_id',
'        , pi_message_key => ''apex-task-invalid-return-var''',
'        , p0 => p_apex_task_id',
'        );      ',
'    end return_approval_result;',
'',
'end flow_usertask_pkg;',
'/',
'',
'create or replace package body flow_plsql_runner_pkg',
'as',
'/* ',
'-- Flows for APEX - flow_plsql_runner_pkg.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2020-2022.',
'--',
'-- Created    15-Nov-2020  Moritz Klein (MT AG)',
'-- Modified   12-Apr-2022  Richard Allen (Oracle)',
'-- Modified   20-May-2022  Moritz Klein (MT AG)',
'-- Modified   2022-07-18   Moritz Klein (MT AG)',
'--',
'*/',
'',
'  type t_runner_config is',
'    record',
'    (',
'      use_apex_exec varchar2(1) default ''N''',
'    , do_autobinds  varchar2(1) default ''N''',
'    , plsql_code    clob',
'    )',
'  ;',
'',
'  g_current_prcs_id flow_processes.prcs_id%type;',
'  g_current_sbfl_id flow_subflows.sbfl_id%type;',
'',
'  procedure init_globals',
'  (',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  , pi_sbfl_id in flow_subflows.sbfl_id%type',
'  )',
'  as',
'  begin',
'    g_current_prcs_id := pi_prcs_id;',
'    g_current_sbfl_id := pi_sbfl_id;',
'  end init_globals;',
'',
'  function get_current_prcs_id',
'    return flow_processes.prcs_id%type',
'  as',
'  begin',
'    return flow_globals.process_id;',
'  end get_current_prcs_id;',
'',
'  function get_current_sbfl_id',
'    return flow_subflows.sbfl_id%type',
'  as',
'  begin',
'    return flow_globals.subflow_id;',
'  end get_current_sbfl_id;',
'',
'  procedure execute_plsql',
'  (',
'    p_plsql_code in clob',
'  )',
'  as',
'  begin',
'    apex_debug.enter ',
'    (''execute_plsql''',
'    , ''p_plsql_code'', dbms_lob.substr(p_plsql_code, 2000, 1)',
'    );',
'    -- Always wrap code into begin..end',
'    -- Developers are allowed to omit those if no declaration section needed',
'',
'    execute immediate',
'      ''begin'' || apex_application.lf ||',
'      p_plsql_code || apex_application.lf ||',
'      ''end;''',
'    ;',
'  end execute_plsql;',
'',
'  procedure get_runner_config',
'  (',
'    pi_objt_id        in flow_objects.objt_id%type',
'  , po_use_apex_exec out nocopy boolean',
'  , po_do_autobinds  out nocopy boolean',
'  , po_plsql_code    out nocopy clob',
'  )',
'  as',
'    l_plain_json  clob;',
'    l_json_config sys.json_object_t;',
'    l_code_json   sys.json_array_t;',
'  begin',
'    select json_query( objt.objt_attributes format json, ''$.apex'' returning clob ) as json_data',
'      into l_plain_json',
'      from flow_objects objt',
'     where objt.objt_id = pi_objt_id',
'    ;',
'',
'    l_json_config    := sys.json_object_t( l_plain_json );',
'    po_use_apex_exec := coalesce( l_json_config.get_boolean( ''engine'' ), false );',
'    po_do_autobinds  := coalesce( l_json_config.get_boolean( ''autoBinds'' ), false );',
'    l_code_json      := l_json_config.get_array( ''plsqlCode'' );',
'    po_plsql_code    := flow_engine_util.json_array_join( p_json_array => l_code_json );',
'  end get_runner_config;',
'',
'  procedure run_task_script',
'  (',
'    pi_prcs_id  in flow_processes.prcs_id%type',
'  , pi_sbfl_id  in flow_subflows.sbfl_id%type',
'  , pi_objt_id  in flow_objects.objt_id%type',
'  , pi_step_key in flow_subflows.sbfl_step_key%type default null',
'  )',
'  as',
'    l_use_apex_exec boolean := false;',
'    l_plsql_code    clob;',
'    l_do_autobind   boolean := false;',
'',
'    l_sql_parameters apex_exec.t_parameters;',
'  begin',
'    apex_debug.enter ',
'    ( ''run_task_script''',
'    , ''pi_objt_id'', pi_objt_id',
'    );',
'',
'    flow_globals.set_context ',
'    ( pi_prcs_id      => pi_prcs_id',
'    , pi_sbfl_id      => pi_sbfl_id ',
'    , pi_step_key     => pi_step_key',
'    , pi_scope        => flow_engine_util.get_scope ( p_process_id => pi_prcs_id, p_subflow_id => pi_sbfl_id)',
'    , pi_loop_counter => flow_engine_util.get_loop_counter (pi_sbfl_id => pi_sbfl_id)',
'    );',
'',
'    get_runner_config',
'    (',
'      pi_objt_id       => pi_objt_id',
'    , po_use_apex_exec => l_use_apex_exec',
'    , po_do_autobinds  => l_do_autobind',
'    , po_plsql_code    => l_plsql_code',
'    );',
'',
'    flow_proc_vars_int.do_substitution',
'    (',
'      pi_prcs_id  => pi_prcs_id',
'    , pi_sbfl_id  => pi_sbfl_id',
'    , pi_scope    => flow_globals.scope',
'    , pi_step_key => pi_step_key',
'    , pio_string  => l_plsql_code',
'    );',
'',
'    if not l_do_autobind then',
'      -- bind in process variables rather than APEX session state',
'      l_sql_parameters := flow_proc_vars_int.get_parameter_list',
'                          ( pi_expr       => l_plsql_code',
'                          , pi_prcs_id     => pi_prcs_id',
'                          , pi_sbfl_id    => pi_sbfl_id',
'                          , pi_scope      => flow_globals.scope',
'                          );',
'    end if;',
'      ',
'    if l_use_apex_exec then',
'      apex_exec.execute_plsql',
'      (',
'        p_plsql_code      => l_plsql_code',
'      , p_auto_bind_items => l_do_autobind',
'      , p_sql_parameters  => l_sql_parameters',
'      );',
'    else',
'      execute_plsql',
'      (',
'        p_plsql_code => l_plsql_code',
'      );',
'    end if;',
'',
'  exception',
'    when e_plsql_script_requested_stop then ',
'      apex_debug.error',
'      (',
'        p_message => ''User script run by flow_plsql_runner_pkg.run_task_script requested stop.''',
'      , p0        => sqlerrm',
'      );',
'      raise e_plsql_script_requested_stop;     ',
'    when others then',
'      apex_debug.error',
'      (',
'        p_message => ''Error during flow_plsql_runner_pkg.run_task_script. SQLERRM: %s''',
'      , p0        => sqlerrm',
'      );',
'      raise e_plsql_script_failed;',
'  end run_task_script;',
'',
'end flow_plsql_runner_pkg;',
'/',
'',
'create or replace package body flow_apex_session',
'as',
'',
'  type t_session_parameters    is record ',
'  ( app_id   flow_types_pkg.t_bpmn_attribute_vc2',
'  , page_id  flow_types_pkg.t_bpmn_attribute_vc2',
'  , username flow_types_pkg.t_bpmn_attribute_vc2',
'  );',
'  e_apex_session_missing_param        exception;',
'  e_apex_session_multiple_processes   exception;',
'',
'  function get_session_parameters ',
'  ( p_dgrm_id         flow_diagrams.dgrm_id%type default null',
'  )',
'  return t_session_parameters',
'  as',
'    l_var_value             flow_subflows.sbfl_current%type;',
'    l_session_parameters    t_session_parameters;',
'  begin',
'    -- null dgrm_id case is for running archives - no process or diagram is running',
'    if p_dgrm_id is not null then',
'      begin',
'        select jt.app_id',
'             , jt.page_id',
'             , jt.username',
'          into l_session_parameters',
'          from flow_objects objt',
'             , json_table( objt.objt_attributes, ''$.apex''',
'                 columns',
'                   app_id   varchar2(4000) path ''$.applicationId''',
'                 , page_id  varchar2(4000) path ''$.pageId''',
'                 , username varchar2(4000) path ''$.username''',
'               ) jt',
'         where objt.objt_dgrm_id  = p_dgrm_id',
'           and objt.objt_tag_name = flow_constants_pkg.gc_bpmn_process',
'        ;',
'      exception',
'        when too_many_rows then',
'          apex_debug.info ( p_message => ''flow_apex_session - multiple bpmn:process events found in model.  Multiple not yet supported.  raising Error'');',
'          raise e_apex_session_multiple_processes;',
'          /* Note for future:  Session information is available from bpmn:process in diagram.  We currently support bpmn:process or bpmn:collaboration as the top ',
'          level in the XML but dont create a flow_object for the collaboration object.   So top level is the bpmn:participation.',
'          when we support collaboration properly (i.e., support message flow between participations), this code will need to be revisited.',
'          */',
'        when no_data_found then',
'          apex_debug.info ( p_message => ''flow_apex_session - no session parameters found from diagram.'');',
'      end;',
'    end if;',
'',
'',
'    if (  l_session_parameters.app_id is null',
'       or l_session_parameters.page_id is null ',
'       or l_session_parameters.username is null',
'       ) then',
'      -- attribute not set at process diagram level - try system config',
'      l_session_parameters.app_id   := flow_engine_util.get_config_value ',
'                        ( p_config_key    => flow_constants_pkg.gc_config_default_application',
'                        , p_default_value => null',
'                        );',
'      l_session_parameters.page_id  := flow_engine_util.get_config_value ',
'                        ( p_config_key    => flow_constants_pkg.gc_config_default_pageid ',
'                        , p_default_value => null',
'                        );',
'      l_session_parameters.username := flow_engine_util.get_config_value ',
'                        ( p_config_key    => flow_constants_pkg.gc_config_default_username',
'                        , p_default_value => null',
'                        );',
'    end if;',
'',
'    if (  l_session_parameters.app_id is null',
'       or l_session_parameters.page_id is null ',
'       or l_session_parameters.username is null',
'       ) then',
'      -- attribute not set at system config level - throw error   ',
'      raise e_apex_session_missing_param;',
'    end if;',
'    return l_session_parameters;',
'  end get_session_parameters;',
'',
'  procedure set_async_proc_vars',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  , p_subflow_id         in flow_subflows.sbfl_id%type',
'  )',
'  is ',
'    l_current                flow_subflows.sbfl_current%type;',
'    l_sbfl_dgrm_id           flow_subflows.sbfl_dgrm_id%type;',
'    l_session_parameters     t_session_parameters;',
'    l_timer_scope            flow_subflows.sbfl_scope%type;   ',
'  begin',
'    -- get the current object (and scope) as timer object name',
'    select sbfl.sbfl_current',
'         , sbfl.sbfl_dgrm_id',
'         , sbfl.sbfl_scope',
'      into l_current',
'         , l_sbfl_dgrm_id',
'         , l_timer_scope',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_prcs_id = p_process_id',
'       and sbfl.sbfl_id      = p_subflow_id',
'    ;',
'    -- check if required process variables exist in current scope ',
'    if flow_proc_vars_int.get_var_vc2 ( pi_prcs_id  => p_process_id',
'                                     , pi_var_name => l_current || '':'' || flow_constants_pkg.gc_async_parameter_applicationId',
'                                     , pi_scope    => l_timer_scope',
'                                     ) is null  ',
'    or flow_proc_vars_int.get_var_vc2 ( pi_prcs_id  => p_process_id',
'                                     , pi_var_name => l_current || '':'' || flow_constants_pkg.gc_async_parameter_pageId',
'                                     , pi_scope    => l_timer_scope',
'                                     ) is null',
'    or flow_proc_vars_int.get_var_vc2 ( pi_prcs_id  => p_process_id',
'                                     , pi_var_name => l_current || '':'' || flow_constants_pkg.gc_async_parameter_username',
'                                     , pi_scope    => l_timer_scope',
'                                     ) is null',
'    then',
'      l_session_parameters := get_session_parameters (p_dgrm_id => l_sbfl_dgrm_id);',
'',
'      flow_proc_vars_int.set_var',
'          ( pi_prcs_id      => p_process_id',
'          , pi_var_name     => l_current || '':'' || flow_constants_pkg.gc_async_parameter_applicationId',
'          , pi_scope        => l_timer_scope',
'          , pi_vc2_value    => l_session_parameters.app_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_objt_bpmn_id => l_current',
'          );',
'      flow_proc_vars_int.set_var',
'          ( pi_prcs_id      => p_process_id',
'          , pi_var_name     => l_current || '':'' || flow_constants_pkg.gc_async_parameter_pageId',
'          , pi_scope        => l_timer_scope',
'          , pi_vc2_value    => l_session_parameters.page_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_objt_bpmn_id => l_current',
'          );',
'      flow_proc_vars_int.set_var',
'          ( pi_prcs_id      => p_process_id',
'          , pi_var_name     => l_current || '':'' || flow_constants_pkg.gc_async_parameter_username',
'          , pi_scope        => l_timer_scope',
'          , pi_vc2_value    => l_session_parameters.username',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_objt_bpmn_id => l_current',
'          );',
'    end if;',
'  exception',
'      when e_apex_session_multiple_processes then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_message_key  => ''apex-task-multiple-process''',
'          );',
'          -- F4A$MESSAGE ''apex-session-multiple-process'' || ''Error creating APEX session.  BPMN diagram contains multiple Process objects.''',
'      when e_apex_session_missing_param then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_message_key  => ''apex-session-params-not-set''',
'          , p0              => l_current',
'          );',
'          -- $F4AMESSAGE ''apex-session-params-not-set'' || ''Asynchronous connection details for timer %0 need to be set in process variables, diagram async connection details, or system config details.'' ',
'  end set_async_proc_vars;',
'',
' function create_async_session',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  , p_subflow_id         in flow_subflows.sbfl_id%type',
'  ) return number',
'  is ',
'    l_timer_name             flow_subflows.sbfl_current%type;',
'    l_timer_scope            flow_subflows.sbfl_scope%type;',
'    l_app_id                 flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_page_id                flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_username               flow_types_pkg.t_bpmn_attribute_vc2;',
'    l_session_id             number;',
'  begin',
'    flow_globals.set_is_recursive_step (p_is_recursive_step => true);',
'    -- get the current object (and scope) as timer object name',
'    select sbfl.sbfl_current',
'         , sbfl.sbfl_scope',
'      into l_timer_name',
'         , l_timer_scope',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_prcs_id = p_process_id',
'       and sbfl.sbfl_id      = p_subflow_id',
'    ;',
'    -- get async process variable details ',
'    l_username  := flow_proc_vars_int.get_var_vc2',
'                      ( pi_prcs_id   => p_process_id',
'                      , pi_var_name  => l_timer_name || '':'' || flow_constants_pkg.gc_async_parameter_username',
'                      , pi_scope     => l_timer_scope',
'                      );',
'    l_app_id    := flow_proc_vars_int.get_var_vc2',
'                      ( pi_prcs_id   => p_process_id',
'                      , pi_var_name  => l_timer_name || '':'' || flow_constants_pkg.gc_async_parameter_applicationId',
'                      , pi_scope     => l_timer_scope',
'                      );',
'    l_page_id   := flow_proc_vars_int.get_var_vc2',
'                      ( pi_prcs_id   => p_process_id',
'                      , pi_var_name  => l_timer_name || '':'' || flow_constants_pkg.gc_async_parameter_pageId',
'                      , pi_scope     => l_timer_scope',
'                      );         ',
'    -- check all process variables are set in case they '))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'have been deleted since timer was set',
'    if l_username is null then',
'      flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_message_key  => ''async-no-username''',
'          , p0              => l_timer_name',
'          );',
'    end if;',
'    if l_app_id is null then',
'      flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_message_key  => ''async-no-appid''',
'          , p0              => l_timer_name',
'          );',
'    end if;',
'    if l_page_id is null then',
'      flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_message_key  => ''async-no-pageid''',
'          , p0              => l_timer_name',
'          );',
'    end if;',
'    -- create apex session',
'    begin',
'      apex_session.create_session ',
'        ( p_app_id   => l_app_id',
'        , p_page_id  => l_page_id',
'        , p_username => l_username ',
'        );',
'    exception',
'      when flow_constants_pkg.ge_invalid_session_params then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_subflow_id',
'          , pi_message_key  => ''async-invalid_params''',
'          , p0              => l_timer_name',
'          );',
'          raise flow_constants_pkg.ge_invalid_session_params;',
'    end;',
'    return v(''APP_SESSION'');',
'  end create_async_session;',
'',
' function create_api_session',
'  ( p_dgrm_id         in flow_diagrams.dgrm_id%type default null',
'  , p_prcs_id         in flow_processes.prcs_id%type default null',
'  ) return number',
'  is ',
'    l_session_id             number;',
'    l_session_parameters     t_session_parameters;',
'  begin',
'    -- get session parameters from process diagram or system config',
'    l_session_parameters := get_session_parameters ( p_dgrm_id => p_dgrm_id);',
'  ',
'    -- create apex session',
'    begin',
'      apex_session.create_session ',
'        ( p_app_id   => l_session_parameters.app_id',
'        , p_page_id  => l_session_parameters.page_id',
'        , p_username => l_session_parameters.username ',
'        );',
'    exception',
'      when flow_constants_pkg.ge_invalid_session_params then',
'        if p_prcs_id is not null then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id      => p_prcs_id',
'          , pi_message_key  => ''async-invalid_params''',
'          , p0              => ''API Call''',
'          );',
'          raise flow_constants_pkg.ge_invalid_session_params;',
'        else',
'          flow_errors.handle_general_error',
'          ( pi_message_key  => ''async-invalid_params''',
'          , p0 => ''Default Parameters in Configurations''',
'          );',
'          raise flow_constants_pkg.ge_invalid_session_params;',
'        end if;',
'    end;',
'    return v(''APP_SESSION'');',
'  end create_api_session;',
'',
'  function create_api_session',
'  ( p_subflow_id         in flow_subflows.sbfl_id%type',
'  ) return number',
'  is ',
'    l_dgrm_id      flow_diagrams.dgrm_id%type;',
'    l_prcs_id      flow_processes.prcs_id%type;',
'  begin',
'    select sbfl.sbfl_dgrm_id',
'         , sbfl.sbfl_prcs_id',
'      into l_dgrm_id',
'         , l_prcs_id',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_id = p_subflow_id',
'    ;',
'    return create_api_session (p_dgrm_id => l_dgrm_id, p_prcs_id => l_prcs_id);',
'  end create_api_session;',
'',
'  function create_api_session',
'  ( p_process_id         in flow_processes.prcs_id%type',
'  ) return number',
'  is ',
'    l_dgrm_id      flow_diagrams.dgrm_id%type;',
'  begin',
'    select prcs.prcs_dgrm_id',
'      into l_dgrm_id',
'      from flow_processes prcs',
'     where prcs.prcs_id = p_process_id',
'    ;',
'    return create_api_session (p_dgrm_id => l_dgrm_id, p_prcs_id => p_process_id);',
'  end create_api_session;',
'',
'  function create_api_session',
'  ( p_function          in varchar2',
'  ) return number',
'  is ',
'    l_dgrm_id      flow_diagrams.dgrm_id%type;',
'  begin',
'    if p_function = ''archive'' then ',
'      return create_api_session (p_prcs_id => null, p_dgrm_id => null);',
'    else',
'      return null;',
'    end if;',
'  end create_api_session;',
'',
'  procedure delete_session',
'  ( p_session_id         in number)',
'  is ',
'  begin',
'    apex_session.delete_session ( p_session_id => p_session_id);',
'  end;',
'',
'end flow_apex_session;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_subprocesses.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2020,2022.',
'--',
'-- Created 22-Feb-2022   Richard Allen - Refactor SubProcess code from flow_engine',
'--',
'*/',
'',
'create or replace package body flow_subprocesses',
'as',
'',
'/* -----------------------------------------------------------------------------',
'--',
'--  process_process_level_endEvent',
'--',
'--  handles endEvents that complete a process level, e.g., subProcesses and callActivities',
'--',
'--------------------------------------------------------------------------------',
'*/',
'',
'  procedure process_process_level_endEvent',
'    ( p_process_id        in flow_processes.prcs_id%type',
'    , p_subflow_id        in flow_subflows.sbfl_id%type',
'    , p_sbfl_info         in flow_subflows%rowtype',
'    , p_step_info         in flow_types_pkg.flow_step_info',
'    , p_sbfl_context_par  in flow_types_pkg.t_subflow_context',
'    )',
'  is',
'    l_boundary_event        flow_objects.objt_bpmn_id%type;',
'    l_subproc_objt          flow_objects.objt_bpmn_id%type;',
'    l_remaining_subflows    number;',
'    l_parent_step_key       flow_subflows.sbfl_step_key%type;',
'    l_end_is_interrupted    boolean;  ',
'    l_par_objt_type         flow_objects.objt_tag_name%type;',
'    l_par_dgrm_id           flow_diagrams.dgrm_id%type;',
'    l_par_objt_id           flow_objects.objt_id%type;',
'  begin',
'    apex_debug.enter',
'      ( ''Process Level End Event''',
'      , ''End Event''       , p_step_info.target_objt_ref',
'      , ''Event Type''      , p_step_info.target_objt_subtag',
'      , ''Parent Event''    , p_sbfl_context_par.sbfl_id',
'      , ''Parent Step Key'' , p_sbfl_context_par.step_key',
'      ); ',
'    if p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_error_event_definition then',
'      -- error exit event - return to errorBoundaryEvent if it exists and if not to normal exit',
'      begin',
'        select boundary_objt.objt_bpmn_id',
'             , subproc_objt.objt_bpmn_id',
'             , par_sbfl.sbfl_step_key',
'          into l_boundary_event',
'             , l_subproc_objt',
'             , l_parent_step_key',
'          from flow_objects boundary_objt',
'          join flow_objects subproc_objt',
'            on subproc_objt.objt_bpmn_id = boundary_objt.objt_attached_to ',
'           and subproc_objt.objt_dgrm_id = boundary_objt.objt_dgrm_id',
'          join flow_subflows par_sbfl',
'            on par_sbfl.sbfl_current = subproc_objt.objt_bpmn_id',
'           and par_sbfl.sbfl_dgrm_id = subproc_objt.objt_dgrm_id',
'         where par_sbfl.sbfl_id = p_sbfl_context_par.sbfl_id',
'           and par_sbfl.sbfl_prcs_id = p_process_id',
'           and boundary_objt.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_error_event_definition',
'        ;',
'        -- first remove any non-interrupting events that are on the parent event',
'        flow_boundary_events.unset_boundary_events (p_process_id, p_sbfl_context_par.sbfl_id);',
'        -- set current event on parent process to the error Boundary Event',
'        update flow_subflows sbfl',
'        set sbfl.sbfl_current         = l_boundary_event',
'          , sbfl.sbfl_last_completed  = l_subproc_objt  -- is this done in next_step?',
'          , sbfl.sbfl_status          = flow_constants_pkg.gc_sbfl_status_running',
'          , sbfl.sbfl_last_update     = systimestamp',
'          , sbfl.sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'        where sbfl.sbfl_id = p_sbfl_context_par.sbfl_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'          ;',
'        -- execute the on-event expressions for the boundary event',
'        flow_expressions.process_expressions',
'        ( pi_objt_bpmn_id => l_boundary_event  ',
'        , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'        , pi_prcs_id      => p_process_id',
'        , pi_sbfl_id      => p_sbfl_context_par.sbfl_id',
'        , pi_var_scope    => p_sbfl_context_par.scope',
'        , pi_expr_scope   => p_sbfl_context_par.scope        ',
'        );',
'        l_end_is_interrupted := true;',
'',
'      exception',
'        when no_data_found then',
'          -- error exit with no Boundary Event specified -- return to normal exit',
'          l_end_is_interrupted := true;',
'        when too_many_rows then',
'          flow_errors.handle_instance_error',
'          ( pi_prcs_id     => p_process_id',
'          , pi_sbfl_id     => p_subflow_id',
'          , pi_message_key => ''boundary-event-too-many''',
'          , p0 => ''error''',
'          );',
'          -- $F4AMESSAGE ''boundary-event-too-many'' || ''More than one %0 boundaryEvent found on sub process.''  ',
'      end;',
'      -- stop processing in process level and all its children levels',
'      flow_engine_util.terminate_level',
'      ( p_process_id => p_process_id',
'      , p_process_level => p_sbfl_info.sbfl_process_level',
'      );',
'      -- normal end processing will be ignored but we neeed to step forward on the parent',
'      flow_engine.flow_complete_step ',
'      ( p_process_id        => p_process_id',
'      , p_subflow_id        => p_sbfl_context_par.sbfl_id',
'      , p_step_key          => p_sbfl_context_par.step_key',
'      , p_log_as_completed  => false',
'      );',
'    elsif p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_terminate_event_definition then',
'      -- sub process terminate end',
'      -- stop processing in sub process and all children',
'      flow_engine_util.terminate_level',
'      ( p_process_id    => p_process_id',
'      , p_process_level => p_sbfl_info.sbfl_process_level',
'      ); ',
'      l_end_is_interrupted := true;',
'      -- normal end processing will be ignored but we neeed to step forward on the parent',
'      flow_engine.flow_complete_step ',
'      ( p_process_id  => p_process_id',
'      , p_subflow_id  => p_sbfl_context_par.sbfl_id',
'      , p_step_key  => p_sbfl_context_par.step_key',
'      , p_log_as_completed  => false',
'      );',
'    elsif p_step_info.target_objt_subtag = flow_constants_pkg.gc_bpmn_escalation_event_definition then',
'      -- sub process escalation end',
'      -- this can be interrupting or non-interupting',
'      flow_boundary_events.process_escalation',
'      ( pi_sbfl_info        => p_sbfl_info',
'      , pi_step_info        => p_step_info',
'      , pi_par_sbfl         => p_sbfl_context_par.sbfl_id',
'      , pi_source_type      => flow_constants_pkg.gc_bpmn_end_event',
'      , po_step_key         => l_parent_step_key',
'      , po_is_interrupting  => l_end_is_interrupted',
'      );',
'    else ',
'      -- sub process - null or other (inc message) end event',
'      flow_engine_util.subflow_complete',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      );',
'      l_end_is_interrupted := false;',
'    end if;',
'',
'    if not l_end_is_interrupted then',
'      -- normal process level processing.  ',
'      -- check if there are ANY remaining subflows in the process level.  ',
'      -- If none, close process level',
'      select count(*)',
'        into l_remaining_subflows',
'        from flow_subflows sbfl',
'       where sbfl.sbfl_prcs_id = p_process_id',
'         and sbfl.sbfl_process_level = p_sbfl_info.sbfl_process_level;',
'',
'      if l_remaining_subflows = 0 then ',
'        -- No remaining subflows so process level has completed ',
'        select objt.objt_tag_name',
'             , par_sbfl.sbfl_dgrm_id',
'             , objt.objt_id',
'          into l_par_objt_type',
'             , l_par_dgrm_id',
'             , l_par_objt_id',
'          from flow_objects objt',
'          join flow_subflows par_sbfl',
'            on par_sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'           and par_sbfl.sbfl_current = objt.objt_bpmn_id',
'         where par_sbfl.sbfl_id = p_sbfl_context_par.sbfl_id',
'        ;',
'        if l_par_objt_type = flow_constants_pkg.gc_bpmn_call_activity then',
'          -- map outVariables expressions for call return (variables in calling scope, expressions in called scope)',
'          -- note: outVariable processing only occurs if the callActivit has a non-interrupted return',
'          flow_expressions.process_expressions',
'          ( pi_objt_id      => l_par_objt_id',
'          , pi_set          => flow_constants_pkg.gc_expr_set_out_variables',
'          , pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => p_sbfl_context_par.sbfl_id   ',
'          , pi_var_scope    => p_sbfl_context_par.scope',
'          , pi_expr_scope   => p_sbfl_info.sbfl_scope',
'          );      ',
'          -- log the diagram as being completed',
'          flow_logging.log_instance_event',
'          ( p_process_id    => p_process_id',
'          , p_objt_bpmn_id  => p_step_info.target_objt_ref',
'          , p_event         => flow_constants_pkg.gc_prcs_event_leave_call',
'          , p_comment       => ''Leaving called diagram ''||',
'                               flow_diagram.get_diagram_name (pi_dgrm_id => p_sbfl_info.sbfl_dgrm_id) ||''.''',
'          );  ',
'        end if;',
'        -- return to parent level and do next step',
'        apex_debug.info (''Process Level Completed: Process level %0'', p_sbfl_info.sbfl_process_level );',
'        flow_engine.flow_complete_step ',
'        ( p_process_id => p_process_id',
'        , p_subflow_id => p_sbfl_context_par.sbfl_id',
'        , p_step_key   => p_sbfl_context_par.step_key',
'        );  ',
'      end if;',
'    end if;',
'  end process_process_level_endEvent;',
'',
'  procedure process_subProcess',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is',
'    l_target_objt_sub        flow_objects.objt_bpmn_id%type; --target object in subprocess',
'    l_sbfl_context_sub       flow_types_pkg.t_subflow_context;   ',
'  begin',
'    apex_debug.enter ',
'    ( ''process_subprocess''',
'    , ''object'', p_step_info.target_objt_tag ',
'    );',
'    begin',
'       select objt.objt_bpmn_id',
'         into l_target_objt_sub',
'         from flow_objects objt',
'        where objt.objt_objt_id  = p_step_info.target_objt_id',
'          and objt.objt_tag_name = flow_constants_pkg.gc_bpmn_start_event  ',
'          and objt.objt_dgrm_id  = p_step_info.dgrm_id',
'       ;',
'    exception',
'      when no_data_found then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => p_subflow_id',
'        , pi_message_key => ''subProcess-no-start''',
'        );',
'      -- $F4AMESSAGE ''subProcess-no-start'' || ''Unable to find Sub-Process Start Event.''  ',
'      when too_many_rows then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id     => p_process_id',
'        , pi_sbfl_id     => p_subflow_id',
'        , pi_message_key => ''subProcess-too-many-starts''',
'        );',
'        -- $F4AMESSAGE ''subProcess-too-many-starts'' || ''More than one Sub-Process Start found.''  ',
'    end;',
'    -- start subflow for the sub-process',
'    l_sbfl_context_sub := ',
'      flow_engine_util.subflow_start',
'      ( p_process_id => p_process_id',
'      , p_parent_subflow => p_subflow_id',
'      , p_starting_object => p_step_info.target_objt_ref -- parent subProc activity',
'      , p_current_object => l_target_objt_sub -- subProc startEvent',
'      , p_route => ''sub main''',
'      , p_last_completed => p_sbfl_info.sbfl_last_completed -- previous activity on parent proc',
'      , p_parent_sbfl_proc_level => null',
'      , p_new_proc_level => true',
'      , p_dgrm_id => p_sbfl_info.sbfl_dgrm_id',
'      );',
'',
'    -- Always do all updates to parent data first before performing any next step in the children.',
'    -- Reason: A subflow could immediately disappear if we''re stepping through it completely.',
'    -- check for any errors on the step',
'    if not flow_globals.get_step_error then ',
'      -- set boundaryEvent events, if any',
'      flow_boundary_events.set_boundary_events ',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_sbfl_info  => p_sbfl_info',
'      );  ',
'      if not flow_globals.get_step_error then ',
'        -- Check again, then Update parent subflow',
'        update flow_subflows sbfl',
'        set   sbfl.sbfl_current         = p_step_info.target_objt_ref -- parent subProc Activity',
'            , sbfl.sbfl_last_completed  = p_sbfl_info.sbfl_last_completed',
'            , sbfl.sbfl_status          = flow_constants_pkg.gc_sbfl_status_in_subprocess',
'            , sbfl.sbfl_last_update     = systimestamp',
'            , sbfl.sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                   , sys_context(''userenv'',''os_user'')',
'                                                   , sys_context(''userenv'',''session_user'')',
'                                                   )  ',
'        where sbfl.sbfl_id = p_subflow_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'        ;  ',
'',
'        --  commit parent here',
'        commit;',
'',
'        apex_debug.info (p_message => ''SubProcess Parent Transaction commited'');',
'',
'        -- reset step_had_error flag',
'        flow_globals.set_step_error ( p_has_error => false);',
'',
'        -- relock child subflow(in case earlier loop terminated everything in level)',
'        if flow_engine_util.lock_subflow',
'          ( p_subflow_id => l_sbfl_context_sub.sbfl_id',
'          )',
'        then',
'          -- run on-event expressions for child startEvent',
'          flow_expressions.process_expressions',
'          ( pi_objt_bpmn_id => l_target_objt_sub  ',
'          , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'          , pi_prcs_id      => p_process_id',
'          , pi_sbfl_id      => l_sbfl_context_sub.sbfl_id',
'          , pi_var_scope    => l_sbfl_context_sub.scope',
'          , pi_expr_scope   => l_sbfl_context_sub.scope',
'          );',
'',
'          if not flow_globals.get_step_error then ',
'',
'            -- check again for any errors from expressions before stepping forward in the sub_process',
'            flow_engine.flow_complete_step   ',
'            ( p_process_id    => p_process_id',
'            , p_subflow_id    => l_sbfl_context_sub.sbfl_id',
'            , p_step_key      => l_sbfl_context_sub.step_key',
'            , p_forward_route => null',
'            );',
'          end if;',
'        end if;',
'        -- reset step_had_error flag',
'        flow_globals.set_step_error ( p_has_error => false);',
'      end if;',
'    end if;',
'  end process_subProcess; ',
'',
'end flow_subprocesses;',
'/',
'',
'',
'',
'',
'',
'create or replace package body flow_call_activities ',
'as',
'/* ',
'-- Flows for APEX - flow_call_activities.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2020,2022.',
'--',
'-- Created  19-Feb-2022  Richard Allen - Oracle  ',
'-- Modified 22-May-2022  Moritz Klein (MT AG)',
'--',
'*/',
'',
'  type t_call_def is record',
'    ( dgrm_name              flow_diagrams.dgrm_name%type',
'    , dgrm_version           flow_diagrams.dgrm_version%type',
'    , dgrm_id                flow_diagrams.dgrm_id%type',
'    , dgrm_version_selection flow_types_pkg.t_bpmn_attribute_vc2',
'    );',
'',
'  function is_called_activity',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type  ',
'    ) return boolean',
'  is',
'    l_prcs_dgrm_id flow_processes.prcs_dgrm_id%type;',
'    l_sbfl_dgrm_id flow_subflows.sbfl_dgrm_id%type;',
'  begin',
'    select prcs.prcs_dgrm_id',
'         , sbfl.sbfl_dgrm_id',
'      into l_prcs_dgrm_id',
'         , l_sbfl_dgrm_id',
'      from flow_subflows sbfl',
'      join flow_processes prcs',
'        on prcs.prcs_id = sbfl.sbfl_prcs_id',
'     where prcs.prcs_id = p_process_id',
'       and sbfl.sbfl_id = p_subflow_id',
'    ;',
'    return ( l_prcs_dgrm_id != l_sbfl_dgrm_id);',
'  end;',
'',
'  -- Note: process_call_activity_endEvent is performed by flow_subprocesses.process_process_level_endEvent',
'',
'',
'  function get_call_definition',
'    ( pi_call_objt_id       in   flow_objects.objt_id%type',
'    ) return t_call_def',
'  is ',
'    l_call_def                  t_call_def;',
'  begin',
'    apex_debug.enter',
'    ( ''get_call_definition''',
'    , ''callActivity objt id'' , pi_call_objt_id',
'    );',
'',
'    select objt.objt_attributes."apex"."calledDiagram" as dgrm_name',
'         , objt.objt_attributes."apex"."calledDiagramVersion" as dgrm_version',
'         , cast( null as number ) as dgrm_id',
'         , objt.objt_attributes."apex"."calledDiagramVersionSelection" as dgrm_version_selection',
'      into l_call_def',
'      from flow_objects objt',
'     where objt.objt_id = pi_call_objt_id',
'    ;',
'',
'    return l_call_def;',
'',
'  end get_call_definition;',
'',
'  procedure process_callActivity',
'    ( p_process_id    in flow_processes.prcs_id%type',
'    , p_subflow_id    in flow_subflows.sbfl_id%type',
'    , p_sbfl_info     in flow_subflows%rowtype',
'    , p_step_info     in flow_types_pkg.flow_step_info',
'    )',
'  is',
'    l_call_definition           t_call_def;',
'    l_called_dgrm_id            flow_diagrams.dgrm_id%type;',
'    l_called_start_objt         flow_objects%rowtype;',
'    l_called_subflow_context    flow_types_pkg.t_subflow_context;',
'    l_calling_sbfl_scope        flow_subflows.sbfl_scope%type;',
'    l_prdg_id                   flow_instance_diagrams.prdg_id%type;',
'  begin',
'    apex_debug.enter ',
'    ( ''process_callActivity''',
'    , ''object'', p_step_info.target_objt_tag ',
'    );',
'',
'    -- get Call activity Attributes',
'    l_call_definition := get_call_definition ( pi_call_objt_id  => p_step_info.target_objt_id );',
'',
'    -- find called diagram and lock it in the flow_instance_diagrams',
'',
'    select child_prdg.prdg_dgrm_id',
'         , child_prdg.prdg_id',
'      into l_called_dgrm_id',
'         , l_prdg_id',
'      from flow_instance_diagrams child_prdg',
'      join flow_instance_diagrams parent_prdg',
'        on parent_prdg.prdg_id = child_prdg.prdg_prdg_id',
'     where child_prdg.prdg_prcs_id = p_process_id',
'       and child_prdg.prdg_calling_dgrm = p_sbfl_info.sbfl_dgrm_id',
'       and child_prdg.prdg_calling_objt = p_step_info.target_objt_ref',
'       and parent_prdg.prdg_diagram_level = p_sbfl_info.sbfl_diagram_level',
'       for update of child_prdg.prdg_diagram_level wait 2',
'    ;',
'',
'    -- find start object',
'',
'    l_called_start_objt    := flow_diagram.get_start_event ',
'                                    ( p_dgrm_id       => l_called_dgrm_id',
'                                    , p_process_id    => p_process_id',
'                                    );',
'',
'    -- create initial subflow in called activity (set new dgrm id, new scope)',
'',
'    l_called_subflow_context := flow_engine_util.subflow_start ',
'      ( p_process_id              => p_process_id',
'      , p_parent_subflow          => p_subflow_id',
'      , p_starting_object         => p_step_info.target_objt_ref -- parent callActivity activity',
'      , p_current_object          => l_called_start_objt.objt_bpmn_id -- callActivity Start event',
'      , p_route                   => ''call main''',
'      , p_last_completed          => p_sbfl_info.sbfl_current',
'      , p_status                  => flow_constants_pkg.gc_sbfl_status_running ',
'      , p_parent_sbfl_proc_level  => p_sbfl_info.sbfl_process_level',
'      , p_new_proc_level          => true',
'      , p_new_scope               => true',
'      , p_new_diagram             => true',
'      , p_dgrm_id                 => l_called_dgrm_id',
'      );',
'',
'      -- Always do all updates to parent data first before performing any next step in the children.',
'      -- Reason: A subflow could immediately disappear if we''re stepping through it completly.',
'      -- check for any errors on the step',
'',
'    if not flow_globals.get_step_error then ',
'      -- set boundaryEvent Timers on parent, if any',
'      flow_boundary_events.set_boundary_events ',
'      ( p_process_id => p_process_id',
'      , p_subflow_id => p_subflow_id',
'      , p_sbfl_info  => p_sbfl_info',
'      );  ',
'      if not flow_globals.get_step_error then ',
'        -- Check again, then Update parent subflow to ''in callActivity''',
'        update flow_subflows sbfl',
'        set   sbfl.sbfl_current         = p_step_info.target_objt_ref -- parent call Activity',
'            , sbfl.sbfl_last_completed  = p_sbfl_info.sbfl_last_completed',
'            , sbfl.sbfl_status          = flow_constants_pkg.gc_sbfl_status_in_callactivity',
'            , sbfl.sbfl_last_update     = systimestamp',
'            , sbfl.sbfl_last_update_by  = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                   , sys_context(''userenv'',''os_user'')',
'                                                   , sys_context(''userenv'',''session_user'')',
'                                                   )  ',
'        where sbfl.sbfl_id = p_subflow_id',
'          and sbfl.sbfl_prcs_id = p_process_id',
'        returning sbfl.sbfl_scope into l_calling_sbfl_scope',
'        ; ',
'',
'        -- update the instance_calls table with the new diagram_level',
'        update flow_instance_diagrams prdg',
'           set prdg.prdg_diagram_level = l_called_subflow_context.sbfl_id',
'         where prdg.prdg_id = l_prdg_id;',
'',
'',
'',
'',
'        -- map inVariables expressions for call (variables in called scope, expressions in calling scope)',
'        flow_expressions.process_expressions',
'        ( pi_objt_id => p_step_info.target_objt_id ',
'        , pi_set          => flow_constants_pkg.gc_expr_set_in_variables',
'        , pi_prcs_id      => p_process_id',
'        , pi_sbfl_id      => l_called_subflow_context.sbfl_id   --- should this be logged on calling or called subflows?  variables only in scope of called...',
'        , pi_var_scope    => l_called_subflow_context.scope',
'        , pi_expr_scope   => l_calling_sbfl_scope',
'        );',
'',
'        -- add diagram start to the instance log',
'        flow_logging.log_instance_event',
'        ( p_process_id    => p_process_id',
'        , p_objt_bpmn_id  => p_step_info.target_objt_ref',
'        , p_event         => flow_constants_pkg.gc_prcs_event_enter_call',
'        , p_comment       => ''Starting called diagram ''||l_call_definition.dgrm_name||',
'                             '' version ''||l_call_definition.dgrm_version||',
'                             '' in diagram level ''||l_called_subflow_context.sbfl_id',
'        );',
'',
'        if not flow_globals.get_step_error then ',
'          -- commit the transaction in the parent process level / diagram plsql_optimize_level',
'          commit;',
'',
'          apex_debug.info ( p_message => ''New Call Activity Parent Commited'');',
'',
'          -- reset step_had_error flag',
'          flow_globals.set_step_error ( p_has_error => false);',
'',
'          -- relock child subflow in new process level',
'          if flow_engine_util.lock_subflow',
'              ( p_subflow_id => l_called_subflow_context.sbfl_id',
'              )',
'          then',
'            -- run on-event expressions for child startEvent (inside called diagram scope)',
'            flow_expressions.process_expressions',
'            ( pi_objt_bpmn_id => l_called_start_objt.objt_bpmn_id ',
'            , pi_set          => flow_constants_pkg.gc_expr_set_on_event',
'            , pi_prcs_id      => p_process_id',
'            , pi_sbfl_id      => l_called_subflow_context.sbfl_id',
'            , pi_var_scope    => l_called_subflow_context.scope',
'            , pi_expr_scope   => l_called_subflow_context.scope',
'            );',
'            if not flow_globals.get_step_error then ',
'              -- check again for any errors from expressions before stepping forward in the called activity',
'              flow_engine.flow_complete_step   ',
'              ( p_process_id    => p_process_id',
'              , p_subflow_id    => l_called_subflow_context.sbfl_id',
'              , p_step_key      => l_called_subflow_context.step_key',
'              );',
'            end if;',
'          end if;',
'          -- reset step_had_error flag',
'          flow_globals.set_step_error ( p_has_error => false);',
'        end if;',
'      end if;',
'    end if;',
'  end process_callActivity; ',
'',
'end flow_call_activities;',
'/',
'',
'create or replace package body flow_logging as',
'/* ',
'-- Flows for APEX - flow_logging.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created 29-Jul-2021  Richard Allen (Flowquest) for  MT AG',
'-- Updated 10-Feb-2023  Richard Allen (Oracle)  ',
'--',
'*/',
'  g_logging_level           flow_configuration.cfig_value%type; ',
'  g_logging_hide_userid     flow_configuration.cfig_value%type;',
'',
'  procedure log_diagram_event',
'  ( p_dgrm_id           in flow_diagrams.dgrm_id%type',
'  , p_dgrm_name         in flow_diagrams.dgrm_name%type default null',
'  , p_dgrm_version      in flow_diagrams.dgrm_version%type default null',
'  , p_dgrm_status       in flow_diagrams.dgrm_status%type default null',
'  , p_dgrm_category     in flow_diagrams.dgrm_category%type default null',
'  , p_dgrm_content      in flow_diagrams.dgrm_content%type default null',
'  , p_comment           in flow_flow_event_log.lgfl_comment%type default null',
'  )',
'  is',
'    l_log_dgrm_content  boolean;',
'    l_diagram_location  flow_flow_event_log.lgfl_dgrm_archive_location%type;',
'    l_dgrm_name         flow_diagrams.dgrm_name%type;',
'    l_dgrm_version      flow_diagrams.dgrm_version%type;',
'    l_dgrm_status       flow_diagrams.dgrm_status%type;',
'    l_dgrm_category     flow_diagrams.dgrm_category%type;',
'  begin',
'    apex_debug.enter(''Log diagram event'');',
'    if g_logging_level in ( flow_constants_pkg.gc_config_logging_level_secure',
'                          , flow_constants_pkg.gc_config_logging_level_full',
'                          ) ',
'    then',
'  '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    if p_dgrm_content is not null and coalesce(p_dgrm_status, ''X'') != flow_constants_pkg.gc_dgrm_status_draft then',
'        l_log_dgrm_content := true;',
'        -- copy the new bpmn content to the bpmn archive (table or OCI object storage)',
'        l_diagram_location := flow_log_admin.archive_bpmn_diagram ( p_dgrm_id       => p_dgrm_id',
'                                                                  , p_dgrm_content  => p_dgrm_content',
'                                                                  );',
'      end if;',
'',
'      begin',
'        select ',
'            coalesce(p_dgrm_name, dgrm_name)',
'          , coalesce(p_dgrm_version, dgrm_version)',
'          , coalesce(p_dgrm_status, dgrm_status)',
'          , coalesce(p_dgrm_category, dgrm_category)',
'          into l_dgrm_name, l_dgrm_version, l_dgrm_status, l_dgrm_category',
'          from flow_diagrams',
'        where dgrm_id = p_dgrm_id;',
'      exception ',
'        when no_data_found then',
'          l_dgrm_name     := p_dgrm_name;',
'          l_dgrm_version  := p_dgrm_version;',
'          l_dgrm_status   := p_dgrm_status;',
'          l_dgrm_category := p_dgrm_category;',
'      end;',
'',
'      insert into flow_flow_event_log',
'      ( lgfl_dgrm_id',
'      , lgfl_dgrm_name',
'      , lgfl_dgrm_version',
'      , lgfl_dgrm_status',
'      , lgfl_dgrm_category',
'      , lgfl_dgrm_archive_location',
'      , lgfl_user',
'      , lgfl_comment',
'      , lgfl_timestamp',
'      )',
'      values',
'      ( p_dgrm_id',
'      , l_dgrm_name',
'      , l_dgrm_version',
'      , l_dgrm_status',
'      , l_dgrm_category',
'      , l_diagram_location',
'      , coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                  , sys_context(''userenv'',''os_user'')',
'                  , sys_context(''userenv'',''session_user'')',
'                  ) ',
'      , p_comment',
'      , systimestamp at time zone ''UTC''',
'      );',
'    end if;',
'  exception',
'    when others then',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''logging-diagram-event''',
'      );',
'      -- $F4AMESSAGE ''logging-diagram-event'' || ''Flows - Internal error while logging a Diagram Event''',
'      raise;',
'  end log_diagram_event;',
'',
'  procedure log_instance_event',
'  ( p_process_id        in flow_subflow_log.sflg_prcs_id%type',
'  , p_objt_bpmn_id      in flow_objects.objt_bpmn_id%type default null',
'  , p_event             in flow_instance_event_log.lgpr_prcs_event%type ',
'  , p_comment           in flow_instance_event_log.lgpr_comment%type default null',
'  , p_error_info        in flow_instance_event_log.lgpr_error_info%type default null',
'  )',
'  is ',
'  begin ',
'    if g_logging_level in ( flow_constants_pkg.gc_config_logging_level_standard ',
'                          , flow_constants_pkg.gc_config_logging_level_secure',
'                          , flow_constants_pkg.gc_config_logging_level_full',
'                          ) ',
'    then',
'      insert into flow_instance_event_log',
'      ( lgpr_prcs_id ',
'      , lgpr_objt_id',
'      , lgpr_dgrm_id ',
'      , lgpr_prcs_name ',
'      , lgpr_business_id',
'      , lgpr_prcs_event',
'      , lgpr_timestamp',
'      , lgpr_duration ',
'      , lgpr_user ',
'      , lgpr_comment',
'      , lgpr_error_info',
'      )',
'      select prcs.prcs_id',
'          , p_objt_bpmn_id',
'          , prcs.prcs_dgrm_id',
'          , prcs.prcs_name',
'          , flow_proc_vars_int.get_business_ref (p_process_id)  --- ',
'          , p_event',
'          , systimestamp ',
'          , case p_event',
'            when flow_constants_pkg.gc_prcs_event_completed then',
'              prcs.prcs_complete_ts - prcs.prcs_start_ts',
'            when flow_constants_pkg.gc_prcs_event_terminated then',
'              prcs.prcs_complete_ts - prcs.prcs_start_ts',
'            else',
'              null',
'            end',
'          , case g_logging_hide_userid ',
'            when ''true'' then ',
'              null',
'            else ',
'              coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                        , sys_context(''userenv'',''os_user'')',
'                        , sys_context(''userenv'',''session_user'')',
'                        )  ',
'            end ',
'          , p_comment',
'          , p_error_info',
'        from flow_processes prcs ',
'      where prcs.prcs_id = p_process_id',
'      ;',
'    end if;',
'  exception',
'    when others then',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''logging-instance-event''',
'      );',
'      -- $F4AMESSAGE ''logging-instance-event'' || ''Flows - Internal error while logging an Instance Event''',
'      raise;',
'  end log_instance_event;',
'',
'  procedure log_step_completion',
'  ( p_process_id        in flow_subflow_log.sflg_prcs_id%type',
'  , p_subflow_id        in flow_subflow_log.sflg_sbfl_id%type',
'  , p_completed_object  in flow_subflow_log.sflg_objt_id%type',
'  , p_iteration_status  in flow_types_pkg.t_iteration_status default null',
'  , p_notes             in flow_subflow_log.sflg_notes%type default null',
'  )',
'  is ',
'    l_notes    varchar2(20);',
'  begin',
'    if p_iteration_status.is_complete then ',
'      l_notes := ''COMPLETE''; ',
'    else ',
'      l_notes := null;',
'    end if;',
'    -- current instance status / progress logging',
'    insert into flow_subflow_log sflg',
'    ( sflg_prcs_id',
'    , sflg_objt_id',
'    , sflg_sbfl_id',
'    , sflg_step_key',
'    , sflg_last_updated',
'    , sflg_dgrm_id',
'    , sflg_diagram_level',
'    , sflg_notes',
'    , sflg_iter_id',
'    )',
'    select p_process_id',
'         , p_completed_object',
'         , p_subflow_id',
'         , sbfl.sbfl_step_key',
'         , sysdate',
'         , sbfl.sbfl_dgrm_id',
'         , sbfl.sbfl_diagram_level',
'         , p_notes',
'         , sbfl.sbfl_iter_id',
'      from flow_subflows sbfl',
'     where sbfl.sbfl_id = p_subflow_id',
'    ;',
'',
'    -- system event logging',
'    if g_logging_level in ( flow_constants_pkg.gc_config_logging_level_standard ',
'                          , flow_constants_pkg.gc_config_logging_level_secure',
'                          , flow_constants_pkg.gc_config_logging_level_full',
'                          ) ',
'    then',
'      insert into flow_step_event_log',
'      ( lgsf_prcs_id ',
'      , lgsf_objt_id ',
'      , lgsf_sbfl_id ',
'      , lgsf_step_key',
'      , lgsf_sbfl_process_level',
'      , lgsf_last_completed',
'      , lgsf_status_when_complete',
'      , lgsf_sbfl_dgrm_id',
'      , lgsf_was_current ',
'      , lgsf_started ',
'      , lgsf_completed',
'      , lgsf_reservation',
'      , lgsf_due_on',
'      , lgsf_priority',
'      , lgsf_user',
'      , lgsf_comment',
'      )',
'      select sbfl.sbfl_prcs_id',
'           , p_completed_object',
'           , sbfl.sbfl_id',
'           , sbfl.sbfl_step_key',
'           , sbfl.sbfl_process_level',
'           , sbfl.sbfl_last_completed',
'           , sbfl.sbfl_status',
'           , sbfl.sbfl_dgrm_id',
'           , sbfl.sbfl_became_current',
'           , sbfl.sbfl_work_started',
'           , systimestamp',
'           , sbfl.sbfl_reservation',
'           , sbfl.sbfl_due_on',
'           , sbfl.sbfl_priority',
'          , case g_logging_hide_userid ',
'            when ''true'' then ',
'              null',
'            else ',
'              coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                        , sys_context(''userenv'',''os_user'')',
'                        , sys_context(''userenv'',''session_user'')',
'                        )  ',
'            end ',
'           , p_notes        ',
'        from flow_subflows sbfl ',
'       where sbfl.sbfl_id = p_subflow_id',
'      ;',
'    end if;',
'  exception',
'    when others then',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''logging-step-event''',
'      );',
'      -- $F4AMESSAGE ''logging-step-event'' || ''Flows - Internal error while logging a Step Event''',
'      raise;',
'  end log_step_completion;',
'',
'  procedure log_variable_event -- logs process variable set events',
'  ( p_process_id        in flow_subflow_log.sflg_prcs_id%type',
'  , p_scope             in flow_process_variables.prov_scope%type',
'  , p_var_name          in flow_process_variables.prov_var_name%type',
'  , p_objt_bpmn_id      in flow_objects.objt_bpmn_id%type default null',
'  , p_subflow_id        in flow_subflow_log.sflg_sbfl_id%type default null',
'  , p_expr_set          in flow_object_expressions.expr_set%type default null',
'  , p_var_type          in flow_process_variables.prov_var_type%type',
'  , p_var_vc2           in flow_process_variables.prov_var_vc2%type default null',
'  , p_var_num           in flow_process_variables.prov_var_num%type default null',
'  , p_var_date          in flow_process_variables.prov_var_date%type default null',
'  , p_var_clob          in flow_process_variables.prov_var_clob%type default null',
'  , p_var_tstz          in flow_process_variables.prov_var_tstz%type default null',
'  , p_var_json          in flow_process_variables.prov_var_json%type default null',
'  )',
'  as ',
'  begin ',
'    if g_logging_level in (  flow_constants_pkg.gc_config_logging_level_full ) then',
'      insert into flow_variable_event_log',
'      ( lgvr_prcs_id  ',
'      , lgvr_scope',
'      , lgvr_var_name	  ',
'      , lgvr_objt_id	  ',
'      , lgvr_sbfl_id	  ',
'      , lgvr_expr_set	  ',
'      , lgvr_timestamp  ',
'      , lgvr_var_type	  ',
'      , lgvr_var_vc2 	  ',
'      , lgvr_var_num  ',
'      , lgvr_var_date   ',
'      , lgvr_var_clob   ',
'      , lgvr_var_tstz  ',
'      , lgvr_var_json',
'      )',
'      values',
'      ( p_process_id',
'      , p_scope',
'      , p_var_name          ',
'      , p_objt_bpmn_id    ',
'      , p_subflow_id ',
'      , p_expr_set ',
'      , systimestamp',
'      , p_var_type ',
'      , p_var_vc2 ',
'      , p_var_num  ',
'      , p_var_date ',
'      , p_var_clob  ',
'      , p_var_tstz ',
'      , p_var_json',
'      );',
'    end if;',
'  exception',
'    when others then',
'      flow_errors.handle_general_error',
'      ( pi_message_key => ''logging-variable-event''',
'      );',
'      -- $F4AMESSAGE ''logging-variable-event'' || ''Flows - Internal error while logging a Variable Event''',
'      raise;',
'  end log_variable_event;',
'',
'  -- initialize logging parameters',
'',
'  begin ',
'    g_logging_level := flow_engine_util.get_config_value',
'                       ( p_config_key => flow_constants_pkg.gc_config_logging_level',
'                       , p_default_value => flow_constants_pkg.gc_config_default_logging_level',
'                       );',
'    g_logging_hide_userid := lower (flow_engine_util.get_config_value',
'                                      ( p_config_key => flow_constants_pkg.gc_config_logging_hide_userid ',
'                                      , p_default_value => flow_constants_pkg.gc_config_default_logging_hide_userid ',
'                                      )',
'                                   );',
'  ',
'    apex_debug.message ( p_message  => ''Logging level: %0''',
'                       , p0         => g_logging_level',
'                       , p_level    => 4 ',
'                       );',
'end flow_logging;',
'/',
'',
'/* ',
'-- Flows for APEX - flow_globals.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created    25-Aug-2021  Richard Allen (Flowquest, for MT AG)',
'-- Modified   12-Apr-2022  Richard Allen (Oracle)',
'--',
'*/',
'',
'create or replace package body flow_globals',
'as',
'',
'',
'  g_error_on_step  boolean := false;  ',
'  -- g_error_on_step starts false when every step is processed but is set true if an error',
'  -- occurs in the engine during processing.  It is then used to determine whether to ',
'  -- commit or rollback the engine transaction at the end of step processing',
'  g_is_recursive_step boolean := false;',
'  -- g_recursive_step is set to false for steps that are being performed by the user, and true',
'  -- for subsequent recursive steps that are performed by the engine (such as gateway steps, scriptTasks, etc.)',
'',
'',
'  procedure set_context',
'  ( pi_prcs_id      in flow_processes.prcs_id%type',
'  , pi_sbfl_id      in flow_subflows.sbfl_id%type default null',
'  , pi_step_key     in flow_subflows.sbfl_step_key%type default null',
'  , pi_scope        in flow_subflows.sbfl_scope%type default null',
'  , pi_loop_counter in flow_subflows.sbfl_loop_counter%type default null',
'  )',
'  is',
'  begin ',
'    process_id    := pi_prcs_id;',
'    subflow_id    := pi_sbfl_id;',
'    step_key      := pi_step_key;',
'    scope         := pi_scope;',
'    loop_counter  := pi_loop_counter;',
'  end set_context;',
'',
'  procedure set_step_error',
'  ( p_has_error  in boolean default false)',
'  is',
'  begin',
'    /*apex_debug.enter',
'    ( ''set_step_error''',
'    , ''p_has_error'', case when p_has_error then ''true'' else ''false'' end',
'    );*/',
'    g_error_on_step := p_has_error;',
'  end set_step_error;',
'',
'  function get_step_error return boolean',
'  is',
'  begin',
'    /*apex_debug.enter',
'    ( ''get_step_error''',
'    , ''g_error_on_step'', case when g_error_on_step then ''true'' else ''false'' end',
'    );*/',
'    return g_error_on_step;',
'  end get_step_error; ',
'',
'  procedure set_is_recursive_step',
'  ( p_is_recursive_step  in boolean default false)',
'  is',
'  begin',
'    g_is_recursive_step := p_is_recursive_step;',
'  end set_is_recursive_step;',
'',
'  function get_is_recursive_step return boolean',
'  is',
'  begin',
'    return g_is_recursive_step;',
'  end get_is_recursive_step; ',
'',
'  function business_ref',
'  (pi_scope       flow_subflows.sbfl_scope%type default 0)',
'  return flow_process_variables.prov_var_vc2%type',
'  is',
'  begin',
'    return flow_proc_vars_int.get_business_ref ',
'                              ( pi_prcs_id => process_id',
'                              , pi_scope   => pi_scope',
'                              );',
'  end business_ref;',
'',
'  function business_ref',
'  (pi_sbfl_id     flow_subflows.sbfl_id%type)',
'  return flow_process_variables.prov_var_vc2%type',
'  is',
'    l_scope     flow_subflows.sbfl_scope%type;',
'  begin',
'    l_scope := flow_engine_util.get_scope ( p_process_id => process_id',
'                                          , p_subflow_id => pi_sbfl_id);             ',
'    return business_ref ( pi_scope   => l_scope );',
'  end business_ref;',
'',
'  procedure set_call_origin',
'  (',
'    p_origin in varchar2',
'  )',
'  as',
'  begin',
'    case p_origin',
'      when ''REST'' then',
'        rest_call := true;',
'      else',
'        null;',
'    end case;',
'  end set_call_origin;',
'',
'  procedure unset_call_origin',
'  as',
'  begin',
'    rest_call := false;',
'  end unset_call_origin;',
'',
'end flow_globals;',
'/',
'',
'create or replace package body flow_errors',
'as ',
'',
'  g_logging_language        flow_configuration.cfig_value%type;',
'',
'  procedure autonomous_write_to_instance_log',
'  ( pi_prcs_id        in flow_processes.prcs_id%type',
'  , pi_objt_bpmn_id   in flow_subflows.sbfl_current%type default null',
'  , pi_message        in flow_instance_event_log.lgpr_comment%type',
'  , pi_error_info     in flow_instance_event_log.lgpr_error_info%type',
'  )',
'  is',
'    pragma autonomous_transaction;',
'  begin',
'    -- add to instance_event_log',
'    flow_logging.log_instance_event',
'    ( p_process_id        => pi_prcs_id',
'    , p_objt_bpmn_id      => pi_objt_bpmn_id',
'    , p_event             => flow_constants_pkg.gc_prcs_event_error',
'    , p_comment           => pi_message',
'    , p_error_info        => pi_error_info',
'    );',
'    --  commit the autonomous transaction',
'    commit;',
'  end autonomous_write_to_instance_log;',
'',
'  procedure set_error_status',
'  ( pi_prcs_id        in flow_processes.prcs_id%type',
'  , pi_sbfl_id        in flow_subflows.sbfl_id%type',
'  )',
'  is ',
'  begin  ',
'      apex_debug.enter',
'      ( ''set_error_status''',
'      , ''pi_prcs_id'', pi_prcs_id',
'      , ''pi_sbfl_id'', pi_sbfl_id',
'      );',
'      -- set sbfl & prcs error status',
'      update flow_subflows sbfl',
'        set sbfl_status              = flow_constants_pkg.gc_sbfl_status_error',
'          , sbfl.sbfl_last_update    = systimestamp',
'          , sbfl.sbfl_last_update_by = coalesce ( sys_context(''apex$session'',''app_user'') ',
'                                                , sys_context(''userenv'',''os_user'')',
'                                                , sys_context(''userenv'',''session_user'')',
'                                                )  ',
'      where sbfl.sbfl_id = pi_sbfl_id',
'      ;',
'      update flow_processes prcs',
'        set prcs.prcs_status         = flow_constants_pkg.gc_prcs_status_error',
'          , prcs.prcs_last_update    = systimestamp',
'          , prcs.prcs_last_update_by = coalesce  ( sys_context(''apex$session'',''app_user'') ',
'                                                 , sys_context(''userenv'',''os_user'')',
'                                                 , sys_context(''userenv'',''session_user'')',
'                                                 )  ',
'      where prcs.prcs_id = pi_prcs_id',
'      ;   ',
'  end set_error_status;',
'',
'  function make_error_message',
'  ( pi_message_key    in flow_messages.fmsg_message_key%type ',
'  , pi_lang           in flow_messages.fmsg_lang%type',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  ) return flow_messages.fmsg_message_content%type',
'  is',
'    l_message_content  flow_messages.fmsg_message_content%type;',
'    l_message          flow_instance_event_log.lgpr_comment%type;',
'  begin ',
'    -- get the message template in the correct language, or fall through to default language',
'    begin',
'      select fmsg.fmsg_message_content',
'        into l_message_content',
'        from flow_messages fmsg',
'       where fmsg.fmsg_message_key = pi_message_key',
'         and fmsg.fmsg_lang = pi_lang',
'      ;',
'    exception',
'      when no_data_found then',
'        begin',
'          select fmsg.fmsg_message_content',
'            into l_message_content',
'            from flow_messages fmsg',
'           where fmsg.fmsg_message_key = pi_message_key',
'             and fmsg.fmsg_lang = flow_constants_pkg.gc_config_default_logging_language',
'          ;',
'        exception',
'          when no_data_found then',
'            l_message_content := ''Missing Message Key ''||pi_message_key||'' language ''',
'                                 ||flow_constants_pkg.gc_config_default_logging_language;',
'          when others then',
'            l_message_content := ''Problem getting error message - check flow_messages loaded'';',
'        end;',
'      when others then',
'        l_message_content := ''Problem getting error message - check flow_messages loaded'';',
'    end;',
'    -- now make the error message in local language for log & apex_error',
'    l_message :=  apex_string.format',
'                  ( p_message => l_message_content',
'                  , p0 => p0',
'                  , p1 => p1',
'                  , p2 => p2',
'                  , p3 => p3',
'                  , p4 => p4',
'                  , p5 => p5',
'                  , p6 => p6',
'                  , p7 => p7',
'                  , p8 => p8',
'                  , p9 => p9',
'                  );',
'    return l_message;',
'  end make_error_message;',
'',
'  procedure handle_instance_error',
'  ( pi_prcs_id        in flow_processes.prcs_id%type',
'  , pi_sbfl_id        in flow_subflows.sbfl_id%type default null',
'  , pi_message_key    in varchar2',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  )',
'  is',
'    l_message_content  flow_messages.fmsg_message_content%type;',
'    l_message          flow_instance_event_log.lgpr_comment%type;',
'    l_error_info       flow_instance_event_log.lgpr_error_info%type;',
'    l_current          flow_subflows.sbfl_current%type;',
'  begin ',
'    apex_debug.enter',
'    ( ''handle_instance_error''',
'    , ''pi_sbfl_id'', pi_sbfl_id',
'    , ''pi_message_key'', pi_message_key',
'    , ''p0'', p0',
'    , ''p1'', p1',
'    , ''p2'', p2',
'    , ''p3'', p3',
'    , ''p4'', p4',
'    , ''is_recursive'' , case when flow_globals.get_is_recursive_step then ''true'' else ''false'' end',
'    );',
'    -- get the message template in the correct language, or fall through to default language',
'    -- for log & apex_error',
'    l_message :=  make_error_message',
'                  ( pi_message_key   => pi_message_key',
'                  , pi_lang          => g_logging_language',
'                  , p0               => p0',
'                  , p1               => p1',
'                  , p2               => p2',
'                  , p3               => p3',
'                  , p4               => p4',
'                  , p5               => p5',
'                  , p6               => p6',
'                  , p7               => p7',
'                  , p8               => p8',
'                  , p9               => p9',
'                  );',
'    -- get the error stack and step type',
'    l_error_info   := dbms_utility.format_error_stack;',
'    -- get the current step, if known & available',
'    begin',
'      if pi_sbfl_id is not null then',
'        select sbfl.sbfl_current',
'          into l_current',
'          from flow_subflows sbfl',
'        where sbfl.sbfl_id = pi_sbfl_id',
'        ;',
'      else',
'        l_current := null;',
'      end if;',
'    exception',
'      when others then',
'        l_current := null;',
'    end; ',
'    -- add to instance_event_log',
'    autonomous_write_to_instance_log',
'    ( pi_prcs_id        => pi_prcs_id',
'    , pi_objt_bpmn_id   => l_current',
'    , pi_message        => l_message',
'    , pi_error_info     => l_error_info',
'    );',
'    -- decide where to put error message',
'    if flow_globals.get_is_recursive_step then',
'      -- errors written to log, status already set to error in autonomous session',
'      flow_globals.set_step_error (p_has_error => true);',
'    elsif flow_globals.rest_call then',
'      raise_application_error(-20001, l_message);',
'    else',
'      -- step belongs to current user''s current session - use apex_error',
'      apex_error.add_error',
'      ( p_message => l_message',
'      , p_display_location => apex_error.c_on_error_page',
'      );',
'    end if;',
'  end handle_instance_error;',
'',
'  procedure handle_general_error',
'  ( pi_message_key    in varchar2',
'  , p0                in varchar2 default null',
'  , p1                in varchar2 default null',
'  , p2                in varchar2 default null',
'  , p3                in varchar2 default null',
'  , p4                in varchar2 default null',
'  , p5                in varchar2 default null',
'  , p6                in varchar2 default null',
'  , p7                in varchar2 default null',
'  , p8                in varchar2 default null',
'  , p9                in varchar2 default null',
'  )',
'  is',
'    l_message_content  flow_messages.fmsg_message_content%type;',
'    l_message          flow_instance_event_log.lgpr_comment%type;',
'  begin ',
'    apex_debug.enter',
'    ( ''handle_instance_error''',
'    , ''pi_message_key'', pi_message_key',
'    );',
'    -- get the message template in the correct language, or fall through to default language',
'    -- for log & apex_error',
'    l_message :=  make_error_message',
'                  ( pi_message_key   => pi_message_key',
'                  , pi_lang          => g_logging_language',
'                  , p0               => p0',
'                  , p1               => p1',
'                  , p2               => p2',
'                  , p3               => p3',
'                  , p4               => p4',
'                  , p5               => p5',
'                  , p6               => p6',
'                  , p7               => p7',
'                  , p8               => p8',
'                  , p9               => p9',
'                  );',
'',
'    if flow_globals.rest_call then',
'      raise_application_error(-20001, l_message);',
'    else',
'      apex_error.add_error',
'        ( p_message => l_message',
'        , p_display_location => apex_error.c_on_error_page',
'        );',
'    end if;',
'  end handle_general_error;',
'',
'  -- initialize logging parameters',
'',
'  begin ',
'    g_logging_language := flow_engine_util.get_config_value',
'                       ( p_config_key => flow_constants_pkg.gc_config_logging_language',
'                       , p_default_value => flow_constants_pkg.gc_config_default_logging_language',
'                       );',
'',
'end flow_errors;',
'/',
'',
'create or replace package body flow_diagram',
'as',
'/* ',
'-- Flows for APEX - flow_diagram.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2022-2023.',
'-- (c) Copyright MT AG, 2021-2022.',
'--',
'-- Created  10-Dec-2021 Dennis Amthor - MT AG  ',
'-- Modified 22-May-2022 Moritz Klein - MT AG',
'-- Modified 16-Mar-2023 Richard Allen - Oracle',
'--',
'*/',
'  ',
'  function upload_diagram',
'  (',
'    pi_dgrm_name       in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version    in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category   in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content    in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status     in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_log_comment     in flow_flow_event_log.lgfl_comment%type default null',
'  , pi_force_overwrite in boolean default false',
'  ) return flow_diagrams.dgrm_id%type',
'  as',
'    l_cnt     number;',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'  begin',
'',
'    begin',
'      select dgrm_id',
'        into l_dgrm_id',
'        from flow_diagrams',
'       where dgrm_name = pi_dgrm_name',
'         and dgrm_version = pi_dgrm_version',
'      ;',
'    exception',
'      when no_data_found then',
'        l_dgrm_id := null;',
'    end;',
'',
'    if l_dgrm_id is null then',
'      insert',
'        into flow_diagrams ( dgrm_name, dgrm_version, dgrm_category, dgrm_status, dgrm_last_update, dgrm_content )',
'        values ( pi_dgrm_name, pi_dgrm_version, pi_dgrm_category, ',
'                 pi_dgrm_status,  systimestamp, pi_dgrm_content )',
'      returning dgrm_id into l_dgrm_id',
'      ;',
'    else',
'      if (pi_force_overwrite) then',
'        update flow_diagrams',
'          set dgrm_content = pi_dgrm_content',
'            , dgrm_last_update = systimestamp',
'            , dgrm_status  = pi_dgrm_status',
'        where dgrm_id = l_dgrm_id',
'        ;',
'      end if;',
'    end if;',
'',
'    flow_logging.log_diagram_event ',
'    ( p_dgrm_id         => l_dgrm_id',
'    , p_dgrm_name       => pi_dgrm_name',
'    , p_dgrm_version    => pi_dgrm_version',
'    , p_dgrm_status     => pi_dgrm_status',
'    , p_dgrm_category   => pi_dgrm_category',
'    , p_dgrm_content    => pi_dgrm_content',
'    , p_comment         => pi_log_comment',
'    );',
'',
'    return l_dgrm_id;',
'',
'  end upload_diagram;',
'',
'  procedure upload_diagram',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_log_comment   in flow_flow_event_log.lgfl_comment%type default null',
'  , pi_force_overwrite in boolean default false',
'  )',
'  as',
'    l_dgrm_id       flow_diagrams.dgrm_id%type;',
'  begin',
'    l_dgrm_id := upload_diagram ( pi_dgrm_name => pi_dgrm_name, pi_dgrm_version => pi_dgrm_version,',
'                                  pi_dgrm_category => pi_dgrm_category, pi_dgrm_content => pi_dgrm_content,',
'                                  pi_dgrm_status => pi_dgrm_status, pi_force_overwrite => pi_force_overwrite,',
'                                  pi_log_comment => pi_log_comment',
'                                );',
'  end upload_diagram;',
'',
'  procedure upload_and_parse',
'  (',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version  in flow_diagrams.dgrm_version%type',
'  , pi_dgrm_category in flow_diagrams.dgrm_category%type',
'  , pi_dgrm_content  in flow_diagrams.dgrm_content%type',
'  , pi_dgrm_status   in flow_diagrams.dgrm_status%type default flow_constants_pkg.gc_dgrm_status_draft',
'  , pi_log_comment   in flow_flow_event_log.lgfl_comment%type default null ',
'  , pi_force_overwrite in boolean default false',
'  )',
'  as',
'    l_dgrm_id  flow_diagrams.dgrm_id%type;',
'  begin',
'',
'    l_dgrm_id := upload_diagram ( pi_dgrm_name => pi_dgrm_name, pi_dgrm_version => pi_dgrm_version,',
'                                  pi_dgrm_category => pi_dgrm_category, pi_dgrm_content => pi_dgrm_content,',
'                                  pi_dgrm_status => pi_dgrm_status, pi_force_overwrite => pi_force_overwrite,',
'                                  pi_log_comment => pi_log_comment',
'                                );',
'    flow_bpmn_parser_pkg.parse ( pi_dgrm_id => l_dgrm_id);',
'  end upload_and_parse;',
'',
'  procedure update_diagram',
'  (',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_dgrm_content in flow_diagrams.dgrm_content%type',
'  )',
'  as',
'  begin',
'',
'    update flow_diagrams',
'       set dgrm_content     = pi_dgrm_content',
'         , dgrm_last_update = systimestamp',
'     where dgrm_id = pi_dgrm_id',
'    ;',
'',
'    flow_logging.log_diagram_event ',
'    ( p_dgrm_id         => pi_dgrm_id',
'    , p_dgrm_content    => pi_dgrm_content',
'    , p_comment         => ''Diagram updated''',
'    ); ',
'',
'    flow_bpmn_parser_pkg.parse ( pi_dgrm_id => pi_dgrm_id);',
'  end update_diagram;',
'',
'  function create_diagram(',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type)',
'  return flow_diagrams.dgrm_id%type',
'  as',
'    l_diagram_exists binary_integer;',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'  begin',
'    select count(*)',
'      into l_diagram_exists',
'      from dual',
'     where exists(',
'           select null',
'             from flow_diagrams',
'            where dgrm_name = pi_dgrm_name',
'              and dgrm_version = pi_dgrm_version);',
'',
'    if l_'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'diagram_exists = 0 then',
'      l_dgrm_id := upload_diagram',
'            ( pi_dgrm_name     => pi_dgrm_name',
'            , pi_dgrm_version  => pi_dgrm_version',
'            , pi_dgrm_category => pi_dgrm_category',
'            , pi_dgrm_content  => replace ( flow_constants_pkg.gc_default_xml, ''#RANDOM_PRCS_ID#'',',
'                                            lower(sys.dbms_random.string(''X'',8))',
'                                          )',
'            , pi_dgrm_status   => flow_constants_pkg.gc_dgrm_status_draft',
'            );',
'',
'            flow_logging.log_diagram_event ',
'            ( p_dgrm_id         => l_dgrm_id',
'            , p_dgrm_name       => pi_dgrm_name',
'            , p_dgrm_version    => pi_dgrm_version',
'            , p_dgrm_status     => flow_constants_pkg.gc_dgrm_status_draft',
'            , p_dgrm_category   => pi_dgrm_category',
'            , p_comment         => ''Diagram Created as template''',
'            );',
'',
'      flow_bpmn_parser_pkg.parse(',
'        pi_dgrm_id => l_dgrm_id);',
'    else',
'      raise diagram_exists;',
'    end if;',
'    return l_dgrm_id;',
'  end create_diagram;',
'  ',
'  function add_diagram_version(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type)',
'  return flow_diagrams.dgrm_id%type',
'  as',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'    r_diagrams flow_diagrams%rowtype;',
'  begin',
'    select * ',
'      into r_diagrams',
'      from flow_diagrams',
'     where dgrm_id = pi_dgrm_id;',
'',
'    l_dgrm_id := upload_diagram ',
'                 ( pi_dgrm_name     => r_diagrams.dgrm_name',
'                 , pi_dgrm_version  => pi_dgrm_version',
'                 , pi_dgrm_category => r_diagrams.dgrm_category',
'                 , pi_dgrm_content  => r_diagrams.dgrm_content',
'                 , pi_dgrm_status   => flow_constants_pkg.gc_dgrm_status_draft',
'                 , pi_log_comment   => ''Add new version''',
'                 );',
'',
'    --no need to log here - upload_diagram will log',
'',
'    flow_bpmn_parser_pkg.parse ( pi_dgrm_id => l_dgrm_id);',
'    return l_dgrm_id;',
'  end add_diagram_version;',
'',
'',
'  function import_diagram(',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type,',
'    pi_dgrm_content in flow_diagrams.dgrm_content%type,',
'    pi_force_overwrite in varchar2 default flow_constants_pkg.gc_false) ',
'  return flow_diagrams.dgrm_id%type',
'  as',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'    l_dgrm_exists binary_integer;',
'    l_dgrm_status flow_diagrams.dgrm_status%type;',
'    l_diagram_unknown boolean;',
'    l_diagram_is_draft boolean;',
'  begin',
'    select count(*)',
'      into l_dgrm_exists',
'      from flow_diagrams',
'     where dgrm_name = pi_dgrm_name',
'       and dgrm_version = pi_dgrm_version;',
'',
'    if (l_dgrm_exists > 0) then',
'        select dgrm_status',
'        into l_dgrm_status',
'        from flow_diagrams',
'        where dgrm_name = pi_dgrm_name',
'        and dgrm_version = pi_dgrm_version;',
'    end if;',
'',
'    l_diagram_unknown  := l_dgrm_exists = 0;',
'    l_diagram_is_draft := l_dgrm_exists > 0 ',
'                      and pi_force_overwrite = flow_constants_pkg.gc_true',
'                      and l_dgrm_status = flow_constants_pkg.gc_dgrm_status_draft;',
'',
'    if l_diagram_unknown or l_diagram_is_draft then',
'      l_dgrm_id := upload_diagram',
'                   ( pi_dgrm_name       => pi_dgrm_name',
'                   , pi_dgrm_version    => pi_dgrm_version',
'                   , pi_dgrm_category   => pi_dgrm_category',
'                   , pi_dgrm_content    => pi_dgrm_content',
'                   , pi_force_overwrite => pi_force_overwrite = flow_constants_pkg.gc_true',
'                   , pi_log_comment     => ''import diagram''',
'                   );',
'      flow_bpmn_parser_pkg.parse ( pi_dgrm_id => l_dgrm_id );',
'    else',
'      if (l_dgrm_status = flow_constants_pkg.gc_dgrm_status_draft) then',
'        raise diagram_exists;',
'      else',
'        raise diagram_not_draft;',
'      end if;',
'    end if;',
'    return l_dgrm_id;',
'  end import_diagram;',
'  ',
'  ',
'  function diagram_is_modifiable(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type)',
'  return boolean',
'  as',
'    l_dgrm_status flow_diagrams.dgrm_status%type;',
'    l_is_draft boolean;',
'    l_is_released boolean;',
'    l_is_development boolean;',
'  begin',
'    if pi_dgrm_id is not null then',
'      select dgrm_status',
'        into l_dgrm_status',
'        from flow_diagrams',
'       where dgrm_id = pi_dgrm_id;',
'      ',
'      l_is_draft       := l_dgrm_status = flow_constants_pkg.gc_dgrm_status_draft;',
'      l_is_released    := l_dgrm_status = flow_constants_pkg.gc_dgrm_status_released;',
'      l_is_development := flow_engine_util.get_config_value(',
'                            p_config_key => ''engine_app_mode'',',
'                            p_default_value => flow_constants_pkg.gc_config_default_engine_app_mode)',
'                        = ''development'';',
'      return l_is_draft or (l_is_released and l_is_development);',
'    else',
'      return false;',
'    end if;',
'  end diagram_is_modifiable;',
'',
'  function get_start_event',
'  ( p_dgrm_id                 in flow_diagrams.dgrm_id%type',
'  , p_process_id              in flow_processes.prcs_id%type',
'  , p_event_starting_object   in flow_objects.objt_bpmn_id%type default null',
'  ) return flow_objects%rowtype',
'  is ',
'    l_starting_object     flow_objects%rowtype;',
'  begin',
'    begin',
'      if p_event_starting_object is null then ',
'        -- get the starting object ',
'        select objt.*',
'          into l_starting_object',
'          from flow_objects objt',
'          join flow_objects parent',
'            on parent.objt_id       = objt.objt_objt_id',
'           and parent.objt_dgrm_id  = objt.objt_dgrm_id',
'           and parent.objt_tag_name = flow_constants_pkg.gc_bpmn_process',
'         where objt.objt_dgrm_id    = p_dgrm_id',
'           and objt.objt_tag_name   = flow_constants_pkg.gc_bpmn_start_event  ',
'           and (    objt.objt_sub_tag_name is null ',
'               or   objt.objt_sub_tag_name = flow_constants_pkg.gc_bpmn_timer_event_definition )',
'        ;',
'      else ',
'        -- get the specified starting object',
'        select objt.*',
'          into l_starting_object',
'          from flow_objects objt',
'         where objt.objt_dgrm_id = p_dgrm_id',
'           and objt.objt_bpmn_id = p_event_starting_object',
'           and objt.objt_tag_name   = flow_constants_pkg.gc_bpmn_start_event ',
'        ;',
'      end if;',
'',
'      apex_debug.info',
'      ( p_message => ''Found starting object %0''',
'      , p0 =>l_starting_object.objt_bpmn_id',
'      );',
'    exception',
'      when too_many_rows then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => p_process_id',
'        , pi_message_key    => ''start-multiple-start-events''',
'        );',
'        -- $F4AMESSAGE ''start-multiple-start-events'' || ''You have multiple starting events defined. Make sure your diagram has only one start event.''',
'      when no_data_found then',
'        flow_errors.handle_instance_error',
'        ( pi_prcs_id        => p_process_id',
'        , pi_message_key    => ''start-no-start-event''',
'        );',
'        -- $F4AMESSAGE ''start-no-start-event'' || ''No starting event is defined in the Flow diagram.''',
'    end;',
'    return l_starting_object;',
'  end get_start_event;',
'',
'  function get_current_diagram',
'    ( pi_dgrm_name              in flow_diagrams.dgrm_name%type',
'    , pi_dgrm_calling_method    in flow_types_pkg.t_bpmn_attribute_vc2',
'    , pi_dgrm_version           in flow_diagrams.dgrm_version%type',
'    , pi_prcs_id                in flow_processes.prcs_id%type default null',
'    )',
'  return flow_diagrams.dgrm_id%type',
'    -- gets the current dgrm_id to be used for a diagram name.',
'    -- returns the current ''released'' diagram or a ''draft'' of version ''0'' ',
'  is',
'    l_dgrm_id     flow_diagrams.dgrm_id%type;',
'  begin',
'    case pi_dgrm_calling_method ',
'    when flow_constants_pkg.gc_dgrm_version_latest_version then',
'      begin ',
'        -- look for the ''released'' version of the diagram',
'        select dgrm_id ',
'          into l_dgrm_id',
'          from flow_diagrams',
'         where dgrm_name = pi_dgrm_name',
'           and dgrm_status = flow_constants_pkg.gc_dgrm_status_released',
'        ;',
'        return l_dgrm_id;',
'      exception',
'        when no_data_found then',
'          -- look for the version 0 (default) of ''draft'' of the diagram',
'          begin',
'            select dgrm_id',
'              into l_dgrm_id',
'              from flow_diagrams',
'             where dgrm_name = pi_dgrm_name',
'               and dgrm_status = flow_constants_pkg.gc_dgrm_status_draft',
'               and dgrm_version = ''0''',
'            ;',
'            return l_dgrm_id;',
'          exception',
'            when no_data_found then',
'              if pi_prcs_id is null then ',
'                -- initial process start so call general error (instance not yet running)',
'                flow_errors.handle_general_error',
'                ( pi_message_key => ''version-no-rel-or-draft-v0''',
'                );',
'                -- $F4AMESSAGE ''version-no-rel-or-draft-v0'' || ''Cannot find released diagram or draft version 0 of diagram - please specify a version or diagram_id''',
'              else ',
'                -- callActivity so log an instance error',
'                flow_errors.handle_instance_error',
'                ( pi_prcs_id     => pi_prcs_id',
'                , pi_message_key => ''version-no-rel-or-draft-v0''',
'                );',
'                -- $F4AMESSAGE ''version-no-rel-or-draft-v0'' || ''Cannot find released diagram or draft version 0 of diagram - please specify a version or diagram_id''',
'              end if; ',
'          end;  ',
'      end;',
'',
'    when flow_constants_pkg.gc_dgrm_version_named_version then',
'      -- dgrm_version was specified',
'      begin',
'        select dgrm_id',
'          into l_dgrm_id',
'          from flow_diagrams',
'         where dgrm_name = pi_dgrm_name',
'           and dgrm_version = pi_dgrm_version',
'        ;',
'      exception',
'        when no_data_found then',
'          -- initial process start so call general error (instance not yet running)',
'          flow_errors.handle_general_error ( pi_message_key => ''version-not-found'');',
'          -- $F4AMESSAGE ''version-not-found'' || ''Cannot find specified diagram version.  Please check version specification.''',
'      end;',
'    end case;',
'    return l_dgrm_id;',
'  end get_current_diagram;',
'',
'',
'  procedure delete_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type,',
'    pi_cascade in varchar2)',
'  as',
'    type t_prcs_id  is table of flow_processes.prcs_id%type',
'         index by binary_integer;',
'    l_running_instances   t_prcs_id;',
'  begin',
'    if pi_cascade = flow_constants_pkg.gc_true then',
'      select prcs_id',
'        bulk collect into l_running_instances',
'        from flow_processes',
'       where prcs_dgrm_id = pi_dgrm_id;',
'                               ',
'      for i in 1..l_running_instances.count',
'      loop',
'        flow_instances.delete_process',
'        ( p_process_id  => l_running_instances(i)',
'        , p_comment     => ''Instance deleted on Diagram Deletion.''',
'        );',
'      end loop;',
'    end if;',
'    delete from flow_diagrams ',
'     where dgrm_id = pi_dgrm_id;',
'',
'    flow_logging.log_diagram_event ',
'    ( p_dgrm_id         => pi_dgrm_id',
'    , p_comment         => ''Diagram deleted.''',
'    );',
'',
'  end delete_diagram;',
'',
'',
'  procedure edit_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type,',
'    pi_dgrm_name in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type)',
'  as',
'    l_dgrm_category flow_diagrams.dgrm_category%type;',
'  begin',
'    -- get existing category',
'    select dgrm_category',
'      into l_dgrm_category',
'      from flow_diagrams',
'     where dgrm_id = pi_dgrm_id;',
'',
'    if coalesce(l_dgrm_category, chr(10)) != coalesce(pi_dgrm_category, chr(10) ) then',
'      -- category has changed',
'      update flow_diagrams',
'         set dgrm_category = pi_dgrm_category',
'       where dgrm_name = (',
'             select dgrm_name ',
'               from flow_diagrams',
'              where dgrm_id = pi_dgrm_id);',
'',
'    end if;',
'',
'    update flow_diagrams',
'       set dgrm_name = pi_dgrm_name,',
'           dgrm_version = pi_dgrm_version,',
'           dgrm_category = pi_dgrm_category',
'     where dgrm_id = pi_dgrm_id;',
'',
'',
'    flow_logging.log_diagram_event ',
'    ( p_dgrm_id         => pi_dgrm_id',
'    , p_dgrm_name       => pi_dgrm_name',
'    , p_dgrm_version    => pi_dgrm_version',
'    , p_dgrm_category   => pi_dgrm_category',
'    , p_comment         => ''Diagram meta-data edited''',
'    );',
'',
'  end edit_diagram;',
'',
'  procedure subscribe_diagram_message_starts',
'  ( pi_dgrm_id        in flow_diagrams.dgrm_id%type',
'  , pi_draft_suffix   in varchar2 default null',
'  )',
'  is',
'    l_subscription    flow_message_flow.t_subscription_details;',
'    l_msub_id         flow_message_subscriptions.msub_id%type;',
'  begin',
'    for message_start_events in ',
'      ( select objt.objt_dgrm_id',
'             , objt.objt_bpmn_id',
'             , objt.objt_sub_tag_name',
'             , objt.objt_attributes."apex"."messageName"."expression" message_name',
'             , objt.objt_attributes."apex"."payloadVariable" payload_var',
'          from flow_objects objt',
'         where objt_dgrm_id      = pi_dgrm_id',
'           and objt_tag_name     = flow_constants_pkg.gc_bpmn_start_event',
'           and objt_sub_tag_name = flow_constants_pkg.gc_bpmn_message_event_definition',
'      )',
'    loop',
'',
'      l_subscription.message_name := message_start_events.message_name;',
'      l_subscription.dgrm_id      := pi_dgrm_id;',
'      l_subscription.callback     := flow_constants_pkg.gc_bpmn_start_event;',
'      l_subscription.callback_par := message_start_events.objt_bpmn_id;',
'      l_subscription.payload_var  := message_start_events.payload_var;',
'',
'      l_msub_id := flow_message_flow.subscribe (p_subscription_details => l_subscription);',
'',
'      apex_debug.message ( p_message => ''Message Start Event - Diagram %0 Start Event %1 Subscribed msub_id = %2.)''',
'      , p0 => pi_dgrm_id',
'      , p1 => message_start_events.objt_bpmn_id',
'      , p2 => l_msub_id',
'      );',
'    end loop;',
'  end subscribe_diagram_message_starts;',
'',
'',
'  procedure release_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type)',
'  as',
'    l_dgrm_id_deprecated  flow_diagrams.dgrm_id%type;',
'    l_dgrm_content        clob;',
'  begin',
'/*    update flow_diagrams',
'       set dgrm_status = flow_constants_pkg.gc_dgrm_status_deprecated',
'     where dgrm_name = (',
'           select dgrm_name ',
'             from flow_diagrams',
'            where dgrm_id = pi_dgrm_id)',
'       and dgrm_status = flow_constants_pkg.gc_dgrm_status_released',
'    returning dgrm_id into l_dgrm_id_deprecated;',
'',
'    if l_dgrm_id_deprecated is not null then ',
'      -- log deprecation of old diagram',
'      apex_debug.message ( p_message => ''Release Diagram - Diagram %0 being deprecated in favor of new diagram %1.)''',
'      , p0 => l_dgrm_id_deprecated',
'      , p1 => pi_dgrm_id',
'      );',
'      flow_logging.log_diagram_event ',
'      ( p_dgrm_id         => l_dgrm_id_deprecated',
'      , p_dgrm_status     => flow_constants_pkg.gc_dgrm_status_deprecated',
'      , p_comment         => ''Diagram deprecated when dgrm_id ''||pi_dgrm_id||'' released.''',
'      );',
'    end if; */',
'',
'    -- deprecate existing released version of model if one exists',
'    begin',
'      select dgrm_id',
'        into l_dgrm_id_deprecated',
'        from flow_diagrams',
'       where dgrm_status = flow_constants_pkg.gc_dgrm_status_released',
'         and dgrm_name = (',
'             select dgrm_name ',
'               from flow_diagrams',
'              where dgrm_id = pi_dgrm_id);',
'    exception',
'      when no_data_found then',
'        l_dgrm_id_deprecated := null;',
'    end;',
'',
'    if l_dgrm_id_deprecated is not null then',
'      deprecate_diagram (pi_dgrm_id => l_dgrm_id_deprecated );',
'    end if;',
'',
'    -- logging needs to include copy of the new production diagram for secure modes',
'    select dgrm_content',
'      into l_dgrm_content',
'      from flow_diagrams',
'     where dgrm_id = pi_dgrm_id;',
'',
'    update flow_diagrams',
'       set dgrm_status = flow_constants_pkg.gc_dgrm_status_released',
'     where dgrm_id = pi_dgrm_id;',
'',
'    subscribe_diagram_message_starts (pi_dgrm_id => pi_dgrm_id );',
'',
'    apex_debug.message ( p_message => ''Release Diagram - Diagram %0 released.)''',
'    , p0 => pi_dgrm_id',
'    );',
'',
'    flow_logging.log_diagram_event ',
'    ( p_dgrm_id         => pi_dgrm_id',
'    , p_dgrm_status     => flow_constants_pkg.gc_dgrm_status_released',
'    , p_dgrm_content    => l_dgrm_content',
'    , p_comment         => ''Diagram released.''',
'    );',
'',
'  end release_diagram;',
'',
'  procedure release_diagram(',
'    pi_dgrm_name    in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type default ''0'')',
'  is',
'    l_dgrm_id  flow_diagrams.dgrm_id%type;',
'  begin',
'    l_dgrm_id :=  get_current_diagram',
'                  ( pi_dgrm_name              => pi_dgrm_name',
'                  , pi_dgrm_calling_method    => flow_constants_pkg.gc_dgrm_version_named_version',
'                  , pi_dgrm_version           => pi_dgrm_version',
'                  );',
'    release_diagram (pi_dgrm_id => l_dgrm_id);',
'  end release_diagram;',
'',
'  procedure deprecate_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type)',
'  as',
'  begin',
'',
'    $IF flow_apex_env.ee $THEN',
'      flow_message_util_ee.cancel_diagram_subscriptions ',
'      ( p_dgrm_id   => pi_dgrm_id',
'      , p_callback  => flow_constants_pkg.gc_bpmn_start_event',
'      );',
'    $END',
'',
'    update flow_diagrams',
'       set dgrm_status = flow_constants_pkg.gc_dgrm_status_deprecated',
'     where dgrm_id = pi_dgrm_id;',
'',
'    apex_debug.message ( p_message => ''Release Diagram - Diagram %0 deprecated.)''',
'    , p0 => pi_dgrm_id',
'    );',
'',
'    flow_logging.log_diagram_event ',
'    ( p_dgrm_id         => pi_dgrm_id',
'    , p_dgrm_status     => flow_constants_pkg.gc_dgrm_status_deprecated',
'    , p_comment         => ''Diagram deprecated.''',
'    );   ',
'',
'  end deprecate_diagram;',
'',
'',
'  procedure archive_diagram(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type)',
'  as',
'    l_running_instances       number ;',
'    e_has_running_instances   exception;',
'  begin',
'    -- check that diagram has no current running process instances',
'    select count(prcs_id)',
'      into l_running_instances',
'      from flow_processes prcs',
'     where prcs.prcs_id in (',
'            select prdg.prdg_prcs_id',
'              from flow_instance_diagrams prdg',
'             where prdg.prdg_dgrm_id = pi_dgrm_id',
'            )',
'       and prcs.prcs_status not in  ( flow_constants_pkg.gc_prcs_status_completed',
'                                    , flow_constants_pkg.gc_prcs_status_terminated',
'                                    );',
'    if l_running_instances = 0 then',
'      update flow_diagrams',
'         set dgrm_status = flow_constants_pkg.gc_dgrm_status_archived',
'       where dgrm_id = pi_dgrm_id;',
'',
'      flow_logging.log_diagram_event ',
'      ( p_dgrm_id         => pi_dgrm_id',
'      , p_dgrm_status     => flow_constants_pkg.gc_dgrm_status_archived',
'      , p_comment         => ''Diagram archived.''',
'      );',
'    else                     ',
'      raise e_has_running_instances;',
'    end if;',
'  exception',
'    when e_has_running_instances then',
'          -- initial process start so call general error (instance not yet running)',
'          flow_errors.handle_general_error ( pi_message_key => ''diagram-archive-has-instances'');',
'          -- $F4AMESSAGE ''version-not-found'' || ''Cannot find specified diagram version.  Please check version specification.''',
'  end archive_diagram;   ',
'',
'  function get_diagram_name',
'    ( pi_dgrm_id       in flow_diagrams.dgrm_id%type)',
'  return flow_diagrams.dgrm_name%type',
'  is',
'    l_dgrm_name   flow_diagrams.dgrm_name%type;',
'  begin',
'    select dgrm_name',
'      into l_dgrm_name',
'      from flow_diagrams',
'     where dgrm_id = pi_dgrm_id',
'    ;',
'     return l_dgrm_name;',
'  end get_diagram_name;',
'',
'end flow_diagram;',
'/',
'',
'create or replace package body flow_log_admin as',
'  /* ',
'  -- Flows for APEX - flow_log_admin.pkb',
'  -- ',
'  -- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'  -- (c) Copyright Flowquest Consulting Limited. 2024',
'  --',
'  -- Created    18-Feb-2023  Richard Allen (Oracle)',
'  -- Modified   11-Feb-2024  Richard Allen (Flowquest Consulting)',
'  --',
'  -- Package flow_log_admin manaes the Flows for APEX log tables, including',
'  --    - creation of instance archive summary',
'  --    - archiving of instance logs',
'  --    - purging of instance log tables ',
'  */  ',
'',
'  type t_archive_location is record',
'  ( destination_type               flow_types_pkg.t_vc200',
'  , db_table_name                  flow_types_pkg.t_vc200',
'  , db_id_column                   flow_types_pkg.t_vc200',
'  , db_timestamp_column            flow_types_pkg.t_vc200',
'  , db_blob_column                 flow_types_pkg.t_vc200',
'  , oci_base_url                   flow_types_pkg.t_vc200',
'  , oci_bucket_name                flow_types_pkg.t_vc200',
'  , oci_document_prefix            flow_types_pkg.t_vc200',
'  , oci_request_url                flow_types_pkg.t_vc200  -- url to use for request',
'  , oci_credential_static_id       flow_types_pkg.t_vc200  -- APEX Static ID of Credential',
'  );',
'',
'',
'  function get_instance_json_summary',
'  ( p_process_id     in flow_processes.prcs_id%type',
'  ) return clob',
'  is',
'    l_archive_json    clob;',
'  begin',
'    with p as',
'       (  select prcs_id',
'               , prcs_dgrm_id',
'               , prcs_name',
'               , prcs_priority',
'               , prcs_status',
'               , prcs_init_ts',
'               , prcs_init_by',
'               , prcs_due_on',
'          from   flow_processes prcs',
'          where  prcs_id = p_process_id               ',
'      ),',
'     s as',
'        ( select distinct sc.lgvr_scope scope, sc.lgvr_prcs_id',
'          from   flow_variable_event_log sc',
'        )',
'    select json_object (',
'       ''processID''    value p.prcs_id,',
'       ''mainDiagram''  value p.prcs_dgrm_id,',
'       ''processName''  value p.prcs_name,',
'       ''businessID''   value prov.prov_var_vc2,',
'       ''priority''     value p.prcs_priority,',
'       ''prcs_status''  value p.prcs_status,',
'       ''prcs_init_ts'' value p.prcs_init_ts,',
'       ''prcs_init_by'' value p.prcs_init_by,',
'       ''prcs_due_on''  value p.prcs_due_on,',
'       ''json_created'' value systimestamp,',
'       ''diagramsUsed'' value',
'            (select json_arrayagg ',
'                       ( json_object ',
'                           (',
'                           ''diagramLevel''               value prdg_diagram_level,',
'                           ''diagramId''                  value prdg_dgrm_id,',
'                           ''diagramName''                value dgrm_name,',
'                           ''diagramVersion''             value dgrm_version,',
'                           ''diagramStatus''              value dgrm_status,',
'                           ''callingDiagram''             value prdg_calling_dgrm,',
'                           ''callingObject''              value prdg_calling_objt',
'                           ) order by prdg_diagram_level asc ',
'                       returning clob)',
'               from flow_instance_diagrams prdg',
'               join flow_diagrams dgrm',
'                 on dgrm.dgrm_id = prdg.prdg_dgrm_id',
'              where prdg.prdg_prcs_id = p.prcs_id   ',
'           ),',
'       ''events'' : ',
'           (select json_arrayagg ',
'                       ( json_object ',
'                           (',
'                           ''event''                      value lgpr_prcs_event,',
'                           ''object''                     value lgpr_objt_id,',
'                           ''diagram''                    value lgpr_dgrm_id,',
'                           ''timestamp''                  value lgpr_timestamp,',
'                           ''user''                       value lgpr_user,',
'                           ''error-info''                 value lgpr_error_info,',
'                           ''comment''                    value lgpr_comment absent on null',
'                           ) order by lgpr_timestamp ',
'                        returning clob )',
'              from flow_instance_event_log lgpr',
'             where lgpr.lgpr_prcs_id = p.prcs_id',
'           ),       ',
'       ''steps'' :',
'           (select json_arrayagg',
'                       (json_object ',
'                           (',
'                           ''object''                     value lgsf_objt_id,',
'                           ''subflowID''                  value lgsf_sbfl_id,',
'                           ''stepKey''                    value lgsf_step_key,',
'                           ''processLevel''               value lgsf_sbfl_process_level,',
'                           ''priority''                   value lgsf_priority,',
'                           ''lastCompleted''              value lgsf_last_completed,',
'                           ''wasCurrent''                 value lgsf_was_current,',
'                           ''wasStarted''                 value lgsf_started,',
'                           ''wasCompleted''               value lgsf_completed,',
'                           ''statusWhenComplete''         Value lgsf_status_when_complete,',
'                           ''subflowDiagram''             value lgsf_sbfl_dgrm_id,',
'                           ''reservation''                value lgsf_reservation,',
'                           ''priority''                   value lgsf_priority,',
'                           ''dueOn''                      value lgsf_due_on,',
'                           ''user''                       value lgsf_user,',
'                           ''comment''                    value lgsf_comment absent on null',
'                           ) order by lgsf_was_current',
'                       returning clob )',
'             from flow_step_event_log lgsf',
'            where lgsf.lgsf_prcs_id = p.prcs_id',
'            ),',
'       ''processVariablesSet'' :',
'               (  select json_arrayagg (',
'                       json_object (',
'                           ''scope''         value s.scope,',
'                           ''variables''     value',
'                               ( select json_arrayagg ',
'                                           (',
'                                           json_object ',
'                                               (',
'                                               ''var_name''        value lgvr.lgvr_var_name,',
'                                               ''subflowID''       value lgvr.lgvr_sbfl_id,',
'                                               ''objectId''        value lgvr.lgvr_objt_id,',
'                                               ''expr_set''        value lgvr.lgvr_expr_set,',
'                                               ''type''            value lgvr.lgvr_var_type,',
'                                               ''timestamp''       value lgvr.lgvr_timestamp,',
'                                               ''newValue''        value case lgvr.lgvr_var_type',
'                                                          when ''VARCHAR2''                   then lgvr.lgvr_var_vc2',
'                                                          when ''NUMBER''                     then to_char(lgvr.lgvr_var_num)',
'                                                          when ''DATE''                       then to_char(lgvr.lgvr_var_date,''YYYY-MM-DD"T"HH24:MI:SS"Z"'')',
'                                                          when ''TIMESTAMP WITH TIME ZONE''   then to_char(lgvr.lgvr_var_tstz,''YYYY-MM-DD"T"HH24:MI:SSTZR'')',
'                                                          when ''CLOB''                       then ''CLOB Value''',
'                                                          when ''JSON''                       then cast(dbms_lob.substr(lgvr_var_json, 4000) as  varchar2(4000))',
'                                                          end ',
'                                               )',
'                                           order by lgvr.lgvr_timestamp ',
'                                           returning clob )',
'                                   from flow_variable_event_log lgvr',
'                                  where lgvr.lgvr_prcs_id = p.prcs_id',
'                                    and lgvr.lgvr_scope   = s.scope',
'                               ) returning clob',
'                           )',
'                       returning clob )',
'                   from s',
'                  where s.lgvr_prcs_id = p.prcs_id',
'               )',
'           returning clob )',
'     into l_archive_json',
'     from p ',
'     left join flow_process_variables prov',
'       on prov.prov_prcs_id    = p.prcs_id',
'      and prov.prov_var_name   = ''BUSINESS_REF''',
'      and prov.prov_scope      = 0',
'    ;',
'    return l_archive_json;',
'  end get_instance_json_summary;',
'',
'  procedure purge_instance_logs',
'  ( p_retention_period_days  in number default null',
'  )',
'  is',
'    l_log_retain_days    flow_configuration.cfig_value%type;',
'    l_purge_interval     interval day(4) to second(0);',
'  begin',
'    apex_debug.enter (''purge_instance_logs''',
'    , ''p_retention_period_days'', p_retention_period_days);',
'',
'    -- if retention period not specified, get configuration parameter or default',
'    if p_retention_period_days is null then',
'      l_log_retain_days     := flow_engine_util.get_config_value ',
'                               ( p_config_key  => flow_constants_pkg.gc_config_logging_retain_logs',
'                               , p_default_value  => flow_constants_pkg.gc_config_default_log_retain_logs',
'                               );   ',
'      l_purge_interval   := to_dsinterval (''P''||trim( both from l_log_retain_days)||''D'');',
'    else',
'      l_purge_interval   := to_dsinterval (''P''||trim( both from p_retention_period_days)||''D'');   ',
'    end if;',
'    -- delete',
'    delete from flow_variable_event_log',
'    where lgvr_prcs_id in (select lgpr_prcs_id',
'                           from   flow_instan'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ce_event_log',
'                           where  lgpr_prcs_event = flow_constants_pkg.gc_prcs_event_completed',
'                           and    lgpr_timestamp < systimestamp - l_purge_interval);',
'',
'',
'    delete from flow_step_event_log',
'    where lgsf_prcs_id in (select lgpr_prcs_id',
'                           from   flow_instance_event_log',
'                           where  lgpr_prcs_event = flow_constants_pkg.gc_prcs_event_completed',
'                           and    lgpr_timestamp < systimestamp - l_purge_interval);',
'',
'    delete from flow_instance_event_log',
'    where lgpr_prcs_id in (select lgpr_prcs_id',
'                           from   flow_instance_event_log',
'                           where  lgpr_prcs_event = flow_constants_pkg.gc_prcs_event_completed',
'                           and    lgpr_timestamp < systimestamp - l_purge_interval);',
'',
'    flow_log_admin.purge_message_logs(p_retention_period_days => p_retention_period_days);',
'',
'    flow_log_admin.purge_rest_logs(p_retention_period_days => p_retention_period_days);',
'',
'  end purge_instance_logs;',
'',
'  procedure purge_message_logs',
'  ( p_retention_period_days    in number default null',
'  )',
'  is',
'    l_log_retain_days    flow_configuration.cfig_value%type;',
'    l_purge_interval     interval day(4) to second(0);',
'  begin',
'    apex_debug.enter (''purge_message_logs''',
'    , ''p_retention_period_days'', p_retention_period_days);',
'',
'    -- if retention period not specified, get configuration parameter or default',
'    if p_retention_period_days is null then',
'      l_log_retain_days     := flow_engine_util.get_config_value ',
'                               ( p_config_key  => flow_constants_pkg.gc_config_logging_retain_msg_flow ',
'                               , p_default_value  => flow_constants_pkg.gc_config_default_log_retain_msg_flow_logs',
'                               );   ',
'      l_purge_interval   := to_dsinterval (''P''||trim( both from l_log_retain_days)||''D'');',
'    else',
'      l_purge_interval   := to_dsinterval (''P''||trim( both from p_retention_period_days)||''D'');   ',
'    end if;',
'',
'    delete from flow_message_received_log',
'    where lgrx_received_on < systimestamp - l_purge_interval;',
'',
'  end purge_message_logs;',
'',
'  procedure purge_rest_logs',
'  ( p_retention_period_days    in number default null',
'  )',
'  is',
'    l_log_retain_days    flow_configuration.cfig_value%type;',
'    l_purge_interval     interval day(4) to second(0);',
'  begin',
'    apex_debug.enter (''purge_rest_logs''',
'    , ''p_retention_period_days'', p_retention_period_days);',
'',
'    -- if retention period not specified, get configuration parameter or default',
'    if p_retention_period_days is null then',
'      l_log_retain_days     := flow_engine_util.get_config_value ',
'                               ( p_config_key  => flow_rest_logging.c_log_rest_incoming_retain_days',
'                               , p_default_value  => flow_rest_logging.c_log_rest_incoming_retain_days_default',
'                               );   ',
'      l_purge_interval   := to_dsinterval (''P''||trim( both from l_log_retain_days)||''D'');',
'    else',
'      l_purge_interval   := to_dsinterval (''P''||trim( both from p_retention_period_days)||''D'');   ',
'    end if;',
'',
'    delete from flow_rest_event_log',
'    where lgrt_timestamp < systimestamp - l_purge_interval;',
'',
'  end purge_rest_logs;',
'',
'  function get_archive_location',
'  ( p_archive_type   in varchar2',
'  )',
'  return t_archive_location',
'  is',
'    l_archive_location              t_archive_location;',
'    e_archive_bad_destination_json  exception;',
'    l_destination_json              flow_configuration.cfig_value%type;',
'  begin',
'    apex_debug.enter ( ''get_archive_location'');',
'',
'    l_destination_json      := flow_engine_util.get_config_value ',
'                             ( p_config_key  => p_archive_type',
'                             , p_default_value  => null);',
'',
'    apex_debug.message ',
'    ( p_message => ''Retrieved configuration parameter %0 contents %1''',
'    , p0 => p_archive_type',
'    , p1 => l_destination_json',
'    );                         ',
'    -- dbms_output.put_line(''archive destination''||l_destination_json);',
'    apex_json.parse (p_source => l_destination_json);',
'',
'    l_archive_location.destination_type            := apex_json.get_varchar2 (p_path => ''destinationType'');',
'',
'    apex_debug.message (p_message => ''--- Destination Type : %0'', p0=> l_archive_location.destination_type);  ',
'    -- dbms_output.put_line(''--- Destination Type : ''||l_archive_location.destination_type);',
'',
'    case l_archive_location.destination_type ',
'    when flow_constants_pkg.gc_config_archive_destination_table then',
'      l_archive_location.db_table_name             := apex_json.get_varchar2 (p_path => ''tableDetails.tableName'');',
'      l_archive_location.db_id_column              := apex_json.get_varchar2 (p_path => ''tableDetails.idColumn'');',
'      l_archive_location.db_timestamp_column       := apex_json.get_varchar2 (p_path => ''tableDetails.timestampColumn'');',
'      l_archive_location.db_blob_column            := apex_json.get_varchar2 (p_path => ''tableDetails.blobColumn'');',
'',
'    when flow_constants_pkg.gc_config_archive_destination_oci_api then',
'      l_archive_location.oci_base_url              := apex_json.get_varchar2 (p_path => ''ociApiDetails.baseUrl'');',
'      apex_debug.message (p_message => ''--- Base URL : %0'', p0=> l_archive_location.oci_base_url);  ',
'      l_archive_location.oci_bucket_name           := apex_json.get_varchar2 (p_path => ''ociApiDetails.bucketName'');',
'      apex_debug.message (p_message => ''--- Bucket Name : %0'', p0=> l_archive_location.oci_bucket_name);',
'      l_archive_location.oci_document_prefix       := apex_json.get_varchar2 (p_path => ''ociApiDetails.documentPrefix'');',
'      l_archive_location.oci_credential_static_id  := apex_json.get_varchar2 (p_path => ''ociApiDetails.credentialApexStaticId'');',
'',
'      l_archive_location.oci_request_url :=  l_archive_location.oci_base_url',
'                                         || ''b/'' ',
'                                         || l_archive_location.oci_bucket_name ',
'                                         || ''/o/'';',
'      apex_debug.message (p_message => ''--- Request URL : %0'', p0=> l_archive_location.oci_request_url);',
'    when flow_constants_pkg.gc_config_archive_destination_oci_preauth then',
'      l_archive_location.oci_request_url           := apex_json.get_varchar2 (p_path => ''ociPreAuthDetails.preAuthUrl'');',
'      apex_debug.message (p_message => ''--- Request URL : %0'', p0=> l_archive_location.oci_request_url);',
'      l_archive_location.oci_document_prefix       := apex_json.get_varchar2 (p_path => ''ociPreAuthDetails.documentPrefix'');',
'      l_archive_location.oci_credential_static_id  := apex_json.get_varchar2 (p_path => ''ociPreAuthDetails.credentialApexStaticId'');',
'    end case;',
'    return l_archive_location;',
'    exception',
'      when others then ',
'        apex_debug.info ',
'        ( p_message => '' --- Error in %0 configuration parameter definition. Value :''',
'        , p0  => flow_constants_pkg.gc_config_logging_archive_location',
'        , p1  => l_destination_json',
'        );',
'        flow_errors.handle_general_error',
'        ( pi_message_key    => ''archive-destination-bad-json''',
'        , p0 => l_destination_json',
'        );  ',
'        -- $F4AMESSAGE ''archive-destination-bad-json'' || ''Error in archive destination configuration parameter.  Parameter: %0'' ',
'      return null;',
'  end get_archive_location;',
'',
'  procedure archive_to_database',
'  ( p_object_id         in number',
'  , p_archive           in blob',
'  , p_archive_location  in t_archive_location',
'  )',
'  is',
'    l_insert_sql           varchar2(4000);',
'    l_update_sql           varchar2(4000);',
'    e_db_archive_fail      exception;',
'',
'  begin',
'    apex_debug.enter ( ''archive_to_database'',',
'    ''instance'', p_object_id',
'    );   ',
'',
'    l_insert_sql := ''insert into ''',
'                    ||p_archive_location.db_table_name',
'                    ||'' ( '' ||p_archive_location.db_id_column ',
'                    ||'' , '' ||p_archive_location.db_timestamp_column ',
'                    ||'' , '' ||p_archive_location.db_blob_column',
'                    ||'' ) values ( :1, systimestamp,  :2 )''',
'                    ;',
'    execute immediate l_insert_sql using p_object_id, p_archive;',
'    apex_debug.message ',
'    ( p_message => ''-- Object %0 inserted into archive to %1.%2''',
'    , p0 => p_object_id',
'    , p1 => p_archive_location.db_table_name',
'    , p2 => p_archive_location.db_blob_column',
'    ); ',
'  exception',
'  /*  when dup_val_on_index then  -- added timestap column so this will not be called now...',
'      -- handle re-archive if the archive already exists.   This usually occurs if the process ',
'      -- was reset after archiving.',
'      l_update_sql := ''update ''',
'                      ||p_archive_location.db_table_name',
'                      ||'' set ''',
'                      ||p_archive_location.db_blob_column',
'                      ||'' = :1 where ''',
'                      ||p_archive_location.db_id_column',
'                      ||'' = :2 ''',
'                      ;',
'      execute immediate l_update_sql using p_archive, p_object_id;',
'      apex_debug.message ',
'      ( p_message => ''-- Object %0 archive updated in %1.%2''',
'      , p0 => p_object_id',
'      , p1 => p_archive_location.db_table_name',
'      , p2 => p_archive_location.db_blob_column',
'      ); */',
'    when others then',
'      apex_debug.message ',
'      ( p_message => ''Archiving object %0 into database column %1.%2 failed. Failed SQL: %3.''',
'      , p0 => p_object_id',
'      , p1 => p_archive_location.db_table_name',
'      , p2 => p_archive_location.db_blob_column',
'      , p3 => l_insert_sql',
'      ); ',
'      raise e_db_archive_fail;',
'  end archive_to_database;',
'',
'  procedure archive_to_oci',
'  ( p_archive           in blob',
'  , p_archive_location  in t_archive_location',
'  , p_object_name       in varchar2',
'  , p_content_type      in varchar2',
'  )',
'  is',
'    l_url                       varchar2(4000);',
'    l_response                  clob;',
'    e_upload_failed_exception   exception;',
'  begin',
'    l_url := p_archive_location.oci_request_url',
'              ||p_archive_location.oci_document_prefix',
'              ||p_object_name;',
'    apex_debug.message ',
'    ( p_message => ''Preparing Archive URL - URL : %0 Credential Static ID: %1''',
'    , p0 => l_url',
'    , p1 => p_archive_location.oci_credential_static_id',
'    );',
'    apex_web_service.g_request_headers(1).name :=  ''Content-Type'';',
'    apex_web_service.g_request_headers(1).value :=  p_content_type;',
'    l_response :=  apex_web_service.make_rest_request',
'                   ( p_url          => l_url',
'                   , p_http_method  => ''PUT''',
'                   , p_body_blob    => p_archive',
'                   , p_credential_static_id => p_archive_location.oci_credential_static_id',
'                   );',
'    if apex_web_service.g_status_code != 200 then',
'      raise e_upload_failed_exception;',
'    end if;',
'  end archive_to_oci;',
'',
'  function archive_bpmn_diagram',
'  ( p_dgrm_id            flow_diagrams.dgrm_id%type',
'  , p_dgrm_content       flow_diagrams.dgrm_content%type',
'  ) return flow_flow_event_log.lgfl_dgrm_archive_location%type',
'  is',
'    l_archive_blob        blob;',
'    l_archive_location    t_archive_location;',
'    l_timestamp           timestamp with time zone;',
'    l_stored_location     flow_flow_event_log.lgfl_dgrm_archive_location%type;',
'    l_object_name         flow_flow_event_log.lgfl_dgrm_archive_location%type;',
'  begin',
'    -- fix timestamp',
'    l_timestamp := systimestamp at time zone ''UTC'';',
'    -- create bpmn blob',
'    l_archive_blob := flow_engine_util.clob_to_blob( pi_clob  => p_dgrm_content );',
'    -- get archive location',
'    l_archive_location := get_archive_location (p_archive_type => flow_constants_pkg.gc_config_logging_bpmn_location);',
'    -- store in preferred location',
'    case l_archive_location.destination_type',
'    when flow_constants_pkg.gc_config_archive_destination_table then',
'      archive_to_database ( p_object_id        => p_dgrm_id',
'                          , p_archive          => l_archive_blob',
'                          , p_archive_location => l_archive_location',
'                          );',
'      return l_archive_location.db_table_name;',
'    when flow_constants_pkg.gc_config_archive_destination_oci_api then',
'      l_object_name := trim(to_char(p_dgrm_id,''099999''))||''-''||to_char(l_timestamp,''YYYYMMDD-HH24MISS'')||''.bpmn'';',
'      archive_to_oci      ( p_archive          => l_archive_blob',
'                          , p_archive_location => l_archive_location',
'                          , p_object_name      => l_object_name',
'                          , p_content_type     => flow_constants_pkg.gc_mime_type_bpmn',
'                          );   ',
'      return l_object_name;',
'    when flow_constants_pkg.gc_config_archive_destination_oci_preauth then',
'      l_object_name := trim(to_char(p_dgrm_id,''099999''))||''-''||to_char(l_timestamp,''YYYYMMDD-HH24MISS'')||''.bpmn'';',
'      archive_to_oci      ( p_archive          => l_archive_blob',
'                          , p_archive_location => l_archive_location',
'                          , p_object_name      => l_object_name',
'                          , p_content_type     => flow_constants_pkg.gc_mime_type_bpmn',
'                          );  ',
'      return l_object_name;',
'    end case;',
'  end archive_bpmn_diagram;',
'',
'  procedure archive_instance',
'  ( p_process_id         flow_processes.prcs_id%type',
'  , p_archive_location   t_archive_location',
'  )',
'  is',
'    l_archive_blob   blob;',
'  begin',
'    -- create instance summary json',
'    l_archive_blob := flow_engine_util.clob_to_blob( pi_clob  => get_instance_json_summary (p_process_id => p_process_id) );',
'    -- store in preferred location',
'    case p_archive_location.destination_type',
'    when flow_constants_pkg.gc_config_archive_destination_table then',
'      archive_to_database ( p_object_id        => p_process_id',
'                          , p_archive          => l_archive_blob',
'                          , p_archive_location => p_archive_location',
'                          );',
'    when flow_constants_pkg.gc_config_archive_destination_oci_api then',
'      archive_to_oci      ( p_archive          => l_archive_blob',
'                          , p_archive_location => p_archive_location',
'                          , p_object_name      => trim(to_char(p_process_id,''09999999''))||''.json''',
'                          , p_content_type     => flow_constants_pkg.gc_mime_type_json',
'                          );  ',
'    when flow_constants_pkg.gc_config_archive_destination_oci_preauth then',
'      archive_to_oci      ( p_archive          => l_archive_blob',
'                          , p_archive_location => p_archive_location',
'                          , p_object_name      => trim(to_char(p_process_id,''09999999''))||''.json''',
'                          , p_content_type     => flow_constants_pkg.gc_mime_type_json',
'                          );  ',
'    end case;',
'    -- update instance with archive timestamp',
'    update flow_processes',
'    set prcs_archived_ts = systimestamp',
'      , prcs_last_update = systimestamp',
'    where prcs_id = p_process_id;',
'  end archive_instance;',
'',
'  procedure archive_completed_instances',
'  ( p_completed_before         in date default trunc(sysdate)',
'  , p_process_id               in flow_processes.prcs_id%type default null  ',
'  )',
'  is',
'    type t_instance           is record (',
'      prcs_id                 flow_processes.prcs_id%type);',
'    type t_instances          is table of t_instance;',
'',
'    l_response                clob;',
'    l_archive_location        t_archive_location;',
'    l_instances               t_instances;',
'',
'    e_upload_failed_exception exception;',
'  begin',
'    apex_debug.enter (''archive_completed_instances''',
'    ,''p_completed_before'',p_completed_before',
'    , ''p_process_id'', p_process_id',
'    );',
'    -- get list of process instances to archive, if a single p_process_id was not passed in.',
'    -- get all completed (''completed'' or ''terminated'') non-archived instances',
'    -- dbms_output.put_line(''Archiving starting'');',
'    if p_process_id is null then',
'      select prcs.prcs_id',
'        bulk collect into l_instances',
'        from flow_processes prcs',
'       where prcs.prcs_status in ( flow_constants_pkg.gc_prcs_status_completed',
'                                 , flow_constants_pkg.gc_prcs_status_terminated )',
'         and trunc(prcs.prcs_complete_ts) < p_completed_before',
'         and prcs.prcs_archived_ts is null',
'      ;',
'    else',
'      select p_process_id',
'        bulk collect into l_instances',
'        from dual;',
'    end if;',
'',
'    apex_debug.message (p_message => ''Instances to be Archived : %0''',
'    , p0 => l_instances.count);',
'',
'    if l_instances.count > 0 then',
'      -- dbms_output.put_line(''getting location'');',
'      -- get archive location',
'      l_archive_location := get_archive_location (p_archive_type => flow_constants_pkg.gc_config_logging_archive_location);',
'      --dbms_output.put_line(''got location'');',
'      -- loop over instances',
'      for instance in 1 .. l_instances.count',
'      loop',
'        -- lock flow_processes?',
'        -- dbms_output.put_line(''Archiving process ''||l_instances(instance).prcs_id);',
'        archive_instance ( p_process_id => l_instances(instance).prcs_id',
'                         , p_archive_location => l_archive_location',
'                         );',
'        ',
'        -- commit?',
'      end loop;      ',
'    end if;',
'  exception  ',
'    when others then',
'      flow_errors.handle_general_error( pi_message_key  => ''log-archive-error''',
'                                      , p0 => apex_web_service.g_status_code);',
'      raise;      ',
'  end archive_completed_instances;',
'',
'end flow_log_admin;',
'/',
'',
'create or replace package body flow_admin_api as',
' /* Flows for APEX - flow_admin_api.pkb',
'--',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created    11-Feb-2023   Richard Allen, Oracle',
'*/',
' /**',
'FLOWS FOR APEX ADMIN API',
'=========================',
'',
'The `flow_admin_api` package gives you access to the Flows for APEX engine admin procedures, and allows you to perform:',
'-  Maintenance, Archiving and Purging of the Flows for APEX log files',
'-  Maintenance, Archiving, and Purging of the Flows for APEX performance statistics all_summaries',
'- Maintenance of Flows for APEX instance configuration parameters',
'',
'*/',
'-- Log File Functions',
'  procedure purge_instance_logs',
'  ( p_retention_period_days  in number default null',
'  ) ',
'  is',
'  begin',
'    flow_log_admin.purge_instance_logs ',
'    ( p_retention_period_days => p_retention_period_days ',
'    );',
'  end purge_instance_logs;',
'',
'  function instance_summary',
'  ( p_process_id        in flow_processes.prcs_id%type',
'  ) return clob',
'  is',
'  begin',
'    return flow_log_admin.get_instance_json_summary ( p_process_id => p_process_id);',
'  end instance_summary;',
'',
'  procedure archive_completed_instances',
'  ( p_completed_before         in date default trunc(sysdate)',
'  )',
'  is',
'      l_session_id   number;',
'    begin  ',
'        if v(''APP_SESSION'') is null then',
'          l_session_id := flow_apex_session.create_api_session(p_process_id => null);',
'        end if;',
'',
'        flow_log_admin.archive_completed_instances',
'        ( p_completed_before         => p_completed_before',
'        );',
'',
'        if l_session_id is not null then',
'          flow_apex_session.delete_session (p_session_id => l_session_id );',
'        end if;',
'    exception',
'      when others then',
'        if l_session_id is not null then',
'          flow_apex_session.delete_session (p_session_id => l_session_id );',
'        end if;',
'        raise;      ',
'  end archive_completed_instances;',
'',
'-- Performance Summary Functions',
'',
'  procedure run_daily_stats',
'  is',
'  begin',
'    flow_statistics.run_daily_stats;',
'  end run_daily_stats;',
'',
'',
'  procedure purge_statistics',
'  is',
'  begin',
'    flow_statistics.purge_statistics;',
'  end purge_statistics;',
'',
'  -- Configuration Parameters',
'',
'  procedure set_config_value',
'  ( p_config_key        in flow_configuration.cfig_key%type,',
'    p_value             in flow_configuration.cfig_value%type,',
'    p_update_if_set     in boolean default true',
'  )',
'  is',
'  begin',
'    flow_engine_util.set_config_value',
'    ( p_config_key      => p_config_key',
'    , p_value           => p_value',
'    , p_update_if_set   => p_update_if_set',
'    );',
'  end set_config_value;',
'',
'  function get_config_value',
'  ( p_config_key        in flow_configuration.cfig_key%type',
'  , p_default_value     in flow_configuration.cfig_value%type',
'  ) return flow_configuration.cfig_value%type',
'  is',
'  begin',
'    return flow_engine_util.get_config_value ( p_config_key     => p_config_key ',
'                                             , p_default_value  => p_default_value',
'                                             );       ',
'  end get_config_value;',
'',
'  -- Diagram Release',
'',
'  procedure release_diagram',
'  ( pi_dgrm_name    in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_version in flow_diagrams.dgrm_version%type default ''0'' ',
'  )',
'  is',
'  begin ',
'    flow_diagram.release_diagram',
'    ( pi_dgrm_name    => pi_dgrm_name',
'    , pi_dgrm_version => pi_dgrm_version',
'    );',
'  end release_diagram;',
'',
'end flow_admin_api;',
'/',
'',
'create or replace package body flow_statistics',
'as',
'/* ',
'-- Flows for APEX - flow_statistics.pkb',
'-- ',
'-- (c) Copyright Oracle Corporation and / or its affiliates, 2023.',
'--',
'-- Created    11-Jan-2023  Richard Allen (Oracle)',
'--',
'*/',
'',
'',
'',
'',
'------------------',
'---  collect daily step stats',
'-------------------',
'  procedure create_daily_step_summary',
'  ( p_start_date   in   date',
'  )',
'  is',
'  begin',
'      insert into flow_step_stats ',
'          ( stsf_dgrm_id',
'          , stsf_tag_name',
'          , stsf_objt_bpmn_id',
'          , stsf_period_start',
'          , stsf_period',
'          , stsf_duration_10pc_ivl',
'          , stsf_duration_50pc_ivl',
'          , stsf_duration_90pc_ivl',
'          , stsf_duration_max_ivl',
'          , stsf_duration_10pc_sec',
'          , stsf_duration_50pc_sec',
'          , stsf_duration_90pc_sec',
'          , stsf_duration_max_sec',
'          , stsf_waiting_10pc_ivl',
'          , stsf_waiting_50pc_ivl',
'          , stsf_waiting_90pc_ivl',
'          , stsf_waiting_max_ivl',
'          , stsf_waiting_10pc_sec',
'          , stsf_waiting_50pc_sec',
'          , stsf_waiting_90pc_sec',
'          , stsf_waiting_max_sec  ',
'          , stsf_completed',
'          ) ',
'      with ivl_stats as',
'        ( select  lgsf_sbfl_dgrm_id                                                   as dgrm_id',
'                  , objt.objt_tag_name                                                as objt_tag_name',
'                  , lgsf_objt_id                                                      as objt_bpmn_id',
'                  , trunc (sys_extract_utc ( lgsf_completed ))                        as period_start',
'                  , approx_percentile (0.10 )',
'                      within group (order by (lgsf_completed - lgsf_was_current) ASC) as duration_10pc_ivl',
'                  , approx_percentile (0.50 )',
'                      within group (order by lgsf_completed - lgsf_was_current ASC)   as duration_50pc_ivl',
'                  , approx_percentile (0.90 )',
'                      within group (order by lgsf_completed - lgsf_was_current ASC)   as duration_90pc_ivl',
'                  , max ( lgsf_completed - lgsf_was_current)                          as duration_max_ivl',
'                  , approx_percentile (0.10 )',
'                      within group (order by (lgsf_started - lgsf_was_current) ASC)   as waiting_10pc_ivl',
'                  , approx_percentile (0.50 )',
'                      within group (order by lgsf_started - lgsf_was_current ASC)     as waiting_50pc_ivl',
'                  , approx_percentile (0.90 )',
'                      within group (order by lgsf_started - lgsf_was_current ASC)     as waiting_90pc_ivl',
'                  , max ( lgsf_started - lgsf_was_current)                            as waiting_max_ivl',
'                  , count (*)                                                         as completed',
'             from flow_step_event_log lgsf',
'        left join flow_objects objt',
'               on objt.objt_dgrm_id = lgsf.lgsf_sbfl_dgrm_id',
'              and objt.objt_bpmn_id = lgsf.lgsf_objt_id',
'            where objt.objt_tag_name in ( ''bpmn:userTask'', ''bpmn:serviceTask'', ''bpmn:manualTask''',
'                                        , ''bpmn:subProcess'', ''bpmn:callActivity'', ''bpmn:scriptTask'', ''bpmn:task'')',
'         group by lgsf_sbfl_dgrm_id, objt.objt_tag_name, lgsf_objt_id, trunc (sys_extract_utc ( lgsf_completed ))',
'        )',
'      select i.dgrm_id',
'           , i.objt_tag_name',
'           , i.objt_bpmn_id',
'           , i.period_start',
'           , flow_constants_pkg.gc_stats_period_day ',
'           , i.duration_10pc_ivl',
'           , i.duration_50pc_ivl',
'           , i.duration_90pc_ivl',
'           , i.duration_max_ivl',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.duration_10pc_ivl)',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.duration_50pc_ivl)',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.duration_90pc_ivl)',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.duration_max_ivl)',
'           , i.waiting_10pc_ivl',
'           , i.waiting_50pc_ivl',
'           , i.waiting_90pc_ivl',
'           , i.waiting_max_ivl',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.waiting_10pc_ivl)',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.waiting_50pc_ivl)',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.waiting_90pc_ivl)',
'           , flow_api_pkg.intervaldstosec (p_intervalds  => i.waiting_max_ivl) ',
'           , i.completed ',
'      from ivl_stats i',
'      where i.period_start between p_start_date and trunc(sysdate)-1',
'      ;',
'  end create_daily_step_summary;',
'  ',
'  ',
'  procedure create_monthly_step_summaries',
'  ( p_start_date in date',
'  )',
'  is',
'  begin',
'    -- now create ''MONTH'' summaries for any month that doesn''t yet exist and MTD to current month',
'    merge into flow_step_stats tgt',
'    using (        ',
'    with mon as ',
'    (',
'      select stsf_dgrm_id, ',
'             stsf_tag_name,',
'             stsf_objt_bpmn_id,',
'             trunc(stsf_period_start, ''MM'') period_start, ',
'             sum ( ds.stsf_duration_10pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) duration_10pc_sec,',
'             sum ( ds.stsf_duration_50pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) duration_50pc_sec, ',
'             sum ( ds.stsf_duration_90pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) duration_90pc_sec, ',
'             sum ( ds.stsf_duration_max_sec  * ds.stsf_completed ) / sum (ds.stsf_completed) duration_max_sec,',
'             sum ( ds.stsf_waiting_10pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_10pc_sec,',
'             sum ( ds.stsf_waiting_50pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_50pc_sec, ',
'             sum ( ds.stsf_waiting_90pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_90pc_sec, ',
'             sum ( ds.stsf_waiting_max_sec  * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_max_sec,',
'             sum ( stsf_completed) completed',
'      from   flow_step_stats ds',
'      where  ds.stsf_period = ''DAY''',
'      group by stsf_dgrm_id, stsf_tag_name, stsf_objt_bpmn_id, trunc(stsf_period_start, ''MM'')',
'      order by stsf_dgrm_id, stsf_tag_name, stsf_objt_bpmn_id, trunc(stsf_period_start, ''MM'')',
'    )',
'    select mon.stsf_dgrm_id ',
'         , mon.stsf_tag_name',
'         , mon.stsf_objt_bpmn_id',
'         , mon.period_start as stsf_period_start',
'         , case when mon.period_start = trunc(sys_extract_utc(systimestamp),''MM'') then ''MTD''',
'                else ''MONTH'' end as stsf_period',
'         , numtodsinterval (mon.duration_10pc_sec , ''SECOND'') as duration_10pc_ivl',
'         , numtodsinterval (mon.duration_50pc_sec , ''SECOND'') as duration_50pc_ivl',
'         , numtodsinterval (mon.duration_90pc_sec , ''SECOND'') as duration_90pc_ivl',
'         , numtodsinterval (mon.duration_max_sec  , ''SECOND'') as duration_max_ivl',
'         , mon.duration_10pc_sec',
'         , mon.duration_50pc_sec',
'         , mon.duration_90pc_sec',
'         , mon.duration_max_sec',
'         , numtodsinterval (mon.waiting_10pc_sec , ''SECOND'') as waiting_10pc_ivl',
'         , numtodsinterval (mon.waiting_50pc_sec , ''SECOND'') as waiting_50pc_ivl',
'         , numtodsinterval (mon.waiting_90pc_sec , ''SECOND'') as waiting_90pc_ivl',
'         , numtodsinterval (mon.waiting_max_sec  , ''SECOND'') as waiting_max_ivl',
'         , mon.waiting_10pc_sec',
'         , mon.waiting_50pc_sec',
'         , mon.waiting_90pc_sec',
'         , mon.waiting_max_sec',
'         , mon.completed',
'    from mon',
'    where mon.period_start >= trunc(p_start_date,''MM'')',
'    ) src ',
'    on  ( src.stsf_dgrm_id      = tgt.stsf_dgrm_id',
'      and src.stsf_tag_name     = tgt.stsf_tag_name',
'      and src.stsf_objt_bpmn_id = tgt.stsf_objt_bpmn_id',
'      and src.stsf_period_start = tgt.stsf_period_start',
'      and src.stsf_period       = tgt.stsf_period )',
'    when matched then ',
'    update set tgt.stsf_duration_10pc_ivl  = src.duration_10pc_ivl',
'            ,  tgt.stsf_duration_50pc_ivl  = src.duration_50pc_ivl',
'            ,  tgt.stsf_duration_90pc_ivl  = src.duration_90pc_ivl',
'            ,  tgt.stsf_duration_max_ivl   = src.duration_max_ivl',
'            ,  tgt.stsf_duration_10pc_sec  = src.duration_10pc_sec',
'            ,  tgt.stsf_duration_50pc_sec  = src.duration_50pc_sec',
'            ,  tgt.stsf_duration_90pc_sec  = src.duration_90pc_sec',
'            ,  tgt.stsf_duration_max_sec   = src.duration_max_sec',
'            ,  tgt.stsf_waiting_10pc_ivl   = src.waiting_10pc_ivl',
'            ,  tgt.stsf_waiting_50pc_ivl   = src.waiting_50pc_ivl',
'            ,  tgt.stsf_waiting_90pc_ivl   = src.waiting_90pc_ivl',
'            ,  tgt.stsf_waiting_max_ivl    = src.waiting_max_ivl',
'            ,  tgt.stsf_waiting_10pc_sec   = src.wait'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ing_10pc_sec',
'            ,  tgt.stsf_waiting_50pc_sec   = src.waiting_50pc_sec',
'            ,  tgt.stsf_waiting_90pc_sec   = src.waiting_90pc_sec',
'            ,  tgt.stsf_waiting_max_sec    = src.waiting_max_sec',
'            ,  tgt.stsf_completed          = src.completed',
'    when not matched then ',
'    insert (  tgt.stsf_dgrm_id',
'            , tgt.stsf_tag_name',
'            , tgt.stsf_objt_bpmn_id',
'            , tgt.stsf_period_start',
'            , tgt.stsf_period',
'            , tgt.stsf_duration_10pc_ivl',
'            , tgt.stsf_duration_50pc_ivl',
'            , tgt.stsf_duration_90pc_ivl',
'            , tgt.stsf_duration_max_ivl',
'            , tgt.stsf_duration_10pc_sec',
'            , tgt.stsf_duration_50pc_sec',
'            , tgt.stsf_duration_90pc_sec',
'            , tgt.stsf_duration_max_sec',
'            , tgt.stsf_waiting_10pc_ivl',
'            , tgt.stsf_waiting_50pc_ivl',
'            , tgt.stsf_waiting_90pc_ivl',
'            , tgt.stsf_waiting_max_ivl',
'            , tgt.stsf_waiting_10pc_sec',
'            , tgt.stsf_waiting_50pc_sec',
'            , tgt.stsf_waiting_90pc_sec',
'            , tgt.stsf_waiting_max_sec  ',
'            , tgt.stsf_completed',
'            )',
'    values  ( src.stsf_dgrm_id',
'            , src.stsf_tag_name',
'            , src.stsf_objt_bpmn_id',
'            , src.stsf_period_start',
'            , src.stsf_period',
'            , src.duration_10pc_ivl',
'            , src.duration_50pc_ivl',
'            , src.duration_90pc_ivl',
'            , src.duration_max_ivl',
'            , src.duration_10pc_sec',
'            , src.duration_50pc_sec',
'            , src.duration_90pc_sec',
'            , src.duration_max_sec',
'            , src.waiting_10pc_ivl',
'            , src.waiting_50pc_ivl',
'            , src.waiting_90pc_ivl',
'            , src.waiting_max_ivl',
'            , src.waiting_10pc_sec',
'            , src.waiting_50pc_sec',
'            , src.waiting_90pc_sec',
'            , src.waiting_max_sec  ',
'            , src.completed',
'            );',
'  end create_monthly_step_summaries; ',
'',
'  -- quarter step stats',
'',
'  procedure create_quarterly_step_summaries  ',
'  ( p_start_date   in date',
'  )',
'  is',
'  begin',
'    insert into flow_step_stats ',
'        ( stsf_dgrm_id',
'        , stsf_tag_name',
'        , stsf_objt_bpmn_id',
'        , stsf_period_start',
'        , stsf_period',
'        , stsf_duration_10pc_ivl',
'        , stsf_duration_50pc_ivl',
'        , stsf_duration_90pc_ivl',
'        , stsf_duration_max_ivl',
'        , stsf_duration_10pc_sec',
'        , stsf_duration_50pc_sec',
'        , stsf_duration_90pc_sec',
'        , stsf_duration_max_sec',
'        , stsf_waiting_10pc_ivl',
'        , stsf_waiting_50pc_ivl',
'        , stsf_waiting_90pc_ivl',
'        , stsf_waiting_max_ivl',
'        , stsf_waiting_10pc_sec',
'        , stsf_waiting_50pc_sec',
'        , stsf_waiting_90pc_sec',
'        , stsf_waiting_max_sec  ',
'        , stsf_completed',
'        )',
'    with mon as ',
'    (',
'    select stsf_dgrm_id, ',
'           stsf_tag_name,',
'           stsf_objt_bpmn_id,',
'           trunc(stsf_period_start, ''Q'') period_start, ',
'           sum ( ds.stsf_duration_10pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) duration_10pc_sec,',
'           sum ( ds.stsf_duration_50pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) duration_50pc_sec, ',
'           sum ( ds.stsf_duration_90pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) duration_90pc_sec, ',
'           sum ( ds.stsf_duration_max_sec  * ds.stsf_completed ) / sum (ds.stsf_completed) duration_max_sec,',
'           sum ( ds.stsf_waiting_10pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_10pc_sec,',
'           sum ( ds.stsf_waiting_50pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_50pc_sec, ',
'           sum ( ds.stsf_waiting_90pc_sec * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_90pc_sec, ',
'           sum ( ds.stsf_waiting_max_sec  * ds.stsf_completed ) / sum (ds.stsf_completed) waiting_max_sec,',
'           sum ( stsf_completed) stsf_completed',
'     from  flow_step_stats ds',
'    where  ds.stsf_period = ''MONTH''',
'      and  ds.stsf_period_start >= p_start_date',
'    group by stsf_dgrm_id, stsf_tag_name, stsf_objt_bpmn_id, trunc(stsf_period_start, ''Q'')',
'    order by stsf_dgrm_id, stsf_tag_name, stsf_objt_bpmn_id, trunc(stsf_period_start, ''Q'')',
'    )',
'    select mon.stsf_dgrm_id',
'         , mon.stsf_tag_name',
'         , mon.stsf_objt_bpmn_id',
'         , mon.period_start',
'         , ''QUARTER'' as period',
'         , numtodsinterval (mon.duration_10pc_sec , ''SECOND'') as duration_10pc_ivl',
'         , numtodsinterval (mon.duration_50pc_sec , ''SECOND'') as duration_50pc_ivl',
'         , numtodsinterval (mon.duration_90pc_sec , ''SECOND'') as duration_90pc_ivl',
'         , numtodsinterval (mon.duration_max_sec  , ''SECOND'') as duration_max_ivl',
'         , mon.duration_10pc_sec',
'         , mon.duration_50pc_sec',
'         , mon.duration_90pc_sec',
'         , mon.duration_max_sec',
'         , numtodsinterval (mon.waiting_10pc_sec , ''SECOND'') as waiting_10pc_ivl',
'         , numtodsinterval (mon.waiting_50pc_sec , ''SECOND'') as waiting_50pc_ivl',
'         , numtodsinterval (mon.waiting_90pc_sec , ''SECOND'') as waiting_90pc_ivl',
'         , numtodsinterval (mon.waiting_max_sec  , ''SECOND'') as waiting_max_ivl',
'         , mon.waiting_10pc_sec',
'         , mon.waiting_50pc_sec',
'         , mon.waiting_90pc_sec',
'         , mon.waiting_max_sec',
'         , mon.stsf_completed',
'    from mon',
'    where mon.period_start between p_start_date and add_months ( trunc( sys_extract_utc (systimestamp), ''Q'' ), -3)',
'    ;',
'  end create_quarterly_step_summaries;',
'',
'  ------------------',
'  ---  collect daily process stats',
'  -------------------',
'  procedure create_daily_instance_summary',
'  ( p_start_date   in   date',
'  )',
'  is',
'  begin',
'    insert into flow_instance_stats',
'        ( stpr_dgrm_id    ',
'        , stpr_period_start  ',
'        , stpr_period',
'        , stpr_created    ',
'        , stpr_started    ',
'        , stpr_error      ',
'        , stpr_completed  ',
'        , stpr_terminated ',
'        , stpr_reset      ',
'        , stpr_duration_10pc_ivl',
'        , stpr_duration_50pc_ivl',
'        , stpr_duration_90pc_ivl',
'        , stpr_duration_max_ivl ',
'        , stpr_duration_10pc_sec',
'        , stpr_duration_50pc_sec',
'        , stpr_duration_90pc_sec',
'        , stpr_duration_max_sec ',
'        )',
'    with daily_event_completion_times as',
'        (   select lgpr_dgrm_id dgrm_id',
'                 , trunc (sys_extract_utc (lgpr_timestamp )) period_start',
'                 , lgpr_prcs_event event',
'                 , count (*) times',
'                 , approx_percentile (0.10 )',
'                        within group (order by (lgpr_duration) ASC) duration_10pc_ivl',
'                 , approx_percentile (0.50 )',
'                        within group (order by (lgpr_duration) ASC) duration_50pc_ivl',
'                 , approx_percentile (0.90 )',
'                        within group (order by (lgpr_duration) ASC) duration_90pc_ivl',
'                 , max (lgpr_duration) duration_Max_ivl',
'            from flow_instance_event_log lgpr',
'            where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'            group by lgpr_dgrm_id',
'                   , trunc (sys_extract_utc (lgpr_timestamp )) ',
'                   , lgpr_prcs_event',
'            order by lgpr_dgrm_id',
'                   , trunc (sys_extract_utc (lgpr_timestamp )) ',
'                   , lgpr_prcs_event ',
'        ),',
'    prcs_pivot_totals as ',
'        (    select * from ',
'                (select dgrm_id, period_start, event, times ',
'                from daily_event_completion_times',
'                ) tot pivot (sum (times)',
'                for event in ( ''created'' as CREATED, ''started'' as STARTED, ''error'' as ERROR',
'                             , ''completed'' as COMPLETED, ''terminated'' as TERMINATED, ''reset'' as RESET))',
'            order by dgrm_id  ',
'        )',
'    select t.dgrm_id',
'         , t.period_start',
'         , flow_constants_pkg.gc_stats_period_day ',
'         , p.created, p.started, p.error, p.completed, p.terminated, p.reset',
'         , t.duration_10pc_ivl',
'         , t.duration_50pc_ivl',
'         , t.duration_90pc_ivl',
'         , t.duration_Max_ivl',
'         , flow_api_pkg.intervalDStoSec (t.duration_10pc_ivl) duration_10pc_sec',
'         , flow_api_pkg.intervalDStoSec (t.duration_50pc_ivl) duration_50pc_sec',
'         , flow_api_pkg.intervalDStoSec (t.duration_90pc_ivl) duration_90pc_sec',
'         , flow_api_pkg.intervalDStoSec (t.duration_max_ivl ) duration_max_sec',
'     from  prcs_pivot_totals p',
'     join  daily_event_completion_times t',
'       on  t.dgrm_id = p.dgrm_id',
'      and  t.period_start = p.period_start',
'    where  t.event = ''completed''',
'      and  t.period_start between p_start_date and trunc(sysdate)-1',
'    ;',
'  end create_daily_instance_summary;',
'',
'',
'  -- creeate monthly instance summaries',
'  procedure create_monthly_instance_summaries',
'  ( p_start_date in date',
'  )',
'  is',
'  begin',
'    -- now create ''MONTH'' and ''MTD'' summaries for any month that doesn''t yet exist and MTD to current month',
'    merge into flow_instance_stats tgt',
'    using (',
'      with mon as ',
'      (',
'      select stpr_dgrm_id, ',
'             trunc(stpr_period_start, ''MM'') period_start, ',
'             sum (stpr_created) stpr_created,',
'             sum (stpr_started) stpr_started,',
'             sum (stpr_error) stpr_error,',
'             sum (stpr_completed) stpr_completed,',
'             sum (stpr_terminated) stpr_terminated,',
'             sum (stpr_reset) stpr_reset,',
'             sum ( ds.stpr_duration_10pc_sec * ds.stpr_completed ) / sum (ds.stpr_completed) duration_10pc_sec,',
'             sum ( ds.stpr_duration_50pc_sec * ds.stpr_completed ) / sum (ds.stpr_completed) duration_50pc_sec, ',
'             sum ( ds.stpr_duration_90pc_sec * ds.stpr_completed ) / sum (ds.stpr_completed) duration_90pc_sec, ',
'             sum ( ds.stpr_duration_max_sec * ds.stpr_completed  ) / sum (ds.stpr_completed) duration_max_sec',
'      from   flow_instance_stats ds',
'      where  ds.stpr_period = ''DAY''',
'      group by stpr_dgrm_id, trunc(stpr_period_start, ''MM'')',
'      order by stpr_dgrm_id, trunc(stpr_period_start, ''MM'')',
'      )',
'      select mon.stpr_dgrm_id',
'           , mon.period_start as stpr_period_start',
'           , case when mon.period_start = trunc(sys_extract_utc(systimestamp),''MM'') then ''MTD''',
'                  else ''MONTH'' end as stpr_period',
'           , mon.stpr_created',
'           , mon.stpr_started',
'           , mon.stpr_error',
'           , mon.stpr_completed',
'           , mon.stpr_terminated',
'           , mon.stpr_reset',
'           , numtoDSinterval( mon.duration_10pc_sec, ''SECOND'' ) as stpr_duration_10pc_ivl',
'           , numtoDSinterval( mon.duration_50pc_sec, ''SECOND'' ) as stpr_duration_50pc_ivl',
'           , numtoDSinterval( mon.duration_90pc_sec, ''SECOND'' ) as stpr_duration_90pc_ivl',
'           , numtoDSinterval( mon.duration_max_sec , ''SECOND'' ) as stpr_duration_max_ivl',
'           , mon.duration_10pc_sec as stpr_duration_10pc_sec',
'           , mon.duration_50pc_sec as stpr_duration_50pc_sec',
'           , mon.duration_90pc_sec as stpr_duration_90pc_sec',
'           , mon.duration_max_sec  as stpr_duration_max_sec',
'      from mon',
'      where mon.period_start >= trunc(p_start_date,''MM'')',
'      ) src',
'    on (   src.stpr_dgrm_id      = tgt.stpr_dgrm_id    ',
'       and src.stpr_period_start = tgt.stpr_period_start  ',
'       and src.stpr_period       = tgt.stpr_period',
'       )',
'    when matched then ',
'    update set tgt.stpr_created           = src.stpr_created',
'             , tgt.stpr_started           = src.stpr_started',
'             , tgt.stpr_error             = src.stpr_error',
'             , tgt.stpr_completed         = src.stpr_completed',
'             , tgt.stpr_terminated        = src.stpr_terminated',
'             , tgt.stpr_reset             = src.stpr_reset',
'             , tgt.stpr_duration_10pc_ivl = src.stpr_duration_10pc_ivl',
'             , tgt.stpr_duration_50pc_ivl = src.stpr_duration_50pc_ivl',
'             , tgt.stpr_duration_90pc_ivl = src.stpr_duration_90pc_ivl',
'             , tgt.stpr_duration_max_ivl  = src.stpr_duration_max_ivl',
'             , tgt.stpr_duration_10pc_sec = src.stpr_duration_10pc_sec',
'             , tgt.stpr_duration_50pc_sec = src.stpr_duration_50pc_sec',
'             , tgt.stpr_duration_90pc_sec = src.stpr_duration_90pc_sec',
'             , tgt.stpr_duration_max_sec  = src.stpr_duration_max_sec',
'    when not matched then',
'    insert ( tgt.stpr_dgrm_id    ',
'           , tgt.stpr_period_start  ',
'           , tgt.stpr_period',
'           , tgt.stpr_created    ',
'           , tgt.stpr_started    ',
'           , tgt.stpr_error      ',
'           , tgt.stpr_completed  ',
'           , tgt.stpr_terminated ',
'           , tgt.stpr_reset      ',
'           , tgt.stpr_duration_10pc_ivl',
'           , tgt.stpr_duration_50pc_ivl',
'           , tgt.stpr_duration_90pc_ivl',
'           , tgt.stpr_duration_max_ivl ',
'           , tgt.stpr_duration_10pc_sec',
'           , tgt.stpr_duration_50pc_sec',
'           , tgt.stpr_duration_90pc_sec',
'           , tgt.stpr_duration_max_sec ',
'           )',
'    values ( src.stpr_dgrm_id    ',
'           , src.stpr_period_start  ',
'           , src.stpr_period',
'           , src.stpr_created    ',
'           , src.stpr_started    ',
'           , src.stpr_error      ',
'           , src.stpr_completed  ',
'           , src.stpr_terminated ',
'           , src.stpr_reset      ',
'           , src.stpr_duration_10pc_ivl',
'           , src.stpr_duration_50pc_ivl',
'           , src.stpr_duration_90pc_ivl',
'           , src.stpr_duration_max_ivl ',
'           , src.stpr_duration_10pc_sec',
'           , src.stpr_duration_50pc_sec',
'           , src.stpr_duration_90pc_sec',
'           , src.stpr_duration_max_sec ',
'           ) ; ',
'',
'  end create_monthly_instance_summaries;',
'',
'  -- quarter summary',
'',
'  procedure create_quarterly_instance_summaries  ',
'  ( p_start_date   in date',
'  )',
'  is',
'  begin',
'',
'    insert into flow_instance_stats',
'      ( stpr_dgrm_id    ',
'      , stpr_period_start  ',
'      , stpr_period',
'      , stpr_created    ',
'      , stpr_started    ',
'      , stpr_error      ',
'      , stpr_completed  ',
'      , stpr_terminated ',
'      , stpr_reset      ',
'      , stpr_duration_10pc_ivl',
'      , stpr_duration_50pc_ivl',
'      , stpr_duration_90pc_ivl',
'      , stpr_duration_max_ivl ',
'      , stpr_duration_10pc_sec',
'      , stpr_duration_50pc_sec',
'      , stpr_duration_90pc_sec',
'      , stpr_duration_max_sec ',
'      )',
'    with mon as ',
'    (',
'    select stpr_dgrm_id, ',
'         trunc(stpr_period_start, ''Q'') period_start, ',
'         sum (stpr_created) stpr_created,',
'         sum (stpr_started) stpr_started,',
'         sum (stpr_error) stpr_error,',
'         sum (stpr_completed) stpr_completed,',
'         sum (stpr_terminated) stpr_terminated,',
'         sum (stpr_reset) stpr_reset,',
'         sum ( ds.stpr_duration_10pc_sec * ds.stpr_completed ) / sum (ds.stpr_completed) duration_10pc_sec,',
'         sum ( ds.stpr_duration_50pc_sec * ds.stpr_completed ) / sum (ds.stpr_completed) duration_50pc_sec, ',
'         sum ( ds.stpr_duration_90pc_sec * ds.stpr_completed ) / sum (ds.stpr_completed) duration_90pc_sec, ',
'         sum ( ds.stpr_duration_max_sec * ds.stpr_completed  ) / sum (ds.stpr_completed) duration_max_sec',
'    from   flow_instance_stats ds',
'    where  ds.stpr_period = ''MONTH''',
'      and  ds.stpr_period_start >= p_start_date',
'    group by stpr_dgrm_id, trunc(stpr_period_start, ''Q'')',
'    order by stpr_dgrm_id, trunc(stpr_period_start, ''Q'')',
'    )',
'    select mon.stpr_dgrm_id',
'       , mon.period_start',
'       , ''QUARTER'' as period',
'       , mon.stpr_created',
'       , mon.stpr_started',
'       , mon.stpr_error',
'       , mon.stpr_completed',
'       , mon.stpr_terminated',
'       , mon.stpr_reset',
'       , numtoDSinterval( mon.duration_10pc_sec, ''SECOND'' )',
'       , numtoDSinterval( mon.duration_50pc_sec, ''SECOND'' )',
'       , numtoDSinterval( mon.duration_90pc_sec, ''SECOND'' )',
'       , numtoDSinterval( mon.duration_max_sec , ''SECOND'' )',
'       , mon.duration_10pc_sec',
'       , mon.duration_50pc_sec',
'       , mon.duration_90pc_sec',
'       , mon.duration_max_sec',
'    from mon',
'    where mon.period_start between p_start_date and add_months ( trunc( sys_extract_utc (systimestamp), ''Q'' ), -3)',
'    ;',
'',
'  end create_quarterly_instance_summaries;',
'',
'/*-- instance stats query - showing quarterly, monthly and daily summaries',
'',
'-- used to drive process performance history charts on engine app p16',
'--  current day statistics are based on live data',
'--  next previous 6 days summaries ',
'--  current month and previous 3-6 months summary data (depending on where month lies in the quarter)',
'--  quarterly summary data before that for upto 4 quarters',
'--  note that label value is in a specific format so that all of the sets sort into the correct calender order',
'',
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stpr_created,',
'       ist.stpr_started,',
'       ist.stpr_completed,',
'       ist.stpr_error,',
'       ist.stpr_terminated,',
'       ist.stpr_reset,',
'       ist.stpr_duration_10pc_sec,',
'       ist.stpr_duration_50pc_sec,',
'       ist.stpr_duration_90pc_sec,',
'       ist.stpr_duration_max_sec',
'  from summary_dates sd',
'  left join flow_instance_stats ist',
'    on sd.dt     = ist.stpr_period_start',
'   and sd.period = ist.stpr_period',
' where ist.stpr_dgrm_id = :P16_DGRM_ID',
' order by sd.sort_order desc',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysday,''YYYY-MM-DD'')',
'        , 0',
'        , sum ( case lgpr_prcs_event when ''created''    then 1 else 0 end) num_created',
'        , sum ( case lgpr_prcs_event when ''started''    then 1 else 0 end) num_started',
'        , sum ( case lgpr_prcs_event when ''completed''  then 1 else 0 end) num_completed',
'        , sum ( case lgpr_prcs_event when ''error    ''  then 1 else 0 end) num_error',
'        , sum ( case lgpr_prcs_event when ''terminated'' then 1 else 0 end) num_terminated',
'        , sum ( case lgpr_prcs_event when ''reset''      then 1 else 0 end) num_reset',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgpr_duration) ASC)) duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgpr_duration) ASC)) duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgpr_duration) ASC)) duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgpr_duration)) duration_max_sec                                  ',
'         from flow_instance_event_log lgpr',
'        where lgpr.lgpr_prcs_event in (''created'',''started'', ''error'', ''completed'', ''terminated'', ''reset'')',
'        and   trunc (sys_extract_utc(lgpr_timestamp)) = trunc(sysdate)',
'        and  lgpr_dgrm_id = :P16_DGRM_ID',
'        group by lgpr_dgrm_id',
'        order by lgpr_dgrm_id',
';',
'',
'-- step stats query - showing quarterly, monthly and daily summaries',
'',
'-- used to drive process performance history charts on engine app p17',
'--  current day statistics are based on live data',
'--  next previous 6 days summaries ',
'--  current month and previous 3-6 months summary data (depending on where month lies in the quarter)',
'--  quarterly summary data before that for upto 4 quarters',
'--  note that label value is in a specific format so that all of the sets sort into the correct calender order',
'',
'with summary_dates as',
'(',
'    select trunc(sysdate) - 7 + level dt, ''DAY'' as period, 8-level sort_order',
'    from dual',
'    connect by level <= ( sysdate - sysdate +7)',
'    union',
'    select add_months( trunc(sysdate,''MM'')',
'                     , - floor (months_between ( trunc ( sysdate)',
'                                               , trunc ( add_months(sysdate,-6) , ''Q'')',
'                                               ) - 3',
'                                ) + level-1',
'                     )',
'                     ,''MONTH''',
'                     , 10*(7-level)',
'    from dual',
'    connect by level <= ( sysdate - sysdate + floor (months_between ( trunc (sysdate)',
'                                                                    , trunc (add_months ( sysdate ,-6) , ''Q'')',
'                                                                    ) - 2',
'                                                    )',
'                        )',
'    union ',
'    select add_months(trunc(sysdate,''Q''), -3 - (3*level)),''QUARTER'', 100*level',
'    from dual',
'    connect by level <= (sysdate -sysdate +4)',
')',
'select sd.dt, ',
'       sd.period, ',
'       case sd.period',
'          when ''DAY''     then to_char(dt,''YYYY-MM-DD'')',
'          when ''MONTH''   then to_char(dt,''YYYY-MM'')',
'          when ''QUARTER'' then to_char(dt,''YYYY-"0"Q'')',
'       end PeriodLabel,',
'       sd.sort_order,',
'       ist.stsf_completed,',
'       ist.stsf_duration_10pc_sec,',
'       ist.stsf_duration_50pc_sec,',
'       ist.stsf_duration_90pc_sec,',
'       ist.stsf_duration_max_sec,',
'       ist.stsf_waiting_10pc_sec,',
'       ist.stsf_waiting_50pc_sec,',
'       ist.stsf_waiting_90pc_sec,',
'       ist.stsf_waiting_max_sec',
'  from summary_dates sd',
'  left join flow_step_stats ist',
'    on sd.dt     = ist.stsf_period_start',
'   and sd.period = ist.stsf_period',
' where ist.stsf_dgrm_id = :P17_DGRM_ID',
'   and ist.stsf_objt_bpmn_id = :P17_OBJT_BPMN_ID',
'union all',
'   select trunc(sysdate)',
'        , ''DAY''',
'        , to_char (sysdate,''YYYY-MM-DD'')',
'        , 0',
'        , count(lgsf_prcs_id) num_completed',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_completed - lgsf_was_current) ASC))   duration_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_completed - lgsf_was_current)) duration_max_sec                                  ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.10 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_10pc_sec',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.50 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_50pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( approx_percentile (0.90 )',
'               within group (order by (lgsf_started - lgsf_was_current) ASC))   waiting_90pc_sec             ',
'        , flow_api_pkg.intervaldstosec ( max (lgsf_started - lgsf_was_current)) waiting_max_sec           ',
'        from flow_step_event_log lgsf',
'        where trunc (sys_extract_utc(lgsf_completed)) = trunc(sysdate)',
'        and  lgsf_sbfl_dgrm_id = :P17_DGRM_ID',
'        and  lgsf_objt_id = :P17_OBJT_BPMN_ID',
'        group by lgsf_sbfl_dgrm_id, lgsf_objt_id',
'*/',
'',
'  function get_last_successful_summary',
'  ( p_type        flow_stats_history.sths_type%type',
'  , p_operation   flow_stats_history.sths_operation%type',
'  )',
'  return date',
'  is',
'    l_last_successful_summary  date;',
'  begin',
'    select nvl( trunc( max( sths.sths_date)), to_date(''01-JAN-2020'',''DD-MON-YYYY''))',
'        -- deemed start of Flows for APEX epoch!',
'      into l_last_successful_summary',
'      from flow_stats_history sths',
'     where sths.sths_type      = p_type',
'       and sths.sths_operation = p_operation',
'       and sths.sths_status    = flow_constants_pkg.gc_stats_outcome_success',
'    ;',
'    return l_last_successful_summary;',
'  exception',
'    when no_data_found then',
'      return to_date(''01-JAN-2020'',''DD-MON-YYYY''); -- deemed start of Flows for APEX epoch!',
'  end get_last_successful_summary;',
'',
'',
'',
'  procedure create_daily_summaries',
'  ( p_start_date    in  date',
'  )',
'  is',
'  begin',
'    -- creates daily Summaries for all days between last successful run up to yesterday',
'    -- create daily instance summary',
'    create_daily_instance_summary (p_start_date => p_start_date);',
'    -- create daily step summary',
'    create_daily_step_summary (p_start_date => p_start_date);',
'',
'    -- if successful update Stats history',
'    insert into flow_stats_history',
'    ( sths_date ',
'    , sths_status  ',
'    , sths_type',
'    , sths_operation',
'    , sths_errors',
'    , sths_created_on',
'    )',
'    values ',
'    ( trunc(sys_extract_utc(systimestamp))-1',
'    , flow_constants_pkg.gc_stats_outcome_success',
'    , flow_constants_pkg.gc_stats_period_day',
'    , flow_constants_pkg.gc_stats_operation_generate',
'    , null',
'    , systimestamp',
'    );',
'',
'    commit;',
'',
'  end create_daily_summaries;',
'',
'  procedure create_monthly_summaries',
'  is',
'    l_last_summary_date date;',
'    l_start_date        date;',
'  begin',
'    -- creates monthly Summaries for all months between last successful run up to yesterday',
'    -- get last successful quarterly summmary date',
'    l_last_summary_date := get_last_successful_summary ( p_type      => flow_constants_pkg.gc_stats_period_month',
'                                                       , p_operation => flow_constants_pkg.gc_stats_operation_generate',
'                                                       )  ;',
'    l_start_date := l_last_summary_date + 1;                                                   ',
'',
'    -- create monthly instance summary',
'    create_monthly_instance_summaries (p_start_date => l_start_date);',
'    -- create monthly step summary',
'    create_monthly_step_summaries (p_start_date => l_start_date);   ',
'    ',
'    -- if successful update Stats history',
'    insert into flow_stats_history',
'    ( sths_date ',
'    , sths_status  ',
'    , sths_type',
'    , sths_operation',
'    , sths_errors',
'    , sths_created_on',
'    )',
'    values ',
'    ( trunc(sys_extract_utc(systimestamp))-1',
'    , flow_constants_pkg.gc_stats_outcome_success',
'    , flow_constants_pkg.gc_stats_period_month',
'    , flow_constants_pkg.gc_stats_operation_generate',
'    , null',
'    , systimestamp',
'    );',
'',
'    commit;  ',
'        --',
'  end create_monthly_summaries;',
'',
'  procedure create_quarterly_summaries',
'  is',
'    l_last_summary_date                 date;',
'    l_start_date                        date;',
'    l_final_quarter                     date;  -- final quarter start date included in this new summary',
'',
'  begin',
'    -- get last successful quarterly summmary date',
'    l_last_summary_date := get_last_successful_summary ( p_type      => flow_constants_pkg.gc_stats_period_quarter',
'                                                       , p_operation => flow_constants_pkg.gc_stats_operation_generate',
'                                                       );',
'    l_start_date := add_months (l_last_summary_date, 3);',
'    -- create quarterly instance summary',
'    create_quarterly_instance_summaries (p_start_date => l_start_date);',
'    -- create quarterly step summary',
'    create_quarterly_step_summaries (p_start_date => l_start_date);     ',
'    -- set last quarterly summary in hstory',
'    l_final_quarter := add_months( trunc(sysdate,''Q'') , -3);',
'',
'    insert into flow_stats_history',
'    ( sths_date ',
'    , sths_status',
'    , sths_type',
'    , sths_operation',
'    , sths_errors',
'    , sths_created_on',
'    )',
'    values ',
'    ( l_final_quarter',
'    , flow_constants_pkg.gc_stats_outcome_success',
'    , flow_constants_pkg.gc_stats_period_quarter',
'    , flow_constants_pkg.gc_stats_operation_generate',
'    , null',
'    , systimestamp',
'    );',
'',
'    commit;',
'  end create_quarterly_summaries;       ',
'',
'  procedure run_daily_stats',
'  is',
'    l_last_successful_daily             date;',
'    l_last_successful_quarterly         date;',
'    e_daily_summary_generation_error    exception;',
'    e_monthly_summary_generation_error  exception;',
'  begin',
'    begin',
'      -- get last successfully completed day',
'      l_last_successful_daily := get_last_successful_summary ',
'                                       ( p_type => flow_constants_pkg.gc_stats_period_day',
'                                       , p_operation => flow_constants_pkg.gc_stats_operation_generate);',
'      -- make daily summaries from last successfully completed day to yesterday night',
'      create_daily_summaries (p_start_date => l_last_successful_daily +1 );',
'    exception',
'      when others then',
'        raise e_daily_summary_generation_error;',
'    end;',
'    begin',
'    -- run monthly and MTD summary',
'      create_monthly_summaries;',
'    exception',
'      when others then ',
'        raise e_monthly_summary_generation_error;',
'    end;',
'    -- run quarterlies if '))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'required',
'    l_last_successful_quarterly := get_last_successful_summary ',
'                                   ( p_type => flow_constants_pkg.gc_stats_period_quarter',
'                                   , p_operation => flow_constants_pkg.gc_stats_operation_generate);',
'    if trunc(l_last_successful_quarterly,''Q'') != trunc(sysdate,''Q'') then',
'         create_quarterly_summaries ;',
'    end if;',
'  end run_daily_stats;',
'',
'  procedure purge_statistics',
'  is',
'    l_daily_summary_purge_date      date;',
'    l_monthly_summary_purge_date    date;',
'    l_quarterly_summary_purge_date  date;',
'  begin',
'    apex_debug.enter(p_routine_name  => ''purge_statistics'');',
'',
'    l_daily_summary_purge_date      := sysdate - flow_engine_util.get_config_value',
'                                      ( p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_daily ',
'                                      , p_default_value => flow_constants_pkg.gc_config_default_stats_retain_summary_daily   ',
'                                      );',
'    l_monthly_summary_purge_date    := add_months ( sysdate, -1 * flow_engine_util.get_config_value',
'                                                      ( p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_month ',
'                                                      , p_default_value => flow_constants_pkg.gc_config_default_stats_retain_summary_month  ',
'                                                      )',
'                                                  );                                      ',
'    l_quarterly_summary_purge_date  := add_months ( sysdate, -1 * flow_engine_util.get_config_value',
'                                                      ( p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_qtr ',
'                                                      , p_default_value => flow_constants_pkg.gc_config_default_stats_retain_summary_qtr  ',
'                                                      )',
'                                                  );',
'',
'    apex_debug.message',
'    ( p_message => ''Statistics purge starting for daily before %0, monthly before %1 and quarterly before %2''',
'    , p0 => to_char(l_daily_summary_purge_date)',
'    , p1 => to_char(l_monthly_summary_purge_date)',
'    , p2 => to_char(l_quarterly_summary_purge_date)',
'    );',
'    --',
'    begin',
'      -- dailies',
'      delete from flow_instance_stats',
'      where stpr_period = flow_constants_pkg.gc_stats_period_day',
'      and stpr_period_start < l_daily_summary_purge_date;',
'',
'      delete from flow_step_stats',
'      where stsf_period = flow_constants_pkg.gc_stats_period_day',
'      and stsf_period_start < l_daily_summary_purge_date;',
'',
'      -- monthlies',
'      delete from flow_instance_stats',
'      where stpr_period = flow_constants_pkg.gc_stats_period_month',
'      and stpr_period_start < l_monthly_summary_purge_date;',
'',
'      delete from flow_step_stats',
'      where stsf_period = flow_constants_pkg.gc_stats_period_month',
'      and stsf_period_start < l_monthly_summary_purge_date;',
'',
'      -- quarterlies',
'      delete from flow_instance_stats',
'      where stpr_period = flow_constants_pkg.gc_stats_period_quarter',
'      and stpr_period_start < l_quarterly_summary_purge_date;',
'',
'      delete from flow_step_stats',
'      where stsf_period = flow_constants_pkg.gc_stats_period_quarter',
'      and stsf_period_start < l_quarterly_summary_purge_date;',
'      --',
'      insert into flow_stats_history',
'        ( sths_date',
'        , sths_status',
'        , sths_type',
'        , sths_operation',
'        , sths_comments',
'        , sths_created_on',
'        )',
'      values',
'        ( sysdate',
'        , flow_constants_pkg.gc_stats_outcome_success',
'        , flow_constants_pkg.gc_stats_period_day',
'        , flow_constants_pkg.gc_stats_operation_purge',
'        , ''purge completed''',
'        , systimestamp',
'        );        ',
'    end;',
'    exception',
'      when others then',
'        insert into flow_stats_history',
'        ( sths_date',
'        , sths_status',
'        , sths_type',
'        , sths_operation',
'        , sths_comments',
'        , sths_errors',
'        , sths_created_on',
'        )',
'        values',
'        ( sysdate',
'        , flow_constants_pkg.gc_stats_outcome_error',
'        , flow_constants_pkg.gc_stats_period_day',
'        , flow_constants_pkg.gc_stats_operation_purge',
'        , ''error on purge''',
'        , dbms_utility.format_error_stack',
'        , systimestamp',
'        ); ',
'        raise;  ',
'  end purge_statistics;',
'',
'',
'end flow_statistics;',
'/',
'',
'create or replace package body flow_simple_form_template',
'as',
'/* ',
'-- Flows for APEX - flow_simple_form_template.pkb',
'-- ',
'-- (c) Copyright Hyand, 2024',
'--',
'-- Created  20-Aug-2024  Dennis Amthor - Hyand',
'--',
'*/',
'  function create_template(',
'    pi_sfte_name      in flow_simple_form_templates.sfte_name%type',
'  , pi_sfte_static_id in flow_simple_form_templates.sfte_static_id%type',
'  , pi_sfte_content   in flow_simple_form_templates.sfte_content%type)',
'  return flow_simple_form_templates.sfte_id%type',
'  as',
'    l_template_exists binary_integer;',
'    l_sfte_id flow_simple_form_templates.sfte_id%type;',
'  begin',
'    select count(*)',
'      into l_template_exists',
'      from dual',
'     where exists(',
'           select null',
'             from flow_simple_form_templates',
'            where sfte_static_id = pi_sfte_static_id);',
'',
'    if l_template_exists = 0 then',
'      insert into flow_simple_form_templates',
'        (sfte_name, sfte_static_id, sfte_content)',
'      values',
'        (pi_sfte_name, pi_sfte_static_id, pi_sfte_content)',
'      returning',
'        sfte_id into l_sfte_id;',
'    else',
'      raise template_exists;',
'    end if;',
'    return l_sfte_id;',
'',
'  end create_template;',
'  ',
'  ',
'  procedure edit_template(',
'    pi_sfte_id        in flow_simple_form_templates.sfte_id%type',
'  , pi_sfte_name      in flow_simple_form_templates.sfte_name%type',
'  , pi_sfte_static_id in flow_simple_form_templates.sfte_static_id%type',
'  , pi_sfte_content   in flow_simple_form_templates.sfte_content%type)',
'  as',
'  begin',
'    update flow_simple_form_templates',
'       set sfte_name = pi_sfte_name',
'         , sfte_static_id = pi_sfte_static_id',
'         , sfte_content = pi_sfte_content',
'     where sfte_id = pi_sfte_id;',
'',
'  end edit_template;',
'',
'',
'  procedure delete_template(',
'    pi_sfte_id in flow_simple_form_templates.sfte_id%type)',
'  as',
'  begin',
'    delete from flow_simple_form_templates ',
'     where sfte_id = pi_sfte_id;',
'',
'  end delete_template;',
'',
'end flow_simple_form_template;',
'/',
'',
'create or replace package body flow_rest',
'as',
'',
'  req_apex_host  varchar2(4000);',
'',
'  function get_apex_host',
'    return varchar2',
'  as',
'  begin',
'    return req_apex_host;',
'  end get_apex_host;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure set_apex_host',
'  as',
'  begin',
'',
'    req_apex_host := flow_rest.get_config_value( pi_key => flow_rest_constants.c_config_key_base);',
'',
'    if req_apex_host is null then',
'      begin',
'        req_apex_host :=  owa_util.get_cgi_env(''X-APEX-BASE'');',
'      exception',
'        when others then ',
'          null;',
'      end;',
'    end if;',
'',
'    if req_apex_host is not null and trim(req_apex_host) not like ''%/'' then',
'      req_apex_host := req_apex_host || ''/'';',
'    end if;',
'    ',
'  end set_apex_host;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_config_value( pi_key  flow_configuration.cfig_key%type )',
'    return flow_configuration.cfig_value%type',
'  as',
'    l_key    flow_configuration.cfig_key%type := flow_rest_constants.c_config_prefix || pi_key;',
'    l_value  flow_configuration.cfig_value%type;',
'  begin ',
'    select cfig_value',
'      into l_value',
'      from flow_configuration ',
'      where cfig_key = l_key;',
'    return l_value;',
'  end get_config_value;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'  ',
'  procedure initialize( pi_client_id varchar2',
'                      , pi_method    varchar2 ',
'                      , pi_endpoint  varchar2 )',
'  as',
'    l_check_privilege  varchar2(50 char);',
'  begin',
'',
'    case upper(pi_method) ',
'      when ''POST'' then',
'        l_check_privilege := flow_rest_constants.c_rest_priv_write;',
'      when ''PUT''  then         ',
'        if regexp_like(pi_endpoint, ''^v1/messages/[[:alnum:][:blank:][:punct:]]+$'', ''i'') then',
'          l_check_privilege := flow_rest_constants.c_rest_priv_messages;',
'        else',
'          l_check_privilege := flow_rest_constants.c_rest_priv_write;',
'        end if;',
'      when ''DELETE'' then ',
'        l_check_privilege := flow_rest_constants.c_rest_priv_admin;',
'    end case;',
'',
'    flow_rest.initialize( pi_client_id        => pi_client_id',
'                        , pi_check_privilege  => l_check_privilege ) ;             ',
'',
'  end initialize;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure initialize( pi_client_id        varchar2',
'                      , pi_check_privilege  varchar2 )',
'  as',
'  begin',
'',
'    flow_rest_logging.initialize;',
'',
'    set_apex_host;',
'',
'    flow_globals.set_call_origin( p_origin => flow_rest_constants.c_config_origin );',
'',
'    owa_util.mime_header (''application/json'', true); ',
'',
'    flow_rest_auth.check_privilege( pi_client_id       => pi_client_id ',
'                                  , pi_privilege_name  => pi_check_privilege );                              ',
'',
'  end initialize;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure cleanup',
'  as',
'  begin',
'',
'    flow_globals.unset_call_origin;',
'    flow_rest_logging.cleanup;',
'',
'  end cleanup;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function blob_to_json( pi_body  blob )',
'    return json_element_t',
'  as',
'    l_ret_json  json_element_t;',
'  begin',
'    ',
'      if pi_body is not null and dbms_lob.getLength( pi_body ) > 0 then     ',
'          l_ret_json := json_element_t.parse(pi_body); ',
'      else',
'        l_ret_json := json_object_t();',
'      end if;    ',
'    ',
'    return l_ret_json;',
'',
'    exception',
'      when others then ',
'        raise flow_rest_constants.e_payload_processing;',
'',
'  end blob_to_json; ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure add_error( pio_object_jo in out nocopy json_object_t ',
'                     , pi_error_type in varchar2',
'                     , pi_error_msg  in varchar2 )',
'  as',
'    l_error_jo   json_object_t;',
'    l_errors_ja  json_array_t;',
'  begin',
'',
'    if not pio_object_jo.has(flow_rest_constants.c_json_errors_key) then',
'      pio_object_jo.put(flow_rest_constants.c_json_errors_key, new json_array_t() );',
'    end if;',
'',
'    l_error_jo := new json_object_t();',
'    l_error_jo.put( flow_rest_constants.c_json_error_type, pi_error_type );',
'    l_error_jo.put( flow_rest_constants.c_json_error_value, pi_error_msg );',
'',
'    l_errors_ja := pio_object_jo.get_Array(flow_rest_constants.c_json_errors_key);',
'    l_errors_ja.append(l_error_jo);',
'  end add_error;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_json_array_t( pi_json_object_t  json_object_t)',
'    return json_array_t',
'  as',
'    l_json_array_t  json_array_t;',
'  begin',
'    l_json_array_t := new json_array_t();',
'    l_json_array_t.append( pi_json_object_t );',
'    return l_json_array_t;',
'  end get_json_array_t;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure verify_and_prepare_payload( pi_payload         json_element_t ',
'                                      , pi_array_allowed   boolean ',
'                                      , po_payload_object  out json_object_t',
'                                      , po_payload_array   out json_array_t )',
'  as',
'  begin',
'  ',
'    if pi_payload.is_Object then',
'',
'      po_payload_object := treat(pi_payload as json_object_t);',
'      po_payload_array  := new json_array_t;',
'      po_payload_array.append( po_payload_object );',
'',
'    elsif pi_payload.is_Array then  ',
'',
'      if not pi_array_allowed then ',
'        raise flow_rest_constants.e_multiple_object_error;',
'      end if;',
'      po_payload_array := treat(pi_payload as json_array_t);',
'',
'    else',
'      raise flow_rest_constants.e_payload_not_acceptable;',
'    end if;',
'',
'  end verify_and_prepare_payload;       ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure verify_and_prepare_payload( pi_payload         json_element_t ',
'                                      , pi_array_allowed   boolean ',
'                                      , po_payload_object  out json_object_t)',
'  as',
'    po_payload_array json_array_t;',
'  begin',
'',
'    verify_and_prepare_payload( pi_payload              => pi_payload',
'                              , pi_array_allowed        => pi_array_allowed',
'                              , po_payload_object       => po_payload_object',
'                              , po_payload_array        => po_payload_array );',
'    ',
'',
'  end verify_and_prepare_payload;   ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure verify_and_prepare_payload( pi_payload         json_element_t ',
'                                      , pi_array_allowed   boolean ',
'                                      , po_payload_array   out json_array_t)',
'  as',
'    po_payload_object json_object_t;',
'  begin',
'',
'    verify_and_prepare_payload( pi_payload              => pi_payload',
'                              , pi_array_allowed        => pi_array_allowed',
'                              , po_payload_object       => po_payload_object',
'                              , po_payload_array        => po_payload_array );',
'    ',
'',
'  end verify_and_prepare_payload;   ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function chk_attributes_exist( pio_object_jo       in out nocopy json_object_t',
'                               , pi_attributes_list  varchar2',
'                               , pi_add_error_msg    boolean default true )',
'    return boolean',
'  as',
'    l_attribute_exists  boolean := true;',
'  begin',
'    for rec_attributes in (select column_value as name ',
'                             from apex_string.split( pi_attributes_list',
'                                                   , flow_rest_constants.c_split_sep ))',
'    loop',
'      if pio_object_jo.get(rec_attributes.name) is null then',
'',
'        l_attribute_exists := false;',
'',
'        if pi_add_error_msg then',
'          add_error( pio_object_jo => pio_object_jo',
'                   , pi_error_type => flow_rest_constants.c_json_error_type_missing_attr',
'                   , pi_error_msg  => rec_attributes.name );',
'        end if;',
'',
'      end if;',
'    end loop;',
'',
'    return l_attribute_exists;',
'',
'  end chk_attributes_exist;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure verify_diagram_exists( pi_dgrm_id       flow_diagrams.dgrm_id%type',
'                                 , pi_dgrm_version  flow_diagrams.dgrm_version%type default null )',
'  as',
'    l_check  number; ',
'  begin',
'    select 1',
'      into l_check ',
'      from flow_diagrams',
'      where dgrm_id = pi_dgrm_id ',
'        and dgrm_version = nvl(pi_dgrm_version, dgrm_version)',
'      fetch first 1 rows only;',
'',
'    exception ',
'      when no_data_found then',
'        raise flow_rest_constants.e_item_not_found;',
'',
'  end verify_diagram_exists;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure verify_process_exists( pi_prcs_id  flow_processes.prcs_id%type )',
'  as',
'    l_check  number; ',
'  begin',
'    select 1',
'      into l_check ',
'      from flow_processes',
'      where prcs_id = pi_prcs_id;',
'',
'    exception ',
'      when no_data_found then',
'        raise flow_rest_constants.e_item_not_found;',
'',
'  end verify_process_exists;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure verify_subflow_exists( pi_sbfl_id  flow_subflows.sbfl_id%type )',
'  as',
'    l_check  number; ',
'  begin',
'    select 1',
'      into l_check ',
'      from flow_subflows',
'      where sbfl_id = pi_sbfl_id;',
'',
'    exception ',
'      when no_data_found then',
'        raise flow_rest_constants.e_item_not_found;',
'',
'  end verify_subflow_exists;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_process_id( p_sbfl_id  flow_subflows.sbfl_id%type )',
'    return flow_processes.prcs_id%type',
'  is',
'    l_prcs_id  flow_processes.prcs_id%type;',
'  begin',
'    select sbfl_prcs_id ',
'      into l_prcs_id',
'      from flow_subflows',
'      where sbfl_id = p_sbfl_id;',
'    return l_prcs_id;',
'  end get_process_id;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'  ',
'  function get_process_id( pi_message_name   flow_message_subscriptions.msub_message_name%type',
'                         , pi_msub_key_name  flow_message_subscriptions.msub_key_name%type',
'                         , pi_msub_key_value flow_message_subscriptions.msub_key_value%type )',
'    return flow_processes.prcs_id%type',
'  is',
'    l_prcs_id  flow_processes.prcs_id%type;',
'  begin',
'    select msub_prcs_id ',
'      into l_prcs_id',
'      from flow_message_subscriptions',
'      where msub_message_name = pi_message_name',
'        and msub_key_name     = pi_msub_key_name',
'        and msub_key_value    = pi_msub_key_value;',
'    return l_prcs_id;',
'  end get_process_id;',
'  ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_step_key( p_sbfl_id  flow_subflows.sbfl_id%type )',
'    return flow_subflows.sbfl_step_key%type',
'  is',
'    l_step_key  flow_subflows.sbfl_step_key%type;',
'  begin',
'    select sbfl_step_key',
'      into l_step_key',
'      from flow_subflows',
'      where sbfl_id = p_sbfl_id;',
'    return l_step_key;',
'  end get_step_key;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure process_status_update( pi_prcs_id   flow_processes.prcs_id%type ',
'                                 , pi_payload   in out nocopy json_object_t )',
'  as',
'  begin',
'',
'    if not chk_attributes_exist( pio_object_jo       => pi_payload',
'                               , pi_attributes_list  => flow_rest_constants.c_check_attr_process_update',
'                               , pi_add_error_msg    => true ) ',
'    then',
'      raise flow_rest_constants.e_attribute_not_found;',
'    end if;',
'',
'    case lower(pi_payload.get_string( ''status'' ))',
'      when flow_rest_constants.c_process_status_start then',
'        flow_api_pkg.flow_start( p_process_id => pi_prcs_id );',
'',
'      when flow_rest_constants.c_process_status_reset then',
'        flow_api_pkg.flow_reset( p_process_id => pi_prcs_id',
'                               , p_comment    => pi_payload.get_string( ''comment'' ));',
'',
'      when flow_rest_constants.c_process_status_terminate then',
'        flow_api_pkg.flow_terminate( p_process_id  => pi_prcs_id',
'                                   , p_comment     => pi_payload.get_string( ''comment'' ));    ',
'',
'      else',
'        raise flow_rest_constants.e_process_unknown_status;',
'    end case;',
'',
'  end process_status_update;                          ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure process_vars_update( pi_prcs_id    flow_processes.prcs_id%type ',
'                               , pio_prov_arr  in out nocopy json_array_t ',
'                               , pi_add_error_msg   boolean default true )',
'  as ',
'    l_prov_object  json_object_t;',
'    l_error_occured boolean := false;',
'  begin',
'',
'    verify_process_exists( pi_prcs_id => pi_prcs_id );',
'',
'    for idx_json in 0..pio_prov_arr.get_size-1',
'    loop',
'      begin',
'        l_prov_object := treat(pio_prov_arr.get(idx_json) as json_object_t);',
'',
'        if not chk_attributes_exist( pio_object_jo       => l_prov_object',
'                                   , pi_attributes_list  => flow_rest_constants.c_check_attr_process_var_update',
'                                   , pi_add_error_msg    => pi_add_error_msg ) ',
'        then',
'          raise flow_rest_constants.e_attribute_not_found;',
'        end if;',
'',
'        if not l_prov_object.has( flow_rest_constants.c_json_prov_sbfl_id ) then',
'          case lower( l_prov_object.get_string( flow_rest_constants.c_json_prov_type ) )',
'            when flow_rest_constants.c_pvar_type_varchar then',
'              flow_process_vars.set_var( pi_prcs_id   => pi_prcs_id',
'                                       , pi_var_name  => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_scope     => nvl( l_prov_object.get_string( flow_rest_constants.c_json_prov_scope ), 0)',
'                                       , pi_vc2_value => l_prov_object.get_string( flow_rest_constants.c_json_prov_value ) );',
'            when flow_rest_constants.c_pvar_type_number then',
'              flow_process_vars.set_var( pi_prcs_id   => pi_prcs_id',
'                                       , pi_var_name  => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_scope     => nvl( l_prov_object.get_string( flow_rest_constants.c_json_prov_scope ), 0)',
'                                       , pi_num_value => to_number(l_prov_object.get_string( flow_rest_constants.c_json_prov_value )) );',
'            when flow_rest_constants.c_pvar_type_date then',
'              flow_process_vars.set_var( pi_prcs_id    => pi_prcs_id',
'                                       , pi_var_name   => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_scope      => nvl( l_prov_object.get_string( flow_rest_constants.c_json_prov_scope ), 0)',
'                                       , pi_date_value => to_date(l_prov_object.get_string( flow_rest_constants.c_json_prov_value )) );',
'            when flow_rest_constants.c_pvar_type_clob then',
'              flow_process_vars.set_var( pi_prcs_id    => pi_prcs_id',
'                                       , pi_var_name   => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_scope      => nvl( l_prov_object.get_string( flow_rest_constants.c_json_prov_scope ), 0)',
'                                       , pi_clob_value => to_clob(l_prov_object.get_string( flow_rest_constants.c_json_prov_value )) );',
'          end case;',
'        else',
'          case lower( l_prov_object.get_string( flow_rest_constants.c_json_prov_type ) )',
'            when flow_rest_constants.c_pvar_type_varchar then',
'              flow_process_vars.set_var( pi_prcs_id   => pi_prcs_id',
'                                       , pi_var_name  => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_sbfl_id   => l_prov_object.get_number( flow_rest_constants.c_json_prov_sbfl_id )',
'                                       , pi_vc2_value => l_prov_object.get_string( flow_rest_constants.c_json_prov_value ) );',
'            when flow_rest_constants.c_pvar_type_number then',
'              flow_process_vars.set_var( pi_prcs_id   => pi_prcs_id',
'                                       , pi_var_name  => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_sbfl_id   => l_prov_object.get_number( flow_rest_constants.c_json_prov_sbfl_id )',
'                                       , pi_num_value => to_number(l_prov_object.get_string( flow_rest_constants.c_json_prov_value )) );',
'            when flow_rest_constants.c_pvar_type_date then',
'              flow_process_vars.set_var( pi_prcs_id    => pi_prcs_id',
'                                       , pi_var_name   => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_sbfl_id    => l_prov_object.get_number( flow_rest_constants.c_json_prov_sbfl_id )',
'                                       , pi_date_value => to_date(l_prov_object.get_string( flow_rest_constants.c_json_prov_value )) );',
'            when flow_rest_constants.c_pvar_type_clob then',
'              flow_process_vars.set_var( pi_prcs_id    => pi_prcs_id',
'                                       , pi_var_name   => l_prov_object.get_string( flow_rest_constants.c_json_prov_name )',
'                                       , pi_sbfl_id    => l_prov_object.get_number( flow_rest_constants.c_json_prov_sbfl_id )',
'                                       , pi_clob_value => to_clob(l_prov_object.get_string( flow_rest_constants.c_json_prov_value )) );',
'          end case;',
'        end if;',
'',
'',
'      exception ',
'        when flow_rest_constants.e_attribute_not_found then',
'          l_error_occured := true;     ',
'        when others then ',
'          l_error_occured := true;',
'          if pi_add_error_msg then ',
'            add_error( pio_object_jo  => l_prov_object',
'                     , pi_error_type  => flow_rest_constants.c_json_error_type_processing_error',
'                     , pi_error_msg   => SQLERRM );',
'          end if;',
'      end;',
'    ',
'    end loop;',
'',
'    if l_error_occured then ',
'      raise flow_rest_constants.e_processing_error;',
'    end if;',
'',
'  end process_vars_update;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure process_vars_delete( pi_prcs_id    flow_processes.prcs_id%type ',
'                               , pio_prov_arr  in out nocopy json_array_t ',
'                               , pi_add_error_msg   boolean default true )',
'  as ',
'    l_prov_object    json_object_t;',
'    l_error_occured  boolean := false;',
'  begin',
'',
'    verify_process_exists( pi_prcs_id => pi_prcs_id );',
'',
'    for idx_json in 0..pio_prov_arr.get_size-1',
'    loop',
'      begin',
'        l_prov_object := treat(pio_prov_arr.get(idx_json) as json_object_t);',
'',
'        -- check if necessary parameters exists',
'        if not chk_attributes_exist( pio_object_jo       => l_prov_object',
'                                   , pi_attributes_list  => flow_rest_constants.c_check_attr_process_var_delete',
'                                   , pi_add_error_msg    => pi_add_error_msg ) ',
'        then',
'          raise flow_rest_constants.e_attribute_not_found;',
'        end if;',
'',
'        if not l_prov_object.has(''sbfl_id'') then',
'          flow_process_vars.delete_var( pi_prcs_id   => pi_prcs_id',
'                                      , pi_scope     => nvl( l_prov_object.get_string(''scope''), 0) ',
'                                      , pi_var_name  => l_prov_object.get_string(''name'') );',
'        else',
'          flow_process_vars.delete_var( pi_prcs_id   => pi_prcs_id',
'                                      , pi_sbfl_id   => l_prov_object.get_number(''sbfl_id'')',
'                                      , pi_var_name  => l_prov_object.get_string(''name'') );',
'        end if;',
'',
'        exception ',
'        when flow_rest_constants.e_attribute_not_found then',
'          l_error_occured := true;     ',
'        when others then ',
'          l_error_occured := true;',
'          if pi_add_error_msg then ',
'            add_error( pio_object_jo  => l_prov_object',
'                     , pi_error_type  => flow_rest_constants.c_json_error_type_processing_error',
'                     , pi_error_msg   => SQLERRM );',
'          end if;',
'      end;',
'    end loop;         ',
'                      ',
'    if l_error_occured then ',
'      raise flow_rest_constants.e_processing_error;',
'    end if;',
'',
'  end process_vars_delete;',
'  ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure step_update( pi_sbfl_id  flow_subflows.sbfl_id%type',
'                       , pi_payload   in out nocopy json_object_t )',
'  as',
'  begin',
'',
'    verify_subflow_exists( pi_sbfl_id => pi_sbfl_id );',
'    ',
'    if not chk_attributes_exist(pio_object_jo      => pi_payload',
'                              , pi_attributes_list => flow_rest_constants.c_check_attr_step_update',
'                              , pi_add_error_msg   => true)',
'    then ',
'      raise flow_rest_constants.e_attribute_not_found;',
'    end if; ',
'',
'    case lower( pi_payload.get_string(flow_rest_constants.c_step_status_status) )',
'      when flow_rest_constants.c_step_status_start then',
'        flow_api_pkg.flow_start_step( p_process_id => get_process_id( p_sbfl_id => pi_sbfl_id )',
'                                    , p_subflow_id => pi_sbfl_id ',
'                                    , p_step_key   => pi_payload.get_string(''step_key'') );',
'      when flow_rest_constants.c_step_status_reserve then',
'        flow_api_pkg.flow_reserve_step( p_process_id  => get_process_id( p_sbfl_id => pi_sbfl_id )',
'                                      , p_subflow_id  => pi_sbfl_id ',
'                                      , p_step_key    => pi_payload.get_string(''step_key'')',
'                                      , p_reservation => pi_payload.get_string(''reservation'') );',
'      when flow_rest_constants.c_step_status_release then',
'        flow_api_pkg.flow_release_step( p_process_id =>'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' get_process_id( p_sbfl_id => pi_sbfl_id )',
'                                      , p_subflow_id => pi_sbfl_id',
'                                      , p_step_key   => pi_payload.get_string(''step_key'') );',
'      when flow_rest_constants.c_step_status_complete then',
'        flow_api_pkg.flow_complete_step( p_process_id  => get_process_id( p_sbfl_id => pi_sbfl_id )',
'                                        , p_subflow_id  => pi_sbfl_id',
'                                        , p_step_key    => pi_payload.get_string(''step_key'') );',
'      when flow_rest_constants.c_step_status_restart then',
'        flow_api_pkg.flow_restart_step( p_process_id  => get_process_id( p_sbfl_id => pi_sbfl_id )',
'                                      , p_subflow_id  => pi_sbfl_id',
'                                      , p_step_key    => pi_payload.get_string(''step_key'') );',
'      when flow_rest_constants.c_step_status_reschedule_timer then',
'        flow_api_pkg.flow_reschedule_timer( p_process_id    => get_process_id( p_sbfl_id => pi_sbfl_id )',
'                                          , p_subflow_id    => pi_sbfl_id',
'                                          , p_step_key      => pi_payload.get_string(''step_key'')',
'                                          , p_is_immediate  => pi_payload.get_boolean(''is_immediate'') ',
'                                          , p_new_timestamp => cast(pi_payload.get_date(''new_timestamp'') as timestamp)',
'                                          , p_comment       => pi_payload.get_string(''comment'') );',
'      else',
'        raise flow_rest_constants.e_step_unknown_operation;',
'    end case;',
'',
'  end step_update;                       ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure messages_update( pi_message_name   flow_message_subscriptions.msub_message_name%type ',
'                           , pi_msg_arr        in out nocopy json_array_t )',
'  as ',
'    l_msg_object  json_object_t;',
'    l_error_occured boolean := false;',
'  begin',
'',
'    for idx_json in 0..pi_msg_arr.get_size-1',
'    loop',
'      begin',
'        l_msg_object := treat(pi_msg_arr.get(idx_json) as json_object_t);',
'',
'        -- check if necessary parameters exists',
'        if not chk_attributes_exist(pio_object_jo      => l_msg_object',
'                                  , pi_attributes_list => flow_rest_constants.c_check_attr_message_update',
'                                  , pi_add_error_msg   => true)',
'        then ',
'          raise flow_rest_constants.e_attribute_not_found;',
'        end if;',
'',
'        flow_api_pkg.receive_message( p_message_name  => pi_message_name',
'                                    , p_key_name      => l_msg_object.get_string(''key'')',
'                                    , p_key_value     => l_msg_object.get_string(''value'')',
'                                    , p_payload       => l_msg_object.get_clob(''payload'') );',
'',
'        exception ',
'            when flow_rest_constants.e_attribute_not_found then ',
'              l_error_occured := true;',
'      end;',
'    end loop;',
'',
'    if l_error_occured then ',
'      raise flow_rest_constants.e_processing_error;',
'    end if;',
'',
'  end messages_update;',
'  ',
'',
'end flow_rest;',
'/',
'',
'create or replace package body flow_rest_auth',
'as',
'',
'  function get_rest_roles',
'    return flow_rest_roles_nt',
'    pipelined',
'  as',
'    l_roles apex_application_global.vc_arr2;  ',
'  begin',
'',
'    l_roles(1) := flow_rest_constants.c_rest_role_read;',
'    l_roles(2) := flow_rest_constants.c_rest_role_write;',
'    l_roles(3) := flow_rest_constants.c_rest_role_admin;',
'    l_roles(4) := flow_rest_constants.c_rest_role_messages;',
'',
'    for rec_roles in (select id, name ',
'                        from user_ords_roles ',
'                        where name in (select column_value from table(l_roles)))',
'    loop',
'      PIPE ROW (flow_rest_auth.flow_rest_role_ot ( rec_roles.id, rec_roles.name ));',
'    end loop;',
'    return;',
'',
'  end get_rest_roles;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_client_id( pi_name  user_ords_clients.name%type )',
'    return user_ords_clients.id%type',
'  as',
'    l_id  user_ords_clients.id%type;',
'  begin',
'    select id ',
'      into l_id ',
'      from user_ords_clients',
'      where name = pi_name;',
'    return l_id;',
'  end get_client_id;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_client_roles( pi_id   user_ords_clients.id%type )',
'    return apex_application_global.vc_arr2',
'  as',
'    l_roles  apex_application_global.vc_arr2;',
'  begin',
'    select role_id ',
'      bulk collect into l_roles',
'      from user_ords_client_roles',
'      where client_id = pi_id;',
'    return l_roles;',
'  end get_client_roles;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function has_privilege( pi_client_id       varchar2 -- client_id is returned by implicit parameter :current_user',
'                        , pi_privilege_name  varchar2)',
'    return boolean',
'  as',
'    l_check number;',
'  begin',
'',
'    select count(1)',
'      into l_check',
'      from user_ords_clients oc ',
'      join user_ords_client_roles ocr on oc.id = ocr.client_id',
'      join user_ords_privilege_roles opr on ocr.role_id = opr.role_id',
'      where oc.client_id = pi_client_id',
'        and opr.privilege_name = pi_privilege_name;',
'',
'    if l_check > 0 then',
'      return true;',
'    else',
'      return false;',
'    end if;',
'',
'  end has_privilege;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function has_privilege_read( pi_client_id       varchar2)',
'    return number',
'  as',
'  begin',
'',
'    if has_privilege( pi_client_id       => pi_client_id',
'                    , pi_privilege_name  => flow_rest_constants.c_rest_priv_read)',
'    then ',
'      return 1;',
'    else',
'      return 0;',
'    end if;',
'',
'  end has_privilege_read;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function has_privilege_admin( pi_client_id       varchar2)',
'    return number',
'  as',
'  begin',
'',
'    if has_privilege( pi_client_id       => pi_client_id',
'                    , pi_privilege_name  => flow_rest_constants.c_rest_priv_admin)',
'    then ',
'      return 1;',
'    else',
'      return 0;',
'    end if;',
'',
'  end has_privilege_admin;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure check_privilege( pi_client_id       varchar2 -- client_id is returned by implicit parameter :current_user',
'                           , pi_privilege_name  varchar2 )',
'  as',
'  begin',
'',
'    if not has_privilege( pi_client_id      => pi_client_id ',
'                        , pi_privilege_name => pi_privilege_name )',
'    then ',
'      raise flow_rest_constants.e_privilege_not_granted;',
'    end if;',
'',
'  end check_privilege;                       ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure create_client( pi_name           varchar2',
'                         , pi_owner          varchar2',
'                         , pi_description    varchar2',
'                         , pi_support_email  varchar2',
'                         , pi_support_uri    varchar2 )',
'  as',
'  begin   ',
'    OAUTH.CREATE_CLIENT( p_name            => pi_name,',
'                         p_grant_type      => flow_rest_constants.c_rest_grant_type,',
'                         p_owner           => pi_owner,',
'                         p_description     => pi_description,',
'                         p_support_email   => pi_support_email,',
'                         p_support_uri     => pi_support_uri,',
'                         p_privilege_names => flow_rest_constants.c_rest_priv_access );',
'  end create_client;                     ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'  procedure update_client_roles( pi_id     user_ords_clients.id%type',
'                               , pi_roles  apex_application_global.vc_arr2)',
'  as',
'    l_client_name  user_ords_clients.name%type;',
'',
'    cursor c_update_roles is  ',
'        with cur_roles as (',
'          select ocr.role_id   as cur_role_id',
'                , ocr.role_name as cur_role_name',
'            from user_ords_clients c ',
'            join user_ords_client_roles ocr on c.id = ocr.client_id',
'            where c.id = pi_id ),',
'          set_roles as (',
'              select uor.id  as set_role_id',
'                    , uor.name as set_role_name',
'                from table(pi_roles) t',
'                join user_ords_roles uor on t.column_value = uor.id )',
'        select cur_role_id',
'              , cur_role_name',
'              , set_role_id',
'              , set_role_name',
'          from cur_roles ocr_cur',
'          full outer join set_roles sr on ocr_cur.cur_role_id = sr.set_role_id ;',
'',
'    procedure get_client_name',
'    as',
'    begin',
'      select name ',
'        into l_client_name ',
'        from user_ords_clients',
'        where id = pi_id;',
'    end;',
'  begin',
'',
'    get_client_name;',
'',
'    for rec_update_roles in c_update_roles',
'    loop',
'',
'      if    rec_update_roles.cur_role_id is not null ',
'        and rec_update_roles.set_role_id is null ',
'      then ',
'        ',
'        oauth.revoke_client_role( p_client_name => l_client_name',
'                                , p_role_name   => rec_update_roles.cur_role_name );',
'',
'      elsif rec_update_roles.cur_role_id is null ',
'        and rec_update_roles.set_role_id is not null ',
'      then ',
'        apex_debug.info(''add role %s to client %s'', rec_update_roles.cur_role_name, l_client_name);',
'        oauth.grant_client_role( p_client_name => l_client_name',
'                               , p_role_name   => rec_update_roles.set_role_name );',
'',
'      end if; ',
'',
'    end loop;',
'',
'  end update_client_roles;                         ',
'',
'end flow_rest_auth;',
'/',
'',
'create or replace package body flow_rest_logging',
'as',
'',
'  req_call_guid  raw(16);',
'  req_method     varchar2(10);',
'  req_endpoint   varchar2(2000);',
'  req_client_id  varchar2(200);',
'  req_token      varchar2(200);',
'',
'  req_log_rest_incoming varchar2(1);',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure initialize',
'  as',
'  begin',
'    req_call_guid  := sys_guid();',
'    req_method     := owa_util.get_cgi_env(''REQUEST_METHOD'');',
'    req_endpoint   := owa_util.get_cgi_env(''X-APEX-PATH'');',
'    req_client_id  := owa_util.get_cgi_env(''REMOTE_USER'');',
'    req_token      := replace(owa_util.get_cgi_env(''Authorization''),''Bearer '');',
'    ',
'    req_log_rest_incoming := flow_engine_util.get_config_value( p_config_key     => flow_rest_logging.c_log_rest_incoming',
'                                                              , p_default_value  => flow_rest_logging.c_log_rest_incoming_default );',
'',
'  end initialize;',
'  ',
'  procedure cleanup',
'  as',
'  begin',
'    req_call_guid  := null;',
'    req_method     := null;',
'    req_endpoint   := null;',
'    req_client_id  := null;',
'    req_token      := null;',
'    req_log_rest_incoming := null;',
'  end cleanup;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function is_event_log_enabled',
'    return boolean',
'  as',
'  begin',
'',
'    if nvl(req_log_rest_incoming, ''Y'') = ''Y'' then',
'      return true;',
'    end if;',
'',
'    return false;',
'    ',
'  end is_event_log_enabled;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure enter( pi_payload          json_element_t ',
'                 )',
'  as',
'    PRAGMA AUTONOMOUS_TRANSACTION;',
'    l_payload_clob  clob;',
'  begin',
'    ',
'    if is_event_log_enabled ',
'    then',
'',
'      l_payload_clob := pi_payload.to_clob;',
'',
'      INSERT INTO flow_rest_event_log (',
'          lgrt_call_guid',
'        , lgrt_client_id',
'        , lgrt_log_info',
'        , lgrt_token',
'        , lgrt_timestamp',
'        , lgrt_http_method',
'        , lgrt_endpoint',
'        , lgrt_payload',
'      ) VALUES (',
'          req_call_guid',
'        , req_client_id',
'        , flow_rest_logging.c_log_info_enter',
'        , req_token',
'        , systimestamp',
'        , req_method',
'        , req_endpoint',
'        , l_payload_clob',
'      );',
'',
'      commit;',
'',
'    end if;',
'',
'    exception ',
'      when others then ',
'        rollback;',
'        raise;',
'  end enter;',
'    ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure finished( pi_payload          json_element_t ',
'                    )',
'  as',
'    PRAGMA AUTONOMOUS_TRANSACTION;',
'    l_payload_clob  clob;',
'  begin',
'',
'    if is_event_log_enabled ',
'    then',
'      l_payload_clob := pi_payload.to_clob;',
'',
'      INSERT INTO flow_rest_event_log (',
'          lgrt_call_guid',
'        , lgrt_client_id',
'        , lgrt_log_info',
'        , lgrt_token',
'        , lgrt_timestamp',
'        , lgrt_http_method',
'        , lgrt_endpoint',
'        , lgrt_payload',
'      ) VALUES (',
'          req_call_guid',
'        , req_client_id',
'        , flow_rest_logging.c_log_info_finished',
'        , req_token',
'        , systimestamp',
'        , req_method',
'        , req_endpoint',
'        , l_payload_clob',
'      );',
'',
'      commit;',
'',
'    end if;',
'',
'    exception ',
'      when others then ',
'        rollback;',
'        raise;',
'  end finished;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure error( pi_payload            json_element_t',
'                 , pi_error_code         flow_rest_event_log.lgrt_error_code%type',
'                 , pi_error_msg          flow_rest_event_log.lgrt_error_msg%type',
'                 , pi_error_stacktrace   flow_rest_event_log.lgrt_error_stacktrace%type',
'                 )',
'  as',
'    PRAGMA AUTONOMOUS_TRANSACTION;',
'    l_payload_clob  clob;',
'  begin',
'',
'    if is_event_log_enabled ',
'    then',
'    ',
'      if pi_payload is not null then ',
'        l_payload_clob := pi_payload.to_clob;',
'      end if;',
'',
'      INSERT INTO flow_rest_event_log (',
'          lgrt_call_guid',
'        , lgrt_client_id',
'        , lgrt_log_info',
'        , lgrt_token',
'        , lgrt_timestamp',
'        , lgrt_http_method',
'        , lgrt_endpoint',
'        , lgrt_payload',
'        , lgrt_error_code',
'        , lgrt_error_msg',
'        , lgrt_error_stacktrace',
'      ) VALUES (',
'          req_call_guid',
'        , req_client_id',
'        , flow_rest_logging.c_log_info_error',
'        , req_token',
'        , systimestamp',
'        , req_method',
'        , req_endpoint',
'        , l_payload_clob',
'        , pi_error_code',
'        , pi_error_msg',
'        , pi_error_stacktrace',
'      );',
'',
'      commit;',
'    ',
'    end if;',
'',
'    exception ',
'      when others then ',
'        rollback;',
'        raise;',
'',
'  end error;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure set_logging_config( pi_log_rest_incoming         varchar2',
'                              , pi_log_rest_incoming_retain  varchar2 )',
'  as',
'  begin',
'',
'    flow_engine_util.set_config_value( p_config_key => flow_rest_logging.c_log_rest_incoming',
'                                     , p_value      => pi_log_rest_incoming );',
'',
'    flow_engine_util.set_config_value( p_config_key => flow_rest_logging.c_log_rest_incoming_retain_days',
'                                     , p_value      => pi_log_rest_incoming_retain );',
'',
'  end set_logging_config;',
'',
'end flow_rest_logging;',
'/',
'',
'create or replace package body flow_rest_response',
'as',
'',
'  procedure send_error( pi_sqlerrm            varchar2 ',
'                      , pi_stacktrace         varchar2 default null',
'                      , pi_payload            json_element_t default null',
'                      , pi_payload_attr_name  varchar2 default null',
'                      , po_status_code        out number )',
'  as',
'    l_error_jo  json_object_t;',
'  begin',
'    l_error_jo := new json_object_t();',
'    l_error_jo.put( key => ''success'', val => false);',
'    l_error_jo.put( key => ''message'', val => pi_sqlerrm);',
'',
'    /*',
'    if pi_stacktrace is not null then ',
'      l_error_jo.put( key => ''stacktrace'', val => pi_stacktrace);',
'    end if;',
'    */',
'',
'    if pi_payload is not null then ',
'      l_error_jo.put( key => pi_payload_attr_name, val => pi_payload );   ',
'    end if;',
'    ',
'    --apex_util.prn(p_clob => l_error_jo.stringify, p_escape => false);',
'    sys.htp.p(l_error_jo.stringify);',
'    po_status_code := flow_rest_constants.c_http_code_ERROR;',
'',
'  end send_error;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure send_success( pi_success_message   varchar2',
'                        , pi_payload           json_element_t default null',
'                        , pi_payload_attr_name varchar2 default null',
'                        , po_status_code       out number )',
'  as',
'    l_success_jo  json_object_t;',
'  begin',
'    l_success_jo := new json_object_t();',
'    l_success_jo.put( key => ''success'', val => true);',
'    l_success_jo.put( key => ''message'', val => pi_success_message);',
'    if pi_payload is not null then ',
'      l_success_jo.put( key => pi_payload_attr_name, val => pi_payload );   ',
'    end if;',
'',
'    --apex_util.prn(p_clob => l_success_jo.stringify, p_escape => false);',
'    sys.htp.p(l_success_jo.stringify);',
'    po_status_code := flow_rest_constants.c_http_code_OK;',
'',
'  end send_success;',
'',
'end flow_rest_response;',
'/',
'',
'create or replace package body flow_rest_errors',
'as',
'',
'  procedure handle_error( pi_sqlcode            number ',
'                        , pi_message            varchar2 ',
'                        , pi_stacktrace         varchar2 ',
'                        , pi_payload            json_element_t default null',
'                        , pi_payload_attr_name  varchar2 default null',
'                        , po_status_code        out number )',
'  as',
'',
'    l_message  varchar2(2000);',
'    ',
'    function remove_ora_numer( pi_msg  varchar2 )',
'      return varchar2',
'    is',
'    begin',
'      return regexp_replace( pi_msg, ''ORA-[0-9]+: +'','''');',
'    end;',
'',
'  begin                                ',
'',
'    rollback;',
'',
'    case pi_sqlcode',
'',
'      when -20101 then -- e_payload_not_acceptable',
'        l_message :=  ''Payload not accepted'';',
'      when -20102 then -- e_multiple_object_error',
'        l_message :=  ''Multiple objects found'';',
'      when -20103 then -- e_attribute_not_found',
'        l_message :=  ''Attribute not found'';',
'      when -20104 then -- e_item_not_found',
'        l_message :=  ''Item not found'';',
'      when -20105 then -- e_processing_error',
'        l_message :=  ''Processing Error'';',
'      when -20106 then -- e_process_unknown_status',
'        l_message :=  ''Status unknown'';',
'      when -20107 then -- e_step_unknown_operation',
'        l_message :=  ''Unkown operation for step'';',
'      when -20108 then -- e_privilege_not_granted',
'        flow_rest_response.send_error( pi_sqlerrm     => ''Necessary privilege not granted''',
'                                     , po_status_code => po_status_code );',
'        po_status_code := 401;',
'      when -20109 then --e_payload_processing',
'        l_message :=  ''JSON Payload can not be processed'';',
'      when -20200 then -- e_not_implemented',
'        l_message :=  ''Not implemented'';',
'      else',
'',
'        l_message := pi_message;',
'',
'    end case;',
'',
'    flow_rest_logging.error( pi_payload            => pi_payload',
'                           , pi_error_code         => pi_sqlcode',
'                           , pi_error_msg          => l_message',
'                           , pi_error_stacktrace   => pi_stacktrace',
'                           );',
' ',
'',
'    if nvl(po_status_code, -1) != 401 then ',
'      flow_rest_response.send_error(  pi_sqlerrm            => remove_ora_numer(l_message)',
'                                    , pi_stacktrace         => pi_stacktrace',
'                                    , pi_payload            => pi_payload',
'                                    , pi_payload_attr_name  => pi_payload_attr_name',
'                                    , po_status_code        => po_status_code',
'                                    );',
'    end if;',
'    ',
'    po_status_code := nvl(po_status_code, flow_rest_constants.c_http_code_ERROR) ;',
'',
'    flow_rest.cleanup;',
'',
'  end handle_error;',
'',
'end flow_rest_errors;',
'/',
'',
'create or replace package body flow_rest_api_v1',
'as',
'',
'  function get_path( pi_path_endpoint  varchar2, pi_object_id  varchar2)',
'    return varchar2',
'  is',
'  begin',
'',
'    if flow_rest.get_apex_host is null then ',
'      flow_rest.set_apex_host;',
'    end if;',
'',
'    return replace( flow_rest.get_apex_host || flow_rest_constants.c_module || pi_path_endpoint,'':id'', pi_object_id);',
'  end get_path;',
'  ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_link_json( pi_rel       varchar2',
'                        , pi_path      varchar2',
'                        , pi_object_id varchar2',
'                        , pi_action    varchar2 )',
'    return json_object_t',
'  as',
'    l_link_jo  json_object_t;',
'  begin',
'    l_link_jo := new json_object_t;',
'    l_link_jo.put(key => ''rel'',    val => pi_rel);',
'    l_link_jo.put(key => ''href'',   val => get_path(pi_path, pi_object_id));',
'    l_link_jo.put(key => ''action'', val => pi_action);',
'    l_link_jo.put(key => ''types'',  val => json_array_t.parse(''["application/json"]''));',
'    return l_link_jo;',
'  end get_link_json;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure add_usertask_url( pi_links  in out nocopy json_array_t',
'                            , pi_rel       varchar2',
'                            , pi_sbfl_id   flow_subflows.sbfl_id%type',
'                            , pi_action    varchar2 )',
'  as',
'    l_link_jo  json_object_t;',
'    l_url      varchar2(4000);',
'  begin',
'',
'    begin',
'      l_url := flow_api_pkg.get_current_usertask_url( p_process_id => flow_rest.get_process_id(p_sbfl_id => pi_sbfl_id)',
'                                                    , p_subflow_id => pi_sbfl_id',
'                                                    , p_step_key   => flow_rest.get_step_key(p_sbfl_id => pi_sbfl_id) );',
'      exception ',
'        when others then ',
'          null; -- TODO: implement logic to check if usertask url should be created instead of catching exception',
'    end;',
'    ',
'    if l_url is not null then ',
'      l_link_jo := new json_object_t;',
'      l_link_jo.put(key => ''rel'',    val => pi_rel);',
'      l_link_jo.put(key => ''href'',   val => l_url);',
'      l_link_jo.put(key => ''action'', val => pi_action);',
'      l_link_jo.put(key => ''types'',  val => json_array_t.parse(''["application/json"]''));',
'',
'      pi_links.append(l_link_jo);',
'    end if;',
'',
'  end add_usertask_url;',
'  ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_links_array ( pi_object_type  varchar2',
'                           , pi_object_id    varchar2)',
'    return json_array_t',
'  as',
'    l_links  json_array_t;',
'    l_link   json_object_t;',
'  begin ',
'    l_links := new json_array_t();',
'',
'    case lower(pi_object_type)',
'      when flow_rest_constants.c_object_type_diagram then ',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_diagram, flow_rest_constants.c_path_diagrams, pi_object_id, flow_rest_constants.c_http_action_get));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_diagram_processes, pi_object_id, flow_rest_constants.c_http_action_get));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_diagram_processes, pi_object_id, flow_rest_constants.c_http_action_post));',
'      when flow_rest_constants.c_object_type_process then ',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_processes, pi_object_id, flow_rest_constants.c_http_action_get));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_processes, pi_object_id, flow_rest_constants.c_http_action_delete));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_process_start, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_process_reset, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process, flow_rest_constants.c_path_process_terminate, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process_vars, flow_rest_constants.c_path_process_vars, pi_object_id, flow_rest_constants.c_http_action_get));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_process_vars, flow_rest_constants.c_path_process_vars, pi_object_id, flow_rest_constants.c_http_action_put));',
'      when flow_rest_constants.c_object_type_step then',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_step, flow_rest_constants.c_path_steps_start, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_step, flow_rest_constants.c_path_steps_reserve, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_step, flow_rest_constants.c_path_steps_release, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_step, flow_rest_constants.c_path_steps_complete, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_step, flow_rest_constants.c_path_steps_restart, pi_object_id, flow_rest_constants.c_http_action_put));',
'        l_links.append( get_link_json( flow_rest_constants.c_object_type_step, flow_rest_constants.c_path_steps_reschedule_timer, pi_object_id, flow_rest_constants.c_http_action_put));',
'        add_usertask_url( l_links, flow_rest_constants.c_object_type_step_usertask, pi_object_id, flow_rest_constants.c_http_action_get);',
'      else ',
'        null;',
'    end case;',
'',
'    return l_links;',
'  end get_links_array;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_links_object ( pi_object_type  varchar2',
'                            , pi_object_id    varchar2)',
'    return json_object_t',
'  as',
'    l_json_object  json_object_t;',
'  begin',
'',
'    l_json_object := new json_object_t();',
'    l_json_object.put(key => ''links'', val => get_links_array ( pi_object_type  => pi_object_type',
'                                                             , pi_object_id    => pi_object_id));',
'    return l_json_object;                                                         ',
'  end get_links_object;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'  ',
'  function get_links_string_http_GET ( pi_object_type  varchar2',
'                            , pi_object_id    varchar2)',
'    return clob',
'  as',
'    l_json_string  clob;',
'  begin',
'',
'    l_json_string := get_links_array ( pi_object_type  => pi_object_type',
'                                     , pi_object_id    => pi_object_id).stringify;',
'    return trim( trailing '']'' from trim( leading ''['' from l_json_string));',
'  end get_links_string_http_GET;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function get_business_ref_object( pi_business_ref  varchar2 )',
'    return json_object_t',
'  as',
'    l_business_ref  json_object_t;',
'  begin',
'    l_business_ref := new json_object_t();',
'    l_business_ref.put( ''name'', ''business_ref'');',
'    l_business_ref.put( ''type'', ''varchar'');',
'    l_business_ref.put( ''value'', pi_business_ref );',
'    return l_business_ref;',
'',
'  end get_business_ref_object;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure processes_post( pi_dgrm_id  flow_diagrams.dgrm_id%type',
'                          , pi_payload  json_element_t',
'                          , pi_current_user     varchar2',
'                          , po_status_code      out number',
'                          , po_forward_location out varchar2 ',
'                          , po_exc_payload      out json_element_t',
'                          , po_exc_payload_attr_name out varchar2 )',
'  as',
'    pragma autonomous_transaction;',
'',
'    l_item_object   json_object_t;',
'    l_prcs_id       flow_processes.prcs_id%type;',
'    l_business_ref_arr  json_array_t;',
'    l_error_occured     boolean := false;',
'',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    flow_rest.verify_diagram_exists( pi_dgrm_id       => pi_dgrm_id',
'                                   , pi_dgrm_version  => l_item_object.get_String( flow_rest_constants.c_check_item_dgrm_versi'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'on ) );',
'',
'   ',
'    l_prcs_id := flow_api_pkg.flow_create ( pi_dgrm_id    => pi_dgrm_id',
'                                          , pi_prcs_name  => l_item_object.get_String( ''name'' ));',
'',
'    -- if business_ref was provided set process variable after creation',
'    if l_item_object.has( ''business_ref'' ) then',
'      l_business_ref_arr := flow_rest.get_json_array_t( get_business_ref_object( l_item_object.get_string( ''business_ref'' )));',
'      flow_rest.process_vars_update( pi_prcs_id    => l_prcs_id',
'                                   , pio_prov_arr  => l_business_ref_arr',
'                                   , pi_add_error_msg  => true );',
'    end if;',
'',
'    po_forward_location := get_path( pi_path_endpoint => flow_rest_constants.c_path_processes',
'                                   , pi_object_id     => l_prcs_id );',
'',
'    commit;',
'',
'    exception ',
'      when others then ',
'        raise;',
'      ',
'  end processes_post;                       ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure processes_start_put( pi_prcs_id          flow_processes.prcs_id%type',
'                               , pi_current_user     varchar2',
'                               , po_status_code      out number ',
'                               , po_forward_location out varchar2',
'                               , po_exc_payload      out json_element_t',
'                               , po_exc_payload_attr_name out varchar2 )',
'  as ',
'    l_item_object      json_object_t;   ',
'  begin',
'    ',
'    flow_rest.verify_process_exists( pi_prcs_id  => pi_prcs_id );',
'',
'    l_item_object := new json_object_t();',
'',
'    l_item_object.put( flow_rest_constants.c_process_status, flow_rest_constants.c_process_status_start);',
'',
'    flow_rest.process_status_update( pi_prcs_id  => pi_prcs_id',
'                                   , pi_payload  => l_item_object );',
'',
'    ',
'    ',
'    flow_rest_response.send_success( pi_success_message => ''status updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_process',
'                                                                           , pi_object_id    => pi_prcs_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code       => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end processes_start_put;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure processes_reset_put( pi_prcs_id          flow_processes.prcs_id%type',
'                               , pi_payload          json_element_t  ',
'                               , pi_current_user     varchar2',
'                               , po_status_code      out number ',
'                               , po_forward_location out varchar2 ',
'                               , po_exc_payload      out json_element_t',
'                               , po_exc_payload_attr_name out varchar2)       ',
'  as ',
'    l_item_object      json_object_t;   ',
'  begin',
'',
'    if pi_payload is null then ',
'      l_item_object := new json_object_t();',
'    else ',
'      flow_rest.verify_and_prepare_payload( pi_payload        => pi_payload ',
'                                          , pi_array_allowed  => false ',
'                                          , po_payload_object => l_item_object );',
'    end if;',
'',
'    l_item_object.put( flow_rest_constants.c_process_status, flow_rest_constants.c_process_status_reset);',
'',
'    flow_rest.verify_process_exists( pi_prcs_id  => pi_prcs_id );',
'',
'    flow_rest.process_status_update( pi_prcs_id  => pi_prcs_id',
'                                   , pi_payload  => l_item_object );',
'',
'    ',
'    ',
'    flow_rest_response.send_success( pi_success_message => ''status updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_process',
'                                                                           , pi_object_id    => pi_prcs_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code       => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end processes_reset_put;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure processes_terminate_put( pi_prcs_id          flow_processes.prcs_id%type',
'                                   , pi_payload          json_element_t  ',
'                                   , pi_current_user     varchar2',
'                                   , po_status_code      out number ',
'                                   , po_forward_location out varchar2',
'                                   , po_exc_payload      out json_element_t',
'                                   , po_exc_payload_attr_name out varchar2 )                                                         ',
'  as',
'    l_item_object      json_object_t;   ',
'  begin',
'',
'    if pi_payload is null then ',
'      l_item_object := new json_object_t();',
'    else',
'      flow_rest.verify_and_prepare_payload( pi_payload        => pi_payload ',
'                                          , pi_array_allowed  => false ',
'                                          , po_payload_object => l_item_object );',
'    end if;',
'',
'    l_item_object.put( flow_rest_constants.c_process_status, flow_rest_constants.c_process_status_terminate);',
'',
'    flow_rest.verify_process_exists( pi_prcs_id  => pi_prcs_id );',
'',
'    flow_rest.process_status_update( pi_prcs_id  => pi_prcs_id',
'                                   , pi_payload  => l_item_object );',
'',
'    flow_rest_response.send_success( pi_success_message => ''status updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_process',
'                                                                           , pi_object_id    => pi_prcs_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code       => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end processes_terminate_put;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure processes_delete( pi_prcs_id          flow_processes.prcs_id%type',
'                            , pi_payload          json_element_t ',
'                            , pi_current_user     varchar2',
'                            , po_status_code      out number',
'                            , po_exc_payload      out json_element_t',
'                            , po_exc_payload_attr_name out varchar2 )',
'  as',
'    l_item_object          json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    flow_rest.verify_process_exists( pi_prcs_id  => pi_prcs_id );',
'',
'    flow_api_pkg.flow_delete( p_process_id => pi_prcs_id',
'                            , p_comment    => l_item_object.get_string(''comment'') );',
'',
'    flow_rest_response.send_success( pi_success_message => ''process deleted'' ',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end processes_delete;    ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'  ',
'  procedure steps_start_put( pi_sbfl_id          flow_subflows.sbfl_id%type',
'                           , pi_payload          json_element_t ',
'                           , pi_current_user     varchar2',
'                           , po_status_code      out number ',
'                           , po_forward_location out varchar2',
'                           , po_exc_payload      out json_element_t',
'                           , po_exc_payload_attr_name out varchar2 )',
'  as',
'    l_item_object      json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    l_item_object.put( flow_rest_constants.c_step_status_status, flow_rest_constants.c_step_status_start);',
'',
'    flow_rest.step_update( pi_sbfl_id  => pi_sbfl_id',
'                         , pi_payload  => l_item_object );',
'',
'                        ',
'    flow_rest_response.send_success( pi_success_message => ''step updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_step',
'                                                                           , pi_object_id    => pi_sbfl_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end steps_start_put;                               ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure steps_reserve_put( pi_sbfl_id          flow_subflows.sbfl_id%type',
'                             , pi_payload          json_element_t ',
'                             , pi_current_user     varchar2',
'                             , po_status_code      out number ',
'                             , po_forward_location out varchar2',
'                             , po_exc_payload      out json_element_t',
'                             , po_exc_payload_attr_name out varchar2)',
'  as',
'    l_item_object      json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    l_item_object.put( flow_rest_constants.c_step_status_status, flow_rest_constants.c_step_status_reserve);',
'',
'    flow_rest.step_update( pi_sbfl_id  => pi_sbfl_id',
'                         , pi_payload  => l_item_object );',
'',
'                        ',
'    flow_rest_response.send_success( pi_success_message => ''step updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_step',
'                                                                           , pi_object_id    => pi_sbfl_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end steps_reserve_put;                          ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure steps_release_put( pi_sbfl_id          flow_subflows.sbfl_id%type',
'                             , pi_payload          json_element_t ',
'                             , pi_current_user     varchar2',
'                             , po_status_code      out number ',
'                             , po_forward_location out varchar2',
'                             , po_exc_payload      out json_element_t',
'                             , po_exc_payload_attr_name out varchar2)',
'  as',
'    l_item_object      json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    l_item_object.put( flow_rest_constants.c_step_status_status, flow_rest_constants.c_step_status_release);',
'',
'    flow_rest.step_update( pi_sbfl_id  => pi_sbfl_id',
'                         , pi_payload  => l_item_object );',
'',
'                        ',
'    flow_rest_response.send_success( pi_success_message => ''step updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_step',
'                                                                           , pi_object_id    => pi_sbfl_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end steps_release_put;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure steps_complete_put( pi_sbfl_id          flow_subflows.sbfl_id%type',
'                              , pi_payload          json_element_t ',
'                              , pi_current_user     varchar2',
'                              , po_status_code      out number ',
'                              , po_forward_location out varchar2',
'                              , po_exc_payload      out json_element_t',
'                              , po_exc_payload_attr_name out varchar2)',
'  as',
'    l_item_object      json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    l_item_object.put( flow_rest_constants.c_step_status_status, flow_rest_constants.c_step_status_complete);',
'',
'    flow_rest.step_update( pi_sbfl_id  => pi_sbfl_id',
'                         , pi_payload  => l_item_object );',
'',
'                        ',
'    flow_rest_response.send_success( pi_success_message => ''step updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_step',
'                                                                           , pi_object_id    => pi_sbfl_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end steps_complete_put;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'  ',
'  procedure steps_restart_put( pi_sbfl_id          flow_subflows.sbfl_id%type',
'                             , pi_payload          json_element_t ',
'                             , pi_current_user     varchar2',
'                             , po_status_code      out number ',
'                             , po_forward_location out varchar2',
'                             , po_exc_payload      out json_element_t',
'                             , po_exc_payload_attr_name out varchar2 )',
'  as',
'    l_item_object      json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    l_item_object.put( flow_rest_constants.c_step_status_status, flow_rest_constants.c_step_status_restart);',
'',
'    flow_rest.step_update( pi_sbfl_id  => pi_sbfl_id',
'                         , pi_payload  => l_item_object );',
'',
'                        ',
'    flow_rest_response.send_success( pi_success_message => ''step updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_step',
'                                                                           , pi_object_id    => pi_sbfl_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end steps_restart_put;',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure steps_reschedule_timer_put( pi_sbfl_id          flow_subflows.sbfl_id%type',
'                                      , pi_payload          json_element_t ',
'                                      , pi_current_user     varchar2',
'                                      , po_status_code      out number ',
'                                      , po_forward_location out varchar2',
'                                      , po_exc_payload      out json_element_t',
'                                      , po_exc_payload_attr_name out varchar2 )',
'  as',
'    l_item_object      json_object_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload              => pi_payload ',
'                                        , pi_array_allowed        => false ',
'                                        , po_payload_object       => l_item_object );',
'',
'    l_item_object.put( flow_rest_constants.c_step_status_status, flow_rest_constants.c_step_status_reschedule_timer);',
'',
'    flow_rest.step_update( pi_sbfl_id  => pi_sbfl_id',
'                         , pi_payload  => l_item_object );',
'',
'                        ',
'    flow_rest_response.send_success( pi_success_message => ''step updated'' ',
'                                   , pi_payload         => get_links_array ( pi_object_type  => flow_rest_constants.c_object_type_step',
'                                                                           , pi_object_id    => pi_sbfl_id )',
'                                   , pi_payload_attr_name => ''links''',
'                                   , po_status_code     => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_item_object;',
'        po_exc_payload_attr_name := ''item'';',
'        raise;',
'',
'  end steps_reschedule_timer_put;                                    ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure process_vars_put( pi_prcs_id          flow_processes.prcs_id%type ',
'                            , pi_payload          json_element_t ',
'                            , pi_current_user     varchar2',
'                            , po_status_code      out number ',
'                            , po_forward_location out varchar2',
'                            , po_exc_payload      out json_element_t',
'                            , po_exc_payload_attr_name out varchar2 )',
'  as',
'    l_prov_array   json_array_t;',
'',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload       => pi_payload ',
'                                        , pi_array_allowed => true ',
'                                        , po_payload_array => l_prov_array );',
'',
'    flow_rest.process_vars_update( pi_prcs_id    => pi_prcs_id',
'                                 , pio_prov_arr  => l_prov_array',
'                                 , pi_add_error_msg  => true );',
'',
'',
'    flow_rest_response.send_success( pi_success_message   => ''process variables updated'' ',
'                                   , pi_payload           => l_prov_array',
'                                   , pi_payload_attr_name => ''items''',
'                                   , po_status_code       => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_prov_array;',
'        po_exc_payload_attr_name := ''items'';',
'        raise;',
'',
'  end process_vars_put;    ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure process_vars_delete( pi_prcs_id          flow_processes.prcs_id%type ',
'                               , pi_payload          json_element_t ',
'                               , pi_current_user     varchar2',
'                               , po_status_code      out number',
'                               , po_exc_payload      out json_element_t',
'                               , po_exc_payload_attr_name out varchar2 )',
'  as',
'    l_prov_array   json_array_t;',
'  begin',
'',
'    flow_rest.verify_and_prepare_payload( pi_payload         => pi_payload ',
'                                        , pi_array_allowed   => false ',
'                                        , po_payload_array   => l_prov_array );',
'',
'    flow_rest.verify_process_exists( pi_prcs_id  => pi_prcs_id );',
'',
'    flow_rest.process_vars_delete( pi_prcs_id    => pi_prcs_id',
'                                 , pio_prov_arr  => l_prov_array',
'                                 , pi_add_error_msg  => true );',
'',
'    flow_rest_response.send_success( pi_success_message   => ''process variables deleted'' ',
'                                   , pi_payload           => l_prov_array',
'                                   , pi_payload_attr_name => ''items''',
'                                   , po_status_code       => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_prov_array;',
'        po_exc_payload_attr_name := ''items'';',
'        raise;',
'',
'  end process_vars_delete;    ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure messages_put( pi_message_name     flow_message_subscriptions.msub_message_name%type ',
'                        , pi_payload          json_element_t ',
'                        , pi_current_user     varchar2',
'                        , po_status_code      out number ',
'                        , po_forward_location out varchar2 ',
'                        , po_exc_payload      out json_element_t',
'                        , po_exc_payload_attr_name out varchar2)',
'  as',
'    l_msg_array json_array_t;',
'  begin',
'    ',
'    flow_rest.verify_and_prepare_payload( pi_payload         => pi_payload ',
'                                        , pi_array_allowed   => true ',
'                                        , po_payload_array   => l_msg_array );',
'',
'    flow_rest.messages_update( pi_message_name  => pi_message_name',
'                             , pi_msg_arr       => l_msg_array );',
'',
'    flow_rest_response.send_success( pi_success_message   => ''message processed'' ',
'                                   , pi_payload           => l_msg_array',
'                                   , pi_payload_attr_name => ''items''',
'                                   , po_status_code       => po_status_code );',
'',
'    exception ',
'      when others then ',
'        po_exc_payload := l_msg_array;',
'        po_exc_payload_attr_name := ''items'';',
'        raise;',
'',
'  end messages_put;      ',
'',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure dispatch( pi_method           varchar2  --PUT/POST/DELETE',
'                    , pi_endpoint         varchar2',
'                    , pi_dgrm_id          flow_diagrams.dgrm_id%type default null',
'                    , pi_prcs_id          flow_processes.prcs_id%type default null',
'                    , pi_sbfl_id          flow_subflows.sbfl_id%type default null',
'                    , pi_message_name     flow_message_subscriptions.msub_message_name%type default null',
'                    , pi_payload          blob ',
'                    , pi_current_user     varchar2',
'                    , po_status_code      out number ',
'                    , po_forward_location out varchar2',
'                    )',
'  as',
'    l_payload                json_element_t;',
'    l_exc_payload            json_element_t;',
'    l_exc_payload_attr_name  varchar2(200);',
'  begin',
'',
'    flow_rest.initialize( pi_client_id => pi_current_user',
'                        , pi_method    => pi_method ',
'                        , pi_endpoint  => pi_endpoint );',
'    ',
'    begin',
'      l_payload := flow_rest.blob_to_json(pi_payload);',
'      exception ',
'        when others then',
'          l_exc_payload_attr_name := ''payload'';',
'          l_exc_payload := new json_object_t(''{ "content": "''|| apex_escape.json(to_clob(pi_payload)) ||''" }'' ); ',
'          raise;',
'    end;',
'',
'    flow_rest_logging.enter( pi_payload => l_payload );',
'    ',
'    case upper(pi_method)',
'      when ''POST'' then',
'',
'        case ',
'          when regexp_like(pi_endpoint, ''^v1/diagrams/[[:digit:]]+/processes$'', ''i'') then',
'            flow_rest_api_v1.processes_post(  pi_dgrm_id          => pi_dgrm_id',
'                                            , pi_payload          => l_payload',
'                                            , pi_current_user     => pi_current_user',
'                                            , po_status_code      => po_status_code',
'                                            , po_forward_location => po_forward_location',
'                                            , po_exc_payload      => l_exc_payload',
'                                            , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          else ',
'            raise flow_rest_constants.e_not_implemented;',
'        end case;',
'',
'      when ''PUT'' then',
'',
'        case ',
'          when regexp_like(pi_endpoint, ''^v1/messages/[[:alnum:][:blank:][:punct:]]+$'', ''i'') then',
'            flow_rest_api_v1.messages_put( pi_message_name     => pi_message_name',
'                                         , pi_payload          => l_payload',
'                                         , pi_current_user     => pi_current_user',
'                                         , po_status_code      => po_status_code',
'                                         , po_forward_location => po_forward_location ',
'                                         , po_exc_payload      => l_exc_payload',
'                                         , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/processes/[[:digit:]]+/start$'', ''i'') then',
'            flow_rest_api_v1.processes_start_put( pi_prcs_id          => pi_prcs_id',
'                                                , pi_current_user     => pi_current_user',
'                                                , po_status_code      => po_status_code',
'                                                , po_forward_location => po_forward_location ',
'                                                , po_exc_payload      => l_exc_payload',
'                                                , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/processes/[[:digit:]]+/reset$'', ''i'') then',
'            flow_rest_api_v1.processes_reset_put( pi_prcs_id          => pi_prcs_id',
'                                                , pi_payload          => l_payload',
'                                                , pi_current_user     => pi_current_user',
'                                                , po_status_code      => po_status_code',
'                                                , po_forward_location => po_forward_location  ',
'                                                , po_exc_payload      => l_exc_payload',
'                                                , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/processes/[[:digit:]]+/terminate$'', ''i'') then',
'            flow_rest_api_v1.processes_terminate_put( pi_prcs_id          => pi_prcs_id',
'                                                    , pi_payload          => l_payload',
'                                                    , pi_current_user     => pi_current_user',
'                                                    , po_status_code      => po_status_code',
'                                                    , po_forward_location => po_forward_location ',
'                                                    , po_exc_payload      => l_exc_payload',
'                                                    , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/steps/[[:digit:]]+/start$'', ''i'') then',
'            flow_rest_api_v1.steps_start_put( pi_sbfl_id          => pi_sbfl_id',
'                                            , pi_payload          => l_payload',
'                                            , pi_current_user     => pi_current_user',
'                                            , po_status_code      => po_status_code',
'                                            , po_forward_location => po_forward_location ',
'                                            , po_exc_payload      => l_exc_payload',
'                                            , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/steps/[[:digit:]]+/reserve$'', ''i'') then',
'            flow_rest_api_v1.steps_reserve_put( pi_sbfl_id          => pi_sbfl_id',
'                                              , pi_payload          => l_payload',
'                                              , pi_current_user     => pi_current_user',
'   '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'                                           , po_status_code      => po_status_code',
'                                              , po_forward_location => po_forward_location ',
'                                              , po_exc_payload      => l_exc_payload',
'                                              , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/steps/[[:digit:]]+/release$'', ''i'') then',
'            flow_rest_api_v1.steps_release_put( pi_sbfl_id          => pi_sbfl_id',
'                                              , pi_payload          => l_payload',
'                                              , pi_current_user     => pi_current_user',
'                                              , po_status_code      => po_status_code',
'                                              , po_forward_location => po_forward_location ',
'                                              , po_exc_payload      => l_exc_payload',
'                                              , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/steps/[[:digit:]]+/complete$'', ''i'') then',
'            flow_rest_api_v1.steps_complete_put( pi_sbfl_id          => pi_sbfl_id',
'                                               , pi_payload          => l_payload',
'                                               , pi_current_user     => pi_current_user',
'                                               , po_status_code      => po_status_code',
'                                               , po_forward_location => po_forward_location ',
'                                               , po_exc_payload      => l_exc_payload',
'                                               , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/steps/[[:digit:]]+/restart$'', ''i'') then',
'            flow_rest_api_v1.steps_restart_put( pi_sbfl_id          => pi_sbfl_id',
'                                              , pi_payload          => l_payload',
'                                              , pi_current_user     => pi_current_user',
'                                              , po_status_code      => po_status_code',
'                                              , po_forward_location => po_forward_location ',
'                                              , po_exc_payload      => l_exc_payload',
'                                              , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/steps/[[:digit:]]+/reschedule_timer$'', ''i'') then',
'            flow_rest_api_v1.steps_reschedule_timer_put( pi_sbfl_id          => pi_sbfl_id',
'                                                       , pi_payload          => l_payload',
'                                                       , pi_current_user     => pi_current_user',
'                                                       , po_status_code      => po_status_code',
'                                                       , po_forward_location => po_forward_location ',
'                                                       , po_exc_payload      => l_exc_payload',
'                                                       , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/processes/[[:digit:]]+/process_vars$'', ''i'') then',
'            flow_rest_api_v1.process_vars_put( pi_prcs_id          => pi_prcs_id',
'                                             , pi_payload          => l_payload',
'                                             , pi_current_user     => pi_current_user',
'                                             , po_status_code      => po_status_code',
'                                             , po_forward_location => po_forward_location ',
'                                             , po_exc_payload      => l_exc_payload',
'                                             , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          else ',
'            raise flow_rest_constants.e_not_implemented;',
'        end case;',
'',
'      when ''DELETE'' then',
'        case ',
'          when regexp_like(pi_endpoint, ''^v1/processes/[[:digit:]]+$'', ''i'') then',
'            flow_rest_api_v1.processes_delete( pi_prcs_id      => pi_prcs_id',
'                                             , pi_payload      => l_payload',
'                                             , pi_current_user => pi_current_user',
'                                             , po_status_code  => po_status_code ',
'                                             , po_exc_payload  => l_exc_payload',
'                                             , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          when regexp_like(pi_endpoint, ''^v1/processes/[[:digit:]]+/process_vars$'', ''i'') then',
'            flow_rest_api_v1.process_vars_delete( pi_prcs_id       => pi_prcs_id',
'                                                , pi_payload       => l_payload',
'                                                , pi_current_user  => pi_current_user',
'                                                , po_status_code   => po_status_code ',
'                                                , po_exc_payload   => l_exc_payload',
'                                                , po_exc_payload_attr_name => l_exc_payload_attr_name );',
'          else',
'            raise flow_rest_constants.e_not_implemented;',
'        end case;                                                ',
'      else ',
'        raise flow_rest_constants.e_not_implemented;',
'    end case;',
'',
'    flow_rest_logging.finished( pi_payload => l_payload );',
'    flow_rest.cleanup;',
'    commit;',
'',
'    exception ',
'      when others then ',
'        flow_rest_errors.handle_error( pi_sqlcode            => SQLCODE',
'                                     , pi_message            => SQLERRM ',
'                                     , pi_stacktrace         => dbms_utility.format_error_backtrace ',
'                                     , pi_payload            => l_exc_payload',
'                                     , pi_payload_attr_name  => l_exc_payload_attr_name',
'                                     , po_status_code        => po_status_code );',
'',
'  end dispatch;',
'',
'end flow_rest_api_v1;',
'/',
'',
'create or replace package body flow_rest_install',
'as',
'',
'  function is_rest_enabled( pi_schema varchar2 default apex_application.g_flow_owner )',
'    return boolean',
'  as',
'    l_status varchar2(50);',
'  begin',
'    select upper(max(status))',
'      into l_status',
'      from user_ords_schemas',
'      where parsing_schema = pi_schema;',
'',
'    return nvl(l_status, flow_rest_constants.c_rest_schema_status_disabled) = flow_rest_constants.c_rest_schema_status_enabled;',
'',
'  end is_rest_enabled;',
'  ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  function is_module_published( pi_schema varchar2 default apex_application.g_flow_owner',
'                              , pi_module_prefix varchar2 default flow_rest_constants.c_rest_current_version )',
'    return boolean',
'  as',
'    l_status varchar2(50);',
'  begin',
'    select upper(max(om.status))',
'      into l_status',
'      from user_ords_modules om',
'      join user_ords_schemas os on om.schema_id = os.id',
'      where os.parsing_schema = pi_schema',
'        and trim(''/'' from om.uri_prefix) = pi_module_prefix;',
'',
'    return nvl(l_status, ''X'') = flow_rest_constants.c_rest_module_status_published;',
'',
'  end is_module_published;',
'    ',
'  -------------------------------------------------------------------------------------------------------------------',
'',
'  procedure set_base_url( pi_base_url  varchar2 )',
'  as',
'  begin',
'    flow_engine_util.set_config_value( p_config_key => flow_rest_constants.c_config_prefix || flow_rest_constants.c_config_key_base',
'                                     , p_value      => pi_base_url );',
'  end set_base_url;',
'',
'',
'end flow_rest_install;',
'/',
'',
'create or replace package body flow_engine_app_api',
'as',
'',
'  function apex_error_handling (',
'    p_error in apex_error.t_error ',
'  )',
'  return apex_error.t_error_result',
'  is',
'    l_result          apex_error.t_error_result;',
'    l_reference_id    number;',
'    l_constraint_name varchar2(255);',
'  begin',
'    l_result := apex_error.init_error_result (',
'                    p_error => p_error );',
'                    ',
'    -- If it''s an internal error raised by APEX, like an invalid statement or',
'    -- code which can''t be executed, the error text might contain security sensitive',
'    -- information. To avoid this security problem we can rewrite the error to',
'    -- a generic error message and log the original error message for further',
'    -- investigation by the help desk.',
'    if p_error.is_internal_error then',
'      -- mask all errors that are not common runtime errors (Access Denied',
'      -- errors raised by application / page authorization and all errors',
'      -- regarding session and session state)',
'      if not p_error.is_common_runtime_error then',
'        -- log error for example with an autonomous transaction and return',
'        -- l_reference_id as reference#',
'        -- l_reference_id := log_error (',
'        --                       p_error => p_error );',
'        --',
'',
'        -- Change the message to the generic error message which doesn''t expose',
'        -- any sensitive information.',
'        l_result.message         := ''An unexpected internal application error has occurred. ''||',
'                                    ''Please fill a bug at  https://github.com/flowsforapex/apex-flowsforapex/issues''||',
'                                    '' for further investigation.'';',
'        l_result.additional_info := null;',
'      end if;',
'    else',
'      -- Note: If you want to have friendlier ORA error messages, you can also define',
'      --       a text message with the name pattern APEX.ERROR.ORA-number',
'      --       There is no need to implement custom code for that.',
'',
'      -- If it''s a constraint violation like',
'      --',
'      --   -) ORA-00001: unique constraint violated',
'      --   -) ORA-02091: transaction rolled back (-> can hide a deferred constraint)',
'      --   -) ORA-02290: check constraint violated',
'      --   -) ORA-02291: integrity constraint violated - parent key not found',
'      --   -) ORA-02292: integrity constraint violated - child record found',
'      --',
'      -- we try to get a friendly error message from APEX Text Messages.',
'      -- If we don''t find the constraint in APEX text message then create it',
'      if p_error.ora_sqlcode in (-1, -2091, -2290, -2291, -2292) then',
'        l_constraint_name := apex_error.extract_constraint_name (',
'                                   p_error => p_error );',
'',
'        l_result.message := apex_lang.message( l_constraint_name );',
'',
'      end if;',
'',
'      -- If no associated page item/tabular form column has been set, we can use',
'      -- apex_error.auto_set_associated_item to automatically guess the affected',
'      -- error field by examine the ORA error for constraint names or column names.',
'      if l_result.page_item_name is null and l_result.column_alias is null then',
'          apex_error.auto_set_associated_item (',
'              p_error        => p_error,',
'              p_error_result => l_result );',
'      end if;',
'    end if;',
'',
'    return l_result;',
'  end apex_error_handling;',
'',
'  procedure handle_ajax',
'  as ',
'    l_error_occured boolean := false;',
'    l_url           varchar2(4000);',
'    l_clob          clob;',
'    l_before_prcs_status flow_instances_vw.prcs_status%type;',
'    l_after_prcs_status flow_instances_vw.prcs_status%type;',
'    l_reload boolean := false;',
'',
'  begin',
'    apex_debug.message( p_message => ''Action: %s'', p0 => apex_application.g_x01 );',
'    if instr(apex_application.g_x01, ''bulk-'') > 0 then',
'      apex_debug.message( p_message => ''This is a bulk action'');',
'      if ( upper(apex_application.g_x01) = ''BULK-COMPLETE-STEP'' or upper(apex_application.g_x01) = ''BULK-RESTART-STEP'' ) then',
'        select prcs_status',
'        into l_before_prcs_status',
'        from flow_instances_vw',
'        where prcs_id = apex_application.g_f01(1);',
'      end if;',
'      for i in apex_application.g_f01.first..apex_application.g_f01.last',
'      loop',
'        apex_debug.message( p_message => ''Action: %s, PRCS: %s'', p0 => apex_application.g_x01, p1 => apex_application.g_f01(i) );',
'        case upper(apex_application.g_x01)',
'          when ''BULK-RESET-FLOW-INSTANCE'' then',
'            flow_api_pkg.flow_reset( p_process_id => apex_application.g_f01(i), p_comment => apex_application.g_x02 );',
'          when ''BULK-START-FLOW-INSTANCE'' then',
'            flow_api_pkg.flow_start( p_process_id => apex_application.g_f01(i) );',
'          when ''BULK-DELETE-FLOW-INSTANCE'' then',
'            flow_api_pkg.flow_delete( p_process_id => apex_application.g_f01(i), p_comment => apex_application.g_x02 );',
'          when ''BULK-TERMINATE-FLOW-INSTANCE'' then ',
'            flow_api_pkg.flow_terminate ( p_process_id => apex_application.g_f01(i), p_comment => apex_application.g_x02 );',
'          when ''BULK-RESERVE-STEP'' then',
'            flow_api_pkg.flow_reserve_step',
'            (',
'              p_process_id => apex_application.g_f01(i)',
'            , p_subflow_id => apex_application.g_f02(i)',
'            , p_step_key   => apex_application.g_f03(i)',
'            , p_reservation => coalesce(apex_application.g_x02, V(''APP_USER''))',
'            );',
'          when ''BULK-RELEASE-STEP'' then',
'            flow_api_pkg.flow_release_step',
'            (',
'              p_process_id => apex_application.g_f01(i)',
'            , p_subflow_id => apex_application.g_f02(i)',
'            , p_step_key   => apex_application.g_f03(i)',
'            );        ',
'          when ''BULK-COMPLETE-STEP'' then',
'            flow_api_pkg.flow_complete_step',
'            (',
'              p_process_id => apex_application.g_f01(i)',
'            , p_subflow_id => apex_application.g_f02(i)',
'            , p_step_key   => apex_application.g_f03(i)',
'            );',
'          when ''BULK-RESTART-STEP'' then ',
'            flow_api_pkg.flow_restart_step ',
'            (',
'              p_process_id => apex_application.g_f01(i)',
'            , p_subflow_id => apex_application.g_f02(i)',
'            , p_step_key   => apex_application.g_f03(i)',
'            , p_comment       => apex_application.g_x02           ',
'            );',
'          when ''BULK-DELETE-PROCESS-VARIABLE'' then ',
'            flow_process_vars.delete_var(',
'              pi_prcs_id  => apex_application.g_f01(i)',
'            , pi_var_name => apex_application.g_f02(i)',
'            , pi_scope    => apex_application.g_f03(i)',
'          );',
'          when ''BULK-RESCHEDULE-TIMER'' then',
'          flow_api_pkg.flow_reschedule_timer(',
'              p_process_id    => apex_application.g_f01(i)',
'            , p_subflow_id    => apex_application.g_f02(i)',
'            , p_step_key      => apex_application.g_f03(i)',
'            , p_is_immediate  => case apex_application.g_x02 when ''Y'' then true end',
'            , p_new_timestamp => case apex_application.g_x03 when ''N'' then to_timestamp(apex_application.g_x06, v(''APP_NLS_TIMESTAMP_FORMAT'')) end',
'            , p_comment       => apex_application.g_x04',
'          );',
'          else',
'            apex_error.add_error',
'            (',
'              p_message          => ''Unknow action requested.''',
'            , p_display_location => apex_error.c_on_error_page',
'            );',
'        end case;',
'      end loop;',
'      if ( upper(apex_application.g_x01) = ''BULK-COMPLETE-STEP'' or upper(apex_application.g_x01) = ''BULK-RESTART-STEP'' ) then',
'        select prcs_status',
'        into l_after_prcs_status',
'        from flow_instances_vw',
'        where prcs_id = apex_application.g_f01(1);',
'',
'        if l_before_prcs_status != l_after_prcs_status then',
'          l_reload := true;',
'        end if;',
'      end if;',
'    else',
'      apex_debug.message( p_message => ''Action: %0, PRCS: %1, SBFL: %2, STEP KEY: %3'', p0 => apex_application.g_x01, ',
'      p1 => apex_application.g_x02, p2 => apex_application.g_x03 , p3 => apex_application.g_x04);',
'',
'      if ( upper( apex_application.g_x01 ) = ''COMPLETE-STEP'' or upper( apex_application.g_x01 ) = ''RESTART-STEP'' ) then',
'        select prcs_status',
'        into l_before_prcs_status',
'        from flow_instances_vw',
'        where prcs_id = apex_application.g_x02;',
'      end if;',
'',
'',
'      case upper(apex_application.g_x01)',
'        when ''RESET-FLOW-INSTANCE'' then',
'          flow_api_pkg.flow_reset( p_process_id => apex_application.g_x02, p_comment => apex_application.g_x03 );',
'        when ''STEP-TIMERS'' then',
'          flow_api_pkg.step_timers;',
'        when ''START-FLOW-INSTANCE'' then',
'          flow_api_pkg.flow_start( p_process_id => apex_application.g_x02 );',
'        when ''DELETE-FLOW-INSTANCE'' then',
'          flow_api_pkg.flow_delete( p_process_id => apex_application.g_x02, p_comment => apex_application.g_x03 );',
'          l_url := apex_page.get_url(',
'                p_page => 10',
'              , p_clear_cache => 10',
'          );',
'        when ''RESERVE-STEP'' then',
'          flow_api_pkg.flow_reserve_step',
'          (',
'            p_process_id => apex_application.g_x02',
'          , p_subflow_id => apex_application.g_x03',
'          , p_step_key   => apex_application.g_x04',
'          , p_reservation => coalesce(apex_application.g_x05, V(''APP_USER''))',
'          );',
'        when ''TERMINATE-FLOW-INSTANCE'' then ',
'          flow_api_pkg.flow_terminate ( p_process_id => apex_application.g_x02, p_comment => apex_application.g_x03 );',
'        when ''RELEASE-STEP'' then',
'          flow_api_pkg.flow_release_step',
'          (',
'            p_process_id => apex_application.g_x02',
'          , p_subflow_id => apex_application.g_x03',
'          , p_step_key   => apex_application.g_x04',
'          );    ',
'        when ''COMPLETE-STEP'' then',
'          flow_api_pkg.flow_complete_step',
'          (',
'            p_process_id    => apex_application.g_x02',
'          , p_subflow_id    => apex_application.g_x03',
'          , p_step_key      => apex_application.g_x04',
'          );',
'                  apex_debug.message (p_message => ''ajax handler happy'');',
'        when ''RESTART-STEP'' then ',
'          flow_api_pkg.flow_restart_step ',
'          (',
'            p_process_id    => apex_application.g_x02',
'          , p_subflow_id    => apex_application.g_x03',
'          , p_step_key      => apex_application.g_x04',
'          , p_comment       => apex_application.g_x05       ',
'          );',
'        when ''FLOW-INSTANCE-AUDIT'' then',
'          l_url := apex_page.get_url(',
'              p_page => 14',
'            , p_items => ''P14_PRCS_ID,P14_TITLE''',
'            , p_values => apex_application.g_x02||'',''||apex_application.g_x03',
'            , p_clear_cache => ''RP''',
'          );',
'        when ''EDIT-FLOW-DIAGRAM'' then',
'          l_url := apex_page.get_url(',
'              p_page => 7',
'            , p_items => ''P7_DGRM_ID''',
'            , p_values => apex_application.g_x02',
'          );',
'        when ''OPEN-FLOW-INSTANCE-DETAILS'' then',
'          l_url := apex_page.get_url(',
'              p_page => 8',
'            , p_items => ''P8_PRCS_ID''',
'            , p_values => apex_application.g_x02',
'            , p_clear_cache => 8',
'          );',
'        when ''VIEW-FLOW-INSTANCE'' then',
'          l_url := apex_page.get_url(',
'              p_page => 12',
'            , p_items => ''P12_PRCS_ID''',
'            , p_values => apex_application.g_x02',
'            , p_clear_cache => 12',
'          );',
'        when ''PROCESS-VARIABLE'' then',
'          case apex_application.g_x04',
'            when ''VARCHAR2'' then',
'              flow_process_vars.set_var',
'              (',
'                pi_prcs_id   => apex_application.g_x02',
'              , pi_var_name  => apex_application.g_x03',
'              , pi_vc2_value => apex_application.g_x05',
'              , pi_scope     => apex_application.g_x06',
'              );',
'            when ''NUMBER'' then',
'              flow_process_vars.set_var',
'              (',
'                pi_prcs_id   => apex_application.g_x02',
'              , pi_var_name  => apex_application.g_x03',
'              , pi_num_value => to_number(apex_application.g_x05)',
'              , pi_scope     => apex_application.g_x06',
'              );',
'            when ''DATE'' then',
'              flow_process_vars.set_var',
'              (',
'                pi_prcs_id    => apex_application.g_x02',
'              , pi_var_name   => apex_application.g_x03',
'              , pi_date_value => to_date(apex_application.g_x05, v(''APP_DATE_TIME_FORMAT''))',
'              , pi_scope      => apex_application.g_x06',
'              );',
'            when ''TIMESTAMP WITH TIME ZONE'' then',
'              flow_process_vars.set_var',
'              (',
'                pi_prcs_id    => apex_application.g_x02',
'              , pi_var_name   => apex_application.g_x03',
'              , pi_tstz_value => to_timestamp_tz(apex_application.g_x05, flow_constants_pkg.gc_prov_default_tstz_format)',
'              , pi_scope      => apex_application.g_x06',
'              );',
'            when ''CLOB'' then',
'              for i in apex_application.g_f01.first..apex_application.g_f01.last',
'              loop',
'                l_clob := l_clob || apex_application.g_f01(i);',
'              end loop;',
'              flow_process_vars.set_var',
'              (',
'                pi_prcs_id    => apex_application.g_x02',
'              , pi_var_name   => apex_application.g_x03',
'              , pi_clob_value => l_clob',
'              , pi_scope      => apex_application.g_x06',
'              );',
'            when ''JSON'' then',
'              for i in apex_application.g_f01.first..apex_application.g_f01.last',
'              loop',
'                l_clob := l_clob || apex_application.g_f01(i);',
'              end loop;',
'              /*Using internal for now since we don''t have public API for that*/',
'              flow_process_vars.set_var',
'              (',
'                pi_prcs_id    => apex_application.g_x02',
'              , pi_var_name   => apex_application.g_x03',
'              , pi_json_value => l_clob',
'              , pi_scope      => apex_application.g_x06',
'              );  ',
'            else',
'              null;',
'          end case;',
'        when ''DELETE-PROCESS-VARIABLE'' then',
'          flow_process_vars.delete_var(',
'              pi_prcs_id  => apex_application.g_x02',
'            , pi_var_name => apex_application.g_x03',
'            , pi_scope    => apex_application.g_x04',
'          );',
'        when ''RESCHEDULE-TIMER'' then',
'          flow_api_pkg.flow_reschedule_timer(',
'              p_process_id    => apex_application.g_x02',
'            , p_subflow_id    => apex_application.g_x03',
'            , p_step_key      => apex_application.g_x04',
'            , p_is_immediate  => case apex_application.g_x05 when ''Y'' then true end',
'            , p_new_timestamp => case apex_application.g_x05 when ''N'' then to_timestamp(apex_application.g_x06, v(''APP_NLS_TIMESTAMP_FORMAT'')) end',
'            , p_comment       => apex_application.g_x07',
'          );',
'        when ''RECEIVE-MESSAGE'' then',
'          for i in apex_application.g_f01.first..apex_application.g_f01.last',
'          loop',
'            l_clob := l_clob || apex_application.g_f01(i);',
'          end loop;',
'',
'          flow_api_pkg.receive_message(',
'            p_message_name => apex_application.g_x02,',
'            p_key_name     => apex_application.g_x03,',
'            p_key_value    => apex_application.g_x04,',
'            p_payload      => l_clob',
'          );',
'        else',
'          apex_error.add_error',
'          (',
'            p_message          => ''Unknow action requested.''',
'          , p_display_location => apex_error.c_on_error_page',
'          );',
'      end case;',
'',
'        apex_debug.message (p_message => ''after ajax handler case end'');',
'      if ( upper( apex_application.g_x01 ) = ''COMPLETE-STEP'' or upper( apex_application.g_x01 ) = ''RESTART-STEP'' ) then',
'        select prcs_status',
'        into l_after_prcs_status',
'        from flow_instances_vw',
'        where prcs_id = apex_application.g_x02;',
'        ',
'        apex_debug.message (p_message => ''after ajax handler before status %0 after status %1''',
'        , p0 => l_before_prcs_status',
'        , p1 => l_after_prcs_status',
'        );',
'',
'        if l_before_prcs_status != l_after_prcs_status then',
'          l_reload := true;',
'        end if;',
'      end if;',
'',
'    end if;',
'',
'    apex_json.open_object;',
'    apex_json.write( p_name => ''success'', p_value => not apex_error.have_errors_occurred );',
'    if l_url is not null then',
'      apex_json.write( p_name => ''url'', p_value => l_url );',
'    end if;',
'    if l_reload then ',
'      apex_json.write( p_name => ''reloadPage'', p_value => true );',
'    end if;',
'    apex_json.close_all;',
'    ',
'  exception',
'      when others then',
'        apex_json.open_object;',
'        apex_json.write( p_name => ''success'', p_value => false );',
'        apex_json.write( p_name => ''message'', p_value => sqlerrm);',
'        apex_json.write( p_name => ''fullstack'', p_value => dbms_utility.format_error_stack);',
'        apex_json.close_all;',
'        l_error_occured := true;',
'  end handle_ajax;',
'',
'',
'  function get_objt_list(',
'    p_prcs_id in flow_processes.prcs_id%type',
'  ) return varchar2',
'  as',
'    l_objt_list apex_t_varchar2;',
'  begin    ',
'    select bpmn_id',
'      bulk collect into l_objt_list',
'      from ( select objt_bpmn_id as bpmn_id',
'               from flow_objects',
'              where objt_dgrm_id = ( select prcs_dgrm_id ',
'                                       from flow_processes',
'                                      where prcs_id = p_prcs_id)',
'                and objt_tag_name not in (''bpmn:process'', ''bpmn:textAnnotation'', ''bpmn:participant'', ''bpmn:laneSet'', ''bpmn:lane'')',
'              union all',
'             select conn_bpmn_id as bpmn_id',
'               from flow_connections',
'              where conn_dgrm_id = ( select prcs_dgrm_id ',
'                                       from flow_processes',
'                                      where prcs_id = p_prcs_id)',
'           );',
'    return apex_string.join( p_table => l_objt_list, p_sep => '':'' );',
'  end get_objt_list;',
'',
'',
'  function get_objt_list(',
'    p_dgrm_id in flow_diagrams.dgrm_id%type',
'  ) return varchar2',
'  as',
'    l_objt_list apex_t_varchar2;',
'  begin    ',
'    select bpmn_id',
'      bulk collect into l_objt_list',
'      from ( select objt_bpmn_id as bpmn_id',
'               from flow_objects',
'              where objt_dgrm_id = p_dgrm_id',
'                and objt_tag_name not in (''bpmn:process'', ''bpmn:textAnnotation'', ''bpmn:participant'', ''bpmn:laneSet'', ''bpmn:lane'')',
'              union all',
'             select conn_bpmn_id as bpmn_id',
'               from flow_connections',
'              where conn_dgrm_id = p_dgrm_id',
'           );',
'    return apex_string.join( p_table => l_objt_list, p_sep => '':'' );',
'  end get_objt_list;',
'',
'',
'  function get_objt_list(',
'    p_prdg_id in flow_instance_diagrams.prdg_id%type',
'  ) return varchar2',
'  as',
'    l_objt_list apex_t_varchar2;',
'  begin    ',
'    select bpmn_id',
'      bulk collect into l_objt_list',
'      from ( select objt_bpmn_id as bpmn_id',
'               from flow_objects',
'              where objt_dgrm_id = ( select prdg_dgrm_id ',
'                                       from flow_instance_diagrams',
'                                      where prdg_id = p_prdg_id)',
'                and objt_tag_name not in (''bpmn:process'', ''bpmn:textAnnotation'', ''bpmn:participant'', ''bpmn:laneSet'', ''bpmn:lane'')',
'              union all',
'             select conn_bpmn_id as bpmn_id',
'               from flow_connections',
'              where conn_dgrm_id = ( select prdg_dgrm_id ',
'                                       from flow_instance_diagrams',
'                                      where prdg_id = p_prdg_id)',
'           );',
'    return apex_string.join( p_table => l_objt_list, p_sep => '':'' );',
'  end get_objt_list;',
'  ',
'  ',
'  function get_objt_name(',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_dgrm_id      in flow_diagrams.dgrm_id%type',
'  ) return flow_objects.objt_name%type',
'  as',
'    l_objt_name flow_objects.objt_name%type;',
'  begin',
'    select name',
'      into l_objt_name',
'      from ( select objt_bpmn_id as bpmn_id',
'                  , objt_name as name',
'                  , objt_dgrm_id as dgrm_id',
'               from flow_objects',
'              union',
'             select conn_bpmn_id as bpmn_id',
'                  , conn_name as name',
'                  , conn_dgrm_id as dgrm_id',
'               from flow_connections',
'           )',
'    where bpmn_id = p_objt_bpmn_id',
'      and dgrm_id = p_dgrm_id;',
'    return l_objt_name;',
'  end get_objt_name;',
'',
'',
'  function get_objt_name(',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_prcs_id      in flow_processes.prcs_id%type',
'  ) return flow_objects.objt_name%type',
'  as',
'    l_objt_name flow_objects.objt_name%type;',
'  begin',
'    select name',
'      into l_objt_name',
'      from ( select objt_bpmn_id as bpmn_id',
'                  , objt_name as name',
'                  , objt_dgrm_id as dgrm_id',
'               from flow_objects',
'              union',
'             select conn_bpmn_id as bpmn_id',
'                  , conn_name as name',
'                  , conn_dgrm_id as dgrm_id',
'               from flow_connections',
'           )',
'    where bpmn_id = p_objt_bpmn_id',
'      and dgrm_id = (select prcs_dgrm_id',
'                       from flow_processes',
'                      where prcs_id = p_prcs_id);',
'    return l_objt_name;',
'  end get_objt_name;',
'',
'',
'  function get_objt_name(',
'    p_objt_bpmn_id in flow_objects.objt_bpmn_id%type',
'  , p_prdg_id      in flow_instance_diagrams.prdg_id%type',
'  ) return flow_objects.objt_name%type',
'  as',
'    l_objt_name flow_objects.objt_name%type;',
'  begin',
'    select name',
'      into l_objt_name',
'      from ( select objt_bpmn_id as bpmn_id',
'                  , objt_name as name',
'                  , objt_dgrm_id as dgrm_id',
'               from flow_objects',
'              union',
'             select conn_bpmn_id as bpmn_id',
'      '))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'            , conn_name as name',
'                  , conn_dgrm_id as dgrm_id',
'               from flow_connections',
'           )',
'    where bpmn_id = p_objt_bpmn_id',
'      and dgrm_id = (select prdg_dgrm_id',
'                       from flow_instance_diagrams',
'                      where prdg_id = p_prdg_id);',
'    return l_objt_name;',
'  end get_objt_name;',
'',
'',
'  procedure set_viewport(',
'    p_display_setting in varchar2)',
'  as',
'  begin',
'    apex_util.set_preference(''VIEWPORT'', p_display_setting);',
'  end set_viewport;',
'    ',
'    ',
'  procedure add_viewport_script(',
'    p_item in varchar2',
'  )',
'  as',
'    l_script varchar2(4000 byte);',
'    l_display_setting varchar2(20 byte);',
'  begin',
'    -- Initialize',
'    l_display_setting := coalesce(apex_util.get_preference(''VIEWPORT''),''row'');',
'    apex_util.set_session_state(p_item, l_display_setting);',
'    ',
'    -- Set IDs for the the row divs',
'    l_script := q''#apex.jQuery("#flow-instances").parent().attr("id","col1");',
'                 apex.jQuery("#flow-monitor").parent().attr("id","col2");#'';',
'    ',
'    apex_javascript.add_onload_code(',
'      p_code => l_script,',
'      p_key  => ''init_viewport'');    ',
'    ',
'    l_script := null;',
'    -- Set view to side-by-side if preference = ''column''',
'    case l_display_setting ',
'      when ''column'' then    ',
'        l_script := q''#apex.jQuery( "#col1" ).addClass( "col-6" ).removeClass( [ "col-12", "col-end" ] );',
'                      apex.jQuery( "#col2" ).addClass( "col-6" ).removeClass( [ "col-12", "col-start" ] );',
'                      apex.jQuery("#col2").appendTo(apex.jQuery("#col1").parent());',
'                      apex.jQuery("#flow-monitor").show();',
'                      apex.region( "flow-monitor" ).refresh();#'';',
'      when ''window'' then',
'        l_script := q''#apex.jQuery("#flow-monitor").hide();',
'                       apex.jQuery( "#col1" ).addClass( [ "col-12", "col-start", "col-end" ] ).removeClass( "col-6" );',
'                       apex.jQuery( "#col2" ).addClass( [ "col-12", "col-start", "col-end" ] ).removeClass( "col-6" );#'';',
'    else',
'      null;',
'    end case;',
'    ',
'    if l_script is not null then',
'      apex_javascript.add_onload_code(',
'        p_code => l_script,',
'        p_key  => ''viewport'');',
'    end if;',
'  end add_viewport_script;',
'',
'',
'  procedure get_url_p13(',
'    pi_dgrm_id flow_diagrams.dgrm_id%type',
'  , pi_objt_id varchar2',
'  , pi_title varchar2',
'  )',
'  as',
'    l_url varchar2(2000);',
'  begin',
'    l_url := apex_page.get_url(',
'      p_application => v(''APP_ID''),',
'      p_page => ''13'',',
'      p_session => v(''APP_SESSION''),',
'      p_clear_cache => ''RP'',',
'      p_items => ''P13_DGRM_ID,P13_OBJT_ID,P13_TITLE'',',
'      p_values => pi_dgrm_id || '','' || pi_objt_id || '','' || pi_title',
'    );',
'    htp.p(l_url);',
'  end get_url_p13;',
'',
'',
'  procedure get_url_p13(',
'    pi_prcs_id flow_processes.prcs_id%type',
'  , pi_prdg_id flow_instance_diagrams.prdg_id%type',
'  , pi_objt_id varchar2',
'  , pi_title varchar2',
'  )',
'  as',
'    l_url varchar2(2000);',
'    l_dgrm_id flow_processes.prcs_dgrm_id%type;',
'  begin',
'    select prdg_dgrm_id ',
'      into l_dgrm_id ',
'      from flow_instance_diagrams',
'     where prdg_id = pi_prdg_id;',
'      ',
'    l_url := apex_page.get_url(',
'      p_application => v(''APP_ID''),',
'      p_page => ''13'',',
'      p_session => v(''APP_SESSION''),',
'      p_clear_cache => ''RP'',',
'      p_items => ''P13_DGRM_ID,P13_PRCS_ID,P13_OBJT_ID,P13_TITLE,P13_PRDG_ID'',',
'      p_values => l_dgrm_id || '','' || pi_prcs_id || '','' || pi_objt_id || '','' || pi_title || '','' || pi_prdg_id',
'    );',
'    htp.p(l_url);',
'  end get_url_p13;',
'',
'',
'  /* page 2 */',
'  ',
'',
'  function check_flow_exists(',
'    p_dgrm_name    in flow_diagrams.dgrm_name%type,',
'    p_dgrm_version in flow_diagrams.dgrm_version%type)',
'  return boolean',
'  as',
'    l_exists binary_integer;',
'  begin',
'  ',
'    select count(*)',
'      into l_exists',
'      from dual',
'     where exists(',
'           select null',
'             from flow_diagrams',
'            where dgrm_name = p_dgrm_name',
'              and dgrm_version = p_dgrm_version);',
'    return l_exists = 1;',
'  end check_flow_exists;',
'  ',
'',
'  function validate_flow_exists_bulk(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_version  in flow_diagrams.dgrm_version%type',
'  ) return varchar2 ',
'  as',
'    l_err varchar2(4000 byte);',
'    l_flows apex_t_varchar2;',
'    l_dgrm_name flow_diagrams.dgrm_name%type;',
'  begin',
'    -- Initialize',
'    l_flows := apex_string.split(pi_dgrm_id_list, '':'');',
'    ',
'    for i in 1 .. l_flows.count loop',
'  ',
'      select dgrm_name ',
'        into l_dgrm_name',
'        from flow_diagrams',
'       where dgrm_id = l_flows(i);',
'',
'      if check_flow_exists(l_dgrm_name, pi_new_version) then',
'        l_err := apex_lang.message(',
'                   p_name => ''APP_ERR_MODEL_EXIST'',',
'                   p0 => l_dgrm_name,',
'                   p1 => pi_new_version);',
'      end if;',
'      exit when l_err is not null;',
'    end loop;',
'    return l_err;',
'  end validate_flow_exists_bulk;',
'',
'',
'  function validate_flow_exists(',
'    pi_dgrm_id     in flow_diagrams.dgrm_id%type',
'  , pi_new_version in flow_diagrams.dgrm_version%type ',
'  ) return varchar2 ',
'  as',
'    l_err varchar2(4000 byte);',
'    l_dgrm_name flow_diagrams.dgrm_name%type;',
'  begin',
'  ',
'    select dgrm_name',
'      into l_dgrm_name',
'      from flow_diagrams',
'     where dgrm_id = pi_dgrm_id;',
'    ',
'    if check_flow_exists(l_dgrm_name, pi_new_version) then',
'      l_err := apex_lang.message(',
'                 p_name => ''APP_ERR_MODEL_EXIST'',',
'                 p0 => l_dgrm_name,',
'                 p1 => pi_new_version);',
'    end if;',
'    return l_err;',
'  end validate_flow_exists;',
'  ',
'  ',
'  function validate_flow_copy_bulk(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_name     in flow_diagrams.dgrm_name%type ',
'  ) return varchar2 ',
'  as',
'    l_err varchar2(4000 byte);',
'    l_flows apex_t_varchar2;',
'    l_dgrm_name flow_diagrams.dgrm_name%type;',
'  begin',
'    -- Initialize',
'    l_flows := apex_string.split(pi_dgrm_id_list, '':'');',
'    ',
'    for i in 1 .. l_flows.count loop',
'  ',
'      select dgrm_name|| '' - '' || pi_new_name',
'        into l_dgrm_name',
'        from flow_diagrams ',
'       where dgrm_id = l_flows(i);',
'',
'      if check_flow_exists(l_dgrm_name, ''0'') then',
'        l_err := apex_lang.message(',
'                   p_name => ''APP_ERR_MODEL_EXIST'',',
'                   p0 => pi_new_name,',
'                   p1 => ''0'');',
'      end if;',
'      exit when l_err is not null;',
'    end loop;',
'    return l_err;',
'  end validate_flow_copy_bulk;',
'  ',
'  ',
'  function validate_flow_copy(',
'    pi_new_name in flow_diagrams.dgrm_name%type ',
'  ) return varchar2 ',
'  as',
'    l_err varchar2(4000);',
'  begin',
'    if check_flow_exists(pi_new_name, ''0'') then',
'      l_err := apex_lang.message(',
'                 p_name => ''APP_ERR_MODEL_EXIST'',',
'                 p0 => pi_new_name,',
'                 p1 => ''0'');',
'    end if;',
'    return l_err;',
'  end validate_flow_copy;',
'  ',
'  ',
'  procedure copy_selection_to_collection',
'  as',
'  begin',
'    apex_collection.create_or_truncate_collection(p_collection_name => ''C_SELECT'' );',
'    for i in 1 .. apex_application.g_f01.count() loop',
'      apex_collection.add_member(',
'         p_collection_name => ''C_SELECT'',',
'         p_n001 => apex_application.g_f01(i));',
'    end loop;',
'  end;',
'',
'  ',
'  procedure add_new_version(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_version  in flow_diagrams.dgrm_version%type ',
'  )',
'  as',
'    r_diagrams flow_diagrams%rowtype;',
'    l_flows apex_t_varchar2;',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'  begin',
'    -- Initialize',
'    l_flows := apex_string.split(pi_dgrm_id_list, '':'');',
'    ',
'    for i in 1 .. l_flows.count loop',
'      select * ',
'        into r_diagrams',
'        from flow_diagrams',
'       where dgrm_id = l_flows(i);',
'',
'      l_dgrm_id := flow_diagram.import_diagram(',
'        pi_dgrm_name => r_diagrams.dgrm_name,',
'        pi_dgrm_version => pi_new_version,',
'        pi_dgrm_category => r_diagrams.dgrm_category,',
'        pi_dgrm_content => r_diagrams.dgrm_content);',
'    end loop;',
'    ',
'  end add_new_version;',
'  ',
'  ',
'  procedure copy_model(',
'    pi_dgrm_id_list in varchar2',
'  , pi_new_name     in flow_diagrams.dgrm_name%type ',
'  )',
'  as',
'    l_flows apex_t_varchar2;',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'    r_diagrams flow_diagrams%rowtype;',
'  begin',
'    -- Initialize',
'    l_flows := apex_string.split(pi_dgrm_id_list, '':'');',
'    ',
'    for i in 1 .. l_flows.count loop',
'      select * ',
'        into r_diagrams',
'        from flow_diagrams',
'       where dgrm_id = l_flows(i);',
'',
'      l_dgrm_id := flow_diagram.import_diagram(',
'        pi_dgrm_name => case when l_flows.count() > 1 then r_diagrams.dgrm_name || '' - '' end || pi_new_name,',
'        pi_dgrm_version => ''0'',',
'        pi_dgrm_category => r_diagrams.dgrm_category,',
'        pi_dgrm_content => r_diagrams.dgrm_content);',
'',
'    end loop;',
'  end copy_model;',
'',
'  /* page 3 */',
'  function check_version_mismatch(',
'    p_app_id number default apex_application.g_flow_id',
'  ) return varchar2',
'  is',
'    l_app_version       apex_applications.version%type;',
'    l_datamodel_version flow_configuration.cfig_value%type;',
'    l_code_version      varchar2(10) := flow_constants_pkg.gc_version;',
'    l_message           varchar2(4000);',
'  begin',
'    select version',
'    into l_app_version',
'    from apex_applications',
'    where application_id = p_app_id;',
'   ',
'    select cfig_value',
'    into l_datamodel_version',
'    from flow_configuration',
'    where cfig_key = ''version_now_installed'';',
'   ',
'    if (( l_app_version = l_datamodel_version )  and ( l_datamodel_version = l_code_version )) = false then',
'        l_message := apex_lang.message(',
'            p_name => ''APP_VERSION_MISMATCH'',',
'            p0     => l_app_version,',
'            p1     => l_datamodel_version,',
'            p2     => l_code_version',
'        );',
'    end if;',
'',
'    return l_message;',
'',
'  end check_version_mismatch;',
'',
'  function check_apex_upgrade(',
'    p_app_id number default apex_application.g_flow_id',
'  ) return varchar2',
'  is',
'    l_actual_version pls_integer;',
'    l_actual_release pls_integer;',
'    l_stored_version pls_integer := flow_apex_env.version;',
'    l_stored_release pls_integer := flow_apex_env.release;',
'    l_message        varchar2(4000);',
'  begin',
'    select  ',
'         to_number(substr(version_no, 1, instr(version_no, ''.'', 1, 1) - 1))',
'       , to_number(substr(version_no, instr(version_no, ''.'', 1, 1) + 1, instr(version_no, ''.'', 1, 1) - 2))',
'    into l_actual_version, l_actual_release',
'    from apex_release;',
'',
'    if (( l_actual_version = l_stored_version ) and ( l_actual_release = l_stored_release )) = false then',
'        l_message := apex_lang.message(',
'            p_name => ''APP_APEX_UPGRADE_DETECTED'',',
'            p0     => l_actual_version,',
'            p1     => l_actual_release,',
'            p2     => l_stored_version,',
'            p3     => l_stored_release',
'        );',
'    end if;',
'',
'    return l_message;',
'',
'  end check_apex_upgrade;',
'',
'',
'  /* page 4 */',
'',
'',
'  function get_region_title(',
'    pi_dgrm_id in flow_diagrams.dgrm_id%type',
'  )',
'  return varchar2 ',
'  as',
'    l_region_title varchar2(128 byte);',
'  begin',
'  ',
'    select dgrm_name || '' (Version: '' || dgrm_version || '', Status: '' || dgrm_status || '')'' as d',
'      into l_region_title',
'      from flow_diagrams',
'     where dgrm_id = pi_dgrm_id;',
'',
'    return l_region_title;',
'  end get_region_title;',
'',
'',
'  /* page 5 */',
'',
'',
'  function get_file_name',
'  (',
'    p_dgrm_id                  in number',
'  , p_include_version          in varchar2',
'  , p_include_status           in varchar2',
'  , p_include_category         in varchar2',
'  , p_include_last_change_date in varchar2',
'  , p_download_as              in varchar2',
'  ) ',
'  return varchar2',
'  is',
'    l_file_name        varchar2(300 char);',
'    l_dgrm_name        flow_diagrams.dgrm_name%type;',
'    l_dgrm_version     flow_diagrams.dgrm_version%type;',
'    l_dgrm_status      flow_diagrams.dgrm_status%type;',
'    l_dgrm_category    flow_diagrams.dgrm_category%type;',
'    l_dgrm_last_update flow_diagrams.dgrm_last_update%type;',
'  begin',
'    select dgrm_name',
'         , dgrm_version',
'         , dgrm_status',
'         , dgrm_category',
'         , dgrm_last_update',
'      into l_dgrm_name',
'         , l_dgrm_version',
'         , l_dgrm_status',
'         , l_dgrm_category',
'         , l_dgrm_last_update',
'      from flow_diagrams',
'     where dgrm_id = p_dgrm_id',
'    ;',
'    ',
'    l_file_name := to_char(sysdate, ''YYYYMMDD-HH24MI'') || ''_'' || l_dgrm_name;',
'    ',
'    if (p_include_category = ''Y'' and l_dgrm_category is not null) then',
'      l_file_name := l_file_name || ''_'' || l_dgrm_category;',
'    end if;',
'    if (p_include_status = ''Y'') then',
'      l_file_name := l_file_name || ''_'' || l_dgrm_status;',
'    end if;',
'    if (p_include_version = ''Y'') then',
'      l_file_name := l_file_name || ''_'' || l_dgrm_version;',
'    end if;',
'    if (p_include_last_change_date = ''Y'') then',
'      l_file_name := l_file_name || ''_'' || to_char(l_dgrm_last_update, ''YYYYMMDD-HH24MI'');',
'    end if;',
'    if (p_download_as = ''SQL'') then',
'      l_file_name := l_file_name || ''.sql'';',
'    end if;',
'    if (p_download_as = ''BPMN'') then',
'      l_file_name := l_file_name || ''.bpmn'';',
'    end if;',
'    return l_file_name;',
'  end get_file_name;',
'',
'',
'  function get_sql_script(',
'      p_dgrm_id in number',
'  ) ',
'  return clob',
'  is',
'    l_split_content apex_t_varchar2;',
'    l_sql clob;',
'    l_buffer varchar2(32767);  ',
'    r_diagrams flow_diagrams%rowtype;',
'  begin ',
'    dbms_lob.createtemporary(l_sql,true, DBMS_LOB.CALL);',
'    select *',
'    into r_diagrams',
'    from flow_diagrams',
'    where dgrm_id = p_dgrm_id;',
'    l_buffer := ''declare''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''  l_dgrm_content clob;''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''begin''||utl_tcp.crlf;',
'    dbms_lob.writeappend(l_sql, length(l_buffer), l_buffer);',
'    l_split_content := apex_string.split(p_str => replace(r_diagrams.dgrm_content,  apex_application.CRLF,  apex_application.LF));',
'    l_buffer := ''  l_dgrm_content := apex_string.join_clob(''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''    apex_t_varchar2(''||utl_tcp.crlf;',
'    dbms_lob.writeappend(l_sql, length(l_buffer), l_buffer);',
'    for i in l_split_content.first..l_split_content.last',
'    loop',
'      if (i = l_split_content.first) then',
'        l_buffer := ''      q''''[''||l_split_content(i)||'']''''''||utl_tcp.crlf;',
'      else',
'        l_buffer := ''      ,q''''[''||l_split_content(i)||'']''''''||utl_tcp.crlf;',
'      end if;',
'      dbms_lob.writeappend(l_sql, length(l_buffer), l_buffer);',
'    end loop;',
'    l_buffer := ''  ));'';',
'    l_buffer := l_buffer||utl_tcp.crlf;',
'    l_buffer := l_buffer||''  flow_diagram.upload_and_parse(''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''    pi_dgrm_name => ''||dbms_assert.enquote_literal(r_diagrams.dgrm_name)||'',''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''    pi_dgrm_version => ''||dbms_assert.enquote_literal(r_diagrams.dgrm_version)||'',''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''    pi_dgrm_category => ''||dbms_assert.enquote_literal(r_diagrams.dgrm_category)||'',''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''    pi_dgrm_content => l_dgrm_content''||utl_tcp.crlf||'');''||utl_tcp.crlf;',
'    l_buffer := l_buffer||''end;''||utl_tcp.crlf||''/''||utl_tcp.crlf;',
'    dbms_lob.writeappend(l_sql, length(l_buffer), l_buffer);',
'    ',
'    return l_sql;',
'  end get_sql_script;',
'',
'  ',
'  function get_bmpn_content(',
'      p_dgrm_id in number',
'  ) return clob',
'  is ',
'    l_dgrm_content flow_diagrams.dgrm_content%type;',
'  begin',
'    select dgrm_content',
'    into l_dgrm_content',
'    from flow_diagrams',
'    where dgrm_id = p_dgrm_id;',
'    return l_dgrm_content;',
'  end get_bmpn_content;',
'',
'',
'  function sanitize_file_name(',
'    p_file_name in varchar2',
'  )',
'  return varchar2',
'  is',
'    l_file_name varchar2(300 char);',
'  begin',
'    l_file_name := p_file_name;',
'    l_file_name := replace(l_file_name, ''/'', ''_'');',
'    l_file_name := replace(l_file_name, ''\'', ''_'');',
'    l_file_name := replace(l_file_name, ''*'', ''_'');',
'    l_file_name := replace(l_file_name, '':'', ''_'');',
'    l_file_name := replace(l_file_name, ''?'', ''_'');',
'    l_file_name := replace(l_file_name, ''|'', ''_'');',
'    l_file_name := replace(l_file_name, ''<'', ''_'');',
'    l_file_name := replace(l_file_name, ''>'', ''_'');',
'    return l_file_name;',
'  end sanitize_file_name;',
'',
'',
'  function clob_to_blob(',
'    p_clob in clob',
'  )',
'  return blob',
'  is',
'    l_blob         BLOB;',
'    l_dest_offset  PLS_INTEGER := 1;',
'    l_src_offset   PLS_INTEGER := 1;',
'    l_lang_context PLS_INTEGER := DBMS_LOB.default_lang_ctx;',
'    l_warning      PLS_INTEGER := DBMS_LOB.warn_inconvertible_char;',
'  begin',
'    dbms_lob.createtemporary(',
'      lob_loc => l_blob,',
'      cache   => TRUE',
'    );',
'    dbms_lob.converttoblob(',
'      dest_lob      => l_blob,',
'      src_clob      => p_clob,',
'      amount        => DBMS_LOB.lobmaxsize,',
'      dest_offset   => l_dest_offset,',
'      src_offset    => l_src_offset, ',
'      blob_csid     => DBMS_LOB.default_csid,',
'      lang_context  => l_lang_context,',
'      warning       => l_warning',
'    );',
'  ',
'    return l_blob;',
'  end clob_to_blob;',
'',
'  procedure download_file(',
'    p_file_name in varchar2,',
'    p_mime_type in varchar2,',
'    p_blob_content in blob',
'  )',
'  is',
'    l_length integer;',
'    l_blob_content blob := p_blob_content;',
'  begin',
'    l_length := sys.dbms_lob.getlength(l_blob_content);',
'    owa_util.mime_header(p_mime_type, false) ;',
'    htp.p(''Content-length: '' || l_length);',
'    htp.p(''Content-Disposition: attachment; filename="''||sanitize_file_name(p_file_name)||''"'');',
'    owa_util.http_header_close;',
'    wpg_docload.download_file(l_blob_content);',
'    apex_application.stop_apex_engine;',
'  end download_file;',
'',
'  procedure download_file(',
'      p_dgrm_id     in number,',
'      p_file_name   in varchar2,',
'      p_download_as in varchar2,',
'      p_multi_file  in boolean default false',
'  )',
'  is ',
'    l_clob        clob;',
'    l_blob        blob;',
'    l_zip_file    blob;',
'    l_buffer      varchar2(32767);  ',
'    l_desc_offset pls_integer := 1;',
'    l_src_offset  pls_integer := 1;',
'    l_lang        pls_integer := 0;',
'    l_warning     pls_integer := 0;',
'    l_mime_type   varchar2(100) := ''application/octet'';',
'    type r_flow   is record (',
'      dgrm_id       flow_diagrams.dgrm_id%type, ',
'      dgrm_name     flow_diagrams.dgrm_name%type,',
'      dgrm_version  flow_diagrams.dgrm_version%type,',
'      dgrm_status   flow_diagrams.dgrm_status%type,',
'      dgrm_category flow_diagrams.dgrm_category%type,',
'      filename      varchar2(300)',
'    );',
'    type t_flows  is table of r_flow index by binary_integer;',
'    l_flows       t_flows;',
'    l_flow        r_flow;',
'    l_json_array  json_array_t;',
'    l_json_object json_object_t;',
'    l_json_clob   clob;',
'    l_sql_clob    clob;',
'    l_file_name   varchar2(300);',
'  begin',
'    l_file_name := p_file_name;',
'    if ( p_download_as = ''BPMN'' ) then',
'      l_json_array := json_array_t(''[]'');',
'    end if;',
'    if ( p_multi_file ) then',
'      select ',
'        dgrm_id, ',
'        dgrm_name,',
'        dgrm_version,',
'        dgrm_status,',
'        dgrm_category,',
'        dgrm_name||''_''||dgrm_version as filename',
'      bulk collect into l_flows',
'      from flow_diagrams ',
'      where dgrm_id in (',
'        select n001',
'        from apex_collections',
'        where collection_name = ''C_SELECT''',
'      )',
'      order by dgrm_name, dgrm_version;',
'    else',
'      l_flow.dgrm_id := p_dgrm_id;',
'      l_flows(1)     := l_flow;',
'    end if;',
'    for i in 1..l_flows.count()',
'    loop',
'      if (p_download_as = ''BPMN'') then',
'          l_clob := get_bmpn_content(p_dgrm_id => l_flows(i).dgrm_id);',
'          apex_debug.message(dbms_lob.getlength(l_clob));',
'      end if;',
'      if (p_download_as = ''SQL'') then',
'        l_clob := get_sql_script(p_dgrm_id => l_flows(i).dgrm_id);',
'      end if;',
'      l_blob := clob_to_blob(l_clob);',
'      if ( p_multi_file ) then',
'        apex_zip.add_file (',
'          p_zipped_blob => l_zip_file,',
'          p_file_name   => sanitize_file_name(l_flows(i).filename) || ''.'' || lower(p_download_as),',
'          p_content     => l_blob',
'        );',
'        if ( p_download_as = ''BPMN'' ) then',
'          l_json_object := json_object_t(''{}'');',
'          l_json_object.put(''dgrm_name'' ,  l_flows(i).dgrm_name);',
'          l_json_object.put(''dgrm_version'' ,  l_flows(i).dgrm_version);',
'          l_json_object.put(''dgrm_status'' ,  l_flows(i).dgrm_status);',
'          l_json_object.put(''dgrm_category'' ,  l_flows(i).dgrm_category);',
'          l_json_object.put(''file'' ,  sanitize_file_name(l_flows(i).filename) || ''.bpmn'');',
'          l_json_array.append(l_json_object);',
'        elsif ( p_download_as = ''SQL'' ) then',
'          l_sql_clob := l_sql_clob||''@"''||sanitize_file_name(l_flows(i).filename) || ''.'' || lower(p_download_as)||''";''||utl_tcp.crlf;',
'        end if;',
'      end if;',
'    end loop;',
'    if ( p_multi_file ) then',
'      if ( p_download_as = ''BPMN'' ) then',
'        l_json_clob := treat(l_json_array as json_element_t).to_clob(); ',
'        l_blob := clob_to_blob(l_json_clob);',
'        apex_zip.add_file (',
'          p_zipped_blob => l_zip_file,',
'          p_file_name   => ''import.json'',',
'          p_content     => l_blob',
'        );',
'      elsif ( p_download_as = ''SQL'' ) then',
'        l_sql_clob := ''set define off;'' || utl_tcp.crlf || l_sql_clob || utl_tcp.crlf;',
'        l_blob := clob_to_blob(l_sql_clob);',
'        apex_zip.add_file (',
'          p_zipped_blob => l_zip_file,',
'          p_file_name   => ''import.sql'',',
'          p_content     => l_blob',
'        );',
'      end if;',
'      apex_zip.finish (',
'        p_zipped_blob => l_zip_file ',
'      );',
'      l_blob := l_zip_file;',
'      l_mime_type := ''application/zip'';',
'      l_file_name := ''F4A_''||to_char(systimestamp, ''YYYYMMDD_HH24MISS'')||''.zip'';',
'    end if;',
'',
'    download_file(',
'      p_file_name    => l_file_name,',
'      p_mime_type    => l_mime_type,',
'      p_blob_content => l_blob',
'    );',
'  end download_file;',
'',
'',
'  /* page 6 */',
'',
'',
'  function is_file_uploaded(',
'        pi_file_name in varchar2',
'    )',
'    return boolean',
'    is',
'        l_dgrm_content flow_diagrams.dgrm_content%type;',
'        l_err boolean := true;',
'    begin',
'        begin',
'            select to_clob(blob_content)',
'            into l_dgrm_content',
'            from apex_application_temp_files',
'            where name = pi_file_name;',
'        exception when no_data_found then',
'            l_err := false;',
'        end;',
' ',
'        return l_err;',
'    end is_file_uploaded;',
'    ',
'    ',
'    function is_valid_xml(',
'        pi_import_from  in varchar2,',
'        pi_dgrm_content in flow_diagrams.dgrm_content%type,',
'        pi_file_name    in varchar2',
'    )',
'    return boolean',
'    is',
'        l_dgrm_content flow_diagrams.dgrm_content%type;',
'        l_xmltype xmltype;',
'        l_err boolean := true;',
'    begin',
'        if (pi_import_from = ''text'') then',
'            l_dgrm_content := pi_dgrm_content;',
'        else',
'            select to_clob(blob_content)',
'            into l_dgrm_content',
'            from apex_application_temp_files',
'            where name = pi_file_name;',
'        end if;',
'        begin',
'            l_xmltype := xmltype.createXML(l_dgrm_content);',
'        exception when others then',
'            l_err := false;',
'        end;',
'        return l_err;',
'    end is_valid_xml;',
'    ',
'    ',
'    function is_valid_multi_file_archive(',
'        pi_file_name in varchar2',
'    )',
'    return varchar2',
'    is',
'        l_mime_type    apex_application_temp_files.mime_type%type;',
'        l_blob_content apex_application_temp_files.blob_content%type;',
'        l_error        varchar2(4000);',
'        l_files        apex_zip.t_files;',
'        l_found_json   boolean := false;',
'    begin',
'        select mime_type, blob_content',
'        into l_mime_type, l_blob_content',
'        from apex_application_temp_files',
'        where name = pi_file_name;',
'        if ( l_mime_type != ''application/zip'') then',
'            l_error := ''You should provide a valid Flows for APEX zip export file.'';',
'        else',
'            l_files := apex_zip.get_files(',
'                p_zipped_blob => l_blob_content',
'            );',
'            for i in 1..l_files.count loop',
'                apex_debug.message(l_files(i));',
'                if ( l_files(i) = ''import.json'' ) then',
'                    l_found_json := true;',
'                end if;',
'                exit when l_found_json;',
'            end loop;',
'            if ( l_found_json = false ) then',
'                l_error := ''Missing import.json file in the zip export file.'';',
'            end if;',
'        end if;',
'        return l_error;',
'    end is_valid_multi_file_archive;',
'    ',
'    ',
'    function upload_and_parse(',
'        pi_import_from     in varchar2,',
'        pi_dgrm_name       in flow_diagrams.dgrm_name%type,',
'        pi_dgrm_category   in flow_diagrams.dgrm_category%type,',
'        pi_dgrm_version    in flow_diagrams.dgrm_version%type,',
'        pi_dgrm_content    in flow_diagrams.dgrm_content%type,',
'        pi_file_name       in varchar2,',
'        pi_force_overwrite in varchar2',
'    ) return flow_diagrams.dgrm_id%type',
'    is',
'        l_dgrm_id flow_diagrams.dgrm_id%type;',
'        l_dgrm_content flow_diagrams.dgrm_content%type;',
'        l_dgrm_exists number;',
'    begin',
'        if (pi_import_from = ''text'') then',
'            l_dgrm_content := pi_dgrm_content;',
'        else',
'            select to_clob(blob_content)',
'            into l_dgrm_content',
'            from apex_application_temp_files',
'            where name = pi_file_name;',
'        end if;',
'            ',
'        l_dgrm_id := flow_diagram.import_diagram(',
'            pi_dgrm_name => pi_dgrm_name,',
'            pi_dgrm_version => pi_dgrm_version,',
'            pi_dgrm_category => pi_dgrm_category,',
'            pi_dgrm_content => l_dgrm_content,',
'            pi_force_overwrite => pi_force_overwrite);',
'        return l_dgrm_id;',
'    exception',
'      when flow_diagram.diagram_exists then',
'        apex_error.add_error(',
'            p_message => apex_lang.message(''APP_ERR_MODEL_EXIST'', pi_dgrm_name, pi_dgrm_version)',
'            , p_display_location => apex_error.c_on_error_page);',
'      when flow_diagram.diagram_not_draft then',
'        apex_error.add_error(',
'            p_message => apex_lang.message(''APP_ERR_ONLY_DRAFT'')',
'            , p_display_location => apex_error.c_on_error_page);',
'    end upload_and_parse;',
'    ',
'    ',
'    procedure multiple_flow_import(',
'        pi_file_name       in varchar2,',
'        pi_force_overwrite in varchar2',
'    )',
'    as',
'        l_dgrm_id       flow_diagrams.dgrm_id%type;',
'        l_dgrm_name     flow_diagrams.dgrm_name%type;',
'        l_dgrm_category flow_diagrams.dgrm_category%type;',
'        l_dgrm_version  flow_diagrams.dgrm_version%type;',
'        l_dgrm_content  flow_diagrams.dgrm_content%type;',
'        l_file          varchar2(300);',
'        l_json_array    json_array_t;',
'        l_json_object   json_object_t;',
'        l_blob_content  blob;',
'        l_json_file     blob;',
'        l_bpmn_file     blob;',
'        l_clob          clob;',
'    begin',
'        select blob_content',
'        into l_blob_content',
'        from apex_application_temp_files',
'        where name = pi_file_name;',
'        l_json_file := apex_zip.get_file_content(',
'            p_zipped_blob => l_blob_content,',
'            p_file_name   => ''import.json''',
'        );',
'        l_json_array := json_array_t.parse(l_json_file);',
'        for i in 0..l_json_array.get_size() - 1 loop',
'            l_json_object := treat(l_json_array.get(i) as json_object_t);',
'            l_dgrm_name     := l_json_object.get_String(''dgrm_name'');',
'            l_dgrm_version  := l_json_object.get_String(''dgrm_version'');',
'            l_dgrm_category := l_json_object.get_String(''dgrm_category'');',
'            l_dgrm_name     := l_json_object.get_String(''dgrm_name'');',
'            l_file          := l_json_object.get_String(''file'');   ',
'            l_bpmn_file := apex_zip.get_file_content(',
'                p_zipped_blob => l_blob_content,',
'                p_file_name   => l_file',
'            );',
'            select to_clob(l_bpmn_file)',
'            into l_clob',
'            from dual;',
'            ',
'            l_dgrm_id := upload_and_parse(',
'                  pi_import_from => ''text''',
'                , pi_dgrm_name => l_dgrm_name',
'                , pi_dgrm_category => l_dgrm_category',
'                , pi_dgrm_version => l_dgrm_version',
'                , pi_dgrm_content => l_clob',
'                , pi_file_name => null',
'                , pi_force_overwrite => pi_force_overwrite',
'            );',
'        end loop;',
'    end multiple_flow_import;',
'',
'',
'  /* page 7 */',
'  ',
'',
'  function validate_new_version(',
'    pi_dgrm_name    in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version in flow_diagrams.dgrm_version%type',
'  ) return varchar2',
'  as',
'    l_err varchar2(4000);',
'  begin',
'    ',
'    if (pi_dgrm_version is null) then',
'        l_err := apex_lang.message(p_name => ''APEX.PAGE_ITEM_IS_REQUIRED''); --''#LABEL# must have a value'';',
'    elsif check_flow_exists(pi_dgrm_name, pi_dgrm_version) then',
'        l_err := apex_lang.message(p_name => ''APP_ERR_MODEL_VERSION_EXIST'');',
'    end if;',
'    return l_err;',
'  end validate_new_version;',
'  ',
'',
'  procedure process_page_p7(',
'    pio_dgrm_id      in out nocopy flow_diagrams.dgrm_id%type,',
'    pi_dgrm_name     in flow_diagrams.dgrm_name%type,',
'    pi_dgrm_version  in flow_diagrams.dgrm_version%type,',
'    pi_dgrm_category in flow_diagrams.dgrm_category%type,',
'    pi_new_version   in flow_diagrams.dgrm_version%type,',
'    pi_cascade       in varchar2,',
'    pi_request       in varchar2)',
'  as',
'  begin',
'    case pi_request',
'      when ''CREATE'' then',
'        pio_dgrm_id := flow_diagram.create_diagram(',
'                         pi_dgrm_name => pi_dgrm_name,',
'                         pi_dgrm_category => pi_dgrm_category,',
'                         pi_dgrm_version => pi_dgrm_version);',
'      when ''SAVE'' then',
'        flow_diagram.edit_diagram(',
'          pi_dgrm_id => pio_dgrm_id,',
'          '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'pi_dgrm_name => pi_dgrm_name,',
'          pi_dgrm_category => pi_dgrm_category,',
'          pi_dgrm_version => pi_dgrm_version);',
'      when ''DELETE'' then',
'        flow_diagram.delete_diagram(',
'          pi_dgrm_id => pio_dgrm_id,',
'          pi_cascade => pi_cascade);',
'      when ''ADD_VERSION'' then',
'        pio_dgrm_id := flow_diagram.add_diagram_version(',
'          pi_dgrm_id => pio_dgrm_id,',
'          pi_dgrm_version => pi_new_version);',
'      when ''RELEASE'' then',
'        flow_diagram.release_diagram(',
'          pi_dgrm_id => pio_dgrm_id);',
'      when ''DEPRECATE'' then',
'        flow_diagram.deprecate_diagram(',
'          pi_dgrm_id => pio_dgrm_id);',
'      when ''ARCHIVE'' then',
'        flow_diagram.archive_diagram(',
'          pi_dgrm_id => pio_dgrm_id);',
'      else',
'        raise_application_error(-20002, ''Unknown operation requested.'');',
'    end case;',
'    exception',
'      when flow_diagram.diagram_exists then',
'        apex_error.add_error(',
'            p_message => apex_lang.message(''APP_ERR_MODEL_EXIST'', pi_dgrm_name, pi_dgrm_version)',
'            , p_display_location => apex_error.c_on_error_page);',
'  end process_page_p7;',
'  ',
'  ',
'  function get_page_title(',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_dgrm_name    in flow_diagrams.dgrm_name%type',
'  , pi_dgrm_version in flow_diagrams.dgrm_version%type',
'  ) return varchar2',
'  as',
'    l_page_title varchar2(128 byte);',
'  begin',
'    case ',
'    when pi_dgrm_id is null then ',
'      l_page_title := apex_lang.message(',
'                        p_name => ''APP_TITLE_NEW_MODEL''',
'                      );',
'    else ',
'      l_page_title := apex_lang.message(',
'                        p_name => ''APP_TITLE_MODEL'',',
'                        p0 => pi_dgrm_name,',
'                        p1 => pi_dgrm_version',
'                      );',
'    end case;',
'    return l_page_title;',
'  end get_page_title;',
'',
'  function get_current_diagram',
'    ( pi_dgrm_name              in flow_diagrams.dgrm_name%type',
'    , pi_dgrm_calling_method    in flow_types_pkg.t_bpmn_attribute_vc2',
'    , pi_dgrm_version           in flow_diagrams.dgrm_version%type',
'    )',
'  return flow_diagrams.dgrm_id%type',
'    -- gets the current dgrm_id to be used for a diagram name.',
'    -- returns the current ''released'' diagram or a ''draft'' of version ''0'' ',
'  is',
'    l_dgrm_id     flow_diagrams.dgrm_id%type;',
'  begin',
'    case pi_dgrm_calling_method ',
'    when flow_constants_pkg.gc_dgrm_version_latest_version then',
'      begin ',
'        -- look for the ''released'' version of the diagram',
'        select dgrm_id ',
'          into l_dgrm_id',
'          from flow_diagrams',
'         where dgrm_name = pi_dgrm_name',
'           and dgrm_status = flow_constants_pkg.gc_dgrm_status_released',
'        ;',
'        return l_dgrm_id;',
'      exception',
'        when no_data_found then',
'          -- look for the version 0 (default) of ''draft'' of the diagram',
'          begin',
'            select dgrm_id',
'              into l_dgrm_id',
'              from flow_diagrams',
'             where dgrm_name = pi_dgrm_name',
'               and dgrm_status = flow_constants_pkg.gc_dgrm_status_draft',
'               and dgrm_version = ''0''',
'            ;',
'            return l_dgrm_id;',
'          exception',
'            when no_data_found then',
'              null;',
'          end;  ',
'      end;',
'',
'    when flow_constants_pkg.gc_dgrm_version_named_version then',
'      -- dgrm_version was specified',
'      begin',
'        select dgrm_id',
'          into l_dgrm_id',
'          from flow_diagrams',
'         where dgrm_name = pi_dgrm_name',
'           and dgrm_version = pi_dgrm_version',
'        ;',
'      exception',
'        when no_data_found then',
'          null;',
'      end;',
'    end case;',
'    return l_dgrm_id;',
'  end get_current_diagram;',
'',
'',
'  /* page 8 */',
'',
'',
'  function check_is_date(',
'    pi_value       in varchar2,',
'    pi_format_mask in varchar2)',
'  return varchar2 ',
'  as',
'    l_dummy_date date;',
'  begin ',
'    l_dummy_date := to_date(pi_value, pi_format_mask);',
'    return flow_constants_pkg.gc_true;',
'  exception',
'    when others then  ',
'      return flow_constants_pkg.gc_false;',
'  end check_is_date;',
'',
'  function check_is_tstz(',
'    pi_value       in varchar2,',
'    pi_format_mask in varchar2)',
'  return varchar2',
'  as',
'    l_dummy_tstz timestamp with time zone;',
'  begin ',
'    l_dummy_tstz := to_timestamp_tz(pi_value, pi_format_mask);',
'    return flow_constants_pkg.gc_true;',
'  exception',
'    when others then  ',
'      return flow_constants_pkg.gc_false;',
'  end check_is_tstz;',
'',
'  function check_is_number(',
'    pi_value in varchar2)',
'  return varchar2 ',
'  as',
'    l_dummy_number number;',
'  begin ',
'    l_dummy_number := to_number(pi_value);',
'    return flow_constants_pkg.gc_true;',
'  exception',
'    when others then  ',
'      return flow_constants_pkg.gc_false;',
'  end check_is_number;',
'  ',
'  ',
'  procedure pass_variable',
'  as',
'    l_prov_prcs_id  flow_process_variables.prov_prcs_id%type;',
'    l_prov_var_name flow_process_variables.prov_var_name%type;',
'    l_prov_var_type flow_process_variables.prov_var_type%type;',
'    l_prov_scope    flow_process_variables.prov_scope%type;',
'    l_prov_var_vc2  flow_process_variables.prov_var_vc2%type;',
'    l_prov_var_num  flow_process_variables.prov_var_num%type;',
'    l_prov_var_date flow_process_variables.prov_var_date%type;',
'    l_prov_var_tstz flow_process_variables.prov_var_tstz%type;',
'    l_prov_var_clob flow_process_variables.prov_var_clob%type;',
'    l_prov_var_json flow_process_variables.prov_var_json%type;',
'  begin',
'    -- Initialize',
'    l_prov_prcs_id  := apex_application.g_x01;',
'    l_prov_var_name := apex_application.g_x02;',
'    l_prov_var_type := apex_application.g_x03;',
'    l_prov_scope    := apex_application.g_x04;',
'    ',
'    case l_prov_var_type',
'      when ''VARCHAR2'' then',
'        l_prov_var_vc2 := flow_process_vars.get_var_vc2(',
'                            pi_prcs_id  => l_prov_prcs_id,',
'                            pi_var_name => l_prov_var_name,',
'                            pi_scope    => l_prov_scope);',
'      when ''NUMBER'' then',
'        l_prov_var_num := flow_process_vars.get_var_num(',
'                            pi_prcs_id  => l_prov_prcs_id,',
'                            pi_var_name => l_prov_var_name,',
'                            pi_scope    => l_prov_scope);',
'      when ''DATE'' then',
'        l_prov_var_date := flow_process_vars.get_var_date(',
'                             pi_prcs_id  => l_prov_prcs_id,',
'                             pi_var_name => l_prov_var_name,',
'                             pi_scope    => l_prov_scope);',
'      when ''TIMESTAMP WITH TIME ZONE'' then',
'        l_prov_var_tstz := flow_process_vars.get_var_tstz(',
'                             pi_prcs_id  => l_prov_prcs_id,',
'                             pi_var_name => l_prov_var_name,',
'                             pi_scope    => l_prov_scope);',
'      when ''CLOB'' then',
'          l_prov_var_clob := flow_process_vars.get_var_clob(',
'                               pi_prcs_id  => l_prov_prcs_id,',
'                               pi_var_name => l_prov_var_name,',
'                               pi_scope    => l_prov_scope);',
'      when ''JSON'' then',
'          l_prov_var_json := flow_process_vars.get_var_json(',
'                               pi_prcs_id  => l_prov_prcs_id,',
'                               pi_var_name => l_prov_var_name,',
'                               pi_scope    => l_prov_scope);                         ',
'    end case;',
'    ',
'    apex_json.open_object;',
'    apex_json.write( p_name => ''success'', p_value => not apex_error.have_errors_occurred );',
'    apex_json.write( p_name => ''vc2_value'', p_value => l_prov_var_vc2);',
'    apex_json.write( p_name => ''num_value'', p_value => to_char(l_prov_var_num));',
'    apex_json.write( p_name => ''date_value'', p_value => to_char(l_prov_var_date, v(''APP_DATE_TIME_FORMAT'')));',
'    apex_json.write( p_name => ''tstz_value'', p_value => to_char(l_prov_var_tstz, flow_constants_pkg.gc_prov_default_tstz_format));',
'    apex_json.write( p_name => ''clob_value'', p_value => l_prov_var_clob);',
'    apex_json.write( p_name => ''json_value'', p_value => l_prov_var_json);',
'    apex_json.close_all;',
'    ',
'  end pass_variable;',
'    ',
'  ',
'  function get_connection_select_option(',
'    pi_gateway in flow_objects.objt_bpmn_id%type',
'  , pi_prdg_id in flow_instance_diagrams.prdg_id%type',
'  ) return varchar2',
'  as',
'    l_select_option flow_instance_gateways_lov.select_option%type;',
'  begin',
'    select select_option',
'      into l_select_option',
'      from flow_instance_gateways_lov',
'     where objt_bpmn_id = pi_gateway',
'       and prdg_id = pi_prdg_id;',
'    return l_select_option;',
'  end get_connection_select_option;',
'',
'   function get_scope(',
'      pi_gateway in flow_objects.objt_bpmn_id%type',
'    , pi_prdg_id in flow_instance_diagrams.prdg_id%type',
'  ) return number',
'  as ',
'    l_prdg_diagram_level flow_instance_gateways_lov.prdg_diagram_level%type;',
'  begin',
'    select prdg_diagram_level',
'      into l_prdg_diagram_level',
'      from flow_instance_gateways_lov',
'     where objt_bpmn_id = pi_gateway',
'       and prdg_id = pi_prdg_id;',
'    return l_prdg_diagram_level;',
'    ',
'  end get_scope;',
'',
'  procedure download_instance_summary(',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  )',
'  is',
'    l_summary   clob;',
'    l_file_name varchar2(300 char);',
'    l_blob      blob;',
'  begin',
'    select prcs_id ||''_''|| prcs_name || ''_'' || to_char(current_date, ''YYYYDDMM_HH24MISS'')',
'      into l_file_name',
'      from flow_instances_vw',
'     where prcs_id = pi_prcs_id;',
'',
'    l_file_name := sanitize_file_name(l_file_name)||''.json'';',
'',
'    l_summary := flow_admin_api.instance_summary(p_process_id => pi_prcs_id);',
'    l_blob := clob_to_blob(l_summary);',
'    download_file(',
'      p_file_name    => l_file_name,',
'      p_mime_type    => ''application/json'',',
'      p_blob_content => l_blob',
'    );',
'  end download_instance_summary;',
'',
'  /* page 11 */',
'',
'',
'  function create_instance(',
'    pi_dgrm_id      in flow_diagrams.dgrm_id%type',
'  , pi_prcs_name    in flow_processes.prcs_name%type',
'  , pi_business_ref in flow_process_variables.prov_var_vc2%type',
'  ) return flow_processes.prcs_id%type',
'  as',
'    l_prcs_id flow_processes.prcs_id%type;',
'  begin',
'    l_prcs_id := flow_api_pkg.flow_create( ',
'                   pi_dgrm_id   => pi_dgrm_id,',
'                   pi_prcs_name => pi_prcs_name);',
'    ',
'    if pi_business_ref is not null then',
'      flow_process_vars.set_var( ',
'        pi_prcs_id   => l_prcs_id,',
'        pi_var_name  => ''BUSINESS_REF'',',
'        pi_vc2_value => pi_business_ref,',
'        pi_scope => 0);',
'    end if;',
'    return l_prcs_id; ',
'  end create_instance;',
'',
'',
'  /* page 12 */',
'  ',
'  ',
'  function get_prcs_name(',
'    pi_prcs_id in flow_processes.prcs_id%type',
'  ) return flow_processes.prcs_name%type',
'  as',
'    l_prcs_name flow_processes.prcs_name%type;',
'  begin',
'    select prcs_name ',
'      into l_prcs_name',
'      from flow_instances_vw ',
'     where prcs_id = pi_prcs_id;',
'    return l_prcs_name;',
'  end get_prcs_name;',
'  ',
'',
'  /* page 13 */',
'',
'',
'  function has_error(',
'    pi_prcs_id in flow_processes.prcs_id%type,',
'    pi_objt_id in flow_subflows.sbfl_current%type)',
'  return boolean ',
'  as',
'    l_has_error binary_integer;',
'  begin',
'    select count(*)',
'      into l_has_error',
'      from flow_subflows_vw',
'     where sbfl_prcs_id = pi_prcs_id ',
'       and sbfl_current = pi_objt_id',
'       and sbfl_status = ''error''',
'       and exists (',
'           select null',
'             from FLOW_P0013_INSTANCE_LOG_VW',
'            where lgpr_prcs_id = pi_prcs_id ',
'              and lgpr_objt_id = pi_objt_id);',
'              ',
'    return l_has_error = 1;',
'  end has_error;',
'',
'',
'  /* page 51 */',
'  ',
'',
'  procedure process_page_p51',
'  (',
'    pio_sfte_id       in out nocopy flow_simple_form_templates.sfte_id%type',
'  , pi_sfte_name      in flow_simple_form_templates.sfte_name%type',
'  , pi_sfte_static_id in flow_simple_form_templates.sfte_static_id%type',
'  , pi_sfte_content   in flow_simple_form_templates.sfte_content%type',
'  , pi_request        in varchar2)',
'  as',
'  begin',
'    case pi_request',
'      when ''CREATE'' then',
'        pio_sfte_id := flow_simple_form_template.create_template(',
'                         pi_sfte_name => pi_sfte_name,',
'                         pi_sfte_static_id => pi_sfte_static_id,',
'                         pi_sfte_content => pi_sfte_content);',
'      when ''SAVE'' then',
'        flow_simple_form_template.edit_template(',
'          pi_sfte_id => pio_sfte_id,',
'          pi_sfte_name => pi_sfte_name,',
'          pi_sfte_static_id => pi_sfte_static_id,',
'          pi_sfte_content => pi_sfte_content);',
'      when ''DELETE'' then',
'        flow_simple_form_template.delete_template(',
'          pi_sfte_id => pio_sfte_id);',
'      else',
'        raise_application_error(-20002, ''Unknown operation requested.'');',
'    end case;',
'    exception',
'      when flow_simple_form_template.template_exists then',
'        apex_error.add_error(',
'            p_message => apex_lang.message(''APP_ERR_TEMPLATE_EXIST'', pi_sfte_static_id)',
'            , p_display_location => apex_error.c_on_error_page);',
'  end process_page_p51;',
'',
'',
'  /* configuration */',
'',
'',
'  procedure set_logging_settings(',
'    pi_logging_language          in flow_configuration.cfig_value%type',
'  , pi_logging_level             in flow_configuration.cfig_value%type',
'  , pi_logging_hide_userid       in flow_configuration.cfig_value%type',
'  , pi_logging_retain_logs       in flow_configuration.cfig_value%type',
'  , pi_logging_message_flow_recd in flow_configuration.cfig_value%type',
'  , pi_logging_retain_msg_flow   in flow_configuration.cfig_value%type',
'  )',
'  as',
'  begin',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_language          , p_value => pi_logging_language);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_level             , p_value => pi_logging_level);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_hide_userid       , p_value => pi_logging_hide_userid);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_retain_logs       , p_value => pi_logging_retain_logs);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_message_flow_recd , p_value => pi_logging_message_flow_recd);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_retain_msg_flow   , p_value => pi_logging_retain_msg_flow);',
'',
'  end set_logging_settings;',
'',
'',
'  procedure set_archiving_settings(',
'    pi_archiving_enabled  in flow_configuration.cfig_value%type',
'  )',
'  as',
'  begin',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_logging_archive_enabled  , p_value => pi_archiving_enabled);',
'',
'  end set_archiving_settings;',
'',
'',
'  procedure set_statictis_settings(',
'    pi_stats_retain_daily in flow_configuration.cfig_value%type',
'  , pi_stats_retain_month in flow_configuration.cfig_value%type',
'  , pi_stats_retain_qtr   in flow_configuration.cfig_value%type',
'  )',
'  as',
'  begin',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_daily  , p_value => pi_stats_retain_daily);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_month , p_value => pi_stats_retain_month);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_stats_retain_summary_qtr , p_value => pi_stats_retain_qtr);',
'',
'  end set_statictis_settings;',
'',
'',
'  procedure set_engine_app_settings(',
'    pi_engine_app_mode in flow_configuration.cfig_value%type',
'  )',
'  as',
'  begin',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_engine_app_mode , p_value => pi_engine_app_mode);',
'',
'  end set_engine_app_settings;',
'',
'',
'  procedure set_engine_settings(',
'    pi_duplicate_step_prevention in flow_configuration.cfig_value%type',
'  , pi_default_workspace         in flow_configuration.cfig_value%type',
'  , pi_default_email_sender      in flow_configuration.cfig_value%type',
'  , pi_default_application       in flow_configuration.cfig_value%type',
'  , pi_default_pageid            in flow_configuration.cfig_value%type',
'  , pi_default_username          in flow_configuration.cfig_value%type',
'  )',
'  as',
'  begin',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_dup_step_prevention  , p_value => pi_duplicate_step_prevention);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_default_workspace    , p_value => pi_default_workspace);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_default_email_sender , p_value => pi_default_email_sender);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_default_application  , p_value => pi_default_application);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_default_pageid       , p_value => pi_default_pageid);',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_default_username     , p_value => pi_default_username);',
'',
'  end set_engine_settings;',
'',
'',
'  procedure set_timers_settings(',
'    pi_timer_max_cycles      in flow_configuration.cfig_value%type',
'  , pi_timer_status          in sys.all_scheduler_jobs.enabled%type',
'  , pi_timer_repeat_interval in sys.all_scheduler_jobs.repeat_interval%type',
'  )',
'  as',
'  begin',
'      flow_engine_util.set_config_value( p_config_key => flow_constants_pkg.gc_config_timer_max_cycles , p_value => pi_timer_max_cycles);',
'',
'      case pi_timer_status',
'      when ''TRUE''  then flow_timers_pkg.enable_scheduled_job;',
'      when ''FALSE'' then flow_timers_pkg.disable_scheduled_job;',
'      end case;',
'',
'      flow_timers_pkg.set_timer_repeat_interval( p_repeat_interval => pi_timer_repeat_interval);',
'',
'  end set_timers_settings;',
'',
'',
'end flow_engine_app_api;',
'/',
'',
'create or replace package body flow_theme_api ',
'as',
'  subtype small_char is varchar2(128 byte);',
'  ',
'  C_UNIVERSAL_THEME    constant number := 42;',
'  C_THEME_PLUGIN_CLASS constant small_char := ''THEME_PLUGIN_CLASS'';',
'  C_FLOWS              constant small_char := ''FLOWS'';',
'  C_FLOWS_DARK         constant small_char := ''FLOWS-DARK'';',
'  C_VITA               constant small_char := ''Vita'';',
'  C_VITA_DARK          constant small_char := ''Vita - Dark''; ',
'  C_LIGHT              constant small_char := ''light'';',
'  C_DARK               constant small_char := ''dark'';',
'  ',
'  /* Helper */',
'  function file_exists(',
'    p_file_name in varchar2',
'  ) return boolean',
'  as',
'    l_file_exists binary_integer;',
'  begin',
'    select count(*)',
'      into l_file_exists',
'      from dual',
'     where exists(',
'           select null',
'             from apex_application_static_files',
'            where file_name = p_file_name',
'              and application_id = apex_application.g_flow_id);',
'    return l_file_exists = 1;',
'  end file_exists;',
'  ',
'  function get_user_theme_preference(',
'    pi_theme_mode in varchar2',
'  ) return varchar2',
'  as',
'    l_theme_style_id apex_application_theme_styles.theme_style_id%type;',
'    l_theme_name     apex_application_theme_styles.name%type;',
'  begin',
'    l_theme_style_id := apex_theme.get_user_style(apex_application.g_flow_id, apex_application.g_user, C_UNIVERSAL_THEME);',
'    ',
'    select s.name',
'      into l_theme_name',
'      from apex_application_theme_styles s',
'      join apex_application_themes t',
'        on s.application_id = t.application_id',
'       and s.theme_number = t.theme_number',
'     where s.application_id = apex_application.g_flow_id',
'       and s.theme_style_id = l_theme_style_id;',
'    return l_theme_name;',
'  exception',
'    when no_data_found then ',
'      return pi_theme_mode;',
'  end get_user_theme_preference;',
'  ',
'  ',
'  /* Interface */',
'  procedure switch_theme_mode(',
'    pi_request in varchar2',
'  ) ',
'  as',
'    l_theme_style_id     number;',
'    l_theme_name         small_char;',
'    l_theme_plugin_class small_char;',
'  begin',
'',
'    apex_util.set_preference (',
'        p_preference => ''THEME_MODE'',',
'        p_value      => ''static'',',
'        p_user       => apex_application.g_user',
'    );',
'    ',
'    case pi_request',
'      when ''LIGHT_MODE'' then ',
'        l_theme_name := C_VITA; ',
'        l_theme_plugin_class := C_FLOWS;',
'      when ''DARK_MODE'' then ',
'        l_theme_name := C_VITA_DARK; ',
'        l_theme_plugin_class := C_FLOWS_DARK;',
'      else null;',
'    end case;',
'    ',
'    select s.theme_style_id',
'      into l_theme_style_id',
'      from apex_application_theme_styles s',
'      join apex_application_themes t',
'        on s.application_id = t.application_id',
'       and s.theme_number = t.theme_number',
'     where s.application_id = apex_application.g_flow_id',
'       and s.name = l_theme_name;',
'',
'    apex_theme.set_user_style (',
'      p_application_id => apex_application.g_flow_id',
'    , p_user           => apex_application.g_user',
'    , p_theme_number   => C_UNIVERSAL_THEME',
'    , p_id             => l_theme_style_id',
'    );',
'  ',
'    apex_theme.set_session_style(',
'      p_theme_number => C_UNIVERSAL_THEME',
'    , p_name         => l_theme_name',
'    );',
'    ',
'    apex_util.set_session_state(',
'      p_name  => C_THEME_PLUGIN_CLASS',
'    , p_value => l_theme_plugin_class',
'    );',
'  end switch_theme_mode;',
'',
'  procedure reset_theme_mode(',
'    pi_request in varchar2',
'  )',
'  as',
'    l_theme_style_id     number;',
'    l_theme_name         small_char;',
'    l_theme_plugin_class small_char;',
'  begin',
'',
'    apex_util.set_preference (',
'      p_preference => ''THEME_MODE''',
'    , p_value      => ''automatic''',
'    , p_user       => apex_application.g_user',
'    );',
'    ',
'    case pi_request ',
'      when ''RESET_LIGHT'' then ',
'        l_theme_name := C_VITA; ',
'        l_theme_plugin_class := C_FLOWS;',
'      when ''RESET_DARK'' then ',
'        l_theme_name := C_VITA_DARK; ',
'        l_theme_plugin_class := C_FLOWS_DARK;',
'      else null;',
'    end case;',
'',
'    select s.theme_style_id',
'      into l_theme_style_id',
'      from apex_application_theme_styles s, apex_application_themes t',
'     where s.application_id = t.application_id',
'       and s.theme_number = t.theme_number',
'       and s.application_id = apex_application.g_flow_id',
'       and s.name = l_theme_name;',
'',
'     apex_theme.set_user_style (',
'        p_application_id => apex_application.g_flow_id',
'      , p_user           => apex_application.g_user',
'      , p_theme_number   => C_UNIVERSAL_THEME',
'      , p_id             => l_theme_style_id ',
'    );',
'    ',
'    apex_theme.set_session_style(',
'      p_theme_number => C_UNIVERSAL_THEME',
'    , p_name         => l_theme_name',
'    );',
'    ',
'    apex_util.set_session_state(',
'      p_name  => C_THEME_PLUGIN_CLASS',
'    , p_value => l_theme_plugin_class',
'    );',
'  end reset_theme_mode;',
'',
'  procedure set_init_theme_mode ',
'  as',
'    l_theme_style_id        number;',
'    l_theme_name            apex_application_theme_styles.name%type;',
'    l_theme_plugin_class    small_char;',
'    l_url                   varchar2(4000);',
'    l_theme_mode_preference small_char;',
'  begin',
'',
'    l_theme_mode_preference := apex_util.get_preference (',
'        p_preference => ''THEME_MODE'',',
'        p_user       => apex_application.g_user',
'    );',
'    ',
'    if l_theme_mode_preference = ''automatic'' then',
'        l_theme_name := v(''P9999_THEME_MODE'');',
'    end if;',
'    ',
'    if l_theme_name is null then',
'        begin',
'            select s.name',
'              into l_theme_name',
'              from apex_application_theme_styles s, apex_application_themes t',
'             where s.application_id = t.application_id',
'               and s.theme_number = t.theme_number',
'               and s.application_id = apex_application.g_flow_id',
'               and s.theme_style_id = apex_theme.get_user_style(',
'                                        apex_application.g_flow_id',
'                                      , apex_application.g_user',
'                                      , C_UNIVERSAL_THEME',
'                                      );',
'        exception',
'            when no_data_found',
'            then l_theme_name := C_VITA;',
'        end;',
'    end if;',
'    ',
'    select s.theme_style_id',
'      into l_theme_style_id',
'      from apex_application_theme_styles s, apex_application_themes t',
'     where s.application_id = t.application_id',
'       and s.theme_number = t.theme_number',
'       and s.application_id = apex_application.g_flow_id',
'       and s.name = l_theme_name;',
'',
'    apex_theme.set_user_style (',
'        p_application_id => apex_application.g_flow_id',
'      , p_user           => apex_application.g_user',
'      , p_theme_number   => C_UNIVERSAL_THEME',
'      , p_id            => l_theme_style_id ',
'    );',
'    ',
'    apex_theme.set_session_style(',
'      p_theme_number => C_UNIVERSAL_THEME',
'    , p_name => l_theme_name',
'    );',
'    ',
'    case l_theme_name ',
'      when C_VITA then l_theme_plugin_class := C_FLOWS;',
'      when C_VITA_DARK then l_theme_plugin_class := C_FLOWS_DARK;',
'      else null;',
'    end case;',
'    ',
'    apex_util.set_session_state(',
'        p_name => ''THEME_PLUGIN_CLASS'',',
'        p_value => l_theme_plugin_class',
'    );',
'  end set_init_theme_mode;',
'  ',
'  procedure css_tricks(',
'    pi_theme_plugin_class in varchar2',
'  )',
'  as',
'    l_user_style_id number;',
'    l_theme_mode        small_char;',
'    l_theme_css         small_char;',
'    l_directory         small_char;',
'    l_filename          small_char;',
'    l_filename_css      small_char;',
'    l_filename_minified small_char;',
'  begin',
'    -- Initialize',
'    l_theme_mode := case pi_theme_plugin_class when C_FLOWS then C_VITA else C_VITA_DARK end;',
'    ',
'    -- Overwrite l_theme_mode with user preference if it exists',
'    l_theme_mode := get_user_theme_preference(l_theme_mode);',
'    ',
'    l_theme_css := case l_theme_mode when C_VITA then C_LIGHT else C_DARK end;',
'',
'    -- load theme specific file',
'    l_directory := ''css/'';',
'    l_filename := ''flows4apex.'' || l_theme_css;',
'    l_filename_css := l_directory || l_filename || ''.css'';',
'    l_filename_minified := l_filename || ''#MIN#'';',
'',
'    if file_exists(l_filename_css) then   ',
'      apex_css.add_file(',
'        p_name      => l_filename_minified',
'      , p_directory => ''#APP_IMAGES#'' || l_directory',
'      );',
'    end if;',
'    ',
'    -- load version specific file',
'    select ''css/'' || substr(version_no, 1, 4) || ''/''',
'      into l_directory',
'      from apex_release;',
'    l_filename_css := l_directory || l_filename || ''.css'';',
'',
'    if file_exists(l_filename_css) then',
'      apex_css.add_file(',
'        p_name      => l_filename_minified',
'      , p_directory => ''#APP_IMAGES#'' || l_directory',
'      );',
'    end if;',
'    ',
'    -- load prism file',
'    apex_css.add_file(',
'      p_name      => ''prism'' || case l_theme_mode when C_VITA_DARK then ''.dark'' end ||''#MIN#''',
'    , p_directory => ''#APP_IMAGES#lib/prismjs/css/''',
'    ); ',
'  end css_tricks;',
'',
'end flow_theme_api;',
'/',
'create or replace package body flow_plugin_manage_instance as',
'',
'   procedure log_attributes(',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   )',
'   is',
'   begin',
'',
'      apex_debug.info(',
'           p_message => '' > Process plug-in attributes''',
'      );',
'      apex_debug.info(',
'           p_message => ''...Action: %s''',
'         , p0        => p_process.attribute_01',
'      );',
'      ',
'      apex_debug.info(',
'           p_message => ''...Flow %s define by: %s''',
'         , p0        => case ',
'                           when p_process.attribute_01 in ( ''create'', ''create_and_start'' ) then  ',
'                              ''Diagram''',
'                           else ',
'                              ''Instance ID''',
'                        end',
'         , p1        => p_process.attribute_03',
'      );',
'',
'      if p_process.attribute_03 = ''item'' then ',
'         apex_debug.info(',
'            p_message => ''......Item used: %s - Session state value: %s''',
'            , p0        => p_process.attribute_04',
'            , p1        => apex_util.get_session_state(p_item => p_process.attribute_02)',
'         );',
'      elsif p_process.attribute_03 = ''sql''  then',
'         apex_debug.info(',
'            p_message => ''......Query''',
'         );',
'         apex_debug.log_long_message(',
'              p_message => p_process.attribute_06',
'            , p_level   => apex_debug.c_log_level_info',
'         );',
'      elsif p_process.attribute_03 = ''static''  then',
'         apex_debug.info(',
'              p_message => ''......Static value: %s''',
'            , p0        => p_process.attribute_05',
'         );',
'      elsif p_process.attribute_03 = ''component'' then',
'        apex_debug.info(',
'            p_message => ''......Component Setting: %s''',
'            , p0        => p_plugin.attribute_01',
'         );',
'      end if;',
'',
'      if p_process.attribute_09 is not null then',
'         apex_debug.info(',
'            p_message => ''...Return Instance ID into: %s''',
'            , p0        => p_process.attribute_09',
'         );',
'      end if;',
'',
'      if p_process.attribute_01 in ( ''create'', ''create_and_start'' ) then',
'',
'         if p_process.attribute_08 is not null then',
'            apex_debug.info(',
'               p_message => ''...Process Variable BUSINESS_REF set with item: %s - Session State Value: %s''',
'               , p0        => p_process.attribute_08',
'               , p1        => apex_util.get_session_state( p_process.attribute_08 )',
'            );',
'         end if;',
'      end if;',
'',
'      if p_process.attribute_01 in ( ''create'', ''create_and_start'', ''start'' ) then',
'         apex_debug.info(',
'            p_message => ''...Set Process Variables: %s''',
'            , p0        => p_process.attribute_10',
'         );',
'         if p_process.attribute_10 = ''json'' then',
'            apex_debug.info(',
'               p_message => ''......JSON''',
'            );',
'            apex_debug.log_long_message(',
'               p_message => p_process.attribute_11',
'               , p_level   => ap'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ex_debug.c_log_level_info',
'            );',
'         elsif p_process.attribute_10 = ''sql'' then',
'            apex_debug.info(',
'               p_message => ''......Query''',
'            );',
'            apex_debug.log_long_message(',
'               p_message => p_process.attribute_12',
'               , p_level   => apex_debug.c_log_level_info',
'            );',
'         end if;',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => '' < Process plug-in attributes''',
'      );',
'   end log_attributes;',
'',
'   function execution (',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   ) return apex_plugin.t_process_exec_result ',
'   as',
'      l_result          apex_plugin.t_process_exec_result;',
'',
'      --exceptions',
'      e_missing_version          exception;',
'      e_incorrect_variable_type  exception;',
'      e_invalid_json             exception;',
'',
'      --attributes',
'      l_attribute1      p_process.attribute_01%type := p_process.attribute_01; -- Action (create/start/create_and_start/reset/delete)',
'      l_attribute2      p_process.attribute_02%type := p_process.attribute_02; -- Flow Instance Name',
'      l_attribute3      p_process.attribute_03%type := p_process.attribute_03; -- Select Flow using (static/item/sql/component)',
'      l_attribute4      p_process.attribute_04%type := p_process.attribute_04; -- APEX item(s) for Instance or Diagram',
'      l_attribute5      p_process.attribute_05%type := p_process.attribute_05; -- Static Text for Instance or Diagram',
'      l_attribute6      p_process.attribute_06%type := p_process.attribute_06; -- SQL Query for Instance or Diagram',
'      l_attribute7      p_process.attribute_07%type := p_process.attribute_07; -- Flow (Diagram) selection based on',
'      l_attribute8      p_process.attribute_08%type := p_process.attribute_08; -- Set Business Reference',
'      l_attribute9      p_process.attribute_09%type := p_process.attribute_09; -- Return Instance ID',
'      l_attribute10     p_process.attribute_10%type := p_process.attribute_10; -- Set Process Variables (json/sql)',
'      l_attribute11     p_process.attribute_11%type := p_process.attribute_11; -- JSON (variables)',
'      l_attribute12     p_process.attribute_12%type := p_process.attribute_12; -- SQL (variables)',
'',
'      l_g_attribute1    p_plugin.attribute_01%type  := p_plugin.attribute_01;  -- Global Flow',
'',
'      l_context                  apex_exec.t_context;',
'      l_dgrm_id                  flow_diagrams.dgrm_id%type;',
'      l_dgrm_name                flow_diagrams.dgrm_name%type;',
'      l_dgrm_version             flow_diagrams.dgrm_version%type;',
'      l_prcs_name                flow_processes.prcs_name%type;',
'      l_prcs_id                  flow_processes.prcs_id%type;',
'      l_json                     clob;',
'      l_process_variables        json_array_t;',
'      l_process_variables_count  number;',
'      l_process_variable         json_object_t;',
'      l_var_name                 varchar2(4000);',
'      l_var_type                 varchar2(4000);',
'      l_split_values             apex_t_varchar2;',
'',
'   begin',
'',
'      --debug',
'      log_attributes(',
'           p_plugin   => p_plugin',
'         , p_process  => p_process',
'      );',
'',
'      apex_debug.info(',
'         p_message => '' > Start %s instance.''',
'         , p0      => case l_attribute1',
'                         when ''start'' then ''starting''',
'                         when ''delete'' then ''deleting''',
'                         when ''reset'' then ''reseting''',
'                         when ''terminate'' then ''terminating''',
'                         when ''create'' then ''creating''',
'                         when ''create_and_start'' then ''creating and starting''',
'                      end  ',
'      );',
'',
'      if l_attribute3 = ''item'' then',
'         if l_attribute1 in ( ''start'', ''delete'', ''reset'', ''terminate'' ) then',
'            l_prcs_id  := apex_util.get_session_state( p_item => l_attribute4 );',
'         else',
'            --Flow is define by name only',
'            if l_attribute7 = ''name'' then',
'               l_dgrm_name := apex_util.get_session_state( p_item => l_attribute4 );',
'            --Flow is define by name and version',
'            elsif l_attribute7 = ''name_and_version'' then',
'               --Value is coma separated',
'               l_split_values  := apex_string.split( l_attribute4, '','' );',
'               --Check if item value contains two values otherwise raise error',
'               if (l_split_values.count != 2) then',
'                  raise e_missing_version;',
'               end if;',
'               l_dgrm_name     := apex_util.get_session_state(p_item => l_split_values(1));',
'               l_dgrm_version  := apex_util.get_session_state(p_item => l_split_values(2));',
'            -- Flow is define by id',
'            elsif l_attribute7 = ''id'' then',
'               --Add test number to raise error',
'               l_dgrm_id := apex_util.get_session_state( p_item => l_attribute4 );',
'            end if;',
'         end if;',
'   ',
'      elsif l_attribute3 = ''sql'' then',
'         l_context         := apex_exec.open_query_context(',
'            p_location   => apex_exec.c_location_local_db',
'         , p_sql_query  => l_attribute6',
'         );',
'',
'         while apex_exec.next_row(l_context) loop',
'            if l_attribute1 in ( ''start'', ''delete'', ''reset'', ''terminate'' ) then',
'               l_prcs_id  := apex_exec.get_number(l_context, 1);',
'            else',
'               if l_attribute7 in ( ''name'', ''name_and_version'' ) then',
'                  l_dgrm_name := apex_exec.get_varchar2( l_context, 1 );',
'                  -- Flow is define by name & version, second column contains flow version',
'                  if l_attribute7 = ''name_and_version'' then',
'                     l_dgrm_version := apex_exec.get_varchar2( l_context, 2 );',
'                  end if;',
'               else',
'                  -- Flow is define by id, first column contains flow id',
'                  l_dgrm_id := apex_exec.get_number( l_context, 1 );',
'               end if;',
'            end if;',
'         end loop;',
'         apex_exec.close(l_context);',
'',
'      elsif l_attribute3 = ''static'' then',
'         if l_attribute1 in ( ''start'', ''delete'', ''reset'', ''terminate'' ) then',
'            l_prcs_id := l_attribute5;',
'         else',
'            --Flow is define by name only',
'            if l_attribute7 = ''name'' then',
'               l_dgrm_name := l_attribute5;',
'            --Flow is define by name & version, coma separated',
'            elsif l_attribute7 = ''name_and_version'' then',
'               l_split_values  := apex_string.split( l_attribute5, '','');',
'               --Check if item value contains two values otherwise raise error',
'               if l_split_values.count != 2 then',
'                  raise e_missing_version;',
'               end if;',
'               l_dgrm_name     := l_split_values(1);',
'               l_dgrm_version  := l_split_values(2);',
'            -- Flow is define by id',
'            elsif l_attribute7 = ''id'' then',
'               l_dgrm_id := l_attribute5;',
'            end if;',
'         end if;',
'      elsif l_attribute3 = ''component'' then',
'         if l_attribute1 in ( ''start'', ''delete'', ''reset'', ''terminate'' ) then',
'            l_prcs_id := l_g_attribute1;',
'         else',
'            --Flow is define by name only',
'            if l_attribute7 = ''name'' then',
'               l_dgrm_name := l_g_attribute1;',
'            --Flow is define by name & version',
'            elsif l_attribute7 = ''name_and_version'' then',
'               l_split_values  := apex_string.split( l_g_attribute1, '','' );',
'               --Check if item value contains two values otherwise raise error',
'               if l_split_values.count != 2 then',
'                  raise e_missing_version;',
'               end if;',
'               l_dgrm_name     := l_split_values(1);',
'               l_dgrm_version  := l_split_values(2);',
'            -- Flow is define by id',
'            elsif l_attribute7 = ''id'' then',
'               l_dgrm_id := l_g_attribute1;',
'            end if;',
'         end if;',
'      end if;',
'      ',
'      if l_attribute1 = ''delete'' then',
'         -- Call API to delete the instance',
'         apex_debug.info(',
'            p_message => ''...Delete Flow Instance Id %s''',
'            , p0        => l_prcs_id',
'         );',
'         flow_api_pkg.flow_delete(',
'            p_process_id  => l_prcs_id',
'         );',
'      elsif l_attribute1 = ''start'' then',
'         -- Call API to start the instance',
'         apex_debug.info(',
'            p_message => ''...Start Flow Instance Id %s''',
'            , p0        => l_prcs_id',
'         );',
'         flow_api_pkg.flow_start(',
'            p_process_id  => l_prcs_id',
'         );',
'      elsif l_attribute1 = ''reset'' then',
'         -- Call API to reset the instance',
'         apex_debug.info(',
'            p_message => ''...Reset Flow Instance Id %s''',
'            , p0        => l_prcs_id',
'         );',
'         flow_api_pkg.flow_reset(',
'            p_process_id  => l_prcs_id',
'         );',
'      elsif l_attribute1 = ''terminate'' then',
'         -- Call API to terminate the instance',
'         apex_debug.info(',
'            p_message => ''...Terminate Flow Instance Id %s''',
'            , p0        => l_prcs_id',
'         );',
'         flow_api_pkg.flow_terminate(',
'            p_process_id  => l_prcs_id',
'         );',
'      elsif l_attribute1 in ( ''create'', ''create_and_start'' ) then',
'         apex_debug.info(',
'            p_message => ''...Retrieve FLow Instance Name''',
'         );',
'         l_prcs_name := l_attribute2;',
'',
'         --Create flow instance',
'         if l_attribute7 in ( ''name'', ''name_and_version'' ) then',
'            l_dgrm_name := trim( l_dgrm_name );',
'            l_dgrm_version := trim( l_dgrm_version );',
'               ',
'            apex_debug.info(',
'                 p_message => ''...Create Flow instance "%s" with diagram: %s %s''',
'               , p0        => l_prcs_name',
'               , p1        => l_dgrm_name',
'               , p2        => case when l_dgrm_version is not null then apex_string.format( p_message => ''(version %s)'', p0 => l_dgrm_version) end',
'            );',
'',
'            l_prcs_id :=',
'               flow_api_pkg.flow_create(',
'                 pi_dgrm_name     => l_dgrm_name',
'               , pi_dgrm_version  => l_dgrm_version',
'               , pi_prcs_name     => l_prcs_name',
'            );',
'         else',
'            apex_debug.info(',
'               p_message => ''...Create Flow instance "%s" with diagram id: %s''',
'               , p0      => l_prcs_name',
'               , p1      => l_dgrm_id',
'            );',
'',
'            l_prcs_id := flow_api_pkg.flow_create(',
'               pi_dgrm_id    => l_dgrm_id',
'            , pi_prcs_name  => l_prcs_name',
'            );',
'         end if;',
'',
'         apex_debug.info(',
'            p_message => '' < Flow instance %s created.''',
'            , p0      => l_prcs_id',
'         );',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => '' > Additional actions.''',
'         , p0        => l_prcs_id',
'      );',
'',
'      -- Return instance id in the APEX item provided',
'      if ( l_attribute9 is not null ) then',
'         apex_debug.info(',
'            p_message => ''...Return Flow Instance Id into item "%s"''',
'         , p0        => l_attribute9',
'         );',
'         apex_util.set_session_state( l_attribute9, l_prcs_id );',
'      end if;',
'',
'      if l_attribute1 in ( ''create'', ''create_and_start'', ''start'' ) then',
'',
'         --Get JSON for process variables',
'         if ( l_attribute10 = ''json'' ) then',
'            l_json := l_attribute11;',
'         elsif ( l_attribute10 = ''sql'' ) then',
'            l_context := apex_exec.open_query_context(',
'               p_location   => apex_exec.c_location_local_db',
'            , p_sql_query  => l_attribute12',
'            );',
'',
'            while apex_exec.next_row(l_context) loop',
'               l_json := apex_exec.get_clob(l_context, 1);',
'            end loop;',
'            apex_exec.close(l_context);',
'         end if;',
'',
'         --Set process variables',
'         if ( l_attribute10 in (',
'                  ''json'', ''sql''',
'               ) ) then',
'            apex_debug.info(',
'               p_message => ''...Start setting Flow Instance Variable(s)''',
'            );',
'            begin',
'               l_process_variables        := json_array_t(l_json);',
'            exception when others then',
'               raise e_invalid_json;',
'            end;',
'            l_process_variables_count  := l_process_variables.get_size();',
'            for object in 0..l_process_variables_count - 1 loop',
'               l_process_variable  := json_object_t(l_process_variables.get(object));',
'               l_var_name          := l_process_variable.get_string(''name'');',
'               l_var_type          := l_process_variable.get_string(''type'');',
'               case l_var_type',
'                  when ''varchar2'' then',
'                     apex_debug.info(',
'                        p_message => ''.....Name: %s - Type: %s - Value %s''',
'                        , p0 => l_var_name',
'                        , p1 => l_var_type',
'                        , p2 => l_process_variable.get_string(''value'')',
'                     );',
'                     flow_process_vars.set_var(',
'                        pi_prcs_id    => l_prcs_id',
'                     , pi_var_name   => l_var_name',
'                     , pi_vc2_value  => l_process_variable.get_string(''value'')',
'                     );',
'                  when ''number'' then',
'                     apex_debug.info(',
'                        p_message => ''......Name: %s - Type: %s - Value %s''',
'                        , p0 => l_var_name',
'                        , p1 => l_var_type',
'                        , p2 => l_process_variable.get_number(''value'')',
'                     );',
'                     flow_process_vars.set_var(',
'                        pi_prcs_id    => l_prcs_id',
'                     , pi_var_name   => l_var_name',
'                     , pi_num_value  => l_process_variable.get_number(''value'')',
'                     );',
'                  when ''date'' then',
'                     apex_debug.info(',
'                        p_message => ''......Name: %s - Type: %s - Value %s''',
'                        , p0 => l_var_name',
'                        , p1 => l_var_type',
'                        , p2 => l_process_variable.get_date(''value'')',
'                     );',
'                     flow_process_vars.set_var(',
'                        pi_prcs_id     => l_prcs_id',
'                     , pi_var_name    => l_var_name',
'                     , pi_date_value  => l_process_variable.get_date(''value'')',
'                     );',
'                  when ''timestamp'' then',
'                     apex_debug.info(',
'                        p_message => ''......Name: %s - Type: %s - Value %s''',
'                        , p0 => l_var_name',
'                        , p1 => l_var_type',
'                        , p2 => l_process_variable.get_timestamp(''value'')',
'                     );',
'                     flow_process_vars.set_var(',
'                        pi_prcs_id     => l_prcs_id',
'                     , pi_var_name    => l_var_name',
'                     , pi_tstz_value  => l_process_variable.get_timestamp(''value'')',
'                     );',
'                  when ''clob'' then',
'                     apex_debug.info(',
'                        p_message => ''......Name: %s - Type: %s - Value %s''',
'                        , p0 => l_var_name',
'                        , p1 => l_var_type',
'                        , p2 => l_process_variable.get_clob(''value'')',
'                     );',
'                     flow_process_vars.set_var(',
'                        pi_prcs_id     => l_prcs_id',
'                     , pi_var_name    => l_var_name',
'                     , pi_clob_value  => l_process_variable.get_clob(''value'')',
'                     );',
'                  when ''json'' then',
'                     apex_debug.info(',
'                        p_message => ''......Name: %s - Type: %s - Value %s''',
'                        , p0 => l_var_name',
'                        , p1 => l_var_type',
'                        , p2 => l_process_variable.get_clob(''value'')',
'                     );',
'                     flow_process_vars.set_var(',
'                        pi_prcs_id    => l_prcs_id',
'                     , pi_var_name    => l_var_name',
'                     , pi_json_value  => l_process_variable.get_clob(''value'')',
'                     );   ',
'                  else',
'                     raise e_incorrect_variable_type;',
'               end case;',
'            end loop;',
'            apex_debug.info(',
'               p_message => ''...End setting Flow Instance Variable(s)''',
'            );',
'         end if;',
'',
'         if l_attribute1 in ( ''create'', ''create_and_start'' ) and l_attribute8 is not null then',
'            apex_debug.info(',
'               p_message => ''...Setting BUSINESS_REF Variable: "%s"''',
'            , p0        => apex_util.get_session_state(l_attribute8)',
'            );',
'            flow_process_vars.set_var(',
'               pi_prcs_id    => l_prcs_id',
'            , pi_var_name   => ''BUSINESS_REF''',
'            , pi_vc2_value  => apex_util.get_session_state(l_attribute8)',
'            );',
'         end if;',
'',
'         --Start flow instance',
'         if l_attribute1 = ''create_and_start'' then',
'            apex_debug.info(',
'               p_message => ''...Starting Flow Instance %s''',
'            , p0        => l_prcs_id',
'            );',
'            flow_api_pkg.flow_start(p_process_id => l_prcs_id);',
'         end if;',
'',
'      end if;',
'',
'      apex_debug.info(',
'            p_message => '' < Additional actions.''',
'            , p0      => l_prcs_id',
'         );',
'',
'      return l_result;',
'   exception ',
'      when e_missing_version then',
'         apex_debug.error(',
'            p_message => ''-- Flows4apex - Plug-in configuration issue, diagram selection is done with name and version but version is not provided.''',
'         );',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-model-no-version'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_incorrect_variable_type then',
'         apex_debug.error(',
'            p_message => ''-- Flows4apex - Plug-in configuration issue, process variables JSON contains incorrect variable type.''',
'         );',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-parsing-json-variables'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_invalid_json then',
'         apex_debug.error(',
'            p_message => ''-- Flows4apex - Plug-in configuration issue, JSON provided is not valid.''',
'         );',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-invalid-json'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'   end execution;',
'   ',
'end flow_plugin_manage_instance;',
'/',
'',
'create or replace package body flow_plugin_manage_instance_step as',
'   ',
'   procedure log_attributes(',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   )',
'   is',
'   begin',
'      apex_debug.info(',
'           p_message => '' > Process plug-in attributes''',
'      );',
'      apex_debug.info(',
'           p_message => ''...Flow Instance, Subflow and Step Key define by: %s''',
'         , p0        => p_process.attribute_01',
'      );',
'',
'      if p_process.attribute_01 = ''item'' then ',
'         apex_debug.info(',
'            p_message => ''......Flow Instance Item used: %s - Session state value: %s''',
'            , p0        => p_process.attribute_02',
'            , p1        => apex_util.get_session_state(p_item => p_process.attribute_02)',
'         );',
'         apex_debug.info(',
'            p_message => ''......Subflow Item used: %s - Session state value: %s''',
'            , p0        => p_process.attribute_03',
'            , p1        => apex_util.get_session_state(p_item => p_process.attribute_03)',
'         );',
'         apex_debug.info(',
'            p_message => ''......Step Key Item used: %s - Session state value: %s''',
'            , p0        => p_process.attribute_12',
'            , p1        => apex_util.get_session_state(p_item => p_process.attribute_12)',
'         );',
'      elsif p_process.attribute_01 = ''sql''  then',
'         apex_debug.info(',
'            p_message => ''......Query''',
'         );',
'         apex_debug.log_long_message(',
'              p_message => p_process.attribute_04',
'            , p_level   => apex_debug.c_log_level_info',
'         );',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => ''...Flow Instance action: %s''',
'         , p0        => p_process.attribute_05',
'      );',
'',
'      if ( p_process.attribute_05 = ''complete'' ) then',
'         apex_debug.info(',
'            p_message => ''...Set Gateway route?: %s''',
'            , p0        => p_process.attribute_06',
'         );',
'',
'         if ( p_process.attribute_06 = ''Y'' ) then',
'            if ( p_process.attribute_07 is not null ) then',
'               apex_debug.info(',
'                  p_message => ''......Gateway "%s"''',
'                  , p0        => p_process.attribute_07',
'               );',
'            else',
'               apex_debug.info(',
'                  p_message => ''......No Gateway define, next gateway will be used.''',
'               );',
'            end if;',
'         end if;',
'         apex_debug.info(',
'            p_message => ''......Route %s''',
'            , p0        => p_process.attribute_08',
'         );',
'',
'         apex_debug.info(',
'            p_message => ''...Auto branching?: %s''',
'            , p0        => p_process.attribute_09',
'         );',
'      elsif ( p_process.attribute_05 = ''reserve'' ) then',
'         apex_debug.info(',
'                 p_message => ''......Reserved for: %s''',
'               , p0        => p_process.attribute_10',
'            );',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => '' < Process plug-in attributes''',
'      );',
'   end log_attributes;',
'',
'   function execution (',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   ) return apex_plugin.t_process_exec_result ',
'   as',
'      l_result          apex_plugin.t_process_exec_result;',
'',
'      --exceptions',
'      e_no_gateway         exception;',
'      e_gateway_not_exists exception;',
'      e_no_flow            exception;',
'',
'      --attributes',
'      l_attribute1      p_process.attribute_01%type := p_process.attribute_01; -- Flow instance selection (APEX item/SQL)',
'      l_attribute2      p_process.attribute_02%type := p_process.attribute_02; -- Process ID (APEX item)',
'      l_attribute3      p_process.attribute_03%type := p_process.attribute_03; -- Subflow ID (APEX item)',
'      l_attribute4      p_process.attribute_04%type := p_process.attribute_04; -- SQL query (2 columns process id and subflow id)',
'      l_attribute5      p_process.attribute_05%type := p_process.attribute_05; -- Action (complete/reserve/release)',
'      l_attribute6      p_process.attribute_06%type := p_process.attribute_06; -- Set Gateway route? (Y/N)',
'      l_attribute7      p_process.attribute_07%type := p_process.attribute_07; -- Gateway ID',
'      l_attribute8      p_process.attribute_08%type := p_process.attribute_08; -- Route ID',
'      l_attribute9      p_process.attribute_09%type := p_process.attribute_09; -- Auto branching (Y/N)',
'      l_attribute10     p_process.attribute_10%type := p_process.attribute_10; -- Reservation ',
'      ',
'      l_attribute12     p_process.attribute_12%type := p_process.attribute_12; -- Step Key  ',
'',
'      l_process_id      flow_processes.prcs_id%type;',
'      l_subflow_id      flow_subflows.sbfl_id%type;',
'      l_step_key        flow_subflows.sbfl_step_key%type;',
'      l_dgrm_id         flow_processes.prcs_dgrm_id%type;',
'      l_gateway_name    flow_objects.objt_bpmn_id%type;',
'      l_gateway_exists  number;',
'      l_context         apex_exec.t_context;',
'      l_url             varchar2(4000);',
'      l_split_items     apex_t_varchar2;',
'      l_col_count       pls_integer;',
'',
'       type flow_step_info is record (',
'           dgrm_id            flow_diagrams.dgrm_id%type',
'         , source_objt_tag    flow_objects.objt_tag_name%type',
'         , source_lane_id     flow_objects.objt_objt_lane_id%type',
'         , target_objt_id     flow_objects.objt_id%type',
'         , target_objt_ref    flow_objects.objt_bpmn_id%type',
'         , target_objt_tag    flow_objects.objt_tag_name%type',
'         , target_objt_subtag flow_objects.objt_sub_tag_name%type',
'         , target_lane_id     flow_objects.objt_objt_lane_id%type',
'      );',
'      l_step_info       flow_step_info;',
'',
'      l_reservation flow_subflows.sbfl_reservation%type;',
'   begin',
'',
'      --debug',
'      log_attributes(',
'           p_plugin  => p_plugin',
'         , p_process => p_process',
'      );',
'',
'      apex_debug.info(',
'         p_message => ''...Retrieve FLow Instance Id and Subflow Id''',
'      );',
'      -- Get process Id, subflow Id and Step key',
'      if ( l_attribute1 = ''item'' ) then',
'         l_process_id  := apex_util.get_session_state(p_item => l_attribute2);',
'         l_subflow_id  := apex_util.get_session_state(p_item => l_attribute3);',
'         l_step_key    := apex_util.get_session_state(p_item => l_attribute12);',
'      elsif ( l_attribute1 = ''sql'' ) then',
'         l_context         := apex_exec.open_query_context(',
'            p_location   => apex_exec.c_location_local_db',
'          , p_sql_query  => l_attribute4',
'         );',
'         l_col_count := apex_exec.get_column_count(l_context);',
'',
'         while apex_exec.next_row(l_context) loop',
'            l_process_id  := apex_exec.get_number(l_context, 1);',
'            l_subflow_id  := apex_exec.get_number(l_context, 2);',
'            if ( l_col_count = 3 ) then',
'               l_step_key    := apex_exec.get_varchar2(l_context, 3);',
'            end if;',
'         end loop;',
'         apex_exec.close(l_context);',
'      end if;',
'',
'      --Raise error if unable to find process id or subflow id',
'      if l_process_id is null or l_subflow_id is null then',
'         raise e_no_flow;',
'      end if;',
'',
'      --Raise error for step key if strict mode',
'',
'      if ( l_attribute5 = ''complete'' ) then',
'         -- Get step informations',
'         select sbfl.sbfl_dgrm_id',
'            , objt_source.objt_tag_name',
'            , objt_source.objt_objt_lane_id',
'            , conn.conn_tgt_objt_id',
'            , objt_target.objt_bpmn_id',
'            , objt_target.objt_tag_name',
'            , objt_target.objt_sub_tag_name',
'            , objt_target.objt_objt_lane_id',
'         into l_step_info',
'         from flow_connections conn',
'         join flow_objects objt_source',
'            on conn.conn_src_objt_id = objt_source.objt_id',
'            and conn.conn_dgrm_id = objt_source.objt_dgrm_id',
'         join flow_objects objt_target',
'            on conn.conn_tgt_objt_id = objt_target.objt_id',
'            and conn.conn_dgrm_id = objt_target.objt_dgrm_id',
'         join flow_subflows sbfl',
'            on sbfl.sbfl_current = objt_source.objt_bpmn_id',
'            and sbfl.sbfl_dgrm_id = conn.conn_dgrm_id',
'         where conn.conn_tag_name = flow_constants_pkg.gc_bpmn_sequence_flow',
'            and sbfl.sbfl_prcs_id = l_process_id',
'            and sbfl.sbfl_id = l_subflow_id;',
'',
'         --Set the gateway route',
'         if ( l_attribute6 = ''Y'' ) then',
'            l_gateway_name := l_attribute7;',
'',
'            -- If attribute 6 is filled, check if gateway define exists',
'            if ( l_gateway_name is not null ) then',
'',
'               select count(*)',
'               into l_gateway_exists',
'               from flow_instance_diagrams prdg',
'               join flow_objects obj on obj.objt_dgrm_id = prdg.prdg_dgrm_id',
'               where prdg.prdg_prcs_id = l_process_id',
'               and obj.objt_tag_name in (flow_constants_pkg.gc_bpmn_gateway_exclusive, flow_constants_pkg.gc_bpmn_gateway_inclusive)',
'               and obj.objt_bpmn_id = l_gateway_name;',
'',
'               if ( l_gateway_exists = 0) then',
'                  raise e_gateway_not_exists;',
'               end if;',
'            end if;',
'            ',
'            --Gateway attribute is not filled so we look at the next target object if it''s exclusive or inclusive gateway',
'            if (',
'               l_attribute7 is null and l_step_info.target_objt_tag in (',
'                        flow_constants_pkg.gc_bpmn_gateway_exclusive, flow_constants_pkg.gc_bpmn_gateway_inclusive',
'                     )',
'            ) then',
'               l_gateway_name := l_step_info.target_objt_ref;',
'            end if;',
'',
'            if ( l_gateway_name is not null ) then',
'',
'               apex_debug.info(',
'                  p_message => ''...Setting Flow Instance Variable "%s" value "%s"''',
'                  , p0      => l_gateway_name || '':route''',
'                  , p1      => l_attribute8',
'               );',
'',
'               flow_process_vars.set_var(',
'                 pi_prcs_id    => l_process_id',
'               , pi_sbfl_id    => l_subflow_id',
'               , pi_var_name   => l_gateway_name || '':route''',
'               , pi_vc2_value  => l_attribute8',
'               );',
'            else',
'               raise e_no_gateway;',
'            end if;',
'         end if;',
'',
'         apex_debug.info(',
'              p_message => ''...Complete Step - Flow Instance Id %s - Subflow Id %s - Step Key %s''',
'            , p0        => l_process_id',
'            , p1        => l_subflow_id',
'            , p2        => l_step_key',
'         );',
'         -- Call API to complete the step',
'         flow_api_pkg.flow_complete_step(',
'            p_process_id  => l_process_id',
'         , p_subflow_id  => l_subflow_id',
'         , p_step_key    => l_step_key',
'         );',
'',
'         -- Auto-branching',
'         -- Only if next object is a user task and it''s on the same lane than the current step',
'    '))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'     if (',
'            l_attribute9 = ''Y'' and l_step_info.target_objt_tag = flow_constants_pkg.gc_bpmn_usertask and ( ( l_step_info.source_lane_id =',
'            l_step_info.target_lane_id ) or (',
'               l_step_info.source_lane_id is null and l_step_info.target_lane_id is null',
'            ) )',
'         ) then',
'            -- Get APEX page url',
'            l_url :=',
'               flow_usertask_pkg.get_url(',
'                  pi_prcs_id  => l_process_id',
'               , pi_sbfl_id  => l_subflow_id',
'               , pi_objt_id  => l_step_info.target_objt_id',
'               );',
'            apex_debug.info(',
'                 p_message => ''...Redirecting to %s''',
'               , p0        => l_url',
'            );',
'            -- Redirect',
'            apex_util.redirect_url(p_url => l_url);',
'         end if;',
'',
'      elsif ( l_attribute5 = ''reserve'' ) then',
'         l_reservation := l_attribute10;',
'',
'         apex_debug.info(',
'              p_message => ''...Reserve Step - Flow Instance Id %s - Subflow Id %s - Step Key %s''',
'            , p0        => l_process_id',
'            , p1        => l_subflow_id',
'            , p2        => l_step_key',
'         );',
'',
'         flow_api_pkg.flow_reserve_step(',
'            p_process_id    => l_process_id',
'            , p_subflow_id  => l_subflow_id',
'            , p_step_key    => l_step_key',
'            , p_reservation => l_reservation',
'         );',
'',
'      elsif ( l_attribute5 = ''release'' ) then',
'         apex_debug.info(',
'              p_message => ''...Release Step - Flow Instance Id %s - Subflow Id %s - Step Key %s''',
'            , p0        => l_process_id',
'            , p1        => l_subflow_id',
'            , p2        => l_step_key',
'         );',
'',
'         flow_api_pkg.flow_release_step(',
'              p_process_id => l_process_id',
'            , p_subflow_id => l_subflow_id',
'            , p_step_key   => l_step_key',
'         );',
'      elsif ( l_attribute5 = ''start'' ) then',
'         apex_debug.info(',
'              p_message => ''...Start Step - Flow Instance Id %s - Subflow Id %s - Step Key %s''',
'            , p0        => l_process_id',
'            , p1        => l_subflow_id',
'            , p2        => l_step_key',
'         );',
'',
'         flow_api_pkg.flow_start_step(',
'              p_process_id => l_process_id',
'            , p_subflow_id => l_subflow_id',
'            , p_step_key   => l_step_key',
'         );',
'      end if;',
'',
'      return l_result;',
'   exception ',
'      when e_no_gateway then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-route-not-define'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_gateway_not_exists then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-gateway-not-exist'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_no_flow then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-no-instance-subflow-id'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when others then',
'         apex_exec.close(l_context);',
'         raise;',
'   end execution;',
'   ',
'end flow_plugin_manage_instance_step;',
'/',
'',
'create or replace package body flow_plugin_manage_instance_variables as',
'',
'   procedure log_attributes(',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   )',
'   is',
'   begin',
'      apex_debug.info(',
'           p_message => '' > Process plug-in attributes''',
'      );',
'      apex_debug.info(',
'           p_message => ''...Flow Instance define by: %s''',
'         , p0        => p_process.attribute_01',
'      );',
'',
'      if p_process.attribute_01 = ''item'' then ',
'         apex_debug.info(',
'            p_message => ''......Flow Instance Item used: %s - Session state value: %s''',
'            , p0        => p_process.attribute_02',
'            , p1        => apex_util.get_session_state(p_item => p_process.attribute_02)',
'         );',
'		 ',
'         if p_process.attribute_11 is not null then ',
'            apex_debug.info(',
'               p_message => ''......Flow Subflow Item used: %s - Session state value: %s''',
'               , p0        => p_process.attribute_11',
'               , p1        => apex_util.get_session_state(p_item => p_process.attribute_11)',
'            );',
'         else',
'            apex_debug.info(',
'               p_message => ''......No Subflow Item provided''',
'            );',
'         end if;',
'      elsif p_process.attribute_01 = ''sql''  then',
'         apex_debug.info(',
'            p_message => ''......Query''',
'         );',
'         apex_debug.log_long_message(',
'              p_message => p_process.attribute_03',
'            , p_level   => apex_debug.c_log_level_info',
'         );',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => ''...Flow Instance Variables action: %s''',
'         , p0        => p_process.attribute_04',
'      );',
'',
'      apex_debug.info(',
'           p_message => ''...Manage Flow Instance Variables using: %s''',
'         , p0        => p_process.attribute_05',
'      );',
'',
'      if p_process.attribute_05 = ''item'' then ',
'         apex_debug.info(',
'            p_message => ''......Flow Instance Variable(s): %s''',
'            , p0        => p_process.attribute_06',
'         );',
'         apex_debug.info(',
'            p_message => ''......APEX item(s): %s''',
'            , p0        => p_process.attribute_07',
'         );',
'      elsif p_process.attribute_01 = ''sql''  then',
'         apex_debug.info(',
'            p_message => ''......Query''',
'         );',
'         apex_debug.log_long_message(',
'              p_message => p_process.attribute_08',
'            , p_level   => apex_debug.c_log_level_info',
'         );',
'      elsif p_process.attribute_01 = ''json''  then',
'         apex_debug.info(',
'            p_message => ''......JSON''',
'         );',
'         apex_debug.log_long_message(',
'              p_message => p_process.attribute_09',
'            , p_level   => apex_debug.c_log_level_info',
'         );',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => '' < Process plug-in attributes''',
'      );',
'   end log_attributes;',
'   ',
'   function execution (',
'      p_process  in  apex_plugin.t_process',
'    , p_plugin   in  apex_plugin.t_plugin',
'   ) return apex_plugin.t_process_exec_result ',
'   as',
'      l_result  apex_plugin.t_process_exec_result;',
'      l_context apex_exec.t_context;',
'',
'      --attributes',
'      l_attribute1  p_process.attribute_01%type := p_process.attribute_01; -- Flow instance selection (APEX item/SQL)',
'      l_attribute2  p_process.attribute_02%type := p_process.attribute_02; -- Process ID (APEX item)',
'      l_attribute3  p_process.attribute_03%type := p_process.attribute_03; -- SQL query (1 column process id)',
'      l_attribute4  p_process.attribute_04%type := p_process.attribute_04; -- Action (get/set)',
'      l_attribute5  p_process.attribute_05%type := p_process.attribute_05; -- Manage Process Variables using',
'      l_attribute6  p_process.attribute_06%type := p_process.attribute_06; -- Process Variable(s) Name(s)',
'      l_attribute7  p_process.attribute_07%type := p_process.attribute_07; -- APEX item(s)',
'      l_attribute8  p_process.attribute_08%type := p_process.attribute_08; -- JSON',
'      l_attribute9  p_process.attribute_09%type := p_process.attribute_09; -- SQL query (1 column JSON array)',
'      ',
'	   l_attribute11 p_process.attribute_11%type := p_process.attribute_11; -- Subflow ID (APEX item)																								',
'',
'      --exceptions',
'      e_var_config              exception;',
'      e_incorrect_variable_type exception;',
'      e_types_different         exception;',
'      e_invalid_number          exception;',
'      e_invalid_date            exception;',
'      e_invalid_json            exception;',
'',
'      --types',
'      type t_prcs_var is table of varchar2(50) index by varchar2(50);',
'      type t_item     is record (item_type varchar2(50), format_mask varchar(50));',
'      type t_items    is table of t_item index by varchar2(50);',
'',
'      --collections',
'      l_prcs_var   t_prcs_var;',
'      l_items      t_items;',
'      l_cur_app_id number;',
'',
'      --json',
'      l_json              clob;',
'      l_process_variables json_array_t;',
'      l_process_variable  json_object_t;',
'      l_json_element      json_element_t;',
'      l_dummy_num         number;',
'',
'      --variables',
'      l_prcs_id         flow_processes.prcs_id%type;',
'      l_sbfl_id         flow_subflows.sbfl_id%type;',
'      l_prov_var_type   flow_process_variables.prov_var_type%type;',
'      l_prov_var_name   flow_process_variables.prov_var_name%type;',
'      l_prov_scope      flow_process_variables.prov_scope%type;',
'      l_prov_var_vc2    flow_process_variables.prov_var_vc2%type;',
'      l_prov_var_num    flow_process_variables.prov_var_num%type;',
'      l_prov_var_date   flow_process_variables.prov_var_date%type;',
'      l_prov_var_clob    flow_process_variables.prov_var_clob%type;',
'      l_split_prcs_var  apex_t_varchar2;',
'      l_split_items     apex_t_varchar2;',
'      l_item_name       varchar2(4000);',
'      l_format_mask     apex_application_page_items.format_mask%type;',
'      l_types_different number;',
'      l_ts              timestamp;',
'      l_col_count       pls_integer;',
'   begin',
'',
'      --debug',
'      log_attributes(',
'         p_plugin   => p_plugin',
'       , p_process  => p_process',
'      );',
'',
'',
'      apex_debug.info(',
'         p_message => ''...Retrieve FLow Instance Id''',
'      );',
'      -- Get process Id and subflow Id',
'      if ( l_attribute1 = ''item'' ) then',
'         l_prcs_id  := apex_util.get_session_state(p_item => l_attribute2);',
'		 ',
'		   if l_attribute11 is not null then',
'            l_sbfl_id  := apex_util.get_session_state(p_item => l_attribute11);',
'         end if;								  ',
'      elsif ( l_attribute1 = ''sql'' ) then',
'         l_context         := apex_exec.open_query_context(',
'            p_location   => apex_exec.c_location_local_db',
'          , p_sql_query  => l_attribute3',
'         );',
'',
'		   l_col_count := apex_exec.get_column_count( p_context => l_context );',
'',
'         while apex_exec.next_row(l_context) loop',
'            l_prcs_id  := apex_exec.get_number(l_context, 1);',
'			   if l_col_count = 2 then',
'               l_sbfl_id := apex_exec.get_number(l_context, 2);',
'            end if;',
'         end loop;',
'         apex_exec.close(l_context);',
'      end if;',
'',
'      apex_debug.info(',
'           p_message => ''...Flow Instance Id is %s''',
'         , p0        => l_prcs_id',
'      );',
'',
'	  if l_sbfl_id is not null then',
'         apex_debug.info(',
'            p_message => ''...Flow Subflow Id is %s''',
'            , p0        => l_sbfl_id',
'         );',
'',
'         -- get the scope and current object for the supplied subflow',
'         select sbfl.sbfl_scope',
'         into l_prov_scope',
'         from flow_subflows sbfl',
'         where sbfl.sbfl_id = l_sbfl_id',
'         and sbfl.sbfl_prcs_id = l_prcs_id;',
'',
'      else',
'         l_prov_scope := 0;',
'      end if;',
'      ',
'      apex_debug.info(',
'         p_message => ''...Scope is %s''',
'         , p0        => l_prov_scope',
'      );',
'      apex_debug.info(',
'           p_message => ''...Start %s Flow Instance Variable(s)''',
'         , p0        => case l_attribute4',
'                           when ''set'' then ''setting''',
'                           when ''get'' then ''getting''',
'                        end',
'      );',
'      --Set process variables',
'      if ( l_attribute5 in (',
'                ''json'', ''sql''',
'             ) ) then',
'         ',
'         --Get JSON for process variables',
'         if ( l_attribute5 = ''json'' ) then',
'            l_json := l_attribute8;',
'         elsif ( l_attribute5 = ''sql'' ) then',
'            l_context := apex_exec.open_query_context(',
'               p_location   => apex_exec.c_location_local_db',
'            , p_sql_query  => l_attribute9',
'            );',
'',
'            while apex_exec.next_row(l_context) loop',
'               l_json := apex_exec.get_clob(l_context, 1);',
'            end loop;',
'            apex_exec.close(l_context);',
'         end if;',
'',
'         begin',
'            l_process_variables := json_array_t(l_json);',
'         exception when others then',
'            raise e_invalid_json;',
'         end;',
'         ',
'         if ( l_attribute4 = ''set'' ) then',
'            --Check variables types',
'            select count(*)',
'            into l_types_different',
'            from',
'               json_table ( l_json ,',
'               ''$[*]''',
'                  columns (',
'                     name varchar2 ( 4000 ) path ''$.name''',
'                  , type varchar2 ( 4000 ) path ''$.type''',
'                  )',
'               ) set_var',
'               join flow_process_variables prcs_var ',
'               on prcs_var.prov_var_name = set_var.name ',
'               and prcs_var.prov_prcs_id = l_prcs_id',
'               where ',
'                  case ',
'                     when prcs_var.prov_var_type = ''TIMESTAMP WITH TIME ZONE'' then ',
'                        ''TIMESTAMP''',
'                  else',
'                     prcs_var.prov_var_type',
'                  end != upper( set_var.type )',
'			   and prcs_var.prov_scope = l_prov_scope;',
'            ',
'            -- Raise exception if incoherent value found',
'            if ( l_types_different > 0 ) then',
'               raise e_types_different;',
'            end if;',
'         end if;',
'',
'         for object in 0..l_process_variables.get_size() - 1 loop',
'            l_process_variable := json_object_t(l_process_variables.get(object));',
'            l_prov_var_name    := l_process_variable.get_string(''name'');',
'            l_prov_var_type    := l_process_variable.get_string(''type'');',
'            l_item_name        := l_process_variable.get_string(''item'');',
'            case l_prov_var_type',
'               when ''varchar2'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then l_process_variable.get_string(''value'')',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_vc2(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                           pi_prcs_id   => l_prcs_id',
'						      , pi_scope      => l_prov_scope   ',
'                        , pi_var_name   => l_prov_var_name',
'                        , pi_vc2_value  => l_process_variable.get_string(''value'')',
'                        );',
'                     when ''get'' then',
'                        apex_util.set_session_state( ',
'                             p_name  => l_item_name',
'                           , p_value => flow_process_vars.get_var_vc2(',
'                                             pi_prcs_id  => l_prcs_id',
'										             , pi_scope    => l_prov_scope	 ',
'                                           , pi_var_name => l_prov_var_name',
'                                        ) ',
'                        );',
'                  end case;',
'               when ''number'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then l_process_variable.get_number(''value'')',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_num(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        l_json_element := l_process_variable.get(''value'');',
'                        if ( l_json_element.is_String and l_process_variable.get_String(''value'') is not null ',
'                           ) then',
'                           l_process_variable.On_error(3);',
'                           begin',
'                              l_dummy_num := l_process_variable.get_Number(''value'');',
'                           exception',
'                              when others then',
'                                l_process_variable.On_error(0);',
'                                raise e_invalid_number;',
'                           end;',
'                        end if;',
'                        flow_process_vars.set_var(',
'                             pi_prcs_id   => l_prcs_id',
'						         , pi_scope     => l_prov_scope	 ',
'                           , pi_var_name  => l_prov_var_name',
'                           , pi_num_value => case ',
'                                                when l_process_variable.get_String(''value'') is null ',
'                                                   then ',
'                                                      null ',
'                                             else ',
'                                                l_process_variable.get_number(''value'') ',
'                                             end',
'                        );',
'                     when ''get'' then',
'                        apex_util.set_session_state( ',
'                             p_name  => l_item_name',
'                           , p_value => flow_process_vars.get_var_num(',
'                                             pi_prcs_id  => l_prcs_id',
'										             , pi_scope    => l_prov_scope	 ',
'                                           , pi_var_name => l_prov_var_name',
'                                        ) ',
'                        );',
'                  end case;   ',
'               when ''date'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then l_process_variable.get_date(''value'')',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_date(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        l_json_element := l_process_variable.get(''value'');',
'                        begin',
'                           if instr( l_process_variable.get_String(''value''), ''T'' ) > 0 then',
'                              l_ts := to_timestamp_tz( replace ( l_process_variable.get_String(''value''), ''T'', '' '' ), ''YYYY-MM-DD HH24:MI:SS TZR'' ); ',
'                           else',
'                              l_ts := to_timestamp_tz( l_process_variable.get_String(''value''), ''YYYY-MM-DD TZR'' ); ',
'                           end if;',
'                        exception when others then',
'                           raise e_invalid_date;',
'                        end;',
'                        flow_process_vars.set_var(',
'                          pi_prcs_id    => l_prcs_id',
'						      , pi_scope      => l_prov_scope									',
'                        , pi_var_name   => l_prov_var_name',
'                        , pi_date_value => l_process_variable.get_timestamp(''value'')',
'                        );',
'                     when ''get'' then',
'                        apex_exec.execute_plsql(   ''begin',
'                           :'' || l_item_name || '' :=  flow_process_vars.get_var_date(',
'                                                pi_prcs_id  => ''||l_prcs_id||''',
'											            , pi_scope     => ''||l_prov_scope||''										',
'                                             , pi_var_name => ''''''||l_prov_var_name||''''''',
'                                          ); ',
'                           end;'');',
'                  end case;',
'               when ''timestamp'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then l_process_variable.get_timestamp(''value'')',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_tstz(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        l_json_element := l_process_variable.get(''value'');',
'                        begin',
'                           if instr( l_process_variable.get_String(''value''), ''T'' ) > 0 then',
'                              l_ts := to_timestamp_tz( replace ( l_process_variable.get_String(''value''), ''T'', '' '' ), ''YYYY-MM-DD HH24:MI:SS TZR'' ); ',
'                           else',
'                              l_ts := to_timestamp_tz( l_process_variable.get_String(''value''), ''YYYY-MM-DD TZR'' ); ',
'                           end if;',
'                        exception when others then',
'                           raise e_invalid_date;',
'                        end;',
'                        flow_process_vars.set_var(',
'                          pi_prcs_id    => l_prcs_id',
'						      , pi_scope      => l_prov_scope									',
'                        , pi_var_name   => l_prov_var_name',
'                        , pi_date_value => l_process_variable.get_timestamp(''value'')',
'                        );',
'                     when ''get'' then',
'                        apex_exec.execute_plsql(   ''begin',
'                           :'' || l_item_name || '' :=  flow_process_vars.get_var_tstz(',
'                                                pi_prcs_id  => ''||l_prcs_id||''',
'											            , pi_scope     => ''||l_prov_scope||''										',
'                                             , pi_var_name => ''''''||l_prov_var_name||''''''',
'                                          ); ',
'                           end;'');',
'                  end case;',
'               when ''clob'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then l_process_variable.get_clob(''value'')',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_clob(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                          pi_prcs_id    => l_prcs_id',
'						      , pi_scope      => l_prov_scope									',
'                        , pi_var_name   => l_prov_var_name',
'                        , pi_clob_value => l_process_variable.get_clob(''value'')',
'                        );',
'                     when ''get'' then',
'                        apex_exec.execute_plsql(''begin',
'                           :'' || l_item_name || '' := flow_process_vars.get_var_clob(',
'                                               pi_prcs_id  => ''|| l_prcs_id ||''',
'											            , pi_scope    => ''|| l_prov_scope ||''									   ',
'                                             , pi_var_name => ''''''|| l_prov_var_name ||''''''',
'                                          );',
'                           end;''',
'                        );',
'                  end case;   ',
'               when ''json'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then l_process_variable.get_clob(''value'')',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_json(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                          pi_prcs_id    => l_prcs_id',
'						      , pi_scope      => l_prov_scope									',
'                        , pi_var_name   => l_prov_var_name',
'                        , pi_json_value => l_process_variable.get_clob(''value'')',
'                        );',
'                     when ''get'' then',
'                        apex_exec.execute_plsql(''begin',
'                           :'' || l_item_name || '' := flow_process_vars.get_var_json(',
'                                               pi_prcs_id  => ''|| l_prcs_id ||''',
'											            , pi_scope    => ''|| l_prov_scope ||''									   ',
'                                             , pi_var_name => ''''''|| l_prov_var_name ||''''''',
'                                          );',
'                           end;''',
'                        );',
'                  end case;                      ',
'               else',
'                  raise e_incorrect_variable_type;',
'            end case;',
'         end loop;',
'      elsif ( l_attribute5 = ''item'' ) then',
'         -- Get process variable(s) name(s)',
'         l_split_prcs_var := apex_string.split(l_attribute6, '','');',
'',
'         -- Get APEX item(s) name(s)',
'         l_split_items := apex_string.split(l_attribute7, '','');',
'',
'         --Raise exception if number of process variables is not the same of APEX items',
'         if ( l_split_prcs_var.count() != l_split_items.count() ) then',
'            raise e_var_config;',
'         end if;',
'',
'         -- Get process variables types',
'         for rec in (',
'            select prov_var_name, prov_var_type',
'            from flow_process_variables prov',
'         where prov.prov_prcs_id = l_prcs_id',
'			and prov.prov_scope = l_prov_scope								 ',
'            and prov.prov_var_name in (',
'               select trim(column_value)',
'               from table(l_split_prcs_var)',
'            )',
'         )',
'         loop',
'            l_prcs_var(rec.prov_var_name) := rec.prov_var_type;',
'         end loop;',
'',
'         l_cur_app_id := nv(''APP_ID'');',
'         -- Get items types',
'         for rec in (',
'            select column_value as item_name',
'               , case',
'                     when aapi.display_as_code = ''NATIVE_NUMBER_FIELD'' then',
'                        ''NUMBER''',
'                     when aapi.display_as_code in (''NATIVE_DATE_PICKER'', ''NATIVE_DATE_PICKER_JET'', ''NATIVE_DATE_PICKER_APEX'') then',
'                        ''DATE''',
'                     else',
'                        ''VARCHAR2''',
'                  end as item_type',
'               , aapi.format_mask',
'            from table(apex_string.split(l_attribute7, '','')) items',
'            left outer join apex_application_page_items aapi',
'               on aapi.item_name = items.column_value',
'              and aapi.application_id = l_cur_app_id',
'            left outer join apex_application_items aai',
'               on aai.item_name = items.column_value',
'              and aai.application_id = l_cur_app_id',
'         )',
'         loop',
'            l_items(rec.item_name).item_type   := rec.item_type;',
'            l_items(rec.item_name).format_mask := rec.format_mask;',
'         end loop;',
'',
'         -- Loop through variables',
'         for i in l_split_prcs_var.first..l_split_prcs_var.last',
'         loop',
'            -- Get process variable name and item name ',
'            l_prov_var_name := trim( l_split_prcs_var( i ) );',
'            l_item_name     := trim( l_split_items( i ) );',
'',
'            -- Look for variable type',
'            begin',
'               l_prov_var_type := l_prcs_var( l_prov_var_name );',
'               l_items ( l_item_name ).format_mask  :=',
'                  case l_prov_var_type',
'                     when ''date'' ',
'                        then coalesce( l_items ( l_item_name ).format_mask, v(''APP_NLS_DATE_FORMAT'') )',
'                     when ''tim'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'estamp''',
'                        then coalesce( l_items ( l_item_name ).format_mask, v(''APP_NLS_TIMESTAMP_TZ_FORMAT'') ) ',
'                  else',
'                     l_items ( l_item_name ).format_mask',
'                  end;',
'            exception ',
'               -- Look for item type',
'               when no_data_found then',
'                  l_prov_var_type := l_items ( l_item_name ).item_type;',
'                  l_items ( l_item_name ).format_mask := ',
'                     case l_prov_var_type',
'                        when ''DATE'' ',
'                           then coalesce( l_items ( l_item_name ).format_mask, v(''APP_NLS_DATE_FORMAT'') )',
'                     else',
'                        l_items ( l_item_name ).format_mask',
'                     end;',
'            end;',
'            ',
'            case l_prov_var_type ',
'               when ''VARCHAR2'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then apex_util.get_session_state( p_item => l_item_name )',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_vc2(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope  ',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                             pi_prcs_id    => l_prcs_id',
'						         , pi_scope      => l_prov_scope								  ',
'                           , pi_var_name   => l_prov_var_name',
'                           , pi_vc2_value  => apex_util.get_session_state( p_item => l_item_name )',
'                        );',
'                     when ''get'' then',
'                        apex_util.set_session_state( ',
'                             p_name  => l_item_name',
'                           , p_value => flow_process_vars.get_var_vc2(',
'                                             pi_prcs_id  => l_prcs_id',
'										             , pi_scope    => l_prov_scope	 ',
'                                           , pi_var_name => l_prov_var_name',
'                                        ) ',
'                        );',
'                  end case;',
'',
'               when ''NUMBER'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then ',
'                                      $if wwv_flow_api.c_current >= 20210415 $then ',
'                                         to_number( apex_util.get_session_state( p_item => l_item_name ), l_items ( l_item_name ).format_mask )  ',
'                                      $else                                          ',
'                                         to_number( apex_util.get_session_state( p_item => l_item_name ) )',
'                                      $end',
'                                 when ''get'' ',
'                                    then flow_process_vars.get_var_num(',
'                                              pi_prcs_id  => l_prcs_id',
'											           , pi_scope    => l_prov_scope',
'                                            , pi_var_name => l_prov_var_name',
'                                         )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                             pi_prcs_id    => l_prcs_id',
'						         , pi_scope      => l_prov_scope	 ',
'                           , pi_var_name   => l_prov_var_name',
'                           , pi_num_value  => $if wwv_flow_api.c_current >= 20210415 $then ',
'                                                 case when l_items ( l_item_name ).format_mask is not null then',
'                                                    to_number( apex_util.get_session_state( p_item => l_item_name ), l_items ( l_item_name ).format_mask )',
'                                                 else',
'                                                    to_number( apex_util.get_session_state( p_item => l_item_name ) )',
'                                                 end',
'                                              $else',
'                                                 to_number( apex_util.get_session_state( p_item => l_item_name ) )',
'                                              $end',
'                        );',
'                     when ''get'' then',
'                        apex_util.set_session_state( ',
'                             p_name  => l_item_name',
'                           , p_value => flow_process_vars.get_var_num(',
'                                             pi_prcs_id  => l_prcs_id',
'										             , pi_scope    => l_prov_scope	 ',
'                                           , pi_var_name => l_prov_var_name',
'                                        ) ',
'                        );',
'                  end case;',
'               when ''DATE'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then apex_util.get_session_state( p_item => l_item_name )',
'                                 when ''get'' ',
'                                    then to_char(',
'                                            flow_process_vars.get_var_date(',
'                                               pi_prcs_id  => l_prcs_id',
'											            , pi_scope    => l_prov_scope   ',
'                                             , pi_var_name => l_prov_var_name',
'                                            ), l_items(l_item_name).format_mask ',
'                                          )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                             pi_prcs_id    => l_prcs_id',
'						         , pi_scope      => l_prov_scope',
'                           , pi_var_name   => l_prov_var_name',
'                           , pi_date_value => to_date( apex_util.get_session_state( p_item => l_item_name ) , l_items(l_item_name).format_mask )',
'                        );',
'                     when ''get'' then',
'                        apex_util.set_session_state( ',
'                             p_name  => l_item_name',
'                           , p_value => to_char(',
'                                          flow_process_vars.get_var_date(',
'                                             pi_prcs_id  => l_prcs_id',
'										             , pi_scope    => l_prov_scope	 ',
'                                           , pi_var_name => l_prov_var_name',
'                                        ), l_items(l_item_name).format_mask )',
'                        );',
'                  end case;',
'            when ''TIMESTAMP WITH TIME ZONE'' then',
'                  apex_debug.info(',
'                     p_message => ''......Name: %s - Type: %s - Value %s''',
'                     , p0 => l_prov_var_name',
'                     , p1 => l_prov_var_type',
'                     , p2 => case l_attribute4',
'                                when ''set'' ',
'                                   then apex_util.get_session_state( p_item => l_item_name )',
'                                 when ''get'' ',
'                                    then to_char(',
'                                            flow_process_vars.get_var_tstz(',
'                                               pi_prcs_id  => l_prcs_id',
'											            , pi_scope    => l_prov_scope   ',
'                                             , pi_var_name => l_prov_var_name',
'                                            ), l_items(l_item_name).format_mask ',
'                                          )',
'                             end ',
'                  );',
'                  case l_attribute4',
'                     when ''set'' then',
'                        flow_process_vars.set_var(',
'                             pi_prcs_id    => l_prcs_id',
'						         , pi_scope      => l_prov_scope',
'                           , pi_var_name   => l_prov_var_name',
'                           , pi_tstz_value => to_timestamp_tz( apex_util.get_session_state( p_item => l_item_name ) , l_items(l_item_name).format_mask )',
'                        );',
'                     when ''get'' then',
'                        apex_util.set_session_state( ',
'                             p_name  => l_item_name',
'                           , p_value => to_char(',
'                                          flow_process_vars.get_var_tstz(',
'                                             pi_prcs_id  => l_prcs_id',
'										             , pi_scope    => l_prov_scope	 ',
'                                           , pi_var_name => l_prov_var_name',
'                                        ), l_items(l_item_name).format_mask )',
'                        );',
'                  end case;      ',
'            when ''CLOB'' then',
'               apex_debug.info(',
'                  p_message => ''......Name: %s - Type: %s - Value %s''',
'                  , p0 => l_prov_var_name',
'                  , p1 => l_prov_var_type',
'                  , p2 => case l_attribute4',
'                             when ''set'' ',
'                                then apex_util.get_session_state( p_item => l_item_name )',
'                              when ''get'' ',
'                                 then flow_process_vars.get_var_clob(',
'                                           pi_prcs_id  => l_prcs_id',
'										           , pi_scope    => l_prov_scope  ',
'                                         , pi_var_name => l_prov_var_name',
'                                      )',
'                          end ',
'               );',
'               case l_attribute4',
'                  when ''set'' then',
'                     flow_process_vars.set_var(',
'                          pi_prcs_id     => l_prcs_id',
'						      , pi_scope       => l_prov_scope',
'                        , pi_var_name    => l_prov_var_name',
'                        , pi_clob_value  => apex_util.get_session_state( p_item => l_item_name )',
'                     );',
'                  when ''get'' then',
'                     apex_exec.execute_plsql(''begin',
'                        :'' || l_item_name || q''[ := '']'' || flow_process_vars.get_var_clob(',
'                                            pi_prcs_id  => l_prcs_id',
'										            , pi_scope    => l_prov_scope	 ',
'                                          , pi_var_name => l_prov_var_name',
'                                       ) || q''['';',
'                        end;]''',
'                     );',
'               end case;',
'            when ''JSON'' then',
'               apex_debug.info(',
'                  p_message => ''......Name: %s - Type: %s - Value %s''',
'                  , p0 => l_prov_var_name',
'                  , p1 => l_prov_var_type',
'                  , p2 => case l_attribute4',
'                             when ''set'' ',
'                                then apex_util.get_session_state( p_item => l_item_name )',
'                              when ''get'' ',
'                                 then flow_process_vars.get_var_json(',
'                                           pi_prcs_id  => l_prcs_id',
'										           , pi_scope    => l_prov_scope  ',
'                                         , pi_var_name => l_prov_var_name',
'                                      )',
'                          end ',
'               );',
'               case l_attribute4',
'                  when ''set'' then',
'                     flow_process_vars.set_var(',
'                          pi_prcs_id     => l_prcs_id',
'						      , pi_scope       => l_prov_scope',
'                        , pi_var_name    => l_prov_var_name',
'                        , pi_json_value  => apex_util.get_session_state( p_item => l_item_name )',
'                     );',
'                  when ''get'' then',
'                     apex_exec.execute_plsql(''begin',
'                        :'' || l_item_name || q''[ := '']'' || flow_process_vars.get_var_json(',
'                                            pi_prcs_id  => l_prcs_id',
'										            , pi_scope    => l_prov_scope	 ',
'                                          , pi_var_name => l_prov_var_name',
'                                       ) || q''['';',
'                        end;]''',
'                     );',
'               end case;   ',
'            end case;',
'         end loop;',
'      end if;',
'      apex_debug.info(',
'           p_message => ''...End %s Flow Instance Variable(s)''',
'         , p0        => case l_attribute4',
'                           when ''set'' then ''setting''',
'                           when ''get'' then ''getting''',
'                        end ',
'      );',
'',
'      return l_result;',
'   exception ',
'      when e_var_config then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-wrong-variable-number'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_incorrect_variable_type then',
'         if apex_application.g_debug then',
'            apex_debug.error(',
'               p_message => ''-- Flows4apex - Plug-in configuration issue, process variables JSON contains incorrect variable type.''',
'            );',
'         end if;',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-parsing-json-variables'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_types_different then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-wrong-variable-type'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_invalid_number then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( ',
'                                p_message_key => ''plugin-variable-not-a-number''',
'                              , p0            => l_process_variable.get(''value'').stringify() ',
'                              , p_lang        => apex_util.get_session_lang() ',
'                           )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_invalid_date then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( ',
'                                p_message_key => ''plugin-variable-not-a-date''',
'                              , p0            =>  l_process_variable.get(''value'').stringify() ',
'                              , p_lang        => apex_util.get_session_lang() ',
'                           )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'      when e_invalid_json then',
'         apex_error.add_error( ',
'              p_message => flow_api_pkg.message( p_message_key => ''plugin-invalid-json'', p_lang => apex_util.get_session_lang() )',
'            , p_display_location => apex_error.c_on_error_page',
'         );',
'   end execution;',
'',
'end flow_plugin_manage_instance_variables;',
'/',
'create or replace package body flow_modeler',
'as',
'  function render',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  , p_is_printer_friendly in  boolean',
'  )',
'    return apex_plugin.t_region_render_result',
'  as',
'    l_return apex_plugin.t_region_render_result;',
'',
'    l_show_custom_extensions flow_configuration.cfig_value%type;',
'  begin',
'    -- get config value for plugin mode',
'    begin',
'        select cfig_value',
'        into l_show_custom_extensions',
'        from flow_configuration',
'        where cfig_key = ''modeler_show_custom_extensions'';',
'    exception',
'        when no_data_found then',
'            l_show_custom_extensions := ''false'';',
'    end;',
'',
'    apex_plugin_util.debug_region',
'    (',
'      p_plugin => p_plugin',
'    , p_region => p_region',
'    );',
'    sys.htp.p( ''<div id="'' || p_region.static_id || ''_modeler" class="flows4apex-modeler '' || v(''THEME_PLUGIN_CLASS'') || ''">'' );',
'    sys.htp.p( ''<div id="'' || p_region.static_id || ''_canvas" class="canvas"></div>'' );',
'    sys.htp.p( ''<div id="'' || p_region.static_id || ''_properties" class="properties-panel-parent"></div>'' );',
'    sys.htp.p( ''<div id="'' || p_region.static_id || ''_dialogContainer" class="dialog-container"></div>'' );',
'    sys.htp.p( ''</div>'' );',
'    apex_javascript.add_onload_code',
'    (',
'      p_code =>',
'        ''apex.jQuery("#'' || p_region.static_id || ''").modeler({'' ||',
'        apex_javascript.add_attribute',
'        (',
'          p_name      => ''ajaxIdentifier''',
'        , p_value     => apex_plugin.get_ajax_identifier',
'        , p_add_comma => true',
'        ) ||',
'        apex_javascript.add_attribute',
'        (',
'          p_name      => ''itemsToSubmit''',
'        , p_value     => apex_plugin_util.page_item_names_to_jquery( p_page_item_names => p_region.ajax_items_to_submit )',
'        , p_add_comma => true',
'        ) ||',
'        apex_javascript.add_attribute',
'        (',
'          p_name      => ''showCustomExtensions''',
'        , p_value     => l_show_custom_extensions',
'        , p_add_comma => true',
'        ) ||',
'        ''})''',
'    );',
'    return l_return;',
'  end render;',
'',
'',
'  procedure load',
'  (',
'    p_region in apex_plugin.t_region',
'  , p_plugin in apex_plugin.t_plugin',
'  )',
'  as',
'    type t_col_position_tab is table of pls_integer index by varchar2(128);',
'',
'    l_col_positions t_col_position_tab;',
'    l_context       apex_exec.t_context;',
'    l_id      number;',
'    l_content clob;',
'    l_found   boolean := false;',
'  begin',
'    apex_plugin_util.debug_region',
'    (',
'      p_plugin => p_plugin',
'    , p_region => p_region',
'    );',
'    l_context :=',
'      apex_exec.open_query_context',
'      (',
'        p_first_row => 1',
'      , p_max_rows  => 1',
'      );',
'    l_col_positions(''id'') :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => ''DGRM_ID''',
'      , p_is_required => true',
'      , p_data_type   => apex_exec.c_data_type_number',
'      );',
'    l_col_positions(''content'') :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => ''DGRM_CONTENT''',
'      , p_is_required => true',
'      , p_data_type   => apex_exec.c_data_type_clob',
'      );',
'    apex_json.open_object;',
'    apex_json.write',
'    (',
'      p_name  => ''success''',
'    , p_value => true',
'    );',
'    if apex_exec.next_row( p_context => l_context ) then',
'      l_found   := true;',
'      l_id      := apex_exec.get_number( p_context => l_context, p_column_idx => l_col_positions(''id'') );',
'      l_content := apex_exec.get_clob( p_context => l_context, p_column_idx => l_col_positions(''content'') );',
'    else',
'      l_found   := false;',
'    end if;',
'    apex_exec.close( p_context => l_context );',
'    apex_json.write',
'    (',
'      p_name  => ''found''',
'    , p_value => l_found',
'    );',
'    apex_json.open_object',
'    (',
'      p_name => ''data''',
'    );',
'    if l_found then',
'      apex_json.write',
'      (',
'        p_name  => ''id''',
'      , p_value => l_id',
'      );',
'      apex_json.write',
'      (',
'        p_name  => ''content''',
'      , p_value => l_content',
'      );',
'    else',
'      apex_json.write',
'      (',
'        p_name  => ''message''',
'      , p_value => flow_api_pkg.message( p_message_key => ''plugin-modeler-id-not-found'', p_lang => apex_util.get_session_lang() )',
'      );',
'    end if;',
'    apex_json.close_all;',
'  exception',
'    when others then',
'      apex_exec.close( p_context => l_context );',
'      apex_json.open_object;',
'      apex_json.write',
'      (',
'        p_name  => ''success''',
'      , p_value => false',
'      );',
'      apex_json.write',
'      (',
'        p_name  => ''message''',
'      , p_value => flow_api_pkg.message( p_message_key => ''plugin-unexpected-error'', p_lang => apex_util.get_session_lang() )',
'      );',
'      apex_json.close_all;',
'  end load;',
'',
'',
'  procedure save',
'  (',
'    p_region in apex_plugin.t_region',
'  , p_plugin in apex_plugin.t_plugin',
'  )',
'  as',
'    l_str_tab apex_t_varchar2 := apex_t_varchar2();',
'    l_clob    clob;',
'    l_values  apex_json.t_values;',
'    l_id      number;',
'    l_content clob;',
'  begin',
'    for i in 1..apex_application.g_json.count loop',
'      l_str_tab.extend();',
'      l_str_tab(i) := apex_application.g_json(i);',
'    end loop;',
'    l_clob := apex_string.join_clob( p_table => l_str_tab, p_sep => null );',
'    apex_json.parse',
'    (',
'      p_values => l_values',
'    , p_source => l_clob',
'    );',
'    l_id      := apex_json.get_number( p_values => l_values, p_path => ''regions[1].data.id'' );',
'    l_content := apex_json.get_clob( p_values => l_values, p_path => ''regions[1].data.content'');',
'    flow_bpmn_parser_pkg.update_diagram',
'    (',
'      pi_dgrm_id      => l_id',
'    , pi_dgrm_content => l_content',
'    );',
'    apex_json.open_object;',
'    apex_json.write( p_name => ''success'', p_value => true );',
'    apex_json.write',
'      (',
'        p_name  => ''message''',
'      , p_value => flow_api_pkg.message( p_message_key => ''plugin-diagram-saved'', p_lang => apex_util.get_session_lang() )',
'      );',
'    apex_json.close_all;',
'  exception',
'    when others then',
'      apex_json.open_object;',
'      apex_json.write( p_name => ''success'', p_value => false );',
'      apex_json.write',
'      (',
'        p_name  => ''message''',
'      , p_value => flow_api_pkg.message( p_message_key => ''plugin-diagram-not-parsable'', p_lang => apex_util.get_session_lang() )',
'      );',
'      apex_json.close_all;',
'  end save;',
'',
'',
'  procedure get_applications',
'  as',
'    l_result clob;',
'    cursor c_applications is select * from apex_applications order by application_name;',
'    l_application apex_applications%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_applications;',
'    loop',
'        fetch c_applications into l_application;',
'        exit when c_applications%NOTFOUND;',
'        l_result :=',
'          l_result ||',
'          ''{"label":"'' || l_application.application_id || '' - '' || l_application.application_name ||',
'          ''","value":"'' || l_application.application_id || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_applications;',
'',
'',
'  procedure get_pages',
'  as',
'    l_result clob;',
'    l_application_id number := cast(apex_application.g_x02 as number default null on conversion error);',
'    cursor c_pages is select * from apex_application_pages where application_id = l_application_id order by page_id;',
'    l_page apex_application_pages%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_pages;',
'    loop',
'        fetch c_pages into l_page;',
'        exit when c_pages%NOTFOUND;',
'        l_result :=',
'          l_result ||',
'          ''{"label":"'' || l_page.page_id || '' - '' || l_page.page_name ||',
'          ''","value":"'' || l_page.page_id || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_pages;',
'',
'',
'  procedure get_items',
'  as',
'    l_result clob;',
'    l_application_id number := cast(apex_application.g_x02 as number default null on conversion error);',
'    l_page_id number := cast(apex_application.g_x03 as number default null on conversion error);',
'    cursor c_items is select * from apex_application_page_items where application_id = l_application_id and page_id = l_page_id order by item_name;',
'    l_item apex_application_page_items%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_items;',
'    loop',
'        fetch c_items into l_item;',
'        exit when c_items%NOTFOUND;',
'        l_result := l_result || ''{"label":"'' || l_item.item_name || ''","value":"'' || l_item.item_name || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_items;',
'',
'',
'  procedure get_applications_mail',
'  as',
'    l_result clob;',
'    cursor c_applications is select * from apex_applications where application_id in (select application_id from apex_appl_email_templates) order by application_name;',
'    l_application apex_applications%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_applications;',
'    loop',
'        fetch c_applications into l_application;',
'        exit when c_applications%NOTFOUND;',
'        l_result :=',
'          l_result ||',
'          ''{"label":"'' || l_application.application_id || '' - '' || l_application.application_name ||',
'          ''","value":"'' || l_application.application_id || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_applications_mail;',
'',
'',
'  procedure get_templates',
'  as',
'    l_result clob;',
'    l_application_id number := cast(apex_application.g_x02 as number default null on conversion error);',
'    cursor c_templates is select * from apex_appl_email_templates where application_id = l_application_id order by name;',
'    l_template apex_appl_email_templates%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_templates;',
'    loop',
'        fetch c_templates into l_template;',
'        exit when c_templates%NOTFOUND;',
'        l_result := l_result || ''{"label":"'' || l_template.name || ''","value":"'' || l_template.static_id || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_templates;',
'',
'',
'  procedure get_json_placeholders',
'  as',
'    l_placeholders apex_t_varchar2;',
'    l_application_id number := cast(apex_application.g_x02 as number default null on conversion error);',
'  begin',
'    with email_content as (',
'      select subject||text_template||html_body||html_footer||html_header as d',
'      from apex_appl_email_templates',
'      where application_id = l_application_id ',
'      and static_id = apex_application.g_x03',
'   ),',
'   placeholders as (',
'      select distinct to_char(regexp_substr(ec.d, ''\#(.*?)\#'', 1, level, NULL, 1)) AS placeholder',
'      from email_content ec',
'      connect by level <= length(regexp_replace(ec.d, ''\#(.*?)\#'')) + 1',
'   ) ',
'   select p.placeholder',
'   bulk collect into l_placeholders',
'   from placeholders p',
'   where p.placeholder is not null',
'   order by p.placeholder;',
'   apex_json.open_object;',
'   for i in 1..l_placeholders.count()',
'   loop',
'      apex_json.write(p_name => l_placeholders(i), p_value => '''', p_write_null => true);',
'   end loop;',
'   apex_json.close_object;',
'  end get_json_placeholders;',
'',
'',
'  procedure get_diagrams',
'  as',
'    l_result clob;',
'    cursor c_diagrams',
'        is',
'    select distinct dgrm_name',
'      from flow_diagrams dgrm',
'      join flow_objects objt',
'        on dgrm.dgrm_id = objt.objt_dgrm_id',
'       and objt.objt_tag_name = flow_constants_pkg.gc_bpmn_process',
'     where objt.objt_attributes."apex"."isCallable" = flow_constants_pkg.gc_vcbool_true',
'     order by dgrm_name;',
'    l_diagram flow_diagrams.dgrm_name%type;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_diagrams;',
'    loop',
'        fetch c_diagrams into l_diagram;',
'        exit when c_diagrams%NOTFOUND;',
'        l_result := l_result || ''{"label":"'' || l_diagram || ''","value":"'' || l_diagram || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_diagrams;',
'',
'',
'  procedure get_variable_mapping',
'  as',
'    l_result clob;',
'',
'    l_dgrm_id flow_diagrams.dgrm_id%type;',
'',
'    l_in_variables  clob;',
'    l_out_variables clob;',
'  begin',
'    l_dgrm_id := flow_diagram.get_current_diagram',
'        ( pi_dgrm_name            => apex_application.g_x02',
'        , pi_dgrm_calling_method  => apex_application.g_x03',
'        , pi_dgrm_version         => apex_application.g_x04',
'        );',
'',
'    select coalesce(objt.objt_attributes."apex"."inVariables", ''""'')',
'         , coalesce(objt.objt_attributes."apex"."outVariables", ''""'')',
'      into l_in_variables',
'         , l_out_variables',
'      from flow_objects objt',
'     where objt.objt_dgrm_id = l_dgrm_id',
'       and objt.objt_tag_name = flow_constants_pkg.gc_bpmn_process;',
'',
'    l_result := ''{"InVariables":'' || l_in_variables ||'',"OutVariables":'' || l_out_variables || ''}'';',
'    htp.p(l_result);',
'  end get_variable_mapping;',
'',
'',
'  procedure get_usernames',
'  as',
'    l_result clob;',
'    cursor c_users is select * from apex_workspace_apex_users order by user_name;',
'    l_user apex_workspace_apex_users%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_users;',
'    loop',
'        fetch c_users into l_user;',
'        exit when c_users%NOTFOUND;',
'        l_result := l_result || ''{"label":"'' || l_user.user_name || ''","value":"'' || l_user.user_name || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_usernames;',
'',
'',
'  procedure get_tasks',
'  as',
'    l_result clob;',
'    l_application_id number := cast(apex_application.g_x02 as number default null on conversion error);',
'    -- check that APEX is min v22.1',
'    $IF flow_apex_env.ver_le_21_2',
'    $THEN',
'    $ELSE',
'      cursor c_task_defs is select * from apex_appl_taskdefs where application_id = l_application_id order by static_id;',
'      l_task_def apex_appl_taskdefs%rowtype;',
'    $END',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    $I'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374096093486864)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'F flow_apex_env.ver_le_21_2',
'    $THEN',
'    $ELSE',
'      open c_task_defs;',
'      loop',
'          fetch c_task_defs into l_task_def;',
'          exit when c_task_defs%NOTFOUND;',
'          l_result := l_result || ''{"label":"'' || l_task_def.name || ''","value":"'' || l_task_def.static_id || ''"},'';',
'    end loop;',
'    $END',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_tasks;',
'',
'',
'  procedure get_json_parameters',
'  as',
'    l_placeholders apex_t_varchar2;',
'    l_application_id number := cast(apex_application.g_x02 as number default null on conversion error);',
'    -- check that APEX is min v22.1',
'    $IF flow_apex_env.ver_le_21_2',
'    $THEN',
'    $ELSE',
'      cursor c_parameters',
'      is ',
'      select aatp.*',
'        from apex_appl_taskdef_params aatp',
'        join apex_appl_taskdefs aat',
'          on aatp.task_def_id = aat.task_def_id',
'      where aat.application_id = l_application_id',
'        and aat.static_id = apex_application.g_x03;',
'      l_parameter apex_appl_taskdef_params%rowtype;',
'    $END',
'  begin',
'    apex_json.open_array;',
'    $IF flow_apex_env.ver_le_21_2',
'    $THEN',
'    $ELSE',
'      open c_parameters;',
'      loop',
'          fetch c_parameters into l_parameter;',
'          exit when c_parameters%NOTFOUND;',
'          apex_json.open_object;',
'          apex_json.write(',
'            p_name  => ''STATIC_ID''',
'          , p_value => l_parameter.static_id',
'          , p_write_null => true',
'          );',
'          apex_json.write(',
'            p_name  => ''DATA_TYPE''',
'          , p_value => l_parameter.data_type',
'          , p_write_null => true',
'          );',
'          apex_json.write(',
'            p_name  => ''VALUE''',
'          , p_value => case l_parameter.static_id',
'                      when ''PROCESS_ID'' then chr(38) || ''F4A$PROCESS_ID.''',
'                      when ''SUBFLOW_ID'' then chr(38) || ''F4A$SUBFLOW_ID.''',
'                      when ''STEP_KEY'' then chr(38) || ''F4A$STEP_KEY.''',
'                      else ''''',
'                      end',
'          , p_write_null => true',
'          );',
'          apex_json.close_object;',
'      end loop;',
'    $END',
'    apex_json.close_array;',
'  end get_json_parameters;',
'',
'',
'  procedure get_form_templates',
'  as',
'    l_result clob;',
'    cursor c_form_templates is select * from flow_simple_form_templates order by sfte_name;',
'    l_form_template flow_simple_form_templates%rowtype;',
'  begin',
'    l_result := ''[{"label":"","value":""},'';',
'    open c_form_templates;',
'    loop',
'        fetch c_form_templates into l_form_template;',
'        exit when c_form_templates%NOTFOUND;',
'        l_result := l_result || ''{"label":"'' || l_form_template.sfte_name || ''","value":"'' || l_form_template.sfte_static_id || ''"},'';',
'    end loop;',
'    l_result := rtrim(l_result, '','') || '']'';',
'    htp.p(l_result);',
'  end get_form_templates;',
'',
'',
'  procedure parse_code',
'  as',
'    v_cur     int;',
'    v_command varchar2(100);',
'    v_input   varchar2(4000);',
'    v_json    json_element_t;',
'    ',
'    l_result  clob := ''{"message":""}'';',
'  begin',
'    if (apex_application.g_x02 is not null) then',
'        case apex_application.g_x03',
'        when ''sql'' then',
'            v_command := upper(substr(apex_application.g_x02, 1,instr(apex_application.g_x02,'' '') - 1));',
'            if v_command in ( ''ALTER'', ''COMPUTE'', ''CREATE'', ''DROP'', ''GRANT'', ''REVOKE'') then',
'                l_result := ''{"message":"Forbidden DDL statement","success":"false"}'';',
'            elsif v_command in ( ''SELECT'', ''INSERT'', ''UPDATE'', ''DELETE'' ) then',
'                v_input := rtrim(apex_application.g_x02, '';'');',
'                begin',
'                    v_cur := dbms_sql.open_cursor();',
'                    dbms_sql.parse(v_cur, v_input, dbms_sql.native);',
'                    dbms_sql.close_cursor(v_cur);',
'                    l_result := ''{"message":"Validation successful","success":"true"}'';',
'                exception',
'                    when others then l_result := ''{"message":"'' || apex_escape.json(sqlerrm) || ''","success":"false"}'';',
'                end;',
'            else',
'                l_result := ''{"message":"Unparsable SQL","success":"false"}'';',
'            end if;',
'        when ''plsql'' then',
'            case apex_application.g_x04',
'            when ''plsqlProcess'' then',
'                v_input := ''begin'' || apex_application.lf || apex_application.g_x02 || apex_application.lf || ''end;'';',
'            when ''plsqlExpression'' then',
'                v_input := ''declare dummy varchar2(4000) :=''',
'                           || apex_application.lf || rtrim(apex_application.g_x02, '';'') || '';'' || apex_application.lf || ''begin null; end;'';',
'            when ''plsqlRawExpression'' then -- use the same snippet as non-raw',
'                v_input := ''declare dummy varchar2(4000) :=''',
'                           || apex_application.lf || rtrim(apex_application.g_x02, '';'') || '';'' || apex_application.lf || ''begin null; end;'';',
'            when ''plsqlExpressionBoolean'' then',
'                v_input := ''declare dummy boolean :=''',
'                           || apex_application.lf || rtrim(apex_application.g_x02, '';'') || '';'' || apex_application.lf || ''begin null; end;'';',
'            when ''plsqlFunctionBody'' then',
'                v_input := ''declare function dummy return varchar2 is begin''',
'                           || apex_application.lf || apex_application.g_x02 || apex_application.lf || ''end; begin null; end;'';',
'            when ''plsqlRawFunctionBody'' then -- use the same snippet as non-raw',
'                v_input := ''declare function dummy return varchar2 is begin''',
'                           || apex_application.lf || apex_application.g_x02 || apex_application.lf || ''end; begin null; end;'';               ',
'            when ''plsqlFunctionBodyBoolean'' then',
'                v_input := ''declare function dummy return boolean is begin''',
'                           || apex_application.lf || apex_application.g_x02 || apex_application.lf || ''end; begin null; end;'';',
'            end case;',
'            begin',
'                v_cur := dbms_sql.open_cursor();',
'                dbms_sql.parse(v_cur, v_input, dbms_sql.native);',
'                dbms_sql.close_cursor(v_cur);',
'                l_result := ''{"message":"Validation successful","success":"true"}'';',
'            exception',
'                when others then l_result := ''{"message":"'' || apex_escape.json(sqlerrm) || ''","success":"false"}'';',
'            end;',
'        when ''json'' then',
'            begin',
'                v_json := json_element_t.parse(apex_application.g_x02);',
'                l_result := ''{"message":"Validation successful","success":"true"}'';',
'            exception',
'               when others then l_result := ''{"message":"'' || apex_escape.json(sqlerrm) || ''","success":"false"}'';',
'            end;',
'        end case;',
'    end if;',
'    htp.p(l_result);',
'  end parse_code;',
'',
'',
'  function ajax',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  )',
'    return apex_plugin.t_region_ajax_result',
'  as',
'    l_return apex_plugin.t_region_ajax_result;',
'  begin',
'    case upper(apex_application.g_x01)',
'      when ''LOAD'' then load( p_region => p_region, p_plugin => p_plugin );',
'      when ''SAVE'' then save( p_region => p_region, p_plugin => p_plugin );',
'      when ''GET_APPLICATIONS'' then get_applications;',
'      when ''GET_PAGES'' then get_pages;',
'      when ''GET_ITEMS'' then get_items;',
'      when ''GET_APPLICATIONS_MAIL'' then get_applications_mail;',
'      when ''GET_TEMPLATES'' then get_templates;',
'      when ''PARSE_CODE'' then parse_code;',
'      when ''GET_JSON_PLACEHOLDERS'' then get_json_placeholders;',
'      when ''GET_DIAGRAMS'' then get_diagrams;',
'      when ''GET_VARIABLE_MAPPING'' then get_variable_mapping;',
'      when ''GET_USERNAMES'' then get_usernames;',
'      when ''GET_TASKS'' then get_tasks;',
'      when ''GET_JSON_PARAMETERS'' then get_json_parameters;',
'      when ''GET_FORM_TEMPLATES'' then get_form_templates;',
'      else null;',
'    end case;',
'    return l_return;',
'  end ajax;',
'end flow_modeler;',
'/',
'',
'create or replace package body flow_viewer',
'as',
'',
'    function render',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  , p_is_printer_friendly in  boolean',
'  )',
'    return apex_plugin.t_region_render_result',
'  as',
'    l_return apex_plugin.t_region_render_result;',
'  begin',
'',
'    apex_plugin_util.debug_region',
'    (',
'      p_plugin => p_plugin',
'    , p_region => p_region',
'    );',
'    sys.htp.p( ''<div id="'' || p_region.static_id || ''_viewer" class="flows4apex-viewer '' || v(''THEME_PLUGIN_CLASS'') || ''">'' );',
'    sys.htp.p( ''<div id="'' || p_region.static_id || ''_canvas" class="canvas" style="display: none;"></div>'' );',
'    sys.htp.p( ''<span id="'' || p_region.static_id || ''_ndf" class="nodatafound" style="display: none;">'' || coalesce(p_region.no_data_found_message, ''No data found.'') || ''</span>'' );',
'    sys.htp.p( ''</div>'' );',
'    apex_javascript.add_onload_code',
'    (',
'      p_code => ''apex.jQuery("#'' || p_region.static_id || ''").viewer({'' ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''ajaxIdentifier''',
'                  , p_value     => apex_plugin.get_ajax_identifier',
'                  , p_add_comma => true',
'                  ) ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''itemsToSubmit''',
'                  , p_value     => apex_plugin_util.page_item_names_to_jquery( p_page_item_names => p_region.ajax_items_to_submit )',
'                  , p_add_comma => true',
'                  ) ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''noDataFoundMessage''',
'                  , p_value     => p_region.no_data_found_message',
'                  , p_add_comma => true',
'                  ) ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''refreshOnLoad''',
'                  , p_value     => ( p_region.attribute_08 = ''Y'' )',
'                  , p_add_comma => true',
'                  ) ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''showToolbar''',
'                  , p_value     => ( p_region.attribute_11 = ''Y'' )',
'                  , p_add_comma => true',
'                  ) ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''addHighlighting''',
'                  , p_value     => ( p_region.attribute_09 = ''Y'' )',
'                  , p_add_comma => true',
'                  ) ||    ',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''enableCallActivities''',
'                  , p_value     => ( p_region.attribute_14 = ''Y'' )',
'                  , p_add_comma => true',
'                  ) ||  ',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''enableMousewheelZoom''',
'                  , p_value     => ( p_region.attribute_15 = ''Y'' )',
'                  , p_add_comma => true',
'                  ) ||',
'                  apex_javascript.add_attribute',
'                  (',
'                    p_name      => ''useBPMNcolors''',
'                  , p_value     => ( p_region.attribute_16 = ''Y'' )',
'                  , p_add_comma => true',
'                  ) ||',
'                  ''"config":'' || p_region.init_javascript_code || ''({})'' ||',
'                ''})''',
'    );',
'',
'    return l_return;',
'  end render;',
'',
'  function ajax',
'  (',
'    p_region              in  apex_plugin.t_region',
'  , p_plugin              in  apex_plugin.t_plugin',
'  )',
'    return apex_plugin.t_region_ajax_result',
'  as',
'',
'    l_context                  apex_exec.t_context;',
'    l_diagram_col_idx          pls_integer;',
'    l_current_col_idx          pls_integer;',
'    l_completed_col_idx        pls_integer;',
'    l_error_col_idx            pls_integer;',
'    l_dgrm_id_col_idx          pls_integer;',
'    l_calling_dgrm_col_idx     pls_integer;',
'    l_calling_objt_col_idx     pls_integer;',
'    l_breadcrumb_col_idx       pls_integer;',
'    l_sub_prcs_insight_col_idx pls_integer;',
'    l_iteration_data_col_idx   pls_integer;',
'    l_user_task_urls_col_idx   pls_integer;',
'',
'    l_current_nodes   apex_t_varchar2;',
'    l_completed_nodes apex_t_varchar2;',
'    l_error_nodes     apex_t_varchar2;',
'',
'    l_return apex_plugin.t_region_ajax_result;',
'  begin',
'    apex_plugin_util.debug_region',
'    (',
'      p_plugin => p_plugin',
'    , p_region => p_region',
'    );',
'',
'    l_context :=',
'      apex_exec.open_query_context',
'      (',
'        p_total_row_count => true',
'      );',
'',
'    l_diagram_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_01',
'      , p_is_required => true',
'      , p_data_type   => apex_exec.c_data_type_clob',
'      );',
'',
'    l_current_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_02',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_varchar2',
'      );',
'',
'    l_completed_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_04',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_varchar2',
'      );',
'',
'    l_error_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_06',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_varchar2',
'      );',
'',
'    l_dgrm_id_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_03',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_number',
'      );',
'',
'    l_calling_dgrm_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_05 ',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_number',
'      );',
'',
'    l_calling_objt_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_07 ',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_varchar2',
'      );',
'    l_breadcrumb_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_12 ',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_varchar2',
'      );',
'    l_sub_prcs_insight_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_13',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_number',
'      );',
'    l_iteration_data_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_17',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_clob',
'      );',
'    l_user_task_urls_col_idx :=',
'      apex_exec.get_column_position',
'      (',
'        p_context     => l_context',
'      , p_column_name => p_region.attribute_18',
'      , p_is_required => false',
'      , p_data_type   => apex_exec.c_data_type_clob',
'      );',
'',
'    apex_json.open_object;',
'',
'    if apex_exec.get_total_row_count( p_context => l_context ) > 0 then',
'',
'      -- multiple rows found but call activity option disabled',
'      if apex_exec.get_total_row_count( p_context => l_context ) > 1 and p_region.attribute_14 = ''N'' then',
'',
'        apex_json.write',
'        (',
'          p_name  => ''found''',
'        , p_value => false',
'        );',
'',
'        apex_json.write',
'        (',
'          p_name  => ''message''',
'        , p_value => flow_api_pkg.message( p_message_key => ''plugin-multiple-rows'', p_lang => apex_util.get_session_lang() )',
'        );',
'',
'      else',
'',
'        apex_json.write',
'        (',
'          p_name  => ''found''',
'        , p_value => true',
'        );',
'',
'        apex_json.open_array',
'        (',
'          p_name => ''data''',
'        );',
'',
'        while apex_exec.next_row( p_context => l_context ) loop',
'          apex_json.open_object;',
'',
'          apex_json.write',
'          (',
'            p_name  => ''diagram''',
'          , p_value => apex_exec.get_clob( p_context => l_context, p_column_idx => l_diagram_col_idx )',
'          );',
'',
'          if l_dgrm_id_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''diagramIdentifier''',
'              , p_value => apex_exec.get_number( p_context => l_context, p_column_idx => l_dgrm_id_col_idx )',
'              );',
'          end if;',
'',
'          if l_calling_dgrm_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''callingDiagramIdentifier''',
'              , p_value => apex_exec.get_number( p_context => l_context, p_column_idx => l_calling_dgrm_col_idx )',
'              );',
'          end if;',
'',
'          if l_calling_objt_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''callingObjectId''',
'              , p_value => apex_exec.get_varchar2( p_context => l_context, p_column_idx => l_calling_objt_col_idx )',
'              );',
'          end if;',
'',
'          if l_breadcrumb_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''breadcrumb''',
'              , p_value => apex_exec.get_varchar2( p_context => l_context, p_column_idx => l_breadcrumb_col_idx )',
'              );',
'          end if;',
'',
'          if l_sub_prcs_insight_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''insight''',
'              , p_value => apex_exec.get_number( p_context => l_context, p_column_idx => l_sub_prcs_insight_col_idx )',
'              );',
'          end if;',
'',
'          if l_iteration_data_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''iterationData''',
'              , p_value => apex_exec.get_clob( p_context => l_context, p_column_idx => l_iteration_data_col_idx )',
'              );',
'          end if;',
'',
'          if l_user_task_urls_col_idx is not null then',
'              apex_json.write',
'              (',
'                p_name  => ''userTaskData''',
'              , p_value => apex_exec.get_clob( p_context => l_context, p_column_idx => l_user_task_urls_col_idx )',
'              );',
'          end if;',
'',
'          apex_json.open_array',
'          (',
'            p_name => ''current''',
'          );',
'',
'          if l_current_col_idx is not null then',
'            l_current_nodes :=',
'              apex_string.split',
'              (',
'                p_str => apex_exec.get_varchar2( p_context => l_context, p_column_idx => l_current_col_idx )',
'              , p_sep => '':''',
'              );',
'',
'            for i in 1..l_current_nodes.count loop',
'              apex_json.write( p_value => l_current_nodes(i) );',
'            end loop;',
'          end if;',
'',
'          apex_json.close_array;',
'',
'          apex_json.open_array',
'          (',
'            p_name => ''completed''',
'          );',
'',
'          if l_completed_col_idx is not null then',
'            l_completed_nodes :=',
'              apex_string.split',
'              (',
'                p_str => apex_exec.get_varchar2( p_context => l_context, p_column_idx => l_completed_col_idx )',
'              , p_sep => '':''',
'              );',
'',
'            for i in 1..l_completed_nodes.count loop',
'              apex_json.write( p_value => l_completed_nodes(i) );',
'            end loop;',
'          end if;',
'',
'          apex_json.close_array;',
'',
'          apex_json.open_array',
'          (',
'            p_name => ''error''',
'          );',
'',
'          if l_error_col_idx is not null then',
'            l_error_nodes :=',
'              apex_string.split',
'              (',
'                p_str => apex_exec.get_varchar2( p_context => l_context, p_column_idx => l_error_col_idx )',
'              , p_sep => '':''',
'              );',
'',
'            for i in 1..l_error_nodes.count loop',
'              apex_json.write( p_value => l_error_nodes(i) );',
'            end loop;',
'          end if;',
'',
'          apex_json.close_array;',
'',
'          apex_json.close_object;',
'        end loop;',
'',
'        apex_exec.close( p_context => l_context );',
'',
'        apex_json.close_array;',
'',
'      end if;',
'',
'    else',
'      apex_json.write',
'      (',
'        p_name  => ''found''',
'      , p_value => false',
'      );',
'',
'    end if;',
'',
'    apex_json.close_object;',
'    return l_return;',
'  end ajax;',
'',
'end flow_viewer;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_examples
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Examples'
,p_sequence=>50
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Get_Started" name="Getting Started" isExecutable="true" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_1h6hi8k" name="Process Start">]''',
'      ,q''[      <bpmn:outgoing>Flow_16vwtz6</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0i4a27g" name="Task A">]''',
'      ,q''[      <bpmn:incoming>Flow_16vwtz6</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1j6b5h7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_16vwtz6" sourceRef="Event_1h6hi8k" targetRef="Activity_0i4a27g" />]''',
'      ,q''[    <bpmn:task id="Activity_0k99i8a" name="Task B">]''',
'      ,q''[      <bpmn:incoming>Flow_1j6b5h7</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_16n8dwi</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1j6b5h7" sourceRef="Activity_0i4a27g" targetRef="Activity_0k99i8a" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_16n8dwi" sourceRef="Activity_0k99i8a" targetRef="Gateway_1nhkn7p" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_1nhkn7p" name="Split Paths">]''',
'      ,q''[      <bpmn:incoming>Flow_16n8dwi</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1cxgzbp</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_11kyyj5</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_1gpoou5" name="Task C">]''',
'      ,q''[      <bpmn:incoming>Flow_1cxgzbp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_11oncpd</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1cxgzbp" sourceRef="Gateway_1nhkn7p" targetRef="Activity_1gpoou5" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_1ef89m3" name="Re-Merge &#38; Synchronize">]''',
'      ,q''[      <bpmn:incoming>Flow_11oncpd</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0x0prhl</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wcqldc</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11oncpd" sourceRef="Activity_1gpoou5" targetRef="Gateway_1ef89m3" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0aiip5h" name="Process End">]''',
'      ,q''[      <bpmn:incoming>Flow_0wcqldc</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wcqldc" sourceRef="Gateway_1ef89m3" targetRef="Event_0aiip5h" />]''',
'      ,q''[    <bpmn:task id="Activity_1uvn0o8" name="Task D">]''',
'      ,q''[      <bpmn:incoming>Flow_11kyyj5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0x0prhl</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11kyyj5" sourceRef="Gateway_1nhkn7p" targetRef="Activity_1uvn0o8" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0x0prhl" sourceRef="Activity_1uvn0o8" targetRef="Gateway_1ef89m3" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0s1apks">]''',
'      ,q''[      <bpmn:text>Welcome to the Flows for APEX Tutorials.]''',
'      ,q''[]''',
'      ,q''[We''ve left a few tutorial and demo models here for you to get started!]''',
'      ,q''[]''',
unistr('      ,q''[To create a new model, use the Flow Management page then the +Create Flow button to create or edit a model.\00A0 If you edit the tutorials, please save them into your own model so that others can start from a clean model!]'''),
'      ,q''[- select or create a new category - e.g., ''my tests'']''',
unistr('      ,q''[- give your model a name ''my first model''\00A0 \00A0 - version 0 is fine.]'''),
'      ,q''[]''',
'      ,q''[To execute a model, go to Flow Monitor.]''',
unistr('      ,q''[Using + Create New Instance button, select the Process Diagram that you want to execute an Instance of.\00A0 Give the instance a Name.]'''),
'      ,q''[]''',
unistr('      ,q''[In Flow Monitor, the Process Instances tab shows you all of the current process instances.\00A0 Find your process instance and then using the row menu, select Start to begin executing your process.]'''),
'      ,q''[]''',
unistr('      ,q''[Select Details.\00A0 Then move to the Subflows tab to see the individual routes (subflows) through your process.\00A0 Use the Complete option to move the subflow forwards.]'''),
'      ,q''[]''',
unistr('      ,q''[Other tabs include\00A0]'''),
unistr('      ,q''[- Variables - this shows you the current state / contents of any process variables set for the process instance. \00A0We''ll explore that in the Gateway Tutorial model.]'''),
unistr('      ,q''[- Subscriptions - this shows you any MessageFlow messages that the process instance is waiting for. \00A0We''ll explain that later in Tutorial 7, which is all about message flow.]'''),
'      ,q''[- Task List Entries - shows you what entries the current process is putting into user''s Task Lists at present.]''',
'      ,q''[]''',
unistr('      ,q''[This model has a parallel section, but is otherwise very simple.\00A0 Step through the model using the Complete icon to show progress.]'''),
'      ,q''[]''',
'      ,q''[When the process has completed, you can go back to Process Instances and either reset it, to execute it again, or delete it.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1qmz32s" sourceRef="Event_1h6hi8k" targetRef="TextAnnotation_0s1apks" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1ooxxc0">]''',
unistr('      ,q''[      <bpmn:text>When you''re happy with this, move on to\00A0 Tutorial 1,\00A0 about Gateways....]'''),
'      ,q''[]''',
'      ,q''[You can also look at our sample applications - access them from http://flowsforapex.org/</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1tltpuk" sourceRef="Event_0aiip5h" targetRef="TextAnnotation_1ooxxc0" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1w4dn1z">]''',
unistr('      ,q''[      <bpmn:text>These are Tasks that have to be performed in your process.\00A0 \00A0Each Task is a Process Step.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1gei2vd" sourceRef="Activity_0i4a27g" targetRef="TextAnnotation_1w4dn1z" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Get_Started">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1h6hi8k_di" bpmnElement="Event_1h6hi8k">]''',
'      ,q''[        <dc:Bounds x="312" y="432" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="297" y="475" width="67" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0i4a27g_di" bpmnElement="Activity_0i4a27g" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="400" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0k99i8a_di" bpmnElement="Activity_0k99i8a" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="560" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1ye0z4z_di" bpmnElement="Gateway_1nhkn7p" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="725" y="425" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="724" y="395" width="53" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1gpoou5_di" bpmnElement="Activity_1gpoou5" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="840" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1ef89m3_di" bpmnElement="Gateway_1ef89m3" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1005" y="425" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1000" y="395" width="61" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0aiip5h_di" bpmnElement="Event_0aiip5h">]''',
'      ,q''[        <dc:Bounds x="1122" y="432" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1078" y="483" width="63" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1uvn0o8_di" bpmnElement="Activity_1uvn0o8" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="840" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0s1apks_di" bpmnElement="TextAnnotation_0s1apks">]''',
'      ,q''[        <dc:Bounds x="480" y="-30" width="810" height="420" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1ooxxc0_di" bpmnElement="TextAnnotation_1ooxxc0">]''',
'      ,q''[        <dc:Bounds x="1160" y="560" width="250" height="98" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1w4dn1z_di" bpmnElement="TextAnnotation_1w4dn1z">]''',
'      ,q''[        <dc:Bounds x="480" y="628" width="200" height="62" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16vwtz6_di" bpmnElement="Flow_16vwtz6">]''',
'      ,q''[        <di:waypoint x="348" y="450" />]''',
'      ,q''[        <di:waypoint x="400" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1j6b5h7_di" bpmnElement="Flow_1j6b5h7">]''',
'      ,q''[        <di:waypoint x="500" y="450" />]''',
'      ,q''[        <di:waypoint x="560" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16n8dwi_di" bpmnElement="Flow_16n8dwi">]''',
'      ,q''[        <di:waypoint x="660" y="450" />]''',
'      ,q''[        <di:waypoint x="725" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1cxgzbp_di" bpmnElement="Flow_1cxgzbp">]''',
'      ,q''[        <di:waypoint x="775" y="450" />]''',
'      ,q''[        <di:waypoint x="840" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11oncpd_di" bpmnElement="Flow_11oncpd">]''',
'      ,q''[        <di:waypoint x="940" y="450" />]''',
'      ,q''[        <di:waypoint x="1005" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wcqldc_di" bpmnElement="Flow_0wcqldc">]''',
'      ,q''[        <di:waypoint x="1055" y="450" />]''',
'      ,q''[        <di:waypoint x="1122" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11kyyj5_di" bpmnElement="Flow_11kyyj5">]''',
'      ,q''[        <di:waypoint x="750" y="475" />]''',
'      ,q''[        <di:waypoint x="750" y="560" />]''',
'      ,q''[        <di:waypoint x="840" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0x0prhl_di" bpmnElement="Flow_0x0prhl">]''',
'      ,q''[        <di:waypoint x="940" y="560" />]''',
'      ,q''[        <di:waypoint x="1030" y="560" />]''',
'      ,q''[        <di:waypoint x="1030" y="475" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1qmz32s_di" bpmnElement="Association_1qmz32s">]''',
'      ,q''[        <di:waypoint x="339" y="435" />]''',
'      ,q''[        <di:waypoint x="480" y="210" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1tltpuk_di" bpmnElement="Association_1tltpuk">]''',
'      ,q''[        <di:waypoint x="1149" y="465" />]''',
'      ,q''[        <di:waypoint x="1202" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1gei2vd_di" bpmnElement="Association_1gei2vd">]''',
'      ,q''[        <di:waypoint x="467" y="490" />]''',
'      ,q''[        <di:waypoint x="524" y="628" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 1  - Getting Started'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Gateway_Tutorial" name="Gateway Routing Tutorial" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_0rq5hjv" name="Start Tutorial">]''',
'      ,q''[      <bpmn:outgoing>Flow_0yr7dsk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_Concept1" name="Concept 1:&#10;Default Routing">]''',
'      ,q''[      <bpmn:incoming>Flow_0yr7dsk</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_02o3o4y</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0yr7dsk" sourceRef="Event_0rq5hjv" targetRef="Activity_Concept1" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_One" name="Select Route 1?" default="Flow_1h8t6bd">]''',
'      ,q''[      <bpmn:incoming>Flow_02o3o4y</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0jo4c98</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1h8t6bd</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02o3o4y" sourceRef="Activity_Concept1" targetRef="Gateway_One" />]''',
'      ,q''[    <bpmn:task id="Activity_1b47q7i" name="Yes Route">]''',
'      ,q''[      <bpmn:incoming>Flow_0jo4c98</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0xk0udg</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0jo4c98" name="Y" sourceRef="Gateway_One" targetRef="Activity_1b47q7i" apex:sequence="20" />]''',
'      ,q''[    <bpmn:task id="Activity_0jktnki" name="No Route&#10;(Default Path)">]''',
'      ,q''[      <bpmn:incoming>Flow_1h8t6bd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1q12jx5</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1h8t6bd" name="N" sourceRef="Gateway_One" targetRef="Activity_0jktnki" apex:sequence="30" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1d4vdv1" name="Closing&#10;Gateway 1">]''',
'      ,q''[      <bpmn:incoming>Flow_1q12jx5</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0xk0udg</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_12a7a04</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1q12jx5" sourceRef="Activity_0jktnki" targetRef="Gateway_1d4vdv1" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0xk0udg" sourceRef="Activity_1b47q7i" targetRef="Gateway_1d4vdv1" />]''',
'      ,q''[    <bpmn:task id="Activity_0yr8k9p" name="Second Yes Route">]''',
'      ,q''[      <bpmn:incoming>Flow_3_Yes</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0k5jysk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_0uu6w6g" name="End Tutorial">]''',
'      ,q''[      <bpmn:incoming>Flow_0bc9nni</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0k5jysk" sourceRef="Activity_0yr8k9p" targetRef="Gateway_0wcdym9" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_Three" name="Gateway Three">]''',
'      ,q''[      <bpmn:incoming>Flow_05v09nk</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_3_Yes</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_3_No</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_3_Yes" name="3_Yes" sourceRef="Gateway_Three" targetRef="Activity_0yr8k9p" apex:sequence="20" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_0wcdym9">]''',
'      ,q''[      <bpmn:incoming>Flow_0k5jysk</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1lsahzw</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0bc9nni</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0bc9nni" sourceRef="Gateway_0wcdym9" targetRef="Event_0uu6w6g" apex:sequence="10" />]''',
'      ,q''[    <bpmn:task id="Activity_0jpxv7u" name="Second No Route">]''',
'      ,q''[      <bpmn:incoming>Flow_3_No</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1lsahzw</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_3_No" name="3_No" sourceRef="Gateway_Three" targetRef="Activity_0jpxv7u" apex:sequence="30" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1lsahzw" sourceRef="Activity_0jpxv7u" targetRef="Gateway_0wcdym9" />]''',
'      ,q''[    <bpmn:task id="Activity_Concept3" name="Concept 3: Gateway Routing Variables">]''',
'      ,q''[      <bpmn:incoming>Flow_11z8xs6</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_05v09nk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_05v09nk" sourceRef="Activity_Concept3" targetRef="Gateway_Three" />]''',
'      ,q''[    <bpmn:task id="Activity_Concept2" name="Concept 2:&#10;Gateway Routing Expressions">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>DEPT</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>SALES</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[        <apex:afterTask />]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_12a7a04</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1691lnn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12a7a04" sourceRef="Gateway_1d4vdv1" targetRef="Activity_Concept2" apex:sequence="10" />]''',
unistr('      ,q''[    <bpmn:exclusiveGateway id="Gateway_Two" name="Gateway&#10;\00A0Two" default="Flow_ProdDev">]'''),
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeSplit />]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1691lnn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_Sales</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_ProdDev</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1691lnn" sourceRef="Activity_Concept2" targetRef="Gateway_Two" />]''',
'      ,q''[    <bpmn:task id="Activity_Sales" name="Process Sales Bonus">]''',
'      ,q''[      <bpmn:incoming>Flow_Sales</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1txhooo</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_Sales" name=":DEPT = &#39;SALES&#39;" sourceRef="Gateway_Two" targetRef="Activity_Sales" apex:sequence="10">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$DEPT = ''SALES''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:task id="Activity_ProdDev" name="Process ProdDev Bonus">]''',
'      ,q''[      <bpmn:incoming>Flow_ProdDev</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1j0axlj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_ProdDev" name=":DEPT = &#39;PRODDEV&#39;" sourceRef="Gateway_Two" targetRef="Activity_ProdDev" apex:sequence="20" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_19h24z4">]''',
'      ,q''[      <bpmn:incoming>Flow_1j0axlj</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1txhooo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_11z8xs6</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1j0axlj" sourceRef="Activity_ProdDev" targetRef="Gateway_19h24z4" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1txhooo" sourceRef="Activity_Sales" targetRef="Gateway_19h24z4" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11z8xs6" sourceRef="Gateway_19h24z4" targetRef="Activity_Concept3" apex:sequence="10" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1fvohcn">]''',
unistr('      ,q''[      <bpmn:text>How to Navigate through a Gateway for a Demo Model:\00A0]'''),
'      ,q''[]''',
'      ,q''[Method 1: Default Routing.]''',
'      ,q''[]''',
unistr('      ,q''[Note that the Lower Route has a ''/'' mark across the flow.\00A0 This denotes it as the default path.]'''),
'      ,q''[To add default path:]''',
'      ,q''[- select the Flow between the Gateway and the next object.]''',
'      ,q''[- click on the ''morph'' tool (the spanner)]''',
'      ,q''[- select default path</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0jg4oqm" sourceRef="Gateway_One" targetRef="TextAnnotation_1fvohcn" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0qhtqn5">]''',
'      ,q''[      <bpmn:text>This is a mini-tutorial on Gateways that will help you create a test model here and execute it.]''',
'      ,q''[]''',
unistr('      ,q''[When you add Flows for APEX into your application, you would have some application logic helping to steer you through the gateways.\00A0 In this demo environment, we have to cheat a little.]'''),
'      ,q''[]''',
unistr('      ,q''[The first gateway pair uses default routing to force your model to always go on one path.\00A0 Obviously, to test your model you can edit the model to move the default from one path to another....]'''),
'      ,q''[]''',
unistr('      ,q''[The second gateway uses Gateway Routing Expressions (new in v22.2) - which allows you to define an expression on each of the forward paths. \00A0These are evaluated in sequence_number order - and the first path with an expression that evaluates')
||unistr(' to ''true'' is chosen. \00A0]'''),
'      ,q''[]''',
unistr('      ,q''[The third gateway pair shows you how a special process variable, called a Gateway Routing Variable, \00A0can be used to instruct the gateway which route to take. \00A0This is the ''old way'' to set gateway routing -- but sometimes this can still be u')
||'seful.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1y1u9dd" sourceRef="Activity_Concept1" targetRef="TextAnnotation_0qhtqn5" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1vzs22f">]''',
'      ,q''[      <bpmn:text>Method 3: Instructing the Gateway using Routing Variables]''',
unistr('      ,q''[(This is useful - but a bit more\00A0complicated!)]'''),
'      ,q''[]''',
'      ,q''[Click on the Gateway &amp; see that it has an ID of ''Gateway_Three'' in the properties panel on the right.]''',
'      ,q''[Note that the two forward paths have ID''s of ''Flow_3_Yes'' and ''Flow_3_No'']''',
'      ,q''[]''',
unistr('      ,q''[To instruct our gateway ''Gateway_Three'' which way to route the process, you would set up a Process Variable with the routing instructions somewhere in your application before you get to the Gateway.\00A0]'''),
'      ,q''[]''',
'      ,q''[You need to set a process variable with name = &lt;gateway_ID&gt;&lt;:route&gt;. The value needs to be the ID of the route you want it to take.]''',
'      ,q''[]''',
'      ,q''[So in our example, we need to set process variable ''Gateway_Three:route'' with a varchar2 value of ''Flow_3_Yes'' to go down the 3_Yes route, and ''Flow_3_No'' to go down the 3_No route.]''',
'      ,q''[]''',
'      ,q''[In the Flow Monitor, you can set this manually or you can use the Gateway Route Tool. Run a copy of this model in Flow Control. Before you get to Gateway Three, Click on the Variables Tab. Add a row into the Interactive Grid to create our p'
||'rocess variable named ''Gateway_Three:route'' , give it a type of VARCHAR2, and set its value to ''Flow_3_No''. Don''t forget to Save this. Then go to the Subflows tab, and step the process on through the gateway.]''',
'      ,q''[]''',
'      ,q''[Using the Gateway Routing Tool makes this manual process easier. Once you have the process running, select the Variables tab. This gives you a pop-up list of opening gateways, and shows you the possible route options. Select the one or ones'
||' you want, and you will see the process variable has been created and set for you. Again, don''t forget to save this, then go to the Subflows tab, and step the process on through the gateway.]''',
'      ,q''[]''',
'      ,q''[In a real application you wouldn''t do this through the Flow Engine console. Somewhere in your application you would set the routing based on your data. This could be a variable set call in any previous step, or you could have a scriptTask i'
||unistr('n the step immediately before that runs a PL/SQL script to set it based on some query or whatever your imagination can create, or you could use a declarative variable expression to set this in the gateway step.\00A0 We''ll explore that later...</bpmn:text')
||'>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0hx891w" sourceRef="Activity_Concept3" targetRef="TextAnnotation_1vzs22f" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0kv1ra3">]''',
unistr('      ,q''[      <bpmn:text>An Opening Gateway will first look for a process variable &lt;its name&gt;:route containing a route. \00A0If not finds that, it uses that for its routing.]'''),
'      ,q''[]''',
'      ,q''[if there is no process variable, it looks for default routing]''',
'      ,q''[]''',
'      ,q''[If there is no variable and no default routing, it will return an error to the user.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0jgd1xj" sourceRef="Gateway_Three" targetRef="TextAnnotation_0kv1ra3" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_09eif2m">]''',
unistr('      ,q''[      <bpmn:text>Method 2: Gateway Routing Expressions.\00A0]'''),
'      ,q''[]''',
unistr('      ,q''[Here we place a condition on each of the forward paths. \00A0The condition can be a PL/SQL Expression or a PL/SQL Function Body. \00A0And note that the forward paths have a Sequence Number to determine the order in which their expressions are \00A0eval')
||unistr('uated. \00A0For an Exclusive Gateway, the first path with a condition that evaluates to TRUE is chosen.]'''),
'      ,q''[]''',
unistr('      ,q''[We used a Variable Expression that evaluates ''Before Task'' in the Concept2 Task to set a process variable called ''DEPT'' equal to ''SALES''. \00A0 The demo just uses a static assignment, so it''s always ''SALES'' -- but the variable expression could ')
||'have been set by a SQL Query or a PL/SQL Function or Expression...]''',
'      ,q''[]''',
'      ,q''[Then the Condition on the Forward path uses ''bind'' syntax to compare the current value of DEPT to ''SALES'' - If so, it takes this path...]''',
'      ,q''[]''',
unistr('      ,q''[Note that we always prefix Flows for APEX variables with F4A$ - \00A0just so they don''t get confused with any APEX Page Items.]'''),
'      ,q''[]''',
'      ,q''[You could also use Substitution Syntax for a process variable, so the condition would be ''&amp;F4A$DEPT.'' = ''SALES''.]''',
'      ,q''[]''',
'      ,q''[You can re-running the process instance and try setting DEPT to ''PRODDEV'' or another value...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_11qbgm5" sourceRef="Activity_Concept2" targetRef="TextAnnotation_09eif2m" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Gateway_Tutorial">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0rq5hjv_di" bpmnElement="Event_0rq5hjv">]''',
'      ,q''[        <dc:Bounds x="222" y="332" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="209" y="375" width="63" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[   '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_135jcwt_di" bpmnElement="Activity_Concept1" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="340" y="310" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_11lejcq_di" bpmnElement="Gateway_One" isMarkerVisible="true" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="495" y="325" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="522" y="273" width="79" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1b47q7i_di" bpmnElement="Activity_1b47q7i" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="600" y="310" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0jktnki_di" bpmnElement="Activity_0jktnki" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="600" y="420" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1d4vdv1_di" bpmnElement="Gateway_1d4vdv1" isMarkerVisible="true" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="755" y="325" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="753" y="266" width="53" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0yr8k9p_di" bpmnElement="Activity_0yr8k9p" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1560" y="540" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0uu6w6g_di" bpmnElement="Event_0uu6w6g">]''',
'      ,q''[        <dc:Bounds x="1912" y="562" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1902" y="605" width="58" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0r9iz6p_di" bpmnElement="Gateway_Three" isMarkerVisible="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1395" y="555" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1305" y="570" width="76" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0wcdym9_di" bpmnElement="Gateway_0wcdym9" isMarkerVisible="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1775" y="555" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0jpxv7u_di" bpmnElement="Activity_0jpxv7u" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1560" y="650" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1qvl818_di" bpmnElement="Activity_Concept3" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1370" y="450" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0bimpj6_di" bpmnElement="Activity_Concept2" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="860" y="310" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0a8tre1_di" bpmnElement="Gateway_Two" isMarkerVisible="true" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1015" y="325" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="978" y="300" width="44" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0g057v7_di" bpmnElement="Activity_Sales" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1170" y="250" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0nsxg9h_di" bpmnElement="Activity_ProdDev" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1170" y="420" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_19h24z4_di" bpmnElement="Gateway_19h24z4" isMarkerVisible="true" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1315" y="345" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1fvohcn_di" bpmnElement="TextAnnotation_1fvohcn" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="410" y="570" width="539.9999389648438" height="137.996337890625" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0qhtqn5_di" bpmnElement="TextAnnotation_0qhtqn5" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="500" y="-50" width="544.9631958007812" height="222.99630737304688" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1vzs22f_di" bpmnElement="TextAnnotation_1vzs22f" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1970" y="50" width="790" height="420" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0kv1ra3_di" bpmnElement="TextAnnotation_0kv1ra3" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1890" y="660" width="470" height="96" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_09eif2m_di" bpmnElement="TextAnnotation_09eif2m" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1180" y="-70" width="680" height="311" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0yr7dsk_di" bpmnElement="Flow_0yr7dsk">]''',
'      ,q''[        <di:waypoint x="258" y="350" />]''',
'      ,q''[        <di:waypoint x="340" y="350" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02o3o4y_di" bpmnElement="Flow_02o3o4y">]''',
'      ,q''[        <di:waypoint x="440" y="350" />]''',
'      ,q''[        <di:waypoint x="495" y="350" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jo4c98_di" bpmnElement="Flow_0jo4c98">]''',
'      ,q''[        <di:waypoint x="545" y="350" />]''',
'      ,q''[        <di:waypoint x="600" y="350" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="569" y="332" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1h8t6bd_di" bpmnElement="Flow_1h8t6bd">]''',
'      ,q''[        <di:waypoint x="520" y="375" />]''',
'      ,q''[        <di:waypoint x="520" y="460" />]''',
'      ,q''[        <di:waypoint x="600" y="460" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="546" y="443" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1q12jx5_di" bpmnElement="Flow_1q12jx5">]''',
'      ,q''[        <di:waypoint x="700" y="460" />]''',
'      ,q''[        <di:waypoint x="780" y="460" />]''',
'      ,q''[        <di:waypoint x="780" y="375" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xk0udg_di" bpmnElement="Flow_0xk0udg">]''',
'      ,q''[        <di:waypoint x="700" y="350" />]''',
'      ,q''[        <di:waypoint x="755" y="350" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0k5jysk_di" bpmnElement="Flow_0k5jysk">]''',
'      ,q''[        <di:waypoint x="1660" y="580" />]''',
'      ,q''[        <di:waypoint x="1775" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0qf714m_di" bpmnElement="Flow_3_Yes">]''',
'      ,q''[        <di:waypoint x="1445" y="580" />]''',
'      ,q''[        <di:waypoint x="1560" y="580" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1487" y="562" width="31" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0bc9nni_di" bpmnElement="Flow_0bc9nni">]''',
'      ,q''[        <di:waypoint x="1825" y="580" />]''',
'      ,q''[        <di:waypoint x="1912" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0eztoqc_di" bpmnElement="Flow_3_No">]''',
'      ,q''[        <di:waypoint x="1420" y="605" />]''',
'      ,q''[        <di:waypoint x="1420" y="690" />]''',
'      ,q''[        <di:waypoint x="1560" y="690" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1490" y="663" width="26" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1lsahzw_di" bpmnElement="Flow_1lsahzw">]''',
'      ,q''[        <di:waypoint x="1660" y="690" />]''',
'      ,q''[        <di:waypoint x="1800" y="690" />]''',
'      ,q''[        <di:waypoint x="1800" y="605" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_05v09nk_di" bpmnElement="Flow_05v09nk">]''',
'      ,q''[        <di:waypoint x="1420" y="530" />]''',
'      ,q''[        <di:waypoint x="1420" y="555" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12a7a04_di" bpmnElement="Flow_12a7a04">]''',
'      ,q''[        <di:waypoint x="805" y="350" />]''',
'      ,q''[        <di:waypoint x="860" y="350" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1691lnn_di" bpmnElement="Flow_1691lnn">]''',
'      ,q''[        <di:waypoint x="960" y="350" />]''',
'      ,q''[        <di:waypoint x="1015" y="350" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1loyk10_di" bpmnElement="Flow_Sales">]''',
'      ,q''[        <di:waypoint x="1040" y="325" />]''',
'      ,q''[        <di:waypoint x="1040" y="290" />]''',
'      ,q''[        <di:waypoint x="1170" y="290" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1059" y="263" width="82" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03bj1fy_di" bpmnElement="Flow_ProdDev">]''',
'      ,q''[        <di:waypoint x="1040" y="375" />]''',
'      ,q''[        <di:waypoint x="1040" y="460" />]''',
'      ,q''[        <di:waypoint x="1170" y="460" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1071" y="426" width="57" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1j0axlj_di" bpmnElement="Flow_1j0axlj">]''',
'      ,q''[        <di:waypoint x="1270" y="460" />]''',
'      ,q''[        <di:waypoint x="1340" y="460" />]''',
'      ,q''[        <di:waypoint x="1340" y="395" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1txhooo_di" bpmnElement="Flow_1txhooo">]''',
'      ,q''[        <di:waypoint x="1270" y="290" />]''',
'      ,q''[        <di:waypoint x="1340" y="290" />]''',
'      ,q''[        <di:waypoint x="1340" y="345" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11z8xs6_di" bpmnElement="Flow_11z8xs6">]''',
'      ,q''[        <di:waypoint x="1365" y="370" />]''',
'      ,q''[        <di:waypoint x="1420" y="370" />]''',
'      ,q''[        <di:waypoint x="1420" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0jg4oqm_di" bpmnElement="Association_0jg4oqm" bioc:stroke="#0d4372" color:border-color="#0d4372">]''',
'      ,q''[        <di:waypoint x="510" y="365" />]''',
'      ,q''[        <di:waypoint x="463" y="570" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1y1u9dd_di" bpmnElement="Association_1y1u9dd" bioc:stroke="#0d4372" color:border-color="#0d4372">]''',
'      ,q''[        <di:waypoint x="403" y="310" />]''',
'      ,q''[        <di:waypoint x="486" y="61" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0hx891w_di" bpmnElement="Association_0hx891w" bioc:stroke="#6b3c00" color:border-color="#6b3c00">]''',
'      ,q''[        <di:waypoint x="1470" y="460" />]''',
'      ,q''[        <di:waypoint x="1970" y="170" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0jgd1xj_di" bpmnElement="Association_0jgd1xj" bioc:stroke="#6b3c00" color:border-color="#6b3c00">]''',
'      ,q''[        <di:waypoint x="1400" y="600" />]''',
'      ,q''[        <di:waypoint x="1320" y="760" />]''',
'      ,q''[        <di:waypoint x="1770" y="760" />]''',
'      ,q''[        <di:waypoint x="1890" y="708" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_11qbgm5_di" bpmnElement="Association_11qbgm5" bioc:stroke="#5b176d" color:border-color="#5b176d">]''',
'      ,q''[        <di:waypoint x="945" y="310" />]''',
'      ,q''[        <di:waypoint x="1139" y="85" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 2a - Basic Navigation with Gateways'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial_2" name="Parallel Gateways Tutorial" isExecutable="true" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_1ekt5mq" name="Start AA2">]''',
'      ,q''[      <bpmn:outgoing>Flow_0ym2y4w</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1xxuo52" name="A">]''',
'      ,q''[      <bpmn:incoming>Flow_0ym2y4w</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_13o51hn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ym2y4w" sourceRef="Event_1ekt5mq" targetRef="Activity_1xxuo52" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_13o51hn" sourceRef="Activity_1xxuo52" targetRef="Gateway_0gacmud" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0gacmud" name="B Split">]''',
'      ,q''[      <bpmn:incoming>Flow_13o51hn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dxi1m8</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0b7spte</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0g77k3n</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_12vd6sc" name="B2">]''',
'      ,q''[      <bpmn:incoming>Flow_1dxi1m8</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_16zf3s8</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dxi1m8" sourceRef="Gateway_0gacmud" targetRef="Activity_12vd6sc" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_16zf3s8" sourceRef="Activity_12vd6sc" targetRef="Gateway_1khra03" />]''',
'      ,q''[    <bpmn:task id="Activity_0wuljzt" name="B3">]''',
'      ,q''[      <bpmn:incoming>Flow_0b7spte</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0krognm</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0b7spte" sourceRef="Gateway_0gacmud" targetRef="Activity_0wuljzt" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0krognm" sourceRef="Activity_0wuljzt" targetRef="Gateway_1khra03" />]''',
'      ,q''[    <bpmn:task id="Activity_06fpn0t" name="B1">]''',
'      ,q''[      <bpmn:incoming>Flow_0g77k3n</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_12s08fn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0g77k3n" sourceRef="Gateway_0gacmud" targetRef="Activity_06fpn0t" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12s08fn" sourceRef="Activity_06fpn0t" targetRef="Gateway_1khra03" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_1khra03" name="B Merge &#38; Synchronise">]''',
'      ,q''[      <bpmn:incoming>Flow_16zf3s8</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0krognm</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_12s08fn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1jfhl7d</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_1wamq8j" name="C">]''',
'      ,q''[      <bpmn:incoming>Flow_1jfhl7d</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1aygwgq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1jfhl7d" sourceRef="Gateway_1khra03" targetRef="Activity_1wamq8j" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1aygwgq" sourceRef="Activity_1wamq8j" targetRef="Gateway_1lw6nkv" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_1lw6nkv">]''',
'      ,q''[      <bpmn:incoming>Flow_1aygwgq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_014mvny</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1orbblw</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1k49en2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_014mvny" sourceRef="Gateway_1lw6nkv" targetRef="Gateway_0s1ulva" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1orbblw" sourceRef="Gateway_1lw6nkv" targetRef="Gateway_10ezijr" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0s1ulva">]''',
'      ,q''[      <bpmn:incoming>Flow_014mvny</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1703f6v</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1lqn8n2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_10ezijr">]''',
'      ,q''[      <bpmn:incoming>Flow_1orbblw</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ohb55f</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_144kbaj</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_19zuvwu</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_16nxamy" name="D1">]''',
'      ,q''[      <bpmn:incoming>Flow_1703f6v</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dipzc0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1703f6v" sourceRef="Gateway_0s1ulva" targetRef="Activity_16nxamy" />]''',
'      ,q''[    <bpmn:task id="Activity_14txpks" name="D2">]''',
'      ,q''[      <bpmn:incoming>Flow_1dipzc0</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1qmguin</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dipzc0" sourceRef="Activity_16nxamy" targetRef="Activity_14txpks" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1do1crj" name="D End">]''',
'      ,q''[      <bpmn:incoming>Flow_1qmguin</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1qmguin" sourceRef="Activity_14txpks" targetRef="Event_1do1crj" />]''',
'      ,q''[    <bpmn:task id="Activity_0yc7jyq" name="E1">]''',
'      ,q''[      <bpmn:incoming>Flow_1lqn8n2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_07xrd12</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1lqn8n2" sourceRef="Gateway_0s1ulva" targetRef="Activity_0yc7jyq" />]''',
'      ,q''[    <bpmn:task id="Activity_07chlsk" name="E2">]''',
'      ,q''[      <bpmn:incoming>Flow_07xrd12</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0jv2zfv</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07xrd12" sourceRef="Activity_0yc7jyq" targetRef="Activity_07chlsk" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0tj8iv7" name="E End">]''',
'      ,q''[      <bpmn:incoming>Flow_0jv2zfv</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0jv2zfv" sourceRef="Activity_07chlsk" targetRef="Event_0tj8iv7" />]''',
'      ,q''[    <bpmn:task id="Activity_0nuq9gg" name="F">]''',
'      ,q''[      <bpmn:incoming>Flow_1ohb55f</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0lud504</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ohb55f" sourceRef="Gateway_10ezijr" targetRef="Activity_0nuq9gg" />]''',
'      ,q''[    <bpmn:task id="Activity_0rko617" name="G">]''',
'      ,q''[      <bpmn:incoming>Flow_144kbaj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1c0m2ui</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_144kbaj" sourceRef="Gateway_10ezijr" targetRef="Activity_0rko617" />]''',
'      ,q''[    <bpmn:task id="Activity_04sg1f1" name="H">]''',
'      ,q''[      <bpmn:incoming>Flow_19zuvwu</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_135t0ky</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_19zuvwu" sourceRef="Gateway_10ezijr" targetRef="Activity_04sg1f1" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_0cco76x">]''',
'      ,q''[      <bpmn:incoming>Flow_1c0m2ui</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0lud504</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_135t0ky</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0r82kjo</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1c0m2ui" sourceRef="Activity_0rko617" targetRef="Gateway_0cco76x" />]''',
'      ,q''[    <bpmn:task id="Activity_0vesmoj" name="J">]''',
'      ,q''[      <bpmn:incoming>Flow_0r82kjo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0eg3kjl</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0r82kjo" sourceRef="Gateway_0cco76x" targetRef="Activity_0vesmoj" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0zsiv0z" name="J End">]''',
'      ,q''[      <bpmn:incoming>Flow_0eg3kjl</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0eg3kjl" sourceRef="Activity_0vesmoj" targetRef="Event_0zsiv0z" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0lud504" sourceRef="Activity_0nuq9gg" targetRef="Gateway_0cco76x" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_135t0ky" sourceRef="Activity_04sg1f1" targetRef="Gateway_0cco76x" />]''',
'      ,q''[    <bpmn:task id="Activity_1po2k4u" name="That&#39;s Enough&#10;about&#10;Parallel&#10;Gateways">]''',
'      ,q''[      <bpmn:incoming>Flow_1k49en2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1x47nfa</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1k49en2" sourceRef="Gateway_1lw6nkv" targetRef="Activity_1po2k4u" />]''',
'      ,q''[    <bpmn:endEvent id="Event_146ot6j" name="The Parallel End">]''',
'      ,q''[      <bpmn:incoming>Flow_1x47nfa</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1x47nfa" sourceRef="Activity_1po2k4u" targetRef="Event_146ot6j" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1elusm3">]''',
'      ,q''[      <bpmn:text>The first section here uses a PARALLEL GATEWAY.]''',
'      ,q''[]''',
'      ,q''[When you use a Parallel Gateway, ALL of the forward paths are taken - so tasks B1, B2, and B3 become the current task on their own subflows.]''',
'      ,q''[]''',
unistr('      ,q''[As ALL paths are taken, there are no default paths or process variables required to instruct the gateway. \00A0All paths are taken...]'''),
'      ,q''[]''',
unistr('      ,q''[At the end of our parallel section, we have another Parallel Gateway.\00A0 This acts as a merge and synchronize gateway to bring all of the sections together again.\00A0 Task C only becomes the current tasks when all 3 of B1, B2, and B3 have comple')
||'ted.]''',
'      ,q''[]''',
'      ,q''[Flows for APEX requires that Parallel Gateway areas are balanced if you want to merge / synchronize the paths before moving forwards. If you want to merge with a closing parallel gateway, all of the paths that start at B Split must go to B '
||'Merge.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_01fj9ha" sourceRef="Activity_1xxuo52" targetRef="TextAnnotation_1elusm3" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1g5plgd">]''',
'      ,q''[      <bpmn:text>I have 2 more concepts I want to demo us on here,so this just creates 2 separate paths.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0vub955" sourceRef="Gateway_1lw6nkv" targetRef="TextAnnotation_1g5plgd" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1rkv8we">]''',
'      ,q''[      <bpmn:text>While we said in the first section (ABC) that any Split &amp; re-merge had to be balanced, that doesn''t mean that you have to merge or re-synchronise a parallel section.]''',
'      ,q''[]''',
'      ,q''[]''',
'      ,q''[In this section, we use a Parallel Gateway to create Flow D and Flow E in Parallel. Both sections continue on to their own end Events.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_09fpsjg" sourceRef="Gateway_0s1ulva" targetRef="TextAnnotation_1rkv8we" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0d1c0wm">]''',
'      ,q''[      <bpmn:text>So What''s different here is that the Closing Gateway is NOT a Parallel Gateway -- we''ve used an Exclusive Gateway to Close the Parallel Section. The Exclusive Gateway does not cause the flows to wait until F G and H have al'
||'l completed.]''',
'      ,q''[]''',
'      ,q''[]''',
'      ,q''[How many times does J get executed?</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0flsrlo" sourceRef="Gateway_0cco76x" targetRef="TextAnnotation_0d1c0wm" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial_2">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1ekt5mq_di" bpmnElement="Event_1ekt5mq">]''',
'      ,q''[        <dc:Bounds x="252" y="482" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="246" y="525" width="48" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1xxuo52_di" bpmnElement="Activity_1xxuo52" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="340" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0nxjl3m_di" bpmnElement="Gateway_0gacmud" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="495" y="475" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="464" y="443" width="32" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_12vd6sc_di" bpmnElement="Activity_12vd6sc" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0w'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'uljzt_di" bpmnElement="Activity_0wuljzt" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06fpn0t_di" bpmnElement="Activity_06fpn0t" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0stnt0g_di" bpmnElement="Gateway_1khra03" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="755" y="475" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="799" y="456" width="61" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1wamq8j_di" bpmnElement="Activity_1wamq8j" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="920" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0novg93_di" bpmnElement="Gateway_1lw6nkv" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1075" y="475" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0srgw3z_di" bpmnElement="Gateway_0s1ulva" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1275" y="305" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1kn2ff9_di" bpmnElement="Gateway_10ezijr" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1245" y="775" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_16nxamy_di" bpmnElement="Activity_16nxamy" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1390" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_14txpks_di" bpmnElement="Activity_14txpks" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1550" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1do1crj_di" bpmnElement="Event_1do1crj" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1712" y="312" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1715" y="355" width="31" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0yc7jyq_di" bpmnElement="Activity_0yc7jyq" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1390" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_07chlsk_di" bpmnElement="Activity_07chlsk" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1560" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0tj8iv7_di" bpmnElement="Event_0tj8iv7" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1712" y="422" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1715" y="465" width="30" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0nuq9gg_di" bpmnElement="Activity_0nuq9gg" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1360" y="640" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0rko617_di" bpmnElement="Activity_0rko617" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1360" y="760" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_04sg1f1_di" bpmnElement="Activity_04sg1f1" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1360" y="870" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0cco76x_di" bpmnElement="Gateway_0cco76x" isMarkerVisible="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1535" y="775" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0vesmoj_di" bpmnElement="Activity_0vesmoj" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1680" y="760" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0zsiv0z_di" bpmnElement="Event_0zsiv0z" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1862" y="782" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1866" y="825" width="29" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1po2k4u_di" bpmnElement="Activity_1po2k4u" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1360" y="1000" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_146ot6j_di" bpmnElement="Event_146ot6j" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1762" y="1022" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1739" y="1065" width="82" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1elusm3_di" bpmnElement="TextAnnotation_1elusm3">]''',
'      ,q''[        <dc:Bounds x="440" y="100" width="580" height="230" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1g5plgd_di" bpmnElement="TextAnnotation_1g5plgd">]''',
'      ,q''[        <dc:Bounds x="1130" y="390" width="100" height="96" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1rkv8we_di" bpmnElement="TextAnnotation_1rkv8we">]''',
'      ,q''[        <dc:Bounds x="1330" y="100" width="407" height="130" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0d1c0wm_di" bpmnElement="TextAnnotation_0d1c0wm">]''',
'      ,q''[        <dc:Bounds x="1319" y="510" width="501" height="100" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ym2y4w_di" bpmnElement="Flow_0ym2y4w">]''',
'      ,q''[        <di:waypoint x="288" y="500" />]''',
'      ,q''[        <di:waypoint x="340" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13o51hn_di" bpmnElement="Flow_13o51hn">]''',
'      ,q''[        <di:waypoint x="440" y="500" />]''',
'      ,q''[        <di:waypoint x="495" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dxi1m8_di" bpmnElement="Flow_1dxi1m8">]''',
'      ,q''[        <di:waypoint x="545" y="500" />]''',
'      ,q''[        <di:waypoint x="600" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16zf3s8_di" bpmnElement="Flow_16zf3s8">]''',
'      ,q''[        <di:waypoint x="700" y="500" />]''',
'      ,q''[        <di:waypoint x="755" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0b7spte_di" bpmnElement="Flow_0b7spte">]''',
'      ,q''[        <di:waypoint x="520" y="525" />]''',
'      ,q''[        <di:waypoint x="520" y="610" />]''',
'      ,q''[        <di:waypoint x="600" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0krognm_di" bpmnElement="Flow_0krognm">]''',
'      ,q''[        <di:waypoint x="700" y="610" />]''',
'      ,q''[        <di:waypoint x="780" y="610" />]''',
'      ,q''[        <di:waypoint x="780" y="525" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0g77k3n_di" bpmnElement="Flow_0g77k3n">]''',
'      ,q''[        <di:waypoint x="520" y="475" />]''',
'      ,q''[        <di:waypoint x="520" y="380" />]''',
'      ,q''[        <di:waypoint x="600" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12s08fn_di" bpmnElement="Flow_12s08fn">]''',
'      ,q''[        <di:waypoint x="700" y="380" />]''',
'      ,q''[        <di:waypoint x="780" y="380" />]''',
'      ,q''[        <di:waypoint x="780" y="475" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1jfhl7d_di" bpmnElement="Flow_1jfhl7d">]''',
'      ,q''[        <di:waypoint x="805" y="500" />]''',
'      ,q''[        <di:waypoint x="920" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1aygwgq_di" bpmnElement="Flow_1aygwgq">]''',
'      ,q''[        <di:waypoint x="1020" y="500" />]''',
'      ,q''[        <di:waypoint x="1075" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_014mvny_di" bpmnElement="Flow_014mvny">]''',
'      ,q''[        <di:waypoint x="1100" y="475" />]''',
'      ,q''[        <di:waypoint x="1100" y="330" />]''',
'      ,q''[        <di:waypoint x="1275" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1orbblw_di" bpmnElement="Flow_1orbblw">]''',
'      ,q''[        <di:waypoint x="1100" y="525" />]''',
'      ,q''[        <di:waypoint x="1100" y="800" />]''',
'      ,q''[        <di:waypoint x="1245" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1703f6v_di" bpmnElement="Flow_1703f6v">]''',
'      ,q''[        <di:waypoint x="1325" y="330" />]''',
'      ,q''[        <di:waypoint x="1390" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dipzc0_di" bpmnElement="Flow_1dipzc0">]''',
'      ,q''[        <di:waypoint x="1490" y="330" />]''',
'      ,q''[        <di:waypoint x="1550" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qmguin_di" bpmnElement="Flow_1qmguin">]''',
'      ,q''[        <di:waypoint x="1650" y="330" />]''',
'      ,q''[        <di:waypoint x="1712" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1lqn8n2_di" bpmnElement="Flow_1lqn8n2">]''',
'      ,q''[        <di:waypoint x="1300" y="355" />]''',
'      ,q''[        <di:waypoint x="1300" y="440" />]''',
'      ,q''[        <di:waypoint x="1390" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07xrd12_di" bpmnElement="Flow_07xrd12">]''',
'      ,q''[        <di:waypoint x="1490" y="440" />]''',
'      ,q''[        <di:waypoint x="1560" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jv2zfv_di" bpmnElement="Flow_0jv2zfv">]''',
'      ,q''[        <di:waypoint x="1660" y="440" />]''',
'      ,q''[        <di:waypoint x="1712" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ohb55f_di" bpmnElement="Flow_1ohb55f">]''',
'      ,q''[        <di:waypoint x="1270" y="775" />]''',
'      ,q''[        <di:waypoint x="1270" y="680" />]''',
'      ,q''[        <di:waypoint x="1360" y="680" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_144kbaj_di" bpmnElement="Flow_144kbaj">]''',
'      ,q''[        <di:waypoint x="1295" y="800" />]''',
'      ,q''[        <di:waypoint x="1360" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_19zuvwu_di" bpmnElement="Flow_19zuvwu">]''',
'      ,q''[        <di:waypoint x="1270" y="825" />]''',
'      ,q''[        <di:waypoint x="1270" y="910" />]''',
'      ,q''[        <di:waypoint x="1360" y="910" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1c0m2ui_di" bpmnElement="Flow_1c0m2ui">]''',
'      ,q''[        <di:waypoint x="1460" y="800" />]''',
'      ,q''[        <di:waypoint x="1535" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0r82kjo_di" bpmnElement="Flow_0r82kjo">]''',
'      ,q''[        <di:waypoint x="1585" y="800" />]''',
'      ,q''[        <di:waypoint x="1680" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0eg3kjl_di" bpmnElement="Flow_0eg3kjl">]''',
'      ,q''[        <di:waypoint x="1780" y="800" />]''',
'      ,q''[        <di:waypoint x="1862" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0lud504_di" bpmnElement="Flow_0lud504">]''',
'      ,q''[        <di:waypoint x="1460" y="680" />]''',
'      ,q''[        <di:waypoint x="1560" y="680" />]''',
'      ,q''[        <di:waypoint x="1560" y="775" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_135t0ky_di" bpmnElement="Flow_135t0ky">]''',
'      ,q''[        <di:waypoint x="1460" y="910" />]''',
'      ,q''[        <di:waypoint x="1560" y="910" />]''',
'      ,q''[        <di:waypoint x="1560" y="825" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1k49en2_di" bpmnElement="Flow_1k49en2">]''',
'      ,q''[        <di:waypoint x="1100" y="525" />]''',
'      ,q''[        <di:waypoint x="1100" y="1040" />]''',
'      ,q''[        <di:waypoint x="1360" y="1040" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1x47nfa_di" bpmnElement="Flow_1x47nfa">]''',
'      ,q''[        <di:waypoint x="1460" y="1040" />]''',
'      ,q''[        <di:waypoint x="1762" y="1040" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_01fj9ha_di" bpmnElement="Association_01fj9ha">]''',
'      ,q''[        <di:waypoint x="403" y="460" />]''',
'      ,q''[        <di:waypoint x="445" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0vub955_di" bpmnElement="Association_0vub955">]''',
'      ,q''[        <di:waypoint x="1111" y="486" />]''',
'      ,q''[        <di:waypoint x="1130" y="464" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_09fpsjg_di" bpmnElement="Association_09fpsjg">]''',
'      ,q''[        <di:waypoint x="1307" y="312" />]''',
'      ,q''[        <di:waypoint x="1340" y="230" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0flsrlo_di" bpmnElement="Association_0flsrlo">]''',
'      ,q''[        <di:waypoint x="1569" y="784" />]''',
'      ,q''[        <di:waypoint x="1623" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 2b - Parallel Gateways'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns'
||':dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial_3" name="Inclusive Gateway Tutorial" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestRehg</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_1warv4h" name="Start Tutorial 3">]''',
'      ,q''[      <bpmn:outgoing>Flow_166n1nj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1ve7i3d" name="Inspect Your Gateway Variable">]''',
'      ,q''[      <bpmn:incoming>Flow_0mzxaxx</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1qhovsw</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_166n1nj" sourceRef="Event_1warv4h" targetRef="Activity_Concept1" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1qhovsw" sourceRef="Activity_1ve7i3d" targetRef="Gateway_Inclusive_Opening" />]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_Inclusive_Opening" name="Opening Inclusive Gateway" default="Flow_C">]''',
'      ,q''[      <bpmn:incoming>Flow_1qhovsw</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_A</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_B</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_C</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_0buy3jb" name="A">]''',
'      ,q''[      <bpmn:incoming>Flow_A</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0raoa8o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_A" name="Flow A" sourceRef="Gateway_Inclusive_Opening" targetRef="Activity_0buy3jb" apex:sequence="30" />]''',
'      ,q''[    <bpmn:task id="Activity_1iqxrc6" name="B">]''',
'      ,q''[      <bpmn:incoming>Flow_B</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0dmljno</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_B" name="Flow B" sourceRef="Gateway_Inclusive_Opening" targetRef="Activity_1iqxrc6" apex:sequence="40" />]''',
'      ,q''[    <bpmn:task id="Activity_1ajwcwr" name="C">]''',
'      ,q''[      <bpmn:incoming>Flow_C</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1hljb3z</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_C" name="Flow C" sourceRef="Gateway_Inclusive_Opening" targetRef="Activity_1ajwcwr" apex:sequence="50" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0dmljno" sourceRef="Activity_1iqxrc6" targetRef="Gateway_0008jgf" />]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_0008jgf" name="Merge and Resync">]''',
'      ,q''[      <bpmn:incoming>Flow_0dmljno</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0raoa8o</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1hljb3z</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0jbvoj2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0raoa8o" sourceRef="Activity_0buy3jb" targetRef="Gateway_0008jgf" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1hljb3z" sourceRef="Activity_1ajwcwr" targetRef="Gateway_0008jgf" />]''',
'      ,q''[    <bpmn:task id="Activity_0gtcq94" name="D">]''',
'      ,q''[      <bpmn:incoming>Flow_0jbvoj2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1kt6sw3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0jbvoj2" sourceRef="Gateway_0008jgf" targetRef="Activity_0gtcq94" apex:sequence="10" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0n1anww" name="End Tutorial 3">]''',
'      ,q''[      <bpmn:incoming>Flow_1kt6sw3</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1kt6sw3" sourceRef="Activity_0gtcq94" targetRef="Event_0n1anww" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mzxaxx" sourceRef="Activity_0buimbx" targetRef="Activity_1ve7i3d" />]''',
'      ,q''[    <bpmn:scriptTask id="Activity_0buimbx" name="ScriptTask to Set Gateway Variable" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>flow_process_vars.set_var ]''',
'      ,q''[    ( pi_prcs_id =&gt; flow_plsql_runner_pkg.get_current_prcs_id]''',
'      ,q''[    , pi_var_name =&gt; ''Gateway_Inclusive_Opening:route'']''',
'      ,q''[    , pi_vc2_value =&gt; ''Flow_A:Flow_C'');</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_080bqby</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mzxaxx</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:task id="Activity_Concept1" name="Concept 1:&#10;Gateway Routing Expressions">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>FoodOrdered</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>PIZZA:CHIPS</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_166n1nj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_153ygxs</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_153ygxs" sourceRef="Activity_Concept1" targetRef="Gateway_1gp1fyn" />]''',
'      ,q''[    <bpmn:task id="Activity_1yp3qv8" name="Concept 2:&#10;Gateway Routing Variables">]''',
'      ,q''[      <bpmn:incoming>Flow_0ph2k43</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_080bqby</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_080bqby" sourceRef="Activity_1yp3qv8" targetRef="Activity_0buimbx" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_BERGER" name="FoodOrdered contains &#39;BURGER&#39;" sourceRef="Gateway_1gp1fyn" targetRef="Activity_1m4w5ac" apex:sequence="20">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression" sequence="0">:F4A$FoodOrdered like ''%BURGER%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ph2k43" sourceRef="Gateway_1d5oe5w" targetRef="Activity_1yp3qv8" apex:sequence="10" />]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_1gp1fyn">]''',
'      ,q''[      <bpmn:incoming>Flow_153ygxs</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_BERGER</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_PIZZA</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_CHIPS</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_1d5oe5w">]''',
'      ,q''[      <bpmn:incoming>Flow_1h80wgk</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1cr6b75</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0i4a0v0</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ph2k43</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_1m4w5ac" name="Make Burger">]''',
'      ,q''[      <bpmn:incoming>Flow_BERGER</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1h80wgk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1h80wgk" sourceRef="Activity_1m4w5ac" targetRef="Gateway_1d5oe5w" />]''',
'      ,q''[    <bpmn:task id="Activity_1ef33ii" name="Make Pizza">]''',
'      ,q''[      <bpmn:incoming>Flow_PIZZA</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1cr6b75</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_PIZZA" name="FoodOrdered contains PIZZA" sourceRef="Gateway_1gp1fyn" targetRef="Activity_1ef33ii" apex:sequence="10">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression" sequence="">:F4A$FoodOrdered like ''%PIZZA%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:task id="Activity_1bt8ouh" name="Make Chips">]''',
'      ,q''[      <bpmn:incoming>Flow_CHIPS</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0i4a0v0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_CHIPS" name="FoodOrdered contains &#39;CHIPS&#39;" sourceRef="Gateway_1gp1fyn" targetRef="Activity_1bt8ouh" apex:sequence="30">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$FoodOrdered like ''%CHIPS%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1cr6b75" sourceRef="Activity_1ef33ii" targetRef="Gateway_1d5oe5w" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0i4a0v0" sourceRef="Activity_1bt8ouh" targetRef="Gateway_1d5oe5w" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1w4hasz">]''',
'      ,q''[      <bpmn:text>Method 2: Setting a Gateway Routing Variable (the old way)...]''',
'      ,q''[]''',
'      ,q''[You can choose 1 or more (or all) of the possible routes.]''',
'      ,q''[]''',
'      ,q''[Routing is supplied to the gateway in a Process Variable named &lt;gateway id&gt;&lt;:route&gt;.]''',
'      ,q''[]''',
'      ,q''[Routes selected are listed in the variable, colon separated]''',
'      ,q''[]''',
unistr('      ,q''[In our Example, the Gateway ID is ''Gateway_Inclusive_Opening'', routes have IDs ''Flow_A'', ''Flow_B'', and ''Flow_C''.\00A0 So to choose A and C only, in the scriptTask we set the variable]'''),
'      ,q''[]''',
'      ,q''[''Gateway_Inclusive_Opening:route'' with varchar2 value ''Flow_A:Flow_C''.]''',
'      ,q''[]''',
unistr('      ,q''[In this example, we ran a scriptTask as the first task in the flow which set this variable for you.\00A0 If you look at the variables tab above, you can see the variable and it''s value.\00A0]'''),
'      ,q''[]''',
'      ,q''[Step forward &amp; see routes A &amp; C become the current task.]''',
'      ,q''[]''',
'      ,q''[You can restart the model, and manually change the routing variable if you want.]''',
'      ,q''[]''',
unistr('      ,q''[This is a tutorial, and we''ve set the variable using a simple script.\00A0 Obviously in your app, your pl/sql script could look at process variables, or could run a query in the database, or perform some other calculation or logic to determine ')
||unistr('and then set the routing that makes sense in your application.\00A0 These can be set in a scriptTask (as here) or using declarative variable expressions, which we will explore later....]'''),
'      ,q''[]''',
unistr('      ,q''[Note that an Inclusive Gateway also can have a default path - on Flow C in our example. \00A0Flows for APEX will first look for a process variable with the correct name; if that doesn''t exist, it will look for default routing; and it that doesn')
||'''t exist, it will show an error.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0k4787z" sourceRef="Activity_1ve7i3d" targetRef="TextAnnotation_1w4hasz" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0v50lx0">]''',
'      ,q''[      <bpmn:text>This scriptTask sets the process variable for the Gateway.]''',
'      ,q''[]''',
'      ,q''[]''',
unistr('      ,q''[We''ve used a scriptTask that runs a simple PL/SQL procedure that sets the routing to ''Flow_A:Flow_C''.\00A0]'''),
'      ,q''[]''',
'      ,q''[In the Properties Panel on the right side of the Flow Modeler, select the ScriptTask and select the APEX tab to see how we get the process id and then set the process variable.]''',
'      ,q''[]''',
'      ,q''[Your application could include a PL/SQL procedure that performs a query in the database &amp; which determines the route through your process. That makes this very powerful!</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0oa2eg1" sourceRef="Activity_0buimbx" targetRef="TextAnnotation_0v50lx0" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0jyiofy">]''',
'      ,q''[      <bpmn:text>Tutorial 2c - Inclusive Gateways]''',
'      ,q''[]''',
unistr('      ,q''[An inclusive Gateway is a cross between a Parallel Gateway (All paths operate in parallel) and an Exclusive Gateway (where only one forward path is chosen). \00A0An Inclusive Gateway chooses multiple forward paths that can operate in parallel.]')
||'''',
'      ,q''[]''',
'      ,q''[Like the Exclusive Gateway, the Inclusive Gateway can be controlled by:]''',
unistr('      ,q''[\00A0- Gateway Routing Expressions - giving the conditions under which a forward path should be taken]'''),
unistr('      ,q''[\00A0- Gateway Rout')))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ing Variables - giving the path names of all paths to be taken,\00A0]'''),
unistr('      ,q''[\00A0- Default Path, specifying the path that should be taken if no others are selected.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1fdyic0" sourceRef="Event_1warv4h" targetRef="TextAnnotation_0jyiofy" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1jcq7cx">]''',
unistr('      ,q''[      <bpmn:text>Method 1: Gateway Routing Expressions, \00A0New in v22.2]'''),
'      ,q''[]''',
unistr('      ,q''[Each forward path contains a condition for that path to be taken. \00A0If the condition evaluates to TRUE, the path is taken.]'''),
'      ,q''[]''',
'      ,q''[Conditions can be specified as either:]''',
'      ,q''[- PL/SQL Expressions, evaluating to a boolean (true/false) result.]''',
'      ,q''[- PL/SQL Function Body, returning a boolean (true/false) result.]''',
'      ,q''[]''',
'      ,q''[Conditions are evaluated in sequence order - so take care if your conditions are overlapping (not good practice).]''',
'      ,q''[]''',
'      ,q''[Conditions can use an expression or a function body to compare a process variable, perform a database query, or some other complex processing.]''',
'      ,q''[]''',
unistr('      ,q''[In our example, we''ve set a variable to ''PIZZA:CHIPS'' using a static assignment (you could use the SQL Query returning multiple values to do this in a real system). \00A0 Then written conditions on the forward paths to test if these values are ')
||'present.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0hjn351" sourceRef="Activity_Concept1" targetRef="TextAnnotation_1jcq7cx" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial_3">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1warv4h_di" bpmnElement="Event_1warv4h">]''',
'      ,q''[        <dc:Bounds x="412" y="482" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="395" y="525" width="70" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ve7i3d_di" bpmnElement="Activity_1ve7i3d" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1690" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_19m857j_di" bpmnElement="Gateway_Inclusive_Opening" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1845" y="475" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1766" y="416" width="90" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0buy3jb_di" bpmnElement="Activity_0buy3jb" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1950" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1iqxrc6_di" bpmnElement="Activity_1iqxrc6" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1950" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ajwcwr_di" bpmnElement="Activity_1ajwcwr" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1950" y="590" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_03knf6b_di" bpmnElement="Gateway_0008jgf" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="2105" y="475" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2153" y="426" width="53" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0gtcq94_di" bpmnElement="Activity_0gtcq94">]''',
'      ,q''[        <dc:Bounds x="2210" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0n1anww_di" bpmnElement="Event_0n1anww">]''',
'      ,q''[        <dc:Bounds x="2372" y="482" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2358" y="525" width="66" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0l6cpk6_di" bpmnElement="Activity_0buimbx" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1550" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06rbtnv_di" bpmnElement="Activity_Concept1" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="520" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1yp3qv8_di" bpmnElement="Activity_1yp3qv8" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1420" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0hqskic_di" bpmnElement="Gateway_1gp1fyn" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="685" y="475" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1ahm5ft_di" bpmnElement="Gateway_1d5oe5w" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1245" y="475" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1m4w5ac_di" bpmnElement="Activity_1m4w5ac" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="930" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ef33ii_di" bpmnElement="Activity_1ef33ii" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="930" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1bt8ouh_di" bpmnElement="Activity_1bt8ouh" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="930" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1w4hasz_di" bpmnElement="TextAnnotation_1w4hasz">]''',
'      ,q''[        <dc:Bounds x="1650" y="-35" width="1079.9998779296875" height="354.9999694824219" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0v50lx0_di" bpmnElement="TextAnnotation_0v50lx0">]''',
'      ,q''[        <dc:Bounds x="1660" y="710" width="510" height="164" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0jyiofy_di" bpmnElement="TextAnnotation_0jyiofy">]''',
'      ,q''[        <dc:Bounds x="460" y="-90" width="729.9985939257593" height="137.98861079865017" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1jcq7cx_di" bpmnElement="TextAnnotation_1jcq7cx">]''',
'      ,q''[        <dc:Bounds x="635" y="80" width="689.9815673828125" height="222.97792053222656" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_166n1nj_di" bpmnElement="Flow_166n1nj">]''',
'      ,q''[        <di:waypoint x="448" y="500" />]''',
'      ,q''[        <di:waypoint x="520" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qhovsw_di" bpmnElement="Flow_1qhovsw">]''',
'      ,q''[        <di:waypoint x="1790" y="500" />]''',
'      ,q''[        <di:waypoint x="1845" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0raiyk0_di" bpmnElement="Flow_A">]''',
'      ,q''[        <di:waypoint x="1870" y="475" />]''',
'      ,q''[        <di:waypoint x="1870" y="370" />]''',
'      ,q''[        <di:waypoint x="1950" y="370" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1884" y="343" width="33" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1jj2iet_di" bpmnElement="Flow_B">]''',
'      ,q''[        <di:waypoint x="1895" y="500" />]''',
'      ,q''[        <di:waypoint x="1950" y="500" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1907" y="482" width="33" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1w4x95t_di" bpmnElement="Flow_C">]''',
'      ,q''[        <di:waypoint x="1870" y="525" />]''',
'      ,q''[        <di:waypoint x="1870" y="630" />]''',
'      ,q''[        <di:waypoint x="1950" y="630" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1893" y="593" width="33" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0dmljno_di" bpmnElement="Flow_0dmljno">]''',
'      ,q''[        <di:waypoint x="2050" y="500" />]''',
'      ,q''[        <di:waypoint x="2105" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0raoa8o_di" bpmnElement="Flow_0raoa8o">]''',
'      ,q''[        <di:waypoint x="2050" y="370" />]''',
'      ,q''[        <di:waypoint x="2130" y="370" />]''',
'      ,q''[        <di:waypoint x="2130" y="475" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1hljb3z_di" bpmnElement="Flow_1hljb3z">]''',
'      ,q''[        <di:waypoint x="2050" y="630" />]''',
'      ,q''[        <di:waypoint x="2130" y="630" />]''',
'      ,q''[        <di:waypoint x="2130" y="525" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jbvoj2_di" bpmnElement="Flow_0jbvoj2">]''',
'      ,q''[        <di:waypoint x="2155" y="500" />]''',
'      ,q''[        <di:waypoint x="2210" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1kt6sw3_di" bpmnElement="Flow_1kt6sw3">]''',
'      ,q''[        <di:waypoint x="2310" y="500" />]''',
'      ,q''[        <di:waypoint x="2372" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0mzxaxx_di" bpmnElement="Flow_0mzxaxx">]''',
'      ,q''[        <di:waypoint x="1650" y="500" />]''',
'      ,q''[        <di:waypoint x="1690" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_153ygxs_di" bpmnElement="Flow_153ygxs">]''',
'      ,q''[        <di:waypoint x="620" y="500" />]''',
'      ,q''[        <di:waypoint x="685" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_080bqby_di" bpmnElement="Flow_080bqby">]''',
'      ,q''[        <di:waypoint x="1520" y="500" />]''',
'      ,q''[        <di:waypoint x="1550" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07014fh_di" bpmnElement="Flow_BERGER">]''',
'      ,q''[        <di:waypoint x="735" y="500" />]''',
'      ,q''[        <di:waypoint x="930" y="500" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="806" y="450" width="63" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ph2k43_di" bpmnElement="Flow_0ph2k43">]''',
'      ,q''[        <di:waypoint x="1295" y="500" />]''',
'      ,q''[        <di:waypoint x="1420" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1h80wgk_di" bpmnElement="Flow_1h80wgk">]''',
'      ,q''[        <di:waypoint x="1030" y="500" />]''',
'      ,q''[        <di:waypoint x="1245" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0u2pbth_di" bpmnElement="Flow_PIZZA">]''',
'      ,q''[        <di:waypoint x="710" y="475" />]''',
'      ,q''[        <di:waypoint x="710" y="370" />]''',
'      ,q''[        <di:waypoint x="930" y="370" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="802" y="326" width="73" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_09h9bb8_di" bpmnElement="Flow_CHIPS">]''',
'      ,q''[        <di:waypoint x="710" y="525" />]''',
'      ,q''[        <di:waypoint x="710" y="610" />]''',
'      ,q''[        <di:waypoint x="930" y="610" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="790" y="565" width="79" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1cr6b75_di" bpmnElement="Flow_1cr6b75">]''',
'      ,q''[        <di:waypoint x="1030" y="370" />]''',
'      ,q''[        <di:waypoint x="1270" y="370" />]''',
'      ,q''[        <di:waypoint x="1270" y="475" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0i4a0v0_di" bpmnElement="Flow_0i4a0v0">]''',
'      ,q''[        <di:waypoint x="1030" y="610" />]''',
'      ,q''[        <di:waypoint x="1270" y="610" />]''',
'      ,q''[        <di:waypoint x="1270" y="525" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0k4787z_di" bpmnElement="Association_0k4787z">]''',
'      ,q''[        <di:waypoint x="1714" y="460" />]''',
'      ,q''[        <di:waypoint x="1470" y="90" />]''',
'      ,q''[        <di:waypoint x="1650" y="90" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0oa2eg1_di" bpmnElement="Association_0oa2eg1">]''',
'      ,q''[        <di:waypoint x="1624" y="540" />]''',
'      ,q''[        <di:waypoint x="1727" y="710" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1fdyic0_di" bpmnElement="Association_1fdyic0">]''',
'      ,q''[        <di:waypoint x="432" y="482" />]''',
'      ,q''[        <di:waypoint x="493" y="48" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0hjn351_di" bpmnElement="Association_0hjn351">]''',
'      ,q''[        <di:waypoint x="577" y="460" />]''',
'      ,q''[        <di:waypoint x="635" y="120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 2c - Inclusive Gateways'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial_2D" name="Tutorial 2D Simple Timers" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_1li3yuj" name="start 2d Timers">]''',
'      ,q''[      <bpmn:outgoing>Flow_00rz550</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_16kndlc" name="Concept 1&#10;Adding a Timer">]''',
'      ,q''[      <bpmn:incoming>Flow_00rz550</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ntun9k</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_00rz550" sourceRef="Event_1li3yuj" targetRef="Activity_16kndlc" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ntun9k" sourceRef="Activity_16kndlc" targetRef="Event_0s12ekd" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_0s12ekd">]''',
'      ,q''[      <bpmn:incoming>Flow_1ntun9k</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_08iv23e</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0cngawg">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT10S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1hz3cyg" name="Concept 2:&#10;Specifying a Timer">]''',
'      ,q''[      <bpmn:incoming>Flow_08iv23e</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0qppozd</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08iv23e" sourceRef="Event_0s12ekd" targetRef="Activity_1hz3cyg" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0qppozd" sourceRef="Activity_1hz3cyg" targetRef="Gateway_0vx9hk2" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0vx9hk2">]''',
'      ,q''[      <bpmn:incoming>Flow_0qppozd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_04zw2uj</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0sdhfsr</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_12q3n8x</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0d6n996</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_1dpg3fy" name="Wait for a Fixed Duration (Oracle Method)">]''',
'      ,q''[      <bpmn:incoming>Flow_04zw2uj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1otethy</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_04zw2uj" sourceRef="Gateway_0vx9hk2" targetRef="Activity_1dpg3fy" />]''',
'      ,q''[    <bpmn:task id="Activity_17qqrdj" name="Wait for a fixed Duration (ISO 8601 Style)">]''',
'      ,q''[      <bpmn:incoming>Flow_0sdhfsr</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wjbipz</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0sdhfsr" sourceRef="Gateway_0vx9hk2" targetRef="Activity_17qqrdj" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1otethy" sourceRef="Activity_1dpg3fy" targetRef="Event_Ora_Duration" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wjbipz" sourceRef="Activity_17qqrdj" targetRef="Event_ISO_Duration" />]''',
'      ,q''[    <bpmn:task id="Activity_0xk8wss" name="Wait until a Fixed Time (Oracle Method)">]''',
'      ,q''[      <bpmn:incoming>Flow_12q3n8x</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_187vjjj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12q3n8x" sourceRef="Gateway_0vx9hk2" targetRef="Activity_0xk8wss" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_187vjjj" sourceRef="Activity_0xk8wss" targetRef="Event_Oracle_Time" />]''',
'      ,q''[    <bpmn:task id="Activity_0g0gn3b" name="Wait for a Fixed Time (ISO 8601 Method">]''',
'      ,q''[      <bpmn:incoming>Flow_0d6n996</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0exp2j4</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0d6n996" sourceRef="Gateway_0vx9hk2" targetRef="Activity_0g0gn3b" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0exp2j4" sourceRef="Activity_0g0gn3b" targetRef="Event_ISO_Date" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_Ora_Duration" name="Oracle Duration">]''',
'      ,q''[      <bpmn:documentation>15 Seconds delay.]''',
'      ,q''[]''',
'      ,q''[The formatting here is important....]''',
'      ,q''[</bpmn:documentation>]''',
'      ,q''[      <bpmn:incoming>Flow_1otethy</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_054vnaw</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_1fs1p10" apex:timerType="oracleDuration">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:oracleDuration>]''',
'      ,q''[            <apex:intervalYM>00-00</apex:intervalYM>]''',
'      ,q''[            <apex:intervalDS>000 00:00:15</apex:intervalDS>]''',
'      ,q''[          </apex:oracleDuration>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:endEvent id="Event_0sqqq5d">]''',
'      ,q''[      <bpmn:incoming>Flow_054vnaw</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_054vnaw" sourceRef="Event_Ora_Duration" targetRef="Event_0sqqq5d" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_ISO_Duration" name="ISO Duration">]''',
'      ,q''[      <bpmn:documentation>ISO 8601 Duration.]''',
'      ,q''[]''',
'      ,q''[Durations start with P (for period).]''',
'      ,q''[]''',
'      ,q''[Then you could add 2M3W4D for 2 Months, 3 Weeks and 4 Days.]''',
'      ,q''[]''',
'      ,q''[Then comes a T for Time]''',
'      ,q''[Then something like 2H20M15S]''',
'      ,q''[- for 2 Hours, 20 Minutes and 15 seconds.]''',
'      ,q''[]''',
'      ,q''[]''',
'      ,q''[</bpmn:documentation>]''',
'      ,q''[      <bpmn:incoming>Flow_0wjbipz</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0fhxihw</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_1epki1c">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT20S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:endEvent id="Event_0kwb0k6">]''',
'      ,q''[      <bpmn:incoming>Flow_0fhxihw</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0fhxihw" sourceRef="Event_ISO_Duration" targetRef="Event_0kwb0k6" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_Oracle_Time" name="Oracle Time">]''',
'      ,q''[      <bpmn:documentation>You can specify an Oracle Date (optionally including a time) along with the format mask used for that date.]''',
'      ,q''[]''',
'      ,q''[In practicing, hard coding a fixed Date into your model is not often very useful.]''',
'      ,q''[]''',
'      ,q''[If you specify Just a Time (no date), the timer will go off next time that timer occurs (later today, or tomorrow if the time has already passed today).]''',
'      ,q''[]''',
'      ,q''[Or you can use substitution of a process variable --- more on that later in the tutorials....]''',
'      ,q''[]''',
'      ,q''[]''',
'      ,q''[]''',
'      ,q''[]''',
'      ,q''[</bpmn:documentation>]''',
'      ,q''[      <bpmn:incoming>Flow_187vjjj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1xtmf5p</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_04zedwp" apex:timerType="oracleDate">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:oracleDate>]''',
'      ,q''[            <apex:date>24-JUN-2023 09:15:00</apex:date>]''',
'      ,q''[            <apex:formatMask>DD-MON-YYYY HH24:MI:SS</apex:formatMask>]''',
'      ,q''[          </apex:oracleDate>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:endEvent id="Event_1p9psxw">]''',
'      ,q''[      <bpmn:incoming>Flow_1xtmf5p</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1xtmf5p" sourceRef="Event_Oracle_Time" targetRef="Event_1p9psxw" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_ISO_Date" name="ISO Date">]''',
'      ,q''[      <bpmn:documentation>This uses an ISO 8601 date Time String to specify a fixed future time.]''',
'      ,q''[]''',
'      ,q''[See documentation for ISO 8601 Time specs - or Google ''ISO 8601''.]''',
'      ,q''[</bpmn:documentation>]''',
'      ,q''[      <bpmn:incoming>Flow_0exp2j4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_083i9d5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0kqfp2i">]''',
'      ,q''[        <bpmn:timeDate xsi:type="bpmn:tFormalExpression">20250901T13:30:20</bpmn:timeDate>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:endEvent id="Event_0dozg9s">]''',
'      ,q''[      <bpmn:incoming>Flow_083i9d5</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_083i9d5" sourceRef="Event_ISO_Date" targetRef="Event_0dozg9s" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0b87nxd">]''',
'      ,q''[      <bpmn:text>If you want to make your process wait for some period of time before it continues, you can add a Timer.]''',
'      ,q''[]''',
'      ,q''[To add a Timer, start by adding an Intermediate Event (the double circle), then change it with the Spanner Tool to an Intermediate Timer Catch Event.]''',
'      ,q''[]''',
'      ,q''[A timer delay / pause can be specified as either:]''',
unistr('      ,q''[\00A0- a DURATION -- how long you want to pause the process \00A0(e.g., wait for 2 Hours),or\00A0]'''),
unistr('      ,q''[\00A0- a TIME that the process flow should wait before restarting \00A0(e.g., wait until 31-DEC-2025 23:59:59 ).]'''),
'      ,q''[]''',
unistr('      ,q''[This First Timer is set for 10 seconds. \00A0Move onto the timer event. \00A0 \00A0After a few seconds, select the Refresh option on the Actions menu to refresh the screen. \00A0 The timer actually checks to see which processes should proceed every 10 seco')
||unistr('nds* -- so you might need to wait unto an additional 10 seconds for the timer to fire. \00A0 If it still hasn''t fired after 30* seconds, timers might not be enabled currently on your system - ask to your system administrator or read the documentation on ')
||'setting up theScheduler...]''',
'      ,q''[]''',
unistr('      ,q''[* The interval at which timers are checked would typically be 10 seconds on a production system - but you can see how your system is set up if you Click on Configuration - Timers. \00A0On public demo systems like apex.oracle.com (and apex.oracl')
||'ecorp.com) you will have to wait a bit longer - the timer checking interval is every minute.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_07h0he2" sourceRef="Activity_16kndlc" targetRef="TextAnnotation_0b87nxd" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0pb1xw1">]''',
'      ,q''[      <bpmn:text>This is set up using IS0 8601 format for a 10 Second delay</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1ex81lj" sourceRef="Event_0s12ekd" targetRef="TextAnnotation_0pb1xw1" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0uwfxws">]''',
'      ,q''[      <bpmn:text>15 Seconds delay.]''',
'      ,q''[]''',
'      ,q''[The formatting here is important....</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_09dzds0" sourceRef="Event_Ora_Duration" targetRef="TextAnnotation_0uwfxws" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1defw8d">]''',
'      ,q''[      <bpmn:text>ISO 8601 Duration.]''',
'      ,q''[]''',
'      ,q''[Durations start with P (for period).]''',
'      ,q''[]''',
'      ,q''[Then you could add 2M3W4D for 2 Months, 3 Weeks and 4 Days.]''',
'      ,q''[]''',
'      ,q''[Then comes a T for Time]''',
'      ,q''[Then something like 2H20M15S]''',
'      ,q''[- for 2 Hours, 20 Minutes and 15 seconds.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1q8z07t" sourceRef="Event_ISO_Duration" targetRef="TextAnnotation_1defw8d" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_15qukwy">]''',
'      ,q''[      <bpmn:text>You can specify an Oracle Date (optionally including a time) along with the format mask used for that date.]''',
'      ,q''[]''',
'      ,q''[In practicing, hard coding a fixed Date into your model is not often very useful.]''',
'      ,q''[]''',
'      ,q''[If you specify Just a Time (no date), the timer will go off next time that timer occurs (later today, or tomorrow if the time has already passed today).]''',
'      ,q''[]''',
'      ,q''[Or you can use substitution of a process variable --- more on that later in the tutorials....</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0073qme" sourceRef="Event_Oracle_Time" targetRef="TextAnnotation_15qukwy" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1grdtja">]''',
'      ,q''[      <bpmn:text>This uses an ISO 8601 date Time String to specify a fixed future time.]''',
'      ,q''[]''',
'      ,q''[See documentation for ISO 8601 Time specs - or Google ''ISO 8601''.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0xnxta8" sourceRef="Event_ISO_Date" targetRef="TextAnnotation_1grdtja" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0jw7law">]''',
'      ,q''[      <bpmn:text>We''ll cover m'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ore advanced uses of timers in later sections, including Tutorial 4d on Timer Boundary Events.]''',
'      ,q''[]''',
'      ,q''[You can also add a Timer to a process Start Event if you want to delay it''s start.]''',
'      ,q''[]''',
'      ,q''[We''ll also look at how to make a process wait for a message from another process or from an outside program in Message Flow...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1c34puf" sourceRef="Event_0dozg9s" targetRef="TextAnnotation_0jw7law" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial_2D">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1li3yuj_di" bpmnElement="Event_1li3yuj">]''',
'      ,q''[        <dc:Bounds x="252" y="432" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="235" y="475" width="71" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_16kndlc_di" bpmnElement="Activity_16kndlc" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="340" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1lu07kr_di" bpmnElement="Event_0s12ekd" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="492" y="432" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1hz3cyg_di" bpmnElement="Activity_1hz3cyg">]''',
'      ,q''[        <dc:Bounds x="580" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0l4626v_di" bpmnElement="Gateway_0vx9hk2">]''',
'      ,q''[        <dc:Bounds x="735" y="425" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1dpg3fy_di" bpmnElement="Activity_1dpg3fy" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="840" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_17qqrdj_di" bpmnElement="Activity_17qqrdj" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="840" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0xk8wss_di" bpmnElement="Activity_0xk8wss" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="840" y="630" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0g0gn3b_di" bpmnElement="Activity_0g0gn3b" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="840" y="740" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1x38y3l_di" bpmnElement="Event_Ora_Duration" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1002" y="432" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="983" y="475" width="78" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0sqqq5d_di" bpmnElement="Event_0sqqq5d" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1102" y="432" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0e46wtj_di" bpmnElement="Event_ISO_Duration" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1002" y="542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="989" y="585" width="64" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0kwb0k6_di" bpmnElement="Event_0kwb0k6" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1102" y="542" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_01l560j_di" bpmnElement="Event_Oracle_Time" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1002" y="652" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="991" y="695" width="60" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1p9psxw_di" bpmnElement="Event_1p9psxw" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1102" y="652" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_124r45a_di" bpmnElement="Event_ISO_Date" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1002" y="762" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="998" y="805" width="46" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0dozg9s_di" bpmnElement="Event_0dozg9s" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1102" y="762" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_07h0he2_di" bpmnElement="Association_07h0he2">]''',
'      ,q''[        <di:waypoint x="387" y="410" />]''',
'      ,q''[        <di:waypoint x="379" y="320" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0pb1xw1_di" bpmnElement="TextAnnotation_0pb1xw1">]''',
'      ,q''[        <dc:Bounds x="520" y="330" width="99.99999237060547" height="67.99632263183594" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0uwfxws_di" bpmnElement="TextAnnotation_0uwfxws">]''',
'      ,q''[        <dc:Bounds x="1190" y="270" width="320" height="60" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1defw8d_di" bpmnElement="TextAnnotation_1defw8d">]''',
'      ,q''[        <dc:Bounds x="1190" y="380" width="486.9852600097656" height="139.9816131591797" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_15qukwy_di" bpmnElement="TextAnnotation_15qukwy">]''',
'      ,q''[        <dc:Bounds x="1190" y="540" width="450" height="150" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1grdtja_di" bpmnElement="TextAnnotation_1grdtja">]''',
'      ,q''[        <dc:Bounds x="1190" y="710" width="440" height="60" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0jw7law_di" bpmnElement="TextAnnotation_0jw7law">]''',
'      ,q''[        <dc:Bounds x="1190" y="830" width="370" height="124" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_00rz550_di" bpmnElement="Flow_00rz550">]''',
'      ,q''[        <di:waypoint x="288" y="450" />]''',
'      ,q''[        <di:waypoint x="340" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ntun9k_di" bpmnElement="Flow_1ntun9k">]''',
'      ,q''[        <di:waypoint x="440" y="450" />]''',
'      ,q''[        <di:waypoint x="492" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08iv23e_di" bpmnElement="Flow_08iv23e">]''',
'      ,q''[        <di:waypoint x="528" y="450" />]''',
'      ,q''[        <di:waypoint x="580" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0qppozd_di" bpmnElement="Flow_0qppozd">]''',
'      ,q''[        <di:waypoint x="680" y="450" />]''',
'      ,q''[        <di:waypoint x="735" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_04zw2uj_di" bpmnElement="Flow_04zw2uj">]''',
'      ,q''[        <di:waypoint x="785" y="450" />]''',
'      ,q''[        <di:waypoint x="840" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0sdhfsr_di" bpmnElement="Flow_0sdhfsr">]''',
'      ,q''[        <di:waypoint x="760" y="475" />]''',
'      ,q''[        <di:waypoint x="760" y="560" />]''',
'      ,q''[        <di:waypoint x="840" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1otethy_di" bpmnElement="Flow_1otethy">]''',
'      ,q''[        <di:waypoint x="940" y="450" />]''',
'      ,q''[        <di:waypoint x="1002" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wjbipz_di" bpmnElement="Flow_0wjbipz">]''',
'      ,q''[        <di:waypoint x="940" y="560" />]''',
'      ,q''[        <di:waypoint x="1002" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12q3n8x_di" bpmnElement="Flow_12q3n8x">]''',
'      ,q''[        <di:waypoint x="760" y="475" />]''',
'      ,q''[        <di:waypoint x="760" y="670" />]''',
'      ,q''[        <di:waypoint x="840" y="670" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_187vjjj_di" bpmnElement="Flow_187vjjj">]''',
'      ,q''[        <di:waypoint x="940" y="670" />]''',
'      ,q''[        <di:waypoint x="1002" y="670" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0d6n996_di" bpmnElement="Flow_0d6n996">]''',
'      ,q''[        <di:waypoint x="760" y="475" />]''',
'      ,q''[        <di:waypoint x="760" y="780" />]''',
'      ,q''[        <di:waypoint x="840" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0exp2j4_di" bpmnElement="Flow_0exp2j4">]''',
'      ,q''[        <di:waypoint x="940" y="780" />]''',
'      ,q''[        <di:waypoint x="1002" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_054vnaw_di" bpmnElement="Flow_054vnaw">]''',
'      ,q''[        <di:waypoint x="1038" y="450" />]''',
'      ,q''[        <di:waypoint x="1102" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0fhxihw_di" bpmnElement="Flow_0fhxihw">]''',
'      ,q''[        <di:waypoint x="1038" y="560" />]''',
'      ,q''[        <di:waypoint x="1102" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1xtmf5p_di" bpmnElement="Flow_1xtmf5p">]''',
'      ,q''[        <di:waypoint x="1038" y="670" />]''',
'      ,q''[        <di:waypoint x="1102" y="670" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_083i9d5_di" bpmnElement="Flow_083i9d5">]''',
'      ,q''[        <di:waypoint x="1038" y="780" />]''',
'      ,q''[        <di:waypoint x="1102" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1ex81lj_di" bpmnElement="Association_1ex81lj">]''',
'      ,q''[        <di:waypoint x="519" y="435" />]''',
'      ,q''[        <di:waypoint x="540" y="398" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_09dzds0_di" bpmnElement="Association_09dzds0">]''',
'      ,q''[        <di:waypoint x="1032" y="437" />]''',
'      ,q''[        <di:waypoint x="1160" y="300" />]''',
'      ,q''[        <di:waypoint x="1190" y="300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1q8z07t_di" bpmnElement="Association_1q8z07t">]''',
'      ,q''[        <di:waypoint x="1035" y="550" />]''',
'      ,q''[        <di:waypoint x="1160" y="470" />]''',
'      ,q''[        <di:waypoint x="1190" y="470" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0073qme_di" bpmnElement="Association_0073qme">]''',
'      ,q''[        <di:waypoint x="1036" y="662" />]''',
'      ,q''[        <di:waypoint x="1150" y="600" />]''',
'      ,q''[        <di:waypoint x="1190" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0xnxta8_di" bpmnElement="Association_0xnxta8">]''',
'      ,q''[        <di:waypoint x="1037" y="774" />]''',
'      ,q''[        <di:waypoint x="1150" y="730" />]''',
'      ,q''[        <di:waypoint x="1190" y="730" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1c34puf_di" bpmnElement="Association_1c34puf">]''',
'      ,q''[        <di:waypoint x="1120" y="798" />]''',
'      ,q''[        <di:waypoint x="1120" y="880" />]''',
'      ,q''[        <di:waypoint x="1190" y="880" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0b87nxd_di" bpmnElement="TextAnnotation_0b87nxd">]''',
'      ,q''[        <dc:Bounds x="269" y="10" width="722" height="310" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 2d - Making your process pause'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:di="http://'
||'www.omg.org/spec/DD/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial3A" name="Tutorial 3A - Setting Process Variables" isExecutable="true" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_07kduq4" name="Start">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:onEvent>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>Originator</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>coalesce  ( sys_context(''apex$session'',''app_user'') ]''',
'      ,q''[                        , sys_context(''userenv'',''os_user'')]''',
'      ,q''[                        , sys_context(''userenv'',''session_user''))</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:onEvent>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:outgoing>Flow_1mu28br</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0f3qzi7" name="Intro">]''',
'      ,q''[      <bpmn:incoming>Flow_1mu28br</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_18wa8fy</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1mu28br" sourceRef="Event_07kduq4" targetRef="Activity_0f3qzi7" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_18wa8fy" sourceRef="Activity_0f3qzi7" targetRef="Gateway_Split" />]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_Split" name="Split">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeSplit>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>Gateway_Split:route</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>Flow_A:Flow_C</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeSplit>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_18wa8fy</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_A</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_B</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_C</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_07qs6zg" name="A">]''',
'      ,q''[      <bpmn:incoming>Flow_A</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0v2gxnx</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_A" name="Path A" sourceRef="Gateway_Split" targetRef="Activity_07qs6zg" />]''',
'      ,q''[    <bpmn:task id="Activity_1ncqgha" name="B">]''',
'      ,q''[      <bpmn:incoming>Flow_B</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_12ant4j</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_B" name="Path B" sourceRef="Gateway_Split" targetRef="Activity_1ncqgha" />]''',
'      ,q''[    <bpmn:task id="Activity_04g7z25" name="C">]''',
'      ,q''[      <bpmn:incoming>Flow_C</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0q16wkh</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_C" name="Path C" sourceRef="Gateway_Split" targetRef="Activity_04g7z25" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0v2gxnx" sourceRef="Activity_07qs6zg" targetRef="Gateway_Merge" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12ant4j" sourceRef="Activity_1ncqgha" targetRef="Gateway_Merge" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0q16wkh" sourceRef="Activity_04g7z25" targetRef="Gateway_Merge" />]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_Merge" name="Merge">]''',
'      ,q''[      <bpmn:incoming>Flow_0v2gxnx</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_12ant4j</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0q16wkh</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1umd44r</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_Check_EMP_DEPT" name="Check if EMP/DEPT exists">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EMP_DEPT_exists</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlFunctionBody</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>declare]''',
'      ,q''[  l_table varchar2(30);]''',
'      ,q''[begin]''',
'      ,q''[  select table_name into l_table from user_tables where table_name = ''EMP'';]''',
'      ,q''[     return ''yes'';]''',
'      ,q''[exception]''',
'      ,q''[  when no_data_found then]''',
'      ,q''[    return ''no'';]''',
'      ,q''[  when others then ]''',
'      ,q''[   return ''some other problem'';]''',
'      ,q''[end;</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1umd44r</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_02gbfxv</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1umd44r" sourceRef="Gateway_Merge" targetRef="Activity_Check_EMP_DEPT" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02gbfxv" sourceRef="Activity_Check_EMP_DEPT" targetRef="Gateway_Split2" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_Split2" name="Split for Expression Types">]''',
'      ,q''[      <bpmn:incoming>Flow_02gbfxv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1lf75u4</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0n99kf7</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_09wlg86</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_Static" name="Static Assignment">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>Static_before</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>This gets set to your Static String Content Before the Task</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>Static_After</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>And this one gets set after the task completes.</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1lf75u4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_12jbalk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1lf75u4" sourceRef="Gateway_Split2" targetRef="Activity_Static" />]''',
'      ,q''[    <bpmn:task id="Activity_Copy" name="Copy of another Process Variable">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>BeforeTask_CopyofEMP_DEPT_route</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>processVariable</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>EMP_DEPT_exists</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0n99kf7</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_048t0de</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0n99kf7" sourceRef="Gateway_Split2" targetRef="Activity_Copy" />]''',
'      ,q''[    <bpmn:task id="Activity_SQLSingle" name="Single SQL Query">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>KingJob</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQuerySingle</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select job]''',
'      ,q''[from emp]''',
'      ,q''[where ename = ''KING''</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[            <apex:varName>NoDataFoundItem</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQuerySingle</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select job]''',
'      ,q''[from emp]''',
'      ,q''[where ename = ''Fred''</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1ncsvvk</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0uhb1gg</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_SQLMulti" name="Colon Delimited SQL Query">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>SALESstaff</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename]''',
'      ,q''[from emp]''',
'      ,q''[join dept on dept.deptno = emp.deptno]''',
'      ,q''[where dname = ''SALES''</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[            <apex:varName>NoDataResult</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 60</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_19owlyu</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_11xbqtl</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_Expression" name="expression">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>expression_number</apex:varName>]''',
'      ,q''[            <apex:varDataType>NUMBER</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>7 * 6</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[            <apex:varName>this_month</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>to_char(sysdate,''Month'')</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0h2z2w4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0v3onte</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:exclusiveGateway id="EMP_DEPT_exists" name="EMP and DEPT Exist?">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeSplit>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EMP_DEPT_exists:route</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>processVariable</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>EMP_DEPT_exists</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeSplit>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_09wlg86</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>yes</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>no</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_09wlg86" sourceRef="Gateway_Split2" targetRef="EMP_DEPT_exists" />]''',
'      ,q''[    <bpmn:sequenceFlow id="yes" name="yes" sourceRef="EMP_DEPT_exists" targetRef="Gateway_Split_EMP_exists" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_Split_EMP_exists" name="Paths using EMP">]''',
'      ,q''[      <bpmn:incoming>yes</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ncsvvk</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_19owlyu</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0h2z2w4</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_19qdo14</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0dpvv93</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ncsvvk" sourceRef="Gateway_Split_EMP_exists" targetRef="Activity_SQLSingle" />]''',
'      ,q''[    <bpmn:sequenceFl'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ow id="Flow_19owlyu" sourceRef="Gateway_Split_EMP_exists" targetRef="Activity_SQLMulti" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0h2z2w4" sourceRef="Gateway_Split_EMP_exists" targetRef="Activity_Expression" />]''',
'      ,q''[    <bpmn:task id="Activity_FuncBody" name="function body">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>BeforeTask_FuncBody</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlFunctionBody</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>declare]''',
'      ,q''[  l_month varchar2(20);]''',
'      ,q''[begin]''',
'      ,q''[  l_month := to_char( to_date(''24-12-1970'',''DD-MM-YYYY'') , ''MM'');]''',
'      ,q''[ return l_month;]''',
'      ,q''[end;</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_19qdo14</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0494hmn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_19qdo14" sourceRef="Gateway_Split_EMP_exists" targetRef="Activity_FuncBody" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0sttahj" name="Static End">]''',
'      ,q''[      <bpmn:incoming>Flow_12jbalk</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12jbalk" sourceRef="Activity_Static" targetRef="Event_0sttahj" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1323y7h" name="Copy End">]''',
'      ,q''[      <bpmn:incoming>Flow_048t0de</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_048t0de" sourceRef="Activity_Copy" targetRef="Event_1323y7h" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0yhvzko" name="SQL End">]''',
'      ,q''[      <bpmn:incoming>Flow_0uhb1gg</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0uhb1gg" sourceRef="Activity_SQLSingle" targetRef="Event_0yhvzko" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0nmox7s" name="SQL Multi End">]''',
'      ,q''[      <bpmn:incoming>Flow_11xbqtl</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11xbqtl" sourceRef="Activity_SQLMulti" targetRef="Event_0nmox7s" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0mmc47q" name="Expression End">]''',
'      ,q''[      <bpmn:incoming>Flow_0v3onte</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0v3onte" sourceRef="Activity_Expression" targetRef="Event_0mmc47q" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1sjraqb" name="Function Body End">]''',
'      ,q''[      <bpmn:incoming>Flow_0494hmn</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0494hmn" sourceRef="Activity_FuncBody" targetRef="Event_1sjraqb" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1g6u9dx" name="No EMP/DEPT End">]''',
'      ,q''[      <bpmn:incoming>no</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="no" name="no" sourceRef="EMP_DEPT_exists" targetRef="Event_1g6u9dx" />]''',
'      ,q''[    <bpmn:task id="Activity_037o7il" name="JSON Array SQL Query">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>JSONarrayFromSQL</apex:varName>]''',
'      ,q''[            <apex:varDataType>JSON</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryArray</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select empno, ename, (sal + comm) Compensation]''',
'      ,q''[from   emp]''',
'      ,q''[where  deptno = 20;</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0dpvv93</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0u1yti2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0dpvv93" sourceRef="Gateway_Split_EMP_exists" targetRef="Activity_037o7il" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1vkpxw2" name="SQL Array End">]''',
'      ,q''[      <bpmn:incoming>Flow_0u1yti2</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0u1yti2" sourceRef="Activity_037o7il" targetRef="Event_1vkpxw2" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0saz0u3">]''',
unistr('      ,q''[      <bpmn:text>So you can set the routing instruction in a declarative variable expression, now defined inside the gateway definition in the model - rather than by a scriptTask.\00A0 Click in this gateway, then look at the Variables tab in th')
||'e properties panel.]''',
'      ,q''[You can see that the routing instruction is set up in a ''Before Split'' expression set to route the process to Task A and Task C.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1njps2n" sourceRef="Gateway_Split" targetRef="TextAnnotation_0saz0u3" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0hdt28j">]''',
'      ,q''[      <bpmn:text>This tutorial introduces Declarative Variable Expressions, new in V21.1]''',
'      ,q''[]''',
'      ,q''[Each object in the Flow diagram can set a group of Process Variables before and after* it executes - so you can use this to keep track of process state, set gateway routing variables, hand keep track of things like who started the process, '
||'when you need it to finish, its priority or sensitivity, as well as run counters or other control variables.]''',
'      ,q''[]''',
'      ,q''[Variable Expressions can set process variables to static values, copy another variable, do a SQL query, evaluate an expression or a PL/SL function body.]''',
'      ,q''[]''',
'      ,q''[This tutorial works best if you have the standard EMP &amp; DEPT tables installed in your workspace - but you can see how we test whether they are there before running the parts of the model that rely on them.]''',
'      ,q''[]''',
unistr('      ,q''[This tutorial runs through the key features.\00A0 Variable expression definitions are shown in the ''Variables'' tab of the properties panel.]'''),
'      ,q''[]''',
'      ,q''[* Task objects (task, script task, user task, etc) can have expressions that execute BEFORE TASK and AFTER TASK.]''',
'      ,q''[Event Objects (Start, End, Intermediate Throws and Catches, Boundary Events) ON EVENT and sometimes BEFORE EVENT.]''',
'      ,q''[Gateway Objects have expressions that execute BEFORE SPLIT and AFTER MERGE, depending upon the gateway usage.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1nkd87f" sourceRef="Activity_0f3qzi7" targetRef="TextAnnotation_0hdt28j" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_04rgdnn">]''',
'      ,q''[      <bpmn:text>Use your start event to initialise any standard variables that you want to use for all of your running instances...]''',
'      ,q''[]''',
'      ,q''[We set ''Originator'' here to your userid...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0tqwtb7" sourceRef="Event_07kduq4" targetRef="TextAnnotation_04rgdnn" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0y91707">]''',
unistr('      ,q''[      <bpmn:text>This executes a function body, returning ''yes'' if EMP exists in your workspace, and ''no'' if it doesn''t -- as a before task activity.\00A0]'''),
'      ,q''[]''',
'      ,q''[This is then used to set the routing for the ''EMP and DEPT exist?'' gateway 2 steps later...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0vlxnu9" sourceRef="Activity_Check_EMP_DEPT" targetRef="TextAnnotation_0y91707" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1w01shu">]''',
'      ,q''[      <bpmn:text>new in 24.1</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1vgf7fb" associationDirection="None" sourceRef="Activity_037o7il" targetRef="TextAnnotation_1w01shu" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial3A">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_07kduq4_di" bpmnElement="Event_07kduq4">]''',
'      ,q''[        <dc:Bounds x="242" y="482" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="248" y="525" width="24" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0f3qzi7_di" bpmnElement="Activity_0f3qzi7">]''',
'      ,q''[        <dc:Bounds x="330" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0befb5k_di" bpmnElement="Gateway_Split" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="485" y="475" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="500" y="445" width="22" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_07qs6zg_di" bpmnElement="Activity_07qs6zg" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="640" y="460" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ncqgha_di" bpmnElement="Activity_1ncqgha" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="640" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_04g7z25_di" bpmnElement="Activity_04g7z25" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="640" y="680" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0xexztv_di" bpmnElement="Gateway_Merge" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="825" y="585" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="884" y="573" width="32" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ymetlw_di" bpmnElement="Activity_Check_EMP_DEPT">]''',
'      ,q''[        <dc:Bounds x="960" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_03bnkja_di" bpmnElement="Gateway_Split2">]''',
'      ,q''[        <dc:Bounds x="1115" y="585" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1098" y="642" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_07hns5v_di" bpmnElement="Activity_Static" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1440" y="300" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_17wunpk_di" bpmnElement="Activity_Copy" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1440" y="440" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ikwbj4_di" bpmnElement="Activity_SQLSingle" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1440" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ov9j10_di" bpmnElement="Activity_SQLMulti" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1440" y="700" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0qmyt5q_di" bpmnElement="EMP_DEPT_exists" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1205" y="585" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1192" y="555" width="78" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1meehlq_di" bpmnElement="Gateway_Split_EMP_exists">]''',
'      ,q''[        <dc:Bounds x="1295" y="585" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1317" y="562" width="85" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0sttahj_di" bpmnElement="Event_0sttahj" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1642" y="322" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1635" y="365" width="51" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1323y7h_di" bpmnElement="Event_1323y7h" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1642" y="462" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1636" y="505" width="49" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0yhvzko_di" bpmnElement="Event_0yhvzko" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1642" y="592" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1638" y="635" width="45" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0nmox7s_di" bpmnElement="Event_0nmox7s" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1642" y="722" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1625" y="765" width="71" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1s8xbrn_di" bpmnElement="Activity_Expression" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1440" y="940" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ltt770_di" bpmnElement="Activity_FuncBody" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1440" y="1050" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0mmc47q_di" bpmnElement="Event_0mmc47q" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1642" y="962" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1622" y="1005" width="78" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1sjraqb_di" bpmnElement="Event_1sjraqb" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1642" y="1072" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1625" y="1115" width="71" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1g6u9dx_di" bpmnElement="Event_1g6u9dx">]''',
'      ,q''[        <dc:Bounds x="1642" y="1202" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1623" y="1245" width="74" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_037o7il_di" bpmnElement="Activity_037o7il" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="1440" y="820" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1vkpxw2_di" bpmnElement="Event_1vkpxw2" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="1642" y="842" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1623" y="885" width="74" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1vgf7fb_di" bpmnElement="Association_1vgf7fb">]''',
'      ,q''[        <di:waypoint x="1440" y="851" />]''',
'      ,q''[        <di:waypoint x="1330" y="830" />]''',
'      ,q''[        <di:waypoint x="1330" y="795" />]''',
'      ,q''[        <di:waypoint x="1350" y="795" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0saz0u3_di" bpmnElement="TextAnnotation_0saz0u3">]''',
'      ,q''[        <dc:Bounds x="510" y="260" width="520" height="98" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0hdt28j_di" bpmnElement="TextAnnotation_0hdt28j">]''',
'      ,q''[        <dc:Bounds x="330" y="-60" width="760" height="270" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_04rgdnn_di" bpmnElement="TextAnnotation_04rgdnn">]''',
'      ,q''[        <dc:Bounds x="260" y="595" width="189.99231763033313" height="111" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0y91707_di" bpmnElement="TextAnnotation_0y91707">]''',
'      ,q''[        <dc:Bounds x="820" y="855" width="345.0000305175781" height="91.99652862548828" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mu28br_di" bpmnElement="Flow_1mu28br">]''',
'      ,q''[        <di:waypoint x="278" y="500" />]''',
'      ,q''[        <di:waypoint x="330" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_18wa8fy_di" bpmnElement="Flow_18wa8fy">]''',
'      ,q''[        <di:waypoint x="430" y="500" />]''',
'      ,q''[        <di:waypoint x="485" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0my1j3h_di" bpmnElement="Flow_A">]''',
'      ,q''[        <di:waypoint x="535" y="500" />]''',
'      ,q''[        <di:waypoint x="640" y="500" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="573" y="482" width="34" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_045akdd_di" bpmnElement="Flow_B">]''',
'      ,q''[        <di:waypoint x="510" y="525" />]''',
'      ,q''[        <di:waypoint x="510" y="610" />]''',
'      ,q''[        <di:waypoint x="640" y="610" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="541" y="583" width="33" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ztr3iy_di" bpmnElement="Flow_C">]''',
'      ,q''[        <di:waypoint x="510" y="525" />]''',
'      ,q''[        <di:waypoint x="510" y="720" />]''',
'      ,q''[        <di:waypoint x="640" y="720" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="542" y="693" width="34" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0v2gxnx_di" bpmnElement="Flow_0v2gxnx">]''',
'      ,q''[        <di:waypoint x="740" y="500" />]''',
'      ,q''[        <di:waypoint x="850" y="500" />]''',
'      ,q''[        <di:waypoint x="850" y="585" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12ant4j_di" bpmnElement="Flow_12ant4j">]''',
'      ,q''[        <di:waypoint x="740" y="610" />]''',
'      ,q''[        <di:waypoint x="825" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0q16wkh_di" bpmnElement="Flow_0q16wkh">]''',
'      ,q''[        <di:waypoint x="740" y="720" />]''',
'      ,q''[        <di:waypoint x="850" y="720" />]''',
'      ,q''[        <di:waypoint x="850" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1umd44r_di" bpmnElement="Flow_1umd44r">]''',
'      ,q''[        <di:waypoint x="875" y="610" />]''',
'      ,q''[        <di:waypoint x="960" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02gbfxv_di" bpmnElement="Flow_02gbfxv">]''',
'      ,q''[        <di:waypoint x="1060" y="610" />]''',
'      ,q''[        <di:waypoint x="1115" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1lf75u4_di" bpmnElement="Flow_1lf75u4">]''',
'      ,q''[        <di:waypoint x="1140" y="585" />]''',
'      ,q''[        <di:waypoint x="1140" y="340" />]''',
'      ,q''[        <di:waypoint x="1440" y="340" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0n99kf7_di" bpmnElement="Flow_0n99kf7">]''',
'      ,q''[        <di:waypoint x="1140" y="585" />]''',
'      ,q''[        <di:waypoint x="1140" y="480" />]''',
'      ,q''[        <di:waypoint x="1440" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_09wlg86_di" bpmnElement="Flow_09wlg86">]''',
'      ,q''[        <di:waypoint x="1165" y="610" />]''',
'      ,q''[        <di:waypoint x="1205" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ndh330_di" bpmnElement="yes">]''',
'      ,q''[        <di:waypoint x="1255" y="610" />]''',
'      ,q''[        <di:waypoint x="1295" y="610" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1266" y="592" width="18" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ncsvvk_di" bpmnElement="Flow_1ncsvvk">]''',
'      ,q''[        <di:waypoint x="1345" y="610" />]''',
'      ,q''[        <di:waypoint x="1440" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_19owlyu_di" bpmnElement="Flow_19owlyu">]''',
'      ,q''[        <di:waypoint x="1320" y="635" />]''',
'      ,q''[        <di:waypoint x="1320" y="740" />]''',
'      ,q''[        <di:waypoint x="1440" y="740" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0h2z2w4_di" bpmnElement="Flow_0h2z2w4">]''',
'      ,q''[        <di:waypoint x="1320" y="635" />]''',
'      ,q''[        <di:waypoint x="1320" y="980" />]''',
'      ,q''[        <di:waypoint x="1440" y="980" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_19qdo14_di" bpmnElement="Flow_19qdo14">]''',
'      ,q''[        <di:waypoint x="1320" y="635" />]''',
'      ,q''[        <di:waypoint x="1320" y="1090" />]''',
'      ,q''[        <di:waypoint x="1440" y="1090" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12jbalk_di" bpmnElement="Flow_12jbalk">]''',
'      ,q''[        <di:waypoint x="1540" y="340" />]''',
'      ,q''[        <di:waypoint x="1642" y="340" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_048t0de_di" bpmnElement="Flow_048t0de">]''',
'      ,q''[        <di:waypoint x="1540" y="480" />]''',
'      ,q''[        <di:waypoint x="1642" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0uhb1gg_di" bpmnElement="Flow_0uhb1gg">]''',
'      ,q''[        <di:waypoint x="1540" y="610" />]''',
'      ,q''[        <di:waypoint x="1642" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11xbqtl_di" bpmnElement="Flow_11xbqtl">]''',
'      ,q''[        <di:waypoint x="1540" y="740" />]''',
'      ,q''[        <di:waypoint x="1642" y="740" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0m65uty_di" bpmnElement="no">]''',
'      ,q''[        <di:waypoint x="1230" y="635" />]''',
'      ,q''[        <di:waypoint x="1230" y="1220" />]''',
'      ,q''[        <di:waypoint x="1642" y="1220" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1239" y="1062" width="13" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1njps2n_di" bpmnElement="Association_1njps2n">]''',
'      ,q''[        <di:waypoint x="515" y="480" />]''',
'      ,q''[        <di:waypoint x="542" y="358" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1nkd87f_di" bpmnElement="Association_1nkd87f">]''',
'      ,q''[        <di:waypoint x="379" y="460" />]''',
'      ,q''[        <di:waypoint x="374" y="210" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0tqwtb7_di" bpmnElement="Association_0tqwtb7">]''',
'      ,q''[        <di:waypoint x="267" y="516" />]''',
'      ,q''[        <di:waypoint x="303" y="595" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0vlxnu9_di" bpmnElement="Association_0vlxnu9">]''',
'      ,q''[        <di:waypoint x="988" y="650" />]''',
'      ,q''[        <di:waypoint x="878" y="855" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0v3onte_di" bpmnElement="Flow_0v3onte">]''',
'      ,q''[        <di:waypoint x="1540" y="980" />]''',
'      ,q''[        <di:waypoint x="1642" y="980" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0494hmn_di" bpmnElement="Flow_0494hmn">]''',
'      ,q''[        <di:waypoint x="1540" y="1090" />]''',
'      ,q''[        <di:waypoint x="1642" y="1090" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0dpvv93_di" bpmnElement="Flow_0dpvv93">]''',
'      ,q''[        <di:waypoint x="1320" y="635" />]''',
'      ,q''[        <di:waypoint x="1320" y="860" />]''',
'      ,q''[        <di:waypoint x="1440" y="860" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0u1yti2_di" bpmnElement="Flow_0u1yti2">]''',
'      ,q''[        <di:waypoint x="1540" y="860" />]''',
'      ,q''[        <di:waypoint x="1642" y="860" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1w01shu_di" bpmnElement="TextAnnotation_1w01shu">]''',
'      ,q''[        <dc:Bounds x="1350" y="780" width="99.99473856692492" height="29.99278552634423" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 3a - Setting Process Variables from your Model'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial3b" name="Tutorial 3b - Substitution and Bind Syntax" isExecutable="false" apex:isCallable="false" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_1plpgom">]''',
'      ,q''[      <bpmn:outgoing>Flow_1ec73q3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0ozxsb9" name="Concept 1:&#10;Using Process Variables">]''',
'      ,q''[      <bpmn:incoming>Flow_1ec73q3</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0r29a9k</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ec73q'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'3" sourceRef="Event_1plpgom" targetRef="Activity_0ozxsb9" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0r29a9k" sourceRef="Activity_0ozxsb9" targetRef="Gateway_0k7wwo7" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0k7wwo7">]''',
'      ,q''[      <bpmn:incoming>Flow_0r29a9k</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1gcfz9u</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0k2h11g</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_08olq9m</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0inf8qr</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0vsy08g</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1rz8nif</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_10y1yso" name="In a Timer Definition">]''',
'      ,q''[      <bpmn:incoming>Flow_1gcfz9u</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_048u5lq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1gcfz9u" sourceRef="Gateway_0k7wwo7" targetRef="Activity_10y1yso" />]''',
'      ,q''[    <bpmn:task id="Activity_0j6pujb" name="In a Gateway">]''',
'      ,q''[      <bpmn:incoming>Flow_0k2h11g</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0klopa5</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0k2h11g" sourceRef="Gateway_0k7wwo7" targetRef="Activity_0j6pujb" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0klopa5" sourceRef="Activity_0j6pujb" targetRef="Gateway_04509o5" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_048u5lq" sourceRef="Activity_10y1yso" targetRef="Event_0iob1po" />]''',
'      ,q''[    <bpmn:task id="Activity_0946wwh" name="In a Task">]''',
'      ,q''[      <bpmn:incoming>Flow_08olq9m</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1vdold9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08olq9m" sourceRef="Gateway_0k7wwo7" targetRef="Activity_0946wwh" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1vdold9" sourceRef="Activity_0946wwh" targetRef="Gateway_11x8qex" />]''',
'      ,q''[    <bpmn:task id="Activity_1w8et0w" name="In a UserTask - APEX Page call">]''',
'      ,q''[      <bpmn:incoming>Flow_0inf8qr</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1hk6xxp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0inf8qr" sourceRef="Gateway_0k7wwo7" targetRef="Activity_1w8et0w" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1hk6xxp" sourceRef="Activity_1w8et0w" targetRef="Activity_025ghr0" />]''',
'      ,q''[    <bpmn:task id="Activity_1wyrdke" name="In a UserTask - APEX Approval call">]''',
'      ,q''[      <bpmn:incoming>Flow_0vsy08g</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1vqhn5f</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0vsy08g" sourceRef="Gateway_0k7wwo7" targetRef="Activity_1wyrdke" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1vqhn5f" sourceRef="Activity_1wyrdke" targetRef="Activity_00ikjar" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_11x8qex">]''',
'      ,q''[      <bpmn:incoming>Flow_1vdold9</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_01ahvyv</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1nhbi01</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0ngmayk</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0yg5gl0</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0zkr82p</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_16cbzmb</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_02zdkhv</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_0uu2coh" name="Concept 2; How?">]''',
'      ,q''[      <bpmn:incoming>Flow_02zdkhv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ylq0wi</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02zdkhv" sourceRef="Gateway_11x8qex" targetRef="Activity_0uu2coh" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ylq0wi" sourceRef="Activity_0uu2coh" targetRef="Gateway_0but2hg" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0but2hg">]''',
'      ,q''[      <bpmn:incoming>Flow_1ylq0wi</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_07bi894</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0n5ncld</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_109wr9z" name="Substitution Syntax">]''',
'      ,q''[      <bpmn:incoming>Flow_07bi894</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_18ek31f</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07bi894" sourceRef="Gateway_0but2hg" targetRef="Activity_109wr9z" />]''',
'      ,q''[    <bpmn:task id="Activity_0l3xwhd" name="Bind Syntax">]''',
'      ,q''[      <bpmn:incoming>Flow_0n5ncld</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0tljhpd</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0n5ncld" sourceRef="Gateway_0but2hg" targetRef="Activity_0l3xwhd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_18ek31f" sourceRef="Activity_109wr9z" targetRef="Gateway_066hu8c" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_066hu8c">]''',
'      ,q''[      <bpmn:incoming>Flow_18ek31f</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0tljhpd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0bfhz6m</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0tljhpd" sourceRef="Activity_0l3xwhd" targetRef="Gateway_066hu8c" />]''',
'      ,q''[    <bpmn:task id="Activity_064ohbq" name="Concept 3:&#10;Things to Remember">]''',
'      ,q''[      <bpmn:incoming>Flow_0bfhz6m</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_024p93z</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0bfhz6m" sourceRef="Gateway_066hu8c" targetRef="Activity_064ohbq" />]''',
'      ,q''[    <bpmn:task id="Activity_1krbaa9" name="Substitution is always VARCHAR2 only">]''',
'      ,q''[      <bpmn:incoming>Flow_040sz4v</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1yoridh</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_024p93z" sourceRef="Activity_064ohbq" targetRef="Gateway_0oiud3h" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1d8h7t2">]''',
'      ,q''[      <bpmn:incoming>Flow_1yoridh</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1yoridh" sourceRef="Activity_1krbaa9" targetRef="Event_1d8h7t2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_040sz4v" sourceRef="Gateway_0oiud3h" targetRef="Activity_1krbaa9" apex:sequence="10" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0oiud3h">]''',
'      ,q''[      <bpmn:incoming>Flow_024p93z</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_040sz4v</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_07ut43o</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1bedtbq</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0h58bew</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1yn9h9h</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_04jc012" name="Dates always use the format YYYY-MM-DD HH24MI:SS">]''',
'      ,q''[      <bpmn:incoming>Flow_07ut43o</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1en3v8m</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07ut43o" sourceRef="Gateway_0oiud3h" targetRef="Activity_04jc012" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0epw44y">]''',
'      ,q''[      <bpmn:incoming>Flow_1en3v8m</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1en3v8m" sourceRef="Activity_04jc012" targetRef="Event_0epw44y" />]''',
'      ,q''[    <bpmn:task id="Activity_1543y23" name="Binding can be used in all expressions, function bodies, scripts in 23.1">]''',
'      ,q''[      <bpmn:incoming>Flow_1bedtbq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1bw826o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1bedtbq" sourceRef="Gateway_0oiud3h" targetRef="Activity_1543y23" />]''',
'      ,q''[    <bpmn:endEvent id="Event_08bp25i">]''',
'      ,q''[      <bpmn:incoming>Flow_1bw826o</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1bw826o" sourceRef="Activity_1543y23" targetRef="Event_08bp25i" />]''',
'      ,q''[    <bpmn:task id="Activity_19cz6nm" name="Using Call Activities?&#10;See Tutorial 8d (scoping)">]''',
'      ,q''[      <bpmn:incoming>Flow_0h58bew</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_08fk99d</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0h58bew" sourceRef="Gateway_0oiud3h" targetRef="Activity_19cz6nm" />]''',
'      ,q''[    <bpmn:endEvent id="Event_End5">]''',
'      ,q''[      <bpmn:incoming>Flow_08fk99d</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08fk99d" sourceRef="Activity_19cz6nm" targetRef="Event_End5" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_01ahvyv" sourceRef="Event_0iob1po" targetRef="Gateway_11x8qex" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_0iob1po">]''',
'      ,q''[      <bpmn:incoming>Flow_048u5lq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_01ahvyv</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0pde5i3" />]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_04509o5">]''',
'      ,q''[      <bpmn:incoming>Flow_0klopa5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1nhbi01</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ngmayk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1nhbi01" sourceRef="Gateway_04509o5" targetRef="Gateway_11x8qex" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ngmayk" sourceRef="Gateway_04509o5" targetRef="Gateway_11x8qex" apex:sequence="20" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0yg5gl0" sourceRef="Activity_025ghr0" targetRef="Gateway_11x8qex" />]''',
'      ,q''[    <bpmn:userTask id="Activity_025ghr0" name="All Page inputs can be substituted" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_1hk6xxp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0yg5gl0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0zkr82p" sourceRef="Activity_00ikjar" targetRef="Gateway_11x8qex" />]''',
'      ,q''[    <bpmn:userTask id="Activity_00ikjar" name="All Approval Task inputs can be substituted" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_1vqhn5f</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0zkr82p</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:task id="Activity_0b9bskz" name="In fact, most parameters can be substituted...">]''',
'      ,q''[      <bpmn:incoming>Flow_1rz8nif</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_16cbzmb</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1rz8nif" sourceRef="Gateway_0k7wwo7" targetRef="Activity_0b9bskz" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_16cbzmb" sourceRef="Activity_0b9bskz" targetRef="Gateway_11x8qex" />]''',
unistr('      ,q''[    <bpmn:task id="Activity_14jn3ja" name="Timestamps \00A0always use YYYY-MM-DD HH24:MI:SS TZR">]'''),
'      ,q''[      <bpmn:incoming>Flow_1yn9h9h</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1d9orfq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1yn9h9h" sourceRef="Gateway_0oiud3h" targetRef="Activity_14jn3ja" />]''',
'      ,q''[    <bpmn:endEvent id="Event_173ws7k">]''',
'      ,q''[      <bpmn:incoming>Flow_1d9orfq</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1d9orfq" sourceRef="Activity_14jn3ja" targetRef="Event_173ws7k" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0y2my1c">]''',
unistr('      ,q''[      <bpmn:text>Substitution Syntax -\00A0]'''),
'      ,q''[]''',
unistr('      ,q''[Just like APEX, but we add F4A$ in front of the variable name to separate Process Variables from Page Items, etc. \00A0So refer to the ''MyVar'' variable as]'''),
'      ,q''[]''',
'      ,q''[&amp;F4A$MyVar.]''',
'      ,q''[]''',
'      ,q''[Note the ''&amp;'' and the ''.'' at the end.]''',
'      ,q''[]''',
unistr('      ,q''[Substitution puts a VARCHAR2-formatted copy of the Process Variable contents into whatever is being substituted. \00A0For Dates and Timestamps, you have to be careful about how the format it gets converted with...</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0tujo7w" sourceRef="Activity_109wr9z" targetRef="TextAnnotation_0y2my1c" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1jczv9c">]''',
unistr('      ,q''[      <bpmn:text>Bind Syntax -\00A0]'''),
'      ,q''[]''',
'      ,q''[Just like APEX, but we add F4A$ in front of the variable name to separate Process Variables from Page Items, etc. So refer to the ''MyVar'' variable as]''',
'      ,q''[]''',
'      ,q''[:F4A$MyVar]''',
'      ,q''[]''',
'      ,q''[When we BIND a variable into an expression or a script, the content of the variable is used directly - without having to worry about converting dates or timestamps into character strings first.]''',
'      ,q''[]''',
'      ,q''[Binding is also safer &amp; prevents SQL Injection attacks -- so n general, if you are referencing a process variable in a script, expression, or function body -- its better to use binds than substitutions.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1i8e0u4" sourceRef="Activity_0l3xwhd" targetRef="TextAnnotation_1jczv9c" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1fz3jj4">]''',
'      ,q''[      <bpmn:text>All of the parameters can be substituted - see doc.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1dq65gz" sourceRef="Event_0iob1po" targetRef="TextAnnotation_1fz3jj4" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0fcz1tf">]''',
'      ,q''[      <bpmn:text>Gateway Routing Expressions - Process Variables can be bound or substituted into an expression of function body.]''',
'      ,q''[]''',
'      ,q''[Gateway Routing Variables - are a process variable.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1cy1qjf" sourceRef="Gateway_04509o5" targetRef="TextAnnotation_0fcz1tf" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0frra4d">]''',
'      ,q''[      <bpmn:text>Don''t Run this tutorial - just read the model!</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1tve32h" associationDirection="None" sourceRef="Activity_0ozxsb9" targetRef="TextAnnotation_0frra4d" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial3b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1plpgom_di" bpmnElement="Event_1plpgom">]''',
'      ,q''[        <dc:Bounds x="372" y="592" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ozxsb9_di" bpmnElement="Activity_0ozxsb9" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="460" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0lauwst_di" bpmnElement="Gateway_0k7wwo7" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="615" y="585" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_10y1yso_di" bpmnElement="Activity_10y1yso" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="450" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0j6pujb_di" bpmnElement="Activity_0j6pujb" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0946wwh_di" bpmnElement="Activity_0946wwh" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="680" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1w8et0w_di" bpmnElement="Activity_1w8et0w" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="790" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1wyrdke_di" bpmnElement="Activity_1wyrdke" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="900" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1cfykx0_di" bpmnElement="Gateway_11x8qex" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1045" y="585" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0uu2coh_di" bpmnElement="Activity_0uu2coh" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1150" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0pt7ww8_di" bpmnElement="Gateway_0but2hg" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1305" y="585" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_109wr9z_di" bpmnElement="Activity_109wr9z" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1410" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0l3xwhd_di" bpmnElement="Activity_0l3xwhd" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1410" y="680" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0ll51df_di" bpmnElement="Gateway_066hu8c" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1565" y="585" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_064ohbq_di" bpmnElement="Activity_064ohbq" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1670" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1krbaa9_di" bpmnElement="Activity_1krbaa9" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1940" y="570" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1d8h7t2_di" bpmnElement="Event_1d8h7t2" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="2102" y="592" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1yv5wrk_di" bpmnElement="Gateway_0oiud3h" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1825" y="585" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_04jc012_di" bpmnElement="Activity_04jc012" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1940" y="680" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0epw44y_di" bpmnElement="Event_0epw44y" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="2112" y="702" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1543y23_di" bpmnElement="Activity_1543y23" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1940" y="880" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_08bp25i_di" bpmnElement="Event_08bp25i" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="2112" y="902" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_19cz6nm_di" bpmnElement="Activity_19cz6nm" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1940" y="980" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0lvs1ap_di" bpmnElement="Event_End5" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="2112" y="1002" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2103" y="1045" width="58" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_08pp0hi_di" bpmnElement="Event_0iob1po" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="912" y="472" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_04509o5_di" bpmnElement="Gateway_04509o5" isMarkerVisible="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="865" y="585" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1e21yda_di" bpmnElement="Activity_025ghr0" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="880" y="790" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0x3d4kh_di" bpmnElement="Activity_00ikjar" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="880" y="900" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0b9bskz_di" bpmnElement="Activity_0b9bskz" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="1010" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_14jn3ja_di" bpmnElement="Activity_14jn3ja" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1940" y="780" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_173ws7k_di" bpmnElement="Event_173ws7k" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="2112" y="802" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1tve32h_di" bpmnElement="Association_1tve32h">]''',
'      ,q''[        <di:waypoint x="488" y="650" />]''',
'      ,q''[        <di:waypoint x="448" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0y2my1c_di" bpmnElement="TextAnnotation_0y2my1c">]''',
'      ,q''[        <dc:Bounds x="1460" y="280" width="297" height="222" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1jczv9c_di" bpmnElement="TextAnnotation_1jczv9c">]''',
'      ,q''[        <dc:Bounds x="1380" y="815" width="340" height="250" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1fz3jj4_di" bpmnElement="TextAnnotation_1fz3jj4">]''',
'      ,q''[        <dc:Bounds x="890" y="366" width="99.99999237060547" height="67.99632263183594" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0fcz1tf_di" bpmnElement="TextAnnotation_0fcz1tf">]''',
'      ,q''[        <dc:Bounds x="1050" y="366" width="239.99998474121094" height="95.99263763427734" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ec73q3_di" bpmnElement="Flow_1ec73q3">]''',
'      ,q''[        <di:waypoint x="408" y="610" />]''',
'      ,q''[        <di:waypoint x="460" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0r29a9k_di" bpmnElement="Flow_0r29a9k">]''',
'      ,q''[        <di:waypoint x="560" y="610" />]''',
'      ,q''[        <di:waypoint x="615" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gcfz9u_di" bpmnElement="Flow_1gcfz9u">]''',
'      ,q''[        <di:waypoint x="640" y="585" />]''',
'      ,q''[        <di:waypoint x="640" y="490" />]''',
'      ,q''[        <di:waypoint x="720" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0k2h11g_di" bpmnElement="Flow_0k2h11g">]''',
'      ,q''[        <di:waypoint x="665" y="610" />]''',
'      ,q''[        <di:waypoint x="720" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0klopa5_di" bpmnElement="Flow_0klopa5">]''',
'      ,q''[        <di:waypoint x="820" y="610" />]''',
'      ,q''[        <di:waypoint x="865" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_048u5lq_di" bpmnElement="Flow_048u5lq">]''',
'      ,q''[        <di:waypoint x="820" y="490" />]''',
'      ,q''[        <di:waypoint x="912" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08olq9m_di" bpmnElement="Flow_08olq9m">]''',
'      ,q''[        <di:waypoint x="640" y="635" />]''',
'      ,q''[        <di:waypoint x="640" y="720" />]''',
'      ,q''[        <di:waypoint x="720" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1vdold9_di" bpmnElement="Flow_1vdold9">]''',
'      ,q''[        <di:waypoint x="820" y="720" />]''',
'      ,q''[        <di:waypoint x="1070" y="720" />]''',
'      ,q''[        <di:waypoint x="1070" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0inf8qr_di" bpmnElement="Flow_0inf8qr">]''',
'      ,q''[        <di:waypoint x="640" y="635" />]''',
'      ,q''[        <di:waypoint x="640" y="830" />]''',
'      ,q''[        <di:waypoint x="720" y="830" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1hk6xxp_di" bpmnElement="Flow_1hk6xxp">]''',
'      ,q''[        <di:waypoint x="820" y="830" />]''',
'      ,q''[        <di:waypoint x="880" y="830" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0vsy08g_di" bpmnElement="Flow_0vsy08g">]''',
'      ,q''[        <di:waypoint x="640" y="635" />]''',
'      ,q''[        <di:waypoint x="640" y="940" />]''',
'      ,q''[        <di:waypoint x="720" y="940" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1vqhn5f_di" bpmnElement="Flow_1vqhn5f">]''',
'      ,q''[        <di:waypoint x="820" y="940" />]''',
'      ,q''[        <di:waypoint x="880" y="940" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02zdkhv_di" bpmnElement="Flow_02zdkhv">]''',
'      ,q''[        <di:waypoint x="1095" y="610" />]''',
'      ,q''[        <di:waypoint x="1150" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ylq0wi_di" bpmnElement="Flow_1ylq0wi">]''',
'      ,q''[        <di:waypoint x="1250" y="610" />]''',
'      ,q''[        <di:waypoint x="1305" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07bi894_di" bpmnElement="Flow_07bi894">]''',
'      ,q''[        <di:waypoint x="1355" y="610" />]''',
'      ,q''[        <di:waypoint x="1410" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge i'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'd="Flow_0n5ncld_di" bpmnElement="Flow_0n5ncld">]''',
'      ,q''[        <di:waypoint x="1330" y="635" />]''',
'      ,q''[        <di:waypoint x="1330" y="720" />]''',
'      ,q''[        <di:waypoint x="1410" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_18ek31f_di" bpmnElement="Flow_18ek31f">]''',
'      ,q''[        <di:waypoint x="1510" y="610" />]''',
'      ,q''[        <di:waypoint x="1565" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0tljhpd_di" bpmnElement="Flow_0tljhpd">]''',
'      ,q''[        <di:waypoint x="1510" y="720" />]''',
'      ,q''[        <di:waypoint x="1590" y="720" />]''',
'      ,q''[        <di:waypoint x="1590" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0bfhz6m_di" bpmnElement="Flow_0bfhz6m">]''',
'      ,q''[        <di:waypoint x="1615" y="610" />]''',
'      ,q''[        <di:waypoint x="1670" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_024p93z_di" bpmnElement="Flow_024p93z">]''',
'      ,q''[        <di:waypoint x="1770" y="610" />]''',
'      ,q''[        <di:waypoint x="1825" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1yoridh_di" bpmnElement="Flow_1yoridh">]''',
'      ,q''[        <di:waypoint x="2040" y="610" />]''',
'      ,q''[        <di:waypoint x="2102" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_040sz4v_di" bpmnElement="Flow_040sz4v">]''',
'      ,q''[        <di:waypoint x="1875" y="610" />]''',
'      ,q''[        <di:waypoint x="1940" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07ut43o_di" bpmnElement="Flow_07ut43o">]''',
'      ,q''[        <di:waypoint x="1850" y="635" />]''',
'      ,q''[        <di:waypoint x="1850" y="720" />]''',
'      ,q''[        <di:waypoint x="1940" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1en3v8m_di" bpmnElement="Flow_1en3v8m">]''',
'      ,q''[        <di:waypoint x="2040" y="720" />]''',
'      ,q''[        <di:waypoint x="2112" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1bedtbq_di" bpmnElement="Flow_1bedtbq">]''',
'      ,q''[        <di:waypoint x="1850" y="635" />]''',
'      ,q''[        <di:waypoint x="1850" y="920" />]''',
'      ,q''[        <di:waypoint x="1940" y="920" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1bw826o_di" bpmnElement="Flow_1bw826o">]''',
'      ,q''[        <di:waypoint x="2040" y="920" />]''',
'      ,q''[        <di:waypoint x="2112" y="920" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0h58bew_di" bpmnElement="Flow_0h58bew">]''',
'      ,q''[        <di:waypoint x="1850" y="635" />]''',
'      ,q''[        <di:waypoint x="1850" y="1020" />]''',
'      ,q''[        <di:waypoint x="1940" y="1020" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08fk99d_di" bpmnElement="Flow_08fk99d">]''',
'      ,q''[        <di:waypoint x="2040" y="1020" />]''',
'      ,q''[        <di:waypoint x="2112" y="1020" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_01ahvyv_di" bpmnElement="Flow_01ahvyv">]''',
'      ,q''[        <di:waypoint x="948" y="490" />]''',
'      ,q''[        <di:waypoint x="1070" y="490" />]''',
'      ,q''[        <di:waypoint x="1070" y="585" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1nhbi01_di" bpmnElement="Flow_1nhbi01">]''',
'      ,q''[        <di:waypoint x="890" y="635" />]''',
'      ,q''[        <di:waypoint x="890" y="660" />]''',
'      ,q''[        <di:waypoint x="1070" y="660" />]''',
'      ,q''[        <di:waypoint x="1070" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ngmayk_di" bpmnElement="Flow_0ngmayk">]''',
'      ,q''[        <di:waypoint x="890" y="585" />]''',
'      ,q''[        <di:waypoint x="890" y="560" />]''',
'      ,q''[        <di:waypoint x="1070" y="560" />]''',
'      ,q''[        <di:waypoint x="1070" y="585" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0yg5gl0_di" bpmnElement="Flow_0yg5gl0">]''',
'      ,q''[        <di:waypoint x="980" y="830" />]''',
'      ,q''[        <di:waypoint x="1070" y="830" />]''',
'      ,q''[        <di:waypoint x="1070" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0zkr82p_di" bpmnElement="Flow_0zkr82p">]''',
'      ,q''[        <di:waypoint x="980" y="940" />]''',
'      ,q''[        <di:waypoint x="1070" y="940" />]''',
'      ,q''[        <di:waypoint x="1070" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1rz8nif_di" bpmnElement="Flow_1rz8nif">]''',
'      ,q''[        <di:waypoint x="640" y="635" />]''',
'      ,q''[        <di:waypoint x="640" y="1050" />]''',
'      ,q''[        <di:waypoint x="720" y="1050" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16cbzmb_di" bpmnElement="Flow_16cbzmb">]''',
'      ,q''[        <di:waypoint x="820" y="1050" />]''',
'      ,q''[        <di:waypoint x="1070" y="1050" />]''',
'      ,q''[        <di:waypoint x="1070" y="635" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1yn9h9h_di" bpmnElement="Flow_1yn9h9h">]''',
'      ,q''[        <di:waypoint x="1850" y="635" />]''',
'      ,q''[        <di:waypoint x="1850" y="820" />]''',
'      ,q''[        <di:waypoint x="1940" y="820" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1d9orfq_di" bpmnElement="Flow_1d9orfq">]''',
'      ,q''[        <di:waypoint x="2040" y="820" />]''',
'      ,q''[        <di:waypoint x="2112" y="820" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0tujo7w_di" bpmnElement="Association_0tujo7w">]''',
'      ,q''[        <di:waypoint x="1465" y="570" />]''',
'      ,q''[        <di:waypoint x="1476" y="502" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1i8e0u4_di" bpmnElement="Association_1i8e0u4">]''',
'      ,q''[        <di:waypoint x="1478" y="760" />]''',
'      ,q''[        <di:waypoint x="1503" y="815" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1dq65gz_di" bpmnElement="Association_1dq65gz">]''',
'      ,q''[        <di:waypoint x="917" y="477" />]''',
'      ,q''[        <di:waypoint x="840" y="400" />]''',
'      ,q''[        <di:waypoint x="890" y="400" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1cy1qjf_di" bpmnElement="Association_1cy1qjf">]''',
'      ,q''[        <di:waypoint x="899" y="594" />]''',
'      ,q''[        <di:waypoint x="1010" y="412" />]''',
'      ,q''[        <di:waypoint x="1050" y="412" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0frra4d_di" bpmnElement="TextAnnotation_0frra4d">]''',
'      ,q''[        <dc:Bounds x="390" y="720" width="190" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 3b - Substitution and Bind Syntax'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Tutorial4" name="Task Types Tutorial" isExecutable="false" apex:isCallable="false" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_0etkrt2">]''',
'      ,q''[      <bpmn:outgoing>Flow_1nctu2s</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0byebb7" name="This is a standard Task">]''',
'      ,q''[      <bpmn:incoming>Flow_1nctu2s</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0pijurl</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1nctu2s" sourceRef="Event_0etkrt2" targetRef="Activity_0byebb7" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0pijurl" sourceRef="Activity_0byebb7" targetRef="Activity_0a6djqt" />]''',
'      ,q''[    <bpmn:userTask id="Activity_0srf4in" name="UserTask - I can call an APEX Human Task ( Action or Approval )" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexPage />]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_17qungp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_199lc3i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_199lc3i" sourceRef="Activity_0srf4in" targetRef="Activity_0w0fi2i" />]''',
'      ,q''[    <bpmn:scriptTask id="Activity_0w0fi2i" name="scriptTask&#10;- I can run a&#10;PL/SQL script&#10;" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_199lc3i</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_05hp9u3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_05hp9u3" sourceRef="Activity_0w0fi2i" targetRef="Activity_1sk9zqj" />]''',
'      ,q''[    <bpmn:serviceTask id="Activity_1sk9zqj" name="serviceTask&#10;- Use me to&#10;send an email" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_05hp9u3</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0kd3kyt</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0kd3kyt" sourceRef="Activity_1sk9zqj" targetRef="Activity_0t8licd" />]''',
'      ,q''[    <bpmn:manualTask id="Activity_0t8licd" name="This is a Manual Task">]''',
'      ,q''[      <bpmn:incoming>Flow_0kd3kyt</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_07uwsw9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:manualTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_1da6vg3">]''',
'      ,q''[      <bpmn:incoming>Flow_104w405</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1pjx0pk" sourceRef="Activity_0l6ac3x" targetRef="Activity_1wg9nda" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_104w405" sourceRef="Activity_1wg9nda" targetRef="Event_1da6vg3" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sendTask id="Activity_0l6ac3x" name="SendTask&#10;- sends a message to another process" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0mxa79i</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1pjx0pk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:sendTask>]''',
'      ,q''[    <bpmn:receiveTask id="Activity_1wg9nda" name="ReceiveTask&#10;- receives a message from another process" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1pjx0pk</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_104w405</bpmn:outgoing>]''',
'      ,q''[    </bpmn:receiveTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wpq0ks" sourceRef="Activity_0a6djqt" targetRef="Activity_0tt3lr5" />]''',
'      ,q''[    <bpmn:userTask id="Activity_0a6djqt" name="UserTask - I can call an APEX page in your app" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_0pijurl</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wpq0ks</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_17qungp" sourceRef="Activity_0tt3lr5" targetRef="Activity_0srf4in" />]''',
unistr('      ,q''[    <bpmn:userTask id="Activity_0tt3lr5" name="UserTask - I can use\00A0&#10;Simple Form to collect some data" apex:type="apexPage" apex:manualInput="false">]'''),
'      ,q''[      <bpmn:incoming>Flow_0wpq0ks</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_17qungp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:businessRuleTask id="Activity_1ysn2gx" name="&#10;BusinessRule Task - use me to run a ML model" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:incoming>Flow_07uwsw9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mxa79i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:businessRuleTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mxa79i" sourceRef="Activity_1ysn2gx" targetRef="Activity_0l6ac3x" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07uwsw9" sourceRef="Activity_0t8licd" targetRef="Activity_1ysn2gx" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0xw8y26">]''',
'      ,q''[      <bpmn:text>Tutorial 4a - Tasks - Getting your Work Done!]''',
'      ,q''[]''',
unistr('      ,q''[So much for steering your process through gateways, etc.\00A0 How do we actually get things done?]'''),
'      ,q''[]''',
unistr('      ,q''[Flows for APEX\00A0 can now direct steps in your process.\00A0 This step introduces the task types, and how to configure them.]'''),
'      ,q''[]''',
'      ,q''[This tutorial is one to look at in Flow Management / Flow Modeler, but not run in your system.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_00jab7b" sourceRef="Event_0etkrt2" targetRef="TextAnnotation_0xw8y26" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1vygfet">]''',
'      ,q''[      <bpmn:text>A User Task can call an APEX page, pass variables into the page, etc -- just like an APEX menu does.]''',
'      ,q''[]''',
'      ,q''[Open the APEX tab in the Properties Panel (on the right) and you can see how you specify the application and page to call, provide instructions on what action to perform, what to do with the cache, and list items to set and values to use.</'
||'bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1r0p5lj" sourceRef="Activity_0a6djqt" targetRef="TextAnnotation_1vygfet" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1egb903">]''',
unistr('      ,q''[      <bpmn:text>Service Tasks call various services, such as messaging, email, etc.\00A0\00A0]'''),
'      ,q''[]''',
'      ,q''[In v23.1, you can use these to:]''',
'      ,q''[]''',
unistr('      ,q''[- run a\00A0 PL/SQL procedure that you provide (similar to a scriptTask)]'''),
'      ,q''[- send an email (defined declaratively, optionally using an APEX Mail Template)</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_061ntp9" sourceRef="Activity_1sk9zqj" targetRef="TextAnnotation_1egb903" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1rkmr7t">]''',
'      ,q''[      <bpmn:text>Manual Tasks are used to model non-computer steps in your process.]''',
'      ,q''[]''',
'      ,q''[In V5 and v21.1, they behave like a standard Task.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1crb5iq" sourceRef="Activity_0t8licd" targetRef="TextAnnotation_1rkmr7t" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_02mhmae">]''',
'      ,q''[      <bpmn:text>A Script Task can run a piece of PL/SQL that you supply in the model.]''',
'      ,q''[]''',
'      ,q''[You can use a script task to set process variables, execute a script, Lots of useful things.]''',
'      ,q''[]''',
'      ,q''[As the modeller is not a great editor, we usually write our PL/SQL as packages that are stored in the database, and just call the procedure from the diagram.]''',
'      ,q''[]''',
unistr('      ,q''[Optionally you can bind Process Variables \00A0into your scripts.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1ipwm4g">]''',
'      ,q''[      <bpmn:text>Business Rules Tasks are used to model the use of machine learning models or credit scoring models.]''',
'      ,q''[]''',
'      ,q''[These could be models stored in the database using the SQL Models feature or something else you can call via PL/SQL script.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1ity14p" sourceRef="TextAnnotation_02mhmae" targetRef="Activity_0w0fi2i" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1qygjgj">]''',
'      ,q''[      <bpmn:text>SendTask and ReceiveTask (and Intermediate Message Throw and Catch Events) are used for messaging between process instances (MessageFlow).]''',
'      ,q''[]''',
'      ,q''[MessageFlow is explored further in Tutorial 7a.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0pp4g90" sourceRef="Activity_0l6ac3x" targetRef="TextAnnotation_1qygjgj" />]''',
'      ,q''[    <bpmn:association id="Association_13luki1" sourceRef="TextAnnotation_1qygjgj" targetRef="Activity_1wg9nda" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_004vkfx">]''',
'      ,q''[      <bpmn:text>Use these standard tasks early in your process modelling journey - but aim to replace them with more specific task types as you make your logical process diagram into an executable workflow...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0mbekaw" associationDirection="None" sourceRef="Activity_0byebb7" targetRef="TextAnnotation_004vkfx" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_00z1cx4">]''',
'      ,q''[      <bpmn:text>SimpleForm allows you to collect some data from the user without having to develop APEX</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1hnmiu8" associationDirection="None" sourceRef="Activity_0tt3lr5" targetRef="TextAnnotation_00z1cx4" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1ulqhgu">]''',
unistr('      ,q''[      <bpmn:text>UserTask can also call an APEX Human Task (APEX Approval Task or Action Task), allowing high interoperability \00A0with APEX Workflow components</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0fteof6" associationDirection="None" sourceRef="Activity_0srf4in" targetRef="TextAnnotation_1ulqhgu" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1wp6ozy">]''',
'      ,q''[      <bpmn:text>New in 24.1</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_12rs891" associationDirection="None" sourceRef="Activity_0tt3lr5" targetRef="TextAnnotation_1wp6ozy" />]''',
'      ,q''[    <bpmn:association id="Association_01wl35g" sourceRef="Activity_1ysn2gx" targetRef="TextAnnotation_1ipwm4g" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Tutorial4">]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1e92hqx_di" bpmnElement="Activity_0w0fi2i" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="670" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0yapt8d_di" bpmnElement="Activity_1sk9zqj" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="830" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1apqobn_di" bpmnElement="Activity_0t8licd" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="990" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1da6vg3_di" bpmnElement="Event_1da6vg3">]''',
'      ,q''[        <dc:Bounds x="1672" y="362" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0lrcet4_di" bpmnElement="Activity_1ysn2gx" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1170" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_15lsg1n_di" bpmnElement="Activity_0l6ac3x" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1330" y="340" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0tfwzsa_di" bpmnElement="Activity_1wg9nda" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1510" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0etkrt2_di" bpmnElement="Event_0etkrt2">]''',
'      ,q''[        <dc:Bounds x="-28" y="362" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0byebb7_di" bpmnElement="Activity_0byebb7">]''',
'      ,q''[        <dc:Bounds x="60" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ok42am_di" bpmnElement="Activity_0srf4in" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="510" y="340" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0peoakh_di" bpmnElement="Activity_0a6djqt" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="220" y="340" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ac87zw_di" bpmnElement="Activity_0tt3lr5" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="370" y="340" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0mbekaw_di" bpmnElement="Association_0mbekaw">]''',
'      ,q''[        <di:waypoint x="100" y="420" />]''',
'      ,q''[        <di:waypoint x="34" y="670" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1r0p5lj_di" bpmnElement="Association_1r0p5lj">]''',
'      ,q''[        <di:waypoint x="240" y="340" />]''',
'      ,q''[        <di:waypoint x="100" y="310" />]''',
'      ,q''[        <di:waypoint x="80" y="238" />]''',
'      ,q''[        <di:waypoint x="140" y="238" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1hnmiu8_di" bpmnElement="Association_1hnmiu8">]''',
'      ,q''[        <di:waypoint x="454" y="340" />]''',
'      ,q''[        <di:waypoint x="510" y="275" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0fteof6_di" bpmnElement="Association_0fteof6">]''',
'      ,q''[        <di:waypoint x="591" y="340" />]''',
'      ,q''[        <di:waypoint x="680" y="225" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_00jab7b_di" bpmnElement="Association_00jab7b">]''',
'      ,q''[        <di:waypoint x="-13" y="363" />]''',
'      ,q''[        <di:waypoint x="-60" y="92" />]''',
'      ,q''[        <di:waypoint x="-60" y="92" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_12rs891_di" bpmnElement="Association_12rs891">]''',
'      ,q''[        <di:waypoint x="396" y="420" />]''',
'      ,q''[        <di:waypoint x="379" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1egb903_di" bpmnElement="TextAnnotation_1egb903">]''',
'      ,q''[        <dc:Bounds x="950" y="490" width="390" height="113" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1rkmr7t_di" bpmnElement="TextAnnotation_1rkmr7t">]''',
'      ,q''[        <dc:Bounds x="1020" y="190" width="200" height="95" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_02mhmae_di" bpmnElement="TextAnnotation_02mhmae">]''',
'      ,q''[        <dc:Bounds x="450" y="490" width="430" height="152" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1ipwm4g_di" bpmnElement="TextAnnotation_1ipwm4g">]''',
'      ,q''[        <dc:Bounds x="1250" y="90" width="220" height="127" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1qygjgj_di" bpmnElement="TextAnnotation_1qygjgj">]''',
'      ,q''[        <dc:Bounds x="1450" y="480" width="258" height="123" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_199lc3i_di" bpmnElement="Flow_199lc3i">]''',
'      ,q''[        <di:waypoint x="610" y="380" />]''',
'      ,q''[        <di:waypoint x="670" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_05hp9u3_di" bpmnElement="Flow_05hp9u3">]''',
'      ,q''[        <di:waypoint x="770" y="380" />]''',
'      ,q''[        <di:waypoint x="830" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0kd3kyt_di" bpmnElement="Flow_0kd3kyt">]''',
'      ,q''[        <di:waypoint x="930" y="380" />]''',
'      ,q''[        <di:waypoint x="990" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07uwsw9_di" bpmnElement="Flow_07uwsw9">]''',
'      ,q''[        <di:waypoint x="1090" y="380" />]''',
'      ,q''[        <di:waypoint x="1170" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0mxa79i_di" bpmnElement="Flow_0mxa79i">]''',
'      ,q''[        <di:waypoint x="1270" y="380" />]''',
'      ,q''[        <di:waypoint x="1330" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1pjx0pk_di" bpmnElement="Flow_1pjx0pk">]''',
'      ,q''[        <di:waypoint x="1430" y="380" />]''',
'      ,q''[        <di:waypoint x="1510" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_104w405_di" bpmnElement="Flow_104w405">]''',
'      ,q''[        <di:waypoint x="1610" y="380" />]''',
'      ,q''[        <di:waypoint x="1672" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_061ntp9_di" bpmnElement="Association_061ntp9">]''',
'      ,q''[        <di:waypoint x="918" y="420" />]''',
'      ,q''[        <di:waypoint x="986" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1crb5iq_di" bpmnElement="Association_1crb5iq">]''',
'      ,q''[        <di:waypoint x="1044" y="340" />]''',
'      ,q''[        <di:waypoint x="1049" y="285" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_01wl35g_di" bpmnElement="Association_01wl35g">]''',
'      ,q''[        <di:waypoint x="1230" y="340" />]''',
'      ,q''[        <di:waypoint x="1260" y="217" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1ity14p_di" bpmnElement="Association_1ity14p">]''',
'      ,q''[        <di:waypoint x="699" y="490" />]''',
'      ,q''[        <di:waypoint x="717" y="420" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0pp4g90_di" bpmnElement="Association_0pp4g90">]''',
'      ,q''[        <di:waypoint x="1421" y="420" />]''',
'      ,q''[        <di:waypoint x="1484" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_13luki1_di" bpmnElement="Association_13luki1">]''',
'      ,q''[        <di:waypoint x="1510" y="480" />]''',
'      ,q''[        <di:waypoint x="1553" y="420" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_004vkfx_di" bpmnElement="TextAnnotation_004vkfx">]''',
'      ,q''[        <dc:Bounds x="-20" y="670" width="377.9476876986229" height="56.481825833940235" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1nctu2s_di" bpmnElement="Flow_1nctu2s">]''',
'      ,q''[        <di:waypoint x="8" y="380" />]''',
'      ,q''[        <di:waypoint x="60" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0pijurl_di" bpmnElement="Flow_0pijurl">]''',
'      ,q''[        <di:waypoint x="160" y="380" />]''',
'      ,q''[        <di:w'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'aypoint x="220" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wpq0ks_di" bpmnElement="Flow_0wpq0ks">]''',
'      ,q''[        <di:waypoint x="320" y="380" />]''',
'      ,q''[        <di:waypoint x="370" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_17qungp_di" bpmnElement="Flow_17qungp">]''',
'      ,q''[        <di:waypoint x="470" y="380" />]''',
'      ,q''[        <di:waypoint x="510" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1vygfet_di" bpmnElement="TextAnnotation_1vygfet">]''',
'      ,q''[        <dc:Bounds x="140" y="174" width="350" height="128" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_00z1cx4_di" bpmnElement="TextAnnotation_00z1cx4">]''',
'      ,q''[        <dc:Bounds x="510" y="174" width="110" height="127" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1ulqhgu_di" bpmnElement="TextAnnotation_1ulqhgu">]''',
'      ,q''[        <dc:Bounds x="680" y="150" width="150" height="108" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0xw8y26_di" bpmnElement="TextAnnotation_0xw8y26">]''',
'      ,q''[        <dc:Bounds x="-60" y="-10" width="619.9975982914127" height="125.42292188407376" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1wp6ozy_di" bpmnElement="TextAnnotation_1wp6ozy">]''',
'      ,q''[        <dc:Bounds x="320" y="450" width="99.98485463283065" height="29.99861315152371" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 4a - Tasks Get Your Work Done!'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial_4b" name="Tutorial 4b - Timer Boundary Events" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_063wz8j" name="Start 4b">]''',
'      ,q''[      <bpmn:outgoing>Flow_03t16bn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0a56gp5" name="Concept 1:&#10;Setting Reminders">]''',
'      ,q''[      <bpmn:incoming>Flow_03t16bn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1kxjxrj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_03t16bn" sourceRef="Event_063wz8j" targetRef="Activity_0a56gp5" />]''',
'      ,q''[    <bpmn:task id="Activity_0aiaz74" name="Do Homework">]''',
'      ,q''[      <bpmn:incoming>Flow_1kxjxrj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_031kd26</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1kxjxrj" sourceRef="Activity_0a56gp5" targetRef="Activity_0aiaz74" />]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_0m96t82" name="Non Interrupting Timer (20sec)" cancelActivity="false" attachedToRef="Activity_0aiaz74">]''',
'      ,q''[      <bpmn:outgoing>Flow_07810n8</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_05trzil">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT20S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07810n8" sourceRef="Event_0m96t82" targetRef="Activity_0qo0apq" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0v5aniw" name="Reminder Sent">]''',
'      ,q''[      <bpmn:incoming>Flow_110va1r</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_110va1r" sourceRef="Activity_0qo0apq" targetRef="Event_0v5aniw" />]''',
'      ,q''[    <bpmn:scriptTask id="Activity_0qo0apq" name="Send Reminder" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_07810n8</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_110va1r</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:task id="Activity_07yt4el" name="Concept 2: Time-outs or Deadlines">]''',
'      ,q''[      <bpmn:incoming>Flow_031kd26</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wu1yf9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_031kd26" sourceRef="Activity_0aiaz74" targetRef="Activity_07yt4el" />]''',
'      ,q''[    <bpmn:task id="Activity_1x99lgf" name="Submit budget">]''',
'      ,q''[      <bpmn:incoming>Flow_0wu1yf9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1mqgk8a</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wu1yf9" sourceRef="Activity_07yt4el" targetRef="Activity_1x99lgf" />]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_1kdqlxk" name="Interrupting Timer (20 sec)" attachedToRef="Activity_1x99lgf">]''',
'      ,q''[      <bpmn:outgoing>Flow_1oasbbc</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_15c4olo">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT20S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1oasbbc" name="Time-Out Path" sourceRef="Event_1kdqlxk" targetRef="Activity_1iauqss" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1vauko0">]''',
'      ,q''[      <bpmn:incoming>Flow_1mqgk8a</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0cwunbe</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mm3511</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1mqgk8a" name="Usual Path" sourceRef="Activity_1x99lgf" targetRef="Gateway_1vauko0" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cwunbe" sourceRef="Activity_1iauqss" targetRef="Gateway_1vauko0" />]''',
'      ,q''[    <bpmn:task id="Activity_1qsrfjy" name="Concept 3:">]''',
'      ,q''[      <bpmn:incoming>Flow_0mm3511</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1fsfn01</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mm3511" sourceRef="Gateway_1vauko0" targetRef="Activity_1qsrfjy" apex:sequence="10" />]''',
'      ,q''[    <bpmn:scriptTask id="Activity_1iauqss" name="Default Budget Submitted" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1oasbbc</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0cwunbe</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_02k0a5w" name="End 4b">]''',
'      ,q''[      <bpmn:incoming>Flow_1fsfn01</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1fsfn01" sourceRef="Activity_1qsrfjy" targetRef="Event_02k0a5w" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0a1jfb0">]''',
'      ,q''[      <bpmn:text>Tutorial 4b: Timer Boundary Events]''',
'      ,q''[]''',
'      ,q''[What happens if your task sits there and doesn''t get completed?]''',
'      ,q''[]''',
unistr('      ,q''[Boundary Events allow you to attach an event to a Task, in this case ''Do Homework''. \00A0This Boundary Event is defined as a Non-Interrupting Timer Boundary Event - which is a very long way to say that if the task is not completed by a certain ')
||unistr('time, a new path gets started which doesn''t interrupt the original task. \00A0 \00A0So if the Homework has not been completed by a specified time, a Reminder is set. \00A0 The Homework task remains the current task on its path.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_09shi0r" sourceRef="Event_063wz8j" targetRef="TextAnnotation_0a1jfb0" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0o1h1es">]''',
'      ,q''[      <bpmn:text>To Add a Non-Interrupting Timer Boundary Event:]''',
'      ,q''[]''',
unistr('      ,q''[1. \00A0 Drag an Intermediate / Boundary Event from the side toolbar (double circle) onto the Task]'''),
unistr('      ,q''[2. \00A0Use the Spanner Tool to change it to a Timer Boundary Event (Non-Interrupting).]'''),
unistr('      ,q''[3. \00A0Configure the Delay in the Properties Panel.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_08jokvv" sourceRef="Event_0m96t82" targetRef="TextAnnotation_0o1h1es" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_16muge5">]''',
unistr('      ,q''[      <bpmn:text>Tip: \00A0A Non-Interrupting Timer can be configured to fire repetitively -- so that it continues to send reminders until the task gets done!]'''),
'      ,q''[]''',
'      ,q''[You can set this reminder to go off, for example, everyday, or every 3* weeks, or upto a maximum of 15* times. (all numbers configurable).]''',
'      ,q''[]''',
'      ,q''[Read the documentation pages to see all of the details of how to configure these...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0pmrlzv" sourceRef="Event_0m96t82" targetRef="TextAnnotation_16muge5" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_12a9y6k">]''',
'      ,q''[      <bpmn:text>Our second Timer Boundary Event is an INTERRUPTING one. (Note the circles are solid, unlike the dashed circle for the non-interrupting one).]''',
'      ,q''[]''',
unistr('      ,q''[Our business case here is a budget submission process. \00A0If the manager doesn''t submit his budget by the task deadline, a default budget is submitted for him instead.]'''),
'      ,q''[]''',
'      ,q''[So the timer is set to the deadline.]''',
'      ,q''[]''',
unistr('      ,q''[When the deadline occurs and the timer fires, the process stops waiting for the ''Submit Budget'' task to be completed. \00A0And instead of proceeding on the ''Usual Path'', the process goes forward on the ''Time-Out Path'' - which executes a Script ')
||'Task ''Default Budget Submitted'' which automatically submits a default budget instead.]''',
'      ,q''[]''',
'      ,q''[Interrupting Timers can be used to close submission periods, execute time-outs, etc.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1rfb5m6" sourceRef="Activity_07yt4el" targetRef="TextAnnotation_12a9y6k" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_12bqilh">]''',
'      ,q''[      <bpmn:text>Here we have only put Timers onto Tasks - but we will see later in the tutorials that these can also be added to Sub Processes and Call Activities...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0rh9i9v" sourceRef="Activity_1qsrfjy" targetRef="TextAnnotation_12bqilh" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0597ztx">]''',
'      ,q''[      <bpmn:text>Try running through this model several times...]''',
'      ,q''[]''',
'      ,q''[If you do the Homework Quickly, No Reminder fires.]''',
'      ,q''[]''',
'      ,q''[If you leave the Homework for &gt; 20 sec, then refresh - the Reminder path will become active.]''',
'      ,q''[]''',
'      ,q''[Submit the Budget in &lt; 20 sec, take the Usual Path.]''',
'      ,q''[]''',
'      ,q''[Don''t Submit the Budget on time &amp; watch ge default get submitted instead.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_15xdauq" sourceRef="Event_02k0a5w" targetRef="TextAnnotation_0597ztx" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial_4b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_063wz8j_di" bpmnElement="Event_063wz8j">]''',
'      ,q''[        <dc:Bounds x="362" y="532" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="361" y="575" width="38" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0a56gp5_di" bpmnElement="Activity_0a56gp5" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="450" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0aiaz74_di" bpmnElement="Activity_0aiaz74" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="610" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0v5aniw_di" bpmnElement="Event_0v5aniw" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="882" y="652" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="864" y="695" width="74" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0nfsr52_di" bpmnElement="Activity_0qo0apq" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="730" y="630" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_07yt4el_di" bpmnElement="Activity_07yt4el" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="960" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1x99lgf_di" bpmnElement="Activity_1x99lgf" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1200" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1vauko0_di" bpmnElement="Gateway_1vauko0" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1445" y="525" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1qsrfjy_di" bpmnElement="Activity_1qsrfjy" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1640" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0yu2m2s_di" bpmnElement="Activity_1iauqss" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1350" y="630" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_02k0a5w_di" bpmnElement="Event_02k0a5w" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1892" y="532" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1893" y="575" width="35" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0a1jfb0_di" bpmnElement="TextAnnotation_0a1jfb0">]''',
'      ,q''[        <dc:Bounds x="480" y="60" width="700" height="152" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0o1h1es_di" bpmnElement="TextAnnotation_0o1h1es">]''',
'      ,q''[        <dc:Bounds x="580" y="250" width="550.9926147460938" height="91.98529052734375" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_16muge5_di" bpmnElement="TextAnnotation_16muge5">]''',
'      ,q''[        <dc:Bounds x="550" y="760" width="360" height="170" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_12a9y6k_di" bpmnElement="TextAnnotation_12a9y6k">]''',
'      ,q''[        <dc:Bounds x="1140" y="200" width="490" height="251" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_12bqilh_di" bpmnElement="TextAnnotation_12bqilh">]''',
'      ,q''[        <dc:Bounds x="1750" y="360" width="220" height="100" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0597ztx_di" bpmnElement="TextAnnotation_0597ztx">]''',
'      ,q''[        <dc:Bounds x="1890" y="640" width="365.9742431640625" height="174.9816131591797" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0fpbkka_di" bpmnElement="Event_1kdqlxk" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1232" y="572" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1147" y="596" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1u7uib4_di" bpmnElement="Event_0m96t82">]''',
'      ,q''[        <dc:Bounds x="642" y="572" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="542" y="596" width="76" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03t16bn_di" bpmnElement="Flow_03t16bn">]''',
'      ,q''[        <di:waypoint x="398" y="550" />]''',
'      ,q''[        <di:waypoint x="450" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1kxjxrj_di" bpmnElement="Flow_1kxjxrj">]''',
'      ,q''[        <di:waypoint x="550" y="550" />]''',
'      ,q''[        <di:waypoint x="610" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07810n8_di" bpmnElement="Flow_07810n8">]''',
'      ,q''[        <di:waypoint x="660" y="608" />]''',
'      ,q''[        <di:waypoint x="660" y="670" />]''',
'      ,q''[        <di:waypoint x="730" y="670" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_110va1r_di" bpmnElement="Flow_110va1r">]''',
'      ,q''[        <di:waypoint x="830" y="670" />]''',
'      ,q''[        <di:waypoint x="882" y="670" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_031kd26_di" bpmnElement="Flow_031kd26">]''',
'      ,q''[        <di:waypoint x="710" y="550" />]''',
'      ,q''[        <di:waypoint x="960" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wu1yf9_di" bpmnElement="Flow_0wu1yf9">]''',
'      ,q''[        <di:waypoint x="1060" y="550" />]''',
'      ,q''[        <di:waypoint x="1200" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1oasbbc_di" bpmnElement="Flow_1oasbbc">]''',
'      ,q''[        <di:waypoint x="1250" y="608" />]''',
'      ,q''[        <di:waypoint x="1250" y="670" />]''',
'      ,q''[        <di:waypoint x="1350" y="670" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1265" y="643" width="69" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mqgk8a_di" bpmnElement="Flow_1mqgk8a">]''',
'      ,q''[        <di:waypoint x="1300" y="550" />]''',
'      ,q''[        <di:waypoint x="1445" y="550" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1347" y="532" width="52" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cwunbe_di" bpmnElement="Flow_0cwunbe">]''',
'      ,q''[        <di:waypoint x="1450" y="670" />]''',
'      ,q''[        <di:waypoint x="1470" y="670" />]''',
'      ,q''[        <di:waypoint x="1470" y="575" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0mm3511_di" bpmnElement="Flow_0mm3511">]''',
'      ,q''[        <di:waypoint x="1495" y="550" />]''',
'      ,q''[        <di:waypoint x="1640" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1fsfn01_di" bpmnElement="Flow_1fsfn01">]''',
'      ,q''[        <di:waypoint x="1740" y="550" />]''',
'      ,q''[        <di:waypoint x="1892" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_09shi0r_di" bpmnElement="Association_09shi0r">]''',
'      ,q''[        <di:waypoint x="381" y="532" />]''',
'      ,q''[        <di:waypoint x="400" y="136" />]''',
'      ,q''[        <di:waypoint x="480" y="136" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_08jokvv_di" bpmnElement="Association_08jokvv">]''',
'      ,q''[        <di:waypoint x="652" y="574" />]''',
'      ,q''[        <di:waypoint x="520" y="296" />]''',
'      ,q''[        <di:waypoint x="580" y="296" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0pmrlzv_di" bpmnElement="Association_0pmrlzv">]''',
'      ,q''[        <di:waypoint x="648" y="603" />]''',
'      ,q''[        <di:waypoint x="480" y="787" />]''',
'      ,q''[        <di:waypoint x="550" y="787" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1rfb5m6_di" bpmnElement="Association_1rfb5m6">]''',
'      ,q''[        <di:waypoint x="1025" y="510" />]''',
'      ,q''[        <di:waypoint x="1090" y="340" />]''',
'      ,q''[        <di:waypoint x="1140" y="340" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0rh9i9v_di" bpmnElement="Association_0rh9i9v">]''',
'      ,q''[        <di:waypoint x="1696" y="510" />]''',
'      ,q''[        <di:waypoint x="1710" y="410" />]''',
'      ,q''[        <di:waypoint x="1750" y="410" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_15xdauq_di" bpmnElement="Association_15xdauq">]''',
'      ,q''[        <di:waypoint x="1899" y="564" />]''',
'      ,q''[        <di:waypoint x="1830" y="655" />]''',
'      ,q''[        <di:waypoint x="1890" y="655" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 4b - Reminders and Timeouts'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial4c" name="Tutorial 4c" isExecutable="false" apex:manualInput="false">]''',
'      ,q''[    <bpmn:extensionElements>]''',
'      ,q''[      <apex:dueOn>]''',
'      ,q''[        <apex:expressionType>interval</apex:expressionType>]''',
'      ,q''[      </apex:dueOn>]''',
'      ,q''[    </bpmn:extensionElements>]''',
'      ,q''[    <bpmn:startEvent id="Event_1g4stqi">]''',
'      ,q''[      <bpmn:outgoing>Flow_16pfhkf</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_04hvvpj" name="Priorities and Due Dates">]''',
'      ,q''[      <bpmn:incoming>Flow_16pfhkf</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ts4odn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_16pfhkf" sourceRef="Event_1g4stqi" targetRef="Activity_04hvvpj" />]''',
unistr('      ,q''[    <bpmn:task id="Activity_03fe5g1" name="1. \00A0Process&#10;\00A0Instance&#10;\00A0Priority and\00A0&#10;Due Date">]'''),
'      ,q''[      <bpmn:incoming>Flow_0ts4odn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1q9tj7w</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ts4odn" sourceRef="Activity_04hvvpj" targetRef="Activity_03fe5g1" />]''',
'      ,q''[    <bpmn:task id="Activity_0k5mueu" name="Setting Process Priority and Due Date">]''',
'      ,q''[      <bpmn:incoming>Flow_1q9tj7w</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_04kfywn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1q9tj7w" sourceRef="Activity_03fe5g1" targetRef="Activity_0k5mueu" />]''',
'      ,q''[    <bpmn:task id="Activity_1sx6tny" name="2 Task Priority and Due Date">]''',
'      ,q''[      <bpmn:incoming>Flow_04kfywn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1htpo8q</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_04kfywn" sourceRef="Activity_0k5mueu" targetRef="Activity_1sx6tny" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1htpo8q" sourceRef="Activity_1sx6tny" targetRef="Activity_0133nx5" />]''',
'      ,q''[    <bpmn:userTask id="Activity_0133nx5" name="Setting Task Priority and Due Date" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_1htpo8q</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1r3ufvw</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_1yl8fo0" name="End Scheduling">]''',
'      ,q''[      <bpmn:incoming>Flow_1r3ufvw</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1r3ufvw" sourceRef="Activity_0133nx5" targetRef="Event_1yl8fo0" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0t4o8e4">]''',
'      ,q''[      <bpmn:text>To be able to track and schedule process instances and tasks, you can set a PRIORITY and a DUE DATE for both a PROCESS INSTANCE and for a USER TASK.]''',
'      ,q''[]''',
'      ,q''[These values are then shown in the Task Inbox, and can be used to determine what tasks to perform next.]''',
'      ,q''[]''',
'      ,q''[We''ll start by looking at how to set PROCESS PRIORITY and DUE DATE, then look at how this can be done for a TASK...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1ltq2yb" sourceRef="Activity_04hvvpj" targetRef="TextAnnotation_0t4o8e4" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_06r02b3">]''',
unistr('      ,q''[      <bpmn:text>1. \00A0Open this model in the Flow Modeler.]'''),
unistr('      ,q''[2. \00A0Click on the background canvas behind the model - so that the properties panel shows the Process object.]'''),
unistr('      ,q''[3. \00A0Select ''Scheduling'' on the Process Properties Panel]'''),
unistr('      ,q''[4. \00A0Select ''Priority'' inside the ''Scheduling'' region.]'''),
unistr('      ,q''[5. \00A0The Priority can be set by several different methods:]'''),
'      ,q''[]''',
'      ,q''[- Static Value - Set to 1 (Highest) down to 5 (Lowest).]''',
'      ,q''[- Process Variable - Enter the name of a Process Variable that contains your chosen process priority]''',
'      ,q''[- SQL - Enter a SQL Query that can return the required priority (1-5).]''',
'      ,q''[- Expression - Enter a PL/SQL expression that returns your required process priority]''',
'      ,q''[- Function Body - Enter a PL/SQL function body that returns your required process priority.]''',
'      ,q''[]''',
'      ,q''[Remember the Priority must be between 1 (Highest) and 5 (Lowest).</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0iesp4f" sourceRef="Activity_0k5mueu" targetRef="TextAnnotation_06r02b3" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_18hjgsv">]''',
'      ,q''[      <bpmn:text>The Process Due Date can also be specified, in a similar way to the Priority.]''',
'      ,q''[]''',
unistr('      ,q''[Due Date must be specified using a TIMESTAMP WITH TIME ZONE - so that it is fully defined when the completion is required if some users or your database server is in a different time zone to some other users. \00A0]'''),
'      ,q''[]''',
'      ,q''[A Simple DATE or DATE/TIME without a specified Time Zone may be converted using the time '))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'zone of the User or with UTC time zone -- and shouldn''t be used.]''',
'      ,q''[]''',
'      ,q''[In addition to the methods for Priority, the Due Date can also be specified using these additional methods:]''',
'      ,q''[]''',
unistr('      ,q''[- As an Interval - specifying how long after start it is required to complete. \00A0 For example, an instance is due 12 Hours after it is started, or after 30 days. \00A0These intervals can be specified in Oracle Interval (Day to Second ) format:]'''),
unistr('      ,q''[\00A0 \00A0DDD HH24:MI:SS]'''),
unistr('      ,q''[\00A0 \00A0e.g., ''000 12:00:00'' or ''030 00:00:00'']'''),
'      ,q''[or in ISO 8601 Duration / Period Format format:]''',
unistr('      ,q''[\00A0 \00A0P(ddD)(T)(hh24H)(miM)(ssS)\00A0]'''),
unistr('      ,q''[\00A0 \00A0e.g., PT12H or P30D]'''),
'      ,q''[- Using Oracle Scheduler Syntax (see documentation for DBMS_SCHEDULER)</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_012d9xr" sourceRef="Activity_0k5mueu" targetRef="TextAnnotation_18hjgsv" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0810uji">]''',
'      ,q''[      <bpmn:text>Priority and Due Date can be set for User Tasks (Human Tasks).]''',
'      ,q''[]''',
unistr('      ,q''[1. \00A0Select the UserTask]'''),
unistr('      ,q''[2. \00A0In the Properties Panel for the UserTask, select ''Scheduling'']'''),
unistr('      ,q''[3. \00A0Then in the ''Scheduling'' Region, select the ''Priority'' item.]'''),
'      ,q''[]''',
'      ,q''[Same setting methods exist as for the Instance Priority.]''',
'      ,q''[]''',
'      ,q''[Note that the Process Instance priority (defining the whole process) is available to you as a Process Variable named ''PROCESS_PRIORITY''.]''',
'      ,q''[]''',
'      ,q''[So if you want the Task to have the same priority as the process instance, choose ''Process Variable'' input method, and set the Process Variable name to ''PROCESS_PRIORITY''.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_16lpjbj" sourceRef="Activity_0133nx5" targetRef="TextAnnotation_0810uji" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1yf8nam">]''',
'      ,q''[      <bpmn:text>...And similar for setting the Due Date.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1mrs5e3" sourceRef="Activity_0133nx5" targetRef="TextAnnotation_1yf8nam" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial4c">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1g4stqi_di" bpmnElement="Event_1g4stqi">]''',
'      ,q''[        <dc:Bounds x="312" y="412" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_04hvvpj_di" bpmnElement="Activity_04hvvpj" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="400" y="390" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_03fe5g1_di" bpmnElement="Activity_03fe5g1" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="560" y="390" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0k5mueu_di" bpmnElement="Activity_0k5mueu" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="720" y="390" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1sx6tny_di" bpmnElement="Activity_1sx6tny" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1110" y="390" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0d46kjr_di" bpmnElement="Activity_0133nx5" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1260" y="390" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1yl8fo0_di" bpmnElement="Event_1yl8fo0" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1412" y="412" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1391" y="455" width="78" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0t4o8e4_di" bpmnElement="TextAnnotation_0t4o8e4">]''',
'      ,q''[        <dc:Bounds x="380" y="140" width="240" height="208" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_06r02b3_di" bpmnElement="TextAnnotation_06r02b3">]''',
'      ,q''[        <dc:Bounds x="740" y="60" width="400" height="270" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_18hjgsv_di" bpmnElement="TextAnnotation_18hjgsv">]''',
'      ,q''[        <dc:Bounds x="570" y="540" width="520" height="330" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0810uji_di" bpmnElement="TextAnnotation_0810uji">]''',
'      ,q''[        <dc:Bounds x="1260" y="60" width="350" height="270" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1yf8nam_di" bpmnElement="TextAnnotation_1yf8nam">]''',
'      ,q''[        <dc:Bounds x="1260" y="540" width="100" height="54" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16pfhkf_di" bpmnElement="Flow_16pfhkf">]''',
'      ,q''[        <di:waypoint x="348" y="430" />]''',
'      ,q''[        <di:waypoint x="400" y="430" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ts4odn_di" bpmnElement="Flow_0ts4odn">]''',
'      ,q''[        <di:waypoint x="500" y="430" />]''',
'      ,q''[        <di:waypoint x="560" y="430" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1q9tj7w_di" bpmnElement="Flow_1q9tj7w">]''',
'      ,q''[        <di:waypoint x="660" y="430" />]''',
'      ,q''[        <di:waypoint x="720" y="430" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_04kfywn_di" bpmnElement="Flow_04kfywn">]''',
'      ,q''[        <di:waypoint x="820" y="430" />]''',
'      ,q''[        <di:waypoint x="1110" y="430" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1htpo8q_di" bpmnElement="Flow_1htpo8q">]''',
'      ,q''[        <di:waypoint x="1210" y="430" />]''',
'      ,q''[        <di:waypoint x="1260" y="430" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1r3ufvw_di" bpmnElement="Flow_1r3ufvw">]''',
'      ,q''[        <di:waypoint x="1360" y="430" />]''',
'      ,q''[        <di:waypoint x="1412" y="430" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1ltq2yb_di" bpmnElement="Association_1ltq2yb">]''',
'      ,q''[        <di:waypoint x="400" y="407" />]''',
'      ,q''[        <di:waypoint x="300" y="360" />]''',
'      ,q''[        <di:waypoint x="300" y="244" />]''',
'      ,q''[        <di:waypoint x="380" y="244" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0iesp4f_di" bpmnElement="Association_0iesp4f">]''',
'      ,q''[        <di:waypoint x="741" y="390" />]''',
'      ,q''[        <di:waypoint x="690" y="320" />]''',
'      ,q''[        <di:waypoint x="690" y="190" />]''',
'      ,q''[        <di:waypoint x="740" y="190" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_012d9xr_di" bpmnElement="Association_012d9xr">]''',
'      ,q''[        <di:waypoint x="727" y="469" />]''',
'      ,q''[        <di:waypoint x="670" y="520" />]''',
'      ,q''[        <di:waypoint x="450" y="520" />]''',
'      ,q''[        <di:waypoint x="450" y="690" />]''',
'      ,q''[        <di:waypoint x="570" y="690" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_16lpjbj_di" bpmnElement="Association_16lpjbj">]''',
'      ,q''[        <di:waypoint x="1264" y="393" />]''',
'      ,q''[        <di:waypoint x="1210" y="350" />]''',
'      ,q''[        <di:waypoint x="1210" y="94" />]''',
'      ,q''[        <di:waypoint x="1260" y="94" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1mrs5e3_di" bpmnElement="Association_1mrs5e3">]''',
'      ,q''[        <di:waypoint x="1310" y="470" />]''',
'      ,q''[        <di:waypoint x="1310" y="540" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 4c - Task Priority and Due Dates'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial_5a" name="Tutorial 5a - Sub Process and Call Intro" isExecutable="false" apex:isCallable="false" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_0n10060" name="Start 5a">]''',
'      ,q''[      <bpmn:outgoing>Flow_0cru3b7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1d5cwc2" name="Concept A&#10;SubProcesses&#10;...">]''',
'      ,q''[      <bpmn:incoming>Flow_0cru3b7</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_00khktj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cru3b7" sourceRef="Event_0n10060" targetRef="Activity_1d5cwc2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_00khktj" sourceRef="Activity_1d5cwc2" targetRef="Activity_0jjqteg" />]''',
'      ,q''[    <bpmn:subProcess id="Activity_0jjqteg" name="SubProcess A">]''',
'      ,q''[      <bpmn:incoming>Flow_00khktj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1k22ii5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_0qpee4j" name="Start A">]''',
'      ,q''[        <bpmn:outgoing>Flow_02xx2rl</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_1y3kmqt" name="Task A1">]''',
'      ,q''[        <bpmn:incoming>Flow_02xx2rl</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_14dpou2</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_02xx2rl" sourceRef="Event_0qpee4j" targetRef="Activity_1y3kmqt" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_14dpou2" sourceRef="Activity_1y3kmqt" targetRef="Gateway_0y4slbc" />]''',
'      ,q''[      <bpmn:task id="Activity_1qp5186" name="Task A2">]''',
'      ,q''[        <bpmn:incoming>Flow_0pxde3t</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0dd8rfg</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0pxde3t" sourceRef="Gateway_0y4slbc" targetRef="Activity_1qp5186" apex:sequence="10" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0dd8rfg" sourceRef="Activity_1qp5186" targetRef="Gateway_1hmr8e8" />]''',
'      ,q''[      <bpmn:task id="Activity_1rzmas6" name="Task A4">]''',
'      ,q''[        <bpmn:incoming>Flow_0d3u52u</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1c8xsz0</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0d3u52u" sourceRef="Gateway_1hmr8e8" targetRef="Activity_1rzmas6" apex:sequence="10" />]''',
'      ,q''[      <bpmn:endEvent id="Event_0k2oo0k" name="End A">]''',
'      ,q''[        <bpmn:incoming>Flow_1c8xsz0</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1c8xsz0" sourceRef="Activity_1rzmas6" targetRef="Event_0k2oo0k" />]''',
'      ,q''[      <bpmn:task id="Activity_1cajrr6" name="Task A3">]''',
'      ,q''[        <bpmn:incoming>Flow_0z14f0l</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1ga6zxf</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0z14f0l" sourceRef="Gateway_0y4slbc" targetRef="Activity_1cajrr6" apex:sequence="20" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1ga6zxf" sourceRef="Activity_1cajrr6" targetRef="Gateway_1hmr8e8" />]''',
'      ,q''[      <bpmn:parallelGateway id="Gateway_0y4slbc">]''',
'      ,q''[        <bpmn:incoming>Flow_14dpou2</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0pxde3t</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_0z14f0l</bpmn:outgoing>]''',
'      ,q''[      </bpmn:parallelGateway>]''',
'      ,q''[      <bpmn:parallelGateway id="Gateway_1hmr8e8">]''',
'      ,q''[        <bpmn:incoming>Flow_0dd8rfg</bpmn:incoming>]''',
'      ,q''[        <bpmn:incoming>Flow_1ga6zxf</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0d3u52u</bpmn:outgoing>]''',
'      ,q''[      </bpmn:parallelGateway>]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_Reminder" name="Reminder Timer 2 Days  (Tutorial: 20 sec)" cancelActivity="false" attachedToRef="Activity_0jjqteg">]''',
'      ,q''[      <bpmn:outgoing>Flow_0tlzczp</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0i1mhte">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT30S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0tlzczp" sourceRef="Event_Reminder" targetRef="Activity_1di1p0i" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0uzx2t9" name="Reminder Sent">]''',
'      ,q''[      <bpmn:incoming>Flow_0fcs7xz</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0fcs7xz" sourceRef="Activity_1di1p0i" targetRef="Event_0uzx2t9" />]''',
'      ,q''[    <bpmn:scriptTask id="Activity_1di1p0i" name="Reminder Email" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0tlzczp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0fcs7xz</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:task id="Activity_1nwkvy9" name="Concept 2&#10;Call Activities">]''',
'      ,q''[      <bpmn:incoming>Flow_1k22ii5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1uwqiy2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1k22ii5" sourceRef="Activity_0jjqteg" targetRef="Activity_1nwkvy9" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1uwqiy2" sourceRef="Activity_1nwkvy9" targetRef="Activity_0wtd4in" />]''',
'      ,q''[    <bpmn:callActivity id="Activity_1xsihhy" name="Call Another Process Diagram" apex:manualInput="true" apex:calledDiagram="Tutorial 5e - ship Goods (Called by Tutorial 5d)" apex:calledDiagramVersionSelection="latestVersion">]''',
'      ,q''[      <bpmn:incoming>Flow_156het6</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_18q8g04</bpmn:outgoing>]''',
'      ,q''[    </bpmn:callActivity>]''',
'      ,q''[    <bpmn:endEvent id="Event_0mwru4k" name="End Introduction">]''',
'      ,q''[      <bpmn:incoming>Flow_18q8g04</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_18q8g04" sourceRef="Activity_1xsihhy" targetRef="Event_0mwru4k" />]''',
unistr('      ,q''[    <bpmn:task id="Activity_0fgll5t" name="Concept 3\00A0&#10;CallActivities">]'''),
'      ,q''[      <bpmn:incoming>Flow_1at7slz</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_156het6</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_156het6" sourceRef="Activity_0fgll5t" targetRef="Activity_1xsihhy" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1at7slz" sourceRef="Activity_0wtd4in" targetRef="Activity_0fgll5t" />]''',
'      ,q''[    <bpmn:subProcess id="Activity_0wtd4in" name="SubProcess B">]''',
'      ,q''[      <bpmn:incoming>Flow_1uwqiy2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1at7slz</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_0tshfdq" name="SubStart">]''',
'      ,q''[        <bpmn:outgoing>Flow_0w45tev</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_0g0btwm" name="This SubProcess Detail is Hidden">]''',
'      ,q''[        <bpmn:incoming>Flow_0w45tev</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0q1id54</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0w45tev" sourceRef="Event_0tshfdq" targetRef="Activity_0g0btwm" />]''',
'      ,q''[      <bpmn:task id="Activity_0hbv0hb" name="Use the Breadcrumb Above to Return to the Main Diagram">]''',
'      ,q''[        <bpmn:incoming>Flow_0q1id54</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_04k6cvo</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0q1id54" sourceRef="Activity_0g0btwm" targetRef="Activity_0hbv0hb" />]''',
'      ,q''[      <bpmn:task id="Activity_1onwrnf" name="A SubProcess Never has its own lanes">]''',
'      ,q''[        <bpmn:incoming>Flow_04k6cvo</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_12wr52q</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_04k6cvo" sourceRef="Activity_0hbv0hb" targetRef="Activity_1onwrnf" />]''',
'      ,q''[      <bpmn:task id="Activity_08zmfgf" name="You can nest subProcesses&#10;Inside others like this...">]''',
'      ,q''[        <bpmn:incoming>Flow_12wr52q</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1p57na4</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_12wr52q" sourceRef="Activity_1onwrnf" targetRef="Activity_08zmfgf" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1p57na4" sourceRef="Activity_08zmfgf" targetRef="Activity_1cj3hot" />]''',
'      ,q''[      <bpmn:subProcess id="Activity_1cj3hot" name="My SubSubProcess">]''',
'      ,q''[        <bpmn:incoming>Flow_1p57na4</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_06oiels</bpmn:outgoing>]''',
'      ,q''[        <bpmn:startEvent id="Event_08nvmz3">]''',
'      ,q''[          <bpmn:outgoing>Flow_0pz16z7</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_02afphd" name="This is a Nested Sub Process">]''',
'      ,q''[          <bpmn:incoming>Flow_0pz16z7</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_1j8d366</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0pz16z7" sourceRef="Event_08nvmz3" targetRef="Activity_02afphd" />]''',
'      ,q''[        <bpmn:task id="Activity_1d8wtbd" name="There are no restrictions on how deep you can nest">]''',
'      ,q''[          <bpmn:incoming>Flow_1j8d366</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0d9al95</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1j8d366" sourceRef="Activity_02afphd" targetRef="Activity_1d8wtbd" />]''',
'      ,q''[        <bpmn:endEvent id="Event_0e6f3lf">]''',
'      ,q''[          <bpmn:incoming>Flow_0d9al95</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0d9al95" sourceRef="Activity_1d8wtbd" targetRef="Event_0e6f3lf" />]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[      <bpmn:endEvent id="Event_118ei9i" name="SubEnd">]''',
'      ,q''[        <bpmn:incoming>Flow_02r0ftq</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_06oiels" sourceRef="Activity_1cj3hot" targetRef="Activity_115gonw" />]''',
'      ,q''[      <bpmn:task id="Activity_115gonw" name="SubProcessess can iterate and loop - see 7f">]''',
'      ,q''[        <bpmn:incoming>Flow_06oiels</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_02r0ftq</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_02r0ftq" sourceRef="Activity_115gonw" targetRef="Event_118ei9i" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1xxo0g1">]''',
unistr('      ,q''[      <bpmn:text>Tutorial Section 5: \00A0Introduction to SubProcesses and Call Activities]'''),
'      ,q''[]''',
unistr('      ,q''[Both Sub Processes and Call Activities allow you to break your process down into subprocesses. \00A0with bpmn:subProcesses, those sub Processes are defined as part of your diagram and are only callable from within the diagram they are contained')
||unistr(' on. \00A0]'''),
'      ,q''[]''',
unistr('      ,q''[CallActivities allow you to call a different diagram as the detail of your subProcess. \00A0This allows you to reuse process components across different processes. \00A0 For example, a bank could define a model for its ''Know Your Client'' process. \00A0')
||' This process could then be built into many other process diagrams -- as a call - rather than being contained in each diagram.]''',
'      ,q''[]''',
'      ,q''[The tutorials in this section look at some of the details of Sub Processes and Call activities...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1i1gbpg" sourceRef="Event_0n10060" targetRef="TextAnnotation_1xxo0g1" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1uz56tw">]''',
'      ,q''[      <bpmn:text>This is a SubProcess]''',
'      ,q''[]''',
unistr('      ,q''[Once the subProcess becomes the current task on the main path, processing starts inside the subProcess -- starting at its Start event. \00A0When The Sub Process is complete, processing returns to the main path.]'''),
'      ,q''[]''',
unistr('      ,q''[Sub Processes can have Boundary Events set on them -- so just like a Task could have a Reminder or a TimeOut Set with Timer Boundary Events (see Tutorial 2d), so can a Sub Procedure. \00A0We''ll look at other Boundary Events in Tutorial 4c.]'''),
'      ,q''[]''',
'      ,q''[A Sub Process can only be accessed from the diagram that contains it.]''',
'      ,q''[]''',
unistr('      ,q''[This SubProcess is ''expanded'' - you can see all of the details of the subProcess from the main diagram. \00A0The next subprocess in Concet 2 shows a ''collapsed'' SubProcess.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_07bb3i9" sourceRef="Activity_0jjqteg" targetRef="TextAnnotation_1uz56tw" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0u7euj0">]''',
'      ,q''[      <bpmn:text>This is a Call Activity]''',
'      ,q''[]''',
'      ,q''[A Call activity is a link to another Process Diagram.]''',
'      ,q''[]''',
unistr('      ,q''[When the Call Activity becomes the current object in the workflow, the process then executes the process defined in that other diagram; \00A0 When the called diagram is complete, the process returns to the calling diagram and continues.]'''),
'      ,q''[]''',
unistr('      ,q''[Adding Call Activities allows processes to be shared and reused by other processes. \00A0 We''ll look into this in more detail in Tutorial 5d...</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_03losbj" sourceRef="Activity_1xsihhy" targetRef="TextAnnotation_0u7euj0" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0u2xfsn">]''',
'      ,q''[      <bpmn:text>Sub Processes can have their detail hidden in a ''Collapsed SubProcess''.]''',
'      ,q''[]''',
'      ,q''[Click on the Blue Arrow Widget to open the SubProcess Details...]''',
'      ,q''[]''',
unistr('      ,q''[Before v23.1, we discouraged use of Collapsed SubProcesses because it was hard to see the detail. \00A0 Now that you are able to drill down into the subprocess, they are a very useful tool to keep your models de-cluttered - and probably a bette')
||'r way to go!]''',
'      ,q''[]''',
unistr('      ,q''[Collapsed SubProcesses can run multiple times, once for each item in a collection. \00A0See Tutorial 7f on Iterations and Loops (requires Enterprise Edition).</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1k5eseb" sourceRef="Activity_0wtd4in" targetRef="TextAnnotation_0u2xfsn" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial_5a">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0n10060_di" bpmnElement="Event_0n10060">]''',
'      ,q''[        <dc:Bounds x="382" y="532" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="381" y="575" width="38" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1d5cwc2_di" bpmnElement="Activity_1d5cwc2" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="470" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0i0x4v2_di" bpmnElement="Activity_0jjqteg" isExpanded="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="630" y="510" width="900" height="280" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0qpee4j_di" bpmnElement="Event_0qpee4j">]''',
'      ,q''[        <dc:Bounds x="671.6666666666666" y="582" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="673" y="625" width="33" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1y3kmqt_di" bpmnElement="Activity_1y3kmqt">]''',
'      ,q''[        <dc:Bounds x="760" y="560" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1qp5186_di" bpmnElement="Activity_1qp5186">]''',
'      ,q''[        <dc:Bounds x="1020" y="560" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1rzmas6_di" bpmnElement="Activity_1rzmas6">]''',
'      ,q''[        <dc:Bounds x="1280" y="560" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0k2oo0k_di" bpmnElement="Event_0k2oo0k">]''',
'      ,q''[        <dc:Bounds x="1442" y="582" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1446" y="625" width="29" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1cajrr6_di" bpmnElement="Activity_1cajrr6">]''',
'      ,q''[        <dc:Bounds x="1020" y="670" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0e1ttb1_di" bpmnElement="Gateway_0y4slbc">]''',
'      ,q''[        <dc:Bounds x="915" y="575" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0ghj7i1_di" bpmnElement="Gateway_1hmr8e8">]''',
'      ,q''[        <dc:Bounds x="1175" y="575" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02xx2rl_di" bpmnElement="Flow_02xx2rl">]''',
'      ,q''[        <di:waypoint x="708" y="600" />]''',
'      ,q''[        <di:waypoint x="760" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_14dpou2_di" bpmnElement="Flow_14dpou2">]''',
'      ,q''[        <di:waypoint x="860" y="600" />]''',
'      ,q''[        <di:waypoint x="915" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0pxde3t_di" bpmnElement="Flow_0pxde3t">]''',
'      ,q''[        <di:waypoint x="965" y="600" />]''',
'      ,q''[        <di:waypoint x="1020" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0dd8rfg_di" bpmnElement="Flow_0dd8rfg">]''',
'      ,q''[        <di:waypoint x="1120" y="600" />]''',
'      ,q''[        <di:waypoint x="1175" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0d3u52u_di" bpmnElement="Flow_0d3u52u">]''',
'      ,q''[        <di:waypoint x="1225" y="600" />]''',
'      ,q''[        <di:waypoint x="1280" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1c8xsz0_di" bpmnElement="Flow_1c8xsz0">]''',
'      ,q''[        <di:waypoint x="1380" y="600" />]''',
'      ,q''[        <di:waypoint x="1442" y="600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0z14f0l_di" bpmnElement="Flow_0z14f0l">]''',
'      ,q''[ '))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'       <di:waypoint x="940" y="625" />]''',
'      ,q''[        <di:waypoint x="940" y="710" />]''',
'      ,q''[        <di:waypoint x="1020" y="710" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ga6zxf_di" bpmnElement="Flow_1ga6zxf">]''',
'      ,q''[        <di:waypoint x="1120" y="710" />]''',
'      ,q''[        <di:waypoint x="1200" y="710" />]''',
'      ,q''[        <di:waypoint x="1200" y="625" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0uzx2t9_di" bpmnElement="Event_0uzx2t9">]''',
'      ,q''[        <dc:Bounds x="1082" y="852" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1065" y="895" width="71" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1vz8iyg_di" bpmnElement="Activity_1di1p0i">]''',
'      ,q''[        <dc:Bounds x="930" y="830" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1nwkvy9_di" bpmnElement="Activity_1nwkvy9" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1600" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0vnal3w_di" bpmnElement="Activity_1xsihhy" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="2020" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0mwru4k_di" bpmnElement="Event_0mwru4k">]''',
'      ,q''[        <dc:Bounds x="2182" y="532" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2160" y="575" width="81" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0fgll5t_di" bpmnElement="Activity_0fgll5t" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1880" y="510" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1xm8cev_di" bpmnElement="Activity_0wtd4in" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1740" y="510" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1xxo0g1_di" bpmnElement="TextAnnotation_1xxo0g1">]''',
'      ,q''[        <dc:Bounds x="480" y="150" width="463" height="250" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1uz56tw_di" bpmnElement="TextAnnotation_1uz56tw">]''',
'      ,q''[        <dc:Bounds x="1040" y="140" width="370" height="264" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0u7euj0_di" bpmnElement="TextAnnotation_0u7euj0">]''',
'      ,q''[        <dc:Bounds x="2050" y="130" width="349.9883180023521" height="180.6334792926747" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0u2xfsn_di" bpmnElement="TextAnnotation_0u2xfsn">]''',
'      ,q''[        <dc:Bounds x="1530" y="150" width="389.99944217438957" height="197.0693355172924" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_18tk28b_di" bpmnElement="Event_Reminder">]''',
'      ,q''[        <dc:Bounds x="842" y="772" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="767" y="815" width="85" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cru3b7_di" bpmnElement="Flow_0cru3b7">]''',
'      ,q''[        <di:waypoint x="418" y="550" />]''',
'      ,q''[        <di:waypoint x="470" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_00khktj_di" bpmnElement="Flow_00khktj">]''',
'      ,q''[        <di:waypoint x="570" y="550" />]''',
'      ,q''[        <di:waypoint x="630" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0tlzczp_di" bpmnElement="Flow_0tlzczp">]''',
'      ,q''[        <di:waypoint x="860" y="808" />]''',
'      ,q''[        <di:waypoint x="860" y="870" />]''',
'      ,q''[        <di:waypoint x="930" y="870" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0fcs7xz_di" bpmnElement="Flow_0fcs7xz">]''',
'      ,q''[        <di:waypoint x="1030" y="870" />]''',
'      ,q''[        <di:waypoint x="1082" y="870" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1k22ii5_di" bpmnElement="Flow_1k22ii5">]''',
'      ,q''[        <di:waypoint x="1530" y="550" />]''',
'      ,q''[        <di:waypoint x="1600" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1uwqiy2_di" bpmnElement="Flow_1uwqiy2">]''',
'      ,q''[        <di:waypoint x="1700" y="550" />]''',
'      ,q''[        <di:waypoint x="1740" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_18q8g04_di" bpmnElement="Flow_18q8g04">]''',
'      ,q''[        <di:waypoint x="2120" y="550" />]''',
'      ,q''[        <di:waypoint x="2182" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_156het6_di" bpmnElement="Flow_156het6">]''',
'      ,q''[        <di:waypoint x="1980" y="550" />]''',
'      ,q''[        <di:waypoint x="2020" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1at7slz_di" bpmnElement="Flow_1at7slz">]''',
'      ,q''[        <di:waypoint x="1840" y="550" />]''',
'      ,q''[        <di:waypoint x="1880" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1i1gbpg_di" bpmnElement="Association_1i1gbpg">]''',
'      ,q''[        <di:waypoint x="403" y="533" />]''',
'      ,q''[        <di:waypoint x="460" y="240" />]''',
'      ,q''[        <di:waypoint x="480" y="240" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_07bb3i9_di" bpmnElement="Association_07bb3i9">]''',
'      ,q''[        <di:waypoint x="1023" y="510" />]''',
'      ,q''[        <di:waypoint x="990" y="430" />]''',
'      ,q''[        <di:waypoint x="990" y="252" />]''',
'      ,q''[        <di:waypoint x="1011" y="273" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_03losbj_di" bpmnElement="Association_03losbj">]''',
'      ,q''[        <di:waypoint x="2064" y="510" />]''',
'      ,q''[        <di:waypoint x="2010" y="220" />]''',
'      ,q''[        <di:waypoint x="2050" y="220" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1k5eseb_di" bpmnElement="Association_1k5eseb">]''',
'      ,q''[        <di:waypoint x="1773" y="510" />]''',
'      ,q''[        <di:waypoint x="1706" y="347" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1fi6zbm">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0p5b20p" bpmnElement="Activity_0wtd4in">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0tshfdq_di" bpmnElement="Event_0tshfdq" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-838" y="-218" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-841" y="-175" width="43" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0g0btwm_di" bpmnElement="Activity_0g0btwm" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-750" y="-240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0hbv0hb_di" bpmnElement="Activity_0hbv0hb" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-590" y="-240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1onwrnf_di" bpmnElement="Activity_1onwrnf" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-430" y="-240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_08zmfgf_di" bpmnElement="Activity_08zmfgf" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-270" y="-240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1dmnljq_di" bpmnElement="Activity_1cj3hot">]''',
'      ,q''[        <dc:Bounds x="-110" y="-240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_118ei9i_di" bpmnElement="Event_118ei9i">]''',
'      ,q''[        <dc:Bounds x="242" y="-218" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="240" y="-175" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_115gonw_di" bpmnElement="Activity_115gonw" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="20" y="-240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0w45tev_di" bpmnElement="Flow_0w45tev">]''',
'      ,q''[        <di:waypoint x="-802" y="-200" />]''',
'      ,q''[        <di:waypoint x="-750" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0q1id54_di" bpmnElement="Flow_0q1id54">]''',
'      ,q''[        <di:waypoint x="-650" y="-200" />]''',
'      ,q''[        <di:waypoint x="-590" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_04k6cvo_di" bpmnElement="Flow_04k6cvo">]''',
'      ,q''[        <di:waypoint x="-490" y="-200" />]''',
'      ,q''[        <di:waypoint x="-430" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12wr52q_di" bpmnElement="Flow_12wr52q">]''',
'      ,q''[        <di:waypoint x="-330" y="-200" />]''',
'      ,q''[        <di:waypoint x="-270" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1p57na4_di" bpmnElement="Flow_1p57na4">]''',
'      ,q''[        <di:waypoint x="-170" y="-200" />]''',
'      ,q''[        <di:waypoint x="-110" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_06oiels_di" bpmnElement="Flow_06oiels">]''',
'      ,q''[        <di:waypoint x="-10" y="-200" />]''',
'      ,q''[        <di:waypoint x="20" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02r0ftq_di" bpmnElement="Flow_02r0ftq">]''',
'      ,q''[        <di:waypoint x="120" y="-200" />]''',
'      ,q''[        <di:waypoint x="242" y="-200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1wj8tqa">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1f6wxmv" bpmnElement="Activity_1cj3hot">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_08nvmz3_di" bpmnElement="Event_08nvmz3">]''',
'      ,q''[        <dc:Bounds x="-738" y="-198" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_02afphd_di" bpmnElement="Activity_02afphd">]''',
'      ,q''[        <dc:Bounds x="-650" y="-220" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1d8wtbd_di" bpmnElement="Activity_1d8wtbd">]''',
'      ,q''[        <dc:Bounds x="-490" y="-220" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0e6f3lf_di" bpmnElement="Event_0e6f3lf">]''',
'      ,q''[        <dc:Bounds x="-328" y="-198" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0pz16z7_di" bpmnElement="Flow_0pz16z7">]''',
'      ,q''[        <di:waypoint x="-702" y="-180" />]''',
'      ,q''[        <di:waypoint x="-650" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1j8d366_di" bpmnElement="Flow_1j8d366">]''',
'      ,q''[        <di:waypoint x="-550" y="-180" />]''',
'      ,q''[        <di:waypoint x="-490" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0d9al95_di" bpmnElement="Flow_0d9al95">]''',
'      ,q''[        <di:waypoint x="-390" y="-180" />]''',
'      ,q''[        <di:waypoint x="-328" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 5a - Structure your Process with Sub Processes and Calls'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Tutorial_05b" name="Tutorial - Introducing Sub Processes" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_0iygv59">]''',
'      ,q''[      <bpmn:outgoing>Flow_1gz0sgq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_13yt1ft" name="Tutorial 5b&#10;SubProcesses">]''',
'      ,q''[      <bpmn:incoming>Flow_1gz0sgq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ha31js</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1gz0sgq" sourceRef="Event_0iygv59" targetRef="Activity_13yt1ft" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ha31js" sourceRef="Activity_13yt1ft" targetRef="Activity_1lt3f7j" />]''',
'      ,q''[    <bpmn:subProcess id="Activity_1lt3f7j" name="SubProcess B">]''',
'      ,q''[      <bpmn:incoming>Flow_1ha31js</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1trgt3r</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_0j57auc" name="A subProcess Starts&#10;with a Start Event">]''',
'      ,q''[        <bpmn:outgoing>Flow_1bfswcs</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_0kcgja9" name="B1">]''',
'      ,q''[        <bpmn:incoming>Flow_1bfswcs</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1dfsgk8</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1bfswcs" sourceRef="Event_0j57auc" targetRef="Activity_0kcgja9" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1dfsgk8" sourceRef="Activity_0kcgja9" targetRef="Gateway_0tapl6i" />]''',
'      ,q''[      <bpmn:parallelGateway id="Gateway_0tapl6i" name="B Split">]''',
'      ,q''[        <bpmn:incoming>Flow_1dfsgk8</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_14jrwrx</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_0sw8mct</bpmn:outgoing>]''',
'      ,q''[      </bpmn:parallelGateway>]''',
'      ,q''[      <bpmn:task id="Activity_1n7m2kj" name="B2">]''',
'      ,q''[        <bpmn:incoming>Flow_14jrwrx</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0l8zsga</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_14jrwrx" sourceRef="Gateway_0tapl6i" targetRef="Activity_1n7m2kj" />]''',
'      ,q''[      <bpmn:task id="Activity_1ox4cmk" name="B3">]''',
'      ,q''[        <bpmn:incoming>Flow_0l8zsga</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1smtq7r</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0l8zsga" sourceRef="Activity_1n7m2kj" targetRef="Activity_1ox4cmk" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1v77s5u" name="B2 B3 End">]''',
'      ,q''[        <bpmn:incoming>Flow_1smtq7r</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1smtq7r" sourceRef="Activity_1ox4cmk" targetRef="Event_1v77s5u" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0sw8mct" sourceRef="Gateway_0tapl6i" targetRef="Activity_1l75ys0" />]''',
'      ,q''[      <bpmn:subProcess id="Activity_1l75ys0" name="SubProcess B4">]''',
'      ,q''[        <bpmn:incoming>Flow_0sw8mct</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0dxi3lp</bpmn:outgoing>]''',
'      ,q''[        <bpmn:startEvent id="Event_094xygx" name="B4 Start">]''',
'      ,q''[          <bpmn:outgoing>Flow_1ji74dg</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_1rct9yd" name="B4A">]''',
'      ,q''[          <bpmn:incoming>Flow_1ji74dg</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0lkjrzz</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1ji74dg" sourceRef="Event_094xygx" targetRef="Activity_1rct9yd" />]''',
'      ,q''[        <bpmn:task id="Activity_1nqf2t2" name="B4B">]''',
'      ,q''[          <bpmn:incoming>Flow_0lkjrzz</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0t7vhh2</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0lkjrzz" sourceRef="Activity_1rct9yd" targetRef="Activity_1nqf2t2" />]''',
'      ,q''[        <bpmn:endEvent id="Event_0ytprrh" name="B4 end">]''',
'      ,q''[          <bpmn:incoming>Flow_0t7vhh2</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0t7vhh2" sourceRef="Activity_1nqf2t2" targetRef="Event_0ytprrh" />]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[      <bpmn:task id="Activity_0ems563" name="B5">]''',
'      ,q''[        <bpmn:incoming>Flow_0dxi3lp</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_03kjiig</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0dxi3lp" sourceRef="Activity_1l75ys0" targetRef="Activity_0ems563" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1mr01vo" name="B4 B5 end">]''',
'      ,q''[        <bpmn:incoming>Flow_03kjiig</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_03kjiig" sourceRef="Activity_0ems563" targetRef="Event_1mr01vo" />]''',
'      ,q''[      <bpmn:textAnnotation id="TextAnnotation_0mjqcjn">]''',
'      ,q''[        <bpmn:text>All of the active subflows have to complete for the sub process to complete, and then return to the parent subflow.</bpmn:text>]''',
'      ,q''[      </bpmn:textAnnotation>]''',
'      ,q''[      <bpmn:association id="Association_0n233kd" sourceRef="Event_1v77s5u" targetRef="TextAnnotation_0mjqcjn" />]''',
'      ,q''[      <bpmn:textAnnotation id="TextAnnotation_09hooly">]''',
'      ,q''[        <bpmn:text>SubProcesses can be Nested</bpmn:text>]''',
'      ,q''[      </bpmn:textAnnotation>]''',
'      ,q''[      <bpmn:association id="Association_0tslhea" sourceRef="Activity_1l75ys0" targetRef="TextAnnotation_09hooly" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:task id="Activity_0n0h791" name="C">]''',
'      ,q''[      <bpmn:incoming>Flow_1trgt3r</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wppxk7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1trgt3r" sourceRef="Activity_1lt3f7j" targetRef="Activity_0n0h791" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1h0lzcv" name="End">]''',
'      ,q''[      <bpmn:incoming>Flow_0wppxk7</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wppxk7" sourceRef="Activity_0n0h791" targetRef="Event_1h0lzcv" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0m1p9cx">]''',
'      ,q''[      <bpmn:text>Tutorial 5b - Sub Processes]''',
'      ,q''[]''',
'      ,q''[A Sub Process is defined inside the diagram that it is used on.]''',
'      ,q''[]''',
unistr('      ,q''[Sub Processes can encapsulate part of your business process, hiding the details when necessary. \00A0This diagram shows an expanded subprocess - where you can see the inside steps on the same page as the parent - but you could also draw this us')
||'ing collapsed sub processes, where the inside details of the parent subprocess are not visible on the parent page.]''',
'      ,q''[]''',
'      ,q''[Run this model and look carefully to see how the subflows come and go, and what waits for what!</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0ccwauj" sourceRef="Activity_1lt3f7j" targetRef="TextAnnotation_0m1p9cx" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Tutorial_05b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0iygv59_di" bpmnElement="Event_0iygv59">]''',
'      ,q''[        <dc:Bounds x="242" y="292" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_13yt1ft_di" bpmnElement="Activity_13yt1ft" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="330" y="270" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0x9pws1_di" bpmnElement="Activity_1lt3f7j" isExpanded="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="530" y="210" width="1170" height="480" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0j57auc_di" bpmnElement="Event_0j57auc">]''',
'      ,q''[        <dc:Bounds x="561.6666666666666" y="312" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="537" y="355" width="87" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0kcgja9_di" bpmnElement="Activity_0kcgja9">]''',
'      ,q''[        <dc:Bounds x="650" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0iissxc_di" bpmnElement="Gateway_0tapl6i">]''',
'      ,q''[        <dc:Bounds x="805" y="305" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="784" y="293" width="32" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1n7m2kj_di" bpmnElement="Activity_1n7m2kj">]''',
'      ,q''[        <dc:Bounds x="910" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ox4cmk_di" bpmnElement="Activity_1ox4cmk">]''',
'      ,q''[        <dc:Bounds x="1070" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1v77s5u_di" bpmnElement="Event_1v77s5u">]''',
'      ,q''[        <dc:Bounds x="1602" y="312" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1594" y="355" width="53" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_19cs6tz_di" bpmnElement="Activity_1l75ys0" isExpanded="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="900" y="410" width="500" height="160" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_094xygx_di" bpmnElement="Event_094xygx">]''',
'      ,q''[        <dc:Bounds x="931.6666666666666" y="472" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="930" y="515" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1rct9yd_di" bpmnElement="Activity_1rct9yd">]''',
'      ,q''[        <dc:Bounds x="1020" y="450" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1nqf2t2_di" bpmnElement="Activity_1nqf2t2">]''',
'      ,q''[        <dc:Bounds x="1180" y="450" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0ytprrh_di" bpmnElement="Event_0ytprrh">]''',
'      ,q''[        <dc:Bounds x="1342" y="472" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1343" y="515" width="35" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ji74dg_di" bpmnElement="Flow_1ji74dg">]''',
'      ,q''[        <di:waypoint x="968" y="490" />]''',
'      ,q''[        <di:waypoint x="1020" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0lkjrzz_di" bpmnElement="Flow_0lkjrzz">]''',
'      ,q''[        <di:waypoint x="1120" y="490" />]''',
'      ,q''[        <di:waypoint x="1180" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0t7vhh2_di" bpmnElement="Flow_0t7vhh2">]''',
'      ,q''[        <di:waypoint x="1280" y="490" />]''',
'      ,q''[        <di:waypoint x="1342" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ems563_di" bpmnElement="Activity_0ems563">]''',
'      ,q''[        <dc:Bounds x="1450" y="450" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1mr01vo_di" bpmnElement="Event_1mr01vo">]''',
'      ,q''[        <dc:Bounds x="1602" y="472" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1594" y="515" width="52" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0mjqcjn_di" bpmnElement="TextAnnotation_0mjqcjn">]''',
'      ,q''[        <dc:Bounds x="1390" y="230" width="248" height="54" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_09hooly_di" bpmnElement="TextAnnotation_09hooly">]''',
'      ,q''[        <dc:Bounds x="1100" y="610" width="100" height="40" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1bfswcs_di" bpmnElement="Flow_1bfswcs">]''',
'      ,q''[        <di:waypoint x="598" y="330" />]''',
'      ,q''[        <di:waypoint x="650" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dfsgk8_di" bpmnElement="Flow_1dfsgk8">]''',
'      ,q''[        <di:waypoint x="750" y="330" />]''',
'      ,q''[        <di:waypoint x="805" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_14jrwrx_di" bpmnElement="Flow_14jrwrx">]''',
'      ,q''[        <di:waypoint x="855" y="330" />]''',
'      ,q''[        <di:waypoint x="910" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0l8zsga_di" bpmnElement="Flow_0l8zsga">]''',
'      ,q''[        <di:waypoint x="1010" y="330" />]''',
'      ,q''[        <di:waypoint x="1070" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1smtq7r_di" bpmnElement="Flow_1smtq7r">]''',
'      ,q''[        <di:waypoint x="1170" y="330" />]''',
'      ,q''[        <di:waypoint x="1602" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0sw8mct_di" bpmnElement="Flow_0sw8mct">]''',
'      ,q''[        <di:waypoint x="830" y="355" />]''',
'      ,q''[        <di:waypoint x="830" y="450" />]''',
'      ,q''[        <di:waypoint x="900" y="450" />]''',
'      ,q''[      </bpmndi:BPMNE'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'dge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0dxi3lp_di" bpmnElement="Flow_0dxi3lp">]''',
'      ,q''[        <di:waypoint x="1400" y="490" />]''',
'      ,q''[        <di:waypoint x="1450" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03kjiig_di" bpmnElement="Flow_03kjiig">]''',
'      ,q''[        <di:waypoint x="1550" y="490" />]''',
'      ,q''[        <di:waypoint x="1602" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0n233kd_di" bpmnElement="Association_0n233kd">]''',
'      ,q''[        <di:waypoint x="1617" y="313" />]''',
'      ,q''[        <di:waypoint x="1611" y="284" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0tslhea_di" bpmnElement="Association_0tslhea">]''',
'      ,q''[        <di:waypoint x="1150" y="570" />]''',
'      ,q''[        <di:waypoint x="1150" y="610" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0n0h791_di" bpmnElement="Activity_0n0h791">]''',
'      ,q''[        <dc:Bounds x="1800" y="440" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1h0lzcv_di" bpmnElement="Event_1h0lzcv">]''',
'      ,q''[        <dc:Bounds x="1962" y="462" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1970" y="505" width="20" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0ccwauj_di" bpmnElement="Association_0ccwauj">]''',
'      ,q''[        <di:waypoint x="992" y="210" />]''',
'      ,q''[        <di:waypoint x="976" y="180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gz0sgq_di" bpmnElement="Flow_1gz0sgq">]''',
'      ,q''[        <di:waypoint x="278" y="310" />]''',
'      ,q''[        <di:waypoint x="330" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ha31js_di" bpmnElement="Flow_1ha31js">]''',
'      ,q''[        <di:waypoint x="430" y="310" />]''',
'      ,q''[        <di:waypoint x="530" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1trgt3r_di" bpmnElement="Flow_1trgt3r">]''',
'      ,q''[        <di:waypoint x="1700" y="480" />]''',
'      ,q''[        <di:waypoint x="1800" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wppxk7_di" bpmnElement="Flow_0wppxk7">]''',
'      ,q''[        <di:waypoint x="1900" y="480" />]''',
'      ,q''[        <di:waypoint x="1962" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0m1p9cx_di" bpmnElement="TextAnnotation_0m1p9cx">]''',
'      ,q''[        <dc:Bounds x="820" y="0" width="629.9874206625337" height="179.98592155343286" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 5b - Introducing Sub Processes'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Tutorial5c" name="Tutorial 5c - SubProcess Errors and Escalations" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:startEvent id="Event_0iygv59">]''',
'      ,q''[      <bpmn:outgoing>Flow_1gz0sgq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_13yt1ft" name="Tutorial 5c&#10;SubProcess Errors and Escalations">]''',
'      ,q''[      <bpmn:incoming>Flow_1gz0sgq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ha31js</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1gz0sgq" sourceRef="Event_0iygv59" targetRef="Activity_13yt1ft" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ha31js" sourceRef="Activity_13yt1ft" targetRef="Activity_1lt3f7j" />]''',
'      ,q''[    <bpmn:subProcess id="Activity_1lt3f7j" name="SubProcess B">]''',
'      ,q''[      <bpmn:incoming>Flow_1ha31js</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1trgt3r</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_0j57auc" name="A subProcess Starts&#10;with a Start Event">]''',
'      ,q''[        <bpmn:outgoing>Flow_1bfswcs</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_0kcgja9" name="B1">]''',
'      ,q''[        <bpmn:incoming>Flow_1bfswcs</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1dfsgk8</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1bfswcs" sourceRef="Event_0j57auc" targetRef="Activity_0kcgja9" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1dfsgk8" sourceRef="Activity_0kcgja9" targetRef="Gateway_0tapl6i" />]''',
'      ,q''[      <bpmn:parallelGateway id="Gateway_0tapl6i" name="B Split">]''',
'      ,q''[        <bpmn:incoming>Flow_1dfsgk8</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_14jrwrx</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_0sw8mct</bpmn:outgoing>]''',
'      ,q''[      </bpmn:parallelGateway>]''',
'      ,q''[      <bpmn:task id="Activity_1n7m2kj" name="B2">]''',
'      ,q''[        <bpmn:incoming>Flow_14jrwrx</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0l8zsga</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_14jrwrx" sourceRef="Gateway_0tapl6i" targetRef="Activity_1n7m2kj" />]''',
'      ,q''[      <bpmn:task id="Activity_1ox4cmk" name="B3">]''',
'      ,q''[        <bpmn:incoming>Flow_0l8zsga</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1smtq7r</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0l8zsga" sourceRef="Activity_1n7m2kj" targetRef="Activity_1ox4cmk" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1v77s5u" name="B2 B3 B6 End">]''',
'      ,q''[        <bpmn:incoming>Flow_1o2xxi5</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1smtq7r" sourceRef="Activity_1ox4cmk" targetRef="Gateway_0okheq5" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0sw8mct" sourceRef="Gateway_0tapl6i" targetRef="Activity_1l75ys0" />]''',
'      ,q''[      <bpmn:subProcess id="Activity_1l75ys0" name="SubProcess B4">]''',
'      ,q''[        <bpmn:incoming>Flow_0sw8mct</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0dxi3lp</bpmn:outgoing>]''',
'      ,q''[        <bpmn:startEvent id="Event_094xygx" name="B4 Start">]''',
'      ,q''[          <bpmn:outgoing>Flow_1ji74dg</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_1rct9yd" name="B4A">]''',
'      ,q''[          <bpmn:incoming>Flow_1ji74dg</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0lkjrzz</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1ji74dg" sourceRef="Event_094xygx" targetRef="Activity_1rct9yd" />]''',
'      ,q''[        <bpmn:task id="Activity_1nqf2t2" name="B4B">]''',
'      ,q''[          <bpmn:incoming>Flow_1x95h95</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0t7vhh2</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0lkjrzz" sourceRef="Activity_1rct9yd" targetRef="Gateway_0qtnlf2" />]''',
'      ,q''[        <bpmn:endEvent id="Event_0ytprrh" name="B4 end">]''',
'      ,q''[          <bpmn:incoming>Flow_0t7vhh2</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0t7vhh2" sourceRef="Activity_1nqf2t2" targetRef="Event_0ytprrh" />]''',
'      ,q''[        <bpmn:exclusiveGateway id="Gateway_0qtnlf2" name="Anything really bad?" default="Flow_18i162p">]''',
'      ,q''[          <bpmn:incoming>Flow_0lkjrzz</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_1x95h95</bpmn:outgoing>]''',
'      ,q''[          <bpmn:outgoing>Flow_18i162p</bpmn:outgoing>]''',
'      ,q''[        </bpmn:exclusiveGateway>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1x95h95" name="N" sourceRef="Gateway_0qtnlf2" targetRef="Activity_1nqf2t2" apex:sequence="20" />]''',
'      ,q''[        <bpmn:task id="Activity_1ummob2" name="B4 Pre-Error Step">]''',
'      ,q''[          <bpmn:incoming>Flow_18i162p</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_1e22oat</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_18i162p" name="Y" sourceRef="Gateway_0qtnlf2" targetRef="Activity_1ummob2" apex:sequence="30" />]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1e22oat" sourceRef="Activity_1ummob2" targetRef="Event_185dh52" />]''',
'      ,q''[        <bpmn:endEvent id="Event_185dh52" name="B4 Error End">]''',
'      ,q''[          <bpmn:incoming>Flow_1e22oat</bpmn:incoming>]''',
'      ,q''[          <bpmn:errorEventDefinition id="ErrorEventDefinition_1jh4n0h" />]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[      <bpmn:task id="Activity_0ems563" name="B5">]''',
'      ,q''[        <bpmn:incoming>Flow_0dxi3lp</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_03kjiig</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0dxi3lp" sourceRef="Activity_1l75ys0" targetRef="Activity_0ems563" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1mr01vo" name="B4 B5 end">]''',
'      ,q''[        <bpmn:incoming>Flow_03kjiig</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_03kjiig" sourceRef="Activity_0ems563" targetRef="Event_1mr01vo" />]''',
'      ,q''[      <bpmn:exclusiveGateway id="Gateway_0okheq5" name="Everything OK?" default="Flow_1n7yz35">]''',
'      ,q''[        <bpmn:incoming>Flow_1smtq7r</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_00jpo2b</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_1n7yz35</bpmn:outgoing>]''',
'      ,q''[      </bpmn:exclusiveGateway>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_00jpo2b" name="Yes" sourceRef="Gateway_0okheq5" targetRef="Activity_0ksy34k" apex:sequence="20" />]''',
'      ,q''[      <bpmn:task id="Activity_0ksy34k" name="B6">]''',
'      ,q''[        <bpmn:incoming>Flow_00jpo2b</bpmn:incoming>]''',
'      ,q''[        <bpmn:incoming>Flow_01yn0la</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1o2xxi5</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1o2xxi5" sourceRef="Activity_0ksy34k" targetRef="Event_1v77s5u" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1n7yz35" sourceRef="Gateway_0okheq5" targetRef="Event_1yflz91" apex:sequence="30" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_01yn0la" sourceRef="Event_1yflz91" targetRef="Activity_0ksy34k" />]''',
'      ,q''[      <bpmn:intermediateThrowEvent id="Event_1yflz91" name="Throw Escalation Event">]''',
'      ,q''[        <bpmn:incoming>Flow_1n7yz35</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_01yn0la</bpmn:outgoing>]''',
'      ,q''[        <bpmn:escalationEventDefinition id="EscalationEventDefinition_1todiyv" />]''',
'      ,q''[      </bpmn:intermediateThrowEvent>]''',
'      ,q''[      <bpmn:boundaryEvent id="Event_0ilybau" name="Interrupting Error Boundary Event" attachedToRef="Activity_1l75ys0">]''',
'      ,q''[        <bpmn:outgoing>Flow_0rzsiz6</bpmn:outgoing>]''',
'      ,q''[        <bpmn:errorEventDefinition id="ErrorEventDefinition_13fuvpw" />]''',
'      ,q''[      </bpmn:boundaryEvent>]''',
'      ,q''[      <bpmn:task id="Activity_0czq539" name="Process Error Handler">]''',
'      ,q''[        <bpmn:incoming>Flow_0rzsiz6</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0pw6aqw</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0rzsiz6" sourceRef="Event_0ilybau" targetRef="Activity_0czq539" apex:sequence="10" />]''',
'      ,q''[      <bpmn:endEvent id="Event_0jj0hcj" name="B4 Bad End">]''',
'      ,q''[        <bpmn:incoming>Flow_0pw6aqw</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0pw6aqw" sourceRef="Activity_0czq539" targetRef="Event_0jj0hcj" />]''',
'      ,q''[      <bpmn:textAnnotation id="TextAnnotation_0mjqcjn">]''',
'      ,q''[        <bpmn:text>All of the active subflows have to complete for the sub process to complete, and then return to the parent subflow.</bpmn:text>]''',
'      ,q''[      </bpmn:textAnnotation>]''',
'      ,q''[      <bpmn:association id="Association_0n233kd" sourceRef="Event_1v77s5u" targetRef="TextAnnotation_0mjqcjn" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:task id="Activity_0n0h791" name="C">]''',
'      ,q''[      <bpmn:incoming>Flow_1trgt3r</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wppxk7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1trgt3r" sourceRef="Activity_1lt3f7j" targetRef="Activity_0n0h791" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1h0lzcv" name="End">]''',
'      ,q''[      <bpmn:incoming>Flow_0wppxk7</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wppxk7" sourceRef="Activity_0n0h791" targetRef="Event_1h0lzcv" />]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_05m9taf" name="Non-Interrupting Escalation Catch Event" cancelActivity="false" attachedToRef="Activity_1lt3f7j">]''',
'      ,q''[      <bpmn:outgoing>Flow_0oc2x09</bpmn:outgoing>]''',
'      ,q''[      <bpmn:escalationEventDefinition id="EscalationEventDefinition_157jo9p" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0oc2x09" sourceRef="Event_05m9taf" targetRef="Activity_1mbzten" />]''',
'      ,q''[    <bpmn:serviceTask id="Activity_1b9ghnl" name="Email Manager for Help" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1wddzwq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0jim7nk</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_099tlz0" name="Escalation Handler End">]''',
'      ,q''[      <bpmn:incoming>Flow_0jim7nk</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0jim7nk" sourceRef="Activity_1b9ghnl" targetRef="Event_099tlz0" />]''',
'      ,q''[    <bpmn:task id="Activity_1mbzten" name="This gets started in Parallel when escalated...">]''',
'      ,q''[      <bpmn:incoming>Flow_0oc2x09</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1wddzwq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1wddzwq" sourceRef="Activity_1mbzten" targetRef="Activity_1b9ghnl" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0m1p9cx">]''',
'      ,q''[      <bpmn:text>Tutorial 6 - Introducing Escalations and Error Events]''',
'      ,q''[]''',
'      ,q''[Let''s build on our Sub Process Model.]''',
'      ,q''[]''',
unistr('      ,q''[Escalations are used when a process has a warning, or something happens when you need to bring in an extra process to help.\00A0]'''),
'      ,q''[]''',
unistr('      ,q''[We use an Escalation Intermediate Throw Event between B3 and B6 to signal that we have an escalation.\00A0The escalation is caught by the Non-Interrupting Escalation Boundary Event on the sub process boundary, where our escalation handling proc')
||unistr('ess is defined.\00A0This is non-interrupting - so the main process continues.\00A0]'''),
'      ,q''[]''',
'      ,q''[Escalations can be non-interrupting (usual) or can interrupt the process.]''',
'      ,q''[]''',
'      ,q''[Sub process B4 has an Error End Event - so in this tutorial it always ends with an error - which interrupts the sub-process, and passes control to the error handler if you have one defined.]''',
'      ,q''[]''',
'      ,q''[Note that we''re talking about business process Escalations (and Errors) here - not technical escalations (or errors!).]''',
'      ,q''[]''',
unistr('      ,q''[Error Events and Escalation Events can be used to send Errors and Escalations from inside a SubProcess or CallActivity to their Calling Process Level. \00A0They are only used with SubProcesses and CallActivities.]'''),
'      ,q''[]''',
'      ,q''[So here the Error End Event (Pink) throws an Error to the Error Boundary Event (Pink) resulting in SubProcess B4 taking a different End path if an error is signalled.]''',
'      ,q''[]''',
unistr('      ,q''[And the Escalation Throw Event (Purple) in SubProcess B throws an escalation which is caught by the non-interrupting escalation catch event on the outside of SubProcess B, (Purple) - causing the\00A0]'''),
'      ,q''[purple path to execute</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0ccwauj" sourceRef="Activity_1lt3f7j" targetRef="TextAnnotation_0m1p9cx" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Tutorial5c">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0iygv59_di" bpmnElement="Event_0iygv59">]''',
'      ,q''[        <dc:Bounds x="242" y="292" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_13yt1ft_di" bpmnElement="Activity_13yt1ft">]''',
'      ,q''[        <dc:Bounds x="330" y="270" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0x9pws1_di" bpmnElement="Activity_1lt3f7j" isExpanded="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="530" y="210" width="1170" height="600" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0j57auc_di" bpmnElement="Event_0j57auc">]''',
'      ,q''[        <dc:Bounds x="561.6666666666666" y="312" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="537" y="355" width="87" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0kcgja9_di" bpmnElement="Activity_0kcgja9">]''',
'      ,q''[        <dc:Bounds x="650" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0iissxc_di" bpmnElement="Gateway_0tapl6i">]''',
'      ,q''[        <dc:Bounds x="805" y="305" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="784" y="293" width="32" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1n7m2kj_di" bpmnElement="Activity_1n7m2kj">]''',
'      ,q''[        <dc:Bounds x="910" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ox4cmk_di" bpmnElement="Activity_1ox4cmk">]''',
'      ,q''[        <dc:Bounds x="1070" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1v77s5u_di" bpmnElement="Event_1v77s5u">]''',
'      ,q''[        <dc:Bounds x="1602" y="312" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1586" y="355" width="70" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_19cs6tz_di" bpmnElement="Activity_1l75ys0" isExpanded="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="770" y="510" width="640" height="250" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_094xygx_di" bpmnElement="Event_094xygx">]''',
'      ,q''[        <dc:Bounds x="802" y="572" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="800" y="615" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1rct9yd_di" bpmnElement="Activity_1rct9yd">]''',
'      ,q''[        <dc:Bounds x="900" y="550" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1nqf2t2_di" bpmnElement="Activity_1nqf2t2">]''',
'      ,q''[        <dc:Bounds x="1170" y="550" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0ytprrh_di" bpmnElement="Event_0ytprrh">]''',
'      ,q''[        <dc:Bounds x="1342" y="572" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1343" y="615" width="35" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0qtnlf2_di" bpmnElement="Gateway_0qtnlf2" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1055" y="565" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1078" y="546" width="73" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ummob2_di" bpmnElement="Activity_1ummob2">]''',
'      ,q''[        <dc:Bounds x="1120" y="660" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0ppaw77_di" bpmnElement="Event_185dh52" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1272" y="682" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1258" y="725" width="64" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ji74dg_di" bpmnElement="Flow_1ji74dg">]''',
'      ,q''[        <di:waypoint x="838" y="590" />]''',
'      ,q''[        <di:waypoint x="900" y="590" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0lkjrzz_di" bpmnElement="Flow_0lkjrzz">]''',
'      ,q''[        <di:waypoint x="1000" y="590" />]''',
'      ,q''[        <di:waypoint x="1055" y="590" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0t7vhh2_di" bpmnElement="Flow_0t7vhh2">]''',
'      ,q''[        <di:waypoint x="1270" y="590" />]''',
'      ,q''[        <di:waypoint x="1342" y="590" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1x95h95_di" bpmnElement="Flow_1x95h95">]''',
'      ,q''[        <di:waypoint x="1105" y="590" />]''',
'      ,q''[        <di:waypoint x="1170" y="590" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1134" y="572" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_18i162p_di" bpmnElement="Flow_18i162p">]''',
'      ,q''[        <di:waypoint x="1080" y="615" />]''',
'      ,q''[        <di:waypoint x="1080" y="700" />]''',
'      ,q''[        <di:waypoint x="1120" y="700" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1091" y="655" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1e22oat_di" bpmnElement="Flow_1e22oat">]''',
'      ,q''[        <di:waypoint x="1220" y="700" />]''',
'      ,q''[        <di:waypoint x="1272" y="700" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ems563_di" bpmnElement="Activity_0ems563">]''',
'      ,q''[        <dc:Bounds x="1450" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1mr01vo_di" bpmnElement="Event_1mr01vo">]''',
'      ,q''[        <dc:Bounds x="1602" y="532" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1594" y="575" width="52" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0okheq5_di" bpmnElement="Gateway_0okheq5" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1215" y="305" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1201" y="283" width="78" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ksy34k_di" bpmnElement="Activity_0ksy34k">]''',
'      ,q''[        <dc:Bounds x="1380" y="290" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0inroqp_di" bpmnElement="Event_1yflz91" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1282" y="422" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1258" y="465" width="85" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0czq539_di" bpmnElement="Activity_0czq539" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1480" y="670" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0jj0hcj_di" bpmnElement="Event_0jj0hcj" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1612" y="692" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1601" y="735" width="59" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0mjqcjn_di" bpmnElement="TextAnnotation_0mjqcjn">]''',
'      ,q''[        <dc:Bounds x="1390" y="230" width="248" height="54" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0nr80d2_di" bpmnElement="Event_0ilybau" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1392" y="692" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1418" y="636" width="84" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1bfswcs_di" bpmnElement="Flow_1bfswcs">]''',
'      ,q''[        <di:waypoint x="598" y="330" />]''',
'      ,q''[        <di:waypoint x="650" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dfsgk8_di" bpmnElement="Flow_1dfsgk8">]''',
'      ,q''[        <di:waypoint x="750" y="330" />]''',
'      ,q''[        <di:waypoint x="805" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_14jrwrx_di" bpmnElement="Flow_14jrwrx">]''',
'      ,q''[        <di:waypoint x="855" y="330" />]''',
'      ,q''[        <di:waypoint x="910" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0l8zsga_di" bpmnElement="Flow_0l8zsga">]''',
'      ,q''[        <di:waypoint x="1010" y="330" />]''',
'      ,q''[        <di:waypoint x="1070" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1smtq7r_di" bpmnElement="Flow_1smtq7r">]''',
'      ,q''[        <di:waypoint x="1170" y="330" />]''',
'      ,q''[        <di:waypoint x="1215" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0sw8mct_di" bpmnElement="Flow_0sw8mct">]''',
'      ,q''[        <di:waypoint x="830" y="355" />]''',
'      ,q''[        <di:waypoint x="830" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0dxi3lp_di" bpmnElement="Flow_0dxi3lp">]''',
'      ,q''[        <di:waypoint x="1410" y="550" />]''',
'      ,q''[        <di:waypoint x="1450" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03kjiig_di" bpmnElement="Flow_03kjiig">]''',
'      ,q''[        <di:waypoint x="1550" y="550" />]''',
'      ,q''[        <di:waypoint x="1602" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_00jpo2b_di" bpmnElement="Flow_00jpo2b">]''',
'      ,q''[        <di:waypoint x="1265" y="330" />]''',
'      ,q''[        <di:waypoint x="1380" y="330" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'280" y="312" width="18" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1o2xxi5_di" bpmnElement="Flow_1o2xxi5">]''',
'      ,q''[        <di:waypoint x="1480" y="330" />]''',
'      ,q''[        <di:waypoint x="1602" y="330" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1n7yz35_di" bpmnElement="Flow_1n7yz35">]''',
'      ,q''[        <di:waypoint x="1240" y="355" />]''',
'      ,q''[        <di:waypoint x="1240" y="440" />]''',
'      ,q''[        <di:waypoint x="1282" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_01yn0la_di" bpmnElement="Flow_01yn0la">]''',
'      ,q''[        <di:waypoint x="1318" y="440" />]''',
'      ,q''[        <di:waypoint x="1349" y="440" />]''',
'      ,q''[        <di:waypoint x="1349" y="350" />]''',
'      ,q''[        <di:waypoint x="1380" y="350" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0rzsiz6_di" bpmnElement="Flow_0rzsiz6">]''',
'      ,q''[        <di:waypoint x="1428" y="710" />]''',
'      ,q''[        <di:waypoint x="1480" y="710" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0pw6aqw_di" bpmnElement="Flow_0pw6aqw">]''',
'      ,q''[        <di:waypoint x="1580" y="710" />]''',
'      ,q''[        <di:waypoint x="1612" y="710" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0n233kd_di" bpmnElement="Association_0n233kd">]''',
'      ,q''[        <di:waypoint x="1617" y="313" />]''',
'      ,q''[        <di:waypoint x="1611" y="284" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0n0h791_di" bpmnElement="Activity_0n0h791">]''',
'      ,q''[        <dc:Bounds x="1800" y="440" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1h0lzcv_di" bpmnElement="Event_1h0lzcv">]''',
'      ,q''[        <dc:Bounds x="1962" y="462" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1970" y="505" width="20" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_13xmf2s_di" bpmnElement="Activity_1b9ghnl" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1460" y="850" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_099tlz0_di" bpmnElement="Event_099tlz0" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1612" y="872" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1599" y="915" width="62" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1mbzten_di" bpmnElement="Activity_1mbzten" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1330" y="850" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0ccwauj_di" bpmnElement="Association_0ccwauj">]''',
'      ,q''[        <di:waypoint x="873" y="210" />]''',
'      ,q''[        <di:waypoint x="825" y="159" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_170xafm_di" bpmnElement="Event_05m9taf" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1272" y="792" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1178" y="835" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gz0sgq_di" bpmnElement="Flow_1gz0sgq">]''',
'      ,q''[        <di:waypoint x="278" y="310" />]''',
'      ,q''[        <di:waypoint x="330" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ha31js_di" bpmnElement="Flow_1ha31js">]''',
'      ,q''[        <di:waypoint x="430" y="310" />]''',
'      ,q''[        <di:waypoint x="530" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1trgt3r_di" bpmnElement="Flow_1trgt3r">]''',
'      ,q''[        <di:waypoint x="1700" y="480" />]''',
'      ,q''[        <di:waypoint x="1800" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wppxk7_di" bpmnElement="Flow_0wppxk7">]''',
'      ,q''[        <di:waypoint x="1900" y="480" />]''',
'      ,q''[        <di:waypoint x="1962" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0oc2x09_di" bpmnElement="Flow_0oc2x09">]''',
'      ,q''[        <di:waypoint x="1290" y="828" />]''',
'      ,q''[        <di:waypoint x="1290" y="890" />]''',
'      ,q''[        <di:waypoint x="1330" y="890" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jim7nk_di" bpmnElement="Flow_0jim7nk">]''',
'      ,q''[        <di:waypoint x="1560" y="890" />]''',
'      ,q''[        <di:waypoint x="1612" y="890" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1wddzwq_di" bpmnElement="Flow_1wddzwq">]''',
'      ,q''[        <di:waypoint x="1430" y="890" />]''',
'      ,q''[        <di:waypoint x="1460" y="890" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0m1p9cx_di" bpmnElement="TextAnnotation_0m1p9cx">]''',
'      ,q''[        <dc:Bounds x="510" y="-160" width="1080" height="318.659423828125" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 5c - Handling Sub Process Error and Escalation Events'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:di="http://'
||'www.omg.org/spec/DD/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial5d" name="Tutorial5d" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_09z8ee7" name="Customer on promotion target list">]''',
'      ,q''[      <bpmn:outgoing>Flow_0c50l8q</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0fpcard" name="make customer call for sales promotion">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>Action</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>ORDER:FOLLOWUP</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0c50l8q</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0dvvgox</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0c50l8q" sourceRef="Event_09z8ee7" targetRef="Activity_0fpcard" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0dvvgox" sourceRef="Activity_0fpcard" targetRef="Gateway_0t8ybcj" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_Info" name=":F4A$Action like &#39;%INFO%&#39;" sourceRef="Gateway_0t8ybcj" targetRef="Activity_1wezuvx" apex:sequence="10">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$Action like ''%INFO%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_0t8ybcj" name="customer needs follow up" default="Flow_Followup">]''',
'      ,q''[      <bpmn:incoming>Flow_0dvvgox</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_Info</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_15a033v</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_Followup</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0jgqhp9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_15a033v" name=":F4A$Action like &#39;%ORDER%&#39;" sourceRef="Gateway_0t8ybcj" targetRef="Activity_0gyfptj" apex:sequence="20">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$Action like ''%ORDER%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_Followup" name=":F4A$Action like &#39;%FOLLOWUP%&#39;" sourceRef="Gateway_0t8ybcj" targetRef="Activity_1h6w1sp" apex:sequence="40">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression" sequence="">:F4A$Action like ''%FOLLOWUP%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0jgqhp9" name=":F4A$Action like &#39;%REMOVE%&#39;" sourceRef="Gateway_0t8ybcj" targetRef="Activity_021su62" apex:sequence="30">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression" sequence="">:F4A$Action like ''%REMOVE%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0or0rxi" sourceRef="Activity_0gyfptj" targetRef="Activity_0jcpdul" />]''',
'      ,q''[    <bpmn:callActivity id="Activity_0jcpdul" name="Process order" apex:manualInput="false" apex:calledDiagram="Tutorial 5e - ship Goods (Called by Tutorial 5d)" apex:calledDiagramVersionSelection="namedVersion" apex:calledDiagramVersion="22'
||'.2">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:inVariables>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>OrderRef</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>processVariable</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>OrderRef</apex:varExpression>]''',
'      ,q''[            <apex:varDescription>Order requiring Shipping</apex:varDescription>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[            <apex:varName>ShippingPriority</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>URGENT</apex:varExpression>]''',
'      ,q''[            <apex:varDescription>URGENT or ROUTINE</apex:varDescription>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:inVariables>]''',
'      ,q''[        <apex:outVariables>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>ShipperName</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>processVariable</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>ShipperName</apex:varExpression>]''',
'      ,q''[            <apex:varDescription>Shipper Used</apex:varDescription>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[            <apex:varName>ShippedDate</apex:varName>]''',
'      ,q''[            <apex:varDataType>DATE</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>processVariable</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>ShippedDate</apex:varExpression>]''',
'      ,q''[            <apex:varDescription>Date Order Shipped</apex:varDescription>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>2</apex:varSequence>]''',
'      ,q''[            <apex:varName>TrackingID:</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>processVariable</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>TrackingID</apex:varExpression>]''',
'      ,q''[            <apex:varDescription>Tracking Reference for Shipment</apex:varDescription>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:outVariables>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0or0rxi</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0fl4rrv</bpmn:outgoing>]''',
'      ,q''[    </bpmn:callActivity>]''',
'      ,q''[    <bpmn:userTask id="Activity_1wezuvx" name="select info to send customer" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_Info</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0491f8g</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_0gyfptj" name="take order" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>OrderRef</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>dbms_random.string (''A'',8);</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_15a033v</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0or0rxi</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_1484c4f" name="followup scheduled">]''',
'      ,q''[      <bpmn:incoming>Flow_0ihtyj4</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ihtyj4" sourceRef="Activity_1h6w1sp" targetRef="Event_1484c4f" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0x68t1e" name="removed from promotion">]''',
'      ,q''[      <bpmn:incoming>Flow_09tth3s</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_09tth3s" sourceRef="Activity_021su62" targetRef="Event_0x68t1e" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0491f8g" sourceRef="Activity_1wezuvx" targetRef="Activity_1ejij76" />]''',
'      ,q''[    <bpmn:serviceTask id="Activity_1ejij76" name="send info to customer" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:incoming>Flow_0491f8g</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1t15ahv</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1t15ahv" sourceRef="Activity_1ejij76" targetRef="Event_0vziymp" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_0vziymp" name="7 days (demo 20 sec)">]''',
'      ,q''[      <bpmn:incoming>Flow_1t15ahv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0fy1x5x</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_1mat8jk">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT20S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0fy1x5x" sourceRef="Event_0vziymp" targetRef="Activity_1kwqlbl" />]''',
'      ,q''[    <bpmn:serviceTask id="Activity_1kwqlbl" name="send tickler email" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:incoming>Flow_0fy1x5x</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_12r2bp8</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0fl4rrv" sourceRef="Activity_0jcpdul" targetRef="Event_0trjr0k" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1hwxs6h" sourceRef="Event_0trjr0k" targetRef="Activity_00iss9v" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0sqk7g5" name="info sent">]''',
'      ,q''[      <bpmn:incoming>Flow_12r2bp8</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12r2bp8" sourceRef="Activity_1kwqlbl" targetRef="Event_0sqk7g5" />]''',
'      ,q''[    <bpmn:scriptTask id="Activity_1h6w1sp" name="mark for follow up call" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_Followup</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ihtyj4</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_021su62" name="remove from promotion" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0jgqhp9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_09tth3s</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:serviceTask id="Activity_00iss9v" name="send welcome email" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:incoming>Flow_1hwxs6h</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1qrm13o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_1cfcjsk" name="item sold and delivered">]''',
'      ,q''[      <bpmn:incoming>Flow_1qrm13o</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1qrm13o" sourceRef="Activity_00iss9v" targetRef="Event_1cfcjsk" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_0trjr0k" name="2 Days after Delivery&#10;(demo 20 sec)">]''',
'      ,q''[      <bpmn:incoming>Flow_0fl4rrv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1hwxs6h</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0z1rkyf">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT20S</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0h4j8v0">]''',
'      ,q''[      <bpmn:text>Tutorial 5d: Using Call Activities to ''Reuse Processes'']''',
'      ,q''[]''',
'      ,q''[In this diagram, the Sales &amp; Marketing Group have just created a sales promotion process to call targeted customers, and try to sell them a product.]''',
'      ,q''[If the sales call is successful, they will take an order - and ship the product to the customer.]''',
'      ,q''[]''',
unistr('      ,q''[The Sales and Marketing Group don''t want to define all of the order processing process steps in their promotion. \00A0 But the Supply Chain IT developers have already created a process for booking an order, picking, packing, and shipping it. \00A0T')
||unistr('his Shipping process is contained in the model ''Tutorial 5e''. \00A0 So our Sales and Marketing process developer can just ''call'' this model using a Call Activity (Task ''Process Order'')</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0wo3s14" sourceRef="Event_09z8ee7" targetRef="TextAnnotation_0h4j8v0" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1aazt0j">]''',
unistr('      ,q''[      <bpmn:text>The Call Activity calls another diagram. (Tutorial 5e). \00A0Look at theProperties Panel to see how this is configured.]'''),
'      ,q''[]''',
unistr('      ,q''[When configuring a Call Activity call, first find the model you want to call. \00A0Select a specific version, or the latest version.]'''),
'      ,q''[]''',
unistr('      ,q''[Use the In/Out Variables tab to configure how process variables in the Calling diagram get copied into the Called Diagram. \00A0Click on the green ''Load Defined Variables'' button to get all of the required Input and Output Variables loaded into')
||' the properties panel....]''',
'      ,q''[]''',
'      ,q''[Process Variables are scoped to a single diagram -- so any variables in the calling diagram only exist in the called diagram if you copy them into the called diagram when the diagram starts running.]''',
'      ,q''[]''',
'      ,q''[Similarly, any variables or results that you create in the called diagram need be explicitly returned to the calling diagram when election of the called diagram completes.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_13ugv4j" sourceRef="Activity_0jcpdul" targetRef="TextAnnotation_1aazt0j" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0p6eegv">]''',
'      ,q''[      <bpmn:text>Tutorial Tasks:]''',
'      ,q''[]''',
unistr('      ,q''[1. \00A0Look at the Definition of the two models Tutorial 5d (this one) and Tutorial 5e (the called diagram). \00A0]'''),
'      ,q''[- in this diagram, see how the Call Activity is configured to select the diagram, and then look at the In/Out tab to see how process variables can be passed into and returned from the Called Diagram.]''',
unistr('      ,q''[- in Tutorial 5e diagram, see how the parameters were defined in the Process-level In/Out Parameters tab. \00A0Also note that the Process object has an attribute Is Callable, which must be set for a diagram to be called.]'''),
'      ,q''[]''',
unistr('      ,q''[2. \00A0Run Model 5d. \00A0 By default, ''ACTIONS'' is set to ''ORDER:FOLLOWUP'' so those paths are taken.]'''),
unistr('      ,q''[- step the ''Take Order'' path forward into the ''Process Order'' Call Activity task. \00A0On the Flow Diagram, click the ''+'' box to show progress inside the Called Diagram.]'''),
'      ,q''[- use the breadcrumb at the top of the diagram to move between models.]''',
'      ,q''[- Look at the process variables as you step through the model - notice the original diagram variables (shown in scope 0) and then new variables in the scope of the called diagram once you step into the called diagram.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0re9avf" sourceRef="Event_1cfcjsk" targetRef="TextAnnotation_0p6eegv" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial5d">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_09z8ee7_di" bpmnElement="Event_09z8ee7">]''',
'      ,q''[        <dc:Bounds x="242" y="422" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="221" y="465" width="78" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0fpcard_di" bpmnElement="Activity_0fpcard" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="330" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_09inf4z_di" bpmnElement="Gateway_0t8ybcj">]''',
'      ,q''[        <dc:Bounds x="485" y="415" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="432" y="356" width="76" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0glnydz_di" bpmnElement="Activity_0jcpdul" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="800" y="270" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1s3xnap_di" bpmnElement="Activity_1wezuvx" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="640" y="140" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0kivh8b_di" bpmnElement="Activity_0gyfptj" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="640" y="270" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1484c4f_di" bpmnElement="Event_1484c4f" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="802" y="552" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="795" y="595" width="51" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0x68t1e_di" bpmnElement="Event_0x68t1e" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="802" y="422" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="786" y="465" width="68" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1b5gwt7_di" bpmnElement="Activity_1ejij76" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="800" y="140" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0svbp8u_di" bpmnElement="Event_0vziymp">]''',
'      ,q''[        <dc:Bounds x="962" y="162" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="941" y="205" width="79" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0jtbimi_di" bpmnElement="Activity_1kwqlbl" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="1060" y="140" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0sqk7g5_di" bpmnElement="Event_0sqk7g5" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="1222" y="162" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1220" y="205" width="42" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1m7jjp4_di" bpmnElement="Activity_1h6w1sp" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="640" y="530" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0iiov2q_di" bpmnElement="Activity_021su62" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="640" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1yp9y86_di" bpmnElement="Activity_00iss9v" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1060" y="270" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1cfcjsk_di" bpmnElement="Event_1cfcjsk" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1222" y="292" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1208" y="335" width="66" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0huehfr_di" bpmnElement="Event_0trjr0k">]''',
'      ,q''[        <dc:Bounds x="962" y="292" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="946" y="335" width="68" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0h4j8v0_di" bpmnEle'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ment="TextAnnotation_0h4j8v0">]''',
'      ,q''[        <dc:Bounds x="330" y="-100" width="429.9999694824219" height="194.99998474121094" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1aazt0j_di" bpmnElement="TextAnnotation_1aazt0j">]''',
'      ,q''[        <dc:Bounds x="1050" y="440" width="489.9999694824219" height="236.9852752685547" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0p6eegv_di" bpmnElement="TextAnnotation_0p6eegv">]''',
'      ,q''[        <dc:Bounds x="1420" y="110" width="540" height="280" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0c50l8q_di" bpmnElement="Flow_0c50l8q">]''',
'      ,q''[        <di:waypoint x="278" y="440" />]''',
'      ,q''[        <di:waypoint x="330" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0dvvgox_di" bpmnElement="Flow_0dvvgox">]''',
'      ,q''[        <di:waypoint x="430" y="440" />]''',
'      ,q''[        <di:waypoint x="485" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0u4qa74_di" bpmnElement="Flow_Info">]''',
'      ,q''[        <di:waypoint x="510" y="415" />]''',
'      ,q''[        <di:waypoint x="510" y="180" />]''',
'      ,q''[        <di:waypoint x="640" y="180" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="531" y="146" width="77" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_15a033v_di" bpmnElement="Flow_15a033v">]''',
'      ,q''[        <di:waypoint x="510" y="415" />]''',
'      ,q''[        <di:waypoint x="510" y="310" />]''',
'      ,q''[        <di:waypoint x="640" y="310" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="541" y="276" width="77" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0bf6itn_di" bpmnElement="Flow_Followup">]''',
'      ,q''[        <di:waypoint x="510" y="465" />]''',
'      ,q''[        <di:waypoint x="510" y="570" />]''',
'      ,q''[        <di:waypoint x="640" y="570" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="538" y="526" width="83" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jgqhp9_di" bpmnElement="Flow_0jgqhp9">]''',
'      ,q''[        <di:waypoint x="535" y="440" />]''',
'      ,q''[        <di:waypoint x="640" y="440" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="544" y="370" width="72" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0or0rxi_di" bpmnElement="Flow_0or0rxi">]''',
'      ,q''[        <di:waypoint x="740" y="310" />]''',
'      ,q''[        <di:waypoint x="800" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ihtyj4_di" bpmnElement="Flow_0ihtyj4">]''',
'      ,q''[        <di:waypoint x="740" y="570" />]''',
'      ,q''[        <di:waypoint x="802" y="570" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_09tth3s_di" bpmnElement="Flow_09tth3s">]''',
'      ,q''[        <di:waypoint x="740" y="440" />]''',
'      ,q''[        <di:waypoint x="802" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0491f8g_di" bpmnElement="Flow_0491f8g">]''',
'      ,q''[        <di:waypoint x="740" y="180" />]''',
'      ,q''[        <di:waypoint x="800" y="180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1t15ahv_di" bpmnElement="Flow_1t15ahv">]''',
'      ,q''[        <di:waypoint x="900" y="180" />]''',
'      ,q''[        <di:waypoint x="962" y="180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0fy1x5x_di" bpmnElement="Flow_0fy1x5x">]''',
'      ,q''[        <di:waypoint x="998" y="180" />]''',
'      ,q''[        <di:waypoint x="1060" y="180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0fl4rrv_di" bpmnElement="Flow_0fl4rrv">]''',
'      ,q''[        <di:waypoint x="900" y="310" />]''',
'      ,q''[        <di:waypoint x="962" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1hwxs6h_di" bpmnElement="Flow_1hwxs6h">]''',
'      ,q''[        <di:waypoint x="998" y="310" />]''',
'      ,q''[        <di:waypoint x="1060" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12r2bp8_di" bpmnElement="Flow_12r2bp8">]''',
'      ,q''[        <di:waypoint x="1160" y="180" />]''',
'      ,q''[        <di:waypoint x="1222" y="180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qrm13o_di" bpmnElement="Flow_1qrm13o">]''',
'      ,q''[        <di:waypoint x="1160" y="310" />]''',
'      ,q''[        <di:waypoint x="1222" y="310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0wo3s14_di" bpmnElement="Association_0wo3s14">]''',
'      ,q''[        <di:waypoint x="264" y="423" />]''',
'      ,q''[        <di:waypoint x="339" y="95" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_13ugv4j_di" bpmnElement="Association_13ugv4j">]''',
'      ,q''[        <di:waypoint x="900" y="339" />]''',
'      ,q''[        <di:waypoint x="1074" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0re9avf_di" bpmnElement="Association_0re9avf">]''',
'      ,q''[        <di:waypoint x="1254" y="299" />]''',
'      ,q''[        <di:waypoint x="1420" y="165" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 5d - Using CallActivities to call another diagram'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:di="http://'
||'www.omg.org/spec/DD/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="ShipGoods_Tut5e" name="Ship Goods - Called by Tutorial 5d" isExecutable="false" apex:isCallable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:extensionElements>]''',
'      ,q''[      <apex:inVariables>]''',
'      ,q''[        <apex:processVariable>]''',
'      ,q''[          <apex:varName>OrderRef</apex:varName>]''',
'      ,q''[          <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[          <apex:varDescription>Order requiring Shipping</apex:varDescription>]''',
'      ,q''[        </apex:processVariable>]''',
'      ,q''[        <apex:processVariable>]''',
'      ,q''[          <apex:varName>ShippingPriority</apex:varName>]''',
'      ,q''[          <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[          <apex:varDescription>URGENT or ROUTINE</apex:varDescription>]''',
'      ,q''[        </apex:processVariable>]''',
'      ,q''[      </apex:inVariables>]''',
'      ,q''[      <apex:outVariables>]''',
'      ,q''[        <apex:processVariable>]''',
'      ,q''[          <apex:varName>ShipperName</apex:varName>]''',
'      ,q''[          <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[          <apex:varDescription>Shipper Used</apex:varDescription>]''',
'      ,q''[        </apex:processVariable>]''',
'      ,q''[        <apex:processVariable>]''',
'      ,q''[          <apex:varName>ShippedDate</apex:varName>]''',
'      ,q''[          <apex:varDataType>DATE</apex:varDataType>]''',
'      ,q''[          <apex:varDescription>Date Order Shipped</apex:varDescription>]''',
'      ,q''[        </apex:processVariable>]''',
'      ,q''[        <apex:processVariable>]''',
'      ,q''[          <apex:varName>TrackingID:</apex:varName>]''',
'      ,q''[          <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[          <apex:varDescription>Tracking Reference for Shipment</apex:varDescription>]''',
'      ,q''[        </apex:processVariable>]''',
'      ,q''[      </apex:outVariables>]''',
'      ,q''[    </bpmn:extensionElements>]''',
'      ,q''[    <bpmn:startEvent id="Event_Ship_Start" name="Goods to Ship">]''',
'      ,q''[      <bpmn:outgoing>Flow_06qz5ww</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_06qz5ww" sourceRef="Event_Ship_Start" targetRef="Activity_19f7o06" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1e2h6le" name="ShipPriority?" default="Flow_08yk7ka">]''',
'      ,q''[      <bpmn:incoming>Flow_1pd2q97</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_URGENT</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_08yk7ka</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1pd2q97" sourceRef="Activity_19f7o06" targetRef="Gateway_1e2h6le" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_URGENT" name="ShippingPriority = &#39;URGENT&#39;" sourceRef="Gateway_1e2h6le" targetRef="Activity_Book_Urgent" apex:sequence="10">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$ShippingPriority = ''URGENT''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08yk7ka" name="Non Urgent" sourceRef="Gateway_1e2h6le" targetRef="Activity_Find_Routine" apex:sequence="20">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$ShipPriority = ''ROUTINE''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:businessRuleTask id="Activity_Find_Routine" name="Find Cheapest 48hr Service" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>ShipperName</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlFunctionBody</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>declare]''',
'      ,q''[  l_rand number;]''',
'      ,q''[  l_carrier varchar2(20);]''',
'      ,q''[begin]''',
'      ,q''[  l_rand := sys.dbms_random.value (0,1);]''',
'      ,q''[  if l_rand &lt; 0.4 then]''',
'      ,q''[    return ''UPS'';]''',
'      ,q''[  else]''',
'      ,q''[    return ''DHL'';]''',
'      ,q''[  end if;]''',
'      ,q''[end;]''',
'      ,q''[</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_08yk7ka</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0k2vk16</bpmn:outgoing>]''',
'      ,q''[    </bpmn:businessRuleTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0k2vk16" sourceRef="Activity_Find_Routine" targetRef="Activity_Book_routine" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_0xh1d35">]''',
'      ,q''[      <bpmn:incoming>Flow_1mqm8p6</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1xjwnbj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_08qzca3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1mqm8p6" sourceRef="Activity_Book_Urgent" targetRef="Gateway_0xh1d35" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1xjwnbj" sourceRef="Activity_Book_routine" targetRef="Gateway_0xh1d35" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08qzca3" sourceRef="Gateway_0xh1d35" targetRef="Activity_Pick" apex:sequence="10" />]''',
'      ,q''[    <bpmn:userTask id="Activity_Pick" name="Pick Goods" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_08qzca3</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1vf2z9i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_Pack" name="Pack Goods" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>ShippedDate</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>to_date(sysdate,''YYYY-MM-DD HH24:MI:SS'')</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1vf2z9i</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_18mfexs</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_18mfexs" sourceRef="Activity_Pack" targetRef="Activity_Mail" />]''',
'      ,q''[    <bpmn:serviceTask id="Activity_Mail" name="Email Customer Tracking Info" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_18mfexs</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1v4skc4</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_Book_routine" name="Book Shipment" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>TrackingID</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>sys.dbms_random.string(opt=&gt;''U'',len=&gt;8)</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0k2vk16</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1xjwnbj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_Book_Urgent" name="Book FedEx NextDay Shipment" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>ShipperName</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>FedEx</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[            <apex:varName>TrackingID:</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>sys.dbms_random.string(opt=&gt;''U'',len=&gt;8)</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_URGENT</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1mqm8p6</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_19f7o06" name="Get Order Details and Check Priority" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_06qz5ww</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1pd2q97</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_ShipEnd" name="Shipment Complete">]''',
'      ,q''[      <bpmn:incoming>Flow_1v4skc4</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1v4skc4" sourceRef="Activity_Mail" targetRef="Event_ShipEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1vf2z9i" sourceRef="Activity_Pick" targetRef="Activity_Pack" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="ShipGoods_Tut5e">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1w9cwmv_di" bpmnElement="Event_Ship_Start">]''',
'      ,q''[        <dc:Bounds x="982" y="432" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="966" y="475" width="68" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1e2h6le_di" bpmnElement="Gateway_1e2h6le" isMarkerVisible="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1225" y="425" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1178" y="393" width="63" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ep4ycz_di" bpmnElement="Activity_Find_Routine" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1350" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0xh1d35_di" bpmnElement="Gateway_0xh1d35" isMarkerVisible="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1695" y="425" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0izavb0_di" bpmnElement="Activity_Pick" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1810" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_11flad3_di" bpmnElement="Activity_Pack" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1990" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ez2lb8_di" bpmnElement="Activity_Mail" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="2170" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_10fqo30_di" bpmnElement="Activity_Book_routine" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1530" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1eh78qu_di" bpmnElement="Activity_Book_Urgent" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1350" y="300" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0r8rmow_di" bpmnElement="Activity_19f7o06" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1070" y="410" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_10evpe0_di" bpmnElement="Event_ShipEnd" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="2352" y="432" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2346" y="475" width="48" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_06qz5ww_di" bpmnElement="Flow_06qz5ww">]''',
'      ,q''[        <di:waypoint x="1018" y="450" />]''',
'      ,q''[        <di:waypoint x="1070" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1pd2q97_di" bpmnElement="Flow_1pd2q97">]''',
'      ,q''[        <di:waypoint x="1170" y="450" />]''',
'      ,q''[        <di:waypoint x="1225" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_149rygf_di" bpmnElement="Flow_URGENT">]''',
'      ,q''[        <di:waypoint x="1250" y="425" />]''',
'      ,q''[        <di:waypoint x="1250" y="340" />]''',
'      ,q''[        <di:waypoint x="1350" y="340" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1248" y="306" width="84" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08yk7ka_di" bpmnElement="Flow_08yk7ka">]''',
'      ,q''[        <di:waypoint x="1250" y="475" />]''',
'      ,q''[        <di:waypoint x="1250" y="560" />]''',
'      ,q''[        <di:waypoint x="1350" y="560" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1272" y="533" width="55" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0k2vk16_di" bpmnElement="Flow_0k2vk16">]''',
'      ,q''[        <di:waypoint x="1450" y="560" />]''',
'      ,q''[        <di:waypoint x="1530" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mqm8p6_di" bpmnElement="Flow_1mqm8p6">]''',
'      ,q''[        <di:waypoint x="1450" y="340" />]''',
'      ,q''[        <di:waypoint x="1720" y="340" />]''',
'      ,q''[        <di:waypoint x="1720" y="425" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1xjwnbj_di" bpmnElement="Flow_1xjwnbj">]''',
'      ,q''[        <di:waypoint x="1630" y="560" />]''',
'      ,q''[        <di:waypoint x="1720" y="560" />]''',
'      ,q''[        <di:waypoint x="1720" y="475" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08qzca3_di" bpmnElement="Flow_08qzca3">]''',
'      ,q''[        <di:waypoint x="1745" y="450" />]''',
'      ,q''[        <di:waypoint x="1810" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_18mfexs_di" bpmnElement="Flow_18mfexs">]''',
'      ,q''[        <di:waypoint x="2090" y="450" />]''',
'      ,q''[        <di:waypoint x="2170" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1v4skc4_di" bpmnElement="Flow_1v4skc4">]''',
'      ,q''[        <di:waypoint x="2270" y="450" />]''',
'      ,q''[        <di:waypoint x="2352" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1vf2z9i_di" bpmnElement="Flow_1vf2z9i">]''',
'      ,q''[        <di:waypoint x="1910" y="450" />]''',
'      ,q''[        <di:waypoint x="1990" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 5e - ship Goods (Called by Tutorial 5d)'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial5f" name="Tutorial 5F - Making a Diagram Callable" isExecutable="false" apex:isCallable="false" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_13pm9fl">]''',
'      ,q''[      <bpmn:outgoing>Flow_0nyyjkj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1w86o6c" name="Step A">]''',
'      ,q''[      <bpmn:incoming>Flow_0nyyjkj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0u3mznx</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0nyyjkj" sourceRef="Event_13pm9fl" targetRef="Activity_1w86o6c" />]''',
'      ,q''[    <bpmn:task id="Activity_0irzelz" name="Step B">]''',
'      ,q''[      <bpmn:incoming>Flow_175gkh6</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0jlmtjb</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0u3mznx" sourceRef="Activity_1w86o6c" targetRef="Activity_1kv9zax" />]''',
'      ,q''[    <bpmn:endEvent id="Event_18an09f">]''',
'      ,q''[      <bpmn:incoming>Flow_11ko7k8</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0jlmtjb" sourceRef="Activity_0irzelz" targetRef="Activity_0vygmu9" />]''',
'      ,q''[    <bpmn:task id="Activity_1kv9zax" name="Set is Callable = Yes">]''',
'      ,q''[      <bpmn:incoming>Flow_0u3mznx</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_175gkh6</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_175gkh6" sourceRef="Activity_1kv9zax" targetRef="Activity_0irzelz" />]''',
'      ,q''[    <bpmn:task id="Activity_0vygmu9" name="Set In/Out Variable Specs">]''',
'      ,q''[      <bpmn:incoming>Flow_0jlmtjb</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_11ko7k8</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11ko7k8" sourceRef="Activity_0vygmu9" targetRef="Event_18an09f" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_006k1ua">]''',
'      ,q''[      <bpmn:text>1. Click on the modeler background to select the Process object.]''',
unistr('      ,q''[2.In the Properties Panel &gt; General - \00A0set Execution - Is Callable to ''yes''</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1bpdyqv" sourceRef="Activity_1kv9zax" targetRef="TextAnnotation_006k1ua" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1smzwql">]''',
'      ,q''[      <bpmn:text>In the Properties Panel &gt; In/Out Mapping,]''',
'      ,q''[define the required Input &amp; Output variables to be passed in and returned after completion.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1o407ht" sourceRef="Activity_0vygmu9" targetRef="TextAnnotation_1smzwql" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0prrv7o">]''',
'      ,q''[      <bpmn:text>Tutorial 5f: Setting a Diagram to be Callable]''',
'      ,q''[]''',
'      ,q''[It''s very easy to make a diagram callable by other diagrams.....</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_18c814z" sourceRef="Event_13pm9fl" targetRef="TextAnnotation_0prrv7o" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_16jzotv">]''',
'      ,q''[      <bpmn:text>experiment by making this diagram callable....</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1wsaj6b" sourceRef="Event_18an09f" targetRef="TextAnnotation_16jzotv" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial5f">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_13pm9fl_di" bpmnElement="Event_13pm9fl">]''',
'      ,q''[        <dc:Bounds x="372" y="422" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
',q''[      <bpmndi:BPMNShape id="Activity_1w86o6c_di" bpmnElement="Activity_1w86o6c" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="460" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0irzelz_di" bpmnElement="Activity_0irzelz" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="815" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_18an09f_di" bpmnElement="Event_18an09f">]''',
'      ,q''[        <dc:Bounds x="1202" y="422" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1kv9zax_di" bpmnElement="Activity_1kv9zax" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0vygmu9_di" bpmnElement="Activity_0vygmu9" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="960" y="400" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_006k1ua_di" bpmnElement="TextAnnotation_006k1ua">]''',
'      ,q''[        <dc:Bounds x="710" y="220" width="309.9815979003906" height="67.99632263183594" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1smzwql_di" bpmnElement="TextAnnotation_1smzwql">]''',
'      ,q''[        <dc:Bounds x="1080" y="220" width="249.99998474121094" height="67.99632263183594" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0prrv7o_di" bpmnElement="TextAnnotation_0prrv7o">]''',
'      ,q''[        <dc:Bounds x="550" y="70" width="589.9999389648438" height="53.98896789550781" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_16jzotv_di" bpmnElement="TextAnnotation_16jzotv">]''',
'      ,q''[        <dc:Bounds x="1240" y="340" width="99.99999237060547" height="67.99632263183594" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0nyyjkj_di" bpmnElement="Flow_0nyyjkj">]''',
'      ,q''[        <di:waypoint x="408" y="440" />]''',
'      ,q''[        <di:waypoint x="460" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0u3mznx_di" bpmnElement="Flow_0u3mznx">]''',
'      ,q''[        <di:waypoint x="560" y="440" />]''',
'      ,q''[        <di:waypoint x="600" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jlmtjb_di" bpmnElement="Flow_0jlmtjb">]''',
'      ,q''[        <di:waypoint x="915" y="440" />]''',
'      ,q''[        <di:waypoint x="960" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_175gkh6_di" bpmnElement="Flow_175gkh6">]''',
'      ,q''[        <di:waypoint x="700" y="440" />]''',
'      ,q''[        <di:waypoint x="815" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11ko7k8_di" bpmnElement="Flow_11ko7k8">]''',
'      ,q''[        <di:waypoint x="1060" y="440" />]''',
'      ,q''[        <di:waypoint x="1202" y="440" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1bpdyqv_di" bpmnElement="Association_1bpdyqv">]''',
'      ,q''[        <di:waypoint x="671" y="400" />]''',
'      ,q''[        <di:waypoint x="732" y="288" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1o407ht_di" bpmnElement="Association_1o407ht">]''',
'      ,q''[        <di:waypoint x="1010" y="400" />]''',
'      ,q''[        <di:waypoint x="1091" y="288" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_18c814z_di" bpmnElement="Association_18c814z">]''',
'      ,q''[        <di:waypoint x="399" y="425" />]''',
'      ,q''[        <di:waypoint x="577" y="124" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1wsaj6b_di" bpmnElement="Association_1wsaj6b">]''',
'      ,q''[        <di:waypoint x="1231" y="426" />]''',
'      ,q''[        <di:waypoint x="1246" y="408" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 5f - Making a Diagram Callable'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns'
||':di="http://www.omg.org/spec/DD/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:collaboration id="Collaboration_1rka1qz">]''',
'      ,q''[    <bpmn:documentation>Tutorials by Richard Allen.]''',
'      ,q''[Flowquest Consulting.]''',
'      ,q''[twitter: @FlowquestR</bpmn:documentation>]''',
'      ,q''[    <bpmn:participant id="Participant_0o8ym8r" name="MyCompany" processRef="Process_0rxermh" />]''',
'      ,q''[  </bpmn:collaboration>]''',
'      ,q''[  <bpmn:process id="Process_0rxermh" isExecutable="false">]''',
'      ,q''[    <bpmn:laneSet id="LaneSet_1vcug1u">]''',
'      ,q''[      <bpmn:lane id="Lane_1di2z70" name="Sales" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Event_15p5zwa</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1fb79se</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_0xszxbu</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1btthx3</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0u1cxe0</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0hcbcm9</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_06y2vip" name="Finance" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_0ctvx3o</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1bbwgpd</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_080aaf2</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_00ou09q</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1enngrb</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_1uzm09b</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0j2a5z0</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0052vug</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_03etxno" name="Shipping" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_1hvg7i1</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_1fqq9sr</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0a9stdf</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1r5snya</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0rghtfj</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0lm6w3e</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[    </bpmn:laneSet>]''',
'      ,q''[    <bpmn:startEvent id="Event_15p5zwa" name="start">]''',
'      ,q''[      <bpmn:outgoing>Flow_0kubj9p</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1fb79se" name="Take Order">]''',
'      ,q''[      <bpmn:incoming>Flow_0kubj9p</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ry9q57</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0kubj9p" sourceRef="Event_15p5zwa" targetRef="Activity_1fb79se" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ry9q57" sourceRef="Activity_1fb79se" targetRef="Gateway_0xszxbu" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0xszxbu">]''',
'      ,q''[      <bpmn:incoming>Flow_0ry9q57</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1air6n9</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_06iqwjh</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_08s6jze</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1air6n9" sourceRef="Gateway_0xszxbu" targetRef="Activity_1btthx3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_06iqwjh" sourceRef="Gateway_0xszxbu" targetRef="Activity_080aaf2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ututkm" sourceRef="Activity_080aaf2" targetRef="Activity_00ou09q" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1pyqngd" sourceRef="Activity_00ou09q" targetRef="Activity_1enngrb" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08s6jze" sourceRef="Gateway_0xszxbu" targetRef="Activity_0a9stdf" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_006uuj2" sourceRef="Activity_0a9stdf" targetRef="Gateway_1hvg7i1" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1hvg7i1" name="Embargoed Customer?" default="Flow_1aa0af4">]''',
'      ,q''[      <bpmn:incoming>Flow_006uuj2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1aa0af4</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1tof406</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1aa0af4" name="N" sourceRef="Gateway_1hvg7i1" targetRef="Activity_1r5snya" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1tof406" name="Y" sourceRef="Gateway_1hvg7i1" targetRef="Event_1fqq9sr" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1fqq9sr" name="Terminate Order">]''',
'      ,q''[      <bpmn:incoming>Flow_1tof406</bpmn:incoming>]''',
'      ,q''[      <bpmn:terminateEventDefinition id="TerminateEventDefinition_180cega">]''',
'      ,q''[        <apex:processStatus>terminated</apex:processStatus>]''',
'      ,q''[      </bpmn:terminateEventDefinition>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_10doy19" sourceRef="Activity_1r5snya" targetRef="Activity_0rghtfj" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1071r1d" sourceRef="Activity_1btthx3" targetRef="Gateway_0ctvx3o" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0al8eiu" sourceRef="Activity_1enngrb" targetRef="Gateway_0ctvx3o" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1olo1p2" sourceRef="Activity_0rghtfj" targetRef="Activity_0lm6w3e" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0ctvx3o">]''',
'      ,q''[      <bpmn:incoming>Flow_1071r1d</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0al8eiu</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_07xilb7</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1da66k3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07xilb7" sourceRef="Activity_0lm6w3e" targetRef="Gateway_0ctvx3o" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1da66k3" sourceRef="Gateway_0ctvx3o" targetRef="Activity_1bbwgpd" />]''',
'      ,q''[    <bpmn:userTask id="Activity_1bbwgpd" name="Final approval to ship" apex:type="apexPage">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexPage />]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1da66k3</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1qhwtp2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_080aaf2" name="Draft Invoice" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_06iqwjh</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ututkm</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_00ou09q" name="Approve Discounts" apex:type="apexPage">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexPage />]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1ututkm</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1pyqngd</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:serviceTask id="Activity_1enngrb" name="Send invoice" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1pyqngd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0al8eiu</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:serviceTask id="Activity_1btthx3" name="Email Customer to confirm" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1air6n9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1071r1d</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:serviceTask id="Activity_0a9stdf" name="Check Embargoed Customer List" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_08s6jze</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_006uuj2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_1r5snya" name="Prepare Shipping" apex:type="apexPage">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexPage />]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1aa0af4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_10doy19</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_0rghtfj" name="Book Transport" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_10doy19</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1olo1p2</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:manualTask id="Activity_0lm6w3e" name="Pack Goods">]''',
'      ,q''[      <bpmn:incoming>Flow_1olo1p2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_07xilb7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:manualTask>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1uzm09b" name="Approved" default="Flow_0v4ypbt">]''',
'      ,q''[      <bpmn:incoming>Flow_1qhwtp2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0v4ypbt</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_11edvtt</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1qhwtp2" sourceRef="Activity_1bbwgpd" targetRef="Gateway_1uzm09b" />]''',
'      ,q''[    <bpmn:task id="Activity_0j2a5z0" name="Ship Goods">]''',
'      ,q''[      <bpmn:incoming>Flow_0v4ypbt</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0raow5t</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0v4ypbt" name="Y" sourceRef="Gateway_1uzm09b" targetRef="Activity_0j2a5z0" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0052vug" name="End">]''',
'      ,q''[      <bpmn:incoming>Flow_0raow5t</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0raow5t" sourceRef="Activity_0j2a5z0" targetRef="Event_0052vug" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11edvtt" name="N" sourceRef="Gateway_1uzm09b" targetRef="Activity_0u1cxe0" />]''',
'      ,q''[    <bpmn:task id="Activity_0u1cxe0" name="Advise Sales">]''',
'      ,q''[      <bpmn:incoming>Flow_11edvtt</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_09hbzak</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_0hcbcm9" name="Order needs to be redone.">]''',
'      ,q''[      <bpmn:incoming>Flow_09hbzak</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_09hbzak" sourceRef="Activity_0u1cxe0" targetRef="Event_0hcbcm9" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0l49ruu">]''',
'      ,q''[      <bpmn:text>Tutorial 8: Keep in Your Lane]''',
'      ,q''[]''',
unistr('      ,q''[We''re now added Lanes to our model to show who does what. \00A0Look at the Left side of the diagram &amp; you can see our Sales, Finance and Shipping lanes.]'''),
'      ,q''[When you run the process, you can see the task information in the Process Monitor shows which Lane each current task is in.]''',
'      ,q''[]''',
unistr('      ,q''[Using Lanes can be very helpful when you model your processes. \00A0 We''ll look at Task Assignment in more detail in Tutorials 6a, b, and c....</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_024tpq3" sourceRef="Activity_1fb79se" targetRef="TextAnnotation_0l49ruu" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1q7qdra">]''',
'      ,q''[      <bpmn:text>This is a Terminate End - which immediately ends the process if it is in the top level of the process.]''',
'      ,q''[]''',
unistr('      ,q''[You can control how the process shows up in your monitoring after Termination End by setting the ''Completed Status'' in the modeler. \00A0 This controls whether the process has a normal ''completed'' status, or a ''terminated'' status after an abnor')
||unistr('mal end.\00A0 Set in the properties panel. --&gt;]'''),
'      ,q''[]''',
'      ,q''[If it''s inside a Sub-Process, it ends the sub Process and any embedded processes &amp; returns control to the parent process.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_18cs70j" sourceRef="Event_1fqq9sr" targetRef="TextAnnotation_1q7qdra" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Collaboration_1rka1qz">]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_0o8ym8r_di" bpmnElement="Participant_0o8ym8r" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="220" y="100" width="1810" height="894" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_03etxno_di" bpmnElement="Lane_03etxno" isHorizontal="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="250" y="690" width="1780" height="304" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_06y2vip_di" bpmnElement="Lane_06y2vip" isHorizontal="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="250" y="420" width="1780" height="270" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_1di2z70_di" bpmnElement="Lane_1di2z70" isHorizontal="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="250" y="100" width="1780" height="320" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_15p5zwa_di" bpmnElement="Event_15p5zwa">]''',
'      ,q''[        <dc:Bounds x="372" y="262" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="379" y="305" width="22" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1fb79se_di" bpmnElement="Activity_1fb79se">]''',
'      ,q''[        <dc:Bounds x="460" y="240" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1tdosqr_di" bpmnElement="Gateway_0xszxbu">]''',
'      ,q''[        <dc:Bounds x="615" y="255" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1hvg7i1_di" bpmnElement="Gateway_1hvg7i1" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="875" y="735" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="872" y="705" width="57" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0ujpq6a_di" bpmnElement="Event_1fqq9sr">]''',
'      ,q''[        <dc:Bounds x="982" y="842" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="960" y="885" width="80" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0uu1z3t_di" bpmnElement="Gateway_0ctvx3o">]''',
'      ,q''[        <dc:Bounds x="1425" y="535" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0op2vlf_di" bpmnElement="Activity_1bbwgpd">]''',
'      ,q''[        <dc:Bounds x="1500" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1xvxmx2_di" bpmnElement="Activity_080aaf2">]''',
'      ,q''[        <dc:Bounds x="720" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_150wweq_di" bpmnElement="Activity_00ou09q">]''',
'      ,q''[        <dc:Bounds x="880" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0qvcf9e_di" bpmnElement="Activity_1enngrb">]''',
'      ,q''[        <dc:Bounds x="1040" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0t823hl_di" bpmnElement="Activity_1btthx3">]''',
'      ,q''[        <dc:Bounds x="720" y="240" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1novl0e_di" bpmnElement="Activity_0a9stdf">]''',
'      ,q''[        <dc:Bounds x="720" y="720" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06icm2o_di" bpmnElement="Activity_1r5snya">]''',
'      ,q''[        <dc:Bounds x="980" y="720" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0qnu0yv_di" bpmnElement="Activity_0rghtfj">]''',
'      ,q''[        <dc:Bounds x="1140" y="720" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0e3ved3_di" bpmnElement="Activity_0lm6w3e">]''',
'      ,q''[        <dc:Bounds x="1300" y="720" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1uzm09b_di" bpmnElement="Gateway_1uzm09b" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1625" y="535" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1626" y="592" width="48" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0j2a5z0_di" bpmnElement="Activity_0j2a5z0">]''',
'      ,q''[        <dc:Bounds x="1700" y="520" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0052vug_di" bpmnElement="Event_0052vug">]''',
'      ,q''[        <dc:Bounds x="1832" y="542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1840" y="585" width="20" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0u1cxe0_di" bpmnElement="Activity_0u1cxe0">]''',
'      ,q''[        <dc:Bounds x="1700" y="240" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0hcbcm9_di" bpmnElement="Event_0hcbcm9">]''',
'      ,q''[        <dc:Bounds x="1832" y="262" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1806" y="305" width="89" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0l49ruu_di" bpmnElement="TextAnnotation_0l49ruu">]''',
'      ,q''[        <dc:Bounds x="560" y="120" width="915" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1q7qdra_di" bpmnElement="TextAnnotation_1q7qdra">]''',
'      ,q''[        <dc:Bounds x="1070" y="810" width="570" height="150" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0kubj9p_di" bpmnElement="Flow_0kubj9p">]''',
'      ,q''[        <di:waypoint x="408" y="280" />]''',
'      ,q''[        <di:waypoint x="460" y="280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ry9q57_di" bpmnElement="Flow_0ry9q57">]''',
'      ,q''[        <di:waypoint x="560" y="280" />]''',
'      ,q''[        <di:waypoint x="615" y="280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1air6n9_di" bpmnElement="Flow_1air6n9">]''',
'      ,q''[        <di:waypoint x="665" y="280" />]''',
'      ,q''[        <di:waypoint x="720" y="280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_06iqwjh_di" bpmnElement="Flow_06iqwjh">]''',
'      ,q''[        <di:waypoint x="640" y="305" />]''',
'      ,q''[        <di:waypoint x="640" y="560" />]''',
'      ,q''[        <di:waypoint x="720" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ututkm_di" bpmnElement="Flow_1ututkm">]''',
'      ,q''[        <di:waypoint x="820" y="560" />]''',
'      ,q''[        <di:waypoint x="880" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1pyqngd_di" bpmnElement="Flow_1pyqngd">]''',
'      ,q''[        <di:waypoint x="980" y="560" />]''',
'      ,q''[        <di:waypoint x="1040" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08s6jze_di" bpmnElement="Flow_08s6jze">]''',
'      ,q''[        <di:waypoint x="640" y="305" />]''',
'      ,q''[        <di:waypoint x="640" y="760" />]''',
'      ,q''[        <di:waypoint x="720" y="760" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_006uuj2_di" bpmnElement="Flow_006uuj2">]''',
'      ,q''[        <di:waypoint x="820" y="760" />]''',
'      ,q''[        <di:waypoint x="875" y="760" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1aa0af4_di" bpmnElement="Flow_1aa0af4">]''',
'      ,q''[        <di:waypoint x="925" y="760" />]''',
'      ,q''[        <di:waypoint x="980" y="760" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="949" y="742" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1tof406_di" bpmnElement="Flow_1tof406">]''',
'      ,q''[        <di:waypoint x="900" y="785" />]''',
'      ,q''[        <di:waypoint x="900" y="860" />]''',
'      ,q''[        <di:waypoint x="982" y="860" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="911" y="820" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_10doy19_di" bpmnElement="Flow_10doy19">]''',
'      ,q''[        <di:waypoint x="1080" y="760" />]''',
'      ,q''[        <di:waypoint x="1140" y="760" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1071r1d_di" bpmnElement="Flow_1071r1d">]''',
'      ,q''[        <di:waypoint x="820" y="280" />]''',
'      ,q''[        <di:waypoint x="1450" y="280" />]''',
'      ,q''[        <di:waypoint x="1450" y="535" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0al8eiu_di" bpmnElement="Flow_0al8eiu">]''',
'      ,q''[        <di:waypoint x="1140" y="560" />]''',
'      ,q''[        <di:waypoint x="1425" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1olo1p2_di" bpmnElement="Flow_1olo1p2">]''',
'      ,q''[        <di:waypoint x="1240" y="760" />]''',
'      ,q''[        <di:waypoint x="1300" y="760" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07xilb7_di" bpmnElement="Flow_07xilb7">]''',
'      ,q''[        <di:waypoint x="1400" y="760" />]''',
'      ,q''[        <di:waypoint x="1450" y="760" />]''',
'      ,q''[        <di:waypoint x="1450"'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' y="585" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1da66k3_di" bpmnElement="Flow_1da66k3">]''',
'      ,q''[        <di:waypoint x="1475" y="560" />]''',
'      ,q''[        <di:waypoint x="1500" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qhwtp2_di" bpmnElement="Flow_1qhwtp2">]''',
'      ,q''[        <di:waypoint x="1600" y="560" />]''',
'      ,q''[        <di:waypoint x="1625" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0v4ypbt_di" bpmnElement="Flow_0v4ypbt">]''',
'      ,q''[        <di:waypoint x="1675" y="560" />]''',
'      ,q''[        <di:waypoint x="1700" y="560" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1684" y="533" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0raow5t_di" bpmnElement="Flow_0raow5t">]''',
'      ,q''[        <di:waypoint x="1800" y="560" />]''',
'      ,q''[        <di:waypoint x="1832" y="560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11edvtt_di" bpmnElement="Flow_11edvtt">]''',
'      ,q''[        <di:waypoint x="1650" y="535" />]''',
'      ,q''[        <di:waypoint x="1650" y="280" />]''',
'      ,q''[        <di:waypoint x="1700" y="280" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1661" y="483" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_09hbzak_di" bpmnElement="Flow_09hbzak">]''',
'      ,q''[        <di:waypoint x="1800" y="280" />]''',
'      ,q''[        <di:waypoint x="1832" y="280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_024tpq3_di" bpmnElement="Association_024tpq3">]''',
'      ,q''[        <di:waypoint x="551" y="240" />]''',
'      ,q''[        <di:waypoint x="578" y="216" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_18cs70j_di" bpmnElement="Association_18cs70j">]''',
'      ,q''[        <di:waypoint x="1018" y="857" />]''',
'      ,q''[        <di:waypoint x="1070" y="850" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 6a - Collaborations, Lanes and Reservations'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:collaboration id="Collaboration_05ia5zp">]''',
'      ,q''[    <bpmn:participant id="Participant_0sxtbbr" name="My Revenue Process" processRef="Process_cr2unkh0" />]''',
'      ,q''[    <bpmn:group id="Group_1vb8gzv" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0qxito5">]''',
'      ,q''[      <bpmn:text>Note now that a Lane can be divided into a further set of Lanes by adding a CHILD LANESET inside a LANE</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1ffrhyq" sourceRef="Group_1vb8gzv" targetRef="TextAnnotation_0qxito5" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1b5twef">]''',
'      ,q''[      <bpmn:text>2 Concepts in this Tutorial.]''',
'      ,q''[]''',
unistr('      ,q''[1. \00A0Lanes can be sub-divided into sub-lanes.]'''),
'      ,q''[]''',
unistr('      ,q''[2. \00A0Lanes can be mapped to an APEX Role - or not, as required.</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0idyme6" sourceRef="Activity_173wq6m" targetRef="TextAnnotation_1b5twef" />]''',
'      ,q''[  </bpmn:collaboration>]''',
'      ,q''[  <bpmn:process id="Process_cr2unkh0" isExecutable="false">]''',
'      ,q''[    <bpmn:laneSet id="LaneSet_0t97tel">]''',
'      ,q''[      <bpmn:lane id="Lane_1fip85k" name="Sales" apex:isRole="false" apex:role="SALES">]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0vw62ey</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_173wq6m</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_11jtvuj" name="Finance" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_022oq4a</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1f73a9g</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0c5yeyr</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1f18qvf</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_047jt22</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:childLaneSet id="LaneSet_149q3g6">]''',
'      ,q''[          <bpmn:lane id="Lane_17hsgq6" name="Revenue Recognition Team" apex:isRole="false">]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_1f18qvf</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_047jt22</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:childLaneSet id="LaneSet_12eax3z">]''',
'      ,q''[              <bpmn:lane id="Lane_0g7r886" name="Clerk" apex:isRole="true" apex:role="FIN-REV-REC-CLERK">]''',
'      ,q''[                <bpmn:flowNodeRef>Activity_1f18qvf</bpmn:flowNodeRef>]''',
'      ,q''[              </bpmn:lane>]''',
'      ,q''[              <bpmn:lane id="Lane_16vkzwu" name="Manager" apex:isRole="true" apex:role="FIN-REV-REC-MANAGER">]''',
'      ,q''[                <bpmn:flowNodeRef>Activity_047jt22</bpmn:flowNodeRef>]''',
'      ,q''[              </bpmn:lane>]''',
'      ,q''[            </bpmn:childLaneSet>]''',
'      ,q''[          </bpmn:lane>]''',
'      ,q''[          <bpmn:lane id="Lane_1ok0dgu" name="Sales Compensation" apex:isRole="true" apex:role="FINANCE-COMP-AP">]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_022oq4a</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_1f73a9g</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_0c5yeyr</bpmn:flowNodeRef>]''',
'      ,q''[          </bpmn:lane>]''',
'      ,q''[        </bpmn:childLaneSet>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[    </bpmn:laneSet>]''',
'      ,q''[    <bpmn:startEvent id="Event_0vw62ey">]''',
'      ,q''[      <bpmn:outgoing>Flow_0sm1nql</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_173wq6m" name="Enter Sales Deal">]''',
'      ,q''[      <bpmn:incoming>Flow_0sm1nql</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ufs4r3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0sm1nql" sourceRef="Event_0vw62ey" targetRef="Activity_173wq6m" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ufs4r3" sourceRef="Activity_173wq6m" targetRef="Activity_1f18qvf" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1csiktc" sourceRef="Activity_1f18qvf" targetRef="Activity_047jt22" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0k0njn0" sourceRef="Activity_047jt22" targetRef="Activity_022oq4a" />]''',
'      ,q''[    <bpmn:task id="Activity_022oq4a" name="Setup Commission Payment">]''',
'      ,q''[      <bpmn:incoming>Flow_0k0njn0</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0it1bo5</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0it1bo5" sourceRef="Activity_022oq4a" targetRef="Activity_1f73a9g" />]''',
'      ,q''[    <bpmn:callActivity id="Activity_1f73a9g" name="Make Staff Payment" apex:manualInput="false" apex:calledDiagramVersionSelection="latestVersion">]''',
'      ,q''[      <bpmn:incoming>Flow_0it1bo5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_03pg83c</bpmn:outgoing>]''',
'      ,q''[    </bpmn:callActivity>]''',
'      ,q''[    <bpmn:endEvent id="Event_0c5yeyr">]''',
'      ,q''[      <bpmn:incoming>Flow_03pg83c</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_03pg83c" sourceRef="Activity_1f73a9g" targetRef="Event_0c5yeyr" />]''',
'      ,q''[    <bpmn:userTask id="Activity_1f18qvf" name="Confirm Sales Team Engagement Plan" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_0ufs4r3</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1csiktc</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_047jt22" name="Approve Commission Payment" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_1csiktc</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0k0njn0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0v3fgmw">]''',
unistr('      ,q''[      <bpmn:text>Some BPMN Lanes map nicely to ROLES in your Privilege Management System \00A0(database / OIM / AD, etc.). \00A0But some are more like useful process modelling concepts and aren''t useful for routing a particular task to a specific p')
||'erson / group in your organization.]''',
'      ,q''[]''',
'      ,q''[Now if you select the LANE Object, look in the Properties Panel under ''APEX Role'', and you can see a Switch to denote that this Lane maps to an APEX Role, and if so, allows you to specify the default ROLE that tasks in this lane will be ass'
||'igned to.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_04blk6w" sourceRef="Activity_047jt22" targetRef="TextAnnotation_0v3fgmw" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Collaboration_05ia5zp">]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_0sxtbbr_di" bpmnElement="Participant_0sxtbbr" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="330" y="120" width="1480" height="760" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_11jtvuj_di" bpmnElement="Lane_11jtvuj" isHorizontal="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="360" y="450" width="1450" height="430" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_1ok0dgu_di" bpmnElement="Lane_1ok0dgu" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="390" y="690" width="1420" height="190" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_17hsgq6_di" bpmnElement="Lane_17hsgq6" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="390" y="450" width="1420" height="240" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_16vkzwu_di" bpmnElement="Lane_16vkzwu" isHorizontal="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="420" y="570" width="1390" height="120" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_0g7r886_di" bpmnElement="Lane_0g7r886" isHorizontal="true" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="420" y="450" width="1390" height="120" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_1fip85k_di" bpmnElement="Lane_1fip85k" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="360" y="120" width="1450" height="330" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0vw62ey_di" bpmnElement="Event_0vw62ey">]''',
'      ,q''[        <dc:Bounds x="482" y="282" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_173wq6m_di" bpmnElement="Activity_173wq6m">]''',
'      ,q''[        <dc:Bounds x="570" y="260" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_022oq4a_di" bpmnElement="Activity_022oq4a">]''',
'      ,q''[        <dc:Bounds x="1050" y="740" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1xva8lv_di" bpmnElement="Activity_1f73a9g">]''',
'      ,q''[        <dc:Bounds x="1210" y="740" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0c5yeyr_di" bpmnElement="Event_0c5yeyr">]''',
'      ,q''[        <dc:Bounds x="1372" y="762" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1lsy29w_di" bpmnElement="Activity_1f18qvf">]''',
'      ,q''[        <dc:Bounds x="730" y="470" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0kto05l_di" bpmnElement="Activity_047jt22">]''',
'      ,q''[        <dc:Bounds x="890" y="590" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0v3fgmw_di" bpmnElement="TextAnnotation_0v3fgmw">]''',
'      ,q''[        <dc:Bounds x="980" y="230" width="520" height="150" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0sm1nql_di" bpmnElement="Flow_0sm1nql">]''',
'      ,q''[        <di:waypoint x="518" y="300" />]''',
'      ,q''[        <di:waypoint x="570" y="300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ufs4r3_di" bpmnElement="Flow_0ufs4r3">]''',
'      ,q''[        <di:waypoint x="670" y="300" />]''',
'      ,q''[        <di:waypoint x="690" y="300" />]''',
'      ,q''[        <di:waypoint x="690" y="510" />]''',
'      ,q''[        <di:waypoint x="730" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1csiktc_di" bpmnElement="Flow_1csiktc">]''',
'      ,q''[        <di:waypoint x="830" y="510" />]''',
'      ,q''[        <di:waypoint x="860" y="510" />]''',
'      ,q''[        <di:waypoint x="860" y="630" />]''',
'      ,q''[        <di:waypoint x="890" y="630" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0k0njn0_di" bpmnElement="Flow_0k0njn0">]''',
'      ,q''[        <di:waypoint x="990" y="630" />]''',
'      ,q''[        <di:waypoint x="1020" y="630" />]''',
'      ,q''[        <di:waypoint x="1020" y="780" />]''',
'      ,q''[        <di:waypoint x="1050" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0it1bo5_di" bpmnElement="Flow_0it1bo5">]''',
'      ,q''[        <di:waypoint x="1150" y="780" />]''',
'      ,q''[        <di:waypoint x="1210" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03pg83c_di" bpmnElement="Flow_03pg83c">]''',
'      ,q''[        <di:waypoint x="1310" y="780" />]''',
'      ,q''[        <di:waypoint x="1372" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_04blk6w_di" bpmnElement="Association_04blk6w">]''',
'      ,q''[        <di:waypoint x="949" y="590" />]''',
'      ,q''[        <di:waypoint x="998" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Group_1vb8gzv_di" bpmnElement="Group_1vb8gzv" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="230" y="410" width="300" height="300" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0qxito5_di" bpmnElement="TextAnnotation_0qxito5">]''',
'      ,q''[        <dc:Bounds x="-10" y="190" width="260" height="54" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1b5twef_di" bpmnElement="TextAnnotation_1b5twef">]''',
'      ,q''[        <dc:Bounds x="640" y="-40" width="520" height="82" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1ffrhyq_di" bpmnElement="Association_1ffrhyq">]''',
'      ,q''[        <di:waypoint x="236" y="410" />]''',
'      ,q''[        <di:waypoint x="77" y="244" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0idyme6_di" bpmnElement="Association_0idyme6">]''',
'      ,q''[        <di:waypoint x="629" y="260" />]''',
'      ,q''[        <di:waypoint x="676" y="42" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 6b - Lanes and More Lanes'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:collaboration id="Collaboration_0w37ggk">]''',
'      ,q''[    <bpmn:participant id="Participant_1lsw9xv" name="Expense Reimbursement Process" processRef="Process_f78hz1j5" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1w8l7jz">]''',
'      ,q''[      <bpmn:text>In this Model, See how we use various mechanisms to assign tasks to people...]''',
'      ,q''[]''',
unistr('      ,q''[Any employee can file an expense claim -- but once they do, any rework goes to the originator. \00A0And Approving the Expenses has to be done by the originator''s manager, not by just any manager. \00A0And paying the expenses can be done by anyone h')
||'olding the Accts Payable Expenses role in the Finance Team.]''',
'      ,q''[]''',
'      ,q''[Look at this model to see how we use Lanes, Lane Roles, Process Variables, and Task Assignment settings based on an SQL Query to get all of these tasks performed by the correct person or people.]''',
'      ,q''[]''',
'      ,q''[Having the workflow definition tied to the database enables you to build very powerful process models....</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1rb8dv3" sourceRef="Event_07h3npi" targetRef="TextAnnotation_1w8l7jz" />]''',
'      ,q''[  </bpmn:collaboration>]''',
'      ,q''[  <bpmn:process id="Process_f78hz1j5" isExecutable="false">]''',
'      ,q''[    <bpmn:laneSet id="LaneSet_1wckkhm">]''',
'      ,q''[      <bpmn:lane id="Lane_1heaz13" name="Employee" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Event_07h3npi</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_17d1qse</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1xfh2o5</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_0jqrewd" name="Line Manager" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_05irww6</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_0g8imb3</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:childLaneSet id="LaneSet_0b0q9rm" />]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_1cdvys2" name="Finance - ACCts Payable" apex:isRole="true" apex:role="FINANCE-AP-EXPENSES">]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1d0x2un</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_048i897</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1rxtwce</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[    </bpmn:laneSet>]''',
'      ,q''[    <bpmn:startEvent id="Event_07h3npi">]''',
'      ,q''[      <bpmn:outgoing>Flow_10x7qam</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_10x7qam" sourceRef="Event_07h3npi" targetRef="Activity_17d1qse" />]''',
'      ,q''[    <bpmn:userTask id="Activity_17d1qse" name="Make Expense Claim" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:afterTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>ORIGINATOR</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQuerySingle</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select exp_empno]''',
'      ,q''[  from expense_claim]''',
'      ,q''[ where exp_claim_id = :F4A$BUSINESS_REF</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:afterTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_10x7qam</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1utt5ar</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0hyv87c</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0hyv87c" sourceRef="Activity_17d1qse" targetRef="Activity_05irww6" />]''',
'      ,q''[    <bpmn:userTask id="Activity_05irww6" name="Manager Review" apex:type="apexApproval" apex:manualInput="true">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexApproval>]''',
'      ,q''[          <apex:applicationId>100</apex:applicationId>]''',
'      ,q''[          <apex:resultVariable>EXP_APPROVED</apex:resultVariable>]''',
'      ,q''[        </apex:apexApproval>]''',
'      ,q''[        <apex:potentialUsers>]''',
'      ,q''[          <apex:expressionType>sqlQuerySingle</apex:expressionType>]''',
'      ,q''[          <apex:expression>select mgr.ename]''',
'      ,q''[  from emp mgr]''',
'      ,q''[  join emp originator]''',
'      ,q''[    on originator.mgr = mgr.empno]''',
'      ,q''[ where originator.empn0 = :F4A$ORIGINATOR</apex:expression>]''',
'      ,q''[        </apex:potentialUsers>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0hyv87c</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0b8ltiw</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_0g8imb3" name="Approved?">]''',
'      ,q''[      <bpmn:incoming>Flow_0b8ltiw</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0rghka5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_07qvq2z</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0b8ltiw" sourceRef="Activity_05irww6" targetRef="Gateway_0g8imb3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0rghka5" name=":F4A$EXP_APPROVED = &#39;Y&#39;" sourceRef="Gateway_0g8imb3" targetRef="Activity_1rxtwce" apex:sequence="10">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$EXP_APPROVED = ''Y''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:task id="Activity_1d0x2un" name="Make Payment">]''',
'      ,q''[      <bpmn:incoming>Flow_0fp9ehs</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_10mx95n</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0fp9ehs" sourceRef="Activity_1rxtwce" targetRef="Activity_1d0x2un" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_10mx95n" sourceRef="Activity_1d0x2un" targetRef="Activity_048i897" />]''',
'      ,q''[    <bpmn:serviceTask id="Activity_048i897" name="Notify Employee" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:incoming>Flow_10mx95n</bpmn:incoming>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07qvq2z" name=":F4A$EXP_APPROVED = &#39;N&#39;" sourceRef="Gateway_0g8imb3" targetRef="Activity_1xfh2o5" apex:sequence="20">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$EXP_APPROVED = ''N''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1utt5ar" sourceRef="Activity_1xfh2o5" targetRef="Activity_17d1qse" apex:sequence="10" />]''',
'      ,q''[    <bpmn:userTask id="Activity_1xfh2o5" name="Rework Claim" apex:type="apexPage" apex:manualInput="true">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:potentialUsers>]''',
'      ,q''[          <apex:expressionType>sqlQuerySingle</apex:expressionType>]''',
'      ,q''[          <apex:expression>select ename]''',
'      ,q''[  from emp]''',
'      ,q''[ where empno = :F4A$ORIGINATOR</apex:expression>]''',
'      ,q''[        </apex:potentialUsers>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_07qvq2z</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1utt5ar</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_1rxtwce" name="Arrange Payment" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_0rghka5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0fp9ehs</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1j723td">]''',
'      ,q''[      <bpmn:text>Claim sets Process Variable ''ORIGINATOR'' to the Employee ID (empno) of the Employee</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1luyp15" sourceRef="Activity_17d1qse" targetRef="TextAnnotation_1j723td" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0rornk9">]''',
'      ,q''[      <bpmn:text>See that This Task is Assigned to the Employee who originated the process.]''',
'      ,q''[]''',
'      ,q''[Look at Task Assignment - set by a SQL Query to the user who oriented the process...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_136oa8m" sourceRef="Activity_1xfh2o5" targetRef="TextAnnotation_0rornk9" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0spwhxv">]''',
'      ,q''[      <bpmn:text>See how the Task for the Manager''s. Review is assigned to their manager set by a SQL query to get the Originator''s Manager from the EMPLOYEE table...]''',
'      ,q''[]''',
unistr('      ,q''[And Manager needs be the Claiming Employee''s Manager, not just any manager in the company. \00A0So we don''t map the Manager Lane to a role - but instead use the Task Assignment by SQL Query to look up the appropriate manager and assign them the')
||' approval task.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1ka600q" sourceRef="Activity_05irww6" targetRef="TextAnnotation_0spwhxv" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0xje0fi">]''',
unistr('      ,q''[      <bpmn:text>This task is assigned to a Role - the Finance - Accts Payable _ Expenses Clerk role. \00A0Anyone holding that role can perform this task...</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_17p3o3l" sourceRef="Activity_1rxtwce" targetRef="TextAnnotation_0xje0fi" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Collaboration_0w37ggk">]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_1lsw9xv_di" bpmnElement="Participant_1lsw9xv" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="270" y="90" width="1600" height="820" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_1cdvys2_di" bpmnElement="Lane_1cdvys2" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="300" y="650" width="1570" height="260" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_0jqrewd_di" bpmnElement="Lane_0jqrewd" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="300" y="420" width="1570" height="230" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_1heaz13_di" bpmnElement="Lane_1heaz13" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="300" y="90" width="1570" height="330" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_07h3npi_di" bpmnElement="Event_07h3npi" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="412" y="252" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0we3s6f_di" bpmnElement="Activity_17d1qse" bioc:stroke="#6b3c00" bioc'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="500" y="230" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_143ubv9_di" bpmnElement="Activity_05irww6" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="670" y="490" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0g8imb3_di" bpmnElement="Gateway_0g8imb3" isMarkerVisible="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="845" y="505" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="783" y="493" width="54" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1d0x2un_di" bpmnElement="Activity_1d0x2un" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1130" y="740" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0yxt9tw_di" bpmnElement="Activity_048i897" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1300" y="740" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1wpm7mn_di" bpmnElement="Activity_1xfh2o5" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="820" y="230" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0pbfrvi_di" bpmnElement="Activity_1rxtwce" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="960" y="740" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1j723td_di" bpmnElement="TextAnnotation_1j723td">]''',
'      ,q''[        <dc:Bounds x="670" y="130" width="190" height="90" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0rornk9_di" bpmnElement="TextAnnotation_0rornk9">]''',
'      ,q''[        <dc:Bounds x="980" y="134" width="340" height="82" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0spwhxv_di" bpmnElement="TextAnnotation_0spwhxv" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="440" y="710" width="330" height="180" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0xje0fi_di" bpmnElement="TextAnnotation_0xje0fi">]''',
'      ,q''[        <dc:Bounds x="1060" y="660" width="500" height="70" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_10x7qam_di" bpmnElement="Flow_10x7qam">]''',
'      ,q''[        <di:waypoint x="448" y="270" />]''',
'      ,q''[        <di:waypoint x="500" y="270" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0hyv87c_di" bpmnElement="Flow_0hyv87c">]''',
'      ,q''[        <di:waypoint x="550" y="310" />]''',
'      ,q''[        <di:waypoint x="550" y="530" />]''',
'      ,q''[        <di:waypoint x="670" y="530" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0b8ltiw_di" bpmnElement="Flow_0b8ltiw">]''',
'      ,q''[        <di:waypoint x="770" y="530" />]''',
'      ,q''[        <di:waypoint x="845" y="530" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0rghka5_di" bpmnElement="Flow_0rghka5" bioc:stroke="#205022" color:border-color="#205022">]''',
'      ,q''[        <di:waypoint x="870" y="555" />]''',
'      ,q''[        <di:waypoint x="870" y="780" />]''',
'      ,q''[        <di:waypoint x="960" y="780" />]''',
'      ,q''[        <bpmndi:BPMNLabel color:color="#205022">]''',
'      ,q''[          <dc:Bounds x="880" y="566" width="80" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0fp9ehs_di" bpmnElement="Flow_0fp9ehs">]''',
'      ,q''[        <di:waypoint x="1060" y="780" />]''',
'      ,q''[        <di:waypoint x="1130" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_10mx95n_di" bpmnElement="Flow_10mx95n">]''',
'      ,q''[        <di:waypoint x="1230" y="780" />]''',
'      ,q''[        <di:waypoint x="1300" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07qvq2z_di" bpmnElement="Flow_07qvq2z" bioc:stroke="#831311" color:border-color="#831311">]''',
'      ,q''[        <di:waypoint x="870" y="505" />]''',
'      ,q''[        <di:waypoint x="870" y="310" />]''',
'      ,q''[        <bpmndi:BPMNLabel color:color="#831311">]''',
'      ,q''[          <dc:Bounds x="876" y="462" width="88" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1utt5ar_di" bpmnElement="Flow_1utt5ar" bioc:stroke="#831311" color:border-color="#831311">]''',
'      ,q''[        <di:waypoint x="820" y="270" />]''',
'      ,q''[        <di:waypoint x="600" y="270" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1luyp15_di" bpmnElement="Association_1luyp15">]''',
'      ,q''[        <di:waypoint x="598" y="235" />]''',
'      ,q''[        <di:waypoint x="670" y="182" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_136oa8m_di" bpmnElement="Association_136oa8m">]''',
'      ,q''[        <di:waypoint x="918" y="234" />]''',
'      ,q''[        <di:waypoint x="980" y="187" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1ka600q_di" bpmnElement="Association_1ka600q">]''',
'      ,q''[        <di:waypoint x="678" y="569" />]''',
'      ,q''[        <di:waypoint x="526" y="710" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_17p3o3l_di" bpmnElement="Association_17p3o3l">]''',
'      ,q''[        <di:waypoint x="1048" y="740" />]''',
'      ,q''[        <di:waypoint x="1060" y="728" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1w8l7jz_di" bpmnElement="TextAnnotation_1w8l7jz">]''',
'      ,q''[        <dc:Bounds x="680" y="-90" width="670" height="170" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1rb8dv3_di" bpmnElement="Association_1rb8dv3">]''',
'      ,q''[        <di:waypoint x="442" y="257" />]''',
'      ,q''[        <di:waypoint x="680" y="-17" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 6c - User Assignment - Putting it all together'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:collaboration id="Collaboration_7a">]''',
'      ,q''[    <bpmn:participant id="Participant_11y0cdc" name="My Process" processRef="Tutorial_7a" />]''',
'      ,q''[    <bpmn:participant id="Participant_1n4c4l0" name="This is an &#39;Empty Pool&#39; and represents another process as a &#39;Black Box&#39; - i.e., we don&#39;t know about the internal implementation details." />]''',
'      ,q''[    <bpmn:participant id="Participant_0qabxrw" name="Another Process" processRef="Process_0u5as8x" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_1mf0t72" sourceRef="Activity_0izlkl1" targetRef="Participant_1n4c4l0" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_19l2sy0" sourceRef="Participant_1n4c4l0" targetRef="Activity_0izlkl1" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_0hqqiiu" sourceRef="Activity_0mhkzh2" targetRef="Participant_1n4c4l0" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_1rtp00p" sourceRef="Participant_1n4c4l0" targetRef="Activity_0zzol2u" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_1h2ekkn" sourceRef="Event_0m1a6k2" targetRef="Event_1k9dkfm" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_13gq3gc" sourceRef="Event_1m4gahw" targetRef="Event_02gdru8" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_07c9y3f" sourceRef="Activity_1w25uqw" targetRef="Event_1qhlqtm" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0gyba6i">]''',
unistr('      ,q''[      <bpmn:text>We can also put\00A0]'''),
unistr('      ,q''[message boundary events* \00A0onto tasks, subProcesses, and Call Activities. \00A0These can interrupt or be non-interrupting</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1nxz8a7">]''',
unistr('      ,q''[      <bpmn:text>This is another process, which gets \00A0started by an incoming message</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0igizeg" associationDirection="None" sourceRef="Event_1qhlqtm" targetRef="TextAnnotation_1nxz8a7" />]''',
'      ,q''[  </bpmn:collaboration>]''',
'      ,q''[  <bpmn:process id="Tutorial_7a" name="Tutorial 7a - MessageFlow Basics" isExecutable="false">]''',
'      ,q''[    <bpmn:laneSet id="LaneSet_0zv5eda">]''',
'      ,q''[      <bpmn:lane id="Lane_136ry9p" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0s323xl</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0mhkzh2</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_12krons</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0zzol2u</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1cmxdp7</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0s2za6d</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0izlkl1</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_0zba19v</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1u4gq6u</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_1gb2wji</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1w25uqw</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_0uo74go" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_04nvebw</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0t1ev9d</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1id6b5x</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0fixygu</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0m1a6k2</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_02gdru8</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[    </bpmn:laneSet>]''',
'      ,q''[    <bpmn:startEvent id="Event_0s323xl">]''',
'      ,q''[      <bpmn:outgoing>Flow_17b6g1h</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_17b6g1h" sourceRef="Event_0s323xl" targetRef="Activity_0izlkl1" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0xtgyk0" sourceRef="Activity_0izlkl1" targetRef="Activity_1u4gq6u" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1bw7mvj" sourceRef="Activity_1u4gq6u" targetRef="Activity_1w25uqw" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0a9vat2" sourceRef="Gateway_1gb2wji" targetRef="Activity_0mhkzh2" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sendTask id="Activity_0mhkzh2" name="SendTask" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0a9vat2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1co4h5b</bpmn:outgoing>]''',
'      ,q''[    </bpmn:sendTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_111ldh8" sourceRef="Gateway_1gb2wji" targetRef="Activity_0zzol2u" apex:sequence="20" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0wa3yvx" sourceRef="Gateway_1gb2wji" targetRef="Event_0m1a6k2" apex:sequence="30" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1u9z9zl" sourceRef="Gateway_1gb2wji" targetRef="Event_02gdru8" apex:sequence="40" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02w8qhh" sourceRef="Gateway_1gb2wji" targetRef="Activity_0fixygu" apex:sequence="50" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1co4h5b" sourceRef="Activity_0mhkzh2" targetRef="Gateway_12krons" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_12krons">]''',
'      ,q''[      <bpmn:incoming>Flow_1co4h5b</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_149xi7o</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1pxnz40</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0umsd4h</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0vmcx38</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0g67vgs</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_149xi7o" sourceRef="Activity_0zzol2u" targetRef="Gateway_12krons" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1pxnz40" sourceRef="Activity_0fixygu" targetRef="Gateway_12krons" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0umsd4h" sourceRef="Event_0m1a6k2" targetRef="Gateway_12krons" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0vmcx38" sourceRef="Event_02gdru8" targetRef="Gateway_12krons" apex:sequence="10" />]''',
'      ,q''[    <bpmn:receiveTask id="Activity_0zzol2u" name="ReceiveTask" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_111ldh8</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_149xi7o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:receiveTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1inbmjx" sourceRef="Gateway_0zba19v" targetRef="Activity_1cmxdp7" apex:sequence="10" />]''',
'      ,q''[    <bpmn:task id="Activity_1cmxdp7" name="A Message Has to exactly match the subscription created for it">]''',
'      ,q''[      <bpmn:incoming>Flow_1inbmjx</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0g67vgs" sourceRef="Gateway_12krons" targetRef="Gateway_0zba19v" apex:sequence="20" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0p4dldk" sourceRef="Gateway_0zba19v" targetRef="Activity_0s2za6d" />]''',
'      ,q''[    <bpmn:task id="Activity_0s2za6d" name="A subscription must be created by the receiver before the message is sent">]''',
'      ,q''[      <bpmn:incoming>Flow_0p4dldk</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_05lb32a" sourceRef="Gateway_0zba19v" targetRef="Activity_04nvebw" />]''',
'      ,q''[    <bpmn:task id="Activity_04nvebw" name="in 23.1 message flow is only between processes in the same workspace">]''',
'      ,q''[      <bpmn:incoming>Flow_05lb32a</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0vmjyh0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0vmjyh0" sourceRef="Activity_04nvebw" targetRef="Activity_0t1ev9d" />]''',
'      ,q''[    <bpmn:task id="Activity_0t1ev9d" name="....but we hope to add more capabilities soon!">]''',
'      ,q''[      <bpmn:incoming>Flow_0vmjyh0</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_1id6b5x" name="Tutorials 7b and 7c can be run to show message flow..">]''',
'      ,q''[      <bpmn:incoming>Flow_1h798dh</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1h798dh" sourceRef="Gateway_0zba19v" targetRef="Activity_1id6b5x" />]''',
'      ,q''[    <bpmn:task id="Activity_0fixygu" name="..or you can use message Events (better practice)">]''',
'      ,q''[      <bpmn:incoming>Flow_02w8qhh</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1pxnz40</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_0izlkl1" name="Messageflow allows you to pass messages into or out of a process">]''',
'      ,q''[      <bpmn:incoming>Flow_17b6g1h</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0xtgyk0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_0zba19v">]''',
'      ,q''[      <bpmn:incoming>Flow_0g67vgs</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1inbmjx</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0p4dldk</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_05lb32a</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1h798dh</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_09nusca" sourceRef="Activity_1w25uqw" targetRef="Gateway_1gb2wji" />]''',
'      ,q''[    <bpmn:task id="Activity_1u4gq6u" name="A Receiver subscribes to a message then waits for it to arrive">]''',
'      ,q''[      <bpmn:incoming>Flow_0xtgyk0</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1bw7mvj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1gb2wji">]''',
'      ,q''[      <bpmn:incoming>Flow_09nusca</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0a9vat2</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_111ldh8</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0wa3yvx</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1u9z9zl</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_02w8qhh</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sendTask id="Activity_1w25uqw" name="Send Task" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1bw7mvj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_09nusca</bpmn:outgoing>]''',
'      ,q''[    </bpmn:sendTask>]''',
'      ,q''[    <bpmn:intermediateThrowEvent id="Event_0m1a6k2" name="Message Throw Event" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0wa3yvx</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0umsd4h</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0v9snn7" />]''',
'      ,q''[    </bpmn:intermediateThrowEvent>]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_02gdru8" name="Message Catch Event" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1u9z9zl</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0vmcx38</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_10qaiem" />]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0iqi3gb">]''',
'      ,q''[      <bpmn:text>MessageFlow only works BETWEEN processes and CANNOT be used WITHIN a process - where you use Sequence Flow (solid lines)</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0g76b8t">]''',
'      ,q''[      <bpmn:text>Don''t run this tutorial</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_055qq8e" sourceRef="Event_0s323xl" targetRef="TextAnnotation_0g76b8t" />]''',
'      ,q''[    <bpmn:association id="Association_10wi0mu" sourceRef="Activity_0izlkl1" targetRef="TextAnnotation_0iqi3gb" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmn:process id="Process_0u5as8x">]''',
'      ,q''[    <bpmn:startEvent id="Event_1qhlqtm" name="Message Start Event *" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:outgoing>Flow_1ksryuz</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0nlo0kb" />]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ksryuz" sourceRef="Event_1qhlqtm" targetRef="Activity_064bqdb" />]''',
'      ,q''[    <bpmn:task id="Activity_064bqdb" name="This process was started by the incoming message">]''',
'      ,q''[      <bpmn:incoming>Flow_1ksryuz</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_14l9gvf</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_14l9gvf" sourceRef="Activity_064bqdb" targetRef="Event_1k9dkfm" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0j888id" sourceRef="Event_1k9dkfm" targetRef="Event_1m4gahw" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_03pslu3" sourceRef="Event_1m4gahw" targetRef="Event_0bqx3lb" />]''',
'      ,q''[    <bpmn:task id="Activity_1k56x55" name="Task">]''',
'      ,q''[      <bpmn:outgoing>Flow_07deqwm</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_1bft1qt" name="Non-Interrupting Message Boundary Event*" apex:type="simpleMessage" cancelActivity="false" attachedToRef="Activity_1k56x55">]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1nlcya3" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_12pdldq" name="Interrupting Message Boundary Event*" apex:type="simpleMessage" attachedToRef="Activity_1k56x55">]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0pz73ap" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_07deqwm" sourceRef="Activity_1k56x55" targetRef="Activity_0zw04ka" />]''',
'      ,q''[    <bpmn:subProcess id="Activity_0zw04ka" name="Sub Process">]''',
'      ,q''[      <bpmn:incoming>Flow_07deqwm</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0twpz2i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_1y7gbua" name="Non-Interrupting Message Boundary Event*" apex:type="simpleMessage" cancelActivity="false" attachedToRef="Activity_0zw04ka">]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_04uruif" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_03560w5" name="Interrupting Message Boundary Event*" apex:type="simpleMessage" attachedToRef="Activity_0zw04ka">]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1fqemmv" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
unistr('      ,q''[    <bpmn:intermediateCatchEvent id="Event_1k9dkfm" name="Message Catch\00A0&#10;- waits for\00A0&#10;matched incoming message" apex:type="simpleMessage">]'''),
'      ,q''[      <bpmn:incoming>Flow_14l9gvf</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0j888id</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1fmx7hd" />]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:intermediateThrowEvent id="Event_1m4gahw" name="Message Throw Sends a Message" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0j888id</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_03pslu3</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_07ab261" />]''',
'      ,q''[    </bpmn:intermediateThrowEvent>]''',
unistr('      ,q''[    <bpmn:endEvent id="Event_0bqx3lb" name="Message End Event *&#10;- throws a\00A0&#10;message when it ends" apex:type="simpleMessage">]'''),
'      ,q''[      <bpmn:incoming>Flow_03pslu3</bpmn:incoming>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0381hmv" />]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:callActivity id="Activity_17locw8" name="Call Activity" apex:manualInput="false" apex:calledDiagramVersionSelection="latestVersion">]''',
'      ,q''[      <bpmn:incoming>Flow_0twpz2i</bpmn:incoming>]''',
'      ,q''[    </bpmn:callActivity>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0twpz2i" sourceRef="Activity_0zw04ka" targetRef="Activity_17locw8" />]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_16ppomb" name="Interrupting Message Boundary Event*" apex:type="simpleMessage" attachedToRef="Activity_17locw8">]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1ao7gro" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_15i3bqd" name="Non-Interrupting Message Boundary Event*" apex:type="simpleMessage" cancelActivity="false" attachedToRef="Activity_17locw8">]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0s312sl" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:association id="Association_0hbfzmk" associationDirection="None" sourceRef="Event_0bqx3lb" targetRef="TextAnnotation_0gyba6i" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Collaboration_7a">]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_11y0cdc_di" bpmnElement="Participant_11y0cdc" isHorizontal="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="210" y="340" width="1430" height="570" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_0uo74go_di" bpmnElement="Lane_0uo74go" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="240" y="615" width="1400" height="295" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_136ry9p_di" bpmnElement="Lane_136ry9p" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="240" y="340" width="1400" height="275" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0s323xl_di" bpmnElement="Event_0s323xl">]''',
'      ,q''[        <dc:Bounds x="282" y="502" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1cxnaxb_di" bpmnElement="Activity_0mhkzh2">]''',
'      ,q''[        <dc:Bounds x="780" y="360" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_12krons_di" bpmnElement="Gateway_12krons" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="955" y="495" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1jcn5z7_di" bpmnElement="Activity_0zzol2u">]''',
'      ,q''[        <dc:Bounds x="830" y="480" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1cmxdp7_di" bpmnElement="Activity_1cmxdp7">]''',
'      ,q''[        <dc:Bounds x="1220" y="410" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0s2za6d_di" bpmnElement="Activity_0s2za6d">]''',
'      ,q''[        <dc:Bounds x="1220" y="530" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_04nvebw_di" bpmnElement="Activity_04nvebw">]''',
'      ,q''[        <dc:Bounds x="1220" y="650" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0t1ev9d_di" bpmnElement="Activity_0t1ev9d">]''',
'      ,q''[        <dc:Bounds x="1360" y="650" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1id6b5x_di" bpmnElement="Activity_1id6b5x">]''',
'      ,q''[        <dc:Bounds x="1220" y="810" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0fixygu_di" bpmnElement="Activity_0fixygu">]''',
'      ,q''[        <dc:Bounds x="780" y="580" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0izlkl1_di" bpmnElement="Activity_0izlkl1">]''',
'      ,q''[        <dc:Bounds x="350" y="480" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_04a3o2p_di" bpmnElement="Gateway_0zba19v">]''',
'      ,q''[        <dc:Bounds x="1105" y="495" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1u4gq6u_di" bpmnElement="Activity_1u4gq6u">]''',
'      ,q''[        <dc:Bounds x="470" y="480" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1gb2wji_di" bpmnElement="Gateway_1gb2wji" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="725" y="495" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_052ti0x_di" bpmnElement="Activity_1w25uqw" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="600" y="480" width="100" h'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'eight="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1euj7p8_di" bpmnElement="Event_0m1a6k2" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="782" y="722" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="830" y="746" width="79" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0vatlax_di" bpmnElement="Event_02gdru8" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="902" y="812" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="901" y="776" width="77" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0iqi3gb_di" bpmnElement="TextAnnotation_0iqi3gb">]''',
'      ,q''[        <dc:Bounds x="340" y="660" width="160" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0g76b8t_di" bpmnElement="TextAnnotation_0g76b8t">]''',
'      ,q''[        <dc:Bounds x="260" y="380" width="99.9875821019153" height="41.337466732851176" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_17b6g1h_di" bpmnElement="Flow_17b6g1h">]''',
'      ,q''[        <di:waypoint x="318" y="520" />]''',
'      ,q''[        <di:waypoint x="350" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xtgyk0_di" bpmnElement="Flow_0xtgyk0">]''',
'      ,q''[        <di:waypoint x="450" y="520" />]''',
'      ,q''[        <di:waypoint x="470" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1bw7mvj_di" bpmnElement="Flow_1bw7mvj">]''',
'      ,q''[        <di:waypoint x="570" y="520" />]''',
'      ,q''[        <di:waypoint x="600" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0a9vat2_di" bpmnElement="Flow_0a9vat2">]''',
'      ,q''[        <di:waypoint x="750" y="495" />]''',
'      ,q''[        <di:waypoint x="750" y="400" />]''',
'      ,q''[        <di:waypoint x="780" y="400" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_111ldh8_di" bpmnElement="Flow_111ldh8">]''',
'      ,q''[        <di:waypoint x="775" y="520" />]''',
'      ,q''[        <di:waypoint x="830" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wa3yvx_di" bpmnElement="Flow_0wa3yvx">]''',
'      ,q''[        <di:waypoint x="750" y="545" />]''',
'      ,q''[        <di:waypoint x="750" y="740" />]''',
'      ,q''[        <di:waypoint x="782" y="740" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1u9z9zl_di" bpmnElement="Flow_1u9z9zl">]''',
'      ,q''[        <di:waypoint x="750" y="545" />]''',
'      ,q''[        <di:waypoint x="750" y="830" />]''',
'      ,q''[        <di:waypoint x="902" y="830" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02w8qhh_di" bpmnElement="Flow_02w8qhh">]''',
'      ,q''[        <di:waypoint x="750" y="545" />]''',
'      ,q''[        <di:waypoint x="750" y="620" />]''',
'      ,q''[        <di:waypoint x="780" y="620" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1co4h5b_di" bpmnElement="Flow_1co4h5b">]''',
'      ,q''[        <di:waypoint x="880" y="400" />]''',
'      ,q''[        <di:waypoint x="980" y="400" />]''',
'      ,q''[        <di:waypoint x="980" y="495" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_149xi7o_di" bpmnElement="Flow_149xi7o">]''',
'      ,q''[        <di:waypoint x="930" y="520" />]''',
'      ,q''[        <di:waypoint x="955" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1pxnz40_di" bpmnElement="Flow_1pxnz40">]''',
'      ,q''[        <di:waypoint x="880" y="620" />]''',
'      ,q''[        <di:waypoint x="980" y="620" />]''',
'      ,q''[        <di:waypoint x="980" y="545" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0umsd4h_di" bpmnElement="Flow_0umsd4h">]''',
'      ,q''[        <di:waypoint x="818" y="740" />]''',
'      ,q''[        <di:waypoint x="980" y="740" />]''',
'      ,q''[        <di:waypoint x="980" y="545" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0vmcx38_di" bpmnElement="Flow_0vmcx38">]''',
'      ,q''[        <di:waypoint x="938" y="830" />]''',
'      ,q''[        <di:waypoint x="980" y="830" />]''',
'      ,q''[        <di:waypoint x="980" y="545" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1inbmjx_di" bpmnElement="Flow_1inbmjx">]''',
'      ,q''[        <di:waypoint x="1130" y="495" />]''',
'      ,q''[        <di:waypoint x="1130" y="450" />]''',
'      ,q''[        <di:waypoint x="1220" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0g67vgs_di" bpmnElement="Flow_0g67vgs">]''',
'      ,q''[        <di:waypoint x="1005" y="520" />]''',
'      ,q''[        <di:waypoint x="1105" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0p4dldk_di" bpmnElement="Flow_0p4dldk">]''',
'      ,q''[        <di:waypoint x="1130" y="545" />]''',
'      ,q''[        <di:waypoint x="1130" y="570" />]''',
'      ,q''[        <di:waypoint x="1220" y="570" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_05lb32a_di" bpmnElement="Flow_05lb32a">]''',
'      ,q''[        <di:waypoint x="1130" y="545" />]''',
'      ,q''[        <di:waypoint x="1130" y="690" />]''',
'      ,q''[        <di:waypoint x="1220" y="690" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0vmjyh0_di" bpmnElement="Flow_0vmjyh0">]''',
'      ,q''[        <di:waypoint x="1320" y="690" />]''',
'      ,q''[        <di:waypoint x="1360" y="690" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1h798dh_di" bpmnElement="Flow_1h798dh">]''',
'      ,q''[        <di:waypoint x="1130" y="545" />]''',
'      ,q''[        <di:waypoint x="1130" y="850" />]''',
'      ,q''[        <di:waypoint x="1220" y="850" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_09nusca_di" bpmnElement="Flow_09nusca">]''',
'      ,q''[        <di:waypoint x="700" y="520" />]''',
'      ,q''[        <di:waypoint x="725" y="520" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_055qq8e_di" bpmnElement="Association_055qq8e">]''',
'      ,q''[        <di:waypoint x="293" y="503" />]''',
'      ,q''[        <di:waypoint x="260" y="421" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_10wi0mu_di" bpmnElement="Association_10wi0mu">]''',
'      ,q''[        <di:waypoint x="397" y="560" />]''',
'      ,q''[        <di:waypoint x="388" y="660" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_0wxmvig_di" bpmnElement="Participant_1n4c4l0" isHorizontal="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="210" y="230" width="1240" height="60" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_1ruoh75_di" bpmnElement="Participant_0qabxrw" isHorizontal="true" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="210" y="990" width="1420" height="250" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1m5awsm_di" bpmnElement="Event_1qhlqtm" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="392" y="1102" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="375" y="1145" width="71" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_064bqdb_di" bpmnElement="Activity_064bqdb">]''',
'      ,q''[        <dc:Bounds x="500" y="1080" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1k56x55_di" bpmnElement="Activity_1k56x55" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1180" y="1080" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1c0y1rf_di" bpmnElement="Activity_0zw04ka" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1330" y="1080" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_10689f2_di" bpmnElement="Event_1k9dkfm" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="702" y="1102" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="680" y="1145" width="80" height="66" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_06jzlam_di" bpmnElement="Event_1m4gahw" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="832" y="1102" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="806" y="1145" width="89" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0ppnav5_di" bpmnElement="Event_0bqx3lb">]''',
'      ,q''[        <dc:Bounds x="932" y="1102" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="909" y="1145" width="83" height="66" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1p1t10d_di" bpmnElement="Activity_17locw8" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1480" y="1080" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_02xknjy_di" bpmnElement="Event_15i3bqd">]''',
'      ,q''[        <dc:Bounds x="1512" y="1062" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1488" y="1010" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1aq7eka_di" bpmnElement="Event_16ppomb">]''',
'      ,q''[        <dc:Bounds x="1482" y="1142" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1459" y="1185" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0wkpvzk_di" bpmnElement="Event_03560w5">]''',
'      ,q''[        <dc:Bounds x="1332" y="1142" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1309" y="1185" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1a2pfey_di" bpmnElement="Event_1y7gbua">]''',
'      ,q''[        <dc:Bounds x="1362" y="1062" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1338" y="1010" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0p9k8lt_di" bpmnElement="Event_12pdldq">]''',
'      ,q''[        <dc:Bounds x="1212" y="1142" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1189" y="1185" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0i3hcnq_di" bpmnElement="Event_1bft1qt">]''',
'      ,q''[        <dc:Bounds x="1212" y="1062" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1189" y="1010" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ksryuz_di" bpmnElement="Flow_1ksryuz">]''',
'      ,q''[        <di:waypoint x="428" y="1120" />]''',
'      ,q''[        <di:waypoint x="500" y="1120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_14l9gvf_di" bpmnElement="Flow_14l9gvf">]''',
'      ,q''[        <di:waypoint x="600" y="1120" />]''',
'      ,q''[        <di:waypoint x="702" y="1120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0j888id_di" bpmnElement="Flow_0j888id">]''',
'      ,q''[        <di:waypoint x="738" y="1120" />]''',
'      ,q''[        <di:waypoint x="832" y="1120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03pslu3_di" bpmnElement="Flow_03pslu3">]''',
'      ,q''[        <di:waypoint x="868" y="1120" />]''',
'      ,q''[        <di:waypoint x="932" y="1120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07deqwm_di" bpmnElement="Flow_07deqwm">]''',
'      ,q''[        <di:waypoint x="1280" y="1120" />]''',
'      ,q''[        <di:waypoint x="1330" y="1120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0twpz2i_di" bpmnElement="Flow_0twpz2i">]''',
'      ,q''[        <di:waypoint x="1430" y="1120" />]''',
'      ,q''[        <di:waypoint x="1480" y="1120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0hbfzmk_di" bpmnElement="Association_0hbfzmk">]''',
'      ,q''[        <di:waypoint x="966" y="1112" />]''',
'      ,q''[        <di:waypoint x="1020" y="1085" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0igizeg_di" bpmnElement="Association_0igizeg">]''',
'      ,q''[        <di:waypoint x="393" y="1124" />]''',
'      ,q''[        <di:waypoint x="250" y="1160" />]''',
'      ,q''[        <di:waypoint x="250" y="1075" />]''',
'      ,q''[        <di:waypoint x="270" y="1075" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0gyba6i_di" bpmnElement="TextAnnotation_0gyba6i">]''',
'      ,q''[        <dc:Bounds x="1020" y="1020" width="150" height="130" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mf0t72_di" bpmnElement="Flow_1mf0t72">]''',
'      ,q''[        <di:waypoint x="380" y="480" />]''',
'      ,q''[        <di:waypoint x="380" y="290" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_19l2sy0_di" bpmnElement="Flow_19l2sy0">]''',
'      ,q''[        <di:waypoint x="420" y="290" />]''',
'      ,q''[        <di:waypoint x="420" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0hqqiiu_di" bpmnElement="Flow_0hqqiiu">]''',
'      ,q''[        <di:waypoint x="830" y="360" />]''',
'      ,q''[        <di:waypoint x="830" y="290" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1rtp00p_di" bpmnElement="Flow_1rtp00p">]''',
'      ,q''[        <di:waypoint x="900" y="290" />]''',
'      ,q''[        <di:waypoint x="900" y="480" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1h2ekkn_di" bpmnElement="Flow_1h2ekkn">]''',
'      ,q''[        <di:waypoint x="800" y="758" />]''',
'      ,q''[        <di:waypoint x="800" y="930" />]''',
'      ,q''[        <di:waypoint x="720" y="930" />]''',
'      ,q''[        <di:waypoint x="720" y="1100" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13gq3gc_di" bpmnElement="Flow_13gq3gc">]''',
'      ,q''[        <di:waypoint x="850" y="1102" />]''',
'      ,q''[        <di:waypoint x="850" y="975" />]''',
'      ,q''[        <di:waypoint x="920" y="975" />]''',
'      ,q''[        <di:waypoint x="920" y="848" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07c9y3f_di" bpmnElement="Flow_07c9y3f">]''',
'      ,q''[        <di:waypoint x="650" y="560" />]''',
'      ,q''[        <di:waypoint x="650" y="1020" />]''',
'      ,q''[        <di:waypoint x="410" y="1020" />]''',
'      ,q''[        <di:waypoint x="410" y="1102" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1nxz8a7_di" bpmnElement="TextAnnotation_1nxz8a7">]''',
'      ,q''[        <dc:Bounds x="270" y="1020" width="100" height="110" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_01egisp">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1lz6x7p" bpmnElement="Activity_0zw04ka" />]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 7a - MessageFlow Basics'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:collaboration id="Collaboration_Tutorial7b">]''',
'      ,q''[    <bpmn:participant id="Participant_7b_Customer" name="Customer" processRef="Process_7b_Customer" />]''',
'      ,q''[    <bpmn:participant id="Participant_7b_Supplier" name="Supplier" processRef="Process_7b_Supplier" />]''',
'      ,q''[    <bpmn:participant id="Participant_7b_Shipper" name="Shipper" processRef="Process_7b_Shipper" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_0qqyp6t" name="PO" sourceRef="Activity_1g5w4wf" targetRef="Event_0fqjob4" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_1lagn3a" name="SO" sourceRef="Event_08o84ee" targetRef="Event_19wz3hb" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_1fa2d0d" name="Shipping Instructions" sourceRef="Event_0s6f6tl" targetRef="Event_1uaun7m" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_0jri9bb" name="Delivery Order" sourceRef="Activity_1w7qibr" targetRef="Event_1fztck2" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_13km3up" name="Delivery Confirmation" sourceRef="Event_0mnrcwj" targetRef="Event_02ycj50" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_175p4nl" name="Invoice" sourceRef="Event_10ujxv8" targetRef="Event_0hf2lpk" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_066thix">]''',
'      ,q''[      <bpmn:text>Message Start sends most data inc PO number in Payload as it''s a new transaction...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0t0pz11" associationDirection="None" sourceRef="Event_0fqjob4" targetRef="TextAnnotation_066thix" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0kt0jjy">]''',
'      ,q''[      <bpmn:text>Allocate a SO number in supplier''s system...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_06ooxgb" associationDirection="None" sourceRef="Activity_1657afv" targetRef="TextAnnotation_0kt0jjy" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1rzdx0j">]''',
'      ,q''[      <bpmn:text>So I now have the Supplier''s SO Number and pricing returned in payload</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1xt7bzk" associationDirection="None" sourceRef="Event_19wz3hb" targetRef="TextAnnotation_1rzdx0j" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0bhm3wb">]''',
unistr('      ,q''[      <bpmn:text>There are \00A0sample messages for all of these transactions, to show how a process is coordinated across multiple parties only using "real world" keys &amp; without some magic shaped GUID.]'''),
'      ,q''[]''',
'      ,q''[Take some time to open the message properties.]''',
'      ,q''[]''',
unistr('      ,q''[* This model relies on messageStart and messageEnd events, which are features of the \00A0Enterprise Edition. \00A0To run the model must be ''released'']'''),
unistr('      ,q''[\00A0It''s hard to do this with Community Edition...</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1o8f1tb" associationDirection="None" sourceRef="Event_1uaun7m" targetRef="TextAnnotation_0bhm3wb" />]''',
'      ,q''[  </bpmn:collaboration>]''',
'      ,q''[  <bpmn:process id="Process_7b_Customer" isExecutable="true" apex:isStartable="true">]''',
'      ,q''[    <bpmn:startEvent id="Event_1nkrf5h" name="Need Parts">]''',
'      ,q''[      <bpmn:outgoing>Flow_1u809yb</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1u809yb" sourceRef="Event_1nkrf5h" targetRef="Activity_1g5w4wf" />]''',
'      ,q''[    <bpmn:sendTask id="Activity_1g5w4wf" name="Send PO" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:endpoint>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>local</apex:expression>]''',
'      ,q''[        </apex:endpoint>]''',
'      ,q''[        <apex:messageName>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>purchaseOrder</apex:expression>]''',
'      ,q''[        </apex:messageName>]''',
'      ,q''[        <apex:payload>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>{"customer" : ""CustomerCo",]''',
'      ,q''[ "customerPO" : "PO123",]''',
'      ,q''["dateRequired" :  2024-12-30T12:00:00,]''',
'      ,q''["purchaseItems" : [ {"UPC" : "24586356789",]''',
'      ,q''[                                "qty_reqd" : 20},]''',
'      ,q''[                              {"UPC" : "24586456862",]''',
'      ,q''[                                "qty_reqd" : 10}]]''',
'      ,q''[}]''',
'      ,q''[</apex:expression>]''',
'      ,q''[        </apex:payload>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1u809yb</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_02x6exq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:sendTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02x6exq" sourceRef="Activity_1g5w4wf" targetRef="Event_19wz3hb" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ts8jds" sourceRef="Event_19wz3hb" targetRef="Activity_1kljmjo" />]''',
'      ,q''[    <bpmn:task id="Activity_1kljmjo" name="Prepare Order">]''',
'      ,q''[      <bpmn:incoming>Flow_1ts8jds</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1frr481</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_19wz3hb" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_02x6exq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ts8jds</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_18afvni">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>salesOrder</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>customerPOnumber</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>PO123</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payloadVariable>SupplierSO</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1frr481" sourceRef="Activity_1kljmjo" targetRef="Event_1fztck2" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_1fztck2" name="Receive Delivery Note" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1frr481</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_13afku8</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0pgruip">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>deliveryOrder</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>customerPO</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>PO123</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payloadVariable>MyDeliveryNote</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_13afku8" sourceRef="Event_1fztck2" targetRef="Event_0hf2lpk" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0zdvd7b" sourceRef="Event_0hf2lpk" targetRef="Event_0iewhwo" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0iewhwo" name="Order Completed">]''',
'      ,q''[      <bpmn:incoming>Flow_0zdvd7b</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_0hf2lpk" name="Receive Invoice" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_13afku8</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0zdvd7b</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1nkqyag">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>sendInvoice</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>customerPO</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>PO123</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payloadVariable>MyInvoice</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmn:process id="Process_7b_Supplier">]''',
'      ,q''[    <bpmn:startEvent id="Event_0fqjob4" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:outgoing>Flow_1c0rg1m</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1q84afy">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>purchaseOrder</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:payloadVariable>OrderPayload</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1657afv" name="Prepare Order">]''',
'      ,q''[      <bpmn:incoming>Flow_1c0rg1m</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0spqr5a</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1c0rg1m" sourceRef="Event_0fqjob4" targetRef="Activity_1657afv" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0spqr5a" sourceRef="Activity_1657afv" targetRef="Ev'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ent_08o84ee" />]''',
'      ,q''[    <bpmn:intermediateThrowEvent id="Event_08o84ee" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0spqr5a</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0hfmmi9</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1bl3gqo">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>salesOrder</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>customerPOnumber</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>PO123</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payload>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>{ "supplierSalesOrder" ; "SO4567",]''',
'      ,q''[ "orderItems" : []''',
'      ,q''[           {"UPC" : "24586356789",]''',
'      ,q''[             "qty_ordered" : 20,]''',
'      ,q''[             "unit_price" : 12.56 },]''',
'      ,q''[            {"UPC" : "24586456862",]''',
'      ,q''[              "qty_reqd" : 10,]''',
'      ,q''[             "unit_price" : 86.56 }]]''',
'      ,q''[}</apex:expression>]''',
'      ,q''[          </apex:payload>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateThrowEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0wj2cv8" name="Prepare Goods">]''',
'      ,q''[      <bpmn:incoming>Flow_0hfmmi9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0cy0mu1</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0hfmmi9" sourceRef="Event_08o84ee" targetRef="Activity_0wj2cv8" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cy0mu1" sourceRef="Activity_0wj2cv8" targetRef="Event_0s6f6tl" />]''',
'      ,q''[    <bpmn:intermediateThrowEvent id="Event_0s6f6tl" name="Send Shipping Instructions" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0cy0mu1</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_16mzs2c</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1o2yx5r">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>shippingInstruction</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:payload>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>{ "ShipFrom" : "MySupplierCo",]''',
'      ,q''[  "SupplierRef" : "SO5678",]''',
'      ,q''[  "ShipTo" : "MyCustomerCo",]''',
'      ,q''[  "CustomerRef" : "PO123",]''',
'      ,q''[  "DateRequired" : 2024-12-30T12:00:00,]''',
'      ,q''[ "orderItems" : []''',
'      ,q''[           {"UPC" : "24586356789",]''',
'      ,q''[             "qty_ordered" : 20},]''',
'      ,q''[            {"UPC" : "24586456862",]''',
'      ,q''[              "qty_reqd" : 10}]]''',
'      ,q''[}]''',
'      ,q''[  </apex:expression>]''',
'      ,q''[          </apex:payload>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateThrowEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_16mzs2c" sourceRef="Event_0s6f6tl" targetRef="Event_02ycj50" apex:sequence="10" />]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_02ycj50" name="Receive Delivery Confirmation" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_16mzs2c</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_15quyrs</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0aje11i">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>deliveryConfirmation</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>supplierSO</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>SO5678</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payloadVariable>MyDeliveryConfirmation</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_15quyrs" sourceRef="Event_02ycj50" targetRef="Event_10ujxv8" />]''',
'      ,q''[    <bpmn:endEvent id="Event_10ujxv8" name="Send Invoice and Complete" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_15quyrs</bpmn:incoming>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0h9qn96">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>sendInvoice</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>customerPO</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>PO123</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payload>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>{"the bill": "..."}</apex:expression>]''',
'      ,q''[          </apex:payload>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmn:process id="Process_7b_Shipper">]''',
'      ,q''[    <bpmn:startEvent id="Event_1uaun7m" name="Start Delivery Process" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:outgoing>Flow_1wjgsuc</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1jy6i1x">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>shippingInstruction</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:payloadVariable>MyShippingInstruction</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1djmvxg" name="Prepare Shipment">]''',
'      ,q''[      <bpmn:incoming>Flow_1wjgsuc</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mkjf1m</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1wjgsuc" sourceRef="Event_1uaun7m" targetRef="Activity_1djmvxg" />]''',
'      ,q''[    <bpmn:task id="Activity_1dsrrm0" name="Process">]''',
'      ,q''[      <bpmn:incoming>Flow_0mkjf1m</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_01ollhu</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mkjf1m" sourceRef="Activity_1djmvxg" targetRef="Activity_1dsrrm0" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_01ollhu" sourceRef="Activity_1dsrrm0" targetRef="Activity_1w7qibr" />]''',
'      ,q''[    <bpmn:sendTask id="Activity_1w7qibr" name="Send Shipping Details" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:endpoint>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>local</apex:expression>]''',
'      ,q''[        </apex:endpoint>]''',
'      ,q''[        <apex:messageName>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>deliveryOrder</apex:expression>]''',
'      ,q''[        </apex:messageName>]''',
'      ,q''[        <apex:correlationKey>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>customerPO</apex:expression>]''',
'      ,q''[        </apex:correlationKey>]''',
'      ,q''[        <apex:correlationValue>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>PO123</apex:expression>]''',
'      ,q''[        </apex:correlationValue>]''',
'      ,q''[        <apex:payload>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression> { "ShipFrom" : "MySupplierCo",]''',
'      ,q''[ "SupplierRef" : "SO5678",]''',
'      ,q''["orderItems" : []''',
'      ,q''[           {"UPC" : "24586356789",]''',
'      ,q''[             "qty_ordered" : 20 },]''',
'      ,q''[            {"UPC" : "24586456862",]''',
'      ,q''[              "qty_reqd" : 10 }],]''',
'      ,q''[ "mode" ; "air",]''',
'      ,q''[ "waybill" : "45673647741578"]''',
'      ,q''[}</apex:expression>]''',
'      ,q''[        </apex:payload>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_01ollhu</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0c700da</bpmn:outgoing>]''',
'      ,q''[    </bpmn:sendTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0c700da" sourceRef="Activity_1w7qibr" targetRef="Event_0mnrcwj" />]''',
'      ,q''[    <bpmn:endEvent id="Event_0mnrcwj" name="Send Delivery Confirmation and End" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_0c700da</bpmn:incoming>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_129h25w">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>deliveryConfirmation</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>supplierSO</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>SO5678</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payload>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression> { "ShipFrom" : "MySupplierCo",]''',
'      ,q''[ "SupplierRef" : "SO5678",]''',
'      ,q''[  "ShipTo" : "MyCustomerCo",]''',
'      ,q''[  "CustomerRef" : "PO123",]''',
'      ,q''["deliveredItems" : []''',
'      ,q''[           {"UPC" : "24586356789",]''',
'      ,q''[             "qty_ordered" : 20 },]''',
'      ,q''[            {"UPC" : "24586456862",]''',
'      ,q''[              "qty_reqd" : 10 }],]''',
'      ,q''[ "mode" ; "air",]''',
'      ,q''[ "waybill" : "45673647741578",]''',
'      ,q''[ "dateDelivered" : 2024-10-02T08:47:00,]''',
'      ,q''[ "signedForBy" : "Bill Smith"]''',
'      ,q''[}</apex:expression>]''',
'      ,q''[          </apex:payload>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Collaboration_Tutorial7b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_15yep6c_di" bpmnElement="Participant_7b_Customer" isHorizontal="true" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="130" y="60" width="1410" height="250" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1nkrf5h_di" bpmnElement="Event_1nkrf5h">]''',
'      ,q''[        <dc:Bounds x="172" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="162" y="225" width="56" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1eeaz0i_di" bpmnElement="Activity_1g5w4wf">]''',
'      ,q''[        <dc:Bounds x="260" y="160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1kljmjo_di" bpmnElement="Activity_1kljmjo">]''',
'      ,q''[        <dc:Bounds x="570" y="160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_08urp2f_di" bpmnElement="Event_19wz3hb">]''',
'      ,q''[        <dc:Bounds x="482" y="182" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_16039p0_di" bpmnElement="Event_1fztck2">]''',
'      ,q''[        <dc:Bounds x="1122" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1099" y="152" width="83" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0iewhwo_di" bpmnElement="Event_0iewhwo">]''',
'      ,q''[        <dc:Bounds x="1442" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1418" y="225" width="85" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_11myztk_di" bpmnElement="Event_0hf2lpk">]''',
'      ,q''[        <dc:Bounds x="1342" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1321" y="152" width="78" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1u809yb_di" bpmnElement="Flow_1u809yb">]''',
'      ,q''[        <di:waypoint x="208" y="200" />]''',
'      ,q''[        <di:waypoint x="260" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02x6exq_di" bpmnElement="Flow_02x6exq">]''',
'      ,q''[        <di:waypoint x="360" y="200" />]''',
'      ,q''[        <di:waypoint x="482" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ts8jds_di" bpmnElement="Flow_1ts8jds">]''',
'      ,q''[        <di:waypoint x="518" y="200" />]''',
'      ,q''[        <di:waypoint x="570" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1frr481_di" bpmnElement="Flow_1frr481">]''',
'      ,q''[        <di:waypoint x="670" y="200" />]''',
'      ,q''[        <di:waypoint x="1122" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13afku8_di" bpmnElement="Flow_13afku8">]''',
'      ,q''[        <di:waypoint x="1158" y="200" />]''',
'      ,q''[        <di:waypoint x="1342" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0zdvd7b_di" bpmnElement="Flow_0zdvd7b">]''',
'      ,q''[        <di:waypoint x="1378" y="200" />]''',
'      ,q''[        <di:waypoint x="1442" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_1rpty8o_di" bpmnElement="Participant_7b_Supplier" isHorizontal="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="130" y="370" width="1410" height="250" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0lengvb_di" bpmnElement="Event_0fqjob4">]''',
'      ,q''[        <dc:Bounds x="282" y="492" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1657afv_di" bpmnElement="Activity_1657afv">]''',
'      ,q''[        <dc:Bounds x="350" y="470" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_07bajuw_di" bpmnElement="Event_08o84ee">]''',
'      ,q''[        <dc:Bounds x="482" y="492" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0wj2cv8_di" bpmnElement="Activity_0wj2cv8">]''',
'      ,q''[        <dc:Bounds x="550" y="470" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1b2xsdh_di" bpmnElement="Event_0s6f6tl">]''',
'      ,q''[        <dc:Bounds x="682" y="492" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="664" y="462" width="72" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1r3kc27_di" bpmnElement="Event_02ycj50">]''',
'      ,q''[        <dc:Bounds x="1252" y="492" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1229" y="462" width="83" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1ggdcq9_di" bpmnElement="Event_10ujxv8">]''',
'      ,q''[        <dc:Bounds x="1342" y="492" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1317" y="535" width="86" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1c0rg1m_di" bpmnElement="Flow_1c0rg1m">]''',
'      ,q''[        <di:waypoint x="318" y="510" />]''',
'      ,q''[        <di:waypoint x="350" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0spqr5a_di" bpmnElement="Flow_0spqr5a">]''',
'      ,q''[        <di:waypoint x="450" y="510" />]''',
'      ,q''[        <di:waypoint x="482" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0hfmmi9_di" bpmnElement="Flow_0hfmmi9">]''',
'      ,q''[        <di:waypoint x="518" y="510" />]''',
'      ,q''[        <di:waypoint x="550" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cy0mu1_di" bpmnElement="Flow_0cy0mu1">]''',
'      ,q''[        <di:waypoint x="650" y="510" />]''',
'      ,q''[        <di:waypoint x="682" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16mzs2c_di" bpmnElement="Flow_16mzs2c">]''',
'      ,q''[        <di:waypoint x="718" y="510" />]''',
'      ,q''[        <di:waypoint x="1252" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_15quyrs_di" bpmnElement="Flow_15quyrs">]''',
'      ,q''[        <di:waypoint x="1288" y="510" />]''',
'      ,q''[        <di:waypoint x="1342" y="510" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_1e0if9q_di" bpmnElement="Participant_7b_Shipper" isHorizontal="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="130" y="670" width="1420" height="250" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_18mxl06_di" bpmnElement="Event_1uaun7m">]''',
'      ,q''[        <dc:Bounds x="682" y="782" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="667" y="825" width="67" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1djmvxg_di" bpmnElement="Activity_1djmvxg">]''',
'      ,q''[        <dc:Bounds x="770" y="760" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1dsrrm0_di" bpmnElement="Activity_1dsrrm0">]''',
'      ,q''[        <dc:Bounds x="930" y="760" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_00enaqu_di" bpmnElement="Activity_1w7qibr">]''',
'      ,q''[        <dc:Bounds x="1090" y="760" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1fxf80q_di" bpmnElement="Event_0mnrcwj">]''',
'      ,q''[        <dc:Bounds x="1252" y="782" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1228" y="825" width="84" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1wjgsuc_di" bpmnElement="Flow_1wjgsuc">]''',
'      ,q''[        <di:waypoint x="718" y="800" />]''',
'      ,q''[        <di:waypoint x="770" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0mkjf1m_di" bpmnElement="Flow_0mkjf1m">]''',
'      ,q''[        <di:waypoint x="870" y="800" />]''',
'      ,q''[        <di:waypoint x="930" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_01ollhu_di" bpmnElement="Flow_01ollhu">]''',
'      ,q''[        <di:waypoint x="1030" y="800" />]''',
'      ,q''[        <di:waypoint x="1090" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0c700da_di" bpmnElement="Flow_0c700da">]''',
'      ,q''[        <di:waypoint x="1190" y="800" />]''',
'      ,q''[        <di:waypoint x="1252" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_066thix_di" bpmnElement="TextAnnotation_066thix">]''',
'      ,q''[        <dc:Bounds x="180" y="390" width="100" height="110.00000762939453" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0kt0jjy_di" bpmnElement="TextAnnotation_0kt0jjy">]''',
'      ,q''[        <dc:Bounds x="230" y="550" width="100" height="67.9891357421875" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1rzdx0j_di" bpmnElement="TextAnnotation_1rzdx0j">]''',
'      ,q''[        <dc:Bounds x="520" y="70" width="100" height="95.99185180664062" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0bhm3wb_di" bpmnElement="TextAnnotation_0bhm3wb">]''',
'      ,q''[        <dc:Bounds x="190" y="690" width="269.98750728735666" height="210.2112099960983" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0t0pz11_di" bpmnElement="Association_0t0pz11">]''',
'      ,q''[        <di:waypoint x="283" y="504" />]''',
'      ,q''[        <di:waypoint x="270" y="500" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_06ooxgb_di" bpmnElement="Association_06ooxgb">]''',
'      ,q''[        <di:waypoint x="350" y="533" />]''',
'      ,q''[        <di:waypoint x="313" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1xt7bzk_di" bpmnElement="Association_1xt7bzk">]''',
'      ,q''[        <di:waypoint x="509" y="185" />]''',
'      ,q''[        <di:waypoint x="521" y="166" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1o8f1tb_di" bpmnElement="Association_1o8f1tb">]''',
'      ,q''[        <di:waypoint x="682" y="796" />]''',
'      ,q''[        <di:waypoint x="460" y="750" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0qqyp6t_di" bpmnElement="Flow_0qqyp6t">]''',
'      ,q''[        <di:waypoint x="300" y="240" />]''',
'      ,q''[        <di:waypoint x="300" y="492" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="312" y="333" width="16" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1lagn3a_di" bpmnElement="Flow_1lagn3a">]''',
'      ,q''[        <di:waypoint x="500" y="492" />]''',
'      ,q''[        <di:waypoint x="500" y="218" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="481" y="333" width="16" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1fa2d0d_di" bpmnElement="Flow_1fa2d0d">]''',
'      ,q''[        <di:waypoint x="700" y="528" />]''',
'      ,q''[        <di:waypoint x="700" y="782" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="711" y="636" width="57" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jri9bb_di" bpmnElement="Flow_0jri9bb">]''',
'      ,q''[        <di:waypoint x="1140" y="760" />]''',
'      ,q''[        <di:waypoint x="1140" y="218" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1154" y="633" width="71" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13km3up_di" bpmnElement="Flow_13km3up">]''',
'      ,q''[        <di:waypoint x="1270" y="782" />]''',
'      ,q''[        <di:waypoint x="1270" y="528" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1278" y="626" width="63" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_175p4nl_di" bpmnElement="Flow_175p4nl">]''',
'      ,q''[        <di:waypoint x="1360" y="492" />]''',
'      ,q''[        <di:waypoint x="1360" y="218" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1372" y="333" width="35" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 7b - Process Collaboration and MessageFlow Example'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial7e" name="Tutorial 7e - Loops and Interators Overview" isExecutable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_Start" name="Start">]''',
'      ,q''[      <bpmn:outgoing>Flow_00jstgp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_PreSplit" name="Pre-Split">]''',
'      ,q''[      <bpmn:incoming>Flow_00jstgp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1i6fc42</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_00jstgp" sourceRef="Event_Start" targetRef="Activity_PreSplit" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1i6fc42" sourceRef="Activity_PreSplit" targetRef="Gateway_Split" />]''',
'      ,q''[    <bpmn:task id="Activity_A1" name="A1- List">]''',
'      ,q''[      <bpmn:extensionElements>]'''))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EmpList</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1ngmguv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0xh1wjg</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ngmguv" sourceRef="Gateway_Split" targetRef="Activity_A1" apex:sequence="10" />]''',
'      ,q''[    <bpmn:task id="Activity_A2" name="A2">]''',
'      ,q''[      <bpmn:incoming>Flow_0xh1wjg</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1v6vync</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics isSequential="true">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableList</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpList</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayA</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:description>Iteration &amp;LOOP_COUNTER. - &amp;ENAME.</apex:description>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;=3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0xh1wjg" sourceRef="Activity_A1" targetRef="Activity_A2" />]''',
'      ,q''[    <bpmn:task id="Activity_A3" name="A3">]''',
'      ,q''[      <bpmn:incoming>Flow_1v6vync</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0emop6i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1v6vync" sourceRef="Activity_A2" targetRef="Activity_A3" />]''',
'      ,q''[    <bpmn:endEvent id="Event_AEnd" name="AEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0emop6i</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0emop6i" sourceRef="Activity_A3" targetRef="Event_AEnd" />]''',
'      ,q''[    <bpmn:task id="Activity_B1" name="B1 - Array">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EmpArray</apex:varName>]''',
'      ,q''[            <apex:varDataType>JSON</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryArray</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename, empno]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_02y11qo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mg0jl9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_B2" name="B2">]''',
'      ,q''[      <bpmn:incoming>Flow_0mg0jl9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0m8ne0j</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpArray</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayB</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:description>Iteration &amp;LOOP_COUNTER. - &amp;ENAME. (&amp;EMPNO.)</apex:description>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;=3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_B3" name="B3">]''',
'      ,q''[      <bpmn:incoming>Flow_0m8ne0j</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0cv0t6o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_BEnd" name="BEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0cv0t6o</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mg0jl9" sourceRef="Activity_B1" targetRef="Activity_B2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0m8ne0j" sourceRef="Activity_B2" targetRef="Activity_B3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cv0t6o" sourceRef="Activity_B3" targetRef="Event_BEnd" />]''',
'      ,q''[    <bpmn:task id="Activity_C1" name="C1 - Query">]''',
'      ,q''[      <bpmn:incoming>Flow_1a4xxmd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1f9kxmo</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_C2" name="C2">]''',
'      ,q''[      <bpmn:incoming>Flow_1f9kxmo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dcufu5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>sqlQueryArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>select ename, empno]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayC</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[          <apex:description>Iteration &amp;LOOP_COUNTER. - &amp;ENAME. (&amp;EMPNO.)</apex:description>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_C3" name="C3">]''',
'      ,q''[      <bpmn:incoming>Flow_1dcufu5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0opd4zr</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_CEnd" name="CEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0opd4zr</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1f9kxmo" sourceRef="Activity_C1" targetRef="Activity_C2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dcufu5" sourceRef="Activity_C2" targetRef="Activity_C3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0opd4zr" sourceRef="Activity_C3" targetRef="Event_CEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02y11qo" sourceRef="Gateway_Split" targetRef="Activity_B1" apex:sequence="20" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1a4xxmd" sourceRef="Gateway_Split" targetRef="Activity_C1" apex:sequence="30" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_Split" name="Split">]''',
'      ,q''[      <bpmn:incoming>Flow_1i6fc42</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ngmguv</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_02y11qo</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1a4xxmd</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_14oqpn7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:task id="Activity_D1" name="D1 - Loop">]''',
'      ,q''[      <bpmn:incoming>Flow_14oqpn7</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_075zpir</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_D3" name="D3">]''',
'      ,q''[      <bpmn:incoming>Flow_1inz4p7</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_134vuwh</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_DEnd" name="DEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_134vuwh</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_134vuwh" sourceRef="Activity_D3" targetRef="Event_DEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_14oqpn7" sourceRef="Gateway_Split" targetRef="Activity_D1" apex:sequence="40" />]''',
'      ,q''[    <bpmn:task id="Activity_D2" name="D2">]''',
'      ,q''[      <bpmn:incoming>Flow_075zpir</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1inz4p7</bpmn:outgoing>]''',
'      ,q''[      <bpmn:standardLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayD</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[          <apex:description>Loop &amp;LOOP_COUNTER. </apex:description>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:standardLoopCharacteristics>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1inz4p7" sourceRef="Activity_D2" targetRef="Activity_D3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_075zpir" sourceRef="Activity_D1" targetRef="Activity_D2" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0i9q5wo">]''',
unistr('      ,q''[      <bpmn:text>emplist = select name\00A0]'''),
'      ,q''[from emp]''',
'      ,q''[where dept no = 20]''',
'      ,q''[]''',
'      ,q''[SMITH:JONES:SCOTT:ADAMS:FORD</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_050cm0v" sourceRef="Activity_A1" targetRef="TextAnnotation_0i9q5wo" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_06yrhts">]''',
'      ,q''[      <bpmn:text>sequentially iterate over emplist</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0bi9txm" sourceRef="Activity_A2" targetRef="TextAnnotation_06yrhts" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1dh1ysa">]''',
'      ,q''[      <bpmn:text>emparray = select name, empno from amp where dept no = 20]''',
'      ,q''[]''',
'      ,q''[[{"name":"SMITH","EMPNO":7369},]''',
'      ,q''[{"name":"JONES","EMPNO":7566}]''',
'      ,q''[...]</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0iayq8p" sourceRef="Activity_B1" targetRef="TextAnnotation_1dh1ysa" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1tdwshf">]''',
'      ,q''[      <bpmn:text>iterate over emparray]''',
'      ,q''[in parallel</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1cqii1i" sourceRef="Activity_B2" targetRef="TextAnnotation_1tdwshf" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0ehpw4n">]''',
'      ,q''[      <bpmn:text>iterate over query in parallel...]''',
'      ,q''[]''',
unistr('      ,q''[select name, empno\00A0]'''),
'      ,q''[from emp]''',
'      ,q''[where dept no = 20</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0hlx4e9" sourceRef="Activity_C2" targetRef="TextAnnotation_0ehpw4n" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_003r2il">]''',
'      ,q''[      <bpmn:text>with completion condition]''',
'      ,q''[]''',
'      ,q''[F4A$completed_instances &gt;= 3"</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_08292lx" sourceRef="Activity_C2" targetRef="TextAnnotation_003r2il" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0uxdiqy">]''',
'      ,q''[      <bpmn:text>loop until completion condition]''',
'      ,q''[]''',
'      ,q''[F4A$completed_instances &gt;= 3</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_00wsf7y" sourceRef="Activity_D2" targetRef="TextAnnotation_0uxdiqy" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_186d7sa">]''',
'      ,q''[      <bpmn:text>Iterations* and loops* can be added to]''',
'      ,q''[tasks or sub processes.]''',
'      ,q''[]''',
'      ,q''[They operate in parallel or sequentially.]''',
'      ,q''[]''',
unistr('      ,q''[Iterations have an input list. \00A0 The task occurs once for each item in the input list]'''),
'      ,q''[]''',
'      ,q''[The input can be a:]''',
'      ,q''[- process variable containing a colon separated list]''',
'      ,q''[- process variable containing a json array]''',
'      ,q''[- or directly from a query...]''',
'      ,q''[]''',
'      ,q''[*Iterations and Loops require the Enterprise Edition.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1mf8re7" associationDirection="None" sourceRef="Activity_PreSplit" targetRef="TextAnnotation_186d7sa" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial7e">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0nj6ios_di" bpmnElement="Event_Start">]''',
'      ,q''[        <dc:Bounds x="242" y="342" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="248" y="385" width="24" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1v4awr2_di" bpmnElement="Activity_PreSplit">]''',
'      ,q''[        <dc:Bounds x="330" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06o8whk_di" bpmnElement="Activity_A1" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0v2wn2j_di" bpmnElement="Activity_A2" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="760" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1m1j7lz_di" bpmnElement="Activity_A3" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="920" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0xoy17b_di" bpmnElement="Event_AEnd" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1082" y="124" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1088" y="167" width="27" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0lsnoc7" bpmnElement="Activity_B1" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="600" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_07it2bq" bpmnElement="Activity_B2" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="760" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_12yruu2" bpmnElement="Activity_B3" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="920" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_10192cq" bpmnElement="Event_BEnd" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1082" y="342" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="385" width="27" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0dwx7ia" bpmnElement="Activity_C1" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="600" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0ethqvm" bpmnElement="Activity_C2" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="760" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1s29z1t" bpmnElement="Activity_C3" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="920" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1x8vuch" bpmnElement="Event_CEnd" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1082" y="562" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="605" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1b1nb8o_di" bpmnElement="Gateway_Split">]''',
'      ,q''[        <dc:Bounds x="495" y="335" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="489" y="313" width="22" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0o13huf" bpmnElement="Activity_D1" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="600" y="710" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0fnnpeb" bpmnElement="Activity_D3" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="920" y="710" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1c42z7e" bpmnElement="Event_DEnd" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1082" y="732" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="775" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_137fa4v" bpmnElement="Activity_D2" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="760" y="710" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0i9q5wo_di" bpmnElement="TextAnnotation_0i9q5wo">]''',
'      ,q''[        <dc:Bounds x="570" y="-28" width="280" height="82" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_06yrhts_di" bpmnElement="TextAnnotation_06yrhts">]''',
'      ,q''[        <dc:Bounds x="860" y="22" width="160" height="40" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1dh1ysa_di" bpmnElement="TextAnnotation_1dh1ysa">]''',
'      ,q''[        <dc:Bounds x="570" y="201" width="207" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1tdwshf_di" bpmnElement="TextAnnotation_1tdwshf">]''',
'      ,q''[        <dc:Bounds x="860" y="231" width="160" height="40" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0ehpw4n_di" bpmnElement="TextAnnotation_0ehpw4n">]''',
'      ,q''[        <dc:Bounds x="770" y="413" width="159.99568083501214" height="94.33962264150944" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_003r2il_di" bpmnElement="TextAnnotation_003r2il">]''',
'      ,q''[        <dc:Bounds x="960" y="420" width="205" height="67" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1q3npzg" bpmnElement="TextAnnotation_0uxdiqy">]''',
'      ,q''[        <dc:Bounds x="837" y="630" width="265" height="59" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_186d7sa_di" bpmnElement="TextAnnotation_186d7sa">]''',
'      ,q''[        <dc:Bounds x="210" y="60" width="300" height="217" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_00jstgp_di" bpmnElement="Flow_00jstgp">]''',
'      ,q''[        <di:waypoint x="278" y="360" />]''',
'      ,q''[        <di:waypoint x="330" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1i6fc42_di" bpmnElement="Flow_1i6fc42">]''',
'      ,q''[        <di:waypoint x="430" y="360" />]''',
'      ,q''[        <di:waypoint x="495" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ngmguv_di" bpmnElement="Flow_1ngmguv">]''',
'      ,q''[        <di:waypoint x="520" y="335" />]''',
'      ,q''[        <di:waypoint x="520" y="142" />]''',
'      ,q''[        <di:waypoint x="600" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xh1wjg_di" bpmnElement="Flow_0xh1wjg">]''',
'      ,q''[        <di:waypoint x="700" y="142" />]''',
'      ,q''[        <di:waypoint x="760" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1v6vync_di" bpmnElement="Flow_1v6vync">]''',
'      ,q''[        <di:waypoint x="860" y="142" />]''',
'      ,q''[        <di:waypoint x="920" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0emop6i_di" bpmnElement="Flow_0emop6i">]''',
'      ,q''[        <di:waypoint x="1020" y="142" />]''',
'      ,q''[        <di:waypoint x="1082" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1fgochk" bpmnElement="Flow_0mg0jl9">]''',
'      ,q''[        <di:waypoint x="700" y="360" />]''',
'      ,q''[        <di:waypoint x="760" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1ipi0cl" bpmnElement="Flow_0m8ne0j">]''',
'      ,q''[        <di:waypoint x="860" y="370" />]''',
'      ,q''[        <di:waypoint x="920" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1j2m5si" bpmnElement="Flow_0cv0t6o">]''',
'      ,q''[        <di:waypoint x="1020" y="360" />]''',
'      ,q''[        <di:waypoint x="1082" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_04kv3hq" bpmnElement="Flow_1f9kxmo">]''',
'      ,q''[        <di:waypoint x="700" y="580" />]''',
'      ,q''[        <di:waypoint x="760" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0pgg5lp" bpmnElement="Flow_1dcufu5">]''',
'      ,q''[        <di:waypoint x="860" y="580" />]''',
'      ,q''[        <di:waypoint x="920" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_13nxtw3" bpmnElement="Flow_0opd4zr">]''',
'      ,q''[        <di:waypoint x="1020" y="580" />]''',
'      ,q''[        <di:waypoint x="1082" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02y11qo_di" bpmnElement="Flow_02y11qo">]''',
'      ,q''[        <di:waypoint x="545" y="360" />]''',
'      ,q''[        <di:waypoint x="600" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1a4xxmd_di" bpmnElement="Flow_1a4xxmd">]''',
'      ,q''[        <di:waypoint x="520" y="385" />]''',
'      ,q''[        <di:waypoint x="520" y="580" />]''',
'      ,q''[        <di:waypoint x="600" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1yzay12" bpmnElement="Flow_134vuwh">]''',
'      ,q''[        <di:waypoint x="1020" y="750" />]''',
'      ,q''[        <di:waypoint x="1082" y="750" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_14oqpn7_di" bpmnElement="Flow_14oqpn7">]''',
'      ,q''[        <di:waypoint x="520" y="385" />]''',
'      ,q''[        <di:waypoint x="520" y="750" />]''',
'      ,q''[        <di:waypoint x="600" y="750" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0xg75l1" bpmnElement="Flow_1inz4p7">]''',
'      ,q''[        <di:waypoint x="860" y="750" />]''',
'      ,q''[        <di:waypoint x="920" y="750" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1nd59tv" bpmnElement="Flow_075zpir">]''',
'      ,q''[        <di:waypoint x="700" y="750" />]''',
'      ,q''[        <di:waypoint x="760" y="750" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_050cm0v_di" bpmnElement="Association_050cm0v">]''',
'      ,q''[        <di:waypoint x="630" y="102" />]''',
'      ,q''[        <di:waypoint x="606" y="54" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0bi9txm_di" bpmnElement="Association_0bi9txm">]''',
'      ,q''[        <di:waypoint x="829" y="102" />]''',
'      ,q''[        <di:waypoint x="860" y="37" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0iayq8p_di" bpmnElement="Association_0iayq8p">]''',
'      ,q''[        <di:waypoint x="605" y="322" />]''',
'      ,q''[        <di:waypoint x="580" y="300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1cqii1i_di" bpmnElement="Association_1cqii1i">]''',
'      ,q''[        <di:waypoint x="828" y="320" />]''',
'      ,q''[        <di:waypoint x="858" y="251" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0hlx4e9_di" bpmnElement="Association_0hlx4e9">]''',
'      ,q''[        <di:waypoint x="794" y="540" />]''',
'      ,q''[        <di:waypoint x="782" y="507" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_08292lx_di" bpmnElement="Association_08292lx">]''',
'      ,q''[        <di:waypoint x="856" y="543" />]''',
'      ,q''[        <di:waypoint x="960" y="454" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_185yip0" bpmnElement="Association_00wsf7y">]''',
'      ,q''[        <di:waypoint x="790" y="710" />]''',
'      ,q''[        <di:waypoint x="800" y="663" />]''',
'      ,q''[        <di:waypoint x="837" y="6'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'63" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1mf8re7_di" bpmnElement="Association_1mf8re7">]''',
'      ,q''[        <di:waypoint x="330" y="346" />]''',
'      ,q''[        <di:waypoint x="130" y="290" />]''',
'      ,q''[        <di:waypoint x="130" y="180" />]''',
'      ,q''[        <di:waypoint x="208" y="180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 7e - Introduction to Iterations and Tasks'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial7f" name="A7f - Sequential Iterations with SubProcesses and Completions" isExecutable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_Start" name="Start">]''',
'      ,q''[      <bpmn:outgoing>Flow_00jstgp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_PreSplit" name="Pre-Split">]''',
'      ,q''[      <bpmn:incoming>Flow_00jstgp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1i6fc42</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_00jstgp" sourceRef="Event_Start" targetRef="Activity_PreSplit" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1i6fc42" sourceRef="Activity_PreSplit" targetRef="Gateway_Split" />]''',
'      ,q''[    <bpmn:task id="Activity_A1" name="A1- List">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EmpList</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1ngmguv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0xh1wjg</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ngmguv" sourceRef="Gateway_Split" targetRef="Activity_A1" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0xh1wjg" sourceRef="Activity_A1" targetRef="Activity_A2" />]''',
'      ,q''[    <bpmn:task id="Activity_A3" name="A3">]''',
'      ,q''[      <bpmn:incoming>Flow_1v6vync</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0emop6i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1v6vync" sourceRef="Activity_A2" targetRef="Activity_A3" />]''',
'      ,q''[    <bpmn:endEvent id="Event_AEnd" name="AEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0emop6i</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0emop6i" sourceRef="Activity_A3" targetRef="Event_AEnd" />]''',
'      ,q''[    <bpmn:task id="Activity_B1" name="B1 - Array">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EmpArray</apex:varName>]''',
'      ,q''[            <apex:varDataType>JSON</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryArray</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename, empno]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_02y11qo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mg0jl9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_B3" name="B3">]''',
'      ,q''[      <bpmn:incoming>Flow_0m8ne0j</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0cv0t6o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_BEnd" name="BEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0cv0t6o</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mg0jl9" sourceRef="Activity_B1" targetRef="Activity_B2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0m8ne0j" sourceRef="Activity_B2" targetRef="Activity_B3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cv0t6o" sourceRef="Activity_B3" targetRef="Event_BEnd" />]''',
'      ,q''[    <bpmn:task id="Activity_C1" name="C1 - Query">]''',
'      ,q''[      <bpmn:incoming>Flow_1a4xxmd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1f9kxmo</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_C3" name="C3">]''',
'      ,q''[      <bpmn:incoming>Flow_1dcufu5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0opd4zr</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_CEnd" name="CEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0opd4zr</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1f9kxmo" sourceRef="Activity_C1" targetRef="Activity_C2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dcufu5" sourceRef="Activity_C2" targetRef="Activity_C3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0opd4zr" sourceRef="Activity_C3" targetRef="Event_CEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02y11qo" sourceRef="Gateway_Split" targetRef="Activity_B1" apex:sequence="20" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1a4xxmd" sourceRef="Gateway_Split" targetRef="Activity_C1" apex:sequence="30" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_Split" name="Split">]''',
'      ,q''[      <bpmn:incoming>Flow_1i6fc42</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ngmguv</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_02y11qo</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1a4xxmd</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1qgior9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:subProcess id="Activity_A2" name="A2">]''',
'      ,q''[      <bpmn:incoming>Flow_0xh1wjg</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1v6vync</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics isSequential="true">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Instance &amp;LOOP_COUNTER. : Employee &amp;ENAME.</apex:description>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableList</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpList</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayA</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_A2Start" name="A2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_0xcd6m0</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_A2a" name="A2a">]''',
'      ,q''[        <bpmn:incoming>Flow_0xcd6m0</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1alq874</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0xcd6m0" sourceRef="Event_A2Start" targetRef="Activity_A2a" />]''',
'      ,q''[      <bpmn:task id="Activity_A2b" name="A2b">]''',
'      ,q''[        <bpmn:incoming>Flow_1alq874</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0cvzkj3</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1alq874" sourceRef="Activity_A2a" targetRef="Activity_A2b" />]''',
'      ,q''[      <bpmn:endEvent id="Event_A2End" name="A2 End">]''',
'      ,q''[        <bpmn:incoming>Flow_0cvzkj3</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0cvzkj3" sourceRef="Activity_A2b" targetRef="Event_A2End" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_B2" name="B2">]''',
'      ,q''[      <bpmn:incoming>Flow_0mg0jl9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0m8ne0j</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Instance &amp;LOOP_COUNTER. : Employee &amp;ENAME. (&amp;EMPNO.).</apex:description>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpArray</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayB</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_B2Start" name="B2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_0pvftkr</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_B2a" name="B2a">]''',
'      ,q''[        <bpmn:incoming>Flow_0pvftkr</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1l3p7hs</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0pvftkr" sourceRef="Event_B2Start" targetRef="Activity_B2a" />]''',
'      ,q''[      <bpmn:task id="Activity_B2b" name="B2b">]''',
'      ,q''[        <bpmn:incoming>Flow_1l3p7hs</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0macjlk</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1l3p7hs" sourceRef="Activity_B2a" targetRef="Activity_B2b" />]''',
'      ,q''[      <bpmn:endEvent id="Event_B2End" name="B2 End">]''',
'      ,q''[        <bpmn:incoming>Flow_0macjlk</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0macjlk" sourceRef="Activity_B2b" targetRef="Event_B2End" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_C2" name="C2">]''',
'      ,q''[      <bpmn:incoming>Flow_1f9kxmo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dcufu5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Instance &amp;LOOP_COUNTER. : Employee &amp;ENAME. (&amp;EMPNO.).</apex:description>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>sqlQueryArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>select ename, empno]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayC</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt; 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_C2Start" name="C2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_1dcanwo</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_C2a" name="C2a">]''',
'      ,q''[        <bpmn:incoming>Flow_1dcanwo</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1ot6t0q</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:task id="Activity_C2b" name="C2b">]''',
'      ,q''[        <bpmn:incoming>Flow_1ot6t0q</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0t5f62e</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:endEvent id="Event_C2End" name="C2 End">]''',
'      ,q''[        <bpmn:incoming>Flow_0t5f62e</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1dcanwo" sourceRef="Event_C2Start" targetRef="Activity_C2a" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1ot6t0q" sourceRef="Activity_C2a" targetRef="Activity_C2b" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0t5f62e" sourceRef="Activity_C2b" targetRef="Event_C2End" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:task id="Activity_D1" name="D1 - Loop Query">]''',
'      ,q''[      <bpmn:incoming>Flow_1qgior9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_01x54dq</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_D3" name="D3">]''',
'      ,q''[      <bpmn:incoming>Flow_1xv59ld</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1da9m66</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_DEnd" name="DEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_1da9m66</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:subProcess id="Activity_D2" name="D2">]''',
'      ,q''[      <bpmn:incoming>Flow_01x54dq</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1xv59ld</bpmn:outgoing>]''',
'      ,q''[      <bpmn:standardLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Loop &amp;LOOP_COUNTER.</apex:description>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayD</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt; 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:standardLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_D2Start" name="D2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_19abxc6</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_D2a" name="D2a">]''',
'      ,q''[        <bpmn:incoming>Flow_19abxc6</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1n9349j</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:task id="Activity_D2b" name="D2b">]''',
'      ,q''[        <bpmn:incoming>Flow_1n9349j</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0130kla</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:endEvent id="Event_D2End" name="D2 End">]''',
'      ,q''[        <bpmn:incoming>Flow_0130kla</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_19abxc6" sourceRef="Event_D2Start" targetRef="Activity_D2a" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1n9349j" sourceRef="Activity_D2a" targetRef="Activity_D2b" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0130kla" sourceRef="Activity_D2b" targetRef="Event_D2End" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_01x54dq" sourceRef="Activity_D1" targetRef="Activity_D2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1xv59ld" sourceRef="Activity_D2" targetRef="Activity_D3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1da9m66" sourceRef="Activity_D3" targetRef="Event_DEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1qgior9" sourceRef="Gateway_Split" targetRef="Activity_D1" apex:sequence="40" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0i9q5wo">]''',
unistr('      ,q''[      <bpmn:text>emplist = select name\00A0]'''),
'      ,q''[from emp]''',
'      ,q''[where dept no = 20]''',
'      ,q''[]''',
'      ,q''[SMITH:JONES:SCOTT:ADAMS:FORD</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_050cm0v" sourceRef="Activity_A1" targetRef="TextAnnotation_0i9q5wo" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_06yrhts">]''',
'      ,q''[      <bpmn:text>iterate over emplist until 3 completed</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0bi9txm" sourceRef="Activity_A2" targetRef="TextAnnotation_06yrhts" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1dh1ysa">]''',
'      ,q''[      <bpmn:text>emparray = select name, empno from amp where dept no = 20]''',
'      ,q''[]''',
'      ,q''[[{"name":"SMITH","EMPNO":7369},]''',
'      ,q''[{"name":"JONES","EMPNO":7566}]''',
'      ,q''[...]</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0iayq8p" sourceRef="Activity_B1" targetRef="TextAnnotation_1dh1ysa" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1tdwshf">]''',
'      ,q''[      <bpmn:text>iterate over emparray until 3 completed</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1cqii1i" sourceRef="Activity_B2" targetRef="TextAnnotation_1tdwshf" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0ehpw4n">]''',
'      ,q''[      <bpmn:text>iterate over query until 3 completed]''',
'      ,q''[]''',
unistr('      ,q''[select name, empno\00A0]'''),
'      ,q''[from emp]''',
'      ,q''[where dept no = 20</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0hlx4e9" sourceRef="Activity_C2" targetRef="TextAnnotation_0ehpw4n" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1dxh1gv">]''',
'      ,q''[      <bpmn:text>loop until 3 completed</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_03r5hig" sourceRef="Activity_D2" targetRef="TextAnnotation_1dxh1gv" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0hgci3t">]''',
'      ,q''[      <bpmn:text>This time, we''re iterating sub processes, rather than]''',
unistr('      ,q''[tasks. \00A0 But the idea is pretty similar.]'''),
'      ,q''[]''',
'      ,q''[Again, this requires the Enterprise Edition.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0jy3m4z" associationDirection="None" sourceRef="Activity_PreSplit" targetRef="TextAnnotation_0hgci3t" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1h4yyjp">]''',
unistr('      ,q''[      <bpmn:text>Hint: \00A0If you are struggling to remember which is parallel &amp; which is sequential.... paraLLeL has three l''s in it, which looks a bit like the three vertical lines!]'''),
'      ,q''[Now you won''t forget...</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0iaq5us" associationDirection="None" sourceRef="Event_Start" targetRef="TextAnnotation_1h4yyjp" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial7f">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0nj6ios_di" bpmnElement="Event_Start">]''',
'      ,q''[        <dc:Bounds x="242" y="342" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="248" y="318" width="24" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1v4awr2_di" bpmnElement="Activity_PreSplit">]''',
'      ,q''[        <dc:Bounds x="330" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06o8whk_di" bpmnElement="Activity_A1" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1m1j7lz_di" bpmnElement="Activity_A3" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="920" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0xoy17b_di" bpmnElement="Event_AEnd" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1082" y="124" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1088" y="167" width="27" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0lsnoc7" bpmnElement="Activity_B1" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="600" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_12yruu2" bpmnElement="Activity_B3" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="920" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_10192cq" bpmnElement="Event_BEnd" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1082" y="342" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="385" width="27" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0dwx7ia" bpmnElement="Activity_C1" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="600" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1s29z1t" bpmnElement="Activity_C3" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="920" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1x8vuch" bpmnElement="Event_CEnd" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="1082" y="562" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="605" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1b1nb8o_di" bpmnElement="Gateway_Split" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="495" y="335" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="489" y="313" width="22" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_109mvy1_di" bpmnElement="Activity_A2" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="760" y="102" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1mmigx9_di" bpmnElement="Activity_B2" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="760" y="320" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1xa0r7w_di" bpmnElement="Activity_C2" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="760" y="540" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0gpln1r" bpmnElement="Activity_D1" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="600" y="760" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_14d44fs" bpmnElement="Activity_D3" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="920" y="760" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_144ziin" bpmnElement="Event_DEnd" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1082" y="782" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="825" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1t67ock" bpmnElement="Activity_D2" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="760" y="760" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0jy3m4z_di" bpmnElement="Association_0jy3m4z">]''',
'      ,q''[        <di:waypoint x="330" y="334" />]''',
'      ,q''[        <di:waypoint x="150" y="240" />]''',
'      ,q''[        <di:waypoint x="120" y="160" />]''',
'      ,q''[        <di:waypoint x="190" y="160" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0iaq5us_di" bpmnElement="Association_0iaq5us">]''',
'      ,q''[        <di:waypoint x="260" y="378" />]''',
'      ,q''[        <di:waypoint x="260" y="470" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0i9q5wo_di" bpmnElement="TextAnnotation_0i9q5wo">]''',
'      ,q''[        <dc:Bounds x="570" y="-28" width="280" height="82" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_06yrhts_di" bpmnElement="TextAnnotation_06yrhts">]''',
'      ,q''[        <dc:Bounds x="860" y="22" width="160" height="39" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1dh1ysa_di" bpmnElement="TextAnnotation_1dh1ysa">]''',
'      ,q''[        <dc:Bounds x="570" y="201" width="207" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1tdwshf_di" bpmnElement="TextAnnotation_1tdwshf">]''',
'      ,q''[        <dc:Bounds x="8'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'60" y="231" width="160" height="39" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0ehpw4n_di" bpmnElement="TextAnnotation_0ehpw4n">]''',
'      ,q''[        <dc:Bounds x="850" y="430" width="160" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0ghoryq" bpmnElement="TextAnnotation_1dxh1gv">]''',
'      ,q''[        <dc:Bounds x="850" y="650" width="160" height="30" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_00jstgp_di" bpmnElement="Flow_00jstgp">]''',
'      ,q''[        <di:waypoint x="278" y="360" />]''',
'      ,q''[        <di:waypoint x="330" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1i6fc42_di" bpmnElement="Flow_1i6fc42">]''',
'      ,q''[        <di:waypoint x="430" y="360" />]''',
'      ,q''[        <di:waypoint x="495" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ngmguv_di" bpmnElement="Flow_1ngmguv">]''',
'      ,q''[        <di:waypoint x="520" y="335" />]''',
'      ,q''[        <di:waypoint x="520" y="142" />]''',
'      ,q''[        <di:waypoint x="600" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xh1wjg_di" bpmnElement="Flow_0xh1wjg">]''',
'      ,q''[        <di:waypoint x="700" y="142" />]''',
'      ,q''[        <di:waypoint x="760" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1v6vync_di" bpmnElement="Flow_1v6vync">]''',
'      ,q''[        <di:waypoint x="860" y="142" />]''',
'      ,q''[        <di:waypoint x="920" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0emop6i_di" bpmnElement="Flow_0emop6i">]''',
'      ,q''[        <di:waypoint x="1020" y="142" />]''',
'      ,q''[        <di:waypoint x="1082" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1fgochk" bpmnElement="Flow_0mg0jl9">]''',
'      ,q''[        <di:waypoint x="700" y="360" />]''',
'      ,q''[        <di:waypoint x="760" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1ipi0cl" bpmnElement="Flow_0m8ne0j">]''',
'      ,q''[        <di:waypoint x="860" y="360" />]''',
'      ,q''[        <di:waypoint x="920" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1j2m5si" bpmnElement="Flow_0cv0t6o">]''',
'      ,q''[        <di:waypoint x="1020" y="360" />]''',
'      ,q''[        <di:waypoint x="1082" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_04kv3hq" bpmnElement="Flow_1f9kxmo">]''',
'      ,q''[        <di:waypoint x="700" y="580" />]''',
'      ,q''[        <di:waypoint x="760" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0pgg5lp" bpmnElement="Flow_1dcufu5">]''',
'      ,q''[        <di:waypoint x="860" y="580" />]''',
'      ,q''[        <di:waypoint x="920" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_13nxtw3" bpmnElement="Flow_0opd4zr">]''',
'      ,q''[        <di:waypoint x="1020" y="580" />]''',
'      ,q''[        <di:waypoint x="1082" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02y11qo_di" bpmnElement="Flow_02y11qo">]''',
'      ,q''[        <di:waypoint x="545" y="360" />]''',
'      ,q''[        <di:waypoint x="600" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1a4xxmd_di" bpmnElement="Flow_1a4xxmd">]''',
'      ,q''[        <di:waypoint x="520" y="385" />]''',
'      ,q''[        <di:waypoint x="520" y="580" />]''',
'      ,q''[        <di:waypoint x="600" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_162qrx2" bpmnElement="Flow_01x54dq">]''',
'      ,q''[        <di:waypoint x="700" y="800" />]''',
'      ,q''[        <di:waypoint x="760" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1325uez" bpmnElement="Flow_1xv59ld">]''',
'      ,q''[        <di:waypoint x="860" y="800" />]''',
'      ,q''[        <di:waypoint x="920" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0e7p0q5" bpmnElement="Flow_1da9m66">]''',
'      ,q''[        <di:waypoint x="1020" y="800" />]''',
'      ,q''[        <di:waypoint x="1082" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qgior9_di" bpmnElement="Flow_1qgior9">]''',
'      ,q''[        <di:waypoint x="520" y="385" />]''',
'      ,q''[        <di:waypoint x="520" y="800" />]''',
'      ,q''[        <di:waypoint x="600" y="800" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_050cm0v_di" bpmnElement="Association_050cm0v">]''',
'      ,q''[        <di:waypoint x="630" y="102" />]''',
'      ,q''[        <di:waypoint x="606" y="54" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0bi9txm_di" bpmnElement="Association_0bi9txm">]''',
'      ,q''[        <di:waypoint x="829" y="102" />]''',
'      ,q''[        <di:waypoint x="860" y="37" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0iayq8p_di" bpmnElement="Association_0iayq8p">]''',
'      ,q''[        <di:waypoint x="605" y="322" />]''',
'      ,q''[        <di:waypoint x="580" y="300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1cqii1i_di" bpmnElement="Association_1cqii1i">]''',
'      ,q''[        <di:waypoint x="828" y="320" />]''',
'      ,q''[        <di:waypoint x="858" y="251" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0hlx4e9_di" bpmnElement="Association_0hlx4e9">]''',
'      ,q''[        <di:waypoint x="823" y="540" />]''',
'      ,q''[        <di:waypoint x="842" y="478" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0mr2vpy" bpmnElement="Association_03r5hig">]''',
'      ,q''[        <di:waypoint x="819" y="760" />]''',
'      ,q''[        <di:waypoint x="842" y="665" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0hgci3t_di" bpmnElement="TextAnnotation_0hgci3t">]''',
'      ,q''[        <dc:Bounds x="190" y="124" width="339.99094645182294" height="66.66667090521918" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1h4yyjp_di" bpmnElement="TextAnnotation_1h4yyjp">]''',
'      ,q''[        <dc:Bounds x="90" y="470" width="220" height="128" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_15ubg12">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0a722e0" bpmnElement="Activity_A2">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_03m23u4_di" bpmnElement="Event_A2Start">]''',
'      ,q''[        <dc:Bounds x="-498" y="-168" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-500" y="-125" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0h2vez0_di" bpmnElement="Activity_A2a" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="-410" y="-190" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_032mmho_di" bpmnElement="Activity_A2b" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="-250" y="-190" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_05xh4ts_di" bpmnElement="Event_A2End">]''',
'      ,q''[        <dc:Bounds x="-88" y="-168" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-88" y="-125" width="37" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xcd6m0_di" bpmnElement="Flow_0xcd6m0">]''',
'      ,q''[        <di:waypoint x="-462" y="-150" />]''',
'      ,q''[        <di:waypoint x="-410" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1alq874_di" bpmnElement="Flow_1alq874">]''',
'      ,q''[        <di:waypoint x="-310" y="-150" />]''',
'      ,q''[        <di:waypoint x="-250" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cvzkj3_di" bpmnElement="Flow_0cvzkj3">]''',
'      ,q''[        <di:waypoint x="-150" y="-150" />]''',
'      ,q''[        <di:waypoint x="-88" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_0872cwf">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_10x527o" bpmnElement="Activity_B2">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_03ss5oz_di" bpmnElement="Event_B2Start">]''',
'      ,q''[        <dc:Bounds x="-438" y="-198" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-440" y="-155" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1lwnb6a_di" bpmnElement="Activity_B2a" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-350" y="-220" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0knio13_di" bpmnElement="Activity_B2b" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="-190" y="-220" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_06jlt4r_di" bpmnElement="Event_B2End">]''',
'      ,q''[        <dc:Bounds x="-28" y="-198" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-28" y="-155" width="37" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0pvftkr_di" bpmnElement="Flow_0pvftkr">]''',
'      ,q''[        <di:waypoint x="-402" y="-180" />]''',
'      ,q''[        <di:waypoint x="-350" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1l3p7hs_di" bpmnElement="Flow_1l3p7hs">]''',
'      ,q''[        <di:waypoint x="-250" y="-180" />]''',
'      ,q''[        <di:waypoint x="-190" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0macjlk_di" bpmnElement="Flow_0macjlk">]''',
'      ,q''[        <di:waypoint x="-90" y="-180" />]''',
'      ,q''[        <di:waypoint x="-28" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_0j6lzkt">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0nkaeke" bpmnElement="Activity_C2">]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_15oxsja" bpmnElement="Event_C2Start">]''',
'      ,q''[        <dc:Bounds x="-308" y="-158" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-310" y="-115" width="41" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0ftvn1o" bpmnElement="Activity_C2a" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-220" y="-180" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1xikkj1" bpmnElement="Activity_C2b" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-60" y="-180" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1dtzoyy" bpmnElement="Event_C2End">]''',
'      ,q''[        <dc:Bounds x="102" y="-158" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="102" y="-115" width="37" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1q3grve" bpmnElement="Flow_1dcanwo">]''',
'      ,q''[        <di:waypoint x="-272" y="-140" />]''',
'      ,q''[        <di:waypoint x="-220" y="-140" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0l3l8oi" bpmnElement="Flow_1ot6t0q">]''',
'      ,q''[        <di:waypoint x="-120" y="-140" />]''',
'      ,q''[        <di:waypoint x="-60" y="-140" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0vae546" bpmnElement="Flow_0t5f62e">]''',
'      ,q''[        <di:waypoint x="40" y="-140" />]''',
'      ,q''[        <di:waypoint x="102" y="-140" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_0l1ty2n">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1fl0smv" bpmnElement="Activity_D2">]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0yofx6o" bpmnElement="Event_D2Start">]''',
'      ,q''[        <dc:Bounds x="182" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="180" y="225" width="41" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0ued6ad" bpmnElement="Activity_D2a" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="270" y="160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_12o2sz8" bpmnElement="Activity_D2b" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="430" y="160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1qp6eop" bpmnElement="Event_D2End">]''',
'      ,q''[        <dc:Bounds x="592" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="592" y="225" width="37" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1a5wirs" bpmnElement="Flow_19abxc6">]''',
'      ,q''[        <di:waypoint x="218" y="200" />]''',
'      ,q''[        <di:waypoint x="270" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0nea0zb" bpmnElement="Flow_1n9349j">]''',
'      ,q''[        <di:waypoint x="370" y="200" />]''',
'      ,q''[        <di:waypoint x="430" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1ughvqb" bpmnElement="Flow_0130kla">]''',
'      ,q''[        <di:waypoint x="530" y="200" />]''',
'      ,q''[        <di:waypoint x="592" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 7f - Iterations and Looped Sub Processes'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial7g" name="Tutorial 7g - Nested Parallel SubProcess Iterations" isExecutable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_Start" name="Start">]''',
'      ,q''[      <bpmn:outgoing>Flow_00jstgp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_PreSplit" name="Pre-Split">]''',
'      ,q''[      <bpmn:incoming>Flow_00jstgp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1i6fc42</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_00jstgp" sourceRef="Event_Start" targetRef="Activity_PreSplit" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1i6fc42" sourceRef="Activity_PreSplit" targetRef="Gateway_Split" />]''',
'      ,q''[    <bpmn:task id="Activity_A1" name="A1- List">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EmpList</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1ngmguv</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0xh1wjg</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ngmguv" sourceRef="Gateway_Split" targetRef="Activity_A1" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0xh1wjg" sourceRef="Activity_A1" targetRef="Activity_A2" />]''',
'      ,q''[    <bpmn:task id="Activity_A3" name="A3">]''',
'      ,q''[      <bpmn:incoming>Flow_1v6vync</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0emop6i</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1v6vync" sourceRef="Activity_A2" targetRef="Activity_A3" />]''',
'      ,q''[    <bpmn:endEvent id="Event_AEnd" name="AEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0emop6i</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0emop6i" sourceRef="Activity_A3" targetRef="Event_AEnd" />]''',
'      ,q''[    <bpmn:task id="Activity_B1" name="B1 - Array">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeTask>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>EmpArray</apex:varName>]''',
'      ,q''[            <apex:varDataType>JSON</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>sqlQueryArray</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>select ename, empno]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeTask>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_02y11qo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mg0jl9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_B3" name="B3">]''',
'      ,q''[      <bpmn:incoming>Flow_0m8ne0j</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0cv0t6o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_BEnd" name="BEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0cv0t6o</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mg0jl9" sourceRef="Activity_B1" targetRef="Activity_B2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0m8ne0j" sourceRef="Activity_B2" targetRef="Activity_B3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cv0t6o" sourceRef="Activity_B3" targetRef="Event_BEnd" />]''',
'      ,q''[    <bpmn:task id="Activity_C1" name="C1 - Query">]''',
'      ,q''[      <bpmn:incoming>Flow_1a4xxmd</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1f9kxmo</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_C3" name="C3">]''',
'      ,q''[      <bpmn:incoming>Flow_1dcufu5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0opd4zr</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_CEnd" name="CEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_0opd4zr</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1f9kxmo" sourceRef="Activity_C1" targetRef="Activity_C2" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dcufu5" sourceRef="Activity_C2" targetRef="Activity_C3" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0opd4zr" sourceRef="Activity_C3" targetRef="Event_CEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02y11qo" sourceRef="Gateway_Split" targetRef="Activity_B1" apex:sequence="20" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1a4xxmd" sourceRef="Gateway_Split" targetRef="Activity_C1" apex:sequence="30" />]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_Split" name="Split">]''',
'      ,q''[      <bpmn:incoming>Flow_1i6fc42</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ngmguv</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_02y11qo</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1a4xxmd</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:subProcess id="Activity_A2" name="A2">]''',
'      ,q''[      <bpmn:incoming>Flow_0xh1wjg</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1v6vync</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Iteration A2 - iteration &amp;LOOP_COUNTER. (&amp;ENAME.)</apex:description>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableList</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpList</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>iterationArrayA2</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_A2Start" name="A2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_0xcd6m0</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_A2a" name="A2a">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:beforeTask>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[              <apex:varName>NewEmpList</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression>select ename]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 30</apex:varExpression>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[          </apex:beforeTask>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:incoming>Flow_0xcd6m0</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1alq874</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0xcd6m0" sourceRef="Event_A2Start" targetRef="Activity_A2a" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1alq874" sourceRef="Activity_A2a" targetRef="Activity_A2b" />]''',
'      ,q''[      <bpmn:endEvent id="Event_A2End" name="A2 End">]''',
'      ,q''[        <bpmn:incoming>Flow_0uihkyr</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0cvzkj3" sourceRef="Activity_A2b" targetRef="Activity_A2c" />]''',
'      ,q''[      <bpmn:task id="Activity_A2c" name="A2c">]''',
'      ,q''[        <bpmn:incoming>Flow_0cvzkj3</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0uihkyr</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0uihkyr" sourceRef="Activity_A2c" targetRef="Event_A2End" />]''',
'      ,q''[      <bpmn:subProcess id="Activity_A2b" name="A2b">]''',
'      ,q''[        <bpmn:incoming>Flow_1alq874</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0cvzkj3</bpmn:outgoing>]''',
'      ,q''[        <bpmn:multiInstanceLoopCharacteristics isSequential="true">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:inputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableList</apex:expressionType>]''',
'      ,q''[              <apex:expression>NewEmpList</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[            </apex:inputCollection>]''',
'      ,q''[            <apex:description>Sub Iteration A2b - iteration &amp;LOOP_COUNTER. (&amp;ENAME.)</apex:description>]''',
'      ,q''[            <apex:outputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>iterationArrayA2b</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ename</apex:insideVariable>]''',
'      ,q''[            </apex:outputCollection>]''',
'      ,q''[            <apex:completionCondition>]''',
'      ,q''[              <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[              <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[            </apex:completionCondition>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:startEvent id="Event_A2bStart" name="A2bStart">]''',
'      ,q''[          <bpmn:outgoing>Flow_1mh25vb</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_A2b1" name="A2b1">]''',
'      ,q''[          <bpmn:incoming>Flow_1mh25vb</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_135tn8v</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1mh25vb" sourceRef="Event_A2bStart" targetRef="Activity_A2b1" />]''',
'      ,q''[        <bpmn:task id="Activity_A2b2" name="A2b2">]''',
'      ,q''[          <bpmn:incoming>Flow_135tn8v</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0ipy053</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_135tn8v" sourceRef="Activity_A2b1" targetRef="Activity_A2b2" />]''',
'      ,q''[        <bpmn:endEvent id="Event_A2bEnd" name="A2bEnd">]''',
'      ,q''[          <bpmn:incoming>Flow_0ipy053</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0ipy053" sourceRef="Activity_A2b2" targetRef="Event_A2bEnd" />]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_B2" name="B2">]''',
'      ,q''[      <bpmn:incoming>Flow_0mg0jl9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0m8ne0j</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpArray</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayB</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[      '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_B2Start" name="B2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_0pvftkr</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_B2a" name="B2a">]''',
'      ,q''[        <bpmn:incoming>Flow_0pvftkr</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1l3p7hs</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0pvftkr" sourceRef="Event_B2Start" targetRef="Activity_B2a" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1l3p7hs" sourceRef="Activity_B2a" targetRef="Activity_B2b" />]''',
'      ,q''[      <bpmn:endEvent id="Event_B2End" name="B2 End">]''',
'      ,q''[        <bpmn:incoming>Flow_0macjlk</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0macjlk" sourceRef="Activity_B2b" targetRef="Event_B2End" />]''',
'      ,q''[      <bpmn:subProcess id="Activity_B2b" name="B2b">]''',
'      ,q''[        <bpmn:incoming>Flow_1l3p7hs</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0macjlk</bpmn:outgoing>]''',
'      ,q''[        <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:completionCondition>]''',
'      ,q''[              <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[              <apex:expression>:F4A$completed_instances &gt;= 3</apex:expression>]''',
'      ,q''[            </apex:completionCondition>]''',
'      ,q''[            <apex:outputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>iterArrayNestedB</apex:expression>]''',
'      ,q''[              <apex:insideVariable>dname:deptno</apex:insideVariable>]''',
'      ,q''[            </apex:outputCollection>]''',
'      ,q''[            <apex:inputCollection>]''',
'      ,q''[              <apex:expressionType>sqlQueryArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>Select dname, deptno from dept</apex:expression>]''',
'      ,q''[            </apex:inputCollection>]''',
'      ,q''[            <apex:description>Sub Iteration of B2b: Department &amp;DNAME. (Loop &amp;LOOP_COUNTER.)</apex:description>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:startEvent id="Event_B2BStart" name="B2b start">]''',
'      ,q''[          <bpmn:outgoing>Flow_0kc9rpm</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_B2B1" name="B2B1">]''',
'      ,q''[          <bpmn:incoming>Flow_0kc9rpm</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0cktw33</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0kc9rpm" sourceRef="Event_B2BStart" targetRef="Activity_B2B1" />]''',
'      ,q''[        <bpmn:task id="Activity_B2B2" name="B2B2">]''',
'      ,q''[          <bpmn:incoming>Flow_0cktw33</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0xopiv5</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0cktw33" sourceRef="Activity_B2B1" targetRef="Activity_B2B2" />]''',
'      ,q''[        <bpmn:endEvent id="Event_B2BEnd" name="B2bEnd">]''',
'      ,q''[          <bpmn:incoming>Flow_0xopiv5</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0xopiv5" sourceRef="Activity_B2B2" targetRef="Event_B2BEnd" />]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_C2" name="C2">]''',
'      ,q''[      <bpmn:incoming>Flow_1f9kxmo</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dcufu5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>sqlQueryArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>select ename, empno ]''',
'      ,q''[from emp]''',
'      ,q''[where deptno = 20</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>IterationArrayC</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename:empno</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$completed_instances &gt; 3</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[          <apex:description>Instance &amp;LOOP_COUNTER. (&amp;ENAME.)</apex:description>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_C2Start" name="C2 Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_0l9o9as</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_C2a" name="C2a">]''',
'      ,q''[        <bpmn:incoming>Flow_0l9o9as</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0v9gdmc</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0l9o9as" sourceRef="Event_C2Start" targetRef="Activity_C2a" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0v9gdmc" sourceRef="Activity_C2a" targetRef="Activity_C2b" />]''',
'      ,q''[      <bpmn:task id="Activity_C2c" name="C2c">]''',
'      ,q''[        <bpmn:incoming>Flow_1r97bug</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1buzp0p</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1r97bug" sourceRef="Activity_C2b" targetRef="Activity_C2c" />]''',
'      ,q''[      <bpmn:endEvent id="Event_C2End" name="C2End">]''',
'      ,q''[        <bpmn:incoming>Flow_1buzp0p</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1buzp0p" sourceRef="Activity_C2c" targetRef="Event_C2End" />]''',
'      ,q''[      <bpmn:subProcess id="Activity_C2b" name="C2b">]''',
'      ,q''[        <bpmn:incoming>Flow_0v9gdmc</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1r97bug</bpmn:outgoing>]''',
'      ,q''[        <bpmn:standardLoopCharacteristics>]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:description>C2b Loop - &amp;LOOP_COUNTER.</apex:description>]''',
'      ,q''[            <apex:completionCondition>]''',
'      ,q''[              <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[              <apex:expression>:F4A$LOOP_COUNTER &gt;= 3</apex:expression>]''',
'      ,q''[            </apex:completionCondition>]''',
'      ,q''[            <apex:outputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>C2b_output_array</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ENAME</apex:insideVariable>]''',
'      ,q''[            </apex:outputCollection>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:standardLoopCharacteristics>]''',
'      ,q''[        <bpmn:startEvent id="Event_1pr19p3" name="C2bStart">]''',
'      ,q''[          <bpmn:outgoing>Flow_0nxnzrr</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_08nour2" name="C2BTask">]''',
'      ,q''[          <bpmn:incoming>Flow_0nxnzrr</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_066o4bv</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0nxnzrr" sourceRef="Event_1pr19p3" targetRef="Activity_08nour2" />]''',
'      ,q''[        <bpmn:endEvent id="Event_13t68ia" name="C2bEnd">]''',
'      ,q''[          <bpmn:incoming>Flow_066o4bv</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_066o4bv" sourceRef="Activity_08nour2" targetRef="Event_13t68ia" />]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0i9q5wo">]''',
unistr('      ,q''[      <bpmn:text>emplist = select name\00A0]'''),
'      ,q''[from emp]''',
'      ,q''[where dept no = 20]''',
'      ,q''[]''',
'      ,q''[SMITH:JONES:SCOTT:ADAMS:FORD</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_050cm0v" sourceRef="Activity_A1" targetRef="TextAnnotation_0i9q5wo" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_06yrhts">]''',
'      ,q''[      <bpmn:text>iterate over emplist]''',
'      ,q''[]''',
'      ,q''[contains subprocess with nested SEQUENTIAL iteration</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0bi9txm" sourceRef="Activity_A2" targetRef="TextAnnotation_06yrhts" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1dh1ysa">]''',
'      ,q''[      <bpmn:text>emparray = select name, empno from emp where dept no = 20]''',
'      ,q''[]''',
'      ,q''[[{"name":"SMITH","EMPNO":7369},]''',
'      ,q''[{"name":"JONES","EMPNO":7566}]''',
'      ,q''[...]</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1tdwshf">]''',
unistr('      ,q''[      <bpmn:text>iterate over emparray\00A0]'''),
'      ,q''[]''',
'      ,q''[contains subprocess with nested PARALEL iteration</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1cqii1i" sourceRef="Activity_B2" targetRef="TextAnnotation_1tdwshf" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0ehpw4n">]''',
'      ,q''[      <bpmn:text>iterate over query...]''',
'      ,q''[]''',
unistr('      ,q''[select name, empno\00A0]'''),
'      ,q''[from emp]''',
'      ,q''[where dept no = 20</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0hlx4e9" sourceRef="Activity_C2" targetRef="TextAnnotation_0ehpw4n" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0p3j9kh">]''',
'      ,q''[      <bpmn:text>And in this example, we have Nested]''',
'      ,q''[iterating Sub Processes.]''',
'      ,q''[]''',
'      ,q''[this is where it starts to get difficult to]''',
'      ,q''[keep track of what''s going on.]''',
'      ,q''[]''',
unistr('      ,q''[Use the Iteration Selector in the Viewer \00A0to choose which iteration to look at.]'''),
'      ,q''[]''',
'      ,q''[And look at the product documentation (Iteration concepts)</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1c83hs4" associationDirection="None" sourceRef="Activity_PreSplit" targetRef="TextAnnotation_0p3j9kh" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial7g">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0nj6ios_di" bpmnElement="Event_Start">]''',
'      ,q''[        <dc:Bounds x="242" y="342" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="248" y="385" width="24" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1v4awr2_di" bpmnElement="Activity_PreSplit">]''',
'      ,q''[        <dc:Bounds x="330" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06o8whk_di" bpmnElement="Activity_A1" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="600" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1m1j7lz_di" bpmnElement="Activity_A3" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="920" y="102" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0xoy17b_di" bpmnElement="Event_AEnd" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="1082" y="124" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1088" y="167" width="27" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0lsnoc7" bpmnElement="Activity_B1" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="600" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_12yruu2" bpmnElement="Activity_B3" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="920" y="320" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_10192cq" bpmnElement="Event_BEnd" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1082" y="342" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="385" width="27" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_0dwx7ia" bpmnElement="Activity_C1" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="600" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1s29z1t" bpmnElement="Activity_C3" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="920" y="540" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="BPMNShape_1x8vuch" bpmnElement="Event_CEnd" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1082" y="562" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1087" y="605" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1b1nb8o_di" bpmnElement="Gateway_Split">]''',
'      ,q''[        <dc:Bounds x="495" y="335" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="489" y="313" width="22" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_109mvy1_di" bpmnElement="Activity_A2" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="760" y="102" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1mmigx9_di" bpmnElement="Activity_B2" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="760" y="320" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_07xqvgw_di" bpmnElement="Activity_C2" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="760" y="540" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1c83hs4_di" bpmnElement="Association_1c83hs4">]''',
'      ,q''[        <di:waypoint x="330" y="329" />]''',
'      ,q''[        <di:waypoint x="210" y="255" />]''',
'      ,q''[        <di:waypoint x="278" y="255" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0i9q5wo_di" bpmnElement="TextAnnotation_0i9q5wo">]''',
'      ,q''[        <dc:Bounds x="570" y="-28" width="280" height="82" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_06yrhts_di" bpmnElement="TextAnnotation_06yrhts">]''',
'      ,q''[        <dc:Bounds x="860" y="-28" width="257.9963073730469" height="81.98529052734375" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1dh1ysa_di" bpmnElement="TextAnnotation_1dh1ysa">]''',
'      ,q''[        <dc:Bounds x="570" y="201" width="207" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1tdwshf_di" bpmnElement="TextAnnotation_1tdwshf">]''',
'      ,q''[        <dc:Bounds x="860" y="231" width="180" height="68" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0ehpw4n_di" bpmnElement="TextAnnotation_0ehpw4n">]''',
'      ,q''[        <dc:Bounds x="850" y="430" width="160" height="82" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_00jstgp_di" bpmnElement="Flow_00jstgp">]''',
'      ,q''[        <di:waypoint x="278" y="360" />]''',
'      ,q''[        <di:waypoint x="330" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1i6fc42_di" bpmnElement="Flow_1i6fc42">]''',
'      ,q''[        <di:waypoint x="430" y="360" />]''',
'      ,q''[        <di:waypoint x="495" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ngmguv_di" bpmnElement="Flow_1ngmguv">]''',
'      ,q''[        <di:waypoint x="520" y="335" />]''',
'      ,q''[        <di:waypoint x="520" y="142" />]''',
'      ,q''[        <di:waypoint x="600" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xh1wjg_di" bpmnElement="Flow_0xh1wjg">]''',
'      ,q''[        <di:waypoint x="700" y="142" />]''',
'      ,q''[        <di:waypoint x="760" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1v6vync_di" bpmnElement="Flow_1v6vync">]''',
'      ,q''[        <di:waypoint x="860" y="142" />]''',
'      ,q''[        <di:waypoint x="920" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0emop6i_di" bpmnElement="Flow_0emop6i">]''',
'      ,q''[        <di:waypoint x="1020" y="142" />]''',
'      ,q''[        <di:waypoint x="1082" y="142" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1fgochk" bpmnElement="Flow_0mg0jl9">]''',
'      ,q''[        <di:waypoint x="700" y="360" />]''',
'      ,q''[        <di:waypoint x="760" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1ipi0cl" bpmnElement="Flow_0m8ne0j">]''',
'      ,q''[        <di:waypoint x="860" y="360" />]''',
'      ,q''[        <di:waypoint x="920" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_1j2m5si" bpmnElement="Flow_0cv0t6o">]''',
'      ,q''[        <di:waypoint x="1020" y="360" />]''',
'      ,q''[        <di:waypoint x="1082" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_04kv3hq" bpmnElement="Flow_1f9kxmo">]''',
'      ,q''[        <di:waypoint x="700" y="580" />]''',
'      ,q''[        <di:waypoint x="760" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_0pgg5lp" bpmnElement="Flow_1dcufu5">]''',
'      ,q''[        <di:waypoint x="860" y="580" />]''',
'      ,q''[        <di:waypoint x="920" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="BPMNEdge_13nxtw3" bpmnElement="Flow_0opd4zr">]''',
'      ,q''[        <di:waypoint x="1020" y="580" />]''',
'      ,q''[        <di:waypoint x="1082" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02y11qo_di" bpmnElement="Flow_02y11qo">]''',
'      ,q''[        <di:waypoint x="545" y="360" />]''',
'      ,q''[        <di:waypoint x="600" y="360" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1a4xxmd_di" bpmnElement="Flow_1a4xxmd">]''',
'      ,q''[        <di:waypoint x="520" y="385" />]''',
'      ,q''[        <di:waypoint x="520" y="580" />]''',
'      ,q''[        <di:waypoint x="600" y="580" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_050cm0v_di" bpmnElement="Association_050cm0v">]''',
'      ,q''[        <di:waypoint x="630" y="102" />]''',
'      ,q''[        <di:waypoint x="606" y="54" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0bi9txm_di" bpmnElement="Association_0bi9txm">]''',
'      ,q''[        <di:waypoint x="823" y="102" />]''',
'      ,q''[        <di:waypoint x="860" y="-13" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1cqii1i_di" bpmnElement="Association_1cqii1i">]''',
'      ,q''[        <di:waypoint x="830" y="320" />]''',
'      ,q''[        <di:waypoint x="858" y="265" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0hlx4e9_di" bpmnElement="Association_0hlx4e9">]''',
'      ,q''[        <di:waypoint x="822" y="540" />]''',
'      ,q''[        <di:waypoint x="842" y="471" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0p3j9kh_di" bpmnElement="TextAnnotation_0p3j9kh">]''',
'      ,q''[        <dc:Bounds x="278" y="80" width="222" height="188" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_15ubg12">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0a722e0" bpmnElement="Activity_A2">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_03m23u4_di" bpmnElement="Event_A2Start">]''',
'      ,q''[        <dc:Bounds x="-498" y="-168" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-500" y="-125" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0h2vez0_di" bpmnElement="Activity_A2a" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-410" y="-190" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_05xh4ts_di" bpmnElement="Event_A2End">]''',
'      ,q''[        <dc:Bounds x="32" y="-168" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="32" y="-125" width="37" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1miaqnq_di" bpmnElement="Activity_A2c" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-110" y="-190" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1v7o18t_di" bpmnElement="Activity_A2b" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-250" y="-190" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xcd6m0_di" bpmnElement="Flow_0xcd6m0">]''',
'      ,q''[        <di:waypoint x="-462" y="-150" />]''',
'      ,q''[        <di:waypoint x="-410" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1alq874_di" bpmnElement="Flow_1alq874">]''',
'      ,q''[        <di:waypoint x="-310" y="-150" />]''',
'      ,q''[        <di:waypoint x="-250" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cvzkj3_di" bpmnElement="Flow_0cvzkj3">]''',
'      ,q''[        <di:waypoint x="-150" y="-150" />]''',
'      ,q''[        <di:waypoint x="-110" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0uihkyr_di" bpmnElement="Flow_0uihkyr">]''',
'      ,q''[        <di:waypoint x="-10" y="-150" />]''',
'      ,q''[        <di:waypoint x="32" y="-150" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_0872cwf">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_10x527o" bpmnElement="Activity_B2">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_03ss5oz_di" bpmnElement="Event_B2Start">]''',
'      ,q''[        <dc:Bounds x="-438" y="-198" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-440" y="-155" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1lwnb6a_di" bpmnElement="Activity_B2a">]''',
'      ,q''[        <dc:Bounds x="-350" y="-220" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_06jlt4r_di" bpmnElement="Event_B2End">]''',
'      ,q''[        <dc:Bounds x="-28" y="-198" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-28" y="-155" width="37" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1c4d1sg_di" bpmnElement="Activity_B2b">]''',
'      ,q''[        <dc:Bounds x="-190" y="-220" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0pvftkr_di" bpmnElement="Flow_0pvftkr">]''',
'      ,q''[        <di:waypoint x="-402" y="-180" />]''',
'      ,q''[        <di:waypoint x="-350" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1l3p7hs_di" bpmnElement="Flow_1l3p7hs">]''',
'      ,q''[        <di:waypoint x="-250" y="-180" />]''',
'      ,q''[        <di:waypoint x="-190" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0macjlk_di" bpmnElement="Flow_0macjlk">]''',
'      ,q''[        <di:waypoint x="-90" y="-180" />]''',
'      ,q''[        <di:waypoint x="-28" y="-180" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_148ytf9">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0zczjb2" bpmnElement="Activity_A2b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_10m6kpa_di" bpmnElement="Event_A2bStart">]''',
'      ,q''[        <dc:Bounds x="-438" y="-88" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-441" y="-45" width="43" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1woa0md_di" bpmnElement="Activity_A2b1" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-350" y="-110" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0m0g7ri_di" bpmnElement="Activity_A2b2" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="-190" y="-110" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_01fvnpp_di" bpmnElement="Event_A2bEnd">]''',
'      ,q''[        <dc:Bounds x="-28" y="-88" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-30" y="-45" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mh25vb_di" bpmnElement="Flow_1mh25vb">]''',
'      ,q''[        <di:waypoint x="-402" y="-70" />]''',
'      ,q''[        <di:waypoint x="-350" y="-70" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_135tn8v_di" bpmnElement="Flow_135tn8v">]''',
'      ,q''[        <di:waypoint x="-250" y="-70" />]''',
'      ,q''[        <di:waypoint x="-190" y="-70" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'bpmndi:BPMNEdge id="Flow_0ipy053_di" bpmnElement="Flow_0ipy053">]''',
'      ,q''[        <di:waypoint x="-90" y="-70" />]''',
'      ,q''[        <di:waypoint x="-28" y="-70" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_0cmoet0">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_13wwlah" bpmnElement="Activity_B2b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0lyr3gn_di" bpmnElement="Event_B2BStart">]''',
'      ,q''[        <dc:Bounds x="-528" y="-128" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-532" y="-85" width="45" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0qdf4xi_di" bpmnElement="Activity_B2B1">]''',
'      ,q''[        <dc:Bounds x="-440" y="-150" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1wf3c1q_di" bpmnElement="Activity_B2B2">]''',
'      ,q''[        <dc:Bounds x="-280" y="-150" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1l0ot67_di" bpmnElement="Event_B2BEnd">]''',
'      ,q''[        <dc:Bounds x="-118" y="-128" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-120" y="-85" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0kc9rpm_di" bpmnElement="Flow_0kc9rpm">]''',
'      ,q''[        <di:waypoint x="-492" y="-110" />]''',
'      ,q''[        <di:waypoint x="-440" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cktw33_di" bpmnElement="Flow_0cktw33">]''',
'      ,q''[        <di:waypoint x="-340" y="-110" />]''',
'      ,q''[        <di:waypoint x="-280" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xopiv5_di" bpmnElement="Flow_0xopiv5">]''',
'      ,q''[        <di:waypoint x="-180" y="-110" />]''',
'      ,q''[        <di:waypoint x="-118" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_0ncf303">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0tcn2n9" bpmnElement="Activity_C2">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0gc0w7u_di" bpmnElement="Event_C2Start">]''',
'      ,q''[        <dc:Bounds x="-558" y="-128" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-560" y="-85" width="41" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1th265y_di" bpmnElement="Activity_C2a">]''',
'      ,q''[        <dc:Bounds x="-470" y="-150" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0nplyt3_di" bpmnElement="Activity_C2c">]''',
'      ,q''[        <dc:Bounds x="-150" y="-150" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1yeizp8_di" bpmnElement="Event_C2End">]''',
'      ,q''[        <dc:Bounds x="12" y="-128" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="13" y="-85" width="34" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_152bw7m_di" bpmnElement="Activity_C2b">]''',
'      ,q''[        <dc:Bounds x="-310" y="-150" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0l9o9as_di" bpmnElement="Flow_0l9o9as">]''',
'      ,q''[        <di:waypoint x="-522" y="-110" />]''',
'      ,q''[        <di:waypoint x="-470" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0v9gdmc_di" bpmnElement="Flow_0v9gdmc">]''',
'      ,q''[        <di:waypoint x="-370" y="-110" />]''',
'      ,q''[        <di:waypoint x="-310" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1r97bug_di" bpmnElement="Flow_1r97bug">]''',
'      ,q''[        <di:waypoint x="-210" y="-110" />]''',
'      ,q''[        <di:waypoint x="-150" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1buzp0p_di" bpmnElement="Flow_1buzp0p">]''',
'      ,q''[        <di:waypoint x="-50" y="-110" />]''',
'      ,q''[        <di:waypoint x="12" y="-110" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1u6oxd8">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1hygx4m" bpmnElement="Activity_C2b">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1pr19p3_di" bpmnElement="Event_1pr19p3">]''',
'      ,q''[        <dc:Bounds x="-398" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-402" y="-95" width="44" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_08nour2_di" bpmnElement="Activity_08nour2">]''',
'      ,q''[        <dc:Bounds x="-310" y="-160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_13t68ia_di" bpmnElement="Event_13t68ia">]''',
'      ,q''[        <dc:Bounds x="-158" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-160" y="-95" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0nxnzrr_di" bpmnElement="Flow_0nxnzrr">]''',
'      ,q''[        <di:waypoint x="-362" y="-120" />]''',
'      ,q''[        <di:waypoint x="-310" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_066o4bv_di" bpmnElement="Flow_066o4bv">]''',
'      ,q''[        <di:waypoint x="-210" y="-120" />]''',
'      ,q''[        <di:waypoint x="-158" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 7g - Iterations and Looped Nested Sub Processes'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:xsi'
||'="http://www.w3.org/2001/XMLSchema-instance" xmlns:apex="https://flowsforapex.org" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_0wpri2w" targetNamespace="http:'
||'//bpmn.io/schema/bpmn" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:collaboration id="Collaboration_Tutorial_8a">]''',
'      ,q''[    <bpmn:participant id="Participant_1eelczk" name="My Flows For APEX Pool" processRef="Process_Tutorial8a" />]''',
'      ,q''[    <bpmn:participant id="Participant_1yoxs96" name="Enterprise Edition Process" processRef="Process_0pkcg19" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_15hbzbw" sourceRef="Activity_1k0u0f3" targetRef="Event_1vrocwd" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_07eem0o" sourceRef="Event_1c7yivk" targetRef="Activity_1r9v7rj" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_0995mzn" sourceRef="Event_0w25ri0" targetRef="Event_05kih0q" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_0ggij67" sourceRef="Event_1ao382y" targetRef="Event_10g29co" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_17etfk6" name="from. inside end" sourceRef="Activity_1ewbvrh" targetRef="Event_0wngn5b" />]''',
'      ,q''[    <bpmn:messageFlow id="Flow_0nj0983" sourceRef="Event_02j6heh" targetRef="Event_13x93sm" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1nzqkt7">]''',
'      ,q''[      <bpmn:text>All running paths must end before the sub process completes and moves on to the next task</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0ig39o8">]''',
'      ,q''[      <bpmn:text>Annotations help explain the model to readers</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1n3sri5">]''',
'      ,q''[      <bpmn:text>Routing using Gateway Routing Variable</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1az2cby">]''',
'      ,q''[      <bpmn:text>Routing Using Gateway Routing Expressions</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:group id="Group_0idyabq" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0gjv3vu">]''',
unistr('      ,q''[      <bpmn:text>BPMN MessageFlow \00A0is used to communicate BETWEEN BPMN Processes</bpmn:text>]'''),
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_036ykn1" associationDirection="None" sourceRef="Group_0idyabq" targetRef="TextAnnotation_0gjv3vu" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_19s4sic">]''',
'      ,q''[      <bpmn:text>Features marked * require the Flows for APEX Enterprise Edition, a paid feature</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0tnvzhx">]''',
'      ,q''[      <bpmn:text>Click to open to see parallel* and sequentially* iterating task, loop event*, and a message end event*</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_14n3ji1">]''',
'      ,q''[      <bpmn:text>This is a BPMN Group - it has no function other than to make your diagrams more understandable</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_04tzkyw" associationDirection="None" sourceRef="TextAnnotation_14n3ji1" targetRef="Group_0idyabq" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0e04jqy">]''',
'      ,q''[      <bpmn:text>This section shows process collaboration using MessageFlow on start, end and boundary events, and looping and iteration of tasks and subProcesses]''',
'      ,q''[]''',
unistr('      ,q''[THIS SECTION WILL ONLY\00A0]'''),
'      ,q''[WORK IF YOU HAVE THE]''',
'      ,q''[ENTERPRISE EDITION INSTALLED AND THE DIAGRAM IS IN ''released'' STATUS.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[  </bpmn:collaboration>]''',
'      ,q''[  <bpmn:process id="Process_Tutorial8a" name="Tutorial8a - The Full Monty" isExecutable="true" apex:isCallable="false" apex:isStartable="true" apex:applicationId="" apex:pageId="">]''',
'      ,q''[    <bpmn:extensionElements>]''',
'      ,q''[      <apex:priority>]''',
'      ,q''[        <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[        <apex:expression>3</apex:expression>]''',
'      ,q''[      </apex:priority>]''',
'      ,q''[      <apex:dueOn>]''',
'      ,q''[        <apex:expressionType>interval</apex:expressionType>]''',
'      ,q''[        <apex:expression>PT30M</apex:expression>]''',
'      ,q''[      </apex:dueOn>]''',
'      ,q''[    </bpmn:extensionElements>]''',
'      ,q''[    <bpmn:laneSet id="LaneSet_1kndmqr">]''',
'      ,q''[      <bpmn:lane id="Lane_A" name="Department A Lane" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>StartEvent_1</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_stdTask</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_CloseInput</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_FRemindEnd</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_EBG</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_TimerH</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_G</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_GHMerge</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_H</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_MessageCatch_G</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_FRemind</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_TheEnd</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_MainSync</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_Notify</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_FTermEnd</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_SubProcF</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_MainSplit</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_FTimeoutBE</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_FNI_Timer_BE</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_FEscBE</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_0eex1qm</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_0ayu08h</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:childLaneSet id="LaneSet_0us2kaj">]''',
'      ,q''[          <bpmn:lane id="Lane_0odyi81" name="Dept A Analyst" apex:isRole="false">]''',
'      ,q''[            <bpmn:flowNodeRef>StartEvent_1</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_stdTask</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_CloseInput</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_FRemindEnd</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Gateway_EBG</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_TimerH</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_G</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Gateway_GHMerge</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_H</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_MessageCatch_G</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_FRemind</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_TheEnd</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Gateway_MainSync</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_Notify</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_FTermEnd</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_SubProcF</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Gateway_MainSplit</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_FTimeoutBE</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_FNI_Timer_BE</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_FEscBE</bpmn:flowNodeRef>]''',
'      ,q''[          </bpmn:lane>]''',
'      ,q''[          <bpmn:lane id="Lane_0tdl27u" name="Dept A Manager" apex:isRole="false">]''',
'      ,q''[            <bpmn:flowNodeRef>Activity_0eex1qm</bpmn:flowNodeRef>]''',
'      ,q''[            <bpmn:flowNodeRef>Event_0ayu08h</bpmn:flowNodeRef>]''',
'      ,q''[          </bpmn:lane>]''',
'      ,q''[        </bpmn:childLaneSet>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[      <bpmn:lane id="Lane_B" name="Department B Lane" apex:isRole="false">]''',
'      ,q''[        <bpmn:flowNodeRef>Event_uT_remind_end</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_Reminder</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_Excl_Choose1</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_OptionB</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_CTermEnd</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_S</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_RSTClose</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_R</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_T</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_ManualTask</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_scriptTask</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1i0012l</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_19316nz</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_OptionA</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_RST_Inc_Split</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Gateway_ABMerge</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_userTask</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Activity_1noqbij</bpmn:flowNodeRef>]''',
'      ,q''[        <bpmn:flowNodeRef>Event_ReminderBE</bpmn:flowNodeRef>]''',
'      ,q''[      </bpmn:lane>]''',
'      ,q''[    </bpmn:laneSet>]''',
'      ,q''[    <bpmn:startEvent id="StartEvent_1" name="Start">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:onEvent>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>BUSINESS_REF</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>plsqlRawExpression</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>coalesce( flow_globals.business_ref, to_char(flow_globals.process_id) )</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:onEvent>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:outgoing>Flow_1u5kfn1</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_stdTask" name="standard Task">]''',
'      ,q''[      <bpmn:incoming>Flow_1u5kfn1</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0k089wp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1u5kfn1" sourceRef="StartEvent_1" targetRef="Activity_stdTask" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0k089wp" sourceRef="Activity_stdTask" targetRef="Gateway_MainSplit" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1q7lyne" sourceRef="Gateway_MainSplit" targetRef="Activity_userTask" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_15m8qw2" sourceRef="Gateway_MainSplit" targetRef="Activity_SubProcF" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1sl1mr5" sourceRef="Gateway_MainSplit" targetRef="Gateway_EBG" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0av2w95" sourceRef="Activity_userTask" targetRef="Activity_1noqbij" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_139aflr" sourceRef="Activity_Reminder" targetRef="Event_uT_remind_end" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1qh3zb4" sourceRef="Event_FTimeoutBE" targetRef="Activity_CloseInput" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1320p09" sourceRef="Activity_CloseInput" targetRef="Gateway_MainSync" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1hkw8tj" sourceRef="Activity_FRemind" targetRef="Event_FRemindEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1hbzc2c" sourceRef="Gateway_EBG" targetRef="Event_MessageCatch_G" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ab2ygs" sourceRef="Gateway_EBG" targetRef="Event_TimerH" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0bevchi" sourceRef="Event_TimerH" targetRef="Activity_H" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_04ew1x4" sourceRef="Event_MessageCatch_G" targetRef="Activity_G" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0e3ltbj" sourceRef="Activity_G" targetRef="Gateway_GHMerge" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0mw3yoc" sourceRef="Activity_H" targetRef="Gateway_GHMerge" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1lkzgyz" sourceRef="Gateway_GHMerge" targetRef="Gateway_MainSync" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1bssnss" sourceRef="Event_ReminderBE" targetRef="Activity_Reminder" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_10ebnqk" sourceRef="Event_FNI_Timer_BE" targetRef="Activity_FRemind" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0f14hah" sourceRef="Event_FEscBE" targetRef="Activity_Notify" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1d0hvhw" sourceRef="Activity_Notify" targetRef="Event_FTermEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_05y14rb" sourceRef="Gateway_MainSync" targetRef="Event_TheEnd" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0g7i78z" sourceRef="Activity_SubProcF" targetRef="Gateway_MainSync" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ml8gyp" sourceRef="Gateway_RSTClose" targetRef="Gateway_MainSync" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12bf5hj" sourceRef="Activity_ManualTask" targetRef="Gateway_Excl_Choose1" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_A" name="route A" sourceRef="Gateway_Excl_Choose1" targetRef="Activity_OptionA" apex:sequence="30" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_B" name="route B&#10;(default path)" sourceRef="Gateway_Excl_Choose1" targetRef="Activity_OptionB" apex:sequence="40" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_C" name="route C&#10;(bad path)" sourceRef="Gateway_Excl_Choose1" targetRef="Event_CTermEnd" apex:sequence="50" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dyxw9o" sourceRef="Activity_OptionB" targetRef="Gateway_ABMerge" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_S" name=":F4A$RST_Path like &#39;%S%&#39;" sourceRef="Gateway_RST_Inc_Split" targetRef="Activity_S" apex:sequence="20">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$RST_Path like ''%S%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_02uxial" sourceRef="Activity_S" targetRef="Gateway_RSTClose" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_135n6n7" sourceRef="Activity_R" targetRef="Gateway_RSTClose" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1mpw2yu" sourceRef="Activity_T" targetRef="Gateway_RSTClose" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_R" name=":F4A$RST_Path like &#39;%R%&#39;" sourceRef="Gateway_RST_Inc_Split" targetRef="Activity_R" apex:sequence="10">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression" sequence="1">:F4A$RST_Path like ''%R%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_T" name=":F4A$RST_Path like &#39;%T%&#39;" sourceRef="Gateway_RST_Inc_Split" targetRef="Activity_T" apex:sequence="30">]''',
'      ,q''[      <bpmn:conditionExpression xsi:type="bpmn:tFormalExpression" language="plsqlExpression">:F4A$RST_Path like ''%T%''</bpmn:conditionExpression>]''',
'      ,q''[    </bpmn:sequenceFlow>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1a3mwvi" sourceRef="Activity_1i0012l" targetRef="Activity_ManualTask" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0m74axl" sourceRef="Activity_19316nz" targetRef="Activity_scriptTask" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0395vvt" sourceRef="Activity_scriptTask" targetRef="Activity_1i0012l" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_03kgsyn" sourceRef="Activity_OptionA" targetRef="Gateway_ABMerge" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0f0z11o" sourceRef="Gateway_ABMerge" targetRef="Gateway_RST_Inc_Split" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1atdbof" sourceRef="Gateway_MainSplit" targetRef="Activity_0eex1qm" apex:sequence="40" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_12ao8zk" sourceRef="Event_0ayu08h" targetRef="Gateway_MainSync" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0tzaa8e" sourceRef="Activity_0eex1qm" targetRef="Gateway_MainSync" apex:sequence="10" />]''',
'      ,q''[    <bpmn:endEvent id="Event_uT_remind_end" name="End">]''',
'      ,q''[      <bpmn:incoming>Flow_139aflr</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:task id="Activity_CloseInput" name="Close Input Period and Proceed">]''',
'      ,q''[      <bpmn:incoming>Flow_1qh3zb4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1320p09</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_FRemindEnd" name="F Reminder End">]''',
'      ,q''[      <bpmn:incoming>Flow_1hkw8tj</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:eventBasedGateway id="Gateway_EBG" name="Event Based Gateway&#10;- picks first event to occur only">]''',
'      ,q''[      <bpmn:incoming>Flow_1sl1mr5</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1hbzc2c</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ab2ygs</bpmn:outgoing>]''',
'      ,q''[    </bpmn:eventBasedGateway>]''',
unistr('      ,q''[    <bpmn:intermediateCatchEvent id="Event_TimerH" name="Timer H&#10;\00A0(Oracle Format)">]'''),
'      ,q''[      <bpmn:documentation>2 Minutes Delay</bpmn:documentation>]''',
'      ,q''[      <bpmn:incoming>Flow_0ab2ygs</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0bevchi</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_12qqs40" apex:timerType="oracleDuration">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:oracleDuration>]''',
'      ,q''[            <apex:intervalYM>00-00</apex:intervalYM>]''',
'      ,q''[            <apex:intervalDS>000 00:02:00</apex:intervalDS>]''',
'      ,q''[          </apex:oracleDuration>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:task id="Activity_G" name="Process Message Payload">]''',
'      ,q''[      <bpmn:incoming>Flow_04ew1x4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0e3ltbj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_GHMerge" name="GH Merge">]''',
'      ,q''[      <bpmn:incoming>Flow_0e3ltbj</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0mw3yoc</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1lkzgyz</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_H" name="H">]''',
'      ,q''[      <bpmn:incoming>Flow_0bevchi</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0mw3yoc</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:serviceTask id="Activity_Reminder" name="Send&#10;reminder&#10;Email" apex:type="sendMail">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:sendMail>]''',
'      ,q''[          <apex:useTemplate>false</apex:useTemplate>]''',
'      ,q''[          <apex:immediately>true</apex:immediately>]''',
'      ,q''[        </apex:sendMail>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1bssnss</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_139aflr</bpmn:outgoing>]''',
'      ,q''[    </bpmn:serviceTask>]''',
'      ,q''[    <bpmn:intermediateCatchEvent id="Event_MessageCatch_G" name="Message Catch Event" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1hbzc2c</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_04ew1x4</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0fkvhn8">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>SendPO</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>PONumber</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>processVariable</apex:expressionType>]''',
'      ,q''[            <apex:expression>BUSINESS_REF</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payloadVariable>Incoming_PO_Details</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateCatchEvent>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_FRemind" name="Post Reminders (PL/SQL Script)" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_10ebnqk</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1hkw8tj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:endEvent id="Event_TheEnd" name="Process End">]''',
'      ,q''[      <bpmn:incoming>Flow_05y14rb</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_MainSync" name="Merging Parallel Gateway&#10;- Merges and&#10;Syncronises paths">]''',
'      ,q''[      <bpmn:incoming>Flow_0g7i78z</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1ml8gyp</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1lkzgyz</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1320p09</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_12ao8zk</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0tzaa8e<'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_05y14rb</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_Excl_Choose1" name="Exclusive Gateway - Choose 1 Path" default="Flow_B">]''',
'      ,q''[      <bpmn:incoming>Flow_12bf5hj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_B</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_A</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_C</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_OptionB" name="Option B&#10;(default)">]''',
'      ,q''[      <bpmn:incoming>Flow_B</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dyxw9o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_CTermEnd" name="Terminate End&#10;Terminates the entire process">]''',
'      ,q''[      <bpmn:incoming>Flow_C</bpmn:incoming>]''',
'      ,q''[      <bpmn:terminateEventDefinition id="TerminateEventDefinition_1ixj664" />]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:task id="Activity_S" name="S">]''',
'      ,q''[      <bpmn:incoming>Flow_S</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_02uxial</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_RSTClose" name="Closing Inclusive Gateway&#10;- Merges and&#10;Synchronises paths">]''',
'      ,q''[      <bpmn:incoming>Flow_02uxial</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_135n6n7</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1mpw2yu</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1ml8gyp</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_R" name="R">]''',
'      ,q''[      <bpmn:incoming>Flow_R</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_135n6n7</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:task id="Activity_T" name="T">]''',
'      ,q''[      <bpmn:incoming>Flow_T</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1mpw2yu</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:manualTask id="Activity_ManualTask" name="Manual Task&#10;(placeholder for non computer task)">]''',
'      ,q''[      <bpmn:incoming>Flow_1a3mwvi</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_12bf5hj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:manualTask>]''',
'      ,q''[    <bpmn:scriptTask id="Activity_scriptTask" name="scriptTask&#10;(run a PL/SQL script)" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0m74axl</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0395vvt</bpmn:outgoing>]''',
'      ,q''[    </bpmn:scriptTask>]''',
'      ,q''[    <bpmn:businessRuleTask id="Activity_1i0012l" name="businessRules&#10;Task&#10;(run scoring model)" apex:type="executePlsql">]''',
'      ,q''[      <bpmn:documentation>This can be used to run a credit scoring routine or a ML model -- anything accessible via PL/SQL).]''',
'      ,q''[]''',
'      ,q''[</bpmn:documentation>]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:executePlsql>]''',
'      ,q''[          <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[        </apex:executePlsql>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0395vvt</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1a3mwvi</bpmn:outgoing>]''',
'      ,q''[    </bpmn:businessRuleTask>]''',
'      ,q''[    <bpmn:userTask id="Activity_19316nz" name="userTask&#10;(call APEX Approval Task)" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_0227ot0</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0m74axl</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:task id="Activity_OptionA" name="Option A">]''',
'      ,q''[      <bpmn:incoming>Flow_A</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_03kgsyn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:inclusiveGateway id="Gateway_RST_Inc_Split" name="Inclusive Gateway&#10;- Pick 1 or more Options" default="Flow_T">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:beforeSplit>]''',
'      ,q''[          <apex:processVariable>]''',
'      ,q''[            <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[            <apex:varName>RST_Path</apex:varName>]''',
'      ,q''[            <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[            <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[            <apex:varExpression>RT</apex:varExpression>]''',
'      ,q''[          </apex:processVariable>]''',
'      ,q''[        </apex:beforeSplit>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_0f0z11o</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_S</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_R</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_T</bpmn:outgoing>]''',
'      ,q''[    </bpmn:inclusiveGateway>]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_ABMerge" name="Merge">]''',
'      ,q''[      <bpmn:incoming>Flow_1dyxw9o</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_03kgsyn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0f0z11o</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:task id="Activity_Notify" name="Notify Manager of Termination">]''',
'      ,q''[      <bpmn:incoming>Flow_0f14hah</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1d0hvhw</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:endEvent id="Event_FTermEnd" name="F Term End">]''',
'      ,q''[      <bpmn:incoming>Flow_1d0hvhw</bpmn:incoming>]''',
'      ,q''[      <bpmn:terminateEventDefinition id="TerminateEventDefinition_1hfrp0v">]''',
'      ,q''[        <apex:processStatus>completed</apex:processStatus>]''',
'      ,q''[      </bpmn:terminateEventDefinition>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:subProcess id="Activity_SubProcF" name="Sub Process F">]''',
'      ,q''[      <bpmn:incoming>Flow_15m8qw2</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0g7i78z</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_FStart" name="F Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_06l5x9i</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_06l5x9i" sourceRef="Event_FStart" targetRef="Gateway_FSplit" />]''',
'      ,q''[      <bpmn:parallelGateway id="Gateway_FSplit" name="F Split">]''',
'      ,q''[        <bpmn:incoming>Flow_06l5x9i</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_toF2</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_toF1</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_F3</bpmn:outgoing>]''',
'      ,q''[      </bpmn:parallelGateway>]''',
'      ,q''[      <bpmn:subProcess id="Activity_subProcF1" name="Sub Process F1">]''',
'      ,q''[        <bpmn:incoming>Flow_toF1</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1eyfbtd</bpmn:outgoing>]''',
'      ,q''[        <bpmn:startEvent id="Event_F1Start" name="F1 Start">]''',
'      ,q''[          <bpmn:outgoing>Flow_0oyf6xf</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:task id="Activity_0gj73o4" name="Task F1A&#10;(with Timeout Timer)">]''',
'      ,q''[          <bpmn:incoming>Flow_0oyf6xf</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_1rsbmbe</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0oyf6xf" sourceRef="Event_F1Start" targetRef="Activity_0gj73o4" />]''',
'      ,q''[        <bpmn:exclusiveGateway id="Gateway_AllOK" name="All OK?" default="Flow_1qccguc">]''',
'      ,q''[          <bpmn:incoming>Flow_1rsbmbe</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_1qccguc</bpmn:outgoing>]''',
'      ,q''[          <bpmn:outgoing>Flow_1f2lsls</bpmn:outgoing>]''',
'      ,q''[        </bpmn:exclusiveGateway>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1rsbmbe" sourceRef="Activity_0gj73o4" targetRef="Gateway_AllOK" />]''',
'      ,q''[        <bpmn:task id="Activity_F1B" name="F1B">]''',
'      ,q''[          <bpmn:incoming>Flow_1qccguc</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_13gdlkj</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1qccguc" name="Yes" sourceRef="Gateway_AllOK" targetRef="Activity_F1B" apex:sequence="20" />]''',
'      ,q''[        <bpmn:endEvent id="Event_F1HappyEnd" name="F1 Happy End">]''',
'      ,q''[          <bpmn:incoming>Flow_13gdlkj</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_13gdlkj" sourceRef="Activity_F1B" targetRef="Event_F1HappyEnd" />]''',
'      ,q''[        <bpmn:task id="Activity_F1_Proc_error" name="Process Error Handler">]''',
'      ,q''[          <bpmn:incoming>Flow_1f2lsls</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_13w3z3z</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1f2lsls" name="No - Process Error" sourceRef="Gateway_AllOK" targetRef="Activity_F1_Proc_error" apex:sequence="30" />]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_13w3z3z" sourceRef="Activity_F1_Proc_error" targetRef="Event_F1ErrorEnd" />]''',
'      ,q''[        <bpmn:endEvent id="Event_F1ErrorEnd" name="F1 Error End">]''',
'      ,q''[          <bpmn:incoming>Flow_13w3z3z</bpmn:incoming>]''',
'      ,q''[          <bpmn:errorEventDefinition id="ErrorEventDefinition_1x4hxz5" />]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:task id="Activity_F1AHandleTimeout" name="Handle Timeout">]''',
'      ,q''[          <bpmn:incoming>Flow_03ice2s</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_10714n0</bpmn:outgoing>]''',
'      ,q''[        </bpmn:task>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_03ice2s" sourceRef="Event_1ko5r23" targetRef="Activity_F1AHandleTimeout" />]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_10714n0" sourceRef="Activity_F1AHandleTimeout" targetRef="Event_F1TermEnd" />]''',
'      ,q''[        <bpmn:endEvent id="Event_F1TermEnd" name="Terminating End&#10;Immediately ends Sub Process">]''',
'      ,q''[          <bpmn:incoming>Flow_10714n0</bpmn:incoming>]''',
'      ,q''[          <bpmn:terminateEventDefinition id="TerminateEventDefinition_0hlwdiw" />]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:boundaryEvent id="Event_1ko5r23" name="Interrupting Timer Boundary Event" attachedToRef="Activity_0gj73o4">]''',
'      ,q''[          <bpmn:outgoing>Flow_03ice2s</bpmn:outgoing>]''',
'      ,q''[          <bpmn:timerEventDefinition id="TimerEventDefinition_0h3jerj">]''',
'      ,q''[            <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT120M</bpmn:timeDuration>]''',
'      ,q''[          </bpmn:timerEventDefinition>]''',
'      ,q''[        </bpmn:boundaryEvent>]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[      <bpmn:subProcess id="Activity_subProcF2" name="Sub Process F2">]''',
'      ,q''[        <bpmn:incoming>Flow_toF2</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1kgfn9a</bpmn:outgoing>]''',
'      ,q''[        <bpmn:startEvent id="Event_F2Start" name="F2 Start">]''',
'      ,q''[          <bpmn:outgoing>Flow_0nyapnc</bpmn:outgoing>]''',
'      ,q''[        </bpmn:startEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0nyapnc" sourceRef="Event_F2Start" targetRef="Activity_subProcF2A" />]''',
'      ,q''[        <bpmn:exclusiveGateway id="Gateway_F2Open" name="Everything OK?" default="Flow_0hzmts8">]''',
'      ,q''[          <bpmn:incoming>Flow_0bler3b</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0hzmts8</bpmn:outgoing>]''',
'      ,q''[          <bpmn:outgoing>Flow_1dar5q9</bpmn:outgoing>]''',
'      ,q''[        </bpmn:exclusiveGateway>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0bler3b" sourceRef="Activity_subProcF2A" targetRef="Gateway_F2Open" />]''',
'      ,q''[        <bpmn:exclusiveGateway id="Gateway_F2Close">]''',
'      ,q''[          <bpmn:incoming>Flow_0hzmts8</bpmn:incoming>]''',
'      ,q''[          <bpmn:incoming>Flow_0hra594</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_1t5akvc</bpmn:outgoing>]''',
'      ,q''[        </bpmn:exclusiveGateway>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0hzmts8" name="Y" sourceRef="Gateway_F2Open" targetRef="Gateway_F2Close" apex:sequence="20" />]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1dar5q9" name="N" sourceRef="Gateway_F2Open" targetRef="Event_F2EscITE" apex:sequence="30" />]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_0hra594" sourceRef="Event_F2EscITE" targetRef="Gateway_F2Close" />]''',
'      ,q''[        <bpmn:intermediateThrowEvent id="Event_F2EscITE" name="Escalation Intermediate Throw Event">]''',
'      ,q''[          <bpmn:incoming>Flow_1dar5q9</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0hra594</bpmn:outgoing>]''',
'      ,q''[          <bpmn:escalationEventDefinition id="EscalationEventDefinition_0ue9ndq" />]''',
'      ,q''[        </bpmn:intermediateThrowEvent>]''',
'      ,q''[        <bpmn:sequenceFlow id="Flow_1t5akvc" sourceRef="Gateway_F2Close" targetRef="Event_F2End" apex:sequence="10" />]''',
'      ,q''[        <bpmn:endEvent id="Event_F2End" name="F2 End">]''',
'      ,q''[          <bpmn:incoming>Flow_1t5akvc</bpmn:incoming>]''',
'      ,q''[        </bpmn:endEvent>]''',
'      ,q''[        <bpmn:subProcess id="Activity_subProcF2A" name="F2A Collapsed SubProcess&#10;(Click to Open)">]''',
'      ,q''[          <bpmn:incoming>Flow_0nyapnc</bpmn:incoming>]''',
'      ,q''[          <bpmn:outgoing>Flow_0bler3b</bpmn:outgoing>]''',
'      ,q''[          <bpmn:startEvent id="Event_F2AStart" name="F2A Start">]''',
'      ,q''[            <bpmn:outgoing>Flow_0x0i35d</bpmn:outgoing>]''',
'      ,q''[          </bpmn:startEvent>]''',
'      ,q''[          <bpmn:task id="Activity_F2ATask" name="F2ATask">]''',
'      ,q''[            <bpmn:incoming>Flow_0x0i35d</bpmn:incoming>]''',
'      ,q''[            <bpmn:outgoing>Flow_1oedyea</bpmn:outgoing>]''',
'      ,q''[          </bpmn:task>]''',
'      ,q''[          <bpmn:sequenceFlow id="Flow_0x0i35d" sourceRef="Event_F2AStart" targetRef="Activity_F2ATask" />]''',
'      ,q''[          <bpmn:endEvent id="Event_EndF2A" name="EndF2A">]''',
'      ,q''[            <bpmn:incoming>Flow_1f2gbzn</bpmn:incoming>]''',
'      ,q''[          </bpmn:endEvent>]''',
'      ,q''[          <bpmn:sequenceFlow id="Flow_1oedyea" sourceRef="Activity_F2ATask" targetRef="Activity_F2BTask" />]''',
'      ,q''[          <bpmn:task id="Activity_F2BTask" name="F2B Task">]''',
'      ,q''[            <bpmn:incoming>Flow_1oedyea</bpmn:incoming>]''',
'      ,q''[            <bpmn:outgoing>Flow_1f2gbzn</bpmn:outgoing>]''',
'      ,q''[          </bpmn:task>]''',
'      ,q''[          <bpmn:sequenceFlow id="Flow_1f2gbzn" sourceRef="Activity_F2BTask" targetRef="Event_EndF2A" />]''',
'      ,q''[        </bpmn:subProcess>]''',
'      ,q''[      </bpmn:subProcess>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_toF2" name="to F2" sourceRef="Gateway_FSplit" targetRef="Activity_subProcF2" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_toF1" name="to Fl" sourceRef="Gateway_FSplit" targetRef="Activity_subProcF1" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_05k289e" sourceRef="Event_F1ErrorBoundary" targetRef="Event_F1_LinkA" />]''',
'      ,q''[      <bpmn:endEvent id="Event_FEndA" name="F End A">]''',
'      ,q''[        <bpmn:incoming>Flow_1eyfbtd</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1eyfbtd" sourceRef="Activity_subProcF1" targetRef="Event_FEndA" />]''',
'      ,q''[      <bpmn:endEvent id="Event_F_End_B" name="F End B">]''',
'      ,q''[        <bpmn:incoming>Flow_1kgfn9a</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1kgfn9a" sourceRef="Activity_subProcF2" targetRef="Event_F_End_B" />]''',
'      ,q''[      <bpmn:boundaryEvent id="Event_F2Esc" name="Non-Interrupting Escalation Catch&#10;Boundary Event" cancelActivity="false" attachedToRef="Activity_subProcF2">]''',
'      ,q''[        <bpmn:outgoing>Flow_031cc6f</bpmn:outgoing>]''',
'      ,q''[        <bpmn:escalationEventDefinition id="EscalationEventDefinition_1afovgx" />]''',
'      ,q''[      </bpmn:boundaryEvent>]''',
'      ,q''[      <bpmn:boundaryEvent id="Event_F1ErrorBoundary" name="Error Boundary Event" attachedToRef="Activity_subProcF1">]''',
'      ,q''[        <bpmn:outgoing>Flow_05k289e</bpmn:outgoing>]''',
'      ,q''[        <bpmn:errorEventDefinition id="ErrorEventDefinition_11g00uv" />]''',
'      ,q''[      </bpmn:boundaryEvent>]''',
'      ,q''[      <bpmn:intermediateThrowEvent id="Event_F2EscLinkA" name="LinkA">]''',
'      ,q''[        <bpmn:incoming>Flow_0wjommq</bpmn:incoming>]''',
'      ,q''[        <bpmn:linkEventDefinition id="LinkEventDefinition_0imlax6" name="" />]''',
'      ,q''[      </bpmn:intermediateThrowEvent>]''',
'      ,q''[      <bpmn:intermediateCatchEvent id="Event_LinkA_ICE" name="LinkA">]''',
'      ,q''[        <bpmn:outgoing>Flow_0a3amjb</bpmn:outgoing>]''',
'      ,q''[        <bpmn:linkEventDefinition id="LinkEventDefinition_1klargh" name="" />]''',
'      ,q''[      </bpmn:intermediateCatchEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0a3amjb" sourceRef="Event_LinkA_ICE" targetRef="Event_TimerAfterLink" />]''',
'      ,q''[      <bpmn:exclusiveGateway id="Gateway_AllOKNow" name="All OK Now?" default="Flow_1jynl0c">]''',
'      ,q''[        <bpmn:incoming>Flow_0uoidfy</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1jynl0c</bpmn:outgoing>]''',
'      ,q''[        <bpmn:outgoing>Flow_0zm2lio</bpmn:outgoing>]''',
'      ,q''[      </bpmn:exclusiveGateway>]''',
'      ,q''[      <bpmn:endEvent id="Event_FEndC" name="F End C">]''',
'      ,q''[        <bpmn:incoming>Flow_1jynl0c</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1jynl0c" name="Y" sourceRef="Gateway_AllOKNow" targetRef="Event_FEndC" apex:sequence="20" />]''',
'      ,q''[      <bpmn:intermediateThrowEvent id="Event_F1_LinkA" name="LinkA">]''',
'      ,q''[        <bpmn:incoming>Flow_05k289e</bpmn:incoming>]''',
'      ,q''[        <bpmn:linkEventDefinition id="LinkEventDefinition_098srpp" name="" />]''',
'      ,q''[      </bpmn:intermediateThrowEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0zm2lio" name="N" sourceRef="Gateway_AllOKNow" targetRef="Activity_PrepForTerm" apex:sequence="30" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0203h3w" sourceRef="Activity_PrepForTerm" targetRef="Event_FEscEnd" />]''',
'      ,q''[      <bpmn:endEvent id="Event_FEscEnd" name="Escalating End">]''',
'      ,q''[        <bpmn:incoming>Flow_0203h3w</bpmn:incoming>]''',
'      ,q''[        <bpmn:escalationEventDefinition id="EscalationEventDefinition_1niprfw" />]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0uoidfy" sourceRef="Event_TimerAfterLink" targetRef="Gateway_AllOKNow" />]''',
'      ,q''[      <bpmn:intermediateCatchEvent id="Event_TimerAfterLink" name="Timer Catch Event&#10;(2 Day Delay)">]''',
'      ,q''[        <bpmn:incoming>Flow_0a3amjb</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0uoidfy</bpmn:outgoing>]''',
'      ,q''[        <bpmn:timerEventDefinition id="TimerEventDefinition_1ywd80b">]''',
'      ,q''[          <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT2M</bpmn:timeDuration>]''',
'      ,q''[        </bpmn:timerEventDefinition>]''',
'      ,q''[      </bpmn:intermediateCatchEvent>]''',
'      ,q''[      <bpmn:task id="Activity_PrepForTerm" name="Prepare for SubProcess&#10;Termination">]''',
'      ,q''[        <bpmn:incoming>Flow_0zm2lio</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0203h3w</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_F3" name="To F3" sourceRef="Gateway_FSplit" targetRef="Activity_F3" />]''',
'      ,q''[      <bpmn:callActivity id="Activity_F3" name="F3 Call Another Diagram" apex:manualInput="false" apex:calledDiagram="Tutorial 5e - ship Goods (Called by Tutorial 5d)" apex:calledDiagramVersionSelection="latestVersion">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:inVariables>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[              <apex:varName>OrderRef</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression>1234</apex:varExpression>]''',
'      ,q''[              <apex:varDescription>Order requiring Shipping</apex:varDescription>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[              <apex:varName>ShippingPriority</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression>URGENT</apex:varExpression>]''',
'      ,q''[              <apex:varDescription>URGENT or ROUTINE</apex:varDescription>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[          </apex:inVariables>]''',
'      ,q''[          <apex:outVariables>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[              <apex:varName>ShipperName</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression></apex:varExpression>]''',
'      ,q''[              <apex:varDescription>Shipper Used</apex:varDescription>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[              <apex:varName>ShippedDate</apex:varName>]''',
'      ,q''[              <apex:varDataType>DATE</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression></apex:varExpression>]''',
'      ,q''[              <apex:varDescription>Date Order Shipped</apex:varDescription>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>2</apex:varSequence>]''',
'      ,q''[              <apex:varName>TrackingID:</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>static</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression></apex:varExpression>]''',
'      ,q''[              <apex:varDescription>Tracking Reference for Shipment</apex:varDescription>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[          </apex:outVariables>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:incoming>Flow_F3</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0qcvrkv</bpmn:outgoing>]''',
'      ,q''[      </bpmn:callActivity>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0qcvrkv" sourceRef="Activity_F3" targetRef="Event_0wf0v6l" />]''',
'      ,q''[      <bpmn:intermediateThrowEvent id="Event_0wf0v6l" name="LinkB">]''',
'      ,q''[        <bpmn:incoming>Flow_0qcvrkv</bpmn:incoming>]''',
'      ,q''[        <bpmn:linkEventDefinition id="LinkEventDefinition_11dqyd7" name="LinkB" />]''',
'      ,q''[      </bpmn:intermediateThrowEvent>]''',
'      ,q''[      <bpmn:intermediateCatchEvent id="Event_11kl7us" name="LinkB">]''',
'      ,q''[        <bpmn:outgoing>Flow_1f1h0pi</bpmn:outgoing>]''',
'      ,q''[        <bpmn:linkEventDefinition id="LinkEventDefinition_10krl16" name="LinkB" />]''',
'      ,q''[      </bpmn:intermediateCatchEvent>]''',
'      ,q''[      <bpmn:endEvent id="Event_1u4qtdo" name="F End D">]''',
'      ,q''[        <bpmn:incoming>Flow_1f1h0pi</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1f1h0pi" sourceRef="Event_11kl7us" targetRef="Event_1u4qtdo" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0wjommq" sourceRef="Activity_EmailManagerHelp" targetRef="Event_F2EscLinkA" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_031cc6f" sourceRef="Event_F2Esc" targetRef="Activity_EmailManagerHelp" />]''',
'      ,q''[      <bpmn:serviceTask id="Activity_EmailManagerHelp" name="Email Manager to Help" apex:type="executePlsql">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:executePlsql>]''',
'      ,q''[            <apex:plsqlCode>null;</apex:plsqlCode>]''',
'      ,q''[          </apex:executePlsql>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:incoming>Flow_031cc6f</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0wjommq</bpmn:outgoing>]''',
'      ,q''[      </bpmn:serviceTask>]''',
'      ,q''[      <bpmn:association id="Association_1x9wuxi" sourceRef="Event_FEndA" targetRef="TextAnnotation_1nzqkt7" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_FEscBE" name="Interrupting Escalation Handler&#10;(Terminates F)" attachedToRef="Activity_SubProcF">]''',
'      ,q''[      <bpmn:outgoing>Flow_0f14hah</bpmn:outgoing>]''',
'      ,q''[      <bpmn:escalationEventDefinition id="EscalationEventDefinition_1i2ea4w" />]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_FNI_Timer_BE" name="Non Interrupting Timer on F" cancelActivity="false" attachedToRef="Activity_SubProcF">]''',
'      ,q''[      <bpmn:outgoing>Flow_10ebnqk</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_17ny1xz">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT120M</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_FTimeoutBE" name="Interrupting Timer on F" attachedToRef="Activity_SubProcF">]''',
'      ,q''[      <bpmn:outgoing>Flow_1qh3zb4</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0b8p9qg">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT130M</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:parallelGateway id="Gateway_MainSplit" name="Parallel Gateway&#10;- splits process">]''',
'      ,q''[      <bpmn:incoming>Flow_0k089wp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1q7lyne</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_15m8qw2</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1sl1mr5</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1atdbof</bpmn:outgoing>]''',
'      ,q''[    </bpmn:parallelGateway>]''',
'      ,q''[    <bpmn:userTask id="Activity_userTask" name="userTask&#10;(call APEX page or URL)" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexPage />]''',
'      ,q''[        <apex:priority>]''',
'      ,q''[          <apex:expressionType>processVariable</apex:expressionType>]''',
'      ,q''[          <apex:expression>PROCESS_PRIORITY</apex:expression>]''',
'      ,q''[        </apex:priority>]''',
'      ,q''[        <apex:dueOn>]''',
'      ,q''[          <apex:expressionType>interval</apex:expressionType>]''',
'      ,q''[          <apex:expression>PT1H</apex:expression>]''',
'      ,q''[        </apex:dueOn>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1q7lyne</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0av2w95</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_ReminderBE" name="Reminder Timer (Repeats every 2min)" cancelActivity="false" attachedToRef="Activity_userTask">]''',
'      ,q''[      <bpmn:documentation>Sends a reminder email every 2 minutes.   Stops after 5 cycles.</bpmn:documentation>]''',
'      ,q''[      <bpmn:outgoing>Flow_1bssnss</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_12bhsbj">]''',
'      ,q''[        <bpmn:timeCycle xsi:type="bpmn:tFormalExpression">R5/PT2M</bpmn:timeCycle>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0227ot0" sourceRef="Activity_1noqbij" targetRef="Activity_19316nz" />]''',
'      ,q''[    <bpmn:userTask id="Activity_1noqbij" name="userTask (call APEX Simple Form)" apex:type="apexPage" apex:manualInput="false">]''',
'      ,q''[      <bpmn:incoming>Flow_0av2w95</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0227ot0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:subProcess id="Activity_0eex1qm" name="MessageFlow Objects - These objects are in Community Edition but do not run in this model">]''',
'      ,q''[      <bpmn:incoming>Flow_1atdbof</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0tzaa8e</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_0csn51r" name="U Start">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:onEvent>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[              <apex:varName>ModelRunKey</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>plsqlRawExpression</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression>dbms_random.string(''x'',10)</apex:varExpression>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[          </apex:onEvent>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:outgoing>Flow_1gd74ja</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1gd74ja" sourceRef="E'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'vent_0csn51r" targetRef="Activity_06248kr" />]''',
'      ,q''[      <bpmn:sendTask id="Activity_1k0u0f3" name="sendTask&#10;(plsql or simple Message)" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>startFullMontyEE</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:payload>]''',
'      ,q''[            <apex:expressionType>plsqlRawExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>flow_process_vars.get_var_vc2 ( pi_prcs_id =&gt; flow_globals.process_id]''',
'      ,q''[                             , pi_var_name=&gt; ''ModelRunKey'']''',
'      ,q''[                              )</apex:expression>]''',
'      ,q''[          </apex:payload>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:incoming>Flow_0hchqi3</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_07kv3w8</bpmn:outgoing>]''',
'      ,q''[      </bpmn:sendTask>]''',
'      ,q''[      <bpmn:receiveTask id="Activity_1r9v7rj" name="receiveTask (simple Message)" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>FullMontyEERunning</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>RunKey</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>processVariable</apex:expressionType>]''',
'      ,q''[            <apex:expression>ModelRunKey</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[          <apex:payloadVariable>Incoming_SO</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:incoming>Flow_07kv3w8</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0wjn6p3</bpmn:outgoing>]''',
'      ,q''[      </bpmn:receiveTask>]''',
'      ,q''[      <bpmn:intermediateCatchEvent id="Event_0wngn5b" name="Message Catch (simple message)" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:incoming>Flow_16qf0a4</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0ufboyw</bpmn:outgoing>]''',
'      ,q''[        <bpmn:messageEventDefinition id="MessageEventDefinition_1jf3smj">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:messageName>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>SUBPROC_ENDED</apex:expression>]''',
'      ,q''[            </apex:messageName>]''',
'      ,q''[            <apex:correlationKey>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>SOnumber</apex:expression>]''',
'      ,q''[            </apex:correlationKey>]''',
'      ,q''[            <apex:correlationValue>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>120</apex:expression>]''',
'      ,q''[            </apex:correlationValue>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:messageEventDefinition>]''',
'      ,q''[      </bpmn:intermediateCatchEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0ufboyw" sourceRef="Event_0wngn5b" targetRef="Activity_0icmf8o" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1a709ef" name="U End">]''',
'      ,q''[        <bpmn:incoming>Flow_0jmj15r</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0s5ddhp" sourceRef="Event_1ao382y" targetRef="Event_13x93sm" />]''',
'      ,q''[      <bpmn:intermediateThrowEvent id="Event_1ao382y" name="Message Throw (simple message)" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:incoming>Flow_1pu37ym</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0s5ddhp</bpmn:outgoing>]''',
'      ,q''[        <bpmn:messageEventDefinition id="MessageEventDefinition_0qi7c1j">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:endpoint>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>local</apex:expression>]''',
'      ,q''[            </apex:endpoint>]''',
'      ,q''[            <apex:messageName>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>AnotherThrow</apex:expression>]''',
'      ,q''[            </apex:messageName>]''',
'      ,q''[            <apex:correlationKey>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>EmpID</apex:expression>]''',
'      ,q''[            </apex:correlationKey>]''',
'      ,q''[            <apex:correlationValue>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>160</apex:expression>]''',
'      ,q''[            </apex:correlationValue>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:messageEventDefinition>]''',
'      ,q''[      </bpmn:intermediateThrowEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0wjn6p3" sourceRef="Activity_1r9v7rj" targetRef="Activity_1i49a3k" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_07kv3w8" sourceRef="Activity_1k0u0f3" targetRef="Activity_1r9v7rj" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_16qf0a4" sourceRef="Event_0w25ri0" targetRef="Event_0wngn5b" />]''',
'      ,q''[      <bpmn:intermediateThrowEvent id="Event_0w25ri0" name="Message Throw (simple message)" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:incoming>Flow_1fm2bkv</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_16qf0a4</bpmn:outgoing>]''',
'      ,q''[        <bpmn:messageEventDefinition id="MessageEventDefinition_0d3cmm0">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:messageName>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>InterruptEE</apex:expression>]''',
'      ,q''[            </apex:messageName>]''',
'      ,q''[            <apex:correlationKey>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>POnumber</apex:expression>]''',
'      ,q''[            </apex:correlationKey>]''',
'      ,q''[            <apex:correlationValue>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>100</apex:expression>]''',
'      ,q''[            </apex:correlationValue>]''',
'      ,q''[            <apex:endpoint>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>local</apex:expression>]''',
'      ,q''[            </apex:endpoint>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:messageEventDefinition>]''',
'      ,q''[      </bpmn:intermediateThrowEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0jmj15r" sourceRef="Event_13x93sm" targetRef="Event_1a709ef" />]''',
'      ,q''[      <bpmn:intermediateCatchEvent id="Event_13x93sm" name="Message Catch (simple message)" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:incoming>Flow_0s5ddhp</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0jmj15r</bpmn:outgoing>]''',
'      ,q''[        <bpmn:messageEventDefinition id="MessageEventDefinition_0hpfrny">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:messageName>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>OtherFinished</apex:expression>]''',
'      ,q''[            </apex:messageName>]''',
'      ,q''[            <apex:correlationKey>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>Dept</apex:expression>]''',
'      ,q''[            </apex:correlationKey>]''',
'      ,q''[            <apex:correlationValue>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>20</apex:expression>]''',
'      ,q''[            </apex:correlationValue>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:messageEventDefinition>]''',
'      ,q''[      </bpmn:intermediateCatchEvent>]''',
'      ,q''[      <bpmn:task id="Activity_06248kr" name="Ready To Message?">]''',
'      ,q''[        <bpmn:incoming>Flow_1gd74ja</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0hchqi3</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0hchqi3" sourceRef="Activity_06248kr" targetRef="Activity_1k0u0f3" />]''',
unistr('      ,q''[      <bpmn:task id="Activity_1i49a3k" name="Check Messages. \00A0Reply?">]'''),
'      ,q''[        <bpmn:incoming>Flow_0wjn6p3</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1fm2bkv</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1fm2bkv" sourceRef="Activity_1i49a3k" targetRef="Event_0w25ri0" />]''',
'      ,q''[      <bpmn:task id="Activity_0icmf8o" name="Now send a message to fire Boundary Event">]''',
'      ,q''[        <bpmn:incoming>Flow_0ufboyw</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1pu37ym</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1pu37ym" sourceRef="Activity_0icmf8o" targetRef="Event_1ao382y" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_0ayu08h" name="Timeout 10 minc (in case subprocess not executable in this demo)" attachedToRef="Activity_0eex1qm">]''',
'      ,q''[      <bpmn:outgoing>Flow_12ao8zk</bpmn:outgoing>]''',
'      ,q''[      <bpmn:timerEventDefinition id="TimerEventDefinition_0hekjsp">]''',
'      ,q''[        <bpmn:timeDuration xsi:type="bpmn:tFormalExpression">PT10M</bpmn:timeDuration>]''',
'      ,q''[      </bpmn:timerEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0xch24e">]''',
'      ,q''[      <bpmn:text>This model does nearly]''',
'      ,q''[everything that we can process]''',
'      ,q''[in v23.1.]''',
'      ,q''[]''',
'      ,q''[Work your way through this.]''',
'      ,q''[]''',
'      ,q''[Try changing the way the gateways direct the process to cover all of the ways through the model, until you understand how this model gets processed!</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0tjhct6" sourceRef="StartEvent_1" targetRef="TextAnnotation_0xch24e" />]''',
'      ,q''[    <bpmn:association id="Association_095hgt1" sourceRef="Gateway_Excl_Choose1" targetRef="TextAnnotation_1n3sri5" />]''',
'      ,q''[    <bpmn:association id="Association_09n6lvz" sourceRef="Gateway_RST_Inc_Split" targetRef="TextAnnotation_1az2cby" />]''',
'      ,q''[    <bpmn:association id="Association_14q8sx5" sourceRef="Activity_userTask" targetRef="TextAnnotation_0ig39o8" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmn:process id="Process_0pkcg19">]''',
'      ,q''[    <bpmn:startEvent id="Event_1vrocwd" name="MessageStart* - This process started by incoming message" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:outgoing>Flow_13wkq2x</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_14nv64b">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>startFullMontyEE</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:payloadVariable>RunKey</apex:payloadVariable>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:endEvent id="Event_02j6heh" name="Message EndEvent*&#10;- sends message when done" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1w3d0be</bpmn:incoming>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1pvaz44">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>OtherFinished</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>Dept</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>20</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:endEvent id="Event_0d9pz7p" name="MsgRecdEnd">]''',
'      ,q''[      <bpmn:incoming>Flow_1cqf80d</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1cctr9o" name="Follows Non Interrupting Msg Boundary Event*">]''',
'      ,q''[      <bpmn:incoming>Flow_1vhzcec</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1cqf80d</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:subProcess id="Activity_Par_Iter_SubProc" name="Parallel Iterating SubProcess*">]''',
'      ,q''[      <bpmn:incoming>Flow_0f2j2zf</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_11ntl9r</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Parallel SubProc Iteration &amp;LOOP_COUNTER. &amp;ENAME.</apex:description>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>sqlQueryArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>select ename, loc]''',
'      ,q''[from emp]''',
'      ,q''[join dept]''',
'      ,q''[  on emp.deptno = dept.deptno]''',
'      ,q''[where emp.deptno = 20;</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>Par_SubProc_Iteration_array</apex:expression>]''',
'      ,q''[            <apex:insideVariable>ename,loc</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_0lsyvlo" name="ParSubProc Start">]''',
'      ,q''[        <bpmn:outgoing>Flow_1yl313z</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_1bpy6hr" name="This SubProc repeats once for each iteration in parallel">]''',
'      ,q''[        <bpmn:incoming>Flow_1yl313z</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_16k0o3u</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1yl313z" sourceRef="Event_0lsyvlo" targetRef="Activity_1bpy6hr" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1s5ht1k" name="Par SubProc End">]''',
'      ,q''[        <bpmn:incoming>Flow_16k0o3u</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_16k0o3u" sourceRef="Activity_1bpy6hr" targetRef="Event_1s5ht1k" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_Seq_Iter_Sub_Proc" name="Sequentially Iterating SubProcess*">]''',
'      ,q''[      <bpmn:incoming>Flow_11ntl9r</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0iuudif</bpmn:outgoing>]''',
'      ,q''[      <bpmn:multiInstanceLoopCharacteristics isSequential="true">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Sequential Iteration &amp;LOOP_COUNTER. </apex:description>]''',
'      ,q''[          <apex:inputCollection>]''',
'      ,q''[            <apex:expressionType>sqlQueryArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>select deptno, dname]''',
'      ,q''[from dept ]''',
'      ,q''[order by deptno</apex:expression>]''',
'      ,q''[          </apex:inputCollection>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>Seq_SubProc_Iter_Array</apex:expression>]''',
'      ,q''[            <apex:insideVariable>DEPTNO</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_1tnbl7q" name="SeqSPStart">]''',
'      ,q''[        <bpmn:outgoing>Flow_1fzr640</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_16p5k1p" name="Seq SubProc Task">]''',
'      ,q''[        <bpmn:incoming>Flow_1fzr640</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0frevmc</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1fzr640" sourceRef="Event_1tnbl7q" targetRef="Activity_16p5k1p" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1jrxbq5" name="SeqSPEnd">]''',
'      ,q''[        <bpmn:incoming>Flow_0frevmc</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0frevmc" sourceRef="Activity_16p5k1p" targetRef="Event_1jrxbq5" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_Loop_sub_proc" name="Looping SubProcess*">]''',
'      ,q''[      <bpmn:incoming>Flow_0iuudif</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1w3d0be</bpmn:outgoing>]''',
'      ,q''[      <bpmn:standardLoopCharacteristics>]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:description>Loop &amp;LOOP_COUNTER.</apex:description>]''',
'      ,q''[          <apex:outputCollection>]''',
'      ,q''[            <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[            <apex:expression>LOOP_SUBPROC_ARRAY</apex:expression>]''',
'      ,q''[            <apex:insideVariable>EMPNO</apex:insideVariable>]''',
'      ,q''[          </apex:outputCollection>]''',
'      ,q''[          <apex:completionCondition>]''',
'      ,q''[            <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>:F4A$LOOP_COUNTER &gt;= 4</apex:expression>]''',
'      ,q''[          </apex:completionCondition>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:standardLoopCharacteristics>]''',
'      ,q''[      <bpmn:startEvent id="Event_LoopStart" name="LoopStart">]''',
'      ,q''[        <bpmn:outgoing>Flow_0y0u2mk</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_LoopTask" name="Do something in Loop">]''',
'      ,q''[        <bpmn:incoming>Flow_0y0u2mk</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1gn7ey5</bpmn:outgoing>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0y0u2mk" sourceRef="Event_LoopStart" targetRef="Activity_LoopTask" />]''',
'      ,q''[      <bpmn:endEvent id="Event_LoopEnd" name="LoopEnd">]''',
'      ,q''[        <bpmn:incoming>Flow_1gn7ey5</bpmn:incoming>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1gn7ey5" sourceRef="Activity_LoopTask" targetRef="Event_LoopEnd" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:subProcess id="Activity_1ewbvrh" name="SubProc full of iterating tasks*">]''',
'      ,q''[      <bpmn:incoming>Flow_17mah9s</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_1xc0gyr</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0f2j2zf</bpmn:outgoing>]''',
'      ,q''[      <bpmn:startEvent id="Event_1wmv0td" name="SubProcess Start">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:onEvent>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>0</apex:varSequence>]''',
'      ,q''[              <apex:varName>EMP_LIST</apex:varName>]''',
'      ,q''[              <apex:varDataType>VARCHAR2</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>sqlQueryList</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression>Select ENAME from emp where deptno = 20;</apex:varExpression>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[            <apex:processVariable>]''',
'      ,q''[              <apex:varSequence>1</apex:varSequence>]''',
'      ,q''[              <apex:varName>EMP_ARRAY</apex:varName>]''',
'      ,q''[              <apex:varDataType>JSON</apex:varDataType>]''',
'      ,q''[              <apex:varExpressionType>sqlQueryArray</apex:varExpressionType>]''',
'      ,q''[              <apex:varExpression>select ename, empno, sal ]''',
'      ,q''[from emp ]''',
'      ,q''[where deptno = 20</apex:varExpression>]''',
'      ,q''[            </apex:processVariable>]''',
'      ,q''[          </apex:onEvent>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[        <bpmn:outgoing>Flow_0y99afk</bpmn:outgoing>]''',
'      ,q''[      </bpmn:startEvent>]''',
'      ,q''[      <bpmn:task id="Activity_Par_Task_Iter" name="Parallel Iterated Task">]''',
'      ,q''[        <bpmn:incoming>Flow_0y99afk</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_15ns9rr</bpmn:outgoing>]''',
'      ,q''[        <bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:description>Iteration &amp;LOOP_COUNTER. - &amp;ENAME.</apex:description>]''',
'      ,q''[            <apex:inputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableList</apex:expressionType>]''',
'      ,q''[              <apex:expression>EMP_LIST</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ENAME</apex:insideVariable>]''',
'      ,q''[            </apex:inputCollection>]''',
'      ,q''[            <apex:outputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>Parallel_iteration_Array</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ENAME</apex:insideVariable>]''',
'      ,q''[            </apex:outputCollection>]''',
'      ,q''[            <apex:completionCondition>]''',
'      ,q''[              <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[              <apex:expression>:F4A$LOOP_COUNTER &gt;= 4</apex:expression>]''',
'      ,q''[            </apex:completionCondition>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0y99afk" sourceRef="Event_1wmv0td" targetRef="Activity_Par_Task_Iter" />]''',
'      ,q''[      <bpmn:task id="Activity_Seq_Iter_Task" name="Sequential Iterated Task">]''',
'      ,q''[        <bpmn:incoming>Flow_15ns9rr</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_0negvt3</bpmn:outgoing>]''',
'      ,q''[        <bpmn:multiInstanceLoopCharacteristics isSequential="true">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:description>Parallel Task &amp;LOOP_COUNTER. &amp;ENAME. (ID - &amp;EMPNO.)</apex:description>]''',
'      ,q''[            <apex:inputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>EMP_ARRAY</apex:expression>]''',
'      ,q''[            </apex:inputCollection>]''',
'      ,q''[            <apex:outputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>Par_task_iteration_array</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ENAME, EMPNO</apex:insideVariable>]''',
'      ,q''[            </apex:outputCollection>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:multiInstanceLoopCharacteristics>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_15ns9rr" sourceRef="Activity_Par_Task_Iter" targetRef="Activity_Seq_Iter_Task" />]''',
'      ,q''[      <bpmn:task id="Activity_0a24dav" name="Looped Task">]''',
'      ,q''[        <bpmn:incoming>Flow_0negvt3</bpmn:incoming>]''',
'      ,q''[        <bpmn:outgoing>Flow_1swygly</bpmn:outgoing>]''',
'      ,q''[        <bpmn:standardLoopCharacteristics>]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:description>LOOP TASK &amp;LOOP_COUNTER.</apex:description>]''',
'      ,q''[            <apex:outputCollection>]''',
'      ,q''[              <apex:expressionType>processVariableArray</apex:expressionType>]''',
'      ,q''[              <apex:expression>Loop_Task_Array</apex:expression>]''',
'      ,q''[              <apex:insideVariable>ENAME</apex:insideVariable>]''',
'      ,q''[            </apex:outputCollection>]''',
'      ,q''[            <apex:completionCondition>]''',
'      ,q''[              <apex:expressionType>plsqlExpression</apex:expressionType>]''',
'      ,q''[              <apex:expression>:F4A$LOOP_COUNTER &gt;= 3</apex:expression>]''',
'      ,q''[            </apex:completionCondition>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:standardLoopCharacteristics>]''',
'      ,q''[      </bpmn:task>]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_0negvt3" sourceRef="Activity_Seq_Iter_Task" targetRef="Activity_0a24dav" />]''',
'      ,q''[      <bpmn:sequenceFlow id="Flow_1swygly" sourceRef="Activity_0a24dav" targetRef="Event_1a84d7n" />]''',
'      ,q''[      <bpmn:endEvent id="Event_1a84d7n" name="Message End Event" apex:type="simpleMessage">]''',
'      ,q''[        <bpmn:incoming>Flow_1swygly</bpmn:incoming>]''',
'      ,q''[        <bpmn:messageEventDefinition id="MessageEventDefinition_0mb4lpd">]''',
'      ,q''[          <bpmn:extensionElements>]''',
'      ,q''[            <apex:endpoint>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>local</apex:expression>]''',
'      ,q''[            </apex:endpoint>]''',
'      ,q''[            <apex:messageName>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>SUBPROC_ENDED</apex:expression>]''',
'      ,q''[            </apex:messageName>]''',
'      ,q''[            <apex:correlationKey>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>SOnumber</apex:expression>]''',
'      ,q''[            </apex:correlationKey>]''',
'      ,q''[            <apex:correlationValue>]''',
'      ,q''[              <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[              <apex:expression>120</apex:expression>]''',
'      ,q''[            </apex:correlationValue>]''',
'      ,q''[          </bpmn:extensionElements>]''',
'      ,q''[        </bpmn:messageEventDefinition>]''',
'      ,q''[      </bpmn:endEvent>]''',
'      ,q''[      <bpmn:textAnnotation id="TextAnnotation_069t8tz">]''',
'      ,q''[        <bpmn:text>EMP_LIST and EMP_ARRAY (json Array) created in here to drive the iterations...</bpmn:text>]''',
'      ,q''[      </bpmn:textAnnotation>]''',
'      ,q''[      <bpmn:association id="Association_1w3b1po" associationDirection="None" sourceRef="Event_1wmv0td" targetRef="TextAnnotation_069t8tz" />]''',
'      ,q''[    </bpmn:subProcess>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_10g29co" apex:type="simpleMessage" cancelActivity="false" attachedToRef="Activity_1ewbvrh">]''',
'      ,q''[      <bpmn:outgoing>Flow_1vhzcec</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1sin00i">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>AnotherThrow</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>EmpID</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>160</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_13wkq2x" sourceRef="Event_1vrocwd" targetRef="Activity_1scsf1y" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0cyxw6b" sourceRef="Event_1c7yivk" targetRef="Activity_1snupqi" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_17mah9s" sourceRef="Activity_1snupqi" targetRef="Activity_1ewbvrh" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_13xeslp" sourceRef="Event_05kih0q" targetRef="Activity_0z7tzsn" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1x'))
);
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'c0gyr" sourceRef="Activity_0z7tzsn" targetRef="Activity_1ewbvrh" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1w3d0be" sourceRef="Activity_Loop_sub_proc" targetRef="Event_02j6heh" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1cqf80d" sourceRef="Activity_1cctr9o" targetRef="Event_0d9pz7p" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1vhzcec" sourceRef="Event_10g29co" targetRef="Activity_1cctr9o" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0f2j2zf" sourceRef="Activity_1ewbvrh" targetRef="Activity_Par_Iter_SubProc" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_11ntl9r" sourceRef="Activity_Par_Iter_SubProc" targetRef="Activity_Seq_Iter_Sub_Proc" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0iuudif" sourceRef="Activity_Seq_Iter_Sub_Proc" targetRef="Activity_Loop_sub_proc" />]''',
'      ,q''[    <bpmn:task id="Activity_1snupqi" name="Task with Interrupting Message* Boundary Event">]''',
'      ,q''[      <bpmn:incoming>Flow_0cyxw6b</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_17mah9s</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:boundaryEvent id="Event_05kih0q" apex:type="simpleMessage" attachedToRef="Activity_1snupqi">]''',
'      ,q''[      <bpmn:outgoing>Flow_13xeslp</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_1wsoaah">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>InterruptEE</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>POnumber</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>100</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:boundaryEvent>]''',
'      ,q''[    <bpmn:task id="Activity_0z7tzsn" name="Takes over from main task if message received">]''',
'      ,q''[      <bpmn:incoming>Flow_13xeslp</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1xc0gyr</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:intermediateThrowEvent id="Event_1c7yivk" name="Message Throw" apex:type="simpleMessage">]''',
'      ,q''[      <bpmn:incoming>Flow_1gyyaq9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0cyxw6b</bpmn:outgoing>]''',
'      ,q''[      <bpmn:messageEventDefinition id="MessageEventDefinition_0slx68c">]''',
'      ,q''[        <bpmn:extensionElements>]''',
'      ,q''[          <apex:endpoint>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>local</apex:expression>]''',
'      ,q''[          </apex:endpoint>]''',
'      ,q''[          <apex:messageName>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>FullMontyEERunning</apex:expression>]''',
'      ,q''[          </apex:messageName>]''',
'      ,q''[          <apex:correlationKey>]''',
'      ,q''[            <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[            <apex:expression>RunKey</apex:expression>]''',
'      ,q''[          </apex:correlationKey>]''',
'      ,q''[          <apex:correlationValue>]''',
'      ,q''[            <apex:expressionType>plsqlRawExpression</apex:expressionType>]''',
'      ,q''[            <apex:expression>flow_process_vars.get_var_clob ( pi_prcs_id =&gt; flow_globals.process_id]''',
'      ,q''[                               , pi_var_name=&gt; ''RunKey'']''',
'      ,q''[                               )</apex:expression>]''',
'      ,q''[          </apex:correlationValue>]''',
'      ,q''[        </bpmn:extensionElements>]''',
'      ,q''[      </bpmn:messageEventDefinition>]''',
'      ,q''[    </bpmn:intermediateThrowEvent>]''',
'      ,q''[    <bpmn:task id="Activity_1scsf1y" name="Send next message back">]''',
'      ,q''[      <bpmn:incoming>Flow_13wkq2x</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1gyyaq9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1gyyaq9" sourceRef="Activity_1scsf1y" targetRef="Event_1c7yivk" />]''',
'      ,q''[    <bpmn:association id="Association_0ujbmek" associationDirection="None" sourceRef="Event_02j6heh" targetRef="TextAnnotation_19s4sic" />]''',
'      ,q''[    <bpmn:association id="Association_1lgk5q3" associationDirection="None" sourceRef="Activity_1ewbvrh" targetRef="TextAnnotation_0tnvzhx" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Collaboration_Tutorial_8a">]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_1eelczk_di" bpmnElement="Participant_1eelczk" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="180" y="200" width="2310" height="1490" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_09houmv_di" bpmnElement="Lane_B" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="210" y="200" width="2280" height="340" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_1malyps_di" bpmnElement="Lane_A" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="210" y="540" width="2280" height="1150" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_0tdl27u_di" bpmnElement="Lane_0tdl27u" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="240" y="1450" width="2250" height="240" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Lane_0odyi81_di" bpmnElement="Lane_0odyi81" isHorizontal="true">]''',
'      ,q''[        <dc:Bounds x="240" y="540" width="2250" height="910" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="_BPMNShape_StartEvent_2" bpmnElement="StartEvent_1">]''',
'      ,q''[        <dc:Bounds x="302" y="702" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="308" y="745" width="24" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_05egit3_di" bpmnElement="Activity_stdTask">]''',
'      ,q''[        <dc:Bounds x="390" y="680" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1j5qhdr_di" bpmnElement="Event_uT_remind_end">]''',
'      ,q''[        <dc:Bounds x="1102" y="472" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1110" y="515" width="20" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_08afvxa_di" bpmnElement="Activity_CloseInput">]''',
'      ,q''[        <dc:Bounds x="1920" y="1260" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1p4ubrv_di" bpmnElement="Event_FRemindEnd">]''',
'      ,q''[        <dc:Bounds x="1752" y="1282" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1730" y="1325" width="81" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0hjgvl4_di" bpmnElement="Gateway_EBG" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="825" y="1255" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="808" y="1173" width="83" height="53" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_19z3jbf_di" bpmnElement="Event_TimerH" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="922" y="1362" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="900" y="1405" width="81" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_10uxh66_di" bpmnElement="Activity_G">]''',
'      ,q''[        <dc:Bounds x="1010" y="1240" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1td0zrj_di" bpmnElement="Gateway_GHMerge" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1165" y="1355" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1165" y="1412" width="51" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_00w4hzt_di" bpmnElement="Activity_H">]''',
'      ,q''[        <dc:Bounds x="1010" y="1340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_149vhoy_di" bpmnElement="Activity_Reminder" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="950" y="450" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0y2q8ss_di" bpmnElement="Event_MessageCatch_G" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="922" y="1262" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="905" y="1305" width="77" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1dg82fs_di" bpmnElement="Activity_FRemind">]''',
'      ,q''[        <dc:Bounds x="1620" y="1260" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1tokmzs_di" bpmnElement="Event_TheEnd">]''',
'      ,q''[        <dc:Bounds x="2392" y="867" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2379" y="910" width="63" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0mce1tt_di" bpmnElement="Gateway_MainSync">]''',
'      ,q''[        <dc:Bounds x="2305" y="860" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2226" y="917" width="90" height="53" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1a5in2d_di" bpmnElement="Gateway_Excl_Choose1" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1555" y="345" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1490" y="316" width="80" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1ev2yqx_di" bpmnElement="Activity_OptionB" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1670" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1citjar_di" bpmnElement="Event_CTermEnd">]''',
'      ,q''[        <dc:Bounds x="1672" y="462" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1713" y="480" width="74" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_05958zc_di" bpmnElement="Activity_S" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="2080" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0bkzha0_di" bpmnElement="Gateway_RSTClose" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="2255" y="345" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2299" y="287" width="83" height="66" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1n9ks7b_di" bpmnElement="Activity_R" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="2080" y="230" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1o9oe05_di" bpmnElement="Activity_T" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="2080" y="440" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_03tagro_di" bpmnElement="Activity_ManualTask" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1390" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1d8dhsd_di" bpmnElement="Activity_scriptTask" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1110" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0cax07n_di" bpmnElement="Activity_1i0012l" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="1250" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0s7k7au_di" bpmnElement="Activity_19316nz" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="970" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0owgu48_di" bpmnElement="Activity_OptionA" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1670" y="220" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0pqx7yh_di" bpmnElement="Gateway_RST_Inc_Split" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1935" y="345" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1865" y="310" width="90" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0elt40y_di" bpmnElement="Gateway_ABMerge" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1815" y="345" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1825" y="402" width="32" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0clb94i_di" bpmnElement="Activity_Notify">]''',
'      ,q''[        <dc:Bounds x="1330" y="1270" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_03waax2_di" bpmnElement="Event_FTermEnd">]''',
'      ,q''[        <dc:Bounds x="1462" y="1292" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1450" y="1338" width="59" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1g13boe_di" bpmnElement="Activity_SubProcF" isExpanded="true">]''',
'      ,q''[        <dc:Bounds x="900" y="555" width="1280" height="675" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_08c82vn_di" bpmnElement="Event_FStart">]''',
'      ,q''[        <dc:Bounds x="922" y="837" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="924" y="880" width="34" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0wacmvg_di" bpmnElement="Gateway_FSplit">]''',
'      ,q''[        <dc:Bounds x="985" y="830" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="964" y="813" width="32" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1bun2of_di" bpmnElement="Activity_subProcF1" isExpanded="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1050" y="595" width="670" height="255" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1atmvvp_di" bpmnElement="Event_F1Start">]''',
'      ,q''[        <dc:Bounds x="1072" y="647" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1070" y="690" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0gj73o4_di" bpmnElement="Activity_0gj73o4">]''',
'      ,q''[        <dc:Bounds x="1140" y="625" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1vj65s8_di" bpmnElement="Gateway_AllOK" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1395" y="640" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1371" y="638" width="38" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0u7ha21_di" bpmnElement="Activity_F1B">]''',
'      ,q''[        <dc:Bounds x="1500" y="625" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1km6ey2_di" bpmnElement="Event_F1HappyEnd">]''',
'      ,q''[        <dc:Bounds x="1642" y="647" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1625" y="690" width="71" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1jlvbjb_di" bpmnElement="Activity_F1_Proc_error">]''',
'      ,q''[        <dc:Bounds x="1500" y="735" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1vevdb0_di" bpmnElement="Event_F1ErrorEnd">]''',
'      ,q''[        <dc:Bounds x="1642" y="757" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1629" y="800" width="63" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0guy1ox_di" bpmnElement="Activity_F1AHandleTimeout">]''',
'      ,q''[        <dc:Bounds x="1220" y="745" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1snpwfa_di" bpmnElement="Event_F1TermEnd">]''',
'      ,q''[        <dc:Bounds x="1352" y="767" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1327" y="810" width="87" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1obg85y_di" bpmnElement="Event_1ko5r23">]''',
'      ,q''[        <dc:Bounds x="1172" y="687" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1101" y="715" width="79" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0oyf6xf_di" bpmnElement="Flow_0oyf6xf">]''',
'      ,q''[        <di:waypoint x="1108" y="665" />]''',
'      ,q''[        <di:waypoint x="1140" y="665" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1rsbmbe_di" bpmnElement="Flow_1rsbmbe">]''',
'      ,q''[        <di:waypoint x="1240" y="665" />]''',
'      ,q''[        <di:waypoint x="1395" y="665" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qccguc_di" bpmnElement="Flow_1qccguc">]''',
'      ,q''[        <di:waypoint x="1445" y="665" />]''',
'      ,q''[        <di:waypoint x="1500" y="665" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1464" y="647" width="19" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13gdlkj_di" bpmnElement="Flow_13gdlkj">]''',
'      ,q''[        <di:waypoint x="1600" y="665" />]''',
'      ,q''[        <di:waypoint x="1642" y="665" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1f2lsls_di" bpmnElement="Flow_1f2lsls">]''',
'      ,q''[        <di:waypoint x="1420" y="690" />]''',
'      ,q''[        <di:waypoint x="1420" y="775" />]''',
'      ,q''[        <di:waypoint x="1500" y="775" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1423" y="741" width="74" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13w3z3z_di" bpmnElement="Flow_13w3z3z">]''',
'      ,q''[        <di:waypoint x="1600" y="775" />]''',
'      ,q''[        <di:waypoint x="1642" y="775" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03ice2s_di" bpmnElement="Flow_03ice2s">]''',
'      ,q''[        <di:waypoint x="1190" y="723" />]''',
'      ,q''[        <di:waypoint x="1190" y="785" />]''',
'      ,q''[        <di:waypoint x="1220" y="785" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_10714n0_di" bpmnElement="Flow_10714n0">]''',
'      ,q''[        <di:waypoint x="1320" y="785" />]''',
'      ,q''[        <di:waypoint x="1352" y="785" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_10prt96_di" bpmnElement="Activity_subProcF2" isExpanded="true" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1060" y="873" width="590" height="202" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0nq6sli_di" bpmnElement="Event_F2Start">]''',
'      ,q''[        <dc:Bounds x="1082" y="927" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1080" y="970" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0rv26eu_di" bpmnElement="Gateway_F2Open" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1345" y="920" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1332" y="896" width="78" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0ixs2o5_di" bpmnElement="Gateway_F2Close" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1465" y="920" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1kmzijd_di" bpmnElement="Event_F2EscITE">]''',
'      ,q''[        <dc:Bounds x="1412" y="997" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1449" y="1025" width="62" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1c43ovj_di" bpmnElement="Event_F2End">]''',
'      ,q''[        <dc:Bounds x="1572" y="927" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1572" y="970" width="36" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_03kqukz_di" bpmnElement="Activity_subProcF2A" isExpanded="false">]''',
'      ,q''[        <dc:Bounds x="1180" y="905" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0nyapnc_di" bpmnElement="Flow_0nyapnc">]''',
'      ,q''[        <di:waypoint x="1118" y="945" />]''',
'      ,q''[        <di:waypoint x="1180" y="945" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0bler3b_di" bpmnElement="Flow_0bler3b">]''',
'      ,q''[        <di:waypoint x="1280" y="945" />]''',
'      ,q''[        <di:waypoint x="1345" y="945" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0hzmts8_di" bpmnElement="Flow_0hzmts8">]''',
'      ,q''[        <di:waypoint x="1395" y="945" />]''',
'      ,q''[        <di:waypoint x="1465" y="945" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1426" y="927" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dar5q9_di" bpmnElement="Flow_1dar5q9">]''',
'      ,q''[        <di:waypoint x="1370" y="970" />]''',
'      ,q''[        <di:waypoint x="1370" y="1015" />]''',
'      ,q''[        <di:waypoint x="1412" y="1015" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1381" y="990" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0hra594_di" bpmnElement="Flow_0hra594">]''',
'      ,q''[        <di:waypoint x="1448" y="1015" />]''',
'      ,q''[        <di:waypoint x="1490" y="1015" />]''',
'      ,q''[        <di:waypoint x="1490" y="970" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1t5akvc_di" bpmnElement="Flow_1t5akvc">]''',
'      ,q''[        <di:waypoint x="1515" y="945" />]''',
'      ,q''[        <di:waypoint x="1572" y="945" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_03lhv9d_di" bpmnElement="Event_FEndA">]''',
'      ,q''[        <dc:Bounds x="1922" y="657" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1920" y="700" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1wkp2r5_di" bpmnElement="Event_F_End_B">]''',
'      ,q''[        <dc:Bounds x="1922" y="873" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1921" y="916" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_04jlqb2_di" bpmnElement="Event_F2EscLinkA" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1442" y="1137" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1446" y="1180" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0s2njo0_di" bpmnElement="Event_LinkA_ICE" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1552" y="1137" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1556" y="1180" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_05mhmtp_di" bpmnElement="Gateway_AllOKNow" isMarkerVisible="true">]''',
'      ,q''[        <dc:Bounds x="1695" y="1130" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1689" y="1187" width="63" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_194ut3i_di" bpmnElement="Event_FEndC">]''',
'      ,q''[        <dc:Bounds x="1922" y="1137" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1920" y="1180" width="41" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="'))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Event_0gb8w62_di" bpmnElement="Event_F1_LinkA">]''',
'      ,q''[        <dc:Bounds x="1922" y="757" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1927" y="800" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0220gli_di" bpmnElement="Event_FEscEnd">]''',
'      ,q''[        <dc:Bounds x="1922" y="1057" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1904" y="1100" width="74" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0c9r2uu_di" bpmnElement="Event_TimerAfterLink">]''',
'      ,q''[        <dc:Bounds x="1622" y="1137" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1606" y="1180" width="68" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0xyp3mc_di" bpmnElement="Activity_PrepForTerm">]''',
'      ,q''[        <dc:Bounds x="1760" y="1035" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0oum5jo_di" bpmnElement="Activity_F3" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1060" y="1115" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1q9eutv_di" bpmnElement="Event_0wf0v6l">]''',
'      ,q''[        <dc:Bounds x="1192" y="1137" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1197" y="1180" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1eiscel_di" bpmnElement="Event_11kl7us" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1722" y="956" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1727" y="999" width="28" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1u4qtdo_di" bpmnElement="Event_1u4qtdo">]''',
'      ,q''[        <dc:Bounds x="1922" y="956" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1920" y="999" width="41" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0fjkffv_di" bpmnElement="Activity_EmailManagerHelp" bioc:stroke="#205022" bioc:fill="#c8e6c9" color:background-color="#c8e6c9" color:border-color="#205022">]''',
'      ,q''[        <dc:Bounds x="1320" y="1115" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0s9z99m_di" bpmnElement="Event_F1ErrorBoundary">]''',
'      ,q''[        <dc:Bounds x="1702" y="757" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1742" y="800" width="75" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1026xtr_di" bpmnElement="Event_F2Esc">]''',
'      ,q''[        <dc:Bounds x="1262" y="1057" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1189" y="1087" width="83" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_06l5x9i_di" bpmnElement="Flow_06l5x9i">]''',
'      ,q''[        <di:waypoint x="958" y="855" />]''',
'      ,q''[        <di:waypoint x="985" y="855" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1c3cdi9_di" bpmnElement="Flow_toF2">]''',
'      ,q''[        <di:waypoint x="1010" y="880" />]''',
'      ,q''[        <di:waypoint x="1010" y="974" />]''',
'      ,q''[        <di:waypoint x="1060" y="974" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1027" y="943" width="26" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1eru5rx_di" bpmnElement="Flow_toF1">]''',
'      ,q''[        <di:waypoint x="1010" y="830" />]''',
'      ,q''[        <di:waypoint x="1010" y="715" />]''',
'      ,q''[        <di:waypoint x="1050" y="715" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1009" y="693" width="22" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_05k289e_di" bpmnElement="Flow_05k289e">]''',
'      ,q''[        <di:waypoint x="1738" y="775" />]''',
'      ,q''[        <di:waypoint x="1922" y="775" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1eyfbtd_di" bpmnElement="Flow_1eyfbtd">]''',
'      ,q''[        <di:waypoint x="1720" y="675" />]''',
'      ,q''[        <di:waypoint x="1922" y="675" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1kgfn9a_di" bpmnElement="Flow_1kgfn9a">]''',
'      ,q''[        <di:waypoint x="1650" y="891" />]''',
'      ,q''[        <di:waypoint x="1922" y="891" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0a3amjb_di" bpmnElement="Flow_0a3amjb">]''',
'      ,q''[        <di:waypoint x="1588" y="1155" />]''',
'      ,q''[        <di:waypoint x="1622" y="1155" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1jynl0c_di" bpmnElement="Flow_1jynl0c">]''',
'      ,q''[        <di:waypoint x="1745" y="1155" />]''',
'      ,q''[        <di:waypoint x="1922" y="1155" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1830" y="1137" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0zm2lio_di" bpmnElement="Flow_0zm2lio">]''',
'      ,q''[        <di:waypoint x="1720" y="1130" />]''',
'      ,q''[        <di:waypoint x="1720" y="1075" />]''',
'      ,q''[        <di:waypoint x="1760" y="1075" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1731" y="1099" width="8" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0203h3w_di" bpmnElement="Flow_0203h3w">]''',
'      ,q''[        <di:waypoint x="1860" y="1075" />]''',
'      ,q''[        <di:waypoint x="1922" y="1075" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0uoidfy_di" bpmnElement="Flow_0uoidfy">]''',
'      ,q''[        <di:waypoint x="1658" y="1155" />]''',
'      ,q''[        <di:waypoint x="1695" y="1155" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gkk731_di" bpmnElement="Flow_F3">]''',
'      ,q''[        <di:waypoint x="1010" y="880" />]''',
'      ,q''[        <di:waypoint x="1010" y="1155" />]''',
'      ,q''[        <di:waypoint x="1060" y="1155" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1026" y="1123" width="29" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0qcvrkv_di" bpmnElement="Flow_0qcvrkv">]''',
'      ,q''[        <di:waypoint x="1160" y="1155" />]''',
'      ,q''[        <di:waypoint x="1192" y="1155" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1f1h0pi_di" bpmnElement="Flow_1f1h0pi">]''',
'      ,q''[        <di:waypoint x="1758" y="974" />]''',
'      ,q''[        <di:waypoint x="1922" y="974" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wjommq_di" bpmnElement="Flow_0wjommq">]''',
'      ,q''[        <di:waypoint x="1420" y="1155" />]''',
'      ,q''[        <di:waypoint x="1442" y="1155" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_031cc6f_di" bpmnElement="Flow_031cc6f">]''',
'      ,q''[        <di:waypoint x="1280" y="1093" />]''',
'      ,q''[        <di:waypoint x="1280" y="1155" />]''',
'      ,q''[        <di:waypoint x="1320" y="1155" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1x9wuxi_di" bpmnElement="Association_1x9wuxi">]''',
'      ,q''[        <di:waypoint x="1923" y="670" />]''',
'      ,q''[        <di:waypoint x="1762" y="622" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_19sx8sy_di" bpmnElement="Gateway_MainSplit">]''',
'      ,q''[        <dc:Bounds x="575" y="695" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="608" y="752" width="84" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0c53mbs_di" bpmnElement="Activity_userTask" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="680" y="330" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_104bhos_di" bpmnElement="Activity_1noqbij" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="820" y="330" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ceytj4_di" bpmnElement="Activity_0eex1qm" isExpanded="true" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="370" y="1490" width="1830" height="170" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0csn51r_di" bpmnElement="Event_0csn51r">]''',
'      ,q''[        <dc:Bounds x="402" y="1542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="403" y="1585" width="35" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0nlt28u_di" bpmnElement="Activity_1k0u0f3">]''',
'      ,q''[        <dc:Bounds x="630" y="1520" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_02vdwno_di" bpmnElement="Activity_1r9v7rj">]''',
'      ,q''[        <dc:Bounds x="820" y="1520" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0crkf0q_di" bpmnElement="Event_0wngn5b">]''',
'      ,q''[        <dc:Bounds x="1212" y="1542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1186" y="1516" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1a709ef_di" bpmnElement="Event_1a709ef">]''',
'      ,q''[        <dc:Bounds x="2082" y="1542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2085" y="1585" width="31" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_02ndwin_di" bpmnElement="Event_1ao382y">]''',
'      ,q''[        <dc:Bounds x="1542" y="1542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1516" y="1516" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1eqfu6q_di" bpmnElement="Event_0w25ri0">]''',
'      ,q''[        <dc:Bounds x="1092" y="1542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1066" y="1516" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0chuxbk_di" bpmnElement="Event_13x93sm">]''',
'      ,q''[        <dc:Bounds x="1832" y="1542" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1807" y="1512" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_06248kr_di" bpmnElement="Activity_06248kr">]''',
'      ,q''[        <dc:Bounds x="470" y="1520" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1i49a3k_di" bpmnElement="Activity_1i49a3k">]''',
'      ,q''[        <dc:Bounds x="950" y="1520" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0icmf8o_di" bpmnElement="Activity_0icmf8o">]''',
'      ,q''[        <dc:Bounds x="1340" y="1520" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gd74ja_di" bpmnElement="Flow_1gd74ja">]''',
'      ,q''[        <di:waypoint x="438" y="1560" />]''',
'      ,q''[        <di:waypoint x="470" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ufboyw_di" bpmnElement="Flow_0ufboyw">]''',
'      ,q''[        <di:waypoint x="1248" y="1560" />]''',
'      ,q''[        <di:waypoint x="1340" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0s5ddhp_di" bpmnElement="Flow_0s5ddhp">]''',
'      ,q''[        <di:waypoint x="1578" y="1560" />]''',
'      ,q''[        <di:waypoint x="1832" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0wjn6p3_di" bpmnElement="Flow_0wjn6p3">]''',
'      ,q''[        <di:waypoint x="920" y="1560" />]''',
'      ,q''[        <di:waypoint x="950" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07kv3w8_di" bpmnElement="Flow_07kv3w8">]''',
'      ,q''[        <di:waypoint x="730" y="1560" />]''',
'      ,q''[        <di:waypoint x="820" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16qf0a4_di" bpmnElement="Flow_16qf0a4">]''',
'      ,q''[        <di:waypoint x="1128" y="1560" />]''',
'      ,q''[        <di:waypoint x="1212" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0jmj15r_di" bpmnElement="Flow_0jmj15r">]''',
'      ,q''[        <di:waypoint x="1868" y="1560" />]''',
'      ,q''[        <di:waypoint x="2082" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0hchqi3_di" bpmnElement="Flow_0hchqi3">]''',
'      ,q''[        <di:waypoint x="570" y="1560" />]''',
'      ,q''[        <di:waypoint x="630" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1fm2bkv_di" bpmnElement="Flow_1fm2bkv">]''',
'      ,q''[        <di:waypoint x="1050" y="1560" />]''',
'      ,q''[        <di:waypoint x="1092" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1pu37ym_di" bpmnElement="Flow_1pu37ym">]''',
'      ,q''[        <di:waypoint x="1440" y="1560" />]''',
'      ,q''[        <di:waypoint x="1542" y="1560" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0xch24e_di" bpmnElement="TextAnnotation_0xch24e">]''',
'      ,q''[        <dc:Bounds x="330" y="320" width="190" height="168" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_09wrm4v_di" bpmnElement="Event_0ayu08h">]''',
'      ,q''[        <dc:Bounds x="2182" y="1592" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="2227" y="1627" width="85" height="66" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_14ldymq_di" bpmnElement="Event_ReminderBE">]''',
'      ,q''[        <dc:Bounds x="712" y="392" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="641" y="435" width="79" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1rvlutc_di" bpmnElement="Event_FTimeoutBE">]''',
'      ,q''[        <dc:Bounds x="1842" y="1212" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1757" y="1246" width="87" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1xu4vjx_di" bpmnElement="Event_FNI_Timer_BE">]''',
'      ,q''[        <dc:Bounds x="1502" y="1212" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1531" y="1246" width="79" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_11dxhil_di" bpmnElement="Event_FEscBE">]''',
'      ,q''[        <dc:Bounds x="1272" y="1212" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1253" y="1318" width="73" height="53" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1u5kfn1_di" bpmnElement="Flow_1u5kfn1">]''',
'      ,q''[        <di:waypoint x="338" y="720" />]''',
'      ,q''[        <di:waypoint x="390" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0k089wp_di" bpmnElement="Flow_0k089wp">]''',
'      ,q''[        <di:waypoint x="490" y="720" />]''',
'      ,q''[        <di:waypoint x="575" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1q7lyne_di" bpmnElement="Flow_1q7lyne">]''',
'      ,q''[        <di:waypoint x="600" y="695" />]''',
'      ,q''[        <di:waypoint x="600" y="370" />]''',
'      ,q''[        <di:waypoint x="680" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_15m8qw2_di" bpmnElement="Flow_15m8qw2">]''',
'      ,q''[        <di:waypoint x="625" y="720" />]''',
'      ,q''[        <di:waypoint x="900" y="720" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1sl1mr5_di" bpmnElement="Flow_1sl1mr5">]''',
'      ,q''[        <di:waypoint x="600" y="745" />]''',
'      ,q''[        <di:waypoint x="600" y="1280" />]''',
'      ,q''[        <di:waypoint x="825" y="1280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0av2w95_di" bpmnElement="Flow_0av2w95">]''',
'      ,q''[        <di:waypoint x="780" y="370" />]''',
'      ,q''[        <di:waypoint x="820" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_139aflr_di" bpmnElement="Flow_139aflr">]''',
'      ,q''[        <di:waypoint x="1050" y="490" />]''',
'      ,q''[        <di:waypoint x="1102" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1qh3zb4_di" bpmnElement="Flow_1qh3zb4">]''',
'      ,q''[        <di:waypoint x="1860" y="1248" />]''',
'      ,q''[        <di:waypoint x="1860" y="1300" />]''',
'      ,q''[        <di:waypoint x="1920" y="1300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1320p09_di" bpmnElement="Flow_1320p09">]''',
'      ,q''[        <di:waypoint x="2020" y="1300" />]''',
'      ,q''[        <di:waypoint x="2330" y="1300" />]''',
'      ,q''[        <di:waypoint x="2330" y="910" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1hkw8tj_di" bpmnElement="Flow_1hkw8tj">]''',
'      ,q''[        <di:waypoint x="1720" y="1300" />]''',
'      ,q''[        <di:waypoint x="1752" y="1300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1hbzc2c_di" bpmnElement="Flow_1hbzc2c">]''',
'      ,q''[        <di:waypoint x="875" y="1280" />]''',
'      ,q''[        <di:waypoint x="922" y="1280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ab2ygs_di" bpmnElement="Flow_0ab2ygs">]''',
'      ,q''[        <di:waypoint x="850" y="1305" />]''',
'      ,q''[        <di:waypoint x="850" y="1380" />]''',
'      ,q''[        <di:waypoint x="922" y="1380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0bevchi_di" bpmnElement="Flow_0bevchi">]''',
'      ,q''[        <di:waypoint x="958" y="1380" />]''',
'      ,q''[        <di:waypoint x="1010" y="1380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_04ew1x4_di" bpmnElement="Flow_04ew1x4">]''',
'      ,q''[        <di:waypoint x="958" y="1280" />]''',
'      ,q''[        <di:waypoint x="1010" y="1280" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0e3ltbj_di" bpmnElement="Flow_0e3ltbj">]''',
'      ,q''[        <di:waypoint x="1110" y="1280" />]''',
'      ,q''[        <di:waypoint x="1190" y="1280" />]''',
'      ,q''[        <di:waypoint x="1190" y="1355" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0mw3yoc_di" bpmnElement="Flow_0mw3yoc">]''',
'      ,q''[        <di:waypoint x="1110" y="1380" />]''',
'      ,q''[        <di:waypoint x="1165" y="1380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1lkzgyz_di" bpmnElement="Flow_1lkzgyz">]''',
'      ,q''[        <di:waypoint x="1215" y="1380" />]''',
'      ,q''[        <di:waypoint x="2330" y="1380" />]''',
'      ,q''[        <di:waypoint x="2330" y="910" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1bssnss_di" bpmnElement="Flow_1bssnss">]''',
'      ,q''[        <di:waypoint x="730" y="428" />]''',
'      ,q''[        <di:waypoint x="730" y="490" />]''',
'      ,q''[        <di:waypoint x="950" y="490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_10ebnqk_di" bpmnElement="Flow_10ebnqk">]''',
'      ,q''[        <di:waypoint x="1520" y="1248" />]''',
'      ,q''[        <di:waypoint x="1520" y="1300" />]''',
'      ,q''[        <di:waypoint x="1620" y="1300" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0f14hah_di" bpmnElement="Flow_0f14hah">]''',
'      ,q''[        <di:waypoint x="1290" y="1248" />]''',
'      ,q''[        <di:waypoint x="1290" y="1310" />]''',
'      ,q''[        <di:waypoint x="1330" y="1310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1d0hvhw_di" bpmnElement="Flow_1d0hvhw">]''',
'      ,q''[        <di:waypoint x="1430" y="1310" />]''',
'      ,q''[        <di:waypoint x="1462" y="1310" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_05y14rb_di" bpmnElement="Flow_05y14rb">]''',
'      ,q''[        <di:waypoint x="2355" y="885" />]''',
'      ,q''[        <di:waypoint x="2392" y="885" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0g7i78z_di" bpmnElement="Flow_0g7i78z">]''',
'      ,q''[        <di:waypoint x="2180" y="885" />]''',
'      ,q''[        <di:waypoint x="2305" y="885" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ml8gyp_di" bpmnElement="Flow_1ml8gyp">]''',
'      ,q''[        <di:waypoint x="2305" y="370" />]''',
'      ,q''[        <di:waypoint x="2330" y="370" />]''',
'      ,q''[        <di:waypoint x="2330" y="860" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12bf5hj_di" bpmnElement="Flow_12bf5hj">]''',
'      ,q''[        <di:waypoint x="1490" y="370" />]''',
'      ,q''[        <di:waypoint x="1555" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0iu6gi4_di" bpmnElement="Flow_A">]''',
'      ,q''[        <di:waypoint x="1580" y="345" />]''',
'      ,q''[        <di:waypoint x="1580" y="260" />]''',
'      ,q''[        <di:waypoint x="1670" y="260" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1602" y="243" width="36" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ir2osx_di" bpmnElement="Flow_B">]''',
'      ,q''[        <di:waypoint x="1605" y="370" />]''',
'      ,q''[        <di:waypoint x="1670" y="370" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1597" y="336" width="65" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0xjsivb_di" bpmnElement="Flow_C">]''',
'      ,q''[        <di:waypoint x="1580" y="395" />]''',
'      ,q''[        <di:waypoint x="1580" y="480" />]''',
'      ,q''[        <di:waypoint x="1672" y="480" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1594" y="446" width="51" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dyxw9o_di" bpmnElement="Flow_1dyxw9o">]''',
'      ,q''[        <di:waypoint x="1770" y="370" />]''',
'      ,q''[        <di:waypoint x="1815" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03skdre_di" bpmnElement="Flow_S">]''',
'      ,q''[        <di:waypoint x="1985" y="370" />]''',
'      ,q''[        <di:waypoint x="2080" y="370" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1979" y="336" width="81" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_02uxial_di" bpmnElement="Flow_02uxial">]''',
'      ,q''[        <di:waypoint x="2180" y="370" />]''',
'      ,q''[        <di:waypoint x="2255" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_135n6n7_di" bpmnElement="Flow_135n6n7">]''',
'      ,q''[        <di:waypoint x="2180" y="270" />]''',
'      ,q''[        <di:waypoint x="2280" y="270" />]''',
'      ,q''[        <di:waypoint x="2280" y="345" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mpw2yu_di" bpmnElement="Flow_1mpw2yu">]''',
'      ,q''[        <di:waypoint x="2180" y="480" />]''',
'      ,q''[        <di:waypoint x="2280" y="480" />]''',
'      ,q''[        <di:waypoint x="2280" y="395" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0miynpd_di" bpmnElement="Flow_R">]''',
'      ,q''[        <di:waypoint x="1960" y="345" />]''',
'      ,q''[        <di:waypoint x="1960" y="270" />]''',
'      ,q''[        <di:waypoint x="2080" y="270" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1979" y="236" width="81" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1wt3yjm_di" bpmnElement="Flow_T">]''',
'      ,q''[        <di:waypoint x="1960" y="395" />]''',
'      ,q''[        <di:waypoint x="1960" y="480" />]''',
'      ,q''[        <di:waypoint x="2080" y="480" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1970" y="446" width="81" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1a3mwvi_di" bpmnElement="Flow_1a3mwvi">]''',
'      ,q''[        <di:waypoint x="1350" y="370" />]''',
'      ,q''[        <di:waypoint x="1390" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0m74axl_di" bpmnElement="Flow_0m74axl">]''',
'      ,q''[        <di:waypoint x="1070" y="370" />]''',
'      ,q''[        <di:waypoint x="1110" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0395vvt_di" bpmnElement="Flow_0395vvt">]''',
'      ,q''[        <di:waypoint x="1210" y="370" />]''',
'      ,q''[        <di:waypoint x="1250" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_03kgsyn_di" bpmnElement="Flow_03kgsyn">]''',
'      ,q''[        <di:waypoint x="1770" y="260" />]''',
'      ,q''[        <di:waypoint x="1840" y="260" />]''',
'      ,q''[        <di:waypoint x="1840" y="345" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0f0z11o_di" bpmnElement="Flow_0f0z11o">]''',
'      ,q''[        <di:waypoint x="1865" y="370" />]''',
'      ,q''[        <di:waypoint x="1935" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1atdbof_di" bpmnElement="Flow_1atdbof">]''',
'      ,q''[        <di:waypoint x="600" y="745" />]''',
'      ,q''[        <di:waypoint x="600" y="1490" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_12ao8zk_di" bpmnElement="Flow_12ao8zk">]''',
'      ,q''[        <di:waypoint x="2218" y="1610" />]''',
'      ,q''[        <di:waypoint x="2330" y="1610" />]''',
'      ,q''[        <di:waypoint x="2330" y="910" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0tzaa8e_di" bpmnElement="Flow_0tzaa8e">]''',
'      ,q''[        <di:waypoint x="2200" y="1560" />]''',
'      ,q''[        <di:waypoint x="2330" y="1560" />]''',
'      ,q''[        <di:waypoint x="2330" y="910" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,'))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'q''[      <bpmndi:BPMNEdge id="Flow_0227ot0_di" bpmnElement="Flow_0227ot0">]''',
'      ,q''[        <di:waypoint x="920" y="370" />]''',
'      ,q''[        <di:waypoint x="970" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0tjhct6_di" bpmnElement="Association_0tjhct6">]''',
'      ,q''[        <di:waypoint x="324" y="703" />]''',
'      ,q''[        <di:waypoint x="369" y="488" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_095hgt1_di" bpmnElement="Association_095hgt1">]''',
'      ,q''[        <di:waypoint x="1562" y="377" />]''',
'      ,q''[        <di:waypoint x="1353" y="450" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_09n6lvz_di" bpmnElement="Association_09n6lvz">]''',
'      ,q''[        <di:waypoint x="1944" y="379" />]''',
'      ,q''[        <di:waypoint x="1810" y="442" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_14q8sx5_di" bpmnElement="Association_14q8sx5">]''',
'      ,q''[        <di:waypoint x="774" y="331" />]''',
'      ,q''[        <di:waypoint x="822" y="290" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="Participant_1yoxs96_di" bpmnElement="Participant_1yoxs96" isHorizontal="true" bioc:stroke="#0d4372" bioc:fill="#bbdefb" color:background-color="#bbdefb" color:border-color="#0d4372">]''',
'      ,q''[        <dc:Bounds x="180" y="1743" width="2310" height="340" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0dgqedc_di" bpmnElement="Event_1vrocwd">]''',
'      ,q''[        <dc:Bounds x="692" y="1915" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="670" y="1958" width="81" height="66" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0ol0c8w_di" bpmnElement="Event_02j6heh">]''',
'      ,q''[        <dc:Bounds x="1832" y="1915" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1808" y="1966" width="84" height="53" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0d9pz7p_di" bpmnElement="Event_0d9pz7p">]''',
'      ,q''[        <dc:Bounds x="1782" y="1795" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1767" y="1838" width="67" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1cctr9o_di" bpmnElement="Activity_1cctr9o">]''',
'      ,q''[        <dc:Bounds x="1380" y="1773" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_056oisd_di" bpmnElement="Activity_Par_Iter_SubProc">]''',
'      ,q''[        <dc:Bounds x="1410" y="1893" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1jz6d3v_di" bpmnElement="Activity_Seq_Iter_Sub_Proc">]''',
'      ,q''[        <dc:Bounds x="1550" y="1893" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0q4b698_di" bpmnElement="Activity_Loop_sub_proc">]''',
'      ,q''[        <dc:Bounds x="1690" y="1893" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1l1lz04_di" bpmnElement="Activity_1ewbvrh">]''',
'      ,q''[        <dc:Bounds x="1230" y="1893" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1snupqi_di" bpmnElement="Activity_1snupqi">]''',
'      ,q''[        <dc:Bounds x="970" y="1893" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0z7tzsn_di" bpmnElement="Activity_0z7tzsn">]''',
'      ,q''[        <dc:Bounds x="1070" y="1773" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1ycf87w_di" bpmnElement="Event_1c7yivk">]''',
'      ,q''[        <dc:Bounds x="904" y="1915" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="883" y="1958" width="79" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1scsf1y_di" bpmnElement="Activity_1scsf1y">]''',
'      ,q''[        <dc:Bounds x="770" y="1893" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_19tuvl9_di" bpmnElement="Event_05kih0q">]''',
'      ,q''[        <dc:Bounds x="1002" y="1875" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1ta3fyl_di" bpmnElement="Event_10g29co">]''',
'      ,q''[        <dc:Bounds x="1262" y="1875" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13wkq2x_di" bpmnElement="Flow_13wkq2x">]''',
'      ,q''[        <di:waypoint x="728" y="1933" />]''',
'      ,q''[        <di:waypoint x="770" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0cyxw6b_di" bpmnElement="Flow_0cyxw6b">]''',
'      ,q''[        <di:waypoint x="940" y="1933" />]''',
'      ,q''[        <di:waypoint x="970" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_17mah9s_di" bpmnElement="Flow_17mah9s">]''',
'      ,q''[        <di:waypoint x="1070" y="1933" />]''',
'      ,q''[        <di:waypoint x="1230" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_13xeslp_di" bpmnElement="Flow_13xeslp">]''',
'      ,q''[        <di:waypoint x="1026" y="1876" />]''',
'      ,q''[        <di:waypoint x="1050" y="1813" />]''',
'      ,q''[        <di:waypoint x="1070" y="1813" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1xc0gyr_di" bpmnElement="Flow_1xc0gyr">]''',
'      ,q''[        <di:waypoint x="1120" y="1853" />]''',
'      ,q''[        <di:waypoint x="1120" y="1913" />]''',
'      ,q''[        <di:waypoint x="1230" y="1913" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1w3d0be_di" bpmnElement="Flow_1w3d0be">]''',
'      ,q''[        <di:waypoint x="1790" y="1933" />]''',
'      ,q''[        <di:waypoint x="1832" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1cqf80d_di" bpmnElement="Flow_1cqf80d">]''',
'      ,q''[        <di:waypoint x="1480" y="1813" />]''',
'      ,q''[        <di:waypoint x="1782" y="1813" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1vhzcec_di" bpmnElement="Flow_1vhzcec">]''',
'      ,q''[        <di:waypoint x="1290" y="1878" />]''',
'      ,q''[        <di:waypoint x="1335" y="1813" />]''',
'      ,q''[        <di:waypoint x="1380" y="1813" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0f2j2zf_di" bpmnElement="Flow_0f2j2zf">]''',
'      ,q''[        <di:waypoint x="1330" y="1933" />]''',
'      ,q''[        <di:waypoint x="1410" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_11ntl9r_di" bpmnElement="Flow_11ntl9r">]''',
'      ,q''[        <di:waypoint x="1510" y="1933" />]''',
'      ,q''[        <di:waypoint x="1550" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0iuudif_di" bpmnElement="Flow_0iuudif">]''',
'      ,q''[        <di:waypoint x="1650" y="1933" />]''',
'      ,q''[        <di:waypoint x="1690" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gyyaq9_di" bpmnElement="Flow_1gyyaq9">]''',
'      ,q''[        <di:waypoint x="870" y="1933" />]''',
'      ,q''[        <di:waypoint x="904" y="1933" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0ujbmek_di" bpmnElement="Association_0ujbmek">]''',
'      ,q''[        <di:waypoint x="1868" y="1935" />]''',
'      ,q''[        <di:waypoint x="1950" y="1995" />]''',
'      ,q''[        <di:waypoint x="2050" y="1995" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1lgk5q3_di" bpmnElement="Association_1lgk5q3">]''',
'      ,q''[        <di:waypoint x="1259" y="1973" />]''',
'      ,q''[        <di:waypoint x="1220" y="2045" />]''',
'      ,q''[        <di:waypoint x="1280" y="2033" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1nzqkt7_di" bpmnElement="TextAnnotation_1nzqkt7">]''',
'      ,q''[        <dc:Bounds x="1630" y="575" width="132" height="75" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0ig39o8_di" bpmnElement="TextAnnotation_0ig39o8">]''',
'      ,q''[        <dc:Bounds x="820" y="236" width="140" height="54" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1n3sri5_di" bpmnElement="TextAnnotation_1n3sri5">]''',
'      ,q''[        <dc:Bounds x="1260" y="450" width="100" height="68" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1az2cby_di" bpmnElement="TextAnnotation_1az2cby">]''',
'      ,q''[        <dc:Bounds x="1710" y="440" width="100" height="68" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Group_0idyabq_di" bpmnElement="Group_0idyabq">]''',
'      ,q''[        <dc:Bounds x="410" y="1625" width="1540" height="150" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0gjv3vu_di" bpmnElement="TextAnnotation_0gjv3vu">]''',
'      ,q''[        <dc:Bounds x="230" y="1685" width="200" height="60" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_19s4sic_di" bpmnElement="TextAnnotation_19s4sic">]''',
'      ,q''[        <dc:Bounds x="2050" y="1980" width="260" height="45" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0tnvzhx_di" bpmnElement="TextAnnotation_0tnvzhx">]''',
'      ,q''[        <dc:Bounds x="1280" y="1990" width="170" height="67" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_14n3ji1_di" bpmnElement="TextAnnotation_14n3ji1">]''',
'      ,q''[        <dc:Bounds x="2060" y="1830" width="190" height="70" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0e04jqy_di" bpmnElement="TextAnnotation_0e04jqy">]''',
'      ,q''[        <dc:Bounds x="310" y="1830" width="219.99613444010416" height="164.924506387921" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_036ykn1_di" bpmnElement="Association_036ykn1">]''',
'      ,q''[        <di:waypoint x="410" y="1690" />]''',
'      ,q''[        <di:waypoint x="330" y="1660" />]''',
'      ,q''[        <di:waypoint x="330" y="1685" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_04tzkyw_di" bpmnElement="Association_04tzkyw">]''',
'      ,q''[        <di:waypoint x="2060" y="1865" />]''',
'      ,q''[        <di:waypoint x="2010" y="1865" />]''',
'      ,q''[        <di:waypoint x="1945" y="1775" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_15hbzbw_di" bpmnElement="Flow_15hbzbw">]''',
'      ,q''[        <di:waypoint x="710" y="1600" />]''',
'      ,q''[        <di:waypoint x="710" y="1915" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_07eem0o_di" bpmnElement="Flow_07eem0o">]''',
'      ,q''[        <di:waypoint x="922" y="1915" />]''',
'      ,q''[        <di:waypoint x="922" y="1758" />]''',
'      ,q''[        <di:waypoint x="870" y="1758" />]''',
'      ,q''[        <di:waypoint x="870" y="1600" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0995mzn_di" bpmnElement="Flow_0995mzn">]''',
'      ,q''[        <di:waypoint x="1098" y="1573" />]''',
'      ,q''[        <di:waypoint x="1098" y="1727" />]''',
'      ,q''[        <di:waypoint x="1020" y="1727" />]''',
'      ,q''[        <di:waypoint x="1020" y="1875" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ggij67_di" bpmnElement="Flow_0ggij67">]''',
'      ,q''[        <di:waypoint x="1560" y="1578" />]''',
'      ,q''[        <di:waypoint x="1560" y="1725" />]''',
'      ,q''[        <di:waypoint x="1280" y="1725" />]''',
'      ,q''[        <di:waypoint x="1280" y="1875" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_17etfk6_di" bpmnElement="Flow_17etfk6">]''',
'      ,q''[        <di:waypoint x="1230" y="1903" />]''',
'      ,q''[        <di:waypoint x="1230" y="1578" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1179" y="1737" width="79" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0nj0983_di" bpmnElement="Flow_0nj0983">]''',
'      ,q''[        <di:waypoint x="1850" y="1915" />]''',
'      ,q''[        <di:waypoint x="1850" y="1578" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram>]''',
'      ,q''[    <bpmndi:BPMNPlane bpmnElement="Activity_subProcF2A">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0xhv1o8_di" bpmnElement="Event_F2AStart">]''',
'      ,q''[        <dc:Bounds x="180" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="776" y="870" width="47" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1foixjn_di" bpmnElement="Activity_F2ATask">]''',
'      ,q''[        <dc:Bounds x="268" y="160" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_07batcd_di" bpmnElement="Event_EndF2A">]''',
'      ,q''[        <dc:Bounds x="552" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1152" y="845" width="40" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1jlj56u_di" bpmnElement="Activity_F2BTask">]''',
'      ,q''[        <dc:Bounds x="410" y="160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0x0i35d_di" bpmnElement="Flow_0x0i35d">]''',
'      ,q''[        <di:waypoint x="216" y="200" />]''',
'      ,q''[        <di:waypoint x="268" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1oedyea_di" bpmnElement="Flow_1oedyea">]''',
'      ,q''[        <di:waypoint x="368" y="200" />]''',
'      ,q''[        <di:waypoint x="410" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1f2gbzn_di" bpmnElement="Flow_1f2gbzn">]''',
'      ,q''[        <di:waypoint x="510" y="200" />]''',
'      ,q''[        <di:waypoint x="552" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1rxzzpz">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0ox67si" bpmnElement="Activity_1ewbvrh">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1wmv0td_di" bpmnElement="Event_1wmv0td">]''',
'      ,q''[        <dc:Bounds x="-758" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-783" y="-95" width="86" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_15l1gh7_di" bpmnElement="Activity_Par_Task_Iter">]''',
'      ,q''[        <dc:Bounds x="-670" y="-160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_05rpt4x_di" bpmnElement="Activity_Seq_Iter_Task">]''',
'      ,q''[        <dc:Bounds x="-510" y="-160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0a24dav_di" bpmnElement="Activity_0a24dav">]''',
'      ,q''[        <dc:Bounds x="-350" y="-160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1inc9ya_di" bpmnElement="Event_1a84d7n">]''',
'      ,q''[        <dc:Bounds x="-188" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-204" y="-95" width="68" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_069t8tz_di" bpmnElement="TextAnnotation_069t8tz">]''',
'      ,q''[        <dc:Bounds x="-720" y="-300" width="100" height="96" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0y99afk_di" bpmnElement="Flow_0y99afk">]''',
'      ,q''[        <di:waypoint x="-722" y="-120" />]''',
'      ,q''[        <di:waypoint x="-670" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_15ns9rr_di" bpmnElement="Flow_15ns9rr">]''',
'      ,q''[        <di:waypoint x="-570" y="-120" />]''',
'      ,q''[        <di:waypoint x="-510" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0negvt3_di" bpmnElement="Flow_0negvt3">]''',
'      ,q''[        <di:waypoint x="-410" y="-120" />]''',
'      ,q''[        <di:waypoint x="-350" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1swygly_di" bpmnElement="Flow_1swygly">]''',
'      ,q''[        <di:waypoint x="-250" y="-120" />]''',
'      ,q''[        <di:waypoint x="-188" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1w3b1po_di" bpmnElement="Association_1w3b1po">]''',
'      ,q''[        <di:waypoint x="-733" y="-136" />]''',
'      ,q''[        <di:waypoint x="-704" y="-204" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1grrrcr">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_09k4dqd" bpmnElement="Activity_Par_Iter_SubProc">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0lsyvlo_di" bpmnElement="Event_0lsyvlo">]''',
'      ,q''[        <dc:Bounds x="-528" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-553" y="-95" width="86" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1bpy6hr_di" bpmnElement="Activity_1bpy6hr">]''',
'      ,q''[        <dc:Bounds x="-440" y="-160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1s5ht1k_di" bpmnElement="Event_1s5ht1k">]''',
'      ,q''[        <dc:Bounds x="-288" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-312" y="-95" width="85" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1yl313z_di" bpmnElement="Flow_1yl313z">]''',
'      ,q''[        <di:waypoint x="-492" y="-120" />]''',
'      ,q''[        <di:waypoint x="-440" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_16k0o3u_di" bpmnElement="Flow_16k0o3u">]''',
'      ,q''[        <di:waypoint x="-340" y="-120" />]''',
'      ,q''[        <di:waypoint x="-288" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1g0tpgc">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0lz69gr" bpmnElement="Activity_Seq_Iter_Sub_Proc">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1tnbl7q_di" bpmnElement="Event_1tnbl7q">]''',
'      ,q''[        <dc:Bounds x="-638" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-649" y="-95" width="58" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_16p5k1p_di" bpmnElement="Activity_16p5k1p">]''',
'      ,q''[        <dc:Bounds x="-550" y="-160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1jrxbq5_di" bpmnElement="Event_1jrxbq5">]''',
'      ,q''[        <dc:Bounds x="-398" y="-138" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-407" y="-95" width="54" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1fzr640_di" bpmnElement="Flow_1fzr640">]''',
'      ,q''[        <di:waypoint x="-602" y="-120" />]''',
'      ,q''[        <di:waypoint x="-550" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0frevmc_di" bpmnElement="Flow_0frevmc">]''',
'      ,q''[        <di:waypoint x="-450" y="-120" />]''',
'      ,q''[        <di:waypoint x="-398" y="-120" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1kbtnu3">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_0jcopnf" bpmnElement="Activity_Loop_sub_proc">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1ddjsgw_di" bpmnElement="Event_LoopStart">]''',
'      ,q''[        <dc:Bounds x="-668" y="-98" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-674" y="-55" width="48" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0qtxf43_di" bpmnElement="Activity_LoopTask">]''',
'      ,q''[        <dc:Bounds x="-580" y="-120" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0bmvfpx_di" bpmnElement="Event_LoopEnd">]''',
'      ,q''[        <dc:Bounds x="-428" y="-98" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="-432" y="-55" width="45" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0y0u2mk_di" bpmnElement="Flow_0y0u2mk">]''',
'      ,q''[        <di:waypoint x="-632" y="-80" />]''',
'      ,q''[        <di:waypoint x="-580" y="-80" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1gn7ey5_di" bpmnElement="Flow_1gn7ey5">]''',
'      ,q''[        <di:waypoint x="-480" y="-80" />]''',
'      ,q''[        <di:waypoint x="-428" y="-80" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 8a - The Full Monty (the top half!)'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
'',
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bioc="http://bpmn.io/schema/bpmn/biocolor/1.0" xmlns:color="http://www.omg.org/spec/BPMN/non-normative/color/1.0" id="Definitions_1wzb475" targetNamespace="http:'
||'//bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_Tutorial8c" name="Tutorial 8c Configuring Background Session Info." isExecutable="false" apex:isCallable="false" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_0azvr6s">]''',
'      ,q''[      <bpmn:outgoing>Flow_1pbkya4</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:task id="Activity_13a72nr" name="A&#10;What is Background Session Configuration?">]''',
'      ,q''[      <bpmn:incoming>Flow_1pbkya4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0f3f33h</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1pbkya4" sourceRef="Event_0azvr6s" targetRef="Activity_13a72nr" />]''',
'      ,q''[    <bpmn:task id="Activity_1dbvyye">]''',
'      ,q''[      <bpmn:incoming>Flow_0f3f33h</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_08rm783</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0f3f33h" sourceRef="Activity_13a72nr" targetRef="Activity_1dbvyye" />]''',
'      ,q''[    <bpmn:task id="Activity_0hd37ul" name="B:&#10;General Rules">]''',
'      ,q''[      <bpmn:incoming>Flow_08rm783</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0e6jmr0</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08rm783" sourceRef="Activity_1dbvyye" targetRef="Activity_0hd37ul" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_0408kh3" name="Object Configs exist?">]''',
'      ,q''[      <bpmn:incoming>Flow_0e6jmr0</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_101nook</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1dby9g9</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0e6jmr0" sourceRef="Activity_0hd37ul" targetRef="Gateway_0408kh3" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_1pi1ivj" name="Process (Diagram) level Configs Exist?">]''',
'      ,q''[      <bpmn:incoming>Flow_101nook</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_08uig3a</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1mtbcgj</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_101nook" sourceRef="Gateway_0408kh3" targetRef="Gateway_1pi1ivj" apex:sequence="10" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_0h7d4f3" name="System Defaults Exist?">]''',
'      ,q''[      <bpmn:incoming>Flow_08uig3a</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_168zmuv</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_0tmn4zn</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_08uig3a" sourceRef="Gateway_1pi1ivj" targetRef="Gateway_0h7d4f3" apex:sequence="10" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_168zmuv" sourceRef="Gateway_0h7d4f3" targetRef="Event_1pvxays" apex:sequence="10" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1pvxays">]''',
'      ,q''[      <bpmn:incoming>Flow_168zmuv</bpmn:incoming>]''',
'      ,q''[      <bpmn:errorEventDefinition id="ErrorEventDefinition_081aaqh" />]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:task id="Activity_16017fe" name="Use Them">]''',
'      ,q''[      <bpmn:incoming>Flow_1mtbcgj</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ohelsh</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1mtbcgj" sourceRef="Gateway_1pi1ivj" targetRef="Activity_16017fe" apex:sequence="20" />]''',
'      ,q''[    <bpmn:task id="Activity_0ft0taj" name="Use them!">]''',
'      ,q''[      <bpmn:incoming>Flow_1dby9g9</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_05f1t7n</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1dby9g9" sourceRef="Gateway_0408kh3" targetRef="Activity_0ft0taj" apex:sequence="20" />]''',
'      ,q''[    <bpmn:task id="Activity_1x1pob2" name="Use Them">]''',
'      ,q''[      <bpmn:incoming>Flow_0tmn4zn</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0a0c6c3</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0tmn4zn" sourceRef="Gateway_0h7d4f3" targetRef="Activity_1x1pob2" apex:sequence="20" />]''',
'      ,q''[    <bpmn:exclusiveGateway id="Gateway_041nvwb">]''',
'      ,q''[      <bpmn:incoming>Flow_05f1t7n</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0ohelsh</bpmn:incoming>]''',
'      ,q''[      <bpmn:incoming>Flow_0a0c6c3</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0rb49i4</bpmn:outgoing>]''',
'      ,q''[    </bpmn:exclusiveGateway>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_05f1t7n" sourceRef="Activity_0ft0taj" targetRef="Gateway_041nvwb" />]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ohelsh" sourceRef="Activity_16017fe" targetRef="Gateway_041nvwb" '))
);
null;
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(10374182853489453)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0a0c6c3" sourceRef="Activity_1x1pob2" targetRef="Gateway_041nvwb" />]''',
'      ,q''[    <bpmn:task id="Activity_09djncc" name="C:&#10;Setting Them...">]''',
'      ,q''[      <bpmn:incoming>Flow_0rb49i4</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_0ecpkxy</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1doqhpb</bpmn:outgoing>]''',
'      ,q''[      <bpmn:outgoing>Flow_1v5txna</bpmn:outgoing>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0rb49i4" sourceRef="Gateway_041nvwb" targetRef="Activity_09djncc" apex:sequence="10" />]''',
'      ,q''[    <bpmn:task id="Activity_0i579u9" name="Process Variables">]''',
'      ,q''[      <bpmn:incoming>Flow_0ecpkxy</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_0ecpkxy" sourceRef="Activity_09djncc" targetRef="Activity_0i579u9" />]''',
unistr('      ,q''[    <bpmn:task id="Activity_0mjj8b3" name="Process object\00A0&#10;in&#10;Process Diagrams">]'''),
'      ,q''[      <bpmn:incoming>Flow_1doqhpb</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1doqhpb" sourceRef="Activity_09djncc" targetRef="Activity_0mjj8b3" />]''',
'      ,q''[    <bpmn:task id="Activity_0fr1c0z" name="System Configuration Parameters">]''',
'      ,q''[      <bpmn:incoming>Flow_1v5txna</bpmn:incoming>]''',
'      ,q''[    </bpmn:task>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1v5txna" sourceRef="Activity_09djncc" targetRef="Activity_0fr1c0z" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0gf319s">]''',
'      ,q''[      <bpmn:text>Tutorial 8c - Advanced Topics - Session Parameters]''',
'      ,q''[]''',
'      ,q''[Many steps in your workflow will be started by a user, from an APEX Session -- because the application that they are running starts a process instance, executes a user Task, or causes subsequent steps to occur after a step that they started'
||unistr('. \00A0Any steps like this use the APEX Session from the user.]'''),
'      ,q''[]''',
unistr('      ,q''[However, some steps are executed from outside APEX. \00A0 For example, if the step executes as the result of a timer firing, there was no APEX Session. \00A0Some features of Flows for APEX use APEX features tat require an APEX Session - such as exe')
||'cuting variable expressions based on a pl/sql expression or function body, or evaluating gateway routing expressions.]''',
'      ,q''[]''',
'      ,q''[Flows for APEX now uses session configuration information to create an APEX session when the user is not accessing Flows for APEX from an APEX Application.]''',
'      ,q''[]''',
'      ,q''[We are not storing passwords or user credentials (don''t panic!) - but APEX does need a username, an application id, and a page id to create a APEX Session.]''',
'      ,q''[]''',
'      ,q''[This tutorial shows how you specify these, and other issues.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1h3277z" sourceRef="Activity_13a72nr" targetRef="TextAnnotation_0gf319s" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1s4fcmh">]''',
'      ,q''[      <bpmn:text>For a Timer, you can give Flows for APEX session configuration information for a specific timer by creating process variables before the timer starts.]''',
'      ,q''[]''',
unistr('      ,q''[You do this by creating / setting 3 process variables BEFORE the timer starts: These are based on the bpmn_id of the timer: \00A0 Let''s assume for this that our timer has a BPMN ID of ''Timer_1ar3df''. \00A0The variables would be:]'''),
'      ,q''[- Timer_1ar3df:applicationId - set to the application ID you want to use]''',
'      ,q''[- Timer_1ar3df:pageId - set to the page ID of a page in the app]''',
'      ,q''[- Timer_1ar3df:username - set to the username of the user.]''',
'      ,q''[]''',
'      ,q''[These could be set in your application, maybe using variable expressions before the timer starts.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_01q6512" sourceRef="Activity_0ft0taj" targetRef="TextAnnotation_1s4fcmh" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_1a1kyv3">]''',
unistr('      ,q''[      <bpmn:text>If Flows for APEX can''t find these process variables contains valid content, it looks to see if process-level default values were created as part of the diagram information. \00A0These would be stored in the Property Panel &gt;')
||' General Tab &gt; Background Task Session on the Process object of your diagram.</bpmn:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_0yzpwh1" sourceRef="Activity_16017fe" targetRef="TextAnnotation_1a1kyv3" />]''',
'      ,q''[    <bpmn:textAnnotation id="TextAnnotation_0enm3v8">]''',
'      ,q''[      <bpmn:text>And if Flows for APEX still can''t find them after looking at the process variables and at process-level, it looks to see if system-wide configuration defaults have been specified.]''',
'      ,q''[]''',
unistr('      ,q''[These are added in the Flows for APEX Application (probably the app that you are using to read this!) -- See the ''Configuration'' button in the top right hand page menu. \00A0]'''),
'      ,q''[]''',
unistr('      ,q''[You can specify default values here -- which you might want to do in your test and development environment only, \00A0On your secure, production installation you might want to leave these not configured, which will cause an error to occur.</bpm')
||'n:text>]''',
'      ,q''[    </bpmn:textAnnotation>]''',
'      ,q''[    <bpmn:association id="Association_1fapr8o" sourceRef="Activity_1x1pob2" targetRef="TextAnnotation_0enm3v8" />]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_Tutorial8c">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0azvr6s_di" bpmnElement="Event_0azvr6s">]''',
'      ,q''[        <dc:Bounds x="432" y="532" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_13a72nr_di" bpmnElement="Activity_13a72nr" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="520" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1dbvyye_di" bpmnElement="Activity_1dbvyye" bioc:stroke="#6b3c00" bioc:fill="#ffe0b2" color:background-color="#ffe0b2" color:border-color="#6b3c00">]''',
'      ,q''[        <dc:Bounds x="680" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0hd37ul_di" bpmnElement="Activity_0hd37ul" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="890" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0408kh3_di" bpmnElement="Gateway_0408kh3" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1155" y="435" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1094" y="416" width="73" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_1pi1ivj_di" bpmnElement="Gateway_1pi1ivj" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1155" y="595" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1082" y="580" width="75" height="40" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_0h7d4f3_di" bpmnElement="Gateway_0h7d4f3" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1155" y="755" width="50" height="50" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="1090" y="736" width="81" height="27" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_0df2rf6_di" bpmnElement="Event_1pvxays">]''',
'      ,q''[        <dc:Bounds x="1162" y="862" width="36" height="36" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_16017fe_di" bpmnElement="Activity_16017fe" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1260" y="580" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0ft0taj_di" bpmnElement="Activity_0ft0taj" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1260" y="420" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_1x1pob2_di" bpmnElement="Activity_1x1pob2" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1260" y="740" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Gateway_041nvwb_di" bpmnElement="Gateway_041nvwb" isMarkerVisible="true" bioc:stroke="#831311" bioc:fill="#ffcdd2" color:background-color="#ffcdd2" color:border-color="#831311">]''',
'      ,q''[        <dc:Bounds x="1525" y="525" width="50" height="50" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_09djncc_di" bpmnElement="Activity_09djncc" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1730" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0i579u9_di" bpmnElement="Activity_0i579u9" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1890" y="340" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0mjj8b3_di" bpmnElement="Activity_0mjj8b3" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1890" y="510" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_0fr1c0z_di" bpmnElement="Activity_0fr1c0z" bioc:stroke="#5b176d" bioc:fill="#e1bee7" color:background-color="#e1bee7" color:border-color="#5b176d">]''',
'      ,q''[        <dc:Bounds x="1890" y="690" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0gf319s_di" bpmnElement="TextAnnotation_0gf319s">]''',
'      ,q''[        <dc:Bounds x="560" y="90" width="511.9668884277344" height="279.9999694824219" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1s4fcmh_di" bpmnElement="TextAnnotation_1s4fcmh">]''',
'      ,q''[        <dc:Bounds x="1310" y="120" width="499.9999694824219" height="180.9926300048828" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_1a1kyv3_di" bpmnElement="TextAnnotation_1a1kyv3">]''',
'      ,q''[        <dc:Bounds x="1550" y="820" width="395.9742431640625" height="81.98529052734375" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="TextAnnotation_0enm3v8_di" bpmnElement="TextAnnotation_0enm3v8">]''',
'      ,q''[        <dc:Bounds x="1480" y="960" width="409.9815979003906" height="180.97425842285156" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1pbkya4_di" bpmnElement="Flow_1pbkya4">]''',
'      ,q''[        <di:waypoint x="468" y="550" />]''',
'      ,q''[        <di:waypoint x="520" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0f3f33h_di" bpmnElement="Flow_0f3f33h">]''',
'      ,q''[        <di:waypoint x="620" y="550" />]''',
'      ,q''[        <di:waypoint x="680" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08rm783_di" bpmnElement="Flow_08rm783">]''',
'      ,q''[        <di:waypoint x="780" y="550" />]''',
'      ,q''[        <di:waypoint x="890" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0e6jmr0_di" bpmnElement="Flow_0e6jmr0">]''',
'      ,q''[        <di:waypoint x="990" y="550" />]''',
'      ,q''[        <di:waypoint x="1090" y="550" />]''',
'      ,q''[        <di:waypoint x="1090" y="460" />]''',
'      ,q''[        <di:waypoint x="1155" y="460" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_101nook_di" bpmnElement="Flow_101nook">]''',
'      ,q''[        <di:waypoint x="1180" y="485" />]''',
'      ,q''[        <di:waypoint x="1180" y="595" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_08uig3a_di" bpmnElement="Flow_08uig3a">]''',
'      ,q''[        <di:waypoint x="1180" y="645" />]''',
'      ,q''[        <di:waypoint x="1180" y="755" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_168zmuv_di" bpmnElement="Flow_168zmuv">]''',
'      ,q''[        <di:waypoint x="1180" y="805" />]''',
'      ,q''[        <di:waypoint x="1180" y="862" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1mtbcgj_di" bpmnElement="Flow_1mtbcgj">]''',
'      ,q''[        <di:waypoint x="1205" y="620" />]''',
'      ,q''[        <di:waypoint x="1260" y="620" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1dby9g9_di" bpmnElement="Flow_1dby9g9">]''',
'      ,q''[        <di:waypoint x="1205" y="460" />]''',
'      ,q''[        <di:waypoint x="1260" y="460" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0tmn4zn_di" bpmnElement="Flow_0tmn4zn">]''',
'      ,q''[        <di:waypoint x="1205" y="780" />]''',
'      ,q''[        <di:waypoint x="1260" y="780" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_05f1t7n_di" bpmnElement="Flow_05f1t7n">]''',
'      ,q''[        <di:waypoint x="1360" y="460" />]''',
'      ,q''[        <di:waypoint x="1470" y="460" />]''',
'      ,q''[        <di:waypoint x="1470" y="550" />]''',
'      ,q''[        <di:waypoint x="1525" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ohelsh_di" bpmnElement="Flow_0ohelsh">]''',
'      ,q''[        <di:waypoint x="1360" y="620" />]''',
'      ,q''[        <di:waypoint x="1470" y="620" />]''',
'      ,q''[        <di:waypoint x="1470" y="550" />]''',
'      ,q''[        <di:waypoint x="1525" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0a0c6c3_di" bpmnElement="Flow_0a0c6c3">]''',
'      ,q''[        <di:waypoint x="1360" y="780" />]''',
'      ,q''[        <di:waypoint x="1470" y="780" />]''',
'      ,q''[        <di:waypoint x="1470" y="550" />]''',
'      ,q''[        <di:waypoint x="1525" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0rb49i4_di" bpmnElement="Flow_0rb49i4">]''',
'      ,q''[        <di:waypoint x="1575" y="550" />]''',
'      ,q''[        <di:waypoint x="1730" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_0ecpkxy_di" bpmnElement="Flow_0ecpkxy">]''',
'      ,q''[        <di:waypoint x="1830" y="550" />]''',
'      ,q''[        <di:waypoint x="1860" y="550" />]''',
'      ,q''[        <di:waypoint x="1860" y="380" />]''',
'      ,q''[        <di:waypoint x="1890" y="380" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1doqhpb_di" bpmnElement="Flow_1doqhpb">]''',
'      ,q''[        <di:waypoint x="1830" y="550" />]''',
'      ,q''[        <di:waypoint x="1890" y="550" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1v5txna_di" bpmnElement="Flow_1v5txna">]''',
'      ,q''[        <di:waypoint x="1830" y="550" />]''',
'      ,q''[        <di:waypoint x="1860" y="550" />]''',
'      ,q''[        <di:waypoint x="1860" y="730" />]''',
'      ,q''[        <di:waypoint x="1890" y="730" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1h3277z_di" bpmnElement="Association_1h3277z">]''',
'      ,q''[        <di:waypoint x="574" y="510" />]''',
'      ,q''[        <di:waypoint x="586" y="370" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_01q6512_di" bpmnElement="Association_01q6512">]''',
'      ,q''[        <di:waypoint x="1316" y="420" />]''',
'      ,q''[        <di:waypoint x="1334" y="301" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_0yzpwh1_di" bpmnElement="Association_0yzpwh1">]''',
'      ,q''[        <di:waypoint x="1360" y="640" />]''',
'      ,q''[        <di:waypoint x="1510" y="700" />]''',
'      ,q''[        <di:waypoint x="1510" y="835" />]''',
'      ,q''[        <di:waypoint x="1550" y="835" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Association_1fapr8o_di" bpmnElement="Association_1fapr8o">]''',
'      ,q''[        <di:waypoint x="1354" y="819" />]''',
'      ,q''[        <di:waypoint x="1513" y="960" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Tutorial 8c - Background Session Configuration'',',
'    pi_dgrm_version => ''24.1'',',
'    pi_dgrm_category => ''Tutorials'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/',
''))
);
null;
end;
/
prompt --application/deployment/install/install_configuration
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10374248587492709)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Configuration'
,p_sequence=>60
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'PROMPT >> Inital System Configuration for new systems',
'begin',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_level''                                 ,p_value => ''standard'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_hide_userid''                           ,p_value => ''false'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_language''                              ,p_value => ''en'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_retain_logs_after_prcs_completion_days'',p_value => ''60'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_archive_instance_summaries''            ,p_value => ''false'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_received_message_flow''                 ,p_value => ''true'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_retain_message_flow_days''              ,p_value => ''5'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''stats_retain_daily_summaries_days''             ,p_value => ''185'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''stats_retain_monthly_summaries_months''         ,p_value => ''9'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''stats_retain_quarterly_summaries_months''       ,p_value => ''60'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''engine_app_mode''                               ,p_value => ''production'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''duplicate_step_prevention''                     ,p_value => ''strict'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''version_initial_installed''                     ,p_value => ''24.1'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''version_now_installed''                         ,p_value => ''24.1'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''default_workspace''                             ,p_value => ''FLOWS4APEX'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''default_application''                           ,p_value => ''100'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''default_pageid''                                ,p_value => ''1'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''default_username''                              ,p_value => ''FLOWS4APEX'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''default_email_sender''                          ,p_value => '''');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''timer_max_cycles''                              ,p_value => ''1000'');',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''parser_log_enabled''                            ,p_value => ''false'' );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_rest_incoming_calls''                   ,p_value => ''Y'' );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_rest_incoming_calls_retain_days''       ,p_value => ''60'' );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''rest_base''                                     ,p_value => null );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_archive_location''                      ,p_value => null );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''logging_bpmn_location''                         ,p_value => null );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''license_edition''                               ,p_value => ''community'' );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''license_key''                                   ,p_value => '''' );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''licensed_to''                                   ,p_value => '''' );',
'  flow_admin_api.set_config_value ( p_update_if_set => false, p_config_key => ''license_expiry_date''                           ,p_value => '''' );',
'',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_german
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15943830418133179)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - German'
,p_sequence=>70
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_de.sql',
'--',
'-- Engine Messages for language code "de"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "de"',
'declare',
'  c_load_lang constant varchar2(10) := ''de'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[Einstellungen k\00F6nnen keine Prozessvariable ohne Prozess-ID angeben.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[Sie haben versucht, ein Diagramm mit ausgef\00FChrten Instanzen zu archivieren.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-diagram-event'', c_load_lang, q''[Flows - Interner Fehler beim Protokollieren eines Diagrammereignisses.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[Fehler beim Archivieren der Instanz\00FCbersicht f\00FCr Prozessinstanz %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[Nachrichtenempf\00E4nger kann Subflow nicht sperren. Versuchen Sie es erneut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[Fehler beim Auswerten der Einstellung. Ausdruck ist ung\00FCltig. Ausdruck: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[Der angegebene MessageFlow-Endpunkt ( %0 ) wird nicht unterst\00FCtzt.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[Nachrichtenabonnement wurde von einem anderen Benutzer gesperrt. Versuchen Sie es erneut.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[Fehler beim Erstellen der Genehmigungsaufgabe - Gesch\00E4ftsreferenz/Prim\00E4rschl\00FCssel des Datensatzsystems darf nicht Null sein.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[Fehler beim Auswerten des F\00E4lligkeitsdatums. Intervallausdruck ist ung\00FCltig. Intervall: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[Fehler beim Auswerten des F\00E4lligkeitsdatums.  Ausdruck f\00FCr F\00E4lligkeitsdatum ist ung\00FCltig.  Intervallausdruck: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[Fehler beim Auswerten der Priorit\00E4t. Priorit\00E4tsausdruck ist ung\00FCltig. Ausdruck: %0. Stattdessen wird die Priorit\00E4t 3 verwendet.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[Ung\00FCltiger Geltungsbereich (%0) f\00FCr Prozessvariable angegeben.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[Timer-Wiederholungsintervall zu h\00E4ufig f\00FCr Host (%0) Angefordertes Intervall %1. muss gr\00F6\00DFer als 1 Minute sein.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''archive-destination-bad-json'', c_load_lang, q''[Fehler im Konfigurationsparameter des Archivierungsziels. Parameter: %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[Die empfangene Nachricht stimmt mit keiner erwarteten Nachricht \00FCberein.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[Empfangende Nachricht f\00FCr Prozessschritt ist bereits aufgetreten (falscher Step-Key angegeben).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[F\00FCr die Verarbeitung dieses Features ist die Lizenzierung von Flows for APEX Enterprise Edition erforderlich.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[Interner Fehler beim Verarbeiten der Iterationsschlie\00DFung bei Subflow %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[Fehler beim Festlegen der Prozessvariablen %1 in Prozess-ID %0 (Set %2).  Abfrage gibt mehr als einen Wert zur\00FCck.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[Fehler beim Festlegen der Prozessvariable %1: Ung\00FCltiges JSON-Format (Subflow: %0, Set: %3)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[Fehler beim Sperren der Iterationsdetails (Iteration %0 Schleife %2) f\00FCr Prozess-ID %1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[Start Zeit-Aufnahme nicht erfolgreich. Subflow %0 in Prozess %1 konnte nicht gefunden werden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[Dieser Prozessschritt wurde bereits aufgerufen. (Ung\00FCltiger Schritt %0 angegeben, w\00E4hrend Schritt %1 erwartet wurde).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''subProcess-no-start'', c_load_lang, q''[Teil-Prozess Startereignis kann nicht gefunden werden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''subProcess-too-many-starts'', c_load_lang, q''[Mehr als ein Teil-Prozess Start gefunden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-broken'', c_load_lang, q''[Timer %0 Ausf\00FChrung %4 fehlerhaft in Prozess %1, Subflow: %2. Weitere Informationen in error_info]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[Zyklus-Timer f\00FCr Objekt %0 wird aktuell nicht unterst\00FCtzt.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[Unvollst\00E4ndige Timerdefinition f\00FCr Objekt %0. Typ: %1; Wert1: %2 Wert2: %3  Wert3: %4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[Timer f\00FCr Subflow %0 aktuell von einem anderen Benutzer gesperrt. Bitte versuchen sie es sp\00E4ter erneut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[Timer f\00FCr Prozess %0 wird aktuell von einem anderen Benutzer blockiert. Bitte versuchen sie es sp\00E4ter erneut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[Fehler beim erstellen der Prozessvariable %0 f\00FCr Prozess %1 in Bereich %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[Fehler beim Abrufen der Prozessvariablen %0 f\00FCr Prozess-ID %1 in Geltungsbereich %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[Fehler beim setzen der Prozessvariable %0 f\00FCr Prozess %1 in Bereich %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[Fehler beim l\00F6schen der Prozessvariable %0 f\00FCr Prozess %1 in Bereich %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[Fehler beim sperren der Prozessvariable %0 f\00FCr Prozess %1 in Bereich %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[Fehler beim setzen der Prozessvariable. Falscher Datentyp f\00FCr Variable %0. Der SQL Fehler wird in der Debug-Ausgabe angezeigt]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[Fehler beim setzen der Prozessvariable %1: Ung\00FCltiges Datumsformat (Teilfluss: %0, Set: %3.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[Interner Fehler bei Abfrage von Objekt %0 in Prozess-Ausdr\00FCcken. SQL Fehler in Debug-Output ersichtlich.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[Subflow: %0 Fehler in Ausdruck %2 f\00FCr Variable : %1]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_no_data'', c_load_lang, q''[Fehler beim setzen von Prozessvariable %1 in Prozess %0 (setze %2). Keine Daten in der Abfrage vorhanden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_other'', c_load_lang, q''[Fehler beim setzen von Prozessvariable %1 in Prozess %0 (setze %2). SQL Fehler in Ereignislog ersichtlich.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[Fehler beim setzen von Prozessvariable %1 in Prozess %0 (setze %2). Abfrage liefert mehrere Zeilen zur\00FCck.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_static_general'', c_load_lang, q''[Fehler beim setzen vonProzessvariable %1 in Prozess %0 (setze %2). Fehler in Ereignislog ersichtlich.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[Diagramm-Release oder Entwurf Version 0 nicht gefunden. Bitte spezifizieren sie eine Version oder Diagramm-ID]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[Die angegebene Diagrammversion wurde nicht gefunden.  Bitte \00FCberpr\00FCfen Sie die Versionsangabe.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer_definition_error'', c_load_lang, q''[Fehler beim parsen der Timerdefinition in Prozess %0, Subflow %1. Timertyp: %2, Definition: %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-model-no-version'', c_load_lang, q''[Version nicht definiert]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[Fehler w\00E4hrend des Parse-Vorgangs der Prozess-Variablen.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[Gateway ist nicht f\00FCr Routing definiert.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[Gateway Definition f\00FCr diesen Flow nicht definiert]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[Flow-Instanz-ID oder Subflow-ID k\00F6nnen nicht abgerufen werden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[Falsche Anzahl von APEX-Element(en) oder Prozessvariable(n).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[Eine oder mehrere Prozessvariable(n) besitzen nicht den selben, im JSON definierten Typ.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 ist keine g\00FCltige Zahl.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 ist kein g\00FCltiges Datum.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-invalid-json'', c_load_lang, q''[Kein valides JSON.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[Keine Daten gefunden. Bitte \00FCberpr\00FCfen sie ob ein Diagramm mit dieser ID existiert.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-unexpected-error'', c_load_lang, q''[Unerwarteter Fehler, bitte kontaktieren sie ihren Administrator.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-object-not-found'', c_load_lang, q''[Objekt mit Timer nicht in get_timer_definition gefunden. Subflow %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[Diagram kann nicht geparst werden.<br />Bitte \00FCberpr\00FCfen sie ob ihr Diagram unterst\00FCtzt wird.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[\00C4nderungen gespeichert!]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[Modell wurde ge\00E4ndert. \00C4nderungen verwerfen?]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''wrong-default-workspace'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen: der konfigurierte Standard-Workspace ist nicht valide.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen: Der, zu der Applikations-ID, zugewiesene Workspace konnte nicht gefunden werden. Bitte \00FCberpr\00FCfen sie das Modell]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen: Attribut "Von" und "Standard Email Absender" nicht definiert. Bitte \00FCberpr\00FCfen sie das model und/oder die Konfigurations-Parameter.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen: Attribut "An" nicht definiert. Bitte \00FCberpr\00FCfen sie das Modell.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen: Attribut "Vorlage" nicht definiert. Bitte \00FCberpr\00FCfen sie das Modell.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen: Attribut "Text" nicht definiert. Bitte \00FCberpr\00FCfen sie das Modell.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[Prozess %0: Aufgabe %1 fehlgeschlagen. \00DCberpr\00FCfen sie das Fehlerlog und \00FCberpr\00FCfen sie das Modell.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[Prozess %0: Aufgabe %1 Platzhalter JSON ist nicht valide. Bitte \00FCberpr\00FCfen sie das Modell.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-multiple-rows'', c_load_lang, q''[Mehrere Zeilen gefunden. Bitte aktivieren sie die "Enable Call Activities" in den Viewer-Plugin Attributen.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-cancelation-error'', c_load_lang, q''[Fehler beim Versuch, die APEX-Workflowaufgabe (task_id: %1 ) f\00FCr Prozessschritt %0 abzubrechen.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[F\00FCr die Verwendung des APEX-Workflowfeatures ist Oracle APEX v%0 erforderlich.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-found'', c_load_lang, q''[APEX-Workflowaufgabe %0 nicht in Flows for APEX-Prozess gefunden]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[APEX-Workflowaufgabe %0 gefunden, die mehreren Flows for APEX-Prozessschritten zugeordnet ist.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[APEX-Workflowaufgabe %0 ist nicht der aktuelle Schritt des Prozesses. Der Schritt ist m\00F6glicherweise bereits abgeschlossen.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[Ergebnisprozessvariable f\00FCr APEX-Workflowaufgabe ist nicht definiert oder ung\00FCltig.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-creation-error'', c_load_lang, q''[Fehler beim Erstellen der APEX-Workflowaufgabe %0 in Anwendung %1. Weitere Informationen finden Sie im Debugging.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[Fehler beim Auswerten der Priorit\00E4t. Die Priorit\00E4t muss zwischen 1 und 5 liegen. Priorit\00E4t: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[Fehler beim Erstellen der APEX-Session. BPMN-Diagramm enth\00E4lt mehrere Prozessobjekte.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''call-diagram-not-callable'', c_load_lang, q''[Sie haben versucht, ein Diagramm %0 aufzurufen, das als nicht aufrufbar markiert ist.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[Aktuell wird der Typ des ausgel\00F6sten Zwischenereignisses bei %0 nicht unterst\00FCtzt.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[Asynchrone Verbindungs-Details f\00FCr Objekt %0 m\00FCssen in den Prozessvariablen, den Diagramm Async-Verbindungsdetails oder der Systemkonfiguration definiert werden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[Asynchrone Verbindung f\00FCr Objekt %0 kann nicht erstellt werden. Benutzername f\00FCr angegebene Applikation nicht g\00FCltig.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[Asynchrone Verbindung f\00FCr Objekt %0 kann nicht erstellt werden. Der Benutzername muss in einer Prozessvariable, dem Prozessdiagramm oder der Systemkonfiguration angegeben werden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[Asynchrone Verbindung f\00FCr Objekt %0 kann nicht erstellt werden. Applikations-ID muss in einer Prozessvariable, dem Prozessdiagramm oder der Systemkonfiguration angegeben werden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''async-no-pageid'', c_load_lang, q''[Unable to create asyncronous connection for object %0.  Page ID needs to be specified in process variable, the process diagram, or system configuration.',
unistr('Asynchrone Verbindung f\00FCr Objekt %0 kann nicht erstellt werden. Die Seiten-ID muss in einer Prozessvariable, dem Prozessdiagramm oder der Systemkonfiguration angegeben werden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[Kind-Zwischenereignis oder Timer von %0 von einem anderen Benutzer gesperrt. Bitte versuchen sie die Transaktion zu einem sp\00E4teren Zeitpunkt erneut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[Kein Zwischenereignis von Typ %0 gefunden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[Mehr als ein Zwischenereignis %0 f\00FCr Unterprozess gefunden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''eng_handle_event_int'', c_load_lang, q''[Flow Engine Internal Error: Process %0 Subflow %1 Module %2 Current %4 Current Tag %3',
'Flow Engine Interner Fehler: Prozess %0 Subflow %1 Modul %2 Aktuell %4 Aktueller Eintrag %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[Modellfehler: Der n\00E4chste Schritt des BPMN Modells verwendet ein nicht unterst\00FCtztes Objekt %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[Applikationsfehler: Prozess ID %0 nicht gefunden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[Applikationsfehler: Angegebene Subflow-ID ( %0 ) existiert, ist aber kein Kind der angegebenen Prozess ID ( %1 ).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[Angegebene Subflow-ID ( %0 ) nicht gefunden. Bitte \00FCberpr\00FCfen sie Prozess-Ereignisse die Prozess-Abl\00E4ufe \00E4ndern (Timeouts, Fehler, Eskalationen).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[Fehler bei Gateway %0. Angegebene Prozessvariable %1 beinhaltet ung\00FCltigen Pfad: %2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[Interner Fehler bei Zusammenf\00FChrungs-Gateway in Subflow %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-no-route'', c_load_lang, q''[Kein vorgegebener Gateway-Pfad in Variable %0  gefunden. Modell beinhaltet keine Standard-Route.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[Ung\00FCltiger Gateway-Routingausdruck. Dies kann auftreten, wenn Sie versuchen, eine Variable mit einem eingebetteten Doppelpunkt (:) zu binden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[Mehr als eine Standard-Route f\00FCr Gateway %0 in Modell angegeben.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''link-no-catch'', c_load_lang, q''[Zutreffendes Link-Ereignis mit Namen %0 konnte nicht gefunden werden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''link-too-many-catches'', c_load_lang, q''[Mehr als ein zutreffendes Link-Ereignis mit Namen %0 gefunden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-instance-event'', c_load_lang, q''[Flows - Interner Fehler beim protokollieren (log) eines Instanz-Ereignisses.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-step-event'', c_load_lang, q''[Flows - Interner Fehler beim protokollieren (log) eines Schritt-Ereignisses.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-variable-event'', c_load_lang, q''[Flows - Interner Fehler w\00E4hrend der protokollierung (log) eines Variablenereignisses.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[Prozess-Objekt %0 aktuell von einem anderem Benutzer gesperrt. Bitte versuchen sie es sp\00E4ter erneut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[Mehr als ein vorw\00E4rts gerichteter Pfad gefunden (nur ein Pfad erlaubt).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[Kein weiterer Schritt f\00FCr Subflow %0 gefunden. Bitte das Prozess-Diagramm \00FCberpr\00FCfen.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_failed'', c_load_lang, q''[Prozess %0: Aufgabe %1 aufgrund eines PL/SQL Fehlers fehlgeschlagen. Bitte \00FCberpr\00FCfen sie das Ereignis-Log]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[Prozess %0: Aufgabe %1 Ausf\00FChrungsstopp angefordert - Bitte \00FCberpr\00FCfen sie das Ereignis-Log]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[Subflow %0 kann nicht gesperrt werden. Es wird aktuell bereits von einem anderen Benutzer gesperrt. Bitte versuchen sie sp\00E4ter erneut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[Reservierung f\00FCr n\00E4chste Aufgabe f\00FCr sie bereits vorgesehen.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[Reservierung f\00FCr %0 nicht erfolgreich. Der Schritt ist bereits von einem anderen Benutzer reserviert.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[Reservierung f\00FCr %2 nicht erfolgreich. Subflow %0 in Prozess %1  nicht gefunden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[Die Aufgabe ist nicht mehr aktuell und eventuell schon abgeschlossen. Bitte aktualisieren sie ihre Inbox.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[Subflow aktuell von einem anderen Benutzer gesperrt (nicht reserviert). Bitte versuchen die die Reservierung zu einem sp\00E4teren Zeitpunkt noch einmal durchzuf\00FChren.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-release-not-found'', c_load_lang, q''[Reservierung konnte nicht erfolgreich freigegeben werden. Subflow %0 in Prozess %1 nicht gefunden.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[Keine aktuellen Fehler gefunden. Bitte \00FCberpr\00FCfen sie das Prozess-Diagramm.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-already-running'', c_load_lang, q''[Sie haben versucht einen bereits laufenden Prozess (ID %0) zu starten.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[Beim Versuch einen Prozess f\00FCr Diagramm %0 zu starten wurde eine, sich selbst aufrufende, Aktivit\00E4t gefunden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[Sie haben versucht einen Prozess (%0) zu starten f\00FCr den bereits mehrere Kopien gestartet wurden.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-multiple-start-events'', c_load_lang, q''[Sie haben mehrfache Startereignisse definiert. Bitte stellen sie sicher, dass ihr Diagramm nur ein Startereignis beinhaltet.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-no-start-event'', c_load_lang, q''[Es gibt kein definiertes Startereignis im Flow-Diagramm.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-not-created'', c_load_lang, q''[Sie haben versucht einen nicht existierenden Prozess (ID %0) zu starten.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[Nicht unterst\00FCtzter Startereignistyp (%0). Derzeit werden')))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(15943830418133179)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr(' nur "Kein Wert" (Standard), "Nachricht" und "Timer-Startereignis" unterst\00FCtzt.]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
null;
end;
/
prompt --application/deployment/install/install_engine_messages_english
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10374352137495602)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - English'
,p_sequence=>80
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_en.sql',
'--',
'-- Engine Messages for language code "en"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Mon, 26 Jun 2023 15:38:36 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "en"',
'declare',
'  c_load_lang constant varchar2(10) := ''en'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''ITE-unsupported-type'', c_load_lang, q''[Currently unsupported type of Intermediate Throw Event encountered at %0 .]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-session-params-not-set'', c_load_lang, q''[Asynchronous connection details for object %0 need to be set in process variables, diagram async connection details, or system config details.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''async-invalid_params'', c_load_lang, q''[Unable to create asyncronous connection for object %0.  Username not valid in specified Application]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''async-no-username'', c_load_lang, q''[Unable to create asyncronous connection for object %0.  Username needs to be specified in process variable, the process diagram, or system configuration.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''async-no-appid'', c_load_lang, q''[Unable to create asyncronous connection for object %0.  Application ID needs to be specified in process variable, the process diagram, or system configuration.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''async-no-pageid'', c_load_lang, q''[Unable to create asyncronous connection for object %0.  Page ID needs to be specified in process variable, the process diagram, or system configuration.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[Child Boundary Subflows or Timers of %0 currently locked by another user.  Retry your transaction later.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[No boundaryEvent of type %0 found to catch event.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-too-many'', c_load_lang, q''[More than one %0 boundaryEvent found on sub process.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''eng_handle_event_int'', c_load_lang, q''[Flow Engine Internal Error: Process %0 Subflow %1 Module %2 Current %4 Current Tag %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-unsupported-object'', c_load_lang, q''[Model Error: Process BPMN model next step uses unsupported object %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[Application Error: Process ID %0 not found.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[Application Error: Subflow ID supplied ( %0 ) exists but is not child of Process ID Supplied ( %1 ).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[Subflow ID supplied ( %0 ) not found. Check for process events that changed process flow (timeouts, errors, escalations).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-invalid-route'', c_load_lang, q''[Error at gateway %0. Supplied variable %1 contains invalid route: %2]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-merge-error'', c_load_lang, q''[Internal error processing merging gateway on subflow %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-no-route'', c_load_lang, q''[No gateway routing instruction provided in variable %0 and model contains no default route.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-bad-expression'', c_load_lang, q''[Bad gateway routing expression.  This can occur if you attempt to bind a variable with embedded colon (:).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-too-many-defaults'', c_load_lang, q''[More than one default route specified in model for Gateway %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''link-no-catch'', c_load_lang, q''[Unable to find matching link catch event named %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''link-too-many-catches'', c_load_lang, q''[More than one matching link catch event named %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-instance-event'', c_load_lang, q''[Flows - Internal error while logging an Instance Event]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-step-event'', c_load_lang, q''[Flows - Internal error while logging a Step Event]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-variable-event'', c_load_lang, q''[Flows - Internal error while logging a Variable Event]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''process-lock-timeout'', c_load_lang, q''[Process objects for %0 currently locked by another user.  Try again later.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''more_than_1_forward_path'', c_load_lang, q''[More than 1 forward path found when only 1 allowed.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''no_next_step_found'', c_load_lang, q''[No Next Step Found on subflow %0.  Check your process diagram.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plsql_script_failed'', c_load_lang, q''[Process %0: Task %1 failed due to PL/SQL error - see event log.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plsql_script_requested_stop'', c_load_lang, q''[Process %0: Task %1 requested processing stop - see event log.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timeout_locking_subflow'', c_load_lang, q''[Unable to lock subflow %0 as currently locked by another user.  Try again later.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-already-placed'', c_load_lang, q''[Reservation already placed on next task for you.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-by-other_user'', c_load_lang, q''[Reservation for %0 unsuccessful.  Step already reserved by another user (%1).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-failed-not-found'', c_load_lang, q''[Reservation for %2 unsuccessful.  Subflow %0 in Process %1 not found.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[Task is no longer current, probably already completed.  Please refresh your Inbox.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-lock-timeout'', c_load_lang, q''[Subflow currently locked (not reserved) by another user.  Try your reservation again later.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-release-not-found'', c_load_lang, q''[Reservation release unsuccessful.  Subflow %0 in Process %1 not found.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''restart-no-error'', c_load_lang, q''[No Current Error Found.  Check your process diagram.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-already-running'', c_load_lang, q''[You tried to start a process (id %0)that is already running.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-diagram-calls-itself'', c_load_lang, q''[You tried to start a process with a diagram %0 that includes a callActivity calling itself.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-multiple-already-running'', c_load_lang, q''[You tried to start a process (id %0) with multiple copies already running.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-multiple-start-events'', c_load_lang, q''[You have multiple starting events defined. Make sure your diagram has only one start event.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-no-start-event'', c_load_lang, q''[No starting event is defined in the Flow diagram.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-not-created'', c_load_lang, q''[You tried to start a process (id %0) that does not exist.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-type-unsupported'', c_load_lang, q''[Unsupported start event type (%0). Only None (standard), Message and Timer Start Event are currently supported.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[Start Work time recording unsuccessful.  Subflow %0 in Process %1 not found.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''step-key-incorrect'', c_load_lang, q''[This Process Step has already occurred.  (Incorrect step key %0 supplied while expecting step key %1).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''subProcess-no-start'', c_load_lang, q''[Unable to find Sub-Process Start Event.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''subProcess-too-many-starts'', c_load_lang, q''[More than one Sub-Process Start found.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-broken'', c_load_lang, q''[Timer %0 Run %4 broken in process %1 , subflow : %2.  See error_info.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-cycle-unsupported'', c_load_lang, q''[Cycle Timer defined for object %0 not currently supported.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-incomplete-definition'', c_load_lang, q''[Incomplete timer definitions for object %0. Type: %1; Value1: %2 Value2: %3  Value3: %4]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-lock-timeout'', c_load_lang, q''[Timer for subflow %0 currently locked by another user.  Try again later.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-object-not-found'', c_load_lang, q''[Object with timer not found in get_timer_definition. Subflow %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timers-lock-timeout'', c_load_lang, q''[Timers for process %0 currently locked by another user.  Try again later.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-set-error'', c_load_lang, q''[Error creating process variable %0 for process id %1 in scope %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-get-error'', c_load_lang, q''[Error getting process variable %0 for process id %1 in scope %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-update-error'', c_load_lang, q''[Error updating process variable %0 for process id %1 in scope %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-delete-error'', c_load_lang, q''[Error deleting process variable %0 for process id %1 in scope %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-lock-error'', c_load_lang, q''[Error locking process variable %0 for process id %1 in scope %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_datatype'', c_load_lang, q''[Error setting process variable.  Incorrect datatype for variable %0.  SQL error shown in debug output.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_date_format'', c_load_lang, q''[Error setting Process Variable %1: Incorrect Date Format (Subflow: %0, Set: %3.)]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_object_not_found'', c_load_lang, q''[Internal error looking up object %0 in process_expressions.  SQL error shown in debug output.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_plsql_error'', c_load_lang, q''[Subflow : %0 Error in %2 expression for Variable : %1]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_no_data'', c_load_lang, q''[Error setting process variable %1 in process id %0 (set %2).  No data found in query.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_other'', c_load_lang, q''[Error setting process variable %1 in process id %0 (set %2).  SQL error shown in event log.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[Error setting process variable %1 in process id %0 (set %2).  Query returns multiple rows.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_static_general'', c_load_lang, q''[Error setting process variable %1 in process id %0 (set %2).  See error in event log.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[Cannot find released diagram or draft version 0 of diagram - please specify a version or diagram_id]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''version-not-found'', c_load_lang, q''[Cannot find specified diagram version.  Please check version specification.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer_definition_error'', c_load_lang, q''[Error parsing timer definition in process %0, subflow %1. Timer Type: %2, Definition: %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-model-no-version'', c_load_lang, q''[Version not defined.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[Error during parsing process variables.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-route-not-define'', c_load_lang, q''[Gateway is not defined for routing.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[Gateway define does not exists for this flow.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[Unable to get Flow Instance Id and or subflow Id to manage the step.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[Wrong number of APEX item(s) or process variable(s).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[One or more process variable(s) are a different type than the one defined in the JSON.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 is not a valid number.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 is not a valid date.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-invalid-json'', c_load_lang, q''[JSON provided is invalid.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[No data found. Check if Diagram with given ID exists.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-unexpected-error'', c_load_lang, q''[Unexpected error, please contact your administrator.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[Diagram could not be parsed.<br />Please review your diagram to ensure that it is supported.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-diagram-saved'', c_load_lang, q''[Changes saved!]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[Model has changed. Discard changes?]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''wrong-default-workspace'', c_load_lang, q''[Process %0: ServiceTask %1 failed: the default workspace defined in the configuration parameter is not valid.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''workspace-not-found'', c_load_lang, q''[Process %0: ServiceTask %1 failed: unable to find the workspace associated with the application id defined in the diagram. Please check the model.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-from'', c_load_lang, q''[Process %0: ServiceTask %1 failed: attribute "From" and default email sender are not defined. Please check the model and or the configuration parameter.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-to'', c_load_lang, q''[Process %0: ServiceTask %1 failed: attribute "To" not defined. Please check the model.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-template'', c_load_lang, q''[Process %0: ServiceTask %1 failed: attribute "Template" not defined. Please check the model.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-body'', c_load_lang, q''[Process %0: ServiceTask %1 failed: attribute "Body" not defined. Please check the model.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-failed'', c_load_lang, q''[Process %0: ServiceTask %1 failed see error log and check the model.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[Process %0: ServiceTask %1 placeholder JSON is invalid.Please check the model.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-multiple-rows'', c_load_lang, q''[Multiple rows found. Please enable the ''Enable Call Activities'' setting in the viewer plugin attributes.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-cancelation-error'', c_load_lang, q''[Error attempting to cancel APEX workflow task (task_id: %1 ) for process step : %0.)]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-supported'', c_load_lang, q''[APEX Workflow Feature use requires Oracle APEX v%0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-found'', c_load_lang, q''[APEX Workflow Task %0 not found in Flows for APEX Process]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[APEX Workflow Task %0 found associated with more than one Flows for APEX process step.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-current-step'', c_load_lang, q''[APEX Workflow Task %0 is not the current step of the Process.  Step may have completed all ready.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[APEX Workflow Task result process variable is not defined or invalid.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-creation-error'', c_load_lang, q''[Error creating APEX Workflow task %0 in application %1.  see debug for details.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-priority-error'', c_load_lang, q''[Error evaluating Priority.  Priority must be between 1 and 5.  Priority: %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-multiple-processes'', c_load_lang, q''[Error creating APEX session.  BPMN diagram contains multiple Process objects.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''call-diagram-not-callable'', c_load_lang, q''[You tried to call a diagram %0 that is marked as being not callable.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''diagram-archive-has-instances'', c_load_lang, q''[You tried to archive a diagram that has running instances.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[Error setting process variable %1 in process id %0 (set %2).  Query returns more than one value.]'' );',
'  -- below here manually added for 23.1 dev',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-business-ref-null'', c_load_lang, q''[Error creating Approval Task - Business Ref / System of Record Primary Key must be not null.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''archive-destination-bad-json'', c_load_lang, q''[Error in archive destination configuration parameter.  Parameter: %0]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''log-archive-error'', c_load_lang, q''[Error archiving instance summary for Process Instance %0]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[Timer repeat interval too frequent for host (%0) Requested Interval %1.  Must be greater than 1 Minute.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-not-correlated'', c_load_lang, q''[Received message does not match an expected message.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[Process step receiving message has already occured (incorrect step key provided).]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[Message Subscription locked by another user.   Try again.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[Message receiver unable to lock subflow.  Try again.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-diagram-event'', c_load_lang, q''[Flows - Internal error while logging a Diagram Event.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''due-on-interval-error'', c_load_lang, q''[Error evaluating Due On.  Interval expression is invalid.  Interval: %0.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''due-on-error'', c_load_lang, q''[Error evaluating Due On.  Due On expression is invalid.  Interval Expression: %0. ]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''settings-priority-error'', c_load_lang, q''[Error evaluating Priority. Priority expression is invalid.  Expression: %0.  Priority 3 used instead.]'' ); ',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''settings-error'', c_load_lang, q''[Error evaluating Setting. Expression is invalid.  Expression: %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[Settings cannot specify Process Variable without a Process ID.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[MessageFlow Endpoint specified ( %0 ) is not supported.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-bad-scope'', c_load_lang, q''[Invalid scope (%0) supplied for process variable.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_json_format'', c_load_lang, q''[Error setting Process Variable %1: Incorrect JSON Format (Subflow: %0, Set: %3.)]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''iter_lock_error'', c_load_lang, q''[Error locking iteration detail (iter %0 loop %2) for process id %1.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''iter_close_error'', c_load_lang, q''[Internal error processing iteration closure on subflow %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''feature-requires-ee'', c_load_lang, q''[Processing this feature requires licensing Flows for APEX Enterprise Edition.]'' );',
'',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_spanish
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15944395532136715)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Spanish'
,p_sequence=>90
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_es.sql',
'--',
'-- Engine Messages for language code "es"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "es"',
'declare',
'  c_load_lang constant varchar2(10) := ''es'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[Error al crear la tarea de aprobaci\00F3n - La referencia de negocio o la clave primaria del sistema de registro no deben ser nulas.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[Error al evaluar el vencimiento. La expresi\00F3n de intervalo no es v\00E1lida. Intervalo: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[Error al evaluar el vencimiento.  La expresi\00F3n de vencimiento no es v\00E1lida.  Expresi\00F3n de intervalo: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[Error al evaluar la prioridad. La expresi\00F3n de prioridad no es v\00E1lida. Expresi\00F3n: %0. En su lugar, se utiliza la prioridad 3.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[Se ha proporcionado un \00E1mbito no v\00E1lido (%0) para la variable de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[Intervalo de repetici\00F3n de temporizador demasiado frecuente para el host (%0) Intervalo solicitado %1. Debe ser mayor que 1 minuto.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[Error en el par\00E1metro de configuraci\00F3n de destino de archivo. Par\00E1metro: %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-not-correlated'', c_load_lang, q''[El mensaje recibido no coincide con un mensaje esperado.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[Ya se ha producido un mensaje de recepci\00F3n de paso de proceso (se ha proporcionado una clave de paso incorrecta).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[El procesamiento de esta funci\00F3n requiere la licencia Flows for APEX Enterprise Edition.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[Error interno al procesar cierre de iteraci\00F3n en subflujo %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[Error al establecer la variable de proceso %1 en el ID de proceso %0 (juego %2).  La consulta devuelve m\00E1s de un valor.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_json_format'', c_load_lang, q''[Error al definir la variable de proceso %1: formato JSON incorrecto (subflujo: %0, juego: %3).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[Error al bloquear el detalle de iteraci\00F3n (bucle de iteraci\00F3n %0 %2) para el ID de proceso %1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''subProcess-no-start'', c_load_lang, q''[No se ha encontrado el evento de inicio de subproceso.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[Se ha encontrado m\00E1s de un inicio de subproceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-broken'', c_load_lang, q''[Temporizador %0 Ejecuci\00F3n %4 interrumpido en proceso %1 , subflujo : %2. Consulte error_info.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[El temporizador de ciclo definido para el objeto %0 no est\00E1 soportado actualmente.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-incomplete-definition'', c_load_lang, q''[Definiciones de temporizador incompletas para el objeto %0. Tipo: %1; Value1: %2 Value2: %3  Value3: %4]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[El temporizador para el subflujo %0 est\00E1 bloqueado actualmente por otro usuario. Vuelva a intentarlo m\00E1s tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-object-not-found'', c_load_lang, q''[No se ha encontrado el objeto con temporizador en get_timer_definition. Subflujo %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[Los temporizadores del proceso %0 est\00E1n bloqueados actualmente por otro usuario. Vuelva a intentarlo m\00E1s tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[Error al crear la variable de proceso %0 para el ID de proceso %1 en el \00E1mbito %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[Error al obtener la variable de proceso %0 para el ID de proceso %1 en el \00E1mbito %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[Error al actualizar la variable de proceso %0 para el ID de proceso %1 en el \00E1mbito %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[Error al suprimir la variable de proceso %0 para el ID de proceso %1 en el \00E1mbito %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[Error al bloquear la variable de proceso %0 para el ID de proceso %1 en el \00E1mbito %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[Error al definir la variable de proceso. Tipo de dato incorrecto para la variable %0. Error SQL mostrado en la salida de depuraci\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_date_format'', c_load_lang, q''[Error al definir la variable de proceso %1: Formato de fecha incorrecto (subflujo: %0, juego: %3).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[Error interno al buscar el objeto %0 en process_expressions. Error SQL mostrado en la salida de depuraci\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[Subflujo: %0 Error en expresi\00F3n %2 para variable: %1]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_no_data'', c_load_lang, q''[Error al establecer la variable de proceso %1 en el ID de proceso %0 (juego %2). No se han encontrado datos en la consulta.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_other'', c_load_lang, q''[Error al establecer la variable de proceso %1 en el ID de proceso %0 (juego %2). Error SQL mostrado en el log de eventos.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[Error al establecer la variable de proceso %1 en el ID de proceso %0 (juego %2). La consulta devuelve varias filas.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_static_general'', c_load_lang, q''[Error al establecer la variable de proceso %1 en el ID de proceso %0 (juego %2). Consulte el error en el log de eventos.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[No se ha encontrado el diagrama publicado o la versi\00F3n de borrador 0 del diagrama; especifique una versi\00F3n o diagram_id]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[No se ha encontrado la versi\00F3n de diagrama especificada. Compruebe la especificaci\00F3n de versi\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[Error al analizar la definici\00F3n de temporizador en el proceso %0, subflujo %1. Tipo de temporizador: %2, Definici\00F3n: %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[Versi\00F3n no definida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[Error durante el an\00E1lisis de variables de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[Gateway no est\00E1 definido para direccionamiento.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[La definici\00F3n de gateway no existe para este flujo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[No se ha podido obtener el ID de instancia de flujo ni el ID de subflujo para gestionar el paso.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[N\00FAmero incorrecto de elementos APEX o variables de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[Una o m\00E1s variables de proceso son de un tipo diferente al definido en JSON.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 no es un n\00FAmero v\00E1lido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 no es una fecha v\00E1lida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[El JSON proporcionado no es v\00E1lido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[No se encontraron datos. Compruebe si existe un diagrama con el ID proporcionado.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-unexpected-error'', c_load_lang, q''[Error inesperado. P\00F3ngase en contacto con el administrador.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[No se ha podido analizar el diagrama.<br />Revise el diagrama para asegurarse de que est\00E1 soportado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[\00A1Cambios guardados!]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[El modelo ha cambiado. \00BFDescartar los cambios?]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[Proceso %0: fallo de ServiceTask %1: el espacio de trabajo por defecto definido en el par\00E1metro de configuraci\00F3n no es v\00E1lido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[Proceso %0: ServiceTask %1 ha fallado: no se ha encontrado el espacio de trabajo asociado al ID de aplicaci\00F3n definido en el diagrama. Compruebe el modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[Proceso %0: ServiceTask %1 ha fallado: el atributo "De" y el remitente de correo electr\00F3nico por defecto no est\00E1n definidos. Compruebe el modelo o el par\00E1metro de configuraci\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-to'', c_load_lang, q''[Proceso %0: fallo de ServiceTask %1: atributo "A" no definido. Compruebe el modelo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-template'', c_load_lang, q''[Proceso %0: fallo de ServiceTask %1: atributo "Plantilla" no definido. Compruebe el modelo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-body'', c_load_lang, q''[Proceso %0: fallo de ServiceTask %1: atributo "Cuerpo" no definido. Compruebe el modelo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-failed'', c_load_lang, q''[Proceso %0: ServiceTask %1 no ha podido ver el log de errores y comprobar el modelo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[Proceso %0: ServiceTask %1 marcador de posici\00F3n JSON es invalid.Please comprobar el modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-multiple-rows'', c_load_lang, q''[Se han encontrado varias filas. Active el valor ''Activar actividades de llamada'' en los atributos del plugin del visor.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-cancelation-error'', c_load_lang, q''[Error al intentar cancelar la tarea de flujo de trabajo de APEX (task_id: %1 ) para el paso de proceso: %0.)]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[El uso de la funci\00F3n Flujo de trabajo de APEX necesita Oracle APEX v%0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-found'', c_load_lang, q''[No se ha encontrado la tarea de flujo de trabajo de APEX %0 en flujos para el proceso APEX]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[La tarea de flujo de trabajo de APEX %0 se ha encontrado asociada a m\00E1s de un flujo para el paso de proceso de APEX.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-current-step'', c_load_lang, q''[La tarea de flujo de trabajo de APEX %0 no es el paso actual del proceso. El paso puede haber finalizado todo listo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[La variable de proceso de resultado de tarea de flujo de trabajo de APEX no est\00E1 definida o no es v\00E1lida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[Error al crear la tarea de flujo de trabajo de APEX %0 en la aplicaci\00F3n %1. Consulte la depuraci\00F3n para obtener m\00E1s informaci\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-priority-error'', c_load_lang, q''[Error al evaluar la prioridad. La prioridad debe estar entre 1 y 5. Prioridad: %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[Error al crear la sesi\00F3n de APEX. El diagrama BPMN contiene varios objetos de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''call-diagram-not-callable'', c_load_lang, q''[Ha intentado llamar a un diagrama %0 marcado como no llamable.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[Se ha encontrado un tipo de evento de devoluci\00F3n intermedio no soportado actualmente en %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[Los detalles de conexi\00F3n as\00EDncrona para el objeto %0 se deben definir en variables de proceso, detalles de conexi\00F3n as\00EDncrona de diagrama o detalles de configuraci\00F3n del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[No se puede crear una conexi\00F3n as\00EDncrona para el objeto %0. Nombre de usuario no v\00E1lido en la aplicaci\00F3n especificada]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[No se puede crear una conexi\00F3n as\00EDncrona para el objeto %0. Se debe especificar el nombre de usuario en la variable de proceso, el diagrama de proceso o la configuraci\00F3n del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[No se puede crear una conexi\00F3n as\00EDncrona para el objeto %0. El ID de aplicaci\00F3n se debe especificar en la variable de proceso, el diagrama de proceso o la configuraci\00F3n del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[No se puede crear una conexi\00F3n as\00EDncrona para el objeto %0. El ID de p\00E1gina se debe especificar en la variable de proceso, el diagrama de proceso o la configuraci\00F3n del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[Subflujos o temporizadores de l\00EDmite secundario de %0 bloqueados actualmente por otro usuario. Vuelva a intentar la transacci\00F3n m\00E1s tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[No se ha encontrado ning\00FAn boundaryEvent de tipo %0 para capturar el evento.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[Se ha encontrado m\00E1s de un %0 boundaryEvent en el subproceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''eng_handle_event_int'', c_load_lang, q''[Error interno del motor de flujo: Proceso %0 Subflujo %1 M\00F3dulo %2 Actual %4 Etiqueta actual %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-unsupported-object'', c_load_lang, q''[Error de modelo: el siguiente paso del modelo BPMN del proceso utiliza un objeto %0 no soportado]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[Error de aplicaci\00F3n: No se ha encontrado el ID de proceso %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[Error de aplicaci\00F3n: el ID de subflujo proporcionado ( %0 ) existe pero no es secundario del ID de proceso proporcionado ( %1 ).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[No se ha encontrado el ID de subflujo proporcionado (%0). Compruebe los eventos de proceso que han cambiado el flujo de proceso (tiempos de espera, errores, escaladas).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[Error en gateway %0. La variable proporcionada %1 contiene una ruta no v\00E1lida: %2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[Error interno al procesar el gateway de fusi\00F3n en el subflujo %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[No se ha proporcionado ninguna instrucci\00F3n de direccionamiento de gateway en la variable %0 y el modelo no contiene ninguna ruta por defecto.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[Expresi\00F3n de enrutamiento de gateway incorrecta. Esto puede ocurrir si intenta enlazar una variable con dos puntos incrustados (:).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[Se ha especificado m\00E1s de una ruta por defecto en el modelo para el gateway %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''link-no-catch'', c_load_lang, q''[No se ha encontrado el evento de captura de enlace coincidente denominado %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[Hay m\00E1s de un evento de captura de enlace coincidente denominado %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-instance-event'', c_load_lang, q''[Flujos: error interno al registrar un evento de instancia]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-step-event'', c_load_lang, q''[Flujos - Error interno al registrar un evento de paso]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-variable-event'', c_load_lang, q''[Flujos: error interno al registrar un evento variable]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[Objetos de proceso para %0 bloqueados actualmente por otro usuario. Vuelva a intentarlo m\00E1s tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[Se encontraron m\00E1s de 1 ruta hacia adelante cuando solo se permiten 1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[No se ha encontrado ning\00FAn paso siguiente en el subflujo %0. Compruebe el diagrama de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plsql_script_failed'', c_load_lang, q''[Proceso %0: la tarea %1 ha fallado debido a un error de PL/SQL. Consulte el log de eventos.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[Proceso %0: la tarea %1 ha solicitado la detenci\00F3n del procesamiento. Consulte el log de eventos.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[No se puede bloquear el subflujo %0 porque est\00E1 bloqueado actualmente por otro usuario. Vuelva a intentarlo m\00E1s tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-already-placed'', c_load_lang, q''[Ya ha realizado la reserva en la siguiente tarea.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[Reserva incorrecta para %0. El paso ya est\00E1 reservado por otro usuario (%1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-failed-not-found'', c_load_lang, q''[Reserva para %2 incorrecta. No se ha encontrado el subflujo %0 en el proceso %1.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[La tarea ya no est\00E1 actualizada, probablemente ya se haya completado. Refresque la bandeja de entrada.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[Subflujo bloqueado actualmente (no reservado) por otro usuario. Intente realizar su reserva de nuevo m\00E1s tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[Liberaci\00F3n de reserva incorrecta. No se ha encontrado el subflujo %0 en el proceso %1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[No se ha encontrado ning\00FAn error actual. Compruebe el diagrama de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[Ha intentado iniciar un proceso (ID %0) que ya se est\00E1 ejecutando.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-diagram-calls-itself'', c_load_lang, q''[Ha intentado iniciar un proceso con un diagrama %0 que incluye una llamada callActivity.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[Intent\00F3 iniciar un proceso (ID %0) con varias copias ya en ejecuci\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[Tiene varios eventos iniciales definidos. Aseg\00FArese de que el diagrama solo tiene un evento de inicio.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-no-start-event'', c_load_lang, q''[No se ha definido ning\00FAn evento inicial en el diagrama de flujo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-not-created'', c_load_lang, q''[Ha intentado iniciar un proceso (ID %0) que no existe.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[Tipo de evento de inicio no admitido (%0). Actualmente solo se admite Ninguno (est\00E1ndar), Mensaje y Evento de inicio de temporizador.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[La configuraci\00F3n no puede especificar una variable de proceso sin un ID de proceso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[Ha intentado archivar un diagrama que tiene instancias en ejecuci\00F3n.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-diagram-event'', c_load_lang, q''[Flujos: error interno al registrar un evento de diagrama.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''log-archive-error'', c_load_lang, q''[Error al archivar el resumen de instancias para la instancia de proceso %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[El receptor de mensajes no puede bloquear el subflujo. Vuelva a intentarlo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[Error al evaluar la configuraci\00F3n. La expresi\00F3n no es v\00E1lida. Expresi\00F3n: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[MessageFlow El punto final especificado ( %0 ) no est\00E1 soportado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[Suscripci\00F3n de mensaje bloqueada por otro usuario. Vuelva a intentarlo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[Registro de hora de inicio de trabajo incorrecto. No se ha encontrado el subflujo %0 en el proceso %1.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''step-key-incorrect'', c_load_lang, q''[Ya se ha producido este paso de proceso. (Se ha proporcionado '))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(15944395532136715)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'una clave de paso incorrecta %0 mientras se esperaba la clave de paso %1).]'' );',
'  ',
'  commit;',
'end;',
'/',
''))
);
null;
end;
/
prompt --application/deployment/install/install_engine_messages_french
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15944556204137842)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - French'
,p_sequence=>100
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_fr.sql',
'--',
'-- Engine Messages for language code "fr"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "fr"',
'declare',
'  c_load_lang constant varchar2(10) := ''fr'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_static_general'', c_load_lang, q''[Erreur de d\00E9finition de la variable %1 (valeur : %2) dans le processus d''id %0. Voir l''erreur dans le journal des \00E9v\00E9nements.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[Impossible de trouver le diagramme publi\00E9 ou la version 0 du diagramme - veuillez sp\00E9cifier une version ou un num\00E9ro de diagramme.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[Impossible de trouver la version sp\00E9cifi\00E9e du diagramme. Veuillez v\00E9rifier la version.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[La r\00E9servation pour %0 est impossible. L''\00E9tape est d\00E9j\00E0 r\00E9serv\00E9e par un autre utilisateur (%1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[La r\00E9servation pour %0 est impossible. Sous-flux %0 dans le processus %1 non trouv\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[La t\00E2che n''est plus en cours, elle est probablement d\00E9j\00E0 termin\00E9e.  Veuillez rafra\00EEchir votre liste de t\00E2ches.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[Sous-flux actuellement verrouill\00E9 (non reserv\00E9) par un autre utilisteur. Veuillez r\00E9essayez ult\00E9rieurement.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[La lib\00E9ration de la r\00E9servation est impossible. Sous-flux %0 dans le processus %1 non trouv\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[Les param\00E8tres ne peuvent pas sp\00E9cifier de variable de processus sans ID de processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[Vous avez essay\00E9 d''archiver un diagramme comportant des instances en cours d''ex\00E9cution.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[Ereur lors de la d\00E9finition de la variable %1 avec la valeur %2 dans le processus %0.  La requ\00EAte renvoie plusieurs lignes.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[Le destinataire du message ne peut pas verrouiller le sous-flux. R\00E9essayez.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[Erreur lors de l''\00E9valuation du param\00E8tre. Expression non valide. Expression : %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[L''adresse MessageFlow indiqu\00E9e ( %0) n''est pas prise en charge.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[Abonnement aux messages verrouill\00E9 par un autre utilisateur. R\00E9essayez.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[Erreur lors de la cr\00E9ation de la t\00E2che d''approbation - La r\00E9f\00E9rence commerciale / la cl\00E9 primaire du syst\00E8me d''enregistrement ne doit pas avoir la valeur NULL.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[Erreur lors de l''\00E9valuation de la date d''\00E9ch\00E9ance. Expression d''intervalle non valide. Intervalle : %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[Erreur lors de l''\00E9valuation de l''\00E9ch\00E9ance.  L''expression Ech\00E9ance le n''est pas valide.  Expression d''intervalle : %0. ]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[Erreur lors de l''\00E9valuation de la priorit\00E9. Expression de priorit\00E9 non valide. Expression : %0. Priorit\00E9 3 utilis\00E9e \00E0 la place.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[Port\00E9e non valide (%0) fournie pour la variable de processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[Intervalle de r\00E9p\00E9tition du compteur trop fr\00E9quent pour l''h\00F4te (%0) Intervalle demand\00E9 %1. Doit \00EAtre sup\00E9rieur \00E0 1 minute.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[Erreur dans le param\00E8tre de configuration de destination d''archivage. Param\00E8tre : %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[Le message re\00E7u ne correspond pas \00E0 un message attendu.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[Un message de r\00E9ception d''\00E9tape de processus s''est d\00E9j\00E0 produit (cl\00E9 d''\00E9tape incorrecte fournie).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-diagram-event'', c_load_lang, q''[Flows - Erreur interne lors de la journalisation d''un \00E9v\00E9nement de diagramme.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[Erreur lors de l''archivage du r\00E9capitulatif d''instance pour l''instance de processus %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[Cette fonctionnalit\00E9 n\00E9cessite une licence pour Flows for APEX Enterprise Edition.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[Erreur interne lors du traitement de la fermeture de l''it\00E9ration sur le sous-flux %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[Erreur dans la mise \00E0 jour de la variable %1 dans le processus id %0 (valeur %2). La requ\00EAte renvoie plus d''une valeur.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[Erreur lors de la mise \00E0 jour de la variable de processus %1 : Format JSON incorrect (sous-flux : %0, valeur : %3.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[Erreur lors du verrouillage du d\00E9tail d''it\00E9ration (it\00E9ration %0 boucle %2) pour l''ID de processus %1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-step-event'', c_load_lang, q''[Flows - Erreur interne lors de l''enregistrement d''un \00E9v\00E8nement d''\00E9tape]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-variable-event'', c_load_lang, q''[Flows - Erreur interne lors de l''enregistrement d''un \00E9v\00E8nement de variable]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[Les objets de traitement pour %0 sont actuellement verrouill\00E9s par un autre utilisateur. R\00E9essayez plus tard.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[Plus d''un chemin d''acc\00E8s trouv\00E9 alors qu''un seul est autoris\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[Aucune \00E9tape suivante trouv\00E9e pour le sous-flux %0. V\00E9rifiez votre diagramme de processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_failed'', c_load_lang, q''[Processus %0 : la t\00E2che %1 a \00E9chou\00E9 en raison d''une erreur PL/SQL - voir le journal des \00E9v\00E9nements.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[Processus %0: T\00E2che %1 arr\00EAt du traitement demand\00E9 - voir le journal des \00E9v\00E9nements.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[Impossible de verrouiller le sous-flux %0, celui-ci est actuellement verrouill\00E9 par un autre utilisateur. Veuillez r\00E9essayer ult\00E9rieurement.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[R\00E9servation d\00E9j\00E0 effectu\00E9e sur la prochaine t\00E2che pour vous.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[Erreur de d\00E9finition de la variable de processus. Type de donn\00E9es incorrect pour la variable %0. Erreur SQL affich\00E9e dans le d\00E9bogage.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[Erreur de d\00E9finition de la variable de processus %1 : format de date incorrect (Sous-flux : %0, Valeur : %3.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[Erreur interne dans la recherche de l''objet %0 dans process_expressions. Erreur SQL affich\00E9e dans le d\00E9bogage]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_plsql_error'', c_load_lang, q''[Sous-flux : %0 Erreur dans l''expression %2 de la variable : %1]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_no_data'', c_load_lang, q''[Ereur lors de la d\00E9finition de la variable %1 avec la valeur %2 dans le processus %0 - Aucune donn\00E9e trouv\00E9e dans la requ\00EAte.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_other'', c_load_lang, q''[Ereur lors de la d\00E9finition de la variable %1 avec la valeur %2 dans le processus %0.  Erreur SQL indiqu\00E9e dans le journal des \00E9v\00E9nements.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[La t\00E2che de workflow APEX %0 est associ\00E9e \00E0 plus d''une \00E9tape de processus dans Flows for APEX.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[Aucune erreur courante trouv\00E9e. V\00E9rifiez votre diagramme de processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[Vous avez essay\00E9 de d\00E9marrer un processus (id %0) qui est d\00E9j\00E0 en cours d''ex\00E9cution.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[Vous avez essay\00E9 de d\00E9marrer un processus avec un diagramme %0 qui inclut une activit\00E9 d''appel s''appelant lui m\00EAme.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[Vous avez essay\00E9 de d\00E9marrer un processus (id %0) dont plusieurs copies sont d\00E9j\00E0 en cours d''ex\00E9cution.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[Vous avez d\00E9fini plusieurs \00E9v\00E9nements de d\00E9but. Assurez-vous que votre diagramme n''a qu''un seul \00E9v\00E9nement de d\00E9but.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-no-start-event'', c_load_lang, q''[Aucun \00E9v\00E9nement de d\00E9but n''est d\00E9fini dans le diagramme de flux.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[Vous avez essay\00E9 de d\00E9marrer un processus (id %0) qui n''existe pas.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[Type d''\00E9v\00E9nement de d\00E9but non pris en charge (%0). Seuls les \00E9v\00E9nements Aucun (standard), Message et D\00E9but de minuteur sont actuellement pris en charge.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[Sous-flux enfant ou minuteur de %0 sont actuellement verrouill\00E9s par un autre utilisateur. . R\00E9essayez votre transaction plus tard.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[Aucun \00E9v\00E9nement de fronti\00E8re de type %0 trouv\00E9 pour capturer l''\00E9v\00E9nement.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[Plus d''un \00E9v\00E9nement de fronti\00E8re %0 trouv\00E9 sur le sous-processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''eng_handle_event_int'', c_load_lang, q''[Erreur interne du moteur de flux: Processus %0 Sous-flux %1 Module %2 Courant %4 Balise courante %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[Erreur de mod\00E8le : L''\00E9tape suivante du mod\00E8le de processus BPMN utilise un objet non support\00E9 %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[Erreur applicative : L''ID du processus %0 n''a pas \00E9t\00E9 trouv\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[Erreur applicative: L''ID du sous-flux fourni ( %0 ) existe mais n''est pas un enfant de l''ID de processus fourni ( %1 ).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[L''ID du sous-flux fourni ( %0 ) est introuvable. V\00E9rifiez les \00E9v\00E9nements du processus qui ont modifi\00E9 le flux du processus (d\00E9lais, erreurs, escalades).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-invalid-route'', c_load_lang, q''[Erreur au niveau de la passerelle %0. La variable fournie %1 contient une route invalide : %2]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-merge-error'', c_load_lang, q''[Erreur interne de traitement lors de la fusion au nivau de la passerelle sur le sous-flux %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[Aucune instruction de routage de passerelle n''est fournie dans la variable %0 et le mod\00E8le ne contient pas de route par d\00E9faut.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[Plus d''une route par d\00E9faut sp\00E9cifi\00E9e dans le mod\00E8le pour la passerelle %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[Expression de routage de passerelle incorrecte. Cela peut se produire si vous tentez de lier une variable \00E0 l''aide du signe deux-points ( :).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-no-catch'', c_load_lang, q''[Impossible de trouver le lien correspondant \00E0 l''\00E9v\00E9nement %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[Plus d''un lien correspond \00E0 l''\00E9v\00E9nement %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-instance-event'', c_load_lang, q''[Flows - Erreur interne lors de l''enregistrement d''un \00E9v\00E8nement d''instance]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[D\00E9but de l''enregistrement des temps de travail non r\00E9ussi. Le sous-flux %0 du processus %1 est introuvable.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[Cette \00E9tape de processus a d\00E9j\00E0 \00E9t\00E9 r\00E9alis\00E9e.  (Cl\00E9 d''\00E9tape fournie incorrecte %0, cl\00E9 d''\00E9tape attendue %1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-no-start'', c_load_lang, q''[Impossible de trouver l''\00E9v\00E9nement de d\00E9but de sous-processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[Plus d''un \00E9v\00E9nement de sous-processus trouv\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-broken'', c_load_lang, q''[Minuteur %0 cycle %4 en erreur dans le processus %1 , sous-flux : %2.  Voir error_info.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[Minuteur de type cycle d\00E9fini pour l''objet %0 n''est pas pris en charge actuellement.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[D\00E9finition incompl\00E8te du minuteur de l''objet %0. Type: %1; Valeur1: %2 Valeur2: %3 Valeur3: %4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[La minuteur du sous-flux %0 est verrouill\00E9 par un autre utilisateur. Veuillez r\00E9essayer ult\00E9rieurement.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-object-not-found'', c_load_lang, q''[Objet avec minuteur non trouv\00E9 dans get_timer_definition. Sous-flux %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[Les minuteurs pour le processus %0 sont verrouill\00E9s par un autre utilisateur. Veuillez r\00E9essayer ult\00E9rieurement.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[Erreur de cr\00E9ation de la variable de processus %0 pour l''ID de processus %1 dans la port\00E9e %2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[Erreur lors de l''obtention de la variable de processus %0 pour l''ID de processus %1 dans la port\00E9e %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[Erreur de mise \00E0 jour de la variable de processus %0 pour l''ID de processus %1 dans la port\00E9e %2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[Erreur de suppression de la variable de processus %0 pour l''ID de processus %1 dans la port\00E9e %2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[Erreur de verrouillage de la variable de processus %0 pour l''ID de processus %1 dans la port\00E9e %2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[Erreur lors de l''analyse de la d\00E9finition du minuteur dans le processus %0, sous-flux %1. Type de minuteur : %2, D\00E9finition: %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[La version n''est pas d\00E9finie.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[Erreur lors de l''analyse des variables du processus.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[La passerelle n''est pas d\00E9finie pour le routage.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[La d\00E9finition de la passerelle n''existe pas pour ce flux.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[Impossible d''obtenir l''Id de l''Instance de flux et ou l''Id du sous-flux pour g\00E9rer l''\00E9tape.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[Mauvais nombre d''\00E9l\00E9ment(s) APEX ou de variable(s) de processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[Une ou plusieurs variables de processus sont d''un type diff\00E9rent de celui d\00E9fini dans le JSON.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 n''est pas un nombre valide.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 n''est pas une date valide.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-invalid-json'', c_load_lang, q''[Le JSON fourni est invalide.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[Aucune donn\00E9e trouv\00E9e.\00A0V\00E9rifiez si le Diagramme avec l''ID fourni existe.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-unexpected-error'', c_load_lang, q''[Erreur inattendue, veuillez contacter votre administrateur.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[Le diagramme n''a pas pu \00EAtre analys\00E9.<br />Veuillez examiner votre diagramme pour vous assurer qu''il est pris en charge.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[Changements enregistr\00E9s !]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[Le mod\00E8le a chang\00E9, annuler les changements?]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : l''espace de travail par d\00E9faut d\00E9fini dans le param\00E8tre de configuration n''est pas valide.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : impossible de trouver l''espace de travail associ\00E9 \00E0 l''aplication d\00E9finie dans le diagramme. Veuillez v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : attribut De non d\00E9fini. Veuillez v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : attribut To non d\00E9fini. Veuillez v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : attribut Template non d\00E9fini. Veuillez v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : attribut Corps non d\00E9fini. Veuillez v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[Processus %0 : la t\00E2che de service %1 a \00E9chou\00E9 : voir le journal pour plus de d\00E9tail et v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[Processus %0: la t\00E2che de service %1 a \00E9chou\00E9 : l''objet JSON des espaces r\00E9serv\00E9s est invalide. Veuillez v\00E9rifier le mod\00E8le.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[Impossible de cr\00E9er une connexion asynchrone pour l''objet %0.  Le nom d''utilisateur n''est pas valide dans l''application sp\00E9cifi\00E9e]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[Plusieurs lignes trouv\00E9es. Activez le param\00E8tre "Activer les activit\00E9s d''appel" dans les attributs de plug-in de la visionneuse.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-cancelation-error'', c_load_lang, q''[Erreur lors de la tentative d''annulation de la t\00E2che de workflow APEX (task_id : %1 ) pour l''\00E9tape de processus : %0.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[L''utilisation de la fonctionnalit\00E9 de workflow APEX n\00E9cessite Oracle APEX v%0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-found'', c_load_lang, q''[T\00E2che de workflow APEX %0 introuvable dans les processus Flows for APEX]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[La t\00E2che de workflow APEX %0 n''est pas la t\00E2che courante du processus. Vous pourriez avoir d\00E9j\00E0 tout compl\00E9t\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[La variable de processus du r\00E9sultat de la t\00E2che de workflow APEX n''est pas d\00E9finie ou n''est pas valide.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[Erreur lors de la cr\00E9ation de la t\00E2che de workflow APEX %0 dans l''application %1. Pour plus de d\00E9tails, reportez-vous au d\00E9bogage.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[Erreur lors de l''\00E9valuation de la priorit\00E9. La priorit\00E9 doit \00EAtre comprise entre 1 et 5. Priorit\00E9 : %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[Erreur lors de la cr\00E9ation de la session APEX. Le diagramme BPMN contient plusieurs objets de processus.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[Vous avez essay\00E9 d''appeler un diagramme %0 marqu\00E9 comme ne pouvant pas \00EAtre appel\00E9.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[Type d''\00E9v\00E9nement de lancer interm\00E9diaire actuellement non pris en charge rencontr\00E9 \00E0 %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[Les d\00E9tails de connexion asynchrone pour l''objet %0 doivent \00EAtre d\00E9finis dans les variables de processus, les d\00E9tails de connexion asynchrone de diagramme ou les d\00E9tails de configuration sys')
||unistr('t\00E8me.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[Impossible de cr\00E9er une connexion asynchrone pour l''objet %0. Le nom d''utilisateur doit \00EAtre la variable du processus, le diagramme du processus ou la con')))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(15944556204137842)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('figuration du syst\00E8me.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[Impossible de cr\00E9er une connexion asynchrone pour l''objet %0. L''ID d''application doit \00EAtre indiqu\00E9 dans la variable de processus, le diagramme de processus ou la configuration syst\00E8me.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[Impossible de cr\00E9er une connexion asynchrone pour l''objet %0. L''ID de page doit \00EAtre sp\00E9cifi\00E9 dans la variable de processus, le diagramme de processus ou la configuration syst\00E8me.]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
null;
end;
/
prompt --application/deployment/install/install_engine_messages_italian
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15944759485138892)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Italian'
,p_sequence=>110
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_it.sql',
'--',
'-- Engine Messages for language code "it"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "it"',
'declare',
'  c_load_lang constant varchar2(10) := ''it'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-found'', c_load_lang, q''[Task del workflow APEX %0 non trovato in Flows for APEX]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[Trovato task del workflow APEX %0 associato a pi\00F9 di un passo del processo Flows for APEX.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[Il task del workflow APEX %0 non \00E8 il passo corrente del processo. \00C8 possibile che il passo sia stato completato tutto pronto.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[Variabile del processo dei risultati del task del workflow APEX non definita o non valida.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-creation-error'', c_load_lang, q''[Errore durante la creazione del task del workflow APEX %0 nell''applicazione %1. Per i dettagli, vedere il debug.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[Errore durante la creazione del task del workflow APEX - priorit\00E0 non valida %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[Errore durante la creazione della sessione APEX. Il diagramma BPMN contiene pi\00F9 oggetti processo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[Si \00E8 tentato di chiamare un diagramma %0 contrassegnato come non richiamabile.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[Si \00E8 tentato di archiviare un diagramma con istanze in esecuzione.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-business-ref-null'', c_load_lang, q''[Errore durante la creazione del task di approvazione - Riferimento aziendale/Chiave principale sistema di record non deve essere nullo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''archive-destination-bad-json'', c_load_lang, q''[Errore nel parametro di configurazione della destinazione dell''archivio. Parametro: %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''log-archive-error'', c_load_lang, q''[Errore durante l''archiviazione del riepilogo dell''istanza di processo %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[Intervallo di ripetizione del timer troppo frequente per l''host (%0) Intervallo richiesto %1. Deve essere maggiore di 1 minuto.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-not-correlated'', c_load_lang, q''[Il messaggio ricevuto non corrisponde a un messaggio previsto.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[Il messaggio di ricezione del passo del processo \00E8 gi\00E0 stato eseguito (fornita chiave passo errata).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[Sottoscrizione messaggio bloccata da un altro utente. Riprovare.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[Il ricevente del messaggio non \00E8 in grado di bloccare il flusso secondario. Riprovare.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-diagram-event'', c_load_lang, q''[Flussi - Errore interno durante la registrazione di un evento del diagramma.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''due-on-interval-error'', c_load_lang, q''[Errore durante la valutazione della scadenza. Espressione dell''intervallo non valida. Intervallo: %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[Errore durante la valutazione della scadenza. L''espressione Scadenza non \00E8 valida. Espressione intervallo: %0. Verr\00E0 utilizzato l''indicatore di sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[Errore durante la valutazione della priorit\00E0. L''espressione della priorit\00E0 non \00E8 valida. Espressione: %0. Viene invece utilizzata la priorit\00E0 3.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''settings-error'', c_load_lang, q''[Errore durante la valutazione dell''impostazione. Espressione non valida. Espressione: %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[Le impostazioni non possono specificare una variabile di processo senza un ID processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[MessageFlow L''endpoint specificato ( %0 ) non \00E8 supportato.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-bad-scope'', c_load_lang, q''[Ambito (%0) non valido fornito per la variabile di processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-get-error'', c_load_lang, q''[Errore durante il recupero della variabile di processo %0 per l''ID processo %1 nell''ambito %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''ITE-unsupported-type'', c_load_lang, q''[Tipo di evento riga intermedio attualmente non supportato rilevato in %0 .]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-session-params-not-set'', c_load_lang, q''[I dettagli di connessione asincrona per l''oggetto %0 devono essere impostati nelle variabili di processo, nei dettagli di connessione asincrona del diagramma o nei dettagli di configurazione'
||' del sistema.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''async-invalid_params'', c_load_lang, q''[Impossibile creare una connessione asincrona per l''oggetto %0. Nome utente non valido nell''applicazione specificata]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[Impossibile creare una connessione asincrona per l''oggetto %0. \00C8 necessario specificare il nome utente nella variabile di processo, nel diagramma del processo o nella configurazione del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[Impossibile creare una connessione asincrona per l''oggetto %0. \00C8 necessario specificare l''ID applicazione nella variabile di processo, nel diagramma del processo o nella configurazione del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[Impossibile creare una connessione asincrona per l''oggetto %0. \00C8 necessario specificare l''ID pagina nella variabile di processo, nel diagramma del processo o nella configurazione del sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[Flussi secondari limiti figlio o timer di %0 attualmente bloccati da un altro utente. Riprovare la transazione pi\00F9 tardi.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[Nessun boundaryEvent di tipo %0 trovato per rilevare l''evento.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[Trovati pi\00F9 %0 boundaryEvent nel processo secondario.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''eng_handle_event_int'', c_load_lang, q''[Errore interno motore flusso: processo %0 flusso secondario %1 modulo %2 corrente tag %4 corrente %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-unsupported-object'', c_load_lang, q''[Errore di modello: il passo successivo del modello BPMN del processo utilizza l''oggetto non supportato %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[Errore dell''applicazione: ID processo %0 non trovato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[Errore dell''applicazione: l''ID flusso secondario fornito ( %0 ) esiste ma non \00E8 figlio dell''ID processo fornito ( %1 ).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[ID flusso secondario fornito ( %0 ) non trovato. Controllare gli eventi di processo che hanno modificato il flusso del processo (timeout, errori, escalation).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-invalid-route'', c_load_lang, q''[Errore nel gateway %0. La variabile %1 fornita contiene un percorso non valido: %2]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-merge-error'', c_load_lang, q''[Errore interno durante l''elaborazione del gateway di unione nel flusso secondario %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''gateway-no-route'', c_load_lang, q''[Nessuna istruzione di instradamento gateway fornita nella variabile %0 e il modello non contiene un instradamento predefinito.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[Espressione di instradamento del gateway non valida. Ci\00F2 pu\00F2 verificarsi se si tenta di associare una variabile con due punti (:).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[Elabora gli oggetti per %0 attualmente bloccati da un altro utente. Riprovare pi\00F9 tardi.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[Trovati pi\00F9 di 1 percorso di inoltro quando ne sono consentiti solo 1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''no_next_step_found'', c_load_lang, q''[Nessun passo successivo trovato nel flusso secondario %0. Controllare il diagramma del processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plsql_script_failed'', c_load_lang, q''[Processo %0: task %1 non riuscito a causa di un errore PL/SQL. Vedere il log eventi.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plsql_script_requested_stop'', c_load_lang, q''[Processo %0: il task %1 ha richiesto l''arresto dell''elaborazione - Vedere il log eventi.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[Impossibile bloccare il flusso secondario %0 in quanto attualmente bloccato da un altro utente. Riprovare pi\00F9 tardi.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[Prenotazione gi\00E0 effettuata per il task successivo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[Impossibile trovare il diagramma rilasciato o la versione bozza 0 del diagramma. Specificare una versione o diagram_id]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''version-not-found'', c_load_lang, q''[Impossibile trovare la versione del diagramma specificata. Controllare la specifica della versione.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer_definition_error'', c_load_lang, q''[Errore durante l''analisi della definizione del timer nel processo %0, flusso secondario %1. Tipo timer: %2, Definizione: %3]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-model-no-version'', c_load_lang, q''[Versione non definita.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[Errore durante l''analisi delle variabili del processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-route-not-define'', c_load_lang, q''[Gateway non definito per l''instradamento.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[La definizione del gateway non esiste per questo flusso.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[Impossibile ottenere l''ID istanza flusso e/o l''ID flusso secondario per gestire il passo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[Numero di elementi o variabili di processo APEX errato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[Una o pi\00F9 variabili di processo sono di tipo diverso da quello definito nel file JSON.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 non \00E8 un numero valido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 non \00E8 una data valida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[Il file JSON fornito non \00E8 valido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[Nessun dato trovato. Verificare se esiste un diagramma con l''ID specificato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-unexpected-error'', c_load_lang, q''[Errore imprevisto. Contattare l''amministratore.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[Impossibile analizzare il diagramma.<br />Controllare il diagramma per assicurarsi che sia supportato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-diagram-saved'', c_load_lang, q''[Modifiche salvate.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[Il modello \00E8 stato modificato. Ignorare le modifiche?]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito: l''area di lavoro predefinita definita nel parametro di configurazione non \00E8 valida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''workspace-not-found'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito: impossibile trovare l''area di lavoro associata all''ID applicazione definito nel diagramma. Controllare il modello.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-from'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito: attributo "Da" e mittente e-mail predefinito non definiti. Controllare il modello e il parametro di configurazione.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-to'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito: attributo "A" non definito. Controllare il modello.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-template'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito: attributo "Template" non definito. Controllare il modello.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-no-body'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito: attributo "Corpo" non definito. Controllare il modello.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''email-failed'', c_load_lang, q''[Processo %0: ServiceTask %1 non riuscito. Vedere il log degli errori e controllare il modello.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[Processo %0: ServiceTask %1 segnaposto JSON non \00E8 valido. Controllare il modello.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[Trovate pi\00F9 righe. Abilitare l''impostazione ''Abilita attivit\00E0 chiamata'' negli attributi del plugin del visualizzatore.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-cancelation-error'', c_load_lang, q''[Errore durante il tentativo di annullare il task del workflow APEX (task_id: %1 ) per il passo del processo: %0.)]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-supported'', c_load_lang, q''[L''uso della funzione di workflow APEX richiede Oracle APEX v%0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_date_format'', c_load_lang, q''[Errore durante l''impostazione della variabile di processo %1: Formato data errato (flusso secondario: %0, set: %3).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_object_not_found'', c_load_lang, q''[Errore interno durante la ricerca dell''oggetto %0 in process_expressions. Errore SQL visualizzato nell''output di debug.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_plsql_error'', c_load_lang, q''[Flusso secondario: %0 Errore nell''espressione %2 per la variabile: %1]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_no_data'', c_load_lang, q''[Errore durante l''impostazione della variabile di processo %1 nell''ID processo %0 (set %2). Nessun dato trovato nella query.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[Si \00E8 tentato di avviare un processo con un diagramma %0 che include un callActivity che si chiama.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[Pi\00F9 di un instradamento predefinito nel modello per il gateway %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''link-no-catch'', c_load_lang, q''[Impossibile trovare l''evento di recupero collegamento corrispondente denominato %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[Pi\00F9 di un evento di recupero collegamento corrispondente denominato %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-instance-event'', c_load_lang, q''[Flussi - Errore interno durante la registrazione di un evento istanza]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-step-event'', c_load_lang, q''[Flussi - Errore interno durante la registrazione di un evento passo]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[Errore durante l''impostazione della variabile di processo %1 nell''ID processo %0 (set %2). La query restituisce pi\00F9 righe.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_static_general'', c_load_lang, q''[Errore durante l''impostazione della variabile di processo %1 nell''ID processo %0 (set %2). Vedere l''errore nel log eventi.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_sql_other'', c_load_lang, q''[Errore durante l''impostazione della variabile di processo %1 nell''ID processo %0 (set %2). Errore SQL visualizzato nel log eventi.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''feature-requires-ee'', c_load_lang, q''[elaborazione di questa funzione richiede la concessione di licenze per i Flows for APEX Enterprise Edition.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''iter_close_error'', c_load_lang, q''[Internal errore durante l''elaborazione dell iterazione chiusa nel flusso secondario %0]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[Errore durante impostazione della variabile di processo %1 - ID processo %0 (set %2).  La query restituisce pi\00F9 di un valore.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_json_format'', c_load_lang, q''[Errore durante impostazione della variabile di processo %1: formato JSON errato (flusso secondario: %0, set: %3).]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''iter_lock_error'', c_load_lang, q''[Error dettaglio iterazione di blocco (iter %0 loop %2) per ID processo %1.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[Prenotazione per %0 non riuscita. Passo gi\00E0 riservato da un altro utente (%1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-failed-not-found'', c_load_lang, q''[Prenotazione per %2 non riuscita. Flusso secondario %0 nel processo %1 non trovato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[Il task non \00E8 pi\00F9 corrente, probabilmente gi\00E0 completato. Aggiornare la posta in arrivo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-lock-timeout'', c_load_lang, q''[Flusso secondario attualmente bloccato (non riservato) da un altro utente. Prova la tua prenotazione in seguito.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''reservation-release-not-found'', c_load_lang, q''[Rilascio prenotazione non riuscito. Flusso secondario %0 nel processo %1 non trovato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''restart-no-error'', c_load_lang, q''[Nessun errore corrente trovato. Controllare il diagramma del processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[Si \00E8 tentato di avviare un processo (ID %0) gi\00E0 in esecuzione.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-variable-event'', c_load_lang, q''[Flussi - Errore interno durante la registrazione di un evento variabile]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[Si \00E8 tentato di avviare un processo (ID %0) con pi\00F9 copie gi\00E0 in esecuzione.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[Sono stati definiti pi\00F9 eventi di avvio. Assicurarsi che il diagramma contenga un solo evento iniziale.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-no-start-event'', c_load_lang, q''[Nessun evento iniziale definito nel diagramma di flusso.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[Si \00E8 tentato di avviare un processo (ID %0) che non esiste.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-type-unsupported'', c_load_lang, q''[Tipo di evento iniziale non supportato (%0). Attualmente sono supportati solo gli eventi di avvio Nessuno (standard) e gli eventi di inizio timer.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[Inizio Registrazione tempo di lavoro non riuscita.  Flusso secondario %0 nel processo %1 non trovato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[Questo passo del processo \00E8 gi\00E0 stato eseguito. (\00C8 stata fornita una chiave passo %0 errata mentre era prevista la chiave passo %1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[Timer per il flusso secondario %0 attualmente bloccato da un altro utente. Riprovare pi\00F9 tardi.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-object-not-found'', c_load_lang, q''[Oggetto con timer non trovato in get_timer_definition. Flusso secondario %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[Timer per il processo %0 attualmente bloccati da un altro utente. Riprovare pi\00F9 tardi.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-set-error'', c_load_lang, q''[Errore durante la creazione della variabile di processo %0 per l''ID processo %1 nell''ambito %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-update-error'', c_load_lang, q''[Errore durante l''aggiornamento della variabile di processo %0 per l''ID processo %1 nell''ambito %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-delete-error'', c_load_lang, q''[Errore durante l''eliminazione della variabile di processo %0 per l''ID processo %1 nell''ambito %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var-lock-error'', c_load_lang, q''[Errore durante il blocco della variabile di processo %0 per l''ID processo %1 nell''ambito %2.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''var_exp_datatype'', c_load_lang, q''[Errore durante l''impostazione della variabile di processo. Tipo di dati errato per la variabile %0. Errore SQL visualizzato nell''output di debug.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''subProcess-no-start'', c_load_lang, q''[Impossibile trovare l''evento di inizio del processo secondario.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[Sono stati trovati pi\00F9 processi secondari.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-broken'', c_load_lang, q''[Timer %0 Esecuzione %4 interrotto nel processo %1, flusso secondario: %2. Vedere error_info.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[Il timer del ciclo definito per l''oggetto %0 non \00E8 at')))
);
end;
/
begin
wwv_flow_imp_shared.append_to_install_script(
 p_id=>wwv_flow_imp.id(15944759485138892)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'tualmente supportato.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-incomplete-definition'', c_load_lang, q''[Definizioni timer incomplete per l''oggetto %0. Tipo: %1; Value1: %2 Value2: %3  Value3: %4]'' );',
'  ',
'  commit;',
'end;',
'/',
''))
);
null;
end;
/
prompt --application/deployment/install/install_engine_messages_japanese_1
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15944907155140405)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Japanese (1)'
,p_sequence=>120
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_ja.sql',
'--',
'-- Engine Messages for language code "ja"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "ja"',
'declare',
'  c_load_lang constant varchar2(10) := ''ja'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[\30BF\30B9\30AF\306F\65E2\306B\7D42\4E86\3057\3066\3044\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002  \53D7\4FE1\30C8\30EC\30A4\3092\66F4\65B0\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[\73FE\5728\3001\30B5\30D6\30D5\30ED\30FC\306F\4ED6\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\FF08\4E88\7D04\3055\308C\3066\3044\307E\305B\3093\FF09\3002  \5F8C\307B\3069\3001\518D\8A66\884C\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[\4E88\7D04\306E\89E3\9664\306B\5931\6557\3057\307E\3057\305F\3002  \30D7\30ED\30BB\30B9\FF05\FF11\5185\306E\30B5\30D6\30D5\30ED\30FC %0 \304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[\30A8\30E9\30FC\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002  \30D7\30ED\30BB\30B9\30C0\30A4\30A2\30B0\30E9\30E0\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[\30D7\30ED\30BB\30B9 (id %0) \306F\65E2\306B\5B9F\884C\4E2D\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[\30B3\30FC\30EB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\3092\542B\3080\30C0\30A4\30A2\30B0\30E9\30E0%0\3067\30D7\30ED\30BB\30B9\3092\958B\59CB\3057\3088\3046\3068\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[\30D7\30ED\30BB\30B9 (id %0) \306B\304A\3044\3066\65E2\306B\8907\6570\306E\30B3\30D4\30FC\304C\5B9F\884C\4E2D\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[\8907\6570\306E\958B\59CB\30A4\30D9\30F3\30C8\304C\5B9A\7FA9\3055\308C\3066\3044\307E\3059\3002\30C0\30A4\30A2\30B0\30E9\30E0\306E\958B\59CB\30A4\30D9\30F3\30C8\304C1\3064\306E\307F\3068\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-no-start-event'', c_load_lang, q''[\30D5\30ED\30FC\56F3\306B\958B\59CB\30A4\30D9\30F3\30C8\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[\30D7\30ED\30BB\30B9 (id %0) \306F\5B58\5728\3057\306A\3044\305F\3081\958B\59CB\3067\304D\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8%0\306E\975E\540C\671F\63A5\7D9A\3092\4F5C\6210\3067\304D\307E\305B\3093\3002\30E6\30FC\30B6\30FC\540D\306F\3001\30D7\30ED\30BB\30B9\5909\6570\3001\30D7\30ED\30BB\30B9\56F3\307E\305F\306F\30B7\30B9\30C6\30E0\69CB\6210\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8%0\306E\975E\540C\671F\63A5\7D9A\3092\4F5C\6210\3067\304D\307E\305B\3093\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306F\3001\30D7\30ED\30BB\30B9\5909\6570\3001\30D7\30ED\30BB\30B9\30FB\30C0\30A4\30A2\30B0\30E9\30E0\307E\305F\306F\30B7\30B9\30C6\30E0\69CB\6210\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[\3053\306E\30D7\30ED\30BB\30B9\30FB\30B9\30C6\30C3\30D7\306F\65E2\306B\767A\751F\3057\3066\3044\307E\3059\3002  (\30B9\30C6\30C3\30D7\30FB\30AD\30FC %1 \306E\4EE3\308F\308A\306B\8AA4\3063\3066\30B9\30C6\30C3\30D7\30FB\30AD\30FC %0 \304C\4F9B\7D66\3055\308C\307E\3057\305F\3002\FF09]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-no-start'', c_load_lang, q''[\30B5\30D6\30D7\30ED\30BB\30B9\958B\59CB\30A4\30D9\30F3\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[\8A2D\5B9A\3067\306F\3001\30D7\30ED\30BB\30B9ID\306A\3057\3067\30D7\30ED\30BB\30B9\5909\6570\3092\6307\5B9A\3067\304D\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[\5B9F\884C\4E2D\306E\30A4\30F3\30B9\30BF\30F3\30B9\304C\3042\308B\30C0\30A4\30A2\30B0\30E9\30E0\3092\30A2\30FC\30AB\30A4\30D6\3057\3088\3046\3068\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-diagram-event'', c_load_lang, q''[\30D5\30ED\30FC- \30C0\30A4\30A2\30B0\30E9\30E0\30FB\30A4\30D9\30F3\30C8\306E\30ED\30AE\30F3\30B0\4E2D\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[\30D7\30ED\30BB\30B9\30FB\30A4\30F3\30B9\30BF\30F3\30B9%0\306E\30A4\30F3\30B9\30BF\30F3\30B9\8981\7D04\306E\30A2\30FC\30AB\30A4\30D6\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[\30E1\30C3\30BB\30FC\30B8\53D7\4FE1\8005\306F\30B5\30D6\30D5\30ED\30FC\3092\30ED\30C3\30AF\3067\304D\307E\305B\3093\3002\518D\5EA6\8A66\3057\3066\307F\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[\8A2D\5B9A\306E\8A55\4FA1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\5F0F\304C\7121\52B9\3067\3059\3002\5F0F: %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[MessageFlow\6307\5B9A\3055\308C\305F\30A8\30F3\30C9\30DD\30A4\30F3\30C8( %0 )\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[\30E1\30C3\30BB\30FC\30B8\30FB\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\306F\5225\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002\518D\5EA6\8A66\3057\3066\307F\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[\627F\8A8D\30BF\30B9\30AF\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F- \30D3\30B8\30CD\30B9\53C2\7167/\30EC\30B3\30FC\30C9\306E\30B7\30B9\30C6\30E0\4E3B\30AD\30FC\306Fnull\306B\3067\304D\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[\671F\65E5\306E\8A55\4FA1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\9593\9694\5F0F\304C\7121\52B9\3067\3059\3002\9593\9694: %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[\671F\65E5\8A55\4FA1\306E\969B\306B\30A8\30E9\30FC\304C\51FA\307E\3057\305F\3002\671F\65E5\8868\793A\304C\7121\52B9\3067\3059\3002\9593\9694\8868\793A\FF1A%0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[\512A\5148\9806\4F4D\306E\8A55\4FA1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\512A\5148\5EA6\5F0F\304C\7121\52B9\3067\3059\3002\5F0F: %0\3002\304B\308F\308A\306B\512A\5148\5EA63\304C\4F7F\7528\3055\308C\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[\30D7\30ED\30BB\30B9\5909\6570\306B\7121\52B9\306A\30B9\30B3\30FC\30D7(%0)\304C\6307\5B9A\3055\308C\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[\30DB\30B9\30C8(%0)\304C\8981\6C42\3057\305F\9593\9694%1\306B\5BFE\3057\3066\30BF\30A4\30DE\30FC\306E\7E70\8FD4\3057\9593\9694\304C\983B\7E41\3059\304E\307E\3059\30021\5206\3088\308A\9577\304F\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[\30A2\30FC\30AB\30A4\30D6\5148\69CB\6210\30D1\30E9\30E1\30FC\30BF\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30D1\30E9\30E1\30FC\30BF: %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[\53D7\4FE1\3057\305F\30E1\30C3\30BB\30FC\30B8\304C\4E88\671F\3055\308C\305F\30E1\30C3\30BB\30FC\30B8\3068\4E00\81F4\3057\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[\30E1\30C3\30BB\30FC\30B8\3092\53D7\4FE1\3059\308B\30D7\30ED\30BB\30B9\30FB\30B9\30C6\30C3\30D7\304C\3059\3067\306B\767A\751F\3057\307E\3057\305F(\4E0D\6B63\306A\30B9\30C6\30C3\30D7\30FB\30AD\30FC\304C\6307\5B9A\3055\308C\307E\3057\305F)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[\30B9\30BF\30FC\30C8\30A4\30D9\30F3\30C8\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002(%0 ) \73FE\5728\3001\6A19\6E96\30E1\30C3\30BB\30FC\30B8\304A\3088\3073\30BF\30A4\30DE\30FC\30B9\30BF\30FC\30C8\30A4\30D9\30F3\30C8\306E\307F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[\958B\59CB\4F5C\696D\6642\9593\306E\8A18\9332\306B\5931\6557\3057\307E\3057\305F\3002  \30D7\30ED\30BB\30B9%1 \306E\30B5\30D6\30D5\30ED\30FC %0 \304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[\3053\306E\6A5F\80FD\3092\51E6\7406\3059\308B\306B\306F\3001Flow for APEX Enterprise Edition\306E\30E9\30A4\30BB\30F3\30B9\304C\5FC5\8981\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[\30B5\30D6\30D5\30ED\30FC%0\306E\53CD\5FA9\30AF\30ED\30FC\30BA\306E\51E6\7406\4E2D\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[\30D7\30ED\30BB\30B9ID %0 (\30BB\30C3\30C8%2)\3067\30D7\30ED\30BB\30B9\5909\6570%1\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\554F\5408\305B\306B\3088\3063\3066\8907\6570\306E\5024\304C\8FD4\3055\308C\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[\30D7\30ED\30BB\30B9\5909\6570%1\306E\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: JSON\30D5\30A9\30FC\30DE\30C3\30C8\304C\6B63\3057\304F\3042\308A\307E\305B\3093(\30B5\30D6\30D5\30ED\30FC: %0\3001\30BB\30C3\30C8: %3)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[\30D7\30ED\30BB\30B9ID %1\306E\53CD\5FA9\8A73\7D30(\53CD\5FA9%0\30EB\30FC\30D7%2)\3092\30ED\30C3\30AF\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[APEX\30EF\30FC\30AF\30D5\30ED\30FC\30FB\30BF\30B9\30AF\306E\7D50\679C\30D7\30ED\30BB\30B9\5909\6570\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\304B\3001\7121\52B9\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8%0\306E\975E\540C\671F\63A5\7D9A\3092\4F5C\6210\3067\304D\307E\305B\3093\3002\30DA\30FC\30B8ID\306F\3001\30D7\30ED\30BB\30B9\5909\6570\3001\30D7\30ED\30BB\30B9\30FB\30C0\30A4\30A2\30B0\30E9\30E0\307E\305F\306F\30B7\30B9\30C6\30E0\69CB\6210\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[%0 \306E\5B50\30D0\30A6\30F3\30C0\30EA\30FB\30B5\30D6\30D5\30ED\30FC\307E\305F\306F\30BF\30A4\30DE\30FC\306F\73FE\5728\4ED6\306E\30E6\30FC\30B6\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002  \5F8C\3067\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\3092\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-variable-event'', c_load_lang, q''[\30D5\30ED\30FC - \5909\6570\30A4\30D9\30F3\30C8\306E\30ED\30B0\8A18\9332\6642\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[%0 \306E\30D7\30ED\30BB\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\73FE\5728\4ED6\306E\30E6\30FC\30B6\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002  \5F8C\3067\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[\8907\6570\306E\30D5\30A9\30EF\30FC\30C9\30D1\30B9\304C\898B\3064\304B\308A\307E\3057\305F\3002\30D1\30B9\306F\4E00\3064\306E\307F\53EF\80FD\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[\30B5\30D6\30D5\30ED\30FC %0 \3067\6B21\306E\30B9\30C6\30C3\30D7\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002  \30D7\30ED\30BB\30B9\56F3\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_failed'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: PL/SQL \30A8\30E9\30FC\304C\767A\751F\3057\305F\305F\3081\3001\30BF\30B9\30AF\FF05\FF11\306B\5931\6557\3057\307E\3057\305F\3002\30A4\30D9\30F3\30C8\30FB\30ED\30B0\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: \30BF\30B9\30AF\FF05\FF11\304C\51E6\7406\306E\505C\6B62\3092\8981\6C42\3057\307E\3057\305F - \30A4\30D9\30F3\30C8\30FB\30ED\30B0\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[\30B5\30D6\30D5\30ED\30FC %0 \306F\73FE\5728\4ED6\306E\30E6\30FC\30B6\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\308B\305F\3081\3001\30ED\30C3\30AF\3067\304D\307E\305B\3093\3002  \5F8C\3067\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[\6B21\306E\30BF\30B9\30AF\306E\4E88\7D04\306F\3059\3067\306B\3055\308C\3066\3044\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[\FF050 \306E\4E88\7D04\306B\5931\6557\3057\307E\3057\305F\3002  \30B9\30C6\30C3\30D7\306F\65E2\306B\4ED6\306E\30E6\30FC\30B6\306B\3088\3063\3066\4E88\7D04\3055\308C\3066\3044\307E\3059(%1)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[%2\306E\4E88\7D04\306B\5931\6557\3057\307E\3057\305F\3002  \30D7\30ED\30BB\30B9\5185\306E\30B5\30D6\30D5\30ED\30FC %0 \304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[\8907\6570\306E\30B5\30D6\30D7\30ED\30BB\30B9\30FB\30B9\30BF\30FC\30C8\304C\898B\3064\304B\308A\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-broken'', c_load_lang, q''[\30BF\30A4\30DE \30FC%0\3000\5B9F\884C%4 \304C\30D7\30ED\30BB\30B9%1 \3068\30B5\30D6\30D5\30ED\30FC%2\3067\5931\6557\3057\307E\3057\305F\3002error_info \3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8 %0 \306E\30BF\30A4\30DE\30FC\5B9A\7FA9\304C\4E0D\5B8C\5168\3067\3059\3002\30BF\30A4\30D7: %1; \50241: %2  \50242: %3 \50243: %4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[\30B5\30D6\30D5\30ED\30FC %0 \306E\30BF\30A4\30DE\30FC\306F\73FE\5728\4ED6\306E\30E6\30FC\30B6\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002  \5F8C\3067\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-object-not-found'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8\306E\30BF\30A4\30DE\30FC\304C get_timer_definition \3067\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002\30B5\30D6\30D5\30ED\30FC %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0 \306E\30BF\30A4\30DE\30FC\306F\73FE\5728\4ED6\306E\30E6\30FC\30B6\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002  \5F8C\3067\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[\30B9\30B3\30FC\30D7%2\306E\30D7\30ED\30BB\30B9ID %1\306E\30D7\30ED\30BB\30B9\5909\6570%0\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[\30B9\30B3\30FC\30D7%2\306E\30D7\30ED\30BB\30B9ID %1\306E\30D7\30ED\30BB\30B9\5909\6570%0\3092\53D6\5F97\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[\30B9\30B3\30FC\30D7%2\306E\30D7\30ED\30BB\30B9ID %1\306E\30D7\30ED\30BB\30B9\5909\6570%0\3092\66F4\65B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[\30B9\30B3\30FC\30D7%2\306E\30D7\30ED\30BB\30B9ID %1\306E\30D7\30ED\30BB\30B9\5909\6570%0\3092\524A\9664\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[\30B9\30B3\30FC\30D7%2\306E\30D7\30ED\30BB\30B9ID %1\306E\30D7\30ED\30BB\30B9\5909\6570%0\306E\30ED\30C3\30AF\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[\30D7\30ED\30BB\30B9\5909\6570\306E\8A2D\5B9A\30A8\30E9\30FC\3002  \5909\6570 %0 \306E\30C7\30FC\30BF\578B\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002  \30C7\30D0\30C3\30B0\51FA\529B\306B SQL \30A8\30E9\30FC\304C\8868\793A\3055\308C\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[\30D7\30ED\30BB\30B9\5909\6570 %1 \306E\8A2D\5B9A\30A8\30E9\30FC : \65E5\4ED8\306E\5F62\5F0F\304C\6B63\3057\304F\3042\308A\307E\305B\3093 (\30B5\30D6\30D5\30ED\30FC: %0\3001\8A2D\5B9A: %3)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[process_expressions \306E\30AA\30D6\30B8\30A7\30AF\30C8 %0 \306E\691C\7D22\3067\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002  \30C7\30D0\30C3\30B0\51FA\529B\306B SQL \30A8\30E9\30FC\304C\8868\793A\3055\308C\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[\30B5\30D6\30D5\30ED\30FC :% 0 \5909\6570 : %1\306E%2\306B\304A\3044\3066\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_no_data'', c_load_lang, q''[\30D7\30ED\30BB\30B9ID %0 (\30BB\30C3\30C8%2)\3067\30D7\30ED\30BB\30B9\5909\6570%1\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\554F\5408\305B\306B\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_other'', c_load_lang, q''[\30D7\30ED\30BB\30B9ID %0 (\30BB\30C3\30C8%2)\3067\30D7\30ED\30BB\30B9\5909\6570%1\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30A4\30D9\30F3\30C8\30ED\30B0\306BSQL\30A8\30E9\30FC\304C\8868\793A\3055\308C\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[\30D7\30ED\30BB\30B9ID %0 (\30BB\30C3\30C8%2)\3067\30D7\30ED\30BB\30B9\5909\6570%1\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30AF\30A8\30EA\30FC\306F\8907\6570\306E\884C\3092\8FD4\3057\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_static_general'', c_load_lang, q''[\30D7\30ED\30BB\30B9ID %0 (\30BB\30C3\30C8%2)\3067\30D7\30ED\30BB\30B9\5909\6570%1\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30A4\30D9\30F3\30C8\30ED\30B0\306E\30A8\30E9\30FC\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[\30EA\30EA\30FC\30B9\3055\308C\305F\30C0\30A4\30A2\30B0\30E9\30E0\307E\305F\306F\30C9\30E9\30D5\30C8\72480\304C\898B\3064\304B\308A\307E\305B\3093 - \30D0\30FC\30B8\30E7\30F3\307E\305F\306Fdiagram_id\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[\6307\5B9A\3055\308C\305F\30C0\30A4\30A2\30B0\30E9\30E0\30FB\30D0\30FC\30B8\30E7\30F3\304C\898B\3064\304B\308A\307E\305B\3093\3002\30D0\30FC\30B8\30E7\30F3\6307\5B9A\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0\3001\30B5\30D6\30D5\30ED\30FC %1 \3067\30BF\30A4\30DE\30FC\5B9A\7FA9\306E\89E3\6790\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30BF\30A4\30DE\30FC\30BF\30A4\30D7: %2, \5B9A\7FA9: %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[\30D0\30FC\30B8\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[\30D7\30ED\30BB\30B9\5909\6570\306E\30D1\30FC\30B7\30F3\30B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[\30B2\30FC\30C8\30A6\30A7\30A4\304C\30EB\30FC\30C6\30A3\30F3\30B0\7528\306B\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[\3053\306E\30D5\30ED\30FC\306B\306F\30B2\30FC\30C8\30A6\30A7\30A4\5B9A\7FA9\304C\5B58\5728\3057\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8 %0 \3067\5B9A\7FA9\3055\308C\305F\30B5\30A4\30AF\30EB\30FB\30BF\30A4\30DE\30FC\306F\3001\73FE\5728\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[\30B9\30C6\30C3\30D7\3092\7BA1\7406\3059\308B\305F\3081\306E\30D5\30ED\30FC\30A4\30F3\30B9\30BF\30F3\30B9ID\3001\307E\305F\306F\30B5\30D6\30D5\30ED\30FCID\3092\53D6\5F97\3067\304D\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[APEX\9805\76EE\307E\305F\306F\30D7\30ED\30BB\30B9\5909\6570\306E\6570\304C\9593\9055\3063\3066\3044\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[1\3064\4EE5\4E0A\306E\30D7\30ED\30BB\30B9\5909\6570\304C\3001JSON\3067\5B9A\7FA9\3055\308C\305F\3082\306E\3068\7570\306A\308B\30BF\30A4\30D7\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[0 \306F\6709\52B9\306A\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[0 \306F\6709\52B9\306A\65E5\4ED8\3067\306F\3042\308A\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[\63D0\4F9B\3055\308C\305FJSON\306F\7121\52B9\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002\6307\5B9A\3055\308C\305FID\306E\30C0\30A4\30A2\30B0\30E9\30E0\304C\5B58\5728\3059\308B\304B\3069\3046\304B\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-unexpected-error'', c_load_lang, q''[\4F8B\5916\30A8\30E9\30FC\767A\751F\3002\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[\30C0\30A4\30A2\30B0\30E9\30E0\3092\30D1\30FC\30B9\3059\308B\3053\3068\304C\3067\304D\307E\305B\3093\3067\3057\305F\3002\3053\306E\30C0\30A4\30A2\30B0\30E9\30E0\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\304B\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[\30E2\30C7\30EB\304C\5909\66F4\306B\306A\308A\307E\3057\305F\3002\5909\66F4\3057\3066\3088\308D\3057\3044\3067\3059\304B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: ServiceTask %1 \306B\5931\6557\3057\307E\3057\305F: \69CB\6210\30D1\30E9\30E1\30FC\30BF\3067\5B9A\7FA9\3055\308C\305F\65E2\5B9A\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\7121\52B9\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: ServiceTask %1 \306B\5931\6557\3057\307E\3057\305F: \30C0\30A4\30A2\30B0\30E9\30E0\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3 ID \306B\95A2\9023\4ED8\3051\3089\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\898B\3064\304B\308A\307E\305B \3093\3002\30E2\30C7\30EB\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: ServiceTask %1 \306B\5931\6557\3057\307E\3057\305F\3002: "From" \3068\65E2\5B9A\306EE\30E1\30FC\30EB\9001\4FE1\8005\304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002 \30E2\30C7\30EB\307E\305F\306F\8A2D\5B9A\30D1\30E9\30E1\30FC\30BF\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: \30B5\30FC\30D3\30B9\30BF\30B9\30AF %1 \306B\5931\6557\3057\307E\3057\305F\3002:  "To" \304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002\30E2\30C7\30EB\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: \30B5\30FC\30D3\30B9\30BF\30B9\30AF%1\306B\5931\6557\3057\307E\3057\305F\3002: "Template" \304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002\30E2\30C7\30EB\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: \30B5\30FC\30D3\30B9\30BF\30B9\30AF%1\306B\5931\6557\3057\307E\3057\305F\3002: "Body" \304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002\30E2\30C7\30EB\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: \30B5\30FC\30D3\30B9\30BF\30B9\30AF%1\306B\5931\6557\3057\307E\3057\305F\3002\30A8\30E9\30FC\30FB\30ED\30B0\3092\53C2\7167\3057\3066\3001\30E2\30C7\30EB\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[\30D7\30ED\30BB\30B9 %0: \30B5\30FC\30D3\30B9\30BF\30B9\30AF \30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC JSON \304C\7121\52B9\3067\3059\3002\30E2\30C7\30EB\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[\8907\6570\306E\884C\304C\898B\3064\304B\308A\307E\3057\305F\3002\30D3\30E5\30FC\30A2\30FB\30D7\30E9\30B0\30A4\30F3\5C5E\6027\3067\300C\30B3\30FC\30EB\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\6709\52B9\5316\300D\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-cancelation-error'', c_load_lang, q''[\30D7\30ED\30BB\30B9\30FB\30B9\30C6\30C3\30D7: %0\306EAPEX\30EF\30FC\30AF\30D5\30ED\30FC\30FB\30BF\30B9\30AF(task_id: %1)\3092\53D6\308A\6D88\305D\3046\3068\3057\3066\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[APEX\30EF\30FC\30AF\30D5\30ED\30FC\6A5F\80FD\3092\4F7F\7528\3059\308B\306B\306F\3001Oracle APEX v%0\304C\5FC5\8981\3067\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-found'', c_load_lang, q''[Flows for Apex\306E\30D7\30ED\30BB\30B9\4E2D\306BAPEX\30EF\30FC\30AF\30D5\30ED\30FC\30FB\30BF\30B9\30AF%0\304C\898B\3064\304B\308A\307E\305B\3093]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[\30B5\30D6\30D5\30ED\30FC %0 \3067\30DE\30FC\30B8\30FB\30B2\30FC\30C8\30A6\30A7\30A4\3092\51E6\7406\3059\308B\969B\306E\5185\90E8\30A8\30E9\30FC\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[\5909\6570 %0 \3067\30B2\30FC\30C8\30A6\30A7\30A4\30FB\30EB\30FC\30C6\30A3\30F3\30B0\304C\6307\5B9A\3055\308C\3066\3044\306A\304F\3001\30E2\30C7\30EB\306B\306F\30C7\30D5\30A9\30EB\30C8\30FB\30EB\30FC\30C8\304C\3042\308A\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[\4E0D\6B63\306A\30B2\30FC\30C8\30A6\30A7\30A4\30FB\30EB\30FC\30C6\30A3\30F3\30B0\3067\3059\3002\3053\308C\306F\3001\57CB\8FBC\307F\30B3\30ED\30F3(: )\3067\5909\6570\3092\30D0\30A4\30F3\30C9\3057\3088\3046\3068\3057\305F\5834\5408\306B\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[\30B2\30FC\30C8\30A6\30A7\30A4 %0 \306E\30E2\30C7\30EB\3067\8907\6570\306E\65E2\5B9A\30EB\30FC\30C8\304C\6307\5B9A\3055\308C\3066\3044\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-no-catch'', c_load_lang, q''[\4E00\81F4\3059\308B\30EA\30F3\30AF\30FB\30AD\30E3\30C3\30C1\30FB\30A4\30D9\30F3\30C8\540D %0 \3092\898B\3064\3051\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[\4E00\81F4\3059\308B\30EA\30F3\30AF\30FB\30AD\30E3\30C3\30C1\30FB\30A4\30D9\30F3\30C8\540D\304C %0 \306E\3082\306E\304C\8907\6570\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-instance-event'', c_load_lang, q''[Flows - \30A4\30F3\30B9\30BF\30F3\30B9\30A4\30D9\30F3\30C8\306E\30ED\30B0\8A18\9332\6642\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-step-event'', c_load_lang, q''[\30D5\30ED\30FC - \30B9\30C6\30C3\30D7\30A4\30D9\30F3\30C8\306E\30ED\30B0\8A18\9332\6642\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[\73FE\5728\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30BF\30A4\30D7\306E\4E2D\9593\30B9\30ED\30FC\30A4\30D9\30F3\30C8\304C %0 \3067\767A\751F\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8%0\306E\975E\540C\671F\63A5\7D9A\8A73\7D30\306F\3001\30D7\30ED\30BB\30B9\5909\6570\3001\30C0\30A4\30A2\30B0\30E9\30E0\975E\540C\671F\63A5\7D9A\8A73\7D30\307E\305F\306F\30B7\30B9\30C6\30E0\69CB\6210\8A73\7D30\3067\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[\30AA\30D6\30B8\30A7\30AF\30C8%0\306E\975E\540C\671F\63A5\7D9A\3092\4F5C\6210\3067\304D\307E\305B\3093\3002\6307\5B9A\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\30E6\30FC\30B6\30FC\540D\304C\7121\52B9\3067\3059]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[\8907\6570\306EFlows for APEX\30D7\30ED\30BB\30B9\30FB\30B9\30C6\30C3\30D7\306B\95A2\9023\3059\308BAPEX\30EF\30FC\30AF\30D5\30ED\30FC\30FB\30BF\30B9\30AF%0\304C\898B\3064\304B\308A\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[APEX\30EF\30FC\30AF\30D5\30ED\30FC\30FB\30BF\30B9\30AF%0\306F\30D7\30ED\30BB\30B9\306E\73FE\5728\306E\30B9\30C6\30C3\30D7\3067\306F\3042\308A\307E\305B\3093\3002\30B9\30C6\30C3\30D7\304C\5B8C\4E86\3057\3066\3044\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%1\3067APEX\30EF\30FC\30AF\30D5\30ED\30FC\30FB\30BF\30B9\30AF%0\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\8A73\7D30\306F\30C7\30D0\30C3\30B0\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[\512A\5148\9806\4F4D\306E\8A55\4FA1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\512A\5148\5EA6\306F1\304B\30895\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\512A\5148\5EA6: %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[APEX\30BB\30C3\30B7\30E7\30F3\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002BPMN\30C0\30A4\30A2\30B0\30E9\30E0\306B\3001\8907\6570\306E\30D7\30ED\30BB\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\542B\307E\308C\3066\3044\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[\30B3\30FC\30EB\4E0D\53EF\306E\30C0\30A4\30A2\30B0\30E9\30E0%0\3092\30B3\30FC\30EB\3057\3088\3046\3068\3057\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[\30A4\30D9\30F3\30C8\3092\6355\6349\3059\308B\305F\3081\306E\30BF\30A4\30D7 %0 \306E boundaryEvent \304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[\30B5\30D6\30D7\30ED\30BB\30B9\3067 1 \3064\4EE5\4E0A\306E %0 boundaryEvent \304C\898B\3064\304B\308A\307E\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''eng_handle_event_int'', c_load_lang, q''[\30D5\30ED\30FC\30FB\30A8\30F3\30B8\30F3\5185\90E8\30A8\30E9\30FC\FF1A\30D7\30ED\30BB\30B9 %0 \30B5\30D6\30D5\30ED\30FC%1 \30E2\30B8\30E5\30FC\30EB%2 \73FE\884C %4\73FE\884C\30BF\30B0 %3]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_japanese_2
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15951228099629216)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Japanese (2)'
,p_sequence=>125
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_ja.sql',
'--',
'-- Engine Messages for language code "ja"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "ja"',
'declare',
'  c_load_lang constant varchar2(10) := ''ja'';',
'begin',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[\30E2\30C7\30EB\30FB\30A8\30E9\30FC\3002\30D7\30ED\30BB\30B9 BPMN \30E2\30C7\30EB\306E\6B21\306E\30B9\30C6\30C3\30D7\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30AA\30D6\30B8\30A7\30AF\30C8 %0 \304C\4F7F\7528\3055\308C\3066\3044\307E\3059\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\3002\30D7\30ED\30BB\30B9 ID %0 \304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\3002\6307\5B9A\3055\308C\305F\30B5\30D6\30D5\30ED\30FC ID ( %0 ) \306F\5B58\5728\3057\307E\3059\304C\3001\6307\5B9A\3055\308C\305F\30D7\30ED\30BB\30B9 ID (%1) \306E\5B50\3067\306F\3042\308A\307E\305B\3093\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[\6307\5B9A\3055\308C\305F\30B5\30D6\30D5\30ED\30FC ID ( %0 ) \304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002\30D7\30ED\30BB\30B9\30FB\30D5\30ED\30FC\3092\5909\66F4\3057\305F\30D7\30ED\30BB\30B9\30FB\30A4\30D9\30F3\30C8 (\30BF\30A4\30E0\30A2\30A6\30C8\3001\30A8\30E9\30FC\3001\30A8\30B9\30AB\30EC\30FC\30B7\30E7\30F3) \3092\30C1\30A7\30C3\30AF\3057\3066\304F\3060\3055\3044\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[\30B2\30FC\30C8\30A6\30A7\30A4 %0 \3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\6307\5B9A\3055\308C\305F\5909\6570\306B\7121\52B9\306A\30EB\30FC\30C8\304C\542B\307E\308C\3066\3044\307E\3059: %2]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_korean
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15945127509141899)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Korean'
,p_sequence=>130
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_ko.sql',
'--',
'-- Engine Messages for language code "ko"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "ko"',
'declare',
'  c_load_lang constant varchar2(10) := ''ko'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[\C9C0\C815\B41C \B2E4\C774\C5B4\ADF8\B7A8 \BC84\C804\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \BC84\C804 \C0AC\C591\C744 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0, \D558\C704 \D50C\B85C\C6B0 %1\C5D0\C11C \D0C0\C774\BA38 \C815\C758\B97C \AD6C\BB38 \BD84\C11D\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \D0C0\C774\BA38 \C720\D615: %2, \C815\C758: %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[\BC84\C804\C774 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[\D504\B85C\C138\C2A4 \BCC0\C218\B97C \AD6C\BB38 \BD84\C11D\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[\ACBD\B85C \C9C0\C815\C5D0 \B300\D574 \AC8C\C774\D2B8\C6E8\C774\AC00 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[\C774 \D50C\B85C\C6B0\C5D0 \B300\D55C \AC8C\C774\D2B8\C6E8\C774 \C815\C758\AC00 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[\B2E8\ACC4\B97C \AD00\B9AC\D560 \D50C\B85C\C6B0 \C778\C2A4\D134\C2A4 ID \BC0F/\B610\B294 \D558\C704 \D50C\B85C\C6B0 ID\B97C \AC00\C838\C62C \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[APEX \D56D\BAA9 \C218 \B610\B294 \D504\B85C\C138\C2A4 \BCC0\C218\AC00 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[\D558\B098 \C774\C0C1\C758 \D504\B85C\C138\C2A4 \BCC0\C218\AC00 JSON\C5D0 \C815\C758\B41C \C720\D615\ACFC \B2E4\B985\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0\C740(\B294) \C801\D569\D55C \C22B\C790\AC00 \C544\B2D9\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0\C740(\B294) \C801\D569\D55C \C77C\C790\AC00 \C544\B2D9\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[\C81C\ACF5\B41C JSON\C774 \BD80\C801\D569\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[\B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \C81C\ACF5\B41C ID\B97C \AC00\C9C4 \B2E4\C774\C5B4\ADF8\B7A8\C774 \C874\C7AC\D558\B294\C9C0 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-unexpected-error'', c_load_lang, q''[\C608\C0C1\CE58 \C54A\C740 \C624\B958\C785\B2C8\B2E4. \AD00\B9AC\C790\C5D0\AC8C \BB38\C758\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[\B2E4\C774\C5B4\ADF8\B7A8\C758 \AD6C\BB38\C744 \BD84\C11D\D560 \C218 \C5C6\C2B5\B2C8\B2E4.<br />\B2E4\C774\C5B4\ADF8\B7A8\C774 \C9C0\C6D0\B418\B294\C9C0 \AC80\D1A0\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[\BCC0\ACBD \B0B4\C6A9\C774 \C800\C7A5\B418\C5C8\C2B5\B2C8\B2E4!]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C2E4\D328: \AD6C\C131 \B9E4\AC1C\BCC0\C218\C5D0 \C815\C758\B41C \AE30\BCF8 \C791\C5C5 \C601\C5ED\C774 \BD80\C801\D569\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C2E4\D328: \B2E4\C774\C5B4\ADF8\B7A8\C5D0 \C815\C758\B41C \C560\D50C\B9AC\CF00\C774\C158 ID\C640 \C5F0\AD00\B41C \C791\C5C5\C601\C5ED\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \BAA8\B378\C744 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C2E4\D328: \C18D\C131 "\BCF4\B0B8 \C0AC\B78C" \BC0F \AE30\BCF8 \C804\C790\BA54\C77C \BC1C\C2E0\C790\AC00 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \BAA8\B378 \BC0F/\B610\B294 \AD6C\C131 \B9E4\AC1C\BCC0\C218\B97C \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C2E4\D328: \C18D\C131 "\B300\C0C1"\C774 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \BAA8\B378\C744 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C2E4\D328: \C18D\C131 "\D15C\D50C\B9AC\D2B8"\AC00 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \BAA8\B378\C744 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C2E4\D328: \C18D\C131 "\BCF8\BB38"\C774 \C815\C758\B418\C9C0 \C54A\C558\C2B5\B2C8\B2E4. \BAA8\B378\C744 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1\C774(\AC00) \C624\B958 \B85C\ADF8\B97C \D655\C778\D558\ACE0 \BAA8\B378\C744 \AC80\C0AC\D558\C9C0 \BABB\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: ServiceTask %1 \C704\CE58 \D45C\C2DC\C790 JSON\C774 invalid.Please\C785\B2C8\B2E4. \BAA8\B378\C744 \D655\C778\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[\B2E4\C911 \D589\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4. \BDF0\C5B4 \D50C\B7EC\ADF8\C778 \C18D\C131\C5D0\C11C ''\D638\CD9C \D65C\B3D9 \C0AC\C6A9'' \C124\C815\C744 \C0AC\C6A9\C73C\B85C \C124\C815\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-cancelation-error'', c_load_lang, q''[\D504\B85C\C138\C2A4 \B2E8\ACC4 %0\C5D0 \B300\D55C APEX \C6CC\D06C\D50C\B85C\C6B0 \D0DC\C2A4\D06C(task_id: %1)\B97C \CDE8\C18C\D558\B824\ACE0 \C2DC\B3C4\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[APEX Workflow \AE30\B2A5\C744 \C0AC\C6A9\D558\B824\BA74 Oracle APEX v%0\C774(\AC00) \D544\C694\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-found'', c_load_lang, q''[APEX Workflow Task %0\C744(\B97C) Flows for APEX \D504\B85C\C138\C2A4\C5D0\C11C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[APEX Workflow Task %0\AC00 APEX\C758 \D558\B098\C774\C0C1\C758 Flows \D504\B85C\C138\C2A4 \B2E8\ACC4\C640 \C5F0\AD00\C131\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[APEX Workflow Task %0\C774(\AC00) \D504\B85C\C138\C2A4\C758 \D604\C7AC \B2E8\ACC4\AC00 \C544\B2D9\B2C8\B2E4. \B2E8\ACC4\AC00 \BAA8\B4E0 \C900\BE44\B97C \C644\B8CC\D588\C744 \C218 \C788\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[APEX Workflow Task \ACB0\ACFC \D504\B85C\C138\C2A4 \BCC0\C218\AC00 \C815\C758\B418\C9C0 \C54A\C558\AC70\B098 \BD80\C801\D569\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[%1 \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C APEX \C6CC\D06C\D50C\B85C\C6B0 \D0DC\C2A4\D06C %0\C744(\B97C) \C0DD\C131\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C790\C138\D55C \B0B4\C6A9\C740 \B514\BC84\ADF8\B97C \CC38\C870\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[APEX \C6CC\D06C\D50C\B85C\C6B0 \D0DC\C2A4\D06C\B97C \C0DD\C131\D558\B294 \C911 \C624\B958 \BC1C\C0DD - \C6B0\C120\C21C\C704 %0\C774(\AC00) \BD80\C801\D569\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[%0 \AC8C\C774\D2B8\C6E8\C774\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C81C\ACF5\B41C \BCC0\C218 %1\C5D0 \BD80\C801\D569\D55C \ACBD\B85C %2\C774(\AC00) \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[\D558\C704 \D50C\B85C\C6B0 %0\C5D0\C11C \AC8C\C774\D2B8\C6E8\C774 \BCD1\D569\C744 \CC98\B9AC\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[%0 \BCC0\C218\C5D0 \C81C\ACF5\B41C \AC8C\C774\D2B8\C6E8\C774 \ACBD\B85C \C9C0\C815 \C9C0\CE68\C774 \C5C6\ACE0 \BAA8\B378\C5D0 \AE30\BCF8 \ACBD\B85C\AC00 \D3EC\D568\B418\C5B4 \C788\C9C0 \C54A\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[\AC8C\C774\D2B8\C6E8\C774 \ACBD\B85C \C9C0\C815 \D45C\D604\C2DD\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \C774 \C624\B958\B294 \CF5C\B860(:)\C774 \D3EC\D568\B41C \BCC0\C218\B97C \BC14\C778\B4DC\D558\B824\ACE0 \D560 \B54C \BC1C\C0DD\D560 \C218 \C788\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[\D604\C7AC \B2E4\B978 \C0AC\C6A9\C790\AC00 %0\C5D0 \B300\D55C \D504\B85C\C138\C2A4 \AC1D\CCB4\B97C \C7A0\AC14\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[\D55C \AC1C\B9CC \D5C8\C6A9\B418\B294 \ACBD\C6B0 \C804\B2EC \ACBD\B85C\AC00 \B450 \AC1C \C774\C0C1 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[\D558\C704 \D50C\B85C\C6B0 %0\C5D0\C11C \B2E4\C74C \B2E8\ACC4\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \B2E4\C774\C5B4\ADF8\B7A8\C744 \D655\C778\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[\D558\C704 \D504\B85C\C138\C2A4\C5D0 \B458 \C774\C0C1\C758 %0 boundaryEvent\C774(\AC00) \C788\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''eng_handle_event_int'', c_load_lang, q''[\D50C\B85C\C6B0 \C5D4\C9C4 \B0B4\BD80 \C624\B958: \D504\B85C\C138\C2A4 %0 \D558\C704 \D50C\B85C\C6B0 %1 \BAA8\B4C8 %2 \D604\C7AC %4 \D604\C7AC \D0DC\ADF8 %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[\BAA8\B378 \C624\B958: \D504\B85C\C138\C2A4 BPMN \BAA8\B378 \B2E4\C74C \B2E8\ACC4\C5D0\C11C\B294 \C9C0\C6D0\B418\C9C0 \C54A\B294 \AC1D\CCB4 %0\C744(\B97C) \C0AC\C6A9\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[\C560\D50C\B9AC\CF00\C774\C158 \C624\B958: \D504\B85C\C138\C2A4 ID %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[\C560\D50C\B9AC\CF00\C774\C158 \C624\B958: \C81C\ACF5\B41C \D558\C704 \D750\B984 ID(%0)\AC00 \C788\C9C0\B9CC \C81C\ACF5\B41C \D504\B85C\C138\C2A4 ID(%1)\C758 \D558\C704\AC00 \C544\B2D9\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[\C81C\ACF5\B41C \D558\C704 \D50C\B85C\C6B0 ID( %0 )\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \D50C\B85C\C6B0(\C2DC\AC04 \CD08\ACFC, \C624\B958, \C5D0\C2A4\CEEC\B808\C774\C158)\B97C \BCC0\ACBD\D55C \D504\B85C\C138\C2A4 \C774\BCA4\D2B8\B97C \D655\C778\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_failed'', c_load_lang, q''[%0 \D504\B85C\C138\C2A4: PL/SQL \C624\B958\B85C \C778\D574 %1 \D0DC\C2A4\D06C\AC00 \C2E4\D328\D588\C2B5\B2C8\B2E4. \C774\BCA4\D2B8 \B85C\ADF8\B97C \CC38\C870\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[\D504\B85C\C138\C2A4 %0: %1 \D0DC\C2A4\D06C\AC00 \CC98\B9AC \C911\C9C0\B97C \C694\CCAD\D588\C2B5\B2C8\B2E4. \C774\BCA4\D2B8 \B85C\ADF8\B97C \CC38\C870\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[\D604\C7AC \B2E4\B978 \C0AC\C6A9\C790\AC00 \C7A0\AC14\C73C\BBC0\B85C \D558\C704 \D50C\B85C\C6B0 %0\C744(\B97C) \C7A0\AE00 \C218 \C5C6\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[\C608\C57D\C774 \C774\BBF8 \B2E4\C74C \D0DC\C2A4\D06C\C5D0 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[%0\C5D0 \B300\D55C \C608\C57D\C5D0 \C2E4\D328\D588\C2B5\B2C8\B2E4. \B2E4\B978 \C0AC\C6A9\C790(%1)\AC00 \C774\BBF8 \B2E8\ACC4\B97C \C608\C57D\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[%2 \C608\C57D\C5D0 \C2E4\D328\D588\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 %1\C758 \D558\C704 \D50C\B85C\C6B0 %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[\D0DC\C2A4\D06C\AC00 \B354 \C774\C0C1 \CD5C\C2E0 \C0C1\D0DC\AC00 \C544\B2D9\B2C8\B2E4. \C774\BBF8 \C644\B8CC\B418\C5C8\C744 \C218 \C788\C2B5\B2C8\B2E4. \BC1B\C740 \D3B8\C9C0\D568\C744 \C0C8\B85C \ACE0\CE58\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[\B2E4\B978 \C0AC\C6A9\C790\AC00 \D604\C7AC \D558\C704 \D50C\B85C\C6B0\B97C \C7A0\AC14\C2B5\B2C8\B2E4(\C608\C57D\B418\C9C0 \C54A\C74C). \B098\C911\C5D0 \B2E4\C2DC \C608\C57D\C744 \C2DC\B3C4\D558\C138\C694.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[\C608\C57D \D574\C81C\C5D0 \C2E4\D328\D588\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 %1\C758 \D558\C704 \D50C\B85C\C6B0 %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[\D604\C7AC \C624\B958\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \B2E4\C774\C5B4\ADF8\B7A8\C744 \D655\C778\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[\C774\BBF8 \C2E4\D589 \C911\C778 \D504\B85C\C138\C2A4(ID %0)\B97C \C2DC\C791\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[\AC8C\C774\D2B8\C6E8\C774 %0\C5D0 \B300\D55C \BAA8\B378\C5D0 \B458 \C774\C0C1\C758 \AE30\BCF8 \ACBD\B85C\AC00 \C9C0\C815\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-no-catch'', c_load_lang, q''[\C774\B984\C774 %0\C778 \C77C\CE58\D558\B294 \B9C1\D06C Catch \C774\BCA4\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[\C774\B984\C774 %0\C778 \C77C\CE58\D558\B294 \B9C1\D06C \CE90\CE58 \C774\BCA4\D2B8\AC00 \B450 \AC1C \C774\C0C1 \C788\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-step-event'', c_load_lang, q''[\D50C\B85C\C6B0 - \B2E8\ACC4 \C774\BCA4\D2B8\B97C \AE30\B85D\D558\B294 \C911 \B0B4\BD80 \C624\B958 \BC1C\C0DD]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-variable-event'', c_load_lang, q''[\D50C\B85C\C6B0 - \BCC0\C218 \C774\BCA4\D2B8\B97C \AE30\B85D\D558\B294 \C911 \B0B4\BD80 \C624\B958 \BC1C\C0DD]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[\C5EC\B7EC \BCF5\C0AC\BCF8\C774 \C774\BBF8 \C2E4\D589 \C911\C778 \D504\B85C\C138\C2A4(ID %0)\B97C \C2DC\C791\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[\C815\C758\B41C \C2DC\C791 \C774\BCA4\D2B8\AC00 \C5EC\B7EC \AC1C \C788\C2B5\B2C8\B2E4. \B2E4\C774\C5B4\ADF8\B7A8\C5D0 \C2DC\C791 \C774\BCA4\D2B8\AC00 \D558\B098\B9CC \C788\B294\C9C0 \D655\C778\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-no-start-event'', c_load_lang, q''[\D50C\B85C\C6B0 \B2E4\C774\C5B4\ADF8\B7A8\C5D0 \C815\C758\B41C \C2DC\C791 \C774\BCA4\D2B8\AC00 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[\C874\C7AC\D558\C9C0 \C54A\B294 \D504\B85C\C138\C2A4(ID %0)\B97C \C2DC\C791\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[\C9C0\C6D0\B418\C9C0 \C54A\B294 \C2DC\C791 \C774\BCA4\D2B8 \C720\D615(%0). \C5C6\C74C(\D45C\C900), \BA54\C2DC\C9C0 \BC0F \D0C0\C774\BA38 \C2DC\C791 \C774\BCA4\D2B8\B9CC \D604\C7AC \C9C0\C6D0\B429\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[\C2DC\C791 \C791\C5C5 \C2DC\AC04 \AE30\B85D\C5D0 \C2E4\D328\D588\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 %1\C758 \D558\C704 \D50C\B85C\C6B0 %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[\C774 \D504\B85C\C138\C2A4 \B2E8\ACC4\B294 \C774\BBF8 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. (\B2E8\ACC4 \D0A4 %1\C774(\AC00) \D544\C694\D55C \B3D9\C548 \C798\BABB\B41C \B2E8\ACC4 \D0A4 %0\C774(\AC00) \C81C\ACF5\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-no-start'', c_load_lang, q''[\D558\C704 \D504\B85C\C138\C2A4 \C2DC\C791 \C774\BCA4\D2B8\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[\B458 \C774\C0C1\C758 \D558\C704 \D504\B85C\C138\C2A4 \C2DC\C791\C774 \BC1C\ACAC\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-broken'', c_load_lang, q''[\D0C0\C774\BA38 %0 \C2E4\D589 %4\C774(\AC00) \D504\B85C\C138\C2A4 %1, \D558\C704 \D50C\B85C\C6B0 %2\C5D0\C11C \BD84\B9AC\B418\C5C8\C2B5\B2C8\B2E4. error_info\B97C \CC38\C870\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[%0 \AC1D\CCB4\C5D0 \B300\D574 \C815\C758\B41C \C8FC\AE30 \D0C0\C774\BA38\B294 \D604\C7AC \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[%0 \AC1D\CCB4\C5D0 \B300\D55C \D0C0\C774\BA38 \C815\C758\AC00 \BD88\C644\C804\D569\B2C8\B2E4. \C720\D615: %1, Value1: %2 Value2: %3  Value3: %4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[\D604\C7AC \B2E4\B978 \C0AC\C6A9\C790\AC00 \D558\C704 \D50C\B85C\C6B0 %0\C5D0 \B300\D55C \D0C0\C774\BA38\B97C \C7A0\AC14\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-object-not-found'', c_load_lang, q''[\D0C0\C774\BA38\AC00 \C788\B294 \AC1D\CCB4\B97C get_timer_definition\C5D0\C11C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \D558\C704 \D50C\B85C\C6B0 %0\C785\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[\D604\C7AC \B2E4\B978 \C0AC\C6A9\C790\AC00 \D504\B85C\C138\C2A4 %0\C5D0 \B300\D55C \D0C0\C774\BA38\B97C \C7A0\AC14\C2B5\B2C8\B2E4. \B098\C911\C5D0 \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[%2 \BC94\C704\C5D0\C11C \D504\B85C\C138\C2A4 ID %1\C5D0 \B300\D55C \D504\B85C\C138\C2A4 \BCC0\C218 %0\C744(\B97C) \C0DD\C131\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[%2 \BC94\C704\C758 \D504\B85C\C138\C2A4 ID %1\C5D0 \B300\D55C \D504\B85C\C138\C2A4 \BCC0\C218 %0\C744(\B97C) \C5C5\B370\C774\D2B8\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[%2 \BC94\C704\C5D0\C11C \D504\B85C\C138\C2A4 ID %1\C5D0 \B300\D55C \D504\B85C\C138\C2A4 \BCC0\C218 %0\C744(\B97C) \C0AD\C81C\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[%2 \BC94\C704\C758 \D504\B85C\C138\C2A4 ID %1\C5D0 \B300\D55C \D504\B85C\C138\C2A4 \BCC0\C218 %0\C744(\B97C) \C7A0\ADF8\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[\D504\B85C\C138\C2A4 \BCC0\C218\B97C \C124\C815\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \BCC0\C218 %0\C5D0 \B300\D55C \B370\C774\D130 \C720\D615\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4. \B514\BC84\ADF8 \CD9C\B825\C5D0 \D45C\C2DC\B41C SQL \C624\B958\C785\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[\D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C798\BABB\B41C \C77C\C790 \D615\C2DD(\D558\C704 \D50C\B85C\C6B0: %0, \C138\D2B8: %3)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[process_expressions\C5D0\C11C %0 \AC1D\CCB4\B97C \C870\D68C\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \B514\BC84\ADF8 \CD9C\B825\C5D0 \D45C\C2DC\B41C SQL \C624\B958\C785\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[\D558\C704 \D50C\B85C\C6B0: %0 \BCC0\C218\C5D0 \B300\D55C %2 \D45C\D604\C2DD\C5D0\C11C \C624\B958 \BC1C\C0DD: %1]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_no_data'', c_load_lang, q''[\D504\B85C\C138\C2A4 ID %0(\C124\C815 %2)\C5D0\C11C \D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C9C8\C758\C5D0\C11C \B370\C774\D130\B97C \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_other'', c_load_lang, q''[\D504\B85C\C138\C2A4 ID %0(\C124\C815 %2)\C5D0\C11C \D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C774\BCA4\D2B8 \B85C\ADF8\C5D0 \D45C\C2DC\B41C SQL \C624\B958\C785\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[\D504\B85C\C138\C2A4 ID %0(\C124\C815 %2)\C5D0\C11C \D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. query\B294 \C5EC\B7EC \D589\C744 \BC18\D658\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_static_general'', c_load_lang, q''[\D504\B85C\C138\C2A4 ID %0(\C124\C815 %2)\C5D0\C11C \D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C774\BCA4\D2B8 \B85C\ADF8\C5D0\C11C \C624\B958\B97C \CC38\C870\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[\B9B4\B9AC\C2A4\B41C \B2E4\C774\C5B4\ADF8\B7A8 \B610\B294 \CD08\C548 \BC84\C804 0 \B2E4\C774\C5B4\ADF8\B7A8\C744 \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4. \BC84\C804 \B610\B294 diagram_id\C744 \C9C0\C815\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[\BAA8\B378\C774 \BCC0\ACBD\B418\C5C8\C2B5\B2C8\B2E4. \BCC0\ACBD\C0AC\D56D\C744 \BB34\C2DC\D558\C2DC\ACA0\C2B5\B2C8\AE4C?]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-instance-event'', c_load_lang, q''[\D50C\B85C\C6B0 - \C778\C2A4\D134\C2A4 \C774\BCA4\D2B8\B97C \AE30\B85D\D558\B294 \C911 \B0B4\BD80 \C624\B958 \BC1C\C0DD]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[\C124\C815\C740 \D504\B85C\C138\C2A4 ID \C5C6\C774 \D504\B85C\C138\C2A4 \BCC0\C218\B97C \C9C0\C815\D560 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[\C774 \AE30\B2A5\C744 \CC98\B9AC\D558\B824\BA74 Flows for APEX Enterprise Edition \B77C\C774\C13C\C2A4\AC00 \D544\C694\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[''\D558\C704 \D50C\B85C\C6B0 %0\C5D0\C11C \BC18\BCF5 \B9C8\AC10\C744 \CC98\B9AC\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[\D504\B85C\C138\C2A4 ID %0(\C138\D2B8 %2)\C5D0\C11C \D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C9C8\C758\AC00 \B450 \AC1C \C774\C0C1\C758 \AC12\C744 \BC18\D658\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[\D504\B85C\C138\C2A4 \BCC0\C218 %1\C744(\B97C) \C124\C815\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. JSON \D615\C2DD\C774 \C798\BABB\B418\C5C8\C2B5\B2C8\B2E4(\D558\C704 \D50C\B85C\C6B0: %0, \C138\D2B8: %3).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[''\D504\B85C\C138\C2A4 ID %1\C5D0 \B300\D55C \BC18\BCF5 \C138\BD80\C815\BCF4(\BB38\C790 %0 \B8E8\D504 %2)\B97C \C7A0\ADF8\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[%0 \AC1D\CCB4\C5D0 \B300\D55C \BE44\B3D9\AE30 \C811\C18D\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \BCC0\C218, \D504\B85C\C138\C2A4 \B2E4\C774\C5B4\ADF8\B7A8 \B610\B294 \C2DC\C2A4\D15C \AD6C\C131\C5D0 \C560\D50C\B9AC\CF00\C774\C158 ID\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[%0 \AC1D\CCB4\C5D0 \B300\D55C \BE44\B3D9\AE30 \C811\C18D\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \BCC0\C218, \D504\B85C\C138\C2A4 \B2E4\C774\C5B4\ADF8\B7A8 \B610\B294 \C2DC\C2A4\D15C \AD6C\C131\C5D0 \D398\C774\C9C0 ID\B97C \C9C0\C815\D574\C57C \D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[\D604\C7AC \B2E4\B978 \C0AC\C6A9\C790\AC00 %0\C758 \D558\C704 \ACBD\ACC4 \D558\C704 \D50C\B85C\C6B0 \B610\B294 \D0C0\C774\BA38\B97C \C7A0\AC14\C2B5\B2C8\B2E4. \B098\C911\C5D0 \D2B8\B79C\C7AD\C158\C744 \C7AC\C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[APEX \C138\C158\C744 \C0DD\C131\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. BPMN \B2E4\C774\C5B4\ADF8\B7A8\C5D0\B294 \C5EC\B7EC Process \AC1D\CCB4\AC00 \D3EC\D568\B418\C5B4 \C788\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[\D638\CD9C\D560 \C218 \C5C6\B294 \AC83\C73C\B85C \D45C\C2DC\B41C %0 \B2E4\C774\C5B4\ADF8\B7A8\C744 \D638\CD9C\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[\C2E4\D589 \C911\C778 \C778\C2A4\D134\C2A4\AC00 \C788\B294 \B2E4\C774\C5B4\ADF8\B7A8\C744 \C544\CE74\C774\BE0C\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[\C2B9\C778 \D0DC\C2A4\D06C\B97C \C0DD\C131\D558\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \BE44\C988\B2C8\C2A4 \CC38\C870/\B808\CF54\B4DC \C2DC\C2A4\D15C \AE30\BCF8 \D0A4\B294 Null\C774 \C544\B2C8\C5B4\C57C \D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[\C544\CE74\C774\BE0C \B300\C0C1 \AD6C\C131 \B9E4\AC1C\BCC0\C218\C5D0\C11C \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \B9E4\AC1C\BCC0\C218: %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[\D504\B85C\C138\C2A4 \C778\C2A4\D134\C2A4 %0\C5D0 \B300\D55C \C778\C2A4\D134\C2A4 \C694\C57D\C744 \C544\CE74\C774\BE0C\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[\D638\C2A4\D2B8(%0) \C694\CCAD\B41C \AC04\ACA9 %1\C5D0 \B300\D574 \D0C0\C774\BA38 \BC18\BCF5 \AC04\ACA9\C774 \B108\BB34 \C790\C8FC \BC1C\C0DD\D569\B2C8\B2E4. 1\BD84\BCF4\B2E4 \CEE4\C57C \D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[\C218\C2E0\B41C \BA54\C2DC\C9C0\AC00 \C608\C0C1\B41C \BA54\C2DC\C9C0\C640 \C77C\CE58\D558\C9C0 \C54A\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[\D504\B85C\C138\C2A4 \B2E8\ACC4 \C218\C2E0 \BA54\C2DC\C9C0\AC00 \C774\BBF8 \BC1C\C0DD\D588\C2B5\B2C8\B2E4(\C798\BABB\B41C \B2E8\ACC4 \D0A4\AC00 \C81C\ACF5\B428).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[\B2E4\B978 \C0AC\C6A9\C790\AC00 \BA54\C2DC\C9C0 \AC00\C785\C744 \C7A0\AC14\C2B5\B2C8\B2E4. \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[\BA54\C2DC\C9C0 \C218\C2E0\C790\AC00 \D558\C704 \D50C\B85C\C6B0\B97C \C7A0\AE00 \C218 \C5C6\C2B5\B2C8\B2E4. \B2E4\C2DC \C2DC\B3C4\D558\C2ED\C2DC\C624.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-diagram-event'', c_load_lang, q''[\D50C\B85C\C6B0 - \B2E4\C774\C5B4\ADF8\B7A8 \C774\BCA4\D2B8\B97C \AE30\B85D\D558\B294 \C911 \B0B4\BD80 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[\AE30\D55C\C744 \D3C9\AC00\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \AC04\ACA9 \D45C\D604\C2DD\C774 \BD80\C801\D569\D569\B2C8\B2E4. \AC04\ACA9: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[\AE30\D55C\C744 \D3C9\AC00\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \AE30\D55C \C77C\C790 \D45C\D604\C2DD\C774 \BD80\C801\D569\D569\B2C8\B2E4. \AC04\ACA9 \D45C\D604\C2DD: %0. ]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[\C6B0\C120\C21C\C704\B97C \D3C9\AC00\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \C6B0\C120\C21C\C704 \D45C\D604\C2DD\C774 \BD80\C801\D569\D569\B2C8\B2E4. \D45C\D604\C2DD: %0. \C6B0\C120 \C21C\C704 3\C774 \B300\C2E0 \C0AC\C6A9\B429\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[\C124\C815\C744 \D3C9\AC00\D558\B294 \C911 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4. \D45C\D604\C2DD\C774 \BD80\C801\D569\D569\B2C8\B2E4. \D45C\D604\C2DD: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[MessageFlow \C9C0\C815\B41C \B05D\C810( %0 )\C740 \C9C0\C6D0\B418\C9C0 \C54A\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[\D504\B85C\C138\C2A4 \BCC0\C218\C5D0 \B300\D574 \BD80\C801\D569\D55C \BC94\C704(%0)\AC00 \C81C\ACF5\B418\C5C8\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[%2 \BC94\C704\C5D0\C11C \D504\B85C\C138\C2A4 ID %1\C5D0 \B300\D55C \D504\B85C\C138\C2A4 \BCC0\C218 %0\C744(\B97C) \AC00\C838\C624\B294 \B3D9\C548 \C624\B958\AC00 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[\D604\C7AC \C9C0\C6D0\B418\C9C0 \C54A\B294 \C911\AC04 Throw \C774\BCA4\D2B8 \C720\D615\C774 %0 \C5D0 \BC1C\C0DD\D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-session-params-not-set'', c_load_lang, q''[',
unistr('\AC1D\CCB4 %0\C5D0 \B300\D55C \BE44\B3D9\AE30 \C811\C18D \C138\BD80\C815\BCF4\B294 \D504\B85C\C138\C2A4 \BCC0\C218, \BE44\B3D9\AE30 \C811\C18D \C138\BD80\C815\BCF4\C758 \B2E4\C774\C5B4\ADF8\B7A8\C5D0 \C124\C815\B418\C5B4\C57C \D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[%0 \AC1D\CCB4\C5D0 \B300\D55C \BE44\B3D9\AE30 \C811\C18D\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \C9C0\C815\B41C \C560\D50C\B9AC\CF00\C774\C158\C5D0\C11C \C0AC\C6A9\C790 \C774\B984\C774 \BD80\C801\D569\D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[%0 \AC1D\CCB4\C5D0 \B300\D55C \BE44\B3D9\AE30 \C811\C18D\C744 \C0DD\C131\D560 \C218 \C5C6\C2B5\B2C8\B2E4. \D504\B85C\C138\C2A4 \BCC0\C218, \D504\B85C\C138\C2A4 \B2E4\C774\C5B4\ADF8\B7A8 \B610\B294 \C2DC\C2A4\D15C \AD6C\C131\C5D0 \C0AC\C6A9\C790 \C774\B984\C744 \C9C0\C815\D574\C57C \D569\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[callActivity \D638\CD9C \C790\CCB4\B97C \D3EC\D568\D558\B294 %0 \B2E4\C774\C5B4\ADF8\B7A8\C73C\B85C \D504\B85C\C138\C2A4\B97C \C2DC\C791\D558\B824\ACE0 \D588\C2B5\B2C8\B2E4.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[\C774\BCA4\D2B8\B97C \CC98\B9AC\D560 boundaryEvent \C720\D615 %0\C744(\B97C) \CC3E\C744 \C218 \C5C6\C2B5\B2C8\B2E4.]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_portuguese
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15945389284143537)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Portuguese'
,p_sequence=>140
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_pt-br.sql',
'--',
'-- Engine Messages for language code "pt-br"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "pt-br"',
'declare',
'  c_load_lang constant varchar2(10) := ''pt-br'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[Erro ao avaliar Defini\00E7\00E3o. A express\00E3o \00E9 inv\00E1lida. Express\00E3o: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[O ponto final MessageFlow especificado ( %0 ) n\00E3o \00E9 suportado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[Assinatura da Mensagem bloqueada por outro usu\00E1rio. Tente novamente.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[Erro ao criar a Tarefa de Aprova\00E7\00E3o - A Ref. Comercial/Chave Principal do Sistema de Registro n\00E3o deve ser nula.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[Erro ao avaliar Vencimento em. A express\00E3o de intervalo \00E9 inv\00E1lida. Intervalo: %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[Erro ao avaliar Vencimento.  A express\00E3o Vencimento em \00E9 inv\00E1lida.  Express\00E3o do Intervalo: %0. ]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[Erro ao avaliar Prioridade. A express\00E3o de prioridade \00E9 inv\00E1lida. Express\00E3o: %0. Prioridade 3 usada.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[Escopo inv\00E1lido (%0) fornecido para a vari\00E1vel do processo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[Intervalo de repeti\00E7\00E3o do temporizador muito frequente para o host (%0) Intervalo Solicitado %1. Deve ser maior que 1 Minuto.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[Erro no par\00E2metro de configura\00E7\00E3o do destino de arquivamento. Par\00E2metro: %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[A mensagem recebida n\00E3o corresponde a uma mensagem esperada.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[A mensagem de recebimento da etapa do processo j\00E1 ocorreu (chave de etapa incorreta fornecida).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-cancelation-error'', c_load_lang, q''[Erro ao tentar cancelar tarefa de workflow do APEX (task_id: %1 ) para etapa do processo : %0.)]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[Disparo de Evento de Tipo Intermedi\00E1rio n\00E3o suportado no momento encontrado a 0%.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[Os detalhes da conex\00E3o ass\00EDncrona para o objeto %0 precisam ser definidos nas vari\00E1veis de processo, nos detalhes da conex\00E3o ass\00EDncrona do diagrama ou nos detalhes de configura\00E7\00E3o do sistema')
||'.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[N\00E3o \00E9 poss\00EDvel criar conex\00E3o ass\00EDncrona para o objeto %0. Nome de usu\00E1rio inv\00E1lido no Aplicativo especificado]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[N\00E3o \00E9 poss\00EDvel criar conex\00E3o ass\00EDncrona para o objeto %0. O nome de usu\00E1rio precisa ser especificado na vari\00E1vel de processo, no diagrama de processo ou na configura\00E7\00E3o do sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[N\00E3o \00E9 poss\00EDvel criar conex\00E3o ass\00EDncrona para o objeto %0. O ID aplicativo precisa ser especificado na vari\00E1vel de processo, no diagrama de processo ou na configura\00E7\00E3o do sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[N\00E3o \00E9 poss\00EDvel criar conex\00E3o ass\00EDncrona para o objeto %0. O ID p\00E1gina precisa ser especificado na vari\00E1vel de processo, no diagrama de processo ou na configura\00E7\00E3o do sistema.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[Subfluxo filho do Tipo Fronteira ou Termporizador %0 est\00E1 bloqueado atualmente por outro usu\00E1rio. Tente realizar sua transa\00E7\00E3o mais tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[Nenhum Evento do Tipo Fronteira/Limite %0 foi encontrado para capturar o evento.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''boundary-event-too-many'', c_load_lang, q''[Mais de um evento %0 evento de Fronteira/Limite encontrado no Subprocesso.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''eng_handle_event_int'', c_load_lang, q''[Erro Interno no Motor de Fluxo. Processo %0 Subfluxo %1 M\00F3dulo %2 Corrente %4 Etiqueta Atual (Tag) %3.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[Erro de Modelo: A pr\00F3xima etapa no modelo de processo BPMN usa objeto n\00E3o suportado %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[O ID do Subfluxo (%0) informado n\00E3o foi localizado. Verifique a exist\00EAncia de eventos de processos que modificam o fluxo (limite de tempo, erros, escala\00E7\00F5es).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[Erro em Gateway (Porta de Entrada) %0. Vari\00E1vel fornecida %1 indica uma rota inv\00E1lida:  %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[Erro interno ao processar liga\00E7\00E3o de Gateway (Porta de Entrada) no subfluxo %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[A vari\00E1vel %0 n\00E3o forneceu nenhuma instru\00E7\00E3o de direcionamento de rota para Gateway (Porta de Entrada) e o modelo n\00E3o possui rota Padr\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[Express\00E3o de roteamento de gateway inv\00E1lida. Isso poder\00E1 ocorrer se voc\00EA tentar vincular uma vari\00E1vel a dois-pontos incorporados (:).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[Mais de uma rota padr\00E3o foi definida no modelo para o Gateway (Porta de Entrada) %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-no-catch'', c_load_lang, q''[N\00E3o foi poss\00EDvel localizar evento de captura de link com nome %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[Mais de uma correspond\00EAncia de caputra de evento de link com nome %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-instance-event'', c_load_lang, q''[Flows - Erro interno durante registro da Inst\00E2ncia de Evento.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-step-event'', c_load_lang, q''[Flows - Erro interno ao registrar Evento da Etapa.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-variable-event'', c_load_lang, q''[Flows - Erro interno ao registrar uma Variavel de Evento.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[Objeto %0 do processo est\00E1 bloqueado atualmente para por outro usu\00E1rio. Tente novamente mais tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[Mais de um caminho poss\00EDvel encontrado odne apenas um era permitido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''no_next_step_found'', c_load_lang, q''[Nenbuma etapa seguinte foi identificada para o Subfluxo %0. Verifique o diagrama do processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plsql_script_failed'', c_load_lang, q''[Processo %0: a Tarefa %1 falhou devido a um erro de PL/SQL - consulte o log de eventos.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[Processo %0: A tarefa %1 solicitou a interrup\00E7\00E3o do processamento - consulte o log de eventos.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[N\00E3o foi poss\00EDvel bloquear o subfluxo %0, pois ele est\00E1 atualmente bloqueado por outro usu\00E1rio. Tente novamente mais tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[Reserva j\00E1 feita na pr\00F3xima tarefa para voc\00EA.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[Reserva para %0 malsucedida. Etapa j\00E1 reservada por outro usu\00E1rio (%1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[Reserva para %2 malsucedida. Subfluxo %0 no Processo %1 n\00E3o encontrado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[A tarefa n\00E3o est\00E1 mais em andamento, provavelmente j\00E1 foi conclu\00EDda. Por favor, atualize sua lista de tarefas.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[Subfluxo atualmente bloqueado (n\00E3o reservado) por outro usu\00E1rio. Tente sua reserva novamente mais tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[Libera\00E7\00E3o de reserva sem sucesso. Subfluxo %0 no Processo %1 n\00E3o encontrado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''restart-no-error'', c_load_lang, q''[Nenhum erro atual encontrado. Verifique seu diagrama de processo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[Voc\00EA tentou iniciar um processo (id %0) que j\00E1 est\00E1 em execu\00E7\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[Voc\00EA tentou iniciar um processo com um diagrama %0 que inclui uma chamada Atividade de Chamada (callActivity) propriamente dita.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[Erro de Aplica\00E7\00E3o: ID do Processo %0 n\00E3o encontrado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[Erro de Aplica\00E7\00E3o: ID do Subfluxo forneceido (%0) existe mas n\00E3o \00E9 filho do ID do Processo Informado (%1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''feature-requires-ee'', c_load_lang, q''[O processamento desse recurso requer o licenciamento do Flows for APEX Enterprise Edition.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[''Erro interno ao processar encerramento de itera\00E7\00E3o no subfluxo %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[Erro ao definir a vari\00E1vel de processo %1 no ID de processo %0 (conjunto %2).  A consulta retorna mais de um valor.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[Erro ao definir a Vari\00E1vel de processo %1: Formato JSON incorreto (Subfluxo: %0, Conjunto: %3.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[''Erro ao bloquear detalhe da itera\00E7\00E3o (loop %2 do iterador %0) para o ID do processo %1.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-not-supported'', c_load_lang, q''[O uso do Recurso APEX Workflow exige o Oracle APEX v%0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-found'', c_load_lang, q''[Tarefa de Workflow APEX %0 n\00E3o encontrada nos do Processo do Flows for APEX]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[Tarefa de Workflow APEX %0 encontrada e associada a mais de um etapa do processo do Flows for APEX.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[Tarefa de Workflow APEX %0 n\00E3o \00E9 a etapa atual do Processo. A etapa j\00E1 pode ter sido conclu\00EDda.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[A vari\00E1vel do processo de resultado da Tarefa de Workflow do APEX n\00E3o est\00E1 definida ou \00E9 inv\00E1lida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[Erro ao criar a tarefa do Workflow APEX %0 no aplicativo %1. Consulte a depura\00E7\00E3o para obter detalhes.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-priority-error'', c_load_lang, q''[Erro ao avaliar Prioridade. A prioridade deve estar entre 1 e 5. Prioridade: %0.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[Erro ao criar sess\00E3o do APEX. O diagrama BPMN cont\00E9m v\00E1rios objetos de Processo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[Voc\00EA tentou chamar um diagrama %0 marcado como n\00E3o cham\00E1vel.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[As defini\00E7\00F5es n\00E3o podem especificar a Vari\00E1vel do Processo sem um ID do Processo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[Voc\00EA tentou arquivar um diagrama que tem inst\00E2ncias em execu\00E7\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''logging-diagram-event'', c_load_lang, q''[Fluxos - Erro interno ao registrar um Evento do Diagrama.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[Erro ao arquivar o resumo da inst\00E2ncia para a Inst\00E2ncia do Processo %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[O receptor da mensagem n\00E3o pode bloquear o subfluxo. Tente novamente.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[Voc\00EA tentou iniciar um processo (id %0) que possui v\00E1rias c\00F3pias j\00E1 em execu\00E7\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[Voc\00EA definiu v\00E1rios eventos de in\00EDcio. Certifique-se de que seu diagrama tenha apenas um evento de in\00EDcio.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''start-no-start-event'', c_load_lang, q''[Nenhum evento inicial foi definido no diagrama de fluxo.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[Voc\00EA tentou iniciar um processo (id %0) que n\00E3o existe.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[Tipo de evento de in\00EDcio n\00E3o suportado (%0). Somente Nenhum (padr\00E3o), Mensagem e Evento de In\00EDcio do Timer s\00E3o suportados no momento.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[O In\00EDcio do Registro do hor\00E1rio de trabalho foi malsucedido. O subfluxo %0 do processo %1 n\00E3o foi encontrado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[Esta Etapa do Processo j\00E1 foi realizada. (Chave da etapa incorreta %0 fornecida enquanto esperava a chave da etapa %1).]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-no-start'', c_load_lang, q''[N\00E3o foi poss\00EDvel encontrar o Evento de In\00EDcio do Subprocesso.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[Mais de um Evento de In\00EDcio de Subprocesso encontrado.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''timer-broken'', c_load_lang, q''[Temporizador %0 ciclo %4 com erro no processo %1 , subfluxo: %2. Veja error_info.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_static_general'', c_load_lang, q''[Erro ao definir a vari\00E1vel de processo %1 no ID de processo %0 (conjunto %2). Consulte erro no log de eventos.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[N\00E3o foi poss\00EDvel encontrar o diagrama publicado ou a vers\00E3o rascunho 0 do diagrama - especifique a vers\00E3o ou o n\00FAmero do diagrama.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[N\00E3o \00E9 poss\00EDvel localizar a vers\00E3o especificada do diagrama. Verifique a especifica\00E7\00E3o da vers\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[Erro ao analisar a defini\00E7\00E3o do temporizador no processo %0, subfluxo %1. Tipo de temporizador: %2, Defini\00E7\00E3o: %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[Vers\00E3o n\00E3o definida]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[Erro ao analisar vari\00E1veis de processo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[Gateway n\00E3o definido para roteamento.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[A defini\00E7\00E3o de Gateway (Porta de Entrada) n\00E3o foi definida para este fluxo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[N\00E3o \00E9 poss\00EDvel obter o ID da inst\00E2ncia de fluxo e/ou o ID do subfluxo para gerenciar a etapa.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[N\00FAmero incorreto de item(s) do APEX ou vari\00E1veis de processo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[Uma ou mais vari\00E1veis \200B\200Bde processo s\00E3o de um tipo diferente daquele definido no JSON.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 n\00E3o \00E9 um n\00FAmero v\00E1lidlo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 n\00E3o \00E9 uma data v\00E1lida.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[JSON forneceido \00E9 inv\00E1lido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[O Temporizador do Tipo Ciclo definido para o objeto %0 n\00E3o \00E9 suportado atualmente.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[Defini\00E7\00F5es de temporizador incompletas para o objeto %0. Tipo 1; Valor1: %2 Valor2: %3 Valor3: %4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[Temporizador para subfluxo %0 atualmente bloqueado por outro usu\00E1rio. Tente mais tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-object-not-found'', c_load_lang, q''[Objeto com temporizador n\00E3o encontrado em get_timer_definition. Subfluxo %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[Os Temporizadores para o processo %0 est\00E3o bloqueados por outro usu\00E1rio. Tente novamente mais tarde.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[Erro ao criar a vari\00E1vel de processo %0 para o ID de processo %1 no escopo %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[Erro ao obter a vari\00E1vel de processo %0 para o ID de processo %1 no escopo %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[Erro ao atualizar a vari\00E1vel de processo %0 para o ID de processo %1 no escopo %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[Erro ao excluir a vari\00E1vel de processo %0 para o ID de processo %1 no escopo %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[Erro ao bloquear a vari\00E1vel de processo %0 para o ID de processo %1 no escopo %2.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[Erro ao definir a vari\00E1vel de processo. Tipo de dados incorreto para a vari\00E1vel %0. Erro de SQL exibido na sa\00EDda de depura\00E7\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[Erro ao configurar a Vari\00E1vel de Processo %1: Formato de Data Incorreto (Subfluxo: %0, Conjunto: %3.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[Erro interno ao procurar o objeto %0 em process_expressions. Erro de SQL exibido na sa\00EDda de depura\00E7\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[Subfluxo: %0 Erro na express\00E3o %2 para Vari\00E1vel: %1]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_no_data'', c_load_lang, q''[Erro ao definir a vari\00E1vel de processo %1 no ID de processo %0 (conjunto %2). Nenhum dado encontrado na consulta.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_other'', c_load_lang, q''[Erro ao definir a vari\00E1vel de processo %1 no ID de processo %0 (conjunto %2). Erro SQL mostrado no log de eventos.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[Erro ao definir a vari\00E1vel de processo %1 no ID de processo %0 (conjunto %2). A consulta retorna v\00E1rias linhas.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[Nenhum dado encontrado. Verifique se o Diagrama com o ID fornecido existe.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''plugin-unexpected-error'', c_load_lang, q''[Erro inesperado, entre em contato com o administrador.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[N\00E3o foi poss\00EDvel analisar o diagrama.<br />Reveja seu diagrama para garantir que ele seja compat\00EDvel.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[Altera\00E7\00F5es salvas!]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[O Modelo foi alterado. Deseja descartar as mudan\00E7as realizadas?]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[Processo %0: Falha na Tarefa do Tipo Servi\00E7o %1: O espa\00E7o de trabalho padr\00E3o definido no par\00E2metro de configura\00E7\00E3o \00E9 inv\00E1lido.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[Processo %0: Falha na Tarefa do Tipo Servi\00E7o %1: n\00E3o foi poss\00EDvel localizar o espa\00E7o de trabalho associado ao aplicativo definido no diagrama. Por favor, verifique o modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[Processo %0:  Tarefa do Tipo Servi\00E7o %1 falhou: o atributo "De" e o Remetente de Email padr\00E3o n\00E3o est\00E3o definidos. Verifique o modelo e/ou o par\00E2metro de configura\00E7\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[Processo %0: Tarefa do Tipo Servi\00E7o %1 falhou: atributo "Para" n\00E3o foi definido. Por favor, verifique o modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[Processo %0: Tarefa do Tipo Servi\00E7o %1 falhou: atributo "Modelo" n\00E3o foi definido. Por favor, verifique o modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[Processo %0: Tarefa do Tipo Servi\00E7o %1 falhou: o atributo "Corpo de E-mail" n\00E3o foi definido. Por favor, verifique o modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[Processo %0: Falha na Tarefa do Tipo Servi\00E7o %1: consulte o log para obter detalhes e verifique o padr\00E3o.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[Processo %0: Falha na Tarefa do Tipo Servi\00E7o %1: objeto JSON de espa\00E7o reservado inv\00E1lido. Por favor, verifique o modelo.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[V\00E1rias linhas encontradas. Ative a configura\00E7\00E3o ''Ativar Atividades de Chamada'' nos atributos de plug-in do visualizador.]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_chinese_simplified
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15945585037144822)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Chinese (Simplified)'
,p_sequence=>150
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_zh-cn.sql',
'--',
'-- Engine Messages for language code "zh-cn"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "zh-cn"',
'declare',
'  c_load_lang constant varchar2(10) := ''zh-cn'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[\8BC4\4F30\8BBE\7F6E\65F6\51FA\9519\3002\8868\8FBE\5F0F\65E0\6548\3002\8868\8FBE\5F0F\FF1A%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[\8BBE\7F6E\4E0D\80FD\6307\5B9A\6CA1\6709\8FDB\7A0B ID \7684\8FDB\7A0B\53D8\91CF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[\4E0D\652F\6301\6307\5B9A\7684 MessageFlow \7AEF\70B9 ( %0)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[\4E3A\6D41\7A0B\53D8\91CF\63D0\4F9B\7684\8303\56F4 (%0) \65E0\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[\83B7\53D6\8303\56F4 %2 \4E2D\8FDB\7A0B ID %1 \7684\8FDB\7A0B\53D8\91CF %0 \65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[\5F53\524D\5728 %0 \9047\5230\7684\4E2D\95F4\5F15\53D1\4E8B\4EF6\7C7B\578B\4E0D\53D7\652F\6301\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[\9700\8981\5728\6D41\7A0B\53D8\91CF\4E2D\8BBE\7F6E\5BF9\8C61 %0 \7684\5F02\6B65\8FDE\63A5\8BE6\7EC6\4FE1\606F\3001\56FE\8868\5F02\6B65\8FDE\63A5\8BE6\7EC6\4FE1\606F\6216\7CFB\7EDF\914D\7F6E\8BE6\7EC6\4FE1\606F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[\65E0\6CD5\4E3A\5BF9\8C61 %0 \521B\5EFA\5F02\6B65\8FDE\63A5\3002\7528\6237\540D\5728\6307\5B9A\7684\5E94\7528\7A0B\5E8F\4E2D\65E0\6548]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[\65E0\6CD5\4E3A\5BF9\8C61 %0 \521B\5EFA\5F02\6B65\8FDE\63A5\3002\9700\8981\5728\8FDB\7A0B\53D8\91CF\3001\8FDB\7A0B\56FE\6216\7CFB\7EDF\914D\7F6E\4E2D\6307\5B9A\7528\6237\540D\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[\65E0\6CD5\4E3A\5BF9\8C61 %0 \521B\5EFA\5F02\6B65\8FDE\63A5\3002\9700\8981\5728\8FDB\7A0B\53D8\91CF\3001\8FDB\7A0B\56FE\6216\7CFB\7EDF\914D\7F6E\4E2D\6307\5B9A\5E94\7528\7A0B\5E8F ID\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[\65E0\6CD5\4E3A\5BF9\8C61 %0 \521B\5EFA\5F02\6B65\8FDE\63A5\3002\9700\8981\5728\8FDB\7A0B\53D8\91CF\3001\8FDB\7A0B\56FE\6216\7CFB\7EDF\914D\7F6E\4E2D\6307\5B9A\9875 ID\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[%0 \7684\5B50\8FB9\754C\5B50\6D41\6216\8BA1\65F6\5668\5F53\524D\88AB\5176\4ED6\7528\6237\9501\5B9A\3002\7A0D\540E\91CD\8BD5\4E8B\52A1\5904\7406\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[\627E\4E0D\5230\7C7B\578B\4E3A %0 \7684 boundaryEvent \6765\6355\83B7\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[\5728\5B50\8FDB\7A0B\4E2D\627E\5230\591A\4E2A %0 boundaryEvent\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''eng_handle_event_int'', c_load_lang, q''[\6D41\5F15\64CE\5185\90E8\9519\8BEF\FF1A\6D41\7A0B %0 \5B50\6D41 %1 \6A21\5757 %2 \5F53\524D %4 \5F53\524D\6807\7B7E %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[\5E94\7528\7A0B\5E8F\9519\8BEF\FF1A\672A\627E\5230\8FDB\7A0B ID %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[\5E94\7528\7A0B\5E8F\9519\8BEF\FF1A\63D0\4F9B\7684\5B50\6D41 ID ( %0) \5B58\5728\FF0C\4F46\4E0D\662F\63D0\4F9B\6D41\7A0B ID ( %1) \7684\5B50\9879\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[\7F51\5173 %0 \51FA\9519\3002\63D0\4F9B\7684\53D8\91CF %1 \5305\542B\65E0\6548\8DEF\7531\FF1A%2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[\5904\7406\5B50\6D41\7A0B %0 \4E0A\7684\5408\5E76\7F51\5173\65F6\51FA\73B0\5185\90E8\9519\8BEF]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[\53D8\91CF %0 \4E2D\672A\63D0\4F9B\7F51\5173\8DEF\7531\6307\4EE4\FF0C\6A21\578B\4E0D\5305\542B\9ED8\8BA4\8DEF\7531\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[%0 \7684\8FDB\7A0B\5BF9\8C61\5F53\524D\88AB\5176\4ED6\7528\6237\9501\5B9A\3002\8BF7\7A0D\540E\91CD\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[\627E\52301 \4E2A\4EE5\4E0A\7684\8F6C\53D1\8DEF\5F84\4EC5\FF0C\53EA\5141\8BB8 1 \4E2A\8F6C\53D1\8DEF\5F84\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[\5728\5B50\6D41 %0 \4E0A\672A\627E\5230\4E0B\4E00\6B65\9AA4\3002\68C0\67E5\60A8\7684\6D41\7A0B\56FE\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[\6D41\7A0B %0\FF1A\4EFB\52A1 %1 \5DF2\8BF7\6C42\5904\7406\505C\6B62 - \8BF7\53C2\9605\4E8B\4EF6\65E5\5FD7\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[\65E0\6CD5\9501\5B9A\5B50\6D41\7A0B %0\FF0C\56E0\4E3A\76EE\524D\5DF2\88AB\5176\4ED6\7528\6237\9501\5B9A\3002\8BF7\7A0D\540E\91CD\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[%0 \7684\4FDD\7559\4E0D\6210\529F\3002\6B65\9AA4\5DF2\88AB\5176\4ED6\7528\6237 (%1) \4FDD\7559\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[%2 \7684\4FDD\7559\4E0D\6210\529F\3002\672A\627E\5230\6D41\7A0B %1 \4E2D\7684\5B50\6D41 %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[\4EFB\52A1\4E0D\518D\662F\5F53\524D\4EFB\52A1\FF0C\53EF\80FD\5DF2\7ECF\5B8C\6210\3002\8BF7\5237\65B0\6536\4EF6\7BB1\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[\5B50\6D41\7A0B\5F53\524D\88AB\53E6\4E00\7528\6237\9501\5B9A\FF08\672A\4FDD\7559\FF09\3002\8BF7\7A0D\540E\518D\6B21\5C1D\8BD5\60A8\7684\9884\8BA2\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[\4FDD\7559\53D1\653E\5931\8D25\3002\672A\627E\5230\6D41\7A0B %1 \4E2D\7684\5B50\6D41 %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[\672A\627E\5230\5F53\524D\9519\8BEF\3002\68C0\67E5\60A8\7684\6D41\7A0B\56FE\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[\60A8\5C1D\8BD5\542F\52A8\5DF2\8FD0\884C\7684\8FDB\7A0B\FF08\6807\8BC6 %0\FF09\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[\60A8\5C1D\8BD5\4F7F\7528\5305\62EC callActivity \8C03\7528\81EA\8EAB\7684\56FE\8868 %0 \542F\52A8\8FDB\7A0B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[\5728\7F51\5173 %0 \7684\6A21\578B\4E2D\6307\5B9A\4E86\591A\4E2A\9ED8\8BA4\8DEF\7531\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-no-catch'', c_load_lang, q''[\627E\4E0D\5230\540D\4E3A %0 \7684\76F8\914D\94FE\63A5\6355\83B7\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[\591A\4E2A\540D\4E3A %0 \7684\76F8\914D\94FE\63A5\6355\83B7\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-instance-event'', c_load_lang, q''[\6D41\7A0B - \8BB0\5F55\5B9E\4F8B\4E8B\4EF6\65F6\51FA\73B0\5185\90E8\9519\8BEF]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-step-event'', c_load_lang, q''[\6D41\7A0B - \8BB0\5F55\6B65\9AA4\4E8B\4EF6\65F6\51FA\73B0\5185\90E8\9519\8BEF]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-variable-event'', c_load_lang, q''[\6D41\7A0B - \8BB0\5F55\53D8\91CF\4E8B\4EF6\65F6\51FA\73B0\5185\90E8\9519\8BEF]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[\60A8\5C1D\8BD5\542F\52A8\4E00\4E2A\8FDB\7A0B\FF08\6807\8BC6 %0\FF09\FF0C\5176\4E2D\591A\4E2A\526F\672C\5DF2\5728\8FD0\884C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-no-start-event'', c_load_lang, q''[\672A\5728\6D41\7A0B\56FE\4E2D\5B9A\4E49\8D77\59CB\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[\60A8\5C1D\8BD5\542F\52A8\4E0D\5B58\5728\7684\8FDB\7A0B\FF08\6807\8BC6 %0\FF09\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[\4E0D\652F\6301\7684\5F00\59CB\4E8B\4EF6\7C7B\578B (%0)\3002\5F53\524D\4EC5\652F\6301\201C\65E0\201D\FF08\6807\51C6\FF09\3001\201C\6D88\606F\201D\548C\201C\8BA1\65F6\5668\5F00\59CB\4E8B\4EF6\201D\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[\5DF2\53D1\751F\6B64\6D41\7A0B\6B65\9AA4\3002\FF08\5728\671F\671B\6B65\9AA4\5173\952E\5B57 %1 \65F6\5374\4E0D\6B63\786E\7684\63D0\4F9B\6B65\9AA4\5173\952E\5B57 %0 \FF09\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-no-start'', c_load_lang, q''[\65E0\6CD5\627E\5230\5B50\6D41\7A0B\5F00\59CB\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-broken'', c_load_lang, q''[\8BA1\65F6\5668 %0 \8FD0\884C %4 \5728\6D41\7A0B %1 \4E2D\4E2D\65AD\FF0C\5B50\6D41\7A0B\FF1A%2\3002\8BF7\53C2\9605 error_info\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[\5F53\524D\4E0D\652F\6301\4E3A\5BF9\8C61 %0 \5B9A\4E49\7684\5468\671F\8BA1\65F6\5668\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[\5B50\6D41\7A0B %0 \7684\8BA1\65F6\5668\5F53\524D\88AB\5176\4ED6\7528\6237\9501\5B9A\3002\8BF7\7A0D\540E\91CD\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-object-not-found'', c_load_lang, q''[\5728 get_timer_definition \4E2D\672A\627E\5230\5177\6709\8BA1\65F6\5668\7684\5BF9\8C61\3002\5B50\6D41 %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[\4E3A\8303\56F4 %2 \4E2D\7684\6D41\7A0B ID %1 \521B\5EFA\6D41\7A0B\53D8\91CF %0 \65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[\66F4\65B0\8303\56F4 %2 \4E2D\8FDB\7A0B ID %1 \7684\8FDB\7A0B\53D8\91CF %0 \65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[\9501\5B9A\8303\56F4 %2 \4E2D\8FDB\7A0B ID %1 \7684\8FDB\7A0B\53D8\91CF %0 \65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[\8BBE\7F6E\6D41\7A0B\53D8\91CF\65F6\51FA\9519\3002\53D8\91CF %0 \7684\6570\636E\7C7B\578B\4E0D\6B63\786E\3002\8C03\8BD5\8F93\51FA\4E2D\663E\793A\7684 SQL \9519\8BEF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[\8BBE\7F6E\6D41\7A0B\53D8\91CF %1 \65F6\51FA\9519\FF1A\65E5\671F\683C\5F0F\4E0D\6B63\786E\FF08\5B50\6D41\FF1A%0\FF0C\96C6\FF1A%3\3002\FF09]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[\5728 process_expressions \4E2D\67E5\627E\5BF9\8C61 %0 \65F6\51FA\73B0\5185\90E8\9519\8BEF\3002\8C03\8BD5\8F93\51FA\4E2D\663E\793A\7684 SQL \9519\8BEF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[\5B50\6D41\7A0B\FF1A%0 \53D8\91CF %1 \7684 %2 \8868\8FBE\5F0F\4E2D\51FA\9519]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_no_data'', c_load_lang, q''[\5728\8FDB\7A0B ID %0\FF08\96C6 %2\FF09\4E2D\8BBE\7F6E\8FDB\7A0B\53D8\91CF %1 \65F6\51FA\9519\3002\67E5\8BE2\4E2D\672A\627E\5230\6570\636E\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_other'', c_load_lang, q''[\5728\8FDB\7A0B ID %0\FF08\96C6 %2\FF09\4E2D\8BBE\7F6E\8FDB\7A0B\53D8\91CF %1 \65F6\51FA\9519\3002\4E8B\4EF6\65E5\5FD7\4E2D\663E\793A\7684 SQL \9519\8BEF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[\5728\8FDB\7A0B ID %0\FF08\96C6 %2\FF09\4E2D\8BBE\7F6E\8FDB\7A0B\53D8\91CF %1 \65F6\51FA\9519\3002\67E5\8BE2\5C06\8FD4\56DE\591A\884C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_static_general'', c_load_lang, q''[\5728\8FDB\7A0B ID %0\FF08\96C6 %2\FF09\4E2D\8BBE\7F6E\8FDB\7A0B\53D8\91CF %1 \65F6\51FA\9519\3002\5728\4E8B\4EF6\65E5\5FD7\4E2D\67E5\770B\9519\8BEF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[\627E\4E0D\5230\5DF2\53D1\5E03\56FE\8868\6216\8349\7A3F\7248\672C 0 - \8BF7\6307\5B9A\7248\672C\6216 diagram_id]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[\627E\4E0D\5230\6307\5B9A\7684\56FE\8868\7248\672C\3002\8BF7\68C0\67E5\7248\672C\89C4\8303\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[\5206\6790\6D41\7A0B %0\3001\5B50\6D41 %1 \4E2D\7684\8BA1\65F6\5668\5B9A\4E49\65F6\51FA\9519\3002\8BA1\65F6\5668\7C7B\578B\FF1A%2\FF0C\5B9A\4E49\FF1A%3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[\672A\5B9A\4E49\7248\672C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[\5206\6790\6D41\7A0B\53D8\91CF\65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[\6CA1\6709\4E3A\8DEF\7531\5B9A\4E49\7F51\5173\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[\6B64\6D41\7A0B\4E0D\5B58\5728\7F51\5173\5B9A\4E49\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[\65E0\6CD5\83B7\53D6\6D41\7A0B\5B9E\4F8B ID \548C/\6216\5B50\6D41\7A0B ID \4EE5\7BA1\7406\6B65\9AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[APEX \9879\6216\8FDB\7A0B\53D8\91CF\7684\6570\91CF\9519\8BEF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[\4E00\4E2A\6216\591A\4E2A\8FDB\7A0B\53D8\91CF\4E0E JSON \4E2D\5B9A\4E49\7684\4E0D\540C\7C7B\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 \4E0D\662F\6709\6548\6570\5B57\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 \4E0D\662F\6709\6548\65E5\671F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[\63D0\4F9B\7684 JSON \65E0\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[\672A\627E\5230\6570\636E\3002\68C0\67E5\5177\6709\7ED9\5B9A ID \7684\56FE\8868\662F\5426\5B58\5728\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-unexpected-error'', c_load_lang, q''[\610F\5916\9519\8BEF\FF0C\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[\65E0\6CD5\89E3\6790\56FE\8868\3002<br /> \8BF7\67E5\770B\60A8\7684\56FE\8868\4EE5\786E\4FDD\5176\53D7\652F\6301\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[\66F4\6539\5DF2\4FDD\5B58\FF01]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF1A\914D\7F6E\53C2\6570\4E2D\5B9A\4E49\7684\9ED8\8BA4\5DE5\4F5C\533A\65E0\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF1A\672A\5B9A\4E49\5C5E\6027 "From" \548C\9ED8\8BA4\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA\3002\8BF7\68C0\67E5\6A21\578B\548C\914D\7F6E\53C2\6570\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF1A\672A\5B9A\4E49\5C5E\6027\201C\81F3\201D\3002\8BF7\68C0\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF1A\672A\5B9A\4E49\5C5E\6027 "Body"\3002\8BF7\68C0\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF0C\8BF7\67E5\770B\9519\8BEF\65E5\5FD7\5E76\68C0\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5360\4F4D\7B26 JSON \65E0\6548. \8BF7\68C0\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[\5904\7406\6B64\529F\80FD\9700\8981\83B7\5F97 Flows for APEX Enterprise Edition \8BB8\53EF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[\2019\5904\7406\5B50\6D41 %0 \4E0A\7684\8FED\4EE3\5173\95ED\65F6\51FA\73B0\5185\90E8\9519\8BEF]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[\5728\8FDB\7A0B ID %0\FF08\96C6 %2\FF09\4E2D\8BBE\7F6E\8FDB\7A0B\53D8\91CF %1 \65F6\51FA\9519\3002\67E5\8BE2\5C06\8FD4\56DE\591A\4E2A\503C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[\8BBE\7F6E\6D41\7A0B\53D8\91CF %1 \65F6\51FA\9519\FF1AJSON \683C\5F0F\4E0D\6B63\786E\FF08\5B50\6D41\FF1A%0\FF0C\96C6\FF1A%3\FF09\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[\9501\5B9A\8FDB\7A0B ID %1 \7684\8FED\4EE3\8BE6\7EC6\4FE1\606F\FF08iter %0 \5FAA\73AF %2\FF09\65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[\6A21\578B\9519\8BEF\FF1A\6D41\7A0B BPMN \6A21\578B\4E0B\4E00\6B65\5C06\4F7F\7528\4E0D\652F\6301\7684\5BF9\8C61 %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[\672A\627E\5230\63D0\4F9B\7684\5B50\6D41\7A0B ID ( %0)\3002\68C0\67E5\66F4\6539\4E86\6D41\7A0B\7684\6D41\7A0B\4E8B\4EF6\FF08\8D85\65F6\3001\9519\8BEF\3001\5347\7EA7\FF09\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[\7F51\5173\8DEF\7531\8868\8FBE\5F0F\9519\8BEF\3002\5982\679C\5C1D\8BD5\4F7F\7528\5D4C\5165\5F0F\5192\53F7 (\FF1A) \7ED1\5B9A\53D8\91CF\FF0C\5219\4F1A\53D1\751F\8FD9\79CD\60C5\51B5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_failed'', c_load_lang, q''[\6D41\7A0B %0\FF1A\7531\4E8E PL/SQL \9519\8BEF\FF0C\4EFB\52A1 %1 \5931\8D25 - \8BF7\67E5\770B\4E8B\4EF6\65E5\5FD7\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[\5DF2\4E3A\60A8\5B89\6392\4E0B\4E00\4E2A\4EFB\52A1\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[\60A8\5B9A\4E49\4E86\591A\4E2A\8D77\59CB\4E8B\4EF6\3002\786E\4FDD\56FE\8868\53EA\6709\4E00\4E2A\5F00\59CB\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[\5F00\59CB\5DE5\4F5C\65F6\95F4\8BB0\5F55\4E0D\6210\529F\3002\672A\627E\5230\6D41\7A0B %1 \4E2D\7684\5B50\6D41 %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[\627E\5230\591A\4E2A\5B50\6D41\7A0B\5F00\59CB\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[\5BF9\8C61 %0 \7684\8BA1\65F6\5668\5B9A\4E49\4E0D\5B8C\6574\3002\7C7B\578B\FF1A%1\FF1BValue1\FF1A%2 Value2\FF1A%3  Value3\FF1A%4 \503C\FF1F]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[\8FDB\7A0B %0 \7684\8BA1\65F6\5668\5F53\524D\88AB\5176\4ED6\7528\6237\9501\5B9A\3002\8BF7\7A0D\540E\91CD\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[\5220\9664\8303\56F4 %2 \4E2D\8FDB\7A0B ID %1 \7684\8FDB\7A0B\53D8\91CF %0 \65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[\6A21\578B\5DF2\66F4\6539\3002\662F\5426\653E\5F03\66F4\6539\FF1F]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF1A\65E0\6CD5\627E\5230\4E0E\56FE\8868\4E2D\5B9A\4E49\7684\5E94\7528\7A0B\5E8F ID \5173\8054\7684\5DE5\4F5C\533A\3002\8BF7\68C0\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[\6D41\7A0B %0\FF1AServiceTask %1 \5931\8D25\FF1A\672A\5B9A\4E49\5C5E\6027 "Template"\3002\8BF7\68C0\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[\627E\5230\591A\884C\3002\8BF7\5728\67E5\770B\5668\63D2\4EF6\5C5E\6027\4E2D\542F\7528\201C\542F\7528\547C\53EB\6D3B\52A8\201D\8BBE\7F6E\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-cancelation-error'', c_load_lang, q''[\5C1D\8BD5\4E3A\6D41\7A0B\6B65\9AA4 %0 \53D6\6D88 APEX \5DE5\4F5C\6D41\4EFB\52A1 (task_id\FF1A%1) \65F6\51FA\9519\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[\4F7F\7528 APEX \5DE5\4F5C\6D41\529F\80FD\9700\8981 Oracle APEX v%0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-found'', c_load_lang, q''[\5728 Flows for APEX \6D41\7A0B\4E2D\672A\627E\5230 APEX \5DE5\4F5C\6D41\4EFB\52A1 %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[\627E\5230\4E0E\591A\4E2A Flows for APEX \6D41\7A0B\6B65\9AA4\5173\8054\7684 APEX \5DE5\4F5C\6D41\4EFB\52A1 %0.]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[APEX \5DE5\4F5C\6D41\4EFB\52A1 %0 \4E0D\662F\6D41\7A0B\7684\5F53\524D\6B65\9AA4\3002\6B65\9AA4\53EF\80FD\5DF2\5B8C\6210\6240\6709\51C6\5907\5C31\7EEA\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[APEX \5DE5\4F5C\6D41\4EFB\52A1\7ED3\679C\6D41\7A0B\53D8\91CF\672A\5B9A\4E49\6216\65E0\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[\5728\5E94\7528\7A0B\5E8F %1 \4E2D\521B\5EFA APEX \5DE5\4F5C\6D41\4EFB\52A1 %0 \65F6\51FA\9519\3002\6709\5173\8BE6\7EC6\4FE1\606F\FF0C\8BF7\53C2\9605\8C03\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[\521B\5EFA APEX \5DE5\4F5C\6D41\4EFB\52A1\65F6\51FA\9519 - \4F18\5148\7EA7 %0 \65E0\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[\521B\5EFA APEX \4F1A\8BDD\65F6\51FA\9519\3002BPMN \56FE\5305\542B\591A\4E2A\6D41\7A0B\5BF9\8C61\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[\60A8\5C1D\8BD5\8C03\7528\6807\8BB0\4E3A\4E0D\53EF\8C03\7528\7684\56FE\8868 %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[\60A8\5C1D\8BD5\5F52\6863\5305\542B\6B63\5728\8FD0\884C\7684\5B9E\4F8B\7684\56FE\8868\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[\521B\5EFA\5BA1\6279\4EFB\52A1\65F6\51FA\9519 - \4E1A\52A1\53C2\8003/\8BB0\5F55\7CFB\7EDF\4E3B\5173\952E\5B57\4E0D\80FD\4E3A NULL\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[\5F52\6863\76EE\6807\914D\7F6E\53C2\6570\51FA\9519\3002\53C2\6570\FF1A%0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[\5F52\6863\8FDB\7A0B\5B9E\4F8B %0 \7684\5B9E\4F8B\6982\8981\65F6\51FA\9519]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[\4E3B\673A (%0) \8BF7\6C42\7684\95F4\9694 %1 \7684\8BA1\65F6\5668\91CD\590D\95F4\9694\592A\9891\7E41\3002\5FC5\987B\5927\4E8E 1 \5206\949F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[\6536\5230\7684\6D88\606F\4E0E\9884\671F\6D88\606F\4E0D\5339\914D\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[\5DF2\53D1\751F\6D41\7A0B\6B65\9AA4\63A5\6536\6D88\606F\FF08\63D0\4F9B\7684\6B65\9AA4\5173\952E\5B57\4E0D\6B63\786E\FF09\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[\6D88\606F\8BA2\9605\5DF2\88AB\5176\4ED6\7528\6237\9501\5B9A\3002\8BF7\91CD\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[\6D88\606F\63A5\6536\8005\65E0\6CD5\9501\5B9A\5B50\6D41\3002\8BF7\91CD\8BD5\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-diagram-event'', c_load_lang, q''[\6D41 - \8BB0\5F55\56FE\8868\4E8B\4EF6\65F6\51FA\73B0\5185\90E8\9519\8BEF\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[\8BC4\4F30\5230\671F\65E5\671F\65F6\51FA\9519\3002\95F4\9694\8868\8FBE\5F0F\65E0\6548\3002\95F4\9694\FF1A%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[\8BC4\4F30\5230\671F\65E5\671F\65F6\51FA\9519\3002\5230\671F\65E5\8868\8FBE\5F0F\65E0\6548\3002\95F4\9694\8868\8FBE\5F0F\FF1A%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[\8BC4\4F30\4F18\5148\7EA7\65F6\51FA\9519\3002\4F18\5148\7EA7\8868\8FBE\5F0F\65E0\6548\3002\8868\8FBE\5F0F\FF1A%0\3002\6539\4E3A\4F7F\7528\4F18\5148\7EA7 3\3002]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/install/install_engine_messages_chinese_traditional
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15945797971146347)
,p_install_id=>wwv_flow_imp.id(17031066408817192)
,p_name=>'Engine Messages - Chinese (Traditional)'
,p_sequence=>160
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'-- Flows for APEX - engine_messages_zh-tw.sql',
'--',
'-- Engine Messages for language code "zh-tw"',
'--',
'-- Generated by language-load-generator',
'-- Generated on Wed, 09 Oct 2024 11:34:25 GMT',
'*/',
'',
'set define ''^''',
'whenever sqlerror exit rollback;',
'',
'PROMPT >> Loading Engine Messages for Language "zh-tw"',
'declare',
'  c_load_lang constant varchar2(10) := ''zh-tw'';',
'begin',
'  delete',
'    from flow_messages',
'   where fmsg_lang = c_load_lang;',
'',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''archive-destination-bad-json'', c_load_lang, q''[\5B58\6A94\76EE\7684\5730\7D44\614B\53C3\6578\4E2D\767C\751F\932F\8AA4\3002\53C3\6578\FF1A%0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''log-archive-error'', c_load_lang, q''[\5B58\6A94\8655\7406\4F5C\696D\57F7\884C\8655\7406 %0 \7684\57F7\884C\8655\7406\6458\8981\6642\767C\751F\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''scheduler-repeat-shared-env'', c_load_lang, q''[\4E3B\6A5F (%0) \8981\6C42\7684\9593\9694 %1 \7684\8A08\6642\5668\91CD\8907\9593\9694\592A\983B\7E41\3002\5FC5\9808\5927\65BC 1 \5206\9418\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-not-correlated'', c_load_lang, q''[\6536\5230\7684\8A0A\606F\8207\9810\671F\8A0A\606F\4E0D\76F8\7B26\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-no-longer-current-step'', c_load_lang, q''[\63A5\6536\8A0A\606F\7684\8655\7406\4F5C\696D\6B65\9A5F\5DF2\7D93\767C\751F (\63D0\4F9B\7684\6B65\9A5F\7D22\5F15\9375\4E0D\6B63\78BA)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-msub'', c_load_lang, q''[\8A0A\606F\8A02\95B1\5DF2\7531\5176\4ED6\4F7F\7528\8005\9396\5B9A\3002\8ACB\518D\8A66\4E00\6B21\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-lock-timeout-subflow'', c_load_lang, q''[\8A0A\606F\63A5\6536\8005\7121\6CD5\9396\5B9A\5B50\6D41\7A0B\3002\8ACB\518D\8A66\4E00\6B21\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-diagram-event'', c_load_lang, q''[\6D41\7A0B - \8A18\9304\300C\5716\8868\4E8B\4EF6\300D\6642\767C\751F\5167\90E8\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-interval-error'', c_load_lang, q''[\8A55\4F30\5230\671F\65E5\6642\767C\751F\932F\8AA4\3002\9593\9694\8868\793A\5F0F\7121\6548\3002\9593\9694\FF1A%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''due-on-error'', c_load_lang, q''[\8A55\4F30\5230\671F\65E5\6642\767C\751F\932F\8AA4\3002\300C\5230\671F\65E5\300D\904B\7B97\5F0F\7121\6548\3002\9593\9694\8868\793A\5F0F\FF1A%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-priority-error'', c_load_lang, q''[\8A55\4F30\512A\5148\9806\5E8F\6642\767C\751F\932F\8AA4\3002\512A\5148\9806\5E8F\904B\7B97\5F0F\7121\6548\3002\8868\793A\5F0F\FF1A%0\3002\5DF2\6539\7528\512A\5148\9806\5E8F 3\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-error'', c_load_lang, q''[\8A55\4F30\8A2D\5B9A\6642\767C\751F\932F\8AA4\3002\8868\793A\5F0F\7121\6548\3002\8868\793A\5F0F\FF1A%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''settings-procvar-no-prcs'', c_load_lang, q''[\8A2D\5B9A\503C\7121\6CD5\6307\5B9A\6C92\6709\8655\7406 ID \7684\8655\7406\8B8A\6578\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''msgflow-endpoint-not-supported'', c_load_lang, q''[\4E0D\652F\63F4 MessageFlow \6307\5B9A\7684\7AEF\9EDE (%0)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-bad-scope'', c_load_lang, q''[\63D0\4F9B\7D66\8655\7406\4F5C\696D\8B8A\6578\7684\7BC4\570D (%0) \7121\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-get-error'', c_load_lang, q''[\53D6\5F97\7BC4\570D %2 \4E2D\8655\7406\4F5C\696D ID %1 \7684\8655\7406\4F5C\696D\8B8A\6578 %0 \6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''ITE-unsupported-type'', c_load_lang, q''[\76EE\524D\5728 %0 \767C\751F\4E0D\652F\63F4\7684\300C\4E2D\9593\767C\51FA\4E8B\4EF6\300D\985E\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-session-params-not-set'', c_load_lang, q''[\5FC5\9808\5728\8655\7406\4F5C\696D\8B8A\6578\3001\5716\8868\975E\540C\6B65\9023\7DDA\8A73\7D30\8CC7\8A0A\6216\7CFB\7D71\7D44\614B\8A73\7D30\8CC7\8A0A\4E2D\8A2D\5B9A\7269\4EF6 %0 \7684\975E\540C\6B65\9023\7DDA\8A73\7D30\8CC7\8A0A\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-invalid_params'', c_load_lang, q''[\7121\6CD5\5EFA\7ACB\7269\4EF6 %0 \7684\975E\540C\6B65\9023\7DDA\3002\6307\5B9A\7684\61C9\7528\7A0B\5F0F\4E2D\4F7F\7528\8005\540D\7A31\7121\6548]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
'    values ( ''apex-task-on-multiple-steps'', c_load_lang, q''[APEX Workflow Task %0 found associated with more than one Flows for APEX process step.]'' );',
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-pageid'', c_load_lang, q''[\7121\6CD5\5EFA\7ACB\7269\4EF6 %0 \7684\975E\540C\6B65\9023\7DDA\3002\5FC5\9808\5728\8655\7406\8B8A\6578\3001\8655\7406\5716\8868\6216\7CFB\7D71\7D44\614B\4E2D\6307\5B9A\9801\9762 ID\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-child-lock-to'', c_load_lang, q''[%0 \7684\5B50\754C\9650\5B50\6D41\7A0B\6216\8A08\6642\5668\76EE\524D\5DF2\7531\5176\4ED6\4F7F\7528\8005\9396\5B9A\3002\8ACB\7A0D\5F8C\91CD\8A66\60A8\7684\4EA4\6613\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-no-catch-found'', c_load_lang, q''[\627E\4E0D\5230\985E\578B\70BA %0 \7684 boundaryEvent \4F86\64F7\53D6\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''boundary-event-too-many'', c_load_lang, q''[\5728\5B50\8655\7406\4F5C\696D\627E\5230\591A\500B %0 boundaryEvent\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''eng_handle_event_int'', c_load_lang, q''[\6D41\7A0B\5F15\64CE\5167\90E8\932F\8AA4\FF1A\8655\7406 %0 \5B50\6D41\7A0B %1 \6A21\7D44 %2 \76EE\524D\7684 %4 \76EE\524D\7684\6A19\8A18 %3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-unsupported-object'', c_load_lang, q''[\6A21\578B\932F\8AA4\FF1A\8655\7406 BPMN \6A21\578B\4E0B\4E00\6B65\4F7F\7528\4E0D\652F\63F4\7684\7269\4EF6 %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-prcs-not-found'', c_load_lang, q''[\61C9\7528\7A0B\5F0F\932F\8AA4\FF1A\627E\4E0D\5230\8655\7406\4F5C\696D ID %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-in-prcs'', c_load_lang, q''[\61C9\7528\7A0B\5F0F\932F\8AA4\FF1A\63D0\4F9B\7684\5B50\6D41\7A0B ID (%0) \5B58\5728\FF0C\4F46\4E0D\662F\6240\63D0\4F9B\8655\7406 ID \7684\5B50\9805 (%1)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-no-rel-or-draft-v0'', c_load_lang, q''[\627E\4E0D\5230\5DF2\767C\884C\5716\8868\6216\5716\8868\7684\8349\7A3F\7248\672C 0 - \8ACB\6307\5B9A\7248\672C\6216 diagram_id]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''version-not-found'', c_load_lang, q''[\627E\4E0D\5230\6307\5B9A\7684\5716\8868\7248\672C\3002\8ACB\6AA2\67E5\7248\672C\898F\683C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer_definition_error'', c_load_lang, q''[\5256\6790\8655\7406 %0 (\5B50\6D41\7A0B %1) \4E2D\7684\8A08\6642\5668\5B9A\7FA9\6642\767C\751F\932F\8AA4\3002\8A08\6642\5668\985E\578B\FF1A%2\FF0C\5B9A\7FA9\FF1A%3]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-model-no-version'', c_load_lang, q''[\672A\5B9A\7FA9\7248\672C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-parsing-json-variables'', c_load_lang, q''[\5256\6790\8655\7406\8B8A\6578\6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-route-not-define'', c_load_lang, q''[\672A\5B9A\7FA9\8DEF\7531\7684\9598\9053\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-gateway-not-exist'', c_load_lang, q''[\6B64\6D41\7A0B\6C92\6709\9598\9053\5B9A\7FA9\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-no-instance-subflow-id'', c_load_lang, q''[\7121\6CD5\53D6\5F97\6D41\7A0B\5BE6\4F8B ID \8207\6216\5B50\6D41\7A0B ID \4F86\7BA1\7406\6B65\9A5F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-number'', c_load_lang, q''[APEX \9805\76EE\6216\8655\7406\8B8A\6578\6578\76EE\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-wrong-variable-type'', c_load_lang, q''[\4E00\6216\591A\500B\8655\7406\8B8A\6578\7684\985E\578B\8207 JSON \4E2D\5B9A\7FA9\7684\985E\578B\4E0D\540C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-number'', c_load_lang, q''[%0 \4E0D\662F\6709\6548\7684\6578\5B57\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-variable-not-a-date'', c_load_lang, q''[%0 \4E0D\662F\6709\6548\7684\65E5\671F\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-invalid-json'', c_load_lang, q''[\63D0\4F9B\7684 JSON \7121\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-modeler-id-not-found'', c_load_lang, q''[\627E\4E0D\5230\8CC7\6599\3002\6AA2\67E5\6307\5B9A ID \7684\5716\8868\662F\5426\5B58\5728\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-unexpected-error'', c_load_lang, q''[\672A\9810\671F\7684\932F\8AA4\FF0C\8ACB\8207\60A8\7684\7BA1\7406\54E1\806F\7D61\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-not-parsable'', c_load_lang, q''[\7121\6CD5\5256\6790\5716\8868\3002<br /> \8ACB\8907\67E5\60A8\7684\5716\8868\4EE5\78BA\5B9A\652F\63F4\5716\8868\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-saved'', c_load_lang, q''[\8B8A\66F4\5DF2\5132\5B58\FF01]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-diagram-has-changed'', c_load_lang, q''[\6A21\578B\5DF2\8B8A\66F4\3002\8981\6368\68C4\8B8A\66F4\55CE\FF1F]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''wrong-default-workspace'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \5931\6557\FF1A\7D44\614B\53C3\6578\4E2D\5B9A\7FA9\7684\9810\8A2D\5DE5\4F5C\5340\7121\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''workspace-not-found'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \5931\6557\FF1A\627E\4E0D\5230\8207\5716\8868\4E2D\5B9A\7FA9\4E4B\61C9\7528\7A0B\5F0F ID \76F8\95DC\806F\7684\5DE5\4F5C\5340\3002\8ACB\6AA2\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-from'', c_load_lang, q''[\8655\7406 %0\FF1AServiceTask %1 \5931\6557\FF1A\672A\5B9A\7FA9\5C6C\6027\300C\5BC4\4EF6\8005\300D\548C\9810\8A2D\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005\3002\8ACB\6AA2\67E5\6A21\578B\8207\6216\7D44\614B\53C3\6578\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-to'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \5931\6557\FF1A\672A\5B9A\7FA9\5C6C\6027 "To"\3002\8ACB\6AA2\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-template'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \5931\6557\FF1A\672A\5B9A\7FA9\5C6C\6027 "Template"\3002\8ACB\6AA2\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-no-body'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \5931\6557\FF1A\672A\5B9A\7FA9\5C6C\6027 "Body"\3002\8ACB\6AA2\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-failed'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \5931\6557\FF0C\8ACB\53C3\95B1\932F\8AA4\65E5\8A8C\4E26\6AA2\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''email-placeholder-json-invalid'', c_load_lang, q''[\8655\7406\4F5C\696D %0\FF1AServiceTask %1 \9810\7559\4F4D\7F6E JSON \662F invalid.Please\FF0C\8ACB\6AA2\67E5\6A21\578B\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plugin-multiple-rows'', c_load_lang, q''[\627E\5230\591A\500B\8CC7\6599\5217\3002\8ACB\555F\7528\6AA2\8996\8005\5916\639B\7A0B\5F0F\5C6C\6027\4E2D\7684\300C\555F\7528\62DC\8A2A\6D3B\52D5\300D\8A2D\5B9A\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-cancelation-error'', c_load_lang, q''[\5617\8A66\53D6\6D88\8655\7406\4F5C\696D\6B65\9A5F %0 \7684 APEX \5DE5\4F5C\6D41\7A0B\4F5C\696D (task_id\FF1A%1) \6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-supported'', c_load_lang, q''[APEX \5DE5\4F5C\6D41\7A0B\529F\80FD\4F7F\7528\9700\8981 Oracle APEX v%0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-found'', c_load_lang, q''[\5728 APEXFlows for APEX \8655\7406\7684 Flows \4E2D\627E\4E0D\5230 APEX \5DE5\4F5C\6D41\7A0B\4F5C\696D %0]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-not-current-step'', c_load_lang, q''[APEX \5DE5\4F5C\6D41\7A0B\4F5C\696D %0 \4E0D\662F\8655\7406\4F5C\696D\7684\76EE\524D\6B65\9A5F\3002\6B65\9A5F\53EF\80FD\5DF2\5B8C\6210\6240\6709\6E96\5099\5C31\7DD2\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-invalid-result-var'', c_load_lang, q''[\672A\5B9A\7FA9\300CAPEX \5DE5\4F5C\6D41\7A0B\4F5C\696D\300D\7D50\679C\8655\7406\4F5C\696D\8B8A\6578\6216\8B8A\6578\7121\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-creation-error'', c_load_lang, q''[\5728\61C9\7528\7A0B\5F0F %1 \4E2D\5EFA\7ACB APEX \5DE5\4F5C\6D41\7A0B\4F5C\696D %0 \6642\767C\751F\932F\8AA4\3002   \8ACB\53C3\95B1\9664\932F\77AD\89E3\8A73\7D30\8CC7\8A0A\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-priority-error'', c_load_lang, q''[\5EFA\7ACB APEX \5DE5\4F5C\6D41\7A0B\4F5C\696D\6642\767C\751F\932F\8AA4 - \512A\5148\9806\5E8F %0 \7121\6548\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-multiple-processes'', c_load_lang, q''[\5EFA\7ACB APEX \968E\6BB5\4F5C\696D\6642\767C\751F\932F\8AA4\3002BPMN \5716\5305\542B\591A\500B\300C\8655\7406\4F5C\696D\300D\7269\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''call-diagram-not-callable'', c_load_lang, q''[\60A8\5617\8A66\547C\53EB\6A19\793A\70BA\4E0D\53EF\547C\53EB\7684\5716\8868 %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''diagram-archive-has-instances'', c_load_lang, q''[\60A8\5617\8A66\5C07\542B\6709\57F7\884C\4E2D\57F7\884C\8655\7406\7684\5716\8868\5B58\6A94\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''apex-task-business-ref-null'', c_load_lang, q''[\5EFA\7ACB\6838\51C6\4EFB\52D9\6642\767C\751F\932F\8AA4 - \696D\52D9\53C3\8003 / \8A18\9304\7CFB\7D71\4E3B\7D22\5F15\9375\4E0D\5F97\70BA\7A7A\503C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-not-created'', c_load_lang, q''[\60A8\5617\8A66\555F\52D5\4E0D\5B58\5728\7684\8655\7406\4F5C\696D (ID %0)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-type-unsupported'', c_load_lang, q''[\4E0D\652F\63F4\7684\958B\59CB\4E8B\4EF6\985E\578B (%0)\3002\76EE\524D\50C5\652F\63F4\300C\7121\300D(\6A19\6E96)\3001\300C\8A0A\606F\300D\53CA\300C\8A08\6642\5668\958B\59CB\4E8B\4EF6\300D\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''startwork-sbfl-not-found'', c_load_lang, q''[\958B\59CB\5DE5\4F5C\6642\9593\8A18\9304\5931\6557\3002\627E\4E0D\5230\8655\7406 %1 \4E2D\7684\5B50\6D41\7A0B %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''step-key-incorrect'', c_load_lang, q''[\6B64\8655\7406\6B65\9A5F\5DF2\767C\751F\3002(\6B65\9A5F\7D22\5F15\9375 %1 \6642\63D0\4F9B\4E86\4E0D\6B63\78BA\7684\6B65\9A5F\7D22\5F15\9375 %0)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-no-start'', c_load_lang, q''[\627E\4E0D\5230\5B50\8655\7406\958B\59CB\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''subProcess-too-many-starts'', c_load_lang, q''[\627E\5230\591A\500B\5B50\8655\7406\958B\59CB\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-broken'', c_load_lang, q''[\8A08\6642\5668 %0 \57F7\884C %4 \5728\8655\7406 %1 \4E2D\4E2D\65B7\FF0C\5B50\6D41\7A0B\FF1A%2\3002\8ACB\53C3\95B1 error_info\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-cycle-unsupported'', c_load_lang, q''[\76EE\524D\4E0D\652F\63F4\70BA\7269\4EF6 %0 \5B9A\7FA9\7684\9031\671F\8A08\6642\5668\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-incomplete-definition'', c_load_lang, q''[\7269\4EF6 %0 \7684\8A08\6642\5668\5B9A\7FA9\4E0D\5B8C\6574\3002\985E\578B\FF1A%1\FF1BValue1\FF1A%2 Value2\FF1A%3  Value3\FF1A%4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-lock-timeout'', c_load_lang, q''[\5176\4ED6\4F7F\7528\8005\76EE\524D\9396\5B9A\5B50\6D41\7A0B %0 \7684\8A08\6642\5668\3002\8ACB\7A0D\5F8C\518D\8A66\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timer-object-not-found'', c_load_lang, q''[get_timer_definition \4E2D\627E\4E0D\5230\542B\6709\8A08\6642\5668\7684\7269\4EF6\3002\5B50\6D41\7A0B %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timers-lock-timeout'', c_load_lang, q''[\8655\7406 %0 \7684\8A08\6642\5668\76EE\524D\88AB\5176\4ED6\4F7F\7528\8005\9396\5B9A\3002\8ACB\7A0D\5F8C\518D\8A66\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-set-error'', c_load_lang, q''[\70BA\7BC4\570D %2 \4E2D\7684\7A0B\5E8F ID %1 \5EFA\7ACB\7A0B\5E8F\8B8A\6578 %0 \6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-update-error'', c_load_lang, q''[\66F4\65B0\7BC4\570D %2 \4E2D\7A0B\5E8F ID %1 \7684\7A0B\5E8F\8B8A\6578 %0 \6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-delete-error'', c_load_lang, q''[\522A\9664\7BC4\570D %2 \4E2D\8655\7406\4F5C\696D ID %1 \7684\8655\7406\4F5C\696D\8B8A\6578 %0 \6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var-lock-error'', c_load_lang, q''[\9396\5B9A\7BC4\570D %2 \4E2D\7A0B\5E8F ID %1 \7684\7A0B\5E8F\8B8A\6578 %0 \6642\767C\751F\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_datatype'', c_load_lang, q''[\8A2D\5B9A\8655\7406\8B8A\6578\6642\767C\751F\932F\8AA4\3002\8B8A\6578 %0 \7684\8CC7\6599\985E\578B\4E0D\6B63\78BA\3002\5728\9664\932F\8F38\51FA\4E2D\986F\793A SQL \932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_date_format'', c_load_lang, q''[\8A2D\5B9A\8655\7406\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\FF1A\65E5\671F\683C\5F0F\4E0D\6B63\78BA (\5B50\6D41\7A0B\FF1A%0\FF0C\96C6\5408\FF1A%3)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_object_not_found'', c_load_lang, q''[\67E5\8A62 process_expressions \4E2D\7684\7269\4EF6 %0 \6642\767C\751F\5167\90E8\932F\8AA4\3002\5728\9664\932F\8F38\51FA\4E2D\986F\793A SQL \932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''restart-no-error'', c_load_lang, q''[\627E\4E0D\5230\76EE\524D\932F\8AA4\3002\6AA2\67E5\60A8\7684\8655\7406\7A0B\5E8F\5716\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-already-running'', c_load_lang, q''[\60A8\5617\8A66\555F\52D5\5DF2\5728\57F7\884C\7684\8655\7406\4F5C\696D (ID %0)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_other'', c_load_lang, q''[\5728\8655\7406 ID %0 (\8A2D\5B9A %2) \4E2D\8A2D\5B9A\8655\7406\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\3002\4E8B\4EF6\65E5\8A8C\4E2D\986F\793A\7684 SQL \932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_rows'', c_load_lang, q''[\5728\8655\7406 ID %0 (\8A2D\5B9A %2) \4E2D\8A2D\5B9A\8655\7406\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\3002\67E5\8A62\50B3\56DE\591A\500B\8CC7\6599\5217\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_static_general'', c_load_lang, q''[\5728\8655\7406 ID %0 (\8A2D\5B9A %2) \4E2D\8A2D\5B9A\8655\7406\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\3002\67E5\770B\4E8B\4EF6\8A18\9304\4E2D\7684\932F\8AA4\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_plsql_error'', c_load_lang, q''[\5B50\6D41\7A0B\FF1A%0 \8B8A\6578 %1 \7684 %2 \904B\7B97\5F0F\767C\751F\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_no_data'', c_load_lang, q''[\5728\8655\7406 ID %0 (\8A2D\5B9A %2) \4E2D\8A2D\5B9A\8655\7406\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\3002\67E5\8A62\4E2D\627E\4E0D\5230\8CC7\6599\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''feature-requires-ee'', c_load_lang, q''[\8655\7406\6B64\529F\80FD\9700\8981\6388\6B0A Flows for APEX Enterprise Edition\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_close_error'', c_load_lang, q''[\300D\5728\5B50\6D41\7A0B %0 \4E0A\8655\7406\53CD\8986\95DC\9589\6642\767C\751F\5167\90E8\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_sql_too_many_values'', c_load_lang, q''[\8A2D\5B9A\8655\7406\4F5C\696D ID %0 (\8A2D\5B9A %2) \4E2D\7684\8655\7406\4F5C\696D\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\3002\67E5\8A62\6703\50B3\56DE\4E00\500B\4EE5\4E0A\7684\503C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''engine-util-sbfl-not-found'', c_load_lang, q''[\627E\4E0D\5230\63D0\4F9B\7684\5B50\6D41\7A0B ID (%0)\3002\6AA2\67E5\8B8A\66F4\8655\7406\6D41\7A0B (\903E\6642\3001\932F\8AA4\3001\5448\5831) \7684\8655\7406\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-invalid-route'', c_load_lang, q''[\9598\9053 %0 \767C\751F\932F\8AA4\3002\63D0\4F9B\7684\8B8A\6578 %1 \5305\542B\7121\6548\7684\8DEF\5F91\FF1A%2]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-merge-error'', c_load_lang, q''[\5728\5B50\6D41\7A0B %0 \4E0A\5408\4F75\9598\9053\6642\767C\751F\5167\90E8\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-no-route'', c_load_lang, q''[\8B8A\6578 %0 \4E2D\672A\63D0\4F9B\9598\9053\8DEF\7531\6307\793A\FF0C\4E14\6A21\578B\672A\5305\542B\9810\8A2D\8DEF\7531\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-bad-expression'', c_load_lang, q''[\7121\6548\7684\9598\9053\8DEF\7531\8868\793A\5F0F\3002\5982\679C\5617\8A66\4EE5\5167\5D4C\5192\865F (\FF1A) \9023\7D50\8B8A\6578\FF0C\5C31\53EF\80FD\767C\751F\6B64\60C5\6CC1\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''process-lock-timeout'', c_load_lang, q''[%0 \7684\8655\7406\7269\4EF6\76EE\524D\88AB\5176\4ED6\4F7F\7528\8005\9396\5B9A\3002\8ACB\7A0D\5F8C\518D\8A66\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''more_than_1_forward_path'', c_load_lang, q''[\627E\52301 \500B\4EE5\4E0A\7684\6B63\5411\8DEF\5F91\FF0C\4F46\50C5\5141\8A31 1 \500B]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''no_next_step_found'', c_load_lang, q''[\5728\5B50\6D41\7A0B %0 \4E0A\627E\4E0D\5230\4E0B\4E00\500B\6B65\9A5F\3002\6AA2\67E5\60A8\7684\8655\7406\7A0B\5E8F\5716\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_failed'', c_load_lang, q''[\8655\7406 %0\FF1A\4F5C\696D %1 \56E0 PL/SQL \932F\8AA4\800C\5931\6557 - \8ACB\53C3\95B1\4E8B\4EF6\65E5\8A8C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''plsql_script_requested_stop'', c_load_lang, q''[\8655\7406 %0\FF1A\4EFB\52D9 %1 \8981\6C42\8655\7406\505C\6B62 - \8ACB\53C3\95B1\4E8B\4EF6\65E5\8A8C\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''timeout_locking_subflow'', c_load_lang, q''[\7121\6CD5\9396\5B9A\5B50\6D41\7A0B %0\FF0C\56E0\70BA\76EE\524D\5DF2\7531\5176\4ED6\4F7F\7528\8005\9396\5B9A\3002\8ACB\7A0D\5F8C\518D\8A66\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-already-placed'', c_load_lang, q''[\5DF2\70BA\60A8\9810\7559\4E0B\4E00\500B\4EFB\52D9\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-by-other_user'', c_load_lang, q''[%0 \7684\4FDD\7559\5931\6557\3002\6B65\9A5F\5DF2\7531\5176\4ED6\4F7F\7528\8005 (%1) \4FDD\7559\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-failed-not-found'', c_load_lang, q''[%2 \7684\9810\8A02\5931\6557\3002\627E\4E0D\5230\8655\7406 %1 \4E2D\7684\5B50\6D41\7A0B %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-incorrect-step-key'', c_load_lang, q''[\4EFB\52D9\5DF2\4E0D\518D\662F\76EE\524D\4EFB\52D9\FF0C\53EF\80FD\5DF2\7D93\5B8C\6210\3002\8ACB\91CD\65B0\6574\7406\60A8\7684\6536\4EF6\5323\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-lock-timeout'', c_load_lang, q''[\5176\4ED6\4F7F\7528\8005\76EE\524D\5DF2\9396\5B9A (\672A\4FDD\7559) \5B50\6D41\7A0B\3002\8ACB\7A0D\5F8C\518D\8A66\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''reservation-release-not-found'', c_load_lang, q''[\9810\7559\6838\767C\5931\6557\3002\627E\4E0D\5230\8655\7406 %1 \4E2D\7684\5B50\6D41\7A0B %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-username'', c_load_lang, q''[\7121\6CD5\5EFA\7ACB\7269\4EF6 %0 \7684\975E\540C\6B65\9023\7DDA\3002\5FC5\9808\5728\8655\7406\8B8A\6578\3001\8655\7406\5716\8868\6216\7CFB\7D71\7D44\614B\4E2D\6307\5B9A\4F7F\7528\8005\540D\7A31\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''async-no-appid'', c_load_lang, q''[\7121\6CD5\5EFA\7ACB\7269\4EF6 %0 \7684\975E\540C\6B65\9023\7DDA\3002\5FC5\9808\5728\8655\7406\8B8A\6578\3001\8655\7406\5716\8868\6216\7CFB\7D71\7D44\614B\4E2D\6307\5B9A\61C9\7528\7A0B\5F0F ID\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-diagram-calls-itself'', c_load_lang, q''[\60A8\5617\8A66\4F7F\7528\5305\542B callActivity \547C\53EB\672C\8EAB\7684\5716\8868 %0 \555F\52D5\8655\7406\4F5C\696D\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''gateway-too-many-defaults'', c_load_lang, q''[\9598\9053 %0 \7684\6A21\578B\4E2D\6307\5B9A\4E86\591A\500B\9810\8A2D\8DEF\7531\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-no-catch'', c_load_lang, q''[\627E\4E0D\5230\540D\7A31\70BA %0 \7684\76F8\7B26\9023\7D50\64F7\53D6\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''link-too-many-catches'', c_load_lang, q''[\4E00\500B\4EE5\4E0A\7684\76F8\7B26\9023\7D50\64F7\53D6\4E8B\4EF6\540D\7A31\70BA %0\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-instance-event'', c_load_lang, q''[\6D41\7A0B - \8A18\9304\57F7\884C\8655\7406\4E8B\4EF6\6642\767C\751F\5167\90E8\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-step-event'', c_load_lang, q''[\6D41\7A0B - \8A18\9304\6B65\9A5F\4E8B\4EF6\6642\767C\751F\5167\90E8\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''logging-variable-event'', c_load_lang, q''[\6D41\7A0B - \8A18\9304\300C\8B8A\6578\4E8B\4EF6\300D\6642\767C\751F\5167\90E8\932F\8AA4]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-already-running'', c_load_lang, q''[\60A8\5617\8A66\555F\52D5\4E00\500B\5DF2\7D93\57F7\884C\591A\500B\8907\672C\7684\8655\7406\4F5C\696D (ID %0)\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-multiple-start-events'', c_load_lang, q''[\60A8\5B9A\7FA9\4E86\591A\500B\958B\59CB\4E8B\4EF6\3002\8ACB\78BA\5B9A\60A8\7684\5716\8868\53EA\6709\4E00\500B\958B\59CB\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''start-no-start-event'', c_load_lang, q''[\6D41\7A0B\5716\4E2D\672A\5B9A\7FA9\958B\59CB\4E8B\4EF6\3002]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''var_exp_json_format'', c_load_lang, q''[\8A2D\5B9A\8655\7406\8B8A\6578 %1 \6642\767C\751F\932F\8AA4\FF1A\4E0D\6B63\78BA\7684 JSON \683C\5F0F (\5B50\6D41\7A0B\FF1A%0\FF0C\96C6\FF1A%3.)]'' );'),
'  insert into flow_messages( fmsg_message_key, fmsg_lang, fmsg_message_content )',
unistr('    values ( ''iter_lock_error'', c_load_lang, q''[\9396\5B9A\8655\7406\4F5C\696D ID %1 \7684\91CD\8907\8A73\7D30\8CC7\8A0A (iter %0 \8FF4\5708 %2) \6642\767C\751F\932F\8AA4\3002]'' );'),
'  ',
'  commit;',
'end;',
'/',
''))
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
